/*!
*  filename: ej.web.all.js
*  version : 15.2.0.46
*  Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
*/


window.ej = window.Syncfusion = window.Syncfusion || {};


(function ($, ej, undefined) {
    'use strict';

    ej.version = "15.2.0.46";

    ej.consts = {
        NamespaceJoin: '-'
    };
    ej.TextAlign = {
        Center: 'center',
        Justify: 'justify',
        Left: 'left',
        Right: 'right'
    };
    ej.Orientation = { Horizontal: "horizontal", Vertical: "vertical" };

    ej.serverTimezoneOffset = 0;

    ej.persistStateVersion = null;

    if (!Object.prototype.hasOwnProperty) {
        Object.prototype.hasOwnProperty = function (obj, prop) {
            return obj[prop] !== undefined;
        };
    }

    //to support toISOString() in IE8
    if (!Date.prototype.toISOString) {
        (function () {
            function pad(number) {
                var r = String(number);
                if (r.length === 1) {
                    r = '0' + r;
                }
                return r;
            }
            Date.prototype.toISOString = function () {
                return this.getUTCFullYear()
                    + '-' + pad(this.getUTCMonth() + 1)
                    + '-' + pad(this.getUTCDate())
                    + 'T' + pad(this.getUTCHours())
                    + ':' + pad(this.getUTCMinutes())
                    + ':' + pad(this.getUTCSeconds())
                    + '.' + String((this.getUTCMilliseconds() / 1000).toFixed(3)).slice(2, 5)
                    + 'Z';
            };
        }());
    }

    String.format = function () {
        var source = arguments[0];
        for (var i = 0; i < arguments.length - 1; i++)
            source = source.replace(new RegExp("\\{" + i + "\\}", "gm"), arguments[i + 1]);

        source = source.replace(/\{[0-9]\}/g, "");
        return source;
    };

    jQuery.uaMatch = function (ua) {
        ua = ua.toLowerCase();

        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];

        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };
    // Function to create new class
    ej.defineClass = function (className, constructor, proto, replace) {
        /// <summary>Creates the javascript class with given namespace & class name & constructor etc</summary>
        /// <param name="className" type="String">class name prefixed with namespace</param>
        /// <param name="constructor" type="Function">constructor function</param>
        /// <param name="proto" type="Object">prototype for the class</param>
        /// <param name="replace" type="Boolean">[Optional]Replace existing class if exists</param>
        /// <returns type="Function">returns the class function</returns>
        if (!className || !proto) return undefined;

        var parts = className.split(".");

        // Object creation
        var obj = window, i = 0;
        for (; i < parts.length - 1; i++) {

            if (ej.isNullOrUndefined(obj[parts[i]]))
                obj[parts[i]] = {};

            obj = obj[parts[i]];
        }

        if (replace || ej.isNullOrUndefined(obj[parts[i]])) {

            //constructor
            constructor = typeof constructor === "function" ? constructor : function () {
            };

            obj[parts[i]] = constructor;

            // prototype
            obj[parts[i]].prototype = proto;
        }

        return obj[parts[i]];
    };

    ej.util = {
        getNameSpace: function (className) {
            /// <summary>Internal function, this will create namespace for plugins using class name</summary>
            /// <param name="className" type="String"></param>
            /// <returns type="String"></returns>
            var splits = className.toLowerCase().split(".");
            splits[0] === "ej" && (splits[0] = "e");

            return splits.join(ej.consts.NamespaceJoin);
        },

        getObject: function (nameSpace, from) {
            if (!from) return undefined;

            var value = from, splits = nameSpace.split('.');

            for (var i = 0; i < splits.length; i++) {

                if (ej.util.isNullOrUndefined(value)) break;

                value = value[splits[i]];
            }

            return value;
        },

        createObject: function (nameSpace, value, initIn) {
            var splits = nameSpace.split('.'), start = initIn || window, from = start, i, t, length = splits.length;

            for (i = 0; i < length; i++) {
                t = splits[i];
                if (i + 1 == length)
                    from[t] = value;
                else if (ej.isNullOrUndefined(from[t]))
                    from[t] = {};

                from = from[t];
            }

            return start;
        },

        isNullOrUndefined: function (value) {
            /// <summary>Util to check null or undefined</summary>
            /// <param name="value" type="Object"></param>
            /// <returns type="Boolean"></returns>
            return value === undefined || value === null;
        },
        print: function (element, printWin) {
            var $div = ej.buildTag('div')
            var elementClone = element.clone();
            $div.append(elementClone);
            if (!printWin)
                var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no");
            printWin.document.write('<!DOCTYPE html>');
            var links = $('head').find('link').add("style");
            if (ej.browserInfo().name === "msie") {
                var a = ""
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.write('<html><head></head><body>' + a + $div[0].innerHTML + '</body></html>');
            }
            else {
                var a = ""
                printWin.document.write('<html><head>')
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.writeln(a + '</head><body>')
                printWin.document.writeln($div[0].innerHTML + '</body></html>')
            }
            printWin.document.close();
            printWin.focus();
            setTimeout(function () {
                if (!ej.isNullOrUndefined(printWin.window)) {
                    printWin.print();
                    setTimeout(function () { printWin.close() }, 1000);
                }
            }, 1000);
        },
        ieClearRemover: function (element) {
            var searchBoxHeight = $(element).height();
            element.style.paddingTop = parseFloat(searchBoxHeight / 2) + "px";
            element.style.paddingBottom = parseFloat(searchBoxHeight / 2) + "px";
            element.style.height = "1px";
            element.style.lineHeight = "1px";
        },
        //To send ajax request
        sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.successHandler,
                error: ajaxOptions.errorHandler,
                beforeSend: ajaxOptions.beforeSendHandler,
                complete: ajaxOptions.completeHandler
            });
        },

        buildTag: function (tag, innerHtml, styles, attrs) {
            /// <summary>Helper to build jQuery element</summary>
            /// <param name="tag" type="String">tagName#id.cssClass</param>
            /// <param name="innerHtml" type="String"></param>
            /// <param name="styles" type="Object">A set of key/value pairs that configure styles</param>
            /// <param name="attrs" type="Object">A set of key/value pairs that configure attributes</param>
            /// <returns type="jQuery"></returns>
            var tagName = /^[a-z]*[0-9a-z]+/ig.exec(tag)[0];

            var id = /#([_a-z]+[-_0-9a-z]+)/ig.exec(tag);
            id = id ? id[id.length - 1] : undefined;

            var className = /\.([a-z]+[-_0-9a-z ]+)/ig.exec(tag);
            className = className ? className[className.length - 1] : undefined;

            return $(document.createElement(tagName))
                .attr(id ? { "id": id } : {})
                .addClass(className || "")
                .css(styles || {})
                .attr(attrs || {})
                .html(innerHtml || "");
        },
        _preventDefaultException: function (el, exceptions) {
            if (el) {
                for (var i in exceptions) {
                    if (exceptions[i].test(el[i])) {
                        return true;
                    }
                }
            }

            return false;
        },

        //Gets the maximum z-index in the document
        getMaxZindex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute' || $(e).css('position') == 'fixed')
                    return parseInt($(e).css('z-index')) || 1;
            })
            );
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },

        //To prevent default actions for the element
        blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },

        //To get dimensions of the element when its hidden
        getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().andSelf().filter(':hidden');
            if ($hidden) {
                var prop = { visibility: 'hidden', display: 'block' };
                var tmp = [];
                $hidden.each(function () {
                    var temp = {}, name;
                    for (name in prop) {
                        temp[name] = this.style[name];
                        this.style[name] = prop[name];
                    }
                    tmp.push(temp);
                });
                value = /(outer)/g.test(method) ?
                $(element)[method](true) :
               $(element)[method]();

                $hidden.each(function (i) {
                    var temp = tmp[i], name;
                    for (name in prop) {
                        this.style[name] = temp[name];
                    }
                });
            }
            return value;
        },
        //Get triggers when transition End
        transitionEndEvent: function () {
            var transitionEnd = {
                '': 'transitionend',
                'webkit': 'webkitTransitionEnd',
                'Moz': 'transitionend',
                'O': 'otransitionend',
                'ms': 'MSTransitionEnd'
            };

            return transitionEnd[ej.userAgent()];
        },
        //Get triggers when transition End
        animationEndEvent: function () {
            var animationEnd = {
                '': 'animationend',
                'webkit': 'webkitAnimationEnd',
                'Moz': 'animationend',
                'O': 'webkitAnimationEnd',
                'ms': 'animationend'
            };

            return animationEnd[ej.userAgent()];
        },
        //To return the start event to bind for element
        startEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchstart" : "mousedown";
        },
        //To return end event to bind for element
        endEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchend" : "mouseup"
        },
        //To return move event to bind for element
        moveEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? ($.support.hasPointer && !ej.isMobile()) ? "ejtouchmove" : "touchmove" : "mousemove";
        },
        //To return cancel event to bind for element
        cancelEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchcancel" : "mousecancel";
        },
        //To return tap event to bind for element
        tapEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "tap" : "click";
        },
        //To return tap hold event to bind for element
        tapHoldEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "taphold" : "click";
        },
        //To check whether its Device
        isDevice: function () {
            if (ej.getBooleanVal($('head'), 'data-ej-forceset', false))
                return ej.getBooleanVal($('head'), 'data-ej-device', this._device());
            else
                return this._device();
        },
        //To check whether its portrait or landscape mode
        isPortrait: function () {
            var elem = document.documentElement;
            return (elem) && ((elem.clientWidth / elem.clientHeight) < 1.1);
        },
        //To check whether its in lower resolution
        isLowerResolution: function () {
            return ((window.innerWidth <= 640 && ej.isPortrait() && ej.isDevice()) || (window.innerWidth <= 800 && !ej.isDevice()) || (window.innerWidth <= 800 && !ej.isPortrait() && ej.isWindows() && ej.isDevice()) || ej.isMobile());
        },
        //To check whether its iOS web view
        isIOSWebView: function () {
            return (/(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(navigator.userAgent));
        },
        //To check whether its Android web view
        isAndroidWebView: function () {
            return (!(typeof (Android) === "undefined"));
        },
        //To check whether its windows web view
        isWindowsWebView: function () {
            return location.href.indexOf("x-wmapp") != -1;
        },
        _device: function () {
            return (/Android|BlackBerry|iPhone|iPad|iPod|IEMobile|kindle|windows\sce|palm|smartphone|iemobile|mobile|pad|xoom|sch-i800|playbook/i.test(navigator.userAgent.toLowerCase()));
        },
        //To check whether its Mobile
        isMobile: function () {
            return ((/iphone|ipod|android|blackberry|opera|mini|windows\sce|palm|smartphone|iemobile/i.test(navigator.userAgent.toLowerCase()) && /mobile/i.test(navigator.userAgent.toLowerCase()))) || (ej.getBooleanVal($('head'), 'data-ej-mobile', false) === true);
        },
        //To check whether its Tablet
        isTablet: function () {
            return (/ipad|xoom|sch-i800|playbook|tablet|kindle/i.test(navigator.userAgent.toLowerCase())) || (ej.getBooleanVal($('head'), 'data-ej-tablet', false) === true) || (!ej.isMobile() && ej.isDevice());
        },
        //To check whether its Touch Device
        isTouchDevice: function () {
            return (('ontouchstart' in window || (window.navigator.msPointerEnabled && ej.isMobile())) && this.isDevice());
        },
        //To get the outerHTML string for object
        getClearString: function (string) {
            return $.trim(string.replace(/\s+/g, " ").replace(/(\r\n|\n|\r)/gm, "").replace(new RegExp("\>[\n\t ]+\<", "g"), "><"));
        },
        //Get the attribute value with boolean type of element
        getBooleanVal: function (ele, val, option) {
            /// <summary>Util to get the property from data attributes</summary>
            /// <param name="ele" type="Object"></param>
            /// <param name="val" type="String"></param>
            /// <param name="option" type="GenericType"></param>
            /// <returns type="GenericType"></returns>
            var value = $(ele).attr(val);
            if (value != null)
                return value.toLowerCase() == "true";
            else
                return option;
        },
        //Gets the Skew class based on the element current position
        _getSkewClass: function (item, pageX, pageY) {
            var itemwidth = item.width();
            var itemheight = item.height();
            var leftOffset = item.offset().left;
            var rightOffset = item.offset().left + itemwidth;
            var topOffset = item.offset().top;
            var bottomOffset = item.offset().top + itemheight;
            var widthoffset = itemwidth * 0.3;
            var heightoffset = itemheight * 0.3;
            if (pageX < leftOffset + widthoffset && pageY < topOffset + heightoffset)
                return "e-m-skew-topleft";
            if (pageX > rightOffset - widthoffset && pageY < topOffset + heightoffset)
                return "e-m-skew-topright";
            if (pageX > rightOffset - widthoffset && pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottomright";
            if (pageX < leftOffset + widthoffset && pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottomleft";
            if (pageX > leftOffset + widthoffset && pageY < topOffset + heightoffset && pageX < rightOffset - widthoffset)
                return "e-m-skew-top";
            if (pageX < leftOffset + widthoffset)
                return "e-m-skew-left";
            if (pageX > rightOffset - widthoffset)
                return "e-m-skew-right";
            if (pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottom";
            return "e-m-skew-center";
        },
        //Removes the added Skew class on the element
        _removeSkewClass: function (element) {
            $(element).removeClass("e-m-skew-top e-m-skew-bottom e-m-skew-left e-m-skew-right e-m-skew-topleft e-m-skew-topright e-m-skew-bottomleft e-m-skew-bottomright e-m-skew-center e-skew-top e-skew-bottom e-skew-left e-skew-right e-skew-topleft e-skew-topright e-skew-bottomleft e-skew-bottomright e-skew-center");
        },
        //Object.keys  method to support all the browser including IE8.
        _getObjectKeys: function (obj) {
            var i, keys = [];
            obj = Object.prototype.toString.call(obj) === Object.prototype.toString() ? obj : {};
            if (!Object.keys) {
                for (i in obj) {
                    if (obj.hasOwnProperty(i))
                        keys.push(i);
                }
                return keys;
            }
            if (Object.keys)
                return Object.keys(obj);
        },
        _touchStartPoints: function (evt, object) {
            if (evt) {
                var point = evt.touches ? evt.touches[0] : evt;
                object._distX = 0;
                object._distY = 0;
                object._moved = false;
                object._pointX = point.pageX;
                object._pointY = point.pageY;
            }
        },
        _isTouchMoved: function (evt, object) {
            if (evt) {
                var point = evt.touches ? evt.touches[0] : evt,
                deltaX = point.pageX - object._pointX,
                deltaY = point.pageY - object._pointY,
                timestamp = Date.now(),
                newX, newY,
                absDistX, absDistY;
                object._pointX = point.pageX;
                object._pointY = point.pageY;
                object._distX += deltaX;
                object._distY += deltaY;
                absDistX = Math.abs(object._distX);
                absDistY = Math.abs(object._distY);
                return !(absDistX < 5 && absDistY < 5);
            }
        },
        //To bind events for element
        listenEvents: function (selectors, eventTypes, handlers, remove, pluginObj, disableMouse) {
            for (var i = 0; i < selectors.length; i++) {
                ej.listenTouchEvent(selectors[i], eventTypes[i], handlers[i], remove, pluginObj, disableMouse);
            }
        },
        //To bind touch events for element
        listenTouchEvent: function (selector, eventType, handler, remove, pluginObj, disableMouse) {
            var event = remove ? "removeEventListener" : "addEventListener";
            var jqueryEvent = remove ? "off" : "on";
            var elements = $(selector);
            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];
                switch (eventType) {
                    case "touchstart":
                        ej._bindEvent(element, event, eventType, handler, "mousedown", "MSPointerDown", "pointerdown", disableMouse);
                        break;
                    case "touchmove":
                        ej._bindEvent(element, event, eventType, handler, "mousemove", "MSPointerMove", "pointermove", disableMouse);
                        break;
                    case "touchend":
                        ej._bindEvent(element, event, eventType, handler, "mouseup", "MSPointerUp", "pointerup", disableMouse);
                        break;
                    case "touchcancel":
                        ej._bindEvent(element, event, eventType, handler, "mousecancel", "MSPointerCancel", "pointercancel", disableMouse);
                        break;
                    case "tap": case "taphold": case "ejtouchmove": case "click":
                        $(element)[jqueryEvent](eventType, handler);
                        break;
                    default:
                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                            pluginObj["_on"]($(element), eventType, handler);
                        else
                            element[event](eventType, handler, true);
                        break;
                }
            }
        },
        //To bind events for element
        _bindEvent: function (element, event, eventType, handler, mouseEvent, pointerEvent, ie11pointerEvent, disableMouse) {
            if ($.support.hasPointer)
                element[event](window.navigator.pointerEnabled ? ie11pointerEvent : pointerEvent, handler, true);
            else
                element[event](eventType, handler, true);
        },
        _browser: function () {
            return (/webkit/i).test(navigator.appVersion) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : (/trident/i).test(navigator.userAgent) ? 'ms' : 'opera' in window ? 'O' : '';
        },
        styles: document.createElement('div').style,
        /**
       * To get the userAgent Name     
       * @example             
       * &lt;script&gt;
       *       ej.userAgent();//return user agent name
       * &lt;/script&gt         
       * @memberof AppView
       * @instance
       */
        userAgent: function () {
            var agents = 'webkitT,t,MozT,msT,OT'.split(','),
            t,
            i = 0,
            l = agents.length;

            for (; i < l; i++) {
                t = agents[i] + 'ransform';
                if (t in ej.styles) {
                    return agents[i].substr(0, agents[i].length - 1);
                }
            }

            return false;
        },
        addPrefix: function (style) {
            if (ej.userAgent() === '') return style;

            style = style.charAt(0).toUpperCase() + style.substr(1);
            return ej.userAgent() + style;
        },
        //To Prevent Default Exception

        //To destroy the mobile widgets
        destroyWidgets: function (element) {
            var dataEl = $(element).find("[data-role *= ejm]");
            dataEl.each(function (index, element) {
                var $element = $(element);
                var plugin = $element.data("ejWidgets");
                if (plugin)
                    $element[plugin]("destroy");
            });
        },
        //Get the attribute value of element
        getAttrVal: function (ele, val, option) {
            /// <summary>Util to get the property from data attributes</summary>
            /// <param name="ele" type="Object"></param>
            /// <param name="val" type="String"></param>
            /// <param name="option" type="GenericType"></param>
            /// <returns type="GenericType"></returns>
            var value = $(ele).attr(val);
            if (value != null)
                return value;
            else
                return option;
        },

        // Get the offset value of element
        getOffset: function (ele) {
            var pos = {};
            var offsetObj = ele.offset() || { left: 0, top: 0 };
            $.extend(true, pos, offsetObj);
            if ($("body").css("position") != "static") {
                var bodyPos = $("body").offset();
                pos.left -= bodyPos.left;
                pos.top -= bodyPos.top;
            }
            return pos;
        },

        // Z-index calculation for the element
        getZindexPartial: function (element, popupEle) {
            if (!ej.isNullOrUndefined(element) && element.length > 0) {
                var parents = element.parents(), bodyEle;
                bodyEle = $('body').children();
                if (!ej.isNullOrUndefined(element) && element.length > 0)
                    bodyEle.splice(bodyEle.index(popupEle), 1);
                $(bodyEle).each(function (i, ele) { parents.push(ele); });

                var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                    if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
                }));
                if (!maxZ || maxZ < 10000) maxZ = 10000;
                else maxZ += 1;
                return maxZ;
            }
        },

        isValidAttr: function (element, attribute) {
            var element = $(element)[0];
            if (typeof element[attribute] != "undefined")
                return true;
            else {
                var _isValid = false;
                $.each(element, function (key) {
                    if (key.toLowerCase() == attribute.toLowerCase()) {
                        _isValid = true;
                        return false;
                    }
                });
            }
            return _isValid;
        }

    };

    $.extend(ej, ej.util);

    // base class for all ej widgets. It will automatically inhertied
    ej.widgetBase = {
        droppables: { 'default': [] },
        resizables: { 'default': [] },

        _renderEjTemplate: function (selector, data, index, prop) {
            var type = null;
            if (typeof selector === "object" || selector.startsWith("#") || selector.startsWith("."))
                type = $(selector).attr("type");
            if (type) {
                type = type.toLowerCase();
                if (ej.template[type])
                    return ej.template[type](this, selector, data, index, prop);
            }
            return ej.template.render(this, selector, data, index, prop);
        },

        destroy: function () {

            if (this._trigger("destroy"))
                return;

            if (this.model.enablePersistence) {
                this.persistState();
                $(window).off("unload", this._persistHandler);
            }

            try {
                this._destroy();
            } catch (e) { }

            var arr = this.element.data("ejWidgets") || [];
            for (var i = 0; i < arr.length; i++) {
                if (arr[i] == this.pluginName) {
                    arr.splice(i, 1);
                }
            }
            if (!arr.length)
                this.element.removeData("ejWidgets");

            while (this._events) {
                var item = this._events.pop(), args = [];

                if (!item)
                    break;

                for (var i = 0; i < item[1].length; i++)
                    if (!$.isPlainObject(item[1][i]))
                        args.push(item[1][i]);

                $.fn.off.apply(item[0], args);
            }

            this._events = null;

            this.element
                .removeClass(ej.util.getNameSpace(this.sfType))
                .removeClass("e-js")
                .removeData(this.pluginName);

            this.element = null;
            this.model = null;
        },

        _on: function (element) {
            if (!this._events)
                this._events = [];
            var args = [].splice.call(arguments, 1, arguments.length - 1);

            var handler = {}, i = args.length;
            while (handler && typeof handler !== "function") {
                handler = args[--i];
            }

            args[i] = ej.proxy(args[i], this);

            this._events.push([element, args, handler, args[i]]);

            $.fn.on.apply(element, args);

            return this;
        },

        _off: function (element, eventName, selector, handlerObject) {
            var e = this._events, temp;
            if (!e || !e.length)
                return this;
            if (typeof selector == "function") {
                temp = handlerObject;
                handlerObject = selector;
                selector = temp;
            }
            var t = (eventName.match(/\S+/g) || [""]);
            for (var i = 0; i < e.length; i++) {
                var arg = e[i],
                r = arg[0].length && (!handlerObject || arg[2] === handlerObject) && (arg[1][0] === eventName || t[0]) && (!selector || arg[1][1] === selector) && $.inArray(element[0], arg[0]) > -1;
                if (r) {
                    $.fn.off.apply(element, handlerObject ? [eventName, selector, arg[3]] : [eventName, selector]);
                    e.splice(i, 1);
                    break;
                }
            }

            return this;
        },

        // Client side events wire-up / trigger helper.
        _trigger: function (eventName, eventProp) {
            var fn = null, returnValue, args, clientProp = {};
            $.extend(clientProp, eventProp)

            if (eventName in this.model)
                fn = this.model[eventName];

            if (fn) {
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }

                if ($.isFunction(fn)) {

                    args = ej.event(eventName, this.model, eventProp);

                    var scopeFn = this.model["_applyScope"];

                    returnValue = fn.call(this, args);

                    scopeFn && scopeFn.call();

                    // sending changes back - deep copy option should not be enabled for this $.extend 
                    if (eventProp) $.extend(eventProp, args);

                    if (args.cancel || !ej.isNullOrUndefined(returnValue))
                        return returnValue === false || args.cancel;
                }
            }

            var isPropDefined = Boolean(eventProp);
            eventProp = eventProp || {};
            eventProp.originalEventType = eventName;
            eventProp.type = this.pluginName + eventName;

            args = $.Event(eventProp.type, ej.event(eventProp.type, this.model, eventProp));

            this.element && this.element.trigger(args);

            // sending changes back - deep copy option should not be enabled for this $.extend 
            if (isPropDefined) $.extend(eventProp, args);

            if (ej.isOnWebForms && args.cancel == false && this.model.serverEvents && this.model.serverEvents.length)
                ej.raiseWebFormsServerEvents(eventName, eventProp, clientProp);

            return args.cancel;
        },

        setModel: function (options, forceSet) {
            // check for whether to apply values are not. if _setModel function is defined in child,
            //  this will call that function and validate it using return value

            if (this._trigger("modelChange", { "changes": options }))
                return;

            for (var prop in options) {
                if (!forceSet) {
                    if (this.model[prop] === options[prop]) {
                        delete options[prop];
                        continue;
                    }
                    if ($.isPlainObject(options[prop])) {
                        iterateAndRemoveProps(this.model[prop], options[prop]);
                        if ($.isEmptyObject(options[prop])) {
                            delete options[prop];
                            continue;
                        }
                    }
                }

                if (this.dataTypes) {
                    var returnValue = this._isValidModelValue(prop, this.dataTypes, options);
                    if (returnValue !== true)
                        throw "setModel - Invalid input for property :" + prop + " - " + returnValue;
                }
                if (this.model.notifyOnEachPropertyChanges && this.model[prop] !== options[prop]) {
                    var arg = {
                        oldValue: this.model[prop],
                        newValue: options[prop]
                    };

                    options[prop] = this._trigger(prop + "Change", arg) ? this.model[prop] : arg.newValue;
                }
            }
            if ($.isEmptyObject(options))
                return;

            if (this._setFirst) {
                var ds = options.dataSource;
                if (ds) delete options.dataSource;

                $.extend(true, this.model, options);
                if (ds) {
                    this.model.dataSource = (ds instanceof Array) ? ds.slice() : ds;
                    options["dataSource"] = this.model.dataSource;
                }
                !this._setModel || this._setModel(options);

            } else if (!this._setModel || this._setModel(options) !== false) {
                $.extend(true, this.model, options);
            }
            if ("enablePersistence" in options) {
                this._setState(options.enablePersistence);
            }
        },
        option: function (prop, value, forceSet) {
            if (!prop)
                return this.model;

            if ($.isPlainObject(prop))
                return this.setModel(prop, forceSet);

            if (typeof prop === "string") {
                prop = prop.replace(/^model\./, "");
                var oldValue = ej.getObject(prop, this.model);

                if (value === undefined && !forceSet)
                    return oldValue;

                if (prop === "enablePersistence")
                    return this._setState(value);

                if (forceSet && value === ej.extensions.modelGUID) {
                    return this._setModel(ej.createObject(prop, ej.getObject(prop, this.model), {}));
                }

                if (forceSet || ej.getObject(prop, this.model) !== value)
                    return this.setModel(ej.createObject(prop, value, {}), forceSet);
            }
            return undefined;
        },

        _isValidModelValue: function (prop, types, options) {
            var value = types[prop], option = options[prop], returnValue;

            if (!value)
                return true;

            if (typeof value === "string") {
                if (value == "enum") {
                    options[prop] = option ? option.toString().toLowerCase() : option;
                    value = "string";
                }

                if (value === "array") {
                    if (Object.prototype.toString.call(option) === '[object Array]')
                        return true;
                }
                else if (value === "data") {
                    return true;
                }
                else if (value === "parent") {
                    return true;
                }
                else if (typeof option === value)
                    return true;

                return "Expected type - " + value;
            }

            if (option instanceof Array) {
                for (var i = 0; i < option.length; i++) {
                    returnValue = this._isValidModelValue(prop, types, option[i]);
                    if (returnValue !== true) {
                        return " [" + i + "] - " + returnValue;
                    }
                }
                return true;
            }

            for (var innerProp in option) {
                returnValue = this._isValidModelValue(innerProp, value, option);
                if (returnValue !== true)
                    return innerProp + " : " + returnValue;
            }

            return true;
        },

        _returnFn: function (obj, propName) {
            if (propName.indexOf('.') != -1) {
                this._returnFn(obj[propName.split('.')[0]], propName.split('.').slice(1).join('.'));
            }
            else
                obj[propName] = obj[propName].call(obj.propName);
        },

        _removeCircularRef: function (obj) {
            var seen = [];
            function detect(obj, key, parent) {
                if (typeof obj != 'object') { return; }
                if (!Array.prototype.indexOf) {
                    Array.prototype.indexOf = function (val) {
                        return jQuery.inArray(val, this);
                    };
                }
                if (seen.indexOf(obj) >= 0) {
                    delete parent[key];
                    return;
                }
                seen.push(obj);
                for (var k in obj) { //dive on the object's children
                    if (obj.hasOwnProperty(k)) { detect(obj[k], k, obj); }
                }
                seen.pop();
                return;
            }
            detect(obj, 'obj', null);
            return obj;
        },

        stringify: function (model, removeCircular) {
            var observables = this.observables;
            for (var k = 0; k < observables.length; k++) {
                var val = ej.getObject(observables[k], model);
                if (!ej.isNullOrUndefined(val) && typeof (val) === "function")
                    this._returnFn(model, observables[k]);
            }
            if (removeCircular) model = this._removeCircularRef(model);
            return JSON.stringify(model);
        },

        _setState: function (val) {
            if (val === true) {
                this._persistHandler = ej.proxy(this.persistState, this);
                $(window).on("unload", this._persistHandler);
            } else {
                this.deleteState();
                $(window).off("unload", this._persistHandler);
            }
        },

        _removeProp: function (obj, propName) {
            if (!ej.isNullOrUndefined(obj)) {
                if (propName.indexOf('.') != -1) {
                    this._removeProp(obj[propName.split('.')[0]], propName.split('.').slice(1).join('.'));
                }
                else
                    delete obj[propName];
            }
        },

        persistState: function () {
            var model;

            if (this._ignoreOnPersist) {
                model = copyObject({}, this.model);
                for (var i = 0; i < this._ignoreOnPersist.length; i++) {
                    this._removeProp(model, this._ignoreOnPersist[i]);
                }
                model.ignoreOnPersist = this._ignoreOnPersist;
            } else if (this._addToPersist) {
                model = {};
                for (var i = 0; i < this._addToPersist.length; i++) {
                    ej.createObject(this._addToPersist[i], ej.getObject(this._addToPersist[i], this.model), model);
                }
                model.addToPersist = this._addToPersist;
            } else {
                model = copyObject({}, this.model);
            }

            if (this._persistState) {
                model.customPersists = {};
                this._persistState(model.customPersists);
            }

            if (window.localStorage) {
                if (!ej.isNullOrUndefined(ej.persistStateVersion) && window.localStorage.getItem("persistKey") == null)
                    window.localStorage.setItem("persistKey", ej.persistStateVersion);
                window.localStorage.setItem("$ej$" + this.pluginName + this._id, JSON.stringify(model));
            }
            else if (document.cookie) {
                if (!ej.isNullOrUndefined(ej.persistStateVersion) && ej.cookie.get("persistKey") == null)
                    ej.cookie.set("persistKey", ej.persistStateVersion);
                ej.cookie.set("$ej$" + this.pluginName + this._id, model);
            }
        },

        deleteState: function () {
            if (window.localStorage)
                window.localStorage.removeItem("$ej$" + this.pluginName + this._id);
            else if (document.cookie)
                ej.cookie.set("$ej$" + this.pluginName + this._id, model, new Date());
        },

        restoreState: function (silent) {
            var value = null;
            if (window.localStorage)
                value = window.localStorage.getItem("$ej$" + this.pluginName + this._id);
            else if (document.cookie)
                value = ej.cookie.get("$ej$" + this.pluginName + this._id);

            if (value) {
                var model = JSON.parse(value);

                if (this._restoreState) {
                    this._restoreState(model.customPersists);
                    delete model.customPersists;
                }

                if (ej.isNullOrUndefined(model) === false)
                    if (!ej.isNullOrUndefined(model.ignoreOnPersist)) {
                        this._ignoreOnPersist = model.ignoreOnPersist;
                        delete model.ignoreOnPersist;
                    } else if (!ej.isNullOrUndefined(model.addToPersist)) {
                        this._addToPersist = model.addToPersist;
                        delete model.addToPersist;
                    }
            }
            if (!ej.isNullOrUndefined(model) && !ej.isNullOrUndefined(this._ignoreOnPersist)) {
                for (var i in this._ignoreOnPersist) {
                    if (this._ignoreOnPersist[i].indexOf('.') !== -1)
                        ej.createObject(this._ignoreOnPersist[i], ej.getObject(this._ignoreOnPersist[i], this.model), model);
                    else
                        model[this._ignoreOnPersist[i]] = this.model[this._ignoreOnPersist[i]];
                }
                this.model = model;
            }
            else
                this.model = $.extend(true, this.model, model);

            if (!silent && value && this._setModel)
                this._setModel(this.model);
        },

        //to prevent persistence
        ignoreOnPersist: function (properties) {
            var collection = [];
            if (typeof (properties) == "object")
                collection = properties;
            else if (typeof (properties) == 'string')
                collection.push(properties);
            if (this._addToPersist === undefined) {
                this._ignoreOnPersist = this._ignoreOnPersist || [];
                for (var i = 0; i < collection.length; i++) {
                    this._ignoreOnPersist.push(collection[i]);
                }
            } else {
                for (var i = 0; i < collection.length; i++) {
                    var index = this._addToPersist.indexOf(collection[i]);
                    this._addToPersist.splice(index, 1);
                }
            }
        },

        //to maintain persistence
        addToPersist: function (properties) {
            var collection = [];
            if (typeof (properties) == "object")
                collection = properties;
            else if (typeof (properties) == 'string')
                collection.push(properties);
            if (this._addToPersist === undefined) {
                this._ignoreOnPersist = this._ignoreOnPersist || [];
                for (var i = 0; i < collection.length; i++) {
                    var index = this._ignoreOnPersist.indexOf(collection[i]);
                    this._ignoreOnPersist.splice(index, 1);
                }
            } else {
                for (var i = 0; i < collection.length; i++) {
                    if ($.inArray(collection[i], this._addToPersist) === -1)
                        this._addToPersist.push(collection[i]);
                }
            }
        },

        // Get formatted text 
        formatting: function (formatstring, str, locale) {
            formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
            locale = ej.preferredCulture(locale) ? locale : "en-US";
            var s = formatstring;
            var frontHtmlidx, FrontHtml, RearHtml, lastidxval;
            frontHtmlidx = formatstring.split("{0:");
            lastidxval = formatstring.split("}");
            FrontHtml = frontHtmlidx[0];
            RearHtml = lastidxval[1];
            if (typeof (str) == "string" && $.isNumeric(str))
                str = Number(str);
            if (formatstring.indexOf("{0:") != -1) {
                var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                var formatVal = toformat.exec(formatstring);
                if (formatVal != null && str != null) {
                    if (FrontHtml != null && RearHtml != null)
                        str = FrontHtml + ej.format(str, formatVal[2], locale) + RearHtml;
                    else
                        str = ej.format(str, formatVal[2], locale);
                } else if (str != null)
                    str = str;
                else
                    str = "";
                return str;
            } else if (s.startsWith("{") && !s.startsWith("{0:")) {
                var fVal = s.split(""), str = (str || "") + "", strSplt = str.split(""), formats = /[0aA\*CN<>\?]/gm;
                for (var f = 0, f, val = 0; f < fVal.length; f++)
                    fVal[f] = formats.test(fVal[f]) ? "{" + val++ + "}" : fVal[f];
                return String.format.apply(String, [fVal.join("")].concat(strSplt)).replace('{', '').replace('}', '');
            } else if (this.data != null && this.data.Value == null) {
                $.each(this.data, function (dataIndex, dataValue) {
                    s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
                });
                return s;
            } else {
                return this.data.Value;
            }
        },
    };

    ej.WidgetBase = function () {
    }

    var iterateAndRemoveProps = function (source, target) {
        for (var prop in source) {
            if (source[prop] === target[prop])
                delete target[prop];
            if ($.isPlainObject(target[prop]) && $.isPlainObject(source[prop]))
                iterateAndRemoveProps(source[prop], target[prop]);
        }
    }

    ej.widget = function (pluginName, className, proto) {
        /// <summary>Widget helper for developers, this set have predefined function to jQuery plug-ins</summary>
        /// <param name="pluginName" type="String">the plugin name that will be added in jquery.fn</param>
        /// <param name="className" type="String">the class name for your plugin, this will help create default cssClas</param>
        /// <param name="proto" type="Object">prototype for of the plug-in</param>

        if (typeof pluginName === "object") {
            proto = className;
            for (var prop in pluginName) {
                var name = pluginName[prop];

                if (name instanceof Array) {
                    proto._rootCSS = name[1];
                    name = name[0];
                }

                ej.widget(prop, name, proto);

                if (pluginName[prop] instanceof Array)
                    proto._rootCSS = "";
            }

            return;
        }

        var nameSpace = proto._rootCSS || ej.getNameSpace(className);

        proto = ej.defineClass(className, function (element, options) {

            this.sfType = className;
            this.pluginName = pluginName;
            this.instance = pInstance;

            if (ej.isNullOrUndefined(this._setFirst))
                this._setFirst = true;

            this["ob.values"] = {};

            $.extend(this, ej.widgetBase);

            if (this.dataTypes) {
                for (var property in options) {
                    var returnValue = this._isValidModelValue(property, this.dataTypes, options);
                    if (returnValue !== true)
                        throw "setModel - Invalid input for property :" + property + " - " + returnValue;
                }
            }

            var arr = (element.data("ejWidgets") || []);
            arr.push(pluginName);
            element.data("ejWidgets", arr);

            for (var i = 0; ej.widget.observables && this.observables && i < this.observables.length; i++) {
                var t = ej.getObject(this.observables[i], options);
                if (t) ej.createObject(this.observables[i], ej.widget.observables.register(t, this.observables[i], this, element), options);
            }

            this.element = element.jquery ? element : $(element);
            this.model = copyObject(true, {}, proto.prototype.defaults, options);
            this.model.keyConfigs = copyObject(this.keyConfigs);

            this.element.addClass(nameSpace + " e-js").data(pluginName, this);

            this._id = element[0].id;

            if (!this.element.attr("tabIndex"))
                this.element.attr("tabIndex", "");

            if (this.model.enablePersistence) {
                if (window.localStorage && !ej.isNullOrUndefined(ej.persistStateVersion) && window.localStorage.getItem("persistKey") != ej.persistStateVersion) {
                    for (var i in window.localStorage) {
                        if (i.indexOf("$ej$") != -1)
                            window.localStorage.removeItem(i); //removing the previously stored plugin item from local storage				
                    }
                }
                else if (document.cookie && !ej.isNullOrUndefined(ej.persistStateVersion) && ej.cookie.get("persistKey") != ej.persistStateVersion) {
                    var splits = document.cookie.split(/; */);
                    for (var k in splits) {
                        if (k.indexOf("$ej$") != -1)
                            ej.cookie.set(k.split("=")[0], model, new Date()); //removing the previously stored plugin item from local storage		
                    }
                }
                this._persistHandler = ej.proxy(this.persistState, this);
                $(window).on("unload", this._persistHandler);
                this.restoreState(true);
            }

            this._init(options);

            if (typeof this.model.keyConfigs === "object" && !(this.model.keyConfigs instanceof Array)) {
                var requiresEvt = false;
                if (this.model.keyConfigs.focus)
                    this.element.attr("accesskey", this.model.keyConfigs.focus);

                for (var keyProps in this.model.keyConfigs) {
                    if (keyProps !== "focus") {
                        requiresEvt = true;
                        break;
                    }
                }

                if (requiresEvt && this._keyPressed) {
                    var el = element, evt = "keydown";

                    if (this.keySettings) {
                        el = this.keySettings.getElement ? this.keySettings.getElement() || el : el;
                        evt = this.keySettings.event || evt;
                    }

                    this._on(el, evt, function (e) {
                        if (!this.model.keyConfigs) return;

                        var action = keyFn.getActionFromCode(this.model.keyConfigs, e.which, e.ctrlKey, e.shiftKey, e.altKey);
                        var arg = {
                            code: e.which,
                            ctrl: e.ctrlKey,
                            alt: e.altKey,
                            shift: e.shiftKey
                        };
                        if (!action) return;

                        if (this._keyPressed(action, e.target, arg, e) === false)
                            e.preventDefault();
                    });
                }
            }
            this._trigger("create");
        }, proto);

        $.fn[pluginName] = function (options) {
            var opt = options, args;
            for (var i = 0; i < this.length; i++) {

                var $this = $(this[i]),
                    pluginObj = $this.data(pluginName),
                    isAlreadyExists = pluginObj && $this.hasClass(nameSpace),
                    obj = null;

                if (this.length > 0 && $.isPlainObject(opt))
                    options = ej.copyObject({}, opt);

                // ----- plug-in creation/init
                if (!isAlreadyExists) {
                    if (proto.prototype._requiresID === true && !$(this[i]).attr("id")) {
                        $this.attr("id", getUid("ejControl_"));
                    }
                    if (!options || typeof options === "object") {
                        if (proto.prototype.defaults && !ej.isNullOrUndefined(ej.setCulture) && "locale" in proto.prototype.defaults && pluginName != "ejChart") {
                            if (options && !("locale" in options)) options.locale = ej.setCulture().name;
                            else if (ej.isNullOrUndefined(options)) {
                                options = {}; options.locale = ej.setCulture().name;
                            }
                        }
                        new proto($this, options);
                    }
                    else {
                        throwError(pluginName + ": methods/properties can be accessed only after plugin creation");
                    }
                    continue;
                }

                if (!options) continue;

                args = [].slice.call(arguments, 1);

                if (this.length > 0 && args[0] && opt === "option" && $.isPlainObject(args[0])) {
                    args[0] = ej.copyObject({}, args[0]);
                }

                // --- Function/property set/access
                if ($.isPlainObject(options)) {
                    // setModel using JSON object
                    pluginObj.setModel(options);
                }

                    // function/property name starts with "_" is private so ignore it.
                else if (options.indexOf('_') !== 0
                    && !ej.isNullOrUndefined(obj = ej.getObject(options, pluginObj))
                    || options.indexOf("model.") === 0) {

                    if (!obj || !$.isFunction(obj)) {

                        // if property is accessed, then break the jquery chain
                        if (arguments.length == 1)
                            return obj;

                        //setModel using string input
                        pluginObj.option(options, arguments[1]);

                        continue;
                    }

                    var value = obj.apply(pluginObj, args);

                    // If function call returns any value, then break the jquery chain
                    if (value !== undefined)
                        return value;

                } else {
                    throwError(className + ": function/property - " + options + " does not exist");
                }
            }
            if (pluginName.indexOf("ejm") != -1)
                ej.widget.registerInstance($this, pluginName, className, proto.prototype);
            // maintaining jquery chain
            return this;
        };

        ej.widget.register(pluginName, className, proto.prototype);
    };

    $.extend(ej.widget, (function () {
        var _widgets = {}, _registeredInstances = [],

        register = function (pluginName, className, prototype) {
            if (!ej.isNullOrUndefined(_widgets[pluginName]))
                throwError("ej.widget : The widget named " + pluginName + " is trying to register twice.");

            _widgets[pluginName] = { name: pluginName, className: className, proto: prototype };

            ej.widget.extensions && ej.widget.extensions.registerWidget(pluginName);
        },
        registerInstance = function (element, pluginName, className, prototype) {
            _registeredInstances.push({ element: element, pluginName: pluginName, className: className, proto: prototype });
        }

        return {
            register: register,
            registerInstance: registerInstance,
            registeredWidgets: _widgets,
            registeredInstances: _registeredInstances
        };

    })());

    ej.widget.destroyAll = function (elements) {
        if (!elements || !elements.length) return;

        for (var i = 0; i < elements.length; i++) {
            var data = elements.eq(i).data(), wds = data["ejWidgets"];
            if (wds && wds.length) {
                for (var j = 0; j < wds.length; j++) {
                    if (data[wds[j]] && data[wds[j]].destroy)
                        data[wds[j]].destroy();
                }
            }
        }
    };

    ej.cookie = {
        get: function (name) {
            var value = RegExp(name + "=([^;]+)").exec(document.cookie);

            if (value && value.length > 1)
                return value[1];

            return undefined;
        },
        set: function (name, value, expiryDate) {
            if (typeof value === "object")
                value = JSON.stringify(value);

            value = escape(value) + ((expiryDate == null) ? "" : "; expires=" + expiryDate.toUTCString());
            document.cookie = name + "=" + value;
        }
    };

    var keyFn = {
        getActionFromCode: function (keyConfigs, keyCode, isCtrl, isShift, isAlt) {
            isCtrl = isCtrl || false;
            isShift = isShift || false;
            isAlt = isAlt || false;

            for (var keys in keyConfigs) {
                if (keys === "focus") continue;

                var key = keyFn.getKeyObject(keyConfigs[keys]);
                for (var i = 0; i < key.length; i++) {
                    if (keyCode === key[i].code && isCtrl == key[i].isCtrl && isShift == key[i].isShift && isAlt == key[i].isAlt)
                        return keys;
                }
            }
            return null;
        },
        getKeyObject: function (key) {
            var res = {
                isCtrl: false,
                isShift: false,
                isAlt: false
            };
            var tempRes = $.extend(true, {}, res);
            var $key = key.split(","), $res = [];
            for (var i = 0; i < $key.length; i++) {
                var rslt = null;
                if ($key[i].indexOf("+") != -1) {
                    var k = $key[i].split("+");
                    for (var j = 0; j < k.length; j++) {
                        rslt = keyFn.getResult($.trim(k[j]), res);
                    }
                }
                else {
                    rslt = keyFn.getResult($.trim($key[i]), $.extend(true, {}, tempRes));
                }
                $res.push(rslt);
            }
            return $res;
        },
        getResult: function (key, res) {
            if (key === "ctrl")
                res.isCtrl = true;
            else if (key === "shift")
                res.isShift = true;
            else if (key === "alt")
                res.isAlt = true;
            else res.code = parseInt(key, 10);
            return res;
        }
    };

    ej.getScrollableParents = function (element) {
        return $(element).parentsUntil("html").filter(function () {
            return $(this).css("overflow") != "visible";
        }).add($(window));
    }
    ej.browserInfo = function () {
        var browser = {}, clientInfo = [],
        browserClients = {
            opera: /(opera|opr)(?:.*version|)[ \/]([\w.]+)/i, edge: /(edge)(?:.*version|)[ \/]([\w.]+)/i, webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie|trident) ([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        for (var client in browserClients) {
            if (browserClients.hasOwnProperty(client)) {
                clientInfo = navigator.userAgent.match(browserClients[client]);
                if (clientInfo) {
                    browser.name = clientInfo[1].toLowerCase() == "opr" ? "opera" : clientInfo[1].toLowerCase();
                    browser.version = clientInfo[2];
                    browser.culture = {};
                    browser.culture.name = browser.culture.language = navigator.language || navigator.userLanguage;
                    if (typeof (ej.globalize) != 'undefined') {
                        var oldCulture = ej.preferredCulture().name;
                        var culture = (navigator.language || navigator.userLanguage) ? ej.preferredCulture(navigator.language || navigator.userLanguage) : ej.preferredCulture("en-US");
                        for (var i = 0; (navigator.languages) && i < navigator.languages.length; i++) {
                            culture = ej.preferredCulture(navigator.languages[i]);
                            if (culture.language == navigator.languages[i])
                                break;
                        }
                        ej.preferredCulture(oldCulture);
                        $.extend(true, browser.culture, culture);
                    }
                    if (!!navigator.userAgent.match(/Trident\/7\./)) {
                        browser.name = "msie";
                    }
                    break;
                }
            }
        }
        browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
        browser.pointerEnabled = window.navigator.pointerEnabled;
        return browser;
    };
    ej.eventType = {
        mouseDown: "mousedown touchstart",
        mouseMove: "mousemove touchmove",
        mouseUp: "mouseup touchend",
        mouseLeave: "mouseleave touchcancel",
        click: "click touchend"
    };

    ej.event = function (type, data, eventProp) {

        var e = $.extend(eventProp || {},
            {
                "type": type,
                "model": data,
                "cancel": false
            });

        return e;
    };

    ej.proxy = function (fn, context, arg) {
        if (!fn || typeof fn !== "function")
            return null;

        if ('on' in fn && context)
            return arg ? fn.on(context, arg) : fn.on(context);

        return function () {
            var args = arg ? [arg] : []; args.push.apply(args, arguments);
            return fn.apply(context || this, args);
        };
    };

    ej.hasStyle = function (prop) {
        var style = document.documentElement.style;

        if (prop in style) return true;

        var prefixs = ['ms', 'Moz', 'Webkit', 'O', 'Khtml'];

        prop = prop[0].toUpperCase() + prop.slice(1);

        for (var i = 0; i < prefixs.length; i++) {
            if (prefixs[i] + prop in style)
                return true;
        }

        return false;
    };

    Array.prototype.indexOf = Array.prototype.indexOf || function (searchElement) {
        var len = this.length;

        if (len === 0) return -1;

        for (var i = 0; i < len; i++) {
            if (i in this && this[i] === searchElement)
                return i;
        }
        return -1;
    };

    String.prototype.startsWith = String.prototype.startsWith || function (key) {
        return this.slice(0, key.length) === key;
    };
    var copyObject = ej.copyObject = function (isDeepCopy, target) {
        var start = 2, current, source;
        if (typeof isDeepCopy !== "boolean") {
            start = 1;
        }
        var objects = [].slice.call(arguments, start);
        if (start === 1) {
            target = isDeepCopy;
            isDeepCopy = undefined;
        }

        for (var i = 0; i < objects.length; i++) {
            for (var prop in objects[i]) {
                current = target[prop], source = objects[i][prop];

                if (source === undefined || current === source || objects[i] === source || target === source)
                    continue;
                if (source instanceof Array) {
                    if (i === 0 && isDeepCopy) {
                        target[prop] = new Array();
                        for (var j = 0; j < source.length; j++) {
                            copyObject(true, target[prop], source);
                        }
                    }
                    else
                        target[prop] = source.slice();
                }
                else if (ej.isPlainObject(source)) {
                    target[prop] = current || {};
                    if (isDeepCopy)
                        copyObject(isDeepCopy, target[prop], source);
                    else
                        copyObject(target[prop], source);
                } else
                    target[prop] = source;
            }
        }
        return target;
    };
    var pInstance = function () {
        return this;
    }

    var _uid = 0;
    var getUid = function (prefix) {
        return prefix + _uid++;
    }

    ej.template = {};

    ej.template.render = ej.template["text/x-jsrender"] = function (self, selector, data, index, prop) {
        if (selector.slice(0, 1) !== "#")
            selector = ["<div>", selector, "</div>"].join("");
        var property = { prop: prop, index: index };
        return $(selector).render(data, property);
    }

    ej.isPlainObject = function (obj) {
        if (!obj) return false;
        if (ej.DataManager !== undefined && obj instanceof ej.DataManager) return false;
        if (typeof obj !== "object" || obj.nodeType || jQuery.isWindow(obj)) return false;
        try {
            if (obj.constructor &&
                !obj.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                return false;
            }
        } catch (e) {
            return false;
        }

        var key, ownLast = ej.support.isOwnLast;
        for (key in obj) {
            if (ownLast) break;
        }

        return key === undefined || obj.hasOwnProperty(key);
    };
    var getValueFn = false;
    ej.util.valueFunction = function (prop) {
        return function (value, getObservable) {
            var val = ej.getObject(prop, this.model);

            if (getValueFn === false)
                getValueFn = ej.getObject("observables.getValue", ej.widget);

            if (value === undefined) {
                if (!ej.isNullOrUndefined(getValueFn)) {
                    return getValueFn(val, getObservable);
                }
                return typeof val === "function" ? val.call(this) : val;
            }

            if (typeof val === "function") {
                this["ob.values"][prop] = value;
                val.call(this, value);
            }
            else
                ej.createObject(prop, value, this.model);
        }
    };
    ej.util.getVal = function (val) {
        if (typeof val === "function")
            return val();
        return val;
    };
    ej.support = {
        isOwnLast: function () {
            var fn = function () { this.a = 1; };
            fn.prototype.b = 1;

            for (var p in new fn()) {
                return p === "b";
            }
        }(),
        outerHTML: function () {
            return document.createElement("div").outerHTML !== undefined;
        }()
    };

    var throwError = ej.throwError = function (er) {
        try {
            throw new Error(er);
        } catch (e) {
            throw e.message + "\n" + e.stack;
        }
    };

    ej.getRandomValue = function (min, max) {
        if (min === undefined || max === undefined)
            return ej.throwError("Min and Max values are required for generating a random number");

        var rand;
        if ("crypto" in window && "getRandomValues" in crypto) {
            var arr = new Uint16Array(1);
            window.crypto.getRandomValues(arr);
            rand = arr[0] % (max - min) + min;
        }
        else rand = Math.random() * (max - min) + min;
        return rand | 0;
    }

    ej.extensions = {};
    ej.extensions.modelGUID = "{0B1051BA-1CCB-42C2-A3B5-635389B92A50}";
})(window.jQuery, window.Syncfusion);
(function () {
    $.fn.addEleAttrs = function (json) {
        var $this = $(this);
        $.each(json, function (i, attr) {
            if (attr && attr.specified) {
                $this.attr(attr.name, attr.value);
            }
        });

    };
    $.fn.removeEleAttrs = function (regex) {
        return this.each(function () {
            var $this = $(this),
                names = [],
                attrs = $(this.attributes).clone();
            $.each(attrs, function (i, attr) {
                if (attr && attr.specified && regex.test(attr.name)) {
                    $this.removeAttr(attr.name);
                }
            });
        });
    };
    $.fn.attrNotStartsWith = function (regex) {
        var proxy = this;
        var attributes = [], attrs;
        this.each(function () {
            attrs = $(this.attributes).clone();
        });
        for (i = 0; i < attrs.length; i++) {
            if (attrs[i] && attrs[i].specified && regex.test(attrs[i].name)) {
                continue
            }
            else
                attributes.push(attrs[i])
        }
        return attributes;

    }
    $.fn.removeEleEmptyAttrs = function () {
        return this.each(function () {
            var $this = $(this),
                names = [],
                attrs = $(this.attributes).clone();
            $.each(attrs, function (i, attr) {
                if (attr && attr.specified && attr.value === "") {
                    $this.removeAttr(attr.name);
                }
            });
        });
    };
    $.extend($.support, {
        has3d: ej.addPrefix('perspective') in ej.styles,
        hasTouch: 'ontouchstart' in window,
        hasPointer: navigator.msPointerEnabled,
        hasTransform: ej.userAgent() !== false,
        pushstate: "pushState" in history &&
        "replaceState" in history,
        hasTransition: ej.addPrefix('transition') in ej.styles
    });
    //Ensuring elements having attribute starts with 'ejm-' 
    $.extend($.expr[':'], {
        attrNotStartsWith: function (element, index, match) {
            var i, attrs = element.attributes;
            for (i = 0; i < attrs.length; i++) {
                if (attrs[i].nodeName.indexOf(match[3]) === 0) {
                    return false;
                }
            }
            return true;
        }
    });
    //addBack() is supported from Jquery >1.8 and andSelf() supports later version< 1.8. support for both the method is provided by extending the JQuery function.
    var oldSelf = $.fn.andSelf || $.fn.addBack;
    $.fn.andSelf = $.fn.addBack = function () {
        return oldSelf.apply(this, arguments);
    };
})();;
;
window.ej = window.Syncfusion = window.Syncfusion || {};

(function ($, ej, doc, undefined) {
    'use strict';
	
    ej.DataManager = function (dataSource, query, adaptor) {
          if (!(this instanceof ej.DataManager))
            return new ej.DataManager(dataSource, query, adaptor);

        if (!dataSource)
            dataSource = [];
        adaptor = adaptor || dataSource.adaptor;

        if (typeof (adaptor) === "string") 
            adaptor = new ej[adaptor]();
        var data = [], self = this;

        if (dataSource instanceof Array) {
            // JSON array
            data = {
                json: dataSource,
                offline: true
            };

        } else if (typeof dataSource === "object") {
            if ($.isPlainObject(dataSource)) {
                if (!dataSource.json)
                    dataSource.json = [];
                if (dataSource.table)
                    dataSource.json = this._getJsonFromElement(dataSource.table, dataSource.headerOption);
                data = {
                    url: dataSource.url,
                    insertUrl: dataSource.insertUrl,
                    removeUrl: dataSource.removeUrl,
                    updateUrl: dataSource.updateUrl,
                    crudUrl: dataSource.crudUrl,
                    batchUrl: dataSource.batchUrl,
                    json: dataSource.json,
                    headers: dataSource.headers,
                    accept: dataSource.accept,
                    data: dataSource.data,
					async : dataSource.async,
                    timeTillExpiration: dataSource.timeTillExpiration,
                    cachingPageSize: dataSource.cachingPageSize,
                    enableCaching: dataSource.enableCaching,
                    requestType: dataSource.requestType,
                    key: dataSource.key,
                    crossDomain: dataSource.crossDomain,
                    jsonp: dataSource.jsonp,
                    dataType: dataSource.dataType,
                    offline: dataSource.offline !== undefined ? dataSource.offline : dataSource.adaptor == "remoteSaveAdaptor" || dataSource.adaptor instanceof ej.remoteSaveAdaptor ? false : dataSource.url ? false : true,
                    requiresFormat: dataSource.requiresFormat
                };
            } else if (dataSource.jquery || isHtmlElement(dataSource)) {
                data = {
                    json: this._getJsonFromElement(dataSource),
                    offline: true,
                    table: dataSource
                };
            }
        } else if (typeof dataSource === "string") {
            data = {
                url: dataSource,
                offline: false,
                dataType: "json",
                json: []
            };
        }

        if (data.requiresFormat === undefined && !ej.support.cors)
            data.requiresFormat = isNull(data.crossDomain) ? true : data.crossDomain;
        if (data.dataType === undefined)
            data.dataType = "json";
        this.dataSource = data;
        this.defaultQuery = query;

        if (data.url && data.offline && !data.json.length) {
            this.isDataAvailable = false;
            this.adaptor = adaptor || new ej.ODataAdaptor();
            this.dataSource.offline = false;
            this.ready = this.executeQuery(query || ej.Query()).done(function (e) {
                self.dataSource.offline = true;
                self.isDataAvailable = true;
                data.json = e.result;
                self.adaptor = new ej.JsonAdaptor();
            });
        }
        else
            this.adaptor = data.offline ? new ej.JsonAdaptor() : new ej.ODataAdaptor();
        if (!data.jsonp && this.adaptor instanceof ej.ODataAdaptor)
            data.jsonp = "callback";
        this.adaptor = adaptor || this.adaptor;
        if (data.enableCaching)
            this.adaptor = new ej.CacheAdaptor(this.adaptor, data.timeTillExpiration, data.cachingPageSize);
        return this;
    };

    ej.DataManager.prototype = {
        setDefaultQuery: function (query) {
            this.defaultQuery = query;
        },
	
        executeQuery: function (query, done, fail, always) {
            if (typeof query === "function") {
                always = fail;
                fail = done;
                done = query;
                query = null;
            }

            if (!query)
                query = this.defaultQuery;

            if (!(query instanceof ej.Query))
                throwError("DataManager - executeQuery() : A query is required to execute");

            var deffered = $.Deferred();

            deffered.then(done, fail, always);
            var args = { query: query };

            if (!this.dataSource.offline && this.dataSource.url != undefined) {
				 var result = this.adaptor.processQuery(this, query);
                if (!ej.isNullOrUndefined(result.url))
                    this._makeRequest(result, deffered, args, query);
                else {
                    nextTick(function () {
                        args = this._getDeferedArgs(query, result, args);
                        deffered.resolveWith(this, [args]);;
                    }, this);
                }
            } else {
				if(!ej.isNullOrUndefined(this.dataSource.async) && this.dataSource.async == false)
					this._localQueryProcess(query, args, deffered);
				else{
					nextTick(function () {
						this._localQueryProcess(query, args, deffered);
					}, this);
				}
            }
            return deffered.promise();
        },
		_localQueryProcess: function(query, args, deffered){
			var res = this.executeLocal(query);
			args = this._getDeferedArgs(query, res, args);
			deffered.resolveWith(this, [args]);
		},
        _getDeferedArgs: function (query, result, args) {
            if (query._requiresCount) {
                args.result = result.result;
                args.count = result.count;
            } else
                args.result = result;
            args.getTableModel = getTableModel(query._fromTable, args.result, this);
            args.getKnockoutModel = getKnockoutModel(args.result);
            return args;
        },
	
        executeLocal: function (query) {
            if (!this.defaultQuery && !(query instanceof ej.Query))
                throwError("DataManager - executeLocal() : A query is required to execute");

            if (!this.dataSource.json)
                throwError("DataManager - executeLocal() : Json data is required to execute");

            query = query || this.defaultQuery;

            var result = this.adaptor.processQuery(this, query);

            if (query._subQuery) {
                var from = query._subQuery._fromTable, lookup = query._subQuery._lookup,
                    res = query._requiresCount ? result.result : result;

                if (lookup && lookup instanceof Array) {
                    buildHierarchy(query._subQuery._fKey, from, res, lookup, query._subQuery._key);
                }

                for (var j = 0; j < res.length; j++) {
                    if (res[j][from] instanceof Array) {
                        res[j] = $.extend({}, res[j]);
                        res[j][from] = this.adaptor.processResponse(query._subQuery.using(ej.DataManager(res[j][from].slice(0))).executeLocal(), this, query);
                    }
                }
            }

            return this.adaptor.processResponse(result, this, query);
        },

        _makeRequest: function (url, deffered, args, query) {
            var isSelector = !!query._subQuerySelector;

            var fnFail = $proxy(function (e) {
                args.error = e;
                deffered.rejectWith(this, [args]);
            }, this);

            var process = $proxy(function (data, count, xhr, request, actual, aggregates, virtualSelectRecords) {
                if (isSelector) return;

                args.xhr = xhr;
                args.count = parseInt(count, 10);
                args.result = data;
                args.request = request;
                args.aggregates = aggregates;
                args.getTableModel = getTableModel(query._fromTable, data, this);
                args.getKnockoutModel = getKnockoutModel(data);
                args.actual = actual;
                args.virtualSelectRecords = virtualSelectRecords;
                deffered.resolveWith(this, [args]);

            }, this);

            var fnQueryChild = $proxy(function (data, selector) {
                var subDeffer = $.Deferred(),
                    childArgs = { parent: args };

                query._subQuery._isChild = true;

                var subUrl = this.adaptor.processQuery(this, query._subQuery, data ? this.adaptor.processResponse(data) : selector);

                var childReq = this._makeRequest(subUrl, subDeffer, childArgs, query._subQuery);

                if(!isSelector)
                    subDeffer.then(function (subData) {
                        if (data) {
                            buildHierarchy(query._subQuery._fKey, query._subQuery._fromTable, data, subData, query._subQuery._key);
                            process(data);
                        }
                    }, fnFail);

                return childReq;
            }, this);

            var fnSuccess = proxy(function (data, status, xhr, request) {
                if (xhr.getResponseHeader("Content-Type").indexOf("xml") == -1 && ej.dateParse)
                    data = ej.parseJSON(data);
                var result = this.adaptor.processResponse(data, this, query, xhr, request), count = 0, aggregates = null;
                var virtualSelectRecords = data.virtualSelectRecords;
                if (query._requiresCount) {
                    count = result.count;
                    aggregates = result.aggregates;
                    result = result.result;
                }

                if (!query._subQuery) {
                    process(result, count, xhr, request, data, aggregates, virtualSelectRecords);
                    return;
                }

                if (!isSelector)
                    fnQueryChild(result);

            }, this);

            var req = $.extend({
                type: "GET",
                dataType: this.dataSource.dataType,
                crossDomain: this.dataSource.crossDomain,
                jsonp: this.dataSource.jsonp,
                cache: true,
                beforeSend: $proxy(this._beforeSend, this),
                processData: false,
                success: fnSuccess,
                error: fnFail
            }, url);

            if ("async" in this.dataSource)
                req.async = this.dataSource.async;

            req = $.ajax(req);

            if (isSelector) {
                var res = query._subQuerySelector.call(this, { query: query._subQuery, parent: query });

                if (res && res.length) {
                    req = $.when(req, fnQueryChild(null, res));

                    req.then(proxy(function (pData, cData, requests) {
                        var pResult = this.adaptor.processResponse(pData[0], this, query, pData[2], requests[0]), count = 0;
                        if (query._requiresCount) {
                            count = pResult.count;
                            pResult = pResult.result;
                        }
                        var cResult = this.adaptor.processResponse(cData[0], this, query._subQuery, cData[2], requests[1]), count = 0;
                        if (query._subQuery._requiresCount) {
                            count = cResult.count;
                            cResult = cResult.result;
                        }

                        buildHierarchy(query._subQuery._fKey, query._subQuery._fromTable, pResult, cResult, query._subQuery._key);
                        isSelector = false;
                        process(pResult, count, pData[2]);

                    }, this), fnFail);
                } else {
                    isSelector = false;
                }
            }

            return req;
        },

        _beforeSend: function (request, settings) {
            this.adaptor.beforeSend(this, request, settings);

            var headers = this.dataSource.headers, props;
            for (var i = 0; headers && i < headers.length; i++) {
                props = [];
                for (var prop in headers[i]) {
                    props.push(prop);
                    request.setRequestHeader(prop, headers[i][prop]);
                }
            }
        },
	
        saveChanges: function (changes, key, tableName, query) {

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var args = {
                url: tableName,
                key: key || this.dataSource.key
            };

            var req = this.adaptor.batchRequest(this, changes, args, query);

            if (this.dataSource.offline) {
                return req;
            }

            var deff = $.Deferred();
            $.ajax($.extend({
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (data, status, xhr, request) {
                    deff.resolveWith(this, [this.adaptor.processResponse(data, this, null, xhr, request, changes)]);
                }, this),
                error: function (e) {
                    deff.rejectWith(this, [{ error: e }]);
                }
            }, req));

            return deff.promise();
        },
	
        insert: function (data, tableName, query) {           
            data = p.replacer(data);

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.insert(this, data, tableName, query);

            if (this.dataSource.offline) {
                return res;
            }            

            var deffer = $.Deferred();

            $.ajax($.extend({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                processData: false,
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
            }, res));

            return deffer.promise();
        },
	
        remove: function (keyField, value, tableName, query) {
            if (typeof value === "object")
                value = value[keyField];

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.remove(this, keyField, value, tableName, query);

            if (this.dataSource.offline)
                return res;          

            var deffer = $.Deferred();
            $.ajax($.extend({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
            }, res));
            return deffer.promise();
        },
	
        update: function (keyField, value, tableName, query) {
            value = p.replacer(value);

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.update(this, keyField, value, tableName, query);

            if (this.dataSource.offline) {
                return res;
            }           

            var deffer = $.Deferred();

           $.ajax($.extend({
                contentType: "application/json; charset=utf-8",
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
           }, res));

           return deffer.promise();
        },

        _getJsonFromElement: function (ds) {
            if (typeof (ds) == "string")
                ds = $($(ds).html());

            ds = ds.jquery ? ds[0] : ds;

            var tagName = ds.tagName.toLowerCase();

            if (tagName !== "table")
                throwError("ej.DataManager : Unsupported htmlElement : " + tagName);

            return ej.parseTable(ds);
        }
    };

    var buildHierarchy = function (fKey, from, source, lookup, pKey) {
        var i, grp = {}, t;
        if (lookup.result) lookup = lookup.result;

        if (lookup.GROUPGUID)
            throwError("ej.DataManager: Do not have support Grouping in hierarchy");

        for (i = 0; i < lookup.length; i++) {
            var fKeyData = ej.getObject(fKey, lookup[i]);
            t = grp[fKeyData] || (grp[fKeyData] = []);

            t.push(lookup[i]);
        }

        for (i = 0; i < source.length; i++) {
            source[i][from] = grp[ej.getObject(pKey || fKey, source[i])];
        }
    };

    var oData = {
        accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
        multipartAccept: "multipart/mixed",
        batch: "$batch",
        changeSet: "--changeset_",
        batchPre: "batch_",
        contentId: "Content-Id: ",
        batchContent: "Content-Type: multipart/mixed; boundary=",
        changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
        batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
    };
    var p = {
        parseJson: function (jsonText) {
            var type = typeof jsonText;
            if (type === "string") {
                jsonText = JSON.parse(jsonText, p.jsonReviver);
            } else if (jsonText instanceof Array) {
                p.iterateAndReviveArray(jsonText);
            } else if (type === "object")
                p.iterateAndReviveJson(jsonText);
            return jsonText;
        },
        iterateAndReviveArray: function (array) {
            for (var i = 0; i < array.length; i++) {
                if (typeof array[i] === "object")
                    p.iterateAndReviveJson(array[i]);
                else if (typeof array[i] === "string" && !/^[\s]*\[|^[\s]*\{|\"/g.test(array[i]))
                    array[i] = p.jsonReviver("",array[i]);
                else
                    array[i] = p.parseJson(array[i]);
            }
        },
        iterateAndReviveJson: function (json) {
            var value;

            for (var prop in json) {
                if (prop.startsWith("__"))
                    continue;

                value = json[prop];
                if (typeof value === "object") {
                    if (value instanceof Array)
                        p.iterateAndReviveArray(value);
                    else
                        p.iterateAndReviveJson(value);
                } else
                    json[prop] = p.jsonReviver(prop, value);
            }
        },
        jsonReviver: function (field, value) {
            var s = value;
            if (typeof value === "string") {
                var ms = /^\/Date\(([+-]?[0-9]+)([+-][0-9]{4})?\)\/$/.exec(value);
                if (ms)
                    return p.replacer(new Date(parseInt(ms[1])));
                else if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*){1})([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(value)) {
                    value = p.replacer(new Date(value));
                    if (isNaN(value)) {
                        var a = s.split(/[^0-9]/);
                        value = p.replacer(new Date(a[0], a[1] - 1, a[2], a[3], a[4], a[5]));
                    }
                }
            }

            return value;
        },
        isJson: function (jsonData) {
            if(typeof jsonData[0]== "string")
                return jsonData;
            return ej.parseJSON(jsonData);
        },
        isGuid: function (value) {
            var regex = /[A-Fa-f0-9]{8}(?:-[A-Fa-f0-9]{4}){3}-[A-Fa-f0-9]{12}/i;
            var match = regex.exec(value);
            return match != null;
        },
        replacer: function (value) {

            if (ej.isPlainObject(value))
                return p.jsonReplacer(value);

            if (value instanceof Array)
                return p.arrayReplacer(value);

            if (value instanceof Date)
                return p.jsonReplacer({ val: value }).val;

            return value;
        },
        jsonReplacer: function (val) {
            var value;
            for (var prop in val) {
                value = val[prop];

                if (!(value instanceof Date))
                    continue;
                val[prop] = new Date(+value + (ej.serverTimezoneOffset * 60 * 60 * 1000));
            }

            return val;
        },
        arrayReplacer: function (val) {

            for (var i = 0; i < val.length; i++) {            
                if (ej.isPlainObject(val[i]))
                    val[i] = p.jsonReplacer(val[i]);
                else if (val[i] instanceof Date)
                    val[i] = p.jsonReplacer({ date: val[i] }).date;
            }

            return val;
        }
    };

    ej.isJSON = p.isJson;
    ej.parseJSON = p.parseJson;
    ej.dateParse = true;
    ej.isGUID = p.isGuid;
    ej.Query = function (from) {
        if (!(this instanceof ej.Query))
            return new ej.Query(from);

        this.queries = [];
        this._key = "";
        this._fKey = "";

        if (typeof from === "string")
            this._fromTable = from || "";
        else if (from && from instanceof Array)
            this._lookup = from;

        this._expands = [];
        this._sortedColumns = [];
        this._groupedColumns = [];
        this._subQuery = null;
        this._isChild = false;
        this._params = [];
        return this;
    };

    ej.Query.prototype = {
        key: function (field) {
            if (typeof field === "string")
                this._key = field;

            return this;
        },
	
        using: function (dataManager) {
            if (dataManager instanceof ej.DataManager) {
                this.dataManagar = dataManager;
                return this;
            }

            return throwError("Query - using() : 'using' function should be called with parameter of instance ej.DataManager");
        },
	
        execute: function (dataManager, done, fail, always) {
            dataManager = dataManager || this.dataManagar;

            if (dataManager && dataManager instanceof ej.DataManager)
                return dataManager.executeQuery(this, done, fail, always);

            return throwError("Query - execute() : dataManager needs to be is set using 'using' function or should be passed as argument");
        },
	
        executeLocal: function (dataManager) {
            // this does not support for URL binding
            

            dataManager = dataManager || this.dataManagar;

            if (dataManager && dataManager instanceof ej.DataManager)
                return dataManager.executeLocal(this);

            return throwError("Query - executeLocal() : dataManager needs to be is set using 'using' function or should be passed as argument");
        },
	
        clone: function () {
            var cl = new ej.Query();
            cl.queries = this.queries.slice(0);
            cl._key = this._key;
            cl._isChild = this._isChild;
            cl.dataManagar = this.dataManager;
            cl._fromTable = this._fromTable;
            cl._params = this._params.slice(0);
            cl._expands = this._expands.slice(0);
            cl._sortedColumns = this._sortedColumns.slice(0);
            cl._groupedColumns = this._groupedColumns.slice(0);
            cl._subQuerySelector = this._subQuerySelector;
            cl._subQuery = this._subQuery;
            cl._fKey = this._fKey;
            cl._requiresCount = this._requiresCount;
            return cl;
        },
	
        from: function (tableName) {
            if (typeof tableName === "string")
                this._fromTable = tableName;

            return this;
        },
	
        addParams: function (key, value) {
            if (typeof value !== "function" && !ej.isPlainObject(value))
                this._params.push({ key: key, value: value });
            else if (typeof value === "function")
                this._params.push({ key: key, fn: value });

            return this;
        },
	
        expand: function (tables) {
            if (typeof tables === "string")
                this._expands = [].slice.call(arguments, 0);
            else
                this._expands = tables.slice(0);

            return this;
        },
	
        where: function (fieldName, operator, value, ignoreCase) {
            operator = (operator || ej.FilterOperators.equal).toLowerCase();
            var predicate = null;

            if (typeof fieldName === "string")
                predicate = new ej.Predicate(fieldName, operator, value, ignoreCase);
            else if (fieldName instanceof ej.Predicate)
                predicate = fieldName;
            else
                throwError("Query - where : Invalid arguments");

            this.queries.push({
                fn: "onWhere",
                e: predicate
            });
            return this;
        },
	
        search: function (searchKey, fieldNames, operator, ignoreCase) {
            if (!fieldNames || typeof fieldNames === "boolean") {
                fieldNames = [];
                ignoreCase = fieldNames;
            } else if (typeof fieldNames === "string")
                fieldNames = [fieldNames];

            if (typeof operator === "boolean") {
                ignoreCase = operator;
                operator = null;
            }
            operator = operator || ej.FilterOperators.contains;
            if (operator.length < 3)
                operator = ej.data.operatorSymbols[operator];

            var comparer = ej.data.fnOperators[operator] || ej.data.fnOperators.processSymbols(operator);

            this.queries.push({
                fn: "onSearch",
                e: {
                    fieldNames: fieldNames,
                    operator: operator,
                    searchKey: searchKey,
                    ignoreCase: ignoreCase,
                    comparer: comparer
                }
            });
            return this;
        },
		
        sortBy: function (fieldName, comparer, isFromGroup) {
            var order = ej.sortOrder.Ascending, sorts, t;

            if (typeof fieldName === "string" && fieldName.toLowerCase().endsWith(" desc")) {
                fieldName = fieldName.replace(/ desc$/i, '');
                comparer = ej.sortOrder.Descending;
            }
            if (fieldName instanceof Array) {
                for(var i=0;i<fieldName.length;i++)
                   this.sortBy(fieldName[i],comparer,isFromGroup);
                return this;
            }
            if (typeof comparer === "boolean")
                comparer = !comparer ? ej.sortOrder.Ascending : ej.sortOrder.Descending;
            else if (typeof comparer === "function")
                order = "custom";

            if (!comparer || typeof comparer === "string") {
                order = comparer ? comparer.toLowerCase() : ej.sortOrder.Ascending;
                comparer = ej.pvt.fnSort(comparer);
            }
            if (isFromGroup) {
                sorts = filterQueries(this.queries, "onSortBy");

                for (var i = 0; i < sorts.length; i++) {
                    t = sorts[i].e.fieldName;
                    if (typeof t === "string") {
                        if (t === fieldName) return this;
                    } else if (t instanceof Array) {
                        for (var j = 0; j < t.length; j++)
                            if (t[j] === fieldName || fieldName.toLowerCase() === t[j] + " desc")
                                return this;
                    }
                }
            }

            this.queries.push({
                fn: "onSortBy",
                e: {
                    fieldName: fieldName,
                    comparer: comparer,
                    direction: order
                }
            });

            return this;
        },
		
        sortByDesc: function (fieldName) {
            return this.sortBy(fieldName, ej.sortOrder.Descending);
        },
		
        group: function (fieldName,fn) {
            this.sortBy(fieldName, null, true);

            this.queries.push({
                fn: "onGroup",
                e: {
                    fieldName: fieldName,
                    fn: fn
                }
            });
            return this;
        },
	
        page: function (pageIndex, pageSize) {
            this.queries.push({
                fn: "onPage",
                e: {
                    pageIndex: pageIndex,
                    pageSize: pageSize
                }
            });
            return this;
        },
	
        range: function (start, end) {
            if (typeof start !== "number" || typeof end !== "number")
                throwError("Query() - range : Arguments type should be a number");

            this.queries.push({
                fn: "onRange",
                e: {
                    start: start,
                    end: end
                }
            });
            return this;
        },
	

        take: function (nos) {
            if (typeof nos !== "number")
                throwError("Query() - Take : Argument type should be a number");

            this.queries.push({
                fn: "onTake",
                e: {
                    nos: nos
                }
            });
            return this;
        },
	
        skip: function (nos) {
            if (typeof nos !== "number")
                throwError("Query() - Skip : Argument type should be a number");

            this.queries.push({
                fn: "onSkip",
                e: { nos: nos }
            });
            return this;
        },
	
        select: function (fieldNames) {
            if (typeof fieldNames === "string")
                fieldNames = [].slice.call(arguments, 0);

            if (!(fieldNames instanceof Array)) {
                throwError("Query() - Select : Argument type should be String or Array");
            }

            this.queries.push({
                fn: "onSelect",
                e: { fieldNames: fieldNames }
            });
            return this;
        },
	
        hierarchy: function (query, selectorFn) {
            if (!query || !(query instanceof ej.Query))
                throwError("Query() - hierarchy : query must be instance of ej.Query");

            if (typeof selectorFn === "function")
                this._subQuerySelector = selectorFn;

            this._subQuery = query;
            return this;
        },
	
        foreignKey: function (key) {
            if (typeof key === "string")
                this._fKey = key;

            return this;
        },
	
        requiresCount: function () {
            this._requiresCount = true;

            return this;
        },
        //type - sum, avg, min, max
        aggregate: function (type, field) {
            this.queries.push({
                fn: "onAggregates",
                e: { field: field, type: type }
            });
        }
    };

    ej.Adaptor = function (ds) {
        this.dataSource = ds;
        this.pvt = {};
		this.init.apply(this, [].slice.call(arguments, 1));
    };

    ej.Adaptor.prototype = {
        options: {
            from: "table",
            requestType: "json",
            sortBy: "sorted",
            select: "select",
            skip: "skip",
            group: "group",
            take: "take",
            search: "search",
            count: "requiresCounts",
            where: "where",
            aggregates: "aggregates"
        },
        init: function () {
        },
        extend: function (overrides) {
            var fn = function (ds) {
                this.dataSource = ds;

                if (this.options)
                    this.options = $.extend({}, this.options);
				this.init.apply(this, [].slice.call(arguments, 0));

                this.pvt = {};
            };
            fn.prototype = new this.type();
            fn.prototype.type = fn;

            var base = fn.prototype.base = {};
            for (var p in overrides) {
                if (fn.prototype[p])
                    base[p] = fn.prototype[p];
            }
            $.extend(true, fn.prototype, overrides);
            return fn;
        },
        processQuery: function (dm, query) {
            // this needs to be overridden
        },
        processResponse: function (data, ds, query, xhr) {
            if (data.d)
               return data.d;
            return data;
        },
        convertToQueryString: function (req, query, dm) {
            return $.param(req);
        },
        type: ej.Adaptor
    };

    ej.UrlAdaptor = new ej.Adaptor().extend({
        processQuery: function (dm, query, hierarchyFilters) {
            var sorted = filterQueries(query.queries, "onSortBy"),
                grouped = filterQueries(query.queries, "onGroup"),
                filters = filterQueries(query.queries, "onWhere"),
                searchs = filterQueries(query.queries, "onSearch"),
                aggregates = filterQueries(query.queries, "onAggregates"),
                singles = filterQueryLists(query.queries, ["onSelect", "onPage", "onSkip", "onTake", "onRange"]),
                params = query._params,
                url = dm.dataSource.url, tmp, skip, take = null,
                op = this.options;

            var r = {
                sorted: [],
                grouped: [],
                filters: [],
                searches: [],
                aggregates: []
            };

            // calc Paging & Range
            if (singles["onPage"]) {
                tmp = singles["onPage"];
                skip = getValue(tmp.pageIndex, query);
                take = getValue(tmp.pageSize, query);
				skip = (skip - 1) * take;
            } else if (singles["onRange"]) {
                tmp = singles["onRange"];
                skip = tmp.start;
                take = tmp.end - tmp.start;
            }

            // Sorting
            for (var i = 0; i < sorted.length; i++) {
                tmp = getValue(sorted[i].e.fieldName, query);

                r.sorted.push(callAdaptorFunc(this, "onEachSort", { name: tmp, direction: sorted[i].e.direction }, query));
            }

            // hierarchy
            if (hierarchyFilters) {
                tmp = this.getFiltersFrom(hierarchyFilters, query);
                if (tmp)
                    r.filters.push(callAdaptorFunc(this, "onEachWhere", tmp.toJSON(), query));
            }

            // Filters
            for (var i = 0; i < filters.length; i++) {
                r.filters.push(callAdaptorFunc(this, "onEachWhere", filters[i].e.toJSON(), query));

                for (var prop in r.filters[i]) {
                    if (isNull(r[prop]))
                        delete r[prop];
                }
            }

            // Searches
            for (var i = 0; i < searchs.length; i++) {
                tmp = searchs[i].e;
                r.searches.push(callAdaptorFunc(this, "onEachSearch", {
                    fields: tmp.fieldNames,
                    operator: tmp.operator,
                    key: tmp.searchKey,
                    ignoreCase: tmp.ignoreCase
                }, query));
            }

            // Grouping
            for (var i = 0; i < grouped.length; i++) {
                r.grouped.push(getValue(grouped[i].e.fieldName, query));
            }

            // aggregates
            for (var i = 0; i < aggregates.length; i++) {
                tmp = aggregates[i].e; 
                r.aggregates.push({ type: tmp.type, field: getValue(tmp.field, query) });
            }

            var req = {};
            req[op.from] = query._fromTable;
            if (op.expand) req[op.expand] = query._expands;
            req[op.select] = singles["onSelect"] ? callAdaptorFunc(this, "onSelect", getValue(singles["onSelect"].fieldNames, query), query) : "";
            req[op.count] = query._requiresCount ? callAdaptorFunc(this, "onCount", query._requiresCount, query) : "";
            req[op.search] = r.searches.length ? callAdaptorFunc(this, "onSearch", r.searches, query) : "";
            req[op.skip] = singles["onSkip"] ? callAdaptorFunc(this, "onSkip", getValue(singles["onSkip"].nos, query), query) : "";
            req[op.take] = singles["onTake"] ? callAdaptorFunc(this, "onTake", getValue(singles["onTake"].nos, query), query) : "";
            req[op.where] = r.filters.length || r.searches.length ? callAdaptorFunc(this, "onWhere", r.filters, query) : "";
            req[op.sortBy] = r.sorted.length ? callAdaptorFunc(this, "onSortBy", r.sorted, query) : "";
            req[op.group] = r.grouped.length ? callAdaptorFunc(this, "onGroup", r.grouped, query) : "";
            req[op.aggregates] = r.aggregates.length ? callAdaptorFunc(this, "onAggregates", r.aggregates, query) : "";
			req["param"] = [];
			
            // Params
			callAdaptorFunc(this, "addParams", { dm: dm, query: query, params: params, reqParams: req });

            // cleanup
            for (var prop in req) {
                if (isNull(req[prop]) || req[prop] === "" || req[prop].length === 0 || prop === "params")
                    delete req[prop];
            }

            if (!(op.skip in req && op.take in req) && take !== null) {
                req[op.skip] = callAdaptorFunc(this, "onSkip", skip, query);
                req[op.take] = callAdaptorFunc(this, "onTake", take, query);
            }
            var p = this.pvt;
            this.pvt = {};

            if (this.options.requestType === "json") {
                return {
                    data: JSON.stringify(req),
                    url: url,
                    ejPvtData: p,
                    type: "POST",
                    contentType: "application/json; charset=utf-8"
                }
            }
            tmp = this.convertToQueryString(req, query, dm);
            tmp =  (dm.dataSource.url.indexOf("?")!== -1 ? "&" : "/") + tmp;
            return {
                type: "GET",
                url: tmp.length ? url.replace(/\/*$/, tmp) : url,
                ejPvtData: p
            };
        },
        convertToQueryString: function (req, query, dm) {
            if (dm.dataSource.url && dm.dataSource.url.indexOf("?") !== -1)
                return $.param(req);
            return "?" + $.param(req);
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            var pvt = request.ejPvtData || {};
			var groupDs= data.groupDs;
			if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            var d = JSON.parse(request.data);
            if (d && d.action === "batch" && data.added) {
                changes.added = data.added;
                return changes;
            }
            if (data.d)
                data = data.d;

            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                if ('count' in data) args.count = data.count;
                if (data["result"]) args.result = data.result;
                if (data["aggregate"]) data = data.aggregate;
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                args["aggregates"] = res;
                data = args;
            }

            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups, args = {};
                if ('count' in data) args.count = data.count;
                if (data["aggregates"]) args.aggregates = data.aggregates;
                if (data["result"]) data = data.result;
                for (var i = 0; i < groups.length; i++){
                    var level = null;
                    var format = getColFormat(groups[i], query.queries);
                    if (!ej.isNullOrUndefined(groupDs))
                        groupDs = ej.group(groupDs, groups[i], null, format);
                    data = ej.group(data, groups[i], pvt.aggregates, format, level, groupDs);
                }
                if (args.count != undefined)
                    args.result = data;
                else
                    args = data;
                return args;
            }
            return data;
        },
        onGroup: function (e) {
            this.pvt.groups = e;
        },
        onAggregates: function (e) {
            this.pvt.aggregates = e;
        },
        batchRequest: function (dm, changes, e, query) {
            var res = {
                changed: changes.changed,
                added: changes.added,
                deleted: changes.deleted,
                action: "batch",
                table: e.url,
                key: e.key
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.removeUrl || dm.dataSource.url,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(res)
            };
        },
        beforeSend: function (dm, request) {
        },
        insert: function (dm, data, tableName, query) {
            var res = {
                value: data,
                table: tableName,
                action: "insert"
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                url: dm.dataSource.insertUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        remove: function (dm, keyField, value, tableName, query) {
            var res = {
                key: value,
                keyColumn: keyField,
                table: tableName,
                action: "remove"
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.removeUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        update: function (dm, keyField, value, tableName, query) {
            var res = {
                value: value,
                action: "update",
                keyColumn: keyField,
                key: value[keyField],
                table: tableName
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.updateUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        getFiltersFrom: function (data, query) {
            if (!(data instanceof Array) || !data.length)
                throwError("ej.SubQuery: Array of key values required");
            var key = query._fKey, value, prop = key, pKey = query._key, predicats = [],
                isValues = typeof data[0] !== "object";

            if (typeof data[0] !== "object") prop = null;

            for (var i = 0; i < data.length; i++) {
                value = !isValues ? ej.pvt.getObject(pKey || prop, data[i]) : data[i];
                predicats.push(new ej.Predicate(key, "==", value));
            }

            return ej.Predicate.or(predicats);
        },
        addParams: function (options) {
            var dm = options.dm, query = options.query, params = options.params, req = options.reqParams; req["params"] = {};
            for (var i = 0, tmp; tmp = params[i]; i++) {
                if (req[tmp.key]) throwError("ej.Query: Custom Param is conflicting other request arguments");
                req[tmp.key] = tmp.value;
                if (tmp.fn)
                    req[tmp.key] = tmp.fn.call(query, tmp.key, query, dm);                
                req["params"][tmp.key] = req[tmp.key];
            }
        }
    });
    ej.WebMethodAdaptor = new ej.UrlAdaptor().extend({
        processQuery: function (dm, query, hierarchyFilters) {
            var obj = ej.UrlAdaptor.prototype.processQuery(dm, query, hierarchyFilters);
            var data = ej.parseJSON(obj.data), result = {};

            result["value"] = data;

            //Params             
            callAdaptorFunc(this, "addParams", { dm: dm, query: query, params: query._params, reqParams: result });

            return {
                data: JSON.stringify(result),
                url: obj.url,
                ejPvtData: obj.ejPvtData,
                type: "POST",
                contentType: "application/json; charset=utf-8"
            }
        },
        addParams: function (options) {
            var dm = options.dm, query = options.query, params = options.params, req = options.reqParams; req["params"] = {};
            for (var i = 0, tmp; tmp = params[i]; i++) {
                if (req[tmp.key]) throwError("ej.Query: Custom Param is conflicting other request arguments");
                var webkey = tmp.key, webvalue = tmp.value;
                if (tmp.fn)
                    webvalue = tmp.fn.call(query, tmp.key, query, dm);
                req[webkey] = webvalue;
                req["params"][webkey] = req[webkey];
            }
        }
    });
    ej.CacheAdaptor = new ej.UrlAdaptor().extend({
        init: function (adaptor, timeStamp, pageSize) {
            if (!ej.isNullOrUndefined(adaptor)) {
                this.cacheAdaptor = adaptor;
            }
            this.pageSize = pageSize;
            this.guidId = ej.getGuid("cacheAdaptor");
            var obj = { keys: [], results: [] };
            if (window.localStorage)
                window.localStorage.setItem(this.guidId, JSON.stringify(obj));
            var guid = this.guidId;
            if (!ej.isNullOrUndefined(timeStamp)) {
                setInterval(function () {
                    var data = ej.parseJSON(window.localStorage.getItem(guid));
                    var forDel = [];
                    for (var i = 0; i < data.results.length; i++) {
                        data.results[i].timeStamp = new Date() - new Date(data.results[i].timeStamp)
                        if (new Date() - new Date(data.results[i].timeStamp) > timeStamp)
                            forDel.push(i);
                    }
                    var d = forDel;
                    for (var i = 0; i < forDel.length; i++) {
                        data.results.splice(forDel[i], 1);
                        data.keys.splice(forDel[i], 1);
                    }
                    window.localStorage.removeItem(guid);
                    window.localStorage.setItem(guid, JSON.stringify(data));
                }, timeStamp);
            }
        },
        generateKey: function (url, query) {
            var sorted = filterQueries(query.queries, "onSortBy"),
                grouped = filterQueries(query.queries, "onGroup"),
                filters = filterQueries(query.queries, "onWhere"),
                searchs = filterQueries(query.queries, "onSearch"),
				pageQuery = filterQueries(query.queries, "onPage"),
                singles = filterQueryLists(query.queries, ["onSelect", "onPage", "onSkip", "onTake", "onRange"]),
                params = query._params;
            var key = url;
            if (singles["onPage"])
              key += singles["onPage"].pageIndex;
              sorted.forEach(function (obj) {
                   key += obj.e.direction + obj.e.fieldName;
              });
                grouped.forEach(function (obj) {
                    key += obj.e.fieldName;
                });
                searchs.forEach(function (obj) {
                    key += obj.e.searchKey;
                });
            
            for (var filter = 0; filter < filters.length; filter++) {
                var currentFilter = filters[filter];
                if (currentFilter.e.isComplex) {
                    var newQuery = query.clone();
                    newQuery.queries = [];
                    for (var i = 0; i < currentFilter.e.predicates.length; i++) {
                        newQuery.queries.push({ fn: "onWhere", e: currentFilter.e.predicates[i], filter: query.queries.filter });
                    }
                    key += currentFilter.e.condition + this.generateKey(url, newQuery);
                }
                else
                    key += currentFilter.e.field + currentFilter.e.operator + currentFilter.e.value
            }
            return key;
        },
        processQuery: function (dm, query, hierarchyFilters) {
            var key = this.generateKey(dm.dataSource.url, query);
            var cachedItems;
            if (window.localStorage)
                cachedItems = ej.parseJSON(window.localStorage.getItem(this.guidId));
            var data = cachedItems ? cachedItems.results[cachedItems.keys.indexOf(key)] : null;
            if (data != null && !this._crudAction && !this._insertAction) {
                return data;
            }
            this._crudAction = null; this._insertAction = null;
            return this.cacheAdaptor.processQuery.apply(this.cacheAdaptor, [].slice.call(arguments, 0))
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            if (this._insertAction || (request && this.cacheAdaptor.options.batch && request.url.endsWith(this.cacheAdaptor.options.batch) && request.type.toLowerCase() === "post")) {
                return this.cacheAdaptor.processResponse(data, ds, query, xhr, request, changes);
            }
            var data = this.cacheAdaptor.processResponse.apply(this, [].slice.call(arguments, 0));
            var key = this.generateKey(ds.dataSource.url, query)
            var obj = {};
            if (window.localStorage)
                obj = ej.parseJSON(window.localStorage.getItem(this.guidId));
            var index = $.inArray(key, obj.keys);
            if (index != -1) {
                obj.results.splice(index, 1);
                obj.keys.splice(index, 1);
            }
            obj.results[obj.keys.push(key) - 1] = { keys: key, result: data.result, timeStamp: new Date(), count: data.count }
            while (obj.results.length > this.pageSize) {
                obj.results.splice(0, 1);
                obj.keys.splice(0, 1);
            }
            window.localStorage.setItem(this.guidId, JSON.stringify(obj));
            return data;
        },
        update: function (dm, keyField, value, tableName) {
            this._crudAction = true;
            return this.cacheAdaptor.update(dm, keyField, value, tableName);
        },
        insert: function (dm, data, tableName) {
            this._insertAction = true;
            return this.cacheAdaptor.insert(dm, data, tableName);
        },
        remove: function (dm, keyField, value, tableName) {
            this._crudAction = true;
            return this.cacheAdaptor.remove(dm, keyField, value, tableName);
        },
        batchRequest: function (dm, changes, e) {
            return this.cacheAdaptor.batchRequest(dm, changes, e);
        }
    });
    var filterQueries = function (queries, name) {
        return queries.filter(function (q) {
            return q.fn === name;
        }) || [];
    };
    var filterQueryLists = function (queries, singles) {
        var filtered = queries.filter(function (q) {
            return singles.indexOf(q.fn) !== -1;
        }), res = {};
        for (var i = 0; i < filtered.length; i++) {
            if (!res[filtered[i].fn])
                res[filtered[i].fn] = filtered[i].e;
        }
        return res;
    };
    var callAdaptorFunc = function (obj, fnName, param, param1) {
        if (obj[fnName]) {
            var res = obj[fnName](param, param1);
            if (!isNull(res)) param = res;
        }
        return param;
    };

    ej.ODataAdaptor = new ej.UrlAdaptor().extend({
        options: {
            requestType: "get",
            accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
            multipartAccept: "multipart/mixed",
            sortBy: "$orderby",
            select: "$select",
            skip: "$skip",
            take: "$top",
            count: "$inlinecount",
            where: "$filter",
            expand: "$expand",
            batch: "$batch",
            changeSet: "--changeset_",
            batchPre: "batch_",
            contentId: "Content-Id: ",
            batchContent: "Content-Type: multipart/mixed; boundary=",
            changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
            batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
        },
        onEachWhere: function (filter, requiresCast) {
            return filter.isComplex ? this.onComplexPredicate(filter, requiresCast) : this.onPredicate(filter, requiresCast);
        },
        onPredicate: function (pred, query, requiresCast) {
            var returnValue = "",
                operator,guid,
                val = pred.value,
                type = typeof val,
                field = this._p(pred.field);

            if (val instanceof Date)
                val = "datetime'" + p.replacer(val).toJSON() + "'";

            if (type === "string") {
				if(val.indexOf("'") != -1)
                    val = val.replace(new RegExp(/'/g),"''");
                val = "'" + val + "'";

                if (requiresCast) {
                    field = "cast(" + field + ", 'Edm.String')";
                }
                if (ej.isGUID(val))
                    guid = 'guid';
                if (pred.ignoreCase) {
                    !guid ? field = "tolower(" + field + ")" : field;
                    val = val.toLowerCase();
                }
            }

            operator = ej.data.odBiOperator[pred.operator];
            if (operator) {
                returnValue += field;
                returnValue += operator;
                if (guid)
                    returnValue += guid;
                return returnValue + val;
            }

            operator = ej.data.odUniOperator[pred.operator];
            if (!operator || type !== "string") return "";

            if (operator === "substringof") {
                var t = val;
                val = field;
                field = t;
            }

            returnValue += operator + "(";
            returnValue += field + ",";
            if (guid) returnValue += guid;
            returnValue += val + ")";

            return returnValue;
        },
        onComplexPredicate: function (pred, requiresCast) {
            var res = [];
            for (var i = 0; i < pred.predicates.length; i++) {
                res.push("(" + this.onEachWhere(pred.predicates[i], requiresCast) + ")");
            }
            return res.join(" " + pred.condition + " ");
        },
        onWhere: function (filters) {
            if (this.pvt.searches)
                filters.push(this.onEachWhere(this.pvt.searches, null, true));

            return filters.join(" and ");
        },
        onEachSearch: function (e) {
            if (e.fields.length === 0)
                throwError("Query() - Search : oData search requires list of field names to search");

            var filter = this.pvt.searches || [];
            for (var i = 0; i < e.fields.length; i++) {
                filter.push(new ej.Predicate(e.fields[i], e.operator, e.key, e.ignoreCase));
            }
            this.pvt.searches = filter;
        },
        onSearch: function (e) {
            this.pvt.searches = ej.Predicate.or(this.pvt.searches);
            return "";
        },
        onEachSort: function (e) {
            var res = [];
            if (e.name instanceof Array) {
                for (var i = 0; i < e.name.length; i++)
                    res.push(this._p(e.name[i]));
            } else {
                res.push(this._p(e.name) + (e.direction === "descending" ? " desc" : ""));
            }
            return res.join(",");
        },
        onSortBy: function (e) {
            return e.reverse().join(",");
        },
        onGroup: function (e) {
            this.pvt.groups = e;
            return "";
        },
        onSelect: function (e) {
            for (var i = 0; i < e.length; i++)
                e[i] = this._p(e[i]);

            return e.join(',');
        },
        onAggregates: function(e){
            this.pvt.aggregates = e;
            return "";
        },
        onCount: function (e) {
            return e === true ? "allpages" : "";
        },
        beforeSend: function (dm, request, settings) {
            if (settings.url.endsWith(this.options.batch) && settings.type.toLowerCase() === "post") {
                request.setRequestHeader("Accept", oData.multipartAccept);
                request.setRequestHeader("DataServiceVersion", "2.0");
                request.overrideMimeType("text/plain; charset=x-user-defined");
            }

            if (!dm.dataSource.crossDomain) {
                request.setRequestHeader("DataServiceVersion", "2.0");
                request.setRequestHeader("MaxDataServiceVersion", "2.0");
            }
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            if (!ej.isNullOrUndefined(data.d)) {
                var dataCopy = (query && query._requiresCount) ? data.d.results : data.d;
                if (!ej.isNullOrUndefined(dataCopy))
                    for (var i = 0; i < dataCopy.length; i++) {
                        !ej.isNullOrUndefined(dataCopy[i].__metadata) && delete dataCopy[i].__metadata;
                    }
            }
            var pvt = request && request.ejPvtData;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            if (request && this.options.batch && request.url.endsWith(this.options.batch) && request.type.toLowerCase() === "post") {
                var guid = xhr.getResponseHeader("Content-Type"), cIdx, jsonObj;
                guid = guid.substring(guid.indexOf("=batchresponse") + 1);
                data = data.split(guid);
                if (data.length < 2) return;

                data = data[1];
                var exVal = /(?:\bContent-Type.+boundary=)(changesetresponse.+)/i.exec(data);
                data.replace(exVal[0], "");

                var changeGuid = exVal[1];
                data = data.split(changeGuid);

                for (var i = data.length; i > -1; i--) {
                    if (!/\bContent-ID:/i.test(data[i]) || !/\bHTTP.+201/.test(data[i]))
                        continue;

                    cIdx = parseInt(/\bContent-ID: (\d+)/i.exec(data[i])[1]);

                    if (changes.added[cIdx]) {
                        jsonObj = p.parseJson(/^\{.+\}/m.exec(data[i])[0]);
                        $.extend(changes.added[cIdx], this.processResponse(jsonObj));
                    }
                }
                return changes;
            }
            var version = xhr && xhr.getResponseHeader("DataServiceVersion"), count = null, aggregateResult = {};
            version = (version && parseInt(version, 10)) || 2;

            if (query && query._requiresCount) {
                if (data.__count || data['odata.count']) count = data.__count || data['odata.count'];
                if (data.d) data = data.d;
                if (data.__count || data['odata.count']) count = data.__count || data['odata.count'];
            }

            if (version === 3 && data.value) data = data.value;
            if (data.d) data = data.d;
            if (version < 3 && data.results) data = data.results;

            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                aggregateResult = res;
            }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups;
                for (var i = 0; i < groups.length; i++) {
                    var format = getColFormat(groups[i], query.queries)
                    data = ej.group(data, groups[i], pvt.aggregates, format);
                }
            }
            return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
        },
        convertToQueryString: function (req, query, dm) {
            var res = [], tableName = req.table || "";
            delete req.table;

            if (dm.dataSource.requiresFormat)
                req["$format"] = "json";

            for (var prop in req)
                res.push(prop + "=" + req[prop]);

            res = res.join("&");

            if (dm.dataSource.url && dm.dataSource.url.indexOf("?") !== -1 && !tableName)
                return res;

            return res.length ? tableName + "?" + res : tableName || "";
        },
        insert: function (dm, data, tableName) {
            return {
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : ''),
                data: JSON.stringify(data)
            }
        },
        remove: function (dm, keyField, value, tableName) {
            return {
                type: "DELETE",
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : '') + '(' + value + ')'
            };
        },
        update: function (dm, keyField, value, tableName) {
            return {
                type: "PUT",
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : '') + '(' + value[keyField] + ')',
                data: JSON.stringify(value),
                accept: this.options.accept
            };
        },
        batchRequest: function (dm, changes, e) {
            var initialGuid = e.guid = ej.getGuid(oData.batchPre);
            var url = dm.dataSource.url.replace(/\/*$/, '/' + this.options.batch);
            var args = {
                url: e.url,
                key: e.key,
                cid: 1,
                cSet: ej.getGuid(oData.changeSet)
            };
            var req = "--" + initialGuid + "\n";

            req += "Content-Type: multipart/mixed; boundary=" + args.cSet.replace("--", "") + "\n";

            this.pvt.changeSet = 0;

            req += this.generateInsertRequest(changes.added, args);
            req += this.generateUpdateRequest(changes.changed, args);
            req += this.generateDeleteRequest(changes.deleted, args);

            req += args.cSet + "--\n";
            req += "--" + initialGuid + "--";

            return {
                type: "POST",
                url: url,
                contentType: "multipart/mixed; charset=UTF-8;boundary=" + initialGuid,
                data: req
            };
        },
        generateDeleteRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "DELETE ";
                req += e.url + "(" + arr[i][e.key] + ") HTTP/1.1\n";
                req += "If-Match : * \n"
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n";
            }

            return req + "\n";
        },
        generateInsertRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "POST ";
                req += e.url + " HTTP/1.1\n";
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n\n";

                req += JSON.stringify(arr[i]) + "\n";
            }

            return req;
        },
        generateUpdateRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "PUT ";
                req += e.url + "(" + arr[i][e.key] + ")" + " HTTP/1.1\n";
                req += "If-Match : * \n"
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n\n";

                req += JSON.stringify(arr[i]) + "\n\n";
            }

            return req;
        },
        _p: function (prop) {
            return prop.replace(/\./g, "/");
        }
    });
    ej.ODataV4Adaptor = new ej.ODataAdaptor().extend({
        options: {
            requestType: "get",
            accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
            multipartAccept: "multipart/mixed",
            sortBy: "$orderby",
            select: "$select",
            skip: "$skip",
            take: "$top",
            count: "$count",
            search: "$search",
            where: "$filter",
            expand: "$expand",
            batch: "$batch",
            changeSet: "--changeset_",
            batchPre: "batch_",
            contentId: "Content-Id: ",
            batchContent: "Content-Type: multipart/mixed; boundary=",
            changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
            batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
        },
        onCount: function (e) {
            return e === true ? "true" : "";
        },
        onPredicate: function (pred, query, requiresCast) {
            var returnValue = "",
                val = pred.value,
                isDate = val instanceof Date;               
            ej.data.odUniOperator["contains"] = "contains";
            returnValue = ej.ODataAdaptor.prototype.onPredicate.call(this, pred, query, requiresCast);
            ej.data.odUniOperator["contains"] = "substringof";
                if (isDate)
                    returnValue = returnValue.replace(/datetime'(.*)'$/, "$1");

            return returnValue;
        },
        onEachSearch: function (e) {
			 var search = this.pvt.search || [];
			 search.push(e.key);
			 this.pvt.search = search;
		},
		onSearch: function (e) {
			 return this.pvt.search.join(" OR ");
		},
        beforeSend: function (dm, request, settings) {
 
        },
        processQuery: function (ds, query) {
            var digitsWithSlashesExp = /\/[\d*\/]*/g;
            var poppedExpand = "";
            for (var i = query._expands.length - 1; i > 0; i--) {
                if (poppedExpand.indexOf(query._expands[i]) >= 0) { // If current expand is child of previous
                    query._expands.pop(); // Just remove it because its in the expand already
                }
                else {
                    if (digitsWithSlashesExp.test(query._expands[i])) { //If expanded to subentities
                        poppedExpand = query._expands.pop();
                        var r = poppedExpand.replace(digitsWithSlashesExp, "($expand="); //Rewrite into odata v4 expand
                        for (var j = 0; j < poppedExpand.split(digitsWithSlashesExp).length - 1; j++) {
                            r = r + ")"; // Add closing brackets
                        }
                        query._expands.unshift(r); // Add to the front of the array
                        i++;
                    }
                }
            }
            return ej.ODataAdaptor.prototype.processQuery.apply(this, [ds, query]);
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            var pvt = request && request.ejPvtData;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            if (request && this.options.batch && request.url.endsWith(this.options.batch) && request.type.toLowerCase() === "post") {
                var guid = xhr.getResponseHeader("Content-Type"), cIdx, jsonObj;
                guid = guid.substring(guid.indexOf("=batchresponse") + 1);
                data = data.split(guid);
                if (data.length < 2) return;

                data = data[1];
                var exVal = /(?:\bContent-Type.+boundary=)(changesetresponse.+)/i.exec(data);
                data.replace(exVal[0], "");

                var changeGuid = exVal[1];
                data = data.split(changeGuid);

                for (var i = data.length; i > -1; i--) {
                   if (!/\bContent-ID:/i.test(data[i]) || !/\bHTTP.+201/.test(data[i]))
                        continue;

                    cIdx = parseInt(/\bContent-ID: (\d+)/i.exec(data[i])[1]);

                    if (changes.added[cIdx]) {
                        jsonObj = p.parseJson(/^\{.+\}/m.exec(data[i])[0]);
                        $.extend(changes.added[cIdx], this.processResponse(jsonObj));
                    }
                }
                return changes;
           }
            var count = null, aggregateResult = {};
            if (query && query._requiresCount)
                if ('@odata.count' in data) count = data['@odata.count'];

            data = ej.isNullOrUndefined(data.value) ? data : data.value;
           if (pvt && pvt.aggregates && pvt.aggregates.length) {
               var agg = pvt.aggregates, args = {}, fn, res = {};
               for (var i = 0; i < agg.length; i++) {
                   fn = ej.aggregates[agg[i].type];
                   if (fn)
                       res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
               }
               aggregateResult = res;
           }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups;
                for (var i = 0; i < groups.length; i++) {
                    var format = getColFormat(groups[i], query.queries);
                    data = ej.group(data, groups[i], pvt.aggregates, format);
                }
            }
            return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
        },
    });
    ej.JsonAdaptor = new ej.Adaptor().extend({
        processQuery: function (ds, query) {
            var result = ds.dataSource.json.slice(0), count = result.length, cntFlg = true, ret, key, agg = {};

            for (var i = 0; i < query.queries.length; i++) {
                key = query.queries[i];
                ret = this[key.fn].call(this, result, key.e, query);
                if (key.fn == "onAggregates")
                    agg[key.e.field + " - " + key.e.type] = ret;
                else
                result = ret !== undefined ? ret : result;

                if (key.fn === "onPage" || key.fn === "onSkip" || key.fn === "onTake" || key.fn === "onRange") cntFlg = false;

                if (cntFlg) count = result.length;
            }

            if (query._requiresCount) {
                result = {
                    result: result,
                    count: count,
                    aggregates: agg
                };
            }

            return result;
        },
        batchRequest: function (dm, changes, e) {
            var i;
            for (i = 0; i < changes.added.length; i++)
                this.insert(dm, changes.added[i]);
            for (i = 0; i < changes.changed.length; i++)
                this.update(dm, e.key, changes.changed[i]);
            for (i = 0; i < changes.deleted.length; i++)
                this.remove(dm, e.key, changes.deleted[i]);
            return changes;
        },
        onWhere: function (ds, e) {
            if (!ds) return ds;

            return ds.filter(function (obj) {
                return e.validate(obj);
            });
        },
        onAggregates: function(ds, e){
            var fn = ej.aggregates[e.type];
            if (!ds || !fn || ds.length == 0) return null;
            return fn(ds, e.field);
        },
        onSearch: function (ds, e) {
            if (!ds || !ds.length) return ds;

            if (e.fieldNames.length === 0) {
                ej.pvt.getFieldList(ds[0], e.fieldNames);
            }

            return ds.filter(function (obj) {
                for (var j = 0; j < e.fieldNames.length; j++) {
                    if (e.comparer.call(obj, ej.pvt.getObject(e.fieldNames[j], obj), e.searchKey, e.ignoreCase))
                        return true;
                }
                return false;
            });
        },
        onSortBy: function (ds, e, query) {
            if (!ds) return ds;
            var fnCompare, field = getValue(e.fieldName, query);
            if (!field)
                return ds.sort(e.comparer);

            if (field instanceof Array) {
                field = field.slice(0);

                for (var i = field.length - 1; i >= 0; i--) {
                    if (!field[i]) continue;

                    fnCompare = e.comparer;

                    if (field[i].endsWith(" desc")) {
                        fnCompare = ej.pvt.fnSort(ej.sortOrder.Descending);
                        field[i] = field[i].replace(" desc", "");
                    }

                    ds = stableSort(ds, field[i], fnCompare, []);
                }
                return ds;
            }
            return stableSort(ds, field, e.comparer, query ? query.queries : []);
        },
        onGroup: function (ds, e, query) {
            if (!ds) return ds;
            var aggQuery = filterQueries(query.queries, "onAggregates"), agg = [];
            if (aggQuery.length) {
                var tmp;
                for (var i = 0; i < aggQuery.length; i++) {
                    tmp = aggQuery[i].e;
                    agg.push({ type: tmp.type, field: getValue(tmp.field, query) });
                }
            }
            var format = getColFormat(e.fieldName, query.queries);
            return ej.group(ds, getValue(e.fieldName, query), agg, format);
        },
        onPage: function (ds, e, query) {
            var size = getValue(e.pageSize, query),
                start = (getValue(e.pageIndex, query) - 1) * size, end = start + size;

            if (!ds) return ds;

            return ds.slice(start, end);
        },
        onRange: function (ds, e) {
            if (!ds) return ds;
            return ds.slice(getValue(e.start), getValue(e.end));
        },
        onTake: function (ds, e) {
            if (!ds) return ds;

            return ds.slice(0, getValue(e.nos));
        },
        onSkip: function (ds, e) {
            if (!ds) return ds;
            return ds.slice(getValue(e.nos));
        },
        onSelect: function (ds, e) {
            if (!ds) return ds;
            return ej.select(ds, getValue(e.fieldNames));
        },
        insert: function (dm, data) {
            return dm.dataSource.json.push(data);
        },
        remove: function (dm, keyField, value, tableName) {
            var ds = dm.dataSource.json, i;
            if (typeof value === "object")
                value = ej.getObject(keyField, value);
            for (i = 0; i < ds.length; i++) {
                if (ej.getObject(keyField, ds[i]) === value) break;
            }

            return i !== ds.length ? ds.splice(i, 1) : null;
        },
        update: function (dm, keyField, value, tableName) {
            var ds = dm.dataSource.json, i, key = ej.getObject(keyField, value);

            for (i = 0; i < ds.length; i++) {
                if (ej.getObject(keyField, ds[i]) === key) break;
            }

            return i < ds.length ? $.extend(ds[i], value) : null;
        }
    });
    ej.ForeignKeyAdaptor = function (data, type) {
        var foreignObj = new ej[type || "JsonAdaptor"]().extend({
            init: function () {
                this.foreignData = [];
                this.key = [];
                this.adaptorType = type;
                this.value = [];
                this.fValue = [];
                this.keyField = [];
                var dataObj = data;
                for (var i = 0; i < dataObj.length; i++) {
                    this.foreignData[i] = dataObj[i].dataSource;
                    this.key[i] = dataObj[i].foreignKeyField;
                    this.fValue[i] = ej.isNullOrUndefined(dataObj[i].field)? dataObj[i].foreignKeyValue : dataObj[i].field + "_" + dataObj[i].foreignKeyValue;
                    this.value[i] = dataObj[i].foreignKeyValue;
                    this.keyField[i] = dataObj[i].field || dataObj[i].foreignKeyField;
                    this.initial = true;
                }
            },
            processQuery: function (ds, query) {
                var data = ds.dataSource.json;
                if (this.initial) {
                    for (var i = 0; i < data.length; i++) {
                        var proxy = this;
                        for (var j = 0; j < this.foreignData.length; j++) {
                            this.foreignData[j].filter(function (col) { //filtering the foreignKey dataSource
                                if (ej.getObject(proxy.key[j], col) == ej.getObject(proxy.keyField[j], data[i]))
                                    data[i][proxy.fValue[j]] = ej.getObject(proxy.value[j], col);
                            });
                        }
                    }
                    this.initial = false;
                }
                return this.base.processQuery.apply(this, [ds, query]);
            },
            setValue: function (value) {
                for (var i = 0; i < this.foreignData.length; i++) {
                    var proxy = this;
                    var keyValue = value[this.fValue[i]];
                    if (typeof keyValue == "string" && !isNaN(keyValue))
                        keyValue = ej.parseFloat(keyValue);
                    var data = $.grep(proxy.foreignData[i], function (e) {
                        return e[proxy.value[i]] == keyValue;
                    })[0];
                    if (ej.isNullOrUndefined(data)) {
                        data = $.grep(proxy.foreignData[i], function (e) {
                            return e[proxy.key[i]] == keyValue;
                        })[0];
                        if (ej.getObject(this.value[i], data) != undefined)
                            ej.createObject(proxy.value[i], ej.getObject(this.value[i], data), value);
                    }
                    if (ej.getObject(this.value[i], data) != undefined)
                        ej.createObject(this.keyField[i], ej.getObject(this.key[i], data), value);
                }
            },
            insert: function (dm, data, tableName) {
                this.setValue(data);
                return {
                    url: dm.dataSource.insertUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                    data: JSON.stringify({
                        value: data,
                        table: tableName,
                        action: "insert"
                    })
                };
            },
            update: function (dm, keyField, value, tableName) {
                this.setValue(value);
                ej.JsonAdaptor.prototype.update(dm, keyField, value, tableName);
                return {
                    type: "POST",
                    url: dm.dataSource.updateUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                    data: JSON.stringify({
                        value: value,
                        action: "update",
                        keyColumn: keyField,
                        key: value[keyField],
                        table: tableName
                    })
                };
            }
        });
        $.extend(this, new foreignObj());
        return this;
    }
    ej.remoteSaveAdaptor = new ej.JsonAdaptor().extend({
        beforeSend: ej.UrlAdaptor.prototype.beforeSend,
        insert: ej.UrlAdaptor.prototype.insert,
        update: ej.UrlAdaptor.prototype.update,
        remove: ej.UrlAdaptor.prototype.remove,
        addParams: ej.UrlAdaptor.prototype.addParams,
        batchRequest: function (dm, changes, e, query) {
            var i;
            for (i = 0; i < changes.added.length; i++)
                ej.JsonAdaptor.prototype.insert(dm, changes.added[i]);
            for (i = 0; i < changes.changed.length; i++)
                ej.JsonAdaptor.prototype.update(dm, e.key, changes.changed[i]);
            for (i = 0; i < changes.deleted.length; i++)
                ej.JsonAdaptor.prototype.remove(dm, e.key, changes.deleted[i]);
			var res = {
                changed: changes.changed,
                added: changes.added,
                deleted: changes.deleted,
                action: "batch",
                table: e.url,
                key: e.key
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });
            return {
                type: "POST",
                url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(res)
            };
        }
    });
    ej.WebApiAdaptor = new ej.ODataAdaptor().extend({
        insert: function (dm, data, tableName) {
            return {
                type: "POST",
                url: dm.dataSource.url,
                data: JSON.stringify(data)
            };
        },
        remove: function (dm, keyField, value, tableName) {
            return {
                type: "DELETE",
                url: dm.dataSource.url + "/" + value,
                data: JSON.stringify(value)
            };
        },
        update: function (dm, keyField, value, tableName) {
            return {
                type: "PUT",
                url: dm.dataSource.url,
                data: JSON.stringify(value)
            };
        },
        processResponse: function (data, ds, query, xhr, request, changes) {

            var pvt = request && request.ejPvtData;
            if (request && request.type.toLowerCase() != "post") {
                var version = xhr && xhr.getResponseHeader("DataServiceVersion"), count = null, aggregateResult = {};
                version = (version && parseInt(version, 10)) || 2;

                if (query && query._requiresCount) {
                     if (!isNull(data.Count)) count = data.Count;
                }

                if (version < 3 && data.Items) data = data.Items;

                if (pvt && pvt.aggregates && pvt.aggregates.length) {
                    var agg = pvt.aggregates, args = {}, fn, res = {};
                    for (var i = 0; i < agg.length; i++) {
                        fn = ej.aggregates[agg[i].type];
                        if (fn)
                            res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                    }
                    aggregateResult = res;
                }
                if (pvt && pvt.groups && pvt.groups.length) {
                    var groups = pvt.groups;
                    for (var i = 0; i < groups.length; i++) {
                        var format = getColFormat(groups[i], query.queries);
                        data = ej.group(data, groups[i], pvt.aggregates, format);
                    }
                }
                return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
            }
        }
    });
    var getValue = function (value, inst) {
        if (typeof value === "function")
            return value.call(inst || {});
        return value;
    }

    ej.TableModel = function (name, jsonArray, dataManager, modelComputed) {
        if (!instance(this, ej.TableModel))
            return new ej.TableModel(jsonArray);

        if (!instance(jsonArray, Array))
            throwError("ej.TableModel - Json Array is required");

        var rows = [], model, dirtyFn = $proxy(setDirty, this);

        for (var i = 0; i < jsonArray.length; i++) {
            model = new ej.Model(jsonArray[i], this);
            model.state = "unchanged";
            model.on("stateChange", dirtyFn);
            if (modelComputed)
                model.computes(modelComputed);
            rows.push(model);
        }

        this.name = name || "table1";

        this.rows = ej.NotifierArray(rows);
        this._deleted = [];

        this._events = $({});

        this.dataManager = dataManager;

        this._isDirty = false;

        return this;
    };

    ej.TableModel.prototype = {
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },

        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },

        setDataManager: function (dataManager) {
            this.dataManagar = dataManager;
        },

        saveChanges: function () {
            if (!this.dataManager || !instance(this.dataManager, ej.DataManager))
                throwError("ej.TableModel - saveChanges : Set the dataManager using setDataManager function");

            if (!this.isDirty())
                return;

            var promise = this.dataManager.saveChanges(this.getChanges(), this.key, this.name);

            promise.done($proxy(function (changes) {
                var rows = this.toArray();
                for (var i = 0; i < rows.length; i++) {
                    if (rows.state === "added") {
                        rows.set(this.key, changes.added.filter(function (e) {
                            return e[this.key] === rows.get(this.key);
                        })[0][this.key]);
                    }
                    rows[i].markCommit();
                }

                this._events.triggerHandler({ type: "save", table: this });

            }, this));

            promise.fail($proxy(function (e) {
                this.rejectChanges();
                this._events.triggerHandler({ type: "reject", table: this, error: e });
            }, this));

            this._isDirty = false;
        },

        rejectChanges: function () {
            var rows = this.toArray();
            for (var i = 0; i < rows.length; i++)
                rows[i].revert(true);

            this._isDirty = false;
            this._events.triggerHandler({ type: "reject", table: this });
        },

        insert: function (json) {
            var model = new ej.Model(json);
            model._isDirty = this._isDirty = true;

            this.rows.push(model);

            this._events.triggerHandler({ type: "insert", model: model, table: this });
        },

        update: function (value) {
            if (!this.key)
                throwError("TableModel - update : Primary key should be assigned to TableModel.key");

            var row = value, model, key = this.key, keyValue = row[key];

            model = this.rows.array.filter(function (obj) {
                return obj.get(key) === keyValue;
            });

            model = model[0];

            for (var col in row) {
                model.set(col, row[col]);
            }

            this._isDirty = true;

            this._events.triggerHandler({ type: "update", model: model, table: this });
        },

        remove: function (key) {
            if (!this.key)
                throwError("TableModel - update : Primary key should be assigned to TableModel.key");

            var field = this.key;

            var index = -1, model;

            if (key && typeof key === "object") {
                key = key[field] !== undefined ? key[field] : key.get(field);
            }

            for (var i = 0; i < this.rows.length() ; i++) {
                if (this.rows.array[i].get(field) === key) {
                    index = i;
                    break;
                }
            }

            if (index > -1) {
                model = this.rows.removeAt(index);
                model.markDelete();

                this._deleted.push({ model: model, position: index });

                this._isDirty = true;
                this._events.triggerHandler({ type: "remove", model: model, table: this });
            }
        },

        isDirty: function () {
            return this._isDirty;
        },

        getChanges: function () {

            var changes = {
                added: [],
                changed: []
            };
            var rows = this.toArray();
            for (var i = 0; i < rows.length; i++) {
                if (changes[rows[i].state])
                    changes[rows[i].state].push(rows[i].json);
            }

            changes.deleted = ej.select(this._deleted, ["model"]);

            return changes;
        },

        toArray: function () {
            return this.rows.toArray();
        },

        setDirty: function (dirty, model) {
            if (this._isDirty === !!dirty) return;

            this._isDirty = !!dirty;

            this._events.triggerHandler({ type: "dirty", table: this, model: model });
        },
        get: function (index) {
            return this.rows.array[index];
        },
        length: function () {
            return this.rows.array.length;
        },

        bindTo: function (element) {
            var marker = tDiv, template = $(element.html()), rows = this.toArray(), cur;
            if ($.inArray(element.prop("tagName").toLowerCase(), ["table", "tbody"]))
                marker = tTR;

            marker.insertBefore(element);
            element.detach().empty();

            for (var i = 0; i < rows.length; i++) {
                cur = template.clone();
                rows[i].bindTo(cur);
                element.append(cur);
            }

            element.insertAfter(marker);
            marker.remove();
        }
    };

    var tDiv = doc ? $(document.createElement("div")) : {},
        tTR = doc ? $(document.createElement("tr")) : {};

    ej.Model = function (json, table, name) {
        if (typeof table === "string") {
            name = table;
            table = null;
        }
        this.$id = getUid("m");

        this.json = json;
        this.table = table instanceof ej.TableModel ? table : null;
        this.name = name || (this.table && this.table.name);
        this.dataManager = (table instanceof ej.DataManager) ? table : table.dataManagar;
        this.actual = {};
        this._events = $({});
        this.isDirty = false;
        this.state = "added";
        this._props = [];
        this._computeEls = {};
        this._fields = {};
        this._attrEls = {};
        this._updates = {};
        this.computed = {};
    };

    ej.Model.prototype = {
        computes: function (value) {
            $.extend(this.computed, value);
        },
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },
        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },
        set: function (field, value) {
            var obj = this.json, actual = field, prev;
            field = field.split('.');

            for (var i = 0; i < field.length - 1; i++) {
                field = field[0];
                obj = obj[field[0]];
            }

            this.isDirty = true;
            this.changeState("changed", { from: "set" });

            prev = obj[field];

            if (this.actual[field] === undefined && !(field in this.actual))
                this.actual[field] = value; // Complex property ?

            obj[field] = value;

            this._updateValues(field, value);
            this._events.triggerHandler({ type: actual, current: value, previous: prev, model: this });
        },
        get: function (field) {
            return ej.pvt.getObject(field, this.json);
        },
        revert: function (suspendEvent) {
            for (var prop in this.actual) {
                this.json[prop] = this.actual[prop];
            }

            this.isDirty = false;

            if (suspendEvent)
                this.state = "unchanged";
            else
                this.changeState("unchanged", { from: "revert" });
        },
        save: function (dm, key) {
            dm = dm || this.dataManagar;
            key = key || dm.dataSource.key;
            if (!dm) throwError("ej.Model - DataManager is required to commit the changes");
            if (this.state === "added") {
                return dm.insert(this.json, this.name).done(ej.proxy(function (e) {
                    $.extend(this.json, e.record);
                }, this));
            }
            else if (this.state === "changed") {
                return dm.update(key, this.json, this.name);
            }
            else if (this.state === "deleted") {
                return dm.remove(key, this.json, this.name);
            }
        },
        markCommit: function () {
            this.isDirty = false;
            this.changeState("unchanged", { from: "commit" });
        },
        markDelete: function () {
            this.changeState("deleted", { from: "delete" });
        },
        changeState: function (state, args) {
            if (this.state === state) return;

            if (this.state === "added") {
                if (state === "deleted")
                    state = "unchanged";
                else return;
            }

            var prev = state;
            args = args || {};

            this.state = state;
            this._events.triggerHandler($.extend({ type: "stateChange", current: state, previous: prev, model: this }, args));
        },
        properties: function () {
            if (this._props.length)
                return this._props;

            for (var pr in this.json) {
                this._props.push(pr);
                this._updates[pr] = { read: [], input: [] };
            }

            return this._props;
        },
        bindTo: function (element) {
            var el = $(element), ctl, field,
                elements = el.find("[ej-observe], [ej-computed], [ej-prop]"), len = elements.length;

            el.data("ejModel", this);
            var unbindData = { fields: [], props: [], computes: [] };
            for (var i = 0; i < len; i++) {
                ctl = elements.eq(i);

                field = ctl.attr("ej-prop");
                if (field) {
                    this._processAttrib(field, ctl, unbindData);
                }
                field = ctl.attr("ej-observe");
                if (field && this._props.indexOf(field) !== -1) {
                    this._processField(ctl, field, unbindData);
                    continue;
                }

                field = ctl.attr("ej-computed");
                if (field) {
                    this._processComputed(field, ctl, unbindData);
                    continue;
                }
            }
            el.data("ejModelBinding" + this.$id, unbindData);
        },
        unbind: function (element) {
            var tmp, data = {
                props: this._attrEls,
                computes: this._computeEls
            }, isCustom = false;

            if (element) {
                data = $(element).removeData("ejModel").data("ejModelBinding" + this.$id) || data;
                isCustom = true;
            }

            for (var p in this.computed) {
                tmp = data.computes[p], p = this.computed[p];
                if (tmp && p.deps) {
                    this.off(p.deps.join(' '), tmp.handle);
                    if (isCustom)
                        delete this._computeEls[p];
                }
            }
            if (!isCustom)
                this._computeEls = {};

            for (var p in data.props) {
                tmp = data.props[p];
                if (tmp) {
                    this.off(tmp.deps.join(' '), tmp.handle);
                    delete data.props[p];
                    if (isCustom)
                        delete this._attrEls[p];
                }
            }
            if (!isCustom)
                this._attrEls = {};

            if (data.fields && data.fields.length) {
                var len = data.fields.length, ctl, idx, ty;
                for (var i = 0; i < len; i++) {
                    ctl = data.fields[i];
                    $(ctl).off("change", null, this._changeHandler);

                    ty = this.formElements.indexOf(ctl.tagName.toLowerCase()) !== -1 ? "input" : "read";
                    idx = this._updates[ty].indexOf(ctl);
                    if (idx !== -1)
                        this._updates[ty].splice(idx, 1);
                }
            }
        },
        _processComputed: function (value, element, data) {
            if (!value) return;

            var val, deps, safeVal = safeStr(value),
            type = this.formElements.indexOf(element[0].tagName.toLowerCase()) !== -1 ? "val" : "html";

            if (!this.computed[value] || !this.computed[safeVal]) {
                this.computed[safeVal] = {
                    value: new Function("var e = this; return " + value),
                    deps: this._generateDeps(value)
                }
                value = safeVal;
            }

            val = this.computed[value];
            if (!val.get) {
                val.get = function () {
                    val.value.call(this.json);
                }
            }

            deps = val.deps;
            val = val.value;

            this._updateDeps(deps);
            this._updateElement(element, type, val);

            val = { el: element, handle: $proxy(this._computeHandle, this, { value: value, type: type }) };
            this._computeEls[value] = val;
            data.computes[value] = val;

            this.on(deps.join(' '), val.handle);
        },
        _computeHandle: function (e) {
            var el = this._computeEls[e.value];
            if (el && this.computed[e.value])
                this._updateElement(el.el, e.type, this.computed[e.value].value);
        },
        _updateElement: function (el, type, val) {
            el[type](val.call($.extend({}, this.json, this.computed)));
        },
        _updateDeps: function (deps) {
            for (var i = 0; i < deps.length; i++) {
                if (!(deps[i] in this.json) && deps[i] in this.computed)
                    ej.merge(deps, this.computed[deps[i]].deps);
            }
        },
        _generateDeps: function (value) {
            var splits = value.replace(/(^e\.)|( e\.)/g, '#%^*##ej.#').split("#%^*#"),
                field, deps = [];

            for (var i = 0; i < splits.length; i++) {
                if (splits[i].startsWith("#ej.#")) {
                    field = splits[i].replace("#ej.#", "").split(' ')[0];
                    if (field && this._props.indexOf(field) !== -1)
                        deps.push(field);
                }
            }

            return deps;
        },
        _processAttrib: function (value, el, data) {
            var prop, val, res = {};
            value = value.replace(/^ +| +$/g, "").split(";");
            for (var i = 0; i < value.length; i++) {
                value[i] = value[i].split(":");
                if (value[i].length < 2) continue;

                prop = value[i][0].replace(/^ +| +$/g, "").replace(/^'|^"|'$|"$/g, "");
                res[prop] = value[i][1].replace(/^ +| +$/g, "").replace(/^'|^"|'$|"$/g, "");
            }
            value = res;
            var deps = [];
            for (prop in value)
                deps.push(value[prop]);

            this._updateDeps(deps);
            this._updateProps(el, value);

            res = getUid("emak");
            val = { el: el, handle: $proxy(this._attrHandle, this, res), value: value, deps: deps };
            el.prop("ejmodelattrkey", res);

            data.props[res] = val;
            this._attrEls[res] = val;

            this.on(deps.join(' '), val.handle);
        },
        _attrHandle: function (res) {
            var el = this._attrEls[res];
            if (el)
                this._updateProps(el.el, el.value);
        },
        _updateProps: function (element, value) {
            var json = this.json, t, c = this.computed;
            for (var prop in value) {
                t = value[prop];
                if (t in json)
                    t = json[t];
                else if (t in c) {
                    t = c[t];
                    if (t) {
                        t = t.value.call($.extend({}, this.json, c));
                    }
                }

                if (!isNull(t)) {
                    element.prop(prop, t);
                }
            }
        },
        _updateValues: function (prop, value) {
            var arr = this._updates[prop];

            if (!arr || (!arr.read && !arr.input)) return;

            this._ensureItems(arr.read, "html", value);
            this._ensureItems(arr.input, "val", value);
        },
        _ensureItems: function (a, type, value) {
            if (!a) return;

            for (var i = a.length - 1; i > -1; i--) {
                if (!a[i].offsetParent) {
                    a.splice(i, 1);
                    continue;
                }
                $(a[i])[type](value);
            }
        },
        _changeHandler: function (e) {
            e.data.self.set(e.data.prop, $(this).val());
        },
        _processField: function (ctl, field, data) {
            var e = { self: this, prop: field }, val = this.get(field);

            data.fields.push(ctl[0]);

            if (this.formElements.indexOf(ctl[0].tagName.toLowerCase()) === -1) {
                ctl.html(val);
                return this._updates[field].read.push(ctl[0]);
            }

            ctl.val(val)
                    .off("change", null, this._changeHandler)
                    .on("change", null, e, this._changeHandler);

            return this._updates[field].input.push(ctl[0]);
        },
        formElements: ["input", "select", "textarea"]
    };

    var safeReg = /[^\w]+/g;
    var safeStr = function (value) {
        return value.replace(safeReg, "_");
    };
    var setDirty = function (e) {
        this.setDirty(true, e.model);
    };

    ej.Predicate = function (field, operator, value, ignoreCase) {
        if (!(this instanceof ej.Predicate))
            return new ej.Predicate(field, operator, value, ignoreCase);

        if (typeof field === "string") {
            this.field = field;
            this.operator = operator;
            this.value = value;
            this.ignoreCase = ignoreCase;
            this.isComplex = false;

            this._comparer = ej.data.fnOperators.processOperator(this.operator);

        } else if (field instanceof ej.Predicate && value instanceof ej.Predicate || value instanceof Array) {
            this.isComplex = true;
            this.condition = operator.toLowerCase();
            this.predicates = [field];
            if (value instanceof Array)
                [].push.apply(this.predicates, value);
            else
                this.predicates.push(value);
        }
        return this;
    };

    ej.Predicate.and = function () {
        return pvtPredicate._combinePredicates([].slice.call(arguments, 0), "and");
    };

    ej.Predicate.or = function () {
        return pvtPredicate._combinePredicates([].slice.call(arguments, 0), "or");
    };

    ej.Predicate.fromJSON = function (json) {
        if (instance(json, Array)) {
            var res = [];
            for (var i = 0, len = json.length; i < len; i++)
                res.push(pvtPredicate._fromJSON(json[i]));
            return res;
        }

        return pvtPredicate._fromJSON(json);
    };

    // Private fn
    var pvtPredicate = {
        _combinePredicates: function (predicates, operator) {
            if (!predicates.length) return undefined;
            if (predicates.length === 1) {
                if (!instance(predicates[0], Array))
                    return predicates[0];
                predicates = predicates[0];
            }
            return new ej.Predicate(predicates[0], operator, predicates.slice(1));
        },

        _combine: function (pred, field, operator, value, condition, ignoreCase) {
            if (field instanceof ej.Predicate)
                return ej.Predicate[condition](pred, field);

            if (typeof field === "string")
                return ej.Predicate[condition](pred, new ej.Predicate(field, operator, value, ignoreCase));

            return throwError("Predicate - " + condition + " : invalid arguments");
        },

        _fromJSON: function (json) {

            if (!json || instance(json, ej.Predicate))
                return json;

            var preds = json.predicates || [], len = preds.length, predicates = [], result;

            for (var i = 0; i < len; i++)
                predicates.push(pvtPredicate._fromJSON(preds[i]));                     

            if(!json.isComplex)
                result = new ej.Predicate(json.field, json.operator, ej.parseJSON({ val: json.value }).val, json.ignoreCase);
            else
                result = new ej.Predicate(predicates[0], json.condition, predicates.slice(1));

            return result;
        }
    };

    ej.Predicate.prototype = {
        and: function (field, operator, value, ignoreCase) {
            return pvtPredicate._combine(this, field, operator, value, "and", ignoreCase);
        },
        or: function (field, operator, value, ignoreCase) {
            return pvtPredicate._combine(this, field, operator, value, "or", ignoreCase);
        },
        validate: function (record) {
            var p = this.predicates, isAnd, ret;

            if (!this.isComplex) {
                return this._comparer.call(this, ej.pvt.getObject(this.field, record), this.value, this.ignoreCase);
            }

            isAnd = this.condition === "and";

            for (var i = 0; i < p.length; i++) {
                ret = p[i].validate(record);
                if (isAnd) {
                    if (!ret) return false;
                } else {
                    if (ret) return true;
                }
            }

            return isAnd;
        },
        toJSON: function () {
            var predicates, p;
            if (this.isComplex) {
                predicates = [], p = this.predicates;
                for (var i = 0; i < p.length; i++)
                    predicates.push(p[i].toJSON());
            }
            return {
                isComplex: this.isComplex,
                field: this.field,
                operator: this.operator,
                value: this.value,
                ignoreCase: this.ignoreCase,
                condition: this.condition,
                predicates: predicates
            }
        }
    };

    ej.dataUtil = {
        swap: function (array, x, y) {
            if (x == y) return;

            var tmp = array[x];
            array[x] = array[y];
            array[y] = tmp;
        },

        mergeSort: function (jsonArray, fieldName, comparer) {
            if (!comparer || typeof comparer === "string")
                comparer = ej.pvt.fnSort(comparer, true);

            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.mergeSort(jsonArray, fieldName, comparer);
        },

        max: function (jsonArray, fieldName, comparer) {
            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.getItemFromComparer(jsonArray, fieldName, comparer || ej.pvt.fnDescending);
        },

        min: function (jsonArray, fieldName, comparer) {
            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.getItemFromComparer(jsonArray, fieldName, comparer || ej.pvt.fnAscending);
        },

        distinct: function (json, fieldName, requiresCompleteRecord) {
            var result = [], val, tmp = {};
            for (var i = 0; i < json.length; i++) {
                val = getVal(json, fieldName, i);
                if (!(val in tmp)) {
                    result.push(!requiresCompleteRecord ? val : json[i]);
                    tmp[val] = 1;
                }
            }
            return result;
        },

        sum: function (json, fieldName) {
            var result = 0, val, castRequired = typeof getVal(json, fieldName, 0) !== "number";

            for (var i = 0; i < json.length; i++) {
                val = getVal(json, fieldName, i);
                if (!isNaN(val) && val !== null) {
                    if (castRequired)
                       val = +val;
                   result += val;
                }
            }
            return result;
        },

        avg: function (json, fieldName) {
            return ej.sum(json, fieldName) / json.length;
        },

        select: function (jsonArray, fields) {
            var newData = [];

            for (var i = 0; i < jsonArray.length; i++) {
                newData.push(ej.pvt.extractFields(jsonArray[i], fields));
            }

            return newData;
        },

        group: function (jsonArray, field, agg, format,/* internal */ level,groupDs) {
            level = level || 1;

            if (jsonArray.GROUPGUID == ej.pvt.consts.GROUPGUID) {
                for (var j = 0; j < jsonArray.length; j++) {
                    if(!ej.isNullOrUndefined(groupDs)){
                        var indx = -1;
                        var temp = $.grep(groupDs,function(e){return e.key==jsonArray[j].key});
                        indx = groupDs.indexOf(temp[0]);
                        jsonArray[j].items = ej.group(jsonArray[j].items, field, agg, format, jsonArray.level + 1, groupDs[indx].items);
                        jsonArray[j].count = groupDs[indx].count;
                    }
                    else{
                        jsonArray[j].items = ej.group(jsonArray[j].items, field, agg, format, jsonArray.level + 1);
                        jsonArray[j].count = jsonArray[j].items.length;
                    }  
                }

                jsonArray.childLevels += 1;
                return jsonArray;
            }

            var grouped = {}, groupedArray = [];

            groupedArray.GROUPGUID = ej.pvt.consts.GROUPGUID;
            groupedArray.level = level;
            groupedArray.childLevels = 0;
            groupedArray.records = jsonArray;

            for (var i = 0; i < jsonArray.length; i++) {
                var val = getVal(jsonArray, field, i);
                if (!ej.isNullOrUndefined(format)) val = format(val, field);

                if (!grouped[val]) {
                    grouped[val] = {
                        key: val,
                        count: 0,
                        items: [],
                        aggregates: {},
                        field: field
                    };
                    groupedArray.push(grouped[val]);
					if(!ej.isNullOrUndefined(groupDs)) {
                        var tempObj = $.grep(groupDs,function(e){return e.key==grouped[val].key});
                       grouped[val].count = tempObj[0].count
                    }
                }

                grouped[val].count = !ej.isNullOrUndefined(groupDs) ? grouped[val].count :  grouped[val].count += 1;
                grouped[val].items.push(jsonArray[i]);
            }
            if (agg && agg.length) {

                for (var i = 0; i < groupedArray.length; i++) {
                    var res = {}, fn;
                    for (var j = 0; j < agg.length; j++) {

                        fn = ej.aggregates[agg[j].type];
                        if(!ej.isNullOrUndefined(groupDs)) {
                            var temp = $.grep(groupDs,function(e){return e.key==groupedArray[i].key});
                            if(fn)
                                res[agg[j].field + " - " + agg[j].type] = fn(temp[0].items, agg[j].field);
                        }
                        else{
                            if (fn)
                                res[agg[j].field + " - " + agg[j].type] = fn(groupedArray[i].items, agg[j].field);
                        }

                    }
                    groupedArray[i]["aggregates"] = res;
                }
            }
            return groupedArray;
        },

        parseTable: function (table, headerOption, headerRowIndex) {
            var tr = table.rows, headerRow, headerTds = [], data = [], i;

            if (!tr.length) return [];

            headerRowIndex = headerRowIndex || 0;

            switch ((headerOption || "").toLowerCase()) {
                case ej.headerOption.tHead:
                    headerRow = table.tHead.rows[headerRowIndex];
                    break;
                case ej.headerOption.row:
                default:
                    headerRow = table.rows[headerRowIndex];
                    break;
            }

            var hTd = headerRow.cells;

            for (i = 0; i < hTd.length; i++)
                headerTds.push($.trim(hTd[i].innerHTML));

            for (i = headerRowIndex + 1; i < tr.length; i++) {
                var json = {}, td = tr[i].cells;
                for (var j = 0; j < td.length; j++) {
                    var temp = td[j].innerHTML;
                    if (typeof temp == "string" && $.isNumeric(temp))
                       json[headerTds[j]] = Number(temp);
				    else
                       json[headerTds[j]] = temp;
                }
                data.push(json);
            }
            return data;
        }
    };

    ej.headerOption = {
        tHead: "thead",
        row: "row"
    };

    ej.aggregates = {
        sum: function (ds, field) {
            return ej.sum(ds, field);
        },
        average: function (ds, field) {
            return ej.avg(ds, field);
        },
        minimum: function (ds, field) {
            return ej.getObject(field, ej.min(ds, field));
        },
        maximum: function (ds, field) {
            return  ej.getObject(field, ej.max(ds, field));
        },
        truecount: function (ds, field){
            var predicate = ej.Predicate(field, "equal", true);
            return ej.DataManager(ds).executeLocal(ej.Query().where(predicate)).length;
        },
        falsecount: function (ds, field) {
            var predicate = ej.Predicate(field, "equal", false);
            return ej.DataManager(ds).executeLocal(ej.Query().where(predicate)).length;
        },
        count: function (ds, field) {
            return ds.length;
        }

    };
    ej.pvt = {
        filterQueries: filterQueries,
        mergeSort: function (jsonArray, fieldName, comparer) {
            if (jsonArray.length <= 1)
                return jsonArray;

            // else list size is > 1, so split the list into two sublists
            var middle = parseInt(jsonArray.length / 2, 10);

            var left = jsonArray.slice(0, middle),
                right = jsonArray.slice(middle);

            left = ej.pvt.mergeSort(left, fieldName, comparer);
            right = ej.pvt.mergeSort(right, fieldName, comparer);

            return ej.pvt.merge(left, right, fieldName, comparer);
        },

        getItemFromComparer: function (array, field, comparer) {
            var keyVal, current, key, i = 0,castRequired = typeof getVal(array, field, 0) == "string";
            if (array.length)
            while (ej.isNullOrUndefined(keyVal) && i < array.length) {
                keyVal = getVal(array, field, i);
                key = array[i++];
            }
            for (; i < array.length; i++) {
                current = getVal(array, field, i);
                if (ej.isNullOrUndefined(current))
                    continue;
                if (castRequired) {
                    keyVal = +keyVal;
                    current = +current;
                }
                if (comparer(keyVal, current) > 0) {
                    keyVal = current;
                    key = array[i];
                }
            }
            return key;
        },

        quickSelect: function (array, fieldName, left, right, k, comparer) {
            if (left == right)
                return array[left];

            var pivotNewIndex = ej.pvt.partition(array, fieldName, left, right, comparer);

            var pivotDist = pivotNewIndex - left + 1;

            if (pivotDist == k)
                return array[pivotNewIndex];

            else if (k < pivotDist)
                return ej.pvt.quickSelect(array, fieldName, left, pivotNewIndex - 1, k, comparer);
            else
                return ej.pvt.quickSelect(array, fieldName, pivotNewIndex + 1, right, k - pivotDist, comparer);
        },

        extractFields: function (obj, fields) {
            var newObj = {};

            if (fields.length == 1)
                return ej.pvt.getObject(fields[0], obj);

            for (var i = 0; i < fields.length; i++) {
                newObj[fields[i].replace('.', ej.pvt.consts.complexPropertyMerge)] = ej.pvt.getObject(fields[i], obj);
            }

            return newObj;
        },

        partition: function (array, field, left, right, comparer) {

            var pivotIndex = parseInt((left + right) / 2, 10),
                pivot = getVal(array, field, pivotIndex);

            ej.swap(array, pivotIndex, right);

            pivotIndex = left;

            for (var i = left; i < right; i++) {
                if (comparer(getVal(array, field, i), pivot)) {
                    ej.swap(array, i, pivotIndex);
                    pivotIndex++;
                }
            }

            ej.swap(array, pivotIndex, right);

            return pivotIndex;
        },

        fnSort: function (order) {
            order = order ? order.toLowerCase() : ej.sortOrder.Ascending;

            if (order == ej.sortOrder.Ascending)
                return ej.pvt.fnAscending;

            return ej.pvt.fnDescending;
        },

        fnGetComparer: function (field, fn) {
            return function (x, y) {
                return fn(ej.pvt.getObject(field, x), ej.pvt.getObject(field, y));
            }
        },

        fnAscending: function (x, y) {
            if (y === null || y === undefined)
                return -1;

            if (typeof x === "string")
                return x.localeCompare(y);

            if (x === null || x === undefined)
                return 1;

            return x - y;
        },

        fnDescending: function (x, y) {
            if (y === null || y === undefined)
                return 1;

            if (typeof x === "string")
                return x.localeCompare(y) * -1;

            if (x === null || x === undefined)
                return -1;

            return y - x;
        },

        merge: function (left, right, fieldName, comparer) {
            var result = [], current;

            while (left.length > 0 || right.length > 0) {
                if (left.length > 0 && right.length > 0) {
                    if (comparer)
                        current = comparer(getVal(left, fieldName, 0), getVal(right, fieldName, 0)) <= 0 ? left : right;
                    else
                        current = left[0][fieldName] < left[0][fieldName] ? left : right;
                } else {
                    current = left.length > 0 ? left : right;
                }

                result.push(current.shift());
            }

            return result;
        },

        getObject: function (nameSpace, from) {
            if (!from) return undefined;
            if (!nameSpace) return from;

            if (nameSpace.indexOf('.') === -1) return from[nameSpace];

            var value = from, splits = nameSpace.split('.');

            for (var i = 0; i < splits.length; i++) {

                if (value == null) break;

                value = value[splits[i]];
            }

            return value;
        },

        createObject: function (nameSpace, value, initIn) {
            var splits = nameSpace.split('.'), start = initIn || window, from = start, i;

            for (i = 0; i < splits.length; i++) {

                if (i + 1 == splits.length)
                    from[splits[i]] = value === undefined ? {} : value;
                else if (from[splits[i]] == null)
                    from[splits[i]] = {};

                from = from[splits[i]];
            }

            return start;
        },

        getFieldList: function (obj, fields, prefix) {
            if (prefix === undefined)
                prefix = "";

            if (fields === undefined || fields === null)
                return ej.pvt.getFieldList(obj, [], prefix);

            for (var prop in obj) {
                if (typeof obj[prop] === "object" && !(obj[prop] instanceof Array))
                    ej.pvt.getFieldList(obj[prop], fields, prefix + prop + ".");
                else
                    fields.push(prefix + prop);
            }

            return fields;
        }
    };

    ej.FilterOperators = {
        lessThan: "lessthan",
        greaterThan: "greaterthan",
        lessThanOrEqual: "lessthanorequal",
        greaterThanOrEqual: "greaterthanorequal",
        equal: "equal",
        contains: "contains",
        startsWith: "startswith",
        endsWith: "endswith",
        notEqual: "notequal"
    };

    ej.data = {};

    ej.data.operatorSymbols = {
        "<": "lessthan",
        ">": "greaterthan",
        "<=": "lessthanorequal",
        ">=": "greaterthanorequal",
        "==": "equal",
        "!=": "notequal",
        "*=": "contains",
        "$=": "endswith",
        "^=": "startswith"
    };

    ej.data.odBiOperator = {
        "<": " lt ",
        ">": " gt ",
        "<=": " le ",
        ">=": " ge ",
        "==": " eq ",
        "!=": " ne ",
        "lessthan": " lt ",
        "lessthanorequal": " le ",
        "greaterthan": " gt ",
        "greaterthanorequal": " ge ",
        "equal": " eq ",
        "notequal": " ne "
    };

    ej.data.odUniOperator = {
        "$=": "endswith",
        "^=": "startswith",
        "*=": "substringof",
        "endswith": "endswith",
        "startswith": "startswith",
        "contains": "substringof"
    };

    ej.data.fnOperators = {
        equal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) == toLowerCase(expected);

            return actual == expected;
        },
        notequal: function (actual, expected, ignoreCase) {
            return !ej.data.fnOperators.equal(actual, expected, ignoreCase);
        },
        lessthan: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) < toLowerCase(expected);

            return actual < expected;
        },
        greaterthan: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) > toLowerCase(expected);

            return actual > expected;
        },
        lessthanorequal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) <= toLowerCase(expected);

            return actual <= expected;
        },
        greaterthanorequal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) >= toLowerCase(expected);

            return actual >= expected;
        },
        contains: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return !isNull(actual) && !isNull(expected) && toLowerCase(actual).indexOf(toLowerCase(expected)) != -1;

            return !isNull(actual) && !isNull(expected) && actual.toString().indexOf(expected) != -1;
        },
        notnull: function (actual) {
            return actual !== null;
        },
        isnull: function (actual) {
            return actual === null;
        },
        startswith: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return actual && expected && toLowerCase(actual).startsWith(toLowerCase(expected));

            return actual && expected && actual.startsWith(expected);
        },
        endswith: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return actual && expected && toLowerCase(actual).endsWith(toLowerCase(expected));

            return actual && expected && actual.endsWith(expected);
        },

        processSymbols: function (operator) {
            var fnName = ej.data.operatorSymbols[operator];
            if (fnName) {
                var fn = ej.data.fnOperators[fnName];
                if (fn) return fn;
            }

            return throwError("Query - Process Operator : Invalid operator");
        },

        processOperator: function (operator) {
            var fn = ej.data.fnOperators[operator];
            if (fn) return fn;
            return ej.data.fnOperators.processSymbols(operator);
        }
    };

    ej.NotifierArray = function (array) {
        if (!instance(this, ej.NotifierArray))
            return new ej.NotifierArray(array);

        this.array = array;

        this._events = $({});
        this._isDirty = false;

        return this;
    };

    ej.NotifierArray.prototype = {
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },
        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },
        push: function (item) {
            var ret;

            if (instance(item, Array))
                ret = [].push.apply(this.array, item);
            else
                ret = this.array.push(item);

            this._raise("add", { item: item, index: this.length() - 1 });

            return ret;
        },
        pop: function () {
            var ret = this.array.pop();

            this._raise("remove", { item: ret, index: this.length() - 1 });

            return ret;
        },
        addAt: function (index, item) {
            this.array.splice(index, 0, item);

            this._raise("add", { item: item, index: index });

            return item;
        },
        removeAt: function (index) {
            var ret = this.array.splice(index, 1)[0];

            this._raise("remove", { item: ret, index: index });

            return ret;
        },
        remove: function (item) {
            var index = this.array.indexOf(item);

            if (index > -1) {
                this.array.splice(index, 1);
                this._raise("remove", { item: item, index: index });
            }

            return index;
        },
        length: function () {
            return this.array.length;
        },
        _raise: function (e, args) {
            this._events.triggerHandler($.extend({ type: e }, args));
            this._events.triggerHandler({ type: "all", name: e, args: args });
        },
        toArray: function () {
            return this.array;
        }
    };

    $.extend(ej, ej.dataUtil);

    // For IE8
    Array.prototype.forEach = Array.prototype.forEach || function (fn, scope) {
        for (var i = 0, len = this.length; i < len; ++i) {
            fn.call(scope, this[i], i, this);
        }
    };

    Array.prototype.indexOf = Array.prototype.indexOf || function (searchElement) {
        var len = this.length;

        if (len === 0) return -1;

        for (var i = 0; i < len; i++) {
            if (i in this && this[i] === searchElement)
                return i;
        }
        return -1;
    };

    Array.prototype.filter = Array.prototype.filter || function (fn) {
        if (typeof fn != "function")
            throw new TypeError();

        var res = [];
        var thisp = arguments[1] || this;
        for (var i = 0; i < this.length; i++) {
            var val = this[i]; // in case fun mutates this
            if (fn.call(thisp, val, i, this))
                res.push(val);
        }

        return res;
    };

    String.prototype.endsWith = String.prototype.endsWith || function (key) {
        return this.slice(-key.length) === key;
    };

    String.prototype.startsWith = String.prototype.startsWith || function (key) {
        return this.slice(0, key.length) === key;
    };

    if (!ej.support) ej.support = {};
    ej.support.stableSort = function () {
        var res = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16].sort(function () { return 0; });
		for(var i = 0; i < 17; i++){
		    if(i !== res[i]) return false;
		}
        return true;
    }();
    ej.support.cors = $.support.cors;

    if (!$.support.cors && window.XDomainRequest) {
        var httpRegEx = /^https?:\/\//i;
        var getOrPostRegEx = /^get|post$/i;
        var sameSchemeRegEx = new RegExp('^' + location.protocol, 'i');
        var xmlRegEx = /\/xml/i;

        // ajaxTransport exists in jQuery 1.5+
        $.ajaxTransport('text html xml json', function (options, userOptions, jqXHR) {
            // XDomainRequests must be: asynchronous, GET or POST methods, HTTP or HTTPS protocol, and same scheme as calling page
            if (options.crossDomain && options.async && getOrPostRegEx.test(options.type) && httpRegEx.test(userOptions.url) && sameSchemeRegEx.test(userOptions.url)) {
                var xdr = null;
                var userType = (userOptions.dataType || '').toLowerCase();
                return {
                    send: function (headers, complete) {
                        xdr = new XDomainRequest();
                        if (/^\d+$/.test(userOptions.timeout)) {
                            xdr.timeout = userOptions.timeout;
                        }
                        xdr.ontimeout = function () {
                            complete(500, 'timeout');
                        };
                        xdr.onload = function () {
                            var allResponseHeaders = 'Content-Length: ' + xdr.responseText.length + '\r\nContent-Type: ' + xdr.contentType;
                            var status = {
                                code: 200,
                                message: 'success'
                            };
                            var responses = {
                                text: xdr.responseText
                            };

                            try {
                                if (userType === 'json') {
                                    try {
                                        responses.json = JSON.parse(xdr.responseText);
                                    } catch (e) {
                                        status.code = 500;
                                        status.message = 'parseerror';
                                        //throw 'Invalid JSON: ' + xdr.responseText;
                                    }
                                } else if ((userType === 'xml') || ((userType !== 'text') && xmlRegEx.test(xdr.contentType))) {
                                    var doc = new ActiveXObject('Microsoft.XMLDOM');
                                    doc.async = false;
                                    try {
                                        doc.loadXML(xdr.responseText);
                                    } catch (e) {
                                        doc = undefined;
                                    }
                                    if (!doc || !doc.documentElement || doc.getElementsByTagName('parsererror').length) {
                                        status.code = 500;
                                        status.message = 'parseerror';
                                        throw 'Invalid XML: ' + xdr.responseText;
                                    }
                                    responses.xml = doc;
                                }
                            } catch (parseMessage) {
                                throw parseMessage;
                            } finally {
                                complete(status.code, status.message, responses, allResponseHeaders);
                            }
                        };
                        xdr.onerror = function () {
                            complete(500, 'error', {
                                text: xdr.responseText
                            });
                        };
						if(navigator.userAgent.indexOf("MSIE 9.0") != -1)
							xdr.onprogress = function() {};
                        xdr.open(options.type, options.url);
                        xdr.send(userOptions.data);
                        //xdr.send();
                    },
                    abort: function () {
                        if (xdr) {
                            xdr.abort();
                        }
                    }
                };
            }
        });
    }

    $.support.cors = true;

    ej.sortOrder = {
        Ascending: "ascending",
        Descending: "descending"
    };

    // privates
    ej.pvt.consts = {
        GROUPGUID: "{271bbba0-1ee7}",
        complexPropertyMerge: "_"
    };

    // private utils
    var nextTick = function (fn, context) {
        if (context) fn = $proxy(fn, context);
        (window.setImmediate || window.setTimeout)(fn, 0);
    };

    ej.support.enableLocalizedSort = false;

    var stableSort = function (ds, field, comparer, queries) {
        if (ej.support.stableSort) {
            if(!ej.support.enableLocalizedSort && typeof ej.pvt.getObject(field, ds[0] || {}) == "string" 
                && (comparer === ej.pvt.fnAscending || comparer === ej.pvt.fnDescending)
                && queries.filter(function(e){return e.fn === "onSortBy";}).length === 1)
                return fastSort(ds, field, comparer === ej.pvt.fnDescending);
            return ds.sort(ej.pvt.fnGetComparer(field, comparer));
        }
        return ej.mergeSort(ds, field, comparer);
    };
    var getColFormat = function (field, query) {
        var grpQuery = $.grep(query, function (args) { return args.fn == "onGroup" });
        for (var grp = 0; grp < grpQuery.length; grp++) {
            if (ej.getObject("fieldName", grpQuery[grp].e) == field) {
                return ej.getObject("fn", grpQuery[grp].e);
            }
        }
    };
    var fastSort = function(ds, field, isDesc){
        var old = Object.prototype.toString;
        Object.prototype.toString = (field.indexOf('.') === -1) ? function(){
            return this[field];
        }:function(){
            return ej.pvt.getObject(field, this);
        };
        ds = ds.sort();
        Object.prototype.toString = old;
        if(isDesc)
            ds.reverse();
    }

    var toLowerCase = function (val) {
        return val ? val.toLowerCase ? val.toLowerCase() : val.toString().toLowerCase() : (val === 0 || val === false) ? val.toString() : "";
    };

    var getVal = function (array, field, index) {
        return field ? ej.pvt.getObject(field, array[index]) : array[index];
    };

    var isHtmlElement = function (e) {
        return typeof HTMLElement === "object" ? e instanceof HTMLElement :
            e && e.nodeType === 1 && typeof e === "object" && typeof e.nodeName === "string";
    };

    var instance = function (obj, element) {
        return obj instanceof element;
    };

    var getTableModel = function (name, result, dm, computed) {
        return function (tName) {
            if (typeof tName === "object") {
                computed = tName;
                tName = null;
            }
            return new ej.TableModel(tName || name, result, dm, computed);
        };
    };

    var getKnockoutModel = function (result) {
        return function (computedObservables, ko) {
            ko = ko || window.ko;

            if (!ko) throwError("Knockout is undefined");

            var model, koModels = [], prop, ob;
            for (var i = 0; i < result.length; i++) {
                model = {};
                for (prop in result[i]) {
                    if (!prop.startsWith("_"))
                        model[prop] = ko.observable(result[i][prop]);
                }
                for (prop in computedObservables) {
                    ob = computedObservables[prop];

                    if ($.isPlainObject(ob)) {
                        if (!ob.owner) ob.owner = model;
                        ob = ko.computed(ob);
                    } else
                        ob = ko.computed(ob, model);

                    model[prop] = ob;
                }
                koModels.push(model);
            }

            return ko.observableArray(koModels);
        };
    };

    var uidIndex = 0;
    var getUid = function (prefix) {
        uidIndex += 1;
        return prefix + uidIndex;
    };

    ej.getGuid = function (prefix) {
        var hexs = '0123456789abcdef', rand;
        return (prefix || "") + '00000000-0000-4000-0000-000000000000'.replace(/0/g, function (val, i) {
            if ("crypto" in window && "getRandomValues" in crypto) {
                var arr = new Uint8Array(1)
                window.crypto.getRandomValues(arr);
                rand = arr[0] % 16|0
            }
            else rand = Math.random() * 16 | 0;
            return hexs[i === 19 ? rand & 0x3 | 0x8 : rand];
        });
    };

    var proxy = function (fn, context) {
        return function () {
            var args = [].slice.call(arguments, 0);
            args.push(this);

            return fn.apply(context || this, args);
        };
    };

    var $proxy = function (fn, context, arg) {
        if ('bind' in fn)
            return arg ? fn.bind(context, arg) : fn.bind(context);

        return function () {
            var args = arg ? [arg] : []; args.push.apply(args, arguments);
            return fn.apply(context || this, args);
        };
    };

    ej.merge = function (first, second) {
        if (!first || !second) return;

        Array.prototype.push.apply(first, second);
    };

    var isNull = function (val) {
        return val === undefined || val === null;
    };

    var throwError = function (er) {
        try {
            throw new Error(er);
        } catch (e) {
            throw e.message + "\n" + e.stack;
        }
    };

})(window.jQuery, window.Syncfusion, window.document);;

(function ($, undefined) {

    var $document = $(document);
    // add new event shortcuts
    $.each(("touchstart touchmove touchend " +
		"tap doubletap taphold " +
		"swipe swipeleft swiperight " + "pinch pinchin pinchout pinchstop " +
		"scrollstart scrollstop").split(" "), function (i, name) {

		    $.fn[name] = function (fn) {
		        return fn ? this.on(name, fn) : this.trigger(name);
		    };

		    // jQuery < 1.8
		    if ($.attrFn) {
		        $.attrFn[name] = true;
		    }
		});

    var isPointer = browserInfo().isMSPointerEnabled,
    isIE11Pointer = browserInfo().pointerEnabled,
    supportTouch = 'ontouchstart' in window,
	scrollEvent = "scroll",
    isDesktop = (typeof window.orientation === "undefined"),
    isIosDevice = navigator.userAgent.match(/iPhone|iPad|iPod/i),
	touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : (supportTouch ? "touchstart" : "mousedown"),
	touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : isIosDevice ? ("touchend") : (supportTouch ? "touchend" : "mouseup"),
	touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : (supportTouch ? "touchmove" : "mousemove"),
    touchCancelEvent = isPointer ? (isIE11Pointer ? "pointercancel" : "MSPointerCancel") : (supportTouch ? "touchcancel" : "mouseleave"),
    mouseStartEvent = isPointer || !isDesktop ? touchStartEvent : isIosDevice ? "touchstart" : "touchstart mousedown",
    mouseStopEvent = isPointer || !isDesktop ? touchStopEvent : "touchend mouseup",
    mouseMoveEvent = isPointer || !isDesktop ? touchMoveEvent : "touchmove mousemove",
    browser = browserInfo(),
    isIE9 = ((browser.name == 'msie') && (browser.version == '9.0')) ? true : false;

    function browserInfo() {
        var browser = {}, clientInfo = [],
        browserClients = {
            webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
            opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        for (var client in browserClients) {
            if (browserClients.hasOwnProperty(client)) {
                clientInfo = navigator.userAgent.match(browserClients[client]);
                if (clientInfo) {
                    browser.name = clientInfo[1].toLowerCase();
                    browser.version = clientInfo[2];
                    if (!!navigator.userAgent.match(/Trident\/7\./)) {
                        browser.name = "msie";
                    }
                    break;
                }
            }
        }
        browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
        browser.pointerEnabled = window.navigator.pointerEnabled;
        return browser;
    }
    function initiateCustomEvent(obj, eventType, e) {
        var originalType = e.type;
        e.type = eventType;
        $.event.dispatch.call(obj, e);
        e.type = originalType;
    }
    function copyObject(e, origEvent) {
        if (origEvent) {
            for (prop in origEvent) {
                if (!(prop in e)) {
                    e[prop] = origEvent[prop];
                }
            }
        }
    }
    $.event.special.ejtouchmove = {
        setup: function () {
            var thisObj = this,
				$this = $(thisObj);
            $this.on(touchStartEvent, startMoveHandler);
            $document.on(touchStopEvent, clearTouchMoveHandlers);
            function clearTouchMoveHandlers() {
               // $this.off(touchMoveEvent, moveHandler)
            }
            var coords = {};
            function startMoveHandler(e) {
                if (!(e.which && e.which !== 1)) {
                    var origTarget = e.target,
					origEvent = e.originalEvent;
                    if (isPointer)
                        coords = { x: origEvent.x, y: origEvent.y };
                    $this.on(touchMoveEvent, moveHandler);
                }
            }
            function moveHandler(e) {
                if (!(e.which && e.which !== 1)) {
                    var origTarget = e.target,
					origEvent = e.originalEvent;
                    copyObject(e, e.originalEvent);
                    if (!isPointer || !coords || (Math.abs(coords.x - origEvent.x) > 10 || Math.abs(coords.y - origEvent.y) > 10 && isPointer))
                        initiateCustomEvent(thisObj, "ejtouchmove", e);
                }
            }
        }
    };
    function touchObj(e) {
        return e.originalEvent.touches ?
					e.originalEvent.touches[0] : isPointer ? e.originalEvent : e;
    }
    // handles swipeup and swipedown
    $.event.special.swipeupdown = {
        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);
            $this.on(touchStartEvent, function (e) {
                var _startevent = e;
                var data = touchObj(e),
                            startPoint = {
                                time: (new Date).getTime(),
                                coords: [data.pageX, data.pageY],
                                origin: $(e.target)
                            },
                            stopPoint;
                function moveHandler(e) {
                    e.preventDefault();
                    if (!startPoint) return;
                    var data = touchObj(e);
                    stopPoint = {
                        time: (new Date).getTime(),
                        coords: [data.pageX, data.pageY]
                    };
                    if (Math.abs(startPoint.coords[1] - stopPoint.coords[1]) > 10) e.preventDefault();
                }

                $this
                            .on(touchMoveEvent, moveHandler)
                            .one(touchStopEvent, function (e) {
                                $this.off(touchMoveEvent, moveHandler);
                                if (startPoint && stopPoint) {
                                    if (stopPoint.time - startPoint.time < 1000 &&
                                    Math.abs(startPoint.coords[1] - stopPoint.coords[1]) > 30 &&
                                    Math.abs(startPoint.coords[0] - stopPoint.coords[0]) < 75) {
                                        var _addDetails = { time: stopPoint.time - startPoint.time, _isSwipe: true, _isDelta: true, stopPoint: stopPoint };
                                        var _options = _getOptions(e, _addDetails, _startevent);

                                        startPoint.origin
                                        .trigger($.extend(true, { type: "swipeupdown" }, _options))
                                        .trigger($.extend(true, { type: startPoint.coords[1] > stopPoint.coords[1] ? "swipeup" : "swipedown" }, _options));
                                    }
                                }
                                startPoint = stopPoint = undefined;
                            });
            });
        }
    };
    $.event.special.scrollstart = {
        isEnabled: true,
        setup: function () {
            var thisObj = this, $this = $(thisObj), scrolling, timer;
            function trigger(e, scrollState) {
                scrolling = scrollState;
                initiateCustomEvent(thisObj, scrolling ? "scrollstart" : "scrollstop", e);
            }
            $this.on(scrollEvent, function (e) {
                if (!$.event.special.scrollstart.isEnabled) return;
                if (!scrolling) trigger(e, true);
                clearTimeout(timer);
                timer = setTimeout(function () {
                    trigger(e, false);
                }, 250);
            });
        }
    };

    // also handles doubletap, taphold
    $.event.special.tap = {
        doubleTapThreshold: 500,
        tapholdThreshold: 650,
        canDoubleTap: function (d) {
            return ((getTimeSpan() - d.doubleTapStartTime) <= $.event.special.tap.doubleTapThreshold);
        },
        setup: function () {
            var thisObj = this, $this = $(thisObj), d = $this.data();
            var mouseDownTarget;            
            checkMsieTouch($this);
            d.isDoubleTapWait = false;
            d.stopProcess = false;
            d.preTouchend = null;
            d.preTouchstart = null;

            $this.on(mouseStartEvent, function (event) {
                if (event.type == "mousedown" || event.type == "pointerdown" || "MSPointerDown")                   
                    mouseDownTarget = event.target;
                               
                d = $this.data();
                d.startTime = getTimeSpan();
                if (!d.isDoubleTapWait) d.doubleTapStartTime = d.startTime;
                if (event.type == "touchstart") d.preTouchstart = d.startTime;
                // checked mousedown event arrives within 300'ms after the touchend completes
                if (event.type == "mousedown" && (d.startTime - d.preTouchend < 300 || d.startTime - d.preTouchstart < 30))
                    d.stopProcess = true;
                else d.stopProcess = false;

                var origTarget = event.currentTarget,
					origEvent = event.originalEvent,
					timer;

                function clearTapHandlers() {
                    clearTimeout(timer);

                    $this.off(mouseStopEvent, clickHandler);
                    if (isIE9) $document.off(mouseStopEvent, clickHandler);
                    $this.off(touchCancelEvent, clearTapHandlers);
                    $this.off(mouseMoveEvent, touchMoveAction);
                    $this.off('dragstart', dragAction);
                }
                function touchMoveAction(e) {
                    var touchmoveThreshold = 10;
                    var coor1 = (e.originalEvent.changedTouches ? e.originalEvent.changedTouches[0] : e.originalEvent),
                        coor2 = (event.originalEvent.changedTouches ? event.originalEvent.changedTouches[0] : event.originalEvent);
                    if (!((coor1.pageX - coor2.pageX < touchmoveThreshold && coor1.pageX - coor2.pageX > -(touchmoveThreshold)) &&
                        (coor1.pageY - coor2.pageY < touchmoveThreshold && coor1.pageY - coor2.pageY > -(touchmoveThreshold)))) {
                        if (e.type == "mousemove" || (e.type == "pointermove" && e.originalEvent.pointerType == "mouse") ||
                            e.type == "MSPointerMove" && e.originalEvent.pointerType == 4) {
                            clearTimeout(timer);
                            $this.off(touchCancelEvent, clearTapHandlers);
                            $this.off(mouseMoveEvent, touchMoveAction);
                        }
                        else
                          clearTapHandlers();                                            
                    }                    
                }
                function clickHandler(e) {
                    if (e.type == "touchend") d.preTouchend = getTimeSpan();
                    clearTapHandlers();

                    // Modify the tap event target
                    if (mouseDownTarget != e.target && (e.type == "mouseup" || event.type == "pointerup" || "MSPointerUp")) {
                        var mouseupTarget = e.target;                        
                        // Mousedown element is the parent of the mouseup element.                       
                        if (jQuery.contains(mouseDownTarget, mouseupTarget))
                            // Mousedown element is target.
                            updateTargetEle(e, mouseDownTarget);
                       
                        // Mousedown element is the sibiling of the mouseup element.                            
                        else if (!(jQuery.contains(mouseupTarget, mouseDownTarget))) {
                            var ele = $(mouseDownTarget).parents().has($(mouseupTarget)).first()[0];
							if(!ej.isNullOrUndefined(ele))
                                updateTargetEle(e, ele);                         
                        }
                    }

                    // ONLY trigger a 'tap' event if the startPoint target is
                    // the same as the stopPoint target.
                    if (origTarget === e.currentTarget) {
                        initiateCustomEvent(thisObj, "tap", $.extend(_getBaseOptions(e), {
                            time: getTimeSpan() - d.startTime
                        }));

                        if (d.isDoubleTapWait && $.event.special.tap.canDoubleTap(d)) {
                            d.isDoubleTapWait = false;

                            initiateCustomEvent(thisObj, "doubletap", $.extend(_getBaseOptions(e), {
                                time: getTimeSpan() - d.doubleTapStartTime
                            }));
                        }
                        else {
                            if (d.isDoubleTapWait) {
                                d.isDoubleTapWait = false;
                                d.doubleTapStartTime = d.startTime;
                            }
                            if ($.event.special.tap.canDoubleTap(d)) {
                                d.isDoubleTapWait = true;
                            }
                        }
                    }
                }
                function updateTargetEle(e,target) {
                    e.target = target;
                    e.toElement = target;                  
                }
                function dragAction(e) {
                    // Remove the tap handler while moving the element inside the tap.
                    clearTapHandlers();
                }
                if (!(event.which && event.which !== 1) && !d.stopProcess) {                   
                    $this.on(mouseStopEvent, clickHandler);
                    if (isIE9) $document.on(mouseStopEvent, clickHandler);
                    $this.on(touchCancelEvent, clearTapHandlers);
                    $this.on(mouseMoveEvent, touchMoveAction);
                    $this.on('dragstart', dragAction);
                    var eventCopy = {};  
                    for (var i in origEvent) {
                        eventCopy[i] = origEvent[i];    // For IE8 taphold issue, copy the original event in local variable 
                    }
                    timer = setTimeout(function () {
                        if (d.isDoubleTapWait) d.isDoubleTapWait = false;
                        initiateCustomEvent(thisObj, "taphold", $.extend(_getBaseOptions(event), {
                            options: eventCopy,
                            time: getTimeSpan() - d.startTime
                        }));

                    }, $.event.special.tap.tapholdThreshold);
                }
                else if (d.stopProcess) d.stopProcess = false;
            });
        }
    };    
    $.event.special.swipe = {
        scrollSupression: 10,
        duration: 1000,
        horizontalDistance: 30,
        verticalDistance: 75,
        pointers: window.navigator.msPointerEnabled,
        startPoint: function (e) {
            var data = touchObj(e);
            return {
                time: (new Date()).getTime(),
                coords: [data.pageX, data.pageY],
                origin: $(e.target)
            };
        },
        stopPoint: function (e) {
            var data = touchObj(e);
            return {
                time: (new Date()).getTime(),
                coords: [data.pageX, data.pageY]
            };
        },
        handleSwipe: function (startPoint, stopPoint, e, _startevent) {

            if (stopPoint.time - startPoint.time < $.event.special.swipe.duration &&
				Math.abs(startPoint.coords[0] - stopPoint.coords[0]) > $.event.special.swipe.horizontalDistance &&
				Math.abs(startPoint.coords[1] - stopPoint.coords[1]) < $.event.special.swipe.verticalDistance) {

                var _addDetails = { time: stopPoint.time - startPoint.time, _isSwipe: true, _isDelta: true, stopPoint: stopPoint };
                var _options = _getOptions(e, _addDetails, _startevent);

                startPoint.origin.trigger($.extend(true, { type: "swipe" }, _options))
					.trigger($.extend(true,
                    { type: startPoint.coords[0] > stopPoint.coords[0] ? "swipeleft" : "swiperight" }, _options));
            }
        },

        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);

            $this.on(touchStartEvent, function (e) {
                var startPoint = $.event.special.swipe.startPoint(e),
					stopPoint;
                var _startevent = e;
                $(e.target).data('_dataTouchStart', { event: e, _now: new Date().getTime() });

                function moveHandler(e) {
                    if (!startPoint) return;
                    stopPoint = $.event.special.swipe.stopPoint(e);
                    if (Math.abs(startPoint.coords[0] - stopPoint.coords[0]) > $.event.special.swipe.scrollSupression) e.preventDefault();
                }

                $this.on(touchMoveEvent, moveHandler)
					.one(touchStopEvent, function (e) {
					    $this.off(touchMoveEvent, moveHandler);
					    if (startPoint && stopPoint) {
					        $.event.special.swipe.handleSwipe(startPoint, stopPoint, e, _startevent);
					    }
					    startPoint = stopPoint = undefined;
					});
            });
        }
    };
    // also handles pinchin, pinchout
    $.event.special.pinch = {
        distance: function (e) {
            if (e.originalEvent.touches.length < 2) return null;
            return $.event.special.pinch._getdistance(e.originalEvent.touches[0], e.originalEvent.touches[1]);
        },
        _getdistance: function (coor1, coor2) {
            return Math.sqrt((coor1.pageX - coor2.pageX) * (coor1.pageX - coor2.pageX) +
                (coor1.pageY - coor2.pageY) * (coor1.pageY - coor2.pageY));
        },
        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);
            $this.on(touchStartEvent, function (e) {
                var _startevent = e;
                if (e.originalEvent.touches && e.originalEvent.touches.length >= 2) {
                    var startPoint = $.event.special.pinch.distance(e), stopPoint, minDistance = 5;

                    var _pinchDistance = startPoint, moveEvent;
                    var _options = _getOptions(e, { _isPinch: true, _pinchDistance: _pinchDistance }, _startevent);

                    $(e.target).trigger($.extend(true, { type: "pinch" }, _options));

                    function moveHandler(e) {
                        moveEvent = e;
                        stopPoint = $.event.special.pinch.distance(e) || null;
                        if (startPoint && stopPoint && Math.abs(startPoint - stopPoint) > minDistance) {

                            $(e.target).trigger($.extend(true,
                                { type: startPoint > stopPoint ? "pinchin" : "pinchout" }, _getOptions(e,
                                { _isPinch: true, _pinchDistance: _pinchDistance }, _startevent)));

                            startPoint = stopPoint;
                        }
                    }

                    $this.on(touchMoveEvent, moveHandler)
                        .one(touchStopEvent, function () {
                            $this.off(touchMoveEvent, moveHandler);
                            $(e.target).trigger($.extend(true, { type: "pinchstop" }, _getOptions(moveEvent,
                                { _isPinch: true, _pinchDistance: stopPoint }, _startevent)));
                            startPoint = stopPoint = undefined;
                        });
                }
            });
        }
    };
    //  handles touchdrag, touchdrag
    $.event.special.touchdrag = {

        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);

            $this.on(touchStartEvent, function (e) {

                var startPoint = touchObj(e),
					stopPoint;
                var _startevent = e;
                $(e.target).data('_dataTouchStart', { event: e, _now: new Date().getTime() });

                function moveHandler(e) {
                    if (!startPoint) {
                        return;
                    }
                    stopPoint = touchObj(e);

                    if ($.event.special.pinch._getdistance(startPoint, stopPoint) > 5)
                        $(e.target).trigger($.extend(true, { type: "touchdrag" },
                            _getOptions(e, { _isdrag: true, stopPoint: stopPoint, _isDelta: true }, _startevent)));
                }

                $this.on(touchMoveEvent, moveHandler)
					.one(touchStopEvent, function (e) {
					    $this.off(touchMoveEvent, moveHandler);
					    startPoint = stopPoint = undefined;
					});
            });
        }
    };
    function _getBaseOptions(e) {
        var _pointer = isPointer ? e.originalEvent.pointerType : (!e.originalEvent.touches ? "mouse" : "touch")
        var pointerType = (isPointer && isIE11Pointer == undefined) ? (_pointer == 4 ? "mouse" : "touch") : _pointer;
        e["pointerType"] = pointerType;
        if (e.type != "mousedown" && e.type != "mouseup") {
            copyObject(e, e.originalEvent);
        }
        return e;
    }
    function _getOptions(e, _details, _startevent) {
        var _distance, _time, _scale, _iDelta = {}, _startXY, _endXY;
        if (_startevent) {
            var coor;
            if (!_startevent.originalEvent.touches) coor = [_startevent.originalEvent, e.originalEvent];
            else coor = [_startevent.originalEvent.touches[0], e.originalEvent.changedTouches[0]];

            if (_details._isSwipe || _details._isdrag) {
                _distance = $.event.special.pinch._getdistance(coor[0], coor[1]);
                _time = _details.time;
                _endXY = { pageX: _details.stopPoint.pageX, pageY: _details.stopPoint.pageY };
            }
            else if (_details._isPinch) {
                _distance = $.event.special.pinch.distance(e);
                _time = e.timeStamp - _startevent.timeStamp;
                _scale = _details._pinchDistance;
            }
            if (_details._isDelta) {
                _iDelta._dTime = e.timeStamp - _startevent.timeStamp;
                _iDelta._x = coor[1].pageX - coor[0].pageX;
                _iDelta._y = coor[1].pageY - coor[0].pageY;
            }
        }

        return {
            options: e,
            delta: {
                time: _iDelta._dTime || null,
                X: _iDelta._x || null,
                Y: _iDelta._y || null
            },
            distance: _distance,
            scale: _details._isPinch ? _scale : null,
            time: _time,
            velocity: {
                XY: _distance / _iDelta._dTime || null,
                X: _iDelta._x / _iDelta._dTime || null,
                Y: _iDelta._y / _iDelta._dTime || null
            },
            currentPosition: { pageX: _endXY ? _endXY.pageX : null, pageY: _endXY ? _endXY.pageY : null }
        };
    }

    function getTimeSpan() {
        var now = new Date();
        return now.getTime();
    }
    function checkMsieTouch($this) {
        if (isPointer)
            $this.css("-ms-touch-action", "pinch-zoom").css("touch-action", "pinch-zoom");
    }

    $.each({
        scrollstop: "scrollstart",
        doubletap: "tap",
        taphold: "tap",
        swipeleft: "swipe",
        swiperight: "swipe",
        swipedown: "swipeupdown",
        swipeup: "swipeupdown",
        pinchin: "pinch",
        pinchout: "pinch",
        pinchstop: "pinch"
    }, function (event, sourceEvent) {

        $.event.special[event] = {
            setup: function () {
                $(this).on(sourceEvent, $.noop);
            }
        };
    });

})(jQuery);;
/**
* @fileOverview Plugin to drag the html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    
    ej.widget("ejDraggable", "ej.Draggable", {
        
        element: null,

        
        model: null,
        validTags: ["div", "span", "a"],

        
        defaults: {
            
            scope: 'default', 
            
            handle: null,  
            
            dragArea: null,
            
            clone: false,
            
            distance: 1, 
			
			dragOnTaphold: false,
            
            cursorAt: { top: -1, left: -2 }, 
            
            dragStart: null, 
            
            drag: null, 
            
            dragStop: null, 
			
			create: null,
            
            destroy: null, 
            
            helper: function () {
                return $('<div class="e-drag-helper" />').html("draggable").appendTo(document.body);
            }
        },

        
        _init: function () {
            this.handler = function () { },
			this.resizables = {},
			helpers = {};
            this._wireEvents();
            this._browser = ej.browserInfo();
            this._isIE8 = this._browser.name == "msie" && this._browser.version == "8.0";
            this._isIE9 = this._browser.name == "msie" && this._browser.version == "9.0";
            //e-pinch class enables the touch mode operations in IE browsers
            this._browser.name == "msie" && this.element.addClass("e-pinch");
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "dragArea":
                        this.model.dragArea = options[key];
                        break;
						case "dragOnTaphold":
                        this.model.dragOnTaphold = options[key];
                        break; 
                }
            }
        },
        
        
        _destroy: function () {
            $(document)
                .off(ej.eventType.mouseUp, this._destroyHandler)
                .off(ej.eventType.mouseUp, this._dragStopHandler)
                .off(ej.eventType.mouseMove, this._dragStartHandler)
                .off(ej.eventType.mouseMove, this._dragHandler)
                .off("mouseleave", this._dragMouseOutHandler)
                .off('selectstart', false);

            

            ej.widgetBase.droppables[this.scope] = null;
            
        },

        _initialize: function (e) {
            if( e.target && e.target.nodeName && $( e.target ).closest( "input[type='text'], textarea, select, option" ).length) return true;
            var ori = e;
			e.preventDefault();
            e = this._getCoordinate(e);
            this.target = $(ori.currentTarget);
            this._initPosition = { x: e.pageX, y: e.pageY };
            
            $(document).on(ej.eventType.mouseMove, this._dragStartHandler).on(ej.eventType.mouseUp, this._destroyHandler);
            if (!this.model.clone) {
                var _offset = this.element.offset();
                this._relXposition = e.pageX - _offset.left;
                this._relYposition = e.pageY - _offset.top;
            }
            $(document.documentElement).trigger(ej.eventType.mouseDown, ori); // The next statement will prevent 'mousedown', so manually trigger it.
           //return false;
        },
        _setDragArea: function () {
            var _dragElement = $(this.model.dragArea)[0]; if (!_dragElement) return;
            var elementArea, elementWidthBound, elementHeightBound, elementArea, direction = ["left", "right", "bottom", "top"], top, left;
            if (!ej.isNullOrUndefined(_dragElement.getBoundingClientRect)) {
                elementArea = _dragElement.getBoundingClientRect();
                elementArea.width ? elementWidthBound = elementArea.width : elementWidthBound = elementArea.right - elementArea.left;
                elementArea.height ? elementHeightBound = elementArea.height : elementHeightBound = elementArea.bottom - elementArea.top;
                for (var j = 0; j < direction.length; j++) {
                    this["border-" + direction[j] + "-width"] = isNaN(parseFloat($($(this.model.dragArea)[0]).css("border-" + direction[j] + "-width"))) ? 0 : parseFloat($($(this.model.dragArea)[0]).css("border-" + direction[j] + "-width"));
                    this["padding-" + direction[j]] = isNaN(parseFloat($($(this.model.dragArea)[0]).css("padding-" + direction[j]))) ? 0 : parseFloat($($(this.model.dragArea)[0]).css("padding-" + direction[j]));
                }
                top = $(this.model.dragArea).offset().top; left = $(this.model.dragArea).offset().left;
            } else {
                elementWidthBound = $(this.model.dragArea).outerWidth();
                elementHeightBound = $(this.model.dragArea).outerHeight();
                for (var j = 0; j < direction.length; j++) {
                    this["border-" + direction[j] + "-width"] = 0;
                    this["padding-" + direction[j]] = 0;
                }
                top = left = 0;
            }
            this._left = ej.isNullOrUndefined($(this.model.dragArea).offset()) ? 0 + this["border-left-width"] + this["padding-left"] : left + this["border-left-width"] + this["padding-left"];
            this._top = ej.isNullOrUndefined($(this.model.dragArea).offset()) ? 0 + this["border-top-width"] + this["padding-top"] : top + this["border-top-width"] + this["padding-top"];
            this._right = left + elementWidthBound - [this["border-right-width"] + this["padding-right"]];
            this._bottom = top + elementHeightBound - [this["border-bottom-width"] + this["padding-bottom"]];
        },
        _dragStart: function (e) {
            var ori = e;
            e = this._getCoordinate(e);
            this.margins = {
                left: (parseInt(this.element.css("marginLeft"), 10) || 0),
                top: (parseInt(this.element.css("marginTop"), 10) || 0),
                right: (parseInt(this.element.css("marginRight"), 10) || 0),
                bottom: (parseInt(this.element.css("marginBottom"), 10) || 0)
            };
            this.offset = this.element.offset();
            this.offset = {
                top: this.offset.top - this.margins.top,
                left: this.offset.left - this.margins.left
            };
            this.position = this._getMousePosition(ori);
            var x = this._initPosition.x - e.pageX, y = this._initPosition.y - e.pageY;
            var distance = Math.sqrt((x * x) + (y * y));

            if (distance >= this.model.distance) {
			    var ele = this.model.helper({ sender: ori, element: this.target });
				if(!ele || ej.isNullOrUndefined(ele)) return;
                var dragTargetElmnt = this.model.handle = this.helper = ele;
                if (this.model.dragStart) {
                    var currTarget = null;
                    if (ori.type == 'touchmove') {
                        var coor = ori.originalEvent.changedTouches[0];
                        currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                    }
                    else currTarget = ori.originalEvent.target || ori.target;
					if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
						currTarget = this._checkTargetElement(e) || currTarget;   
                    if (this._trigger("dragStart", { event: ori, element: this.element, target: currTarget })) {
                        this._destroy();
                        return false;
                    }
                }
                if (this.model.dragArea) this._setDragArea();
                else {
                    this._left = this._top = this._right = this._bottom = 0;
                    this["border-top-width"] = this["border-left-width"] = 0;
                }
                
                var pos= dragTargetElmnt.offsetParent().offset();
                $(document).off(ej.eventType.mouseMove, this._dragStartHandler).off(ej.eventType.mouseUp, this._destroyHandler)
                    .on(ej.eventType.mouseMove, this._dragHandler).on(ej.eventType.mouseUp, this._dragStopHandler).on("mouseleave", this._dragMouseOutHandler).on("selectstart", false);
                ej.widgetBase.droppables[this.model.scope] = {
                    draggable: this.element,
                    helper: dragTargetElmnt.css({ position: 'absolute',  left: (this.position.left-pos.left), top: (this.position.top-pos.top) }),
                    destroy: this._destroyHandler
                }
            }
        },

        _drag: function (e) {
            var left, top, pageX, pageY;
			e.preventDefault();
            this.position = this._getMousePosition(e);
            if (this.position.top < 0)
                this.position.top = 0;
            if ($(document).height() < this.position.top)
                this.position.top = $(document).height();
            if ($(document).width() < this.position.left)
                this.position.left = $(document).width();
            var helperElement = ej.widgetBase.droppables[this.model.scope].helper;
            if (this.model.drag) {
                var currTarget = null;
                if (e.type == 'touchmove') {
                    var coor = e.originalEvent.changedTouches[0];
                    currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                }
                else currTarget = e.originalEvent.target || e.target;
				if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0 )
                    currTarget = this._checkTargetElement(e)|| currTarget; 
                this._trigger("drag", { event: e, element: this.target, target: currTarget });// Raise the dragging event
            }
            var element = this._checkTargetElement(e);
            if (!ej.isNullOrUndefined(element)) {
                e.target = e.toElement = element;
                element.object._over(e); 
                this._hoverTarget = element; 
            }
            else if (this._hoverTarget) {
                e.target = e.toElement = this._hoverTarget;
                this._hoverTarget.object._out(e);
                this._hoverTarget = null;
            }
            var helperElement = ej.widgetBase.droppables[this.model.scope].helper;
			var pos= helperElement.offsetParent().offset();			 
            pageX = ej.isNullOrUndefined(e.pageX) ? e.originalEvent.changedTouches[0].pageX : e.pageX;
            pageY = ej.isNullOrUndefined(e.pageY) ? e.originalEvent.changedTouches[0].pageY : e.pageY;
            if (this.model.dragArea) {
                if (this._pageX != pageX) {
                    if (this._left > this.position.left) left = this._left;
                    else if (this._right < this.position.left + helperElement.outerWidth(true)) left = this._right - helperElement.outerWidth(true);
                    else left = this.position.left;
                }
                if (this._pageY != pageY) {
                    if (this._top > this.position.top) top = this._top;
                    else if (this._bottom < this.position.top + helperElement.outerHeight(true)) top = this._bottom - helperElement.outerHeight(true);
                    else top = this.position.top;
                }
            }
            else {
                left = this.position.left;
                top = this.position.top;
            }
            if (top < 0 || top - [pos.top + this["border-top-width"]] < 0) top = [pos.top + this["border-top-width"]];
            if (left < 0 || left - [pos.left + this["border-left-width"]] < 0) left = [pos.left + this["border-left-width"]];
            helperElement.css({ left: left - [pos.left + this["border-left-width"]], top: top - [pos.top + this["border-top-width"]] });
            this.position.left = left;
            this.position.top = top;
            this._pageX = pageX;
            this._pageY = pageY;
        },

        _dragStop: function (e) {
            if (e.type == 'mouseup' || e.type == 'touchend') 
                this._destroy(e);
            if (this.model.dragStop) {
                var currTarget = null;
                if (e.type == 'touchend') {
                    var coor = e.originalEvent.changedTouches[0];
                    currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                }
                else currTarget = e.originalEvent.target || e.target;                
                if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
                    currTarget = this._checkTargetElement(e) || currTarget;              
                this._trigger("dragStop", { event: e, element: this.target, target: currTarget });// Raise the dragstop event
            }
            this._dragEnd(e);
        },
        _dragEnd: function (e) {
            var element = this._checkTargetElement(e);
            if (!ej.isNullOrUndefined(element)) {
                e.target = e.toElement = element;
                element.object._drop(e, this.element);
            }
        },

        _dragMouseEnter: function (e) {
            $(document).off("mouseenter", this._dragMouseEnterHandler);
            if (this._isIE9)
                this._dragManualStop(e);
            else if (this._isIE8) {
                if (e.button == 0)
                    this._dragManualStop(e);
            }
            else if (e.buttons == 0)
                this._dragManualStop(e);
        },

        _dragManualStop: function (e) {
            if (this.model.dragStop != null)
                this._trigger("dragStop", { event: e, element: this.target, target: e.originalEvent.target || e.target });  // Raise the dragstop event
            this._destroy(e);
        },

        _dragMouseOut: function (e) {
            $(document).on("mouseenter", this._dragMouseEnterHandler);
        },

        _checkTargetElement:function(e)
        {
            var target ;
			if (e.type == "touchmove" || e.type == "touchstart" || e.type == "touchend" || e.type=="taphold") {
				var coor = e.originalEvent.changedTouches[0];
				target = document.elementFromPoint(coor.clientX, coor.clientY);
			}
			else
				target = e.target;
            if (this.helper && this._contains(this.helper[0], target)) {
                this.helper.hide();
                target = this._elementUnderCursor(e);
                this.helper.show();
                return this._withDropElement(target);
            }
            return this._withDropElement(target);
        },
        _withDropElement:function(target)
        {
            if (target) {
                dropObj = $(target).data('ejDroppable');
                if (ej.isNullOrUndefined(dropObj)) dropObj = this._checkParentElement($(target));
                if (!ej.isNullOrUndefined(dropObj)) {
                    return $.extend(target, { object: dropObj });
                }
            }
        },
        _checkParentElement: function (element) {
            var target = $(element).closest('.e-droppable');
            if (target.length > 0) {
                dropObj = $(target).data('ejDroppable');
                if (!ej.isNullOrUndefined(dropObj)) return dropObj;
            }
        },
        _elementUnderCursor:function(e){
            if(e.type == "touchmove" || e.type == "touchstart" || e.type == "touchend" || e.type=="taphold")
                return document.elementFromPoint(e.originalEvent.changedTouches[0].clientX, e.originalEvent.changedTouches[0].clientY);
            else return document.elementFromPoint(e.clientX, e.clientY);
        },
        _contains:function(parent, child) {
            try {
                return $.contains(parent, child) || parent == child;
            } catch (e) {
                    return false;
                }
        },
        _wireEvents: function () {
			if(ej.isDevice()==true && this.model.dragOnTaphold==true)
            this._on(this.element, "taphold", this._initialize);
		else
            this._on(this.element, ej.eventType.mouseDown, this._initialize);
            this._dragStartHandler = $.proxy(this._dragStart, this);
            this._destroyHandler = $.proxy(this._destroy, this);
            this._dragStopHandler = $.proxy(this._dragStop, this);
            this._dragHandler = $.proxy(this._drag, this);
            this._dragMouseEnterHandler = $.proxy(this._dragMouseEnter, this);
            this._dragMouseOutHandler = $.proxy(this._dragMouseOut, this);
        },
        _getMousePosition: function (event) {
            event = this._getCoordinate(event);
            var pageX = this.model.clone ? event.pageX : event.pageX - this._relXposition;
            var pageY = this.model.clone ? event.pageY : event.pageY - this._relYposition;
            return { left: pageX - [this.margins.left + this.model.cursorAt.left ], top: pageY - [this.margins.top + this.model.cursorAt.top ] };
        },
        _getCoordinate: function (evt) {
            var coor = evt;
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend" || evt.type== "taphold" && ej.browserInfo().name !="msie")
                coor = evt.originalEvent.changedTouches[0];
            return coor;
        }
    });

})(jQuery, Syncfusion);

/**
* @fileOverview Plugin to drop the html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDroppable", "ej.Droppable", {
        
        element: null,        
        model: null,
        validTags: ["div", "span", "a"],
        dropElements : [],
        defaults: {
            
            accept: null,
            
            scope: 'default',
            
            drop: null,
            
            over: null,
            
            out: null,
			
			create: null,
            
            destroy: null
        },

        
        _init: function () {
            this._mouseOver = false;
			this.dropElements.push(this);
        },

        _setModel: function (options) {

        },
        
        
        _destroy: function () {
			 $(this.element).off('mouseup', $.proxy(this._drop, this));
        },

        _over: function (e) {
            if (!this._mouseOver) {
                this._trigger("over", e);
                this._mouseOver = true;
            }
        },
        _out: function (e) {
            if (this._mouseOver) {
                this._trigger("out", e);
                this._mouseOver = false;
            }
        },
        _drop: function (e, dragElement) {
			var _target = e.target;
			if (e.type == "touchend") {
				var coor = e.originalEvent.changedTouches[0], _target;
				_target = document.elementFromPoint(coor.clientX, coor.clientY);
			}
			var _parents = $(_target).parents(".e-droppable");
			if($(_target).hasClass("e-droppable")) _parents.push(_target);
			for (var i =0; i< this.dropElements.length; i++ ){
				if ($(_parents).is($(this.dropElements[i].element)))
					this.dropElements[i]._dropEvent.call( this.dropElements[i], e, dragElement );
			}
        },
		_dropEvent : function (e, dragElement){
			var drag = ej.widgetBase.droppables[this.model.scope];
            var isDragged = !ej.isNullOrUndefined(drag.helper) && drag.helper.is(":visible");
			if(isDragged && e.type == "touchend") $(drag.helper).hide();
            var area = this._isDropArea(e);
			if(isDragged && e.type == "touchend") $(drag.helper).show();
            if (drag && !ej.isNullOrUndefined(this.model.drop) && isDragged && area.canDrop) {
                this.model.drop($.extend(e, { dropTarget: area.target , dragElement : dragElement }, true), drag);
            }
		},
        _isDropArea: function (e) {
            // check for touch devices only
            var area = { canDrop: true, target: $(e.target) };
            if (e.type == "touchend") {
                var coor = e.originalEvent.changedTouches[0], _target;
                _target = document.elementFromPoint(coor.clientX, coor.clientY);
                area.canDrop = false;
                var _parents = $(_target).parents();

                for (var i = 0; i < this.element.length; i++) {
                    if ($(_target).is($(this.element[i]))) area = { canDrop: true, target: $(_target) };
                    else for (var j = 0; j < _parents.length; j++) {
                        if ($(this.element[i]).is($(_parents[j]))) {
                            area = { canDrop: true, target: $(_target) };
                            break;
                        }
                    }
                    if (area.canDrop) break;
                }
            }
            return area;
        }
    });

})(jQuery, Syncfusion);

/**
* @fileOverview Plugin to resize the Html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    
    ej.widget("ejResizable", "ej.resizable", {
        
        element: null,        
        model: null,
        validTags: ["div", "span", "a"],
        
        defaults: {
            
            scope: 'default',
            
            handle: null,
            
            distance: 1,
            
            maxHeight: null,
            
            maxWidth: null,
            
            minHeight: 10,
            
            minWidth: 10,
            
            cursorAt: { top: 1, left: 1 },
            
            resizeStart: null,
            
            resize: null,
            
            resizeStop: null,
			
			create: null,
            
            destroy: null,
            
            helper: function () {
                return $('<div class="e-resize-helper" />').html("resizable").appendTo(document.body);
            }
        },
        
        _init: function () {
            this.target = this.element;
            this._browser = ej.browserInfo();
            this._isIE8 = this._browser.name == "msie" && this._browser.version == "8.0";
            this._isIE9 = this._browser.name == "msie" && this._browser.version == "9.0";
            if (this.handle != null) {
                $(this.target).delegate(this.handle, ej.eventType.mouseDown, $.proxy(this._mousedown, this))
                .delegate(this.handle, 'resizestart', this._blockDefaultActions);
            }
            else {
                $(this.target).on("mousedown", $.proxy(this._mousedown, this));                                
            }
            this._resizeStartHandler = $.proxy(this._resizeStart, this);
            this._destroyHandler = $.proxy(this._destroy, this);
            this._resizeStopHandler = $.proxy(this._resizeStop, this);
            this._resizeHandler = $.proxy(this._resize, this);
            this._resizeMouseEnterHandler = $.proxy(this._resizeMouseEnter, this);
        },
        _mouseover: function (e) {
            if ($(e.target).hasClass("e-resizable")) {
                $(e.target).css({ cursor: "se-resize" });
                $(this.target).on(ej.eventType.mouseDown, $.proxy(this._mousedown, this));
            }
            else {
                $(this.target).off(ej.eventType.mouseDown);
                $(this.target).css({ cursor: "" });
            }
        },
        _blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },
        _setModel: function (options) {

        },
        _mousedown: function (e) {
            var ori = e;
            e = this._getCoordinate(e);
            this.target = $(ori.currentTarget);
            this._initPosition = { x: e.pageX, y: e.pageY };
            this._pageX = e.pageX;
            this._pageY = e.pageY;

            $(document).on(ej.eventType.mouseMove, this._resizeStartHandler).on(ej.eventType.mouseUp, this._destroyHandler);

            $(document.documentElement).trigger(ej.eventType.mouseDown, ori); // The next statement will prevent 'mousedown', so manually trigger it.
            return false;
        },

        _resizeStart: function (e) {
            if ($(e.target).hasClass("e-resizable")) {
                e = this._getCoordinate(e);
                var x = this._initPosition.x - e.pageX, y = this._initPosition.y - e.pageY, _width, _height;
                var distance = Math.sqrt((x * x) + (y * y));
                if (distance >= this.model.distance) {
                    if (this.model.resizeStart != null) 
                        if (this._trigger("resizeStart", { event: e, element: this.target }))  // Raise the resize start event
                            return;
                    var resizeTargetElmnt = this.model.helper({ element: this.target });
                    _width = (e.pageX - this._pageX) + resizeTargetElmnt.outerWidth();
                    _height = (e.pageY - this._pageY) + resizeTargetElmnt.outerHeight();
                    this._pageX = e.pageX;
                    this._pageY = e.pageY;
                    var pos = this.getElementPosition(resizeTargetElmnt);
                    $(document).off(ej.eventType.mouseMove, this._resizeStartHandler).off(ej.eventType.mouseUp, this._destroyHandler)
                        .on(ej.eventType.mouseMove, this._resizeHandler).on(ej.eventType.mouseUp, this._resizeStopHandler).on("mouseenter", this._resizeMouseEnterHandler).on("selectstart", false);
                    ej.widgetBase.resizables[this.scope] = {
                        resizable: this.target,
                        helper: resizeTargetElmnt.css({ width: _width, height: _height }),
                        destroy: this._destroyHandler
                    }
                }
            }
        },

        _resize: function (e) {
            var _width, _height, _diff;
            e = this._getCoordinate(e);
            var pos = this.getElementPosition(ej.widgetBase.resizables[this.scope].helper);
            var resizeTargetElmnt = this.model.helper({ element: this.target });
            _width = (e.pageX - this._pageX) + resizeTargetElmnt.outerWidth();
            _height = (e.pageY - this._pageY) + resizeTargetElmnt.outerHeight();
            this._pageX = e.pageX;
            this._pageY = e.pageY;
            if (_width < this.model.minWidth) {
                _diff = this.model.minWidth - _width;
                _width = this.model.minWidth;
                this._pageX = e.pageX + _diff;
            }
            if (_height < this.model.minHeight) {
                _diff = this.model.minHeight - _height;
                _height = this.model.minHeight;
                this._pageY = e.pageY + _diff;
            }
            if (this.model.maxHeight != null && _height > this.model.maxHeight) {
                _diff = _height - this.model.maxHeight;
                _height = this.model.maxHeight;
                this._pageY = e.pageY - _diff;
            }
            if (this.model.maxWidth != null && _width > this.model.maxWidth) {
                _diff = _width - this.model.maxWidth;
                _width = this.model.maxWidth;
                this._pageX = e.pageX - _diff;
            }
            ej.widgetBase.resizables[this.scope].helper.css({ width: _width, height: _height });
            this._trigger("resize", { element: this.target }) // Raise the resize event
        },

        _resizeStop: function (e) {
            if (this.model.resizeStop != null)
                this._trigger("resizeStop", { element: this.target });  // Raise the resize stop event
            if (e.type == 'mouseup' || e.type == 'touchend')
                this._destroy(e);
        },

        _resizeMouseEnter: function (e) {
            if (this._isIE9)
                this._resizeManualStop(e);
            else if (this._isIE8) {
                if (e.button == 0)
                    this._resizeManualStop(e);
            }
            else if (e.buttons == 0)
                this._resizeManualStop(e);
        },

        _resizeManualStop: function (e) {
            if (this.model.resizeStop != null)
                this._trigger("resizeStop", { element: this.target });  // Raise the resize stop event
            this._destroy(e);
        },

        
        _destroy: function (e) {
            $(document)
                .off(ej.eventType.mouseUp, this._destroyHandler)
                .off(ej.eventType.mouseUp, this._resizeStopHandler)
                .off(ej.eventType.mouseMove, this._resizeStartHandler)
                .off(ej.eventType.mouseMove, this._resizeHandler)
                .off("mouseenter", this._resizeMouseEnterHandler)
                .off('selectstart', false);            
            ej.widgetBase.resizables[this.scope] = null;
            
        },

        getElementPosition: function (elemnt) {
            if (elemnt != null && elemnt.length > 0)
                return {
                    left: elemnt[0].offsetLeft,
                    top: elemnt[0].offsetTop
                };
            else
                return null;
        },
        _getCoordinate: function (evt) {
            var coor = evt;
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend")
                coor = evt.originalEvent.changedTouches[0];
            return coor;
        }
    });

})(jQuery, Syncfusion);;

/**
* @fileOverview Plugin to style the Html ScrollBar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, window, undefined) {
    'use strict';

    ej.widget("ejScrollBar", "ej.ScrollBar", {
        defaults: {

            orientation: "horizontal",

            viewportSize: 0,

            height: 18,

            width: 18,

            smallChange: 57,

            largeChange: 57,

            value: 0,

            maximum: 0,

            minimum: 0,

            buttonSize: 18,

            infiniteScrolling: false
        },
        validTags: ["div"],
        type: "transclude",
        dataTypes: {
            buttonSize: "number",
            smallChange: "number",
            largeChange: "number",
        },
        observables: ["value"],
        value: ej.util.valueFunction("value"),
        _enabled: true,
        content: function () {
            if (!this._content || !this._content.length) {
                if (this.model.orientation === "horizontal") {
                    this._content = this.element.find(".e-hhandle");
                }
                else {
                    this._content = this.element.find(".e-vhandle");
                }
            }
            return this._content;
        },
        _init: function () {
            this.element.addClass("e-widget");
            this._ensureScrollers();
            this.content();
            this._setInitialValues();

        },

        _setInitialValues: function () {
            var xy = "X";
            if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                this.element.addClass("e-hscrollbar");
            }
            else {
                this.element.addClass("e-vscrollbar");
                xy = "Y";
            }
            if (this.value() !== 0 || this.model.minimum !== 0) {
                if (this.value() < this.model.minimum)
                    this.value(this.model.minimum);
                this["scroll"](this.value(), "none");
            }
        },

        _ensureScrollers: function () {
            var jqVersion = $.fn.jquery, height, width;
            if (this.model.height) {
                this.element.height(this.model.height);
            }
            if (this.model.width) {
                this.element.width(this.model.width);
            }            
            var d2;
            if (!this._scrollData) {
                if (this.model.orientation === "vertical") {
                    this._scrollData = this._createScroller("Height", "Y", "Top", "e-v");
                }
                else {
                    this._scrollData = this._createScroller("Width", "X", "Left", "e-h");
                }
            }
        },

        _setModel: function (option) {
            for (var prop in option) {
                if (prop === "value") {
                    if (this.value()) {
                        this.scroll(this.value(), "none");
                    }
                } else {
                    this.refresh();
                    break;
                }
            }
        },

        _createScroller: function (dimension, xy, position, css) {
            var height;
            var d = {};
            var jqVersion = $.fn.jquery;
            d.dimension = dimension;
            d.xy = xy;
            d.position = position;
            d.css = css;
            d.uDimension = dimension;

            this._calculateLayout(d);
            this._createLayout(d);
            var buttons = this[d.main].find(".e-button");

            this._off(buttons, "mousedown")
                ._on(buttons, "mousedown", { d: d, step: 1 }, this._spaceMouseDown);
            this._off(this[d.scroll], "mousedown")
                ._on(this[d.scroll], "mousedown", { d: d }, this._spaceMouseDown);
            this._off(this[d.handler], "mousedown touchstart")
                ._on(this[d.handler], "mousedown touchstart", { d: d }, this._mouseDown);

            return d;
        },
        _createLayout: function (d) {
            var divString = "<div class='" + d.css + "{0}' style='" + d.dimension + ":{1}px'>{2}</div>";
            var jqVersion = $.fn.jquery;
            var lit = {}, height;
            lit[d.dimension] = d.modelDim;

            var el = ej.buildTag(
                "div." + d.css + "scroll e-box",
                    String.format(divString, "up e-chevron-up_01 e-icon e-box e-button", d.buttonSize) +
                    String.format(divString, "handlespace", d.handleSpace,
                        String.format(divString, "handle e-box e-pinch" , d.handle)) +
                    String.format(divString, "down e-chevron-down_01 e-icon e-box e-button", d.buttonSize),
                lit
            );

            this.element.append(el);
            this.element.find('.e-vhandle').addClass("e-v-line e-icon");
            this.element.find('.e-hhandle').addClass("e-h-line e-icon");
            jqVersion === "1.7.1" || jqVersion === "1.7.2" ? height = d.uDimension.toLowerCase() : height = "outer" + d.uDimension;
            this[d.handler] = this.element.find("." + d.handler);
            this[d.handler].css("transition", "none");
            this[d.scroll] = this[d.handler].parent();
            this[d.main] = this[d.scroll].parent();
            this[d.main].find(".e-button")["outer" + d.uDimension](d.buttonSize);
        },
        _calculateLayout: function (d) {
            d.scrollDim = "scroll" + d.dimension;
            d.lPosition = d.position.toLowerCase();
            d.clientXy = "page" + d.xy;
            d.scrollVal = "scroll" + d.position;
            d.scrollOneStepBy = this.model.smallChange;
            d.modelDim = this.model[(d.dimension = d.dimension.toLowerCase())];
            d.handler = d.css + "handle";
            d.buttonSize = this.model.buttonSize;
            d.main = d.css + "scroll";
            d.scroll = d.css + "ScrollSpace";
            d.handleSpace = d.modelDim - 2 * d.buttonSize;
            d.scrollable = (this.model.maximum - this.model.minimum);
            var trackLength = this.model.height;
            if (this.model.orientation === "horizontal")
                trackLength = this.model.width;
            d.handle = (this.model.viewportSize / ((this.model.maximum - this.model.minimum) + this.model.viewportSize)) * (trackLength - 2 * this.model.buttonSize);
            var check;
            !ej.isNullOrUndefined(this.model.elementHeight) && typeof this.model.elementHeight === "string" && this.model.elementHeight.indexOf("%") != -1 ? check = true : check = false;
            if (d.handle < 20 && !check) d.handle = 20;
            d.onePx = d.scrollable / (d.handleSpace - d.handle);
            d.fromScroller = false;
            d.up = true;
            d.vInterval = undefined;
        },
        _updateLayout: function (d) {
            this.element.height(this.model.height);
            this.element.width(this.model.width);
            var handle = this.element.find("." + d.css + "handle");
            var handleSpace = this.element.find("." + d.css + "handlespace");
            var size = d.dimension == "width" ? handle.css('left') : handle.css('top'); 
            var dimension = d.dimension == "width" ? handleSpace.outerWidth() : handleSpace.outerHeight(); 
            if (size !== undefined && size !== "auto"){
                if (!(dimension >= d.handle + parseFloat(size)))
                    if (this.model.enableRTL) handle.css(d.dimension === "width" ? 'left' : 'top', (parseFloat(dimension) - d.handle));
                    else handle.css(d.dimension === "width" ? 'left' : 'top', (parseFloat(dimension) - d.handle) > 0 ? (parseFloat(dimension) - d.handle) : 0);
            }
            this.element.find("." + d.css + "scroll").css(d.dimension, d.modelDim + "px")
                .find(".e-button").css(d.dimension, this.model.buttonSize).end()
                .find("." + d.css + "handlespace").css(d.dimension, d.handleSpace + "px")
                .find("." + d.css + "handle").css(d.dimension, d.handle + "px");
        },
        refresh: function () {
            this._ensureScrollers();
            if (this.value()) {
                this.scroll(this.value(), "none");
            }
            if (this._scrollData) {
                this._calculateLayout(this._scrollData);
                this._updateLayout(this._scrollData);
            }
        },

        scroll: function (pixel, source, triggerEvent, e) {
            var dS = this._scrollData;
            if (!triggerEvent) {
                if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                    if (this._trigger("scroll", { source: source || "custom", scrollData: this._scrollData, scrollLeft: pixel, originalEvent: e }))
                        return;
                }
                else {
                    if (this._trigger("scroll", { source: source || "custom", scrollData: this._scrollData, scrollTop: pixel, originalEvent: e }))
                        return;
                }
            }
			if (this._scrollData) { 
            if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name != "msie") 
                this.value(-dS.scrollable + pixel);              
            else {
                if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name == "msie")  this.value(-1 * pixel);              
                else this.value(pixel);
            }
            if (this.content().length > 0) {
                if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                        var left = (this.element.find('.e-hhandlespace').width() - this.element.find('.e-hhandle').outerWidth());
                        pixel = left < ((pixel - this.model.minimum) / this._scrollData.onePx) ? left : ((pixel - this.model.minimum) / this._scrollData.onePx);
                        if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name != "msie") {
                            pixel = left - pixel;
                            pixel > 0 ? pixel = pixel * -1 : pixel;                           
                        }
                        if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name == "msie") pixel = -pixel;       
                        this._scrollData.enableRTL && pixel > 0 && !this._scrollData._scrollleftflag ? pixel = 0 : pixel             
                        if (this._scrollData._scrollleftflag) {
                           
                            pixel > 0 ? pixel = pixel * -1 : pixel;
                            this.value(pixel);
                        }
                        this.content()[0].style.left = pixel + "px";
                        this._scrollData._scrollleftflag = false;
                }
                else {
                    var top = (this.element.find('.e-vhandlespace').height() - this.element.find('.e-vhandle').outerHeight());
                    pixel = top < ((pixel - this.model.minimum) / this._scrollData.onePx) ? top : ((pixel - this.model.minimum) / this._scrollData.onePx);
					if(ej.browserInfo().name=="msie" && isNaN(pixel)) pixel="";
                    this.content()[0].style.top = pixel + "px";
                }
				}
			}
        },

        _changeTop: function (d, step, source) {
            var start, t;
            if (d.dimension === "height")
                start = this.value();
            else
                start = this.value();
            t = start + step;
            d.step = step;
            if ((d.enableRTL && step < 0) || (step > 0 && !d.enableRTL)) {
                if (d.enableRTL) {
                    if (t < this.model.maximum * -1)
                        t = this.model.maximum * -1;
                }
                else {
                    if (t > this.model.maximum)
                        t = this.model.maximum;
                }
            }
            else {
                if (d.enableRTL) {
                    if (t > this.model.minimum)
                        t = this.model.minimum;
                }
                else {
                    if (t < this.model.minimum)
                        t = this.model.minimum;
                }
            }
            if (t !== start || this.model.infiniteScrolling) {
                this["scroll"](t, source);
            }
            return t !== start;
        },

        _mouseUp: function (e) {
            if (!e.data) return;
            var d = e.data.d;
            clearInterval(d.vInterval);
            if (e.type == "touchend") $(e.target).removeClass("e-touch");
            if (e.type === "mouseup"  || e.type === "touchend" || (!e.toElement && !e.relatedTarget && !e.target)) {
                this._prevY = this._d = this._data = null;
                this._off($(document), "mousemove touchmove", this._mouseMove);
                $(document).off("mouseup touchend", ej.proxy(this._mouseUp, this));
                d.fromScroller = false;
                this[d.scroll].off("mousemove");
                this[d.handler].off("mousemove").css("transition", "");
                if (e.data.source === "thumb" && !ej.isNullOrUndefined(this.model)) {
                    $.when(this.content()).done(ej.proxy(function () {
                        this._trigger("thumbEnd", { originalEvent: e, scrollData: d });
                    }, this));
                }
            }
            d.up = true;
        },


        _mouseDown: function (down) {
            if (!this._enabled) return;
            this._d = down;
            this._data = this._d.data.d,
            this._data.target = this._d.target;
            this._data.fromScroller = true;
            this[this._data.handler].css("transition", "none");
            this._on($(document), "mousemove touchmove", { d: this._data, source: "thumb" }, this._mouseMove);
            this._trigger("thumbStart", { originalEvent: this._d, scrollData: this._data });
            $(document).one("mouseup touchend", { d: this._data, source: "thumb" }, ej.proxy(this._mouseUp, this));
            if (down.type == "touchstart") $(down.target).addClass("e-touch");
        },
        _mouseCall:function(move){
            move.type = "mouseup";
            this._mouseUp(move);
        },
        _mouseMove:function(move){
            var value, step = 0, top = parseInt(this[this._data.handler].css(this._data.lPosition)) || 0;
            move.preventDefault();
            var skip = 1;
            if (ej.isNullOrUndefined(move.target.tagName)) {
                if ($(move.target).is(document)) {
                    this._mouseCall(move);
                    return;
                }
            }
            else if (move.target.tagName.toLowerCase() === "iframe") { this._mouseCall(move); return; }
            var pageXY = move.type == "mousemove" ? move[this._data.clientXy] : move.originalEvent.changedTouches[0][this._data.clientXy];
            if (this._prevY && pageXY !== this._prevY) {
                step = (pageXY - this._prevY);
                if (this.model.infiniteScrolling) {
                    top = top + step;
                    this._data.step = step;
                    if (this._data.enableRTL ? top > 0 : top < 0) top = 0;
                    if ((top * (this._data.enableRTL ? -1 : 1)) + this._data.handle >= this._data.handleSpace)
                        top = (this._data.handleSpace - this._data.handle) * (this._data.enableRTL ? -1 : 1);
                    value = Math.ceil(top * this._data.onePx);
                    this["scroll"](value, "thumb");
                }
                else {
                    value = step * this._data.onePx;
                    this._changeTop(this._data, value, "thumb", this._d);
                }
                this._trigger("thumbMove", { originalEvent: move, scrollData: this._data });
            }
            if (skip === 1)
                this._prevY = pageXY;
        },

        _spaceMouseDown: function (e) {
            if (!e.data || !this._enabled) return;
            var d = e.data.d;
            if (e.which !== 1 || e.target === this[d.handler][0]) return;
            var step = e.data.step ? this.model.smallChange : this.model.largeChange, hTop = e.data.top || this[d.handler].offset()[d.lPosition];
            e[d.clientXy] = e[d.clientXy] || 0;
            if (e[d.clientXy] < hTop) step *= -1;
            d.target = e.target;
            this._changeTop(d, step, step === 3 ? "track" : "button", e);
            if (e.data.step !== 1) {
                this[d.scroll].mousemove(function () {
                    d.up = true;
                });
            }
            d.up = false;
            d.vInterval = setInterval(ej.proxy(function () {
                if (step < 0 ? hTop + (step / d.onePx) < e[d.clientXy] : hTop + d.handle + (step / d.onePx) > e[d.clientXy])
                    d.up = true;
                if (d.up) {
                    clearInterval(d.vInterval);
                    return;
                }
                this._changeTop(d, step, step === 3 ? "track" : "button", e);
                e.data ? hTop = e.data.top || this[d.handler].offset()[d.lPosition] : hTop = this[d.handler].offset()[d.lPosition];
            }, this), 150);

            $(document).one("mouseup", { d: d }, ej.proxy(this._mouseUp, this));
            $(document).mouseout({ d: d }, ej.proxy(this._mouseUp, this));
        },

        _remove: function () {
            if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal)
                this.element.find(".e-hscroll").remove();
            if (this.model.orientation === ej.ScrollBar.Orientation.Vertical)
                this.element.find(".e-vscroll").remove();
            this._scrollData = null;
            this._content = null;
        },

        _destroy: function () {
            this.element.remove();
        },
    });

    ej.ScrollBar.Orientation = {
        Horizontal: "horizontal",
        Vertical: "vertical"
    };
})(jQuery, Syncfusion, window);;

/**
* @fileOverview Plugin to style the Html Scroller elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/


(function ($, ej, window, undefined) {
    'use strict';

    ej.widget("ejScroller", "ej.Scroller", {
        _addToPersist: ["scrollLeft", "scrollTop"],
        defaults: {

            height: 250,

            autoHide: false,

            animationSpeed: 600,

            width: 0,

            scrollOneStepBy: 57,

            buttonSize: 18,

            scrollLeft: 0,

            scrollTop: 0,

            targetPane: null,

            scrollerSize: 18,

            enablePersistence: false,

            enableRTL: undefined,

            enableTouchScroll: true,

            enabled: true,

            create: null,

            destroy: null,

            wheelStart: null,

            wheelMove: null,

            wheelStop: null
        },
        validTags: ["div"],
        type: "transclude",

        dataTypes: {
            buttonSize: "number",
            scrollOneStepBy: "number"
        },
        observables: ["scrollTop", "scrollLeft"],
        scrollTop: ej.util.valueFunction("scrollTop"),
        scrollLeft: ej.util.valueFunction("scrollLeft"),

        keyConfigs: {
            up: "38",
            down: "40",
            left: "37",
            right: "39",
            pageUp: "33",
            pageDown: "34",
            pageLeft: "ctrl+37",
            pageRight: "ctrl+39"
        },

        content: function () {
            if (!this._content || !this._content.length || !this._content[0].offsetParent)
                this._content = this.element.children().first().addClass("e-content");

            return this._content;
        },
        _setFirst: true,
        _updateScroll: false,

        _init: function () {
			if(!ej.isNullOrUndefined(this.content()[0])){
            this._prevScrollWidth = this.content()[0].scrollWidth, this._prevScrollHeight = this.content()[0].scrollHeight;
            this.element.addClass("e-widget");
            this.content();
            this._browser = ej.browserInfo().name;
            this._wheelStart = true;
            this._eleHeight = this.model.height;
            this._eleWidth = this.model.width;
            if (this.model.enableRTL === undefined) {
                this.model.enableRTL = this.element.css("direction") === "rtl";
            }
            this._ensureScrollers();
            if (this.model.enableRTL) {
                this.element.addClass("e-rtl");
                this._rtlScrollLeftValue = this.content().scrollLeft();
            }
            this._on(this.content(), "scroll", this._scroll);
            this.model.targetPane != null && this._on(this.content().find(this.model.targetPane), "scroll", this._scroll);
            if (this.scrollLeft())
                this._setScrollLeftValue(this.scrollLeft());
            if (this.scrollTop())
                this.content().scrollTop(this.scrollTop());

            if (this.model.autoHide) {
                this._autohide();
            }
            if (this.model.enabled) {
                this.enable();
            }
            else {
                this.disable();
            }
            this._setDimension();
            if (this._prevScrollWidth !== this.content()[0].scrollWidth || this._prevScrollHeight !== this.content()[0].scrollHeight) this.refresh();
			}
            this._addActionClass();
        },
        _addActionClass: function () {
            //e-pinch class enables the touch mode operations in IE browsers
            if (this._browser == "msie") {
                this.content().removeClass('e-pinch e-pan-x e-pan-y');
                if (this._vScrollbar && this._hScrollbar) this.content().addClass('e-pinch');
                else if (this._vScrollbar && !this._hScrollbar) this.content().addClass('e-pan-x');
                else if (this._hScrollbar && !this._vScrollbar) this.content().addClass('e-pan-y');
            }
        },
        _setDimension:function(){
            if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1) {
                if (!this._vScroll) $(this.content()[0]).height("");
                else this.model.height = this._convertPercentageToPixel(parseInt(this._eleHeight), this.element.parent().height());
            }
            if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1) {
                if (!this._hScroll) $(this.content()[0]).width("");
                else this.model.width = this._convertPercentageToPixel(parseInt(this._eleWidth), this.element.parent().width());
            }
        },
        _setScrollLeftValue: function (leftValue) {
            if (this.model.enableRTL) {
                if (ej.browserInfo().name == "mozilla")
                    leftValue = leftValue < 0 ? leftValue : (leftValue * -1);
                else if (!ej.isNullOrUndefined(this._rtlScrollLeftValue) && (ej.browserInfo().name == "chrome" || this._rtlScrollLeftValue > 0))
                    leftValue = leftValue < 0 ? (this._rtlScrollLeftValue + leftValue) : (this._rtlScrollLeftValue - leftValue);
                else
                    leftValue = Math.abs(leftValue);
            }
            this.content().scrollLeft(leftValue);
        },


        _ensureScrollers: function () {
            var jqVersion = $.fn.jquery, height, width;
          this.model.height = typeof this.model.height == "string" && this.model.height.indexOf("px") != -1 ? parseInt(this.model.height) : this.model.height;
          this.model.width = typeof this.model.width == "string" && this.model.width.indexOf("px") != -1 ? parseInt(this.model.width) : this.model.width;
            if (this.model.height) {
                this.element.height(this.model.height);
            }
            if (this.model.width) {
                this.element.width(this.model.width);
            }            

            this._off(this.content(), "mousedown touchstart");
            if (this.content().length > 0) {
                if (this.isVScroll()) {
                    if (!this._vScrollbar) {
                        this._vScrollbar = this._createScrollbar(ej.ScrollBar.Orientation.Vertical, this.isHScroll());
                    }
                    if (this.model.enableTouchScroll)
                        this._on(this.content(), "mousedown touchstart", { d: this._vScrollbar._scrollData }, this._mouseDownOnContent);
                } else {
                    this._vScrollbar = null;
                    this.element.children(".e-vscrollbar").remove();
                }
                if (this.isHScroll()) {
                    if (!this._hScrollbar) {
                        this._hScrollbar = this._createScrollbar(ej.ScrollBar.Orientation.Horizontal, this.isVScroll());
                    }
                    if (this.model.enableTouchScroll)
                        this._on(this.content(), "mousedown touchstart", { d: this._hScrollbar._scrollData }, this._mouseDownOnContent);
                } else {
                    this._hScrollbar = null;
                    this.element.children(".e-hscrollbar").remove();
                }

                if (!this._vScrollbar && !this._hScrollbar)
                    this.content().css({ width: "auto", height: "auto" });

                if (!(this.element.find(".e-hscroll").length > 0)) {
                    if (this._vScrollbar) {
                        this.content().outerHeight(this.content().outerHeight() - 1);
                    }
                }
                this._hScroll = this.isHScroll(), this._vScroll = this.isVScroll();
                if (this._hScroll || this._vScroll) {
                    this.content().addClass("e-content");
                    jqVersion === "1.7.1" || jqVersion === "1.7.2" ? (this._contentHeight = "height", this._contentWidth = "width") : (this._contentHeight = "outerHeight", this._contentWidth = "outerWidth");
                    var rect = this._exactElementDimension(this.element);
                    this._ElementHeight = rect.height - (this["border_bottom"] + this["border_top"] + this["padding_bottom"] + this["padding_top"]);
                    this.content()[this._contentHeight](this._ElementHeight - ((this._hScroll && !this.model.autoHide) ? this.model.scrollerSize : 0));
                    this._ElementWidth = rect.width - (this["border_left"] + this["border_right"] + this["padding_left"] + this["padding_right"]);
                    this.content()[this._contentWidth](this._ElementWidth - ((this._vScroll && !this.model.autoHide) ? this.model.scrollerSize : 0));
                    if ((isNaN(this._eleWidth) && (this._eleWidth.indexOf("%") > 0)) && (isNaN(this._eleHeight) && (this._eleHeight.indexOf("%") > 0))) $(window).on('resize', $.proxy(this._resetScroller, this));
                } else
                    this.content().removeClass("e-content");
                this._setDimension();
                this._parentHeight = $(this.element).parent().height(); this._parentWidth = $(this.element).parent().width();
            }
        },        
        _convertPercentageToPixel: function (ele, outer) {
            return Math.floor((ele * outer) / 100);
        },

        isHScroll: function () {
            if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1)
                return this.content()[0].scrollWidth > this.element.width();
            else {
                if (this.model.width > 0) {
                    var $paneObject = this.content().find(this.model.targetPane);
                    if (this.model.targetPane != null && $paneObject.length)
                        return ($paneObject[0].scrollWidth + $paneObject.siblings().width()) > this.model.width;
                    else {
                        if (this.content()[0].scrollWidth > this.model.width) return true;
                        else if (this.content()[0].scrollWidth == this.model.width)
                            if ($(this.content()[0]).find('> *').length > 0) return $(this.content()[0]).find('> *')[0].scrollWidth > this.model.width;
                        return false;
                    }
                }
                return false;
            }
            return false;
        },

        isVScroll: function () {
            //To avoid unnecessarilly render the vertical scrollbar for 1 or 2 px difference range.
            var border = 2;
            if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1)
                return this.content()[0].scrollHeight > this.element.outerHeight(); //this._convertPercentageToPixel(parseInt(this._eleHeight), this.element.parent().height());        
            else if (this.model.height > 0){
                if((this.content()[0].scrollHeight > this.model.height)) return true;
                else if(this.isHScroll()) if((this.content()[0].scrollHeight == this.model.height || (this.content()[0].scrollHeight > this.model.height - (this.model.scrollerSize - border)))) return true;
            }
            return false;
        },
        _setModel: function (option) {
            for (var prop in option) {
                switch(prop){
                    case "enableRTL":
                        if (option[prop]) {
                            this.element.addClass("e-rtl");
                            this._rtlScrollLeftValue = this.content().scrollLeft();
                            if(!ej.isNullOrUndefined(this._hScrollbar)) this._hScrollbar._scrollData.enableRTL = true;
                        
                        } else {
                            this.element.removeClass("e-rtl");
                            if (!ej.isNullOrUndefined(this._hScrollbar)) this._hScrollbar._scrollData.enableRTL = false;
                        }
                        if (this._hScrollbar) {
                            this.element.find(".e-hhandle").css("left", 0);
                            this._hScrollbar.value(0);
                        }
                        break;
                    case "scrollLeft":
                        if (parseFloat(ej.util.getVal(option[prop])) < 0 || !this._hScroll) option[prop] = 0;
                        this._externalCall = true;
                        if (this._hScrollbar) option[prop] = parseFloat(ej.util.getVal(option[prop])) > this._hScrollbar._scrollData.scrollable ? this._hScrollbar._scrollData.scrollable : parseFloat(ej.util.getVal(option[prop]));
                        this._setScrollLeftValue(parseFloat(option[prop]));
                        this["scrollLeft"](option[prop]);
                        if (this._hScrollbar && !(this._hScrollbar._scrollData._scrollleftflag && this.model.enableRTL))
                        this.scrollX(option[prop]);
                        break;
                    case "scrollTop":
                        if (this._vScrollbar) option[prop] = parseFloat(ej.util.getVal(option[prop])) > this._vScrollbar._scrollData.scrollable ? this._vScrollbar._scrollData.scrollable : parseFloat(ej.util.getVal(option[prop]));
                        if (parseFloat(option[prop]) < 0 || !this._vScroll) option[prop] = 0;
                        this._externalCall = true;
                        this.content().scrollTop(parseFloat(option[prop]));
                        this["scrollTop"](option[prop]);
                        this.scrollY(option[prop]);
                        break;
                    case "touchScroll" :
                        if (!this.model.enableTouchScroll)
                            this._off(this.content(), "mousedown touchstart");
                        else {
                            if (this._vScrollbar)
                                this._on(this.content(), "mousedown touchstart", { d: this._vScrollbar._scrollData }, this._mouseDownOnContent);
                            if (this._hScrollbar)
                                this._on(this.content(), "mousedown touchstart", { d: this._hScrollbar._scrollData }, this._mouseDownOnContent);
                        }
                        break;
                    case "scrollOneStepBy" : 
                        if (this._vScrollbar) {
                            this._vScrollbar._scrollData.scrollOneStepBy = option[prop];
                            this._vScrollbar.model.smallChange = option[prop];
                        }
                        if (this._hScrollbar) {
                            this._hScrollbar._scrollData.scrollOneStepBy = option[prop];
                            this._hScrollbar.model.smallChange = option[prop];
                        }
                        break;
                    case "buttonSize" :
                        if (this._vScrollbar) this._vScrollbar.model.buttonSize = this.model.buttonSize;
                        if (this._hScrollbar) this._hScrollbar.model.buttonSize = this.model.buttonSize;
                        this.refresh();
                        break;
                    case "height" : this._eleHeight = option[prop];
                        this.refresh();
                        break;
                    case "width" : this._eleWidth = option[prop];
                        this.refresh();
                        break;
					default:
						this.refresh();
                }
            }
        },

        _createScrollbar: function (orientation, isOtherScroll) {
            var proxy = this;
            var id, viewportSize, width, height, maximum, value;
            var div = document.createElement("div");
            if (orientation === ej.ScrollBar.Orientation.Vertical) {
                width = this.model.scrollerSize;
                if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1)
                    height = viewportSize = this.element.height() - (isOtherScroll ? this.model.scrollerSize : 0);
                else
                    height = viewportSize = this.model.height - (isOtherScroll ? this.model.scrollerSize : 0);
                maximum = this.content()[0]["scrollHeight"];
                value = this.scrollTop();
            }
            else {
                width = viewportSize = this.model.width - (isOtherScroll ? this.model.scrollerSize : 0);
                height = this.model.scrollerSize;
                if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1) {
                    width = viewportSize = this.element.width() - (isOtherScroll ? this.model.scrollerSize : 0);
                    maximum = this.content()[0]["scrollWidth"];
                }
                else {
                    var $pane = this.content().find(this.model.targetPane);
                    if (this.model.targetPane != null && $pane.length)
                        maximum = $pane[0]["scrollWidth"] + $pane.parent().width() - $pane.width();
                    else
                        maximum = this.content()[0]["scrollWidth"];
                }
                value = this.scrollLeft();
            }
            if (this.element.children(".e-hscrollbar").length > 0)
                $(this.element.children(".e-hscrollbar")).before(div);
            else
                this.element.append(div);
            $(div).ejScrollBar({
                elementHeight: proxy._eleHeight,
                elementWidth: proxy._eleWidth,
                buttonSize: proxy.model.buttonSize,
                orientation: orientation,
                viewportSize: viewportSize,
                height: height,
                width: width,
                maximum: maximum - viewportSize,
                value: value,
                smallChange: this.model.scrollOneStepBy,
                largeChange: 3 * this.model.scrollOneStepBy,
                scroll: ej.proxy(this._scrollChanged, this),
                thumbEnd: ej.proxy(this._thumbEnd, this),
                thumbStart: ej.proxy(this._thumbStart, this),
                thumbMove: ej.proxy(this._thumbMove, this),
            });
            var scrollbar = $(div).ejScrollBar("instance");
            (orientation === ej.ScrollBar.Orientation.Vertical || !isOtherScroll) && this._off(this.element, this._browser == "msie" ? "wheel mousewheel" : "mousewheel DOMMouseScroll", this._mouseWheel)
                ._on(this.element, this._browser == "msie" ? "wheel mousewheel" : "mousewheel DOMMouseScroll", { d: scrollbar._scrollData }, this._mouseWheel);
            if (orientation === ej.ScrollBar.Orientation.Horizontal) {
                this._scrollXdata = scrollbar._scrollData;
            }
            else
                this._scrollYdata = scrollbar._scrollData;
            if (orientation === ej.ScrollBar.Orientation.Horizontal && this.model.enableRTL) {
                scrollbar._scrollData.enableRTL = true;
            }
            scrollbar._enabled = this.model.enabled;
            return scrollbar;
        },

        _updateScrollbar: function (orientation, isOtherScroll) {
            var scrollbar = orientation === ej.ScrollBar.Orientation.Vertical ? this._vScrollbar : this._hScrollbar;
            if (scrollbar) {
                if (orientation === ej.ScrollBar.Orientation.Vertical) {
                    scrollbar.model.width = this.model.scrollerSize;
                    scrollbar.model.height = scrollbar.model.viewportSize = this.model.height - (isOtherScroll ? this.model.scrollerSize : 0);
                    scrollbar.model.maximum = this.content()[0]["scrollHeight"] - scrollbar.model.viewportSize;
                    scrollbar.model.value = this.scrollTop();
                }
                else {
                    scrollbar.model.width = scrollbar.model.viewportSize = this.model.width - (isOtherScroll ? this.model.scrollerSize : 0);
                    scrollbar.model.height = this.model.scrollerSize;
                    scrollbar.model.maximum = ((this.model.targetPane != null && this.content().find(this.model.targetPane).length >0) ? this.content().find(this.model.targetPane)[0]["scrollWidth"] + (this.content().width() - $(this.model.targetPane).outerWidth()) : this.content()[0]["scrollWidth"]) - scrollbar.model.viewportSize;
                    if (!this.model.enableRTL)
                        scrollbar.model.value = this.scrollLeft();
                }
            }
        },

        _autohide: function(){
            if (this.model.autoHide) {
                this.element.addClass("e-autohide");
                this._on(this.element, "mouseenter mouseleave touchstart touchend", this._scrollerHover);
                this.content().siblings(".e-scrollbar.e-js").hide();
            }
            else {
                this.element.removeClass("e-autohide");
                this._off(this.element, "mouseenter mouseleave touchstart touchend", this._scrollerHover);
                this.content().siblings(".e-scrollbar.e-js").show();
            }
        },

        _scrollChanged: function (e) {
            this._updateScroll = true;
            if (e.scrollTop !== undefined)
                this.scrollY(e.scrollTop, true, "", e.source);
            else if (e.scrollLeft !== undefined)
                this.scrollX(e.scrollLeft, true, "", e.source);
            this._updateScroll = false;
            var proxy = this;
            $.when(this.content()).done(ej.proxy(function () {
                proxy._trigger("scrollEnd", { scrollData: e });
            }));
        },
        _bindBlurEvent: function (scrollObj, e) {
            this._scrollEle = $(scrollObj).data('ejScrollBar');
            this._event = e; var proxy = this;
            this._listener = function (e) {
                this._scrollEle._off($(document), "mousemove touchmove", this._scrollEle._mouseMove);
                $(document).off("mouseup touchend", ej.proxy(this._scrollEle._mouseUp, this._scrollEle));
                this._scrollEle._prevY = null;
                this._off($(document), "mousemove touchmove", this._mouseMove);
                this._off($(document), "mouseup touchend", this._mouseUp);
                this._off($(window), "blur");
                if (this._evtData.handler === "e-vhandle") this._scrollEle._trigger("thumbEnd", { originalEvent: this._event, scrollData: this._evtData });
                else this._scrollEle._trigger("thumbEnd", { originalEvent: this._event, scrollData: this._evtData });
            };
            this._on($(window), "blur", this._listener);
        },
        _thumbStart: function (e) {
            this._evtData = e.scrollData;
            var scrollObj = e.scrollData.handler === "e-vhandle" ? this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar') : this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar'); var scrollObj = e.scrollData.handler === "e-vhandle" ? this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar') : this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar');            
            this._bindBlurEvent(scrollObj, e);
            this._trigger("thumbStart", e);            
        },
        _thumbMove: function (e) {
            this._trigger("thumbMove", e);            
        },
        _thumbEnd: function (e) {
            this._trigger("thumbEnd", e);
            this._off($(window), "blur");
        },

        refresh: function (needRefresh) {
			if(!needRefresh)
				this.element.find(">.e-content").removeAttr("style");

            if (!ej.isNullOrUndefined(this._eleHeight) && typeof this._eleHeight === "string" && this._eleHeight.indexOf("%") != -1 && this._parentHeight != $(this.element).parent().height()) {
               var element = this._exactElementDimension(this.element.parent());
               element = element.height - (this["border_bottom"] + this["border_top"] + this["padding_bottom"] + this["padding_top"]);
               this.model.height = this._convertPercentageToPixel(parseInt(this._eleHeight), element);
            }
            if (!ej.isNullOrUndefined(this._eleWidth) && typeof this._eleWidth === "string" && this._eleWidth.indexOf("%") != -1 && this._parentWidth != $(this.element).parent().width()) {
               var element = this._exactElementDimension(this.element.parent());
               element = element.width - (this["border_left"] + this["border_right"] + this["padding_left"] + this["padding_right"]);
               this.model.width = this._convertPercentageToPixel(parseInt(this._eleWidth), element);
            }

            this._ensureScrollers();
            var scrollLeftValue = this.scrollLeft();
            if (this.model.enableRTL) {
                !this.element.hasClass("e-rtl") && this.element.addClass("e-rtl");
                this._rtlScrollLeftValue = this.content().scrollLeft();
                scrollLeftValue > 0 ? this.content().scrollLeft(scrollLeftValue) : this._setScrollLeftValue(scrollLeftValue);
            }
            else
                this.content().scrollLeft(scrollLeftValue);
            if ((this.scrollTop() && this._vScrollbar == null) || (this._vScrollbar !== null && (this._vScrollbar && this._vScrollbar._scrollData != null) && !this._vScrollbar._scrollData.skipChange))
                this.content().scrollTop(this.scrollTop());

            if (this._vScrollbar) {
                this._vScrollbar._scrollData.dimension = "Height";
                this._updateScrollbar(ej.ScrollBar.Orientation.Vertical, this._hScroll);
                this._vScroll && !this._vScrollbar._calculateLayout(this._vScrollbar._scrollData) && this._vScrollbar._updateLayout(this._vScrollbar._scrollData);
            }
            if (this._hScrollbar) {
                this._hScrollbar._scrollData.dimension = "Width";
                this._updateScrollbar(ej.ScrollBar.Orientation.Horizontal, this._vScroll);
                this._hScroll && !this._hScrollbar._calculateLayout(this._hScrollbar._scrollData) && this._hScrollbar._updateLayout(this._hScrollbar._scrollData);
            }
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                this.element.find(".e-hhandle").css("left", "0px");
            else
                this.model.targetPane != null && this._on(this.content().find(this.model.targetPane), "scroll", this._scroll);
            this._addActionClass();
            this._autohide();
        },
        _exactElementDimension:function(element){
            var rect = element.get(0).getBoundingClientRect(), direction = ["left", "right", "top", "bottom"],width,height;
            rect.width ? width = rect.width : width = rect.right - rect.left;
            rect.height ? height = rect.height : height = rect.bottom - rect.top;
            for (var i = 0; i < direction.length; i++) {
                this["border_" + direction[i]] = isNaN(parseFloat(element.css("border-" + direction[i] + "-width"))) ? 0 : parseFloat(element.css("border-" + direction[i] + "-width"));
                this["padding_" + direction[i]] = isNaN(parseFloat(element.css("padding-" + direction[i]))) ? 0 : parseFloat(element.css("padding-" + direction[i]));
            }
            return rect = { width: width, height: height };
		},
        _keyPressed: function (action, target) {
            if (!this.model.enabled) return;
            if (["input", "select", "textarea"].indexOf(target.tagName.toLowerCase()) !== -1)
                return true;

            var d, iChar;

            if (["up", "down", "pageUp", "pageDown"].indexOf(action) !== -1) {
                if (this._vScrollbar) {
                    if (ej.browserInfo().name == "msie" && this.model.allowVirtualScrolling)
                        this._content.focus();
                    d = this._vScrollbar._scrollData;
                }
                iChar = "o";
            } else if (["left", "right", "pageLeft", "pageRight"].indexOf(action) !== -1) {
                if (this._hScrollbar)
                    d = this._hScrollbar._scrollData;
                iChar = "i";
            } else return true;
            if (!d) return true;

            return !this._changeTop(d, (action.indexOf(iChar) < 0 ? -1 : 1) * (action[0] !== "p" ? 1 : 3) * d.scrollOneStepBy, "key");
        },

        scrollY: function (pixel, disableAnimation, animationSpeed, source, e) {
            var proxy=this;
            if (pixel === "") return;
            if (disableAnimation) {
                var e = { source: source || "custom", scrollData: this._vScrollbar ? this._vScrollbar._scrollData : null, scrollTop: pixel, originalEvent: e };
                pixel = e.scrollTop;
                this.scrollTop(pixel);
				if (this._trigger("scroll", e)) return;                
                this.content().scrollTop(pixel);
                return;
            }
            if (ej.isNullOrUndefined(animationSpeed) || animationSpeed === "") animationSpeed = 100;
            if (this._vScrollbar) pixel = parseFloat(pixel) > this._vScrollbar._scrollData.scrollable ? this._vScrollbar._scrollData.scrollable : parseFloat(pixel)
            this.scrollTop(pixel);
            this.content().stop().animate({
                scrollTop: pixel
            }, animationSpeed, 'linear',function(){
            if (proxy._trigger("scroll", { source: source || "custom", scrollData: proxy._vScrollbar ? proxy._vScrollbar._scrollData : null, scrollTop: pixel, originalEvent: e })) return;      
	   })
        },

        scrollX: function (pixel, disableAnimation, animationSpeed, source, e) {   
            var proxy=this;		
            if (pixel === "") return;
            if (this._hScrollbar) pixel = parseFloat(pixel) > this._hScrollbar._scrollData.scrollable ? this._hScrollbar._scrollData.scrollable : parseFloat(pixel)
            this._externalCall = true;
            var browserName = ej.browserInfo().name;
            if (this.model.enableRTL && browserName != "mozilla") {
                if (pixel < 0) pixel = Math.abs(pixel);
                var content = this.model.targetPane != null ? this.content().find(this.model.targetPane)[0] : this.content()[0];
                if (e != "mousemove" && e != "touchmove" && (browserName != "msie")) if (browserName != "msie") pixel = this._hScrollbar._scrollData.scrollable - pixel;
            }
            this.scrollLeft(pixel);
            if (disableAnimation) {
                if (this._trigger("scroll", { source: source || "custom", scrollData: this._hScrollbar ? this._hScrollbar._scrollData : null, scrollLeft: pixel, originalEvent: e }))
                    return;
                if (this.model.targetPane != null && this.content().find(this.model.targetPane).length)
                    this.content().find(this.model.targetPane).scrollLeft(pixel);
                else
                    this.content().scrollLeft(pixel);
                return;
            }
            if (ej.isNullOrUndefined(animationSpeed) || animationSpeed === "") animationSpeed = 100;
            if (this.model.targetPane != null && this.content().find(this.model.targetPane).length)
                this.content().find(this.model.targetPane).stop().animate({
                    scrollLeft: pixel
                }, animationSpeed, 'linear');
            else this.content().stop().animate({
                scrollLeft: pixel
            }, animationSpeed, 'linear',function() {
            if (proxy._trigger("scroll", { source: source || "custom", scrollData: proxy._hScrollbar ? proxy._hScrollbar._scrollData : null, scrollLeft: pixel, originalEvent: e })) return;
			});
        },

        enable: function () {
            var scroller = this.element.find(".e-vscrollbar,.e-hscrollbar,.e-vscroll,.e-hscroll,.e-vhandle,.e-hhandle,.e-vscroll .e-icon,.e-hscroll .e-icon");
            if (scroller.hasClass("e-disable")) {
                scroller.removeClass("e-disable").attr({ "aria-disabled": false });
                this.model.enabled = true;
            }
            if (this._vScrollbar)
                this._vScrollbar._enabled = this.model.enabled;
            if (this._hScrollbar)
                this._hScrollbar._enabled = this.model.enabled;
        },

        disable: function () {
            var scroller = this.element.find(".e-vscrollbar,.e-hscrollbar,.e-vscroll,.e-hscroll,.e-vhandle,.e-hhandle,.e-vscroll .e-icon,.e-hscroll .e-icon");
            scroller.addClass("e-disable").attr({ "aria-disabled": true });
            this.model.enabled = false;
            if (this._vScrollbar)
                this._vScrollbar._enabled = this.model.enabled;
            if (this._hScrollbar)
                this._hScrollbar._enabled = this.model.enabled;
        },

        _changeTop: function (d, step, source, e) {
            var start =Math.ceil(this.model.targetPane != null && d.dimension != "height" ? this.content().find(this.model.targetPane)[d.scrollVal]() : this.content()[d.scrollVal]()), t;

            if (d.dimension == "height" && start == 0)
                start = this.scrollTop() != 0 ? this.scrollTop() : 0;
            t = start + step;
            if (!d.enableRTL ? t > d.scrollable : t < d.scrollable) t = Math.round(d.scrollable);
            if (!d.enableRTL ? t < 0 : t > 0) t = 0;

            if (t !== start) {
                this["scroll" + d.xy](t, true, "", source, e);
                if (d.xy === "X" && !ej.isNullOrUndefined(this._hScrollbar))
                    this._hScrollbar["scroll"](t, source, true, e);
                else if (!ej.isNullOrUndefined(this._vScrollbar))
                    this._vScrollbar["scroll"](t, source, true, e);
            }

            return t !== start;
        },

        _mouseWheel: function (e) {
			 if (this._vScrollbar && e.ctrlKey )
                    return;
            if (!this._vScrollbar && !e.shiftKey )
                    return;
            if (!e.data || !this.model.enabled) return;
            var delta = 0, data = e.data.d, ori = e, direction;
            e = e.originalEvent;
            this._wheelStart && this._trigger("wheelStart", { originalEvent: e, scrollData: ori.data.d });
            this._wheelStart = false;
            clearTimeout($.data(this, 'timer'));
            if (this._wheelx != 1 && (e.wheelDeltaX == 0 || e.wheelDeltaY == 0))
                this._wheelx = 1;
            if (navigator.platform.indexOf("Mac") == 0 && (this._wheelx == 0)) {
                if (this._browser == "webkit" || this._browser == "chrome")
                    return true;
            }
            if (this._browser == "mozilla")
                e.axis == e.HORIZONTAL_AXIS ? data = this._scrollXdata : this._scrollYdata;
            else if (this._browser == "msie") {
                if ((e.type == "wheel")) delta = e.deltaX / 120;
                if ((e.type == "mousewheel" && e.shiftKey)) {
                    data = this._scrollXdata;
                    e.preventDefault ? e.preventDefault() : (e.returnValue = false);
                }
            }
            else if (this._wheelx && e.wheelDeltaX != 0 && e.wheelDeltaY == 0 && this._scrollXdata)
                data = this._scrollXdata;
            if (e.wheelDeltaX == 0) this._wheelx = e.wheelDeltaX;
            if (e.wheelDelta) {
                delta = navigator.platform.indexOf("Mac") == 0 ? -e.wheelDelta / 3 : -e.wheelDelta / 120;
                if (window.opera) {
                    if (parseFloat(window.opera.version, 10) < 10)
                        delta = -delta;
                }
            } else if (e.detail) delta = e.detail / 3;
            if (!delta) return;            
            if ((ori.originalEvent))
                if (ori.originalEvent.wheelDelta && ori.originalEvent.wheelDelta > 0 || ori.originalEvent.detail && ori.originalEvent.detail < 0) direction = -1;
                else direction = 1;
            if (this._changeTop(data, delta * data.scrollOneStepBy, "wheel", e)) {
                e.preventDefault ? e.preventDefault() : ori.preventDefault();
                ori.stopImmediatePropagation();
                ori.stopPropagation();
                this._trigger("wheelMove", { originalEvent: e, scrollData: ori.data.d, direction: direction });
            }
            else {
                this._trigger("scrollEnd", { originalEvent: e, scrollData: ori });
                this._wheelx = 0;
            }
            var proxy = this;
            $.data(this, 'timer', setTimeout(function () {
                proxy._wheelStart = true;
                proxy._trigger("wheelStop", { originalEvent: e, scrollData: ori.data.d, direction: direction });
            }, 250));
        },
        _contentHeightWidth: function () {
            if (this.content().siblings().css("display") == "block" && this.model.autoHide && this._hScroll) {
                this.content()[this._contentHeight](this._ElementHeight - (this.model.scrollerSize));
                this.content()[this._contentWidth](this._ElementWidth - (this.model.scrollerSize));
            }
            else if (this.content().siblings().css("display") == "none" && this.model.autoHide &&this._vScroll) {
                this.content()[this._contentHeight](this._ElementHeight);
                this.content()[this._contentWidth](this._ElementWidth);
            }
        },
        _scrollerHover: function (e) {
            if (this.model.enabled) {
                if ((e.type == "mouseenter" || e.type == "touchstart") && !this.content().siblings().is(":visible")) {

                    this.content().siblings().css("display", "block");
                    this._contentHeightWidth();
                    this._trigger("scrollVisible", { originalEvent: e });
                }
                else if (e.type == "mouseleave" || e.type == "touchend") {
                    this.content().siblings().hide();
                    this._contentHeightWidth();
                    this._trigger("scrollHide", { originalEvent: e });
                }
            }
        },

        _mouseUp: function (e) {
            if (!e.data) return;
            var d = e.data.d;
            if (e.type === "mouseup" || e.type === "touchend" || (!e.toElement && !e.relatedTarget)) {
			    this.content().css("cursor", "default");
                this._off($(document), "mousemove touchmove");
                this._off($(document), "mouseup touchend", this._mouseUp);
                d.fromScroller = false;
                if (this._mouseMoved === true && e.data.source === "thumb" && !ej.isNullOrUndefined(this.model)) {
                    $.when(this.content()).done(ej.proxy(function () {
                        this._trigger("thumbEnd", { originalEvent: e, scrollData: d });
                    }, this));
                    this._off($(window), "blur");
                }
            }
            d.up = true;
        },

        _mouseDownOnContent: function (down) {
            this._startX = (down.clientX != undefined) ? down.clientX : down.originalEvent.changedTouches[0].clientX;
            this._startY = (down.clientY != undefined) ? down.clientY : down.originalEvent.changedTouches[0].clientY;
            this._timeStart = down.timeStamp || Date.now();
            if (!this.model.enabled) return;
            var d = down.data.d;
            this._evtData = down.data;
            var scrollObj = d.handler === "e-vhandle" ? this.element.find('.' + d.handler).closest('.e-scrollbar') : this.element.find('.' + d.handler).closest('.e-scrollbar');            
            this._bindBlurEvent(scrollObj, down);
            if (this._trigger("thumbStart", { originalEvent: down, scrollData: d }))
                return;
		    if (down.which == 3 && down.button == 2) return;
            d.fromScroller = true;
            var prevY = null, skip = 1, min = 5, direction;
            this._document = $(document); this._window = $(window);
            this._mouseMove = function (move) {
                this._relDisX = ((move.clientX != undefined) ? this._startx = move.clientX : this._startx = move.originalEvent.changedTouches[0].clientX) - this._startX;
                this._relDisY = ((move.clientY != undefined) ? this._starty = move.clientY : this._starty = move.originalEvent.changedTouches[0].clientY) - this._startY;
                this._duration = (move.timeStamp || Date.now()) - this._timeStart;
                this._velocityY = Math.abs(this._relDisY) / this._duration;
                this._velocityX = Math.abs(this._relDisX) / this._duration;
                move.preventDefault();
                if (!ej.isNullOrUndefined(move.target.tagName) && move.target.tagName.toLowerCase() === "iframe") {
                    move.type = "mouseup";
                    this._mouseUp(move);
                    return;
                }
                var pageXY = move.type == "mousemove" ? move[d.clientXy] : move.originalEvent.changedTouches[0][d.clientXy];
                if (prevY && pageXY !== prevY) {
                    this._mouseMoved = true;
                    var diff = pageXY - prevY, sTop = this.model[d.scrollVal] - (diff);

                    if (skip == 1 && Math.abs(diff) > min) {
                        direction = d.position;
                        skip = 0;
                    }
                    if (skip == 0) prevY = pageXY;

                    if (sTop >= 0 && sTop <= d.scrollable && direction === d.position) {
                        var top = this._velocityY > 0.5 && this._duration < 50 && d.position == "Top";
                        var left = this._velocityX > 0.5 && this._duration < 50 && d.position == "Left";
                        var swipeXY = ((this._velocityY > 0.5) || (this._velocityX > 0.5)) && this._duration < 50;
                        if (swipeXY) {
                            if (top) {
                                sTop = Math.abs(this._relDisY) + (this._duration * this._velocityY);
                                if (this._startY > this._starty) {
                                    sTop += this.scrollTop();
                                    if (sTop > d.scrollable) sTop = d.scrollable;
                                }
                                else {
                                    if (sTop < this.scrollTop()) sTop = Math.abs(sTop - this.scrollTop());
									if(sTop>this.scrollTop())								
									sTop=0;								
                                }
                                if (this.scrollTop() <= d.scrollable) this["scrollY"](sTop, false, this.model.animationSpeed, "thumb");
                            }
                            else if (left) {
                                sTop = Math.abs(this._relDisX);
                                if (this._startX > this._startx) {
                                    sTop += this.scrollLeft();
                                    if (sTop > d.scrollable) sTop = d.scrollable;
                                }
                                else {
                                    sTop -= this.scrollLeft();
                                    sTop = Math.abs(sTop);
                                    if (sTop > d.scrollable || sTop >= this.scrollLeft()) sTop = 0;
                                }
                                if (this.scrollLeft() <= d.scrollable) this["scrollX"](sTop, false, this.model.animationSpeed, "thumb");
                            }
                        }
                        else {
                            this["scroll" + d.xy](sTop, true, "", "thumb",move.type);
                            if (d.xy === "X")
                                this._hScrollbar["scroll"](sTop, "thumb", true,move.type);
                            else if (!ej.isNullOrUndefined(this._vScrollbar))
                                this._vScrollbar["scroll"](sTop, "thumb", true,move.type);
                            this.content().css("cursor", "pointer");
                            this._trigger("thumbMove", { originalEvent: move, scrollData: d });
                        }
                    }
                }
                if (prevY == null) prevY = pageXY;
                if (Math.abs(this._relDisX) > Math.abs(this._relDisY))
                    this._swipe = (this._relDisX < 0) ? "left" : "right";
                else 
                    this._swipe = (this._relDisY < 0) ? "up" : "down";
                if (((Math.round(this._content["scrollTop"]()) == 0) && this._swipe == "down" || ((Math.ceil(this._content["scrollTop"]()) == d.scrollable) && this._swipe == "up"))) {
                    this._trigger("scrollEnd", { originalEvent: move.originalEvent, scrollData: move });
                    if (window.removeEventListener) window.removeEventListener('DOMMouseScroll', this._preventDefault, false);

                    window.ontouchmove = null;
                }
                else if (move.data.d.clientXy == "pageY") {
                    if (window.addEventListener) window.addEventListener('DOMMouseScroll', this._preventDefault, false);

                    window.ontouchmove = this._preventDefault; // mobile
                } 
            }
            this._on($(document), "mousemove touchmove", { d: d, source: "thumb" }, this._mouseMove);
            this._mouseMoved = false;
            this._on($(document), "mouseup touchend", { d: d, source: "thumb" }, this._mouseUp);
        },
		
        _scroll: function (e) {
            var dS = [this._vScrollbar ? this._vScrollbar._scrollData : null, this._hScrollbar ? this._hScrollbar._scrollData : null];

            for (var i = 0; i < 2; i++) {
                var d = dS[i];
                if (!d || d.skipChange) continue;
                if(!this._externalCall) d.dimension === "height" ? this.scrollTop(e.target[d.scrollVal]) : this.scrollLeft(e.target[d.scrollVal])
                if (this.model && this.model.targetPane != null && i == 1 && this.content().find(this.model.targetPane).length)
                    d.sTop = this.content().find(this.model.targetPane)[0][d.scrollVal];
                else d.scrollVal == "scrollTop" ? d.sTop = this.scrollTop() : d.sTop = this.scrollLeft();
                this[d.scrollVal](d.sTop);
                if (d.fromScroller) return;
                if (i === 1) {
                    var content = this.content()[0];
                    if (this._rtlScrollLeftValue && content.scrollWidth - content.clientWidth != this._rtlScrollLeftValue)
                        this._rtlScrollLeftValue = content.scrollWidth - content.clientWidth;
                    d.sTop = (this.model && ej.browserInfo().name != "mozilla" && this.model.enableRTL && !this._hScrollbar._scrollData._scrollleftflag) ? (this._rtlScrollLeftValue == 0 ? (d.sTop * -1) : (d.sTop - this._rtlScrollLeftValue)) : d.sTop;
                    this._hScrollbar["scroll"](d.sTop, "", true);
                } else
                    this._vScrollbar["scroll"](d.sTop, "", true);
                if (dS.length == 2 && i == 1 || dS.length == 1 && i == 0) this._externalScroller = false;
            }
        },

        _changevHandlerPosition: function (top) {
            var scrollbar = this._vScrollbar;
            if (scrollbar) {
                top = scrollbar._scrollData != null && top >= scrollbar._scrollData.scrollable ? scrollbar._scrollData.scrollable : top;
                if (scrollbar != null && top >= 0 && top <= scrollbar._scrollData.scrollable)
                    scrollbar[scrollbar._scrollData.handler].css(scrollbar._scrollData.lPosition, (top / scrollbar._scrollData.onePx) + "px");
            }
        },

        _changehHandlerPosition: function (left) {
            var scrollbar = this._hScrollbar;
            if (scrollbar) {
                left = scrollbar._scrollData != null && left >= scrollbar._scrollData.scrollable ? scrollbar._scrollData.scrollable : left;
                if (scrollbar != null && top >= 0 && left <= scrollbar._scrollData.scrollable)
                    scrollbar[scrollbar._scrollData.handler].css(scrollbar._scrollData.lPosition, (left / scrollbar._scrollData.onePx) + "px");
            }
        },

        _destroy: function () {
            this.element.css({ "width": "", "height": "" }).find(".e-vscrollbar,.e-hscrollbar").remove();
            this.content().removeClass("e-content").css({ "width": "", "height": "" });
        },
        _preventDefault: function (e) {
            e = e || window.event;
            if (e.preventDefault) e.preventDefault();

            e.returnValue = false;
        } 
    });
})(jQuery, Syncfusion, window);;
/**
* @fileOverview Plugin to style the Html NavigationDrawer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejNavigationDrawerBase", "ej.NavigationDrawerBase", {

        defaults: {

            contentId: null,

            cssClass: "",

            direction: "left",

            targetId: null,

            position: "normal",

            enableListView: false,

            listViewSettings: {},

            type: "overlay",

            width: "auto",

            swipe: null,

            open: null,

            beforeClose: null,

            items: [],

            ajaxSettings: {

				type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true

            },

            ajaxSuccess: null,

            ajaxError: null,

			ajaxComplete: null
        },

        dataTypes: {
            direction: "enum",
            type: "enum",
            ajaxSettings: "data"
        },

        loadContent: function (content ,link) {
            var proxy = this;
			if(link.indexOf("#") == 0) {
				var _link = $(link)[0] && $(link)[0].nodeName && $(link)[0].nodeName.toLowerCase() == "script" ? ej.getClearString($(link)[0].innerHTML) : link;
				if(_link != $(link)) {
					if($(_link).length != 0)
						this._scriptTemplate.push({id:link,data:$(_link)});
					else {
						var result = $.grep(this._scriptTemplate, function(e){ if(e.id == _link) return e.data; });
						_link = (result.length >0 )?result[0].data[0]:_link;
					}
				}
				$(content).html($(_link));
				this._hide();
			}
			else {
				var ajaxOptions = {

					url:link,

					"success": function (data) {
						try { 
							$(content).html(data);
                            proxy._trigger("ajaxSuccess", { data: data, url: link ,content: content});
							proxy._hide();
							
						}
						catch (e) { }
					},
					"error": function (e) {
						try { 
                            proxy._trigger("ajaxError", {data:{ "status": e.status, "responseText": e.responseText, "statusText": e.statusText },content: content,url: link});
							proxy._hide();
							}
						catch (e) { }
					},
					"complete": function (e) {
						 try {
							 proxy._trigger("ajaxComplete", {data:e, content: content, url: link });
                    } catch (e) {}
					}
				};
				this._sendAjaxRequest(ajaxOptions);
			}
        },
        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },
		_shadowWrapper: function () {
			if (!this.model.isPaneOpen) {
                this._elementOverlay = ej.buildTag("div#" + this._id + "_Overlay", {}, {}, { "class": this._rootCSS + " " + this._prefixClass + "nb-layout " + this._prefixClass + "nb-overlay" });
                this._elementShadow = ej.buildTag("div#" + this._id + "_shadow", {}, {}, { "class": this._rootCSS + " " + this._prefixClass + "nb-shadow " + "" + this._prefixClass + "nb-type-" + (this.model.type == "slide" ? "slide" : "overlay") });
                this._nbHome.append(this._elementOverlay);
                this._elementOverlay.hide();
                this.element.hide();
				this.element.prepend(this._elementShadow);
            }
		},
        _renderControl: function () {
            if (this.model.position.toLowerCase() == "fixed")
                this.element.appendTo(this._nbHome);
			this._shadowWrapper();
            this.element.addClass(this._prefixClass + "user-select" + " " + this.model.cssClass);
            this.element.addClass(this._prefixClass + 'nb-layout ' + (this.model.direction.toLowerCase() == "left" ? this._prefixClass + 'nb-left' : this._prefixClass + 'nb-right'));
            this.element.addClass(this._prefixClass + 'nb-type-' + (this.model.type == "slide" ? "slide" : "overlay"));
            this._maxIndex = this._getMaxZindex();
            this._parentWidth = this._nbHome.width();
            this._setWidth();
            this._setLayout();
        },
        _getMaxZindex: function () {
            return Math.max.apply(null, $.map($('body *'), function (e, n) {
                return parseInt($(e).css('z-index')) + 1 || 1;
            }));
        },
        _transform: function (dist, time, element) {
            var translate = "-" + this._browser + "-transform",
                translateVal = "translateX(" + dist + "px) translateZ(0px)";
            var trans = "-" + this._browser + "-transition-property",
            transVal = "transform",
            transDur = "-" + this._browser + "-transition-duration",
            transDurVal = time + "ms";
            if (element) {
                var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                if (this.model.position == "normal" && this.model.type=="slide")
                    $("#" + this._id + "_WrapContainer").addClass("e-nb-normal");
                this.element.addClass("" + this._prefixClass + "nb-animate" + " " + positionClass);
                this.element.css(trans, transVal).css(transDur, transDurVal).css(translate, translateVal);
				this.element.css("transition-property", transVal).css("transition-duration", transDurVal).css("transform", translateVal);
            }
            else {
                var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                if (this.model.position == "normal" && this.model.type == "slide")
                    $("#" + this._id + "_WrapContainer").addClass("e-nb-normal");
                this._nbHome.addClass(this._rootCSS + " " + this._prefixClass + "nb-animate" + " " + positionClass);
                this._nbHome.css(trans, transVal).css(transDur, transDurVal).css(translate, translateVal);
				this._nbHome.css("transition-property", transVal).css("transition-duration", transDurVal).css("transform", translateVal);
            }
        },

        _show: function () {
            if (!ej.isNullOrUndefined(this.element.css("left").match((/\d/g))) && (!Number(this.element.css("left").match((/\d/g))[0] < this.element.width()))) this._setLayout();
            if ($("." + this._prefixClass + "nb-opened").length && $("." + this._prefixClass + "nb-opened")[0] != this.element[0])
                $("." + this._prefixClass + "nb-opened").ejNavigationDrawer("close");
            this.element.show();
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionOpenHandler, false, this);
            this.element.addClass("" + this._prefixClass + "nb-opened");
            this._elementOverlay.css("z-index", this._maxIndex * 2);
            this.element.css("z-index", this._maxIndex * 3);
            if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9))
                this.model.direction == "left" ? this._transform($(this.element).width(), 400, this._isTransitionElement()) : this._transform(-($(this.element).width()), 400, this._isTransitionElement());
            else
                $(this.element).show().animate({ "left": (this.model.direction == "left" ? "0px" : (this._parentWidth - $(this.element).width())) }, 400, $.proxy(this._transitionOpenEnd, this));
            this._data = { element: this.element };
            this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : null;
            this._elementOverlay.show();
            this._trigger("open", this._data);
        },

        _hide: function () {
            this._elementOverlay.hide();
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionCloseHandler, false, this);
            this.element.removeClass("" + this._prefixClass + "nb-opened");
            if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9))
                this._transform(0, 400, this._isTransitionElement());
            else
                $(this.element).animate({ "left": (this.model.direction == "left" ? -($(this.element).width()) : this._nbHome.width()) }, 400, $.proxy(this._transitionCloseEnd, this));
        },
        _clearHomeElement: function () {
            var browSpec = "";
            if (this._browser != "")
                browSpec = '-' + this._browser + '-';
            var translate = browSpec + "transform";
            var trans = browSpec + "transition-property";
            var transDur = browSpec + "transition-duration";
            this._nbHome.css(translate, "").css(transDur, "").css(trans, "");
            var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
            this._nbHome.removeClass(this._rootCSS + " " + this._prefixClass + "nb-animate" + " " + positionClass);
        },

        _isOpened: function () {
            return this.element.hasClass("" + this._prefixClass + "nb-opened");
        },

        _isOtherOpened: function () {
            return $("." + this._prefixClass + "nb-opened").length;
        },

        _isTransitionElement: function () {
            return this.model.type == "overlay" ? true : false;
        },

        _isOrientationSupported: function () {
            return ("orientation" in window && "onorientationchange" in window);
        },

        _setWidth: function () {
            $(this._nbHome).width() < 500 ? this.element.css("maxwidth", "80%") : this.element.css("maxwidth", "40%");
            if (this.model.width != "auto" && Number(this.model.width) != 0)
                this.element.width(Number(this.model.width));
            this.element.height("100%");
        },

          _setLayout: function () {
            this.element.show();
            this.element.find('.' + this._prefixClass + 'list-container').removeClass("e-scroller");
            if (this.model.position == "fixed")
                this.element.css("min-height", window.innerHeight);
            if (this.model.direction.toLowerCase() == "left") {
                $("#" + this._id + "_WrapContainer").css({ right: "" }).removeClass("e-nb-right").addClass("e-nb-left");
                this.element.removeClass("e-nb-right").addClass("e-nb-left");
                if (!this.model.isPaneOpen) {
                    if (this.model.position == "normal")
                        this.element.css({ right: "", left: this.model.type == "overlay" ? (-(ej.getDimension(this.element, "width"))) : "0px" });
                    else
                        this.element.css({ right: "", left: (-(ej.getDimension(this.element, "width"))) });
                    if (this.model.type == "slide")
                        $("#" + this._id + "_WrapContainer").removeAttr("style").css({ left: (-(ej.getDimension(this.element, "width"))) })
                }
                else {
                    var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                    this.element.css({ "right": "", "left": this.model.position == "fixed" ? -ej.getDimension(this.element, "width") : 0 });
                    this._nbHome.css({ "width": this._nbHome.parent().width() - ej.getDimension(this.element, "width"), "left": ej.getDimension(this.element, "width"), "position": "absolute" }).addClass(positionClass);
                }
            }
            else {
                $("#" + this._id + "_WrapContainer").css({ left: "" }).removeClass("e-nb-left").addClass("e-nb-right");
                this.element.css({ left: "" }).removeClass("e-nb-left").addClass("e-nb-right");
                if (!this.model.isPaneOpen) {
                    var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                    this._nbHome.removeClass("e-nb-fixed-slide" + " " + positionClass);
                    $("#" + this._id + "_WrapContainer").removeClass("e-nb-left").addClass("e-nb-right");
                    if (this.model.type == "slide")
                        $("#" + this._id + "_WrapContainer").removeAttr("style").css({ right: "0px" });
                    if (this.model.position.toLowerCase() == "fixed" && this.model.type == "slide")
                        this._nbHome.addClass("e-nb-fixed-slide");
                    if (this.model.position.toLowerCase() == "fixed" && this.model.type == "overlay")
                        this.element.addClass(positionClass);
                    if (this.model.position.toLowerCase() == "normal")
                        this.element.css({ left: ej.getDimension(this.element, "width") });
                    else
                        this.element.css({ right: -ej.getDimension(this.element, "width") });
                }
                else {
                    var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                    this._nbHome.css({"left": "","position":"", "width": ej.getDimension(this._nbHome.parent(), "width") - ej.getDimension(this.element, "width") }).addClass(positionClass);
                    this.element.css({ "left": "", "right": "0px" });
                }
            }
            if (!this._isOpened() && !this.model.isPaneOpen)
                this.element.hide();
        },

        _destroy: function (isSetModel) {
            this._wireEvents(true);
            if (this._elementOverlay)
                this._elementOverlay.remove();
            if (this._elementShadow)
                this._elementShadow.remove();
            if (this._elementWrapper) this.element.unwrap();
            this.element.removeAttr("style");
            this.element.css("left", "");
            this._destroyEJMPlugin();
            if(!isSetModel) this.element.removeClass("e-nb e-user-select e-nb-layout e-nb-left e-nb-type-overlay e-nb-animate e-nb-opened");
        },

        _refresh: function () {
            this._destroy(true);
            this._load();
            this._renderControl();
            this._renderEJMControls();
            this._createDelegate();
            this._wireEvents();
        },


        _createDelegate: function () {
            //Swipe Events Handler
            this._swipeStartHandler = $.proxy(this._swipeStart, this);
            this._swipeEndHandler = $.proxy(this._swipeEnd, this);
            this._swipeMoveHandler = $.proxy(this._swipeMove, this);
            //Touch Event Handler
            this._touchMoveHandler = $.proxy(this._touchMove, this);
            this._touchEndHandler = $.proxy(this._touchEnd, this);
            //Transition Event
            this._transitionOpenHandler = $.proxy(this._transitionOpenEnd, this);
            this._transitionCloseHandler = $.proxy(this._transitionCloseEnd, this);
            //Target Touch Event Handler
            this._overlayTapHandler = $.proxy(this._elementOverlayTap, this);
            //TargetButton Tap
            this._targetButtonTapHandler = $.proxy(this._targetButtonTap, this);
            // Size Event Handler
            this._onOrientationChangeHandler = $.proxy(this._onOrientationChangeEvent, this);
            this._onResizeEventHandler = $.proxy(this._onResizeEvent, this);
        },

        _wireEvents: function (remove) {
            if (!this.model.isPaneOpen || remove) {
                //Event Binding
                if (this.model.targetId) {
                    if (ej.getCurrentPage)
                        var ele = ej.getCurrentPage();
                    else
                        var ele = $("body");
                    ej.listenTouchEvent(ele.find("#" + this.model.targetId), (this._prefixClass == "e-" ? "click" : ej.endEvent()), this._targetButtonTapHandler, remove, this);
                }
                else {
                    if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8))
                        ej.listenTouchEvent(this._nbHome, ej.startEvent(), this._swipeStartHandler, remove, this);
                }
                //Ovelay Binding
                ej.listenTouchEvent(this._elementOverlay, ej.endEvent(), this._overlayTapHandler, remove, this);
            }
            if (this.model.isPaneOpen) {
                if (ej.isTouchDevice() && this._isOrientationSupported())
                    ej.listenTouchEvent(window, "orientationchange", this._onOrientationChangeHandler, remove, this);
                else
                    ej.listenTouchEvent(window, "resize", this._onResizeEventHandler, remove, this);
            }
        },
        _onResizeEvent: function (e) {
            var state;
            this.element.show();
            if (this._isOpened() && this.element.is(":visible") && !this.model.isPaneOpen) { state = "opened "; } else { state = "closed" }
            this._transform(0, 0, this._isTransitionElement());
            this.element.hide();
            this.element.removeClass("" + this._prefixClass + "nb-opened");
            this._clearHomeElement();
            this._parentWidth = this._nbHome.width();
            this._setWidth();
            this._setLayout();
            if (state == "opened ") { this._show(); }
        },
        _onOrientationChangeEvent: function (e) {
            var state;
            this.element.show();
            if (this._isOpened() && this.element.is(":visible")) { state = "opened "; } else { state = "closed" }
            if (window.orientation == 0 || window.orientation == 180 || window.orientation == 90) { window.scrollTo(0, 0); }
            this._transform(0, 0, this._isTransitionElement());
            this.element.hide();
            this.element.removeClass("" + this._prefixClass + "nb-opened");
            this._parentWidth = this._nbHome.width();
            this._clearHomeElement();
            var proxy = this
            setTimeout(function () {
                proxy._setWidth();
                proxy._setLayout();
                if (state == "opened ") { proxy._show(); }
            }, 300);
        },
        _transitionCloseEnd: function () {
            if(!ej.isNullOrUndefined(this.element)) this.element.hide();
            this._clearHomeElement();
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionCloseHandler, true, this);
            if(this._lbObj)
                this.model.listViewSettings.selectedItemIndex = this._lbObj.model.selectedItemIndex;
        },
        _transitionOpenEnd: function () {
            if (!ej.isNullOrUndefined(this.element)) this.element.show();
            if (this._scrollbar)
                this._scrollbar.ejmScrollPanel("refresh");
            if (this._lbscrollbar)
                this._lbscrollbar.ejmScrollPanel("refresh");
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionOpenHandler, true, this);
        },

        _targetButtonTap: function (e) {
            e.preventDefault();
            if (!this._isOtherOpened()) this._show();
        },
        _elementOverlayTap: function (e) {
            ej.blockDefaultActions(e);
            this._data = { element: this.element };
            this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : undefined;
            this._trigger("beforeclose", this._data);
            this._hide();
        },

        _swipeStart: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            this._startSwipeOffsetX = point.clientX - this._nbHome.offset().left;
            this._startSwipeOffsetActualX = point.clientX;
            this._startSwipeOffsetY = point.clientY;
            this._containerX = this._isTransitionElement() ? this.element.offset().left : this._nbHome.offset().left;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._swipeMoveHandler, false, this);
            ej.listenTouchEvent(this._nbHome, ej.endEvent(), this._swipeEndHandler, false, this);
        },

        _swipeMove: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            if (!ej.isNullOrUndefined(this.element.css("left").match((/\d/g))) && Number(this.element.css("left").match((/\d/g))[0]) < this.element.width()) this._setLayout();
            if (this._startSwipeOffsetActualX && this._startSwipeOffsetActualX > (point.clientX)) { this._swipeDirection = "right"; }
            else { this._swipeDirection = "left"; }
            var allowOpDirection = this._isOpened() ? (this._swipeDirection != this.model.direction.toLowerCase() ? true : false) : false;
            if (!allowOpDirection) {
                if (this._swipeDirection == this.model.direction.toLowerCase() && !this._isOtherOpened()) {
                    ej.listenEvents([this._nbHome, this._nbHome, this._nbHome], [ej.moveEvent(), ej.endEvent()], [this._touchMoveHandler, this._touchEndHandler], false, this);
                }
                else {
                    ej.listenEvents([this._nbHome, this._nbHome, this._nbHome], [ej.moveEvent(), ej.endEvent()], [this._touchMoveHandler, this._touchEndHandler], true, this);
                }
            }
            else {
                if (this._startSwipeOffsetX && this._isOpened()) {
                    this._relativeX = point.clientX - this._startSwipeOffsetActualX;
                    this._relativeY = point.clientY - this._startSwipeOffsetY;
                    var leftPoint = (this.element.width() + this._relativeX) - (this.model.type.toLowerCase() == "overlay" ? this._nbHome.offset().left : 0);
                    if ($(point.target).hasClass("" + this._prefixClass + "nb-overlay")) {
                        if (this.model.direction == "left" ? -(this._relativeX) < this.element.width() : this._relativeX < this.element.width())
                            this._transform((this.model.direction == "left" ? leftPoint : -((this.element.width() - this._relativeX))), 0, this._isTransitionElement());
                    }
                }
            }
        },

        _swipeEnd: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._swipeMoveHandler, true, this);
            ej.listenTouchEvent(this._nbHome, ej.endEvent(), this._swipeEndHandler, true, this);
        },

        _touchMove: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._swipeMoveHandler, true, this);
            if (this._isTransitionElement()) { this._containerX = 0; }
            if (this._startSwipeOffsetX && !this._isOpened()) {
                this._relativeX = point.clientX - this._startSwipeOffsetX;
                this._relativeY = point.clientY - this._startSwipeOffsetY;
                if ((this.model.direction == "left" ? this._startSwipeOffsetX < 50 : this._startSwipeOffsetX > this._nbHome.width() - 50)) {
                    this.element.show();
                    var leftPoint = this.model.type.toLowerCase() == "slide" ? 0 : this._nbHome.offset().left;
                    if (this.model.direction == "left" ? this._relativeX - leftPoint < this.element.width() : this._relativeX - leftPoint > -(this.element.width())) {
                        !this._containerX || this.model.targetHome ? this._transform((this._containerX + this._relativeX) - leftPoint, 0, this._isTransitionElement()) : undefined;
                    }
                }
            }
        },

        _touchEnd: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._touchMoveHandler, true, this);
            if (!this._isOpened() && !($.isFunction(ej.isIOS7) ? ej.isIOS7() : false)) {
                if (!this._containerX) {
                    this._relativeX = point.clientX - this._startSwipeOffsetX;
                    this._relativeY = point.clientY - this._startSwipeOffsetY;
                    if (this.model.direction == "left" ? this._startSwipeOffsetX < 50 : this._startSwipeOffsetX > this._nbHome.width() - 50) {
                        if (this._relativeX > 30 || this._relativeX < -30)
                            this._show();
                        else
                            this._hide();
                    }
                }
                else {
                    this._hide();
                }
            }
            this._data = { targetElement: this._nbHome, element: this.element, direction: this._swipeDirection };
            this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : undefined;
            this._trigger("swipe", this._data);
            ej.listenTouchEvent(this._nbHome, ej.endEvent(), this._touchEndHandler, true, this);
            ej.listenTouchEvent(this._nbHome, "mouseleave", this._touchEndHandler, true, this);
        },

        open: function (e) {
            if (!this.model.isPaneOpen) {
                this._show();
            }
        },

        close: function (e) {
            if (!this.model.isPaneOpen) {
                this._data = { element: this.element };
                this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : undefined;
                this._trigger("beforeClose", this._data);
                this._hide();
            }
        },

        toggle: function (e) {
            if (!this.model.isPaneOpen) {
                this._isOpened() ? this.close() : this.open();
            }
        }
    });

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html ListView elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejListViewBase", "ej.ListViewBase", {
        _addToPersist: ["selectedItemIndex", "checkedIndices"],
        defaults: {
            
            height: null,

            width: null,

            selectedItemIndex: -1,

            enableGroupList: false,
            
            enableAjax: false,
            
            enableCache: false,
            
            enablePersistence: false,
			
			ready: null,
            
            load: null,

            itemRequestCount: 5,

            totalItemsCount: null,
			
            loadComplete: null,
            
            ajaxBeforeLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            ajaxComplete: null,

            ajaxSettings: {
                type: 'GET',
                cache: false,
                async: true,
                dataType: "html",
                contentType: "html",
                url: "",
                data: {}
            },
                                    
            renderTemplate: false,

            templateId: null,

            persistSelection: false,

            preventSelection: false,

            dataSource: [],

            query: null,

            allowVirtualScrolling: false,

            virtualScrollMode: "normal",

            showHeader: false,
			
			showHeaderBackButton: false,

            cssClass: "",

            headerTitle: "Title",

            headerBackButtonText: null,

            enableFiltering: false,

            enableCheckMark: false,

            checkedIndices :[],
			
			locale:"en-US"

        },

        observables: ["selectedItemIndex", "dataSource"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        dataSource: ej.util.valueFunction("dataSource"),
        checkedIndices: ej.util.valueFunction("checkedIndices"),

        _updateModelItems: function () {
            this.model.items = eval(this.model.items);
            var ang_attr = this.model.items;
            if (ang_attr.length) {
                var ul = ej.buildTag("ul.e-m-clearall");
                for (i = 0; i < ang_attr.length; i++) {
                    ang_attr[i].items = [];
                    var ang_li = ej.buildTag("li");
                    if (this.model.items[i].template)
                        ang_li.html(this.model.items[i].template);
                    if (!this.model.items[i].childId && this.model.items[i].href)
                        this.model.items[i].childId = ("page_" + parseInt(Math.random().toFixed(3) * 1000));
                    if (this.model.items[i].renderTemplate) {
                        if (!this._storedTemplate[i]) {
                            if (this.model.items[i].templateId) {
                                var ele = this._tempContent.find('#' + this.model.items[i].templateId).remove();
                                this._storedTemplate[i] = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                            }
                            else
                                this._storedTemplate[i] = this.model.items[i].template;
                            this.model.items[i].templateId = this._storedTemplate[i];
                        }
                    }
                    if (this.model.fieldSettings)
                        this.model.fieldSettings = $.extend(this.defaults.fieldSettings, this.model.fieldSettings);
                    ul.append(ang_li);
                }
                this.element.append(ul)
            }
            else {
                var ul = this.element.find(">ul");
                var groupid = 1;
                for (var ulindex = 0; ulindex < ul.length; ulindex++) {
                    this._listitems = $(ul[ulindex]).find(">li");
                    for (var index = 0; index < this._listitems.length; index++) {
                        var element = this._listitems[index];
                        if ((ej.getAttrVal(element, "data-ej-primarykey") == null) && ($(element).find("ul").length)) {
                            var primaryKey = Math.round(Math.random() * 100);
                            $(element).attr("data-ej-primarykey", primaryKey);
                        }
                        else
                            primaryKey = "";
                        var groupTitle = ej.getAttrVal($(ul[ulindex]), "data-ej-grouplistitle") ? ej.getAttrVal($(ul[ulindex]), "data-ej-grouplistitle") : "GroupList" + groupid;
                        this.model.items.push(this._itemsObjectCollection($(this._listitems[index]), primaryKey, null, groupTitle));
                        this._nestedListitems = $(this._listitems[index]).find("ul >li");
                        for (var index1 = 0; index1 < this._nestedListitems.length; index1++) {
                            var element1 = this._nestedListitems[index1];
                            if ((ej.getAttrVal(element1, "data-ej-primarykey") == null) && ($(element1).find("ul").length)) {
                                var primaryKey = Math.round(Math.random() * 100);
                                $(element1).attr("data-ej-primarykey", primaryKey);
                            }
                            else
                                primaryKey = "";
                            var parentPrimaryKey = ej.getAttrVal($($(element1).parent()).closest("li"), "data-ej-primarykey");
                            this.model.items.push(this._itemsObjectCollection($(this._nestedListitems[index1]), primaryKey, parentPrimaryKey, groupTitle));
                        }
                    }
                    groupid++;
                }
            }
        },

        _load: function () {
            this._orgEle = this.element.clone();
            this.tempcount = 0;
            this._index = 0;
            this._items = [];
            this._checkedValues = [];
            this._checkedValues = this.model.checkedIndices;
            this.model.id = this.element[0].id;
            if (this.model.load)
                this._trigger("load");
            this.model.fieldSettings = eval(this.model.fieldSettings);
            if (this.model.fieldSettings && this.model.query != null) {
                this._dataUrl = this.model.dataSource;
                var proxy = this;
                this.dataSource().executeQuery(eval(this.model.query)).done(function (e) {
                    proxy.model.dataSource = e.result;
                    proxy._renderControl();
               
                });
            }
            else
                if(!this.model.allowVirtualScrolling)
                    this._renderControl();
        },
        _loadVirtualData: function (args) {
            var list = this._renderLists();
            $.views.helpers({ _checkAjaxUrls: this._checkAjaxUrl, _checkImgUrls: this._checkImgUrl, _checkIsChecked: this._checkIsCheck, Object: this, ej: ej });           
            this.jsRender = ej.buildTag("script#" + this.model.id + "_Template", "", {}, { "type": "text/x-jsrender" }); //Template for parent item
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');
            else
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');          
            this.jsChildRender = ej.buildTag("script#" + this.model.id + "_ChildTemplate", "", {}, { "type": "text/x-jsrender" });  //Template for child item
            var ul = ej.buildTag("ul." + this._prefixClass + "childcontainer " + this._prefixClass + "list-hdr " + this._prefixClass + "clearall");
            list.addClass(this._prefixClass + "childli");
            ul[0].innerHTML = "{{for items}}" + list[0].outerHTML + "{{/for}}";             
            var result = args;
            if (result) {
                ul.empty().html($(this.jsRender).render(result));
                var _ulItems = ul.clone().find('li'), temp = "";
                if (this._initEJCheckBox) this._initEJCheckBox(ul);                     				               
                var proxy = this;
                for (var j =0; j < result.length; j++) {              
                    if (result[j] && result[j].attributes) {
                        $.each(result[j].attributes, function (i, attr) {
                            if (attr && attr.name.toLowerCase() == "class") temp = $(_ulItems[j]).attr('class');
                        });
                    }
                    if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                        var k = this.realUllength;	
                        if(this.model.enableCheckMark){
                            if($(this.element.find('li').eq(k).find('.e-chkbox-wrap')).length!=0){
                                var x=$(this.element.find('li').eq(k).find('.e-chkbox-wrap'))[0];
                                var checked = x.getAttribute("aria-checked")=="true" ? true : false;
                                $($(_ulItems[j]).find(".e-lv-check")).ejCheckBox({ checked: checked });		
                            }
                            else{
                                var checked = false;
                                if(this._removeIndex!=j)
                                    $($(_ulItems[j]).find(".e-lv-check")).ejCheckBox({ checked: checked });	
                                else 
                                    $(_ulItems[j]).find('.e-lv-check').remove();									
                            }																							 													 									
                        }
                        if($(_ulItems[j]).find('.e-lv-check').length !=0) $(_ulItems[j]).find('.e-lv-check').parent().addClass("e-lv-checkdiv");
                        this.element.find('li').eq(k).replaceWith(_ulItems[j]);                          					
                        this._removeEmptyElements();
                        this.scrollerObj.refresh();
                    }
                    else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "continuous") {
                        if(this.model.enableCheckMark){																										 				
                            $($(_ulItems[j]).find(".e-lv-check")).ejCheckBox();												
                        }
                        $(_ulItems[j]).find('.e-lv-check').parent().addClass("e-lv-checkdiv");
                        this._lContainer.find('ul').append(_ulItems[j]);
                        this._removeEmptyElements();
                        this.scrollerObj.refresh();
                    }
                    this.realUllength+=1;
                }
            }
                       
                       
        },
        _removeEmptyElements:function()
        {
            this.eLi = this.element.find('li.' + this._prefixClass + 'list');
            this.eLi.removeEleEmptyAttrs();
            this.eLi.find('.' + this._prefixClass + 'chevron-right_01').removeEleEmptyAttrs();
        },
        _itemStyle: function () {
            var height = ej.isNullOrUndefined(this.model.itemHeight) ? this.model.itemHeight : this.model.itemHeight.toString().replace("px", "");
            var itemHeight = ej.isNullOrUndefined(this.model.itemHeight) ? "min-height:20px;" : "min-height:" + height + "px;height:" + height + "px";
            return { style: itemHeight }
        },
        
        _initDataSource: function (gg) {
            
            var _query = this._savedQueries;
            this._savedQueries = this.model.query.clone();
            _query = _query.range(0, parseInt(this.model.height / 20));
            var dataMgr = ej.DataManager(gg);

            var childItem = [];
            var parentItem = dataMgr.executeLocal(_query);
            return { parent: parentItem, child: childItem };
        },
        _renderControl: function () {
            
            var proxy = this;
            this.element.addClass(this._prefixClass + "parentlv " + this.model.cssClass);
            this._lbEle = ej.buildTag("div." + this._rootCSS);
            this._lbEle.addClass("subpage");
            this._lContainer = ej.buildTag("div." + this._prefixClass + "list-container#" + this.model.id + "_container");            
            if (this._hasDataSource()) 
                var ul = this.element.find(">ul");
            else
                var ul = this.element.find("ul:first");
            if (this.model.showHeader) {
                var hdr = this._renderHeader(this.model.id, false , this.model.headerTitle, this.model.headerBackButtonText);
                this._lbEle.prepend(hdr);
            }
            if (this._hasDataSource() && !this.model.renderTemplate)
                this.element.empty();
            if (this.model.renderTemplate) {
                if (this.model.templateId) {
                    if (this._tempContent.find('#' + this.model.templateId).length) {
                        this._template = this._tempContent.find('#' + this.model.templateId);
                        ej.destroyWidgets(this._template);
                        if (this._template[0].nodeName.toLowerCase() != "script")
                            this._template.remove();
                        this._template = this._template[0].nodeName && this._template[0].nodeName.toLowerCase() == "script" ? ej.getClearString(this._template[0].innerHTML) : this._template[0].outerHTML;
                    }
                }
                else {
                    ej.destroyWidgets(this.element);
                    this._template = this.element.html();
                    this.element.empty();
                }
				this._lContainer.addClass(this._prefixClass+"template-list");
            }
            if (this.model.renderTemplate && !this._hasDataSource() && !this.model.enableGroupList) {
                this.element.append(this._lbEle.append(this._lContainer));
				$(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass+'template-checkmark');
                if (this._template) {
                    this._lContainer.append(this._template);
                    if (ej.widget.init)
                        ej.widget.init(this._lContainer);
                }
            }
            else if (!this.model.renderTemplate || this.model.renderTemplate && this._hasDataSource() || this.model.renderTemplate && this.model.enableGroupList) {
                this._model_index = 0;
                if (this.model.enableGroupList) {
                    this._lContainer.addClass(this._prefixClass + "grouped");
                    var innerDiv = ej.buildTag("div." + this._prefixClass + "grouplist");
                    ul = this.element.children();
                    if (ul.length || this.dataSource().length) {
                        if (this.dataSource().length)
                            var group = ej.DataManager(this.dataSource()).executeLocal(ej.Query().from(this.dataSource()).group(this.model.fieldSettings['groupID']));
                        else
                            var group = ej.DataManager(this.model.items).executeLocal(ej.Query().from(this.model.items).group(this.model.fieldSettings['groupID']));
                        var length = group.length;
                        var title;
                        for (var i = 0; i < length; i++) {
                            this._items = group[i].items;
                            if (this._hasDataSource()) {
                                ulItem = ej.buildTag('ul', "", {}, { "data-ej-grouplisttitle": group[i].key });
                                this._lbEle.append(ulItem);
                            }
                            else
                                ulItem = ul[i];
                            title = this._hasDataSource() ? group[i].key : ej.getAttrVal($(ulItem), 'data-ej-grouplisttitle', "GroupList" + (i + 1));
                            $(ulItem).attr("data-ej-grouplisttitle", title);
                            var groupdiv = ej.buildTag("div." + this._prefixClass + "groupdiv", ej.buildTag("div." + this._prefixClass + "grouptitle", title));
                            innerDiv.append(groupdiv.append(this._renderListItems($(ulItem).addClass(this._prefixClass + "grouped"))));
                        }
                    }
                    else if (this._template) {
                        ej.destroyWidgets(this._template);
                        innerDiv[0].innerHTML = this._template;
                    }
					this._lContainer.append(innerDiv);
                    if (ej.widget.init)
                        ej.widget.init(innerDiv);
                }
                else {
                    if (this._hasDataSource()) {
                        var ul = ej.buildTag('ul');
                        this._items = this.dataSource();
                        this._items = eval(this._items);
                        for (j = 0; j < this._items.length; j++) {
                            if (this._items[j].href && !this._items[j].childId) {
                                this._items[j].childId = ("page_" + parseInt(Math.random().toFixed(3) * 1000));
                            }
                        }
                    }
                    if (ul.length) {
                        ej.destroyWidgets(ul);
						this._lContainer.append(this._renderListItems(ul));
                        if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                            var i;
                            var dmycount=Math.round(this.model.height/20);
                            for (i = 0; i <= this._items.length - dmycount; i++) {
                                var $listEle = ej.buildTag('li', null, null, this._itemStyle());
                                this.dummyUl.push($listEle[0]);
                                this._lContainer.find('ul').append(this.dummyUl);
                            }                           
                        }
                    }
                    else if (this._template) {
                        ej.destroyWidgets(this._template);
                        this._lContainer[0].innerHTML = this._template;
                    }
                }
                this.element.prepend(this._lbEle);
                if (this.model.enableFiltering)
                    this._createFilterWrapper(this._lbEle);
				this._setHeightWidth();
				this._lContainer.ejScroller({
                       height: this._lContainer.outerHeight(),
                       width: 0,
                       scrollerSize: 20,
                    scroll: function (e) {
                        if ((e.source == "key" || e.source == "wheel" || (e.source != "button" && e.source != "thumb" && e.source != "custom")) && proxy.model != null) proxy._onScroll(e);
                    },
                    thumbEnd: function (e) {
                        //Please use the first code for debugging purpose
                        // if (proxy.model != null &&  $(e.originalEvent.target).parents(".e-list")[0].tagName.toUpperCase() != "LI" && e.originalEvent.target.tagName.toUpperCase() != "HTML")
                        if (proxy.model != null)
                            proxy._onScroll(e);
                    },
                    scrollEnd: function (e) {
                        if (e.scrollData.source == "button" && proxy.model != null) proxy._onScroll(e);
                    }
                
                });
			    this.scrollerObj = this._lContainer.ejScroller("instance");
                this._lbEle.append(this._lContainer);
                if (ej.widget.init)
                    ej.widget.init(this._lContainer);
                var eLi = this.element.find('li.' + this._prefixClass + 'list');
                eLi.removeEleEmptyAttrs();
                eLi.find('.' + this._prefixClass + 'chevron-right_01').removeEleEmptyAttrs();
                if (ej.widget.init)
                    ej.widget.init(this._lbEle);
                var ulItems = this.element.find('ul');
                ulItems.find('li:first').addClass(this._prefixClass + "firstitem");
                ulItems.find('li:last').addClass(this._prefixClass + "lastitem");
                this._liEl = this.element.find("li");
                if (this.selectedItemIndex() >= 0 && !this.model.preventSelection && this.model.persistSelection) {
                    if (!ej.getBooleanVal(ulItems[this.selectedItemIndex()], 'data-preventselection', this.model.preventSelection) && ej.getBooleanVal(ulItems[this.selectedItemIndex()], 'data-persistselection', this.model.persistSelection)) {
                        this._currentItem = $(this._liEl[this.selectedItemIndex()]);
                        this._prevItem = this._currentItem;
                        this._currentItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
                    }
                }

                $(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass + 'lv-checkdiv');
				if(this.model.renderTemplate) $(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass+'template-checkmark');
                $(this.element.find('.' + this._prefixClass + 'lv-check').closest('li.' + this._prefixClass + 'list')).addClass(this._prefixClass + 'list-check');
                $(this.element.find('.' + this._prefixClass + 'lv-input').closest('.' + this._prefixClass + 'lv-filter')).addClass(this._prefixClass + 'lv-inputdiv');
                this._wireEvents();
            }
            this._setHeightWidth();
			if (this.model.height !== null) 
				if (this._lContainer.height() > this.model.height)
					this._refreshScroller(this._lContainer,false);
			if (this.scrollerObj) {
				this.scrollerObj.refresh();
				$(this.scrollerObj.element).find(".e-vhandlespace").css("height",($(this.scrollerObj.element).find(".e-vhandlespace").height() -1));
            }
            if (this.model.loadComplete)
                this._trigger("loadComplete");
        },

        _createFilterWrapper: function (element) {
            var fDiv = this._createFilterDiv();
            var fAnchor = ej.buildTag("a." + this._prefixClass + "lv-anchor", ej.buildTag('span.' + this._prefixClass + 'input-btn'), {}, { "Title": "Clear text", "data-role": "none" });
            $(fDiv).append(fAnchor);
            element.append(fDiv);
        },
        
		_refreshScroller: function (container,isChild) {
            //added start
               if (this.model.virtualScrollMode == "continuous") {
                this._lContainer.find(".e-content, .e-vhandle,.e-vhandle div").removeAttr("style");
                this._lContainer.css({ "display": "block" });
                if (this.scrollerObj) {
                    this.scrollerObj.model.height = this._lContainer.height();
                    this.scrollerObj.refresh();
                    this.scrollerObj.option("scrollTop", 0);
                }
            }
            //added end
            container.find(".e-vhandle div").removeAttr("style");
            if(isChild)
                hgt = this.model.showHeader && this.model.enableFiltering ? this.model.height - ((ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight')) + (ej.getDimension($(id).find('.' + this._prefixClass + 'lv-filter'), 'outerHeight'))) - 2 : this.model.showHeader ? this.model.height - ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight') - 2 : this.model.enableFiltering ? this.model.height - (ej.getDimension($(id).find('.' + this._prefixClass + 'lv-filter'), 'outerHeight')) - 2 : this.model.height - 2;
            else
                hgt = this.model.showHeader && this.model.enableFiltering ? this.model.height - ((ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight')) + ($('.' + this._prefixClass + 'lv-filter').height())) - 2 : this.model.showHeader ? this.model.height - ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight') - 2 : this.model.enableFiltering ? this.model.height - $('.' + this._prefixClass + 'lv-filter').height() - 2 : this.model.height - 2;
            if (this.scrollerObj) {
                this.scrollerObj.model.height = hgt;
            }
        },
        
        _renderListItems: function (ul) {
            ul.addClass(this._prefixClass + "list-hdr " + this._prefixClass + "clearall");
            this._liItems = ul.find("li");
            if (this._liItems.length && !this._hasDataSource() || this._hasDataSource()) {
                this._renderParentChildTemplate();
                if (!this._hasDataSource() && !this.model.enableGroupList) {
                    this._items = this.model.items;
                }
                var items = this._items;
                var proxy = this;
                if (this.model.allowVirtualScrolling) {
                    var result = this._initDataSource(items);
                }
                else {
                    var result = this._filterParentChild(items);
                }
                if (result.child.length)
                    this._childRendering(result.child);
                if (result.parent) {
                    ul.empty().html($(this.jsRender).render(result.parent));
                    var ulItems = ul.find('>li'), temp = "";
                    for (var j = 0; j < ulItems.length; j++) {
                        if (result.parent[j] && result.parent[j].attributes) {
                            $.each(result.parent[j].attributes, function (i, attr) {
                                if (attr && attr.name.toLowerCase() == "class") temp = $(ulItems[j]).attr('class');
                            });
							$(ulItems[j]).addEleAttrs(result.parent[j].attributes);
							$(ulItems[j]).addClass(temp);
                        }

                    }
                }
            }
            if (this._initEJCheckBox)
                this._initEJCheckBox(ul);
            return ul;
        },
        _onScroll: function (e) {
            var proxy = this;
            value = this.model.query;
            this._temp = this._dataUrl;
            if (this.model.actionBegin)
                this._trigger("actionBegin", {});
            var proxy = this, liEle = this.element.find('li')[0];
            var _getLiCount = Math.round(this.model.height / 20);
            this.realUllength = _getLiCount;
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                var liHeight = $(liEle).outerHeight();
                this.itemIndex = Math.round(this.scrollerObj.scrollTop() / liHeight);
                this.realUllength = this.itemIndex;
                var start = this.itemIndex, end;
                if (this.itemIndex > this._lContainer.outerHeight() / $(liEle).outerHeight()) {
                    start = Math.round(start);
                    end = Math.round(this.itemIndex + _getLiCount);
                }
                if (this.itemIndex <= start <= 0)
                    start = 0;
                if (this._dataUrl.length == undefined && (this._temp == this._dataUrl)) {
                    if (ej.DataManager && this._dataUrl instanceof ej.DataManager) {
                        var startPoint = start == 0 ? start : start - 1;
                        var endPoint = start == this.element.find('li').length ? start : start + 1;
                        this._queryPromise(startPoint, proxy, endPoint + Math.ceil(this.model.height / liHeight), e);
                    }
                       
                }

                else if (this._temp != this._dataUrl) {
                    this._queryPromise(start, proxy, this._listitems.length, e);
                }
                else if (this._dataUrl.length > 0)
                    this._loadQueryData(start, end, proxy);
            }
              
                else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "continuous") {
                if (this.element.find("li").length -2 <= (this.scrollerObj.scrollTop() + this.model.height) / this.element.find('li').outerHeight()) {
                    this.lastScrollPosition = this.scrollerObj.scrollTop();
                    var start =this.element.children().length;
                    if (start <= 0)
                        start = 0;
                    if (this._oldStartValue)
                        start = this._oldStartValue;
                    var totalLength = this.model.totalItemsCount ? this.model.totalItemsCount : this._items.length
                    if (this.element.find("li").length < totalLength-1) {
                        if (this._dataUrl.length == undefined) {
                            var end = (start + this.model.itemRequestCount);
                            if (ej.DataManager && this._dataUrl) {
                                if (start <= end)
                                    this._queryPromise(start, proxy, end, e);
                                else
                                    return false;
                            }
                            
                            this._oldStartValue = start + this.model.itemRequestCount;
                        }
                        if (this._dataUrl.length > 0) {
                            if (this._isScrollComplete) return;
                            this._loadQueryData(proxy.realUllength, proxy.realUllength + this.model.itemRequestCount, proxy);
                        }
                    }
                }
            }
        },
  	
        _loadQueryData: function (start, end, proxy) {
            this._isScrollComplete = (end >= this._items.length) ? true : false;
            this._updateLoadingClass(true);
            var tempSrc = this.dataSource();
            this._loadVirtualData(tempSrc.slice(start, end))._updateLoadingClass();
            //  proxy._applySelection();
          if (proxy.model.virtualScrollMode == "continuous") {
                proxy.scrollerObj.option("scrollTop", proxy.lastScrollPosition);
                proxy.scrollerObj.refresh();
            }
        },
        _updateLoadingClass: function (value) {
            var _id = this.element.attr("id")
			if(value){
				$("#" + _id+" .e-list-container.e-scroller >ul").addClass("e-load");
				$(".e-lv .e-list.e-state-default").css("opacity","0.5");}
			else {
				$("#" + _id+" .e-list-container.e-scroller >ul").removeClass("e-load");
				$(".e-lv .e-list.e-state-default").css("opacity","1");}
            return this;
        },
        _queryPromise: function (start, proxy, end, e) {
            this._trigger('itemRequest', { event: e, isInteraction: true });
            var mQuery = this._savedQueries.clone();
            var queryPromise = this._dataUrl.executeQuery(mQuery.range(start, end));
            this._updateLoadingClass(true);
            queryPromise.done(function (d) {
                proxy._trigger("actionBeforeSuccess", d);
                proxy.realUllength =start;
                proxy._loadVirtualData(d.result);
                if (proxy.model.virtualScrollMode == "continuous") {
                    proxy.scrollerObj.refresh();
                    proxy.scrollerObj.option("scrollTop", proxy.lastScrollPosition);
				proxy._updateLoadingClass(false);
                }
                proxy._trigger("actionSuccess", d);
            }).fail(function (e) {
                proxy._trigger("actionFailure", e);
            }).always(function (e) {
                proxy._trigger("actionComplete", e);
            });
        },
        _filterParentChild: function (items) {
            var dataMgr = ej.DataManager(items);
            var childItem = dataMgr.executeLocal(ej.Query().from(items).where(ej.Predicate(this.model.fieldSettings['parentPrimaryKey'], ej.FilterOperators.notEqual, null)).group(this.model.fieldSettings['parentPrimaryKey']));
            var parentItem = dataMgr.executeLocal(ej.Query().from(items).where(ej.Predicate(this.model.fieldSettings['parentPrimaryKey'], ej.FilterOperators.equal, null)));
            return { parent: parentItem, child: childItem };
        },

        _childRendering: function (grouped) {
            var proxy = this;
            if (grouped.length) {
                proxy.element.append($(proxy.jsChildRender).render(grouped));
                $.each(grouped, function (index, element) {
                    if (ej.widget.init)
                        ej.widget.init(proxy.element.find('#child' + element.key));
                    var ul = proxy.element.find('#child' + element.key).find('ul');
                    var li = ul.find('li');
                   var k = 0;
                    for (var j = 0; j < li.length; j++) {
                        if (grouped[k].items[j] && grouped[k].items[j].attributes)
                            $(li[j]).addEleAttrs(grouped[k].items[j].attributes);
                    }
                    k++;
                });
            }
        },
        _renderParentChildTemplate: function () {
            var list = this._renderLists();
            $.views.helpers({ _checkAjaxUrls: this._checkAjaxUrl, _checkImgUrls: this._checkImgUrl, _checkIsChecked: this._checkIsCheck, Object: this, ej: ej });
            //Template for parent item
            this.jsRender = ej.buildTag("script#" + this.model.id + "_Template", "", {}, { "type": "text/x-jsrender" });
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');
            else
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');
            //Template for child item
            this.jsChildRender = ej.buildTag("script#" + this.model.id + "_ChildTemplate", "", {}, { "type": "text/x-jsrender" });
            var ul = ej.buildTag("ul." + this._prefixClass + "childcontainer " + this._prefixClass + "list-hdr " + this._prefixClass + "clearall");
            list.addClass(this._prefixClass + "childli");
            ul[0].innerHTML = "{{for items}}" + list[0].outerHTML + "{{/for}}";
            var div = ej.buildTag("div." + this._rootCSS + " subpage " + this._prefixClass + "childitem", "", {}, { "id": "{{if key}}child{{>key}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}", "style": "display:none" });
            var innerdiv = ej.buildTag("div." + this._prefixClass + "list-container", "", {}, { "id": "{{if key}}child{{>key}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}_container" });
            if (this.model.showHeader)
                div.append(this._renderHeader("{{if key}}child{{>key}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}", true, "Title"));
            if (this.model.enableFiltering)
                this._createFilterWrapper(div);
            div.append(innerdiv.append(ul));
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this.jsChildRender[0].text = div[0].outerHTML.replace(/&gt;/g, '>');
            else
                this.jsChildRender[0].innerHTML = div[0].outerHTML.replace(/&gt;/g, '>');
        },
    
        _renderChild: function (childId, ignoreWidth) {
            this._currentItem.attr('data-childid', childId);
            if (!this._currentItem.attr('data-childtitle'))
                this._currentItem.attr('data-childtitle', this._currentItem.text());
            this._createListDiv(childId);
            this._div.hide();
            this._container = ej.buildTag("div." + this._prefixClass + "list-container#" + childId + "_container");
            this.element.append(this._div);
        },

        _getText: function (element) {
            return $(element).clone()
           .children()
           .remove()
           .end()
           .text();
        },

        
        _checkImgUrl: function (item) {
            var obj = this.getRsc("helpers", "Object");
            var img = this.data[obj.model.fieldSettings.imageUrl];
            if (!$.support.pushstate)
                img = typeof App == "object" ? App.route.makeUrlAbsolute(img, true) : img;
            return "<img src = " + img + " class='" + obj._prefixClass + "list-img " + obj._prefixClass + "rel " + obj._prefixClass + "user-select'/>";
        },

        
        
        _checkAjaxUrl: function () {
            var href = this.data.href;
            var childid = this.data.childId;
            var rendertemp = this.data.renderTemplate;
            var tempid = this.data.templateId;
            var listObj = this.getRsc("helpers", "Object");
            var ej = this.getRsc("helpers", "ej");
            var content = listObj._currentPage(listObj);
            if (href && href.indexOf("#") != -1 && href != "#") {
                if (!listObj._storedContent[childid]) {
                    content.find(href).show();
                    var ele = content.find(href).clone();
                    content.find(href).hide();
                    listObj._storedContent[childid] = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                }
            }
            else {
                if (listObj._storedContent[this.index])
                    listObj._storedContent = ej._pushValue(listObj._storedContent, "", this.index);
            }

        },

        _currentPage: function (obj) {
            return obj._prefixClass == "e-m-" ? ej.getCurrentPage() : $("body");
        },
        
        _checkIsCheck: function (item) {
            return this.data[this.getRsc("helpers", "Object").model.fieldSettings.checked] ? true : false;
        },

        _onTouchStartHandler: function (evt) {
             this._mouseDown = { x: (!ej.isNullOrUndefined(evt.clientX)) ? evt.clientX : evt.touches[0].clientX, y: (!ej.isNullOrUndefined(evt.clientY)) ? evt.clientY : evt.touches[0].clientY };
			if(($(evt.target.parentElement).hasClass(this._prefixClass + 'disable')) || ($(evt.currentTarget).hasClass(this._prefixClass + 'disable'))) 
				return false;
            if (!ej.isDevice() && !ej._preventDefaultException(evt.target, this._preventDefaultException))
                evt.preventDefault && evt.preventDefault();
            if (ej.isWindows && ej.isWindows())
                ej._touchStartPoints(evt, this);
            this._currentItem = $(evt.currentTarget);
            this._scroll = false;
            if (!ej.getBooleanVal(this._currentItem, 'data-preventSelection', this.model.preventSelection))
                this._addSelection();
			 if (this.model.renderMode == "windows" &&!this.model.windows.preventSkew)
                 this._currentItem.addClass(this._prefixClass + "m-skew-center");
            this._triggerStartEvent(this._returnData());
			ej.listenEvents([this._liEl, this._liEl],
                           [ej.endEvent(), ej.moveEvent(), ej.cancelEvent()],
                           [this._touchEndDelegate, this._touchMoveDelegate, this._touchMoveDelegate], false, this);
            $(window).on(ej.endEvent() + " MSPointerUp pointerup", this._docClickDelegate);
        },
        
        
        _onTouchMoveHandler: function (evt) {
		if ((ej.browserInfo().name == "msie" && ej.browserInfo().version > 8)|| ej.browserInfo().name != "msie"){
           if (((!ej.isNullOrUndefined(evt.clientX)) ? evt.clientX : evt.changedTouches[0].clientX !== this._mouseDown.x) || ((!ej.isNullOrUndefined(evt.clientY)) ? evt.clientY : evt.changedTouches[0].clientY !== this._mouseDown.y)) {
            this._isMoved = true;
             if (ej.isMobile() && (!ej.isWindows || (ej.isWindows && !ej.isWindows()) || (ej.isWindows && ej.isWindows() && ej._isTouchMoved(evt, this)))) {
                this._scroll = true;
                if (!ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection))
                    this._removeSelection();
                else if (this._prevItem && this._prevItem[0] != this._currentItem[0])
                    this._removeSelection();
                 if (this.model.renderMode == "windows" && !this.model.windows.preventSkew)					
                     ej._removeSkewClass(this._currentItem);
                else if (!ej.getBooleanVal(this._currentItem, 'data-preventselection', this.model.preventSelection) && this._prevItem && ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection))
                    this._prevItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
                    }
                }
            }
        },
        
        

        _onTouchEndHandler: function (evt) {
            this._isFromAjax = false;
            if (!ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection))
                this._removeSelection();
            if (this.model.renderMode == "windows" && !this.model.windows.preventSkew)			
                ej._removeSkewClass(this._currentItem);
            if (this._scroll) {
                this._setCurrent();
                this._unbindEvents(evt);
                return false;
            }
            else if (!this._scroll) {
                if (this._currentItem.find('.' + this._prefixClass + 'lv-check').length) {
                    var lbCheck = this._currentItem.find('.' + this._prefixClass + 'lv-check');
					  if ((this._prefixClass == "e-" && !ej.isNullOrUndefined(evt) && !$(evt.target).closest('.e-lv-checkdiv').length))
                        this._toggleCheckboxValue(lbCheck);
                }
                var backButton = this._currentItem.attr('data-childheaderbackbuttontext') == undefined ? this._currentItem.closest('.' + this._rootCSS + '').find('.' + this._prefixClass + 'header').length && ! this.model.showHeaderBackButton ? this._currentItem.closest('.' + this._rootCSS + '').find('.' + this._prefixClass + 'header .' + this._prefixClass + 'htitle').text() : "Back" : ej.getAttrVal(this._currentItem, 'data-childheaderbackbuttontext');
                var urlVal = this._currentItem.attr('data-href');
                if (!this._currentItem.attr('data-navigateUrl')) {
                    var page = this._isInsideNavigation ? this._tempContent.find("[data-ajaxurl='" + this._convertToRelativeUrl(urlVal) + "']") : this.element.find("[data-ajaxurl='" + this._convertToRelativeUrl(urlVal) + "']");
                    if (ej.getBooleanVal(this._currentItem, 'data-loadajax', (this.model.enableAjax && typeof (urlVal) != "undefined" || !typeof (urlVal))) && (!this.model.enableCache || page.length == 0)) {
                        if (page.length)
                            page.remove();
                        if ((this._prefixClass == "e-" && this._currentItem.hasClass("e-arrow")) || this._prefixClass != "e-")
                            this.loadAjaxContent(urlVal, backButton);
                        this._unbindEvents(evt);
                        if (this._isInsideNavigation && this._nearestND.model.contentId)
                            this._closeNavigation();
                        return;
                    }
                    else if (urlVal && urlVal.indexOf("#") != -1) {
                        if (this._currentPage(this).find('#' + urlVal.replace('#', '')).length) {
                            this._renderChild(ej.getAttrVal(this._currentItem, 'data-childid', "page_" + parseInt(Math.random().toFixed(3) * 1000)));
                            var content = ej.buildTag("div." + this._prefixClass + "content", this._storedContent[this._currentItem.attr('data-childid')]);
                            this._div.append(this._container.append(content));
                            if (ej.widget.init)
                                ej.widget.init(this._div);
                        }
                    }
                    this._updateContent(this._currentItem, backButton);
					if (this.model.ready) this._trigger("ready");
                    if (this._isInsideNavigation)
                        var close = this._nearestND.model.contentId ? (!this._currentItem.attr("data-childid") || this._currentItem.attr("data-href")) : !(this._currentItem.attr("data-childid") || this._currentItem.attr("data-href"));
                    if (this._isInsideNavigation && close)
                        this._closeNavigation();
                    this._touchEndEventHandler(evt);
                }
                else
                    this._touchEndEventHandler();
                this._prevItem = this._currentItem;
            }
            this._unbindEvents(evt);
        },

        _hasValue: function (data, index) {
            for (var i = 0; i < data.length; i++) {
                if (data[i] == index) return true;
            }
        },

        _generateData: function (items, elementId) {
            var collection = ej.DataManager(items).executeLocal(ej.Query().from(this.model.dataSource).where(ej.Predicate(typeof ej.getAttrVal(this._currentItem, "data-id") == "undefined" ? this.model.fieldSettings['text'] : this.model.fieldSettings['id'], ej.FilterOperators.equal, elementId)).group(elementId))[0];
            return collection ? collection.items[0] : [];
        },


        
        _closeNavigation: function () {
                this.element.closest('.' + this._prefixClass + 'nb').ejNavigationDrawer('close');
        },

        
        _setCurrent: function (e) {
            if (this._prevItem && ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection)) {
                this._currentItem = this._prevItem;
                this._currentItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
            }
        },
        
        _unbindEvents: function (e) {
            if (e && e.target.nodeName && e.target.nodeName.toLowerCase() != "a") {
                
                this._scroll = false;
            }
            ej.listenEvents([this._liEl, this._liEl],
                           [ej.endEvent(), ej.moveEvent(), ej.cancelEvent()],
                           [this._touchEndDelegate, this._touchMoveDelegate, this._touchMoveDelegate], true, this);
        },
        
        
        _addSelection: function () {
            if (!this._scroll) {
                this._currentItem.closest('.' + this._prefixClass + 'list-container').find('.' + this._prefixClass + 'state-active').removeClass(this._prefixClass + "state-active").addClass(this._prefixClass + "state-default");
                this._currentItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
            }
        },
        
        
        _removeSelection: function () {
            var proxy = this;
            proxy._currentItem.removeClass(this._prefixClass + "state-active").addClass(this._prefixClass + "state-default");
        },

        
        _setHeightWidth: function () {
            if (this.model.autoAdjustHeight)
                this.element.height(window.innerHeight);
            else if (this.model.height)
                this.element.height(this.model.height);
            else {
                var hgt = this.element[0].scrollHeight ? this.element[0].scrollHeight : ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'list-container'), 'outerHeight');
                this.element.height(hgt);
            }
            if (this.model.width)
                this.element.width(this.model.width);
        },
        
        
        _touchEndEventHandler: function (evt) {
            this._triggerEndEvent(this._returnData(),evt);
        },
                
        _docClick: function (evt) {
            if (this._scroll) {
                this._setCurrent();
                $(document).off(ej.endEvent() + " MSPointerUp pointerup", this._docClickDelegate);
                ej.listenEvents([this._liEl, this._liEl],
                               [ej.endEvent(), ej.moveEvent()],
                               [this._touchEndDelegate, this._touchMoveDelegate], true, this);
                $(window).off(ej.endEvent() + " MSPointerUp pointerup", this._docClickDelegate);
            }
        },
        
        
        _popStateNavigation: function (evt, data) {
            if (data.pageUrl && this.model.enableFiltering)
                this._initializeFiltering($("div[data-url='" + data.pageUrl.replace('#', '') + "']"));
        },
        
        
        _anchorClickHandler: function (e) {
            if (this._scroll) {
                ej.blockDefaultActions(e);
                return false;
            }
        },
        
        _onResize: function () {
            var proxy = this;
            setTimeout(function () {
                proxy._setHeightWidth();
            }, ej.isAndroid() ? 200 : 0);
        },
        _onScrollStop: function (e) {
            ej.blockDefaultActions(e);
        },
        
        
        _createDelegates: function () {
            this._anchorClickDelegate = $.proxy(this._anchorClickHandler, this);
            this._keyup = $.proxy(this._onKeyUp, this);
            this._touchStartDelegate = $.proxy(this._onTouchStartHandler, this);
            this._touchEndDelegate = $.proxy(this._onTouchEndHandler, this);
            this._touchMoveDelegate = $.proxy(this._onTouchMoveHandler, this);
            this._resizeDelegate = $.proxy(this._onResize, this);
            this._popStateDelegate = $.proxy(this._popStateNavigation, this);
            this._docClickDelegate = $.proxy(this._docClick, this);
        },
        
        
        _wireEvents: function (remove, items) {
            var listItems = this._liEl || items;
            if (listItems) {
                this._createDelegates();
                var eventType = remove ? "unbind" : "bind";
                if (this.model.autoAdjustHeight) {
                    var evt = !ej.isDevice() && "onorientationchange" in window ? "orientationchange" : "resize";
                    ej.listenEvents([window], [evt], [this._resizeDelegate], remove, this);
                }
                ej.listenEvents([listItems.find('a'), this.element.find('.' + this._prefixClass + 'lv-input'), listItems, listItems],
                ["click", "keyup", ej.startEvent(), ej.cancelEvent()],
                [this._anchorClickDelegate, this._keyup, this._touchStartDelegate, this._touchMoveDelegate], remove, this);
                this._lContainer.on("scrollstop", $.proxy(this._onScrollStop, this));
                $('body')[eventType]('viewpopstate', this._popStateDelegate);
                if (this.model.enableFiltering)
                    this._initializeFiltering(this._lbEle);
            }
        },
        
        
        _initializeFiltering: function (element) {
            this._searchItems = $(element).find("." + this._prefixClass + "list");
            this._emptyFilterTextValue(element);
            element.find('.' + this._prefixClass + 'list[style*="display: none"]').show();
            this._elementText = [];
            for (var i = 0; i < this._searchItems.length; i++) {
                if ($(this._searchItems[i]))
                    this._elementText.push($.trim($(this._searchItems[i]).html().replace(new RegExp('<[^<]+\>', 'g'), "").toLowerCase()));
                else
                    this._elementText.push("");
            }
        },
        
        
        _onKeyUp: function (evt) {
            for (var i = 0; i < this._searchItems.length; i++) {
                if (this._elementText[i].indexOf(evt.target.value.toLowerCase()) == -1)
                    $(this._searchItems[i]).css("display", "none");
                else
                    $(this._searchItems[i]).css("display", "");
            }
        },
        
        
        _setModel: function (options) {
            var refresh = false;
            for (var prop in options) {
                var setModel = "_set" + prop.charAt(0).toUpperCase() + prop.slice(1);
				 if (this[setModel] || prop == "locale") {
                    switch (prop) {                       
						case "locale":
							if (ej.ListView.Locale[options[prop]]) {
								this.model.locale = options[prop];
								this._setCulture();	
                                this._setHeaderVal(this.model.id,this.model.headerTitle, this.model.headerBackButtonText);						
							}
                            break;
                        default:
                            this[setModel](options[prop]);
                    }
                }               
                else
                    refresh = true;
            }
            if (refresh)
                this._refresh();
        },
        
        
        _setTheme: function (value) {
            if (value) {
                this.model.theme = value;
                this._lbEle.removeClass("e-m-dark e-m-light e-default").addClass("e-m-" + this.model.theme);
                if (this.model.enableFiltering)
                    this.element.find('.' + this._prefixClass + 'text-input').ejmTextBox('model.theme', this.model.theme);
                if (this.model.showHeader)
                    this._lbEle.find('#' + this.model.id + "_header").ejmHeader('model.theme', this.model.theme);
                if (this.element.find('.' + this._prefixClass + 'childitem').length) {
                    $(this.element.find('.' + this._prefixClass + 'childitem')).removeClass("e-m-dark e-m-light e-default").addClass("e-m-" + this.model.theme);
                    var header = this.element.find('.' + this._prefixClass + 'childitem .' + this._prefixClass + 'header');
                    var proxy = this;
                    header.each(function (index, element) {
                        $(element).ejmHeader('model.theme', proxy.model.theme);
                    });
                }
            }
        },
        
        
        _setDataSource: function (dataSource, fieldSettings) {
            if (this._hasDataSource() && dataSource) {
                if (fieldSettings)
                    this.model.fieldSettings = fieldSettings;
                this._refresh();
            }
        },
        
        
        _hasDataSource: function () {
            return this.dataSource() && this.dataSource().length;
        },
        
        
        _getElement: function (childId) {
            return childId ? this.element.find('#' + childId) : this._lbEle;
        },
        
        
        _isEnable: function (item) {
            return item.hasClass(this._prefixClass + 'state-disabled') ? false : true;
        },
        //To refresh the control
        _refresh: function () {
            this._destroy();
            this.element.addClass(this._rootCSS);
            this._load();
        },
        //To clear the element
        _clearElement: function () {
            this.element.removeAttr("class style");
            this.element.empty().html(this._orgEle.html());
        },
        // all events bound using this._on will be unbind automatically
        _destroy: function () {
			if (this._prefixClass == "e-")
			   ej.listenEvents([window], ["resize"], [this._resizeDelegate], true, this);
            this._wireEvents(true);
            this._clearElement();
        },

        loadAjaxContent: function (urlVal, backButton) {
            var proxy = this;
            this._isFromAjax = true;
            this._renderChild(ej.getAttrVal(this._currentItem, 'data-childid', "page_" + parseInt(Math.random().toFixed(3) * 1000)));
            if (!$.support.pushstate || ej.isWindowsWebView())
            var loadData = { content: proxy._div, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
            if (this.model.ajaxBeforeLoad)
                this._trigger("ajaxBeforeLoad", loadData);
            var ajaxSettings = {
                cache: proxy.model.ajaxSettings.cache,
                async: proxy.model.ajaxSettings.async,
                type: proxy.model.ajaxSettings.type,
                contentType: proxy.model.ajaxSettings.contentType,
                url: ej.isWindowsWebView() ? urlVal : proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal,
                dataType: proxy.model.ajaxSettings.dataType,
                data: proxy.model.ajaxSettings.data,
                "successHandler": function (data) { //Ajax post success event handler
                    var content = ej.buildTag("div." + this._prefixClass + "content", (/<\/?body[^>]*>/gmi).test(data) ? data.split(/<\/?body[^>]*>/gmi)[1] : data || "");
                    proxy._div.append(proxy._container.append(content));
                    proxy._updateContent(proxy._currentItem, backButton);                    
					if ((App.angularAppName || ej.angular.defaultAppName))
                        ej.angular.compile(content);
                    var successData = { content: proxy._div, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
                    if (proxy.model.ajaxSuccess)
                        proxy._trigger("ajaxSuccess", successData);
                },
                "errorHandler": function (xhr, textStatus, errorThrown) {
                    var errorData = { "xhr": xhr, "textStatus": textStatus, "errorThrown": errorThrown, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
                    if (proxy.model.ajaxError)
                        proxy._trigger("ajaxError", errorData);
                },
                "completeHandler": function (data) {
                    var completeData = { content: proxy._div, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
                    if (proxy.model.ajaxComplete)
                        proxy._trigger("ajaxComplete", completeData);
                }
            };
            ej.sendAjaxRequest(ajaxSettings);
        },

        selectItem: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]))) {
                this.setActive(index, childId);
                this._currentItem = $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]);
                this._prevItem = this._currentItem;
                this._onTouchEndHandler();
            }
        },

        setActive: function (index, childId) {
            if (index >= 0) {
               var element = this._getElement(childId);
                if (this._isEnable($(element.find('li.' + this._prefixClass + 'list')[index])) && ej.getBooleanVal($(element.find('li.' + this._prefixClass + 'list')[index]), 'data-persistSelection', this.model.persistSelection)) {
                    element.find('li.' + this._prefixClass + 'list.' + this._prefixClass + 'state-active').removeClass(this._prefixClass + 'state-active').addClass(this._prefixClass + 'state-default');
                    this._currentItem = $(element.find('li.' + this._prefixClass + 'list')[index]);
                    this._prevItem = this._currentItem;
                    this._currentItem.removeClass(this._prefixClass + 'state-default').addClass(this._prefixClass + 'state-active');
                }
            }
        },

        deActive: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index])))
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).removeClass(this._prefixClass + 'state-active').addClass(this._prefixClass + 'state-default');
        },

        enableItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).removeClass(this._prefixClass + 'disable').addClass(this._prefixClass + 'state-default').find('a').removeClass(this._prefixClass + 'disable').find('.' + this._prefixClass + 'lv-check').ejCheckBox("enable");
        },

        disableItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).addClass(this._prefixClass + 'disable').removeClass(this._prefixClass + 'state-default').find('a').addClass(this._prefixClass + 'disable').find('.' + this._prefixClass + 'lv-check').ejCheckBox("disable");
        },

        removeCheckMark: function (index, childId) {
            this._removeIndex=index;
           var element = this._getElement(childId);
            if (index >= 0 && this._isEnable($(element.find('li.' + this._prefixClass + 'list')[index])))
                $(element.find('li.' + this._prefixClass + 'list')[index]).find('.' + this._prefixClass + 'lv-checkdiv').remove();
            else
                element.find('.' + this._prefixClass + 'lv-checkdiv').remove();
        },

        checkItem: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index])))
                this._setCheckboxValue($(this._getElement(childId).find('.' + this._prefixClass + 'lv-check')[index]), true);
        },

        unCheckItem: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index])))
                this._setCheckboxValue($(this._getElement(childId).find('.' + this._prefixClass + 'lv-check')[index]), false);
        },

        checkAllItem: function (childId) {
            var proxy = this;
            this._getElement(childId).find('.' + this._prefixClass + 'lv-check').each(function (index, check) {
                if (proxy._isEnable($(proxy._getElement(childId).find('li.' + proxy._prefixClass + 'list')[index])))
                    proxy._setCheckboxValue($(check), true);
            });
			this._currentItem = $(this._liEl);
			for(i=0; i<this._currentItem.length; i++){
			  index = this.element.find("li").index(this._currentItem[i]);
			  if (!this._hasValue(this._checkedValues, index))
                        this._checkedValues.push(index);
                    else
                        this._checkedValues.splice(this._checkedValues.indexOf(index), 1);}

				this.checkedIndices(this._checkedValues);
			    this.model.checkedIndices = this.checkedIndices();		
        },

        unCheckAllItem: function (childId) {
            var proxy = this;
            this._getElement(childId).find('.' + this._prefixClass + 'lv-check').each(function (index, check) {
                if (proxy._isEnable($(proxy._getElement(childId).find('li.' + proxy._prefixClass + 'list')[index])))
                    proxy._setCheckboxValue($(check), false);
            });
        },

        getActiveItem: function (childId) {
            return this._getElement(childId).find('li.' + this._prefixClass + 'list.' + this._prefixClass + 'state-active');
        },

        getActiveItemText: function (childId) {
            return this._getElement(childId).find('li.' + this._prefixClass + 'list.' + this._prefixClass + 'state-active').text();
        },

        getItemText: function (index, childId) {
            if (index >= 0)
                return $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).text();
        },

        getCheckedItems: function (childId) {
            if (childId != undefined)
                return this._getElement(childId).find('input.' + this._prefixClass + 'lv-check:checked').closest('li.' + this._prefixClass + 'list');
            else
                var checkedlist=[];
		        for(i=0; i<this.checkedIndices().length; i++){
			    var clist = this.element.find("li")[this.checkedIndices()[i]];
			    checkedlist.push(clist);
		   }
			   return checkedlist;
        },

        getCheckedItemsText: function (childId) {
            return $(this.getCheckedItems(childId)).map(function () { return $(this).text(); }).get();
        },

        hasChild: function (index, childId) {
            if (index >= 0)
                return this.element.find('#' + $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).attr('data-childid')).length ? true : false;
        },
        
        isChecked: function (index, childId) {
            if (index >= 0)
                return $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).find('input.' + this._prefixClass + 'lv-check').prop('checked');
        },

        showItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).css('visibility', '');
        },

        hideItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).css('visibility', 'hidden');
        },

        show: function (childId) {
            this._getElement(childId).css('visibility', '');
        },

        hide: function (childId) {
            this._getElement(childId).css('visibility', 'hidden');
        },

		_objectSplice:function(list,index){
		    for (var i = 0; i < list.length; i++) {
		        this.model.items.splice(index, 0, list[i]);
		    }
		},
		
        addItem: function (list, index, groupid) {
            if (index >= 0) {
                if (!this._hasDataSource()) {
					if($('.e-list-container').find('ul').length == 0){
                    var ul = ej.buildTag('ul'), li = ej.buildTag('li');
                    $('.e-list-container').find('div:first').append(ul);
                    $('.e-list-container > div > ul').append(li);
                }
                    if (typeof (list) == 'object')
                        this._objectSplice(list, index);
                    else
                        this.model.items.splice(index, 0, this._getLiAttributes(list, null, null, groupid));
                    var items = this.model.items;
                }
                else {
                    if (typeof (list) == 'object') {
                        for (var i = 0; i < list.length; i++) 
                            this.dataSource().splice(index, 0, list[i]);
                    }
                    else 
                    this.dataSource().splice(index, 0, this._itemsObjectCollection($(list), null, null, groupid));
                    var items = this.dataSource();
                }
            }
            else
                this._orgEle.children().append(list);
            if (!this.model.enableGroupList)
                var $ul = $(this.element.find("ul:visible"));
            else
                var $ul = $(this.element.find('ul[data-ej-grouplisttitle= ' + groupid + ']'));
            if (!ej.isNullOrUndefined(this.jsRender)) {
				 var ele;
				if (typeof (list) == 'object') {
                    for (var i = 0; i < list.length; i++) 
	                    ele = $($(this.jsRender).render(items[index+i])).insertBefore($ul.children()[index]);
                }
                else 
                      ele = $($(this.jsRender).render(items[index])).insertBefore($ul.children()[index]);    
                ej.widget.init && ej.widget.init(ele);
				if($(list).attrNotStartsWith(/^data-ej-/).length>0) $(ele).addEleAttrs($($(list).attrNotStartsWith(/^data-ej-/)));
            }
            else {
                this._renderControl();
                if ($(this.element).find('.subpage').length > 1) {
                    $(this.element).find('.subpage:nth-child(2)').remove();
                }
            }
            this._processing($ul);
            this._liEl = this.element.find('li.' + this._prefixClass + 'list');
            if (this._initEJCheckBox){
			this._initEJCheckBox($ul);
		    if(this.model.renderTemplate) $(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass+'template-checkmark');
			}
            this._setHeightWidth();
            this._wireEvents();
        },

            _processing: function ($ul) {
            $ul.find("li." + this._prefixClass + "firstitem").removeClass(this._prefixClass + "firstitem");
            $ul.find('li:first').addClass(this._prefixClass + "firstitem");
            $ul.find("li." + this._prefixClass + "lastitem").removeClass(this._prefixClass + "lastitem");
            $ul.find('li:last').addClass(this._prefixClass + "lastitem");
            eLi = $ul.find('li.' + this._prefixClass + 'list');
            eLi.removeEleEmptyAttrs();
            eLi.find('.' + this._prefixClass + 'chevron-right_01').removeEleEmptyAttrs();
            $ul.find('.' + this._prefixClass + 'lv-check').parent().addClass(this._prefixClass + 'lv-checkdiv');
            $ul.find('.' + this._prefixClass + 'lv-check').closest('li.' + this._prefixClass + 'list').addClass(this._prefixClass + 'list-check');
            $ul.find('.' + this._prefixClass + 'lv-input').closest('.' + this._prefixClass + 'lv-filter').addClass(this._prefixClass + 'lv-inputdiv');
        },

        removeItem: function (index, childId) {
            if (index >= 0) {
                element = this._getElement(childId);
                var child = $(element.find('li.' + this._prefixClass + 'list')[index]).attr('data-childid');
                if (this.element.find($('#' + child).length))
                    this.element.find($('#' + child)).remove();
                $(element.find('li.' + this._prefixClass + 'list')[index]).remove();
            }
        },

        clear: function () {
            this.element.empty().html();
            this._liEl = this.element.find('li.' + this._prefixClass + 'list');
        },

        getItemsCount: function (childId) {
            return this._getElement(childId).find('li.' + this._prefixClass + 'list').length;
        },
		
        getActiveItemData: function () {
            if (this.getActiveItem().attr("data-id"))
                return (this._generateData(this.dataSource().length ? typeof this.dataSource() == "string" ? eval(this.dataSource()) : this.dataSource() : this.model.items, this.getActiveItem().attr("data-id")));
        }
    });
	ej.VirtualScrollMode = {
        /** Supports to Virtual Scrolling mode with normal only */
        Normal: "normal",
        /** Supports to Virtual Scrolling mode with continuous only */
        Continuous: "continuous"
    };
})(jQuery, Syncfusion);;;
(function($, undefined){
    
ej.globalize = {};
ej.cultures = {};

ej.cultures['default'] = ej.cultures['en-US'] = $.extend(true, {
    name: 'en-US',
    englishName: "English",
    nativeName: "English",
    language: 'en',
    isRTL: false,
    numberFormat: {
        pattern: ["-n"],
        decimals: 2,
        ',': ",",
        '.': ".",
        groupSizes: [3],
        '+': "+",
        '-': "-",
        percent: {
            pattern: ["-n %", "n %"],
            decimals: 2,
            groupSizes: [3],
            ',': ",",
            '.': ".",
            symbol: '%'
        },
        currency: {
            pattern: ["($n)", "$n"],
            decimals: 2,
            groupSizes: [3],
            ',': ",",
            '.': ".",
            symbol: '$'
        }
    },
    calendars: {
    	standard: {
	        '/': '/',
	        ':': ':',
	        firstDay: 0,
	        days: {
	            names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
	            namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
	            namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
	        },
	        months: {
	            names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""],
	            namesAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""]
	        },
	        AM: ['AM', 'am', 'AM'],
	        PM: ['PM', 'pm', 'PM'],
            twoDigitYearMax: 2029,
	        patterns: {
                d: "M/d/yyyy",
                D: "dddd, MMMM dd, yyyy",
                t: "h:mm tt",
                T: "h:mm:ss tt",
                f: "dddd, MMMM dd, yyyy h:mm tt",
                F: "dddd, MMMM dd, yyyy h:mm:ss tt",
                M: "MMMM dd",
                Y: "yyyy MMMM",
                S: "yyyy\u0027-\u0027MM\u0027-\u0027dd\u0027T\u0027HH\u0027:\u0027mm\u0027:\u0027ss"

	        }
    	}
    }
}, ej.cultures['en-US']);

ej.cultures['en-US'].calendar = ej.cultures['en-US'].calendar || ej.cultures['en-US'].calendars.standard; 



// *************************************** Numbers ***************************************
var regexTrim = /^\s+|\s+$/g,
    regexInfinity = /^[+-]?infinity$/i,
    regexHex = /^0x[a-f0-9]+$/i,
    regexParseFloat = /^[+-]?\d*\.?\d*(e[+-]?\d+)?$/;

function patternStartsWith(value, pattern) {
    return value.indexOf( pattern ) === 0;
}

function patternEndsWith(value, pattern) {
    return value.substr( value.length - pattern.length ) === pattern;
}

function trim(value) {
    return (value+"").replace( regexTrim, "" );
}

function truncate(value){
    if(isNaN(value))
        return NaN;
    
    return Math[value < 0 ? "ceil" : "floor"](value);
}

function padWithZero(str, count, left) {
    for (var l = str.length; l < count; l++) {
        str = (left ? ('0' + str) : (str + '0'));
    }
    return str;
}

function parseNumberWithNegativePattern(value, nf, negativePattern) {
    var neg = nf["-"],
        pos = nf["+"],
        ret;
    switch (negativePattern) {
        case "n -":
            neg = ' ' + neg;
            pos = ' ' + pos;
            // fall through
        case "n-":
            if ( patternEndsWith( value, neg ) ) {
                ret = [ '-', value.substr( 0, value.length - neg.length ) ];
            }
            else if ( patternEndsWith( value, pos ) ) {
                ret = [ '+', value.substr( 0, value.length - pos.length ) ];
            }
            break;
        case "- n":
            neg += ' ';
            pos += ' ';
            // fall through
        case "-n":
            if ( patternStartsWith( value, neg ) ) {
                ret = [ '-', value.substr( neg.length ) ];
            }
            else if ( patternStartsWith(value, pos) ) {
                ret = [ '+', value.substr( pos.length ) ];
            }
            break;
        case "(n)":
            if ( patternStartsWith( value, '(' ) && patternEndsWith( value, ')' ) ) {
                ret = [ '-', value.substr( 1, value.length - 2 ) ];
            }
            break;
    }
    return ret || [ '', value ];
}

function getFullNumber(number, precision, formatInfo) {
    var groupSizes = formatInfo.groupSizes || [3],
        curSize = groupSizes[0],
        curGroupIndex = 1,
        factor = Math.pow(10, precision),
        rounded = Math.round(number * factor) / factor;
    if (!isFinite(rounded)) {
        rounded = number;
    }
    number = rounded;

    var numberString = number + "",
        right = "",
        split = numberString.split(/e/i),
        exponent = split.length > 1 ? parseInt(split[1], 10) : 0;
    numberString = split[0];
    split = numberString.split(".");
    numberString = split[0];
    right = split.length > 1 ? split[1] : "";

    var l;
    if (exponent > 0) {
        right = padWithZero(right, exponent, false);
        numberString += right.slice(0, exponent);
        right = right.substr(exponent);
    } else if (exponent < 0) {
        exponent = -exponent;
        numberString = padWithZero(numberString, exponent + 1);
        right = numberString.slice(-exponent, numberString.length) + right;
        numberString = numberString.slice(0, -exponent);
    }

    var dot = formatInfo['.'] || '.';
    if (precision > 0) {
        right = dot +
            ((right.length > precision) ? right.slice(0, precision) : padWithZero(right, precision));
    } else {
        right = "";
    }

    var stringIndex = numberString.length - 1,
        sep = formatInfo[","] || ',',
        ret = "";

    while (stringIndex >= 0) {
        if (curSize === 0 || curSize > stringIndex) {
            return numberString.slice(0, stringIndex + 1) + (ret.length ? (sep + ret + right) : right);
        }
        ret = numberString.slice(stringIndex - curSize + 1, stringIndex + 1) + (ret.length ? (sep + ret) : "");

        stringIndex -= curSize;

        if (curGroupIndex < groupSizes.length) {
            curSize = groupSizes[curGroupIndex];
            curGroupIndex++;
        }
    }
    return numberString.slice(0, stringIndex + 1) + sep + ret + right;
}

function formatNumberToCulture(value, format, culture) {
    if (!format || format === 'i') {
        return culture.name.length ? value.toLocaleString() : value.toString();
    }
    format = format || "D";

    var nf = culture.numberFormat,
        number = Math.abs(value),
        precision = -1,
        pattern;

    if (format.length > 1) precision = parseInt(format.slice(1), 10);

    var current = format.charAt(0).toUpperCase(),
        formatInfo;

    switch (current) {
        case 'D':
            pattern = 'n';
            number = truncate(number);
            if (precision !== -1) {
                number = padWithZero("" + number, precision, true);
            }
            if (value < 0) number = -number;
            break;
        case 'N':
            formatInfo = nf;
            formatInfo.pattern = formatInfo.pattern || ['-n'];
            // fall through
        case 'C':
            formatInfo = formatInfo || nf.currency;
            formatInfo.pattern = formatInfo.pattern || ['-$n', '$n'];
            // fall through
        case 'P':
            formatInfo = formatInfo || nf.percent;
            formatInfo.pattern = formatInfo.pattern || ['-n %', 'n %'];
            pattern = value < 0 ? (formatInfo.pattern[0] || "-n") : (formatInfo.pattern[1] || "n");
            if (precision === -1) precision = formatInfo.decimals;
            number = getFullNumber(number * (current === "P" ? 100 : 1), precision, formatInfo);
            break;
        default:
            throw "Bad number format specifier: " + current;
    }

    return matchNumberToPattern(number, pattern, nf);
}



function matchNumberToPattern(number, pattern, nf){
    var patternParts = /n|\$|-|%/g,
        ret = "";
    for (;;) {
        var index = patternParts.lastIndex,
            ar = patternParts.exec(pattern);

        ret += pattern.slice(index, ar ? ar.index : pattern.length);

        if (!ar) {
            break;
        }

        switch (ar[0]) {
            case "n":
                ret += number;
                break;
            case "$":
                ret += nf.currency.symbol || "$";
                break;
            case "-":
                // don't make 0 negative
                if (/[1-9]/.test(number)) {
                    ret += nf["-"] || "-";
                }
                break;
            case "%":
                ret += nf.percent.symbol || "%";
                break;
        }
    }

    return ret;
}

// *************************************** Dates ***************************************

var dateFormat = {
    DAY_OF_WEEK_THREE_LETTER : "ddd",
    DAY_OF_WEEK_FULL_NAME : "dddd",
    DAY_OF_MONTH_SINGLE_DIGIT : "d",
    DAY_OF_MONTH_DOUBLE_DIGIT : "dd",
    MONTH_THREE_LETTER : "MMM",
    MONTH_FULL_NAME : "MMMM",
    MONTH_SINGLE_DIGIT : "M",
    MONTH_DOUBLE_DIGIT : "MM",
    YEAR_SINGLE_DIGIT : "y",
    YEAR_DOUBLE_DIGIT : "yy",
    YEAR_FULL : "yyyy",
    HOURS_SINGLE_DIGIT_12_HOUR_CLOCK : "h",
    HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK : "hh",
    HOURS_SINGLE_DIGIT_24_HOUR_CLOCK : "H",
    HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK : "HH",
    MINUTES_SINGLE_DIGIT : "m",
    MINUTES_DOUBLE_DIGIT : "mm",
    SECONDS_SINGLE_DIGIT : "s",
    SECONDS_DOUBLE_DIGIT : "ss",
    MERIDIAN_INDICATOR_SINGLE : "t",
    MERIDIAN_INDICATOR_FULL : "tt",
    DECISECONDS : "f",
    CENTISECONDS: "ff",
    MILLISECONDS : "fff",
    TIME_ZONE_OFFSET_SINGLE_DIGIT : "z",
    TIME_ZONE_OFFSET_DOUBLE_DIGIT : "zz",
    TIME_ZONE_OFFSET_FULL : "zzz",
    DATE_SEPARATOR : "/"
};

function valueOutOfRange(value, low, high) {
    return value < low || value > high;
}

function expandYear(cal, year) {
    // expands 2-digit year into 4 digits.
    var now = new Date();
    if ( year < 100 ) {
        var twoDigitYearMax = cal.twoDigitYearMax;
        twoDigitYearMax = typeof twoDigitYearMax === 'string' ? new Date().getFullYear() % 100 + parseInt( twoDigitYearMax, 10 ) : twoDigitYearMax;
        var curr = now.getFullYear();
        year += curr - ( curr % 100 );
        if ( year > twoDigitYearMax ) {
            year -= 100;
        }
    }
    return year;
}

function arrayIndexOf( array, item ) {
    if ( array.indexOf ) {
        return array.indexOf( item );
    }
    for ( var i = 0, length = array.length; i < length; i++ ) {
        if ( array[ i ] === item ) return i;
    }
    return -1;
}

function toUpper(value) {
    // 'he-IL' has non-breaking space in weekday names.
    return value.split( "\u00A0" ).join(' ').toUpperCase();
}

function toUpperArray(arr) {
    var results = [];
    for ( var i = 0, l = arr.length; i < l; i++ ) {
        results[i] = toUpper(arr[i]);
    }
    return results;
}

function getIndexOfDay(cal, value, abbr) {
    var ret,
        days = cal.days,
        upperDays = cal._upperDays;
    if ( !upperDays ) {
        cal._upperDays = upperDays = [
            toUpperArray( days.names ),
            toUpperArray( days.namesAbbr ),
            toUpperArray( days.namesShort )
        ];
    }
    value = toUpper( value );
    if ( abbr ) {
        ret = arrayIndexOf( upperDays[ 1 ], value );
        if ( ret === -1 ) {
            ret = arrayIndexOf( upperDays[ 2 ], value );
        }
    }
    else {
        ret = arrayIndexOf( upperDays[ 0 ], value );
    }
    return ret;
}

function getIndexOfMonth(cal, value, abbr) {
    var months = cal.months,
        monthsGen = cal.monthsGenitive || cal.months,
        upperMonths = cal._upperMonths,
        upperMonthsGen = cal._upperMonthsGen;
    if ( !upperMonths ) {
        cal._upperMonths = upperMonths = [
            toUpperArray( months.names ),
            toUpperArray( months.namesAbbr )
        ];
        cal._upperMonthsGen = upperMonthsGen = [
            toUpperArray( monthsGen.names ),
            toUpperArray( monthsGen.namesAbbr )
        ];
    }
    value = toUpper( value );
    var i = arrayIndexOf( abbr ? upperMonths[ 1 ] : upperMonths[ 0 ], value );
    if ( i < 0 ) {
        i = arrayIndexOf( abbr ? upperMonthsGen[ 1 ] : upperMonthsGen[ 0 ], value );
    }
    return i;
}

function appendMatchStringCount(preMatch, strings) {
    var quoteCount = 0,
        escaped = false;
    for ( var i = 0, il = preMatch.length; i < il; i++ ) {
        var c = preMatch.charAt( i );
        if(c == '\''){
            escaped ? strings.push( "'" ) : quoteCount++;
            escaped = false;
        } else if( c == '\\'){
            if (escaped) strings.push( "\\" );
            escaped = !escaped;
        } else {
            strings.push( c );
            escaped = false;
        }
    }
    return quoteCount;
}


function parseDayByInt(value, format, culture, cal) {
    if (!value) {
        return null;
    }
    var index = 0, valueX = 0, day = null;
    format = format.split("");
    length = format.length;
    var countDays = function (match) {
        var i = 0;
        while (format[index] === match) {
            i++;
            index++;
        }
        if (i > 0) {
            index -= 1;
        }
        return i;
    },
    getNumber = function (size) {
        var rg = new RegExp('^\\d{1,' + size + '}'),
            match = value.substr(valueX, size).match(rg);

        if (match) {
            match = match[0];
            valueX += match.length;
            return parseInt(match, 10);
        }
        return null;
    },
    getName = function (names, lower) {
        var i = 0,
            length = names.length,
            name, nameLength,
            subValue;

        for (; i < length; i++) {
            name = names[i];
            nameLength = name.length;
            subValue = value.substr(valueX, nameLength);

            if (lower) {
                subValue = subValue.toLowerCase();
            }

            if (subValue == name) {
                valueX += nameLength;
                return i + 1;
            }
        }
        return null;
    },
     lowerArray = function (data) {
         var index = 0,
             length = data.length,
             array = [];

         for (; index < length; index++) {
             array[index] = (data[index] + "").toLowerCase();
         }

         return array;
     },
     lowerInfo = function (localInfo) {
         var newLocalInfo = {}, property;

         for (property in localInfo) {
             newLocalInfo[property] = lowerArray(localInfo[property]);
         }

         return newLocalInfo;
     };
    for (; index < length; index++) {
        ch = format[index];
        if (ch === "d") {
            count = countDays("d");
            if (!cal._lowerDays) {
                cal._lowerDays = lowerInfo(cal.days);
            }
            day = count < 3 ? getNumber(2) : getName(cal._lowerDays[count == 3 ? "namesAbbr" : "names"], true)
        }
    }
    return day;
}


function getFullDateFormat(cal, format) {
    // expands unspecified or single character date formats into the full pattern.
    format = format || "F";
    var pattern,
        patterns = cal.patterns,
        len = format.length;
    if ( len === 1 ) {
        pattern = patterns[ format ];
        if ( !pattern ) {
            throw "Invalid date format string '" + format + "'.";
        }
        format = pattern;
    }
    else if ( len === 2  && format.charAt(0) === "%" ) {
        // %X escape format -- intended as a custom format string that is only one character, not a built-in format.
        format = format.charAt( 1 );
    }
    return format;
}

ej.globalize._getDateParseRegExp = function (cal, format) {
    // converts a format string into a regular expression with groups that
    // can be used to extract date fields from a date string.
    // check for a cached parse regex.
    var re = cal._parseRegExp;
    if ( !re ) {
        cal._parseRegExp = re = {};
    }
    else {
        var reFormat = re[ format ];
        if ( reFormat ) {
            return reFormat;
        }
    }

    // expand single digit formats, then escape regular expression characters.
    var expFormat = getFullDateFormat( cal, format ).replace( /([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g, "\\\\$1" ),
        regexp = ["^"],
        groups = [],
        index = 0,
        quoteCount = 0,
        tokenRegExp = /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g,
        match;

    // iterate through each date token found.
    while ( (match = tokenRegExp.exec( expFormat )) !== null ) {
        var preMatch = expFormat.slice( index, match.index );
        index = tokenRegExp.lastIndex;

        // don't replace any matches that occur inside a string literal.
        quoteCount += appendMatchStringCount( preMatch, regexp );
        if ( quoteCount % 2 ) {
            regexp.push( match[ 0 ] );
            continue;
        }

        // add a regex group for the token.
        var m = match[ 0 ],
            len = m.length,
            add;
            
        switch ( m ) {
            case dateFormat.DAY_OF_WEEK_THREE_LETTER: case dateFormat.DAY_OF_WEEK_FULL_NAME:
            case dateFormat.MONTH_FULL_NAME: case dateFormat.MONTH_THREE_LETTER:
                add = "(\\D+)";
                break;
            case dateFormat.MERIDIAN_INDICATOR_FULL: case dateFormat.MERIDIAN_INDICATOR_SINGLE:
                add = "(\\D*)";
                break;
            case dateFormat.YEAR_FULL:
            case dateFormat.MILLISECONDS:
            case dateFormat.CENTISECONDS:
            case dateFormat.DECISECONDS:
                add = "(\\d{" + len + "})";
                break;
            case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT: case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
            case dateFormat.MONTH_DOUBLE_DIGIT: case dateFormat.MONTH_SINGLE_DIGIT:
            case dateFormat.YEAR_DOUBLE_DIGIT: case dateFormat.YEAR_SINGLE_DIGIT:
            case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK: case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK: case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK:
            case dateFormat.MINUTES_DOUBLE_DIGIT: case dateFormat.MINUTES_SINGLE_DIGIT:
            case dateFormat.SECONDS_DOUBLE_DIGIT: case dateFormat.SECONDS_SINGLE_DIGIT:
                add = "(\\d\\d?)";
                break;
            case dateFormat.TIME_ZONE_OFFSET_FULL:
                add = "([+-]?\\d\\d?:\\d{2})";
                break;
            case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT: case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT:
                add = "([+-]?\\d\\d?)";
                break;
            case dateFormat.DATE_SEPARATOR:
                add = "(\\" + cal["/"] + ")";
                break;
            default:
                throw "Invalid date format pattern '" + m + "'.";
                break;
        }
        if ( add ) {
            regexp.push( add );
        }
        groups.push( match[ 0 ] );
    }
    appendMatchStringCount( expFormat.slice( index ), regexp );
    regexp.push( "$" );

    // allow whitespace to differ when matching formats.
    var regexpStr = regexp.join( '' ).replace( /\s+/g, "\\s+" ),
        parseRegExp = {'regExp': regexpStr, 'groups': groups};

    // cache the regex for this format.
    return re[ format ] = parseRegExp;
}

function getParsedDate(value, format, culture) {
    // try to parse the date string by matching against the format string
    // while using the specified culture for date field names.
    value = trim( value );
    format = trim(format);
    var cal = culture.calendar,
        // convert date formats into regular expressions with groupings.
        parseInfo = ej.globalize._getDateParseRegExp(cal, format),
        match = new RegExp(parseInfo.regExp).exec(value);
    if (match === null) {
        return null;
    }
    // found a date format that matches the input.
    var groups = parseInfo.groups,
        year = null, month = null, date = null, weekDay = null,
        hour = 0, hourOffset, min = 0, sec = 0, msec = 0, tzMinOffset = null,
        pmHour = false;
    // iterate the format groups to extract and set the date fields.
    for ( var j = 0, jl = groups.length; j < jl; j++ ) {
        var matchGroup = match[ j + 1 ];
        if ( matchGroup ) {
            var current = groups[ j ],
                clength = current.length,
                matchInt = parseInt( matchGroup, 10 );
            
            switch ( current ) {
                case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT: case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
                    date = matchInt;
                    if ( valueOutOfRange( date, 1, 31 ) ) return null;
                    break;
                case dateFormat.MONTH_THREE_LETTER:
                case dateFormat.MONTH_FULL_NAME:
                    month = getIndexOfMonth( cal, matchGroup, clength === 3 );
                    if ( valueOutOfRange( month, 0, 11 ) ) return null;
                    break;
                case dateFormat.MONTH_SINGLE_DIGIT: case dateFormat.MONTH_DOUBLE_DIGIT:
                    month = matchInt - 1;
                    if ( valueOutOfRange( month, 0, 11 ) ) return null;
                    break;
                case dateFormat.YEAR_SINGLE_DIGIT: case dateFormat.YEAR_DOUBLE_DIGIT:
                case dateFormat.YEAR_FULL:
                    year = clength < 4 ? expandYear( cal, matchInt ) : matchInt;
                    if ( valueOutOfRange( year, 0, 9999 ) ) return null;
                    break;
                case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK: case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK:
                    hour = matchInt;
                    if ( hour === 12 ) hour = 0;
                    if ( valueOutOfRange( hour, 0, 11 ) ) return null;
                    break;
                case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK: case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK:
                    hour = matchInt;
                    if ( valueOutOfRange( hour, 0, 23 ) ) return null;
                    break;
                case dateFormat.MINUTES_SINGLE_DIGIT: case dateFormat.MINUTES_DOUBLE_DIGIT:
                    min = matchInt;
                    if ( valueOutOfRange( min, 0, 59 ) ) return null;
                    break;
                case dateFormat.SECONDS_SINGLE_DIGIT: case dateFormat.SECONDS_DOUBLE_DIGIT:
                    sec = matchInt;
                    if ( valueOutOfRange( sec, 0, 59 ) ) return null;
                    break;
                case dateFormat.MERIDIAN_INDICATOR_FULL: case dateFormat.MERIDIAN_INDICATOR_SINGLE:
                    pmHour = cal.PM && ( matchGroup === cal.PM[0] || matchGroup === cal.PM[1] || matchGroup === cal.PM[2] );
                    if ( !pmHour && ( !cal.AM || (matchGroup !== cal.AM[0] && matchGroup !== cal.AM[1] && matchGroup !== cal.AM[2]) ) ) return null;
                    break;
                case dateFormat.DECISECONDS:
                case dateFormat.CENTISECONDS:
                case dateFormat.MILLISECONDS:
                    msec = matchInt * Math.pow( 10, 3-clength );
                    if ( valueOutOfRange( msec, 0, 999 ) ) return null;
                    break;
                case dateFormat.DAY_OF_WEEK_THREE_LETTER:
                    date = parseDayByInt(value, format, culture, cal);
                    break;
                case dateFormat.DAY_OF_WEEK_FULL_NAME:
                     getIndexOfDay( cal, matchGroup, clength === 3 );
                    if ( valueOutOfRange( weekDay, 0, 6 ) ) return null;
                    break;
                case dateFormat.TIME_ZONE_OFFSET_FULL:
                    var offsets = matchGroup.split( /:/ );
                    if ( offsets.length !== 2 ) return null;

                    hourOffset = parseInt( offsets[ 0 ], 10 );
                    if ( valueOutOfRange( hourOffset, -12, 13 ) ) return null;
                    
                    var minOffset = parseInt( offsets[ 1 ], 10 );
                    if ( valueOutOfRange( minOffset, 0, 59 ) ) return null;
                    
                    tzMinOffset = (hourOffset * 60) + (patternStartsWith( matchGroup, '-' ) ? -minOffset : minOffset);
                    break;
                case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT: case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT:
                    // Time zone offset in +/- hours.
                    hourOffset = matchInt;
                    if ( valueOutOfRange( hourOffset, -12, 13 ) ) return null;
                    tzMinOffset = hourOffset * 60;
                    break;
            }
        }
    }
    var result = new Date(), defaultYear, convert = cal.convert;
    defaultYear = convert ? convert.fromGregorian( result )[ 0 ] : result.getFullYear();
    if ( year === null ) {
        year = defaultYear;
    }
    
    // set default day and month to 1 and January, so if unspecified, these are the defaults
    // instead of the current day/month.
    if ( month === null ) {
        month = 0;
    }
    if ( date === null ) {
        date = 1;
    }
    // now have year, month, and date, but in the culture's calendar.
    if ( convert ) {
        result = convert.toGregorian( year, month, date );
        if ( result === null ) return null;
    }
    else {
        // have to set year, month and date together to avoid overflow based on current date.
        result.setFullYear( year, month, date );
        // check to see if date overflowed for specified month (only checked 1-31 above).
        if ( result.getDate() !== date ) return null;
        // invalid day of week.
        if ( weekDay !== null && result.getDay() !== weekDay ) {
            return null;
        }
    }
    // if pm designator token was found make sure the hours fit the 24-hour clock.
    if ( pmHour && hour < 12 ) {
        hour += 12;
    }
    result.setHours( hour, min, sec, msec );
    if ( tzMinOffset !== null ) {
        var adjustedMin = result.getMinutes() - ( tzMinOffset + result.getTimezoneOffset() );
        result.setHours( result.getHours() + parseInt( adjustedMin / 60, 10 ), adjustedMin % 60 );
    }
    return result;
}


function formatDateToCulture(value, format, culture) {
    var cal = culture.calendar,
        convert = cal.convert;
    if ( !format || !format.length || format === 'i' ) {
        var ret;
        if ( culture && culture.name.length ) {
            if ( convert ) {
                // non-gregorian calendar, so we cannot use built-in toLocaleString()
                ret = formatDateToCulture( value, cal.patterns.F, culture );
            }
            else {
                ret = value.toLocaleString();
            }
        }
        else {
            ret = value.toString();
        }
        return ret;
    }

    var sortable = format === "s";
        format = getFullDateFormat(cal, format);


    // Start with an empty string
    ret = [];
    var hour,
        zeros = ['0','00','000'],
        foundDay,
        checkedDay,
        dayPartRegExp = /([^d]|^)(d|dd)([^d]|$)/g,
        quoteCount = 0,
        tokenRegExp = /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g,
        converted;

    function padWithZeros(num, c) {
        var r, s = num+'';
        if ( c > 1 && s.length < c ) {
            r = ( zeros[ c - 2 ] + s);
            return r.substr( r.length - c, c );
        }
        else {
            r = s;
        }
        return r;
    }

    function hasDay() {
        if ( foundDay || checkedDay ) {
            return foundDay;
        }
        foundDay = dayPartRegExp.test( format );
        checkedDay = true;
        return foundDay;
    }

    if ( !sortable && convert ) {
        converted = convert.fromGregorian( value );
    }

    for (;;) {
        // Save the current index
        var index = tokenRegExp.lastIndex,
            // Look for the next pattern
            ar = tokenRegExp.exec( format );

        // Append the text before the pattern (or the end of the string if not found)
        var preMatch = format.slice( index, ar ? ar.index : format.length );
        quoteCount += appendMatchStringCount( preMatch, ret );

        if ( !ar ) {
            break;
        }

        // do not replace any matches that occur inside a string literal.
        if ( quoteCount % 2 ) {
            ret.push( ar[ 0 ] );
            continue;
        }

        var current = ar[ 0 ],
            clength = current.length;


        switch ( current ) {
            case dateFormat.DAY_OF_WEEK_THREE_LETTER:
            case dateFormat.DAY_OF_WEEK_FULL_NAME:
                var names = (clength === 3) ? cal.days.namesAbbr : cal.days.names;
                ret.push( names[ value.getDay() ] );
                break;
            case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
            case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT:
                foundDay = true;
                ret.push( padWithZeros( (converted ? converted[2] : value.getDate()), clength ) );
                break;
            case dateFormat.MONTH_THREE_LETTER:
            case dateFormat.MONTH_FULL_NAME:
                var part = converted ? converted[1] : value.getMonth();
                ret.push( (cal.monthsGenitive && hasDay())
                    ? cal.monthsGenitive[ clength === 3 ? "namesAbbr" : "names" ][ part ]
                    : cal.months[ clength === 3 ? "namesAbbr" : "names" ][ part ] );
                break;
            case dateFormat.MONTH_SINGLE_DIGIT:
            case dateFormat.MONTH_DOUBLE_DIGIT:
                ret.push( padWithZeros((converted ? converted[1] : value.getMonth()) + 1, clength ) );
                break;
            case dateFormat.YEAR_SINGLE_DIGIT:
            case dateFormat.YEAR_DOUBLE_DIGIT:
            case dateFormat.YEAR_FULL:
                part = converted ? converted[ 0 ] : value.getFullYear();
                if ( clength < 4 ) {
                    part = part % 100;
                }
                ret.push( padWithZeros( part, clength ) );
                break;
            case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK:
                hour = value.getHours() % 12;
                if ( hour === 0 ) hour = 12;
                ret.push( padWithZeros( hour, clength ) );
                break;
            case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK:
                ret.push( padWithZeros( value.getHours(), clength ) );
                break;
            case dateFormat.MINUTES_SINGLE_DIGIT:
            case dateFormat.MINUTES_DOUBLE_DIGIT:
                ret.push( padWithZeros( value.getMinutes(), clength ) );
                break;
            case dateFormat.SECONDS_SINGLE_DIGIT:
            case dateFormat.SECONDS_DOUBLE_DIGIT:
                ret.push( padWithZeros(value .getSeconds(), clength ) );
                break;
            case dateFormat.MERIDIAN_INDICATOR_SINGLE:
            case dateFormat.MERIDIAN_INDICATOR_FULL:
                part = value.getHours() < 12 ? (cal.AM ? cal.AM[0] : " ") : (cal.PM ? cal.PM[0] : " ");
                ret.push( clength === 1 ? part.charAt( 0 ) : part );
                break;
            case dateFormat.DECISECONDS:
            case dateFormat.CENTISECONDS:
            case dateFormat.MILLISECONDS:
                ret.push( padWithZeros( value.getMilliseconds(), 3 ).substr( 0, clength ) );
                break;
            case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT:
            case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT:
                hour = value.getTimezoneOffset() / 60;
                ret.push( (hour <= 0 ? '+' : '-') + padWithZeros( Math.floor( Math.abs( hour ) ), clength ) );
                break;
            case dateFormat.TIME_ZONE_OFFSET_FULL:
                hour = value.getTimezoneOffset() / 60;
                ret.push( (hour <= 0 ? '+' : '-') + padWithZeros( Math.floor( Math.abs( hour ) ), 2 ) +
                    ":" + padWithZeros( Math.abs( value.getTimezoneOffset() % 60 ), 2 ) );
                break;
            case dateFormat.DATE_SEPARATOR:
                ret.push( cal["/"] || "/" );
                break;
            default:
                throw "Invalid date format pattern '" + current + "'.";
                break;
        }
    }
    return ret.join( '' );
}

//add new culture into ej 
ej.globalize.addCulture = function (name, culture) {
    ej.cultures[name] = $.extend(true, $.extend(true, {}, ej.cultures['default'], culture), ej.cultures[name]);
	ej.cultures[name].calendar = ej.cultures[name].calendars.standard;
}

//return the specified culture or default if not found
ej.globalize.preferredCulture = function (culture) {
    culture = (typeof culture != "undefined" && typeof culture === typeof this.cultureObject) ? culture.name : culture;
    this.cultureObject = ej.globalize.findCulture(culture);
    return this.cultureObject;
}
ej.globalize.setCulture = function (culture) {
	if (ej.isNullOrUndefined(this.globalCultureObject)) this.globalCultureObject = ej.globalize.findCulture(culture);
	culture = (typeof culture != "undefined" && typeof culture === typeof this.globalCultureObject) ? culture.name : culture;
    if (culture) this.globalCultureObject = ej.globalize.findCulture(culture);
    ej.cultures.current = this.globalCultureObject;
    return this.globalCultureObject;
}
ej.globalize.culture=function(name){
    ej.cultures.current = ej.globalize.findCulture(name);
}

//return the specified culture or current else default if not found
ej.globalize.findCulture = function (culture) {
    var cultureObject;
    if (culture) {

        if ($.isPlainObject(culture) && culture.numberFormat) {
            cultureObject = culture;
        }
        if (typeof culture === "string") {
            var cultures = ej.cultures;
            if (cultures[culture]) {
                return cultures[culture];
            }
            else {
                if (culture.indexOf("-") > -1) {
                    var cultureShortName = culture.split("-")[0];
                    if (cultures[cultureShortName]) {
                        return cultures[cultureShortName];
                    }
                }
                else {
                    var cultureArray = $.map(cultures, function (el) { return el });
                    for (var i = 0; i < cultureArray.length; i++) {
                        var shortName = cultureArray[i].name.split("-")[0];
                        if (shortName === culture) {
                            return cultureArray[i];
                        }
                    };
                }
            }
            return ej.cultures["default"];
        }
    }
    else {
        cultureObject = ej.cultures.current || ej.cultures["default"];
    }

    return cultureObject;
}
//formatting date and number based on given format
ej.globalize.format = function (value, format, culture) {
    var cultureObject =  ej.globalize.findCulture(culture);
    if (typeof(value) === 'number') {
        value = formatNumberToCulture(value, format, cultureObject);
    } else if(value instanceof Date){
    	value = formatDateToCulture(value, format, cultureObject);
    }

    return value;
}

//parsing integer takes string as input and return as number
ej.globalize.parseInt = function(value, radix, culture) {
    return Math.floor( this.parseFloat( value, radix, culture ) );
}

//returns the ISO date string from date object
ej.globalize.getISODate = function(value) {
    if(value instanceof Date) return value.toISOString();
}

//parsing floationg poing number takes string as input and return as number
ej.globalize.parseFloat = function(value, radix, culture) {
    // make radix optional
    if (typeof radix === "string") {
        culture = radix;
        radix = 10;
    }

    culture = ej.globalize.findCulture(culture);
    var ret = NaN,
        nf = culture.numberFormat,
        npattern = culture.numberFormat.pattern[0];
    value = value.replace(/ /g, '');
    if (value.indexOf(culture.numberFormat.currency.symbol) > -1) {
        // remove currency symbol
        value = value.replace(culture.numberFormat.currency.symbol || "$", "");
        // replace decimal seperator
        value = value.replace(culture.numberFormat.currency["."] || ".", culture.numberFormat["."] || ".");
        // pattern of the currency
        npattern = trim(culture.numberFormat.currency.pattern[0].replace("$", ""));
    } else if (value.indexOf(culture.numberFormat.percent.symbol) > -1) {
        // remove percentage symbol
        value = value.replace(culture.numberFormat.percent.symbol || "%", "");
        // replace decimal seperator
        value = value.replace(culture.numberFormat.percent["."] || ".", culture.numberFormat["."] || ".");
        // pattern of the percent
        npattern = trim(culture.numberFormat.percent.pattern[0].replace("%", ""));
    }

    // trim leading and trailing whitespace
    value = trim( value );

    // allow infinity or hexidecimal
    if (regexInfinity.test(value)) {
        ret = parseFloat(value, radix);
    }
    else if (!radix && regexHex.test(value)) {
        ret = parseInt(value, 16);
    }
    else {
        var signInfo = parseNumberWithNegativePattern( value, nf, npattern ),
            sign = signInfo[0],
            num = signInfo[1];
        // determine sign and number
        if ( sign === "" && nf.pattern[0] !== "-n" ) {
            signInfo = parseNumberWithNegativePattern( value, nf, "-n" );
            sign = signInfo[0];
            num = signInfo[1];
        }
        sign = sign || "+";
        // determine exponent and number
        var exponent,
            intAndFraction,
            exponentPos = num.indexOf( 'e' );
        if ( exponentPos < 0 ) exponentPos = num.indexOf( 'E' );
        if ( exponentPos < 0 ) {
            intAndFraction = num;
            exponent = null;
        }
        else {
            intAndFraction = num.substr( 0, exponentPos );
            exponent = num.substr( exponentPos + 1 );
        }
        // determine decimal position
        var integer,
            fraction,
            decSep = nf['.'] || '.',
            decimalPos = intAndFraction.indexOf( decSep );
        if ( decimalPos < 0 ) {
            integer = intAndFraction;
            fraction = null;
        }
        else {
            integer = intAndFraction.substr( 0, decimalPos );
            fraction = intAndFraction.substr( decimalPos + decSep.length );
        }
        // handle groups (e.g. 1,000,000)
        var groupSep = nf[","] || ",";
        integer = integer.split(groupSep).join('');
        var altGroupSep = groupSep.replace(/\u00A0/g, " ");
        if ( groupSep !== altGroupSep ) {
            integer = integer.split(altGroupSep).join('');
        }
        // build a natively parsable number string
        var p = sign + integer;
        if ( fraction !== null ) {
            p += '.' + fraction;
        }
        if ( exponent !== null ) {
            // exponent itself may have a number patternd
            var expSignInfo = parseNumberWithNegativePattern( exponent, nf, npattern );
            p += 'e' + (expSignInfo[0] || "+") + expSignInfo[1];
        }
        if ( regexParseFloat.test( p ) ) {
            ret = parseFloat( p );
        }
    }
    return ret;
}

//parsing date takes string as input and return as date object
ej.globalize.parseDate = function(value, formats, culture) {
    culture = ej.globalize.findCulture(culture);

    var date, prop, patterns;
    if ( formats ) {
        if ( typeof formats === "string" ) {
            formats = [ formats ];
        }
        if ( formats.length ) {
            for ( var i = 0, l = formats.length; i < l; i++ ) {
                var format = formats[ i ];
                if ( format ) {
                    date = getParsedDate( value, format, culture );
                    if ( date ) break;
                }
            }
        }
    }
    else {
        patterns = culture.calendar.patterns;
        for ( prop in patterns ) {
            date = getParsedDate( value, patterns[prop], culture );
            if ( date ) break;
        }
    }
    return date || null;
}

function getControlObject(obj, stringArray){
    return stringArray.length ? getControlObject(obj[stringArray[0]], stringArray.slice(1)) : obj;
}

//return localized constants as object for the given widget control and culture
ej.globalize.getLocalizedConstants = function(controlName, culture){
    var returnObject,
        controlNameArray = controlName.replace("ej.", "").split(".");
    
    returnObject = getControlObject(ej, controlNameArray);

    return ( $.extend(true, {}, returnObject.Locale['default'], returnObject.Locale[culture ? culture : this.cultureObject.name]) ) ;
}

$.extend(ej, ej.globalize);

}(jQuery));;
/**
* @fileOverview Plugin to style the Waiting pop elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejWaitingPopup", "ej.WaitingPopup", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,
        _rootCSS: "e-waitingpopup",


        defaults: {

            showOnInit: false,

            target: null,

            appendTo: null,

            showImage: true,

            htmlAttributes: {},

            cssClass: "",

            text: null,

            template: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            showOnInit: "boolean",
            showImage: "boolean",
            cssClass: "string"
        },
		_isTargetVisible: function(){
			return this.element.css('display') != 'none';
		},
        show: function () {
			if(this._isTargetVisible()){
				this._refreshPanel();
				this.maindiv.css("display", "block");
				this.model.showOnInit = true;
			}
        },

        hide: function () {
			this.maindiv.css("display", "none");
			this.model.showOnInit = false;
        },

        refresh: function () {
            if(this._isTargetVisible())
				this._refreshPanel();
        },

        _setText: function (text) {
            if (text) {
                if (this.popupText) this.popupText.html(text);
                else {
                    this._generateTextTag(text);
                    this._setContentPosition();
                }
            }
            else if (this.popupText) {
                this.popupText.remove();
                this.popupText = null;
            }
        },

        _showImage: function (boolean) {
            if (boolean) {
                this.popupImage = ej.buildTag("span.e-image");
                if (this.popupText) this.popupImage.insertBefore(this.popupText);
                else this.maindiv.append(this.popupImage);
            }
            else if (this.popupImage) {
                this.popupImage.remove();
                this.popupImage = null;
            }
        },

        _setTemplate: function () {
            var template = this.model.template;
            if (typeof template === "string") template = $(template);
            if (typeof template === "object" && typeof template.css === "function")
                this.templateObj = template;
            else
                this.templateObj = ej.buildTag("div", "", { "text-align": "center" }).append(template);

            this.templateObj.css({ "visibility": "visible", "display": "block" });
            this.maindiv.append(this.templateObj);
        },

        _setTheme: function (skin) {
            this.maindiv.removeClass(this.model.cssClass).addClass(skin);
        },



        _init: function () {
			this._initialize();
			this._render();
			this._wireEvents();
        },

        _wireEvents: function () {
            $(window).on('resize', $.proxy(this._resizeHandler, this));
        },
        _unwireEvents: function () {
            $(window).off("resize", $.proxy(this._resizeHandler, this));
        },

        _resizeHandler: function () {
            this.refresh();
         },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "text": this._setText(options[option]); break;
                    case "cssClass": this._setTheme(options[option]); break;
                    case "htmlAttributes ": this._addAttr(options[option]); break;
                    case "showOnInit": this._setVisibility(options[option]); break;
                    case "showImage": this._showImage(options[option]); this._setContentPosition(); break;
                    case "target": this.model.target = options[option]; this._setTarget(); this.refresh(); break;
                    case "appendTo": this.model.appendTo = options[option]; this._setTarget();
                        if (!ej.isNullOrUndefined(this.model.appendTo) && this.model.appendTo != "document" && this.model.appendTo != "window")
                            this.maindiv.appendTo($(this.model.appendTo));
                        else
                            $('body').append(this.maindiv);
                        this.refresh(); break;
                    case "template":
                        this.maindiv.empty();
                        if (options[option]) {
                            this.model.template = options[option];
                            this._setTemplate();
                        }
                        else {
                            this.model.template = options[option] = null;
                            this._showImage(this.model.showImage);
                            if (this.model.text) this._generateTextTag(this.model.text);
                        }
                        this._setContentPosition();
                        break;
                }
            }
        },
        _setTarget: function () {
            if (this.model.target == "document") 
                this.targetElement = $(document);
            else if (this.model.target == "window")
                this.targetElement = $(window);
            else
                this.targetElement = this.model.target ? $(this.model.target) : this.element;
        },
        _destroy: function () {
            this.maindiv.remove();
			this._unwireEvents();
        },

        _initialize: function () {
            this.maindiv = null;
            this.popupText = null;
            this.popupImage = null;
            this.templateObj = null;
            this.targetElement = null;
        },


        _render: function () {
            this._setTarget();
            var oldWrapper = $("#" + this.element[0].id + "_WaitingPopup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.maindiv = ej.buildTag("div.e-waitpopup-pane e-widget " + this.model.cssClass + "#" + this.element[0].id + "_WaitingPopup");
            if (this.model.template) {
                this._setTemplate();
            }
            else {
                this._showImage(this.model.showImage);
                if (this.model.text) {
                    this._generateTextTag(this.model.text);
                }
            }
            if (!ej.isNullOrUndefined(this.model.appendTo) && this.model.appendTo != "document" && this.model.appendTo != "window")
                this.maindiv.appendTo($(this.model.appendTo));
            else
                $('body').append(this.maindiv);
            this._setVisibility(this.model.showOnInit);
            this._addAttr(this.model.htmlAttributes);
        },

        _refreshPanel: function () {
            this.maindiv.width(this.targetElement.outerWidth());
            this.maindiv.height(this.targetElement.outerHeight());
            this._setPanelPosition();
            this._setContentPosition();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.maindiv.addClass(value);
                else proxy.maindiv.attr(key, value)
            });
        },

        _setPanelPosition: function () {			 
            var location = ej.util.getOffset(this.targetElement);
			if(this.model.appendTo != null && $(this.model.appendTo).length >0) {				
				if ((this.targetElement.css("position") == "relative" || this.targetElement.css("position") == "absolute") && this.targetElement[0] === $(this.model.appendTo)[0] ) {					
					location = {left:0, top:0};														
				}
				else{
					location.left -= this.targetElement.offsetParent().offset().left;
					location.top -= this.targetElement.offsetParent().offset().top;
				}
			}
            this.maindiv.css({
                "position": "absolute",
                "left": Math.ceil(location.left) + "px",
                "top": Math.ceil(location.top) + "px",
                "z-index": this._maxZindex() + 1
            });
        },

        _setContentPosition: function () {
            if (this.model.template == null) {
                var textHeight = 0, imgHeight = 0, targetHeight, top = null;
                targetHeight = this.targetElement.outerHeight();
                if (this.popupText) textHeight = this.popupText.outerHeight();
                if (this.popupImage) imgHeight = this.popupImage.outerHeight();

                if (this.popupImage) {
                    top = Math.ceil((targetHeight - (imgHeight + textHeight)) / 2);
                    this.popupImage.css("top", top + "px");
                }
                if (this.popupText) {
                    if (!top) top = Math.ceil((targetHeight - textHeight) / 2);
                    this.popupText.css("top", top + "px");
                }
            }
            else {
                this.templateObj.css({
                    "position": "relative",
                    "left": Math.ceil((this.targetElement.outerWidth() - this.templateObj.outerWidth()) / 2),
                    "top": Math.ceil((this.targetElement.outerHeight() - this.templateObj.outerHeight()) / 2)
                });
            }
        },

        _generateTextTag: function (text) {
            this.popupText = ej.buildTag("div.e-text", text);
            this.maindiv.append(this.popupText);
        },

        _setVisibility: function (showOnInit) {
            if (showOnInit && this._isTargetVisible()) this.show();
            else this.hide();
        },

        _maxZindex: function () {
            return ej.util.getZindexPartial(this.element);
        }
    });
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejButton", "ej.Button", {

        element: null,

        model: null,
        validTags: ["button", "input"],
        _setFirst: false,

        _rootCSS: "e-button",
        _requiresID: true,

        defaults: {

            size: "normal",

            type: "submit",

            height: "",

            width: "",

            enabled: true,

            htmlAttributes: {},

            text: null,

            contentType: "textonly",

            imagePosition: "imageleft",

            showRoundedCorner: false,

            cssClass: "",

            prefixIcon: null,

            suffixIcon: null,

            enableRTL: false,

            repeatButton: false,

            timeInterval: "150",

            create: null,

            click: null,

            destroy: null
        },


        dataTypes: {
            size: "enum",
            enabled: "boolean",
            type: "enum",
            showRoundedCorner: "boolean",
            text: "string",
            contentType: "enum",
            imagePosition: "enum",
            prefixIcon: "string",
            suffixIcon: "string",
            cssClass: "string",
            repeatButton: "boolean",
            enableRTL: "boolean",
            timeInterval: "string",
            htmlAttributes: "data"
        },

        disable: function () {
            this.element.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
        },

        enable: function () {
            this.element.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
        },

        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._render();
            this._controlStatus(this.model.enabled);
            this._wireEvents(this.model.repeatButton);
            this._addAttr(this.model.htmlAttributes);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value);
                if (key == "disabled" && value == "disabled") proxy.disable();
            });
        },

        _destroy: function () {
            this._off(this.element, "blur", this._btnBlur);
            this.element.removeClass(this.model.cssClass + "e-ntouch e-btn e-select e-disable e-corner e-widget").removeAttr("role aria-describedby aria-disabled");
            this.element.removeClass("e-btn-" + this.model.size);
            this.model.contentType && this.model.contentType != "textonly" ? this.element.append(this._cloneElement.text()) && this.imgtxtwrap[0].remove() : "";
            
        },


        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "text":
                        this._setText(options[option]);
                        break;
                    case "prefixIcon":
                        this._setMajorIcon(options[option]);
                        break;
                    case "suffixIcon":
                        this._setMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "timeInterval":
                        this.model.timeInterval = options[option];
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },


        _setSize: function (val) {
            this.element.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal');
            this.element.addClass("e-btn-" + val);
        },
        _setType: function (val) {
            this.element.prop({ "type": val });
        },

        _setHeight: function (val) {
            this.element.css('height', val);
        },

        _setWidth: function (val) {
            this.element.css('width', val);
        },

        _setText: function (val) {
            if (this.buttonType == "inputButton") {
                this.element.val(val);
            } else {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.element.html(val);
                } else {
                    this.textspan.html(val);
                }
            }
            this.model.text = val;
        },

        _setMajorIcon: function (val) {
            this.majorimgtag.removeClass(this.model.prefixIcon);
            this.majorimgtag.addClass(val);
            this.model.prefixIcon = val;
        },

        _setMinorIcon: function (val) {
            this.minorimgtag.removeClass(this.model.suffixIcon);
            this.minorimgtag.addClass(val);
            this.model.suffixIcon = val;
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.element.empty();
                this.model.contentType = val;
                this._renderButtonNormal();
            }
        },

        _setImagePosition: function (val) {
            if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                this.element.empty();
                this.model.imagePosition = val;
                this._renderButtonNormal();
            }
        },

        _setRTL: function (val) {
            if (val) {
                this.element.addClass("e-rtl");
            } else {
                this.element.removeClass("e-rtl");
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass);
                this.element.addClass(skin);
            }
        },

        _initialize: function () {
            if(!ej.isTouchDevice()) this.element.addClass("e-ntouch");
            if (this.element.is("input")) {
                this.buttonType = "inputButton";
            }
            else if ((this.element.is("a")) || (this.element.is("button"))) {
                this.buttonType = "tagButton";
            }
            else {
                this.element.removeClass("e-button");
            }
            if (this.element.attr("type")) {
                this.model.type = this.element.attr("type");
            }
            else
                this._setType(this.model.type);
            this._timeout = null;
        },


        _render: function () {
            this._setSize(this.model.size);
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            this._setRTL(this.model.enableRTL);
            this.element.addClass(this.model.cssClass + " e-btn e-select e-widget").attr("role", "button");
            if (this.buttonType == "inputButton") {
                this.element.addClass("e-txt");
                if ((this.model.text != null) && (this.model.text != "")) {
                    this.element.val(this.model.text);
                } else {
                    this.model.text = this.element.val();
                }
            } else { this._renderButtonNormal(); }
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.text)
                this.element.attr("aria-describedby", this.model.text);
        },

        _renderButtonNormal: function () {
            if ((this.model.text == null) || (this.model.text == "")) {
                this.model.text = this.element.html();
            }
            this.element.empty();
            /*Image and Text*/
            this.textspan = ej.buildTag('span.e-btntxt', this.model.text);
            if (this.model.contentType.indexOf("image") > -1) {
                this.majorimgtag = ej.buildTag('span').addClass(this.model.prefixIcon);
                this.minorimgtag = ej.buildTag('span').addClass(this.model.suffixIcon);
                this.imgtxtwrap = ej.buildTag('div');
            }

            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.majorimgtag.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.majorimgtag.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                }
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.majorimgtag, this.textspan, this.minorimgtag);
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.majorimgtag, this.minorimgtag);
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.majorimgtag);
                this.element.append(this.imgtxtwrap);
            } else {
                this.element.addClass("e-txt");
                this.element.html(this.model.text);
            }
        },

        _roundedCorner: function (value) {
            value == true ? this.element.addClass('e-corner') : this.element.removeClass('e-corner');
        },

        _wireEvents: function (val) {
            if (val) {
                this._on(this.element, "mousedown", this._btnRepatMouseClickEvent);
                this._on($(document), 'mouseup', this._mouseUpClick);
                this._on(this.element, "keyup", this._btnRepatKeyUpEvent);
                this._on($(document), "keypress", this._btnRepatKeyDownEvent);

            }
            this._on(this.element, "click", this._btnMouseClickEvent);
            this._on(this.element, "blur", this._btnBlur);
        },

        _btnBlur:function(e){
            this.element.removeClass("e-animate");
        },

        _btnMouseClickEvent: function (e) {
            var self = this;
            this.element.addClass("e-animate");
            if(!self.model.enabled) return false;
            if (!self.element.hasClass("e-disable")) {
                // here aregument 'e' used in serverside events 
                var args = { target: e.currentTarget, e : e , status:self.model.enabled};
                self._trigger("click", args);
            } 
        },

        _btnRepatMouseClickEvent: function (e) {
            var self = this;
            if(!self.model.enabled) return false;
            if (!self.element.hasClass("e-disable")) {
                var args = { status: self.model.enabled };
                if ((e.button == 0) || (e.which == 1)) {

                    self._timeout = setInterval(function () { self._trigger("click", { target: e.currentTarget, status: self.model.enabled }); }, this.model.timeInterval);
                }
            }
        },

        _mouseUpClick: function (event) {
            clearTimeout(this._timeout);
        },

        _btnRepatKeyDownEvent: function (e) {
            var self = this;
            if (!self.element.hasClass("e-disable")) {
                var args = { status: self.model.enabled };
                if ((e.keyCode == 32) || (e.keyCode == 13)) {
                    self._trigger("click", args);
                }
            }
        },

        _btnRepatKeyUpEvent: function (e) {
            if ((e.keyCode == 32) || (e.keyCode == 13)) {
                clearTimeout(this._timeout);
            }
        },
    });


    ej.ContentType = {
		/**  Supports only for text content only */
		TextOnly: "textonly", 
		/** Supports only for image content only */
		ImageOnly: "imageonly", 
		/** Supports image for both ends of the button */
		ImageBoth: "imageboth", 
		/** Supports image with the text content */
		TextAndImage: "textandimage", 
		/** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
		/**  support for aligning text in left and image in right. */
		ImageRight: "imageright", 
		/**  support for aligning text in right and image in left. */
		ImageLeft: "imageleft",
		/**  support for aligning text in bottom and image in top. */
		ImageTop: "imagetop", 
		/**  support for aligning text in top and image in bottom. */
		ImageBottom: "imagebottom"
    };

    ej.ButtonSize = {
		/**  Creates button with inbuilt default size height, width specified */
		Normal : "normal",
		/**  Creates button with inbuilt mini size height, width specified */
		Mini: "mini", 
		/**  Creates button with inbuilt small size height, width specified */
		Small: "small",
		/**  Creates button with inbuilt medium size height, width specified */
		Medium:"medium", 
		/**  Creates button with inbuilt large size height, width specified */
        Large: "large"
    };

    ej.ButtonType = {
		/**  Creates button with inbuilt button type specified */
		Button : "button",
		/**  Creates button with inbuilt reset type specified */
		Reset: "reset", 
		/**  Creates button with inbuilt submit type specified */
		Submit: "submit"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Calculate engine to perform the calculatin
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.3 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    
    //JS-48438 'this' is not a reference of the object in 'use strict' mode. 
    window.__calcQuickextends = function (d, b) {
        for (var p = 0; p < b.length; p++) if (b.hasOwnProperty(p)) d[p] = b[p];
        function __() { this.constructor = d; }
        __.prototype = b.prototype;
        d.prototype = new __();
    };
    
	/**
    * @namespace ej
	* @classdesc Custom engine to perfom calculation like excel sheet
	* @class ejCalculate
	* @requires jQuery
	* @requires ej.core.js
	* @requires ej.calculate.js
	* @example 
    * &lt;script&gt;
	* // Create calcEngine with grid data
    * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
	* &lt;/script&gt;
	*/
    CalcEngine = function (parentObject) {
        this.parentObject = parentObject;
        this._useFormulaValues = false;
        this._multiTick = false;
        this._isErrorString = false;
        this._ignoreBracet = false;
        this._libraryFunctions = new HashTable();
        this._customlibraryFunctions = new HashTable();
        this._refreshedCells = new HashTable();
        this._treatStringsAsZero = true;
        this._supportLogicalOperators = false;
        this._isRangeOperand = false;
        this._uniqueStringMarker = String.fromCharCode(127);
        this._isParseArgumentSeparator = false;
        this._isParseDecimalSeparatorChanged = false;
        this._enableFormulaErrorValidation = false;
        this._validPrecedingChars = " (+-*/^&<>=";
        this._validFunctionNameChars = "_";
        this.bMARKER = String.fromCharCode(146);
        this.bMARKER2 = this.bMARKER + this.bMARKER;
        this.tic = "\"";
        this._parseDecimalSeparator = '.';
        this.parseDateTimeSeparator = '/';
        this._parseArgumentSeparator = ',';
        this._rightBracket = String.fromCharCode(131);
        this._leftBracket = String.fromCharCode(130);
        this.iFMarker = "qIF" + String.fromCharCode(130);
        this.braceLeft = "{";
        this.braceRight = "}";
        this._braceRightNLeft = ")(";
        this.computedValueLevel = 0;
        this._circCheckList = [];
        this._maximumRecursiveCalls = 100;
        this._sortedSheetNames = null;
        this.trueValueStr = "TRUE";
        this.falseValueStr = "FALSE";
        this.useDatesInCalcs = false;
        this.sheetToken = '!';
        this.namedRanges = null;
        this.undefinednamedRange = null;
        this.undefinedsheetNamedRnages = null;
        this.namerangecellcollection = null;
        this.sheetNamedRangesOriginalNames = null;
        this.sheetNamedRangeCellCollection = null;
        this.sheetDependentNamedRangeCells = null;
        this.namedRangesOriginalNames = null;
        this.namedRangeValues = null;
        this.rangeValues = null;
        this.dependentNamedRangeCells = null;
        this.namedRangesSized = null;
        this._namedRangesNonScoped = null;
        this.char_add = '+';
        this.char_and = 'i';
        this.char_ANDop = String.fromCharCode(140);
        this.char_divide = '/';
        this.char_ELSEop = String.fromCharCode(144);
        this.char_EM = 'r';
        this.char_EP = 'x';
        this.char_equal = '=';
        this.char_greater = '>';
        this.char_greatereq = 'h';
        this.char_IFop = String.fromCharCode(142);
        this.char_less = '<';
        this.char_lesseq = 'f';
        this.char_multiply = '*';
        this.char_noequal = 'p';
        this.char_NOTop = String.fromCharCode(145);
        this.char_or = 'w';
        this.char_ORop = String.fromCharCode(139);
        this.char_subtract = '-';
        this.char_THENop = String.fromCharCode(143);
        this.char_XORop = String.fromCharCode(141);
        this.chartic = "'"[0];
        this._string_and = "&";
        this._string_E = "E";
        this._string_EM = "E-";
        this._string_empty = "";
        this._string_EP = "E+";
        this._string_fixedreference = "$";
        this._string_greatereq = ">=";
        this._string_lesseq = "<=";
        this._string_noequal = "<>";
        this._string_or = "^";
        this.token_add = 'a';
        this.token_and = 'c';
        this.token_ANDop = String.fromCharCode(133);
        this.token_divide = 'd';
        this.token_ELSEop = String.fromCharCode(137);
        this.token_EM = 'v';
        this.token_EP = 't';
        this.token_equal = 'e';
        this.token_greater = 'g';
        this.token_greatereq = 'j';
        this.token_IFop = String.fromCharCode(135);
        this.token_less = 'l';
        this.token_lesseq = 'k';
        this.token_multiply = 'm';
        this.token_noequal = 'o';
        this.token_NOTop = String.fromCharCode(138);
        this.token_or = String.fromCharCode(126);
        this.token_ORop = String.fromCharCode(132);
        this.token_subtract = 's';
        this.token_THENop = String.fromCharCode(136);
        this.token_XORop = String.fromCharCode(134);
        this.tokens = [
            this.token_add, this.token_subtract, this.token_multiply, this.token_divide, this.token_less,
            this.token_greater, this.token_equal, this.token_lesseq, this.token_greatereq, this.token_noequal, this.token_and, this.token_or];
        this._dateTime1900 = new Date(1900, 0, 1, 0, 0, 0);
        this._preserveLeadingZeros = false;
        this._ignoreCellValue = false;
        this._errorStrings = null;
        this._cell = "";
        this._iterationMaxCount = 0;
        this._supportRangeOperands = false;
        this._allowShortCircuitIFs = false;
        this._processUpperCaseFormula = "";
        this._processUpperCaseIvalue = 0;
        this._processUpperCaseSheet = "";
        this._markerChar = '`';
        this._rowMaxCount = -1;
        this._columnMaxCount = -1;
        this._isInteriorFunction = false;
        this._tempSheetPlaceHolder = String.fromCharCode(133);
        this.sheetFamilyID = 0;
        this._supportsSheetRanges = true;
        this._markers = "()+-*/=><.,!";
        this._formulaInfoTable = null;
        this._dependentFormulaCells = null;
        this._dependentCells = new HashTable();
        this._calculatingSuspended = false;
        this._inAPull = false;
        this._useDatesInCalcs = false;
        this._excelLikeComputations = false;
        this._rethrowLibraryComputationExceptions = false;
        this.formulaErrorStrings = [
            "binary operators cannot start an expression",
            "cannot parse",
            "bad library",
            "invalid char in front of",
            "number contains 2 decimal points",
            "expression cannot end with an operator",
            "invalid characters following an operator",
            "invalid character in number",
            "mismatched parentheses",
            "unknown formula name",
            "requires a single argument",
            "requires 3 arguments",
            "invalid Math argument",
            "requires 2 arguments",
            "#NAME?",
            "too complex",
            "circular reference: ",
            "missing formula",
            "improper formula",
            "invalid expression",
            "cell empty",
            "bad formula",
            "empty expression",
            "",
            "mismatched string quotes",
            "wrong number of arguments",
            "invalid arguments",
            "iterations do not converge",
            "Control named '{0}' is already registered",
            "Calculation overflow",
            "Missing sheet"
        ];
        this._parseDateTimeSeparator = '/';
        this._millisecondsOfaDay = 24 * 60 * 60 * 1000;
        this.treat1900AsLeapYear = false;
        this._oaDate = new Date(1899, 11, 30);
        this._saveStringsText = "";
        this._processedCells = [];
        this.ignoreValueChanged = false;
        this._breakedFormulaCells = [];
        this._tempBreakedFormulaCells = [];
        this._lockDependencies = false;
        this._useDependencies = false;
        this._inHandleIterations = false;
        this._inRecalculateRange = false;
        this._useNoAmpersandQuotes = false;
        this._calcID = 0;
        this._operators_cannot_start_an_expression = 0;
        this._reservedWord_AND = 1;
        this._reservedWord_XOR = 2;
        this._reservedWord_IF = 3;
        this._number_contains_2_decimal_points = 4;
        this._reservedWord_ELSE = 5;
        this._reservedWord_NOT = 6;
        this._invalid_char_in_number = 7;
        this._invalid_characters_following_an_operator = 6;
        this._mismatched_parentheses = 8;
        this._unknown_formula_name = 9;
        this._requires_a_single_argument = 10;
        this._requires_3_args = 11;
        this._invalid_Math_argument = 12;
        this._requires_2_args = 13;
        this._bad_index = 14;
        this._too_complex = 15;
        this._circular_reference_ = 16;
        this._missing_formula = 17;
        this._improper_formula = 18;
        this._invalid_expression = 19;
        this._cell_empty = 20;
        this._bad_formula = 21;
        this._empty_expression = 22;
        this._virtual_mode_required = 23;
        this._mismatched_tics = 24;
        this._wrong_number_arguments = 25;
        this._invalid_arguments = 26;
        this._iterations_dont_converge = 27;
        this._calculation_overflow = 29;
        this._already_registered = 28;
        this._missing_sheet = 30;
        this._alwaysComputeDuringRefresh = true;
        this._libraryComputationException = null;
        this._dependencyLevel = 0;
        this._isDisposed = undefined;
        this._forceRefreshCall = false;
        this.grid = this.parentObject;
        this._enableLookupTableCaching = 0 /* None */;
        this._lookupTables = new HashTable();
        this._isIE8 = (ej.browserInfo().name == 'msie' && ej.browserInfo().version == '8.0') ? true : false;

		/**
         * 
		 * @private
         */	 
        this._addFunction = function (name, func) {
            name = name.toUpperCase();
            if (this._libraryFunctions.getItem(name) == undefined) {
                this._libraryFunctions.add(name, func);
                return true;
            }
            return false;
        };
        /**
         * 
		 * @private
         */
		 this._addToFormulaDependentCells = function (s) {
            var cell1 = this.cell;
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family.sheetNameToParentObject != null && cell1.indexOf(this.sheetToken) == -1) {
                var token = family.parentObjectToToken.getItem(this.grid);
                cell1 = token + cell1;
            }

            if (!this.getDependentFormulaCells().containsKey(cell1)) {
                this.getDependentFormulaCells().add(cell1, new HashTable());
                this.getDependentFormulaCells().getItem(cell1).add(s, s);
            } else if (!(this.getDependentFormulaCells().getItem(cell1)).containsKey(s)) {
                this.getDependentFormulaCells().getItem(cell1).add(s, s);
            }
        };
        /**
         * 
		 * @private
         */
		 this._arrayRemove = function (array, value) {
            var index = null;

            while ((index = array.indexOf(value)) !== -1)
                array.splice(index, 1);

            return array;
        };
        /**
         * 
		 * @private
         */
		 this._canGetRowIndex = function (s) {
            var i = 0;
            if (i < s.length && s[i] == this.sheetToken) {
                i++;
                while (i < s.length && s[i] != this.sheetToken) {
                    i++;
                }
                i++;
            }

            while (i < s.length && this._isLetter(s[i])) {
                i++;
            }

            if (i < s.length) {
                if (this._isDigit(s[i]))
                    return true;
                else
                    return false;
            }
            return false;
        };
        /**
         * 
		 * @private
         */
		 this._checkAddNonScopedNamedRange = function (key) {
            var loc = -1;
            if ((loc = key.indexOf('!')) > -1) {
                var key1 = key.substring(loc + 1);
                if (!this._namedRangesNonScoped.containsKey(key1)) {
                    this._namedRangesNonScoped.add(key1, this.namedRanges.getItem(key));
                }
            }
        };
        /**
         * 
		 * @private
         */
		 this._checkHasCharBeforeNumber = function (tempFormula) {
            var check = false;
            for (var x = tempFormula.length - 1; x > 0; x--) {
                if (this._isLetter(tempFormula[x])) {
                    check = true;
                    break;
                }
            }
            return check;
        };
        /**
         * 
		 * @private
         */
		this._checkIfScopedRange = function (text, scopedRange) {
            scopedRange = "";
            var b = "NaN";
            var id = this.getSheetID(this.grid);
            var sheet = CalcEngine.getSheetFamilyItem(this.grid);

            if (text[0] == this.sheetToken.toString()) {
                var i = text.indexOf(this.sheetToken, 1);
                if (i > 1 && !isNaN(parseInt(text.substring(1, i - 1)))) {
                    //id reset to proper value
                    text = text.substring(i + 1);
                }
            }

            var token = '!' + id.toString() + '!';

            if (sheet.sheetNameToToken == null)
                return b;
            var sheetNameKeys = sheet.sheetNameToToken.keys();
            for (var name = 0; name < sheetNameKeys.length; name++) {
                if (sheet.sheetNameToToken.getItem(sheetNameKeys[name]).toString() == token) {
                    var s = (sheetNameKeys[name] + '!' + text).toUpperCase();
                    if (this.getNamedRanges().containsKey(s)) {
                        scopedRange = (this.getNamedRanges().getItem(s)).toUpperCase();
                        b = scopedRange;
                    }
                }
            }
            return b;
        };
        /**
         * 
		 * @private
         */
		this._checkUnderTolerance = function (d, oldValue) {
            if (Math.abs(oldValue) > this._absoluteZero) {
                return Math.abs((d - oldValue) / oldValue) < this._iterationMaxTolerance;
            } else {
                return Math.abs(d - oldValue) < this._iterationMaxTolerance;
            }
        };
        /**
         * 
		 * @private
        */
		this._combineStack = function (formula, i, _tempStack) {
            var combineString = "";
            if (_tempStack.length == 2) {
                var j = 3;
                var checkString = formula.substring(i);
                while (j > 1) {
                    var popStringValue = _tempStack.pop().toString();
                    combineString = (popStringValue == (this.tic + this.tic)) ? combineString + this.tic : popStringValue + combineString;
                    checkString = (j == 3) ? popStringValue : checkString;
                    j--;
                }
                if (_tempStack[0] == (this.tic + this.tic))
                    _tempStack.pop();
                combineString = (formula.length == i && this._isTextEmpty(checkString.split(this.tic).join(""))) ? combineString + checkString : combineString;

                _tempStack.push(combineString);
            }
            return _tempStack;
        };
        /**
         * 
		 * @private
        */
		this._computeMath = function (args, func) {
            var ans = 0;
            var s1;
            var isDegree = false;

            ////Only work with first arg.
            if (args.length > 0) {
                args = this.splitArgsPreservingQuotedCommas(args)[0];
            }
            var indexArray = [this.getParseArgumentSeparator(), ':'];

            ////parsed formula
            if (args.length > 0 && ((!this._isLetter(args[0]) && args[0] != this.sheetToken && args[0] != this.bMARKER) || (args[0] == 'u' && this._isDigit(args[1]))) && this._indexOfAny(args, indexArray) == -1) {
                ////Swap out unary minus.
                args = (args.split('u').join('-')).split("n").join("");

                var d1 = this._parseDouble(args);

                if (!isNaN(d1)) {
                    ans = func(d1);
                } else {
                    return this.getErrorStrings()[1].toString();
                }
            } else if (args.length > 0 && (args[0] == this.bMARKER || args[0] == 'u' || args[0] == 'n' || this._indexOfAny(args, this.tokens) > -1)) {
                ////parsed formula
                args = args.split('{').join('(');
                args = args.split('}').join(')');
                var rightparam = "";
                var decimalPI = (Math.PI).toString();
                try  {
                    if (args.indexOf(decimalPI) > -1) {
                        s1 = this._substring(args, 1, args.indexOf(decimalPI) - 2);
                        s1 = (this._isTextEmpty(s1)) ? "1" : s1;
                        rightparam = (this._indexOfAny(args, this.tokens) > -1) ? args.split(decimalPI.toString())[1] : "1";
                        isDegree = true;
                    } else
                        s1 = this.computedValue(args);
                } catch (ex) {
                    if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                        throw this.getLibraryComputationException();
                    }

                    return ex;
                }
                if (isDegree) {
                    var leftparam = this.computedValue(s1.toString());
                    if (rightparam.indexOf("180") > -1) {
                        d1 = this._parseDouble(leftparam);
                        if (d1)
                            ans = func(d1 * (Math.PI / 180));
                        else {
                            return this.getErrorStrings()[1].toString();
                        }
                    } else {
                        var temp, d2;
                        temp = this.computedValue(leftparam + rightparam);
                        d2 = this._parseDouble(temp);
                        if (!isNaN(d2))
                            ans = func(d2 * (Math.PI));
                        else {
                            return this.getErrorStrings()[1].toString();
                        }
                    }
                } else {
                    d1 = this._parseDouble(s1);
                    if (!isNaN(d1))
                        ans = func(d1);
                    else {
                        return this.getErrorStrings()[1].toString();
                    }
                }
            } else {
                ////Swap out unary minus.
                args = args.split('u').join('-');
                var cells = this.getCellsFromArgs(args);
                for (var s = 0; s < cells.length; s++) {
                    try  {
                        s1 = this.getValueFromArg(cells[s]);
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        d1 = this._parseDouble(s1);
                        if (!isNaN(d1)) {
                            ans = func(d1);
                        } else
                            return this.getErrorStrings()[1].toString();
                    }

                    break;
                }
            }
            if (this.computeIsErr(ans.toString()) == this.trueValueStr) {
                return this.getErrorStrings()[4].toString();
            }
            return ans.toString();
        };
        /**
         * 
		 * @private
        */
		this._computeInteriorFunctions = function (formula) {
            try  {
                if (this._isTextEmpty(formula)) {
                    return formula;
                }

                this.computeFunctionLevel++;

                ////int q = formula.LastIndexOf('q');
                var q = this._findLastqNotInBrackets(formula);
                while (q > 0) {
                    var last = formula.substring(q).indexOf(this._rightBracket);
                    if (last == -1) {
                        throw this.formulaErrorStrings[this._bad_formula];
                    }
                    this._isInteriorFunction = true;
                    var s = this._substring(formula, q, last + 1);
                    s = this.computedValue(s);
                    if (!(s == "") && s[0] == this.tic[0] && s[s.length - 1] == this.tic[0]) {
                        var newS = this._substring(s, 1, s.length - 2);
                        if (newS.indexOf(this.tic) != -1) {
                            this._multiTick = true;
                            newS = newS.split(this.tic).join("|");
                        }
                        s = this.tic + newS + this.tic;
                    }
                    s = this._markupResultToIncludeInFormula(s);
                    if (!this._isInteriorFunction)
                        formula = formula.substring(0, q) + s.split(this.tic).join("") + formula.substring(q + last + 1);
                    else
                        formula = formula.substring(0, q) + s + formula.substring(q + last + 1);
                    this._isInteriorFunction = false;
                    q = this._findLastqNotInBrackets(formula);
                }
            } catch (ex) {
                return ex;
            } finally {
                this.computeFunctionLevel--;
            }

            return formula;
        };
        /**
         * 
		 * @private
        */
		this._findAndCheckPrecedingChar = function (copy, op, loc) {
            var loc1 = copy.indexOf(op, loc);
            if (loc1 > 0) {
                while (loc1 > -1 && this.getValidPrecedingChars().indexOf(copy[loc1 - 1]) == -1) {
                    loc1 = copy.indexOf(op, loc1 + 1);
                }
            }
            this._findAndCheckPrecedingCharCopy = copy;
            return loc1;
        };
        /**
         * 
		 * @private
        */
		this._findLastNonQB = function (text) {
            var ret = -1;
            if (text.indexOf(this.bMARKER) > -1) {
                var bracketLevel = 0;
                for (var i = text.length - 1; i >= 0; --i) {
                    if (text[i] == this._rightBracket) {
                        bracketLevel--;
                    } else if (text[i] == this._leftBracket) {
                        bracketLevel++;
                    } else if (text[i] == this.bMARKER && bracketLevel == 0) {
                        ret = i;
                        break;
                    }
                }
            }

            return ret;
        };
        /**
         * 
		 * @private
        */
		this._findLastqNotInBrackets = function (s) {
            var found = -1;
            var lastBracket = false;
            var i = s.length - 1;
            while (i > -1) {
                if (s[i] == 'q' && lastBracket) {
                    found = i;
                    break;
                }

                if (s[i] == this._leftBracket) {
                    lastBracket = true;
                } else if (s[i] == this._rightBracket) {
                    lastBracket = false;
                }

                i--;
            }

            return found;
        };
        /**
         * 
		 * @private
        */
		this._findNextSeparator = function (formula, location) {
            var qCount = 0;
            var found = false;
            while (!found && location < formula.length) {
                if (formula[location] == 'q') {
                    qCount++;
                } else if (formula[location] == this._rightBracket) {
                    qCount--;
                } else if (qCount == 0 && formula[location] == this.getParseArgumentSeparator()) {
                    found = true;
                    location--;
                }

                location++;
            }
		    return location.toString();
		};
        /**
         * 
		 * @private
        */
		this._findNextEndIndex = function (formula, location) {
		    var count = 0;
		    var loc = location;
		    var found = false;
		    while (!found && location < formula.Length) {
		        if (formula[location] == '[') {
		            count++;
		        }
		        else if (formula[location] == ']') {
		            count--;
		            if (count == 0) {
		                found = true;
		            }
		        }
		        location++;
		    }
		    location = location - loc;
		    return location;
		};

        /**
         * 
		 * @private
        */
		this._findNonQB = function (text) {
            var ret = -1;
            if (text.indexOf(this.bMARKER) > -1) {
                var bracketLevel = 0;
                for (var i = 0; i < text.length; ++i) {
                    if (text[i] == this._rightBracket) {
                        bracketLevel--;
                    } else if (text[i] == this._leftBracket) {
                        bracketLevel++;
                    } else if (text[i] == this.bMARKER && bracketLevel == 0) {
                        ret = i;
                        break;
                    }
                }
            }

            return ret;
        };
        /**
         * 
		 * @private
        */
		this._findRightBracket = function (formula, location) {
            var qCount = 0;
            var found = false;
            while (!found && location < formula.length) {
                if (formula[location] == 'q') {
                    qCount++;
                } else if (qCount == 0 && formula[location] == this._rightBracket) {
                    found = true;
                    location--;
                } else if (formula[location] == this._rightBracket) {
                    qCount--;
                }

                location++;
            }

            if (found)
                return location.toString();
            else
                return "NaN";
        };
        /**
         * 
		 * @private
        */
		this._fromOADate = function (doubleNumber) {
            var result = new Date();
            result.setTime((doubleNumber * this._millisecondsOfaDay) + Date.parse(this._oaDate));
            return result;
        };
        /**
         * 
		 * @private
        */
		this._getDateFromSerialDate = function (days) {
            if (this.treat1900AsLeapYear && days > 59) {
                days -= 1;
            }

            return new Date(this._oaDate.setDate(this._oaDate.getDate() + days));
		};


        /**
        * 
        * @private
       */
		var _weekEndType = ["", "6,0", "0,1", "1,2", "2,3", "3,4", "4,5", "5,6", "", "", "", "0", "1", "2", "3", "4", "5", "6"];

        /**
         * 
		 * @private
        */
		this._getDoubleArray = function (range) {
            var d;
            var s1 = "";
            var x = [];

            range = this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            for (var r = 0; r < ranges.length; r++) {
                ////cell range
                if (ranges[r].indexOf(':') > -1) {
                    var cells = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cells.length; s++) {
                        s1 = this.getValueFromArg(cells[s]);
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d)) {
                                x.push(Number(d));
                            } else {
                                x.push(0.0);
                            }
                        }
                    }
                } else {
                    s1 = this.getValueFromArg(ranges[r]);
                    s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                    d = this._parseDouble(s1);
                    if (!isNaN(Number(d))) {
                        x.push(d);
                    } else {
                        x.push(0.0);
                    }
                }
            }
            return x;
        };
        /**
         * 
		 * @private
        */
		this._getDoubleArrayA = function (range) {
            var d;
            var s1 = "";
            var x = [];

            range = this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            for (var r = 0; r < ranges.length; r++) {
                ////cell range
                if (ranges[r].indexOf(':') > -1) {
                    var cells = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cells.length; s++) {
                        s1 = this.getValueFromArg(cells[s]);

                        if (s1.length > 0) {
                            if (s1 == this.trueValueStr){
                                d = 1.0;
                            } else {
                                d = this._parseDouble(s1);
                                if (isNaN(Number(d))) {
                                    d == 0.0;
                                }
                            }
                            x.push(d);
                        }
                    }
                } else {
                    s1 = this.getValueFromArg(ranges[r]);
                    if (s1 == this.trueValueStr){
                        d = 1.0;
                    } else {
                        d = this._parseDouble(s1.toString());
                        if (isNaN(d)) {
                            d = 0.0;
                        }
                    }
                    x.push(d);
                }
            }
            return x;
        };
        /**
         * 
		 * @private
        */
		this._getFormulaArrayBounds = function (currentCell, arrayHeight, arrayWidth) {
            var currentColIndex = this.colIndex(this.cell);
            var currentRowIndex = this.rowIndex(this.cell);

            var formulaText = "";
            var formula = this.getFormulaInfoTable().containsKey(this.cell) ? this.getFormulaInfoTable().getItem(this.cell) : null;
            if (formula != null)
                formulaText = formula.getFormulaText();
            else if (this.parentObject.getValueRowCol == undefined)
                formulaText = this.getValueRowCol(this.getSheetID(this.grid) + 1, currentRowIndex, currentColIndex);
            else
                formulaText = this.parentObject.getValueRowCol(this.getSheetID(this.grid)+1, currentRowIndex, currentColIndex);
            var startRowIndex = 1, startColIndex = 1;
            for (var x = 1; x <= arrayHeight; x++) {
                if ((currentColIndex - x) > 0) {
                    var tempCell = this._getSheetTokenFromReference(this.cell) + RangeInfo.getAlphaLabel(currentColIndex - x) + currentRowIndex.toString();
                    var tempFormulaText = "";
                    var formula1 = this.getFormulaInfoTable().containsKey(tempCell) ? this.getFormulaInfoTable().getItem(tempCell) : null;
                    if (formula1 != null)
                        tempFormulaText = formula1.getFormulaText();
                    else if (this.parentObject.getValueRowCol == undefined)
                        tempFormulaText = this.getValueRowCol(this.getSheetID(this.grid) + 1, currentRowIndex, currentColIndex - x);
                    else
                        tempFormulaText = this.parentObject.getValueRowCol(this.getSheetID(this.grid) + 1, currentRowIndex, currentColIndex - x);
                    startColIndex = currentColIndex - x;
                    if (formulaText != null && tempFormulaText != formulaText) {
                        startColIndex++;
                        break;
                    }
                }
            }
            for (var y = 1; y <= arrayWidth; y++) {
                if ((currentRowIndex - y) > 0) {
                    var tempCell = this._getSheetTokenFromReference(this.cell) + RangeInfo.getAlphaLabel(startColIndex) + (currentRowIndex - y).toString();
                    var tempFormulaText = "";
                    var formula1 = this.getFormulaInfoTable().containsKey(tempCell) ? this.getFormulaInfoTable().getItem(tempCell) : null;
                    if (formula1 != null)
                        tempFormulaText = formula1.getFormulaText();
                    else if (this.parentObject.getValueRowCol == undefined)
                        tempFormulaText = this.getValueRowCol(this.getSheetID(this.grid) + 1, currentRowIndex - y, startColIndex);
                    else
                        tempFormulaText = this.parentObject.getValueRowCol(this.getSheetID(this.grid) + 1, currentRowIndex - y, startColIndex);
                    startRowIndex = currentRowIndex - y;
                    if (formulaText != null && tempFormulaText != formulaText) {
                        startRowIndex++;
                        break;
                    }
                }
            }

            this._getFormulaArrayBoundsfirstRowIndex = startRowIndex;
            this._getFormulaArrayBoundsfirstColIndex = startColIndex;
            this._getFormulaArrayBoundslastRowIndex = startRowIndex + arrayHeight;
            this._getFormulaArrayBoundslastColIndex = startColIndex + arrayWidth;
            return true;
		};

		var FormulaArgumentType = {
		    None: {},
		    Range: {},
		    CellReference: {},
		    TwoTextWithNumber: {},
		    TextWithNumber: {},
		    Numbers: {},
		    Text: {},
		    Date: {},
		};

		this.formulaErrorStringCheck = function (args, argumentType) {
		    var splitArguments = this.splitArgsPreservingQuotedCommas(args);
		    switch (argumentType) {
		        case FormulaArgumentType.None: {
		            if (args != "") {
		                if (this.getRethrowLibraryComputationExceptions())
		                    throw this.getLibraryComputationException();
		                return this.formulaErrorStrings[this._invalid_arguments];
		            }
		            break;
		        }

		        case FormulaArgumentType.Range: {
		            var s2 = "";
		            var argumentsArray = splitArguments;
		            if (argumentsArray != null) {
		                for (var i = 0; i < argumentsArray.length; i++) {
		                    var argument = argumentsArray[i];
		                    if (argument.indexOf(':') > -1) {
		                        if (argument[0] == this.tic) {
		                            if (this.getRethrowLibraryComputationExceptions())
		                                throw this.getLibraryComputationException();
		                            return this._errorStrings[1].toString();
		                        }
		                        var cellValues = this.getCellsFromArgs(argument);
		                        for (var j = 0; j < cellValues.length; j++) {
		                            try {
		                                s2 = this.getValueFromArg(j);
		                            }
		                            catch (ex) {
		                            }
		                            if (s2.length > 0) {
		                                if (this.getErrorStrings().indexOf(s2) > -1) {
		                                    if (this.getRethrowLibraryComputationExceptions())
		                                        throw this.getLibraryComputationException();
		                                    return s2;
		                                }
		                            }
		                        }

		                    }
		                    else {
		                        try {
		                            s2 = this.getValueFromArg(argument);
		                        }
		                        catch (ex) {
		                        }
		                        if (s2.length > 0) {
		                            var checkString = this.formulaErrorStringCheck(s2, FormulaArgumentType.Numbers);
		                            if (this.getErrorStrings().indexOf(checkString) > -1) {
		                                return checkString;
		                            }
		                        }
		                    }

		                }
		            }
		            break;
		        }

		        case FormulaArgumentType.CellReference: {
		            var argumentsArray = splitArguments;
		            if (argumentsArray != null) {
		                for (var i = 0; i < argumentsArray.length; i++) {
		                    var argument = argumentsArray[i];
		                    if (!this._isCellReference(argument) && argument[0] == this.tic) {
		                        return this.getErrorStrings()[1].toString();
		                    }
		                    else if (!this._isCellReference(argument)) {
		                        return this.getErrorStrings()[5].toString();
		                    }
		                }
		            }
		            break;
		        }

		        case FormulaArgumentType.TwoTextWithNumber: {
		            var argument1 = this.formulaErrorStringCheck(splitArguments[0], FormulaArgumentType.Text);
		            if (this.getErrorStrings().indexOf(argument1) > -1) {
		                return argument1;
		            }
		            var argument2 = this.formulaErrorStringCheck(splitArguments[1], FormulaArgumentType.Text);
		            if (this.getErrorStrings().indexOf(argument2) > -1) {
		                return argument2;
		            }
		            //Third argument is not mandatory. So argument length is checked to avoid Index out of range exception
		            if (splitArguments.length == 3) {
		                var argument3 = this.formulaErrorStringCheck(splitArguments[2], FormulaArgumentType.Text);
		                if (this.getErrorStrings().indexOf(argument3) > -1) {
		                    return argument3;
		                }
		            }
		            break;
		        }

		        case FormulaArgumentType.TextWithNumber: {
		            var d1 = 0; d2 = 0;
		            var s = this.getValueFromArg(splitArguments[0].split(this.tic).join(""));
		            var trueFalseString1 = Boolean(s);
		            var trueFalseString2 = (splitArguments.length == 2 && isNaN(typeof this.getValueFromArg(splitArguments[1]) == "boolean"));
		            var d1 = isNaN(this._parseDouble(splitArguments[0].split(this.tic).join("")));
		            if (d1) {
		                var argumentValue = this.getValueFromArg(splitArguments[0]);
		                if (this.getErrorStrings().indexOf(argumentValue) > -1) {
		                    if (this.getRethrowLibraryComputationExceptions())
		                        throw this.getLibraryComputationException();
		                    return argumentValue;
		                }
		            }
		            var d2 = isNaN(this._parseDouble(splitArguments[1].split(this.tic).join("")));
		            if ((splitArguments.length == 2) && d2) {
		                var checkString = this.formulaErrorStringCheck(splitArguments[1], FormulaArgumentType.Numbers);
		                if (this.getErrorStrings().indexOf(checkString) > -1) {
		                    return checkString;
		                }
		            }
		            break;
		        }

		        case FormulaArgumentType.Text: {
		            var d1;
		            var argumentArray = splitArguments;
		            for (var i = 0; i < argumentArray.length; i++) {
		                var s = this.getValueFromArg(argumentArray[i]);
		                var trueFalseString1 = Boolean(s);
		                var d1 = isNaN(this._parseDouble(argumentArray[i].split(this.tic).join("")));
		                if (d1) {
		                    var argumentValue = this.getValueFromArg(argumentArray[i]);
		                    if (this.getErrorStrings().indexOf(argumentValue) > -1) {
		                        if (this.getRethrowLibraryComputationExceptions())
		                            throw this.getLibraryComputationException();
		                        return argumentValue;
		                    }
		                }
		            }
		            break;
		        }

		        case FormulaArgumentType.Numbers: {
		            var d1;
		            var numberArrays = splitArguments;
		            for (var i = 0; i < numberArrays.length; i++) {
		                var flag;
		                var s = this.getValueFromArg(numberArrays[i].split(this.tic).join(""));
		                var trueFalseString1 = Boolean(s);
		                var d1 = this._parseDouble(numberArrays[i].split(this.tic).join(""));
		                if (isNaN(d1)) {
		                    var argumentValue = this.getValueFromArg(numberArrays[i]);
		                    if (this.getErrorStrings().indexOf(argumentValue) > -1) {
		                        if (this.getRethrowLibraryComputationExceptions())
		                            throw this.getLibraryComputationException();
		                        return argumentValue;
		                    }
		                    if (!trueFalseString1 && (isNaN(this._parseDouble(argumentValue)) && argumentValue != "") || (numberArrays[i].includes(":") && this._isCellReference(numberArrays[i])) || argumentValue.startsWith(this.tic)) {
		                        if (this.getRethrowLibraryComputationExceptions())
		                            throw this.getLibraryComputationException();
		                        return this._errorStrings[1].toString();
		                    }
		                }
		            }
		            break;

		        }

		        case FormulaArgumentType.Date: {
		            var tempDate;
		            var number = 0;
		            var argumentArray = splitArguments;
		            for (var i = 0; i < argumentArray.length; i++) {
		                var s = this.getValueFromArg(argumentArray[i].split(this.tic).join(""));
		                var trueFalseString = Boolean(s);
		                var argumentValue = this.getValueFromArg(argumentArray[i]);
		                if (this.getErrorStrings().indexOf(argumentValue) > -1) {
		                    if (this.getRethrowLibraryComputationExceptions())
		                        throw this.getLibraryComputationException();
		                    return argumentValue;
		                }
		                if (!trueFalseString && isNaN(Date.parse(this._stripTics0(argumentValue))) && isNaN(this._parseDouble(this._stripTics0(argumentValue))) && argumentValue != "") {
		                    if (this.getRethrowLibraryComputationExceptions())
		                        throw this.getLibraryComputationException();
		                    return this._errorStrings[1].toString();
		                }
		            }
		        }

		    }
            return args;
		}
		
        /**
         * 
		 * @private
        */
		this._getSerialDateFromDate = function (y, m, d) {
            var days = 0;
            if (y < 1900) {
                y += 1900;
            }

           
            var isValidMonth = false;
            while (!isValidMonth) {
                while (m > 12) {
                    y++;
                    m -= 12;
                }
                isValidMonth = true;
                var x = new Date(y, m, 1, -1).getDate();
                while (d > x) {
                    x = new Date(y, m, 1, -1).getDate();
                    m++;
                    d -= x;
                    isValidMonth = false;
                }
                if (d < 1) {
                    m--;
                    x = new Date(y, m, 1, -1).getDate();
                    d = x - d;
                }
            }
            var dateTime = Date.parse(y.toString() + this.getParseDateTimeSeparator() + m.toString() + this.getParseDateTimeSeparator() + d.toString());
            if (!isNaN(dateTime)) {
                days = this._toOADate(new Date(dateTime));
            }
            if (this.treat1900AsLeapYear && days > 59) {
                days += 1;
            }
            return days;
        };
        /**
         * 
		 * @private
        */
		this._getSerialDateTimeFromDate = function (dt) {
            var d = this._toOADate(dt);

            if (this.treat1900AsLeapYear && d > 59) {
                d += 1;
            }

            return d;
        };
        /**
         * 
		 * @private
        */
		this._getSheetTokenFromReference = function (r) {
            var sheet = "";
            if (r.length > 2 && r[0] == this.sheetToken) {
                var i = 1;
                sheet = this.sheetToken;
                while (i < r.length && r[i] != this.sheetToken) {
                    sheet += r[i];
                    i++;
                }

                sheet += this.sheetToken;
            }

            return sheet;
        };
        /**
         * 
		 * @private
        */
		this._getValueComputeFormulaIfNecessary = function (row, col, grd) {
            var alreadyComputed = false;

            var formula = this.getFormulaInfoTable().getItem(this.cell);
            var o;
            if (this.parentObject.getValueRowCol == undefined)
                o = this.getValueRowCol(this.getSheetID(grd) + 1, row, col);
            else
                o = this.parentObject.getValueRowCol(this.getSheetID(grd) + 1, row, col);

            var val = (o != null && !(o.Length === 0)) ? o : "";

            if (val[val.length - 1] == ("}") && val[0] == ("{")) {
                val = this._substring(val, 1, val.length - 2);
            }

            if ((val == "" && (formula == null || formula == undefined)) || (val != "" && val[0] != this.getFormulaCharacter() && val[val.length - 1] != "%")) {
                if (formula != null && val == formula.getFormulaValue())
                    return formula.getFormulaValue();
                else
                    return val;
            }

            if (val.length > 0 && val[0] == this.getFormulaCharacter()) {
                if (formula != null) {
                    ////will be set later..
                    //// val = formula.FormulaValue;
                    ////val = ComputeFormula(formula.ParsedFormula);
                } else {
                    formula = new FormulaInfo();
                    formula.setFormulaText(o.toString());

                    if (!this.getDependentFormulaCells().containsKey(this.cell)) {
                        this.getDependentFormulaCells().add(this.cell, new HashTable());
                    }

                    var compute = true;
                    try  {
                        formula.setParsedFormula(this.parseFormula(val));
                    } catch (ex) {
                        if (this._inAPull) {
                            val = ex;
                            formula = null;
                        } else {
                            formula.setFormulaValue(ex);
                        }
                        compute = false;
                    }

                    if (compute) {
                        formula.setFormulaValue(this.computeFormula(formula.getParsedFormula()));
                        alreadyComputed = true;
                    }
                    if (formula != null) {
                        formula.calcID = this._calcID;
                        if (!this.getFormulaInfoTable().containsKey(this.cell))
                            this.getFormulaInfoTable().add(this.cell, formula);
                        val = formula.getFormulaValue() != null ? formula.getFormulaValue() : "";
                    }
                }
            }

            if (formula != null) {
                if (this.getUseFormulaValues() || this.getCalculatingSuspended() && (!this._inAPull || alreadyComputed)) {
                    val = formula.getFormulaValue() != null ? formula.getFormulaValue() : "";
                } else if (!alreadyComputed) {
                    if (this._calcID == formula.calcID) {
                        val = formula.getFormulaValue();
                    } else {
                        val = this.computeFormula(formula.getParsedFormula());
                        formula.setFormulaValue(val);
                        formula.calcID = this._calcID;
                    }
                }
            }

            if (val == "" || val == undefined) {
                val = "";
            }

            var d = this._parseDouble(val.substring(0, val.length - 1));

            if (val[val.length - 1] == ("%") && !isNaN(d)) {
                val = (Number(d) / 100).toString();
            }
            return val;
        };
        /**
         * 
		 * @private
        */
		this._handleEmbeddedEs = function (text) {
            var j = 0;
            while (j > -1 && ((j = text.indexOf(this._string_EP, j)) > -1)) {
                if (this._notInBlock(text, j)) {
                    var left = j;
                    while (left > 0 && (this._isDigit(text[left - 1]) || text[left - 1] == this.getParseDecimalSeparator())) {
                        left--;
                    }

                    if (left != j && (left == 0 || !this._isUpperChar(text[left - 1]))) {
                        var right = j + this._string_EP.length;
                        while (right < text.length && this._isDigit(text[right])) {
                            right++;
                        }

                        if (right != j + this._string_EP.length) {
                            text = text.substring(0, j) + this.char_EP + this._substring(text, j + this._string_EP.length);
                        }
                    }
                }

                j += 1;
            }

            j = 0;
            while (j > -1 && ((j = text.indexOf(this._string_EM, j)) > -1)) {
                if (this._notInBlock(text, j)) {
                    var left = j;
                    while (left > 0 && (this._isDigit(text[left - 1]) || text[left - 1] == this.getParseDecimalSeparator())) {
                        left--;
                    }

                    if (left != j && (left == 0 || !this._isUpperChar(text[left - 1]))) {
                        var right = j + this._string_EM.length;
                        while (right < text.length && this._isDigit(text[right])) {
                            right++;
                        }

                        if (right != j + this._string_EM.length) {
                            text = text.substring(0, j) + this.char_EM + this._substring(text, j + this._string_EM.length);
                        }
                    }
                }

                j += 1;
            }

            j = 0;

            while (j > -1 && ((j = text.indexOf(this._string_E, j)) > -1) && text[0] != this.bMARKER) {
                if (this._notInBlock(text, j)) {
                    var left = j;
                    while (left > 0 && (this._isDigit(text[left - 1]) || text[left - 1] == this.getParseDecimalSeparator())) {
                        left--;
                    }

                    if (left != j && (left == 0 || !this._isUpperChar(text[left - 1]))) {
                        var right = j + this._string_E.length;
                        while (right < text.length && this._isDigit(text[right])) {
                            right++;
                        }

                        if (right != j + this._string_E.length && (left == -1 || !this._isUpperChar(text[left]))) {
                            text = text.substring(0, j) + this.char_EP + this._substring(text, j + this._string_E.length);
                        }
                    }
                }

                j += 1;
            }

            return text;
        };
        /**
         * 
		 * @private
        */
		this._handleIterations = function (formula) {
            this._inHandleIterations = true;
            var oldValue = 0;
            var d = 0;
            var count = 1;
            var first = true;
            while (count < this._iterationMaxCount - 1 && (first || !this._checkUnderTolerance(d, oldValue))) {
                first = false;
                if (!this.getIterationValues().containsKey(this.cell)) {
                    this.getIterationValues().add(this.cell, "0");
                }

                this.getIterationValues().add(this.cell, (formula.getFormulaValue() == "" ? "0" : formula.getFormulaValue()));

                formula.setFormulaValue(this.computeFormula(formula.getParsedFormula()));
                oldValue = d;
                d = this._parseDouble(formula.getFormulaValue());
                if (isNaN(d))
                    d = 0;
                count++;
            }

            ////save the last iteration
            this.getIterationValues.getItem(this.cell, (formula.getFormulaValue() == "" ? "0" : formula.getFormulaValue()));

            this._inHandleIterations = false;
        };
        /**
         * 
		 * @private
        */
		this._indexOfAny = function (text, operators) {
            for (var i = 0; i < text.length; i++) {
                if (operators.indexOf(text[i]) > -1) {
                    return i;
                }
            }
            return -1;
        };
        /**
         * 
		 * @private
        */
		this._initLibraryFunctions = function () {
            this._libraryFunctions = new HashTable();

            ////Hand-coded formulas.
            this._addFunction("SUM", "computeSum");
            this._addFunction("EncodeURL", "computeEncodeURL");

            
            //TEXT FORMULA
            this._addFunction("CHAR", "computeChar");
            this._addFunction("CODE", "computeCode");
            this._addFunction("UNICODE", "computeUniCode");
            this._addFunction("UNICHAR", "computeUniChar");
            this._addFunction("UPPER", "computeUpper");
            this._addFunction("LOWER", "computeLower");
            this._addFunction("LEN", "computeLen");
            this._addFunction("MID", "computeMid");
            this._addFunction("LEFT", "computeLeft");
            this._addFunction("CLEAN", "computeClean");
            this._addFunction("REPT", "computeRept");
            this._addFunction("RIGHT", "computeRight");
            this._addFunction("REPLACE", "computeReplace");
            this._addFunction("EXACT", "computeExact");
            this._addFunction("FIND", "computeFind");
            this._addFunction("TRIM", "computeTrim");
            this._addFunction("SEARCH", "computeSearch");
            this._addFunction("SUBSTITUTE", "computeSubstitute");
            this._addFunction("PROPER", "computeProper");
            this._addFunction("T", "computeT");
            this._addFunction("NUMBERVALUE", "computeNumberValue");
            this._addFunction("CONCATENATE", "computeConcatenate");
            this._addFunction("VALUE", "computeValue");
            this._addFunction("DOLLAR", "computeDollar");
            this._addFunction("FIXED", "computeFixed");

            //Engineering formulas
            this._addFunction("BIN2DEC", "computeBin2Dec");
            this._addFunction("BIN2OCT", "computeBin2Oct");
            this._addFunction("BIN2HEX", "computeBin2Hex");
            this._addFunction("DEC2BIN", "computeDec2Bin");
            this._addFunction("DEC2OCT", "computeDec2Oct");
            this._addFunction("HEX2BIN", "computeHex2Bin");
            this._addFunction("HEX2OCT", "computeHex2Oct");
            this._addFunction("BITAND", "computeBitAnd");
            this._addFunction("BITOR", "computeBitOr");
            this._addFunction("BITLSHIFT", "computeBitLShift");
            this._addFunction("BITRSHIFT", "computeBitRShift");
            this._addFunction("BITXOR", "computeBitXor");

            // DATE and TIME
            this._addFunction("DATE", "computeDate");
            this._addFunction("DATEVALUE", "computeDatevalue");
            this._addFunction("DAY", "computeDay");
            this._addFunction("DAYS", "computeDays");
            this._addFunction("DAYS360", "computeDays360");
            this._addFunction("EDATE", "computeEDate");
            this._addFunction("EOMONTH", "computeEOMonth");
            this._addFunction("HOUR", "computeHour");
            this._addFunction("ISOWEEKNUM", "computeISOWeeknum");
            this._addFunction("MINUTE", "computeMinute");
            this._addFunction("MONTH", "computeMonth");
            this._addFunction("NETWORKDAYS", "computeNetworkDays");
            this._addFunction("NETWORKDAYS.INTL", "computeNetworkDaysOintl");
            this._addFunction("NOW", "computeNow");
            this._addFunction("SECOND", "computeSecond");
            this._addFunction("TIME", "computeTime");
            this._addFunction("TIMEVALUE", "computeTimevalue");
            this._addFunction("TODAY", "computeToday");
            this._addFunction("WEEKDAY", "computeWeekday");
            this._addFunction("WEEKNUM", "computeWeeknum");
            this._addFunction("WORKDAY", "computeWorkDay");
            this._addFunction("WORKDAY.INTL", "computeWorkDayOintl");
            this._addFunction("YEAR", "computeYear");

            //look and ref
            this._addFunction("ADDRESS", "computeAddress");
            this._addFunction("AREAS", "computeAreas");
            this._addFunction("CHOOSE", "computeChoose");
            this._addFunction("COLUMN", "computeColumn");
            this._addFunction("COLUMNS", "computeColumns");
            this._addFunction("FORMULATEXT", "computeFormulaText");
            this._addFunction("HYPERLINK", "computeHyperlink");
            this._addFunction("HLOOKUP", "computeHLookUp");
            this._addFunction("INDEX", "computeIndex");
            this._addFunction("INDIRECT", "computeIndirect");
            this._addFunction("LOOKUP", "computeLookUp");
            this._addFunction("OFFSET", "computeOffSet");
            this._addFunction("TRANSPOSE", "computeTranspose");



            // Statics
            this._addFunction("LOGNORM.INV", "computeLognormOinv");
            this._addFunction("NORM.INV", "computeNormOinv");
            this._addFunction("NORM.DIST", "computeNormOdist");
            this._addFunction("NORM.S.DIST", "computeNormOsODist");
            this._addFunction("NORM.S.INV", "computeNormOsOInv");
            this._addFunction("PERMUT", "computePermut");
            this._addFunction("PERMUTATIONA", "computePermutationA");
            this._addFunction("STANDARDIZE", "computeStandardize");
            this._addFunction("BINOM.DIST", "computeBinomOdist");
            this._addFunction("BINOM.INV", "computeBinomOInv");
            this._addFunction("CHISQ.INV.RT", "computeChisqOinvOrt");
            this._addFunction("CHISQ.INV", "computeChisqOinv");
            this._addFunction("CHISQ.DIST.RT", "computeChisqOdistOrt");
            this._addFunction("F.DIST", "computeFOdist");
            this._addFunction("GAMMALN", "computeGammaln");
            this._addFunction("CONFIDENCE.NORM", "computeConfidenceOnorm");
            this._addFunction("EXPON.DIST", "computeExponOdist");
            this._addFunction("FISHER", "computeFisher");
            this._addFunction("FISHERINV", "computeFisherInv");
            this._addFunction("GAMMALN.PRECISE", "computeGammalnOPrecise");
            this._addFunction("AVERAGE", "computeAverage");
            this._addFunction("AVERAGEA", "computeAverageA");
            this._addFunction("POISSON.DIST", "computePoissonODist");
            this._addFunction("WEIBULL.DIST", "computeWeiBullODist");
            this._addFunction("F.INV.RT", "computeFOinvOrt");
            this._addFunction("T.DIST", "computeTOdist");
            this._addFunction("MAX", "computeMax");
            this._addFunction("MAXA", "computeMaxa");
            this._addFunction("MEDIAN", "computeMedian");
            this._addFunction("MIN", "computeMin");
            this._addFunction("MINA", "computeMina");
            this._addFunction("PERCENTRANK.INC", "computePercentrankInc");
            this._addFunction("PERCENTILE", "computePercentile");
            this._addFunction("RANK.EQ", "computeRankOEq");
            this._addFunction("COUNT", "computeCount");
            this._addFunction("COUNTA", "computeCounta");
            this._addFunction("DEVSQ", "computeDevsq");
            this._addFunction("F.DIST.RT", "computeFOdistORt");
            this._addFunction("FORECAST", "computeForecast");
            this._addFunction("GEOMEAN", "computeGeomean");
            this._addFunction("HARMEAN", "computeHarmean");
            this._addFunction("INTERCEPT", "computeIntercept");
            this._addFunction("LARGE", "computeLarge");
            this._addFunction("SMALL", "computeSmall");
            this._addFunction("LOGNORM.DIST", "computeLognormOdist");          
            this._addFunction("AVEDEV", "computeAvedev");
            this._addFunction("COUNTBLANK", "computeCountblank"); 
            this._addFunction("STDEV.P", "computeStdevOp");
            this._addFunction("STDEV.S", "computeStdevOS");
            this._addFunction("STDEVA", "computeStdeva");
            this._addFunction("STDEVPA", "computeStdevpa");
            this._addFunction("T.INV", "computeTOinv");
            this._addFunction("VAR.P", "computeVarp");
            this._addFunction("VARA", "computeVara");
            this._addFunction("VARPA", "computeVarpa");
            this._addFunction("CORREL","computeCorrel");
            //this._addFunction("NEGBINOM.DIST", "computeNegbinomODist");
            this._addFunction("PERCENTILE.EXC", "computePercentileExc");
            this._addFunction("PERCENTILE.INC", "computePercentileOInc");
            this._addFunction("TRIMMEAN", "computeTrimmean");
            this._addFunction("RSQ", "computeRsq");
            this._addFunction("PEARSON", "computePearson");
            this._addFunction("CHIDIST","computeChidist");
            //60 statics function
            

            // math and Trig
            this._addFunction("ABS", "computeAbs");
            this._addFunction("ACOS", "computeAcos");
            this._addFunction("ACOSH", "computeAcosh");
            this._addFunction("ACOT", "computeAcot");
            this._addFunction("ACOTH", "computeAcoth");
            this._addFunction("ARABIC", "computeArabic");
            this._addFunction("ASIN", "computeAsin");
            this._addFunction("ATAN", "computeAtan");
            this._addFunction("ATAN2", "computeAtan2");
            this._addFunction("CEILING.MATH", "computeCeilingMath");
            this._addFunction("CEILING", "computeCeiling");
            this._addFunction("COMBIN", "computeCombin");
            this._addFunction("COMBINA", "computeCombinA");
            this._addFunction("COS", "computeCos");
            this._addFunction("COSH", "computeCosh");
            this._addFunction("COT", "computeCot");
            this._addFunction("CSC", "computeCsc");
            this._addFunction("CSCH", "computeCsch");
            this._addFunction("DECIMAL", "computeDecimal");
            this._addFunction("DEGREES", "computeDegrees");
            this._addFunction("ISTEXT", "computeIsText");
            this._addFunction("EXP", "computeExp");
            this._addFunction("EVEN", "computeEven");
            this._addFunction("FACT", "computeFact");
            this._addFunction("FACTDOUBLE", "computeFactdouble");
            this._addFunction("FLOOR", "computeFloor");
            this._addFunction("INT", "computeInt");
            this._addFunction("LN", "computeLn");
            this._addFunction("LOG", "computeLog");
            this._addFunction("PI", "computePI");
            this._addFunction("PRODUCT", "computeProduct");
            this._addFunction("SEC", "computeSecant");
            this._addFunction("SERIESSUM", "computeSeriessum");
            this._addFunction("SIN", "computeSin");
            this._addFunction("SINH", "computeSinh");
            this._addFunction("SQRT", "computeSqrt");
            this._addFunction("SUBTOTAL", "computeSubTotal");
            this._addFunction("SUMIF", "computeSumif");
            this._addFunction("TRUNC", "computeTrunc");
            this._addFunction("TAN", "computeTan");
            this._addFunction("LOG10", "computeLogTen");
            this._addFunction("COTH", "computeCoth");

            //Logic Function

            this._addFunction("AND", "computeAnd");
            this._addFunction("FALSE", "computeFalse");
            this._addFunction("IF", "computeIf");
            this._addFunction("IFERROR", "computeIfError");
           // this._addFunction("IFNA", "computeIfNA");
            this._addFunction("NOT", "computeNot");
            this._addFunction("OR", "computeOr");
            this._addFunction("TRUE", "computeTrue");
            this._addFunction("XOR", "computeXor");

            // Information Function

            this._addFunction("CELL", "computeCell");
            this._addFunction("ERROR.TYPE", "computeErrorType");
            this._addFunction("INFO", "computeInfo");
            this._addFunction("ISBLANK", "computeIsBlank");
            this._addFunction("ISERR", "computeIsErr");
            this._addFunction("ISERROR", "computeIsError");
            this._addFunction("ISEVEN", "computeIsEven");
            this._addFunction("ISFORMULA", "computeIsFormula");
            this._addFunction("ISLOGICAL", "computeIsLogical");
            this._addFunction("ISNA", "computeIsNA");
            this._addFunction("ISNONTEXT", "computeIsNonText");
            this._addFunction("ISNUMBER", "computeIsNumber");
            this._addFunction("ISODD", "computeIsOdd");
            this._addFunction("ISREF", "computeIsRef");
            this._addFunction("ISTEXT", "computeIsText");
            this._addFunction("N", "computeN");
            this._addFunction("NA", "computeNA");
            this._addFunction("SHEET", "computeSheet");
            this._addFunction("SHEETS", "computeSheets");
            this._addFunction("TYPE", "computeType");
            this._addFunction("ROW", "computeRow");
            this._addFunction("ROWS", "computeRows");
            this._addFunction("MATCH", "computeMatch");

		    //Financial Function
            this._addFunction("PMT", "computePmt");
		};
        /**
         * 
		 * @private
        */
		this._comb = function (k, n) {
            var top = 1;
            for (var i = k + 1; i <= n; ++i) {
                top = top * i;
            }

            var bottom = 1;
            for (var i = 2; i <= (n - k) ; ++i) {
                bottom = bottom * i;
            }

            return top / bottom;
        };
        /**
         * 
		 * @private
        */
		this._finv = function (p, df1, df2) {
            var mult = Math.exp(this._gammaln((df1 + df2) / 2) - this._gammaln(df1 / 2) - this._gammaln(df2 / 2) + (df1 / 2) * Math.log(df1 / df2));

            var guess = mult;

            var lastIncrement = guess / 2;
            var gi = 0;
            var eps = 1e-7;
            var k = 100;
            var tries = 3;
            var its = 0;
            while (k == 100 && tries > 0) {
                tries--;
                guess = guess / 2;
                lastIncrement = guess / 2;

                for (k = 0; k < 100; ++k) {
                    its++;
                    gi = 1 - mult * this._fdist(guess, df1, df2);

                    ////Console.WriteLine("{0}: guess {1}  computed {2}  target {3}", its, guess, gi, p);
                    if (Math.abs((gi - p) / p) < eps) {
                        break;
                    }

                    ////greater since looking for 1 - xxxx
                    if (gi > p) {
                        guess = guess + lastIncrement;
                    } else {
                        lastIncrement = lastIncrement / 2;
                        if (guess - lastIncrement < 0) {
                            lastIncrement = guess / 2;
                        }

                        guess = guess - lastIncrement;
                    }
                }
            }

            if (k == 100) {
                guess = -1;
            }

            return guess;
        };
        /**
         * 
		 * @private
        */
		this._tProbabilityDensity = function (x, k) {
            var a = this._gammaFunction(0.5 * k + 0.5);
            var b = Math.pow(1.0 + (x * x) / k, -0.5 * k - 0.5);
            var c = Math.sqrt(k * Math.PI) * this._gammaFunction(0.5 * k);
            return a * b / c;
        };
        /**
         * 
		 * @private
        */
		this._tCumulativeDensity = function (x, k) {
            if (isNaN(x))
                return NaN;
            if (x == 0)
                return 0.5;
            if (x > 0) {
                var x2 = k / (x * x + k);
                return 1.0 - 0.5 * this._rIBetaFunction(x2, 0.5 * k, 0.5);
            }
            return 1.0 - this._tCumulativeDensity(-x, k);
        };
        /**
         * 
		 * @private
        */
		this._sign = function (p) {
            if (p === 0 || isNaN(p))
                return p;
            return p > 0 ? 1 : -1;
        };
        /**
         * 
		 * @private
        */
		this._var = function (x) {
            var sumx = 0;
            var n = x.length;
            for (var i = 0; i < n; ++i) {
                sumx += x[i];
            }

            sumx = sumx / n;

            var sumx2 = 0;
            var d;
            for (var i = 0; i < n; ++i) {
                d = x[i] - sumx;
                sumx2 += d * d;
            }

            return sumx2 / (n - 1);
        };
        /**
         * 
		 * @private
        */
		this._tCumulativeDistributionInverse = function (p, k) {
            var maxIterations= 50;
            var minAccuracy = 0.0001;

            if (p < 0 || p > 1.0)
                throw "Probability must be between 0 and 1";
            if (p == 0)
                return Number.NEGATIVE_INFINITY;
            if (p == 1)
                return Number.POSITIVE_INFINITY;
            if (p == 0.5)
                return 0.0;

            switch (k) {
                case 1:
                    return Math.tan(Math.PI * (p - 0.5));
                case 2:
                    var alpha = 4 * p * (1 - p);
                    return 2 * (p - 0.5) * Math.sqrt(2.0 / alpha);
                case 4:
                    var alpha = 4 * p * (1 - p);
                    var sqrtAlpha = Math.sqrt(alpha);
                    var q = Math.cos((1.0 / 3.0) * Math.acos(sqrtAlpha)) / sqrtAlpha;
                    return this._sign(p - 0.5) * 2 * Math.sqrt(q - 1);
                default:
                    var x;
                    if (k > 6)
                        x = this._standardNormalCumulativeDistributionFunctionInverse(p);
                    else
                        x = this._tCumulativeDistributionInverse(p, 4);

                    for (var i = 0; i < maxIterations; i++) {
                        var p0 = this._tCumulativeDensity(x, k);
                        var absAccuracy = Math.abs(p - p0);
                        if (absAccuracy < minAccuracy)
                            return x;
                        var slope = this._tProbabilityDensity(x, k);
                        x = x + (p - p0) / slope;
                    }
                    throw "Solution did not converge";
            }
        };
        /**
         * 
		 * @private
        */
		this._fdist = function (x, df1, df2) {
            var nPanels = 32;
            var leftside = 0;
            var rightside = x;

            var h = (rightside - leftside) / nPanels;
            var mult = h / 3;

            var sum1 = this._fdensity(leftside, df1, df2) + this._fdensity(rightside, df1, df2);
            var sum4 = 0;
            for (var i = 1; i < nPanels; i += 2) {
                sum4 = sum4 + 4 * this._fdensity(leftside + i * h, df1, df2);
            }

            var sum2 = 0;
            for (var i = 2; i < nPanels; i += 2) {
                sum2 = sum2 + 2 * this._fdensity(leftside + i * h, df1, df2);
            }

            var gd = mult * (sum1 + sum2 + sum4);
            var oldgd = gd;
            var eps = 1e-7;

            var k = 0;

            for (k = 0; k < 10; ++k) {
                nPanels = nPanels * 2;

                sum2 += sum4 / 2;
                sum4 = 0;
                h = (rightside - leftside) / nPanels;
                for (var i = 0; i < nPanels; ++i) {
                    if (i % 2 == 1) {
                        var d = this._fdensity(leftside + h * i, df1, df2);
                        sum4 = sum4 + d;
                    }
                }

                sum4 = 4 * sum4;
                mult = h / 3;
                gd = mult * (sum1 + sum2 + sum4);

                if (Math.abs((gd - oldgd) / oldgd) < eps) {
                    break;
                }

                oldgd = gd;
            }

            return gd;
        };
        /**
         * 
		 * @private
        */
		this._fdensity = function (x, df1, df2) {
            return Math.pow(x, (df1 - 2) / 2) / Math.pow(1 + df1 * x / df2, (df1 + df2) / 2);
        };
        /**
         * 
		 * @private
        */
		this._normaldist = function (x, u, s) {
            var nPanels = 32;
            var leftside;
            var rightside;
            if (x > u) {
                leftside = u - (x - u);
                rightside = x;
            } else {
                leftside = x;
                rightside = u + (u - x);
            }

            var h = (rightside - leftside) / nPanels;
            var mult = h / 3;

            var sum1 = this._normaldensity(leftside, u, s) + this._normaldensity(rightside, u, s);
            var sum4 = 0;
            for (var i = 1; i < nPanels; i += 2) {
                sum4 = sum4 + 4 * this._normaldensity(leftside + i * h, u, s);
            }

            var sum2 = 0;
            for (var i = 2; i < nPanels; i += 2) {
                sum2 = sum2 + 2 * this._normaldensity(leftside + i * h, u, s);
            }

            var gd = mult * (sum1 + sum2 + sum4);
            var oldgd = gd;
            var eps = 1e-7;

            var k = 0;

            for (k = 0; k < 10; ++k) {
                nPanels *= 2;

                sum2 = sum2 + sum4 / 2;
                sum4 = 0;
                h = h = (rightside - leftside) / nPanels;
                for (var i = 0; i < nPanels; ++i) {
                    if (i % 2 == 1) {
                        var d = this._normaldensity(leftside + h * i, u, s);
                        sum4 += d;
                    }
                }

                sum4 = 4 * sum4;
                mult = h / 3;
                gd = mult * (sum1 + sum2 + sum4);

                if (Math.abs((gd - oldgd) / oldgd) < eps) {
                    break;
                }

                oldgd = gd;
            }

            if (x > u) {
                ////Add the left tails.
                gd = gd + (1 - gd) / 2;
            } else {
                ////Return only the left tail.
                gd = (1 - gd) / 2;
            }

            ////Console.WriteLine(k.toString() + "  " + gd.toString());
            return gd;
        };
        /**
         * 
		 * @private
        */
		this._normaldensity = function (x, u, s) {
            return 1 / (Math.sqrt(2 * Math.PI) * s) * Math.exp(-(x - u) * (x - u) / (2 * s * s));
        };
        /**
         * 
		 * @private
        */
		this._standardNormalCumulativeDistribution = function (x) {
            //Approimation based on Abramowitz & Stegun (1964)
            if (x < 0)
                return 1.0 - this._standardNormalCumulativeDistribution(-x);
            var b0 = 0.2316419;
            var b1 = 0.319381530;
            var b2 = -0.356563782;
            var b3 = 1.781477937;
            var b4 = -1.821255978;
            var b5 = 1.330274429;
            var pdf = this._standardNormalProbabilityDensityFunction(x);
            var a = 1.0 / (1.0 + b0 * x);
            return 1.0 - pdf * (b1 * a + b2 * Math.pow(a, 2) + b3 * Math.pow(a, 3) + b4 * Math.pow(a, 4) + b5 * Math.pow(a, 5));
        };
        /**
         * 
		 * @private
        */
		this._normalinv = function (p, u, s) {
            var guess = u;
            if (p < .05) {
                guess = u - 2 * s;
            } else if (p < .5) {
                guess = u;
            } else if (p < .95) {
                guess = u + 2 * s;
            } else {
                guess = u + 5 * s;
            }

            var lastIncrement = guess / 2;
            var gi = 0;
            var eps = 1e-7;
            var k = 100;
            var tries = 3;
            var its = 0;
            while (k == 100 && tries > 0) {
                tries--;
                guess = guess / 2;
                lastIncrement = guess / 2;

                for (k = 0; k < 100; ++k) {
                    its++;
                    gi = this._normaldist(guess, u, s);
                    if (Math.abs((gi - p) / p) < eps) {
                        break;
                    }

                    if (gi < p) {
                        guess = guess + lastIncrement;
                    } else {
                        lastIncrement = lastIncrement / 2;
                        if (guess - lastIncrement < 0) {
                            lastIncrement = guess / 2;
                        }

                        guess = guess - lastIncrement;
                    }
                }
            }

            if (k == 100) {
                guess = -1;
            }

            return guess;
        };
		/**
         * 
		 * @private
        */
		this._normalCumulativeDistributionFunctionInverse = function (p, mean, standardDeviation) {
            var x = this._standardNormalCumulativeDistributionInverse(p);
            return standardDeviation * x + mean;
        };
        /**
         * 
		 * @private
        */
		this._standardNormalCumulativeDistributionInverse = function (p) {
            if (p < 0 || p > 1.0)
                throw "Probability must be between 0 and 1";
            if (p == 0)
                return Number.NEGATIVE_INFINITY;
            if (p == 1)
                return Number.POSITIVE_INFINITY;
            if (p == 0.5)
                return 0.0;

            var a1 = -3.969683028665376e+01;
            var a2 = 2.209460984245205e+02;
            var a3 = -2.759285104469687e+02;
            var a4 = 1.383577518672690e+02;
            var a5 = -3.066479806614716e+01;
            var a6 = 2.506628277459239e+00;

            var b1 = -5.447609879822406e+01;
            var b2 = 1.615858368580409e+02;
            var b3 = -1.556989798598866e+02;
            var b4 = 6.680131188771972e+01;
            var b5 = -1.328068155288572e+01;

            var c1 = -7.784894002430293e-03;
            var c2 = -3.223964580411365e-01;
            var c3 = -2.400758277161838e+00;
            var c4 = -2.549732539343734e+00;
            var c5 = 4.374664141464968e+00;
            var c6 = 2.938163982698783e+00;

            var d1 = 7.784695709041462e-03;
            var d2 = 3.224671290700398e-01;
            var d3 = 2.445134137142996e+00;
            var d4 = 3.754408661907416e+00;

            var pLow = 0.02425;
            var pHigh = 1 - pLow;

            var q, x;
            if (0 < p && p < pLow) {
                q = Math.sqrt(-2 * Math.log(p));
                x = (((((c1 * q + c2) * q + c3) * q + c4) * q + c5) * q + c6) / ((((d1 * q + d2) * q + d3) * q + d4) * q + 1);
                return x;
            }

            if (pLow <= p && p <= pHigh) {
                q = p - 0.5;
                var r = q * q;
                x = (((((a1 * r + a2) * r + a3) * r + a4) * r + a5) * r + a6) * q / (((((b1 * r + b2) * r + b3) * r + b4) * r + b5) * r + 1);
                return x;
            }

            //if(p_high < p && p < 1)
            q = Math.sqrt(-2 * Math.log(1 - p));
            x = -(((((c1 * q + c2) * q + c3) * q + c4) * q + c5) * q + c6) / ((((d1 * q + d2) * q + d3) * q + d4) * q + 1);
            return x;
        };
        /**
         * 
		 * @private
        */
		this._normalProbabilityDensity = function (x, mean, standardDeviation) {
            var sqrtTwoPiInv = 0.398942280401433;
            var z = (x - mean) / standardDeviation;
            return sqrtTwoPiInv * Math.exp(-0.5 * z * z) / standardDeviation;
        };
        /**
         * 
		 * @private
        */
		this._standardNormalProbabilityDensityFunction = function (x) {
            var SqrtTwoPiInv = 0.398942280401433;
            return SqrtTwoPiInv * Math.exp(-0.5 * x * x);
        };
        /**
         * 
		 * @private
        */
		this._standardNormalCumulativeDistributionFunction = function (x) {
            if (x < 0)
                return 1.0 - this._standardNormalCumulativeDistributionFunction(-x);
            var b0 = 0.2316419;
            var b1 = 0.319381530;
            var b2 = -0.356563782;
            var b3 = 1.781477937;
            var b4 = -1.821255978;
            var b5 = 1.330274429;
            var pdf = this._standardNormalProbabilityDensityFunction(x);
            var a = 1.0 / (1.0 + b0 * x);
            return 1.0 - pdf * (b1 * a + b2 * Math.pow(a, 2) + b3 * Math.pow(a, 3) + b4 * Math.pow(a, 4) + b5 * Math.pow(a, 5));
        };
        /**
         * 
		 * @private
        */
		this._standardNormalCumulativeDistributionFunctionInverse = function (p) {
            if (p < 0 || p > 1.0)
                throw "Probability must be between 0 and 1";
            if (p == 0)
                return Number.NEGATIVE_INFINITY;
            if (p == 1)
                return Number.POSITIVE_INFINITY;
            if (p == 0.5)
                return 0.0;

            var a1 = -3.969683028665376e+01;
            var a2 = 2.209460984245205e+02;
            var a3 = -2.759285104469687e+02;
            var a4 = 1.383577518672690e+02;
            var a5 = -3.066479806614716e+01;
            var a6 = 2.506628277459239e+00;

            var b1 = -5.447609879822406e+01;
            var b2 = 1.615858368580409e+02;
            var b3 = -1.556989798598866e+02;
            var b4 = 6.680131188771972e+01;
            var b5 = -1.328068155288572e+01;

            var c1 = -7.784894002430293e-03;
            var c2 = -3.223964580411365e-01;
            var c3 = -2.400758277161838e+00;
            var c4 = -2.549732539343734e+00;
            var c5 = 4.374664141464968e+00;
            var c6 = 2.938163982698783e+00;

            var d1 = 7.784695709041462e-03;
            var d2 = 3.224671290700398e-01;
            var d3 = 2.445134137142996e+00;
            var d4 = 3.754408661907416e+00;

            var pLow = 0.02425;
            var pHigh = 1 - pLow;

            var q, x;
            if (0 < p && p < pLow) {
                q = Math.sqrt(-2 * Math.log(p));
                x = (((((c1 * q + c2) * q + c3) * q + c4) * q + c5) * q + c6) / ((((d1 * q + d2) * q + d3) * q + d4) * q + 1);
                return x;
            }

            if (pLow <= p && p <= pHigh) {
                q = p - 0.5;
                var r = q * q;
                x = (((((a1 * r + a2) * r + a3) * r + a4) * r + a5) * r + a6) * q / (((((b1 * r + b2) * r + b3) * r + b4) * r + b5) * r + 1);
                return x;
            }

            //if(p_high < p && p < 1)
            q = Math.sqrt(-2 * Math.log(1 - p));
            x = -(((((c1 * q + c2) * q + c3) * q + c4) * q + c5) * q + c6) / ((((d1 * q + d2) * q + d3) * q + d4) * q + 1);
            return x;
        };
        /**
         * 
		 * @private
        */
		this._chiSquaredProbabilityDensityFunction = function (x, k) {
            var g = this._gammaFunction(0.5 * k);
            var a = 1.0 / (Math.pow(2, 0.5 * k) * g);
            return a * Math.pow(x, 0.5 * k - 1.0) * Math.exp(-0.5 * x);
        };
        /**
         * 
		 * @private
        */
		this._binomdist = function (trials, successes, p) {
            var pPow = 1;
            var pm1 = 1 - p;

            var p1Pow = Math.pow(pm1, trials);

            var dist = 0;
            var cbn = pPow * Math.pow(pm1, trials);
            if (cbn == 0) {
                return NaN;
            }

            for (var i = 0; i <= successes; ++i) {
                dist += cbn;
                cbn = cbn * p / pm1 * (trials - i) / (i + 1);
                if (!isFinite(cbn) || isNaN(cbn)) {
                    dist = NaN;
                    break;
                }
            }

            return dist;
        };
        /**
         * 
		 * @private
        */
		this._gammadensity = function (a, b, x) {
            //// excel version     dist = 1 / (Math.Pow(b, a) * gammaln(a)) * Math.Pow(x, a - 1) * Math.Exp(-x / b);
            //// http://www.itl.nist.gov/div898/handbook/eda/section3/eda366b.htm
            return Math.pow(x / b, a - 1) * Math.exp(-x / b) / (b * Math.exp(this._gammaln(a)));
        };
        this.minValue = -1.79769e+308;
        this.maxValue = 2147483647;
        this._charTable = [this._string_empty, "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];
        /**
         * 
		 * @private
        */
		this._stdevdotP = function (range) {
            var n = range.length;
            var mean = 0;
            var sigma = 0;
            var count = 0;
            for (var i = 0; i < n; ++i)
                mean = mean + range[i];
            mean = mean / n;
            for (var i = 0; i < n; i++) {
                sigma = sigma + Math.pow(range[i] - mean, 2);
                count++;
            }

            return Math.sqrt(sigma / count);
        };
        /**
         * 
		 * @private
        */
		this._determinant = function (a, k) {
            var s = 1, det = 0;
            var matlength = parseInt(k.toString());
            var b = [matlength, matlength];
            var i, j, m, n, c;
            if (k == 1) {
                return (a[0, 0]);
            } else {
                det = 0;
                for (c = 0; c < k; c++) {
                    m = 0;
                    n = 0;
                    for (i = 0; i < k; i++) {
                        for (j = 0; j < k; j++) {
                            b[i, j] = 0;
                            if (i != 0 && j != c) {
                                b[m, n] = a[i, j];
                                if (n < (k - 2))
                                    n++;
                                else {
                                    n = 0;
                                    m++;
                                }
                            }
                        }
                    }
                    det = det + s * (a[0, c] * this._determinant(b, k - 1));
                    s = -1 * s;
                }
            }

            return (det);
        };
        this._factorialTable = [
            1, 1, 2, 6, 24, 120, 720,
            5040, 40320, 362880, 3628800,
            39916800, 479001600
        ];
        /**
         * 
		 * @private
        */
		this._mean = function (array) {
            return this._mean(array, 1.0);
        };
        /**
         * 
		 * @private
        */
		this._negbinomdensity = function (failures, successes, p) {
            return this._comb(successes - 1, failures + successes - 1) * Math.pow(p, successes) * Math.pow(1 - p, failures);
        };
        /**
         * 
		 * @private
        */
		this._sd = function (x, xbar) {
            var n = x.length;
            xbar = 0;
            for (var i = 0; i < n; ++i) {
                xbar += x[i];
            }

            xbar = xbar / n;
            var sumx2 = 0;
            var d = 0;

            for (var i = 0; i < n; ++i) {
                d = x[i] - xbar;
                sumx2 += d * d;
            }
            if (n == 1)
                return 0;
            return Math.sqrt(sumx2 / (n - 1));
        };
        /**
         * 
		 * @private
        */
		this._betaCumulativeDist = function (x, a, b) {
            if (x < 0 || x > 1)
                throw "x must be between 0 and 1";
            return this._rIBetaFunction(x, a, b);
        };
        /**
         * 
		 * @private
        */
		this._betaProbabilityDens = function (x, a, b) {
            if (x < 0 || x > 1)
                throw "x must be between 0 and 1";

            var B = this._betaFunction(a, b);
            var d = Math.pow(x, a - 1) * Math.pow(1 - x, b - 1) / B;
            return d;
        };
        /**
         * 
		 * @private
        */
		this._critbinom = function (nTrials, p, alpha) {
            var checkval = nTrials;
            var half = nTrials;
            var dist = 1;
            var dist1 = 1;
            do {
                half = Math.floor(half / 2) + 1;
                if (dist >= alpha) {
                    dist1 = this._binomdist(nTrials, checkval - 1, p);
                    if (isNaN(dist1)) {
                        return this.maxValue;
                    }

                    if (dist1 < alpha && dist1 > 0) {
                        break;
                    }

                    checkval = checkval - half;
                } else {
                    dist1 = this._binomdist(nTrials, checkval + 1, p);
                    if (dist1 >= alpha) {
                        checkval = checkval + 1;
                        break;
                    }

                    checkval = checkval + half;
                }

                dist = this._binomdist(nTrials, checkval, p);
            } while (checkval < nTrials && checkval > 0);

            return checkval;
        };
        /**
         * 
		 * @private
        */
		this._newnormalinv = function (p) {
            var region1 = [
                -3.969683028665376e+01, 2.209460984245205e+02,
                -2.759285104469687e+02, 1.383577518672690e+02,
                -3.066479806614716e+01, 2.506628277459239e+00];

            var region2 = [
                -5.447609879822406e+01, 1.615858368580409e+02,
                -1.556989798598866e+02, 6.680131188771972e+01,
                -1.328068155288572e+01];

            var region3 = [
                -7.784894002430293e-03, -3.223964580411365e-01,
                -2.400758277161838e+00, -2.549732539343734e+00,
                4.374664141464968e+00, 2.938163982698783e+00];

            var region4 = [
                7.784695709041462e-03, 3.224671290700398e-01,
                2.445134137142996e+00, 3.754408661907416e+00];

            var pLow = 0.02425;
            var pHigh = 1 - pLow;
            var q = 0.0;
            var r = 0.0;

            // For lower region:
            if (p < pLow) {
                q = Math.sqrt(-2 * Math.log(p));
                return (((((region3[0] * q + region3[1]) * q + region3[2]) * q + region3[3]) * q + region3[4]) * q + region3[5]) / ((((region4[0] * q + region4[1]) * q + region4[2]) * q + region4[3]) * q + 1);
            }

            // For upper region:
            if (pHigh < p) {
                q = Math.sqrt(-2 * Math.log(1 - p));
                return -(((((region3[0] * q + region3[1]) * q + region3[2]) * q + region3[3]) * q + region3[4]) * q + region3[5]) / ((((region4[0] * q + region4[1]) * q + region4[2]) * q + region4[3]) * q + 1);
            }

            // For central region:
            q = p - 0.5;
            r = q * q;
            return (((((region1[0] * r + region1[1]) * r + region1[2]) * r + region1[3]) * r + region1[4]) * r + region1[5]) * q / (((((region2[0] * r + region2[1]) * r + region2[2]) * r + region2[3]) * r + region2[4]) * r + 1);
        };
        /**
         * 
		 * @private
        */
		this._chiinv = function (p, v) {
            var guess = p;

            var lastIncrement = Number(guess / 2);
            var gi = 0;
            var eps = 1e-7;
            var k = 100;
            var tries = 3;
            while (k == 100 && tries > 0) {
                tries--;
                guess = (guess / 2);
                lastIncrement = guess / 2;

                for (k = 0; k < 100; ++k) {
                    gi = 1 - this._chidist(guess, v);
                    if (Math.abs((gi - p) / p) < eps) {
                        break;
                    }

                    if (gi > p) {
                        guess = guess + lastIncrement;
                    } else {
                        lastIncrement = lastIncrement / 2;
                        if (guess - lastIncrement < 0) {
                            lastIncrement = guess / 2;
                        }

                        guess = guess - lastIncrement;
                    }
                }
            }

            if (k == 100) {
                guess = -1;
            }

            return guess;
        };
        /**
         * 
		 * @private
        */
		this._chidist = function (x, v) {
            var gauss_w = [
                0.09654008851,
                0.09563872008,
                0.09384439908,
                0.09117387870,
                0.08765209300,
                0.08331192423,
                0.07819389579,
                0.07234579411,
                0.06582222278,
                0.05868409348,
                0.05099805926,
                0.04283589802,
                0.03427386291,
                0.02539206531,
                0.01627439473,
                0.00701861001
            ];

            var gauss_x = [
                0.04830766569,
                0.14447196158,
                0.23928736225,
                0.33186860228,
                0.42135127613,
                0.50689990893,
                0.58771575724,
                0.66304426693,
                0.73218211874,
                0.79448379597,
                0.84936761373,
                0.89632115577,
                0.93490607594,
                0.96476225559,
                0.98561151155,
                0.99726386185
            ];

            var gauss_n = 16;
            var ex = v / 2;
            var mult = 1 / (Math.pow(2, ex) * Math.exp(this._gammaln(ex)));
            ex = ex - 1;

            var a = 0;
            var b = x;

            var midPt = (a + b) / 2;
            var radius = (b - a) / 2;

            var sum = 0;

            var offset;
            for (var i = 0; i < gauss_n; ++i) {
                offset = gauss_x[i] * radius;
                sum = Number(sum) + Number(gauss_w[i] * (Math.pow(midPt + offset, ex) * Math.exp(-(midPt + offset) / 2) + Math.pow(midPt - offset, ex) * Math.exp(-(midPt - offset) / 2)));
            }

            sum = Number(mult) * Number(sum) * Number(radius);
            return sum;
        };
        /**
         * 
		 * @private
        */
		this._gammaln = function (x) {
            var gammaAs = [0.918938533204673, 0.000595238095238, 0.000793650793651, 0.002777777777778, 0.083333333333333];
            var y = x;
            var f = 0;
            if (y < 7) {
                f = y;
                y++;
                while (y < 7) {
                    f = f * y;
                    if (y < 7) {
                        y++;
                    }
                }

                f = -Math.log(f);
            }

            var z = this._parseDouble((1 / (y * y)).toString());
            return f + (y - this._parseDouble("0.5")) * Math.log(y) - y + gammaAs[0] + (((-gammaAs[1] * z + gammaAs[2]) * z - gammaAs[3]) * z + gammaAs[4]) / y;
		};
        /**
         * 
		 * @private
        */
		this._pearson = function (x, y, n) {
            var sumx = 0;
            var sumy = 0;
            for (var i = 0; i < n; ++i) {
                sumx += x[i];
                sumy += y[i];
            }

            sumx = sumx / n;
            sumy = sumy / n;

            var sumxy = 0;
            var sumx2 = 0;
            var sumy2 = 0;
            var d1, d;
            for (var i = 0; i < n; ++i) {
                d = x[i] - sumx;
                d1 = y[i] - sumy;
                sumxy += d * d1;
                sumx2 += d * d;
                sumy2 += d1 * d1;
            }

            return sumxy / Math.sqrt(sumx2 * sumy2);
        };
        /**
         * 
		 * @private
        */
		this._fProbabilityDensity = function (x, k1, k2) {
            if (k1 <= 0 || k2 <= 0)
                throw "k1 and k2 must be greater than 0.";
            if (x == 0)
                return 0.0;
            var a1 = Math.pow(k1 * x, 0.5 * k1);
            var a2 = Math.pow(k2, 0.5 * k2);
            var a3 = Math.pow(k1 * x + k2, 0.5 * (k1 + k2));
            var a = a1 * a2 / a3;
            var b = this._betaFunction(0.5 * k1, 0.5 * k2);
            var c = x * b;
            return a / c;
        };
        /**
         * 
		 * @private
        */
		this._fCumulativeDensity = function (x, k1, k2) {
            if (k1 <= 0 || k2 <= 0)
                throw "k1 and k2 must be greater than 0.";
            if (x < 0)
                throw "x must be greater than 0.";

            if (x == 0)
                return 0.0;
            var x2 = (k1 * x) / (k1 * x + k2);
            var p = this._rIBetaFunction(x2, 0.5 * k1, 0.5 * k2);
            return Math.min(1, p);
        };
        /**
         * 
		 * @private
        */
		this._rIBetaFunction = function (x, a, b) {
            if (x <= 0.0)
                return 0.0;
            if (x >= 1.0)
                return 1.0;

            if (a % 1.0 == 0 && b % 1.0 == 0 && a + b > 0)
                return this._rIBetaFunction1(x, a, b);
            if (b % 1.0 == 0 && a + b < 172)
                return this._rIBetaFunction2(x, a, b);
            if (a % 1.0 == 0 && a + b < 172)
                return 1.0 - this._rIBetaFunction2(1.0 - x, b, a);
            if (a == 0.5 && b == 0.5)
                return (2.0 / Math.PI) * Math.atan(Math.sqrt(x / (1.0 - x)));
            if (a == 0.5 && b % 0.5 == 0) {
                return 1.0 - this._rIBetaFunction(1.0 - x, b, 0.5);
            }
            if (a % 0.5 == 0 && b == 0.5) {
                if (a < 45) {
                    //CASE B (partial)
                    var s = 0;
                    var n = Math.round(a - 0.5);
                    var logGammaHalf = this._parseDouble(this.computeGammaln("0.5".toString()));
                    for (var i = 0; i < n; i++) {
                        s = s + Math.exp(this._gammaln(i + 1) - this._gammaln(i + 1.5) - logGammaHalf) * Math.pow(x, i);
                    }
                    return this._rIBetaFunction(x, 0.5, 0.5) - Math.sqrt(x * (1 - x)) * s;
                } else {
                    //CASE C (partial)
                    var M = this._betaFunction(a, 0.5);
                    var lambda = Math.sqrt(1.0 - Math.pow(M * Math.sqrt((a - 1.0) / Math.PI) * this._epsilon, 1.0 / (a - 1.0)));

                    //Gaussian weights
                    var weights = [
                        0.066671344308688, 0.14945134915058, 0.21908636251598, 0.26926671931000, 0.29552422471475,
                        0.29552422471475, 0.26926671931000, 0.21908636251598, 0.14945134915058, 0.066671344308688];

                    var mgas = [
                        0.013046735791414, 0.067468316655507, 0.16029521585049, 0.28330230293538, 0.42556283050918,
                        0.57443716949081, 0.71669769706462, 0.83970478414951, 0.93253168334449, 0.98695326420859];

                    var sqrtOneMinusX = Math.sqrt(1 - x);
                    var s = 0;
                    for (var i = 0; i < 10; i++) {
                        s = s + weights[i] * Math.pow(1.0 - Math.pow((lambda - sqrtOneMinusX) * mgas[i] + sqrtOneMinusX, 2), a - 1.0);
                    }
                    var l = Math.exp(this._gammaln(a + 0.5) - this._gammaln(a) - this._gammaln(0.5));
                    return (lambda - sqrtOneMinusX) * l * s;
                }
            }
            if (a % 0.5 == 0 && b % 0.5 == 0) {
                //CASE B and C
                var s = 0;
                var n = Math.round(b - 0.5);
                var logGammaA = this._gammaln(a);
                var xToTheA = Math.pow(x, a);
                for (var i = 0; i < n; i++) {
                    s = s + Math.exp(this._gammaln(a + i + 0.5) - logGammaA - this._gammaln(i + 1.5)) * Math.pow(1 - x, i) * xToTheA;
                }
                var d = this._rIBetaFunction(x, a, 0.5) + Math.sqrt(1 - x) * s;
                return Math.max(0.0, Math.min(1.0, d));
            }
            if (x > 0.5)
                return 1.0 - this._rIBetaFunction(1.0 - x, b, a);

            var ribf = this._iBetaFunction(x, a, b) / this._betaFunction(a, b);
            return Math.max(0.0, Math.min(1.0, ribf));
        };
        /**
         * 
		 * @private
        */
		this._rIBetaFunction1 = function (x, a, b) {
            var s = 0;
            var c = a + b - 1;
            if (c < 21) {
                for (var i = a; i < a + b; i++) {
                    s = s + Math.pow(x, i) * Math.pow(1.0 - x, c - i) / (this._factorial(i) * this._factorial(c - i));
                }
                s = s * this._factorial(c);
            } else {
                for (var i = a; i < a + b; i++) {
                    s = s + Math.pow(x, i) * Math.pow(1.0 - x, c - i) * this._combinations(c, i);
                }
            }

            return Math.max(0.0, Math.min(1.0, s));
        };
        /**
         * 
		 * @private
        */
		this._rIBetaFunction2 = function (x, a, b) {
            if (a + b > 172)
                throw "Cannot currently compute RegularizedIncompleteBetaFunction for a + b > 172";

            var s = 0;
            for (var i = 1; i < b + 1; i++) {
                s = s + Math.pow(1 - x, i - 1) * Math.exp(this._gammaln(a + i - 1) - this._gammaln(i));
            }
            s = s * (Math.pow(x, a) * Math.exp(-this._gammaln(a)));
            return s;
        };
        /**
         * 
		 * @private
        */
		this._iBetaFunction = function (x, a, b) {
            if (x == 0)
                return 0;
            if (x == 1)
                return this._betaFunction(a, b);

            if (x <= 0.9) {
                return this._pIBetaFunction(0, x, a, b);
            }
            if (x <= 0.99) {
                var s1 = this._pIBetaFunction(0, 0.9, a, b);
                var s2 = this._pIBetaFunction(0.90, x, a, b);
                return s1 + s2;
            } else {
                var s1 = this._pIBetaFunction(0, 0.9, a, b);
                var s2 = this._pIBetaFunction(0.9, 0.99, a, b);
                var s3 = this._pIBetaFunction(0.99, x, a, b);
                return s1 + s2 + s3;
            }
        };
        /**
         * 
		 * @private
        */
		this._pIBetaFunction = function (xL, xU, a, b) {
            if (xU == xL)
                return 0.0;
            if (xU < xL)
                return NaN;

            var nSteps = 1000;
            if (a < 1)
                nSteps = 80000;

            var dt = (xU - xL) / nSteps;
            var t = xL + 0.5 * dt;
            var sum = 0;
            for (var i = 0; i < nSteps; i++) {
                sum = sum + Math.pow(t, a - 1) * Math.pow(1.0 - t, b - 1) * dt;
                t = t + dt;
            }
            return sum;
        };
        /**
         * 
		 * @private
        */
		this._betaFunction = function (a, b) {
            if (a + b > 143) {
                if (b > 20)
                    return 2.5066282746310002 * Math.pow(a, a - 0.5) * Math.pow(b, b - 0.5) / Math.pow(a + b, a + b - 0.5);
                return this._gammaFunction(b) * Math.pow(a, -b);
            }
            return this._gammaFunction(a) * this._gammaFunction(b) / this._gammaFunction(a + b);
        };
        /**
         * 
		 * @private
        */
		this._gammaFunction = function (z) {
            //approximation based on Stirling's formula
            //based on approximation from NIST Handbook of Mathematical Function. 2010. Cambridge University Press.
            if (z > 143)
                throw "Cannot currently compute gamma function for z > 143";

            //need z<21 or z<11 becaus Factorial(x) will not work for x>20
            if (z > 0 && z < 21 && z % 1.0 == 0)
                return this._factorial(Math.round(z - 1));
            if (z > 0 && z < 11 && z % 0.5 == 0) {
                var n = z;
                var sqrtPi = 1.77245385090552;
                return sqrtPi * this._factorial(2 * n) / (Math.pow(4, n) * this._factorial(n));
            }

            var sqrtTwoPi = 2.5066282746310002;
            var d = 1.0 + 1.0 / (12 * z) + 1.0 / (288 * z * z) - 139.0 / (51840 * Math.pow(z, 3)) - 571.0 / (2488320 * Math.pow(z, 4)) + 163879.0 / (209018880 * Math.pow(z, 5)) + 5246819.0 / (75246796800 * Math.pow(z, 6));
            var g = Math.pow(z, z - 0.5) * Math.exp(-z) * sqrtTwoPi * d;
            return g;
        };
        /**
         * 
		 * @private
        */
		this._epsilon = 4.94066e-324;
        /**
         * 
		 * @private
        */
		this._factorial = function (n) {
            if (n < 0)
                throw "Factorial not defined for negative n";
            if (n > 20)
                throw "Answer will exceed max long";
            var fact = 1;
            for (var i = n; i > 0; i--)
                fact = fact * i;
            return fact;
        };
        /**
         * 
		 * @private
        */
		this._combinations = function (n, k) {
            var logCombin = this._logCombin(n, k);
            var combin = Math.exp(logCombin);
            return Math.round(combin);
        };
        /**
         * 
		 * @private
        */
		this._logCombin = function (n, k) {
            return this._logFactorial(n) - this._logFactorial(k) - this._logFactorial(n - k);
        };
        /**
         * 
		 * @private
        */
		this._logFactorial = function (x) {
            var lf = 0;
            for (var i = 2; i <= x; i++)
                lf = lf + Math.log(i);
            return lf;
        };
        /**
         * 
		 * @private
        */
		this._isCellReference = function (args) {
            if (args == "") {
                return false;
            }
            args = this.setTokensForSheets(args);
            var sheetToken1 = this._sheetToken(args);
            var containsBoth = false;
            if (sheetToken1 != "") {
                args = args.split(this.sheetToken).join("");
            }

            var isAlpha = false, isNum = false;
            if (args.indexOf(':') != args.lastIndexOf(':')) {
                return false;
            }
            var charArray = (args.split('').join(this.getParseArgumentSeparator())).split(this.getParseArgumentSeparator());
            for (var c = 0; c < charArray.length; c++) {
                if (this._isLetter(charArray[c])) {
                    isAlpha = true;
                } else if (this._isDigit(charArray[c])) {
                    if (charArray[c] === 0)
                        return false;
                    isNum = true;
                } else if (charArray[c] == ':') {
                    if (isAlpha && isNum) {
                        containsBoth = true;
                    }
                    isAlpha = false;
                    isNum = false;
                } else
                    return false;
            }
            if (args.indexOf(":") > -1 && args.indexOf(this.tic) == -1) {
                if (containsBoth && isAlpha && isNum)
                    return true;
                else if (((isAlpha && !isNum) || (!isAlpha && isNum)) && !containsBoth) {
                    return true;
                } else
                    return false;
            }
            if (isAlpha && isNum && args.indexOf(this.tic) == -1) {
                return true;
            }

            return false;
        };
        /**
         * 
		 * @private
        */
		this._isDate = function (dateString) {
		    //JS-32710 - To parse the date object properly.
		    if (typeof dateString == "object" || ej.parseDate(dateString) != null) {
		        var date = new Date(Date.parse(dateString));
		        if (date >= this._dateTime1900) {
		            return date;
		        } else
		            return "NaN";
		    }
		    else {
		        return "NaN";
		    }
		};
        /**
         * 
		 * @private
        */
		this._isDigit = function (text) {
            var charCode = text.charCodeAt(0);

            if ((charCode > 47) && (charCode < 58)) {
                return true;
            }
            return false;
        };
        /**
         * 
		 * @private
        */
		this._isHLookupCachingEnabled = function () {
            return ((this._enableLookupTableCaching & 3 /* Both */) != 0) || ((this._enableLookupTableCaching & 2 /* HLOOKUP */) != 0);
        };
        /**
         * 
		 * @private
        */
		this._isLetter = function (c) {
            var cc = c.charCodeAt(0);
            if ((cc >= 0x41 && cc <= 0x5A) || (cc >= 0x61 && cc <= 0x7A)) {
                return true;
            }
            return false;
        };
        /**
         * 
		 * @private
        */
		this._isLetterOrDigit = function (c) {
            var cc = c.charCodeAt(0);
            if ((cc >= 0x30 && cc <= 0x39) || (cc >= 0x41 && cc <= 0x5A) || (cc >= 0x61 && cc <= 0x7A)) {
                return true;
            }
            return false;
        };
        /**
         * 
		 * @private
        */
		this._isLookupCachingEnabled = function () {
            return ((this._enableLookupTableCaching & 3 /* Both */) != 0) || ((this._enableLookupTableCaching & 1 /* VLOOKUP */) != 0) || ((this._enableLookupTableCaching & 2 /* HLOOKUP */) != 0);
        };
        /**
         * 
		 * @private
        */
		this._isOptimizedMatchesEnabled = function () {
            return (this._enableLookupTableCaching & 4 /* OptimizeForMatches */) != 0;
        };
        /**
         * 
		 * @private
        */
		this._isRange = function (range) {
            ////checks if range holds a stand-alone range. Used to id when user inputs
            ////a formula that is just a range. Part of the support for using ranges as
            ////operands of binary operators. This method allows a range to be used with
            ////the formula assignment operator, =
            var isRange = false;
            var i = range.indexOf(':');
            if (i > 1 && i < range.length - 2) {
                ////check left side
                var j = i - 1;

                if (this._isDigit(range[j])) {
                    //// left side must end in digit
                    var needToCheckRightSide = false;
                    j--;
                    while (j > 0 && this._isDigit(range[j])) {
                        j--;
                    }

                    if (this._isLetter(range[j])) {
                        ////letters must come now
                        j--;
                        while (j >= 0 && this._isLetter(range[j])) {
                            j--;
                        }

                        if (j > -1 && range[j] == this._string_fixedreference[0]) {
                            j--;
                        }

                        if (j < 0) {
                            needToCheckRightSide = true; ////might have a range
                        } else {
                            if (range[j] == this.sheetToken) {
                                if (j-- > 1 && range[j] == this.tic[0]) {
                                    needToCheckRightSide = range.substring(0, j - 1).lastIndexOf(this.tic[0]) == 0;
                                } else if (j > 0 && this._isDigit(range[j])) {
                                    needToCheckRightSide = range.substring(0, j).lastIndexOf(this.sheetToken) == 0;
                                }
                            }
                        }
                    }

                    if (needToCheckRightSide) {
                        ////check right side
                        j = i + 1;

                        ////handle possible sheetnames
                        if (j < range.length - 6 && range[j] == this.tic[0]) {
                            j = range.indexOf(this.sheetToken, j + 1);
                            if (j < range.length - 2) {
                                j++;
                            }
                        }

                        if (j < range.length - 2 && range[j] == this._string_fixedreference[0]) {
                            j++;
                        }

                        if (this._isLetter(range[j])) {
                            j++;
                            while (j < range.length - 1 && this._isLetter(range[j])) {
                                j++;
                            }

                            if (this._isDigit(range[j])) {
                                j++;
                                while (j < range.length && this._isDigit(range[j])) {
                                    j++;
                                }

                                isRange = j == range.length;
                            }
                        }
                    }
                }
            }

            return isRange;
        };
        /**
         * 
		 * @private
        */
		this._isUpperChar = function (text) {
            var charCode = text.charCodeAt(0);
            return ((charCode > 64) && (charCode < 91));
        };
        /**
         * 
		 * @private
        */
		this._iisVLookupCachingEnabled = function () {
            return ((this._enableLookupTableCaching & 3 /* Both */) != 0) || ((this._enableLookupTableCaching & 1 /* VLOOKUP */) != 0);
        };
        /**
         * 
		 * @private
        */
		this._mark = function (copy, text, op, token, checkPrecedingChar) {
            var loc = 0;
            if (checkPrecedingChar) {
                loc = this._findAndCheckPrecedingChar(copy, op, loc);
                copy = this._findAndCheckPrecedingCharCopy;
            } else
                loc = copy.indexOf(op);
            var len = op.length;
            while (loc > -1) {
                copy = copy.substring(0, loc) + token + copy.substring(loc + len);
                text = text.substring(0, loc) + token + text.substring(loc + len);
                if (checkPrecedingChar) {
                    loc = this._findAndCheckPrecedingChar(copy, op, loc);
                    copy = this._findAndCheckPrecedingCharCopy;
                } else
                    loc = copy.indexOf(op, loc);
            }
            this._markCopy = "";
            return text;
        };
        /**
         * 
		 * @private
        */
		this._markColonsInQuotes = function (args) {
            var inQuotes = false;
            for (var i = 0; i < args.length; ++i) {
                if (args[i] == this.tic[0]) {
                    inQuotes = !inQuotes;
                } else if (args[i] == ':' && inQuotes) {
                    args = args.split(':').join(this._markerChar);
                }
            }
            return args;
        };
        /**
         * 
		 * @private
        */
		this._markIF = function (copy, text) {
            var locIF = copy.indexOf(this.getReservedWordOperators()[this._reservedWord_IF]);
            var locTHEN = copy.indexOf(this.getReservedWordOperators()[this._reservedWord_THEN]);
            var locELSE = copy.indexOf(this.getReservedWordOperators()[this._reservedWord_ELSE]);

            if (locELSE > -1 && locTHEN > -1) {
                var ifStart = this.getReservedWordOperators()[this._reservedWord_IF].length;
                var iflength = locTHEN - ifStart;
                var thenStart = locTHEN + this.getReservedWordOperators()[this._reservedWord_THEN].length;
                var thenlength = locELSE - thenStart;
                var elseStart = locELSE + this.getReservedWordOperators()[this._reservedWord_ELSE].length;
                var elselength = text.length - elseStart;
                text = "IF((" + this._substring(text, ifStart, iflength) + ")" + this.getParseArgumentSeparator() + "(" + this._substring(text, thenStart, thenlength) + ")" + this.getParseArgumentSeparator() + "(" + this._substring(text, elseStart, elselength) + "))";

                copy = text;
            } else if (locTHEN > -1) {
                var ifStart = 0;
                var iflength = locTHEN;
                var thenStart = locTHEN + this.getReservedWordOperators()[this._reservedWord_THEN].length;
                var thenlength = text.length - thenStart + 1;
                text = "IF((" + this._substring(text, ifStart, iflength) + ")" + this.getParseArgumentSeparator() + "(" + this._substring(text, thenStart, thenlength) + "))";

                copy = text;
            }

            this._markIFCopy = text;
            return text;
        };
        /**
         * 
		 * @private
        */
		this._markLibraryFormulas = function (formula) {
            var rightParens = formula.indexOf(')');
            if (rightParens == -1) {
                formula = this._markNamedRanges(formula);
            } else {
                while (rightParens > -1) {
                    var parenCount = 0;
                    var leftParens = rightParens - 1;
                    while (leftParens > -1 && (formula[leftParens] != '(' || parenCount != 0)) {
                        if (formula[leftParens] == ')') {
                            parenCount++;
                        } else if (formula[leftParens] == ')') {
                            parenCount--;
                        }

                        leftParens--;
                    }

                    if (leftParens == -1) {
                        throw this.formulaErrorStrings[this._mismatched_parentheses];
                    }

                    var i = leftParens - 1;
                    while (i > -1 && (this._isLetterOrDigit(formula[i]) || this._validFunctionNameChars.indexOf(formula[i]) > -1 || formula[i] == this.getParseDecimalSeparator())) {
                        i--;
                    }

                    var len = leftParens - i - 1;
                    if (len > 0 && this.getLibraryFunctions().getItem(this._substring(formula, i + 1, len)) != undefined) {
                        if (this._substring(formula, i + 1, len) == "AREAS")
                            this._ignoreBracet = true;
                        else
                            this._ignoreBracet = false;
                        var s = this._substring(formula, leftParens, rightParens - leftParens + 1);
                        s = this._markNamedRanges(s);
                        formula = formula.substring(0, i + 1) + 'q' + this._substring(formula, i + 1, len) + (s.split('(').join(this._leftBracket)).split(')').join(this._rightBracket) + formula.substring(rightParens + 1);
                    } else if (len > 0) {
                        if (this.unknownFunction != null) {
                            var family = CalcEngine.getSheetFamilyItem(this.grid);
                            var grd = this.grid;
                            var sheet = this._sheetToken(this.cell);
                            var s = this.cell;
                            if (sheet.length > 0) {
                                grd = family.tokenToParentObject.getItem(sheet);
                                s = s.substring(s.lastIndexOf(this.sheetToken) + 1);
                            }

                            var sheetNamekeys = family.sheetNameToParentObject.keys();
                            for (var key = 0; key < sheetNamekeys.length; key++) {
                                if (family.sheetNameToParentObject.getItem(sheetNamekeys[key]) == grd) {
                                    s = sheetNamekeys[key] + this.sheetToken + s;
                                    break;
                                }
                            }

                            var args = new UnknownFunctionEventArgs();
                            args.setMissingFunctionName(this._substring(formula, i + 1, len));
                            args.setCellLocation(s);

                            this.unknownFunction(this, args);
                            if (formula.substring(i + 1, len) == "AREAS")
                                this._ignoreBracet = true;
                            else
                                this._ignoreBracet = false;
                        }
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._unknown_formula_name] + " " + this._substring(formula, i + 1, len);
                        return this.getErrorStrings()[5].toString();

                    } else {
                        var s = "";
                        if (leftParens > 0) {
                            s = formula.substring(0, leftParens);
                        }

                        s = s + '{' + this._substring(formula, leftParens + 1, rightParens - leftParens - 1) + '}';
                        if (rightParens < formula.length) {
                            s = s + formula.substring(rightParens + 1);
                        }

                        s = this._markNamedRanges(s);
                        formula = s;
                    }

                    rightParens = formula.indexOf(')');
                }
            }

            formula = (formula.split('{').join('(')).split('}').join(')');
            return formula;
        };
        /**
         * 
		 * @private
        */
		this._markNamedRanges = function (argList) {
            ////Console.WriteLine("MarkNamedRanges in#{0}#", argList);
            var rightParens = argList.indexOf(')');
            var markers = [')', this.getParseArgumentSeparator(), '}', '+', '-', '*', '/', '<', '>', '=', '&'];

            //  int i = (argList.length > 0 && argList[0] == '(')
            var i = (argList.length > 0 && (argList[0] == '(' || argList[0] == '{')) ? 1 : 0;
            if (argList.indexOf("#N/A") > -1) {
                argList = argList.split("#N/A").join("#N~A");
            }
            if (argList.indexOf("#DIV/0!") > -1) {
                argList = argList.split("#DIV/0!").join("#DIV~0!");
            }
            var end = i;
            if (argList.indexOf("[") == -1 || argList.indexOf("[") > this._indexOfAny(argList.substring(i),markers))
                end = this._indexOfAny(argList.substring(i), markers);
            else
                end = this._findNextEndIndex(argList, end);

            while (end > -1 && end + i < argList.length) {
                var scopedRange = "";
                var s = null;
                if ((this._substring(argList, i, end)).indexOf("[") > -1) {
                    s = this._getTableRange(this._substring(argList, i, end));
                }
                else {
                    s = this.getNamedRanges().getItem(this._substring(argList, i, end));
                }
                if (s != undefined && !(typeof s === 'string'))
                    s = s.getItem(this._substring(argList, i, end));
                if (s == null) {
                    scopedRange = this._checkIfScopedRange(this._substring(argList, i, end));
                    if (!isNaN(scopedRange)) {
                        s = scopedRange;
                    } else if (this._substring(argList, i, end).startsWith(this.sheetToken.toString())) {
                        var iii = this._substring(argList, i, end).indexOf(this.sheetToken, 1);
                        if (iii > 1) {
                            s = this.getNamedRanges().getItem(this._substring(argList.substring(i), iii + 1, end - iii - 1));
                        }
                    }
                }
                if (s != null) {
                    s = s.toUpperCase();
                    s = this.setTokensForSheets(s);
                    s = this._markLibraryFormulas(s); ////recursive call
                }

                if (s != null) {
                    argList = argList.substring(0, i) + s + argList.substring(i + end);
                    i += s.length + 1;
                } else {
                    i += end + 1;
                    while (i < argList.length && !this._isUpperChar(argList[i]) && argList[i] != this.sheetToken) {
                        i++;
                    }
                }
                end = i;// argList.Substring(i).IndexOfAny(markers);
                if (argList.indexOf("[") == -1 || argList.indexOf("[") > this._indexOfAny(argList.substring(i), markers))
                    end = this._indexOfAny(argList.substring(i), markers);
                else
                    end = this._findNextEndIndex(argList, end);
                end = this._indexOfAny(argList.substring(i), markers);
                while (end == 0 && i < argList.length - 1) {
                    i++;
                    end = this._indexOfAny(argList.substring(i), markers);
                }

                if ((end == -1 || argList.substring(i).indexOf("[") >-1) && i < argList.length) {
                    if (argList.substring(i).indexOf("[") > -1) {
                        s = this._getTableRange(argList.substring(i));
                    }
                    else {
                        ////check last part of arglist
                        s = this.getNamedRanges().length > 0 ? this.getNamedRanges().getItem(argList.substring(i)) : s;
                    }
                    if (s == null) {
                        scopedRange = this._checkIfScopedRange(argList.substring(i));
                        if (!isNaN(scopedRange))
                            s = scopedRange;
                    }
                    if (s != null) {
                        s = s.toUpperCase();
                        s = this.setTokensForSheets(s);
                        s = this._markLibraryFormulas(s);
                        if (s != null) {
                            argList = argList.substring(0, i) + s; //// +argList.Substring(i + end);
                            i += s.toString().length + 1;
                        }
                    }

                    end = (i < argList.length) ? this._indexOfAny(argList.substring(i), markers) : -1;
                }
            }
            if (argList.indexOf("#N~A") > -1) {
                argList = argList.split("#N~A").join("#N/A");
            }

            if (argList.indexOf("#DIV~0!") > -1) {
                argList = argList.split("#DIV~0!").join("#DIV/0!");
            }
            return argList;
        };
        /**
         * 
		 * @private
        */
		this._markReserveWords = function (text) {
            var copy = text.toLowerCase();
            var trimStr = (this._isIE8) ? copy.replace(/^\s+|\s+$/g, '') : copy.trim();
            if (trimStr[0] == (this.getReservedWordOperators()[this._reservedWord_IF])) {
                text = this._markIF(copy, text);
                copy = this._markIFCopy;
            }

            text = this._mark(copy, text, this.getReservedWordOperators()[this._reservedWord_NOT], this.char_NOTop, true);
            copy = this._markCopy;
            text = this._mark(copy, text, this.getReservedWordOperators()[this._reservedWord_OR], this.char_ORop, false);
            copy = this._markCopy;
            text = this._mark(copy, text, this.getReservedWordOperators()[this._reservedWord_AND], this.char_ANDop, false);
            copy = this._markCopy;
            text = this._mark(copy, text, this.getReservedWordOperators()[this._reservedWord_XOR], this.char_XORop, false);
            copy = this._markCopy;
            return text;
        };
        /**
         * 
		 * @private
        */
		this._markupResultToIncludeInFormula = function (s) {
            var d3;
            if (s.length > 0 && s[0] == '-' && !isNaN(this._parseDouble(s))) {
                s = "nu" + s.substring(1);
            } else if (s.length > 0 && (s[0] == this.tic[0] || s[0] == this.bMARKER || s[0] == '#')) {
                ////Pass on the string...
            } else if (s.startsWith(this.trueValueStr) || s.startsWith(this.falseValueStr)) {
                ////Pass on the bool...
            } else {
                ////if(double.TryParse(s, NumberStyles.Any, null, out d))
                if (!isNaN(this._parseDouble(s))) {
                    // s = d.toString(); ////defect 8721
                    s = s.split(this.getParseArgumentSeparator()).join(String.fromCharCode(32));

                    s = 'n' + s;
                } else {
                    if (!this._isRange(s)) {
                        s = this.tic + s + this.tic;
                    }
                }
            }
            return s;
        };
        /**
         * 
		 * @private
        */
		this._matchCompare = function (o1, o2) {
            var s1 = o1.toString();
            var s2 = o2.toString();
            var d1 = this._parseDouble(s1), d2 = this._parseDouble(s2);
            if (!isNaN(d1) && !isNaN(d2)) {
                if (d1 == d2)
                    return 0;
                if (d1 > d2)
                    return 1;
                else
                    return -1;
            } else {
                if (s1 == s2)
                    return 0;
                if (s1 > s2)
                    return 1;
                else
                    return -1;
            }
        };
        /**
         * 
		 * @private
        */
		this._matchingRightBracket = function (formula) {
            var ret = -1;
            var loc = 1;
            var bracketLevel = 0;
            var token = this._sheetToken(formula);
            while (ret == -1 && loc < formula.length) {
                if (formula[loc] == this._rightBracket) {
                    if (bracketLevel == 0) {
                        ret = loc;
                    } else {
                        bracketLevel--;
                        if (bracketLevel == 0 && loc == formula.length - 1) {
                            ret = loc;
                        }
                    }
                } else if (formula[loc] == 'q') {
                    var val = loc + 1;
                    if (val < formula.length) {
                        var libFunc = this._processUpperCase(formula, val, token);
                        formula = this._processUpperCaseFormula;
                        val = this._processUpperCaseIvalue;
                        token = this._processUpperCaseSheet;
                        if (libFunc != "" && this.getLibraryFunctions().containsKey(libFunc))
                            bracketLevel++;
                    }
                }

                loc++;
            }

            return ret;
        };
        /**
         * 
		 * @private
        */
		this._notInBlock = function (text, position) {
            var i = text.indexOf(this.bMARKER);
            var inBlock = false;
            while (i > -1 && i < position) {
                inBlock = !inBlock;
                i = text.indexOf(this.bMARKER, i + 1);
            }

            return !inBlock;
        };
        /**
         * 
		 * @private
        */
		this._getTopRowIndexFromRange = function (range) {
		    range = this._markColonsInQuotes(range);
		    var row1, col1;
		    var i = range.indexOf(':');
		    if (i == -1)
		        return this.rowIndex(range);
		    var sheet = "";
		    var j = range.indexOf(this.sheetToken);
		    if (j > -1) {
		        var j1 = range.indexOf(this.sheetToken, j + 1);
		        if (j1 > -1) {
		            sheet = this._substring(range, j, j1 - j + 1);
		            range = range.replace(sheet, "");
		            i = range.indexOf(':');
		        }
		    }
		    row1 = this.rowIndex(range.substring(0, i));
		    return row1;
		};

        /**
         * 
		 * @private
        */
		this._getTableRange = function (text) {
		    text = text.replace(" ", "").toUpperCase();
		    var name = text.replace("]", "").replace("#DATA", "");
		    var tableName = name;
		    if (name.indexOf(this.getParseArgumentSeparator()) > -1) {
		        tableName = name.substring(0, name.indexOf(this.getParseArgumentSeparator())).replace("[", "");
		        name = name.replace("[", "").replace(this.getParseArgumentSeparator(), '_');
		    }
		    var range = "";
		    if (text.indexOf("#THISROW") > -1) {
		        var cellRange = this.getNamedRanges().getItem(name.replace("#THISROW", ""));

		        if (cellRange != undefined && !(typeof cellRange === 'string'))
		            cellRange = cellRange.getItem(name.replace("#THISROW", ""));
		        if (cellRange == null)
		            return cellRange;
		        cellRange = cellRange.toUpperCase();
		        var row = this.rowIndex(this.cell);
		        cellRange = cellRange.replace(this._string_fixedreference, "");

		        cellRange = this.setTokensForSheets(cellRange);
		        var startindex = 0;
		        var rangeTable = this.getNamedRanges().getItem(tableName.Replace("#THISROW", ""));
		        if (rangeTable != undefined && !(typeof rangeTable === 'string'))
		            rangeTable = rangeTable.getItem(tableName.Replace("#THISROW", ""));
		        rangeTable = rangeTable.replace(this._string_fixedreference, "").toUpperCase();
		        rangeTable = this.setTokensForSheets(rangeTable);
		        var topRow = this._getTopRowIndexFromRange(cellRange);
		        range = this.getCellsFromArgs(cellRange)[row - topRow];
		    }
		    else {
		        name = (name[name.length - 1] == "[") ? name.replace("[", "") : name.replace("[", "_");
		        if (name.indexOf("#TOTALS") > -1 || name.indexOf("#ALL") > -1 || name.indexOf("#HEADERS") > -1 || name.indexOf("#DATA") > -1)
		            name = name.replace("#", "");
		        range = this.getNamedRanges().getItem(name);
		        if (range != undefined && !(typeof range === 'string'))
		            range = range.getItem(name);
		        if (range == null)
		            return null;
		    }
		    return range.toUpperCase();;
		};
        /**
         * 
		 * @private
        */
		this._parse = function (formulaText) {
            var text = formulaText;
            if (this._isTextEmpty(text)) {
                return text;
            }
            text = this.getFormulaText(text);

            if (this.getSupportLogicalOperators()) {
                text = this._markReserveWords(text);
            }

            if (this.getFormulaCharacter() != String.fromCharCode(0) && this.getFormulaCharacter() == text[0]) {
                text = text.substring(1);
            }

            ////Special check for single namedrange.
            if (this.getNamedRanges().length > 0) {
                if (text.indexOf("[") > -1) {
                    var namerangeVal = this._getTableRange(text);
                    if (namerangeVal != null)
                        text = namerangeVal;
                }
                if (this.getNamedRanges().getItem(text.toUpperCase()) != undefined) {
                    text = this.getNamedRanges().getItem(text.toUpperCase()).toUpperCase();
                } else {
                    var scopedRange = "";
                    scopedRange = this._checkIfScopedRange(text.toUpperCase());
                    if (!isNaN(scopedRange)) {
                        text = scopedRange.toUpperCase();
                    }
                }
            }

            var formulaStrings = this._saveStrings(text);
            text = this._saveStringsText;
            text = text.split(this.braceLeft).join(this.tic);
            text = text.split(this.braceRight).join(this.tic);

            text = text.split("-+").join("-");
            var i = 0;
            if (text[text.length - 1] != this.bMARKER || this._indexOfAny(text, this.tokens) != (text.length - 2))
                text = text.toUpperCase();

            if (text.indexOf(this.sheetToken) > -1) {
                //replace sheet references with tokens.
                var family = CalcEngine.getSheetFamilyItem(this.grid);
                if (family.sheetNameToParentObject != null && family.sheetNameToParentObject.length > 0) {
                    try  {
                        text = this.setTokensForSheets(text);
                    } catch (ex) {
                        if (this._rethrowExceptions) {
                            throw ex;
                        } else {
                            return ex;
                        }
                    }
                }
            }

            if (this._isRangeOperand) {
                this._isRangeOperand = false;
                return this._getCellFrom(this._parseSimple(text));
            }

            ////next 3 lines moved from above - //keep the tic defect#541
            text = text.split(" ").join("");
            text = text.split("=>").join(">=");
            text = text.split("=<").join("<=");

            try  {
                text = this._markLibraryFormulas(text);
            } catch (ex) {
                if (this._rethrowExceptions) {
                    throw ex;
                } else {
                    return ex;
                }
            }

            ////Look for inner matching and parse pieces without parens with ParseSimple.
            if (!this._ignoreBracet) {
                while ((i = text.indexOf(')')) > -1) {
                    var k = text.substring(0, i).lastIndexOf('(');
                    if (k == -1) {
                        throw this.formulaErrorStrings[this._mismatched_parentheses];
                    }

                    if (k == i - 1) {
                        throw this.formulaErrorStrings[this._empty_expression];
                    }
                    var s = "";
                    if (this._ignoreBracet) {
                        s = this._substring(text, k, i - k + 1);
                    } else
                        s = this._substring(text,k + 1, i - k - 1);
                    text = text.substring(0, k) + this._parseSimple(s) + text.substring(i + 1);
                }
            }

            ////All parens should have been removed.
            if (!this._ignoreBracet && text.indexOf('(') > -1) {
                throw this.formulaErrorStrings[this._mismatched_parentheses];
            }

            var retValue = this._parseSimple(text);

            if (formulaStrings != null && formulaStrings.length > 0) {
                retValue = this._setStrings(retValue, formulaStrings);
            }
            return retValue;
        };
        /**
         * 
		 * @private
        */
		this._parseDouble = function (value) {
            return !isNaN(parseInt(value)) ? Number(value.toString().replace(/[^0-9\.]-+/g,"")) * 1 : NaN;
        };
        /**
         * 
		 * @private
        */
		this._parseSimple = function (formulaText) {
            var text = formulaText;

            ////strip leading plus
            if (text.length > 0 && text[0] == '+') {
                text = text.substring(1);
            }

            if (text == "#N/A" || text == "#N~A") {
                return "#N/A";
            } else if (text.indexOf("#N/A") > -1) {
                text = text.split("#N/A").join("#N~A");
            }
            if (text == "#DIV/0!" || text == "#DIV~0!") {
                return "#DIV/0!";
            } else if (text.indexOf("#DIV/0!") > -1) {
                text = text.split("#DIV/0!").join("#DIV~0!");
            }

            text = this._handleEmbeddedEs(text);

            text = text.split(this._string_lesseq).join(this.char_lesseq);
            text = text.split(this._string_greatereq).join(this.char_greatereq);
            text = text.split(this._string_noequal).join(this.char_noequal);
            text = text.split(this._string_fixedreference).join(this._string_empty);
            text = text.split(this._string_or).join(this.char_or);
            text = text.split(this._string_and).join(this.char_and);

            if (text == "") {
                return text;
            }

            var needToContinue = true;

            ////doing things sequentially imposes computation hierarchy for 6 levels
            //// 0. E+ E- //handles exponential notation like 1.2e-1 or 1.2e+1 to 1.2e1
            //// 1. ^ exponentiation
            //// 2. * /
            //// 3. + -
            //// 4. < > = <= >= <>
            //// 5. & concatenation
            //// in each level parsing done left to right
            var expTokenArray = [this.token_EP, this.token_EM];
            var orTokenArray = [this.token_or];
            var mulTokenArray = [this.token_multiply, this.token_divide];
            var addTokenArray = [this.token_add, this.token_subtract];
            var compareTokenArray = [this.token_less, this.token_greater, this.token_equal, this.token_lesseq, this.token_greatereq, this.token_noequal];
            var notTokenArray = [this.token_NOTop];
            var logicTokenArray = [this.token_ORop, this.token_ANDop, this.token_XORop];
            var andTokenArray = [this.token_and];

            var expCharArray = [this.char_EP, this.char_EM];
            var orCharArray = [this.char_or];
            var mulCharArray = [this.char_multiply, this.char_divide];
            var addCharArray = [this.char_add, this.char_subtract];
            var compareCharArray = [this.char_less, this.char_greater, this.char_equal, this.char_lesseq, this.char_greatereq, this.char_noequal];
            var notCharArray = [this.char_NOTop];
            var logicCharArray = [this.char_ORop, this.char_ANDop, this.char_XORop];
            var andCharArray = [this.char_and];

            text = this._parseSimpleOperators(text, expTokenArray, expCharArray);

            text = this._parseSimpleOperators(text, orTokenArray, orCharArray);

            if (needToContinue) {
                text = this._parseSimpleOperators(text, mulTokenArray, mulCharArray);
            }

            if (needToContinue) {
                text = this._parseSimpleOperators(text, addTokenArray, addCharArray);
            }

            if (needToContinue) {
                text = this._parseSimpleOperators(text, compareTokenArray, compareCharArray);
            }

            if (needToContinue) {
                text = this._parseSimpleOperators(text, notTokenArray, notCharArray);
            }

            if (needToContinue) {
                text = this._parseSimpleOperators(text, logicTokenArray, logicCharArray);
            }

            if (needToContinue) {
                text = this._parseSimpleOperators(text, andTokenArray, andCharArray);
            }

            if (text.indexOf("#N~A") > -1) {
                text = text.split("#N~A").join("#N/A");
            }

            if (text.indexOf("#DIV~0!") > -1) {
                text = text.split("#DIV~0!").join("#DIV/0!");
            }
            return text;
        };
        /**
         * 
		 * @private
        */
		this._parseSimpleOperators = function (formulaText, markers, operators) {
            var text = formulaText;
            var i;

            ////op is string containing this.char_xxxx's for each operator in this level
            var op = "";
            for (var c = 0; c < operators.length; c++) {
                op = op + operators[c];
            }

            //text = sb.replace(",-", ",u").replace(this._leftBracket + "-", this._leftBracket + "u").replace("=-", "=u").replace(">-", ">u").replace("<-", "<u").replace("/-", "/u").replace("*-", "*u").replace("+-", "+u").replace("--", "-u").replace("w-", "wu").toString();
            text = text.split("---").join("-").split("--").join("+").split(this.getParseArgumentSeparator() + "-").join(this.getParseArgumentSeparator() + "u").split(this._leftBracket + "-").join(this._leftBracket + "u").split("=-").join("=u");
            text = text.split(">-").join(">u").split("<-").join("<u").split("/-").join("/u").split("*-").join("*u").split("+-").join("-").split("--").join("-u").split("w-").join("wu").split(this.tic + "-").join(this.tic + "u").toString();

            ////Get rid of leading pluses.
            text = text.split(",+").join(",").split(this._leftBracket + "+").join(this._leftBracket).split("=+").join("=").split(">+").join(">").split("<+").join("<").split("/+").join("/").split("*+").join("*").split("++").join("+").toString();

            if (text.length > 0 && text[0] == '-') {
                ////Leading unary minus.
                text = "0" + text;
            } else if (text.length > 0 && text[0] == '+') {
                ////Leading plus.
                text = text.substring(1);
            }

            if (this._indexOfAny(text, operators) > -1) {
                while ((i = this._indexOfAny(text, operators)) > -1) {
                    var left = "";
                    var right = "";

                    var leftIndex = 0;
                    var rightIndex = 0;
                    var isNotOperator = this._supportLogicalOperators && text[i] == this.char_NOTop;
                    var j = 0;

                    if (!isNotOperator) {
                        if (i < 1 && text[i] != '-') {
                            throw this.formulaErrorStrings[this._operators_cannot_start_an_expression];
                        }

                        j = i - 1;

                        if (i == 0 && text[i] == '-') {
                            ////Unary minus - block and continue.
                            text = this.bMARKER + "nu" + text.substring(1) + this.bMARKER;
                            continue;
                        } else if (text[j] == this.tic[0]) {
                            ////string
                            var k = text.substring(0, j - 1).lastIndexOf(this.tic);
                            if (k < 0) {
                                throw this.formulaErrorStrings[this._cannot_parse];
                            }

                            left = this._substring(text, k, j - k + 1); ////Keep the tics.
                            leftIndex = k;
                        } else if (text[j] == this.bMARKER) {
                            var k = this._findLastNonQB(text.substring(0, j - 1));
                            if (k < 0) {
                                throw this.formulaErrorStrings[this._cannot_parse];
                            }
                            left = this._substring(text, k + 1, j - k - 1);
                            leftIndex = k + 1;
                        } else if (text[j] == this._rightBracket) {
                            ////Library member.
                            var bracketCount = 0;
                            var k = j - 1;
                            while (k > 0 && (text[k] != 'q' || bracketCount != 0)) {
                                if (text[k] == 'q') {
                                    bracketCount--;
                                } else if (text[k] == this._rightBracket) {
                                    bracketCount++;
                                }

                                k--;
                            }

                            if (k < 0) {
                                throw this.formulaErrorStrings[this._cannot_parse];
                            }

                            left = this._substring(text, k, j - k + 1);
                            leftIndex = k;
                        } else if (!this._isDigit(text[j]) && text[j] != '%') {
                            while (j >= 0 && (this._isUpperChar(text[j]) || text[j] == '_' || text[j] == '.')) {
                                j--;
                            }

                            left = this._substring(text, j + 1, i - j - 1); ////'n' for number
                            leftIndex = j + 1;
                            var scopedRange = "";

                            if (this.getNamedRanges().containsKey(left) > -1) {
                                //JS-47897 - To get the value from HashTable
                                left = this._parse(this.getNamedRanges().getItem(left));
                            } else if (!isNaN(scopedRange = this._checkIfScopedRange(left, scopedRange))) {
                                left = this._parse(scopedRange);
                            } else if (left == this.trueValueStr) {
                                left = 'n' + this.trueValueStr;
                            } else if (left == this.falseValueStr) {
                                left = 'n' + this.falseValueStr;
                            } else {
                                if (this.getRethrowLibraryComputationExceptions())
                                    throw this.formulaErrorStrings[this._invalid_char_in_front_of]  + " " + text[i];
                                return this.getErrorStrings()[5].toString();
                            }
                        } else {
                            var period = false;
                            var percent = false;

                            while (j > -1 && (this._isDigit(text[j]) || (!period && text[j] == this.getParseDecimalSeparator()) || (!percent && text[j] == '%') || text[j] == 'u')) {
                                if (text[j] == this.getParseDecimalSeparator()) {
                                    period = true;
                                } else if (text[j] == '%') {
                                    percent = true;
                                }
                                j = j - 1;
                            }

                            ////Add error check for 2%.
                            if (j > -1 && period && text[j] == this.getParseDecimalSeparator()) {
                                throw this.formulaErrorStrings[this._number_contains_2_decimal_points];
                            }

                            j = j + 1;

                            if (j == 0 || (j > 0 && !this._isUpperChar(text[j - 1]))) {
                                left = 'n' + this._substring(text, j, i - j); ////'n' for number
                                leftIndex = j;
                            } else {
                                ////We have a cell reference.
                                j = j - 1;
                                while (j > -1 && this._isUpperChar(text[j])) {
                                    j = j - 1;
                                }

                                ////include any unary minus as part of the left piece
                                if (j > -1 && text[j] == 'u') {
                                    j = j - 1;
                                }
                                if (j > -1 && text[j] == this.sheetToken) {
                                    j = j - 1;
                                    while (j > -1 && text[j] != this.sheetToken) {
                                        j = j - 1;
                                    }

                                    if (j > -1 && text[j] == this.sheetToken) {
                                        j = j - 1;
                                    }
                                }

                                if (j > -1 && text[j] == ':') {
                                    //// handle range operands
                                    j = j - 1;
                                    while (j > -1 && this._isDigit(text[j])) {
                                        j = j - 1;
                                    }

                                    while (j > -1 && this._isUpperChar(text[j])) {
                                        j = j - 1;
                                    }

                                    if (j > -1 && text[j] == this.sheetToken) {
                                        j--;
                                        while (j > -1 && text[j] != this.sheetToken) {
                                            j--;
                                        }

                                        if (j > -1 && text[j] == this.sheetToken) {
                                            j--;
                                        }
                                    }

                                    j = j + 1;
                                    left = this._substring(text, j, i - j);
                                    left = this._getCellFrom(left);
                                } else {
                                    //// handle normal cell reference
                                    j = j + 1;
                                    left = this._substring(text, j, i - j);
                                }
                                this.updateDependencies(left);
                                leftIndex = j;
                            }
                        }
                    } else {
                        leftIndex = i;
                    }
                    if (i == text.length - 1) {
                        throw this.formulaErrorStrings[this._expression_cannot_end_with_an_operator];
                    } else {
                        j = i + 1;

                        var isU = text[j] == 'u';
                        if (isU) {
                            j++; ////ship for now, but add back later
                        }

                        if (text[j] == this.tic[0]) {
                            ////string
                            var k = text.substring(j + 1).indexOf(this.tic);
                            if (k < 0) {
                                throw this.formulaErrorStrings[this._cannot_parse];
                            }

                            right = this._substring(text, j, k + 2);
                            rightIndex = k + j + 2;
                        } else if (text[j] == this.bMARKER) {
                            ////Block of already parsed code.
                            var k = this._findNonQB(text.substring(j + 1));
                            if (k < 0) {
                                throw this.formulaErrorStrings[this._cannot_parse];
                            }

                            right = this._substring(text, j + 1, k);

                            if (isU) {
                                right = right + "nu1m"; ////multiply quantity by -1...
                            }

                            rightIndex = k + j + 2;
                        } else if (text[j] == 'q') {
                            ////library
                            var bracketCount = 0;
                            var k = j + 1;
                            while (k < text.length && (text[k] != this._rightBracket || bracketCount != 0)) {
                                if (text[k] == this._rightBracket) {
                                    bracketCount++;
                                } else if (text[k] == 'q') {
                                    bracketCount--;
                                }

                                k++;
                            }

                            if (k == text.length) {
                                throw this.formulaErrorStrings[this._cannot_parse];
                            }

                            right = this._substring(text, j, k - j + 1);

                            if (isU) {
                                right = 'u' + right;
                            }

                            rightIndex = k + 1;
                        } else if (this._isDigit(text[j]) || text[j] == this.getParseDecimalSeparator()) {
                            var period = text[j] == this.getParseDecimalSeparator();
                            j = j + 1;
                            while (j < text.length && (this._isDigit(text[j]) || (!period && text[j] == this.getParseDecimalSeparator()))) {
                                if (text[j] == this.getParseDecimalSeparator()) {
                                    period = true;
                                }

                                j = j + 1;
                            }

                            if (j < text.length && text[j] == '%') {
                                j += 1;
                            }

                            if (period && j < text.length && text[j] == this.getParseDecimalSeparator()) {
                                throw this.formulaErrorStrings[this._number_contains_2_decimal_points];
                            }
                            right = 'n' + this._substring(text, i + 1, j - i - 1);
                            rightIndex = j;
                        } else if (this._isUpperChar(text[j]) || text[j] == this.sheetToken || text[j] == 'u') {
                            if (text[j] == this.sheetToken) {
                                j++;
                                while (j < text.length && text[j] != this.sheetToken) {
                                    j++;
                                }
                            }
                            j = j + 1;
                            var j0 = 0;
                            while (j < text.length && (this._isUpperChar(text[j]) || text[j] == '_' || text[j] == '.')) {
                                j++;
                                j0++;
                            }

                            var noCellReference = (j == text.length) || !this._isDigit(text[j]);

                            if (j0 > 4) {
                                while (j < text.length && (this._isUpperChar(text[j]) || this._isDigit(text[j]))) {
                                    j++;
                                }

                                noCellReference = true;
                            }

                            while (j < text.length && this._isDigit(text[j])) {
                                j = j + 1;
                            }

                            if (j < text.length && text[j] == ':') {
                                //// handle range operands
                                j = j + 1;
                                if (j < text.length && text[j] == this.sheetToken) {
                                    j++;
                                    while (j < text.length && text[j] != this.sheetToken) {
                                        j = j + 1;
                                    }

                                    if (j < text.length && text[j] == this.sheetToken) {
                                        j++;
                                    }
                                }

                                while (j < text.length && this._isUpperChar(text[j])) {
                                    j = j + 1;
                                }

                                while (j < text.length && this._isDigit(text[j])) {
                                    j = j + 1;
                                }

                                j = j - 1;

                                right = this._substring(text, i + 1, j - i);
                                right = this._getCellFrom(right);
                            } else {
                                //// handle normal cell reference
                                j = j - 1;
                                right = this._substring(text, i + 1, j - i);
                                isU = text[j] == 'u';
                                if (isU) {
                                    right = 'u' + right;
                                }
                            }
                            if (!noCellReference) {
                                this.updateDependencies(right);
                            } else {
                                var scopedRange = "";
                                if (this.getNamedRanges().getItem(right) > -1) {
                                    //JS-47897 - To get the value from HashTable
                                    right = this._parse(this.getNamedRanges().getItem(right));
                                } else if (!isNaN(scopedRange = this._checkIfScopedRange(right, scopedRange))) {
                                    right = this._parse(scopedRange);
                                } else if (right == this.trueValueStr) {
                                    right = 'n' + this.trueValueStr;
                                } else if (right == this.falseValueStr) {
                                    right = 'n' + this.falseValueStr;
                                } else {
                                    if(this.getRethrowLibraryComputationExceptions())
                                        throw this.formulaErrorStrings[this._invalid_characters_following_an_operator];
                                    return this.getErrorStrings()[5].toString();
                                }
                            }

                            rightIndex = j + 1;
                        } else {
                            if(this.getRethrowLibraryComputationExceptions())
                                        throw this.formulaErrorStrings[this._invalid_characters_following_an_operator];
                                    return this.getErrorStrings()[5].toString();
                        }
                    }
                    var p = op.indexOf(text[i]);
                    var s = this.bMARKER + this._zapBlocks(left) + this._zapBlocks(right) + markers[p] + this.bMARKER;
                    if (leftIndex > 0) {
                        s = text.substring(0, leftIndex) + s;
                    }

                    if (rightIndex < text.length) {
                        s = s + text.substring(rightIndex);
                    }

                    s = s.split(this.bMARKER2).join(this.bMARKER.toString());

                    //// s = s.replace(tic+tic, tic); removed forum post http://64.78.18.34/Support/Forums/message.aspx?MessageID=22483
                    text = s;
                }
            } else {
                ////Process left argument.
                var j = text.length - 1;
                if (text[j] == this.bMARKER) {
                    var k = this._findLastNonQB(text.substring(0, j - 1));
                    if (k < 0) {
                        throw this.formulaErrorStrings[this._cannot_parse];
                    }
                } else if (text[j] == this._rightBracket) {
                    ////library member
                    var bracketCount = 0;
                    var k = j - 1;
                    while (k > 0 && (text[k] != 'q' || bracketCount != 0)) {
                        if (text[k] == 'q') {
                            bracketCount--;
                        } else if (text[k] == this._rightBracket) {
                            bracketCount++;
                        }

                        k--;
                    }

                    if (k < 0) {
                        throw this.formulaErrorStrings[this._bad_library];
                    }
                } else if (!this._isDigit(text[j])) {
                    // return "ERROR";
                } else {
                    var period = false;
                    var percent = false;

                    while (j > -1 && (this._isDigit(text[j]) || (!period && text[j] == this.getParseDecimalSeparator()) || (!percent && text[j] == '%'))) {
                        if (text[j] == this.getParseDecimalSeparator()) {
                            period = true;
                        } else if (text[j] == '%') {
                            percent = true;
                        }

                        j = j - 1;
                    }

                    if (j > -1 && period && text[j] == this.getParseDecimalSeparator()) {
                        throw this.formulaErrorStrings[this._number_contains_2_decimal_points];
                    }
                }
                if (text.length > 0 && (this._isUpperChar(text[0]) || text[0] == this.sheetToken)) {
                    ////Check if cell reference.
                    var ok = true;
                    var checkLetter = true;
                    var oneTokenFound = false;
                    for (var k = 0; k < text.length; ++k) {
                        if (text[k] == this.sheetToken) {
                            if (k > 0 && !oneTokenFound) {
                                throw this.formulaErrorStrings[this._missing_sheet];
                                ////break;
                            }

                            oneTokenFound = true;
                            k++;
                            while (k < text.length && this._isDigit(text[k])) {
                                k++;
                            }

                            if (k == text.length || text[k] != this.sheetToken) {
                                ok = false;
                                break;
                            }
                        } else {
                            ////if(!checkLetter && char.IsUpper(text, k))
                            if (!checkLetter && this._isLetter(text[k])) {
                                ok = false;
                                break;
                            }

                            if (this._isLetterOrDigit(text[k]) || text[k] == this.sheetToken) {
                                checkLetter = this._isUpperChar(text[k]);
                            } else {
                                ok = false;
                                break;
                            }
                        }
                    }

                    if (ok) {
                        this.updateDependencies(text); ////cb
                        //needToContinue = false;
                    }
                }
            }
            return text;
        };
        /**
         * 
		 * @private
        */
		this._pop = function (_stack) {
            var o = _stack.pop();

            var s;
            if (o != null) {
                if (o.toString() == this.tic + this.tic) {
                    return NaN;
                } else
                    s = o.toString().split(this.tic).join("");
                if (this.getErrorStrings().indexOf(s) > -1) {
                    this._isErrorString = true;
                    return this.getErrorStrings().indexOf(s);
                }

                ////moved from ComputedValue above as result of DT26064
                if (s[0] == "#" || s == "") {
                    return 0;
                }

                if (s == this.trueValueStr) {
                    return 1;
                } else if (s == this.falseValueStr) {
                    return 0;
                }

                var d = this._parseDouble(s);
                if (!isNaN(d)) {
                    return d;
                } else if (this.getUseDatesInCalculations() && isNaN(this._parseDouble(o))) {
                    var dt = this._isDate(s);
                    if (!isNaN(dt))
                        return this._getSerialDateTimeFromDate(dt);
                    else
                        return 0;
                }
            }
            if (s == ""  && this.getTreatStringsAsZero()) {
                return 0;
            }
            else if (o != null && o.toString().length > 0) {
                return Number.NaN;
            }
            return 0;
        };
        /**
         * 
		 * @private
        */
		this._popString = function (_stack) {
            var o = _stack.pop();
            var number = this._parseDouble(o);
            if (o == null) {
                o = "";
            } else if (!isNaN(number)) {
                return number.toString();
            } else if (this.getUseDatesInCalculations() && isNaN(this._parseDouble(o.split(this.tic).join("")))) {
                var dt = this._isDate(o.split(this.tic).join(""));
                if (!isNaN(dt))
                    return this._getSerialDateTimeFromDate(dt).toString();
            }

            return this.removeTics(o.toString());
        };
        /**
         * 
		 * @private
        */
		this._populateNamedRangesNonScoped = function () {
            if (this._namedRangesNonScoped == null) {
                this._namedRangesNonScoped = new HashTable();
            }
            this._namedRangesNonScoped.clear();

            for (var k = 0; k < this.namedRanges.keys().length; k++) {
                this._checkAddNonScopedNamedRange(this.namedRanges.keys()[k]);
            }
        };
        /**
         * 
		 * @private
        */
		this._processUpperCase = function (formula, i, sheet) {
            var s = "";
            while (i < formula.length && this._isUpperChar(formula[i])) {
                s = s + formula[i];
                i = i + 1;
            }

            while (i < formula.length && this._isDigit(formula[i])) {
                s = s + formula[i];
                i = i + 1;
            }
            var firstCell = s;
            var firstIndex = i;
            if (i < formula.length && formula[i] == ':') {
                s = "";
                i = i + 1;
                if (i < formula.length && formula[i] == this.sheetToken) {
                    s = s + formula[i];
                    i = i + 1;

                    while (i < formula.length && formula[i] != this.sheetToken) {
                        s = s + formula[i];
                        i = i + 1;
                    }
                }

                while (i < formula.length && this._isUpperChar(formula[i])) {
                    s = s + formula[i];
                    i = i + 1;
                }

                while (i < formula.length && this._isDigit(formula[i])) {
                    s = s + formula[i];
                    i = i + 1;
                }
            } if (this._supportRangeOperands && firstCell != s) {
                s = sheet + this._getCellFrom(firstCell + ':' + s);
            } else {
                i = (firstCell != s) ? firstIndex : i;
                s = sheet + firstCell;
            }
            sheet = "";
            this._processUpperCaseFormula = formula;
            this._processUpperCaseIvalue = i;
            this._processUpperCaseSheet = sheet;
            return s;
        };
        /**
         * 
		 * @private
        */
		this._saveStrings = function (text) {
            var strings = null;
            var TICs2 = this.tic + this.tic;
            var id = 0;
            var i = -1;
            if ((i = text.indexOf(this.tic)) > -1) {
                while (i > -1 && i < text.length) {
                    if (strings == null) {
                        strings = new HashTable();
                    }

                    var j = (i + 1) < text.length ? text.indexOf(this.tic, i + 1) : -1;
                    if (j > -1) {
                        var key = this.tic + this._uniqueStringMarker + id.toString() + this.tic;
                        if (j < text.length - 2 && text[j + 1] == this.tic[0]) {
                            j = text.indexOf(this.tic, j + 2);
                            if (j == -1) {
                                throw this.formulaErrorStrings[this._mismatched_tics];
                            }
                        }

                        var s = this._substring(text, i, j - i + 1);
                        strings.add(key, s);
                        s = s.split(TICs2).join(this.tic);
                        id++;
                        text = text.substring(0, i) + key + text.substring(j + 1);
                        i = i + key.length;
                        if (i < text.length) {
                            i = text.indexOf(this.tic, i);
                        }
                    } else if (j == -1 && text.indexOf(this.sheetToken) > -1 && i < text.indexOf(this.sheetToken, i)) {
                        var sheetName = "";
                        for (var k = (text.indexOf(this.sheetToken, i)) - 1; k > -1; k--) {
                            if (this.getValidPrecedingChars().indexOf(text[k].toString()) == -1)
                                sheetName = text[k] + sheetName;
                            else
                                break;
                        }
                        if (!(sheetName[0] == "'" && sheetName[sheetName.length - 1] == "'")) {
                            throw this.formulaErrorStrings[this._mismatched_tics];
                        }
                        if (sheetName[0] == "'")
                            sheetName = sheetName.substring(1);
                        if (sheetName[sheetName.length - 1] == "'")
                            sheetName = sheetName.substring(0, sheetName.length - 1);
                        if (this.getSortedSheetNames().indexOf(sheetName.toUpperCase()) == -1) {
                            throw this.formulaErrorStrings[this._missing_sheet];
                        }
                        if ((i + 1) < text.length) {
                            i = text.indexOf(this.tic, i + 1);
                        }
                    } else {
                        throw this.formulaErrorStrings[this._mismatched_tics];
                    }
                }
            }
            this._saveStringsText = text;
            return strings;
        };
        /**
         * 
		 * @private
        */
		this._setStrings = function (retValue, strings) {
            var keys = strings.keys();
            for (var s = 0; s < keys.length; s++) {
                retValue = retValue.split(keys[s]).join(strings.getItem(keys[s]));
            }
            return retValue;
        };
        /**
         * 
		 * @private
        */
		this._sheetToken = function (s) {
            var i = 0;
            var s1 = "";
            if (i < s.length && s[i] == this.sheetToken) {
                i++;
                while (i < s.length && s[i] != this.sheetToken) {
                    i++;
                }

                s1 = s.substring(0, i + 1);
            }

            if (i < s.length) {
                return s1;
            }

            throw this.formulaErrorStrings[this._bad_index];
        };
        /**
         * 
		 * @private
        */
		this._splitArguments = function (args, argSeperator) {
            return args.split(argSeperator);
        };
        /**
         * 
		 * @private
        */
		this._stripTics0 = function (s) {
            if (s.length > 1 && s[0] == this.tic[0] && s[s.length - 1] == this.tic[0]) {
                s = this._substring(s, 1, s.length - 2);
            }

            return s;
        };
        /**
         * 
		 * @private
        */
		this._substring = function (text, startIndex, length) {
            return text.substring(startIndex, length + startIndex);
        };
        /**
         * 
		 * @private
        */
		this._isTextEmpty = function (s) {
            return s == null || s == "";
        };
        /**
         * 
		 * @private
        */
		this._toOADate = function (dateTime) {
            var result = (dateTime.getTime() - Date.parse(this._oaDate)) / this._millisecondsOfaDay;
            return result;
        };
        /**
         * 
		 * @private
        */
		this._zapBlocks = function (text) {
            if (text.indexOf(this.bMARKER) > -1) {
                var bracketLevel = 0;
                for (var i = text.length - 1; i > 0; --i) {
                    if (text[i] == this._rightBracket) {
                        bracketLevel--;
                    } else if (text[i] == this._leftBracket) {
                        bracketLevel++;
                    } else if (text[i] == this.bMARKER && bracketLevel == 0) {
                        text = text.substring(0, i - 1) + text.substring(i + 1);
                    }
                }
            }

            return text;
        };
        
		
		/**		
        * Add the custom formuls with function in CalcEngine library 
        * @return boolean
        * @param {string} FormulaName pass the formula name 
        * @param {string} FunctionName pass the custom function name to call 
        * @example 
        * &lt;div id="Grid"&gt;&lt;/div&gt; 
        * &lt;script&gt;
        * // Create Grid
        * $('#Grid').ejGrid({
        *     dataSource: window.gridData
        * });         
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * var sheetID = calcObj.createSheetFamilyID();
        * calcObj.registerGridAsSheet("sheet1", $("#Grid").data("ejGrid"), sheetID);
        * calcObj.addCustomFunction("ADD", "customAdd");
        *    customAdd = function (argsList) {
        *    var splitArgs = argsList.split(calcObj.getParseArgumentSeparator())
        *       var result = 0;
        *       for (var i in splitArgs) {
        *           var s1 = calcObj.getValueFromArg(splitArgs[i]);
        *           result = Number(result) + Number(s1);
        *       }
        *       return result;
        *    }
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.addCustomFunction = function (name, func) {
            name = name.toUpperCase();
            this._addFunction(name, func);
            if (this._customlibraryFunctions.getItem(name) == undefined) {
                this._customlibraryFunctions.add(name,func);
                return true;
            }
            return false;
        };
        this.UpdateDependentNamedRangeCell = function (key) {
            if (this.getDependentNamedRangeCells()!=null && this.getDependentNamedRangeCells().containsKey(key)) {
                var ht = this.getDependentNamedRangeCells().keys();
                  if (ht != null && ht.length > 0) {
                    for (var s = 0; s<ht.length; s++) {
                        var cell1 = this.getDependentNamedRangeCells().getItem(ht[s]);
                        var i = cell1.indexOf(this.sheetToken);
                        var row, col;
                        var grd = this.grid;
                        if (i > -1) {
                            var family = CalcEngine.getSheetFamilyItem(this.grid);
                           
                            this.grid = family.tokenToParentObject.getItem(cell1.substring(0, i + 3));
                            row = this.rowIndex(cell1);
                            col = this.colIndex(cell1);
                        }
                        else {
                            row = this.rowIndex(cell1);
                            col = this.colIndex(cell1);
                        }
                        this.recalculateRange(RangeInfo.cells(row, col,row,col), this.grid);

                        this.grid = grd;
                    }
                }
            }
        }

        this.RemoveNamedRangeDependency = function (key) {
            if (this.getDependentNamedRangeCells().containsKey(key)) {
                var ht = (Hashtable)(this.getDependentNamedRangeCells()[key]);
                ht.Clear();
                this.getDependentNamedRangeCells().remove(key);
            }
        }
        this.SetNamedRangeDependency = function (key, cell1) {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family.sheetNameToParentObject != null && cell1.indexOf(this.sheetToken) == -1) {
                var token = family.GridModelToToken[this.grid];
                cell1 = token + cell1;
            }

            if (this.getDependentNamedRangeCells()!=null && this.getDependentNamedRangeCells().containsKey(key)) {
                var ht = this.getDependentNamedRangeCells()[key];
                if (!ht.containsKey(cell1)) {
                    ht.add(cell1, "0");
                }
            }
            else {
                var ht1 = new HashTable();
                ht1.add(cell1, "0");
                this.getDependentNamedRangeCells().add(key, cell1.toString());
            }
        }
        /**		
        * Adds a named range to the NamedRanges collection 
        * @return boolean
        * @param {string} Name pass the namedRange's name 
        * @param {string} cellRange pass the cell range of NamedRange
        * @example
        * &lt;div id="Grid"&gt;&lt;/div&gt; 
        * &lt;script&gt;
        * // Create Grid
        * $('#Grid').ejGrid({
        *     dataSource: window.gridData
        * });         
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * var sheetID = calcObj.createSheetFamilyID();
        * calcObj.registerGridAsSheet("sheet1", $("#Grid").data("ejGrid"), sheetID);
        * calcObj.addNamedRange("FIRSTCELL","A1");
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.addNamedRange = function (name, range) {
            name = name.toUpperCase();
            if (this.getNamedRanges().getItem(name) == null) {
                this.getNamedRanges().add(name, range);
                if (!this.getNameRangeValues().containsKey(name)) {
                    this.getNameRangeValues().add(name, range.toString());
                }
                if (this.getUndefinedNamedRanges().containsKey(name) || this.getUndefinedNamedRanges().containsKey(name.toUpperCase()) || this.getUndefinedNamedRanges().containsKey(name.toLowerCase())) {
                    this.SetNamedRangeDependency(name.toUpperCase(), this.cell);
                    this.UpdateDependentNamedRangeCell(name.toUpperCase());
                }
               this.namedRangesSized = null;
                this._checkAddNonScopedNamedRange(name);
                return true;
            }
            return false;
        };
        /**		
        * Accepts a possible parsed formula and returns the calculated value without quotes.
        * @return string
        * @param {string} Name pass the cell range to adjust its range
        * @example
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * var sheetID = calcObj.createSheetFamilyID();
        * calcObj.registerGridAsSheet("sheet1", $("#Grid").data("ejGrid"), sheetID);
        * calcObj.addNamedRange("FIRSTCELL","A1");
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.adjustRangeArg = function (range) {
            if (range.length > 1 && range[0] == this.bMARKER && range[range.length - 1] == this.bMARKER && this._substring(range, 1, range.length - 2).indexOf(this.bMARKER) == -1) {
                range = this.computedValue(range);
            }

            if (range.length > 1 && range[0] == this.tic[0] && range[range.length - 1] == this.tic[0]) {
                range = this._substring(range, 1, range.length - 2);
            }
            return range;
        };
        /**		
        * When a formula cell changes, call this method to clear it from its dependent cells.
        * @param {string} Cell pass the changed cell address
        * @example
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * calcObj.clearFormulaDependentCells("A1");
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.clearFormulaDependentCells = function (cell) {
            var ht = this.getDependentFormulaCells().getItem(cell);
            if (ht != null) {
                var keys = ht.keys();
                for (var o = 0; o < keys.length; o++) {
                    var s = keys[o];
                    var al = this.getDependentCells().getItem(s);
                    this._arrayRemove(al, cell);
                    if (al.length == 0) {
                        this.getDependentCells().remove(s);
                    }
                }

                this.getDependentFormulaCells().remove(cell);
            }
        };
        /**		
        *  Call this method to clear whether an exception was raised during the computation of a library function.
        * @example
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * calcObj.clearLibraryComputationException();
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.clearLibraryComputationException = function () {
            this._libraryComputationException = null;
        };
        /**		
        * Get the column index from a cell reference passed in.
        * @param {string} Cell pass the cell address
        * @example
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * calcObj.colIndex("A1");
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.colIndex = function (s) {
            var i = 0;
            var k = 0;
            s = s.toUpperCase();

            if (i < s.length && s[i] == this.sheetToken) {
                i++;
                while (i < s.length && s[i] != this.sheetToken) {
                    i++;
                }

                i++;
            }

            while (i < s.length && this._isLetter(s[i])) {
                var charCode = s[i].charCodeAt(0);
                k = k * 26 + charCode - 64;
                i++;
            }

            if (k == 0) {
                return -1;
            }

            return k;
        };
        /**		
        * Evaluates a parsed formula.
        * @return string
        * @param {string} Formula pass the parsed formula
        * @example
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * calcObj.computedValue("n10n2a");
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.computedValue = function (formula) {
            if (this._isTextEmpty(formula)) {
                return formula;
            }
            try  {
                this.computedValueLevel++;
                if (this.computedValueLevel > this._maximumRecursiveCalls) {
                    this.computedValueLevel = 0;
                    throw this.formulaErrorStrings[this._too_complex];
                }
                var _stack = [];

                var i = 0;
                _stack.length = 0;
                var sheet = "";
                if (this.getAllowShortCircuitIFs()) {
                    var loc = -1;
                    do {
                        ////code peels all only the outer most IF functions  and relies on a custom IF to handle the proper alternative
                        if (i < formula.length && (i = formula.indexOf(this.iFMarker, i)) > -1) {
                            loc = this._matchingRightBracket(formula.substring(i));
                            if (loc > -1) {
                                var result = "";
                                var nextIfLoc = formula.indexOf(this.iFMarker, loc);

                                do {
                                    loc = i;
                                    var sepLoc = this._findNextSeparator(formula, loc);
                                    if (!isNaN(sepLoc)) {
                                        loc = sepLoc;
                                    }
                                    var funcArgs = this._substring(formula, i + this.iFMarker.length, loc - this.iFMarker.length - 1);
                                    var ifArguments = [];
                                    var argLoc = 0;
                                    var argNo = 0;
                                    while (argLoc < funcArgs.length) {
                                        sepLoc = this._findNextSeparator(funcArgs, argLoc);
                                        if (!isNaN(sepLoc)) {
                                            argLoc = sepLoc;
                                            ifArguments.push(funcArgs.substring(0, argLoc));
                                            funcArgs = funcArgs.substring(Number(argLoc) + 1);
                                            argLoc = 0;
                                        }
                                        else if (argLoc > 0) {
                                            arguments.push(funcArgs.substring(0, argLoc));
                                        }
                                    }
                                    var ifResult = this.getValueFromArg(ifArguments[0]);
                                    if (ifResult == this.trueValueStr)
                                        result = this.getValueFromArg(ifArguments[1]);
                                    else
                                        result = this.getValueFromArg(ifArguments[2]);
                                    nextIfLoc = formula.indexOf(this.iFMarker, loc);
                                }
                                while (formula.indexOf(this.iFMarker) > -1 && nextIfLoc > -1);

                                result = this._markupResultToIncludeInFormula(result)
                                var rightPiece = "";
                                if (i + loc + 1 < formula.length)
                                    rightPiece = formula.substring(i + loc + 1);
                                formula = formula.substring(0, i) + result + rightPiece;
                            }
                        }
                    }
                    while (formula.indexOf(this.iFMarker) > -1 && loc > -1);
                }
                i = 0;
                while (i < formula.length) {
                    if (formula[i] == this.bMARKER) {
                        i = i + 1;
                        continue;
                    }

                    var uFound = formula[i] == 'u';
                    if (uFound) {
                        i++;
                        if (i >= formula.length) {
                            continue;
                        }

                        if (formula[i] == this.bMARKER) {
                            i++;
                        }

                        if (i >= formula.length) {
                            continue;
                        }
                    }

                    ////defect 8729
                    ////************
                    //// The % is the last thing in the cell contents here
                    if (formula[i] == '%' && _stack.length > 0) {
                        var o = _stack[0];
                        var d = this._parseDouble(o);
                        if (!isNaN(d)) {
                            _stack.pop(); ////remove it
                            _stack.push(Number(d) / 100); ////push it back
                        }
                        i = i + 1;
                        continue;
                    }
                    if (formula[i] == this.sheetToken) {
                        sheet = formula[i].toString();
                        i++;
                        while (i < formula.length && formula[i] != this.sheetToken) {
                            sheet += formula[i];
                            i++;
                        }

                        if (i < formula.length) {
                            sheet += formula[i];
                            i++;
                        } else {
                            continue;
                        }
                    }
                    if ((formula.substring(i)).indexOf(this.trueValueStr) == 0) {
                        _stack.push(this.trueValueStr);
                        i += this.trueValueStr.length;
                    } else if (formula.substring(i).indexOf(this.falseValueStr) == 0) {
                        _stack.push(this.falseValueStr);
                        i += this.falseValueStr.length;
                    } else if (formula[i] == this.tic[0] || formula[i] == '|') {
                        if (_stack.length == 3)
                            _stack = this._combineStack(formula, i - 2, _stack);

                        var s = formula[i].toString();
                        i++;
                        while (i < formula.length && formula[i] != this.tic[0]) {
                            s = s + formula[i];
                            i = i + 1;
                        }
                        if (this._multiTick) {
                            s = s.split("|").join(this.tic);
                        }
                        _stack.push(s + this.tic);
                        i += 1;
                    } else if (this._isUpperChar(formula[i])) {
                        ////cell loc
                        var s = this._processUpperCase(formula, i, sheet);
                        formula = this._processUpperCaseFormula;
                        i = this._processUpperCaseIvalue;
                        sheet = this._processUpperCaseSheet;
                        if (uFound) {
                            s = this.getValueFromParentObjectCell(s);
                            var d3;
                            if (!isNaN(this._parseDouble(s))) {
                                d3 = -d3;
                                _stack.push(d3.toString());
                            } else {
                                _stack.push(s);
                            }
                        } else {
                            if (this.getUseFormulaValues() && this.computedValueLevel > 50) {
                                if (this._breakedFormulaCells.indexOf(s) == -1 && this.getUseFormulaValues()) {
                                    var family = CalcEngine.getSheetFamilyItem(this.grid);
                                    var token = this.sheetToken + this.getSheetID(this.grid).toString() + this.sheetToken;
                                    s = token + s;
                                    this._breakedFormulaCells.add(s);
                                    this._tempBreakedFormulaCells.add(s);
                                    break;
                                }
                                _stack.push("FALSE");
                            } else
                                _stack.push(this.getValueFromParentObjectCell(s));
                        }
                    } else if (formula[i] == 'q') {
                        ////library
                        formula = this._computeInteriorFunctions(formula);

                        var ii = formula.substring(i + 1).indexOf(this._leftBracket);
                        if (ii > 0) {
                            var bracketCount = 0;
                            var bracketFound = false;
                            var start = ii + i + 2;
                            var k = start;
                            while (k < formula.length && (formula[k] != this._rightBracket || bracketCount > 0)) {
                                if (formula[k] == this._leftBracket) {
                                    bracketCount++;
                                    bracketFound = true;
                                } else if (formula[k] == this._leftBracket) {
                                    bracketCount--;
                                }

                                k++;
                            }

                            if (bracketFound) {
                                var s = this._substring(formula, start, k - start - 2);
                                var s1 = "";
                                var splits = this.splitArgsPreservingQuotedCommas(s);
                                for (var t = 0; t < splits.length; t++) {
                                    if (s1.length > 0) {
                                        s1 += ",";
                                    }

                                    var j = this._findLastqNotInBrackets(t);
                                    if (j > 0) {
                                        s1 += splits[t].substring(0, j) + this.computedValue(splits[t].substring(j));
                                    } else {
                                        s1 += this.computedValue(splits[t]);
                                    }
                                }

                                formula = formula.substring(0, start) + s1 + formula.substring(k - 2);
                            }

                            var name = this._substring(formula, i + 1, ii);
                            if (name == "AVG" && this._excelLikeComputations) {
                                throw this.formulaErrorStrings[this._bad_index];
                            }
                            if (this.getLibraryFunctions().getItem(name) != undefined) {
                                var j = formula.substring(i + ii + 1).indexOf(this._rightBracket);
                                var args = this._substring(formula, i + ii + 2, j - 1);
                                try  {
                                    var functionName = this.getLibraryFunctions().getItem(name);
                                    var result;
                                    if (this.getCustomLibraryFunctions().getItem(name) != undefined) {
                                        result = eval(functionName)(args);
                                    } else
                                        result = this[functionName](args);
                                    _stack.push(result);
                                } catch (ex) {
                                    if (this.getRethrowLibraryComputationExceptions()) {
                                        this._libraryComputationException = ex;
                                        throw ex;
                                    }

                                    return ex;
                                }

                                i += j + ii + 2;
                            } else {
                                if (this.getRethrowLibraryComputationExceptions()) {
                                    throw this.formulaErrorStrings[this._missing_formula];
                                    return this.getErrorStrings()[5].toString();
                                }

                            }
                        } else if (formula[0] == this.bMARKER) {
                            ////Restart the processing with the formula without library finctions.
                            i = 0;
                            _stack.length == 0;
                            continue;
                        } else {
                            throw this.formulaErrorStrings[this._improper_formula];
                        }
                    } else if (this._isDigit(formula[i]) || formula[i] == 'u') {
                        var s = "";
                        if (formula[i] == 'u' || uFound) {
                            s = "-";
                            if (!uFound) {
                                i++;
                            } else {
                                uFound = false;
                            }
                        }

                        if (i < formula.length && this._isUpperChar(formula[i])) {
                            s = s + this.getValueFromParentObjectCell(this._processUpperCase(formula, i, sheet));
                            formula = this._processUpperCaseFormula;
                            i = this._processUpperCaseIvalue;
                            sheet = this._processUpperCaseSheet;
                        } else {
                            while (i < formula.length && (this._isDigit(formula[i]) || formula[i] == this.getParseDecimalSeparator())) {
                                s = s + formula[i];
                                i = i + 1;
                            }
                        }

                        _stack.push(s);
                    } else {
                        switch (formula[i]) {
                            case '#': {
                                var errIndex = 0;
                                if (formula.indexOf('!') == -1) {
                                    errIndex = formula.indexOf('?') + 1;
                                } else
                                    errIndex = formula.indexOf('!') + 1;
                                _stack.push(this._substring(formula, i, errIndex - i));
                                i = errIndex;
                                break;
                            }

                            case 'n':
                                {
                                    i = i + 1;

                                    var s = "";
                                    if (formula.substring(i).indexOf("Infinity") == 0) {
                                        s = "Infinity";
                                        i += s.length;
                                    } else if (formula.substring(i).indexOf("uInfinity") == 0) {
                                        s = "Infinity";
                                        i += s.length + 1;
                                    } else if (formula.substring(i).indexOf(this.trueValueStr) == 0) {
                                        s = this.trueValueStr;
                                        i += s.length;
                                    } else if (formula.substring(i).indexOf(this.falseValueStr) == 0) {
                                        s = this.falseValueStr;
                                        i += s.length;
                                    } else if (i <= formula.length - 3 && formula.substring(i, 3) == "NaN") {
                                        i += 3;
                                        s = "0";
                                    } else {
                                        if (formula[i] == 'u' || uFound) {
                                            s = "-";
                                            if (!uFound) {
                                                i = i + 1;
                                            } else {
                                                uFound = false;
                                            }
                                        }

                                        while (i < formula.length && (this._isDigit(formula[i]) || formula[i] == this.getParseDecimalSeparator())) {
                                            s = s + formula[i];
                                            i = i + 1;
                                        }
                                        if (i < formula.length && formula[i] == '%') {
                                            i = i + 1;

                                            ////defect 8729
                                            ////**************
                                            if (s == "") {
                                                if (_stack.length > 0) {
                                                    var o = _stack[0];
                                                    var d = this._parseDouble(o.toString());
                                                    if (!isNaN(d)) {
                                                        _stack.pop(); ////remove it
                                                        s = (d / 100).toString(); ////push it back
                                                    }
                                                }
                                            } else {
                                                ////**************
                                                s = (Number(s) / 100).toString();
                                            }
                                        } else if (i < formula.length - 2 && formula[i] == 'E' && (formula[i + 1] == '+' || formula[i + 1] == '-')) {
                                            s += this._substring(formula, i, 4);
                                            i += 4;
                                        }
                                    }
                                    _stack.push(s);
                                }
                                break;
                            case this.token_add:
                                {
                                    var d = this._pop(_stack);
                                    var x = parseInt(d.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    var d1 = this._pop(_stack);
                                    x = parseInt(d1.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    if (isNaN(d) || isNaN(d1)) {
                                        _stack.push("#VALUE!");
                                    } else
                                        _stack.push((Number(d1) + Number(d)).toString());
                                    i = i + 1;
                                }

                                break;
                            case this.token_subtract:
                                {
                                    var d = this._pop(_stack);
                                    var x = parseInt(d.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    var d1 = this._pop(_stack);
                                    x = parseInt(d1.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    if (isNaN(d) || isNaN(d1)) {
                                        _stack.push("#VALUE!");
                                    } else {
                                        _stack.push((d1 - d).toString());
                                    }
                                    i = i + 1;
                                }

                                break;
                            case this.token_multiply:
                                {
                                    var d = this._pop(_stack);
                                    var x = parseInt(d.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    var d1 = this._pop(_stack);
                                    x = parseInt(d1.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    if (isNaN(d) || isNaN(d1)) {
                                        _stack.push("#VALUE!");
                                    } else {
                                        _stack.push((d1 * d).toString());
                                    }
                                    i = i + 1;
                                }

                                break;
                            case this.token_divide:
                                {
                                    var d = this._pop(_stack);
                                    var x = parseInt(d.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    var d1 = this._pop(_stack);
                                    x = parseInt(d1.toString());
                                    if (!isNaN(x) && this._isErrorString) {
                                        this._isErrorString = false;
                                        return this.getErrorStrings()[x].toString();
                                    }
                                    if (isNaN(d) || isNaN(d1)) {
                                        _stack.push("#VALUE!");
                                    } else if (d == 0) {
                                        _stack.push(this.getErrorStrings()[3]);
                                    } else {
                                        _stack.push((d1 / d).toString());
                                    }
                                    i = i + 1;
                                }

                                break;
                            case this.token_EP:
                                {
                                    var d = this._pop(_stack);
                                    var d1 = this._pop(_stack);
                                    _stack.push((d1 * Math.pow(10, d)).toString());
                                    i = i + 1;
                                }
                                break;
                            case this.token_EM:
                                {
                                    var d = this._pop(_stack);
                                    var d1 = this._pop(_stack);
                                    _stack.push((Number(d1) * Math.pow(10, -Number(d))).toString());
                                    i = i + 1;
                                }
                                break;
                            case this.token_less:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    //JS-30899-Return 0 when compare string.Empty value with a cell referenced value only if this cell reference value also string.Empty.
                                    //if (s1 == "" && this.getTreatStringsAsZero()) {
                                    //    s1 = "0";
                                    //}
                                    if (s2 == "" && this.getTreatStringsAsZero() && s1 != "") {
                                        s2 = "0";
                                    }
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (!isNaN(d) && !isNaN(d1)) {
                                        val = (d1 < d) ? this.trueValueStr : this.falseValueStr;
                                    } else {
                                        if (s1 == "#VALUE!" || s2 == "#VALUE!")
                                            val = "#VALUE!";
                                        else
                                            val = (s2.toUpperCase().split(this.tic).join("").localeCompare(s1.toUpperCase().split(this.tic).join("")) < 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_greater:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    //JS-30899-Return 0 when compare string.Empty value with a cell referenced value only if this cell reference value also string.Empty.
                                    //if (s1 == "") {
                                    //    if (this.getTreatStringsAsZero())
                                    //        s1 = "0";
                                    //    else
                                    //        s1 = s2 + 1;
                                    //}

                                    if (s2 == "" && s1 != "") {
                                        if (this.getTreatStringsAsZero())
                                            s2 = "0";
                                        else
                                            s2 = s1 + 1;
                                    }
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (!isNaN(d) && !isNaN(d1)) {
                                        val = (Number(d1) > Number(d)) ? this.trueValueStr : this.falseValueStr;
                                    } else {
                                        if (s1 == "#VALUE!" || s2 == "#VALUE!")
                                            val = "#VALUE!";
                                        else
                                            val = (s2.toUpperCase().split(this.tic).join("").localeCompare(s1.toUpperCase().split(this.tic).join("")) > 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_equal:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    //JS-30899-Return 0 when compare string.Empty value with a cell referenced value only if this cell reference value also string.Empty.
                                    //if (s1 == "" && this.getTreatStringsAsZero()) {
                                    //    s1 = "0";
                                    //}
                                    if (s2 == "" && this.getTreatStringsAsZero() && s1 != "") {
                                        s2 = "0";
                                    }
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (!isNaN(d) && !isNaN(d1)) {
                                        val = (Number(d1) == Number(d)) ? this.trueValueStr : this.falseValueStr;
                                    } else {
                                        if (s1 == "#VALUE!" || s2 == "#VALUE!")
                                            val = "#VALUE!";
                                        else
                                            val = (s1.toUpperCase().split(this.tic).join("") == s2.toUpperCase().split(this.tic).join("")) ? this.trueValueStr : this.falseValueStr;
                                    }
                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_lesseq:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    //JS-30899-Return 0 when compare string.Empty value with a cell referenced value only if this cell reference value also string.Empty.
                                    //if (s1 == "" && this.getTreatStringsAsZero()) {
                                    //    s1 = "0";
                                    //}
                                    if (s2 == "" && this.getTreatStringsAsZero() && s2 != "") {
                                        s2 = "0";
                                    }
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (!isNaN(d) && !isNaN(d1)) {
                                        val = (Number(d1) <= Number(d)) ? this.trueValueStr : this.falseValueStr;
                                    } else {
                                        if (s1 == "#VALUE!" || s2 == "#VALUE!")
                                            val = "#VALUE!";
                                        else
                                            val = (s1.toUpperCase().split(this.tic).join("").localeCompare(s2.toUpperCase().split(this.tic).join("")) <= 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_greatereq:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    //JS-30899-Return 0 when compare string.Empty value with a cell referenced value only if this cell reference value also string.Empty.
                                    //if (s1 == "" && this.getTreatStringsAsZero()) {
                                    //    s1 = "0";
                                    //}
                                    if (s2 == "" && this.getTreatStringsAsZero() && s1 != "") {
                                        s2 = "0";
                                    }
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (!isNaN(d) && !isNaN(d1)) {
                                        val = (Number(d1) >= Number(d)) ? this.trueValueStr : this.falseValueStr;
                                    } else {
                                        if (s1 == "#VALUE!" || s2 == "#VALUE!")
                                            val = "#VALUE!";
                                        else
                                            val = (s1.toUpperCase().split(this.tic).join("").localeCompare(s2.toUpperCase().split(this.tic).join("")) >= 0) ? this.trueValueStr : this.falseValueStr;
                                    }
                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_noequal:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    //JS-30899-Return 0 when compare string.Empty value with a cell referenced value only if this cell reference value also string.Empty.
                                    //if (s1 == "" && this.getTreatStringsAsZero()) {
                                    //    s1 = "0";
                                    //}
                                    if (s2 == "" && this.getTreatStringsAsZero() && s1 != "") {
                                        s2 = "0";
                                    }
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (!isNaN(d) && !isNaN(d1)) {
                                        val = (Number(d1) != Number(d)) ? this.trueValueStr : this.falseValueStr;
                                    } else {
                                        if (s1 == "#VALUE!" || s2 == "#VALUE!")
                                            val = "#VALUE!";
                                        else
                                            val = (s1.toUpperCase().split(this.tic).join("") != s2.toUpperCase().split(this.tic).join("")) ? this.trueValueStr : this.falseValueStr;
                                    }
                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_and:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = "";
                                    if (_stack.length > 0)
                                        s2 = this._popString(_stack);
                                    if (this.getUseNoAmpersandQuotes()) {
                                        _stack.push(s2 + s1);
                                    } else {
                                        _stack.push(this.tic + s2 + s1 + this.tic);
                                    }
                                    i = i + 1;
                                }
                                break;
                            case this.token_or:
                                {
                                    var d = this._pop(_stack);
                                    var d1 = this._pop(_stack);
                                    _stack.push(Math.pow(d1, d).toString());
                                    i = i + 1;
                                }
                                break;
                            case this.token_ORop:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (s1 == "") {
                                        s1 = this.falseValueStr;
                                    } else if (!isNaN(d)) {
                                        s1 = (Number(s1) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    if (s2 == "") {
                                        s2 = this.falseValueStr;
                                    } else if (!isNaN(d1)) {
                                        s2 = (Number(s2) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    val = (s1.toUpperCase().split(this.tic).join("") == this.trueValueStr || s2.toUpperCase().split(this.tic).join("") == this.trueValueStr) ? this.trueValueStr : this.falseValueStr;

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_ANDop:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (s1 == "") {
                                        s1 = this.falseValueStr;
                                    } else if (!isNaN(d)) {
                                        s1 = (Number(s1) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    if (s2 == "") {
                                        s2 = this.falseValueStr;
                                    } else if (!isNaN(d1)) {
                                        s2 = (Number(s2) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    val = (s1.toUpperCase().split(this.tic).join("") == this.trueValueStr && s2.toUpperCase().split(this.tic).join("") == this.trueValueStr) ? this.trueValueStr : this.falseValueStr;

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_XORop:
                                {
                                    var s1 = this._popString(_stack);
                                    var s2 = this._popString(_stack);
                                    var d = this._parseDouble(s1);
                                    var d1 = this._parseDouble(s2);
                                    var val;
                                    if (s1 == "") {
                                        s1 = this.falseValueStr;
                                    } else if (!isNaN(d)) {
                                        s1 = (Number(s1) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    if (s2 == "") {
                                        s2 = this.falseValueStr;
                                    } else if (!isNaN(d1)) {
                                        s2 = (Number(s2) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    val = ((s1.toUpperCase().split(this.tic).join("") == this.trueValueStr && s2.toUpperCase().split(this.tic).join("") != this.trueValueStr) || (s2.toUpperCase().split(this.tic).join("") == this.trueValueStr && s1.toUpperCase().split(this.tic).join("") != this.trueValueStr)) ? this.trueValueStr : this.falseValueStr;

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            case this.token_NOTop:
                                {
                                    var s1 = this._popString(_stack);
                                    var d = this._parseDouble(s1);
                                    var val;
                                    if (s1 == "") {
                                        s1 = this.falseValueStr;
                                    } else if (!isNaN(d)) {
                                        s1 = (Number(s1) != 0) ? this.trueValueStr : this.falseValueStr;
                                    }

                                    val = (s1.toUpperCase().split(this.tic).join("") == this.falseValueStr) ? this.trueValueStr : this.falseValueStr;

                                    _stack.push(val);
                                    i = i + 1;
                                }
                                break;
                            default: {
                                this.computedValueLevel = 0;
                                if(this.getRethrowLibraryComputationExceptions())
                                    throw this.formulaErrorStrings[this._invalid_expression];
								else
                                    return this.getErrorStrings()[1].toString();
                            }
                        }
                    }
                }
                if (this._checkDanglingStack && _stack.length > 1 && formula.length > 1 && (formula.indexOf(this.bmarker.toString()) != 0 || formula.indexOf(this.bmarker) != (formula.length - 1) || formula.indexOf(this.bmarker2) > -1)) {
                    this.computedValueLevel = 0;
                    return this.formulaErrorStrings[this._improper_formula];
                }

                if (_stack.length == 0) {
                    return "";
                } else {
                    var s = "";
                    var d;
                    var cc = _stack.length;
                    do {
                        s = _stack.pop().toString() + s;
                        //JS-30899-Below code has been returns "0" when the formula value is CellReference and S value is String.Empty
                        if (s == "" && !this.getUseNoAmpersandQuotes() && this._isCellReference(formula) && this.getTreatStringsAsZero())
                            return "0";
                        return s;
                        cc--;
                    } while(cc > 0 && !(s.indexOf(this.FALSEVALUESTR) > -1 || s.indexOf(this.tRUEVALUESTR) > 1));

                    ////This check moved below in Pop as result of DT26064
                    ////if(_textIsEmpty(s))
                    ////    s = "0"; //Empty is zero in calculations.
                    return s;
                }
            } catch (ex) {
                this.computedValueLevel = 0;
                if (ex.toString().indexOf(this.formulaErrorStrings[this._circular_reference_]) > -1 || (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null)) {
                    if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                        throw this.getLibraryComputationException();
                    }

                    throw ex;
                }

                if (ex.toString().indexOf(this.formulaErrorStrings[this._cell_empty]) > -1) {
                    return "";
                } else {
                    if (this.getRethrowLibraryComputationExceptions()) {
                        this._libraryComputationException = ex;
                        throw ex;
                    }
                    return ex;
                }
            } finally {
                this.computedValueLevel--;
                if (this.computedValueLevel < 0) {
                    this.computedValueLevel = 0;
                }
            }
        };
        /**		
        * Evaluates a parsed formula.
        * @return string
        * @param {string} Formula pass the parsed formula
        * @example
        * var calcObj = new CalcEngine($("#Grid").data("ejGrid"));
        * calcObj.computedValue("n10n2a");
        * &lt;/script&gt;
		* @memberof ejCalculate
		* @instance
        */
        this.computeFormula = function (parsedFormula) {
            if (this.getThrowCircularException()) {
                if (this._iterationMaxCount > 0) {
                    if (this.computedValueLevel == 0) {
                        this._circCheckList.length = 0;
                        this._circCheckList.push(this.cell);
                    } else if (this._circCheckList.indexOf(this.cell) > -1) {
                        if (!this.getIterationValues().containsKey(this.cell)) {
                            this.getIterationValues().add(this.cell, "0");
                        }

                        return this.getIterationValues().getItem(this.cell).toString();
                    }
                } else {
                    if (this.computedValueLevel == 0) {
                        this._circCheckList.length = 0;
                    } else if (this._circCheckList.indexOf(this.cell) > -1) {
                        this.computedValueLevel = 0;
                        this._circCheckList.length = 0;
                        throw this.formulaErrorStrings[this._circular_reference_];
                    }

                    this._circCheckList.push(this.cell);
                }
            }

            var s = this.computedValue(parsedFormula);

            if (this.getUseNoAmpersandQuotes() && s.length > 1 && s[0] == this.tic[0] && s[s.length - 1] == this.tic[0]) {
                s = this._substring(s, 1, s.length - 2);
            }
            return s;
        };
        
        this.dispose = function () {
            if (!this._isDisposed) {
                var i = 0;
                if (this.grid != null) {
                    i = this.getSheetID(this.grid);
                }
                CalcEngine._tokenCount--;
                CalcEngine.sheetFamilyID--;
                if (CalcEngine._sheetFamiliesList != null && CalcEngine._sheetFamiliesList.length > 0) {
                    CalcEngine._sheetFamiliesList[i] = null;
                    CalcEngine._sheetFamiliesList.remove(i);
                }
                if (CalcEngine.modelToSheetID != null && CalcEngine.modelToSheetID.length > 0) {
                    CalcEngine.modelToSheetID[i] = null;
                    CalcEngine._sheetFamiliesList.remove(i);
                }
                if (this._formulaInfoTable != null) {
                    this._formulaInfoTable.clear();
                    this._formulaInfoTable = null;
                }
                if (this._circCheckList != null) {
                    this._circCheckList.length = 0;
                    this._circCheckList = null;
                }
                if (this._dependentCells != null) {
                    this._dependentCells.clear();
                    this._dependentCells = null;
                }
                if (this._dependentFormulaCells != null) {
                    this._dependentFormulaCells.clear();
                    this._dependentFormulaCells = null;
                }

                if (this.getIterationValues() != null) {
                    this.getIterationValues().clear();
                    this.getIterationValues(null);
                }
                if (this._libraryFunctions != null) {
                    this._libraryFunctions.clear();
                    this._libraryFunctions = null;
                }
                if (this._lookupTables != null) {
                    this._lookupTables.clear();
                    this._lookupTables = null;
                }
                this.grid = null;
                if (this.getLibraryFunctions() != null) {
                    this.getLibraryFunctions().clear();
                    this.setLibraryFunctions(null);
                }
                this._isDisposed = true;
            }
        };
        this.getCalcID = function () {
            return this._calcID;
        };

        this._getCellFrom = function (range)
        {
            var cellRange = "";
            var cells = this.getCellsFromArgs(range);
            var last = cells.length - 1;
            var r1 = this.rowIndex(cells[0]);
            var x;
            if (r1 == this.rowIndex(cells[last]))
            {
                var c1 = this.colIndex(cells[0]);
                var c2 = this.colIndex(cells[last]);
                var c = this.colIndex(this.cell);
                if (c >= c1 && c <= c2)
                {
                    cellRange = RangeInfo.getAlphaLabel(c).toString() + r1.toString();
                }
            }
            else if ((x = this.colIndex(cells[0])) == this.colIndex(cells[last]))
            {
                var r2 = this.rowIndex(cells[last]);
                var r = this.rowIndex(this.cell);
                if (r >= r1 && r <= r2)
                {
                    cellRange = RangeInfo.getAlphaLabel(x).toString() + r.toString();
                }
            }

            return cellRange;
        };

        this.getCellsFromArgs = function (args) {
            args = this._markColonsInQuotes(args);

            var row1;
            var col1;

            var i = args.indexOf(':');
            if (i == -1) {
                args = args.split(this._markerChar).join(':');
                i = args.indexOf(this.getParseArgumentSeparator());
                if (i == -1) {
                    row1 = this.rowIndex(args); ////maybe throw exception
                    col1 = this.colIndex(args); ////maybe throw exception
                    var argsArray = [];
                    argsArray.push(args);
                    return argsArray;
                } else {
                    return this.splitArgsPreservingQuotedCommas(args);
                }
            }

            this.getRowIndexFromName = function (str) {
                if (str.indexOf(":") != -1) {
                    return;
                }
                var count = "";
                for (var i = 0; i < str.length; i++) {
                    if (this._isDigit(str[i]))
                        count += str[i];
                }
                return count;
            }

            var sheet = "";
            var argsRet = args;
            var j = args.indexOf(this.sheetToken);
            if (j > -1) {
                var j1 = args.indexOf(this.sheetToken, j + 1);
                if (j1 > -1) {
                    sheet = this._substring(args, j, j1 - j + 1);
                    args = args.split(sheet).join("");
                    i = args.indexOf(':');
                }
            }

            ////check if column only range
            if (i > 0 && this._isLetter(args[i - 1])) {
                var count = (this._rowMaxCount > 0) ? this._rowMaxCount : 50;
                args = args.substring(0, i) + "1:" + args.substring(i + 1) + count.toString();
                i = args.indexOf(':');
            } else if (i > 0 && this._isDigit(args[i - 1])) {
                var k1 = i - 2;
                while (k1 >= 0 && this._isDigit(args[k1])) {
                    k1--;
                }

                if (k1 == -1 || !this._isLetter(args[k1])) {
                    var count = (this._columnMaxCount > 0) ? this._columnMaxCount : 50;
                    args = "A" + args.substring(0, i) + ":" + RangeInfo.getAlphaLabel(count) + args.substring(i + 1);
                    i = args.indexOf(':');
                }
            }

            // Check Whether rowindex can get from the arguments
            var isDigit = this._canGetRowIndex(args.substring(0, i));
            if (!isDigit) {
                // if unable to get index return the arguments
                this._ignoreCellValue = true;
                args = argsRet;
                return this.splitArgsPreservingQuotedCommas(args);
            }
            row1 = this.rowIndex(args.substring(0, i));
            var row2 = this.rowIndex(this._substring(args, i + 1, args.length - i - 1));
            var errorStr;
            if ((!(!(row1 == -1) || (row2 == -1)) == (((row1 == -1) || !(row2 == -1))))) {
                throw this.getErrorStrings()[5].toString();
                // errorStr[0] = this.getErrorStrings()[5].toString();
                // return errorStr;
            }

            col1 = this.colIndex(args.substring(0, i));

            var col2 = this.colIndex(this._substring(args, i + 1, args.length - i - 1));

            if (row1 > row2) {
                i = row2;
                row2 = row1;
                row1 = i;
            }

            if (col1 > col2) {
                i = col2;
                col2 = col1;
                col1 = i;
            }

            var numCells = (row2 - row1 + 1) * (col2 - col1 + 1);
            var cells = [];
            var k = 0;
            for (i = row1; i <= row2; ++i) {
                for (j = col1; j <= col2; ++j) {
                    try  {
                        cells[k++] = sheet + RangeInfo.getAlphaLabel(j) + i.toString();
                    } catch (ex) {
                        continue;
                    }
                }
            }
            return cells;
        };
        this.getFormulaRowCol = function (grd, row, col) {
            var family = CalcEngine.getSheetFamilyItem(grd);
            var s = RangeInfo.getAlphaLabel(col) + row.toString();
            if (family.sheetNameToParentObject != null) {
                var token = family.parentObjectToToken.getItem(grd);
                s = token + s;
            }

            if (this.getFormulaInfoTable().containsKey(s)) {
                var formula = this.getFormulaInfoTable.getItem(s);
                var value = formula.getFormulaText();
                this.getFormulaText(value);
                return value;
            }

            return "";
        };
        this.getFormulaText = function (s) {
            var e = new FormulaParsing(s);
            s = e.getText();
            return s;
        };
        this.getSheetID = function (grd) {
            var family = CalcEngine.getSheetFamilyItem(grd);
            if (family.sheetNameToParentObject != null && family.sheetNameToParentObject.length > 0) {
                var token = family.parentObjectToToken.getItem(grd);
                token = token.split("!").join("");
                var d = this._parseDouble(token);
                if (!isNaN(d)) {
                    return d;
                }
            }

            return -1;
        };
        this.getStringArray = function (s) {
            //ArrayList argList = new ArrayList();
            var argList = [];
            var argStart = 0;
            var inQuote = false;
            for (var argEnd = 0; argEnd < s.length; argEnd++) {
                var ch = s[argEnd];
                if (ch == this.tic[0]) {
                    inQuote = !inQuote;
                } else if (!inQuote && ch == this.getParseArgumentSeparator()) {
                    argList.push(this._substring(s, argStart, argEnd - argStart));
                    argStart = argEnd + 1;
                }
            }

            argList.push(s.substring(argStart));
            return argList;
        };
        this.getValueFromArg = function (arg) {
            var d;
            var tempDate = this._dateTime1900;

            ////handle special characters - probably need to revise...
            ////if(arg.IndexOf("%") > -1)
            ////	Console.WriteLine("special");
            ////arg = arg//.replace(TRUEVALUESTR, TRUEVALUE.toString())
            ////		//.replace(FALSEVALUESTR, FALSEVALUE.toString())
            ////		.replace("%", "");

            if (!isNaN(arg))
                arg = arg.toString();

            if (this._isTextEmpty(arg)) {
                return arg;
            } else if (arg[0] == this.tic[0]) {
                ////string
                var doubleValue;
                tempDate = this._isDate(arg.split(this.tic).join(""));
                if (this.getExcelLikeComputations() && this.getUseDatesInCalculations() && isNaN(this._parseDouble(arg.split(this.tic).join(""))) && !isNaN(tempDate) && !isNaN(tempDate.getDate()) && this._dateTime1900 <= tempDate) {
                    return this._toOADate(tempDate).toString();
                }
                return arg;
            } else if (arg[0] == this.bMARKER || arg[0] == 'q') {
                ////parsed formula
                arg = arg.split('{').join('(');
                arg = arg.split('}').join(')');
                return this.computedValue(arg);
            } else if (arg.length > 1 && arg.substring(0, 2) == "ub") {
                ////parsed formula
                arg = arg.split('{').join('(');
                arg = arg.split('}').join(')');
                var ggg = arg.substring(1);
                ggg = this.computedValue(ggg);
                var d2 = this._parseDouble(ggg);
                if (!isNaN(d2)) {
                    d2 = -d2;
                    return d2.toString();
                }
                return this.computedValue(arg);
            } else {
                if (arg.indexOf("unu") == 0) {
                    arg = "n" + arg.substring(3);
                } else if (arg.indexOf("un") == 0) {
                    arg = "-" + arg.substring(2);
                }

                arg = arg.split('u').join('-');
                if (!this._isUpperChar(arg[0]) && (this._isDigit(arg[0]) || arg[0] == this.getParseDecimalSeparator() || arg[0] == '-' || arg[0] == 'n')) {
                    if (arg[0] == 'n') {
                        arg = arg.substring(1);
                    }

                    d = this._parseDouble(arg);
                    if (!isNaN(d)) {
                        return this._preserveLeadingZeros ? arg : d.toString();
                    } else if (arg.indexOf(this.trueValueStr) == 0 || arg.indexOf(this.falseValueStr) == 0) {
                        return arg;
                    }
                }
            }
            if (this._ignoreCellValue && !(arg.indexOf(this.trueValueStr) == 0 || arg.indexOf(this.falseValueStr) == 0)) {
                this._ignoreCellValue = false;
                return arg;
            }

            var symbolArray = ['+', '-', '/', '*', ')', ')', '{'];

            ////Not a number.
            if ((this._indexOfAny(arg, symbolArray) == -1 && this._isUpperChar(arg[0])) || arg[0] == this.sheetToken) {

                if (((arg != this.trueValueStr && arg != this.falseValueStr)) && this._isCellReference(arg)) {
                    var family = CalcEngine.getSheetFamilyItem(this.grid);
                    if (family.sheetNameToParentObject != null && arg.indexOf(this.sheetToken) == -1) {
                        var token = family.parentObjectToToken.getItem(this.grid);
                        arg = token + arg;
                    }
                }
                ////Check for circular reference.
                if (arg == this.cell) {
                    var ht = this.getDependentCells().getItem(arg);
                    if (ht != null && ht.indexOf(arg) > -1) {
                        this._arrayRemove(ht, arg);
                    }
                    if (!this.getDependentFormulaCells().containsKey(this.cell))
                        this.clearFormulaDependentCells(this.cell);
                    throw this.formulaErrorStrings[this._circular_reference_] + arg;
                }

                var s1 = this.getValueFromParentObjectCell(arg);
                tempDate = this._isDate(s1);
                s1 = s1.toString();
                if (arg != this.trueValueStr && arg != this.falseValueStr) {
                    d = this._parseDouble(s1.split(this.tic).join(""));
                    if (!this._preserveLeadingZeros && s1.length > 0 && !isNaN(d)) {
                        s1 = d.toString();
                    }

                    this.updateDependencies(arg);
                }
                if (s1 == this.tic + this.tic) {
                    return "NaN";
                }
                var doubleValue;
                if (this.getExcelLikeComputations() && this.getUseDatesInCalculations() && !isNaN(tempDate) && isNaN(this._parseDouble(s1)) && !isNaN(tempDate.getDate()) && this._dateTime1900 <= tempDate) {
                    s1 = this._toOADate(tempDate).toString();
                }
                return s1;
            }

            ////Must be a formula, so try to parse it and compute.
            arg = arg.split('{').join('(');
            arg = arg.split('}').join(')');
            arg = this._parse(arg);

            d = this._parseDouble(arg.substring(0, arg.length - 1));
            if (arg.indexOf("%") == (arg.length - 1) && !isNaN(d)) {
                arg = (Number(d) / 100).toString();
            }
            if (this.getErrorStrings().indexOf(arg) > -1) {
                return arg;
            }

            return this.computedValue(arg);
        };
        this.getValueFromParentObjectCell = function (cell1) {
            if (cell1 == this.trueValueStr || cell1 == this.falseValueStr) {
                return cell1;
            }

            var i = cell1.lastIndexOf(this.sheetToken);
            var row = 0, col = 0;
            var grd = this.grid;
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (i > -1 && family.tokenToParentObject != null) {
                this.grid = family.tokenToParentObject.getItem(cell1.substring(0, i + 1));
                row = this.rowIndex(cell1);
                col = this.colIndex(cell1);
            } else if (i == -1) {
                var j = 0;
                while (j < cell1.length && this._isLetter(cell1[j])) {
                    j++;
                }
                if (j == cell1.length) {
                    cell1 = cell1.toLowerCase();
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_formula];
                    return this.getErrorStrings()[5].toString();
                } else {
                    row = this.rowIndex(cell1);
                    col = this.colIndex(cell1);
                    if (this.isSheetMember() && family.parentObjectToToken != null) {
                        cell1 = family.parentObjectToToken.getItem(this.grid) + cell1;
                    }
                }
            }

            var saveCell = (this.cell == "" || this.cell == null) ? "" : this.cell;
            this.cell = cell1;

            if (this._iterationMaxCount > 0) {
                if (this._circCheckList.indexOf(this.cell) > -1 && this.computedValueLevel > 0) {
                    this.grid = grd;
                    this.cell = saveCell;

                    if (!this.getIterationValues().containsKey(this.cell)) {
                        this.getIterationValues().add(this.cell, "0");
                    }

                    return this.getIterationValues().getItem(this.cell).toString();
                } else if (this.getIterationValues().containsKey(this.cell) && this.computedValueLevel > 0) {
                    return this.getIterationValues.getItem(this.cell).toString();
                }
            }

            var val = this._getValueComputeFormulaIfNecessary(row, col, this.grid);

            this.grid = grd;
            this.cell = saveCell;
            return val;
        };
        this.getValueFromParentObject = function (grd, row, col) {
            var family = CalcEngine.getSheetFamilyItem(grd);
            var cell1 = (family.parentObjectToToken == null || family.parentObjectToToken.length == 0) ? "" : family.parentObjectToToken.getItem(grd).toString();
            cell1 = cell1 + RangeInfo.getAlphaLabel(col) + row.toString();

            var saveGrid = this.grid;
            var saveCell = this.cell;
            this.cell = cell1;
            this.grid = grd;

            var val = this._getValueComputeFormulaIfNecessary(row, col, grd);
            var tempDate = new Date(Date.parse(val));
            var doubleValue = this._parseDouble(val);
            if (this.getExcelLikeComputations() && this.getUseDatesInCalculations() && isNaN(doubleValue) && !isNaN(tempDate.getDate()) && this._dateTime1900 <= tempDate) {
                val = this._toOADate(tempDate).toString();
            }
            this.grid = saveGrid;
            this.cell = saveCell;
            return val;
        };
        this.getValueFromParentObjectRowCol = function (row, col) {
            return this._getValueComputeFormulaIfNecessary(row, col, this.grid);
        }

        this.handleIteration = function (s, formula) {
            if (this.getFormulaInfoTable().containsKey(s)) {
                this.getFormulaInfoTable.add(s, formula);
            } else {
                this.getFormulaInfoTable.add(s, formula);
            }
            if (this._iterationMaxCount > 0) {
                if (s == this.cell) {
                    this._handleIterations(formula);
                }
            }
            return formula.getFormulaValue();
        };
        this.handleSheetRanges = function (text, family) {
            var sheetLoc = text.indexOf(this.sheetToken);
            var start = 0;
            while (sheetLoc > 0) {
                var colonLoc = this._substring(text, start, sheetLoc).lastIndexOf(':');
                if (colonLoc > -1) {
                    var rightSide = this._substring(text, start + colonLoc + 1, sheetLoc - colonLoc - 1).toUpperCase().split("'").join("");
                    var trimStr = (this._isIE8) ? rightSide.replace(/^\s+|\s+$/g, '') : rightSide.trim();
                    if (family.sheetNameToToken.containsKey(trimStr)) {
                        var leftStart = start + colonLoc - 1;
                        if (this._sortedSheetNames.contains(rightSide)) {
                            leftStart = leftStart - rightSide.length - 1;
                        } else {
                            while (leftStart > 0 && this._markers.indexOf(text[leftStart]) == -1) {
                                leftStart--;
                            }
                        }

                        var leftSide = this._substring(text, leftStart + 1, colonLoc - leftStart + start - 1).toUpperCase().split("'").join("");
                        trimStr = (this._isIE8) ? leftSide.replace(/^\s+|\s+$/g, '') : leftSide.trim();
                        if (family.sheetNameToToken.containsKey(trimStr)) {
                            var rightEnd = sheetLoc + start + 1;
                            if (this._sortedSheetNames.contains(trimStr)) {
                                rightEnd = text.length - 1;
                            } else {
                                while (rightEnd < text.length && this._markers.indexOf(text[rightEnd]) == -1) {
                                    rightEnd++;
                                }
                            }

                            var otherSide = this._substring(text, start + sheetLoc + 1, rightEnd - start - sheetLoc - 1);
                            var left = family.sheetNameToToken.getItem(trimStr).toString();
                            var right = family.sheetNameToToken.getItem(trimStr).toString();

                            ////make sure they are ordered properly
                            if (right < left) {
                                var s = left;
                                left = right;
                                right = s;
                            }

                            var replacement = "";

                            for (var name = 0; name < _sortedSheetNames.length; name++) {
                                var s = family.sheetNameToToken.getItem(this._sortedSheetNames[name]).toString();
                                var sint = parseInt(s.split("!").join(""));
                                var leftint = parseInt(left.split("!").join(""));
                                var rightint = parseInt(right.split("!").join(""));
                                if (sint > leftint && sint < rightint) {
                                    if (replacement.length > 0) {
                                        replacement += this.getParseArgumentSeparator();
                                    }

                                    replacement += name + String.fromCharCode(131) + otherSide;
                                }
                            }

                            text = text.substring(0, leftStart + 1) + replacement + text.substring(rightEnd);
                            start = text.length - rightEnd;
                        } else {
                            start = sheetLoc + start;
                        }
                    } else {
                        start = sheetLoc + start;
                    }
                } else {
                    start = sheetLoc + start;
                }

                sheetLoc = text.substring(start + 1).indexOf(this.sheetToken) + 1;
            }

            text = text.split(String.fromCharCode(131)).join(this.sheetToken);
            return text;
        };
        this.isSheetMember = function () {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            return (family == null || family == undefined) ? false : family.isSheetMember;
        };
        this.parseAndComputeFormula = function (formulaString) {
            var formula = formulaString;
            if (formula.length > 0 && formula[0] == this.getFormulaCharacter()) {
                formula = formula.substring(1);
            }

            if (formula.length > 0 && formula[0] == '+') {
                formula = formula.substring(1);
            }
            if (formula.length > 1 && formula[0] == ',') {
                if (formula[1] >= '0' && formula[1] <= '9')
                    formula = "0" + ',' + formula.substring(1);
            }
            var tempFormula = formula.split(" ").join("");

            for (var i = tempFormula.indexOf("("); i != -1 && i < tempFormula.length; i++) {
                if (i > 0) {
                    if (this._isDigit(tempFormula[i - 1])) {
                        if (!this._checkHasCharBeforeNumber(tempFormula.substring(0, i)))
                            throw (this.formulaErrorStrings[this._bad_formula] + " " + tempFormula.substring(0, i + 1));
                    }
                    var next = tempFormula.substring(i + 1).indexOf('(');
                    if (next == -1) {
                        break;
                    } else {
                        i += next;
                    }
                }
            }
            for (var i = tempFormula.indexOf(")"); i != -1 && i < tempFormula.length - 1; i++) {
                if (this._isDigit(tempFormula[i + 1])) {
                    throw (this.formulaErrorStrings[this._bad_formula] + " " + tempFormula.substring(0, i + 2));
                }
                var next = tempFormula.substring(i + 1).indexOf(')');
                if (next == -1) {
                    break;
                } else {
                    i += next;
                }
            }
            this._multiTick = false;

            var s = this._parse(formula);
            return this.computedValue(s);
        };
        this.parseFormula = function (formula) {
            if (formula.length > 0 && formula[0] == this.getFormulaCharacter()) {
                formula = formula.substring(1);
            }

            if (formula.length > 0 && formula[0] == '+') {
                formula = formula.substring(1);
            }

            this._isRangeOperand = this._supportRangeOperands && this._isRange(formula);
            if (this.getCheckDanglingStack() && (formula.split(" ").join("")).indexOf(this._braceRightNLeft) > -1) {
                this.computedValueLevel = 0;
                return this.formulaErrorStrings[this._improper_formula];
            }
            var trimStr = (this._isIE8) ? formula.replace(/^\s+|\s+$/g, '') : formula.trim();
            return this._parse(trimStr);
        };
        this.getUpdatedValueCell = function (cellRef) {
            var isUseFormulaValueChanged = false;
            this._inAPull = true;
            var grd = this.grid;
            var saveCell = this.cell;
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            var s = cellRef.toUpperCase();
            var i;
            if ((i = s.indexOf(this.sheetToken)) == -1 && this.cell != "" && this.cell != undefined) {
                i = this.cell.indexOf(this.sheetToken, 1);
                if (i > -1 && family.tokenToParentObject != null) {
                    s = this.cell.substring(0, i + 1) + s;
                    this.grid = family.tokenToParentObject.getItem(this.cell.substring(0, i + 1));
                }
            } else {
                if (i > 0 && family.sheetNameToToken != null && family.tokenToParentObject != null) {
                    ////need sheet id
                    var token = family.sheetNameToToken.getItem(s.substring(0, i));
                    s = token + s.substring(i + 1);
                    this.grid = family.tokenToParentObject.getItem(token);
                    this.cell = s;
                }
            }

            this.updateCalcID();
            var txt;
            if (!this.getDependentFormulaCells().containsKey(s) && !this.getFormulaInfoTable().containsKey(s)) {
                txt = this.getValueFromParentObjectCell(s);
                while (this._breakedFormulaCells.length == 1) {
                    this.updateCalcID();
                    txt = this.getValueFromParentObjectCell(this._breakedFormulaCells[0].toString());
                    this._breakedFormulaCells.removeAt(0);
                    this.setUseFormulaValues(true);
                }
                if (this.getUseFormulaValues()) {
                    this.isUseFormulaValueChanged = true;
                    this.setUseFormulaValue(false);
                }
                if (this._tempBreakedFormulaCells.length > 0) {
                    for (var p = 1; p <= this._tempBreakedFormulaCells.length; p++) {
                        txt = this.getValueFromParentObjectCell(this._tempBreakedFormulaCells[this._tempBreakedFormulaCells.length - p].toString());
                    }
                    this._tempBreakedFormulaCells.length = 0;
                    txt = this.getValueFromParentObjectCell(s);
                }
                this.setUseFormulaValues(this.isUseFormulaValueChanged);
                var saveIVC = this.ignoreValueChanged;
                this.ignoreValueChanged = true;
                var row = this.rowIndex(s);

                var col = this.colIndex(s);
                if (this.getPreserveFormula()) {
                    var token = this._sheetToken(cellRef);
                    if (token == "") {
                        token = "!" + this.getSheetID(this.grid) + "!";
                        var formula = this.getFormulaInfoTable().getItem(token + s);
                        if (formula != null && formula != undefined) {
                            if (this.parentObject.setValueRowCol == undefined)
                                this.setValueRowCol(this.getSheetID(this.grid) + 1, formula.getFormulaText(), row, col);
                            else
                                this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, formula.getFormulaText(), row, col);
                        }
                    } else if (this.parentObject.setValueRowCol == undefined)
                        this.setValueRowCol(this.getSheetID(this.grid) + 1, txt, row, col);
                    else
                        this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, txt, row, col);
                } else if (this.parentObject.setValueRowCol == undefined)
                    this.setValueRowCol(this.getSheetID(this.grid) + 1, txt, row, col);
                else
                    this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, txt, row, col);

                this.ignoreValueChanged = saveIVC;
            } else {
                this._processedCells.clear();
                this.updateDependenciesAndCell(s);
                this._processedCells.clear();
                txt = this.getValueFromParentObject(s);
            }

            this.grid = grd;
            this.cell = saveCell;
            this._inAPull = false;

            return txt;
        };
        this.getUpdatedValueRowCol = function (targetSheetID, row, col) {
            var saveGrid = this.grid;
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            var token = this.sheetToken + targetSheetID.toString() + this.sheetToken;
            this.grid = family.tokenToParentObject.getItem(token);
            this._inAPull = true;
            var s = token + RangeInfo.getAlphaLabel(col) + row.toString();

            this.updateCalcID();

            if (!this.getDependentFormulaCells().containsKey(s) && !this.formulaInfoTable.containsKey(s)) {
                var txt = this.getValueFromParentObjectCell(s);
                var saveIVC = this.ignoreValueChanged;
                this.ignoreValueChanged = true;
                if (this.parentObject.setValueRowCol == undefined)
                    this.setValueRowCol(this.getSheetID(this.grid) + 1, txt, row, col);
                else
                    this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, txt, row, col);
                this.ignoreValueChanged = saveIVC;
            } else {
                this._processedCells.clear();
                this.updateDependenciesAndCell(s);
                this._processedCells.clear();
            }

            this.grid = saveGrid;
            this._inAPull = false;
        };
        this.setTokensForSheets = function (text) {
            var family = CalcEngine.getSheetFamilyItem(this.grid);

            if (this.getSupportsSheetRanges()) {
                text = this.handleSheetRanges(text, family);
            }

            var sortedSheetNamesCollection = this.getSortedSheetNames();

            ////family.SheetNameToToken.Keys)
            if (sortedSheetNamesCollection != null) {
                for (var name = 0; name < sortedSheetNamesCollection.length; name++) {
                    var token = family.sheetNameToToken.getItem(sortedSheetNamesCollection[name]);
                    token = token.split(this.sheetToken).join(this._tempSheetPlaceHolder);

                    ////keep the tic defect#541 - TODO: Optimize this process - cache tic names for instance
                    var s = "'" + sortedSheetNamesCollection[name].toUpperCase() + "'" + this.sheetToken;
                    if (text.indexOf(s) == -1) {
                        s = sortedSheetNamesCollection[name].toUpperCase() + this.sheetToken;
                    }

                    text = text.split(s).join(token);

                    //do it again without the tics
                    s = sortedSheetNamesCollection[name].toUpperCase() + this.sheetToken;

                    text = text.split(s).join(token);
                }
            }

            text = text.split(this._tempSheetPlaceHolder).join(this.sheetToken);
            return text;
        };
        this.recalculateRange = function (range, data) {
            this._inRecalculateRange = true;
            for (var row = range.getTop(); row <= range.getBottom(); ++row) {
                for (var col = range.getLeft() ; col <= range.getRight() ; ++col) {
                    if (this.parentObject.getValueRowCol != undefined)
                        this.parentObject.setValueRowCol(this.getSheetID(data) + 1, this.parentObject.getValueRowCol(this.getSheetID(data) + 1, row, col), row, col);
                    else
                        data.setValueRowCol(this.getSheetID(data) + 1, data.getValueRowCol(this.getSheetID(data) + 1, row, col), row, col);
                }
            }
            this._inRecalculateRange = false;
        };
        this.refresh = function (s) {
            ////Don't refresh any cells.
            if (this.getCalculatingSuspended()) {
                return;
            }

            if (this._dependencyLevel == 0) {
                this._refreshedCells.clear();
            }

            if (this.getDependentCells().containsKey(s) && this.getDependentCells().getItem(s) != null) {
                this._dependencyLevel++;
                try  {
                    var family = CalcEngine.getSheetFamilyItem(this.grid);

                    var ht = this.getDependentCells().getItem(s);
                    var save1 = this._lockDependencies;
                    this._lockDependencies = true;
                    for (var o = 0; o < ht.length; o++) {
                        var s1 = ht[o];
                        if (s1 != null) {
                            var grd = this.grid;
                            var sheet = this._sheetToken(s1);
                            if (sheet.length > 0) {
                                this.grid = family.tokenToParentObject.getItem(sheet);
                            }
                            try  {
                                var row = this.rowIndex(s1);
                                var col = this.colIndex(s1);

                                var info = this.getFormulaInfoTable().getItem(s1);
                                if (info != null) {
                                    var save = this.cell;
                                    this.cell = s1;
                                    if (this.getAlwaysComputeDuringRefresh() || info.calcID != this._calcID || info.getFormulaValue() == "") {
                                        info.setFormulaValue(this.computeFormula(info.getParsedFormula()));
                                    }

                                    info.calcID = this._calcID;
                                    this.cell = save;
                                    var saveIVC = this.ignoreValueChanged;
                                    this.ignoreValueChanged = true;
                                    if (this.parentObject.setValueRowCol == undefined)
                                        this.setValueRowCol(this.getSheetID(this.grid) + 1, info.getFormulaValue(), row, col);
                                    else
                                        this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, info.getFormulaValue(), row, col);
                                    this.ignoreValueChanged = saveIVC;
                                    if (!this._refreshedCells.containsKey(s1)) {
                                        this._refreshedCells.add(s1, 0); ////from below ...a
                                        this.refresh(s1); ////recursive call
                                    }
                                }
                            } catch (ex) {
                                continue;
                            }
                            this.grid = grd;
                        }
                    }

                    this._lockDependencies = save1;
                } finally {
                    if (!this._refreshedCells.containsKey(s)) {
                        this._refreshedCells.add(s, 0);
                    }

                    this._dependencyLevel--;
                    if (this._dependencyLevel == 0) {
                        this._refreshedCells.clear();
                    }
                }
            }
        };
        this.refreshRange = function (range) {
            for (var r = range.getTop(); r <= range.getBottom(); r++) {
                for (var c =range.getLeft(); c <= range.getRight(); c++) {
                    var s = RangeInfo.getAlphaLabel(c) + r.toString();
                    this._dependencyLevel = 0;
                    var family = CalcEngine.getSheetFamilyItem(this.grid);
                    var token = this.sheetToken + this.getSheetID(this.grid).toString() + this.sheetToken;
                    if (family.tokenToParentObject != null && family.tokenToParentObject.contains(token))
                        this.grid = family.tokenToParentObject.getItem(token);

                    s = token + s;
                    this.refresh(s);
                }
            }
        };
        this.registerGridAsSheet = function (refName, model, sheetFamilyID) {
            ////refName = refName.replace(" ", ""); //keep the spaces defect#541
            if (CalcEngine.modelToSheetID != null) {
                // this.wireParentObject();
            }


            if (CalcEngine.modelToSheetID == null) {
                CalcEngine.modelToSheetID = new HashTable();
            }

            if (CalcEngine.modelToSheetID.getItem(model) == null || CalcEngine.modelToSheetID.getItem(model) == undefined) {
                CalcEngine.modelToSheetID.add(model, sheetFamilyID);
            }

            var family = CalcEngine.getSheetFamilyItem(model);
            family.isSheetMember = true;

            var refName1 = refName.toUpperCase();
            if (family.sheetNameToParentObject == null) {
                family.sheetNameToParentObject = new HashTable();
            }

            if (family.tokenToParentObject == null) {
                family.tokenToParentObject = new HashTable();
            }

            if (family.sheetNameToToken == null) {
                family.sheetNameToToken = new HashTable();
            }

            if (family.parentObjectToToken == null) {
                family.parentObjectToToken = new HashTable();
            }

            if (family.sheetNameToParentObject.getItem(refName1) != undefined) {
                var token = family.sheetNameToToken.getItem(refName1);
                family.tokenToParentObject.add(token, model);
                family.parentObjectToToken.add(model, token);
            } else {
                var token = this.sheetToken + CalcEngine._tokenCount.toString() + this.sheetToken;
                CalcEngine._tokenCount++;
                family.tokenToParentObject.add(token, model);
                family.sheetNameToToken.add(refName1, token);
                family.sheetNameToParentObject.add(refName1, model);
                family.parentObjectToToken.add(model, token);
                this.sortedSheetNames = null;
            }
            return refName;
        };
        this.renameSheet = function (sheetName, model) {
            var family = CalcEngine.getSheetFamilyItem(model);
            var previousSheetName = "";
            if (sheetName.includes("/") || sheetName.includes("?") || sheetName.includes("*") || sheetName.includes("[") || sheetName.includes("]") || sheetName.includes(":") || sheetName.includes("\\")) {
                throw "The name does not contain any of following characters:  / ? *  [ ] : \\";
            }
            previousSheetName = model.toString();
            previousSheetName = previousSheetName.toUpperCase()
            currentSheetName = sheetName.toUpperCase()
            var token = family.sheetNameToToken.getItem(previousSheetName)

            if (CalcEngine.modelToSheetID.containsKey(model)) {
                CalcEngine.modelToSheetID.remove(model);
                CalcEngine.modelToSheetID.add(sheetName,this._calcID)
            }
            if (family.sheetNameToParentObject.containsKey(previousSheetName)) {
                family.sheetNameToParentObject.remove(previousSheetName);
                family.sheetNameToParentObject.add(currentSheetName, sheetName);

            }
            if (family.tokenToParentObject.containsKey(token)) {
                family.tokenToParentObject.remove(token);
                family.tokenToParentObject.add(token, sheetName);
            }
            if (family.sheetNameToToken.containsKey(previousSheetName)) {
                family.sheetNameToToken.remove(previousSheetName);
                family.sheetNameToToken.add(currentSheetName, token);

            }
            if (family.parentObjectToToken.containsKey(previousSheetName)) {
                family.parentObjectToToken.remove(previousSheetName);
                family.parentObjectToToken.add(sheetName, token);

            }
        };
        this.removeFunction = function (name) {
            if (this._customlibraryFunctions.getItem(name) != undefined) {
                this._customlibraryFunctions.remove(name);
            }
            if (this._libraryFunctions.getItem(name) != null) {
                this._libraryFunctions.remove(name);
                return true;
            }
            return false;
        };
        this.removeNamedRange = function (name) {
            name = name.toUpperCase();
            if (this.getNamedRanges().getItem(name) != null) {
                this.getNamedRanges().remove(name);
                this._populateNamedRangesNonScoped();
                return true;
            }
            return false;
        };
        this.rowIndex = function (s) {
            var i = 0;
            var result;

            var isLetter = false;
            if (i < s.length && s[i] == this.sheetToken) {
                i++;
                while (i < s.length && s[i] != this.sheetToken) {
                    i++;
                }

                i++;
            }

            while (i < s.length && this._isLetter(s[i])) {
                isLetter = true;
                i++;
            }
            result = parseInt(s.substring(i));
            if (i < s.length && !isNaN(result)) {
                return result;
            }

            if (isLetter) {
                return -1;
            }
            throw this.formulaErrorStrings[this._bad_index];
        };
        this.splitArgsPreservingQuotedCommas = function (args) {
            if (args.toString().indexOf(this.tic) == -1) {
                return args.toString().split(this._parseArgumentSeparator);
            }

            var formulaStrings = this._saveStrings(args);
            args = this._saveStringsText;
            var results = args.split(this._parseArgumentSeparator);
            var pieces = [];
            for (var s = 0; s < results.length; s++) {
                var s1 = results[s];
                s1 = this._setStrings(s1, formulaStrings); ////replace tokens with original strings
                pieces.push(s1);
            }
            return pieces;
        };
        this.removeTics = function (s) {
            if (s.length > 1 && s[0] == this.tic[0] && s[s.length - 1] == this.tic[0]) {
                if (this._substring(s, 1, s.length - 2).indexOf(this.tic) == -1) {
                    s = this._substring(s, 1, s.length - 2);
                } else if (this._multiTick) {
                    s = this._substring(s, 1, s.length - 2);
                }
            }
            return s;
        };
        this.updateCalcID = function () {
            this._calcID++;
            if (this._calcID == Number.MAX_SAFE_INTEGER) {
                this._calcID = Number.MIN_SAFE_INTEGER + 1;
            }
        };
        this.updateDependencies = function (s) {
            ////TraceUtil.TraceCurrentMethodInfoIf(Switches.FormulaCell.TraceVerbose, this);
            if (this._lockDependencies || !this.getUseDependencies()) {
                return;
            }
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            var cell1 = this.cell;
            if (family.sheetNameToParentObject != null && cell1.indexOf(this.sheetToken) == -1) {
                var token = family.parentObjectToToken.getItem(this.grid);
                cell1 = token + cell1;
            }
            if (family.sheetNameToParentObject != null && s.indexOf(this.sheetToken) == -1) {
                var token = family.parentObjectToToken.getItem(this.grid);
                s = token + s;
            }

            if (!this.getDependentCells().containsKey(s)) {
                var ht1 = [];
                this.getDependentCells().add(s, ht1);

                ht1.push(cell1);

                if (this.getDependentFormulaCells().containsKey(s)) {
                    //JS-47897 - To get the value from HashTable
                    var ht = this.getDependentFormulaCells().getItem(s);
                    if (ht != null) {
                        var keys = ht.keys();
                        for (var o = 0; o < keys.length; o++) {
                            var s1 = keys[o];
                            var ht2 = this.getDependentCells().getItem(s1);
                            if (ht2 == null) {
                                ht2 = [];
                                this.getDependentCells().add(s1, ht2);
                            }

                            if (ht2.indexOf(cell1) == -1) {
                                ht2.push(cell1);
                            }
                        }
                    }
                }

                ////	else
                this._addToFormulaDependentCells(s);

                if (this.getDependentCells().containsKey(cell1)) {
                    var htCells = this.getDependentCells().getItem(cell1);
                    if (htCells != null && htCells != ht1) {
                        for (var o = 0; o < htCells.length; o++) {
                            var s1 = htCells[o];
                            ht1.push(s1);
                        }
                    }
                }
            } else {
                var ht1 = this.getDependentCells().getItem(s);

                if (ht1.indexOf(cell1) == -1) {
                    ht1.push(cell1);
                }

                this._addToFormulaDependentCells(s);

                ////maybe remove this block ..... not needed if other dependencies working OK
                if (this.getDependentFormulaCells().containsKey(s)) {
                    var ht = this.getDependentFormulaCells().getItem(s);
                    if (ht != null) {
                        var keys = ht.keys();
                        for (var o = 0; o < keys.length; o++) {
                            var s1 = keys[o];
                            var ht2 = this.getDependentCells().getItem(s1);
                            if (ht2 == null) {
                                ht2 = [];
                                this.getDependentCells().add(s1, ht2);
                            }
                            if (ht2.indexOf(cell1) == -1) {
                                ht2.push(cell1);
                            }
                        }
                    }
                }
            }
        };
        this.updateDependenciesAndCell = function (cell1) {
            var grd = this.grid;
            var family = CalcEngine.getSheetFamilyItem(this.grid);

            var sheet = this._sheetToken(cell1);
            if (sheet.length > 0) {
                this.grid = family.tokenToParentObject.getItem(sheet);
            }

            if (this.formulaInfoTable.containsKey(cell1)) {
                var formula = this.formulaInfoTable[cell1];
                if (formula.calcID != this._calcID) {
                    var saveCell = this.cell;
                    this.cell = cell1;

                    if (this._iterationMaxCount > 0 && this._circCheckList.indexOf(this.cell) > -1) {
                        this._handleIterations(formula);
                    } else {
                        formula.setFormulaValue(this.computeFormula(formula.getParsedFormula()));
                    }

                    if (this.getDependentCells().containsKey(cell1)) {
                        var ht = this.getDependentCells().getItem(cell1);
                        for (var s = 0; s < ht.length; s++) {
                            var f = this.FormulaInfoTable.getItem(ht[s]);
                            if (f != null && f != undefined) {
                                f.calcID = Number.MIN_SAFE_INTEGER; ////mark as dirty
                            }
                        }
                    }

                    formula.calcID = this._calcID;
                    this.cell = saveCell;
                }

                var saveIVC = this.ignoreValueChanged;
                this.ignoreValueChanged = true;

                var row = this.rowIndex(cell1);
                var col = this.colIndex(cell1);
                if (this.getPreserveFormula()) {
                    if (this.parentObject.setValueRowCol == undefined)
                        this.setValueRowCol(this.getSheetID(this.grid) + 1, formula.getFormulaText(), row, col);
                    else
                        this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, formula.getFormulaText(), row, col);
                }
                this.ignoreValueChanged = saveIVC;

                this.grid = grd;

                if (this._processedCells.contains(cell1)) {
                    return;
                } else {
                    this._processedCells.add(cell1);
                }
                if (this.parentObject.setValueRowCol == undefined)
                    this.setValueRowCol(this.getSheetID(this.grid) + 1, formula.getFormulaValue(), row, col);
                else
                    this.parentObject.setValueRowCol(this.getSheetID(this.grid) + 1, formula.getFormulaValue(), row, col);
                if (this.getDependentFormulaCells().containsKey(cell1)) {
                    var hthash = this.getDependentFormulaCells().getItem(cell1);
                    var keys = hthash.keys();
                    for (var c = 0; c < keys.length; c++) {
                        this.updateDependenciesAndCell(keys[c]); ////recursive call
                    }
                }
            }
        };
        this.valueChanged = function (grid, e) {
            if (this.ignoreValueChanged) {
                return;
            }

            var grd = grid;
            this.grid = grid;

            var computedValueChanged = true;
            var family = CalcEngine.getSheetFamilyItem(grd);
            var s = RangeInfo.getAlphaLabel(e.getColIndex()) + e.getRowIndex().toString();
            if (family.sheetNameToParentObject != null && family.sheetNameToParentObject.length > 0) {
                var token = family.parentObjectToToken.getItem(grd);
                s = token + s;
            }

            if (e.getValue().length > 0 && e.getValue()[0] == this.getFormulaCharacter()) {
                this.cell = s;
                var formula;
                var compute = true;
                if (this.getFormulaInfoTable().containsKey(s)) {
                    formula = this.getFormulaInfoTable().getItem(s);
                    if (e.getValue() != formula.getFormulaText() || formula.getParsedFormula() == null) {
                        formula.setFormulaText(e.getValue());
                        if (this.getDependentFormulaCells().containsKey(this.cell))
                            this.clearFormulaDependentCells(this.cell);
                        try  {
                            formula.setParsedFormula(this.parseFormula(e.getValue()));
                        } catch (ex) {
                            formula.setFormulaValue(ex);
                            compute = false;
                        }
                    }

                    if (compute) {
                        var s1 = this.computeFormula(formula.getParsedFormula());

                        computedValueChanged = (s1 != formula.getFormulaValue()) || this.getForceRefreshCall();

                        formula.setFormulaValue(s1);
                    }

                    formula.calcID = this._calcID;
                } else {
                    formula = new FormulaInfo();
                    formula.setFormulaText(e.getValue());
                    if (!this.getDependentFormulaCells().containsKey(s)) {
                        this.getDependentFormulaCells().add(s, new HashTable());
                    }

                    try  {
                        formula.setParsedFormula(this.parseFormula(e.getValue()));
                    } catch (ex) {
                        formula.setFormulaValue(ex);
                        compute = false;
                    }

                    if (compute) {
                        formula.setFormulaValue(this.computeFormula(formula.getParsedFormula()));
                        if (this.computeIsFormula(formula).toString() == "#NAME?" && !(this.getNamedRanges().containsKey(formula.getFormulaText().split("=")[1].toUpperCase())))
                            this.getUndefinedNamedRanges().add(formula.getFormulaText().split("=")[1].toUpperCase());
                    }

                    formula.calcID = this._calcID;

                    if (this.getFormulaInfoTable().containsKey(s)) {
                        this.getFormulaInfoTable().add(s, formula);
                    } else {
                        this.getFormulaInfoTable().add(s, formula);
                    }
                }

                if (this._iterationMaxCount > 0 && compute && !this._inHandleIterations) {
                    if (s == this.cell) {
                        this._handleIterations(formula);
                    }
                }

                var saveIVC = this.ignoreValueChanged;
                this.ignoreValueChanged = true;
                if (this.parentObject.setValueRowCol == undefined)
                    this.setValueRowCol(this.getSheetID(grd) + 1, formula.getFormulaValue(), e.getRowIndex(), e.getColIndex());
                else
                    this.parentObject.setValueRowCol(this.getSheetID(grd) + 1, formula.getFormulaValue(), e.getRowIndex(), e.getColIndex());
                this.ignoreValueChanged = saveIVC;
            } else if (!this._inRecalculateRange && this.getFormulaInfoTable().containsKey(s)) {
                this.getFormulaInfoTable().remove(s);
                if (this.getDependentFormulaCells().containsKey(s))
                    this.clearFormulaDependentCells(s);
            }

            if (computedValueChanged && this.getDependentCells().containsKey(s)) {
                this._dependencyLevel = 0;
                this.refresh(s);
            }
        };
        this.getActiveCell = function () {
            return this.cell;
        };
        this.getAllowShortCircuitIFs = function () {
            return this._allowShortCircuitIFs;
        };
        this.setAllowShortCircuitIFs = function (value) {
            this._allowShortCircuitIFs = value;
        };
        this.getAlwaysComputeDuringRefresh = function () {
            return this._alwaysComputeDuringRefresh;
        };
        this.setAlwaysComputeDuringRefresh = function (value) {
            this._alwaysComputeDuringRefresh = value;
        };
        this.getCalculatingSuspended = function () {
            return this._calculatingSuspended;
        };
        this.setCalculatingSuspended = function (value) {
            this._calculatingSuspended = value;
        };
        this.getCheckDanglingStack = function () {
            return this._checkDanglingStack;
        };
        this.setCheckDanglingStack = function (value) {
            this._checkDanglingStack = value;
        };
        this.getCustomLibraryFunctions = function () {
            return this._customlibraryFunctions;
        };
        this.getDependentCells = function () {
            if (this.isSheetMember()) {
                var family = CalcEngine.getSheetFamilyItem(this.grid);
                if (family.sheetDependentCells == null) {
                    family.sheetDependentCells = new HashTable();
                }

                return family.sheetDependentCells;
            } else {
                if (this._dependentCells == null) {
                    this._dependentCells = new HashTable();
                }

                return this._dependentCells;
            }
        };
        this.getDependentFormulaCells = function () {
            if (this.isSheetMember()) {
                var family = CalcEngine.getSheetFamilyItem(this.grid);
                if (family.sheetDependentFormulaCells == null) {
                    family.sheetDependentFormulaCells = new HashTable();
                }

                return family.sheetDependentFormulaCells;
            } else {
                if (this._dependentFormulaCells == null) {
                    this._dependentFormulaCells = new HashTable();
                }

                return this._dependentFormulaCells;
            }
        };
        this.getEnableLookupTableCaching = function () {
            return this._enableLookupTableCaching;
        };
        this.setEnableLookupTableCaching = function (value) {
            this._enableLookupTableCaching = value;
        };
        this.getErrorStrings = function () {
            if (this._errorStrings == null) {
                this._errorStrings = ["#N/A", "#VALUE!", "#REF!", "#DIV/0!", "#NUM!", "#NAME?", "#NULL!"];
            }
            return this._errorStrings;
        };
        this.setErrorStrings = function (value) {
            this._errorStrings = value;
        };
        this.getExcelLikeComputations = function () {
            return this._excelLikeComputations;
        };
        this.setExcelLikeComputations = function (value) {
            this._excelLikeComputations = value;
        };
        this.getForceRefreshCall = function () {
            return this._forceRefreshCall;
        };
        this.setForceRefreshCall = function (value) {
            this._forceRefreshCall = value;
        };
        this.getFormulaCharacter = function () {
            if (CalcEngine._formulaChar == '\0') {
                CalcEngine._formulaChar = '=';
            }
            return CalcEngine._formulaChar;
        };
        this.setFormulaCharacter = function (value) {
            CalcEngine._formulaChar = value;
        };
        this.getFormulaInfoTable = function () {
            if (this.isSheetMember()) {
                var family = CalcEngine.getSheetFamilyItem(this.grid);
                if (family.sheetFormulaInfoTable == null) {
                    family.sheetFormulaInfoTable = new HashTable();
                }

                return family.sheetFormulaInfoTable;
            } else {
                if (this._formulaInfoTable == null) {
                    this._formulaInfoTable = new HashTable();
                }

                return this._formulaInfoTable;
            }
        };
        this.getPreserveLeadingZeros = function () {
            return this._preserveLeadingZeros;
        };
        this.setPreserveLeadingZeros = function (value) {
            this._preserveLeadingZeros = value;
        };
        this.getIterationMaxCount = function () {
            return this._iterationMaxCount;
        };
        this.setIterationMaxCount = function (value) {
            this._iterationMaxCount = value;
            if (this._iterationMaxCount > 0) {
                this.setThrowCircularException(true);
            }
        };
        this.getIterationMaxTolerance = function () {
            return this._iterationMaxTolerance;
        };
        this.setIterationMaxTolerance = function (value) {
            this._iterationMaxTolerance = value;
        };
        this.getIterationValues = function () {
            if (this._iterationValues == null) {
                this._iterationValues = new HashTable();
            }
            return this._iterationValues;
        };
        this.getLibraryComputationException = function () {
            return this._libraryComputationException;
        };
        this.getLibraryFunctions = function () {
            return this._libraryFunctions;
        };
        this.getLockDependencies = function () {
            return this._lockDependencies;
        };
        this.setLockDependencies = function (value) {
            this._lockDependencies = value;
        };
        this.getMaximumRecursiveCalls = function () {
            return this._maximumRecursiveCalls;
        };
        this.setMaximumRecursiveCalls = function (value) {
            this._maximumRecursiveCalls = value;
        };
        this.getNamedRanges = function () {
            if (this.namedRanges == null) {
                this.namedRanges = new HashTable();
                this._namedRangesNonScoped = new HashTable();
            }
            return this.namedRanges;
        };
        this.setNamedRanges = function (value) {
            this.namedRanges = value;
            this._populateNamedRangesNonScoped();
        };
        this.getUndefinedNamedRanges = function () {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family != null || family != undefined) {
                if (this.undefinedsheetNamedRnages == null) {
                    this.undefinedsheetNamedRnages = new HashTable();
                }
                return this.undefinedsheetNamedRnages;
            }
            else {
                if (this.undefinednamedRange == null) {
                    this.undefinednamedRange = new HashTable();
                }
                return this.undefinednamedRange;
            }
        };
        this.getNameRangeValues = function () {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family != null || family != undefined) {
                if (this.namedRangeValues == null) {
                    this.namedRangeValues = new HashTable();
                }
                return this.namedRangeValues;
            }
            else {
                if (this.rangeValues == null) {
                    this.rangeValues = new HashTable();
                }
                return this.rangeValues;
            }
        };
        this.getNamedRangesOriginalNames = function () {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family != null || family != undefined) {
                if (this.sheetNamedRangesOriginalNames == null) {
                    this.sheetNamedRangesOriginalNames = new HashTable();
                }
                return this.sheetNamedRangesOriginalNames;
            }
            else {
                if (this.namedRangesOriginalNames == null) {
                    this.namedRangesOriginalNames = new HashTable();
                }
                return this.namedRangesOriginalNames;
            }
        };
        this.getNamedRangeCellCollection = function () {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family != null || family != undefined) {
                if (this.sheetNamedRangeCellCollection == null) {
                    this.sheetNamedRangeCellCollection = new HashTable();
                }
                return this.sheetNamedRangeCellCollection;
            }
            else {
                if (this.namerangecellcollection == null) {
                    this.namerangecellcollection = new HashTable();
                }
                return this.namerangecellcollection;
            }
        };
        this.getDependentNamedRangeCells = function () {
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (family != null || family != undefined) {
                if (this.sheetDependentNamedRangeCells == null) {
                    this.sheetDependentNamedRangeCells = new HashTable();
                }
                return this.sheetDependentNamedRangeCells;
            }
            else {
                if (this.dependentNamedRangeCells == null) {
                    this.dependentNamedRangeCells = new HashTable();
                }
                return this.dependentNamedRangeCells;
            }
        };
        this.getParseArgumentSeparator = function () {
            if (this._parseArgumentSeparator == '\0') {
                this._parseArgumentSeparator = ',';
            }
            var seperator = ',';
            if (!this._isParseArgumentSeparator && seperator != this._parseArgumentSeparator) {
                this._parseArgumentSeparator = seperator;
            }
            return this._parseArgumentSeparator;
        };
        this.setParseArgumentSeparator = function (value) {
            this._parseArgumentSeparator = value;
            this._isParseArgumentSeparator = true;
        };
        this.getParseDateTimeSeparator = function () {
            return this._parseDateTimeSeparator;
        };
        this.setParseDateTimeSeparator = function (value) {
            this._parseDateTimeSeparator = value;
        };
        this.getParseDecimalSeparator = function () {
            ////DT 26058 incident
            ////handle problems with threading by dynamically assigning the static values
            if (this._parseDecimalSeparator == '\0') {
                this._parseDecimalSeparator = '.';
            }

            var seperator = '.';
            if (!this._isParseDecimalSeparatorChanged && seperator != this._parseDecimalSeparator) {
                this._parseDecimalSeparator = seperator;
            }

            return this._parseDecimalSeparator;
        };
        this.setParseDecimalSeparator = function (value) {
            this._parseDecimalSeparator = value;
            this._parseDecimalSeparator = true;
        };
        this.getPreserveFormula = function () {
            return this._preserveFormula;
        };
        this.setPreserveFormula = function (value) {
            this._preserveFormula = value;
        };
        this.getReservedWordOperators = function () {
            if (this._reservedWordOperators == null) {
                this._reservedWordOperators = [" or ", " and ", " xor ", "if ", " then ", " else ", "not "];
            }

            return this._reservedWordOperators;
        };
        this.setReservedWordOperators = function (value) {
            this._reservedWordOperators = value;
        };
        this.getRethrowLibraryComputationExceptions = function () {
            return this._rethrowLibraryComputationExceptions;
        };
        this.setRethrowLibraryComputationExceptions = function (value) {
            this._rethrowLibraryComputationExceptions = value;
        };
        this.getRethrowParseExceptions = function () {
            return this._rethrowExceptions;
        };
        this.setRethrowParseExceptions = function (value) {
            this._rethrowExceptions = value;
        };
        this.getRowMaxCount = function () {
            return this._rowMaxCount;
        };
        this.setRowMaxCount = function (value) {
            this._rowMaxCount = value;
        };
        this.getSortedSheetNames = function () {
            if (this._sortedSheetNames == null) {
                var family = CalcEngine.getSheetFamilyItem(this.grid);
                if (family != null && family.sheetNameToToken != null) {
                    this._sortedSheetNames = family.sheetNameToToken.keys();
                    this._sortedSheetNames.sort(); //(new LenComparer());
                }
            }

            return this._sortedSheetNames;
        };
        this.getSupportLogicalOperators = function () {
            return this._supportLogicalOperators;
        };
        this.setSupportLogicalOperators = function (value) {
            this._supportLogicalOperators = value;
        };
        this.getSupportRangeOperands = function () {
            return this._supportRangeOperands;
        };
        this.setSupportRangeOperands = function (value) {
            this._supportRangeOperands = value;
        };
        this.getSupportsSheetRanges = function () {
            return this._supportsSheetRanges;
        };
        this.setSupportsSheetRanges = function (value) {
            this._supportsSheetRanges = value;
        };
        this.getThrowCircularException = function () {
            return this._throwCircularException;
        };
        this.setThrowCircularException = function (value) {
            this._throwCircularException = value;
        };
        this.getTreatStringsAsZero = function () {
            return this._treatStringsAsZero;
        };
        this.setTreatStringsAsZero = function (value) {
            this._treatStringsAsZero = value;
        };
        this.getUseDatesInCalculations = function () {
            return this._useDatesInCalcs;
        };
        this.setUseDatesInCalculations = function (value) {
            this._useDatesInCalcs = value;
        };
        this.getUseDependencies = function () {
            return this._useDependencies;
        };
        this.setUseDependencies = function (value) {
            this._useDependencies = value;
        };
        this.getUseFormulaValues = function () {
            return this._useFormulaValues;
        };
        this.setUseFormulaValues = function (value) {
            this._useFormulaValues = value;
        };
        this.getUseNoAmpersandQuotes = function () {
            return this._useNoAmpersandQuotes;
        };
        this.setUseNoAmpersandQuotes = function (value) {
            this._useNoAmpersandQuotes = value;
        };
        this.getValidPrecedingChars = function () {
            return this._validPrecedingChar + this.getParseArgumentSeparator();
        };
        this.setValidPrecedingChars = function (value) {
            this._validPrecedingChars = value;
        };
        this.getEnableFormulaErrorValidation = function () {
            return this._enableFormulaErrorValidation;
        };
        this.setEnableFormulaErrorValidation = function (value) {
            this._enableFormulaErrorValidation = value;
        }
        this.getWeekEndType = function () {
            return ["", "6,0", "0,1", "1,2", "2,3", "3,4", "4,5", "5,6", "", "", "", "0", "1", "2", "3", "4", "5", "6"];
        };
        this.computeSum = function (range) {
            var sum = 0, s1, d, adjustRange;
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (!range || range.length == 0) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var key = 0; key < ranges.length; key++) {
                adjustRange = ranges[key];
                if (adjustRange.indexOf(':') > -1) {
                    if (adjustRange.startsWith(this.tic)) {
                        if (this._rethrowLibraryComputationExceptions)
                            throw this.formulaErrorStrings[this._bad_index];
                        return this.getErrorStrings()[4].toString();
                    }
                    var cellCollection = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            if (cellCollection[s].startsWith(this.tic) && isNaN(this._parseDouble(cellCollection[s]))) {
                                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                    throw this.getLibraryComputationException();
                                return this.getErrorStrings()[1].toString();
                            }
                            var family = CalcEngine.getSheetFamilyItem(this.grid);
							if(!ej.isNullOrUndefined(family.parentObjectToToken))
							{
                            var token = family.parentObjectToToken.getItem(this.grid) + cellCollection[s];
                            var formula = this.getFormulaInfoTable().getItem(token);
                            if (!ej.isNullOrUndefined(formula) && !ej.isNullOrUndefined(formula._formulaText.toUpperCase().match("SUBTOTAL")))
                                s1 = "0";
                            else
                                s1 = this.getValueFromArg(cellCollection[s]).split(this.tic).join("");
							}
							else
							    s1 = this.getValueFromArg(cellCollection[s]).split(this.tic).join("");
                            if (this.getErrorStrings().indexOf(s1) > -1) {
                                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                    throw this.getLibraryComputationException();
                                return s1;
                            }
                        } catch (ex) {
                            if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1 != "") {
                            d = (s1 == this.trueValueStr) ? true : (s1 == this.falseValueStr) ? false : this._parseDouble(s1);
                            if (this.getErrorStrings().indexOf(s1) > -1) {
                                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                    throw this.getLibraryComputationException();
                                return s1;
                            }
                            if (isNaN(d)) {
                                s1 = "";
                            } else {
                                sum = sum + d;
                            }
                        }
                    }
                } else {
                    try {
                        if (adjustRange.startsWith(this.tic) && isNaN(this._parseDouble(adjustRange))) {
                            if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                throw this.getLibraryComputationException();
                            return this.getErrorStrings()[1].toString();
                        }
                        s1 = this.getValueFromArg(adjustRange).split(this.tic).join("");
                        if (this.getErrorStrings().indexOf(s1) > -1) {
                            if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                throw this.getLibraryComputationException();
                            return s1;
                        }
                    } catch (ex) {
                        if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        d = (s1 == this.trueValueStr) ? true : (s1 == this.falseValueStr) ? false : this._parseDouble(s1);
                        if (this.getErrorStrings().indexOf(s1) > -1) {
                            return s1;
                        }
                        if (!isNaN(d)) {
                            sum = sum + d;
                        }
                    }
                }
            }
            return sum.toString();
        };

        this.computeDate = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
            }

            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            args[2] = (args[2].split(this.tic).join("") == "TRUE") ? "1" : (args[2].split(this.tic).join("") == "FALSE") ? "0" : args[2];
            var year = this._parseDouble(args[0]);
            var month = this._parseDouble(args[1]);
            var day = this._parseDouble(args[2]);
            var days = 0;

            if (!isNaN(year) && !isNaN(month) && !isNaN(day)) {
                if (year < 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                while (month > 12) {
                    month -= 12;
                    year++;
                }

                days = this._getSerialDateFromDate(year, month, day);
            }
            if (days == 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[4].toString();
            }
            if (this._excelLikeComputations) {
                var date = this._fromOADate(days);
                if (date.toString() != "Invalid Date") {
                    return date.toLocaleDateString();
                }
            }
            return days.toString();
        };
        this.computeDatevalue = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (this._isCellReference(argList)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[1].toString();
            }
            var dt = new Date(Date.parse(args[0]));
            var dtNum = this._parseDouble(args[0]);
            try  {
                if (!isNaN(dtNum) || dt.toString() == "Invalid Date") {
                    if (dtNum > 0) {
                        dt = this._fromOADate(dtNum);
                    } else {
                        var ranges = argList.split(this.getParseDateTimeSeparator());
                        var argCount = ranges.length;
                        var arg = "";
                        for (var i = 0; i < argCount; ++i) {
                            ranges[i] = this.computedValue(ranges[i]);
                            if (i < argCount - 1)
                                arg += ranges[i] + this.getParseDateTimeSeparator();
                            else
                                arg += ranges[i];
                        }
                        arg = arg.split(this.tic).join(this._string_empty);
                        dt = new Date(Date.parse(arg));
                    }
                }
            } catch (ex) {
                return this.formulaErrorStrings[this.invalid_arguments];
            }
            if (args[0].indexOf("2001") == -1 && dt.getFullYear() == 2001) {
                dt.setFullYear((new Date(Date.now())).getFullYear());
            }
            var days = this._toOADate(dt);
            if (isNaN(days)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[1].toString();
            }
            if (this.treat1900AsLeapYear && days > 59) {
                days += 1;
            }

            return Math.round(days).toString();
        };
        this.computeDay = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            if (args.length > 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var day = 1;
            var s = this.getValueFromArg(argList).split(this.tic).join("");
            var serialdate = this._parseDouble(s);
            if (!isNaN(serialdate)) {
                if (serialdate < 1) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_Math_argument];
                    return this.getErrorStrings()[4].toString();
                } else {
                    date = this._getDateFromSerialDate(serialdate);
                    day = date.getDate();
                }
            } else {
                var date = new Date(Date.parse(s));
                if (date.toString() != "Invalid Date") {
                    day = date.getDate();
                } else {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_Math_argument];
                    return this.getErrorStrings()[1].toString();
                }
            }
            return day.toString();
        };
        this.computeDays = function (argList) {
            var argument = argList;
            var args = this.splitArgsPreservingQuotedCommas(argList);
            if (args.length != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var startDateValue = this.getValueFromArg(args[0]);
            startDateValue = (startDateValue.split(this.tic).join("") == "TRUE") ? "1" : (startDateValue.split(this.tic).join("") == "FALSE") ? "0" : startDateValue;
            var endDateValue = this.getValueFromArg(args[1]);
            endDateValue = (endDateValue.split(this.tic).join("") == "TRUE") ? "1" : (endDateValue.split(this.tic).join("") == "FALSE") ? "0" : endDateValue;

            startDateValue = (startDateValue == "" || startDateValue == null) ? new Date(Date.parse("1899-12-31")).toDateString() : startDateValue;
            endDateValue = (endDateValue == "" || endDateValue == null) ? new Date(Date.parse("1899-12-31")).toDateString() : endDateValue;
            var startDateTime, endDateTime;

            var startDateSerial = this._parseDouble(startDateValue.split(this.tic).join(""));
            var endDateSerial = this._parseDouble(endDateValue.split(this.tic).join(""));

            if (!isNaN(startDateSerial)) {
                startDateTime = this._getDateFromSerialDate(startDateSerial);
            } else
                startDateTime = new Date(Date.parse(startDateValue));

            if (!isNaN(endDateSerial)) {
                endDateTime = this._getDateFromSerialDate(endDateSerial);
            } else
                endDateTime = new Date(Date.parse(endDateValue));

            var timeDiff = endDateTime.getTime() - startDateTime.getTime();

            var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
            return diffDays.toString();
        };
        this.computeDays360 = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if ((argCount != 2 && argCount != 3) || argList == "") {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var method = false;
            var days = 0;
            var dt1 = new Date(Date.parse(this.getValueFromArg(args[0]).split(this.tic).join("")));
            var dt2 = new Date(Date.parse(this.getValueFromArg(args[1]).split(this.tic).join("")));
            var date1 = this.getValueFromArg(args[0]);
            var date2 = this.getValueFromArg(args[1]);
            var serialdate1 = (date1.split(this.tic).join("") == "TRUE") ? "1" : (date1.split(this.tic).join("") == "FALSE") ? "0" : date1;
            var serialdate2 = (date2.split(this.tic).join("") == "TRUE") ? "1" : (date2.split(this.tic).join("") == "FALSE") ? "0" : date2;
            serialdate1 = this._parseDouble(serialdate1.split(this.tic).join(""));
            serialdate2 = this._parseDouble(serialdate2.split(this.tic).join(""));

            if ((!isNaN(serialdate1) || !isNaN(this._isDate(dt1))) && (!isNaN(serialdate2) || !isNaN(this._isDate(dt2)))) {
                dt1 = (serialdate1 > 0) ? this._getDateFromSerialDate(serialdate1) : dt1;
                dt2 = (serialdate2 > 0) ? this._getDateFromSerialDate(serialdate2) : dt2;
                var flipSign = false;
                var mathodStr = this.falseValueStr;
                if (argCount == 3)
                    mathodStr = this.getValueFromArg(args[2]);
                method = (mathodStr == this.trueValueStr) ? true : false;
                if (dt1.getDate() == 31) {
                    dt1 = new Date(dt1.setDate(dt1.getDate() - 1));
                }

                if (dt2.getDate() == 31 && !method && dt1.getDate() < 30) {
                    dt2 = new Date(dt2.setDate(dt2.getDate() + 1));
                } else if (dt2.getDate() == 31) {
                    dt2 = new Date(dt2.setDate(dt2.getDate() - 1));
                }

                if (dt2 < dt1) {
                    flipSign = true;
                    var t = dt1;
                    dt1 = dt2;
                    dt2 = t;
                }

                days = dt2.getDate() - dt1.getDate();
                days += 30 * (dt2.getMonth() - dt1.getMonth());
                days += 360 * (dt2.getFullYear() - dt1.getFullYear());
                if (flipSign) {
                    days = -days;
                }
            } else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[1].toString();
            }
            return days.toString();
        };
        this.computeEDate = function (argList) {
            var argument = argList;
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (args[0] == "" || args[1] == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[0].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var startDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            var StartDateValue = parseInt(startDate);
            var startDateTime = (isNaN(startDate)) ? new Date(Date.parse(startDate)) : this._fromOADate(parseInt(startDate));
            var monthCount = this.getValueFromArg(args[1]).split(this.tic).join("");
            var month = parseInt(monthCount);
            if (startDateTime.toString() == "Invalid Date" && isNaN(month)) {
                try {
                    var today = new Date(Date.now());
                    var first = this._parseDouble(startDate);
                    var second = parseInt(monthCount);
                    if (second < 0 && second < first) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._bad_index];
                        return this.getErrorStrings()[4].toString();
                    }
                    if (first != 0) {
                        var dt = this.dateTime1900;
                        dt = this._fromOADate(first);
                        startDateTime = new Date(dt.setMonth(dt.getMonth() + second));
                    } else {
                        startDateTime = new Date(today.setMonth(today.getMonth() + second));
                        var days = this.computeDays(today.toLocaleDateString() + this.getParseArgumentSeparator() + startDateTime.toLocaleDateString());
                        return days;
                    }
                }
                catch (ex) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_formula] + ex;
                    return this.getErrorStrings()[1].toString();
                }
            }
            startDateTime = new Date(startDateTime.setMonth(startDateTime.getMonth() + month));
            if (this.getExcelLikeComputations()) {
                return startDateTime.toLocaleDateString();
            } else {
                return parseInt(this._toOADate(startDateTime)).toString();
            }
        };
        this.computeEOMonth = function (argList) {
            var argument = argList;
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (args[0] == "" || args[1] == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[0].toString();
                return this.getErrorStrings()[0].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var startDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            var startDateTime = new Date(startDate);
            var month = this._parseDouble(this.getValueFromArg(args[1]).split(this.TIC).join(""));
            if(startDateTime.toString() == "Invalid Date")
            {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            if (isNaN(month)) {
                try  {
                    var today = new Date(Date.now());
                    var first = parseInt(startDate);
                    month = this._parseDouble(this.getValueFromArg(args[1]).split(this.tic).join(""));
                    if (month < 0 && first <= 0 && month < first) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._bad_index];
                        return this.getErrorStrings()[4].toString();
                    }
                } catch (ex) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_index];
                    return this.getErrorStrings()[1].toString();
                }
            }
            var dateValue = parseInt(startDate);
            if (!isNaN(dateValue) && startDateTime.getFullYear() > 9999) {
                startDateTime = this._fromOADate(dateValue);
            }
            startDateTime = new Date(startDateTime.setMonth(startDateTime.getMonth() + month));
            var totalDays = (new Date(startDateTime.getFullYear(), startDateTime.getMonth() + 1, 1, -1)).getDate();
            startDateTime = new Date(startDateTime.getFullYear(), startDateTime.getMonth(), totalDays);

            if (this.getExcelLikeComputations())
                return startDateTime.toLocaleDateString();
            else
                return this._getSerialDateTimeFromDate(startDateTime).toString();
        };
        this.computeHour = function (argList) {
            var time;
            var args = this.splitArgsPreservingQuotedCommas(argList);
            if (args.length != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var dt = new Date(Date.now());
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }   
            argList = this.getValueFromArg(argList);
            argList = argList.split(this.tic).join("");
            argList = (argList == "TRUE") ? "1" : (argList == "FALSE") ? "0" : argList;
            dt = new Date(Date.parse(argList));
            var hourValue = parseInt(argList);
            if (hourValue < 0)
            {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[4].toString();
            }
            if (dt.toString() == "Invalid Date") {
                var argVal = (new Date(Date.now())).toLocaleDateString() + " " + argList;
                dt = new Date(Date.parse(argVal));
            }
            if (dt.toString() == "Invalid Date") {
                dt = this._fromOADate(argList);
            }
            if (dt.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            return dt.getHours().toString();
        };
        this.computeISOWeeknum = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var value = this.getValueFromArg(args[0]);
            if (value[0] == (this.tic) && this._isTextEmpty(value.split(this.tic).join(""))) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[1].toString();
            }
            if (this._isTextEmpty(value)) {
                argList = this.computeDatevalue(new Date(1990, 12, 28).toLocaleDateString());
            }

            if (argList.indexOf(":") > -1 || !this._isCellReference(this.getValueFromArg(args[0])) && this.getValueFromArg(this.DateFormatter(args[0])).indexOf(":") > -1) {
                argList = "0";
            }
            var weekDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            weekDate = (weekDate.split(this.tic).join("") == "TRUE") ? "1" : (weekDate.split(this.tic).join("") == "FALSE") ? "0" : weekDate;
            var date = new Date(weekDate);
            var weekDateOnly = this.DateFormatter(weekDate);
    
            var weekDateTime = new Date(Date.parse(weekDateOnly)), firstDate = this.dateTime1900;
            ;
            if (weekDateTime.toString() == "Invalid Date") {
                try  {
                    var weeknumber = parseInt(weekDateOnly);
                    weekDateTime = this.fromOADate(weeknumber);
                    weekDate = weekDateTime.toLocaleDateString();
                } catch (ex) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw "Bad Cell reference";
                    return this.getErrorStrings()[1].toString();
                }
            }
            var isoarg = weekDate + this.getParseArgumentSeparator() + "21";
            var weekno = parseInt(this.computeWeeknum(isoarg));
            return weekno.toString();
        };

       this.DateFormatter= function  (date) {
           var d = new Date(date);
            var day = d.getDate();
            var month = d.getMonth() + 1;
            var year = d.getFullYear();
            if (day < 10) {
                day = + day;
            }
            if (month < 10) {
                month =  month;
            }
            var date = month + "/" + day + "/" + year;

            return date;
        }; 

        this.computeMinute = function (argList) {
           var argument = this.splitArgsPreservingQuotedCommas(argList);
           if (argument.length > 1 || argList == "") {
               if (this.getRethrowLibraryComputationExceptions())
                   throw this.formulaErrorStrings[this._wrong_number_arguments];
               return this.formulaErrorStrings[this._wrong_number_arguments];
           }
           if (this.getEnableFormulaErrorValidation()) {
               var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
               if (this.getErrorStrings().indexOf(checkString) > -1) {
                   return checkString;
               }
           }
            var time;
            var dt = new Date(Date.now());
            argList = this.getValueFromArg(argList);
            argList = argList.split(this.tic).join("");
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;
            dt = new Date(Date.parse(argList));
            if (argList < 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[4].toString();
            }
            if (dt.toString() == "Invalid Date") {
                var argVal = (new Date(Date.now())).toLocaleDateString() + " " + argList;
                dt = new Date(Date.parse(argVal));
            }
            if (dt.toString() == "Invalid Date") {
                dt = this._fromOADate(argList);
            }
            if (dt.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            return dt.getMinutes().toString();
        };
        this.computeMonth = function (argList) {
            var month = 1;
            var args = this.splitArgsPreservingQuotedCommas(argList);
            if (args.length != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }   
            var s = this.getValueFromArg(argList);
            s = (s.split(this.tic).join("") == "TRUE") ? "1" : (s.split(this.tic).join("") == "FALSE") ? "0" : s;
            var date = new Date(Date.parse(s.split(this.tic).join("")));

            var dateValue = parseInt(s);
            if (!isNaN(dateValue) && date.getFullYear() > 9999) {
                date = this._fromOADate(dateValue);
            }
            if (s < 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[4].toString();
            }
            if (date.toString() == "Invalid Date") {
                argList = (new Date(Date.now())).toLocaleDateString() + " " + argList;
                date = new Date(Date.parse(argList));
            }
            if (date.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            if (date.toString() != "Invalid Date") {
                month = date.getMonth() + 1;
            } else {
                var serialdate = this._parseDouble(this.getValueFromArg(argList));
                if (!isNaN(serialdate)) {
                    ////serialdate = serialdate - 1 - ((Treat1900AsLeapYear && serialdate > 59) ?  1 : 0);
                    if (serialdate < 1) {
                        month = 1;
                    } else {
                        date = this._getDateFromSerialDate(serialdate); ////dateTime1900.AddDays(serialdate);
                        month = date.getMonth() +1;
                    }
                } else {
                    return this.formulaErrorStrings[this._invalid_arguments];
                }
            }
            return month.toString();
        };
        this.computeNetworkDays = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var adjustRange, s1;
            var date;
            var holidays = [];

            if (argCount != 2 && argCount != 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var startDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            var endDate = this.getValueFromArg(args[1]).split(this.tic).join("");
            if (startDate == "" || endDate == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[0].toString();
                return this.getErrorStrings()[0].toString();
            }
            var startDateTime = new Date(Date.parse(startDate));
            var endDateTime = new Date(Date.parse(endDate));
            var dval = this._parseDouble(startDate);
            if (!isNaN(dval) && startDateTime.getFullYear() > 9999) {
                startDateTime = this._fromOADate(dval);
            }
            if (startDateTime.toString() == "Invalid Date") {
                startDateTime = this._fromOADate(dval);
            }
            if (startDateTime.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }
            var dval = this._parseDouble(endDate);
            if (!isNaN(dval) && endDateTime.getFullYear() > 9999) {
                endDateTime = this._fromOADate(dval);
            }
            if (endDateTime.toString() == "Invalid Date") {
                endDateTime = this._fromOADate(dval);
            }
            if (endDateTime.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }
            if (argCount == 3) {
                adjustRange = args[2];
                ////is a cellrange
                if (adjustRange.indexOf(':') > -1) {
                    var cells = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cells.length; s++) {
                        try  {
                            s1 = this.getValueFromArg(s).split(this.tic).join("");
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1 != "") {
                            date = new Date(Date.parse(s1));
                            if (date.toString() != "Invalid Date" && (holidays.indexOf(date) == -1) && date > startDateTime && date < endDateTime && date.getDay() != 0 && date.getDay() != 6) {
                                holidays.push(date);
                            }
                        }
                    }
                } else {
                    var dateArray = this.splitArgsPreservingQuotedCommas(adjustRange.split(this.tic).join(""));
                    for (var i = 0; i < dateArray.length; i++) {
                        try {
                            s1 = this.getValueFromArg(dateArray[i]);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            date = new Date(Date.parse(s1));
                            if (date.toString() != "Invalid Date" && (holidays.indexOf(date) == -1) && date > startDateTime && date < endDateTime && date.getDay() != 0 && date.getDay() != 6) {
                                holidays.push(date);
                            }
                        }
                    }
                }
            }

            var numberOfWorkingDays = 0;
            var noofDays = parseInt(this.computeDatevalue(endDate)) - parseInt(this.computeDatevalue(startDate));
            var startWeekDay = startDateTime.getDay();
            var endWeekDay = endDateTime.getDay();
            var excesStartDays = startWeekDay - 1;
            var excesEndDays = 7 - endWeekDay;
            noofDays = noofDays + excesStartDays + excesEndDays;

            var noofholidays = parseInt(noofDays / 7) * 2;

            numberOfWorkingDays = noofDays - excesStartDays - excesEndDays - noofholidays + 1 - holidays.length;
            if (endWeekDay == 6 || startWeekDay == 0)
                numberOfWorkingDays--;
            return numberOfWorkingDays.toString();
        };
        this.computeNetworkDaysOintl = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var adjustRange, s1;
            var date;
            var holidays = [];

            if (argCount != 2 && argCount > 4 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                for (var i = 0; i < argCount; i++) {
                    if (i != 2) {
                        var checkString = this.formulaErrorStringCheck(args[i], FormulaArgumentType.Date);
                        if (this.getErrorStrings().indexOf(checkString) > -1) {
                            return checkString;
                        }
                    }
                }
                if (argCount >= 3) {
                    checkString = this.formulaErrorStringCheck(args[2], FormulaArgumentType.Text);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }

            var startDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            var endDate = this.getValueFromArg(args[1]).split(this.tic).join("");
            if (startDate == "" || endDate == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[0].toString();
                return this.getErrorStrings()[0].toString();
            }
            var startDateTime = new Date(Date.parse(this._fromOADate(startDate)));
            var endDateTime = new Date(Date.parse(this._fromOADate(endDate)));
            if (startDateTime.toString() == "Invalid Date") {
                var dval = this._parseDouble(startDate);
                if (!isNaN(dval)) {
                    startDateTime = this.fromOADate(dval);
                } else {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.getErrorStrings()[1].toString();
                    return this.getErrorStrings()[1].toString();
                }
            }
            if (endDateTime.toString() == "Invalid Date") {
                var dval = this._parseDouble(endDate);
                if (!isNaN(dval)) {
                    endDateTime = this._fromOADate(dval);
                } else {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.getErrorStrings()[1].toString();
                    return this.getErrorStrings()[1].toString();
                }
            }
            if (argCount == 4) {
                adjustRange = args[3];
                adjustRange = this.adjustRangeArg(adjustRange);

                ////is a cellrange
                if (adjustRange.indexOf(':') > -1 || adjustRange.indexOf(',') > -1) {
                    var cells = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cells.length; s++) {
                        try  {
                            s1 = this.getValueFromArg(cells[s]).toString().split(this.tic).join("");
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1 != "") {
                            date = new Date(Date.parse(s1));
                            if (date.toString() != "Invalid Date" && (holidays.indexOf(date) == -1) && date > startDateTime && date > endDateTime && date.getDay() != 0 && date.getDay() != 6) {
                                holidays.push(date);
                            }
                        }
                    }
                } else {
                    try  {
                        s1 = this.getValueFromArg(adjustRange).split(this.tic).join("");
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        date = new Date(Date.parse(s1));
                        if (date.toString() != "Invalid Date" && (holidays.indexOf(date) == -1) && date > startDateTime && date < endDateTime && date.getDay() != 0 && date.getDay() != 6) {
                            holidays.push(date);
                        }
                    }
                }
            }

            var weekend = parseInt(args[2]);
            if (!(argCount > 2 && !isNaN(weekend))) {
                weekend = 1;
            } else if(!isNaN(args[2])) {
                weekend = parseInt(args[2]);
            }
        else{ 
            
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            var weekendDays = this._splitArguments(this.getWeekEndType()[weekend].toString(), ',');
            var noofDays = parseInt(this.computeDatevalue(endDate)) - parseInt(this.computeDatevalue(startDate)) + 1;
            var netWorkDays = noofDays;
            var j = 1;
            var tempStartDate = startDateTime;
            while (j < noofDays) {
                var dayofweek = tempStartDate.getDay();
                if (weekendDays.indexOf(dayofweek.toString()) >= 0) {
                    netWorkDays--;
                } else if (holidays.indexOf(tempStartDate) >= 0) {
                    netWorkDays--;
                }
                tempStartDate = new Date(tempStartDate.setDate(tempStartDate.getDate() + 1));
                j++;
            }
            return netWorkDays.toString();
        };
        this.computeNow = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argList != "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            return new Date(Date.now()).toString();
        };
        this.computeSecond = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var time;
            var dt = new Date(Date.now());
            argList = this.getValueFromArg(argList);
            argList = argList.split(this.tic).join("");
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;
            dt = new Date(Date.parse(argList));
            if (argList < 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[4].toString();
            }
            if (dt.toString() == "Invalid Date") {
                var argVal = (new Date(Date.now())).toLocaleDateString() + " " + argList;
                dt = new Date(Date.parse(argVal));
            }
            if (dt.toString() == "Invalid Date") {
                dt = this._fromOADate(argList);
            }
            if (dt.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            return dt.getSeconds().toString();
        };
        this.computeTime = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            args[0] = this.getValueFromArg(args[0]);
            args[1] = this.getValueFromArg(args[1]);
            args[2] = this.getValueFromArg(args[2]);

            args[0] = (args[0] == "") ? "0" : args[0];
            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = (args[1] == "") ? "0" : args[1];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            args[2] = (args[2] == "") ? "0" : args[2];
            args[2] = (args[2].split(this.tic).join("") == "TRUE") ? "1" : (args[2].split(this.tic).join("") == "FALSE") ? "0" : args[2];

            var hour = this._parseDouble(args[0]);
            var minute = this._parseDouble(args[1]);
            var second = this._parseDouble(args[2]);
            var time = 0;
            if (!isNaN(hour) && !isNaN(minute) && !isNaN(second)) {
                time = (3600 * hour + 60 * minute + second) / 86400;
                var dateString = (new Date(Date.now())).toLocaleDateString() + " " + time;
                dt = new Date(Date.parse(dateString));
                if (time < 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_index];
                    return this.getErrorStrings()[4].toString();
                }
                return time.toString();
            }
            else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
        };
        this.computeTimevalue = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]).split(this.tic).join("");

            argValue = argValue.split(this.tic).join("");
            if (argValue.indexOf(":") > -1) {
                var date = new Date();
                var argValue = date.toLocaleDateString() + " " + argValue;
            }
            var dateTime = new Date(Date.parse(argValue));
            if (dateTime.toString() == "Invalid Date") {
                argList = (new Date(Date.now())).toLocaleDateString() + " " + argList;
                dateTime = new Date(Date.parse(argList));
            }
            if (dateTime.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            var time = (3600 * dateTime.getHours() + 60 * dateTime.getMinutes() + dateTime.getSeconds()) / 86400;
            return time.toString();
        };
        this.computeToday = function (argList) {
            if (argList != "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var dt = new Date(Date.now());

            if (this.getExcelLikeComputations()) {
                return dt.toLocaleDateString();
            } else
                return this._toOADate(dt).toString();
        };
       
        this.computeWeekday = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if ((argCount != 1 && argCount != 2) || argList == "") {
                 if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (args.length == 2) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString1 = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString1) > -1) {
                        return checkString1;
                    }
                }
            }
            var dateString = this.getValueFromArg(args[0]);

            dateString = (dateString.split(this.tic).join("") == "TRUE") ? "1" : (dateString.split(this.tic).join("") == "FALSE") ? "0" : dateString;
            var dt = new Date(Date.parse(dateString.split(this.tic).join("")));
            var dateValue = parseInt(dateString);
            if (!isNaN(dateValue) && dt.getFullYear() > 9999) {
                dt = this._fromOADate(dateValue);
            }
            args[1] = (argCount == 2) ? args[1] : "1";
            if (dt.toString() == "Invalid Date")
                dt = this._fromOADate(dateValue);
            var return_type = parseInt(this.getValueFromArg(args[1]));
            var day = dt.getDay();

            if (return_type == 1) {
                day += 1;
            } else {
                if (day == 0) {
                    day = 7;
                }

                if (return_type == 3) {
                    day -= 1;
                }
            }
            return day.toString();
        };
        this.computeWeeknum = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                if (argCount == 2) {
                    checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            if (args[0] == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[0].toString();
                return this.getErrorStrings()[0].toString();
            }
            var weekDate;
            if (this._fromOADate(this.DateFormatter(this.getValueFromArg(args[0]).split(this.tic).join(""))) == "Invalid Date")

                weekDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            else
                weekDate = this.DateFormatter(this.getValueFromArg(args[0]).split(this.tic).join(""));
            var weeknumber = parseInt(weekDate);
            var d = new Date(weekDate);
            var weekDateTime = new Date(Date.parse(weekDate));
           // weekDateTime = this._fromOADate(weekDateTime);

            if (weekDateTime.toString() == "Invalid Date")
            {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            var weekStart = ["", "0", "1", "", "", "", "", "", "", "", "", "1", "2", "3", "4", "5", "6", "0", "", "", "", "1"];

            var weektype ;
            if (argCount != 2) {
                weektype = 1;
            }
            else {
                weektype = this.getValueFromArg(args[1]);
                if (weektype == "")
                    weektype = 1;
            }
            if (Boolean(weektype == "TRUE" || weektype == "FALSE")) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }
            if (!isNaN(weektype)) {
            }
            var weehStartValue = parseInt(weekStart[weektype]);
            var firstDate = new Date(weekDateTime.getFullYear(), 0, 1);
            var firstDay = firstDate.getDate();
            var offset = (firstDay < weehStartValue) ? weehStartValue - firstDay + 1 : firstDay - weehStartValue;
            var dt = this._fromOADate(this._toOADate(firstDate) - offset);
            var noofDays = this._toOADate(weekDateTime) - this._toOADate(dt);
            var dval = Math.floor(noofDays / 7) +1 + weehStartValue;
            return dval.toString();
        };
        this.computeWorkDay = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;

            if (argCount != 2 && argCount > 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                for (var i = 0; i < argCount; i++) {
                    if (i != 1) {
                        var checkString = this.formulaErrorStringCheck(args[i], FormulaArgumentType.Date);
                        if (this.getErrorStrings().indexOf(checkString) > -1) {
                            return checkString;
                        }
                    }
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            if (args[0] == "" || args[1] == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[0].toString();
            }
            var argString = "";
            var dateValue = 0;
            if (argCount == 3) {
                argString = args[0] + this.getParseArgumentSeparator() + args[1] + this.getParseArgumentSeparator() + "1" + this.getParseArgumentSeparator() + args[2];
            } else
                argString = args[0] + this.getParseArgumentSeparator() + args[1] + this.getParseArgumentSeparator() + "1";
            var value = this.computeWorkDayOintl(argString);

            var dateTime = new Date(Date.parse(this._fromOADate(value).toString()));

            if (isNaN(Date.parse(value)) && parseInt(value)) {
                dateTime = this._fromOADate(value);
            }

            if (dateTime.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[1].toString();
            }

            return this._toOADate(dateTime).toString();
        };
        this.computeWorkDayOintl = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;

            if (argCount > 4 || argCount < 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (args[0] == "" || args[1] == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[0].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                if (argCount >= 3) {
                    checkString = this.formulaErrorStringCheck(args[2], FormulaArgumentType.Text);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                if (argCount == 4) {
                    checkString = this.formulaErrorStringCheck(args[3], FormulaArgumentType.Date);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            var adjustRange, s1;
            var date;
            var holidays = [];

            var startDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            var startDateTime = new Date(Date.parse(startDate));

            var temp = this.getValueFromArg(args[1]).split(this.tic).join("");
            var dateval;

            if (!isNaN(Date.parse(startDate)) && parseInt(startDate)) {
                startDateTime = this._fromOADate(startDate);
            }

            if (isNaN(temp)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[1].toString();
            } else {
                dateval = this._toOADate(startDateTime) + temp;
            }

            if (startDate.split(this.tic).join("") == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[0].toString();
            } else if (startDateTime.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[1].toString();
            }
            var totalDays = parseInt(temp.toString());
            if (argCount == 4) {
                adjustRange = args[3];
                adjustRange = this.adjustRangeArg(adjustRange);

                ////is a cellrange
                if (adjustRange.indexOf(':') > -1 || adjustRange.indexOf(',') > -1) {
                    var cells = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cells.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cells[s]).split(this.tic).join("");
                        } catch (ex) {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.formulaErrorStrings[this.bad_formula];
                            return this.getErrorStrings()[4].toString();
                        }

                        if (s1 != "") {
                            var dt = new Date(Date.parse(s1));
                            if (dt.toString() != "Invalid Date" && holidays.indexOf(dt) == -1 && dt > startDateTime) {
                                holidays.push(dt.toString());
                            }
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(adjustRange).split(this.tic).join("");
                    } catch (Exception) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this.bad_formula];
                        return this.getErrorStrings()[4].toString();
                    }

                    if (s1 != "") {
                        var dt = new Date(Date.parse(s1));

                        if (isNaN(Date.parse(s1)) && parseInt(s1)) {
                            dt = this._fromOADate(s1);
                        }

                        if (dt.toString() != "Invalid Date" && holidays.indexOf(dt) == -1 && dt > startDateTime) {
                            holidays.push(dt);
                        }
                    }
                }
            }
            
            var weekend = parseInt(args[2]);
            if (!(argCount > 2 && !isNaN(weekend))) {
                weekend = 1;
            }
            if (weekend == 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            var weekendDays = this._splitArguments(_weekEndType[weekend].toString(), ",");
            var j = 0;
            var tempStartDate = startDateTime;
            if (totalDays < 0) {
                while (j > totalDays) {
                    tempStartDate = new Date(tempStartDate.setDate(tempStartDate.getDate() - 1));
                    var dayofweek = tempStartDate.getDay();
                    if (weekendDays.indexOf(dayofweek.toString()) < 0 && holidays.indexOf(tempStartDate) < 0) {
                        j--;
                    }
                }
            } else {
                while (j < totalDays) {
                    tempStartDate = new Date(tempStartDate.setDate(tempStartDate.getDate() + 1));
                    var dayofweek = tempStartDate.getDay();
                    if (weekendDays.indexOf(dayofweek.toString()) < 0 && holidays.indexOf(tempStartDate.toString()) < 0) {
                        j++;
                    }
                }
            }
            return this._toOADate(tempStartDate).toString();
        };
        this.computeYear = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;

            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Date);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var startDate = this.getValueFromArg(args[0]).split(this.tic).join("");
            startDate = (startDate.split(this.tic).join("") == "TRUE") ? "1" : (startDate.split(this.tic).join("") == "FALSE") ? "0" : startDate;
            var startDateTime = new Date(Date.parse(startDate));
            var dateValue = parseInt(startDate);
            if (!isNaN(dateValue) && startDateTime.getFullYear() > 9999) {
                startDateTime = this._fromOADate(dateValue);
            }
            if (dateValue == 0) {
                return "1900";
            }
            if (dateValue < 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            if (startDate.split(this.tic).join("") == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[0].toString();
            } else if (startDateTime.toString() == "Invalid Date") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this.bad_formula];
                return this.getErrorStrings()[1].toString();
            }

            return startDateTime.getFullYear().toString();
        };


        this.computeChar = function (arg) {
            var ranges = this.splitArgsPreservingQuotedCommas(arg);
            var argCount = ranges.length;
            if (argCount != 1 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s = this.getValueFromArg(ranges[0]).split(this.tic).join("");
            s = (s.split(this.tic).join("") == "TRUE") ? "1" : (s.split(this.tic).join("") == "FALSE") ? "0" : s;
            var i = this._parseDouble(s);
            if (!isNaN(i) && i > 0 && i < 256) {
                return String.fromCharCode(s);
            }
            else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getLibraryComputationException();
                return this._errorStrings[1].toString();
            }
            if (this.getErrorStrings().indexOf(s) > -1) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return s;
            }
            return s;
        };
        this.computeCode = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var text = this.getValueFromArg(args[0]).split(this.tic).join("");
            var num =  parseInt(text);
            if (!isNaN(num))
            {
                return text.charCodeAt(0).toString();
            }
            if (text == null || text == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return (args[0].length > 4) ? this.getErrorStrings()[5].toString() : this.getErrorStrings()[1].toString();
            }
            var code = text;

            return code.charCodeAt(0).toString();
        };
        this.computeUniCode = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var text = this.getValueFromArg(args[0]);
            if (this._isCellReference(args[0])) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }
            var str = this._parseDouble(text);
            if (text == "invalid expression" || text == null || text == ""){
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[1].toString();
            }
            var unicodeString = text.split(this.tic).join("").charCodeAt(0);
            return unicodeString.toString();
        };
        this.computeUpper = function (args) {

            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            return this._stripTics0(this.getValueFromArg(args)).toUpperCase();
        };
        this.computeLower = function (args) {

            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            return this._stripTics0(this.getValueFromArg(args)).toLowerCase();
        };
        this.computeLen = function (range) {

            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 1 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }            
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s1 = this._stripTics0(this.getValueFromArg(args[0]));

            if(isNaN(parseInt(s1))){
                var dt = new Date(Date.parse(s1));
                if (dt != "Invalid Date") {
                    s1 = this.DateFormatter(s1);
                }
            }
            var hasTics = s1[0] == this.tic && s1[s1.length - 1] == this.tic;
            return (hasTics ? s1.length - 2 : s1.length).toString();
        };
        this.computeMid = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 3 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[2], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s1 = args[0];
            s1 = this.getValueFromArg(s1);
            var hasTics = s1[0] == this.tic && s1[s1.length - 1] == this.tic;
            var s2 = this.getValueFromArg(args[1]);
            var len = this._parseDouble(args[2]);
            s2 = this.getValueFromArg(args[1]);
            var start = Number(s2) + Number(hasTics ? 0 : -1);

            if (s2 == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            if (args[1].indexOf("#VALUE!") > -1) {
                return "#VALUE!";
            }
            if (Number(start) > s1.length) {
                return "";
            }
            if (start + len > s1.length) {
                s1 = s1.substring(start);
            }
            else
                s1 = this._substring(s1, start, len);
            if (hasTics && s1[0] != this.tic) {
                s1 = this.tic + s1;
            }

            if (hasTics && s1) {
                s1 = s1 + this.tic;
            }

            return this._stripTics0(s1);
        };
        this.computeLeft = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if ((argCount != 1 && argCount != 2) || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.TextWithNumber);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var s1 = this._stripTics0(this.getValueFromArg(args[0]));
            if (!this._isCellReference(args[0]) && args[0].indexOf(this.tic) == -1) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }
            var hasTics = s1[0] == this.tic && s1[s1.length - 1] == this.tic;
            var s2 = (argCount == 2) ? args[1] : "1";
            s2 = this.computedValue(s2);
            s2 = (s2.split(this.tic).join("") == "TRUE") ? "1" : (s2.split(this.tic).join("") == "FALSE") ? "0" : s2;
            var len = Number(s2) + Number(hasTics ? 1 : 0);
            len = (s1.length >= len) ? len : s1.length;
            len = (s1.length >= len) ? len : s1.length;
            if (len < 0) {
                return this.getErrorStrings()[1].toString();
            }
            if (len == 0) {
                s1 = "";
            }
            else {
                s1 = s1.substring(0, len);
                if (hasTics && s1[s1.length - 1] != this.tic) {
                    s1 = s1 + this.tic;
                }
            }
            if (this.getUseNoAmpersandQuotes() && s1.length > 1 && s1[0] == this.tic[0] && s1[s1.length - 1] == this.tic[0]) {
                s1 = this._substring(s1,1, s1.length - 2);
            }
            return s1;
        };
        this.computeRight = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if ((argCount != 1 && argCount != 2) || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.TextWithNumber);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            s1 = this._stripTics0(this.getValueFromArg(args[0]));
            if (!this._isCellReference(args[0]) && args[0].indexOf(this.tic) == -1) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }
            var hasTics = s1[0] == this.tic && s1[s1.length - 1] == this.tic;
            var s2 = (argCount == 2) ? this.getValueFromArg(args[1]) : "1";
            s2 = (s2.split(this.tic).join("") == "TRUE") ? "1" : (s2.split(this.tic).join("") == "FALSE") ? "0" : s2;
            var len = parseInt(s2);
            if (isNaN(len) || len <0 || s2.indexOf("#VALUE!") > -1) {
                return "#VALUE!";
            }
            if (len == 0)
                return "";
            var len = Number(s2) + Number(hasTics ? 1 : 0);
            var start = (s1.length >= len) ? s1.length - len : 0;
            s1 = s1.substring(start);
            if (hasTics && s1[0] != this.tic) {
                s1 = this.tic + s1;
            }

            return s1;
        };
        this.computeReplace = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 4 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }

                var checkString1 = this.formulaErrorStringCheck(args[3], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString1) > -1) {
                    return checkString1;
                }
            }
            var firstText = this._stripTics0(this.getValueFromArg(args[0]));
            var newText = this._stripTics0(this.getValueFromArg(args[3]));
            var resultText = "";
            var startIndex = this.getValueFromArg(args[1]);
            startIndex = (startIndex == "TRUE") ? "1" : (startIndex == "FALSE") ? "0" : startIndex;
            startIndex = this._parseDouble(startIndex);
            var noOfChar = this.getValueFromArg(args[2]);
            noOfChar = (noOfChar == "TRUE") ? "1" : (noOfChar == "FALSE") ? "0" : noOfChar;
            noOfChar = this._parseDouble(noOfChar);
            if ((!this._isCellReference(args[0]) && args[0][0] != this.tic) || (!this._isCellReference(args[3]) && args[3][0] != this.tic)) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }
            if (startIndex == 0 && noOfChar == 0)
            {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[1].toString();
            }
            if (!isNaN(startIndex) && !isNaN(noOfChar)) {
                try {
                    var replaceText = "";
                    if (firstText == null || firstText == "") {
                        return newText;
                    }
                    if (firstText.length <= startIndex && startIndex > noOfChar) {
                        resultText = firstText + newText;
                    } else if (firstText.length <= startIndex) {
                        replaceText = firstText;
                        resultText = firstText.split(replaceText).join(newText);
                    } else if (noOfChar == 0) {
                        resultText = newText + firstText;
                    }else {
                        replaceText = this._substring(firstText, startIndex - 1, noOfChar);
                        resultText = firstText.split(replaceText).join(newText);
                    }
                } catch (ex) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[1].toString();
                }
            } else {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[1].toString();
            }

            return resultText;
        };
        this.computeExact = function (range) {
            //this.AdjustRangeArg(ref range);
            var args = this.splitArgsPreservingQuotedCommas(range);
            if (args.length != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s1, s2, d;

            s1 = this.getValueFromArg(args[0]);
            s2 = this.getValueFromArg(args[1]);
            var str1 = this._parseDouble(s1);
            var str2 = this._parseDouble(s2);

            if (!isNaN(str1)) {
                s1 = str1.toString();
            }

            if (!isNaN(str2)) {
                s2 = str2.toString();
            }

            return (s1.split(this.tic).join("") == s2.split(this.tic).join("")) ? "TRUE" : "FALSE";
        };
        this.computeFind = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if ((args.length != 2 && args.length != 3) || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.TwoTextWithNumber);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            ////strip off outside tics (if any) on the evaluated arguments
            var lookFor = this._stripTics0(this.getValueFromArg(args[0]));
            var lookIn = this._stripTics0(this.getValueFromArg(args[1]));
            var start = 1;

            if (args.length == 3) {
                var s3 = this.getValueFromArg(args[2]);
                start = this._parseDouble(s3);
                if (isNaN(start)) {
                    start = 1;
                }
            }

            if (start <= 0 || start > lookIn.length) {
                return "#VALUE!";
            }

            var loc = lookIn.indexOf(lookFor, start - 1);
            if (loc < 0) {
                return "#VALUE!";
            }

            return (Number(loc) + Number(1)).toString();
        };
        this.computeSearch = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var index;
            var startNum = 1;
            if ((argCount != 2 && argCount != 3) || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.TwoTextWithNumber);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var firstStr = this._stripTics0(this.getValueFromArg(args[0])).toUpperCase();
            var secondStr = this._stripTics0(this.getValueFromArg(args[1])).toUpperCase();
            if ((!this._isCellReference(args[0]) && args[0][0] != this.tic) || (!this._isCellReference(args[1]) && args[1][0] != this.tic)) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }

            var qusfirstStr = firstStr;
            if (firstStr.indexOf("*") >-1)
            {
                firstStr = firstStr.split("*").join("")[0].toString();
            }
            else if (firstStr.indexOf("?") >-1)
            {
                var subStr = qusfirstStr.substring(0, qusfirstStr.indexOf("?"));
                var strIndex = Number(secondStr.indexOf(subStr));
                while (secondStr.indexOf(qusfirstStr) == -1)
                {
                    strIndex = Number(secondStr.substring(strIndex).indexOf(subStr)) + Number(strIndex) + 1;
                    qusfirstStr = firstStr;
                    while (qusfirstStr.indexOf("?") != -1)
                    {
                        if (secondStr.length <= strIndex)
                            return this.getErrorStrings()[1].toString();
                        qusfirstStr = qusfirstStr.substring(0, qusfirstStr.indexOf("?")) + secondStr[strIndex] + firstStr.substring(qusfirstStr.indexOf("?") + 1);
                        strIndex++;
                    }
                }
                firstStr = qusfirstStr;
            }
            index = Number(secondStr.indexOf(firstStr)) + 1;
            if (argCount == 3) {

                var startNum = parseInt(this.getValueFromArg(args[2]));
                if (startNum == 1 && firstStr[0] == secondStr[0])
                {
                    return startNum;
                }
                if (!isNaN(startNum)) {
                    try {
                        index = Number(secondStr.indexOf(firstStr, startNum)) + 1;
                    } catch (ex) {
                        return this.getErrorStrings()[1].toString();
                    }
                }
            }
            if (index == 0) {
                return this.getErrorStrings()[1].toString();
            }

            return index.toString();
        };
        this.computeSubstitute = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            if (args.length != 3 && args.length != 4) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                for (var i = 0; i < 3; i++) {
                    var checkString = this.formulaErrorStringCheck(args[i], FormulaArgumentType.Text);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            if (args.length == 4) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(args[3], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }

            }
            ////strip off outside tics (if any) on the evaluated arguments
            var s1 = this._stripTics0(this.getValueFromArg(args[0]));
            var s2 = this._stripTics0(this.getValueFromArg(args[1]));
            var s3 = this._stripTics0(this.getValueFromArg(args[2]));
            if (args.length == 3) {
                if(s2=="" || s2==null)
                {
                    return s1;
                }
                s1 = s1.split(s2).join(s3);
            } else {
                var s4 = this.getValueFromArg(args[3]);
                if (!this._isCellReference(args[3]) && args[3][0] == this.tic) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[5].toString();
                }
                var d = parseInt(s4)

                if (!isNaN(d)) {
                    var count = d;
                    var loc = -1;
                    while (count > 0 && (loc = s1.indexOf(s2, Number(loc) + 1)) > -1) {
                        count--;
                    }
                    if (count == 0) {
                        s1 = s1.substring(0, loc) + s3 + s1.substring(Number(loc) + Number(s2.length));
                    }
                }
            }
            return  s1;
        };
        this.computeUniChar = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var text = this.getValueFromArg(args[0]);
            text = (text.split(this.tic).join("") == "TRUE") ? "1" : (text.split(this.tic).join("") == "FALSE") ? "0" : text;
            var code = this._parseDouble(this._stripTics0(text));
            if (isNaN(code) || code <=0) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return (text[0] == this.tic) ? this.getErrorStrings()[5].toString() : this.getErrorStrings()[1].toString();
            }
            var unicharString = String.fromCharCode(text);
            return unicharString.toString();
        };
        this.computeClean = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            var result;
            if (args.length != 1 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var cleanedArg = this.getValueFromArg(args[0]);
            var isLogic = true;
            var boolFlag = (cleanedArg == "TRUE" || cleanedArg == "FALSE") ? true : false;
            if (this.getErrorStrings().indexOf(cleanedArg) > -1)
            {
                return cleanedArg;
            }
            if (cleanedArg.indexOf(this.tic) == -1 && !this._isCellReference(arg) && isNaN(this._parseDouble(cleanedArg)) && !boolFlag) {
                return this.getErrorStrings()[5].toString();
            }
            for (var i = 0; i <= 31; i++) {
                var nonPrintChar = this.computeChar(i.toString());
                if (cleanedArg.indexOf(nonPrintChar) > -1)
                    cleanedArg = cleanedArg.replace(nonPrintChar, "");
            }
            if (cleanedArg[0] == this.tic && cleanedArg[cleanedArg.length - 1] == this.tic) {
                cleanedArg = this._substring(cleanedArg, 1, cleanedArg.length - 1);
            }
            return cleanedArg;
        };
        this.computeTrim = function (args) {
            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList.length != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s = this._stripTics0(this.getValueFromArg(args));
            var arr = [this.tic, ''];
            s = s.split(this.tic).join("");
            var len = 0;
            while (s.length != len) {
                len = s.length;
                s = s.split("  ").join(" ");
            }

            return s;
        };
        this.computeRept = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.TextWithNumber);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var text = this._stripTics0(this.getValueFromArg(args[0]));
            var repeatTime = 1;
            args[1] = this.getValueFromArg(args[1].split(this.tic).join(""));
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            if (text == null || text == "" || args[1] == null || args[1] == "") {
                return "";
            }
            var value = parseInt(args[1].split(this.tic).join(""));
            if (value < 0 || isNaN(value)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            var reptString = "";
            for (var i = 0; i < value ; i++) {
                if (reptString.length > 32767) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_index];
                    return this.getErrorStrings()[1].toString();
                }
                reptString = reptString.concat(text);
            }

            return reptString;
        };
        this.computeProper = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var textValue = this.getValueFromArg(args[0]);
            if (!this._isCellReference(args[0]) && args[0][0] != this.tic) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }
            var text = this._stripTics0(textValue);

            var quoteIndex = text.indexOf("'");

            if (quoteIndex >= 0 && quoteIndex < text.length - 1) {
                text = text.replace(/[']/, " '");
            }
            if (/[^a - zA - Z]/.test(text)) {

                text = text.replace(/\w\S*/g, function (text) {
                    var i = 0;
                    var charCode = (text[i].toString().toUpperCase()).charCodeAt(0);
                    while (!(charCode > 64 && charCode < 91))
                    {
                        i++;
                        if (text[i] != undefined)
                            charCode = (text[i].toUpperCase()).charCodeAt(0);
                        else
                        {
                            i--;
                            charCode = 0;
                        }
                    }
                    return text.substr(0, i) + text.charAt(i).toUpperCase() + text.substr(i + 1).toLowerCase();
                });
            }
            else if (/[a - zA - Z0 - 9] + $/.test(text)) {
                text = text.replace(/[^a-zA-Z0-9_\\]/, "");
            }

            return text;

            if (text == null || text == "") {
                return "";
            }
            text = text[0].toUpperCase() + text.slice(1).split(" '").join("'");
            return text.toString();
        };
        this.computeT = function (args) {
            var elements = 0;
            var arg = this.splitArgsPreservingQuotedCommas(args);
            if (arg.length > 1) {
                for (var r = 0; r < arg.length; r++) {
                    elements++;
                    if (arg[r].indexOf(':') > -1) {
                        --elements;
                        var cells1 = this.getCellsFromArgs(r);
                        for (var s1 = 0; s1 < cells1.length; s1++) {
                            elements++;
                        }
                    }
                }
            }
            if (elements > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s = this.getValueFromArg(args);
            var d;
            var pattern = /[a-zA-Z0-9!#$%&'()*+,/:;<=>?@\^_`{|}~-]/;
            var flag = (s == "TRUE" || s == "FALSE") ? true : false;
            if (!isNaN(this._parseDouble(s)) || flag || !isNaN(this._isDate(s))) {
                return " ";
            } else if (/[a-zA-Z0-9!#$%&'()*+,/:;<=>?@\^_`{|}~-]/.test(s)) {
                s = this._stripTics0(s);
                return s;
            } else {
                return " ";
            }
        };

        this.computeNumberValue = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var decimalseparator = this._parseDecimalSeparator;
            var groupseparator = this._parseArgumentSeparator;
            if (argCount > 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var text = this._stripTics0(this.getValueFromArg(args[0]));
            if (argCount > 1) {
                try {
                    var deci = (args.length > 1 && args[2] != null) ? this._stripTics0(this.getValueFromArg(args[1])) : groupseparator;
                    var gro = (args.length > 1 && args[2]!=null) ? this._stripTics0(this.getValueFromArg(args[2])) : decimalseparator;
                    if ((deci == "invalid expression" || gro == "invalid expression") || ((deci == null || deci == "") && (gro == null || gro == ""))) {
                        if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                            throw this.getLibraryComputationException();
                        return this.getErrorStrings()[1].toString();
                    } else {
                        decimalseparator = this._stripTics0(deci)[0];
                        groupseparator = this._stripTics0(gro)[0];
                    }
                } catch (ex) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
            }
            if (text == "" || text == null) {
                return "0";
            }
            var indexDecimal = text.indexOf(decimalseparator);
            var indexGroup = text.indexOf(groupseparator);
            if ((indexGroup >= indexDecimal) && (indexDecimal != -1 || indexGroup != -1) && args.length>2) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[1].toString();
            }
            text = text.replace(this.tic, "");
            text = text.replace(" ", "");
            text = text.replace(groupseparator.toString(), "");
            text = text.replace(decimalseparator, this._parseDecimalSeparator);
            var compText = this.computeValue(text);
            if (isNaN(compText) || (text[text.length - 1] == "$")) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[1].toString();
            }
            return compText;
        };
        this.computeConcatenate = function (range) {
            var text = "";
            var ar = this.splitArgsPreservingQuotedCommas(range);
            if (!range || range.length == 0){
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var r = 0; r < ar.length; r++) {
                if ((this._isCellReference(ar[r]) && ar[r].indexOf(":") != -1)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
                var toAppend = ar[r];
                text = text.concat(this._stripTics0(this.getValueFromArg(ar[r])));
            }
            if (text.indexOf("#N/A") > -1) {
                text = "#N/A";
            }
            return text;
        };
        this.computeValue = function (range) {
            var val = "";
            try {
                var args = this.splitArgsPreservingQuotedCommas(range);
                var argCount = args.length;
                if (argCount != 1 || range == "") {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.formulaErrorStrings[this._wrong_number_arguments];
                }
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Text);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                var s1 = args[0];
                var ticContains = false;
                var quotation = false;
                if (s1.indexOf(this.tic) > -1)
                    ticContains = true;
                s1 = this._stripTics0(this.getValueFromArg(s1));
                if ((s1 != null || s1 != "") && !this._isCellReference(s1) && ticContains && isNaN(this._parseDouble(s1.split(",").join("").split("$").join("")))) {
                    s1 = s1.split(this.tic).join("");
                    quotation = true;
                }
                if (!this._isCellReference(args[0]) && args[0].indexOf(this.tic) == -1 && isNaN(this._parseDouble(s1))) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[5].toString();
                }
                if ((s1 == null || s1 == "") && ticContains) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                } else if ((s1 == null || s1 == "") && !ticContains) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.formulaErrorStrings[this._invalid_arguments];
                }
                if (s1.indexOf(":") > -1) {
                    val = this.computeTimevalue(s1);
                    return val.toString();
                }
                if (s1[0] == "$") {
                    s1 = s1.split("$").join("");
                }
                if (s1.indexOf(",") > -1) {
                    s1 = s1.split(",").join("");
                }
                if (s1[0] == "%" || s1[s1.length - 1] == "%") {
                    s1 = s1.split("%").join("");
                    var per = this._parseDouble(s1);
                    if (!isNaN(per)) {
                        s1 = (per / 100).toString();
                    }
                }
                var dt = new Date(Date.parse(s1));
                var dous = this._parseDouble(s1);
                if (!isNaN(dous)) {
                    val = dous.toString();
                } else if (dt.toString() != "Invalid Date") {
                    val = this._toOADate(dt);
                } else {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
            } catch (ex) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[1].toString();
            }

            return val.toString();
        };
        this.computeDollar = function (args) {
            var argsArray = this.splitArgsPreservingQuotedCommas(args);
            var s1 = argsArray[0];
            var s2 = "2";
            if (argsArray.length == 2) {
                s2 = argsArray[1];
            }
            if (argsArray.length > 2 || args == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            s1 = this.getValueFromArg(s1);
            s1 = (s1 == "" || s1 == null) ? "0" : s1;
            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
            s2 = this.getValueFromArg(s2);
            s2 = (s2 == "" || s2 == null) ? "0" : s2;
            s2 = (s2.split(this.tic).join("") == "TRUE") ? "1" : (s2.split(this.tic).join("") == "FALSE") ? "0" : s2;
            var number = this._parseDouble(s1);
            var emptyCell = false;
            if ( isNaN(this._parseDouble(s2))) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[5].toString();
            }
            if ((s1 == null || s1 == "") && this._isCellReference(argsArray[0]) && (s1[0] != this.tic && s1[s1.length - 1] != this.tic))
            {
                number=0;
                emptyCell=true;
            }            
            if (isNaN(number) && !emptyCell) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[1].toString();
            }
            var decimals = this._parseDouble(s2);
            var round = 0.0;
            if (isNaN(decimals)) {
                decimals = (s2 == "") ? 0 : 2;
            }
            if (decimals > 0) {
                return ej.format(number, "c" + decimals);
            }
            else {
                var mult = Math.pow(10, -decimals);
                round = Math.round(number / mult) * mult;
                return ej.format(round, "c0");
            }
        };
        this.computeFixed = function (args) {
            var argsArray = this.splitArgsPreservingQuotedCommas(args);
            var s1 = argsArray[0];
            var s2 = "2";
            var s3 = "FALSE";

            if (argsArray.length > 3 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argCount = argsArray.length;
            if (argCount > 1) {
                s2 = argsArray[1];
            }

            if (argCount > 2) {
                s3 = argsArray[2];
            }

            s1 = this.getValueFromArg(s1);
            s2 = this.getValueFromArg(s2);
            s3 = this.getValueFromArg(s3);
            s1 = (s1 == "" || s1 == null) ? "0" : s1;
            s2 = (s2 == "" || s2 == null) ? "0" : s2;
            s3 = (s3 == "" || s3 == null) ? "0" : s3;

            var numbers, decimals;
            numbers = this._parseDouble(s1);
            decimals = this._parseDouble(s2);
            if (isNaN(decimals)) {
                decimals = 2;
            }
            var no_commas_flag;
            var no_commas;
            no_commas_flag = this._parseDouble(s3);
            if (!isNaN(no_commas_flag)) {
                if (no_commas_flag == 0) {
                    no_commas = false;
                } else {
                    no_commas = true;
                }
            } else {
                if (s3.toUpperCase() == this.falseValueStr) {
                    no_commas = false;
                } else {
                    if (s3.toUpperCase() == this.trueValueStr) {
                        no_commas = true;
                    } else {
                        return "#NAME?";
                    }
                }
            }
            if (no_commas)
            {
               ej.preferredCulture().numberFormat[","] = "";
            }
            if (decimals > 0) {
                return ej.format(numbers, "n" + decimals)
            } else {
                var mult = Math.pow(10, -decimals);
                numbers = Math.round(numbers / mult) * mult;
                return ej.format(numbers, "n0");
            }
        };
        this.computeBin2Dec = function (argList) {
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            if (ranges.length > 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var value = this.getValueFromArg(ranges[0]).replace(this.tic, "");
            if (!/^[01]{1,10}$/.test(value))
                return this.getErrorStrings()[4].toString();
            try {
                if (value == "")
                    value = "0";

                // Convert binary number to decimal
                var result = parseInt(value, 2);

                // Handle negative numbers
                if (value.length == 10 && value.substring(0, 1) == "1") {
                    return (parseInt(value.substring(1), 2) - 512).toString();
                } else {
                    return result.toString();
                }
            } catch (Exception) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.getErrorStrings()[1].toString();
            }
        };
        this.computeBin2Oct = function (argList) {
            var charCount = 0;
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var number = this.getValueFromArg(ranges[0]).replace(this.tic, "");
            var result = "";
            // Return error if number is not binary or contains more than 10 characters (10 digits)
            if (!/^[01]{1,10}$/.test(number))
                return this.getErrorStrings()[4].toString();

            if (ranges.length > 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.formulaErrorStrings[this._wrong_number_arguments];
            } else if (ranges.length > 1) {
                places = parseInt(this.getValueFromArg(ranges[1]).replace(this.tic, ""));
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            // Ignore places and return a 10-character octal number if number is negative
            var value = ranges.toString();
            if (value.length == 10 && value.substring(0, 1) == "1") {
                var i = 10;
                var s = "";
                for (var j = 0; j < 3; j++) {
                    i = i - 3;
                    var rmv = this._substring(value, i ,3)
                    var valResult = this._parseDouble(parseInt(rmv, 2).toString(8));
                    var sum = 0;
                    for (var n = valResult; n > 0; sum += parseInt(n % 10), n = parseInt(n / 10));
                        s = sum.toString() + s;
                }
                return "7777777" + s;
            }

            //try {
            //    if (value.length > 10) {
            //        if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
            //            throw this.getLibraryComputationException();
            //        else
            //            return this.getErrorStrings()[4].toString();
            //    } else {
            //        result = parseInt(value, 2).toString(8);
            //        if (ranges.length > 1) {
            //            if (charCount >= result.length && charCount <= 10) {
            //                result = this._padLeft('0', charCount, result);
            //            } else {
            //                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
            //                    throw this.getLibraryComputationException();
            //                else
            //                    result = this.getErrorStrings()[4].toString();
            //            }
            //        }
            //    }
            //} catch (Exception) {
            //    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
            //        throw this.getLibraryComputationException();
            //            result = this.getErrorStrings()[5].toString();
            //    }

            // Ignore places and return a 10-character octal number if number is negative
            if (number < 0) {
                return (1073741824 + number).toString(8);
            }

            // Convert decimal number to octal
            var result = parseInt(number, 10).toString(8);

            // Return octal number using the minimum number of characters necessary if places is undefined
            if (typeof places === 'undefined') {
                return result;
            } else {
                // Return error if places is nonnumeric
                if (isNaN(places)) return '#VALUE!';

                // Return error if places is negative
                if (places < 0) return '#NUM!';

                // Truncate places in case it is not an integer
                places = Math.floor(places);

                // Pad return value with leading 0s (zeros) if necessary (using Underscore.string)
                if (places >= result.length && places <= 10) {
                    while (places- result.length > 0) {
                        result = "0" + result;
                        places--;
                    }
                }
                else
                    if (this.getRethrowLibraryComputationExceptions())
                        throw new this.getErrorStrings()[4].toString();
                    
                return  result;
            }
            //return result;
        };
        this.computeBin2Hex = function (argList) {
            var charCount = 0;
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var value = this.getValueFromArg(ranges[0]).replace(this.tic, "");
            var result = "";

            if (ranges.length > 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.formulaErrorStrings[this._wrong_number_arguments];
            } else if (ranges.length > 1) {
                charCount = this._parseDouble(ranges[1]);
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            if (value == "1111111111") {
                return value.replace('1', 'F');
            }

            // Ignore places and return a 10-character octal number if number is negative
            if (value.length == 10 && value.substring(0, 1) == "1") {
                return (1073741312 + parseInt(value, 2).toString(8)).toString();
            }

            try {
                if (value.length > 10 || this._parseDouble(value) < 0 || isNaN(value)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[4].toString();
                } else {
                    result = parseInt(value, 2).toString(16);
                    if (result == "NaN") {
                        result = this.getErrorStrings()[4].toString();
                    }
                    if (ranges.length > 1) {
                        if (charCount >= result.length && charCount <= 10) {
                            result = this._padLeft('0', charCount, result);
                        } else {
                            if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                throw this.getLibraryComputationException();
                            else
                                result = this.getErrorStrings()[4].toString();
                        }
                    }
                }
            } catch (Exception) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else {
                    if (this.computeIsText(value) == this.trueValueStr)
                        result = this.getErrorStrings()[5].toString();
                    else if (value == "")
                        return "0";
                    else
                        return this.getErrorStrings()[4].toString();
                }
            }

            return result.toUpperCase();
        };
        this.computeDec2Bin = function (argList) {
            var charCount = 0;
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var value = this.getValueFromArg(ranges[0]).replace(this.tic, "");
            var range1 = (ranges.length > 1) ? this.getValueFromArg(ranges[1]).replace(this.tic, "") : "10";
            var result = "";
            if (argList == null || argList == "" || ranges.length > 2 || ranges.length < 1) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            // double d1, d2;
            if (isNaN(this._parseDouble(value)) && isNaN(this._parseDouble(range1))) {
                if (((value != null || value != "") && (this.computeIsText(value) == this.trueValueStr)) || ((range1 != null || range1 != "") && (this.computeIsText(range1) == this.trueValueStr))) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
                if (((value != null && value != "") && (this.computeIsText(value) == this.falseValueStr)) || ((value != null && value != "") && (this.computeIsText(range1) == this.falseValueStr))) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
                if ((value == null && value == "") || (range1 == null || range1 == "")) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
            }
            try {
                if (ranges.length > 1) {
                    var value1 = this.getValueFromArg(ranges[1]).replace(this.tic, "");
                    charCount = this._parseDouble(value1);
                }

                if (isNaN(value1)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
                if ((this._parseDouble(value) < -512 || this._parseDouble(value) > 511)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[4].toString();
                } else {
                    result = (value>>>0).toString(2); //BaseToBase(value, 10, 2);
                    if (!isNaN(this._parseDouble(value)) && this._parseDouble(value) < 0) {
                        result = result.substring(result.length - 10);
                    }
                    if (ranges.length > 1) {
                        if (charCount > 10) {
                            if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                throw this.getLibraryComputationException();
                            return this.getErrorStrings()[4].toString();
                        }
                        if (charCount <= 10)
                            result = this._padLeft('0', charCount, result);
                    }
                }
            } catch (Exception) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
            }
            return result;
        };
       
        this.computeDec2Oct = function (argList) {
            var charCount = 0;
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var value = this.getValueFromArg(ranges[0]).replace(this.tic, "");
            var range1 = (ranges.length > 1) ? this.getValueFromArg(ranges[1]).replace(this.tic, "") : "10";
            var result = "";
            if (argList == null || argList == "" || ranges.length > 2 || ranges.length < 1) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (!(!isNaN(this._parseDouble(value)) && !isNaN(this._parseDouble(range1)))) {
                if (((value != null || value != "") && (this.computeIsText(value) == this.trueValueStr)) || ((range1 != null || range1 != "") && (this.computeIsText(range1) == this.trueValueStr))) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }

                if (this.getErrorStrings().indexOf(value) > -1)
                    return value;
                if (this.getErrorStrings().indexOf(range1) > -1)
                    return range1;

                if (((value != null && value != "") && (this.computeIsText(value) == this.falseValueStr)) || ((value != null && value != "") && (this.computeIsText(range1) == this.falseValueStr))) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[1].toString();
                }
                if ((value == null && value == "") || (range1 == null || range1 == "")) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    return this.getErrorStrings()[0].toString();
                }
            }
            try {
                if (ranges.length > 1) {
                    var value1 = this.getValueFromArg(ranges[1]).replace(this.tic, "");
                    charCount = this._parseDouble(value1);
                }

                if ((this._parseDouble(value) < -536870912 || this._parseDouble(value) > 536870911)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[4].toString();
                } else if (this._parseDouble(value) < 0) {
                    result = parseInt((value) >>> 0, 10).toString(8);
                    if (!isNaN(this._parseDouble(value)) && this._parseDouble(value) < 0) {
                        result = result.substring(result.length - 10);
                    }
                }
                else {
                    result = parseInt(value, 10).toString(8);
                    if (!isNaN(this._parseDouble(value)) && this._parseDouble(value) < 0) {
                        result = result.substring(result.length - 10);
                    }
                    if (ranges.length > 1) {
                        if (charCount > 10) {
                            if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                                throw this.getLibraryComputationException();
                            return this.getErrorStrings()[4].toString();
                        }
                        if (charCount <= 10)
                            result = this._padLeft('0', charCount, result);
                    }
                }
            } catch (Exception) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
            }
            return result;
        };
        this.computeHex2Bin = function (argList) {
            var charCount = 0;
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            if (ranges.length > 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (argList == this._parseArgumentSeparator.toString()) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[0].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(ranges[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (ranges.length == 2) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString1 = this.formulaErrorStringCheck(ranges[1], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString1) > -1) {
                        return checkString1;
                    }
                }
            }
            var value = this.getValueFromArg(ranges[0]);
            var chars = (ranges.length == 2) ? this.getValueFromArg(ranges[1]) : "0";

            var dChars = 0;
            dChars = this._parseDouble(chars);
            if (!isNaN(dChars) && (dChars < 0 || dChars > 10)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            if (Boolean(value == "TRUE" || value == "FALSE") || (ranges.length == 2 && (Boolean(chars == "TRUE" || chars == "FALSE")))) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            if (value != "") {
                if (value[0] != this.tic && !this._isCellReference(value) && isNaN(this._parseDouble(value))) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[5].toString();
                }
            } else if (this._isCellReference(ranges[0]) && value == "") {
                return "0";
            }
            if ((value[0] == this.tic) && (value.split(this.tic).join("") == null || value.split(this.tic).join("") == "")) {
                return "0";
            }
            if (chars[0] == this.tic) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[1].toString();
            } else if (isNaN(this._parseDouble(chars.split(this.tic).join("")))) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[5].toString();
            }
            charCount = this._parseDouble(chars);
            if (charCount < 0 || value[0] == "-") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[4].toString();
            }
            var result = "";
            value = value.split(this.tic).join("");
            try {
                for (var i = 0; i < value.length; i++) {
                    // Convert to decimal
                    var output = this._padLeft('0', 4, parseInt(value.charAt(i), 16).toString(2));
                    result += output;
                }
                if (value.split(this.tic).join("") == "FFFFFFFFFF") {
                    return this._parseDouble(value.split('F').join('1'));
                }

                if (result.length > 10 || charCount > 10 || (charCount < result.length && charCount != 0)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[4].toString();
                }

                if (charCount >= result.length)
                    result = this._padLeft('0', charCount, result);
                else if (charCount != 0) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[4].toString();
                }

                if (!isNaN(this._parseDouble(result)) && (this._parseDouble(result) > 536870911.0)) {
                    if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                        throw this.getLibraryComputationException();
                    else
                        return this.getErrorStrings()[4].toString();
                }
            } catch (ex) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[4].toString();
            }

            return result;
        };
        
        this.computeHex2Oct = function (argList) {
            var charCount = 0;
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            if (ranges.length > 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (argList == this._parseArgumentSeparator.toString()) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[0].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(ranges[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (ranges.length == 2) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString1 = this.formulaErrorStringCheck(ranges[1], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString1) > -1) {
                        return checkString1;
                    }
                }
            }
            var value = this.getValueFromArg(ranges[0]);
            ranges[0] = ranges[0].split(this.TIC).join("");
            var chars = (ranges.length == 2) ? this.getValueFromArg(ranges[1]) : "0";
            if (value != "") {
                if (value[0] != this.tic && !this._isCellReference(value) && isNaN(this._parseDouble(value))) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[5].toString();
                }
            }
            if (Boolean(value == "TRUE" || value == "FALSE") || (ranges.length == 2 && (Boolean(chars == "TRUE" || chars == "FALSE")))) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            if ((value[0] == this.tic) && (value.split(this.tic).join("") == null || value.split(this.tic).join("") == "")) {
                return "0";
            } else if (value.indexOf(this._parseArgumentSeparator.toString()) > -1) {
                var len = value.indexOf(this._parseArgumentSeparator);
                value = value.split(this.tic).join("").substring(0, len - 1);
            }
            var result = "";
            if (isNaN(this._parseDouble(chars.split(this.tic).join("")))) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[5].toString();
            }
            charCount = this._parseDouble(chars);
            if (charCount < 0 || value[0] == "-") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[4].toString();
            }
            if (ranges.length > 2) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else
                    return this.getErrorStrings()[4].toString();
            }

            if (ranges.length > 1)
                charCount = this._parseDouble(ranges[1]);
            try {
                value = value.split(this.tic).join("");
                result = parseInt(value, 16).toString(8);
                if (!isNaN(this._parseDouble(result)) && result.length > 10) {
                    result = result.substring(result.length - 10);
                }
                if (ranges.length > 1) {
                    if (charCount >= result.length && charCount <= 10)
                        result = this._padLeft('0', charCount, result);
                    else {
                        if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                            throw this.getLibraryComputationException();
                        else
                            return this.getErrorStrings()[4].toString();
                    }
                    if (!isNaN(this._parseDouble(result)) && (this._parseDouble(result) > 536870911.0)) {
                        if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                            throw this.getLibraryComputationException();
                        else
                            return this.getErrorStrings()[4].toString();
                    }
                }
            } catch (Exception) {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                else {
                    if (this.computeIsText(value) == this.trueValueStr)
                        return this.getErrorStrings()[4].toString();
                    else if (value == "")
                        return "0";
                    else
                        return this.getErrorStrings()[4].toString();
                }
            }
            return result;
        };
        this._padLeft = function (paddingChar, length, stringpad) {
            var strlen = stringpad.length;
            if ((stringpad.length < length) && (paddingChar.toString().length > 0)) {
                for (var i = 0; i < (length - strlen) ; i++)
                    stringpad = paddingChar.toString().charAt(0).concat(stringpad);
            }
            return stringpad;
        };


        this.computeAddress = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 5 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                for (var i = 0; i < argCount - 1; i++) {
                    var checkString = this.formulaErrorStringCheck(args[i], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                if (argCount == 5) {
                    checkString = this.formulaErrorStringCheck(args[4], FormulaArgumentType.Text);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            var ans = this._string_empty;
            var arg0 = this.getValueFromArg(args[0].split(this.tic).join(this._string_empty));
            arg0 = (arg0.split(this.tic).join("") == "TRUE") ? "1" : (arg0.split(this.tic).join("") == "FALSE") ? "0" : arg0;
            var arg1 = this.getValueFromArg(args[1].split(this.tic).join(this._string_empty));
            arg1 = (arg1.split(this.tic).join("") == "TRUE") ? "1" : (arg1.split(this.tic).join("") == "FALSE") ? "0" : arg1;
            if (arg0 == "" || arg1 == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }
            var row = this._parseDouble(arg0);
            var col = this._parseDouble(arg1);
            if (row < 1 || col < 1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }
            var absNum = (argCount > 2) ? this.getValueFromArg(args[2].split(this.tic).join(this._string_empty)) : "1";
            var temp = col;
            var rem = temp % 26;
            temp = parseInt(temp / 26);
            ans = ans + this._charTable[rem];
            ans = ans + this._charTable[parseInt(temp)];
            var arr = (ans.split('').join(',')).split(this.getParseArgumentSeparator());
            arr.reverse();
			//JS-44351 - Converting array to string in order to avoid the stack over flow.
            var ans1 = arr.join("");
            ans = '$' + ans1 + '$' + arg0;
            if (argCount > 2) {
                switch (absNum) {
                    case "":
                        break;
                    case "1":
                        break;
                    case "2":
                        ans = ans1 + '$' + arg0;
                        break;
                    case "3":
                        ans = '$' + ans1 + arg0;
                        break;
                    case "4":
                        ans = ans1 + arg0;
                        break;
                }
            }
            if (argCount > 3 && (this.getValueFromArg(args[3].split(this.tic).join(this._string_empty)) == "FALSE" || this.getValueFromArg(args[3].split(this.tic).join(this._string_empty)) == "0")) {
                switch (absNum) {
                    case "":
                        ans = "R" + row + "C" + col;
                        break;
                    case "1":
                        ans = "R" + row + "C" + col;
                        break;
                    case "2":
                        ans = "R" + row + "C[" + col + "]";
                        break;
                    case "3":
                        ans = "R[" + row + "]C" + col;
                        break;
                    case "4":
                        ans = "R[" + row + "]C[" + col + "]";
                        break;
                }
            }
            if ((argCount > 4 && this.getValueFromArg(args[4].split(this.tic).join(this._string_empty)) == this._string_empty)) {
                args[4] = this.getValueFromArg(args[4]);
                ans = args[4].split(this.tic).join(this._string_empty) + "!" + ans;
            }
            return ans;
        };
        this.computeAreas = function (arg) {
            if (arg.indexOf(" ") > 0) {
                arg = arg.substring(0, arg.indexOf(" "));
            }
            if (!this._isCellReference(arg) && !this.getNamedRanges().containsKey(arg) && !arg.indexOf(")")) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.formulaErrorStrings[this._invalid_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var args1;
            args1 = this._splitArguments(arg, ')');
            if (args1.length > 2) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.getErrorStrings()[1].toString();
            }
            var argument = args1[0].split("(").join(this._string_empty);
            var args;
            args = this.splitArgsPreservingQuotedCommas(argument);
            var argCount = args.length;
            for (var i = 0; i < args.length; i++) {
                if (!this._isCellReference(args[i])) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[5].toString();
                }
            }
            return args.length.toString();
        };
        this.computeChoose = function (arg) {
            var args;
            args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length < 2 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var s3 = this.getValueFromArg(args[0]).split(this.tic).join("");
            s3 = (s3.split(this.tic).join("") == "TRUE") ? "1" : (s3.split(this.tic).join("") == "FALSE") ? "0" : s3;
            var indexArgs = this.splitArgsPreservingQuotedCommas(s3);
            s3 = indexArgs[0];
            var loc = parseInt(s3);
            if (isNaN(loc) || loc > args.length - 1 || loc < 1) {
                return "#VALUE!";
            }
            if (this._isInteriorFunction)
            {
                this._isInteriorFunction = !this._isInteriorFunction;
                return args[loc];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[loc], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var value = this.getValueFromArg(args[loc]);
            if (value == "")
            {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[5].toString();
            }
            return value;
        };
        this.computeColumn = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length != 1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var rowInd, colInd;
            if (arg == null || arg == this._string_empty) {
                colInd = this.colIndex(this.cell).toString();
                rowInd = this.rowIndex(this.cell).toString();
                return colInd;
            }

            colInd =  this.colIndex(arg).toString();
            rowInd = this.rowIndex(arg).toString();
            if (rowInd <= 0 || !isNaN(this._parseDouble(arg)))
            {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[5].toString();
            }
            return colInd;
        };
        this.computeColumns = function (arg) {
            var args;
            args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length != 1 || arg == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var val = -1;
            if (this._parseDouble(args[0], val)) {
                return "1";
            } else if ((args[0].indexOf(this.tic) && !args[0].indexOf(";") && !args[0].indexOf(this.getParseArgumentSeparator().toString())) || (!this._isCellReference(args[0]) && !this.getNamedRanges().containsValue(args[0]) && !arg.indexOf(";") && !arg.indexOf(this.getParseArgumentSeparator().toString()))) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }

            var firstCol, LastCol, totalCols = 1;
            if (arg.indexOf(':') > -1) {
                var cells;
                cells = this.getCellsFromArgs(arg);
                firstCol = this.colIndex(cells[0].toString());
                LastCol = this.colIndex(cells[cells.length - 1].toString());
                totalCols = LastCol - firstCol + 1;
                totalCols = (totalCols > 0) ? totalCols : 1;
            } else if (arg.indexOf(';') > -1) {
                var arrayArg;
                arrayArg = this._splitArguments(arg.split(this.tic).join(this._string_empty), ';');
                for (var i = 1; i < arrayArg.length; i++) {
                    if (this.splitArgsPreservingQuotedCommas(arrayArg[i - 1]).length != this.splitArgsPreservingQuotedCommas(arrayArg[1]).length) {
                        if (this._rethrowLibraryComputationExceptions)
                            throw this.formulaErrorStrings[this._wrong_number_arguments];
                        return this.formulaErrorStrings[this._wrong_number_arguments];
                    }
                    totalCols = this.splitArgsPreservingQuotedCommas(arrayArg[0]).length;
                }
            } else {
                var arrayArg;
                arrayArg = this.splitArgsPreservingQuotedCommas(args[0].split(this.tic).join(this._string_empty));
                totalCols = arrayArg.length;
            }
            return totalCols.toString();
        };
        this.computeFormulaText = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var value = this._string_empty;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            value = this.getValueFromArg(args[0]);
            value = (value.split(this.tic).join("") == "TRUE") ? "1" : (value.split(this.tic).join("") == "FALSE") ? "0" : value;
            if (this.getNamedRanges().containsValue(value)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (args[0].indexOf(this.sheetToken) == -1 && this.isSheetMember() && family.parentObjectToToken != null) {
                args[0] = family.parentObjectToToken.getItem(this.grid) + args[0];
            }
            if (this.getFormulaInfoTable().containsKey(args[0])) {
                var formula = this.getFormulaInfoTable().getItem(args[0]);
                value = formula.getFormulaText();
                this.getFormulaText(value);
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._bad_formula];
                }
                return (this.rowIndex(args[0]) <= 0) ? this.getErrorStrings()[5].toString() : this.getErrorStrings()[0].toString();
            }

            return value;
        };
        this.computeHyperlink = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 2 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var firstStr = this._stripTics0(this.getValueFromArg(args[0]));
            if (argCount == 2) {
                var displayText = this._stripTics0(this.getValueFromArg(args[1]));

                if (displayText == null) {
                    return "0";
                }
                if (displayText == this._string_empty) {
                    return "0";
                }
                return displayText;
            }
            return firstStr;
        };
        this.computeAbs = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue.split(this.tic).join(""));
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            return Math.abs(dVal).toString();
        };
        this.computeAcos = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue);
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            if (dVal > 1 || dVal < -1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            return Math.acos(dVal).toString();
        };
        this.computeAcosh = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue);
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            z = Math.log(dVal + Math.sqrt(dVal * dVal - 1));
            if (dVal <= 0 || z == Infinity) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            return z.toString();
        };
        this.computeAcot = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(argList);
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;
            var d1 = this._parseDouble(argList), d2 = 0;

            if (!isNaN(d1)) {
                if (d1 <= 0) {
                    d2 = Math.PI / 2 - Math.atan(d1);
                }
                else {
                    d2 = Math.atan(1 / d1);
                }
            }
            return d2.toString();
        };
        this.computeAcoth = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue);
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[5].toString();
            }
            if (dVal < 1 && dVal > -1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            var acothVal = (Math.log((dVal + 1) / (dVal - 1)) / 2).toString();

            if (this.computeIsErr(acothVal) == this.trueValueStr)
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
            return this.getErrorStrings()[4].toString();

            return acothVal;
        };
        this.computeArabic = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length != 1 || arg == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var text = this.getValueFromArg(args[0]);
            if (this.getErrorStrings().indexOf(text) != -1) {
                return text;
            }
            var dvalue = parseInt(text.split(this.tic).join("").toUpperCase());
            if (!isNaN(dvalue) || (!this._isCellReference(args[0]) && args[0][0] != this.tic)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (!isNaN(dvalue)) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            text = text.split(this.tic).join("").toUpperCase()
            var i = 0;
            var ch = null;
            var result = 0;
            var new_value = 0;
            var old_value = 0;
            old_value = 1000;
            var isNegative = false;
            for (i = 1; i <= text.length; i++) {
                // See what the next character is worth.
                ch = this._substring(text, i - 1, 1);
                switch (ch) {
                    case "-":
                        isNegative = true;
                        break;
                    case "I":
                        new_value = 1;
                        break;
                    case "V":
                        new_value = 5;
                        break;
                    case "X":
                        new_value = 10;
                        break;
                    case "L":
                        new_value = 50;
                        break;
                    case "C":
                        new_value = 100;
                        break;
                    case "D":
                        new_value = 500;
                        break;
                    case "M":
                        new_value = 1000;
                        break;
                    default: {
                        if (this._rethrowLibraryComputationExceptions)
                            throw this.formulaErrorStrings[this._bad_formula];
                        return this.getErrorStrings()[1].toString();
                    }
                }

                // See if this character is bigger
                // than the previous one.
                if (new_value > old_value) {
                    // The new value > the previous one.
                    // Add this value to the result
                    // and subtract the previous one twice.
                    result = result + new_value - 2 * old_value;
                } else {
                    // The new value <= the previous one.
                    // Add it to the result.
                    result = result + new_value;
                }
                old_value = new_value;
            }
            if (isNegative)
                result = -result;
            return result.toString();
        };
        this.computeAsin = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue);
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            if (dVal > 1 || dVal < -1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            var d1 = this._parseDouble(argValue), d2 = 0;

            if (!isNaN(d1)) {
                d2 = Math.asin(d1);
            }
            return d2.toString();
        };
        this.computeAtan = function (args) {
            var argument = this.splitArgsPreservingQuotedCommas(args);
            if (argument.length > 1 || args == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            args = this.getValueFromArg(args);
            args = (args.split(this.tic).join("") == "TRUE") ? "1" : (args.split(this.tic).join("") == "FALSE") ? "0" : args;
            return this._computeMath(args, Math.atan).toString();
        };
        this.computeAtan2 = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var x;
            var y = 0;
            var atan2 = 0;
            var param1, param2;
            var flag1, flag2;
            param1 = this.getValueFromArg(args[0]);
            param2 = this.getValueFromArg(args[1]);
            param1 = (param1.split(this.tic).join("") == "TRUE") ? "1" : (param1.split(this.tic).join("") == "FALSE") ? "0" : param1;
            param2 = (param2.split(this.tic).join("") == "TRUE") ? "1" : (param2.split(this.tic).join("") == "FALSE") ? "0" : param2;

            flag1 = (param1 == "true") ? true : false;
            flag2 = (param2 == "true") ? true : false;

            if (flag1)
                param1 = (flag1).toString();
            else if (param1 == (this._string_empty))
                param1 = "0";
            if (flag2)
                param2 = flag2.toString();
            else if (param2 == (this._string_empty))
                param2 = "0";
            if (this.getErrorStrings().indexOf(param1) > -1) {
                return param1;
            }
            if (this.getErrorStrings().indexOf(param2) > -1) {
                return param2;
            }
            x = this._parseDouble(param1);
            y = this._parseDouble(param2);
            if (isNaN(x) || isNaN(y)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                else
                    return this.getErrorStrings()[1].toString();
            } else if (y == 0 && x == 0) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[3].toString();
                else
                    return this.getErrorStrings()[3].toString();
            }
            atan2 = Math.atan2(y, x);
            return atan2.toString();
        };
        this.computeCeilingMath = function (args) {
            var range = this.splitArgsPreservingQuotedCommas(args);
            var argCount = range.length;
            if (this._isTextEmpty(args) || argCount > 3 || argCount < 1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var range0 = this.getValueFromArg(range[0]);
            range0 = (range0.split(this.tic).join("") == "TRUE") ? "1" : (range0.split(this.tic).join("") == "FALSE") ? "0" : range0;
            var range1 = (argCount > 1 && range[1].length != 0) ? this.getValueFromArg(range[1]) : "1";
            range1 = (range1.split(this.tic).join("") == "TRUE") ? "1" : (range1.split(this.tic).join("") == "FALSE") ? "0" : range1;
            var range2 = (argCount == 3 && range[2].length != 0) ? this.getValueFromArg(range[2]) : "1";
            range2 = (range2.split(this.tic).join("") == "TRUE") ? "1" : (range2.split(this.tic).join("") == "FALSE") ? "0" : range2;

            var d1, d2 = -1, d3 = -1, result;
            var numberresult = false, signresult = false, moderesult = false;
            numberresult = (range0.split(this.tic).join(this._string_empty) == "true") ? true : false;
            signresult = (range1.split(this.tic).join(this._string_empty) == "true") ? true : false;
            moderesult = (range2.split(this.tic).join(this._string_empty) == "true") ? true : false;
            range0 = numberresult ? (numberresult).toString() : range0;
            range1 = signresult ? (signresult).toString() : range1;
            range2 = moderesult ? (moderesult).toString() : range2;

            if (this.getErrorStrings().indexOf(range0) != -1)
                return range0;
            if (this.getErrorStrings().indexOf(range1) != -1)
                return range1;
            if (this.getErrorStrings().indexOf(range2) != -1)
                return range2;
            if (range1.indexOf(" ") > -1) {

                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }
            else if (range1.startsWith(this.tic))
            {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[4].toString();
            }


            d1 = this._parseDouble(range0); //.split(this.tic).join(this._string_empty);
            d2 = this._parseDouble(range1); //.split(this.tic).join(this._string_empty);
            d3 = this._parseDouble(range2); //.split(this.tic).join(this._string_empty);
            if (isNaN(d1) && !isNaN(d2) && !isNaN(d3)) {
                if ((d1 == 0 && !this._isTextEmpty(range0) && (this.computeIsText(range0) == this.falseValueStr)) || (d2 == 0 && !this._isTextEmpty(range1) && (this.computeIsText(range1) == this.falseValueStr) || (d3 == 0 && !this._isTextEmpty(range2) && (this.computeIsText(range2) == this.falseValueStr)))) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._bad_index];
                    return this.getErrorStrings()[5].toString();
                }
                if ((this._isTextEmpty(range0.split(this.tic).join(this._string_empty)) && range0[0] == (this.tic)) || (this._isTextEmpty(range1.split(this.tic).join(this._string_empty)) && range1[1] == (this.tic)) || (this._isTextEmpty(range2.split(this.tic).join(this._string_empty)) && range2[2] == (this.tic))) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[1].toString();
                }
                if (this._isTextEmpty(range0.split(this.tic).join(this._string_empty)) || this._isTextEmpty(range1.split(this.tic).join(this._string_empty)) || this._isTextEmpty(range2.split(this.tic).join(this._string_empty))) {
                    return "0";
                }
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }

            if (d1 < 0 && d3 < 0) {
                d2 = -1;
            }

            if (d1 == 0 || d2 == 0) {
                return "0";
            }
            var divideResult = 0;
            d1 = this._parseDouble(d1.toString());
            if (d1 > 0) {

                d1+=.4999999999;
            }
            if (d1 < 0 && -0.5 >= d1 - parseInt(d1)) {
                d1 -= .4999999999;
            }
            d1 =  Math.round(d1);
            divideResult = Math.floor(d1 / d2);

            result = divideResult * d2;

            if (d1 < 0 && (d1 % 2 != 0)) {
                if (d3 == 0) {
                    result += d2;
                }
            }

            return result.toString();
        };
        this.computeCeiling = function (args) {
            var range = this.splitArgsPreservingQuotedCommas(args);
            var argCount = range.length;
            if (argCount != 2 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            range[0] = this.getValueFromArg(range[0]);
            var range0 = (argCount > 1) ? range[0] : "1";
            range0 = (range0 == null || range0 == "") ? "0" : range0;
            range0 = (range0.split(this.tic).join("") == "TRUE") ? "1" : (range0.split(this.tic).join("") == "FALSE") ? "0" : range0;
            range[1] = this.getValueFromArg(range[1]);
            var range1 = (argCount > 1 && range[1].length != 0) ? range[1] : "0";
            range1 = (range1 == "" || range1 == null) ? "0" : range1;
            range1 = (range1.split(this.tic).join("") == "TRUE") ? "1" : (range1.split(this.tic).join("") == "FALSE") ? "0" : range1;
            var numberresult = false, signresult = false;

            numberresult = (range0.split(this.tic).join(this._string_empty) == "true") ? true : false;
            signresult = (range1.split(this.tic).join(this._string_empty) == "true") ? true : false;
            range0 = numberresult ? numberresult.toString() : range0;
            range1 = signresult ? signresult.toString() : range1;

            if (range1 == this.trueValueStr)
                return "1";
            else if (range1 == this.falseValueStr)
                return "0";
            if (range1.indexOf(" ") > -1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_index];
                return this.getErrorStrings()[1].toString();
            }

            if (this.getErrorStrings().indexOf(range0) != -1)
                return range0;
            if (this.getErrorStrings().indexOf(range1) != -1)
                return range1;
            var d1, d2 = -1, d3 = -1;
            d1 = this._parseDouble(range0);
            d2 = this._parseDouble(range1);
            if (isNaN(d1) && !isNaN(d2)) {
                if ((d1 == 0 && !this._isTextEmpty(range0) && (this.computeIsText(range0) == this.falseValueStr)) || (d2 == 0 && !this._isTextEmpty(range1) && (this.computeIsText(range1) == this.falseValueStr))) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._bad_index];
                    return this.getErrorStrings()[5].toString();
                }
                if ((this._isTextEmpty(range0.split(this.tic).join(this._string_empty)) && range0[0] == (this.tic)) || (this._isTextEmpty(range1.split(this.tic).join(this._string_empty)) && range1[0] == (this.TIC))) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this.invalid_arguments];
                    return this.getErrorStrings()[1].toString();
                }
                if (this._isTextEmpty(range0.split(this.tic).join(this._string_empty)) || this._isTextEmpty(range1.split(this.tic).join(this._string_empty))) {
                    return "0";
                }
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            d1 = this._parseDouble(range0);
            d2 = this._parseDouble(range1);
            if (!isNaN(d1) && !isNaN(d2)) {
                if (d1 > 0 && d2 < 0)
                {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                if (d1 == 0 || d2 == 0)
                    return "0";
                d3 = Math.floor(d1 / d2) * d2;
                if (d2 > 0) {
                    while (d3 < d1) {
                        d3 += d2;
                    }
                } else {
                    while (d3 > d1) {
                        d3 += d2;
                    }
                }
            }
            return d3.toString();
        };
        this.computeDecimal2 = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 3) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var Base64 = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/";
            if (!this.getValueFromArg(args[0]).indexOf(this.tic) && !this._isCellReference(args[0])) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[1].toString();
            }
            var strValue;
            var radix = 0;
            try {
                strValue = this.getValueFromArg(args[0]).split(this.tic).join("");
                radix = parseInt(this.getValueFromArg(args[1]).split(this.tic).join(""));
            } catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_Math_argument] + ex;
                return this.getErrorStrings()[1].toString();
            }
            var result;
            if (radix < 2 || radix > Base64.length) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "Base requested outside range, it should be from 2 - 16";
                return this.getErrorStrings()[4].toString();
            }
            strValue = (this._isIE8) ? strValue.replace(/^\s+|\s+$/g, '') : strValue.trim();
            if (radix <= 36)
                strValue = strValue.toUpperCase();
            var pos = 0;
            result = 0;

            while (pos < strValue.length && !this._isWhiteSpace(strValue[pos])) {
                var digit = strValue.substring(pos, 1);
                var i = Base64.indexOf(digit);
                if (i >= 0 && i < radix) {
                    result *= radix;
                    result += i;
                    pos++;
                } else {
                    if (this._rethrowLibraryComputationExceptions)
                        throw "Base requested outside range, it should be from 2 - 16";
                    return this.getErrorStrings()[4].toString();
                }
            }
            return result.toString();
        };
        this.computeCombin = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            ////N things taken k at the time.
            var nd;
            var kd;
            var combin = 0;

            var argument1 = this.getValueFromArg(args[0]).split(this.tic).join("");
            argument1 = (argument1 == null || argument1 == "") ? "0" : argument1;
            argument1 = (argument1.split(this.tic).join("") == "TRUE") ? "1" : (argument1.split(this.tic).join("") == "FALSE") ? "0" : argument1;
            var argument2 = this.getValueFromArg(args[1]).split(this.tic).join("");
            argument2 = (argument2 == null || argument2 == "") ? "0" : argument2;
            argument2 = (argument2.split(this.tic).join("") == "TRUE") ? "1" : (argument2.split(this.tic).join("") == "FALSE") ? "0" : argument2;
            if (argument1.split(this.tic).join("") == (this._string_empty) || argument2.split(this.tic).join("") == (this._string_empty)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                else
                    return this.getErrorStrings()[1].toString();
            }
            nd = this._parseDouble(argument1);
            kd = this._parseDouble(argument2);
            if (!isNaN(nd) && !isNaN(kd)) {
                var k = parseInt((kd + 0.1).toString());
                var n = parseInt((nd + 0.1).toString());
                if (n < k || k < 0 || n < 0 || kd < 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[1].toString();
                    else
                        return this.getErrorStrings()[4].toString();
                }
                combin = this._comb(k, n);
            } else {
                if (!this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                else
                    return this.formulaErrorStrings[this._invalid_arguments];
            }
            return combin.toString();
        };
        this.computeCombinA = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argList.indexOf("u") > -1) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.getErrorStrings()[4].toString();
                }
                return this.getErrorStrings()[4].toString();
            }
            if (argCount != 2 || argList == "") {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (argList.length > 15) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.getErrorStrings()[4].toString();
                }
                return this.getErrorStrings()[4].toString();
            }
            var number1 = this.getValueFromArg(args[0]).split(this.tic).join("");
            number1 = (number1.split(this.tic).join("") == "TRUE") ? "1" : (number1.split(this.tic).join("") == "FALSE") ? "0" : number1;
            number1 = (number1 == "" || number1 == 0) ? "0" : number1;
            number1 = parseInt(number1.split(this.tic).join(""));
            var choosedNumber = this.getValueFromArg(args[1]).split(this.tic).join("");
            choosedNumber = (choosedNumber.split(this.tic).join("") == "TRUE") ? "1" : (choosedNumber.split(this.tic).join("") == "FALSE") ? "0" : choosedNumber;
            choosedNumber = (choosedNumber == "" || choosedNumber == 0) ? "0" : choosedNumber;
            choosedNumber = parseInt(choosedNumber.split(this.tic).join(""));
            var result;
            if (number1 == 0 && choosedNumber == 0) {
                result = "1";
            } else {
                var number2 = number1 + choosedNumber - 1;
                var pass = number2 + "," + (number1 - 1);
                result = this.computeCombin(pass);
            }
            return result;
        };
        this.computeCos = function (args) {
            var argument = this.splitArgsPreservingQuotedCommas(args);
            if (argument.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            args = this.getValueFromArg(args);
            args = (args.split(this.tic).join("") == "TRUE") ? "1" : (args.split(this.tic).join("") == "FALSE") ? "0" : args;
            return this._computeMath(args, Math.cos).toString();
        };
       
        this.computeCosh = function (args) {
            var arg = this._splitArguments(args, this.getParseArgumentSeparator().toString());
            var argCount = arg.length;
            if (argCount > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(arg[0]);
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            var value = this._parseDouble(argVal.split(this.tic).join(""));
            if (isNaN(value)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(arg[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            var y = Math.exp(value);
            return (y + 1 / y) / 2;
        };
        this.computeCot = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            argList = this.getValueFromArg(argList);
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;
            if (argList[0] == (this.tic) && argList[length - 1] == (this.tic))
                argList = argList.split(this.tic).join("");
            if (argList == this._string_empty) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[4].toString();
            }
            var isNumber = this.computeIsNumber(argList);
            if (isNumber == this.trueValueStr) {
                var tempList = argList;
                tempList = tempList.indexOf("u") ? tempList.split("u").join(this._string_empty) : tempList;
                var number = this._parseDouble(tempList);
                if (number >= 134217728) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
            } else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[5].toString();
            }
            if (argList == "0") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[3].toString();
                return this.getErrorStrings()[3].toString();
            }
            var cotVal = this._computeMath(argList, Math.tan);
            if (cotVal != "#NUM!" || cotVal != "#VALUE!") {
                cotVal = (1 / parseFloat(cotVal)).toString();
            }
            return cotVal;
        };
        this.computeCsc = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue);
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            if (dVal >= 134217728) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            
            var cscVal = (1 / parseFloat(Math.sin(dVal))).toString();
            return cscVal;
        };
        
        this.computeCsch = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var dVal = this._parseDouble(argValue);
            var isNumber = this.computeIsNumber(argList);
            if (isNaN(dVal)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            if (dVal == 0) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[3].toString();
            }
            if (dVal > 709) {
                return "0";
            }
            var cschVal = (2 / (Math.exp(dVal) - Math.exp(-dVal))).toString();

            return cschVal;
        };
        this.computeDecimal = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.TextWithNumber);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (args[1] == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            var Base64 = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/";
            var strValue;
            var radix = 0;
            try {
                strValue = this.getValueFromArg(args[0]).split(this.tic).join("");
                radix = parseInt(this.getValueFromArg(args[1]).split(this.tic).join(""));
            } catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._invalid_Math_argument] + ex;
                return this.getErrorStrings()[1].toString();
            }
            var result;
            if (radix < 2 || radix > Base64.length) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "Base requested outside range, it should be from 2 - 16";
                return this.getErrorStrings()[4].toString();
            }

            strValue = (this._isIE8) ? strValue.replace(/^\s+|\s+$/g, '') : strValue.trim();
            if (radix <= 36)
                strValue = strValue.toUpperCase();
            var pos = 0;
            result = 0;

            while (pos < strValue.length ) {
                var digit = this._substring(strValue, pos, 1);
                var i = Base64.indexOf(digit);
                if (i >= 0 && i < radix) {
                    result *= radix;
                    result += i;
                    pos++;
                    
                } else {
                    if (this._rethrowLibraryComputationExceptions)
                        throw "Base requested outside range, it should be from 2 - 16";
                    return this.getErrorStrings()[4].toString();
                }
            }

            return result.toString();
        };
        this.computeDegrees = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argValue = this.getValueFromArg(args[0]);
            argValue = (argValue.split(this.tic).join("") == "TRUE") ? "1" : (argValue.split(this.tic).join("") == "FALSE") ? "0" : argValue;
            var radians = this._parseDouble(argValue);
            if (isNaN(radians)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argValue[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            var degrees = 0;
            degrees = 180 * radians / Math.PI;
            return degrees.toString();
        };
        
        this.computeExp = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(args[0]);
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            if (argVal == "")
                argList = "0";
            var x = this._parseDouble(argVal);
            if (x > 709) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            return this._computeMath(argList, Math.exp).toString();
        };

        this.computeEven = function (argList) {
            var even = 0;
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(args[0]);
            var number = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            number = this._parseDouble(number.split(this.tic).join(""));
            if (!isNaN(number)) {
                var sgn = Math.sign(number);
                number = Math.abs(number);
                number = Math.ceil(number);
                if ((number % 2) == 1) {
                    even = sgn * (number + 1);
                }
                else {
                    even = sgn * number;
                }
            }
            else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }

            return even.toString();
        }

        this.computeFact = function (args) {
            var fact = 0;
            var numList = this.splitArgsPreservingQuotedCommas(args);
            if (numList.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(args);
            var number = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            number = this._parseDouble(number.split(this.tic).join(""));
            if (isNaN(number)) {
                return this.getErrorStrings()[1].toString();
            } else if (number < 0) {
                return this.getErrorStrings()[4].toString();
            } else {
                var x = number;
                if (x > 12) {
                    fact = this._factorialTable[12];
                    for (var i = 13; i <= x; i++) {
                        fact *= i;
                    }
                } else {
                    fact = this._factorialTable[x];
                }
            }
            return fact.toString();
        };
        this.computeFactdouble = function (args) {
            var number;
            var fact = 1;
            var numList = this.splitArgsPreservingQuotedCommas(args);
            if (numList.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            number = parseInt(this.getValueFromArg(args));
            if (isNaN(number)) {
                return this.getErrorStrings()[1].toString();
            } else if (number < 0) {
                return this.getErrorStrings()[4].toString();
            } else {
                var x = number;
                var n = x;
                if (x > 3) {
                    while (n > 0) {
                        fact = fact * n;
                        n = n - 2;
                    }
                } else if (x == 0)
                    fact = 1;
                else
                    fact = x;
            }
            return fact.toString();
        };
        this.computeFloor = function (args) {
            var range = this.splitArgsPreservingQuotedCommas(args);
            var argCount = range.length;
            if (argCount != 2 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var d1 = this._parseDouble(this.getValueFromArg(range[0]));
            var d2 = this._parseDouble(this.getValueFromArg(range[1])), d3 = 0;
            if (!isNaN(d1) && !isNaN(d2)) {
                if (d1 == 0)
                    return d3.toString();
                if (d1 * d2 <= 0 && !(d1 < 0)) {
                    return this.formulaErrorStrings[this._invalid_arguments];
                }

                d3 = Math.ceil(d1 / d2) * d2;
                if (d2 > 0) {
                    while (d3 > d1) {
                        d3 -= d2;
                    }
                } else {
                    while (d3 < d1) {
                        d3 -= d2;
                    }
                }
                if (d2 == 0.1) {
                    d3 = d1;
                }
            }
            return d3.toString();
        };
        this.computeInt = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount > 1 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var argVal = this.getValueFromArg(args[0]);
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var x;
           
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            x = Math.floor(argVal).toString();
          
            if (!isNaN(x)) {
                return x;
            }
            else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
        };
        this.computeLn = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 1) {
                return this.formulaErrorStrings[this.invalid_arguments];
            }
            var argVal = this.getValueFromArg(args[0]);
            var x = this._parseDouble(argVal);
            if (x <= 0) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            if (!isNaN(x)) {
                return (Math.log(x)).toString();
            }
            else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
        };
        this.computeLog = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount > 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(args[0]);
            var baseVal = (argCount == 2) ? this.getValueFromArg(args[1]) : "10";
            if ((argVal == "" || argVal == null) || (baseVal == "" || baseVal == null)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            var x = this._parseDouble(argVal);
            var b =  this._parseDouble(baseVal);
            if (x <= 0 || b <= 0) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            if (!isNaN(x) && !isNaN(b)) {
                return ((Math.log(x) / Math.LN10) / (Math.log(b) / Math.LN10)).toString();
            }
            else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || baseVal[0] == this.tic) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
        };
        this.computeLogTen = function (args) {
            var arg = this._splitArguments(args, this.getParseArgumentSeparator().toString());
            var argCount = arg.length;
            if (argCount > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(arg[0]);
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            var value = this._parseDouble(argVal.split(this.tic).join(""));
            if (isNaN(value)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(arg[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            if (value <= 0) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            return (this._computeMath(argVal, Math.log) / Math.LN10).toString();
        };
        
        this.computePI = function (args) {
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.None);
                if (this.formulaErrorStrings[this._invalid_arguments] == checkString) {
                    return checkString;
                }
                else {
                    return Math.PI.toString();
                }
            }
            return Math.PI.toString();
        };
        this.computeProduct = function (range) {
            var prod = 1;
            var d;
            var s1;
            var nohits = true;
            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var r = 0; r < ranges.length; r++) {
                var adjustRange = ranges[r];

                ////is a cellrange
                if (ranges[r].indexOf(':') > -1) {
                    var cellCollection = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cellCollection[s]);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        } catch (ex) {
                            return ex;
                        }

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d)) {
                                prod = prod * d;
                                nohits = false;
                            } else if (this.getErrorStrings().indexOf(s1) > -1) {
                                return s1;
                            }
                            else {
                                if (this._rethrowLibraryComputationExceptions)
                                    throw this.formulaErrorStrings[this._bad_formula];
                                return this.getErrorStrings()[1].toString();
                            }
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges[r]);
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                    } catch (ex) {
                        return ex;
                    }

                    if (s1.length > 0) {
                        d = this._parseDouble(s1);
                        if (!isNaN(d)) {
                            prod = prod * d;
                            nohits = false;
                        } else if (this.getErrorStrings().indexOf(s1) > -1) {
                            return s1;
                        }
                        else {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.formulaErrorStrings[this._bad_formula];
                            return (s1 == this.tic || this._isCellReference(ranges[r])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
                        }
                    }
                }
            }
            return nohits ? "0" : prod.toString();
        };
        this.computeSecant = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            argList = this.getValueFromArg(argList);
            var argCount = args.length;
            if (argCount != 1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (argList[0] == (this.tic) && argList[length - 1] == (this.tic))
                argList = argList.split(this.tic).join("");
            if (argList == this._string_empty) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[4].toString();
            }
            var isNumber = this.computeIsNumber(argList);
            if (isNumber == this.trueValueStr) {
                var tempList = argList;
                tempList = tempList.indexOf("u") ? tempList.split("u").join("") : tempList;
                var number = parseFloat(tempList);
                if (number >= 134217728) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
            } else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[5].toString();
            }
            var secVal = this._computeMath(argList, Math.cos);
            if (secVal != "#NUM!" || secVal != "#VALUE!")
                secVal = (1 / parseFloat(secVal)).toString();
            return secVal;
        };
        this.computeSeriessum = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length != 4 || arg == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            for (var index = 0; index <= 2; index++) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(args[index], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString1 = this.formulaErrorStringCheck(args[3], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString1) > -1) {
                    return checkString1;
                }
            }
            var xValue = 0, nValue = 0, mValue = 0, coeff = 0, result = 0;
            var arrayArg;
            if (args[3].indexOf(';') > -1) {
                arrayArg = this._splitArguments(args[3].split(this.tic).join(""), ';');
            } else {
                arrayArg = this.getCellsFromArgs(args[3].split(this.tic).join(""));
            }
            if (args[0] == "" || args[1] == "" || args[2] == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[0].toString();
            }
            xValue = this._parseDouble(this.getValueFromArg(args[0]));
            nValue = this._parseDouble(this.getValueFromArg(args[1]));
            mValue = this._parseDouble(this.getValueFromArg(args[2]));
            for (var i = 0; i < arrayArg.length; i++) {
                coeff = this._parseDouble(this.getValueFromArg(arrayArg[i]));
                if (!isNaN(coeff)) {
                    result = result + (coeff * Math.pow(xValue, (nValue + (i * mValue))));
                } else {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._bad_formula];
                    return this.getErrorStrings()[1].toString();
                }
            }
            if (isNaN(result)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[4].toString();
            }
            return result.toString();
        };
        this.computeSin = function (args) {
            var argument = this.splitArgsPreservingQuotedCommas(args);
            if (argument.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            args = this.getValueFromArg(args);
            args = (args.split(this.tic).join("") == "TRUE") ? "1" : (args.split(this.tic).join("") == "FALSE") ? "0" : args;
            return this._computeMath(args, Math.sin).toString();
        };
        this.computeSinh = function (args) {
            var arg = this._splitArguments(args, this.getParseArgumentSeparator().toString());
            var argCount = arg.length;
            if (argCount > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var argVal = this.getValueFromArg(arg[0]);
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            var value = this._parseDouble(argVal.split(this.tic).join(""));
            if (isNaN(value)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(arg[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
           
            var y = Math.exp(value);
            return (y - 1 / y) / 2;
        };
        this.computeSqrt = function (args) {
            var arg = this._splitArguments(args, this.getParseArgumentSeparator().toString());
            var argCount = arg.length;
            if (argCount > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            args = this.getValueFromArg(args);
            args = (args.split(this.tic).join("") == "TRUE") ? "1" : (args.split(this.tic).join("") == "FALSE") ? "0" : args;
            return this._computeMath(args, Math.sqrt).toString();
        };
        this.computeSubTotal = function (args) {
            var ignoreSubtotal = false;
            var cellReference = this._string_empty;
            var val;
            var index = 0;
            var arg = this._splitArguments(args, this.getParseArgumentSeparator().toString());
            var argCount = arg.length;
            if (argCount < 2 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg[0], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (this._isCellReference(arg[0])) {
                cellReference = this.getValueFromArg(arg[0]);
            } else {
                cellReference = arg[0].toString();
            }
            val = this._parseDouble(cellReference);
            if (!isNaN(val)) {
                index = parseInt(val.toString());
                if ((index < 1 || index > 11) && (index < 101 || index > 111)) {
                    return this.getErrorStrings()[1].toString();
                }
            }
            else
            {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[5].toString();
            }
            if (ignoreSubtotal)
                return "0";

            cellReference = args.substring((arg[0].toString()).length + 1);
            ignoreSubtotal = true;
            var value = this._string_empty;
            switch (index) {
                case 1:
                case 101:
                    value = this.computeAverage(cellReference);
                    break;
                case 2:
                case 102:
                    value = this.computeCount(cellReference);
                    break;
                case 3:
                case 103:
                    value = this.computeCounta(cellReference);
                    break;
                case 4:
                case 104:
                    value = this.computeMax(cellReference);
                    break;
                case 5:
                case 105:
                    value = this.computeMin(cellReference);
                    break;
                case 6:
                case 106:
                    value = this.computeProduct(cellReference);
                    break;
                case 7:
                case 107:
                    value = this.computeStdev(cellReference);
                    break;
                case 8:
                case 108:
                    value = this.computeStdevp(cellReference);
                    break;
                case 9:
                case 109:
                    value = this.computeSum(cellReference);
                    break;
                case 10:
                case 110:
                    value = this.computeVar(cellReference);
                    break;
                case 11:
                case 111:
                    value = this.ComputeVarp(cellReference);
                    break;
                default:
                    value = this.getErrorStrings()[1].toString();
                    break;
            }
            ignoreSubtotal = false;
            return value;
        };
        this.computeSumif = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 && argCount != 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                if (argCount == 3) {
                    checkString = this.formulaErrorStringCheck(args[2], FormulaArgumentType.CellReference);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }

            var criteriaRange = args[0];
            var criteria = args[1];
            if (criteria.length < 1) {
                return "0";
            }

            var op = this.token_equal;
            if (criteria[0] != this.tic[0] && "=><".indexOf(criteria[0]) == -1) {
                ////cell reference
                criteria = this.getValueFromArg(criteria);
            }

            var offset = (criteria.length > 0 && criteria[0] == this.tic[0]) ? 1 : 0;
            var compare = this.minValue;
            if (criteria.substring(offset)[0] == (">=")) {
                criteria = this._substring(criteria, offset + 2, criteria.length - 2 - 2 * offset);
                op = this.token_greatereq;
            } else if (criteria.substring(offset)[0] == ("<=")) {
                criteria = this._substring(criteria, offset + 2, criteria.length - 2 - 2 * offset);
                op = this.token_lesseq;
            } else if (criteria.substring(offset)[0] == ("<")) {
                criteria = this._substring(criteria, offset + 1, criteria.length - 1 - 2 * offset);
                op = this.token_less;
            } else if (criteria.substring(offset)[0] == (">")) {
                criteria = this._substring(criteria, offset + 1, criteria.length - 1 - 2 * offset);
                op = this.token_greater;
            } else if (criteria.substring(offset)[0] == ("=")) {
                criteria = this._substring(criteria, offset + 1, criteria.length - 1 - 2 * offset);
            }

            criteria = criteria.split(this.tic).join("");
            var numer = this._parseDouble(criteria, compare);

            var sumRange = (argCount == 2) ? criteriaRange : args[2];

            var s1 = this.getCellsFromArgs(criteriaRange);
            var s2 = this.getCellsFromArgs(sumRange);

            var count = s1.length;

            if (count > s2.length) {
                var i = sumRange.indexOf(':');
                if (i > -1) {
                    var startRow = this.rowIndex(this._substring(sumRange, 0, i));
                    var startCol = this.colIndex(this._substring(sumRange, 0, i));
                    var row = this.rowIndex(this._substring(sumRange, i + 1));
                    var col = this.colIndex(this._substring(sumRange, i + 1));
                    if (startRow != row) {
                        row += count - s2.length;
                    } else if (startCol != col) {
                        col += count - s2.length;
                    }

                    sumRange = this._substring(sumRange, 0, i + 1) + RangeInfo.getAlphaLabel(col) + row.toString();
                    s2 = this.getCellsFromArgs(sumRange);
                }
            }

            var sum = 0;

            var d;
            var s;
            switch (op) {
                case this.token_equal:
                    {
                        for (var index = 0; index < count; ++index) {
                            s = this.getValueFromArg(s1[index]); //// +criteria;

                            if (s.split(this.tic).join("") == criteria) {
                                s = s2[index];
                                s = this.getValueFromArg(s);
                                d = this._parseDouble((s.split(this.tic).join("")).split("$").join(""));
                                if (!isNaN(d)) {
                                    sum += d;
                                }
                            }
                        }
                    }

                    break;
                case this.token_greatereq:
                    {
                        for (var index = 0; index < count; ++index) {
                            s = this.getValueFromArg(s1[index]); //// +criteria;
                            d = this._parseDouble((s.split(this.tic).join("")).split("$").join(""));
                            if (!isNaN(d)) {
                                if (d >= compare) {
                                    s = s2[index];
                                    s = this.getValueFromArg(s);
                                    d = this._parseDouble(s);
                                    if (!isNaN(d)) {
                                        sum += d;
                                    }
                                }
                            }
                        }
                    }

                    break;
                case this.token_greater:
                    {
                        for (var index = 0; index < count; ++index) {
                            s = this.getValueFromArg(s1[index]); //// +criteria;
                            d = this._parseDouble((s.split(this.tic).join("")).split("$").join(""));
                            if (!isNaN(d)) {
                                if (d > compare) {
                                    s = s2[index];
                                    s = this.getValueFromArg(s);
                                    d = this._parseDouble(s);
                                    if (!isNaN(d)) {
                                        sum += d;
                                    }
                                }
                            }
                        }
                    }

                    break;
                case this.token_less:
                    {
                        for (var index = 0; index < count; ++index) {
                            s = this.getValueFromArg(s1[index]); //// +criteria;
                            d = this._parseDouble((s.split(this.tic).join("")).split("$").join(""));
                            if (!isNaN(d)) {
                                if (d < compare) {
                                    s = s2[index];
                                    s = this.getValueFromArg(s);
                                    d = this._parseDouble(s);
                                    if (!isNaN(d)) {
                                        sum += d;
                                    }
                                }
                            }
                        }
                    }

                    break;
                case this.token_lesseq:
                    {
                        for (var index = 0; index < count; ++index) {
                            s = this.getValueFromArg(s1[index]); //// +criteria;
                            d = this._parseDouble((s.split(this.tic).join("")).split("$").join(""));
                            if (!isNaN(d)) {
                                if (d <= compare) {
                                    s = s2[index];
                                    s = this.getValueFromArg(s);
                                    d = this._parseDouble(s);
                                    if (!isNaN(d)) {
                                        sum += d;
                                    }
                                }
                            }
                        }
                    }

                    break;
                default:
                    break;
            }
            return sum.toString();
        };
        this.computeTan = function (args) {
            return this._computeMath(args, Math.tan).toString();
        };
        this.computeTrunc = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            var digits = 0;

            if (argCount > 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (argCount == 2) {
                digits = this.getValueFromArg(args[1]);
                digits = (digits.split(this.tic).join("") == "TRUE") ? "1" : (digits.split(this.tic).join("") == "FALSE") ? "0" : digits;
                ////ignore return value...
                digits = this._parseDouble(digits);
            }
            var argVal = this.getValueFromArg(args[0]);
            argVal = (argVal.split(this.tic).join("") == "TRUE") ? "1" : (argVal.split(this.tic).join("") == "FALSE") ? "0" : argVal;
            var value = this._parseDouble(argVal.split(this.tic).join(""));
            if (isNaN(value)) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._bad_formula];
                return (argVal[0] == this.tic || this._isCellReference(args[0])) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
            }
            var normalizer = Math.pow(10, digits);
            var d1 = (value < 0) ? -1 : 1;
            return (d1 * Math.floor(normalizer * Math.abs(value)) / normalizer).toString();
        };
        this.computeLognormOdist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 4 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var x;
            var u;
            var s;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            u = this._parseDouble(args[1]);
            s = this._parseDouble(args[2]);
            if (!isNaN(x) && !isNaN(u) && !isNaN(s)) {
                if (x <= 0 || s <= 0) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "#Num! Passsed value is incorrect";
                    }
                    return this.getErrorStrings()[4].toString();
                }
                if (args[3] == this.falseValueStr) {
                    var mean = 0;
                    var std = 0;

                    // mean = Math.Exp(u+Math.Pow(u,2))
                    dist = (Math.exp(-(Math.pow((Math.log(x) - u), 2) / (2 * Math.pow(s, 2))))); //this.normaldist(Math.Log(x), u, s);
                    dist = dist / (x * s * Math.sqrt(2 * Math.PI));
                } else {
                    dist = this._standardNormalCumulativeDistribution((Math.log(x) - u) / s);
                }
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#Value! Passsed value is non - numeric";
                }
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
        this.computeLognormOinv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var p;
            var u;
            var s;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            p = this._parseDouble(args[0]);
            u = this._parseDouble(args[1]);
            s = this._parseDouble(args[2]);
            if (!isNaN(p) && !isNaN(u) && !isNaN(s)) {
                if (p <= 0 || p >= 1 || s <= 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                dist = Math.exp(this._normalinv(p, u, s));
            }
            return dist.toString();
        };
        this.computeNormOinv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var p;
            var u;
            var s;
            var invdist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }

            p = this._parseDouble(args[0]);
            u = this._parseDouble(args[1]);
            s = this._parseDouble(args[2]);
            if (!isNaN(p) && !isNaN(u) && !isNaN(s)) {
                if (p >= 0 && p <= 0 || s <= 0) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw this.formulaErrorStrings[this._wrong_number_arguments] + this.getErrorStrings()[4].toString();
                    }
                    return this.getErrorStrings()[4].toString();
                }
                invdist = this._normalCumulativeDistributionFunctionInverse(p, u, s); //this.normalinv(p, u, s);
            }

            if (invdist <= 0) {
                return this.formulaErrorStrings[this._iterations_dont_converge];
            }
            return invdist.toString();
        };
        this.computeNormOdist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 4 || argList == "") {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var u;
            var s;
            var cum = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            u = this._parseDouble(args[1]);
            s = this._parseDouble(args[2]);
            if (!isNaN(x) && !isNaN(u) && !isNaN(s)) {
                if (s <= 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                if (argCount != 3) {
                    cum = (args[3] == this.trueValueStr) ? 1 : 0;
                    var check = 0;
                    check = this._parseDouble(args[3]);
                    if (!isNaN(check))
                        cum = 1;
                }

                if (cum == 0) {
                    dist = this._normalProbabilityDensity(x, u, s);
                } else {
                    dist = this._normaldist(x, u, s);
                }
            }
            return dist.toString();
        };
        this.computeNormOsODist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 && argCount != 2) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var x;
            var cum = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
            }
            x = this._parseDouble(args[0]);
            if (!isNaN(x)) {
                if (argCount == 2) {
                    cum = (args[1] == this.trueValueStr) ? 1 : 0;
                    var check = 0;
                    check = this._parseDouble(args[1]);
                    if (!isNaN(check))
                        cum = 1;
                }

                if (cum == 0) {
                    dist = this._standardNormalProbabilityDensityFunction(x);
                } else {
                    dist = this._standardNormalCumulativeDistributionFunction(x);
                }
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#VALUE! Passed argument value is non numeric";
                }
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
        this.computeNormOsOInv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var x;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
            }
            x = this._parseDouble(args[0]);
            if (!isNaN(x)) {
                if (x <= 0 || x >= 1) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "#NUM! Passed argument value doesnot match with in range level";
                    }
                    return this.getErrorStrings()[4].toString();
                }
                dist = this._standardNormalCumulativeDistributionFunctionInverse(x);
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#VALUE! Passed argument value is non numeric";
                }
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
        this.computePermut = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            ////N things taken k at the time.
            var nd;
            var kd;
            var combin = 0;
            args[0] = this.getValueFromArg(args[0]);
            args[0] = (args[0] == "" || args[0] == null) ? "0" : args[0];
            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = this.getValueFromArg(args[1]);
            args[1] = (args[1] == "" || args[1] == null) ? "0" : args[1];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            nd = this._parseDouble(this.getValueFromArg(args[0]));
            kd = this._parseDouble(this.getValueFromArg(args[1]));
            if (!isNaN(nd) && !isNaN(kd)) {
                var k = (kd + 0.1);
                var n = (nd + 0.1);

                var top = 1;
                for (var i = (n - k) + 1; i <= n; ++i) {
                    top = top * i;
                }

                combin = top;
            } else {
                return this.formulaErrorStrings[this._invalid_arguments];
            }
            return combin.toString();
        };
        this.computePermutationA = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null)
                    throw this.getLibraryComputationException();
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var nd;
            var kd;
            var combin = 0;
            args[0] = this.getValueFromArg(args[0]);
            args[0] = (args[0] == "" || args[0] == null) ? "0" : args[0];
            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = this.getValueFromArg(args[1]);
            args[1] = (args[1] == "" || args[1] == null) ? "0" : args[1];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            nd = this._parseDouble(args[0]);
            kd = this._parseDouble(args[1]);
            if (!isNaN(nd) && !isNaN(kd)) {
                var k = (kd + 0.1);
                var n = (nd + 0.1);
            } else {
                return this.formulaErrorStrings[this._invalid_arguments];
            }
            return Math.pow(nd, kd).toString();
        };
        this.computeStandardize = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var u;
            var sd = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == "" || args[i] == null) ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            u = this._parseDouble(args[1]);
            sd = this._parseDouble(args[2]);
            if (!isNaN(x) && !isNaN(u) && !isNaN(sd)) {
                if (sd <= 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                dist = (x - u) / sd;
            }
            return dist.toString();
        };
        this.computeBinomOdist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 4 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var successes;
            var trials;
            var p;
            var cum = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
                args[i] = (args[i] == null || args[i] == "") ? "0" :args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            successes = this._parseDouble(args[0]);
            trials = this._parseDouble(args[1]);
            p = this._parseDouble(args[2]);
            if (!isNaN(successes) && !isNaN(trials) && !isNaN(p)) {
                if (successes < 0 || successes > trials || p < 0 || p > 1) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "#NAME! Passed argument value is not equal to minimum par value";
                    }
                    return this.getErrorStrings()[4].toString();
                }
                cum = (args[3] == this.trueValueStr) ? 1 : 0;
                if (cum == 0) {
                    dist = this._comb(successes, trials) * Math.pow(p, successes) * Math.pow(1 - p, trials - successes);
                } else {
                    dist = this._binomdist(trials, successes, p);
                }
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#VALUE! Passed value is nonnumeric";
                }
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
        this.computeChisqOinvOrt = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var p;
            var v;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            p = this._parseDouble(args[0]);
            v = this._parseDouble(args[1]);
            if (!isNaN(p) && !isNaN(v)) {
                if (p <= 0 || p > 1 || v < 1) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                if (p == 1) {
                    return "0";
                }
                dist = this._chiinv(p, v);
            }
            return dist.toString();
        };
        this.computeChisqOdistOrt = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var v;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            v = this._parseDouble(args[1]);
            if (!isNaN(x) && !isNaN(v)) {
                if (x < 0 || v < 1) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                if (x == 0) {
                    return v.toString();

                }
                if (v == 1 && this._excelLikeComputations) {
                    //continue;
                }

                dist = 1 - this._chidist(x, v);
                for (var i = 0; i < dist.toString().length; i++) {
                }
                var ss = Math.round(dist);
            }
            return dist.toString();
        };
        this.computeFOdist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 4 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var df1 = 0;
            var df2 = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            df1 = this._parseDouble(args[1]);
            df2 = this._parseDouble(args[2]);
            if (!isNaN(x) && !isNaN(df1) && !isNaN(df2)) {
                if (df1 < 1 || df2 < 1 || (x[0] == ("-"))) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "#NUM! Passed argument value is incorrect";
                    }
                    return this.getErrorStrings()[4].toString();
                }

                if (args[3] == 1){
                    dist = this._fCumulativeDensity(x, df1, df2);
                } else if (args[3] == 0){
                    dist = this._fProbabilityDensity(x, df1, df2);
                }
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#VALUE! Passed argument value is incorrect";
                }
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
        this.computeGammaln = function (argList) {
            var argument = this.splitArgsPreservingQuotedCommas(argList);
            if (argument.length > 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            argList = this.getValueFromArg(argList);
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;
            var x = 0;
            x = this._parseDouble(argList);
            if (!isNaN(x) && x > 1) {
                x = this._gammaln(x);
            }
            else if(x == 1){
                return "0";
            }
            else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            return x.toString();
        };
        this.computeConfidenceOnorm = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "Wrong number of arguments";
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var alpha;
            var s;
            var sz;
            var val = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }

            alpha = this._parseDouble(args[0]);
            s = this._parseDouble(args[1]);
            sz = this._parseDouble(args[2]);
            if (!isNaN(alpha) && !isNaN(s) && !isNaN(sz)) {
                if (alpha <= 0 || alpha >= 1 || s <= 0 || sz < 1) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "Passed argument value is different from minimum par";
                    }
                    return this.getErrorStrings()[4].toString();
                }

                //// 1 - alpha  would be from -inf to 1-alpha. adding alpha + 2
                //// takes away the left tail making the integral from alpha-1 to 1-alpha.
                if (this._excelLikeComputations)
                    val = this._normalinv(1 - alpha + alpha / 2, 0, 1);
                else
                    val = this._newnormalinv(1 - alpha + alpha / 2);
                val = val * s / Math.sqrt(sz);
            }

            return val.toString();
        };
        this.computeExponOdist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var x;
            var lambda;
            var cum = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == null) ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            lambda = this._parseDouble(args[1]);
            if (!isNaN(x) && !isNaN(lambda)) {
                if (x < 0 || lambda <= 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw "Passed argument value is below or equal to 0";
                    return this.getErrorStrings()[4].toString();
                }
                cum = (args[2] == this.trueValueStr) ? 1 : 0;
                var check = this._parseDouble(args[2]);
                if (!isNaN(check))
                    cum = 0;
                if (cum == 0) {
                    dist = lambda * Math.exp(-lambda * x);
                } else {
                    dist = 1 - Math.exp(-lambda * x);
                }
            } else {
                if (this._rethrowLibraryComputationExceptions)
                    throw "Passed argument value is non-numerical";
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
        this.computeFisher = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var x;
            var z = 0;

            var s = this.getValueFromArg(args[0]);
            s = (s.split(this.tic).join("") == "TRUE") ? "1" : (s.split(this.tic).join("") == "FALSE") ? "0" : s;

            x = this._parseDouble(s);
            if (!isNaN(x) && (x > -1 && x < 1)) {
                z = 0.5 * Math.log((1 + x) / (1 - x));
            }
            else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            return z.toString();
        };
        this.computeFisherInv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var y;
            var x = 0;

            var s = this.getValueFromArg(args[0]);
            s = (s.split(this.tic).join("") == "TRUE") ? "1" : (s.split(this.tic).join("") == "FALSE") ? "0" : s;

            y = this._parseDouble(s);
            if (!isNaN(y)) {
                var d = Math.exp(2 * y);
                x = (d - 1) / (d + 1);
            }
            return x.toString();
        };
        this.computeGammalnOPrecise = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            argList = this.getValueFromArg(argList);
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;
            var x = 0;
            x = this._parseDouble(argList.toString());
            if (!isNaN(x) && x > 1)
                x = this._gammaln(x);
            else if (x == 1) {
                return "0";
            }
            else {
                if (x <= 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw "Passed Argument value is less than or equal to minimum value 0";
                    return this.getErrorStrings()[4].toString();
                }
            }
            return x.toString();
        };
        
        this.computeLarge = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString1 = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString1) > -1) {
                    return checkString1;
                }
                var checkString2 = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString2) > -1) {
                    return checkString2;
                }
            }

            var x0;
            var s1 = this.getValueFromArg(args[1]);
            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
            x0 = this._parseDouble(s1);
            if (isNaN(x0)) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }

            var k = x0;
            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;
            if (k < 1 || k > n) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }

            dd.sort(function (a, b) {
                if (isNaN(a) || isNaN(b)) {
                    if (a > b) return 1;
                    else return -1;
                }
                return a - b;
            });
            return dd[n - k].toString();
        };
        this.computeSmall = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                var checkString1 = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString1) > -1) {
                    return checkString1;
                }
            }
            var s1 = this.getValueFromArg(args[1]);
            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
            var x0 = this._parseDouble(s1);
            if (isNaN(x0)) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }

            var k = x0;
            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;
            if (k < 1 || k > dd.length) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }
           
            dd.sort(function (a, b) {
                if (isNaN(a) || isNaN(b)) {
                    if (a < b) return 1;
                    else return -1;
                }
                return b - a;
            });
            return dd[n-k].toString();
        };
        this.computeCounta = function (range) {
            var count = 0;
            var s1;
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            var argsRange;

            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            for (var r = 0; r < ranges.length; r++) {
                argsRange = ranges[r];

                ////is a cellrange
                if (argsRange.indexOf(':') > -1) {
                    var cellCollection = this.getCellsFromArgs(argsRange);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cellCollection[s]).split(this.tic).join(this._string_empty);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            count++;
                        }
                    }
                } else if (argsRange == "") {
                    count++;
                } else if (this._isLetter(argsRange[0])) {
                    s1 = this.getValueFromArg(argsRange);
                    if (s1.length > 0) {
                        count++;
                    }
                } else {
                    if (argsRange.indexOf(this.getParseArgumentSeparator()) > -1) {
                        var array = this.splitArgsPreservingQuotedCommas(argsRange.split(this.tic).join(""));
                        for (var str = 0; str < array.length; str++) {
                            if (str[0] != this.tic && this._isCellReference(array[str])) {
                                if (this._rethrowLibraryComputationExceptions)
                                    throw this.formulaErrorStrings[this.invalid_arguments];
                                else
                                    return this.formulaErrorStrings[this.invalid_arguments];
                            }
                            if (str.length > 0 || str == "") {
                                count++;
                            }
                        }
                    }
                    else if (r.length > 0) {
                        count++;
                    }
                }
            }
            return count.toString();
        };
        this.computeAverage = function (range) {
            var sum = 0, count = 0, d, s1, adjustRange = [];
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (ranges.length < 1 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var r = 0; r < ranges.length; r++) {
                adjustRange = ranges[r];
                if (adjustRange.indexOf(':') > -1) {
                    var cellCollection = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cellCollection[s]).split(this.tic).join("");
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getErrorStrings()[4].toString();
                            else
                                return this.getErrorStrings()[4].toString();
                        }

                        if (s1.length > 0) {
                            if(!isNaN(s1)){
                                d = this._parseDouble(s1);
                                if (!isNaN(d)) {
                                    sum = Number(sum) + Number(d);
                                    count++;
                                } else if (this.getErrorStrings().indexOf(s1) == -1) {
                                    return s1;
                                } else {
                                    if (this._rethrowLibraryComputationExceptions)
                                        throw this.getErrorStrings()[5].toString();
                                    else
                                        return this.getErrorStrings()[5].toString();
                                }
                            }
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(adjustRange).split(this.tic).join(this._string_empty);
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        var s2 = this.getValueFromArg(adjustRange);
                        s2 = (s2.split(this.tic).join("") == "TRUE") ? "1" : (s2.split(this.tic).join("") == "FALSE") ? "0" : s2;
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions)
                            throw this.getErrorStrings()[4].toString();
                        else
                            return this.getErrorStrings()[4].toString();
                    }

                    if (s1.length > 0) {
                        d = this._parseDouble(s1);
                        if (!isNaN(d)) {
                            sum = Number(sum) + Number(d);
                            count++;
                        } 
                        else if (s2[0] == (this.tic)) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getErrorStrings()[1].toString();
                            else
                                return this.getErrorStrings()[1].toString();
                        } else {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getErrorStrings()[5].toString();
                            else
                                return this.getErrorStrings()[5].toString();
                        }
                    }
                }
            }

            if (count > 0) {
                sum = Number(sum) / Number(count);
            }
            return sum.toString();
        };
        this.computeAverageA = function (range) {
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (ranges.length < 1 || range == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var newargs = this._string_empty;
            var d = 0;
            if (ranges == this.trueValueStr || ranges == this.falseValueStr) {
                var boolvalue = (ranges == this.trueValueStr);
                if (boolvalue)
                    return +boolvalue;
                else
                    return +boolvalue;
            }

            for (var i = 0; i < ranges.length; i++) {
                if (ranges[i].indexOf(this.getParseArgumentSeparator().toString()) > -1) {
                    var temp = this.splitArgsPreservingQuotedCommas(ranges[i].split(this.tic).join(this._string_empty));
                    var j = 0;
                    for (var item = 0; item < temp.length; item++) {
                        var adjustRange = temp[item];
                        newargs = newargs + adjustRange + this.getParseArgumentSeparator().toString();
                        ranges[j] = adjustRange;
                    }
                } else if (this._isCellReference(ranges[i]))
                    newargs += ranges[i] + this.getParseArgumentSeparator().toString();
                else if (!this._parseDouble(ranges[i], d))
                    newargs = newargs + "0" + this.getParseArgumentSeparator().toString();
                else
                    newargs = newargs + ranges[i] + this.getParseArgumentSeparator().toString();
            }

            // if (newargs.endsWith(this.getParseArgumentSeparator().toString()))
            if (newargs[newargs.length - 1] == (","))
                newargs = newargs.substring(0, newargs.length - 1);

            var sum = this.computeAverage(newargs);
            return sum;
        };
        this.computeMax = function (range) {
            var max = this.minValue;
            var d;
            var s1;
            var argslist;
            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (ranges == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            for (var r = 0; r < ranges.length; r++) {
                argslist = ranges[r];

                ////cell range
                if (argslist.indexOf(':') > -1) {
                    var cellCollection = this.getCellsFromArgs(argslist);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cellCollection[s]).split(this.tic).join(this._string_empty);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d)) {
                                max = Math.max(max, d);
                            } else if (this.getErrorStrings().indexOf(s1) != -1) {
                                return s1;
                            }
                        }
                    }
                } else {
                    try {
                        //To check the error string #VALUE! for invalid argument
                        if (!this._isCellReference(argslist) && argslist[0] == this.tic) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getErrorStrings()[1].toString();
                            return this.getErrorStrings()[1].toString();
                        }
                        s1 = (argslist == this._string_empty) ? "0" : this.getValueFromArg(argslist);
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        d = this._parseDouble(s1);
                        if (!isNaN(d)) {
                            max = Math.max(max, d);
                        } else if (this.getErrorStrings().indexOf(s1) != -1) {
                            return s1;
                        }
                    }
                }
            }
            if (max != this.minValue) {
                return max.toString();
            }

            return this._string_empty;
        };
        this.computeMaxa = function (range) {
            var max = this.minValue;
            var d;
            var s1;

            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var r = 0; r < ranges.length; r++) {
                ////cell range
                if (ranges[r].indexOf(':') > -1) {
                    var cell = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cell.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cell[s]);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                                return ex;
                            }
                        }

                        ////ignore if empty
                        if (s1.length > 0) {
                            d = 0;
                            if (s1.toUpperCase() == (this.trueValueStr)) {
                                d = 1;
                            } else if (this.getErrorStrings().indexOf(s1) > -1) {
                                return s1;
                            } else {
                                d = this._parseDouble(s1);
                            }

                            max = Math.max(max, d);
                        }
                    }
                } else {
                    try {
                        if ((!ranges[r].startsWith(this.tic)) && ranges[r] == "") {
                            s1 = "0";
                        }
                        else {
                            s1 = this.getValueFromArg(ranges[r]);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                            if (this.getErrorStrings().indexOf(s1) > -1) {
                                if (this.getRethrowLibraryComputationExceptions())
                                    throw this.formulaErrorStrings[this._invalid_arguments];
                                return s1;
                            }
                            if (s1 == "") {
                                s1 = "0";
                            }
                        }
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                            return ex;
                        }
                    }

                    if (s1.length > 0) {
                        d = 0;
                        if (s1.toUpperCase() == (this.trueValueStr)) {
                            d = 1;
                        } else if (this.getErrorStrings().indexOf(s1) == -1) {
                            return s1;
                        } else {
                            d = this._parseDouble(s1);
                        }

                        max = Math.max(max, d);
                    }
                }
            }
            if (max != this.minValue) {
                return max.toString();
            }

            return this._string_empty;
        };
        this.computeMedian = function (range) {
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var dd = this._getDoubleArray(range);
            dd.sort(function (a, b) {
                if (isNaN(a) || isNaN(b)) {
                    if (a > b) return 1;
                    else return -1;
                }
                return a - b;
            });
            var n = parseInt((dd.length / 2).toString());
            var s1 = "";
            if (dd.length % 2 == 1) {
                s1 = dd[n].toString();
            } else {
                s1 = ((dd[n] + dd[n - 1]) / 2).toString();
            }
            return s1;
        };
        this.computeMin = function (range) {
            var min = this.maxValue;
            var d;
            var s1;

            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var rang = range.split(';');
            if (rang.length > 1) {
                for (var r = 0; r < rang.length; r++) {
                    var valRange = this.splitArgsPreservingQuotedCommas(rang[r]);
                    for (var s = 0; s < valRange.length; s++) {
                        var tempval = this.getValueFromArg(valRange[s]);
                        tempval = (tempval.split(this.tic).join("") == "TRUE") ? "1" : (tempval.split(this.tic).join("") == "FALSE") ? "0" : tempval;
                        if (tempval.length > 0) {
                            d = this._parseDouble(tempval);
                            if (!isNaN(d)) {
                                min = Math.min(min, d);
                            } else if (this.getErrorStrings().indexOf(tempval) == -1) {
                                return tempval;
                            }
                        }
                    }
                }
                if (min != this.maxValue) {
                    return min.toString();
                }
            }
            for (var r = 0; r < ranges.length; r++) {
                ////cell range
                if (ranges[r].indexOf(':') > -1) {
                    var cell = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cell.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cell[s]);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d)) {
                                min = Math.min(min, d);
                            } else if (this.getErrorStrings().indexOf(s1) != -1) {
                                return s1;
                            }
                        }
                    }
                } else {
                    try {
                        //To check the error string #VALUE! for invalid argument
                        if (!this._isCellReference(ranges[r]) && ranges[r][0] == this.tic) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getErrorStrings()[1].toString();
                            return this.getErrorStrings()[1].toString();
                        }
                        s1 = (ranges[r] == this._string_empty) ? "0" : this.getValueFromArg(ranges[r]);
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        if (s1 == "" && this._isCellReference(ranges[r])) {
                            s1 = "0";
                        }
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        d = this._parseDouble(s1);
                        if (!isNaN(d)) {
                            min = Math.min(min, d);
                        } else if (this.getErrorStrings().indexOf(s1) != -1) {
                            return s1;
                        }
                    }
                }
            }
            if (min != this.maxValue) {
                return min.toString();
            }

            return this._string_empty;
        };
        this.computeMina = function (range) {
            var min = this.maxValue;
            var d;
            var s1;

            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            var rang = range.split(';');
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (rang.length > 1) {
                for (var r = 0; r < rang.length; r++) {
                    var valRange = this.splitArgsPreservingQuotedCommas(rang[r]);
                    for (var s = 0; s < valRange.length; s++) {
                        var tempval = this.getValueFromArg(valRange[s]);
                        if (tempval.length > 0) {
                            d = 0;
                            if (tempval.toUpperCase() == (this.trueValueStr)) {
                                d = 1;
                            } else if (this.getErrorStrings().indexOf(tempval) == -1) {
                                return tempval;
                            } else {
                                tempval = (tempval.split(this.tic).join("") == "TRUE") ? "1" : (tempval.split(this.tic).join("") == "FALSE") ? "0" : tempval;
                                d = this._parseDouble(tempval);
                            }

                            min = Math.min(min, d);
                        }
                    }
                }
                if (min != this.maxValue) {
                    return min.toString();
                }
            }
            for (var r = 0; r < ranges.length; r++) {
                ////cell range
                if (ranges[r].indexOf(':') > -1) {
                    var cell = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cell.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cell[s]);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            d = 0;
                            if (s1.toUpperCase() == (this.trueValueStr)) {
                                d = 1;
                            } else if (s1.toUpperCase() == (this.falseValueStr)) {
                                d = 0
                            } else if (this.getErrorStrings().indexOf(s1) != -1) {
                                return s1;
                            } else {
                                d = this._parseDouble(s1);
                            }

                            min = Math.min(min, d);
                        }
                    }
                } else {
                    try {
                        if ((!ranges[r].startsWith(this.tic)) && ranges[r] == "") {
                            s1 = "0";
                        }
                        else {
                            s1 = this.getValueFromArg(ranges[r]);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                            if (s1 == "") {
                                s1 = "0";
                            }
                        }
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        d = 0;
                        if (s1.toUpperCase() == (this.trueValueStr)) {
                            d = 1;
                        } else if (this.getErrorStrings().indexOf(s1) > -1) {
                            return s1;
                        } else {
                            d = this._parseDouble(s1);
                        }

                        min = Math.min(min, d);
                    }
                }
            }
            if (min != this.maxValue) {
                return min.toString();
            }

            return this._string_empty;
        };
       
        this.computePercentrankInc = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 && argCount != 3 || range == "") {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if ((args[0] != "" && args[1] == "") || (args[1] != "" && args[0] == "")) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[0].toString(); 
                return this.getErrorStrings()[0].toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                for (var i = 1; i < argCount; i++) {
                    checkString = this.formulaErrorStringCheck(args[i], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            var x;
            var signif = 3;
            var s1 = this.getValueFromArg(args[1]);
            if (s1 == "") {
                s1 = "0";
            }
            x = this._parseDouble(s1);
            if (isNaN(x)) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._invalid_arguments];
                }
                return this.formulaErrorStrings[this._invalid_arguments];
            } else if (x == 0) {
            }

            if (argCount == 3) {
                args[2] = (args[2].split(this.tic).join("") == "TRUE") ? "1" : (args[2].split(this.tic).join("") == "FALSE") ? "0" : args[2];
                s1 = this.getValueFromArg(args[2]);
                signif = this._parseDouble(s1);
                if (isNaN(signif) || signif < 1) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    }
                    return this.getErrorStrings()[4].toString();
                }
            }
            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;

            dd.sort();

            var d = 1;
            for (var i = 0; i < n; ++i) {
                if (dd[i] == x) {
                    var k = 0;
                    while (k + i < n && dd[k + i] == x) {
                        k++;
                    }

                    d = ((i - 1)) / (i + n - i - k - 1);

                    if (i > 0 && dd[i - 1] < x) {
                        var di = (i) / (n - 1);
                        d = di + (d - di) * (1 - (x - dd[i - 1]) / (dd[i] - dd[i - 1]));
                    }

                    break;
                }
            }
            var fmt = "0." + ('#', parseInt(signif.toString()));
            return d.toString();
        };
        
        this.computeRankOEq = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if ((argCount != 2 && argCount != 3) || range == "") {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var rank = 0;
            var x;
            var s1 = this.getValueFromArg(args[0]);
            if (args[0] == this._string_empty || args[1] == this._string_empty || !(this._isCellReference(args[1])))
                return this.getErrorStrings()[4].toString();
            x = this._parseDouble(s1);
            if (!isNaN(x)) {
                var order = 0;
                if (argCount == 3) {
                    if (this.getEnableFormulaErrorValidation()) {
                        var checkString2 = this.formulaErrorStringCheck(args[2], FormulaArgumentType.Numbers);
                        if (this.getErrorStrings().indexOf(checkString2) > -1) {
                            return checkString2;
                        }
                    }
                    s1 = this.getValueFromArg(args[2]);
                    s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                    if (s1 == this._string_empty)
                        s1 = "0";
                    else if (this._parseDouble(s1) > 1)
                        s1 = "1";
                    order = this._parseDouble(s1);
                }

                var r = args[1];

                var d = 0;
                var eq = false;
                if (r.indexOf(":") == -1)
                    return this.getErrorStrings()[4].toString();
                if (r.indexOf(':') > -1) {
                    var cells1 = this.getCellsFromArgs(r);
                    for (var s = 0; s < cells1.length; s++) {
                        try {
                            s1 = this._getDoubleArray(cells1[s]);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }
                        d = this._parseDouble(s1.toString());
                        if (!isNaN(d)) {
                            if (order == 1) {
                                if (d < x) {
                                    rank += 1;
                                } else if (d == x) {
                                    eq = true;
                                }
                            } else {
                                if (d > x) {
                                    rank += 1;
                                } else if (d == x) {
                                    eq = true;
                                }
                            }
                        }
                    }

                    if (eq) {
                        rank += 1;
                    }
                }
            }
            return rank.toString();
        };
        this.computePercentile = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var k;
            var s1 = this.getValueFromArg(args[1]);
            k = this._parseDouble(s1);
            if (isNaN(k) && (k < 0 || k > 1)) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }

            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;

            dd.sort(function (a, b) {
                if (isNaN(a) || isNaN(b)) {
                    if (a < b) return 1;
                    else return -1;
                }
                return a - b;
            });

            var h = 1 / (n - 1);
            var d = dd[n - 1];
            for (var i = 0; i < n - 1; ++i) {
                if ((i + 1) * h > k) {
                    k = (k - i * h) / h;
                    d = dd[i] + k * (dd[i + 1] - dd[i]);
                    break;
                }
            }
            return d.toString();
        };
        this.computePoissonODist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3) {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var x;
            var u;
            var cum = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
            }
            x = this._parseDouble(args[0]);
            u = this._parseDouble(args[1]);
            if (!isNaN(x) && !isNaN(u)) {
                cum = (args[2] == this.trueValueStr) ? 1 : 0;
                var n = x;
                if (cum == 0) {
                    var prod = 1;
                    for (var i = 2; i <= n; ++i) {
                        prod *= i;
                    }
                    dist = Math.exp(-u) * Math.pow(u, n) / prod;
                } else {
                    var prod = 1;
                    dist = 0;
                    var ui = 1;
                    for (var i = 0; i <= n; ++i) {
                        dist += ui / prod;
                        prod *= i + 1;
                        ui *= u;
                    }

                    dist = Math.exp(-u) * dist;
                }
            }
            return dist.toString();
        };
        this.computeWeiBullODist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;

            if (argCount != 4 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var alpha;
            var beta;
            var cumulative = 0;
            var cumBool = true;

            for (var i = 0; i < argCount; ++i)
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
            x = this._parseDouble(args[0]);
            alpha = this._parseDouble(args[1]);
            beta = this._parseDouble(args[2]);
            if (!isNaN(x) && !isNaN(alpha) && !isNaN(beta)) {
                if (x < 0 || alpha <= 0 || beta <= 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw "Passed argument value is below 0";
                    return this.getErrorStrings()[4].toString();
                }
                if (alpha.toString().length >= 5 && beta.toString().length >= 3) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw "Passed argument length exceeded the minimum length";
                    return this.getErrorStrings()[4].toString();
                }
                if (argCount != 3) {
                    cumulative = (args[3] == this.trueValueStr) ? 1 : 0;
                    var check = 0;
                    check = this._parseDouble(args[3]);
                    if (!isNaN(check))
                        cumulative = 1;
                }

                cumBool = (cumulative == 1) ? true : false;
                cumulative = ((cumBool) ? 1 - Math.exp(-Math.pow(x / beta, alpha)) : Math.pow(x, alpha - 1) * Math.exp(-Math.pow(x / beta, alpha)) * alpha / Math.pow(beta, alpha));
            } else {
                if (this._rethrowLibraryComputationExceptions)
                    throw "Passed argument value is non-numerical";
                return this.getErrorStrings()[1].toString();
            }
            return cumulative.toString();
        };
        this.computeFOinvOrt = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var p;
            var df1;
            var df2;
            var invdist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            p = this._parseDouble(args[0]);
            df1 = this._parseDouble(args[1]);
            df2 = this._parseDouble(args[2]);

            if (!isNaN(p) && (p > 0 && p < 1) && !isNaN(df1) && !isNaN(df2)) {
                if ((p < 0 || p > 1) || (df1 < 1 || df2 < 1)) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw "#NUM! Passed Argument value is less than or equal to minimum value";
                    }
                invdist = this._finv(p, df1, df2);
            }

            if (invdist <= 0) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.getErrorStrings()[4].toString();
            }
            return invdist.toString();
        };
        this.computeTOdist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var df1 = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
            }
            args[0] = (args[0] == null || args[0] == "") ? "0" : args[0];
            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = (args[1] == null || args[1] == "") ? "0" : args[1];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            x = this._parseDouble(args[0]);
            df1 = this._parseDouble(args[1]);
            if (!isNaN(x) && !isNaN(df1)) {
                if (df1 < 1 || (x[0] == ("-"))) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "#NUM! Passed argument value is incorrect";
                    }
                    return this.getErrorStrings()[4].toString();
                }

                if (args[2] == this.trueValueStr) {
                    dist = this._tCumulativeDensity(x, df1);
                    //dist = StudentsTCumulativeDistributionFunctionInverse(x, (int)u);
                } else if (args[2] == this.falseValueStr) {
                    dist = this._tProbabilityDensity(x, df1);
                }
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#VALUE! Passed argument value is incorrect";
                }
                return this.getErrorStrings()[1].toString();
            }

            return dist.toString();
        };
        this.computeAvedev = function (range) {
            var sum = 0, s1, d, ranges;
            var x = [];
            ranges = this.splitArgsPreservingQuotedCommas(range);
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var adjustRange;
            for (var r = 0; r < ranges.length; r++) {
                adjustRange = ranges[r];

                ////is a cellrange
                if (adjustRange.indexOf(':') > -1) {
                    var cellCollection = this.getCellsFromArgs(adjustRange);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cellCollection[s]).split(this.tic).join(this._string_empty);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }
                            return ex;
                        }

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d)) {
                                sum = sum + d;
                                x.push(d);
                            } else if ((this.getErrorStrings().indexOf(s1)) > 0) {
                                return s1;
                            }
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(adjustRange).split(this.tic).join(this._string_empty);
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        if (this.getEnableFormulaErrorValidation()) {
                            var checkString = this.formulaErrorStringCheck(s1, FormulaArgumentType.Numbers);
                            if (this.getErrorStrings().indexOf(checkString) > -1) {
                                return checkString;
                            }
                        }
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }
                    if (s1.length > 0) {
                        d = this._parseDouble(s1);
                        if (!isNaN(d)) {
                            sum = sum + d;
                            x.push(d);
                        } else if ((this.getErrorStrings().indexOf(s1) == -1)) {
                            return s1;
                        }
                    }
                }
            }

            if (x.length > 0) {
                var ave = sum / x.length;
                sum = 0;
                for (var i = 0; i < x.length; ++i) {
                    sum = sum + Math.abs((x[i]) - ave);
                }

                sum = sum / x.length;
            }
            return sum.toString();
        };
        this.computeTOinv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var df1 = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join(this._string_empty);
            }
            args[0] = (args[0] == "" || args[0] == null) ? "0" : args[0];
            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = (args[1] == "" || args[1] == null) ? "0" : args[1];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            x = this._parseDouble(args[0]);
            df1 = this._parseDouble(args[1]);
            if (!isNaN(x) && !isNaN(df1)) {
                if (df1 < 1 || x < 0 || (x[0] == ("-"))) {
                    if (this._rethrowLibraryComputationExceptions) {
                        throw "#NUM! Passed argument value is incorrect";
                    }
                    return this.getErrorStrings()[4].toString();
                }
                dist = this._tCumulativeDistributionInverse(x, df1);
            } else {
                if (this._rethrowLibraryComputationExceptions) {
                    throw "#VALUE! Passed argument value is incorrect";
                }
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        };
       
        this.computeChisqOinv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var p;
            var v;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }

            p = this._parseDouble(args[0]);
            v = this._parseDouble(args[1]);
            if (!isNaN(p) && !isNaN(v)) {
                if (p < 0 || p >= 1 || v <= 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                if (p == 0) {
                    return "0";
                }
                dist = this._chiinv(p, v);
                return dist.toString();
            }
        };
        this.computeCount = function (range) {
            var count = 0;
            var s1;
            var d;
            var dt = new Date;
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var ranges = this.splitArgsPreservingQuotedCommas(range);
            for (var r = 0; r < ranges.length; r++) {
                ////is a cellrange
                if (ranges[r].indexOf(':') > -1) {
                    var cell = this.getCellsFromArgs(ranges[r].split(this.tic).join(""));
                    for (var s = 0; s < cell.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cell[s]);
                            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                        } catch (Exception) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getLibraryComputationException();
                            return this.getErrorStrings()[4].toString();
                        }

                        if (s1.length > 0) {
                            if (s1 == (this.formulaErrorStrings[19])) {
                                if (this.geLibraryComputationException() != null)
                                    throw this.getLibraryComputationException();
                                return this.formulaErrorStrings[19];
                            }
                            d = this._parseDouble(s1);
                            dt = new Date(Date.parse(s1));
                            if ((!isNaN(d) || dt.toString() != "Invalid Date") && this.getErrorStrings().indexOf(s1) == -1) {
                                count++;
                            }
                        }
                    }
                } else {
                    try {
                        if (ranges[r] == this._string_empty && !(ranges[r][0] == (this.tic)))
                            count++;
                        s1 = this.getValueFromArg(ranges[r].split(this.tic).join(""));
                        s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
                    } catch (Exception) {
                        if (this.getLibraryComputationException() != null)
                            throw this.getLibraryComputationException();
                        throw this.getErrorStrings()[4].toString();
                    }

                    if (s1.length > 0) {
                        if (s1[0] == (this.formulaErrorStrings[19])) {
                            if (this.getLibraryComputationException() != null)
                                throw this.getLibraryComputationException();
                            return this.formulaErrorStrings[19];
                        }
                        d = this._parseDouble(s1);
                        dt = new Date(Date.parse(s1));
                        if ((!isNaN(d) || dt.toString() != "Invalid Date") && this.getErrorStrings().indexOf(s1) == -1) {
                            count++;
                        }
                    }
                }
            }
            return count.toString();
        };
        this.computeFOdistORt = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var x;
            var df1 = 0;
            var df2 = 0;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]).split(this.tic).join("");
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            x = this._parseDouble(args[0]);
            df1 = this._parseDouble(args[1]);
            df2 = this._parseDouble(args[2]);
            if (!isNaN(x) && !isNaN(df1) && !isNaN(df2)) {
                if (x < 0 || df1 < 1 || df2 < 1) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._wrong_number_arguments];
                    return this._errorStrings[4].toString();
                }
                var mult = Math.exp(this._gammaln((df1 + df2) / 2) - this._gammaln(df1 / 2) - this._gammaln(df2 / 2) + (df1 / 2) * Math.log(df1 / df2));

                dist = 1 - mult * this._fdist(x, parseInt(df1.toString()), parseInt(df2.toString()));
            } else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this.invalid_Math_argument];
                return this._formulaErrorStrings[this._invalid_Math_argument];
            }
            return dist.toString();
        };
        this.computeGeomean = function (range) {
            var sum = 1;
            var s1;
            var d;
            var count = 0;

            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            for (var r = 0; r < ranges.length; r++) {
                ////is a cellrange
                if (ranges[r].indexOf(':') > -1) {
                    if (r[0] == this.tic) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._invalid_arguments];
                        return this.getErrorStrings()[1].toString();
                    }
                    var cell = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cell.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cell[s]);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d)) {
                                count++;
                                sum = sum * d;
                            } else if (this.getErrorStrings().indexOf(s1) == -1) {
                                return s1;
                            }
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges[r]);
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        if (this.getEnableFormulaErrorValidation()) {
                            var checkString = this.formulaErrorStringCheck(s1, FormulaArgumentType.Numbers);
                            if (this.getErrorStrings().indexOf(checkString) > -1) {
                                return checkString;
                            }
                        }
                        d = this._parseDouble(s1);
                        if (!isNaN(d)) {
                            count++;
                            sum = sum * d;
                        } else if (this.getErrorStrings().indexOf(s1) == -1) {
                            return s1;
                        }
                    }
                }
            }

            if (count > 0) {
                sum = Math.pow(sum, 1 / count);
            }
            return sum.toString();
        };
        this.computeHarmean = function (range) {
            var sum = 0;
            var s1;
            var d;
            var count = 0;

            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            for (var r = 0; r < ranges.length; r++) {
                ////is a cellrange
                if (ranges[r].indexOf(':') > -1) {
                    if (r[0] == this.tic) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._invalid_arguments];
                        return this.getErrorStrings()[1].toString();
                    }
                    var cell = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cell.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cell[s]);
                        } catch (ex) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return ex;
                        }

                        if (s1.length > 0) {
                            d = this._parseDouble(s1);
                            if (!isNaN(d) && d != 0) {
                                count++;
                                sum = sum + 1 / d;
                            } else if (this.getErrorStrings().indexOf(s1) == -1) {
                                return s1;
                            }
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges[r]);
                    } catch (ex) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        }

                        return ex;
                    }

                    if (s1.length > 0) {
                        if (this.getEnableFormulaErrorValidation()) {
                            var checkString = this.formulaErrorStringCheck(s1, FormulaArgumentType.Numbers);
                            if (this.getErrorStrings().indexOf(checkString) > -1) {
                                return checkString;
                            }
                        }
                        d = this._parseDouble(s1);
                        if (!isNaN(d) && d != 0) {
                            count++;
                            sum = sum + 1 / d;
                        } else if (this.getErrorStrings().indexOf(s1)) {
                            return s1;
                        }
                    }
                }
            }

            if (count > 0) {
                sum = (count) / sum;
            }
            return sum.toString();
        };
        this.computeIntercept = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            value1 = this.getValueFromArg(args[0]);
            value2 = this.getValueFromArg(args[1]);
            if (Boolean(value1) || Boolean(value2)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                 return this.getErrorStrings()[1].toString();
            }
            var y = this._getDoubleArray(args[0]);
            var x = this._getDoubleArray(args[1]);
            var n = x.length;

            if (n <= 0 || n != y.length) {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var sumx = 0;
            var sumy = 0;
            for (var i = 0; i < n; ++i) {
                sumx += x[i];
                sumy += y[i];
            }

            sumx = sumx / n;
            sumy = sumy / n;

            var sumxy = 0;
            var sumx2 = 0;
            var d;
            for (var i = 0; i < n; ++i) {
                d = x[i] - sumx;
                sumxy += d * (y[i] - sumy);
                sumx2 += d * d;
            }
            return (sumy - sumxy / sumx2 * sumx).toString();
        };
        this.computeCountblank = function (range) {
            var count = 0;
            var s1;

            this.adjustRangeArg(range);
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            var arglist;
            if (range == "" || ranges.length > 1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var r = 0; r < ranges.length; r++) {
                arglist = ranges[r];

                ////is a cellrange
                if (arglist.indexOf(':') > -1) {
                    var cellCollection = this.getCellsFromArgs(arglist);
                    for (var s = 0; s < cellCollection.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cellCollection[s]);
                        } catch (Exception) {
                            if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                                throw this.getLibraryComputationException();
                            }

                            return this.getErrorStrings()[4].toString();
                        }

                        if (s1 == this._string_empty) {
                            count++;
                        }
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges);
                    } catch (Exception) {
                        if (this._rethrowLibraryComputationExceptions && this.getLibraryComputationException() != null) {
                            throw this.getLibraryComputationException();
                        } else
                            return this.getErrorStrings()[4].toString();
                    }
                    if (!this._isCellReference(arglist)) {
                        var temp = this._parseDouble(s1);

                        if (!isNaN(temp) || this.getErrorStrings.indexOf(s1)) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.formulaErrorStrings[this._invalid_arguments].toString();
                            else
                                return this.formulaErrorStrings[this._invalid_arguments].toString();
                        }
                        if (!(s1.split(this.tic).join(this._string_empty) == (this._string_empty))) {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.getErrorStrings()[5].toString();
                            else
                                return this.getErrorStrings()[5].toString();
                        } else {
                            if (this._rethrowLibraryComputationExceptions)
                                throw this.formulaErrorStrings[this._invalid_arguments].toString();
                            else
                                return this.formulaErrorStrings[this._invalid_arguments].toString();
                        }
                    }
                    if (s1 == this._string_empty) {
                        count++;
                    }
                }
            }
            return count.toString();
        };
        this.computeDevsq = function (range) {
            var d;
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            var x = this._getDoubleArray(range);
            var n = x.length;
            if (range == "") {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (x.length <= 0)
            {
                if (this.getLibraryComputationException() != null)
                    throw this.formulaErrorStrings[this._bad_formula];
                throw this.getErrorStrings()[4].toString();
            }
            var sumx = 0;
            for (var i = 0; i < n; ++i) {
                sumx = sumx + x[i];
            }

            sumx = sumx / n;
            var sumx2 = 0;

            for (var i = 0; i < n; ++i) {
                d = x[i] - sumx;
                sumx2 = sumx2 + d * d;
            }
            return sumx2.toString();
        };
        this.computeForecast = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 3 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            for (var i = 1; i <= 2; i++) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString1 = this.formulaErrorStringCheck(args[i], FormulaArgumentType.Text);
                    if (this.getErrorStrings().indexOf(checkString1) > -1) {
                        return checkString1;
                    }
                }

            }
            var x0, d;
            var s1 = this.getValueFromArg(args[0]);
            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
            x0 = this._parseDouble(s1);
            if (isNaN(x0)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            var y, x;
            y = this._getDoubleArray(args[1]);
            x = this._getDoubleArray(args[2]);
            var n = x.length;

            if (n <= 0 || n != y.length) {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var sumx = 0;
            var sumy = 0;
            for (var i = 0; i < n; ++i) {
                sumx = sumx + x[i];
                sumy = sumy + y[i];
            }

            sumx = sumx / n;
            sumy = sumy / n;

            var sumxy = 0;
            var sumx2 = 0;
            for (var i = 0; i < n; ++i) {
                d = x[i] - sumx;
                sumxy = sumxy + d * (y[i] - sumy);
                sumx2 = sumx2 + d * d;
            }

            var b = sumxy / sumx2;
            var a = sumy - b * sumx;
            return (a + b * x0).toString();
        };
        
        this.computeStdevOp = function (range) {
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var dd = this._getDoubleArrayA(range);
            var n = dd.length;

            if (n < 2) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._invalid_arguments];
                }
                return this.formulaErrorStrings[this.invalid_arguments];
            }
            return this._stdevdotP(dd).toString();
        };
        this.computeStdevOS = function (range) {
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var dd = this._getDoubleArrayA(range);
            var n = dd.length;

            if (n < 2) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._invalid_arguments];
                }
                return this.formulaErrorStrings[this.invalid_arguments];
            }
            var xbar = 0;
            return this._sd(dd, xbar).toString();
        };
        this.computeStdeva = function (range) {
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var dd = this._getDoubleArrayA(range);
            var n = dd.length;
            if (n < 2) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }

            var xbar = 0;
            return this._sd(dd, xbar).toString();
        };
        this.computeStdevpa = function (range) {
            if (range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var dd = this._getDoubleArrayA(range);
            var n = dd.length;
            if (n < 2) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }

            var xbar = 0;
            var sdev = this._sd(dd, xbar);
            return (sdev * Math.sqrt(n - 1) / Math.sqrt(n)).toString();
        };
        this.computeVarp = function (range) {
            var dd = this._getDoubleArray(range);
            var n = dd.length;
            return ((n - 1) * this._var(dd) / n).toString();
        };
        this.computeVara = function (range) {
            var dd = this._getDoubleArrayA(range);
            return this._var(dd).toString();
        };
        this.computeVarpa = function (range) {
            var dd = this._getDoubleArrayA(range);
            var n = dd.length;
            return ((n - 1) * this._var(dd) / n).toString();
        };
        this.computeCorrel = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var arg1 = this.getValueFromArg(args[0]);
            var arg2 = this.getValueFromArg(args[1]);
            if ((arg1 == null || arg1 == "") || (arg2 == null || arg2 == "")) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this._errorStrings[1].toString();
            }
            var y, x;
            y = this._getDoubleArray(args[0]);
            x = this._getDoubleArray(args[1]);
            var n = x.length;
            if (n <= 0 || n != y.length) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this._errorStrings[0].toString();
            }

            var sumx = 0;
            var sumy = 0;
            for (var i = 0; i < n; ++i) {
                sumx = sumx + x[i];
                sumy = sumy + y[i];
            }

            sumx = sumx / n;
            sumy = sumy / n;

            var sumxy = 0;
            var sumxb2 = 0;
            var sumyb2 = 0;
            var xb = 0;
            var yb = 0;

            for (var i = 0; i < n; ++i) {
                xb = x[i] - sumx;
                yb = y[i] - sumy;
                sumxy = sumxy + xb * yb;
                sumxb2 = sumxb2 + xb * xb;
                sumyb2 = sumyb2 + yb * yb;
            }

            var result = (sumxy / Math.sqrt(sumxb2 * sumyb2)).toString();
            if (this.computeIsError(result) == this.trueValueStr) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this._errorStrings[3].toString();
            }
            //  var v = (sumxy / Math.Sqrt(sumxb2 * sumyb2)).toString();
            //        return v;
            return (sumxy / Math.sqrt(sumxb2 * sumyb2)).toString();
        };

        this.computeNegbinomODist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 4) {
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            var successes;
            var failures;
            var p;
            var dist = 0;

            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
            }
            failures = this._parseDouble(args[0]);
            successes = this._parseDouble(args[1]);
            p = this._parseDouble(args[2]);
            if (!isNaN(failures) && !isNaN(successes) && !isNaN(p)) {
                dist = this._negbinomdensity(parseInt(failures.toString()), parseInt(successes.toString()), p);
            }
            return dist.toString();
        };

        this.computePercentileExc = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                var checkString1 = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString1) > -1) {
                    return checkString1;
                }
            }
            var k;
            var s1 = this.getValueFromArg(args[1]);
            var s2 = this.getValueFromArg(args[0]);
            if ((s1 == null || s1 == "") || (s2 == "" || s2 == null) || Boolean(s1 == "TRUE" || s1 == "FALSE") || Boolean(s2 == "TRUE" || s2 == "FALSE")) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            k = this._parseDouble(s1);
            if (isNaN(k) && (k < 0 || k > 1)) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }
            var ss = this._parseDouble(s1);
            if (ss == 0 || ss <= 0 || ss >= 1) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.getErrorStrings()[4].toString();
                }
                return this.getErrorStrings()[4].toString();
            }
            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;

            dd.sort(function (a, b) {
                if (isNaN(a) || isNaN(b)) {
                    if (a < b) return 1;
                    else return -1;
                }
                return a - b;
            });

            var num = dd.length;
            if (k <= this._parseDouble((1 / (num + 1)).toString()) || k >= this._parseDouble((num / (num + 1)).toString())) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.getErrorStrings()[4].toString();
                }
                return this.getErrorStrings()[4].toString();
            }
            var l = k * (num + 1);
            return l.toString();
        };

        this.computePercentileOInc = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                }
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var k;
            var s1 = this.getValueFromArg(args[1]);
            var s2 = this.getValueFromArg(args[0]);
            if ((s1 == null || s1 == "") || (s2 == null || s2 == "") || Boolean(s1 == "TRUE" || s1 == "FALSE") || Boolean(s2 == "TRUE" || s2         == "FALSE")) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            k = this._parseDouble(s1);
            if (isNaN(k) && (k < 0 || k > 1)) {
                return this.formulaErrorStrings[this._invalid_arguments];
            }
            var ss = this._parseDouble(s1);
            if (ss == 0 || ss <= 0 || ss >= 1) {
                if (this._rethrowLibraryComputationExceptions) {
                    throw this.getErrorStrings()[4].toString();
                }
                return this.getErrorStrings()[4].toString();
            }
            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;

            dd.sort();

            var h = 1 / (n - 1);
            var d = dd[n - 1];
            for (var i = 0; i < n - 1; ++i) {
                if ((i + 1) * h > k) {
                    k = (k - i * h) / h;
                    d = dd[i] + k * (dd[i + 1] - dd[i]);
                    break;
                }
            }
            return d.toString();
        };

        this.computeTrimmean = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                var checkString1 = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString1) > -1) {
                    return checkString1;
                }
            }
            var percent;
            var s1 = this.getValueFromArg(args[1]);
            s1 = (s1.split(this.tic).join("") == "TRUE") ? "1" : (s1.split(this.tic).join("") == "FALSE") ? "0" : s1;
            percent = this._parseDouble(s1);
            if (isNaN(percent)) {
                percent = "1";
            }

            if (percent > 1 || percent == 0 || percent < 0) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[4].toString();
            }
            var dd = this._getDoubleArray(args[0]);
            var n = dd.length;
            var k = parseInt((percent * n).toString());
            k = parseInt(k / 2);
            dd.sort(function (a, b) {
                if (isNaN(a) || isNaN(b)) {
                    if (a > b) return 1;
                    else return -1;
                }
                return a - b;
            });
            var sum = 0;
            n = n - k;
            for (var i = k; i < n; ++i) {
                sum += dd[i];
            }
            return (sum / (n - k)).toString();
        };

        this.computePearson = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length;
            if (argCount != 2 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            if ((args[0] == null || args[0] == "") || (args[1] == null || args[1] == "") || Boolean(args[0] == "TRUE" || args[0] == "FALSE") || Boolean(args[1] == "TRUE" || args[1] == "FALSE")) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            var y = this._getDoubleArray(args[0]);
            var x = this._getDoubleArray(args[1]);
            var n = y.length;
            if (n <= 0 || !isNaN(y)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[4].toString();
            }
            var result = this._pearson(x, y, n).toString();

            if ( this.computeIsErr(result) == this.trueValueStr) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[3].toString();
            }
            return result;
        };

        this.computeRsq = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            if (args.length != 2) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(range, FormulaArgumentType.Range);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var s = this.computePearson(range).toString();
                var d = 0;
                d = this._parseDouble(s);
                if (!isNaN(d)) {
                    d = d * d;
                } else if (this.getErrorStrings().indexOf(s) != -1) {
                    return s;
                }
                return d.toString();
            try {
            }
            catch (ex) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_Math_argument];
                return this.getErrorStrings()[5].toString();
            }
        };

        this.computeHLookUp = function (range) {
            var cachingEnabled = this._isHLookupCachingEnabled();
            var optimizedMatchesEnabled = this._isOptimizedMatchesEnabled();
            if (cachingEnabled && this._lookupTables == null)
                this.lookupTables = new HashTable();

            var s = this.splitArgsPreservingQuotedCommas(range);
            if (s.length > 4 || range == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(s[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(s[1], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                for (var i = 2; i < s.length; i++) {
                    checkString = this.formulaErrorStringCheck(s[i], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }

            var lookUp = this.getValueFromArg(s[0]);
            lookUp = lookUp.split(this.tic).join("").toUpperCase();
            var r = s[1].split("\"").join("");
            var o1 = this.getValueFromArg(s[2]).split(this.tic).join("");
            var d = this._parseDouble(o1);
            if (isNaN(d)) {
                return "#N/A";
            }

            ////int row = int.Parse(o1);
            var row = parseInt(o1);

            var match = true;
            if (s.length == 4) {
                match = this.getValueFromArg(s[3]) == this.trueValueStr;
            }

            d = this._parseDouble(lookUp);
            var typeIsNumber = match ? !isNaN(d) : false;

            var i = r.indexOf(":");

            ////single cell
            if (i == -1) {
                r = r + ":" + r;
                i = r.indexOf(":");
            }

            var k = r.substring(0, i).lastIndexOf(this.sheetToken);
            var grd = this.grid;
            var family = CalcEngine.getSheetFamilyItem(this.grid);

            if (k > -1) {
                this.grid = family.tokenToParentObject.getItem(r.substring(0, k + 1));
            }

            var row1 = this.rowIndex(r.substring(0, i));
            var row2 = this.rowIndex(r.substring(i + 1));
            if (!(row1 != -1 || row2 == -1) == (row1 == -1 || row2 != -1)) {
                return this.getErrorStrings()[5].toString();
            }

            var col1 = this.colIndex(r.substring(0, i));
            var col2 = this.colIndex(r.substring(i + 1));

            var newTable = false;
            var key = "";
            var lookUpTable = null;
            var matchedTable = null;
            if (cachingEnabled) {
                key = row1.toString() + "_" + col1.toString() + "_" + col2.toString() + "_" + this.grid.GetHashCode();

                if (!this._lookupTables.containsKey(key)) {
                    if (optimizedMatchesEnabled) {
                        var _lookUp = new LookUps();
                        _lookUp.setMatchLookUpList(new HashTable());
                        this._lookupTables.add(key, _lookUp);
                    } else {
                        var _lookUp = new LookUps();
                        this._lookupTables.add(key, _lookUp);
                    }
                    newTable = true;
                }
                lookUpTable = this._lookupTables.getItem(key).getLinearLookUpList();
                if (optimizedMatchesEnabled) {
                    matchedTable = this._lookupTables.getItem(key).getMatchLookUpList();
                }
            }

            var val = "";
            var lastCol = col1;
            var s1 = "";
            var d1 = 0;
            var doLastColMark = true;
            var exactMatch = false;
            if (cachingEnabled && optimizedMatchesEnabled && matchedTable.containsKey(lookUp)) {
                lastCol = matchedTable.getItem(lookUp);
                s1 = lookUp;
            } else {
                for (var col = col1; col <= col2; ++col) {
                    if (!cachingEnabled || col - col1 >= lookUpTable.length || newTable) {
                        s1 = this.getValueFromParentObject(this.grid, row1, col).toString().toUpperCase().split("\"").join("");
                        if (cachingEnabled) {
                            lookUpTable.push(s1);
                            if (optimizedMatchesEnabled) {
                                matchedTable.add(s1, col);
                            }
                        }
                    } else {
                        s1 = lookUpTable[col - col1];
                    }
                    d1 = (typeIsNumber) ? this._parseDouble(s1) : d1;
                    if (s1 == lookUp || (match && (typeIsNumber ? (!isNaN(d1) && d1 > d) : (s1 > lookUp)))) {
                        if (s1 == lookUp) {
                            lastCol = col;
                            match = true;
                            exactMatch = true;
                        }

                        if (!newTable)
                            break;
                        else
                            doLastColMark = false;
                    }
                    if (doLastColMark)
                        lastCol = col;
                    match = newTable = true;
                }
            }

            if (match || s1 == lookUp) {
                if (!exactMatch && !typeIsNumber) {
                    this.grid = grd;
                    return "#N/A";
                }
                if ((row + row1 - 1) > row2)
                    return "#REF!";
                val = this.getValueFromParentObject(this.grid, row + row1 - 1, lastCol).toString();
                if (val.length > 0 && val[0] == this.getFormulaCharacter()) {
                    val = this.parseFormula(val);
                }

                d = this._parseDouble(val);
                if (val.length > 0 && val[0] != this.tic[0] && isNaN(d)) {
                    val =   val ;
                }
            } else {
                val = "#N/A";
            }

            ////val = "\"#N/A\"";
            this.grid = grd;

            return val;
        };
        this.computeIndex = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            var argCount = args.length;

            if (argCount < 2 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                if (argCount == 3) {
                    checkString = this.formulaErrorStringCheck(args[2], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            var r = args[0];
            r = r.split(this.tic).join("");
            var i = r.indexOf(":");

            ////single cell
            if (i == -1) {
                if (this._isCellReference(r)) {
                    r = r + ":" + r;
                } else {
                    if (r.indexOf(";") > -1)
                    {
                        var rowNumber = parseInt(this.getValueFromArg(args[1]));
                        var arr = this._splitArguments(r, ';');
                        var colInd = (argCount == 3) ? parseInt(this.getValueFromArg(args[2])) : 1;
                        try
                        {
                            rowNumber = (rowNumber == 0) ? 1 : rowNumber;
                            colInd = (colInd == 0) ? 1 : colInd;
                            var colArray = this.splitArgsPreservingQuotedCommas(arr[rowNumber -1]);
                            return colArray[colInd -1];
                        }
                        catch(ex)
                        {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.formulaErrorStrings[this._invalid_Math_argument];
                            return this.getErrorStrings()[2].toString();
                        }
                    }
                    var indexArray = this.splitArgsPreservingQuotedCommas(r);
                    if (!isNaN(rowNumber) && rowNumber > 0) {
                        if (indexArray.length >= rowNumber) {
                            return (parseInt(rowNumber.toString()) == 0) ? indexArray[0] : indexArray[parseInt(rowNumber.toString()) - 1];
                        } else {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.formulaErrorStrings[this._invalid_arguments];
                            return "#REF";
                        }
                    } else {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._invalid_arguments];
                        return this.getErrorStrings()[1].toString();
                    }
                }
            }
            i = r.indexOf(":");
            if (arg.indexOf("#N/A") > -1 || arg.indexOf("#N~A") > -1) {
                return "#N/A";
            }
            if (arg.indexOf("#DIV/0!") > -1 || arg.indexOf("#DIV~0!") > -1) {
                return "#DIV/0!";
            }
            var sheet = this._getSheetTokenFromReference(r);
            args[1] = (argCount == 1 || args[1] == "") ? "1" : args[1];
            args[2] = (argCount <= 2 || args[2] == "") ? "1" : args[2];
            args[1] = this.getValueFromArg(args[1]);
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            var d = parseInt(args[1]);
            var row = !isNaN(d) ? d : -1;
            args[2] = this.getValueFromArg(args[2]);
            args[2] = (args[2].split(this.tic).join("") == "TRUE") ? "1" : (args[2].split(this.tic).join("") == "FALSE") ? "0" : args[2];
            d = parseInt(args[2]);
            var col = !isNaN(d) ? d : -1;
            if (row == -1 || col == -1) {
                return "#REF";
            }

            var top = this.rowIndex(r.substring(0, i));
            var bot = this.rowIndex(r.substring(i + 1));
            if (!(top != -1 || bot == -1) == (top == -1 || bot != -1)) {
                return this.getErrorStrings()[5].toString();
            }

            var left = this.colIndex(r.substring(0, i));
            var right = this.colIndex(r.substring(i + 1));

            if (row > bot - top + 1 || col > right - left + 1) {
                return "#REF";
            }

            row = this.rowIndex(r.substring(0, i)) + row - 1;

            col = this.colIndex(r.substring(0, i)) + col - 1;

            var argsVal = sheet + RangeInfo.getAlphaLabel(col) + row;
            var result = this.getValueFromArg(argsVal);
            if (this._isTextEmpty(result))
                return "0";
            return result;
        };
        this.computeIndirect = function (args) {
            var arg = this.splitArgsPreservingQuotedCommas(args);
            var argCount = arg.length;

            if (argCount > 2 || argCount == 0 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                if (argCount == 2) {
                    checkString = this.formulaErrorStringCheck(arg[1], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            arg[0] = arg[0].toUpperCase();
            arg[0] = this.setTokensForSheets(arg[0]);
            var sheetToken1 = this._sheetToken(arg[0].split(this.tic).join(""));

            ////Remove SheetToken
            if (sheetToken1 != "") {
                arg[0] = arg[0].split(sheetToken1).join("");
            }

            if (arg.length == 2 && arg[1] == this.falseValueStr) {
                var hasTIC = arg[0][0] == this.tic && arg[0][args[0].length - 1] == this.tic;
                var rcCell = (arg[0].toUpperCase()).split(this.tic).join("");
                var cells = rcCell.split(':');
                
                var rc = (cells[0].split("R").join("C")).split("C");
                var index = rc.indexOf("");
                if (index > -1)
                    rc.splice(index, 1);
                if (rc.length > 2) {
                    return this.getErrorStrings()[2].toString();
                }

                arg[0] = RangeInfo.getAlphaLabel(parseInt(rc[1])) + rc[0];

                if (cells.length == 2) {
                    var st = this._sheetToken(cells[1]);
                    if (st != null || st != "") {
                        cells[1] = cells[1].split(st).join("");
                    }

                    rc = (cells[0].split("R").join("C")).split("C");
                    arg[0] += ":" + RangeInfo.getAlphaLabel(parseInt(rc[1])) + rc[0];
                }

                if (hasTIC) {
                    arg[0] = this.tic + arg[0] + this.tic;
                }
            }

            var cellReference = "";

            ////String
            if (arg[0][0] == this.tic) {
                cellReference = sheetToken1 + arg[0].split(this.tic).join("");
            } else {
                if (this._isCellReference(arg[0])) {
                    var scopedRange = "";
                    cellReference = this.getValueFromArg(sheetToken1 + arg[0]);
                    if (cellReference == null || cellReference == "") {
                        return "0";
                    }
                    if (this._isInteriorFunction) {
                        this._isInteriorFunction = !this._isInteriorFunction;
                        return arg[0].split(this._string_fixedreference).join("");
                    }

                    scopedRange = this._checkIfScopedRange(cellReference.toUpperCase());
                    if (this.getNamedRanges().containsKey(cellReference.toUpperCase())) {
                        cellReference = this.getNamedRanges().getItem(cellReference.toUpperCase());
                        cellReference = cellReference.toUpperCase();
                        cellReference = cellReference.split(this._string_fixedreference).join("");
                        cellReference = this.setTokensForSheets(cellReference);
                        if (cellReference[0] != this.sheetToken) {
                            cellReference = sheetToken1 + cellReference;
                        }
                    } else if (scopedRange != "NaN") {
                        cellReference = scopedRange;
                        cellReference = cellReference.toUpperCase();
                        cellReference = cellReference.split(this._string_fixedreference).join("");
                        cellReference = this.setTokensForSheets(cellReference);
                        if (cellReference[0] != this.sheetToken) {
                            cellReference = sheetToken1 + cellReference;
                        }
                    } else if (this._isCellReference(cellReference)) {
                        return this.getValueFromArg(cellReference);
                    } else if (cellReference.indexOf("Invalid" == 0))
                        return this.getErrorStrings()[2].toString();
                    else {
                        return cellReference;
                    }
                } else {
                    cellReference = arg[0];
                }
            }

            if (!this._isCellReference(cellReference.split(this._string_fixedreference).join(""))) {
                var scopedRange = "";
                scopedRange = this._checkIfScopedRange(cellReference.toUpperCase());
                if (this.getNamedRanges().containsKey(cellReference.toUpperCase())) {
                    cellReference = this.getNamedRanges().getItem(cellReference.toUpperCase());
                    if (cellReference[0] != this.sheetToken) {
                        cellReference = sheetToken1 + cellReference;
                    }
                } else if (scopedRange != "NaN") {
                    cellReference = scopedRange;
                    if (cellReference[0] != this.sheetToken) {
                        cellReference = sheetToken1 + cellReference;
                    }
                } else {
                    return this.getErrorStrings()[2].toString();
                }
            }

            if ((cellReference.indexOf(":") > -1 && this._isInteriorFunction) || (this.computedValueLevel>1)) {
                this._isInteriorFunction = !this._isInteriorFunction;

                return cellReference.split(this._string_fixedreference).join("");
            }
            return this.getValueFromArg(cellReference);
        };
        this.computeLookUp = function (range) {
            var cachingEnabled = this._isHLookupCachingEnabled();
            var optimizedMatchesEnabled = this._isOptimizedMatchesEnabled();
            if (cachingEnabled && this._lookupTables == null)
                this.lookupTables = new HashTable();

            var s = this.splitArgsPreservingQuotedCommas(range);
            if (s.length > 3 || range == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(s[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                for (var i = 1; i < s.length; i++) {
                    checkString = this.formulaErrorStringCheck(s[i], FormulaArgumentType.CellReference);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            var lookUp = this.getValueFromArg(s[0]);
            lookUp = lookUp.split(this.tic).join("").toUpperCase();

            var finalResult = "";
            var r = s[1].split("\"").join("");
            s[2] = (s.length = 3) ? s[2].split(this.tic).join("") : s[2];
            var tempLookUp = this.getValueFromArg(s[0]);
            var cellValue =  [];
            var resultValue = [];

            var o1 = this.getValueFromArg(s[2]).split(this.tic).join("");
            //var d = this._parseDouble(o1);
            //if (isNaN(d)) {
            //    return "#N/A";
            //}
            if (s.length == 2) {
                var secondOne = s[1];
                var stringArg = this.splitArgsPreservingQuotedCommas(s[1]);
                if (s[1].indexOf(";") > -1) {
                    var sepArg = this._splitArguments(s[1], ';');
                    if (sepArg.length == 1) {
                        var string1 = this.splitArgsPreservingQuotedCommas(sepArg[0].toUpperCase());
                        for (var cell = 0; cell < string1.length; cell++)  {
                            cellValue.push(this.getValueFromArg(string1[cell]).toUpperCase());
                            resultValue.push(this.getValueFromArg(string1[cell]).toUpperCase());
                        }
                    } else if (sepArg.length == 2) {
                        var strin1 = this.splitArgsPreservingQuotedCommas(sepArg[0].toUpperCase());
                        var strin2 = this.splitArgsPreservingQuotedCommas(sepArg[1].toUpperCase());
                        for (var cell = 0; cell < strin1.length; cell++) {
                            cellValue.push(this.getValueFromArg(strin1[cell]).toUpperCase());
                        }
                        for (var cell = 0; cell < strin2.length; cell++)  {
                            resultValue.push(this.getValueFromArg(strin2[cell]).toUpperCase());
                        }
                    } else
                        for (var y = 0; y < sepArg.length; y++) {
                            var strin1 = this.splitArgsPreservingQuotedCommas(sepArg[y].toUpperCase());
                            cellValue.push(this.getValueFromArg(strin1[0]).toUpperCase());
                            resultValue.push(this.getValueFromArg(strin1[1]).toUpperCase());
                        }
                } else {
                    if (s[1].indexOf(':') > -1) {
                        var cells = this.getCellsFromArgs(s[1]);
                        for (var cell1 = 0; cell1 < cells.length; cell1++)  {
                            cellValue.push(this.getValueFromArg(cells[cell1]).toUpperCase());
                            resultValue.push(this.getValueFromArg(cells[cell1]).toUpperCase());
                        }
                    } else {
                        var string1 = this.splitArgsPreservingQuotedCommas(s[1].toUpperCase());
                        for (var cell = 0; cell < string1.length; cell++)  {
                            cellValue.push(this.getValueFromArg(string1[cell]).toUpperCase());
                            resultValue.push(this.getValueFromArg(string1[cell]).toUpperCase());
                        }
                    }
                }
            } else if (s.length == 3) {
                if (r.indexOf(':') > -1) {
                    var cells = this.getCellsFromArgs(r);

                    for (var cell1 = 0; cell1 < cells.length; cell1++)  {
                        try  {
                            cellValue.push(this.getValueFromArg(cells[cell1]).toUpperCase());
                        } catch (ex) {
                            return this.getErrorStrings()[0].toString();
                        }
                    }
                } else {
                    var s2 = this.splitArgsPreservingQuotedCommas(s[1]);
                    for (var cell1 = 0; cell1 < s2.length; cell1++) {
                        try  {
                            cellValue.push(this.getValueFromArg(s2[cell1]).toUpperCase());
                        } catch (ex) {
                            return this.getErrorStrings()[0].toString();
                        }
                    }
                }
                var result = s[2];
                //Fix for the issue JS-29951.
                var str = s[2].split(":");
                var startCount = this.getRowIndexFromName(str[0]);
                var endCount = this.getRowIndexFromName(str[str.length - 1]);
                //deal with row wise
                if (startCount != endCount) {
                    str[str.length - 1] = str[str.length - 1].replace(endCount, +startCount + cellValue.length - 1);
                    result = str.join(':');
                }
                //deals with single cell and column wise
                else {
                    var columnIndex = this.computeColumn(result);
                    var resultIndex = +columnIndex + cellValue.length - 1;
                    var resultName = this.computeAddress(startCount + "," + resultIndex + ",4");
                    result = str[0] + ":" + resultName;
                }
                if (!this._isCellReference(result))
                    return this.getErrorStrings()[0].toString();
                if (result.indexOf(':') > -1) {
                    var cells = this.getCellsFromArgs(result);

                    for (var cell1 = 0; cell1 < cells.length; cell1++)  {
                        try  {
                            resultValue.push(this.getValueFromArg(cells[cell1]).toUpperCase());
                        } catch (ex) {
                            return this.getErrorStrings()[0].toString();
                        }
                    }
                } else {
                    var s2 = this.splitArgsPreservingQuotedCommas(s[1]);
                    for (var cell1 = 0; cell1 < s2.length; cell1++) {
                        try  {
                            resultValue.push(this.getValueFromArg(s2[cell1]).toUpperCase());
                        } catch (ex) {
                            return this.getErrorStrings()[0].toString();
                        }
                    }
                }
            }
            if (cellValue.indexOf(lookUp) == -1) {
                var temp = cellValue[0];
                var valCount = 0;
                for (var x = 0; x < cellValue.length; x++) {
                    if ((cellValue[x] > temp && lookUp > cellValue[x] && temp > lookUp) || lookUp > cellValue[x]) {
                        temp = (lookUp > cellValue[x]) ? cellValue[x] : cellValue[x+1];
                        valCount++;
                    } else if (valCount != 0)
                        break;
                }
                if (valCount == 0) {
                    return this.getErrorStrings()[0].toString();
                }
                lookUp = temp;
            }
            var no = 0;
            var index = 0;
            if (s.length == 3 && s[2].indexOf(':') > -1) {
                for (var y = 0; y < cellValue.length; y++) {
                    if (cellValue[y] == lookUp) {
                        index = cellValue.indexOf(lookUp);
                        no++;
                    } else if (no != 0)
                        break;
                }

                finalResult = resultValue[index + no - 1];
            } else {
                for (var y = 0; y < cellValue.length; y++) {
                    if (cellValue[y] == lookUp) {
                        index = cellValue.indexOf(lookUp);
                        no++;
                    } else if (no != 0)
                        break;
                }
                finalResult = resultValue[index + no - 1];
            }
            return finalResult;
        };
        this.computeOffSet = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            var argCount = args.length;

            if (argCount < 3 || argCount > 5 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                for (var index = 1; index < argCount; index++) {
                    if (index <= argCount) {
                         checkString = this.formulaErrorStringCheck(args[index], FormulaArgumentType.Numbers);
                         if (this.getErrorStrings().indexOf(checkString) > -1) {
                             return checkString;
                         }
                    }
                }
            }
            var r = args[0];
            var result;
            var d = this._parseDouble(this.getValueFromArg(args[1]));
            var rows = (!isNaN(d)) ? parseInt(d.toString()) : -1;
            d = this._parseDouble(this.getValueFromArg(args[2]));

            var cols = (!isNaN(d)) ? parseInt(d.toString()) : -1;
            var hightNum = (argCount >= 4) ? args[3] : "-1";
            d = parseInt(this.getValueFromArg(hightNum));
            var height = (!isNaN(d) ? (d) : 1);
            var widthNum = (argCount == 5) ? args[4] : "-1";
            d = parseInt(this.getValueFromArg(widthNum));
            var width = (!isNaN(d) ? (d) : 1);

            var i = r.indexOf(":");
            var singleCell = i == -1;

            ////single cell
            if (singleCell) {
                r = r + ":" + r;
                i = r.indexOf(":");
            }

            singleCell = (singleCell && width <= 1 && height <= 1); ////only treat as single cell if no hieght or width given...
            if (width == -1)
                singleCell = true;
            var sheet = this._getSheetTokenFromReference(r);

            var row1 = this.rowIndex(r.substring(0, i)) + rows;
            var row2 = this.rowIndex(r.substring(i + 1)) + rows;
            if (!(this.rowIndex(r.substring(0, i)) != -1 || this.rowIndex(r.substring(i + 1)) != -1) == ((this.rowIndex(r.substring(0, i)) == -1 || this.rowIndex(r.substring(i + 1)) != -1))) {
                return this.getErrorStrings()[5].toString();
            }

            var col1 = this.colIndex(r.substring(0, i)) + cols;
            var col2 = this.colIndex(r.substring(i + 1)) + cols;

            if (row1 <= 0 || col1 <= 0) {
                return this.getErrorStrings()[2].toString();
            }
            if ((height > 0 && width < 0) || (height < 1 && width > 1)) {
                row1 = this.rowIndex(this.cell);
            }
            if (col2 == (parseInt(this.computeColumn(r)) - 1))
                singleCell = true;
            var cellArg = sheet + RangeInfo.getAlphaLabel(col1) + row1;
            result = singleCell ? this.computedValue(cellArg) : cellArg + ":" + RangeInfo.getAlphaLabel(col1 + width - 1) + (row1 + height - 1);
            return result;
        };
        this.computeTranspose = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length !=1 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (!this._isCellReference(arg) && !this.getNamedRanges().containsKey(arg) && arg.indexOf(";") == -1) {
                var arrayArg = this._splitArguments(arg.split(this.tic).join(""), ';');
                if (arrayArg.length == 1) {
                    return this.getValueFromArg(this.splitArgsPreservingQuotedCommas(arrayArg[0])[0]);
                } else {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.formulaErrorStrings[this._invalid_arguments];
                }
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var args = this.splitArgsPreservingQuotedCommas(arg);
            var argCount = args.length;

            if (argCount != 1 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var firstRow, LastRow, firstCol, LastCol;
            var result = "";
            if (arg.indexOf(';') > -1) {
                var arrayArg = this._splitArguments(arg.split(this.tic).join(""), ';');
                for (var i = 1; i < arrayArg.length; i++) {
                    if (this.splitArgsPreservingQuotedCommas(arrayArg[i - 1]).length != this.splitArgsPreservingQuotedCommas(arrayArg[1]).length) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._wrong_number_arguments];
                        return this.formulaErrorStrings[this._wrong_number_arguments];
                    }
                }
                result = this.splitArgsPreservingQuotedCommas(arrayArg[0])[0];
            } else {
                var cells = this.getCellsFromArgs(arg);
                firstRow = this.rowIndex(cells[0].toString());
                LastRow = this.rowIndex(cells[cells.length - 1].toString());
                firstCol = this.colIndex(cells[0].toString());
                LastCol = this.colIndex(cells[cells.length - 1].toString());
                var currentCell = this.cell;
                var currentColIndex = this.colIndex(currentCell);
                var currentRowIndex = this.rowIndex(currentCell);
                var arrayHeight = LastRow - firstRow + 1;
                var arrayWidth = LastCol - firstCol + 1;
                var startRow, startCol, endRow, endCol;

                this._getFormulaArrayBounds(this.cell, arrayHeight, arrayWidth);

                startRow = this._getFormulaArrayBoundsfirstRowIndex;
                startCol = this._getFormulaArrayBoundsfirstColIndex;
                endRow = this._getFormulaArrayBoundslastRowIndex;
                endCol = this._getFormulaArrayBoundslastColIndex;

                var x = currentRowIndex - startRow;
                var y = currentColIndex - startCol;
                var i1 = arg.indexOf(":");

                ////single cell
                if (i1 == -1) {
                    arg = arg + ":" + arg;
                    i1 = arg.indexOf(":");
                }

                var k = arg.substring(0, i1).lastIndexOf(this.sheetToken);
                var grd = this.grid;
                var family = CalcEngine.getSheetFamilyItem(this.grid);

                if (k > -1) {
                    this.grid = family.tokenToParentObject[arg.substring(0, k + 1)];
                }
                result = this._getValueComputeFormulaIfNecessary(firstRow + y, firstCol + x, this.grid);
                this.grid = grd;
            }
            if (result == null || result == "")
                result = "0";
            return result;
        };
        this.computeEncodeURL = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;

            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            if (!this._isCellReference(args[0]) && !this.getNamedRanges().containsKey(args[0]) && args[0].indexOf(this.tic) == -1 && isNaN(this._parseDouble(args[0])) && !Boolean(args[0] == "TRUE" || args[0] == "FALSE")) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[5];
            }
            var text = this._stripTics0(this.getValueFromArg(args[0]));
            return encodeURIComponent(text);
        };
        

        this.computeAnd = function (range) {
            var sum = true, s1, d;
            if (range == null || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                else
                    return this.formulaErrorStrings[this._bad_formula];
            }
            var ranges = this.splitArgsPreservingQuotedCommas(range);
            for (var r = 0; r < ranges.length; r++) {
                if (ranges[r] == (this.tic)) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.getErrorStrings()[1].toString();
                    else
                        return this.getErrorStrings()[1].toString();
                }
                if (ranges[r].indexOf(':') > -1) {
                    cells = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cells.length; s++) {
                        if (this.getErrorStrings().indexOf(cells[s]) > -1) {
                            return cells[s];
                        } else if (cells[s][0] == this.tic) {
                            if (this.getRethrowLibraryComputationExceptions)
                                throw new this.getErrorStrings()[5].toString();
                            else
                                return this.getErrorStrings()[5].toString();
                        }
                        try {
                            s1 = this.getValueFromArg(cells[s]);
                            if (this.getErrorStrings().indexOf(s1) > -1) {
                                return s1;
                            }
                        } catch (ex) {
                            if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                                throw this.getErrorStrings()[4].toString();
                            }
                            return this.getErrorStrings()[4].toString();
                        }

                        sum = (sum & (s1 == "" ? true : ((s1.split(this.tic).join("").toUpperCase() == this.trueValueStr) || (d = this._parseDouble(s1)) && d != 0)));
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges[r]);
                        if (this.getErrorStrings().indexOf(s1) > -1) {
                            return s1;
                        }
                        var tempdate = Date.parse(s1.split(this.tic).join(""));
                        d = this._parseDouble(s1.split(this.tic).join(""))
                        if (!isNaN(tempdate)) {
                            return this.trueValueStr;
                        } else if (isNaN(d) && !(s1 == this._string_empty) && !(s1.split(this.tic).join("").toUpperCase() == this.trueValueStr || s1.split(this.tic).join("").toUpperCase() == this.falseValueStr)) {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.getErrorStrings()[1].toString();
                            else
                                return (this._isCellReference(ranges[r]) || s1[0] == this.tic) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
                        }
                    } catch (Exception) {
                        if (this.getRethrowLibraryComputationExceptions() && this.getLibraryComputationException() != null) {
                            throw this.getErrorStrings()[4].toString();
                        }

                        return this.getErrorStrings()[4].toString();
                    }
                    var dp = this._parseDouble(s1);
                    sum = (sum & ((s1.split(this.tic).join("").toUpperCase() == this.trueValueStr) || (!isNaN(dp) && d != 0)));
                    // sum &= (s1 == this.trueValueStr) || (d = this._parseDouble(s1)) && d != 0;
                }
            }
            return sum ? this.trueValueStr : this.falseValueStr;
        };
        this.computeFalse = function (empty) {
            var args = this.splitArgsPreservingQuotedCommas(empty);
            if (args.length > 0 && args != "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            return this.falseValueStr;
        };
        this.computeIf = function (args) {
            var s1 = this._string_empty;
            var array1 = this.splitArgsPreservingQuotedCommas(args);

            ////parsed formula
            if (array1.length == 1 || array1.length > 3 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            } else {
                var s = this.getCellsFromArgs(args);

                if (s.length >= 2) {
                    try {
                        s1 = this.getValueFromArg(s[0]);
                        if (this.getErrorStrings().indexOf(s1) != -1) {
                            return s1;
                        }
                        if ((!this._isCellReference(s[0]) && !isNaN(typeof s1 == "boolean") && s1.startsWith(this.tic)) || (this._isCellReference(s[0]) && s1.startsWith(this.tic))) {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.formulaErrorStrings[this._invalid_arguments];
                            return this.getErrorStrings()[1].toString();
                        }
                        var d;
                        if (s1.split(this.tic).join("") == this.trueValueStr || (d = this._parseDouble(s1)) && d != 0) {
                            if (this.getEnableFormulaErrorValidation()) {
                                var checkString = this.formulaErrorStringCheck(s[1], FormulaArgumentType.Text);
                                if (this.getErrorStrings().indexOf(checkString) > -1) {
                                    return checkString;
                                }
                            }
                            s1 = this.getValueFromArg(s[1]);
							//JS-44351 - Returns "0" when the output is empty and _treatStringsAsZero property is true.
                            if (s1 == "" && this.getTreatStringsAsZero()) {
                                return "0";
                            }
                        } else if (s1.split(this.tic).join("") == this.falseValueStr || (s1 == "") || (d = this._parseDouble(s1)) && d == 0) {
                            s1 = s.length == 3 ? this.getValueFromArg(s[2]) : false;
							//JS-44351 - Returns "0" when the output is empty and _treatStringsAsZero property is true.
                            if (s1 == "" && this.getTreatStringsAsZero()) {
                                return "0";
                            }
                            if (this.getErrorStrings().indexOf(s1) != -1) {
                                return s1;
                            }
                        } else {
                            //  if (this.tic().indexOf(s[0]) == -1)
                            if (s.indexOf(this.tic) > -1) {
                                var first = s[0].indexOf(this.tic) + 1;
                                var last = s[0].lastIndexOf(this.tic) - 1;
                                var st = s[0].substring(first, last - first + 1);
                                for (var err = 0; err < this.getFormulaErrorStrings().length; err++) {
                                    if (st === (err))
                                        return err;
                                }
                            }
                            s1 = "NaN";
                        }
                    } catch (ex) {
                        if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                            throw this.getLibraryComputationException;
                        }

                        return ex;
                    }
                } else {
                    return this.getFormulaErrorStrings();
                }
            }
            return s1;
        };
        this.computeIfError = function (args) {
            var argsArray = args.split(this.getParseArgumentSeparator());
            var range = argsArray[0];

            //    var arrgsArray = [this.getParseArgumentSeparator, ];
            if (argsArray.length != 2 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argsArray[1], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (range[0] == this.tic)
                return this.getValueFromArg(argsArray[0]);
            try {
                if (range[0] == this.bMARKER) {
                    range = range.replace(this.bMARKER, ' ');
                    range = (this._isIE8) ? range.replace(/^\s+|\s+$/g, '') : range.trim();
                    if (range[0] == ("NAN") || range[0] == ("-NAN") || range[0] == ("INFINITY") || range[0] == ("-INFINITY") || range[0] == ("#") || range[0] == ("n#"))
                        return this.getValueFromArg(argsArray[1]);
                }
                range = argsArray[0];

                range = this.getValueFromArg(range).toUpperCase().split(this.tic).join(this._string_empty);
            } catch (ex) {
                range = range.toUpperCase();
            }
            if (range[0] == ("NAN") || range[0] == ("-NAN") || range[0] == ("INFINITY") || range[0] == ("-INFINITY") || range[0] == ("#") || range[0] == ("n#"))
                return this.getValueFromArg(argsArray[1]);
            else
                return this.getValueFromArg(argsArray[0]);
        };
        this.computeIfNA = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            var argCount = args.length, arg1 = this._string_empty, index = -1, result;
            if (argCount != 2) {
                return this.getFormulaErrorStrings();
            }

            if (this.computeIsNA(args[0]) == this.trueValueStr) {
                if ((this.tic.indexOf(args[1]) == -1) && !this._isCellReference(args[1]) && !(result = this._parseDouble(args[0])) && !this.namedRanges.containsKey(args[1])) {
                    return this.getErrorStrings()[5].toString();
                    ;
                }
                arg1 = this.getValueFromArg(args[1]);
            } else {
                if (this._isRange(args[0])) {
                    arg1 = this.getErrorStrings()[1].toString();
                } else {
                    if ((this.tic.indexOf(args[0]) == -1) && !this._isCellReference(args[0]) && !(result = this._parseDouble(args[0])) && !this.NamedRanges.ContainsKey(args[0])) {
                        return this.getErrorStrings()[5].toString();
                    }
                    arg1 = this.getValueFromArg(args[0]);
                }
            }
            if (arg1[0] == this.tic && arg1[length - 1] == this.tic) {
                arg1 = this.substring(arg1, 1, arg1.length - 2);
            }
            return arg1;
        };
        this.computeNot = function (args) {
            var s = args;
            var d1;
            var array1 = [this.getParseArgumentSeparator(), ':'];

            //var array1 = [this.getParseArgumentSeparator()];
            ////parsed formula
            if ((args.length > 0) && this._indexOfAny(args, array1) > -1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            } else {
                try {
                    s = this.getValueFromArg(s);
                    if (this.getErrorStrings().indexOf(s) != -1) {
                        return s;
                    }
                    if (s == this.trueValueStr) {
                        s = this.falseValueStr;
                    } else if (s == this.falseValueStr) {
                        s = this.trueValueStr;
                    }
                    else if (!isNaN(d1 = this._parseDouble(s))) {
                        ////Flip the value.
                        if (Math.abs(d1) > 1e-10) {
                            s = this.falseValueStr;
                        } else {
                            s = this.trueValueStr;
                        }
                    } else {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.formulaErrorStrings[this._invalid_arguments];
                        return this.getErrorStrings()[1].toString();
                    }
                } catch (ex) {
                    if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                        throw this.getLibraryComputationException;
                    }

                    return ex;
                }
            }

            return s;
        };
        this.computeOr = function (args) {
            var sum = this.falseValueStr;
            var s1;
            var d;

            // args = this.adjustRangeArg(args);
            var ranges = this.splitArgsPreservingQuotedCommas(args);
            if (args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            for (var r = 0; r < ranges.length; r++) {
                ////is a cellrange
                if (ranges[r].indexOf(':') > -1 && this._isCellReference(r)) {
                    cells = this.getCellsFromArgs(ranges[r]);
                    for (var s = 0; s < cells.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cells[s]);
                            if (this.getErrorStrings().indexOf(s1) != -1) {
                                return s1;
                            }
                        } catch (ex) {
                            if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                                throw this.getLibraryComputationException;
                            }

                            return ex;
                        }
                        sum |= (s1 == this.trueValueStr) || (d == this._parseDouble(s1) && d != 0);
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges[r]);
                        if (this.getErrorStrings().indexOf(s1) != -1) {
                            return s1;
                        }
                        d = this._parseDouble(s1.split(this.tic).join(""))
                        if (isNaN(d) && !(s1 == this._string_empty) && !(s1.split(this.tic).join("").toUpperCase() == this.trueValueStr || s1.split(this.tic).join("").toUpperCase() == this.falseValueStr)) {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.getErrorStrings()[1].toString();
                            else
                                return (this._isCellReference(ranges[r]) || s1[0] == this.tic) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
                        }
                    } catch (ex) {
                        if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                            throw this.getLibraryComputationException;
                        }

                        return ex;
                    }

                    sum |= (s1 == this.trueValueStr) || (d == this._parseDouble(s1) && d != 0);
                }
            }
            return sum ? this.trueValueStr : this.falseValueStr;
        };
        this.computeTrue = function (empty) {
            return this.trueValueStr;
        };
        this.computeXor = function (arg) {
            var sum = false, s1, numberResult;

            // range = this.adjustRangeArg;
            var ranges = this.splitArgsPreservingQuotedCommas(arg);
            if (arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            for (var r = 0; r < ranges.length; r++) {
                ////is a cellrange
                if (ranges[r].indexOf(':') > -1 && this._isCellReference(r)) {
                    var cells =this.getCellsFromArgs(ranges[r])
                    for (var s = 0; s < cells.length; s++) {
                        try {
                            s1 = this.getValueFromArg(cells[s]);
                            if (this.getErrorStrings().indexOf(s1) != -1) {
                                return s1;
                            }
                        } catch (ex) {
                            if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                                throw this.getLibraryComputationException;
                            }

                            return ex;
                        }
                        //JS-31580 - For proper number parsing and checking.
                        numberResult = this._parseDouble(s1);
                        sum ^= (s1 == this.trueValueStr) ^ (!isNaN(numberResult) && numberResult != 0);
                    }
                } else {
                    try {
                        s1 = this.getValueFromArg(ranges[r]);
                        if (this.getErrorStrings().indexOf(s1) != -1) {
                            return s1;
                        }
                        d = this._parseDouble(s1.split(this.tic).join(""))
                        if (isNaN(d) && !(s1 == this._string_empty) && !(s1.split(this.tic).join("").toUpperCase() == this.trueValueStr || s1.split(this.tic).join("").toUpperCase() == this.falseValueStr)) {
                            if (this.getRethrowLibraryComputationExceptions())
                                throw this.getErrorStrings()[1].toString();
                            else
                                return (this._isCellReference(ranges[r]) || s1[0] == this.tic) ? this.getErrorStrings()[1].toString() : this.getErrorStrings()[5].toString();
                        }
                    } catch (ex) {
                        if (this.rethrowLibraryComputationExceptions && this.getLibraryComputationException != null) {
                            throw this.getLibraryComputationException;
                        }

                        return ex;
                    }
                    //JS-31580 - For proper number parsing and checking.
                    numberResult = this._parseDouble(s1);
                    sum ^= (s1 == this.trueValueStr) ^ (!isNaN(numberResult) && numberResult != 0);
                }
            }
            return sum ? this.trueValueStr : this.falseValueStr;
        };

        this.computeCell = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length > 2 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                if (args.length == 2) {
                    checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.CellReference);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
            }
            var reference = "";
            if (args.length == 2) {
                if (!this._isCellReference(args[1]) && !this.namedRanges.containsKey(args[1])) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_formula];
                    return this.getErrorStrings()[5].toString();
                }
                reference = args[1];
            } else {
                reference = this.cell;
            }
            var type = args[0].split(this.tic).join(this._string_empty).toLowerCase(), result = "";
            switch (type) {
                case "address":
                    result = this.rowIndex(reference).toString() + this.getParseArgumentSeparator() + this.colIndex(reference).toString();
                    result = this.computeAddress(result);
                    break;
                case "col":
                    result = this.computeColumn(reference);
                    break;
                case "color":
                    break;
                case "contents":
                    result = this.getValueFromArg(reference);
                    break;
                case "filename":
                    result = "Not Supported";
                    break;
                case "format":
                    break;
                case "parentheses":
                    break;
                case "prefix":
                    break;
                case "protect":
                    break;
                case "row":
                    result = this.computeRow(reference);
                    break;
                case "type":
                    if (this.computeIsBlank(reference) == this.trueValueStr)
                        result = "b";
                    else if (this.computeIsText(reference) == this.trueValueStr)
                        result = "l";
                    else
                        result = "v";
                    break;
                case "width":
                    break;
                default:
                    break;
            }
            if (result == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            return result.toString();
        };
        this.computeErrorType = function (args) {
            var cellReference = this._string_empty;
            var arg = this._splitArguments(args, this.getParseArgumentSeparator());
            var argCount = arg.length;
            if (argCount != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (this._isCellReference(args)) {
                cellReference = this.getValueFromArg(args);
            } else {
                cellReference = args;
            }
            if (cellReference.length > 1 && cellReference[0] == this.tic[0] && cellReference[cellReference.length - 1] == this.tic[0]) {
                return "#N/A";
            }
            if (cellReference == "#NULL!")
                return "1";
            else if (cellReference == "#DIV/0!")
                return "2";
            else if (cellReference == "#VALUE!")
                return "3";
            else if (cellReference == "#REF!")
                return "4";
            else if (cellReference == "#NAME?")
                return "5";
            else if (cellReference == "#NUM!")
                return "6";
            else if (cellReference == "#N/A")
                return "7";
            else if (cellReference == "#GETTING_DATA")
                return "8";
            return "#N/A";
        };
        this.computeInfo = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList=="") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var firstStr = this._stripTics0(this.getValueFromArg(args[0])).toLowerCase();
            var result = this._string_empty;
            switch (firstStr) {
                case "directory":
                    result = window.location.toString();
                    break;
                case "numfile":
                    if (this.getSortedSheetNames() != null && CalcEngine._sheetFamiliesList.length == 0)
                        result = this.getSortedSheetNames().length.toString();
                    else
                        result = "1";
                    break;
                case "origin":
                    var cell = this.rowIndex(this.cell).toString() + this.getParseArgumentSeparator() + this.colIndex(this.cell).toString();
                    result = "$A: " + this.computeAddress(cell);
                    break;
                case "osversion":
                    result = navigator.platform.toString();
                    break;
                case "recalc":
                    if (this._alwaysComputeDuringRefresh)
                        result = "Automatic";
                    else
                        result = "Manual";
                    break;
                case "release":
                    result = this.System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.toString();
                    break;
                case "system":
                    switch (navigator.appVersion.indexOf()) {
                        case navigator.platform:
                            result = "unix";
                            break;
                        case navigator.platform:
                            result = "mac";
                            break;
                        default:
                            result = "pcdos";
                            break;
                    }
                    break;
                default:
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_formula];
                    return this.getErrorStrings()[1].toString();
            }
            return result;
        };
        this.computeIsBlank = function (args) {

            var arg = this.splitArgsPreservingQuotedCommas(args);
            var argCount = arg.length;
            if (argCount != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getValueFromArg(args) == "") {
                return this.trueValueStr;
            }
            return this.falseValueStr;
        };
        this.computeIsErr = function (range) {
            var arg = this.splitArgsPreservingQuotedCommas(range);
            var argCount = arg.length;
            if (argCount != 1 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            range = this.getValueFromArg(range).toUpperCase().split(this.tic).join(this._string_empty);
            if (range.count > 1) {

            }
            if ((range.startsWith("NAN") || range.startsWith("-NAN") || range.startsWith("INFINITY") || range.startsWith("-INFINITY") || range.startsWith("#") || range.startsWith("n#")) && !(range.startsWith("#N/A"))) {
                return this.trueValueStr;
            } else {
                return this.falseValueStr;
            }
        };

        this.computeIsError = function (range) {

            var arg = this.splitArgsPreservingQuotedCommas(range);
            var argCount = arg.length;
            if (argCount != 1 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            try {
                range = this.getValueFromArg(range).toUpperCase().split(this.tic).join(this._string_empty);
            }
            catch (ex) {
                return this.trueValueStr;
            }
            if (range.indexOf("NAN") == 0 || range.indexOf("-NAN") == 0 || range.indexOf("INFINITY") == 0 || range.indexOf("-INFINITY") == 1 || range.indexOf("#") == 0 || range.indexOf("n#") == 0) {
                return this.trueValueStr;
            } else {
                return this.falseValueStr;
            }
        };

        this.computeIsEven = function (args) {
            var cellReference = this._string_empty;
            var val = 0.0;
            var arg = this.splitArgsPreservingQuotedCommas(args);
            var argCount = arg.length;
            if (argCount != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var argVal = this.getValueFromArg(arg[0]);
            var value = parseInt(argVal.split(this.tic).join(""));

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var dt = new Date(Date.parse(argVal));
            if (isNaN(value) && dt.toString() != "invalid Date") {
                value = this._toOADate(dt);
            }
            var result = value;
            if (!isNaN(value)) {
                if (result % 2 == 0) {
                    return this.trueValueStr;
                }
                return this.falseValueStr;
            }
            else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            return this.falseValueStr;
        };
        this.computeIsFormula = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var value = this._string_empty;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            value = this.getValueFromArg(args[0]);
            if (this.namedRanges.containsValue(value)) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[1].toString();
            }
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            if (this.isSheetMember() && family.parentObjectToToken != null) {
                args[0] = family.parentObjectToToken.getItem(this.grid) + args[0];
            }
            if (this.getFormulaInfoTable().containsKey(args[0])) {
                return this.trueValueStr;
            } else {
                return this.falseValueStr;
            }
        };
        this.computeIsLogical = function (args) {

            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList.length != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            args = this.getValueFromArg(args);
            if (args == this.falseValueStr || args == this.trueValueStr) {
                return this.trueValueStr;
            }
            return this.falseValueStr;
        };
        this.computeIsNA = function (args) {
            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            args = this.getValueFromArg(args);
            if (this.getErrorStrings().indexOf(args.toUpperCase()) != -1) {
                if (args.toUpperCase() == ("#N/A")) {
                    return this.trueValueStr;
                } else {
                    return this.falseValueStr;
                }
            }
            try {
                args = this.getValueFromArg(args).toUpperCase();
            } catch (ex) {
                return this.falseValueStr;
            }
            if (args[0] == ("#N/A")) {
                return this.trueValueStr;
            }
            return this.falseValueStr;
        };
        this.computeIsNonText = function (args) {
            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.computeIsText(args) == this.trueValueStr) {
                return this.falseValueStr;
            } else {
                return this.trueValueStr;
            }
        };
        this.computeIsNumber = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            if (args.length > 1 || range == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var d;
            range = this.getValueFromArg(range);
            if (!isNaN(this._parseDouble(range))) {
                return this.trueValueStr;
            } else {
                return this.falseValueStr;
            }
        };
        this.computeIsRef = function (args) {
            var arg = this.splitArgsPreservingQuotedCommas(args);
            if (arg.length > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (arg.length != 1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            return ((this.namedRanges.containsKey(args) || this._isCellReference(args)) && args[0] != (this.tic) && args[length - 1] != (this.tic)).toString().toUpperCase();
        };
        this.computeIsOdd = function (args) {
            var cellReference = this._string_empty;
            var val = 0.0;
            var arg = this._splitArguments(args, this.getParseArgumentSeparator());
            var argCount = arg.length;
            var array1 = [this.getParseArgumentSeparator(), ':'];
            if (argCount != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (args != this._string_empty) {
                if (this._indexOfAny(args, array1) != -1) {
                    return "#VALUE!";
                }
                cellReference = this.getValueFromArg(arg[0]);
                val = parseInt(cellReference.split(this.tic).join(this._string_empty))
                if (isNaN(val)) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[1].toString();
                }
                if (val % 2 != 0) {
                    return this.trueValueStr;
                }
                return this.falseValueStr;
            }
            return this.trueValueStr;
        };
        this.computeIsText = function (args) {
            var argList = this.splitArgsPreservingQuotedCommas(args);
            if (argList > 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var isCell = this._isCellReference(args);
            var s = (isCell) ? this.getValueFromArg(args) : args;
            if ((isCell || s[0] == this.tic) && s.length > 0 && isNaN(this._parseDouble(s))) {
                return this.trueValueStr;
            } else {
                return this.falseValueStr;
            }
        };
        this.computeN = function (args) {
            var cellReference = this._string_empty;
            var val = 0.0;
            var date;
            var arg = this._splitArguments(args, this.getParseArgumentSeparator());
            var argCount = arg.length;
            if (argCount != 1 || args == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            cellReference = this.getValueFromArg(args);
            date = new Date(Date.parse(cellReference));
            if (this._parseDouble(cellReference))
            {
                val = this._parseDouble(cellReference);
                return val.toString();
            }
            else if (new Date(Date.parse(cellReference)))
           {
                val = this._getSerialDateTimeFromDate(date);
           }
            if (cellReference == this.trueValueStr) {
                val = 1;
            }
            else if (cellReference == this.falseValueStr) {
                val = 0;
            }
            else if (this.getErrorStrings().indexOf(cellReference) > -1 || this.formulaErrorStrings.indexOf(cellReference) > -1) {
                return cellReference;
            }
            else if (!isNaN(val)) {
                return val.toString();
            }
            else {
                return "0";
            }

            return val.toString();
        };
        this.computeNA = function (range) {
            var args = this.splitArgsPreservingQuotedCommas(range);
            if (args.length > 0 && args != "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            return "#N/A";
        };
        this.computeSheet = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var value = this._string_empty;
            if (argCount > 1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var cellReference = args[0].toUpperCase();
            cellReference = (cellReference == null || cellReference == this._string_empty) ? this.cell : cellReference;
            if (cellReference == null || cellReference == this._string_empty) {
                return "1";
            }
            if (this.getErrorStrings().indexOf(cellReference)>-1) {
                return cellReference;
            }
            if (!this._isCellReference(cellReference) && !this.namedRanges.containsKey(cellReference) && this.getSortedSheetNames().indexOf(cellReference) == -1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[0].toString();
            }
            var family = CalcEngine.getSheetFamilyItem(this.grid);
            var sheet1 = this._getSheetTokenFromReference(cellReference);
            var sheetNumber = 0;
            if ((sheet1 == null || sheet1 == this._string_empty) && this.getSortedSheetNames().indexOf(cellReference) == -1 && !cellReference.indexOf(this.sheetToken.toString())) {
                sheetNumber = this.getSheetID(this.grid) + 1;
            } else if (sheet1.length > 0) {
                sheetNumber = parseInt(sheet1.split(this.sheetToken).join(this._string_empty)) + 1;
            } else {
                try {

                    for (var s = 0; s < family.tokenToParentObject.length; s++){
                        if (family.sheetNameToParentObject.getItem(cellReference.split(this.tic).join(this._string_empty)) == family.tokenToParentObject.values()[s]) {
                            var gg = family.tokenToParentObject.values()[s];
                            sheetNumber = this.getSheetID(gg) + 1;
                            break;
                        }
                    }
                } catch (ex) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._bad_formula];
                    return this.getErrorStrings()[2].toString();
                }
            }
            return sheetNumber.toString();
        };
        this.computeSheets = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var value = this._string_empty;
            if (argCount > 1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var sheetNumber = 0;
            var cellReference = args[0].toUpperCase();
            if (this.getErrorStrings().indexOf(cellReference) > -1) {
                return cellReference;
            }
            if (cellReference == null || cellReference == this._string_empty) {
                return this.getSortedSheetNames().length.toString();
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            else if (cellReference.split(this.tic).join(this._string_empty) == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[5].toString();
            } else if (!this._isCellReference(cellReference) && !this.namedRanges.containsKey(cellReference) && this.getSortedSheetNames().indexOf(cellReference) == -1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._bad_formula];
                return this.getErrorStrings()[0].toString();
            }
            try {
                var sheetsCount = this._splitArguments(cellReference, '!');
                sheetNumber = (sheetsCount.length - 1) / 2;
            } catch (ex) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[2].toString();
                return this.getErrorStrings()[2].toString();
            }
            return sheetNumber.toString();
        };
        this.computeType = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            var result = 0;
            if (argCount != 1 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            var text = this.getValueFromArg(args[0]);
            if (text == null || text == this._string_empty) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            } else if (argList.indexOf(this.getParseArgumentSeparator()) > -1) {
                result = 64;
            } else if (this.computeIsNumber(text) == this.trueValueStr) {
                result = 1;
            } else if (this.computeIsLogical(text) == this.trueValueStr) {
                result = 4;
            } else if (this.getErrorStrings().indexOf(text) > -1) {
                result = 16;
            } else if (this.computeIsText(text) == this.trueValueStr) {
                result = 2;
            }
            return result.toString();
        };
        
        this.computeRow = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            var argCount = args.length;
            if (argCount != 1) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            if (args[0] == this._string_empty) {
                return this.rowIndex(this.cell).toString();
            }
            if (!this._isCellReference(args[0]) && !this.namedRanges.containsKey(args[0])) {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[4].toString();
            }
            if (arg.indexOf(':') > -1) {
                arg = this.getCellsFromArgs(arg)[0]; //considers first cell reference from the range of cells.
            }
            return this.rowIndex(arg).toString();
        };
        this.computeRows = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            if (args.length != 1 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(arg, FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var firstRow, LastRow, totalRows = 1;
            if (args[0].indexOf(':') > -1) {
                var cells = this.getCellsFromArgs(arg);
                firstRow = this.rowIndex(cells[0].toString());
                LastRow = this.rowIndex(cells[cells.length - 1].toString());
                totalRows = LastRow - firstRow + 1;
                totalRows = (totalRows > 0) ? totalRows : 1;
            } else if (args[0].indexOf(';') > -1) {
                var arrayArg = this._splitArguments(arg.split(this.tic).join(this._string_empty), ';');
                for (var i = 1; i < arrayArg.length; i++) {
                    if (this.splitArgsPreservingQuotedCommas(arrayArg[i - 1]).length != this.splitArgsPreservingQuotedCommas(arrayArg[1]).length) {
                        if (this.getRethrowLibraryComputationExceptions())
                            throw this.getErrorStrings()[4].toString();
                        return this.getErrorStrings()[4].toString();
                    }
                    totalRows = arrayArg.length;
                }
            }
            return totalRows.toString();
        };

        /**
        * Computes the payment for a loan.
        * @return payment amount
        * @param {String} Delimited string containing the rate as percentage per period,
        /// number of periods, present value, future value, and payment type (0 = end of period, 1 = start of period).
        * @memberof ejCalculate
        * @instance
        */
        this.computePmt = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount < 3 || argCount > 5 || argList == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var rate, nper = 0, pv = 0, fv = 0, type = 0, val = 0;
            for (var i = 0; i < argCount; i++) {
                args[i] = this.getValueFromArg(args[i].split(this.tic).join(this._string_empty));
                args[i] = (args[i] == null || args[i] == "") ? "0" : args[i];
                args[i] = (args[i].split(this.tic).join("") == "TRUE") ? "1" : (args[i].split(this.tic).join("") == "FALSE") ? "0" : args[i];
            }
            rate = this._parseDouble(args[0]);
            nper = this._parseDouble(args[1]);
            pv = this._parseDouble(args[2]);
            if (argCount == 4)
                fv = this._parseDouble(args[3]);
            if (argCount == 5)
                type = this._parseDouble(args[4]);
            if (!(isNaN(rate) && isNaN(nper) && isNaN(pv) && isNaN(fv) && isNaN(type))) {
                if (nper == 0) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[4].toString();
                }
                if (Math.abs(type) > 0.5) {
                    type = 1;
                }
                else {
                    type = 0;
                }
                if (rate == 0) {
                    val = (1 * (fv + pv)) / ((1 + rate * type) * (1 - (nper + 1)));
                }
                else {
                    var pow = Math.pow(1 + rate, nper);
                    val = (rate * (fv + pv * pow)) / ((1 + rate * type) * (1 - pow));
                }
            }
            else {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._invalid_arguments];
                return this.getErrorStrings()[1].toString();
            }
            return this.computeDollar(val.toString());
        }

        /**
        * Finds the index a specified value in a lookup_range.
        * @return The relative index of the lookup_value in the lookup_range.
        * @param {String} look_value, lookup_range, match_type
        * @memberof ejCalculate
        * @instance
        */
        this.computeMatch = function (arg) {
            var args = this.splitArgsPreservingQuotedCommas(arg);
            var argCount = args.length;
            if (argCount > 3 || arg == "") {
                if (this.getRethrowLibraryComputationExceptions())
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }

            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(args[0], FormulaArgumentType.Text);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
                checkString = this.formulaErrorStringCheck(args[1], FormulaArgumentType.CellReference);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }

            var r = args[1].split(this.tic).join(this._string_empty);
            var i = r.indexOf(":");
            var m = 1;
            if (argCount == 3) {
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString1 = this.formulaErrorStringCheck(args[2], FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString1) > -1) {
                        return checkString1;
                    }
                }
                var d;
                var thirdArg = this.getValueFromArg(args[2]);
                thirdArg = thirdArg.split(this.tic).join(this._string_empty);
                d = this._parseDouble(thirdArg);
                m = isNaN(d) ? 1 : d;
                if (thirdArg == this.falseValueStr)
                    m = 0;
                else if (thirdArg == this.trueValueStr)
                    m = 1;
                else if (thirdArg.includes(this.tic) && this.computeIsText(thirdArg) == this.trueValueStr) {
                    if (this.getRethrowLibraryComputationExceptions())
                        throw this.formulaErrorStrings[this._invalid_arguments];
                    return this.getErrorStrings()[1].toString();
                }
            }
            var searchItem = this.getValueFromArg(args[0].split(this.tic).join(this._string_empty)).toUpperCase();
            var cells = this.getCellsFromArgs(this._stripTics0(r));
            var index = 1;
            var oldValue = "";
            var newValue;
            for (var j = 0; j < cells.length; j++) {
                var s = cells[j];
                var newValue = this.getValueFromArg(s).split(this.tic).join(this._string_empty).toUpperCase();
                if (oldValue != "") {
                    if (m == 1) {
                        if (this._matchCompare(newValue, oldValue) < 0 && newValue == searchItem) {
                            index--;
                            break;
                        }
                    }
                    else if (m == -1) {
                        if (this._matchCompare(newValue, oldValue) > 0) {
                            index = -1;
                            break;
                        }
                    }
                }
                if ((m == 0 || m == 1) && newValue == searchItem) {
                    break;
                }
                else if (m == 1 && this._matchCompare(searchItem, newValue) < 0) {
                    index--;
                    break;
                }
                else if (m == -1 && this._matchCompare(searchItem, newValue) > 0) {
                    index--;
                    break;
                }
                index++;
                oldValue == newValue;
            }
            if (m != 0 && index == cells.length + 1) {
                index = cells.length;
            }
            if (index > 0 && index <= cells.length) {
                return index.toString();
            }
            else {
                return this.getErrorStrings()[0].toString();;
            }
        }

        /**
        * Computes the Bit AND of the given two numbers.
        * @return Bit AND value of the given two numbers.
        * @param {String} Input Numbersfor which the AND operations has to be performed.
        * @memberof ejCalculate
        * @instance
        */
        this.computeBitAnd = function (argList) {
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var number1 = null, number2 = null;
            var value1, value2;
            try {
                if (ranges.length != 2 || argList == "") {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._wrong_number_arguments];
                    return this.formulaErrorStrings[this._wrong_number_arguments];
                }
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                number1 = this.getValueFromArg(ranges[0]);
                number1 = (number1 == null || number1 == "") ? "0" : number1;
                number1 = (number1.split(this.tic).join("") == "TRUE") ? "1" : (number1.split(this.tic).join("") == "FALSE") ? "0" : number1;
                number1 = number1.split(this.tic).join(this._string_empty);
                number2 = this.getValueFromArg(ranges[1]);
                number2 = (number2 == null || number2 == "") ? "0" : number2;
                number2 = (number2.split(this.tic).join("") == "TRUE") ? "1" : (number2.split(this.tic).join("") == "FALSE") ? "0" : number2;
                number2 = number2.split(this.tic).join(this._string_empty);
                if (number1 < 0 || number2 < 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                value1 = this._parseDouble(number1);
                value2 = this._parseDouble(number2);

                return (value1 & value2).toString();
            }
            catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "The parameters are not correct";
                else {
                    if (this.computeIsText(number1) == this.trueValueStr || this.computeIsText(number2) == this.trueValueStr)
                        return this.getErrorStrings()[5].toString();
                    else if (number1 == "" || number2 == "")
                        return this.getErrorStrings()[1].toString();
                    else
                        return this.getErrorStrings()[1].toString();
                }
            }
        }

        /**
        * Computes the Bit OR of the given two numbers.
        * @return Bit OR value of the given two numbers.
        * @param {String} Input Numbersfor which the OR operations has to be performed.
        * @memberof ejCalculate
        * @instance
        */
        this.computeBitOr = function (argList) {
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var number1 = null, number2 = null;
            var value1, value2;
            try {
                if (ranges.length != 2 || argList == "") {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._wrong_number_arguments];
                    return this.formulaErrorStrings[this._wrong_number_arguments];
                }
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                number1 = this.getValueFromArg(ranges[0]);
                number1 = (number1 == null || number1 == "") ? "0" : number1;
                number1 = (number1.split(this.tic).join("") == "TRUE") ? "1" : (number1.split(this.tic).join("") == "FALSE") ? "0" : number1;
                number1 = number1.split(this.tic).join(this._string_empty);
                number2 = this.getValueFromArg(ranges[1]);
                number2 = (number2 == null || number2 == "") ? "0" : number2;
                number2 = (number2.split(this.tic).join("") == "TRUE") ? "1" : (number2.split(this.tic).join("") == "FALSE") ? "0" : number2;
                number2 = number2.split(this.tic).join(this._string_empty);
                if (number1 < 0 || number2 < 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                value1 = this._parseDouble(number1);
                value2 = this._parseDouble(number2);

                return (value1 | value2).toString();
            }
            catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "The parameters are not correct";
                else {
                    if (this.computeIsText(number1) == this.trueValueStr || this.computeIsText(number2) == this.trueValueStr)
                        return this.getErrorStrings()[5].toString();
                    else if (number1 == "" || number2 == "")
                        return this.getErrorStrings()[1].toString();
                    else
                        return this.getErrorStrings()[1].toString();
                }
            }
        }

        /**
        * Computes the Bit Left Shift of the given number.
        * @return Bit Left Shift value of the given number.
        * @param {String} Input Numbersfor which the Bit left shift operations has to be performed.
        * @memberof ejCalculate
        * @instance
        */
        this.computeBitLShift = function (argList) {
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var number = null, shift = null;
            var value, shift_val;
            try {
                if (ranges.length != 2 || argList == "") {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._wrong_number_arguments];
                    return this.formulaErrorStrings[this._wrong_number_arguments];
                }
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                number = this.getValueFromArg(ranges[0]);
                number = (number == null || number == "") ? "0" : number;
                number = (number.split(this.tic).join("") == "TRUE") ? "1" : (number.split(this.tic).join("") == "FALSE") ? "0" : number;
                number = number.split(this.tic).join(this._string_empty);
                shift = this.getValueFromArg(ranges[1]);
                shift = (shift == null || shift == "") ? "0" : shift;
                shift = (shift.split(this.tic).join("") == "TRUE") ? "1" : (shift.split(this.tic).join("") == "FALSE") ? "0" : shift;
                shift = shift.split(this.tic).join(this._string_empty);
                value = this._parseDouble(number);
                shift_val = this._parseDouble(shift);

                if (value > 281474976710655 || Math.abs(shift_val) > 53 || value < 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                else {
                    return ((shift_val >= 0) ? value << shift_val : value >> -shift_val).toString();
                }
            }
            catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "The parameters are not correct";
                else {
                    if (this.computeIsText(number) == this.trueValueStr || this.computeIsText(shift) == this.trueValueStr)
                        return this.getErrorStrings()[5].toString();
                    else if (number == "" || shift == "")
                        return this.getErrorStrings()[1].toString();
                    else if (this._parseDouble(number) < 0 || this._parseDouble(shift) < 0)
                        return this.getErrorStrings()[4].toString();
                    else
                        return this.getErrorStrings()[1].toString();
                }
            }
        }

        /**
        * Computes the Bit Right Shift of the given number.
        * @return Bit Right Shift value of the given number.
        * @param {String} Input Numbersfor which the Bit Right Shift operations has to be performed.
        * @memberof ejCalculate
        * @instance
        */
        this.computeBitRShift = function (argList) {
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var number = null, shift = null;
            var value, shift_val;
            try {
                if (ranges.length != 2 || argList == "") {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._wrong_number_arguments];
                    return this.formulaErrorStrings[this._wrong_number_arguments];
                }
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                number = this.getValueFromArg(ranges[0]);
                number = (number == null || number == "") ? "0" : number;
                number = (number.split(this.tic).join("") == "TRUE") ? "1" : (number.split(this.tic).join("") == "FALSE") ? "0" : number;
                number = number.split(this.tic).join(this._string_empty);
                shift = this.getValueFromArg(ranges[1]);
                shift = (shift == null || shift == "") ? "0" : shift;
                shift = (shift.split(this.tic).join("") == "TRUE") ? "1" : (shift.split(this.tic).join("") == "FALSE") ? "0" : shift;
                shift = shift.split(this.tic).join(this._string_empty);
                value = this._parseDouble(number);
                shift_val = this._parseDouble(shift);

                if (value > 281474976710655 || Math.abs(shift_val) > 53 || value < 0) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                else {
                    return ((shift_val >= 0) ? value >> shift_val : value << -shift_val).toString();
                }
            }
            catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "The parameters are not correct";
                else {
                    if (this.computeIsText(number) == this.trueValueStr || this.computeIsText(shift) == this.trueValueStr)
                        return this.getErrorStrings()[5].toString();
                    else if (number == "" || shift == "")
                        return this.getErrorStrings()[1].toString();
                    else if (this._parseDouble(number) < 0 || this._parseDouble(shift) < 0)
                        return this.getErrorStrings()[4].toString();
                    else
                        return this.getErrorStrings()[1].toString();
                }
            }
        }

        /**
        * Computes the Bit Xor of the given two numbers.
        * @return Bit Xor value of the given two numbers.
        * @param {String} Input Numbersfor which the Xor operations has to be performed.
        * @memberof ejCalculate
        * @instance
        */
        this.computeBitXor = function (argList) {
            var ranges = this.splitArgsPreservingQuotedCommas(argList);
            var number1 = null, number2 = null;
            var value1, value2;
            try {
                if (ranges.length != 2 || argList == "") {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._wrong_number_arguments];
                    return this.formulaErrorStrings[this._wrong_number_arguments];
                }
                if (this.getEnableFormulaErrorValidation()) {
                    var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                    if (this.getErrorStrings().indexOf(checkString) > -1) {
                        return checkString;
                    }
                }
                number1 = this.getValueFromArg(ranges[0]);
                number1 = (number1 == null || number1 == "") ? "0" : number1;
                number1 = (number1.split(this.tic).join("") == "TRUE") ? "1" : (number1.split(this.tic).join("") == "FALSE") ? "0" : number1;
                number1 = number1.split(this.tic).join(this._string_empty);
                number2 = this.getValueFromArg(ranges[1]);
                number2 = (number2 == null || number2 == "") ? "0" : number2;
                number2 = (number2.split(this.tic).join("") == "TRUE") ? "1" : (number2.split(this.tic).join("") == "FALSE") ? "0" : number2;
                number2 = number2.split(this.tic).join(this._string_empty);
                value1 = this._parseDouble(number1);
                value2 = this._parseDouble(number2);
                if ((value1 > 281474976710655 || value2 > 281474976710655) || (value1 < 0 || value2 < 0)) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                else
                    return (value1 ^ value2).toString();
            }
            catch (ex) {
                if (this._rethrowLibraryComputationExceptions)
                    throw "The parameters are not correct";
                else {
                    if (this.computeIsText(number1) == this.trueValueStr || this.computeIsText(number2) == this.trueValueStr)
                        return this.getErrorStrings()[1].toString();
                    else if (number1 == "" || number2 == "")
                        return this.getErrorStrings()[1].toString();
                    else
                        return this.getErrorStrings()[1].toString();
                }
            }
        }

        /**
        * Returns the smallest value for which the cumulative binomial distribution is greater than or equal to a criterion value.
        * @return Returns the critical value.
        * @param {String} Number of trials, probability, alpha.
        * @memberof ejCalculate
        * @instance
        */
        this.computeBinomOInv = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 3 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var trials, p, alpha = 0, dist = 0;
            var trial = this.getValueFromArg(args[0]);
            var probability = this.getValueFromArg(args[1]);
            var alphaStr = this.getValueFromArg(args[2]);

            if (trial == "") {
                args[0] = trial = "0";
            }
            if (probability == "" || alphaStr == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[4].toString();
            }
            trials = this._parseDouble(trial.split(this.tic).join(""));
            p = this._parseDouble(probability.split(this.tic).join(""));
            alpha = this._parseDouble(alphaStr.split(this.tic).join(""));
            if (trials == 0) {
                return "0";
            }
            if (trials < 0 || p <= 0 || p >= 1 || alpha <= 0 || alpha >= 1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString();
                return this.getErrorStrings()[4].toString();
            }
            if (p > 0 && p < 1 && alpha >= 0 && alpha < 1) {
                dist = this._critbinom(trials, p, alpha);
                if (dist == this.maxValue) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.formulaErrorStrings[this._calculation_overflow];
                    return this.formulaErrorStrings[this._calculation_overflow];
                }
            }
            else if (trials <= 0 || p <= 0 || p >= 1 || alpha < 0 || alpha > 1) {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[4].toString(); 
                return this.getErrorStrings()[4].toString();
            }
            else {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[1].toString();
                return this.getErrorStrings()[1].toString();
            }
            return dist.toString();
        }

        /**
        * Returns the chi-squared distribution.
        * @return The chi-squared distribution.
        * @param {String} x, degrees of freedom.
        * @memberof ejCalculate
        * @instance
        */
        this.computeChidist = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 2 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            var x, v, dist = 0;
            for (var i = 0; i < argCount; ++i) {
                args[i] = this.getValueFromArg(args[i]);
                args[i] = this._stripTics0(args[i]);
            }
            args[0] = (args[0] == null || args[0] == "") ? "0" : args[0];
            args[1] = (args[1] == null || args[1] == "") ? "0" : args[1];
            args[0] = (args[0].split(this.tic).join("") == "TRUE") ? "1" : (args[0].split(this.tic).join("") == "FALSE") ? "0" : args[0];
            args[1] = (args[1].split(this.tic).join("") == "TRUE") ? "1" : (args[1].split(this.tic).join("") == "FALSE") ? "0" : args[1];
            var x = this._parseDouble(args[0]);
            var v = this._parseDouble(args[1]);
            if (!isNaN(x) && !isNaN(v)) {
                if (x < 0 || v < 1) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString();
                    return this.getErrorStrings()[4].toString();
                }
                if (x == 0) {
                    return "1";
                }
                else if (v < 1) {
                    if (this._excelLikeComputations)
                        return this.getErrorStrings()[4].toString();
                    return this.formulaErrorStrings[this._invalid_arguments];
                }
                dist = 1 - this._chidist(x, v);
            }
            return dist.toString();
        }

        /**
        * Returns the cotangent of an angle.
        * @return A string containing the cotangent of an angle
        * @param {String} A cell reference or a number.
        * @memberof ejCalculate
        * @instance
        */
        this.computeCoth = function (argList) {
            var args = this.splitArgsPreservingQuotedCommas(argList);
            var argCount = args.length;
            if (argCount != 1 || argList == "") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.formulaErrorStrings[this._wrong_number_arguments];
                return this.formulaErrorStrings[this._wrong_number_arguments];
            }
            if (this.getEnableFormulaErrorValidation()) {
                var checkString = this.formulaErrorStringCheck(argList, FormulaArgumentType.Numbers);
                if (this.getErrorStrings().indexOf(checkString) > -1) {
                    return checkString;
                }
            }
            argList = this.getValueFromArg(argList);
            var isNegative = false;
            argList = (argList.split(this.tic).join("") == "TRUE") ? "1" : (argList.split(this.tic).join("") == "FALSE") ? "0" : argList;

            var isNumber = this.computeIsNumber(argList);
            if (isNumber == this.trueValueStr) {
                var tempList = argList;
                if (tempList.includes("-")) 
                    isNegative = true;
                tempList = tempList.includes("u") ? tempList.replace("u", "") : tempList;
                var number = this._parseDouble(tempList);
                if (number >= 134217728) {
                    if (this._rethrowLibraryComputationExceptions)
                        throw this.getErrorStrings()[4].toString(); 
                    return this.getErrorStrings()[4].toString();
                }
            }
            if (argList == "0") {
                if (this._rethrowLibraryComputationExceptions)
                    throw this.getErrorStrings()[3].toString(); 
                return this.getErrorStrings()[3].toString();
            }
            argList = argList.includes("-") ? argList.replace("-",""):argList;
            var cothVal =this._computeMath(argList,Math.tanh);
            if (cothVal != "#NUM!" || cothVal != "#VALUE!") {
                cothVal = (1 / parseFloat(cothVal)).toString();
            }
            if (isNegative) {
                cothVal = "-" + cothVal;
            }
            return cothVal;
        }
        //this.grid.wireParentObject();
        this._initLibraryFunctions();
        //var _rangeInfo = new RangeInfo();
    }



    CalcEngine.CalcEngine = function () {
    };

    CalcEngine.getFormulaCharacter= function () {
        if (this._formulaChar == '\0') {
            this._formulaChar = '=';
        }

        return this._formulaChar;
    };

    CalcEngine._formulaChar = '=';

    CalcEngine.sheetFamilyID = 0;
    CalcEngine._tokenCount = 0;
    CalcEngine.modelToSheetID = null;
    CalcEngine._sheetFamiliesList = null;

    CalcEngine._defaultFamilyItem = null;

    CalcEngine.createSheetFamilyID = function () {
        if (this.sheetFamilyID == Number.MAX_SAFE_INTEGER) {
            this.sheetFamilyID = Number.MIN_SAFE_INTEGER;
        }
        return this.sheetFamilyID++;
    };

    CalcEngine.getSheetFamilyItem = function (model) {
        if (this.sheetFamilyID == 0) {
            if (CalcEngine._defaultFamilyItem == null) {
                CalcEngine._defaultFamilyItem = new GridSheetFamilyItem();
            }

            return CalcEngine._defaultFamilyItem;
        }

        if (CalcEngine._sheetFamiliesList == null) {
            CalcEngine._sheetFamiliesList = new HashTable();
        }

        var i = CalcEngine.modelToSheetID.getItem(model);

        if (!CalcEngine._sheetFamiliesList.containsKey(i)) {
            CalcEngine._sheetFamiliesList.add(i, new GridSheetFamilyItem());
        }

        return CalcEngine._sheetFamiliesList.getItem(i);
    };

    CalcEngine.resetSheetFamilyID = function () {
        this.sheetFamilyID = 0;

        if (CalcEngine.modelToSheetID != null) {
            CalcEngine.modelToSheetID.clear();
            CalcEngine.modelToSheetID = null;
        }

        if (CalcEngine._sheetFamiliesList != null) {
            CalcEngine._sheetFamiliesList.clear();
            CalcEngine._sheetFamiliesList = null;

            //Fix for defect #12445.
            this.resetSheetIDs();
        }
    };

    CalcEngine.resetSheetIDs = function () {
        this._tokenCount = 0;
    };

    CalcEngine.unregisterGridAsSheet = function (refName, model) {
        var family = CalcEngine.getSheetFamilyItem(model);
        var refName1 = refName.toUpperCase();
        if (family.sheetNameToParentObject != null && family.sheetNameToParentObject.containsKey(refName1)) {
            family.sheetNameToParentObject.remove(refName1);
            var token = family.sheetNameToToken.getItem(refName1);
            family.sheetNameToToken.remove(refName1);
            family.tokenToParentObject.remove(token);
            family.parentObjectToToken.remove(model);
        }
    };
    return CalcEngine;
})(jQuery, Syncfusion);

var LookupCachingMode;
(function (LookupCachingMode) {
    LookupCachingMode[LookupCachingMode["None"] = 0] = "None";
    LookupCachingMode[LookupCachingMode["VLOOKUP"] = 1] = "VLOOKUP";
    LookupCachingMode[LookupCachingMode["HLOOKUP"] = 2] = "HLOOKUP";
    LookupCachingMode[LookupCachingMode["Both"] = 3] = "Both";
    LookupCachingMode[LookupCachingMode["OptimizeForMatches"] = 4] = "OptimizeForMatches";
})(LookupCachingMode || (LookupCachingMode = {}));
;

var FormulaInfoSetAction;
(function (FormulaInfoSetAction) {
    FormulaInfoSetAction[FormulaInfoSetAction["FormulaSet"] = 0] = "FormulaSet";
    FormulaInfoSetAction[FormulaInfoSetAction["NonFormulaSet"] = 1] = "NonFormulaSet";
    FormulaInfoSetAction[FormulaInfoSetAction["CalculatedValueSet"] = 2] = "CalculatedValueSet";
})(FormulaInfoSetAction || (FormulaInfoSetAction = {}));
;

var CalcQuickBase = (function () {
    /// <summary>
    /// Constructor that resets the CalcEngine object.
    /// </summary>
    /// <param name="resetStaticMembers">
    /// Indicates whether the static members of the CalcEngine class will be cleared.</param>
    function CalcQuickBase(resetStaticMembers) {
        this.resetStaticMembers = resetStaticMembers;
        this._calcQuickID = 0;
        this._controlModifiedFlags = null;
        this._dataStore = null;
        this._engine = new Object;
        this._keyToRowsMap = null;
        this._keyToVectors = null;
        this._nameToControlMap = null;
        this._rowsToKeyMap = null;
        this._isValueSetEventChanged = false;
        this._autoCalc = false;
        this._isIE8 = false;
        // Used internally to name the calcsheets.
        this._cellPrefix = "!0!A";
        this._checkKeys = true;
        this._disposeEngineResource = true;
        this._ignoreChanges = false;
        this._leftBrace = "{";
        this._tic = "\"";
        ////Used to change the Hashtable key references to
        ////row,col references needed by the CalcEngine.
        ////Every key is swapped for a reference like A1 or A2 or A14.
        this._leftBracket = "[";
        this._rightBracket = "]";
        this._validLeftChars = "+-*/><=^(&,";
        this._validRightChars = "+-*/><=^)&,";
        this.getKeyValue = function (key) {
            key = key.toUpperCase();

            if (this.getDataStore().containsKey(key)) {
                var fInfo = this.getDataStore().getItem(key);
                var s = fInfo.getFormulaText();
                if (s.length > 0 && s[0] == CalcEngine.getFormulaCharacter() && fInfo.calcID != this.getEngine().getCalcID()) {
                    this.getEngine().cell = this._cellPrefix + this.getKeyToRowsMap().getItem(key).toString();

                    s = s.substring(1); ////strip out formulaChar.

                    try {
                        fInfo.setParsedFormula(this.getEngine().parseFormula(this._markKeys(s)));
                        ;
                    } catch (ex) {
                        if (this.getCheckKeys()) {
                            fInfo.setFormulaValue(ex.Message);
                            fInfo.calcID = this.getEngine().getCalcID();

                            if (this._valueSetEvent != null) {
                                this._valueSetEvent.trigger(this, new ValueSetEventArgs(key, fInfo.getFormulaValue(), 2 /* CalculatedValueSet */));
                            }

                            return this.getDataStore().getItem(key).getFormulaValue();
                        }
                    }

                    try {
                        fInfo.setFormulaValue(this.getEngine().computeFormula(fInfo.getParsedFormula()));
                    } catch (ex) {
                        if (this.getThrowCircularException() && ex.toString().indexOf(this.getEngine().formulaErrorStrings[this.getEngine().circular_reference_]) == 0) {
                            throw ex;
                        }
                    }

                    fInfo.calcID = this.getEngine().getCalcID();

                    if (this._valueSetEvent != null) {
                        this._valueSetEvent.trigger(this, new ValueSetEventArgs(key, fInfo.getFormulaValue(), 2 /* CalculatedValueSet */));
                    }
                }
                if (this.getEngine().getThrowCircularException()) {
                    if (this.getEngine().getIterationMaxCount() > 0) {
                        fInfo.setFormulaValue(this.getEngine().handleIteration(this.getEngine().cell, fInfo));
                    }
                }
                return this.getDataStore().getItem(key).getFormulaValue();
            } else if (this.getKeyToVectors().containsKey(key)) {
                return this.getKeyToVectors().getItem(key).toString();
            } else {
                return "";
            }
        };
        this.setKeyValue = function (key, value) {
            key = key.toUpperCase();
            var s = (this._isIE8) ? value.toString().replace(/^\s+|\s+$/g, '') : value.toString().trim();

            if (!this.getDataStore().containsKey(key) || s.indexOf(this._leftBrace) == 0) {
                ////support for vectors
                if (s.indexOf(this._leftBrace) == 0) {
                    if (!this.getKeyToVectors().containsKey(key)) {
                        this.getKeyToVectors().add(key, "");
                    }

                    s = s.substring(1, s.length - 2);
                    var i = this.getKeyToRowsMap().length + 1;
                    var ss = s.split(this.getEngine().getParseArgumentSeparator());
                    var range = "A" + i + ":A" + (i + ss.length - 1);
                    this.getKeyToVectors()[key] = range;
                    for (var index = 0; index < ss.length; index++) {
                        var key1 = "Q_" + (this.getKeyToRowsMap().length + 1);
                        this.getDataStore().add(key1, new FormulaInfo());
                        this.getKeyToRowsMap().add(key1, this.getKeyToRowsMap().length + 1);
                        this.getRowsToKeyMap().add(this.getRowsToKeyMap().length + 1, key1);

                        var fInfo1 = this.getDataStore().getItem(key1);
                        fInfo1.setFormulaText("");
                        fInfo1.setParsedFormula("");

                        ////fInfo1.FormulaValue = s1;
                        fInfo1.setFormulaValue(this.parseAndCompute(ss[index]));
                    }

                    return;
                } else {
                    this.getDataStore().add(key, new FormulaInfo());
                    this.getKeyToRowsMap().add(key, this.getKeyToRowsMap().length + 1);
                    this.getRowsToKeyMap().add(this.getRowsToKeyMap().length + 1, key);
                }
            }

            if (this.getKeyToVectors().containsKey(key)) {
                this.getKeyToVectors().remove(key);
            }
            var fInfo = this.getDataStore().getItem(key);

            if (!this.ignoreChanges && fInfo.getFormulaText() != null && fInfo.getFormulaText().length > 0 && fInfo.getFormulaText() != s) {
                ////Reset its dependencies if there are any...
                var s1 = this._cellPrefix+ this.getKeyToRowsMap().getItem(key).toString();
                var ht = this.getEngine().getDependentFormulaCells().getItem(s1);
                if (ht != null) {
                    this.getEngine().clearFormulaDependentCells(s1);
                }
            }

            if (s.length > 0 && s[0] == CalcEngine.getFormulaCharacter()) {
                fInfo.setFormulaText(s);
                if (this._valueSetEvent != null) {
                    this._valueSetEvent.trigger(this, new ValueSetEventArgs(key, fInfo.getFormulaValue(), 2 /* CalculatedValueSet */));
                }
            } else if (fInfo.getFormulaValue() != s) {
                fInfo.setFormulaText("");
                fInfo.setParsedFormula("");
                fInfo.setFormulaValue(s);
                if (this._valueSetEvent != null) {
                    this._valueSetEvent.trigger(this, new ValueSetEventArgs(key, fInfo.getFormulaValue(), 2 /* CalculatedValueSet */));
                }
            }

            if (this.getAutoCalc()) {
                this.updateDependencies(key);
            }
        };
        /// <summary>
        /// A method to reset all the keys registered with CalcQuickBase object.
        /// </summary>
        this.resetKeys = function () {
            this.getDataStore().clear();
            this.getKeyToRowsMap().clear();
            this.getRowsToKeyMap().clear();
            this.getKeyToVectors().clear();
            this.getNameToControlMap().clear();
        };
        this._checkAdjacentPiece = function (s, validChars, first) {
            var b = true;
            s = (this._isIE8) ? s.replace(/^\s+|\s+$/g, '') : s.trim();
            if (s.length > 0) {
                b = validChars.indexOf(s[first ? 0 : s.length - 1]) > -1;
            }

            return b;
        };
        /// <summary>
        /// Creates the <see cref="CalcEngine"/> object used by this CalQuick object.
        /// </summary>
        /// <returns>Returns an instance of a CalcEngine object.</returns>
        /// <remarks>You can override this method and return a derived CalcEngine object use
        /// by the derived CalcQuick object.
        /// </remarks>
        this.createEngine = function () {
            return new CalcEngine(this);
        };
        this.dispose = function () {
            this._dataStore = null;
            this._rowsToKeyMap = null;
            this._keyToRowsMap = null;
            this._keyToVectors = null;

            this._controlModifiedFlags = null;
            this._nameToControlMap = null;

            //this.ValueChanged -= new ValueChangedEventHandler(this._engine.grid_ValueChanged);
            if (this.getDisposeEngineResource()) {
                ////CalcEngine.ResetSheetFamilyID();
                this._engine.getDependentFormulaCells().clear();
                this._engine.getDependentCells().clear();

                if (this._engine != null) {
                    this._engine.dispose();
                }

                this._engine = null;
            }
        };
        /// <summary>
        /// A method that parses and computes a well-formed algebraic expression passed in.
        /// </summary>
        /// <param name="formulaText">The text of the formula.</param>
        /// <returns>The computed value.</returns>
        /// <remarks>You would use this method if you have a formula string which
        /// contains only constants or library function references. Such formulas
        /// do not depend upon other values. If you have registered a variable through
        /// an indexer, then that variable can be used in a formula expression passed into this
        /// method. This method will return the Exception text if an exception is thrown
        /// during the computation.
        /// </remarks>
        this.tryParseAndCompute = function (formulaText) {
            var ret = "";
            try {
                ret = this.parseAndCompute(formulaText);
            } catch (ex) {
                ret = ex.message;
            }

            return ret;
        };
        /// <summary>
        /// A method that returns the formula string associated with the key passed in from a FormulaInfo object.
        /// </summary>
        /// <param name="key">The Hashtable key associated with the FormulaInfo object.</param>
        /// <returns>The formula string may be the empty string if no formula is stored with this key.</returns>
        this.getFormula = function (key) {
            key = key.toUpperCase();
            if (this.getDataStore().containsKey(key)) {
                return this.getDataStore().getItem(key).getFormulaText();
            }

            return "";
            ;
        };
        /// <summary>
        /// A method to get the value of the cell referred. For internal CalcQuick use only.
        /// </summary>
        /// <param name="row">Row index.</param>
        /// <param name="col">Column index.</param>
        /// <returns>(row, col) data.</returns>
        /// <remarks>
        /// CalcQuick does not expose a (row, col) data access model.
        /// But since CalcEngine requires such a model, CalcQuick uses
        /// a row, col access model internally, but only exposes the
        /// formula Key model to access values.
        /// </remarks>
        this.getValueRowCol = function (grid, row, col) {
            ////CalcQuick objects do not expose a row, col data access model.
            ////But the CalcEngine requires such a model. So, CalcQuick uses
            ////a row, col access model internally, but only exposes using
            ////formula Key values to access formulas.
            var key = this.getRowsToKeyMap().getItem(row).toString();
            var s = this.getKeyValue(key).toString();
            if (s != null && s[s.length - 1] == ("%") && s.length > 1) {
                var d = this.parseDouble(s.substring(0, s.length - 1));
                if (isNaN(d)) {
                    s = (Number(d) / 100).toString();
                }
            }

            return s;
        };
        /// <summary>
        /// Initializes any structures needed by this instance.
        /// </summary>
        /// <param name="resetStaticMembers">
        /// Indicates whether the static members of the CalcEngine class will be cleared.</param>
        this.initCalcQuick = function (resetStaticMembers) {
            this._dataStore = new HashTable();
            this._rowsToKeyMap = new HashTable();
            this._keyToRowsMap = new HashTable();
            this._keyToVectors = new HashTable();

            this._controlModifiedFlags = new HashTable();
            this._nameToControlMap = new HashTable();
            var i = CalcEngine.createSheetFamilyID();
            this._engine = this.createEngine();
            if (resetStaticMembers) {
                CalcEngine.resetSheetFamilyID();
                this._engine.getDependentFormulaCells().clear();
                this._engine.getDependentCells().clear();
            }

            
            this._cellPrefix= "!" + i + "!A";
            this._engine.registerGridAsSheet(RangeInfo.getAlphaLabel(this.getCalcQuickID()), this, i);

            ////By default, we will trigger the calculations locally,
            ////so turn off the engine calculating mechanism.
            this._engine.setCalculatingSuspended(true);
            this._engine.ignoreValueChanged = true;
            this._isIE8 = (ej.browserInfo().name == 'msie' && ej.browserInfo().version == '8.0') ? true : false;
        };
        /// <summary>
        /// Change the calcQuick keys into cell range. i.e mark the key A as A1
        /// </summary>
        /// <param name="formula">formula to compute value</param>
        /// <returns>marked fommula</returns>
        this._markKeys = function (formula) {
            var left = formula.indexOf(this._leftBracket);
            while (left > -1) {
                var len = formula.substring(left).indexOf(this._rightBracket) - 1;
                var key = "";

                if (len > 0) {
                    key = formula.substring(left + 1, len + left + 1).toUpperCase();
                    if (this.getKeyToVectors().containsKey(key)) {
                        var rightPiece = (left + len + 2 < formula.length) ? formula.substring(left + len + 2) : "";
                        if (this.getCheckKeys() && !this._checkAdjacentPiece(rightPiece, this._validRightChars, true)) {
                            throw "not followed properly" + key;
                        }

                        var leftPiece = (left > 0) ? formula.substring(0, left) : "";
                        if (this.getCheckKeys() && !this._checkAdjacentPiece(leftPiece, this._validLeftChars, false)) {
                            throw "not followed properly" + key;
                        }

                        formula = leftPiece + this.getKeyToVectors().getItem(key).toString() + rightPiece;
                        left = formula.indexOf(this._leftbraket);
                    } else if (this.getKeyToRowsMap().containsKey(key)) {
                        var rightPiece = (left + len + 2 < formula.length) ? formula.substring(left + len + 2) : "";
                        if (this.getCheckKeys() && !this._checkAdjacentPiece(rightPiece, this._validRightChars, true)) {
                            throw "not followed properly" + key;
                        }

                        var leftPiece = (left > 0) ? formula.substring(0, left) : "";
                        if (this.getCheckKeys() && !this._checkAdjacentPiece(leftPiece, this._validLeftChars, false)) {
                            throw "not followed properly" + key;
                        }

                        formula = leftPiece + "A" + this.getKeyToRowsMap().getItem(key).toString() + rightPiece;
                        left = formula.indexOf(this._leftBracket);
                    } else {
                        if (formula.toUpperCase().indexOf(this._tic + this._leftBracket + key + this._rightBracket + this.tic) > 0) {
                            break;
                        } else {
                            throw "Unknown key: " + key;
                        }
                    }
                } else {
                    left = -1;
                }
            }

            return formula;
        };
        /// <summary>
        /// A method that parses and computes a well-formed algebraic expression passed in.
        /// </summary>
        /// <param name="formulaText">The text of the formula.</param>
        /// <returns>The computed value.</returns>
        /// <remarks>You would use this method if you have a formula string which
        /// contains only constants or library function references. Such formulas
        /// do not depend upon other values. If you have registered a variable through
        /// an indexer, then that variable can be used in a formula expression passed into this
        /// method.
        /// </remarks>
        this.parseAndCompute = function (formulaText) {
            if (formulaText.length > 0 && formulaText[0] == this.getEngine().getFormulaCharacter()) {
                formulaText = formulaText.substring(1);
            }

            return this.getEngine().parseAndComputeFormula(this._markKeys(formulaText));
        };
        /// <summary>
        /// A method that recompute any formulas stored in the CalcQuick instance.
        /// </summary>
        /// <remarks>
        /// This method only has is used when AutoCalc is False. It loops through
        /// all FormulaInfo objects stored in the CalcQuick object and recomputes
        /// any formulas.
        /// </remarks>
        this.refreshAllCalculations = function () {
            if (!this.getAutoCalc()) {
                return;
            }

            this.setDirty();

            this.ignoreChanges = true;

            for (var keyIndex = 0; keyIndex < this.getDataStore().keys().length; keyIndex++) {
                var key = this.getDataStore().keys()[keyIndex];
                var fInfo = this.getDataStore().getItem(key);
                var s = fInfo.getFormulaText();
                if (s.length > 0 && s[0] == this.getEngine().getFormulaCharacter() && fInfo.calcID != this.getEngine().getCalcID()) {
                    s = s.substring(1); ////strip out formulaChar.
                    this.getEngine().cell = this._cellPrefix+ this.getKeyToRowsMap().getItem(key).toString();
                    fInfo.setParsedFormula(this.getEngine().parseFormula(this._markKeys(s)));
                    fInfo.setFormulaValue(this.getEngine().computeFormula(fInfo.getParsedFormula()));
                    fInfo.calcID = this.getEngine().getCalcID();
                    var rowNumber = parseInt(this.getKeyToRowsMap().getItem(key));
                    this.getEngine().valueChanged(this, new ValueChangedArgs(rowNumber, 1, fInfo.getFormulaValue()));
                }
                if (this._valueSetEvent != null) {
                    this._valueSetEvent.trigger(this, new ValueSetEventArgs(key, fInfo.getFormulaValue(), 2 /* CalculatedValueSet */));
                }
            }

            this.ignoreChanges = false;
        };
        /// <summary>
        /// A method to force all calculations to be performed the next time the CalcQuick object is
        /// accessed with an indexer requesting the value.
        /// </summary>
        /// <remarks>
        /// Each FormulaInfo object contained in the CalcQuick instance
        /// has a calculation index that is checked any time the computed value is needed. If this index
        /// is current, no calculation is done, and the last computed value is returned. If this index
        /// is not current, the calculation is redone before the value is returned. Calling this method
        /// guarantees that no FormulaInfo object's calculation indexes will be current.
        /// </remarks>
        this.setDirty = function () {
            this.getEngine().updateCalcID();
        };
        /// <summary>
        /// A method to set value to the specified cell. For internal CalcQuick use only.
        /// </summary>
        this.setValueRowCol = function (value, row, col) {
            ////No implementation code in this class.
            //// TODO:  Add CalcQuick.SetValueRowCol implementation
        };
        /// <summary>
        /// Loops through and updates all formula items that depend
        /// on the FormulaInfo object pointed to by the key.
        /// </summary>
        /// <param name="key">Identifies FormulaInfo object that triggered the update.</param>
        this.updateDependencies = function (key) {
            if (this.getAutoCalc()) {
                var s = this._cellPrefix+ this.getKeyToRowsMap().getItem(key).toString();
                var ht = this.getEngine().getDependentCells().getItem(s);
                this.setDirty();
                if (ht != null) {
                    for (var ind = 0; ind < ht.length; ind++) {
                        var i = ht[ind].indexOf('A');
                        if (i > -1) {
                            i = parseInt(ht[ind].substring(i + 1));
                            key = this.getRowsToKeyMap().getItem(i).toString();
                            this.ignoreChanges = true;
                            this.setKeyValue(key, this.getKeyValue(key)); ////triggers calculation in the getter
                            this.ignoreChanges = false;
                        }
                    }
                }
            }
        };
        this.initCalcQuick(resetStaticMembers);
    }
        /// <summary>
        /// A property that gets/sets the auto calculation mode of the CalcQuick.
        /// </summary>
        /// <remarks>
        /// By default, the CalcQuick will not update other values when you change
        /// a FormulaInfo object. By default, you explicitly call SetDirty()
        /// of the CalcQuick instance to force calculations to be done the next time
        /// they are required. Setting AutoCalc to True tells the CalcQuick to maintain
        /// the dependency information necessary to automatically update
        /// dependent formulas when values that affect these formulas change.
        /// </remarks>
    CalcQuickBase.prototype.getAutoCalc= function () {
        return this._autoCalc;
    };
    CalcQuickBase.prototype.setAutoCalc =  function (value) {
        this._autoCalc = value;
        this.getEngine().setCalculatingSuspended(!value);

        //this.getEngine().setIgnoreValueChanged(!value);
        this.getEngine().setUseDependencies(value);
        if (value) {
            this.setDirty();
        }
    };

        /// <summary>
        /// Get the calaQuick id of object.
        /// </summary>
    CalcQuickBase.prototype.getCalcQuickID= function () {
        this._calcQuickID++;
        if (this._calcQuickID == Number.MAX_VALUE) {
            this._calcQuickID = 1;
        }

        return this._calcQuickID;
    };

        /// <summary>
        /// Gets or sets whether formulas should be checked for syntax during key substitutions. Default is true.
        /// </summary>
    CalcQuickBase.prototype.getCheckKeys = function () {
        return this._checkKeys;
    };
    CalcQuickBase.prototype.setCheckKeys = function (value) {
        this._checkKeys = value;
    };

        /// <summary>
        /// Maintains a set of modified flags indicating whether
        /// any control has had a value changed.
        /// </summary>
    CalcQuickBase.prototype.getControlModifiedFlags = function () {
        return this._controlModifiedFlags;
    };

        /// <summary>
        /// Maintains a collection of FormulaInfo objects.
        /// </summary>
        /// <remarks>
        ///  This Hashtable serves as the data store for the
        ///  CalcQuick instance. The keys are the strings used
        ///  to identify formulas and the values are FormulaInfo
        ///  objects that hold the information on each formula or value.
        /// </remarks>
    CalcQuickBase.prototype.getDataStore = function () {
        return this._dataStore;
    };

        /// <summary>
        /// Determines whether the CalcEngine object of this CalcQuick should be disposed on disposing this object.
        /// <para/>Default value is true.
        /// </summary>
    CalcQuickBase.prototype.getDisposeEngineResource = function () {
        return this._disposeEngineResource;
    };
    CalcQuickBase.prototype.setDisposeEngineResource = function (value) {
        this._disposeEngineResource = value;
    };
    
        /// <summary>
        /// A read-only property that gets the reference to the CalcEngine object being used by this CalcQuick instance.
        /// </summary>
    CalcQuickBase.prototype.getEngine = function () {
        return this._engine;
    };

        /// <summary>
        /// A property that gets/sets character by which string starts with, are treated as
        /// formulas when indexing a CalcQuick object.
        /// </summary>
        /// <remarks>If you use the technique of indexing the CalcQuick object
        /// to set a varaible value, then you indicate that the value should be a
        /// formula by starting the string with this character. If you do not want
        /// to require your formulas to start with this character, then you will not
        /// be able to use the indexing technique. Instead, you will have to call
        /// ParseAndCompute directly to handle formulas not starting with this
        /// character.</remarks>
    CalcQuickBase.prototype.getFormulaCharacter = function () {
        return this.getEngine().getFormulaCharacter();
    };
    CalcQuickBase.prototype.setFormulaCharacter = function (value) {
        this.getEngine().setFormulaCharacter(value);
    };


        /// <summary>
        /// Maintains a mapping between the string key and the row
        /// used in a CalcSheet to identify a FormulaInfo object.
        /// </summary>
    CalcQuickBase.prototype.getKeyToRowsMap = function () {
        return this._keyToRowsMap;
    };

        /// <summary>
        /// Maintains a mapping between the string key and a
        /// vector of numbers entered using a brace expression.
        /// </summary>
    CalcQuickBase.prototype.getKeyToVectors = function () {
        return this._keyToVectors;
    };

        /// <summary>
        /// Maintains a mapping between the string key and the control
        /// which is being used to identify a FormulaInfo object.
        /// </summary>
    CalcQuickBase.prototype.getNameToControlMap = function () {
        return this._nameToControlMap;
    };

        /// <summary>
        /// Maintains a mapping between the row used in a CalcSheet
        /// and the string key used to identify a FormulaInfo object.
        /// </summary>
    CalcQuickBase.prototype.getRowsToKeyMap = function () {
        return this._rowsToKeyMap;
    };

        /// <summary>
        /// Gets / sets whether the CalcQuick should throw an exception when a circular calculation is encountered.
        /// </summary>
        /// <remarks>If this property is True, the CalcQuick will throw an exception
        /// when it detects a circular calculation. If ThrowCircularException is False, then
        /// no exception is thrown and the calculation will loop recursively until Engine.MaximumRecursiveCalls
        /// is exceeded.
        /// </remarks>
    CalcQuickBase.prototype.getThrowCircularException = function () {
        return this.getEngine().getThrowCircularException();
    };
    CalcQuickBase.prototype.setThrowCircularException = function (value) {
        this.getEngine().setThrowCircularException(value);
    };

    CalcQuickBase.prototype.getValueSetEventHandler = function () {
        if (this._valueSetEvent == null) {
            this._valueSetEvent = new ValueSetEvent();
        }
        return this._valueSetEvent.getValueSet();
    };
    CalcQuickBase.prototype.setValueSetEventHandler = function (value) {
        if (this._valueSetEvent == null) {
            this._valueSetEvent = new ValueSetEvent();
        }
        this._valueSetEvent.setValueSet(value);
    };

    return CalcQuickBase;
})();

 window.CalcQuick = (function (_super) {
    this.__calcQuickextends(CalcQuick, _super);
    function CalcQuick() {
        _super.apply(this, arguments);
        this.registerControlArray = function (controls) {
            for (var c = 0; c < controls.length; c++) {
                this.registerControl(controls[c]);
            }

            this.setAutoCalc(true);
        };
        /// <summary>
        /// Used to register a control as a calculation object in this CalcQuick instance.
        /// </summary>
        /// <param name="c">The control to register.</param>
        /// <remarks>
        /// To reference this calculation object from another calculation in this CalcQuick
        /// object, you use the Control.Name string. The value of this calculation object is
        /// bound to the Control.Text property.
        /// </remarks>
        this.registerControl = function (c) {
            ////Subscribe once.
            if (this.getNameToControlMap().length == 0) {
                this.setValueSetEventHandler(this.calcQuickValueSet);
            }

            if (this.getControlModifiedFlags().containsKey(c.id) || this.getNameToControlMap().containsKey(c.id)) {
                throw "error";
            }

            this.getControlModifiedFlags().add(c.id, false);
            this.getNameToControlMap().add(c.id.toUpperCase(), c.id);

            this.setKeyValue(c.id, c.value);
            if (c.type == "select-one") {
                var proxy = $.proxy(this.controlTextChanged, this, this);
                c.onchange = proxy;
            } else {
                var proxy = $.proxy(this.controlTextChanged, this, this);
                if (this._isIE8)
                    c.onpropertychange = proxy;
                else
                    c.oninput = proxy;
            }
            var proxy = $.proxy(this.controlLeave, this, this);
            c.onblur = proxy;
        };
        ////Used to autoset the value back to the control.
        this.calcQuickValueSet = function (eventObj, e) {
            if (eventObj.getNameToControlMap().containsKey(e.getKey())) {
                var c = eventObj.getNameToControlMap().getItem(e.getKey());
                document.getElementById(c).value = e.getValue();
            }
        };
        ////When using controls as keys, this event is
        ////used to mark a control as modified.
        this.controlTextChanged = function (e, sender) {
            var srcElement = (e._isIE8) ? event.srcElement : sender.target;
            if (srcElement != null && !e.ignoreChanges
                && e.getControlModifiedFlags().containsKey(srcElement.id)) {
                e.getControlModifiedFlags().items[srcElement.id] = true;
            }

        };
        ////When using controls as keys, this event is
        ////used to trigger an autochange if needed.
        this.controlLeave = function (e, sender) {
            var srcElement = (e._isIE8) ? event.srcElement : sender.target;
            if (srcElement != null) {
                if (this.getControlModifiedFlags().containsKey(srcElement.id)) {
                    if (e.getControlModifiedFlags().getItem(srcElement.id)) {
                        e.setKeyValue(srcElement.id, srcElement.value); ////triggers a possible recalculate
                        e.getControlModifiedFlags().items[srcElement.id] = false;
                    }
                    ////this.getControlModifiedFlags()[c] = false;
                }
            }
        };
    }
    return CalcQuick;
})(CalcQuickBase);


window.ValueSetEventArgs = (function () {
    function ValueSetEventArgs(key, value, action) {
        this._id = key;
        this._val = value;
        this._action = action;
    }
        /// <summary>
        /// The reason the event was raised.
        /// </summary>
    ValueSetEventArgs.prototype.getAction = function () {
        return this._action;
    };
    ValueSetEventArgs.prototype.setAction =  function (value) {
        this._action = value;
    };


    /// <summary>
    /// A property that gets/sets the Hashtable lookup object for the FormulaInfo object being changed.
    /// </summary>
    ValueSetEventArgs.prototype.getKey = function () {
        return this._id;
    };
    ValueSetEventArgs.prototype.setKey = function (value) {
        this._id = value;
    };

        /// <summary>
        /// A property that gets/sets the new value being set.
        /// </summary>
    ValueSetEventArgs.prototype.getValue = function () {
        return this._val;
    };
    ValueSetEventArgs.prototype.setValue = function (value) {
        this._val = value;
    };

    return ValueSetEventArgs;
})();

var FormulaInfoSetAction;
(function (FormulaInfoSetAction) {
    /// <summary>
    /// A formula (string starting with FormulaCharacter) was assigned.
    /// </summary>
    FormulaInfoSetAction[FormulaInfoSetAction["FormulaSet"] = 0] = "FormulaSet";

    /// <summary>
    /// Something other than a formula was assigned.
    /// </summary>
    FormulaInfoSetAction[FormulaInfoSetAction["NonFormulaSet"] = 1] = "NonFormulaSet";

    /// <summary>
    /// A calculated value was assigned.
    /// </summary>
    FormulaInfoSetAction[FormulaInfoSetAction["CalculatedValueSet"] = 2] = "CalculatedValueSet";
})(FormulaInfoSetAction || (FormulaInfoSetAction = {}));
;


var FormulaInfoHashtable = (function () {

    function FormulaInfoHashtable() {
        this.get = function (key) {
            return new FormulaInfo();
        };
        this.set = function (key, value) {
            return new FormulaInfo();
        };
    }
    return FormulaInfoHashtable;
})();
var HashTable = (function () {
    function HashTable() {
        this.length = 0;
        this.items = [];
        this.add = function (key, value) {
            this.previous = undefined;
            if (this.containsKey(key)) {
                this.previous = this.items[key];
            } else {
                this.length++;
            }
            this.items[key] = value;
            return this.previous;
        };
        this.clear = function () {
            this.items = {};
            this.length = 0;
        };
        this.contains = function (key) {
            return this.items.hasOwnProperty(key);
        };
        this.containsKey = function (key) {
            return this.items.hasOwnProperty(key);
        };
        this.containsValue = function (key) {
            return (this.items.hasOwnProperty(key) && this.items[key] != undefined) ? true : false;
        };
        this.getItem = function (key) {
            if (this.containsKey(key))
            {

                return this.items[key]
            }
            else
            {
                return  undefined;
            }
        };
        this.keys = function () {
            var keys = [];
            for (var k in this.items) {
                if (this.containsKey(k)) {
                    keys.push(k);
                }
            }
            return keys;
        };
        this.remove = function (key) {
            if (this.containsKey(key)) {
                this.previous = this.items[key];
                this.length--;
                delete this.items[key];
                return this.previous;
            } else {
                return undefined;
            }
        };
        this.values = function () {
            var values = [];
            for (var k in this.items) {
                if (this.containsKey(k)) {
                    values.push(this.items[k]);
                }
            }
            return values;
        };
        this.each = function (fn) {
            for (var k in this.items) {
                if (this.containsKey(k)) {
                    fn(k, this.items[k]);
                }
            }
        };
        var previous = undefined;
    }
    return HashTable;
})();

 window.RangeInfo = (function () {
    function RangeInfo(top, left, bottom,right) {
        this.top = top;
        this.bottom = bottom;
        this.left = left;
        this.right = right;
        this.getBottom = function () {
            return this.bottom;
        };
        this.setBottom = function (value) {
            this.bottom = value;
        };
        this.getTop = function () {
            return this.top;
        };
        this.setTop = function (value) {
            this.top = value;
        };
        this.getLeft = function () {
            return this.left;
        };
        this.setLeft = function (value) {
            this.left = value;
        };
        this.getRight = function () {
            return this.right;
        };
        this.setRight = function (value) {
            this.right = value;
        };
    }
    RangeInfo.cells = function (top, left, bottom, right) {
        return new RangeInfo(top, left, bottom,right);
    };

    RangeInfo.getAlphaLabel = function (col) {
        var cols = [];
        var n = 0;
        var charText = "A";
        while (col > 0 && n < 9) {
            col--;
            var aCharNo = charText.charCodeAt(0);
            cols[n] = String.fromCharCode(col % 26 + aCharNo);
            col = parseInt((col / 26).toString());
            n++;
        }

        var chs = [];
        for (var i = 0; i < n; i++) {
            chs[n - i - 1] = cols[i];
        }

        return chs.join("");
    };
    return RangeInfo;
})();

window.GridSheetFamilyItem = (function () {
    function GridSheetFamilyItem() {
        this.isSheetMember = false;
        this.parentObjectToToken = null;
        this.sheetDependentCells = null;
        this.sheetDependentFormulaCells = null;
        this.sheetFormulaInfoTable = null;
        /// <summary>
        /// Holds mapping from sheet name to parent object.
        /// </summary>
        this.sheetNameToParentObject = null;
        /// <summary>
        /// Holds mapping from parent object to sheet name.
        /// </summary>
        this.sheetNameToToken = null;
        /// <summary>
        /// Holds mapping from sheet token to parent object.
        /// </summary>
        this.tokenToParentObject = null;
    }
    return GridSheetFamilyItem;
})();

window.FormulaInfo = (function () {
    function FormulaInfo() {
        this.calcID = Number.MIN_SAFE_INTEGER + 1;
        /// <summary>
        /// A property that gets/sets the text of the initial formula.
        /// </summary>
        this.getFormulaText = function () {
            return this._formulaText;
        };
        this.setFormulaText = function (value) {
            this._formulaText = value;
        };
        /// <summary>
        /// A property that gets/sets the last computed value of this formula.
        /// </summary>
        this.getFormulaValue = function () {
            return this._formulaValue;
        };
        this.setFormulaValue = function (value) {
            this._formulaValue = value;
        };
        /// <summary>
        /// A property that gets/sets the formula as a parsed string.
        /// </summary>
        this.getParsedFormula = function () {
            return this._parsedFormula;
        };
        this.setParsedFormula = function (value) {
            this._parsedFormula = value;
        };
        var _formulaText;
        var _formulaValue;
        var _parsedFormula;
        var _calcID = Number.MIN_SAFE_INTEGER + 1;
    }
    return FormulaInfo;
})();

window.ValueChangedArgs = (function () {
    function ValueChangedArgs(row, col, value) {
        this.row = row;
        this.col = col;
        this.value = value;
        this.getRowIndex = function () {
            return this.row;
        };
        this.setRowIndex = function (value) {
            this.row = value;
        };
        this.getColIndex = function () {
            return this.col;
        };
        this.setColIndex = function (value) {
            this.col = value;
        };
        this.getValue = function () {
            return this.value;
        };
        this.setValue = function (value) {
            this.value = value;
        };
    }
    return ValueChangedArgs;
})();

window.FormulaParsing = (function () {
    function FormulaParsing(_text) {
        this._text = _text;
        this.getText = function () {
            return this._text;
        };
        this.setText = function (value) {
            this._text = value;
        };
    }
    return FormulaParsing;
})();

window.UnknownFunctionEventArgs = (function () {
    function UnknownFunctionEventArgs() {
        /// <summary>
        /// Gets the name of the unknown function.
        /// </summary>
        this.getMissingFunctionName = function () {
            return this.m_missingFunctionName;
        };
        this.setMissingFunctionName = function (value) {
            this.m_missingFunctionName = value;
        };
        this.getCellLocation = function () {
            return this.m_cellLocation;
        };
        this.setCellLocation = function (value) {
            this.m_cellLocation = value;
        };
    }
    return UnknownFunctionEventArgs;
})();

window.LookUps = (function () {
    function LookUps() {
        this.getLinearLookUpList = function () {
            return this._linearLookUpList;
        };
        this.setLinearLookUpList = function (value) {
            this._linearLookUpList = value;
        };
        this.getMatchLookUpList = function () {
            return this._matchLookUpList;
        };
        this.setMatchLookUpList = function (value) {
            this._matchLookUpList = value;
        };
    }
    return LookUps;
})();

window.ValueSetEvent = (function () {
    // Private member vars
    function ValueSetEvent() {
    }
    ValueSetEvent.prototype.getValueSet = function () {
        return this.eventFn;
    };
    ValueSetEvent.prototype.setValueSet = function (value) {
        this.eventFn = value;
    };

    ValueSetEvent.prototype.trigger = function () {
        var a = [];
        for (var _i = 0; _i < (arguments.length - 0) ; _i++) {
            a[_i] = arguments[_i + 0];
        }
        /// <summary>Invokes all of the listeners for this event.</summary>
        /// <param name="args">Optional set of arguments to pass to listners.</param>
        var context = {};
        this.getValueSet().apply(context, a || []);
    };
    return ValueSetEvent;
})();;
/**
* @fileOverview Plugin to style the Html CheckBox elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejCheckBox", "ej.CheckBox", {
        _rootCSS: "e-checkbox",

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["checked", "checkState"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },


        defaults: {

            id: null,

            name: null,

            value: null,

            htmlAttributes: {},

            checked: false,

            enabled: true,

            enableTriState: false,

            showRoundedCorner: false,

            enablePersistence: false,

            cssClass: "",

            text: "",

            enableRTL: false,

            idPrefix: "ej",

            size: "small",

            checkState: "uncheck",

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            beforeChange: null,

            change: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            id: "string",
            name: "string",
            enablePersistence: "boolean",
            enableTriState: "boolean",
            size: "enum",
            enabled: "boolean",
            idPrefix: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },
        observables: ["checked", "checkState"],
        checked: ej.util.valueFunction("checked"),
        checkState: ej.util.valueFunction("checkState"),

        _init: function (options) {
            var browserInfo = ej.browserInfo();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._isDevice = this._checkDevice();
            this._setValue();
            this._renderControl();
            this.model.enableRTL && this._setRTL();
            if (this.model.enabled)
                this._wireEvents();
            this._setEnabled(this.model.enabled);
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._addAttr(this.model.htmlAttributes);
        },
        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },
        _setRTL: function () {
            $(this.maindiv).addClass("e-rtl");
        },
        _initValidator: function () {
            (!this.wrapper.closest("form").data("validator")) && this.wrapper.closest("form").validate();
        },
        _setValidation: function () {
            this.wrapper.find('input').rules("add", this.model.validationRules);
            var validator = this.wrapper.closest("form").data("validator");
            validator = validator ? validator : this.wrapper.closest("form").validate();
            name = this.wrapper.find('input').attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "name") proxy.element.attr(key, value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._setEnabled(false);
                else if (key == "checked" && value == "checked") {
                    if (proxy.checked() instanceof Array)
                        proxy._updateCheckedItem();
                    else
                        proxy._checked(true);
                }
                else proxy.wrapper.attr(key, value);
            });
        },

        _triggerBeforeChange: function () {
            var data = { isChecked: this._isChecked, isInteraction: false };
            if (true == this._trigger("beforeChange", data)) return false;
        },

        _triggerChange: function () {
            var data = { isChecked: this._isChecked, checkState: this.checkState(), isInteraction: false };
            this._trigger("change", data);
        },

        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "checked":
                        $(this.maindiv).removeClass("e-material-animate");
                        if (this.model.beforeChange) this._triggerBeforeChange();
                        if (this.checked() instanceof Array) {
                            var checkedItemArray = ej.util.getVal(options[prop]);
                            var lastVal = checkedItemArray[checkedItemArray.length - 1];
                            if (this.model.value == lastVal) this._isChecked = true;
                        }
                        else {
                            this._isChecked = ej.util.getVal(options[prop]);
                            this.checked(this._isChecked);
                        }
                        this._isChecked ? this._checked() : this._unChecked();
                        if (this.model.change) this._triggerChange();
                        break;
                    case "enableTriState":
                        if (options[prop]) {
                            this.model.enableTriState = options[prop];
                            this._indeterminateState = options[prop];
                        }
                        break;
                    case "checkState":
                        if (this.model.enableTriState) {
                            if (this.model.beforeChange) this._triggerBeforeChange();
                            this._isChecked = ej.util.getVal(options[prop]);
                            this.checkState(this._isChecked);
                            this._changeState(this._isChecked);
                            if (this.checked() instanceof Array)
                                this._updateCheckedItem();
                            else if (options[prop] == "check") this._hiddenInput.removeAttribute("name");
                            else this._hiddenInput.setAttribute("name", this.model.name);
                            if (this.model.change) {
                                if (!(this.checked() instanceof Array)) this._isChecked = this.checkState() == "uncheck" ? false : true;
                                this._triggerChange();
                            }
                        }
                        break;
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "enableRTL":
                        (options[prop]) ? this._setRTL() : $(this.maindiv).removeClass("e-rtl");
                        break;
                    case "text": this._setText(options[prop]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.wrapper.find('input').rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[prop];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
					this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                         break;
					case "validationMessages":
					  this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "id": this._setIdAttr(options[prop]); break;
                    case "name": this.element.attr('name', options[prop]);
                        if (!this._isChecked || this.spanImg.hasClass("e-chk-indeter")) this._hiddenInput.setAttribute('name', options[prop]);
                        this.model.name = options[prop];
                        break;
                    case "value": this.element.attr('value', options[prop]); break;
                    case "size": this._setSize(options[prop]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[prop]); break;
                    case "enabled": this._setEnabled(options[prop]); break;
                    case "htmlAttributes": this._addAttr(options[prop]); break;
                }
            }
        },

        _destroy: function () {
            this.element.removeClass("e-checkbox e-input");
            this.element.insertBefore(this.wrapper);
            this.wrapper.remove();
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.wrapper.removeClass(this.model.cssClass).addClass(skin);
                $("#" + this.model.idPrefix + this.model.id + "_wrapper").removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _setValue: function () {
            this._indeterminateState = false;
            this._isChecked = false;
            var _id = this.element[0].getAttribute("id"), _name = this.element[0].getAttribute('name'), _value = this.element[0].getAttribute('value');
            !ej.isNullOrUndefined(_id) && (this.model.id = _id);
            !ej.isNullOrUndefined(_name) && (this.model.name = _name);
            if (!ej.isNullOrUndefined(_value) && _value != "") this.model.value = _value;
            if (!this.checked() && !ej.isNullOrUndefined(this.element.attr('checked'))) this._isChecked = true;
            ej.isNullOrUndefined(this.model.name) && (this.model.name = this.model.id);
            this.model.enabled = this.model.enabled && !this.element.attr("disabled");
        },

        _setSize: function (val) {
            if (val == ej.CheckboxSize.Medium) {
                $(this.innerdiv).removeClass('e-chkbox-small').addClass('e-chkbox-medium');
                $(this.maindiv).removeClass('e-check-small').addClass('e-check-medium');
				
			}
            else {
                $(this.innerdiv).removeClass('e-chkbox-medium').addClass('e-chkbox-small');
				$(this.maindiv).removeClass('e-check-medium').addClass('e-check-small');
			}
        },

        _setRoundedCorner: function (val) {
            if (val)
                this.span.addClass("e-corner");
            else
                this.span.removeClass("e-corner");
        },

        _setEnabled: function (val) {
            if (val) {
                this.enable();
            } else {
                this.disable();
            }
        },
        _setCheckBoxState: function () {
            if (this.model.enableTriState) {
                if (this.checkState() == "indeterminate")
                    this._indeterminateState = true
                else if (this.checkState() == "check")
                    this._isChecked = true;
                else if (this.checkState() == "uncheck")
                    this._isChecked = false;
            }
            else if (this.checkState() == "indeterminate")
                this.checkState("uncheck");
        },
        _createElement: function (tagName, attrs) {
            var ele = document.createElement(tagName);
            this._setAttributes(ele, attrs);
            return ele;
        },
        _setAttributes: function (ele, attrs) {
            for (var key in attrs) {
                ele.setAttribute(key, attrs[key]);
            }
        },
        _renderControl: function () {
            this._setCheckBoxState();
            this.maindiv = this._createElement("span", { "class": "e-chkbox-wrap e-widget " + this.model.cssClass, "role": "checkbox", tabindex: 0 });
            if (this._isValid(this.model.id)) {
                this.maindiv.setAttribute("id", this.model.idPrefix + this.model.id);
                this.element[0].setAttribute("id", this.model.id);
            }
            this.innerdiv = document.createElement("div");
            this._setSize(this.model.size);
            this.span = document.createElement("span");
            this.span = $(this.span);
            this.spanImg = this._createElement("span", { "class": "e-chk-image e-icon", "role": "presentation" });
            this.spanImg = $(this.spanImg);
            this.element.addClass("e-input");
            this.model.name = ej.isNullOrUndefined(this.model.name) ? this.model.id : this.model.name;
            this.model.value = ej.isNullOrUndefined(this.model.value) ? true : this.model.value;
            this._setAttributes(this.element[0], { "name": this.model.name, "value": this.model.value });
            var hiddenEl = $("#" + this._id + "_hidden")
            // hidden input element will be generated in MVC wrapper
            this._hiddenInput = hiddenEl.length ? hiddenEl[0] : this._createElement("input", { type: "checkbox", value: false, style: "display:none" });
            this._isValid(this.model.name) && this._hiddenInput.setAttribute("id", this.model.name + "_hidden");

            this._setRoundedCorner(this.model.showRoundedCorner);
            if (this.checked())
                this._setCheckedItem(this.checked());
            if (this._isChecked) {
                this.spanImg.addClass("e-checkmark");
                this.span.addClass("e-chk-act");
                this.maindiv.setAttribute("aria-checked", true);
                this.element.attr("checked", "checked")
            }
            else {
                this.span.addClass("e-chk-inact");
                this.maindiv.setAttribute("aria-checked", false);
                this._hiddenInput.setAttribute("name", this.model.name);
            }
            if (!(this.checked() instanceof Array))
                this.checked(this._isChecked);
            this.span[0].appendChild(this.spanImg[0]);
            this.innerdiv.appendChild(this.span[0]);
            this.element[0].parentNode && this.element[0].parentNode.insertBefore(this.maindiv, this.element[0]);
            this.maindiv.appendChild(this.element[0]);
            this.maindiv.appendChild(this._hiddenInput);
            this.maindiv.appendChild(this.innerdiv);
            this.wrapper = $(this.maindiv);
            this._setTextWrapper(this.model.text);
            this.chkbx = this.element;
            if (this.model.enableTriState == true && this._indeterminateState == true)
                this._setIndeterminate(this._indeterminateState);
            if (this.checked() instanceof Array)
                this._updateCheckedItem();
        },
        _changeState: function (state) {
            if (state == "indeterminate") {
                this.spanImg.removeClass("e-checkmark").addClass("e-stop");
                this.span.removeClass("e-chk-act e-chk-inact").addClass("e-chk-indeter");
                this.wrapper[0].setAttribute("aria-checked", "mixed");
                this.wrapper.find('input').prop('enableTriState', true);
                if (!(this.checked() instanceof Array))
                    this.checked(null);
            }
            else if (state == "check") {
                this.spanImg.removeClass("e-stop").addClass("e-checkmark");
                this.span.removeClass("e-chk-act e-chk-inact e-chk-indeter").addClass("e-chk-act");
                this.wrapper[0].setAttribute("aria-checked", true);
            }
            else if (state == "uncheck") {
                this.spanImg.removeClass("e-checkmark e-stop");
                this.span.removeClass("e-chk-act e-chk-indeter").addClass("e-chk-inact");
                this.wrapper[0].setAttribute("aria-checked", false);
            }
        },

        _setIndeterminate: function (indeter) {
            if (indeter) {
                this.spanImg.removeClass("e-checkmark").addClass("e-stop");
                this.span.removeClass("e-chk-act e-chk-inact").addClass("e-chk-indeter");
                this.wrapper[0].setAttribute("aria-checked", "mixed");
                this.wrapper.find('input').prop('enableTriState', true);
                this.checkState("indeterminate");
                if (!(this.checked() instanceof Array))
                    this.checked(null);
                this._hiddenInput.setAttribute("name", this.model.name);
            }
            else {
                this.span.removeClass("e-chk-indeter");
                this.spanImg.removeClass("e-stop");
                this.wrapper.find('input').removeAttr('enableTriState');
                this.wrapper.find('input').prop('enableTriState', false);
                if (this.checked())
                    this._checked();
                else
                    this._unChecked();
            }
        },

        _setTextWrapper: function (val) {
            if (val != "") {
                this.txtSpan = ej.buildTag("div.e-text", val);
                this.wrapper.append(this.txtSpan);
                this.model.enableRTL && this._setRTL();
            }
        },

        _setText: function (val) {
            if ((this.model.text == "") && (val != "")) {
                this._setTextWrapper(val);
            } else {
                this.txtSpan.html(val);
            }
        },

        _setIdAttr: function (val) {
            $("#" + this.model.idPrefix + this.model.id + "_wrapper").attr('id', this.model.idPrefix + val + "_wrapper");
            this.element[0].setAttribute('id', val);
        },

        _isValid: function (value) {
            return (!ej.isNullOrUndefined(value) && value != "") ? true : false;
        },

        _wireEvents: function () {
            this._on(this.wrapper, "click", this._checkedHandler);
            if (this._isIE8) {
                this._isValid(this.model.id) && this._on($("label[for=" + this.model.id + "]"), "click", function () { this.wrapper.click(); });
            }
            this._on(this.wrapper, "focus", this._focusIn);
            this._on(this.wrapper, "focusout", this._focusOut);
        },


        _unWireEvents: function () {
            this._off(this.wrapper, (this._isDevice && $.isFunction($.fn.tap)) ? "tap" : "click");
            if (this._isIE8) {
                this._isValid(this.model.id) && this._off($("label[for=" + this.model.id + "]"), "click");
            }
            this._off(this.wrapper, "focus");
            this._off(this.wrapper, "focusout");
        },
        _focusIn: function (evt) {
            $(this.wrapper).addClass("e-focus");
            $(this.wrapper).on("keydown", $.proxy(this._checkUnCheck, this));
        },
        _focusOut: function (evt) {
            $(this.wrapper).removeClass("e-focus");
            $(this.wrapper).off("keydown", $.proxy(this._checkUnCheck, this));
        },
        _checkUnCheck: function (evt) {
            //Space bar to check and uncheck
            if (evt.keyCode == 32) {
                evt.preventDefault();
                this._checkedHandler();
            }
        },
        _checkedHandler: function (evt) {
            var data = { isChecked: this._isChecked, isInteraction: true, event: evt };
            if (true == this._trigger("beforeChange", data)) {
                return false;
            }
            if (this.span.hasClass("e-chk-inact")) {
                this._checked();
                if (!(this.checked() instanceof Array))
                    this.checked(true);
                if (this.model.enableTriState) {
                    this._indeterminateState = true;
                    this.checkState("check");
                }
            }
            else if (this.span.hasClass("e-chk-act")) {
                if ((this.model.enableTriState == true) && (this._indeterminateState == true)) {
                    this._setIndeterminate(true);
                    if (!(this.checked() instanceof Array)) {
                        this.checked(true);
                        this.checkState("indeterminate");
                    }
                } else {
                    this._unChecked();
                    if (!(this.checked() instanceof Array)) {
                        this.checked(false);
                        this.checkState("uncheck");
                    }
                }
            }
            else if (this.span.hasClass("e-chk-indeter")) {
                if (!(this.checked() instanceof Array))
                    this.checked(false);
                else
                    this._isChecked = false;
                this._setIndeterminate(false);
                this._indeterminateState = false;
            }
            if (this.checked() instanceof Array)
                this._updateCheckedItem();
            else
                this._isChecked = this.checked();
            $(this.maindiv).addClass("e-material-animate");
            var data = { isChecked: this._isChecked, checkState: this.checkState(), isInteraction: true, event: evt };
            this._trigger("change", data);
            return true;
        },


        _checked: function () {
            this.span.removeClass("e-chk-inact").addClass("e-chk-act");
            this.spanImg.removeClass("e-stop").addClass("e-checkmark");
            this.wrapper[0].setAttribute("aria-checked", true);
            this.wrapper.find('input[type=checkbox]').prop('checked', true);
            this.checkState("check");
            this._hiddenInput.removeAttribute("name");
        },


        _unChecked: function () {
            this.span.removeClass("e-chk-act e-chk-indeter").addClass("e-chk-inact");
            this.wrapper[0].setAttribute("aria-checked", false);
            this.spanImg.removeClass("e-checkmark e-stop");
            this.wrapper.find('input[type=checkbox]').prop('checked', false);
            this.checkState("uncheck");
            this._hiddenInput.setAttribute("name", this.model.name);
        },

        _setCheckedItem: function (value) {
            if (!ej.isNullOrUndefined(value) && value != "" && !(value instanceof Array))
                this._isChecked = true;
            else if (value instanceof Array && !ej.isNullOrUndefined(this.model.value) && this.model.value != "") {
                for (var item = 0; item < value.length; item++) {
                    if (value[item] == this.model.value)
                        this._isChecked = true;
                }
            }
        },

        _updateCheckedItem: function () {
            if (!ej.isNullOrUndefined(this.model.value) && this.model.value != "" && !this.wrapper.find("span:first").hasClass("e-chk-indeter")) {
                if (($.inArray(this.model.value, this.checked()) < 0) && this.wrapper.find("span:first").hasClass("e-chk-act")) {
                    this.checked().push(this.model.value);
                    this._isChecked = true;
                    this._hiddenInput.removeAttribute("name");
                }
                else if (($.inArray(this.model.value, this.checked()) > -1) && this.wrapper.find("span:first").hasClass("e-chk-inact")) {
                    this.checked().splice($.inArray(this.model.value, this.checked()), 1);
                    this._isChecked = false;
                    this._hiddenInput.setAttribute("name", this.model.name);
                }
            }
        },


        disable: function () {
            if (!this.wrapper.hasClass("e-disable")) {
                this.wrapper.addClass("e-disable");
                this.wrapper[0].setAttribute("aria-disabled", true);
                this.element[0].setAttribute("disabled", "disabled");
                if (this._isIE8) this.span.addClass("e-disable");
                this._unWireEvents();
                this.model.enabled = false;
            }
        },

        enable: function () {
            if (this.wrapper.hasClass("e-disable")) {
                this.wrapper.removeClass("e-disable");
                this.wrapper[0].setAttribute("aria-disabled", false);
                this.element.prop("disabled", false);
                if (this._isIE8) this.span.removeClass("e-disable");
                this._wireEvents();
                this.model.enabled = true;
            }
        },

        isChecked: function () {
            if ((this._isChecked != null) && (this._isChecked != undefined))
                return this._isChecked;
        }
    });

    ej.CheckboxSize = {
        /**  Creates checkbox with inbuilt small size height, width specified */
        Small: "small",
        /**  Creates checkbox with inbuilt medium size height, width specified */
        Medium: "medium"
    };

    ej.CheckState = {
        /**  Specifies the Check attribute of the Checkbox */
        Check: "check",
        /**  Specifies the Uncheck attribute of the Checkbox */
        Uncheck: "uncheck",
        /**  Specifies the Indeterminate state of the Checkbox */
        Indeterminate: "indeterminate"
    };
})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin to style the Html Radiobutton elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRadioButton", "ej.RadioButton", {
        _rootCSS: "e-radiobtn",

        element: null,
        _requiresID: true,
        model: null,
        validTags: ["input"],
        _addToPersist: ["checked"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            id: null,

            name: null,

            value: null,

            checked: false,

            cssClass: "",

            text: "",

            enableRTL: false,

            htmlAttributes: {},

            enablePersistence: false,

            idPrefix: "ej",

            size: "small",

            enabled: true,

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            beforeChange: null,

            change: null,

            create: null,

            destroy: null
        },


        dataTypes: {
            id: "string",
            name: "string",
            enablePersistence: "boolean",
            size: "enum",
            enabled: "boolean",
            idPrefix: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },

        observables: ["checked"],
        checked: ej.util.valueFunction("checked"),

        _init: function (options) {
            var browserInfo = ej.browserInfo();
            this._cloneElement = this.element.clone();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._setValue();
            this._renderControl();
            if (this.isChecked)
                this._checkedHandler();
            if(!ej.isNullOrUndefined(this.radbtn.attr("disabled"))) this.model.enabled = false;
            this._setEnabled(this.model.enabled);
            this._addAttr(this.model.htmlAttributes);
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._wireEvents();
            this.initialRender = false;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.div.addClass(value);
                else if (key == "name") proxy.radbtn.attr(key, value);
                else if (key == "required") proxy.radbtn.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else if (key == "checked" && value == "checked") proxy._checkedChange(true, true);
                else proxy.div.attr(key, value);
            });
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            this.element.find("input").rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.find('input').attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },


        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "enableRTL":
                        if (this.model.text)
                            (options[prop]) ? this.div.addClass("e-rtl") : this.div.removeClass("e-rtl") && this.element.closest('.e-radiobtn-wrap').hasClass('e-rtl') ? this.element.closest('.e-radiobtn-wrap').removeClass('e-rtl') : "";
                        else
                            (options[prop]) ? this.element.closest('.e-radiobtn-wrap').addClass('e-rtl') : this.element.closest('.e-radiobtn-wrap').removeClass('e-rtl');
                        break;
                    case "text": this._setText(options[prop]); break;
                    case "size": this._setSize(options[prop]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.find('input').rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[prop];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                     case "validationMessages":
                        this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "checked":
						$(this.div).removeClass("e-material-animate");
                        if (typeof this.checked() == "boolean") {
                            this.model.checked = options[prop];
                            this._checkedChange(this.model.checked);
                        }
                        else if (options[prop]() != null) {
                            if (options[prop]() == this.element.find(".e-input").attr("value"))
                                this._checkedChange(options[prop]());
                        }
                        break;
                    case "enabled": this._setEnabled(options[prop]); break;
                    case "id": this._setIdAttr(options[prop]); break;
                    case "name": this.radbtn.attr('name', options[prop]); break;
                    case "value":
                        this.radbtn.attr("value", options[prop]);
                        break;
                    case "htmlAttributes": this._addAttr(options[prop]); break;
                }
            }
        },

        _destroy: function () {
            this.radbtn.remove();
            this._cloneElement.removeClass("e-js e-input e-radiobtn");
            this._cloneElement.insertBefore(this.element)
            this.element.remove();
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
                this.div.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _setValue: function () {
            if (ej.isNullOrUndefined(this.element.attr("type")))
                this.element.attr("type", "radio");
            if (!ej.isNullOrUndefined(this.element.attr("id")))
                this.model.id = this.element.attr("id");
            if (!ej.isNullOrUndefined(this.element.attr("name")))
                this.model.name = this.element.attr("name");
            if (!ej.isNullOrUndefined(this.element.attr("value")))
                this.model.value = (this.element.attr("value"));
            this.element.attr({ "id": this.model.id, "name": this.model.name, "value": this.model.value });
            if (typeof this.checked() == "boolean")
                this.model.checked = this.isChecked = this.model.checked || this.element.attr('checked') == "checked"
            else
                this.isChecked = this.element.attr("value") == this.checked();
            if (this.isChecked) this.element.attr('checked', 'checked');
            this._hiddenValue = this.element.attr("value");
            this._isAngularbind = false;
        },

        _setIdAttr: function (val) {
            $("#" + this.model.idPrefix + this.model.id + "_wrapper").attr('id', this.model.idPrefix + val + "_wrapper");
            $("#" + this.model.idPrefix + this.model.id).attr('id', this.model.idPrefix + val);
            this.radbtn.attr('id', val);
        },

        _setSize: function (val) {
            if (val == ej.RadioButtonSize.Medium) {
                this.span.removeClass('e-radsmaller').addClass('e-radmedium');
                this.div.removeClass('e-radsmall').addClass('e-radmed');
			}
            else {
                this.span.removeClass('e-radmedium').addClass('e-radsmaller');
                this.div.removeClass('e-radmed').addClass('e-radsmall');
			}
        },

        _setEnabled: function (val) {
            if (val) {
                this.enable();
            } else {
                this.disable();
            }
        },

        _renderControl: function () {
            this.initialRender = true;
            var browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == '8.0')
                this.div = $('<div class="e-radiobtn-wrap e-widget e-rad-outer" ></div>');
            else
                this.div = $('<div class="e-radiobtn-wrap e-widget" ></div>');
            this.div.attr({ 'id': this.model.idPrefix + this.model.id, "role": "radio", "tabindex": 0, "aria-checked": false });
            this.span = $('<span></span>');
            this.span.addClass("e-spanicon");
            this._setSize(this.model.size);
            this.spanImg = $('<span class="e-rad-icon e-icon e-rad-select"></span>', "", {}, { "role": "presentation" });
            this.element.addClass("e-input");
            this.div.addClass(this.model.cssClass);
            this.span.append(this.spanImg);
            this.div.insertBefore(this.element);
            this.div.append(this.element);
            this.div.append(this.span);
            this._setTextWrapper(this.model.text);
            this.radbtn = this.element;
            this.element = this.div;
        },

        _setTextWrapper: function (val) {
            if (val != "") {
                this.txtSpan = ej.buildTag("div.e-text", val);
                this.div.append(this.txtSpan);
                if (this.model.enableRTL)
                    this.div.addClass("e-rtl");
            } else if (this.model.enableRTL)
                this.element.closest('.e-radiobtn-wrap').addClass('e-rtl');
        },

        _setText: function (val) {
            if ((this.model.text == "") && (val != "")) {
                this._setTextWrapper(val);
            } else {
                this.txtSpan.html(val);
            }
        },

        _wireEvents: function () {
            this._on(this.element, "click", this._checkedHandler);
            this._on(this.element, "focus", this._focusIn);
            this._on(this.element, "focusout", this._focusOut);
        },
        _focusIn: function (evt) {
            $(this.element).addClass("e-focus");
            $(this.element).on("keydown", $.proxy(this._checkUnCheck, this));
        },
        _focusOut: function (evt) {
            $(this.element).removeClass("e-focus");
            $(this.element).off("keydown", $.proxy(this._checkUnCheck, this));
        },

        _checkUnCheck: function (evt) {
            //Space bar,and arrow keys to check and uncheck
            if (evt.keyCode == 32 || evt.keyCode == 37 || evt.keyCode == 38 || evt.keyCode == 39 || evt.keyCode == 40) {
                evt.preventDefault();
                this._checkedHandler();
            }
        },

        _checkedHandler: function (evt) {
			if (evt) this._interacted = true;
            if (!this.element.hasClass('e-disable')) {
                if (typeof this.checked() == "boolean")
                    this.isChecked = this.radbtn.attr('checked') == 'checked' ? true : false;
                else
                    this.isChecked = this.checked() == this.radbtn.attr('value');
                if (!$(this.element).find(".e-rad-icon").hasClass("e-circle_01")) this._changeEvent(true);
				if (evt) $(this.div).addClass("e-material-animate");
            }
        },

        _checkedChange: function (val, interaction) {
            this.isChecked = val;
            this._changeEvent(interaction);
        },

        _changeEvent: function (interaction) {
            var data = { isChecked: this.isChecked, isInteraction: !!interaction };
            if (!this.initialRender) {
                if (true == this._trigger("beforeChange", data))
                    return false;
            }

            if (!$(this.element).find(".e-rad-icon").hasClass("e-circle_01")) {
                var curname = this.element.find(".e-input").attr('name'),
                input = $('input.e-radiobtn[name="' + curname + '"]:radio'),
                proxy = this,
                currElement = this.element.find('.e-input'),
                currObj = $(currElement).data("ejRadioButton");
                if (data.isChecked) {
                    this.spanImg.addClass("e-circle_01").removeClass('e-rad-select');
                    this.span.addClass("e-rad-active");
                    this.div.attr({ "tabindex": 0, "aria-checked": true });
                    this.radbtn.attr("checked", "checked");
                }
                $.each(input, function (i, obj) {
					if (proxy._interacted && $($(obj).closest(".e-widget")).find("span.e-spanicon").hasClass("e-rad-active")) $(obj).closest(".e-radiobtn-wrap").addClass("e-material-animate");
                    $(obj).closest(".e-radiobtn-wrap").find(".e-rad-icon").removeClass("e-circle_01").addClass("e-rad-select");
                    $(obj).closest(".e-radiobtn-wrap").find(".e-spanicon").removeClass("e-rad-active");
                    $(obj).closest(".e-radiobtn-wrap").attr({ "tabindex": 0, "aria-checked": false });
                    var prevObj = $(obj).data("ejRadioButton");
                    if (prevObj != null && prevObj.checked() != null && typeof prevObj.checked() == "boolean")
                        prevObj.model.checked = false;
                });
                if (currObj != null && currObj.checked() != null && typeof currObj.checked() == "boolean")
                    currObj.model.checked = true;
                else
                    currObj.checked(currObj.radbtn.attr("value"));
                this.element.find(".e-rad-icon").addClass("e-circle_01").removeClass("e-rad-select");
                this.span.addClass("e-rad-active");
                this.div.attr({ "tabindex": 0, "aria-checked": true });
                if (!this._isAngularbind) this.element.find(".e-input").click();
                this.isChecked = true;
            }
            else {
                this.spanImg.removeClass("e-circle_01").addClass('e-rad-select');
                this.span.removeClass("e-rad-active");
                this.div.attr({ "tabindex": 0, "aria-checked": false });
                this.radbtn.removeAttr("checked");
            }

            var data = { isChecked: this.isChecked, isInteraction: !!interaction };
            if (!this.initialRender)
                this._trigger("change", data);
            if (interaction) this._trigger("_change", { value: this._hiddenValue });
        },

        disable: function () {
            if (!this.element.hasClass("e-disable")) {
                this.element.addClass("e-disable");
                this.radbtn.attr("disabled", "disabled");
            }
            if (this._isIE8) this.span.addClass("e-disable");
            this.div.attr("aria-disabled", true);
            this.model.enabled = false;
        },

        enable: function () {
            if (this.element.hasClass("e-disable")) {
                this.element.removeClass("e-disable");
                this.radbtn.prop("disabled", false);
            }
            if (this._isIE8) this.span.removeClass("e-disable");
            this.div.attr("aria-disabled", false);
            this.model.enabled = true;
        }
    });

    ej.RadioButtonSize = {
        /**  Creates radio button with inbuilt small size height, width specified */
        Small: "small",
        /**  Creates radio button with inbuilt medium size height, width specified */
        Medium: "medium"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejAutocomplete", "ej.Autocomplete", {

        element: null,

        model: null,
        validTags: ["input"],
        _ignoreOnPersist: ["fields", "dataSource", "query", "focusIn", "focusOut", "change", "select",
                            "create", "destroy", "open", "close", "actionComplete", "actionSuccess", "actionFailure"],
        _setFirst: false,

        _rootCSS: "e-autocomplete",
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        _requiresID: true,

        defaults: {

            dataSource: null,

            query: null,

            fields: {

                text: null,

                key: null,
                //Deprecated
                category: null,

                groupBy: null,

                htmlAttributes: null
            },
            locale: "en-US",
			
			name:null,

            template: null,
            //Deprecated
            allowGrouping: false,

            enableDistinct: false,

            allowSorting: true,

            sortOrder: "ascending",

            htmlAttributes: {},

            multiSelectMode: "none",

            delimiterChar: ',',

            allowAddNew: false,

            addNewText: "Add New",

            showRoundedCorner: false,

            readOnly: false,

            cssClass: "",

            watermarkText: null,

            value: "",

            selectValueByKey: null,

            filterType: "startswith",

            caseSensitiveSearch: false,

            showLoadingIcon: true,
			
			showResetIcon : false,

            itemsCount: 0,

            minCharacter: 1,

            delaySuggestionTimeout: 200,

            showPopupButton: false,

            highlightSearch: false,

            enableAutoFill: false,

            enableRTL: false,

            enabled: true,

            visible: true,

            height: "",

            width: "",

            emptyResultText: "No suggestions",

            animateType: "slide",

            showEmptyResultText: true,

            enablePersistence: false,

            popupHeight: "152px",

            popupWidth: "auto",

            autoFocus: false,
			
            multiColumnSettings: {
    
                enable:false,
    
                showHeader:true, 
                
                stringFormat:"{0}",
    
                columns:[{
                           field:null,
           
                            headerText:null,
							
							textAlign:"left",
							
							headerTextAlign:"left",
							
							cssClass: "",
							
							type:"string",

							filterType: "startswith"
       
                        }]
            },

            validationRules: null,

            validationMessage: null,

            focusIn: null,

            focusOut: null,

            change: null,

            select: null,

            create: null,

            open: null,

            close: null,

            destroy: null,

            actionBegin: null,

            actionComplete: null,

            actionSuccess: null,

            actionFailure: null
        },

        dataTypes: {
            autoFocus: "boolean",
            watermarkText: "string",
            locale: "string",
            cssClass: "string",
            filterType: "enum",
            caseSensitiveSearch: "boolean",
            showLoadingIcon: "boolean",
            template: "string",
            //Deprecated
            allowGrouping: "boolean",
            enableDistinct: "boolean",
            allowSorting: "boolean",
            sortOrder: "enum",
            allowAddNew: "boolean",
            addNewText: "string",
            showRoundedCorner: "boolean",
			showResetIcon:"boolean",
            readOnly: "boolean",
            itemsCount: "number",
            animateType: "enum",
            minCharacter: "number",
            showPopupButton: "boolean",
            highlightSearch: "boolean",
            enableAutoFill: "boolean",
            enableRTL: "boolean",
            multiSelectMode: "enum",
            delimiterChar: "string",
            emptyResultText: "string",
            showEmptyResultText: "boolean",
            enabled: "boolean",
            visible: "boolean",
            enablePersistence: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
            multiColumnSettings: "data"
        },
        observables: ["value", "selectValueByKey"],
        value: ej.util.valueFunction("value"),
        _selectValueByKey:ej.util.valueFunction("selectValueByKey"),
        enable: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                this.target.disabled = false;
                this.element.removeClass("e-disable").attr({ "aria-disabled": false });
                this.element.removeAttr("disabled");
                if (this.model.showPopupButton) this.dropdownbutton.removeClass("e-disable").attr({ "aria-disabled": false });
                if (this.model.multiSelectMode == "visualmode") this._ulBox.removeClass("e-disable").attr({ "aria-disabled": false });
                this.wrapper.removeClass('e-disable-wrap');
            }
        },

        disable: function () {
            if (this.model.enabled) {
                this._hideResult();
                this.model.enabled = false;
                this.target.disabled = true;
                this.element.attr("disabled", "disabled");
                this.element.addClass("e-disable").attr({ "aria-disabled": true });
                if (this.model.showPopupButton) this.dropdownbutton.addClass("e-disable").attr({ "aria-disabled": true });
                if (this.model.multiSelectMode == "visualmode" && this._ulBox) this._ulBox.addClass("e-disable").attr({ "aria-disabled": true });
                this.wrapper.addClass('e-disable-wrap');
            }
        },

        clearText: function () {
            if (this.model.multiSelectMode == "visualmode")
                this._deleteBox(this._ulBox.children("li"));
            this.element.val("");
            this._valueChange();
            if (this._isFocused) this.element.blur();
            else this._focusOutAction();
            this._hideResult()
        },

        getValue: function () {
            var value = this.value();
            return (value == null) ? "" : value; 
        },

        getSelectedItems: function () {
            if (this._isFocused && this.model.multiSelectMode != "visualmode")
                this._updateSelectedItemArray(this.getValue());
            return this._selectedItems;
        },
        _setValue: function (value) {
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            if (typeof value === "object" || (typeof value === "number" && isNaN(value)) || $.trim(value) == "") value = "";
            if (this.model.multiSelectMode == "visualmode")
                this._hiddenInput.val("");
            this.element.val("");
            if (value) {
                if (this.model.multiSelectMode == "visualmode") {
                    this._selectedItems = [];
                    this._modelValue = value;
                    this._deleteBox(this._ulBox.children("li"));
                    var values = value.split(this.model.delimiterChar);
					this.element.width(1).val("").removeAttr('placeholder');
					if(!this._hiddenInput) this._hiddenInput = ej.buildTag("input#" + this.target.id + "_hidden", "", {}, { type: "hidden", "name" : this.element.attr("name")}).insertBefore(this.element);
                    if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
                        this._createBoxForObjectType(values);
                    }
                    else {
                        this.suggestionListItems = this.model.dataSource;
                        if (this.suggestionListItems && typeof this.suggestionListItems[0] != "object") {
							this._hiddenInput.val(value);
                            for (var i = 0, length = values.length; i < length; i++) {
                                if (values[i]) {
                                    this._ulBox.append(this._createBox(values[i]));
                                    this._selectedItems.push(values[i]);
                                }
                            }
                            }
                        else this._createBoxForObjectType(values);
                    }
                }
                else {
                    this.element.val(value);
                    this._updateSelectedItemArray(value);
                }
            }
            if (this.model.multiSelectMode != "visualmode") this.value(this.element.val());
            this._preVal = this.element.val();
            !this._isWatermark && this._setWatermarkTxt();
            return value;

        },
        _createBoxForObjectType: function (values) {
			var proxy=this, map=this._declareVariable();
            for (var data = 0, length = values.length; data < length; data++) {
                var _val = $.trim(values[data]);
				if(_val != ""){
                if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
                    this._dataQuery = this._getQuery().where(map[0], "equal", _val, false);
                    this._promise = (this.model.dataSource).executeQuery(this._dataQuery);
                    this._promise.done(function (e) {
                        var res = e.result;
                        proxy._strData = res instanceof Array && res.length ? res[0] : _val;
                        if (!ej.isNullOrUndefined(proxy._strData[map[1]]))
                            proxy._selectKeyInit();
                        proxy._selectedItems.push(proxy._strData);
                    }).fail(function (e) {
                        proxy._selectedItems.push(_val);
                    });
                }
                else {
                    this._dataQuery = ej.Query().where(map[0], "equal", _val, false);
                    this._promise = ej.DataManager(this.suggestionListItems).executeLocal(this._dataQuery);
                    this._strData = this._promise instanceof Array && this._promise.length ? this._promise[0] : _val;
                    if (!ej.isNullOrUndefined(this._strData[map[1]])) 
					  this._selectKeyInit();
					this._selectedItems.push(this._strData);
                }
                if (this.model.multiSelectMode == "visualmode")
                    this._ulBox.append(this._createBox(_val));
            }
			}
			
        },

        _selectKeyInit: function () {
            var mapper = this._declareVariable();
            delimiterChar = this._delimiterChar();
            if (this.model.multiSelectMode == "visualmode")
                this._hiddenInput.val(this._hiddenInput.val() + (!ej.isNullOrUndefined(this._strData[mapper[1]] || this._strData[mapper[0]]) ? (this._strData[mapper[1]] || this._strData[mapper[0]]) + this.model.delimiterChar : ""));
            if (!ej.isNullOrUndefined(this._strData[mapper[1]])) {
                if (this.model.multiSelectMode != "none") {
                    var keyValue = this._selectValueByKey() != null ? (this._selectValueByKey() + this._strData[mapper[1]] + delimiterChar) : this._strData[mapper[1]] + delimiterChar
                    keyValue = keyValue.split(delimiterChar).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []);
                    this._selectValueByKey(keyValue.join(delimiterChar));
                }
                else this._selectValueByKey(this._strData[mapper[1]]);
            }
        },
		    _declareVariable: function () {
		        var mapper = this.model.fields, mapFld = { _key: null, _text: null, _attr: null }, keyText = [];
			 if(!ej.isNullOrUndefined(mapper)){
				mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text" ;
				mapFld._key = (mapper && mapper.key) ? mapper["key"] : "key" ;
				keyText.push(mapFld._text,mapFld._key);
				return keyText;
			 }
		},

       selectValueByKey: function (key) {
            if (!ej.isNullOrUndefined(key)) {
                var proxy = this;
                key = key.toString();
                var result = this.model.multiSelectMode != "none" ? key.split(this.model.delimiterChar) : key.split(",");
                if (Object.prototype.toString.call(result) === '[object Array]') {
                    $.each(result, function (index, value) {
                        proxy._setOperation($.trim(value), "key");
                    });
                }
                this._eventTrigger();
            }
        },

        selectValueByText: function (text) {
            this._setOperation(text, "text");
            var list = this.model.dataSource;
            if (!(ej.DataManager && list instanceof ej.DataManager)) this._eventTrigger();
        },

        _eventTrigger: function () {
            var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val() == "" ? null : this.element.val();
            this._trigger("select", { isInteraction: true, value: this.value(), text: currValue, key: this._selectValueByKey(), item: this._selectedItems });
        },

        setValue: function (text) {
            this._setText(text);
        },

        _setOperation: function (source, value) {
            var bindTo = "", promise, dataQuery, proxy = this, list = this.model.dataSource;
            if (ej.isNullOrUndefined(list)) return false;
            if (typeof list[0] == "object" || list instanceof ej.DataManager) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper[value]) ? mapper[value] : value;
            } else if (value == "key")
                return false;
            if (ej.DataManager && list instanceof ej.DataManager) {
                dataQuery = this._getQuery().where(bindTo, "equal", source, !this.model.caseSensitiveSearch);
                promise = (list).executeQuery(dataQuery);
                promise.done(function (e) {
                    proxy._setText(e.result[0]);
                    proxy._eventTrigger();
                });
            }
            else {
                if ((!list || !list.length || list.length < 1)) return false;
                dataQuery = ej.Query().where(bindTo, "equal", source, !this.model.caseSensitiveSearch);
                promise = ej.DataManager(list).executeLocal(dataQuery);
                this._setText(promise[0]);
            }
        },

        _setText: function (data) {
            if (!data) return false;
            var currentValue, keyvalue, mapper = this.model.fields;
            if ((typeof this.model.dataSource[0] == "object") || (typeof data == "object")) {
                currentValue = typeof data == "string" ? data : (mapper && mapper["text"]) ? data[mapper["text"]] : data["text"];
                keyvalue = typeof data == "string" ? data : (mapper && mapper["key"]) ? data[mapper["key"]] : data["key"];
            }
            else currentValue = data;
            if (currentValue) {
                if (this.model.multiSelectMode == "visualmode" && this._removeDuplicates(data)) return false;
                this._valueToTextBox(currentValue, data, true);
                var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val();
                this.value(currValue);
				if (this.model.showResetIcon) this._showReset();
            }
            if (!ej.isNullOrUndefined(keyvalue)) this._selectValueByKey(keyvalue);
        },

        _textFormateString: function (data, index) {
            var _textFormatString = this.model.multiColumnSettings.stringFormat
			this._columnsIndex();
            if (!ej.isNullOrUndefined(data) && typeof data == "object") {
                for (var i = 0, length = this._columnIndex.length; i < length; i++)
                    _textFormatString = _textFormatString.replace("{" + this._columnIndex[i] + "}", data[this.model.multiColumnSettings.columns[parseInt(this._columnIndex[i])].field]);
            }
            else if (!ej.isNullOrUndefined(data) && typeof data != "object") {
                _textFormatString = _textFormatString.replace("{" + this._columnIndex[0] + "}", data);
            }
            else
                _textFormatString = this._currList[this._activeItem - 1];
            return _textFormatString;
        },

		_columnsIndex: function(){
			var _proxy = this; this._columnIndex = [];
			$.each(this.model.multiColumnSettings.stringFormat.match(/\{.+?\}/g),function (x,n){ 
				  _proxy._columnIndex[x] = n.slice(1,-1)
			});
		},
        _valueToTextBox: function (currentValue, data, flag) {
            var delimiterIndex;
         if(!this._addNewTemplate && this.model.multiColumnSettings.enable && typeof data != "string") 
             currentValue = this._textFormateString(data);
         if (this.model.multiSelectMode == "visualmode") {
             data = (typeof data == "string" && this._addNewTemplate && data.substr(data.length - this._addNewTemplate.length) == this._addNewTemplate) ? data.replace(this._addNewTemplate, "") : data;
				var temp = currentValue.indexOf(this._addNewTemplate);
                if (this._addNewTemplate) currentValue = currentValue.substr(0, currentValue.length - this._addNewTemplate.length);
                delimiterIndex = this.model.delimiterChar;
                var key = this._getUniqueKey();
                key = key ? key : (this.model.fields && this.model.fields["key"]) ? data[this.model.fields["key"]] : !ej.isNullOrUndefined(data["key"]) ? data["key"] : key;
			    if(!(this._selectValueByKey() == key || key == null) || temp > -1 )					
			        this._selectValueByKey(this._selectValueByKey() != null ? (this._selectValueByKey() + (temp > -1 ? currentValue : key) + delimiterIndex) : (temp > -1 ? currentValue : key) + delimiterIndex);
			    if(!(this._hiddenInput.val() == key || key == null) || temp > -1)
			        this._hiddenInput.val(this._hiddenInput.val() + (key || currentValue) + delimiterIndex);
			    this._modelValue = ej.isNullOrUndefined(this.value()) ? currentValue + delimiterIndex : this.value() + currentValue + delimiterIndex;
                this.element.val("").removeAttr('placeholder').width(1);
                this._ulBox.append(this._createBox(currentValue));
				if(this.model.height!=""){
                $(this._ulBox).parent().css("overflow","auto");	
                if((this.model.showPopupButton)&&(this._ulBox.parent()[0].scrollHeight!=0)) this.dropdownbutton.css("height",this._ulBox.parent()[0].scrollHeight);				
				}
                this._addNewTemplate = null;
            }
            else if (this.model.multiSelectMode == "delimiter") {
                var delimiterIndex = (this.target.value).lastIndexOf(this.model.delimiterChar);
                if (this._typed || this.element.val() == "" || flag || !this.model.showPopupButton) {
                    if (flag)
                        this.element.val(this.element.val() == "" ? (currentValue + this.model.delimiterChar) : (this.element.val() + currentValue + this.model.delimiterChar));
                    else					 
                        delimiterIndex == -1 ? this.element.val(this._queryString.substr(0, delimiterIndex + 1) + currentValue + this.model.delimiterChar):this.element.val(this._queryString.substr(0, delimiterIndex + ((this.model.delimiterChar).length)) + currentValue + this.model.delimiterChar)
                 }
                else {
                    if(!this.model.enableAutoFill || this.showSuggestionBox) {
					if (this._checkDeli())
                        this.element.val(this._queryString.substr(0, delimiterIndex) + this.model.delimiterChar + currentValue + this.model.delimiterChar);
                    else
                        this.element.val(this.element.val() + this.model.delimiterChar);
                    }
					else if(!this._checkDeli()) this.element.val(this.element.val() + this.model.delimiterChar);
				}
                this._typed = false;
            }
            else {
                this.element.val(currentValue);
                this._selectedItems = [];
            }
            this._selectedItems.push(data);
			this._originalval.push(currentValue);
            this._moveCaretToEnd(this.element[0]);
        },

        _removeDuplicates: function (currentValue) {
            if (this._selectedItems.length == 0) return false;
            if (this._selectedItems.indexOf(currentValue) != -1) return true;
        },

        search: function () {
            if (this.model.enabled && this._checkDelimiter()) {
                this._hideResult();
                this._autoFill = false;
                this._queryString = $.trim(this._queryString);
                if (this._queryString.length > 0) this._OnTextEnter();
            }
        },
        setVisible: function (value) {
            if (value)
                this.wrapper.show();
            else
                this.wrapper.hide();
        },

        hide: function () {
            this._hideResult();
        },

        open: function () {
            this._showFullList();
        },

        _changeWatermark: function (text) {
            if (this._isWatermark) this.element.attr("placeholder", text);
            else this._hiddenSpan.text(text);
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.suggestionList.removeClass(this.model.cssClass).addClass(skin);
        },
        _setDropdown: function (boolean) {
            this.model.showPopupButton = boolean;
            if (boolean) this._renderDropdown();
            else this._destroyDropdown();
        },
        _changeHeight: function (height) {
            this.wrapper.height(height);
        },
        _changeWidth: function (width) {
            this.wrapper.width(width);
            this._setListWidth();
        },
        _setCulture: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.addNewText)) this._localizedLabels.addNewText = this._options.addNewText;
                if (!ej.isNullOrUndefined(this._options.emptyResultText)) this._localizedLabels.emptyResultText = this._options.emptyResultText;
                if (!ej.isNullOrUndefined(this._options.watermarkText)) this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this.model.addNewText = this._localizedLabels.addNewText;
            this.model.emptyResultText = this._localizedLabels.emptyResultText;
            this.model.watermarkText = this._localizedLabels.watermarkText;
        },
        
        _init: function (options) {
            this._options = options;
            this._setCulture();
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            //deprecated Property Added
            this.model.fields.groupBy = !this.model.fields.groupBy ? this.model.fields.category : this.model.fields.groupBy;
            this._initialize();
            this._render();
            this._wireEvents();
            this.initialRender = false;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            if (!this.model.validationRules) return;
            var element = this.model.multiSelectMode == "visualmode" ? this._hiddenInput : this.element;
            element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
		_removeDuplicateValue: function(values) {
			return values.split(this.model.delimiterChar).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []).join(this.model.delimiterChar);
		},
        _delimiterChar:function(){
            return (this.model.multiSelectMode != "none" ? this.model.delimiterChar : "");
        },
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "dataSource": this.model.dataSource = null; break;
                    case "watermarkText": this._changeWatermark(options[option]); break;
                    case "delaySuggestionTimeout": this.model.delaySuggestionTimeout = parseInt(options[option]); break;
                    case "value":
                        deli = this._delimiterChar();
                        if (this.model.multiSelectMode != "none") {
                            value = options[option].substr(options[option].length - deli.length) == deli ? options[option] : options[option] + deli;
                            options[option] = options[option] == "" ? this.value() : (this.value() ? this.value() : "") + value;
                            if (this.model.multiSelectMode == "visualmode") {
                                options[option] = options[option].split(deli).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []);
                                options[option] = options[option].join(deli);
                            }
                        }
                        this.value(this._setValue(options[option]));
                        this._modelValue = this.value()
                        var currValue = this.model.multiSelectMode == "visualmode" ? this._hiddenInput.val() : this.element.val();
                        this._changeEvtTrigger(currValue);
                        if (this.model.showResetIcon) this._showReset();
                        break;
                    case "showPopupButton": this._setDropdown(options[option]); break;
                    case "enableRTL": this._RightToLeft(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "readOnly": this._checkReadOnly(options[option]); break;
                    case "delimiterChar": var delchar = this.model.delimiterChar;
                        options[option] = this._validateDelimiter(options[option]);
                        this.model.delimiterChar = options[option];
                        this.element.val(this.value().replace(new RegExp(delchar, 'g'), this.model.delimiterChar));
                        this.value(this.element.val());
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = options[option];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "locale":
                        if (ej.Autocomplete.Locale[options[option]]) {
                            this.model.locale = options[option];
                            this._setCulture();
                            this._setWatermark();
                        } else options[option] = this.model.locale;
                        break;
                    case "filterType":
                        var arr = [];
                        for (var key in ej.filterType)
                            if (ej.filterType.hasOwnProperty(key))
                                arr.push(ej.filterType[key]);
                        if (arr.indexOf(options[option]) > -1)
                            this.model.filterType = options[option];
                        else
                            options[option] = this.model.filterType;
                        break;
                    case "multiSelectMode":
                        this.model.multiSelectMode = options[option];
                         var delimiter =this._delimiterChar();
                         if (this.model.multiSelectMode != "none") {
                             var key = this._selectValueByKey(), value = this.value();
                             if (value) {
                                 value = value.substr(value.length - delimiter.length) == delimiter ? value : value + delimiter
                                 this.value(value);
								 if(this.model.multiSelectMode == "visualmode") this.value(this._removeDuplicateValue(this.value()))
                             }
                             if (key) {
                             this._selectValueByKey(key.substr(key.length - delimiter.length) == delimiter ? key : key + delimiter);
							 if(this.model.multiSelectMode == "visualmode") this._selectValueByKey(this._removeDuplicateValue(this._selectValueByKey()));
							 }
						 }
                         else {

                         }
                        if (options[option] == "visualmode") {
                            if (this.model.validationRules != null)
                                this.element.rules('remove');
							if (this.element.val() != "" && this._isWatermark ) this.element.removeAttr("placeholder");
                            this._renderBoxModel();
                        }
                        else if (this.element.hasClass("e-visual-mode")) 
                            this._destroyBoxModel();
                        this._setValue(this.value());
                        this._setValidation();
                        if (ej.isNullOrUndefined(this.element.attr("placeholder")) && this._isWatermark)
                            this._setWatermark();
                        break;
                    case "enabled": this._disabled(!options[option]); break;
                    case "visible":
                        this.setVisible(options[option]);
                        break;
                    case "height": this._changeHeight(options[option]); break;
                    case "width": this._changeWidth(options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "itemsCount ": if (options[option] <= 0 || isNaN(options[option])) options[option] = 0; break;
                    case "popupHeight": this.suggestionList.css({ "max-height": isNaN(options[option]) ? options[option]: options[option] + "px" }); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "selectValueByKey":
                        deli = this._delimiterChar();
                        key = ej.util.getVal(options[option]);
                        this.selectValueByKey(key);
                        keyValue =   (this.model.multiSelectMode != "none") ? this._selectValueByKey() + options[option]:options[option];
                        keyValue = keyValue.split(deli).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []);
                        keyValue=keyValue.join(deli);
                        options[option] = keyValue.substr(keyValue.length - deli.length) == deli ? keyValue  : keyValue+ deli;
                        break
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "emptyResultText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["emptyResultText"] = this.model.emptyResultText = options[option];
                        this._setCulture(); break;
                    case "addNewText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["addNewText"] = this.model.emptyResultText = options[option];
                        this._setCulture(); break;
					case "multiColumnSettings":
						if(!ej.isNullOrUndefined(options[option].enable)) this.model.multiColumnSettings.enable = options[option].enable;
						if(!ej.isNullOrUndefined(options[option].showHeader)) this.model.multiColumnSettings.showHeader = options[option].showHeader;
						if(!ej.isNullOrUndefined(options[option].stringFormat)) this.model.multiColumnSettings.stringFormat = options[option].stringFormat;
						if(!ej.isNullOrUndefined(options[option].columns)) this.model.multiColumnSettings.columns = options[option].columns;
						this.suggestionList.remove();
						this._renderSuggestionList();
						break; 
                    case "showResetIcon": this.model.showResetIcon = options[option];
                        if (options[option] && !ej.isNullOrUndefined(this.value()) && this.value()!="") this._showReset();
						else this._removeReset();
						break;
                }
				this._hideResult();
            }
        },

        _destroy: function () {
            this.element.width("").removeAttr("role aria-label aria-expanded aria-haspopup aria-autocomplete autocomplete placeholder aria-owns aria-disabled disabled");
            this.element.insertAfter(this.wrapper);
            if (this.model.multiSelectMode == "visualmode")
                this.element.removeClass("e-visual-mode").attr("name", this._hiddenInput.attr("name"));
            if (!this.model.enabled) this.element.removeClass('e-disable');
            this.wrapper.remove();
            this.element.removeClass("e-input").val("");
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this._hideResult();
            this.suggestionList.remove();
        },

        _initialize: function () {
            this.value(this.value() === "" ? this.element[0].value : this.value());
            this.element.attr("role", "combobox").attr("aria-label", "Autocomplete textbox").attr("aria-expanded", false).attr("tabindex", 0).attr("aria-autocomplete", "list");
            if (/Edge\/12./i.test(navigator.userAgent)) this.element.addClass('edge-browser');
            this.target = this.element[0];
            this.dropdownbutton = null;
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this.showSuggestionBox = false;
            this.noresult = true;
            this._queryString = null;
            this.suggLen = 0;
            this._selectedItems = [];
            this._modelValue = "";
            this._activeItem = 0;
			this._originalval = [];
            this.ctrlKeyPressed = false;
            this._isFocused = false;
            this._isOpened = false;
            this._typed = false;
            this._cancelEvent = false;
            this._isWatermark = this._checkWatermarkSupport();
			this._selectedObj = [];
        },

        _render: function () {
            this._renderWrapper();
            this._addAttr(this.model.htmlAttributes);
            this._setDimentions();
            this._renderDropdown();
            this._checkProperties();
            this._isWatermark ? this._setWatermark() : this._setWatermarkTxt();
            this._renderSuggestionList();
            this._RightToLeft(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
            this.setVisible(this.model.visible);
            this._setListPosition();
        },
        _renderWrapper: function () {
            this.element.addClass("e-input").attr("autocomplete", "off");
            this.wrapper = ej.buildTag("span.e-atc e-widget " + this.model.cssClass + "#" + this.target.id + "_wrapper").insertAfter(this.element);
            if (document.activeElement == this.element[0]) var focus = true;
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
            if (!this._isWatermark) {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this.model.watermarkText);
                this._hiddenSpan.css("display", "none");
                var proxy = this;
                this._hiddenSpan.click(function (event) {
                    if (!this._isFocused) proxy.element.focus();
                });
            }
            if (focus) this.element.focus();
        },

        _renderDropdown: function () {
            if (this.model.showPopupButton) {
                var span = ej.buildTag("span.e-icon e-search").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                this.dropdownbutton = ej.buildTag("span.e-select#" + this.target.id + "_dropdown").attr((this._isIE8) ? { 'unselectable': 'on' } : {}).append(span);
                this.container.append(this.dropdownbutton).addClass("e-padding");
                if (!this.model.enabled)this.dropdownbutton.addClass("e-disable").attr({ "aria-disabled": true });
                this.dropdownbutton.on("mousedown", $.proxy(this._OnDropdownClick, this));
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "required") proxy.element.attr(key, value);
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "name") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._disabled(true);
                else if (key == "readOnly" && value === true) proxy._checkReadOnly(true);
                else proxy.wrapper.attr(key, value);
            });
        },
        _setDimentions: function () {
            if (this.model.height)
                this.wrapper.height(this.model.height);
            if (this.model.width)
                this.wrapper.width(this.model.width);
        },

        _renderBoxModel: function () {
            this._ulBox = ej.buildTag("ul.e-ul e-boxes");
            var disableClass = this.model.enabled ? "" : "e-disable";
            this._ulBox.addClass(disableClass);
            this._hiddenInput = ej.buildTag("input#" + this.target.id + "_hidden", "", {}, { type: "hidden" }).insertBefore(this.element);
            this._hiddenInput.attr("name", this.element.attr("name"));
            this.element.val("").removeAttr("name").addClass("e-visual-mode");
            if (!this._isWatermark) this.element.width(1);
            this.container.prepend(this._hiddenInput, this._ulBox);
            if(this.model.height!="")
			  this.wrapper.height(this.model.height);
			else 
				this.wrapper.height("auto");
            this._on(this.container, "mousedown", function (e) {
                if (!this.model.enabled) return false;
                var $target = $(e.target);
                if (!$target.is(this.element)) {
                    e.preventDefault();
                    if (!this._isFocused) this.element.focus();
                    if ($target.hasClass("e-options")) {
                        if (!e.ctrlKey && $target.siblings().hasClass("e-active")) this._removeActive();
                        if ($target.hasClass("e-active")) $target.removeClass("e-active");
                        else $target.addClass("e-active");
                    }
                    else this._moveCaretToEnd(this.element[0]);
                }
                if (!e.ctrlKey && ($target.hasClass("e-boxes") || $target.hasClass("e-input"))) this._removeActive();
            });
        },
        _destroyBoxModel: function () {
            this.container.prepend(this.element);
            this.element.attr({ name: this._hiddenInput.attr("name") }).removeAttr("style").removeClass("e-visual-mode");
            this.wrapper.height(this.model.height);
            this._hiddenInput.remove();
			this._hiddenInput = null;
            this._ulBox.remove();
            this._off(this.container, "mousedown");
        },
        _deleteLastBox: function () {
            var items = this._ulBox.children();
            var item = items.last(), flag = item.hasClass("e-active");
            this._removeActive();
            flag ? this._deleteBox(item) : item.addClass("e-active");
        },
        _deleteBox: function (items) {
            for (var i = 0, length = items.length; i < length; i++) {
                var boxes = this._ulBox.children();
                var index = boxes.index(items[i]);
                this._selectedItems.splice(index, 1);

                var deli = this.model.delimiterChar;
                var values = this._hiddenInput.val().split(deli);
                values.splice(index, 1);
                this._hiddenInput.val(values.join(deli));
                this._selectValueByKey(values.join(deli));

                var val = this._modelValue.split(deli);
                val.splice(index, 1);
                this._modelValue = val.join(deli);
                $(items[i]).remove();
            }
            if (this.showSuggestionBox) this._refreshPopup();
            this._valueChange();
            if (this._hiddenInput.val() == "")
                this._setWatermark();
        },
        _removeActive: function () {
            this._ulBox.children("li.e-active").removeClass("e-active");
        },
        _adjustWidth: function () {
            var tempSpan = ej.buildTag("span", this.element.val()), wid, minWidth;
            this.container.append(tempSpan);
            minWidth = 30;  //  some additional width for textbox in visualmode
            wid = tempSpan.width() + minWidth;
            if (this.element.width() != wid)
                this.element.width(wid);
            if (this._hiddenInput.val() == "")
                this._setWatermark();
            tempSpan.remove();
        },

        _checkProperties: function () {
            this._checkReadOnly(this.model.readOnly);
            this.model.delimiterChar = this._validateDelimiter(this.model.delimiterChar);
            if (!this.model.enabled) {
                this.model.enabled = true;
                this._disabled(true);
            }
            else if (this.model.enabled && $(this.element).hasClass("e-disable")) {
                this.model.enabled = false;
                this._disabled(false);
            }
            this._checkNameAttr();
            if (this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            if (this._selectValueByKey() != null && this.value() == "") {
                var key = this._selectValueByKey().toString();
                if (this.model.multiSelectMode != "none") {
                    key = key.substr(key.length - this.model.delimiterChar.length) == this.model.delimiterChar ? key : key + this.model.delimiterChar;
                    ((this.model.multiSelectMode == "visualmode") ? this._selectValueByKey(null) : this._selectValueByKey(key));
                }
                this.selectValueByKey(key);
				if (this.model.showResetIcon) this._showReset();
            }
            else {
                var value = this.value();
                if (this.model.multiSelectMode != "none" && (!ej.isNullOrUndefined(value) && value !="")) {
                    value = value.substr(value.length - this.model.delimiterChar.length) == this.model.delimiterChar ? value : value + this.model.delimiterChar;
                }
                this.value(this._setValue(value));
				if (this.model.showResetIcon && this.value() != "") this._showReset();
            }
        },

        _checkNameAttr: function () {			
           this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
           this.element.attr("name", this.model.name);
        },

        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        _destroyDropdown: function () {
            this.dropdownbutton.off("mousedown", $.proxy(this._OnDropdownClick, this));
            this.dropdownbutton.remove();
            this.dropdownbutton = null;
            this.container.removeClass("e-padding");
        },

        _validateDelimiter: function (deli) {
           if ($.trim(deli).length == deli.length || deli.length != null) {
                var RegEx = /^[a-zA-Z0-9]+$/;
                if (!RegEx.test(deli)) return deli;
            }
            return ",";
        },

        _checkWatermarkSupport: function () {
            return 'placeholder' in document.createElement('input');
        },
        _setWatermark: function () {
            if ((this.model.watermarkText && (this.value() == ""|| ej.isNullOrUndefined(this.value()))) || (this.model.multiSelectMode != "visualmode"))
                this.element.attr("placeholder", this.model.watermarkText).width("");
        },
        _setWatermarkTxt: function () {
            if (this.model.watermarkText != null && $.trim(this.element.val()) == "" && (this.model.multiSelectMode != "visualmode" || $.trim(this._hiddenInput.val()) == "")) {
                var watermark = (this.model.watermarkText != null) ? this.model.watermarkText : this._localizedLabels.watermarkText;
                this._hiddenSpan.css("display", "block").text(watermark);
            }
        },

        _renderSuggestionList: function () {
            var oldWrapper = $("#" + this.element[0].id + "_suggestion").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.suggestionList = ej.buildTag("div.e-atc-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.target.id + "_suggestion", "", { "display": "none" }).attr("role", "listbox");
            this.element.attr("aria-owns", this.target.id + "_suggestion");
            this.popup = this.suggestionList;
            var scrollerDiv = ej.buildTag("div");
			if(this.model.multiColumnSettings.enable) {
				this._tableColumn = ej.buildTag("table","",{},{ "role": "listbox" ,"border-collapse":"separate" , "border" : 0 , "cellspacing": 0 , "cellpadding" : 0,"class" : "e-atc-tableContent" });
				this._listEventBind(this._tableColumn,"tr");
                this._headerColGroup = document.createElement("colgroup");				
				if(this.model.multiColumnSettings.showHeader) {
				this._tableHeaderDiv = ej.buildTag("div",{},{},{"class":"e-atc-tableHeader "+((this.model.enableRTL)? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll")});
				var headerDiv = ej.buildTag("div",{},{},{"class":"e-atc-tableHeaderContent e-atc-tableHeaderBorder"}); 
				var tr = document.createElement("tr");
				this._tableHeader = ej.buildTag("table" , "" ,{},{"cellspacing": "0.25px"});
									
                for (var z = 0, length = this.model.multiColumnSettings.columns.length; z < length; z++) {
					$(tr).append( ej.buildTag("th" , (this.model.multiColumnSettings.columns[z].headerText ? this.model.multiColumnSettings.columns[z].headerText : "column"+z) , {"text-align":(this.model.multiColumnSettings.columns[z].headerTextAlign ? this.model.multiColumnSettings.columns[z].headerTextAlign:"left")}, {"class":((z == this.model.multiColumnSettings.columns.length - 1) ? "" :(this.model.enableRTL ? "e-atc-thleft" : "e-atc-thright"))}) );
				    $(this._headerColGroup).append(document.createElement("col"));
				}
				$(this._tableHeaderDiv).append($(headerDiv).append($(this._tableHeader).append(tr).append(this._headerColGroup)));
				this.suggestionList.append(this._tableHeaderDiv);
				}
				else {
                    for (var z = 0, length = this.model.multiColumnSettings.columns.length; z < length; z++)
                        $(this._headerColGroup).append(document.createElement("col"));
					this._tableColumn.append(this._headerColGroup);
				}
				var scrollerParent = ej.buildTag("div");
				scrollerParent.append(this._tableColumn);
				scrollerDiv.append(scrollerParent);
			}
			else {
                this.ul = ej.buildTag("ul.e-ul").attr("role", "listbox");
				this._listEventBind(this.ul,"li:not('.e-category')");
				scrollerDiv.append(this.ul);
			}
            this.suggestionList.append(scrollerDiv);
            $('body').append(this.suggestionList);
            this._setListWidth();
            this._setListHeight();
			if(this.model.multiColumnSettings.enable) {
				scrollerDiv.ejScroller({ height: 0, width: 0, scrollerSize: 20 });
            this.scrollerObj = scrollerDiv.ejScroller("instance");
			}
			else {
            this.suggestionList.ejScroller({ height: 0, width: 0, scrollerSize: 20 });
            this.scrollerObj = this.suggestionList.ejScroller("instance");
				}
        },

		_listEventBind: function (element,target) {
			element.on({
					mouseenter: $.proxy(this._OnMouseEnter, this),
					mouseleave: $.proxy(this._OnMouseLeave, this),
					click: $.proxy(this._OnMouseClick, this)
				}, target);
		},
		
        _checkEmptyList: function () {
            if (this.model.multiSelectMode == "visualmode") this._removeRepeated();
            if (this.suggestionListItems.length == 0) {
                this.suggestionListItems.push(this.model.emptyResultText);
                this.noresult = true;
            }
            else this.noresult = false;
        },
        _showSuggestionList: function (e) {
            this.suggestionListItems = this.model.enableDistinct ? ej.dataUtil.distinct(this.suggestionListItems, (typeof this.suggestionListItems[0] != "object" ? "" : (this.model.fields && this.model.fields.text) ? this.model.fields["text"] : "text"), true) : this.suggestionListItems;
            if(this.model.itemsCount > 0) this.suggestionListItems = ej.DataManager(this.suggestionListItems).executeLocal(ej.Query().take(this.model.itemsCount));
            this._checkEmptyList();
            this._addNewTemplate = null;
            if (this.noresult && this.model.multiSelectMode == "visualmode" && this.model.allowAddNew && this.element.val() != "" && !this._repeatRemove ) {
                this.noresult = false;
                this.suggestionListItems.pop();
                this._addNewTemplate = "   (" + this.model.addNewText + ")";
                this.suggestionListItems.push(this.element.val() + this._addNewTemplate);
                this._checkEmptyList();
            }

            if (!this.noresult || this.model.showEmptyResultText)
                this._generateSuggestionList(e);
        },

        _generateSuggestionList: function (e) {
            var list = this.suggestionListItems, i, suggList = [];
            (!this.model.multiColumnSettings.enable) ? this.ul.empty() : this._tableColumn.empty() && this.model.multiColumnSettings.showHeader && this._tableHeaderDiv.css("display", "");
            var _proxy = this;
            var fragmentParent = document.createDocumentFragment();
            if (typeof list[0] != "object") {
                if (_proxy.model.multiColumnSettings.enable) {
					var tbodyEle = ej.buildTag("tbody"); 
                    var trColumnEle = ej.buildTag("tr").attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {});
                    var tdEle = ej.buildTag("td", {}, {}, { "role": "option" });
                    for (var i = 0, listLength = list.length; listLength > i; i++) {
                        var _txt = (_proxy.model.highlightSearch && !_proxy.noresult) ? _proxy._highlightSuggestion(list[i]) : list[i];
                        var trColumn = trColumnEle.clone();
                        var td = tdEle.clone()
                         $(td).attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {}).attr((list[i] != (list.length - 1)) ? { "class": "e-atc-tdbottom" } : {}).html(_txt);
                        trColumn[0].appendChild(td[0]);
						tbodyEle[0].appendChild(trColumn[0]);
                        fragmentParent.appendChild(tbodyEle[0]);
                        _proxy.model.showEmptyResultText && _proxy.model.emptyResultText == _txt && _proxy.model.multiColumnSettings.showHeader && _proxy._tableHeaderDiv.css("display", "none") && $(td).removeClass("e-atc-tdbottom");
                        
                        if ((_proxy._addNewTemplate) && !ej.isNullOrUndefined(_proxy._tableHeaderDiv))
                            _proxy._tableHeaderDiv.css("display", "none");
                    }
                    _proxy._tableColumn[0].appendChild(fragmentParent);
                }
                else {
                    var liEle = ej.buildTag("li", {}, {}, { "role": "option" }).attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {})
                    for (var i = 0, listLength = list.length; listLength > i; i++) {
                        var _txt = (_proxy.model.highlightSearch && !_proxy.noresult) ? _proxy._highlightSuggestion(list[i]) : list[i];
                        var li = liEle.clone();
                        li[0].innerHTML=_txt;
                        fragmentParent.appendChild(li[0])
                    }
                    _proxy.ul[0].appendChild(fragmentParent);
                }
                this._currList = list;
                this._mapper = { txt: null, key: null };
            }
            else {
                var mapper = this.model.fields, mapFld = { _key: null, _text: null, _attr: null };
                mapFld._key = (mapper && mapper.key) ? mapper["key"] : "key";
                mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
                mapFld._attr = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
                this._mapper = { txt: mapFld._text, key: mapFld._key }, this._currList = [];
                if (this.model.fields.groupBy) {
                    var mapCateg = (mapper && mapper.groupBy) ? mapper["groupBy"] : "groupBy", groupedList, _query;
                    _query = ej.Query().group(mapCateg);
                    this._addSortingQuery(_query, "key");
                    groupedList = ej.DataManager(list).executeLocal(_query);
                    this._swapUnCategorized(groupedList);
                    groupedList.forEach(function (each, i) {
                        if (each.key)
                            if (_proxy.model.multiColumnSettings.enable) {
                                var trColumn = ej.buildTag("tr.e-category").attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {});
                                trColumn.append(ej.buildTag("td", each.key).attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {}).attr((i != (list.length - 1)) ? { "class": "e-atc-tdbottom" } : {}));
                                _proxy._tableColumn.append(trColumn);
                            }
                            else _proxy.ul.append(ej.buildTag("li.e-category", each.key).attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {}));
                        _proxy._generateLi(each.items, mapFld);
                    });
                }
                else this._generateLi(list, mapFld);
            }
            if (this._getLiTags().length > 0) {
				this._showResult(e);
			}

        },

        _swapUnCategorized: function (list) {
            var length = list.length;
            for (var i = 0; i < length; i++) {
                if (!list[i].key) {
                    for (var j = i; j > 0; j--) {
                        list[j] = list[j - 1];
                    }
                    list[j] = list[i];
                    return false;
                }
            }
        },

        _generateLi: function (list, mapFld) {
            var _proxy = this;
            var fragmentParent = document.createDocumentFragment();
            var fragment = document.createDocumentFragment();
            if (_proxy.model.multiColumnSettings.enable) {
                var multiColumnLength = _proxy.model.multiColumnSettings.columns.length;
                this._tableColumn.append(ej.buildTag("tbody"));
                var trEle = ej.buildTag("tr");
                var tdEle = ej.buildTag("td");
                for (var j = 0, listLength = list.length; listLength > j; j++) {
                    var _text = list[j][mapFld._text];
                    var _key = list[j][mapFld._key];
                    if (!ej.isNullOrUndefined(_text) || _proxy.model.multiColumnSettings.enable) {
                        var fieldAttr = _proxy._getField(list[j]);
                        var tr = trEle.clone();
                        tr[0].className = (j % 2) ? "e-atc-trbgcolor" : "";
                        for (var z = 0; z < multiColumnLength; z++) {
                            var td = tdEle.clone();
                            td[0].innerHTML = (_proxy.model.highlightSearch && $.inArray(z.toString(), _proxy._columnIndex) > -1) ? _proxy._highlightSuggestion(_proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field).toString()) : _proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field);
                            td[0].className = (((j != (list.length - 1)) ? "e-atc-tdbottom " : "") + ((z != (_proxy.model.multiColumnSettings.columns.length - 1)) ? ((_proxy.model.enableRTL) ? "e-atc-tdleft " : "e-atc-tdright ") : ""))+(_proxy.model.multiColumnSettings.columns[z].cssClass ?_proxy.model.multiColumnSettings.columns[z].cssClass:"" );
                            td[0].style.textAlign = (_proxy.model.multiColumnSettings.columns[z].textAlign ? _proxy.model.multiColumnSettings.columns[z].textAlign:"left");
							fragment.appendChild(td[0])
                        }
                        tr[0].appendChild(fragment);
                        if (_key)
                            tr.attr("id", _key);
                        _proxy._setAttributes(_proxy._getField(list[j], mapFld._attr), tr[0]);
                        fragmentParent.appendChild(tr[0]);
                        _proxy._currList = _proxy._currList.concat([list[j]]);
                    }
                }
                $(_proxy._tableColumn).find("tbody")[0].appendChild(fragmentParent);
            }
            else {
                for (var j = 0, listLength = list.length; listLength > j; j++) {
                    var _text = list[j][mapFld._text];
                    var _key = list[j][mapFld._key];
                    if (!ej.isNullOrUndefined(_text)) {
                        if (_proxy.model.highlightSearch) _text = _proxy._highlightSuggestion(_text);
                        if (_proxy.model.template) _text = _proxy._getTemplatedString(list[j], mapFld._text, _text);
                        var li = document.createElement("li");
                        li.innerHTML += _text;
                        if (_key)
                             li.setAttribute("id", _key);
                        _proxy._setAttributes(_proxy._getField(list[j], mapFld._attr), li);
                        fragmentParent.appendChild(li);
                        _proxy._currList = _proxy._currList.concat([list[j]]);
                    }
                }
                _proxy.ul[0].appendChild(fragmentParent);
            }

        },

        _getLiTags: function () {
            return (!this.model.multiColumnSettings.enable) ? this.ul.children("li:not('.e-category')") :this._tableColumn.find("tbody tr:not('.e-category')") ;
        },

        _getTemplatedString: function (list, searchLabl, searchTxt) {
            var str = this.model.template, start = str.indexOf("${"), end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                var replace = this._getField(list, field);
                // if highlightSearch is enabled, it replaces the highlighted search text
                if (searchLabl == field) replace = searchTxt;
                if (!replace) replace = "";
                str = str.split(content).join(replace);
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },

        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },

        _setAttributes: function (data, element) {
            if (data) {
                if (typeof data == "string")
                    data = $.parseJSON(data);
                for (var key in data)
                    element.setAttribute(key, data[key]);
            }
        },

        _setListWidth: function () {
            var width = this.model.popupWidth;
            if (width && width != "auto") this.suggestionList.css({ "width": width });
            else this.suggestionList.css({ "width": this.wrapper.width() });
        },

        _setListHeight: function () {
            this.suggestionList.css({ "max-height": this.model.popupHeight });
        },

        _refreshPopup: function () {
            if (this.model.popupWidth == "auto" && Math.floor(this.wrapper.outerWidth()) != Math.floor(this.suggestionList.outerWidth())) {
                this.suggestionList.css({ "width": this.wrapper.width() });
                this._refreshScroller();
            }
            this._setListPosition();
        },

        _showResult: function (e) {
            this._refreshScroller();
            this._refreshPopup();
            if (this._isOpened)
                $(document).on("mousedown", $.proxy(this._OnDocumentClick, this));
            else {
                this.suggestionList.css("display", "none");
                var tis = this;
                clearTimeout(this._typing);
                this._typing = setTimeout(function () {
                    tis.suggestionList[(tis.model.animateType == "slide" ? "slideDown" : "fadeIn")]((tis.model.animateType == "none" ? 0 : 300), function () {
                        $(document).on("mousedown", $.proxy(tis._OnDocumentClick, tis));
                    });
                }, this.model.delaySuggestionTimeout);
                var args = (e != undefined) ? { event: e, isInteraction: true } : { isInteraction: false };
                this._trigger("open", args);
                this.wrapper.addClass("e-active");
            }

            this._isOpened = true;
            this.showSuggestionBox = true;
            var _suggestionListItems = this._getLiTags();
            this._listSize = _suggestionListItems.length;


            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            var scrObj = ej.getScrollableParents(this.wrapper);
            if (scrObj[0] != window)
                this._on(scrObj, "scroll", this._hideResult);
        },

        _hideResult: function (e) {
            if (this.showSuggestionBox) {
                this.showSuggestionBox = false;
                this._activeItem = 0;
                clearTimeout(this._hiding);
                this.element.attr("aria-expanded", false);
                var proxy = this;
                if (this._isOpened) {
                    this.suggestionList.css("display", "none");
                    var args = (e != undefined) ? { event: e, isInteraction: true } : { isInteraction: false };
                    this._trigger("close", args);
                }
                else {
                    this._hiding = setTimeout(function () {
                        if( proxy.model ) proxy.suggestionList[(proxy.model.animateType == "slide" ? "slideUp" : "fadeOut")]((proxy.model.animateType == "none" ? 0 : 100));
                         proxy._activeItem = 0;
                    }, this.model.delaySuggestionTimeout);
                }
                $(document).off("mousedown", $.proxy(this._OnDocumentClick, this));
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
                this.wrapper.removeClass("e-active");
            }
        },

        _refreshScroller: function () {
            this.suggestionList.css("height", "auto");
            this.suggestionList.find(".e-content , .e-scroller").removeAttr("style");
            
			if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) {
			$(this._tableColumn).attr("width" ,"auto");
			$(this._tableHeader).attr("width" ,"auto");
			}
            this.suggestionList.css("display", "block");
			if(this.model.multiColumnSettings.enable) {
				this.scrollerObj.option("height","auto");
				this._columnBorderAlign();
			}
            var _suggestHeight = this.suggestionList.height() > (parseInt($.isNumeric(this.model.popupHeight) ? this.model.popupHeight : this.model.popupHeight.replace("px", "")) - 4);
            if ( _suggestHeight || (this.model.multiColumnSettings.enable && (( this.suggestionList.height() <= this._tableColumn.height() )|| ( this.suggestionList.width() <= this._tableColumn.width() || (this.model.multiColumnSettings.showHeader && this.suggestionList.width() <= this._tableHeader.width()) )))){
                if( _suggestHeight ) this.scrollerObj.model.height = (this.model.multiColumnSettings.showHeader && this._tableHeader) ? parseInt(this.suggestionList.height()) - parseInt(this._tableHeader.height()) : this.suggestionList.height();
                if(!this.model.multiColumnSettings.enable && this.suggestionList.width() < this.suggestionList.find(".e-ul").width())  this.suggestionList.find(".e-ul").width(this.suggestionList.find(".e-ul").width());
				this.scrollerObj.model.width = this.suggestionList.width();
                this.scrollerObj.refresh();
                this.scrollerObj.option({"enableRTL" : this.model.enableRTL , "scrollTop": 0 , "scrollLeft" : 0 });
				if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) this._addThBorder();
                this.suggestionList.addClass("e-scroller")
				if(!this.scrollerObj._vScroll && this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) this._removeThBorder();
            }
            else {
                this.suggestionList.removeClass("e-scroller");
				this.scrollerObj.refresh();
				if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) this._removeThBorder();
			}
            this.suggestionList.css("height", "auto");
            if (this._isIE8)
                this.suggestionList.find('.e-vscroll div, .e-hscroll div').attr("unselectable", "on");
			if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) {
		    this.suggestionList.find(".e-content").scroll(ej.proxy(function (e) {
                    this._tableHeader.parent(".e-atc-tableHeaderContent").scrollLeft($(e.currentTarget).scrollLeft());
            }, this));
			if(this.suggestionList.find(".e-content").length > 0) this._tableHeader.parent(".e-atc-tableHeaderContent").scrollLeft(this.model.enableRTL ?  this.suggestionList.find(".e-content")[0].scrollWidth - this.suggestionList.find(".e-content")[0].clientWidth : 0);
			}
        },
		
		_columnBorderAlign : function (){
			if (this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader && this._tableHeaderDiv.css("display") != "none") {
				this._tableWid = (this._tableHeader.outerWidth() > this._tableColumn.outerWidth() ) ? this._tableHeader.outerWidth() : this._tableColumn.outerWidth(); 
				this._tableColumn.find("colgroup").remove();
				$(this._headerColGroup.children).removeAttr("style");
                for (var z = 0, length = this._headerColGroup.children.length; z < length; z++) {
					$(this._headerColGroup.children[z]).css({"width": ( parseInt($(this._tableColumn).find("tr:first td").eq(z).outerWidth()) > parseInt(this._tableHeader.find("tr:first th").eq(z).outerWidth() ) ? $(this._tableColumn).find("tr:first td").eq(z).outerWidth() : this._tableHeader.find("tr:first th").eq(z).outerWidth()) });
				}
				this._tableColumn.append($(this._headerColGroup).clone());
				var wid = (this._tableWid > this.suggestionList.width()) ? this._tableWid : "100%" ;
				$(this._tableColumn).attr("width" , wid );
				$( this._tableHeader ).attr("width" , wid);
			}
			else if (this.model.multiColumnSettings.enable && !this.model.multiColumnSettings.showHeader ) {
				$(this._tableColumn).attr("width" , "auto" );
				this._tableWid = this._tableColumn.outerWidth(); 
				$(this._headerColGroup.children).removeAttr("style");
				var wid = (this._tableWid > this.suggestionList.width()) ? this._tableWid : "100%" ;
				if(wid != "100%") {
                    for (var z = 0, length = this._headerColGroup.children.length; z < length; z++) {
						$(this._headerColGroup.children[z]).css({"width": $(this._tableColumn).find("tr:first td").eq(z).outerWidth() });
					}
					this._tableColumn.append(this._headerColGroup);
				}
				$(this._tableColumn).attr("width" , wid );
			}	
			else $(this._tableColumn).attr("width","100%");
		},

		_removeThBorder: function(){
			this._tableHeader.parents(".e-atc-tableHeader").removeClass((this.model.enableRTL)? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll");
			this._tableHeader.parent(".e-atc-tableHeaderContent").removeClass("e-atc-tableHeaderBorder");
		},
		
		_addThBorder: function(){
			this._tableHeader.parents(".e-atc-tableHeader").addClass((this.model.enableRTL)? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll").removeClass((this.model.enableRTL)? "e-atc-tableHeaderScroll" : "e-atc-tableHeaderRTL");
			this._tableHeader.parent(".e-atc-tableHeaderContent").addClass("e-atc-tableHeaderBorder");
		},
        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.suggestionList.outerHeight(),
            popupWidth = this.suggestionList.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.suggestionList.outerWidth() - elementObj.outerWidth();
            this.suggestionList.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.suggestionList);
        },

        _targetFocus: function (e) {
            var minWidth = 30;  //  minimum width for textbox in visualmode
            if (this.model.multiSelectMode == "visualmode")
                this._setWatermarkWidth(minWidth);
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.wrapper.addClass("e-focus");
			this._focusValue = this.model.value;
            this._isFocused = true;
            this._trigger("focusIn", { event: e, isInteraction: true, value: this.value() });
        },
        _focusOutAction: function (e) {
			var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val();	
            this._isFocused = false;
            this.wrapper.removeClass("e-focus");
			if (this._focusValue != this.model.value)                                     		
                 this._changeEvtTrigger(currValue, e);
			else
			     return false;
            if (this.model.showPopupButton) this.dropdownbutton.removeClass('e-active');
            !this._isWatermark && this._setWatermarkTxt();
            this._removeSelection();
			if(this.model.multiSelectMode == "visualmode" && this.model.showResetIcon && this.element.val() != "")
				this._removeReset();
            if (this.model.multiSelectMode == "visualmode") {
                this._removeActive();
                this.element.val("");
                this._setWatermarkWidth(1);
                this._preVal = "";
                this._addNewTemplate = null;
            }
            else {
                if (this.model.multiSelectMode == "delimiter") 
                        this._valueChange(e);
                this._updateSelectedItemArray(this.getValue());
            }
		    if(!ej.isNullOrUndefined(this.value()) && this.value()!="")
			{
				var values = this.value().split(this.model.delimiterChar);
				if(this.model.multiSelectMode == "delimiter" || this.model.multiSelectMode == "none" )
				{
					var result = this._removeDuplicateVal(values); 
					this._keyProcess(result);
				}
			}
			if(this.element.val() == "" && (this.value() == "" || this.value() == null))
				this._selectValueByKey(null);
        },
        _targetBlur: function (e) {
            this._focusOutAction(e);
            this._trigger("focusOut", { event: e, isInteraction: true, value: this.value() });
        },
        _setWatermarkWidth: function (width) {
            this.model.watermarkText && this.element.attr('placeholder') ? this.element.width("") : this.element.val("").width(width);
        },
        _checkDeli: function () {
            var val = this.element.val(), deli = this.model.delimiterChar, last = val.substr(val.length - deli.length, val.length);
            if (last == deli) {
                this.element.val(val.substr(0, val.length - deli.length));
                return true;
            }
            else return false;
        },
        _removeSelection: function () {
            if (this.model.enableAutoFill) {
                this.element.attr("aria-autocomplete", "both");
                var selection = this._getCaretSelection();
                if (selection.end - selection.start != 0 && selection.end - selection.start != this.element.val().length)
                    this.target.value = this.target.value.substr(0, selection.start);
            }
        },

        _removeListHover: function () {
            this._getLiTags().removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = $(this._getLiTags()[this._activeItem - 1]);
            activeItem.addClass("e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
            activeItem.focus();
        },

        _calcScrollTop: function () {
            var ulH = (this.model.multiColumnSettings.enable) ? ((this.model.multiColumnSettings.showHeader) ? this._tableColumn.outerHeight() + this._tableHeader.outerHeight()  : this._tableColumn.outerHeight() ): this.ul.outerHeight() , li = (!this.model.multiColumnSettings.enable) ? this.ul.find("li") : this._tableColumn.find("tr"), liH = 0, index, top, i;
            index = (!this.model.multiColumnSettings.enable) ? this.ul.find("li.e-hover").index() : this._tableColumn.find("tr.e-hover").index();
            liH = li.eq(1).outerHeight() * index;
            top = liH - ((((this.model.multiColumnSettings.enable) ? this._tableColumn.parent().outerHeight() : this.suggestionList.outerHeight()) - li.eq(index).outerHeight()) / 2);
            return top;
        },

        getActiveText: function () {
			if (this._activeItem > 0) {
				if(this.model.multiColumnSettings.enable) return this._textFormateString(this._currList[this._activeItem -1 ])
				else if (!ej.isNullOrUndefined(this._mapper) && this._mapper.txt) return this._getField(this._currList[this._activeItem - 1], this._mapper.txt);			
				else  return  this._currList[this._activeItem  - 1];
			}
        },

        _getUniqueKey: function () {
            var key = null;
			if(!ej.isNullOrUndefined(this._mapper))
			{
			    if (this._mapper.key) key = this._getField(this._currList[this._activeItem - 1], this._mapper.key);
			    ej.isNullOrUndefined(key) && (key = null);
			}
            return key;
        },

        _setTextBoxValue: function () {
            if (this._activeItem && !this.noresult) {
                var currentValue, selection, val, text;
                currentValue = this.model.multiColumnSettings.enable ? this._textFormateString(this._currList[this._activeItem -1 ]) : this.getActiveText();
                selection = this._getCaretSelection();
                this.suggLen = selection.start;
                val = this.target.value.substr(0, this.suggLen);
                var _deliIndex = (this.target.value).lastIndexOf(this.model.delimiterChar);
				if(_deliIndex == -1) { var query = $.trim(val.substr(_deliIndex + 1, this.suggLen));}
               else				
				var query = $.trim(val.substr(_deliIndex + ((this.model.delimiterChar).length) ,this.suggLen));			
                if (val && (val.toLowerCase() == currentValue.substr(0, this.suggLen).toLowerCase() || query.toLowerCase() == currentValue.substr(0, this.suggLen -( _deliIndex + ((this.model.delimiterChar).length))).toLowerCase())) {
                    if (this.model.multiSelectMode == "delimiter") 
                        text = val + currentValue.substr(query.length, currentValue.length);            
                    else 
                        text = val + currentValue.substr(val.length, currentValue.length);
                    this.element.val(text);
                    this._autofilSelection();
                    if (this.model.multiSelectMode == "visualmode") {
						this._adjustWidth();
						if(this.model.enableAutoFill) this._refreshPopup();
					}
                    if (this.model.autoFocus && !this.noresult) this._addListHover();
                }
                else {
					if (this.model.multiSelectMode == "delimiter" && currentValue && query) this.element.val(this.element.val().replace(query,currentValue))
					else if (currentValue) this.element.val(currentValue)
					this._removeSelection();
				} 
            }
        },

        _enterTextBoxValue: function (e) {
            if (this._activeItem && !this.noresult && !this.model.readOnly) {
                var currentValue = this.getActiveText(), currItem = this._currList[this._activeItem - 1];
                this._preVal = currentValue + ((this.model.multiSelectMode == "delimiter") ? this.model.delimiterChar : "");
                this._valueToTextBox(currentValue, currItem, false);
                var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val() == "" ? null : this.element.val();
                this._trigger("select", { event: e, isInteraction: true, value: currValue, text: currentValue, key: this._getUniqueKey(), item: currItem });
                this._valueChange(e);
                if (this.model.showResetIcon) this._showReset();
            }
            this._isOpened && this._trigger("close", { event: e, isInteraction: true });
        },

        _createBox: function (value) {
            var span = ej.buildTag("span.e-icon e-close");
            var li = ej.buildTag("li.e-options", value).append(span);

            this._on(span, "click", function (e) {
                if (!this.model.enabled) return false;
                this._deleteBox($(e.target).parent());
            });
            return li;
        },

        _addLoadingClass: function () {
            if (this.model.showLoadingIcon)
                this.element.addClass("e-load");
        },

        _removeLoadingClass: function () {
            this.element.removeClass("e-load");
        },


        _highlightSuggestion: function (suggestion) {
            if ($.trim(this._queryString) != "") {
                var caseSensitive, tempQueryString, RegEx, mch, split, query, str;
                caseSensitive = this.model.caseSensitiveSearch ? "g" : "gi";
                query = $.trim(this._queryString);
                query = /^[a-zA-Z0-9- ]*$/.test(query) ? query : query.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
                tempQueryString = this.model.filterType == "startswith" ? "^" + query : this.model.filterType == "endswith" ? query + "$" : query;
                RegEx = new RegExp(tempQueryString, caseSensitive);
                if (RegEx.test(suggestion)) {
                    mch = suggestion.match(RegEx);
                    //for IE-8 the regEx doesnt returns the empty string.So manually we replace string to return empty string.
                    str = suggestion.replace(RegEx, "~^");
                    split = str.split("~^");
                    suggestion = "";
                    for (var i = 0, splitlength = split.length; splitlength > i; i++)
                        suggestion += mch[i] ? split[i] + "<span class='e-hilight-txt'>" + mch[i] + "</span>" : split[i];
                }
            }
            return suggestion;
        },

        _RightToLeft: function (value) {
            if (value) {
                this.wrapper.addClass("e-rtl");
                this.suggestionList.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                this.suggestionList.removeClass("e-rtl");
            }
			if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) {
					this._tableHeaderDiv.removeClass( value ? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll" );
					this._tableHeader.find("tr :not(th:last)").addClass(value ? "e-atc-thleft" : "e-atc-thright").removeClass(value ? "e-atc-thright" : "e-atc-thleft" );
			}
        },

        _setRoundedCorner: function (value) {
            if (value) {
                this.container.addClass("e-corner");
                this.suggestionList.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                this.suggestionList.removeClass("e-corner");
            }
        },

        _checkReadOnly: function (value) {
            this.model.readOnly = value;
            if (this.model.readOnly) {
                this.element.attr({ "readonly": "readonly", "aria-readonly": true });
                this._off(this.element, "keydown", this._OnKeyDown);
                this._off(this.element, "keyup", this._OnKeyUp);
				this._off(this.element, "paste", this._OnPaste);
				this._off(this.element, "keypress", this._onkeyPress);
            }
            else {
                this.element.removeAttr("readonly aria-readonly");
                this._on(this.element, "keydown", this._OnKeyDown);
                this._on(this.element, "keyup", this._OnKeyUp);
			    this._on(this.element, "paste", this._OnPaste);
				this._on(this.element, "keypress", this._onkeyPress);
            }
        },
		_onkeyPress: function (e) {
			if(e.keyCode == 13) this._PreventDefaultAction(e);
		},
		_OnPaste: function (e) {
			var _proxy = this;
			setTimeout(function () {
				 _proxy._OnKeyUp(e);
				}, 0);
		},
        _OnKeyDown: function (e) {
            if (this.model.filterType != "startswith")
                this.model.enableAutoFill = false;

            switch (e.keyCode) {
                case 37:
                case 35:
                case 36:
                    this._removeSelection();
				case 13:
                case 39:
                    break;
                case 38:
                    if (this.showSuggestionBox && this.suggestionList) {
                        this._removeListHover();
                        if (this._activeItem > 1)
                            this._activeItem -= 1;
                        else
                            this._activeItem = this._listSize;
                        this._navigationHover();
                    }
                    this._PreventDefaultAction(e);
                    break;
                case 40:
                    if (this.showSuggestionBox && this.suggestionList) {
                        this._removeListHover();
                        if (this._activeItem < this._listSize)
                            this._activeItem += 1;
                        else
                            this._activeItem = 1;
                        this._navigationHover();
                    } else {
                        if (e.ctrlKey && this.element.val() == "") {
                            this._showFullList(e);
                        }
                        else if (e.ctrlKey) {
                            this._showSuggestionList(e);
                        }
                    }
                    this._PreventDefaultAction(e);
                    break;
				case 33: /* page up */
				case 34:
				    if (this.showSuggestionBox && this.suggestionList) {
						this._removeListHover();             
                        var suggestionH = (this.model.multiColumnSettings.enable) ? this._tableColumn.parent().height() : this.suggestionList.height();
                        var liH = (this.model.multiColumnSettings.enable) ? this._tableColumn.find("tr").outerHeight() : this.ul.children("li").outerHeight();
                        var activeItem = Math.round(suggestionH / liH) != 0 ? Math.round(suggestionH / liH) : this._listSize;
                        this._activeItem = (e.keyCode == 33) ? this._activeItem - activeItem :  this._activeItem + activeItem
						if( this._activeItem < 1) this._activeItem = 1;
						if(this._activeItem > this._listSize ) this._activeItem = this._listSize;
						this._navigationHover();
					}
                        this._PreventDefaultAction(e);
                        break;
                case 8:
                    if ($.trim(this.element.val()) == "") this._isOpened = false;
                    if (this.model.multiSelectMode == "visualmode" && this.element.val() == "") {
                        this._deleteLastBox();
                    }
                    break;
                case 17:
                    this.ctrlKeyPressed = true;
                    break;
                case 9:
                    if (this.showSuggestionBox) {
                        this._queryString = this.element.val();
                        this._enterTextBoxValue(e);
                        this._hideResult(e);
                        this._isOpened = false;
                        this._PreventDefaultAction(e);
                    }
                    break;
                case 27:
                    this._isOpened = false;
                    var _showSuggestionBox = this.showSuggestionBox;
                    this._hideResult(e);
                    this._PreventDefaultAction(e);
                    if (_showSuggestionBox) this._trigger("close", { event: e, isInteraction: true });
                    break;
            }
            if (this.model.multiSelectMode == "visualmode") {
                if (e.keyCode != 17 && e.keyCode != 8 && e.keyCode != 46) this._removeActive();
                this._adjustWidth();
            }
        },


        _PreventDefaultAction: function (e) {

            e.preventDefault();
            if (!this._cancelEvent) {
                e.stopPropagation();
                e.cancelBubble = true;
                e.returnValue = true;
            }

        },
        _bubbleEvent: function (cancelevent) {

            if (typeof cancelevent == "boolean")
                this._cancelEvent = cancelevent;
            return this._cancelEvent;
        },
        _navigationHover: function () {
			this._addListHover();
            if (this.model.enableAutoFill) {
                this.element.attr("aria-autocomplete", "both");
                this._queryString = this.target.value;
                this._setTextBoxValue();
            }
		},


        _OnKeyUp: function (e) {
            this._keyDownComplete(e);
            if (this.ctrlKeyPressed && e.type != "paste") {
                if (e.keyCode == 17)
                    this.ctrlKeyPressed = false;
                return false;
            }

            if ($.trim(this.element.val()) == "" && e.keyCode == 38 && e.keyCode == 40) {
                this._hideResult(e);
                return false;
            }
            if (!this._checkDelimiter()) return false;
            this._queryString = $.trim(this._queryString);

            switch (e.keyCode) {
				case 34:
				case 33:
                case 38:
                case 40:
                case 37:
                case 39:
                case 20:
                case 16:
                case 17:
                case 18:
                case 35:
                case 36:
                case 144:
                case 9:
                case 27: break;

                case 13:
                    e.preventDefault();
                    this._queryString = this.element.val();
                    this._enterTextBoxValue(e);
                    if (this.model.enableAutoFill) {
                        this.element.attr("aria-autocomplete", "both");
                        this.suggLen = this.element.val().length;
                        this._autofilSelection();
                    }
                    this._isOpened = false;
                    this._hideResult(e);
                    break;

                case 46:
                    if (this.model.multiSelectMode == "visualmode" && this.element.val() == "") {
                        this._deleteBox(this._ulBox.children("li.e-active"));
                        break;
                    }
                case 8:
                    if (this._queryString.length >= this.model.minCharacter) {
                        this._autoFill = false;
                        this._OnTextEnter(e);
                    }
                    else {
                        this.noresult = true;
                        this._hideResult(e);
                        if ($.trim(this.element.val()) == "") 
                            this._isOpened = false;
                    }
                    this._typed = true;
                    break;

                default:
                    if (this._queryString.length >= this.model.minCharacter) {
                        this._autoFill = true;
                        this._OnTextEnter(e);
                    }
                    else this.noresult = true;
                    this._typed = true;
                    break;
            }
        },

        _getFilteredList: function (list, e) {
            clearTimeout(this.timeDelay);
            if (!ej.isNullOrUndefined(list) && typeof list[0] == "object") {
                var bindTo = (this.model.fields.text) ? this.model.fields["text"] : "text";
                if ( this.model.actionFailure && ej.isNullOrUndefined((ej.DataManager(list).executeLocal(ej.Query().select(bindTo))[0])) )
                    this._trigger("actionFailure", { error: this._localizedLabels["actionFailure"] });
            }
            if (!list || !list.length || list.length < 1) {
                this.suggestionListItems = [];
                if (this.model.actionFailure) this._trigger("actionFailure", { error: this._localizedLabels["actionFailure"] });
            }
            else {
                var tempQuery = ej.Query();
                this._addQuery(tempQuery, typeof list[0] == "object");
                this.suggestionListItems = ej.DataManager(list).executeLocal(tempQuery);
                if (this.model.actionSuccess) this._trigger("actionSuccess");
            }
            this._doneRemaining(e);
            if (this.model.actionComplete)
                this._trigger("actionComplete");
        },

        _performSearch: function (e) {
            if (this.model.actionBegin)
                this._trigger("actionBegin");
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (!source.dataSource.offline && !(source.dataSource.json && source.dataSource.json.length > 0)) {
                    window.clearTimeout(this.timer);
                    var proxy = this;
                    this.timer = window.setTimeout(function () {
                        proxy._fetchRemoteDat(source);
                    }, 700);
                }
                else {
					this._getFilteredList(source.dataSource.json, e);
					this._selectedObj.push(source.dataSource.json);
				}
            }
            else this._getFilteredList(source, e);
        },

        _fetchRemoteDat: function (source) {
            var proxy = this, queryPromise, tempQuery = this._getQuery();
            this._addQuery(tempQuery, true);
            queryPromise = source.executeQuery(tempQuery);
            queryPromise.fail(function (e) {
                proxy.suggestionListItems = null;
                proxy._removeLoadingClass();
                proxy._trigger("actionFailure", e);
            }).done(function (e) {
                proxy.suggestionListItems = e.result;
				if(proxy.model.multiSelectMode == "none")
					proxy._selectedObj = e.result;
				else if(proxy.model.multiSelectMode == "delimiter")
					proxy._selectedObj = proxy._selectedObj.concat(e.result);
                proxy._doneRemaining(e);
                proxy._trigger("actionSuccess", e);
            }).always(function (e) {
                proxy._trigger("actionComplete", e);
            });
        },

        _addSortingQuery: function (query, key) {
            if (this.model.allowSorting) {
                var order = (this.model.sortOrder == "descending") ? true : false;
                query.sortBy(key, order);
            }
        },

        _addQuery: function (_query, checkMapper) {
            var bindTo = "";
            var predicate, index;
            if (checkMapper) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper.text) ? mapper["text"] : "text";
            }
			if (this._queryString) {
            if (this.model.multiColumnSettings.enable) {
				this._columnsIndex();
				if (checkMapper) {
				    var bindTo = [];
				    for (var i = 0, length = this._columnIndex.length; i < length; i++) {
				        bindTo.push(this.model.multiColumnSettings.columns[this._columnIndex[i]].field);
				        predicate = this._predicateConvertion(predicate, this.model.multiColumnSettings.columns[this._columnIndex[i]].field, (this.model.multiColumnSettings.columns[this._columnIndex[i]].filterType ? this.model.multiColumnSettings.columns[this._columnIndex[i]].filterType : this.model.filterType), this._queryString, !this.model.caseSensitiveSearch, (this.model.multiColumnSettings.columns[this._columnIndex[i]].type ? this.model.multiColumnSettings.columns[this._columnIndex[i]].type : "string"));
				    }
				    for (var i = 0; i < _query.queries.length; i++) {
				        if (_query.queries[i].fn == "onWhere") {
				            index = _query.queries.slice(i)[0].e;
				        }
				    }
				    if (ej.isNullOrUndefined(index))
				        _query.where(predicate);
				    else
				        _query.where((index).and(predicate));
				}
				else _query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);

            }
            
			else _query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);
			}
            this._addSortingQuery(_query, bindTo);
        },

		_predicateConvertion: function( predicate, field, filterType, value, casing ,type){
			var _query;
			if(type == "number")
				_query = Number(value);
			else if(type == "boolean") {
				if(value == "true" || value == "yes" || value =="1") _query = true;
				else if(value == "false" || value == "no" || value =="0") _query = false;
			}	
			else if(type =="date")
				_query = new Date(value);
			else _query = value;
			if( (type == "number" && isNaN(_query)) ||(type == "boolean" && _query == undefined ) )
				predicate = predicate;
			else 
				predicate = predicate != undefined ? predicate["or"]( field, filterType, _query,casing):ej.Predicate( field, filterType, _query,casing);
			return predicate;
		}, 
		
        _getQuery: function () {
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [], queryManager = ej.Query(), mapper = this.model.fields;
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!ej.isNullOrUndefined(this.model.dataSource.dataSource.url) && !this.model.dataSource.dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = this.model.query.clone();
            return queryManager;
        },

        _OnTextEnter: function (e) {
            var proxy = this;
			if( ej.isDevice() ) {
            clearTimeout(this.timeDelay);
            this.timeDelay = setTimeout(function () {
                proxy._onTextProcess(e);
            }, proxy.model.delaySuggestionTimeout);
			}
			else proxy._onTextProcess(e);
        },
		_onTextProcess: function (e) {
			this._addLoadingClass();
			this.element.attr("aria-expanded", false);
			this._performSearch(e);
			if (this.model.showResetIcon) this._showReset();
		},
        _showReset: function () {
            if (ej.isNullOrUndefined(this.resetSpan)) {
                this.resetSpan = ej.buildTag("span.e-icon e-iclose");
                if (!this.model.showPopupButton) {
                    this.container.append(this.resetSpan).addClass("e-reset");
                }
                else {
                    this.dropdownbutton.before(this.resetSpan);
                    this.container.addClass("e-popup e-reset");
                }
            }
            this._on(this.resetSpan, "mousedown", this._refreshSearch);
        },
		 
		_refreshSearch:function(){
			this.resetSpan = null;
			this.clearText();
			this._refreshPopup();			
		},
		
		_removeReset:function (){
	        this.resetSpan = this.resetSpan && this.resetSpan[0].remove();		
            this._refreshPopup();			  
		  },

        _doneRemaining: function (e) {
            this._showSuggestionList(e);
            this.element.attr({"aria-expanded": true , "aria-haspopup": true});
            if (this.model.enableAutoFill && this._autoFill && !this.noresult || this.model.autoFocus) {
                this.element.attr("aria-autocomplete", "both");
                this._activeItem = 1;
                this._queryString = this.target.value;
            }
            if (this.model.enableAutoFill && this._autoFill && !this.noresult) this._setTextBoxValue();
            if (this.model.autoFocus && !this.noresult) this._addListHover();
            this._removeLoadingClass();
            if (this.noresult && !this.model.showEmptyResultText)
                this._hideResult(e);
        },

        _removeRepeated: function () {
            var results = this.suggestionListItems;
            if (!results || results.length == 0 || this._selectedItems.length == 0 || ( this.suggestionListItems.length == 1 && this.suggestionListItems[0] == (this.element.val() + this._addNewTemplate)))
                return false;
			this._repeatRemove = false;
			for (var i = 0, length = this._selectedItems.length; i < length; i++) {
			    var index;
			    if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
			        var proxy = this, tempindex = 0;
			        results.forEach(function (data) {
			            if (!ej.isNullOrUndefined(data[proxy.model.fields["text"]]) ? (data[proxy.model.fields["text"]] == proxy._selectedItems[i][proxy.model.fields["text"]]) : true &&
                            !ej.isNullOrUndefined(data[proxy.model.fields["key"]]) ? (data[proxy.model.fields["key"]] == proxy._selectedItems[i][proxy.model.fields["key"]]) : true &&
                            !ej.isNullOrUndefined(data[proxy.model.fields["htmlAttributes"]]) ? (data[proxy.model.fields["htmlAttributes"]] == proxy._selectedItems[i][proxy.model.fields["htmlAttributes"]]) : true &&
                            !ej.isNullOrUndefined(data[proxy.model.fields["groupBy"]]) ? (data[proxy.model.fields["groupBy"]] == proxy._selectedItems[i][proxy.model.fields["groupBy"]]) : true)
			                index = tempindex;
			            tempindex++;
			        });
			    }
			    else
                 index = results.indexOf(this._selectedItems[i]);
                if (index != -1) this.suggestionListItems.splice(index, 1);
				if( this.element.val() == this._selectedItems[i] )this._repeatRemove = true;
            }
        },

        _checkDelimiter: function () {
            this._queryString = this.element.val();
            var _deliIndex = (this.model.multiSelectMode != "delimiter") ? -1 : this._queryString.lastIndexOf(this.model.delimiterChar);


            if (_deliIndex == -1) {
                return true;
            }
            else {
                this._queryString = this._queryString.substr(_deliIndex + ((this.model.delimiterChar).length), this._queryString.length);
                return true;
            }
        },

        _autofilSelection: function () {
            var element = this.element[0], totLen = this.element.val().length;

            if (element.setSelectionRange)
                element.setSelectionRange(this.suggLen, totLen);
            else if (element.createTextRange) {

                element = element.createTextRange();
                element.collapse(true);
                element.moveEnd('character', totLen);
                element.moveStart('character', this.suggLen);
                element.select();
            }
        },

        _OnDropdownClick: function (e) {
            if (this.model.enabled && !this.model.readOnly) {
                e.preventDefault();
                this.dropdownbutton.addClass("e-active");
                this._iconEventBind(this.dropdownbutton, "span");
				if ((e.which && e.which == 1) ||(e.button && e.button == 0)) {
                this._addLoadingClass();
                if (this.showSuggestionBox) {
                    this._hideResult(e);
                    this._isOpened = false;
                    this._removeLoadingClass();
                }
                else this._showFullList(e);
            }
		  }
        },

        _iconEventBind: function (element, target) {
            element.on({
                mouseleave: $.proxy(this._OnMouseIconClick, this)
            }, target);
        },

        _OnMouseIconClick: function (e) {
            this.dropdownbutton.removeClass("e-active");
        },

        _showFullList: function (e) {
            if (!this._isFocused)
                this.element.focus();
            this._queryString = null;
            this._autoFill = false;
            this._performSearch(e);
        },

        _OnMouseEnter: function (e) {
            this._getActiveItemIndex(e);
            if (this.model.showPopupButton) this.dropdownbutton.removeClass('e-active');
        },
        _getActiveItemIndex: function (e) {
            var targetEle = e.target;
            if (this.model.multiColumnSettings.enable && e.target.tagName.toLowerCase() != "tr") targetEle = $(e.target).parents("tr");
            else if (e.target.tagName.toLowerCase() != "li") targetEle = $(e.target).parents("li");
            this._getLiTags().removeClass("e-hover");
            $(targetEle).addClass("e-hover");
            this._queryString = this.element.val();
            this._activeItem = this._getLiTags().index($(targetEle)) + 1;
        },

        _OnMouseLeave: function (e) {
            this._getLiTags().removeClass("e-hover");
            if (this.model.showPopupButton) this.dropdownbutton.removeClass('e-active');
            if (this.model.highlightSearch)
                this._getLiTags().find(".e-hilight-txt").removeClass("e-hover");
        },

         _OnMouseClick: function (e) {
             this._getActiveItemIndex(e);
            if (!this.noresult) {
                this._enterTextBoxValue(e);
                this._isOpened = false;
                this._hideResult(e);
            }
        },
        
        _OnDocumentClick: function (e) {
            if (!$(e.target).is(this.suggestionList) && !$(e.target).parents(".e-atc-popup").is(this.suggestionList) &&
                !$(e.target).is(this.element) && !$(e.target).parents(".e-atc").is(this.wrapper)) {
                this._isOpened = false;
                this._hideResult(e);
                this._trigger("close", { event: e, isInteraction: true });
            }
            else if ($(e.target).is(this.suggestionList) || $(e.target).parents(".e-atc-popup").is(this.suggestionList))
                e.preventDefault();
        },

        _OnWindowResize: function (e) {
            this._refreshPopup();
        },

		_keyProcess: function (values) {
		    var map = this._declareVariable(), proxy = this;
		    var delimiterIndex;
		    delimiterIndex = this._delimiterChar();
		    if (!ej.isNullOrUndefined(values)){
                for (var data = 0, length = values.length; data < length; data++) {
                    var _val =values[data];
                    if (ej.DataManager && this.model.dataSource instanceof ej.DataManager)
                        proxy._selectValueByKey(null);
                 else {
                        this._dataQuery =this.model.multiColumnSettings.enable ? ej.Query(): ej.Query().where(map[0], this.model.filterType, _val, false);
                        this._promise = ej.DataManager(this.model.dataSource).executeLocal(this._dataQuery);
                        if (!this.model.multiColumnSettings.enable) {
                            if (this._promise instanceof Array && (this._promise.length == 0))
                                this._selectValueByKey() != null ? this._selectValueByKey() : null;
                            else
                                this._getFieldKey(this._promise[0], map[1], delimiterIndex);
                        }
                        else this._formatStringKey(values, map, delimiterIndex)
                    }
                }
			}
		},

		_formatStringKey: function (values, map, delimiterIndex) {
		    this._selectValueByKey(null);
            for (var data = 0, valueLength = values.length; data < valueLength; data++) {
		        if (values[data] != "") {
		            var _val = values[data];
		            var _isExistIndex
                    for (var i = 0, length = this._promise.length; i < length; i++) {
		                if (_val == this._textFormateString(this._promise[i]))
		                    _isExistIndex = i;
		            }
		            if (_isExistIndex) this._getFieldKey(this._promise[_isExistIndex], map[1], delimiterIndex);
		            else
		                this._selectValueByKey() != null ? this._selectValueByKey() : null;
		        }
		    }
		},
		_getFieldKey: function (data, _key, deliIndex) {
		    if (!ej.isNullOrUndefined(this.model.template) && ej.isNullOrUndefined(this._getField(data, _key))) return;
		    if (ej.isNullOrUndefined(this._getField(data, _key))) return;
		    key = this._getField(data, _key).toString();
		    if (this.model.multiSelectMode != "none") {
		        var keyval, splitval, eleVal, key = this._selectValueByKey();
		        delimiterChar = this.model.delimiterChar;
		        keyval = this._getField(data, _key).toString();
		        if (key != null) {
		            splitval = key.toString().split(deliIndex).filter(function (v) { return v !== "" });
		            if ($.inArray(keyval, splitval) == -1) {
		                splitval.push(keyval);
		                key = splitval.join(delimiterChar) + delimiterChar;
		            }
		            else
		                key = keyval + delimiterChar;
		        }
		        else
		            key = keyval + delimiterChar;
		    }
		    this._selectValueByKey(key);
		},

		_removeDuplicateVal: function (values) {
		    var result = [];
		    $.each(values, function (i, e) {
		        if ($.inArray(e, result) == -1)
		            result.push(e);
		    });
		    if (values.length == 1 && !ej.isNullOrUndefined(this._originalval)) {
		        if ($.inArray(values[0], this._originalval) == -1)
		            this._selectValueByKey(null);
		    }
		    return result;
		},

        _valueChange: function (e) {
            var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val();
            if (this.value() != currValue || (currValue == "" && this.element.val() != "")) {
                this.value(currValue);
                this._changeEvtTrigger(currValue, e);
            }
			if(this.model.showResetIcon && !currValue){
			this.wrapper.find("span.e-iclose").remove();
			this.resetSpan = null;}
        },
        _changeEvtTrigger: function (currValue, e) {
            var args = (e != undefined) ? { event: e, isInteraction: true, value: currValue } : { isInteraction: false, value: currValue };
            if (!this.initialRender) {
				this._trigger("_change", { value: currValue });
                this._trigger("change", args);
            }
        },

        _updateSelectedItemArray: function (value) {
            var  values = [];
            this._selectedItems = [];
            this.suggestionListItems = this.model.dataSource;
            if (this.model.multiSelectMode == "delimiter" && value) {
                values = value.split(this.model.delimiterChar);
                if ((ej.DataManager && this.model.dataSource instanceof ej.DataManager) || ((!ej.isNullOrUndefined(this.suggestionListItems)) && (typeof this.suggestionListItems[0] != "object"))) {
                    for (var i = 0, length = values.length; i < length; i++) {
                        if (values[i]) {
                            var _proxy = this;
							var _objLen = this._selectedObj.length;
							var result = {};
							for (var j = 0; j< _objLen; j++ ){
								if(this._selectedObj[j][_proxy.model.fields.text] == values[i]) {
									result = this._selectedObj[j];
									j = _objLen;
								}
							}
							this._selectedItems.push(!$.isEmptyObject(result) ? result : values[i]);
						}
                    }
                }
                else
                    this._createBoxForObjectType(values);
            }
            else if (this.model.multiSelectMode == "none" && value) {
                values.push(value);
                if ((ej.DataManager && this.model.dataSource instanceof ej.DataManager) || ((!ej.isNullOrUndefined(this.suggestionListItems)) && (typeof this.suggestionListItems[0] != "object"))) {
                    var _proxy = this;
					var result = $.grep(this._selectedObj, function(e){ if(e[_proxy.model.fields.text] == value) return e; });
					this._selectedItems.push(result.length > 0 ? result : value);
				}
                else
                    this._createBoxForObjectType(values);
            }
        },

        _keyDownComplete: function (e) {
            var currValue = this.element.val();
            if (this._preVal != currValue) {
                this._preVal = currValue;
                if (this.model.multiSelectMode == "visualmode") this._adjustWidth();
                this._valueChange(e);
            }
        },

        _moveCaretToEnd: function (el) {
            //Chrome Scroll content
            el.scrollLeft = el.scrollWidth;
            //IE Scroll the content
            if (el.createTextRange) {
                var rng = el.createTextRange();
                rng.moveEnd('textedit');
                rng.moveStart('textedit');
                rng.select();
            }
            if (typeof el.selectionStart == "number") {
                el.selectionStart = el.selectionEnd = el.value.length;
            } else if (typeof el.createTextRange != "undefined") {
                var range = el.createTextRange();
                range.collapse(false);
                range.select();
            }
        },

        _getCaretSelection: function () {
            var input = this.element[0], start = 0, end = 0;

            if (!isNaN(input.selectionStart)) {
                start = input.selectionStart;
                end = input.selectionEnd;
                return { start: Math.abs(start), end: Math.abs(end) };
            }

            var bookmark = document.selection.createRange().getBookmark();
            var selection = input.createTextRange();
            selection.moveToBookmark(bookmark);

            var before = input.createTextRange();
            before.collapse(true);
            before.setEndPoint("EndToStart", selection);
            var beforeLength = before.text.length, selLength = selection.text.length;
            return { start: beforeLength, end: beforeLength + selLength };
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _wireEvents: function () {
            this._on(this.element, "focus", this._targetFocus);
            this._on(this.element, "blur", this._targetBlur);
        }
    });
    ej.Autocomplete.Locale = ej.Autocomplete.Locale || {};
    ej.Autocomplete.Locale["default"] = ej.Autocomplete.Locale["en-US"] = {
        addNewText: "Add New",
        emptyResultText: "No suggestions",
        actionFailure: "The specified field doesn't exist in given data source",
        watermarkText: ""
    };

    ej.filterType = {
        /**  Supports to search text with startswith  */
        StartsWith: "startswith",
        /**  Supports to search text with contains */
        Contains: "contains",
        /**  Supports to search text with endswith */
        EndsWith: "endswith",
        /**  Supports only for number lessthan only */
        LessThan: "lessthan",
        /**  Supports only for number greaterthan only */
        GreaterThan: "greaterthan",
        /**  Supports only for number lessthanorequal only */
        LessThanOrEqual: "lessthanorequal",
        /**  Supports only for number greaterthanorequal only */
        GreaterThanOrEqual: "greaterthanorequal",
        /**  Supports only for number equal only */
        Equal: "equal",
        /** Supports only for number notequal only */
        NotEqual: "notequal"
    };

    ej.SortOrder = {
        /** Supports to sorts with ascending only */
        Ascending: "ascending",
        /** Supports to sorts with descending only */
        Descending: "descending"
    };

    ej.MultiSelectMode = {
        /** Supports to selection mode with none only */
        None: "none",
        /** Supports to selection mode with delimitter only */
        Delimiter: "delimiter",
        /** Supports to selection mode with visualmode only */
        VisualMode: "visualmode"
    };
    ej.Animation = {
        /** Supports to animation type with none only */
        None: "none",
        /** Supports to animation type with slide only */
        Slide: "slide",
        /** Supports to animation type with fade only */
        Fade: "fade"
    };
	ej.Type = {
		Number: "number",
		String: "string",
		Boolean: "boolean",
		Date: "date"
	}
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin provides support to display calendar within your web page and allows to pick the date.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDatePicker", "ej.DatePicker", {

        element: null,
        _rootCss: "e-datepicker",

        model: null,
        validTags: ["input", "div", "span"],
        _setFirst: false,
        _addToPersist: ["value"],
        _cancelValue: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },


        defaults: {

            dayHeaderFormat: "min",

            showPopupButton: true,

            enableAnimation: true,

            showFooter: true,

            displayInline: false,

            htmlAttributes: {},

            dateFormat: '',

            watermarkText: "Select date",

            value: null, 
            minDate: new Date("01/01/1900"),

            maxDate: new Date("12/31/2099"),

            startLevel: "month",

            depthLevel: "",

            cssClass: "",

            startDay: -1,

            stepMonths: 1,

            locale: "en-US",

            showOtherMonths: true,

            enableStrictMode: false,

            enablePersistence: false,

            enabled: true,

            width: "",

            height: "",

            enableRTL: false,

            showRoundedCorner: false,

            headerFormat: 'MMMM yyyy',

            buttonText: 'Today',

            readOnly: false,

            specialDates: null,

            fields: {

                date: "date",

                tooltip: "tooltip",

                iconClass: "iconClass",

                cssClass: "cssClass"
            },

            showTooltip: true,

            showDisabledRange: true,

            highlightSection: "none",

            highlightWeekend: false,

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            allowEdit: true,

            tooltipFormat: "ddd MMM dd yyyy",

            allowDrillDown: true,

            blackoutDates: [],

            beforeDateCreate: null,

            open: null,

            close: null,

            select: null,

            change: null,

            focusIn: null,

            focusOut: null,

            beforeOpen: null,

            beforeClose: null,

            navigate: null,

            create: null,

            destroy: null

        },


        dataTypes: {
            startDay: "number",
            stepMonths: "number",
            showOtherMonths: "boolean",
            enableStrictMode: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            displayInline: "boolean",
            showPopupButton: "boolean",
            locale: "string",
            readOnly: "boolean",
            cssClass: "string",
            dateFormat: "string",
            watermarkText: "string",
            headerFormat: "string",
            buttonText: "string",
            specialDates: "data",
            showTooltip: "boolean",
            highlightSection: "enum",
            highlightWeekend: "boolean",
            enableAnimation: "boolean",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data",
            tooltipFormat: "string",
            allowEdit: "boolean",
            allowDrillDown: "boolean"
        },

        _renderPopup: function () {
            this.sfCalendar = ej.buildTag('div.e-datepicker e-popup e-widget ' + this.model.cssClass + ' e-calendar ' + (this.model.specialDates ? (this.model.specialDates[0][this._mapField._icon] ? 'e-icons ' : '') : ''), "", {}, { id: (this._id ? 'e-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                     .insertBefore(this.element);
            if (this.model.displayInline && !this.element.is("input"))
                this.sfCalendar.addClass('e-inline');
            this.popup = this.sfCalendar;
            if (!ej.isTouchDevice()) this.sfCalendar.addClass('e-ntouch');
            this._setRestrictDateState(this.model.showDisabledRange);
            this._createCalender();
            this._setDisplayInline(this.model.displayInline);
            this._resizeCalender();
            this._setRTL(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
            this._wireCalendarEvents();
        },

        _setModel: function (jsondata) {
            if (ej.isNullOrUndefined(this.sfCalendar)) this._renderPopup();
            var callRefresh = false, start = false, validate = false;
            for (var key in jsondata) {
                switch (key) {
                    case "dayHeaderFormat":
                        this.model.dayHeaderFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "showPopupButton":
                        this._renderDateIcon(jsondata[key], true);
                        break;
                    case "displayInline":
                        if (!jsondata[key]) this._bindDateButton();
                        this._setDisplayInline(jsondata[key]);
                        if (!this.model.allowEdit && !jsondata[key] && this._isInputBox)
                            this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                        break;
                    case "value":
                        if (ej.isPlainObject(jsondata[key])) jsondata[key] = null;
                        if (ej.isNullOrUndefined(jsondata["minDate"]) && ej.isNullOrUndefined(jsondata["maxDate"])) {
                            this._setDateValue(jsondata[key]);
                            if (this._specificFormat())
                                this._stopRefresh = true;
                            jsondata[key] = this.model.value;
                        }
                        else
                            this._updateDateValue(jsondata[key]);
                        validate = callRefresh = start = true;
                        break;
                    case "specialDates":
                        this.model.specialDates = jsondata[key];
                        this._createSpecialDateObject();
                        callRefresh = start = true;
                        break;
                    case "fields":
                        this.model.fields = jsondata[key];
                        this._mapField = this._getMapper();
                        callRefresh = start = true;
                        break;
                    case "showTooltip":
                        this.model.showTooltip = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "highlightWeekend":
                        this.model.highlightWeekend = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "highlightSection":
                        this.model.highlightSection = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "dateFormat":
                        this.model.dateFormat = jsondata[key];
                        this._ensureValue();
                        break;
                    case "minDate":
                        this._setMinDate(jsondata[key]);
                        jsondata[key] = this.model.minDate;
                        this._ensureValue();
                        validate = callRefresh = start = true;
                        break;
                    case "maxDate":
                        this._setMaxDate(jsondata[key]);
                        jsondata[key] = this.model.maxDate;
                        this._ensureValue();
                        validate = callRefresh = start = true;
                        break;
                    case "locale":
                        this.model.locale = jsondata[key];
                        this.model.startDay = ((ej.isNullOrUndefined(this._options.startDay)) && (this.model.startDay === this.culture.calendar.firstDay))
                            ? -1 : (this._options.startDay === this.defaults.startDay) ? -1 : this.model.startDay;
                        this.model.dateFormat = ((ej.isNullOrUndefined(this._options.dateFormat)) && (this.model.dateFormat === this.culture.calendar.patterns.d))
                            ? '' : this.model.dateFormat;
                        this._setCulture(jsondata[key]);
                        if (this.model.value) this._setDateValue(this.model.value);
                        jsondata[key] = this.model.locale;
                        callRefresh = start = true;
                        break;
                    case "showOtherMonths":
                        this.model.showOtherMonths = jsondata[key];
                        this._otherMonthsVisibility();
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = jsondata[key];
                        validate = callRefresh = start = true;
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break; 
					case "validationMessage":
                        this.model.validationMessages = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "readOnly":
                        this.model.readOnly = jsondata[key];
                        this._disbleMaualInput();
                        break;
                    case "width":
                        this._setWidth(jsondata[key]);
                        break;
                    case "height":
                        this._setHeight(jsondata[key]);
                        break;
                    case "cssClass":
                        this._setSkin(jsondata[key]);
                        break;
                    case "enableRTL":
                        this._setRTL(jsondata[key]);
                        break;
                    case "showRoundedCorner":
                        this._setRoundedCorner(jsondata[key]);
                        break;
                    case "enabled":
                        if (!jsondata[key]) this.disable();
                        else this.enable();
                        break;
                    case "buttonText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["buttonText"] = this.model.buttonText = jsondata[key];
                        this._localizedLabels.buttonText = this.model.buttonText;
                        this._setFooterText(jsondata[key]);
                        break;
                    case "showFooter":
                        this._enableFooter(jsondata[key]);
                        break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["watermarkText"] = this.model.watermarkText = jsondata[key];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                    case "startDay":
                        var initial = jsondata[key];
                        if (parseInt(jsondata[key]) < 0 || parseInt(jsondata[key]) > 6) {
                            jsondata[key] = this.culture.calendar.firstDay;
                            initial = -1;
                        }
                        this.model.startDay = jsondata[key];
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["startDay"] = initial;
                        callRefresh = start = true;
                        break;
                    case "startLevel":
                        this.model.startLevel = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "headerFormat":
                        this.model.headerFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "depthLevel":
                        this.model.depthLevel = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "allowEdit": this._changeEditable(jsondata[key]); break;
                    case "tooltipFormat":
                        this.model.tooltipFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "allowDrillDown":
                        this._allowQuickPick(jsondata[key]);
                        callRefresh = start = true;
                        break;
                    case "showDisabledRange":
                        this._setRestrictDateState(jsondata[key]);
                        break;
                    case "blackoutDates":
                        this.model.blackoutDates = jsondata[key];
                        this._initDisableObj(this.model.blackoutDates);
                        callRefresh = start = true;
                        break;
                }
            }
            if (validate) {
                this._validateMinMaxDate();
                jsondata["value"] = this.model.value;
                jsondata["maxDate"] = this.model.maxDate;
                jsondata["minDate"] = this.model.minDate;
            }
            this._setWaterMark();

            if (callRefresh && (this.isValidState || this.model.displayInline))
                this._refreshDatepicker();
            if (start) this._startLevel(this.model.startLevel);
            this._triggerChangeEvent();
            this._checkErrorClass();
        },
        observables: ["value"],

        _destroy: function () {
            if (this.model.displayInline)
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
            if (this._isOpen)
                this.hide();
            this.sfCalendar && this.sfCalendar.remove();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
            }
            this._cloneElement.removeClass("e-js e-input").removeClass(ej.util.getNameSpace(this.sfType));
            this._cloneElement.insertAfter(this.element);
            this.element.remove();
        },

        _init: function (options) {
            this._options = options;
            this._cloneElement = this.element.clone();
            this._dt_drilldown = false;
            this._ISORegex();
            this._initDisableObj(this.model.blackoutDates);
            this.animation = {
                open: { duration: 200 },
                close: { duration: 100 }
            };
            this._animating = false;
            this._isInputBox = this._isInputBox();
            this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
            this._checkAttribute();
            this._setValues();
            this._createDatePicker();
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
        },

        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _checkAttribute: function () {
            var attr = ["min", "max", "readonly", "disabled"], propName = ["minDate", "maxDate", "readOnly", "enabled"], value, propValue;
            for (var i = 0; i < attr.length; i++) {
                value = this.element.attr(attr[i]); propValue = propName[i];
                if (!ej.isNullOrUndefined(value)) {
                    if (ej.isNullOrUndefined(this._options))
                        this.model[propValue] = ((propValue != "enabled") && (propValue != "readOnly")) ? new Date(value) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                    else if (ej.isNullOrUndefined(this._options[propValue]))
                        this.model[propValue] = ((propValue != "enabled") && (propValue != "readOnly")) ? new Date(value) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                }
            }
        },
        _updateDateValue: function (value) {
            var date = this._checkDateObject(value);
            if (date != null) {
                this.isValidState = true;
                if (date == "") {
                    this.element.val("");
                    this.model.value = null;
                } else {
                    this.model.value = date;
                    this._preTxtValue = this.element.val(this._formatter(this.model.value, this.model.dateFormat));
                }
            }
            else {
                (typeof date === "string" && this.model.enableStrictMode) ? this.element.val(value) : this.element.val("");
                this.model.value = null;
                this.isValidState = (this.element.val() == "") ? true : false;
            }
            this._removeWatermark();
        },
        _ensureValue: function () {
            var dateValue = this._parseDate(this.element.val(), this.model.dateFormat);
            if (this.model.value)
                this._setDateValue(this.model.value);
            else if (dateValue)
                this._setDateValue(dateValue);
        },
        _changeEditable: function (bool) {
            var action = bool ? "_on" : "_off";
            if (this.element.is(":input")) {
                if (bool) {
                    if (!this.model.readOnly) this.element.attr("readonly", false);
                    this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
                }
                else {
                    if (!this.model.readOnly) this.element.attr("readonly", "readonly");
                    if (!this.model.displayInline) this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                }
                this[action](this.element, "blur", this._onFocusOut);
                this[action](this.element, "focus", this._onFocusIn);
                this[action](this.element, "keydown", this._onKeyDown);
            }
        },
        _allowQuickPick: function (value) {
            $('.e-datepicker-headertext', this.sfCalendar)[value ? "on" : "off"]("click", $.proxy(this._forwardNavHandler, this));
        },
        _setRestrictDateState: function (value) {
            var action = value ? "addClass" : "removeClass";
            this.sfCalendar[action]("e-dp-restrict-show");
        },
        _setValues: function () {
            this.Date = new Date();
            this._id = this.element[0].id;
            this.isValidState = true;
            this._setCulture(this.model.locale);
            this._setMinDate(this.model.minDate);
            this._setMaxDate(this.model.maxDate);
            this._calendarDate = this._zeroTime(new Date());
            if (this.model.startDay < 0 || this.model.startDay > 6) this.model.startDay = 0;
            this.Date.firstDayOfWeek = this.model.startDay;
            this.Date.fullYearStart = '20';
            this._showHeader = true;
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "")
                this.model.value = this.element[0].value;
            this._validateMinMaxDate();
            this._dateValue = new Date(this._calendarDate.toString());
            this._isIE7 = this._checkIE7();
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this._isIE9 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "9.0") ? true : false;
            // this variable is set to true in DateTimePicker control
            this._getInternalEvents = false;
            this._flag = true;
            this._ejHLWeekEnd = false;
            this._isOpen = false;
            this._prevDate = null;
            this._preValue = null;
            this._isFocused = false;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readOnly" && value == "readOnly") proxy.model.readOnly = true;
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);

            });
        },
        _createDatePicker: function () {
            this._createWrapper();
            this._wireEvents();
            if (this.model.displayInline) {
                this.show();
            }
            if (this.model.enableRTL) this._setRTL(true);
            if (this.model.showRoundedCorner) this._setRoundedCorner(true);
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name") && this._isInputBox)
                this.element.attr("name", this.element[0].id);
            if (this.model.displayInline && !this._isInputBox)
                this._hiddenInput.attr("name", this.element[0].id);
        },
        _createWrapper: function () {
            this._getMapper();
            if (this.model.specialDates)
                this._createSpecialDateObject();
            if (this._isInputBox) {
                this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'tabindex': '0' });
                this.wrapper = ej.buildTag("span.e-datewidget e-widget " + this.model.cssClass);
                this.wrapper.attr("style", this.element.attr("style"));
                this.element.removeAttr('style');
                if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
                this.innerWrapper = ej.buildTag("span.e-in-wrap e-box e-padding");
                this.wrapper.append(this.innerWrapper).insertBefore(this.element);
                this.innerWrapper.append(this.element);
                this.dateIcon = ej.buildTag("span.e-select#" + this._id + "-img", "", {}, (this._isIE8) ? { 'unselectable': 'on' } : {})
                    .append(ej.buildTag("span.e-icon e-calendar", "", {}, { 'aria-label': 'Select' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})).insertAfter(this.element);
            }
            if (!this._isSupport || (this.model.displayInline && !this._isInputBox)) {
                this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
                if (this._isInputBox) this._hiddenInput.val(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "block");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
            this._checkNameAttr();
            if(!this.model.height) this.model.height = this.element.attr("height"); if(!this.model.width) this.model.width = this.element.attr("width");
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            if (this._id)
                $("#e-" + this._id).remove();
            this._setDateValue(this.model.value);
            this._preValue = this._parseDate(this.element.val(), this.model.dateFormat);
            this._setWaterMark();
            this._dateValue = new Date(this._calendarDate.toString());
            if (this.model.displayInline) this._renderPopup();
            else if (this._isInputBox) this._renderDateIcon(this.model.showPopupButton, false);
            if (this.model.readOnly) this._disbleMaualInput();
            if (!this.model.enabled) this.disable();
            else if (this.model.enabled && $(this.element).hasClass("e-disable")) this.enable();
            this._layoutChanged();
            this._checkErrorClass();
            this._addAttr(this.model.htmlAttributes);
        },
        _isInputBox: function () {
            return (this.element.is("input") && (this.element.is("input[type=text]") || !this.element.attr('type')));
        },

        _renderDateIcon: function (bool, reRender) {
            if (reRender && this.model.showPopupButton == bool) return;
            if (!bool && this.dateIcon) {
                this._bindInputEvent();
                this.dateIcon.css('display', 'none');
                this.innerWrapper.removeClass('e-padding');
            }
            else {
                if (this.innerWrapper) {
                    this.innerWrapper.addClass('e-padding');
                    this.dateIcon.css('display', 'block');
                }
                if (!this.model.displayInline)
                    this._bindDateButton();
            }
            this.model.showPopupButton = bool;
        },

        _resizeCalender: function () {
            if ((this.model.dayHeaderFormat == "short") || (this.model.dayHeaderFormat == "min") || (this.model.dayHeaderFormat == "none"))
                this.sfCalendar.removeClass("e-headerlong");
            else if (this.model.dayHeaderFormat == "long") {
                this.sfCalendar.addClass("e-headerlong");
            }
        },

        _setWidth: function (value) {
            if (value) {
                if (this.wrapper) this.wrapper.width(value);
                else this.element.width(value);
            }
            else
                this.model.width = this.wrapper ? this.wrapper.outerWidth() : this.element.width();
        },
        _setHeight: function (value) {
            if (value) {
                if (this.wrapper) this.wrapper.height(value);
                else this.element.height(value);
            }
            else
                this.model.height = this.wrapper ? this.wrapper.outerHeight() : this.element.height();
            if (this._isIE7) this.element.height(this.innerWrapper.height());
        },
        _setRTL: function (isRTL) {
            if (isRTL) {
                if (this.wrapper) {
                    this.wrapper.addClass("e-rtl");
                }
                this.sfCalendar && this.sfCalendar.addClass("e-rtl");
            }
            else {
                if (this.wrapper) {
                    this.wrapper.removeClass("e-rtl");
                }
                this.sfCalendar && this.sfCalendar.removeClass("e-rtl");
            }
        },
        _setRoundedCorner: function (bool) {
            if (bool) {
                if (this.innerWrapper)
                    this.innerWrapper.addClass("e-corner");
                this.sfCalendar && this.sfCalendar.addClass("e-corner");
            }
            else {
                if (this.innerWrapper)
                    this.innerWrapper.removeClass("e-corner");
                this.sfCalendar && this.sfCalendar.removeClass("e-corner");
            }
        },

        _refreshDatepicker: function () {
            if (this._stopRefresh) {
                this._stopRefresh = false
                return;
            }
            var _currentVal = this.element.val();
            //  For checking the year maximum range....
            if (this._specificFormat() && this._formatter(this._preValue, this.model.dateFormat, this.model.locale) != _currentVal)
                var currentValue = this._parseDate(_currentVal, true);
            else var currentValue = this._parseDate(_currentVal);
            currentValue = this._validateYearValue(currentValue);
            this._setDateValue(currentValue);
            if (this._specificFormat() && this._compareDate(this.model.value, this._calendarDate))
                this.element.val(_currentVal)
            $(".e-datepicker-headertext", this.sfCalendar).text(this._formatter(this._calendarDate, this.model.headerFormat));
            this._resizeCalender();
            this._dateValue = new Date(this._calendarDate.toString());
            this._hoverDate = this._calendarDate.getDate() - 1;
            this._renderCalendar(this, this._dateValue);
            this._setFooterText(this._localizedLabels.buttonText);
            this._enableFooter(this.model.showFooter);
            this._layoutChanged();
        },
        _validateYearValue: function (value) {
            if (value != null) {
                var twoDigitYearMax = ej.preferredCulture(this.model.locale).calendars.standard.twoDigitYearMax;
                twoDigitYearMax = typeof twoDigitYearMax === "string" ? new Date().getFullYear() % 100 + parseInt(twoDigitYearMax, 10) : twoDigitYearMax;
                if (this._calendarDate.getFullYear() - value.getFullYear() == 100) {
                    if (this._calendarDate.getFullYear() > twoDigitYearMax)
                        value.setFullYear(this._calendarDate.getFullYear())
                }
            }
            return value;
        },
        _setFooterText: function (footerText) {
            $('.e-footer-text', this.sfCalendar).html(footerText);
        },
        _setSkin: function (skin) {
            if (this.wrapper) {
                this.wrapper.removeClass(this.model.cssClass);
                this.wrapper.addClass(skin);
            }
            else {
                this.element.removeClass(this.model.cssClass);
                this.element.addClass(skin);
            }
            this.sfCalendar.removeClass(this.model.cssClass);
            this.sfCalendar.addClass(skin);
        },
        _setDisplayInline: function (isDisplayInline) {
            this.model.displayInline = isDisplayInline;
            if (isDisplayInline && this._isInputBox) {
                this.sfCalendar.insertAfter(this.wrapper);
                this._setDatePickerPosition();
            }
            else if (isDisplayInline) {
                this.element.append(this.sfCalendar);
                if (!this._isSupport || !this._isInputBox) this._hiddenInput.css("display", "none");
            }
            else {
                this.sfCalendar.css('display', 'none');
                $('body').append(this.sfCalendar);
                this._isOpen = false;
            }
            if (isDisplayInline) {
                this.show();
                this._off(this.dateIcon, "mousedown", this._showDatePopUp);
                this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
            }
            
        },

        _disbleMaualInput: function () {
            if (this.model.readOnly) {
                $(this.element).attr("readonly", "readonly");
                if (!this.model.displayInline) this.hide();
            }
            else if (this.model.allowEdit)
                $(this.element).prop("readonly", false);

        },
        _checkDateObject: function (date, val) {
            if (!date || (typeof JSON === "object" && JSON.stringify(date) === "{}")) return date = null;
            else if (!(date instanceof Date)) {
                if (this._specificFormat())
                    var val = this._parseDate(date, true);
                else
                    var val = this._parseDate(date, val);
                date = val ? val : (val = this._checkJSONString(date)) ? val : null;
            }
            if (!isNaN(Date.parse(date))) {
                this._dateValue = this._calendarDate = this._zeroTime(date)
                if (this._validateDate(date))
                    return this._dateValue;
            }
            return null;
        },
        _checkJSONString: function (date) {
            // Validate the string value
            if (!isNaN(Date.parse(date))) {
                if ((new Date(date).toJSON() === date) || (new Date(date).toDateString() === date) || (new Date(date).toGMTString() === date) ||
                    (new Date(date).toISOString() === date) || (new Date(date).toLocaleString() === date) ||
                    (new Date(date).toString() === date) || (new Date(date).toUTCString() === date))
                    return new Date(date);
                else if (typeof date == "string") return this._dateFromISO(date);
            } else if (this._extISORegex.exec(date) || this._basicISORegex.exec(date)) return this._dateFromISO(date);
        },
        _dateFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4]=="Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _checkInstanceType: function (date) {
            date = this._stringToObject(date);
            if (!date) return null;
            else if (!(date instanceof Date)) {
                date = this._parseDate(date);
            }
            if (!isNaN(Date.parse(date))) return this._zeroTime(date);
            return null;
        },
        _stringToObject: function (value) {
            if (typeof value === "string") {
                var val = ej.parseDate(value, this.model.dateFormat, this.model.locale);
                value = (val != null) ? val : new Date(value);
            }
            return value;
        },
        _validateMinMaxDate: function () {
            var dateChange = false, valueExceed = false;
            if (this.model.maxDate < this.model.minDate) this.model.minDate = this.model.maxDate;
            if (!this.model.enableStrictMode) {
                if (this.model.value) {
                    if (this.model.value < this.model.minDate) {
                        this._calendarDate = this.model.value = this.model.minDate;
                        dateChange = true;
                    }
                    else if (this.model.value > this.model.maxDate) {
                        this._calendarDate = this.model.value = this.model.maxDate;
                        dateChange = true;
                    }
                }
                else {
                    this.element.val("");
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
                this.isValidState = true;
            }
            else {
                if (this.model.value) {
                    if (this.model.value < this.model.minDate) {
                        this._calendarDate = this.model.minDate;
                        this.isValidState = false;
                        valueExceed = true;
                    }
                    else if (this.model.value > this.model.maxDate) {
                        this._calendarDate = this.model.maxDate;
                        this.isValidState = false;
                        valueExceed = true;
                    }
                    else this.isValidState = true;
                }
                else {
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
            }
            if (dateChange) this.element.val(this._formatter(this.model.value, this.model.dateFormat));
            if (valueExceed && this._getInternalEvents) this._trigger("outOfRange");
        },
        _setCulture: function (culture) {
            this.culture = ej.preferredCulture(culture);
            if (this.culture) {
                this.model.locale = this.culture.name == "en" ? "en-US" : this.culture.name;
                this.Date.dayNames = this.culture.calendar.days.names;
                this.Date.dayNamesMin = this.culture.calendar.days.namesShort;
                this.Date.abbrDayNames = this.culture.calendar.days.namesAbbr;
                this.Date.monthNames = this.culture.calendar.months.names;
                this.Date.abbrMonthNames = this.culture.calendar.months.namesAbbr;
                this.Date.format = this.culture.calendar.patterns.d;
                if (this.model.dateFormat == '') this.model.dateFormat = this.culture.calendar.patterns.d;
                if (this.model.startDay == -1) this.model.startDay = this.culture.calendar.firstDay;
            }
            this._separator = this._getSeparator();
            this._localizedLabels = this._getLocalizedLabels();

            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    this._localizedLabels.buttonText = this._options.buttonText;
            }
            this._localizedLabelToModel();
        },

        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },

        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val() == "")
                    this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
                else
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                return true;
            }
        },

        _setDatePickerPosition: function () {
            if (!this.model.displayInline || this._isInputBox) {
                var elementObj = this.element.is('input') ? this.wrapper : this.element;
                var pos = this._getOffset(elementObj), winLeftWidth, winRightWidth,
                winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
                winTopHeight = pos.top - $(document).scrollTop(),
                popupHeight = this.sfCalendar.outerHeight(),
                popupWidth = this.sfCalendar.outerWidth(),
                left = pos.left,
                totalHeight = elementObj.outerHeight(),
                border = (totalHeight - elementObj.height()) / 2,
                maxZ = this._getZindexPartial(), popupmargin = 3,
                topPos = (popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin; // popupmargin denotes space b/w the element and the popup.
                winLeftWidth = $(document).scrollLeft() + $(window).width() - left;
                winRightWidth = $(document).scrollLeft() + left + elementObj.width();
                if (this.model.enableRTL || popupWidth > winLeftWidth && (popupWidth < left + elementObj.outerWidth()) && !ej.isNullOrUndefined(this.wrapper))
                    left += this.wrapper.width() - this.sfCalendar.width();
                if (popupWidth > winRightWidth) left = pos.left;
                this.sfCalendar.css({
                    "left": left + "px",
                    "top": topPos + "px",
                    "z-index": maxZ
                });
            }
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.sfCalendar);
        },

        _setMinDate: function (d) {
            this.model.minDate = this._checkInstanceType(d);
            if (!this.model.minDate) {
                this.model.minDate = (new Date('11/31/1899'));
            }
        },

        _setMaxDate: function (d) {
            this.model.maxDate = this._checkInstanceType(d);
            if (!this.model.maxDate) {
                this.model.maxDate = (new Date('12/31/2099')); // using the JS Date.parse function which expects mm/dd/yyyy
            }
        },
        _setDateValue: function (date, val) {
            var newDate = this._checkDateObject(date, val);
            if (newDate != null) {
                this.isValidState = true;
                this.model.value = new Date(newDate.toString());
 				if(!this.model.displayInline)
                this.wrapper.addClass('e-valid');
                this._validateMinMaxDate();
                this._preTxtValue = this.element.val(this._formatter(this.model.value, this.model.dateFormat));
            }
            else {
                if (date instanceof Date) {
                    this._validateMinMaxDate();
                    date = this._formatter(date, this.model.dateFormat);
                }
                (this.model.enableStrictMode) ? this.element.val(date) : this.element.val(null);
                this.model.value = null; //updating model value as null to avoid the recursive call to this method
				if(!this.model.displayInline)
                this.wrapper.removeClass('e-valid');
                this._triggerChangeEvent();
                this.isValidState = (this.element.val() == "" || ej.isNullOrUndefined(this.element.val())) ? true : false;
            }
            this._removeWatermark();
        },
        _updateInputVal: function () {
            var val = this._validateValue();
            if ((val != null || !this.model.enableStrictMode) && this.sfCalendar && this.sfCalendar.find('.e-datepicker-days').is(':visible'))
                this._refreshDatepicker();
        },
        _validateInputVal: function () {
            var val = this._validateValue();
            if (val != null) {
                if (!this.model.enableStrictMode) {
                    if (val <= this.model.maxDate && val >= this.model.minDate)
                        this.isValidState = true;
                    else {
                        this.model.value = null;
                        this.isValidState = true;
                    }
                }
            }
        },

        _validateValue: function () {
            if (this._specificFormat() && this.element.val() != this._formatter(this._preValue, this.model.dateFormat, this.model.locale))
                var value = this._parseDate(this.element.val(), true);
            else var value = this._parseDate(this.element.val());
            return this._validateYearValue(value);
        },
        _getSeparator: function () {
            var formats;
            if (this.culture) {
                formats = this.culture.calendar.patterns.d;
            }
            else formats = this.model.dateFormat;
            var regex = new RegExp("^[a-zA-Z0-9]+$");
            for (var i = 0; i < formats.length; i++) {
                if (!regex.test(formats[i])) return formats[i];
            }
        },
        _checkIE7: function () {
            if (navigator.appName == 'Microsoft Internet Explorer') {
                var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})"), version = -1;
                if (re.exec(navigator.userAgent) != null)
                    version = parseFloat(RegExp.$1);
                if (version >= 7 && version < 8) return true;
            }
            return false;
        },
        _isValidDate: function (dateObj) {
            return dateObj && typeof dateObj.getTime === "function" && isFinite(dateObj.getTime());
        },

        //Date formatter - Convert date object to specific date format
        _formatter: function (date, format) {
            var newFormat = this._checkFormat(format);
            return ej.format(date, newFormat, this.model.locale);
        },
        _parseDate: function (date, type) {
            var newFormat = this._checkFormat(this.model.dateFormat);
            var DateValue = date;
            if ((this._specificFormat()) && DateValue != undefined && date != "" && type != true && !(ej.format(ej.parseDate(DateValue, newFormat, this.model.locale), this.model.dateFormat, this.model.locale) == DateValue)) {
                return this._dateValue;
            }
            else return ej.parseDate(date, newFormat, this.model.locale);
        },
        _checkFormat: function (format) {
            var proxy = this;
            var dateFormatRegExp = this._regExp();
            return format.replace(dateFormatRegExp, function (match) {
                match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
                return match;
            });
        },
        _regExp: function () {
            return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
        },

        isLeapYear: function (year) {
            return (year % 4 == 0 && year % 100 != 0) || year % 400 == 0;
        },
        //Sets the time component of this Date to zero for cleaner, easier comparison of dates where time is not relevant.
        _zeroTime: function (date) {
            var newDate = typeof date === "string" ? this._parseDate(date) : new Date(date);
            newDate.setMilliseconds(0);
            newDate.setSeconds(0);
            newDate.setMinutes(0);
            newDate.setHours(0);
            return newDate;
        },

        _getDaysInMonth: function (date) {
            return [31, (this.isLeapYear(date) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][date.getMonth()];
        },

        _addDays: function (d, number) {
            d.setDate(d.getDate() + number);
            return d;
        },

        _addYears: function (d, number) {
            d.setFullYear(d.getFullYear() + number);
            return d;
        },

        _addMonths: function (d, number) {
            var tempDatedateMonth = d.getDate();
            d.setMonth(d.getMonth() + number);
            if (tempDatedateMonth > d.getDate())
                this._addDays(d, -d.getDate());
            return d;
        },
        //Checks if the day is a weekend day (Sat or Sun).
        _isWeekend: function (date) {
            return date.getDay() == 0 || date.getDay() == 6;
        },

        _isSpecialDates: function (dates) {
            if (this.model.specialDates) {
                for (var i = 0; i < this.model.specialDates.length; i++) {
                    if (this.model.specialDates[i] && this.model.specialDates[i][this._mapField._date]) {
                        if (dates.getDate() == this.model.specialDates[i][this._mapField._date].getDate() && dates.getMonth() == this.model.specialDates[i][this._mapField._date].getMonth() && dates.getFullYear() == this.model.specialDates[i][this._mapField._date].getFullYear()) {
                            this._getIndex = i;
                            return true;
                        }
                    }
                }
            }
            return false;
        },
        _getMapper: function () {
            var mapper = this.model.fields;
            this._mapField = {};
            this._mapField["_date"] = (mapper && mapper.date) ? mapper["date"] : "date";
            this._mapField["_tooltip"] = (mapper && mapper.tooltip) ? mapper["tooltip"] : "tooltip";
            this._mapField["_icon"] = (mapper && mapper.iconClass) ? mapper["iconClass"] : "iconClass";
            this._mapField["_custom"] = (mapper && mapper.cssClass) ? mapper["cssClass"] : "cssClass";
        },
        _createSpecialDateObject: function () {
            for (var i = 0; i < this.model.specialDates.length; i++) {
                this.model.specialDates[i][this._mapField._date] = this._checkInstanceType(this.model.specialDates[i][this._mapField._date]);
            }
        },

        _getMonthName: function (abbreviated, date) {
            return abbreviated ? this.Date.abbrMonthNames[date.getMonth()] : this.Date.monthNames[date.getMonth()];
        },



        _displayNewMonth: function (m, y) {
            this._setDisplayedMonth(this.displayedMonth + m, this.displayedYear + y, true);
            return false;
        },

        _setDisplayedMonth: function (m, y, rerender) {
            if (this.model.minDate == undefined || this.model.maxDate == undefined) {
                return;
            }
            var s = new Date(this.model.minDate.getTime());
            s.setDate(1);
            var e = new Date(this.model.maxDate.getTime());
            e.setDate(1);

            var t;
            if ((!m && !y) || (isNaN(m) && isNaN(y))) {

                t = this._zeroTime(new Date());
                t.setDate(1);
            } else if (isNaN(m)) {

                t = new Date(y, this.displayedMonth, 1);
            } else if (isNaN(y)) {

                t = new Date(this.displayedYear, m, 1);
            } else {

                t = new Date(y, m, 1);
            }

            if (t.getTime() < s.getTime()) {
                t = s;
            } else if (t.getTime() > e.getTime()) {
                t = e;
            }
            var oldMonth = this.displayedMonth;
            var oldYear = this.displayedYear;
            this.displayedMonth = t.getMonth();
            this.displayedYear = t.getFullYear();
            var tempDate = t;
            if (rerender && (this.displayedMonth != oldMonth || this.displayedYear != oldYear)) {
                this._renderCalendar(this, tempDate);
                this._dateValue = tempDate;
                this._trigger("monthChanged", [this.displayedMonth, this.displayedYear]);
            }
        },
        _clearSelected: function () {
            this.numSelected = 0;
            if (this.model.highlightSection == "week") {
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().removeClass('e-selected-week');
            }
            else if (this.model.highlightSection == "month") {
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().parent().removeClass('e-selected-month');
            }
            else if (this.model.highlightSection == "workdays") {
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().removeClass('e-work-week');
            }
            else
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false);

        },
        _addSelected: function () {
            if (this.model.highlightSection == "week") {
                $('td.e-active', this.sfCalendar).parent().addClass('e-selected-week');
            }
            else if (this.model.highlightSection == "month") {
                $('td.e-active, this.sfCalendar').parent().parent().addClass('e-selected-month');
            }
            else if (this.model.highlightSection == "workdays") {
                $('td.e-active', this.sfCalendar).parent().addClass('e-work-week');
            }
        },

        _hideOtherMonths: function (sfCalendar) {
            $('td.other-month', sfCalendar).css("visibility", "hidden");
        },
        _showOtherMonths: function (sfCalendar) {
            $('td.other-month', sfCalendar).css({ 'visibility': 'visible' });
        },
        _otherMonthsVisibility: function () {
            if (this.model.showOtherMonths)
                this._showOtherMonths(this.sfCalendar);
            else
                this._hideOtherMonths(this.sfCalendar);
        },

        _createCalender: function () {
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                    .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-datepicker-headertext").text(this._formatter(this._calendarDate, this.model.headerFormat)).attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .appendTo(this.sfCalendar);
            this._enableHeader(this._showHeader);
            var table = ej.buildTag("table.e-dp-viewdays", "", {}, { 'cellspacing': 2 }).data("e-table", "data").attr({ 'role': 'grid', 'aria-activedescendant': '' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this.sfCalendar.append(table);
            this._renderCalendar(this);
            this._startLevel(this.model.startLevel);
            ej.buildTag("div.e-footer")
                .append(ej.buildTag("span.e-footer-icon"))
                .append(ej.buildTag("span.e-footer-text"))
                .appendTo(this.sfCalendar);
            $('.e-footer-text', this.sfCalendar).html(this._localizedLabels.buttonText);
            this._enableFooter(this.model.showFooter);
        },
        _enableHeader: function (show) {
            if (show) $(".e-header", this.sfCalendar).show();
            else $(".e-header", this.sfCalendar).hide();
        },
        _enableFooter: function (show) {
            if (show) $('.e-footer', this.sfCalendar).show();
            else $('.e-footer', this.sfCalendar).hide();
			this._todayBtnDisable();
        },
		  _todayBtnDisable: function() {
            var today = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 0, 0, 0);
            if (!(+this.model.minDate <= +today && +this.model.maxDate >= +today)) {
                $('.e-footer', this.sfCalendar).addClass('e-footer-disable')
            } else {
                $('.e-footer', this.sfCalendar).removeClass('e-footer-disable')
            }
        },
        _checkArrows: function (min, max) {
            this._preArrowCondition(min, this.model.minDate.getFullYear());
            this._nextArrowCondition(max, this.model.maxDate.getFullYear());
        },
        _checkDateArrows: function () {
            this._preArrowCondition(this._tempMinDate, this.model.minDate);
            this._nextArrowCondition(this._tempMaxDate, this.model.maxDate);
        },
        _preArrowCondition: function (val1, val2) {
            if (val1 <= val2) this.sfCalendar.find(".e-arrow-sans-left").addClass("e-disable").attr({ "aria-disabled": true });
            else this.sfCalendar.find(".e-arrow-sans-left").removeClass("e-disable").attr({ "aria-disabled": false });
        },
        _nextArrowCondition: function (val1, val2) {
            if (val1 >= val2) this.sfCalendar.find(".e-arrow-sans-right").addClass("e-disable").attr({ "aria-disabled": true });
            else this.sfCalendar.find(".e-arrow-sans-right").removeClass("e-disable").attr({ "aria-disabled": false });
        },

        _previousNextHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled || $(event.target).hasClass("e-disable")) return false;
            event.preventDefault();
            var prevTable = $("table", this.sfCalendar), navFrom;
            navFrom = this._navigateFrom(prevTable);
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrevDate(progress);
            var currentTable = $("table", this.sfCalendar), tClassName, navTo;
            tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case "e-dp-viewdays": navTo = "month"; break;
                case "e-dp-viewmonths": navTo = "year"; break;
                case "e-dp-viewyears": navTo = "decade"; break;
                case "e-dp-viewallyears": navTo = "century"; break;
            }
            this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
        },
        _processNextPrevDate: function (progress) {
            if (this._DRPdisableFade) {
                var s = new Date(this.sfCalendar.find("td.current-month").attr("date"));
                this._dateValue = s;
            }
            if (progress && this.sfCalendar.find(".e-arrow-sans-left").hasClass("e-disable")) return false;
            else if (!progress && this.sfCalendar.find(".e-arrow-sans-right").hasClass("e-disable")) return false;

            var currentTable = $("table", this.sfCalendar), temp;
            var tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case 'e-dp-viewdays':
                    var step = this.model.stepMonths;
                    if (progress) {
                        if (this._dateValue <= this.model.minDate) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (this._dateValue >= this.model.maxDate) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    this._addMonths(this._dateValue, (progress ? -step : step));
                    if (this._clickedDate)
                        this._calendarDate = this._clickedDate;
                    this._dateValue = this._dateValue < this.model.minDate ? new Date(this.model.minDate.toString()) : this._dateValue;
                    this._dateValue = this._dateValue > this.model.maxDate ? new Date(this.model.maxDate.toString()) : this._dateValue;
                    this._renderCalendar(this, this._dateValue);
                    $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat));
                    this._addFocus('day', this._hoverDate);
                    var dateRange = this._findFirstLastDay(new Date(this._dateValue.toString()));
                    this._preArrowCondition(dateRange.firstDay, this.model.minDate);
                    this._nextArrowCondition(dateRange.lastDay, this.model.maxDate);
                    break;
                case 'e-dp-viewmonths':
                    var dateValue = this._dateValue;
                    dateValue.setFullYear($('.e-datepicker-headertext', this.sfCalendar).text())
                    if (progress) {
                        if (dateValue.getFullYear() <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (dateValue.getFullYear() >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    this._addYears(dateValue, (progress ? -1 : 1));
                    this._renderCalendar(this, dateValue);
                    temp = dateValue.getFullYear();
                    $('.e-datepicker-headertext', this.sfCalendar).text(temp);
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-months').hide();
                    $($(currentTable).find('.e-datepicker-months')).show();
                    this._addFocus('month', this._hoverMonth);
                    this._checkArrows(temp, temp);
                    break;
                case 'e-dp-viewyears':
                    var yearValue;
                    yearValue = this._dateValue
                    yearValue.setFullYear($(currentTable).find(".e-state-hover").text());
                    if (progress) {
                        if (parseInt($('td.e-year-first:first').text()) <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (parseInt($('td.e-year-last:first').prev().text()) >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    if (($(currentTable).find(".e-state-hover").hasClass('e-year-first') && progress) || ($(currentTable).find(".e-state-hover").hasClass('e-year-last') && !progress))
                        this._dateValue.setFullYear(yearValue.getFullYear());
                    else if (($(currentTable).find(".e-state-hover").hasClass('e-year-first') && !progress))
                        this._dateValue.setFullYear(yearValue.getFullYear() + 11);
                    else if (($(currentTable).find(".e-state-hover").hasClass('e-year-last') && progress))
                        this._dateValue.setFullYear(yearValue.getFullYear() - 11);
                    else
                        this._dateValue.setFullYear(yearValue.getFullYear() + (progress ? -10 : 10));
                    this._renderCalendar(this, this._dateValue);
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 10) + 1);
                    $(".e-datepicker-headertext", this.sfCalendar).text((setYear + 1) + ' - ' + (setYear + 10));
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-years').hide();
                    $($(currentTable).find('.e-datepicker-years')).show();
                    this._addFocus('year', this._hoverYear + (!($('.e-year-first.e-hidedate').length) ? 0 : -1));
                    this._checkArrows(setYear + 1, setYear + 10);
                    break;
                case 'e-dp-viewallyears':
                    var headYears;
                    if (progress) {
                        headYears = parseFloat($('td.e-allyear-first', currentTable.get(0)).text().split('-')[1]);
                        if (headYears <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        } else {
                            this._flag = true;
                        }

                    } else {
                        headYears = parseFloat($('td.e-allyear-last', currentTable.get(0)).prev().text().split('-')[1]);
                        if (headYears >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        } else
                            this._flag = true;
                    }
                    this._dateValue.setFullYear((!(this._lastHoveredYear) ? this._dateValue.getFullYear() : this._lastHoveredYear) + (progress ? -100 : 100));
                    this._lastHoveredYear = this._dateValue.getFullYear();
                    this._renderCalendar(this, this._dateValue);
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 100) + 1);
                    temp = parseFloat($('td.e-allyear-last', currentTable.get(0)).prev().text().split('-')[1]);
                    $('.e-datepicker-headertext', this.sfCalendar).text((setYear + 1) + ' - ' + temp);
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-allyears').hide();
                    $($(currentTable).find('.e-datepicker-allyears')).show();
                    this._addFocus('allyear', this._hoverAllYear + (!($('.e-allyear-first.e-hidedate').length) ? 0 : -1));
                    this._checkArrows(setYear + 1, temp);
                    break;
            }
            this._layoutChanged();
        },
        _addFocus: function (selection, index) {
            var cls = 'e-current-' + selection;
            if (selection == 'day') cls = 'current-month';
            var items = this.sfCalendar.find('tbody tr td.' + cls);
            if (selection == "month") {
                $(items).each(function (i, ele) {
                    if (parseInt($(ele).attr("index")) == parseInt(index)) {
                        index = i;
                        return;
                    }
                });
            }
            var cell = items[index];
            if (!cell) cell = items.last();
            this.sfCalendar.find('table td').removeClass("e-state-hover");
            $(cell).addClass("e-state-hover");
            this._setActiveState(selection);
            return index;
        },
        _setActiveState: function (selection) {
            if (!(this.model.value instanceof Date)) return;
            var items = this.sfCalendar.find('tbody tr td.e-current-' + selection), cell, proxy = this;
            var indx = -1;
            switch (selection) {
                case "month":
                    if (this.model.value.getFullYear() === parseInt($('.e-text', this.sfCalendar).text())) {
                        $(items).each(function (i, ele) {
                            if (parseInt($(ele).attr("index")) == parseInt(proxy.model.value.getMonth())) {
                                indx = i;
                                return;
                            }
                        });
                    }
                    break;
                case "year":
                    var value = this.model.value.getFullYear();
                    $(items).each(function (i, ele) {
                        if (parseInt(ele.innerHTML) == parseInt(value)) {
                            indx = i;
                            return;
                        }
                    });
                    break;
                case "allyear":
                    var start = parseInt(this.model.value.getFullYear()) - ((parseInt(this.model.value.getFullYear()) % 10) + 1);
                    var active = (start + 1) + ' - ' + (start + 10);
                    $(items).each(function (i, ele) {
                        if (parseInt(ele.innerHTML) == parseInt(active)) {
                            indx = i;
                            return;
                        }
                    });
                    break;
            }
            cell = items[indx];
            if (cell) {
                this.sfCalendar.find('table td').removeClass("e-active");
                if (!$(cell).hasClass('e-hidedate'))
                    $(cell).addClass("e-active");
            }
        },
        _setFocusByName: function (name, value) {
            var allValues = this.sfCalendar.find('tbody tr td.e-current-' + name), index, cell;
            $(allValues).each(function (i, ele) {
                if (parseInt(ele.innerHTML) == parseInt(value)) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            this.sfCalendar.find('table td').removeClass("e-state-hover");
            $(cell).addClass("e-state-hover");
            this._setActiveState(name);
            return index;
        },
        _getHeaderTxt: function () {
            return this.sfCalendar.find(".e-datepicker-headertext").text();
        },
        _findFirstLastDay: function (value) {
            var y = value.getFullYear(), m = value.getMonth();
            var firstDay = new Date(y, m, 1);
            var lastDay = new Date(y, m + 1, 0);
            return { firstDay: firstDay, lastDay: lastDay }
        },
        _forwardNavHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (event) event.preventDefault();

            var currentTable = $("table", this.sfCalendar);
            var tclassName = $("table", this.sfCalendar).get(0).className, proxy = this, headerTxt, navTo;
            var navFrom = this._navigateFrom(currentTable);
            switch (tclassName) {
                case 'e-dp-viewdays':
                    this._hoverMonth = this._getDateObj(currentTable.find(".e-state-hover")).getMonth() ||
                                this._getDateObj(currentTable.find(".e-active")).getMonth() || 0;
                    if (this._DRPdisableFade) {
                        this._renderCalendar(this, this._calendarDate);
                        $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat));
                    }
                    this._startLevel("year"); navTo = "year";
                    this._addFocus('month', this._hoverMonth);
                    break;
                case 'e-dp-viewmonths':
                    headerTxt = this._getHeaderTxt();
                    this._startLevel("decade"); navTo = "decade";
                    this._hoverYear = this._setFocusByName('year', headerTxt);
                    break;
                case 'e-dp-viewyears':
                    headerTxt = this._getHeaderTxt();
                    this._startLevel("century"); navTo = "century";
                    this._hoverAllYear = this._setFocusByName('allyear', headerTxt);
                    break;
            }
            if (navFrom != "century") this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
            this._layoutChanged();
        },
        _cellSelection: function () {
            var currentTable = $("table", this.sfCalendar);
            var tclassName = $("table", this.sfCalendar).get(0).className;
            switch (tclassName) {
                case 'e-dp-viewmonths':
                    this._hoverMonth = this._addFocus('month', this._dateValue.getMonth());
                    break;
                case 'e-dp-viewyears':
                    var dateValue = new Date(this._dateValue.toString());
                    // Navigate to Prev/Next year Calendar while selecting the first/last year in the calendar view.
                    this._navigationToPrevNext('year');
                    // Reasssign the old value
                    this._dateValue = dateValue;
                    this._hoverYear = this._setFocusByName('year', this._dateValue.getFullYear());
                    break;
                case 'e-dp-viewallyears':
                    var dateValue = new Date(this._dateValue.toString());
                    // Navigate to Prev/Next year Calendar while selecting the first/last year in the calendar view.
                    this._navigationToPrevNext('allyear');
                    // Reasssign the old value
                    this._dateValue = dateValue;
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 10) + 1);
                    this._hoverAllYear = this._setFocusByName('allyear', setYear + 1 + ' - ' + setYear + 10);
                    break;
            }
            this._layoutChanged();
        },
        _navigationToPrevNext: function (name) {
            var allValues = this.sfCalendar.find('tbody tr td.e-current-' + name), index, cell;
            var value = this._dateValue.getFullYear();
            $(allValues).each(function (i, ele) {
                if (parseInt(ele.innerHTML) == parseInt(value)) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (cell) {
                if ($(cell).hasClass('e-' + name + '-last'))
                    this._processNextPrevDate(false)
                else if ($(cell).hasClass('e-' + name + '-first'))
                    this._processNextPrevDate(true);
            }
        },
        _navigateFrom: function (prevTable) {
            var tPrevClassName = prevTable.get(0).className, navFrom;
            switch (tPrevClassName) {
                case "e-dp-viewdays": navFrom = "month"; break;
                case "e-dp-viewmonths": navFrom = "year"; break;
                case "e-dp-viewyears": navFrom = "decade"; break;
                case "e-dp-viewallyears": navFrom = "century"; break;
            }
            return navFrom;
        },
        _backwardNavHandler: function (event) {
            this._animating = true;
            if (this.model.readOnly || !this.model.enabled) return false;
            var element;
            if (event.type) {
                event.preventDefault();
                element = $(event.currentTarget);
            }
            else element = event;
            var cTable = $("table", this.sfCalendar), temp;
            var tclassName = $("table", this.sfCalendar).get(0).className, proxy = this, navTo;
            var navFrom = this._navigateFrom(cTable);
            switch (tclassName) {
                case 'e-dp-viewmonths':
                    cTable.removeClass("e-dp-viewmonths").addClass("e-dp-viewdays");
                    this._lastHoveredMonth = parseInt($(element).attr('index'));
                    this._dateValue = new Date(this._dateValue.getFullYear(), this._lastHoveredMonth, 1);
                    if (this._DRPdisableFade) this._trigger("_month_Loaded", { currentTarget: event.currentTarget });
                    this._renderCalendar(this, this._dateValue);
                    $('tbody', cTable).not('.e-datepicker-days,.e-week-header').hide();
                    $($(cTable).find('.e-datepicker-days,.e-week-header')).fadeIn("fast", function () {
                        proxy._addFocus('day', proxy._hoverDate || 0);
                        proxy._animating = false;
                    });
                    $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat)); navTo = "month";
                    break;
                case 'e-dp-viewyears':
                    cTable.removeClass("e-dp-viewyears").addClass("e-dp-viewmonths");
                    this._lastHoveredYear = parseInt(element.text());
                    this._dateValue.setFullYear(this._lastHoveredYear);
                    this._renderCalendar(this, this._dateValue);
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-months').hide();
                    if (ej.isNullOrUndefined(this._hoverMonth) && !ej.isNullOrUndefined(this._dateValue)) this._hoverMonth = this._dateValue.getMonth();
                    $($(cTable).find('.e-datepicker-months')).fadeIn("fast", function () {
                        proxy._addFocus('month', proxy._hoverMonth || 0);
                        proxy._animating = false;
                    });
                    temp = element.text();
                    $('.e-datepicker-headertext', this.sfCalendar).text(temp);
                    this._checkArrows(temp, temp); navTo = "year";
                    break;
                case 'e-dp-viewallyears':
                    var headYears = element.text().split('-');
                    cTable.removeClass("e-dp-viewallyears").addClass("e-dp-viewyears");
                    if (headYears[0] < this.model.minDate.getFullYear()) headYears[0] = this.model.minDate.getFullYear().toString();
                    else if (headYears[0] > this.model.maxDate.getFullYear()) headYears[0] = this.model.maxDate.getFullYear().toString();
                    this._renderCalendar(this, (new Date(headYears[0], 0, 1)));
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-years').hide();
                    $($(cTable).find('.e-datepicker-years')).fadeIn("fast", function () {
                        proxy._addFocus('year', proxy._hoverYear || 0);
                        proxy._animating = false;
                    });
                    $('.e-datepicker-headertext', this.sfCalendar).text(headYears[0] + ' - ' + headYears[1]);
                    this._checkArrows(headYears[0], headYears[1]); navTo = "decade";
                    this._dateValue = new Date(this._dateValue.setFullYear(parseInt($.trim(headYears[0])) + ((!this._lastHoveredYear) ? this._dateValue.getFullYear() % 10 : this._lastHoveredYear % 10)));
                    break;
                default:
                    this._clearSelected();
                    this.sfCalendar.find('table td').removeClass("e-state-hover");
                    element.not('td.other-month.e-hidedate').addClass('e-active').attr('aria-selected', true);
                    this._addSelected();

                    this._hoverDate = this._getDateObj(element).getDate() - 1;
                    this._dateValue = new Date(element.attr('date'));
                    this._clickedDate = new Date(element.attr('date'));
                    this._animating = false;
                    break;
            }
            if (navFrom != "month") this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
            this._layoutChanged();
        },

        _startLevel: function (start) {
            var cTable = $("table", this.sfCalendar);
            var headerText = $(".e-datepicker-headertext", this.sfCalendar), s, e;
            var dateValue = this._dateValue;
            switch (start) {
                case "decade":
                    cTable.removeClass("e-dp-viewallyears e-dp-viewmonths e-dp-viewdays").addClass("e-dp-viewyears");
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-years').hide();
                    $($(cTable).find('.e-datepicker-years')).show();
                    if (this.model.enableStrictMode && this._calendarDate < this._dateValue) dateValue = this._calendarDate;
                    else dateValue = dateValue;
                    var setYear = parseInt(dateValue.getFullYear()) - ((parseInt(dateValue.getFullYear()) % 10) + 1);
                    s = setYear + 1;
                    e = setYear + 10;
                    headerText.text(s + ' - ' + e);
                    this._checkArrows(s, e);
                    this._hoverYear = this._setFocusByName('year', dateValue.getFullYear());
                    break;
                case "century":
                    if (!(this._calendarDate < this._dateValue)) this._renderCalendar(this, dateValue);
                    cTable.removeClass("e-dp-viewyears e-dp-viewdays e-dp-viewmonths").addClass("e-dp-viewallyears");
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-allyears').hide();
                    $($(cTable).find('.e-datepicker-allyears')).show();
                    s = parseFloat($('td.e-allyear-first', cTable.get(0)).text().split('-')[1]) + 1;
                    e = parseFloat($('td.e-allyear-last', cTable.get(0)).prev().text().split('-')[1]);
                    var headYears = s + ' - ' + e;
                    headerText.text(headYears);
                    this._checkArrows(s, e);
                    var setYear = parseInt(dateValue.getFullYear()) - ((parseInt(dateValue.getFullYear()) % 10) + 1);
                    this._hoverAllYear = this._setFocusByName('allyear', (setYear + 1) + ' - ' + (setYear + 10));
                    break;
                case "year":
                    cTable.removeClass("e-dp-viewyears e-dp-viewallyears e-dp-viewdays").addClass("e-dp-viewmonths");
                    $('tbody,tr.e-week-header', cTable).hide();
                    $($(cTable).find('.e-datepicker-months')).show();
                    if (this.model.enableStrictMode && this._calendarDate < this._dateValue) s = this._calendarDate.getFullYear();
                    else s = dateValue.getFullYear();
                    headerText.text(s);
                    this._checkArrows(s, s);
                    this._hoverMonth = dateValue.getMonth();
                    this._addFocus('month', this._hoverMonth);
                    break;
                case "month":
                    cTable.removeClass("e-dp-viewyears e-dp-viewallyears e-dp-viewmonths").addClass("e-dp-viewdays ");
                    break;
            }
        },
        _depthLevel: function (depth) {
            var calendarTable = this.sfCalendar;
            switch (depth) {
                case "year":
                    $(calendarTable.find('.e-current-year,.e-current-allyear')).on("click", $.proxy(this._backwardNavHandler, this));
                    this._on($('.e-current-month', this.sfCalendar), "click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "decade":
                    $(calendarTable.find('.e-current-allyear')).on("click", $.proxy(this._backwardNavHandler, this));
                    $('.e-current-year', this.sfCalendar).on("click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "century":
                    $(calendarTable.find('.e-current-allyear')).on("click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "month":
                    this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                    this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
            }
        },
        _onDepthSelectHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if ($(e.target).hasClass("e-current-month"))
                this._dateValue = new Date(this._dateValue.setMonth(parseInt(e.target.attributes["index"].value)));
            else if ($(e.target).hasClass("e-current-year"))
                this._dateValue = new Date(this._dateValue.setFullYear(parseInt(e.target.innerHTML)));
            else if ($(e.target).hasClass("e-current-allyear"))
                this._dateValue = new Date(this._dateValue.setFullYear(parseInt(e.target.innerHTML)));
            this._onSetCancelDateHandler(e);
        },

        _datepickerMonths: function (tbody, calendarTable, currentDate) {
            var dc = function (a) {
                return document.createElement(a);
            };
            var month = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(dc('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(dc('td'))
                        .addClass('e-current-month e-state-default')
                        .attr({ 'index': month }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .html(this.Date.abbrMonthNames[month++]);
                    if (currentDate.getFullYear() < this.model.minDate.getFullYear() || currentDate.getFullYear() > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-month');
                    }
                    else if ((currentDate.getFullYear() <= this.model.minDate.getFullYear() && month < this.model.minDate.getMonth() + 1) ||
                        (currentDate.getFullYear() >= this.model.maxDate.getFullYear() && month > this.model.maxDate.getMonth() + 1)) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-month');
                    }
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
            var s = currentDate.getFullYear();
            this._checkArrows(s, s);
        },

        _datepickerYears: function (tbody, calendarTable, currentYear) {
            var dc = function (a) {
                return document.createElement(a);
            };
            var Year = parseInt(currentYear) - ((parseInt(currentYear) % 10) + 1);
            var years = [];
            for (var j = 0; j < 12; j++) {
                years.push(Year + j);
            }
            var year = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(dc('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(dc('td'));
                    td.attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    if (year == 0)
                        td.addClass('e-year-first e-current-year ');
                    else if (year == 11)
                        td.addClass('e-year-last e-current-year ');
                    else
                        td.addClass('e-current-year e-state-default');
                    if (years[year] < this.model.minDate.getFullYear() || years[year] > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-year');
                    }
                    td.html(years[year++]);
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
            this._checkArrows(years[0], years[years.length]);
        },

        _datepickerAllYears: function (tbody, calendarTable, currentYear) {
            var Year = parseInt(currentYear) - ((parseInt(currentYear) % 100) + 10);
            var headYear = Year;
            var years = [], newline = this._isIE8 || this._isIE9 ? "" : "\n";

            for (var j = 0; j < 12; j++) {
                years.push(parseInt(Year) + " -" + newline + parseInt(Year + 9));
                Year = Year + 10;
            }
            var year = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(document.createElement('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(document.createElement('td'));
                    td.attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    if (year == 0)
                        td.addClass('e-allyear-first e-current-allyear ');
                    else if (year == 11)
                        td.addClass('e-allyear-last e-current-allyear ');
                    else
                        td.addClass('e-current-allyear e-state-default');
                    if (parseInt(years[year].split('-\n')[1]) < this.model.minDate.getFullYear() || parseInt(years[year].split('-\n')[0]) > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-allyear');
                    }
                    td.html(years[year++]);
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
        },
        _renderHeader: function (dpObject) {
            var thead = $(document.createElement('thead'));
            var cultureObj = ej.preferredCulture(this.model.locale).calendars.standard.days;
            if (dpObject.model.dayHeaderFormat != "none") {
                var headRow = ej.buildTag("tr.e-week-header").attr({ 'role': 'columnheader' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                for (var i = this.Date.firstDayOfWeek; i < this.Date.firstDayOfWeek + 7; i++) {
                    var weekday = i % 7;
                    var day = cultureObj.names[weekday];
                    var headerday;
                    if (dpObject.model.dayHeaderFormat == "short")
                        headerday = cultureObj.namesAbbr[weekday];
                    else if (dpObject.model.dayHeaderFormat == "long") headerday = day;
                    else headerday = cultureObj.namesShort[weekday];
                    var th = ej.buildTag("th", "", {}, { 'scope': 'col', 'abbr': day, 'date': day, 'title': this._formatter(day, "dddd"), 'class': (weekday == 0 || weekday == 6 ? 'e-week-end' : 'e-week-day') }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                            .html(headerday);
                    headRow.append(th);
                }
            };
            return thead.append(headRow);
        },

        _renderCalendar: function (dpObject, date) {
            var proxy = this, today;
            dpObject = $.extend({}, ej.DatePicker.prototype.defaults, dpObject);
            this.Date.firstDayOfWeek = this.model.startDay;
            if (date) today = date;
            else if (this._calendarDate) today = this._calendarDate;
            else today = proxy._zeroTime(new Date());
            var calendarTable = $('table', this.sfCalendar);
            calendarTable.empty();

            calendarTable.append(this._renderHeader(dpObject));

            var tbody = ej.buildTag('tbody.e-datepicker-allyears', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._datepickerAllYears(tbody, calendarTable, today.getFullYear());

            tbody = ej.buildTag("tbody.e-datepicker-years", "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._datepickerYears(tbody, calendarTable, today.getFullYear());
            var month = dpObject.model.month == undefined ? today.getMonth() : dpObject.model.month;
            var year = dpObject.model.year || today.getFullYear();
            var currentDate = (new Date(year, month, 1, 0, 0, 0));
            var firstDayOffset = this.Date.firstDayOfWeek - currentDate.getDay() + 1;
            if (firstDayOffset > 1) firstDayOffset -= 7;
            var weeksToDraw = Math.ceil(((-1 * firstDayOffset + 1) + this._getDaysInMonth(currentDate)) / 7);
            this._addDays(currentDate, (firstDayOffset - 1));
            var newdate = proxy._zeroTime(new Date());
            var selected = this._calendarDate;
            tbody = ej.buildTag('tbody.e-datepicker-months', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            this._datepickerMonths(tbody, calendarTable, today);

            tbody = ej.buildTag('tbody.e-datepicker-days', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var w = 0, _first = true, _last = true;
            while (w++ < weeksToDraw) {
                var r = jQuery(document.createElement('tr'));
                for (var i = 0; i < 7; i++) {
                    var thisMonth = currentDate.getMonth() == month;
                    var checkSpecialDate = this._isSpecialDates(currentDate);
                    var disable = this._checkDisableRange(currentDate);
                    var index = this._getIndex;
                    var d = $(document.createElement('td')).
                        html(checkSpecialDate ? '<span></span>' + currentDate.getDate() : currentDate.getDate() + '')
                        .attr({

                            'date': currentDate.toDateString(),
                            'title': (this.model.showTooltip ? (checkSpecialDate && this.model.specialDates[index][this._mapField._tooltip] ? this.model.specialDates[index][this._mapField._tooltip] : this._formatter(currentDate, this.model.tooltipFormat)) : ''),
                            'aria-selected': false,
                            'role': 'gridcell'
                        }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .addClass((thisMonth ? 'current-month e-state-default ' : 'other-month e-state-default ') +
                            (this._isWeekend(currentDate) ? (this._ejHLWeekEnd ? 'e-dp-weekend e-week-end ' : (this.model.highlightWeekend ? 'e-week-end ' : '')) : 'e-week-day ') +
                            (thisMonth && currentDate.getTime() == newdate.getTime() ? 'today ' : ''));

                    d.find('span:first-of-type').addClass((checkSpecialDate ? (this.model.specialDates[index][this._mapField._icon] ? 'e-special-date-icon ' + this.model.specialDates[index][this._mapField._icon] + ' ' : 'e-special-day') : ''));
                    d.addClass(checkSpecialDate ? (this.model.specialDates[index][this._mapField._custom] ? this.model.specialDates[index][this._mapField._custom] : '') : '');
                    if (disable) this._disableDates({ date: currentDate, element: d });
                    if (selected.getTime() == currentDate.getTime() && thisMonth) {
                        if (!d.hasClass('e-hidedate'))
                            if (this.model.value) {
                                d.addClass('e-active').attr({ 'aria-selected': true });
                                if (this.model.highlightSection == "week") {
                                    r.addClass('e-selected-week');
                                }
                                if (this.model.highlightSection == "month") {
                                    tbody.addClass('e-selected-month');
                                }
                                if (this.model.highlightSection == "workdays") {
                                    r.addClass('e-work-week');
                                }
                            }
                            else d.addClass('e-state-hover').attr({ 'aria-selected': false });
                        if (!this._hoverDate) {
                            if (!d.hasClass('e-hidedate')) d.addClass('e-state-hover');
                            this._hoverDate = currentDate.getDate() - 1;
                        }
                    }
                    var cond = true;
                    if (currentDate < this.model.minDate || currentDate > this.model.maxDate) {
                        d.addClass('e-hidedate');
                        d.removeClass('current-month');
                        if (this.model.showOtherMonths) d.removeClass('other-month');
                        cond = _last = false;
                    }
                    if (thisMonth) {
                        if (cond && _first) {
                            this._tempMinDate = currentDate;
                            _first = false; _last = true;
                        }
                        if (_last) this._tempMaxDate = currentDate;
                    }
                    this._trigger("beforeDateCreate", { date: currentDate, value: this._formatter(currentDate, this.model.dateFormat), element: d });
                    r.append(d);
                    currentDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + 1, 0, 0, 0);
                }
                tbody.append(r);
            }
            calendarTable.append(tbody);
            if (this._DRPdisableFade) {
                $(tbody).css("display", "block");
                $(tbody).css({ display: "table-row-group", "vertical-align": "middle", "border-color": "inherit" });
            }
            else {
                (this._isIE8 || this._isIE7) ? $(tbody).css("display", "block") : $(tbody).fadeIn("fast");
            }
            if (this.model.startLevel === this.model.depthLevel)
                this._depthLevel(this.model.depthLevel);
            else if (this.model.depthLevel != "month" && this.model.depthLevel != "") {
                if (this.model.startLevel == "century")
                    this._depthLevel(this.model.depthLevel);
                else if (this.model.startLevel == "decade" && this.model.depthLevel != "century")
                    this._depthLevel(this.model.depthLevel);
                else if (this.model.startLevel == "year" && this.model.depthLevel != "decade" && this.model.depthLevel != "century")
                    this._depthLevel(this.model.depthLevel);
                else {
                    this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                    this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
                }
            }
            else {
                this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
            }

            this._otherMonthsVisibility();
            this._checkDateArrows();
        },

        _checkDisableRange: function (value) {
            if (!ej.isNullOrUndefined(this._disableCollection[value.getFullYear()]))
                if (jQuery.inArray(value.getMonth(), this._disableCollection[value.getFullYear()]) !== -1)
                    return true;
            return false;
        },
        _initDisableObj: function (disableDates) {
            this._disableCollection = {};
            for (var i = 0; i < this.model.blackoutDates.length; i++) {
                var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                if (dateObj) {
                    var year = dateObj.getFullYear();
                    var month = dateObj.getMonth();
                    if (ej.isNullOrUndefined(this._disableCollection[year])) this._disableCollection[year] = [];
                    if (jQuery.inArray(month, this._disableCollection[year]) == -1) this._disableCollection[year].push(month);
                }
            }
        },

        _disableDates: function (args) {
            for (var i = 0; i < this.model.blackoutDates.length; i++) {
                var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                if (dateObj && +args.date === +dateObj)
                    args.element.removeClass('current-month').addClass('e-hidedate');
            }
        },

        _keyboardNavigation: function (e) {
            if (this._animating) return false;
            if ((this._isOpen) && (e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                if (e.altKey) { if (e.keyCode == 13) { this._setCurrDate(e); return false; } else return; }
                var t = { row: null, col: null };

                t.col = this.sfCalendar.find('tbody tr td.e-state-hover').index();
                t.row = this.sfCalendar.find('tbody tr td.e-state-hover').parent().index();

                t.col = (t.col != -1) ? t.col + 1 : this.sfCalendar.find('tbody tr td.e-active').index() + 1;
                t.row = (t.row != -1) ? t.row + 1 : this.sfCalendar.find('tbody tr td.e-active').parent().index() + 1;

                var tableClass = this.sfCalendar.find('table')[0].className, next, rowLength = 3, colLength = 4;
                switch (tableClass) {
                    case "e-dp-viewallyears":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "yearall", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverAllYear = this.sfCalendar.find('tbody.e-datepicker-allyears tr td').index(next);
                        break;
                    case "e-dp-viewyears":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "year", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverYear = this.sfCalendar.find('tbody.e-datepicker-years tr td').index(next);
                        break;
                    case "e-dp-viewmonths":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "month", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverMonth = this.sfCalendar.find('tbody.e-datepicker-months tr td').index(next);
                        break;
                    case "e-dp-viewdays":
                        rowLength = this.sfCalendar.find('tbody.e-datepicker-days tr').length, colLength = 7;
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "day", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverDate = this._getDateObj(next).getDate() - 1;
                        break;
                }
                if (!e.ctrlKey) {
                    this.sfCalendar.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
            else if (!this.model.displayInline && (e.keyCode == 27 || e.keyCode == 9)) { this.hide(); }
            else if (e.altKey && e.keyCode == 40) { this.show(); return false; }
        },
        _changeRowCol: function (t, key, rows, cols, target, ctrlKey) {
            var eleClass, cls = { parent: null, child: null };
            switch (target) {
                case "day": eleClass = "tbody.e-datepicker-days tr td.current-month";
                    cls.parent = ".e-datepicker-days", cls.child = ".current-month";
                    break;
                case "month": eleClass = "tbody.e-datepicker-months tr td.e-current-month";
                    cls.parent = ".e-datepicker-months", cls.child = ".e-current-month";
                    break;
                case "year": eleClass = "tbody.e-datepicker-years tr td.e-current-year";
                    cls.parent = ".e-datepicker-years", cls.child = ".e-current-year";
                    break;
                case "yearall": eleClass = "tbody.e-datepicker-allyears tr td.e-current-allyear";
                    cls.parent = ".e-datepicker-allyears", cls.child = ".e-current-allyear";
                    break;
            }
            if (t.row <= 0 && t.col <= 0)
                return this.sfCalendar.find(eleClass + ':first');
            var cell, proxy = this;
            switch (key) {
                case 36:
                    return this.sfCalendar.find(eleClass + ':first');
                case 35:
                    return this.sfCalendar.find(eleClass + ':last');
                case 38:
                    if (ctrlKey && this.model.allowDrillDown) {
                        this._forwardNavHandler();
                    }
                    else if (t.row > 1) {
                        t.row -= 1;
                    }
                    else {
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "up");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):last');
                    }
                    return cell;
                case 37:
                    if (ctrlKey) {
                        this._processNextPrevDate(true);
                        return this.sfCalendar.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col > 1)
                        t.col -= 1;
                    else if (t.row > 1) {
                        t = { row: t.row - 1, col: cols }
                    }
                    else {
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':last');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "left");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':last');
                    }
                    return cell;
                case 39:
                    if (ctrlKey) {
                        this._processNextPrevDate(false);
                        return this.sfCalendar.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col < cols)
                        t.col += 1;
                    else if (t.row < rows) {
                        t = { row: t.row + 1, col: 1 }
                    }
                    else {
                        this._processNextPrevDate(false);
                        cell = this.sfCalendar.find(eleClass + ':first');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "right");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(false);
                        cell = this.sfCalendar.find(eleClass + ':first');
                    }
                    return cell;
                case 40:
                    if (!ctrlKey) {
                        if (t.row < rows) {
                            t.row += 1;
                        }
                        else {
                            this._processNextPrevDate(false);
                            cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):first');
                            return cell;
                        }
                        cell = this._getCell(t, cls);
                        if (cell.length <= 0) {
                            cell = this._findVisible(t, cls, "down");
                            if (cell !== null) return cell;
                            this._processNextPrevDate(false);
                            cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):first');
                        }
                        return cell;
                    }
                case 13:
                    var tclassName = $("table", this.sfCalendar).get(0).className, ele, element;
                    ele = this._getCell(t, cls); element = $(ele)[0];
                    if (tclassName == "e-dp-viewmonths" && this.model.startLevel == "year" && this.model.depthLevel == "year") {
                        this._dateValue = new Date(this._dateValue.setMonth(parseInt(element.attributes["index"].value)));
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else if ((tclassName == "e-dp-viewyears" && this.model.startLevel == "decade" && this.model.depthLevel == "decade") ||
                        (tclassName == "e-dp-viewallyears" && this.model.startLevel == "century" && this.model.depthLevel == "century")) {
                        this._dateValue = new Date(this._dateValue.setFullYear(parseInt(element.innerHTML)));
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else if (tclassName == "e-dp-viewdays") {
                        this._backwardNavHandler(ele);
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else
                        this._backwardNavHandler(ele);
                    break;
            }
            return this._getCell(t, cls);
        },
        _findVisible: function (t, cls, key) {
            var cols = t.col, rows = t.row, requiredClass = cls.child.slice(1, cls.child.length);
            for (i = 0; i >= 0; i++) {
                nextElement = this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td:nth-child(' + cols + ')');
                if (nextElement.length <= 0) {
                    return null;
                }
                if (nextElement.hasClass('e-hidedate') || !nextElement.is(":visible")) {
                    key == "right" || key == "left" ? (key == "right" ? cols++ : cols--) : (key == "down" ? rows++ : rows--);
                    if ((rows <= 0) || (rows > this.sfCalendar.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                    // Column exceeds the range. 
                    if (cols > this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length) {
                        //move to next row and select first column
                        rows++;
                        cols = 1;
                    }
                    if (cols <= 0) {
                        //move to previous row and select last column
                        rows--;
                        cols = this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length;
                    }
                    // Row exceeds the range.
                    if ((rows <= 0) || (rows > this.sfCalendar.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                } else if (nextElement.hasClass('other-month')) {
                    return null;
                } else if (nextElement.hasClass(requiredClass)) {
                    t.col = cols; t.row = rows;
                    return nextElement;
                }
            }
        },
        _getCell: function (t, cls) {
            return this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child + ':nth-child(' + t.col + ')');
        },
        _getDateObj: function (element) {
            return new Date(element.attr("date"));
        },
        _touchCalendar: function (e) {
            var tableClass = this.sfCalendar.find('table')[0].className;
            switch (e.type) {
                case "pinchin":
                    if (tableClass != "e-dp-viewdays")
                        this._keyboardNavigation({ keyCode: 13 });
                    break;
                case "pinchout":
                    if (tableClass != "e-dp-viewallyears" && this.model.allowDrillDown)
                        this._forwardNavHandler();
                    break;
                case "swipeleft":
                    this._processNextPrevDate(false);
                    break;
                case "swiperight":
                    this._processNextPrevDate(true);
                    break;
            }
        },

        show: function (e) {
            if (ej.isNullOrUndefined(this.sfCalendar)) this._renderPopup();
            if (this._isOpen) return false;
            var proxy = this;
            this._popupOpen = true;
            var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
            if (!this.model.enabled) return;
            if (!this.model.displayInline) this._setDatePickerPosition();
            if (this._trigger("beforeOpen", { element: this.sfCalendar, events: e })) return false;
            this.sfCalendar.attr({ 'aria-hidden': 'false' });
            proxy._isOpen = true;
            this.sfCalendar.slideDown(this.model.enableAnimation ? this.animation.open.duration : 0, function () {
                if (proxy.model && !proxy.model.displayInline)
                    $(document).on("mousedown", $.proxy(proxy._onDocumentClick, proxy));
            });
            if (this._isIE8){
                if(this.element.val() && this._compareDate(new Date(this.element.val()), previous)) this._updateInputVal();
            }
            else this._updateInputVal();
            this._refreshLevel(previous);
            this._trigger("open", { prevDate: previous, date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
			$(window).on("resize", $.proxy(this._OnWindowResize, this));
            if (!this.model.displayInline)
                this._on(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
                this._on(ej.getScrollableParents(this.wrapper), "touchmove", this.hide);
            this._isInputBox && this.wrapper.addClass("e-active");
        },


        hide: function (e) {
            if (!this._isOpen || this._getInternalEvents) return false;
            if (this._trigger("beforeClose", { element: this.sfCalendar, events: e })) return false;
            var proxy = this;
            this._popupOpen = false;
            this.sfCalendar.attr({ 'aria-hidden': 'true' });
            if (this._popClose && e != undefined && e.type != "click") {
                return;
            }
            this.sfCalendar.slideUp(this.model.enableAnimation ? this.animation.close.duration : 0, function () {
                proxy._isOpen = false;
                $(document).off("mousedown", $.proxy(proxy._onDocumentClick, proxy));
                proxy._setWaterMark();
            });
            if (this.element.val() != "") this._validateInputVal();
            this._trigger("close", { prevDate: this._prevDate, date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
            this._off(ej.getScrollableParents(this.wrapper), "touchmove", this.hide);
            this._isInputBox && this.wrapper.removeClass("e-active");
        },


        enable: function () {
            this.model.enabled = true;
            this.wrapper && this.wrapper.removeClass('e-disable');
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this.element.prop("disabled", false);
            if (this.dateIcon) this.dateIcon.removeClass('e-disable').attr({ "aria-disabled": false });
            if (this._isIE8 && this.dateIcon) this.dateIcon.children().removeClass("e-disable");
            this.element.prop("disabled", false);
            if (!this._isSupport)
                this._hiddenInput.prop("disabled", false);
            this.sfCalendar && this.sfCalendar.removeClass('e-disable').attr({ "aria-disabled": false });
        },


        disable: function () {
            this.model.enabled = false;
            this.wrapper && this.wrapper.addClass('e-disable');
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this.element.attr("disabled", "disabled");
            if (this.dateIcon) this.dateIcon.addClass('e-disable').attr({ "aria-disabled": true });
            if (this._isIE8 && this.dateIcon) this.dateIcon.children().addClass("e-disable");
            this.element.attr("disabled", "disabled");
            if (!this._isSupport)
                this._hiddenInput.attr("disabled", "disabled");
            this.sfCalendar && this.sfCalendar.addClass('e-disable').attr({ "aria-disabled": true });
            if (this._isOpen) {
                if (this.element.is(':input')) this.element.blur();
                if (!this.model.displayInline) this.hide();
            }
        },

        getValue: function () { return this._formatter(this.model.value, this.model.dateFormat); },

        _wireCalendarEvents: function () {
            this._allowQuickPick(this.model.allowDrillDown);
            this._on($('.e-next', this.sfCalendar), "click", $.proxy(this._previousNextHandler, this));
            this._on($('.e-prev', this.sfCalendar), "click", $.proxy(this._previousNextHandler, this));
            if (!this.model.displayInline) {
                this.sfCalendar.on("mouseenter touchstart", $.proxy(function () { this._popClose = true; }, this));
                this.sfCalendar.on("mouseleave touchend", $.proxy(function () { this._popClose = false; }, this));
            }
            if (this.model.showFooter)
                this._on($('.e-footer', this.sfCalendar), "click", this._setCurrDate);
            this.sfCalendar && this._on(this.sfCalendar, "pinchin pinchout swipeleft swiperight", $.proxy(this._touchCalendar, this));
        },

        _wireEvents: function () {
            if (this.element.is(":input") && (this.model.allowEdit)) {
                this._on(this.element, "blur", this._onFocusOut);
                this._on(this.element, "focus", this._onFocusIn);
                this._on(this.element, "keydown", this._onKeyDown);
            }

            if (!this.model.allowEdit) {
                this.element.attr("readonly", "readonly");
                this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
            }
        },
        _bindDateButton: function () {
            this._on(this.dateIcon, "mousedown", this._showDatePopUp);
            if (this.model.allowEdit)
                this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
        },
        _bindInputEvent: function () {
            this._off(this.dateIcon, "mousedown", this._showDatePopUp);
        },

        _specificFormat: function () {
            var parseInfo = ej.globalize._getDateParseRegExp(ej.globalize.findCulture(this.model.locale).calendar, this.model.dateFormat);
            return ($.inArray("dddd", parseInfo.groups) > -1 || $.inArray("ddd", parseInfo.groups) > -1)
        },

        _onFocusOut: function (e) {
            this._isFocused = false;
            var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
            this._validateOnFocusOut(this._validateValue(), e);
            this.wrapper.removeClass("e-focus");
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            if ((!this._isOpen || this.model.displayInline) && !this._setWaterMark() && !this._compareDate(this._preValue, this._parseDate(this.element.val(), this.model.dateFormat))) this._updateInputVal();
            if ((!this._isOpen || this.model.displayInline)) this._refreshLevel(previous);
            if (this.element.val() != "" && (!this._isOpen || this.model.displayInline)) { this._validateInputVal(); }
            this.element.off("keydown", $.proxy(this._keyboardNavigation, this));
            if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
            var _currentVal = this.element.val();
            var data = { prevDate: this._prevDate, value: _currentVal };
            if (this._specificFormat()) {
                if (this._prevDate != _currentVal)
                    this._setDateValue(_currentVal, true);
            }
            else
                this._setDateValue(_currentVal);
            if (!this.model.value) this._clearSelected();
            this._trigger("focusOut", data);
            this._checkErrorClass();
        },
        _onFocusIn: function (e) {
            if (this._isSupport) {
                e.preventDefault();
                this._isFocused = true;
            }
            this.wrapper.removeClass('e-error').attr('aria-invalid', "false");
            this.isValidState = true;
            this.wrapper.addClass("e-focus");
            this.wrapper.addClass('e-valid');
            if (this.model.readOnly)
                return;
            if (!this._isSupport) this._hiddenInput.css("display", "none");
            this.element.on("keydown", $.proxy(this._keyboardNavigation, this));
            if (!this.model.showPopupButton && !this.model.readOnly) this.show(e);
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
            this._trigger("focusIn", { date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
        },
        _elementClick: function (e) {
            if (!this._popupOpen) this.show(e);
        },
        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport)
                this._hiddenInput.css("display", "none");
        },
        _refreshPopup: function () {
            this._refreshDatepicker();
            this._startLevel(this.model.startLevel);
        },
        _refreshLevel: function (previous) {
            if ((this.model.startLevel == this.model.depthLevel) && this.model.startLevel != "month") {
                var val = this._stringToObject(this.element.val());
                val = this._validateYearValue(val);
                if (val)
                    if (!this._compareDate(previous, val))
                        this._refreshPopup();
            }
        },
        _validateOnFocusOut: function (val, e) {
            var dateVal = this._preValue != null ? this._calendarDate : this._preValue;
            var calenderDate = this._formatter(dateVal, this.model.dateFormat);
            if (this._specificFormat() && (val > this.model.minDate) && (val < this.model.maxDate)) {
                if (val == null) this.model.value = dateVal
                else {
                    this.model.value = val;
                    var currDate = this._formatter(val, this.model.dateFormat, this.model.locale);
                }
            }
            else var currDate = this._formatter(this._parseDate((this._formatter(new Date(), "MM/dd/yyyy"))), this.model.dateFormat);
            var dateChange = false, valueExceed = false;
            if (val != null && !this.model.enableStrictMode) {
                if (ej.isNullOrUndefined(this.model.value))
                    this.model.value = this._parseDate(this.element.val());
                if (this.model.maxDate < this.model.minDate) this.model.minDate = this.model.maxDate;
                if (!this.model.enableStrictMode) {
                    if (val) {
                        if ((val < this.model.minDate) || (val > this.model.maxDate)) {
                            dateChange = true,
                            this._calendarDate = val = val < this.model.minDate ? this.model.minDate : this.model.maxDate
                        }
                    }
                    else {
                        this.element.val("");
                        if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                        else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                    }
                    this.isValidState = true;
                }
                if (dateChange) this.element.val(this._formatter(val, this.model.dateFormat));
                if (!this._compareDate(this._preValue, this._parseDate(this.element.val(), true))) this._triggerChangeEvent(e);
            }
            else if (val == null && !this.model.enableStrictMode) {
                if (this._preTxtValue == null || this.element.val() == "") {
                    this.element.val("");
                    if (!this._isSupport) this._hiddenInput.css("display", "block");
                } else
                    this.element.val(calenderDate);
                this._triggerChangeEvent(e);
            }
            else {
                if (val) {
                    if ((val < this.model.minDate) || (val > this.model.maxDate)) {
                        this.isValidState = false, valueExceed = true,
                        this._calendarDate = val < this.model.minDate ? this.model.minDate : this.model.maxDate
                    }
                    else
                        this.isValidState = true;
                    this._triggerChangeEvent(e);
                    if (valueExceed && this._getInternalEvents) this._trigger("outOfRange");
                }
                else {
                    this.isValidState = false;
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
            }
        },
        _onKeyDown: function (e) {
            if (e.keyCode === 13) {
                var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
                this._validateOnFocusOut(this._validateValue(), e);
                if ((!this._isOpen || this.model.displayInline) && !this._setWaterMark() && !this._compareDate(this._preValue, this._parseDate(this.element.val(), this.model.dateFormat))) this._updateInputVal();
                if ((!this._isOpen || this.model.displayInline)) this._refreshLevel(previous);
                if (this.element.val() != "" && (!this._isOpen || this.model.displayInline)) { this._validateInputVal(); }
                this._checkErrorClass();
            }
        },
        _showhidePopup: function (e) {
            if (!this.model.enabled) return false;
            if (this._isOpen) {
                if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) this.element.focus();
                if (!this._cancelValue) this.hide(e);
            }
            else {
                if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) this.element.focus();
                this.show(e);
            }
        },
        _compareDate: function (first, second) {
            var result = (+first === +second) ? true : false;
            return result;
        },
        _validateDate: function (val) {
            var result = true;
            if (val != null) {
                for (var i = 0; i < this.model.blackoutDates.length; i++) {
                    var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                    if (dateObj && +val === +dateObj)
                        result = false;
                }
                if ((val < this.model.minDate || val > this.model.maxDate) && this.model.enableStrictMode) {
                    result = false;
                    this.isValidState = false;
                }
            }

            return result;
        },

        _triggerChangeEvent: function (e) {
            var currentValue;
            var _currentVal = this.element.val() == "" ? null : this.element.val();
            this._prevDate = this._formatter(this._preValue, this.model.dateFormat);
            var data = { prevDate: this._prevDate, value: _currentVal, isInteraction: !!e };
            if (this._specificFormat() && e != undefined && e.type == "keydown" && this._formatter(this._preValue, this.model.dateFormat, this.model.locale) != this.element.val())
                currentValue = this._parseDate(this.element.val(), true);
            else if ((this._specificFormat() && e != undefined && e.type == "blur"))
                currentValue = this.model.value;
            else currentValue = this._parseDate(_currentVal);
            currentValue = this._validateYearValue(currentValue);
            if (!this._validateDate(currentValue)) currentValue = null;
            if (!this._compareDate(this._preValue, currentValue)) {
                this._preValue = this.model.value = currentValue;
                data.value = this._formatter(this.model.value, this.model.dateFormat);
                if (this.model.value) this._clickedDate = this._calendarDate = this.model.value;
                if (this.model.displayInline && !this._isInputBox) this._hiddenInput.attr('value', _currentVal);
                if (!this.model.value && !this.model.enableStrictMode) this._setDateValue(this.model.value);
                data.value = _currentVal;
                this._trigger("_change", data);
                data.value = this._formatter(this.model.value, this.model.dateFormat);
                this._trigger("change", data);
                this._checkErrorClass();
            }
            else if (!(this.element.val() == "" && this._prevDate == null) && this.element.val() != this._prevDate) {
                data.value = this.element.val();
                this._trigger("_change", data);
            }
        },

        _triggerSelectEvent: function (e) {
            var val = this.element.val();
            if (this._parseDate(val)) {
                var data = { prevDate: this._prevDate, date: this.model.value, value: val, isSpecialDay: this._isSpecialDates(this.model.value) };
                if (this._prevDate != val) {
                    if (this._parseDate(data.value) && (this.model.value >= this.model.minDate && this.model.value <= this.model.maxDate)) {
                        this._cancelValue = this._trigger("select", data);
                    }
                }
                if (this._dt_drilldown) this._trigger("dt_drilldown", data);
            }
        },

        _onDocumentClick: function (e) {
            if (this.model) {
                if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-popup").is(this.popup) &&
                    !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-datewidget").is(this.wrapper)) {
                    this.hide(e);
                }
                else if ($(e.target).is(this.popup) || $(e.target).parents(".e-popup").is(this.popup)) {
                    e.preventDefault();
                }
            }
        },

        _OnWindowResize: function (e) {
            if (this.sfCalendar) this._setDatePickerPosition();
        },

        _showDatePopUp: function (e) {
            var isRightClick = false;
            if (e.button)
                isRightClick = (e.button == 2);
            else if (e.which)
                isRightClick = (e.which == 3); //for Opera
            if (isRightClick) return;
            if (!this._isSupport && !this.model.showPopupButton) {
                e.preventDefault();
                this._onFocusIn();
            }
            if (this.model.readOnly) return;
            e.preventDefault();
            if (!this.model.enabled && this.model.displayInline) return false;
            this._showhidePopup(e);
        },
        _layoutChanged: function (e) {
            // this event internally used to observe the layout change in "DateTimePicker" control
            if (this._getInternalEvents) this._trigger("layoutChange");
        },
        _setCurrDate: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e) e.preventDefault();
            var proxy = this;
            this._prevDate = this._formatter(this.model.value, this.model.dateFormat);
            this._dateValue = this._zeroTime(new Date());
            this.model.value = this._calendarDate = new Date(this._dateValue.toString());
            this._setDateValue(this.model.value);
            this._triggerSelectEvent(e);
            this._triggerChangeEvent(e);
            this._refreshDatepicker();
            this._changeDayClass();
            this._startLevel(this.model.startLevel);
            this._onSetCancelDateHandler(e);
            this._layoutChanged();
        },
        _changeDayClass: function () {
            var className = this.popup.children("table")[0].className;
            if (className != "e-dp-viewdays") {
                this.popup.children("table").removeClass(className).addClass("e-dp-viewdays");
            }
        },

        _onSetCancelDateHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && ($(e.target).hasClass("e-disable") || $(e.target).hasClass("e-hidedate"))) return false;
            if (e && e.type) e.preventDefault();
            if (this._specificFormat()) this._prevDate = this.element.val();
            else this.model.value = this._parseDate(this.element.val());
            this._prevDate = this._formatter(this.model.value, this.model.dateFormat);
            this._setDateValue(this._dateValue);
            this._triggerSelectEvent(e);
            this._triggerChangeEvent(e);
            this._dateValue = new Date(this.model.value.toString());
            if (this.element.is(':input') && !this.model.displayInline) {
                this._showhidePopup(e);
            }
            if (e && $(e.currentTarget).hasClass("other-month"))
                this._refreshDatepicker();
            this._cellSelection();
        },
        _closeCalendar: function (ele) {
            if (!ele || ele == this.element) {
                this.sfCalendar.empty().remove();
            }
        },
        //Error class for input value validation
        _checkErrorClass: function () {
            if (this.wrapper) {
                if (this.isValidState) this.wrapper.removeClass("e-error").attr('aria-invalid', "false");
                else this.wrapper.addClass("e-error").attr('aria-invalid', "true");
            }
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });

    ej.DatePicker.Locale = ej.DatePicker.Locale || {};

    ej.DatePicker.Locale['default'] = ej.DatePicker.Locale['en-US'] = {
        watermarkText: "Select date",
        buttonText: 'Today'
    };


    ej.DatePicker.Header = {
        /**  Removes the day header */
        None: "none",
        /**  Shows the day header format in short like Sun, Mon, Tue … */
        Short: "short",
        /**  Shows the day header format in min like Su, Mo, Tu … */
        Min: "min",
        /**  Shows the day header format in long like Sunday, Monday, Tuesday … */
        Long: "long"
    };

    ej.DatePicker.HighlightSection = {
        /**  Highlight the Current Month. */
        Month: "month",
        /**  Highlight the Current Week. */
        Week: "week",
        /**  Highlight the Current WorkDays. */
        WorkDays: "workdays",
        /** Don't Highlight Anything. */
        None: "none"
    };


    ej.DatePicker.Level = {
        /**  Starts from month level view. */
        Month: "month",
        /**  Starts from year level view. */
        Year: "year",
        /**  Starts from year decade level view. */
        Decade: "decade",
        /**  Starts from century level view.  */
        Century: "century"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to craete a Timepicker with the Html input element
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejTimePicker", "ej.TimePicker", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _rootCSS: "e-timepicker",
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },

        defaults: {

            cssClass: "",

            timeFormat: "",

            value: null,
            
			enableAnimation: true,

            locale: "en-US",

            htmlAttributes: {},

            readOnly: false,

            showPopupButton: true,

            enableStrictMode: false,

            interval: 30,

            hourInterval: 1,

            minutesInterval: 1,

            secondsInterval: 1,

            height: "",

            width: "",

            minTime: "12:00 AM",

            maxTime: "11:59 PM",

            showRoundedCorner: false,

            enableRTL: false,

            popupHeight: "191px",

            popupWidth: "auto",

            enabled: true,

            enablePersistence: false,

            disableTimeRanges: null,

            validationRules: null,

            validationMessages: null,

            focusIn: null,

            focusOut: null,

            beforeChange: null,

            change: null,

            select: null,

            create: null,

            destroy: null,

            beforeOpen: null,

            open: null,

            close: null
        },


        dataTypes: {
            timeFormat: "string",
            minTime: "string",
            maxTime: "string",
            readOnly: "boolean",
            interval: "number",
            showPopupButton: "boolean",
            locale: "string",
            hourInterval: "number",
            minutesInterval: "number",
            secondsInterval: "number",
            enabled: "boolean",
            enablePersistence: "boolean",
            enableAnimation: "boolean",
            enableStrictMode: "boolean",
            disableTimeRanges: "data",
            htmlAttributes: "data",
            validationRules: "data",
            validationMessages: "data",
        },

        observables: ["value"],

        enable: function () {
            if (!this.model.enabled) {
                this.element[0].disabled = false;
                this.element.prop("disabled", false);
                this.model.enabled = true;
                this.wrapper.removeClass('e-disable');
                this.element.removeClass("e-disable").attr("aria-disabled", false);
                if (this.model.showPopupButton) {
                    this.timeIcon.removeClass("e-disable").attr("aria-disabled", false);
                    this.popupList.removeClass("e-disable").attr("aria-disabled", false);
                }
                if (this._isIE8) this.timeIcon.children().removeClass("e-disable");
            }
        },


        disable: function () {
            if (this.model.enabled) {
                this.element[0].disabled = true;
                this.model.enabled = false;
                this.element.attr("disabled", "disabled");
                this.wrapper.addClass('e-disable');
                this.element.addClass("e-disable").attr("aria-disabled", true);
                if (this.model.showPopupButton) {
                    this.timeIcon.addClass("e-disable").attr("aria-disabled", true);
                    this.popupList.addClass("e-disable").attr("aria-disabled", true);
                }
                if (this._isIE8) this.timeIcon.children().addClass("e-disable");
                this._hideResult();
            }
        },


        getValue: function () {
            return this.element.val();
        },


        setCurrentTime: function () {
            if (!this.model.readOnly) this._setMask();
        },

        show: function () {
            (!this.showDropdown && !this._getInternalEvents) && this._showResult();
        },

        hide: function () {
            (this.showDropdown) && this._hideResult();
        },


        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },

        _timeFormat: function (format) {
            if (!format)
                format = ej.preferredCulture(this.model.locale).calendars.standard.patterns.t;
            var validatedformat = this._validateTimeFormat(format);
            if (validatedformat) {
                this.model.timeFormat = validatedformat;
                // Only change the format when model is not null.   
                this.model.minTime = ej.format(this._createObject(this._minTimeObj), this.model.timeFormat, this.model.locale);
                this.model.maxTime = ej.format(this._createObject(this._maxTimeObj), this.model.timeFormat, this.model.locale);

                if (this.model.value) {
                    this._setModelOption = true;
                    this.model.value = this._localizeTime(this.model.value);
                    this.element.val(this.model.value);
                }
                else {
                    this._setModelOption = false;
                    var timeValue = this._localizeTime(this.element.val());
                    if (timeValue && this._checkMinMax(timeValue)) {
                        this.model.value = timeValue;
                        this.element.val(timeValue);
                    }
                }
            }
            return validatedformat;
        },

        _getTimeFormat: function () {
            this.model.timeFormat = ej.preferredCulture(this.model.locale).calendar.patterns.t || "h:mm tt";
            this.seperator = this._getSeperator();
        },

        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            if (this.popupList) this.popupList.removeClass(this.model.cssClass).addClass(skin);
        },

        _localize: function (culture) {
            var currentTime = this._createObject(this.model.value, true);
            this.model.locale = culture;
            this._getTimeFormat();

            this.model.minTime = ej.format(this._createObject(this._minTimeObj), this.model.timeFormat, this.model.locale);
            this.model.maxTime = ej.format(this._createObject(this._maxTimeObj), this.model.timeFormat, this.model.locale);

            if (currentTime) {
                this.model.value = this._localizeTime(currentTime);
                this.element.val(this.model.value);
            }
            else {
                currentTime = this._localizeTime(this.element.val());
                if (currentTime && this._checkMinMax(currentTime)) {
                    this.model.value = currentTime;
                    this.element.val(currentTime);
                }
            }
            this._getAmPm();
        },
        _setLocalize: function (culture) {
            var culture = ej.preferredCulture(culture);
            if (culture) {
                this.model.locale = culture.name == "en" ? "en-US" : culture.name;
                if (!ej.isNullOrUndefined(this._options) && (ej.isNullOrUndefined(this._options.timeFormat) || (!this._options.timeFormat)))
                    this.model.timeFormat = ej.preferredCulture(this.model.locale).calendars.standard.patterns.t;
            }
        },
        _updateInput: function () {
            if (ej.isNullOrUndefined(this._options)) return;
            var value = this._localizeTime(this._options.value);
            if (!ej.isNullOrUndefined(value))
                if (typeof value === "string" && this.model.enableStrictMode && !this.model.value) {
                    this.element.val(this._options.value);
                    this.isValidState = (this.element.val() == "") ? true : false;
                    this._checkErrorClass();
                }
        },
        _createMinMaxObj: function () {
            // create minTime object
            this._minTimeObj = this._createObject(this.model.minTime);
            if (!this._minTimeObj)
                this.model.minTime = ej.format(this._createObject(new Date().setHours(0, 0, 0, 0)), this.model.timeFormat, this.model.locale);

            // create maxTime object
            this._maxTimeObj = this._createObject(this.model.maxTime);
            if (!this._maxTimeObj)
                this.model.maxTime = ej.format(this._createObject(new Date().setHours(23, 59, 59, 59)), this.model.timeFormat, this.model.locale);
        },
        _setMinMax: function () {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var maxval = new Date().setHours(23, 59, 59, 59);
            if (!ej.isNullOrUndefined(this._options) && ej.isNullOrUndefined(this._options.minTime))
                this.model.minTime = ej.format(this._createObject(minVal), this.model.timeFormat, this.model.locale);
            if (!ej.isNullOrUndefined(this._options) && ej.isNullOrUndefined(this._options.maxTime))
                this.model.maxTime = ej.format(this._createObject(maxval), this.model.timeFormat, this.model.locale);
            this._createMinMaxObj();
        },
        _init: function (options) {
            this._options = options;
            this._cloneElement = this.element.clone();
            this._ISORegex();
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            this._initialize();
            this._render();
            this._wireEvents();
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
            this._updateInput();
            this._updateTextbox();
            if (this.model.validationRules != null) {
                this._initTimeValidator();
                this._setTimeValidation();
            }

        },
        _updateTextbox: function () {
            if (this._options === undefined || (this._options.value === undefined && !this.model.value))
                this._setTime(this._localizeTime(this.model.minTime));
        },

        _setMinMaxTime: function (prev, options) {
            if (!ej.isNullOrUndefined(options["minTime"]) && $.trim(options["minTime"]) && this._isValid(options["minTime"])) {
                this.model.minTime = options["minTime"];
                this._minTimeObj = this._createObject(this.model.minTime);
                this._validateTimes();
            }
            if (!ej.isNullOrUndefined(options["maxTime"]) && $.trim(options["maxTime"]) && this._isValid(options["maxTime"])) {
                this.model.maxTime = options["maxTime"];
                this._maxTimeObj = this._createObject(this.model.maxTime);
                this._validateTimes();
            }

            this._validateMinMax();
            this._createMinMaxObj();
            if (!ej.isNullOrUndefined(options["minTime"])) options["minTime"] = this.model.minTime;
            if (!ej.isNullOrUndefined(options["maxTime"])) options["maxTime"] = this.model.maxTime;
            if (!this._checkMinMax(this.model.value)) {
                if (!this.model.enableStrictMode) {
                    if (this.model.minTime && !this._compareTime(this.model.value, this.model.minTime, true))
                        this.model.value = this.model.minTime;
                    if (this.model.maxTime && !this._compareTime(this.model.maxTime, this.model.value, true))
                        this.model.value = this.model.maxTime;
                }
                else {
                    this.isValidState = false;
                    this.model.value = null;
                }
            }
            if (prev !== this.model.value && this._isValid(this.model.value, true))
                this.element.val(this.model.value);
        },
        _setModel: function (options) {
            var change = false, prev = this.model.value;
            for (var option in options) {
                switch (option) {
                    case "timeFormat":
                        var prevTime = this._createObject(this.model.value);
                        this._preTimeformat = this.model.timeFormat;
                        var newFormat = this._timeFormat(options[option]);
                        options[option] = this.model.timeFormat;
                        if (newFormat)
                            this.seperator = this._getSeperator();
                        var currentTime = this._createObject(this.model.value);
                        change = (+prevTime === +currentTime) ? false : true;
                        break;
                    case "locale":
                        var prevTime = this._createObject(this.model.value);
                        this._localize(options[option]);
                        this.model.minTime = ej.format(this._createObject(this._minTimeObj), this.model.timeFormat, this.model.locale);
                        this.model.maxTime = ej.format(this._createObject(this._maxTimeObj), this.model.timeFormat, this.model.locale);
                        var currentTime = this._createObject(this.model.value);
                        change = (+prevTime === +currentTime) ? false : true;
                        break;
                    case "interval":
                        this.model.interval = options[option];
                        break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "enableRTL": this._setRtl(options[option]); break;
                    case "height":
                        this._setHeight(options[option]); break;
                    case "width":
                        this.wrapper.width(options[option]);
                        this._setListWidth();
                        break;
                    case "value":
                        if (ej.isPlainObject(options[option])) options[option] = null;
                        this.model.value = ej.format(this._createObject(options[option], true), this.model.timeFormat, this.model.locale);
                        this._ensureValue();
                        this._enableMask();
                        if (this.model.enableStrictMode && !this._isValid(options[option], true)) {
                            var tval = this._isValid(options[option]) ? this._localizeTime(options[option]) : options[option];
                            this.element.val(tval);
                        }
                        options[option] = this.model.value;
                        change = true;
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = options[option];
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initTimeValidator();
                            this._setTimeValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initTimeValidator();
                            this._setTimeValidation();
                        }
                        break;
                    case "popupHeight": this.model.popupHeight = options[option]; this._setListHeight(); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "enabled": if (options[option]) this.enable(); else this.disable(); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "disableTimeRanges":
                        this.model.disableTimeRanges = options[option];
                        this._initStartEnd();
                        this.model.value = ej.format(this._createObject(this.element.val(), true), this.model.timeFormat, this.model.locale);
                        this._ensureValue();
                        this._enableMask();
                        if (this.model.enableStrictMode && !this._isValid(this.element.val(), true))
                            this.element.val(this.element.val());
                        change = true;
                }
            }
            if (!ej.isNullOrUndefined(options["minTime"]) || !ej.isNullOrUndefined(options["maxTime"])) {
                this._setMinMaxTime(prev, options);
                change = true;
            }
            if (!ej.isNullOrUndefined(options["showPopupButton"]))
                this._showButton(options[option]);
            else if (this.model.showPopupButton && (newFormat || !ej.isNullOrUndefined(options["minTime"]) || !ej.isNullOrUndefined(options["maxTime"]) ||
                   !ej.isNullOrUndefined(options["locale"]) || !ej.isNullOrUndefined(options["interval"]) || !ej.isNullOrUndefined(options["disableTimeRanges"]))) {
                this._reRenderDropdown();
            }
            if (change) {
                this._raiseChangeEvent(prev, true);
                options["value"] = this.model.value;
            }
            this._checkErrorClass();
        },


        _destroy: function () {
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            this.element.removeClass("e-input").removeAttr("ondragstart draggable aria-atomic aria-live aria-readonly").val(this.element.attr("value"));
            if (!this._cloneElement.attr('name')) this.element.removeAttr('name');
            if (this.popupList) this.popupList.remove();
        },

        _initialize: function () {
            this.target = this.element[0];
            this.timeIcon = null;
            this._disabledItems = [];
            this.popupList = null;
            this.focused = false;
            this.start = 0;
            this.end = 0;
            this.min = null;
            this.max = null;
            this.incomplete = false;
            this.downPosition = 0;
            this._setLocalize(this.model.locale);
            this._setMinMax();
            this._getAmPm();
            this.showDropdown = false;
            this._activeItem = 0;
            this.isValidState = true;
            this._manualFocus = false;
            this._isIE7 = this._checkIE7();
            this._initStartEnd();
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "")
                this.model.value = this.element[0].value;
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            // _getInternalEvents is used when TimePicker used as a subcontrol of DateTimePicker 
            this._getInternalEvents = false;
            this._dateTimeInternal = false;
            if (!this.model.timeFormat) this._getTimeFormat();
            else this.seperator = this._getSeperator();
        },

        _render: function () {
            this._renderWrapper();
            this._setDimentions();
            this._renderTimeIcon();
            this._validateTimes();
            this._createMinMaxObj();
            this._renderDropdown();
            this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
            this._enableMask();
            this._checkErrorClass();
            this.element.attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', "aria-readonly": this.model.readOnly, "value": this.model.value });
            if (this.model.showPopupButton || !ej.isNullOrUndefined(this.popupList))
                this.ul.find("li").attr({ 'tabindex': -1, 'aria-selected': false });
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.addClass('e-valid') : this.wrapper.removeClass('e-valid');
        },

        _renderWrapper: function () {
            this.element.addClass("e-input").attr("tabindex", "0");
            this.wrapper = ej.buildTag("span.e-timewidget e-widget " + this.model.cssClass + "#" + this.target.id + "_timewidget").insertAfter(this.element);
            this.wrapper.attr("style", this.element.attr("style"));
            this.element.removeAttr('style');
            if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readOnly" && value == "readOnly") proxy.model.readOnly = true;
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);

            });
        },
        _initTimeValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setTimeValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _renderTimeIcon: function () {
            if (this.model.showPopupButton) {
                this.timeIcon = ej.buildTag("span.e-select").attr({ 'role': 'button', 'aria-label': 'select' });
                var icon = ej.buildTag("span.e-icon e-clock").attr('role', 'presentation');
                if (this._isIE8) {
                    this.timeIcon.attr("unselectable", "on");
                    icon.attr("unselectable", "on");
                }
                this.timeIcon.append(icon);
                this.container.append(this.timeIcon).addClass("e-padding");
                this._on(this.timeIcon, "mousedown", this._timeIconClick);
            }

        },
        _elementClick: function (e) {
            if (!this.showDropdown) this._showResult();
        },
        _renderDropdown: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            if (!this.model.showPopupButton || this.popupList) return false;
            this.popupList = ej.buildTag("div.e-time-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.target.id + "_popup", "", {}, { 'tabindex': 0, 'aria-activedescendant': '' });
            if (!ej.isTouchDevice()) this.popupList.addClass('e-ntouch');
            this.popup = this.popupList;
            this.ul = ej.buildTag("ul.e-ul");
            if (this._isIE8)
                this.ul.attr("unselectable", "on");
            var scrollDiv = ej.buildTag("div").append(this.ul);
            $('body').append(this.popupList.append(scrollDiv));
            this._renderLiTags();
            this._setListHeight();
            this._setListWidth();
            this.popupList.ejScroller({ height: this.popupList.height(), width: 0, scrollerSize: 20 });
            this.scrollerObj = this.popupList.ejScroller("instance");
            this.popupList.css("display", "none");
            this._listSize = this.ul.find("li").length;
        },
        _renderLiTags: function () {
            this._disabledItems = [];
            var start, end, timeVal, interval = this.model.interval * 60000;
            // Maintain the min and max time as object;
            var disableTime = (!ej.isNullOrUndefined(this.model.disableTimeRanges) && this.model.disableTimeRanges.length > 0) ? true : false;
            start = this._minTimeObj;
            end = this._maxTimeObj;
            var i = 0;
            while (this._compareTime(end, start, true)) {
                timeVal = this._localizeTime(start);
                var litag = $(document.createElement('li'));
                litag[0].appendChild(document.createTextNode(timeVal));
                if (this._isIE8) litag.attr("unselectable", "on");
                if (disableTime) {
                    if (this._ensureTimeRange(timeVal)) {
                        litag.addClass('e-disable');
                        this._disabledItems.push(i);
                    }
                    else {
                        litag.removeClass('e-disable');
                    }
                }
                this.ul[0].appendChild(litag[0]);
                start = new Date(start).getTime() + interval;
                i++;
            }

            var liTags = this.ul.find("li");
            if (!ej.isTouchDevice()) {
                this._on(liTags, "mouseenter", $.proxy(this._OnMouseEnter, this));
                this._on(liTags, "mouseleave", $.proxy(this._OnMouseLeave, this));
            }
            this._on(liTags, "click", $.proxy(this._OnMouseClick, this));
        },
        _ensureTimeRange: function (value) {
            if (!ej.isNullOrUndefined(this.model.disableTimeRanges)) {
                var timeVal = this._makeDateTimeObj(value);
                for (var i = 0; i < this.model.disableTimeRanges.length; i++) {
                    if (+timeVal >= +this._makeDateTimeObj(this.model.disableTimeRanges[i].startTime) && +timeVal <= +this._makeDateTimeObj(this.model.disableTimeRanges[i].endTime))
                        return true;
                }
            }
            return false;
        },
        _initStartEnd: function () {
            this._startTime = [];
            this._endTime = [];
            if (!ej.isNullOrUndefined(this.model.disableTimeRanges)) {
                for (var i = 0; i < this.model.disableTimeRanges.length; i++) {
                    this._startTime[i] = this._makeDateTimeObj(this.model.disableTimeRanges[i].startTime);
                    this._endTime[i] = this._makeDateTimeObj(this.model.disableTimeRanges[i].endTime);
                }
            }
        },
        _makeDateTimeObj: function (value) {
            if (typeof value === "string") {
                var dateFormat = ej.preferredCulture(this.model.locale).calendar.patterns.d;
                var dateValue = ej.format(new Date("1/1/2000"), dateFormat, this.model.locale);
                var obj = ej.parseDate(dateValue + " " + value, dateFormat + " " + this.model.timeFormat);
                if (!obj) {
                    var isJSONString = new Date(value);
                    if (!isNaN(Date.parse(isJSONString)) && !ej.isNullOrUndefined(value))
                        return this._setEmptyDate(value);
                    else
                        obj = new Date("1/1/2000 " + value);
                }
                return obj;
            }
            else if (value instanceof Date)
                return this._setEmptyDate(value);
            else return null;
        },
        _reRenderDropdown: function () {
            this.ul.empty();
            this._renderLiTags();
            this._refreshScroller();
            this._changeActiveEle();
        },
        _refreshScroller: function () {
            var flag = this.popupList.css("display") == "none" ? true : false;
            this.popupList.css("height", "auto");
            this.popupList.find(".e-content, .e-vscroll").removeAttr("style");
            this.popupList.find(".e-vscroll div").removeAttr("style");

            if (flag) this.popupList.css("display", "block");
            this.scrollerObj.model.height = this.popupList.height();
            this.scrollerObj.model.scrollTop = 0;
            this.scrollerObj.refresh();
            if (this._isIE8) {
                $("#" + this.scrollerObj._id).children('.e-vscroll').children().attr("unselectable", "on");
                $("#" + this.scrollerObj._id).find('.e-vhandle').attr("unselectable", "on");
            }
            if (flag) this.popupList.css("display", "none");
        },

        _setListWidth: function () {
            if (this.popupList) {
                var width = this.model.popupWidth;
                if (width && width != "auto") this.popupList.css({ "width": width });
                else this.popupList.css({ "width": this.wrapper.width() });
            }
            if (this.scrollerObj) {
                this._refreshScroller();
                this._updateScrollTop();
            }
        },
        _setListHeight: function () {
            if (this.popupList) this.popupList.css({ "max-height": this.model.popupHeight || "191px" });
            if (this.scrollerObj) {
                this._refreshScroller();
                this._updateScrollTop();
            }
        },
        _updateScrollTop: function () {
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
        },
        _refreshPopup: function () {
            if (this.model.popupWidth == "auto") this.popupList.css({ "width": this.wrapper.width() });
            this._setListPosition();
            this._refreshScroller();
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupList.outerHeight(),
            popupWidth = this.popupList.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupList.outerWidth() - elementObj.outerWidth();
            this.popupList.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupList);
        },

        _enableMask: function () {
            var flag = false;
            if ((this.model.minTime && this._compareTime(this.model.minTime, this.model.value)) ||
                this.model.maxTime && this._compareTime(this.model.value, this.model.maxTime))
                this.isValidState = false;
            else this.isValidState = true;
            this._setTime(this.model.value);
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            if (this._getInternalEvents && !this.isValidState) this._trigger("outOfRange");
            this._changeActiveEle();
            this._preVal = this.element.val();
        },
        _setTime: function (time) {
            var modifiedTime = this._localizeTime(time);
            this.element.val(modifiedTime);
            if (this.model.enableStrictMode) {
                this.model.value = (this._compareTime(this.model.value, this.model.minTime) && this._compareTime(this.model.maxTime, this.model.value)) ? modifiedTime : null;
            } else {
                this.model.value = modifiedTime;
            }
        },
        _timeFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _setMask: function () {
            this.model.value = new Date();
            this._enableMask();
        },

        _validateTimes: function () {
            var validatedformat = this._validateTimeFormat(this.model.timeFormat);
            if (validatedformat) this.model.timeFormat = validatedformat;
            else this.model.timeFormat = "h:mm tt";
            if (!this._isValid(this.model.minTime)) this.model.minTime = "12:00 AM";
            if (!this._isValid(this.model.maxTime)) this.model.maxTime = "11:59 PM";
            if (!this._isValid(this.model.value, true)) this.model.value = null;
            if (!this._checkMinMax(this.model.value) && !this.model.enableStrictMode) {
                if (this.model.minTime && !this._compareTime(this.model.value, this.model.minTime, true))
                    this.model.value = this.model.minTime;
                if (this.model.maxTime && !this._compareTime(this.model.maxTime, this.model.value, true))
                    this.model.value = this.model.maxTime;
            }
            this._validateMinMax();
        },
        _ensureValue: function () {
            if (!this._checkMinMax(this.model.value) && this._isValid(this.model.value, true)) {
                if (!this.model.enableStrictMode) {
                    if (this.model.minTime && !this._compareTime(this.model.value, this.model.minTime, true))
                        this.model.value = this.model.minTime;
                    if (this.model.maxTime && !this._compareTime(this.model.maxTime, this.model.value, true))
                        this.model.value = this.model.maxTime;
                }
                else
                    this.isValidState = false;
            }
        },
        _validateMinMax: function () {
            if (this.model.minTime && this.model.maxTime && this._compareTime(this.model.minTime, this.model.maxTime)) {
                this.model.minTime = this.model.maxTime;
            }
        },
        _checkProperties: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                this.disable();
            }
            else if (this.model.enabled && this.element.hasClass("e-disable")) {
                this.model.enabled = false;
                this.enable();
            }
            this._addProperty();
            this._checkAttributes();
        },
        _addProperty: function () {
            this._setRtl(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
        },
        _setRtl: function (boolean) {
            if (boolean) {
                this.wrapper.addClass("e-rtl");
                if (this.popupList) this.popupList.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                if (this.popupList) this.popupList.removeClass("e-rtl");
            }
        },
        _setRoundedCorner: function (boolean) {
            if (boolean) {
                this.container.addClass("e-corner");
                if (this.popupList) this.popupList.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                if (this.popupList) this.popupList.removeClass("e-corner");
            }
        },
        _showButton: function (show) {
            this.model.showPopupButton = show;
            if (show) {
                this.container.addClass("e-padding");
                this._renderTimeIcon();
                this._renderDropdown();
                this._addProperty();
            }
            else {
                this.container.removeClass("e-padding");
                this.timeIcon.remove();
                this.popupList.remove();
                this.timeIcon = this.popupList = null;
                $(document).off("mousedown", $.proxy(this._OnDocumentClick, this));
            }
        },
        _checkAttributes: function () {
            if (!this.element.attr("name"))
                this.element.attr({ "name": this.element[0].id });
            if ('ondragstart' in document.createElement('input'))
                this.element.attr({ "ondragstart": "return false" });
            if ('draggable' in document.createElement('input'))
                this.element.attr({ "draggable": "false" });
        },

        _getAmPm: function () {
            var dateObj = new Date();
            dateObj.setHours(0);
            this.ttAM = $.trim(this._localizeMeridian(dateObj));
            dateObj.setHours(23);
            this.ttPM = $.trim(this._localizeMeridian(dateObj));
        },

        _setDimentions: function () {
            if (!this.model.height) this.model.height = this.element.attr("height"); if (!this.model.width) this.model.width = this.element.attr("width");
            this._setHeight(this.model.height);
            if (this.model.width) this.wrapper.width(this.model.width);
        },
        _setHeight: function (height) {
            if (height) this.wrapper.height(height);
            if (this._isIE7) this.element.height(this.container.height());
        },

        _validateTimeFormat: function (timeFormat) {
            var parts = timeFormat.split(" "), format = "";
            if (parts.length == 1 || parts.length == 2) {
                $(parts).each(function (i, part) {
                    format += $.trim(part) + " ";
                });
                return $.trim(format);
            }
            else return null;
        },

        _getSeperator: function () {
            var p = this._getElePlace(), formats = this.model.timeFormat.split(" ")[p.time];
            var regex = new RegExp("^[a-zA-Z0-9]+$");

            for (var i = 0; i < formats.length; i++) {
                if (!regex.test(formats.charAt(i))) return formats.charAt(i);
            }
        },

        _checkInComplete: function () {
            var pos = this._getCaretSelection(), cursor = this._getStartEnd(pos);
            var replace = "00", selected = this._getSelectedValue(cursor), category = this._getCategory(cursor);
            if (pos.end - pos.start == this.element.val().length) this._checkAll();

            if (category && category != "tt") {
                this._findCategoryPosition(category);
                if (selected == "__") {
                    if (category == "h" || category == "hh") replace = "12";
                    this._changeToDefault(replace);
                }
                else if (category.length != 1 && selected.length == 1) {
                    selected = this._changeWhole(selected);
                    this.element.val(this._replaceAt(this.target.value, this.start, this.end, selected));
                }
            }
        },
        _checkAll: function () {
            var i, p = this._getElePlace(), categories = this.model.timeFormat.split(" ")[p.time].split(this.seperator);
            for (i = 0; i < categories.length; i++) {
                this._findCategoryPosition(categories[i]);
                var selected = this._getSelectedValue({ start: this.start, end: this.end });

                if (categories[i].length != 1 && selected.length == 1) {
                    selected = this._changeWhole(selected);
                    this.element.val(this._replaceAt(this.element.val(), this.start, this.end, selected));
                }
            }
        },

        _changeToDefault: function (replace) {
            this.incomplete = true;
            var preVal = this.element[0].value
            this.element[0].value = this._replaceAt(this.target.value, this.start, this.end, replace);
            var timeValue = this._checkExceedRange(this.target.value);
            if (!!timeValue) {
                this._setTime(this.model[timeValue]);
            }
            this._setSelection(this.start, this.end);
            this._raiseChangeEvent(preVal);
        },

        _setSelection: function (start, end) {
            var element = this.element[0];

            if (element.setSelectionRange)
                element.setSelectionRange(start, end);
            else if (element.createTextRange) {
                // For lower version browsers (IE8, IE7 ...)
                element = element.createTextRange();
                element.collapse(true);
                element.moveEnd('character', end);
                element.moveStart('character', start);
                element.select();
            }
        },

        _getSelectedValue: function (cursor) {
            return this.target.value.substring(cursor.start, cursor.end);
        },

        _getMinMax: function (currPart, keydown) {
            if (currPart == "hh" || currPart == "h") {
                this.min = 1; this.max = 11;
                if (keydown) this.max = 12;
            }
            else if (currPart == "HH" || currPart == "H") {
                this.min = 0; this.max = 23;
            }
            else if (currPart == "mm" || currPart == "m" || currPart == "ss" || currPart == "s") {
                this.min = 0; this.max = 59;
            }
        },

        _focusElement: function () {
            this._manualFocus = true;
            this.element.focus();
        },
        _targetFocus: function (e) {
            this._clearRange();
            e.preventDefault();
            this.focused = true;
            this.element.on('mousewheel DOMMouseScroll', $.proxy(this._mouseWheel, this));
            this.wrapper.addClass("e-focus").removeClass("e-error").attr('aria-invalid', "false");
            if (!this._manualFocus) {
                this._findCategoryPosition(this._getLeast(false));
                this._setSelection(this.start, this.end);
            }
            this._manualFocus = false;
            this._prevTimeVal = this.element.val();
            this._raiseEvent("focusIn");
            this.wrapper.addClass('e-valid');
        },
        _targetBlur: function () {
            this.focused = false;
            this.element.off('mousewheel DOMMouseScroll', $.proxy(this._mouseWheel, this));
            this.wrapper.removeClass("e-focus");
            if (!this.model.enableStrictMode) {
                // To remove the min value mask while focusout the timepicker.
                if (this.target.value.indexOf('_') > -1) this.element.val('');
            }
            if (!this._checkMinMax(this.target.value) && this._isValid(this.target.value, true)) {
                if (!this.model.enableStrictMode) {
                    if (this.model.minTime && !this._compareTime(this._createObject(this.target.value), this.model.minTime, true))
                        this.element.val(this.model.minTime);
                    if (this.model.maxTime && !this._compareTime(this.model.maxTime, this._createObject(this.target.value), true))
                        this.element.val(this.model.maxTime);
                    if (!this._isValid(this.model.value, true))
                        this.element.val(null);
                    this.isValidState = true;
                    (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
                }
                else
                    this.isValidState = false;
            }
            else this.isValidState = true;
            this._ensureValue();
            this._raiseChangeEvent();
            this._checkErrorClass();
            this._raiseEvent("focusOut");
            if (!this.model.enableStrictMode) this._checkInComplete();
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
        },
        _clearRange: function () {
            var input = this.element[0];
            if (!isNaN(input.selectionStart)) {
                input.selectionStart = 0;
                input.selectionEnd = 0;
            }
        },
        _checkErrorClass: function () {
            if (this.isValidState) this.wrapper.removeClass("e-error").attr('aria-invalid', "false");
            else this.wrapper.addClass("e-error").attr('aria-invalid', "true");
        },

        _getCaretSelection: function () {
            var input = this.element[0], start = 0, end = 0;
            if (!isNaN(input.selectionStart)) {
                start = input.selectionStart;
                end = input.selectionEnd;
                return { start: Math.abs(start), end: Math.abs(end) };
            }
            // For lower version browsers (IE8, IE7 ...)
            var bookmark = document.selection.createRange().getBookmark();
            var selection = input.createTextRange();
            selection.moveToBookmark(bookmark);

            var before = input.createTextRange();
            before.collapse(true);
            before.setEndPoint("EndToStart", selection);
            var beforeLength = before.text.length, selLength = selection.text.length;
            return { start: beforeLength, end: beforeLength + selLength };
        },

        _mouseDownOnInput: function (e) {
            if (!this.focused && (!ej.isTouchDevice())) this._focusElement();
            this.downPosition = this._getCaretSelection();
            $(document).on("mouseup", $.proxy(this._mouseUpOnInput, this));
        },

        _mouseUpOnInput: function (e) {
            e.preventDefault();
            $(document).off("mouseup", $.proxy(this._mouseUpOnInput, this));
            var pos = this._getCaretSelection();

            if (this.incomplete) {
                this.incomplete = false;
                pos = this.downPosition;
            }
            // Select the Complete Time value using mouse.            
            if (this.target.value != this._getSelectedText()) {
                pos = this._getStartEnd(pos);
                this._setSelection(pos.start, pos.end);
            }
        },

        _getCategoryPosition: function (category) {
            var s = 0, e = 0, parts = this.target.value.split(" "), p = this._getElePlace(), sep = this.seperator, valid = false;
            var fParts = this.model.timeFormat.split(" ")[p.time].split(sep);
            var tParts = parts[p.time].split(sep);
            if (fParts.length > tParts.length) return { start: s, end: e, isValid: valid };

            if (category == "tt") {
                if (parts[p.tt] == this.ttAM || parts[p.tt] == this.ttPM) {
                    if (p.tt == 0) s = 0;
                    else s = parts[p.time].length + 1;
                    e = s + parts[p.tt].length;
                    valid = true;
                }
            }
            else {
                if (p.time == 0) s = 0;
                else s = parts[p.tt].length + 1;

                var index = fParts.indexOf(category);
                if (index != -1) {
                    for (var i = 0; i < fParts.length; i++) {
                        e = tParts[i].length + 1;
                        if (i == index) break;
                        else s += e;
                    }
                    e += s - 1;
                    valid = true;
                }
            }
            return { start: s, end: e, isValid: valid };
        },
        _getCategory: function (cursor) {
            var parts = this.model.timeFormat.split(" "), sep = this.seperator;
            var p = this._getElePlace();
            if (cursor.isTT) return parts[p.tt];
            else return parts[p.time].split(sep)[cursor.index];
        },

        _getStartEnd: function (pos) {
            var tt, sep = this.seperator;
            var value = this.element.val(), parts = value.split(" "), s = 0, e = 0, place = tt = null, i, j;

            for (j = 0; j < parts.length; j++) {
                if (parts[j] != this.ttAM && parts[j] != this.ttPM) {
                    var time = parts[j].split(sep), tempS = s, tempE = s + time[0].length;
                    for (i = 0; i < time.length; i++) {
                        e = time[i].length + s;
                        if (pos.start <= e) {
                            place = i;
                            tt = false;
                            j = parts.length;
                            break;
                        }
                        else s += time[i].length + 1;
                    }
                }
                else {
                    if (pos.start <= s + parts[j].length) {
                        e = parts[j].length + s;
                        place = 0;
                        tt = true;
                        j = parts.length;
                        break;
                    }
                    else s += parts[j].length + 1;
                }
            }
            if (place == null) s = tempS, e = tempE, place = 0, tt = false;

            return { start: s, end: e, index: place, isTT: tt };
        },

        _modifyValue: function (isIncrement) {
            if (!this._isValid(this.target.value)) return;
            if (!this.model.enableStrictMode) this._checkInComplete();
            var pos = this._getCaretSelection(), cursor;
            if (pos.start == pos.end) {
                var cate = this._getLeast(true);
                var position = this._getCategoryPosition(cate);
                cursor = this._getStartEnd(position);
            }
            else cursor = this._getStartEnd(pos);
            this.start = cursor.start; this.end = cursor.end;
            this._changeValue(cursor, isIncrement);
        },

        _keyUpOnInput: function (e) {
            e.preventDefault();
            if (this._preVal != this.element.val()) {
                this._preVal = this.element.val();
            }
        },

        _getNextCategory: function (cate, direction) {
            var categories = [], sep = this.seperator;
            var fParts = this.model.timeFormat.split(" ");
            $(fParts).each(function (i, part) {
                if (part == "tt") categories.push(part);
                else {
                    var inner = part.split(sep);
                    categories = inner.concat(categories);
                }
            });
            var index = categories.indexOf(cate), ix;
            if (index != -1) {
                if (direction) {
                    if (index == 0) ix = categories.length - 1;
                    else ix = index - 1;
                }
                else {
                    if (index == categories.length - 1) ix = 0;
                    else ix = index + 1;
                }
                return categories[ix];
            }
            return cate;
        },
        _getElePlace: function () {
            var fParts = this.model.timeFormat.split(" "), time, tt;
            if (fParts[0] == "tt") time = 1, tt = 0;
            else time = 0, tt = 1;
            return { time: time, tt: tt };
        },
        _movePosition: function (pos, direction) {
            var cursor = this._getStartEnd(pos);
            var currCate = this._getCategory(cursor);
            if (!currCate) currCate = this._getLeast(direction);
            var next = this._getNextCategory(currCate, direction);
            var cursor = this._getCategoryPosition(next);

            if (cursor.isValid) {
                this._setSelection(cursor.start, cursor.end);
            }
        },
        _findActiveIndex: function () {
            var elements = this.ul.find("li");
            var currTime = this.element.val(), firstTime = elements.first().html(), index;
            index = (this._parse(currTime) - this._parse(firstTime)) / (this.model.interval * 60000);
            index = Math.round(index);
            this._activeItem = (index == elements.length) ? index : index + 1;
            if (this._activeItem < 0 || this._activeItem > elements.length || isNaN(this._activeItem)) this._activeItem = 0;
        },
        _keyDownOnInput: function (e) {
            if (this.model.readOnly && !this._readOnlyKeys(e)) return false;
            var pos, cursor, category, key = e.keyCode;

            // _getInternalEvents is set to true when TimePicker used inside DateTimePicker control
            // in DateTimePicker control it allows Up, Down, Home, End, Tab keys only
            if (this._getInternalEvents && key != 38 && key != 40 && key != 36 && key != 35 && key != 9) return false;
            // Up, Down, Esc
            if (!this.model.enableStrictMode) {
                // Prevent type operation on popup open in state.
                if (this.showDropdown && key != 38 && key != 40 && key != 27 && !this._readOnlyKeys(e)) return false;
                else if (this.showDropdown && (key == 37 || key == 39)) e.keyCode = (key == 37) ? 38 : 40;
            }
            pos = this._getCaretSelection();
            cursor = this._getStartEnd(pos);
            category = this._getCategory(cursor);
            switch (e.keyCode) {
                case 38:
                    e.preventDefault();
                    if (!this.showDropdown) {
                        if (this._isValid(this.target.value)) this._modifyValue(true);
                    }
                    else if (this.showDropdown) {
                        e.preventDefault();
                        this._findActiveIndex();
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectUp(this._activeItem - 1);
                        if (this._activeItem == 0) this._activeItem = prevActiveItem;
                        this._addListHover();
                        activeItem = this._getActiveItem();
                        if (activeItem.length) this._selectTimeItem(activeItem);
                    }
                    break;
                case 40:
                    e.preventDefault();
                    if (e.altKey && this.model.showPopupButton)
                        this._showhidePopup();
                    else if (!this.showDropdown) {
                        if (this._isValid(this.target.value)) this._modifyValue(false);
                    }
                    else if (this.showDropdown) {
                        e.preventDefault();
                        this._findActiveIndex();
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectDown(this._activeItem);
                        if (this._activeItem < this._listSize) this._activeItem += 1;
                        else
                            this._activeItem = prevActiveItem;
                        this._addListHover();
                        this._selectTimeItem(this._getActiveItem());
                    }
                    break;
                case 37:
                    e.preventDefault();
                    if (pos.start == pos.end) this._setSelection(pos.start - 1, pos.start - 1);
                    else this._movePosition(pos, true);
                    break;
                case 39:
                    e.preventDefault();
                    if (pos.start == pos.end) this._setSelection(pos.start + 1, pos.start + 1);
                    else this._movePosition(pos, false);
                    break;

                case 36:
                    // Home key 
                    e.preventDefault();
                    if (!this.showDropdown) {
                        var homecate = this._firstlastVal(true);
                        var hPos = this._getCategoryPosition(homecate);
                        if (hPos.isValid) this._setSelection(hPos.start, hPos.end);
                    }
                    else {
                        this._activeItem = 0;
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectDown(this._activeItem);
                        if (this._activeItem < this._listSize) this._activeItem += 1;
                        else
                            this._activeItem = prevActiveItem;
                        this._addListHover();
                        this._selectTimeItem(this._getActiveItem());
                    }
                    break;
                case 35:
                    // End key
                    e.preventDefault();
                    if (!this.showDropdown) {
                        var endcate = this._firstlastVal(false);
                        var ePos = this._getCategoryPosition(endcate);
                        if (ePos.isValid) this._setSelection(ePos.start, ePos.end);
                    }
                    else {
                        this._activeItem = this._listSize + 1;
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectUp(this._activeItem - 1);
                        if (this._activeItem == 0) this._activeItem = prevActiveItem;
                        this._addListHover();
                        this._selectTimeItem(this._getActiveItem());
                    }
                    break;
                case 9:
                    if (this._getInternalEvents) break;
                    this._hideResult();
                    var flag = null;
                    if (e.shiftKey && pos.start > 0) flag = true;
                    else if (!e.shiftKey && pos.end < this.element.val().length) flag = false;
                    if (flag != null) {
                        e.preventDefault();
                        this._checkInComplete();
                        this._movePosition(pos, flag);
                    }
                    break;
                case 13:
                    if (!this.showDropdown) {
                        this._raiseChangeEvent();
                        break;
                    }
                case 27:
                    e.preventDefault();
                    this._hideResult();
                    break;
                case 8:
                case 46:
                    if (this.model.enableStrictMode) return;
                    if (this.target.value != this._getSelectedText()) {
                        e.preventDefault();
                        if (category && category != "tt") {
                            this._findCategoryPosition(category);
                            var _doBackspace = (key == 8 && pos.start != this.start), _doDelete = (key == 46 && pos.end != this.end), len;
                            len = this.end - this.start;

                            if ((pos.start != pos.end || len == 1) && (_doBackspace || _doDelete || pos.start != pos.end)) {
                                var s1 = this.start, s2 = this.end, te;
                                this.element[0].value = this._replaceAt(this.target.value, s1, s2, "__");
                                te = (s2 - s1 != 2) ? s2 + 1 : s2;
                                this._setSelection(s1, te);
                            }
                            else {
                                if (_doBackspace) {
                                    this.element[0].value = this._replaceAt(this.target.value, pos.start - 1, pos.start, "");
                                    this._setSelection(pos.start - 1, pos.start - 1);
                                }
                                else if (_doDelete) {
                                    this.element[0].value = this._replaceAt(this.target.value, pos.end, pos.end + 1, "");
                                    this._setSelection(pos.end, pos.end);
                                }
                            }
                        }

                    }
                    break;

            }

            var currSelection = this._getSelectedValue(cursor);
            var unicode = e.keyCode ? e.keyCode : e.charCode, actualkey;

            if (e.keyCode > 47 && e.keyCode < 58)
                actualkey = String.fromCharCode(unicode);
            else if (e.keyCode > 95 && e.keyCode < 106)
                actualkey = String.fromCharCode(unicode - 48);
            if (category == "tt" && ((!e.shiftKey && !e.ctrlKey && !e.altKey) && (e.keyCode > 64 && e.keyCode < 91) || (e.keyCode > 47 && e.keyCode < 58) || (e.keyCode > 95 && e.keyCode < 106))) {
                e.preventDefault();
                var ttPos = this._getCategoryPosition(category);
                this.start = ttPos.start;
                this.end = ttPos.end;
                this._changeAmPm(currSelection);
                this._raiseChangeEvent();
            }

            // Select complete text and then press time value in the textbox               
            if (this.target.value == this._getSelectedText() && (!e.shiftKey && !e.ctrlKey && !e.altKey)) {
                if (e.keyCode > 64 && e.keyCode < 91 && !this.model.enableStrictMode) e.preventDefault();
                if ((e.keyCode > 47 && e.keyCode < 58) || (e.keyCode > 95 && e.keyCode < 106)) {
                    var cursor = this._getStartEnd(pos);
                    this._setSelection(cursor.start, cursor.end);
                }
            }

            if ((!e.shiftKey && !e.ctrlKey && !e.altKey) && (e.keyCode > 47 && e.keyCode < 58) || (e.keyCode > 95 && e.keyCode < 106)) {
                if (category != "tt") {
                    this._getMinMax(category, true);
                    if (pos.start == pos.end) {
                        this._findCategoryPosition(category);
                        var newVal;
                        if (pos.start == this.start) {
                            newVal = actualkey + currSelection;
                            if (this.model.enableStrictMode == false) {
                                this._validateTimes();
                                this._targetBlur();
                            }
                            var cursor = this._getStartEnd(pos);
                            this._setSelection(cursor.start, cursor.end);
                        }
                        else {
                            newVal = currSelection + actualkey;
                        }
                        if (newVal.length > 2 || !(Number(newVal) >= this.min && this.max >= Number(newVal))) {
                            !this.model.enableStrictMode && e.preventDefault();
                        }
                    }
                    else if (!(Number(actualkey) >= this.min && this.max >= Number(actualkey))) {
                        !this.model.enableStrictMode && e.preventDefault();
                    }
                }
            }
            else if (!this._allowKeyCodes(e)) {
                !this.model.enableStrictMode ? (e.keyCode == 8 || e.keyCode == 46) ? e.stopPropagation() : e.preventDefault() : e.stopPropagation();
            }
        },

        _getSelectedText: function (e) {
            if (window.getSelection) {
                var element = $('#' + this.element[0].id).get(0);
                return element.value.substring(element.selectionStart, element.selectionEnd);
            }
                // For IE
            else return document.selection.createRange().text;
        },
        _allowKeyCodes: function (e) {
            if ((e.ctrlKey && (e.keyCode == 65 || e.keyCode == 67 || e.keyCode == 90 || e.keyCode == 89))
                || e.keyCode == 9 || e.keyCode == 116 || e.keyCode == 13)
                return true;
            return false;
        },
        _readOnlyKeys: function (e) {
            if (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || this._allowKeyCodes(e))
                return true;
            return false;
        },

        _firstlastVal: function (initial) {
            var parts = this.model.timeFormat.split(" "), sep = this.seperator;
            if (initial) {
                if (parts[0] != "tt") return parts[0].split(sep)[0];
                return "tt";
            }
            else {
                if (parts[0] != "tt") return "tt";
                else if (parts[1]) {
                    var lastItem = parts[1].split(sep);
                    return lastItem.length ? lastItem[lastItem.length - 1] : "tt";
                }
                return "tt";
            }
        },

        _mouseWheel: function (event) {
            event.preventDefault();
            if (this.model.readOnly) return false;
            var delta, rawEvent = event.originalEvent;
            if (rawEvent.wheelDelta) {
                // IE and Opera use wheelDelta, which is a multiple of 120 (possible values -120, 0, 120).
                delta = rawEvent.wheelDelta / 120;
                // In Opera, value is negated.
                //if (Sys.Browser.agent === Sys.Browser.Opera) delta = -delta;
            }
            else if (rawEvent.detail) {
                // Firefox uses detail property, which is a multiple of 3.
                delta = -rawEvent.detail / 3;
            }
            if (delta > 0)
                this._modifyValue(true);
            else if (delta < 0)
                this._modifyValue(false);
        },

        _addListHover: function () {
            this._addSelected();
            this._updateScrollTop();
        },
        _addSelected: function () {
            this.ul.find("li").removeClass("e-active e-hover");
            var activeItem = this._getActiveItem();
            if (activeItem.length && !activeItem.hasClass('e-disable'))
                activeItem.addClass('e-active');
        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0)
                    return current;
                else
                    return this._disableItemSelectDown(current + 1);
            }
            else return this._listSize;
        },

        _disableItemSelectUp: function (current) {
            current = current - 1;
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0)
                    return current + 1;
                else if (current > 0)
                    return this._disableItemSelectUp(current);
            }
            return 0;
        },
        _getActiveItem: function () {
            return $(this.ul.find("li")[this._activeItem - 1]);
        },

        _timeIconClick: function (event) {
            var isRightClick = false;
            if (event.button)
                isRightClick = (event.button == 2);
            else if (event.which)
                isRightClick = (event.which == 3); //for Opera
            if (isRightClick) return;
            event.preventDefault();
            if (!this.model.enabled || this.model.readOnly || this.ul.find("li").length < 1) return false;
            this._showhidePopup();
            var len = this.element.val().length;
            if (!ej.isTouchDevice()) this._setSelection(len, len);
        },
        _showhidePopup: function () {
            if (this._getInternalEvents) return false;
            if (!this.showDropdown)
                this._showResult();
            else
                this._hideResult();
        },
        _showResult: function () {
            this._raiseEvent("beforeOpen");
                this._refreshPopup();
            if (!this.focused && (!ej.isTouchDevice())) this._focusElement();
            if (this.model.value) this._changeActiveEle();
            else
                this.ul.find("li").removeClass("e-active");

            var proxy = this, sTop = this._vissibleAndCalculateTop();
            this.popupList.slideDown(this.model.enableAnimation ? 200 : 0, function () {
                $(document).on("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
            });
            this.scrollerObj.setModel({ "scrollTop": sTop });
            this.showDropdown = true;
            this._listSize = this.ul.find("li").length;
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._on(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
            this._raiseEvent("open");
            this.wrapper.addClass("e-active");
        },
        _hideResult: function () {
            if (this.showDropdown && !this._getInternalEvents) {
                this.showDropdown = false;
                this.popupList.slideUp(this.model.enableAnimation ? 100 : 0);
                $(document).off("mousedown", $.proxy(this._OnDocumentClick, this));
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
                this._off(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
                this._raiseEvent("close");
                this.wrapper.removeClass("e-active");
            }
        },

        _vissibleAndCalculateTop: function () {
            this.popupList.css({ "display": "block" });
            var scrollTop = this._calcScrollTop();
            this.popupList.css({ "display": "none" });
            return scrollTop;
        },
        _calcScrollTop: function () {
            var ulH = this.ul.outerHeight(), liH = this.ul.find("li").outerHeight(), index, top;
            index = this.ul.find("li.e-active").index();
            top = (liH * index) - ((this.popupList.outerHeight() - liH) / 2);
            return top;
        },
        _changeActiveEle: function () {
            if (!this.model.showPopupButton || !this.popupList) return false;
            var elements = this.ul.find("li");
            var currTime = this.element.val(), firstTime = elements.first().html(), index;
            index = (this._parse(currTime) - this._parse(firstTime)) / (this.model.interval * 60000);
            index = Math.round(index);
            this._activeItem = (index == elements.length) ? index : index + 1;
            if (this._activeItem < 0 || this._activeItem > elements.length || isNaN(this._activeItem) || this._ensureTimeRange(currTime)) this._activeItem = 0;
            this._addListHover();
        },

        _OnDocumentClick: function (e) {
            if (!$(e.target).is(this.popupList) && !$(e.target).parents(".e-time-popup").is(this.popupList) &&
                !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-timewidget").is(this.wrapper)) {
                this._hideResult();
            }
            else if ($(e.target).is(this.popupList) || $(e.target).parents(".e-time-popup").is(this.popupList))
                e.preventDefault();
        },
        _OnWindowResize: function (e) {
            this._refreshPopup();
        },

        _OnMouseEnter: function (e) {
            var targetEle = e.target;
            this.ul.find("li").removeClass("e-hover");
            if (!$(targetEle).hasClass('e-disable'))
                $(targetEle).addClass("e-hover");
        },
        _OnMouseLeave: function (e) {
            if (!this._dateTimeInternal || this.model.value)
                this.ul.find("li").removeClass("e-hover");
        },
        _OnMouseClick: function (e) {
            e.preventDefault();
            if ($(e.target).hasClass('e-disable')) return;
            if (this.model.enabled && !this.model.readOnly) {
                this._activeItem = $(e.target).index() + 1;
                this.ul.find("li").attr({ 'tabindex': -1, 'aria-selected': false });
                $(e.target).attr({ 'aria-selected': true, 'tabindex': 0 });
                this._addSelected();
                this._selectTimeItem($(e.target));
            }
            this._showhidePopup();
        },
        _selectTimeItem: function (ele) {
            this._beforeChange(ele);
            var flag = this._raiseChangeEvent();
            if (flag)
                this._trigger("select", { value: this.model.value, prevTime: this._previousValue });
        },

        _findCategoryPosition: function (category) {
            if (category == "least") category = this._getLeast(true);
            var pos = this._getCategoryPosition(category);
            this.start = pos.start;
            this.end = pos.end;
        },

        _getLeast: function (lower) {
            var formats = this.model.timeFormat.split(" "), sep = this.seperator, res = null;
            $(formats).each(function (i, e) {
                if (e != "tt") {
                    var times = e.split(sep);
                    if (lower) res = times[times.length - 1];
                    else res = times[0];
                }
            });
            return res;
        },

        _changeValue: function (cursor, isIncrement) {
            var preVal = this.target.value, currValue, category = this._getCategory(cursor);
            if (!category) return false;
            this._setSelection(this.start, this.end);
            currValue = this.target.value.substring(this.start, this.end);
            if (this._checkMinMax(this.target.value)) {
                if (currValue != this.ttAM && currValue != this.ttPM) {
                    currValue = this._changeCurrentValue(currValue, category, isIncrement);
                    if (category.length != 1) currValue = this._changeWhole(currValue);
                    this._findCategoryPosition(category);
                    this.element.val(this._replaceAt(this.target.value, this.start, this.end, currValue));
                    this.end = this.start + currValue.toString().length;
                    this._setSelection(this.start, this.end);
                    if (this._ensureTimeRange(this.target.value) && this._checkMinMax(this.target.value)) {
                        var timeObject = this._createObject(this.target.value);
                        var hour = timeObject.getHours();
                        var fromTime = isIncrement ? this._startTime : this._endTime;
                        var toTime = isIncrement ? this._endTime : this._startTime;
                        if (!ej.isNullOrUndefined(this.model.disableTimeRanges)) {
                            for (i = 0; i < this.model.disableTimeRanges.length; i++) {
                                if ((fromTime[i].getHours() === hour) || ((+timeObject >= +this._startTime[i]) && +timeObject <= +this._endTime[i])) {
                                    this.target.value = this._localizeTime(toTime[i]);
                                    this._setSelection(this.start, this.end);
                                    this._changeValue(cursor, isIncrement);
                                }
                            }
                        }
                    }
                }
                else this._changeAmPm(currValue);
            }
            else {
                var timeValue = this._checkExceedRange(this.target.value);
                this._setTime(this.model[timeValue]);
                this._findCategoryPosition(category);
                this._setSelection(this.start, this.end);
            }
            if (!this._checkMinMax(this.target.value)) {
                this.element.val(this.model.value);
                this._findCategoryPosition(category);
                this._setSelection(this.start, this.end);
            }
            else this._raiseChangeEvent();
        },

        _checkMinMax: function (value) {
            var res = this._checkExceedRange(value);
            if (res == null) res = false;
            return !res;
        },
        _checkExceedRange: function (value) {
            if (value) {
                if (this.model.minTime && !this._compareTime(value, this.model.minTime, true)) return "minTime";
                if (this.model.maxTime && !this._compareTime(this.model.maxTime, value, true)) return "maxTime";
            }
            return null;
        },

        _changeWhole: function (currValue) {
            return currValue > 9 ? "" + currValue : "0" + currValue;
        },
        _changeAmPm: function (ampm) {
            ampm = ampm == this.ttAM ? this.ttPM : this.ttAM;
            this.element.val(this._replaceAt(this.target.value, this.start, this.end, ampm));
            this._setSelection(this.start, this.end);
        },
        _changeMinute: function (isIncrement) {
            var formats = ["mm", "m"];
            var currFormat = this._getExactFormat(formats);
            if (currFormat) {
                this._findCategoryPosition(currFormat);
                var minute = Number(this.target.value.substring(this.start, this.end));
                this._getMinMax(currFormat);
                if (isIncrement) {
                    if (minute == this.max) {
                        minute = this.min;
                        this._changeHour(isIncrement);
                    }
                    else minute += 1;
                }
                else {
                    if (minute == this.min) {
                        minute = this.max;
                        this._changeHour(isIncrement);
                    }
                    else minute -= 1;
                }
                this._findCategoryPosition(currFormat);
                if (currFormat.length != 1) minute = this._changeWhole(minute);
                this.element.val(this._replaceAt(this.target.value, this.start, this.end, minute));
            }
        },
        _changeHour: function (isIncrement) {
            var formats = ["hh", "h", "HH", "H"];
            var currFormat = this._getExactFormat(formats);
            if (currFormat) {
                this._findCategoryPosition(currFormat);
                var hour = Number(this.target.value.substring(this.start, this.end));
                this._getMinMax(currFormat);
                if (isIncrement) {
                    if (hour == this.max) {
                        hour += 1;
                        this._changeMeridian();
                    }
                    else if (hour > this.max) hour = this.min;
                    else hour += 1;
                }
                else {
                    if (hour == this.min) hour = this.max + 1;
                    else if (hour > this.max) {
                        hour = this.max;
                        this._changeMeridian();
                    }
                    else hour -= 1;
                }
                this._findCategoryPosition(currFormat);
                if (currFormat.length != 1) hour = this._changeWhole(hour);
                this.element.val(this._replaceAt(this.target.value, this.start, this.end, hour));
            }
        },
        _getExactFormat: function (cate) {
            var tFormat = this.model.timeFormat;
            for (var i = 0; i < cate.length; i++) {
                if (tFormat.indexOf(cate[i]) != -1) return cate[i];
            }
            return null;
        },
        _changeMeridian: function () {
            var start = this.model.timeFormat.indexOf("tt");
            if (start != -1) {
                this._findCategoryPosition("tt");
                var meridian = this.target.value.substring(this.start, this.end);
                meridian = (meridian == this.ttAM) ? this.ttPM : this.ttAM;
                this.element.val(this._replaceAt(this.target.value, this.start, this.end, meridian));
            }
        },
        _changeCurrentValue: function (current, category, isIncrement) {
            current = Number(current);
            var c = category, step = 1, change = true;
            this._getMinMax(c);

            if (c == "hh" || c == "h" || c == "HH" || c == "H") step = this.model.hourInterval;
            else if (c == "mm" || c == "m") step = this.model.minutesInterval;
            else if (c == "ss" || c == "s") step = this.model.secondsInterval;
            if (step <= 0) return current;

            if (isIncrement) {
                if ((c == "hh" || c == "h") && current > this.max) current = this.min - 1 + step;
                else if (current < this.max) current += step;
                else {
                    change = false;
                    if (c != "hh" && c != "h") current = this.min - 1 + step;
                    else current += step;
                    this._changeAdjacent(c, isIncrement);
                }
                if ((c == "hh" || c == "h") && current == this.max + 1)
                    change && this._changeAdjacent(c, isIncrement);
                else if (current > this.max + 1) {
                    current = current - (this.max + 1);
                    change && this._changeAdjacent(c, isIncrement);
                }
                if ((c != "hh" && c != "h") && current == this.max + 1) {
                    current = this.min;
                    change && this._changeAdjacent(c, isIncrement);
                }
            }
            else {
                if ((c != "hh" && c != "h") && current > this.min) current -= step;
                else if ((c == "hh" || c == "h") && current > this.min && current <= this.max) current -= step;
                else if ((c == "hh" || c == "h") && current == this.min) current = this.max + 2 - step;
                else {
                    change = false;
                    current = this.max + 1 - step;
                    this._changeAdjacent(c, isIncrement);
                }
                if (current < this.min) {
                    current = current + (this.max + 1);
                    change && this._changeAdjacent(c, isIncrement);
                }
            }
            return current;
        },
        _changeAdjacent: function (c, isIncrement) {
            if (c == "ss" || c == "s") this._changeMinute(isIncrement);
            else if (c == "mm" || c == "m") this._changeHour(isIncrement);
            else if (c == "hh" || c == "h" || c == "HH" || c == "H") this._changeMeridian();
        },

        _valueChange: function (e) {
            this._raiseChangeEvent();
        },

        _beforeChange: function (ele) {
            if (!this._raiseEvent("beforeChange")) {
                this.element.val(ele.text());
            }
            return true;
        },

        _raiseChangeEvent: function (prev, isCode) {
            prev = (prev === undefined) ? this.model.value : prev;
            this._previousValue = prev;
            var current = !this.target.value ? null : this.target.value;
            if (prev == current) return false;
            if (this._checkMinMax(this.target.value) && this._isValid(this.target.value, this.model.enableStrictMode) || !this.target.value) this.isValidState = true;
            else this.isValidState = false;
            this.model.value = this._isValid(this.target.value, true) && this._checkMinMax(this.target.value) ? this.target.value : null;
            if (!this.model.value && !this.model.enableStrictMode) this._setTime(this.model.value);
            if (this.model.value == this._previousValue) return false;
            this._raiseEvent("change", isCode);
            this._raiseEvent("_change", isCode);
            return true;
        },
        _raiseEvent: function (name, isCode) {
            var data = { value: this.model.value, prevTime: this._previousValue };
            if (name == "change") data.isInteraction = !isCode;
            return (this._trigger(name, data));
        },
        _checkIE7: function () {
            if (navigator.appName == 'Microsoft Internet Explorer') {
                var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})"), version = -1;
                if (re.exec(navigator.userAgent) != null)
                    version = parseFloat(RegExp.$1);
                if (version >= 7 && version < 8) return true;
            }
            return false;
        },
        _replaceAt: function (mainString, from, to, replace) {
            return mainString.substring(0, from) + replace + mainString.substring(to);
        },
        _localizeTime: function (value) {
            if (value)
                return $.trim(ej.format(this._createObject(value), this.model.timeFormat, this.model.locale));
            return null;
        },
        _localizeMeridian: function (value) {
            return $.trim(ej.format(value, "tt", this.model.locale));
        },
        _compareTime: function (time1, time2, orEqual) {
            orEqual = (!orEqual) ? false : true;
            if (orEqual) return this._parse(time1) >= this._parse(time2);
            else return this._parse(time1) > this._parse(time2);
        },
        _isValid: function (time, validate) {
            time = this._createObject(time, validate);
            return time && typeof time.getTime === "function" && isFinite(time.getTime());
        },
        _parse: function (time) {
            return Date.parse(this._createObject(time));
        },
        _setEmptyDate: function (date) {
            var newDate = new Date(date);
            newDate.setDate(1);
            newDate.setMonth(0);
            newDate.setFullYear(2000);
            return newDate;
        },
        _createObject: function (value, validate) {
            var obj = null;
            if (typeof value === "string") {
                var format = this._setModelOption ? this._preTimeformat : this.model.timeFormat;
                var dateFormat = ej.preferredCulture(this.model.locale).calendar.patterns.d;
                var dateValue = ej.format(new Date("1/1/2000"), dateFormat, this.model.locale);
                obj = ej.parseDate(dateValue + " " + value, dateFormat + " " + format, this.model.locale);
                if (this._extISORegex.exec(value) || this._basicISORegex.exec(value)) this.model.value = obj = this._timeFromISO(value);
                this._setModelOption = false;
                if (!obj) {
                    var isJSONString = new Date(value);
                    if (!isNaN(Date.parse(isJSONString)) && !ej.isNullOrUndefined(value))
                        obj = this._setEmptyDate(value);
                    else
                        obj = !this._dateTimeInternal || value == "" ? null : new Date("1/1/2000 " + value);
                }
            }
            else if (typeof value === "number")
                obj = new Date(value);
            else if (value instanceof Date)
                obj = this._setEmptyDate(value);

            if (obj && !this._dateTimeInternal && validate) {
                var timeVal = this._localizeTime(obj);
                if (this._ensureTimeRange(timeVal))
                    obj = null;
            }
            return obj;
        },

        _wireEvents: function () {
            this._on(this.element, "focus", this._targetFocus);
            this._on(this.element, "blur", this._targetBlur);
            this._on(this.element, "mousedown", this._mouseDownOnInput);
            this._on(this.element, "keydown", this._keyDownOnInput);
            this._on(this.element, "keyup", this._keyUpOnInput);
        }
    });
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to select the date and time values.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDateTimePicker", "ej.DateTimePicker", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        _rootCSS: "e-datetimepicker",
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },


        defaults: {

            cssClass: "",

            locale: "en-US",

            readOnly: false,

            showRoundedCorner: false,

            enableRTL: false,

            htmlAttributes: {},
			allowEdit: true,

            enabled: true,

            value: "",

            name: null,

            minDateTime: new Date("1/1/1900 12:00:00 AM"),

            maxDateTime: new Date("12/31/2099 11:59:59 PM"),

            height: "",

            width: "",

            dateTimeFormat: "",

            showPopupButton: true,

            enableStrictMode: false,

            buttonText: {

                today: "Today",

                timeNow: "Time Now",

                done: "Done",

                timeTitle: "Time"
            },

            watermarkText: "Select datetime",

            enablePersistence: false,

            interval: 30,

            timeDisplayFormat: "",

            timePopupWidth: 105,
            popupPosition: "bottom",

            dayHeaderFormat: "short",

            startLevel: "month",

            depthLevel: "",

            startDay: -1,

            stepMonths: 1,

            showOtherMonths: true,

            enableAnimation: true,

            headerFormat: 'MMMM yyyy',

            validationRules: null,

            validationMessage: null,

            validationMessages: null,
            timeDrillDown: {
                enabled: false,
                interval: 5,
                showMeridian: false,
                autoClose: true,
                showFooter: true
            },

            beforeOpen: null,

            beforeClose: null,

            open: null,

            close: null,

            change: null,

            create: null,

            destroy: null,

            focusIn: null,

            focusOut: null

        },


        dataTypes: {
            allowEdit: "boolean",
            cssClass: "string",
            locale: "string",
            readOnly: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            enabled: "boolean",
            enableAnimation: "boolean",
            dateTimeFormat: "string",
            showPopupButton: "boolean",
            buttonText: "data",
            watermarkText: "string",
            enablePersistence: "boolean",
            enableStrictMode: "boolean",
            interval: "number",
            timeDrillDown: "data",
            timeDisplayFormat: "string",
            dayHeaderFormat: "string",
            startLevel: "string",
            depthLevel: "string",
            startDay: "number",
            stepMonths: "number",
            showOtherMonths: "boolean",
            headerFormat: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },

        _setModel: function (options) {
            var option, validate = false;
            for (option in options) {
                switch (option) {
                    case "allowEdit": this._changeEditable(options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "locale": this._localize(options[option]); break;
                    case "readOnly": this._readOnly(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "enableRTL": this._setRtl(options[option]); break;
                    case "enabled": this._enabled(options[option]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;  
					case "validationMessages":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "value":
                        options[option] = this._setValue(options[option]);
                        if (this._specificFormat())
                            this._stopRefresh = true
                        validate = true;
                        this._prevDateTime = this._prevDateTimeVal || this._preVal;
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = options[option];
                        validate = true;
                        break;
                    case "minDateTime":
                        var temp = this._stringToObject(options[option]);
                        var mintime = this._getFormat(temp, this.timePicker.model.timeFormat);
                        if (this._isValidDate(temp)) {
                            this.datePicker.option("minDate", temp);
                            this.timePicker.option("minTime", mintime);
                            options[option] = temp;
                            this.model.minDateTime = temp;
                        }
                        else options[option] = this.model[option];
                        validate = true;
                        break;
                    case "maxDateTime":
                        var temp = this._stringToObject(options[option]);
                        var maxtime = this._getFormat(options[option], this.timePicker.model.timeFormat);
                        if (this._isValidDate(temp)) {
                            this.datePicker.option("maxDate", temp);
                            this.timePicker.option("maxTime", maxtime);
                            options[option] = temp;
                            this.model.maxDateTime = temp;
                        }
                        else options[option] = this.model[option];
                        validate = true; break;
                    case "height": this.wrapper.height(options[option]); break;
                    case "width": this.wrapper.width(options[option]); break;
                    case "dateTimeFormat":
                        this.model.dateTimeFormat = options[option];
                        if (this.isValidState) this._setValue(this.model.value);
                        break;
                    case "showPopupButton": this._showButton(options[option]); break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options[option] = this.model.watermarkText = options[option];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                    case "buttonText":
                        if (!ej.isNullOrUndefined(this._options)) this._options = [];
                        this._options["buttonText"] = this.model.buttonText = options[option];
                        this._localizedLabels.buttonText = this.model.buttonText;
                        this._buttonText(options[option]); break;
                    case "interval":
                        this._updateTimeHeight();
                        this.timePicker.option("interval", options[option]); break;
                    case "timeDisplayFormat":
                        this._updateTimeHeight();
                        this.timePicker.option("timeFormat", options[option]); break;
                    case "timePopupWidth":
                        this._updateTimeHeight();
                        this.timePicker.option("popupWidth", options[option]);
                        break;
                    case "dayHeaderFormat": this.datePicker.option("dayHeaderFormat", options[option]); break;
                    case "startLevel": this.datePicker.option("startLevel", options[option]); break;
                    case "depthLevel": this.datePicker.option("depthLevel", options[option]); break;
                    case "startDay": this.datePicker.option("startDay", options[option]);
                        this.model.startDay = this.datePicker.model.startDay;
                        options[option] = this.model.startDay; break;
                    case "stepMonths": this.datePicker.option("stepMonths", options[option]); break;
                    case "showOtherMonths": this.datePicker.option("showOtherMonths", options[option]); break;
                    case "headerFormat": this.datePicker.option("headerFormat", options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "popupPosition": this.model.popupPosition = options[option]; this._setListPosition(); break;
                    case "timeDrillDown":

                        // For timeDrillDown.enabled
                        if (!ej.isNullOrUndefined(options[option].enabled)) {
                            this.model.timeDrillDown.enabled = options[option].enabled; this._changeDesign();
                        }

                        // For timeDrillDown.interval
                        if (!ej.isNullOrUndefined(options[option].interval)) {
                            this.model.timeDrillDown.interval = options[option].interval;
                            this._generateMins($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)));
                        }

                        // For timeDrillDown.showMeridian
                        if (!ej.isNullOrUndefined(options[option].showMeridian)) {
                            this.model.timeDrillDown.showMeridian = options[option].showMeridian;
                            this._sfTimeHour.empty(); this._renderHourTable();
                        }

                        // For timeDrillDown.showFooter
                        if (!ej.isNullOrUndefined(options[option].showFooter)) {
                            this.model.timeDrillDown.showFooter = options[option].showFooter;
                            this._changeDesign();
                        }
                        break;

                }
            }
            if (validate) this._validateMinMax();
            this._valueChange(true);
            if (option == "value") options[option] = this.model.value;
            this._updateTimeHeight();
            this._checkErrorClass();
        },
        observables: ["value"],

        _destroy: function () {
            if (this.isPopupOpen)
                this._hideResult();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
            }
			this._cloneElement.removeClass("e-js e-input").removeClass(ej.util.getNameSpace(this.sfType));
            this._cloneElement.insertAfter(this.element);
            this.element.remove();
            if (!ej.isNullOrUndefined(this.datePicker))
                this.datePicker.destroy();
            if (!ej.isNullOrUndefined(this.timePicker))
                this.timePicker.destroy();
            this.popup.remove();
        },


        _init: function (options) {
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            this._options = options;
            this._cloneElement = this.element.clone();
            this._ISORegex();
            this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
            this._validateMeridian();
            this._checkAttribute();
            this._initialize();
            this._initial = true;
            this._interval = 60;
            this._render();
            this._wireEvents();
            this._addAttr(this.model.htmlAttributes);
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._changeDesign();
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
        },
        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },
        _changeDesign: function () {
            if (this.model.timeDrillDown.enabled) {
                var state = this.model.timeDrillDown.showFooter ? "block" : "none";
                this.popup.addClass("e-drill-down");
                this._timeContainer.css("display", "none");
                this._buttonContainer.css("display", "none");
                this.datePicker.option("showFooter", this.model.timeDrillDown.showFooter);
                $('.e-footer', this._sfTimeHour).css("display", state);
                $('.e-footer', this._sfTimeMins).css("display", state);
            }
            else {
                this.popup.removeClass("e-drill-down");
                this._sfTimeHour.hide();
                this._sfTimeMins.hide();
                this._updateTimeHeight();
                this._dateContainer.show();
                this._timeContainer.show();
                this._buttonContainer.show();
                this.datePicker.option("showFooter", false);
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
            }
        },
        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _checkAttribute: function () {
            this.model.value = this.model.value === "" ? this.element[0].value : this.model.value;
            if (!this._options.minDateTime) this.model.minDateTime = this.element[0].min;
            if (!this._options.maxDateTime) this.model.maxDateTime = this.element[0].max;
            if (ej.isNullOrUndefined(this._options.readOnly)) this.model.readOnly = this.element.is("[readonly]");
            if (ej.isNullOrUndefined(this._options.enabled)) this.model.enabled = !this.element.is("[disabled]");
        },
        _setValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled" && value == "disabled") proxy._enabled(false);
                else if (keyName == "readOnly" && value == "readOnly") proxy._readOnly(true);
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], keyName)) proxy.element.attr(keyName, value);
                else proxy.wrapper.attr(keyName, value);
            });
        },
        _validateMeridian: function () {
            var culture = ej.preferredCulture(this.model.locale);
            if (culture) this.model.locale = culture.name == "en" ? "en-US" : culture.name;
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.timeDrillDown)) {
                    if (ej.isNullOrUndefined(this._options.timeDrillDown.showMeridian))
                        this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
                }
                else this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
            }
            else
                this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
        },
        _initialize: function () {
            var val;
            this.popup = null;
            this.isPopupOpen = false;
            this.isValidState = true;
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    $.extend(this._localizedLabels.buttonText, this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this._isIE9 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "9.0") ? true : false;
            if (!this.model.dateTimeFormat || !this.model.timeDisplayFormat) this._getDateTimeFormat();
            if (!this.model.value || (typeof JSON === "object" && JSON.stringify(this.model.value) === "{}"))  val = null;
            else if (!(this.model.value instanceof Date)) {
                 var dateTimeObj = ej.parseDate(this.model.value, this.model.dateTimeFormat, this.model.locale);
                  val = dateTimeObj ? dateTimeObj : (dateTimeObj = this._checkJSONString(this.model.value)) ? dateTimeObj : null;
            }
            else  val = this.model.value;
            if (val) this.model.value = val;
            var min = this.model.minDateTime = this._stringToObject(this.model.minDateTime);
            if (!min || !this._isValidDate(min)) this.model.minDateTime = this.defaults.minDateTime;
            var max = this.model.maxDateTime = this._stringToObject(this.model.maxDateTime);
            if (!max || !this._isValidDate(max)) this.model.maxDateTime = this.defaults.maxDateTime;
        },
        _checkJSONString: function (dateTimeString) {
            // Validate the string value
            var dateTimeObj = new Date(dateTimeString);
            if (!isNaN(Date.parse(dateTimeObj))) {
                if ((dateTimeObj.toJSON() === this.model.value) || (dateTimeObj.toGMTString() === this.model.value) ||
                    (dateTimeObj.toISOString() === this.model.value) || (dateTimeObj.toLocaleString() === this.model.value) || 
                    (dateTimeObj.toString() === this.model.value) || (dateTimeObj.toUTCString() === this.model.value))
                    return dateTimeObj;
                else if (typeof dateTimeString == "string") return this._dateFromISO(dateTimeString);
            } else if (this._extISORegex.exec(dateTimeString) || this._basicISORegex.exec(dateTimeString)) return this._dateFromISO(dateTimeString);
        },
        _render: function () {
            this._renderWrapper();
            this._renderIcon();
            this._setDimentions();
            this._renderDropdown();
            this._checkProperties();
        },

        _renderWrapper: function () {
            this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', "tabindex": "0", "value": this.model.value });
            this.wrapper = ej.buildTag("span.e-datetime-wrap e-widget " + this.model.cssClass + "#" + this.element[0].id + "_wrapper").insertAfter(this.element);
            this.wrapper.attr("style", this.element.attr("style"));
            this.element.removeAttr("style");
            if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
            if (!this._isSupport) {
                this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
                this._hiddenInput.val(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "block");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
        },
        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport)
                this._hiddenInput.css("display", "none");
        },
        _renderIcon: function () {
            if (!this.model.showPopupButton) return false;
            this.datetimeIcon = ej.buildTag("span.e-select", "", {}).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var icon = ej.buildTag("span.e-icon e-datetime", "", {}, { "aria-label": "select" }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this.datetimeIcon.append(icon);
            this.container.append(this.datetimeIcon).addClass("e-padding");
            this._on(this.datetimeIcon, "click", this._iconClick);
            this._on(this.datetimeIcon, "mousedown", function (e) { e.preventDefault(); });
        },
        _setDimentions: function () {
            if(!this.model.height) this.model.height = this.element.attr("height"); if(!this.model.width) this.model.width = this.element.attr("width");
            this.wrapper.height(this.model.height);
            this.wrapper.width(this.model.width);
        },

        _renderDropdown: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.popup = ej.buildTag("div.e-datetime-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.element[0].id + "_popup").css("visibility", "hidden");
            if (!ej.isTouchDevice()) this.popup.addClass('e-ntouch');
            $('body').append(this.popup);
            this._renderControls();

            var _timeTitle, _dateContainer, popupContainer, _today, _now, _done;

            _timeTitle = ej.buildTag("div.e-header", this._localizedLabels.buttonText.timeTitle).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._dateContainer = ej.buildTag("div.e-datecontainer").append(this.datePicker.popup).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._timeContainer = ej.buildTag("div.e-timecontainer").append(_timeTitle, this.timePicker.popup).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._drillDownContainer = ej.buildTag("div.e-drillDowncontainer").append().attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            popupContainer = ej.buildTag("div.e-popup-container").append(this._dateContainer, this._timeContainer, this._drillDownContainer).attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            _today = ej.buildTag("div.e-dt-button e-dt-today e-btn e-select e-flat", this._localizedLabels.buttonText.today).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            _now = ej.buildTag("div.e-dt-button e-dt-now e-btn e-select e-flat", this._localizedLabels.buttonText.timeNow).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            _done = ej.buildTag("div.e-dt-button e-dt-done e-btn e-select e-flat", this._localizedLabels.buttonText.done).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._buttonContainer = ej.buildTag("div.e-button-container").append(_today, _now, _done).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._renderDrillDown();
            this.popup.append(popupContainer, this._buttonContainer);
            this._checkForResponsive();
            this._updateTimeHeight();

            this._bindOperations();
            this._updateValues();
            this.popup.css({ "visibility": "visible", "display": "none" });

            this._on(_today, "click", this._todayClick);
            this._on(_now, "click", this._nowClick);
            this._on(_done, "click", this._doneClick);
        },
        _renderControls: function () {
            this._renderDateControl();
            this._renderTimeControl();

            var tempContainer = ej.buildTag("span").append(this.datePicker.wrapper, this.timePicker.wrapper);
            tempContainer.find("span").css("display", "none");
            this.popup.append(tempContainer);
        },
        _renderDrillDown: function () {
            this._renderHourPopup();
            this._renderMinsPopup();
        },
        _renderHourPopup: function () {
            var table;
            this._sfTimeHour = ej.buildTag('div.e-timepicker e-popup e-widget ' + this.model.cssClass + ' e-time-hours ', "", {}, { id: (this._id ? 'e-hours-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
            if (!ej.isTouchDevice()) this._sfTimeHour.addClass('e-ntouch');
            this._drillDownContainer.append(this._sfTimeHour);
            this._renderHourTable();
        },
        _renderHourTable: function () {
            // Rendering header template
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                   .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-hours-headertext").text("October 2015").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .appendTo(this._sfTimeHour);

            // Render meridian calendar popup.
            if (this._interval < 1) return false;
            var start, end, timeVal, rowCount, table, tr, interval = this._interval * 60000;
            var tableCount = this.model.timeDrillDown.showMeridian ? 2 : 1; rowCount = this.model.timeDrillDown.showMeridian ? 6 : 4;
            var timeDisplayFormat = this.model.timeDrillDown.showMeridian ? "hh" : "HH:00";
            var meridianText = ["AM", "PM"], count = 0, meridianClass = "";

            start = this.timePicker._createObject("12:00:00 AM");
            end = this.model.timeDrillDown.showMeridian ? this.timePicker._createObject("11:59:59 AM") : this.timePicker._createObject("11:59:59 PM");

            for (var i = 0; i < tableCount; i++) {
                if (this.model.timeDrillDown.showMeridian) {
                    meridianClass = meridianText[i].toLowerCase();
                    var txt = !ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]]) ? ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]][0] : "";
                    ej.buildTag("div.e-header-" + meridianClass).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                      .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-hours-meridiantxt-" + meridianClass).text(txt)
                      .attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                      .appendTo(this._sfTimeHour);
                }

                // Table for Time Value
                table = ej.buildTag("table.e-dp-viewhours", "", {}, { 'cellspacing': 2 }).data("e-table", "data").attr({ 'role': 'grid', 'aria-activedescendant': '' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                this._sfTimeHour.append(table);

                var tbody = ej.buildTag('tbody.e-timepicker-hours').attr((this._isIE8) ? { 'unselectable': 'on' } : {});

                tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});

                while (this.timePicker._compareTime(end, start, true)) {
                    timeVal = this._localizeTime(start, timeDisplayFormat);
                    var tdtag = ej.buildTag("td.e-hour e-state-default", timeVal);
                    this.model.timeDrillDown.showMeridian && tdtag.addClass("e-hour-" + meridianClass);
                    if (this._isIE8) tdtag.attr("unselectable", "on");
                    tr.append(tdtag);
                    count++;
                    if (count >= rowCount) {
                        count = 0;
                        tbody.append(tr);
                        tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    }
                    start = this.timePicker._createObject(start).getTime() + interval;
                }

                //tbody.append(tr);
                table.append(tbody);

                if (this.model.timeDrillDown.showMeridian) {
                    start = this.timePicker._createObject("12:00:00 PM");
                    end = this.timePicker._createObject("11:59:59 PM");
                }
            }

            // Rendering the footer template
            ej.buildTag("div.e-footer")
              .append(ej.buildTag("span.e-footer-icon"))
              .append(ej.buildTag("span.e-footer-text"))
              .appendTo(this._sfTimeHour);
            $('.e-footer-text', this._sfTimeHour).html(this._localizedLabels.buttonText.timeNow);
            $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this.datePicker.model.value, "dd MMM yyyy"));

            // Bind action to the item.
            this._on(this._sfTimeHour.find('.e-hour'), "click", $.proxy(this._hourNavHandler, this));
            this._on($('.e-next', this._sfTimeHour), "click", $.proxy(this._prevNextHourHandler, this));
            this._on($('.e-prev', this._sfTimeHour), "click", $.proxy(this._prevNextHourHandler, this));
            this._on($('.e-footer', this._sfTimeHour), "click", this._todayBtn);
            $('.e-hours-headertext', this._sfTimeHour).on("click", $.proxy(this._forwardNavHandler, this));

            this._sfTimeHour.hide();
        },
        _localizeTime: function (value, format) {
            return $.trim(ej.format(this.timePicker._createObject(value), format, this.model.locale));
        },
        _renderMinsPopup: function () {
            this._sfTimeMins = ej.buildTag('div.e-timepicker e-popup e-widget ' + this.model.cssClass + ' e-time-minitues ', "", {}, { id: (this._id ? 'e-time-minitues-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
            if (!ej.isTouchDevice()) this._sfTimeMins.addClass('e-ntouch');
            this._drillDownContainer.append(this._sfTimeMins);

            // Rendering header template
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                   .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-minitues-headertext").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .appendTo(this._sfTimeMins);

            // Meridian Header template
            ej.buildTag("div.e-mins-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                          .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-minitues-meridiantxt").text("AM")
                          .attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                          .appendTo(this._sfTimeMins);

            // Table for Time Value
            var table = ej.buildTag("table.e-dp-viewmins", "", {}, { 'cellspacing': 2 }).data("e-table", "data").attr({ 'role': 'grid', 'aria-activedescendant': '' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._sfTimeMins.append(table);

            var tbody = ej.buildTag('tbody.e-timepicker-mins').attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            // Render Time value
            if (this._intervall < 1) return false;
            var start, end, timeVal, interval = this._interval * 60000;
            start = this.timePicker._createObject("12:00:00 AM");
            end = this.timePicker._createObject("11:59:59 PM");
            var tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var count = 0;
            while (this.timePicker._compareTime(end, start, true)) {
                timeVal = this._localizeTime(start, "HH:00");
                var tdtag = ej.buildTag("td.e-mins e-state-default", timeVal);
                if (this._isIE8)
                    tdtag.attr("unselectable", "on");
                tr.append(tdtag);
                count++;
                if (count >= 4) {
                    count = 0;
                    tbody.append(tr);
                    tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                }
                start = this.timePicker._createObject(start).getTime() + interval;
            }
            //tbody.append(tr);
            table.append(tbody);
            $('.e-minitues-headertext', this._sfTimeMins).text($('.e-hours-headertext', this._sfTimeHour).text());

            // Rendering the footer template
            ej.buildTag("div.e-footer")
               .append(ej.buildTag("span.e-footer-icon"))
               .append(ej.buildTag("span.e-footer-text"))
               .appendTo(this._sfTimeMins);
            $('.e-footer-text', this._sfTimeMins).html(this._localizedLabels.buttonText.timeNow);
            $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this.datePicker.model.value, "dd MMM yyyy"));
            !this.model.timeDrillDown.showMeridian && $(".e-mins-header", this._sfTimeMins).css("display", "none");

            // Bind action to the item.
            this._on(table.find('.e-mins'), "click", $.proxy(this._minsNavHandler, this));
            this._on($('.e-next', this._sfTimeMins), "click", $.proxy(this._prevNextMinsHandler, this));
            this._on($('.e-prev', this._sfTimeMins), "click", $.proxy(this._prevNextMinsHandler, this));
            this._on($('.e-footer', this._sfTimeMins), "click", this._todayBtn);
            $('.e-minitues-headertext', this._sfTimeMins).on("click", $.proxy(this._forwardNavHandler, this));
            this._sfTimeMins.hide();
        },
        _todayBtn: function () {
            this._nowClick();
            this._hideResult();
        },
        _hourNavHandler: function (e) {
            var value;
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && $(e.target).hasClass("e-disable")) return false;
            if (e && e.type) e.preventDefault();

            $("table", this._sfTimeHour).find("td").removeClass("e-active");
            $(e.target).addClass("e-active");

            this._sfTimeHour.hide();
            this._sfTimeMins.show();
            this._addFocus(this._sfTimeMins);
            if (this.model.timeDrillDown.showMeridian) {
                var txt = $(e.target).hasClass("e-hour-am") ? "AM" : "PM";
                value = $(e.target).text() + ":00 " + txt;
            }
            else
                value = $(e.target).text();
            this._generateMins(value);
            var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
            var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
            var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));
            var index = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
            index = Math.ceil(index);
            this._hoverMins = this._setFocusByIndex("mins", index, this._sfTimeMins);
        },
        _minsNavHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && $(e.target).hasClass("e-disable")) return false;
            if (e && e.type) e.preventDefault();
            $("table", this._sfTimeMins).find("td").removeClass("e-active").removeClass("e-state-hover");
            $(e.target).addClass("e-active");
            if (this.model.timeDrillDown.showMeridian) {
                var value = $(e.target).text() + " " + ej.format(this._datetimeValue, "tt", "en-US");
                value = this.timePicker._localizeTime(value)
            }
            else
                value = $(e.target).text();
            this.timePicker.option("value", value);
            this.datePicker.option("value", this._datetimeValue);
            this._datetimeValue = new Date(this.model.value.toString());
            this._updateInput();
            this.model.timeDrillDown.autoClose && this._hideResult(e);
        },
        _generateMins: function (value) {
            var minsTable = $('table', this._sfTimeMins);
            minsTable.empty();
            this.model.timeDrillDown.showMeridian ? $(".e-mins-header", this._sfTimeMins).show() : $(".e-mins-header", this._sfTimeMins).hide()
            var displayFormat = this.model.timeDrillDown.showMeridian ? "hh:mm" : "HH:mm";
            $('.e-minitues-headertext', this._sfTimeMins).text($('.e-hours-headertext', this._sfTimeHour).text());
            var tbody = ej.buildTag('tbody.e-timepicker-mins').attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var start, tr, end, timeVal, count = 0, interval = this.model.timeDrillDown.interval * 60000;
            start = this.timePicker._createObject(value);
            this._datetimeValue.setHours(start.getHours());
            end = this.timePicker._createObject(start).getTime() + 59 * 60000;
            tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            tbody.append(tr);
            while (this.timePicker._compareTime(end, start, true)) {
                if (count >= 4) {
                    count = 0;
                    tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    tbody.append(tr);
                }
                timeVal = this._localizeTime(start, displayFormat);
                var tdtag = ej.buildTag("td.e-mins e-state-default", timeVal);
                if (this._isIE8)
                    tdtag.attr("unselectable", "on");
                tr.append(tdtag);
                count++;
                start = this.timePicker._createObject(start).getTime() + interval;
            }
            minsTable.append(tbody);
            $(".e-mins-header", this._sfTimeMins).find('.e-minitues-meridiantxt').text(ej.format(this._datetimeValue, "tt", this.model.locale))
            this._disableRange("mins");
            this._on(minsTable.find('.e-mins'), "click", $.proxy(this._minsNavHandler, this));
        },
        _prevNextHourHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            event.preventDefault();
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrev(progress, this._sfTimeHour);
        },
        _prevNextMinsHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            event.preventDefault();
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrev(progress, this._sfTimeMins);
        },
        _processNextPrev: function (progress, wrapper) {
            if (progress && wrapper.find(".e-arrow-sans-left").hasClass("e-disable")) return false;
            else if (!progress && wrapper.find(".e-arrow-sans-right").hasClass("e-disable")) return false;
            var currentTable = $("table", wrapper), temp;
            var incVal, tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case "e-dp-viewhours":
                    incVal = progress ? -1 : 1;
                    this._datetimeValue.setDate(this._datetimeValue.getDate() + incVal);
                    this._disableRange("hour");

                    this._hoverHour = this._setFocusByIndex("hour", this._hoverHour, this._sfTimeHour);
                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    break;
                case "e-dp-viewmins":
                    incVal = progress ? -1 : 1;
                    this._datetimeValue.setHours(this._datetimeValue.getHours() + incVal);
                    this._generateMins($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)));

                    var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
                    var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
                    var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));

                    var index = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
                    index = Math.ceil(index);

                    this._disableRange("mins");

                    this._hoverMins = this._setFocusByIndex("mins", index, this._sfTimeMins);

                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    break;
            }
        },
        _forwardNavHandler: function (event, table) {
            if (this.model.readOnly || !this.model.enabled) return false;
            var hclassName, proxy = this;
            if (event) event.preventDefault();
            if (event)
                hclassName = $(event.currentTarget).get(0).className;
            else
                hclassName = table.find(".e-text>span").get(0).className;

            switch (hclassName) {
                case "e-hours-headertext":
                    this._sfTimeHour.css("display", "none");
                    this._dateContainer.css("display", "block");
                    this._addFocus(this._dateContainer.find('.e-datepicker'));
                    break;
                case "e-minitues-headertext":
                    this._sfTimeMins.css("display", "none");
                    this._disableRange("hour");

                    var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
                    var val = $.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale));
                    indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
                    indx = Math.floor(indx);

                    this._hoverHour = this._setFocusByIndex("hour", indx, this._sfTimeHour);

                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    this._sfTimeHour.css("display", "block");
                    this._addFocus(this._sfTimeHour);
                    break;
            }
        },
        _renderDateControl: function () {
            var dateInput = ej.buildTag("input#" + this.element[0].id + "_date", "", {}, { "type": "text" });
            this.popup.append(dateInput);
            dateInput.ejDatePicker({

                height: "0px", width: "0px",
                displayInline: true,
                showDateIcon: false,
                showFooter: this.model.timeDrillDown.enabled ? this.model.timeDrillDown.showFooter : false,
                enableStrictMode: true,
                buttonText: this._localizedLabels.buttonText.today,

                minDate: this._stringToObject(this.model.minDateTime),
                maxDate: this._stringToObject(this.model.maxDateTime),

                dayHeaderFormat: this.model.dayHeaderFormat,
                startLevel: this.model.startLevel,
                depthLevel: this.model.depthLevel,
                startDay: this.model.startDay,
                stepMonths: this.model.stepMonths,
                showOtherMonths: this.model.showOtherMonths,
                headerFormat: this.model.headerFormat,

                enabled: this.model.enabled,
                enableRTL: this.model.enableRTL,
                showRoundedCorner: this.model.showRoundedCorner,
                readOnly: this.model.readOnly,
                cssClass: this.model.cssClass,
                locale: this.model.locale
            });
            this.datePicker = dateInput.data("ejDatePicker");
            this.model.startDay = this.datePicker.model.startDay;
            this.datePicker._getInternalEvents = true;
            this.datePicker._dt_drilldown = true;
            this.datePicker.popup.css({ "position": "static", "display": "block" });
        },
        _renderTimeControl: function () {
            var timeInput = ej.buildTag("input#" + this.element[0].id + "_time", "", {}, { "type": "text" });
            this.popup.append(timeInput);

            timeInput.ejTimePicker({
                height: "0px", width: "0px",
                interval: this.model.interval,
                timeFormat: this.model.timeDisplayFormat,
                popupWidth: this.model.timePopupWidth,
                enabled: this.model.enabled,
                enableRTL: this.model.enableRTL,
                showRoundedCorner: this.model.showRoundedCorner,
                readOnly: this.model.readOnly,
                cssClass: this.model.cssClass,
                locale: this.model.locale
            });
            this.timePicker = timeInput.data("ejTimePicker");
            this.timePicker._getInternalEvents = true;
            this.timePicker.showDropdown = true;
            this.timePicker._dateTimeInternal = true;
            this.timePicker.popup.css({ "position": "static", "display": "block" });
            var min = (this.model.minDateTime) ? this._stringToObject(this.model.minDateTime) : this.defaults.minDateTime;
            var max = (this.model.maxDateTime) ? this._stringToObject(this.model.maxDateTime) : this.defaults.maxDateTime;
           
        },
        _updateTimeHeight: function () {
            var height = this.popup.find(".e-timecontainer .e-header").is(":visible") ? this.datePicker.popup.height() - this.popup.find(".e-header").height() : this.datePicker.popup.height();
            height = this.popup.hasClass("e-dt-responsive") ? "98px" : height;
            this.timePicker.option("popupHeight", height);
        },

        _bindOperations: function () {
            var proxy = this;
            this.datePicker.option("layoutChange", function () { proxy._updateTimeHeight(); });
            this.datePicker.option("outOfRange", function () { proxy.isValidState = false; });
            this.timePicker.option("outOfRange", function () { proxy.isValidState = false; });
            this.datePicker.option("change", function (a) {
                proxy._refreshTimes(a);
            });
            this.datePicker.option("select", function (e) {
                proxy._updateInput(e);
            });
            this.datePicker.option("dt_drilldown", function (e) {
                if (proxy.model.timeDrillDown.enabled) {
                    proxy._updateInput(e);
                    proxy._switchToDrilDown(e);
                }
            });
            this.timePicker.option("select", function () { proxy._updateInput(); });
        },
        _switchToDrilDown: function (e) {
            this._dateContainer.hide();
            this._sfTimeHour.show();
            this._addFocus(this._sfTimeHour);
            var selected = new Date(this.model.value.toString());
            this._datetimeValue = new Date(selected.setHours(this._datetimeValue.getHours(), this._datetimeValue.getMinutes(), this._datetimeValue.getSeconds(), this._datetimeValue.getMilliseconds()));

            // To hide the hours that exceeds the min and max.
            this._disableRange("hour");

            var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
            var val = $.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale));
            var indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
            indx = Math.floor(indx);

            this._hoverHour = this._setFocusByIndex("hour", indx, this._sfTimeHour);

            $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
            $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
        },
        _disableRange: function (view) {
            var interval = view == "hour" ? this._interval : this.model.timeDrillDown.interval, table = view == "hour" ? this._sfTimeHour : this._sfTimeMins
            var addClassName = view == "hour" ? "e-hide-hour e-disable" : "e-hide-mins e-disable";
            table.find('tbody tr td.e-' + view).removeClass(addClassName);
            table.find('.e-arrow-sans-left').removeClass("e-disable");
            table.find('.e-arrow-sans-right').removeClass("e-disable");
            var start = view == "hour" ? this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00") :
                this._localizeTime($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)), "HH:00");

            if (this._compareDate(this.model.minDateTime, this._datetimeValue)) {
                if (view == "mins")
                    if (!(this.model.minDateTime.getHours() === this._datetimeValue.getHours())) return false;
                var val = $.trim(ej.format(this.timePicker._createObject(this.model.minDateTime), "HH:mm", this.model.locale));
                indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (interval * 60000);
                indx = view == "hour" ? Math.floor(indx) : Math.ceil(indx);
                for (i = 0; i < indx; i++) {
                    var allValues = table.find('tbody tr td.e-' + view), cell;
                    cell = allValues[i];
                    $(cell).addClass(addClassName);
                }
                table.find('.e-arrow-sans-left').addClass("e-disable");
            }
            if (this._compareDate(this.model.maxDateTime, this._datetimeValue)) {
                if (view == "mins")
                    if (!(this.model.maxDateTime.getHours() === this._datetimeValue.getHours())) return false;
                var val = $.trim(ej.format(this.timePicker._createObject(this.model.maxDateTime), "HH:mm", this.model.locale));
                indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (interval * 60000);
                indx = Math.floor(indx) + 1;
                var length = table.find('tbody tr td.e-' + view).length
                for (i = indx; i < length; i++) {
                    var allValues = table.find('tbody tr td.e-' + view), cell;
                    cell = allValues[i];
                    $(cell).addClass(addClassName);
                }
                table.find('.e-arrow-sans-right').addClass("e-disable");
            }
        },
        _setFocusByName: function (name, value, table) {
            var allValues = table.find('tbody tr td.e-' + name), index, cell;
            $(allValues).each(function (i, ele) {
                if (ele.innerHTML == value) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            table.find('table td').removeClass("e-state-hover").removeClass('e-active');
            if (!$(cell).hasClass("e-hide-" + name))
                $(cell).addClass("e-state-hover");
            this._setActiveState(name, table);
            return index;
        },

        _setFocusByIndex: function (name, index, table) {
            var allValues = table.find('tbody tr td.e-' + name), cell;
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            table.find('table td').removeClass("e-state-hover").removeClass('e-active');
            if (!$(cell).hasClass("e-hide-" + name))
                $(cell).addClass("e-state-hover");
            this._setActiveState(name, table);
            return index;
        },

        _setActiveState: function (selection, table) {
            var items = table.find('tbody tr td.e-' + selection), cell, proxy = this;
            var indx = -1;
            switch (selection) {
                case "hour":
                    if (this._compareDate(this.model.value, this._datetimeValue)) {

                        var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
                        var val = $.trim(ej.format(this.timePicker._createObject(this.model.value), "HH:00", this.model.locale));
                        indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
                        indx = Math.floor(indx);

                    }
                    break;
                case "mins":
                    if (this._compareDate(this.model.value, this._datetimeValue) && (this.model.value.getHours() === this._datetimeValue.getHours())) {

                        var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
                        var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
                        var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));

                        indx = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
                        indx = Math.ceil(indx);
                    }
                    break;
            }
            cell = items[indx];
            if (cell) {
                table.find('table td').removeClass("e-active");
                $(cell).removeClass("e-state-hover").addClass("e-active");
            }
        },

        _compareDate: function (first, second) {
            var val1 = new Date(first.toString()).setHours(0, 0, 0, 0);
            var val2 = new Date(second.toString()).setHours(0, 0, 0, 0);
            var result = (+val1 === +val2) ? true : false;
            return result;
        },

        _updateInput: function (e) {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var date = this._getDate() || new Date(), time = this._getTime() || this.timePicker._createObject(minVal);
            this.model.value = new Date(date.getFullYear(), date.getMonth(), date.getDate(),
                time.getHours(), time.getMinutes(), time.getSeconds());      
            this._updateDateTime();
            this._raiseChangeEvent();
            this._updateModel(e,true);
            if (e)
                e.cancel = true;
        },
        _updateDateTime: function () {
            this.isValidState = true;
            var datetime = this._objectToString(this.model.value);
            this.element.val(datetime);
            this._removeWatermark();
        },
        _refreshTimes: function (args) {
            var value = this._getDateObj(args.value, this.datePicker.model.dateFormat);
            if (!value) return false;
            this.isValidState = true;

            if (this._compare(value, this._setEmptyTime(this.model.minDateTime))) {
                var mintime = this._getFormat(this.model.minDateTime, this.timePicker.model.timeFormat);
                var preTime = this._getTime();
                this.timePicker.option("minTime", mintime);
                if (!this.model.enableStrictMode) {
                    this._updateInput();
                }
            }
            else
                this.timePicker.option("minTime", this._defaultMinVal());

            if (this._compare(value, this._setEmptyTime(this.model.maxDateTime))) {
                var maxtime = this._getFormat(this.model.maxDateTime, this.timePicker.model.timeFormat);
                var preTime = this._getTime();
                this.timePicker.option("maxTime", maxtime);
                if (!this.model.enableStrictMode) {
                    this._updateInput();
                }
            }
            else
                this.timePicker.option("maxTime", this._defaultMaxVal());

            this.timePicker._changeActiveEle();
        },

        _defaultMinVal: function () {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var minTimeVal = ej.format(this.timePicker._createObject(minVal), this.timePicker.model.timeFormat, this.timePicker.model.locale);
            return minTimeVal;
        },
        _defaultMaxVal: function () {
            var maxval = new Date().setHours(23, 59, 59, 59);
            var maxTimeVal = ej.format(this.timePicker._createObject(maxval), this.timePicker.model.timeFormat, this.timePicker.model.locale);
            return maxTimeVal;
        },
        _updateValues: function () {
            var dateValue = this.model.value;
            if (this.model.value != null) {
                this.datePicker.option("value", this.model.value);
                this.timePicker.option("value", this.model.value);
            }
            this._setValue(dateValue);
            this._validateMinMax();
            this._preVal = this.element.val();
            this._checkErrorClass();
        },
        _specificFormat: function () {
            var parseInfo = ej.globalize._getDateParseRegExp(ej.globalize.findCulture(this.model.locale).calendar, this.model.dateFormat);
            return ($.inArray("dddd", parseInfo.groups) > -1 || $.inArray("ddd", parseInfo.groups) > -1)
        },
        _changeEditable: function (bool) {
            var action = bool ? "_on" : "_off";
            if (this.element.is(":input")) {
                if (bool) {
                    if (!this.model.readOnly) this.element.attr("readonly", false);
                    this.element.off("mousedown", $.proxy(this._showhidePopup, this));
                }
                else {
                    if (!this.model.readOnly) this.element.attr("readonly", "readonly");
                    this.element.on("mousedown", $.proxy(this._showhidePopup, this));
                }
                this[action](this.element, "blur", this._targetBlur);
                this[action](this.element, "focus", this._targetFocus);
                this[action](this.element, "keydown", this._keyDownOnInput);
            }
            this._change("allowEdit", bool);
        },
        _setValue: function (value) {
            if (!value || (typeof JSON === "object" && JSON.stringify(value) === "{}")) {
                this.element.val("");
                this.model.value = null;
                this.isValidState = true;
                this.wrapper.removeClass('e-valid');
            }
            else if (typeof value === "string") {
                if (this._extISORegex.exec(value) || this._basicISORegex.exec(value)) this._checkObject(this._dateFromISO(value));
                else {
                    this.element.val(value);
                    this._updateModel();
                    this._validateMinMax();
                    this._checkStrictMode();
                    this.wrapper.addClass('e-valid');
                }
            }
            else if (value instanceof Date && this._isValidDate(value)) {
                this._checkObject(value);
            }
            this._checkErrorClass();
            return this.model.value;
        },
        _checkObject: function (value) {
            if (value instanceof Date && this._isValidDate(value)) {
                this.model.value = value;
                this._updateDateTime();
                this._validateMinMax();
                this._checkStrictMode();
            }
        },
        _dateFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _validateValue: function (value) {
            var dateObj = ej.parseDate(value, this.model.dateTimeFormat);
            if (!dateObj || dateObj < this.model.minDateTime || dateObj > this.model.maxDateTime) {
                this.model.value = null;
                this._change("value", this.model.value);
                this.isValidState = false;
            }
            else {
                this._change("value", this.model.value);
                this.isValidState = true;
            }
        },
        _validateMinMax: function () {
            var value, min, max;
            value = (this.model.value) ? this._stringToObject(this.model.value) : null;
            min = (this.model.minDateTime) ? this._stringToObject(this.model.minDateTime) : this.defaults.minDateTime;
            max = (this.model.maxDateTime) ? this._stringToObject(this.model.maxDateTime) : this.defaults.maxDateTime;
            if (!value || !min || !max) return false;
            if (min > max) this.model.minDateTime = this.model.maxDateTime;
            if (value < min) {
                if (!this.model.enableStrictMode) {
                    this._setValue(min);
                    this.isValidState = true;
                }
                else if (this.model.enableStrictMode) {
                    this.datePicker.option('minDate', this._getFormat(min, this.datePicker.model.dateFormat));
                    this.timePicker.option('minTime', this._getFormat(min, this.timePicker.model.timeFormat));
                    this.isValidState = false;
                }
            }
            if (value > max) {
                if (!this.model.enableStrictMode) {
                    this._setValue(max);
                    this.isValidState = true;
                }
                else if (this.model.enableStrictMode) {
                    this.datePicker.option('maxDate', this._getFormat(max, this.datePicker.model.dateFormat));
                    this.timePicker.option('maxTime', this._getFormat(max, this.timePicker.model.timeFormat));

                    this.isValidState = false;

                }
            }

            if (!(value < min) && !(value > max)) this.isValidState = true;
        },

        _checkProperties: function () {
            this.model.readOnly && this._readOnly(true);
            this.model.showRoundedCorner && this._setRoundedCorner(true);
            this.model.enableRTL && this._setRtl(true);
            this.model.enabled && this._enabled(true);
            if (!this.model.enabled) this._enabled(false);
            else if (this.model.enabled && this.element.hasClass("e-disable")) this._enabled(true);
            this.model.name = !this._options.name ? !this.element.attr("name") ? this.element[0].id : this.element.attr("name") : this.model.name;
            this.element.attr("name", this.model.name);
            this._checkStrictMode();
            this._checkErrorClass();
            this._datetimeValue = new Date(this.datePicker._dateValue.toString());
            if (!ej.isNullOrUndefined(this.model.value))
                this._datetimeValue = new Date(this.model.value.toString());
            this._setWaterMark();
        },

        _checkStrictMode: function () {
            if (!this.model.enableStrictMode) {
                if (!this.isValidState) {
                    if (this.model.value < this.model.minDateTime) {
                        this.element.val(this._objectToString(this.model.minDateTime));
                        this.model.value = this.model.minDateTime;
                        this.isValidState = true;
                    }
                    else if (this.model.value > this.model.maxDateTime) {
                        this.element.val(this._objectToString(this.model.maxDateTime));
                        this.model.value = this.model.maxDateTime;
                        this.isValidState = true;
                    }
                    else {
                        this.model.value = "";
                        this.element.val("");
                        this.isValidState = true;
                    }
                }
            }
            else if (this.model.enableStrictMode) {
                if (!this.isValidState) {

                        this.model.value = null;
                        this.isValidState = false;
                }
            }
        },

        _targetFocus: function (e) {
            e.preventDefault();
            this.isFocused = true;
            this.wrapper.addClass("e-focus");
            this.wrapper.removeClass("e-error");
            if (!this._isSupport) this._hiddenInput.css("display", "none");
            this._prevDateTimeVal = this.element.val();
            if (!this.model.showPopupButton && !this.model.readOnly) this._showResult();
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
            this._trigger("focusIn", { value: this.model.value });
            this.wrapper.addClass('e-valid');
        },
        _targetBlur: function () {
            this.isFocused = false;
            this.wrapper.removeClass("e-focus");
            if (!this.model.showPopupButton) this._hideResult();
            var dateObj = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (dateObj && !this.model.enableStrictMode) {
                if (dateObj < this.model.minDateTime || dateObj > this.model.maxDateTime) {
                    dateObj = dateObj < this.model.minDateTime ? this.model.minDateTime : this.model.maxDateTime;
                    this.element.val(this._objectToString(dateObj));
                }
            }
            var val = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (val == null && !this.model.enableStrictMode) {
                if (this._prevDateTimeVal == null || this.element.val() == "") {
                    this.element.val("");
                } else
                    this.element.val(this._preVal);
            }
            this._valueChange();
            if (!this.model.enableStrictMode) {
                if (!this.isValidState) {
                    this.element.val(this._prevDateTimeVal);
                    this._preVal = this._prevDateTimeVal;
                    this.model.value = this._stringToObject(this._prevDateTimeVal);
                    this.isValidState = true;
                }
                else
                    this._prevDateTimeVal = this.element.val();
            } else if (this.element.val() != "")
                this._validateValue(this.element.val());
            if (!this._isSupport && this.element.val() == "")
                this._hiddenInput.css("display", "block");
            this._checkErrorClass();
            if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
            this._trigger("focusOut", { value: this.model.value });
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            this._previousDateUpdate();
        },
        _previousDateUpdate: function () {
            var previous = ej.parseDate(this._prevDateTime, this.model.dateTimeFormat);
            var current = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (!(+previous === +current)) {
                this._preValString = this._prevDateTime;
                this._prevDateTime = this.element.val();
            }
            return this._preValString;
        },
        _elementClick: function () {
            if (!this.isPopupOpen) this._showResult();
        },
        _keyDownOnInput: function (e) {
            switch (e.keyCode) {
                case 40:
                    if (e.altKey) this._showhidePopup();
                    break;
                case 37:
                case 39:
                    if (!this.model.timeDrillDown.enabled)
                        if (e.altKey && this.isPopupOpen) {
                            e.preventDefault();
                            this._addPrevNextFocus(e.keyCode == 37);
                        }
                    break;
                case 27:
                    e.preventDefault();
                case 9:
                    this._hideResult();
                    break;
                case 13:    // Enter Key
                    var val = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
                    if (val == null && !this.model.enableStrictMode) {
                        if (this._prevDateTimeVal == null || this.element.val() == "") {
                            this.element.val("");
                        } else
                            this.element.val(this._preVal);
                    }
                    this._valueChange();
                    if (!this.model.timeDrillDown.enabled) {
                        this._valueChange();
					 if (this.model.enableStrictMode) 
                        this._checkErrorClass();
                        break;
                    }
            }
        },
        _addFocus: function (target) {
            if (!target.hasClass("e-focus")) {
                this._removeFocus();
                target.addClass("e-focus");
                if (target.hasClass("e-datepicker e-popup"))
                    $(document).on("keydown", $.proxy(this.datePicker._keyboardNavigation, this.datePicker));
                else if (target.hasClass("e-timecontainer"))
                    $(document).on("keydown", $.proxy(this.timePicker._keyDownOnInput, this.timePicker));
                else if (target.hasClass("e-time-hours"))
                    $(document).on("keydown", $.proxy(this._keyDownOnHours, this));
                else if (target.hasClass("e-time-minitues"))
                    $(document).on("keydown", $.proxy(this._keyDownOnMinutes, this));
                else if (target.hasClass("e-dt-button"))
                    $(document).on("keydown", $.proxy(this._buttonClick, this));
            }
        },
        _removeFocus: function () {
            var target = this._getFocusedElement();
            if (target.length > 0) {
                target.removeClass("e-focus");
                if (target.hasClass("e-datepicker e-popup"))
                    $(document).off("keydown", $.proxy(this.datePicker._keyboardNavigation, this.datePicker));
                else if (target.hasClass("e-timecontainer"))
                    $(document).off("keydown", $.proxy(this.timePicker._keyDownOnInput, this.timePicker));
                else if (target.hasClass("e-time-hours"))
                    $(document).off("keydown", $.proxy(this._keyDownOnHours, this));
                else if (target.hasClass("e-time-minitues"))
                    $(document).off("keydown", $.proxy(this._keyDownOnMinutes, this));
                else if (target.hasClass("e-dt-button"))
                    $(document).off("keydown", $.proxy(this._buttonClick, this));
            }
        },
        _addPrevNextFocus: function (flag) {
            // flag true means previous focus, false means next focus
            var target = this._getFocusedElement(), next;
            if (target.length > 0) {
                if (target.hasClass("e-datepicker e-popup"))
                    next = flag ? this.popup.find(".e-dt-done") : this.popup.find(".e-timecontainer");
                else if (target.hasClass("e-timecontainer"))
                    next = flag ? this.popup.find(".e-datecontainer >.e-datepicker.e-popup") : this.popup.find(".e-dt-today");
                else if (target.hasClass("e-dt-today"))
                    next = flag ? this.popup.find(".e-timecontainer") : this.popup.find(".e-dt-now");
                else if (target.hasClass("e-dt-now"))
                    next = flag ? this.popup.find(".e-dt-today") : this.popup.find(".e-dt-done");
                else if (target.hasClass("e-dt-done"))
                    next = flag ? this.popup.find(".e-dt-now") : this.popup.find(".e-datecontainer >.e-datepicker.e-popup");
            }
            else next = flag ? this.popup.find(".e-dt-done") : this.popup.find(".e-datecontainer >.e-datepicker.e-popup");
            this._addFocus(next);
        },
        _getFocusedElement: function () {
            return this.popup.children("div").find("div.e-focus")
        },
        _keyDownOnHours: function (e) {
            if ((e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                var t = { row: null, col: null };

                t.col = this._sfTimeHour.find('tbody tr td.e-state-hover').index();
                t.row = this._sfTimeHour.find('tbody tr td.e-state-hover').parent().index();

                if (t.col != -1)
                    t.col = t.col + 1;
                else
                    t.col = this._sfTimeHour.find('tbody tr td.e-active').index() + 1;


                if (t.row != -1) {
                    t.row = t.row + 1;
                    if (this.model.timeDrillDown.showMeridian && this._sfTimeHour.find('tbody tr td.e-state-hover').hasClass('e-hour-pm'))
                        t.row = t.row + 2;
                }
                else {
                    t.row = this._sfTimeHour.find('tbody tr td.e-active').parent().index() + 1;
                    if (this.model.timeDrillDown.showMeridian && this._sfTimeHour.find('tbody tr td.e-active').hasClass('e-hour-pm'))
                        t.row = t.row + 2;
                }

                var tableClass = this._sfTimeHour.find('table')[0].className, next;
                rowLength = this._sfTimeHour.find('tbody.e-timepicker-hours tr').length, colLength = this.model.timeDrillDown.showMeridian ? 6 : 4;
                next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "hours", e.ctrlKey);
                if (!e.ctrlKey) this._hoverHour = this._sfTimeHour.find('tbody.e-timepicker-hours tr td').index(next);

                if (!e.ctrlKey) {
                    this._sfTimeHour.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
        },

        _changeRowCol: function (t, key, rows, cols, target, ctrlKey) {
            var eleClass, table, cls = { parent: null, child: null };
            switch (target) {
                case "hours": eleClass = "tbody.e-timepicker-hours tr td.e-hour";
                    cls.parent = ".e-timepicker-hours", cls.child = ".e-hour";
                    hiddenClass = ".e-hide-hour";
                    table = this._sfTimeHour;
                    break;
                case "mins": eleClass = "tbody.e-timepicker-mins tr td.e-mins";
                    cls.parent = ".e-timepicker-mins", cls.child = ".e-mins";
                    hiddenClass = ".e-hide-mins";
                    table = this._sfTimeMins;
                    cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child).length;
                    break;

            }
            if (t.row <= 0 && t.col <= 0)
                return table.find(eleClass + ':not(.e-disable):first');
            var cell, proxy = this;
            switch (key) {
                case 36:
                    return table.find(eleClass + ':not(.e-disable):first');
                case 35:
                    return table.find(eleClass + ':not(.e-disable):last');
                case 38:
                    if (ctrlKey) {
                        this._forwardNavHandler(null, table);
                    }
                    else if (t.row > 1) {
                        t.row -= 1;
                    }
                    else {
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':nth-child(' + t.col + '):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "up", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':nth-child(' + t.col + '):last');
                    }
                    return cell;
                case 37:
                    if (ctrlKey) {
                        this._processNextPrev(true, table);
                        return table.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col > 1)
                        t.col -= 1;
                    else if (t.row > 1) {
                        t = { row: t.row - 1, col: cols }
                        // different columns for the mins popup.
                        if (target == "mins") t.col = cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child).length;
                    }
                    else {
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':not(.e-disable):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "left", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':not(.e-disable):last');
                    }
                    return cell;
                case 39:
                    if (ctrlKey) {
                        this._processNextPrev(false, table);
                        return table.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col < cols)
                        t.col += 1;
                    else if (t.row < rows) {
                        t = { row: t.row + 1, col: 1 }
                    }
                    else {
                        this._processNextPrev(false, table);
                        cell = table.find(eleClass + ':not(.e-disable):first');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "right", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(false, table);
                        cell = table.find(eleClass + ':not(.e-disable):first');
                    }
                    return cell;
                case 40:
                    if (!ctrlKey) {
                        if (t.row < rows) {
                            t.row += 1;
                        }
                        else {
                            this._processNextPrev(false, table);
                            cell = table.find(eleClass + ':nth-child(' + t.col + '):first');
                            return cell;
                        }
                        cell = this._getCell(t, cls, table).not(hiddenClass);
                        if (cell.length <= 0) {
                            cell = this._findVisible(t, cls, "down", table);
                            if (cell !== null) return cell;
                            this._processNextPrev(false, table);
                            cell = table.find(eleClass + ':nth-child(' + t.col + '):first');
                        }
                        return cell;
                    }
                case 13:
                    var ele, element;
                    ele = this._getCell(t, cls, table); element = $(ele)[0];
                    args = { type: null, target: ele };
                    if (target == "hours") this._hourNavHandler(args);
                    if (target == "mins") this._minsNavHandler(args);
                    break;
            }
            return this._getCell(t, cls, table).not(hiddenClass);
        },
        _getCell: function (t, cls, table) {
            var row = t.row;
            if (this.model.timeDrillDown.showMeridian && t.row > 2 && table.hasClass('e-time-hours'))
                row = row - 2;
            var cell = table.find('tbody' + cls.parent + ' tr:nth-child(' + row + ') td' + cls.child + ':nth-child(' + t.col + ')');
            if (this.model.timeDrillDown.showMeridian && cell.length > 0 && table.hasClass('e-time-hours'))
                cell = t.row <= 2 ? $(cell[0]) : $(cell[1]);
            return cell;
        },
        _findVisible: function (t, cls, key, table) {
            var cols = t.col, rows = t.row, requiredClass = cls.child.slice(1, cls.child.length);
            for (i = 0; i >= 0; i++) {
                //nextElement = table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td:nth-child(' + cols + ')');
                nextElement = this._getCell({ row: rows, col: cols }, cls, table)
                if (nextElement.length <= 0) {
                    return null;
                }
                if (nextElement.hasClass('e-disable') || !nextElement.is(":visible")) {
                    key == "right" || key == "left" ? (key == "right" ? cols++ : cols--) : (key == "down" ? rows++ : rows--);
                    if ((rows <= 0) || (rows > table.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                    // Column exceeds the range. 
                    if (cols > table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length) {
                        //move to next row and select first column
                        rows++;
                        cols = 1;
                    }
                    if (cols <= 0) {
                        //move to previous row and select last column
                        rows--;
                        cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length;
                    }
                    // Row exceeds the range.
                    if ((rows <= 0) || (rows > table.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                } else if (nextElement.hasClass(requiredClass)) {
                    t.col = cols; t.row = rows;
                    nextElement = this._getCell(t, cls, table)
                    return nextElement;
                }
            }
        },
        _keyDownOnMinutes: function (e) {
            if ((e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                var t = { row: null, col: null };

                t.col = this._sfTimeMins.find('tbody tr td.e-state-hover').index();
                t.row = this._sfTimeMins.find('tbody tr td.e-state-hover').parent().index();

                t.col = (t.col != -1) ? t.col + 1 : this._sfTimeMins.find('tbody tr td.e-active').index() + 1;
                t.row = (t.row != -1) ? t.row + 1 : this._sfTimeMins.find('tbody tr td.e-active').parent().index() + 1;

                var tableClass = this._sfTimeMins.find('table')[0].className, next;
                rowLength = this._sfTimeMins.find('tbody.e-timepicker-mins tr').length, colLength = 4;
                next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "mins", e.ctrlKey);
                if (!e.ctrlKey) this._hoverHour = this._sfTimeMins.find('tbody.e-timepicker-mins tr td').index(next);

                if (!e.ctrlKey) {
                    this._sfTimeMins.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
        },
        _valueChange: function (isCode) {
            if (!this.model.enableStrictMode) {
                if (this._preVal != this.element.val()) {
                    this._preVal = this.element.val();
                    this._updateModel();
                    this._validateMinMax();
                    this._raiseChangeEvent(isCode);
                }
                this._setWaterMark();
            }
            else if (this.model.enableStrictMode) {
                if (this._preVal != this.element.val() || this.model.value < this.model.minDateTime || this.model.value > this.model.maxDateTime) {
                    this._updateModel();
                    this._raiseChangeEvent(isCode);
                }
            }
        },
        _updateModel: function (e,stopUpdateModel) {
            if (this._stopRefresh) {
                this._stopRefresh = false
                return;
            }
            var value = this.element.val();
            if (value == "") {
                this.model.value = null;
                this._change("value", this.model.value);
                this.isValidState = true;
            }
            else {
                var dateObj;
                if (e != undefined && e.type == "select" || this._prevDateTimeVal == this.element.val()) dateObj = this.model.value;
                else dateObj = ej.parseDate(value, this.model.dateTimeFormat, this.model.locale);
                if (dateObj) {
                    this.model.value = dateObj;
                    this.isValidState = true;
					if(!stopUpdateModel)					
                    this._refreshPopup();
                    if (this._specificFormat() && this._prevDateTimeVal != this.element.val())
                        this.element.val(this._objectToString(this.model.value));
                }
                else {
                    this.model.value = null;
                    this._change("value", this.model.value);
                    this.isValidState = false;
                    if (!this.model.enableStrictMode) 
                        this.element.val(this._objectToString(this.model.value));
                }
            }
        },
        _refreshPopup: function () {
            if (this.isValidState && this.isPopupOpen) {
                var date = this._setEmptyTime(this.model.value), time = this._setEmptyDate(this.model.value);
                var getDate = this._getDate(), getTime = this._getTime();
                if (!getDate || !this._compare(getDate, date)) this.datePicker.option("value", date);
                if (!getTime || !this._compare(getTime, time)) this.timePicker.option("value", time);
            }
        },

        _buttonClick: function (e) {
            if (e.keyCode == 13) {
                e.preventDefault();
                var target = this._getFocusedElement();
                if (target.hasClass("e-dt-today"))
                    this._todayClick();
                else if (target.hasClass("e-dt-now"))
                    this._nowClick();
                else if (target.hasClass("e-dt-done"))
                    this._doneClick();
            }
        },
        _todayClick: function () {
            if (!this.model.enabled || this.model.readOnly) return false;
            if (!this.datePicker.popup.find(".today").hasClass("e-active") ||
                !this.datePicker.popup.children("table").hasClass("e-dp-viewdays") ||
                this.element.val() == "" || !this.isValidState) {
                this.datePicker._setCurrDate();
                this._updateInput();
            }
        },
        _nowClick: function () {
            if (!this.model.enabled || this.model.readOnly) return false;
            this.timePicker.setCurrentTime();
            var mintime = this.model.minDateTime, maxtime = this.model.maxDateTime, date = this.datePicker.model.value, time = new Date();
            date = ej.isNullOrUndefined(date) ? new Date() : date;
            var currTime = new Date(date.getFullYear(), date.getMonth(), date.getDate(), time.getHours(), time.getMinutes(), time.getSeconds());
            if (currTime < mintime)
                this.timePicker.option("value", this.timePicker._localizeTime(mintime));
            else if (currTime > maxtime)
                this.timePicker.option("value", this.timePicker._localizeTime(maxtime));
            this._updateInput();
        },
        _doneClick: function () {
            this._hideResult();
        },

        _iconClick: function (e) {
            e.preventDefault();
            if (!this.isFocused && (!ej.isTouchDevice())) this.element.focus();
            this._showhidePopup();
            if(this._isIE9)
            this.popup.find(".e-popup-container").css("display", "inline-block");
        },
        _setInitialSelection: function () {
            var elements = this.timePicker.ul.find("li");
            if (elements.hasClass('e-hover')) return;
            var currentTime = this.timePicker._setEmptyDate(new Date()), selected;
            selected = currentTime;
            if (this.timePicker.minTime && !this._compareTime(this._createObject(currentTime), this.timePicker.minTime, true))
                selected = this.timePicker.minTime;
            if (this.timePicker.maxTime && !this._compareTime(this.timePicker.maxTime, this._createObject(currentTime), true))
                selected = this.timePicker.maxTime;
            var firstTime = elements.first().html(), index;
            index = (this.timePicker._parse(selected) - this.timePicker._parse(firstTime)) / (this.timePicker.model.interval * 60000);
            index = Math.round(index);
            var activeItem = (index == elements.length) ? index : index + 1;
            if (activeItem < 0 || activeItem > elements.length || isNaN(activeItem)) activeItem = 1;
            var activeEle = $(this.timePicker.ul.find("li")[activeItem - 1]);
            activeEle.addClass('e-hover');
            this._calcScrollTop();
        },
        _calcScrollTop: function () {
            var ulH = this.timePicker.ul.outerHeight(), liH = this.timePicker.ul.find("li").outerHeight(), index, top;
            index = this.timePicker.ul.find("li.e-hover").index();
            top = (liH * index) - ((this.timePicker.popupList.outerHeight() - liH) / 2);
            this.timePicker.scrollerObj.setModel({ "scrollTop": top });
        },
        _showhidePopup: function () {
            if (this.model.readOnly) return false;
            if (!this.isPopupOpen)
                this._showResult();
            else
                this._hideResult();
        },
        _showResult: function () {
            if (this.isPopupOpen || !this.model.enabled) return false;
            if (this._trigger("beforeOpen", { element: this.popup })) return false;
            this.isPopupOpen = true;
            this._setListPosition();
            this._checkForResponsive();
            var proxy = this;
            this.popup.slideDown(this.model.enableAnimation ? 200 : 0, function () {
                proxy._on($(document), "mousedown", proxy._OnDocumentClick);
                proxy.model.timeDrillDown.enabled && proxy._addFocus(proxy._dateContainer.find('.e-datepicker'));
                if (!proxy.timePicker.model.value) proxy._setInitialSelection();
            });
            this._updateModel();
            this._updateTimeHeight();
            this._validateMinMax();
            this._on($(window), "resize", this._OnWindowResize);
            this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._raiseEvent("open");
            if (this._initial) {
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
                this._initial = false;
            }
            this.wrapper.addClass("e-active");
        },
        _hideResult: function (e) {
            var proxy = this;
            if (!this.isPopupOpen) return false;
            if (this._trigger("beforeClose", { element: this.popup })) return false;
            this.isPopupOpen = false;
            this._removeFocus();
            if (this._popClose && e && e.type != "click") {
                this.isPopupOpen = true;
                return;
            }
            this.popup.slideUp(this.model.enableAnimation ? 100 : 0, function () {
                if (proxy.model) {
                    if (proxy.model.timeDrillDown.enabled) {
                        proxy._sfTimeHour.hide();
                        proxy._sfTimeMins.hide();
                        proxy._dateContainer.show();
                    }
                    if (!ej.isNullOrUndefined(proxy.model.value))
                        proxy._datetimeValue = new Date(proxy.model.value.toString());
                }
            });
            this._raiseEvent("close");
            this._off($(document), "mousedown", this._OnDocumentClick);
            this._off($(window), "resize", this._OnWindowResize);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this.wrapper.removeClass("e-active");
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popup.outerHeight(),
            popupWidth = this.popup.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
			popupPosition = this.model.popupPosition;
            if (this.model.popupPosition == ej.PopupPosition.Bottom)
                var topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            else
                var topPos = ((popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popup.outerWidth() - elementObj.outerWidth();
            this.popup.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _OnDocumentClick: function (e) {
            if (this.model) {
                if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-datetime-popup").is(this.popup) &&
                    !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-datetime-wrap").is(this.wrapper)) {
                    this._hideResult();
                }
                else if ($(e.target).is(this.popup) || $(e.target).parents(".e-datetime-popup").is(this.popup)) {
                    e.preventDefault();
                    if ($(e.target).parents(".e-datepicker").length > 0) this._addFocus($(e.target).parents(".e-datepicker"));
                    else if ($(e.target).parents(".e-timecontainer").length > 0) this._addFocus($(e.target).parents(".e-timecontainer"));
                    else if ($(e.target).hasClass("e-dt-button")) this._addFocus($(e.target));
                    else if ($(e.target).parents(".e-time-hours").length > 0) this._addFocus($(e.target).parents(".e-time-hours"));
                    else if ($(e.target).parents(".e-time-minitues").length > 0) this._addFocus($(e.target).parents(".e-time-minitues"));
                    else this._removeFocus();
                }
            }
        },
        _OnWindowResize: function (e) {
            this._setListPosition();
            this._checkForResponsive();
            this._updateTimeHeight();
        },

        _raiseChangeEvent: function (isCode) {
            var previous = ej.parseDate(this._prevDateTimeVal, this.model.dateTimeFormat);
            var current = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (!(+previous === +current)) {
                this._preVal=this._prevDateTimeVal;
                var data = { prevDateTime: this._prevDateTimeVal, value: this.element.val(), isInteraction: !isCode, isValidState: this.isValidState };
                this._trigger("_change", data);
                data.value = $.trim(this.element.val()) == "" ? null : this.element.val();
                this._trigger("change", data);
                this._prevDateTimeVal = this.element.val();
            }
            else if ((this._prevDateTimeVal != this.element.val())) {
                var data = { prevDateTime: this._prevDateTimeVal, value: this.element.val(), isValidState: this.isValidState };
                this._prevDateTimeVal = this.element.val()
                this._trigger("_change", data);
            }
        },
        _raiseEvent: function (name) {
            var dateStringVal = this._previousDateUpdate();
            if (this.element != null && this.model[name])
                return this._trigger(name, { prevDateTime: ej.isNullOrUndefined(dateStringVal || this._preValString) ? '' : dateStringVal || this._preValString, value: this.element.val() });
            return false;
        },
        _getDateTimeFormat: function () {
            var pattern = ej.preferredCulture(this.model.locale).calendar.patterns;

            if (!this.model.dateTimeFormat) this.model.dateTimeFormat = pattern.d + " " + pattern.t;
            if (!this.model.timeDisplayFormat) this.model.timeDisplayFormat = pattern.t;
        },
        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },
        _checkErrorClass: function () {
            if (this.isValidState) this.wrapper.removeClass("e-error");
            else this.wrapper.addClass("e-error");
        },
        _getDate: function () {
            return this.datePicker.model.value;
        },
        _getTime: function () {
            return this._getDateObj(this.timePicker.model.value, this.timePicker.model.timeFormat);
        },
        _setEmptyTime: function (date) {
            var newDate = new Date(date);
            newDate.setMilliseconds(0);
            newDate.setSeconds(0);
            newDate.setMinutes(0);
            newDate.setHours(0);
            return newDate;
        },
        _setEmptyDate: function (date) {
            var newDate = new Date(date);
            newDate.setDate(1);
            newDate.setMonth(0);
            newDate.setFullYear(2000);
            return newDate;
        },
        _objectToString: function (obj) {
            return this._getFormat(obj, this.model.dateTimeFormat);
        },
        _stringToObject: function (value) {
            return this._getDateObj(value, this.model.dateTimeFormat);
        },
        _getFormat: function (value, format) {
            if (value instanceof Date) {
                var newFormat = this._checkFormat(format);
                return ej.format(value, newFormat, this.model.locale);
            }
            else return value;
        },
        _checkFormat: function (format) {
            var proxy = this;
            var dateFormatRegExp = this._regExp();
            return format.replace(dateFormatRegExp, function (match) {
                match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
                return match;
            });
        },
        _regExp: function () {
            return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
        },
        _getDateObj: function (value, format) {
            if (typeof value === "string") {
                var newFormat = this._checkFormat(format);
                var temp = ej.parseDate(value, newFormat, this.model.locale);
                if (temp != null)
                    return temp;
                else {
                    if (value != "" && value != null) {
                        var dateregexp = /^\s*(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d).*Z\s*$/, month, datetimesplit = dateregexp.exec(value);
                        var datevariable = new Date();
                        if (datetimesplit) {
                            datevariable = new Date();
                            month = +datetimesplit[2];
                            datevariable.setUTCFullYear(datetimesplit[1], month - 1, datetimesplit[3]);
                            datevariable.setUTCHours(datetimesplit[4], datetimesplit[5], datetimesplit[6]);
                            if (month != datevariable.getUTCMonth() + 1)
                                datevariable.setTime();
                        }
                        if (this._isValidDate(datevariable))
                            return datevariable;
                    }
                    else return null;
                }
            }
            else return value;
        },
        _compare: function (obj1, obj2) {
            return obj1 && obj2 && obj1.getTime() == obj2.getTime();
        },
        _isValidDate: function (dateObj) {
            return dateObj && typeof dateObj.getTime === "function" && isFinite(dateObj.getTime());
        },


        _change: function (property, value) {
            this.datePicker.option(property, value);
            this.timePicker.option(property, value);
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.popup.removeClass(this.model.cssClass).addClass(skin);

            this._change("cssClass", skin);
        },
        _localize: function (culture) {
            this.model.locale = culture;
            this.model.dateTimeFormat = this.model.timeDisplayFormat = "";
            var meridianText = ["AM", "PM"];
            this._getDateTimeFormat();
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    $.extend(this._localizedLabels.buttonText, this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this._buttonText(this._localizedLabels.buttonText);
            if (this.isValidState || (this.model.value instanceof Date && this._isValidDate(this.model.value)))
                this.element.val(this._objectToString(this.model.value));
            this._preVal = this.element.val();
            this._change("locale", culture);
            this.model.startDay = this.datePicker.model.startDay;
            this._validateMeridian();
            this._sfTimeHour.empty();
            this._renderHourTable();

            // Update the meridian support
            if (this.model.timeDrillDown.showMeridian)
                for (i = 0; i < 2; i++) {
                    var txt = !ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]]) ? ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]][0] : "";
                    $("span.e-hours-meridiantxt-" + meridianText[i].toLowerCase(), this._sfTimeHour).text(txt);

                }
        },
        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val() == "")
                    this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
                else
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                return true;
            }
        },
        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },
        _readOnly: function (boolean) {
            this.model.readOnly = boolean;
            if (boolean) this.element.attr("readonly", "readonly");
            else this.element.prop("readonly", false);

            this._change("readOnly", boolean);
        },
        _setRoundedCorner: function (boolean) {
            if (boolean) {
                this.container.addClass("e-corner");
                this.popup.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                this.popup.removeClass("e-corner");
            }
            this.datePicker.option("showRoundedCorner", boolean);
        },
        _setRtl: function (boolean) {
            if (boolean) {
                this.wrapper.addClass("e-rtl");
                this.popup.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                this.popup.removeClass("e-rtl");
            }

            this._change("enableRTL", boolean);
        },
        _enabled: function (boolean) {
            if (boolean) {
                this.model.enabled = false;
                this.enable();
            }
            else {
                this.model.enabled = true;
                this.disable();
            }
        },
        _showButton: function (show) {
            this.model.showPopupButton = show;
            if (show) {
                this.container.addClass("e-padding");
                this._renderIcon();
            }
            else {
                this.container.removeClass("e-padding");
                this.datetimeIcon.remove();
                this.datetimeIcon = null;
            }
        },
        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            this.popup.find(".e-dt-today").html(this.model.buttonText.today);
            this.popup.find(".e-dt-now").html(this.model.buttonText.timeNow);
            this.popup.find(".e-dt-done").html(this.model.buttonText.done);
            this.popup.find(".e-timecontainer").find(".e-header").html(this.model.buttonText.timeTitle);
        },
        _checkForResponsive: function () {
            if (($(window).outerWidth() > 200) && ($(window).outerWidth() <= 500)) {
                if (!this.popup.hasClass("e-dt-responsive")) {
                    this.popup.addClass("e-dt-responsive");
                    this.timePicker.option("popupWidth", this.datePicker.popup.outerWidth());
                    this.timePicker.option("popupHeight", 98);
                    this.timePicker._refreshScroller();
                    this.timePicker._changeActiveEle();
                }
            }
            else if (this.popup.hasClass("e-dt-responsive")) {
                this.popup.removeClass("e-dt-responsive");
                this.timePicker.option("popupWidth", this.model.timePopupWidth);
                var height = this.datePicker.popup.height() - this.popup.find(".e-header").height();
                this.timePicker.option("popupHeight", height);
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
            }
        },

        enable: function () {
            if (!this.model.enabled) {
                this.element[0].disabled = false;
                this.model.enabled = true;
                this.element.prop("disabled", false);
                this.wrapper.removeClass("e-disable");
                this.element.removeClass("e-disable").attr("aria-disabled", false);
                if (!this._isSupport)
                    this._hiddenInput.prop("disabled", false);
                if (this.datetimeIcon) this.datetimeIcon.removeClass("e-disable").attr("aria-disabled", false);
                if (this._isIE8 && this.datetimeIcon) this.datetimeIcon.children().removeClass("e-disable");
                this.popup.children("div").removeClass("e-disable").attr("aria-disabled", false);
                this._change("enabled", true);
            }
        },


        disable: function () {
            if (this.model.enabled) {
                this.element[0].disabled = true;
                this.model.enabled = false;
                this.wrapper.addClass("e-disable");
                this.element.addClass("e-disable").attr("aria-disabled", true);
                this.element.attr("disabled", "disabled");
                if (!this._isSupport)
                    this._hiddenInput.attr("disabled", "disabled");
                if (this.datetimeIcon) this.datetimeIcon.addClass("e-disable").attr("aria-disabled", true);
                if (this._isIE8 && this.datetimeIcon) this.datetimeIcon.children().addClass("e-disable");
                this.popup.children("div").addClass("e-disable").attr("aria-disabled", true);
                this._hideResult();

                this._change("enabled", false);
                this.datePicker.popup.removeClass("e-disable").attr("aria-disabled", false);
                this.timePicker.popup.removeClass("e-disable").attr("aria-disabled", false);
            }
        },


        getValue: function () {
            return this._objectToString(this.model.value);
        },


        setCurrentDateTime: function () {
            if (!this.model.readOnly)
                this._setValue(new Date());
        },


        show: function () {
            this._showResult();
        },


        hide: function () {
            this._hideResult();
        },


        _wireEvents: function () {
            if (this.model.allowEdit) {
                this._on(this.element, "focus", this._targetFocus);
                this._on(this.element, "blur", this._targetBlur);
                this._on(this.element, "keydown", this._keyDownOnInput);
            }
            if (!this.model.allowEdit) {
                this.element.attr("readonly", "readonly");
                this.element.on("mousedown", $.proxy(this._showhidePopup, this));
            }
            this.popup.on("mouseenter touchstart", $.proxy(function () { this._popClose = true; }, this));
            this.popup.on("mouseleave touchend", $.proxy(function () { this._popClose = false; }, this));

        },

        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });

    ej.DateTimePicker.Locale = ej.DateTimePicker.Locale || {};

    ej.DateTimePicker.Locale['default'] = ej.DateTimePicker.Locale['en-US'] = {
        watermarkText: "Select datetime",
        buttonText: {
            today: "Today",
            timeNow: "Time Now",
            done: "Done",
            timeTitle: "Time"
        }
    };

    ej.PopupPosition = {
        Bottom: "bottom",
        Top: "top"
    };
})(jQuery, Syncfusion);;
/// <reference path="../../common/jquery.d.ts" />
/// <reference path="../../ej.web.all.d.ts" />
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};

var ejDateRangePicker = (function (_super) {
    __extends(ejDateRangePicker, _super);
    function ejDateRangePicker(element, options) {
        _super.call(this);
        this._rootCSS = "e-daterangepicker";
        this._setFirst = false;
        this.PluginName = "ejDateRangePicker";
        this.id = "myDateRange";
        this._addToPersist = ["value"];
        this.type = "editor";
        this.angular = {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        };
        this.model = null;
        this.validTags = ["input"];
        this.defaults = {
            height: "",
            width: "",
            value: "",
            cssClass: "",
            enabled: true,
            startDate: null,
            endDate: null,
            enableTimePicker: false,
            ranges: null,
            locale: "en-US",
            separator: "-",
            watermarkText: "Select Range",
            dateFormat: "",
            timeFormat: "",
            showPopupButton: true,
            showRoundedCorner: false,
            allowEdit: true,
            enablePersistence: false,
			create:null,
			change:null,
			beforeClose:null,
			beforeOpen:null,
			close:null,
			open:null,
			hover:null,
			click:null,
			clear:null,
			destroy:null,
			select:null
			
        };
        this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
        this._prevValue = null;
        this._validState = null;
        ejDateRangePicker.prototype.observables =["value"];
        if (element) {
            if (!element["jquery"]) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejDateRangePicker().data(this.PluginName);
            }
        }
    }
    ejDateRangePicker.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    ejDateRangePicker.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };

    ejDateRangePicker.prototype._setModel = function (options) {
        var option;
        for (option in options) {
            switch (option) {
                case "allowEdit":
                    if (!options[option]) {
                        this.element.attr("readonly", "readonly");
                        this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                        this.element.off("blur", $.proxy(this._onMainFocusOut, this));
                    }
                    break;
                case "startDate":
                    var status = this._validateValues(options[option], "left");
                    if (status == false)
                        options[option] = null;
                    else {
                        if (!this._startEndValidation() && this.model.endDate != null) {
                            this._resetValues();
                            this.model.endDate = null;
                        }
                        this._updateValues();
                        this._selectedStartDate = this.model.startDate;
                        options[option] = this.model.startDate;
                    }

                    break;
                case "endDate":
                    var status = this._validateValues(options[option], "right");
                    if (status == false)
                        options[option] = null;
                    else {
                        if (!this._startEndValidation()) {
                            this._rightDP.element.parents(".e-datewidget").addClass("e-val-error");
                            this.model.endDate = null;
                        }
                        this._updateValues();
                        options[option] = this.model.endDate;
                    }
                    break;
                case "enableTimePicker":
                    this.model.enableTimePicker = options[option];
                    if (options[option]) {
                        this._renderTimePicker();
                    } else
                        this._removeTimePicker();
                    if (this._scrollerObj) {
                        this._scrollerObj.model.height = this.datePopup.height();
                        this._scrollerObj.refresh();
                    }
                    break;
                case "locale":
                    this._setCulture(options[option]);
                    options[option] = this.model.locale;
                    break;
                case "separator":
                    this.model.separator = options[option];
                    this._mainValue();
                    break;
                case "dateFormat":
                    if (this._leftDP)
                        this._leftDP.option(option, options[option]);
                    if (this._rightDP)
                        this._rightDP.option(option, options[option]);
                    this.model.dateFormat = options[option];
                    this._getDateTimeFormat();
                    this._updateInput();
                    break;
                case "timeFormat":
                    if (this._leftTP)
                        this._leftTP.option(option, options[option]);
                    if (this._rightTP)
                        this._rightTP.option(option, options[option]);
                    this.model.timeFormat = options[option];
                    this._getDateTimeFormat();
                    this._updateInput();
                    break;
                case "watermarkText":
                    if (ej.isNullOrUndefined(this._options))
                        this._options = {};
                    this._options["watermarkText"] = this.model.watermarkText = options[option];
                    this._localizedLabels.watermarkText = this.model.watermarkText;
                    this._setWaterMark();
                    break;
                case "cssClass":
                    this._changeSkin(options[option]);
                    break;
                case "showRoundedCorner":
                    this._setRoundedCorner(options[option]);
                    break;
                case "showPopupButton":
                    this._renderDateIcon(options[option]);
                    break;

                case "value":
                    this.element.val(options[option]);
                    this._onMainFocusOut();
                    options[option] = this.model.value;
                    break;

                case "height":
                    this.wrapper.height(options[option]);
                    break;
                case "width":
                    this.wrapper.width(options[option]);
                    break;
                case "enabled":
                    if (options[option])
                        this.enable();
                    else
                        this.disable();
                    break;
            }
        }
    };
    ejDateRangePicker.prototype._init = function (options) {
        this._options = options;
        this._flagevents = false;
        this._id = this.element.attr("id");
        this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
        if (this.element.val() == "" && this.model.value) {
            this.element.val(this.model.value);
        }
        if (this.element.val())
            this._setInitValue();
        this._createDateRangePicker();
        if (this._validState == false && this.element.val())
            this.wrapper.addClass("e-error");
        this._popupOpen = false, this._isPopScroll = false;
        if (!this.model.enabled) this.disable();
        this._wireEvents();
    };
    ejDateRangePicker.prototype._setInitValue = function () {
        var datestring = this.element.val().split(this.model.separator), _startdate = ej.parseDate(datestring[0], this._dateTimeFormat, this.model.locale), _enddate = ej.parseDate(datestring[1], this._dateTimeFormat, this.model.locale);
        if (_startdate && _enddate) {
            this.model.startDate = _startdate;
            this.model.endDate = _enddate;
        }
    };
    ejDateRangePicker.prototype._getNextMonth = function (current) {
        var local = current;
        if (!(local instanceof Date))
            return new Date();
        var month = local.getMonth();
        if (month == 11) {
            var year = local.getFullYear() + 1;
            month = -1;
        } else
            var year = local.getFullYear();
        var dummy = new Date();
        dummy = new Date(dummy.setFullYear(year));
        dummy = new Date(dummy.setMonth(month + 1));
        dummy = new Date(dummy.setDate(1));
        return dummy;
    };
    ejDateRangePicker.prototype._getDateTimeFormat = function () {
        var pattern = ej.preferredCulture(this.model.locale).calendars.standard.patterns;
        if (!this.model.dateFormat)
            this.model.dateFormat = pattern.d;
        if (this.model.enableTimePicker) {
            if (!this.model.timeFormat)
                this.model.timeFormat = pattern.t;
            this._dateTimeFormat = this.model.dateFormat + " " + this.model.timeFormat;
        } else
            this._dateTimeFormat = this.model.dateFormat;
    };
    ejDateRangePicker.prototype._setValues = function () {
        this._leftDP.option("value", this.model.startDate);
        this._rightDP.option("value", this.model.endDate || null);
        if (this.model.startDate)
            this._setStartDate(this.model.startDate, $('.current-month[date="' + this.model.startDate.toDateString() + '"]'), true);
        if (this.model.endDate)
            this._setEndDate(this.model.endDate, $('.current-month[date="' + this.model.endDate.toDateString() + '"]'), true);
        this._rangeRefresh(this._setArgs(this._leftDP.popup));
        this._rangeRefresh(this._setArgs(this._rightDP.popup));
        this._rightDP.element.parents(".e-datewidget").removeClass("e-error");
        if (this.model.enableTimePicker) {
            this._leftTP.option("value", this.model.startDate);
            this._rightTP.option("value", this.model.endDate);
        }
        this._updateRanges("left");
        this._updateRanges("right");
    };

    ejDateRangePicker.prototype._customSet = function () {
        this._selectedStartDate = this.model.startDate;
        this._selectedEndDate = this.model.endDate;
        this._resetValues();
        this._setValues();
        if (!this._popupOpen)
            this._mainValue();
        this._refreshMinMax();
        this._setWaterMark();
    };
    ejDateRangePicker.prototype._setCulture = function (culture) {
        culture = ej.preferredCulture(culture).name;
        this.model.locale = culture;
        this._setOption("locale", culture);
        this._localizedLabels = this._getLocalizedLabels();
        this._setLocalizedText();
        this._updateInput();
    };
    ejDateRangePicker.prototype._setRoundedCorner = function (boolean) {
        if (boolean) {
            this._input_innerWrapper.addClass("e-corner");
            this.popup.addClass("e-corner");
        } else {
            this._input_innerWrapper.removeClass("e-corner");
            this.popup.removeClass("e-corner");
        }
        this._setOption("showRoundedCorner", boolean);
    };
    ejDateRangePicker.prototype._renderDateIcon = function (boolean) {
        if(boolean)
        {
		    this.dateRangeIcon = ej.buildTag("span.e-select#" + this.id + "-img", "", {}, (this._isIE8) ? { 'unselectable': 'on' } : {}).append(ej.buildTag("span.e-icon e-calendar", "", {}, { 'aria-label': 'Select' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})).insertAfter(this.element);
             this._input_innerWrapper.addClass('e-padding');
			this._on(this.dateRangeIcon, "mousedown", this._showDatePopUp);
			this._off(this.dateRangeIcon, "click", this._showDatePopUp);
			
        }
        else {
            if (this.dateRangeIcon) {
                this.dateRangeIcon.remove();
            }
			 this._input_innerWrapper.removeClass('e-padding');
            this._bindDateButton();
            this._off(this.dateRangeIcon, "click", this._showDatePopUp);
        }
        },
	ejDateRangePicker.prototype._validateValues = function (val, cal_type) {
        var obj = cal_type == "right" ? this._rightDP : this._leftDP;
        var datavalu = val;
        if (datavalu != null && typeof datavalu == "string") {
            if (cal_type == "left") {
                this.model.startDate = ej.parseDate(val, this.model.dateFormat, this.model.locale) || null;
                this.model.startDate = (this.model.startDate != null) ? this.model.startDate : new Date(datavalu);
            }
            else {
                this.model.endDate = ej.parseDate(val, this.model.dateFormat, this.model.locale) || null;
                this.model.endDate = (this.model.endDate != null) ? this.model.endDate : new Date(datavalu);
            }
        } else {
            if (val instanceof Date) {
                if (cal_type == "left") {
                    this.model.startDate = val;
                    if (!isNaN(val.getDate())) {
                        if (typeof this._formatter(this.model.startDate, this.model.locale) != "string")
                            this.model.startDate = ej.parseDate(this._formatter(this.model.startDate, this.model.locale), this.model.dateFormat);
                    } else
                        return false;
                } else if (cal_type == "right") {
                    this.model.endDate = val;
                    if (!isNaN(val.getDate())) {
                        if (typeof this._formatter(this.model.endDate, this.model.locale) != "string")
                            this.model.endDate = ej.parseDate(this._formatter(this.model.endDate, this.model.locale), this.model.dateFormat);
                    } else
                        return false;
                }
            } else
                return false;
        }
        return true;
    };
    //Date formatter - Convert date object to specific date format
    ejDateRangePicker.prototype._formatter = function (date, format) {
        var newFormat = this._checkFormat(format);
        return ej.format(date, newFormat, this.model.locale);
    };

    ejDateRangePicker.prototype._checkFormat = function (format) {
        var proxy = this;
        var dateFormatRegExp = this._regExp();
        return format.replace(dateFormatRegExp, function (match) {
            match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
            return match;
        });
    };
    ejDateRangePicker.prototype._regExp = function () {
        return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
    };

    ejDateRangePicker.prototype._setArgs = function (element) {
        var date = new Date($(element.find(".current-month")[0]).attr("date"));
        this.args = {};
        this.args.element = element;
        this.args.month = date.getMonth();
        this.args.year = date.getFullYear();
        return this.args;
    };
    ejDateRangePicker.prototype._changeSkin = function (skin) {
        this.wrapper.removeClass(this.model.cssClass).addClass(skin);
        this.popup.removeClass(this.model.cssClass).addClass(skin);

        this._setOption("cssClass", skin);
    };
    ejDateRangePicker.prototype._createDateRangePicker = function () {
        this._localizedLabels = this._getLocalizedLabels();
        this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'tabindex': '0' });

        this.wrapper = ej.buildTag("span.e-daterangewidget e-widget " + this.model.cssClass);
        if (!ej.isTouchDevice())
            this.wrapper.addClass('e-ntouch');
        this._input_innerWrapper = ej.buildTag("span.e-in-wrap e-box");
        this.wrapper.append(this._input_innerWrapper).insertBefore(this.element);
        this._input_innerWrapper.append(this.element);
        this._input_innerWrapper.addClass('e-padding');
        this.popup = ej.buildTag("div.e-daterangepicker-popup e-popup e-widget e-box" + this.model.cssClass + "#" + this.element[0].id + "_popup").css("display", "none");
        if (!this._isSupport) {
            this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
            this._hiddenInput.val(this._localizedLabels.watermarkText);
            this._hiddenInput.css("display", "block");
            var proxy = this;
            $(this._hiddenInput).focus(function () {
                proxy.element.focus();
            });
        }
        $('body').append(this.popup);
        this.datePopup = ej.buildTag("div.e-datepickers-popup");
        this.popup.append(this.datePopup);
        this._leftDiv = ej.buildTag("div.e-left-datepicker");
        this._rightDiv = ej.buildTag("div.e-right-datepicker");
        this.datePopup.append(this._leftDiv);
        this.datePopup.append(this._rightDiv);
        this.calendar_left = ej.buildTag("input.leftDate_wrapper#" + this.element[0].id + "leftDate_wrapper", "", {}, { "type": "text" });
        this._leftDiv.append(this.calendar_left);
        this.calendar_right = ej.buildTag("input.rightDate_wrapper#" + this.element[0].id + "rightDate_wrapper", "", {}, { "type": "text" });
        this._rightDiv.append(this.calendar_right);
        var proxy = this;
        this.culture = ej.preferredCulture(this.model.locale);
        this._getDateTimeFormat();
		this._setRoundedCorner(this.model.showRoundedCorner);
		this._renderDateIcon(this.model.showPopupButton);
        this.calendar_left.ejDatePicker({
            displayInline: true,
            showFooter: false,
            watermarkText: "",
            enableStrictMode: true,
            layoutChange: function (e) {
                proxy._refreshEvents("left");
                proxy._updateRanges("left");
                if (proxy._scrollerObj) {
                    proxy._scrollerObj.model.height = proxy.datePopup.height();
                    proxy._scrollerObj.refresh();
                }
            },
            showTooltip: false,
            locale: this.model.locale,
            dateFormat: this.model.dateFormat,
            _month_Loaded: function (e) {
                proxy._previousNextHandler(e);
            },
            enablePersistence: this.model.enablePersistence
        });
        this._leftDP = this.calendar_left.data("ejDatePicker");
        this._leftDP._getInternalEvents = true, this._leftDP._DRPdisableFade = true;
        this._leftDP.option("showPopupButton", false);
        this._leftDP.popup.css({ "position": "static", "visibility": "inherit" });
        this.calendar_right.ejDatePicker({
            displayInline: true,
            showFooter: false,
            watermarkText: "",
            enableStrictMode: true,
            locale: this.model.locale,
            create: $.proxy(this._updateOnRender, this),
            layoutChange: function (e) {
                proxy._refreshEvents("right");
                proxy._updateRanges("right");
                if (proxy._scrollerObj) {
                    proxy._scrollerObj.model.height = proxy.datePopup.height();
                    proxy._scrollerObj.refresh();
                }
            },
            dateFormat: this.model.dateFormat,
            _month_Loaded: function (e) {
                proxy._previousNextHandler(e);
            },
            enablePersistence: this.model.enablePersistence
        });
        this._rightDP = this.calendar_right.data("ejDatePicker");
        this._rightDP._getInternalEvents = true, this._rightDP._DRPdisableFade = true; // to get the layout change client side event
        this._rightDP.option("showPopupButton", false);
        this._rightDP.popup.css({ "position": "static", "visibility": "inherit" });
        if (this.model.ranges)
            this._renderRanges();
        if (this.model.enableTimePicker)
            this._renderTimePicker();
        this._renderButton();
        this._bindDateButton();
        this._refreshEvents("left");
        this._refreshEvents("right");
        this._updateRanges("left");
        this._updateRanges("right");

        if (this.wrapper) {
           if (this.model.width) this.wrapper.width(this.model.width);
		   if (this.model.height) this.wrapper.height(this.model.height);
		}
    };
    ejDateRangePicker.prototype._updateOnRender = function (e) {
        if (this.model.enableTimePicker) {
            if (this._rightTime) {
                this._rightTP = this._rightTime.ejTimePicker("instance");
                this._updateValues();
            }
        } else {
            if (this.calendar_right) {
                this._rightDP = this.calendar_right.ejDatePicker("instance");
                this._updateValues();
            }
        }
    };
    ejDateRangePicker.prototype._updateRangesList = function () {
        $(".e-dateranges-ul").find(".rangeItem.e-active").removeClass("e-active");
        $(".e-dateranges-ul").find(".rangeItem.e-custompic").addClass("e-active");
    }
    ejDateRangePicker.prototype._updateValues = function () {
        this._updateRangesList();
        this._getDateTimeFormat();
        if (this._startEndValidation() || (this.model.startDate != null && this.model.endDate == null)) {
            this._validateValues(this.model.startDate, "left");
            this._validateValues(this.model.endDate, "right");
            this._setValues();
            this._mainValue();
        } else {
            this._clearRanges();
            this.element.val("");
        }
        this._refreshMinMax();
        this._setWaterMark();
    };
    ejDateRangePicker.prototype._startEndValidation = function () {
        if (this.model.startDate && this.model.endDate) {
            var start = this.model.startDate, end = this.model.endDate;
            if (end && start > end) {
                return false;
            } else
                return true;
        }
        return false;
    };
    ejDateRangePicker.prototype._renderButton = function () {
        this._buttonDiv = ej.buildTag("div.e-drpbuttons");
        var _reset = ej.buildTag("div.e-drp-button e-drp-reset e-btn e-select e-flat").attr({ 'tabindex': '0' });
        var _apply = ej.buildTag("div.e-drp-button e-drp-apply e-disable e-btn e-select e-flat").attr({ 'tabindex': '0' });
        var _cancel = ej.buildTag("div.e-drp-button e-drp-cancel e-btn e-select e-flat").attr({ 'tabindex': '0' });
        this._buttonDiv.append(_reset);
        this._buttonDiv.append(_apply);
        this._buttonDiv.append(_cancel);
        this.popup.append(this._buttonDiv);
        this._setLocalizedText();
    };
    ejDateRangePicker.prototype._setLocalizedText = function () {
        if (!ej.isNullOrUndefined(this._options)) {
            if (!ej.isNullOrUndefined(this._options.buttonText))
                $.extend(this._localizedLabels.ButtonText, this._options.buttonText);
            if (!ej.isNullOrUndefined(this._options.watermarkText))
                this._localizedLabels.watermarkText = this._options.watermarkText;
        }
        this.model.buttonText = this._localizedLabels.ButtonText;
        $(this._buttonDiv.find("div.e-drp-reset")).text(this.model.buttonText.reset);
        $(this._buttonDiv.find("div.e-drp-apply")).text(this.model.buttonText.apply);
        $(this._buttonDiv.find("div.e-drp-cancel")).text(this.model.buttonText.cancel);
        if (this._customRangePicker && this._customRangePicker.find("ul li.e-custompic").length > 0)
            (this._customRangePicker.find("ul li.e-custompic")).text(this._localizedLabels.customPicker);
		this._setWaterMark();
    };

    ejDateRangePicker.prototype._renderRanges = function () {
        this._renderRangesWrapper();
        this.popup.append(this._customRangePicker);
        this._ranges_li = "";
        var proxy = this;
        if (this.model.ranges) {
            for (var i = 0; i < this.model.ranges.length; i++) {
                var s = this.model.ranges[i];
                var value = s.range;
                if (value.length === 2) {
                    var start = new Date(value[0]);
                    var end = new Date(value[1]);
                    if (ej.isNullOrUndefined(start))
                        start = new Date(value[0]);
                    if (ej.isNullOrUndefined(end))
                        end = new Date(value[1]);
                    if (start <= end) {
                        proxy._ranges_li += "<li aria-selected='false' title='" + s.label + "' class='rangeItem' e-date-range='" + JSON.stringify(value) + "' e-data-value='" + s.range + "'>" + s.label + "</li>";
                    }
                }
            }
        }
        this._ranges_li += "<li aria-selected='false' class='rangeItem e-active e-custompic' e-date-range='customPicker'>" + this._localizedLabels.customPicker + "</li>";
        this.popup.find("div.e-custom-dateranges ul").append(this._ranges_li);
        this._on(this._customRangePicker.find("ul li.rangeItem"), "click", this._customSelection);
        this._customRangePicker.ejScroller({ height: this.datePopup.height(), width: 0, scrollerSize: 15 });
        proxy._scrollerObj = this._customRangePicker.ejScroller("instance");
    };
    ejDateRangePicker.prototype._removeTimePicker = function () {
		this._leftDiv.removeClass("e-left-timepicker");
		this._rightDiv.removeClass("e-right-timepicker");
        this._leftTP.destroy();
        this._rightTP.destroy();
        this._rightTP = null;
        this._leftTP = null;
        this._leftTime.remove();
        this._rightTime.remove();
        this._setOption("width", "");
        this._setOption("width", "100%");
        this._updateValues();
    };
    ejDateRangePicker.prototype._setOption = function (option, value) {
        if (this._leftDP)
            this._leftDP.option(option, value);
        if (this._rightDP)
            this._rightDP.option(option, value);
        if (this.model.enableTimePicker) {
            if (this._leftTP)
                this._leftTP.option(option, value);
            if (this._rightTP)
                this._rightTP.option(option, value);
        }
    };
    ejDateRangePicker.prototype._renderTimePicker = function () {
        if (this.model.timeFormat == '')
            this.model.timeFormat = this.culture.calendar.patterns.t;
        this._leftTime = ej.buildTag("input.leftTime#" + this._id + "_lTime");
        this._leftDiv.append(this._leftTime);
		this._leftDiv.addClass("e-left-timepicker");
        var proxy = this;
        this._leftTime.ejTimePicker({
           popupWidth: "115px",
            locale: this.model.locale,
            timeFormat: this.model.timeFormat,
            select: function (e) {
                if (proxy.model.startDate && proxy.model.endDate) {
                    if (proxy._rightTP && proxy.model.startDate.toLocaleDateString() == proxy.model.endDate.toLocaleDateString())
                        proxy._rightTP.option("minTime", e.value);
                    proxy._buttonDiv.find(".e-drp-apply").removeClass("e-disable");
                }
            }
        });
        this._leftTP = this._leftTime.ejTimePicker("instance");
        this._leftTP.popup.addClass("e-daterange-timepopup");
        this._rightTime = ej.buildTag("input.rightTime#" + this._id + "_rTime");
        this._rightDiv.append(this._rightTime);
		this._rightDiv.addClass("e-right-timepicker");
        this._rightTime.ejTimePicker({
            popupWidth: "115px", locale: this.model.locale,
            create: $.proxy(this._updateOnRender, this),
            timeFormat: this.model.timeFormat,
            select: function (e) {
                if (proxy.model.startDate && proxy.model.endDate) {
                    proxy._buttonDiv.find(".e-drp-apply").removeClass("e-disable");
                }
            }
        });
        this._rightTP = this._rightTime.ejTimePicker("instance");
        this._rightTP.popup.addClass("e-daterange-timepopup");
		this._on(this._leftTP.element, "keydown", this._onKeyDown);
        this._on(this._rightTP.element, "keydown", this._onKeyDown);
        //below code for position the timepicker and datepicker
        this._setTimePickerPos();
    };
    ejDateRangePicker.prototype._setTimePickerPos = function () {
        $("#" + this._id + "_lTime_timewidget").css({
            position: "absolute",
            top: 0,
            left: this._leftDP.popup.width() + this._leftDP.popup.position().left - this.popup.find($("#" + this._id + "_lTime_timewidget")).outerWidth()
        });
        $("#" + this._id + "_rTime_timewidget").css({
            position: "absolute",
            top: !this.popup.hasClass("e-daterange-responsive") ? 0 : this._rightDP.wrapper.position().top,
            left: this._rightDP.popup.width() + this._rightDP.popup.position().left - this.popup.find($("#" + this._id + "_rTime_timewidget")).outerWidth()
        });
    };
    ejDateRangePicker.prototype._updateInput = function (e) {
        if (!(this.model.startDate && this.model.endDate)) {
            if (this.model.value)
                this.element.val(this.model.value);
            if (this._popupOpen)
                this.popupHide();
            return;
        }
        this._resetValues();
        this.wrapper.removeClass("e-error");
        this._mainValue();
        this._refreshMinMax();
    };
    ejDateRangePicker.prototype._removeWatermark = function () {
        if (this.element.val() != "" && !this._isSupport)
            this._hiddenInput.css("display", "none");
    };
    ejDateRangePicker.prototype._mainValue = function () {
        var lefttime = "", righttime = "", startDt = this.model.startDate, endDt = this.model.endDate;
        var _startDateString = ej.format(startDt, this.model.dateFormat, this.model.locale);
        var _endDateString = ej.format(endDt, this.model.dateFormat, this.model.locale);

        if (this.model.enableTimePicker && this._leftTP && this._rightTP && this._leftTP.model.value && this._rightTP.model.value) {
            lefttime = this._leftTP.model.value;
            righttime = this._rightTP.model.value;
            _startDateString = ej.format(_startDateString + " " + lefttime, this._dateTimeFormat, this.model.locale);
            _endDateString = ej.format(_endDateString + " " + righttime, this._dateTimeFormat, this.model.locale);
            this.model.startDate = ej.parseDate(_startDateString, this._dateTimeFormat, this.model.locale);
            this.model.endDate = ej.parseDate(_endDateString, this._dateTimeFormat, this.model.locale);
        } else {
            this.model.startDate = ej.parseDate(_startDateString, this._leftDP.model.dateFormat, this.model.locale);
            this.model.endDate = ej.parseDate(_endDateString, this._rightDP.model.dateFormat, this.model.locale);
        }
        if (_startDateString != null && _endDateString != null) {
            this.model.value = _startDateString + " " + this.model.separator + " " + _endDateString;
            this.element.val(this.model.value);
            if (this._hiddenInput)
                this._hiddenInput.attr('value', this.model.value);
            this._removeWatermark();
            this._validState = true;
        } else {
            this.model.value = null;
            this._setWaterMark();
            this._validState = false;
        }
		this._prevValue = this.model.value;
        if (this._buttonDiv)
            this._buttonDiv.find(".e-drp-apply").addClass("e-disable");
        this._trigger("_change", { value: this.model.value });
    };
    ejDateRangePicker.prototype._bindDateButton = function () {
        if(this.dateRangeicon)
        this._on(this.dateRangeIcon, "click", this._showDatePopUp);
        if (!this.model.allowEdit) {
            this.element.attr("readonly", "readonly");
            this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
            this.element.off("blur", $.proxy(this._onMainFocusOut, this));
        }
        if(this.model.allowEdit){
		 this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
		 }
	};

    ejDateRangePicker.prototype._showDatePopUp = function (e) {
        if (!this.model.enabled)
            return false;
        var isRightClick = false;
        if (e.button)
            isRightClick = (e.button == 2);
        else if (e.which)
            isRightClick = (e.which == 3); //for Opera
        if (isRightClick)
            return;
        this._showhidePopup(e);
		 };
    ejDateRangePicker.prototype._showhidePopup = function (e) {
        if (this._popupOpen) {
            if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) {
                this.wrapper.addClass('e-focus');
            }
            this.popupHide(e);
        } else {
            if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) {
                this.wrapper.addClass('e-focus');
            }
            this.popupShow(e);
        }
    };
    ejDateRangePicker.prototype.popupHide = function (e) {
        if (!this._popupOpen || this._isPopScroll) return false;
        var proxy = this;
        this._trigger("beforeClose", { element: this.popup, events: e });
        this.popup.attr({ 'aria-hidden': 'true' });
        if (this._leftTP && !this._leftTP._popupOpen)
            this._leftTP.hide();
        if (this._rightTP && !this._rightTP._popupOpen)
            this._rightTP.hide();
        this.popup.css("visibility", "visible").slideUp(100, function () {
            proxy._popupOpen = false;
        });
		this._off(ej.getScrollableParents(this.wrapper), "scroll", $.proxy(this.popupHide, this));
		this._trigger("close", { element: this.popup, events: e });
		this.wrapper.removeClass("e-active");
    };

    ejDateRangePicker.prototype.popupShow = function (e) {
        if (!this.model.enabled)
            return false;
        if (this._popupOpen)
            return false;
        var proxy = this;
        this._trigger("beforeOpen", { element: this.popup, events: e });
        this.wrapper.addClass('e-focus');
        this.popup.attr({ 'aria-hidden': 'false' });
        proxy._popupOpen = true;
        this.popup.css({'visibility': 'hidden', 'display': 'block'});
        this._resizePopup();
        this.popup.css({'display': 'none', 'visibility': 'visible'}).slideDown(100, function () {
        });
		this._on(ej.getScrollableParents(this.wrapper), "scroll", $.proxy(this.popupHide, this));
		this._trigger("open", { element: this.popup, events: e });
		this.wrapper.addClass("e-active");
    };
    ejDateRangePicker.prototype._resizePopup = function () {
        var proxy = this, range_width = 0, ran_height = 0;
        var cal_width = proxy.datePopup.find(".e-popup.e-calendar").outerWidth();
        var cal_height = proxy.datePopup.find(".e-popup.e-calendar").height();
        if (this._customRangePicker && this._customRangePicker.height() <= 0)
            this._customRangePicker.height(this.datePopup.height());
        if (this.model.ranges && this.model.ranges.length > 0)
            var ran_height = this._customRangePicker.find("ul").height(), range_width = proxy._customRangePicker.outerWidth();
        if ($(window).width() - this.wrapper.position().left < ((cal_width * 2) + range_width) + 25) {
            proxy.popup.addClass("e-daterange-responsive");
            proxy._setOption("width", "95%");
            if (this.model.enableTimePicker) {
                this._setOption("width", "47%");
                this._setDatePickerPosition();
                $("#" + this._id + "_lTime_timewidget").css({
                    left: this._leftDP.wrapper.outerWidth() + 5
                });

                $("#" + this._id + "_rTime_timewidget").css({
                    left: this._rightDP.wrapper.outerWidth() + 5
                });
                if (proxy._scrollerObj) {
                    proxy._scrollerObj.model.height = ran_height < cal_height ? ran_height + 10 : cal_height;
                    proxy._scrollerObj.refresh();
                }
                return;
            }
        } else {
            proxy.popup.removeClass("e-daterange-responsive");
            if (this.model.enableTimePicker) {
                this._leftTP.option("width", "115px");
                this._rightTP.option("width", "115px");
                this._setTimePickerPos();
            }
            if (proxy._scrollerObj) {
                proxy._scrollerObj.model.height = this.datePopup.height();
                proxy._scrollerObj.refresh();
            }
        }
        this._setDatePickerPosition();
    };
    ejDateRangePicker.prototype._onDocumentClick = function (e) {
        if (this.model) {
            if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-popup").is(this.popup) && !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-daterangewidget").is(this.wrapper)) {
                if (this.model.enableTimePicker && !$(e.target).is(this._leftTP.popup) && !$(e.target).parents(".e-popup").is(this._leftTP.popup) && !$(e.target).is(this._rightTP.popup) && !$(e.target).parents(".e-popup").is(this._rightTP.popup)) {
                    if (this._popupOpen)
                        this.popupHide(e);
                    this.wrapper.removeClass('e-focus');
                }
                if (!this.model.enableTimePicker) {
                    if (this._popupOpen)
                        this.popupHide(e);
                    this.wrapper.removeClass('e-focus');
                }
            }
        }
    };
    ejDateRangePicker.prototype._getOffset = function (ele) {
        var pos = ele.offset() || { left: 0, top: 0 };
        if ($("body").css("position") != "static") {
            var bodyPos = $("body").offset();
            pos.left -= bodyPos.left;
            pos.top -= bodyPos.top;
        }
        return pos;
    };

    ejDateRangePicker.prototype._getZindexPartial = function (element, popupEle) {
        if (!ej.isNullOrUndefined(element) && element.length > 0) {
            var parents = element.parents(), bodyEle;
            bodyEle = $('body').children();
            if (!ej.isNullOrUndefined(element) && element.length > 0)
                bodyEle.splice(bodyEle.index(popupEle), 1);
            $(bodyEle).each(function (i, ele) {
                parents.push(ele);
            });

            var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static')
                    return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000)
                maxZ = 10000;
            else
                maxZ += 1;
            return maxZ;
        }
    };

    ejDateRangePicker.prototype._setDatePickerPosition = function () {
        var elementObj = this.element.is('input') ? this.wrapper : this.element;
        var pos = this._getOffset(elementObj), winLeftWidth, winRightWidth, winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()), winTopHeight = pos.top - $(document).scrollTop(), popupHeight = this.popup.outerHeight(), popupWidth = this.popup.outerWidth(), left = pos.left, totalHeight = elementObj.outerHeight(), border = (totalHeight - elementObj.height()) / 2, maxZ = this._getZindexPartial(this.element, this.popup), popupmargin = 3, topPos = (popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin;
        winLeftWidth = $(document).scrollLeft() + $(window).width() - left;
        if (popupWidth > winLeftWidth && (popupWidth < left + elementObj.outerWidth()))
            left -= this.popup.outerWidth() - elementObj.outerWidth();

        this.popup.css({
            "left": left + "px",
            "top": topPos + "px",
            "z-index": maxZ
        });

        if (this.model.enableTimePicker) {
            $("#" + this._id + "_lTime_timewidget").css({
                position: "absolute",
                top: 0,
                left: this._leftDP.popup.width() + this._leftDP.popup.position().left - $("#" + this._id + "_lTime_timewidget").width()
            });
            $("#" + this._id + "_rTime_timewidget").css({
                position: "absolute",
                top: !this.popup.hasClass("e-daterange-responsive") ? 0 : this._rightDP.wrapper.position().top,
                left: this._rightDP.popup.width() + this._rightDP.popup.position().left - $("#" + this._id + "_rTime_timewidget").width()
            });
        }
    };
    ejDateRangePicker.prototype._dateEleClicked = function (e) {
        this._updateRangesList();
        this._activeItem = $(e.currentTarget);
        if (this._activeItem.hasClass("e-hidedate")) {
            e.stopPropagation();
            return;
        }
        if (this._activeItem.hasClass("other-month")) {
            this._refreshMinMax();
        }
        var dateString = this._activeItem.attr("date");
        var cal_type = ($(e.currentTarget).parents(".e-left-datepicker").length > 0) ? "left" : "right";
        if (ej.isNullOrUndefined(dateString) || dateString === "")
            return;
        var currentDate = new Date(dateString);
        if (this._selectedStartDate != null && this._selectedEndDate != null)
            this._selectedStartDate = null;
        if (this._selectedStartDate == null) {
            this._selectedStartDate = currentDate;
            this._selectedEndDate = null;
            if (this._startDate)
                this._startDate.date = null;
            this._rightDP.element.val(null);
            if (cal_type == "right") {
                this._leftDP._stopRefresh = true;
                this._leftDP.option("value", this._selectedStartDate);
                this._leftDP.element.val(this._selectedStartDate.toLocaleDateString());
            }
            if (this._rightTP)
                this._rightTP.option("value", "");
            this.popup.find(".in-range").removeClass("in-range");
            this.datePopup.find("td.e-state-default.e-active").removeClass("e-active");
            this._rightDP.element.parents(".e-datewidget").removeClass("e-error");
            var startElement = $(this.datePopup.find('.current-month[date="' + dateString + '"]'));
            this._selectedStartDate = new Date(startElement.attr("date"));
            this._setStartDate(this._selectedStartDate, startElement, true);
        } else if ((this._selectedStartDate !== null && this._selectedEndDate == null) && !(currentDate < this._selectedStartDate)) {
            var minDate = currentDate;
            var dateString = $(e.currentTarget).attr("date");
            this._rightDP._stopRefresh = true;
            this._rightDP.option("value", new Date(dateString));
            this._rightDP._stopRefresh = false;
            if (this._rightTP)
                this._rightTP.option("value", new Date(dateString));
            this._rightDP.element.parents(".e-datewidget").removeClass("e-error");
            var endElement = $(this.datePopup.find('.current-month[date="' + dateString + '"]'));
            this._selectedStartDate = this.model.startDate;
            this._selectedEndDate = new Date(dateString);
            this._setEndDate(this._selectedEndDate, endElement, true);
            this._startDate = {};
            this._startDate.date = this._selectedStartDate;
            this._updateRanges("left");
            this._updateRanges("right");
            if (cal_type == "left") {
                this._leftDP._stopRefresh = true;
                this._leftDP.option("value", this.model.startDate);
                this._leftDP.element.val(this.model.startDate.toLocaleDateString());
            }
        } else {
            this._selectedStartDate = currentDate;
            this._selectedEndDate = null;
            if (this._endDate)
                this._endDate.date = null;
            this.popup.find(".in-range").removeClass("in-range");
            this._rightDP.option("value", null);
            if (this._rightTP)
                this._rightTP.option("value", "");
            if (cal_type == "right") {
                this._leftDP._stopRefresh = true;
                this._leftDP.option("value", this._selectedStartDate);
                this._leftDP.element.val(this._selectedStartDate.toLocaleDateString());
            }
            this._setStartDate(this._selectedStartDate, this._activeItem, true);
            this._updateRanges("left");
            this._updateRanges("right");
        }
        this._trigger("click", { element: $(e.currentTarget), startDate: this.model.startDate, endDate: this.model.endDate, value: new Date($(e.currentTarget).attr("date")) });
    };
    ejDateRangePicker.prototype._setStartDate = function (value, current_element, newset) {
        this._startDate = {};
        this._startDate.date = value;
        if (newset) {
            this._endDate = {};
            this._endDate.date = null;
        }
        this._leftDP._checkDateArrows();
        this.datePopup.find("td.e-state-default").removeClass("e-select e-start-date e-active showrange e-end-date e-state-hover");
        this.popup.find(".in-range").removeClass("in-range");
        current_element.addClass("e-start-date");
        this.model.startDate = value;
        if (this._buttonDiv)
            this._buttonDiv.find(".e-drp-apply").addClass("e-disable");
        if (!this.model.enableTimePicker)
            return;
        var $this = this._leftTP;
        var _value = ej.format(this._leftTP.model.value || this._leftDP.model.value, $this.model.timeFormat, this.model.locale);
        if (_value)
            this._rightTP.option("minTime", _value);
        if (_value)
            this._leftTP.option("value", _value);
    };
    ejDateRangePicker.prototype._setEndDate = function (value, current_element, newset) {
        this._rightDP.element.parents(".e-datewidget").removeClass("e-val-error");
        this._endDate = {};
        this._endDate.date = value;
        this.popup.find("td.e-end-date").removeClass("e-select e-end-date");
        current_element.addClass("e-end-date");
        if (this._buttonDiv)
            this._buttonDiv.find(".e-disable").removeClass("e-disable");
        this.model.endDate = value;
        if (this._startDate.date.getFullYear() == this._endDate.date.getFullYear()) {
            if (this._startDate.date.getMonth() == this._endDate.date.getMonth()) {
                return;
            }
        }
        if (!this.model.enableTimePicker)
            return;
        if (this.model.startDate.getDate() == this.model.endDate.getDate()) {
            this._rightTP.option("minTime", this._leftTP.option("value") || "");
            this._rightTP.option("value", this._leftTP.option("value") || "");
        } else {
            var $this = this._rightTP;
            var _value = ej.format(this._rightTP.model.value, $this.model.timeFormat, this.model.locale);
            if (_value)
                this._rightTP.option("minTime", _value);
            if (_value)
                this._rightTP.option("value", _value);
        }
    };

    ejDateRangePicker.prototype._rangeRefresh = function (args) {
        var startElement, endElement;
        if (this._rightDP) {
            var popup = args.element.parent().hasClass("e-left-datepicker") ? this._leftDP.popup : this._rightDP.popup;
        }
        if (this._startDate && this._startDate.date && this._startDate.date.getMonth() == args.month && this._startDate.date.getFullYear() == args.year) {
            startElement = $(popup.find('.current-month[date="' + this._startDate.date.toDateString() + '"]'));
            this._setStartDate(this._startDate.date, startElement, false);
            if (this._startDate.date.getDate() + 1 == startElement.next("td").text())
                $(startElement).addClass("showrange");
        }
        if (this._endDate && this._endDate.date && this._endDate.date.getMonth() == args.month && this._endDate.date.getFullYear() == args.year) {
            endElement = $(popup.find('.current-month[date="' + this._endDate.date.toDateString() + '"]'));
            this._setEndDate(this._endDate.date, endElement, false);
        }
        if (startElement == endElement)
            $(startElement).removeClass("showrange");
        if (this._rightDP)
            if ((this._startDate && this._startDate.date) && (this._endDate && this._endDate.date)) {
                if (this._startDate.date.getFullYear() <= args.year && this._endDate.date.getFullYear() >= args.year) {
                    var s = args.element.parent().hasClass("e-left-datepicker") ? $(popup.find('td.current-month')[0]) : $(popup.find('td.current-month')[0]);
                    var type = args.element.parent().hasClass("e-left-datepicker") ? "left" : "right";
                    this._updateRanges(type);
                }
            }
    };
    ejDateRangePicker.prototype._renderRangesWrapper = function () {
        if (ej.isNullOrUndefined(this._customRangePicker)) {
            this._customRangePicker = ej.buildTag("div.e-custom-dateranges").css("height", this.datePopup.height());
            this.popup.append(this._customRangePicker);
            this._customRangePicker.insertBefore(this._buttonDiv);
            this._ranges_li = "<ul class='e-dateranges-ul'></ul>";
            this._customRangePicker.append(this._ranges_li);
        }
    };
    ejDateRangePicker.prototype.setRange = function (range) {
        var startDate, endDate, ranges;
        this._clearRanges();
        if (typeof range == "string") {
            for (var i = 0; i < this.model.ranges.length; i++) {
                ranges = this.model.ranges[i];
                if (ranges.label == range) {
                    this.model.startDate = ranges.range[0];
                    this.model.endDate = ranges.range[1];
                    this._updatePreRanges();
                    return;
                }
            }
        } else if (typeof range == "object") {
            if (range.length == 2) {
                this.model.startDate = range[0];
                this.model.endDate = range[1];
                this._updatePreRanges();
                return;
            }
        }
    };
    ejDateRangePicker.prototype._updatePreRanges = function () {
        this._selectedStartDate = this.model.startDate;
        this._selectedEndDate = this.model.endDate;
        this._resetValues();
        this._setValues();
        this._refreshMinMax();
        if (!this._popupOpen)
            this._mainValue();
        this._setWaterMark();
    };
    ejDateRangePicker.prototype.destroy = function () {
        this.destroy();
    };
    ejDateRangePicker.prototype._destroy = function () {
        if (this._popupOpen)
            this._showhidePopup();
        if (this.wrapper) {
            this.element.removeClass("e-input");
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
        }
        if (!ej.isNullOrUndefined(this._leftDP))
            this._leftDP.destroy();
        if (!ej.isNullOrUndefined(this._rightDP))
            this._rightDP.destroy();
        if (!ej.isNullOrUndefined(this._rightTP))
            this._rightTP.destroy();
        if (!ej.isNullOrUndefined(this._leftTP))
            this._leftTP.destroy();
        if (!ej.isNullOrUndefined(this._scrollerObj))
            this._scrollerObj.destroy();
        this.popup.remove();
    };
    ejDateRangePicker.prototype.addRanges = function (args) {
        var proxy = this, _ranges_li = "", title;
        if (args) {
            for (var i = 0; i < args.length; i++) {
                var s = args[i];
                var value = s.range;
                if (value.length === 2) {
                    var start = new Date(value[0]);
                    var end = new Date(value[1]);
                    if (ej.isNullOrUndefined(start))
                        start = new Date(value[0]);
                    if (ej.isNullOrUndefined(end))
                        end = new Date(value[1]);
                    if (start <= end) {
                        if (!s.label)
                            s.label = "PreDefined Ranges";
                        _ranges_li += "<li aria-selected='false' title='" + s.label + "'class='rangeItem' e-date-range='" + JSON.stringify(value) + "' e-data-value='" + s.range + "'>" + s.label + "</li>";
                    }
                }
            }
        }
        this._renderRangesWrapper();
        this._customRangePicker.find(".e-dateranges-ul").append(_ranges_li);
        this._off(this._customRangePicker.find("ul li.rangeItem"), "click", this._customSelection);
        this._on(this._customRangePicker.find("ul li.rangeItem"), "click", this._customSelection);
        if (this._scrollerObj)
            this._scrollerObj.refresh();
    };
    ejDateRangePicker.prototype._righthoverRange = function (e) {
        this._activeItem = $(e.currentTarget);
        if (this._activeItem.hasClass("e-hidedate")) {
            e.stopPropagation();

            return;
        }
        this.popup.find(".range-hover").removeClass("range-hover");
        if (this._activeItem.hasClass("in-range"))
            this._activeItem.addClass("range-hover");
        var dateString = this._activeItem.attr("date");
        var currentDate = new Date(dateString);
        this._trigger("hover", { element: e.currentTarget, events: e, value: new Date(this._activeItem.attr("date")) });

        var that = this;
        if (!ej.isNullOrUndefined(that._selectedStartDate) && (ej.isNullOrUndefined(that._selectedEndDate)))
            this.popup.find(".current-month").each(function (index, el) {
                var element = $(el);
                var dateString = element.attr("date");
                if (ej.isNullOrUndefined(dateString) || dateString === "")
                    return;
                var date = new Date(dateString);
                if (date > that._startDate.date && date < currentDate) {
                    element.addClass("in-range");
                } else {
                    element.removeClass("in-range");
                }
                if (date.getTime() === that._selectedStartDate.getTime() && element.next().length !== 0 && element.next("td.current-month").length !== 0 && currentDate > that._selectedStartDate && new Date(new Date(that._selectedStartDate.getTime()).setDate(that._selectedStartDate.getDate() + 1)).getTime() !== currentDate.getTime()) {
                    element.addClass("showrange");
                } else {
                    element.removeClass("showrange");
                }
            });
    };
    ejDateRangePicker.prototype._customSelection = function (e) {
        this._customRangePicker.find(".e-active").removeClass("e-active");
        if ($(e.currentTarget).attr("e-date-range") != "customPicker") {
            var range = $(e.currentTarget).attr("e-data-value").split(",");
            this.model.startDate = new Date(range[0]);
            this.model.endDate = new Date(range[1]);
            this._rightDP.element.parents(".e-datewidget").removeClass("e-error");
            this._customSet();
        } else {
            this.model.startDate = null;
            this.model.endDate = null;
            this._clearRanges();
        }
        $(e.currentTarget).addClass("e-active");
    };
    ejDateRangePicker.prototype._setWaterMark = function () {
        if (this.element != null && this.element.hasClass("e-input")) {
            if ((!this._isSupport) && this.element.val() == "")
                this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
            else
                $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
            return true;
        }
    };
    ejDateRangePicker.prototype._clearRanges = function (e) {
        this._updateRangesList();
        this._setOption("value", "");
        this._rightDP.element.parents(".e-datewidget").removeClass("e-val-error");
        this._selectedStartDate = null;
        this._selectedEndDate = null;
        if (this._startDate)
            this._startDate.date = null;
        if (this._endDate)
            this._endDate.date = null;
        this.popup.find("td").removeClass("e-start-date e-end-date in-range e-active e-state-hover today");
        this.model.value = null;
        this.model.startDate = null;
        this.model.endDate = null;
        if (this._buttonDiv)
            this._buttonDiv.find(".e-drp-apply").addClass("e-disable");
    };
    ejDateRangePicker.prototype.clearRanges = function () {
        this._clearRanges();
        this._refreshMinMax();
        this.element.val("");
		this._trigger("_change", { value: this.model.value });
		this._trigger("change", { value: this.model.value, startDate: this.model.startDate, endDate: this.model.endDate });
        this._trigger("clear", {});
    };
	ejDateRangePicker.prototype._getLocalizedLabels = function () {
        return ej.getLocalizedConstants("ej.DateRangePicker", this.model.locale);
    };
    ejDateRangePicker.prototype._unWireEvents = function () {
        this._off($('.e-next', this.popup), "click", $.proxy(this._previousNextHandler, this));
        this._off($('.e-prev', this.popup), "click", $.proxy(this._previousNextHandler, this));
        this._off($(this._buttonDiv.find("div.e-drp-cancel")), "click", this._cancelButton);
        this._off($(this._buttonDiv.find("div.e-drp-reset")), "click", this.clearRanges);
        this._off(this.popup.find(".leftDate_wrapper.e-datepicker.e-js.e-input"), "blur", this._onPopupFocusOut);
        this._off(this.popup.find(".rightDate_wrapper.e-datepicker.e-js.e-input"), "blur", this._onPopupFocusOut);
        if (this.model.allowEdit) {
            this._off(this.element, "blur", this._onMainFocusOut);
            this._off(this.element, "focus", this._onFocusIn);
            this._off(this.element, "keydown", this._onKeyDown);
        }
    };
    ejDateRangePicker.prototype._onDocumentKeyDown = function (e) {
        if (e.keyCode != "13")
            return;
        if (!this._buttonDiv.find(".e-drp-apply").hasClass("e-disable") && this.wrapper.hasClass("e-focus")) {
            this._buttonDiv.find(".e-drp-apply").click();
        }
    };
    ejDateRangePicker.prototype._wireEvents = function () {
        this._on($('.e-next', this.popup), "click", $.proxy(this._previousNextHandler, this));
        this._on($('.e-prev', this.popup), "click", $.proxy(this._previousNextHandler, this));
        this._on($(this._leftDP.sfCalendar.find('table .e-datepicker-months td')), "click", $.proxy(this._previousNextHandler, this));

        var $this = this;
        this._on($(this._buttonDiv.find("div.e-drp-reset")), "click", this.clearRanges);
        this._on($(this._buttonDiv.find("div.e-drp-apply")), "click", function (e) {
            if ($this._buttonDiv.find(".e-drp-apply").hasClass("e-disable")) {
                return;
            }
			$this._isPopScroll = false;
            $this._updateInput();
            $this._showhidePopup();
            $this._buttonDiv.find(".e-drp-apply").addClass("e-disable");
			this._trigger("change", { value: this.model.value, startDate: this.model.startDate, endDate: this.model.endDate });
            this._trigger("select", { startDate: this.model.startDate, endDate: this.model.endDate, value: this.model.value });
        });
        this._on($(window), "resize", this._resizePopup);
        $(document).on("mousedown", $.proxy(this._onDocumentClick, this));
        $(document).on("keydown", $.proxy(this._onDocumentKeyDown, this));

        this._on($(this._buttonDiv.find("div.e-drp-cancel")), "click", this._cancelButton);
        this._on(this.popup.find(".leftDate_wrapper.e-datepicker.e-js.e-input"), "blur", this._onPopupFocusOut);
        this._on(this.popup.find(".rightDate_wrapper.e-datepicker.e-js.e-input"), "blur", this._onPopupFocusOut);
        this._on(this.popup.find(".leftDate_wrapper.e-timepicker.e-js.e-input"), "blur", this._onPopupFocusOut);
        this._on(this.popup.find(".rightDate_wrapper.e-timepicker.e-js.e-input"), "blur", this._onPopupFocusOut);

        if (this.model.allowEdit) {
            this._on(this.element, "blur", this._onMainFocusOut);
            this._on(this.element, "focus", this._onFocusIn);
            this._on(this.element, "keydown", this._onKeyDown);
        }
        this._on(this._leftDP.element, "keydown", this._onKeyDown);
        this._on(this._rightDP.element, "keydown", this._onKeyDown);
		  this.popup.on("mouseenter touchstart", $.proxy(function () { this._isPopScroll = true; }, this));
          this.popup.on("mouseleave touchend", $.proxy(function () { this._isPopScroll = false; }, this));
    };
    ejDateRangePicker.prototype._onFocusIn = function (e) {
        if (this._isSupport) {
            e.preventDefault();
            this._isFocused = true;
        }
        if (this.wrapper.hasClass("e-error")) {
            this._validState = false;
            this.wrapper.removeClass('e-error');
        }
		    if (!this.model.showPopupButton && !this.model.readOnly) this.popupShow(e);
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
          this.wrapper.addClass("e-focus");
    };

    ejDateRangePicker.prototype._onKeyDown = function (e) {
        if (e.keyCode == 13) {
            if ($(e.currentTarget).hasClass("e-datepicker")) {
                this._validateValues($(e.currentTarget).val(), $(e.currentTarget).parents(".e-left-datepicker").length > 0 ? "left" : "right");
                $(e.currentTarget).parents(".e-left-datepicker").length > 0 ? this._leftDP.model.value = this.model.startDate : this._rightDP.model.value = this.model.endDate;
                this._onPopupFocusOut(e);
            } else {
                $(e.currentTarget).hasClass("leftTime") ? this._leftTP._trigger("select") : this._rightTP._trigger("select");
            }
        }
        e.stopImmediatePropagation();
    };
    ejDateRangePicker.prototype._cancelButton = function () {
        this._prevValue = null, this._isPopScroll = false;
        this._clearRanges();
        this._onMainFocusOut();
        this._showhidePopup();
    };
    ejDateRangePicker.prototype._updateRanges = function (cal_type) {
        var cal = cal_type == "left" ? this._leftDP : this._rightDP;
        var proxy = this;
        cal.popup.find("td.current-month").each(function (index, el) {
            var element = $(el);
            var dateString = element.attr("date");
            if (ej.isNullOrUndefined(dateString) || dateString === "")
                return;
            var date = new Date(dateString);
            if (!ej.isNullOrUndefined(proxy._startDate) && !ej.isNullOrUndefined(proxy._startDate.date) && !ej.isNullOrUndefined(proxy._endDate.date))
                if (date > proxy._startDate.date && date < proxy._endDate.date) {
                    element.addClass("in-range");
                } else {
                    element.removeClass("in-range");
                }
            if (!ej.isNullOrUndefined(proxy._startDate) && !ej.isNullOrUndefined(proxy._startDate.date) && date.toDateString() == proxy._startDate.date.toDateString()) {
                element.addClass("e-start-date");
                if (!ej.isNullOrUndefined(proxy._endDate) && !ej.isNullOrUndefined(proxy._endDate.date) && proxy._startDate.date.toDateString() != proxy._endDate.date.toDateString())
                    element.addClass("showrange");
                element.removeClass("in-range");
            }
            if (!ej.isNullOrUndefined(proxy._endDate) && !ej.isNullOrUndefined(proxy._endDate.date))
                if (!ej.isNullOrUndefined(proxy._endDate) && date.toDateString() == proxy._endDate.date.toDateString()) {
                    element.addClass("e-end-date");
                    element.removeClass("in-range");
                }
        });
        if (cal.popup.find(".e-start-date").length > 0) {
            if ($(cal.popup.find(".e-start-date")).next("td.in-range").length > 0)
                return;
            else
                $(cal.popup.find(".e-start-date")).removeClass("showrange");
        }
    };

    ejDateRangePicker.prototype.getSelectedRange = function () {
        var args = { startDate: this.model.startDate, endDate: this.model.endDate };
        return args;
    };
    ejDateRangePicker.prototype.enable = function () {
        this.element[0].disabled = false;
        this.model.enabled = true;
        this.wrapper.removeClass('e-disable');
        this.element.removeClass("e-disable");
        this.element.attr("aria-enabled", "false");
        this.element.attr("enabled", "enabled");
        if (!this._isSupport)
            this._hiddenInput.attr("enabled", "enabled");
        if (this.dateRangeIcon)
            this.dateRangeIcon.removeClass("e-disable").attr("aria-disabled", "false");
        this.popup.children("div").removeClass("e-disable").attr("aria-disabled", "false");
        this._setOption("enabled", true);
    };
    ejDateRangePicker.prototype.disable = function () {
        this.element[0].disabled = true;
        this.model.enabled = false;
        this.wrapper.addClass('e-disable');
        this.element.addClass("e-disable");
        this.element.attr("aria-disabled", "true");
        this.element.attr("disabled", "disabled");
        if (!this._isSupport)
            this._hiddenInput.attr("disabled", "disabled");
        if (this.dateRangeIcon)
            this.dateRangeIcon.addClass("e-disable").attr("aria-disabled", "true");
        this.popup.children("div").addClass("e-disable").attr("aria-disabled", "true");
        this.popupHide();
        this._setOption("enabled", false);
    };

    ejDateRangePicker.prototype._onMainFocusOut = function (e) {
        var element_value = this.element.val(), setError;
        this.wrapper.removeClass('e-focus');
        if (this.element.val() == "" && this._prevValue == null) {
        return;
        }
        if (this._prevValue && this._prevValue == this.element.val()) {
            this._validState ? this.wrapper.removeClass('e-error').removeClass("e-focus") : this.wrapper.addClass('e-error').removeClass("e-focus");
            return;
        }
        else this._updateRangesList();
        if (this.element.val() == "") {
            this.wrapper.removeClass('e-error');
            this._clearRanges();
            this._setWaterMark();
            this._refreshMinMax();
			this._trigger("change", { value: this.model.value, startDate: null, endDate: null });
			this._trigger("_change", { value: this.model.value});
            return;
        }
        this.wrapper.removeClass("e-error");
        var datestring = this.element.val().split(this.model.separator), _startdate = ej.parseDate(datestring[0], this._dateTimeFormat, this.model.locale), _enddate = ej.parseDate(datestring[1], this._dateTimeFormat, this.model.locale);
        this._resetValues();
        this._validState = true;
        if (!this._validateValues(_startdate, "left") || !this._validateValues(_enddate, "right")) {
            this._clearRanges();
            this._refreshMinMax();
            setError = true;
        }
        if (!this._startEndValidation()) {
            this._clearRanges();
            this._refreshMinMax();
            setError = true;
        }
        if (element_value != "" && setError) {
            this.element.val(element_value);
            this.wrapper.addClass("e-error");
            this.model.value = null;
            this._validState = false;
			this._trigger("_change", { value:this.element.val()});
			this._trigger("change", { value: this.model.value, startDate: null,endDate: null});
            return;
        }
        this._resetValues();
        this._setValues();
        this._refreshMinMax();
        this.model.value = this._validState && element_value != "" ? element_value : null;
        if (!this._popupOpen)
            this._mainValue();
        this._prevValue = this.model.value;
        this._validState ? this.wrapper.removeClass('e-error').removeClass("e-focus") : this.wrapper.addClass('e-error').removeClass("e-focus");
        this._trigger("change", { value: this.model.value, startDate: this.model.startDate, endDate: this.model.endDate });
    };
    ejDateRangePicker.prototype._onPopupFocusOut = function (e) {
        if (ej.format(this._selectedStartDate, "M/d/yyyy") != $("#daterangeleftDate_wrapper").val() || ej.format(this._selectedEndDate, "M/d/yyyy") != $("#daterangerightDate_wrapper").val()) {
            this._updateRangesList();
        }
        var picker = $(e.currentTarget).parents(".e-left-datepicker").length > 0 ? this._leftDP : this._rightDP;
        this._validateValues($(e.currentTarget).val(), $(e.currentTarget).parents(".e-left-datepicker").length > 0 ? "left" : "right");
        $(e.currentTarget).parents(".e-left-datepicker").length > 0 ? this._leftDP.model.value = this.model.startDate : this._rightDP.model.value = this.model.endDate;
        var _prevStartValue = this.model.startDate;
        var _prevEndValue = this.model.endDate, stop = false;
        this._rightDP.element.parents(".e-datewidget").removeClass("e-val-error");
        if (!this._startEndValidation()) {
            if ($(e.currentTarget).parents(".e-left-datepicker").length > 0) {
                this._clearRanges();
                this.model.startDate = _prevStartValue;
                this._selectedStartDate = this.model.startDate;
            } else {
                this._rightDP.element.parents(".e-datewidget").addClass("e-val-error");
                this.model.endDate = null;
                stop = true;
            }
        }
        if (_prevStartValue == null) {
            this._clearRanges();
            return;
        }
        this._selectedStartDate = this.model.startDate;
        this._selectedEndDate = this.model.endDate;
        this._resetValues();
	    this._setValues();
		 if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
        this._refreshMinMax();
        if (!this._popupOpen)
            this._mainValue();
        if (stop)
            this._rightDP.element.val(_prevEndValue.toLocaleDateString());
        this._setWaterMark();
    };
    ejDateRangePicker.prototype._resetValues = function () {
        this._leftDP.option("maxDate", null);
        this._rightDP.option("minDate", null);
        this._leftDP.option("value", this._leftDP.model.value);
        this._rightDP.option("value", this._rightDP.model.value);
    };
    ejDateRangePicker.prototype._refreshMinMax = function () {
        var local = this._getNextMonth(this._leftDP._calendarDate);
        if (local.toDateString() > this._rightDP._calendarDate.toDateString()) {
            var temp = this._rightDP.model.value;
            this._rightDP._calendarDate = local;
            this._rightDP._dateValue = local;
            this._rightDP.option("value", local);
        }
        this._rightDP.option("minDate", local);
        this._rightDP.option("value", temp);
        var temp = this._rightDP._calendarDate, y = temp.getFullYear(), m = temp.getMonth();
        this._leftDP.option("maxDate", new Date(y, m, 0));
    };
    ejDateRangePicker.prototype._refreshEvents = function (cal_type) {
        this._off(this._rightDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "click", this._dateEleClicked);
        this._off(this._leftDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "click", this._dateEleClicked);
        this._off(this._rightDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "mouseover", this._righthoverRange);
        this._off(this._leftDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "mouseover", this._righthoverRange);
        this._on(this._leftDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "mouseover", this._righthoverRange);
        this._on(this._leftDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "click", this._dateEleClicked);
        this._on(this._rightDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "mouseover", this._righthoverRange);
        this._on(this._rightDP.sfCalendar.find('table .e-datepicker-days td.e-state-default'), "click", this._dateEleClicked);
        this._on($(this._leftDP.sfCalendar.find('table .e-datepicker-months td')), "click", $.proxy(this._previousNextHandler, this));
    };
    ejDateRangePicker.prototype._previousNextHandler = function (e) {
        var selectedCalender = $(e.currentTarget).closest(".e-calendar").parent();
        var cal_type = selectedCalender.hasClass("e-left-datepicker") ? "left" : "right", leftDateString, rightDateString;
        if (e.type == "_month_Loaded") {
            if (cal_type == "left") {
                rightDateString = $(this._rightDP.popup.find("td.current-month")[0]).attr("date");
                leftDateString = this._leftDP._dateValue.toDateString();
            } else if (cal_type == "right") {
                leftDateString = $(this._leftDP.popup.find("td.current-month")[0]).attr("date");
                rightDateString = this._rightDP._dateValue.toDateString();
            }
        } else {
            rightDateString = $(this._rightDP.popup.find("td.current-month")[0]).attr("date");
            leftDateString = $(this._leftDP.popup.find("td.current-month")[0]).attr("date");
        }
        var leftDate = new Date(leftDateString);
        var rightDate = new Date(rightDateString);
        leftDate.setHours(0, 0, 0, 0);
        rightDate.setHours(0, 0, 0, 0);
        var status = true;
        if (cal_type == "right") {
            var cls = $("table", this._leftDP.sfCalendar).get(0).className;
            if (cls == "e-dp-viewdays")
                this._leftDP._stopRefresh = true;
            this._rightDP._stopRefresh = false;
            var temp = rightDate, y = temp.getFullYear(), m = temp.getMonth();
            this._leftDP.option("maxDate", new Date(y, m, 0));
            if (cls == "e-dp-viewmonths")
                this._leftDP._startLevel("year");
            this._leftDP._checkDateArrows();
        } else {
            var cls = $("table", this._rightDP.sfCalendar).get(0).className;
            if ($("table", this._rightDP.sfCalendar).get(0).className == "e-dp-viewdays")
                this._rightDP._stopRefresh = true;
            this._leftDP._stopRefresh = false;
            this._rightDP.option("minDate", this._getNextMonth(leftDate));
            if (cls == "e-dp-viewmonths")
                this._rightDP._startLevel("year");
            this._rightDP._checkDateArrows();
        }

        this._rightDP.element.parents(".e-datewidget").removeClass("e-error");
    };
    return ejDateRangePicker;
})(ej.WidgetBase);
window.ej.widget("ejDateRangePicker", "ej.DateRangePicker", new ejDateRangePicker());
window["ejDateRangePicker"] = null;

ej.DateRangePicker.Locale = {};

ej.DateRangePicker.Locale = ej.DateRangePicker.Locale || {};

ej.DateRangePicker.Locale['default'] = ej.DateRangePicker.Locale['en-US'] = {
    ButtonText: {
        apply: "Apply",
        cancel: "Cancel",
        reset: "Reset"
    },
    watermarkText: "Select Range",
    customPicker: "Custom Picker"
};
//# sourceMappingURL=ej.daterangepicker.js.map
;

/**
* @fileOverview Plugin to style the Dialog control
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDialog", "ej.Dialog", {
        _rootCSS: "e-dialog",

        element: null,
        _ignoreOnPersist: ["drag", "dragStart", "dragStop", "resizeStop", "resizeStart", "resize", "beforeClose", "beforeOpen", "collapse", "expand", "close", "open", "destroy", "create", "ajaxSuccess", "ajaxError", "contentLoad", "actionButtonClick", "enableResize"],

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            showOnInit: true,

            closeOnEscape: true,

            //currently we have deprecated this API
            closeIconTooltip: "close",

            enableAnimation: true,

            allowDraggable: true,

            backgroundScroll: true,

            height: "auto",

            minHeight: 120,

            minWidth: 200,

            maxHeight: null,

            maxWidth: null,

            enableModal: false,

            position: { X: "", Y: "" },

            containment: null,

            enableResize: true,

            htmlAttributes: {},

            showHeader: true,

            showFooter: false,

            contentType: null,

            contentUrl: null,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            title: "",

            width: 400,

            zIndex: 1000,

            cssClass: "",

            enableRTL: false,

            allowKeyboardNavigation: true,

            showRoundedCorner: false,

            actionButtons: ["close"],

            animation:{
                show:{
                    effect:"fade",
                    duration:400
                },
                hide:{
                    effect:"fade",
                    duration:400
                }
            },            

            tooltip:{
                close: "Close",
                collapse: "Collapse",
                restore: "Restore",
                maximize: "Maximize",
                minimize: "Minimize",
                expand: "Expand",
                unPin: "UnPin",
                pin: "Pin"
            },

            footerTemplateId: null,
            
            locale:"en-US",
            
            faviconCSS: null,

            content: null,

            target: null,

            enablePersistence: false,

            enabled: true,

            isResponsive: false,

            actionButtonClick: null,

            beforeClose: null,

            close: null,            

            expand: null,

            collapse: null,

            beforeOpen: null,

            open: null,

            drag: null,

            dragStart: null,

            dragStop: null,

            resize: null,

            resizeStart: null,

            resizeStop: null,

            contentLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            create: null,

            destroy: null,

            /*Deprecated*/            
            Close:null
        },

        dataTypes: {
            showOnInit: "boolean",
            closeOnEscape: "boolean",
            enableAnimation: "boolean",
            backgroundScroll: "boolean",
            position: "data",
            animation:"data",
            closeIconTooltip: "string",
            tooltip: "data",
            allowDraggable: "boolean",
            enableModal: "boolean",
            enableResize: "boolean",
            isResponsive: "boolean",
            showHeader: "boolean",
            showFooter: "boolean",
            title: "string",
            faviconCSS:"string",
            zIndex: "number",
            cssClass: "string",
            enablePersistence: "boolean",
            contentUrl: "string",
            contentType: "string",
            enableRTL: "boolean",
            enabled: "boolean",
            allowKeyboardNavigation: "boolean",
            showRoundedCorner: "boolean",
            locale: "string",
            htmlAttributes: "data",
            ajaxSettings: "data",
            actionButtons: "array",
			footerTemplateId: "string"
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "closeIconTooltip": this._dialogClose.attr("title", options[key]); break;
                    case "tooltip": this._tooltipText(options[key]); break;
                    case "title":
                        this.model.title = options[key];
                        if (this._ejDialog.find("span.e-title").length <= 0) 
                            this._addTitleText();
                        else
                            this._ejDialog.find("span.e-title").html(options[key]);
                        this._updateCaptionWidth();
                        break;
                    case "width": this.model.width = options[key]; this._changeSize(); this._updateCaptionWidth(); options[key] = this.model.width; break;
                    case "height": this.model.height = options[key]; this._changeSize(); options[key] = this.model.height; break;
                    case "position": this.model.position = options[key]; this._dialogPosition(); break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this.model.showRoundedCorner=options[key]; this._roundedCorner(options[key]); break;
                    case "contentType": { this.model.contentType = options[key]; this._appendContent(options[key]); break; }
                    case "enabled": { this.model.enabled = options[key]; this._enabledAction(options[key]); break; }
                    case "contentUrl": { this.model.contentUrl = options[key]; this._appendContent(this.model.contentType); break; }
					case "backgroundScroll":
						this.model.backgroundScroll = options[key]; 
						if (!this.model.backgroundScroll && this.model.enableModal) $("body").addClass("e-dialog-modal");
						else $("body").removeClass("e-dialog-modal");
						break;
                    case "content":
                    case "target": 
                        this._ejDialog.appendTo($(options[key]));
                        this.model.target = this.model.content = options[key];
                        this._dialogPosition();
                        break;
                    case "containment":
                        this._setDragArea(options[key]);
                        !ej.isNullOrUndefined(this._target) ? this._ejDialog.appendTo(this._target) : this._ejDialog.appendTo(document.body);
                        this.model.position.X = this.model.position.Y = "";
                        this._dialogPosition();
                        this.model.containment = options[key] = this._target;
                        this.model.enableModal && this._createOverlay();
                        this._dialogTitlebar.ejDraggable({ dragArea: this._target });
                        break;
                    case "locale":
					    this.model.locale = options[key];
                        this.localizedLabels = this._getLocalizedLabels(); 
                        this._setLocaleCulture(this.localizedLabels, true);
                        this._tooltipText(this.model.tooltip);
						if (this._ejDialog.find("span.e-title").length <= 0) 
                            this._addTitleText();
                        else
                            this._ejDialog.find("span.e-title").html(this.model.title);
                        this._updateCaptionWidth();                       				
                        break;
                    case "minHeight": { this.model.minHeight = options[key]; this._ejDialog.css("minHeight", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "minWidth": { this.model.minWidth = options[key]; this._ejDialog.css("minWidth", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "maxHeight": { this.model.maxHeight = options[key]; this._ejDialog.css("maxHeight", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "maxWidth": { this.model.maxWidth = options[key]; this._ejDialog.css("maxWidth", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "zIndex": { this._ejDialog.css('z-index', options[key]); break; }
                    case "faviconCSS":
                        this.model.faviconCSS = options[key]; this._favIcon();this._updateCaptionWidth(); break;
                    case "isResponsive": {
                        this.model.isResponsive = options[key];
                        this.model.isResponsive ? this._ejDialog.addClass("e-dialog-resize") : this._ejDialog.removeClass("e-dialog-resize");
                        this._wireResizing();
                        break;
                    }
                    case "allowDraggable": {
                        this.model.allowDraggable = options[key];
                        if (options[key])
                            this._enableDrag();
                        else {
                            this._dialogTitlebar.removeClass("e-draggable");
                        }
                        break;
                    }
                    case "enableResize": {
                        this.model.enableResize = options[key];
                        if (options[key])
                            this._enableResize();
                        else {
                            this._ejDialog.removeClass("e-resizable");
                            this._ejDialog.find(".e-resize-handle").remove();
                        }
                        this._reRenderScroller();
                        break;
                    }
                    case "showHeader": {
                        this.model.showHeader = options[key];
                        if (options[key]) {
                            this._renderTitleBar();
                            this._iconsRender(this.model.actionButtons);
                            if (this.model.faviconCSS) { this._dialogFavIcon = false; this._favIcon(); }
                            this._enableDrag();
                            if (!this._maximize) this._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? (this._ejDialog.outerHeight(true) - (this._dialogTitlebar.outerHeight(true))) : this._ejDialog.outerHeight(true) - 1 - (this._dialogTitlebar.outerHeight(true)), (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2);
                        }
                        else {
                            this._ejDialog.find(".e-titlebar").remove();
                            this._maximize ? this.refresh() : this._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.outerHeight(true) : this._ejDialog.outerHeight(true) - 1, (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2);
                        }
                        this._roundedCorner(this.model.showRoundedCorner);
                        if (this.model.showFooter) this._setContainerSize()._resetScroller();
                        break;
                    }
                    case "showFooter": {
                        this.model.showFooter = options[key];
                        if (options[key]) {
                            this._appendContent();
                            this._ejDialog.find(".e-resizable").remove();
                        }
                        else 
                            this._ejDialog.find(".e-footerbar").remove();
                        this._enableResize()._enableDrag()._sizeInPercent();
                        this._reRenderScroller();
                        this._setContainerSize()._resetScroller();
                        this._roundedCorner(this.model.showRoundedCorner);
                        break;
                    }
                    case "footerTemplateId": {
                        this.model.footerTemplateId = options[key];
                        if (this.model.showFooter) {
                            this._ejDialog.find(".e-footerbar").empty();
                            var templateContent = $('body').find("#" + this.model.footerTemplateId).html();
                            this._dialogFooterbar.append(templateContent);
                            this._enableResize();
                        }
                        break;
                    }
                    case "enableRTL":
                        {
                            this.model.enableRTL = options[key];
                            if (this.model.faviconCSS) this._favIcon();
                            if (options[key]) {
                                this._ejDialog.addClass("e-rtl");
                                this.iframe && this.iframe.contents().find("body").css("direction", "rtl");
                                if (this.scroller) 
                                    this._resetScroller();
                            } else {
                                this._ejDialog.removeClass("e-rtl");
                                this.iframe && this.iframe.contents().find("body").css("direction", "ltr");
                                if (this.scroller) 
                                    this._resetScroller();
                            }
                            break;
                        }
                    case "actionButtons":
                        {
                            if (!ej.isNullOrUndefined(this._dialogTitlebar) ){
                                this._removeAllIcons();
                                this._iconsRender(options[key]);
                            }
                            this.model.actionButtons = options[key];
                            this._updateCaptionWidth();
                            break;
                        }
                    case "enableModal": {
                        this._enableModal(options[key]);
                        break;
                    }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                }
            }
        },


        _destroy: function () {
            if (this._overLay) this._overLay.remove();
            this._cloneElement.appendTo(this._ejDialog.parent());
            this._ejDialog.remove();
            this._cloneElement.removeClass("e-dialog");
            this.element = this._cloneElement;
            this._isOpen = false;
        },

        keyConfigs: [37, 38, 39, 40],

        _init: function () {
			this._init=true;
            this._widthPercent = null;
            this._heightPercent = null;
            this._windowSize = { outerWidth: $(window).outerWidth(), outerHeight: $(window).outerHeight() };
            this._initSize = { width: this.model.width, height: this.model.height };
            this._sizeType = { width: isNaN(this.model.width) ? this.model.width.match(/px|%|auto/g)[0] : null, height: isNaN(this.model.height) ? this.model.height.match(/px|%|auto/g)[0] : null };
            this._isOpen = this._maximize = this._minimize = false;
            this.localizedLabels = this._getLocalizedLabels(); 
            this._setLocaleCulture(this.localizedLabels);
            this._setDimension();
            if (!this.model.close) this.model.close = this.model.Close;
            if (!this.model.target) this.model.target = this.model.content;
			this._responsive();
            this._renderControl();
            this._wireEvents();    
            this.scrObj= this._ejDialog.closest(".e-dialog.e-js").data("ejDialog")
            if(this.scrObj) this.scrObj._resetScroller(); 
			this.hidden=false;			
            this._init=false;
            this._keyNavigation=false;	
        },
		
		_responsive: function () {
            this.width = this.model.width;
            $(this.element).width(this.width);

            this.height = this.model.height;
            $(this.element).height(this.height);
            $(window).on("resize", $.proxy(this._resizeHandler, this));
        },
        
        _resizeHandler: function () {
            if (this._maximize) {
                this.width = $(this._dialogTitlebar).outerWidth();
                $(this.contentDiv).width(this.width);
                $(this.contentDiv).children().width(this.width);

                this.model.height = this.height = $(window).height();
                this._ejDialog.css({ height: this.height });
                this.contentDiv.height(this._ejDialog.height() - $(this._dialogTitlebar).outerHeight() - $(this._dialogFooterbar).outerHeight());
                this.element.height(this.contentDiv.height());
            }
			if(!ej.isNullOrUndefined(this.element)) this._resetScroller();
        },
       
        _setLocaleCulture:function(localizedLabels, isSetModel){
            //Deprecated closeIconTooltip locale
            if(this.defaults.closeIconTooltip===this.model.closeIconTooltip)
                this.model.closeIconTooltip=localizedLabels.closeIconTooltip;
			
                if (isSetModel) {	
                 	 this.model.tooltip= this.localizedLabels.tooltip ;
                     this.model.title= this.localizedLabels.title;			 
				} 
				if(JSON.stringify(this.model.tooltip) === JSON.stringify(this.defaults.tooltip))
                this.model.tooltip=localizedLabels.tooltip;  				
				if(this.model.title === this.defaults.title)
				this.model.title=localizedLabels.title;  
        },

        _setDragArea: function (value) {
            if (!ej.isNullOrUndefined(value))
            {
                if (typeof value == "string") {
                    if (value == "parent") this._target = $(this.element).parent();
                    if (value.toLowerCase() == "document") this._target = $(document);
                    if (value.toLowerCase() == "window") this._target = $(window);
                    else if ($(value).length > 0) this._target = $(value);
                } else if (typeof value == "object") {
                    if (value.length > 0) this._target = value;
                }
                else this._target = null;
            } else this._target = null;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy._ejDialog.addClass(value);
                else if (key == "disabled" && value == "disabled") { proxy.model.enabled = false; proxy._enabledAction(false); }
                else proxy._ejDialog.attr(key, value);
            });
        },
        _tooltipText: function(data){
            $.extend(this.model.tooltip, data);
            if(!ej.isNullOrUndefined(this._dialogClose) && this._dialogClose.hasClass('e-close'))
                this._dialogClose.attr("title", this.model.tooltip.close);
            if (!ej.isNullOrUndefined(this._dialogCollapsible) && (data.collapse || data.expand)) {
                if (this._dialogCollapsible.hasClass('e-arrowhead-up'))
                    this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                if (this._dialogCollapsible.hasClass('e-arrowhead-down'))
                    this._dialogCollapsible.attr("title", this.model.tooltip.expand);
            }
            if (!ej.isNullOrUndefined(this._dialogMaximize) && (data.maximize || data.restore)) {
                if (this._dialogMaximize.hasClass('e-maximize'))
                    this._dialogMaximize.attr("title", this.model.tooltip.maximize);
                if (this._dialogMaximize.hasClass('e-restore'))
                    this._dialogMaximize.attr("title", this.model.tooltip.restore);
            }
            if (!ej.isNullOrUndefined(this._dialogMinimize) && (data.minimize || data.restore)) {
                if (this._dialogMinimize.hasClass('e-minus'))
                    this._dialogMinimize.attr("title", this.model.tooltip.minimize);
                if (this._dialogMinimize.hasClass('e-restore'))
                    this._dialogMinimize.attr("title", this.model.tooltip.restore);
            }
            if (!ej.isNullOrUndefined(this._dialogPin) && (data.pin || data.unPin)) {
                if (this._dialogPin.hasClass('e-unpin'))
                    this._dialogPin.attr("title", this.model.tooltip.pin);
                if (this._dialogPin.hasClass('e-pin'))
                    this._dialogPin.attr("title", this.model.tooltip.unPin);
            }
        },
        _renderControl: function () {
            this._cloneElement = this.element.clone();
            this.element.attr("tabindex", 0).attr({ "role": "dialog", "aria-labelledby": this.element.prop("id") + "_title" });
            this._ejDialog = ej.buildTag("div.e-dialog e-widget e-box " + this.model.cssClass + " e-dialog-wrap e-shadow#" + (this.element.prop("id") == "" ? "" : this.element.prop("id") + "_wrapper"), "", { display: "none", zIndex: this.model.zIndex }, { tabindex: 0 });
            if(this.model.isResponsive) this._ejDialog.addClass("e-dialog-resize");
            this.wrapper = this._ejDialog;
            this._addAttr(this.model.htmlAttributes);
            this._setDragArea(this.model.containment);
            if(!ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target)) var target = this._target;                
            else if(!ej.isNullOrUndefined(this.model.target)) var target = this.model.target;
            var wrapperTarget = !ej.isNullOrUndefined(target) ? target : document.body;
            var oldWrapper = $(wrapperTarget).find("#" + this._id + "_wrapper").get(0);
            if (oldWrapper) $(oldWrapper).remove();
            this._ejDialog.appendTo(wrapperTarget);
            if (this.model.enableRTL) this._ejDialog.addClass("e-rtl");
            if (this.model.showHeader) {
                this._renderTitleBar();
                this._iconsRender(this.model.actionButtons);
                if (this.model.faviconCSS) this._favIcon();
            }
            this._appendContent(this.model.contentType);
            this._enableResize()._enableDrag()._setSize();
			if(this.model.height != "auto") this._sizeInPercent();
            if (this.model.contentType != "ajax"){                                                                  
                if (this.model.showOnInit && this.open()) {
                    this._setContainerSize()._resetScroller();
                }
                else this._setHiddenDialogSize();
            }
            this._roundedCorner(this.model.showRoundedCorner);
            this._enabledAction(this.model.enabled);
            if (this._sizeType.width == "auto") this._maxWidth = this.model.width;
            if (this._sizeType.height == "auto") this._maxHeight = this.model.height;
        },

        _setContainerSize: function () {
            if (this.model.height != "auto") {
                var cntHeight = this._ejDialog.outerHeight() - ((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)  + ((this.model.showFooter)? $(this._ejDialog.find("div.e-footerbar")).outerHeight(true) : 0) - 1;
                this.contentDiv.height(cntHeight);
                this.element.outerHeight(cntHeight);
            }
            return this;
        },

        _changeSize: function () {
            this._initSize = { width: this.model.width, height: this.model.height };
            this._sizeType.width = isNaN(this.model.width) ? this.model.width.match(/px|%|auto/g) : null;
            this._sizeType.height = isNaN(this.model.height) ? this.model.height.match(/px|%|auto/g) : null;
            this._setSize()._sizeInPercent()._setContainerSize()._resetScroller();
        },

        _enableDrag: function () {
            if (this.model.allowDraggable && this.model.showHeader) {
                this._dialogTitlebar.addClass("e-draggable");
                this._dragDialog();
            }
            return this;
        },

        _enableResize: function () {
            if (this.model.enableResize) {
                this._ejDialog.addClass("e-resizable");
                var resizeDiv = ej.buildTag("div.e-icon e-resize-handle");
                if (this.model.showFooter) 
                    resizeDiv.appendTo(this._dialogFooterbar);
                else
                    resizeDiv.appendTo(this._ejDialog);
                this._resizeDialog();
            }
            return this;
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this._ejDialog.removeClass(this.model.cssClass).addClass(skin);
            }
        },
        _enableModal: function (value) {
            if (value) this._isOpen && this._createOverlay();
            else if (this._overLay) this._overLay.remove();
        },

        _enabledAction: function (flag) {
            if (flag) {
                this._ejDialog.removeClass("e-disable");
                this.wrapper.children(".e-disable-overlay").remove();
                if (!ej.isNullOrUndefined(this.scroller))
                    this.scroller.enable();
            }
            else {
                this._ejDialog.addClass("e-disable");
                ej.buildTag("div.e-disable-overlay").appendTo(this.wrapper);
                if (!ej.isNullOrUndefined(this.scroller))
                    this.scroller.disable();
            }
        },

        _renderTitleBar: function () {
            this._elementTitle = this.element.attr("title");
            if (typeof this._elementTitle !== "string")
                this._elementTitle = "";
            this.model.title = this.model.title || this._elementTitle;
            this._dialogTitlebar = ej.buildTag("div#" + this.element.prop("id") + "_title.e-titlebar e-header e-dialog").prependTo(this._ejDialog);
            this._addTitleText();
        },

        _renderFooterBar: function () {
            this._dialogFooterbar = ej.buildTag("div#" + this.element.prop("id") + "_foot.e-footerbar e-dialog e-js").appendTo(this._ejDialog);
        },

        _addTitleText: function () {
            if (this.model.title) 
                this._titleText = ej.buildTag("span.e-title", this.model.title).prependTo(this._dialogTitlebar);
            return this;
        },
        _updateCaptionWidth: function () {
            var addWidth=this.model.faviconCSS && !ej.isNullOrUndefined(this._dialogFavIcon)?this._dialogFavIcon.outerWidth():0;
			if(this._titleText)
			    this._titleText.css("max-width", (this._dialogTitlebar.width() - 20 - (this._dialogTitlebar.find(".e-dialog-icon").width() * this._dialogTitlebar.find(".e-dialog-icon").length) - addWidth));
			return this;
        },
        _iconsRender: function (iconArray) {
            for (var icon = 0; icon < iconArray.length; icon++) {
                switch ((ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8) ? $.trim(iconArray[icon]) : iconArray[icon].trim()) {
                    case "close": {
                        this._closeIcon();
                        break;
                    }
                    case "collapse":
                    case "collapsible": {
                        this._collapsibleIcon();
                        break;
                    }
                    case "maximize": {
                        this._maximizeIcon();
                        break;
                    }
                    case "minimize": {
                        this._minimizeIcon();
                        break;
                    }
                    case "pin": {
                        this._pinIcon();
                        break;
                    }
                    default: {
                        this._customIconsRender(iconArray[icon]);
                        break;
                    }
                }
            }
        },

        _customIconsRender: function (icon) {
            this._customIcon = ej.util.buildTag("div#" + this.element[0].id + "_" + icon + "button.e-dialog-icon e-icon e-" + icon, null, null).attr('tabIndex', '0').attr('title', icon);
            this._customIcon.appendTo(this._dialogTitlebar);
            this._on(this._customIcon, "touchstart click", this._iconClick);
        },

        _iconClick: function () {
            
            if (!this.element.hasClass("e-disable")) {
                var args = {
                    cancel: false,
                    buttonID: $(event.target).attr("id"),
                    event: event.type,
                    model: this.model,
                    currentTarget: event.currentTarget.title
                }
                this._trigger("actionButtonClick", args);
            }
        },

        _removeAllIcons: function () {
            this._dialogTitlebar.find("div.e-dialog-icon").remove();
        },

        _appendContent: function (contentType) {
            this.contentDiv = ej.isNullOrUndefined(this.contentDiv) ? ej.buildTag("div.e-dialog-scroller") : this.contentDiv;
            this.element.removeAttr("title").addClass("e-widget-content e-box");
            var proxy = this;
            if (!ej.isNullOrUndefined(this.model.contentUrl) && !ej.isNullOrUndefined(contentType)) {
                if (contentType == "ajax") {
                    this.model.ajaxSettings.url = this.model.contentUrl;
                    this._sendAjaxOptions(this.element, this.model.ajaxSettings.url);
                }
                else if (contentType == "iframe") {
                    if (this.element.children('.e-iframe').length > 0) {
                        this.iframe = this.element.find('iframe.e-iframe');
                        this.iframe.attr('src', this.model.contentUrl);
                    }
                    else {
                        this.iframe = ej.buildTag("iframe.e-iframe", "", { width: "100%", height:"100%" }, { scrolling: "auto", frameborder: 0, src: this.model.contentUrl });
                        this.element.appendTo(this.contentDiv).append(this.iframe).show();
                    }
                    if (this.model.enableRTL) {
                        $(this.iframe).load(function () {
                            proxy.iframe.contents().find("body").css("direction", "rtl");
                        });
                    }
                    this._trigger("contentLoad", { contentType: contentType, url: this.model.contentUrl });
                }
                else if (contentType == "image") {
                    var img = ej.buildTag("img.e-images", "", "", { src: this.model.contentUrl });
                    this.element.append(img).show().appendTo(this.contentDiv);
                    $(img).on("load", function () {
                        proxy._dialogPosition();
                    });
                    this._trigger("contentLoad", { contentType: contentType, url: this.model.contentUrl });
                }
                else
                    this.element.show().appendTo(this.contentDiv);
            }
            else {
				this.dialogIframeContent = this.element.children().find('iframe').contents()[0];
				if (!ej.isNullOrUndefined(this.dialogIframeContent)) {
				   this.element.show().appendTo(this.contentDiv).find('iframe').append(this.dialogIframeContent.lastChild);
				}
				else
					this.element.show().appendTo(this.contentDiv);
			}
            if (this._ejDialog.find("div.e-resize-handle").length > 0) {
                if (this._ejDialog.find(".e-footerbar").length == 0)
				this.contentDiv.insertBefore(this._ejDialog.find("div.e-resize-handle"));
			}
			else {
				var dialogIframeContent = this.element.children().find('iframe').contents()[0];
				if (!ej.isNullOrUndefined(dialogIframeContent)) {
                    this.contentDiv.appendTo(this._ejDialog);
					var getid = $("#"+this.contentDiv.find('iframe').attr('id'));
					$(getid[0].contentDocument.lastChild).remove();
				    getid[0].contentDocument.appendChild(dialogIframeContent);
					if(ej.browserInfo().name == "mozilla")
					setTimeout(function () {
						$(getid[0].contentDocument.lastChild).remove();
				        getid[0].contentDocument.appendChild(dialogIframeContent);
                    },500);
				}
				else {
					if(this._ejDialog.find(".e-footerbar").length == 0)
					this.contentDiv.appendTo(this._ejDialog);
				    else
                    this.contentDiv.insertBefore(this._dialogFooterbar);
				     }
				}
            if (this.model.showFooter && this._ejDialog.find(".e-footerbar").length == 0) {
                this._renderFooterBar();
                if (this.model.footerTemplateId != null) {
                    var templateContent = $('body').find("#" + this.model.footerTemplateId).html();
                    this._dialogFooterbar.append(templateContent);
                }
            }
        },

        _roundedCorner: function (value) {
            this._ejDialog[(value ? "addClass" : "removeClass")]('e-corner');
            this.contentDiv.removeClass('e-dialog-top e-dialog-bottom e-dialog-content');
            if (this.model.showRoundedCorner) {
                this.model.showHeader && !this.model.showFooter ? this.contentDiv.addClass('e-dialog-bottom') : !this.model.showHeader && this.model.showFooter ? this.contentDiv.addClass('e-dialog-top') : !this.model.showHeader && !this.model.showFooter ? this.contentDiv.addClass('e-dialog-content') : true;
            }
        },

        _reRenderScroller: function () {
            if (this.scroller != undefined) {
				this.scroller.refresh(true);
                if (!this.model.enableRTL) {
                    if ((this.scroller._vScrollbar && this.scroller._vScrollbar._scrollData) && this.model.enableResize) {
                        if (this.model.showFooter) 
                            var height = this.scroller._vScrollbar.element.find('> div.e-vscroll').height(), padngSpace = 0, resizeHandleSize = 0;
                        else
                            var height = this.scroller._vScrollbar.element.find('> div.e-vscroll').height(), padngSpace = 2, resizeHandleSize = this._ejDialog.find('div.e-resize-handle').outerHeight();
	                    if (Math.floor(this.contentDiv.outerHeight()) === Math.floor(this.scroller._vScrollbar.model.height + 1)) {
                            this.scroller._vScrollbar.model.height -= resizeHandleSize + padngSpace;
                            this.scroller._vScrollbar._scrollData.handle -= resizeHandleSize;
                            this.scroller._vScrollbar._scrollData.handleSpace -= resizeHandleSize + padngSpace;
                            this.scroller._vScrollbar._updateLayout(this.scroller._vScrollbar._scrollData);
                            this.scroller._vScrollbar.element.find('> div.e-vscroll').height(height - resizeHandleSize - padngSpace);
                        }
                    }
                    if (!(this.scroller._vScrollbar && this.scroller._vScrollbar._scrollData) && (this.scroller._hScrollbar && this.scroller._hScrollbar._scrollData) && this.model.enableResize) {
                        if (this.model.showFooter) 
                            var width = this.scroller._hScrollbar.element.find('> div.e-hscroll').width(), padngSpace = 0, resizeHandleSize = 0;
                        else
                            var width = this.scroller._hScrollbar.element.find('> div.e-hscroll').width(), padngSpace = 2, resizeHandleSize = this._ejDialog.find('div.e-resize-handle').outerWidth();
                        this.scroller._hScrollbar.model.width -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._scrollData.handle -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._scrollData.handleSpace -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._updateLayout(this.scroller._hScrollbar._scrollData);
                        this.scroller._hScrollbar.element.find('> div.e-hscroll').width(width - resizeHandleSize - padngSpace);
                    }
                }
            }
        },       

        _dialogMaxZindex: function () {
            var parents = this.element.parents(), bodyEle, contEle,index,cindex;
            bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            contEle = $(this.model.target).children(), cindex = contEle.index(this.popup);
            contEle.splice(cindex, 1);
            $(contEle).each(function (i, ele) { parents.push(ele); });
            var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;
        },

        _setZindex: function () {
            var zindex = this._dialogMaxZindex();
            if (this.model.zIndex <= zindex)
                this._ejDialog.css({ zIndex: zindex + 1 });
        },

        _createOverlay: function () {
            var zindex = this._ejDialog.css('zIndex'), target, element, position;
            !ej.isNullOrUndefined(this._overLay) && this._overLay.remove();
            if (!this.model.backgroundScroll) $("body").addClass("e-dialog-modal");
            this._overLay = ej.buildTag("div#" + this.element.attr("id") + "_overLay.e-overlay", "", { zIndex: zindex - 1 });
            if (!ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target)) target = this._target;
            else if (!ej.isNullOrUndefined(this.model.target)) target = this.model.target;
            this._overLay.appendTo(!ej.isNullOrUndefined(target) ? target : document.body);
            var position = !ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target) ? "absolute" : "fixed";
            var left =(ej.isNullOrUndefined(target) || position=="fixed") ? 0 : $(target).css('position').toLowerCase() != "static" ? 0 : $(target).offset().left;
            var top = (ej.isNullOrUndefined(target) || position=="fixed") ? 0 : $(target).css('position').toLowerCase() != "static" ? 0 : $(target).offset().top;
            this._overLay.css({ top: top, left: left, position: position });
        },

        _sendAjaxOptions: function (content, link) {
            //load waiting popup
            content.addClass("e-load");
            var proxy = this;
            var curTitle = this.model.title;
            var hrefLink = link;
            var ajaxOptions = {
                "success": function (data) {
                    try { proxy._ajaxSuccessHandler(data, content, link, curTitle); }
                    catch (e) { }
                },
                "error": function (e) {
                    try { proxy._ajaxErrorHandler({ "status": e.status, "responseText": e.responseText, "statusText": e.statusText }, content, link, curTitle); }
                    catch (e) { }
                },
                "complete": function () {
                    try {
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        if (!proxy.model.showOnInit) proxy._setHiddenDialogSize();
                    } catch (e) {}
                }
            };
            $.extend(true, ajaxOptions, this.model.ajaxSettings);
            this._sendAjaxRequest(ajaxOptions);
        },

        _setHiddenDialogSize: function () {
            if (!this._isOpen) {
                this._ejDialog.css({ "display": "block", "visibility": "hidden" });
                this._setContainerSize()._resetScroller();
                this._ejDialog.css({ "display": "none", "visibility": "" });
            }
        },

        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },

        _ajaxSuccessHandler: function (data, content, link, curTitle) {
            content.removeClass("e-load");
            content.html(data).addClass("e-dialog-loaded").appendTo(this._ejDialog);
            content.appendTo(this.contentDiv);
            this._dialogPosition();
            if (this.model.showOnInit)
                this.open();
            this._trigger("ajaxSuccess", { data: data, url: link });
        },

        _ajaxErrorHandler: function (data, content, link, curTitle) {
            content.addClass("e-dialog-loaded").appendTo(this.contentDiv);
            this._dialogPosition().open();
            this._trigger("ajaxError", { data: data, url: link });
        },
        _closeIcon: function () {
            this._dialogClose = ej.util.buildTag("div#" + this.element[0].id + "_closebutton.e-dialog-icon e-icon e-close",null,null).attr('tabIndex','0');            
            if(this.model.closeIconTooltip == "close" && this.model.tooltip.close == "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            else if(this.model.closeIconTooltip != "close" && this.model.tooltip.close == "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.closeIconTooltip);
            else if(this.model.closeIconTooltip == "close" && this.model.tooltip.close != "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            else   this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            this._on(this._dialogClose, "touchstart click", this._closeClick);
        },
		
        _collapsibleIcon: function () {            
            this._dialogCollapsible = ej.util.buildTag("div#" + this.element[0].id + "_collapsbutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0');             
            if (this._collapsible) {
                this._dialogCollapsible.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.expand).addClass("e-arrowhead-down").removeClass("e-arrowhead-up");
            }
            else {
                this._dialogCollapsible.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.collapse).addClass("e-arrowhead-up").removeClass("e-arrowhead-down");
            }
            this._on(this._dialogCollapsible, "touchstart click", this._collapsibleClick);
        },

        _maximizeIcon: function () {
            this._dialogMaximize = ej.util.buildTag("div#" + this.element[0].id + "_maximizebutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0'); 
            if (this._maximize) {
                this._dialogMaximize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.restore).addClass("e-restore").removeClass("e-maximize");
            }
            else {
                this._dialogMaximize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.maximize).addClass("e-maximize").removeClass("e-restore");
            }
            this._on(this._dialogMaximize, "touchstart click", this._maximizeClick);
        },

        _minimizeIcon: function () {
            this._dialogMinimize = ej.util.buildTag("div#" + this.element[0].id + "_minimizebutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0');           
            if (this._minimize) {
                this._dialogMinimize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.restore).addClass("e-restore").removeClass("e-minus");
            }
            else {
                this._dialogMinimize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.minimize).addClass("e-minus").removeClass("e-restore");
            }
            this._on(this._dialogMinimize, "touchstart click", this._minimizeClick);
        },

        _pinIcon: function () {
            this._dialogPin = ej.util.buildTag("div#" + this.element[0].id + "_pinbutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0'); 
            this._dialogPin.appendTo(this._dialogTitlebar).attr("title", this.dialogPin ? this.model.tooltip.unPin : this.model.tooltip.pin).addClass(this.dialogPin ? "e-pin" : "e-unpin").removeClass(this.dialogPin ? "e-unpin" : "e-pin");
            this._on(this._dialogPin, "touchstart click", this._pinClick);
        },

        _favIcon: function () {
            if (!this._dialogFavIcon) {
                this._dialogFavIcon = ej.util.buildTag("div.e-dialog-favicon", "", {}, { style: "float:"+ (this.model.enableRTL?"right":"left") });
                var span = ej.util.buildTag("span.e-dialog-custom", "", {}, { role: "presentation" });
                span.appendTo(this._dialogFavIcon);
                this._dialogFavIcon.appendTo(this._dialogTitlebar);
            }
            else 
                span = this._dialogFavIcon.find("span").removeClass().addClass("e-dialog-custom");
            if (!this.model.faviconCSS) this._dialogFavIcon.remove();
            else span.addClass(this.model.faviconCSS); this._dialogFavIcon.css("float", (this.model.enableRTL ? "right" : "left"));
        },

        _minMaxValidation: function () {
            var _minWidth = parseInt(this.model.minWidth), _minHeight = parseInt(this.model.minHeight), _maxWidth = parseInt(this.model.maxWidth), _maxHeight = parseInt(this.model.maxHeight),_width = parseInt(this.model.width), _height = parseInt(this.model.height), parentObj = this._getParentObj();
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                _minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), _minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                _minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), _minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                _maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), _maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                _maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), _maxHeight);
			if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
                _width = this._convertPercentageToPixel(parentObj.innerWidth(), _width);
            if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
                _height = this._convertPercentageToPixel(parentObj.innerHeight(), _height);
            if (_maxWidth && _width > _maxWidth || _minWidth && _width < _minWidth) {
                if (_width > _maxWidth) this.model.width = _maxWidth;
                else this.model.width = _minWidth;
            }
            if (_maxHeight && _height >_maxHeight || _minHeight && _height< _minHeight) {
                if (_height > _maxHeight) this.model.height = _maxHeight;
                else this.model.height = _minHeight;
            }
        },

        _setSize: function () {
            var mdl = this.model;
            this._minMaxValidation();
            this._ejDialog.css({ width: mdl.width, minWidth: mdl.minWidth, maxWidth: mdl.maxWidth });
            this._ejDialog.css({ height: mdl.height, minHeight: mdl.minHeight, maxHeight: mdl.maxHeight });
            this._dialogPosition();
            return this;
        },

        _resetScroller: function () {		
			this.element.css({ "height": "auto", "max-width": "", "max-height": "", "width": "" });
            var scrHeight = this._ejDialog.outerHeight(true) - ((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)-((this.model.showFooter)? $(this._ejDialog.find("div.e-footerbar")).outerHeight(true) : 0), eleHeight;
            var scrModel = { width: (this.contentDiv.css('border-width') == "0px" || this.contentDiv.css('border-left-width') == "0px") ? this._ejDialog.width() : Math.round(this._ejDialog.width() - 2), enableRTL: this.model.enableRTL, height: (this.contentDiv.css('border-width') == "0px") ? scrHeight : scrHeight - 1, enableTouchScroll: false }; // 2px border width
            if ((this.model.height == "auto") && (this.element.height() < this.model.maxHeight || !this.model.maxHeight) && !this._maximize)
                scrModel.height = "auto";
            if (this.model.width == "auto" && !this._maximize)
                scrModel.width = this.model.width;
            this.contentDiv.ejScroller(scrModel);
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
            this._padding = parseInt($(this.element).css("padding-top")) + parseInt($(this.element).css("padding-bottom"));
            if(($(this._ejDialog).css("display"))=="none"){
				  this.hidden=true;         
                  this._ejDialog.css({"display":"block"}); 
			}		
			if (!ej.isNullOrUndefined(this.contentDiv.height()) && this.contentDiv.height() > 0) {
                if (!ej.isNullOrUndefined(this.scroller))
                    if (!this.scroller._hScrollbar && this.scroller._vScrollbar)
                        eleHeight = this.contentDiv.outerHeight();
                    else if (this.scroller._hScrollbar)
                         eleHeight = this.contentDiv.outerHeight() - this.scroller.model.buttonSize;
                     else  eleHeight = this.contentDiv.outerHeight();
                 else
                    eleHeight = this.contentDiv.outerHeight() - this._padding;
                if ((this.model.height != "auto" && this.model.height != "100%"))
                    this.element.css({ "height": eleHeight-1 });
                else
                    this.element.css("height", this.model.height);
                if ((this.model.height == "auto" || this.model.height == "100%") && !this.scroller._vScrollbar)
                    this.element.css({ "min-height": this.model.minHeight -((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)});
                if (!this.scroller._vScrollbar && (this.model.width != "auto" && this.model.width != "100%"))
                    this.element.outerWidth((this.contentDiv.css('border-width') == "0px" || this.contentDiv.css('border-left-width') == "0px") ? this._ejDialog.width() : this._ejDialog.width() - 2);
                else if (!this.scroller._vScrollbar)
                    this.element.css("width", this.model.width);
                this.element.css({"max-width": this.model.maxWidth, "max-height": this.model.maxHeight });
            }
			if(this.hidden) this._ejDialog.css({"display":"none"});					
			this.hidden=false;
        },

        _updateScroller: function (height, width) {
            this.contentDiv.ejScroller({ width: width, height: height, enableRTL: this.model.enableRTL, enableTouchScroll: false });
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
			this._changeSize();
        },

        _dragDialog: function () {
            var proxy = this;
            var pos = this._ejDialog.parents(".e-dialog-scroller");
            this._dialogTitlebar.ejDraggable({
                handle: ".e-titlebar",
                cursorAt: { top: 0, left: 0 },
                dragArea: proxy._target,
                dragStart: function (event) {
					event.element.attr('aria-grabbed', true);
                    proxy._clickHandler();
                    if (proxy.dialogPin || !proxy.model.allowDraggable || !proxy.model.enabled) {
                        event.cancel = true;
                        return false;
                    }
                    if (proxy._trigger("dragStart", { event: event })) {
                        event.cancel = true;
                        return false;
                    }
                },
                drag: function (event) {
                    proxy._trigger("drag", { event: event });
                },
                dragStop: function (event) {
                    proxy._ejDialog.focus();
					event.element.attr('aria-grabbed', false);
                    if (proxy.element.find("> .e-draggable.e-titlebar")) {
                       var dragobject = $("#" + proxy.element.find("> .e-draggable.e-titlebar").attr("id")).data("ejDraggable");
                        if (dragobject)
                            dragobject.option("cursorAt", proxy.element.offset());
                    }
                    var pos = this.helper.offsetParent().offset();
                    proxy._trigger("dragStop", { event: event });
                    proxy.model.position.X = ej.isNullOrUndefined(this.position.left) ? parseInt(this.helper.css('left')) : this.position.left - [pos.left + parseFloat(this.helper.offsetParent().css('border-left-width'))];
                    proxy.model.position.Y = ej.isNullOrUndefined(this.position.top) ? parseInt(this.helper.css('top')) : this.position.top - [pos.top + parseFloat(this.helper.offsetParent().css('border-top-width'))];
					proxy._positionChanged=true;
                },
                helper: function (event) {
                    return $(proxy._ejDialog).addClass("dragClone");
                }
            });
            return this;
        },

        _resizeDialog: function () {
            if (!this.model.enableResize)  return;
            var proxy = this, started = false, parentObj;
            var _minWidth = parseInt(this.model.minWidth), _minHeight = parseInt(this.model.minHeight);
            var _maxWidth = parseInt(this.model.maxWidth), _maxHeight = parseInt(this.model.maxHeight);
            parentObj = this._getParentObj();
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                _minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), _minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                _minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), _minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                _maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), _maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                _maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), _maxHeight);
            this._ejDialog.find("div.e-resize-handle").ejResizable(
                {
                    minHeight: _minHeight,
                    minWidth: _minWidth,
                    maxHeight: _maxHeight,
                    maxWidth: _maxWidth,
                    handle: "e-widget-content",
                    resizeStart: function (event) {
                        proxy.dlgresized=true;
                        if (!proxy.model.enabled)
                            return false;
                        !started && proxy._trigger("resizeStart", { event: event });
                        started = true;
                        proxy.model.position = { X: proxy._ejDialog.css("left"), Y: proxy._ejDialog.css("top") };
                        proxy._dialogPosition();
                    },
                    resize: function (event) {
                        proxy.dlgresized=true;
                        var reElement = $(event.element).parents("div.e-dialog-wrap");
                        proxy.model.height = $(reElement).outerHeight();
                        proxy.model.width = $(reElement).outerWidth();
                        proxy._setSize();
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        proxy._updateCaptionWidth();
                        proxy._trigger("resize", { event: event });
                        proxy._sizeType = { width: "px", height: "px" };
                        if(this.scrObj) this.scrObj._resetScroller();                      
                    },
                    resizeStop: function (event) {
                        proxy.dlgresized=true;
                        proxy._ejDialog.focus();
                        proxy._sizeInPercent();
                        var reElement = $(event.element).parents("div.e-dialog-wrap");
                        proxy.model.height = $(reElement).outerHeight();
                        proxy.model.width = $(reElement).outerWidth();
                        proxy._setSize();
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        started && proxy._trigger("resizeStop", { event: event });
                        started = false;
                        proxy._setDimension();
                        proxy.dlgresized=false;
                    },
                    helper: function (event) {
                        return $(proxy._ejDialog);
                    }
                });
            return this;
        },

        _dialogPosition: function () {
            if (this._ejDialog.parents("form").length > 0 && ej.isNullOrUndefined(this.model.containment) && ej.isNullOrUndefined(this.model.target)) {
                this._ejDialog.appendTo(this._ejDialog.parents("form"));
            }
            if (this.model.position.X != "" || this.model.position.Y != "") {
                this._ejDialog.css("position", "absolute");
                if(ej.isNullOrUndefined(this.model.target) && ej.isNullOrUndefined(this.model.containment)) {
                this._ejDialog.css("left", this.model.position.X);
                this._ejDialog.css("top", this.model.position.Y);
				}
				else {
					  var containerEle=ej.isNullOrUndefined(this.model.containment)?this.model.target:this.model.containment;
					  if (this.dlgresized || this._keyNavigation){
                         this._ejDialog.css("left", this.model.position.X);
                         this._ejDialog.css("top", this.model.position.Y);                   
                                    }
                      else{
                      this._ejDialog.css("left", $(containerEle).offset()["left"]+ parseInt(this.model.position.X));
					  this._ejDialog.css("top", $(containerEle).offset()["top"]+ parseInt(this.model.position.Y));
				}
            }
            }
            else {
                this._centerPosition();
            }
            return this;
        },
        _centerPosition:function(){
            var x = 0, y = 0;
            if (!ej.isNullOrUndefined(this.model.target) ||!ej.isNullOrUndefined(this._target) && !$(this._target).is($(document)) && !($(this._target).is($(window)))) {
                var $content = !ej.isNullOrUndefined(this._target) ? $(this._target) : $(this.model.target);
                if ($content.css("position") == 'static') {
                    var parentOffset = $content.offsetParent().offset();
                    var contentOffset = $content.offset();
                    x = contentOffset.left - parentOffset.left;
                    y = contentOffset.top - parentOffset.top;
                }
                if ($content.outerWidth() > this._ejDialog.width()) x += ($content.outerWidth() - this._ejDialog.width()) / 2;
                if ($content.outerHeight() > this._ejDialog.height()) y += ($content.outerHeight() - this._ejDialog.height()) / 2;
            }
            else {
                var doc = document.documentElement;
                x = (($(window).outerWidth() > this._ejDialog.width()) ? ($(window).outerWidth() - this._ejDialog.outerWidth()) / 2 : 0) + (window.pageXOffset || doc.scrollLeft);
                y = (($(window).outerHeight() > this._ejDialog.height()) ? ($(window).outerHeight() - this._ejDialog.outerHeight()) / 2 : 0) + (window.pageYOffset || doc.scrollTop);
            }
            this._ejDialog.css({ top: y, left: x });
            this._ejDialog.css("position", "absolute");
        },
        _closeClick: function (event) {
            if (this.model.enabled) {
                event.stopPropagation();
                this.close(event);
            }
        },

        _collapsibleClick: function (e) {
            if (this.model.enabled) {
                if ($(e.target).hasClass("e-arrowhead-up")) {
                    this._actionCollapse(e);
                }
                else if ($(e.target).hasClass("e-arrowhead-down")) {
                    this._actionExpand(e);
                }
            }
        },
        _actionCollapse: function (e) {
            if (!this._minimize) {
                this._dialogCollapsible&& this._dialogCollapsible.removeClass("e-arrowhead-up").addClass("e-arrowhead-down");
                this._dialogCollapsible && this._dialogCollapsible.attr("title", this.model.tooltip.expand);
                this._ejDialog.find("div.e-resize-handle").hide();
                this._ejDialog.find(".e-widget-content").parent().slideUp("fast");
                if(this.model.showFooter)  this._dialogFooterbar.slideUp("fast");
                this._ejDialog.removeClass("e-shadow");
                this._ejDialog.css("minHeight", "0");
                this._ejDialog.height("auto");
                this._trigger("collapse",{isInteraction :(e ? true : false )});
                this._collapsible = true;
            }
        },
        _actionExpand: function (e) {
            if (!this._minimize) {
                this._dialogCollapsible&& this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                this._dialogCollapsible && this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                this._ejDialog.addClass("e-shadow");
                this._ejDialog.find(".e-widget-content").parent().slideDown("fast");
                if (this.model.showFooter) this._dialogFooterbar.slideDown("fast");
                if (this._maximize) {
                    this._ejDialog.css({ width: "100%", height: "100%" });
                    this.element.css({ width: "100%", height: "100%" });
                    this.contentDiv.css({ width: "100%", height: "100%" });
                }
                else this._ejDialog.height(this.model.height);
                this._ejDialog.find("div.e-resize-handle").show();
                this._trigger("expand",{isInteraction :(e ? true : false )});
                this._collapsible = false;
            }
        },

        _maximizeClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                var hideIcon = this._dialogMaximize;
                if (_target.hasClass("e-maximize")) {
                    this._actionMaximize();
                    if (this._dialogTitlebar){
                        this._dialogTitlebar.find('.e-restore').removeClass('e-restore').addClass('e-minus');
                        this._dialogMinimize && this._dialogMinimize.attr('title', this.model.tooltip.minimize);
                    }
                    _target.removeClass("e-maximize").addClass("e-restore");
                    this._dialogMaximize.attr('title', this.model.tooltip.restore);
                    this._hideIcon(true);
                }
                else if (_target.hasClass("e-restore")) {
                    this._actionRestore();
                    _target.removeClass("e-restore").addClass("e-maximize");
                    this._dialogMaximize.attr('title', this.model.tooltip.maximize);
                    if (!ej.isNullOrUndefined(hideIcon) && $(hideIcon).hasClass('e-arrowhead-down')){
                        $(hideIcon).removeClass('e-arrowhead-down').addClass('e-arrowhead-up');
                        this._dialogMaximize.attr('title', this.model.tooltip.collapse);
                    }
                    this._hideIcon(true);
                }
            }
			this._resetScroller();
        },
        _actionMaximize: function () {
            this._ejDialog.css("top", "0px").css("left", "0px").css("overflow", "hidden").css("position", (this.model.containment ? "absolute" : this.model.target ? "absolute" : "fixed"));
            this._ejDialog.css({ width: "100%", height: "100%" });
            this.element.css({ width: "100%", height: "100%" });
            this.contentDiv.css({ width: "100%", height: "100%" });
            this._maximize = true;
            this._minimize = false;
            var proxy=this;
            if (this._dialogCollapsible && !ej.isNullOrUndefined(this._dialogCollapsible.hasClass("e-arrowhead-down"))) {
                this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                this._dialogCollapsible.attr('title', this.model.tooltip.collapse);
                this._collapseValue = true
            }
            if(this._collapseValue == true) {
                this._ejDialog.find(".e-widget-content").parent().slideDown("fast",function(){
					proxy.refresh();
                    proxy._reRenderScroller();
                });
            }
            this._resetScroller();
        },
        _actionRestore: function () {
            this.element.height("").width("");
            this.contentDiv.height("").width("");
            this._restoreDialog();
            this._maximize = this._minimize = false;
        },

        _minimizeClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                var hideIcon = this._dialogMinimize.hasClass("e-icon")&& this._dialogMinimize;
                if (_target.hasClass("e-minus")) {
                    if (this._maximize)
                        this._setSize();
                    this._actionMinimize();
                } else if (_target.hasClass("e-restore")) {
                    this._actionRestore();
                    _target.removeClass("e-restore").addClass("e-minus");
                    this._dialogMinimize.attr('title', this.model.tooltip.minimize);
                    if (!ej.isNullOrUndefined(hideIcon) && $(hideIcon).hasClass('e-arrowhead-down')){
                        $(hideIcon).removeClass('e-arrowhead-down').addClass('e-arrowhead-up');
                        this._dialogMinimize.attr('title', this.model.tooltip.collapse);
                    }
                    this._hideIcon(true);
                }
            }
        },

        _actionMinimize: function () {
            var top = ($(window).height() - this._ejDialog.height()) + this.element.height() + 14, _height;
            this._ejDialog.css("top", "").css("bottom", "0").css("left", "0").css("position", (this.model.containment ? "absolute" : this.model.target ? "absolute" : "fixed"));
            this._ejDialog.css("minHeight", "0");
            if (this._dialogTitlebar) {
                this._dialogTitlebar.find('.e-restore').removeClass('e-restore').addClass('e-maximize');
                this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.maximize);
                this._dialogTitlebar.find(".e-minus").removeClass("e-minus").addClass("e-restore");
                this._dialogMinimize && this._dialogMinimize.attr('title', this.model.tooltip.restore);
                if (this._isOpen)
                    _height = this._dialogTitlebar.outerHeight();
                else {
                    this._ejDialog.css({ "display": "block", "visibility": "hidden" });
                    _height = this._dialogTitlebar.outerHeight();
                    this._ejDialog.css({ "display": "none", "visibility": "" });
                }
                this._ejDialog.css("height", _height + 2); // 1px bordertop + 1px borderbottom of the dialog wrapper is added
                this._hideIcon(false);
            } else this._ejDialog.css("height", "");
            this.contentDiv.hide();
			if(this.model.showFooter) this._dialogFooterbar.hide();
            this._maximize = false;
            this._minimize = true;
        },

        _hideIcon: function (value) {
            var hideIcon = this._dialogCollapsible ? this._dialogCollapsible : null;
            if (value) {
                if (!ej.isNullOrUndefined(hideIcon)) $(hideIcon).parent('.e-dialog-icon').show();
                this._ejDialog.find("div.e-resize-handle").show();
            } else {
                if (!ej.isNullOrUndefined(hideIcon)) $(hideIcon).parent('.e-dialog-icon').hide();
                this._ejDialog.find("div.e-resize-handle").hide();
            }
        },

        _pinClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                if (_target.hasClass("e-unpin")) {
                    this.dialogPin = true;
                    _target.removeClass("e-unpin").addClass("e-pin");
                    this._dialogPin.attr('title', this.model.tooltip.unPin);
                }
                else if (_target.hasClass("e-pin")) {
                    this.dialogPin = false;
                    _target.removeClass("e-pin").addClass("e-unpin");
                    this._dialogPin.attr('title', this.model.tooltip.pin);
                }
            }
        },

        _restoreDialog: function () {
            this.contentDiv.show();
			if(this.model.showFooter) this._dialogFooterbar.show();
            this._ejDialog.css({"position": "absolute", "bottom": ""}).addClass("e-shadow");
            this._setSize()._resetScroller();
            if (this._dialogTitlebar) {
                this._dialogTitlebar.find(".e-minus").parent().show();
                if (this._dialogCollapsible) {
                    this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                    this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                }
            }
        },

        _clickHandler: function (e) {
            var zindex = this._dialogMaxZindex();
            if (parseInt(this._ejDialog.css("zIndex")) < zindex) 
                this._ejDialog.css({ zIndex: zindex + 1 });            
        },

        _mouseClick: function (e) {
			if(e.currentTarget==this._id)
				if ($(e.target).hasClass("e-dialog") || $(e.target).hasClass("e-icon e-resize-handle")) {
					this._setZindex();
					$(e.target).closest(".e-dialog.e-widget").focus();
				}
        },

        _keyDown: function (e) {
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            if (this.model.allowKeyboardNavigation && this.model.enabled && $(e.target).hasClass("e-dialog"))
                if ($.inArray(code, this.keyConfigs) > -1 && this.model.allowDraggable && !this.dialogPin) {
                    this._keyPressed(code, e.ctrlKey);
                    e.preventDefault();
                }            
            if (this.model.closeOnEscape && code === 27 && this.model.enabled) 
                if (!this.element.find(".e-js.e-dialog").first().is(":visible")) {
                    this.close(e);
                    e.preventDefault();
                }
            if (code===13 && this.model.enabled){
                if($(e.target).hasClass("e-close")) this.close(e);
                else if ($(e.target).hasClass("e-arrowhead-up") || $(e.target).hasClass("e-arrowhead-down")) this._collapsibleClick(e);                
                if ($(e.target).hasClass("e-maximize") || ($(e.target).hasClass("e-restore") && $(e.target).is(this._dialogMaximize)))
				    this._maximizeClick(e);
                else if ($(e.target).hasClass("e-minus") || ($(e.target).hasClass("e-restore") && $(e.target).is(this._dialogMinimize)))
				    this._minimizeClick(e);
				if ($(e.target).hasClass("e-pin") || $(e.target).hasClass("e-unpin")){
				    this._pinClick(e);
					}
            }
            if (code == 9 && this.model.enableModal)
                this._focusOnTab(e);
        },

        _focusOnTab: function (e) {
            var focusEle = this._ejDialog.find("a, button, :input, select, [tabindex]:not('-1')");
            focusEle = $(focusEle).find("a, button, :input, select, [tabindex]:not('')");
            if (e.shiftKey) {
                if (!focusEle[focusEle.index(e.target) - 1]) {
                    e.preventDefault();
                    focusEle.last().focus();
                }
            }
            else if (!focusEle[focusEle.index(e.target) + 1]) {
                e.preventDefault();
                focusEle[0].focus();
            }
        },

        _keyPressed: function (code, ctrlKey) {
            this._keyNavigation=true;
            switch (code) {
                case 40:
                    ctrlKey ?  this._resizing("height", (this._ejDialog.outerHeight() + 3)) : this.option("position", { X: this._ejDialog.position().left, Y: (this._ejDialog.position().top + 3) });
                    break;
                case 39:
                    ctrlKey ? this._resizing("width", (this._ejDialog.outerWidth() + 3)) : this.option("position", { X: (this._ejDialog.position().left + 3), Y: this._ejDialog.position().top });
                    break;
                case 38:
                    ctrlKey ? this._resizing("height", (this._ejDialog.outerHeight() - 3)) : this.option("position", { 
						X: (this._ejDialog.position().left == 0 ? 0 : this._ejDialog.position().left),
						Y: (this._ejDialog.position().top > 3 ? this._ejDialog.position().top - 3 : 0) 
					});
                    break;
                case 37:
                    ctrlKey ? this._resizing("width", (this._ejDialog.outerWidth() - 3)) : this.option("position", { 
						X: (this._ejDialog.position().left > 3 ? this._ejDialog.position().left - 3 : 0), 
						Y: (this._ejDialog.position().top == 0 ? 0 : this._ejDialog.position().top)
					});
                    break;
            }
        },

        _resizing:function(key, value){
            if (this.model.enableResize) this.option(key, value);
        },

        _sizeInPercent: function () {
            if (!this._enableWindowResize()) return this;
            var parentObj = this._getParentObj();
            if (this._sizeType.width == "%") this._widthPercent = parseFloat(this.model.width);
            else this._widthPercent = this._convertPixelToPercentage(parentObj.outerWidth(), this._ejDialog.outerWidth());
            if (this._sizeType.height == "%") this._heightPercent = parseFloat(this.model.height);
            else this._heightPercent = this._convertPixelToPercentage(parentObj.outerHeight(), this._ejDialog.outerHeight());
            if (this._widthPercent >= 100) {
                this._widthPercent = 100;
                this._ejDialog.outerWidth(parentObj.outerWidth());
                this.model.width = this._ejDialog.width();
            }
            if (this._heightPercent >= 100) {
                this._heightPercent = 100;
                this._ejDialog.outerHeight(parentObj.outerHeight());
                this.model.height = this._ejDialog.height();
            }
            return this;
        },

        _getParentObj: function () {
            return (!ej.isNullOrUndefined(this.model.containment) ? $(this.model.containment) : !ej.isNullOrUndefined(this.model.target) ? $(this.model.target) : $(document));
        },

        _convertPercentageToPixel: function (parent, child) {
            return Math.round((child * parent) / 100);
        },

        _convertPixelToPercentage: function (parent, child) {
            return Math.round((child / parent) * 100);
        },

        _reSizeHandler: function () {
            var parentObj;
            if (this._maximize) { this._resetScroller(); return; }
            if (this.model.position.X == "" || this.model.position.Y == "" && !this._minimize) this._centerPosition();
            parentObj = this._getParentObj();
            this._change = false;
            if (this._windowSize.outerWidth != $(window).outerWidth()) {
                if (this._sizeType.width == "%") this._percentageWidthDimension(parentObj);
                else this._pixelsWidthDimension(parentObj);
            }
            else if (this._windowSize.outerHeight != $(window).outerHeight()) {
                if (this._sizeType.height == "%") this._percentageHeightDimension(parentObj);
                else this._pixelsHeightDimension(parentObj);
            }
            this._change && this._resizeContainer(parentObj);
            this._windowSize = { outerWidth: $(window).outerWidth(), outerHeight: $(window).outerHeight() };
			this._centerPosition();
        },
        _setDimension:function(){
            if (ej.isNullOrUndefined(this.model.maxWidth)) {
                if (ej.isNullOrUndefined(this._sizeType.width)) this._maxWidth = +this.model.width;
                else if (this._sizeType.width == "px" || this._sizeType.width == "auto") this._maxWidth = this.model.width;
            } else this._maxWidth = this.model.maxWidth;
            if (ej.isNullOrUndefined(this.model.maxHeight)) {
                if (ej.isNullOrUndefined(this._sizeType.height)) this._maxHeight = +this.model.height;
                else if (this._sizeType.height == "px" || this._sizeType.height == "auto") this._maxHeight = this.model.height;
            } else this._maxHeight = this.model.maxHeight;
        },
        _percentageWidthDimension: function (parentObj) {
            this._ejDialog.outerWidth(this._convertPercentageToPixel(parentObj.outerWidth(), this._widthPercent));
            this._change = true;
        },
        _percentageHeightDimension: function (parentObj) {
            this._ejDialog.outerHeight(this._convertPercentageToPixel(parentObj.outerHeight(), this._heightPercent));
            this._change = true;
        },
        _pixelsWidthDimension: function (parentObj) {
            if ($(parentObj).outerWidth() <= this._ejDialog.outerWidth()) this._setWidth(parentObj);
            if (($(parentObj).outerHeight() <= this._ejDialog.outerHeight()) && !this.model.isResponsive) this._setHeight(parentObj);
            if (parseInt(this._ejDialog.css("width")) < parseInt(this._maxWidth)) {
                if (parseInt(this._maxWidth) < $(parentObj).outerWidth()) this._ejDialog.outerWidth((parseInt(this._maxWidth)));
                else this._ejDialog.outerWidth((parentObj.outerWidth()));
                this._change = true;
            }
        },
        _pixelsHeightDimension: function (parentObj) {
            if (($(parentObj).outerHeight() <= this._ejDialog.outerHeight()) && !this.model.isResponsive) this._setHeight(parentObj);
            if ($(parentObj).outerWidth() <= this._ejDialog.outerWidth()) this._setWidth(parentObj);
            if (parseInt(this._ejDialog.css("height")) < parseInt(this._maxHeight)) {
                if (parseInt(this._maxHeight) < $(parentObj).outerHeight()) this._ejDialog.outerWidth((parseInt(this._maxHeight)));
                else this._ejDialog.outerHeight((parentObj.outerHeight()));
                this._change = true;
            }
        },
        _setWidth: function (parentObj) {
            this._ejDialog.outerWidth((parentObj.outerWidth()));
            this._change = true;
        },
        _setHeight: function (parentObj) {
            this._ejDialog.outerHeight((parentObj.outerHeight()));
            this._change = true;
        },
        _resizeContainer: function (parentObj) {
            this.contentDiv.width(this._ejDialog.width());
            this.element.outerWidth(this.contentDiv.width());
            var contentDivheight = this._ejDialog.height() - ((this.model.showHeader) ? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0);
            this.contentDiv.height((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? contentDivheight : contentDivheight - 1);
            this.element.outerHeight((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? contentDivheight : contentDivheight - 1);
            this.scroller = this.contentDiv.ejScroller({ width: (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2, height: (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this.element.outerHeight() : this.element.outerHeight() - 2, rtl: this.model.rtl, enableTouchScroll: false });
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
            if ((this.model.position.X == "" || this.model.position.Y == "" && !this._minimize)||(this._positionChanged)) this._centerPosition();
            else this._ejDialog.css("height", this._dialogTitlebar.outerHeight());
            this._updateCaptionWidth();
            this._change = false;
        },
        _getLocalizedLabels:function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }, 

        _enableWindowResize: function () {
            return (this.model.isResponsive || ((isNaN(this.model.width) && (this.model.width.indexOf("%") > 0)) && (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0) && (this.model.height != "auto")))) ? true : false;
        },

        _wireResizing: function () {             
            $(window)[(this._enableWindowResize() ? "on" : "off")]('resize', $.proxy(this._reSizeHandler, this));                        
        },

        _wireEvents: function () {
            this._on(this._ejDialog, "keydown", this._keyDown);
            this._on(this._ejDialog, "click", this._mouseClick);
            this._wireResizing();
        },

        refresh: function () {
            this._resetScroller();
        },

        open: function () {
            if (this._isOpen) return true;            
            if (true == this._trigger("beforeOpen")) return false;
            this.element.css("display", "block");
            this._setZindex();
            if (!this._minimize && !this._maximize && !this._init) this._dialogPosition();
            var proxy = this, effect = {}, height;
            this._ejDialog.show();
            if (this.model.enableAnimation) {
                this._ejDialog.css({ "opacity": 0});
                if (this.model.animation.show.effect == "slide") {
                    var eLeft = this._ejDialog.css("left");
                    this._ejDialog.css({ "left": -this._ejDialog.width() });
                    effect = { left: eLeft, opacity: 1 };
                }
                else {
                    effect = { opacity: 1 };
                }
            }
            this._ejDialog.animate(effect, (this.model.enableAnimation ? Number(this.model.animation.show.duration) : 0), function () {
                if (proxy.model) {
					  if (proxy._ejDialog.css("display") == "none") proxy._ejDialog.show();
                    proxy._ejDialog.eq(0).focus();
                    proxy._ejDialog.css({ "opacity": "" });
                    proxy.contentDiv.find("a:visible:enabled, button:visible:enabled, :input:visible:enabled, select:visible:enabled, .e-input").first().focus();
                    proxy._trigger("open");
                    proxy._updateCaptionWidth();
					if(proxy.model.enableModal && !proxy.model.backgroundScroll)
					{
						if( proxy._ejDialog.height() > $(window).height()) proxy._ejDialog.css("height",$(window).height());
						proxy.model.height=$(window).height(); proxy._overLay.css("position","fixed");
						proxy.scroller.refresh(true); proxy.refresh();
					}
                    if (proxy.model.maxHeight || proxy.model.maxWidth)
                    {
                        height = proxy._ejDialog.outerHeight(true) - ((proxy._dialogTitlebar ? proxy._dialogTitlebar.outerHeight(true) : 0));
                        if ((proxy.model.height == "auto" || proxy.model.height == "100%"))
                            height = proxy.model.height;
                        proxy._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? height : height - 2, (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? proxy._ejDialog.width() : proxy._ejDialog.width() - 2);
                    }
                }
            });
            if (this.model.enableModal == true) this._createOverlay();
            this._isOpen = true;
            if (this.element.find("> .e-draggable.e-titlebar")) {
               var dragobject = $("#" + this.element.find("> .e-draggable.e-titlebar").attr("id")).data("ejDraggable");
                if (dragobject)
                    dragobject.option("cursorAt", this.element.offset());
            }
            return this;
        },

        close: function (event) {
            if (!this._isOpen || !this.model.enabled) return true;
            var isInteraction= event ? true : false;            
            if (true == this._trigger("beforeClose", { event: event,isInteraction:isInteraction })) return false;
            this._isOpen = false;
            var proxy = this, effect = {};
            if (this.model.enableAnimation) 
            effect = this.model.animation.hide.effect == "slide" ? { left: -this._ejDialog.width(), opacity: 0 } : { opacity: 0 };
            this._ejDialog.animate(effect, (this.model.enableAnimation ? Number(this.model.animation.hide.duration) : 0), function () {
                proxy._trigger("close", { event: event, isInteraction:isInteraction });
                proxy._ejDialog.hide();
            });
            if (this.model.enableModal){
                if (this._overLay) this._overLay.remove();
                if (!this.model.backgroundScroll) $("body").removeClass("e-dialog-modal");
            }
            return this;
        },

        isOpened: function () { return this.isOpen() },
        isOpen: function () { return this._isOpen; },

        setTitle: function (titleText) {
            this.model.title = titleText;
            this._titleText.text(titleText);
            this._updateCaptionWidth();
            return this;
        },

        setContent: function (htmlContent) {
            if (!this.model.enabled) return false;
            this.element.html(htmlContent);
            this._resetScroller();
            return this;
        },      

        focus: function () {
            this._setZindex();
            this.element.focus();
            return this;
        },

        minimize: function () {
			if(this.model.showHeader){
            this._actionMinimize();
            $(this.wrapper.find(".e-minus")[0]).parent().hide();
            return this;
			}
        },

        maximize: function () {
			if(this.model.showHeader){
            this._actionMaximize();
            $(this.wrapper.find(".e-maximize")[0]).removeClass("e-maximize").addClass("e-restore");
            $(this.wrapper.find(".e-restore")[1]).removeClass("e-restore").addClass("e-minus");
            this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.restore);
            this.contentDiv.show();
            this._dialogTitlebar && this._dialogTitlebar.find(".e-minus").parent().show();
            this._hideIcon(true);
            return this;
			}
        },

        restore: function () {
			if(this.model.showHeader){
            var action = this._minimize;
            this._actionRestore();
            $(this.wrapper.find(".e-restore")[0]).removeClass("e-restore").addClass(action ? "e-minus" : "e-maximize");
            this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.maximize);
            this._hideIcon(true);
            return this;
			}
        },

        pin: function () {
			if(this.model.showHeader){
            this.dialogPin = true;
            $(this.wrapper.find(".e-unpin")[0]).removeClass("e-unpin").addClass("e-pin");
            this._dialogPin && this._dialogPin.attr('title', this.model.tooltip.unPin);
            return this;
			}
        },

        unpin: function () {
            if(this.model.showHeader){
			this.dialogPin = false;
            $(this.wrapper.find(".e-pin")[0]).removeClass("e-pin").addClass("e-unpin");
            this._dialogPin && this._dialogPin.attr('title', this.model.tooltip.pin);
            return this;
			}
        },

        collapse: function () {
			if(this.model.showHeader){
            this._actionCollapse();
            this._collapseValue=true;
            return this;
			}
        },

        expand: function () {
			if(this.model.showHeader){
            this._actionExpand();
            return this;
			}
        }
    });
    
ej.Dialog.Locale = ej.Dialog.Locale || {} ;
    
ej.Dialog.Locale["default"] = ej.Dialog.Locale["en-US"] = {
    tooltip:{
                close: "Close",
                collapse: "Collapse",
                restore: "Restore",
                maximize: "Maximize",
                minimize: "Minimize",
                expand: "Expand",
                unPin: "UnPin",
                pin: "Pin"
            },
    title:"",
     //currently we have deprecated this API
    closeIconTooltip: "close"
};

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDropDownList", "ej.DropDownList", {
        element: null,

        model: null,
        validTags: ["select", "input"],
        _addToPersist: ["value", "text", "selectedIndex", "selectedItemIndex", "selectedItems", "selectedIndices", "popupWidth", "popupHeight", "itemValue"],
        _setFirst: false,

        _rootCSS: "e-dropdownlist",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },
        _requiresID: true,
      


        defaults: {
            cssClass: "",

            value: null,

            htmlAttributes: {},

            text: null,

            itemValue: "",

            itemsCount: 0,

            dataSource: null,

            delimiterChar: ',',

            query: null,

            fields: {
                id: null,

                text: null,

                value: null,

                category: null,
                
                groupBy:null,

                imageUrl: null,

                imageAttributes: null,

                spriteCssClass: null,

                htmlAttributes: null,

                selected: null,

                tableName: null
            },
			
			locale: "en-US",

            watermarkText: null,

            height: "",

            width: "",

            popupHeight: "152px",

            popupWidth: "auto",

            maxPopupHeight: null,

            minPopupHeight: '20',

            maxPopupWidth: null,

            minPopupWidth: '0',

            targetID: null,

            template: null,

            headerTemplate: null,

            selectedItemIndex: -1,

            selectedIndex: -1,

            disableItemsByIndex: null,

            enableItemsByIndex: null,

            selectedItems: [],

            selectedIndices: [],

            cascadeTo: null,

            enablePopupResize: false,

            allowVirtualScrolling: false,

            virtualScrollMode: "normal",

            showRoundedCorner: false,

            showPopupOnLoad: false,

            enableRTL: false,

            enabled: true,

            filterType: "contains",

            sortOrder: "ascending",

            caseSensitiveSearch: false,

            showCheckbox: false,

            checkAll: false,

            uncheckAll: false,

            enablePersistence: false,

            enableFilterSearch: false,

            enableIncrementalSearch: true,

            readOnly: false,

            enableAnimation: false,

            multiSelectMode: "none",

            allowGrouping: false,

            enableSorting: false,

            validationRules: null,

            validationMessage: null,

            actionBegin: null,

            actionComplete: null,

            actionFailure: null,

            actionSuccess: null,

            create: null,

            popupHide: null,

            popupShown: null,

            beforePopupShown: null,

            beforePopupHide: null,

            popupResizeStart: null,

            popupResize: null,

            popupResizeStop: null,

            change: null,

            select: null,

            dataBound: null,

            search: null,

            checkChange: null,

            cascade: null,

            destroy: null

        },

        dataTypes: {
            cssClass: "string",
            itemsCount: "number",
            watermarkText: "string",
            template: "string",
            disableItemsByIndex: "string",
            enableItemsByIndex: "string",
            enableIncrementalSearch: "boolean",
            cascadeTo: "string",
            delimiterChar: "string",
            showRoundedCorner: "boolean",
            showPopupOnLoad: "boolean",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            allowVirtualScrolling: "boolean",
            virtualScrollMode: "enum",
            enabled: "boolean",
            readOnly: "boolean",
            multiSelectMode: "enum",
            dataSource: "data",
            query: "data",
            fields: "data",
            selectedItems: "array",
            enableAnimation: "boolean",
            allowGrouping: "boolean",
            enableSorting: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
			locale:"string"
        },

        observables: ["value", "selectedItemIndex", "selectedIndex"],
        value: ej.util.valueFunction("value"),
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        selectedIndex: ej.util.valueFunction("selectedIndex"),
        

        enable: function () {
            if (this._visibleInput.hasClass("e-disable")) {
                this.target.disabled = false;
                this.model.enabled = true;
				this.container.removeClass('e-disable');
                this._visibleInput.removeClass('e-disable');
                this.dropdownbutton.removeClass('e-disable');
                this.popupListWrapper.removeClass('e-disable');
                if (this._isIE8) this.drpbtnspan.removeClass("e-disable");
                //Element not Maintain in Multiselection
                this.container.on("mousedown", $.proxy(this._OnDropdownClick, this));
                if (this.model.multiSelectMode == "visualmode") this._ulBox.removeClass("e-disable");
                this.wrapper.attr('tabindex', '0');
            }
            this._wireEvents();
        },

        disable: function () {
            if (!this._visibleInput.hasClass("e-disable")) {
                this.target.disabled = true;
                this.model.enabled = false;
				this.container.addClass('e-disable');
                this._visibleInput.addClass('e-disable');
                this.popupListWrapper.addClass('e-disable');
                this.dropdownbutton.addClass('e-disable');
                if (this._isIE8) this.drpbtnspan.addClass("e-disable");
                if (this.model.multiSelectMode == "visualmode") this._ulBox.addClass("e-disable");
                //Element not Maintain in Multiselection
                this.container.off("mousedown", $.proxy(this._OnDropdownClick, this));
                this._unwireEvents();
                this.wrapper.removeAttr('tabindex');
                if (this._isPopupShown()) this._hideResult();
            }
        },

        /* will deprecate with text property */
        getValue: function () {
			return this._visibleInput.val();
        },
        _setValue: function (value) {
            if (!ej.isNullOrUndefined(value)) {
                this._raiseEvents = false;
                if (!ej.isNullOrUndefined(this.model.text)) this.unselectItemByText(this.model.text);
                this._raiseEvents = true;
                this.selectItemByValue(value);
            }
        },
        _setText: function (text) {
            if (text) {
                this._raiseEvents = false;
                this.unselectItemByText(this.model.text);
                this._raiseEvents = true;
                this.selectItemByText(text);
            }
        },
        _setItemValue: function (itemValue) {
            this.model.itemValue = itemValue;
        },
        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            if (this._isWatermark) this._visibleInput.attr("placeholder", text);
            else this._hiddenSpan.text(text);
        },

        hidePopup: function () {
            if (!this.model.enabled) return false;
            if (this.ultag.find('li').length > 0)
                this._hideResult();
        },

        showPopup: function () {
            if (!this.model.enabled) return false;
            if (this.ultag.find('li').length > 0)
                this._showResult();
        },

        clearText: function () {
            this._clearTextboxValue(); 
            if (!this._isWatermark)
                this._setWatermark();
        },

        addItem: function (itemTag) {
            if (!this.model.enabled || !itemTag) return false;
            this._mapFields();
            var list = $.isArray(itemTag) ? itemTag : [itemTag];
            if (list.length < 1) return false;
            var mapper = this.mapFld,
                mapFld = { _id: null, _imageUrl: null, _imageAttributes: null, _spriteCSS: null, _text: null, _value: null, _htmlAttributes: null, _selected: null, _category: null };
            mapFld._id = list[0][mapper._id] ? mapper._id : "id";
            mapFld._imageUrl = list[0][mapper._imageUrl] ? mapper._imageUrl : "imageUrl";
            mapFld._imageAttributes = list[0][mapper._imageAttributes] ? mapper._imageAttributes : "imageAttributes";
            mapFld._spriteCSS = list[0][mapper._spriteCSS] ? mapper._spriteCSS : "spriteCssClass";
            mapFld._text = list[0][mapper._text] ? mapper._text : "text";
            mapFld._value = list[0][mapper._value] ? mapper._value : "value";
            mapFld._htmlAttributes = list[0][mapper._htmlAttributes] ? mapper._htmlAttributes : "htmlAttributes";
            mapFld._selected = list[0][mapper._selected] ? mapper._selected : "selected";
            mapFld._category = list[0][mapper._category] ? mapper._category : "groupBy";
            this._generateLi(list, mapFld);
            
            var i, listItems = this.dummyUl;
            for (var i = 0; i < list.length; i++)
                this._listItem(list[i], "add");
            if (this.model.showCheckbox) {
                this._appendCheckbox(listItems, true);               
            }
            else if (!this._isSingleSelect()) this._multiItemSelection(listItems, true);
			this._virtualUl.append($(this.dummyUl).clone(true));
            this.ultag.append(this.dummyUl);

            if (this._isPopupShown()) {
                var scrollerPosition = this.scrollerObj ? this.scrollerObj.scrollTop() : 0;
                this._refreshScroller();
                if (this.scrollerObj) this.scrollerObj.option("scrollTop", scrollerPosition);
            }
        },

        _toArray: function (index, mode) {
            var items;
            if (typeof index == "function") index = ej.util.getVal(index);
            if ($.isArray(index)) items = index;
            else if (typeof index == "string") {
                if ((mode && (this.model.multiSelectMode == "visualmode" || this.model.multiSelectMode == "delimiter" || this.model.showCheckbox))) {
                    items = index.split(this.model.delimiterChar);
                    if (items.length == 0) items = [index];
                }
                else if (!mode) {
                    items = index.split(this.model.delimiterChar);
                    if (items.length == 0) items = [index];
                }
                else items = [index];
            } else items = [index];
            return items;
        },
        _trim: function (val) {
            return typeof val == "string" ? $.trim(val) : val;
        },
        /*will deprecate with selectItemsByIndices */
        selectItemByIndex: function (index) {
            this._selectItemByIndex(index);
        },

        selectItemsByIndices: function (index) {
            this._selectItemByIndex(index);
        },

        _selectItemByIndex: function (val) {
            this.listitems = this._getLi();
            this._selectedIndices = $.map(this._selectedIndices, function (a) { return parseInt(a); });
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
			if( parseInt(val) == -1 && this.model.selectedItems.length > 0) {
				this._clearTextboxValue();
				this._trigger("change",{ text: this._visibleInput[0].value, selectedText: "", selectedValue: "", value: "" });
			}
			else {
            var items = this._toArray(val, true), index;
            for (var k = 0; k < items.length; k++) {
                index = parseInt(items[k]);
                if (index != null && index >= 0) {
                    if ($.inArray(index, this._selectedIndices) == -1)
                        for (var i = 0; i < this.listitems.length; i++) {
                            if (!$(this.listitems[i]).hasClass('e-disable')) {
                                if (i == index) {
                                    this.selectedIndexValue = i;
                                    this._activeItem = index;
                                    this._enterTextBoxValue();
                                }
                            }
                        }
                } else if (!this.model.showCheckbox && this.model.multiSelectMode == "none" && this.model.selectedItems.length > 0) {
					this._clearTextboxValue();
				   this._trigger("change",{ text: this._visibleInput[0].value, selectedText: "", selectedValue: "", value: "" });
				} 
            }
			}
        },

        unselectItemsByIndices: function (val) { this._unselectItemByIndex(val); },

        /*will deprecate with unselectItemsByIndices method */
        unselectItemByIndex: function (val) { this._unselectItemByIndex(val); },

        _unselectItemByIndex: function (val) {
            this._selectedIndices = $.map(this._selectedIndices, function (a) { return parseInt(a); });
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
            var i, items = this._toArray(val, true), index;
            this.listitems = this._getLi();
            for (var k = 0; k < items.length; k++) {
                index = parseInt(items[k]);
                for (i = 0; i < this.listitems.length; i++) {
                    if (i == index) {
                        this.selectedIndexValue = i;
                        this._activeItem = index;
                        if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                        this._removeTextBoxValue();
                    }
                }
            }
        },

        /*Deprecated with selectedItemByValue */
        setSelectedValue: function (idvalue) { this.selectItemByValue(idvalue); },

        selectItemByValue: function (val) {
            var i, hidelement, items;
            this.listitems = this._getLi();
            if (ej.isNullOrUndefined(val) || val === "") this._clearTextboxValue();
            else {
                items = this._toArray(val, true);
                for (var k = 0; k < items.length; k++) {
                    for (i = 0; i < this.listitems.length; i++) {
                        if (!$(this.listitems[i]).hasClass('e-disable')) {
                            var fieldValue = this._getAttributeValue(this.listitems[i]) || $(this.listitems[i]).text();
                            if (fieldValue) {
                                this._selectedValue = fieldValue;
                                if (this._selectedValue == items[k]) {
                                    this._activeItem = i;
                                    this._aselectedItem = this._activeItem;
                                    this._enterTextBoxValue();
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        },


        unselectItemByValue: function (val) {
            var i, hidelement, items = this._toArray(val, true);
            this.listitems = this._getLi();
            for (var k = 0; k < items.length; k++) {
                for (i = 0; i < this.listitems.length; i++) {
                    if (this._getAttributeValue(this.listitems[i])) {
                        this._selectedValue = this._getAttributeValue(this.listitems[i]);
                        if (this._selectedValue == items[k]) {
                            this._activeItem = i;
                            if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                            this._removeTextBoxValue();
                            break;
                        }
                    }
                }
            }
        },

        /* Deprecated with selectItemByText*/
        setSelectedText: function (value) { this.selectItemByText(value); },

        selectItemByText: function (val) {
            var i, hidelement, items;
            this.listitems = this._getLi();
            this._mapFields();
            if (ej.isNullOrUndefined(val) || val === "") this._clearTextboxValue();
            else {
                items = this._toArray(val, true);
                for (var k = 0; k < items.length; k++) {
                    for (i = 0; i < this.listitems.length; i++) {
                        if (!$(this.listitems[i]).hasClass('e-disable')) {
                            this.selectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                            if (this.selectedTextValue == items[k]) {
                                this._activeItem = i;
                                this._aselectedItem = this._activeItem;
                                this._enterTextBoxValue();
                                break;
                            }
                        }
                    }
                }
            }
        },


        unselectItemByText: function (val) {
            var i, hidelement, items = this._toArray(val, true);
            this.listitems = this._getLi();
            this._mapFields();
            for (var k = 0; k < items.length; k++) {
                for (i = 0; i < this.listitems.length; i++) {
                    this.unselectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    if (this.unselectedTextValue == items[k]) {
                        this._activeItem = i;
                        if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                        this._removeTextBoxValue();
                        break;
                    }
                }
            }
        },

        getSelectedValue: function () {
			return this.element.val();
        },

        getSelectedItem: function () {
            var k, selected = [];
            this.listitems = this._getLi();
            for (k = 0; k < this._selectedIndices.length; k++) {
                selected.push(this.listitems[this._selectedIndices[k]]);
            }
            return selected;
        },
        getItemDataByValue: function (value) {
            var listitems = this._toArray(value, false);
            var k, m, selected = [], field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
            for (k = 0; k < listitems.length; k++) {
                for (m = 0; m < this._rawList.length; m++) {
                    if (this._rawList[m][field] == listitems[k])
                        selected.push(this._rawList[m]);
                }
            }
            return selected;
        },

        getListData: function () { return this._rawList; },

        /* will be deprecate in upcoming releases*/
        getSelectedItemsID: function () {
            return this._selectedItemsID;
        },

        disableItemsByIndices: function (value) { this._disableItemByIndex(value) },

        /*Deprecated with disableItemsByIndices method */
        disableItemByIndex: function (value) { this._disableItemByIndex(value) },

        _disableItemByIndex: function (value) {
            if (!this.model.enabled) return false;
            var listitems = this._toArray(value, false);
            for (var i = 0; i < listitems.length; i++) {
                if (listitems[i] != null && !isNaN(parseInt(listitems[i]))) {
                    if (listitems.length > 0 && !($.inArray(parseInt(listitems[i]), this._disabledItems) > -1)) {
                        index = $.inArray(listitems[i], this._disabledItems);
                        this._setClass(this._getLi()[parseInt(listitems[i])], "e-disable");
                        this._disabledItems.push(parseInt(listitems[i]));
                        this.model.disableItemsByIndex = String(this._disabledItems.join(","));
                    }
                }
            }
        },

        enableItemsByIndices: function (value) { this._enableItemByIndex(value) },

        /*Deprecated with enableItemsByIndices method */
        enableItemByIndex: function (value) { this._enableItemByIndex(value) },

        _enableItemByIndex: function (value) {
            var listitems = this._toArray(value, false), index;
            this.model.enableItemsByIndex = value;
            for (var i = 0; i < listitems.length; i++) {
                if (listitems.length > 0 && ($.inArray(parseInt(listitems[i]), this._disabledItems) > -1) &&  !isNaN(parseInt(listitems[i]))) {
                    index = $.inArray(parseInt(listitems[i]), this._disabledItems);
                    this._removeClass(this._getLi()[parseInt(listitems[i])], "e-disable");
                    this._disabledItems.splice(index, 1);
                }
            }
            this.model.enableItemsByIndex = null;
            this.model.disableItemsByIndex = this._disabledItems.join(this.model.delimiterChar);
        },
        _validateDelimiter: function (deli) {
            if (this._trim(deli).length == 1) {
                var RegEx = /^[a-zA-Z0-9]+$/;
                if (!RegEx.test(deli)) return deli;
            }
            return ",";
        },

        _removeText: function (currentValue) {
            var eleVal = this.element[0].value.split(this.model.delimiterChar), hidVal = this._visibleInput[0].value.split(this.model.delimiterChar),
            index = $.inArray(currentValue, eleVal);
            if (index >= 0) {
                eleVal.splice(index, 1);
                hidVal.splice(index, 1);
            }
            this.element[0].value = eleVal.join(this.model.delimiterChar);
            this._visibleInput[0].value = hidVal.join(this.model.delimiterChar);
        },
        _addText: function (currentValue) {
            if (this._checkContains(this._hiddenValue)) return false;
            var ele = ["element", "_visibleInput"], val;
            for (var i = 0; i < ele.length; i++) {
                val = ele[i] == "element" ? this._hiddenValue : currentValue;
                if (this[ele[i]][0].value && this[ele[i]][0].value != "") {
                    var splitedText = this[ele[i]][0].value.split(this.model.delimiterChar);
                    splitedText.push(val);
                    this[ele[i]][0].value = splitedText.join(this.model.delimiterChar);
                } else this[ele[i]][0].value = val;
            }
        },
        _checkContains: function (chkValue) {
            var values = this.element[0].value.split(this.model.delimiterChar);
            this.contains = false;
            for (var i = 0; i < values.length; i++) {
                if (values[i] === chkValue) {
                    this.contains = true;
                    break;
                }
            }
            return this.contains;
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.DropDownList", this.model.locale);
        },
        _init: function () {
            var browserInfo = ej.browserInfo();
            this._updateLocalConstant();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0');
            this._textContent = this._isIE8 ? "innerText" : "textContent";
            if ((this.element.is("input") && (this.element.is("input[type=text]") || !this.element.attr('type'))) || this.element.is("select")) {
                this._isWatermark = 'placeholder' in $(document.createElement('input')).attr("placeholder", '')[0];
                this._id = this.element[0].id;
                this._initialize();
                this._render();
                this._addAttr(this.model.htmlAttributes);
                this._enabled(this.model.enabled);
                this._initValue = false;
                this._checkboxValue = false;
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
            }
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            if (this.element.closest("form").length != 0) {
                this.element.rules("add", this.model.validationRules);
                var validator = this.element.closest("form").data("validator");
                if (!validator) validator = this.element.closest("form").validate();
                var name = this.element.attr("name");
                validator.settings.messages[name] = {};
                for (var ruleName in this.model.validationRules) {
                    var message = null;
                    if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                        if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                            message = this.model.validationRules["messages"][ruleName];
                        else {
                            validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                            for (var msgName in this.model.validationMessage)
                                ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                        }
                        validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                    }
                }
            }
        },

        _setInitialPopup: function (value) {
            if (this.model.enabled && !this.model.readOnly)
                value == false ? this._hideResult() : this._showResult();
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.popupListWrapper.removeClass(this.model.cssClass).addClass(skin);
        },

        _setRTL: function (val) {
            if (this.model.enableRTL != val) {
                this.model.enableRTL = val;
                this._RightToLeft();
                this._dropbtnRTL();
            }
        },

        _changeHeight: function (height) {
            this.wrapper.height(height);
            this._setListHeight();
        },
        _changeWidth: function (width) {
            this.wrapper.width(width);
            this._setListWidth();
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "dataSource": if (!this._isEqualDataSource(options[option])) this._checkModelDataBinding(options[option], this.model.query); break;
                    case "query": this._checkModelDataBinding(this.model.dataSource, options[option]); break;
                    case "fields": this.model.fields = $.extend(this.model.fields, options[option]); this._checkModelDataBinding(this.model.dataSource, this.model.query); break;
                    case "itemsCount": this.model.itemsCount = options[option]; this._checkModelDataBinding(this.model.dataSource, this.model.query);; break;
                    case "template": this.model.template = options[option]; this._checkModelDataBinding(this.model.dataSource, this.model.query); break;
                    case "value": 
					var optionValue = ej.util.getVal(options[option]);
					if (ej.isNullOrUndefined(optionValue) || optionValue === "") this._clearTextboxValue();
                    else { this._setValue(ej.util.getVal(options[option])); options[option] = this.model.value; } break;
                    case "delimiterChar": 
						var delchar = this.model.delimiterChar; 
						options[option] = this._validateDelimiter(options[option]);
                        this.model.delimiterChar = options[option];
						if (this.model.text) {
							this.model.text = this.model.text.split(delchar).join(this.model.delimiterChar);
							this._visibleInput.val(this.model.text);							
						}
						if(this.model.value) {
							this.model.value = this.model.value.split(delchar).join(this.model.delimiterChar);
							this.element.val(this.model.value);	
						}
                        break;
                    case "text": if (ej.isNullOrUndefined(options[option]) || options[option] === "") this._clearTextboxValue();
                    else { this._setText(options[option]); options[option] = this.model.text; } break;
                    case "itemValue": this._setItemValue(options[option]); break;
                    case "enableRTL": this._setRTL(options[option]); break;
                    case "enabled": this._enabled(options[option]); break;
                    case "height": this._changeHeight(options[option]); break;
                    case "width": this._changeWidth(options[option]); break;
                    case "popupHeight": this.model.popupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "minPopupHeight": this.model.minPopupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "minPopupWidth": this.model.minPopupWidth = options[option]; this._setListWidth(); break;
                    case "maxPopupHeight": this.model.maxPopupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "maxPopupWidth": this.model.maxPopupWidth = options[option]; this._setListWidth(); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showCheckbox": this.model.showCheckbox = options[option];
                        var _text = this.model.text;
                        var _textes = this.model.text ? this.model.text.split(this.model.delimiterChar) : this.model.text;
                        this._raiseEvents = false;
                        this._clearTextboxValue();
                        this._raiseEvents = true;
                        this._checkboxHideShow(options[option]);
                        if (this.model.showCheckbox || (this.model.multiSelectMode != "none")) {
                            if (this.model.multiSelectMode == "visualmode")
                                this._renderBoxModel();
                            this._setText(_text);
                        }
                        else if (_textes && _textes.length)
                            this._setText(_textes[0]);
                        if (this._isPopupShown())
                            this._setListPosition();
                        break;
                        /* will depreciate with checkAll  Method*/
                    case "checkAll": this._setCheckAll(options[option]); return false; break;
                        /* will depreciate with uncheckAll  Method*/
                    case "uncheckAll": this._setUncheckAll(options[option]); return false; break;
                    case "watermarkText": this._changeWatermark(options[option]); break;
                    case "validationRules":
                        if (this.element.closest("form").length != 0) {
                            if (this.model.validationRules != null) {
                                this.element.rules('remove');
                                this.model.validationMessage = null;
                            }
                            this.model.validationRules = options[option];
                            if (this.model.validationRules != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._updateLocalConstant();
                        break;
                    case "validationMessage":
                        if (this.element.closest("form").length != 0) {
                            this.model.validationMessage = options[option];
                            if (this.model.validationRules != null && this.model.validationMessage != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "showRoundedCorner": this._roundedCorner(options[option]); this.model.showRoundedCorner = options[option]; break;
                    case "showPopupOnLoad": this._setInitialPopup(options[option]); break;
                    case "targetID": this.model.targetID = options[option]; this._showFullList(); break;
                        /* will depreciate with selectedIndex  Method*/
                    case "selectedItemIndex":
                    case "selectedIndex":
                        this._selectItemByIndex(options[option]);
                        this.model.selectedItemIndex = this.model.selectedIndex = options[option];
                        break;
                        /* will depreciate with unselectItemByIndex API Method*/
                    case "unselectItemByIndex": this._unselectItemByIndex(options[option]); break;
                        /* will depreciate with disableItemsByIndex API Method*/
                    case "disableItemsByIndex": this._disableItemByIndex(options[option]); break;
                        /* will depreciate with enableItemsByIndex API Method*/
                    case "enableItemsByIndex": this._enableItemByIndex(options[option]); break;
                        /* will depreciate with selectedIndices  Method*/
                    case "selectedItems":
                    case "selectedIndices":
                        this._selectCheckedItem(options[option]);
                        options[option] = this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        break;
                    case "multiSelectMode":
                        if (this.model.multiSelectMode == "visualmode") {
                            this._swapUlandInput(false);
                            this._ulBox.remove();                         
                            this._ulBox = null;                     
                        }
                        this.model.multiSelectMode = options[option];
                        var _text = this.model.text;
                        var _textes = this.model.text ? this.model.text.split(this.model.delimiterChar) : this.model.text;
                        this._raiseEvents = false;
                        this._clearTextboxValue();
                        this._raiseEvents = true;
                        if (this.model.showCheckbox || (this.model.multiSelectMode != "none")) {
                            if (this.model.multiSelectMode == "visualmode")
                                this._renderBoxModel();
                            this._setText(_text);
                        }
                        else {
                            this._setText(_textes[0]);
                            this.wrapper.find("input[name=" + this._name + "]").remove();
                        }
                        if (this._isPopupShown())
                            this._setListPosition();
                        break;
                        /* will deprecate with fields.groupBy and e-category element in target element binding */
                    case "allowGrouping":
                        this._setGroupingAndSorting("allowGrouping", options[option]);
                        break;
                    case "enableSorting":
                        this._setGroupingAndSorting("enableSorting", options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "enablePopupResize": this.model.enablePopupResize = options[option];
                        (options[option]) ? this._enablePopupResize() : this.popupListWrapper.removeClass("e-resizable").find(".e-resizebar").remove() && this._hideResult();
                        break;
                    case "enableFilterSearch":
                        if (!options[option]) this._removeSearch();
                        else {
                            this.model.enableFilterSearch = true;
                            this._enableSearch();
                            break;
                        }

                }
            }
        },

        _clearTextboxValue: function () {
            this.element.val("");
            this._visibleInput.val("");
            this._updateValue("");
            this.selectedTextValue = this._selectedValue = this._hiddenValue = this.model.itemValue = "";
            this._updateText();
            this.selectedIndexValue = this._hiddenDelimiterIndex = this._activeItem = -1;
            this._selectedItemsID = []; this._selectedIndices = [];
            this.model.selectedItems = [];
            this.model.selectedIndices = [];
            this.selectedIndex(null);
            this.ultag.children("li").removeClass('e-hover').removeClass('e-active');
            if (this.model.showCheckbox) this._resetCheck();
            if (this.wrapper.find('ul.e-ul.e-boxes').length != 0) {
                this._ulBox.children("li").remove();
                if (this._name === "")
                    this.wrapper.find("input:hidden[id^='#']").remove();
                else
                    this.wrapper.find("input:hidden[id^='#'][name=" + this._name + "]").remove();
                $(this.element).attr("name", this._name);
            }
        },

        _destroy: function () {
            this._destroyDropdown();
            this._visibleInput.removeClass("e-input ");
            this._setAttr( this.element[0], { 'accesskey': this.wrapper.attr('accesskey'), type:"text" });
            if (this._isWatermark) this._visibleInput.removeAttr("placeholder");
            this.element[0].value = "";
            if (!this.model.dataSource) {
                this.selectOptions ? this.docbdy && this.docbdy.append(this.selectOptions.show()).show() && this.element.remove() && this.selectOptions && this.selectOptions.removeClass("e-dropdownlist e-js") : this.docbdy && this.ultag.find("li").removeClass("e-active") && this.docbdy.append(this.ultag.html()).show();
            }
            this._hideResult();
            this.popupPanelWrapper.remove();
			this.element.removeAttr("aria-expanded aria-autocomplete aria-haspopup aria-owns accesskey role").css({"width": "", "display": "block"});
			this._unwireEvents();
        },


        _finalize: function () {
            if (this.value() == "" && this._visibleInput[0].value !== "")
                this._updateValue(this.element[0].value);
            if (this.value() !== this.element.val())
                this._setValue(this.value());
            if (this.model.text != this._visibleInput.val())
                this._setText(this.model.text);
            this.selectedIndex((this.selectedIndex() != -1) ? this.selectedIndex() : this.selectedItemIndex());
            if (this.selectedIndex() != -1) {
                this._selectItemByIndex(this.selectedIndex());
            } else if (this._selectedIndices.length > 0) {
                this._selectCheckedItem(this._selectedIndices);
            } if (this.model.disableItemsByIndex != null)
                this._disableItemByIndex(this.model.disableItemsByIndex);
            if (this.model.enableItemsByIndex != null)
                this._enableItemByIndex(this.model.enableItemsByIndex);
        },


        _initialize: function () {
            this._selectedIndices = this.model.selectedIndices.length > 0 ? this.model.selectedIndices : this.model.selectedItems;
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
            this.model.selectedIndex = this.model.selectedIndex != -1 ? this.model.selectedIndex : this.model.selectedItemIndex;
            if (this.element.is("select")) {
                this.selectelement = true;
                this._renderSelectToDropdown();
            }
            this._selectedItemsID = [];
            this.target = this.element[0];
            this._disabledItems = new Array();
            this._queryString = null;
            this.suggLen = 0;
            this._itemId = null;
            this.checkedStatus = false;
            this._incqueryString = "";
            this._activeItem = null;
            this.ddWidth = 0;
            this._initValue = true;
            this._virtualCount = 0;
            this._raiseEvents = true;
        },
        _renderSelectToDropdown: function () {
            var i, optionLength, optionText, item;
            this.inputElement = ej.buildTag("input.e-dropdownlist#" + this._id + "_input", "", {}, { "type": "text", "data-role": "none" });
            this.inputElement.insertAfter(this.element);
			if (this.element.attr("name")) {
                this.inputElement.attr("name", this.element.attr("name"));
                this.element.removeAttr("name");
            }
			this.selectOptions = this.element;
            this.selectOptions.attr('id', this._id);
			if( this.model.dataSource == null ) {
            this.optionDiv = ej.buildTag("div#" + this._id + "_list");
            this.optionDiv.insertAfter(this.inputElement);
            this.optionUl = ej.buildTag("ul");
            this.optionDiv.append(this.optionUl);

            this.selectOptionItems = this.element.children("option");
            optionLength = this.selectOptionItems.length;
            this.optionDummyUl = $();

            for (i = 0; i < optionLength; i++) {
                item = this.selectOptionItems[i], optionText = $(item).attr('label') ? $(item).attr('label') : item.innerHTML;
                if (optionText != null) {
                    this.optionLi = ej.buildTag("li", optionText, {}, { 'data-value': item.value, "unselectable": "on" });
                    this.optionDummyUl.push(this.optionLi[0]);
                    if ($(item).attr("selected")) {
                        if (this.model.showCheckbox)
                            if ($.inArray(i, this._selectedIndices) == -1) {
                                this._selectedIndices.push(i);
                                this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                            }
                            else if (ej.isNullOrUndefined(this.selectedIndex())) this.selectedIndex(i);
                    }
                }
            }
            this.optionUl.append(this.optionDummyUl);

			}
            this.element.css('display', 'none');
            this.element = this.inputElement;
        },


        _render: function () {
            this._renderDropdown();
            this._setWatermark();
            this._renderPopupPanelWrapper();
            this._showFullList();
            this._roundedCorner(this.model.showRoundedCorner);
            //To call finalize() only local data source
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                    var proxy = this;
                    proxy._finalize();
                }               
            }
            else this._finalize();
            if (!(ej.DataManager && this.model.dataSource instanceof ej.DataManager)){
                
                 this._finalize();
            }               
            this._setCheckAll(this.model.checkAll);
            if(this.element.attr("disabled") || $(this.selectOptions).attr("disabled"))this.disable();
        },

        _isEqualDataSource: function (source) {
            if (!this.model.dataSource || !source || !(this.model.dataSource.length === source.length) || (ej.DataManager && source instanceof ej.DataManager)) return false;
            var equal = true;
            for (var i = 0, len = this.model.dataSource.length; i < len; i++) {
                if (this.model.dataSource[i] !== source[i]) {
                    equal = false;
                    break;
                }
            }
            return equal;
        },

        _checkModelDataBinding: function (source, query) {
            this.element.val("");
            this._visibleInput.val("");
            this._updateValue("");
            this.selectedTextValue = this._selectedValue = this._hiddenValue = "";
            this._updateText();
            this.selectedIndexValue = this._hiddenDelimiterIndex = this._activeItem = -1;
            this._selectedItemsID = [];
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices = [];
            this.model.selectedIndex = this.model.selectedItemIndex = -1;
            if (this.model.multiSelectMode == "visualmode") this._destroyBoxModel();
            this.model.dataSource = source;
            this.model.query = query;
            this.ultag.empty();
            this._showFullList();
        },
        _initDataSource: function (source) {
            var proxy = this;
            if (ej.DataManager && source instanceof ej.DataManager) {
                proxy._addLoadingClass();
                if (!proxy._trigger("actionBegin", { requestFrom: "default" })) {
                    var queryPromise = source.executeQuery(this._getQuery());
                    queryPromise.done(function (e) {
                        proxy._trigger("actionSuccess", { e: e, requestFrom: "default" });
                        proxy._totalCount = e.count;
                        proxy._listItem(e.result);
                        proxy._removeLoadingClass();
                        proxy._renderPopupList();
                        proxy._finalize();

                    }).fail(function (e) {
                        proxy.model.dataSource = null;
                        proxy._addLoadingClass();
                        proxy._trigger("actionFailure", { e: e, requestFrom: "default" });
                    }).always(function (e) {
                        proxy._trigger("actionComplete", { e: e, requestFrom: "default" });
                    });
                }
            }
        },
        _listItem: function (list, type) {
            if (type == "add") {
                this.popupListItems.push(list);
                this._rawList.push(list);
            } else if ($.isArray(list)) {
                this.popupListItems = list.slice(0);
                this._rawList = list.slice(0);
            }
        },
        _getQuery: function (isLocal) {
            var remoteUrl, mapper = this.model.fields, queryManager = ej.Query();
            if (ej.isNullOrUndefined(this.model.query) && !this.model.template && !isLocal) {
                var column = [];
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
            }
            else if (this.model.query) queryManager = this.model.query.clone();

            if (this.model.allowVirtualScrolling) queryManager.requiresCount();
            if (this.model.itemsCount > 0) queryManager.take(this.model.itemsCount);

            remoteUrl = this.model.dataSource.dataSource;
            if (mapper)
                if ((remoteUrl && remoteUrl.url && !remoteUrl.url.match(mapper.tableName + "$")) || (remoteUrl && !remoteUrl.url) || (!remoteUrl))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);

            return queryManager;
        },

        _addLoadingClass: function () {
            if (this._isPopupShown()) {
                this.popupListWrapper.addClass("e-load");
            } else {
                this.dropdownbutton.addClass("e-load");
                this.drpbtnspan.removeClass("e-icon e-arrow-sans-down");
            }
            this._readOnly = true;
        },
        _removeLoadingClass: function () {
            this.dropdownbutton.removeClass("e-load");
            this.drpbtnspan.addClass("e-icon e-arrow-sans-down");
            this._readOnly = false;
            this.popupListWrapper.removeClass("e-load");
        },

        _renderDropdown: function () {
            this.wrapper = ej.buildTag("span.e-ddl e-widget " + this.model.cssClass + "#" + this._id + "_wrapper", "", {}, { "tabindex": "0", "accesskey": this.element.attr("accesskey") });
            this.container = ej.buildTag("span.e-in-wrap e-box " + "#" + this._id + "_container");
            this.element.removeAttr('accesskey');            
			if(this.model.value == null && this.element.attr("value") != null)
				this.model.value = this.element.attr("value");				
			this.element.attr("value","").val("");
            if(!this._isIE8)
            this._setAttr(this.element[0], { "type":"hidden","role": "combobox", "aria-expanded": false, "aria-autocomplete": "list", "aria-haspopup": true, "aria-owns": this._id + "_popup" }).element.hide();
			else
			this._setAttr(this.element[0], {"role": "combobox", "aria-expanded": false, "aria-autocomplete": "list", "aria-haspopup": true, "aria-owns": this._id + "_popup" }).element.hide();			
            this.drpbtnspan = ej.buildTag("span.e-icon e-arrow-sans-down", "", {}, { "aria-label": "select", "unselectable": "on" });
            this.dropdownbutton = ej.buildTag("span.e-select#" + this._id + "_dropdown", "", {}, { "role": "button", "unselectable": "on" }).append(this.drpbtnspan);
            this.container.insertAfter(this.element);
            this.container.append(this.element);
            this.container.append(this.dropdownbutton);
            this.wrapper.insertBefore(this.container);
            this.wrapper.append(this.container);
            if (this.selectelement) {
                this.selectOptions.insertBefore(this.element);
            }
            this._visibleInput = ej.buildTag("input#" + this._id + "_hidden", "", {}).insertAfter(this.element);
            this._visibleInput.addClass("e-input ");
			this._setAttr(this._visibleInput[0],{ "readonly": true, "tabindex": -1,"data-role": "none" });        
            if (!this._isWatermark) {
				var watermark=(this.model.watermarkText != null)? this.model.watermarkText:this._localizedLabels.watermarkText;
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(watermark);
                this._hiddenSpan.css("display", "none");
                this._hiddenSpan.on("mousedown", $.proxy(this._OnDropdownClick, this));
            }
            this._checkNameAttr();
            this._setDimentions();
            this._RightToLeft();
            this.ddWidth = (this.dropdownbutton.outerWidth() > 0) ? this.dropdownbutton.outerWidth() : 24;
            //Element not Maintain in Multiselection
            this.container.on("mousedown", $.proxy(this._OnDropdownClick, this));
        },

        _checkNameAttr: function () {
            this._name = ej.isNullOrUndefined(this.element.attr("name")) ? this._id : this.element.attr("name");
            this.element.attr("name", this._name);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
				var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value); 
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readOnly" && value == "readOnly") proxy.model.readOnly = true; 
                else if (keyName == "style") proxy.wrapper.attr(key, value);
				else if (ej.isValidAttr(proxy._visibleInput[0], key)) $(proxy._visibleInput).attr(key, value);
                else proxy.wrapper.attr(key, value)
            });
        },
        _renderBoxModel: function () {
            if (!ej.isNullOrUndefined(this._ulBox) || this.model.multiSelectMode != "visualmode") return false;
            this._ulBox = ej.buildTag("ul.e-ul e-boxes");
            this.container.prepend(this._ulBox);
            this._ulBox.css('min-height', '30px');
            this._ulBox.css('display', 'none');
            this._on(this.container, "click", function (e) {
                if (!this.model.enabled) return false;
                var $target = $(e.target);
                if ($target.hasClass("e-options")) {
                    if (!e.ctrlKey && $target.siblings().hasClass("e-active")) this._removeActive();
                    if ($target.hasClass("e-active")) $target.removeClass("e-active");
                    else $target.addClass("e-active");
                }
                if (!e.ctrlKey && ($target.hasClass("e-boxes"))) this._removeActive();
            });
        },

        _renderPopupPanelWrapper: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup_wrapper").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.popupPanelWrapper = ej.buildTag("div#" + this._id + "_popup_wrapper");
            $('body').append(this.popupPanelWrapper);
            this.popupListWrapper = ej.buildTag("div.e-ddl-popup e-box e-widget  e-popup#" + this._id + "_popup_list_wrapper", "", { display: "none", overflow: "hidden" });
            this.popupList = ej.buildTag("div#" + this._id + "_popup", { "tabIndex": 0 });
            this.popupListWrapper.addClass(this.model.cssClass);
            this.popup = this.popupList;
            this.popupScroller = ej.buildTag("div"); this.ultag = ej.buildTag("ul.e-ul", "", {}, { "role": "listbox" });
            this.popupScroller.append(this.ultag);
            this.popupList.append(this.popupScroller);
            if (this.model.headerTemplate) {
                this.headerTemplate = $("<div>").append(this.model.headerTemplate);
                this.popupListWrapper.append(this.headerTemplate);
            }
            this.popupListWrapper.append(this.popupList);
            this.popupPanelWrapper.append(this.popupListWrapper);
            this.ultag.on({ mouseenter: $.proxy(this._OnMouseEnter, this), mouseleave: $.proxy(this._OnMouseLeave, this), click: $.proxy(this._OnMouseClick, this)}, "li:not('.e-category')");
            if (ej.isTouchDevice())
             {
             this.ultag.on({tap:$.proxy(this._OnMouseEnter, this) }, "li:not('.e-category')");
               }
            $(window).on("resize", $.proxy(this._OnWindowResize, this));

        },

        _updateText: function () {
            this.model.text = this._visibleInput.val() == "" ? null : this._visibleInput.val();
        },
        _updateValue: function (val) {
            this.value(val == "" ? null : val);
        },
        _setGroupingAndSorting: function (prop, value) {
            this.model[prop] = value;
            var oldValue = this.model.text;
            this._updateValue("");
            this._selectedIndices = [];
            this.ultag.empty();
            this._showFullList();
            if (this.model.showCheckbox && oldValue) {
                var values = oldValue.split(this.model.delimiterChar);
                for (var i = 0; i < values.length; i++)
                    this.selectItemByText(values[i]);
            }
            else
                this.selectItemByText(oldValue);
        },
        _setSortingList: function () {
            var sortedlist = document.createElement("ul"), i, sortitems;
            $(sortedlist).append(this.itemsContainer.children());
            if (this.model.allowGrouping || $(sortedlist).find(">.e-category").length > 0) {
                this.popupListWrapper.addClass("e-atc-popup");
                for (i = 0; i < $(sortedlist).find(">.e-category").length; i++) {
                    sortitems = $(sortedlist).find(">.e-category").eq(0).first().nextUntil(".e-category").get();
                    this._setSortList(sortedlist, sortitems);
                }
            }
            else {
                $(sortedlist).children('>.e-category').remove();
                sortitems = $(sortedlist).children('li').get();
                this._setSortList(sortedlist, sortitems);
            }
            this.itemsContainer = $(sortedlist);
        },
        _setSortList: function (sortedlist, sortitems) {
            sortitems.sort(function (objA, objB) {
                var sortA = $(objA).text().toUpperCase();
                var sortB = $(objB).text().toUpperCase();
                return (sortA < sortB) ? -1 : (sortA > sortB) ? 1 : 0;
            });
            if (this.model.sortOrder == "descending") sortitems.reverse();
            if (this.model.allowGrouping || $(sortedlist).find(">.e-category").length > 0) {
                $(sortedlist).append($("<li>").text($(sortedlist).find(">.e-category").eq(0).text()).addClass("e-category"));
                $(sortedlist).find(">.e-category").eq(0).remove();
            }
            $.each(sortitems, function (index, item) {
                $(sortedlist).append(item);
            });
        },

        _renderPopupList: function () {
            this._doDataBind();
            this._renderRemaining();
        },
        _renderRemaining: function () {
            var proxy = this;
            this._dropbtnRTL();
            if (this.model.enableFilterSearch) this._enableSearch();
            if (this.model.enablePopupResize) this._enablePopupResize();
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                if (this._totalCount && this._totalCount > 0) {
                    this._totalHeight = this._totalCount * 29;
                    this._totalPages = this._totalCount / (this.model.itemsCount * 29);
                    this._loadedItemHeight =  this._getLi().length * 29;
                    this._getLi().attr("page", 0);
                    this._virtualPages = [0];
                    this.ultag.append($("<span>").addClass("e-virtual").css({ "height": this._totalHeight - this._loadedItemHeight, "display": "block" }));
                }
            }
            this._virtualUl = this.ultag.clone(true);
            this._setListWidth();
            this._setListHeight();
			if (!this._isSingleSelect()) {
                if (this.model.showCheckbox) this._checkboxHideShow(this.model.showCheckbox);
                else this._multiItemSelection(this._getLi());
            }
            this._setUncheckAll(this.model.uncheckAll);
            this.popupScroller.css({ "height": "", "width": "" });
            this.popupList.ejScroller({
                height: this._getPopupHeight(), width: 0, scrollerSize: 20, scroll: function (e) {
                    if (proxy.model.allowVirtualScrolling) proxy._onScroll(e);
                }
            });
            this.scrollerObj = this.popupList.ejScroller("instance");
            this.popupList.find("div.e-scrollbar div").attr("unselectable", "on");
			this._setListPosition();
            this.popupListWrapper.css({ 'display': 'none', 'visibility': 'visible' });
            this._changeSkin(this.model.cssClass);
            this.model.showPopupOnLoad && this._showResult();
           
        },

        _enableSearch: function () {
            if (this.model.enableFilterSearch)
                if (!this.inputSearch) {
                    this.inputSearch = ej.buildTag("input#" + this._id + "_inputSearch.e-input", "", {}, { "type": "text", "data-role": "none" });
                    this.popupListWrapper.prepend($("<span>").addClass("e-atc e-search").append($("<span>").addClass("e-in-wrap ").append(this.inputSearch).append($("<span>").addClass(" e-icon e-search"))));
                    this._on(this.inputSearch, "keyup", this._OnSearchEnter)._on(this.inputSearch, "keydown", function(args){
						var keyCode = args.keyCode || args.which; 
						  if (keyCode == 9) { 
						    args.preventDefault(); 
						    this.wrapper.focus();
							this._hideResult();
						  } 
					});
                }
        },
        _removeSearch: function () {
            this.model.enableFilterSearch = false;
            this.popupListWrapper.find(".e-atc.e-search").remove();
            if (this._isPopupShown()) this.hidePopup();
            this.inputSearch = null;
        },

        _OnSearchEnter: function (e) {
            var proxy = this;
            if ($.inArray(e.keyCode, [38, 40, 13]) != -1 && this.ultag.find("li.e-nosuggestion").length <= 0) {
                if (e.keyCode == 13) this._OnKeyUp(e);
                else this._OnKeyDown(e);
            }
            else {
                this._activeItem = -1;
                this._queryString = this.inputSearch.val();
                if (this._queryString == "" && this._virtualUl) {
                    var args = { searchString: this._queryString, searchQuery: null, items: this._rawList };
                    this._trigger("search", args);
                    this._resetList();
                    this._updateSelectedIndexByValue(this.value());
                    this._refreshScroller();
                    this._setListPosition();
                } else {
                    this._mapFields();
                    var searchQuery = this._addSearchQuery(ej.Query(), !this._isPlainType(this._rawList));
                    var args = { searchString: this._queryString, items: this._rawList, searchQuery: searchQuery };
                    this.popupListWrapper.find(".e-atc.e-search .e-search").addClass("e-cross-circle").removeClass("e-search");
                    this._on(this.popupListWrapper.find(".e-atc.e-search .e-cross-circle"), "mousedown", this._refreshSearch);
                    if (!this._trigger("search", args))
                        proxy._filterSearch(searchQuery, args);
                }
            }
        },

        _refreshSearch: function () {
            this._resetSearch();
            this._refreshPopup();
        },
        _filterSearch: function (searchQuery, args) {
            var flag = false, resultList = args.result ? args.result : ej.DataManager(this._rawList).executeLocal(searchQuery);
            if (resultList.length == 0) {
                flag = true;
                resultList.push(this._getLocalizedLabels("emptyResultText"));
            }
            this.popupListItems = resultList;
            this.ultag.empty();
            this._isPlainType(this.popupListItems) ? this._plainArrayTypeBinding(resultList) :
            this._objectArrayTypeBinding(resultList, "search");
            if (flag && this.ultag.find("li").length == 1) {
                this.ultag.find("li").eq(0).addClass("e-nosuggestion");
            }
            if (this.model.showCheckbox && !flag) {
                this._appendCheckbox( this._getLi());
            }
            this._onSearch = true;
            this._setValue(this.value());
            this._onSearch = false;
            this._updateSelectedIndexByValue(this.value());
            this._refreshScroller();
            this._setListPosition();
        },
        _updateSelectedIndexByValue: function (value) {
            if (!value || !this.model.enableFilterSearch) return;
            this._selectedIndices = this.model.selectedItems = this.model.selectedIndices = [];
            this._virtualList = this._virtualUl.children("li:not('.e-category')");
            var item = this._toArray(value);
            for (var k = 0; k < item.length; k++) {
                for (var m = 0; m < this._virtualList.length; m++) {
                    if (item[k] == this._getIndexedValue(this._virtualList[m])) {
                        this._selectedIndices.push(m);
                        break;
                    }
                }
            }
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
        },
        _getIndexedValue: function (item) {
            return this._getAttributeValue(item) ? this._getAttributeValue(item) : item.innerText;
        },

        _resetSearch: function () {
            if (!this.inputSearch || !(this.model && this.model.enableFilterSearch)) return;
            if (this.inputSearch.val() != "" && this._virtualUl) {
                this.inputSearch.val("");
                this._resetList();
            }
        },
        _resetList: function () {
            if (this.popupListWrapper.find(".e-atc.e-search .e-cross-circle").length == 1) {
                this.popupListWrapper.find(".e-atc.e-search .e-cross-circle").addClass("e-search").removeClass("e-cross-circle");
                this._off(this.popupListWrapper.find(".e-atc.e-search .e-cross-circle"), "mousedown", this._refreshSearch);
            }
            this._listItem(this._rawList);
            this.ultag.empty().append(this._virtualUl.children().clone(true));           
            // this._onSearch variable will restrict the change and select event on searching
            this._onSearch = true;
            this._setValue(this.value());
            this._onSearch = false;
        },

       
        _addSearchQuery: function (query, checkMapper) {
            var bindTo = "";
            if (checkMapper) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper.text) ? mapper["text"] : "text";
            }
            if (this._queryString) query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);
            if (this.model.itemsCount > 0) query.take(this.model.itemsCount);
            return query;
        },

        _targetElementBinding: function () {
            var predecessor = this.element.parents().last();
            this.docbdy = this.model.targetID ? predecessor.find("#" + this.model.targetID) : this.optionDiv ? this.optionDiv : null;
            if (!this.docbdy) return false;
            this.itemsContainer = this.docbdy[0].nodeName == "UL" ? this.docbdy : this.docbdy.children("ol,ul");
            if ((this.model.allowGrouping || this.itemsContainer.find(">.e-category").length > 0) && !this.model.enableSorting) {
                this.popupListWrapper.addClass("e-atc-popup");
                for (var k = 0; k < this.itemsContainer.find(">.e-category").length; k++) {
                    var ele = this.itemsContainer.find(">.e-category").eq(k);
                    ele.replaceWith($("<li>").text(ele.text()).addClass("e-category"));
                }
            }
            else if (this.model.enableSorting) this._setSortingList();
            this.itemsContainer.children("ol,ul").remove();
            this.items = this.itemsContainer.children('li');
            this.items.children("img,div").addClass("e-align");
            this._listItem([]);
            for (var i = 0; i < this.items.length; i++) {
                var fieldText = $(this.items[i]).text(), fieldValue = this._getAttributeValue(this.items[i]);
                if(!$(this.items[i]).attr("data-value")) $(this.items[i]).attr("data-value", fieldValue ? fieldValue : fieldText);
                this._listItem({ text: fieldText, value: fieldValue ? fieldValue : fieldText }, "add");
            }
            //This will append the list with the popup wrapper
            this.ultag.empty().append(this.itemsContainer.children());
			this.ultag.children('li').attr("role", "option").attr("unselectable", "on");		
            this.docbdy.css({ 'display': 'none' }).children("ol,ul").remove();
        },
        _plainArrayTypeBinding: function (list) {
            this.dummyUl = $();
            if (this.model.enableSorting) {
                list.sort();
                if (this.model.sortOrder == "descending") list.reverse();
            }
            if (list.length > 0) {
                for (var i = 0; i < list.length; i++) {
                    if (!ej.isNullOrUndefined(list[i])) {
                        var litag = ej.buildTag("li", list[i], {}, { 'data-value': list[i], "unselectable": "on" });
                        this.dummyUl.push(litag[0]);
                    }
                }
                this.ultag.append(this.dummyUl);
                this._trigger('dataBound', { data: list });
            }

        },
        _mapFields: function () {
            this.model.fields.groupBy = this.model.fields.groupBy ? this.model.fields.groupBy : this.model.fields.category;
            var mapper = this.model.fields;
            this.mapFld = { _id: null, _imageUrl: null, _imageAttributes: null, _spriteCSS: null, _text: null, _value: null, _htmlAttributes: null, _selected: null };
            this.mapFld._id = (mapper && mapper.id) ? mapper["id"] : "id";
            this.mapFld._imageUrl = (mapper && mapper.imageUrl) ? mapper["imageUrl"] : "imageUrl";
            this.mapFld._imageAttributes = (mapper && mapper.imageAttributes) ? mapper["imageAttributes"] : "imageAttributes";
            this.mapFld._spriteCSS = (mapper && mapper.spriteCssClass) ? mapper["spriteCssClass"] : "spriteCssClass";
            this.mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
            this.mapFld._value = (mapper && mapper.value) ? mapper["value"] : "value";
            this.mapFld._htmlAttributes = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
            this.mapFld._selected = (mapper && mapper.selected) ? mapper["selected"] : "selected";
            this.mapFld._category = (mapper && mapper.groupBy) ? mapper["groupBy"] : "groupBy";
        },
        _doDataBind: function () {
            var source = this.model.dataSource, list = this.popupListItems;
            !source || !list || !list.length || list.length < 1 ? this._targetElementBinding()
            : this._isPlainType(list) ? this._plainArrayTypeBinding(list)
            : this._objectArrayTypeBinding(list);
        },
        _isPlainType: function (list) {
            return typeof list[0] != "object";
        },
        _objectArrayTypeBinding: function (list, from) {
            this.dummyUl = $();
            this._mapFields();
            if (this.model.enableSorting) {
                var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                list = ej.DataManager(list).executeLocal(sortQuery);
				this.popupListItems = list;
            }
            if (this.model.allowGrouping || this.model.fields.groupBy) {
                this.popupListWrapper.addClass("e-atc-popup");
                var mapCateg = this.mapFld._category, groupedList, groupQuery;
                groupQuery = ej.Query().group(mapCateg);
                if (!this.model.enableSorting) groupQuery.queries.splice(0, 1);
                groupedList = ej.DataManager(list).executeLocal(groupQuery);
                this._swapUnCategorized(groupedList);
                (from == "search") ? this.popupListItems = [] : this._listItem([]);
                for (var i = 0; i < groupedList.length; i++) {
                    if (groupedList[i].key)
                        this.ultag.append(ej.buildTag("li.e-category", groupedList[i].key).attr("role", "option")[0]);
                    this._generateLi(groupedList[i].items, this.mapFld);
                    this.ultag.append(this.dummyUl);
                    for (var j = 0; j < groupedList[i].items.length; j++) {
                        (from == "search") ? this.popupListItems.push(groupedList[i].items[j]) : this._listItem(groupedList[i].items[j], "add");
                    }
                }
            }
            else {
                this._generateLi(list, this.mapFld);
                this.ultag.append(this.dummyUl);//ko binding
            }
            this._trigger('dataBound', { data: list });
        },
        _onScroll: function (e) {
            if (!e.scrollTop) return;
            var scrollerPositon = e.scrollTop, proxy = this;
            if (proxy.model.allowVirtualScrolling && proxy.model.virtualScrollMode == "continuous") {
                var list, queryPromise, skipQuery = ej.Query().skip(proxy._rawList.length).take(proxy.model.itemsCount).clone();
                if (scrollerPositon >= Math.round($(proxy.popupList).find("ul,ol").height() - $(proxy.popupList).height()) && proxy._rawList.length < proxy._totalCount) {
                    proxy._addLoadingClass();
                    if (ej.DataManager && proxy.model.dataSource instanceof ej.DataManager) {
                        skipQuery = proxy._getQuery().skip(proxy._rawList.length).take(proxy.model.itemsCount).clone();
                        if (!proxy._trigger("actionBegin", { requestFrom: "scroll" })) {
                            queryPromise = proxy.model.dataSource.executeQuery(skipQuery);
                            queryPromise.done(function (e) {
                                proxy.addItem(e.result);
                                proxy._removeLoadingClass();
                                proxy._trigger("actionSuccess", { e: e, requestFrom: "scroll" });
                            }).fail(function () {
                                proxy.model.dataSource = null;
                                proxy._removeLoadingClass();
                                proxy._trigger("actionFailure", { e: e, requestFrom: "scroll" });
                            }).always(function (e) {
                                proxy._trigger("actionComplete", { e: e, requestFrom: "scroll" });
                            });
                        }
                    } else {
                        list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                        proxy.addItem(list);
                        proxy._removeLoadingClass();
                    }
                }
            } else if (proxy.model.allowVirtualScrolling && proxy.model.virtualScrollMode == "normal") {

                window.setTimeout(function () {
                    if (proxy._virtualCount == 0) {
                        proxy._loadList();
                    }
                }, 300);

            }

        },
        _loadList: function () {
            this._virtualCount++;
            var top = this.scrollerObj.scrollTop(), proxy = this, prevIndex = 0, prevPageLoad, nextIndex = null;
            this._currentPage = Math.round(top / (29 * this.model.itemsCount));
            if (($.inArray(this._currentPage, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) {
                if (this._currentPage == 0) {
                    if (($.inArray(this._currentPage + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPage = this._currentPage + 1;
                    }
                }
                else if (($.inArray(this._currentPage - 1, this._virtualPages)) != -1) {
                    if (($.inArray(this._currentPage + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPage = this._currentPage + 1;
                    }
                }
                else {
                    this._currentPage = this._currentPage - 1;
                }
            }
            prevPageLoad = !($.inArray(this._currentPage - 1, this._virtualPages) != -1);
            this._addLoadingClass();
            for (var i = this._virtualPages.length - 1; i >= 0; i--) {
                if (this._virtualPages[i] < this._currentPage) {
                    prevIndex = this._virtualPages[i];
                    if (!(i + 1 == this._virtualPages.length))
                        nextIndex = this._virtualPages[i + 1];
                    break;
                }
            }

            var firstArg = prevPageLoad ? (this._currentPage - 1) * this.model.itemsCount : this._currentPage * this.model.itemsCount;
            var skipQuery = ej.Query().range(firstArg, this._currentPage * this.model.itemsCount + this.model.itemsCount), queryPromise, list;
            if (ej.DataManager && proxy.model.dataSource instanceof ej.DataManager) {
                var skipParam = prevPageLoad ? (this._currentPage - 1) * this.model.itemsCount : this._currentPage * this.model.itemsCount;
                skipQuery = this._getQuery().skip(skipParam);
                if (prevPageLoad) {
                    for (i = 0; i < skipQuery.queries.length; i++) {
                        if (skipQuery.queries[i].fn == "onTake") {
                            skipQuery.queries.splice(i, 1);
                            break;
                        }
                    }
                    skipQuery.take(2 * this.model.itemsCount);
                }
                if (!proxy._trigger("actionBegin", { requestFrom: "scroll" })) {
                    queryPromise = proxy.model.dataSource.executeQuery(skipQuery);
                    queryPromise.done(function (e) {
                        proxy._appendVirtualList(e.result, prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                        proxy._removeLoadingClass();
                        proxy._trigger("actionSuccess", { e: e, requestFrom: "scroll" });
                    }).fail(function () {
                        proxy._virtualCount--;
                        proxy._removeLoadingClass();
                        proxy._trigger("actionFailure", { e: e, requestFrom: "scroll" });
                    }).always(function (e) {
                        proxy._trigger("actionComplete", { e: e, requestFrom: "scroll" });
                    });
                }
            } else {

                list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                this._appendVirtualList(list, prevIndex, this._currentPage, nextIndex, prevPageLoad);
                proxy._removeLoadingClass();
            }
        },
        _appendVirtualList: function (list, prevIndex, currentIndex, nextIndex, prevPageLoad) {
            this._virtualCount--;
            if (($.inArray(currentIndex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) return false;
            if (prevPageLoad && ($.inArray(currentIndex - 1, this._virtualPages.sort()) != -1)) {
                list.splice(0, this.model.itemsCount);
                prevPageLoad = false;
            }
            var items = this.model.itemsCount, tempUl = $("<ul>"), firstVirtualHeight, secondVirtualHeight;
            firstVirtualHeight = prevPageLoad ? ((currentIndex - 1) * items * 29) - (prevIndex * items + items) * 29 : (currentIndex * items * 29) - (prevIndex * items + items) * 29;
            if (firstVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: firstVirtualHeight }));
            this._mapFields();
            this._generateLi(list, this.mapFld);
            $(this.dummyUl).attr("page", currentIndex);
            if (prevPageLoad) {
                $(this.dummyUl).slice(0, items).attr("page", currentIndex - 1);
            }
            if (this.model.showCheckbox) {
                this._appendCheckbox(this.dummyUl);
            }
            tempUl.append(this.dummyUl);
            secondVirtualHeight = (currentIndex * items + items) * 29;
            if (nextIndex != null) secondVirtualHeight = (nextIndex * items * 29) - secondVirtualHeight;
            else secondVirtualHeight = this.ultag.height() - secondVirtualHeight;
            if (secondVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: secondVirtualHeight }));
            var selector = this.ultag.find("li[page=" + prevIndex + "]").last();
            selector.next().remove();
            tempUl.children().insertAfter(selector);
            this._virtualPages.push(currentIndex);
            if (prevPageLoad) this._virtualPages.push(currentIndex - 1);
            for (var i = 0; i < list.length; i++) {
                this._listItem(list[i], "add");
            }
            this._virtualUl = this.ultag.clone(true);
            this._renderBoxModel();
        },

        _generateLi: function (list, mapFld) {
            this.mapFld = mapFld;
            this.dummyUl = [];
            if (!list || !list.length || list.length < 1) return false;
            for (var i = 0; i < list.length; i++) {
                var _did = this._getField(list[i], this.mapFld._id),
                    _dimageUrl = this._getField(list[i], this.mapFld._imageUrl),
                    _dimageAttributes = this._getField(list[i], this.mapFld._imageAttributes),
                    _dspriteCss = this._getField(list[i], this.mapFld._spriteCSS),
                    _dtext = this._getField(list[i], this.mapFld._text),
                    _dvalue = this._getField(list[i], this.mapFld._value),
                    _dhtmlAttributes = this._getField(list[i], this.mapFld._htmlAttributes),
                    _dselected = this._getField(list[i], this.mapFld._selected),
                    litag = document.createElement("li");

                if (!ej.isNullOrUndefined(_dvalue) && _dvalue.toString().length > 0) {
                    litag.setAttribute('data-value', typeof _dvalue == "object" ? JSON.stringify(_dvalue) : _dvalue);
                }
                else {
                     litag.setAttribute('data-value', _dtext);
                }
                if (!ej.isNullOrUndefined(_did) && (_did !== ""))
                    litag.setAttribute('id', _did);
                if (!ej.isNullOrUndefined(_dhtmlAttributes) && (_dhtmlAttributes != "")) {
                    this._setAttr(litag, _dhtmlAttributes);
                }

                if (this.model.template) {
                    $(litag).append(this._getTemplatedString(list[i]));
                } else {
                    if (!ej.isNullOrUndefined(_dimageUrl) && (_dimageUrl != "")) {
                        var imgtag = document.createElement("img");
                        this._setClass(imgtag, "e-align")._setAttr(imgtag, { 'src': _dimageUrl, 'alt': _dtext });
                        if ((_dimageAttributes) && (_dimageAttributes != "")) {
                            this._setAttr(imgtag, _dimageAttributes);
                        }
                        litag.appendChild(imgtag);
                    }
                    if (!ej.isNullOrUndefined(_dspriteCss) && (_dspriteCss != "")) {
                        var divtag = document.createElement("div");
                        this._setClass(divtag, 'div.e-align ' + _dspriteCss + ' sprite-image');
                        litag.appendChild(divtag);
                    }
                    if (_dselected) {
                        this._setClass(litag, "chkselect");
                    }
                    {
                        if (ej.isNullOrUndefined(_dtext)) _dtext = String(_dtext);
                        var textEle = document.createElement("span");
                        textEle.innerHTML = _dtext;                      
                        this._setClass(textEle, "e-ddltxt");
                        litag.innerHTML += textEle.outerHTML;
                    }
                }
                this._setAttr(litag, { "role": "option", "unselectable": "on" });
                this.dummyUl.push(litag);
             
            }
        },

        _setAttr: function (element, attrs) {
            if (typeof attrs == "string") {
                var sAttr = attrs.replace(/['"]/g, "").split("=");
                if (sAttr.length == 2) element.setAttribute(sAttr[0], sAttr[1]);
            }
            else {
                for (var idx in attrs) {
                    if ((idx == 'styles' || idx == 'style') && typeof attrs[idx] == 'object') {
                        for (var prop in attrs[idx]) {
                            element.style[prop] = attrs[idx][prop];
                        }
                    }
                    else
                        element.setAttribute(idx, attrs[idx]);
                }
            }
            return this;
        },
        _setClass: function (element, classNme) {
            element.className += " " + classNme;
            return this;
        },
        _removeClass: function (element, classNme) {
            var index = element.className.indexOf(classNme);
            if (index >= 0) {
                if (index != 0 && element.className[index - 1] === " ")
                    element.className = element.className.replace(" " + classNme, "");
                else element.className = element.className.replace(classNme, "");
            }
            return this;
        },
        _hasClass: function (element, classNme) {
            return element.className.indexOf(classNme) >= 0;
        },
        _swapUnCategorized: function (list) {
            $(list).each(function (i, obj) {
                if (!obj.key) {
                    for (var j = i; j > 0; j--) {
                        list[j] = list[j - 1];
                    }
                    list[j] = obj;
                    return false;
                }
            });
        },

        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },

        _getTemplatedString: function (list) {

            var str = this.model.template, start = str.indexOf("${"), end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                str = str.replace(content, this._getField(list, field));
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },

        _setWatermark: function () {
            if ((this.element.val() == "") && this._trim(this._visibleInput.val()) == "") {
				var watermark=(this.model.watermarkText != null)? this.model.watermarkText:this._localizedLabels.watermarkText;
                if (this._isWatermark)
                    this._visibleInput.attr("placeholder", watermark);
                else
                    this._hiddenSpan.css("display", "block").text(watermark);
                //In visual mode, to show watermark text when no items selected.
                if (this.model.multiSelectMode == "visualmode" && this._ulBox && this._ulBox.find('li').length == 0) this._swapUlandInput(false);
            }
        },

        _checkboxHideShow: function (value) {
            if (value) {
                this.listitems = this._getLi();
                var chklist = this.listitems.find('input[type=checkbox]');
                if (chklist.length == 0) {
                    this._appendCheckbox(this.listitems);
                }
            }

            else
                this._removeCheck(this.popupList);
            this.model.showCheckbox = value;
			this._virtualUl = this.ultag.clone(true);
        },
        
        _setCheckAll: function (value) {
            if (!this._isSingleSelect() && (value))
                this.checkAll();
            else this.model.checkAll = false;
        },
        _setUncheckAll: function (value) {
            if (!this._isSingleSelect() && (value))
                this.uncheckAll();
            else this.model.uncheckAll = false;
        },

        checkAll: function () {
            var _nodes = this._selectedIndices, isAlreadySelected = false;
            this._mapFields();
            this.listitems = this._getLi();
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            if (!this._isSingleSelect()) {
                for (var i = 0; i < this.listitems.length; i++) {
                    this._currentText = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    this._hiddenValue = this._getAttributeValue(this.listitems[i]) || this._currentText;
                    if(!this._checkContains(this._hiddenValue))
                    if (this.model.showCheckbox) {
                        var checkboxWrap = $(this.listitems[i]).children(".e-checkwrap")[0];
                        if (checkboxWrap && !this._isChecked(checkboxWrap)) {
                            this._setClass(checkboxWrap, "e-check-act");
							this._setAttr(checkboxWrap,{"aria-checked":true});
                            checkboxWrap.firstChild.checked = true;
                            isAlreadySelected = false;
                        }
                        else isAlreadySelected = true;
                    }
                    else {
                        isAlreadySelected = false;
                        $(this.listitems[i]).addClass("e-active");
                    }
                    else isAlreadySelected = true;
                    
                    if (!isAlreadySelected) {
						this.checkedStatus = true;
                        this._itemID = $(this.listitems[i]).attr("id");
                        if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "")
                            this._selectedItemsID.push(this._itemID);
                        this._createListHidden(this._hiddenValue);
                        if (this.model.multiSelectMode == "visualmode") {
                            this._ulBox.append(this._createBox(this._currentText,this._hiddenValue));
                            if (this._isPopupShown()) this._setListPosition();
                        }
                        this._addText(this._currentText);
                        if ($.inArray(i, _nodes) == -1) {
                            this._selectedIndices.push(i);
                            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        }
                        this._selectedValue = this._getAttributeValue(this.listitems[i]) || "";
                        if (!this._initValue)
                            this._trigger('checkChange', { isChecked: this.checkedStatus, data: this.model });
                        args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: i, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus };
                        this._updateValue(this.element.val());
                        this._updateText();
                        if (!this._initValue)
                            this._trigger("change", args);
                        this._activeItem = i;
                        this.activeItem = this._getActiveItem();
                        this._cascadeAction();
                    }
                }
                this.model.itemValue = this._selectedValue;
                this.model.uncheckAll = false;
                this.model.checkAll = true;
                this._activeItem = -1;
                this._setWatermark();
            }
        },
        _createListHidden: function (value) {
            var arrayHidden = document.createElement("input");
            this._setAttr(arrayHidden, { type: "hidden", name: this._name, value: value, id: "#" + value });
            this.container.append(arrayHidden);
            $(this.element).attr("name", "hiddenEle");
        },
        _removeListHidden: function (value) {
            var arrayEle = this.container.find("[id='#" + value + "']");
            $(arrayEle).remove();
        },
        _getAttributeValue: function (val) {
            return val ? val.getAttribute("data-value") || val.getAttribute("value") : null;
        },
       
        _selectCheckedItem: function (chkitems) {
            for (var i = 0; i < chkitems.length; i++) {
                this._activeItem = chkitems[i];
                this._enterTextBoxValue();
            }
        },

        /* will deprecate with uncheckAll method */
        unCheckAll: function () { this.uncheckAll(); },

        uncheckAll: function () {
            var isAlreadySelected = false;
            this.listitems = this._getLi();
            this._mapFields();
            if (!this._isSingleSelect()) {
                for (var i = 0; i < this.listitems.length; i++) {
                    this._currentText = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    this._hiddenValue = this._getAttributeValue(this.listitems[i]) || this._currentText;
                    if(this._checkContains(this._hiddenValue))
                    if (this.model.showCheckbox) {
                        var checkboxWrap = $(this.listitems[i]).children(".e-checkwrap")[0];
                        if (checkboxWrap && this._isChecked(checkboxWrap)) {
                            this._removeClass(checkboxWrap, "e-check-act");
							this._setAttr(checkboxWrap,{"aria-checked":false});
                            checkboxWrap.firstChild.checked = false;
                            isAlreadySelected = true;
                        }
                        else isAlreadySelected = false;
                    }
                    else {
                        $(this.listitems[i]).removeClass("e-active");
                        isAlreadySelected = true;
                    }
                    else isAlreadySelected = false;
                    
                    if (isAlreadySelected) {
                        this.checkedStatus = false;
                        this._activeItem = i;
                        this.activeItem = this._getActiveItem();
                        this._removeText(this._hiddenValue);
                        this._removeListHidden(this._hiddenValue);
                        var _nodes = this._selectedIndices;
                        if ($.inArray(i, _nodes) > -1) {
                            this._selectedIndices.splice($.inArray(i, _nodes), 1);
                            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        }
                        this._selectedValue = this._getAttributeValue(this.listitems[i]) || "";
                        this._itemID = $(this.listitems[i]).attr("id");
                        if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "")
                            this._removeSelectedItemsID();
                        if (!this._initValue)
                            this._trigger('checkChange', { isChecked: this.checkedStatus, data: this.model });
                        args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: i, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus };
                        this._updateValue(this.element.val());
                        this._updateText();
                        if (!this._initValue)
                            this._trigger("change", args);
                        this._cascadeAction();
                        if (this.model.multiSelectMode == "visualmode") {
                            this._deleteBoxCheck(this._hiddenValue);
                            if (this._isPopupShown())
                                this._setListPosition();
                        }
                    }
                    
                }
                this.model.itemValue = this._selectedValue;
                this.model.checkAll = false;
                this.model.uncheckAll = true;
                this._setWatermark();
                this._activeItem = -1;
            }

        },
        _removeSelectedItemsID: function () {
            var itemToRemove;
            itemToRemove = this._selectedItemsID.indexOf(this._itemID);
            this._selectedItemsID.splice(itemToRemove, 1);
            this._itemID = "";
        },


        _refreshScroller: function () {
            if (!this.model.enablePopupResize) { // to set popup height as per the no.of list items
                this.popupList.css("height", "auto");
                this.popupListWrapper.css("height", "auto");
            }
            this.popupList.find(".e-content, .e-vhandle").removeAttr("style");
            this.popupList.find(".e-vhandle div").removeAttr("style");
            this.popupList.children(".e-content").removeClass("e-content");
            var flag = this._isPopupShown();
            this.popupListWrapper.css("display", "block");
            this.popupList.css({ "display": "block" });  // For get the height of the popup
            this.scrollerObj.model.height = Math.ceil(this._getPopupHeight());
            this.scrollerObj.refresh();
            if (!this.model.enablePopupResize) { // to set popup height as per the no.of list items
                this.popupList.css("height", "auto");
                this.popupListWrapper.css("height", "auto");
            }
            this.scrollerObj.option("scrollTop", 0);
            if (!flag) this.popupListWrapper.css("display", "none");
        },
        _enablePopupResize: function () {
            if (this.model.enablePopupResize) {
                this.popupListWrapper.addClass("e-resizable").append(ej.buildTag("div.e-resizebar").append(ej.buildTag("div.e-icon e-resize-handle")))
                .find(".e-resize-handle").addClass((this.model.enableRTL) ? "e-rtl-resize" : "");
                this._resizePopup();
            }
        },


        _resizePopup: function () {
            var proxy = this, started = false;
            this.popupListWrapper.find("div.e-resize-handle").ejResizable(
                {
                    minHeight: proxy._validatePixelData(proxy.model.minPopupHeight),
                    minWidth:  proxy._validatePixelData(proxy.model.minPopupWidth),
                    maxHeight: proxy._validatePixelData(proxy.model.maxPopupHeight),
                    maxWidth:  proxy._validatePixelData(proxy.model.maxPopupWidth),
                    handle: "e-ddl-popup",
                    resizeStart: function (event) {
                        if (!proxy.model.enabled)
                            return false;
                        !started && proxy._trigger("popupResizeStart", { event: event });
                        started = true;
                    },
                    resize: function (event) {
                        var reElement = $(event.element).parents("div.e-ddl-popup");
                        proxy._refreshPopupOnResize($(reElement).outerHeight(), $(reElement).outerWidth());
                        proxy._trigger("popupResize", { event: event });
                    },
                    resizeStop: function (event) {
                        if (started) {
                            proxy._refreshPopupOnResize(proxy.model.popupHeight, proxy.model.popupWidth);
                            started && proxy._trigger("popupResizeStop", { event: event });
                            started = false;
                        }
                    },
                    helper: function (event) {
                        var reElement = $(event.element).parents("div.e-ddl-popup");
                        proxy._refreshPopupOnResize($(reElement).outerHeight(), $(reElement).outerWidth());
                        return $(proxy.popupListWrapper);
                    }
                });
        },

        _refreshPopupOnResize: function (currHeight, currWidth) {
            if (currHeight) this.model.popupHeight = currHeight;
            if (currWidth) this.model.popupWidth = currWidth;
            this.popupListWrapper.css({ "height": this._validatePixelData(this.model.popupHeight), "min-height": this._validatePixelData(this.model.minPopupHeight), "max-height": this._validatePixelData(this.model.maxPopupHeight) });
            this._setListWidth();
            this._refreshScroller();
        },

        _setListWidth: function () {
            var width = this.model.popupWidth;
            if (width != "auto") this.popupListWrapper.css({ "width": width });
            else this.popupListWrapper.css({ "min-width": this._validatePixelData(this.model.minPopupWidth) });
            this.popupListWrapper.css({ "max-width": this._validatePixelData(this.model.maxPopupWidth) });
        },

        _setListHeight: function () {
            if (this.model.enablePopupResize && this.model.enableFilterSearch && this.model.minPopupHeight && this.model.minPopupHeight.toString().indexOf("%") <0 && this._validatePixelData(this.model.minPopupHeight) == 20)
                this.model.minPopupHeight = '65'; /* adding default height of search box*/
            this.model.enablePopupResize ? this.popupListWrapper.css({ "min-height": this._validatePixelData(this.model.minPopupHeight), "max-height": this._validatePixelData(this.model.maxPopupHeight), "height": this._validatePixelData(this.model.popupHeight) }) :
            this.popupListWrapper.css({ "max-height": this._validatePixelData(this.model.popupHeight), "min-height": this._validatePixelData(this.model.minPopupHeight) });
        },
		_validatePixelData: function (data) {			
			return (data && !isNaN(data))? Number(data):data;
		},
        _getPopupHeight: function () {
            var wrap = this.popupListWrapper.height();
            if (this.model.enablePopupResize) wrap -= this.popupListWrapper.find(">div.e-resizebar").height();
            if (this.model.headerTemplate && this.headerTemplate) wrap -= this.headerTemplate.height();
            if (this.model.enableFilterSearch && this.inputSearch) {
                var ele = this.inputSearch.parent(".e-in-wrap");
                wrap -= (parseInt(ele.css("height")) + parseInt(ele.css('margin-top')) + parseInt(ele.css('margin-bottom')));
            }
            return wrap;
        },

        _refreshPopup: function () {
            if (this.model.popupWidth == "auto" && !this._validatePixelData(this.model.minPopupWidth)) this.popupListWrapper.css({ "min-width": this.wrapper.width() });
			else if(this._validatePixelData(this.model.minPopupWidth))this.popupListWrapper.css({ "min-width": this._validatePixelData(this.model.minPopupWidth) });
            if(this.scrollerObj != undefined) this._refreshScroller();
            this._setListPosition();
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupListWrapper.outerHeight(),
            popupWidth = this.popupListWrapper.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupListWrapper.outerWidth() - elementObj.outerWidth();
            this.popupListWrapper.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });

        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupListWrapper);
        },


        _showResult: function () {
            var proxy = this;
            var args = { text: this._visibleInput[0].value, value: this._selectedValue, refreshPopup: true };
            if (this._trigger("beforePopupShown", args)) return;
            if (args.refreshPopup) this._refreshPopup();
            $(this.popupListWrapper).slideDown(this.model.enableAnimation ? 200 : 1, function () {
                $(document).on("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
                proxy._on(ej.getScrollableParents(proxy.wrapper), "scroll", proxy._hideResult);
            });
            this.element[0].setAttribute("aria-expanded", true);
            this._listSize =  this._getLi().length;
            this.wrapper.addClass("e-popactive");
            this._trigger("popupShown", { text: this._visibleInput[0].value, value: this._selectedValue });
            this.scrollerObj.setModel({ scrollTop: this._calcScrollTop('active') });
        },

        _OnWindowResize: function (e) {
            if (!ej.isNullOrUndefined(this.model) && this._isPopupShown()) {
                this._refreshPopup();
            }
        },
        _hideResult: function (e) {
            if (this.model && this._isPopupShown()) {
				if (!ej.isNullOrUndefined(e) && !ej.isNullOrUndefined(this.inputSearch) && $(this.inputSearch).is(":focus")){
					if(e.type == "scroll" && ej.isTouchDevice())
						return false;
				}
                var proxy = this;
                if (this._trigger("beforePopupHide", { text: this._visibleInput[0].value, value: this._selectedValue })) return;
                $(this.popupListWrapper).slideUp(this.model.enableAnimation ? 100 : 0, function () {
                    $(document).off("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
                });
                if (this.element != null)
                    this.element.attr( "aria-expanded", false );
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
                if (this._visibleInput != null)
                this.wrapper.removeClass("e-popactive");
                    this._trigger("popupHide", { text: this._visibleInput[0].value, value: this._selectedValue });

                setTimeout(function () {
                    proxy._resetSearch();                 
                }, 100);
				this._getLi().find(".e-ddl-anim").removeClass("e-ddl-anim");
            }
        },

        _isPopupShown: function () {
            return (this.popupListWrapper.css("display") == "block");
        },

        _enterTextBoxValue: function () {
            var args, valueModified = true;
            this.removeID = false;
			this.checkedStatus = false;
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this._chooseSelectionType();
			if (this._activeItem >=0 || this._activeItem != null) {
				if (this.model.showCheckbox) {
					var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
					$(checkboxEle).removeClass('e-check-inact');
					this.checkedStatus = this._isChecked(checkboxEle);                   
				}
				else{
					this.checkedStatus = this.activeItem.hasClass('e-active')
				}            
			}
            args = { text: this._currentText, selectedText: this._currentText, itemId: this.selectedIndexValue, value: this._selectedValue, isChecked: this.checkedStatus, isInteraction: !!this._uiInteract };
            if (!this._initValue && !this._onSearch && this._raiseEvents){ 
                if(this._trigger("select", args)) {
                    this._setWatermark();
                    return;
                }
            }
            if (this._activeItem >=0 || this._activeItem != null) {
                if (!this._isSingleSelect() && !this._checkContains(this._selectedValue)) {                   
                    if (this.model.showCheckbox) {
                        var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
                        if (!this._isChecked(checkboxEle)) {
							this._removeClass(checkboxEle, "e-ddl-anim");	
                            this._setClass(checkboxEle, "e-check-act e-ddl-anim");
                            this._setAttr(checkboxEle,{"aria-checked":true});
                            $(checkboxEle).find(".e-check-input")[0].checked = true;
                        }
                    }
                    else {
                        this.activeItem.addClass('e-active');
                    }
                    if (this.model.multiSelectMode == "visualmode") {
                        this._ulBox.append(this._createBox(this._currentText, this._selectedValue));
                        if (this._isPopupShown())
                            this._setListPosition();
                    }

                    this._maintainHiddenValue();
                    this._addText(this._currentText);
                    this._createListHidden(this._hiddenValue);
                    if ($.inArray(this.selectedIndexValue, this._selectedIndices) == -1) {
                        this._selectedIndices.push(this.selectedIndexValue);
                        this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                    }                
                } else if( this._isSingleSelect()){
                    this.ultag.children("li").removeClass('e-hover').removeClass('e-active');
                    this.activeItem.addClass('e-active');                    
                    this._maintainHiddenValue();
                    this._visibleInput.val(this._currentText);
                    this.element.val(this._hiddenValue);
                    this.selectedItemIndex(this.selectedIndexValue);
                    this.selectedIndex(this.selectedIndexValue);
                    this._selectedIndices[0] = this.selectedIndexValue;
                }
                else valueModified = false;
                if(valueModified) {
					this.checkedStatus = true;
                    this._onValueChange();
                    this._cascadeAction();
                    if (this.selectelement) {
                    if ($("#" + this._id).children().length > this.selectedIndexValue)
                        $("#" + this._id).children()[this.selectedIndexValue].selected = true;
                    }
                }
            }
            this.model.uncheckAll = false;
            this._setWatermark();
			this._uiInteract = false;
        },
        _onValueChange: function () {
            this.model.itemValue = this._selectedValue;
            this._updateText();
            if (this.value() != this.element.val() && !(this.value() == null && this.element.val() =="" )) {
                this._updateSelectedIndexByValue(this.element.val());
                this._updateValue(this.element.val());
				if (!this.model.showCheckbox && this.model.multiSelectMode == "none" && (this.model.value == null || this.model.value == "")){
					this.model.itemValue = "";
				}
                args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: this.selectedIndexValue, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus, isInteraction: !!this._uiInteract };

                if (!this._initValue && !this._onSearch && this._raiseEvents) {
                    this._trigger("change", args);
                    if (this.model.showCheckbox)
                        this._trigger('checkChange', { isChecked: this.checkedStatus, text: this._visibleInput.val(), itemId: this.selectedIndexValue, selectedText: this._currentText, selectedValue: this._selectedValue, value: this._selectedValue, data: this.model });
                }
                this._uiInteract = false;
            }
        },
        _decode: function (val) {
            return $("<span>").html(val).text();
        },
        _chooseSelectionType: function () {
            this.activeItem = this._getActiveItem();
            this.selectedIndexValue = this._activeItem;
            this._mapFields();
            if (this.model.dataSource != null && (!this._isPlainType(this.model.dataSource) || !this._isPlainType(this.popupListItems))) {
                this._currentText = this._decode(this._getField(this.popupListItems[this._activeItem], this.mapFld._text));
                this._currentText = (this._currentText === "" || this._currentText == null) ? this.activeItem.text() : this._currentText;
                this._selectedValue = this._getField(this.popupListItems[this._activeItem], this.mapFld._value);
                this._selectedValue = (this._selectedValue != null) ? this._selectedValue : this._currentText;
                this._itemID = this._getField(this.popupListItems[this._activeItem], this.mapFld._id);
            } else {
                this._currentText = this.activeItem.text();
                if (this._getAttributeValue(this.activeItem[0]))
                    this._selectedValue = this._getAttributeValue(this.activeItem[0]);
                else {
                    if (this._currentText != null) {
                        this.activeItem[0].setAttribute("value", this._currentText);
                        this._selectedValue = this._currentText;
                    }
                    else
                        this._selectedValue = "";
                }
                this._itemID = $(this.activeItem).attr("id");
            }
            if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "") {
                if (!this.model.showCheckbox) {
                    this._selectedItemsID = [];
                    !this.removeID && this._selectedItemsID.push(this._itemID);
                }
                else
                    !this.removeID ? this._selectedItemsID.push(this._itemID) : this._removeSelectedItemsID();
            }
            this.selectedTextValue = this._currentText;
        },
        _maintainHiddenValue: function () {
            this._hiddenValue = this._getAttributeValue(this.activeItem[0]) || this._currentText;
        },
        _removeTextBoxValue: function () {
            this._uiInteract = true;
            this.removeID = true;
			this.checkedStatus = true;
            this._chooseSelectionType();
			if (this._activeItem >=0 || this._activeItem != null) {
				if (this.model.showCheckbox) {
					var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
					$(checkboxEle).removeClass('e-ddl-anim').addClass('e-check-inact e-ddl-anim');
					this.checkedStatus = this._isChecked(checkboxEle);                   
				}
				else{
					this.checkedStatus = this.activeItem.hasClass('e-active')
				}            
			}			
            var args = { text: this._currentText, selectedText: this._currentText, itemId: this.selectedIndexValue, value: this._selectedValue, isChecked: this.checkedStatus };
            if (!this._initValue && !this._onSearch && this._raiseEvents){
                if(this._trigger("select", args)){
                    this._setWatermark();
                    return;
                }
            }                
            this._maintainHiddenValue();
            this._removeText(this._hiddenValue);
            this._removeListHidden(this._hiddenValue);
            this.activeItem.removeClass('e-active');
            if (!this._isSingleSelect()) {
                if (this.model.showCheckbox) {
                    var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
                    if (this._isChecked(checkboxEle)) {
                        this._removeClass(checkboxEle, "e-check-act");
						this._setAttr(checkboxEle,{"aria-checked":false});
                        $(checkboxEle).find(".e-check-input")[0].checked = true;
                    }
                }
                else this.activeItem.removeClass('e-active');

                if ($.inArray(this.selectedIndexValue, this._selectedIndices) > -1) {
                    this._selectedIndices.splice($.inArray(this.selectedIndexValue, this._selectedIndices), 1);
                    this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                }
                if (this.model.multiSelectMode == "visualmode") {
                    this._deleteBoxCheck(this._hiddenValue);
                    if (this._isPopupShown())
                        this._setListPosition();
                }
            }
			this.checkedStatus = false;            
            this._onValueChange();
            if ((this.model.cascadeTo != null) && !this._isSingleSelect() && !this._initValue ) this._cascadeAction();
            this.model.checkAll = false;
            this._setWatermark();
        },


        _createBox: function (text, value) {
            if (!this._checkContains(value)) {

                if (this._ulBox.css('display') == "none" && this._visibleInput.css('display') != "none") this._swapUlandInput(true);
                var span = ej.buildTag("span.e-icon e-close", "", {}, { "unselectable": "on" });
                var li = ej.buildTag("li.e-options").text(text).attr("data-value",value).append(span);
                this._on(span, "click", function (e) {
                    if (!this.model.enabled) return false;
                    this._deleteBox($(e.target).parent());                   
                });
                return li;
            }
        },
        _deleteBoxCheck: function (val) {
            var items = this._ulBox.children('li');
            for (var i = 0; i < items.length; i++) {
                if ($(items[i]).attr("data-value") == val) {
                    $(items[i]).remove();
                }
            }
        },
        _deleteLastBox: function () {
            var items = this._ulBox.children("li:not(.e-search-box)");
            var item = items.last();
            if (item.hasClass("e-active")) this._deleteBox(item);
            else {
                this._removeActive();
                item.addClass("e-active");
            }
        },
        _deleteBox: function (items) {
            for (var i = 0; i < items.length; i++) {              
                var deltext = $(items[i]).attr("data-value");
                var listItems = this._getLi();
                for (var j = 0; j < listItems.length; j++) {
                    if ($(listItems[j]).attr("data-value") == deltext) {
                        this._activeItem = j;
                        this._removeTextBoxValue();
                        break;
                    }
                }
            }
            if (!this._isFocused && !this._isPopupShown())
                this._setWatermark();
        },

        _swapUlandInput: function (inputHide) {
            if (inputHide) {
                this._visibleInput.css('display', 'none');
                this._ulBox.css('display', 'block');
                this.wrapper.css({ 'height': 'auto' });
            }
            else {
                this._visibleInput.css('display', 'block');
                this._ulBox.css('display', 'none');
                this.wrapper.css({ 'height': this.model.height });
            }
        },
        _removeActive: function () {
            this._ulBox.children("li").removeClass("e-active");
        },
        _adjustWidth: function () {
            var tempSpan = ej.buildTag("span", this._visibleInput.val());
            this.container.append(tempSpan);
            this._visibleInput.width(tempSpan.width() + 30);
            tempSpan.remove();
        },
        _destroyBoxModel: function () {
            this._visibleInput.css('display', 'block');
            this.wrapper.height(this.model.height);
            this._ulBox.remove();
			this._ulBox = null;
            this._off(this.container, "click");
        },

        _removeListHover: function () {
            this.ultag.children("li").removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = this._getActiveItem();
            activeItem.addClass("e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop('hover') });
            activeItem.focus();
        },
        _getLi: function () {
            return this.ultag.children("li:not('.e-category'):not('.e-nosuggestion')");
        },
        _calcScrollTop: function (val) {
            var ulH = this.ultag.outerHeight(), li = this.ultag.find("li"), liH = 0, index, top, i;
            if (this._selectedIndices && this._selectedIndices.length > 0 && val == "active") {
                var getLi = this._getLi();
                index = this._selectedIndices.length == getLi.length ? 0
                : this._selectedIndices[this._selectedIndices.length - 1];
                if (this.model.fields.groupBy != null || this.ultag.find("li.e-category").length > 0) {
                    index = $.inArray(getLi.eq(index)[0], li);
                }
            }
            else index = this.ultag.find("li.e-" + val).index();

            for (i = 0; i < index; i++) { liH += li.eq(i).outerHeight(true); }
            top = liH - ((this.popupList.outerHeight() - li.eq(index).outerHeight(true)) / 2);
            return top < 0 ? 0 : top;
        },
        _getActiveItem: function () {
            return this._getLi().eq(this._activeItem);
        },
        _setDimentions: function () {
            if (this.model.height)
                this.wrapper.height(this.model.height);
            if (this.model.width)
                this.wrapper.width(this.model.width);
        },


        _roundedCorner: function (val) {
            if (val) {
                this.container.addClass("e-corner");
                this.popupListWrapper.addClass("e-corner");
                if (this.inputSearch) this.inputSearch.parent('.e-in-wrap').addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                this.popupListWrapper.removeClass("e-corner");
                if (this.inputSearch) this.inputSearch.parent('.e-in-wrap').removeClass("e-corner");
            }

        },

        _enabled: function (boolean) {
            if (boolean) this.enable();
            else this.disable();
        },

        _destroyDropdown: function () {
            this.element.insertAfter(this.wrapper);
            this.element.width(this.element.width() + this.dropdownbutton.outerWidth());
            this.wrapper.remove();
            this.container.off("mousedown", $.proxy(this._OnDropdownClick, this));
        },


        _RightToLeft: function () {
            if (this.model.enableRTL) {
                this.wrapper.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
            }

        },
        _dropbtnRTL: function () {
            if (this.model.enableRTL) {
                this.popupListWrapper.addClass("e-rtl").find(".e-resize-handle").addClass("e-rtl-resize");
                this.popupList.addClass("e-rtl");
            }
            else {
                this.popupListWrapper.removeClass("e-rtl").find(".e-resize-handle").removeClass("e-rtl-resize");
                this.popupList.removeClass("e-rtl");
            }
        },
        _OnDropdownClick: function (e) {
            this._preventDefaultAction(e);
            if (($(e.target).is("li") && $(e.target).parent().hasClass("e-boxes")) || ($(e.target).parents("ul").hasClass("e-boxes") && $(e.target).hasClass("e-icon e-close")))
                return false;
            if (this.model.readOnly || this._readOnly) return false;
            if (this.ultag.find('li').length > 0 && ((e.which && e.which == 1 ) ||(e.button && e.button == 0) )) {
                this._OnPopupHideShow();
            }
        },
        _OnPopupHideShow: function () {
            if (this._isPopupShown()) {
                this._hideResult();
            }
            else {
				this._showResult();
				if (this.model.enableFilterSearch){
					if(this.getSelectedItem().length == 0)
						this.ultag.find("li:first").addClass("e-hover");
					else{
						var length = this.getSelectedItem().length;
						$(this.getSelectedItem()[length -1]).addClass("e-hover");
					}
                    this.inputSearch.focus();
				}
				else
					this.wrapper.focus();
            }
        },

        _showFullList: function () {
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (!source.dataSource.offline && !(source.dataSource.json && source.dataSource.json.length > 0)) {
                    var proxy = this;
                    proxy._initDataSource(source);
                }
                else this._getFilteredList(source.dataSource.json);
            }
            else this._getFilteredList(source);
        },
        _getFilteredList: function (list) {
            if (!list || !list.length || list.length < 1) {
                this._targetElementBinding();
                this._renderRemaining();
            }
            else {
                var listItem = ej.DataManager(list).executeLocal(this._isPlainType(list) ? ej.Query() : this._getQuery(true));
                this._totalCount = listItem.count;
                this._listItem(listItem.result ? listItem.result : listItem);
                this._renderPopupList();
                this._rawList =  this.popupListItems.slice();
            }
        },

        _cascadeAction: function () {
            if (this.model.cascadeTo) {
                var citem = this.model.cascadeTo.split(","), i;
                for (i = 0; i < citem.length; i++) {
                    if ($('#' + citem[i]).hasClass("e-dropdownlist")) {
                        this._doCascadeAction(citem[i], this, this.checkedStatus);
                    }
                    else {
                        $('#' + citem[i]).on("ejDropDownListcreate", { Obj: this, status: this.checkedStatus }, function (e) {
                            if (!ej.isNullOrUndefined(e.data.Obj.getValue()) && e.data.Obj.getValue() != "") {
                                e.data.Obj._doCascadeAction(this.id, e.data.Obj, e.data.status);
                            }
                        });
                    }
                }
            }
        },
        _doCascadeAction: function (id, parentObj, status) {
            parentObj._currentValue = parentObj._getField(parentObj.popupListItems[parentObj._activeItem], parentObj.mapFld._value);
            parentObj.selectDropObj = $('#' + id).ejDropDownList('instance');
            var args = { cascadeModel: parentObj.selectDropObj.model, cascadeValue: parentObj._currentValue, setCascadeModel:{}, requiresDefaultFilter: true };
            this._trigger("cascade", args);
            parentObj.selectDropObj._setCascadeModel = args.setCascadeModel;
            if (ej.isNullOrUndefined(parentObj[id])) {
                parentObj[id] = parentObj.selectDropObj.model.dataSource;
            }
            (ej.DataManager && parentObj[id] instanceof ej.DataManager) ?
                parentObj._cascadeOdataInit(parentObj[id], args.requiresDefaultFilter, status, args.cascadeQuery) :
            parentObj._cascadeJsonInit(parentObj.selectDropObj, parentObj[id], parentObj.mapFld._value, args.requiresDefaultFilter, status, args.cascadeQuery);
        },
        _cascadeOdataInit: function (_dSource, requiresFilter, status, cascadeQuery) {
            var proxy = this, queryPromise, tempQuery;
            proxy._dQuery = this.selectDropObj._getQuery().clone();
            tempQuery = proxy._dQuery.clone();
            requiresFilter ? tempQuery.where(proxy.mapFld._value, "equal", proxy._currentValue) : tempQuery = cascadeQuery;
            proxy.selectDropObj._addLoadingClass();
            if (!proxy._trigger("actionBegin", { requestFrom: "cascade" })) {
                queryPromise = _dSource.executeQuery(tempQuery);
                queryPromise.fail(function (e) {
                    proxy._changedSource = null;
                    proxy.selectDropObj.setModel({ dataSource: proxy._changedSource, enabled: false });
                    proxy._trigger("actionFailure", { e: e, requestFrom: "cascade" });
                }).done(function (e) {
                    proxy._trigger("actionSuccess", { e: e, requestFrom: "cascade" });
                    proxy._cascadeDataBind(proxy.selectDropObj, e.result, status);
                    proxy.selectDropObj._removeLoadingClass();
                }).always(function (e) {
                    proxy._trigger("actionComplete", { e: e, requestFrom: "cascade" });
                });
            }
        },

        _cascadeJsonInit: function (cascadeDropDownObj, _dSource, mapFld, requiresFilter, status, cascadeQuery) {           
            var tempQuery = requiresFilter ? ej.Query().where(mapFld, "==", this._currentValue) : cascadeQuery
            var changedSource = ej.DataManager(_dSource).executeLocal(tempQuery);
            this._cascadeDataBind(cascadeDropDownObj, changedSource, status);
        },

        _cascadeDataBind: function (cascadeDropDownObj, changedSource, status) {
			var cascadeVal  = cascadeDropDownObj.value();
            if ((this.model.showCheckbox && status) || (this.model.multiSelectMode != "none" && this.activeItem.hasClass("e-active"))) {
                this._changedSource = (!ej.isNullOrUndefined(this._changedSource)) ? this._changedSource.concat(changedSource) : changedSource;
            }
            else if (!this.model.showCheckbox && this.model.multiSelectMode == "none") this._changedSource = changedSource;
            else {
                for (var i = 0; i < changedSource.length; i++) {
                    if (this._isPlainType(changedSource) && this._isPlainType(this._changedSource)) this._changedSource.splice(this._changedSource.indexOf(changedSource[i]), 1);
                    else {
                        for (var j = 0; j < this._changedSource.length; j++) {
                            if (JSON.stringify(this._changedSource[j]) == JSON.stringify(changedSource[i]))
                                this._changedSource.splice(j, 1);
                        }

                    }
                }
                cascadeDropDownObj.setModel({ dataSource: null });
            }
            var cascadeModel = JSON.parse(JSON.stringify(cascadeDropDownObj.model)),enable;
            cascadeDropDownObj.setModel({ dataSource: this._changedSource, enabled: this._changedSource.length > 0 });
			if( !this._isSingleSelect() ) cascadeDropDownObj.selectItemByValue(cascadeVal);
            if (cascadeDropDownObj.model.showCheckbox || cascadeDropDownObj.model.multiSelectMode != "none") {
                $("input:hidden[id^='#'][name=" + cascadeDropDownObj._id + "]").remove();
            }
            
            if (!cascadeDropDownObj._setSelectedItem) {
                var selectProp = ["value", "text", "selectedIndex", "selectedIndices"];
                for (var m = 0; m < selectProp.length ; m++)
                    cascadeDropDownObj.model[selectProp[m]] = cascadeModel[selectProp[m]];
                cascadeDropDownObj._finalize();                
            }            
            else {                                               
               cascadeDropDownObj.setModel(cascadeDropDownObj._setCascadeModel);
            }
            cascadeDropDownObj._setSelectedItem = true;
        },        

        _OnMouseEnter: function (e) {
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            var targetEle;
            this.ultag.children("li").removeClass("e-hover");
            if ($(e.target).is("li:not('.e-category')")) { $(e.target).addClass("e-hover"); }
            if ($(e.target).hasClass("e-disable"))
                $(e.target).removeClass('e-hover');
            else if (e.target.tagName != "li") {
                targetEle = $(e.target).parents("li:not('.e-category')");
                $(targetEle).addClass("e-hover");
            }
            var activeItem;
            this.ultag.children("li:not('.e-category')").each(function (index) {
                if ($(this).hasClass("e-hover")) {
                    activeItem = index;
                    return false;
                }
            });
            this._activeItem = activeItem;
        },
        _OnMouseLeave: function (e) {
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            this.ultag.children("li").removeClass("e-hover");
        },
        _OnMouseClick: function (e) {
            this._uiInteract = true;
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            if (this.model.enableFilterSearch && $(e.target).is("li") && $(e.target).hasClass('e-nosuggestion')) return false;
            else if (($(e.target).is("li") && !$(e.target).hasClass('e-disable')) || (!$(e.target).is("li") && !$(e.target).closest("li").hasClass('e-disable'))) {
                if (this._isSingleSelect()) {
                    this._enterTextBoxValue();
                    this._hideResult();
                } else {
                    if (this.model.showCheckbox) {
                        var liEle = e.target.nodeName === "LI" ? e.target : $(e.target).parents("li.e-hover"),
                        checkboxEle = $(liEle).find('.e-checkwrap')[0];
                        this._onCheckChange({ target: checkboxEle });
                    }
                    else {
                        var ele = $(e.target).is("li") ? e.target : $(e.target).closest("li")[0];
                        this._activeItem = $.inArray(ele, this._getLi());
                        if ($(ele).hasClass("e-active")) this._removeTextBoxValue();
                        else this._enterTextBoxValue();
                    }
                   
                }
            }
        },        

        _OnDocumentClick: function (e) {
            if (this.model && (!this.model.enabled || this.model.readOnly || this._readOnly)) return false;
            if (!$(e.target).is(this.popupList) && !$(e.target).parents(".e-ddl-popup").is(this.popupListWrapper) &&
                !$(e.target).is(this._visibleInput) && !$(e.target).parents(".e-ddl").is(this.wrapper)) {
                this._hideResult();
            }
            else if ($(e.target).is(this.inputSearch)) {
                this.inputSearch.focus();
            }
            else if ($(e.target).is(this.popupList) || $(e.target).parents(".e-ddl-popup").is(this.popupListWrapper))
                this._preventDefaultAction(e);
        },

        _OnKeyPress: function (e) {
            if (this.model.enableIncrementalSearch && e.keyCode != 13) {
                this._OnTextEnter((ej.browserInfo().name == "mozilla") ? e.charCode : e.keyCode);
            }
            if (e.keyCode == 32) this._preventDefaultAction(e);
        },
        _OnTextEnter: function (from) {
            var proxy = this;
            this._incqueryString += String.fromCharCode(from);
            if (this._incqueryString.length > 0) {
                setTimeout(function () { proxy._incqueryString = ""; }, 1000);
            }
            var list = this._getLi(), i,
            caseSence = this.model.caseSensitiveSearch,            
            str, queryStr = this._incqueryString,
            querylength = this._incqueryString.length, searchflag = false;

            if (!caseSence) queryStr = queryStr.toLowerCase();

            for (i = 0; i < list.length; i++) {
                str = $(list[i]).text();
                str = caseSence ? str : str.toLowerCase();
                if (str.substr(0, querylength) == queryStr) {
                    this._activeItem = i;
                    if (this._isSingleSelect()){
						this._enterTextBoxValue();
						this.scrollerObj.setModel({ scrollTop: this._calcScrollTop('active') });
					}
                    else if (this._isPopupShown()) {
                        this._removeListHover();                      
                        this._addListHover();
                    } 
                    searchflag = true;
                }                 
                if (searchflag) break;
            }

        },

        _selectItem: function (current) {
            if (!this._isSingle) this._clearTextboxValue();
            this._activeItem = current;
            this._addListHover();
            this._enterTextBoxValue();
        },
        _focusItem: function (current) {
            this._removeListHover();
            this._activeItem = current;
            this._addListHover();
        },
        _selectFocusedItem: function (current) {
            this._focusItem(current);
            this._enterTextBoxValue();
        },
        
        _selectShiftDown: function (start, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            for (var n = start; n <= stop; n++) {
                if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                    this._selectFocusedItem(n);
                }
            }
        },
        _selectShiftUp: function (start, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            for (var n = stop; n >= start ; n--) {
                if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                    this._selectFocusedItem(n);
                }
            }
        },
        _selectShiftHome: function (current, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            if (current >= 0 && current <= this._listSize - 1) {
                if (current == 0) this._clearTextboxValue();
                else {
                    for (var n = current; n >= stop ; n--) {
                        if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                            this._activeItem = n;
                            this._enterTextBoxValue();
                        }
                    }
                }
                this._activeItem = current;
                if (current == 0) this._enterTextBoxValue();
                this.scrollerObj.setModel({ "scrollTop": 0 });
            }
        },
        _selectShiftEnd: function (current, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            if (current <= this._listSize - 1) {
                if (current == stop) this._clearTextboxValue();
                else 
                for (var n = current; n <= stop; n++) {
                    if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                        this._activeItem = n;
                        this._enterTextBoxValue();
                    }
                }
                this._activeItem = current;
                if (current == stop) this._enterTextBoxValue();
                this.scrollerObj.setModel({ "scrollTop": this.ultag.outerHeight() });
            }
        },


        _getLastFocusedLi: function () {
            return this._selectedIndices && this._selectedIndices.length > 0 ? this._selectedIndices[this._selectedIndices.length - 1] : null;
        },

        _getLastShiftFocusedLi: function (index, isDown) {
            var step = isDown ? index - 1 : index + 1;
            if ($.inArray(step, this._selectedIndices) < 0) {
                return index;
            }
            else {
                return this._getLastShiftFocusedLi(step, isDown);
            }
        },

        _shiftUp: function (current, step, isCtrl) {
            if (current == null || current < 0) {
                this._checkDisableStep(0, step, false, false, true);
            }
            else if (current > 0 && current <= this._listSize - 1) {

                var select = this._disableItemSelectUp(current - step)
                if (select != null) {
                    if (this._getLastFocusedLi() != null) {
                        if (this._selectedIndices.length > 1 && current - 1 == this._selectedIndices[this._selectedIndices.length - 2])
                            for (var s = 1; s <= step; s++) {
                                if (current - s == this._selectedIndices[this._selectedIndices.length - 2]) {
                                    this._activeItem = current + 1 -s;
                                    this._removeTextBoxValue();
                                    this._focusItem(current - s);
                                }
                                else break;
                            }
                        else {
                            var next = this._getLastShiftFocusedLi(this._getLastFocusedLi(), false);
                            this._selectShiftUp(select, next, isCtrl);
                        }
                    }
                    else {
                        this._moveUp(current, step, false);
                    }

                }

            }
        },

        _shiftDown: function (current, step, isCtrl) {
            if (current == null || current < 0) {
                this._checkDisableStep(-1, step, true, false, true);
            }
            else if (current < this._listSize - 1) {
                var select = this._disableItemSelectDown(current + step)
                if (select != null) {
                    if (this._getLastFocusedLi() != null) {
                        if (this._selectedIndices.length > 1 && current + 1 == this._selectedIndices[this._selectedIndices.length - 2]) {
                           for (var s = 1; s <= step; s++) {
                                if (current + s == this._selectedIndices[this._selectedIndices.length - 2]) {
                                    this._activeItem = current - 1 +s;
                                    this._removeTextBoxValue();
                                    this._focusItem(current + s);
                                }
                                else break;
                            }
                        }
                        else {
                            var start = this._getLastShiftFocusedLi(this._getLastFocusedLi(), true);
                            this._selectShiftDown(start, select, isCtrl);
                        }
                    }
                    else {
                        this._moveDown(current, step, false);
                    }
                }

            }
        },
        _moveUp: function (current, step, isMulti) {
            if (current == null || current <= 0) {
                this._checkDisableStep(0, step, false, isMulti);
            }
            else if (current > this._listSize - 1) {
                this._checkDisableStep(this._listSize - 1, step, false, isMulti);
            }
            else if (current > 0 && current <= this._listSize - 1) {
                this._checkDisableStep(current, step, false, isMulti);
            }
        },
        _moveDown: function (current, step, isMulti) {
            if (current == null || current < 0) {
                this._checkDisableStep(-1, step, true, isMulti);
            }
            else if (current == 0) {
                this._checkDisableStep(0, step, true, isMulti);
            }
            else if (current >= this._listSize - 1) {
                this._checkDisableStep(this._listSize - 1, step, true, isMulti);
            }
            else if (current < this._listSize - 1) {
                this._checkDisableStep(current, step, true, isMulti);
            }
        },
        _checkDisableStep: function (current, step, isdown, isMulti, shift) {
            var command = isdown ? "_disableItemSelectDown" : "_disableItemSelectUp";
            var index = isdown ? current + step : current - step;
            var select = this[command](index);
            if (select == null) {
                for (var i = step; i >= 0; i--) {
                    index = isdown ? current + i : current - i;
                    select = this[command](index);
                    if (select != null) break;
                }
            }
            if (select != null) {
                isMulti ? this._focusItem(select) : this._selectItem(select);
                if (shift && isMulti) this._enterTextBoxValue();
            }

        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) {
                    return current;
                }
                else {
                    return this._disableItemSelectDown(current + 1);
                }
            }
            else return this._listSize - 1;
        },

        _disableItemSelectUp: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) {
                    return current;
                }
                else {
                    if (current > 0) {
                        return this._disableItemSelectUp(current - 1);
                    }
                }
            }
        },

        _preventDefaultAction: function (e, stopBubble) {
            e.preventDefault ? e.preventDefault() : (e.returnValue = false);
            if (stopBubble) {
                e.stopPropagation ? e.stopPropagation() : (e.cancelBubble = true);
            }
        },

        _OnKeyDown: function (e) {
            this._uiInteract = true;
            if (this.model.enabled) {
                this._itemId = null;
                var _popupListItems = this._getLi(), liH, popupH, activeitem, flag;
                this._listSize = _popupListItems.length;                
                popupH = this.popupList.height();
                liH = this.ultag.children("li").outerHeight();
                activeitem = Math.round(popupH / liH) != 0 ? Math.round(popupH / liH) : 5;
                this._isSingle = this._isSingleSelect();
                if (this._isSingle) {
                    switch (e.keyCode) {
                        case 38: /* up arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._hideResult();
                                break;
                            }
                        case 33: /* page up */
                            var step = e.keyCode == 33 ? activeitem : 1;
                            this._moveUp(this._activeItem, step);
                            this._preventDefaultAction(e,true);
                            break;
					    case 8:
                            this._preventDefaultAction(e);
                            break;
                        case 40: /* down arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._showResult();
                                break;
                            }
                        case 34: /* page down */
                            var step = e.keyCode == 34 ? activeitem : 1;
                            this._moveDown(this._activeItem, step);
                            this._preventDefaultAction(e,true);
                            break;
                        case 37 /* left arrow*/:
                            if (this.model.enableRTL) this._moveDown(this._activeItem, 1);
                            else this._moveUp(this._activeItem, 1);
                            this._preventDefaultAction(e);
                            break;
                        case 39 /* right arrow */:
                            if (this.model.enableRTL) this._moveUp(this._activeItem, 1);
                            else this._moveDown(this._activeItem, 1);
                            this._preventDefaultAction(e);
                            break;
                        case 9 /* Tab */:
                        case 27 /*ESC*/:
                            if (this._isPopupShown()) this._hideResult();
                            break;
                        case 35 /*End*/:
                            this._moveDown(this._listSize - 1, 0);
                            this._preventDefaultAction(e);
                            break;
                        case 36 /*Home*/:
                            var step = this._activeItem != null ? this._activeItem : this._listSize - 1;
                            this._moveUp(step, step);
                            this._preventDefaultAction(e);
                            break;
                    }
                }
                else {
                    switch (e.keyCode) {
                        
                        case 38: /* up arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._hideResult();
                            }
                            else if (e.shiftKey) {
                                this._shiftUp(this._activeItem, 1, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, 1, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                        case 33: /* page up */
                            if (e.shiftKey) {
                                this._shiftUp(this._activeItem, activeitem, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, activeitem, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
						case 8:
                            this._preventDefaultAction(e);
                            break;
                        case 40: /* down arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._showResult();
                            }
                            else if (e.shiftKey) {
                                this._shiftDown(this._activeItem, 1, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, 1, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;

                        case 34: /* page down */

                            if (e.shiftKey) {
                                this._shiftDown(this._activeItem, activeitem, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, activeitem, e.ctrlKey);
                            this._preventDefaultAction(e);
                            break;
                        case 37 /* left arrow*/:
                            if (this.model.enableRTL) this._moveDown(this._activeItem, 1, false);
                            else this._moveUp(this._activeItem, 1, false);
                            this._preventDefaultAction(e);
                            break;
                        case 39 /* right arrow */:
                            if (this.model.enableRTL) this._moveUp(this._activeItem, 1, false);
                            else this._moveDown(this._activeItem, 1, false);
                            this._preventDefaultAction(e);
                            break;
                        case 9 /* Tab */:
                        case 27 /*ESC*/:
                            if (this._isPopupShown()) this._hideResult();
                            break;
                        case 35 /*End*/:
                            if (e.shiftKey) {
                                this._selectShiftEnd(this._activeItem, this._listSize - 1, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, this._listSize, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                        case 36 /*Home*/:
                            var step = this._activeItem != null ? this._activeItem : this._listSize - 1;
                            if (e.shiftKey) {
                                this._selectShiftHome(this._activeItem, 0, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, step, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                    }
                }
            }
        },

        _OnKeyUp: function (e) {
            if (this.model.enabled) {
                this._preventDefaultAction(e);
                var target = e.target;
                if (this._activeItem == null) {
                    this._activeItem = this._getLi().index(this.popupList.find("ol,ul").children("li.e-hover"));
                }
                if (this._trim(this._visibleInput.val()) == "" && e.keyCode == 38 && e.keyCode == 40) {
                    this._hideResult();
                    return false;
                }

                switch (e.keyCode) {
                    case 38: break;
                    case 40: break;
                    case 37: break;
                    case 39: break;

                    case 20: break;
                    case 16: break;
                    case 17: break;
                    case 18: break;
                    case 35: break;
                    case 36: break;
                    case 144: break;
                    case 27: break;
                    case 9: break;

                    case 13 /*Enter*/:
                        if (!this._isSingle && this._isPopupShown() && (e.ctrlKey || e.shiftKey) && this._activeItem >= 0) 
                            this._selectAndUnselect();
                        else if (this._isPopupShown() && !e.ctrlKey && !e.shiftKey){
							if(!ej.isNullOrUndefined(this.inputSearch)){
								if(this.getSelectedItem().length == 0) {
									this.selectItemByIndex(0);
									$(this.listitems[0]).removeClass("e-hover");
								}
								else {		
									var focusedItems = this._getLastFocusedLi();
                                    if(this.model.multiSelectMode  != "none" || this.model.showCheckbox) {
										this.unselectItemByIndex(focusedItems);
										$(this.listitems[focusedItems]).removeClass("e-hover");
									}
								}
							}
							this._hideResult();
						}
						else if (this._isPopupShown()) this._hideResult();
                        this._preventDefaultAction(e);
                        break;

                    case 32 /*spacebar*/:
                        if (this._isPopupShown() && this._isSingle) this._hideResult();
                        if (!this._isSingle && this._isPopupShown() && this._activeItem >= 0) {
                            this._selectAndUnselect();
                        }
                        this._preventDefaultAction(e);
                        break;
                    case 8 /*backspace*/:
                        if(this.model.multiSelectMode =="visualmode") this._deleteLastBox();                        
                        this._preventDefaultAction(e);
                        break;
                    case 46 /*Del*/:
                        if (this.model.multiSelectMode == "visualmode" || this.model.showCheckbox) {
                            this._deleteBox(this._ulBox.children("li.e-active"));
                            break;
                        }
                }
            }
        },

        _isSingleSelect: function () {
            return !this.model.showCheckbox && this.model.multiSelectMode == "none";
        },

        _selectAndUnselect: function () {
            if (this.model.showCheckbox) {
                this._isChecked(this._getActiveItem().find(".e-checkwrap")[0]) ?
                        this._removeTextBoxValue() : this._enterTextBoxValue();
            }
            else if (this.model.MultiSelectMode != "none") {
                this._getActiveItem().hasClass("e-active") ? this._removeTextBoxValue() : this._enterTextBoxValue();
            }
        },

        _targetFocus: function () {
            if (this.model.enabled && !this._isFocused) {
                if (!this._isWatermark)
                    this._hiddenSpan.css("display", "none");
                this.wrapper.addClass("e-focus e-popactive");
                this._isFocused = true;
                this._trigger("focusIn");
            }
        },

        _targetBlur: function () {
            if (this.model.enabled) {
                this._isFocused = false;
                this.wrapper.removeClass("e-focus e-popactive");
                this._setWatermark();
                this._trigger("focusOut");
            }
        },

		_getLocalizedLabels: function (property) {
            return this._localizedLabels[property] === undefined ? ej.DropDownList.Locale["en-US"][property] : this._localizedLabels[property]
        },
        _wireEvents: function () {
            this._on(this.wrapper, "focus", this._targetFocus);
            this._on(this.wrapper, "blur", this._targetBlur);
            this._on(this.wrapper, "keydown", this._OnKeyDown);
            this._on(this.popupList, "keydown", this._OnKeyDown);
            this._on(this.popupList, "keyup", this._OnKeyUp);
            this._on(this.wrapper, "keyup", this._OnKeyUp);
            this._on(this.popupList, "keypress", this._OnKeyPress);
            this._on(this.wrapper, "keypress", this._OnKeyPress);
        },

        _unwireEvents: function () {
            this._off(this.wrapper, "focus", this._targetFocus);
            this._off(this.wrapper, "blur", this._targetBlur);
            this._off(this.wrapper, "keydown", this._OnKeyDown);
            this._off(this.popupList, "keydown", this._OnKeyDown);
            this._off(this.popupList, "keyup", this._OnKeyUp);
            this._off(this.wrapper, "keyup", this._OnKeyUp);
            this._off(this.popupList, "keypress", this._OnKeyPress);
            this._off(this.wrapper, "keypress", this._OnKeyPress);
			$(window).off("resize", $.proxy(this._OnWindowResize, this));
        },

        _multiItemSelection: function (listItems, isAddItem) {
            if (!this._ulBox && this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            for (var i = 0; i < listItems.length; i++) {
                var index = isAddItem ? this._rawList.length - (listItems.length - i) : i;
                if (this._hasClass(listItems[i], "chkselect")) {
                    this._activeItem = index;
                    this._enterTextBoxValue();
                    this._removeClass(listItems[i], "chkselect");
                }
            }
            this._setWatermark();
        },
        _appendCheckbox: function (listItems, isAddItem) {
            if (!this._ulBox && this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            for (var i = 0; i < listItems.length; i++) {
                var index = isAddItem ? this._rawList.length - (listItems.length - i) : i,
                $checkbox = document.createElement("input"),
                $spanCheck = document.createElement("span");
                this._setAttr($checkbox, { type: "checkbox", name: "list" + index, "data-role": "none", id: this._id + "_" + "check" + index })
                    ._setClass($checkbox, "e-check-input")
                    ._setAttr($spanCheck, { name: "list" + index + "_wrap", "data-role": "none", id: this._id + "_" + "check" + index + "wrap", unselectable: "on" })
                    ._setClass($spanCheck, "e-checkwrap e-icon ");
                $spanCheck.appendChild($checkbox);
                listItems[i].insertBefore($spanCheck, listItems[i].childNodes[0]);
                if (this._hasClass(listItems[i], "chkselect")) {
                    this._activeItem = index;
                    this._enterTextBoxValue();
                    this._removeClass(listItems[i], "chkselect");
                }
            }
            this._setWatermark();
        },

        _onCheckChange: function (e) {
            var curEle = e.target.nodeName === "INPUT" ? e.target.parentElement : e.target;
            this._activeItem = $.inArray($(curEle).parents("li")[0], this._getLi());
            if (!this._hasClass(curEle, "e-check-act")) {
                this._enterTextBoxValue();
            }
            else {
                this._removeTextBoxValue();
            }
        },
        _isChecked: function (checkEle) {
            return (this._hasClass(checkEle, "e-check-act") && $(checkEle).children(".e-check-input")[0].checked == true);
        },
        _removeCheck: function () {
            this._getLi().find(".e-checkwrap").remove();
        },
        _resetCheck: function () {
            var getLi = this._getLi(), checkEle;
            getLi.find(".e-check-act").removeClass("e-check-act").attr("aria-checked",false);
            checkEle = getLi.find(".e-check-input:checked");
            for (var e = 0; e < checkEle.length; e++) {
                checkEle[e].checked = false;
            }
        }

    });
	ej.DropDownList.Locale = ej.DropDownList.Locale || {};
    ej.DropDownList.Locale["default"] = ej.DropDownList.Locale["en-US"] = {        
        emptyResultText: "No suggestions",  
		watermarkText:""
    };
    ej.MultiSelectMode = {
        /** Supports to selection mode with none only */
        None: "none",
        /** Supports to selection mode with delimitter only */
        Delimiter: "delimiter",
        /** Supports to selection mode with visualmode only */
        VisualMode: "visualmode"
    };
    ej.VirtualScrollMode = {      
        /** Make virtual scrollbar in normal mode */
        Normal: "normal",
        /** Make virtual scrollbar in continuous mode*/
        Continuous: "continuous"
    };
    
})(jQuery, Syncfusion);;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ejTooltip = (function (_super) {
    __extends(ejTooltip, _super);
    function ejTooltip(element, options) {
        _super.call(this);
        this._rootCSS = "e-tooltip";
        this._setFirst = false;
        this.PluginName = "ejTooltip";
        this.id = "null";
        this.model = null;
        this.defaults = {
            height: "auto",
            width: "auto",
            enabled: true,
            content: null,
            containment: "body",
            target: null,
            title: null,
            closeMode: "none",
            autoCloseTimeout: 4000,
            position: {
                stem: { horizontal: "center", vertical: "bottom" },
                target: { horizontal: "center", vertical: "top" }
            },
            associate: "target",
            collision: "flipfit",
            showShadow: false,
            cssClass: null,
            animation: {
                effect: "none",
                speed: 0
            },
            isBalloon: true,
            showRoundedCorner: false,
            enableRTL: false,
            allowKeyboardNavigation: true,
            tip: {
                size: {
                    width: 20,
                    height: 10
                },
                adjust: {
                    xValue: 0,
                    yValue: 0
                }
            },
            trigger: "hover",
            create: null,
            click: null,
            destroy: null,
            hover: null,
            tracking: null,
            beforeOpen: null,
            beforeClose: null,
            open: null,
            close: null,
        };
        this.dataTypes = {
            enabled: "boolean",
            closeMode: "enum",
            autoCloseTimeout: "number",
            trigger: "enum",
            position: {
                stem: "data",
                target: "data"
            },
            associate: "enum",
            collision: "enum",
            showShadow: "boolean",
            animation: {
                effect: "enum",
                speed: "number"
            },
            isBalloon: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            allowKeyboardNavigation: "boolean",
            tip: {
                size: {
                    width: "number",
                    height: "number"
                },
                adjust: {
                    xValue: "number",
                    yValue: "number"
                }
            }
        };
        this.isTrack = true;
        this._isCancel = false;
        this._isHidden = true;
        this.arrowValue = { left: 0, top: 0, width: 0, height: 0, display: null };
        this.tooltipPos = { width: 0, height: 0, left: 0, top: 0, bottom: 0, right: 0, position: "absolute" };
        this.targetPos = { width: 0, height: 0, left: 0, top: 0, bottom: 0, right: 0, position: "absolute" };
        this.mouseTimer = null;
        this.positionTarget = null;
        this.positionTooltip = null;
        this.containerSize = null;
        this._createTitle = function () {
            this.tooltipTitle = ej.buildTag('div.e-def e-header', " ", {}, {});
            this.tooltipHeader = ej.buildTag('div', " ", {}, {});
            $(this.tooltipTitle).html(this.model.title).appendTo(this.tooltipHeader);
        };
        if (element) {
            if (!element["jquery"]) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejTooltip(options).data(this.PluginName);
            }
        }
    }
    ejTooltip.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    ejTooltip.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };
    ejTooltip.prototype.triggerEvents = function (eventName, eventProp) {
        var temp;
        switch (eventName) {
            case "click":
                var clickArg = eventProp;
                temp = this._trigger(eventName, clickArg);
                break;
            case "hover":
                var hoverArg = eventProp;
                temp = this._trigger(eventName, hoverArg);
                break;
            case "tracking":
                var trackArg = eventProp;
                temp = this._trigger(eventName, trackArg);
                break;
            case "beforeOpen":
                var beforeOpenArg = eventProp;
                temp = this._trigger(eventName, beforeOpenArg);
                break;
            case "open":
                var openArg = eventProp;
                temp = this._trigger(eventName, openArg);
                break;
            case "beforeClose":
            case "close":
                var closeArg = eventProp;
                temp = this._trigger(eventName, closeArg);
                break;
        }
        return temp;
    };
    ejTooltip.prototype.enable = function (val) {
        if (this.tooltip.hasClass("e-disable")) {
            this.model.enabled = true;
            this.tooltip.removeClass("e-disable");
        }
    };
    ejTooltip.prototype.disable = function (val) {
        if (!this.tooltip.hasClass("e-disable")) {
            this.model.enabled = false;
            this.tooltip.addClass("e-disable");
        }
    };
    ejTooltip.prototype.show = function (targetElement, func) {
        if (this.model.enabled) {
            if (ej.isNullOrUndefined(targetElement)) {
                var target = (this.model.target == null) ? this.element : $(this.element).find(this.model.target + ":first");
                this._positionElement(target);
            }
            else {
                this._positionElement(targetElement);
            }
            if (!ej.isNullOrUndefined(func)) {
                if (typeof func === "string") {
                    $(this.tooltip).show(func);
                }
                else {
                    if (typeof func === "function") {
                        func.call.apply(this.tooltip);
                    }
                }
            }
            else {
                this._showTooltip();
            }
        }
    };
    ejTooltip.prototype.hide = function (func) {
        if (this.model.enabled) {
            if (!ej.isNullOrUndefined(func)) {
                if (typeof func === "string") {
                    $(this.tooltip).hide(func);
                }
                else if (typeof func === "function") {
                    func.call.apply(this.tooltip);
                }
            }
            else {
                this._hideTooltip();
            }
        }
    };
    ejTooltip.prototype._destroy = function () {
        $(this.tooltip).remove();
        this.tooltip = null;
    };
    ejTooltip.prototype._setModel = function (options) {
        var option;
        for (option in options) {
            switch (option) {
                case "height":
                    this._setHeight(options[option]);
                    break;
                case "width":
                    this._setWidth(options[option]);
                    break;
                case "enabled":
                    this._enabled(options[option]);
                    break;
                case "content":
                    this._setContent(options[option]);
                    break;
                case "title":
                    this.model.title = options[option];
                    if (this.model.title == null) {
                        $(this.tooltipHeader).remove();
                        this.tooltipHeader = null;
                        this.tooltipTitle = null;
                        if (this.model.closeMode === ej.Tooltip.CloseMode.Sticky)
                            this._iconRender();
                    }
                    else
                        (ej.isNullOrUndefined(this.tooltipHeader)) ? this._createHeader() : $(this.tooltipTitle).html(this.model.title);
                    this.tooltipPos.height = $(this.tooltip).outerHeight();
                    break;
                case "associate":
                    this.model.associate = options[option];
                    this._wireMouseEvents(false);
                    this._wireMouseEvents(true);
                    break;
                case "position":
                    this._setPosition(options[option]);
                    break;
                case "collision":
                    this.model.collision = options[option];
                    break;
                case "closeMode":
                    if (typeof options[option] !== "undefined") {
                        this.model.closeMode = options[option];
                        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky)
                            this._iconRender();
                        else {
                            $(this.tooltipClose).remove();
                            this.tooltipClose = null;
                        }
                        this.tooltipPos.height = $(this.tooltip).outerHeight();
                    }
                    break;
                case "cssClass":
                    this._setSkin(options[option]);
                    break;
                case "showShadow":
                    this._shadowEffect(options[option], this.model.position);
                    break;
                case "isBalloon":
                    if (!ej.isNullOrUndefined(options[option])) {
                        this.model.isBalloon = options[option];
                        if (!this.model.isBalloon) {
                            $(this.tip).remove();
                            this.tip = null;
                        }
                        else
                            this._renderArrow();
                    }
                    break;
                case "animation":
                    var val = options[option];
                    this.model.animation = $.extend(true, this.model.animation, val);
                    if (this.model.animation.effect != ej.Tooltip.Effect.None) {
                        this._off($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
                        this._off($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
                    }
                    else if (this.model.animation.effect == ej.Tooltip.Effect.None) {
                        this._on($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
                        this._on($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
                    }
                    break;
                case "enableRTL":
                    this._setRTL(options[option]);
                    break;
                case "target":
                    this._wireTriggerEvents(false);
                    this.model.target = options[option];
                    this._wireTriggerEvents(true);
                    this._renderTarget();
                    break;
                case "trigger":
                    this._setTrigger(options[option]);
                    break;
                case "showRoundedCorner":
                    this.model.showRoundedCorner = options[option];
                    this._roundedCorner(options[option]);
                    break;
                case "allowKeyboardNavigation":
                    this.model.allowKeyboardNavigation = options[option];
                    if (!this.model.allowKeyboardNavigation) {
                        this._off($(window), "keydown", this._keyDown);
                    }
                    else {
                        this._on($(window), "keydown", this._keyDown);
                    }
                    break;
            }
        }
    };
    ejTooltip.prototype._enabled = function (val) {
        (val) ? this.enable(val) : this.disable(val);
        this.model.enabled = val;
    };
    ejTooltip.prototype._shadowEffect = function (val, position) {
        this.model.showShadow = val;
        var shadowEffect = null;
        $(this.tooltip).removeClass("e-tooltipShadowLeft e-tooltipShadowRight");
        if (this.model.showShadow) {
            if (this.model.isBalloon) {
                switch (position.stem.horizontal) {
                    case "center":
                        shadowEffect = (position.stem.vertical == "top") ? "e-tooltipShadowLeft" : (position.stem.vertical == "bottom") ? "e-tooltipShadowRight" : "e-tooltipShadowLeft";
                        break;
                    case "right":
                        shadowEffect = (position.target.horizontal == "center" && position.stem.vertical == "top") ? "e-tooltipShadowLeft" : "e-tooltipShadowRight";
                        break;
                    case "left":
                        shadowEffect = (position.target.horizontal == "center" && position.stem.vertical == "bottom") ? "e-tooltipShadowRight" : "e-tooltipShadowLeft";
                        break;
                }
            }
            else
                shadowEffect = "e-tooltipShadowLeft";
            $(this.tooltip).addClass(shadowEffect);
        }
    };
    ejTooltip.prototype._setContent = function (val) {
        this.model.content = val;
        $(this.tooltipContent).html(this.model.content);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
        this.tooltipPos.width = $(this.tooltip).outerWidth();
    };
    ejTooltip.prototype._setPosition = function (val) {
        this.model.position.stem = $.extend(true, this.model.position.stem, val.stem);
        this.model.position.target = $.extend(true, this.model.position.target, val.target);
    };
    ejTooltip.prototype._setTrigger = function (val) {
        this._wireTriggerEvents(false);
        this.model.trigger = val;
        this._wireTriggerEvents(true);
    };
    ejTooltip.prototype._init = function () {
        this.id = this.element[0].id;
        this.positionTarget = $.extend(true, {}, this.model.position.target);
        this.positionTooltip = $.extend(true, {}, this.model.position.stem);
        this.tipSize = $.extend(true, {}, this.model.tip.size);
        this._initialize();
        this._render();
        this.enable(this.model.enabled);
        this._wireEvents(true);
    };
    ejTooltip.prototype._initialize = function () {
        if (ej.isNullOrUndefined(this.model.target)) {
            if (ej.isNullOrUndefined(this.model.content) && (!ej.isNullOrUndefined(this.element.attr("title")))) {
                this.model.content = this.element.attr("title");
                this.element.attr("data-content", this.model.content);
                this.element.removeAttr("title");
            }
        }
        else
            this._renderTarget();
    };
    ejTooltip.prototype._wireEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        this._wireTriggerEvents(val);
        if (this.model.allowKeyboardNavigation)
            this[wire]($(window), "keydown", this._keyDown);
        (this.model.target != null) ? this[wire](this.element, "scroll", this.model.target, this._hideTooltip) : this[wire](this.element, "scroll", this._hideTooltip);
        this[wire]($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
        this[wire]($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
        this[wire]($(window), "resize", this._hideTooltip);
        this[wire]($(window), "touchend", this._docTouchEndHandler);
    };
    ejTooltip.prototype._wireTriggerEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        this._wireMouseEvents(val);
        var triggerEvent = (this.model.trigger == ej.Tooltip.Trigger.Click) ? "click touchstart" : (this.model.trigger == ej.Tooltip.Trigger.Focus) ? "focus touchstart" : "mouseenter touchstart";
        (this.model.target != null) ? this[wire](this.element, triggerEvent, this.model.target, this._targetHover) : this[wire](this.element, triggerEvent, this._targetHover);
        if (this.model.trigger == ej.Tooltip.Trigger.Focus)
            (this.model.target != null) ? this[wire](this.element, "blur", this.model.target, this._hideTooltip) : this[wire](this.element, "blur", this._hideTooltip);
        else
            (this.model.target != null) ? this[wire](this.element, "mouseleave", this.model.target, this._onMouseOut) : this[wire](this.element, "mouseleave", this._onMouseOut);
    };
    ejTooltip.prototype._wireMouseEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        if (this.model.associate == ej.Tooltip.Associate.MouseEnter || this.model.associate == ej.Tooltip.Associate.MouseFollow)
            (this.model.target != null) ? this[wire](this.element, "mousemove touchstart", this.model.target, this._tooltipMove) : this[wire](this.element, "mousemove touchstart", this._tooltipMove);
    };
    ejTooltip.prototype._render = function () {
        this.tooltip = ej.buildTag("div.e-tooltip-wrap e-widget", "", {}, { role: "tooltip", 'aria-readonly': 'true', 'aria-hidden': 'true', 'aria-describedby': this.id + '_content', 'id': this.id + '_Main' });
        this.tooltipInter = ej.buildTag("div.e-tipContainer", "", {}, {});
        this.tooltip.append(this.tooltipInter);
        if (this.model.isBalloon)
            this._renderArrow();
        $(this.model.containment).append(this.tooltip);
        this._setHeight(this.model.height);
        this._setWidth(this.model.width);
        this._createHeader();
        this._tooltipContent();
        if (this.model.cssClass)
            this.tooltip.addClass(this.model.cssClass);
        if (this.model.showRoundedCorner)
            this._roundedCorner(this.model.showRoundedCorner);
        if (this.model.enableRTL)
            this._setRTL(this.model.enableRTL);
        $(this.tooltip).css({ "top": "auto", "left": "auto" });
        this.tooltipPos = { width: $(this.tooltip).outerWidth(), height: $(this.tooltip).outerHeight(), left: $(this.tooltip).offset().left, top: $(this.tooltip).offset().top, position: "absolute" };
        if (ej.isNullOrUndefined(this.model.target)) {
            this._containerCalc(this.element);
            this._positionElement(this.element);
        }
    };
    ejTooltip.prototype._containerCalc = function (target) {
        if (ej.isNullOrUndefined(target))
            target = this.element;
        var containerElement = { left: 0, top: 0 };
        var childElement = $(target).offset();
        this.containerSize = {
            height: (this.model.containment == "body") ? $(window).innerHeight() || document.documentElement.clientHeight || document.body.clientHeight : $(this.model.containment).innerHeight(),
            width: (this.model.containment == "body") ? $(window).innerWidth() || document.documentElement.clientWidth || document.body.clientWidth : $(this.model.containment).innerWidth()
        };
        this.containerSize.left = (this.model.containment != "body") ? ($(this.model.containment).css("position") == "static") ? ($(this.model.containment).offset().left - $(this.model.containment).offsetParent().offset().left) : 0 : 0;
        this.containerSize.top = (this.model.containment != "body") ? ($(this.model.containment).css("position") == "static") ? ($(this.model.containment).offset().top - $(this.model.containment).offsetParent().offset().top) : 0 : 0;
        childElement.left -= (this.model.containment != "body") ? (($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset().left : $(this.model.containment).offset().left) : 0;
        childElement.top -= (this.model.containment != "body") ? (($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset().top : $(this.model.containment).offset().top) : 0;
        this.targetPos.left = childElement.left;
        this.targetPos.top = childElement.top;
    };
    ejTooltip.prototype._setHeight = function (val) {
        this.model.height = val;
        (!isNaN(+val) && isFinite(val)) ? $(this.tooltip).css("height", val + "px") : $(this.tooltip).css("height", val);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
    };
    ejTooltip.prototype._setWidth = function (val) {
        this.model.width = val;
        if (this.model.width != "auto") {
            val = (!isNaN(+val) && isFinite(val)) ? val + "px" : val;
            $(this.tooltip).css("max-width", val);
            $(this.tooltip).css("min-width", "0px");
        }
        $(this.tooltip).css("width", val);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
    };
    ejTooltip.prototype._setRTL = function (val) {
        this.model.enableRTL = val;
        val ? this.tooltip.addClass("e-rtl") : this.tooltip.removeClass("e-rtl");
    };
    ejTooltip.prototype._setSkin = function (skin) {
        if (this.model.cssClass != skin) {
            this.tooltip.removeClass(this.model.cssClass).addClass(skin);
            this.model.cssClass = skin;
        }
    };
    ejTooltip.prototype._roundedCorner = function (val) {
        (this.model.showRoundedCorner) ? this.tooltip.addClass("e-corner") : this.tooltip.removeClass("e-corner");
    };
    ejTooltip.prototype._renderArrow = function () {
        if (ej.isNullOrUndefined(this.tip)) {
            this.tip = ej.buildTag('div.e-arrowTip', " ", { 'id': this.id + "_eTip" }, {});
            $(this.tip).append("<div class='e-arrowTipOuter'></div>").append("<div class='e-arrowTipInner'></div>");
            $(this.tip).insertBefore(this.tooltipInter);
        }
    };
    ejTooltip.prototype._adjustArrow = function (position) {
        var leftValue, topValue, tooltipWidth = $(this.tooltip).width(), tooltipHeight = $(this.tooltip).height();
        var positionTooltip = position.stem, positionTarget = position.target;
        var arrow = { "tipHeight": 0, "tipWidth": 0 };
        if (positionTarget.horizontal == "right" || positionTarget.horizontal == "left") {
            leftValue = (positionTooltip.horizontal == "left") ? -(this.model.tip.size.height) : (positionTooltip.horizontal == "right") ? tooltipWidth : ((tooltipWidth) / 2 - (this.tipSize.width / 2));
            if (positionTooltip.horizontal != "center")
                topValue = (positionTooltip.vertical == "top") ? 5 : (positionTooltip.vertical == "center") ? ((tooltipHeight / 2) - (this.tipSize.width / 2)) : ((tooltipHeight - 5) - this.tipSize.width);
            else
                topValue = (positionTooltip.vertical == "top") ? -this.tipSize.height : (positionTooltip.vertical == "bottom") ? tooltipHeight : ((this.tooltipPos.height / 2) - (this.tipSize.width / 2));
            arrow = this._arrowBinding(position, "horizontal");
        }
        else {
            topValue = (positionTooltip.vertical == "top") ? -this.tipSize.height : (positionTooltip.vertical == "bottom") ? tooltipHeight : ((tooltipHeight / 2) - (this.tipSize.width / 2));
            if (positionTooltip.vertical == "center")
                leftValue = (positionTooltip.horizontal == "left") ? -(this.model.tip.size.height) : tooltipWidth;
            else
                leftValue = (positionTooltip.horizontal == "left") ? 10 : (positionTooltip.horizontal == "center") ? ((this.tooltipPos.width) / 2 - (this.tipSize.width / 2)) : ((tooltipWidth - 10) - this.tipSize.width);
            arrow = this._arrowBinding(position, "vertical");
        }
        this.arrowValue.left = leftValue;
        this.arrowValue.top = topValue;
        $(this.tip).css({ height: arrow.tipHeight + "px", width: arrow.tipWidth + "px", left: leftValue + "px", top: topValue + "px", display: (positionTooltip.horizontal == "center" && positionTooltip.vertical == "center") ? "none" : "block" });
    };
    ejTooltip.prototype._arrowBinding = function (position, arrowType) {
        var positionTooltip = position.stem, condition = (arrowType == "horizontal") ? (positionTooltip.horizontal != "center") : (positionTooltip.vertical == "center");
        var tipWidth, tipHeight, borderColor = $(this.tooltip).css("border-top-color"), backgroudColor = $(this.tooltip).css("background-color"), arrowOuterSize = this.model.tip.size.height, arrowInterSize = this.model.tip.size.height - 1, arrowCalculation = { "border-top": "none", "border-bottom": "none", "border-right": "none", "border-left": "none" };
        if (condition) {
            tipWidth = this.model.tip.size.height;
            tipHeight = this.model.tip.size.width;
            $(this.tip).find(".e-arrowTipOuter").css(this._arrow(position, arrowOuterSize, borderColor, arrowCalculation, "horizontal"));
            $(this.tip).find(".e-arrowTipInner").css(this._arrow(position, arrowInterSize, backgroudColor, arrowCalculation, "horizontal"));
        }
        else {
            tipWidth = this.model.tip.size.width;
            tipHeight = this.model.tip.size.height;
            $(this.tip).find(".e-arrowTipOuter").css(this._arrow(position, arrowOuterSize, borderColor, arrowCalculation, "vertical"));
            $(this.tip).find(".e-arrowTipInner").css(this._arrow(position, arrowInterSize, backgroudColor, arrowCalculation, "vertical"));
        }
        return { tipHeight: tipHeight, tipWidth: tipWidth };
    };
    ejTooltip.prototype._arrow = function (position, size, color, arrowCalculation, arrowType) {
        var positionTooltip = position.stem, innerLeft = (arrowType == "horizontal") ? (positionTooltip.horizontal == "right") ? "0px" : "1px" : "1px", innerTop = (arrowType == "horizontal") ? "1px" : (positionTooltip.vertical == "bottom") ? "0px" : "1px";
        arrowCalculation["border-top"] = (arrowType == "horizontal") ? size + "px solid transparent" : (positionTooltip.vertical == "bottom") ? (size + "px solid " + color) : "none";
        arrowCalculation["border-bottom"] = (arrowType == "horizontal") ? size + "px solid transparent" : (positionTooltip.vertical == "top") ? (size + "px solid " + color) : "none";
        arrowCalculation["border-right"] = (arrowType == "horizontal") ? (positionTooltip.horizontal == "left") ? (size + "px solid " + color) : "none" : size + "px solid transparent";
        arrowCalculation["border-left"] = (arrowType == "horizontal") ? (positionTooltip.horizontal == "right") ? (size + "px solid " + color) : "none" : size + "px solid transparent";
        if (size == this.model.tip.size.height - 1) {
            arrowCalculation["left"] = innerLeft;
            arrowCalculation["top"] = innerTop;
        }
        return arrowCalculation;
    };
    ejTooltip.prototype._iconRender = function () {
        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky) {
            if (!ej.isNullOrUndefined(this.tooltipClose))
                $(this.tooltipClose).remove();
            this.tooltipClose = ej.buildTag("div .e-icon", " ", {}, { 'id': "_closeIcon" });
            (this.model.title != null) ? $(this.tooltipClose).insertAfter(this.tooltipTitle).addClass("e-close") : $(this.tooltipClose).insertBefore(this.tooltipInter).addClass("e-cross-circle");
            this._on($(this.tooltipClose), "click", this._hideTooltip);
        }
    };
    ejTooltip.prototype._renderTarget = function () {
        this.targetElement = $(this.element).find(this.model.target);
        for (var i = 0; i < this.targetElement.length; i++) {
            if (!ej.isNullOrUndefined($(this.targetElement[i]).attr("title"))) {
                this.targetElement[i].setAttribute("data-content", this.targetElement[i].title);
                this.targetElement[i].removeAttribute("title");
            }
        }
    };
    ejTooltip.prototype._tooltipContent = function () {
        this.tooltipContent = ej.buildTag('div.e-tipcontent e-def', "", {}, { 'id': this.id + '_content' });
        $(this.tooltipContent).html(this.model.content).addClass("e-def");
        (this.model.title != null) ? $(this.tooltipContent).insertAfter(this.tooltipHeader) : $(this.tooltipContent).appendTo(this.tooltipInter);
    };
    ejTooltip.prototype._positionElement = function (target) {
        this.tooltipPos.width = $(this.tooltip).outerWidth();
        this.tooltipPos.height = $(this.tooltip).outerHeight();
        this.targetPos.width = $(target).outerWidth();
        this.targetPos.height = $(target).outerHeight();
        this._containerCalc(target);
        if (this.model.associate == ej.Tooltip.Associate.Window)
            this._browserPosition();
        else if (this.model.associate == ej.Tooltip.Associate.Axis)
            this._axisPosition();
        else if (this.model.associate == ej.Tooltip.Associate.Target)
            this._tooltipPosition(this.model.position);
        if (this.model.collision != ej.Tooltip.Collision.None && this.model.associate == ej.Tooltip.Associate.Target)
            this._calcCollision(this.model.position, target);
    };
    ejTooltip.prototype._browserPosition = function () {
        if (this.model.containment == "body") {
            this.containerSize = {
                height: $(window).innerHeight() || document.documentElement.clientHeight || document.body.clientHeight,
                width: $(window).innerWidth() || document.documentElement.clientWidth || document.body.clientWidth
            };
            var position = $.extend(true, {}, this.model.position);
            var calPosition = { position: "absolute", left: "auto", top: "auto", bottom: "auto", right: "auto" }, offsetTop, offsetLeft;
            if (!ej.isNullOrUndefined(this.tip))
                $(this.tip).css({ "display": "none" });
            (this.model.position.target.horizontal == "right") ? calPosition.right = 0 : (this.model.position.target.horizontal == "left") ? calPosition.left = 0 : (calPosition.left = (this.containerSize.width / 2) - (this.tooltipPos.width / 2));
            (this.model.position.target.vertical == "top") ? (calPosition.top = 0) : (this.model.position.target.vertical == "center") ? (calPosition.top = ((this.containerSize.height / 2) - (this.tooltipPos.height / 2))) : calPosition.bottom = 0;
            if (this.model.showShadow)
                this._shadowEffect(this.model.showShadow, position);
            $(this.tooltip).css(calPosition);
        }
    };
    ejTooltip.prototype._tooltipMove = function (event) {
        if (this.model.closeMode == ej.Tooltip.CloseMode.None && this.model.enabled) {
            var proxy = this;
            if (this._isCancel)
                return;
            if (this.model.associate == ej.Tooltip.Associate.MouseFollow)
                this._mousePosition(event);
            else if (this.model.associate == ej.Tooltip.Associate.MouseEnter) {
                clearTimeout(this.mouseTimer);
                this.mouseTimer = setTimeout(function () {
                    if (proxy.isTrack)
                        proxy._mousePosition(event);
                }, 300);
            }
        }
    };
    ejTooltip.prototype._mousePosition = function (event) {
        var eventPageX, eventPageY;
        if (event.type == "touchstart") {
            event.preventDefault();
            eventPageX = event.touches[0].pageX;
            eventPageY = event.touches[0].pageY;
        }
        else if (event.type == "mousemove") {
            eventPageX = event.pageX;
            eventPageY = event.pageY;
        }
        this.isCollision = true;
        this._containerCalc(event.currentTarget);
        var tipGapX = 0, tipGapY = 0, tipSize = 0, positionTooltip = $.extend(true, {}, this.model.position.stem), position = $.extend(true, {}, this.model.position), containerElement = { left: 0, top: 0 }, calcPosition = { left: eventPageX, top: eventPageY }, childElement = { left: eventPageX, top: eventPageY }, containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        var targetLeft = (this.model.containment != "body") ? (eventPageX - $(this.model.containment).offset().left) : eventPageX, targetTop = (this.model.containment != "body") ? (eventPageY - $(this.model.containment).offset().top) : eventPageY;
        position.target.horizontal = position.target.vertical = "center";
        if (this.model.containment != "body")
            containerElement = ($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset() : $(this.model.containment).offset();
        childElement.left -= containerElement.left;
        childElement.top -= containerElement.top;
        while (this.isCollision) {
            calcPosition = $.extend(true, {}, childElement);
            var tipY = (this.model.isBalloon) ? (positionTooltip.vertical == "top" || positionTooltip.vertical == "bottom") ? (5 + (this.tipSize.height / 2)) : 0 : 0, tipX = (this.model.isBalloon) ? (positionTooltip.horizontal == "right" || positionTooltip.horizontal == "left") ? (10 + (this.tipSize.width / 2)) : 0 : 0;
            tipGapX = (this.model.tip.adjust.xValue != 0) ? this.model.tip.adjust.xValue : 7;
            tipGapY = (this.model.tip.adjust.yValue != 0) ? this.model.tip.adjust.yValue : 10;
            tipSize = (this.model.isBalloon) ? (positionTooltip.horizontal != "center") ? this.model.tip.size.height : (positionTooltip.vertical != "center") ? this.model.tip.size.height : 0 : 2;
            calcPosition.left += (positionTooltip.horizontal == "right") ? -this.tooltipPos.width : (positionTooltip.horizontal == "left") ? 0 : -(this.tooltipPos.width / 2);
            calcPosition.top += (positionTooltip.vertical == "bottom") ? -this.tooltipPos.height : (positionTooltip.vertical == "top") ? 0 : -(this.tooltipPos.height / 2);
            calcPosition.left += (positionTooltip.vertical != "center") ? ((positionTooltip.horizontal == "right") ? tipX : (positionTooltip.horizontal == "left") ? -tipX : 0) : 0;
            calcPosition.left += (positionTooltip.vertical == "center") ? (positionTooltip.horizontal == "right") ? -(tipSize) : (positionTooltip.horizontal == "left") ? +(tipSize + tipGapX) : 0 : 0;
            calcPosition.top += (positionTooltip.vertical == "top") ? +(tipSize + tipGapY) : (positionTooltip.vertical == "bottom") ? -(tipSize) : 0;
            if (this.targetElement != event.currentTarget) {
                this.targetElement = event.currentTarget;
                if (calcPosition.left < containerLeft || (calcPosition.left + this.tooltipPos.width > (containerLeft + this.containerSize.width)))
                    this.positionTooltip.horizontal = (targetLeft >= this.tooltipPos.width) ? "right" : ((this.containerSize.width - targetLeft) >= this.tooltipPos.width) ? "left" : "center";
                if (calcPosition.top < containerTop || ((calcPosition.top + this.tooltipPos.height) > (this.containerSize.height + containerTop)))
                    this.positionTooltip.vertical = (targetTop >= this.tooltipPos.height) ? "bottom" : ((this.containerSize.height - targetTop) >= this.tooltipPos.height) ? "top" : "center";
            }
            if (this.positionTooltip.horizontal != positionTooltip.horizontal || this.positionTooltip.vertical != positionTooltip.vertical) {
                this.isCollision = true;
                positionTooltip = $.extend(true, {}, this.positionTooltip);
            }
            else {
                this.isCollision = false;
                $(this.tooltip).css({ top: calcPosition.top + "px", left: calcPosition.left + "px", position: "absolute", right: "auto", bottom: "auto" });
                position.stem = $.extend(true, {}, this.positionTooltip);
                if (this.model.showShadow)
                    this._shadowEffect(this.model.showShadow, position);
                if (this.model.isBalloon)
                    this._adjustArrow(position);
                this._showTooltip();
                if (this.model.associate == ej.Tooltip.Associate.MouseEnter)
                    this.isTrack = false;
                if (this.model.associate == ej.Tooltip.Associate.MouseFollow) {
                    if (this.triggerEvents("tracking", { position: this.model.position, event: event }))
                        return;
                }
            }
        }
    };
    ejTooltip.prototype._axisPosition = function () {
        var position = $.extend(true, {}, this.model.position);
        if (typeof this.model.position.target.horizontal == 'number')
            var leftValue = (this.model.position.target.horizontal).toString();
        if (typeof this.model.position.target.vertical == 'number')
            var topValue = (this.model.position.target.vertical).toString();
        var offsetLeft = parseInt(leftValue), offsetTop = parseInt(topValue);
        if (!ej.isNullOrUndefined(this.tip))
            $(this.tip).css({ "display": "none" });
        if (this.model.showShadow)
            this._shadowEffect(this.model.showShadow, position);
        if (this.model.isBalloon)
            this._adjustArrow(position);
        if (isFinite(offsetLeft) && isFinite(offsetTop))
            $(this.tooltip).css({ top: offsetTop, left: offsetLeft, position: "absolute" });
    };
    ejTooltip.prototype._tooltipPosition = function (position) {
        var tipSize = 0, tipGap = 0, tipAdjustment = 0, positionTooltip = $.extend(true, {}, position.stem), positionTarget = $.extend(true, {}, position.target);
        var calcPosition = $.extend(true, {}, this.targetPos);
        var tipY = (positionTooltip.vertical === "top" || positionTooltip.vertical === "bottom") ? (5 + (this.tipSize.width / 2)) : 0, tipX = (positionTooltip.horizontal === "right" || positionTooltip.horizontal === "left") ? (10 + (this.tipSize.width / 2)) : 0, tipSize = (this.model.isBalloon) ? (positionTooltip.horizontal !== "center") ? this.model.tip.size.height : (positionTooltip.vertical !== "center") ? this.model.tip.size.height : 0 : 0;
        var tipGapX = (this.model.tip.adjust.xValue != 0) ? this.model.tip.adjust.xValue : (this.model.isBalloon) ? 0 : 2, tipGapY = (this.model.tip.adjust.yValue != 0) ? this.model.tip.adjust.yValue : (this.model.isBalloon) ? 0 : 2;
        calcPosition.left += (positionTarget.horizontal === "right") ? this.targetPos.width : (positionTarget.horizontal === "left") ? 0 : (this.targetPos.width / 2);
        calcPosition.top += (positionTarget.vertical === "bottom") ? this.targetPos.height : (positionTarget.vertical === "top") ? 0 : (this.targetPos.height / 2);
        calcPosition.left += (positionTooltip.horizontal === "right") ? -this.tooltipPos.width : (positionTooltip.horizontal === "left") ? 0 : -(this.tooltipPos.width / 2);
        calcPosition.top += (positionTooltip.vertical === "bottom") ? -this.tooltipPos.height : (positionTooltip.vertical === "top") ? 0 : -(this.tooltipPos.height / 2);
        calcPosition.left += (positionTarget.horizontal !== "center") ? (positionTooltip.horizontal === "right") ? -tipSize : (positionTooltip.horizontal === "left") ? tipSize : 0 : (positionTooltip.vertical === "center") ? (positionTooltip.horizontal === "right") ? -tipSize : (positionTooltip.horizontal === "left") ? tipSize : 0 : 0;
        calcPosition.top += (positionTarget.horizontal === "center") ? ((positionTooltip.vertical === "bottom") ? -tipSize : (positionTooltip.vertical === "top") ? tipSize : 0) : (positionTooltip.horizontal === "center") ? (positionTooltip.vertical === "bottom") ? -tipSize : (positionTooltip.vertical === "top") ? tipSize : 0 : 0;
        calcPosition.left += (positionTarget.horizontal === "center" && positionTooltip.vertical !== "center") ? ((positionTooltip.horizontal === "right") ? tipX : (positionTooltip.horizontal === "left") ? -tipX : 0) : 0;
        calcPosition.top += (positionTarget.horizontal !== "center" && positionTooltip.horizontal !== "center") ? ((positionTooltip.vertical === "top") ? -tipY : (positionTooltip.vertical === "bottom") ? tipY : 0) : 0;
        calcPosition.left += (positionTarget.horizontal !== "center") ? (positionTooltip.horizontal === "right") ? -tipGapX : (positionTooltip.horizontal === "left") ? tipGapX : 0 : (positionTooltip.vertical === "center") ? (positionTooltip.horizontal === "right") ? -tipGapX : (positionTooltip.horizontal === "left") ? tipGapX : 0 : 0;
        calcPosition.top += (positionTarget.horizontal === "center") ? ((positionTooltip.vertical === "bottom") ? -tipGapY : (positionTooltip.vertical === "top") ? tipGapY : 0) : (positionTooltip.horizontal === "center") ? (positionTooltip.vertical === "bottom") ? -tipGapY : (positionTooltip.vertical === "top") ? tipGapY : 0 : 0;
        this.tooltipPos.left = calcPosition.left;
        this.tooltipPos.top = calcPosition.top;
        if (this.model.collision === ej.Tooltip.Collision.None) {
            if (this.model.isBalloon)
                this._adjustArrow(position);
            this._shadowEffect(this.model.showShadow, position);
            $(this.tooltip).css({ "top": calcPosition.top + "px", "left": calcPosition.left + "px", position: "absolute" });
        }
    };
    ejTooltip.prototype._calcCollision = function (position, target) {
        var position = $.extend(true, {}, position), newPosition = $.extend(true, {}, position), arrowSize = this.model.tip.size.height, isCollision = true;
        var targetLeft = (this.model.containment != "body") ? ($(target).offset().left - $(this.model.containment).offset().left) : $(target).offset().left, targetTop = (this.model.containment != "body") ? ($(target).offset().top - $(this.model.containment).offset().top) : $(target).offset().top;
        var availSpace = {
            topSpace: targetTop,
            rightSpace: this.containerSize.width - (targetLeft + this.targetPos.width),
            bottomSpace: this.containerSize.height - (targetTop + this.targetPos.height),
            leftSpace: targetLeft,
            centerRight: this.containerSize.width - (targetLeft + (this.targetPos.width / 2)),
            centerLeft: (targetLeft + (this.targetPos.width / 2)),
            centerTop: targetTop + (this.targetPos.height / 2),
            centerBottom: this.containerSize.height - (targetTop + (this.targetPos.height / 2)),
            tooltipWidth: this.tooltipPos.width + arrowSize,
            tooltipHeight: this.tooltipPos.height + arrowSize
        };
        if (this.model.collision === ej.Tooltip.Collision.Fit)
            this._collisionFit(position, availSpace);
        else {
            while (isCollision) {
                newPosition = this._collisionFlip(newPosition, availSpace);
                if (newPosition.target.horizontal != position.target.horizontal || newPosition.target.vertical != position.target.vertical || newPosition.stem.horizontal != position.stem.horizontal || newPosition.stem.vertical != position.stem.vertical) {
                    this._tooltipPosition(newPosition);
                    position = $.extend(true, {}, newPosition);
                }
                else
                    isCollision = false;
            }
            if (!isCollision) {
                if (this.model.collision == ej.Tooltip.Collision.FlipFit)
                    this._collisionFit(newPosition, availSpace);
                else {
                    this._adjustArrow(newPosition);
                    this._shadowEffect(this.model.showShadow, newPosition);
                    $(this.tooltip).css({ "top": this.tooltipPos.top + "px", "left": this.tooltipPos.left + "px", position: "absolute" });
                }
            }
        }
    };
    ejTooltip.prototype._collisionFlip = function (position, availSpace) {
        var tooltipPos = $.extend(true, {}, this.tooltipPos), newPosition = $.extend(true, {}, position);
        var scrollLeft = $(this.model.containment).scrollLeft(), scrollTop = $(this.model.containment).scrollTop();
        var containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        if ((tooltipPos.left + tooltipPos.width) > (containerLeft + this.containerSize.width + scrollLeft) || (tooltipPos.left < containerLeft)) {
            if (position.target.horizontal != "center")
                newPosition.target.horizontal = (availSpace.leftSpace >= availSpace.tooltipWidth) ? "left" : (availSpace.rightSpace >= availSpace.tooltipWidth) ? "right" : "center";
            else
                newPosition.stem.horizontal = (availSpace.centerLeft >= availSpace.tooltipWidth) ? "right" : (availSpace.centerRight >= availSpace.tooltipWidth) ? "left" : "center";
        }
        if (tooltipPos.top < containerTop)
            newPosition.target.vertical = (availSpace.bottomSpace >= availSpace.tooltipHeight) ? "bottom" : "center";
        if ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop))
            newPosition.target.vertical = (availSpace.topSpace >= availSpace.tooltipHeight) ? "top" : "center";
        if (newPosition.target.horizontal != position.target.horizontal || newPosition.target.vertical != position.target.vertical) {
            if (newPosition.target.horizontal == "center")
                newPosition.stem.horizontal = (availSpace.centerLeft >= availSpace.tooltipWidth) ? "right" : (availSpace.centerRight >= availSpace.tooltipWidth) ? "left" : "center";
            else
                newPosition.stem.horizontal = (newPosition.target.horizontal == "right") ? "left" : "right";
        }
        if (newPosition.target.vertical != position.target.vertical || newPosition.target.horizontal != position.target.horizontal) {
            if (newPosition.target.vertical == "center")
                newPosition.stem.vertical = (availSpace.centerTop >= availSpace.tooltipHeight) ? "bottom" : (availSpace.centerBottom >= availSpace.tooltipHeight) ? "top" : (availSpace.centerTop > availSpace.centerBottom) ? "bottom" : "top";
            else
                newPosition.stem.vertical = (newPosition.target.vertical == "top") ? "bottom" : "top";
        }
        return newPosition;
    };
    ejTooltip.prototype._collisionFit = function (position, availSpace) {
        var tooltipPos = $.extend(true, {}, this.tooltipPos), isHorizontalCollision = false, isVerticalCollision = false;
        var leftValue = 1, topValue = 1, arrowValue = null;
        var scrollLeft = $(this.model.containment).scrollLeft();
        var scrollTop;
        if (this.model.containment == "body") {
            scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        }
        else {
            scrollTop = $(this.model.containment).scrollTop();
        }
        var containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        if (tooltipPos.left < containerLeft || ((tooltipPos.left + tooltipPos.width) > (this.containerSize.width + scrollLeft + containerLeft))) {
            leftValue = (tooltipPos.left < containerLeft) ? containerLeft : ((tooltipPos.left + tooltipPos.width) > (this.containerSize.width + scrollLeft + containerLeft)) ? (tooltipPos.left - ((tooltipPos.left + tooltipPos.width) - (this.containerSize.width + containerLeft))) : 1;
            isHorizontalCollision = true;
        }
        if (tooltipPos.top < containerTop || ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop))) {
            topValue = (tooltipPos.top < containerTop) ? containerTop : ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop)) ? (tooltipPos.top - ((tooltipPos.top + tooltipPos.height) - (this.containerSize.height + containerTop))) : 1;
            isVerticalCollision = true;
        }
        $(this.tooltip).css({
            top: (topValue != 1) ? topValue + "px" : tooltipPos.top + "px",
            left: (leftValue != 1) ? leftValue + "px" : tooltipPos.left + "px",
            position: "absolute"
        });
        this._adjustArrow(position);
        arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top, height: this.model.tip.size.height, width: this.model.tip.size.width, display: $(this.tip).css("display") };
        this.tooltipPos.top = topValue = (topValue != 1) ? topValue : tooltipPos.top;
        this.tooltipPos.left = leftValue = (leftValue != 1) ? leftValue : tooltipPos.left;
        var tooltipWidth = $(this.tooltip).width(), tooltipHeight = $(this.tooltip).height();
        if (isHorizontalCollision || isVerticalCollision && (arrowValue.display != "none")) {
            if (this.model.isBalloon) {
                if (isHorizontalCollision)
                    this.arrowValue.left = this._horizontalAdjustment(position, availSpace);
                if (isVerticalCollision)
                    this.arrowValue.top = this._verticalAdjustment(position, availSpace);
            }
            if (this.arrowValue.left == -this.model.tip.size.height || this.arrowValue.left == tooltipWidth) {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "block" });
            }
            else if (this.arrowValue.top == -this.model.tip.size.height || this.arrowValue.top == tooltipHeight) {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "block" });
            }
            else {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "none" });
            }
        }
        this._shadowEffect(this.model.showShadow, position);
    };
    ejTooltip.prototype._horizontalAdjustment = function (position, availSpace) {
        var arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top };
        $(this.tooltip).css({ "display": "block" });
        var arrowSize = (position.target.horizontal != "center") ? this.model.tip.size.height : this.model.tip.size.height;
        var arrowLeft = (position.target.horizontal != "center" && position.stem.horizontal == "left") ? $(this.tip).offset().left : (position.target.horizontal != "center" && position.stem.horizontal == "right") ? $(this.tip).offset().left + arrowSize : $(this.tip).offset().left;
        $(this.tooltip).css({ "display": "none" });
        if ((arrowLeft > availSpace.leftSpace) && ((arrowLeft + arrowSize) < (availSpace.leftSpace + this.targetPos.width)))
            return arrowValue.left;
        else {
            if ((arrowLeft > (availSpace.leftSpace + this.targetPos.width)) || (arrowLeft < availSpace.leftSpace))
                arrowValue.left = (availSpace.leftSpace + this.targetPos.width / 2) - parseInt(this.tooltipPos.left.toString());
            return arrowValue.left;
        }
    };
    ejTooltip.prototype._verticalAdjustment = function (position, availSpace) {
        var arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top, height: this.model.tip.size.height, width: this.model.tip.size.width, display: this.arrowValue.display };
        $(this.tooltip).css({ "display": "block" });
        var arrowSize = (position.target.horizontal != "center") ? this.model.tip.size.height : this.model.tip.size.height;
        var arrowTop = (position.target.horizontal == "center" && position.stem.vertical == "top") ? $(this.tip).offset().top : $(this.tip).offset().top + arrowSize;
        $(this.tooltip).css({ "display": "none" });
        if ((arrowTop > availSpace.topSpace) && (arrowTop < (availSpace.topSpace + this.targetPos.height)))
            return arrowValue.top;
        else {
            if ((arrowTop < availSpace.topSpace) || ((arrowTop + arrowSize) > (availSpace.topSpace + this.targetPos.height)))
                arrowValue.top = (availSpace.topSpace + this.targetPos.height / 2) - parseInt(this.tooltipPos.top.toString());
            return arrowValue.top;
        }
    };
    ejTooltip.prototype._createHeader = function () {
        if (this.model.title != null) {
            if (ej.isNullOrUndefined(this.tooltipTitle))
                this._createTitle();
            if (ej.isNullOrUndefined(this.tooltipContent))
                $(this.tooltipHeader).appendTo(this.tooltipInter).addClass("e-tooltipHeader");
            else
                $(this.tooltipHeader).insertBefore(this.tooltipContent).addClass("e-tooltipHeader");
        }
        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky)
            this._iconRender();
    };
    ejTooltip.prototype._hideTooltip = function () {
        var speed;
        this._isHidden = true;
        speed = (this.model.animation.speed != 0) ? this.model.animation.speed : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? 200 : (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? 800 : 0;
        if (this.model.enabled == true && $(this.tooltip).css("display") == 'block') {
            if (this.triggerEvents("beforeClose", {}))
                return;
            (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? $(this.tooltip).fadeOut(speed) : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? $(this.tooltip).slideUp(speed) : $(this.tooltip).css({ display: "none" });
            if ($(this.tooltip).css("display") == 'none')
                $(this.tooltip).attr('aria-hidden', 'true').removeClass("e-customAnimation");
            if (this.triggerEvents("close", {}))
                return;
        }
    };
    ejTooltip.prototype._showTooltip = function () {
        if (this._isHidden) {
            var speed = (this.model.animation.speed != 0) ? this.model.animation.speed : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? 200 : (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? 800 : 0;
            this._isHidden = false;
            if ($(this.tooltip).css("display") == 'none' && this.model.enabled == true) {
                (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? $(this.tooltip).fadeIn(speed) : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? $(this.tooltip).slideDown(speed) : $(this.tooltip).css({ display: "block" });
                if ($(this.tooltip).css("display") == 'block') {
                    $(this.tooltip).attr('aria-hidden', 'false').css({ zIndex: ej.getMaxZindex() + 1 });
                    if (this.model.animation.effect == ej.Tooltip.Effect.None)
                        $(this.tooltip).addClass("e-customAnimation");
                    this._getScrollableParents();
                }
                if (this.triggerEvents("open", {}))
                    return;
            }
        }
    };
    ejTooltip.prototype._getScrollableParents = function () {
        var elements = $(this.element).parentsUntil("html").filter(function () {
            $(this).css("overflow") != "visible";
        }).add($(window));
        this._on(elements, "scroll", this._hideTooltip);
    };
    ejTooltip.prototype._tooltipAuto = function () {
        var proxy = this;
        this.timer = setTimeout(function () {
            proxy._hideTooltip();
        }, proxy.model.autoCloseTimeout);
    };
    ejTooltip.prototype._beforeOpenTooltip = function (event) {
        this.positionTooltip = $.extend(true, {}, this.model.position.stem);
        this.positionTarget = $.extend(true, {}, this.model.position.target);
        this.targetElement = this.element;
        if (!ej.isNullOrUndefined(this.model.target)) {
            if (!ej.isNullOrUndefined($(event.currentTarget).attr('data-content'))) {
                this.model.content = $(event.currentTarget).attr('data-content');
                this._setContent(this.model.content);
            }
        }
    };
    ejTooltip.prototype._targetHover = function (event) {
        this.isTrack = true;
        if (this.model.enabled) {
            if (this._isHidden || ((ej.browserInfo().name == 'msie' || ej.browserInfo().name == 'edge') && this.model.associate == ej.Tooltip.Associate.MouseFollow)) {
                this.tooltip.stop(true, true);
                if (this.triggerEvents("beforeOpen", { event: event })) {
                    this._isCancel = true;
                    return;
                }
                this._isCancel = false;
                this._beforeOpenTooltip(event);
                if (this.model.associate != ej.Tooltip.Associate.MouseEnter && this.model.associate != ej.Tooltip.Associate.MouseFollow) {
                    (!ej.isNullOrUndefined(this.model.target)) ? this._positionElement(event.currentTarget) : this._positionElement(this.element);
                    clearTimeout(this.timer);
                    this._showTooltip();
                    if (this.model.closeMode == ej.Tooltip.CloseMode.Auto)
                        this._tooltipAuto();
                    (event.type == "click") ? this.triggerEvents("click", { event: event }) : this.triggerEvents("hover", { event: event });
                }
                else
                    this.isTrack = true;
            }
            else if (!ej.isNullOrUndefined(this.model.target))
                this._positionElement(event.currentTarget);
        }
    };
    ejTooltip.prototype._onMouseOut = function (event) {
        if (this.model.enabled && !this._isHidden) {
            if (this.model.closeMode == ej.Tooltip.CloseMode.None)
                this._hideTooltip();
            clearTimeout(this.mouseTimer);
        }
        this.isTrack = false;
    };
    ejTooltip.prototype._onTooltipMouseEnter = function (event) {
        var proxy = this;
        if (this.model.enabled) {
            if (this.model.animation.effect == ej.Tooltip.Effect.None)
                $(proxy.tooltip).css({ display: "block" });
        }
    };
    ejTooltip.prototype._onTooltipMouseLeave = function (event) {
        var proxy = this;
        if (this.model.enabled) {
            if (this.model.animation.effect == ej.Tooltip.Effect.None) {
                if (proxy.model.closeMode == ej.Tooltip.CloseMode.None)
                    $(proxy.tooltip).css({ display: "none" });
            }
        }
    };
    ejTooltip.prototype._docTouchEndHandler = function (e) {
        if (!$(e.target).closest('.e-tooltip').length && this.model.closeMode == ej.Tooltip.CloseMode.None)
            this._hideTooltip();
    };
    ejTooltip.prototype._keyDown = function (event) {
        var code = (event.keyCode) ? event.keyCode : (event.which) ? event.which : event.charCode;
        if (this.model.enabled) {
            switch (code) {
                case 27:
                    event.preventDefault();
                    this._hideTooltip();
                    break;
            }
        }
    };
    return ejTooltip;
}(ej.WidgetBase));
window.ej.widget("ejTooltip", "ej.Tooltip", new ejTooltip());
window["ejTooltip"] = null;
ej.Tooltip.CloseMode = {
    Auto: "auto",
    None: "none",
    Sticky: "sticky"
};
ej.Tooltip.Effect = {
    Slide: "slide",
    Fade: "fade",
    None: "none"
};
ej.Tooltip.Trigger = {
    Hover: "hover",
    Click: "click",
    Focus: "focus"
};
ej.Tooltip.Collision = {
    Flip: "flip",
    FlipFit: "flipfit",
    None: "none",
    Fit: "fit"
};
ej.Tooltip.Associate = {
    Window: "window",
    MouseFollow: "mousefollow",
    MouseEnter: "mouseenter",
    Target: "target",
    Axis: "axis"
};
;
/**
* @fileOverview Plugin to style the Html ListView elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejListView", "ej.ListView", {
        _rootCSS: "e-lv",
        validTags:['div'],
        _prefixClass: "e-",
        defaults: {

            fieldSettings: {
                "navigateUrl": "navigateUrl",
                "href": "href",
                "enableAjax": "enableAjax",
                "preventSelection": "preventSelection",
                "persistSelection": "persistSelection",
                "text": "text",
                "enableCheckMark": "enableCheckMark",
                "checked": "checked",
                "primaryKey": "primaryKey",
                "parentPrimaryKey": "parentPrimaryKey",
                "imageClass": "imageClass",
                "imageUrl": "imageUrl",
                "childHeaderTitle": "childHeaderTitle",
                "childId": "childId",
                "childHeaderBackButtonText": "childHeaderBackButtonText",
                "renderTemplate": "renderTemplate",
                "templateId": "templateId",
                "attributes": "attributes",
                "mouseUp": "mouseUp",
                "mouseDown": "mouseDown",
                "groupID": "groupID",
                "id": "id"
            },

            mouseDown: null,

            mouseUp: null,

            items: [],
            dataSource: null,
            query: null,
        },



        dataTypes: {
            dataSource: "data",
            query: "data",
            itemRequestCount: "number",
            fieldSettings: "data",
            renderMode: "enum",
            theme: "enum",
            enablePersistence: "boolean"
        },
        observables: ["selectedItemIndex", "dataSource"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        dataSource: ej.util.valueFunction("dataSource"),
		checkedIndices: ej.util.valueFunction("checkedIndices"),

        _tags: [{
            tag: "items",
            attr:
                ["navigateUrl",
                "href",
                "text",
                "checked",
                "primaryKey",
                "parentPrimaryKey",
                "imageClass",
                "imageUrl",
                "childHeaderTitle",
                "childId",
                "childHeaderBackButtonText",
                "mouseUP",
                "mouseDown",
                "attributes",
                "renderTemplate",
                "templateId",
                "enableAjax",
                "preventSelection",
                "persistSelection",
                "enableCheckMark",
                "attributes"
                ],
            content: "template"
        }
        ],


        _init: function (options) {
            this._options = options;
            this._preventDefaultException = { tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT)$/ };
            this._storedContent = [];
            this._storedTemplate = [];
            this._tempContent = $("body");
            this._touchStart = this.model.mouseDown;
            this._touchEnd = this.model.mouseUp;
            this._oldEle = this.element.clone();
            if (this._oldEle.find("ul").length)
                this.model.items = [];
            this._indexVal = 0;
			this._setCulture();
			this._updateModelItems();
			if (this.model.allowVirtualScrolling) {
			    var litag;
			    this.dummyUl = $();
			    this._savedQueries = this.model.query.clone();
			}
            this._load();
            var navObj = this.element.closest(".e-nb.e-js");
            this._isInsideNavigation = navObj.length;
            if (this._isInsideNavigation)
                this._nearestND = navObj.ejNavigationDrawer("instance");
            this._responsive();
        },

        _responsive: function () {
			$(window).on("resize", $.proxy(this._resizeHandler, this));
        },

        _resizeHandler: function () {
			if ($(this.element).parent().width() == null && this.model == null) {
				$(this.element).width(this.width);
			}
			else if($(this.element).parent().width()<=this.model.width) {
				this.width = $(this.element).parent().width();
				$(this.element).width(this.width);
			}
			else
				$(this.element).width(this.model.width);
        },

        _itemsObjectCollection: function (element, primaryKey, parentPrimaryKey, groupid) {
            if (ej.getAttrVal(element, "data-ej-rendertemplate")) {
                var tempid = this._tempContent.find('#' + ej.getAttrVal(element, "data-ej-templateid"));
                if (tempid.length) {
                    var ele = tempid.remove();
                    this._storedTemplate[this._indexVal] = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                }
                else if (!this._storedTemplate[this._indexVal])
                    if ($(element)[0].innerHTML)
                        this._storedTemplate[this._indexVal] = $(element)[0].innerHTML;
                    else if (this._storedTemplate[this._indexVal] && this._tempContent.find('#' + template).length) {
                        var ele = this._tempContent.find('#' + template).remove();
                        ele = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                        this._storedTemplate = ej._pushValue(this._storedTemplate, ele, this._indexVal);
                    }
                this._indexVal++;
            }
          return  this._getLiAttributes(element, primaryKey, parentPrimaryKey, groupid);
        },

        _getLiAttributes: function (element, primaryKey, parentPrimaryKey, groupid) {
            var item = {};
            item.groupID = groupid ? groupid : "",
            item.text = ej.getAttrVal(element, "data-ej-text") ? ej.getAttrVal(element, "data-ej-text") : this._getText(element);
            item.preventSelection = ej.getAttrVal(element, "data-ej-preventselection");
            item.persistSelection = ej.getAttrVal(element, "data-ej-persistselection");
            item.navigateUrl = ej.getAttrVal(element, "data-ej-navigateurl");
            item.href = ej.getAttrVal(element, "data-ej-href");
            item.checked = ej.getAttrVal(element, "data-ej-checked");
            item.primaryKey = ej.getAttrVal(element, "data-ej-primarykey", primaryKey);
            item.parentPrimaryKey = ej.getAttrVal(element, "data-ej-parentprimarykey", parentPrimaryKey);
            item.imageClass = ej.getAttrVal(element, "data-ej-imageclass");
            item.imageUrl = ej.getAttrVal(element, "data-ej-imageurl");
            item.childHeaderTitle = ej.getAttrVal(element, "data-ej-childheadertitle");
            item.childId = item.href ? ej.getAttrVal(element, "data-ej-childid") ? ej.getAttrVal(element, "data-ej-childid") : ("page_" + parseInt(Math.random().toFixed(3) * 1000)) : "";
            item.childHeaderBackButtonText = ej.getAttrVal(element, "data-ej-childheaderbackbuttontext");
            item.mouseUp = ej.getAttrVal(element, "data-ej-mouseUp");
            item.mouseDown = ej.getAttrVal(element, "data-ej-mouseDown");
            if (this.element.find('li').length > 0) item.attributes = (typeof(element)=="object")? element.attrNotStartsWith(/^data-ej-/):$(element).attrNotStartsWith(/^data-ej-/);
            item.renderTemplate = ej.getAttrVal(element, "data-ej-rendertemplate");
            item.templateId = this._storedTemplate[this._indexVal - 1],
            item.enableAjax = ej.getAttrVal(element, "data-ej-enableajax");
            item.enableCheckMark = ej.getAttrVal(element, "data-ej-enablecheckmark");
            return item;
        },



        _renderLists: function () {
            var list = ej.buildTag("li", "", {}, {
                "class": this._prefixClass + "user-select " + this._prefixClass + "list " + this._prefixClass + "state-default{{if " + this.model.fieldSettings['primaryKey'] + " || " + this.model.fieldSettings['enableAjax'] + " || " + this.model.enableAjax + "}} " + this._prefixClass + "arrow{{/if}}{{if " + this.model.fieldSettings['imageClass'] + "}} " + this._prefixClass + "margin{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}} " + this._prefixClass + "margin{{/if}}{{/if}}",
                "data-childid": "{{if " + this.model.fieldSettings['primaryKey'] + "}}child{{>" + this.model.fieldSettings['primaryKey'] + "}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}",
                "data-childheadertitle": "{{>" + this.model.fieldSettings['childHeaderTitle'] + "}}",
                "data-childheaderbackbuttontext": "{{>" + this.model.fieldSettings['childHeaderBackButtonText'] + "}}",
                "data-preventSelection": "{{>" + this.model.fieldSettings['preventSelection'] + "}}",
                "data-persistSelection": "{{>" + this.model.fieldSettings['persistSelection'] + "}}",
                "data-navigateUrl": "{{>" + this.model.fieldSettings['navigateUrl'] + "}}",
                "data-loadajax": "{{>" + this.model.fieldSettings['enableAjax'] + "}}",
                "data-href": '{{>' + this.model.fieldSettings['href'] + '}}{{:~_checkAjaxUrls()}}',
                "data-checked": '{{>' + this.model.fieldSettings['checked'] + '}}',
                "data-templateid": "{{>" + this.model.fieldSettings['renderTemplate'] + "}}",
                "data-mouseup": "{{>" + this.model.fieldSettings['mouseUp'] + "}}",
                "data-mousedown": "{{>" + this.model.fieldSettings['mouseDown'] + "}}",
                "data-id": "{{>" + this.model.fieldSettings['id'] + "}}"
            });
            if (this.model.renderTemplate) {
               if (this._hasDataSource() && this._template){
                    var check = this._createCheckBox();
                    list[0].innerHTML = this._template+"{{if " + this.model.fieldSettings['enableCheckMark'] + " !== undefined}}{{if " + this.model.fieldSettings['enableCheckMark'] + ".toString() == 'false' ? " + this.model.fieldSettings['enableCheckMark'] + " : " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{else}}{{if " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{/if}}";
            }
            }
            else {
                var linkTag = ej.buildTag("a", "", {}, { "class": this._prefixClass + "chevron-right_01 " + this._prefixClass + "remove-shadow{{if " + this.model.fieldSettings['imageClass'] + "}} " + this._prefixClass + "margin{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}} " + this._prefixClass + "margin{{/if}}{{/if}}{{if " + this.model.fieldSettings['primaryKey'] + " || " + this.model.fieldSettings['enableAjax'] + " || " + this.model.enableAjax + "}} " + this._prefixClass + "fontimage e-icon{{/if}}", "href": (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 ? "" : "{{if " + this.model.fieldSettings['navigateUrl'] + " == '' || " + this.model.fieldSettings['navigateUrl'] + " == undefined }}{{else}}{{:" + this.model.fieldSettings['navigateUrl'] + "}}{{/if}}") }); 
                (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) && linkTag.removeAttr('href');
				var span = ej.buildTag("span", "{{>" + this.model.fieldSettings['text'] + "}}", {}, { "class": this._prefixClass + "list-text " + this._prefixClass + "rel " + this._prefixClass + "user-select{{if " + this.model.fieldSettings['imageClass'] + "}} " + this._prefixClass + "text{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}} " + this._prefixClass + "text{{/if}}{{/if}}" });
                var imgClass = ej.buildTag("div", "", {}, { 'class': this._prefixClass + "list-img " + this._prefixClass + "rel " + this._prefixClass + "user-select {{>" + this.model.fieldSettings['imageClass'] + "}}" });
                var check = this._createCheckBox();
                if (this.model.renderMode == "windows" && ej.isMobile())
                    linkTag[0].innerHTML = "{{if !" + this.model.fieldSettings['primaryKey'] + "}}{{if " + this.model.fieldSettings['enableAjax'] + " == undefined || " + this.model.fieldSettings['enableAjax'] + ".toString() == 'false'}}{{if !" + this.model.fieldSettings['navigateUrl'] + "}}{{if " + this.model.fieldSettings['enableCheckMark'] + " !== undefined}}{{if " + this.model.fieldSettings['enableCheckMark'] + ".toString() == 'false' ? " + this.model.fieldSettings['enableCheckMark'] + " : " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{else}}{{if " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{/if}}{{/if}}{{/if}}{{/if}}" + "{{if " + this.model.fieldSettings['imageClass'] + "}}" + imgClass[0].outerHTML + "{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}}{{:~_checkImgUrls()}}{{/if}}{{/if}}" + span[0].outerHTML;
                else
                    linkTag[0].innerHTML = "{{if " + this.model.fieldSettings['imageClass'] + "}}" + imgClass[0].outerHTML + "{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}}{{:~_checkImgUrls()}}{{/if}}{{/if}}" + span[0].outerHTML + "{{if !" + this.model.fieldSettings['primaryKey'] + "}}{{if " + this.model.fieldSettings['enableAjax'] + " == undefined || " + this.model.fieldSettings['enableAjax'] + ".toString() == 'false'}}{{if !" + this.model.fieldSettings['navigateUrl'] + "}}{{if " + this.model.fieldSettings['enableCheckMark'] + " !== undefined}}{{if " + this.model.fieldSettings['enableCheckMark'] + ".toString() == 'false' ? " + this.model.fieldSettings['enableCheckMark'] + " : " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{else}}{{if " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{/if}}{{/if}}{{/if}}{{/if}}";

                list[0].innerHTML = "{{if " + this.model.fieldSettings['renderTemplate'] + " == undefined || " + this.model.fieldSettings['renderTemplate'] + ".toString() == 'false'}}" + linkTag[0].outerHTML + "{{else}}{{:templateId}}{{/if}}";
            }
            if (this.model.renderMode == "ios7") {
                var innerDiv = ej.buildTag("div." + this._prefixClass + "list-div");
                innerDiv[0].innerHTML = list[0].innerHTML;
                list.empty().append(innerDiv);
            }
            return list;
        },


        _updateContent: function (currentItem, backButton) {
            var proxy = this;
            var $curIte = $(currentItem), childid = $curIte.attr('data-childid');
            var id = this._isInsideNavigation && currentItem.attr('data-href') ? $('body').find($("#" + childid)) : this.element.find($("#" + childid));
            if (id.length) {
                var hdr = this.element.find('#' + childid + '_header');
                if (this.model.enableFiltering)
                    this._initializeFiltering($(id));
                var title = $curIte.attr('data-childheadertitle') == undefined ? currentItem.text() : $curIte.attr('data-childheadertitle');
                if (hdr.hasClass('e-header')) {
                    this._setHeaderVal(childid, title, backButton);
                }
                id.attr("data-hdr-title", title).attr("data-hdr-bckbtn", backButton);
                this._initEJCheckBox(id);
                if (this._isInsideNavigation && currentItem.attr('data-href') && this._nearestND.model.contentId) {
                    if ($('body').find('.e-lv.subpage.e-childitem')) {
                        $("#" + this._nearestND.model.contentId).empty().append(id.show());
                    }
                }
                else {
                    $curIte.closest('.subpage').hide();
                    id.show();
					this._childContainer = id.find('.' + this._prefixClass + 'list-container');
					this._childContainer.ejScroller({
                        height: this._childContainer.height(),
                        width: 0,
                        scrollerSize: 20
                    });
			        this.scrollerObj = this._childContainer.ejScroller("instance");
					this._containerHeight = this.element.height() - ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'lv-inputdiv'), 'outerHeight')-ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight');
					if (this.model.height !== null) {
				        if (this._childContainer.height() > this._containerHeight) {
			                this._refreshScroller(this._childContainer,true);
					    }
				    }
				    if (this.scrollerObj) {
						this.scrollerObj.refresh();
						$(this.scrollerObj.element).find(".e-vhandlespace").css("height",($(this.scrollerObj.element).find(".e-vhandlespace").height() - 1));
					}
                    $(this.element.children()[0]).removeClass("e-slideright");
                    id.addClass("e-slideleft");
                }
            }
        },



        _renderHeader: function (id, showbutton, title, backtext) {
            var header = ej.buildTag("div", "", {}, { "id": id + "_header", "class": "e-header e-box" });
            if (showbutton) {
                header.append("<span class='e-hicon e-icon e-chevron-left_01'></span>");
                header.append("<div class='e-btn-text'>" + (backtext ? backtext : "Back") + "</div>");
            }
            else
                header.append("<div class='e-htitle'>" + title + "</div>");
            return header;
        },
        _setHeaderVal: function (id, title, backtext) {
            this._onBackButtonDelegate = $.proxy(this._onBackButtonClick, this);
            ej.listenTouchEvent($("#" + id + "_header"), ej.endEvent(), this._onBackButtonDelegate, false, this);
            var backButtonText = this.model.showHeaderBackButton ? this.model.headerBackButtonText ? this.model.headerBackButtonText : backtext : backtext;
            $("#" + id + "_header").find(".e-btn-text").text(backtext ? backButtonText : "Back");
            $("#" + id + "_header").find(".e-htitle").text(title);
        },
        _onBackButtonClick: function (e) {
            this.element.find(".e-slideleft").removeClass("e-slideleft");
            this.element.children(":visible").hide();
            $(this.element.children()[0]).show();
            $(this.element.children()[0]).addClass("e-slideright");
            if (this.model.enableFiltering)
            this._initializeFiltering($(this.element.children()[0]));
     },


        _returnData: function () {
            var checkedItem = this._currentItem.closest('ul.e-list-hdr').find('.e-chkbox-wrap[aria-checked="true"]').closest("li");
            var elementId = ej.getAttrVal(this._currentItem, "data-id", this._currentItem.text());
            var items = this.dataSource().length ? typeof this.dataSource() == "string" ? eval(this.dataSource()) : this.dataSource() : this.model.items;
            return {
                hasChild: this._currentItem.attr("data-childid") && this._currentItem.attr('data-childid').length > 0 ? (this.element.find('#' + this._currentItem.attr('data-childid')).length ? true : false) : false,
                item: this._currentItem,
                text: this._currentItem.text(),
                index: this._currentItem.index(),
                isChecked: this._currentItem.find("input.e-lv-check").closest('.e-chkbox-wrap').attr('aria-checked') == "true" ? true : false,
                checkedItems: checkedItem.length ? checkedItem : null,
                checkedItemsText: $(checkedItem).map(function () { return $(this).text(); }).get(),
                itemData: this._generateData(items, elementId),
                checkedValues: this.checkedIndices()  
            };
        },
        _initEJCheckBox: function (ul) {
            var liItems = ul.find("li");
            var count = liItems.length;
            for (i = 0; i < count; i++) {
                if (this.model.enablePersistence || this.model.checkedIndices.length > 0 ) {   
                    var localItems = this.model.checkedIndices;
                    var checked = this._hasValue(localItems, i);
                }
                else {
                    var checked = ej.getAttrVal($(liItems[i]), "data-checked");
                    var checked = checked == "true" ? true : false;
                }
                $($(liItems[i]).find(".e-lv-check")).ejCheckBox({ checked: checked });
            }
            ul.find('.e-lv-checkdiv').removeClass("e-lv-checkdiv")
            ul.find('.e-lv-check').parent().addClass("e-lv-checkdiv")
        },
        _triggerStartEvent: function (data) {
			if (ej.browserInfo().name == "msie" && ej.browserInfo().version == 8)
				this.model.mouseDown = this._touchStart;
            else this.model.mouseDown = ej.getAttrVal(this._currentItem, 'data-mousedown', this._touchStart);
                this._trigger("mouseDown", data);
        },

        _triggerEndEvent: function (data, evt) {
			if (ej.browserInfo().name == "msie" && ej.browserInfo().version == 8)
				this.model.mouseUp = this._touchEnd;
            else this.model.mouseUp = ej.getAttrVal(this._currentItem, 'data-mouseup', this._touchEnd);
            this.selectedItemIndex(this._currentItem.index());
            if (this.model.enablePersistence || this.model.enableCheckMark) {
                var state = this._currentItem.find('.e-chkbox-wrap'), index = this._currentItem.index();
                if (state.attr('aria-checked') == 'true' || (index||$(evt.target).parent().hasClass('e-chk-inact'))) {
                    if (!this._hasValue(this._checkedValues, index))
                        this._checkedValues.push(index);
                    else
                        this._checkedValues.splice(this._checkedValues.indexOf(index), 1);
                }
                else
                    this._checkedValues.splice(this._checkedValues.indexOf(index), 1);
            }
            this.checkedIndices(this._checkedValues);
            if (this.model.mouseUp)
                this._trigger("mouseUp", data);
        },
        _createFilterDiv: function () {
            return ej.buildTag('div.e-lv-filter', ej.buildTag('input.e-lv-input', "", {}, { 'type': 'text', 'placeholder': 'search' }));
        },
        _emptyFilterTextValue: function (element) {
            element.find('.e-lv-input').val("");
        },
        _createListDiv: function (childId) {
            this._div = ej.buildTag("div#" + childId + "." + this._rootCSS + " subpage e-childitem e-ajaxchild", (this.model.showHeader && this._isInsideNavigation && !this._nearestND.model.contentId) ? this._renderHeader(childId, true, this._currentItem.text()) : "");
        },
        _createCheckBox: function () {
            return ej.buildTag("input.e-lv-check", "", {}, { "type": "checkbox", });
        },
        _toggleCheckboxValue: function (lbCheck) {
            lbCheck.ejCheckBox({ checked: $(lbCheck.closest('.e-chkbox-wrap')).attr('aria-checked') == "true" ? false : true });
        },
        _setCheckboxValue: function (element, val) {
            element.ejCheckBox({ checked: val });
        },
        _convertToRelativeUrl: function (url) {
            return url;
        },
		_setCulture: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.headerTitle)) this._localizedLabels.headerTitle = this._options.headerTitle;
                if (!ej.isNullOrUndefined(this._options.headerBackButtonText)) this._localizedLabels.headerBackButtonText = this._options.headerBackButtonText;
            }
            this.model.headerTitle = this._localizedLabels.headerTitle;
            this.model.headerBackButtonText = this._localizedLabels.headerBackButtonText;
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
		
    });
	 ej.ListView.Locale = ej.ListView.Locale || {};
        ej.ListView.Locale["default"] = ej.ListView.Locale["en-US"] = {
            headerTitle: "Title",
            headerBackButtonText: "",
        };
    $.extend(true, ej.ListView.prototype, ej.ListViewBase.prototype);
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Navigation Drawer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejNavigationDrawer", "ej.NavigationDrawer", {

        _setFirst: true,
        validTags: ["div"],
        _rootCSS: "e-nb",
        _prefixClass: "e-",

        defaults: {
            isPaneOpen: false
        },

        dataTypes: {
            isPaneOpen: "boolean"
        },

        _init: function () {
            this._load();
            this._renderControl();
            this._renderEJMControls();
            this._createDelegate();
            this._wireEvents();
        },

        _load: function () {
            this._browser = this._getBrowserAgent();
            if (this.model.position == "normal") {
                if (!this.model.isPaneOpen) {
                    this._elementWrapper = ej.buildTag("div#" + this._id + "_WrapContainer", {}, {}, { "class": this._rootCSS + " e-nb-container e-nb-" + this.model.direction.toLowerCase() });
                    this.element.wrapAll(this._elementWrapper);
                    this._nbHome = $("#" + this._id + "_WrapContainer").parent();
                }
                else {
                    this.element.siblings().wrapAll("<div id='" + this._id + "_PageContainer' class='e-nb-container e-nb-pageContainer'></div>")
                    this._pageContainer = this._nbHome = this.element.siblings();
                }
            }
            else {
                this._nbHome = $("body");
                this.element.appendTo(this._nbHome);
            }
            this._nbHomeCss = this._nbHome.clone(true)[0].style;
        },

        _renderEJMControls: function () {
            if (this.model.enableListView) {
                this._lb = ej.buildTag("div#" + this._id + "_listview", {}, {}, { "class": "e-nb-listview" });
                if (this.model.items.length || this.model.listViewSettings.dataSource.length)
                    this._lb.appendTo(this.element);
                else
                    this.element.find(">ul").wrapAll(this._lb);
                this._lb = $("#" + this._id + "_listview");
                if (!this.model.listViewSettings["width"])
                    this.model.listViewSettings["width"] = 240;
                this.model.listViewSettings.items = this.model.items;
                this._lb.ejListView($.extend({}, this.model.listViewSettings, { loadComplete: $.proxy(this._setLayout, this) }));
                this._lbObj = this._lb.data("ejListView"); 
                this._lb.ejListView("selectItem", this.model.listViewSettings.selectedItemIndex);
            }
			else
				this.element.find(".e-nb-listview").empty();
        },

        _setModel: function (options) {
            var refresh = false;
            for (var prop in options) {
                switch (prop) {
                    case "width":
                        this._setWidth();
                        this._setLayout();
                        break;
                    case "direction":
                        this._setLayout();
                        break;
                    case "type":
                        this._transform(0, 0, true);
                        this._transform(0, 0, false);
                        break;
                    case "isPaneOpen":
                        this.model[prop] = options[prop];
						this.element.hide();
						if(options[prop]) {
							$(this._elementWrapper,this._elementShadow,this._elementOverlay).remove();
							this.element.removeAttr("style").height("100%");
							this.element.unwrap();
						}
						else{
							this._pageContainer.children().unwrap();
							this._pageContainer.remove();
						}
						this._load();
						this._shadowWrapper();
						if (this.model.enableListView) this._renderEJMControls();
						this._wireEvents();
						break;
					case "enableListView":
					    this._renderEJMControls();
						break;
                    default:
                        refresh = true;
                }
                if (refresh) { this._refresh(); }
            }
        },

        _destroyEJMPlugin: function () {
            if (this._lb) {
                this._lb.ejListView("destroy");
                this._lb.children().unwrap();
            }
            if (this.model.contentId) $("#" + this.model.contentId).empty();
			if (this._id) $("#"+this._id).hide();
        },

        _getBrowserAgent: function () {
            return (/webkit/i).test(navigator.appVersion) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : (/trident/i).test(navigator.userAgent) ? 'ms' : 'opera' in window ? 'O' : '';
        }

    });
    $.extend(true, ej.NavigationDrawer.prototype, ej.NavigationDrawerBase.prototype);
    $.extend(true, ej.NavigationDrawer.prototype.defaults.listViewSettings, ej.ListView.prototype.defaults);
    ej.NavigationDrawer.prototype._tags = ej.ListView.prototype._tags;

})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html UL elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejListBox", "ej.ListBox", {

        element: null,
        _ignoreOnPersist: ["dataSource", "query", "itemRequestCount", "fields", "create", "change", "select", "unselect", "itemDragStart", "itemDrag", "itemDragStop", "itemDrop", "checkChange", "destroy", "actionComplete", "actionFailure", "actionSuccess", "actionBegin", "itemDropped", "selected"],
        model: null,
        validTags: ["ul"],
        _setFirst: false,
        _rootCSS: "e-listbox",
        defaults: {
            itemsCount: null,
            totalItemsCount: null,
            dataSource: null,
            query: ej.Query(),
            itemRequestCount: 5,
            itemHeight:null,
            fields: {
                id: null,
                text: null,
                imageUrl: null,
                imageAttributes: null,
                spriteCssClass: null,
                htmlAttributes: null,
                tooltipText: null,
                selectBy: null,
                checkBy: null,
                groupBy: null,
                tableName: null,

                //deprecated field properties
                selected: null,
                category: null,
                toolTipText: null
            },
            height: "auto",
            width: "200",
            template: null,
            text: "",
            selectedIndex: null,
            checkedIndices: [],
            selectedIndices: [],
            cascadeTo: null,
            value: "",
            cssClass: "",
            targetID: null,
            htmlAttributes: {},
            showRoundedCorner: false,
            enableRTL: false,
            enabled: true,
            showCheckbox: false,
            allowVirtualScrolling: false,
            virtualScrollMode: "normal",
            enablePersistence: false,
            allowMultiSelection: false,
            allowDrag: false,
            allowDrop: false,
            enableIncrementalSearch: false,
            enableWordWrap:true,
            caseSensitiveSearch: false,
            loadDataOnInit: true,
            create: null,
            change: null,
            select: null,
            unselect: null,
            itemDragStart: null,
            itemDrag: null,
            itemDragStop: null,
            itemDrop: null,
            checkChange: null,
            destroy: null,
            actionComplete: null,
            actionSuccess: null,
            actionBeforeSuccess:null,
            focusIn:null,
            focusOut:null,
            actionFailure: null,
            actionBegin: null,
			cascade: null,
            sortOrder: "none",

            //Deprecated Members
            enableVirtualScrolling: false,
            checkAll: false,
            uncheckAll: false,
            enableLoadOnDemand: false,
            itemRequest: null,
            allowDragAndDrop: undefined,
            selectedItemIndex: null,
            enableItemsByIndex: null,
            checkItemsByIndex: null,
            disableItemsByIndex: null,
            uncheckItemsByIndex: null,
            itemDropped: null,
            selected: null,
            selectIndexChanged: null,
            selectedItems: [],
            checkedItems: [],
            checkedItemlist: [],
            selectedItemlist: [],
        },
        dataTypes: {
            cssClass: "string",
            itemsCount: "number",
            itemRequestCount: "number",
            allowDrag: "boolean",
            allowDrop: "boolean",
            enableWordWrap:"boolean",
            enableIncrementalSearch: "boolean",
            caseSensitiveSearch: "boolean",
            template: "string",
            targetID: "string",
            cascadeTo: "string",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            enabled: "boolean",
            allowMultiSelection: "boolean",
            dataSource: "data",
            query: "data",
            checkedIndices: "data",
            selectedIndices: "data",
            htmlAttributes: "data",
            loadDataOnInit: "boolean",
            showCheckbox: "boolean",
            sortOrder: "enum"
        },
        observables: ["value", "dataSource"],
        value: ej.util.valueFunction("value"),
        dataSource: ej.util.valueFunction("dataSource"),
        enable: function () {
            if (this.listContainer.hasClass("e-disable")) {
                this.target.disabled = false;
                this.model.enabled = this.model.enabled = true;
                this.element.removeAttr("disabled");
                this.listContainer.removeClass('e-disable');
                if (this.model.allowMultiSelection) this.listContainer.removeClass("e-disable");
                var scroller = this.listContainer.find(".e-vscrollbar,.e-hscrollbar");
                if (this.model.showCheckbox) { 
                    var items = this.listContainer.find('li:not(.e-disable)');
                    items.find(".listcheckbox").ejCheckBox("enable");
                }
                if (scroller.length > 0)
                    this.scrollerObj.enable();
            }
        },
        disable: function () {
            if (!this.listContainer.hasClass("e-disable")) {
                this.target.disabled = true;
                this.model.enabled = this.model.enabled = false;
                this.element.attr("disabled", "disabled");
                this.listContainer.addClass('e-disable');
                if (this.model.allowMultiSelection) this.listContainer.addClass("e-disable");
                var scroller = this.listContainer.find(".e-vscrollbar,.e-hscrollbar");
                if (this.model.showCheckbox) this.element.find(".listcheckbox").ejCheckBox("disable");
                if (scroller.length > 0)
                    this.scrollerObj.disable();
            }
        },
        selectItemByIndex: function (index) {            
            var prevSelectedItem = this.model.selectedIndex, listitems= (this.listitems)?this.listitems:this.listitem;
			if(index!=0) index=parseInt(index);       
            if (index != null && !this.model.showCheckbox) {				
                if ((index > this.element.find("li:not('.e-ghead')").length) || (index < 0) || ((1 / index) == -Infinity))
					 index=this.model.selectedIndex;                    				
                var activeitem = $(this.element.find("li:not('.e-ghead')")[index]);
                if (!activeitem.hasClass("e-select")) {
                    this._activeItem = index;
                    this.element.children("li").removeClass("e-select");
                    this._selectedItems = [];
                    this.model.selectedIndices = [];
                    activeitem.addClass("e-select");
                    this._selectedItems.push(activeitem);
                    this.model.selectedIndices.push(index);
                    var selectData = this._getItemObject(activeitem, null);
                    selectData["isInteraction"] = false;
                    if (this.model.select)
                        this._trigger('select', selectData);
                }
            }
            if (this.model.cascadeTo) {
                this._activeItem = index;
                this._cascadeAction();
            }
            this._setSelectionValues()._OnListSelect(prevSelectedItem, this._activeItem);;
        },
        checkItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.checkItemsByIndices(index.toString());
        },
        uncheckItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.uncheckItemsByIndices(index.toString());
        },
        checkItemsByIndices: function (index) {
            if ((ej.isNullOrUndefined(index))) return false;
            var checkitems = index.toString().split(',');
            if (checkitems.length > 0) {
                for (var i = 0; i < checkitems.length; i++) {
                    if (checkitems[i] != null) {
                        this._activeItem = parseInt(checkitems[i]);
                        if (this._activeItem < 0) this._activeItem = 0;
                        var activeitem = $(this.element.children("li:not('.e-ghead')")[this._activeItem]);
                        if (this.model.showCheckbox) {
                            if (!($(activeitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                                $(activeitem).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                                this.checkedStatus = true;
                                if (!($.inArray(this._activeItem, this._checkedItems) > -1)) this._checkedItems.push(this._activeItem);
                                if (!($.inArray(activeitem[0], this.model.checkedIndices) > -1)) this.model.checkedIndices.push(this._activeItem);
                                var checkData = this._getItemObject(activeitem, null);
                                checkData["isInteraction"] = false;
                                if (this.model.checkChange)
                                    this._trigger('checkChange', checkData);
                            }
                        }
                    }
                }
            }
            this._setSelectionValues();
        },
        uncheckItemsByIndices: function (value) {
            if ((ej.isNullOrUndefined(value))) return false;
            var checkitems = value.toString().split(',');
            if (checkitems.length > 0) {
                for (var i = 0; i < checkitems.length; i++) {
                    if (checkitems[i] != null) {
                        var index = parseInt(checkitems[i]);
                        var unselectitem = $(this.element.children("li:not('.e-ghead')")[parseInt(index)]);
                        if (this.model.showCheckbox) {
                            if (($(unselectitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                                $(unselectitem).find('.listcheckbox').ejCheckBox('option', 'checked', false);
                                this.checkedStatus = false;
                                var itemIndex = $.inArray(index, this.model.checkedIndices);
                                if ($.inArray(index, this._checkedItems) > -1) this._checkedItems.splice(itemIndex, 1);
                                if (itemIndex > -1) this.model.checkedIndices.splice(itemIndex, 1);
                                var unselectData = this._getItemObject(unselectitem, null);
                                unselectData["isInteraction"] = false;
                                if (this.model.checkChange)
                                    this._trigger('checkChange', unselectData);
                            }
                        }
                    }
                }
            }
            this._setSelectionValues();
        },
        selectAll: function () {
            if (!this.model.showCheckbox && this.model.allowMultiSelection) {
                var activeItem = this.element.children("li:not('.e-ghead')");
                for (var i = 0; i < activeItem.length; i++) {
                    if (!$(activeItem[i]).hasClass("e-select") && !$(activeItem[i]).hasClass("e-disable")) {
                        $(activeItem[i]).addClass("e-select");
                        this._selectedItems.push($(activeItem[i]));
                        this.model.selectedIndices.push(i);
                        var selectData = this._getItemObject(activeItem, null);
                        selectData["isInteraction"] = false;
                        if (this.model.select)
                            this._trigger('select', selectData);
                    }
                }
            }
            this._setSelectionValues();
        },
        //Deprecated Method
        unSelectAll: function () { this.unselectAll(); },
        unselectAll: function () {
            if (!this.model.showCheckbox)
                this._removeListHover();
            this._setSelectionValues();
            return this;
        },
        //deprecated function
        selectItemsByIndex: function (value) {
            this.selectItemsByIndices(value);
        },
        selectItemsByIndices: function (value) {
            if (ej.isNullOrUndefined(value)) return false;
            var selectitems = value.toString().split(',');
            if (!this.model.showCheckbox && this.model.allowMultiSelection) {
                for (var i = 0; i < selectitems.length; i++) {
                    if (selectitems[i] != null && !isNaN(parseInt(selectitems[i])) && selectitems[i] < this.element.children('li').length) {
                        var index = parseInt(selectitems[i]);
                        this._activeItem = index;
                        var activeitem = $(this.element.children("li:not('.e-ghead')")[this._activeItem]);
                        if (!activeitem.hasClass("e-select")) {
                            activeitem.addClass("e-select");
                            this._selectedItems.push(activeitem);
                            this.model.selectedIndices.push(index);
                            var selectData = this._getItemObject(activeitem, null);
                            selectData["isInteraction"] = false;
                            if (this.model.select)
                                this._trigger('select', selectData);
                        }
                    }
                }
            }
            this._setSelectionValues();
        },
        //deprecated property
        unselectItemsByIndex: function (value) {
            this.unselectItemsByIndices(value);
        },
        unselectItemsByIndices: function (value) {
            if (this.model.showCheckbox) return false;
            var selectitems = value.toString().split(',');
            for (var i = 0; i < selectitems.length; i++) {
                if (selectitems[i] != null) {
                    var index = parseInt(selectitems[i]);
                    var activeitem = $(this.listItemsElement[index]);
                    this._activeItem = index;
                    activeitem.removeClass('e-active e-select');
                    if (this.model.selectedIndex == index) this.model.selectedIndex = this._activeItem = null;
                    var itemIndex = this._selectedItems.indexOf(activeitem[0]);
                    this._selectedItems.splice(this.model.selectedIndices.indexOf(itemIndex), 1);
                    this.model.selectedIndices.splice(this.model.selectedIndices.indexOf(itemIndex), 1);

                    var unselectData = this._getItemObject(activeitem, null);
                    unselectData["isInteraction"] = false;
                    if (this.model.unselect)
                        this._trigger('unselect', unselectData);
                }
            }
            this._setSelectionValues();
        },
        unselectItemByIndex: function (index) {
            if (this.model.showCheckbox) return false;
            index = parseInt(index);
            var unselectitem = $(this.element.children("li:not('.e-ghead')")[index]);
            if (unselectitem.hasClass('e-select')) {
                unselectitem.removeClass('e-active e-select');
                if (this.model.selectedIndex == index) this.model.selectedIndex = this._activeItem = null;
                var itemIndex = this._selectedItems.indexOf(unselectitem[0]);
                this._selectedItems.splice(this.model.selectedIndices.indexOf(itemIndex), 1);
                this.model.selectedIndices.splice(this.model.selectedIndices.indexOf(itemIndex), 1);
                var unselectData = this._getItemObject(unselectitem, null);
                unselectData["isInteraction"] = false;
                if (this.model.unselect)
                    this._trigger('unselect', unselectData);
            }
            this._setSelectionValues();
        },
        selectItemByText: function (text) {
            if (!ej.isNullOrUndefined(text))
            this[(this.model.allowMultiSelection ? "selectItemsByIndices" : "selectItemByIndex")](this.getIndexByText(text));
        },
        selectItemByValue: function (value) {
            this[(this.model.allowMultiSelection ? "selectItemsByIndices" : "selectItemByIndex")](this.getIndexByValue(value));
        },
        unselectItemByText: function (text) {
            this[(this.model.allowMultiSelection ? "unselectItemsByIndices" : "unselectItemByIndex")](this.getIndexByText(text));
        },
        unselectItemByValue: function (value) {
            this[(this.model.allowMultiSelection ? "unselectItemsByIndices" : "unselectItemByIndex")](this.getIndexByValue(value));
        },
        getSelectedItems: function () {
            var items = [], proxy = this;
            $(proxy.model.selectedIndices).each(function (index, elementIndex) {
                items.push(proxy.getItemByIndex(elementIndex));
            });
            return items;
        },
        getCheckedItems: function () {
            var items = [], proxy = this;
            $(proxy.model.checkedIndices).each(function (index, elementIndex) {
                items.push(proxy.getItemByIndex(elementIndex));
            });
            return items;
        },
        removeItem: function () {
            return this.removeSelectedItems();
        },
        removeItemByText: function (text) {
            if (ej.isNullOrUndefined(this.getItemByText(text))) return false;
            return this.removeItemByIndex(this.getItemByText(text).index);
        },
        hideSelectedItems: function () {
            var items = this.getSelectedItems();
            this._hideOrShowItemsByIndex(items, "hide");
        },
        hideCheckedItems: function () {
            var items = this.getCheckedItems();
            this._hideOrShowItemsByIndex(items, "hide");
        },
        _hideOrShowItemsByIndex: function (items, hideOrShow) {
            if ($.type(items) == "number") {
                if (hideOrShow == "hide") {
                    $(this.listItemsElement[items]).hide();
                    if ($(this.listItemsElement[items]).next().hasClass('e-ghead'))
                        $(this.listItemsElement[items]).prev().hide();
                }
                else {
                    $(this.listItemsElement[items]).show();
                    if ($(this.listItemsElement[items]).prev().hasClass('e-ghead'))
                        $(this.listItemsElement[items]).prev().show();
                }
            }
            else {
                for (var litem = 0; litem < items.length; litem++) {
                    if (hideOrShow == "hide")
                        items[litem].item ? items[litem].item.hide() : $(this.listItemsElement[items[litem]]).hide();
                    else
                        items[litem].item ? items[litem].item.show() : $(this.listItemsElement[items[litem]]).show();
                }
            }
            this._refreshScroller();
        },
        showItemsByIndices: function (items) {
            this._hideOrShowItemsByIndex(items, "show");
        },
        hideItemsByIndices: function (items) {
            this._hideOrShowItemsByIndex(items, "hide");
        },
        _hideOrShowItemsByValue: function (values, hideOrShow) {
            if ($.type(values) == "array") {
				for(var i=0;i < this.listItemsElement.length;i++){
					 for (var length = 0; length <= values.length; length++) {
                        if ($(this.listItemsElement[i]).text() == values[length])
                            (hideOrShow == "hide") ? $(this.listItemsElement[i]).hide() : $(this.listItemsElement[i]).show();
                    }			
			 }                
            }
            else {
                for(var i=0;i < this.listItemsElement.length;i++){
                    if ($(this.listItemsElement[i]).text() == values)
                        (hideOrShow == "hide") ? $(this.listItemsElement[i]).hide() :$(this.listItemsElement[i]).show();
                }
            }
            this._refreshScroller();
        },
        showItemsByValues: function (value) {
            this._hideOrShowItemsByValue(value, "show");
        },
        hideItemsByValues: function (value) {
            this._hideOrShowItemsByValue(value, "hide");
        },
        showItemByValue: function (value) {
            this._hideOrShowItemsByValue(value, "show");
        },
        hideItemByValue: function (value) {
            this._hideOrShowItemsByValue(value, "hide");
        },
        showItemByIndex: function (item) {
            this._hideOrShowItemsByIndex(item, "show");
        },
        hideItemByIndex: function (item) {
            this._hideOrShowItemsByIndex(item, "hide");
        },
        hide: function () {
            this.listContainer.hide();
        },
        show: function () {
            this.listContainer.show()
        },
        hideAllItems: function () {
            this.element.find("li:visible").hide()
            this._refreshScroller();
        },
        showAllItems: function () {
            this.element.find("li:hidden").show()
            this._refreshScroller();
        },
        _stateMaintained: function (index) {
            var lenth, len, value, j;
            this.model.disableItemsByIndex = [];
            this.model.selectedIndices = [];
            this.model.checkedIndices = [];
            if (this.model.selectedIndex >= index && this.model.selectedIndex != null) {
                if (this.model.selectedIndex == index || $(this.element.children()[index - 1]).hasClass('e-disable'))
                    this.model.selectedIndex = null;
                else if (this.model.selectedIndex != index)
                    this.model.selectedIndex -= 1;
            }
            len = $(index).length;
            if (len > 1) {
                for (i = len; i >= 0; i--)
                    $(this.element.children()[index[i]]).remove();
                lenth = this.element.children().length;
                for (j = 0; j < lenth; j++)
                    if ($(this.element.children()[j]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(j);
            }
            else {
                value = index - 1;
                for (value; value >= 0; value--) {
                    if ($(this.element.children()[value]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(value);
                    if ($(this.element.children()[value]).hasClass('e-select'))
                        this.model.selectedIndices.push(value);
                    if ($(this.element.children()[value]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(value);
                }
                index = parseInt(index) + 1;
                for (index; index < this._listSize; index++) {
                    if ($(this.element.children()[index]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(index - 1);
                    if ($(this.element.children()[index]).hasClass('e-select'))
                        this.model.selectedIndices.push(index - 1);
                    if ($(this.element.children()[index]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(index - 1);
                }
            }
        },
        removeAll: function () {
            if (ej.isNullOrUndefined(this.dataSource())) {
                var text = [];
                $(this.listItemsElement).each(function (i, e) {
                    text.push($(this).text());
                    e.remove();
                });
                this._refreshItems();
                return text;
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) {
                var elements = [], count = $(this.listItemsElement).length;
                for (var i = 0; i < count; i++) {
                    elements.push(this._getRemovedItems([parseInt(0)]));
                }
                return elements;
            }
        },
        removeItemByIndex: function (index) {
            var text, selectItem = this.model.selectedIndex;
            if (ej.isNullOrUndefined(this.dataSource())) {
                text = $(this.listItemsElement[index]).remove().text();
                this._stateMaintained(index);
                this._refreshItems();
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) text = this._getRemovedItems([parseInt(index)]);
            this.model.selectedIndex = (index == selectItem) ? null : index < selectItem ? selectItem - 1 : selectItem;
            return text;
        },
        removeSelectedItems: function () {
            if (this.model.showCheckbox) return false;
            if (ej.isNullOrUndefined(this.dataSource())) {
                var text = this.value();
                $(this.getSelectedItems()).each(function (i, e) {
                    e.item.remove()
                });
                this._refreshItems();
                return text;
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) {
                this.model.selectedIndex = null;
                return this._getRemovedItems(this.model.selectedIndices);
            }
        },
        _getRemovedItems: function (index) {
            var removedItems = [];
            this._stateMaintained(index);
            this.value(null);
            this._activeItem = null;
            this.dataSource(this.dataSource().filter(function (e, i) {
                if (index.indexOf(i) != -1)
                    removedItems.push(e);
                else
                    return true;
            }));
            this.refresh(true);
            return removedItems;
        },
        getIndexByValue: function (value) {
            var index;
			for(var i=0;i < this.listItemsElement.length;i++){
				if($(this.listItemsElement[i]).text()==value){
					index=i;
                    break;					
				}             
			}                     
			return index;
        },
        getIndexByText: function (text) {
            var index;
            if (this.model.allowMultiSelection) {
                var text = text.split(",");
                index = [];
            }
			for(var i=0;i < this.listItemsElement.length;i++){
				if (typeof text == "object") {
                    for (var j = 0; j < text.length; j++) {
                        if ($(this.listItemsElement[i]).text() == text[j]) {                           
                            index.push(i);                          
                            break;							
                        }
                    }
                }
                else if ($(this.listItemsElement[i]).text() == text) {
                    index = i;  
                    break;					
                }				
				}			                    
            return index;
        },
        getTextByIndex: function (index) {
            return $(this.element.find("li:not('.e-ghead')")[index]).text();
        },
        getItemByText: function (text) {
            var proxy = this, obj;
            this.listItemsElement.each(function () {
                if ($(this).text() == text) {
                    obj = proxy._getItemObject($(this));
                    return false;
                }
            });
            return obj;
        },
        getItemByIndex: function (index) {
            return this._getItemObject($(this.element.children("li:not('.e-ghead')")[index]));
        },
        getListData: function () {
            if (ej.DataManager && this.dataSource() instanceof ej.DataManager)
                return this.listitems;
            else if (this.dataSource())
                return this.dataSource();
            else
                return;
        },
        enableItem: function (text) {
            var proxy = this;
            this.listItemsElement.each(function () {
                if ($(this).text() == text) {
                    $(this).removeClass("e-disable");
                    if (proxy.model.showCheckbox) $(this).find(".listcheckbox").ejCheckBox("enable");
                    proxy._disabledItems.splice($(this).index().toString());
                    return false;
                }
            });
        },
        disableItem: function (text) {
            var proxy = this;
            this.listItemsElement.each(function () {
                if ($(this).text() == text) {
                    $(this).addClass("e-disable");
                    if (proxy.model.showCheckbox) $(this).find(".listcheckbox").ejCheckBox("disable");
                    proxy._disabledItems.push($(this).index().toString());
                    return false;
                }
            });
        },
        moveUp: function () {
            var process = (this.model.fields.groupBy != null) ? (this.model.allowMultiSelection || this.model.showCheckbox) ? false : true : true;
            if (process) {
                this.checkedorselected = this.model.checkedIndices.length == 0 ? this.model.selectedIndices.reverse() : this.model.checkedIndices.reverse();
                var prevItem = $(this.element.children("li:not('.e-ghead')")[this.checkedorselected[0]]);
                if (!prevItem.prev().hasClass("e-ghead")) {
                    if (!ej.isNullOrUndefined(this.checkedorselected)) {
                        var selectIndex = 0;
                        var listval = this._getItem(this.checkedorselected[selectIndex]);
                        this._moveupdown(listval, selectIndex, "up");
                    }
                }
            }
        },
        moveDown: function () {
            var process = (this.model.fields.groupBy != null) ? (this.model.allowMultiSelection || this.model.showCheckbox) ? false : true : true;
            if (process) {
                this.checkedorselected = this.model.checkedIndices.length == 0 ? this.model.selectedIndices : this.model.checkedIndices;
                var nextItem = $(this.element.children("li:not('.e-ghead')")[this.checkedorselected[0]]);
                if (!nextItem.next().hasClass("e-ghead")) {
                    if (!ej.isNullOrUndefined(this.checkedorselected)) {
                        var selectIndex = 0;
                        var listval = this._getItem(this.checkedorselected[selectIndex]);
                        this._moveupdown(listval, selectIndex, "down");
                    }
                }
            }


        },
        _moveItem: function (item, list, direction) {
            var selectedItem = item, index = item.index(), moveup = (direction == "up"), movedown = (direction == "down");
            if (moveup) {
                list.insertAfter(selectedItem);
                if (list.hasClass('e-disable') && $.inArray(index.toString(), this._disabledItems) > -1) {
                    this._disabledItems.splice($.inArray(index.toString(), this._disabledItems), 1);
                    this._disabledItems.push((index + 1).toString());
                }
            } else if (movedown) {
                list.insertBefore(selectedItem);
                if (list.hasClass('e-disable') && $.inArray(index.toString(), this._disabledItems) > -1) {
                    this._disabledItems.splice($.inArray(index.toString(), this._disabledItems), 1);
                    this._disabledItems.push((index - 1).toString());
                }
            }
        },
        _moveupdown: function (list, index, direction) {

            var j = this.checkedorselected[index], next, k;
            var i = 0, i = j;
            while (i < $(this.element.children("li:not('.e-ghead')")).length) {
                next = $(this.element.children("li:not('.e-ghead')")[i]);
                if (ej.isNullOrUndefined(next)) break;
                if (next.hasClass("e-select") || next.find("span").hasClass("e-checkmark")) {
                    k = i;
                    direction == "down" ? eval(i++) : eval(i--);
                    continue;
                }
                else break;
            }
            if (!ej.isNullOrUndefined(next) && i < $(this.element.children("li")).length) this._moveItem(list, next, direction);

            if (index < this.checkedorselected.length) {
                ele = $(this.element.children("li")[this.checkedorselected[index]]);
                if (ele.next().hasClass("e-select") || ele.next().find("span").hasClass("e-checkmark")) var oneafter = direction == "down" ? true : false;
                else if (ej.isNullOrUndefined(ele[0])) var oneafter = direction == "up" ? true : false;
                else if (ele.hasClass("e-select") || ele.find("span").hasClass("e-checkmark")) {
                    this._moveupdown(ele, index + 1, direction);
                }

            }

            length = this.element.children("li:not('.e-ghead')").length;
            if (this.model.checkedIndices.length == 0) {
                this.model.selectedIndices = [];
                for (var i = 0; i < length; i++) {
                    if ($(this.element.children("li:not('.e-ghead')")[i]).hasClass('e-select'))
                        this.model.selectedIndices.push(i);
                }
            } else {
                this.model.checkedIndices = [];
                for (var j = 0; j < length; j++)
                    if ($.parseJSON($(this.element.children("li:not('.e-ghead')")[j]).find("span").attr("aria-checked")))
                        this.model.checkedIndices.push(j);
            }

        },


        checkAll: function () {
            if (!this.model.showCheckbox) return false;
            var items = this.element.find("li:not('.e-ghead')");
            for (i = 0; i < items.length; i++) {
                if (!($(items[i].firstChild).find('.listcheckbox').ejCheckBox('isChecked'))) {
                    $(items[i].firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                    this._checkedItems.push(items[i]);
                    this.model.checkedIndices.push(i);
                }
            }
			this._setSelectionValues();
            this.model.uncheckAll = false;
        },
        //Deprecated Method
        unCheckAll: function () { this.uncheckAll(); },
        uncheckAll: function () {
            if (!this.model.showCheckbox) return false;
            var items = this.element.find("li:not('.e-ghead')");
            for (i = 0; i < items.length; i++)
                if ($(items[i].firstChild).find('.listcheckbox').ejCheckBox('isChecked'))
                    $(items[i].firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', false);
            this._checkedItems = [];
            this.model.checkedIndices = [];
			this._setSelectionValues();
            this.model.checkAll = false;
        },
        addItem: function (val, index) {
            var index = (!ej.isNullOrUndefined(index) && index <= this.element.find("li:not('.e-ghead')").length) ? index : this.element.find("li:not('.e-ghead')").length;
            var proxy = this, num = index;
            if (ej.isNullOrUndefined(this.dataSource())) {
                if (!(val instanceof Array)) {
					 if(this.model.fields.groupBy && typeof val == "object" ){ 
                          _query = ej.Query().group(this.model.fields.groupBy);
                           groupedList = ej.DataManager([val]).executeLocal(_query);
                            this.dataSource([]);  
                            for (i = 0; i < groupedList.length; i++) {
							this._setMapFields();
                            this.dummyUl.push(ej.buildTag('li.e-ghead', groupedList[i].key)[0]);
                            this._loadlist(groupedList[i].items);
                            this.dataSource(this.dataSource().concat(groupedList[i].items));										
					               } 
					    }
					 else{
                    this.listitem = (this.element.find("li:not('.e-ghead')").length ?
                                        ((index - 1 < 0) ? $(this.element.find("li:not('.e-ghead')")[0]).before('<li role="option">' + val + '</li>') : $(this.element.find("li:not('.e-ghead')")[index - 1]).after('<li role="option">' + val + '</li>'))
                                         : $(this.element).html('<li role="option">' + val + '</li>'));
					 }
                    this.listitems = this.element.find('li');
                    this._addItemIndex = index;
                    if (this.model.showCheckbox) {
                        $checkbox = ej.buildTag("input.listcheckbox e-align#popuplist" + (this.listitems.length - 1) + "_" + this._id, "", {}, {
                            type: "checkbox",
                            name: "list" + (this.listitems.length - 1)
                        });
                        $(this.listitems[index]).prepend($checkbox);
                        $($(this.listitems[index]).find(".listcheckbox")).ejCheckBox({
                            change: $.proxy(this._onClickCheckList, this)
                        });
                    }
                    if (this.model.allowDrag || this.model.allowDrop) this._enableDragDrop();
                    this._addItemIndex = null;
                    this._refreshItems();
                }
                else {
                    $(val).each(function (i, e) {
                        proxy.addItem(e, index);
                        index = index + 1;
                    })
                }
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) {
                if (proxy.dataSource() instanceof Object) {
					dup = new Object();
                    if (!(val instanceof Object)) {
                        dup[proxy.model.fields.text] = val;
                        val = dup;
                    }
                }
                else if (!(val instanceof Array)) val = [val];
                $(val).each(function (i, e) {
                    proxy.dataSource().splice(index, 0, e);
                    index = index + 1;
                })
                this.model.disableItemsByIndex = [];
                this.model.selectedIndices = [];
                this.model.checkedIndices = [];
                if (this.model.selectedIndex >= num)
                    this.model.selectedIndex += 1;
                var value = num - 1;
                for (value; value >= 0; value--) {
                    if ($(this.element.children()[value]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(value);
                    if ($(this.element.children()[value]).hasClass('e-select'))
                        this.model.selectedIndices.push(value);
                    if ($(this.element.children()[value]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(value);
                }
                for (num; num < this._listSize; num++) {
                    if ($(this.element.children()[num]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(num + 1);
                    if ($(this.element.children()[num]).hasClass('e-select'))
                        this.model.selectedIndices.push(num + 1);
                    if ($(this.element.children()[num]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(num + 1);
                }
                this.refresh(true);
            }
        },
        enableItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.enableItemsByIndices(index.toString());
        },
        disableItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.disableItemsByIndices(index.toString());
        },
        disableItemsByIndices: function (value) {
            if (ej.isNullOrUndefined(value)) return false;
            var selectitems = value.toString().split(',');
            for (var i = 0; i < selectitems.length; i++) {
                if (selectitems.length > 0 && !($.inArray(selectitems[i], this._disabledItems) > -1)) {
                    var disable = $(this.element.children("li:not('.e-ghead')")[parseInt(selectitems[i])]).addClass('e-disable');
                    disable.find(".listcheckbox").ejCheckBox("disable");
                    this._disabledItems.push(selectitems[i]);
                }
            }
        },
        enableItemsByIndices: function (value) {
            var selectitems = value.toString().split(','), index;
            for (var i = 0; i < selectitems.length; i++) {
                if (selectitems.length > 0 && ($.inArray(selectitems[i], this._disabledItems) > -1)) {
                    index = $.inArray(selectitems[i], this._disabledItems);
                    var enable = $(this.element.children("li:not('.e-ghead')")[parseInt(selectitems[i])]).removeClass('e-disable');
                    enable.find(".listcheckbox").ejCheckBox("enable");
                    this._disabledItems.splice(index, 1);
                }
            }
        },
        _init: function () {
            this._id = this.element[0].id;
            this._isMozilla = ej.browserInfo().name == "mozilla" ? true : false;
            this._cloneElement = this.element.clone();
            this._deprecatedValue()._initialize()._render()._wireEvents();
            this._initValue = this.focused = false;
            this._typeInterval = null;
            this._typingThreshold = 2000;
            //deprecatedFunction
            if (this.model.checkAll)
                this.checkAll();
            if (this.model.uncheckAll)
                this.uncheckAll();
            if (this.model.disableItemsByIndex)
                this.disableItemsByIndices(this.model.disableItemsByIndex.toString());
            if (this.model.enableItemsByIndex)
                this.enableItemsByIndices(this.model.enableItemsByIndex.toString());
            if (this.model.uncheckItemsByIndex)
                this.uncheckItemsByIndices(this.model.uncheckItemsByIndex.toString());
            this._deprecatedValue()._enabled(this.model.enabled);

        },
        _deprecatedValue: function () {
            this.model.itemDrop = (this.model.itemDrop || this.model.itemDropped);
            this.model.change = (this.model.change || this.model.selectIndexChanged);
            this.model.fields.checkBy = this.model.fields.selected || this.model.fields.checkBy;
            this.model.fields.tooltipText = this.model.fields.toolTipText || this.model.fields.tooltipText;
            this.model.fields.groupBy = this.model.fields.category || this.model.fields.groupBy;
            this.model.select = (this.model.select || this.model.selected);
            if (this.model.allowDragAndDrop != undefined)
                this.model.allowDrag = this.model.allowDrop = true;
            this.model.selectedIndex = this.model.selectedIndex != null ? this.model.selectedIndex : this.model.selectedItemIndex;
            this.model.checkedIndices = ((this.model.checkedIndices.length ? this.model.checkedIndices : null) || (this.model.checkItemsByIndex ? this.model.checkItemsByIndex : null) || (this.model.checkedItems.length ? this.model.checkedItems : null) || (this.model.checkedItemlist.length ? this.model.checkedItemlist : []));
            this.model.selectedIndices = ((this.model.selectedIndices.length ? this.model.selectedIndices : null) || (this.model.selectedItems.length ? this.model.selectedItems : null) || (this.model.selectedItemlist.length ? this.model.selectedItemlist : []));
            return this;
        },
        _setModel: function (options) {
            var option, refresh = false;
            for (option in options) {
                switch (option) {
                    case "value":
                        this._setText(ej.util.getVal(options[option]));
                        break;
                    case "dataSource":
                        if (!ej.isNullOrUndefined(this._isCasCadeTarget))
                            this.model.selectedIndex = null;
                        options[option] = ej.util.getVal(options[option])
                        this._checkModelDataBinding(options[option]);
                        break;
                    case "query":
                        this._queryCheck(options[option]);
                        break;
                    case "fields":
                        this.model.fields = $.extend(this.model.fields, options[option]);
                        this._checkModelDataBinding(this.dataSource());
                        break;
                    case "template":
                        this.model.template = options[option];
                        this.refresh(true);
                        break;
                    case "loadDataOnInit":
                        this._loadContent = options[option];
                        this._checkModelDataBinding(this.dataSource());
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[option];
                        (this.model.enableRTL) ? this.listContainer.addClass("e-rtl") : this.listContainer.removeClass("e-rtl");
                        break;
                    case "enabled":
                        this.model.enabled = options[option];
                        this._enabled(options[option]);
                        break;
				    case "enableWordWrap":
					      this.model.enableWordWrap=options[option];
					      this._wordWrapItems(options[option]);
						  break;
                    case "height":
                    case "width":
                        this.model[option] = options[option];
                        this._setDimensions();
                        break;
                    case "cssClass":
                        this.model.cssClass = options[option];
                        this.listContainer.addClass(this.model.cssClass);
                        break;
                    case "showCheckbox":
                        this._checkboxHideShow(options[option]); if (options[option]) this._removeListHover();
                        break;
                    case "showRoundedCorner":
                        this.model.showRoundedCorner=options[option];
                        this._roundedCorner();
                        break;
                    case "selectedItemIndex":
                    case "selectedIndex":
                         if (this.listitem[options[option]] || options[option] == null || this.listitems[options[option]]) {
                            this.selectItemByIndex(options[option]);
                            this.model.selectedIndex = this.model.selectedItemIndex = options[option];
                        } else options[option] = this.model.selectedIndex;
                        break;
                    case "sortOrder":
                        this.model.sortOrder = options[option];
                        if (this.dataSource() != null)
                            this._showFullList();
                        else
                            this._renderlistContainer();
                        break;
                    case "checkItemsByIndex":
                    case "checkedItemlist":
                    case "checkedItems":
                    case "checkedIndices":
                        this.uncheckAll();
                        this.checkItemsByIndices(options[option].toString());
                        options[option] = this.model[option] = this.model.checkedIndices;
                        break;
                    case "uncheckItemsByIndex":
                        this.uncheckItemsByIndices(options[option].toString());
                        this.model[option] = options[option];
                        break;
                    case "selectedItemlist":
                    case "selectedItems":
                    case "selectedIndices":
                        this.unselectAll();
                        this.selectItemsByIndices(options[option].toString());
                        options[option] = this.model.selectedIndices;
                        break;
                    case "enableItemsByIndex":
                        this.model[option] = options[option];
                        this.enableItemsByIndices(options[option].toString());
                        break;
                    case "disableItemsByIndex":
                        this.model[option] = options[option];
                        this.disableItemsByIndices(options[option].toString());
                        break;
                    case "enableVirtualScrolling":
                        this.model.allowVirtualScrolling = options[option]; refresh = true;
                        break;
                    case "allowDrag":
                    case "allowDrop":
                    case "allowDragAndDrop":
                    case "allowVirtualScrolling":
                    case "virtualScrollMode":
                        this.model[option] = options[option]; refresh = true;
                        break;
                    case "checkAll":
                        this.model[option] = options[option]; if (options[option]) this.checkAll(); else this.uncheckAll();
                        break;
                    case "uncheckAll":
                        this.model[option] = options[option]; if (options[option]) this.uncheckAll(); else this.checkAll();
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "itemsCount":
                        var items = this.model.itemsCount;
                        if (this.model.height) {
                            this.model.itemsCount = options[option];
                            this._setItemsCount()._setDimensions();
                        } else options[option] = items;
                        break;
                    case "itemHeight":
                        var $liElements = this.listItemsElement;
                        var optionHeight = ej.isNullOrUndefined(options[option]) ? options[option] : options[option].toString().replace("px", "");
                        var modelHeight= ej.isNullOrUndefined(this.model.itemHeight) ? this.model.itemHeight :this.model.itemHeight.toString().replace("px", "");
                        for (var z = 0; z < $liElements.length; z++) {
                            var style = ej.isNullOrUndefined(options[option]) ? { "min-height": ej.isNullOrUndefined(this.model.itemHeight)? "20px":modelHeight } : { "min-height": optionHeight + "px", "height": optionHeight + "px" };
                            $liElements.eq(z).css(style);
                        } this.refresh();
                        break;
                    case "allowMultiSelection":
                        this.model.allowMultiSelection = options[option];
                        if (!options[option]) {
                            var index = this.model.selectedIndex;
                            this._removeListHover();
                            ej.isNullOrUndefined(index) ? "" : this.selectItemByIndex(index);
                        };
                        break;
                    case "totalItemsCount":
                        if (!ej.isNullOrUndefined(this.dataSource())) {
                            this.model.totalItemsCount = options[option];
                            if (this.model.query)
                                this._queryCheck(this.model.query);
                        }
                        break;
                }
            }
            if (refresh) this._refresh();
        },
        _destroy: function () {
            if (!ej.isNullOrUndefined(this._lilist)) $(this._lilist).ejDraggable("destroy");
            this.element.insertAfter(this.listContainer);
            this.element.find(".e-chkbox-wrap").remove();
            this.listContainer.remove();
            if (!this._isList) this.element.empty();
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
			this._ListEventUnbind(this.element.children("li"));
            return this;
        },
		_ListEventUnbind: function (_ListItemsContainer) {
			_ListItemsContainer.off("contextmenu", $.proxy(this._OnMouseContext, this));
            _ListItemsContainer.off("click", $.proxy(this._OnMouseClick, this));
            _ListItemsContainer.off("touchstart mouseenter", $.proxy(this._OnMouseEnter, this));
            _ListItemsContainer.off("touchend mouseleave", $.proxy(this._OnMouseLeave, this));
		},
        _refresh: function () {
            this._destroy()._init();
        },
        _finalize: function () {
            if (this.model.selectedIndex != null)
                this.selectItemByIndex(this.model.selectedIndex);
            else if ((this.model.showCheckbox == true) && (this._selectedItems.length > 0))
                this._selectCheckedItem(this._selectedItems);
            if (this.model.checkedIndices != null) this.checkItemsByIndices(this.model.checkedIndices.toString());
            return this;
        },
        _initialize: function () {
            this._isList = this.element.children().length ? true : false;
            this.target = this.element[0];
            this._queryString = null;
            this._disabledItems = [];
            this._itemId = null;
            this._up = this._down = this._ctrlClick = false;
            this.checkedStatus = this._isScrollComplete = false;
            this._incqueryString = "";
            this._activeItem = null;
            this._initValue = true;
            this.model.allowVirtualScrolling = (this.model.allowVirtualScrolling) ? this.model.allowVirtualScrolling : this.model.enableLoadOnDemand;
            this.model.virtualScrollMode = (this.model.enableVirtualScrolling) ? "continuous" : this.model.virtualScrollMode;
            this._selectedItems = [];
            this._checkedItems = [];
            this._loadContent = this.model.loadDataOnInit;
            this._loadInitialRemoteData = true;
            this._skipInitialRemoteData = false;
            if (this.model.enableVirtualScrolling) this.model.allowVirtualScrolling = true;
            this._setItemsCount();
            return this;
        },
        _render: function () {
            this._savedQueries = this.model.query.clone();
            if (this.model.totalItemsCount)
                this._savedQueries.take(this.model.totalItemsCount);
            this._renderContainer()._addAttr(this.model.htmlAttributes);
            if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
                if (this.model.actionBegin)
                    this._trigger("actionBegin", {});
                if (this._loadInitialRemoteData)
                    this._initDataSource(this.dataSource());
            }
            else
                this._showFullList();
            if (!this.dataSource()) this._finalize();
			this.listItemsElement=this.element.find("li:not('.e-ghead')");
            if (this.model.showRoundedCorner)
                this._roundedCorner();
            return this;
        },
        _queryCheck: function (value) {
            this._savedQueries = value.clone();
            this.element.empty();
            if (this.dataSource())
                this._checkModelDataBinding(this.dataSource());
        },
        _checkModelDataBinding: function (source) {
            this.mergeValue = null;
            this.dataSource(source);
            if (source != null && source.length != 0) {
                if (ej.DataManager && source instanceof ej.DataManager) this._initDataSource(source);
                else this._showFullList();
            } else { this.element.empty(); this._refreshScroller(); }
        },
        _initDataSource: function (source) {
            var proxy = this;
            proxy.listitems = proxy.dataSource();
            proxy._updateLoadingClass(true);
            var queryPromise = source.executeQuery(this._getQuery());
            queryPromise.done(function (e) {
                proxy.listitems = e.result;
                proxy._updateLoadingClass()._showFullList()._trigger("actionSuccess", e);
                proxy._finalize();
            }).fail(function (e) {
                proxy.dataSource(null);
                proxy._updateLoadingClass(true)._trigger("actionFailure", e);
            }).always(function (e) {
                if (proxy.model.checkAll)
                    proxy.checkAll();
                if (proxy.model.uncheckAll)
                    proxy.uncheckAll();
                proxy._trigger("actionComplete", e);
            });
        },
        _getQuery: function () {
            var queryManager;
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [],
                    mapper = this.model.fields;
                queryManager = ej.Query();
                for (var col in mapper)
                    if (col !== "tableName") column.push(mapper[col]);
                if (column.length > 0) queryManager.select(column);
                if (!this.dataSource().dataSource.url.match(mapper.tableName + "$")) !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            } else queryManager = this._savedQueries;
            return queryManager;
        },
        _addDragableClass: function () {
            if (this.model.allowDrag || this.model.allowDrop) {
                this.element.css("cursor", "pointer");
                if (this.model.allowDrop) {
                    this.listContainer.addClass("e-droppable");
                    this.listBoxScroller.addClass("e-droppable");
                }
                var proxy = this;
                this.element.children("li").each(function (index) {
                    if (proxy.model.allowDrag) ($(this).addClass("e-draggable"));
                    if (proxy.model.allowDrop) ($(this).addClass("e-droppable"));
                });
            }
            return this;
        },
        _enableDragDrop: function () {
            if (this.model.allowDrag || this.model.allowDrop) this._drag();
        },
        _updateLoadingClass: function (value) {
            this.listContainer[(value ? "addClass" : "removeClass")]("e-load"); return this;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.listContainer.addClass(value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._enabled(false);
                else proxy.listContainer.attr(key, value);
            });
        },
        _renderContainer: function () {
            this.listContainer = ej.buildTag("div.e-ddl-popup e-box e-popup e-widget " + this.model.cssClass, "", {
                "visibility": "hidden"
            }, {
                "tabIndex": 0,
                "id": this._id + "_container"
            });
            this.listBoxScroller = ej.buildTag("div");
            this.ultag = ej.buildTag("ul.e-ul", "", {}, {
                "role": "listbox"
            });
            this.element = this.element.addClass("e-ul");
            this.listContainer.append(this.listBoxScroller).insertAfter(this.element);
            this.listBoxScroller.append(this.element);
            this.element.attr('unselectable', 'on').css('user-select', 'none');
            this._hiddenInput = ej.buildTag("input#" + this._id + "_hidden", "", {}, {
                type: "hidden"
            }).insertBefore(this.element);
            this._hiddenInput.attr('name', this._id);
            return this;
        },
        _setMapFields: function () {
           var mapper = this.model.fields;
            this.mapFld = {
                _id: null,
                _imageUrl: null,
                _imageAttributes: null,
                _tooltipText: null,
                _spriteCSS: null,
                _text: null,
                _value: null,
                _htmlAttributes: null,
                _selectBy: null,
                _checkBy: null
            };
            this.mapFld._id = (mapper && mapper.id) ? mapper["id"] : "id";
            this.mapFld._imageUrl = (mapper && mapper.imageUrl) ? mapper["imageUrl"] : "imageUrl";
            this.mapFld._tooltipText = (mapper && mapper.tooltipText) ? mapper["tooltipText"] : "tooltipText";
            this.mapFld._imageAttributes = (mapper && mapper.imageAttributes) ? mapper["imageAttributes"] : "imageAttributes";
            this.mapFld._spriteCSS = (mapper && mapper.spriteCssClass) ? mapper["spriteCssClass"] : "spriteCssClass";
            this.mapFld._text = (mapper && mapper.text) ? mapper["text"] : this.listitems[0].text ? "text" : this._getObjectKey(this.listitems[0])[0];
            this.mapFld._value = (mapper && mapper.value) ? mapper["value"] : "value";
            this.mapFld._htmlAttributes = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
            this.mapFld._checkBy = (mapper && mapper.checkBy) ? mapper["checkBy"] : "checkBy";
            this.mapFld._selectBy = (mapper && mapper.selectBy) ? mapper["selectBy"] : "selectBy";
            this.mapCateg = (mapper && mapper.groupBy) ? mapper["groupBy"] : ""
        },
        _getObjectKey: function (obj) {
            if (!Object.keys) {
                var keys = [];
                for (var i in obj) {
                    if (obj.hasOwnProperty(i)) {
                        keys.push(i);
                    }
                }
                return keys;
            }
            else return Object.keys(obj)
        },
        _itemStyle:function(){
            var height = ej.isNullOrUndefined(this.model.itemHeight) ? this.model.itemHeight : this.model.itemHeight.toString().replace("px", "");
            var itemHeight = ej.isNullOrUndefined(this.model.itemHeight) ? "min-height:20px;" : "min-height:" + height + "px;height:" + height + "px";
            return { style: itemHeight }
        },
        sort: function () {
            var sortedlist = document.createElement("ul"), i, sortitems;
            $(sortedlist).append(this.itemsContainer.children());
            if (this.model.fields.groupBy != null || $(sortedlist).find(">.e-ghead").length > 0) {
                for (i = 0; i < $(sortedlist).find(">.e-ghead").length; i++) {
                    sortitems = $(sortedlist).find(">.e-ghead").eq(0).first().nextUntil(".e-ghead").get();
                    this._setSortList(sortedlist, sortitems);
                }
                var headerlist = document.createElement("ul"), headeritems, j;
                headeritems = $(sortedlist).clone().find('>.e-ghead').get();
                for (var k = 0; k < headeritems.length; k++)
                    headerlist.append(headeritems[k]);
                var headerdata = this._customSort(headerlist, headeritems);
                var groupSort = document.createElement("ul"), groupitems;
                var temp = $(sortedlist).find('li.e-ghead').get();
                if (this.model.sortOrder.toLowerCase() == "descending")
                    headerdata.reverse();
                for (j = 0; j < headerdata.length; j++) {
                    groupSort.append(headerdata[j]);
                    for (l = 0; l < temp.length; l++) {
                        if (headerdata[j].textContent == temp[l].textContent) {
                            groupitems = $(sortedlist).find(">.e-ghead").eq(l).first().nextUntil(".e-ghead").get();
                            for (m = 0; m < groupitems.length; m++) {
                                groupSort.append(groupitems[m]);
                            }
                        }
                    }
                }
                this.itemsContainer = $(groupSort);
            }
            else {
                sortitems = $(sortedlist).children('li').get();
                this._setSortList(sortedlist, sortitems);
                this.itemsContainer = $(sortedlist)
            }
        },
        _customSort: function (headerlist, headeritems) {
            headeritems.sort(function (objA, objB) {
                var sortA = $(objA).text().toUpperCase();
                var sortB = $(objB).text().toUpperCase();
                return (sortA < sortB) ? -1 : (sortA > sortB) ? 1 : 0;
            });
            return headeritems;
        },
        _setSortList: function (sortedlist, sortitems) {
            this._customSort(sortedlist, sortitems);
            if (this.model.sortOrder.toLowerCase() == "descending") sortitems.reverse();
            if (this.model.fields.groupBy != null || $(sortedlist).find(">.e-ghead").length > 0) {
                $(sortedlist).append($("<li>").text($(sortedlist).find(">.e-ghead").eq(0).text()).addClass("e-ghead"));
                $(sortedlist).find(">.e-ghead").eq(0).remove();
            }
            $.each(sortitems, function (index, item) {
                $(sortedlist).append(item);
            });
        },
        _renderlistContainer: function () {
            this.hold = this.touchhold = false;
            this.item = "";
            this.startime = 0;
            this.listitemheight = 24;
            var list = this.listitems,
                i, ulempty, ulno, litag, _id, _txt, mapper = this.model.fields,
                predecessor;
            this.lastScrollTop = -1;
            this.dummyUl = $();
            if (this.model.enableRTL) this.listContainer.addClass("e-rtl");
            this._wordWrapItems();
            if (this.dataSource() == null || this.dataSource().length < 1) {
                predecessor = this.element.parents().last();
                if (this.model.targetID) this.docbdy = predecessor.find("#" + this.model.targetID);
                else this.docbdy = predecessor.find("#" + this._id);
                this.itemsContainer = this.docbdy;
                if(this.model.sortOrder != "none") this.sort();
                this.itemsContainer.children("ol,ul").remove();
                this.items = this.itemsContainer.children('li');
                this.items.children("img").addClass("e-align");
                this.items.children("div").addClass("e-align");
                var iHeight = parseInt(this.model.itemHeight) + "px";
                if (this.model.itemHeight) $('li').css({ "min-height": iHeight, "height": iHeight });
                this.element.append(this.itemsContainer.children());
            }
            else if (this.dataSource() != null && typeof list[0] != "object") {
                if (this._loadInitialRemoteData && this.mergeValue && this.model.virtualScrollMode == "continuous" && this.model.totalItemsCount)
                    this._loadlist(this.mergeValue);
                else if (this._loadInitialRemoteData && this.mergeValue && this.model.virtualScrollMode == "normal" && this.model.totalItemsCount) {
                    this.realUllength = 0;
                    this.mergeUl = [];
                    for (i = 0; i < this.mergeValue.length; i++)
                         this.mergeUl.push(ej.buildTag('li', this.mergeValue[i][this.model.fields.text], null, this._itemStyle())[0]);
                    this.element.append(this.mergeUl);
                    for (i = 0; i < this.model.totalItemsCount - this.mergeValue.length; i++)
                        this.dummyUl.push(ej.buildTag('li', null, null, this._itemStyle())[0]);
                    this.element.append(this.dummyUl);
                    this._refreshScroller();
                }
                else if (this._loadInitialRemoteData && this.mergeValue && !this.model.totalItemsCount)
                    this._initDataSource(this.dataSource());
            }
            else {
                this._setMapFields();
                var groupedList, _query;
                _query = this._savedQueries;
                this.listContainer.height(this.model.height);
                this.listitemheight = 24;
                if (this.model.allowVirtualScrolling) {
                    if (this.model.virtualScrollMode == "normal") {
                        this.realUllength = 0;
                        if (this.dataSource().length < 0) {
                            query = this._savedQueries.take(parseInt(this.listContainer.height() / this.listitemheight));
                            var proxy = this;
                            if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
                                proxy.listitems = proxy.dataSource();
                                var queryPromise = this.dataSource().executeQuery(query);
                                queryPromise.done(function (e) {
								    proxy._trigger("actionBeforeSuccess", e);
                                    proxy.listitems = e.result;
                                    proxy._trigger("actionSuccess", e);
                                }).fail(function (e) { proxy._trigger("actionFailure", e); })
                                  .always(function (e) { proxy._trigger("actionComplete", e); });
                            }
                        }
                        if (this.mergeValue && this.mergeValue != groupedList && this.mergeValue != undefined) {
                            this.mergeUl = [];
                            for (i = 0; i < this.mergeValue.length; i++) {
                                var $liEle = ej.buildTag('li', this.model.template ? "" : this.mergeValue[i][this.model.fields.text], null,  this._itemStyle())[0]
                                if (this.model.template) $liEle.append(this._getTemplatedString(list[i]));
                                this.mergeUl.push($liEle[0]);
                            }
                            this.element.append(this.mergeUl);
                        }
                        if (!this.model.totalItemsCount)
                            var originalliLength = this.listitems.length;
                        else
                            var originalliLength = (this.mergeValue) ? this.model.totalItemsCount - this.mergeValue.length : this.model.totalItemsCount;
                        for (var i = 0; i < originalliLength; i++) {
                            var $listEle = ej.buildTag('li', null, null,  this._itemStyle());
                            this.dummyUl.push($listEle[0]);
                        }
                        this.element.append(this.dummyUl);
                    }
                    this._loadInitialData(_query, list);
                } else {
                    if (this.mapCateg && this.mapCateg != "") {
                        _query = ej.Query().group(this.mapCateg);
                        if(this.model.sortOrder.toLowerCase() == "none")
                       _query.queries.splice(0, 1);
                        groupedList = ej.DataManager(list).executeLocal(_query);
                        if (this.model.sortOrder.toLowerCase() != "none") {
                            var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                            groupedList = ej.DataManager(groupedList).executeLocal(sortQuery);
                        }
                        this.dataSource([]);
                        for (i = 0; i < groupedList.length; i++) {
                            this.dummyUl.push(ej.buildTag('li.e-ghead', groupedList[i].key)[0]);
                            this._loadlist(groupedList[i].items);
                            this.dataSource(this.dataSource().concat(groupedList[i].items));
                        }
                    }
                    else {
                        groupedList = ej.DataManager(list).executeLocal(_query);
                        if (groupedList.length > 0) {
                            if (this.mergeValue && this.mergeValue != groupedList && this.mergeValue != undefined) {
                                this.mergeUl = [];
                                for (i = 0; i < this.mergeValue.length; i++) {
                                    this.mergeUl.push(ej.buildTag('li', this.mergeValue[i][this.model.fields.text], null,  this._itemStyle())[0]);
                                    groupedList.push(this.mergeValue[i]);
                                }
                            }
                            if (this.model.template != null && this._loadContent) {
                                for (i = 0; i < list.length; i++) {
                                    var _dhtmlAttributes = this._getField(list[i], this.mapFld._htmlAttributes);
                                    var _did = this._getField(list[i], this.mapFld._id);
                                    litag = ej.buildTag('li');
                                    if ((_dhtmlAttributes) && (_dhtmlAttributes != "")) litag.attr(_dhtmlAttributes);
                                    if (_did) litag.attr('id', _did);
                                    if (this.model.template) litag.append(this._getTemplatedString(list[i]));
                                    this.dummyUl.push(litag[0]);
                                }
                                if (!this.model.allowVirtualScrolling) this.element.children().remove();
								var k = (this.model.virtualScrollMode == "continuous" && this.mergeValue) ? this.realUllength + this.mergeValue.length : this.realUllength;
                                if (this.element.children()[k] == null && (!this.model.allowVirtualScrolling || this.model.virtualScrollMode == ej.VirtualScrollMode.Continuous) && this._loadContent)								
                                this.element.append(this.dummyUl);
                            }
                            else {
                                this.realUllength = 0;
                                this._loadlist(groupedList);
                            }
                        }
                    }
                }
            }
            var proxy = this;
            if (groupedList) this.listitems = groupedList;
            this._setDimensions();
            this.listContainer.css({ "position": "relative", "height": "" });
            this.listBoxScroller.css({ "height": "", "width": "" });
            this.listContainer.ejScroller({
                height: this.listContainer.height(),
                width: 0,
                scrollerSize: 20,
                scroll: function (e) {
                    if ((e.source == "key" || e.source == "wheel" || (e.source != "button" && e.source != "thumb" && e.source != "custom")) && proxy.model != null) proxy._onScroll(e);
                },
                thumbEnd: function (e) {
                    //Please use the first code for debugging purpose
                    //if (proxy.model != null && e.originalEvent.target.tagName.toUpperCase() != "LI" && e.originalEvent.target.tagName.toUpperCase() != "HTML")
                    if (proxy.model != null)
                        proxy._onScroll(e);
                },
				scrollEnd: function (e) {
					if( e.scrollData.source == "button" && proxy.model != null) proxy._onScroll(e);
				}
            });
            this.scrollerObj = this.listContainer.ejScroller("instance");
            this._setDimensions();
            this.listContainer.css({ 'display': 'none', 'visibility': 'visible' });
            this._checkboxHideShow(this.model.showCheckbox)._checkitems()._showResult();
            if (this.model.totalItemsCount)
                this._setTotalItemsCount();
        },
		  _wordWrapItems:function(){
			   this.model.enableWordWrap?this.listContainer.addClass("e-wrap").removeClass("e-nowrap"):this.listContainer.addClass("e-nowrap").removeClass("e-wrap");
			},
	
        _loadInitialData: function (query, list) {
            var _query = query.clone();
            this.realUllength = 0;
            if ((ej.DataManager && this.dataSource() instanceof ej.DataManager))
                _query = _query.range(0, parseInt(this.listContainer.height() / this.listitemheight));
            else
                _query = _query.range(0, this.listitems.length);
            groupedList = ej.DataManager(list).executeLocal(_query);
            if (this.mergeValue && this.mergeValue != groupedList && this.mergeValue != undefined && this.model.virtualScrollMode == "continuous") {
                this.mergeUl = [];
                for (i = 0; i < this.mergeValue.length; i++)
                    this.mergeUl.push(ej.buildTag('li', this.mergeValue[i][this.model.fields.text], null,  this._itemStyle())[0]);
                this.element.append(this.mergeUl);
            }
            if (!this.mergeValue || (this.mergeValue && this._loadInitialRemoteData))
                this._loadlist(groupedList);
        },
        _loadlist: function (sublist) {
            if (this.element != null) {
                var selectionArray = [];
                if (this.model.sortOrder.toLowerCase() != "none") {
                    var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                    sublist = ej.DataManager(sublist).executeLocal(sortQuery);
                }
                for (var j = 0; j < sublist.length; j++) {
                    var _did = this._getField(sublist[j], this.mapFld._id);
                    var _dimageUrl = this._getField(sublist[j], this.mapFld._imageUrl);
                    var _dimageAttributes = this._getField(sublist[j], this.mapFld._imageAttributes);
                    var _dspriteCss = this._getField(sublist[j], this.mapFld._spriteCSS);
                    var _dtext = this._getField(sublist[j], this.mapFld._text);
                    var _dvalue = this._getField(sublist[j], this.mapFld._value);
                    var _dhtmlAttributes = this._getField(sublist[j], this.mapFld._htmlAttributes);
                    var _dselectBy = this._getField(sublist[j], this.mapFld._selectBy);
                    var _dcheckBy = this._getField(sublist[j], this.mapFld._checkBy);
                    var _dtooltipText = this._getField(sublist[j], this.mapFld._tooltipText);
                    var k = (this.model.virtualScrollMode == "continuous" && this.mergeValue) ? this.realUllength + this.mergeValue.length : this.realUllength;
                    if ((_dvalue) && (_dvalue != "")) litag = ej.buildTag('li', "", "", $.extend( this._itemStyle(), {value: _dvalue}));
                    else var litag = ej.buildTag('li', null, null,  this._itemStyle()); if (_did) litag.attr('id', _did);
                    if ((_dimageUrl) && (_dimageUrl != "")) {
                        imgtag = ej.buildTag('img.e-align', '', {}, {
                            'src': _dimageUrl,
                            'alt': _dtext
                        });
                        if ((_dimageAttributes) && (_dimageAttributes != "")) imgtag.attr(_dimageAttributes);
                        litag.append(imgtag);
                    }
                    if ((_dspriteCss) && (_dspriteCss != "")) {
                        divtag = ej.buildTag('div.e-align ' + _dspriteCss + ' sprite-image');
                        litag.append(divtag);
                    }
                    if ((_dtext) && (_dtext != "")){
                    if(this.model.template) litag.append(this._getTemplatedString(sublist[j]))
                    else litag.append(_dtext);
                    }
                    if ((_dhtmlAttributes) && (_dhtmlAttributes != "")) litag.attr(_dhtmlAttributes);
                    if ((_dtooltipText) && (_dtooltipText != "")) litag.attr('data-content', _dtooltipText).addClass("e-tooltip");
                    if (_dcheckBy || this.model.checkAll) litag.addClass("checkItem");
                    if (_dselectBy || this.model.selectAll) litag.addClass("selectItem");
                    if (this.element.children()[k] != null && this.model.allowVirtualScrolling && $(this.element.children()[k]).text() == "") {
                        $(this.element.children()[k]).replaceWith(litag[0]);
                    } else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                        if (this.model.template)
                            ($(this.dummyUl[k])).replaceWith(litag[0]);
                        else
                        ($(this.dummyUl[k])).text($(litag[0]).text());
                    }
                    else
                        this.dummyUl.push(litag[0]);
                    this.realUllength += 1;
                }
                if (!this.model.allowVirtualScrolling) this.element.children().remove();
                if (this.element.children()[k] == null && (!this.model.allowVirtualScrolling || this.model.virtualScrollMode == ej.VirtualScrollMode.Continuous) && this._loadContent)
                    this.element.append(this.dummyUl);
                var listItems = this.element.find("li:not('.e-ghead')"); this.listItemsElement = this.element.find("li:not('.e-ghead')");
                if (this.model.showCheckbox && this.model.checkedIndices) {
                    for (var i = 0; i < listItems.length; i++)
                        if (this.model.checkedIndices.indexOf(i) != -1)
                            $(listItems[i]).addClass("checkItem");
                }
                else if (!this.model.showCheckbox) {
					if(this.value()!="" && !this.mapCateg && !this.mapCateg != "") this.selectItemByText(this.value());
                    for (var i = 0; i < listItems.length; i++)
                        if (this.model.selectedIndices.indexOf(i) != -1 || this.model.selectedIndex == i)
                            $(listItems[i]).addClass("selectItem");
                }
                this.element.find('.selectItem').each(function (i, e) {
                    selectionArray.push($(e).parent().find("li").index($(e)));
                });
                var proxy = this;
                if (!proxy.model.showCheckbox && !this.mapCateg && !this.mapCateg != "")
                    proxy._selectListItems();
                this.element.find('.checkItem').each(function (i, e) {
                    proxy.model.checkedIndices.push(proxy._elementIndex(e));
                });
				if(!this.mapCateg && !this.mapCateg != ""){
                if (selectionArray.length)
                    this.model.allowMultiSelection ? this.model.selectedIndices = selectionArray : this.model.selectedIndex = selectionArray[0];
                if (this.model.checkedIndices)
                    this.model.checkedIndices = $.grep(proxy.model.checkedIndices, function (el, index) { return index == $.inArray(el, proxy.model.checkedIndices); });
                else if (this.model.selectedIndices)
                    this.model.selectedIndices = $.grep(proxy.model.selectedIndices, function (el, index) { return index == $.inArray(el, proxy.model.selectedIndices); });
				}
                this._loadContent = true;
            }
            return this;
            
        },
        _applySelection: function () {
            if (!(this.model.fields.checkBy || this.model.fields.selectBy)) return false;
            if (this.model.showCheckbox) {
                this.uncheckAll();
                this.checkItemsByIndices(this.model.checkedIndices);
            }
            else {
                if (this.model.allowMultiSelection)
                    this.selectItemsByIndices(this.model.selectedIndices);
                else {
                    this.unselectAll();
                    this.selectItemByIndex(this.model.selectedIndex);
                }
            }
        },
        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },
        _getTemplatedString: function (list) {
            var str = this.model.template,
                start = str.indexOf("${"),
                end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                str = str.replace(content, this._getField(list, field));
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },
        _checkboxHideShow: function (value) {
            this.model.showCheckbox = value;
            (value) ? this._createCheckbox() : this._removeCheckbox();
            return this;
        },
        _createCheckbox: function () {
            var i, _extchk, chklist, me = this;
            this._listitems = this.listContainer.find("ol,ul").length > 0 ? this.listContainer.find("ol,ul").children("li:not('.e-ghead')") : this.element.children("li:not('.e-ghead')");
            chklist = this._listitems.find('input[type=checkbox]');
            for (i = 0; i < this._listitems.length; i++) {
                if ($(this._listitems[i]).text() != "") {
                    $checkbox = ej.buildTag("input.listcheckbox e-align#popuplist" + i + "_" + this._id, "", {}, {
                        type: "checkbox",
                        name: "list" + i
                    });
                    if (!$(this._listitems[i]).find('input[type=checkbox]').length)
                        $(this._listitems[i]).prepend($checkbox);
                }
            }
            this.listContainer.find(".listcheckbox").ejCheckBox({
                cssClass: this.model.cssClass,
                change: $.proxy(this._onClickCheckList, this)
            });
            for (i = 0; i < this._listitems.length; i++) {
                var checkbox = $(this._listitems[i]).find(".listcheckbox");
                if ($(this._listitems[i]).hasClass('e-disable')) checkbox.ejCheckBox('disable');
                else if ( $(this._listitems[i]).hasClass('checkItem') && !checkbox.ejCheckBox('isChecked')) {                    
                    checkbox.ejCheckBox({
                        "checked": true
                    });
                    this._activeItem = i;
                    this.checkedStatus = true;
                    var checkData = this._getItemObject($(this._listitems[i]), null);
                    checkData["isInteraction"] = true;
                    if (!this._initValue) this._trigger('checkChange', checkData);
                    $(this._listitems[i]).removeClass('checkItem');
                }
            }
            for (i = 0; i < this.model.selectedIndices.length; i++) {
                this.checkItemsByIndices(this.model.selectedIndices);
            }
        },
        _removeCheckbox: function () {
            var i, checkbox;
            this.listitem = this.listContainer.find("ol,ul").children("li");
            checkbox = this.listitem.find('.listcheckbox');
            if (checkbox.length > 0) {
                this.listitem.find('.listcheckbox').ejCheckBox('destroy');
                this.listitem.find('input[type=checkbox]').remove();
                if (this.model.allowMultiSelection) {
                    for (i = 0; i < this.model.checkedIndices.length; i++) {
                        this.selectItemsByIndices(this.model.checkedIndices);
                    }
                } else this.selectItemByIndex(this.model.checkedIndices[0]);
                this._checkedItems = this.model.checkedIndices = [];
            }
        },
        _selectCheckedItem: function (chkitems) {
            if (chkitems.length > 0)
                for (i = 0; i < chkitems.length; i++)
                    this._selectedItems.push(chkitems[i]);
        },
        _refreshScroller: function () {
            if (this.model.virtualScrollMode == "continuous") {
                this.listContainer.find(".e-content, .e-vhandle,.e-vhandle div").removeAttr("style");
                this.listContainer.css({ "display": "block" });
                if (this.scrollerObj) {
                    this.scrollerObj.model.height = this.listContainer.height();
                    this.scrollerObj.refresh();
                    this.scrollerObj.option("scrollTop", 0);
                }
            } else {
                this.listContainer.find(".e-vhandle div").removeAttr("style");
                var listboxcontent = this.listBoxScroller.height();
                this.listContainer.css({ "display": "block" });
                if (this.scrollerObj) {
                    this.scrollerObj.model.height = this.listContainer.css("height");
                    this.scrollerObj.refresh();
                }
                this.listBoxScroller.css("height", "100%");
            }
            if (!this.model.enabled) {
                if (this.scrollerObj) this.scrollerObj.disable();
            }
            this.listContainer.css("height", this.model.height);
        },
        _setDimensions: function () {
            this.listContainer.css({ "width": this.model.width, "height": this.model.height });
            this._refreshScroller();
            return this;
        },
        _setItemsCount: function () {
            if(this.model.height=="auto"){
            if (this.model.itemsCount && this.model.itemsCount != 0 && this.model.height == "auto")
                this.model.height = this.model.itemsCount * 30;
            else
                this.model.height = (this.model.height == "auto") ? "220" : this.model.height;
              }
               else if (this.model.height != "auto" && this.model.itemsCount) {
                if (this.model.itemHeight)
                this.model.height = (this.model.height == "auto") ? "220" : this.model.itemsCount * this.model.itemHeight.replace(/[^-\d\.]/g, '');
                else
                    this.model.height = (this.model.height == "auto") ? "220" : this.model.itemsCount * 30;
            }
            else if (this.model.height != "auto" && this.model.itemsCount !=0) {
                this.model.height;
            }
            return this;
        },
        _setTotalItemsCount: function () {
            if (this.model.virtualScrollMode != "continuous") {
                this.element.height(this.element.find("li").outerHeight() * this.model.totalItemsCount);
                this.scrollerObj.refresh();
            }
        },

        _refreshContainer: function () {
            this.listContainer.css({ "position": "relative" });
            this._setDimensions()._roundedCorner()._refreshScroller();
        },
        _drag: function () {
            var proxy = this,
                pre = false,
                _clonedElement = null,
                dragContainment = null;
            this._listitem = this.element.parent();
            this._lilist = this._addItemIndex ? $($(this._listitem).find("li")[this._addItemIndex]) : $(this._listitem).find("li");
            this._lilist.not(".e-js").ejDraggable({
                dragArea: dragContainment,
                clone: true,
                dragStart: function (args) {
                  if( proxy.model.allowDrag || proxy.model.allowDragAndDrop ) {
                    if (!$(args.element.closest('.e-ddl-popup.e-js')).hasClass('e-disable') && !args.element.hasClass('e-disable')) {
                        var draggedobj = $("#" + this.element.parent()[0].id).data("ejListBox");
                        draggedobj._refreshItems();
                        var dragEle = proxy.getSelectedItems();
                        if (dragEle.length > 1 ? proxy._onDragStarts(dragEle, args.target) : proxy._onDragStarts([proxy._getItemObject(args.element, args)], args.target)) {
                            args.cancel = true;
                            _clonedElement && _clonedElement.remove();
                            return false;
                        }
                    } else {
                        _clonedElement && _clonedElement.remove();
                        return false;
                    }
                  }
                  else return false;
                },
                drag: function (args) {
                    var target = args.target;
                    var dragEle = proxy.getSelectedItems();
                    if (dragEle.length > 1 ? proxy._onDrag(dragEle, target) : proxy._onDrag([proxy._getItemObject(args.element, args)], target)) return false;
                    if ($(target).hasClass('e-droppable') || $(target).parent().hasClass('e-droppable'))
                        $(target).addClass("allowDrop");
                },
                dragStop: function (args) {
                    if (!args.element.dropped)
                        _clonedElement && _clonedElement.remove();
                    var target = args.target, targetObj = proxy;
                    var position = pre ? "Before" : "After";
                    var dragEle = proxy.getSelectedItems();
                    if (dragEle.length > 1 ? proxy._onDragStop(dragEle, target) : proxy._onDragStop([proxy._getItemObject(args.element, args)], target)) return false;
                    $(args.element).removeClass("e-active");
                    if (target.nodeName == 'UL') target = $(target).children()[0];
                    if ($(target).closest('li').length) target = $(args.target).closest('li')[0];
                    else if (target.nodeName != 'LI') target = $(target).closest('.e-ddl-popup.e-droppable')[0];
                    if (target && target.nodeName == 'LI' && $(target).hasClass('e-droppable') && $(target).closest('.e-ddl-popup.e-droppable').length) proxy._dropItem(target, args.element, pre, args.event);
                    else if ($(target).hasClass('e-droppable') && $(target).closest('.e-ddl-popup.e-droppable').length) proxy._dropItemContainer(target, args.element, args.event);
                    $(".allowDrop").removeClass("allowDrop");
                    if (args.target != proxy.element[0] && (args.element.parent().length && $(args.element.parent()[0]).data().ejWidgets[0] == "ejListBox")) {
                        proxy = $("#" + args.element.parent()[0].id).data($(args.element.parent()[0]).data().ejWidgets[0]);
                        if (dragEle.length > 1 ? proxy._onDropped(dragEle, target) : proxy._onDropped([proxy._getItemObject(args.element), args], args.target)) return false;
                    }
                    if( !proxy.model.allowDrag && !proxy.model.allowDragAndDrop ) proxy.element.children().removeClass("e-draggable");
                },
                helper: function (event, ui) {
                    if (!ej.isNullOrUndefined(event.element) && !$(event.element.closest('.e-ddl-popup.e-js')).hasClass('e-disable') && $(event.element).hasClass('e-draggable')) {
                        proxy = $(event.element).closest('.e-listbox.e-js').data('ejListBox');
                        proxy._tempTarget = $(event.element).text();
                        if ((proxy.model.allowDrag || proxy.model.allowDragAndDrop) && proxy) {
                            _clonedElement = $(event.sender.target).clone().addClass("dragClone dragClonelist");
                            _clonedElement.addClass(proxy.model.cssClass + (proxy.model.enableRTL ? ' e-rtl' : ''));
                            _clonedElement.css({ "width": proxy.element.width(), "padding": "5px 5px 5px 0.857em", "list-style": "none", "text-align": (proxy.model.enableRTL ? "right" : "left"), "opacity": "1" });
                            return _clonedElement.appendTo($("body"));
                        }
                    }
                }
            });
        },
        _dropItem: function (target, element, pre, event) {
            element.addClass("e-droppable");
            var targetid = $(target).closest('.e-ddl-popup.e-droppable')[0].id.replace('_container', '');
            var dataIndex = [], dataObj = [];
            var droppedobj = $("#" + targetid).data("ejListBox");
            var preventDrop = (droppedobj.model.showCheckbox ? !this.model.showCheckbox : this.model.showCheckbox);
            if (preventDrop) return;
            var data = this._getDropObject(target, element, event);
            dataIndex = data.dataIndex;
            dataObj = data.dataObj;
            pre ? $(this.li).insertBefore(target) : $(this.li).insertAfter(target);
            this._refreshItems();
            if (dataObj && this.dataSource())
                this._dropDataSource(droppedobj, dataIndex, dataObj, this.li.index());
            droppedobj._refreshItems();
        },
        _dropItemContainer: function (target, element, event) {
            element.addClass("e-droppable");
            var targetid = $(target)[0].id.replace('_container', '');
            var droppedobj = $("#" + targetid).data("ejListBox");
            var preventDrop = (droppedobj.model.showCheckbox ? !this.model.showCheckbox : this.model.showCheckbox);
            if (preventDrop) return;
            var dataIndex = [], dataObj = [];
            var data = this._getDropObject(target, element, event);
            dataIndex = data.dataIndex;
            dataObj = data.dataObj;
            this.li.insertAfter($($(target).find('li')).last());
			if($(target).find('ul').length > 0) $(target).find('ul').append(this.li);
			else $(target).find('ej-listbox').append(this.li);
            this._refreshItems();
            if (dataObj && this.dataSource())
                this._dropDataSource(droppedobj, dataIndex, dataObj, droppedobj.dataSource() ? droppedobj.dataSource().length : 0);
            if (!droppedobj.model.allowDrag)
                $(this.li).ejDraggable("instance")._destroy();
            droppedobj._refreshItems();
        },
        _dropDataSource: function (droppedobj, dataIndex, dataObj, droppedIndex) {
            var preventDropData = ej.DataManager && this.dataSource() instanceof ej.DataManager;
            if (preventDropData) return;
            if (dataIndex instanceof Array) {
                var proxy = this;
                $.each(dataObj, function (index) {
                   var indx = proxy.dataSource().indexOf(dataObj[index]);
                    proxy.dataSource().splice(indx, 1);
                });
            }
            else
                this.dataSource().splice(dataIndex, 1);
            if (droppedobj.dataSource() instanceof Array) {
                droppedobj.dataSource().splice.apply(droppedobj.dataSource(), [droppedIndex, 0].concat(dataObj));
            }
            else {
                droppedobj.dataSource(dataObj);
            }
        },
        _getDropObject: function (target, element, event) {
            var dataIndex = [], dataObj = [];
            if (this.model.allowMultiSelection) {
                this.li = $(element).parent().find(".e-select").removeClass("e-select e-hover");
                if (!this.li.length)
                 this.li = element.removeClass("e-select e-hover");
            }
            else
                this.li = element.removeClass("e-select e-hover");

            if (this.li.length) {
               var proxy = this;
                $.each(this.li, function (ele) {
                    dataIndex.push($(this).index());
                    dataObj.push((proxy.dataSource()) ? proxy.dataSource()[$(this).index()] : null);
                });
            }
            else {
                dataIndex = this.li.index();
                dataObj = (this.dataSource()) ? this.dataSource()[dataIndex] : null;
            }
            return { "dataIndex": dataIndex, "dataObj": dataObj };
        },
        _showResult: function () {
            var proxy = this;
            this._refreshContainer();
            this.element.attr({
                "aria-expanded": true
            });
            var _ListItemsContainer = this.element.children("li:not('.e-ghead')");
            this._listSize = _ListItemsContainer.length;
			this._ListEventUnbind(_ListItemsContainer);
            _ListItemsContainer.on("touchstart mouseenter", $.proxy(this._OnMouseEnter, this));
            _ListItemsContainer.on("touchend mouseleave", $.proxy(this._OnMouseLeave, this));
            _ListItemsContainer.on("click", $.proxy(this._OnMouseClick, this));
            _ListItemsContainer.on("contextmenu", $.proxy(this._OnMouseContext, this));            
            if (proxy.model.showCheckbox) proxy.element.find(".listcheckbox").ejCheckBox({ enabled: proxy.model.enabled });
            return this;
        },
        _OnWindowResize: function (e) {
            this._refreshContainer();
            this.listContainer.css("display", "block");
        },
        refresh: function (value) {
		    if (!ej.isNullOrUndefined(this.model.query)) this._savedQueries = this.model.query; 
            if (this.model.dataSource) {
                if (this.model.template)
                    this.element.empty();
                this._checkModelDataBinding(this.dataSource());
            }
            else {
                this.listContainer.css({ "height": this.model.height, "width": this.model.width });
                this._refreshScroller();
            }
        },
        _removeListHover: function () {
            this._selectedItems = [];
            this.model.selectedIndices = [];
            this.model.selectedIndex = null;
            this.element.children("li").removeClass("e-hover e-select selectItem");
            return this;
        },
        _addListHover: function () {
            this._activeItem = this._selectedItem;
            var activeItem = this._getItem(this._selectedItem);
            activeItem.addClass("e-select e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
            activeItem.focus();
            this._OnListSelect(this.prevselectedItem, this._selectedItem);
        },
        _calcScrollTop: function (value) {
            var ulH = this.element.outerHeight(),
                li = this.element.find("li"),
                liH = 0,
                index, top, i;
            index = value ? value : this.element.find("li.e-select").index();
            for (i = 0; i < index; i++)
                liH += li.eq(i).outerHeight();
            top = liH - ((this.listContainer.outerHeight() - li.eq(index).outerHeight()) / 2);
            return top;
        },
        _refreshItems: function () {
            this.listBoxScroller.append(this.element);
            this.listContainer.append(this.listBoxScroller);
            this._refreshContainer();
            this._showResult();
            this._setSelectionValues();
            this._setDisableValues();
        },
        _selectedIndices: function () {
            var selectItem;
            this.element.children("li:not('.e-ghead')").each(function (index) {
                if ($(this).hasClass("e-select")) {
                    selectItem = index;
                    return false
                }
            });
            this._selectedItem = selectItem;
            return selectItem;
        },
        _addSelectedItem: function (e) {
            if ((!$.isArray(this.model.disableItemsByIndex) && this.model.disableItemsByIndex != null) || ($.isArray(this.model.disableItemsByIndex) && this.model.disableItemsByIndex.length > 0)) {
                if (e.keyCode == 40 || e.keyCode == 39) this._disableItemSelectDown();
                else this._disableItemSelectUp();
                this._selectedItem = this._activeItem
            }
            var activeItem = this._getItem(this._selectedItem);
            this._selectedItems.push(activeItem)
        },
        _getItem: function (val) {
            return $(this.element.children("li:not('.e-ghead')")[val])
        },
        _getItemObject: function (item, evt) {
            var index = this._elementIndex(item);
            return {
                item: item,
                index: index,
                text: item.text(),
                value: item.attr("value") ? item.attr("value") : item.text(),
                isEnabled: !item.hasClass("e-disable"),
                isSelected: item.hasClass("e-select"),
                isChecked: item.find('.e-chk-image').hasClass('e-checkmark'),
                data: this.dataSource() ? this.getListData()[index] : null,
                event: evt ? evt : null
            };
        },
        _roundedCorner: function () {
            this.listContainer[(this.model.showRoundedCorner ? "addClass" : "removeClass")]("e-corner-all");
            return this;
        },
        _enabled: function (boolean) {
            boolean ? this.enable() : this.disable();
            return this;
        },
        _showFullList: function () {
            if (this.dataSource() != null) {
                if (!(ej.DataManager && this.dataSource() instanceof ej.DataManager))
                    this.listitems = this.dataSource();
                if (this._savedQueries.queries.length && !(ej.DataManager && this.dataSource() instanceof ej.DataManager))
                    this.listitems = ej.DataManager(this.dataSource()).executeLocal(this._savedQueries);
            }
            this._renderlistContainer();
            if (!(this.dataSource() instanceof ej.DataManager)) this._trigger("actionComplete");
            this._addDragableClass()._enableDragDrop();
            this._disabledItems = [];
            this.disableItemsByIndices(this.model.disableItemsByIndex);
            if (this.model.selectedIndex == 0) this.selectItemByIndex(this.model.selectedIndex);
            else this.model.selectedIndex && this.selectItemByIndex(this.model.selectedIndex);
            this.selectItemsByIndices(this.model.selectedIndices);
            this.checkItemsByIndices(this.model.checkedIndices);
            this._tooltipList();
            return this;
        },
        _tooltipList: function(){
             if (this.listContainer.find('li').hasClass('e-tooltip')){
                $(this.listContainer).ejTooltip({
                    target: ".e-tooltip",
                    isBalloon: false,
                    position: {
                        target: { horizontal: "center", vertical: "bottom" },
                        stem: { horizontal: "left", vertical: "top" }
                    }
                });
            }
       },
        _cascadeAction: function () {
            if (this.model.cascadeTo) {
                this._currentValue = this._getField(this.listitems[this._activeItem], this.mapFld._value);
                this.selectDropObj = $('#' + this.model.cascadeTo).ejListBox('instance');
                 $.extend(true, this.selectDropObj, { _isCasCadeTarget: true });
                if (ej.isNullOrUndefined(this._dSource))
                    this._dSource = this.selectDropObj.dataSource();
                this._performJsonDataInit();
			     var args = { cascadeModel: this.selectDropObj.model, cascadeValue: this._currentValue, setCascadeModel:{}, requiresDefaultFilter: true };
                this._trigger("cascade", args);	
                this.selectDropObj._setCascadeModel = args.setCascadeModel;				
            }
        },
        _performJsonDataInit: function () {
            this._changedSource = ej.DataManager(this._dSource).executeLocal(ej.Query().where(this.mapFld._value, "==", this._currentValue));
            this.selectDropObj.setModel({
                dataSource: this._changedSource,
                enable: true,
                value: "",
                selectedIndex: -1                
            })
        },
        _OnMouseContext: function (e) {
            e.preventDefault();
            return false
        },
        _OnMouseEnter: function (e) {
            this.startime = 0;
            this.item = "";
            if (e.type == "touchstart") {
                this.item = $(e.target).text();
                this.startime = new Date().getTime()
            }
            if (this.model.enabled) {
                var targetEle;
                this.element.children("li").removeClass("e-hover");
                if ($(e.target).is("li")) $(e.target).addClass("e-hover");
                if ($(e.target).hasClass("e-disable")) $(e.target).removeClass('e-hover');
                else if (e.target.tagName != "li") {
                    targetEle = $(e.target).parents("li");
                    $(targetEle).addClass("e-hover")
                }
                var activeItem, selectItem = 0;
                this.element.children("li:not('.e-ghead')").each(function (index) {
                    if ($(this).hasClass("e-hover")) {
                        activeItem = index;
                        return false
                    }
                });
                this._hoverItem = activeItem
            }
        },
        _OnMouseLeave: function (e) {
            this.element.children("li").removeClass("e-hover");
            this.endtime = new Date().getTime();
            if ((((this.endtime - this.startime) / 200) > 2))
                if ((this.item == $(e.target).text())) this.hold = (((this.endtime - this.startime) / 200) > 2) ? !this.hold : false;
        },
        _OnMouseClick: function (e) {
            if($(e.currentTarget).hasClass("e-disable")) return false;
            if (e.which == 3)
                this.hold = true;
            this.endtime = new Date().getTime();
            if ((((this.endtime - this.startime) / 200) > 2))
                if ((!this.model.template && this.item == $(e.target).text()) && (!this.hold))
                    this.hold = (((this.endtime - this.startime) / 200) > 2);
            if (e.shiftKey && this._shiftkey) {
                this._shiftkey = false;
                this.prevselectedItem = this._activeItem;
            }
            if (!ej.isNullOrUndefined(this._hoverItem)) this._activeItem = this._hoverItem;
            if (this.model.enabled && this._activeItem != undefined) {
                if (!e.shiftKey || isNaN(this.prevselectedItem)) {
                    this._shiftkey = true;
                    this.prevselectedItem = this._lastEleSelect ? this._lastEleSelect : this._activeItem;
                }
                if (!this.model.showCheckbox) {
                    var activeitem = $(this.element.children("li:not('.e-ghead')")[this._hoverItem]);
                    if (!this.model.allowMultiSelection || (!(e.ctrlKey || this.touchhold || this.hold) && !e.shiftKey))
                        this._removeListHover();
                    this.element.children("li").removeClass('e-hover');
                    if (!activeitem.hasClass('e-select') ||(e.shiftKey && this.model.allowMultiSelection)) {
                        activeitem.addClass('e-select');
                        this._selectedItems.push(activeitem);
                        this.model.selectedIndices.push(this._activeItem);
                        if (e.shiftKey && (this.model.allowMultiSelection)) {
                            if (!e.ctrlKey) this._removeListHover();
                            var initial, last;
                            if (this.prevselectedItem < this._activeItem)
                                initial = this.prevselectedItem, last = this._activeItem;
                            else
                                initial = this._activeItem, last = this.prevselectedItem;
                            this._activeItemLoop(initial,last);
                        }
                    } else {
                        activeitem.removeClass('e-select');
                        this._selectedItems.splice(this.model.selectedIndices.indexOf(this._activeItem), 1);
                        this.model.selectedIndices.splice(this.model.selectedIndices.indexOf(this._activeItem), 1);
                    }
                    this._selectedItem = this._selectedIndices();
                    this.model.selectedIndex = this._activeItem;
                    this._cascadeAction();
                    var selecteditem = $(this.element.children("li:not('.e-ghead')")[this._selectedItem]);
                    if ($(selecteditem).text() != "") {
                        this.element.val($(selecteditem).text());
                        this.element.attr({
                            "value": this.element.val()
                        });
                    }
                    this.model.selectedText = activeitem.text();
                    this._selectedData = this._getItemObject($(selecteditem), e);
                    this._selectedData["isInteraction"] = true;
                    if (this._prevSelectedData && (this._selectedData.text != this._prevSelectedData.text))
                        this._trigger("unselect", this._prevSelectedData)
                    this._trigger("select", this._selectedData);
                    this._prevSelectedData = this._selectedData;
                    this._lastEleSelect = this._activeItem;
                    if (this._selectedItems && this._selectedItems.length != 1)
                        this._ctrlClick = true;
                } else {
                    if (($(e.currentTarget).is("li")) && ($(e.target).is("li"))) {
                        if ($(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('isChecked')) {
                            $(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', false);
                            var index = this.model.checkedIndices.indexOf($(e.currentTarget).index());
                            this._checkedItems.splice(index, 1);
                            this.model.checkedIndices.splice(index, 1);
                            this.checkedStatus = false;
                        } else {
                            $(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                            this._checkedItems.push(this._activeItem);
                            this.model.checkedIndices.push(this._elementIndex(e.currentTarget));
                            this.checkedStatus = true;
                        }
                    }
                    else if (($(e.currentTarget).is("li")) && ($(e.target).is("span"))) {
                        if ($(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('isChecked')) {
                            this._checkedItems.push(this._activeItem);
                            this.model.checkedIndices.push($(e.currentTarget).index());
                            this.checkedStatus = true;
                        }
                        else {
                            var index = this.model.checkedIndices.indexOf($(e.currentTarget).index());
                            this._checkedItems.splice(index, 1);
                            this.model.checkedIndices.splice(index, 1);
                            this.checkedStatus = false;
                        }
                    }
                    else
                        return false;
                    this.selectedTextValue = $(e.currentTarget).text();
                    if (!this.element.hasClass("e-disable") && $(e.target).is("li")) {
                        var args = {
                            status: this.model.enabled,
                            isChecked: this.checkedStatus,
                            selectedTextValue: this.selectedTextValue
                        };
                        var checkData = this._getItemObject($(e.target), e);
                        checkData["isInteraction"] = true;
                        this._trigger("checkChange", checkData);
                    }
                    this._lastEleSelect = $(e.currentTarget).index();
                }
                if (e.ctrlKey || e.shiftKey) e.shiftKey ? (this._shiftSelectItem = this._activeItem, this._ctrlSelectItem = null)  : (this._ctrlSelectItem = this._activeItem, this._shiftSelectItem = null);
                else {
                    this._shiftSelectItem = null;
                    this._ctrlSelectItem = null;
                }
                this._setSelectionValues()._OnListSelect(this.prevselectedItem, this._activeItem);
            }
            if (e.target.nodeName != "INPUT")
                this.listContainer.focus();
			this._pageUpStep = this._pageDownStep = null;
        },
		_activeItemLoop: function (initial , last) {
		    if (this.model.showCheckbox) {
		        var items = this.listContainer.find('li:not(.e-disable)');
		        items.find(".listcheckbox").ejCheckBox('option', 'checked', false);
				this._checkedItems = [];
                this.model.checkedIndices = [];
			}
			for (var i = initial; i <= last; i++) {
			    if (this.model.showCheckbox && !this.listContainer.find('li').eq(i).hasClass('e-disable')) {
					this.element.find('.listcheckbox').eq(i).ejCheckBox('option', 'checked', true);
                    this._checkedItems.push(i);
                    this.model.checkedIndices.push(i);
                    this.checkedStatus = true;
                }
				else {
                    activeitem = $(this.element.children("li")[i]);
                    if (!activeitem.hasClass('e-disable')) {
                        if (!activeitem.hasClass('e-select')) activeitem.addClass('e-select');
                        this._selectedItems.push(activeitem);
                        this.model.selectedIndices.push(i);
                    }
                }
            }
		},
        _setSelectionValues: function () {
            var selectionArray = [];
            var oldSelectedIndices = this.model.selectedIndices;
            var oldCheckedIndices = this.model.checkedIndices;
            this.model.selectedIndices = [];
            this.model.checkedIndices = [];
            var proxy = this;
            if (!this.model.showCheckbox) {
                if (!ej.isNullOrUndefined(this._activeItem) && this._activeItem >= 0) this.model.selectedIndex = this._activeItem;
                var liItem = this.element.children("li:not('.e-ghead')");
                this.element.children("li:not('.e-ghead').e-select").each(function (index, ele) {
                    selectionArray.push($(ele).attr("value") ? $(ele).attr("value") : !ej.isNullOrUndefined(proxy.model.fields.text) && proxy.dataSource() ? proxy.getListData()[proxy._elementIndex(ele)][proxy.model.fields.text] : $(ele).text());
                    proxy.model.selectedIndices.push(liItem.index(ele));
                });
            }
            else {
                this.element.find("li:not('.e-ghead') .listcheckbox:checked").closest('li').each(function (index, ele) {
                    selectionArray.push($(ele).attr("value") ? $(ele).attr("value") : !ej.isNullOrUndefined(proxy.model.fields.text) && proxy.dataSource() ? proxy.getListData()[proxy._elementIndex(ele)][proxy.model.fields.text] : $(ele).text());
                    proxy.model.checkedIndices.push(proxy._elementIndex(ele));
                });
            }
            if (ej.DataManager && ej.DataManager && this.dataSource() instanceof ej.DataManager && this.model.allowVirtualScrolling) {
                if (this.model.showCheckbox) {
                    for (var i = 0; i < oldCheckedIndices.length; i++) {
                        if (this.model.checkedIndices.indexOf(oldCheckedIndices[i]) == -1)
                            this.model.checkedIndices.push(oldCheckedIndices[i]);
                    }
                }
                else {
                    for (var i = 0; i < oldSelectedIndices.length; i++) {
                        if (this.model.selectedIndices.indexOf(oldSelectedIndices[i]) == -1)
                            this.model.selectedIndices.push(oldSelectedIndices[i]);
                    }
                }
            }
            this.model.selectedItemIndex = this.model.selectedIndex;
            this.model.selectedItems = this.model.selectedItemlist = this.model.selectedIndices;
            this.model.checkedItems = this.model.checkedItemlist = this.model.checkItemsByIndex = this.model.checkedIndices;
            this.value(selectionArray.toString());
            this._hiddenInput.val(this.value());
            return this;
        },
        _setDisableValues: function () {
            this._disabledItems = [];
            this.model.disableItemsByIndex = [];
            var lenth = this.element.children().length, indx;
            for (var indx = 0; indx < lenth; indx++)
                if ($(this.element.children()[indx]).hasClass('e-disable'))
                    this.model.disableItemsByIndex.push(indx);
            this.disableItemsByIndices(this.model.disableItemsByIndex);
        },
        _onClickCheckList: function (e) {
			if(!e.isChecked) $("#"+ e.model.id).closest('li').removeClass("checkItem");
            if (e.isInteraction) {
                this.checkedStatus = e.isChecked ? true : false;
                if (!this._initValue) {
                    this.checkedStatus ? this.model.checkedIndices.push($(e.event.target).closest('li:not(".e-ghead")').index()) : this.model.checkedIndices.splice($.inArray($(e.event.target).closest('li:not(".e-ghead")').index(), this.model.checkedIndices), 1);
                    var checkData = this._getItemObject($(e.event.target).closest('li'), e);
                    checkData["isInteraction"] = true;
                    this._trigger('checkChange', checkData);
                }
            }
        },
		_elementIndex: function (args) {
		    return $(args).parent().children("li:not('.e-ghead')").index(args);
		},
        _disableItemSelectCommon: function () {
            this.listitems = this.element.find('li');
            this._activeItem = this.listitems.index(this.element.find(".e-select"));
        },

        _disableItemSelectUp: function () {
            this._disableItemSelectCommon();
            var disableList = (typeof (this.model.disableItemsByIndex) != "object") ? this.model.disableItemsByIndex.split(",").sort().reverse() : this.model.disableItemsByIndex;
            if (this._activeItem == 0) this._activeItem = this.listitems.length - 1;
            else this._activeItem--;
            for (var lists = 0;
                ($.inArray(this._activeItem.toString(), disableList.toString())) > -1; lists++) {
                this._activeItem--;
                if (this._activeItem < 0) this._activeItem = this.listitems.length - 1
            }
            $(this.element.children("li")[this._activeItem]).addClass('e-select')
        },
        _disableItemSelectDown: function () {
            this._disableItemSelectCommon();
            var disableList = (typeof (this.model.disableItemsByIndex) != "object") ? this.model.disableItemsByIndex.split(",").sort() : this.model.disableItemsByIndex;
            ((this.listitems.length - 1) == this._activeItem) ? this._activeItem = 0 : this._activeItem++;
            for (var lists = 0;
                ($.inArray(this._activeItem.toString(), disableList.toString())) > -1; lists++) {
                this._activeItem++;
                if ((this.listitems.length) == this._activeItem) this._activeItem = 0
            }
            $(this.element.children("li")[this._activeItem]).addClass('e-select')
        },
        _checkitems: function () {
            if (this.model.showCheckbox) {
                var listitems = this.element.find("li:not('.e-ghead')");
                for (i = 0; i < this.model.checkedIndices.length; i++) {
                    var item = this.model.checkedIndices[i];
                    $(listitems[item]).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                    this._checkedItems.push(listitems[item])
                }
            } else {
                if (this.model.allowMultiSelection) {
                    for (i = 0; i < this.model.selectedIndices.length; i++) {
                        var item = this.model.selectedIndices[i];
                        if (!($(this.listitem[item]).hasClass("e-select"))) {
                            $(this.listitem[item]).addClass("e-select");
                            this._selectedItems.push($(this.listitem[item]));
                        }
                    }
                } else {
                    if (!($(this.listitem[this.model.selectedIndex]).hasClass("e-select")))
                        $(this.listitem[this.model.selectedIndex]).addClass("e-select");
                    this._selectedItems.push($(this.listitem[this.model.selectedIndex]))
                }
            }
            this._setSelectionValues();
            return this;
        },
        _OnListSelect: function (previtem, selecteditem, e) {
            if (!ej.isNullOrUndefined(previtem) && previtem != selecteditem && !this.model.showCheckbox) {
                var selectData = this._getItemObject($(this.element.find("li:not('.e-ghead')")[selecteditem]), e);
                selectData["isInteraction"] = true;
                this._trigger('change', selectData);
            }
        },
        _OnKeyDown: function (e) {
            if (this.model.enabled) {
                if (this._selectedItems && this._selectedItems.length == 1 && !this.model.showCheckbox)
                    this._lastEleSelect = $(this.element.children("li.e-select")).index();
                this._itemId = null;
                var _ListItemsContainer = this.element.children("li"), proxy = this,liH, popupH, activeitem;
                popupH = this.listContainer.height();
                liH = _ListItemsContainer.outerHeight();
                activeitem = Math.round(popupH / liH) != 0 ? Math.floor(popupH / liH) : 7;
                this._listSize = this.element.children("li").length;
                if (!e.shiftKey) this._up = this._down;
				if(e.keyCode != 33 && e.keyCode != 34) this._pageUpStep = this._pageDownStep = null;
                switch (e.keyCode) {
                    case 37:
                    case 38:
                        var liItems = this.listItemsElement;
                        var selectedIndex = this._shiftSelectItem ? this._shiftSelectItem : this._ctrlSelectItem ? this._ctrlSelectItem : (this.model.showCheckbox) ? (this._lastEleSelect || 0) : liItems.index(this.element.find("li.e-select"));
                        if (e.shiftKey && this.model.allowMultiSelection && !this.model.showCheckbox) {
                            if (this._lastEleSelect == 0) return false;
                            this._lastEleSelect = (this._ctrlClick) ? this._lastEleSelect - 1 : this._lastEleSelect;
                            selectedIndex = this._lastEleSelect;
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == 0 ? this._listSize - 1 : (this._down ? selectedIndex : selectedIndex - 1)) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i--)
                                this._selectedItem -= 1;
                            if($(_ListItemsContainer[this._selectedItem]).hasClass("e-select") && this.element.find("li.e-select").length == 1) this._selectedItem -= 1;
                            var activeItem = $(_ListItemsContainer[this._selectedItem]);
                            if (activeItem.hasClass("e-select")) {
                                if (this._selectedItem == 0) return;
                                activeItem.removeClass("e-select");
                                this._selectedItems.pop();
                            }
                            else {
                                activeItem.addClass("e-select");
                                this._selectedItems.push(activeItem);
                            }
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
                            this._up = true;
                            this._down = false;
                            this._ctrlClick = false;
                        }
                        else {
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == 0 ? this._listSize - 1 : selectedIndex - 1) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i--)
                                this._selectedItem -= 1;
                            if (this._selectedItem == -1) this._selectedItem = this._listSize - 1;
                            this._addSelectedItem(e);
                            $(_ListItemsContainer).removeClass("e-hover e-select");
                            var addClass = (this.model.showCheckbox) ? "e-hover" : "e-select";
                            $(_ListItemsContainer[this._selectedItem]).addClass(addClass);
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
                        }
						this._activeItem = this.prevselectedItem = this._selectedItem;
                        this._OnListSelect(this._selectedItem + 1, this._selectedItem, e);
                        this._lastEleSelect = this._selectedItem;
                        this._keyCascade(_ListItemsContainer[this._selectedItem]);
                        this._setSelectionValues();
                        this._shiftSelectItem = this._ctrlSelectItem = null;
                        e.preventDefault();
                        return false;
                        break;
                    case 39:
                    case 40:
                        var liItems = this.listItemsElement;
                        var selectedIndex = this._shiftSelectItem ? this._shiftSelectItem : this._ctrlSelectItem ? this._ctrlSelectItem : (this.model.showCheckbox) ? (this._lastEleSelect || 0) : liItems.index(this.element.find("li.e-select"));
                        if (e.shiftKey && this.model.allowMultiSelection && !this.model.showCheckbox) {
                            if (this._lastEleSelect == this._listSize - 1) return false;
                            this._lastEleSelect = (this._ctrlClick) ? this._lastEleSelect + 1 : this._lastEleSelect;
                            selectedIndex = this._lastEleSelect;
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == this._listSize - 1 ? 0 : ((this._up || this._ctrlClick) ? selectedIndex : selectedIndex + 1)) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i++)
                                this._selectedItem += 1;
							if($(_ListItemsContainer[this._selectedItem]).hasClass("e-select") && this.element.find("li.e-select").length == 1) this._selectedItem += 1;		
                            var activeItem = $(_ListItemsContainer[this._selectedItem]);
                            if (activeItem.hasClass("e-select")) {
                                activeItem.removeClass("e-select");
                                this._selectedItems.pop();
                            }
                            else {
                                activeItem.addClass("e-select");
                                this._selectedItems.push(activeItem);
                            }
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
                            this._up = false;
                            this._down = true;
                            this._ctrlClick = false;
                        }
                        else {
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == this._listSize - 1 ? 0 : selectedIndex + 1) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i++)
                                this._selectedItem += 1;
                            if (this._selectedItem == this._listSize) this._selectedItem = 0;
                            this._addSelectedItem(e);
                            $(_ListItemsContainer).removeClass("e-hover e-select");
                            var addClass = (this.model.showCheckbox) ? "e-hover" : "e-select";
                            $(_ListItemsContainer[this._selectedItem]).addClass(addClass);
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
							this.element.find("li").removeClass("selectItem");
							this.model.selectedIndices.length = 0;
							this.model.selectedIndices.push(this._selectedItem);
                        }
						this._activeItem = this.prevselectedItem = this._selectedItem;
                        this._OnListSelect(this._selectedItem - 1, this._selectedItem);
                        this._lastEleSelect = this._selectedItem;
                        this._keyCascade(_ListItemsContainer[this._selectedItem]);
                        this._setSelectionValues();
                        this._shiftSelectItem = this._ctrlSelectItem = null;
                        return false;
                        break;
                    case 8:
                    case 9:
                    case 13:
                        if (this.model.showCheckbox) {
                            if (this.model.checkedIndices.indexOf(this._selectedItem) < 0)
                                this.checkItemByIndex(this._selectedItem);
                            else
                                this.uncheckItemByIndex(this._selectedItem);
                        }
                        break;
                    case 18:
                    case 33: /* page up */
                        var step = e.keyCode == 33 ? activeitem : 1;
						if (e.shiftKey && this.model.allowMultiSelection) { 
							if(this._pageUpStep == null) this._pageUpStep = this.prevselectedItem;
							if(this._pageDownStep == null) this._pageDownStep = this.prevselectedItem;
							if(this._pageDownStep <= this.prevselectedItem) {
								start = this._pageUpStep - step > 0  ? this._pageUpStep - step : 0;
								end = this._pageDownStep;
							}
							else {
								start = this.prevselectedItem;
								end = this._pageDownStep - step > this.prevselectedItem  ? this._pageDownStep - step : this.prevselectedItem;
							}
							this._shiftHomeAndEndKeyProcess( start,end, end > this.prevselectedItem ? end:start);
							this._pageUpStep = start;
							this._pageDownStep =end;
						}
                        else this._moveUp(this._activeItem, step);
                        this._preventDefaultAction(e);
                        break;
                    case 34: /* page down */
                        var step = e.keyCode == 34 ? activeitem : 1;
                        if (e.shiftKey && this.model.allowMultiSelection){
                            if(this._pageUpStep == null) this._pageUpStep = this.prevselectedItem;
                            if(this._pageDownStep == null) this._pageDownStep = this.prevselectedItem;
                            if( this._pageUpStep == 0 && this.prevselectedItem != 0) { 
								if( this._pageUpStep + step >= this.prevselectedItem) start = end = this.prevselectedItem;
								else {
									start = this._pageUpStep + step ;
									end = this._pageDownStep + step < this.element.children("li").length ?  this._pageDownStep + step : this.element.children("li").length-1;
                               }
                            }
                            else if(this._pageUpStep != this.prevselectedItem && this._pageUpStep + step >= this.prevselectedItem) start = end = this.prevselectedItem;
                            else {
                                start = this._pageUpStep;
                                end = this._pageDownStep + step < this.element.children("li").length ?  this._pageDownStep + step : this.element.children("li").length-1;
                            }
                            if(start < this.prevselectedItem && end > this.prevselectedItem ) end = this.prevselectedItem;
                            this._shiftHomeAndEndKeyProcess(start,end, start < this.prevselectedItem ? start:end);
                            this._pageUpStep = start;
                            this._pageDownStep =end;
                        } 
                        else this._moveDown(this._activeItem, step);
                        this._preventDefaultAction(e);
                        break;
                    case 35:
                        if (e.shiftKey && this.model.allowMultiSelection) this._shiftHomeAndEndKeyProcess(this._activeItem,(this._listSize - 1) , (this._listSize - 1));
                        else this._homeAndEndKeyProcess(e, _ListItemsContainer, (this._listSize - 1));
                        for (var i = this._listSize - 1; i > 0; i--) {
                            if (!$(this.element.find('li')[i]).hasClass('e-disable')) {
                                this.model.selectedIndex = i;
                                this._shiftSelectItem = i;
                                return false;
                            }
                        }
                    break;
                case 36:
                    if (e.shiftKey && this.model.allowMultiSelection) this._shiftHomeAndEndKeyProcess(0, this._activeItem, 0);
                    else this._homeAndEndKeyProcess(e, _ListItemsContainer, 0);
                    for (var i = 0; i < this._listSize; i++) {
                        if (!$(this.element.find('li')[i]).hasClass('e-disable')) {
                            this.model.selectedIndex = i;
                            return false;
                        }
                    }
                    break;
                }
            }
        },
        _moveUp: function (current, step) {
            if (current == null || current <= 0)  this._checkDisableStep(0, step, false);
            else if (current > this._listSize - 1) this._checkDisableStep(this._listSize - 1, step, false);
            else if (current > 0 && current <= this._listSize - 1) this._checkDisableStep(current, step, false);
        },
        _moveDown: function (current, step) {
            if (current == null || current < 0) this._checkDisableStep(-1, step, true);
            else if (current == 0)  this._checkDisableStep(0, step, true);
            else if (current >= this._listSize - 1) this._checkDisableStep(this._listSize - 1, step, true);
            else if (current < this._listSize - 1)  this._checkDisableStep(current, step, true);
        },
        _checkDisableStep: function (current, step, isdown, shift) {
            var command = isdown ? "_disableItemSelectDown" : "_disableItemSelectUp";
            var index = isdown ? current + step : current - step;
            var select = this[command](index);
            if (select == null) {
                for (var i = step; i >= 0; i--) {
                    index = isdown ? current + i : current - i;
                    select = this[command](index);
                    if (select != null) break;
                }
            }
            if (select != null)
                this.selectItemByIndex(select);
        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) 
                    return current;
                else
                    return this._disableItemSelectDown(current + 1);
            }
            else return this._listSize - 1;
        },

        _disableItemSelectUp: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) 
                    return current;
                else {
                    if (current > 0) 
                        return this._disableItemSelectUp(current - 1);
                }
            }
        },

        _preventDefaultAction: function (e, stopBubble) {
            e.preventDefault ? e.preventDefault() : (e.returnValue = false);
            if (stopBubble) 
                e.stopPropagation ? e.stopPropagation() : (e.cancelBubble = true);
        },
        _homeAndEndKeyProcess: function (e, _ListItemsContainer, index) {
            if ($(':focus').length && $(':focus')[0].nodeName != "INPUT") {
                this._OnListSelect(this._selectedItem, index);
                this.selectItemByIndex(index);
                this._selectedItem = index;
                this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(index) });
                if (this.model.showCheckbox) {
                    this._removeListHover();
                    $(_ListItemsContainer[index]).addClass("e-hover");
                    this._lastEleSelect = this._selectedItem = index;
                }
                this._keyCascade(_ListItemsContainer[index],e);
                e.preventDefault();
                return false;
            }
        },
        _shiftHomeAndEndKeyProcess: function(initial , last , index) {
			this._removeListHover();
			this._activeItemLoop(initial ,last);
			this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(index) });
            return false;
		},
        _keyCascade: function (obj, evt) {
            var selectData = this._getItemObject($(obj), evt);
            this.model.selectedText = selectData.text;
            selectData["isInteraction"] = true;
            this._trigger("select", selectData);
            if (this.model.cascadeTo) {
                this._activeItem = this._selectedItem;
                this._cascadeAction();
            }
        },

        mergeData: function (data,skipInitial) {
            this.mergeUl = $();
            this._setMapFields();
            var proxy = this;
            this._skipInitialRemoteData = skipInitial ? skipInitial : false;
            if (ej.DataManager && data instanceof ej.DataManager) {
                var queryPromise = data.executeQuery(this._getQuery());
                queryPromise.done(function (e) {
                    proxy.mergeValue = e.result;
                    proxy._renderlistContainer();
                });
            }
            else {
                this.mergeValue = data;
                this.listitems = this.listitems ? this.listitems : this.dataSource();
                this._renderlistContainer();
            }
            this._loadInitialRemoteData = false;
        },

        _onScroll: function (e) {
            this._temp = this.dataSource();
            if (this.model.actionBegin)
                this._trigger("actionBegin", {});
            if (this._temp != this.dataSource())
                (ej.DataManager && this.dataSource() instanceof ej.DataManager) ? this._initDataSource(this.dataSource()) : this._showFullList();
            var proxy = this, liEle = this.element.find('li')[0];
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                var liHeight=$(liEle).outerHeight();
                this.itemIndex = Math.round(this.scrollerObj.scrollTop() / liHeight);
                this.realUllength = this.itemIndex;
                var start = this.itemIndex, end;
                if (this.itemIndex > this.listContainer.outerHeight() / $(liEle).outerHeight()) {
                    start = (this.mergeValue && start >= this.mergeValue.length) ? start - this.mergeValue.length : start;
                    end = this.itemIndex + this._getLiCount();
                }
                if (this.mergeValue && this.itemIndex <= this.mergeValue.length || start <= 0)
                    start = 0;
                if (this.dataSource().length == undefined && (this._temp == this.dataSource())) {
                    if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
                        var startPoint = start == 0 ? start : start - 1;
                        var endPoint = start == this.element.find('li').length ? start : start + 1;
                        this._queryPromise(startPoint, proxy, endPoint + Math.ceil(this.model.height / liHeight), e);
                    }
                }
                else if (this._temp != this.dataSource()) {
                    this._queryPromise(start, proxy, this._listitems.length, e);
                }
                else if (this.dataSource().length > 0)
                    this._loadQueryData(start, end, proxy);
            } else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "continuous") {
                if (this.listItemsElement.length - 2 <= (this.scrollerObj.scrollTop() + this.listContainer.height()) / this.element.find('li').outerHeight()) {
                    this.lastScrollPosition = this.scrollerObj.scrollTop();
                    var start = this.mergeValue && !this._skipInitialRemoteData ? this.element.children().length - this.mergeValue.length : this.element.children().length;
                    if (start <= 0)
                        start = 0;
					if(this._oldStartValue)
						start = this._oldStartValue;
                    var totalLength = this.model.totalItemsCount ? this.model.totalItemsCount : this.listitems.length
                    if (this.listItemsElement.length < totalLength) {
                        if (this.dataSource().length == undefined) {
                            if (this.mergeValue && !this._skipInitialRemoteData)
                                var end = (this.model.totalItemsCount && start + this.model.itemRequestCount + this.mergeValue.length > this.model.totalItemsCount) ? this.model.totalItemsCount - this.mergeValue.length : start + this.model.itemRequestCount;
                            else
                                var end = (this.model.totalItemsCount && start + this.model.itemRequestCount > this.model.totalItemsCount) ? this.model.totalItemsCount : start + this.model.itemRequestCount;
                            if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
								if(start<=end)
                                	this._queryPromise(start, proxy, end, e);
								else
									return false;
							}
							this._oldStartValue = start + this.model.itemRequestCount;
                        }
                        else if (this.dataSource().length > 0) {
                            if (this._isScrollComplete) return;
                            this._loadQueryData(proxy.realUllength, proxy.realUllength + this.model.itemRequestCount, proxy);
                        }
                    }
                }
            }
        },
        _queryPromise: function (start, proxy, end, e) {
            this._trigger('itemRequest', { event: e, isInteraction: true });
            this._setMapFields();
            var mQuery = this._savedQueries.clone();
            var queryPromise = this.dataSource().executeQuery(mQuery.range(start, end));
            this._updateLoadingClass(true);
            queryPromise.done(function (d) {
			    proxy._trigger("actionBeforeSuccess", d);
                proxy.realUllength = (e.source != "wheel") ? proxy.mergeValue ? proxy.mergeValue.length + start : start : start;
                proxy._loadlist(d.result)._checkboxHideShow(proxy.model.showCheckbox)._showResult()._updateLoadingClass();
                proxy._applySelection();
                if (proxy.model.virtualScrollMode == "continuous") {
                    proxy.scrollerObj.refresh();
                    proxy.scrollerObj.option("scrollTop", proxy.lastScrollPosition);
                }
                proxy._trigger("actionSuccess", d);
            }).fail(function (e) {
                proxy._trigger("actionFailure", e);
            }).always(function (e) {
                proxy._trigger("actionComplete", e);
            });
        },
        _selectListItems: function () {
            var listItems = this.element.find("li:not('.e-ghead')");;
            for (var i = 0; i < listItems.length; i++) {
                if ($(listItems[i]).hasClass('selectItem') && !$(listItems[i]).hasClass('e-select'))
                    $(listItems[i]).addClass("e-select").removeClass('selectItem');
            }
        },
        _loadQueryData: function (start, end, proxy) {
            this._isScrollComplete = (end >= this.listitems.length) ? true : false;
            this._updateLoadingClass(true);
            var tempSrc = this.dataSource();
            this._loadlist(tempSrc.slice(start, end))._showResult()._updateLoadingClass();
            proxy._applySelection();
            if (proxy.model.virtualScrollMode == "continuous") {
                proxy.scrollerObj.option("scrollTop", proxy.lastScrollPosition);
                proxy.scrollerObj.refresh();
            }
        },
        _setText: function (text) {
            for (i = 0; i < this.listitems.length; i++)
                if ($(this.element.children("li")[i]).text() == text) this.unselectAll().selectItemByIndex(i);
        },
        _getLiCount: function () {
            return parseInt(this.listContainer.height() / this.listItemsElement.height());
        },
        _onDragStarts: function (data, target) {
            return this._trigger("itemDragStart", { items: data, target: target });
        },
        _onDrag: function (data, target) {
            return this._trigger("itemDrag", { items: data, target: target });
        },
        _onDragStop: function (data, target) {
            return this._trigger("itemDragStop", { items: data, target: target });
        },
        _onDropped: function (data, target) {
            data = { droppedItemText: data[0].text, droppedItemValue: data[0].value, droppedItemIsChecked: data[0].isChecked, droppedElementData: data[0], dropTarget:[data[1].target],event:data[1].event};
            return this._trigger("itemDrop",data);
        },
        _OnKeyPress: function (e) {
            if (this.model.enableIncrementalSearch && this.model.enabled) {
                this._incrementalSearch(this._isMozilla ? e.charCode : e.keyCode)
            }
        },
        _incrementalSearch: function (from) {
            _proxy = this;
            var typedCharacter = String.fromCharCode(from);
            if (this._incqueryString != typedCharacter) this._incqueryString += typedCharacter;
            else this._incqueryString = typedCharacter;
            if ((this._incqueryString.length > 0) && (this._typeInterval == null)) {
                this._typeInterval = setTimeout(function () {
                    _proxy._incqueryString = "";
                    _proxy._typeInterval = null
                }, _proxy._typingThreshold)
            }
            var list = this.listContainer.find("ol,ul").children("li:not('.e-category')"),
                i, strlen;
            var caseSence = this.model.caseSensitiveSearch,
                str, queryStr = this._incqueryString;
            var querylength = this._incqueryString.length,
                searchflag = false;
            if (!caseSence) queryStr = queryStr.toLowerCase();
            var initialSelection = this._activeItem;
            --initialSelection;
            var startIndex = this._activeItem != list.length - 1 ? (this._activeItem + 1) : 0;
            if (this._incqueryString.length > 1) startIndex = this._activeItem;
            for (var i = startIndex;
                (i < list.length && initialSelection != i) ; i++) {
                str = $.trim($(list[i]).text());
                str = caseSence ? str : str.toLowerCase();
                if (str.substr(0, querylength) === queryStr) {
                    this._removeListHover();
                    this.element.children("li").removeClass('e-active');
                    this._selectedItem = i;
                    this._addListHover();
                    searchflag = true;
                } else if ((i == list.length - 1) && (searchflag == false)) {
                    if (startIndex != 0) {
                        i = -1;
                        ++initialSelection;
                    } else searchflag = true;
                }
                if (searchflag) break;
            }
        },
        _wireEvents: function () {
            this._on(this.listContainer, "focus", this._OnFocusIn);
            this._on(this.listContainer, "blur", this._OnFocusOut);
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
        },
        _OnFocusIn: function () {
            if (!this._focused) {
                this._trigger("focusIn");
                this._on(this.listContainer, "keydown", this._OnKeyDown);
                this._on(this.listContainer, "keypress", this._OnKeyPress);
                this._focused = true;
            }
        },
        _OnFocusOut: function () {
            if (this._focused) {
                this._trigger("focusOut");
                this._off(this.listContainer, "keydown", this._OnKeyDown);
                this._off(this.listContainer, "keypress", this._OnKeyPress);
                this._focused = false;
            }
        }
    });
    ej.VirtualScrollMode = {
        /** Supports to Virtual Scrolling mode with normal only */
        Normal: "normal",
        /** Supports to Virtual Scrolling mode with continuous only */
        Continuous: "continuous"
    };
    ej.SortOrder = {

        Ascending: "ascending",

        Descending: "descending",

	    None:"none"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget(
    {
        "ejNumericTextbox": ["ej.NumericTextbox", "e-numerictextbox"],
        "ejPercentageTextbox": ["ej.PercentageTextbox", "e-percentagetextbox"],
        "ejCurrencyTextbox": ["ej.CurrencyTextbox", "e-currencytextbox"]
    },
    {
        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true,
            requireParser:true
        },

        defaults: {

            width: "",

            height: "",

            value: null,

            name: null,

            htmlAttributes: {},

            minValue: -(Number.MAX_VALUE),

            maxValue: Number.MAX_VALUE,

            incrementStep: 1,

            decimalPlaces: 0,

            validateOnType: false,

            cssClass: "",

            enablePersistence: false,

            showSpinButton: true,

            locale: "en-US",

            enableStrictMode: false,

            showRoundedCorner: false,

            readOnly: false,

            enabled: true,

            enableRTL: false,

            watermarkText: "Enter value",

            validationRules: null,

            validationMessage: null,

            groupSeparator: null,

            groupSize: null,

            positivePattern: null,

            currencySymbol:null,

            negativePattern: null,

            change: null,

            focusIn: null,

            focusOut: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            minValue: "number",
            maxValue: "number",
            incrementStep: "number",
            decimalPlaces: "number",
            showSpinButton: "boolean",
            enableStrictMode: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            locale: "string",
            watermarkText: "string",
            cssClass: "string",
            readOnly: "boolean",
            enabled: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
            validateOnType: "boolean",
            groupSeparator: "string"
        },
        observables: ["value"],

        _setModel: function (jsondata) {
            var validate = false;
            for (var key in jsondata) {
                switch (key) {
                    case "value":
                        if (ej.isNullOrUndefined(jsondata["minValue"]) && ej.isNullOrUndefined(jsondata["maxValue"])) {
                            this._setValue(jsondata[key], true);
                            jsondata[key] = this.model.value;
                        }
                        else {
                            this.model.value = this._checkNumValue(jsondata[key]);
                            this._localizedFormat();
                            this._raiseChangeEvent(true);
                            validate = true;
                        }
                        break;
                    case "enableRTL": this._enableRTL(jsondata[key]); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "minValue":
                        if (isNaN(jsondata[key])) return;
                        this.model.minValue = parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        validate = true;
                        break;
                    case "maxValue":
                        if (isNaN(jsondata[key])) return;
                        this.model.maxValue = parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        validate = true;
                        break;
                    case "incrementStep":
                        if (isNaN(jsondata[key])) return;
                        this.model.incrementStep = parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        break;
                    case "enableStrictMode": this.model.enableStrictMode = jsondata[key]; break;
                    case "showSpinButton": this._showSpin(jsondata[key]); break;
                    case "showRoundedCorner": this._roundedCorner(jsondata[key]); break;
                    case "locale":                        
                        this.model.decimalPlaces = ((ej.isNullOrUndefined(this._options.decimalPlaces)) && (this.model.decimalPlaces === this.culture.numberFormat.decimals))
                           ? -1 : (this._options.decimalPlaces === -1) ? -1 : this.model.decimalPlaces;
                        this._setLocalize(jsondata[key]);
                        this._options.decimalPlaces = this.model.decimalPlaces;
						jsondata[key] = this.model.locale;
						break;
                    case "decimalPlaces":
                        this._setDecimal(jsondata[key]);
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["decimalPlaces"] = jsondata[key];
                        break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "readOnly": this._setReadOnly(jsondata[key]); break;
                    case "enabled": if (jsondata[key]) this.enable(); else this.disable(); break;
                    case "watermarkText":
                        if(!ej.isNullOrUndefined(this._options)) this._options = [];
                        this._options["watermarkText"] = this.model.watermarkText = jsondata[key];
                        this._localizedLabels.watermarkText = this.model.watermarkText;						
						this._changeWatermark(jsondata[key]);
						break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "groupSeparator":
                        this._checkSeparator(jsondata[key]);
                        jsondata[key] = this.model.groupSeparator;
                        break;
                    case "positivePattern":
                    case "negativePattern":
                    case "groupSize":
                    case "currencySymbol":
                        this.model[key] = jsondata[key];
                        this._options[key] = jsondata[key];
                        this._initCustomValue();
                        jsondata[key] = this.model[key];
                        this._setValue(this.model.value, true);
                        break;                    
                }
            }
            if (validate) {
                this._validateMinMaxValue(true, true);
                jsondata["value"] = this.model.value;
                jsondata["maxValue"] = this.model.maxValue;
                jsondata["minValue"] = this.model.minValue;
                if (this.model.minValue != -(Number.MAX_VALUE)) this._startValue = this.model.minValue;
                this.element.attr({ 'aria-valuemin': this.model.minValue, 'aria-valuemax': this.model.maxValue, 'aria-valuenow': this.model.value });
            }
            this._checkSeparator(this.model.groupSeparator);
            this.element.val(this._removeSeparator(this.model.value));
            this._updateSeparator();
            this._checkErrorClass();
        },


        _destroy: function () {
            if (this.wrapper) {
                this.element.insertBefore(this.wrapper);
                this.wrapper.remove();
            }
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this.element.val("").removeClass('e-input e-disable').empty();
            this.element.removeAttr('disabled aria-disabled aria-valuemin aria-valuemax aria-valuenow aria-live');
            if (!(this._cloneElement).attr('role')) this.element.removeAttr('role');
            this.element.css("display", "block");
        },



        _init: function (options) {
            this._cloneElement = this.element.clone();
            this._options = ej.isNullOrUndefined(options) ? {} :options;
            if (this.element.is("input") && (this.element.is("input[type=text]") || this.element.is("input[type=number]") || !this.element.attr('type'))) {
                if(this.model.decimalPlaces > 0){
                    this.element[0].type = "text";
                }
                this._isWatermark = 'placeholder' in document.createElement('input');
                this.model.locale = ej.preferredCulture(this.model.locale).name == "en" ? "en-US" : ej.preferredCulture(this.model.locale).name;
                this._localizedLabels = this._getLocalizedLabels();
                this.culture = ej.preferredCulture(this.model.locale);
                this._browsername = ej.browserInfo().name;
                this._initCustomValue();
                this._prevSeparator = null;
                this._checkSeparator(this.model.groupSeparator);
                this._checkAttribute();
                this._renderControl();
                this._setValues();
                this._wireEvents();
                this._initObjects();
                this._addAttr(this.model.htmlAttributes);
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
                this._updateSeparator();
                if (options && options.value != undefined) {
                    this._trigger("_change", { value: this.model.value });
                }
            }
            else {
                this._destroy();
                return false;
            }
        },
		
        _checkAttribute: function () {
            var attr = ["min", "max", "step", "readonly", "disabled", "placeholder"], propName = ["minValue", "maxValue", "incrementStep", "readOnly", "enabled", "watermarkText"], value, propValue;
            for (var i = 0; i < attr.length; i++) {
                value = this.element.attr(attr[i]); propValue = propName[i];
                if ((!ej.isNullOrUndefined(value)) && !ej.isNullOrUndefined(this._options) && (ej.isNullOrUndefined(this._options[propValue]))) {
                    if (propValue == "watermarkText") this._options[propValue] = value;
                    else this.model[propValue] = ((propValue != "disabled") && (propValue != "readOnly")) ? ej.parseFloat(value, this.model.locale) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "accesskey") proxy._hiddenInput.attr(key, value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readonly" && value == "readOnly") proxy._setReadOnly(true);
                else if (keyName == "tabindex") {
                    proxy._hiddenInput.attr(key, value);
                    proxy.element.attr(key, value);
                }
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);
            });
        },

        _setValues: function () {
            this._id = this.element[0].id;
            this._textBox = this._hiddenInput[0];
            this._error = false;
            this._timeout = null;
            this.isValidState = true;
            this._allowkeyboard = true;
            this._validateOnType = false;
            this._focused = false;
            this._startValue = 0;
            if (this.sfType === "ej.CurrencyTextbox" && this.model.minValue == -(Number.MAX_VALUE))
                this.model.minValue = 0;
            if (ej.isNullOrUndefined(this.model.decimalPlaces) || (this.model.decimalPlaces < 0)) {
				if (this.sfType === "ej.CurrencyTextbox")
				this.model.decimalPlaces = ej.preferredCulture(this.model.locale).numberFormat.currency.decimals;
				else this.model.decimalPlaces = ej.preferredCulture(this.model.locale).numberFormat.decimals; 
				
			}            
            this.model.minValue = parseFloat(this.model.minValue.toFixed(this.model.decimalPlaces));
            this.model.maxValue = parseFloat(this.model.maxValue.toFixed(this.model.decimalPlaces));
            if (this.model.minValue != -(Number.MAX_VALUE)) this._startValue = this.model.minValue;
			if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
                
            }
            this._localizedLabelToModel();
            this._localizedFormat();
            this._validateMinMaxValue(true);
            this._updateSymbol(this.model.locale);
            var value;
            if (ej.isNullOrUndefined(this.model.value)) {
                value = this.model.value;
                this.wrapper.removeClass('e-valid');
            }
            else {
                value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                this.wrapper.addClass('e-valid');
            }
           this.element.val(value);
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            var rules = this.model.validationRules;
            this.element.rules("add", rules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in rules) {
                var message = null;
                if (!ej.isNullOrUndefined(rules[ruleName])) {
                    if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"][ruleName]))
                        message = rules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },


        _renderControl: function () {
            this.wrapper = ej.buildTag("span.e-widget e-pinch");
            this.innerWrap = ej.buildTag("span.e-in-wrap e-box ");
            this.wrapper.attr("style", this.element.attr("style"));
            if (this.sfType === "ej.NumericTextbox")
                this.wrapper.addClass('e-numeric');
            else if (this.sfType === "ej.PercentageTextbox")
                this.wrapper.addClass('e-percent');
            else if (this.sfType === "ej.CurrencyTextbox")
                this.wrapper.addClass('e-currency');
            this.wrapper.append(this.innerWrap).insertAfter(this.element);
            this.innerWrap.append(this.element);
            this._hiddenInput = ej.buildTag("input", "", {}, { type: "text" }).insertBefore(this.element);
            this._hiddenInput.attr('data-role', 'none');

            this._hiddenInput[0].tabIndex = this.element[0].tabIndex;
            this._hiddenInput.attr("accesskey", this.element[0].accessKey);
            this.element[0].accessKey = "";

            this._hiddenInput.css("display", "block");
            this.element.css("display", "none");
            if (!this._isWatermark) {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this._localizedLabels.watermarkText);
                this._hiddenSpan.css("display", "none");
                this._on(this._hiddenSpan,"mousedown", this._focusIn);
                this._on(this._hiddenSpan,'mousewheel', this._mouseWheel);
                this._on(this._hiddenSpan,'DOMMouseScroll',this._mouseWheel);
            }
            this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
            this.element.attr("name") == null ? this.element.attr("name", this.model.name) : "";
            this.element.addClass('e-input');
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "") {
                if (ej.preferredCulture(this.model.locale).numberFormat[','] == ".")
                    this.element[0].value = this.element[0].value.replace(".", ",");
                this.model.value = this._checkNumValue(this.element[0].value);
            }   
            else {
                if (typeof this.model.value== "string" && ej.preferredCulture(this.model.locale).numberFormat[','] == ".")
                    this.model.value = this.model.value.replace(".", ",");
                this.model.value = this._checkNumValue(this.model.value);
            }
            this._hiddenInput.attr({ 'value': this.model.value }).addClass('e-input');
            this.element.attr({ 'role': 'spinbutton', 'aria-valuemin': this.model.minValue, 'aria-valuemax': this.model.maxValue, 'aria-valuenow': this.model.value, 'aria-live': 'assertive', "value": this.model.value });
            var spinbutton = $('<span class="e-select"><span class="e-spin e-spin-up " role="button" "aria-label"="Increase Value" unselectable="on" /><span class="e-spin e-spin-down" role="button" "aria-label"="Decrease Value" unselectable="on" /></span>');
            spinbutton.find('.e-spin-up').append(ej.buildTag('span.e-icon e-arrow e-arrow-sans-up').attr({ 'role': 'presentation', 'unselectable': 'on' }));
            spinbutton.find('.e-spin-down').append(ej.buildTag('span.e-icon e-arrow e-arrow-sans-down').attr({ 'role': 'presentation', 'unselectable': 'on' }));
            this.innerWrap.append(spinbutton);
            this.spin = this.wrapper.find('.e-select');
            this.spinUp = this.wrapper.find('.e-spin-up');
            this.spinDown = this.wrapper.find('.e-spin-down');
            this._setWidth(this.model.width);
            this._setHeight(this.model.height);
            if (this.model.cssClass != "") this._setSkin(this.model.cssClass);
            this._showSpin(this.model.showSpinButton);
            if (this.model.showRoundedCorner) this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.enableRTL) this._enableRTL(this.model.enableRTL);
            if (this.model.readOnly) this._setReadOnly(this.model.readOnly);
            if (!this.model.enabled) this.disable();
            else if (this.model.enabled && this.element.hasClass("e-disable")) this.enable();
        },


        _initObjects: function () {
            this._preVal = this.model.value;
            if (this.model.value === null) {
                this.isValidState = true;
                this._hiddenInput.val(null);
            }
            else if ((this.model.value < this.model.minValue) || (this.model.value > this.model.maxValue))
                this.isValidState = false;
            this._checkErrorClass();
            this._setWaterMark();
        },


        _showSpin: function (value) {
            if (!value) {
                if (this.spin) {
                    this.spin.hide();
                    this.innerWrap.removeClass('e-padding');
                }
                this._spinEvents("_off");
            }
            else {
                if (this.spin) {
                    this.spin.show();
                    this.innerWrap.addClass('e-padding');
                }
                this._spinEvents("_on");
            }
        },


        _roundedCorner: function (value) {
            if (value && !this.innerWrap.hasClass('e-corner')) {
                this.innerWrap.addClass('e-corner');
            } else if (this.innerWrap.hasClass('e-corner')) {
                this.innerWrap.removeClass('e-corner');
            }
        },


        _enableRTL: function (enableRTL) {
            if (enableRTL) {
                if (this.spin) {
                    this.wrapper.addClass("e-rtl");
                }
                else this.element.addClass("e-rtl");
            }
            else {
                if (this.spin) {
                    this.wrapper.removeClass("e-rtl");
                }
                else this.element.removeClass("e-rtl");
            }
        },


        _setWidth: function (value) {
            value != "" ? this.wrapper.width(value) : this.model.width = this.wrapper.outerWidth();
        },


        _setHeight: function (value) {
            value != "" ? this.wrapper.height(value) : this.model.height = this.wrapper.outerHeight();
        },


        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass);
            this.wrapper.addClass(skin);
        },


        _setValue: function (value, isCode) {
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.model.value = this._checkNumValue(value);
            this._validateMinMaxValue(false);
            this._checkErrorClass();
            this._localizedFormat();
            this._raiseChangeEvent(isCode);
            this._setWaterMark();
        },

        _setLocalize: function (val) {
            var prevSeparator = ej.preferredCulture(this.model.locale).numberFormat[',']
            this.model.locale = ej.preferredCulture(val).name == "en" ? "en-US" : ej.preferredCulture(val).name;
            this.model.groupSeparator = ((ej.isNullOrUndefined(this._options.groupSeparator) && (prevSeparator === this.model.groupSeparator))) ?
                ej.preferredCulture(this.model.locale).numberFormat[','] : this.model.groupSeparator;
			this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this.culture = ej.preferredCulture(this.model.locale);
            this._initCustomValue();
            this._updateSymbol(this.model.locale);
            this._localizedFormat();
            this._changeWatermark(this.model.watermarkText);
            if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
            else value = (this.model.value.toString().indexOf('e') == -1) ? this._formatValue(this.model.value, "n",true) : this._convertToExponetial(this.model.value).unformattedValue;
            this.element.val(value);
			
        },
		 _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            
        },
        _updateSymbol: function (locale) {
            this._percentSymbol = ej.preferredCulture(locale).numberFormat.percent.symbol;
            this._currencySymbol = ej.preferredCulture(locale).numberFormat.currency.symbol;
        },

        _setDecimal: function (val) {
            this.model.decimalPlaces = val;
            this._localizedFormat();
        },


        _validateMinMaxValue: function (fromMinMax, isCode) {
            var valChange = false, value;
            if (this.model.minValue > this.model.maxValue) this.model.minValue = this.model.maxValue;
            if (!ej.isNullOrUndefined(this.model.value) && this.model.minValue > this.model.value) {
                if (this.model.enableStrictMode != true) {
                    this.isValidState = true;
                    this._startValue = this.model.value = this.model.minValue;
                }
                else this.isValidState = false;
                valChange = true;
            }
            else if (!ej.isNullOrUndefined(this.model.value) && this.model.maxValue < this.model.value) {
                if (this.model.enableStrictMode != true) {
                    this.isValidState = true;
                    this.model.value = this.model.maxValue;
                }
                else this.isValidState = false;
                valChange = true;
            }
            else this.isValidState = true;
            if (this.model.minValue == this.model.maxValue) this._startValue = this.model.minValue;
            if ((valChange && fromMinMax)) {
                value = this._formatValue(this.model.value, "n", true);
                this._hiddenInput.val(value);
                if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
                else value = (this.model.value.toString().indexOf('e') == -1) ? this._formatValue(this.model.value, "n", true) : this._convertToExponetial(this.model.value).unformattedValue;
                this.element.val(value);
                this._localizedFormat();
                this._raiseChangeEvent(isCode);
            }
        },

        _convertToExponetial: function (value) {
            var number = "", pattern, format;
            var negative = value < 0 ? true : false;
            value = value.toString();
            format = ej.preferredCulture(this.model.locale).numberFormat;
            value = value.replace(".", format["."]);
            unformattedValue = value;
            var length = null;
            if (this.sfType === "ej.NumericTextbox") {
                pattern = negative ? format.pattern[0] : ej.isNullOrUndefined(format.pattern[1]) ? "n" : format.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = "";
            }
            else if (this.sfType === "ej.PercentageTextbox") {
                pattern = negative ? format.percent.pattern[0] : format.percent.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = format.percent.symbol;
            }
            else if (this.sfType === "ej.CurrencyTextbox") {
                pattern = negative ? format.currency.pattern[0] : format.currency.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = format.currency.symbol;
            }
            for (idx = 0, length = pattern.length; idx < length; idx++) {
                ch = pattern.charAt(idx);
                (ch === "n") ? number += value : (ch === "$" || ch === "%") ? number += symbol : number += ch;
            }
            return { formattedValue: number, unformattedValue: unformattedValue }
        },

        _localizedFormat: function () {
			this.culture = ej.preferredCulture(this.model.locale);
            if (ej.isNullOrUndefined(this.model.value)) {
                this._textBox.value = "";
                return;
            }
            if (this.model.value.toString().indexOf('e') == -1) {
                this._textBox.value = this._removeSeparator(this.model.value)
                if (!this._focused && this._textBox.value != "") {
                    this._textBox.value = this._formatValue(this.model.value, "n", true);
                    if (this.sfType === "ej.PercentageTextbox") this._appendPercentSymbol(this._textBox.value);
                    else if (this.sfType === "ej.CurrencyTextbox") this._appendCurrencySymbol(this._textBox.value);
                }
            }
            else {
                var value = this._convertToExponetial(this.model.value);
                this._textBox.value = value.unformattedValue;
                if (!this._focused && this._textBox.value != "")
                    this._textBox.value = value.formattedValue;
            }
        },


        _checkNumValue: function (value) {
            if (typeof value == "string")
                value = !this._changeSeparator ? value : this._replaceSeparator(value, this.model.groupSeparator, ej.preferredCulture(this.model.locale).numberFormat[',']);
            if (typeof value == "string" && !isNaN(this._parseValue(value))) {
                value = this._parseValue(value);
                return parseFloat(value);
            }
            else if ((typeof value == "number") && !isNaN(value))
                return value;
            else return null;
        },


        _setReadOnly: function (bool) {
            this.model.readOnly = bool;
            if (bool) {
                this.element.attr("readonly", true);
                this._hiddenInput.attr("readonly", true);
            }
            else {
                this.element.prop("readonly",false);
                this._hiddenInput.prop("readonly",false);
            }
        },


        _setWaterMark: function () {
            if ((this._localizedLabels.watermarkText != null) && (this._textBox.value === "") && $.trim(this._hiddenInput.val()) === "") {
                if (this._isWatermark) {
                    this._hiddenInput.attr("placeholder", this._localizedLabels.watermarkText);
                    this.element.attr("placeholder", this._localizedLabels.watermarkText);
                }
                else
                    this._hiddenSpan.css("display", "block").text(this._localizedLabels.watermarkText);
            }
        },


        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            if (this._isWatermark) {
                this._hiddenInput.attr("placeholder", text);
                this.element.attr("placeholder", text);
            }
            else this._hiddenSpan.text(text);
        },


        _setSelectionRange: function (selectionStart, selectionEnd) {
            var input = this._textBox;
            try {
                if (input.setSelectionRange) {
                    if (this._browsername == "edge")  setTimeout(function () { input.setSelectionRange(selectionStart, selectionEnd) })
                    else input.setSelectionRange(selectionStart, selectionEnd);
                }
                else if (input.createTextRange) {
                    var range = input.createTextRange();
                    _setselction(range);
                }
            }
            catch (e) {
                var control = this;
                window.setTimeout(function () {
                    document.body.focus();
                    control._textBox.select();
                    if (document.selection) {
                        var range = document.selection.createRange();
                        _setselction(range);
                    }
                }, 1);
            }
            function _setselction(range) {
                range.collapse(true);
                range.moveEnd('character', selectionEnd);
                range.moveStart('character', selectionStart);
                range.select();
            }
        },


        _getSelection: function (value) {
            if (this._textBox.type != "number") {
                var oSel = null;
                if (document.selection) {
                    oSel = document.selection.createRange();
                    return (oSel.text === "" ? oSel.text : this._removeFormats(oSel.text));
                }
                else {
                    if (value == null)
                        return this.model.value;
                    else {
                        oSel = this._removeFormats(value.substring(this._textBox.selectionStart, this._textBox.selectionEnd));
                        return oSel;
                    }
                }
            }
        },


        _caretPosition: function () {
            var oField = this._textBox;
            var iCaretPos = 0;
            // IE Support
            if (oField.type != "number") {
                if (document.selection) {
                    oField.focus();
                    // To get cursor position, get empty selection range
                    var oSel = document.selection.createRange();
                    // Move selection start to 0 position
                    oSel.moveStart('character', -oField.value.length);
                    // The caret position is selection length
                    iCaretPos = oSel.text.length;
                }
                    // Firefox support
                else if (oField.selectionStart || oField.selectionStart == '0')
                    iCaretPos = oField.selectionEnd;
                return (iCaretPos);
            }  
        },


        _appendPercentSymbol: function (value) {
            if (this._percentSymbol) value = value.replace(this._percentSymbol, "");
            if (value.indexOf(ej.preferredCulture(this.model.locale).numberFormat.percent.symbol) < 0)
                this._textBox.value = this._formatValue(this._parseValue(value) / 100, "p", true);
            this._percentSymbol = ej.preferredCulture(this.model.locale).numberFormat.percent.symbol;
        },

        _appendCurrencySymbol: function (value) {
            if (this._currencySymbol) value = value.replace(this._currencySymbol, "");
            if (value.indexOf(ej.preferredCulture(this.model.locale).numberFormat.currency.symbol) < 0)
                this._textBox.value = this._formatValue(this._parseValue(value), "c", true);
            this._currencySymbol = ej.preferredCulture(this.model.locale).numberFormat.currency.symbol;

        },

        _removeFormats: function (val) {
            var grpSep = ej.preferredCulture(this.model.locale).numberFormat[","];
            if (val != null) {
                if (grpSep == ".")
                    return (val.toString().replace(/["."]/g, ""));
                else if (val.toString().match(new RegExp(grpSep, "g")))
                    return (val.toString().replace(new RegExp(grpSep, "g"), ""));
                else
                    return val;
            }
            else
                return null;
        },


        _checkErrorClass: function (obj) {
            if (this.isValidState) this.wrapper.removeClass("e-error");
            else this.wrapper.addClass("e-error");
        },
		


        enable: function () {
            this.model.enabled = true;
            this.element[0].disabled = false;
            this.element.prop("disabled",false);
            this._hiddenInput.prop("disabled", false);
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this._hiddenInput.removeClass('e-disable').attr({ "aria-disabled": false });
            this.wrapper.find(".e-select").removeClass('e-disable').attr({ "aria-disabled": false });
            this.wrapper.find(".e-select span.e-icon.e-arrow").removeClass('e-disable');
            this.wrapper.removeClass('e-disable-wrap');
        },


        disable: function () {
            this.model.enabled = false;
            this.element[0].disabled = true;
            this.element.attr("disabled", "disabled");
            this._hiddenInput.attr("disabled", "disabled");
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this._hiddenInput.addClass('e-disable').attr({ "aria-disabled": true });
            this.wrapper.find(".e-select").addClass('e-disable').attr({ "aria-disabled": true });
            this.wrapper.find(".e-select span.e-icon.e-arrow").addClass('e-disable');
            this.wrapper.addClass('e-disable-wrap');
        },


        getValue: function () {
            return this.model.value;
        },

        _wireEvents: function () {
            this._on(this._hiddenInput, 'focus', this._focusIn);
            this._on(this.element, 'paste', this._paste);
            this._on(this.element, 'blur', this._focusOut);
            this._on(this.element, 'keydown', this._keyDown);
            this._on(this.element, 'keypress', this._keyPress);
            this._on(this.element, 'mousewheel', this._mouseWheel);
            this._on(this.element, 'DOMMouseScroll', this._mouseWheel);
        },

        _spinEvents: function (action) {
            this[action](this.spinUp, "mousedown mouseup touchstart touchend", this._spinUpClick);
            this[action](this.spinDown, "mousedown mouseup touchstart touchend", this._spinDownClick);
        },

        _isIE8: function () {
            var _ie8 = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == "8.0") {
                _ie8 = true;
            }
            return _ie8;
        },

        _spinUpClick: function (event) {
            var isNotLeftClick = false;
            if (event.button)
                isNotLeftClick = this._isIE8() ? event.button != 1 : event.button != 0;
            else if (event.which)
                isNotLeftClick = (event.which == 3); //for Opera
            if (isNotLeftClick) return;
            var self = this;
            event.preventDefault();
            clearTimeout(this._timeout);
            if (!this.model.enabled || this.model.readOnly) return;
            this.wrapper.find(".e-animate").removeClass("e-animate");
            this.spinUp.addClass("e-animate");
            this._on(this.spinUp, 'mouseleave', this._mouseUpClick);
            this.spinUp.addClass("e-active");
            var self = this;
            if (event.type == "mouseup"|| event.type == "touchend") {
                this._updateInputField("increment");
                this.spinUp.removeClass("e-active");
                this._off($(document), 'mouseup', this._mouseUpClick);
            }
            else if (event.type == "mousedown"|| event.type == "touchstart") {
                if (!this._focused) this._hiddenInput[0].focus();
                this._timeout = setInterval(function () {
                    self._updateInputField("increment");
                }, 150);
                this._on($(document), 'mouseup', this._mouseUpClick);
            }
        },

        _spinDownClick: function (event) {
            var isNotLeftClick = false;
            if (event.button)
                isNotLeftClick = this._isIE8() ? event.button != 1 : event.button != 0;
            else if (event.which)
                isNotLeftClick = (event.which == 3); //for Opera
            if (isNotLeftClick) return;
            var self = this;
            event.preventDefault();
            clearTimeout(this._timeout);
            if (!this.model.enabled || this.model.readOnly) return;
            this.wrapper.find(".e-animate").removeClass("e-animate");
            this.spinDown.addClass("e-animate");
            this._on(this.spinDown, 'mouseleave', this._mouseUpClick);
            this.spinDown.addClass("e-active");
            if (event.type == "mouseup"|| event.type == "touchend") {
                this._updateInputField("decrement");
                this.spinDown.removeClass("e-active");
                this._off($(document), 'mouseup', this._mouseUpClick);
            }
            else if (event.type == "mousedown"|| event.type == "touchstart") {
                if (!this._focused) this._hiddenInput[0].focus()
                this._timeout = setInterval(function () {
                    self._updateInputField("decrement");
                }, 150);
                this._on($(document), 'mouseup', this._mouseUpClick);
            }
        },

        _mouseUpClick: function (event) {
            event.stopPropagation();
            clearTimeout(this._timeout);
            this._off(this.spinUp, 'mouseleave', this._mouseUpClick);
            this._off(this.spinDown, 'mouseleave', this._mouseUpClick);
            this.spinDown.removeClass("e-active");
            this.spinUp.removeClass("e-active");
        },

        _mouseWheel: function (event) {
            event.preventDefault();
            if (!this._focused) this.element[0].focus();
            if (!this.model.enabled || this.model.readOnly) return;
            var delta;
            var rawEvent = event.originalEvent;
            if (rawEvent.wheelDelta) {
                // IE and Opera use wheelDelta, which is a multiple of 120 (possible values -120, 0, 120).
                delta = rawEvent.wheelDelta / 120;
                // In Opera, value is negated.
                //if (Sys.Browser.agent === Sys.Browser.Opera) delta = -delta;
            }
            else if (rawEvent.detail) {
                // Firefox uses detail property, which is a multiple of 3.
                delta = -rawEvent.detail / 3;
            }
            if (delta > 0)
                this._updateInputField("increment");
            else if (delta < 0)
                this._updateInputField("decrement");
            this._cancelEvent(event);
        },


        _numberValue: function () {
            var value = this._textBox.value;
            if (this.sfType === "ej.NumericTextbox")
                value = this._formatValue(this.model.value, "n", true);
            if (this.sfType === "ej.PercentageTextbox")
                value = this._formatValue(this.model.value, "n", true);
            else if (this.sfType === "ej.CurrencyTextbox")
                value = this._formatValue(this.model.value, "n", true);
            value = (typeof value == "string" && !isNaN(this._parseValue(value))) ? value : "";
            return value;
        },
        _formatValue: function (value, format,flag) {
            if(flag) this._updateCultureInfo();
            var value = ej.format(value, format + this.model.decimalPlaces, this.model.locale);
            if (flag) this._restCultureInfo();
            return value;
        },
        _parseValue: function (value) {
            this._updateCultureInfo();
            var value = ej.parseFloat(value, this.model.locale);
            this._restCultureInfo();
            return value;            
        },

        _initCustomValue: function () {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            switch (ctr) {
                case "percent":
                case "currency":
                    format = this.culture.numberFormat[ctr];
                    if (ej.isNullOrUndefined(this._options.negativePattern)) this.model.negativePattern = format.pattern[0];
                    if (ej.isNullOrUndefined(this._options.positivePattern)) this.model.positivePattern = format.pattern[1];
                    if (ej.isNullOrUndefined(this._options.currencySymbol) && ctr == "currency") this.model.currencySymbol = format.symbol;
                    if (ej.isNullOrUndefined(this._options.groupSize)) this.model.groupSize = format.groupSizes[0];                    
                    break;
                case "numeric":
                    format = this.culture.numberFormat;
                    if (ej.isNullOrUndefined(this._options.negativePattern)) this.model.negativePattern = format.pattern[0];
                    if (ej.isNullOrUndefined(this._options.positivePattern)) this.model.positivePattern = ej.isNullOrUndefined(format.pattern[1]) ? "n" : format.pattern[1];
                    if (ej.isNullOrUndefined(this._options.groupSize)) this.model.groupSize = format.groupSizes[0];
                    break;
            }
        },

        _updateCultureInfo: function (flag) {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            format = ctr == "numeric" ? this.culture.numberFormat : this.culture.numberFormat[ctr];
            this._oldNegativePattern = format.pattern[0];
            this._oldGroupSize = format.groupSizes[0];
            format.pattern[0] = this.model.negativePattern;
            format.groupSizes[0] = this.model.groupSize;
            this._oldPositivePattern = format.pattern[1];
            format.pattern[1] = this.model.positivePattern;
            if (ctr == "currency") {
                this._oldcurrencySymbol = format.symbol;
                format.symbol = this.model.currencySymbol;
            }
        },
        _restCultureInfo: function () {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            format = ctr == "numeric" ? this.culture.numberFormat : this.culture.numberFormat[ctr];
            format.pattern[0] = this._oldNegativePattern;
            format.groupSizes[0] = this._oldGroupSize;
            format.pattern[1] = this._oldPositivePattern;
            if (ctr == "currency")
                format.symbol = this._oldcurrencySymbol;;
        },
        _toggleTextbox: function (toggle) {
            var proxy = this;
            proxy._hiddenInput.toggle(toggle);
            proxy.element.toggle(!toggle);
        },

        _paste: function (event) {
            var text;
            if (window.clipboardData && window.clipboardData.getData) { // IE
                text = window.clipboardData.getData('Text');
            }
            else if (event.originalEvent.clipboardData && event.originalEvent.clipboardData.getData) { // other browsers
                text = event.originalEvent.clipboardData.getData('text/plain');
            }
            var data = ej.parseFloat(text, this.model.locale);
            if (isNaN(data))
                this._cancelEvent(event)
            else {
                this.element.val(data);
                this._cancelEvent(event);
            }
        },
        _focusIn: function (event) {
            if (this.model.readOnly)
                return;
            this._focused = true;
            if(!ej.isNullOrUndefined(this.model.value)) this.element.val(this._removeSeparator(this.model.value));
            this._toggleTextbox(false);
            this._textBox = this.element[0];
            this.element[0].focus();
            this._preVal = this.model.value;
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.wrapper.addClass("e-focus");
            this.wrapper.removeClass('e-error');
            if (!this._error) {
                if (this._textBox.value != "") {
                    var value = this._formatValue(this._textBox.value, "n", true);
                    this._textBox.value = value;
                    this._hiddenInput.val(value);
                }
                this._setSelectionRange(0, this._textBox.value.length);
            }
            this._trigger("focusIn", { value: this.model.value });
        },

        _focusOut: function (event) {
            this._focused = false;
            this.wrapper.removeClass("e-focus");
            if (!this._error) {
                if (this._textBox.value != "") {
                    var value = ej.parseFloat(this._textBox.value, this.model.locale);
                    if (value < this.model.minValue) {
                        if (!this.model.enableStrictMode)
                            this._textBox.value = this._formatValue(this.model.minValue, "n", false)
                        else
                            this.isValidState = false
                    }
                    else if (value > this.model.maxValue) {
                        if (!this.model.enableStrictMode)
                            this._textBox.value = this._formatValue(this.model.maxValue, "n", false);
                        else
                            this.isValidState = false;
                    }
                    this.model.value = ej.parseFloat(this._textBox.value, this.model.locale);
                    if (isNaN(this.model.value) && !this.model.value) {
                        this.model.value = null;
                        this.isValidState = false;
                    }
                    this._toggleTextbox(true);
                    this._textBox = this._hiddenInput[0];
                    this._localizedFormat();
                    this._checkErrorClass();
                }
                else {
                    var value = this._textBox.value == "" ? null : this._textBox.value;
                    this.model.value = value;
                    this._hiddenInput.val(value);
                    this._toggleTextbox(true);
                    this._textBox = this._hiddenInput[0];
                }
                if (this.model.value === null || this.model.value >= this.model.minValue && this.model.value <= this.model.maxValue) this.isValidState = true;
                else if (this.model.enableStrictMode) this.isValidState = false;
                this._raiseChangeEvent();
                this._setWaterMark();
                if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
                else value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                this.element.val(value);
                this._updateSeparator();
                this._trigger("focusOut", { value: this.model.value });
            }
            this._checkErrorClass();
        },

        _cancelEvent: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            e.stopPropagation();
            e.preventDefault();
            return false;
        },

        _updateInputField: function (operation) {
            this.isValidState = true;
            if (!this._focused) $(this._hiddenInput[0]).focus();
            var step = this.model.incrementStep;
            var itemValue = this.model.value;
            if (this._textBox.value === "") {
                this._textBox.value = this._formatValue(this._startValue, "n", true);
                step = 0;
            }
            else if (this._textBox.value.indexOf(" ") >= 0)
                this._textBox.value = this._textBox.value.replace(" ", "");
            if (this.sfType === "ej.PercentageTextbox" || this.sfType === "ej.CurrencyTextbox") {
                var editorvalue = this._textBox.value, value = editorvalue;
                if (editorvalue.indexOf(ej.preferredCulture(this.model.locale).numberFormat.percent.symbol) > -1)
                    value = editorvalue.substring(0, editorvalue.length - 1);
                this.model.value = this._parseValue(value);
            }
            else if (this.sfType == "ej.NumericTextbox")
                this.model.value = ej.parseFloat(this._textBox.value, this.model.locale);

            if (isNaN(this.model.value) && !this.model.value)
                this.model.value = this._startValue;

            if (this.model.value >= this.model.minValue && this.model.value > this.model.maxValue) {
                this.model.value = this.model.maxValue;
                this._setValue(this.model.value);
            }
            else if (this.model.value < this.model.minValue && this.model.value <= this.model.maxValue) {
                this.model.value = this.model.minValue;
                this._setValue(this.model.value);
            }
            else if (this.model.value >= this.model.minValue && this.model.value <= this.model.maxValue) {
                value = operation == "increment" ? this.model.value + step : this.model.value - step;
                if (value >= this.model.minValue && value <= this.model.maxValue)
                    this._setValue(value);
            }
            this._checkErrorClass();
        },

        _validateDecimal: function (e) {
            var char = String.fromCharCode(e.keyCode);
            char = e.keyCode == 188 ? "," : (e.keyCode == 190) ? "." : (e.keyCode == 110) ? ej.preferredCulture(this.model.locale).numberFormat["."] : char;
            if (ej.preferredCulture(this.model.locale).numberFormat["."].charCodeAt(0) == char.charCodeAt(0))
                return true;
            return false;
        },

        _allowKeyCodes: function (e) {
            var keys = new Array(38, 40, 35, 36, 109, 189, 46, 8, 127, 37, 39, 190, 9, 13, 16, 17, 18, 20, 110, 173, 86, 88, 67);
            for (var i = 0; i < keys.length; i++) {
                if (e.keyCode == keys[i] || (this._validateDecimal(e) && this.model.decimalPlaces != 0))
                    return true;
            }
            return false;
        },

        _raiseChangeEvent: function (isCode) {
            var currVal = this.model.value, value;
            if ((this._checkNumValue(this._preVal) !== this._checkNumValue(currVal))) {
                this._preVal = currVal;
                this.model.value = this._checkNumValue(this._formatValue(this._preVal, "n", false));
                this._updateHiddenField();
                if (ej.isNullOrUndefined(this.model.value)) {
                    value = this.model.value;
                    this.wrapper.removeClass('e-valid');
                }
                else {
                    value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                    this.wrapper.addClass('e-valid');
                }
                this.element.val(value);
                this.element.attr('aria-valuenow', value);
                this._updateSeparator();
                // Trigger the Jquery change event for the input element.
                this.element.trigger("change");
                this._trigger("_change", { value: this.model.value, isInteraction: !isCode });
                this._trigger("change", { value: this.model.value, isInteraction: !isCode });
            }
        },
        _updateHiddenField: function () {
            var prevActive = this._textBox;
            this._textBox = this._hiddenInput[0];
            this._localizedFormat();
            this._textBox = prevActive;
        },
        _removeSeparator: function (number) {
            if (ej.isNullOrUndefined(number)) return;
            var value, format, tag;
            number = this._checkNumValue(this._formatValue(number, "n", false));
            value = number.toString();
            format = ej.preferredCulture(this.model.locale).numberFormat;
            value = value.replace(".", format["."]);
            return value;
        },
        _updateSeparator: function () {
            if (this._changeSeparator && this.model.value) {
                var formatValue;
                if (this.sfType === "ej.NumericTextbox")
                    formatValue = this._formatValue(this.model.value, "n", true);
                else if (this.sfType === "ej.PercentageTextbox")
                    formatValue = this._formatValue((this.model.value) / 100, "p", true);
                else if (this.sfType === "ej.CurrencyTextbox")
                    formatValue = this._formatValue(this.model.value, "c", true);
                this._hiddenInput.val(this._replaceSeparator(formatValue, ej.preferredCulture(this.model.locale).numberFormat[","], this.model.groupSeparator));
            }
        },

        _replaceSeparator: function (value, find, replaceWith) {
            var reg = find === "" ? new RegExp("\\s", "g") : new RegExp("\\" + find, "g");
            if (this.model.groupSeparator == ej.preferredCulture(this.model.locale).numberFormat['.']) {
                var decimalpoints = this.model.decimalPlaces;
                var valuelength = value.length - decimalpoints - 1;
                return value.substring(0, valuelength).replace(reg, replaceWith) + value.substring(valuelength, value.length);
            }
            return value.replace(reg, replaceWith);
        },

        _checkSeparator: function (value) {
            this.model.groupSeparator = value != null ? this._validateSeparator(value) : ej.preferredCulture(this.model.locale).numberFormat[','];
            this._changeSeparator = ej.preferredCulture(this.model.locale).numberFormat[","] != this.model.groupSeparator ? true : false;
            this._prevSeparator = this.model.groupSeparator;
        },
        _validateSeparator: function (value) {
            var separator = value.toString();
            var reg = new RegExp("[a-zA-Z0-9]");
            separator = (separator.length > 1) ? separator[0] : separator;
            separator = (!reg.test(separator)) ? separator : this._prevSeparator != null ? this._prevSeparator : ej.preferredCulture(this.model.locale).numberFormat[','];
            return separator;
        },
        _keyPress: function (e) {
            if (e.which === 0 || e.metaKey || e.ctrlKey || e.keyCode === 8 || e.keyCode === 13)
                return;
            var proxy = this, regExp = null, point = ".", cursor, beforeCursor, afterCursor, numberFormat, value;
            cursor = this._caretPosition();
            beforeCursor = this._textBox.value.toString().substring(0, cursor);
            afterCursor = this._textBox.value.toString().substring(cursor);
            numberFormat = ej.preferredCulture(this.model.locale).numberFormat;

            var character = String.fromCharCode(e.which);
            value = beforeCursor + character + afterCursor;
            var separator = numberFormat[point];
            separator = (separator === point) ? "\\" + separator : separator;
            if (proxy.model.decimalPlaces === 0) regExp = new RegExp("^(\\d*)?(-)$ || ^(-)?(\\d*)$");
            else regExp = new RegExp('"^(-)?(((\\d+("' + separator + '"\\d*)?)|("' + separator + '"\\d*)))?$" || "^(((\\d+("' + separator + '"\\d*)?)|("' + separator + '"\\d*)))?(-)$"');
            // Validate the textbox value 
            if (!regExp.test(value))
                return false;
        },
        _validateDecimalOnType: function (e) {
            var cursor, cancelEvent, beforeCursor, afterCursor, sel, temp;
            cursor = this._caretPosition();
            beforeCursor = this._textBox.value.toString().substring(0, cursor);
            afterCursor = this._textBox.value.toString().substring(cursor);
            sel = this._getSelection(this._textBox.value);
            var decSep = ej.preferredCulture(this.model.locale).numberFormat["."];
            temp = (ej.isNullOrUndefined(this.model.value)) ? "" : this.model.value.toString();
            if (this.model.decimalPlaces != 0) {
                var afterdeci = (this._textBox.value).split(decSep)[1];
                if (temp.indexOf(decSep) > 0) {
                    if ((temp.substring(temp.indexOf(decSep) + 1, temp.length)).length > this.model.decimalPlaces)
                        cancelEvent = true;
                    else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                    else cancelEvent = false;
                }
                else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                else
                    cancelEvent = false;
            }
            else
                cancelEvent = false;
            if (cancelEvent) {
                this._keypressFlag = false;
                this._cancelEvent(e);
                return false;
            }
        },

        _keyDown: function (e) {
            if (this.model.readOnly) return;
            this._CurrentCultureInfo = JSON.parse(JSON.stringify(ej.preferredCulture()));
            var cursor, cancelEvent, beforeCursor, afterCursor, sel;
            if (e.keyCode >= 48 && e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105 || this._allowKeyCodes(e)) {
                if (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 46 || e.keyCode == 127) || (e.ctrlKey && (e.keyCode == 86 || e.keyCode == 118 || e.keyCode == 67 || e.keyCode == 88)))
                    return true;
                if ((((e.ctrlKey == true) && (e.keyCode != 9 && e.keyCode != 17 && e.keyCode != 86 && e.keyCode != 67))) || (e.keyCode == 67 || e.keyCode == 86 || e.keyCode == 88)) {//Prevent Shift + Tab event
                    this._keypressFlag = false;
                    this._cancelEvent(e);
                    return false;
                }

                if (e.keyCode >= 48 && e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105 || e.keyCode == 110) {//Numbers from 0 to 9 in keyboard and numpad (110 for decimal)
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.toString().substring(0, cursor);
                    afterCursor = this._textBox.value.toString().substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                    // For Numpad issue
                    if (e.keyCode >= 96 && e.keyCode <= 105)
                        e.keyCode -= 48;
                    if (this.model.validateOnType) this._validateDecimalOnType(e);
                    if (this._validateOnType) {
                        var decSep = ej.preferredCulture(this.model.locale).numberFormat["."];
                        var temp = this.model.value.toString();
                        var tempIndex = temp.indexOf(decSep);
                        var value = this.model.value;
                        var replaceminVal = this.model.minValue.toFixed(this.model.decimalPlaces);
                        var replacemaxVal = this.model.maxValue.toFixed(this.model.decimalPlaces);
                        var exp = false;
                        if (replaceminVal.toString().indexOf("e") > 0 || replacemaxVal.toString().indexOf("e") > 0)
                            exp = true;
                        if (!exp) {
                            if (decSep != ".") {
                                temp = this._textBox.value.toString();
                                if (this.model.minValue.toString().match(new RegExp(".", "g")))
                                    replaceminVal = this.model.minValue.toString().replace(/["."]/g, decSep);
                                if (this.model.maxValue.toString().match(new RegExp(".", "g")))
                                    replacemaxVal = this.model.maxValue.toString().replace(/["."]/g, decSep);
                            }
                            if (replaceminVal.toString().indexOf(decSep) > 0)
                                minVal = Number(replaceminVal.toString().substring(0, replaceminVal.toString().indexOf(decSep)));
                            else
                                minVal = this.model.minValue;
                            if (replacemaxVal.toString().indexOf(decSep) > 0)
                                maxVal = Number(replacemaxVal.toString().toString().substring(0, replacemaxVal.toString().indexOf(decSep)));
                            else
                                maxVal = this.model.maxValue;
                            if (tempIndex > 0) {
                                value = Number(temp.substring(temp.indexOf(decSep) + 1, temp.toString().length));
                                if (replaceminVal.toString().indexOf(decSep) > 0)
                                    minVal = Number(replaceminVal.toString().substring(replaceminVal.toString().indexOf(decSep) + 1, replaceminVal.toString().length));
                                else
                                    minVal = 0;
                                if (replacemaxVal.toString().indexOf(decSep) > 0)
                                    maxVal = Number(replacemaxVal.toString().substring(replacemaxVal.toString().indexOf(decSep) + 1, replacemaxVal.toString().length));
                                else
                                    maxVal = 0;
                                var valb4Dec = Number(temp.substring(0, temp.indexOf(decSep)));
                                var minValb4Dec = Number(replaceminVal.toString().substring(0, replaceminVal.toString().indexOf(decSep)));
                                var maxValb4Dec = Number(replacemaxVal.toString().substring(0, replacemaxVal.toString().indexOf(decSep)));
                                if (!this._validateValue(value, minVal, maxVal, true, valb4Dec, minValb4Dec, maxValb4Dec))
                                    cancelEvent = true;
                                else
                                    cancelEvent = false;
                            }
                            else {
                                if (!this._validateValue(value, minVal, maxVal, false))
                                    cancelEvent = true;
                                else
                                    cancelEvent = false;
                            }
                        }
                        else if (this.model.decimalPlaces != 0) {
                            var afterdeci = (this._textBox.value).split(".")[1];
                            if (temp.indexOf(decSep) > 0 || (Number(temp) < Number(replaceminVal) || Number(temp) > Number(replacemaxVal))) {
                                if ((temp.substring(temp.indexOf(decSep) + 1, temp.length)).length > this.model.decimalPlaces)
                                    cancelEvent = true;
                                else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                                else cancelEvent = false;
                            }
                            else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                            else
                                cancelEvent = false;
                        }
                        else
                            cancelEvent = false;
                        if (cancelEvent) {
                            this._keypressFlag = false;
                            this._cancelEvent(e);
                            return false;
                        }
                    }

                }
                if (e.keyCode == 38 && this._allowkeyboard) {
                    this._updateInputField("increment");
                    this._cancelEvent(e);
                }

                if (e.keyCode == 40 && this._allowkeyboard) {
                    this._updateInputField("decrement");
                    this._cancelEvent(e);

                }
                if (e.keyCode == 8) {
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.substring(0, cursor);
                    afterCursor = this._textBox.value.substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                }

                if (e.keyCode == 46 || e.keyCode == 127) {
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.substring(0, cursor);
                    afterCursor = this._textBox.value.substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                }
                if (this._validateDecimal(e) && this.model.decimalPlaces != 0 && e.keyCode != 46) {
                    var decChar = ej.preferredCulture(this.model.locale).numberFormat["."];
                    var minVal, maxVal;
                    var dotSplit = this._textBox.value.split(decChar);
                    if (dotSplit[1] == undefined) {
                        var curPosition = this._caretPosition();
                        var strBeforeCursor = dotSplit[0].substring(0, curPosition);
                        var strAfterCursor = dotSplit[0].substring(curPosition);
                        if (this.model.minValue.toString().indexOf("e") > 0 || this.model.maxValue.toString().indexOf("e") > 0)
                            exp = true;
                        if (strAfterCursor.length > this.model.decimalPlaces && this.model.validateOnType == true) {
                            this._keypressFlag = false;
                            this._cancelEvent(e);
                            return false;
                        }
                        if (this._validateOnType && !exp) {
                            if (this.model.minValue.toString().match(new RegExp(".", "g")))
                                minVal = this.model.minValue.toString().replace(/["."]/g, decChar);
                            if (this.model.maxValue.toString().match(new RegExp(".", "g")))
                                maxVal = this.model.maxValue.toString().replace(/["."]/g, decChar);
                            if (minVal.indexOf(decChar) > 0)
                                minVal = Number(minVal.substring(0, minVal.indexOf(decChar)));
                            else
                                minVal = Number(minVal);
                            if (maxVal.indexOf(decChar) > 0)
                                maxVal = Number(maxVal.substring(0, maxVal.indexOf(decChar)));
                            else
                                maxVal = Number(maxVal);
                            if (this._validateValue(this.model.value, minVal, maxVal, "DecimalKeyPressed"))
                                this._textBox.value = strBeforeCursor + decChar + strAfterCursor;
                            else {
                                this._keypressFlag = false;
                                this._cancelEvent(e);
                                return false;
                            }
                        }
                        else
                            this._textBox.value = strBeforeCursor + decChar + strAfterCursor;
                        this._setSelectionRange(curPosition + 1, curPosition + 1);
                    }
                    this._cancelEvent(e);
                } else if (e.keyCode == 190 || e.keyCode == 110) {
                    this._cancelEvent(e);
                }
                if (e.keyCode == 109 || e.keyCode == 189 || e.keyCode == 173) { //'-' char key press.
                    if ((this._caretPosition() != 0 && this._getSelection(this._removeFormats(this._textBox.value)) != this.model.value) || (this.model.minValue >= 0 && !this.model.enableStrictMode) || (this._textBox.value.toString().match(new RegExp("-", "g")) && this._getSelection(this._textBox.value) === ""))
                        this._cancelEvent(e);

                    else if (this._getSelection() == this.model.value)
                        this.model.value = null;
                }

                if (e.keyCode == 13)
                    if ((this._checkNumValue(this._preVal) !== this._checkNumValue(this._textBox.value)))
                        this._setValue(this._textBox.value);
            }

            else if (e.keyCode != 27 && !e.ctrlKey || (e.ctrlKey && e.keyCode == 90 && $.trim(this._textBox.value) === "")) {
                this._keypressFlag = false;
                this._cancelEvent(e);
            }
        },
		_getLocalizedLabels: function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
		
    });
	
    ej.NumericTextbox.Locale = ej.NumericTextbox.Locale || {} ;
    
    ej.NumericTextbox.Locale['default'] = ej.NumericTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	ej.PercentageTextbox.Locale = ej.PercentageTextbox.Locale || {} ;
    
    ej.PercentageTextbox.Locale['default'] = ej.PercentageTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	ej.CurrencyTextbox.Locale = ej.CurrencyTextbox.Locale || {} ;
    
    ej.CurrencyTextbox.Locale['default'] = ej.CurrencyTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	
		
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejMaskEdit", "ej.MaskEdit", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },

        defaults: {

            maskFormat: "",

            value: null,

            watermarkText: "",

            name : null,

            height: "",

            width: "",

            showError: false,

            htmlAttributes: {},

            cssClass: "",

            customCharacter: null,

            inputMode: "text",

            readOnly: false,

            textAlign: ej.TextAlign.Left,

            hidePromptOnLeave: false,

            showRoundedCorner: false,

            enablePersistence: false,

            enabled: true,

            showPromptChar: true,

            validationRules: null,

            validationMessage: null,

            keydown: null,

            keyup: null,

            keyPress: null,

            change: null,

            mouseover: null,

            mouseout: null,

            focusIn: null,

            focusOut: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            maskFormat: "string",
            showError: "boolean",
            enabled: "boolean",
            customCharacter: "string",
            cssClass: "string",
            watermarkText: "string",
            showRoundedCorner: "boolean",
            showPromptChar: "boolean",
            inputMode: "enum",
            textAlign: "enum",
            hidePromptOnLeave: "boolean",
            readOnly: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data"
        },

        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "value":
                        if (ej.isPlainObject(jsondata[key])) jsondata[key] = null;
                        this._setValue(jsondata[key]); jsondata[key] = this.get_UnstrippedValue(); this._raiseEvents("change", true); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "watermarkText": this.model.watermarkText = jsondata[key]; this._changeWatermark(jsondata[key]); break;
                    case "showRoundedCorner": this._roundedCorner(jsondata[key]); break;
                    case "showPromptChar": this._setShowPrompt(jsondata[key]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this._hiddenInput.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "textAlign": this._setTextAlign(jsondata[key]); break;
                    case "inputMode": this._setInputMode(jsondata[key]); break;
                    case "maskFormat":
                        this.model.maskFormat = jsondata[key];
                        this._valueMapper();
                        this._setMask(jsondata[key]);
                        jsondata[key] = this.model.maskFormat;
                        break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "readOnly": this._setReadOnly(jsondata[key]); break;
                    case "enabled": this.model.enabled = jsondata[key]; this._controlStatus(jsondata[key]); break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "hidePromptOnLeave": this.model.hidePromptOnLeave = jsondata[key];
                        if (this._textbox.value != "") {
                            if(this.model.hidePromptOnLeave) {
                                this._unStrippedMask = this._textbox.value;
                                this._textbox.value = this.get_UnstrippedValue();
                            }
                            else this._textbox.value = this._textbox.value.replace(/[ ]/g, '_');
                            this.model.value = this._textbox.value;
                        }
                }
            }
        },
        observables: ["value"],


        _destroy: function () {
            if (!ej.isNullOrUndefined(this._hiddenInput)) this.element.attr("name", this._hiddenInput.attr("name"));
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this.element.insertAfter(this.wrapper);
            if (!ej.isNullOrUndefined(this.wrapper)) this.wrapper.remove();
            if (this.model.textAlign) this.element.css("text-align", "");
            this.element.val("").removeClass(' e-mask e-input e-disable').empty();
        },


        _init: function (options) {
            this._options = options;
            this._tempMask = this.model.maskFormat;
            if (this.element.is("input") && (this.element.is("input[type=text]") || this.element.is("input[type=password]") || !this.element.attr('type'))) {
                this._isWatermark = 'placeholder' in document.createElement('input');
                this._setValues();
                this._valueMapper();
                this._renderControl();
                this._initObjects();
                this._wireEvents();
				this._addAttr(this.model.htmlAttributes);
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
            } else {
                this._destroy();
                return false;
            }
            if (options && options.value != undefined && this.model.value !== options.value)
                this._trigger("_change", { value: this.get_UnstrippedValue(), unmaskedValue: this.get_StrippedValue()});            
        },

        _initValidator: function () {
			(!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
				else if(keyName == "name") proxy._hiddenInput.attr(key,value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readonly" && value == "readOnly") proxy._setReadOnly(true);
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);
            });
        },
        _setValidation: function () {
            this._hiddenInput.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this._hiddenInput.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },

        _setShowPrompt:function(value){
            this.model.showPromptChar = value;
            this._textbox.value = this.model.showPromptChar ? this._unStrippedMask : this.get_UnstrippedValue();
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _setValues: function () {
            this._unStrippedMask = null;
            //Predefined character definitions
            this._charMap = {
                '9': "[0-9 ]",
                'a': "[A-Za-z0-9 ]",
                'A': "[A-Za-z0-9]",
                'N': "[0-9]",
                '#': "[0-9]",
                '&': '[^\x7f]+',
                '<': "",
                '>': "",
                'C': this.model.customCharacter != null ? "[" + this.model.customCharacter + "]" : "[A-Za-z ]",
                '?': "[A-Za-z]",
            };
        },

        _renderControl: function () {
            this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
            if (this.element.attr("name") != null)
                this.element.removeAttr('name');
            this.wrapper = ej.buildTag("span.e-mask e-widget " + this.model.cssClass);
            this.innerWrapper = ej.buildTag("span.e-in-wrap e-box");
            this.wrapper.append(this.innerWrapper).insertBefore(this.element);
            this.innerWrapper.append(this.element);
            this._hiddenInput = ej.buildTag("input#" + this._id + "_hidden", "", {}, { type: "hidden" }).insertBefore(this.element);
            if (!this._isWatermark && this.model.inputMode != "password") {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this.model.watermarkText);
                this._hiddenSpan.css("display", "none");
                this._hiddenSpan.bind("mousedown", $.proxy(this._OnFocusHandler, this));
            }
            if(ej.isNullOrUndefined(this.model.value) && this.element[0].value != "") this.model.value =  this.element[0].value;
            if (!ej.isNullOrUndefined(this.model.value)) {
                this.wrapper.addClass('e-valid');
                if (typeof this.model.value == "number")
                    this.model.value = this.model.value.toString();
            }
            this._hiddenInput.attr({ "name": this.model.name, "value": this.model.value });
            this.element.attr({ 'aria-invalid': false }).addClass('e-input')
            if (this.model.maskFormat == "" && this.model.value == null) {
                var proxy = this;
                setTimeout(function () {
                    if (proxy.element.val() != "") {
                        proxy.option('value', proxy.element.val());
                        proxy.previousValue = proxy.model.value;
                        proxy._initObjects();
                    }
                }, 500)
            }
            else this.element.attr({ 'value': this.model.value });
            if (ej.isNullOrUndefined(this._options.inputMode) && !ej.isNullOrUndefined(this.element.attr("type")))
                this.model.inputMode = this.element.attr("type");
            else
                this._setInputMode(this.model.inputMode);
            this._setWidth(this.model.width);
            this._setHeight(this.model.height);
            this._roundedCorner(this.model.showRoundedCorner);
            this._setTextAlign(this.model.textAlign);
            this._setReadOnly(this.model.readOnly);
            this._controlStatus(this.model.enabled);
            this.previousValue = this.model.value;
        },

        _initObjects: function () {
            this._textbox = this.element[0];
            this._keypressFlag = 0;
            this._selectedTextKeyDown = 0;
            // KeyDown trace [ 0 - None, 1 - BackSpace, 2 - Delete]
            this._keydownFlag = 0;
            // Length of the Mask
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskLength = this.model.maskFormat.length;
            else {
                var _position = 0;
                for (var temp = 0; temp < this.model.maskFormat.length; temp++) {
                    if ((this.model.maskFormat[temp] == "\\"))
                        _position += 1;
                }
                this._maskLength = this.model.maskFormat.length - _position;
            }
            //Replacing all [9?$CANa*] to '_'           
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskModel = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
            else
                this._maskModel = this.model.maskFormat;

            if (this._maskModel.indexOf("<") >= 0 || this._maskModel.indexOf(">") >= 0) {
                this._maskModel = this._maskModel.replace(/[<>]/g, '');
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
                this._valueMapper();
            }

            this._validatedValue = this._maskModel;
            if (this.model.inputMode != "password") {
                this._setValue(this.model.value);
                this._setWaterMark();
            }
            if (this.model.showError) {
                this.element.addClass("e-error").attr('aria-invalid', "true");
            }
        },


        _setWidth: function (value) {
            this.wrapper.width(value);
        },

        _setHeight: function (value) {
            this.wrapper.height(value);
        },

        _roundedCorner: function (value) {
            if (value && !this.innerWrapper.hasClass('e-corner')) {
                this.innerWrapper.addClass('e-corner');
            }
            else if (this.innerWrapper.hasClass('e-corner')) {
                this.innerWrapper.removeClass('e-corner');
            }
        },

        _setTextAlign: function (align) {
            if (align == "right") {
                this.element.css("text-align","");
                this.wrapper.addClass('e-rtl');
            }
            else {
                this.wrapper.removeClass('e-rtl');
                this.element.css("text-align",align);
            }
        },

        _setInputMode: function (type) {
            this.element.attr('type', type);
        },

        _setReadOnly: function (bool) {
            this.model.readOnly = bool;
            if (bool) this.element.attr("readonly", true);
            else this.element.removeAttr("readonly");
        },

        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass);
            this.wrapper.addClass(skin);
        },

        _setWaterMark: function () {
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskModel = $.trim(this.model.maskFormat.replace(/[9?CANa#&]/g, '_')) === "" ? null : this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
            else
                this._maskModel = this.model.maskFormat === "" ? null : this.model.maskFormat;
            if ((this._maskModel != ''&&this._maskModel !=null&& this._textbox.value == formatValue) || (formatValue == '' && this._textbox.value == "") && this.model.inputMode != "password") this._textbox.value = "";
            if(this.model.watermarkText.length==0 && !ej.isNullOrUndefined(this.element.attr("placeholder"))) this.model.watermarkText = this.element.attr("placeholder");
            if (this.model.watermarkText) {
                if (this._isWatermark)
                    this.element.attr("placeholder", this.model.watermarkText);
                else {
                    if (this._textbox.value) this._hiddenSpan.css("display", "none").text(this.model.watermarkText);
                    else this._hiddenSpan.css("display", "block").text(this.model.watermarkText);
                }
            }
            if (!this.model.watermarkText && !this._textbox.value && this.model.maskFormat) {
                if (!this.model.hidePromptOnLeave) this._textbox.value = formatValue;
            else { this._unStrippedMask = this._maskModel; this._textbox.value = this.get_UnstrippedValue(); }
            }
        },

        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if ((this._textbox.value == formatValue || this._textbox.value == '' || $.trim(this.get_StrippedValue()) == "") && this.model.inputMode != "password") this._textbox.value = "";
            (this._isWatermark ? this.element.attr("placeholder", text) : this._hiddenSpan.text(text))
            if (!this.model.watermarkText && $.trim(this.get_StrippedValue()) == "" && this.model.maskFormat) {
                if (!this.model.hidePromptOnLeave) this._textbox.value = formatValue;
                else { this._unStrippedMask = this._maskModel; this._textbox.value = this.get_UnstrippedValue(); }
            }
        },

        _showAlert: function () {
            var ptr = this;
            this.element.addClass("e-error").attr('aria-invalid', "true").animate({ Opacity: 1 }, 700, null, function () {
                $(ptr._textbox).removeClass("e-error").attr('aria-invalid', "false");
            });
        },

        _unMask: function () {
            var tempValue = this.model.value;
            var tempModel = "";
            var valueIndex = -1, maskIndex = 0, i = 0, chr, prompt = "_", rule;
            while (maskIndex < this._rules.length) {
                chr = tempValue[i];
                rule = this._rules[maskIndex];
                if (chr == undefined) break;
                if (chr === rule || chr === prompt) {
                    tempModel += chr === prompt ? prompt : "";
                    i += 1;
                    maskIndex += 1;
                }
                else if (this._rules[maskIndex].rule != undefined && chr.match(this._rules[maskIndex].rule)) {
                    var charCode = tempValue.charCodeAt(i);
                    if (this._validateChars(charCode, maskIndex)) {
                        tempModel += tempValue.charAt(i);
                        maskIndex++;
                        i++;
                    } else maskIndex++;
                } 
                else if (typeof rule !== "string") {
                    if (chr.match(this._rules[maskIndex].rule)) {
                        var charCode = tempValue.charCodeAt(i);
                        if (this._validateChars(charCode, maskIndex)) {
                            tempModel += tempValue.charAt(i);
                            maskIndex++;
                            i++;
                        }
                    } else { i++; maskIndex++;}
                } else maskIndex++;
                if (i > tempValue.length) break;
            }
            return tempModel;
        },

        _validateValue: function () {
            if (ej.isNullOrUndefined(this.model.value)) return;
            var tempValue = this.model.value;
            var tempModel = this._maskModel;
            var valueIndex = -1, maskIndex = i = 0, chr, prompt = "_", rule;
            var oldvalue = this._unMask();
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            // Check if Mask is Empty display the text
            if (this._maskLength == 0) {
                this._textbox.value = tempValue;
                this._setWaterMark();
                return true;
            }
            else {
                var replacestring = this.model.value.toString();
                if (!((this.model.maskFormat.indexOf("\\") >= 0)) && this.model.customCharacter == null)
                    tempValue = this.model.value = replacestring.replace(/[\(\)-]/g, "");
                else
                    tempValue = this.model.value;
            }

            while (maskIndex < this._rules.length) {
                chr = oldvalue[i];
                rule = this._rules[maskIndex];
                if (chr == undefined) break;
                if (chr === rule || chr === prompt) {
                    chr === prompt ? prompt : "";
                    var strBefore = tempModel.substring(0, maskIndex);
                    var strAfter = tempModel.substring(maskIndex);
                    tempModel = strBefore + chr + strAfter.substr(1, strAfter.length);
                    i += 1;
                    maskIndex += 1;
                }
                else if (this._rules[maskIndex].rule != undefined ) {
                    var charCode = oldvalue.charCodeAt(i);
                    if (this._validateChars(charCode, maskIndex)) {
                        var strBefore = tempModel.substring(0, maskIndex);
                        var strAfter = tempModel.substring(maskIndex);
                        tempModel = strBefore + oldvalue.charAt(i) + strAfter.substr(1, strAfter.length);
                        maskIndex++;
                        i++;
                    } else maskIndex++;
                } 
                else if (typeof rule !== "string") {
                    if (chr.match(this._rules[maskIndex].rule)) {
                        var charCode = oldvalue.charCodeAt(i);
                        if (this._validateChars(charCode, maskIndex)) {
                            var strBefore = tempModel.substring(0, maskIndex);
                            var strAfter = tempModel.substring(maskIndex);
                            tempModel = strBefore + oldvalue.charAt(i) + strAfter.substr(1, strAfter.length);
                            maskIndex++;
                            i++;
                        } else maskIndex++;
                    } else {
                        var strBefore = tempModel.substring(0, maskIndex);
                        var strAfter = tempModel.substring(maskIndex);
                        tempModel = strBefore + prompt + strAfter.substr(1, strAfter.length);
                        i++;
                        maskIndex++;
                    }
                } else maskIndex++;
                if (i > tempValue.length) break;
            }
            if (this.model.value) {
                this._textbox.value = tempModel;
                this.model.value = this.get_UnstrippedValue();
                if (!((this.model.maskFormat.indexOf("\\") >= 0) || (this.model.maskFormat.indexOf("&") >= 0))) {
                    if (!this.model.hidePromptOnLeave) this._textbox.value = tempModel;
                    else { this._unStrippedMask = tempModel.replace(/[ ]/g, '_'); this._textbox.value = tempModel; }
                }         
                else {
                    this._textbox.value = "";
                    var _tPos = 0;
                    for (_pos = 0; _pos < this.model.maskFormat.length; _pos++) {
                        if (this.model.maskFormat[_pos] == "\\")
                            _tPos += 1;
                    }
                    var _position = 0;
                    if (this.model.value.length == tempModel.length - _tPos) {
                        for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                            if (this.model.maskFormat[pos] == "\\")
                                _position = _position + 1;
                            else if (this.model.maskFormat[pos - 1] == "\\")
                                this._textbox.value += tempValue[pos - _position];
                            else if (!(this.model.maskFormat[pos] == "\\")) {
                                if (tempValue.length <= pos - _position)
                                    this._textbox.value += tempModel[pos].replace(/[9?CANa#&]/g, '_');
                                else
                                    this._textbox.value += tempValue[pos - _position].replace(/[9?CANa#&]/g, '_');
                            }

                        }
                    }
                    else {
                        this._textbox.value = "";
                        for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                            if (this.model.maskFormat[pos - 1] == "\\")
                                this._textbox.value += tempModel[pos];
                            else if (!(this.model.maskFormat[pos] == "\\"))
                                this._textbox.value += tempModel[pos].replace(/[9?CANa#&]/g, '_');
                        }
                    }

                }
            }
            else {
                if (!(this.model.maskFormat.indexOf("\\") >= 0))
                    this._textbox.value = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
                else {
                    for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                        var val;
                        if (this.model.maskFormat[pos - 1] == "\\")
                            this._textbox.value += this.model.maskFormat[pos];

                        else if (!(this.model.maskFormat[pos] == "\\"))
                            this._textbox.value += this.model.maskFormat[pos].replace(/[9?CANa#&]/g, '_');

                    }
                }
            }
            if (this._textbox.value != undefined && this.model.hidePromptOnLeave) {
                this._unStrippedMask = this._textbox.value.replace(/[ ]/g, '_');
                this._textbox.value = this.get_UnstrippedValue();
            }
            if (this._maskModel!=null &&(this._textbox.value.indexOf(">") >= 0 || this._textbox.value.indexOf("<") >= 0)) {
                this._textbox.value = this._textbox.value.replace(/[<>]/g, '');
                this._tempMask = this.model.maskFormat;
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');                
            }
            if (!this.model.showPromptChar)
                this._textbox.value = this.get_UnstrippedValue();
            // Update the character to upper and lower case.
            if (this._tempMask != null) {
                for (var i = 0; i < this._textbox.value.length; i++) {
                    var tempkey = this._updateCasing(this._textbox.value[i], i);
                    if (!ej.isNullOrUndefined(tempkey))
                        this._textbox.value = this._textbox.value.substring(0, i) + tempkey + this._textbox.value.substring(i + tempkey.length);
                }
            }
            
            this._setWaterMark();
        },


        _selectionText: function (begin, end) {
            var replaceValue = !ej.isNullOrUndefined(this._maskModel)?this._maskModel.substring(begin, end):"";
            this._textbox.value = this._textbox.value.substring(0, begin) + replaceValue + this._textbox.value.substring(end);
            if (this._keydownFlag == 1) {
                this._setCaretPosition(begin);
                return begin;
            }
            else if (this._keydownFlag == 2) {
                this._setCaretPosition(end);
                return end;
            }
            return begin;
        },


        _caretPosition: function (textbox) {
            var caretPos = 0;
            // Microsoft supports only IE for using document.selection
            if (document.selection) {
                // Create a Range of selected position
                var selectedRange = document.selection.createRange();
                var selectionLength = selectedRange.text.length;
                // Move selection start to 0 position
                selectedRange.moveStart('character', -textbox.value.length);
                // Get caret position by selection length, becoz now range is from Zero to current focus
                caretPos = selectedRange.text.length - selectionLength;
                if (selectionLength != 0) {
                    caretPos = this._selectionText(caretPos, selectedRange.text.length);
                    this._selectedTextKeyDown = 1;
                }
            }
            // For Firefox
            else if (textbox.selectionStart || textbox.selectionStart == '0') {
                caretPos = textbox.selectionStart;
                if (textbox.selectionStart != textbox.selectionEnd) {
                    if (this._keydownFlag)
                        caretPos = this._selectionText(textbox.selectionStart, textbox.selectionEnd);
                    this._selectedTextKeyDown = 1;
                }
            }
            return (caretPos);
        },


        _setCaretPosition: function (caretPos) {
            var element = this._textbox;
            //For IE
            if (window.navigator.appName == "Microsoft Internet Explorer") {
                if (element.createTextRange) {
                    var range = element.createTextRange();
                    range.move('character', caretPos);
                    range.select();
                }
            }
            else
            /* For FireFox and Chrome */
                if (element.selectionStart || element.selectionStart == '0') {
                    element.focus();
                    element.setSelectionRange(caretPos, caretPos);
                }
                else
                    element.focus();
        },


        _validateChars: function (keyChar, caretPos) {
            var charmap = this._charMap, match = false;
            if (this.model.maskFormat.indexOf("\\") >= 0) {
                _position = this._getCunrrentPos(caretPos);
                var maskChar = this.model.maskFormat.substr(caretPos + _position, 1);
            }
            else
                var maskChar = this.model.maskFormat.substr(caretPos, 1);
            var customChar = this.model.customCharacter;
            var actualkey = String.fromCharCode(keyChar);
            $.each(charmap, function (key, value) {
                if (maskChar == key) {
                    if (customChar != null) {
                        if (key == "C")
                            value = "[" + customChar + "]";
                        else if (key == "A" || key == "N" || key == "#")
                            value = value.replace(("]"), "") + customChar + "]";
                    }
                    if (actualkey.match(new RegExp(value))) match = true;
                    else match = false;
                }
            });
            return match;
        },


        _seekNext: function () {
            var currentPos = this._caretPosition(this._textbox);
            var tempPos = currentPos;
            var seekFlag = true;
            //seeking the focus to next valid position on right of MaskEdit TextBox
            while (seekFlag) {
                if (currentPos >= 0 && currentPos < this._maskLength) {
                    var _position = 0;
                    for (var temp = 0; temp <= currentPos; temp++) {
                        if ((this.model.maskFormat[temp] == "\\"))
                            _position += 1;
                    }
                    if (this.model.maskFormat.charAt(currentPos) != "C") {
                        if (this.model.maskFormat.indexOf("\\") >= 0) {
                            if (this.model.maskFormat.charAt(currentPos + _position) != "\\" && this.model.maskFormat.charAt(currentPos + _position - 1) != "\\") {
                                if (!this._charMap[this.model.maskFormat.charAt(currentPos + _position)]) {
                                    this._setCaretPosition(currentPos);
                                    currentPos++;
                                }
                            }
                        }
                        else {
                            if (!this._charMap[this.model.maskFormat.charAt(currentPos)]) {
                                this._setCaretPosition(currentPos);
                                currentPos++;
                            }
                        }
                        if (currentPos != tempPos) {
                            tempPos = currentPos;
                            continue;
                        }
                    }
                }
                seekFlag = false;
            }
            return currentPos;
        },


        _seekBefore: function (caretPos) {
            var currentPos = this._caretPosition(this._textbox);
            var tempPos = --currentPos;
            var seekFlag = true;
            // Stop Seek when backspace of select more than a char
            if (this._selectedTextKeyDown == 1)
                seekFlag = false;
            //seeking the focus to next valid position on left of MaskEdit TextBox
            while (seekFlag) {
                if (currentPos >= 0 && currentPos < this._maskLength) {
                    if (this.model.maskFormat.charAt(currentPos) != "C") {
                        if (!this._charMap[this.model.maskFormat.charAt(currentPos)]) {
                            this._setCaretPosition(--currentPos);
                        }
                    }
                    if (currentPos != tempPos) {
                        tempPos = currentPos;
                        continue;
                    }
                }
                seekFlag = false;
            }
            return currentPos;
        },


        _writeBuffer: function (key, cursorPos) {
            if (cursorPos <= this._maskLength) {
                var input = this._textbox.value;
                if (this._tempMask != null)
                    var tempkey = this._updateCasing(key, cursorPos);
                key = (tempkey == undefined) ? key : tempkey;
                var strBeforeCursor = input.substring(0, cursorPos);
                var strAfterCursor = input.substring(cursorPos);
                if (this.model.maskFormat.indexOf("\\") >= 0) {
                    var _position = 0;
                    for (var temp = 0; temp <= cursorPos; temp++) {
                        if ((this.model.maskFormat[temp].indexOf("\\") >= 0) && (cursorPos != 0))
                            _position += 1;
                    }
                    if (this.model.maskFormat[cursorPos + _position].indexOf("\\") >= 0)
                        this._textbox.value = strBeforeCursor + input[cursorPos] + strAfterCursor.substr(1, strAfterCursor.length);
                    else
                        this._textbox.value = strBeforeCursor + key + strAfterCursor.substr(1, strAfterCursor.length);
                }
                else
                    this._textbox.value = strBeforeCursor + key + strAfterCursor.substr(1, strAfterCursor.length);
                this._setCaretPosition(cursorPos + 1);
            }
        },

        _updateCasing: function (key, pos) {
            for (var i = 0; i < pos + 1; i++) {
                if (this._tempMask.substr(i, 1) == '<' || this._tempMask.substr(i, 1) == '>')
                    pos++;
            }

            for (var j = pos; j > -1; j--) {
                if (this._tempMask.substr(j, 1) == '<') {
                    return key.toLowerCase();
                }
                else if (this._tempMask.substr(j, 1) == '>') {
                    return key.toUpperCase();
                }
            }
        },


        get_StrippedValue: function () {
            var i, value, mask = this.model.maskFormat, stripVal = null;
            value = (this._textbox.value == "" && this.model.inputMode != "password") ? this._maskModel : this._textbox.value;
            if (mask.length == 0) return value;
            var _position = 0;
            for (var i = 0; i < mask.length; i++) {
                stripVal = $.trim(stripVal);
                if ((this.model.maskFormat.indexOf("\\") >= 0)) {
                    if ((this.model.maskFormat[i] == "\\"))
                        _position += 1;
                    else if (this.model.maskFormat[i - 1] == "\\")
                        stripVal += this._textbox.value[i - _position];
                    else {
                        var char = mask[i], exp = null;

                        if ("9?$a*".indexOf(char) != -1)
                            exp = this._charMap[char];
                        else if (char == "A" || char == "N" || char == "#")
                            exp = this._charMap[char].replace(("]"), "") + this.model.customCharacter + "]";
                        else if (char == "C")
                            exp = "[" + this.model.customCharacter + "]";
                        else if (char == "&")
                            stripVal += value[i - _position];
                        if (exp && value[i - _position] && value[i - _position].match(new RegExp(exp)))
                            stripVal += value[i - _position];
                    }

                }
                else {
                    var char = mask[i], exp = null;

                    if ("9?$a*".indexOf(char) != -1)
                        exp = this._charMap[char];
                    else if (char == "A" || char == "N" || char == "#")
                        exp = this._charMap[char].replace(("]"), "") + this.model.customCharacter + "]";
                    else if (char == "C")
                        exp = "[" + this.model.customCharacter + "]";
                    else if (char == "&")
                        stripVal += value[i - _position];
                    if (exp && value[i] && value[i].match(new RegExp(exp)))
                        stripVal += value[i];
                }
            }
            return stripVal;
        },


        get_UnstrippedValue: function () {
            var value = (this._textbox.value == "" && this.model.inputMode != "password") ? this._maskModel : this._textbox.value, unstripVal = null;
            if (this.model.maskFormat.length == 0) return value;

            if (value != undefined)
                unstripVal = $.trim(value.replace(/[_]/g, " ")) == "" ? null : value.replace(/[_]/g, " ");
            return unstripVal;
        },

        _setValue: function (value) {
            if (ej.isNullOrUndefined(value) || $.trim(value) == "") value = null;
            this.model.value = value;
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            if (!ej.isNullOrUndefined(this.model.maskFormat) && this.model.maskFormat != "") {
                this._validateValue();
                if (ej.isNullOrUndefined(this.model.value)) { 
                    this._textbox.value = ej.isNullOrUndefined(value) ? "" : value; 
                    this._unStrippedMask = this._maskModel; 
                }
            }
            else { this._textbox.value = ej.isNullOrUndefined(value) ? "" : value;  this._unStrippedMask = this._textbox.value; }
            this._setWaterMark();
        },


        _valueMapper: function () {
            var mapper = [], mapperIdx = 0, mask = this.model.maskFormat || "", maskChars = mask.split(""), i = 0, chr;
            var emptyMask = "", rule, rules = this._charMap, promptChar = "_";

            for (; i < mask.length; i++) {
                chr = maskChars[i];
                rule = rules[chr];
                if (rule) {
                    mapper[mapperIdx] = { rule: rule };
                    emptyMask += promptChar;
                    mapperIdx += 1;
                } else {
                    if (chr === "\\") {
                        idx += 1;
                        chr = maskChars[idx];
                    }
                    chr = chr.split("");
                    for (var j = 0; j < chr.length; j++) {
                        mapper[mapperIdx] = chr[j];
                        emptyMask += chr[j];
                        mapperIdx += 1;
                    }
                }
            }
            this._rules = mapper;
            this._emptyMask = emptyMask;
            this._maskLength = emptyMask.length;
        },

        _setMask: function (maskValue) {
            this._maskLength = maskValue.length;
            this.model.maskFormat = maskValue;
            this._tempMask = this.model.maskFormat;
            this._maskModel = maskValue.replace(/[9?CANa]/g, '_');
            if (this._maskModel.indexOf("<") >= 0 || this._maskModel.indexOf(">") >= 0) {
                this._maskModel = this._maskModel.replace(/[<>]/g, '');
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
            }            
            if (!ej.isNullOrUndefined(this.model.maskFormat) && this.model.maskFormat != "") 
                this._validateValue();
            else if (!this.model.watermarkText && this._textbox.value != this._maskModel) {
                if (!this.model.maskFormat) {
                    unstripVal = this._unStrippedMask.replace(/[_]/g, " ");
                    this._textbox.value = (this.model.customCharacter == null) ? $.trim(unstripVal.replace(/[\(\)-]/g, "")) : $.trim(unstripVal);
                    this._unStrippedMask = this._textbox.value;
                }
                else if (this.model.hidePromptOnLeave) {
                    this._textbox.value = this._maskModel;
                    this._unStrippedMask = this._textbox.value;
                    this._textbox.value = this.get_UnstrippedValue();
                }
                else this._textbox.value = this._maskModel;
            }
        },

        enable: function () {
            this.element.disabled = false;			
            this.element.removeAttr("disabled").removeClass('e-disable').attr({ "aria-disabled": false });
			this.wrapper.removeClass('e-disable-wrap');
            this.model.enabled = true;
        },

        disable: function () {
            this.element.disabled = true;
            this.element.attr("disabled", "disabled").addClass('e-disable').attr({ "aria-disabled": true });
			this.wrapper.addClass('e-disable-wrap');
            this.model.enabled = false;
        },

        clear: function () {
            this._textbox.value = this.model.maskFormat.replace(/[9?aCAN]/g, '_');
            this.model.value = this.get_StrippedValue();
        },

        _wireEvents: function () {
            this._on(this.element, 'focus', this._OnFocusHandler);
            this._on(this.element, 'blur', this._OnBlurHandler);
            this._on(this.element, 'keydown', this._OnKeyDownHandler);
            this._on(this.element, 'keypress', this._OnKeyPressHandler);
            this._on(this.element, 'keyup', this._OnKeyUpHandler);
            this._on(this.element, 'mouseover', this._OnMouseOverHandler);
            this._on(this.element, 'mouseout', this._OnMouseOutHandler);
            this._on(this.element, 'paste', this._OnPasteHandler);
            this._on(this.element, 'cut', this._OnCutHandler);
        },

        _OnCutHandler: function (e) {
            var selectedValue = !ej.isNullOrUndefined(this._maskModel)?this._maskModel.substring(this._textbox.selectionStart, this._textbox.selectionEnd):"";
            var beforeSelection = this._textbox.value.substring(0, this._textbox.selectionStart);
            var afterSelection = this._textbox.value.substring(this._textbox.selectionEnd);
            var cursorPosition = this._textbox.selectionStart;
            var context = this;
            setTimeout(function () {
                context._textbox.value = beforeSelection + selectedValue + afterSelection;
                context._setCaretPosition(cursorPosition);
                context._raiseEvents("change");
            }, 0);
        },


        _OnPasteHandler: function (e) {
            var context = this;
            setTimeout(function () {
                var text = $(context._textbox).val();
                context._setValue(text);
                context._raiseEvents("change");
            }, 0);
            return true;
        },


        _OnFocusHandler: function (e) {
            this.wrapper.addClass("e-focus");
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if (this.model.readOnly)
                return;
            this._focusValue = this.model.value;
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            if (this._textbox.value == "" && this._maskModel != "" && this.model.inputMode != "password")
                if (this.model.maskFormat.indexOf("\\") >= 0) {
                    this._textbox.value = this.model.watermarkText;
                }
                else
                    this._textbox.value = ej.isNullOrUndefined(this._maskModel) ? "" : formatValue;
            if (this._maskModel != null && (this._textbox.value.indexOf("<") >= 0 || this._textbox.value.indexOf(">") >= 0)) {
                this._textbox.value = this._textbox.value.replace(/[<>]/g, '');
                this._maskModel = this._textbox.value;
                this._tempMask = this.model.maskFormat;
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
            }

            if (this._textbox.value != formatValue && this._unStrippedMask != null && this.model.hidePromptOnLeave)
                this._textbox.value = this._unStrippedMask;

            if (!this.model.showPromptChar) this._textbox.value = this.get_UnstrippedValue();

            $.fn.selectRange = function (start, end) {
                return this.each(function () {
                    if (this.setSelectionRange) {
                        this.focus();
                        this.setSelectionRange(start, end);
                    } else if (this.createTextRange) {
                        var range = this.createTextRange();
                        range.collapse(true);
                        range.moveEnd('character', end);
                        range.moveStart('character', start);
                        range.select();
                    }
                });
            };
            if (this.model.maskFormat) {
                $(this.element).selectRange(0, 0);
            }

            this._raiseEvents("focusIn");
        },

        _OnBlurHandler: function (e) {
            this.wrapper.removeClass("e-focus");            
            this.model.value = this.get_StrippedValue();
            var dup = new Array();
            var option = new Array();
            if ((this._textbox.value.indexOf('_') != -1 || this._textbox.value.indexOf(' ') != -1)&& !ej.isNullOrUndefined(this.model.value)) {
                for (var i = 0; i < this.model.maskFormat.length; i++) {
                    if ((this.model.maskFormat[i] == "A") || (this.model.maskFormat[i] == "?")) dup.push(i);
                    else if ((this.model.maskFormat[i] == "9") || (this.model.maskFormat[i] == "a") || (this.model.maskFormat[i] == "C")) {
                        option.push(i);
                    }
                }
                for (var i = 0; i < dup.length; i++) {
                    if (this._textbox.value[dup[i]] === "_") {
                        this._showAlert();
                        this.model.value = this._textbox.value;
                    }
                }
                for (var i = 0; i < option.length; i++) {
                    if ((this.model.value[option[i]] == "_") || (this.model.value[option[i]] == " ")) {
                        this.model.value = this.model.value.substr(0, option[i]) + this.model.value.substr(option[i] + 1, this.model.value.length)
                        for (var j = i; j < option.length; j++) {
                            option[j] = option[j] - 1;
                        }
                    }
                }
            }
            this.model.value = (this.model.value != null) ? this.model.value.replace(/\s+/g, "") : this.model.value;
            if (this._textbox.value != undefined && (this.model.watermarkText == "" || (this.model.watermarkText != "" && this.model.value != ""))) {
                if (this.model.hidePromptOnLeave) {
                    this._unStrippedMask = this._textbox.value;
                    this._textbox.value = this.get_UnstrippedValue();
                }
                else this._unStrippedMask = this._textbox.value;
            }
            if (this.model.inputMode != "password")
                this._setWaterMark();
            this._raiseEvents("change");
            this._raiseEvents("focusOut");
        },


        _OnKeyDownHandler: function (e) {
            if (this.model.readOnly) return;
            this._keypressFlag = 0;
            this._raiseEvents("onKeyDown", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });

            this.element.removeClass("error");

            if (this._maskLength == 0)
                return true;

            var unicode = e.keyCode ? e.keyCode : e.charCode;
            var actualkey = String.fromCharCode(unicode);
            var currentPos = this._seekNext();
            var promptChar = this.model.showPromptChar ? "_" : " ";
            var val = ej.browserInfo().name;
            if ((val == "msie") && (this._textbox.value == "")) {
                if (!(this.model.maskFormat.indexOf("\\") >= 0))
                    this._textbox.value = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
                else {
                    for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                        var val;
                        if (this.model.maskFormat[pos - 1] == "\\")
                            this._textbox.value += this.model.maskFormat[pos];
                        else

                            if (!(this.model.maskFormat[pos] == "\\"))
                                this._textbox.value += this.model.maskFormat[pos].replace(/[9?CANa#&]/g, '_');
                    }
                }
                this._setCaretPosition(currentPos);
            }

            if (unicode >= 35 && unicode <= 41) {
                if (window.navigator.appCodeName == "Mozilla" || window.navigator.appCodeName == "opera") {
                    this._keypressFlag = 1;
                }
            }
            if (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 46 || e.keyCode == 127) || (e.ctrlKey && (e.keyCode == 86 || e.keyCode == 65 || e.keyCode == 67 || e.keyCode == 88))) {
                this._keypressFlag = 1;
                return;
            }
            else if (unicode == 8) {

                if (this.model.inputMode != "password") {
                    this._keydownFlag = 1;
                    // Seek to next valid position
                    var currentPos = this._seekBefore();
                    if (!this._selectedTextKeyDown) {
                        if (currentPos >= 0 && currentPos < this._maskLength)
                            this._writeBuffer(promptChar, currentPos);                       
                        this._setCaretPosition(currentPos);
                    }
                    else if (!this.model.showPromptChar && this._selectedTextKeyDown)
                    {                        
                        this._textbox.value = this.get_UnstrippedValue();
                        this._setCaretPosition(currentPos+1);
                    }
                    this._keydownFlag = 0;
                    this._selectedTextKeyDown = 0;
                    e.preventDefault();
                    return false;
                }
                this._keypressFlag = 1;
                return true;
            }
            else if (e.keyCode == 46 || e.keyCode == 127) {
                if (this.model.inputMode != "password") {
                    this._keydownFlag = 2;
                    // Seek to next valid position
                    currentPos = this._seekNext();
                    if (!this._selectedTextKeyDown) {
                    if (currentPos >= 0 && currentPos < this._maskLength) {                        
                        _position=this. _getCunrrentPos(currentPos);
                            if (!((this.model.maskFormat[currentPos + _position] == "&")))
                                this._writeBuffer(promptChar, currentPos);
                        }
                    }
                    else if (!this.model.showPromptChar && this._selectedTextKeyDown) {
                        this._textbox.value = this.get_UnstrippedValue();
                        this._setCaretPosition(currentPos);
                    }
                    this._keydownFlag = 0;
                    this._selectedTextKeyDown = 0;
                    e.preventDefault();
                    return false;
                }
                this._keypressFlag = 1;
                return true;
            }
        },


        _ErrorHandler: function (currentPos) {
            var promptChar = this.model.showPromptChar ? "_" : " ";
            if (this._textbox.value == "") this._textbox.value = this.model.maskFormat.replace(/[9?$CANa*]/g, promptChar);
            this._setCaretPosition(currentPos);
            this._showAlert();
        },
        _getCunrrentPos: function (currentPos) {
            var _position = 0;
            for (var temp = 0; temp <= currentPos + _position; temp++) {
                if ((this.model.maskFormat[temp] == "\\"))
                    _position += 1;
            }
            return _position;
        },


        _OnKeyPressHandler: function (e) {
            if (this.model.readOnly) return;
            this._raiseEvents("keyPress", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });
            if (this._maskLength == 0)
                return true;

            var unicode = e.keyCode ? e.keyCode : e.charCode;
            var actualkey = String.fromCharCode(unicode);
            var promptChar = this.model.showPromptChar ? "_" : " ";
            var currentPos = this._seekNext();
            var val = ej.browserInfo().name;
            if (this._validateChars(unicode, currentPos)) {
                if (((val == "mozilla") || (val == "opera")) && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39)) {
                }
                else if (((val == "mozilla") || (val == "opera")) && (e.ctrlKey && (unicode == 97 || unicode == 99 || unicode == 118 || unicode == 120))) {
                }
                else {
                    if (this._textbox.value == "") this._textbox.value = this.model.maskFormat.replace(/[9?$CANa*]/g, promptChar);
                    if (this.model.maskFormat.indexOf("\\") >= 0) {
                        if (currentPos < this._maskLength)
                            this._writeBuffer(actualkey, currentPos);
                    }
                    else
                        this._writeBuffer(actualkey, currentPos);
                }
            }
            else
                if (((val == "mozilla") || (val == "opera")) && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39)) {
                }
                else if (((val == "mozilla") || (val == "opera")) && (e.ctrlKey && (unicode == 97 || unicode == 99 || unicode == 118 || unicode == 120))) {
                }
                else if (this.model.maskFormat.indexOf("&") >= 0 || this.model.maskFormat.indexOf("\\") >= 0) {
                    _position = this._getCunrrentPos(currentPos);
                    if (!((this.model.maskFormat[currentPos + _position] == "&") && (unicode == 127))) {
                        if (this.model.maskFormat.indexOf("\\") >= 0) {
                            if (currentPos < this._maskLength) {
                                if (this._validateChars(unicode, currentPos + _position) || (this.model.maskFormat[currentPos + _position - 1] == "\\"))
                                    this._writeBuffer(actualkey, currentPos);
                                else
                                    this._ErrorHandler(currentPos);
                            }
                        }
                        else {
                            if (this._validateChars(unicode, currentPos + _position))
                                this._writeBuffer(actualkey, currentPos);
                            else
                                this._ErrorHandler(currentPos);
                        }
                    }
                }
                else
                    this._ErrorHandler(currentPos);

            if (!this._keypressFlag && unicode != 9) {
                this._keypressFlag = 0;
                e.preventDefault();
                return false;
            }
            this._keypressFlag = 0;
        },

        _OnKeyUpHandler: function (e) {
            if (this._maskLength == 0) this._raiseEvents("change");
            this._raiseEvents("keyUp", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });
            if (!ej.isNullOrUndefined(this.model.validationRules)) this._hiddenInput.valid();
        },


        _OnMouseOverHandler: function (e) {
            this._raiseEvents("mouseOver");
        },


        _OnMouseOutHandler: function (e) {
            this._raiseEvents("mouseOut");
        },


        _raiseEvents: function (eventName, isCode, additionalArgs) {
            var eventArgs, strippedVal = this.get_StrippedValue(), unstrippedVal = this.get_UnstrippedValue();
            this.model.value = unstrippedVal !== null ? (this.model.customCharacter == null && $.trim(unstrippedVal.replace(/[\(\)-]/g, "")) == "") ? null : unstrippedVal : null;
            if (eventName == "change") {
                if (this.previousValue != this.model.value) {
                    this.previousValue = this.model.value;
                }
                else {
                    if (this._focusValue == this.model.value)
                        return false;
                }
            }
            eventArgs = { value: unstrippedVal, unmaskedValue: strippedVal };
            if (eventName == "change") eventArgs["isInteraction"] = !isCode ;
            if (eventName == "change") {
                this._trigger("_change", eventArgs);
                ej.isNullOrUndefined(this.model.value) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            }
            if (additionalArgs) $.extend(true, eventArgs, additionalArgs);
			this._trigger(eventName, eventArgs);
            this._hiddenInput.val(strippedVal);
        },

        _OnValueChange: function () {
            if (this._textbox.value == "" && this._maskModel != "")
                this._textbox.value = this._maskModel;
            this._setValue(this._textbox.value);
        }

    });

    ej.InputMode = {
		/**  support for user enter character in password format. */
		Password: "password", 
		/**  support for user enter character in normal format. */
        Text: "text"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Menu control.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejMenu", "ej.Menu", {

        element: null,

        model: null,
        validTags: ["ul"],
        _setFirst: false,
        _rootCss: "e-menu",
        angular: {
            terminal: false
        },


        defaults: {

            height: "",

            width: "",

            animationType: "default",

            orientation: ej.Orientation.Horizontal,

            menuType: "normalmenu",
			
			isResponsive: true,

            contextMenuTarget: null,

            htmlAttributes: {},

            cssClass: "",

            openOnClick: false,

            subMenuDirection: "none",

            enableCenterAlign: false,

            showRootLevelArrows: true,

            showSubLevelArrows: true,

            enableAnimation: true,
            
            container: null,

            enableSeparator: true,

            enabled: true,

            overflowHeight: "auto",

            overflowWidth: "auto",

            fields: {

                child: null,

                dataSource: null,

                query: null,

                tableName: null,

                id: "id",

                parentId: "parentId",

                text: "text",

                spriteCssClass: "spriteCssClass",

                url: "url",

                imageAttribute: "imageAttribute",

                htmlAttribute: "htmlAttribute",

                linkAttribute: "linkAttribute",

                imageUrl: "imageUrl",
            },

            enableRTL: false,

            titleText: "Menu",

            locale: "en-US",

            excludeTarget: null,

            beforeOpen: null,

            open: null,

            close: null,

            mouseover: null,

            mouseout: null,

            click: null,

            keydown: null,

            overflowOpen: null,

            overflowClose:null,

            create: null,

            destroy: null
        },

        dataTypes: {
            animationType: "enum",
            cssClass: "string",
            titleText: "string",
            locale: "string",
            openOnClick: "boolean",
            enabled: "boolean",
            enableCenterAlign: "boolean",
            showArrow: "boolean",
            showRootLevelArrows: "boolean",
            showSubLevelArrows: "boolean",
            enableSeparator: "boolean",
			isResponsive: "boolean",
            enableRTL: "boolean",
            enableAnimation: "boolean",
            fields: {
                dataSource: "data",
                query: "data",
                child: "data"
            },
            excludeTarget: "string",
            htmlAttributes: "data"
        },


        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "menuType":
                        jsondata[key] = this.model.menuType;
                        break;
                    case "fields":
                        this._wireEvents("_off");
                        this.element.empty().insertBefore(this.wrapper);
                        this.wrapper.remove();
                        $.extend(this.model.fields, jsondata[key]);
                        this._intializeData();
                        if (!this.model.enabled)
                            this._wireEvents("_off");
                        break;
                    case "orientation": this._setOrientation(jsondata[key]); break;
                    case "showRootLevelArrows": this._addArrow(jsondata[key], this.model.showSubLevelArrows); break;
                    case "showSubLevelArrows": this._addArrow(this.model.showRootLevelArrows, jsondata[key]); break;
                    case "enableSeparator": this._setSeparator(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "isResponsive":
                        if (this.model.isResponsive)
                            this._responsiveLayout();
                        else {
                            $(this.resWrap).remove();
                            $(this.wrapper).removeClass("e-menu-responsive");
                            $(this.element).removeClass("e-menu-responsive");
                            this.resWrap = null;
                        }
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "enableRTL": this._setRTL(jsondata[key]); break;
                    case "enableCenterAlign": this._centerAlign(jsondata[key]); break;
                    case "excludeTarget": this.model.excludeTarget = jsondata[key];
                        break;
                    case "enabled": this.model.enabled = jsondata[key]; this._controlStatus(jsondata[key]); break;
                    case "animationType":
                        this._setAnimation(jsondata[key]);
                        break;
                    case "enableAnimation": this.model.enableAnimation = jsondata[key]; break;
                    case "openOnClick":
                            this._hoverOpen = !jsondata[key];
                            this._hoverClose = !jsondata[key]; 
                        break;
                    case "subMenuDirection": this._setSubMenuDirection(this.model.subMenuDirection); break;
                    case "titleText":
						this._titleText(jsondata[key]);
                        break;
                    case "locale":
                        this.model.locale = jsondata[key];
                        this._updateLocalConstant();
                        this._setLocale();
                        break;
                    case "overflowHeight":                       
                            this._setOverflowDimensions("height",jsondata[key]); break;
                    case "overflowWidth":                      
                        this._setOverflowDimensions("width",jsondata[key]); break;

                }
            }
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.Menu", this.model.locale);
        },
        		
        _setLocale: function () {
            this._titleText(this._localizedLabels.titleText);
        },
        _titleText: function(val){
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical"))
                $(this.label).text(val);
        },

        _destroy: function () {
            this.model.menuType == ej.MenuType.ContextMenu ? this._referenceElement.append(this._cloneElement) : this._cloneElement.insertBefore(this.wrapper);
            this._cloneElement.removeClass('e-menu e-js');
            this.wrapper.remove();
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this.element.css("visibility", "hidden");
            this._setValues();
            this._intializeData();
            this.element.css("visibility", "visible");
        },

        _setValues: function () {
            this._mouseOver = true;
            this._hoverOpen = true;
            this._hoverClose = true;
            this._isMenuOpen = false;
            this._hideSpeed = 100;
            this._showSpeed = 100;
            this._isSubMenuOpen = false;
            this._isContextMenuOpen = false;
            this._disabledMenuItems = new Array();
            this._hiddenMenuItems = new Array();
            this._delayMenuHover = 0;
            this._delaySubMenuHover = 0;
            this._delaySubMenuShow = 0;
            this._preventContextOpen = true;
            this._setAnimation(this.model.animationType);
            this._isFocused = true;
            this._menuOverflowItems = new Array();
            this._menuHeaderItems = new Array();
            this._menuCloneItems = new Array();
            this._itemWidth = 0; 
        },
        _intializeData: function () {
            if (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) {
                this._generateTemplate(this.model.fields["dataSource"]);
                this._renderMenu();
            }
            else {
                this._renderMenu();
                this._wireEvents("_on");
                this._calculateOverflowItems();
            }
        },
        _renderMenu: function () {
            this._renderControl();
            this._addArrow(this.model.showRootLevelArrows, this.model.showSubLevelArrows);
			this._renderArrow();
			this._intializeMenu();
            //item Width for width property		
			    this._itemWidth = this.element.width();
			    if (this.model.isResponsive) {
			        this._ensureResponsiveClasses($(window).width() < 767);
			    }
			    if (this.model.orientation == "horizontal") {
			        this._on(this.element.parent().find("span.e-check-wrap.e-icon"), "click", this._mobileResponsiveMenu);
			        if(this.model.fields["dataSource"] != null) this._calculateOverflowItems();
			    }
        },      

        _renderControl: function () {
            var label, checkBox, checkObj, list, spanlist, i;
            if (this.model.menuType == "normalmenu") {
                this.wrapper = ej.buildTag("div");
                this.wrapper.addClass(this.model.cssClass + " e-menu-wrap");
            } else
                this.wrapper = ej.buildTag("div.e-menu-wrap");
            if (this.model.isResponsive) this._responsiveLayout();
            if (this.model.menuType != ej.MenuType.ContextMenu) {
                this.wrapper.insertBefore(this.element);
                this.wrapper.append(this.element);
                }            
            this.element.addClass("e-menu e-widget e-box").attr({ "role": "menu", "tabindex": 0 });
            this._addAttr(this.model.htmlAttributes);
            if (this.model.enableRTL) this._setRTL(this.model.enableRTL);
            this._setSubMenuDirection(this.model.subMenuDirection);
            if (this.model.menuType == "normalmenu") {
                this.model.orientation == "horizontal" ? this.element.addClass("e-horizontal") : this.element.addClass("e-vertical");
            }
            //For ContextMenu Mode
            else this._contextMenu_Template();
            this._addClass();
            if (this.model.enableCenterAlign) this._centerAlign(this.model.enableCenterAlign);
            if (this.model.enableSeparator) this._setSeparator(true);
            (!this.model.enabled) && this.disable();
        },
        _renderPopupWrapper: function (e) {
            if(this._ensureOverflowPopup()){                          
                this.popupWrapper = ej.buildTag("div.e-menu-popwrap");                         
                this.popupWrapper.insertAfter(this.element);              
                var height = typeof value === "number" ? this.model.overflowHeight + "px" :this.model.overflowHeight;
                var width = typeof value === "number" ? this.model.overflowWidth + "px" : this.model.overflowWidth;
                this.popupWrapper.css({ "height": height,"width":width});
                this.popupWrapper.hide();
                this._addOverflowItems();                
            }
        
        },
        _calculateOverflowItems: function (e) {        
            if (this._ensureOverflowPopup()) {
                this.element.find("li.e-list").removeClass("e-menu-show");
                $(this.lastelement).removeClass("e-last");
                this._menuHeaderItems = [];  
                var menuHeaderWidth = this.element.outerWidth();               
                if (this.element.find("li.e-ham-wrap").length > 0) //for window resizing event neglect the hamburger icon list from the listCollection
                {                   
                    if ((this._itemWidth<=this.element.width())||(this._itemWidth>=this.element.width()) && (!(this._isOverflowPopupOpen()))) {
						if(!ej.isNullOrUndefined(this.popupWrapper))
							this.popupWrapper.hide();                        
                    }
                }
				this._renderHamburgerIcon();	
				this.element.find("li.e-ham-wrap").css({display: 'list-item'});
                var hamburgerWidth = this.element.find("li.e-ham-wrap").outerWidth(), itemsOuterWidth = 0, hideState=true;
				this.element.find("li.e-ham-wrap").hide();
                this._menuHeaderItems = this.element.find(">li.e-list");
                this._menuOverflowItems = [];
                for ( var i = 0; i < this._menuHeaderItems.length; i++) {
                   var menuItem = $(this._menuHeaderItems[i]);                                        
                        itemsOuterWidth = itemsOuterWidth + menuItem.outerWidth();
                        if (itemsOuterWidth < menuHeaderWidth) {                      
                            menuItem.removeClass('e-menu-hide');
							this.element.find(">li.e-list.e-haschild>ul").find("li.e-haschild").find("span.e-icon.e-arrowhead-down").removeClass("e-arrowhead-down").addClass("e-arrowhead-right");
                            if (this.model.enableSeparator) this._setSeparator(true);                  
                        }
                        else {
							if(hideState)
							{
								hideState=false;
								this.element.find("li.e-ham-wrap").css({display: 'list-item'}); 
								itemsOuterWidth = itemsOuterWidth - menuItem.outerWidth() + hamburgerWidth;
								if(i>1){
									(itemsOuterWidth = itemsOuterWidth - $(this._menuHeaderItems[i-1]).outerWidth());
									i=i-2;
								}								
								continue;
							}
                            this._menuOverflowItems.push($(menuItem).clone(true));                            
                            menuItem.addClass('e-menu-hide');                            
                        }
                }            
                if (this._menuOverflowItems.length>0) {
                    this._renderHamburgerIcon();
                    $('.e-menu-popwrap').length ?  this._addOverflowItems():  this._renderPopupWrapper();                     
                    this.lastelement = this.element.find('>li.e-list:visible').last().addClass('e-last');
                    this.element.find(">li.e-list.e-haschild>ul").find("li.e-haschild").find("span.e-icon.e-arrowhead-down").removeClass("e-arrowhead-down").addClass("e-arrowhead-right");            
                }
                else if (this._menuOverflowItems.length == 0 && $("li.e-ham-wrap").length > 0) {
                    this.element.find("li.e-ham-wrap").remove();
                }

            }           
            if (this.model.orientation == "vertical" || this.model.menuType == ej.MenuType.ContextMenu && ($(window).width() >= 768) && (this.model.isResponsive)) {
                this.element.find("span.e-icon.e-arrowhead-down").removeClass('e-arrowhead-down').addClass('e-arrowhead-right');
            }
            

        },
        _renderHamburgerIcon: function () {
            if((this._ensureOverflowPopup())&& (this.element.find("li.e-ham-wrap").length==0)){            
                var liTag = ej.buildTag("li.e-ham-wrap");
                var divTag = ej.buildTag("div");
                this.hamburgerspan = ej.buildTag('span.e-hamburger');                                                     
                divTag.append(this.hamburgerspan);
                liTag.append(divTag);    
                this.element.append(liTag);
                //to set border
                if (this.model.height != 0) this._setHeight(this.model.height);
                else {                       
                    $("li.e-ham-wrap").css({"height":this.element.find("li.e-list").first().height()});
                }
                //button click event
                this._on(this.element.find("li.e-ham-wrap"), "click", this._overflowOpen);                
            }
        },
        _addOverflowItems: function () {
            if ((this._ensureOverflowPopup()) && ($('.e-menu-popwrap').length>0)) {
				if(!ej.isNullOrUndefined(this.popupWrapper)){
					this.popupWrapper.empty();
					this._menuCloneItems.length = 0;                
					for (var i = 0; i < this._menuOverflowItems.length; i++) {
						this._menuCloneItems.push($(this._menuOverflowItems[i]).clone(true));                    
					}
					this.ulTag = ej.buildTag("ul");
					this.ulTag.addClass("e-menu e-js e-responsive e-widget e-box e-vertical");
					this.popupWrapper.append(this.ulTag);
					for (var i = 0; i < this._menuCloneItems.length; i++) {
						if ($(this._menuCloneItems[i]).hasClass('e-haschild')) {
							$(this._menuCloneItems[i]).find('span.e-icon').removeClass('e-arrowhead-down e-arrowhead-right').addClass('e-arrowhead-down');
							$(this._menuCloneItems[i]).children('span.e-menu-arrow.e-menu-left').remove();                       
						}
						this.ulTag.append(this._menuCloneItems[i]);
					}
					$(this.ulTag).children("li").removeClass("e-menu-hide");
					//to set width of ULTag          
					var popupWidth = Math.round(this.popupWrapper.width());
					if (popupWidth>0) {
						var popupWrapperWidth = this.popupWrapper.innerWidth();
						this.popupWrapper.find("ul.e-menu").css({ "width":popupWrapperWidth+ "px" });                
					}
					//to set the separator                  
					if (this.model.enableSeparator) this._setSeparator(true);                    
				}
            }         
        },
        _overflowOpen: function (e) {           
            if(this._isOverflowPopupOpen ()){   
                //set popup wrapper left position 
                 var location = ej.util.getOffset(this.element);
					var left = location.left + (this.model.enableRTL? 0 :(this.element.outerWidth() - this.popupWrapper.outerWidth()));
					var top = location.top + this.element.outerHeight();
					
					if(this.wrapper.parent().length && (this.wrapper.parent().css("position") == "absolute" || this.wrapper.parent().css("position") == "relative"))
					{
						location = ej.util.getOffset(this.wrapper.parent());
						left = left-location.left;
						top = top-location.top;
					}						
					this.popupWrapper.css({ "left": left,"top":top});                          
                this.popupWrapper.show();                                
                this._trigger("overflowOpen",  {e:e});
            }
            else {
                this._overflowClose(e);
            }
        },           
        _overflowClose: function (e) {
            if(this._ensureOverflowPopup() && !ej.isNullOrUndefined(this.popupWrapper)){            
                this.popupWrapper.find("li.e-list").removeClass(".e-mhover.e-active.e-mfocused");
                this._hideAnimation(this.popupWrapper.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
                this.popupWrapper.hide();                               
                this._trigger("overflowClose", { e: e });
            }
        },
        _isOverflowPopupOpen: function () {
		       if($(this.popupWrapper).length>0)
            return this.popupWrapper.css("display")=="none";           
        },
        _removePopup:function(e){
            if(($(window).width()<767)&& (this.model.isResponsive)){
			        this._ensureResponsiveClasses($(window).width());
                if ((this.element.find("li.e-ham-wrap").length > 0) && (this.popupWrapper.length>0)){
                    this.element.find("li.e-ham-wrap").remove();
                    $('.e-menu-popwrap').remove();                   
                    this.element.find("li.e-list").addClass("e-menu-show");             
                }
            }          
        },      
        _mobileResponsiveMenu:function(e){            
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && ((this.element.css("display")=="none"))) {
                    this.element.removeClass("e-res-hide").addClass("e-res-show");                 
                }
            else if((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && (!(this.element.css("display")=="none")))
                {
                    this.element.removeClass("e-res-show").addClass("e-res-hide");                    
                }          
        },
        _ensureOverflowPopup:function(e){
            return (this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && ($(window).width() >= 768) && (this.model.isResponsive);                
        },
        _onResize:function(e){
			this.element.find("li.e-ham-wrap").hide(); 
            $(window).width()>=768 ? this._calculateOverflowItems() : this._removePopup();
        },
        _ensureResponsiveClasses:function(viewport){
            if (viewport && this.element.find("span.e-icon").hasClass("e-arrowhead-right") ) this.element.find("span.e-icon.e-arrowhead-right").removeClass('e-arrowhead-right').addClass('e-arrowhead-down');            
        },

        _responsiveLayout: function () {
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) {
                this.wrapper.addClass("e-menu-responsive");
                this.element.addClass("e-menu-responsive")
                this.resWrap = ej.buildTag('span.e-menu-res-wrap e-menu-responsive');
                this.inResWrap = ej.buildTag('span.e-in-wrap e-box e-menu-res-in-wrap');
                this.label = ej.buildTag('span.e-res-title').html(this.model.locale == "en-US" ? this.model.titleText : (ej.Menu.Locale[this.model.locale] && ej.Menu.Locale[this.model.locale].titleText)?ej.Menu.Locale[this.model.locale].titleText:this.model.titleText);
                this.check = ej.buildTag('span.e-check-wrap e-icon');
                this.wrapper.append(this.resWrap)
                this.resWrap.append(this.inResWrap);
                this.inResWrap.append(this.label).append(this.check);
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },

        _oncheck: function (e) {
            var obj = this.element.parents('.e-menu-wrap').children('.e-menu');
            e.isChecked ? obj.removeClass('e-res-hide').addClass('e-res-show') : obj.removeClass('e-res-show').addClass('e-res-hide');
        },
        _addClass : function (){
            //Adding arrows to items with sub items
            this.element.find('li:has("> ul")').find('> a,> span').addClass('aschild');
            this.element.find('>li').addClass('e-list').attr({ "role": "menuitem" });
			this.element.find('li').find(">a, >span").addClass('e-menulink');
            var list = this.element.find('.e-list a.aschild');
            var spanlist = this.element.find('.e-list span.aschild');
            var listElement, spanElement;
            for ( var i = 0; i < list.length; i++) {
                listElement = $(list[i]);
                listElement.siblings().attr({ "aria-hidden": true });
                listElement.parent().attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                listElement.siblings('ul').children('li').addClass('e-list').attr("role", "menuitem");
            }
            for ( var i = 0; i < spanlist.length; i++) {
                spanElement = $(spanlist[i]);
                spanElement.siblings().attr({ "aria-hidden": true });
                spanElement.parent().attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                spanElement.siblings('ul').children('li').addClass('e-list').attr("role", "menuitem");
            }
        },
		_renderArrow : function(){
			 if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) {
				if( $($(this.element).find("span.e-menu-arrow")).length == 0){
					var arrow = ej.buildTag("span.e-menu-arrow e-menu-left");
					$(arrow).append("<span class='e-arrowMenuOuter'></span>").append("<span class='e-arrowMenuInner'></span>");
					this.element.find('>li.e-list.e-haschild').append(arrow);
				}
			 }
		},
        _generateTemplate: function (data) {
            var proxy = this, queryPromise;
            if (data instanceof ej.DataManager) {
                queryPromise = data.executeQuery(this._columnToSelect(this.model.fields));
                queryPromise.done(function (e) {
                    proxy._odataFlag = true;
                    proxy._generateItemTemplate(e.result);
                    proxy._wireEvents("_on");
                });
            } else {
                proxy._odataFlag = false;
                this._generateItemTemplate(proxy.model.fields['dataSource']);
                this._wireEvents("_on");
            }
        },

        _generateItemTemplate: function (items) {
            for (var i = 0; i < items.length; i++) {
                if ((items[i][this.model.fields.parentId] == null) || (items[i][this.model.fields.parentId] == 0)) {
                    var subItem = this._menuTemplate(items[i], items, this.model.fields);
                    this.element.append(subItem);
                }
            }
        },

        _menuTemplate: function (item, tableData, mapper) {
            var liTag, aTag, imgTag, spanTag;
            liTag = $(document.createElement('li'));
            liTag.attr("class", 'e-list');
            if (item[mapper.htmlAttribute]) this._setAttributes(item[mapper.htmlAttribute], liTag);
			aTag = $(document.createElement('a'));
			aTag.attr("class", 'e-menulink');
			if (item[mapper.imageUrl] && item[mapper.imageUrl] != "") {
				imgTag = $(document.createElement('img'));
				imgTag.attr('src', item[mapper.imageUrl]);
				if (item[mapper.imageAttribute]) this._setAttributes(item[mapper.imageAttribute], imgTag);
				aTag.append(imgTag);
			}
			else if (item[mapper.spriteCssClass] && item[mapper.spriteCssClass] != "") {
				spanTag = $(document.createElement('span'));
				spanTag.addClass(item[mapper.spriteCssClass]);
				aTag.append(spanTag);
			}
			aTag.append(item[mapper.text]);
			if (item[mapper.linkAttribute]) this._setAttributes(item[mapper.linkAttribute], aTag);
			if (item[mapper.url])
				aTag.attr('href', item[mapper.url]);
			liTag.append(aTag);
            if (item[mapper.id]) {
                liTag.prop("id", item[mapper.id]);
            }
            if (!ej.isNullOrUndefined(mapper["child"])) {
                this._odataFlag = true;
                if (mapper["child"]["dataSource"] instanceof ej.DataManager) {
                    var proxy = this, queryManager = ej.Query();
					$(liTag).attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                    queryManager = this._columnToSelect(mapper["child"]);
                    queryManager.where(mapper["child"]["parentId"], ej.FilterOperators.equal, item[mapper.id]);
                    var queryPromise = mapper["child"]["dataSource"].executeQuery(queryManager);
                    queryPromise.done(function (e) {
                        var childItems = e.result;
                        if (childItems && childItems.length > 0) {
                            var ul = $(document.createElement('ul'));
                            for (var i = 0; i < childItems.length; i++) {
                                var liItem = proxy._menuTemplate(childItems[i], mapper["child"]["dataSource"], mapper["child"]);
                                ul.append(liItem);
                            }
                            liTag.append(ul);
                            $(liTag).children('a').addClass('aschild');
                            if ($(liTag).parent().hasClass('e-menu') && (proxy.model.showRootLevelArrows))
                                $(liTag).children('a.aschild').append($('<span>').addClass("e-icon e-arrowhead-down")).addClass("e-arrow-space");
                            else if (proxy.model.showSubLevelArrows)
                                $(liTag).children('a.aschild').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
                        }
                    });
                    queryPromise.then(function (e) {
                        proxy._renderArrow();
                    });
                }
                else {
					var childItems;
					if(!ej.isNullOrUndefined(item.child)){
						if(ej.isPlainObject(item.child))
							childItems = ej.DataManager(mapper["child"]["dataSource"]).executeLocal(ej.Query().where(mapper["child"]["parentId"], ej.FilterOperators.equal, item[mapper.id]));
						else if(item.child instanceof Array)
							childItems =  item.child;
					}	
                    if (childItems && childItems.length > 0) {
                        var ul = $(document.createElement('ul'));
                        for (var i = 0; i < childItems.length; i++) {
                            var liItem = this._menuTemplate(childItems[i], mapper["child"]["dataSource"], mapper["child"]);
                            ul.append(liItem);
                        }
                        liTag.append(ul);
                    }
                }
            }
            else if (!this._odataFlag) {
                var childItems = ej.DataManager(mapper["dataSource"]).executeLocal(ej.Query().where(mapper["parentId"], ej.FilterOperators.equal, item[mapper.id]));
                if (childItems && childItems.length > 0) {
                    var ul = ej.buildTag('ul');
                    for (var i = 0; i < childItems.length; i++) {
                        var liItem = this._menuTemplate(childItems[i], mapper["dataSource"], mapper);
                        ul.append(liItem);
                    }
                    liTag.append(ul);
                }
            }
            return liTag;
        },

        _setAttributes: function (data, element) {
            for (var key in data) {
                if (key == "class")
                    element.addClass(data[key]);
                else
                    element.attr(key, data[key]);
            }
        },

        _addArrow: function (topArrows, bottomArrows) {
            if (topArrows) {
				var arrowIcon = (this.model.orientation == "horizontal") ? "e-arrowhead-down" : "e-arrowhead-right";
				this.element.find('>li.e-list:has("> ul")').children('a').append($('<span>').addClass("e-icon "+arrowIcon)).addClass("e-arrow-space");
			}
            else {
                this.element.find('>li.e-list:has("> ul")').children('a').removeClass("e-arrow-space").children('span.e-icon').remove();
            }

            if (bottomArrows)
                this.element.find('>li.e-list > ul li.e-list:has(>ul)').children('a').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
            else {
                this.element.find('>li.e-list > ul li.e-list:has(>ul)').children('a').removeClass("e-arrow-space").children('span.e-icon').remove();
            }

        },

        _intializeMenu: function () {
            if (this.model.height != 0) this._setHeight(this.model.height);
            if (this.model.width != 0) this._setWidth(this.model.width);
            if (this.model.menuType == "contextmenu")
                this.model.openOnClick = false;
            if (this.model.openOnClick) {
                this._hoverOpen = false;
                this._hoverClose = false;
            }
        },

        _setOrientation: function (val) {
            if (val == "horizontal") {
                this.element.removeClass("e-vertical e-horizontal").addClass("e-horizontal");
            } else {
                this.element.removeClass("e-horizontal e-vertical").addClass("e-vertical");
            }
            if (val == "vertical") {
                this._removePopup();
            }
        },

        _setHeight: function (value) {
            if (this.model.orientation == "horizontal" && value !=="auto") {
                value = typeof value === "number" ? value + "px" : value;
                this.element.find('> li').find('>a:first').css("line-height", value);
                if (this.model.showRootLevelArrows)
                    this.element.find('> li').find('>a:first').find('> span:first').css({ "line-height": value, "top": "0px" })
                if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")){
                    if ($("li.e-ham-wrap").length > 0) {                        
                        this.element.find("li.e-ham-wrap").children("div").css({ "line-height": value });
                        this.element.find("li.e-ham-wrap").css({ "height": value });
                        if($(".e-menu-popwrap").length>0)
                        this.popupWrapper.find("a.e-menulink").css({ "line-height":value });                        
                    }
                }
            }
            else
                this.element.height(value);
        },

        _setWidth: function (value) {
            this.element.css("width", value);
            if (this.model.orientation === "horizontal" && value !== "auto") {
                if (this.model.isResponsive)
                    this.resWrap.css("width", value);
            }
            if (this.model.orientation == "horizontal" &&  ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) ) {
                this._calculateOverflowItems();
            }
            
        },        
        _setOverflowDimensions:function(property,value){
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical"))
                value = typeof value == "number" ? value + "px" : value;
                if (property == "height") this.popupWrapper.css({ height: value });
                else if (property == "width") this.popupWrapper.css({ width: value });                           
                this._addOverflowItems();
        },

        _setRTL: function (isRTL) {
            if (isRTL) {
                this.element.removeClass("e-rtl").addClass("e-rtl");
            } else {
                this.element.removeClass("e-rtl");
            }
            if (isRTL && this.model.orientation === "horizontal")
                this.wrapper.removeClass("e-menu-rtl").addClass("e-menu-rtl");
            else
                this.wrapper.removeClass("e-menu-rtl");
			this.model.subMenuDirection = isRTL ? "left" : "right";
        },

        _setSubMenuDirection: function (direction) {
            if (direction != "left" && direction != "right")
                this.model.subMenuDirection = this.model.enableRTL ? "left" : "right";
        },

        _setAnimation: function (value) {
            value === "none" ? (this._showAnim = "none", this._hideAnim = "none") : (this._showAnim = "slideDown", this._hideAnim = "slideUp");
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _centerAlign: function (enableCenterAlign) {
            if (this.model.orientation == "horizontal" && enableCenterAlign)
                this.element.css('text-align', 'center');
            else
                this.element.css('text-align', 'inherit');
        },
        _columnToSelect: function (mapper) {
            var column = [], queryManager = ej.Query();
            if (ej.isNullOrUndefined(mapper.query)) {
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "child" && col !== "dataSource" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.fields["dataSource"].dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else
                queryManager = mapper.query;
            return queryManager;
        },


        _max_zindex: function () {
            var parents, bodyEle, maxZ;
            if (this.model.menuType == "contextmenu") {
                parents = $(this._targetElement).parents();
                parents.push(this._targetElement);
            }
            else
                parents = $(this.element).parents();
            bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;

        },

        _recursiveFunction: function (items, menuText) {
            var context = this;
            var isFound = false;
            $.each(items, function (key, value) {
                if (value.Text == menuText) {
                    context.selectedItem = value;
                    isFound = true;
                    return false;
                }
                else if (value.ChildItems != null) {
                    context._recursiveFunction(value.ChildItems, menuText);
                }
                if (isFound)
                    return false;
            });
        },

        _contextMenu_Template: function () {
            if(this.element[0].id !="")
            var oldWrapper = $(".e-menu-wrap #" + this.element[0].id).get(0);
            if (oldWrapper)
                $(oldWrapper.parentElement).remove();
            this.model.orientation = "vertical";
            this.element.addClass(this.model.cssClass + " e-context");
			 this.element.css("display", "none");
            this._referenceElement = this.element.parent();
            $("body").append(this.element);
            this.wrapper.insertBefore(this.element);
            this.wrapper.append(this.element);
        },

        _closeMenu: function () {
            this._hideAnimation(this.element.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
        },

        _onMenuIntent: function (element, obj, canOpen) {
            obj._delayMenuHover = window.setTimeout(function () {
                if (obj._mouseOver == true && canOpen) {
                    var showanim = obj._showAnim;
                    var hideanim = obj._hideAnim;
                    var showSpeed = obj._showSpeed;
                    var hideSpeed = obj._hideSpeed;
                    obj._show(element, showanim, hideanim);
                }
            }, this._showSpeed);
        },

        _onHide: function (element, obj, canHide) {
            obj._delaySubMenuHover = window.setTimeout(function () {
                if (obj._mouseOver == false && canHide) {
                    var id = obj._id;
                    var hideanim = obj._hideAnim;
                    var hideSpeed = obj._hideSpeed;
                    obj._closeAll();
                }

            }, obj._hideSpeed);
        },

        _subMenuPos: function (element, direction) {
            var pos = $(element).offset();
            var subMenuLeft, subMenuRight ;
            var posLeft = pos.left;
            var subMenu = $('ul:first', element);
            var menuWidth = $(element).outerWidth();
            if (pos == null || pos == undefined)
                return false;
            var submenuWidth = subMenu.outerWidth() + 1; // +1 for the space between menu and submenu
            var left = this.model.container ? $(this.model.container).width() + $(document).scrollLeft() : document.documentElement.clientWidth + $(document).scrollLeft();
            if (this.model.menuType == "normalmenu") {
                if ($(element.parentNode).is(this.element)) {
                    if (this.model.orientation == "horizontal"){
                        subMenu.css("top", $(element).outerHeight() + "px");
                        if (!this.model.enableRTL) {
                            subMenuLeft = (left < (posLeft + submenuWidth)) ? ((posLeft + submenuWidth) - left) : 1;
                            subMenu.css("left", (subMenuLeft *(-1)) + "px");
                        }
                        else {
                            subMenuRight = (((posLeft + menuWidth) - submenuWidth) < 0) ? ((posLeft + menuWidth) - submenuWidth) : 1;
                            subMenu.css({ "left": "auto", "right": subMenuRight + "px" });
                        }
                    }
                    else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth &&  posLeft > submenuWidth))
                        subMenu.css("left", -(submenuWidth + 4) + "px");
                    else {
                        subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                    }
                } else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth &&  posLeft > submenuWidth)) {
                    subMenu.css("left", -(submenuWidth + 4) + "px");
                }
                else {
                    subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                    var submenuHeight = subMenu.outerHeight();
                    var winHeight = $(window).height();
                    var submenuTop = (winHeight - (pos.top - $(window).scrollTop()));
                    if (winHeight < submenuHeight) {
					     var menuPos = pos.top - $(window).scrollTop();
						subMenu.css("top", -(menuPos) + 4 + "px");
					}
                    else if (submenuTop < submenuHeight) {
                        var menuPos = submenuTop - submenuHeight;
						subMenu.css("top", menuPos - 2 + "px");
					}
					else subMenu.css("top", "");
				}
            }
            else {
                left -= (pos.left + (2 * submenuWidth) + 4);
                if (left < 0) {
                    var menuLeftPos = (submenuWidth == null) ? "-206.5px" : "-" + (submenuWidth + 5) + "px";
                    subMenu.css("left", menuLeftPos);
                }
                else {
                    if (subMenu.parent('li.e-list').parent('ul').width() && direction == "right") {
                        subMenu.css("left", (subMenu.parent('li.e-list').parent('ul').width() + 4) + "px");
                    }
                    else if (pos.left > submenuWidth)
                        subMenu.css("left", -(submenuWidth + 4) + "px");
                }
                var submenuHeight = subMenu.outerHeight();
                if ((pos.top + submenuHeight > $(window).height())) {
                    var top = -(submenuHeight) + $(element).outerHeight();
                    if (submenuHeight > (pos.top + ($(element).outerHeight() / 2))) {
                        subMenu.css("top", -(submenuHeight / 2) + "px");
                    }
                    else
                        subMenu.css("top", top + "px");
                }
                else
                    subMenu.css("top","0px");
            }
        },


        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin + " e-menu-wrap");
        },

        _setSeparator: function (separator) {
            if (separator){
                this.element.addClass("e-separator");
                if ($('.e-menu-popwrap').length>0 && !ej.isNullOrUndefined(this.ulTag))
                    this.ulTag.addClass("e-separator");     
            }
            else this.element.removeClass("e-separator");
        },

        _contextMenuEvents: function (action) {
            this[action]($(this.model.contextMenuTarget), "mouseup taphold", this._ContextMenuHandler);
            this[action](this.element, "contextmenu", this._onDefaultPreventer);
            this[action]($(this.model.contextMenuTarget), "contextmenu", this._onDefaultPreventer);
            this[action]($(document), "mousedown", this._onContextClose);
        },

        _show: function (element, showanim, hideanim) {
            var siblingElement;
            var sibling = $('> ul', element);
			var zIndex = this._max_zindex();
            sibling.attr({ "aria-hidden": false });
            this._hideAnimation($(element).siblings().find(' > ul:visible'), hideanim);
            if (!($.inArray(this._disabledMenuItems, element) > -1)) {
                if (sibling.css('display') != "none") {
                    siblingElement = this.model.openOnClick ? $(sibling) : sibling.children().find('> ul');
                    this._hideAnimation(siblingElement, hideanim);
                }
                else $('> ul', element).children().find('> ul').hide();
                this._subMenuPos(element, this.model.subMenuDirection);
                sibling.css({ "z-index": zIndex + 1 });
				$(element).children('span.e-menu-arrow').css({"z-index": zIndex + 2 });
                if ($('> ul', element).css('display') != 'block' && !$(element).hasClass("e-disable-item")) {
                    this._showAnimation(sibling, showanim);
                    sibling.closest('li').addClass('e-active e-mfocused');
                }
                if ($(element).siblings("li.e-active").length > 0)
                    $(element).siblings("li.e-active").removeClass("e-active e-mfocused");
            }
        },

        _closeAll: function () {
            this._hideAnimation(this.element.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
            this._hideAnimation(this.element.find('> ul:visible'), this._hideAnim);
        },

        _showAnimation: function (element, anim) {
            switch (anim) {
                case "slideDown":
                    element.slideDown(this.model.enableAnimation ? 200 : 0); break;
                case "none":
                    element.css("display", "block"); break;
            }
        },

        _hideAnimation: function (element, anim) {
            switch (anim) {
                case "slideUp":
                    $(element).attr({ "aria-hidden": true });
                    element.slideUp(this.model.enableAnimation ? 100 : 0); break;
                case "none":
                    element.css("display", "none"); break;
            }
            element.closest('li').removeClass('e-active e-mfocused');
        },

        _removeValue: function (text, disableList) {
            var $browInfo = ej.browserInfo(), elementText;
            $browInfo.version === "8.0" && $browInfo.name === "msie" ? elementText = text[0].outerText : elementText = text[0].textContent;
            var count = $(disableList).length, i = 0;
            var childEle = $(disableList).children('a').length == 0 ? $(disableList).children('span') : $(disableList).children('a');
            while (i <= count) {
                if ($(childEle[i]).text() === elementText)
                    return i;
                i++;
            }
        },

        _createSubLevelItem: function (target, element) {
            var ulTag;
            ulTag = $(document.createElement('ul'));
            ulTag.append(element);
            target.append(ulTag);
            target.attr({ 'role': 'menu', 'aria-haspopup': 'true' });
            target.addClass("e-haschild");
            this.element.find('li:has("> ul")').find('> a,>span').addClass('aschild e-arrow-space');
            this._insertArrows(ulTag);
        },

        _insertArrows: function (ulTag) {
            if (this.model.showRootLevelArrows)
                ulTag.find('>a,>span').append($('<span>').addClass("e-icon e-arrowhead-down")).addClass("e-arrow-space");
            else
                ulTag.find('>a,>span').removeClass("e-arrow-space").find('>span.e-icon').remove();

            if (this.model.showSubLevelArrows)
                ulTag.parent('li.e-list:has(>ul)').children('a,span').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
            else
                ulTag.parent('li.e-list:has(>ul)').children('a,span').removeClass("e-arrow-space").find('>span.e-icon').remove();
        },

        _createMenuItem: function (item) {
            var liTag, aTag, imgTag, spanTag;
            liTag = $(document.createElement('li'));
            liTag.attr({ "class": 'e-list', "role": "menuitem" });
            if (item["htmlAttribute"]) this._setAttributes(item["htmlAttribute"], liTag);
            if (item["text"] && item["text"] != "") {
                aTag = $(document.createElement('a'));
				aTag.attr({ "class": 'e-menulink'});
                if (item["imageUrl"] && item["imageUrl"] != "") {
                    imgTag = $(document.createElement('img'));
                    imgTag.attr('src', item["imageUrl"]);
                    if (item["imageAttribute"]) this._setAttributes(item["imageAttribute"], imgTag);
                    aTag.append(imgTag);
                }
                else if (item["spriteCssClass"] && item["spriteCssClass"] != "") {
                    spanTag = $(document.createElement('span'));
                    spanTag.addClass(item["spriteCssClass"]);
                    aTag.append(spanTag);
                }
                aTag.append(item["text"]);
                if (item["linkAttribute"]) this._setAttributes(item["linkAttribute"], aTag);
                if (item["url"])
                    aTag.attr('href', item["url"]);
                liTag.append(aTag);
            }
            if (item["id"]) {
                liTag.prop("id", item["id"]);
            }
            if (!this.model.enabled)
                liTag.addClass("e-disable-item");
            return liTag;
        },

        _insertNode: function (itemCollection, targetNode, operation) {
            var item = 0, targetList = 0, target = 0, targetCollection = [];
            if ($(targetNode).is(this.element))
                targetCollection.push(this.element);
            else
                typeof (targetNode) === "string" ? targetCollection.push(this.element.find(targetNode)) : typeof (targetNode) === "undefined" ? targetCollection.push(this.element) : targetCollection.push(targetNode);
            for (targetList = 0; targetList < targetCollection.length; targetList++) {
                for (target = 0; target < targetCollection[targetList].length; target++)
                    for (item = 0; item < itemCollection.length && !ej.isNullOrUndefined(itemCollection[item]) ; item++)
                        this._addItem(itemCollection[item], targetCollection[targetList][target], operation);
            }
        },

        _addItem: function (item, target, operation) {
            var element, targetElement;
            this._wireEvents("_off");
            element = this._createMenuItem(item);
            target = target === "default" ? $("#" + item["parentId"]) : $(target);
            switch (operation) {
                case "insert":
                    $(target).is(this.element) ? targetElement = target : targetElement = target.children('ul');
                    targetElement.length != 0 ? targetElement.append(element) : this._createSubLevelItem(target, element);
                    break;
                case "insertBefore":
                    if (!$(target).is(this.element))
                        element.insertBefore(target);
                    else
                        target.prepend(element);
                    break;
                case "insertAfter":
                    if (!$(target).is(this.element))
                        element.insertAfter(target);
                    else
                        target.append(element);
                    break;
            }
            this._wireEvents("_on");
        },

        _removeItem: function (item) {
            if (item.siblings('li').length == 0) {
                item.closest("ul").siblings('a.aschild').removeClass("aschild e-arrow-space").children('span.e-icon').remove();
                !item.closest("ul").hasClass("e-menu") ? item.closest("ul").remove() : item.remove();
            }
            else
                item.remove();
        },

        _hiddenElement: function (ele) {
            if (ele.length > 0 && ($.inArray(ele[0], this._hiddenMenuItems) == -1)) {
                ele.addClass("e-hidden-item");
                this._hiddenMenuItems.push(ele[0]);
            }
        },

        _showElement: function (ele) {
            if (ele.length > 0 && ($.inArray(ele[0], this._hiddenMenuItems) > -1)) {
                ele.removeClass("e-hidden-item");
                this._hiddenMenuItems.splice(this._hiddenMenuItems.indexOf(ele[0]), 1);
            }
        },

        _getNodeByID: function (node) {
            (typeof node != "object" && node != "") && (node = this.element.find(".e-list" + node));
            return $(node);
        },

        _processItems: function (node, bool) {
            var ele = this._getNodeByID(node);
            for (var i = 0; i < ele.length; i++) bool ? this._showElement($(ele[i])) : this._hiddenElement($(ele[i]));
        },

        insert: function (item, target) {
            this._insertNode(item, target, "insert");
        },

        insertBefore: function (item, target) {
            this._insertNode(item, target, "insertBefore");
        },

        insertAfter: function (item, target) {
            this._insertNode(item, target, "insertAfter");
        },

        remove: function (targetCollection) {
            var target = 0, innerTarget = 0;
            for (target = 0; target < targetCollection.length; target++) {
                targetCollection[target] = typeof (targetCollection[target]) === "string" ? (this.element.find(targetCollection[target])) : targetCollection[target];
                for (innerTarget = 0; innerTarget < targetCollection[target].length; innerTarget++)
                    (targetCollection[target][innerTarget].tagName === "LI" || targetCollection[target][innerTarget].tagName === "UL") ? this._removeItem($(targetCollection[target][innerTarget])) : targetCollection[target][innerTarget].remove();
            }
        },

        showContextMenu: function (locationX, locationY, targetElement, e, update) {
            this._closeMenu();
            this._eventArgs = e;
            if (!ej.isNullOrUndefined(e) && this._checkForExclusion(e.target)) return;
            if (this._trigger("beforeOpen", { target: targetElement, events: e })) return false;
            if (this._preventContextOpen) {
                if (!ej.isNullOrUndefined(targetElement))
                    this._targetElement = targetElement;
                else if (!ej.isNullOrUndefined(target))
                    this._targetElement = target;
                else
                    this._targetElement = this.element;
                if (update) {
                    var position = this._calculateContextMenuPosition(e);
                    locationX = position.X;
                    locationY = position.Y;
                }
                this.element.css({ "left": locationX, "top": locationY });
                this.element.css({ "z-index": this._max_zindex() + 1 });
                this._showAnimation(this.element, this._showAnim);
                this._isContextMenuOpen = true;
                this.element.focus();

                this._trigger("open", { target: targetElement });
                this._on(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
            }
            return false;
        },

        _checkForExclusion: function (e) {
            if (!ej.isNullOrUndefined(this.model.excludeTarget)) {
                var excludeTargets = this.model.excludeTarget.split(",");
                for (var target = 0; target < excludeTargets.length; target++) {
                    if ($(e).closest(this.model.excludeTarget).is($.trim(excludeTargets[target])))
                        return true;
                }
            }
        },


        hideContextMenu: function (e) {
            this._closeMenu();
            this.element.find(".e-mhover").removeClass("e-mhover");
            this.element.find(".e-mfocused").removeClass("e-mfocused");
            this._hideAnimation(this.element, this._hideAnim);
            this._isContextMenuOpen = false;

            this._trigger("close", $.extend({ events: e }, e));
            this._off(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
        },


        disableItem: function (itemToDisable) {
            var isMenuItem = $(this.element.find('li.e-list >a ,li.e-list >span')).filter(function () { return $.trim($(this).text()) === itemToDisable; });
            if (isMenuItem.length > 0 && !($.inArray(isMenuItem.parent()[0], this._disabledMenuItems) > -1)) {
                isMenuItem.parent().addClass("e-disable-item").attr({ "aria-disabled": true });
                isMenuItem.parent().find('>a.aschild span.e-icon').addClass("e-disable");
                this._disabledMenuItems.push(isMenuItem.parent()[0]);
            }
        },


        disableItemByID: function (itemId) {
            if (itemId && itemId != "") {
                var itemToDisable = this.element.find("#" + itemId) ? this.element.find("#" + itemId)[0] : undefined;
                if (itemToDisable && !($.inArray(itemToDisable, this._disabledMenuItems) > -1)) {
                    $(itemToDisable).addClass("e-disable-item").attr({ "aria-disabled": true });
                    $(itemToDisable).find('>a.aschild span.e-icon').addClass("e-disable");
                    this._disabledMenuItems.push(itemToDisable);
                }
            }
        },

        getHiddenItems:function(){
            return this._hiddenMenuItems;
        },

        hideItems: function (node) {
            if (typeof node == "object" && node.length !== undefined) {
                for (var i = 0; i < node.length; i++) this._processItems(node[i], false);                
            }
            else this._processItems(node, false);
        },

        showItems:function(node){
            if (typeof node == "object" && node.length !== undefined) {
                for (var i = 0; i < node.length; i++) this._processItems(node[i], true);
            }
            else this._processItems(node, true);
        },

        enableItem: function (itemToEnable) {
            var isMenuItem = $(this.element.find('li.e-list >a ,li.e-list >span')).filter(function () { return $.trim($(this).text()) === itemToEnable; });
            if (isMenuItem.length > 0 && ($.inArray(isMenuItem.parent()[0], this._disabledMenuItems) > -1)) {
                isMenuItem.parent().removeClass("e-disable-item").attr({ "aria-disabled": false });
                isMenuItem.parent().find('>a.aschild span.e-icon').removeClass("e-disable");
                var index = this._removeValue(isMenuItem, this._disabledMenuItems);
                this._disabledMenuItems.splice(index, 1);
            }
        },


        enableItemByID: function (itemId) {
            if (itemId && itemId != "") {
                var itemToEnable = this.element.find("#" + itemId)[0];
                if (itemToEnable && ($.inArray(itemToEnable, this._disabledMenuItems) > -1)) {
                    $(itemToEnable).removeClass("e-disable-item").attr({ "aria-disabled": false });
                    $(itemToEnable).find('>a.aschild span.e-icon').removeClass("e-disable");
                    for (var i = this._disabledMenuItems.length - 1; i >= 0; i--) {
                        if (this._disabledMenuItems[i].id == itemId) {
                            this._disabledMenuItems.splice(i, 1);
                        }
                    }
                }
            }
        },


        disable: function () {
            this.model.enabled = false;
            var menuItemCollection = this.element.find('>li[class~=e-list]');
            var proxy = this;
            $.each(menuItemCollection, function (key, value) {
                if (!($.inArray(value, proxy._disabledMenuItems) > -1))
                {
                    $(value).addClass("e-disable-item").attr({ "aria-disabled": true });
                    $(value).find('>a.aschild span.e-icon').addClass("e-disable");
                    proxy._disabledMenuItems.push(value);
                }
                
            });
        },


        enable: function () {
            var proxy = this;
            this.model.enabled = true;
            var menuItemCollection = this.element.find('li.e-disable-item');
            $.each(menuItemCollection, function (key, value) {
                $(value).removeClass("e-disable-item").attr({ "aria-disabled": false });
                $(value).find('>a.aschild span.e-icon').removeClass("e-disable");
                proxy._disabledMenuItems.pop(value);
            });
        },

        show: function (locationX, locationY, targetElement, e) {
            if (!this.model.enabled) return false;
            if (this.model.menuType == "contextmenu")
                this.showContextMenu(locationX, locationY, targetElement, e, false);
            else
                this.element.css("display", "block");
        },

        hide: function (e) {
            if (!this.model.enabled) return false;
            if (this.model.menuType == "contextmenu")
                this.hideContextMenu(e);
            else {
                this._closeMenu();
                this.element.css("display", "none");
            }
        },

        _wireEvents: function (action) {
            this[action](this.element.find("li.e-list"), "mouseout", this._mouseOutHandler);
            this[action](this.element.find("li.e-list"), "mouseover", this._mouseOverHandler);
            this[action](this.element.children(), "click", this._onClickHandler); 
            this[action](this.element, "keydown", this._onKeyDownHandler);
            this[action](this.element, "focus", this._OnFocusHandler);
            this[action](this.element, "blur", this._OnFocusOutHandler);
            if (this.model.menuType == "contextmenu" && $(this.model.contextMenuTarget)[0] != null) {
                this._contextMenuEvents(action);
            }
            if (this.model.menuType != "contextmenu") {
                this[action]($(document), "click", this._onDocumentClick);
                this[action](this.element, "mousedown", this._onMouseDownHandler);
            }
            this[action]($(window),"resize", $.proxy(this._onResize, this));            
        },

        _mouseOverHandler: function (event) {
            var element, itemId = "";
            this.element.find(".e-mhover").removeClass("e-mhover");
            event.currentTarget = $(event.target).closest("li")[0];
            if (!$(event.currentTarget).hasClass('e-disable-item'))
                $(event.currentTarget).addClass("e-mhover");
            else this._isFocused = false;
            if (event.stopPropagation)
                event.stopPropagation();
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delaySubMenuHover);
            }
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delayMenuHover);
            }
            this._mouseOver = true;
            this._isMenuOpen = true;
            if ($(event.currentTarget.parentNode.parentNode).is(this.element)) {
                this._isSubMenuOpen = false;
            }
            else {
                this._isSubMenuOpen = true;
            }
            if (event.currentTarget.nodeName == "LI")
                element = event.currentTarget;
            else if (event.currentTarget.parentNode) {
                if (event.currentTarget.parentNode.nodeName == "LI")
                    element = event.currentTarget.parentNode;
                else
                    return false;
            }
            else {
                event.preventDefault();
                return false;
            }
            if (!$(event.currentTarget).hasClass('e-disable-item'))
                this._onMenuIntent(element, this, this._hoverOpen);
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "ID": itemId };

                this._trigger("mouseover", $.extend({ events: eventArgs }, eventArgs));
            }
        },

        _onMouseDownHandler: function (e) {
            if ($(e.target).hasClass('e-menu')) this._isFocused = false;
        },


        _mouseOutHandler: function (event) {
            var element, itemId = "";
            $(event.currentTarget).removeClass("e-mhover");
            if (event.stopPropagation)
                event.stopPropagation();
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delaySubMenuHover);
            }
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delayMenuHover);
            }
            this._mouseOver = false;
            this._isMenuOpen = false;

            if (event.currentTarget.nodeName == "LI")
                element = event.currentTarget;
            else if (event.currentTarget.parentNode) {
                if (event.currentTarget.parentNode.nodeName == "LI")
                    element = event.currentTarget.parentNode;
                else
                    return false;
            }
            else {
                event.preventDefault();
                return false;
            }
            this._onHide(element, this, this._hoverClose);
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "ID": itemId };

                this._trigger("mouseout", $.extend({ events: eventArgs }, eventArgs));
            }
        },

        _onClickHandler: function (event) {
            var element, itemId = "";
            this._isFocused = true;
            var openOnClickStart = false;
            if (!$(event.target).closest("li.e-list").hasClass('e-disable-item') && $(event.target).closest("li.e-list").length > 0) {
                element = $(event.target).closest("li.e-list")[0];
                if ($(element).is(this.element.find(">li.e-list")))
                    this._activeElement = element;
            }
            else {
                if ($(event.target).is(this.element))
                    this._activeElement = this.element.find(">li:first");
                return;
            }
            if ($(event.target).is("a") && $(element).find(">a,>span").hasClass('aschild') && this.model.openOnClick) {
                this._isFocused = false;
            }
            if (!this._hoverOpen && $(element).find(">a,>span").hasClass('aschild')) {
                this._show(element, this._showAnim, this._hideAnim);
                this._hoverOpen = false;
                openOnClickStart = true;
            }
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                //Check if Context Menu, then hide the context menu firing the events
                if (this.model.menuType == "contextmenu") {
                    if (this._isContextMenuOpen && !$(element).hasClass("e-haschild")) {
                        this._hideAnimation(this.element, this._hideAnim);
                        this._isContextMenuOpen = false;

                        this._trigger("close", $.extend({ events: event }, event));
						this._off(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
                    }
                }
                if (!openOnClickStart) {



                    if (!$(element).find(">a,>span").hasClass("aschild")) {
                        this._closeMenu();
                        if (this.model.openOnClick)
                            this._hoverOpen = false;
                    }
                }
                var menuText = $(element).children('a,span').text();
                var parent = $(element).closest("ul").parent("li");
                if (parent.length != 0) {
                    parentId = ej.isNullOrUndefined(parent.attr("id")) ? null : parent.attr("id");
                    parentText = parent.children('a,span').text();
                }
                else {
                    parentId = null;
                    parentText = null;
                }
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "selectedItem": this.selectedItem, "ID": itemId, "parentId": parentId, "parentText": parentText };
                this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                this.selectedItem = null;
                if (this.model.openOnClick && this.model.menuType != "contextmenu")
                    this.element.focus();
            }
        },


        _onKeyDownHandler: function (e) {
            if (this.model.menuType == "contextmenu" && !this._isContextMenuOpen) return;
            var element, focusEle, itemId = "", hoverElement = this.element.find(".e-mhover"), focusedElement = this.element.find(".e-mfocused"), currentElement;
            if (!$(hoverElement).length > 0 && $(this._activeElement).length > 0)
                hoverElement = focusedElement = $(this._activeElement);

            if (e.keyCode == 9) {
                this._isFocused = false;
                this._OnFocusOutHandler();
            }
            else if (e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
                e.preventDefault();

            if (e.keyCode == 40) {
                if (this.model.orientation == "horizontal") {
                    if (this.element.find(">li.e-mhover").children("ul").length > 0 || $(this._activeElement).length > 0) {
                        if ($(hoverElement).children("ul").css('display') === "none")
                            this._show(hoverElement[hoverElement.length - 1], this._showAnim, this._hideAnim);
                        hoverElement.removeClass("e-mhover e-mfocused").children("ul:first").find("li:first").addClass("e-mhover");
                        this._activeElement == null ? hoverElement.addClass("e-mfocused") : $(this._activeElement).addClass("e-mfocused");
                    } else {
                        liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        $(hoverElement[hoverElement.length-1]).removeClass("e-mfocused e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                        focusEle.addClass("e-mhover");
                    }
                }
                else if (this.model.orientation != "horizontal") {
                    if (hoverElement.length == 0) liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    else liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    hoverElement.removeClass("e-mfocused e-mfocused");
                    if (hoverElement.length > 0) {
                        hoverElement.removeClass("e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                    } else focusEle = liVisible.first();
                    focusEle.addClass("e-mhover");
                }
            }
            if (e.keyCode == 39) {
                if (this.model.orientation == "horizontal" && (this.element.find(">li.e-list").hasClass("e-mhover") || $(this._activeElement).length > 0)) {
                    hoverElement.removeClass("e-mfocused e-mhover");
                    liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                    focusEle.addClass("e-mhover");
                }
                else if ($(hoverElement).children("ul").length > 0) {
                    hoverElement.removeClass("e-mfocused e-mhover");
                    var firstChild = hoverElement.children("ul:first").find("li:first");
                    this._show(hoverElement[hoverElement.length - 1], this._showAnim, this._hideAnim);
                    liVisible = hoverElement.addClass('e-mfocused').children("ul:first").children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    focusEle = $(liVisible[liVisible.index(firstChild)]).length > 0 ? $(liVisible[liVisible.index(firstChild)]) : liVisible.first();
                    focusEle.addClass("e-mhover");
                }
                else if (hoverElement.children("ul").length <= 0) {
                    if (this.model.orientation == "horizontal" && hoverElement.parent().closest('.e-list').parent().hasClass('e-menu')) {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) + 1]) : $(liVisible[liVisible.index(focusedElement.first())]);
                        focusEle.addClass("e-mhover");
                    }
                }
            }

            if (e.keyCode == 38) {
                if (this.model.orientation == "horizontal") {
                    liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    hoverElement.removeClass("e-mfocused e-mhover");
                    focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                }
                else if (this.model.orientation != "horizontal") {
                    if (hoverElement.length == 0) liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    else liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    if (hoverElement.length > 0) {
                        hoverElement.removeClass("e-mfocused e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                    } else focusEle = liVisible.last();
                }
                focusEle.addClass("e-mhover");
            }

            if (e.keyCode == 37) {
                if (this.model.orientation == "horizontal") {
                    if (this.element.find(">li.e-list").hasClass("e-mhover") || $(this._activeElement).length > 0) {
                        hoverElement.removeClass("e-mfocused e-mhover");
                        liVisible = this.element.find('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                        focusEle.addClass("e-mhover");
                    }
                    else {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused e-active");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        if (hoverElement.parent().closest('.e-list').parent('.e-menu').length > 0)
                            focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) - 1]) : liVisible.last();
                        else
                            focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]) : liVisible.last();
                        focusEle.addClass("e-mhover");
                    }
                }
                else if (hoverElement.parent("ul.e-menu").length == 0 || (this.model.menuType == "contextmenu" && hoverElement.parent("ul.e-context").length == 0)) {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]) : $(liVisible[liVisible.index(focusedElement.last())]);
                        focusEle.addClass("e-mhover");
                }
            }
            if (e.keyCode == 13) {
                var menuText = $(hoverElement).children('a,span').text();
                itemId = !ej.isNullOrUndefined($(hoverElement)[0]) ? $(hoverElement)[0].id : "";
                var eventArgs = { "menuId": this.element[0].id, "text": menuText, "selectedItem": focusedElement, "ID": itemId };
                if (this.model.menuType == "contextmenu") {
                    if (this._isContextMenuOpen && hoverElement.length > 0 && !focusedElement.hasClass("e-disable-item")) {
                        if (this.model.click)
                            this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                        this.selectedItem = null;
                        this.hideContextMenu(e);
                    }
                } else {
                    if (hoverElement.length > 0 && !hoverElement.hasClass("e-disable-item")) {
                        if ($(hoverElement).find(">a,>span").hasClass('aschild') && $(hoverElement).children("ul").css('display') === "none") {
                            this._show(hoverElement[0], this._showAnim, this._hideAnim);
                            hoverElement.removeClass("e-mhover").children("ul:first").find("li:first").addClass("e-mhover");
                        }
                        else {
                            this.element.find(".e-mhover >a,.e-mhover >span ").focus();
                            this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                            this._closeAll();
                        }
                        if (ej.isNullOrUndefined($(hoverElement).find(">a").attr("href")))
                            this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                    }
                }
            }
            if (e.keyCode == 27) {
                if (this.model.menuType == "contextmenu")
                    this.hideContextMenu(e);
                else
					this.element.find("li.e-list").removeClass("e-mhover");
                    this.element.find('li.e-list:has("> ul")').find('> ul:visible').parents("li.e-list").addClass("e-mhover");
                    this._closeAll();
            }
            if ($(e.target).is(this.element) && e.target.parentNode) {
                if (hoverElement.length)
                    element = hoverElement;
            }
            else
                return false;
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();

                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                if (this.element.find('li.e-mfocused.e-mhover').length || e.keyCode == 13)
                    currentElement = (e.keyCode == 13) ? hoverElement : this.element.find('li.e-mfocused.e-mhover');
                var eventArgs = { "text": menuText, "element": element, "targetElement": currentElement , "event": e, "ID": itemId };

                this._trigger("keydown", $.extend({ events: eventArgs }, eventArgs));
            }
            this._activeElement = null; focusedElement = this.element.find(".e-mfocused");
        },

        _OnFocusHandler: function (event) {
            if (this.model.menuType != "contextmenu" && !this.element.find(">li:first").hasClass("e-disable-item") && this._isFocused && this.element.find(".e-mhover").length == 0 && $('li.e-ham-wrap').length ==0) {
                this.element.find(">li:first").addClass("e-mhover");
            }
            else this._isFocused = true;
            if (this.model.menuType != "contextmenu")
                this._activeElement = this.element.find(">li:first");
        },

        _OnFocusOutHandler: function () {
            if (!this._isFocused) {
                this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                this._closeAll();
            }
            this._isFocused = false;
        },

        _onDocumentClick: function (event) {
            if (this.model.openOnClick)
                this._hoverOpen = false;
            if (!$(event.target).parents("ul.e-menu").is(this.element)) {
                this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                this._closeAll();
                this._isFocused = true;
            }
            if ((!$(event.target).parents("ul.e-menu").is(this.popupWrapper)) && (!$(event.target).hasClass('e-ham-wrap')) && (!($(event.target).parent().hasClass('e-ham-wrap'))) && (!$(event.target).hasClass('e-hamburger')) && (!$(event.target).parent("li").hasClass("e-haschild")) && (!$(event.target).is('span.e-icon.e-arrowhead-down')) && !(this._isOverflowPopupOpen()) && this.model.menuType != "contextmenu" && $("li.e-ham-wrap").length > 0) {
                this._overflowClose();
            }           
        },


        _ContextMenuHandler: function (e) {
            var isRightClick = false;
            if (e.type == "taphold")
                isRightClick = true;
            else if (e.button)
                isRightClick = (e.button == 2);
            else if (e.which)
                isRightClick = (e.which == 3); //for Opera
            var targetElement = e.target;
            if (isRightClick) {
                var evt = e;
                if (e.type == "taphold") {
                    if (e.options.type == "touchstart") evt = e.options.touches[0];
                    else evt = e.options;
                }
                var showSpeed = this._showSpeed;
                this.showContextMenu(null, null, targetElement, evt, true);
            }
            else {
                if (this._isContextMenuOpen) {
                    var hideanim = this._hideAnim;
                    var hideSpeed = this._hideSpeed;
                    this.hideContextMenu(e, hideanim, hideSpeed);
                }
            }
        },

        _calculateContextMenuPosition: function (e) {
			this.element.attr("style","display:block;visibility:hidden");
            locationX = (e.clientX + this.element.width() < $(window).width()) ? e.pageX : e.pageX - this.element.width();
            locationY = (e.clientY + this.element.height() < $(window).height()) ? e.pageY : (e.clientY > this.element.height()) ? e.pageY - this.element.height() : $(window).height() - this.element.outerHeight();
            var bodyPos = $("body").css("position") != "static" ? $("body").offset() : { left: 0, top: 0 };
            locationX -= bodyPos.left, locationY -= bodyPos.top;
			this.element.attr("style","display:none;visibility:visible");
            return {
                X: locationX,
                Y: locationY
            };
        },


        _onDefaultPreventer: function (e) {
            e.preventDefault();
            e.stopPropagation();
            return false;
        },


        _onContextClose: function (e) {
            var proxy = this;
            if (this._isContextMenuOpen) {
                var isRightClick = false;
                if ($(e.target).is(this.element) || $(e.target).parents(".e-context").is(this.element))
                    isRightClick = true;
                if (!isRightClick) {
                    var hideanim = this._hideAnim;
                    var hideSpeed = this._hideSpeed;
                    this.hideContextMenu(e, hideanim, hideSpeed);
                    var parentElements = $(e.target).parents();
                    $.each(parentElements, function (index, value) {
                        if (value.id == proxy._ContextTargetId) {
                            return;
                        }
                    });

                }
            }
        }

    });

    ej.Menu.Locale = ej.Menu.Locale || {} ;
       
    ej.Menu.Locale['default'] = ej.Menu.Locale["en-US"] = {  	
        titleText: "Menu"
    };
    ej.MenuType = {
        /**  support for list of items appears as normal menu in horizontal or vertical direction. */
        NormalMenu: "normalmenu",
        /**  support for list of items appears as menu when right clicked on target area, thereby preventing browser’s default right click.. */
        ContextMenu: "contextmenu"
    };

    ej.Direction = {
        /**  support for Render sub menu popup in left direction. */
        Left: "left",
        /**  support for Render sub menu popup in Right direction. */
        Right: "right",
        /** Default opening direction of menu sub items */
        None: "none",
    };

    ej.AnimationType = {
        /**  support for disable the AnimationType while hover or click an menu items. */
        None: "none",
        /**  support for enable the AnimationType while hover or click an menu items. */
        Default: "default"
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {

    ej.widget("ejPager", "ej.Pager", {
        _rootCSS: "e-pager",
        validTags: ["div"],
        // default model
        defaults: {
            pageSize: 12,
            pageCount: 10,
            currentPage: 1,
            enableExternalMessage: false,
            externalMessage: "",
			pageSizeMessage: "",
            enableQueryString: false,
            locale: "en-US",
            masterObject: null,
            click: null,
            enableRTL: false,
            totalRecordsCount: null,
            totalPages: null,
            customText: "",
            showPageInfo: true,
			cssClass: "",
			enabled: true,
            showGoToPage: false,
            isResponsive: false
        },

        // constructor function
        _init: function () {
            this._initPrivateProperties();
            this.model.enableQueryString && this._queryStringValue();
            this.renderPager();
            if (this.model.isResponsive) this._reSizeHandler();
            this._wireResizing();
            this._wireEvents();
			this.refreshPager();
        },
        _initPrivateProperties: function () {
			if (this.model.pageSize.length > 0) this._pageSize = this.model.pageSize[0];
			else  this._pageSize = this.model.pageSize;
            this._links = [];
            this._$prev = null;
            this._$first = null;
            this._$PP = null;
            this._$NP = null;
            this._lastNP = false;
            this._lastpageCount = null;
            this._$last = null;
            this._$next = null;
            this._prevPageNo = null;
            this.localizedLabels = this._getLocalizedLabels();
			this._intervalWid = 0;
			this._msgWidth = 0;
			this._gotoWid = 0;
        },
        _wireEvents: function () {
			var proxy= this;
                this._on(this.element, "click", this._pagerClickHandler);
              //  $(document).on("mousedown", $.proxy(proxy.hidedrop, proxy));
        },
		_hidedrop: function() {
			if(this.$dropItem && this.$dropItem.css("display") != "none") this.$dropItem.hide();
		},
        _wireResizing: function () {
			this._refreshDropandTextItems();
		   $(window).bind('resize', (this.model.isResponsive)  ? $.proxy(this._reSizeHandler, this)  : $.proxy(this._unWireResizing, this));
        },
        _unWireResizing: function () {
			this._refreshDropandTextItems();
			if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
            $(window).unbind('resize', $.proxy(this._reSizeHandler, this));
        },
        _reSizeHandler: function () {
			if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
			controlwidth = this._intervalWid + this._gotoWid + this.element.find('.e-pagercontainer').outerWidth()+this._msgWidth;
			if (controlwidth > (this.element.outerWidth()-20)) {if (this._msgWidth > 0) this.element.find(".e-parentmsgbar").addClass("e-msg-res");}
			else if(this._msgWidth > 0) this.element.find(".e-parentmsgbar").removeClass("e-msg-res");
            if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
                this._flag = true;
                this._fillScreen();
            }
            if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() > 40) {                
                this.option("pageCount", this._maxPageCount);
                if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
                    this._flag = true;
                    this._fillScreen();
                }
            }
			this._refreshDropandTextItems();
        },
		_refreshDropandTextItems: function() {
			if(this.numTextbox) { 
				if (this.element.find('.e-pagercontainer').position().top != this.element.find(".e-parentmsgbar").position().top) {
					this.numTextbox.addClass("e-pager-goto-res"); }
				else this.numTextbox.removeClass("e-pager-goto-res");
			}
			if (this.pageInterval_wrap) {
				if (this.element.find('.e-pagercontainer').position().top != this.element.find(".e-pager-itemsinterval").position().top) {
					this.element.find(".e-pager-itemsinterval").addClass("e-pager-goto-res");
				}
				else this.element.find(".e-pager-itemsinterval").removeClass("e-pager-goto-res");
			}		
			
			
		},
        renderPager: function () {
            var $pagerContainer = ej.buildTag('div.e-pagercontainer', "", {}, { unselectable: "on" });
            this._renderPagerContainer($pagerContainer);
            this.element[0].appendChild($pagerContainer[0]);
            this._pageInfo();
           if (this.model.showGoToPage) this._renderTextboxItem();
			if (this.model.pageSize.length > 0) this._renderDropdownlist();
            this.model.enableExternalMessage && this._renderPagerMessage();
            if (this.model.enableRTL) this.element.addClass("e-rtl");
			if (!this.model.enabled) this._disable();
			this._cssClass = this.model.cssClass; this.element.addClass(this.model.cssClass);
        },
		_removeDropdownlist: function() {
			this.pageInterval_wrap.remove();
			this.$textspan = null;
			this.$dropItem = null;
		},
		_renderDropdownlist: function () {
			var proxy = this;
			this.pageInterval_wrap =  ej.buildTag('div.e-pager-itemsinterval', "", {}, { unselectable: "on" });
			var pageDrop_wrap =  ej.buildTag('div.e-drpdwndiv e-icon e-arrow-sans-down', "", {}, { unselectable: "on" });
		            this.$textspan = ej.buildTag('span.e-text');
		            this.sizeIntervals = this.model.pageSize;
					pageDrop_wrap.appendTo(this.pageInterval_wrap);
					
					this.pageInterval_wrap.appendTo(this.element);
					this.pageInterval_wrap.insertBefore(this._parentMsgBar);
					this.$textspan.appendTo(pageDrop_wrap);
					proxy.$textspan.text(this.model.pageSize[0]);
					this.$dropItem = ej.buildTag('ul.e-drpdwn e-ul');
					this._renderItems();
					this.$dropItem.appendTo(pageDrop_wrap);
					this._renderPageSizeMessage();
					pageDrop_wrap.on("click", function() {
					if (proxy.$dropItem.css("display") != "none") proxy.$dropItem.hide();
						else {if (proxy.model.enabled) proxy.$dropItem.show()};
					});
					this.$dropItem.hide();
					this.$dropItem.find("li").on("click", function () {
						 proxy.$dropItem.find("li.e-active").removeClass("e-active");
						 $(this).addClass("e-active")
						 proxy._pageSize = $(this).text();
						 proxy.$textspan.text($(this).text());
						 proxy.refreshPager();
						 proxy._trigger("pageSizeSelected", {pageSize:proxy._pageSize});
					});
				this._intervalWid = this.element.find('.e-pager-itemsinterval').outerWidth();
		},
		_renderPageSizeMessage: function () {
		    var msgwrapper = ej.buildTag('div.e-interval-msg');
		    msgwrapper.appendTo(this.pageInterval_wrap);
		    if (this.model.pageSizeMessage.toString().length)
		        msgwrapper.html(this.model.pageSizeMessage);
		    else
		        msgwrapper.hide();
		},
		_renderItems: function() {
				var proxy=this;
					$(this.model.pageSize).each(function() {
						li = ej.buildTag('li');
						li.text(this);
						proxy.$dropItem.append(li);
					});
					this.$dropItem.find("li").first().addClass("e-active");
		},
        _queryStringValue: function () {
            var results = new RegExp('[\\?&]page=([^&#]*)').exec(window.location.href);
            !results ? this.model.currentPage = 1 : this.model.currentPage = parseInt(results[1] || 1);
        },
        _renderPagerMessage: function () {
            var $messageDiv = ej.buildTag('div.e-pagermessage');
            if (this.model.externalMessage.toString().length)
                $messageDiv.html(this.model.externalMessage);
            else
                $messageDiv.hide();
            this.element.append($messageDiv);
        },
		_removePagerMessage: function() {
			this.element.find("div.e-pagermessage").remove();
		},
		_mouseScroll: function(event) {
		 var delta;		 
            if (event.keyCode == "38")
                this._updateField("increment");
            else if (event.keyCode == "40")
                this._updateField("decrement");
		},
		_updateField: function(operation) {
            var step = 1;
            if (this.numTextbox.val() == "") this.numTextbox.val(1);
            else if (this.numTextbox.val().indexOf(" ") >= 1)
                this.numTextbox.val(this._textBox.val().replace(" ", ""));
                this.model.currentPage = ej.parseFloat(this.numTextbox.val(), this.model.locale);
            if (isNaN(this.model.currentPage) && !this.model.currentPage) this.model.currentPage = 1;
            if (this.model.currentPage >= 1 && this.model.currentPage > this.model.totalPages) {
                this.model.currentPage = this.model.totalPages;
				this.numTextbox.val(this.model.currentPage);
            }
            else if (this.model.currentPage < 1 && this.model.currentPage <= this.model.totalPages) {
                this.model.currentPage = 1;
				this.numTextbox.val(this.model.currentPage);
            }
            else if (this.model.currentPage >= 1 && this.model.currentPage <= this.model.totalPages) {
                value = operation == "increment" ? this.model.currentPage + step : this.model.currentPage - step;
                if (value >= 1 && value <= this.model.totalPages) {
                    this.numTextbox.val(value);
					this.model.currentPage = value;
				}
            }
			this.refreshPager();
		},
        _renderTextboxItem: function () {
            proxy = this;
			var numInput = ej.buildTag("input#" + this.element[0].id + "_numtext", "", {}, { "type": "textbox" });
            $(numInput).appendTo(this._parentMsgBar).insertBefore($(this._parentMsgBar).find("span"));
            this.numTextbox = numInput;
			this.numTextbox.height(this.element.find('.e-pagercontainer .e-numericcontainer a').outerHeight());
			this.numTextbox.width(35);
			this.numTextbox.addClass('e-gototextbox e-textbox');
            if (!this.model.showGoToPage) this.numTextbox.hide();
			this._gotoWid = $(this.numTextbox).outerWidth();
			this._on($(this.numTextbox),'keydown', this._mouseScroll);
			this._on(this.numTextbox,'focusout', function(e) {
				e.currentTarget.value = parseInt(e.currentTarget.value);
				var regEx= /^[0-9]*$/;
				var flag = regEx.test(parseInt(e.currentTarget.value));
				if (!flag) {
					proxy.numTextbox.val(proxy.model.currentPage) 
				return false;
				}
				if (proxy.model.currentPage != parseInt(e.currentTarget.value)) {
				if (parseInt(e.currentTarget.value)> 1 && parseInt(e.currentTarget.value) <= proxy.model.totalPages) {
                   proxy.model.currentPage = parseInt(e.currentTarget.value);
                   proxy.refreshPager();
				}
				else proxy.numTextbox.val(this.model.currentPage);
				}
			});

        },
        _renderPagerContainer: function ($pagerContainer) {
            //Update pager styles here for next versions
            this._renderBackwardButton($pagerContainer);
            this._renderpreviousPager($pagerContainer);
            this._renderNumericItem($pagerContainer);
            this._renderForwardPager($pagerContainer);
            this._renderForwardButton($pagerContainer);
        },
        _renderMsgBar: function () {
            var $msgBar = ej.buildTag('span.e-pagermsg', String.format(this.localizedLabels.pagerInfo, this.model.currentPage, this.model.totalPages || 0, this.model.totalRecordsCount || 0));
            this._parentMsgBar.appendChild($msgBar[0]);
            this._parentMsgBar.style.textAlign = ej.TextAlign.Right;
        },
        _renderpreviousPager: function ($pagerContainer) {
            this._$PP = ej.buildTag('a.e-link e-nextprevitemdisabled e-disable e-spacing e-PP', "...", {}, { title: this.localizedLabels.previousPagerTooltip, role: "link" });
            $pagerContainer.append(this._$PP);
        },
        _renderForwardPager: function ($pagerContainer) {
            this._$NP = ej.buildTag('a.e-link e-NP e-numericitem e-spacing e-default', "...", {}, { title: this.localizedLabels.nextPagerTooltip, role: "link" });
            $pagerContainer.append(this._$NP);
        },
        _renderBackwardButton: function ($pagerContainer) {
            this._$first = ej.buildTag('div.e-firstpage e-icon e-mediaback  e-firstpagedisabled e-disable', "", {}, { unselectable: "on", title: this.localizedLabels.firstPageTooltip });
            this._$prev = ej.buildTag('div.e-prevpage e-icon e-arrowheadleft-2x  e-prevpagedisabled e-disable', "", {}, { unselectable: "on", title: this.localizedLabels.previousPageTooltip });
            $pagerContainer.append(this._$first);
            $pagerContainer.append(this._$prev);
        },
        _renderNumericItem: function ($pagerContainer) {
            var $numericContainer = ej.buildTag('div.e-numericcontainer e-default', "", {}, { unselectable: "on" });
            this._renderNumericLinks($numericContainer, this.model.pageCount);
            $pagerContainer.append($numericContainer);
            this._maxPageCount = this.model.pageCount;
        },
        _renderNumericLinks: function ($numericContainer) {
            $numericContainer.empty();
            this.model.pageCount = Math.round(this.model.pageCount);
            for (var page = 1; page <= this.model.pageCount; page++) {
                var $link = ej.buildTag('a.e-link', this.model.customText + page, {}, { role: "link" }).addClass("e-numericitem e-spacing e-default").data("index", page);
                if (page == this.model.currentPage)
                    $link.removeClass("e-default").addClass("e-currentitem e-active");
                $numericContainer.append($link);
            }
            this._links = $numericContainer.children();
        },
        _renderForwardButton: function ($pagerContainer) {
            this._$next = ej.buildTag('div.e-nextpage e-icon e-arrowheadright-2x  e-default', "", {}, { unselectable: "on", title: this.localizedLabels.nextPageTooltip });
            this._$last = ej.buildTag('div.e-lastpage e-icon e-mediaforward  e-default', "", {}, { unselectable: "on", title: this.localizedLabels.lastPageTooltip });
            $pagerContainer.append(this._$next);
            $pagerContainer.append(this._$last);

        },
		_setLocale: function () {
			this.localizedLabels = this._getLocalizedLabels();
			this._$first.attr("title", this.localizedLabels.firstPageTooltip);
			this._$prev.attr("title", this.localizedLabels.previousPageTooltip);
			this._$next.attr("title", this.localizedLabels.nextPageTooltip);
			this._$last.attr("title", this.localizedLabels.lastPageTooltip);
			this._$NP.attr("title", this.localizedLabels.nextPagerTooltip);
			this._$NP.attr("title", this.localizedLabels.previousPagerTooltip);
		},
        _applyCss: function () {
            if (this.model.currentPage > 1) {
                this._$prev.removeClass("e-prevpagedisabled").removeClass("e-disable").addClass("e-prevpage e-default");
                this._$first.removeClass("e-firstpagedisabled").removeClass("e-disable").addClass("e-firstpage e-default");
            } else {
                this._$prev.addClass("e-prevpagedisabled e-disable").removeClass("e-prevpage").removeClass("e-default");
                this._$first.addClass("e-firstpagedisabled e-disable").removeClass("e-firstpage").removeClass("e-default");
            }
            (this.model.currentPage > this.model.pageCount) ?
                 (this._$PP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default")) : (this._$PP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default"));

            if (this._links.length && parseInt(this._links[0].innerHTML.replace(this.model.customText, ""), 10) + this.model.pageCount > this.model.totalPages)
                this._lastNP = true;
            else
                this._lastNP = false;

            if (this._lastNP == false)
                this._$NP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default");
            else
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");

            this._lastpageCount = this.model.totalPages % this.model.pageCount;
            if (this._lastpageCount == 0)
                this._lastpageCount = this.model.pageCount;
            if (this.model.currentPage > (this.model.totalPages - this._LastpageCount)) {
                this._$PP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default");
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
            }
            if (this.model.currentPage == this.model.totalPages || this.model.totalRecordsCount == 0) {
                this._$last.addClass("e-lastpagedisabled e-disable").removeClass("e-lastpage").removeClass("e-default");
                this._$next.addClass("e-nextpagedisabled e-disable").removeClass("e-nextpage").removeClass("e-default");
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
            } else {
                this._$last.addClass("e-lastpage e-default").removeClass("e-lastpagedisabled").removeClass("e-disable");
                this._$next.addClass("e-nextpage e-default").removeClass("e-nextpagedisabled").removeClass("e-disable");
            }
            if (this._links.length) {
                this._links.removeClass("e-currentitem").removeClass("e-active").addClass("e-default");
                $(this._links[(this.model.currentPage - 1) % this.model.pageCount]).removeClass("e-default").addClass("e-currentitem e-active");
                $(this._links[(this._prevPageNo - 1) % this.model.pageCount]).removeClass("e-default").addClass("e-numericitem");
            }
            if (this._pageSize >= (this.model.totalRecordsCount / this.model.pageCount) && this._$PP != null && this._$PP.length != 0) {
                this._$PP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
            }
        },
        _SetTotalPages: function () {
            this.model.totalPages = (this.model.totalRecordsCount % this._pageSize == 0) ? (this.model.totalRecordsCount / this._pageSize) : (parseInt(this.model.totalRecordsCount / this._pageSize, 10) + 1);
        },
        _refreshNumericItem: function () {
            if (this._links.length != 0 && this._links != null) {
                this.model.currentPage = this.model.totalPages == 1 ? 1 : this.model.currentPage;
                if (this.model.currentPage > this.model.totalPages && this.model.totalPages != 0)
                    this.model.currentPage = this.model.totalPages;
                var _pagerTarget = parseInt(this.model.currentPage / this.model.pageCount, 10);
                if (this.model.currentPage % this.model.pageCount == 0)
                    if (_pagerTarget > 0)
                        _pagerTarget = _pagerTarget - 1;
                this._links.css("display", "none");
                for (var i = 0; i < this.model.pageCount; i++) {
                    var start = (_pagerTarget * this.model.pageCount) + 1 + i;
                    if (start <= this.model.totalPages) {
                        this._links[i].style.display = '';
                        $(this._links[i]).data('index', start);
                        $(this._links[i]).html(this.model.customText + start);
                    }
                }
            }
        },
        _refreshPagerInfo: function () {
            if (this.model.totalRecordsCount == 0)
                this.model.currentPage = 0;
            this.element.find(".e-pagermsg").text(String.format(this.localizedLabels.pagerInfo, this.model.currentPage, this.model.totalPages || 0, this.model.totalRecordsCount || 0));
        },
        _refreshExternalMessage: function () {
            if (this.model.externalMessage.toString().length)
                this.element.find(".e-pagermessage").empty().html(this.model.externalMessage).show();
            else
                this.element.find(".e-pagermessage").hide();
        },
        refreshPager: function () {
            this._SetTotalPages();
            this._refreshNumericItem();
            this._refreshPagerInfo();
            this._applyCss();
            this.model.enableExternalMessage && this._refreshExternalMessage();
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            else
                this.element.removeClass("e-rtl");
        },

        _kDownHandler: function (e) {
            var code;
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            e.target = null;
            if (this.model.masterObject.checkKey("firstPage", code, e))
                e.target = this._$first;
            else if (this.model.masterObject.checkKey("previousPager", code, e))
                e.target = this._$PP;
            else if (this.model.masterObject.checkKey("previousPage", code, e))
                e.target = this._$prev;
            else if (this.model.masterObject.checkKey("lastPage", code, e))
                e.target = this._$last;
            else if (this.model.masterObject.checkKey("nextPager", code, e))
                e.target = this._$NP;
            else if (this.model.masterObject.checkKey("nextPage", code, e))
                e.target = this._$next;
            else
                return false;
            this._pagerClickHandler(e);
        },
        _pageInfo: function ($pagerContainer) {
            if (this.model.showPageInfo && !this._parentMsgBar) {
                this._parentMsgBar = document.createElement("div");
                this._parentMsgBar.className += "e-parentmsgbar";
                this._renderMsgBar();
                this.element[0].appendChild(this._parentMsgBar);
                this.element[0].className += this.model.enableRTL ? " e-pager e-rtl" : " e-pager";
            } else {
                this._parentMsgBar && this._parentMsgBar.remove();
                this._parentMsgBar = null;
            }
			this._msgWidth = $(this._parentMsgBar).outerWidth()
        },
        _doClickAnimation: function (event) {
            var element = $(event.target);
            if (element == undefined || event.type == undefined) return;
            element.addClass("e-animate");
        },
        _pagerClickHandler: function (e) {
			if (!this.model.enabled) return false;
            this._prevPageNo = this.model.currentPage;
            var $target = $(e.target);
            this.element.find(".e-animate").removeClass("e-animate");
            this._doClickAnimation(e);
            if ($.inArray(e.target, this._links) != -1) {
                this.model.currentPage = parseInt($(e.target).data("index"), 10);
            }
            else if ($target.hasClass("e-nextpage") && $target.hasClass("e-nextpagedisabled") != true) {
                if (this.model.currentPage % this.model.pageCount == 0) {
                    this.model.currentPage++;
                    if (this._links != undefined && this._links.length != 0)
                        this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) + this.model.pageCount;
                    if (parseInt(this._links[this.model.pageCount - 1].innerHTML, 10) + this.model.pageCount >= this.model.totalPages)
                        this._lastNP = true;
                }
                else
                    this.model.currentPage++;
            }
            else if ($target.hasClass("e-prevpage") && $target.hasClass("e-prevpagedisabled") != true) {
                if (this.model.currentPage % this.model.pageCount == 1)
                    this._lastNP = false;
                this.model.currentPage--;
                if (this.model.currentPage < 0) { this.model.currentPage = 0; }
            }
            else if ($target.hasClass("e-lastpage") && $target.hasClass("e-lastpagedisabled") != true) {
                this._LastpageCount = this.model.totalPages % this.model.pageCount;
                (this._LastpageCount == 0) ? (this._LastpageCount = this.model.pageCount) : null;
                this.model.currentPage = this.model.totalPages;
                this._lastNP = true;
            }
            else if ($target.hasClass("e-firstpage") && $target.hasClass("e-firstpagedisabled") != true) {
                this.model.currentPage = 1;
                this._lastNP = false;
            }
            else if ($target.hasClass("e-NP") && $target.hasClass("e-nextprevitemdisabled") != true) {
                if (this._links != undefined)
                    this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) + this.model.pageCount;
                if (parseInt(this._links[this.model.pageCount - 1].innerHTML.replace(this.model.customText, ""), 10) + this.model.pageCount >= this.model.totalPages) {
                    this._lastNP = true;
                    if ((this.model.totalRecordsCount - this._pageSize) < this._pageSize)
                        this._LastpageCount = this.model.totalRecordsCount - this._pageSize;
                    else
                        this._LastpageCount = ((this.model.totalRecordsCount / this._pageSize) % this.model.pageCount);
                    (this._LastpageCount == 0) ? (this._LastpageCount = this.model.pageCount) : null;
                    if (this._links != undefined)
                        this.model.currentPage = parseInt($(this._links[this.model.pageCount - 1]).data("index"), 10) + 1;
                }
            }
            else if ($target.hasClass("e-PP") && $target.hasClass("e-nextprevitemdisabled") != true) {
                if (this._links != undefined)
                    this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) - this.model.pageCount;
                this._lastNP = false;
            }
            this.goToPage(this.model.currentPage, e);
              if (this.numTextbox) this.numTextbox.val(this.model.currentPage);
            return false;
        },
        goToPage: function (pageIndex, event) {
            if (pageIndex != this.model.currentPage)
                this._prevPageNo = this.model.currentPage;
            if (this._prevPageNo !== pageIndex && (pageIndex >= 1 && pageIndex <= this.model.totalPages)) {
                this.model.currentPage = pageIndex;
                this.model.enableQueryString && this._updateQueryString(this.model.currentPage);
                this._trigger("click", { "currentPage": pageIndex, "event": event });
            }
            else
                this._trigger("click", { "currentPage": pageIndex, "event": event });

        },
        _updateQueryString: function (value) {
            var _newUrl = this._getUpdatedURL(window.location.href, "page", value);
            if (history.pushState) {
                window.history.pushState({ path: _newUrl }, '', _newUrl);
            }
            else
                window.location.href = _newUrl;
        },

        _getUpdatedURL: function (uri, key, value) {
            var re = new RegExp("([?|&])" + key + "=.*?(&|#|$)", "i");
            if (uri.match(re)) {
                return uri.replace(re, '$1' + key + "=" + value + '$2');
            } else {
                var hash = '';
                var separator = uri.indexOf('?') !== -1 ? "&" : "?";
                if (uri.indexOf('#') !== -1) {
                    hash = uri.replace(/.*#/, '#');
                    uri = uri.replace(/#.*/, '');
                }
                return uri + separator + key + "=" + value + hash;
            }
        },
        _getLocalizedLabels: function (property) {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _fillScreen: function () {
            var numLen = this.element.find('.e-pagercontainer').outerWidth() - (this._$first.outerWidth() + this._$last.outerWidth() + this._$next.outerWidth() + this._$prev.outerWidth())
            numLen -= this._$NP.hasClass('e-disable') ? 0 : this._$NP.outerWidth();
            numLen -= this._$PP.hasClass('e-disable') ? 0 : this._$PP.outerWidth();
            if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
                if (Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth()) - 1 < 1) this._flag? this.option("pageCount", 1) : this.model.pageCount = 1;
                else this._flag ? this.option("pageCount", Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth()) - 1) : this.model.pageCount = Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth()) - 1;
            }
        },
		_enable: function () {
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this.element.prop("disabled", false);
			if(this.numTextbox) this.numTextbox.addClass("e-disable");
		},
		_disable: function () {
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this.element.prop("disabled", "disabled");
			if(this.numTextbox) this.numTextbox.removeClass("e-disable");
			if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
		},
        _setFirst: true,
        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "pageCount":
                        this._renderNumericLinks(this.element.find(".e-numericcontainer"));
                        if (this.model.isResponsive && !this._flag) {
                            this._maxPageCount = this.model.pageCount;
                            this._fillScreen();
                        }
                        this._flag = false;
                        break;
                    case "enableExternalMessage":
					if (options[prop])
                        this._renderPagerMessage();
					else
						this._removePagerMessage();
                        break;
                    case "showPageInfo":
                        this._pageInfo();
                        break;
                    case "pageSizeMessage":
                        if (options[prop] != null) {
                            this._renderPageSizeMessage();
                        }
                        break;
					case "pageSize":
					this._pageSize = this.model.pageSize;
					if (options[prop].length > 0) {
						this._pageSize = this.model.pageSize[0];
						if (this.$dropItem) {
							this.$dropItem.find("li").remove();
							this._renderItems();
						}
						else this._renderDropdownlist();
					}
					else if (this.$dropItem) this._removeDropdownlist();
						break;
					case "enabled":
						if (!options[prop]) this._disable(); else this._enable(); break;
					case "cssClass":
						this.element.removeClass(this._cssClass).addClass(options[prop]); this._cssClass = this.model.cssClass;
                    case "isResponsive":
                        this._wireResizing();
                        if (!options[prop]) this.option("pageCount", this._maxPageCount);
                        else if (this.model.isResponsive && !this._flag) {
                            this._maxPageCount = this.model.pageCount; this._fillScreen();
                        }
                        this._flag = false;
                        break;
                    case "showGoToPage": if (options[prop]) this._renderTextboxItem();  else if(this.numTextbox) this.numTextbox.remove(); break;
					case "locale": this._setLocale();
                }
            }
            this.refreshPager();
        },

        // all events bound using this._on will be unbind automatically
        _destroy: function () {
            this.element.empty().removeClass("e-pager");
            this._unWireResizing();
        }
    });
    ej.Pager.Locale = ej.Pager.Locale || {};

    ej.Pager.Locale["default"] = ej.Pager.Locale["en-US"] = {
        pagerInfo: "{0} of {1} pages ({2} items)",
        firstPageTooltip: "Go to first page",
        lastPageTooltip: "Go to last page",
        nextPageTooltip: "Go to next page",
        previousPageTooltip: "Go to previous page",
        nextPagerTooltip: "Go to next pager",
        previousPagerTooltip: "Go to previous pager"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSlider", "ej.Slider", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["value", "values"],
        _rootCSS: "e-slider",
        _setFirst: false,
        _requiresID: true,

        defaults: {

            orientation: "horizontal",

            enableAnimation: true,

            animationSpeed: 500,

            showTooltip: true,

            cssClass: "",

            showRoundedCorner: false,

            readOnly: false,

            enableRTL: false,

            htmlAttributes: {},

            minValue: 0,

            maxValue: 100,

            sliderType: "default",

            value: null,

            values: null,

            incrementStep: 1,

            height: null,

            width: null,

            enabled: true,

            showScale: false,

            largeStep: 10,

            smallStep: 1,

            showSmallTicks: true,

            enablePersistence: false,
            
            allowMouseWheel:false,

            start: null,

            stop: null,

            slide: null,

            change: null,

            create: null,

            destroy: null,

            tooltipChange: null,
            
        },

        dataTypes: {
            orientation: "enum",
            enableAnimation: "boolean",
            animationSpeed: "number",
            cssClass: "string",
            showRoundedCorner: "boolean",
            readOnly: "boolean",
            enableRTL: "boolean",
            minValue: "number",
            maxValue: "number",
            sliderType: "enum",
            incrementStep: "number",
            enabled: "boolean",
            showScale: "boolean",
            largeStep: "number",
            smallStep: "number",
            showSmallTicks: "boolean",
            enablePersistence: "boolean",
            htmlAttributes: "data",
            allowMouseWheel:"boolean"
        },

        observables: ["value", "values"],
        value: ej.util.valueFunction("value"),
        values: ej.util.valueFunction("values"),

        enable: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                if (this.wrapper) this.wrapper.removeClass("e-disable");
                this.element.removeClass("e-disable");
                this._wireEvents();
            }
        },

        disable: function () {
            if (this.model.enabled) {
                this.model.enabled = false;
                if (this.wrapper) this.wrapper.addClass("e-disable");
                this.element.addClass("e-disable");
                this._unWireEvents();
            }
        },

        _validateValue: function (value, animation) {
            animation = (typeof animation === 'undefined') ? false : animation;
            if (value == null || value === "") value = this.model.minValue;
            else if (typeof value === "string") value = parseFloat(value);

            if (this._isNumber(value)) {
                this._hidden.val(value);
                this.value(value);
            }
            else if (!this._isNumber(this.value())) {
                this._hidden.val(this.model.minValue);
                this.value(this.model.minValue);
            }
            if (this.model.sliderType != "range") this._setValue(animation);
        },

        _validateRangeValue: function (value, animation) {
            animation = (typeof animation === 'undefined') ? false : animation;
            if (value == null) value = new Array(this.model.minValue, this.model.maxValue);
            else if (typeof value === "string") {
                var vals = value.split(",");
                if (vals.length > 1) value = new Array(parseFloat(vals[0]), parseFloat(vals[1]));
            }

            if (typeof value === "object" && this._isNumber(value[0]) && this._isNumber(value[1])) {
                this._hidden.val(new Array(value[0], value[1]));
                this.values(new Array(value[0], value[1]));
            }
            else if (!(typeof this.values() === "object" && this._isNumber(this.values()[0]) && this._isNumber(this.values()[1]))) {
                this._hidden.val(new Array(this.model.minValue, this.model.maxValue));
                this.values(new Array(this.model.minValue, this.model.maxValue));
            }
            if (this.model.sliderType == "range") this._setRangeValue(animation);
        },

        _validateStartEnd: function () {
            if (isNaN(this.model.minValue)) this.model.minValue = 0;
            if (isNaN(this.model.maxValue)) this.model.maxValue = 100;
        },

        _isNumber: function (number) {
            return typeof number === "number" && !isNaN(number);
        },

        _outerCorner: function (boolean) {
            if (boolean) this._roundedCorner();
            else this._sharpedCorner();
        },

        _changeSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
            if (this.model.showScale)
                this.ul.removeClass(this.model.cssClass).addClass(skin);
        },

        getValue: function () {

            return this._getHandleValue();
        },

        setValue: function (value, animation) {
            if (this.model.sliderType == "range")
                this._validateRangeValue(value, animation);
            else
                this._validateValue(value, animation);
        },

        _init: function () {
            this._isInteraction = true;
            this._initialize();
            this._render();
        },

        _setModel: function (options) {
            this._isInteraction = false;
            if (!ej.isNullOrUndefined(options["minValue"]) || !ej.isNullOrUndefined(options["maxValue"])) {
                if (this._isNumber(options["minValue"])) this.model.minValue = options["minValue"];
                else options["minValue"] = this.model.minValue;

                if (this._isNumber(options["maxValue"])) this.model.maxValue = options["maxValue"];
                else options["maxValue"] = this.model.maxValue;

                if (this.model.sliderType == "range" && options["values"] == undefined) this._setRangeValue();
                else if (this.model.sliderType != "range" && options["value"] == undefined) this._setValue();
            }

            var option;
            for (option in options) {
                switch (option) {
                    case "value":
                        this._validateValue(ej.util.getVal(options[option]));
                        options[option] = this.model.value;
                        break;
                    case "values":
                        var actualValue = typeof this.values().join == "function" ? this.values().join() : this.values();
                        if (actualValue == this._hidden.val()) break;
                        this._validateRangeValue(ej.util.getVal(options[option]));
                        options[option] = this.model.values;
                        break;
                    case "height": this.model.height = options[option]; this._setDimension();
                        if (this.model.showScale) this._scaleAlignment();
                        break;
                    case "width": this.model.width = options[option]; this._setDimension();
                        if (this.model.showScale) this._scaleAlignment();
                        break;
                    case "enabled": this._disabled(!options[option]); break;
                    case "showRoundedCorner": this._outerCorner(options[option]); break;
                    case "enableRTL": this.model.enableRTL = options[option]; this._checkRTL();
                        options[option] = this.model.enableRTL;
                        break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showScale": this._renderScale(options[option]); break;
                    case "orientation":
                        var t = this.model.height;
                        this.model.height = this.model.width;
                        this.model.width = t;
                    case "sliderType":
                        this._sliderOptions(option, options[option]); break;
                    case "smallStep":
                    case "largeStep":
                    case "showSmallTicks":
                    case "minValue":
                    case "maxValue":
                        this._scaleOptions(option, options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "tooltipChange":
                        this.model.tooltipChange = options[option]; break;
                    case "allowMouseWheel": this.model.allowMouseWheel=options[option]; break;
                }
            }
        },

        _destroy: function () {
            if (this.model.showScale) this._destroyScale();
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            this.element.removeClass("e-widget e-box " + this.model.cssClass).empty();
        },

        _initialize: function () {
            this.target = this.element[0];
            this.horDir = "left";
            this.verDir = "bottom";
            this._isFocused = false;
        },

        _render: function () {
            this.initialRender = true;
            this._isIE8 = (ej.browserInfo().name == 'msie' && ej.browserInfo().version == '8.0') ? true : false
            this.wrapper = ej.buildTag("div.e-slider-wrap e-widget" + this.model.cssClass + "#" + this.target.id + "_wrapper", { tabindex: "0", role: "slider" })
                .insertAfter(this.element);
            this.wrapper.append(this.element);

            this.element.addClass("e-widget e-box " + this.model.cssClass);
            if (this.model.sliderType != "default") {
                this.header = ej.buildTag("div.e-range");
                this.element.append(this.header);
                if (this.model.sliderType == "range") {
                    this.secondHandle = this._createHandle();
                }
            }
            this.firstHandle = this._createHandle();
            this._setOrientation();
            this._setDimension();
            this._insertHiddenField();
            this._checkProperties();
            this._addAttr(this.model.htmlAttributes);
            this._setSliderValue();
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._disabled(true);
                else proxy.element.attr(key, value)
            });
        },

        _renderScale: function (showScale) {
            if (showScale) {
                this.wrapper.addClass("e-scale-wrap");
                var width = "width", orien = "h";
                if (this.model.orientation == "vertical") {
                    width = "height";
                    orien = "v";
                }

                var _smallStep = this.model.smallStep;
                if (!this.model.showSmallTicks) {
                    if (this.model.largeStep > 0)
                        _smallStep = this.model.largeStep;
                    else
                        _smallStep = this.model.maxValue - this.model.minValue;
                }
                else if (_smallStep <= 0)
                    _smallStep = this.model.incrementStep;
                var count = Math.abs(this.model.maxValue - this.model.minValue) / _smallStep;

                this.ul = ej.buildTag("ul.e-scale e-" + orien + "-scale " + this.model.cssClass);
                if (this._isIE8) this.ul.addClass('e-ie8')
                this.wrapper.append(this.ul);

                var li, start = this.model.minValue, left = 0, tickWidth = 100 / count;
                if (orien == "v") start = this.model.maxValue;
                for (var i = 0; i <= count; i++) {
                    li = ej.buildTag("li.e-tick", "", {}, { "title": start });
                    li.css(width, tickWidth + "%");

                    if (start % this.model.largeStep == 0) {
                        var span = ej.buildTag("span.e-tick-value", "" + start);
                        li.addClass("e-large").append(span);
                    }
                    this.ul.append(li);

                    if (orien == "h") start += _smallStep;
                    else start -= _smallStep;
                    left += _smallStep;
                }

                this.ul.children().first().addClass("e-first-tick").css(width, (tickWidth / 2) + "%");
                this.ul.children().last().addClass("e-last-tick").css(width, (tickWidth / 2) + "%");

                this._scaleAlignment();
            }
            else this._destroyScale();
            this._setWrapperHeight();
        },
        _destroyScale: function () {
            this.wrapper.removeClass("e-scale-wrap");
            this.ul.remove();
            this.ul = null;
        },

        _tickValuePosition: function () {
            var width = (this.model.orientation == "vertical") ? "height" : "width";
            var left = (this.model.orientation == "vertical") ? "top" : "left";
            var firstTick = this.ul.find(".e-tick.e-first-tick");
            var first = firstTick.find(".e-tick-value");
            var other = this.ul.find(".e-tick.e-large:not(.e-first-tick)").find(".e-tick-value");
            var tickWidth = firstTick[width]() * 2;
            first.css(left, -first[width]() / 2);
            other.css(left, (tickWidth - other[width]()) / 2);
        },

        _scaleAlignment: function () {
            this._tickValuePosition();
            var smallTick = 12, largeTick = 20, half = largeTick / 2;
            var height = "height", top = "top", orien = "h";
            if (this.model.orientation == "vertical") {
                height = "width";
                top = "right";
                orien = "v";
                (this.element.width() <= 15) ? this.wrapper.addClass("e-small-size") : this.wrapper.removeClass("e-small-size");
            }
            else
                (this.element.height() <= 15) ? this.wrapper.addClass("e-small-size") : this.wrapper.removeClass("e-small-size");
            // scale
            this.ul.css(top, -(this.wrapper[height]() + half));
            if (orien == "v") this.ul.css("top", -this.wrapper.height()).css(top, half);
            this.ul[height](this.wrapper[height]() + largeTick);
            // small-ticks
            var topSize = -(largeTick - smallTick) / 2;
            if (this.model.largeStep == null && orien != "v") topSize = -topSize;
            this.ul.find(".e-tick:not(.e-large)").css(height, this.wrapper[height]() + smallTick).css(top, topSize);
            // tick-values   // 4 - distance between tick value and tick
            if (orien == "v") this.ul.children(".e-large").find(".e-tick-value").css("right", this.wrapper.width() + largeTick + 4);
        },

        _setWrapperHeight : function(){
            var wrapHeight, wrapWidth;
            if (this.model.orientation == "horizontal") {
                if (this.ul)
                    wrapHeight = (this.firstHandle.outerHeight() > this.ul.height()) ? this.firstHandle.outerHeight() : this.ul.height();
                else wrapHeight = this.firstHandle.outerHeight();
                var top = (wrapHeight - this.element.outerHeight()) / 2;
                if (top < 0) top = 0;
                this.wrapper.css({ "padding": top + "px 0px" });
            }
            else {
                if (this.ul)
                    wrapWidth = (this.firstHandle.outerWidth() > this.ul.width()) ? this.firstHandle.outerWidth() : this.ul.width();
                else wrapWidth = this.firstHandle.outerWidth();
                var right = ( wrapWidth - this.element.outerWidth()) / 2;
                if (right < 0) right = 0;
                this.wrapper.css({ "padding": "0px " + right + "px" });
            }
        },


        _createHandle: function () {
            var handle = ej.buildTag("a.e-handle e-select", "", {}, { "aria-label": "drag", "tabindex": 0, role: "slider", "aria-valuemin": this.model.minValue, "aria-valuemax": this.model.maxValue });
            ej.browserInfo().name == "msie" && handle.addClass("e-pinch");
            this.element.append(handle);
            return handle;
        },

        _setDimension: function () {
            if (this.model.height) this.wrapper.height(this.model.height);
            if (this.model.width) this.wrapper.width(this.model.width);
            this._setHandleSize();
            this._handleAlignment(this.model.enableRTL);
        },

        _insertHiddenField: function () {
            this._hidden = ej.buildTag("input", "", {},
                { "type": "hidden", "name": this.element[0].id });
            this._hidden.val(this._getHandleValue());
            this.element.append(this._hidden);
        },

        _checkProperties: function () {
            if (!this.model.enabled) {
                if (this.wrapper) this.wrapper.addClass("e-disable");
                else this.element.addClass("e-disable");
            }
            else this._wireEvents();
            if (this.model.showScale) this._renderScale(true);
            else this._setWrapperHeight();
            if (this.model.enableRTL) this._checkRTL();
            if (this.model.showRoundedCorner) this._roundedCorner();
        },

        _roundedCorner: function () {
            this.element.addClass("e-corner");
        },

        _sharpedCorner: function () {
            this.element.removeClass("e-corner");
        },

        _handleAlignment: function (rtl) {
            var mar = -(this.firstHandle.outerWidth() / 2) + "px", margin;
            if (this.model.orientation != "vertical") {
                if (!rtl) margin = "0 0 0 " + mar;
                else margin = "0 " + mar + " 0 0";
            }
            else {
                if (!rtl) margin = "0 0 " + mar + " 0";
                else margin = mar + " 0 0 0";
            }
            this.element.children('.e-handle').css("margin", margin);
        },

        _checkRTL: function () {
            if (this.model.showScale && this.model.orientation == "vertical" && this.model.enableRTL) this.model.enableRTL = false;
            var rtl = this.model.enableRTL, preDir = (this.model.orientation != "vertical") ? this.horDir : this.verDir;
            if (rtl) {
                this.wrapper.addClass("e-rtl");
                this.horDir = "right";
                this.verDir = "top";
            }
            else {
                this.wrapper.removeClass("e-rtl");
                this.horDir = "left";
                this.verDir = "bottom";
            }
            var currDir = (this.model.orientation != "vertical") ? this.horDir : this.verDir;

            if (preDir != currDir) {
                this.firstHandle.css(currDir, this.firstHandle.css(preDir)).css(preDir, "auto");;
                if (this.model.sliderType != "default") {
                    this.header.css(currDir, this.header.css(preDir)).css(preDir, "auto");
                    if (this.model.sliderType == "range")
                        this.secondHandle.css(currDir, this.secondHandle.css(preDir)).css(preDir, "auto");
                }
            }
            this._handleAlignment(rtl);
        },

        _setOrientation: function () {
            if (this.model.orientation != "vertical") {
                this.wrapper.addClass("e-horizontal");
            }
            else {
                this.wrapper.addClass("e-vertical");
                this.firstHandle.css(this.verDir, "0");
            }
        },

        _setHandleSize: function () {
            if ((this.model.height != null && this.model.orientation == "horizontal") || (this.model.width != null && this.model.orientation == "vertical") ) {
                var size;
                if (this.model.orientation != "vertical")
                    size = this.wrapper.height() + 2;
                else
                    size = this.wrapper.width() + 2;
                this.element.find(".e-handle").height(size).width(size);
            }
            else{
                this.wrapper.addClass("e-default-wrap");
                this.element.find(".e-handle").addClass("e-default");
            }
        },

        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        _sliderOptions: function (prop, value) {
            this._unWireEvents();
            this._destroy();
            this.model[prop] = value;
            this._init();
        },

        _scaleOptions: function (prop, value) {
            if (this.model.showScale) {
                this._destroyScale();
                this.model[prop] = value;
                this._renderScale(true);
            }
        },

        _showTooltip: function () {
            if (this.model.showTooltip) {
                this._timeOut && clearTimeout(this._timeOut);
                var _tooltip = this.tooltip ? $('body .e-tooltipbox').text().replace(/\s+/g, '').replace("-", ",") : "";
                if (this.tooltip && this.tooltip.length && this.tooltip.css("display") != "none" && this._getHandle()[0] == this._oldHandle && _tooltip == this.preValue) {
                    if (this._getHandleValue().toString() != this.preValue)
                        this._setTooltipPosition();
                    return;
                }
                this._oldHandle = this._getHandle()[0];
                $('body .e-tooltipbox').remove();
                this.tooltip = ej.buildTag("div.e-tooltipbox" + this.model.cssClass + " e-corner", { role: "tooltip" }).css(this._getOffset(this._getHandle()));
                $("body").append(this.tooltip);
                if (this.model.orientation == "vertical") {
                    this.tooltip.addClass("e-vertical");
                }
                this._setTooltipPosition();
            }
        },

        _hideTooltip: function () {
            if (this.model.showTooltip) {
                var proxy = this;
                this._timeOut = setTimeout(function () {
                    proxy.tooltip.fadeOut(800);
                }, 1500);
            }
                
        },

        _showhideTooltip: function (showTooltip) {
            if (this.model.showTooltip && showTooltip) {
                this._showTooltip();
                this._timeOut && clearTimeout(this._timeOut);
                this._hideTooltip();
            }
        },

        _setTooltipPosition: function () {
            if (this.model.showTooltip) {
                this._updateTooltipValue();
                var top, left, remainLeft, remainTop, handle, pos, gap = 5, broder, tooltipPos, border; // gap -> distance between tooltip and slider
                handle = this._getHandle(), pos = this._getOffset(handle), tooltipPos = this._getOffset(this.tooltip);
                border = $(handle).outerHeight() - $(handle).height();
                if (this.model.orientation == "vertical") {
                    remainTop = (this.tooltip.outerHeight() - handle.outerHeight()) / 2;
                    remainLeft = handle.outerWidth() + gap;
                    top = pos.top - remainTop;
                    left = pos.left + remainLeft;
					var height=$(window).height();
                    if (window.pageYOffset > 0) height+=window.pageYOffset; 
                    if (top < 0) top = 0;
                    else if (height < top + this.tooltip.outerHeight()) top = height - this.tooltip.outerHeight() - border;
                    if ($(window).width() < left + this.tooltip.outerWidth()) left = pos.left - this.tooltip.outerWidth() - border;
                }
                else {
                    if (tooltipPos.left + this.tooltip.outerWidth() > $(window).width()) this.tooltip.css({ "left": '0px' });
                    remainLeft = (this.tooltip.outerWidth() - handle.outerWidth()) / 2;
                    remainTop = this.tooltip.outerHeight() + gap;
                    top = pos.top - remainTop;
                    left = pos.left - remainLeft;
					var width=$(window).width();
                    if (window.pageXOffset > 0) width+=window.pageXOffset;    
                    if (left < 0) left = 0;
                    else if (width < left + this.tooltip.outerWidth()) left = width - this.tooltip.outerWidth() - border;
                    if (top < 0 || pos.top < remainTop) {
                        if (pos.top + handle.outerHeight() + border + this.tooltip.outerHeight() > $(window).height()) {
                            top = pos.top;
                            if (pos.left > this.tooltip.outerWidth() + gap + border) left = pos.left - (this.tooltip.outerWidth() + border);
                            else left = pos.left + (handle.outerWidth() + gap + border);
                        } else top = pos.top + handle.outerHeight() + border;
                    }
                }
                var zindex = this._maxZindex();
                this.tooltip.css({ "top": top, "left": left, "zIndex": zindex + 1 });
            }
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },


        _maxZindex: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },

        _updateTooltipValue: function () {
            var one = 0, two = 1, val;
            if (this.model.enableRTL) { one = 1, two = 0; }
            if (this.model.tooltipChange)
                val = this._raiseEvent("tooltipChange");
            else
                val = this._getHandleValue();
            if (this.model.sliderType != "range")
                this.tooltip[0].innerHTML = val;
            else
                this.tooltip[0].innerHTML = val[one] + " - " + val[two];
        },

        _increaseHeaderWidth: function (animation) {
            if (this.model.sliderType != "default") {
                var size = "width", direction = this.horDir, properties = {};
                if (this.model.orientation == "vertical") { size = "height", direction = this.verDir; }

                if (this.model.sliderType == "range") {
                    properties[size] = this.handlePos - this.handlePos2 + "%";
                    properties[direction] = this.handlePos2 + "%";
                }
                else {
                    properties[size] = this.handlePos + "%";
                    properties[direction] = 0;
                }
                if (!animation) this.header.css(properties);
                else this.header.animate(properties, this.model.animationSpeed);
            }
        },

        _setSliderValue: function () {
            this._validateStartEnd();

            if (this.model.sliderType == "range")
                this._validateRangeValue(this.values());
            else
                this._validateValue(this.value());
            this.preValue = this.getValue().toString();
        },


        _hoverOnHandle: function (evt) {
            $(evt.currentTarget).addClass("e-hover");
        },

        _leaveFromHandle: function (evt) {
            $(evt.currentTarget).removeClass("e-hover");
        },

        _firstHandleClick: function (evt) {
            evt.preventDefault();
            this.firstHandle.focus().addClass("e-no-tab");
            if (this._raiseEvent("start")) return false;

            this.mouseDownPos = this.handlePos;
            if (!this.model.readOnly)
            this._on($(document),ej.eventType.mouseMove, this._firstHandleMove);
            this._on($(document),ej.eventType.mouseUp,this._firstHandleUp);
            this._on($(document),"mouseleave",this._firstHandleUp);
            this._showTooltip();
        },

        _firstHandleMove: function (evt) {
            evt.preventDefault();
            evt = evt.type == "touchmove" ? evt.originalEvent.changedTouches[0] : evt;
            var position = { x: evt.pageX, y: evt.pageY };
            this.handlePos = this._xyToPosition(position);

            if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                this.handlePos = this.handlePos2;
            }
            if (this.handlePos != this.preHandlePos) {
                this.preHandlePos = this.handlePos;
                this.handleVal = this._positionToValue(this.handlePos);
                this._increaseHeaderWidth(false);
                this._setHandlePosition(false, false, false);
                this._setTooltipPosition();

                this._updateModelValue();
                this._raiseEvent("slide");
            }
        },

        _firstHandleUp: function (evt) {
            evt.preventDefault();
            this._off($(document),ej.eventType.mouseMove, this._firstHandleMove);
            this._off($(document),ej.eventType.mouseUp,this._firstHandleUp);
            this._off($(document), "mouseleave", this._firstHandleUp);
            this._timeOut && clearTimeout(this._timeOut);
            this._hideTooltip();

            if (this.mouseDownPos != this.handlePos) this._raiseChangeEvent();
        },

        _secondHandleClick: function (evt) {
            evt.preventDefault();
            this.secondHandle.focus().addClass("e-no-tab");
            if (this._raiseEvent("start")) return false;

            this.mouseDownPos2 = this.handlePos2;
            if (!this.model.readOnly)
            this._on($(document),ej.eventType.mouseMove, this._secondHandleMove);
            this._on($(document),ej.eventType.mouseUp,this._secondHandleUp);
            this._on($(document),"mouseleave",this._secondHandleUp);
            this._showTooltip();
        },

        _secondHandleMove: function (evt) {
            evt.preventDefault();
            evt = evt.type == "touchmove" ? evt.originalEvent.changedTouches[0] : evt;
            var position2 = { x: evt.pageX, y: evt.pageY };
            this.handlePos2 = this._xyToPosition(position2);

            if (this.handlePos2 > this.handlePos) {
                this.handlePos2 = this.handlePos;
            }
            if (this.handlePos2 != this.preHandlePos2) {
                this.preHandlePos2 = this.handlePos2;
                this.handleVal2 = this._positionToValue(this.handlePos2);
                this._increaseHeaderWidth(false);
                this._setHandlePosition(false, false, false);
                this._setTooltipPosition();

                this._updateModelValue();
                this._raiseEvent("slide");
            }
        },

        _secondHandleUp: function (evt) {
            evt.preventDefault();
            this._off($(document),ej.eventType.mouseMove,this._secondHandleMove);
            this._off($(document),ej.eventType.mouseUp,this._secondHandleUp);
            this._off($(document), "mouseleave", this._secondHandleUp);
            this._timeOut && clearTimeout(this._timeOut);
            this._hideTooltip();

            if (this.mouseDownPos2 != this.handlePos2) this._raiseChangeEvent();
        },

        _focusInHandle: function (evt) {
            if (!this._isFocused) {
                this._isFocused = true;
                $(evt.currentTarget).addClass("e-focus");
                if (!this.model.readOnly)
                   this._on($(document),"keydown",this._moveHandle);
                if (this.model.allowMouseWheel && !this.model.readOnly) {
                    this._on(this.element,"mousewheel DOMMouseScroll", this._moveHandle);
                }
                this.activeHandle = $(evt.currentTarget).is(this.firstHandle) ? 1 : 2;
                this._setZindex();
            }
        },

        _focusOutHandle: function (evt) {
            this._isFocused = false;
            if (this.model.showTooltip && this.tooltip)
                this.tooltip.fadeOut(800);
            this.element.find(".e-no-tab").removeClass("e-no-tab");
            $(evt.currentTarget).removeClass("e-focus");
         this._off($(document),"keydown",this._moveHandle);
            this._off(this.element,"mousewheel DOMMouseScroll", this._moveHandle);
        },

        _moveHandle: function (e) {
            if ((e.type == 'mousewheel') || (e.type=='DOMMouseScroll')) e.preventDefault()
            var oper, val, handleNo;
            handleNo = this._getHandleIndex(this.activeHandle) - 1;
            if (e.originalEvent.detail)
            {
               var delta = -e.originalEvent.detail / 3;
                if (delta > 0) {
                    oper = 'add';
                }
                else oper = 'sub';
            }
            switch (e.keyCode || e.originalEvent.wheelDelta) {
                case -120:
                case 37:
                case 40:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    oper = "sub";
                    break;
                case 120:
                case 38:
                case 39:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    oper = "add";
                    break;
                case 36:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    if (this._raiseEvent("start")) return false;
                    if (this.model.sliderType != "range" && this.value() != this.model.minValue) {
                        this._changeHandleValue(this.model.minValue, this.model.enableAnimation);
                    }
                    else if (this.model.sliderType == "range") {
                        val = (this.activeHandle == 2) ? this.model.minValue : this.handleVal2;
                        if (this.values()[handleNo] != val)
                            this._changeHandleValue(val, this.model.enableAnimation);
                    }
                    break;
                case 35:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    if (this._raiseEvent("start")) return false;
                    if (this.model.sliderType != "range" && this.value() != this.model.maxValue) {
                        this._changeHandleValue(this.model.maxValue, this.model.enableAnimation);
                    }
                    else if (this.model.sliderType == "range") {
                        val = (this.activeHandle == 1) ? this.model.maxValue : this.handleVal;
                        if (this.values()[handleNo] != val)
                            this._changeHandleValue(val, this.model.enableAnimation);
                    }
                    break;
                case 27:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    this._getHandle().focusout();
                    break;
            }

            if (oper == "add" || oper == "sub") {
                if (this._raiseEvent("start")) return false;
                var hVal = (this.activeHandle == 1) ? this.handleVal : this.handleVal2;
                var value = (oper == "add") ? this._add(hVal, this.model.incrementStep, true) : this._add(hVal, this.model.incrementStep, false);
                this._changeHandleValue(value, false);
            }
        },

        _changeHandleValue: function (value, animate) {
            var position = null;
            if (this.activeHandle == 1) {
                this.handleVal = this._checkHandleValue(value);
                this.handlePos = this._checkHandlePosition(this.handleVal);

                if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                    this.handlePos = this.handlePos2;
                    this.handleVal = this.handleVal2;
                }
                if (this.handlePos != this.preHandlePos)
                    position = this.preHandlePos = this.handlePos;
            }
            else {
                this.handleVal2 = this._checkHandleValue(value);
                this.handlePos2 = this._checkHandlePosition(this.handleVal2);

                if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                    this.handlePos2 = this.handlePos;
                    this.handleVal2 = this.handleVal;
                }
                if (this.handlePos2 != this.preHandlePos2)
                    position = this.preHandlePos2 = this.handlePos2;
            }

            if (position != null) {
                this._increaseHeaderWidth(animate);
                this._setHandlePosition(animate, true, true);
            }
        },

        _sliderBarClick: function (evt) {
            if (this.model.readOnly) return false;
            if (evt.target == this.target || (this.model.sliderType != "default" && evt.target == this.header[0]) || $(evt.target).hasClass('e-tick') || $(evt.target).hasClass('e-scale') || evt.target == this.wrapper[0]) {
                evt.preventDefault();
                if (this._raiseEvent("start")) return false;
                var pos = { x: evt.pageX, y: evt.pageY },
                handlepos = this._xyToPosition(pos),
                handleVal = this._positionToValue(handlepos);

                if (this.model.sliderType == "range" && (this.handlePos - handlepos) > (handlepos - this.handlePos2)) {
                    this.handlePos2 = this.preHandlePos2 = handlepos;
                    this.handleVal2 = handleVal;
                    this.activeHandle = 2;
                }
                else {
                    this.handlePos = this.preHandlePos = handlepos;
                    this.handleVal = handleVal;
                    this.activeHandle = 1;
                }

                this._getHandle().focus().addClass("e-no-tab");;
                if (this.model.sliderType != "default") this._increaseHeaderWidth(this.model.enableAnimation);
                this._setHandlePosition(this.model.enableAnimation, true, true);
            }
        },

        _setHandlePosition: function (animation, showTooltip, changeEvt) {
            var Handle = this._getHandle(), proxy = this, properties = {}, pos, val, direction;
            pos = (this.activeHandle == 1) ? this.handlePos : this.handlePos2;
            val = (this.activeHandle == 1) ? this.handleVal : this.handleVal2;
            Handle.attr("aria-label", val);
            direction = (this.model.orientation == "vertical") ? this.verDir : this.horDir;
            properties[direction] = pos + "%";
            if (pos == 0) {
                this.model.sliderType != "range" && this._getHandle().addClass("e-handle-start");
            }
            else {
                this._getHandle().removeClass("e-handle-start");
            }
            if (!animation) {
                Handle.css(properties);
                this._showhideTooltip(showTooltip);
                if (changeEvt) this._raiseChangeEvent();
            }
            else Handle.animate(properties, this.model.animationSpeed, function () {
                proxy._showhideTooltip(showTooltip);
                if (changeEvt) proxy._raiseChangeEvent();
            });
        },

        _xyToPosition: function (position) {
            if (this.model.minValue == this.model.maxValue)
                return 100;
            if (this.model.orientation != "vertical") {
                var left = position.x - this.element.offset().left,
                num = this.element.width() / 100,
                val = (left / num);
            }
            else {
                var top = position.y - this.element.offset().top,
                num = this.element.height() / 100,
                val = 100 - (top / num);
            }
            val = this._stepValueCalculation(val);
            if (val < 0) val = 0;
            else if (val > 100) val = 100;
            if (this.model.enableRTL) return 100 - val;
            return val;
        },

        _updateValue: function () {
            this.handleVal = this._checkHandleValue(this.value());
            this.handlePos = this._checkHandlePosition(this.handleVal);
            this.preHandlePos = this.handlePos;
            this.activeHandle = 1;
        },

        _setValue: function (animation) {
            this._updateValue();
            this._increaseHeaderWidth(animation);
            this._setHandlePosition(animation, false, true);
        },

        _updateRangeValue: function () {
            var values = this.values();
            this.handleVal = this._checkHandleValue(values[1]);
            this.handleVal2 = this._checkHandleValue(values[0]);
            this.handlePos = this._checkHandlePosition(this.handleVal);
            this.handlePos2 = this._checkHandlePosition(this.handleVal2);

            if (this.handlePos < this.handlePos2) {
                this.handlePos = this.handlePos2;
                this.handleVal = this.handleVal2;
            }
            this.preHandlePos = this.handlePos;
            this.preHandlePos2 = this.handlePos2;
        },

        _setRangeValue: function (animation) {
            this._updateRangeValue();
            this._increaseHeaderWidth(animation);
            this.activeHandle = 1;
            this._setHandlePosition(animation, false, false);
            this.activeHandle = 2;
            this._setHandlePosition(animation, false, true);
        },

        _checkHandlePosition: function (value) {
            if (this.model.minValue == this.model.maxValue)
                return 100;
            var handle = this._tempStartEnd();
            if (value >= handle.start && value <= handle.end)
                value = (100 * (value - this.model.minValue)) / (this.model.maxValue - this.model.minValue);
            else if (value < handle.start) value = 0;
            else value = 100;
            return value;
        },

        _checkHandleValue: function (value) {
            if (this.model.minValue == this.model.maxValue)
                return this.model.minValue;
            var handle = this._tempStartEnd();
            if (value < handle.start) value = handle.start;
            else if (value > handle.end) value = handle.end;
            return value;
        },

        _tempStartEnd: function () {
            if (this.model.minValue > this.model.maxValue)
                return {
                    start: this.model.maxValue,
                    end: this.model.minValue
                };
            else
                return {
                    start: this.model.minValue,
                    end: this.model.maxValue
                };
        },

        _positionToValue: function (pos) {
            var diff = this.model.maxValue - this.model.minValue,
            val = this._round(diff * pos / 100),
            total = this._add(val, this.model.minValue, true);
            return total;
        },

        _getHandle: function () {
            return (this.activeHandle == 1) ? this.firstHandle : this.secondHandle;
        },

        _getHandleIndex: function (no) {
            if (this.model.sliderType == "range" && no == 1)
                return 2;
            return 1;
        },

        _getHandleValue: function () {
            if (this.model.sliderType == "range") return [this.handleVal2, this.handleVal];
            else return this.handleVal;
        },

        _updateModelValue: function () {
            var value = this._getHandleValue();
            this._hidden.val(value);
            if (this.model.sliderType == "range") this.values(value);
            else this.value(value);
        },

        _add: function (a, b, addition, precision) {
            var x = Math.pow(10, precision || 3), val;
            if (addition) val = (Math.round(a * x) + Math.round(b * x)) / x;
            else val = (Math.round(a * x) - Math.round(b * x)) / x;
            return val;
        },

        _round: function (a) {
            var _f = this.model.incrementStep.toString().split(".");
            return _f[1] ? parseFloat(a.toFixed(_f[1].length)) : Math.round(a);
        },

        _raiseChangeEvent: function () {
            this._updateModelValue();
            if (this.initialRender)
                this.initialRender = false;
            else {
                if(this.getValue().toString() != this.preValue.toString()){
                        this._raiseEvent("change");
                        this._raiseEvent("stop");
                        this.preValue = this.getValue().toString();
                        this._isInteraction = true;
                }
            }
        },

        _raiseEvent: function (name) {
            var data = { id: this.target.id, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            if (name == "change")
                data = { id: this.target.id, isInteraction: this._isInteraction, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            if (name == "tooltipChange")
                data = { id: this.target.id, isInteraction: this._isInteraction, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            var status = this._trigger(name, data);
            if (name == "tooltipChange")
                return data.value;
            return status;
        },

        _setZindex: function () {
            if (this.model.sliderType == "range") {
                if (this.activeHandle == 1) {
                    this.firstHandle.css("z-index", 2);
                    this.secondHandle.css("z-index", 1);
                }
                else {
                    this.firstHandle.css("z-index", 1);
                    this.secondHandle.css("z-index", 2);
                }
            }
        },

        _stepValueCalculation: function (value) {
            if (this.model.incrementStep == 0) this.model.incrementStep = 1;
            var percentStep = this.model.incrementStep / ((this.model.maxValue - this.model.minValue) / 100);
            var remain = value % Math.abs(percentStep);
            if (remain != 0) {
                if ((percentStep / 2) > remain) value -= remain;
                else value += Math.abs(percentStep) - remain;
            }
            return value;
        },

        _wireEvents: function () {
            this._on(this.wrapper, "mousedown", this._sliderBarClick);
            this._on(this.firstHandle, ej.eventType.mouseDown, this._firstHandleClick);
            this._on(this.firstHandle, "mouseenter", this._hoverOnHandle);
            this._on(this.firstHandle, "mouseleave", this._leaveFromHandle);
            this._on(this.firstHandle, "focusin", this._focusInHandle);
            this._on(this.firstHandle, "focusout", this._focusOutHandle);

            if (this.model.sliderType == "range") {
                this._on(this.secondHandle, ej.eventType.mouseDown, this._secondHandleClick);
                this._on(this.secondHandle, "mouseenter", this._hoverOnHandle);
                this._on(this.secondHandle, "mouseleave", this._leaveFromHandle);
                this._on(this.secondHandle, "focusin", this._focusInHandle);
                this._on(this.secondHandle, "focusout", this._focusOutHandle);
            }
        },


        _unWireEvents: function () {
            this._off(this.wrapper, "mousedown");
            this._off(this.firstHandle, ej.eventType.mouseDown);
            this._off(this.firstHandle, "mouseenter");
            this._off(this.firstHandle, "mouseleave");
            this._off(this.firstHandle, "focusin");
            this._off(this.firstHandle, "focusout");

            if (this.model.sliderType == "range") {
                this._off(this.secondHandle, ej.eventType.mouseDown);
                this._off(this.secondHandle, "mouseenter");
                this._off(this.secondHandle, "mouseleave");
                this._off(this.secondHandle, "focusin");
                this._off(this.secondHandle, "focusout");
            }
        }
    });

    ej.SliderType = {
        /**  support for slider control to select a single value. */
        Default: "default",
        /**  support for slider control to select a single value considered from start value to current handle. */
        MinRange: "minrange",
        /**  support for slider control to select a range of value between the two handles. */
        Range: "range"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSplitButton", "ej.SplitButton", {

        element: null,

        model: null,
        validTags: ["button"],
        _setFirst: false,

        _rootCSS: "e-splitbutton",

        defaults: {

            size: "normal",

            width: "",

            height: "",

            enabled: true,

            htmlAttributes: {},

            text: null,

            contentType: "textonly",

            imagePosition: "imageleft",

            buttonMode: "split",

            arrowPosition: "right",

            targetID: null,

            target: null, 

            showRoundedCorner: false,

            prefixIcon: null,

            suffixIcon: null,

            cssClass: "",

            enableRTL: false,

            create: null,

            beforeOpen: null,

            click: null,

            itemMouseOver: null,

            itemMouseOut: null,

            itemSelected: null,

            open: null,

            close: null,

            destroy: null
        },

        dataTypes: {
            size: "string",
            enabled: "boolean",
            showRoundedCorner: "boolean",
            text: "string",
            contentType: "enum",
            imagePosition: "enum",
            buttonMode: "enum",
            arrowPosition: "enum",
            target: "string",       
            targetID: "string",
            prefixIcon: "string",
            suffixIcon: "string",
            cssClass: "string",
            enableRTL: "boolean",
            htmlAttributes: "data"
        },


        disable: function () {
            this.element.addClass("e-disable");
            this.wrapper.addClass("e-disable");
            if (this.contstatus) {
                this._hidePopup();
            }
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this.dropbutton.addClass("e-disable").attr("aria-disabled", true);
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.btnimgwrap.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
        },

        visible: function (display) {
            if (!display) {
               this.wrapper.addClass("e-split-btn-hide");
               this.wrapper.find(".e-icon").css("visibility", "hidden");
            }
            else {
               this.wrapper.removeClass("e-split-btn-hide");
               this.wrapper.find(".e-icon").css("visibility", "");
            }
        },

        enable: function () {
            this.element.removeClass("e-disable");
            this.wrapper.removeClass("e-disable");
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this.dropbutton.removeClass("e-disable").attr("aria-disabled", false);
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.btnimgwrap.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
        },

        hide: function () {
            if (this.contstatus) {
                this._hidePopup();
            }
        },

        show: function () {
            if (!this.contstatus) {
                if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                    this.element.click();
                else if (this.model.buttonMode == ej.ButtonMode.Split)
                    this.dropbutton.click();
            }
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._controlStatus(this.model.enabled);
            this._documentClickHandler = $.proxy(this._documentClick, this);
            this._wireEvents();
        },


        _destroy: function () {
            this.splitwrap.removeClass("e-drop");
            this.splitwrap.removeClass("e-btn-" + this.model.size);
            this.innerWrap.removeClass("e-splitarrowright e-splitarrowleft e-splitarrowbottom e-splitarrowtop");
            this.element.removeClass(this.model.cssClass + " e-select e-corner e-btn e-disable e-split-btn e-droparrowright e-droparrowleft e-droparrowbottom e-droparrowtop e-left-btn e-txt").empty();
            this.element.append(this._cloneElement.text());
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            $(this.model.target).ejMenu('destroy');
            //this has to be worked out in Menu
            $(this.model.target).insertAfter(this.element); 
            this._off(this.element, "click", this._btnMouseClick);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "width":
                        this._splitbtnWidth(options[option]);
                        break;
                    case "height":
                        this._splitbtnHeight(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "buttonMode":
                        this._setButtonMode(options[option]);
                        break;
                    case "arrowPosition":
                        this._setArrowPosition(options[option]);
                        break;
                    case "text":
                        this._setText(options[option]);
                        break;
                    case "prefixIcon":
                        this._setMajorIcon(options[option]);
                        break;
                    case "suffixIcon":
                        this._setMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "targetID":
                    case "target":
                        this._setTarget(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        $(this.model.target).ejMenu({ enableRTL: options[option] }); 
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                }
            }
        },

        _setText: function (val) {
            if (this.model.contentType == ej.ContentType.TextOnly) {
                if (this.model.buttonMode == ej.ButtonMode.Split)
                    this.element.html(val);
                else {
                    this.element.empty();
                    this.imgtxtwrap = val;
                    if (this.model.arrowPosition == ej.ArrowPosition.Left || this.model.arrowPosition == ej.ArrowPosition.Top)
                        this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    else
                        this.element.append(this.imgtxtwrap, this.btnimgwrap);
                }
            } else {
                this.textspan.html(val);
            }
        },

        _setMajorIcon: function (val) {
            this.majorimgtag.removeClass(this.model.prefixIcon);
            this.majorimgtag.addClass(val);
        },

        _setMinorIcon: function (val) {
            this.minorimgtag.removeClass(this.model.suffixIcon);
            this.minorimgtag.addClass(val);
        },
        _setTarget: function (val) {
            if ((val.substring(0, 1) == ".") || (val.substring(0, 1) == "#")) {
                this.model.target = val; 
            }
            else {
                this.model.targetID = val;
                this.model.target = "#" + val;
            }
            this._renderContxtMenu();
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.element.empty();
                this.model.contentType = val;
                this._renderButtonContent();
            }
        },

        _setImagePosition: function (val) {
            if (val == ej.ImagePosition.ImageRight || val == ej.ImagePosition.ImageLeft || val == ej.ImagePosition.ImageBottom || val == ej.ImagePosition.ImageTop) {
                if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                    this.element.empty();
                    this.model.imagePosition = val;
                    this._renderButtonContent();
                }
            }
        },

        _setButtonMode: function (val) {
            if (val == ej.ButtonMode.Split || val == ej.ButtonMode.Dropdown) {
                if (val != this.model.buttonMode) {
                    this._destroy();
                    this.model.buttonMode = val;
                    this._init();
                }
            }
        },

        _setArrowPosition: function (val) {
            if (val == ej.ArrowPosition.Right || val == ej.ArrowPosition.Left || val == ej.ArrowPosition.Bottom || val == ej.ArrowPosition.Top) {
                if ((this.model.buttonMode == ej.ButtonMode.Dropdown) && (val != this.model.arrowPosition)) {
                    this.model.arrowPosition = val;
                    this.element.empty();
                    this._setSize(this.model.size);
                    this.element.removeClass("e-droparrowright e-droparrowleft e-droparrowbottom e-droparrowtop");
                    this._renderButtonContent();
                }
                else if ((this.model.buttonMode == ej.ButtonMode.Split) && (val != this.model.arrowPosition)) {
                    this.model.arrowPosition = val;
                    this._setSize(this.model.size);
                    this.innerWrap.removeClass("e-splitarrowright e-splitarrowleft e-splitarrowbottom e-splitarrowtop");
                    this._setRTL(this.model.enableRTL);
                }
            }
        },

        _setRTL: function (val) {
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropdownimg.removeClass("e-arrow-sans-up").addClass("e-arrow-sans-down");
                switch (this.model.arrowPosition) {
                    case ej.ArrowPosition.Right:
                        this.innerWrap.addClass("e-splitarrowright");
                        break;
                    case ej.ArrowPosition.Left:
                        this.innerWrap.addClass("e-splitarrowleft");
                        break;
                    case ej.ArrowPosition.Bottom:
                        this.innerWrap.addClass("e-splitarrowbottom");
                        break;
                    case ej.ArrowPosition.Top:
                        this.innerWrap.addClass("e-splitarrowtop");
                        this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
                        break;
                }
                val == true ? this.splitwrap.addClass("e-rtl e-btnrtl") : this.splitwrap.removeClass("e-rtl e-btnrtl");
            }
            else
                val == true ? this.splitwrap.addClass('e-rtl') : this.splitwrap.removeClass('e-rtl');
            this.model.enableRTL = val;
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
                if ($(this.model.target).length > 0) $(this.model.target).addClass('e-corner');  
            } else {
                this.element.removeClass('e-corner');
                if ($(this.model.target).length > 0) $(this.model.target).removeClass('e-corner');
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            this.element.removeClass(this.model.cssClass);
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropbutton.removeClass(this.model.cssClass);
                this.dropbutton.addClass(skin);
            }
            this.element.addClass(skin);
            $(this.model.target).ejMenu('option', 'cssClass', skin);  
        },

        _initialize: function () {
            if (this.element.is("button")) {
                this._render();
            } else {
                this.element.removeClass("e-splitbutton");//need to change in src level
            }
            this._timeout = null;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._controlStatus(false);
                else proxy.wrapper.attr(key, value)
            });
        },


        _render: function () {
            this.element.addClass(this.model.cssClass + " e-btn e-select e-split-btn " + (!ej.isTouchDevice() ? "e-ntouch" : "")).attr("role", "button");
            if ((this.model.text == null) || (this.model.text == "")) {
                this.model.text = this.element.text();
            }
            else
                this.element.attr("aria-describedby", this.model.text);
            if (this.model.buttonMode != ej.ButtonMode.Split && this.model.buttonMode != ej.ButtonMode.Dropdown)
                this.model.buttonMode = ej.ButtonMode.Split;
            if (this.model.arrowPosition != ej.ArrowPosition.Right && this.model.arrowPosition != ej.ArrowPosition.Left && this.model.arrowPosition != ej.ArrowPosition.Bottom && this.model.arrowPosition != ej.ArrowPosition.Top)
                this.model.arrowPosition = ej.ArrowPosition.Right;
            this.element.empty();

            this.splitwrap = (this.model.buttonMode == ej.ButtonMode.Split ? ej.buildTag('span.e-split e-widget', "", {}, { "tab-index": 0 }) : ej.buildTag('span.e-split e-drop e-widget'));
            this.splitwrap.insertBefore(this.element);
            this.innerWrap = ej.buildTag('span.e-in-wrap e-box e-padding');
            this.splitwrap.append(this.innerWrap);
            this.wrapper = this.splitwrap;
            /*DropDown Image*/
            this.dropdownimg = ej.buildTag('span.e-icon e-arrow-sans-down');
            this.btnimgwrap = ej.buildTag('div.e-split-btn-div');
            this.btnimgwrap.append(this.dropdownimg);
            /*Split Button*/
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropbutton = ej.buildTag('button.e-split-btn e-btn e-select ' + this.model.cssClass + ' e-drp-btn' + (!ej.isTouchDevice() ? " e-ntouch" : ""), "", {}, { type: "button", "data-role": "none", "id": this.element[0].id + 'drpbtn' });
                this.dropbutton.append(this.btnimgwrap);
                this.dropbutton.insertAfter(this.element);
                if (this.model.contentType == ej.ContentType.TextOnly)
                    this.dropbutton.addClass("e-btn-txt");
                else
                    this.dropbutton.addClass("e-rht-btn");
            }
            this._setSize(this.model.size);
            this.element.addClass("e-left-btn");
            this._renderButtonContent();
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.innerWrap.append(this.element);
            else
                this.innerWrap.append(this.element, this.dropbutton);
            /* If target ID is set, the value of target will be set to target prefixed with # tag */
            if ((this.model.target == null) && (this.model.targetID != null)) {
                this.model.target = "#"+this.model.targetID;
            }
            /*Rendering Context menu*/
            this._renderContxtMenu();
            this._roundedCorner(this.model.showRoundedCorner);
            this._setRTL(this.model.enableRTL);
            this._addAttr(this.model.htmlAttributes);
        },

        _renderButtonContent: function () {
            /*Image and Text*/
            this.textspan = ej.buildTag('span.e-btntxt', this.model.text);
            this.majorimgtag = ej.buildTag('span').addClass(this.model.prefixIcon);
            this.minorimgtag = ej.buildTag('span').addClass(this.model.suffixIcon);
            this.imgtxtwrap = ej.buildTag('div');
            /*Rendering Option*/
            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.majorimgtag.css("display", "inline-table");
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.majorimgtag.css("display", "inline-table");
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                }
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.majorimgtag, this.textspan, this.minorimgtag);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.majorimgtag, this.minorimgtag);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.majorimgtag);
            } else {
                this.element.addClass("e-txt");
                this.imgtxtwrap = this.model.text;
            }
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this._renderDropdownArrow();
            else
                this.element.append(this.imgtxtwrap);
        },

        _renderDropdownArrow: function () {
            this.btnimgwrap.css("position", "absolute");
            this.dropdownimg.removeClass("e-arrow-sans-up").addClass("e-arrow-sans-down");
            switch (this.model.arrowPosition) {
                case ej.ArrowPosition.Right:
                    this.element.addClass("e-droparrowright");
                    this.element.append(this.imgtxtwrap, this.btnimgwrap);
                    break;
                case ej.ArrowPosition.Left:
                    this.element.addClass("e-droparrowleft");
                    this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    break;
                case ej.ArrowPosition.Bottom:
                    this.element.addClass("e-droparrowbottom");
                    this.element.append(this.imgtxtwrap, this.btnimgwrap);
                    break;
                case ej.ArrowPosition.Top:
                    this.element.addClass("e-droparrowtop");
                    this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
                    this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    break;
            }
        },


        _setSize: function (val) {
            this.wrapper.css({ "height": "", "width": "" });
            switch (val) {
                case "mini":
                    this._splitbtnSize(val);
                    break;
                case "small":
                    this._splitbtnSize(val);
                    break;
                case "medium":
                    this._splitbtnSize(val);
                    break;
                case "large":
                    this._splitbtnSize(val); 
                    break;
                default:
                    this._splitbtnSize(val);
                    break;
            }
            if ((this.model.arrowPosition == ej.ArrowPosition.Bottom || this.model.arrowPosition == ej.ArrowPosition.Top) && this.model.height == "")
                this.splitwrap.addClass("e-btn-arrowsplit-" + val);		   // 15px added the height of the wrapper due to Arrow positioned in bottom
            var wd, ht = this.model.height === "" ? this.wrapper.outerHeight() + "px" : this.model.height;
            this._splitbtnHeight(ht);
            if (this.model.size !== "normal") {
                wd = this.model.width === "" ? this.wrapper.outerWidth() + "px" : this.model.width;
                this._splitbtnWidth(wd);
            }
            else if (this.model.width !== "") {
                wd = this.model.width;
                this._splitbtnWidth(wd);
            }
        },

        _splitbtnSize: function (val) {
        
            this.splitwrap.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal e-btn-arrowsplit-large e-btn-arrowsplit-small e-btn-arrowsplit-mini e-btn-arrowsplit-medium e-btn-arrowsplit-normal');
            if (this.model.arrowPosition == ej.ArrowPosition.Left || this.model.arrowPosition == ej.ArrowPosition.Right)
            {
            this.splitwrap.addClass("e-btn-" + val);
            }
        },
        _splitbtnHeight: function (val) {
           if ((val == "") || (val == null)) val = '30px';
          this.splitwrap.css("height", val);
        },


        _splitbtnWidth: function (val) {
            this.splitwrap.css("width", val);
        },


        _renderContxtMenu: function () {
            /* Check whether target is a class and add a id to that target element if id of that element is not given */
            if ((this.model.target != null) && ($(this.model.target).attr("id") == null)) {
                if (this.model.target.substring(0, 1) == ".") {
                    $(this.model.target).attr("id", this.element.attr('id') + "_" + this.model.target.replace(".", ""));
                }
            }
            
            $(this.model.target).ejMenu({
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                contextMenuTarget: "",
                fields: this.model.fields,
                showArrow: true,
                cssClass: "e-split " + this.model.cssClass,
                enableRTL: this.model.enableRTL
            }).on("ejMenuclose", $.proxy(this._onKeyDown, this));
        },
        _onKeyDown: function (e) {
            e.keyCode == 27 && this._hide();
        },
        _itemClick: function (args) {
            args = { status: this.model.enabled, ID: args.ID, text: args.text };
            this._trigger("itemSelected", args);
            (!$(args.element).hasClass("e-haschild")) && this._hide();
        },

        _itemMouseOver: function (args) {
            this._trigger("itemMouseOver", args);
        },

        _itemMouseOut: function (args) {
            this._trigger("itemMouseOut", args);
        },


        _wireEvents: function () {
            this._on(this.element, "click", this._btnMouseClick);
            this._on(this.element, "mousedown", this._btnMouseDown);
            /*DrpBTN*/
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this._on(this.dropbutton, "click", this._btnMouseClick);
            /*DocClk*/
            this._on($(document), "mousedown", this._docrhtclk);
        },


        _btnMouseClick: function (e) {
            var args;
            if(!this.model.enabled) return false;
            if (!$(e.currentTarget).hasClass("e-disable")) {
                if (e.currentTarget.id != this.element[0].id + "drpbtn" && this.model.buttonMode == ej.ButtonMode.Split) {
                    args = { status: this.model.enabled };
                    this._trigger("click", args);
                } else {
                    !this.contstatus && this._trigger("beforeOpen");
                    this.wrapper.addClass('e-active');
                    if (this.contstatus) {
                        this._hidecontext(e);
                    } else {
                        this._contextPosition(e);
                        this._trigger("open");
                        this._on($(window), "resize", this._OnWindowResize);
                        this.contstatus = true;
                        this.element.on("click", $.proxy(this._hidecontext, this));
                        ej.listenTouchEvent($(document), ej.startEvent(), this._documentClickHandler, false, this);
                        this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hidePopup);
                    }
                }
            }
        },

        _OnWindowResize: function (e) {
            this._contextPosition(e);
        },

        _contextPosition: function (e) {
            var position = this._getXYpos(e), posleft, targetElement;
            targetElement = (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton : this.element);
            var contextObj = $(this.model.target).ejMenu("instance");  
            posleft = position.x - ($(this.model.target).outerWidth() - (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton.outerWidth() : this.element.outerWidth()));
            if (this.model.enableRTL)
                position.x = (posleft < $(this.model.target).outerWidth()) ? position.x : posleft;
            else
                position.x = (position.x + $(this.model.target).outerWidth() < $(window).width()) ? position.x : posleft;

            contextObj.option({
                click: $.proxy(this._itemClick, this),
                mouseover: $.proxy(this._itemMouseOver, this),
                mouseout: $.proxy(this._itemMouseOut, this)
            });
            contextObj.show(position.x, position.y, targetElement, e);
        },

        _getXYpos: function (e) {
            var btnpos, btnposx, btnposy, poscur = 1, postop;
            btnpos = this._getOffset(this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton : this.element);
            btnposx = btnpos.left;
            postop = this.model.arrowPosition == ej.ArrowPosition.Top ? (btnpos.top - $(this.model.target).outerHeight() + 1) : (this.model.buttonMode == ej.ButtonMode.Split ? (btnpos.top + this.dropbutton.outerHeight()) : (btnpos.top + this.element.outerHeight())) - poscur;//1px added to top due to element border-top as none
            btnposy = (postop < 0) ? (btnpos.top + (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton.outerHeight() + this.element.outerHeight() : this.element.outerHeight()) - poscur) : postop;
            return { x: btnposx, y: btnposy };
        },
        _getOffset: function (ele) {
            var pos = ele.offset();
            if ($("body").css("position") != "static") {
                var bodyPos = $("body").offset();
                pos.left -= bodyPos.left;
                pos.top -= bodyPos.top;
            }
            return pos;
        },


        _btnMouseDown: function (e) {
            if (!$(e.currentTarget).hasClass("e-disable")) {
                this._docrhtclk(e);
            }
        },
        _hidePopup: function (e) {
            $(this.model.target).ejMenu('hide', e);    
            this._hide();
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hidePopup);
        },
        _hide: function () {
            this.contstatus = false;
            this.wrapper.removeClass('e-active');
            this.element.off("click", $.proxy(this._hidecontext, this));
            ej.listenTouchEvent($(document), ej.startEvent(), this._documentClickHandler, true, this);
            this._off($(window), "resize", this._OnWindowResize);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hide);
            this._closeEvent();
        },
        _closeEvent: function () {
            this._trigger("close");
        },

        _hidecontext: function (e) {
            if (($(e.target).is(this.element) || $(e.target).is(this.dropbutton) || $(e.target).is(this.textspan) || $(e.target).is(this.dropdownimg) || $(e.target).is(this.btnimgwrap) || !$(e.target).is(this.majorimgtag) || !$(e.target).is(this.minorimgtag)) && !$(e.target).is(this.splitwrap) && !$(e.target).parents().is($(this.model.target)) || (this.element.hasClass("e-txt") || $(e.target).is(this.imgtxtwrap))) {
                this._hidePopup(e);
            }
        },

        _documentClick: function (e) {
            if (!$(e.target).is(this.element) && !$(e.target).is(this.dropbutton) && !$(e.target).is(this.textspan) && !$(e.target).is(this.dropdownimg) && !$(e.target).is(this.btnimgwrap) && !$(e.target).is(this.majorimgtag) && !$(e.target).is(this.minorimgtag) && !$(e.target).is(this.splitwrap) && !$(e.target).parents().is($(this.model.target)) && (this.element.hasClass("e-txt") || !$(e.target).is(this.imgtxtwrap))) {
                this._hidePopup(e);
            }
        },

        _docrhtclk: function (e) {
            var isRightClick, targetElement;
            isRightClick = false;
            if (e.button) {
                isRightClick = (e.button == 2);
            } else if (e.which) {
                isRightClick = (e.which == 3); //for Opera
            }
            targetElement = e.target;
            if (isRightClick) {
                e.preventDefault();
            }
        },

    });

    ej.ContentType = { TextOnly: "textonly", ImageOnly: "imageonly", ImageBoth: "imageboth", TextAndImage: "textandimage", ImageTextImage: "imagetextimage" };

    ej.ImagePosition = { ImageRight: "imageright", ImageLeft: "imageleft", ImageTop: "imagetop", ImageBottom: "imagebottom" };

    ej.ButtonSize = { Mini: "mini", Small: "small", Medium: "medium", Large: "large" };

    ej.ButtonMode = { Split: "split", Dropdown: "dropdown" };

    ej.ArrowPosition = { Right: "right", Left: "left", Top: "top", Bottom: "bottom" };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejToggleButton", "ej.ToggleButton", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["toggleState"],
        _setFirst: false,

        _rootCSS: "e-togglebutton",

        defaults: {

            size: "normal",

            type: "button",

            width: "",

            height: "",

            enabled: true,

            toggleState: false,

            defaultText: null,

            preventToggle: false,

            activeText: null,

            contentType: "textonly",

            htmlAttributes: {},

            imagePosition: "imageleft",

            showRoundedCorner: false,

            enablePersistence: false,

            cssClass: "",

            defaultPrefixIcon: null,

            defaultSuffixIcon: null,

            activePrefixIcon: null,

            activeSuffixIcon: null,

            enableRTL: false,

            create: null,

            click: null,

            change: null,

            destroy: null
        },


        dataTypes: {
            size: "string",
            type: "enum",
            enabled: "boolean",
            showRoundedCorner: "boolean",
            preventToggle: "boolean",
            defaultText: "string",
            activeText: "string",
            contentType: "enum",
            imagePosition: "enum",
            defaultPrefixIcon: "string",
            defaultSuffixIcon: "string",
            activePrefixIcon: "string",
            activeSuffixIcon: "string",
            cssClass: "string",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            htmlAttributes: "data"
        },
        observables: ["toggleState"],
        toggleState: ej.util.valueFunction("toggleState"),


        disable: function () {
            this.buttontag.addClass("e-disable").attr({ "aria-disabled": true });
            this.model.enabled = false;
        },

        enable: function () {
            if (this.buttontag.hasClass("e-disable")) {
                this.buttontag.removeClass("e-disable").attr({ "aria-disabled": false });
                this.model.enabled = true;
            }
        },


        _init: function () {
            this._initialize();
            this._controlStatus(this.model.enabled);
            this._wireEvents();
            this.initialRender = false;
        },

        _destroy: function () {
            this._off(this.buttontag, "blur", this._tglebtnblur);
            this.element.unwrap();
            this.element.removeClass('e-chkbx-hidden');
            this.labelFinder.empty();
            this.labelFinder.text(this.model.defaultText);
            this.buttontag.remove();
            this.element.unwrap();
            this.defaultLabel.insertAfter(this.element);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "type":
                        this._settype(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "defaultText":
                        this._setDefaultText(options[option]);
                        break;
                    case "activeText":
                        this._setActiveText(options[option]);
                        break;
                    case "defaultPrefixIcon":
                        this._setDefaultMajorIcon(options[option]);
                        break;
                    case "defaultSuffixIcon":
                        this._setDefaultMinorIcon(options[option]);
                        break;
                    case "activePrefixIcon":
                        this._setActiveMajorIcon(options[option]);
                        break;
                    case "activeSuffixIcon":
                        this._setActiveMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "toggleState":
                        this._tglevaluestatus(ej.util.getVal(options[option]));
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },

        _setSize: function (val) {
            this.buttontag.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal');
            this.buttontag.addClass("e-btn-" + val);
        },

        _settype: function (val) {
            this.model.type = val;
        },


        _setHeight: function (val) {
            this.buttontag.css('height', val);
        },

        _setWidth: function (val) {
            this.buttontag.css('width', val);
        },

        _setDefaultText: function (val) {
            if (!this.toggleState()) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(val);
                } else {
                    this.defaulttxtspan.html(val);
                }
            }	
        },

        _setActiveText: function (val) {
            if (this.toggleState()) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(val);
                } else {
                    this.defaulttxtspan.html(val);
                }
            }
        },

        _setDefaultMajorIcon: function (val) {
            this.defMainIcon.removeClass(this.model.defaultPrefixIcon);
            this.defMainIcon.addClass(val);
        },

        _setDefaultMinorIcon: function (val) {
            this.defMiniIcon.removeClass(this.model.defaultSuffixIcon);
            this.defMiniIcon.addClass(val);
        },

        _setActiveMajorIcon: function (val) {
            if (this.toggleState()) {
                this.defMainIcon.removeClass(this.model.activePrefixIcon);
                this.defMainIcon.addClass(val);
            }
        },

        _setActiveMinorIcon: function (val) {
            if (this.toggleState()) {
                this.defMiniIcon.removeClass(this.model.activeSuffixIcon);
                this.defMiniIcon.addClass(val);
            }
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.buttontag.empty();
                this.model.contentType = val;
                this._renderButtonContent();
            }
        },

        _setImagePosition: function (val) {
            if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                this.buttontag.empty();
                this.model.imagePosition = val;
                this._renderButtonContent();
            }
        },

        _setRTL: function (val) {
            if (val) {
                this.buttontag.addClass("e-rtl");
            } else {
                this.buttontag.removeClass("e-rtl");
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.buttontag.removeClass(this.model.cssClass);
                this.buttontag.addClass(skin);
            }
        },

        _initialize: function () {
            if (this.element.is('[type = "checkbox"]')) {
                this._render();
            } else {
                this.element.removeClass("e-togglebutton");
            }
        },


        _render: function () {
			this.initialRender = true;
            var predecessor, labelSelector;
            /*Determine Button Type*/
            this.element.addClass('e-chkbx-hidden e-tbtn');
            if (!this.element.attr("name"))
                this.element.attr("name", this.element[0].id);
            /*Finding the label element in the dom*/
            predecessor = this.element.parents().last();
            labelSelector = "label[for='" + this.element[0].id + "']";
            this.labelFinder = predecessor.find(labelSelector);
            this.defaultLabel = predecessor.find(labelSelector).clone();
            if (!this.labelFinder.length) {
                this.labelFinder = ej.buildTag('label', "Button", {}, { "for": this.element[0].id });
                this.labelFinder.insertAfter(this.element);
            }
            if ((this.model.defaultText == null) || (this.model.defaultText == "")) {
                this.model.defaultText = this.labelFinder.text();
            }
            this.labelFinder.empty();
            this.wrapper = $('<span id="' + this.element[0].id + '-wrapper" class="e-tbtn-wrap e-widget"></span>');
            this.labelFinder.append(this.element);
            this.buttontag = ej.buildTag('button.e-togglebutton e-btn e-tbtn ' + this.model.cssClass + ' e-select', "", {}, { "role": "button", "tabindex": 0, "type": this.model.type, "data-role": "none" });
            if (!ej.isTouchDevice()) this.buttontag.addClass("e-ntouch");
            $(this.labelFinder).wrap(this.wrapper);
            this.buttontag.insertAfter(this.labelFinder);
            if (ej.util.isNullOrUndefined(this.model.activeText)) {
                this.model.activeText = this.model.defaultText;
            }
            if (ej.util.isNullOrUndefined(this.model.activePrefixIcon)) {
                this.model.activePrefixIcon = this.model.defaultPrefixIcon;
            }
            if (ej.util.isNullOrUndefined(this.model.activeSuffixIcon)) {
                this.model.activeSuffixIcon = this.model.defaultSuffixIcon;
            }
            this._setSize(this.model.size);
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            this._setRTL(this.model.enableRTL);
            this._renderButtonContent();
            if (!this.toggleState() && !ej.isNullOrUndefined(this.element.attr('checked')))
                this.toggleState(true);
            this._tglevaluestatus(this.toggleState());
            this._roundedCorner(this.model.showRoundedCorner);
            this._addAttr(this.model.htmlAttributes);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else if (key == "checked" && value == "checked") proxy._tglevaluestatus(this.toggleState());
                else proxy.wrapper.attr(key, value);
            });
        },

        _renderButtonContent: function () {
            this.imgtxtwrap = ej.buildTag('div');
            this.defaulttxtspan = ej.buildTag('span.e-btntxt' + '#' + this.element[0].id + 'textstatic',(this.toggleState() ? this.model.activeText : this.model.defaultText));
            if (this.model.contentType.indexOf("image") > -1) {
                this.defMainIcon = ej.buildTag('span ' + '#' + this.element[0].id + 'mainiconstatic');
                this.defMiniIcon = ej.buildTag('span ' + '#' + this.element[0].id + 'miniconstatic');
                (this.toggleState() ? this.defMainIcon.addClass(this.model.activePrefixIcon) : this.defMainIcon.addClass(this.model.defaultPrefixIcon));
                (this.toggleState() ? this.defMiniIcon.addClass(this.model.activeSuffixIcon) : this.defMiniIcon.addClass(this.model.defaultSuffixIcon))
            }
            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.defaulttxtspan, this.defMainIcon);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.defMainIcon.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.defaulttxtspan, this.defMainIcon);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.defMainIcon.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan);
                        break;
                }
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan, this.defMiniIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.defMainIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.defMainIcon, this.defMiniIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else {
                this.buttontag.addClass("e-txt");
                this.buttontag.text(this.model.defaultText);
            }
        },

        _tglevaluestatus: function (value) {
            if (value) {
                this._toggleButtonStatus(value);
                this.element.attr("checked", "checked");
            } else {
                this._toggleButtonStatus(value);
                this.element.prop("checked",false);
            }
        },

        _roundedCorner: function (value) {
            value == true ? this.buttontag.addClass('e-corner') : this.buttontag.removeClass('e-corner');
        },


        _wireEvents: function () {
            this._on(this.buttontag, "click", this._tglebtnclicked);
            this._on(this.buttontag, "blur", this._tglebtnblur);
        },

        _tglebtnblur:function(e){
            this.buttontag.removeClass("e-animate");
        },

        _tglebtnclicked: function (e) {
            if (this.model.preventToggle && !this.model.enabled) return false;
            if (!this.model.preventToggle) {
                if (!this.buttontag.hasClass("e-disable")) {
                    this.toggleState(this.toggleState() ? false : true);
                    if (ej.browserInfo().name == "msie" && (ej.browserInfo().version == "8.0"))
                        this._tglevaluestatus(this.toggleState());
                    else
                        this._toggleButtonStatus(this.toggleState());
                    $(this.element).prop("checked", this.toggleState());
                    e.preventDefault();
                    this.buttontag.addClass("e-animate");
                    this._trigger("click", { "isChecked": this.toggleState(), status: this.model.enabled });
                }
            }
        },

        _toggleButtonStatus: function (buttonstatus) {
            if (buttonstatus) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(this.model.activeText);
                } else {
                    this.defaulttxtspan.html(this.model.activeText);
                    this.defMainIcon.removeClass(this.model.defaultPrefixIcon).addClass(this.model.activePrefixIcon);
                    this.defMiniIcon.removeClass(this.model.defaultSuffixIcon).addClass(this.model.activeSuffixIcon);
                }
                this.buttontag.addClass("e-active").attr("aria-pressed", true);
            } else {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(this.model.defaultText);
                } else {
                    this.defaulttxtspan.html(this.model.defaultText);
                    this.defMainIcon.removeClass(this.model.activePrefixIcon).addClass(this.model.defaultPrefixIcon);
                    this.defMiniIcon.removeClass(this.model.activeSuffixIcon).addClass(this.model.defaultSuffixIcon);
                }
                this.buttontag.removeClass("e-active").attr("aria-pressed", false);
            }
            this.toggleState(buttonstatus);
            if(!this.initialRender)
            this._trigger('change', { "isChecked": this.toggleState() });
        },

    });

    ej.ContentType = {
		/**  Supports only for text content only */
		TextOnly: "textonly", 
		/** Supports only for image content only */
		ImageOnly: "imageonly", 
		/** Supports image for both ends of the button */
		ImageBoth: "imageboth", 
		/** Supports image with the text content */
		TextAndImage: "textandimage", 
		/** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
		/**  support for aligning text in left and image in right. */
		ImageRight: "imageright", 
		/**  support for aligning text in right and image in left. */
		ImageLeft: "imageleft", 
		/**  support for aligning text in bottom and image in top. */
		ImageTop: "imagetop", 
		/**  support for aligning text in top and image in bottom. */
        ImageBottom: "imagebottom"
    };

    ej.ButtonSize = {
		/**  Creates button with inbuilt default size height, width specified */
		Normal : "normal",
		/**  Creates button with inbuilt mini size height, width specified */
		Mini: "mini", 
		/**  Creates button with inbuilt small size height, width specified */
		Small: "small",
		/**  Creates button with inbuilt medium size height, width specified */
		Medium:"medium", 
		/**  Creates button with inbuilt large size height, width specified */
		Large: "large" 
    };
        
    ej.ButtonType = {
        /**  Creates button with button type as button */
        Button: "button",
        /**  Creates button with button type as reset */
        Reset: "reset",
        /**  Creates button with button type as submit */
        Submit: "submit"

    };
})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin to style the groupbutton elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejGroupButton", "ej.GroupButton", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["selectedItemIndex"],
        _setFirst: false,

        _rootCSS: "e-groupbutton",

        defaults: {

            height: "",

            width: "",

            cssClass: "",

            enabled: true,

            enableRTL: false,

            showRoundedCorner: false,

            size: "normal",

            groupButtonMode: "radiobutton",

            orientation: ej.Orientation.Horizontal,

            selectedItemIndex: [],

            htmlAttributes: {},

            dataSource: null,

            query: null,

            fields: {

                text: "text",

                prefixIcon: "prefixIcon",

                suffixIcon: "suffixIcon",

                contentType: "contentType",

                imagePosition: "imagePosition",               

                selected: "selected",

                url: "url",               

                htmlAttribute: "htmlAttribute",

                linkAttribute: "linkAttribute"                

            },

            create: null,

            beforeSelect: null,

            select: null,

            keyPress: null,

            destroy: null
        },

        dataTypes: {
            cssClass: "string",
            enabled: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            size: "enum",
            groupButtonMode: "enum",
            orientation: "enum",
            selectedItemIndex: "array"
        },

        _setModel: function (options) {
            var option, val;
            for (option in options) {
                val = options[option];
                switch (option) {
                    case "size":
                        this._setSize(val);
                        break;
                    case "height":
                        this._setDimension("height", val);
                        break;
                    case "width":
                        this._setDimension("width", val);
                        break;
                    case "enabled":
                        this._setControlStatus(val);
                        break;
                    case "showRoundedCorner":
                        this._setRoundedCorner(val);
                        break;
                    case "cssClass":
                        this._setSkin(val);
                        break;
                    case "enableRTL":
                        this._setRTL(val);
                        break;
                    case "htmlAttributes": this._setAttr(val); break;
                    case "dataSource":
                        this.element.html("");
                        this.model.dataSource = val;
                        this._initialize();
                        break;
                    case "groupButtonMode":
                        (this.model.groupButtonMode != val) && this.itemsContainer.children('.e-grp-btn-item.e-active').removeClass('e-active').attr({ "aria-selected": false });
                        break;
                    case "orientation":
                        this._setOrientation(val);
                        this._setDimension("width", this.model.width);
                        this._setDimension("height", this.model.height);
                        break;
                    case "selectedItemIndex":
                        var temp = JSON.parse(JSON.stringify(this.model.selectedItemIndex));
                        for (var i = 0, len = temp.length; i < len; i++) {
                            if(val.indexOf(temp[i]) == -1)
                                this._removeSelection($(this.items[temp[i]]));
                        }
                        this.model.selectedItemIndex =  val;
                        this._handleSeletedItem();
                        break;
                }
            }
        },
        
        _destroy: function () {
            this.element.html("");
            this._cloneElement.removeClass('e-groupbutton e-js e-widget e-box');
            this.element.replaceWith(this._cloneElement);
        },
        
        _init: function () {
            this._cloneElement = $(this.element).clone(), this._isRender = false;
            this._initialize();
            this._isRender = true;
        },

        _initialize: function () {
            this.element.addClass("e-widget e-box e-widget").attr({ "role": "group", "tabindex": "0", "aria-disabled": false });
            if (this.model.dataSource != null)
                this._checkDataBinding();
             if (!this.element.hasClass("onloading")) this._render();
        },

        _render: function () {
            this._renderItems();
            this._setSize(this.model.size);
            this._setOrientation(this.model.orientation);
            this._setDimension("width", this.model.width);
            this._setDimension("height", this.model.height);
            this._setRoundedCorner(this.model.showRoundedCorner);
            this._setAttr(this.model.htmlAttributes);
            (this.model.enableRTL) && this._setRTL(this.model.enableRTL);
            this._handleSeletedItem();
            this._setControlStatus(this.model.enabled);
        },
        _checkDataBinding: function () {
            var source = this.model.dataSource;
            if (source != null) {
                this.element.addClass("onloading");
                if (ej.DataManager && source instanceof ej.DataManager)
                    this._initDataSource(source);
                else
                    this._createItems(source);
            }
        },
        _initDataSource: function (source) {
            var proxy = this, queryPromise;
            queryPromise = source.executeQuery(this._getQuery());
            queryPromise.done(function (e) {
                proxy._createItems(e.result);
				proxy._render();
            }).fail(function (e) {
                proxy.element.removeClass("onloading");
            });
        },
        _getQuery: function () {
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [], queryManager = ej.Query(), mapper = this.model.fields;
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.dataSource.dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = this.model.query;
            return queryManager;
        },
        _createItems: function (list) {
            this.list = list;
            var i; this.mapField = this._getMapper();
            this.ultag = ej.buildTag("ul");
            this.element.append(this.ultag);
            for (i = 0; i < list.length; i++)
                this._generateTagItems(list[i], this.mapField,i);
            this.element.removeClass("onloading");          
        },
        _getMapper: function () {
            var mapper = this.model.fields, mapFld = { _text: null };
            mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
            mapFld._prefixIcon = (mapper && mapper.prefixIcon) ? mapper["prefixIcon"] : "prefixIcon";
            mapFld._suffixIcon = (mapper && mapper.suffixIcon) ? mapper["suffixIcon"] : "suffixIcon";
            mapFld._contentType = (mapper && mapper.contentType) ? mapper["contentType"] : "contentType";
            mapFld._imagePosition = (mapper && mapper.imagePosition) ? mapper["imagePosition"] : "imagePosition";
            mapFld._selected = (mapper && mapper.selected) ? mapper["selected"] : "selected";
            mapFld._url = (mapper && mapper.url) ? mapper["url"] : "url";            
            mapFld._htmlAttribute = (mapper && mapper.htmlAttribute) ? mapper["htmlAttribute"] : "htmlAttribute";
            mapFld._linkAttribute = (mapper && mapper.linkAttribute) ? mapper["linkAttribute"] : "linkAttribute";
            return mapFld;            
        },
        _generateTagItems: function (list, map, index) {
            var textspan =  (list[map._text]) ? ej.buildTag('span.e-btntxt', list[map._text]):null;
            var majorimgtag, minorimgtag, imgtxtwrap = ej.buildTag('li');
            if (list[map._htmlAttribute]) this._setAttributes(list[map._htmlAttribute], imgtxtwrap);
            var imagePosition = (list[map._imagePosition]) ? list[map._imagePosition] : "imageleft";
            var contentType = (list[map._contentType]) ? list[map._contentType] : "textonly";
            if (contentType.indexOf("image") > -1) {
                if (list[map._prefixIcon]) {
                    majorimgtag = ej.buildTag('span');
                    majorimgtag.addClass(list[map._prefixIcon]);
                }
                if (list[map._suffixIcon]) {
                    minorimgtag = ej.buildTag('span')
                    minorimgtag.addClass(list[map._suffixIcon]);
                }
            }
            switch (contentType) {
                case ej.ContentType.TextAndImage:
                    switch (imagePosition) {
                        case ej.ImagePosition.ImageRight:
                            imgtxtwrap.append(textspan, majorimgtag);
                            break;
                        case ej.ImagePosition.ImageLeft:
                            imgtxtwrap.append(majorimgtag, textspan);
                            break;
                        case ej.ImagePosition.ImageBottom:
                            majorimgtag.attr("style", "display:inherit");
                            imgtxtwrap.append(textspan, majorimgtag);
                            break;
                        case ej.ImagePosition.ImageTop:
                            majorimgtag.attr("style", "display:inherit");
                            imgtxtwrap.append(majorimgtag, textspan);
                            break;
                    }
                    break;
                case ej.ContentType.ImageTextImage:
                    imgtxtwrap.append(majorimgtag, textspan, minorimgtag);
                    break;
                case ej.ContentType.ImageBoth:
                    imgtxtwrap.append(majorimgtag, minorimgtag);
                    break;
                case ej.ContentType.ImageOnly:
                    imgtxtwrap.append(majorimgtag);
                    break;
                case ej.ContentType.TextOnly:
                    imgtxtwrap.append(textspan);
                    break;
            }
                
            if (list[map._url]) {
                aTag = ej.buildTag('a.e-grp-btn-link').attr('href', list[map._url]);
                if (list[map._linkAttribute]) this._setAttributes(list[map._linkAttribute], aTag);              
                imgtxtwrap.wrapInner(aTag);              
            }

            this.ultag.append(imgtxtwrap);
            if ((list[map._selected]) && $.inArray(index, this.model.selectedItemIndex) <= -1) {
                this.model.selectedItemIndex.push(index);
            }
        },
        _setAttributes: function (data, element) {
            for (var key in data) {
                if (key == "class")
                    element.addClass(data[key]);
                else
                    element.attr(key, data[key]);
            }
        },
        _renderItems: function () {
            var target;
            this.itemsContainer = this.element.children("ol, ul, div").addClass('e-ul');
            this.itemsContainer.children("ol, ul").remove();
            this.items = this.itemsContainer.children('li, div').addClass('e-grp-btn-item').attr({ "aria-selected": false, "aria-disabled": false });
            var i = 0, item = [], len = this.items.length, content, span;
            for (; i < len; i++) {
                item = $(this.items[i]);
                content = document.createElement('div');
                content.className = 'e-btn-content';
                if (item.children().length == 0) {
                    span = document.createElement('span');
                    $(span).text(item.text()).addClass("e-btntxt");
                    item.text("");
                    content.appendChild(span);
                } else {
                    target = (item.children('a').length > 0) ? item.children('a').children() : item.children();
                    target.appendTo(content);
                }
                target = (item.children('a').length > 0)? item.children('a'):item;                    
                target.append(content);
            }
            this.items.filter(':last').addClass('last');
        },

        _handleSeletedItem: function() {
            var index = this.model.selectedItemIndex, ele;
            if(this.model.groupButtonMode == ej.GroupButtonMode.RadioButton) {
                this._setSeletedItem($(this.items[index[index.length -1]]));
            } else {
                for (var i = 0, len = index.length; i < len; i++)
                    this._setSeletedItem($(this.items[index[i]]));
            }
        },

        _setSeletedItem: function(ele, e) {
            if(this.isSelected(ele)) return;
            var args = this._getDetails(ele); args['element'] = ele; args['event'] = e;
            if(this._triggerEvent("beforeSelect", args)) return;
            (this.model.groupButtonMode == ej.GroupButtonMode.RadioButton) && this._removeSelection(this.items.filter('.e-active'));
            ele.addClass("e-active").attr("aria-selected", true).siblings('.e-grp-btn-item').removeClass('e-hover');
            this._addSelectedIndex(this.items.index(ele));
            var args = this._getDetails(ele); args['element'] = ele; args['event'] = e;
            this._triggerEvent("select", args);
        },

        _removeSelection: function(ele) {
            ele.removeClass("e-active").attr("aria-selected", false);
            this._removeSelectedIndex(this.items.index(ele));
        },

        _getDetails: function (ele) {
            if (ele[0] != null && ele.hasClass('e-grp-btn-item')) {
                var id, disabled, selected, index;
                id = ele.attr('id');
                selected = this.isSelected(ele);
                disabled = this.isDisabled(ele);
                index = this.getIndex(ele);
                return { id: id, selected: selected, disabled: disabled, index: index };
            } else {
                return { id: "", selected: "", disabled: "", index: "" };
            }
        },

        _setAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value);
                if (key == "disabled" && value == "disabled") proxy.disable();
            });
        },

        _setSize: function (val) {
            this.element.removeClass('e-grp-btn-mini e-grp-btn-medium e-grp-btn-small e-grp-btn-large e-grp-btn-normal');
            this.element.addClass("e-grp-btn-" + val);
        },

        _setDimension: function (prop, val) {
            var minHeight = 26, defaultHeight = 35;
            /* here we use 26 constant is our minimum height and 35 constant is default height of the groupButton while rendering groupbutton without height API*/
            var add, value = 0, method = ( prop == "width") ? "outerWidth" : "outerHeight";
            if(val == "auto") {
                add = this.element[method]() - this.element[prop]();
                for (var i = 0, len = this.items.length; i < len; i++)
                   value += $(this.items[i])[method]();
                this.element.css(prop, value + add);                
            } else
                this.element.css(prop, val);

            if (prop == "height" && !this._vertical) {
                this.element.css("min-height", "").find("div.e-btn-content").removeClass("e-groupBtn-padding");
                this.element.find('.e-grp-btn-item').css("height", "").find("div.e-btn-content").css("margin-top", "").find(".e-btntxt").css("line-height", "");
                if (prop == "height" && parseInt(this.element.height()) < minHeight) {
                    this.element.addClass("e-groupbutton-hSmall").find("div.e-btn-content").addClass("e-groupBtn-padding");
                }
                else if (parseInt(this.element.height()) < defaultHeight)
                    this.element.find("div.e-btn-content").addClass("e-groupBtn-padding");
                else
                    this.element.removeClass("e-groupbutton-hSmall").find("div.e-btn-content").removeClass("e-groupBtn-padding");
            }
            else if (prop == "height") {
                this.element.css("min-height", "").find("div.e-btn-content").removeClass("e-groupBtn-padding");
                this.element.find('.e-grp-btn-item').css("height", "").find("div.e-btn-content").css("margin-top", "").find(".e-btntxt").css("line-height", "");
                var tempHeight = this.element.height() / this.items.length; /* tempHeight- the individual height of the groupButton content for min-height */
                if (tempHeight < minHeight) { 
                    this.element.css("min-height", (this.items.length * minHeight)).find("div.e-btn-content").addClass("e-groupBtn-padding");
                    this.element.find('.e-grp-btn-item').css({
                        'height': Math.ceil(this.element.height() / this.items.length),
                    });
                    
                }
                else {
                    var btnContentHeight = (this.element.height() / this.items.length); /* btnContentHeight- the individual height of the groupButton content without min-height */
                    var tempPadding = (btnContentHeight - this.element.find("div.e-btn-content").outerHeight()) / 2;
                    this.element.find('.e-grp-btn-item').css({
                        'height': btnContentHeight,
                    }).find("div.e-btn-content").css("margin-top", tempPadding + "px").find(".e-btntxt").css("line-height", this.element.find("div.e-btn-content").height() + "px");
                }
            }
        },

        _setRTL: function (val) {
            (val) ? this.element.addClass('e-rtl') : this.element.removeClass('e-rtl');
        },

        _setControlStatus: function (val) {
            (val) ? this.enable() : this.disable();
        },

        _setSkin: function (skin) {
            (this.model.cssClass != skin) && this.element.removeClass(this.model.cssClass).addClass(skin);
        },

        _setOrientation: function (val) {
            (val != ej.Orientation.Vertical) ? this.itemsContainer.removeClass("e-vertical").addClass("e-horizontal") && (this._vertical = false) : this.itemsContainer.removeClass("e-horizontal").addClass("e-vertical") && (this._vertical = true);
        },

        _setRoundedCorner: function (val) {
            (val) ? this.element.addClass('e-corner') : this.element.removeClass('e-corner');
        },

        _updateCss: function() {
            this.items.filter('.last').removeClass('last');
            this.items.filter('.e-grp-btn-item:visible:not(.e-hidden)').last().addClass('last');
            (this.items.filter('.e-hidden').length == this.items.length) ? this.element.addClass('e-no-border') : this.element.removeClass('e-no-border');
        },

        _selectDeselect: function(ele, e) {
            if(this.isSelected(ele)) {
                this._removeSelection(ele);
                this._focusedItem = null;
            } else {
                this._focusedItem = ele;
                this._setSeletedItem(ele, e);
            }
        },

        _getVisibleItems: function() {
            return this.items.filter('.e-grp-btn-item:visible:not(.e-hidden, .e-disable)');
        },

        _getNodeByID: function (node) {
            (typeof node == "number") ? (node = this.items[node]) : (typeof node != "object" && node != "") && (node = this.itemsContainer.find(".e-grp-btn-item#" + node));
            node = $(node), node = $(node[0]);
            return node;
        },

        _addSelectedIndex: function (item) {
            var index = this.model.selectedItemIndex;
            this._removeNullInArray(index);
            !index instanceof Array && (index = []);
            if (index.indexOf(item) == -1) index.push(item);
        },

        _removeSelectedIndex: function (item) {
            var index = this.model.selectedItemIndex;
            !index instanceof Array && (index = []);
            var i = index.indexOf(item);
            if (i != -1) {
                index.splice(i, 1);
                index.length == 0 && (index.push(-1));
            }
        },

        _removeNullInArray: function (array) {
            var i = array.indexOf(-1);
            if (i != -1) array.splice(i, 1);
        },

        _onKeyPress: function(e) {
            var code, items, active, toFocus;
            code = (e.keyCode) ? e.keyCode : (e.which) ? e.which : e.charCode;
            items = this._getVisibleItems();
            if (this._focusedItem) {
                active = this._focusedItem;
                this._focusedItem = null;
            } else
                active = items.filter('.e-hover');
            if(e.type == 'keydown') {
                if(((code == 38 || code == 39) && this.model.orientation != ej.Orientation.Vertical) || ((code == 39 || code == 40) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) + 1]).length > 0 ? $(items[items.index(active) + 1]) : items.first();
                } else if(((code == 37 || code == 40) && this.model.orientation != ej.Orientation.Vertical) || ((code == 37 || code == 38) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) - 1]).length > 0 ? $(items[items.index(active) - 1]) : items.last();
                } else if(code == 36) {
                    e.preventDefault();
                    toFocus = items.first();
                } else if(code == 35) {
                    e.preventDefault();
                    toFocus = items.last();
                } else if(code == 32) {
                    e.preventDefault();
                }
                if(toFocus) {
                    var args = this._getDetails(toFocus); args['element'] = toFocus; args['event'] = e;
                    if(this._triggerEvent("keyPress", args)) return;
                    toFocus.addClass("e-hover").siblings('.e-hover').removeClass('e-hover');
                }
            } else {
                switch(code) {
                    case 35: case 36: case 37: case 38: case 39: case 40: break;
                    case 13: case 32:
                        e.preventDefault();
                        this._selectDeselect(active, e);
                        break;
                    case 27:
                        e.preventDefault();
                        this.element.blur();
                        break;
                }
            }
        },

        _onfocusIn: function(e) {
            this.element.addClass("e-focus");
            (!this._clicked) && this._getVisibleItems().first().addClass("e-hover").siblings('.e-hover').removeClass('e-hover');
            this._on(this.element, "keyup keydown", this._onKeyPress);
        },

        _onfocusOut: function(e) {
            this.element.removeClass("e-focus").find('.e-grp-btn-item.e-hover').removeClass('e-hover');
            this._off(this.element, "keyup keydown", this._onKeyPress);
        },

        _onBtnHover: function (e) {
            var currentItem = $(e.currentTarget);
            (!currentItem.hasClass("e-disable")) && currentItem.addClass("e-hover");
        },

        _onBtnLeave: function (e) {
            var currentItem = $(e.currentTarget);
            (!currentItem.hasClass("e-disable")) && currentItem.removeClass("e-hover");
        },

        _onBtnClick: function (e) {
            var ele = $(e.currentTarget);
            if (!ele.hasClass("e-disable")) {
                this._selectDeselect(ele, e);
            }
        },

        _onMouseDown: function (e) {
            this._clicked = true;
        },

        _triggerEvent: function (e, data) {
            if (this._isRender) return this._trigger(e, data);
        },

        _wireUnwireEvents: function (onOff) {
            this[onOff](this.element, "mousedown", this._onMouseDown)
                [onOff](this.element, "focus", this._onfocusIn)
                [onOff](this.element, "blur", this._onfocusOut);
            this[onOff](this.items, "click", this._onBtnClick)
            if (!ej.isTouchDevice()) {
                this[onOff](this.items, "mouseenter", this._onBtnHover);
                this[onOff](this.items, "mouseleave", this._onBtnLeave);
            }
        },

        isSelected: function(element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item'))
                return element.hasClass('e-active');
        },

        isDisabled: function(element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item'))
                return element.attr('aria-disabled') == "true" ? true : false;
        },

        disable: function () {
            this.element.addClass("e-disable").attr("aria-disabled", true);
            this.items.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
            this._wireUnwireEvents("_off");
        },

        enable: function () {
            this.element.removeClass("e-disable").attr("aria-disabled", false);
            this.items.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
            this._wireUnwireEvents("_on");
        },

        show: function () {
            this.element.removeClass('e-hidden');
        },

        hide: function () {
            this.element.addClass('e-hidden');
        },

        getSelectedItem: function() {
            return this.element.find('.e-grp-btn-item.e-active');
        },

        getIndex: function(element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item'))
                return this.items.index(element);
        },

        enableItem: function (element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item')) {
                element.removeClass('e-disable').attr("aria-disabled", false);
                element.next('.e-grp-btn-item').removeClass('e-border-left e-border-bottom');
            }
        },

        disableItem: function (element) {
            element = this._getNodeByID(element);
            if (element[0] != null && element.hasClass('e-grp-btn-item') && !element.hasClass('e-disable')) {
                element.addClass('e-disable').attr("aria-disabled", true);
                if(this.model.orientation == ej.Orientation.Horizontal) {
                    this._setDimension("width", this.model.width);
                    element.next('.e-grp-btn-item').addClass('e-border-left');
                } else {
                    element.next('.e-grp-btn-item').addClass('e-border-bottom');
                    this._setDimension("height", this.model.height);
                }
            }
        },

        selectItem: function (element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item'))
                this._setSeletedItem(element);
        },

        deselectItem: function (element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item'))
                this._removeSelection(element);
        },

        showItem: function(element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item')) {
                element.removeClass('e-hidden');
                this._updateCss();
            }
        },

        hideItem: function(element) {
            element = this._getNodeByID(element);
            if(element[0] != null && element.hasClass('e-grp-btn-item')) {
                element.addClass('e-hidden');
                this._updateCss();
            }
        }

    });

    ej.ButtonSize = {
		Normal : "normal",
		Mini: "mini", 
		Small: "small",
		Medium:"medium", 
        Large: "large"
    };

    ej.GroupButtonMode = {
        CheckBox : "checkbox",
        RadioButton : "radiobutton"
    };

    ej.ContentType = {
        /**  Supports only for text content only */
        TextOnly: "textonly", 
        /** Supports only for image content only */
        ImageOnly: "imageonly", 
        /** Supports image for both ends of the button */
        ImageBoth: "imageboth", 
        /** Supports image with the text content */
        TextAndImage: "textandimage", 
        /** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
        /**  support for aligning text in left and image in right. */
        ImageRight: "imageright", 
        /**  support for aligning text in right and image in left. */
        ImageLeft: "imageleft",
        /**  support for aligning text in bottom and image in top. */
        ImageTop: "imagetop", 
        /**  support for aligning text in top and image in bottom. */
        ImageBottom: "imagebottom"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Toolbar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejToolbar", "ej.Toolbar", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,

        _rootCSS: "e-toolbar",
        angular: {
            terminal: false
        },


        defaults: {

            height: "",

            width: "",

            enabled: true,

            hide: false,

            disabledItemIndices: [],

            enabledItemIndices: [],

            enableSeparator: false,

            orientation: "horizontal",

            enableRTL: false,

            isResponsive: false,

            showRoundedCorner: false,

            htmlAttributes: {},

            dataSource: null,
			
			Items:{

                id: "id",

                tooltipText: "tooltipText",

                imageUrl: "imageUrl",

                text: "text",

                imageAttributes: "imageAttributes",

                spriteCssClass: "spriteCssClass",

                htmlAttributes: "htmlAttributes",

                group: "group",
				
				template:"template"
            },

            query: null,
		
			responsiveType:"popup",


            fields: {

                id: "id",

                tooltipText: "tooltipText",

                imageUrl: "imageUrl",

                text: "text",

                imageAttributes: "imageAttributes",

                spriteCssClass: "spriteCssClass",

                htmlAttributes: "htmlAttributes",

                group: "group",
				
				template:"template"
            },
            tooltipSettings: {
                associate: "mouseenter",
                showShadow: true,
                position: {
                    stem: { horizontal: "left", vertical: "top" }
                },
                tip: {
                    size: { width: 5, height: 5 },
					adjust: { xValue: 17, yValue: 17 }
                },
                isBalloon: false
            },

            cssClass: "",
			
			targetID : null,

            create: null,

            click: null,

            itemHover: null,

            itemLeave: null,
			
			overflowOpen:null,
			
			overflowClose:null,

            destroy: null

        },


        dataTypes: {
            enabled: "boolean",
            hide: "boolean",
            enableSeparator: "boolean",
            disabledItemIndices: "data",
            enabledItemIndices: "data",
            orientation: "enum",
            enableRTL: "boolean",
            showRoundedCorner: "boolean",
            isResponsive: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            cssClass: "string",
            htmlAttributes: "data",
			targetID: "string",
			responsiveType:"enum"
        },



        hide: function () {
            if (!this.model.enabled && (this.element.css("display") == "none")) return false;
            this.element.css("display", "none");
			this.model.hide = true;
        },

        show: function () {
            if (!this.model.enabled && (this.element.css("display") != "none")) return false;
            this.element.css("display", "block");
			this.model.hide = false;
        },


        _init: function () {
            if(this.model.targetID != null)
				this.element.html($("#" + this.model.targetID).find('ul,ol'));
			this._cloneElement = $(this.element).clone();
			//Stored the local & remote data source processed value. 
			 
			this._localDataSource=null;
            if (this.model.dataSource != null) {
                this._generateTemplate();
            }
			else if(this.model.Items != null)
			{
			  this._generateTemplate();
			}
            (!(this.model.dataSource instanceof ej.DataManager)) && this._initialize();
            this._renderTooltip(this.model.tooltipSettings);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this.model.width = options[option];
                        this._setWidth();
                        this._bindUnbindWidth();
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "disabledItemIndices": {
                        this._disableItemByIndex(options[option]);
						options[option] = this.model.disabledItemIndices;
                        break;
                    }
                    case "enabledItemIndices": {
						this._enableItemByIndex(options[option]); 
						break;
					}
                    case "isResponsive":
                        this.model.isResponsive = options[option];
                        if(this.model.isResponsive) {
							this._responsiveLayout();
							this._renderTooltip(this.model.tooltipSettings);
						}
						else
							this._removeResponsive();
                        break;
                    case "hide":
                        this._controlVisibleOptions(options[option]);
                        break;
                    case "orientation":
                        this._setOrientation(options[option]);
                        this.model.orientation = options[option];
                        this._wireResizing();
                        break;
					case "tooltipSettings":
					    this.model.tooltipSettings = $.extend(true, this.model.tooltipSettings, options[option]);
						this._renderTooltip(this.model.tooltipSettings);
						break;
                    case "enableRTL":
                        this._enableRTL(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "enableSeparator":
                        this.model.enableSeparator = options[option];
                        this._renderToolbarSeparator();
                        break;
                    case "fields":
                        $.extend(this.model.fields, options[option]);
                        break;
                    case "query":
                        this.model.query = options[option];
                        break;
                    case "dataSource":
                        for (optio in options) {
                            if (optio == "fields") $.extend(this.model.fields, options[optio]);
                            if (optio == "query") this.model.query = options[optio];
                        }
                        this._refreshTagItems(option, options[option]);
                        break;
					case "Items":
					 
					   $.extend(this.model.Items, options[option]);
					   this._refreshTagItems(option, options[option]);
					   break;
					case "targetID":
						this.model.targetID = options[option];
						this._setTargetID();					
						break;
					
                }
            }
        },
		
		_setTargetID: function() {
			this.element.removeAttr('role tabindex aria-disabled style');			
			$(this._spantag).remove();
			$(this._liTemplte).remove();			
			this._liTemplte = this._tipRes = null;		
			this.element.removeClass('e-widget e-box e-toolbarspan e-rtl');
			this.element.find('ul,ol').removeClass('e-ul e-horizontal e-vertical e-separator e-comnrtl');
			this.element.find('li').removeClass('e-tooltxt e-comnrtl');
			this.element.find('li').removeAttr('aria-label');
			this._init();
		},
		
        _refreshTagItems: function (key, value) {
            this.model[key] = value;
            this.element.empty();
            this._generateTemplate();
            this._initialize();
        },

        _setHeight: function (val) {
            this.element.css('height', val);
        },

        _setWidth: function () {
            if (this.model.width == "auto") {
                var itemswidth = parseFloat(this.element.css('border-left-width')) + parseFloat(this.element.css('border-right-width')),
                listElement = this.element.find('ul').children('li'), listUl = this.element.find('ul'),resEle;
				if(this.model.responsiveType=="inline")
				 resEle = this.element.find('.e-arrow-sans-down');
				 else
				resEle = this.element.find('.e-toolbar-res-arrow');
				
				for(var i=0, len = listUl.length; i < len; i++) {           // calculate separator width also
                    if (listUl[i] != null && $(listUl[i]).hasClass('e-separator'))
                        itemswidth += parseFloat(listUl.eq(i).css('border-right-width')) + parseFloat(listUl.eq(i).css('border-left-width'));
                }
                if (resEle[0] != null)
				 if(this.model.responsiveType=="inline")
                   itemswidth += Math.round(this.element.find('.e-arrow-sans-down').outerWidth()) + 8; // 8px for position
				 else
				   itemswidth += Math.round(this.element.find('.e-toolbar-res-arrow').outerWidth()) + 8;// 8px for position
                
                for (var i = 0, len = listElement.length; i < len; i++) {
                    if (listElement[i] != null)
                        itemswidth += Math.round(listElement.eq(i).outerWidth());
                }
                this.element.css("width", Math.ceil(itemswidth));
            } else
                this.element.css('width', this.model.width);
        },
        _bindUnbindWidth: function () {
            (this.model.width != "auto") ? this._off($(window), "resize", this._widthHandler) : this._on($(window), "resize", this._widthHandler);
        },
        _widthHandler: function (e) {
            this._setWidth(this.model.width);
        },

        _setOrientation: function (value) {
            if (value != ej.Orientation.Vertical) {
                this.element.removeClass(this.model.cssClass).addClass("e-toolbarspan " + this.model.cssClass);
                this.itemsContainer.removeClass("e-ul e-vertical").addClass("e-ul e-horizontal");
            }
            else {
                this.element.removeClass("e-toolbarspan " + this.model.cssClass).addClass(this.model.cssClass);
                this.itemsContainer.removeClass("e-ul e-horizontal").addClass("e-ul e-vertical");
            }
            this.items.addClass("e-tooltxt");
			
        },

        _reSizeHandler: function () {
			if (this._isResized && this._liTemplte.children().length > 0) {
                $(this._liTemplte.children()).insertBefore($(this.element).find("span.e-res-pos"));
                this._renderToolbarSeparator();
			  if(this.model.responsiveType!="inline")
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
            }
			this._elementWidth = (typeof window.getComputedStyle == "function") ? parseFloat(window.getComputedStyle(this.element[0]).width) : this.element.width()-1; // -1 for IE8 get exact width of an element no border and margin            
            this._liWidth = this._spanWidth;
            this._spantag.removeClass("e-display-block").addClass("e-display-none");
            for (var i = 0; i < this.itemsContainer.length; i++) {
                this._liWidth += $(this.itemsContainer[i]).outerWidth(true)+8;
                if (this._liWidth > this._elementWidth) {
                    if (!this._spantag.hasClass("e-display-block"))
                    this._spantag.removeClass("e-display-none").addClass("e-display-block");
                    this._spantag.addClass('e-res-pos');
					this._liTemplte.addClass('e-normal');
                    this._liTemplte.append(this.itemsContainer[i]);
                }
            }
			if(this.model.responsiveType=="inline")
			{
			this._liTemplte.removeClass('e-normal');
            this._liTemplte.css("width",this.element.width());
			}
		    this._isResized = true;
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _btnMouseClick: function (e) {
            var args, btnpos, btnposx, btnposy, poscur = 1, eleWidth = this.element.outerWidth(), eleHeight = this.element.outerHeight(), resWidth = $(this._liTemplte).outerWidth(), winWidth = $(window).width(), winLeft = $(window).scrollLeft();
            if (!$(e.currentTarget).hasClass("e-disable")) {
                /*Context Menu Functionality*///need to write enableRTL
                maxZ = this._getZindexPartial();
                btnpos = this._getOffset(this.element);
                btnposx = this.model.enableRTL ? btnpos.left : (btnpos.left + eleWidth - resWidth);
                btnposy = btnpos.top + eleHeight - poscur + 2;
                btnposx = btnposx < winLeft ? winLeft + poscur : ((btnposx + resWidth) > (winWidth + winLeft) ? winWidth - resWidth + winLeft - poscur : btnposx);
                if (this._contstatus) {
                    this._liTemplte.addClass("e-display-none");
					if(this.model.responsiveType=="inline")
					   this._spantag.removeClass("e-active");
                    this._contstatus = false;	
                   args = { currentTarget: e.currentTarget, clientX:e.clientX ,clientY:e.clientY , cancel:e.cancellable};					
					this._trigger("overflowClose",args);
                  					
                } else {
				   this._liTemplte.removeClass("e-display-none");
                   if(this.model.responsiveType!="inline")
				     this._liTemplte.css({ "top": btnposy + "px", "left": btnposx + "px", "z-index": maxZ });
				   if(this.model.responsiveType=="inline")	
                      this._spantag.addClass("e-active");
                    this._contstatus = true;
					args = { currentTarget: e.currentTarget, clientX:e.clientX ,clientY:e.clientY , cancel:e.cancellable};
					this._trigger("overflowOpen",args);
				 if(this.model.responsiveType!="inline")
                    this._on(ej.getScrollableParents(this.element), "scroll", this._hidecontext);
                    this.element.bind("click", $.proxy(this._hidecontext, this));
                }
                if ((this._contstatus)&&(this.model.responsiveType!="inline"))
                    this._on($(document), "mouseup", this._documentClick);
					 if(!this._contstatus)
				 this._off($(document), "mouseup", this._documentClick);
                this._removeListHover();
            }
        },

        _hidecontext: function (e) {
            if ((!$(e.target).is($("#" + this.element[0].id + "_target")))&&(this.model.responsiveType!="inline")) {
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
                this.element.unbind("click", $.proxy(this._hidecontext, this));
                this._off(ej.getScrollableParents(this.element), "scroll", this._hidecontext);
                this._off($(document), "mouseup", this._documentClick);
            }
        },

        _documentClick: function (e) {
            if (!$(e.target).is($("#" + this.element[0].id + "_target")) && !($(e.target).closest("div#" + this.element[0].id + "_hiddenlist").length != 0 || $(e.target).parents().hasClass("e-ddl-popup"))) {
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
				var args = { currentTarget: e.currentTarget, clientX: e.clientX, clientY: e.clientY, cancel: e.cancellable };
                this._trigger("overflowClose", args);
                this._off($(document), "mouseup", this._documentClick);
            }
        },

        _setSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
			var tooltipCssClass = "e-toolbarTooltip " + skin; 
			this._subControlsSetModel("cssClass", tooltipCssClass);
        },
		_subControlsSetModel : function (prop, value){
			!ej.isNullOrUndefined(this._tipToolbar) && $(this.target).ejTooltip("option", prop, value);
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("option", prop, value);
		},

        _destroy: function () {
            this.element.html("");
			!ej.isNullOrUndefined(this._tipToolbar) && $(this.target).ejTooltip("destroy");
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("destroy");
            this._cloneElement.removeClass('e-toolbar e-js');
            this.element.replaceWith(this._cloneElement);
            this._liTemplte && this._liTemplte.remove();
            this._unWireResizing();
        },

        _initialize: function () {
            this.element.attr({ "role": "toolbar", "tabindex": "0" });
            var liList = this.element.children().find('li');
            this._focusEnable = true;
            this._renderControl();
            this._responsiveLayout();
            this._wireEvents();
        },
        _responsiveLayout: function () {
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.isResponsive && (this.model.orientation == "horizontal")) {
                if (!ej.isNullOrUndefined(this._liTemplte)) {
                    !ej.isNullOrUndefined(this._tipRes) && this._tipRes.destroy();
                    $(this._liTemplte).remove();
                }
				this._spantag = $("<span id='" + this.element[0].id + "_target' class='e-icon e-toolbar-res-arrow e-rel-position e-display-block' unselectable='on'></span>");
				if(this.model.responsiveType=="inline")
				{
				this._spantag.removeClass("e-toolbar-res-arrow").addClass("e-inlinearrow e-arrow-sans-down");
				}
                this._spantag.appendTo(this.element);
				this._liTemplte = $("<div id='" + this.element[0].id + "_hiddenlist' class='e-responsive-toolbar e-display-none e-abs-position " + $(this.element)[0].className + "'></div>");
                if(this.model.responsiveType=="inline")
                   this._liTemplte.removeClass("e-abs-position").addClass("e-inline");				 
                this._spantag.appendTo(this.element);
                this._spanWidth = this._spantag.outerWidth(true) + 8; // 8px from right of span 
                if (this.model.enableRTL) this._liTemplte.addClass('e-rtl');
                this._isResized = false;
				this._elementWidth = (typeof window.getComputedStyle == "function") ? parseFloat(window.getComputedStyle(this.element[0]).width) : this.element.width()-1; // -1 for IE8 get exact width of an element no border and margin            
				this._liWidth = this._spanWidth;
				for (var i = 0; i < this.itemsContainer.length; i++) {
                this._liWidth += $(this.itemsContainer[i]).outerWidth(true);
				}
                if (this._liWidth > this._elementWidth)
                this._reSizeHandler();
                else 
				this._spantag.removeClass("e-display-block").addClass("e-display-none");
				if(this.model.responsiveType=="inline")
				  $(this.element[0]).append(this._liTemplte);
				else
                  $('body').append(this._liTemplte);
                this._renderTooltip(this.model.tooltipSettings);
            }
            this._on($("#" + this.element[0].id + "_target"), "mousedown", this._btnMouseClick);
            this._wireResizing();
            this._controlVisibleOptions(this.model.hide);
            this._enableRTL(this.model.enableRTL);
			this._disabledItems = this.model.disabledItemIndices; 
            this._controlStatus(this.model.enabled);
			this.model.disabledItemIndices = this._disabledItems;
            if (this.model.disabledItemIndices.length != 0)
                this._disableItemByIndex(this.model.disabledItemIndices);
            if (this.model.enabledItemIndices.length != 0)
                this._enableItemByIndex(this.model.enabledItemIndices);
            this._setWidth();
        },
        _removeResponsive: function () {
            $(this._spantag).remove();
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("destroy");
            var list = $(this._liTemplte).children('ul');
            $(this._liTemplte).detach();
            $(this.element).append(list);
            this.itemsContainer = this.element.children("ol,ul");
            this.items = this.itemsContainer.children('li');
            this._off(this.items, "mouseup");
            this._off(this.items, "mousedown");
            this._off(this.element, "mousedown");
            this._wireEvents();
            this._wireResizing();
            this._setWidth();
        },

        _controlVisibleOptions: function (value) {
            value != false ? this.hide() : this.show();
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
                this._liTemplte && this._liTemplte.addClass('e-corner');
            } else {
                this.element.removeClass('e-corner');
                this._liTemplte && this._liTemplte.removeClass('e-corner');
            }
			this._subControlsSetModel("showRoundedCorner", value);
        },

        _generateTemplate: function () {
            var proxy = this, queryPromise;
            this.element.css("visibility", "hidden");
            if (this.model.dataSource instanceof ej.DataManager) {
                queryPromise = this.model.dataSource.executeQuery(this.model.query);
                queryPromise.done(function (e) {
                    proxy._generateGroup(e.result);
                    proxy._initialize();
                    proxy.element.css("visibility", "");
                });
            } else if(this.model.dataSource!=null)
			{ 
			    proxy._generateGroup(proxy.model.dataSource);
                proxy.element.css("visibility", "");
               
            }
			else {
                proxy._generateGroup(proxy.model.Items);
                proxy.element.css("visibility", "");
            }
        },
        _generateGroup: function (value) {
            var proxy = this;
			this._localDataSource=value;
            var y = -1;
            var groupArray = [];
            for (var i = 0; i < value.length; i++) {
                if (this._isNewGroup(value[i][this.model.fields.group], groupArray)) {
                    groupArray[++y] = value[i][this.model.fields.group];
                    var index = -1;
                    proxy.itemsSource = [];
                    for (var x = i; x < value.length; x++) {
                        if (value[i][this.model.fields.group] == value[x][this.model.fields.group]) {
                            proxy.itemsSource[++index] = value[x];
                        }
                    }
                    proxy.element.append(proxy._generateTagitems());
                }
            }

        },
        _isNewGroup: function (value, group) {
            if (!group)
                return true;
            for (var i = 0; i < group.length; i++) {
                if (value == group[i])
                    return false;
            }
            return true;
        },


        _renderControl: function () {
            this.element.addClass("e-widget e-box");
            this._renderToolbarItems();
            this._addAttr(this.model.htmlAttributes);
            this._setOrientation(this.model.orientation);
            this._renderToolbarSeparator();
            this._setHeight(this.model.height);
            this._bindUnbindWidth();
        },

        _renderToolbarItems: function () {
            this.target = this.element[0];
            this.itemsContainer = this.element.children("ol,ul");
            this.itemsContainer.children("ol,ul").remove();
            this.items = this.itemsContainer.children('li');
            for (var i = 0; i < this.items.length; i++) {
                if (ej.isNullOrUndefined($(this.items[i]).attr("title")))
                    $(this.items[i]).attr("aria-label", this.items[i].id);
            }
            this._liCount = this.items.length;
        },

        _generateTagitems: function () {
            var list, i;
            list = this.itemsSource;
            this.ultag = ej.buildTag('ul');
            for (i = 0; i < list.length; i++) {
                this.ultag.append(this._generateLi(list[i]));
            }
            return this.ultag;
        },

        _generateLi: function (toolbarItem) {
            var litag, imgtag, divtag, i;
            litag = ej.buildTag('li');
            if (toolbarItem[this.model.fields.id])
                litag.attr('id', toolbarItem[this.model.fields.id]);
            else 
                (toolbarItem[this.model.fields.text]) && litag.attr('id', toolbarItem[this.model.fields.text]);
            if (toolbarItem[this.model.fields.tooltipText])
                litag.attr('title', toolbarItem[this.model.fields.tooltipText]);
            if ((toolbarItem[this.model.fields.imageUrl]) && (toolbarItem[this.model.fields.imageUrl] != "")) {
                //Creating the image tag
                imgtag = ej.buildTag('img.e-align', '', {}, { 'src': toolbarItem[this.model.fields.imageUrl], 'alt': toolbarItem[this.model.fields.text] });
                if (toolbarItem[this.model.fields.imageAttributes]) this._setAttributes(toolbarItem[this.model.fields.imageAttributes], imgtag);
                litag.append(imgtag);
            }
            if ((toolbarItem[this.model.fields.spriteCssClass]) && (toolbarItem[this.model.fields.spriteCssClass] != "")) {
                //Creating the Sprite image tag
                divtag = ej.buildTag('div.e-align ' + toolbarItem[this.model.fields.spriteCssClass] + ' e-spriteimg');
                litag.append(divtag);
            }
            if ((toolbarItem[this.model.fields.text]) && (toolbarItem[this.model.fields.text] != "")) {
                //Creating text Content inside the  tag
                litag.append(toolbarItem[this.model.fields.text]);
            }
            if (toolbarItem[this.model.fields.htmlAttributes]) this._setAttributes(toolbarItem[this.model.fields.htmlAttributes], litag);
              if(toolbarItem[this.model.fields.template])
			{
			
			divtag=ej.buildTag('div .e-align' ,toolbarItem[this.model.fields.template]);
			litag.append(divtag);
			}
            return litag;
        },


        _setAttributes: function (data, element) {
            for (var key in data) {
                $(element).attr(key, data[key]);
            }
        },

        _renderToolbarSeparator: function () {
            var i, len;
            if (this.model.enableSeparator) {
                for (i = 0, len = this.itemsContainer.length - 1; i < len; i++) {
                    $(this.itemsContainer[i]).addClass("e-separator");
                }
				if (this.itemsContainer.length == 1) {
                        for (i = 0, len = this.itemsContainer[0].children.length; i < len; i++) {
                            if (i == len - 1) $(this.itemsContainer[0].children[i]).removeClass("e-separator");
                            else
                                $(this.itemsContainer[0].children[i]).addClass("e-separator");
                        }
                    }    
            } else {
                this.itemsContainer.removeClass('e-separator').find('.e-separator').removeClass('e-separator');
            }
            this._setWidth();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },


        _enableRTL: function (value) {
            if (value) {
                this.element.addClass('e-rtl');
                this.items.addClass('e-comnrtl');
                if (this.model.orientation == ej.Orientation.Horizontal) {
                    this.itemsContainer.addClass('e-comnrtl');
                }
                if (this._liTemplte) this._liTemplte.addClass('e-rtl');
            } else {
                this.element.removeClass('e-rtl');
                this.items.removeClass('e-comnrtl');
                if (this.model.orientation == ej.Orientation.Horizontal) {
                    this.itemsContainer.removeClass('e-comnrtl');
                }
                if (this._liTemplte) this._liTemplte.removeClass('e-rtl');
            }
            this.model.enableRTL = value;
			this._subControlsSetModel("enableRTL", value);
            this._renderToolbarSeparator();
        },

        _renderTooltip: function (options) {
            var model =$.extend(true, {}, options); 
			if(!ej.isNullOrUndefined(model.cssClass))//which holds the css for the tooltip
				model.cssClass = model.cssClass + " e-toolbarTooltip " + this.model.cssClass;
			else 
				model.cssClass = "e-toolbarTooltip " + this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
			model.showRoundedCorner = this.model.showRoundedCorner;
			model.target ="li[data-content], li[title]" ;
			model.beforeOpen = this._showTooltip;
            this._tipToolbar = $(this.target).ejTooltip(model).data("ejTooltip");
			if(this.model.isResponsive && !ej.isNullOrUndefined(this._liTemplte))
				this._tipRes = $(this._liTemplte).ejTooltip(model).data("ejTooltip");
        },
		_showTooltip : function (e){
			var currentItem = $(e.event.currentTarget), targetItem = e.event.target;
			if (currentItem.hasClass("e-disable"))
				e.cancel = true;
		
		},
		_hideTooltip : function (){
			//tap to select the items, mousemove triggered after the tap, so private variable isHided of Tooltip is set as false
			if(!ej.isNullOrUndefined(this._tipToolbar)){ this._tipToolbar.hide(); this._tipToolbar._isHidden= false;}
			if(!ej.isNullOrUndefined(this._tipRes)){ this._tipRes.hide(); this._tipRes._isHidden = false;}
		},
        _addOverlay: function (element) {
            for (var i = 0; i < element.length; i++) {
                if (!$(element[i]).hasClass('e-disable')) {
                    $(element[i]).addClass('e-disable');
                    var ele = ej.buildTag("div.e-item-overlay");
                    $(element[i]).append(ele);
                }
            }
        },
        _removeOverlay: function (element) {
            for (var i = 0; i < element.length; i++) {
                $(element[i]).children(".e-item-overlay").remove();
            }
        },



        disableItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            if (!current.hasClass("e-disable")) {
                current.attr("aria-disabled", true).removeAttr("aria-label");
                this._addOverlay(current);
            }
            current.removeClass("e-hover e-active").attr("aria-selected", false);
        },


        enableItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.removeClass("e-disable").attr("aria-disabled", false).removeClass('e-disable');
            this._removeOverlay(current);
        },


        disableItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.disableItem(lielement);
        },

        enableItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.enableItem(lielement);
        },

        _enableItemByIndex: function (indices) {
            var index;
            if (!this.model.enabled) return false;
            if (indices.length != 0) {
                for (var i = 0; i < indices.length; i++) {
                    if ($.inArray(indices[i], this.model.disabledItemIndices) > -1) {
                        index = $.inArray(indices[i], this.model.disabledItemIndices);
                        this.enableItem(this.items[this.model.disabledItemIndices[index]]);
						this.model.disabledItemIndices.splice(index, 1);
                    }

                }
            }
        },

        _disableItemByIndex: function (indices) {
			if (!this.model.enabled) return false;
			this._disabledItems = this.model.disabledItemIndices; 
			for(var i=0; i< indices.length; i++){
				if ($.inArray(indices[i], this.model.disabledItemIndices) < 0)
					this._disabledItems.push(parseInt(indices[i]));
			}
			for (var i = 0; i < this.items.length; i++) {
				if ($.inArray(i, this.model.disabledItemIndices) > -1)
					this.disableItem(this.items[i]);
			}
			this.model.disabledItemIndices = this._disabledItems ;
        },

        disable: function () {
            if (this.element.attr("aria-disabled") == "true") return false;
            this.element.attr("aria-disabled", true).removeAttr("aria-label");
            this._addOverlay(this.items);
            if (this.model.isResponsive && (this.model.orientation == "horizontal"))
                this._spantag.addClass("e-disable");
            this.model.enabled = false;
			this._subControlsSetModel("enabled", false);
        },


        enable: function () {
			this.model.disabledItemIndices = [];
            if (this.element.attr("aria-disabled") == "false") return false;
            this.items.removeClass("e-disable");
            this._removeOverlay(this.items);
            this.element.attr("aria-disabled", false);
            if (this.model.isResponsive && (this.model.orientation == "horizontal"))
                this._spantag.removeClass("e-disable");
            this.model.enabled = true;
			this._subControlsSetModel("enabled", true);
        },


        selectItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.addClass("e-active").attr("aria-selected", true);
            this._activeItem = $(this.items).index(current);
        },


        deselectItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.removeClass("e-active").attr("aria-selected", false);
        },

        selectItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.selectItem(lielement);
        },


        deselectItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.deselectItem(lielement);
        },


        removeItem: function (lielement) {
            this.model.disabledItemIndices = [];
            var current = $(lielement);
			var j=0;
            if ((current == null) || (current.length <= 0)) return;
            current.remove();
            this.items = this.itemsContainer.children('li');
			for(var i=0; i< this.items.length ; i++){
				if($(this.items[i]).hasClass("e-disable"))
					this.model.disabledItemIndices [j++] = i;
			}
        },


        removeItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.removeItem(lielement);
        },
        _wireResizing: function () {
            (this.model.isResponsive && (this.model.orientation == "horizontal")) ? $(window).bind('resize', $.proxy(this._reSizeHandler, this)) : this._unWireResizing();
        },

        _unWireResizing: function () {
            $(window).unbind('resize', $.proxy(this._reSizeHandler, this));
        },

        _wireEvents: function () {
            this._on(this.element, "mousedown", this._clickEventHandler);
            this._on(this.element, "focus", this._focusElement);
            this._on(this.element, "blur", this._targetBlur);
            this._on(this.items, "mouseenter", this._onItemHover);
            this._on(this.items, "mouseleave", this._onItemLeave);
            this._on(this.items, "mousedown", this._onItemClick);
            this._on(this.items, "mouseup", this._onItemClick);
        },

        _onItemHover: function (e) {
            var currentItem = $(e.currentTarget), targetItem = e.target;
            if (!currentItem.hasClass("e-disable")) {
                this.items.removeClass("e-hover");
                currentItem.addClass("e-hover");
                args = { currentTarget: currentItem, target: targetItem, status: this.model.enabled };
                this._trigger("itemHover", args);
            }
        },

        _onItemClick: function (e) {
            if ($(e.currentTarget).hasClass('e-disable') || e.which!=1) return false; //e.which for Opera
            var currentItem = e.currentTarget, targetItem = e.target;
			this._hideTooltip();
            if (e.type == "mousedown") {
                this._focusEnable = false;
                $(currentItem).addClass('e-active');
                this._focusedItem = this._currentItem = $(currentItem);
				
            }
            else if (e.type == "mouseup") {
                this._removeSelection();
				 if (!$(currentItem).hasClass("e-disable")) {
                    args = { currentTarget: currentItem, text: $(currentItem).attr("data-content"), target: targetItem, status: this.model.enabled, event: e };
                    if (this.model.isResponsive && this._contstatus && $(currentItem).closest('.e-responsive-toolbar').length > 0)
                        this._activeItem = this._liTemplte.find('.e-tooltxt').index(currentItem);
                    else
                        this._activeItem = $(this.items).index(currentItem);
                    this._trigger("click", args);
                }
               
            }
        },

        _onItemLeave: function (e) {
            var currentItem = $(e.currentTarget), targetItem = e.target;
            if (!currentItem.hasClass("e-disable")) {
                this._removeSelection();
                currentItem.removeClass("e-hover");
                args = { currentTarget: currentItem, target: targetItem, status: this.model.enabled };
                this._trigger("itemLeave", args);
            }
        },

        _onKeyPress: function(e) {
            var code, items, active, toFocus;
            code = (e.keyCode) ? e.keyCode : (e.which) ? e.which : e.charCode;
            if (this.model.isResponsive && this._liTemplte.find('.e-tooltxt').length > 0) {
                this._keyPressed = true;
                this._items = (this._contstatus) ? this._liTemplte.find('.e-tooltxt') : this.element.find('.e-tooltxt');
                items = this._items.filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)');
            } else {
                this._keyPressed = false;
                items = this.items.filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)');
            }
            if (this._focusedItem) {
                active = this._focusedItem;
                this._focusedItem = null;
            } else
                active = items.filter('.e-hover');
            if(e.type == 'keydown') {
                if(((code == 38 || code == 39) && this.model.orientation != ej.Orientation.Vertical) || ((code == 39 || code == 40) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) + 1]).length > 0 ? $(items[items.index(active) + 1]) : items.first();
                } else if(((code == 37 || code == 40) && this.model.orientation != ej.Orientation.Vertical) || ((code == 37 || code == 38) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) - 1]).length > 0 ? $(items[items.index(active) - 1]) : items.last();
                } else if(code == 33 || code == 36) {
                    e.preventDefault();
                    toFocus = items.first();
                } else if(code == 34 || code == 35) {
                    e.preventDefault();
                    toFocus = items.last();
                }
                if(toFocus) {
                    this._removeListHover();
                    toFocus.addClass('e-hover');
                }
            } else {
                switch(code) {
                    case 33: case 34: case 35: case 36: case 37: case 38: case 39: case 40: break;
                    case 13: case 32:
                        e.preventDefault();
                        if (!active[0])
                            break;
                        args = { currentTarget: active[0], target: $(active)[0], status: this.model.enabled, event: e };
                        this._trigger("click", args);
                        this._removeListHover();
                        break;
                    case 27:
                        e.preventDefault();
                        this.element.blur();
                        break;
                    case 9:
                        e.preventDefault();
                        this._activeItem = $(this.items).filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)').first().index();
                        this._addListHover();
                        break;
                }
            }
        },

        _removeListHover: function () {
            $(this.items).removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = this._getActiveItem();
            if (!activeItem.hasClass('e-disable'))
                activeItem.addClass("e-hover").focus();
        },

        _getActiveItem: function () {
            if (this.model.isResponsive && this._keyPressed)
                return $(this._items[this._activeItem]);
            else
                return $(this.items[this._activeItem]);
        },

        _targetBlur: function (e) {
            e.preventDefault();
            this.element.focusout().removeClass("e-focus");
            this._removeListHover();
            this._off(this.element, "keyup", this._onKeyPress)
                ._off(this.element, "keydown", this._onKeyPress);
            this._trigger("focusOut");
        },

        _clickEventHandler: function (e) {
            this._clicked = true;
        },

        _removeSelection: function() {
            (this._currentItem && this._currentItem.attr("aria-selected") != "true") && this._currentItem.removeClass('e-active');
        },

        _focusElement: function (e) {
		    if(!this.element.hasClass("e-focus")){
				this.element.addClass("e-focus");
				this._on(this.element, "keyup", this._onKeyPress)
					._on(this.element, "keydown", this._onKeyPress);
				if (!this._focusEnable) {
					this._focusEnable = true;
					return;
				}
			}
            this._removeListHover();
            this._activeItem = (this._clicked) ? -1 : 0;
            if (this._getActiveItem().hasClass('e-disable') || this._getActiveItem().is(':hidden'))
                this._activeItem = $(this.items).filter('li:not([class*="e-disable"])').first().index();
            this._addListHover();
        },
    });
ej.Toolbar.ResponsiveType = {
        /**  Renders overflow popup with hamburger icon as usual. */
        Popup:"popup",
        /**  Renders overflow popup  below the toolbar itself on clicking the arrow. */
        Inline: "inline"
    };
	
})(jQuery, Syncfusion);


;
/**
* @fileOverview Plugin to style the Html Accordion elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejAccordion", "ej.Accordion", {
        _rootCSS: "e-acrdn",

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["selectedItemIndex", "selectedItems"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            collapsible: false,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            events: "click",

            customIcon: {

                header: "e-plus",

                selectedHeader: "e-minus"
            },

            heightAdjustMode: "content",

            height: null,

            width: null,

            headerSize: null,

            enableAnimation: true,

            selectedItemIndex: 0,

            cssClass: "",

            enableRTL: false,

            showCloseButton: false,

            showRoundedCorner: false,

            allowKeyboardNavigation: true,

            enableMultipleOpen: false,

            expandSpeed: '300',

            collapseSpeed: '300',

            selectedItems: [],

            disabledItems: [],

            enabledItems: [],

            enablePersistence: false,

            enabled: true,

            htmlAttributes: {},

            ajaxLoad: null,

            ajaxBeforeLoad: null,

            activate: null,

            beforeActivate: null,

            inActivate: null,

            beforeInactivate: null,

            ajaxSuccess: null,

            ajaxError: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            cssClass: "string",
            collapsible: "boolean",
            enabled: "boolean",
            events: "string",
            heightAdjustMode: "enum",
            ajaxSettings: "data",
            customIcon: "data",
            selectedItems: "array",
            disabledItems: "array",
            enabledItems: "array",
            enableAnimation: "boolean",
            htmlAttributes: "data",
        },


        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "events": {
                        this._off(this._headers, this.model.events);
                        this._on(this._headers, options[key], this._headerEventHandler);
                        break;
                    }
                    case "disabledItems": this.disableItems(options[key]); break;
                    case "enabledItems": this.enableItems(options[key]); break;
                    case "enabled": this._enabledAction(options[key]); break;
                    case "selectedItemIndex": {
                        if ($(this._contentPanels[options[key]]).hasClass("e-disable") || options[key] > this._headers.length || this.model.enableMultipleOpen)
                            options[key] = this.model.selectedItemIndex;
                        else {
                            this._isInteraction = true;
                            (!this.model.enableMultipleOpen) && this._activeTab(options[key], false, true);
                            this._isInteraction = false;
                        }
                        break;
                    }
                    case "heightAdjustMode": this._setHeightStyle(options[key]); break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this._roundedCorner(options[key]); break;
                    case "customIcon":
                        {
                            var icons = this.model.customIcon;
                            var newIcons = options[key];
                            this._headers.find("span." + icons.header).removeClass(icons.header).addClass(newIcons.header);
                            this._headers.find("span." + icons.selectedHeader).removeClass(icons.selectedHeader).addClass(newIcons.selectedHeader);
                            break;
                        }
                    case "height": {
                        this.element.height(options[key]);
                        this.model.height = options[key];
                        if (this.model.heightAdjustMode != "fill") {
                            if (this._getHeight() > this.element.height())
                                this._scrollerObj ? this._scrollerObj.option({ height: this.element.height() }) : this._setScoller();
                        }
                        else this._setHeight();
                        break;
                    }
                    case "width": {
                        this.element.width(options[key]);
                        if (this._scrollerObj) this._scrollerObj.option("width", options[key]);
                        if (options[key].toString().indexOf("%"))
                            $(window).on('resize', $.proxy(this._scrollerRefresh, this));
                        else $(window).off('resize', $.proxy(this._scrollerRefresh, this));
                        if (this._scrollerObj) this._scrollerObj.refresh();
                        break;
                    }
                    case "headerSize": {
                        this.model.headerSize = options[key];
                        this._setHeaderSize();
                        break;
                    }
                    case "showCloseButton":{
                        this.model.showCloseButton = options[key];
                        this._addDeleteIcon();
                        break;
                    }
                    case "allowKeyboardNavigation": {
                        if (options[key]) {
                            this._off(this.element, "keydown");
                            this._on(this.element, 'keydown', this._keyPress);
                        }
                        else
                            this._off(this.element, "keydown");
                        break;
                    }
                    case "enableRTL":
                        {
                            if (options[key])
                                this.element.addClass("e-rtl");
                            else
                                this.element.removeClass("e-rtl");
                            if (this._scrollerObj) this._scrollerObj.option("enableRTL", options[key]);
                            break;
                        }
                    case "selectedItems": this._showHideSelectedItems(options[key]);
                        options[key] = this.model.selectedItems;
                        break;
                    case "expandSpeed":this.model.expandSpeed=options[key]; break;                        
                    case "collapseSpeed":this.model.collapseSpeed=options[key]; break;                                           
                    case "htmlAttributes": this._addAttr(options[key]); break;
					case "enableMultipleOpen":
					{	
						this.model.enableMultipleOpen=options[key];						
                        if(this.model.selectedItems.length<=0)
						{
						  var enabledItems=$.extend(true, [],this.model.enabledItems); 
                          this._activeTab(this.model.enabledItems[0]);						
					    }					
					    else if((this.model.selectedItemIndex>0)&&(this.model.selectedItemIndex<=this._headers.length))
						{													
                          var temp=$.extend(true, [],this.model.selectedItems);                       
 						  temp.sort(function(a, b) {
						  return a - b;
						  });	
                          this.model.selectedItemIndex=temp[0];						   
                          var items=temp;						  
						  for(var i=1;i<items.length;i++){														
						  this._hideTab(items[i]);                             					
						  }							
					    }									
						break;
					}
                }
            }
        },

        _destroy: function () {

            this._removeBaseClass();
            this.element.children('.e-disable').removeClass("e-disable");
            this.element.removeClass("e-acrdn e-corner e-widget");
            this._headers.removeClass("e-active  e-state-disabled");
            this._contentPanels.removeClass("e-content-active e-disable e-acrdn-content-active");
            $(this._headers.find(".e-icon")).remove();
            if (this.model.height) this._contentPanels.height("auto");
            if (this.model.width) this._contentPanels.width("auto");
            if (this._scrollerObj) this._scrollerObj.destroy();
            this._unWireEvents();
        },

        _init: function () {
            this._renderControl();
            this._prevSize = this._getDimension($(this.element).parent(), "height");
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && (value == "disabled" || value == "true")) proxy.disable();
                else proxy.element.attr(key, value);
            });
        },

        _renderControl: function () {
            this._headers = this.element.find("> :even");
            this.element.attr("tabindex", 0).attr("role", "tablist");
            this._contentPanels = this._headers.next();
            //Index check negative values
            this._nagativeIndexCheck(this.model.selectedItemIndex);

            this._addBaseClass();
            this._addAttr(this.model.htmlAttributes);
			// Add header icons
            ej.buildTag("span.e-icon " + this.model.customIcon.header).prependTo(this._headers);
            if(this.model.showCloseButton)
                this._addDeleteIcon();
            this._setHeightStyle(this.model.heightAdjustMode);
            if (this.model.height) this.element.css("height", this.model.height);
            this.model.width && this.element.css("width", this.model.width);
            (!this.model.enableMultipleOpen) && this._renderHeaderIcon();
            if (!ej.isNullOrUndefined(this.model.headerSize)) this._setHeaderSize();
            this._wireEvents();
            this._roundedCorner(this.model.showRoundedCorner);
            !this.model.enabled && this._enabledAction(this.model.enabled);
            //Activate the header & content               
            this._selectedItemsAction(this.model.enableMultipleOpen ? this.model.selectedItems : this.model.selectedItemIndex);
            this._disableItems(this.model.disabledItems);
            this._setEnabledItems();
        },
        _setHeight: function () {
            var proxy = this, headersHeight = 0, activeHeaderHeight = 0;
            this.element.css("height", this.model.height);
            maxHeight = this.element.height();
            this._contentPanels.css("height", "auto");
            if (this._scrollerObj) this._scrollerObj.option("height", this.element.height());
            this._headers.each(function (i) {
                maxHeight -= $(this).outerHeight();
                headersHeight += $(this).outerHeight();
                if ($(proxy._contentPanels[i]).hasClass("e-acrdn-content-active"))
                    activeHeaderHeight += $(proxy._contentPanels[i]).outerHeight();
            });
            maxPadding = 0;
            var padding = this.element.height() - (activeHeaderHeight + headersHeight);
            if (padding > 0)
                this._contentPanels.each(function () {
                    $(this).height($(this).height() + padding / proxy.element.find(".e-select.e-active").length);
                });
            else this._setScoller();
            if (this._scrollerObj) this._scrollerObj.refresh();
        },
        _setScoller: function () {
            if (this.element.parent(".e-acrdn-scroller.e-scroller").length < 1) {
                this.scroller = ej.buildTag("div.e-acrdn-scroller");
                this.element.wrap(this.scroller);
                var width = this.element.css("width");
                this.element.parent(".e-acrdn-scroller").ejScroller({ "height": this.element.height(), "width": this.model.width });
                this.element.css("width", width);
                this._scrollerObj = this.element.parent(".e-js").data("ejScroller");
                if (this.model.showRoundedCorner) this.element.parent(".e-acrdn-scroller").addClass("e-corner");
                if (this.model.enableRTL) this._scrollerObj.option("enableRTL", true);
            }
        },
        _setHeaderSize: function () {
            var proxy = this;
            this._headers.each(function () {
                $(this).css({ "padding-top": 0, "padding-bottom": 0 });
                $(this).css("height", proxy.model.headerSize);
                var value = typeof proxy.model.headerSize === "string" && proxy.model.headerSize.indexOf("px") != -1 ? proxy.model.headerSize : proxy.model.headerSize + "px";
                $($(this).find("a[href]")).css("line-height", value);
                if ($(this).find(".e-icon").length > 0) {
                    $(this).find(".e-icon").css("margin-top", ($(this).height() / 2 - 5));
                }
            });
            if (this.model.height) {
                if (this.model.heightAdjustMode != "fill") {
                    if (this._getHeight() > this.element.height())
                        this._scrollerObj ? this._scrollerObj.refresh() : this._setScoller();
                }
                else this._setHeight();
                if (this._scrollerObj) this._scrollerObj.refresh();
            }
        },
        _addDeleteIcon: function(){
            if(this.model.showCloseButton){
                if (this.getItemsCount() > 0)
                    this._headers.append(this._createDeleteIcon());
                this._on(this._headers.children("div.e-close"), "click", this._panelDeleteClick);
            }else{
                this._headers.children("div.e-close").remove();
                this._off(this._headers.children("div.e-close"), "click", this._panelDeleteClick);
            }
        },
        _createDeleteIcon: function(){
            var deleteIcon = ej.buildTag('div.e-icon e-close');
            return deleteIcon;
        },
        _getHeight: function () {
            var headersHeight = 0, activeHeaderHeight = 0;
            var proxy = this;
            this._headers.each(function (i) {
                headersHeight += $(this).outerHeight();
                if ($(proxy._contentPanels[i]).hasClass("e-acrdn-content-active"))
                    activeHeaderHeight += $(proxy._contentPanels[i]).outerHeight();
            });
            return headersHeight + activeHeaderHeight;
        },
        _setEnabledItems: function () {
            for (var index = 0; index < this.getItemsCount() ; index++) {
                if (($.inArray(index, this.model.disabledItems) < 0) && ($.inArray(index, this.model.enabledItems) < 0))
                    this.model.enabledItems.push(index);
            }
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _panelDeleteClick: function(args){
            if(this.model.enabled){
                var currentPanel = $(args.target);
                if(currentPanel.hasClass("e-close"))
                    var index = $(this._headers).index($(args.target).parent())
                this.removeItem(index);
            }
        },

        _showHideSelectedItems: function (activeList) {
            if (this.model.enableMultipleOpen && activeList instanceof Array) {
                for (var index = 0; index < activeList.length; index++) {
                    if (activeList[index] >= 0 && activeList[index] < this._headers.length && this.model.selectedItems.indexOf(activeList[index]) == -1)
                        this._activeTab(activeList[index], true);
                }
                var len = this.model.selectedItems.length, temp = JSON.parse(JSON.stringify(this.model.selectedItems));
                for (var index = 0; index < len; index++) {
                    if (activeList.indexOf(temp[index]) == -1)
                        this._hideTab(temp[index]);
                }
            }
        },
        
        _selectedItemsAction: function (activeList) {
            if (this.model.enableMultipleOpen && activeList instanceof Array && activeList.length > 0) {
                for (var seletedindex = 0; seletedindex < activeList.length; seletedindex++) {
					if(activeList[seletedindex]>=0)
                    this._activeTab(activeList[seletedindex], true);
                }
            }
            else
                if (!(this.collapseALL && this.model.collapsible) && this.model.selectedItemIndex >= 0)
                    this._activeTab(this.model.selectedItemIndex, true);
        },

        _enabledAction: function (flag) {
            if (!flag)
                this.disable();
            else
                this.enable();
        },


        _addBaseClass: function () {
            this.element.addClass(this.model.cssClass + " e-widget");
            if (this.model.enableRTL) this.element.addClass("e-rtl");
            this._headers.addClass(" e-select").attr("role", "tab").attr("tabindex", 0);
            this._contentPanels.addClass("e-content").attr("role", "tabpanel").attr("aria-hidden", true).hide(); // hide all the content panels while loding
            if (!this.model.enableMultipleOpen)
                $(this._contentPanels[this.model.selectedItemIndex]).show();
        },


        _removeBaseClass: function () {
            this._headers.removeClass(" e-select");
            this._contentPanels.removeClass("e-content").show(); // hide all the content panels while loding
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
            }
            else if (this.element.hasClass('e-corner')) {
                this.element.removeClass('e-corner');
            }
        },

        _nagativeIndexCheck: function (index) {

            var panels;
            if (index < 0 && this.model.collapsible) {
                this.collapseALL = true;
                panels = this.getItemsCount();
                for (var pane = 0; pane < panels; pane++) {
                    this._hideTab(pane);
                }
            }
            else if (index < 0 || index >= this._headers.length)
                this.model.selectedItemIndex = 0;
        },
		collapsePanel: function (val) {
			this._expandcollapsepanel(false, val);
		},
		expandPanel: function (val) {
		    this._expandcollapsepanel(true, val);
		},
		_expandcollapsepanel: function(action, val){
			proxy = this;
			if (val instanceof Array) {
			    $.each(val, function (values, indexes) {
			        proxy._activehideIndex(action, indexes);
				});
			}
			else if (typeof val == "number") {
			    proxy._activehideIndex(action, val);
			}
		},
		_activehideIndex: function (action, indexes) {
		    if (indexes >= 0 && indexes <= proxy._headers.length) {
		        if (action)
		            this._activeTab(indexes, false, true);
		        else {
		            this._hideTab(indexes, false, true);
		            this._deleteSelectedItems(indexes);
		            if (this.model.selectedItemIndex == indexes)
		                this.model.selectedItemIndex = null;
		        }
		    }
		},
        _activeTab: function (index, raiseEvent, isCode) {

            if ($.inArray(index, this.model.disabledItems) < 0) {
                var data = { activeIndex: index, isInteraction: !isCode };
                if (true === (!raiseEvent && this._trigger("beforeActivate", data))) {
                    return false;
                }
				
                if (!this.model.enableMultipleOpen)
                    this._hideTab(this.model.selectedItemIndex, raiseEvent, isCode);
				this.model.selectedItemIndex = index;
                if(!ej.isNullOrUndefined(this.model.selectedItemIndex)){
                    var icons = this.model.customIcon;
                    this._headers.attr("tabindex", 0).removeAttr("aria-expanded");
                    this._activeHeader = this._headers.eq(index).addClass("e-active ").attr("aria-selected", true).attr("tabindex", 0).attr("aria-expanded", true);
                    this._activeHeader.find("span.e-icon")
                            .removeClass(icons.header)
                            .addClass(icons.selectedHeader);
                    this._addSelectedItems(index);
                    this._ajaxLoad();
                    this._roundedCorner(this.model.showRoundedCorner);
                    data = { activeHeader: this._activeHeader, activeIndex: this.model.selectedItemIndex, isInteraction: !isCode };
                    var proxy = this;
                    this._activeHeader.next().addClass("e-acrdn-content-active").removeAttr("aria-hidden", false);
                    this._paneAdjustSize();
                    this._activeContent = this._activeHeader.next().slideDown(this.model.enableAnimation ? this._validateSpeed(this.model.expandSpeed) : 0, function () {
                        if (!raiseEvent) proxy._trigger("activate", data);
                        if (proxy.model.height) {
                            if (proxy.model.heightAdjustMode != "fill") {
                                if (proxy._getHeight() > proxy.element.height())
                                    proxy._scrollerObj ? proxy._scrollerObj.refresh() : proxy._setScoller();
                            }
                            else proxy._setHeight();
                                if (proxy._scrollerObj) proxy._scrollerObj.refresh();
                            }
                    });
                }
            }
        },
        _paneAdjustSize: function () {
            var proxy = this;
            if (this.model.heightAdjustMode === "fill") {
                if (this.model.enableMultipleOpen) {
                    maxHeight = this._getDimension($(this.element).parent(), "height");
                    $(this.element).parent().css({ "overflow": "auto" });
                    this._headers.each(function () {
                        maxHeight -= proxy._getDimension($(this), "outerHeight");
                    });
                    var maxPadding = 0;
                    maxPadding = Math.max(maxPadding, proxy._getDimension($(this._activeHeader.next()), "outerHeight") - proxy._getDimension($(this._activeHeader.next()), "height"));
                    maxHeight = (maxHeight / this.model.selectedItems.length) - maxPadding;
                    this._headers.next().animate({ "height": maxHeight }, 300);
                }
            }
        },
        _validateSpeed:function(val){

			if(val && (val=$.trim(val.toString().toLowerCase())) && ((val == 'fast') ||(val == 'slow')))
				return val;
			return Number(val);
		},

        _hideTab: function (index, raiseEvent, isCode) {
            var icons = this.model.customIcon, data;
            if (index >= 0) {
                data = { inActiveIndex: index, isInteraction: !isCode};
                if (true === (!raiseEvent && this._trigger("beforeInactivate", data))) {
                    return false;
                }
                this._activeHeader = this._headers.eq(index).removeClass("e-active ").removeAttr("aria-selected").attr("tabindex", 0).attr("aria-expanded", false);
                this._activeHeader.find("span.e-icon")
                        .removeClass(icons.selectedHeader)
                        .addClass(icons.header);
                data = { inActiveHeader: this._activeHeader, inActiveIndex: index, isInteraction: !isCode };
                var proxy = this; proxy.raiseEvent=raiseEvent;
                this._activeHeader.next().removeClass("e-acrdn-content-active").attr("aria-hidden", true).slideUp(this.model.enableAnimation ? this._validateSpeed(this.model.collapseSpeed) : 0, function () {
                    if(!proxy.raiseEvent) proxy._trigger("inActivate", data);
                    if (proxy.model.height) {
                        if (proxy.model.heightAdjustMode != "fill") {
                            if (proxy._getHeight() > proxy.element.height())
                                proxy._scrollerObj ? proxy._scrollerObj.refresh() : proxy._setScoller();
                        }
                        else proxy._setHeight();
                    }
                    if (proxy._scrollerObj) proxy._scrollerObj.refresh();
                    proxy._paneAdjustSize();
                });
                this._deleteSelectedItems(index);
            }
        },


        _renderHeaderIcon: function () {
            if (this._headers.find(".e-icon").length <= 0) {
                var icons = this.model.customIcon;
                if (icons) {
                    if (!(this.collapseALL && this.model.collapsible)) {
                        this._headers.eq(this.model.selectedItemIndex).find("span.e-icon")
                        .removeClass(icons.header)
                        .addClass(icons.selectedHeader);
                    }
                }
            }
        },


        _ajaxLoad: function () {
            var anchor = this._activeHeader.find("a[href]");
            if (anchor.length > 0) {
                var content = $(this._contentPanels[this.model.selectedItemIndex]);
                var href = $(anchor).attr("href");
                if (href && href !== "#")
                    this._sendAjaxOptions(content, anchor[0]);
            }
        },


        _sendAjaxOptions: function (content, link) {


            if (true === (this._trigger("ajaxBeforeLoad", { url: link })))
                return false;
            content.addClass("e-load");
            var proxy = this;
            var curTabTitle = $(link).html();
            var _hrefLink = link.href.replace("#", "");
            var _ajaxOptions = {
                type: this.model.ajaxSettings.type, cache: this.model.ajaxSettings.cache, url: _hrefLink, data: this.model.ajaxSettings.data,
                dataType: this.model.ajaxSettings.dataType, contentType: this.model.ajaxSettings.contentType, async: this.model.ajaxSettings.async,
                "success": function (data) {
                    try {
                        proxy._ajaxSuccessHandler(data, content, link, curTabTitle);
                    } catch (e) {

                    }
                }, "error": function () {
                    try {
                        proxy._ajaxErrorHandler(data, link, proxy.model.selectedItemIndex, curTabTitle);
                    } catch (e) {

                    }
                }
            };
            this._sendAjaxRequest(_ajaxOptions);
        },


        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },


        _ajaxSuccessHandler: function (data, content, link, curTabTitle) {
            if (curTabTitle != null)
                $(link).html(curTabTitle);
            content.removeClass("e-load");
            content.html(data).addClass("e-acrdn-loaded"); //to indicate the content is already loaded
            var eventData = { data: data, url: link, content: content };
            this._trigger("ajaxSuccess", eventData);

            this._trigger("ajaxLoad", { url: link });
        },


        _ajaxErrorHandler: function (data, link, index, title) {
            this._trigger("ajaxError", { data: data, url: link });

            this._trigger("ajaxLoad", { url: link });
        },


        _setHeightStyle: function (heightFormat) {
            var proxy = this, maxHeight;
            if (ej.Accordion.HeightAdjustMode.Fill == heightFormat) {
                if (this.model.height != null) this._setHeight();
                else {
                    maxHeight = this._getDimension($(this.element).parent(), "height");
                    $(this.element).parent().css({ "overflow": "auto" });
                    proxy._headers.each(function () {
                        maxHeight -= proxy._getDimension($(this), "outerHeight");
                    });
                    var maxPadding = 0;
                    proxy._headers.next().each(function () {
                        maxPadding = Math.max(maxPadding, proxy._getDimension($(this), "outerHeight") - proxy._getDimension($(this), "height"));
                    }).height(maxHeight - maxPadding).css({ "overflow": "auto" });
                }
            } else if (ej.Accordion.HeightAdjustMode.Auto == heightFormat) {
                maxHeight = 0;
                proxy._headers.next().each(function () {
                    maxHeight = Math.max(maxHeight, proxy._getDimension($(this), "outerHeight"));
                }).height(maxHeight);
                this.maxAutoHeight = maxHeight;
            }
            if (ej.Accordion.HeightAdjustMode.Fill != heightFormat)
                if (this.model.height && this._getHeight() > this.element.height()) this._setScoller();
        },

        _getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().addBack().filter(':hidden');
            var prop = { visibility: 'hidden', display: 'block' };
            var tmp = [];
            $hidden.each(function () {
                var temp = {}, name;
                for (name in prop) {
                    temp[name] = this.style[name];
                    this.style[name] = prop[name];
                }
                tmp.push(temp);
            });
            value = /(outer)/g.test(method) ?
            $(element)[method](true) :
           $(element)[method]();

            $hidden.each(function (i) {
                var temp = tmp[i], name;
                for (name in prop) {
                    this.style[name] = temp[name];
                }
            });

            return value;
        },


        _headerEventHandler: function (event) {
            if (this.model.enabled) {
                event.preventDefault();
                var clicked = $(event.currentTarget);
                var index = this._headers.index(clicked);
                if (this.model.enableMultipleOpen && this._headers.eq(index).hasClass("e-active")) {
                    this._hideTab(index);
                }
				else if(this.model.enableMultipleOpen && this.model.collapsible)
					this._activeTab(index);
                else if (this.model.selectedItemIndex == index && this.model.collapsible) {
                    this._hideTab(this.model.selectedItemIndex);
                    this.model.selectedItemIndex = -1
                }
                else if (!this._headers.eq(index).hasClass("e-active")) {
                    this._activeTab(index);
                }
            }
        },

        _addSelectedItems: function (index) {
			var _items = this.model.selectedItems;
            this._removeNullInArray(_items);
            if ($.inArray(index, _items) == -1)
                this.model.selectedItems.push(index);
        },

        _deleteSelectedItems: function (index) {
			
		    var _items = this.model.selectedItems;
            if ($.inArray(index, _items) > -1) {
                this.model.selectedItems.splice($.inArray(index, _items), 1);
                _items.length == 0 && (_items.push(-1));
            }
        },
         _removeNullInArray: function (array) {
            var i = array.indexOf(-1);
            if (i != -1) array.splice(i, 1);
        },
        _deleteDisabledItems: function (index) {
            if ($.inArray(index, this.model.disabledItems) > -1) {
                position = $.inArray(index, this.model.disabledItems);
                this.model.disabledItems.splice(position, 1);
            }
        },
        _addEnabledItems: function (index) {
            if ($.inArray(index, this.model.enabledItems) < 0)
                this.model.enabledItems.push(index);
        },
        _deleteEnabledItems: function (index) {
            if ($.inArray(index, this.model.enabledItems) > -1) {
                position = $.inArray(index, this.model.enabledItems);
                this.model.enabledItems.splice(position, 1);
            }
        },

        _keyPress: function (e) {
            if (this.model.enabled) {
                var index, currentEle, targetEle = $(e.target);
                if ((targetEle.hasClass("e-select")) || (targetEle.hasClass("e-acrdn"))) {
                    index = this.model.selectedItemIndex;
                }

                if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
                else if (e.which) code = e.which; // ns4 and opera
                else code = e.charCode;
                if ((targetEle.hasClass("e-select")) || (targetEle.hasClass("e-acrdn"))) {
                    switch (code) {

                        case 39:
                        case 40:
                            e.preventDefault();
                            index = index == (this.getItemsCount() - 1) ? 0 : index + 1;
                            this._activeTab(index);
                            currentEle = $(this._headers[index]);
                            break;

                        case 38:
                        case 37:
                            e.preventDefault();
                            index = index == 0 ? (this.getItemsCount() - 1) : index - 1;
                            this._activeTab(index);
                            currentEle = $(this._headers[index]);
                            break;

                        case 35:
                            e.preventDefault();
                            currentEle = $(this._headers[this.getItemsCount() - 1]);
                            this._activeTab((this.getItemsCount() - 1));
                            break;

                        case 36:
                            e.preventDefault();
                            currentEle = $(this._headers[0]);
                            this._activeTab(0);
                            break;
                        case 32:
                        case 13:
                            e.preventDefault();
                            $(this._headers[index]).hasClass("e-active") && (this.model.enableMultipleOpen || this.model.collapsible) ? this._hideTab(index) : this._activeTab(index);
                            break;
                    }
                }
                else if (e.ctrlKey && !targetEle.hasClass("e-acrdn")) {
                    switch (code) {
                        case 38:
                            e.preventDefault();
                            index = this._contentPanels.index(targetEle.parent(".e-content"));
                            currentEle = $(this._headers[index]);
                            this._activeTab(index);
                            break;
                        case 33:
                            e.preventDefault();
                            currentEle = $(this._headers[0]);
                            this._activeTab(0);
                            break;
                        case 34:
                            e.preventDefault();
                            currentEle = $(this._headers[this.getItemsCount() - 1]);
                            this._activeTab((this.getItemsCount() - 1));
                            break;
                    }
                }
                if (!ej.isNullOrUndefined(currentEle)) {
                    currentEle.addClass("e-focus");
                    currentEle.focus();
                }
            }
        },


        _wireEvents: function () {
            this._on(this._headers, this.model.events, this._headerEventHandler);
            if (this.model.allowKeyboardNavigation) this._on(this.element, 'keydown', this._keyPress);
            $(window).on('resize', $.proxy(this._contentPaneSize, this));
            if (this.model.height && this.model.width && this.model.width.toString().indexOf("%") != -1)
                $(window).on('resize', $.proxy(this._scrollerRefresh, this));
        },
        _scrollerRefresh: function (e) {
            if (this.model.height) {
                if (this.model.heightAdjustMode != "fill") {
                    if (this._getHeight() > this.model.height)
                        this._scrollerObj ? this._scrollerObj.refresh() : this._setScoller();
                }
                else this._setHeight();
            }
        },
        _unWireEvents: function () {
            this._off(this._headers, this.model.events);
            $(window).off('resize', $.proxy(this._contentPaneSize, this));
            $(window).off('resize', $.proxy(this._scrollerRefresh, this));
            if (this.model.allowKeyboardNavigation) {
                this._off(this.element, 'keydown');
            }
        },

        _contentPaneSize: function () {
            var maxHeight = this._getDimension($(this.element).parent(), "height");
            if (this._prevSize == maxHeight) return;
            if (ej.Accordion.HeightAdjustMode.Fill == this.model.heightAdjustMode) {
                if (this.model.enableMultipleOpen) this._paneAdjustSize()
                else this._setHeightStyle(this.model.heightAdjustMode);
            }
            this._prevSize = maxHeight;
        },
        _disableItems: function (itemIndexes) {
            if ($.isArray(itemIndexes)) {
                for (var i = 0; i < itemIndexes.length; i++) {
                    $(this._headers[itemIndexes[i]]).addClass("e-disable");
                    $(this._contentPanels[itemIndexes[i]]).addClass("e-disable");
                    $(this._headers[itemIndexes[i]]).off(this.model.events);
                    if (this.model.disabledItems.indexOf(itemIndexes[i]) == -1) this.model.disabledItems.push(itemIndexes[i]);
                    this._hideTab(itemIndexes[i], true);
                    this._deleteEnabledItems(itemIndexes[i]);

                }
            }
            else {
                $(this._headers[itemIndexes]).addClass("e-disable");
                $(this._contentPanels[itemIndexes]).addClass("e-disable");
                $(this._headers[itemIndexes]).off(this.model.events);
                if ($(this.model.disabledItems).index(itemIndexes[i]) == -1 && this.model.disabledItems != itemIndexes)
                    this.model.disabledItems.push(itemIndexes);
                this._hideTab(itemIndexes, true);
                this._deleteEnabledItems(itemIndexes[i]);
            }
            if (!this.model.enableMultipleOpen) {
                var index, previous = this.model.selectedItemIndex;
                for (i = 0; i < this.model.disabledItems.length; i++) {
                    index = this.model.selectedItemIndex;
                    if ($.inArray(index, this.model.disabledItems) >= 0) {
                        index++;
                        this.model.selectedItemIndex = index;
                        //this._selectedItemsAction(index);
                    }
                }
                if(index == this._headers.length){
                    index = index - 1;
                    for (i = 0; i < this.model.disabledItems.length; i++) 
                        if ($.inArray(index, this.model.disabledItems) >= 0) {
                            index--;
                            this.model.selectedItemIndex = index;
                        }
                }
                if (previous !== this.model.selectedItemIndex)
                    this._selectedItemsAction(index);
            }
        },
        enableItems: function (itemIndexes) {
            if (!this.model.enabled) return false;
            if ($.isArray(itemIndexes)) {
                for (var i = 0; i < itemIndexes.length; i++) {
                    $(this._headers[itemIndexes[i]]).removeClass("e-disable");
                    $(this._contentPanels[itemIndexes[i]]).removeClass("e-disable");
                    this._on($(this._headers[itemIndexes[i]]), this.model.events, this._headerEventHandler);
                    if (this.model.enabledItems.indexOf(itemIndexes[i]) == -1) this.model.enabledItems.push(itemIndexes[i]);
                    this._deleteDisabledItems(itemIndexes[i]);
                }
            }
            else {
                $(this._headers[itemIndexes]).removeClass("e-disable");
                $(this._contentPanels[itemIndexes]).removeClass("e-disable");
                this._on($(this._headers[itemIndexes]), this.model.events, this._headerEventHandler);
                if (this.model.enabledItems.indexOf(itemIndexes[i]) == -1) this.model.enabledItems.push(itemIndexes[i]);
                this._deleteDisabledItems(itemIndexes);
            }
        },
        disableItems: function (itemIndexes) {
            if (!this.model.enabled) return false;
            this._disableItems(itemIndexes);
        },

        addItem: function (header_name, content, index, isAjaxReq) {
            var contentTag, headerTag, anchorTag, animation;
            if (ej.isNullOrUndefined(isAjaxReq)) isAjaxReq = false;
            if (ej.isNullOrUndefined(index) || index > this._headers.length) this._addItemIndex = this._headers.length;
            else if (index >= 0 && index <= this._headers.length) this._addItemIndex = index;
            else return false;
            animation = this.model.enableAnimation;
            if(animation)
                this.model.enableAnimation = false;
            if(this.model.heightAdjustMode == "fill") this._headers.next().height("auto")
            for (var disable_index = 0; disable_index < this.model.disabledItems.length; disable_index++) {
                if (this.model.disabledItems[disable_index] >= this._addItemIndex)
                    this.model.disabledItems[disable_index]++;
            }
            var headerTag = ej.buildTag('h3').addClass("e-select").attr("role", "tab").attr("tabindex", 0);
            if(this._addItemIndex == 0)
                headerTag.insertBefore($(this._headers[this._addItemIndex]));
            else
                headerTag.insertAfter($(this._headers[this._addItemIndex - 1]).next());
            if(this._addItemIndex <= this.model.selectedItemIndex)
                this.model.selectedItemIndex += 1;
            if (!this._headers.length) {
                this._headers = headerTag;
                this.element.append(this._headers);
                this.model.selectedItemIndex = 0;
            }
            var anchorTag = ej.buildTag("a").attr("href", isAjaxReq ? content : "#").text(header_name);
            anchorTag.appendTo(headerTag);
            if (isAjaxReq) content = "";
            if ($(content).length > 0) contentTag = $(content);
            else contentTag = ej.buildTag('div').text(content);
            contentTag.addClass("e-content").attr("role", "tabpanel").attr("aria-hidden", true).hide();
            contentTag.insertAfter(headerTag);
            this._headers = this.element.find("> :even");
            this._contentPanels = this._headers.next();
            ej.buildTag("span.e-icon " + this.model.customIcon.header).prependTo(headerTag);
            if(this.model.showCloseButton) {
                var deleteIcon = this._createDeleteIcon();
                headerTag.append(deleteIcon);
                this._on(deleteIcon, "click", this._panelDeleteClick);
            }
            if(this.model.enableMultipleOpen){
                this.model.selectedItems = [];
                for(var value = 0; value < this._headers.length; value++)
                    if($(this._headers[value]).hasClass('e-active'))
                        this.model.selectedItems.push(value);
                this._selectedItemsAction(this.model.selectedItems);
            }
            else{
                this.model.selectedItems = [];
                this.model.selectedItems.push(this.model.selectedItemIndex);
                this._selectedItemsAction(this.model.selectedItems);
            }
            this.model.width = this.model.width || this.element.css("width");
            if (this.model.height) this.element.css("height", this.model.height);
            if (this.model.enableRTL) {
                headerTag.addClass("e-rtl");
                contentTag.addClass("e-rtl");
            }
            (!this.model.enableMultipleOpen) && this._renderHeaderIcon();
            if (!ej.isNullOrUndefined(this.model.headerSize)) this._setHeaderSize();
            this._on(headerTag, this.model.events, this._headerEventHandler);
            this._roundedCorner(this.model.showRoundedCorner);

            if (this.model.heightAdjustMode == "fill" && !this.model.enableMultipleOpen)
                this._setHeightStyle(this.model.heightAdjustMode);
            this.disableItems(this.model.disabledItems);
            this._setEnabledItems();
            if(animation)
                this.model.enableAnimation = true;
        },

        removeItem: function (index) {
            if (!this.model.enabled) return false;
            if (index != null && index > -1 && index < this._headers.length) {
                var animation = this.model.enableAnimation;
                if(animation)
                    this.model.enableAnimation = false;
                var removedTab = $(this._headers[index]).remove();
                for (var disable_index = 0; disable_index < $(this.model.disabledItems).length; disable_index++) {
                    if (this.model.disabledItems[disable_index] > index)
                        this.model.disabledItems[disable_index]--;
                    else if (this.model.disabledItems[disable_index] == index) {
                        this.model.disabledItems.splice(disable_index, 1);
                    }
                }
                $(this.element.find(">div.e-content")[index]).remove();
                this._contentPanels.splice(index, 1);
                this._headers.splice(index, 1);
                if(this.model.enableMultipleOpen && this.model.selectedItemIndex == index)
                    this.model.selectedItemIndex = null;
                else if(!this.model.enableMultipleOpen){
                    if (index == this.model.selectedItemIndex && this.model.collapsible)
                        this.model.selectedItemIndex = null;
                    else if (index == 0 && this.model.selectedItemIndex == 0)
                        this.model.selectedItemIndex = 0;
                    else if (index <= this.model.selectedItemIndex)
                        this.model.selectedItemIndex -= 1;
                }
                this._unWireEvents();
                this._wireEvents();
                if (this.model.heightAdjustMode == "fill" && !this.model.enableMultipleOpen)
                   this._setHeightStyle(this.model.heightAdjustMode);
                if(this.model.enableMultipleOpen){
                    this.model.selectedItems = [];
                    for(var value = 0; value < this._headers.length; value++)
                        if($(this._headers[value]).hasClass('e-active'))
                            this.model.selectedItems.push(value);
                    this._selectedItemsAction(this.model.selectedItems);
                }else{
                    this.model.selectedItems = [];
                    this.model.selectedItems.push(this.model.selectedItemIndex);
                    this._selectedItemsAction(this.model.selectedItems);
                }
                this.disableItems(this.model.disabledItems);
                this._setEnabledItems();
                if(animation)    
                    this.model.enableAnimation = true;
            }
        },

        collapseAll: function () {
            if (this.model.enableMultipleOpen || this.model.collapsible) {
                this.model.selectedItemIndex = null;
                for (var index = 0; index < this.getItemsCount() ; index++)
                    this._hideTab(index, false, true);
            }
        },

        expandAll: function (val) {
            if (this.model.enableMultipleOpen) {
                for (var index = 0; index < this.getItemsCount() ; index++) {
                    this._activeTab(index, false, true);
                    this.model.selectedItemIndex = index;
            }
            }
        },


        disable: function () {
			this.model.enabled = false;
            for (var i = 0; i < this._headers.length; i++) this._disableItems([i]);
            
            $(this.element.parent(".e-scroller")).addClass(".e-disable");
            if (this._scrollerObj) {
                var scroller = $(this.element.parent(".e-scroller")).find(".e-vscrollbar");
                if (scroller.length > 0) this._scrollerObj.disable();
            }
            this._unWireEvents();
        },

        enable: function () {
			this.model.enabled = true;
            for (var i = 0; i < this._headers.length; i++) this.enableItems([i]);
            if (this._scrollerObj) this._scrollerObj.enable();
            this._unWireEvents();
            this._wireEvents();
        },

        refresh: function () {
            this._contentPaneSize();
        },
        _selected: function (index) {
            if (!this.model.enabled) return false;
            if (index != null && this.model.selectedItemIndex != index) {
                this._activeTab(index);
            }
        },

        show: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "visible");
        },

        hide: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "hidden");
        },


        getItemsCount: function () {
            if (this._headers) {
                return this._headers.length;
            }
        }
    });


    ej.Accordion.HeightAdjustMode = {
		/**  Height fit to the content in the panel */
        Content: "content",
		/**  Height set to the largest content in the panel */
        Auto: "auto",
		/**  Height filled to the content of the panel */
        Fill: "fill"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Progressbar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejProgressBar", "ej.ProgressBar", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["value", "percentage"],
        _setFirst: false,
        _rootCSS: "e-progressbar",

        defaults: {

            text: "",

            cssClass: "",

            minValue: 0,

            maxValue: 100,

            value: 0,

            percentage: 0,

            height: null,

            htmlAttributes: {},

            width: null,

            enabled: true,

            enableRTL: false,

            showRoundedCorner: false,

            enablePersistence: false,

            start: null,

            complete: null,

            change: null,

            create: null,

            destroy: null

        },


        dataTypes: {
            cssClass: "string",
            minValue: "number",
            maxValue: "number",
            enabled: "boolean",
            enableRTL: "boolean",
            showRoundedCorner: "boolean",
            htmlAttributes: "data"
        },


        _setValue: function (value) {
            if (value == null) value = this.model.minValue;
            else if (typeof value === "string") value = parseFloat(value);
            if (this._isNumber(value)) this.model.value = value;
            else if (!this._isNumber(this.model.value)) this.model.value = this.model.minValue;
            this.model.value = this._validateRange(this.model.value, this.model.minValue, this.model.maxValue);
            this._setProgressValue();
        },

        _setPercent: function (percent) {
            this.initial = this.model.percentage;
            if (this.initial == 100) this.initial = 0;
            if (percent == null) percent = 0;
            else if (typeof percent === "string") percent = parseFloat(percent);
            if (this._isNumber(percent)) this.model.percentage = percent;
            else if (!this._isNumber(this.model.percentage)) this.model.percentage = 0;
            this.model.percentage = this._validateRange(this.model.percentage, 0, 100);
            this.model.value = this._percentToValue(this.model.percentage);
            this._increaseProgressWidth();
        },

        _validateMinMax: function () {
            if (isNaN(this.model.minValue)) this.model.minValue = 0;
            if (isNaN(this.model.maxValue)) this.model.maxValue = 100;
        },

        _setText: function (text) {
            if (text) {
                if (this.text) this.text.html(text);
                else {
                    this.text = ej.buildTag("div.e-progress-txt", text);
                    this.element.append(this.text);
                    this._setTop();
                }
            }
            else if (this.text) {
                this.text.remove();
                this.text = null;
            }
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
            }
        },


        enable: function () {
            this.element.removeClass("e-disable");
            this.model.enabled = true;
        },

        disable: function () {
            this.element.addClass("e-disable");
            this.model.enabled = false;
        },

        getValue: function () {
            return this.model.value;
        },

        getPercentage: function () {
            return this.model.percentage;
        },


        _init: function () {
            this._initialize();
            this._render();
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "value":
                        this._setValue(options[option]);
                        options[option] = this.model.value; break;
                    case "percentage":
                        this._setPercent(options[option]);
                        options[option] = this.model.percentage; break;
                    case "minValue":
                        if (!isNaN(options[option])) this._minValidation(options[option]);
                        options[option] = this.model.minValue; break;
                    case "maxValue":
                        if (!isNaN(options[option])) this._maxValidation(options[option]);
                        options[option] = this.model.maxValue; break;
                    case "text": this._setText(options[option]); break;
                    case "height": this._setHeight(options[option]); if (this.text) this._setTop(); break;
                    case "width": this._setWidth(options[option]); break;
                    case "enabled": this._disabled(!options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "enableRTL": this._rtl(options[option]); break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },

        _destroy: function () {
            this.element.empty();
            this.element.removeClass("e-widget e-box e-corner " + this.model.cssClass).css("height","");
        },


        _initialize: function () {
            this.text = null;
            this.header = null;
            this._preVal = null;
        },


        _render: function () {
            this.initialRender = true;
            this.element.addClass("e-widget e-box " + this.model.cssClass).attr("role", "ProgressBar");
            this._setDimention();
            this.header = ej.buildTag("div.e-progress");
            this.element.append(this.header);
            this._setText(this.model.text);
            this._setInitialValue();
            this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
            this._roundedCorner(this.model.showRoundedCorner);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._disabled(false);
                else proxy.element.attr(key, value)
            });
        },


        _setDimention: function () {
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
        },

        _setHeight: function (height) {
            if (height) this.element.height(height);
        },

        _setWidth: function (width) {
            if (width) this.element.css("width", width);
        },


        _setInitialValue: function () {
            this._validateMinMax();
            if (this.model.percentage) this._setPercent(this.model.percentage);
            else this._setValue(this.model.value);
        },

        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        _checkProperties: function () {
            if (this.model.enableRTL) this._rtl(this.model.enableRTL);
            this._minValidation(this.model.minValue);
            this._maxValidation(this.model.maxValue);
            if (!this.model.enabled) this._disabled(true);
        },

        _rtl: function (boolean) {
            if (boolean) this.element.addClass("e-rtl");
            else this.element.removeClass("e-rtl");
        },

        _roundedCorner: function (value) {
            if (value && !this.element.hasClass('e-corner'))
                this.element.addClass('e-corner');
            else if (this.element.hasClass('e-corner'))
                this.element.removeClass('e-corner');
        },

        _minValidation: function (minvalue) {
            if (this.model.maxValue && this.model.maxValue < minvalue) this.model.maxValue = minvalue;
            if (this.model.value < minvalue)
                this.model.value = minvalue;
            this.model.minValue = minvalue;
            this._setProgressValue();
        },

        _maxValidation: function (maxValue) {
            if (this.model.minValue && this.model.minValue > maxValue) this.model.minValue = maxValue;
            if (this.model.value > maxValue)
                this.model.value = maxValue;
            this.model.maxValue = maxValue;
            this._setProgressValue();
        },


        _setTop: function () {
            var top = (this.element.height() - this.text.height()) / 2;
            this.text.css("top", Math.floor(top));
        },


        _increaseProgressWidth: function () {
            this.header.css("width", this.model.percentage + "%");
            if (this.initial == 0 && this.model.percentage != this.initial)
                this._raiseEvent("start");
            if (this._preVal != this.model.value) {
                this._preVal = this.model.value;
                $(this.header).attr("aria-label", this.model.percentage);
                if (this.header.hasClass("e-complete"))
                    this.header.removeClass("e-complete");
				this.initialRender ? this.initialRender = false : this._raiseEvent("change");
                if (this.model.percentage == 100) {
                    this.header.addClass("e-complete");
                    this._raiseEvent("complete");
                }
            }
        },

        _raiseEvent: function (event) {
            this._trigger(event, { value: this.model.value, percentage: this.model.percentage });
        },

        _setProgressValue: function () {
            this.initial = this.model.percentage;
            this.model.percentage = this._valueToPercent(this.model.value);
            this._increaseProgressWidth();
        },


        _isNumber: function (number) {
            return typeof number === "number" && !isNaN(number);
        },


        _validateRange: function (value, minvalue, maxValue) {
            if (value < minvalue) return minvalue;
            else if (value > maxValue) return maxValue;
            return value;
        },


        _valueToPercent: function (value) {
            if (this.model.maxValue <= this.model.minValue) return 100;
            value = this._validateRange(value, this.model.minValue, this.model.maxValue);
            value = (100 * (value - this.model.minValue)) / (this.model.maxValue - this.model.minValue);
            return value;
        },


        _percentToValue: function (percent) {
            if (this.model.maxValue <= this.model.minValue) { return this.model.minValue; }
            if (percent >= 0 && percent <= 100) {
                var diff = this.model.maxValue - this.model.minValue;
                var val = diff * percent / 100;
                percent = val + this.model.minValue;
            }
            else if (percent < 0) percent = this.model.minValue;
            else if (percent > 100) percent = this.model.maxValue;
            return percent;
        }
    });

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRating", "ej.Rating", {
        _rootCSS: "e-rating",

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            maxValue: 5,

            minValue: 0,

            value: 1,

            allowReset: true,

            shapeWidth: 23,

            shapeHeight: 23,

            orientation: "horizontal",

            incrementStep: 1,

            readOnly: false,

            htmlAttributes: {},

            enabled: true,

            showTooltip: true,

            precision: "full",

            cssClass: "",

            width: null,

            height: null,

            enablePersistence: false,

            create: null,

            click: null,

            mouseover: null,

            mouseout: null,

            change: null,

            destroy: null
        },

        dataTypes: {
            maxValue: "number",
            minValue: "number",
            allowReset: "boolean",
            shapeWidth: "number",
            shapeHeight: "number",
            orientation: "enum",
            incrementStep: "number",
            readOnly: "boolean",
            precision: "enum",
            enabled: "boolean",
            htmlAttributes: "data"
        },

        observables: ["value"],
        value: ej.util.valueFunction("value"),

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "allowReset": {
                        if (options[key]) {
                            this._showResetButton();
                        }
                        else {
                            this._hideResetButton();
                        }
                        break;
                    }
                    case "value": {
                        this.setValue(ej.util.getVal(options[key]));
                        options[key] = this.value();
                        break;
                    }
                    case "enabled": this._enabledAction(options[key]); break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "height": this._mainDiv.height(options[key]); break;
                    case "width": this._mainDiv.width(options[key]); break;
                    case "readOnly": {
                        this.model.readOnly = options[key];
                        if (options[key]) {
                            this._unWireEvents();
                            this._on(this._mainDiv.find("li"), "mouseleave touchend", this._MouseOutHandler);
                        }
                        else
                            this.refresh();
                        break;
                    }
                    case "orientation":
                        {
                            this.model.orientation = options[key];
                            this.refresh();
                            break;
                        }
                    case "maxValue":
                        {
                            this.model.maxValue = options[key];
                            this.refresh();
                            break;
                        }
                    case "minValue":
                        {
                            this.model.minValue = options[key];
                            this.refresh();
                            break;
                        }
                    case "incrementStep":
                        {
                            this.model.incrementStep = options[key];
                            this.refresh();
                            break;
                        }
                    case "shapeWidth":
                        {
                            this.model.shapeWidth = options[key];
                            this.refresh();
                            break;
                        }
                    case "shapeHeight":
                        {
                            this.model.shapeHeight = options[key];
                            this.refresh();
                            break;
                        }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                }
            }
        },


        _destroy: function () {
            this.element.show();
			this.element.val(this.element.attr("value"));
            this._unWireEvents();
            this._mainDiv.remove();
        },

        _init: function () {
            this._initialize();
        },

        _initialize: function () {
            this.element.hide();
            this._mainDiv = ej.buildTag("div.e-rating e-widget " + this.model.cssClass, "", {}, { tabindex: "0", role: "group", "aria-label": "Rating" });
            if (!ej.isNullOrUndefined(this.model.width))
                this._mainDiv.width(this.model.width);
            if (!ej.isNullOrUndefined(this.model.height))
                this._mainDiv.height(this.model.height);
            this._mainDiv.insertBefore(this.element);
            if (this.model.orientation == ej.Orientation.Horizontal) {
                this._mainDiv.addClass("e-horizontal");
            }
            else
                this._mainDiv.addClass("e-vertical");

            if (this.model.allowReset && !this.model.readOnly) {
                this._createReset();
            }
            this._validation();
            if (this.value() == 1 && this.element[0].value != "")
                this.value(this.element[0].value);
            this._renderShape();
            this._shapes = this._mainDiv.find("div.e-shape");
            this._wireEvents();
            this._CurrentIndex = 0;
            this._initCurrentValue();
            this.element.val(this.value());
            this._enabledAction(this.model.enabled);
            this._checkNameAttr();
            this._addAttr(this.model.htmlAttributes);
            if (this.model.showTooltip)
                this._renderTooltip();
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name"))
                this.element.attr({ "name": this.element[0].id });
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
				var keyName = key.toLowerCase();
                if (keyName == "class") proxy._mainDiv.addClass(value);
                else if (keyName == "readonly") proxy.model.readOnly = value;
                else if (keyName == "disabled" && value == "disabled") proxy._enabledAction(false);
                else if (keyName == "style") proxy._mainDiv.attr(key, value);
				else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy._mainDiv.attr(key, value)
            });
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this._mainDiv.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _enabledAction: function (flag) {
            if (flag) {
                this._mainDiv.removeClass("e-disable");
				this.element.removeAttr("disabled");
            }
            else {
                this._mainDiv.addClass("e-disable");
				this.element.attr("disabled","disabled");
            }
        },

        _validation: function () {
            if (this.model.incrementStep < 1) {
                this.model.incrementStep = 1;
            }
            else if (this.model.incrementStep > this.model.maxValue) {
                this.model.incrementStep = this.model.maxValue;
            }
        },

        _createReset: function () {
            if (this._mainDiv.find("div.e-reset").length <= 0)
                ej.buildTag("div.e-reset", "", { width: this.model.shapeWidth + "px", height: this.model.shapeHeight, title: "Reset" }, { role: "button", "aria-label": "reset", "aria-hidden": false }).appendTo(this._mainDiv);
            else
                this._mainDiv.find("div.e-reset").show();
        },

        _renderShape: function () {
            var _shapeCount = Math.round(this.model.maxValue / this.model.incrementStep);
            var _startCount = Math.round(this.model.minValue / this.model.incrementStep);
            var containerWith, containerHeight;
            if (this.model.orientation == ej.Rating.Orientation.Horizontal) {
                containerWith = (_shapeCount + 1) * this.model.shapeWidth;
                containerHeight = this.model.shapeHeight;
            } else if (this.model.orientation == ej.Rating.Orientation.Vertical) {
                containerWith = this.model.shapeWidth;
                containerHeight = this.model.shapeHeight * _shapeCount;
            }
            if (_shapeCount > 0) {
                var _ulTag = ej.buildTag("ul.e-ul", "", { width: containerWith + "px", height: containerHeight }, {});
                for (var i = _startCount ; i < _shapeCount; i++) {
                    var _liTag = ej.buildTag("li.e-shape-list", "", { width: this.model.shapeWidth + "px", height: this.model.shapeHeight }, { tabindex: -1, "aria-describedby": this.element.prop("id") + "_tooltip" });
                    ej.buildTag("div.e-shape inactive", "", { width: this.model.shapeWidth + "px", height: this.model.shapeHeight }).appendTo(_liTag);
                    _liTag.appendTo(_ulTag);
                }
                _ulTag.appendTo(this._mainDiv);
            }
        },

        _initCurrentValue: function () {
            if (ej.isNullOrUndefined(this.value()) || this.value() == "" || this.value() == 0)
                this._CurrentIndex = 0;
            else if (this.value() > this.model.minValue) {
                var count = (this.value() / this.model.incrementStep) - (this.model.minValue / this.model.incrementStep);
                this._CurrentIndex = count;
                this._valueRefresh(this._CurrentIndex);
                for (var i = 0; i < count; i++) {
                    if (this._shapes[i]) {
                        $(this._shapes[i]).removeClass('inactive').removeClass('active').addClass('selected');
                    }
                    else {
                        this._CurrentIndex = i;
                        break;
                    }
                }
            }
            this.value(this._CurrentIndex * this.model.incrementStep + this.model.minValue);
        },

        _valueRefresh: function (index) {
            index = Math.ceil(index);
            var value = (this.value() / this.model.incrementStep).toFixed(1);
            if (this.model.orientation == ej.Rating.Orientation.Horizontal) {
                var len;
                if (this.model.precision == "exact")
                    len = (value % 1).toFixed(1);
                else if (this.model.precision == "half")
                    len = (value % 1 > 0.5) ? 1 : 0.5;
                else
                    len = 1;
                value = ((value % 1).toFixed(1) != 0 ? len : (value / this._CurrentIndex)) * this.model.shapeWidth;
                for (var i = 0; i < index; i++) {
                    $(this._shapes[i]).css({ width: this.model.shapeWidth + "px" });
                }
                if (this._shapes != null)
                    $(this._shapes[index - 1]).css({ width: value + "px" });
            }
            else {
                value = ((value % 1).toFixed(1) != 0 ? (value % 1).toFixed(1) : (value / this._CurrentIndex)) * this.model.shapeHeight;
                for (var i = 0; i < index; i++) {
                    $(this._shapes[i]).css({ height: this.model.shapeHeight + "px" });
                }
                if (this._shapes != null) $(this._shapes[index - 1]).css({ height: value + "px" });
            }
        },


        _reset: function () {
            if (!this.model.enabled) return false;
            $(this._shapes).removeClass('active').removeClass('selected').addClass('inactive');
            this._prevValue = this.value();
            this.value(0);
            this._CurrentIndex = 0;
            //Update Hidden field
            this._currValue = this.value();
            this.element.value = this._currValue;
            this._valueChanged();
        },

        _fillExactPrecision: function (element, position) {
            var index = this._shapes.index(element) + (this.model.minValue / this.model.incrementStep) + 1;
            var option = this.model;
            if (option.orientation == ej.Rating.Orientation.Horizontal) {
                for (var i = 0; i < this._shapes.length; i++) {
                    if (i < index)
                        $(this._shapes[i]).css({ width: option.shapeWidth + "px" });
                    else
                        $(this._shapes[i]).css({ width: "0px" });
                }
                //Set width and title
                $(element).css({ width: position + "px" });
                this.toolTipValue = ((index - 1) * option.incrementStep + (position / option.shapeWidth) * option.incrementStep).toFixed(1);
            }
            else {
                for (var i = 0; i < index; i++) {
                    $(this._shapes[i]).css({ height: option.shapeHeight + "px" });
                }
                for (var i = index; i < this._shapes.length; i++) {
                    $(this._shapes[i]).css({ height: "0px" });
                }
                //Set width and title
                $(element).css({ height: position + "px" });
                this.toolTipValue = ((index - 1) * option.incrementStep + (position / option.shapeHeight) * option.incrementStep).toFixed(1);
            }
        },


        _fillHalfPrecision: function (element, position) {
            var index = this._shapes.index(element) + (this.model.minValue / this.model.incrementStep) + 1;
            var options = this.model;
            if (options.orientation == ej.Rating.Orientation.Horizontal) {
                for (var i = 0; i < this._shapes.length; i++) {
                    if (i < index)
                        $(this._shapes[i]).css({ width: options.shapeWidth + "px" });
                    else
                        $(this._shapes[i]).css({ width: "0px" });
                }
                if (position < this.model.shapeWidth/2) {
                    position = options.shapeWidth / 2;
                    $(element).css({ width: position + "px" });
                    this.toolTipValue = ((index - 1) * options.incrementStep + (position / options.shapeWidth) * options.incrementStep).toFixed(1);
                }
                else {
                    position = options.shapeWidth;
                    $(element).css({ width: position + "px" });
                    this.toolTipValue = ((index - 1) * options.incrementStep + (position / options.shapeWidth) * options.incrementStep).toFixed(1);
                }
            }
            else {
                for (var i = 0; i < this._shapes.length; i++) {
                    if (i < index)
                        $(this._shapes[i]).css({ height: this._starHeight + "px" });
                    else
                        $(this._shapes[i]).css({ height: "0px" });
                }
                //Set width and title
                if (position <= options.shapeHeight / 2) {
                    position = options.shapeHeight / 2;
                    $(element).css({ height: position + "px" });
                    this.toolTipValue = ((index - 1) * options.incrementStep + (position / options.shapeHeight) * options.incrementStep).toFixed(1);
                }
                else {
                    position = options.shapeHeight;
                    $(element).css({ height: position + "px" });
                    this.toolTipValue = ((index - 1) * options.incrementStep + (position / options.shapeHeight) * options.incrementStep).toFixed(1);
                }
            }
        },

        _fillFullPrecision: function (element) {
            var index = this._shapes.index(element) + (this.model.minValue / this.model.incrementStep) + 1;
            var option = this.model;
            if (option.orientation == ej.Rating.Orientation.Horizontal) {
                for (var i = 0; i < this._shapes.length; i++) {
                    if (i < index)
                        $(this._shapes[i]).css({ width: option.shapeWidth + "px" });
                    else
                        $(this._shapes[i]).css({ width: "0px" });
                }
                $(element).css({ width: option.shapeWidth + "px" });
				this.toolTipValue = (this.model.minValue + (this._shapes.index(element) + 1)) * this.model.incrementStep;
            }
            else {
                for (var i = 0; i < this._shapes.length; i++) {
                    if (i < index)
                        $(this._shapes[i]).css({ height: option.shapeHeight + "px" });
                    else
                        $(this._shapes[i]).css({ height: "0px" });
                }
                $(element).css({ height: option.shapeHeight + "px" });
				this.toolTipValue = (this.model.minValue + (this._shapes.index(element) + 1)) * this.model.incrementStep;
            }
        },

        _ClickHandler: function (e) {
            //Check if stars and rate it
            if (this.model.enabled) {
                var element;
                if (e.target.tagName == "LI")
                    element = e.target.firstChild;
                else if (e.target.parentNode.tagName == "LI")

                    element = e.target;
                if (element) {
                    var index = this._shapes.index(element) + 1;
                    for (var i = 0; i < index; i++) {
                        if (this._shapes[i]) {
                            $(this._shapes[i]).removeClass('inactive').removeClass('active').addClass('selected');
                        }
                    }
                    this._prevValue = this.value();
                    this._CurrentIndex = index;
                    index = index + (this.model.minValue / this.model.incrementStep);
                    var _IncrementStep = this.model.incrementStep;

                    if (this.model.orientation == ej.Rating.Orientation.Horizontal)
                        this._currValue = ((index - 1) * _IncrementStep + (element.clientWidth / this.model.shapeWidth) * _IncrementStep).toFixed(1);
                    else
                        this._currValue = ((index - 1) * _IncrementStep + (element.clientHeight / this.model.shapeHeight) * _IncrementStep).toFixed(1);
                    this.element.value = this._currValue;
                    this.value(parseFloat(this._currValue));
                    this._trigger("click", { event: e, value: this.value(), prevValue: this._prevValue });
                    this._valueChanged();
                }
                //Check if reset button and reset
                if ($(e.target).hasClass('e-reset')) {
                    this._reset();
                }
            }
        },

        _MouseOverHandler: function (e) {
            if (this.model.enabled) {
                var element, target = e.target;
                if (e.type == 'touchmove') {
                    var coor = e.originalEvent.changedTouches[0];
                    target = document.elementFromPoint(coor.pageX, coor.pageY);
                }
                if (target.tagName == "LI")
                    element = target.firstChild;
                else if (target.parentNode.tagName == "LI")
                    element = target;
                else
                    return false;
                var index = this._shapes.index(element) + 1;
                for (var i = 0; i <= this._shapes.length; i++) {
                    if (this._shapes[i]) {
                        if (i < index)
                            $(this._shapes[i]).removeClass('inactive').removeClass('selected').addClass('active');
                        else
                            $(this._shapes[i]).removeClass('active').removeClass('selected').addClass('inactive');
                    }
                }
                this._trigger("mouseover", { event: e, index: index, value: this.value() });
            }
        },

        _MouseOutHandler: function (e) {
            if (!this.model.readOnly && this.model.enabled) {
                var index = this._CurrentIndex;
                if (index != 0) {
                    for (var i = 0; i < this._shapes.length; i++) {
                        if (this._shapes[i]) {
                            if (i < index)
                                $(this._shapes[i]).removeClass('active').removeClass('inactive').addClass('selected');
                            else
                                $(this._shapes[i]).removeClass('active').addClass('inactive');
                        }
                    }
                } else
                    $(this._shapes).removeClass('active').addClass('inactive');
                //On mouse out, keep selected the stars w.r.t current Value
                this._valueRefresh(index);
                this._trigger("mouseout", { event: e, value: this.value() });
            }
            //this._hideTooltip(1000);
        },

        _MouseMoveHandler: function (e) {
            if (!this.model.readOnly && this.model.enabled) {
                var element, position, target = e.target;
                if (e.type == 'touchmove') {
                    var coor = e.originalEvent.changedTouches[0];
                    target = document.elementFromPoint(coor.pageX, coor.pageY);
                }
                if (target.tagName == "LI")
                    element = target.firstChild;
                else if (target.parentNode.tagName == "LI")
                    element = target;
                else
                    return false;
                if (this.model.orientation == ej.Rating.Orientation.Horizontal) {
                    if (ej.isNullOrUndefined(e.offsetX))
                        position = e.pageX - $(target).offset().left;
                    else
                        position = e.offsetX + 1;
                } else {
                    if (ej.isNullOrUndefined(e.offsetY))
                        position = e.pageY - $(target).offset().top;
                    else
                        position = e.offsetY + 1;
                }
                if (this.model.precision == ej.Rating.Precision.Exact)
                    this._fillExactPrecision(element, position);
                else if (this.model.precision == ej.Rating.Precision.Half)
                    this._fillHalfPrecision(element, Math.round(position));
                else this._fillFullPrecision(element);
            } else {
                this.toolTipValue = (this.value() == null || this.value() == "" ? 0 : this.value()) + ' / ' + this.model.maxValue;
            }
            $(e.target).attr("aria-label", this.toolTipValue);
            if (this.model.showTooltip && parseFloat(this.model.maxValue) >= parseFloat(this.toolTipValue)) {
                var tipObj = $(this._mainDiv).data("ejTooltip");
                tipObj._setModel({ content: this.toolTipValue });
            }
                
        },
        
        _renderTooltip: function () {
            var proxy = this;
            if (this.model.showTooltip) {

                var position = { target: { horizontal: "center", vertical: "top" }, stem: { horizontal: "center", vertical: "bottom" } };
                if (this.model.orientation == ej.Rating.Orientation.Vertical)
                    position = { target: { horizontal: "right", vertical: "center" }, stem: { horizontal: "left", vertical: "center" } };

                var tipObj = $(this._mainDiv).ejTooltip({
                    target: ".e-shape-list",
                    content: this.value(),
                    isBalloon: false,
                    collision: "flip",
                    position: position,
                    showRoundedCorner: true,
                    cssClass: this.model.cssClass,
                    beforeOpen: function (args) {
                        proxy._updateTooltipValue(args);

                    }
                }).data("ejTooltip");

                $(tipObj.tooltip).css({ "min-width": "auto" });
            }
        },

        
        _updateTooltipValue: function (args) {
            var tipObj = $(this._mainDiv).data("ejTooltip");
            tipObj._setModel({ content: this.toolTipValue });
            tipObj.show(args.event.target);
            args.cancel = true;
        },

        _wireEvents: function () {
            if (!this.model.readOnly) {
                this._on(this._mainDiv, "mousedown", this._ClickHandler);
                this._on(this._mainDiv.find("li"), "mouseenter touchmove", this._MouseOverHandler);
            }
            this._on(this._mainDiv.find("li"), "mouseleave touchend", this._MouseOutHandler);
            this._on(this._mainDiv.find("li"), ej.eventType.mouseMove, this._MouseMoveHandler);

        },

        _unWireEvents: function () {
            this._mainDiv.find("li").off("mouseenter touchmove");
            this._mainDiv.find("li").off("mouseleave touchend");
            this._mainDiv.off("mousedown");
            if (this.model.precision !== ej.Rating.Precision.Full) {
			    this._mainDiv.find("li").off(ej.eventType.mouseMove);			
            }
        },

        _valueChanged: function () {
            this.element.val(this.value());
            if (this._prevValue != this._currValue)
                this._trigger("change", { value: this.value(), prevValue: this._prevValue });
        },

        reset: function () {
            this._reset();
        },

        show: function () {
            if (!this.model.enabled) return false;
            this._mainDiv.css("visibility", "visible");
        },

        hide: function () {
            if (!this.model.enabled) return false;
            this._mainDiv.css("visibility", "hidden");
        },

        _showResetButton: function () {
            if (!this.model.enabled) return false;
            this._createReset();
        },

        _hideResetButton: function () {
            if (!this.model.enabled) return false;
            this._mainDiv.find("div.e-reset").hide()
        },

        getValue: function () {
            return this.value() == null || this.value() === "" ? "" : this.value();
        },

        setValue: function (value) {
            if (value != null && value != "null") {
                if (this.model.maxValue < value)
                    value = this.model.maxValue;
                else if (this.model.minValue > value)
                    value = this.model.minValue;
                this.value(value);
                $(this._shapes).removeClass('selected').addClass('inactive');
                this._initCurrentValue();
                this.element.val(this.value());
            }
        },

        refresh: function () {
            this._destroy();
            this._unWireEvents();
            this._initialize();
        }
    });

    ej.Rating.Precision = {
        /**  Allows user select full shape of Rating. */
        Full: "full",
        /**  Allows user select half shape of Rating. */
        Half: "half",
        /**  Allows user select exact shape of Rating. */
        Exact: "exact"
    };

    ej.Rating.Orientation = {
        /**  Renders Rating control in horizontal direction. */
        Horizontal: "horizontal",
        /**  Renders Rating control in vertical direction. */
        Vertical: "vertical"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Rotator control.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRotator", "ej.Rotator", {
        element: null,
        model: null,        
        _setFirst: false,
        validTags:["ul"],

        defaults: {

            cssClass: "",

            dataSource: null,

            query: null,

            fields: {

                text: "text",

                url: "url",

                linkAttribute: "linkAttribute",

                targetAttribute: "targetAttribute",

                thumbnailText: "text",

                thumbnailUrl: "url"
            },

            enabled: true,

            displayItemsCount: "1",

            navigateSteps: "1",

            animationSpeed: 600,

            startIndex: "0",

            enableTouch: true,

            showPlayButton: false,

            enableAutoPlay: false,

            showNavigateButton: true,

            slideWidth: "",

            slideHeight: "",

            frameSpace: "",

            isResponsive: false,

            orientation: "horizontal",

            pagerPosition: "outside",

            showThumbnail: false,

            showPager: true,

            stopOnHover: false,

            htmlAttributes: {},

            thumbnailSourceID: null,

            template: null,

            templateId: null,

            showCaption: false,

            allowKeyboardNavigation: true,

            enableRTL: false,

            animationType: "slide",

            delay: 500,

            circularMode: true,

            create: null,

            change: null,

            start: null,

            stop: null,

            thumbItemClick: null,

            pagerClick: null,

            destroy: null

        },

        dataTypes: {
            cssClass: "string",
            dataSource: "data",
            query: "data",
            fields: "data",
            template: "string",
            templateId: "array",
            enabled: "boolean",
            displayItemsCount: "",
            navigateSteps: "",
            animationSpeed: "",
            transitionDelay: "",
            startIndex: "",
            showPlayButton: "boolean",
            enableAutoPlay: "boolean",
            slideWidth: "",
            slideHeight: "",
            frameSpace: "",
            isResponsive: "boolean",
            orientation: "enum",
            pagerPosition: "enum",
            showThumbnail: "boolean",
            thumbnailSourceID: "",
            showPager: "boolean",
            showCaption: "boolean",
            enableRTL: "boolean",
            allowKeyboardNavigation: "boolean",
            circularMode: "boolean",
            animationType: "string",
            delay: "",
            htmlAttributes: "data"
        },


        _init: function () {
            this._rtlDirection = true;
            this._initialize();
            if (this.model.dataSource == null)
                this._setValues();
            this._render();
            this._wireEvent();
            if (this.model.enableAutoPlay) this.play();
            if ((!this.model.enabled) && (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0")) {
                this._outerWrapper.addClass("e-disable").attr({ "aria-disabled": true });
                this._ieEnable("addClass");
            }
        },

        _initialize: function () {
            this.element.attr("tabindex", 0);
            this._liCount = null;
            this.transitionDelay = null;
            this._animating = false;
            this._isPlaying = false;
            this._interval = null;
            this._thumbCount = null;
            this._captionChange = false;
            this._liSize = null;
            this._containerSize = null;
			this._thumbVal = this.model.showThumbnail;
            this.containerCss = this.model.orientation == ej.Orientation.Horizontal ? "outerWidth" : "outerHeight";
            this.displayCss = this.model.orientation == ej.Orientation.Horizontal ? "left" : "top";
            $.extend(jQuery.easing, {
                slowSlide: function (x, t, b, c, d) {
                    var ts = (t /= d) * t;
                    return b + c * (ts * ts);
                },
                fastSlide: function (x, t, b, c, d) {
                    var ts = (t /= d) * t;
                    var tc = ts * t;
                    return b + c * (tc * ts + -5 * ts * ts + 10 * tc + -10 * ts + 5 * t);
                },
                slide: function (x, t, b, c, d) {
                    var ts = (t /= d) * t;
                    var tc = ts * t;
                    return b + c * (6 * tc * ts + -15 * ts * ts + 10 * tc);
                }
            })
        },

        _setValues: function (val) {
            this._setLicount();
            this._setSpeed(this.model.animationSpeed);
            this._setVisibleItemCount(this.model.displayItemsCount);
            this._setItemMove(this.model.navigateSteps);
            this._setFrameSpace(this.model.frameSpace);
            this._setSlideWidth(this.model.slideWidth);
            this._setSlideHeight(this.model.slideHeight);
            this._changeProperty();
            this._setInitial();
        },
        _refresh: function () {
            this._setValues();
            this._setDimension();
            this._changeSkin();
        },
        _reRenderControl: function () {
            this._undoClone();
            this._setLicount();
            this._setSpeed(this.model.animationSpeed);
            this._setVisibleItemCount(this.model.displayItemsCount);
            this._setItemMove(this.model.navigateSteps);
            this._setFrameSpace(this.model.frameSpace);
            this._setSlideWidth(this.model.slideWidth);
            this._setSlideHeight(this.model.slideHeight);
            this._changeProperty();
            this._cloneItem();
            this._createCaption();
            this._changeSkin();
            this._setRTL(false);
        },
        _refreshControl: function () {
            this._setShowPager();
            if (this.model.showCaption) {
                if (this.element.siblings().hasClass("e-caption"))
                    this._caption.remove();
                this._createCaption();
            } else if (this.element.siblings().hasClass("e-caption"))
                this._caption.remove();

            if (this.model.showThumbnail || (this._thumbVal && (this.model.displayItemsCount == 1) && (this.model.navigateSteps == 1))) {
                if (this.element.parents('.e-in-wrap').siblings().hasClass("e-thumb")) {
                    this._thumb.remove();
                    if (!ej.isNullOrUndefined(this._thumbControl)) this._thumbControl.remove();
                }
                this._createThumb();
				this.model.showThumbnail = true;
            }
            else if (this.element.parents('.e-in-wrap').siblings().hasClass("e-thumb")) {
                this._thumb.remove();
                if (!ej.isNullOrUndefined(this._thumbControl)) this._thumbControl.remove();
            }
            this._changeSkin();
            this._setRTL(false);
        },

        _checkDataBinding: function () {
            var source = this.model.dataSource;
            if (source != null) {
                this.element.addClass("onloading");
                if (ej.DataManager && source instanceof ej.DataManager)
                    this._initDataSource(source);
                else
                    this._renderItems(source);
            }
            this._setValues();
        },

        _initDataSource: function (source) {
            var proxy = this, queryPromise;
            queryPromise = source.executeQuery(this._getQuery());
            queryPromise.done(function (e) {
                proxy._renderItems(e.result);
            }).fail(function (e) {
                proxy.element.removeClass("onloading");
            });
        },
        _getQuery: function () {
            var column;
            if (ej.isNullOrUndefined(this.model.query)) {
                column = [], queryManager = ej.Query(), mapper = this.model.fields, col;
                for (col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.dataSource.dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = this.model.query;
            return queryManager;
        },

        _renderItems: function (list) {
            this.list = list;
            this._generateTagItems(this.list);
            this.element.removeClass("onloading");
        },

        _generateTagItems: function (list) {
            var i; this.mapField = this._getMapper();
            for (i = 0; i < list.length; i++) {
                this.element.append(this._generateLi(list[i], this.mapField));
            }
        },

        _getTemplatedItems: function () {
            var itemsId = this.model.templateId, li, templateContent, content;
            for (i = 0; i < itemsId.length; i++) {
                li = ej.buildTag("li");
                templateContent = $("#" + this.model.templateId[i]);
                content= templateContent[0] && templateContent[0].nodeName && templateContent[0].nodeName.toLowerCase() == "script" ? ej.getClearString(templateContent[0].innerHTML) : templateContent;
                this.element.append($(li).append(content));
            }
        },

        _getMapper: function () {
            var mapper = this.model.fields, mapFld = { _text: null, _url: null };
            mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
            mapFld._url = (mapper && mapper.url) ? mapper["url"] : "url";
            mapFld._attr = (mapper && mapper.htmlAttr) ? mapper["htmlAttr"] : "htmlAttr";
            mapFld._linkAttribute = (mapper && mapper.linkAttribute) ? mapper["linkAttribute"] : "linkAttribute";
            mapFld._targetAttribute = (mapper && mapper.targetAttribute) ? mapper["targetAttribute"] : "targetAttribute";
            mapFld._thumbnailText = (mapper && mapper.thumbnailText) ? mapper["thumbnailText"] : "text";
            mapFld._thumbnailUrl = (mapper && mapper.thumbnailUrl) ? mapper["thumbnailUrl"] : "url";
            return mapFld;
        },

        _generateLi: function (list, map) {
            var li = ej.buildTag("li"), imgTag, anchorTag;
            imgTag = ej.buildTag("img");
            if (!ej.isNullOrUndefined(list[map._url])) imgTag.attr("src", list[map._url]);
            if (!ej.isNullOrUndefined(list[map._text])) imgTag.attr("title", list[map._text]);
            if (!ej.isNullOrUndefined(list[map._linkAttribute])) {
                anchorTag = ej.buildTag("a").attr({ 'href': list[map._linkAttribute] }).append(imgTag);
                if (!ej.isNullOrUndefined(list[map._targetAttribute])) anchorTag.attr("target", "_" + list[map._targetAttribute]);
                li.append(anchorTag);
            } else if (!this.model.template)
                li.append(imgTag);
            if (this.model.template) $(li).append(this._getTemplatedString(list));
            this._setAttributes((list[map._attr]), imgTag);
            return li;
        },

        _getTemplatedString: function (list) {
            var str = this.model.template, start = str.indexOf("${"), end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                str = str.replace(content, this._getField(list, field));
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },

        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },

        _generateThumbnailLi: function (list, map) {
            var li = ej.buildTag("li"), imgTag;
            imgTag = ej.buildTag("img");
            if (!ej.isNullOrUndefined(list[map._thumbnailUrl])) imgTag.attr("src", list[map._thumbnailUrl]);
            if (!ej.isNullOrUndefined(list[map._thumbnailText])) imgTag.attr("title", list[map._thumbnailText]);
            li.append(imgTag);
            return li;
        },

        _setAttributes: function (data, element) {
            if (data) {
                for (var key in data)
                    element.attr(key, data[key]);
            }
        },
        _createWrapper: function () {
            this._wrapper = ej.buildTag("div.e-inner e-box e-" + this.model.orientation).insertBefore(this.element);
            if (this.model.dataSource != null)
                this._checkDataBinding();
            if (this.model.templateId != null) {
                this._getTemplatedItems();
                this._setValues();
            }
            this._wrapper.append(this.element);
            this._innerWrapper = ej.buildTag("div.e-in-wrap").insertBefore(this._wrapper);
            this._innerWrapper.append(this._wrapper);
            this._outerWrapper = ej.buildTag("div.e-rotator-wrap e-widget " + this.model.cssClass).insertBefore(this._innerWrapper);
            this._outerWrapper.append(this._innerWrapper);
            if (!this.model.enabled) this._outerWrapper.addClass("e-disable").attr({ "aria-disabled": true });
        },
        _refreshTagItems: function (key, value) {
            this.model[key] = value;
            this.element.children('li').remove();
            this._checkDataBinding();
            this._cloneItem();
            this._refreshControl();
        },

        _createButtonControl: function () {
            this._buttonWrapper = ej.buildTag("div.e-nav").insertAfter(this._wrapper);
            if (this.model.showNavigateButton) {
                this._prevButton = ej.buildTag("span.e-nav-btn e-icon e-previous").attr({ 'role': 'button' }).appendTo(this._buttonWrapper);
                this._nextButton = ej.buildTag("span.e-nav-btn e-icon e-next").attr({ 'role': 'button' }).appendTo(this._buttonWrapper);
            }
            this._buttonWrapper.appendTo(this._wrapper);
            this._createAutoPlay();
            if (this.model.showNavigateButton) this._wireBtnEvents();
        },

        _createAutoPlay: function () {
            var icon;
            if (!this.model.showPlayButton) return false;
            icon = this._interval != null ? 'pause' : 'play';
            this._autoButton = ej.buildTag("span.e-nav-btn e-icon " + icon, "", {}, { role: "button" }).appendTo(this._buttonWrapper);
            this._wireAutoPlayEvents();
        },

        _createBulletControl: function () {
            var end, liElement;
            this._bulletWrapper = ej.buildTag("div.e-pager-wrap", "", {}, { role: "group", "aria-label": "showPager", tabindex: "0" }).insertAfter(this._innerWrapper);
            this._bullet = ej.buildTag("ul.e-bullet e-default");
            if (this.model.circularMode) {
                end = (this._liCount - (this.model.displayItemsCount * 2)) / this.model.navigateSteps;
                if ((this._liCount - (this.model.displayItemsCount * 2)) % this.model.navigateSteps != 0)
                    end++;
            }
            else {
                end = ((this._liCount - this.model.displayItemsCount) / this.model.navigateSteps) + 1;
                if ((this._liCount - this.model.displayItemsCount) % this.model.navigateSteps != 0)
                    end++;
            }
            for (var i = 1; i <= end ; i++)
                ej.buildTag("li.e-icon", "", {}, { tabindex: "-1", "aria-selected": "false" }).appendTo(this._bullet);
            this._bullet.appendTo(this._bulletWrapper);
            this._setActiveBullet();
            this._setPagerposition(this.model.pagerPosition);
            this._wireBulletEvents();
        },

        _createCaption: function () {
            var index;
            if (!this.model.showCaption) return false;
            this._caption = ej.buildTag("div.e-caption").append($('<span>')).insertAfter(this._buttonWrapper);
            if (this.model.circularMode) {
                index = Math.round((-Math.round(this.element.position()[this.displayCss])) / this._liSize);
                index--;
            }
            else
                index = Math.round((-Math.round(this.element.position()[this.displayCss])) / (this._liSize));

            this._setCaptionText(index);
        },

        _createThumb: function () {
            var liElements, i;
            if (this.model.dataSource != null || this.model.thumbnailSourceID != null) {
                this._thumb = this.model.showPager ? ej.buildTag("div.e-thumb", "", {}, { tabindex: "0", role: "group" }).insertAfter(this._bulletWrapper) : ej.buildTag("div.e-thumb", "", {}, { tabindex: "0", role: "group" }).insertAfter(this._innerWrapper);
                this._thumbItems = ej.buildTag("ul.e-thumb-items e-ul");
                if (this.model.dataSource != null) {
                    this._thumbItems.addClass("onloading");
                    this._generateThumbnailTagItems(this.list);
                } else {
                    for (i = 0; i < $('#' + this.model.thumbnailSourceID).children('li').length ; i++) {
                        liElements = $('#' + this.model.thumbnailSourceID).children('li').eq(i).clone();
                        liElements.addClass("e-thumb-ele").attr('tabindex', -1).removeAttr("style").appendTo(this._thumbItems);
                    }
                    $('#' + this.model.thumbnailSourceID).css("display", "none");
                }
                this._thumbItems.appendTo(this._thumb);
                this._setThumbProperty();
                this._setActiveThumb();
            }
        },

        _createThumbControl: function () {
            this._thumbControl = ej.buildTag("div.e-thumb-nav").insertAfter(this._thumb);
            this._previous = ej.buildTag("span.e-thumb-btn e-icon e-previous " + (this.model.enableRTL ? "e-enable" : "e-disable"), "", {}, { "aria-disabled": this.model.enableRTL ? false : true }).appendTo(this._thumbControl);
            this._next = ej.buildTag("span.e-thumb-btn e-icon e-next " + (this.model.enableRTL ? "e-disable" : "e-enable"), "", {}, { "aria-disabled": this.model.enableRTL ? true : false }).appendTo(this._thumbControl);
            this._thumbControl.appendTo(this._outerWrapper);
            this._wireThumbEvents();
        },

        _generateThumbnailTagItems: function (list) {
            var i;
            for (i = 0; i < list.length; i++) {
                this._thumbItems.append(this._generateThumbnailLi(list[i], this.mapField).addClass("e-thumb-ele").attr('tabindex', -1));
            }
            this._thumbItems.removeClass("onloading");
        },

        _setSkin: function (skin) {
            this._outerWrapper.removeClass(this.model.cssClass).addClass(skin);
        },

        _cloneItem: function () {
            if (this.model.circularMode) {
                var i = 0, CloneElements = ej.buildTag("ul");
                for (i = 0; i < this.model.displayItemsCount ; i++)
                    this.element.children('li').eq(i).clone().addClass("clone").appendTo(this.element);
                for (i = (this._liCount - this.model.displayItemsCount) ; i < this._liCount; i++)
                    this.element.children('li').eq(i).clone().addClass("clone").prependTo(CloneElements);
                for (i = 0; i < CloneElements.children('li').length; i++)
                    CloneElements.children('li').eq(i).clone().prependTo(this.element);
            }
            this._setDimension();
        },

        _undoClone: function () {
            for (i = 0; i < this._liCount; i++) {
                if (this.element.children('li').eq(i).hasClass("clone")) {
                    this.element.children('li').eq(i).remove();
                    this._setLicount();
                    i--;
                }
            }
        },

        _setModel: function (options) {
            var option, valueChange = false, controlChange = false;
            for (option in options) {
                switch (option) {
                    case "enableAutoPlay":
                        (this.model.enableAutoPlay = options[option]) ? this._autoPlay() : this._setPause(true);
                        break;
                    case "enableTouch":
                        this.model.enableTouch = options[option];
                        this._wireTouchEvents();
                        break;
                    case "fields":
                    case "query":
                    case "dataSource":
                    case "template":
                        this._refreshTagItems(option, options[option]);
                        break;
                    case "enabled":
                        this._changeState(options[option]);
                        break;
                    case "slideWidth":
                        this._setSlideWidth(options[option]);
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "slideHeight":
                        this._setSlideHeight(options[option]);
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "displayItemsCount":
                        this._undoClone();
                        this._setVisibleItemCount(options[option]);
                        this._cloneItem();
                        if (this.model.displayItemsCount == 1 && this._captionChange) {
                            this.model.showCaption = true;
                            this._captionChange = false;
                        }
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "navigateSteps":
                        options[option] = this._validateItemMove(options[option]);
                        this.model.navigateSteps = options[option];
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "pagerPosition":
                        this._setPagerposition(options[option]);
                        break;
                    case "showPager":
                        this.model.showPager = options[option];
                        this._setShowPager();
                        break;
                    case "showThumbnail":
                        this._thumbVal = this.model.showThumbnail = options[option];
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "thumbnailSourceID":
                        this.model.thumbnailSourceID = options[option];
                        if (this.model.dataSource == null) {
                            valueChange = true;
                            controlChange = true;
                        }
                        break;
                    case "showCaption":
                        this.model.showCaption = options[option];
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "isResponsive":
                        this.model.isResponsive = options[option];
                        this._wireResizeEvents();
                        break;
                    case "orientation":
                        this.model.orientation = options[option];
                        this._setOrientation(options[option]);
                        break;
                    case "animationSpeed":
                        this._setSpeed(options[option]);
                        break;
                    case "frameSpace":
                        this._setFrameSpace(options[option]);
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "showPlayButton":
                        this.model.showPlayButton = options[option];
                        this._setAutoplay(options[option]);
                        this._changeSkin();
                        break;
                    case "startIndex":
                        this.model.startIndex = options[option];
                        valueChange = true;
                        controlChange = true;
                        break;
                    case "allowKeyboardNavigation":
                        this.model.allowKeyboardNavigation = options[option];
                        this._wireKeyboardEvents();
                        break;
                    case "showNavigateButton":
                        this.model.showNavigateButton = options[option];
                        this._setSlideButton(options[option]);
                        this._changeSkin();
                        break;
                    case "animationType":
                        this.model.animationType = options[option];
                        this._setSpeed(this.model.animationSpeed);
                        break;
                    case "cssClass": this._setSkin(options[option]); break;
                    case "enableRTL":
                        this._setRTL(true, options[option]);
                        break;
                    case "circularMode":
                        this.model.circularMode = options[option];
                        this._reRenderControl();
                        this._refresh();
                        break;
                    case "delay":
                        this.model.delay = options[option]
                        this._setSpeed(this.model.animationSpeed);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }

            if (valueChange) this._refresh();
            if (controlChange) this._refreshControl();
        },

        _setShowPager: function () {
            if (this.model.showPager) {
                if (!ej.isNullOrUndefined(this._bulletWrapper))
                    this._bulletWrapper.remove();
                this._createBulletControl();
            }
            else if (this.element.parents('.e-in-wrap').siblings().hasClass("e-pager-wrap"))
                this._bulletWrapper.remove();
        },

        _setDimension: function () {
            this._setLicount();
            this._setUlInitial();
            this._setWidth();
            this._setHeight();
            this._setContainerPercent();
            this._changeProperty();
        },

        _render: function () {
            this._createWrapper();
            this._addAttr(this.model.htmlAttributes);
            this._cloneItem();
            this._createButtonControl();
            this._createCaption();
            if (this.model.showPager) this._createBulletControl();
            if (this.model.showThumbnail) this._createThumb();
            this._outerWrapper.find(this.element).addClass("e-ul");
            this._changeSkin();
            this._setRTL(false);
        },

        _setWidth: function () {
            this._containerWidth = this.model.orientation == "horizontal" ?
            ((parseInt(this.model.slideWidth) * this.model.displayItemsCount) + (parseInt(this.model.frameSpace) * (parseInt(this.model.displayItemsCount) - 1))) : this.model.slideWidth;
            this.element.parent().css('width', this._containerWidth);
            this.element.parents('.e-in-wrap').css('width', this._containerWidth);
            this.element.parents('.e-rotator-wrap').css('width', this._containerWidth);
            this._changeProperty();
        },
        _setHeight: function () {
            this._containerHeight = this.model.orientation == "vertical" ?
            ((parseInt(this.model.slideHeight) * this.model.displayItemsCount) + (parseInt(this.model.frameSpace) * (parseInt(this.model.displayItemsCount) - 1))) : this.model.slideHeight;
            this.element.parent().css('height', this._containerHeight);
            this._changeProperty();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy._outerWrapper.addClass(value);
                else proxy._outerWrapper.attr(key, value);
                if (key == "disabled" && value == "disabled") proxy.disable();
            });
        },

        _setUlInitial: function () {
            if (this.model.orientation == ej.Orientation.Horizontal) {
                this.element.css({
                    "width": this._liCount * this._liWidth,
                    "height": this._liHeight
                });
            }
            else {
                this.element.css({
                    "height": this._liCount * this._liHeight,
                    "width": this._liWidth
                });
            }
        },

        _setInitial: function () {
            this.model.circularMode ? this.element.css(this.displayCss, -(this._liSize * this.model.displayItemsCount) - (((this.model.startIndex > 0 && this.element.children('li').length > this.model.startIndex)  ? this.model.startIndex : 0) * this.model.navigateSteps * this._liSize)) : this.element.css(this.displayCss, "0");
        },
        _setBegin: function () {
            this.model.circularMode ? this.element.css(this.displayCss, -(this._liSize * this.model.displayItemsCount)) : this.element.css(this.displayCss, "0");
        },

        _setSlideWidth: function (val) {
            if (isNaN(parseInt(val)))
                this.model.slideWidth = this._getMaxSize("width");
            else {
                val = val.toString();
                this.model.slideWidth = this._checkValue(val, "width");
            }
            this.element.children('li').css("width", this.model.slideWidth);
            this._liWidth = this.element.children('li').outerWidth(true);
        },

        _setSlideHeight: function (val) {
            if (isNaN(parseInt(val)))
                this.model.slideHeight = this._getMaxSize("height");
            else {
                val = val.toString();
                this.model.slideHeight = this._checkValue(val, "height");
            }
            this.element.children('li').css("height", this.model.slideHeight);
            this._liHeight = this.element.children('li').outerHeight(true);
        },

        _setPagerposition: function (val) {
            if (this.model.showPager) {
                this._bullet.removeClass('e-default e-thumb-pos e-topleft e-topright e-bottomleft e-bottomright e-topCenter e-outside');
                this._bullet.addClass("e-" + val);
                if ((val == "bottomleft" || val == "bottomright") && this.model.showThumbnail && (this.model.dataSource != null || this.model.thumbnailSourceID != null))
                    this._bullet.addClass('e-thumb-pos');
            }
        },

        _setCaptionText: function (index) {
            if (this.model.showCaption) {
                var indx = (this.model.circularMode) ? ++index : index;
                this._caption.children().html(this.element.children('li').eq(indx).children('img').attr("title"));
            }
        },

        _setAutoplay: function (val) {
            if (val)
                this._createAutoPlay();
            else if (this._autoButton != null) {
                this._setPause();
                this._autoButton.remove();
            }
        },

        _setSlideButton: function (val) {
            if (val)
                this._createButtonControl()
            else {
                this._prevButton.remove();
                this._nextButton.remove();
            }
        },

        _setOrientation: function (val) {
            this._wrapper.removeClass("e-" + this.model.orientation).addClass("e-" + val);
            this._setFrameSpace(this.model.frameSpace);
            this._refresh();
            if (this.model.orientation == ej.Orientation.Horizontal)
                this.element.css({ "left": -(Math.round(-(this.element.position().top) / this._liHeight) * this._liSize), "top": 0 });
            else
                this.element.css({ "top": -(Math.round(-(this.element.position().left) / this._liWidth) * this._liSize), "left": 0 });
            this._unwireTouchEvents();
            this._wireTouchEvents();
        },
        _setRTL: function (args, options) {
            if (args && this.model.showNavigateButton) {
                this._unwireBtnEvents();
                this.model.enableRTL = options;
            }
            var action = this.model.enableRTL ? "addClass" : "removeClass";
            this.model.showPager && this._bullet[action]("e-rtl");
            this.model.showCaption && this._caption[action]("e-rtl");
            !ej.isNullOrUndefined(this._thumbItems) && this._thumbItems[action]('e-rtl');
            if (args && this.model.showNavigateButton) this._wireBtnEvents();
        },
        _setActiveBullet: function () {
            var index;
            if (this.model.circularMode) {
                index = Math.round(-Math.round(this.element.position()[this.displayCss]) / (this._liSize * this.model.displayItemsCount));
                if (this.model.navigateSteps < this.model.displayItemsCount)
                    index = -(Math.round(this.element.position()[this.displayCss]) + (this._liSize * this.model.displayItemsCount)) / (this._liSize * this.model.navigateSteps);
                index = this.model.navigateSteps == this.model.displayItemsCount ? index - 1 : index;
            }
            else
                index = Math.round(-(Math.round(this.element.position()[this.displayCss])) / (this._liSize * this.model.navigateSteps));

            index = index < 0 ? -index : index;
            this._bullet.children().eq(Math.round(index)).addClass('e-active').attr({ 'tabindex': 0, 'aria-selected': "true" });
        },

        _setActiveThumb: function () {
            if (this.model.circularMode) {
                var index = Math.round(-Math.round(this.element.position()[this.displayCss]) / this._liSize);
                index--;
            }
            else {
                var index = Math.round(Math.round(this.element.position()[this.displayCss]) / (this._liSize));
                index = (index == 0) ? index : -(index);
            }
            this._thumbItems.children().eq(index).addClass('e-active').attr({ 'tabindex': 0, 'aria-selected': "true" });
            this._transferThumb(index);
        },
        _checkValue: function (val, orient) {
            if ((val.indexOf("%")) > 0) {
                if (Math.round(parseInt(val)) == "100") {
                    this.model.displayItemsCount = 1;
                    this._setVisibleItemCount(this.model.displayItemsCount);
                }
                val = this._convertPercentageToPixel($(this.element[0]).parent()[orient](), parseInt(val));
            }
            return (val);
        },

        _convertPercentageToPixel: function (parent, child) {
            return Math.round((child * parent) / 100);
        },

        _convertPixelToPercentage: function (parent, child) {
            return Math.round((child / parent) * 100);
        },
        _changeProperty: function () {
            this.containerCss = this.model.orientation == ej.Orientation.Horizontal ? "outerWidth" : "outerHeight";
            this.displayCss = this.model.orientation == ej.Orientation.Horizontal ? "left" : "top";
            if (this.model.orientation == ej.Orientation.Horizontal) {
                this._liSize = this._liWidth;
                this._containerSize = this._containerWidth;
            }
            else {
                this._liSize = this._liHeight;
                this._containerSize = this._containerHeight;
            }
        },

        _setFrameSpace: function (val) {
            if (isNaN(parseInt(val))) {
                this.model.frameSpace = "0px";
            } else {
                this.model.frameSpace = val;
                this.model.orientation == ej.Orientation.Horizontal ? this.element.children('li').css({ "margin-right": val, "margin-bottom": 0 }) : this.element.children('li').css({ "margin-bottom": val, "margin-right": 0 });
            }
        },

        _setLicount: function () {
            this._liCount = this.element.children('li').length;
        },

        _setVisibleItemCount: function (val) {
            this.model.displayItemsCount = val;
            this.model.navigateSteps = (this.model.navigateSteps <= this.model.displayItemsCount) ? this.model.navigateSteps : this.model.displayItemsCount;
            this._checkAndSet();
        },
        _checkAndSet: function () {
            if ((this.model.displayItemsCount > 1) || (this.model.navigateSteps > 1)) {
                if (this.model.showThumbnail) this.model.showThumbnail = false;
                if (this.model.showCaption) { this.model.showCaption = false; this._captionChange = true;  }
            }
        },

        _changeSkin: function () {
            var value;
            if ((this.model.displayItemsCount > 1) || (this.model.navigateSteps > 1)) {
                this._innerWrapper.addClass("e-multiple");
                this._wrapper.removeClass("e-single");
                this._outerWrapper.css('width', this._innerWrapper.outerWidth(true));
            } else {
                this._innerWrapper.removeClass('e-multiple');
                this._wrapper.addClass("e-single");
            }
            if (this.model.showPlayButton)
                this._autoButton.css({
                    "left": (((this._innerWrapper.outerWidth(true) / 2) - (this._autoButton.width() / 2)) / this._innerWrapper.outerWidth(true)) * (100) + "%",
                    "top": (((this._wrapper.outerHeight(true) / 2) - (this._autoButton.height() / 2)) / this._wrapper.outerHeight(true)) * (100) + "%"
                });

            if (this.model.showNavigateButton) {
                value = (((this._wrapper.outerHeight(true) / 2) - (this._prevButton.height() / 2)) / this._wrapper.outerHeight(true)) * (100) + "%";
                this._prevButton.css("top", value);
                this._nextButton.css("top", value);
            }
            if ((this.model.showThumbnail) && (this.model.dataSource != null || this.model.thumbnailSourceID != null) && (this._previous != null) && (this._next != null)) {
                value = this._outerWrapper.outerHeight(true) + (this._thumbItems.children('li').outerHeight(true) / 2) - (this._thumbItems.children('li').outerHeight(true)) - (this._previous.height() / 2);
                value = (value / this._outerWrapper.outerHeight(true)) * 100 + "%";
                this._previous.css("top", value);
                this._next.css("top", value);
            }
        },

        _setItemMove: function (val) {
            this.model.navigateSteps = this._validateItemMove(val);
            this._checkAndSet();
        },
        _validateItemMove: function (val) {
            return ((val <= this.model.displayItemsCount) ? val : this.model.displayItemsCount);
        },

        _setPlay: function () {
            if ((this.model.showPlayButton) && (this._autoButton.hasClass("play")))
                this._autoButton.removeClass("play").addClass("pause");
            this._animate = true;
            this._raiseEvent("start");
        },

        _setPause: function (isCode) {
            if (this._interval != null) {
                if ((this.model.showPlayButton) && (this._autoButton.hasClass("pause")))
                    this._autoButton.removeClass("pause").addClass("play");
                clearInterval(this._interval);
                this._isInteraction = !isCode;
                this._animate = this.model.stopOnHover ? true : false;
                this._interval = null;
                this._raiseEvent("stop");
            }
        },
        _setContainerPercent: function () {
            this._containerPercent = this._convertPixelToPercentage(this.element.parents('.e-rotator-wrap').parent().width(), this.element.parent().width());
        },

        _setSpeed: function (val) {
            this.transitionDelay = this.model.animationType != "slideshow" ? (val + this.model.delay) : ((val * 2) + this.model.delay);
        },

        _setThumbProperty: function () {
            var thumbwidth, itemsWidth = 0, margin;
            var listElement = this._thumbItems.children('li');
            if ((ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") && parseFloat($(listElement[0]).width()) < 0) return false; 
            for (var i = 0; i < listElement.length; i++) {
                if (listElement[i] != null)
                    itemsWidth = itemsWidth + (parseFloat(listElement.eq(i).width()) + parseFloat(listElement.eq(i).css("padding-left")) + Math.ceil(parseFloat(listElement.eq(i).css("border-left-width"))) + parseFloat(listElement.eq(i).css("margin-left")) + parseFloat(listElement.eq(i).css("padding-right")) + Math.ceil(parseFloat(listElement.eq(i).css("border-right-width"))) + parseFloat(listElement.eq(i).css("margin-right")));
            }
            thumbwidth = Math.round((this.element.parent().outerWidth(true)) - (((this.element.parent().outerWidth(true)) * 12) / 100));
            this._thumb.css('width', thumbwidth);
            this._thumbCount = Math.floor(this._thumb.outerWidth() / (itemsWidth / (listElement.length)));
            margin = Math.round(((this.element.parent().outerWidth(true) * 6) / 100) + (thumbwidth - (this._thumbCount * (itemsWidth / (listElement.length)))) / 2);
            this._thumb.css({ 'margin-left': margin, 'margin-right': margin, 'width': Math.ceil(this._thumbCount * Math.ceil(itemsWidth / (listElement.length))) });
            this._thumbItems.css({ 'width': Math.ceil(itemsWidth), 'height': this._thumbItems.children('li').outerHeight(true) });
            this._checkState();
            this._previous.css({ 'left': (margin - this._previous.width()) / 2 });
            this._next.css({ 'right': (margin - this._next.width()) / 2 });
        },
        _checkState: function () {
            if (this._thumbCount <= (this._liCount - (this.model.displayItemsCount * 2))) {
                if (!this.element.parents('.e-in-wrap').siblings().hasClass("e-thumb-nav"))
                    this._createThumbControl();
            }
            else if (this.element.parents('.e-in-wrap').siblings().hasClass("e-thumb-nav"))
                this._thumbControl.remove();
        },

        _removeActiveItem: function () {
            if (this.model.showPager)
                this._bullet.children().removeClass('e-active').attr({ 'tabindex': -1, 'aria-selected': "false" });
            if (this.model.showThumbnail)
                this._thumbItems.children().removeClass('e-active').attr({ 'tabindex': -1, 'aria-selected': "false" });
        },

        _setActiveItem: function (index) {
            if (this.model.showPager)
                this._bullet.children().eq(index).addClass('e-active').attr({ 'tabindex': 0, 'aria-selected': "true" });
            if (this.model.showThumbnail) {
                this._thumbItems.children().eq(index).addClass('e-active').attr({ 'tabindex': 0, 'aria-selected': "true" });
                this._transferThumb(index);
                for (i = 0; i < this._thumbItems.children('li').length; i++)
                    if (this._thumbItems.children('li').eq(i).hasClass('e-thumbhover'))
                        this._thumbItems.children('li').eq(i).removeClass('e-thumbhover');
            }
        },

        _transferThumb: function (index) {
            var move, right;
            if (this.model.showThumbnail) {
                move = (index * this._thumbItems.children('li').outerWidth(true)) - (-this._thumbItems.position().left);
                right = -(this._thumbItems.position().left) + this._thumb.width();
                if ((this._thumbItems.width() - right) > move)
                    this._thumbMove(move);
                else
                    this._thumbMove((this._thumbItems.width() - right));
            }
        },

        _changeThumbControl: function (index) {
            var licount;
            if ((this.model.showThumbnail) && (this.model.dataSource != null || this.model.thumbnailSourceID != null)) {
                licount = this._thumbItems.children('li').length;
                if ((index * this._thumbItems.children('li').outerWidth(true)) > 0) {
                    if (this._previous != null && this._previous.hasClass("e-disable"))
                        this._previous.removeClass("e-disable").addClass("e-enable").attr({ "aria-disabled": false });
                }
                else if (this._previous != null && this._previous.hasClass("e-enable"))
                    this._previous.removeClass("e-enable").addClass("e-disable").attr({ "aria-disabled": true });

                if ((index * this._thumbItems.children('li').outerWidth(true)) < ((licount - this._thumbCount) * (this._thumbItems.children('li').outerWidth(true)))) {
                    if (this._next != null && this._next.hasClass("e-disable"))
                        this._next.removeClass("e-disable").addClass("e-enable").attr({ "aria-disabled": false });
                }
                else if (this._next != null && this._next.hasClass("e-enable"))
                    this._next.removeClass("e-enable").addClass("e-disable").attr({ "aria-disabled": true });
            }
        },

        _getMaxSize: function (display) {
            var max = 0, current = 0, i = 0, proxy = this;
            for (i = 0; i < this._liCount; i++) {
                current = this.element.children('li').eq(i)[display]();
                max = current > max ? current : max;
            }
            return max;
        },
        _calculateValue: function () {
            return (this._convertPercentageToPixel((this._containerWidth - ((this.model.displayItemsCount - 1) * parseInt(this.model.frameSpace))), (100 / this.model.displayItemsCount)));
        },

        _changeState: function (val) {
            val ? this.enable() : this.disable();
        },

        _findActive: function () {
            var index, i;
            if (this.model.showPager) {
                for (i = 0; i < this._bullet.children('li').length; i++) {
                    if (this._bullet.children('li').eq(i).hasClass('e-active'))
                        return i;
                }
            }
            else if (this.model.showThumbnail) {
                for (i = 0; i < this._thumbItems.children('li').length; i++) {
                    if (this._thumbItems.children('li').eq(i).hasClass('e-active'))
                        return i;
                }
            }
            else if (!(this.model.showPager) && !(this.model.showThumbnail)) {
                index = Math.round(-Math.round(this.element.position()[this.displayCss]) / this._liSize);
                index = this.model.circularMode ? index - 1 : index;
            }
            return index;
        },

        _wireEvent: function () {
            if (!this.model.enabled) return false;
            this._wrapper.on("mouseenter", $.proxy(this._showControl, this));
            this._wrapper.on("mouseleave", $.proxy(this._hideControl, this));
            this._wireKeyboardEvents();
            this._wireResizeEvents();
            this._wireTouchEvents();
        },

        _wireTouchEvents: function () {
            if (this.model.enableTouch && this.model.orientation=="horizontal")
                this._on(this._wrapper, "swiperight swipeleft", { control: true }, this._touchOperations);
            else if (this.model.enableTouch && this.model.orientation=="vertical")
                this._on(this._wrapper, "swipeup swipedown", { control: true }, this._touchOperations);
            else this._off(this._wrapper, "swiperight swipeleft swipeup swipedown", this._touchOperations);
            if (this.model.showThumbnail && (this.model.dataSource != null || this.model.thumbnailSourceID != null)) this._on(this._thumb, "swiperight swipeleft", { control: false }, this._touchOperations);
        },
        _unwireTouchEvents: function () {
            this._off(this._wrapper, "swiperight swipeleft swipeup swipedown", this._touchOperations);
        },
        _wireKeyboardEvents: function () {
            if (this.model.allowKeyboardNavigation) {
                this._outerWrapper.on("focusin", $.proxy(this._onFocusIn, this));
                this._outerWrapper.on("focusout", $.proxy(this._onFocusOut, this));
            }
            else {
                this._outerWrapper.off("focusin", $.proxy(this._onFocusIn, this));
                this._outerWrapper.off("focusout", $.proxy(this._onFocusOut, this));
            }
        },

        _wireBtnEvents: function () {
            if (this.model.showNavigateButton) {
                this._prevButton.on("click", $.proxy(this.model.enableRTL ? this._nextAction : this._prevAction, this));
                this._nextButton.on("click", $.proxy(this.model.enableRTL ? this._prevAction : this._nextAction, this));
            }
            else
                this._unwireBtnEvents();
        },
        _unwireBtnEvents: function () {
            this._prevButton.off("click", $.proxy(this.model.enableRTL ? this._nextAction : this._prevAction, this));
            this._nextButton.off("click", $.proxy(this.model.enableRTL ? this._prevAction : this._nextAction, this));
        },

        _wireAutoPlayEvents: function () {
            if (this.model.showPlayButton)
                this._on(this._autoButton, "click", this._autoPlay);
            else
                this._off(this._autoButton, "click", this._autoPlay);
        },

        _wireResizeEvents: function () {
            if (this.model.isResponsive)
                $(window).on("resize", $.proxy(this._resizeEvent, this));
            else
                $(window).off("resize", $.proxy(this._resizeEvent, this));
        },

        _wireThumbEvents: function () {
            if (this.model.showThumbnail) {
                this._on(this._thumbItems.children(), "click", this._thumbClick);
                this._on(this._next, "click", (this.model.enableRTL ? this._thumbPrev : this._thumbNext));
                this._on(this._previous, "click", (this.model.enableRTL ? this._thumbNext : this._thumbPrev));
            }
            else {
                this._off(this._thumbItems.children(), "click", this._thumbClick);
                this._off(this._next, "click", (this.model.enableRTL ? this._thumbPrev : this._thumbNext));
                this._off(this._previous, "click", (this.model.enableRTL ? this._thumbNext : this._thumbPrev));
            }
        },

        _wireBulletEvents: function () {
            if (this.model.showPager)
                this._on(this._bullet.children(), "click", this._bulletClick);
            else
                this._off(this._bullet.children(), "click", this._bulletClick);
        },

        _thumbNext: function () {
            var proxy = this, rightValue;
            if (!this.model.enabled) return false;
            if (this[this.model.enableRTL ? "_next" : "_previous"].hasClass("e-disable"))
                this[this.model.enableRTL ? "_next" : "_previous"].removeClass("e-disable").addClass("e-enable").attr({ "aria-disabled": false });
            rightValue = (-Math.round(this._thumbItems.position().left)) + this._thumb.width();
            if (this._thumbItems.width() - rightValue >= this._thumbItems.children('li').outerWidth(true))
                this._thumbMove(this._thumbItems.children('li').outerWidth(true));
            if ((this._thumbItems.width() - rightValue) <= this._thumbItems.children('li').outerWidth(true)) {
                this[this.model.enableRTL ? "_previous" : "_next"].removeClass("e-enable").addClass("e-disable").attr({ "aria-disabled": true });
            }
        },

        _thumbMove: function (move) {
            var proxy = this;
            proxy._thumbItems.animate({
                "left": "-=" + move + "px",
            }, 600, function () { proxy._thumbItems.stop(true, true); });
        },

        _thumbPrev: function () {
            var proxy = this, leftValue, itemWidth;
            if (!this.model.enabled) return false;
                if (this[this.model.enableRTL ? "_previous" : "_next"].hasClass("e-disable"))
                    this[this.model.enableRTL ? "_previous" : "_next"].removeClass("e-disable").addClass("e-enable").attr({ "aria-disabled": false });
                leftValue = Math.round(this._thumbItems.position().left);
                itemWidth = this._thumbItems.children('li').outerWidth(true);
                if ((-leftValue) >= itemWidth) this._thumbMove(-itemWidth);
                if ((-leftValue) <= itemWidth)
                     this[this.model.enableRTL ? "_next" : "_previous"].removeClass("e-enable").addClass("e-disable").attr({ "aria-disabled": true });
               
        },
        _findLength: function () {
            var proxy = this, len;
            if (this.model.showThumbnail) len = proxy._thumbItems.children('li').length - 1;
            if (this.model.showPager) len = proxy._bullet.children('li').length - 1;
            if (!(this.model.showPager) && !(this.model.showThumbnail))
                len = (this.model.circularMode) ? ((this.element[this.containerCss]()) / this._liSize) - ((this.model.displayItemsCount) * 2) : ((this.element[this.containerCss]()) / this._liSize) - 1;
            return len;
        },

        _changeActiveState: function (action) {
            var proxy = this, index, len;
            index = proxy._findActive();
            len = proxy._findLength();
            proxy._removeActiveItem();
            if (action == "prev") {
                if ((index > 0)) {
                    proxy._setActiveItem((index - 1));
                    if (this.model.animationType != "slideshow") this._setCaptionText((index - 1));
                }
                else {
                    proxy._setActiveItem(len);
                    if (this.model.animationType != "slideshow") this._setCaptionText((len));
                }
            }
            else if (index < len) {
                proxy._setActiveItem((index + 1));
                if ((this.model.animationType != "slideshow"))
                    this._setCaptionText((index + 1));
            }
            else {
                proxy._setActiveItem(0);
                if (this.model.animationType != "slideshow") this._setCaptionText(0);
            }
        },

        _moveSlide: function (move, action) {
            var proxy = this, animationType, animationSpeed, index, len, properties = {};
            animationType = this.model.animationType != "slideshow" ? this.model.animationType : "slideshow";
            animationSpeed = this.model.animationType != "slideshow" ? proxy.model.animationSpeed : 0;
            index = proxy._findActive();
            len = proxy._findLength();
            properties[this.displayCss] = proxy.element.position()[proxy.displayCss];
            properties[this.displayCss] -= move;
            index = action == "next" ? (index < len ? index + 1 : 0) : action == "prev" ? (index > 0 ? index - 1 : len) : 0; this._prevIndex = index;
            if (this.model.animationType == "slideshow") { proxy.element.fadeOut(proxy.model.animationSpeed / 2); if (proxy.model.showCaption) proxy._caption.fadeOut(proxy.model.animationSpeed / 2); }
            proxy.element.animate(properties, animationSpeed, animationType, function () { if (action == "end") proxy._setBegin(); proxy._animating = false; proxy._setCaptionText(index); proxy._raiseEvent("change"); });
            if (this.model.animationType == "slideshow") { proxy.element.fadeIn(proxy.model.animationSpeed / 2); if (proxy.model.showCaption) proxy._caption.fadeIn(proxy.model.animationSpeed / 2); }
        },

        _moveNext: function () {
            var proxy = this, ltValue, endValue, rbValue, move;
            proxy._animating = true;

            if (this.model.circularMode) {
                ltValue = Math.round(proxy.element.position()[proxy.displayCss]);
                endValue = (proxy.model.displayItemsCount * proxy._liSize) - (proxy._liCount * proxy._liSize);
                rbValue = Math.round(proxy.element.position()[proxy.displayCss]) + proxy.element[proxy.containerCss]();
                proxy._calculateItemMove();
                if ((ltValue > endValue) && (rbValue - proxy._containerSize > (proxy._move + parseInt(proxy.model.frameSpace)))) {
                    return { move: proxy._move, action: "next" }
                }
                else {
                    if (rbValue - proxy._containerSize <= (proxy._move + parseInt(proxy.model.frameSpace))) {
                        move = rbValue - proxy._containerSize - parseInt(proxy.model.frameSpace);
                        return { move: move, action: "end" }
                    }
                }

            }
            else {
                ltValue = Math.round(proxy.element.position()[proxy.displayCss]);
                endValue = -(proxy._liCount * proxy._liSize);
                rbValue = Math.round(proxy.element.position()[proxy.displayCss]) + proxy.element[proxy.containerCss]();
                proxy._calculateItemMove();
                if ((ltValue - proxy._liSize) != endValue) {
                    if (rbValue - proxy._containerSize <= (proxy._move + parseInt(proxy.model.frameSpace))) {
                        proxy._move = rbValue - proxy._containerSize - parseInt(proxy.model.frameSpace);
                        proxy._move = proxy._move == 0 ? ltValue : proxy._move;
                    }
                    return { move: proxy._move, action: "next" }
                }
                else {
                    if (rbValue - proxy._containerSize <= (proxy._move + parseInt(proxy.model.frameSpace)))
                        return { move: ltValue, action: "end" }
                }
            }
        },

        _movePrev: function () {
            var proxy = this, ltValue, rbValue, endValue, setValue;
            ltValue = Math.round(proxy.element.position()[proxy.displayCss]);
            rbValue = proxy.element.position()[proxy.displayCss]; +proxy.element[proxy.containerCss]();
            endValue = proxy.element[proxy.containerCss]();
            proxy._calculateItemMove();
            if (this.model.circularMode) {
                if ((rbValue < endValue) && (-ltValue > (proxy.model.displayItemsCount * proxy._liSize)))
                    return { move: -proxy._move, action: "prev" }
                else {
                    setValue = ((proxy.model.displayItemsCount * proxy._liSize) * 2) + ltValue - (proxy._liCount * proxy._liSize);
                    proxy._move = ((proxy._liCount - (proxy.model.displayItemsCount * 2)) % proxy.model.navigateSteps) * proxy._liSize;
                    if (proxy._move == 0) proxy._calculateItemMove();
                    if (proxy.model.orientation == ej.Orientation.Horizontal)
                        proxy.element.css("left", setValue);
                    else
                        proxy.element.css("top", setValue);
                    return { move: -proxy._move, action: "prev" }
                }
            }
            else {
                if ((rbValue < endValue) && (-ltValue >= (proxy._liSize * proxy.model.navigateSteps)))
                    return { move: -proxy._move, action: "prev" }
                else {
                    setValue = ((proxy.model.displayItemsCount * proxy._liSize)) + ltValue - (proxy._liCount * proxy._liSize);
                    proxy._move = ((-ltValue < proxy._move) && (ltValue != 0)) ? -ltValue : setValue;
                    return { move: -proxy._move, action: "prev" }
                }
            }
        },

        _autoPlay: function (e) {
            var proxy = this, value, move;
            this._isInteraction = !!e;
            if (this._interval == null) {
                this._setPlay();
                move = function () {
                    proxy._animating = true;
                    value = proxy._rtlDirection ? proxy._moveNext() : proxy._movePrev();
                    proxy._moveSlide(value.move, value.action);
                    proxy._changeActiveState(value.action);
                    proxy._changeThumbControl(proxy._findActive());
                }
                function SetInterval(move, animationSpeed) {
                    return (setInterval(move, animationSpeed))
                }
                if (!this._animating)
                    this._interval = SetInterval(move, this.transitionDelay);
            }
            else
                this._setPause();
        },

        _nextAction: function (isCode) {
            var proxy = this, interval, next, value;
            this._isInteraction = !!isCode;
            next = function () {
                value = proxy._moveNext();
                proxy._moveSlide(value.move, value.action);
                clearInterval(interval);
                proxy._changeActiveState("next");
                proxy._changeThumbControl(proxy._findActive());
            }
            if (this._interval != null)
                this._setPause();

            if (!this._animating) {
                this._animating = true;
                interval = setInterval(next, "");
            } this._prevIndex = this.getIndex();
        },

        _prevAction: function (isCode) {
            var proxy = this, interval, previous, value;
            this._isInteraction = !!isCode;
            previous = function () {
                value = proxy._movePrev();
                proxy._moveSlide(value.move, value.action);
                clearInterval(interval);
                proxy._changeActiveState("prev");
                proxy._changeThumbControl(proxy._findActive());
            }
            if (this._interval != null)
                this._setPause();

            if (!this._animating) {
                this._animating = true;
                interval = setInterval(previous, "")
            } this._prevIndex = this.getIndex();
        },

        _touchOperations: function (e) {
            var isThumb = !e.data.control, direction, orient = this.model.orientation;
            if (isThumb)
                direction = e.type == "swipeleft" ? "left" : "right";
            else {
                if ((orient == "horizontal" && e.type == "swipeleft") ||
                    (orient == "vertical" && e.type == "swipeup"))
                    direction = "left";
                else if ((orient == "horizontal" && e.type == "swiperight") ||
                    (orient == "vertical" && e.type == "swipedown"))
                    direction = "right";
            }
            if (direction == "left")
                isThumb ? this._thumbNext() : this.slideNext();
            else if (direction == "right")
                isThumb ? this._thumbPrev() : this.slidePrevious();
        },

        _resizeEvent: function () {
            var index, parent;
            if (!this.model.enabled) return false;
            index = Math.round(-Math.round(this.element.position().left) / this._liSize);
            parent = Math.round(this.element.parents('.e-rotator-wrap').parent().width());
            this._containerWidth = this._convertPercentageToPixel(parent, this._containerPercent);
            this._setSlideWidth(this._calculateValue().toString());
            this._setWidth();
            this.element.css("left", -(index * this._liSize));
            this._setUlInitial();
            if ((this.model.showThumbnail) && (this.model.dataSource != null || this.model.thumbnailSourceID != null))
                this._setThumbProperty();
        },

        _calculateItemMove: function () {
            if (!isNaN(this.model.navigateSteps))
                this._move = this._liSize * this.model.navigateSteps;
            else {
                this.model.navigateSteps = 1;
                this._move = this._liSize * this.model.navigateSteps;
            }
        },

        _thumbClick: function (event) {
            var index;
            this._isInteraction = true;
            var btnStatus = this._autoButton != null ? (this._autoButton.hasClass("play") ? false : true) : (this.model.enableAutoPlay ? true : false);
            if (!this.model.enabled) return false;

            if (this._interval != null)
                this._setPause();

            this._removeActiveItem();
            index = ((event.target.className == 'e-thumb-ele e-thumbhover') || (event.target.className == 'e-thumb-ele')) ? this._thumbItems.children('li').index($(event.target)) :
            this._thumbItems.children('li').index($(event.target).parents('.e-thumb-ele'));
            this._changeThumbControl(index);
            this._setActiveItem(index);
            this._raiseEvent("thumbItemClick");
            if (this.model.circularMode)
                this._moveSlideContent(this.element.position()[this.displayCss], -((this.model.displayItemsCount * this._liSize) + (index * this.model.navigateSteps * this._liSize)), index, btnStatus);
            else
                this._moveSlideContent(this.element.position()[this.displayCss], -((index * this.model.navigateSteps * this._liSize)), index, btnStatus);
        },

        _bulletClick: function (event) {
            var index, target;
            this._isInteraction = true;
            var btnStatus = this._autoButton != null ? (this._autoButton.hasClass("play") ? false : true) : (this.model.enableAutoPlay ? true : false);
            if (!this.model.enabled) return false;
            if (this._interval != null)
                this._setPause();
            this._removeActiveItem();
            this._eventIndex = index = this._bullet.children('').index(event.target);
            this._changeThumbControl(index);
            this._setActiveItem(index);
            this._raiseEvent("pagerClick");
            if (this.model.circularMode)
                this._moveSlideContent(this.element.position()[this.displayCss], -((this.model.displayItemsCount * this._liSize) + (index * this.model.navigateSteps * this._liSize)), index, btnStatus);
            else {
                target = (index * this.model.navigateSteps * this._liSize);
                if ((this.element[this.containerCss]()) - (this.model.displayItemsCount * this._liSize) < target)
                    target = (this.element[this.containerCss]()) - (this.model.displayItemsCount * this._liSize);
                this._moveSlideContent(this.element.position()[this.displayCss], -target, index, btnStatus);
            }
        },

        _moveSlideContent: function (Current, Target, index, btnStatus, isCode) {
            var proxy = this, animationSpeed, animationType, properties = {};
            animationType = this.model.animationType != "slideshow" ? this.model.animationType : "slideshow";
            animationSpeed = this.model.animationType != "slideshow" ? proxy.model.animationSpeed : 0;
            properties[this.displayCss] = proxy.element.position()[proxy.displayCss];
            properties[this.displayCss] += (Target - Current);
            if (this.model.animationType == "slideshow") { proxy.element.fadeOut(proxy.model.animationSpeed / 2); if (proxy.model.showCaption) proxy._caption.fadeOut(proxy.model.animationSpeed / 2); }
            proxy.element.animate(properties, animationSpeed, animationType, function () {
                proxy._setCaptionText(index); if (btnStatus) {
                    setTimeout(function () {
                        proxy.play();
                    }, proxy.model.animationSpeed);
                }
            });
            if (this.model.animationType == "slideshow") { proxy.element.fadeIn(proxy.model.animationSpeed / 2); if (proxy.model.showCaption) proxy._caption.fadeIn(proxy.model.animationSpeed / 2); }
            this._isInteraction = !isCode;
            if (this._prevIndex != index)
                proxy._raiseEvent("change");
            this._prevIndex = index;
        },

        _destroy: function () {
            this._interval != null ? this.pause() : "";
            this._undoClone();
            this.element.removeAttr("style").insertAfter(this._outerWrapper).removeClass();
            this.element.children().removeAttr("style");
            this._outerWrapper.remove();
            $(window).off("resize", $.proxy(this._resizeEvent, this));
            this.element.stop();
        },

        _raiseEvent: function (event) {
			this.eventType = event; 
            var data = { activeItemIndex: this.getIndex(), itemID: this.element.attr('id') };
            if (event == "start" || event == "change" || event == "stop")
                data = { activeItemIndex: this.getIndex(), itemID: this.element.attr('id'), isInteraction: this._isInteraction };
            return this._trigger(event, data);

        },

        _showControl: function (event) {
            if (!this.model.enabled) return false;
            if (this.model.showNavigateButton) {
                this._prevButton.stop(true, true).fadeIn('slow');
                this._nextButton.stop(true, true).fadeIn('slow');
            }
            if (this.model.showPlayButton)
                this._autoButton.stop(true, true).fadeIn('slow');
            if ((this.model.showCaption) && (this._caption != null))
                this._caption.stop(true, true).fadeIn('slow');
            if (this.model.stopOnHover && this._animate)
                this.pause();
            event.stopPropagation();
        },

        _hideControl: function (event) {
            if (!this.model.enabled) return false;
            if (this.model.showNavigateButton) {
                this._prevButton.stop(true, true).fadeOut('slow');
                this._nextButton.stop(true, true).fadeOut('slow');
            }
            if (this.model.showPlayButton)
                this._autoButton.stop(true, true).fadeOut('slow');
            if ((this.model.showCaption) && (this._caption != null))
                this._caption.stop(true, true).fadeOut('slow');
            if (this.model.stopOnHover && this._animate)
                this.play();
            event.stopPropagation();
        },

        _onFocusIn: function () {
            if (!this.model.enabled) return false;
            this._outerWrapper.addClass("e-Focused");
            this._innerWrapper.addClass("e-shadow");
            $(this._outerWrapper).on("keydown", $.proxy(this._focuseHandle, this));
        },

        _onFocusOut: function () {
            this._outerWrapper.removeClass("e-Focused");
            this._innerWrapper.removeClass("e-shadow");
            $(this._outerWrapper).off("keydown", $.proxy(this._focuseHandle, this));
        },

        _focuseHandle: function (e) {
            if (!this.model.enabled) return false;
            if (this._outerWrapper.hasClass("e-Focused")) {
                e.keyCode = ((e.altKey) && ((e.keyCode == 37) || (e.keyCode == 40))) ? 1000 : e.keyCode;
                e.keyCode = ((e.altKey) && ((e.keyCode == 38) || (e.keyCode == 39))) ? 1001 : e.keyCode;
                switch (e.keyCode) {
                    case 37:
                    case 40:
                        e.preventDefault();
                        this._prevAction();
                        break;
                    case 38:
                    case 39:
                        e.preventDefault();
                        this._nextAction();
                        break;
                    case 32:
                        e.preventDefault();
                        this._autoPlay(true);
                        break;
                    case 1000:
                        e.preventDefault();
                        this._thumbPrev();
                        this._thumbHover("prev");
                        break;
                    case 1001:
                        e.preventDefault();
                        this._thumbNext();
                        this._thumbHover("next");
                        break;
                    case 13:
                        e.preventDefault();
                        for (i = 0; i < this._thumbItems.children('li').length; i++)
                            if (this._thumbItems.children('li').eq(i).hasClass('e-thumbhover'))
                                this.gotoIndex(i);

                }
            }
        },

        _thumbHover: function (action) {
            var proxy = this, index = null, len;
            for (i = 0; i < this._thumbItems.children('li').length; i++) {
                if (this._thumbItems.children('li').eq(i).hasClass('e-thumbhover')) {
                    index = i;
                    this._thumbItems.children('li').eq(i).removeClass('e-thumbhover');
                    break;
                }
            }
            if (index == null)
                index = this._findActive();
            len = proxy._findLength();
            if (action == "prev") {
                if (index > 0)
                    this._thumbItems.children().eq(--index).addClass('e-thumbhover');
                else
                    this._thumbItems.children().eq(0).addClass('e-thumbhover');
            }
            else if (index < len)
                this._thumbItems.children().eq(++index).addClass('e-thumbhover');
            else
                this._thumbItems.children().eq(len).addClass('e-thumbhover');
        },

        _ieEnable: function (action) {
            this.element[action]("e-disable");
            this.model.showPager && this._bulletWrapper.children('ul.e-bullet')[action]('e-disable')
            this.model.showThumbnail && this._thumbItems.children('li.e-thumb-ele')[action]("e-disable");
            if (this.model.showThumbnail) {
                this._next[action]('e-disable');
                this._previous[action]('e-disable');
            }
        },


        enable: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                this._outerWrapper.removeClass("e-disable").attr({ "aria-disabled": false });
                if ((ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0"))
                    this._ieEnable("removeClass");
                if (this._isPlaying) this.play();
            }
        },

        disable: function () {
            if (this.model.enabled) {
                this.model.enabled = false;
                this._outerWrapper.addClass("e-disable").attr({ "aria-disabled": true });
                if ((ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0"))
                    this._ieEnable("addClass");
                this._isPlaying = this._interval != null ? true : false;
                if (this._interval != null)
                    this._setPause();
            }
        },

        updateTemplateById: function (id, index) {
            var templateContent, lastItem, content;
            if (this.model.templateId != null) {
                $(this.element.children()[index]).empty();
                templateContent = $("#" + id);
                content = templateContent[0] && templateContent[0].nodeName && templateContent[0].nodeName.toLowerCase() == "script" ? ej.getClearString(templateContent[0].innerHTML) : templateContent;
                $(this.element.children()[index]).append(content);
                if (this.model.circularMode && this.element.children('li').eq(index - 1).hasClass("clone")) {
                    $(this.element.children()[this._liCount - 1]).empty();
                    lastItem = templateContent[0].nodeName.toLowerCase() == "script" ? content : content.clone();
                    $(this.element.children()[this._liCount - 1]).append(lastItem);
                }
            }
        },

        slideNext: function () {
            this._nextAction(false);
        },

        slidePrevious: function () {
            this._prevAction(false);
        },

        play: function () {
            if (this._interval == null)
                this._autoPlay();
        },

        pause: function () {
            if (this._interval != null)
                this._setPause(true);
        },

        getIndex: function () {
            var index, i, slideIndex = [];
            if (this.model.displayItemsCount > 1) {
                if (this.model.circularMode) {
                    index = Math.round(-Math.round(this.element.position()[this.displayCss]) / this._liSize);
					if(this.eventType != "pagerClick" && ej.isNullOrUndefined(this._prevIndex))
					index = index - this.model.displayItemsCount;else
                   index = (this._eventIndex) ? this._eventIndex : index;
                    for (i = 0; i < this.model.displayItemsCount ; i++) {
                        if (index < (this._liCount - (this.model.displayItemsCount * 2)))
                            slideIndex.push(index++);
                        else {
                            index = 0; i--;
                        }
                    }
                }
                else {
					
                    index = Math.round(Math.round(this.element.position()[this.displayCss]) / (this._liSize));
					index = (this._eventIndex) ? this._eventIndex : index;
                    index = index < 0 ? (index * -1) : index;
                    for (i = 0; i < this.model.displayItemsCount ; i++)
                        slideIndex.push(index++);
				}
                return slideIndex;
            }
            else
                return this._findActive();
        },

        gotoIndex: function (index) {
            var btnStatus = this._autoButton != null ? (this._autoButton.hasClass("play") ? false : true) : (this.model.enableAutoPlay ? true : false);
            if (this._interval != null)
                this._setPause();
            this._removeActiveItem();
            if (this.model.showThumbnail) this._changeThumbControl(index);
            this._setActiveItem(index);
            if (this.model.circularMode)
                this._moveSlideContent(this.element.position()[this.displayCss], -((this.model.displayItemsCount * this._liSize) + (index * this.model.navigateSteps * this._liSize)), index, btnStatus, true);
            else {
                target = ((index * this.model.navigateSteps * this._liSize));
                if ((this.element[this.containerCss]()) - (this.model.displayItemsCount * this._liSize) < target)
                    target = (this.element[this.containerCss]()) - (this.model.displayItemsCount * this._liSize);
                this._moveSlideContent(this.element.position()[this.displayCss], -target, index, btnStatus, true);
            }
        },
    })

    ej.Rotator.PagerPosition = {
        /**  Pager is positioned at the top-left corner of an Item. */
        TopLeft: "topleft",
        /**  Pager is positioned at the top-left corner of an Item. */
        TopRight: "topright",
        /**  Pager is positioned at the top-right corner of an Item. */
        BottomLeft: "bottomleft",
        /**  Pager is positioned at the bottom-left corner of an Item. */
        BottomRight: "bottomright",
        /**  Pager is positioned at the bottom-right corner of an Item. */
        TopCenter: "topCenter",
        /**  Pager is positioned outside an Item. */
        Outside: "outside"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSplitter", "ej.Splitter", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _rootCSS: "e-splitter",
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            cssClass: "",

            orientation: "horizontal",

            enableAnimation: true,

            properties: [],

            height: null,

            width: null,

            // EnableAutoResize is a deprecated API, we can achieve this requirement by isResponsive property
            enableAutoResize: false,

            isResponsive: false,

            enableRTL: false,
			
			allowKeyboardNavigation: true,

            htmlAttributes: {},

            animationSpeed: 300,

            beforeExpandCollapse: null,

            expandCollapse: null,

            resize: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            cssClass: "string",
            orientation: "enum",
            properties: "data",
            enableAutoResize: "boolean",
            isResponsive: "boolean",
            enableRTL: "boolean",
			allowKeyboardNavigation: "boolean",
            animationSpeed: "number",
            enableAnimation: "boolean",
            htmlAttributes: "data",
        },


        _init: function () {
            this._initialize();
            this._render();
            if (this.model.isResponsive || this.model.enableAutoResize)
                this._wireEvents(true);
            else
                this._wireEvents(false);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "enableAutoResize": this._windowResizing(options[option]); break;
                    case "isResponsive": this._windowResizing(options[option]); break;
                    case "enableRTL": this._rtl(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "orientation": this._refreshSplitter("orientation", options[option]); break;
                    case "properties": this._refreshSplitter("properties", options[option]); break;
                    case "width": this.model.width = options[option]; this._setHeightWidth(); break;
                    case "height": this.model.height = options[option]; this._setHeightWidth(); break;
                }
            }
        },

        refresh: function () {
            this._setPanesSize();
            this._getPanesPercent();
        },

        collapse: function (paneIndex) {
            this._clickArrow(paneIndex, true, true);
        },

        expand: function (paneIndex) {
            this._clickArrow(paneIndex, false, true);
        },

        _clickArrow: function (index, bool, canClick) {
            if (this._inMovement || index < 0 || index > this.panes.length || this.panes.length <= 1) return false;
            var arrow, cls = bool ? "e-collapse" : "e-expand", splitbars = this.element.children(".e-splitbar:not(.e-shadowbar)");
            if (index == splitbars.length) arrow = this._clickArrow(index - 1, !bool, false);
            else arrow = $(splitbars[index]).children("." + cls);
            if (canClick) arrow.css("display") != "none" && arrow.mousedown();
            else return arrow;
        },


        addItem: function (content, property, index) {
            var paneCount = this.panes.length;
            index = this._getNumber(index);
			 var totalSize = this.element[this.containerCss]();
            if (ej.isNullOrUndefined(index)) index = paneCount;
            if (index < 0 || index > paneCount) return "";
            var property = this._getPaneProperty(property), paneDiv, paneDivSize, requiredSize;
            property = this._checkMinMaxSize(property);
            paneDiv = ej.buildTag("div.e-pane e-" + this.model.orientation.substr(0, 1) + "-pane");
            this.element.append(paneDiv[this.containerCss](property.paneSize));
            paneDivSize = property.paneSize = paneDiv[this.containerCss]();
			 if(paneCount==0) this.panes.push(paneDiv);	
            paneDiv.remove();
            var start = index, end = (paneCount>0)?paneCount:this.panes.length, i, j, insert, before, direction = 2, getters = {}, taken = 0, canInsert = false;
            requiredSize = paneDivSize + this._bar;

            for (j = 0; j < direction; j++) {
                for (i = start; i < end; i++) {
                    var _paneSize = $(this.panes[i])[this.containerCss]();
					 var minSize=(!ej.isNullOrUndefined(this.model.properties[i]))?(this.model.properties[i].minSize): property.minSize;
                    var availableSpace = _paneSize - minSize;
                    if (availableSpace >= requiredSize - taken) {
                        getters[i] = _paneSize - (requiredSize - taken);
                        canInsert = true;
                        break;
                    }
					else if((paneCount==0)&&(availableSpace>=0)){
						  getters[i] = minSize;
                        taken += availableSpace;
						canInsert=true;
					}
                    else if (availableSpace > 0) {
                        getters[i] = minSize;
                        taken += availableSpace;
                    }
                }
                if (canInsert) break;
                else end = start, start = 0;
            }
            if (!canInsert) return "";
            for (var pos in getters)
                $(this.panes[pos])[this.containerCss](getters[pos]);
			if(paneCount<=0) paneDiv.append($(this.panes[index]));
			else{
            if (index == paneCount) {
                insert = "insertBefore", before = 1;
                paneDiv.insertAfter($(this.panes[index - 1]));
            }
            else {
                insert = "insertAfter", before = 0;
                paneDiv.insertBefore($(this.panes[index]));
            }
			 }
            this.model.properties.splice(index, 0, property);
			 if(paneCount==0)this.element.append(paneDiv[this.containerCss](totalSize));			
			 if(paneCount>0){
            this.panes.splice(index, 0, paneDiv);
            var splitBar = this._createSplitBar(index - before);
            splitBar[insert](paneDiv);
			 }
            paneDiv.append(content);
            this._updateModel();
            return paneDiv;
        },


        removeItem: function (index) {
            var paneCount = this.panes.length - 1;
            index = this._getNumber(index);
            if (ej.isNullOrUndefined(index)) index = paneCount;
            if (index < 0 || index > paneCount || paneCount < 0) return null;
            var targetPane, nextPane, splitbars, removedSize;
            targetPane = $(this.panes[index]);
            removedSize = targetPane[this.containerCss]() + this._bar;
            targetPane.remove();
            splitbars = this.element.children(".e-splitbar:not(.e-shadowbar)");
            if (index == paneCount) {
                nextPane = $(this.panes[index - 1]);
                $(splitbars[index - 1]).remove();
            }
            else {
                nextPane = $(this.panes[index + 1]);
                $(splitbars[index]).remove();
            }
            nextPane[this.containerCss](nextPane[this.containerCss]() + removedSize);
            this._removeArrays(index);
            this._updateModel();
        },
        _checkMinMaxSize: function (property) {
            if ((!ej.isNullOrUndefined(property.minSize))&&(property.paneSize < property.minSize))
                property.paneSize = property.minSize;
            if ((!ej.isNullOrUndefined(property.maxSize))&&(property.paneSize > property.maxSize))
                property.paneSize = property.maxSize;
            return property;
        },

        _removeArrays: function (index) {
            this.model.properties.splice(index, 1);
            this.panes.splice(index, 1);
            this.oldPaneSize.splice(index, 1);
            this.oldPanePercent.splice(index, 1);
            this._sizePercent.splice(index, 1);
        },

        _getNumber: function (value) {
            value = parseFloat(value);
            return isNaN(value) ? null : value;
        },

        _updateModel: function () {
            for (var i = 0; i < this.panes.length; i++)
                this.model.properties[i].paneSize = $(this.panes[i])[this.containerCss]();
            this._getPanesPercent();
        },

        _getPaneProperty: function (property) {
            var _default = { paneSize: 10, minSize: 10, maxSize: null, collapsible: true, resizable: true, expandable: true };
            return $.extend(_default, property);
        },

        _changeSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
        },

        _windowResizing: function (boolean) {
            if (boolean) this._wireEvents(boolean);
            else this._unWireEvents();
        },

        _refreshSplitter:function(key,value){
            this._unWireEvents();
            this._refreshDestroy();
            this.model[key] = value;
            this._init();
        },

		_destroy: function() {
			this.element.removeClass("e-splitter");
			this._refreshDestroy();
			this._unWireEvents();
		},

        _refreshDestroy: function () {
            this.element.removeClass("e-widget e-box e-rtl" + this.model.cssClass + " e-" + this.model.orientation);
            this.element.children(".e-splitbar").remove();
            this.element.children(".e-pane").removeClass("e-pane e-" + this.model.orientation.substr(0, 1) + "-pane").height("").width("");
        },

        _initialize: function () {
            this.panes = [];
            this.oldPaneSize = [];
            this.oldPanePercent = [];
            this.shadowBar = null;
            this._inMovement = false;
            this.containerCss = this.model.orientation == "horizontal" ? "width" : "height";
            this.displayCss = this.model.orientation == "horizontal" ? "left" : "top";
            this.borderCss = this.model.orientation == "horizontal" ? "right" : "bottom";
            this._bar = 9;      // For the center splitbar size
        },

        _render: function () {
            this.element.addClass("e-widget e-box " + this.model.cssClass + " e-" + this.model.orientation).attr("data-role", "splitter");
            var i, j, target = this.element[0];
            for (i = 0, j = 0; i < target.children.length; i++) {
                $(target.children[i]).addClass("e-pane");
                this.panes.push(target.children[i]);
            }
            this._setPanesProperty();
            this._insertSplitBar();
            this._setDimentions();
            this._setPanesSize();
            this._getPanesPercent();
            this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
            this.element.find(".e-pane").addClass("e-" + this.model.orientation.substr(0, 1) + "-pane");
			if(this.model.isResponsive){
				if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
					this.element.css("height",this.model.height);
				if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
					this.element.css("width",this.model.width );
			}
        },

        _setPanesProperty: function () {
            for (var p = 0; p < this.panes.length; p++) {
                if (this.model.properties[p] != undefined) {
                    this.model.properties[p].paneSize = this.model.properties[p].paneSize == undefined ? "0px" : this.model.properties[p].paneSize;
                    this.model.properties[p].minSize = isNaN(parseFloat(this.model.properties[p].minSize)) ? 10 : parseFloat(this.model.properties[p].minSize);
                    this.model.properties[p].maxSize = isNaN(parseFloat(this.model.properties[p].maxSize)) ? null : parseFloat(this.model.properties[p].maxSize);
                    this.model.properties[p].collapsible = this.model.properties[p].collapsible != false ? true : false;
                    this.model.properties[p].resizable = this.model.properties[p].resizable != false ? true : false;
                    this.model.properties[p].expandable = this.model.properties[p].expandable != false ? true : false;
                }
                else this.model.properties.push({ paneSize: "0px", minSize: 10, maxSize: null, collapsible: true, resizable: true, expandable: true });
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value)
            });
        },


        _insertSplitBar: function () {
            if (this.panes.length > 1) {
                var i, splitBar;
                for (i = 0; i < this.panes.length - 1; i++) {
                    splitBar = this._createSplitBar(i);
                    splitBar.insertAfter(this.panes[i]);
                }
            }
        },

        _createSplitBar: function (i) {
            var orient = this.model.orientation.substr(0, 1), arrow1, arrow2, arrow3, splitBar, accessible = false;
            splitBar = ej.buildTag("span.e-box e-splitbar e-split-divider e-" + orient + "-bar").attr("aria-expanded", true);
            ej.browserInfo().name == "msie" && splitBar.addClass("e-pinch");
            arrow1 = ej.buildTag("span.e-icon e-collapse e-" + orient + "-arrow " + ((orient == "h") ? "e-arrow-sans-left" :"e-arrow-sans-up"));
            splitBar.append(arrow1);
            arrow3 = ej.buildTag("span.e-activebar e-" + orient + "-arrow ");
            splitBar.append(arrow3);
            arrow2 = ej.buildTag("span.e-icon e-expand e-" + orient + "-arrow " + ((orient == "h") ? "e-arrow-sans-right" :"e-arrow-sans-down"));
            splitBar.append(arrow2);
            accessible = true;
            this._on(arrow1, "mousedown", this._collapseArrowClick);
            this._on(arrow2, "mousedown", this._expandArrowClick);
            if (!this.model.properties[i].collapsible)
                arrow1.css("display", "none");
		   if(!this.model.properties[i].expandable)
			   arrow2.css("display", "none");
            if (this.model.properties[i + 1].collapsible)
                arrow2.css("display", "block");
            if (this.model.properties[i].resizable && this.model.properties[i + 1].resizable) {
                splitBar.addClass("e-resize").removeClass("e-icon-hide");
                accessible = true;
                this._on(splitBar, ej.eventType.mouseDown, this._mouseDownOnDivider);
                this._on(arrow3, ej.eventType.mouseDown, this._mouseDownOnDivider);
            }
            if (accessible) {
                splitBar.attr({ "role": "separator", "tabindex": "0" });
                this._on(splitBar, "focus focusout", this._focusOnDivider);
            }
            else splitBar.attr({ "role": "presentation" });
            return splitBar;
        },
        _getPanesPercent: function () {
            this._sizePercent = [];
            var size = this.element[this.containerCss](), outerSize = size - ((this.panes.length - 1) * this._bar), i;
            for (i = 0; i < this.panes.length; i++) {
                if (!$(this.panes[i]).hasClass("collapsed"))
                    this.oldPaneSize[i] = $(this.panes[i])[this.containerCss]();
                this.oldPanePercent[i] = this._convertToPercent(outerSize, this.oldPaneSize[i]);
                this._sizePercent.push(this._convertToPercent(outerSize, $(this.panes[i])[this.containerCss]()));
            }
        },

        _setDimentions: function () {
			var parentObj = this._getParentObj(),_width = parseInt(this.model.width), _height = parseInt(this.model.height);
			if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
                _width = (this.model.isResponsive) ? this._convertToPixel(parentObj.innerWidth(), _width):this.model.width;
            if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
                _height = (this.model.isResponsive) ? this._convertToPixel(parentObj.innerHeight(), _height):this.model.height;
            if (this.model.height)
                this.element.css("height",_height);
            if (this.model.width)
                this.element.css("width",_width );
        },

        _setHeightWidth: function () {
   		    this._setDimentions();
            this._setPanesSize();
            this._getPanesPercent();
        },

         _getParentObj: function () {
            return this.element.parent();
        },
        _checkProperties: function () {
            if (this.model.enableRTL) this._rtl(this.model.enableRTL);
            this._prevSize = this.element[this.containerCss]();
        },
        _getExactInnerWidth: function () {
            var browser = ej.browserInfo(), exactInnerWidth;
            if (browser.name == "msie") {
                if (browser.version == 8)
                    exactInnerWidth = $(this.element)[this.containerCss]();
                else
                    exactInnerWidth = parseFloat(window.getComputedStyle(this.element[0])[this.containerCss]);
            }
            else
                exactInnerWidth = parseFloat(window.getComputedStyle(this.element[0])[this.containerCss])
                                 - (parseFloat(this.element.css("border-" + this.displayCss + "-width")) +
                                     parseFloat(this.element.css("border-" + this.borderCss + "-width")) +
                                     parseFloat(this.element.css("padding-" + this.displayCss)) +
                                     parseFloat(this.element.css("padding-" + this.borderCss)));
            return exactInnerWidth;
        },

        _rtl: function (boolean) {
            if (boolean) this.element.addClass("e-rtl");
            else this.element.removeClass("e-rtl");
        },

        _setPanesSize: function () {
            var attr = this.containerCss,
            zeroPanes = 0,
            totalPaneSize = 0,
            totalSize = this.element[attr](),
            remainZero = false,
            bar = this._bar=($(this.element).find(">.e-splitbar").length>0)?parseFloat($(this.element).find(">.e-splitbar").css(attr)):this._bar,
            zerothPanes = [],
            panLength, j, paneCount = this.panes.length;

            if (paneCount > 1) {
                for (j = 0; j < paneCount ; j++) {
                    $(this.panes[j]).css(attr, this.model.properties[j].paneSize);
                    bar = (j == paneCount - 1) ? 0 : bar;
                    panLength = parseFloat($(this.panes[j])[attr]());
                    if(!ej.isNullOrUndefined(this.model.properties[j].maxSize)) panLength = panLength > this.model.properties[j].maxSize ? this.model.properties[j].maxSize : panLength;
                    $(this.panes[j]).css(attr, panLength);
                    if (panLength <= 0) {
                        zeroPanes++;
                        zerothPanes.push(j);
                        totalPaneSize += bar;
                    }
                    else {
                        if (remainZero) {
                            $(this.panes[j]).css(attr, 0);
                            totalPaneSize += panLength + bar;
                            this.model.properties[j].paneSize = 0;
                        }
                        else {
                            totalPaneSize += panLength + bar;
                            if (totalPaneSize > totalSize) {
                                var currPane = totalPaneSize - totalSize + bar,
                                remainDivider = paneCount - j - 1;
                                currPane += remainDivider * bar;
                                $(this.panes[j]).css(attr, currPane);
                                remainZero = true;
                                totalPaneSize += currPane + bar;
                            }
                            this.model.properties[j].paneSize = panLength;
                        }
                    }
                }
            }
            else if (paneCount == 1) {
                $(this.panes[0]).css(attr, "100%");
                totalPaneSize = totalSize;
            }

            if (paneCount > 1 && totalPaneSize != totalSize) {
			     var remainingSize, lastPane = $(this.panes[paneCount - 1]);
                if (totalPaneSize > totalSize) {
                    remainingSize = totalPaneSize - totalSize;
                    lastPane.css(attr, remainingSize);
                }
                else if (totalPaneSize < totalSize) {
                    remainingSize = totalSize - totalPaneSize;
                    if (zeroPanes > 0) {
                        var z, avgWid = parseFloat(remainingSize / zeroPanes);
                        for (z = 0; z < zeroPanes ; z++) {
                            $(this.panes[zerothPanes[z]]).css(attr, avgWid);
                            this.model.properties[zerothPanes[z]].paneSize = avgWid;
                        }
                    }
                    else {
                        for(var i = paneCount; i > 0; i--){
                            if(ej.isNullOrUndefined(this.model.properties[i - 1].maxSize)){ lastPane = $(this.panes[i - 1]); break;	}
                        }
                        lastPane.css(attr, parseFloat(lastPane[attr]() + remainingSize));
                        this.model.properties[paneCount - 1].paneSize = lastPane[attr]();
                    }
                }
            }
            if (paneCount > 1) this._checkPaneSize();
        },

        _getUnit: function (str) {
            if (str == "px") return "px";
            else if (str == "pt") return "pt";
            else if (str.substr(1) == "%") return "%";
            else return "px";
        },

        _getNormalValue: function (position) {
            var currentLOB, currentLOBPercent, totalValue, currentValue;
            if (this.model.orientation == "vertical") {
                currentLOB = position.y - this.element.offset().top;
                currentLOBPercent = currentLOB / this.element.outerHeight();
                totalValue = this.element.height();
            }
            else {
                currentLOB = position.x - this.element.offset().left;
                currentLOBPercent = currentLOB / this.element.outerWidth();
                totalValue = this.element.width();
            }
            if (currentLOBPercent > 1) {
                currentLOBPercent = 1;
            }
            if (currentLOBPercent < 0) {
                currentLOBPercent = 0;
            }
            currentValue = currentLOBPercent * totalValue;
            return this._trimValue(currentValue);
        },

        _trimValue: function (value) {
            var step, stepModValue, correctedValue;
            step = 1;
            stepModValue = (value) % step;
            correctedValue = value - stepModValue;
            if (Math.abs(stepModValue) * 2 >= step)
                correctedValue += (stepModValue > 0) ? step : (-step);
            return parseFloat(correctedValue.toFixed(5));
        },

        _getSplitbarIndex: function () {
            return this.element.children(".e-splitbar:not(.e-shadowbar)").index(this.currentSplitBar);
        },

        _paneResize: function () {
            if (this.shadowBar == null) return false;
            this.currentSplitBar = this.shadowBar.next();
            var newPosition, prevPane, nextPane, prevPaneIndex, nextPaneIndex, index = this._getSplitbarIndex();
            prevPane = this.shadowBar.prev(), nextPane = this.currentSplitBar.next();
            prevPaneIndex = index, nextPaneIndex = index + 1;
            newPosition = this.shadowBar.offset()[this.displayCss];
            newPosition = newPosition - this.currentSplitBar.offset()[this.displayCss];
            $(prevPane).css(this.containerCss, newPosition + $(prevPane)[this.containerCss]() + "px");
            $(nextPane).css(this.containerCss, $(nextPane)[this.containerCss]() - newPosition + "px");
            this.oldPaneSize[prevPaneIndex] = $(prevPane)[this.containerCss]();
            this.oldPaneSize[nextPaneIndex] = $(nextPane)[this.containerCss]();
            this.shadowBar.remove();
            this._checkPaneSize();
            var prevObj = { item: prevPane, index: prevPaneIndex, size: this.oldPaneSize[prevPaneIndex] };
            var nextObj = { item: nextPane, index: nextPaneIndex, size: this.oldPaneSize[nextPaneIndex] };
            this._updateModelValue(prevObj, nextObj);
            this._trigger("resize", {
                prevPane: prevObj,
                nextPane: nextObj,
                splitbarIndex: index
            });
        },

        _checkPaneSize: function () {
            var total = 0, len, i, splitterLen, paneCount = this.panes.length;
            for (i = 0; i < paneCount; i++) {
                len = this.containerCss=='width' ? $(this.panes[i])['outerWidth']() :$(this.panes[i])['outerHeight']();
                total += len + this._bar;
            }
            total -= this._bar;
            splitterLen = this._getExactInnerWidth();
            if (total != splitterLen) {
                var remain = splitterLen - total;
                var last = $(this.panes[paneCount - 1])[this.containerCss]();
                var lastPaneBorder = parseFloat($(this.panes[paneCount-1]).css('border-left-width'))+parseFloat($(this.panes[paneCount-1]).css('border-right-width'));
                var lastPaneBorderLength = (lastPaneBorder > 0) ? lastPaneBorder : 1;
                if (last == 0) {
                    for (i = paneCount - 1; i >= 0; i--) {
                        if ($(this.panes[i]).hasClass("expanded") && !$(this.panes[i]).hasClass("collapsed")) {
                            last = $(this.panes[i])[this.containerCss]();
                            $(this.panes[i]).css(this.containerCss, parseFloat(last + remain));
                            break;
                        }
                    }
                }
                else
                    $(this.panes[paneCount - 1]).css(this.containerCss, parseFloat(last + remain - lastPaneBorderLength));
            }
        },

        _maxminDraggableRange: function (shadowbarPos) {
            var prevPane, nextPane, prevPaneSize, nextPaneSize, splitbarPosition, prevPaneRange, nextPaneRange,
                prevPaneIndex, nextPaneIndex, PaneMax1, PaneMax2, PaneMin1, PaneMin2, index;
            prevPane = this.shadowBar.prev();
            this.currentSplitBar = this.shadowBar.next();
            nextPane = this.currentSplitBar.next();
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            splitbarPosition = this.displayCss == "left" ? this.currentSplitBar[0].offsetLeft : this.currentSplitBar[0].offsetTop;
            prevPaneRange = splitbarPosition - prevPaneSize;
            nextPaneRange = nextPaneSize + splitbarPosition;
            index = this._getSplitbarIndex();
            prevPaneIndex = index;
            nextPaneIndex = index + 1;
            PaneMax1 = this.model.properties[prevPaneIndex].maxSize;
            PaneMax2 = this.model.properties[nextPaneIndex].maxSize;
            PaneMax1 = PaneMax1 != null ? parseInt(PaneMax1, 10) : null;
            PaneMax2 = PaneMax2 != null ? parseInt(PaneMax2, 10) : null;
            this.model.properties[prevPaneIndex].minSize = parseInt(this.model.properties[prevPaneIndex].minSize, 10);
            this.model.properties[nextPaneIndex].minSize = parseInt(this.model.properties[nextPaneIndex].minSize, 10);
            PaneMin1 = this.model.properties[prevPaneIndex].minSize;
            PaneMin2 = this.model.properties[nextPaneIndex].minSize;
            this.shadowBar.removeClass("e-end-indicaton");
            if (shadowbarPos > nextPaneRange - PaneMin2) {
                this.resizedPosition = nextPaneRange - PaneMin2;
                this.shadowBar.addClass("e-end-indicaton");
            }
            else if (shadowbarPos < prevPaneRange + PaneMin1) {
                this.resizedPosition = prevPaneRange + PaneMin1;
                this.shadowBar.addClass("e-end-indicaton");
            }
            if (PaneMax1 != null) {
                if (shadowbarPos > prevPaneRange + PaneMax1) {
                    this.resizedPosition = prevPaneRange + PaneMax1;
                    this.shadowBar.addClass("e-end-indicaton");
                }
            }
            else if (PaneMax2 != null) {
                if (shadowbarPos < nextPaneRange - PaneMax2) {
                    this.resizedPosition = nextPaneRange - PaneMax2;
                    this.shadowBar.addClass("e-end-indicaton");
                }
            }
        },

        _collapseArrowClick: function (event) {
            if (this.shadowBar != null) return;
            var $target = $(event.target);
            this._inMovement = true;
            this.currentSplitBar = $target.parent();
            var currBarNo, prevPane, nextPane, prevPaneIndex, nextPaneIndex, prevPaneSize, nextPaneSize, properties = {};
            var paneCount = this.panes.length;
            currBarNo = this._getSplitbarIndex();
            prevPane = this.currentSplitBar.prev();
            nextPane = this.currentSplitBar.next();
            prevPaneIndex = currBarNo;
            nextPaneIndex = currBarNo + 1;
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            var proxy = this, collapsed, expanded;
            collapsed = { item: prevPane, index: prevPaneIndex, size: prevPaneSize };
            expanded = { item: nextPane, index: nextPaneIndex, size: nextPaneSize };
            if (this._raiseEvent("beforeExpandCollapse", collapsed, expanded, currBarNo))
                return false;
            if (!nextPane.hasClass("collapsed")) {
                this.oldPaneSize[prevPaneIndex] = prevPaneSize;
                prevPane.addClass("collapsed");
                nextPane.addClass("expanded");
                this.currentSplitBar.attr("aria-expanded", false);
                $target.parent().removeClass("e-resize").addClass("e-icon-hide");
                $target.css("display", "none");
                if (!this.model.properties[nextPaneIndex].collapsible)
                     $($target.siblings()).not('.e-activebar').css("display", "block");
                if (prevPaneIndex != 0) {
                    var preBar = prevPane.prev();
                    preBar.find(".e-expand").css("display", "none");
                    if (!this.model.properties[prevPaneIndex - 1].collapsible && $(prevPane.prev().prev()[0]).hasClass("expanded"))
                        preBar.find(".e-collapse").css("display", "block");
                    preBar.removeClass("e-resize").addClass("e-icon-hide");
                }
                properties[this.containerCss] = 0;
                prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                properties[this.containerCss] = prevPaneSize + nextPaneSize;
                nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                    proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                });
            }
            else {
                if (prevPaneSize < this.oldPaneSize[nextPaneIndex]) {
                    $target.addClass("e-end-indicaton");
                    this._inMovement = false;
                    $(document).on("mouseup", $.proxy(this._mouseUpOnArrow, this));
                    return false;
                }
                else {
                    prevPane.removeClass("expanded");
                    nextPane.removeClass("collapsed");
                    $target.parent().addClass("e-resize").removeClass("e-icon-hide");
                    $($target.siblings()).not('.e-activebar').css("display", "block");
                    if (!this.model.properties[prevPaneIndex].collapsible)
                        $target.css("display", "none");
                    if (nextPaneIndex != paneCount - 1) {
                        var nextBar = nextPane.next();
                        if (!this.model.properties[nextPaneIndex + 1].collapsible)
                            nextBar.find(".e-expand").css("display", "none");
                        nextBar.find(".e-collapse").css("display", "block");
                        if (!nextBar.next().hasClass("collapsed")) {
                            nextBar.addClass("e-resize").removeClass("e-icon-hide");
                            nextBar.attr("aria-expanded", true);
                        }
                    }

                    properties[this.containerCss] = this.oldPaneSize[nextPaneIndex];
                    nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                    properties[this.containerCss] = prevPaneSize - this.oldPaneSize[nextPaneIndex];
                    prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                        proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                    });
                }
            }
        },

        _expandArrowClick: function (event) {
            if (this.shadowBar != null) return;
            var $target = $(event.target);
            this._inMovement = true;
            this.currentSplitBar = $target.parent();
            var currBarNo, prevPane, nextPane, prevPaneIndex, nextPaneIndex, prevPaneSize, nextPaneSize, properties = {};
            var paneCount = this.panes.length;
            currBarNo = this._getSplitbarIndex();
            prevPane = this.currentSplitBar.prev();
            nextPane = this.currentSplitBar.next();
            prevPaneIndex = currBarNo;
            nextPaneIndex = currBarNo + 1;
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            var proxy = this, collapsed, expanded;
            collapsed = { item: nextPane, index: nextPaneIndex, size: nextPaneSize };
            expanded = { item: prevPane, index: prevPaneIndex, size: prevPaneSize };

            if (this._raiseEvent("beforeExpandCollapse", collapsed, expanded, currBarNo))
                return false;
            if (!prevPane.hasClass("collapsed")) {
                this.oldPaneSize[nextPaneIndex] = nextPaneSize;
                prevPane.addClass("expanded");
                nextPane.addClass("collapsed");
                $target.parent().removeClass("e-resize").addClass("e-icon-hide");
                $target.css("display", "none");
                if (!this.model.properties[prevPaneIndex].collapsible)
                      $($target.siblings()).not('.e-activebar').css("display", "block");
                if (nextPaneIndex != paneCount - 1) {
                    var nextBar = nextPane.next();
                    nextBar.find(".e-collapse").css("display", "none");
                    if (!this.model.properties[nextPaneIndex + 1].collapsible && $(nextPane.next().next()[0]).hasClass("collapsed"))
                        nextBar.find(".e-expand").css("display", "block");
                    nextBar.removeClass("e-resize").addClass("e-icon-hide");
                    nextBar.attr("aria-expanded", false);
                }
                properties[this.containerCss] = prevPaneSize + nextPaneSize;
                prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                properties[this.containerCss] = 0;
                nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                    proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                });
            }
            else {
                if (nextPaneSize < this.oldPaneSize[prevPaneIndex]) {
                    $target.addClass("e-end-indicaton");
                    this._inMovement = false;
                    $(document).on("mouseup", $.proxy(this._mouseUpOnArrow, this));
                    return false;
                }
                else {
                    prevPane.removeClass("collapsed");
                    nextPane.removeClass("expanded");
                    this.currentSplitBar.attr("aria-expanded", true);
                    $target.parent().addClass("e-resize").removeClass("e-icon-hide");
                      $($target.siblings()).not('.e-activebar').css("display", "block");
                    if (!this.model.properties[nextPaneIndex].collapsible)
                        $target.css("display", "none");
                    if (prevPaneIndex != 0) {
                        var preBar = prevPane.prev();
                        if (!this.model.properties[currBarNo - 1].collapsible)
                            preBar.find(".e-collapse").css("display", "none");
                        preBar.find(".e-expand").css("display", "block");
                        if (!preBar.prev().hasClass("collapsed")) preBar.addClass("e-resize").removeClass("e-icon-hide");
                    }

                    properties[this.containerCss] = this.oldPaneSize[prevPaneIndex];
                    prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                    properties[this.containerCss] = nextPaneSize - this.oldPaneSize[prevPaneIndex];
                    nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                        proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                    });
                }
            }
        },

        _raiseEvent: function (evtName, collapsed, expanded, index) {
            if (evtName == "expandCollapse") {
                this._inMovement = false;
                this._updateModelValue(collapsed, expanded);
            }
            return this._trigger(evtName, {
                collapsed: collapsed,
                expanded: expanded,
                splitbarIndex: index
            });

        },

        _updateModelValue: function (collapsed, expanded) {
            this.model.properties[collapsed.index].paneSize = collapsed.item[this.containerCss]();
            this.model.properties[expanded.index].paneSize = expanded.item[this.containerCss]();
            this._getPanesPercent();
        },

        _mouseUpOnArrow: function (event) {
            this.element.find(".e-end-indicaton").removeClass("e-end-indicaton");
            $(document).off("mouseup", $.proxy(this._mouseUpOnArrow, this));
        },

        _keydownOnDivider: function (e) {
            var key = e.keyCode;
            if (key == 37 || key == 38 || key == 39 || key == 40) {
                e.preventDefault();
                var oriTarget = $(e.data.target);
                if (e.ctrlKey) {
                    if (this.shadowBar == null) {
                        this.currentSplitBar = oriTarget;
                        var index = this._getSplitbarIndex();
                        if (this.model.orientation == "vertical") {
                            if (e.keyCode == 38) this.collapse(index);
                            else if (e.keyCode == 40) this.expand(index);
                        }
                        else {
                            if (e.keyCode == 37) this.collapse(index);
                            else if (e.keyCode == 39) this.expand(index);
                        }
                    }
                }
                else if (oriTarget.hasClass("e-resize")) {
                    var target = (this.shadowBar != null) ? this.shadowBar : oriTarget;
                    var offset = target.offset(), location = { pageX: offset.left, pageY: offset.top };
                    $.extend(true, e, location);
                    if ((this.model.orientation == "vertical" && (e.keyCode == 38 || e.keyCode == 40)) ||
                        (this.model.orientation == "horizontal" && (e.keyCode == 37 || e.keyCode == 39))) {
                        if (e.keyCode == 38) e.pageY -= 5;
                        else if (e.keyCode == 40) e.pageY += 5;
                        else if (e.keyCode == 37) e.pageX -= 5;
                        else if (e.keyCode == 39) e.pageX += 5;
                        this._mouseMoveOnDivider(e);
                    }
                }
            }
            else if (key == 13) {
                e.preventDefault();
                this._mouseUpOnDivider();
            }
            else if (key == 27) {
                e.preventDefault();
                if (this.shadowBar != null) this.shadowBar.remove();
                this.shadowBar = null;
                this._mouseUpOnDivider();
                this.element.children(".e-splitbar.e-hover").focusout();
            }
        },

        _focusOnDivider: function (e) {
            if (e.type == "focus") {
                if (!$(e.target).hasClass("e-hover")) {
                    $(e.target).addClass("e-hover");
                    if (this.model.allowKeyboardNavigation)
                        $(document).on("keydown", { target: e.target }, $.proxy(this._keydownOnDivider, this));
                }
            }
            else {
                this.element.children(".e-splitbar.e-hover").removeClass("e-hover");
                this._mouseUpOnDivider();
                $(document).off("keydown", $.proxy(this._keydownOnDivider, this));
            }
        },

        _mouseDownOnDivider: function (event) {
            event.preventDefault();
            var $target;
            ($(event.target).hasClass("e-activebar")) ? $target=$(event.target.parentElement) : $target=$(event.target);
            if ($target.hasClass("e-splitbar") && $target.hasClass("e-resize")) {
                this._overlayElement = ej.buildTag('div.e-pane-overlay');
                if (!$target.hasClass("e-hover")) $target.focus();
                this.element.find(".e-pane").not(".e-splitter").append(this._overlayElement);
                $(document).on(ej.eventType.mouseMove, { target: ($(event.target).hasClass("e-activebar")) ? event.target.parentElement : event.target }, $.proxy(this._mouseMoveOnDivider, this));
                $(document).on(ej.eventType.mouseUp, $.proxy(this._mouseUpOnDivider, this));
                $(document).on("mouseleave", $.proxy(this._mouseUpOnDivider, this));
            }
            else if ($target.hasClass("e-expand") || $target.hasClass("e-collapse")) {
                $target.parent().focus();
            }
        },

        _mouseMoveOnDivider: function (event) {
            var _data = event.data;
            event = event.type == "touchmove" ? event.originalEvent.changedTouches[0] : event;
            var position = { x: event.pageX, y: event.pageY };
            this.resizedPosition = this._getNormalValue(position);
            if (this.shadowBar == null) {
                var target;
                ($(_data.target).hasClass('e-activebar')) ? target=$(_data.target.parentElement) : target=$(_data.target);
                this.shadowBar = target.clone().addClass("e-shadowbar").removeClass("e-hover").removeClass("e-split-divider").insertBefore(target);
                this.shadowBar.children().remove();
            }
            this._maxminDraggableRange(this.resizedPosition);
            this.shadowBar.css(this.displayCss, this.resizedPosition);
        },

        _mouseUpOnDivider: function (event) {
            this._paneResize();
            this.element.find(".e-pane").not(".e-splitter").find(".e-pane-overlay").remove();
            $(document).off(ej.eventType.mouseMove, $.proxy(this._mouseMoveOnDivider, this));
            $(document).off(ej.eventType.mouseUp, $.proxy(this._mouseUpOnDivider, this));
            $(document).off("mouseleave", $.proxy(this._mouseUpOnDivider, this));
            // sets shadowBar null after removing shadowBar element
            this.shadowBar = null;
        },

        _windowResized: function (event) {
            var size = this._getExactInnerWidth();
            if (this._prevSize == size) return false;
            var paneCount = this.panes.length, outerSize = size - ((paneCount - 1) * this._bar), i, val;
            this._prevSize = size;
            for (i = 0; i < paneCount; i++) {
                val = this._convertToPixel(outerSize, this._sizePercent[i]);
                $(this.panes[i]).css(this.containerCss, val + "px");
            }
            for (i = 0; i < this.oldPaneSize.length; i++)
                this.oldPaneSize[i] = this._convertToPixel(outerSize, this.oldPanePercent[i]);
            this._checkPaneSize();
        },

        _convertToPercent: function (outer, pane) {
            return (pane * 100) / outer;
        },
        _convertToPixel: function (tot, percent) {
            return parseFloat((tot * percent) / 100);
        },

        _wireEvents: function (boolean) {
            if (boolean) $(window).on('resize', $.proxy(this._windowResized, this));
        },

        _unWireEvents: function () {
            $(window).off('resize', $.proxy(this._windowResized, this));
        }
    });

})(jQuery, Syncfusion);;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Print = (function (_super) {
    __extends(Print, _super);
    function Print(element, options) {
        _super.call(this);
        this._rootCSS = "e-print";
        this.PluginName = "ejPrint";
        this.id = "null";
        this.defaults = {
            globalStyles: true,
            externalStyles: null,
            excludeSelector: null,
            append: null,
            printInNewWindow: false,
            prepend: null,
            timeOutPeriod: 1000,
            title: null,
            height: 454,
            width: 1024,
            docType: "<!doctype html>",
            beforeStart: null
        };
        if (element) {
            if (!element.jquery) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejPrint(options).data(this.PluginName);
            }
        }
    }
    Print.prototype._init = function () {
        this.id = this.element[0].id;
        this._initialize(this.element, undefined);
    };
    Print.prototype._initialize = function (element, bool) {
        this.styles = $("");
        this.title = $("title");
        if (this.model.globalStyles) {
            this._addglobalStyles(this.model.globalStyles);
        }
        if (this.model.externalStyles) {
            this._addStylesToElement(this.model.externalStyles);
        }
        if (this.model.title) {
            this._addTitleToElement(this.model.title);
        }
        var htmlTag = $("<html/>");
        var headTag = $("<head/>").append(this.title);
        headTag.append(this.styles.clone());
        var bodyTag = $("<body/>");
        var innercontent = $("<div/>");
        if (bool) {
            if (typeof element === "string") {
                element = $(element);
                innercontent.append(element.clone());
            }
            else if (typeof element === "object") {
                for (var i = 0; i < element.length; i++) {
                    innercontent.append($(element[i]).clone());
                }
            }
        }
        else {
            innercontent.append(element.clone());
        }
        this.copy = innercontent;
        bodyTag.append(this.copy);
        if (this.model.append) {
            bodyTag.append(this._getjQueryObject(this.model.append));
        }
        if (this.model.prepend) {
            bodyTag.prepend(this._getjQueryObject(this.model.prepend));
        }
        this.copy = htmlTag.append(headTag).append(bodyTag);
        if (this.model.excludeSelector != null) {
            this._removeContentFromPrint(this.model.excludeSelector);
        }
        var content = this.copy;
        this.copy.remove();
        if (bool === undefined) {
            this._printContent(content, null, false);
            return true;
        }
        return content;
    };
    Print.prototype._getjQueryObject = function (element) {
        var value = $(element).clone().length === 0 ? $("<div />").html(element) : $(element).clone();
        return value;
    };
    Print.prototype._addglobalStyles = function (element) {
        if (this.model.globalStyles) {
            this.styles = $("style, link, meta, title");
        }
    };
    Print.prototype._addStylesToElement = function (element) {
        if (this.model.externalStyles) {
            var substr = $.isArray(element) ? element : element.split(",");
            for (var i = 0; i < substr.length; i++) {
                var link = $("<link rel='stylesheet' href='" + substr[i] + "'>");
                this.styles = $.merge(this.styles, link);
            }
        }
    };
    Print.prototype._addTitleToElement = function (element) {
        if (this.model.title) {
            if (this.title.length === 0) {
                this.title = $("<title />");
            }
            this.title.text(this.model.title);
        }
    };
    Print.prototype._removeContentFromPrint = function (element) {
        if (this.model.excludeSelector) {
            var substr = $.isArray(element) ? element : element.split(",");
            for (var i = 0; i < substr.length; i++) {
                this.copy.find(substr[i]).remove();
            }
        }
    };
    Print.prototype._printContent = function (element, printWin, bool) {
        var _this = this;
        var printWindow;
        if (bool) {
            var content = [];
            if (this.element.attr("id") !== undefined) {
                content.push("#" + this.element.attr("id"));
            }
            else {
                content.push("." + this.element.attr("class").replace(/ /g, "."));
            }
            if (element !== undefined) {
                if ($.isArray(element)) {
                    for (var i = 0; i < element.length; i++) {
                        content.push(element[i]);
                    }
                }
                else {
                    content.push(element);
                }
            }
            element = this._initialize(content, true);
        }
        this._trigger("beforeStart", { content: element });
        if (!printWin) {
            if (this.model.printInNewWindow) {
                printWindow = window.open();
            }
            else {
                printWindow = window.open(" ", "print", "height=" + this.model.height + ",width=" + this.model.width + ",tabbar=no");
            }
        }
        printWindow.document.write(this.model.docType);
        printWindow.document.write((element[0].outerHTML));
        printWindow.document.close();
        printWindow.focus();
        setTimeout(function () {
            if (!ej.isNullOrUndefined(printWindow.window)) {
                printWindow.print();
                setTimeout(function () { printWindow.close(); }, _this.model.timeOutPeriod);
            }
        }, this.model.timeOutPeriod);
    };
    Print.prototype.print = function (element, printWin) {
        this._printContent(element, printWin, true);
    };
    return Print;
}(ej.WidgetBase));
window.ej.widget("ejPrint", "ej.Print", new Print());
;
/**
* @fileOverview Plugin to style the tab control.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejTab", "ej.Tab", {
        _rootCSS: "e-tab",

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["selectedItemIndex"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            collapsible: false,

            enableAnimation: true,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            disabledItemIndex: [],

            enabledItemIndex: [],

            hiddenItemIndex: [],

            events: "click",

            idPrefix: "ej-tab-",

            heightAdjustMode: "content",

            selectedItemIndex: 0,

            cssClass: "",

            showCloseButton: false,

            htmlAttributes: {},

            enableTabScroll: false,

            showReloadIcon: false,

            headerPosition: "top",

            width: null,

            height: null,

            headerSize: null,

            enableRTL: false,

            allowKeyboardNavigation: true,

            showRoundedCorner: false,

            enablePersistence: false,

            enabled: true,

            ajaxLoad: null,

            ajaxBeforeLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            itemActive: null,

            beforeActive: null,

            itemAdd: null,

            itemRemove: null,

            beforeItemRemove: null,

            create: null,

            destroy: null

        },
        dataTypes: {
            cssClass: "string",
            collapsible: "boolean",
            events: "string",
            heightAdjustMode: "enum",
            enabled: "boolean",
            ajaxSettings: "data",
            disabledItemIndex: "data",
            enabledItemIndex: "data",
            enableAnimation: "boolean",
            htmlAttributes: "data"
        },
        observables: ["selectedItemIndex"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),


        _destroy: function () {
            this._unWireEvents();
            this._removeBaseClass();
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "events": {
                        this._off(this.items, this.model.events);
                        this._on(this.items, options[key], this._tabItemClick);
                        break;
                    }
                    case "disabledItemIndex": {
                        this._disableItems(options[key]);
                        options[key] = this.model.disabledItemIndex;
                        break;
                    }
                    case "enabledItemIndex": this._enableItems(options[key]); break;
                    case "enabled": this._enabledAction(options[key]); break;
                    case "selectedItemIndex": {
                        this._isInteraction = false;
                        this.showItem(ej.util.getVal(options[key]));
                        options[key] = this.model.selectedItemIndex;
                        break;
                    }
                    case "heightAdjustMode": {
                        this.model.heightAdjustMode = options[key];
                        this._setTabsHeightStyle(options[key]);
                        this._resizeEvents(options[key]);
                        break;
                    }
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this._roundedCorner(options[key]); break;
                    case "height": {
                        this.model.height = options[key];
                        this._setTabsHeightStyle(this.model.heightAdjustMode);
                        break;
                    }
                    case "width": this.element.width(options[key]);
                        $(this.contentPanels).width(Number(options[key]));
                        this.refreshTabScroll();
                        break;
                    case "headerSize": this._setHeaderSize(options[key]); break;
                    case "allowKeyboardNavigation": {
                        if (options[key])
                            this._on(this.element, 'keydown', this._keyPress);
                        else
                            this._off(this.element, "keydown");
                        break;
                    }
                    case "headerPosition":
                        {
                            this.model.headerPosition = options[key];
                            if (this.model.headerPosition == ej.Tab.Position.Top) {
                                this._removeVerticalClass();
                                this._removeScroll();
                                this.itemsContainer.remove();
                                this.itemsContainer.insertBefore(this.element.find(">div").first());
                                this.element.find("div.e-active-content").removeClass("e-activebottom");
                                $(this.contentPanels).css("margin-top", "0")
                            }
                            else if (this.model.headerPosition == ej.Tab.Position.Bottom) {
                                this._removeVerticalClass();
                                this._removeScroll();
                                this.element.find("div.e-active-content").removeClass("e-activetop");
                                this.model.enableTabScroll ? $(this.contentPanels).css("margin-top", "0") : $(this.contentPanels).css("position", "relative")
                            }
                            else if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._removeHeaderClass();
                                $(this.items).css('display', '');
                                this._removeScroll();

                            }
                            this._refresh();
                            if (this.model.headerPosition == ej.Tab.Position.Right)
                                this.element.css("position", "")
                            if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                if (this.model.height && this.model.enableTabScroll) {
                                    $(this.contentPanels).height(Number(this.model.height) - 2);
                                    this.element.find("div.e-active-content").height(Number(this.model.height) - 32)
                                }

                            }

                            this.scrollstep = 30
                            break;
                        }
                    case "showCloseButton":
                        {
                            if (options[key]) {
                                this._addDeleteIcon();
                                this._on(this.element.find("div.e-close"), "click", this._tabDeleteClick);
                            } else
                                this.element.find("div.e-close").remove();
                            break;
                        }
                    case "enableTabScroll":
                        {
                            this.model.enableTabScroll = options[key];
                            if (options[key]) {
                                this._removeScroll();
                                this._addScroll();
                                if (this.model.headerPosition == "left") {
                                    this._refresh();
                                    this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                }
                            } else {
                                this._removeScroll();
                                this.itemsContainer.removeAttr("style");
                                $(this.contentPanels).css("margin-top", "0")
                            }
                            if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._refresh();
                                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                if (this.model.headerPosition == ej.Tab.Position.Right && !this.model.enableTabScroll)
                                    this.element.css("margin-left", "")
                            }
                            break;
                        }
                    case "showReloadIcon":
                        {
                            if (options[key]) {
                                this._addReloadIcon();
                            } else
                                this.element.find("div.e-reload").remove();
                            break;
                        }
                    case "enableRTL":
                        {
                            this.model.enableRTL = options[key];
                            this._removeScroll();
                            this.itemsContainer.removeAttr("style");
                            $(this.contentPanels).css("margin-top", "0")
                            this.element.find("ul").removeAttr("style")
                            options[key] ? this.element.addClass("e-rtl") : this.element.removeClass("e-rtl");
                            if (this.model.enableTabScroll)
                                this._addScroll();
                            this._refresh();
                            this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                            if (this.model.headerPosition == ej.Tab.Position.Right && this.model.enableRTL)
                                this.element.css("margin-left", '')

                            break;
                        }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                    case "hiddenItemIndex": {
                        if (this.model.headerPosition == ej.Tab.Position.Top || this.model.headerPosition == ej.Tab.Position.Bottom)
                            $(this.items).css('display', 'inline-block');
                        else $(this.items).css('display', '');
                        this.model.hiddenItemIndex = options[key];
                        this.model.hiddenItemIndex.length > 0 && this._hiddenIndexItem(this.model.hiddenItemIndex);
                        break;
                    }
                }
            }
        },

        _removeScroll: function () {
            this.itemsContainer.removeAttr("style");
            this.element.find("div.e-chevron-circle-right").remove();
            this.element.find("div.e-chevron-circle-left").remove();
        },

        _addScroll: function () {
            if ((this.model.headerPosition == "left" || this.model.headerPosition == "right" && this._tabContentsHeight() > (this.element.width() || Number(this.model.height))) || (this.model.headerPosition == "top" || this.model.headerPosition == "bottom"))
                this._checkScroll();
            this._addScrollIcon();
            this.refreshTabScroll();
        },

        _init: function () {
            this._addItemIndex = null;
            this.tabId = 0;
            this._hiddenIndex = this.model.hiddenItemIndex;
            this._initialize();
            this._prevSize = this._getDimension($(this.element).parent(), "height");
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _tabContentsWidth: function () {
            var length = this.element.find("li").length;
            var tabLength = 0;
            for (var i = 0; i < length; i++) {
                tabLength = tabLength + $(this.element.find("li")[i]).width();
            }
            return tabLength
        },

        _tabContentsHeight: function () {
            var length = this.element.find("li").length;
            var tabHeight = 0;
            for (var i = 0; i < length; i++) {
                tabHeight = tabHeight + $(this.element.find("li")[i]).height();
            }
            return tabHeight
        },

        _initialize: function () {
            this.initialRender = true;
            this.element.attr("tabindex", 0).attr("role", "tablist");
            this._itemsRefreshing();
            $(this.anchors).addClass("e-link");
            this._preTabSelectedIndex = this._preTabIndex = -1;
            if (!ej.isNullOrUndefined(this.model.width))
                this.element.width(this.model.width);
            if (!ej.isNullOrUndefined(this.model.height))
                this.element.height(this.model.height);
            this._setTabPosition(this.model.headerPosition);
            if (this.model.showCloseButton)
                this._addDeleteIcon();
            if (this.model.showReloadIcon)
                this._addReloadIcon();
            if (this.model.showRoundedCorner)
                this._roundedCorner(this.model.showRoundedCorner);
            this._enabledAction(this.model.enabled);
            this.contentPanels = [];
            this._addAttr(this.model.htmlAttributes);
            this._reinitialize();
            this._addBaseClass();
            if (!ej.isNullOrUndefined(this.model.headerSize))
                this._setHeaderSize(this.model.headerSize);
            this._disableTabs();
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.enableTabScroll) {
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    if (this.itemsContainer.width() > (this.element.width()))
                        this._addScrollIcon();
                }
                else {
                    if (this.element.height() < (this.items.height() * this.items.length))
                        this._addScrollIcon();
                }
            }
            this._wireEvents(this.model.events);
            // Added for rendering the Windows tab...
            this.showItem(this.selectedItemIndex());
            this._setTabsHeightStyle(this.model.heightAdjustMode);
            this._enabledAction(this.model.enabled);
            this._resizeEvents(this.model.heightAdjustMode);
            this.model.hiddenItemIndex.length > 0 && this._hiddenIndexItem(this.model.hiddenItemIndex);
        },

        _reinitialize: function ( addContentBaseClass ) {
            var hid, href, hrefbase;
            for (var i = (this._addItemIndex != null) ? this._addItemIndex : 0; i < this.anchors.length; i++) {
                hid = this.anchors[i];
                if (this.divId == undefined)
                    href = $(hid).attr("href");
                else
                    href = this.divId;
                this.divId = undefined;
                hrefBase = href.split("#")[0];
                if (hrefBase && (hrefBase === location.toString().split("#")[0])) {
                    href = a.hash;
                    hid.href = href;
                }
                if (href && href !== "#") {
                    this._addContentTag(href, i);
                    if(addContentBaseClass) this._addContentBaseClass($(this.contentPanels[i]));
                }
                else if (!this.model.enablePersistence) {
                    this.model.disabledItemIndex.push(i);
                }
                if (this._addItemIndex != null) {
                    this._unWireEvents();
                    this._wireEvents(this.model.events);
				if (this.items.length == 1) {
					this.showItem(this.selectedItemIndex());
				}
                    break;
                }
            }

        },
        _itemsRefreshing: function () {
            this.itemsContainer = this.element.find("ol,ul").eq(0);
            this.items = this.itemsContainer.find(" > li:has(a[href])");
            this.anchors = this.items.find('a[href]');
        },
        _setHeaderSize: function (size) {
            this.element.find(">ul li.e-item").css("height", "auto");
            this.element.find(">ul li.e-item").children("a.e-link").css("margin-top", "0px");
            if (this.model.headerPosition == "left") {
                this.element.find(">ul.e-left").css({ "width": size, "text-align": "center" });
            }
            else if (this.model.headerPosition == "right") {
                this.element.find(">ul.e-right").css({ "width": size, "text-align": "center" });
            }
            else {
                this.element.find(">ul.e-header li.e-item").css("height", size);
                this.element.find(">ul.e-header li.e-item a.e-link").css("margin-top", ((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item a.e-link").outerHeight()).toString() + "px")
            }
        },
        _enabledAction: function (flag) {
            if (flag) {
                this.element.removeClass("e-disable");
            }
            else {
                this.element.addClass("e-disable");
            }
        },
        _hiddenIndexItem: function (value) {
            var elementId;
            for (var i = 0; i < value.length; i++) {
                if (!$.inArray(parseInt(value[i]), this._hiddenIndex) > -1) {
                    elementId = $(this.items[parseInt(value[i])]).children('a').attr('href');
                    this._hidePanel(elementId);
                }
            }
            this._hideContentPanel(this.selectedItemIndex(), this.model.hiddenItemIndex);
            this._hiddenIndex = this.model.hiddenItemIndex;
        },
        _hidePanel: function (value) {
            for (var j = 0; j < this.contentPanels.length; j++) {
                if ("#" + $(this.contentPanels[j]).attr('id') == value) {
                    $(this.contentPanels[j]).css('display', 'none');
                    break;
                }
            }
            for (var i = 0; i < this.items.length; i++) {
                if ($(this.items.children('a')[i]).attr('href') == value) {
                    $(this.items[i]).css('display', 'none');
                    break;
                }
            }
        },
        _hideContentPanel: function (index, value) {
            if ($.inArray(index, value) > -1) {
                index += 1;
                if (index <= this.items.length - 1) {
                    this._hideContentPanel(index, value);
                }
                else if (index > this.items.length - 1 && value.length != this.items.length) {
                    this._hideContentPanel(0, value);
                }
            }
            else this.showItem(index);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") { proxy.model.enabled = false; proxy._enabledAction(false); }
                else proxy.element.attr(key, value)
            });
        },


        _setTabPosition: function (position) {
            if (position == ej.Tab.Position.Bottom) {
                this.itemsContainer.appendTo(this.element);
                this.items.removeClass("e-bottom-line");
                this.items.addClass("e-top-line");
            }
            else if (position == ej.Tab.Position.Top) {
                this.items.removeClass("e-top-line");
				this.itemsContainer.prependTo(this.element);
                if (this.model.enableRTL)
                    this.items.addClass("e-rtl-top-line e-top-hover");
                else
                    this.items.addClass("e-bottom-line");
            }
            else if (position == ej.Tab.Position.Left || position == ej.Tab.Position.Right) {
                if (this.items.length >= 0) {
                    if (this.model.height)
                        this.itemsContainer.css("height", this.model.height);
                    else {
                        if (!this.model.heightAdjustMode === "fill") $(this.itemsContainer).css("height", "");
                    }
                    this.element.addClass("e-vertical");
                }
            }
        },


        _addDeleteIcon: function () {
            if (this.element.find("div.e-close.e-tabdelete").length <= 0 && this.items.length > 0) {
                var deleteIcon = ej.buildTag('div.e-icon e-close e-tabdelete', "", {}, { role: "presentation" }).css("visibility", "hidden");
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    var delIconPosition = this.items.find("a");
                    deleteIcon.insertBefore(delIconPosition);
                }
                else
                    this.items.append(deleteIcon);
            }
        },
        _addScrollIcon: function () {
            this.element.addClass("e-tabscroll");
            if (this.element.find("div.e-chevron-circle-right").length <= 0 && this.items.length > 0) {
                this._rightScrollIcon = ej.buildTag('div.e-icon e-chevron-circle-right', "", {}, { role: "presentation" }).css("visibility", "hidden");
                this.itemsContainer.append(this._rightScrollIcon);
                this.scrollstep = 30;
                this._rightScrollIcon.css("position", "relative");
                if (!this.model.enableRTL) {
                    if (this.model.headerPosition == "left")
                        this._rightScrollIcon.css("margin-right", this.itemsContainer.width() / 2 + "px");
                    else if (this.model.headerPosition == "right")
                        this._rightScrollIcon.css("margin-left", this.itemsContainer.width() / 2 - this.scrollstep + "px");
                    else {
                        if (this.model.enablePersistence == true && this._beforeWidth != 0 && (this._beforeWidth > this.scrollPanelWidth))
                            this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - this.scrollPanelWidth + 20 - ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px");
                        else
                            this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - this.scrollPanelWidth + 20 + "px");
                    }
                }
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    this._rightScrollIcon.css("transform", "rotate(270deg)");
                    if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11) {
                        if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")
                            this._rightScrollIcon.css("margin-top", "-" + ((this.itemsContainer.height() + this.scrollPanelWidth) - 3) + "px");
                        else {
                            if (!this.model.enableRTL)
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length) - 20) + "px");
                            else
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length)) + "px");
                        }
                    }
                    else {
                        if (this.model.enablePersistence == true && this._beforeWidth != 0 && (this._beforeWidth > this.scrollPanelHeight))
                            this._rightScrollIcon.css("margin-top", "-" + ((this.items[this.selectedItemIndex()].offsetTop * 3 - this.scrollPanelHeight * 2)) + "px");
                        else
                            if (!this.model.enableRTL)
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length) - 20) + "px");
                            else
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length)) + "px");
                    }
                }

                else {
                    if (this.model.enableRTL) {
                        this._rightScrollIcon.css("margin-top", "-" + (this.itemsContainer.height()) + "px");
                        this._rightScrollIcon.css("margin-left", (this.itemsContainer.width() - 14) + "px");
                    }
                    else
                        this._rightScrollIcon.css("margin-top", "-" + ((this.itemsContainer.height() / 2) + 10) + "px");
                }
                if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11) {
                    if (this.model.headerPosition == "top") {
                        if (parseInt(this._rightScrollIcon.prev().offset().top) - parseInt(this._rightScrollIcon.offset().top) == (-parseInt(this._rightScrollIcon.css("margin-top"))))
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 27) + "px");
                    }
                    else if (this.model.headerPosition == "bottom") {
                        if (!this.model.enableRTL)
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 27) + "px");
                        else
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 20) + "px");
                    }
                }
                if (this.model.headerPosition == "left") {
                    this._rightScrollIcon.css("margin-right", this.itemsContainer.width() / 2 + "px");
                }
                else if (this.model.headerPosition == "right")
                    this._rightScrollIcon.css("margin-left", this.itemsContainer.width() / 2 - this.scrollstep + "px");
                this.element.attr('unselectable', 'on')
                this.element.css('user-select', 'none')
                this.element.on('selectstart', false);
                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
            }
        },
        _addScrollBackIcon: function () {
            if (this.element.find("div.e-chevron-circle-left").length <= 0) {
                this._leftScrollIcon = ej.buildTag('div.e-icon e-chevron-circle-left', "", {}, { role: "presentation" }).css("visibility", "hidden");
                this.itemsContainer.prepend(this._leftScrollIcon);
                this.rightscrollstep = 30;
                this.element.attr('unselectable', 'on')
                this.element.css('user-select', 'none')
                this.element.on('selectstart', false);
                this._leftScrollIcon.css("position", "absolute").css("z-index", "10");
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    if (!this.model.enableRTL) {
                        this._leftScrollIcon.css("margin-left", "20px");
                    }
                    else
                        this._leftScrollIcon.css("margin-right", (this.element.width() - 20) + "px");
                }
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    if (!this.model.enableRTL) {
                        if (this.model.headerPosition == "right")
                            this._leftScrollIcon.css("margin-left", ((this.itemsContainer.width() / 2) - 30) + "px");
                        else if (this.model.headerPosition == "left")
                            this._leftScrollIcon.css("margin-left", ((this.itemsContainer.width() / 2) - 15) + "px");
                        this._leftScrollIcon.css("margin-top", +this.scrollPanelHeight + 20 + "px");
                    }
                    else {
                        this._leftScrollIcon.css("margin-top", +(this.scrollPanelHeight - 4) + "px");
                        if (this.model.headerPosition == "right")
                            this._leftScrollIcon.css("margin-right", (this.itemsContainer.width() / 2 + 14) + "px");
                        else
                            this._leftScrollIcon.css("margin-right", (this.itemsContainer.width() / 2) + "px");
                    }
                    this._leftScrollIcon.css("transform", "rotate(270deg)");
                }
                else
                    if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11)
                        this._leftScrollIcon.css("margin-top", "0px");
                    else {
                        if (!this.model.enableRTL)
                            this._leftScrollIcon.css("margin-top", "-5px");
                        else
                            this._leftScrollIcon.css("margin-top", "0px");
                    }
                this._on(this._leftScrollIcon, "click", this._tabScrollBackClick);
            }
        },


        _addReloadIcon: function () {
            if (this.element.find("div.e-reload").length <= 0 && this.items.length > 0) {
                var reloadIcon = ej.buildTag('div.e-icon e-reload', "", {}, { role: "presentation" }).css("visibility", "hidden");
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    var iconPosition = this.items.find("a");
                    reloadIcon.insertBefore(iconPosition);
                }
                else
                    this.items.append(reloadIcon);
            }
        },


        _addBaseClass: function () {
            this.element.addClass("e-widget " + this.model.cssClass);
            this.itemsContainer.addClass("e-box")
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            // To avoid border blinking 
            if (this.model.headerPosition == "top") {
                $(this.contentPanels).addClass("e-hidebottom e-addborderbottom");
                $(this.itemsContainer).addClass("e-addborderbottom");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hideright e-addborderright e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderright e-addborderleft");
                this.items.length > 0 && this.itemsContainer.addClass("e-header");
                if (this.model.enableRTL) {
                    this.items.addClass("e-rtl-top-line");
                    this.items.removeClass("e-rtl-bottom-line");
                }
            }
            if (this.model.headerPosition == "bottom") {
                $(this.contentPanels).removeClass("e-hidebottom e-addborderbottom e-hideright e-addborderright e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addborderbottom e-addborderright e-addborderleft");
                $(this.contentPanels).addClass("e-hidetop e-addbordertop");
                $(this.itemsContainer).addClass("e-addbordertop");
                this.items.length > 0 && this.itemsContainer.addClass("e-header");
                if (this.model.enableRTL) {
                    this.items.addClass("e-rtl-bottom-line")
                    this.items.removeClass("e-rtl-top-line e-top-line");
                }
            }
            if (this.model.headerPosition == "left") {
                this.items.length > 0 && this.itemsContainer.addClass("e-left");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideright e-addborderright");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderbottom e-addborderright");
                $(this.contentPanels).addClass("e-hideleft e-addborderleft");
                $(this.itemsContainer).addClass("e-addborderleft");
                $(this.items).removeClass("e-rtl-bottom-line e-rtl-top-line");
            }
            if (this.model.headerPosition == "right") {
                this.items.length > 0 && this.itemsContainer.addClass("e-right");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderbottom e-addborderleft");
                $(this.contentPanels).addClass("e-hideright e-addborderright");
                $(this.itemsContainer).addClass("e-addborderright");
                if (this.model.enableTabScroll && this._tabContentsHeight() > (this.element.height || Number(this.model.height)))
                    $(this.itemsContainer).css("z-index", "12").css("margin-left", "-" + this.itemsContainer.find("li").width() + "px");
                $(this.items).removeClass("e-rtl-bottom-line e-rtl-top-line");
            }
            this.items.addClass("e-select e-item").attr("role", "tab").attr("tabindex", -1).attr("aria-expanded", true).attr("aria-selected", false);
            $(this.contentPanels).addClass("e-content  e-content-item e-box").attr("role", "tabpanel").attr("aria-hidden", true);
            if (((this.model.headerPosition == "left" || this.model.headerPosition == "right") && (this._tabContentsHeight() > (this.element.height() || Number(this.model.height)))) || ((this.model.headerPosition == "top" || this.model.headerPosition == "bottom") && this._tabContentsWidth() > ((ej.getDimension(this.element, "width")) || this.model.width)))
                this._checkScroll();
        },
        _addContentBaseClass: function (panelElement) {
            if (this.model.headerPosition == "top") {
                panelElement.addClass("e-hidebottom e-addborderbottom");
                panelElement.removeClass("e-hidetop e-addbordertop e-hideright e-addborderright e-hideleft e-addborderleft");
            }
            if (this.model.headerPosition == "bottom") {
                panelElement.removeClass("e-hidebottom e-addborderbottom e-hideright e-addborderright e-hideleft e-addborderleft");
                panelElement.addClass("e-hidetop e-addbordertop");
            }
            if (this.model.headerPosition == "left") {
                panelElement.removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideright e-addborderright");
                panelElement.addClass("e-hideleft e-addborderleft");
            }
            if (this.model.headerPosition == "right") {
                panelElement.removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideleft e-addborderleft");
                panelElement.addClass("e-hideright e-addborderright");
            }
            panelElement.addClass("e-content  e-content-item e-box").attr("role", "tabpanel").attr("aria-hidden", true);
        },

        _checkScroll: function () {
            this.scrollPanelWidth = ej.getDimension(this.element, "width");
            this.scrollPanelHeight = ej.getDimension(this.element, "height");
            if (this.model.enableTabScroll == true && this._tabContentsHeight() > this.items.height()) {
                this.scrollstep = 0;
                this.model.enableTabScroll = true;
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    this.itemsContainer.css({ "width": ((ej.getDimension(this.element, "width") + (parseInt(this.items.css("width")) * this.items.length))) + "px", "position": "absolute" });
                }
                this._beforeWidth = 0;
                if (this.model.enablePersistence == true) {
                    if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                        for (var val = 0; val < this.selectedItemIndex() ; val++) {
                            this._beforeWidth += this.items[val].offsetWidth;
                        }
                    }
                    else {
                        for (var val = 0; val < this.selectedItemIndex() ; val++) {
                            this._beforeWidth += this.items[val].offsetHeight;
                        }
                    }
                }
                var widthValue = parseInt(this.itemsContainer.css("width"));
                if (this.model.headerPosition == "top") {
                    var item = $(this.contentPanels);
                    item.css("padding-top", this.itemsContainer.outerHeight() + (item.hasClass("e-activetop") ? 0 : (this.model.enableRTL ? 4 : 3)) + "px");
                    $(this.contentPanels).css({"border-top": "none", "width": ej.getDimension(this.element, "width") - 1 + "px" });
                    this.itemsContainer.css("border-bottom", "1px solid #bbbcbb");
                }
                if (this.model.headerPosition == "bottom") {
                    $(this.contentPanels).css({ "position": "relative", "width": ej.getDimension(this.element, "width") - 1 + "px", "border-bottom": "none" });
                    this.itemsContainer.css("border-top", "1px solid #bbbcbb");
                    $(this.contentPanels).css({ "border-top": "" });
                }

                var rigtVaule = parseInt(widthValue - (this.scrollPanelWidth + this.scrollstep - 1));
                if (this.model.enableRTL && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                    this.itemsContainer.css("clip", "rect(0px," + widthValue + "px,100px," + rigtVaule + "px)");
                }
                else if (this.model.headerPosition == "left") {
                    if (this._tabContentsHeight() > Number(this.model.height)) {
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "border-right": "1px solid #bbbcbb", "background": "white" });
                        $(this.contentPanels).css("padding-left", this.itemsContainer.width() + 5 + "px");
                        if (this.model.enableRTL)
                            this.itemsContainer.css("margin-right", (ej.getDimension(this.element, "width") - this.itemsContainer.width()));
                        if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelHeight)
                            this.itemsContainer.css("clip", "rect(0px," + (this.itemsContainer.width() + 4) + "px," + this.scrollPanelHeight + "px," + (this.scrollstep) + "px)");
                        else {
                            if (this._beforeWidth > this.scrollPanelHeight) {
                                this.itemsContainer.css({
                                    "clip": "rect(" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px," + (this.itemsContainer.width() + 2) + "px," + (this.items[this.selectedItemIndex()].offsetTop * 2 - this.scrollPanelHeight) + "px,0px)",
                                    "margin-top": "-" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px"
                                });
                            }
                        }

                        this.element.removeClass("e-scrolltab");
                    }
                }
                else if (this.model.headerPosition == "right") {
                    if (this._tabContentsHeight() > Number(this.model.height)) {
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "margin-left": "-1px" }).css("z-index", "12")
                        $(this.contentPanels).css({ "position": "absolute", "width": parseInt(this.element.width() - 1) + "px", "height": ej.getDimension(this.element, "height") + "px", "margin-left": "-" + ej.getDimension(this.element, "width") + "px", "border-right": "none" });
                        if (!this.model.enableRTL)
                            $(this.element).css("margin-left", ej.getDimension(this.element, "width") + "px");
                        this.itemsContainer.css("border-left", "1px solid #bbbcbb");
                        if (this.model.enableRTL)
                            this.itemsContainer.css("margin-right", "-" + (this.itemsContainer.width() + 1) + "px");
                        if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelHeight)
                            this.itemsContainer.css("clip", "rect(0px," + this.itemsContainer.width() + 2 + "px," + this.scrollPanelHeight + "px," + (this.scrollstep) + "px)");
                        else {
                            if (this._beforeWidth > this.scrollPanelHeight) {
                                this.itemsContainer.css({
                                    "clip": "rect(" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px," + (this.itemsContainer.width() + 2) + "px," + (this.items[this.selectedItemIndex()].offsetTop * 2 - this.scrollPanelHeight) + "px,0px)",
                                    "margin-top": "-" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px"
                                });
                            }
                        }
                        this.element.removeClass("e-scrolltab");
                    }
                }
                else {
                    if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelWidth) {
                        this.itemsContainer.css({ "clip": "rect(0px," + (this.scrollPanelWidth + this.scrollstep) + "px,100px," + (this.scrollstep) + "px)", "margin-left": "-" + this.scrollstep + "px" });
                    }
                    else {
                        if (this._beforeWidth > this.scrollPanelWidth) {
                            this.itemsContainer.css({ "clip": "rect(0px," + (this.items[this.selectedItemIndex()].offsetLeft * 2 - this.scrollPanelWidth) + "px,100px," + ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px)", "margin-left": "-" + ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px" });
                        }
                    }
                }
                this.itemsContainer.find(".e-icon.e-chevron-circle-left").length && this.itemsContainer.find(".e-icon.e-chevron-circle-left").css("display", "none");
                this._initialClip = this.itemsContainer.css("clip");
            }
        },
        _executeForwardScrolling: function (args , scrollStep) {
            this._rightScrollIcon.css("position", "relative");
			var tabScrollStep= (scrollStep) ? scrollStep :(args.type=='swiperight'||args.type=='swipeleft')? 50: 30;
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                if (!this.model.enableRTL) {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var scrollValue = Number(this._rightScrollIcon.css("margin-right").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 + tabScrollStep) + "px,100px," + (ClipValue2 + tabScrollStep) + "px)", "margin-left": "-" + (ClipValue2 + tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-right", (scrollValue - tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-left", (ClipValue2 + tabScrollStep) + "px") : "";
					if(args.type=='swipeleft' && Math.abs(Number((this.itemsContainer.css('margin-left')).split("px")[0])) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
					   this._off(this.items, "swipeleft", this._tabSwipe);
					if ((this._leftScrollIcon && this._leftScrollIcon.css("margin-left")) && (Number(this._leftScrollIcon.css("margin-left").split("px")[0]) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))) {
                        this._rightScrollIcon.css("display", "none"); 
						this._off(this.items, "swipeleft", this._tabSwipe);
                    }

                }
                else {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var itemsMargin = this.itemsContainer.css("margin-right") ? Number(this.itemsContainer.css("margin-right").split("px")[0].replace(",", "")) : 0;
                    var scrollValue = Number(this._rightScrollIcon.css("margin-left").split("px")[0]);
                    var RightScroll = this._leftScrollIcon && this._leftScrollIcon.css("margin-right") ? Number(this._leftScrollIcon.css("margin-right").split("px")[0]) : "";
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 - tabScrollStep) + "px,100px," + (ClipValue2 - tabScrollStep) + "px)", "margin-right": "-" + (-itemsMargin + tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-left", (scrollValue - tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-right", (RightScroll + tabScrollStep) + "px") : "";
					 if(args.type=='swipeleft' && Math.abs(Number((this.itemsContainer.css('margin-right')).split("px")[0])) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
					   this._off(this.items, "swipeleft", this._tabSwipe);
                    if (this._leftScrollIcon && this._leftScrollIcon.css("margin-right") && (Number(this._leftScrollIcon.css("margin-right").split("px")[0])) >= (this._tabContentsWidth() - 40))
                        this._rightScrollIcon.css("display", "none")

                }

            }
            else if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]);
                var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[2].replace(",", ""));
                var scrollValue = Number(this._rightScrollIcon.css("margin-top").split("px")[0].replace(",", ""));
                var RightTop = this._leftScrollIcon && this._leftScrollIcon.css("margin-top") ? Number(this._leftScrollIcon.css("margin-top").split("px")[0]) : 0;
                var MarginTop = this.itemsContainer.css("margin-top") ? Number(this.itemsContainer.css("margin-top").split("px")[0]) : 0;
                this.itemsContainer.css({ "clip": "rect(" + (ClipValue1 + tabScrollStep) + "px, " + (this.itemsContainer.width() + 4) + "px," + (ClipValue2 + tabScrollStep) + "px, 0px)", "margin-top": "-" + (-MarginTop + tabScrollStep) + "px" });
                this._rightScrollIcon.css("margin-top", (scrollValue + tabScrollStep) + "px");
                this._leftScrollIcon ? this._leftScrollIcon.css("margin-top", (RightTop + tabScrollStep) + "px") : "";
                if (ClipValue2 > (this._tabContentsHeight() - 20)) {
                    this.itemsContainer.css({ "clip": "rect(" + (this._tabContentsHeight() - Number(this.model.height) + 2) + "px, " + (this.itemsContainer.width() + 4) + "px, " + (this._tabContentsHeight() + 2) + "px, 0px", "margin-top": "-" + (this._tabContentsHeight() - Number(this.model.height) + 2) + "px" })
                    this._leftScrollIcon.css("margin-top", (this._tabContentsHeight() - 12) + "px")
                    this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - (this._tabContentsHeight() - Number(this.model.height)) - 22) + "px");
                    this._rightScrollIcon.css("display", "none");
                }
            }
        },
        _executeBackwardScrolling: function ( args , scrollStep ) {
            if (this._rightScrollIcon != "") this._rightScrollIcon.css("display", "block");
			var tabScrollStep= (scrollStep) ? scrollStep :(args.type=='swiperight'||args.type=='swipeleft')? 50: 30;
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                if (!this.model.enableRTL) {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var scrollValue = Number(this._rightScrollIcon.css("margin-right").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 - tabScrollStep) + "px,100px," + (ClipValue2 - tabScrollStep) + "px)", "margin-left": "-" + (ClipValue2 - tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-right", (scrollValue + tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-left", (ClipValue2 - tabScrollStep) + "px") : "";
                    if (ClipValue2 - tabScrollStep < 0) {
                        this.itemsContainer.css({ "clip": "rect(0px," + ej.getDimension(this.element, "width") + "px,100px, 0px", "margin-left": "0px" });
                        this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - ej.getDimension(this.element, "width") + 20 + "px");
                    }
					if(args.type=='swiperight' && Math.abs(Number((this.itemsContainer.css('margin-left')).split("px")[0])) <= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
						this._on(this.items, "swipeleft", this._tabSwipe);
                    if (ClipValue2 <= tabScrollStep && this._leftScrollIcon)
                        this._leftScrollIcon.css("display", "none");
                }
                else {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var itemsMargin = Number(this.itemsContainer.css("margin-right").split("px")[0]) ? Number(this.itemsContainer.css("margin-right").split("px")[0]) : 0;
                    var RightScroll = this._leftScrollIcon && this._leftScrollIcon.css("margin-right") ? Number(this._leftScrollIcon.css("margin-right").split("px")[0]) : "";
                    var scrollValue = Number(this._rightScrollIcon.css("margin-left").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 + tabScrollStep) + "px,100px," + (ClipValue2 + tabScrollStep) + "px)", "margin-right": "-" + (-itemsMargin - tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-left", (scrollValue + tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-right", (RightScroll - tabScrollStep) + "px") : "";
					if(args.type=='swiperight' && Math.abs(Number((this.itemsContainer.css('margin-right')).split("px")[0])) <= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
						this._on(this.items, "swipeleft", this._tabSwipe);
                    if (itemsMargin >= -tabScrollStep && this._leftScrollIcon) {
                        this._leftScrollIcon.css("display", "none");
                    }
                }
            }

            else if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]);
                var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[2].replace(",", ""));
                var scrollValue = Number(this._rightScrollIcon.css("margin-top").split("px")[0]);
                var RightTop = this._leftScrollIcon.css("margin-top") ? Number(this._leftScrollIcon.css("margin-top").split("px")[0]) : 0;
                var MarginTop = this.itemsContainer.css("margin-top") ? Number(this.itemsContainer.css("margin-top").split("px")[0]) : 0;
                this.itemsContainer.css({ "clip": "rect(" + (ClipValue1 - tabScrollStep) + "px, " + this.itemsContainer.width() + "px," + (ClipValue2 - tabScrollStep) + "px, 0px)", "margin-top": "-" + (-MarginTop - tabScrollStep) + "px" });
                this._rightScrollIcon.css("margin-top", (scrollValue - tabScrollStep) + "px").css("display", "block");
                this._leftScrollIcon.css("margin-top", (RightTop - tabScrollStep) + "px");
                if (Number(this.itemsContainer.css("clip").split("px")[0].split("(")[1]) <= 0) {
                    this.itemsContainer.css({ "clip": "rect( 0px, " + this.itemsContainer.width() + "px," + (Number(this.model.height)) + "px, 0px)", "margin-top": "0px" });
                    this._leftScrollIcon.css("display", "none");
                    this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - 22) + "px");
                }
            }
        },

        _removeHeaderClass: function () {
            this.itemsContainer.remove();
            this.itemsContainer.insertBefore(this.element.find(">div").first());
            this.items.removeClass("e-bottom-line e-top-line");
            $(this.contentPanels).removeClass("e-content-bottom e-activetop e-activebottom");
            this.itemsContainer.removeClass("e-header e-left e-right");
        },

        _removeVerticalClass: function () {
            this.element.removeClass("e-vertical");
            this.itemsContainer.removeClass("e-left e-right").removeAttr("style");
        },


        _removeBaseClass: function () {
            this.element.removeClass("e-tab e-widget e-corner");
            if ((this.model.headerPosition == "left" || this.model.headerPosition == "right"))
                this._removeVerticalClass();
            this.itemsContainer.removeClass("e-header e-box e-clearall e-select");
            this.anchors.removeClass("e-link");
            this.items.removeClass("e-select e-item e-active e-bottom-line e-top-line");
            $(this.contentPanels).removeClass("e-content  e-content-item e-box");
            $(this.contentPanels).removeClass("e-content  e-content-item e-box e-content-bottom e-activetop e-activebottom e-active-content");
            $(this.contentPanels).css("display", "");
        },


        _addContentTag: function (href, index) {
            var id = this._getTabId(href);
            var panel = this.element.find("#" + id);
            if (!panel.length) {
                panel = ej.buildTag("div.e-content  e-content-item e-box e-content-bottom #" + id)
                    .insertAfter(this.contentPanels[index - 1] || this.itemsContainer);
            }
            this.contentPanels.splice(index, 0, panel[0]);
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
            }
            else if (this.element.hasClass('e-corner')) {
                this.element.removeClass('e-corner');
            }
        },


        _setTabsHeightStyle: function (heightFormat) {
            if (ej.Tab.HeightAdjustMode.Content != heightFormat) $(this.contentPanels).height("");
            if (ej.Tab.HeightAdjustMode.Fill == heightFormat) {
                if (ej.Tab.Position.Left === this.model.headerPosition || ej.Tab.Position.Right === this.model.headerPosition) {
                    $(this.contentPanels).css("height", "100vh");
                }
                this._contentPaneSize();
            }
            else if (ej.Tab.HeightAdjustMode.Auto == heightFormat) {
                var maxHeight = 0;
                $(this.contentPanels).css({ "display": "none" }).addClass('e-active-content');
                for (var i = 0; i < this.contentPanels.length; i++) {
                    maxHeight = Math.max(maxHeight, this._getDimension($(this.contentPanels[i]), "outerHeight"));
                }
                $(this.contentPanels).removeClass('e-active-content');
                $(this.contentPanels).height(maxHeight);
                this.maxAutoHeight = maxHeight;
                this.showItem(this.selectedItemIndex());
            }
            else if (ej.Tab.HeightAdjustMode.None == heightFormat) {
                if (this.model.height != null) {
                    this._contentPaneSize();
                }
            }
            if (ej.Tab.HeightAdjustMode.Fill !== heightFormat) $(this.itemsContainer).height("");
            if (ej.Tab.HeightAdjustMode.Content == heightFormat)
                $(this.contentPanels).height("auto");

            if (this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                $(this.contentPanels).css("height", this.model.height + "px");
            }

        },
        _getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().addBack().filter(':hidden');
            var prop = { visibility: 'hidden', display: 'block' };
            var hiddenCollection = [];
            $hidden.each(function () {
                var hidden = {}, name;
                for (name in prop) {
                    hidden[name] = this.style[name];
                    this.style[name] = prop[name];
                }
                hiddenCollection.push(hidden);
            });
            value = /(outer)/g.test(method) ?
            $(element)[method](true) :
           $(element)[method]();

            $hidden.each(function (i) {
                var hidden = hiddenCollection[i], name;
                for (name in prop) {
                    this.style[name] = hidden[name];
                }
            });
            return value;
        },
        // Tab to active given index value
        showItem: function (index) {
            if ($.inArray(index, this.model.disabledItemIndex) < 0) {
                var proxy = this;
                if (this._isInteraction != false) this._isInteraction = true;
                this._preTabSelectedIndex = this.selectedItemIndex();
                this.selectedItemIndex(index);
                if (this.selectedItemIndex() >= this.contentPanels.length) {
                    this.selectedItemIndex(0);
                    index = this.selectedItemIndex();
                }
                if (index >= 0 && !this.initialRender && true === this._onBeforeActive(index)){
                    this.selectedItemIndex(this._preTabSelectedIndex);
                    return false;
                } 
                else this._preTabIndex = this._preTabSelectedIndex;
                $(this.items[this.selectedItemIndex()]).attr("aria-expanded", true).attr("aria-selected", true).attr("tabindex", 0);
                if (this.selectedItemIndex() != null && this.selectedItemIndex() < this.contentPanels.length) {
                    this._ajaxLoad();
                    this.hideItem(this._preTabIndex);
                    $(this.contentPanels[this.selectedItemIndex()]).fadeIn(this.model.enableAnimation ? 20 : 0, function () {
                        if (!proxy.initialRender && proxy._onActive())
                            return true;
                        proxy.initialRender = false;
                    });
                    if (!(this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                        var activeClass = this.model.headerPosition == ej.Tab.Position.Top ? "e-activetop" : "e-activebottom";
                        $(this.contentPanels[this.selectedItemIndex()]).addClass(activeClass)
                    }
                    else
                        $(this.contentPanels[this.selectedItemIndex()]).addClass("e-active-content ");
                    $(this.items[this.selectedItemIndex()]).addClass("e-active").removeClass("e-select");
                    $(this.items[this.selectedItemIndex()]).removeClass("e-margine-top e-margine-bottom");

                    for (var i = 0; i <= $(this.items).length; i++) {
                        if ($(this.items[i]).hasClass("e-select")) {
                            if (this.model.headerPosition == "right") {
                                $(this.items[i]).removeClass("e-margine-top e-margine-bottom");
                            }
                            if (this.model.headerPosition == "left") {
                                $(this.items[i]).removeClass("e-margine-top e-margine-bottom");
                            }
                            if (this.model.headerPosition == "top") {
                                if (!this.element.hasClass("e-tab-collapsed"))
                                    $(this.items[i]).addClass("e-margine-top");
                                else
                                    $(this.items[i]).removeClass("e-margine-top");
                                $(this.items[i]).removeClass("e-margine-bottom");
                            }
                            if (this.model.headerPosition == "bottom") {
                                $(this.items[i]).removeClass("e-margine-top");
                                $(this.items[i]).addClass("e-margine-bottom");
                            }
                        }
                    }
                    $(this.contentPanels[this.selectedItemIndex()]).addClass("e-active-content").removeAttr("aria-hidden", false);
                }
            }
            if (this.model.enableTabScroll && this._tabContentsWidth() > (this.model.width || this.element.width()) && this.itemsContainer.find("li").length && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                if (!this.model.enableRTL) {
                    var itemPosition = Number(this.itemsContainer.find("li.e-active").position().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() - ej.getDimension(this.element, "width");
                    if ((itemPosition > 0) && (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() > ej.getDimension(this.element, "width") || (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) - this.itemsContainer.find("li.e-active").width() < 0))) {
                        this.itemsContainer.css("clip", "rect(0 ," + (ej.getDimension(this.element, "width") + (itemPosition + 10)) + "px, 100px," + (itemPosition + 10) + "px)").css("margin-left", "-" + (itemPosition + 10) + "px")
                        this._rightScrollIcon ? this._rightScrollIcon.css("margin-right", (this.itemsContainer.width() - ej.getDimension(this.element, "width") + 10 - itemPosition) + "px").css("display", "block") : "";
                        this._addScrollBackIcon();
                        this._leftScrollIcon ? this._leftScrollIcon.css("display", "block").css("margin-left", (itemPosition + 10) + "px") : "";
                    }
                    else if ((itemPosition < 0) && (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() > ej.getDimension(this.element, "width") || (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) - this.itemsContainer.find("li.e-active").width() < 0))) {
                        this.itemsContainer.css("clip", "rect(0 ," + (ej.getDimension(this.element, "width")) + "px, 100px, 0px)").css("margin-left", "0px")
                        this._rightScrollIcon ? this._rightScrollIcon.css("margin-right", (this.itemsContainer.width() - ej.getDimension(this.element, "width") + 20) + "px").css("display", "block") : "";
                        this._leftScrollIcon ? this._leftScrollIcon.css('display', 'none') : "";
                    }
                }
            }
            else if (this.model.enableTabScroll && this.model.height && (this.model.headerPosition == "left" || this.model.headerPosition == "right") && !this.model.enableRTL) {
                var itemPosition = Number(this.itemsContainer.find("li.e-active").position().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() - Number(this.model.height);
                if ((itemPosition > 0) && (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() > Number(this.model.height) || (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) - this.itemsContainer.find("li.e-active").height() < 0))) {
                    this.itemsContainer.css("clip", "rect(" + itemPosition + "px," + (this.itemsContainer.outerWidth() + 2) + "px, " + (Number(this.model.height) + itemPosition) + "px, 0px").css("margin-top", "-" + itemPosition + "px");
                    this._rightScrollIcon ? this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - itemPosition - 22) + "px").css("display", "block") : "";
                    this._addScrollBackIcon();
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-top", Number(this.model.height) + itemPosition - 10 + "px").css("display", "block") : "";
                }
                else if ((itemPosition < 0) && (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() > Number(this.model.height) || (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) - this.itemsContainer.find("li.e-active").height() < 0))) {
                    this.itemsContainer.css("clip", "rect(0px ," + (this.itemsContainer.outerWidth() + 2) + "px, " + Number(this.model.height) + "px, 0px").css("margin-top", "0px")
                    this._rightScrollIcon ? this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - 22) + "px").css("display", "block") : "";
                    this._leftScrollIcon ? this._leftScrollIcon.css('display', 'none').css("margin-top", (Number(this.model.height) - 10) + "px") : "";
                }
            }

        },

        hideItem: function (index) {
            $(this.contentPanels[index]).fadeOut(0);
            if (!(this.model.headerPosition == "left" || this.model.headerPosition == "right"))
                var activeClass = this.model.headerPosition == ej.Tab.Position.Top ? "e-activetop" : "e-activebottom";
            $(this.items[index]).removeClass("e-active").addClass("e-select");
            $(this.contentPanels[index]).removeClass("e-active-content " + activeClass).attr("aria-hidden", true);
        },


        _ajaxLoad: function () {
            var content = $(this.contentPanels[this.selectedItemIndex()]);
            var link = this.anchors[this.selectedItemIndex()];
            var href = $(link).attr("href");
            if (content.is(':empty') && href.indexOf("#") !== 0)
                this._sendAjaxOptions(content, link);
        },


        _getTabId: function (href) {
            return !href.indexOf("#") ? href.replace("#", "") : this.model.idPrefix + this._getNextTabId();
        },

        _getNextTabId: function () {
            return ++this.tabId;
        },


        _disableTabs: function () {
            for (var i = 0, li; (li = this.items[i]) ; i++) {
                if ($.inArray(i, this.model.disabledItemIndex) > -1) {
                    $(li).find("a").off(this.model.events);
                    $(li).find("div.e-close").off("click");
                }
                $(li)[$.inArray(i, this.model.disabledItemIndex) != -1 &&
                    !$(li).hasClass("e-tab-selected") ? "addClass" : "removeClass"]("e-disable");
                $(this.contentPanels[i])[$.inArray(i, this.model.disabledItemIndex) != -1 &&
                    !$(this.contentPanels[i]).hasClass("e-tab-selected") ? "addClass" : "removeClass"]("e-disable");
            }
        },


        _tabItemClick: function (args) {

            if (this.model.enabled) {
                args.preventDefault(); // Prevent the ancher tag url action
                var index;
                if (this.selectedItemIndex() == $(this.items).index($(args.currentTarget)) && this.model.collapsible) {
                    index = -1; $(this.element).addClass("e-tab-collapsed");
                }
                else {
                    index = $(this.items).index($(args.currentTarget));
                }
                if (index != this.selectedItemIndex())
                    this.showItem(index);
                $(this.element).removeClass("e-tab-collapsed");
            }
        },

        _tabDeleteClick: function (args) {
            if (this.model.enabled) {
                var currentTab = $(args.target);
                var tabWidth = $(args.target).parent().width();
                if (currentTab.hasClass("e-close"))
                    var index = $(this.items).index($(args.target).parent());
                if (index == this.selectedItemIndex() && this.items.length > index)
                    this.selectedItemIndex(this.selectedItemIndex() + 1)
                var itemsMargin = Number(this.itemsContainer.css("margin-right").split("px")[0]) ? Number(this.itemsContainer.css("margin-right").split("px")[0]) : 0;
                if(this.model.enableTabScroll && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                     if(!this.model.enableRTL || (this.model.enableRTL && itemsMargin < -tabWidth )) this._executeBackwardScrolling(args,tabWidth);
                     else {
                         this.itemsContainer.css({"margin-right":"0px","clip":this._initialClip});
                         this._leftScrollIcon && this._leftScrollIcon.css("display", "none");
                         this._rightScrollIcon && this._rightScrollIcon.css("display", "none");
                     }	 
                }
                this.removeItem(index);
            }
        },
        _tabScrollClick: function (args) {
            if (this.model.enabled) {
                if ((this._rightScrollIcon[0] == args.target)) {
                    this._executeForwardScrolling(args);

                    this._addScrollBackIcon();
                    this._leftScrollIcon.css("display", "block");
                }
            }
        },
		
		_tabSwipe: function(e){ 
			 if(e.type=='swipeleft')  
			this._executeForwardScrolling(e);
			else 
			this._executeBackwardScrolling(e);
		},
        _tabScrollBackClick: function (args) { 
            if (this.model.enabled) {
                if ((this._leftScrollIcon[0] == args.target)) {
                    this._executeBackwardScrolling(args);
                }
            }
        },

        _tabReloadClick: function (args) {
            if (this.model.enabled) {
                var currentTab = $(args.target);
                if (currentTab.hasClass("e-reload")) {
                    var link = this.anchors[this.selectedItemIndex()];
                    var href = $(link).attr("href");
                    var content = $(this.contentPanels[this.selectedItemIndex()]);
                    if (href.indexOf("#") !== 0)
                        this._sendAjaxOptions(content, link);
                    else
                        this.showItem(this.selectedItemIndex());
                }
            }
        },


        _sendAjaxOptions: function (content, link) {
            //load waiting popup
            if (this._onBeforeLoad(link))
                return true;
            content.addClass("e-load");
            var proxy = this;
            var curTabTitle = $(link).html();
            var hrefLink = link.href.replace("#", "");
            var ajaxOptions = {
                type: this.model.ajaxSettings.type, cache: this.model.ajaxSettings.cache, url: hrefLink, data: this.model.ajaxSettings.data,
                dataType: this.model.ajaxSettings.dataType, contentType: this.model.ajaxSettings.contentType, async: this.model.ajaxSettings.async,
                "success": function (data) {
                    try {
                        proxy._ajaxSuccessHandler(data, content, link, curTabTitle);
                    } catch (e) {

                    }
                }, "error": function () {
                    try {
                        proxy._ajaxErrorHandler(link, proxy.selectedItemIndex(), curTabTitle);
                    } catch (e) {

                    }
                }
            };
            this._sendAjaxRequest(ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },


        _ajaxSuccessHandler: function (data, content, link, curTabTitle) {
            if (curTabTitle != null)
                $(link).html(curTabTitle);
            content.removeClass("e-load");
            content.html(data).addClass("e-tab-loaded"); //to indicate the content is already loaded
            var eventData = { data: data, url: link, content: content };
            this._trigger("ajaxSuccess", eventData);
            if (this._onLoad(link))
                return true;
        },


        _ajaxErrorHandler: function (data, link, index, title) {
            this._trigger("ajaxError", { data: data, url: link });
            this._onLoad(link);
        },

        _createContentPanel: function (id) {
            return $('<div></div>')
				.attr("id", id)
				.addClass("e-content  e-content-item e-content-bottom e-box");
        },


        _refresh: function () {
            this._unWireEvents();
            this.itemsContainer.removeAttr("style class");
            $(this.contentPanels).removeAttr("style class");
            this.element.css("margin-left", "");
            this._removeVerticalClass();
            this._removeHeaderClass();
            this._initialize();
        },

        _keyPress: function (e) {
            if (this.model.enabled) {
                var index, currentEle, targetEle = $(e.target);
                if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
                else if (e.which) code = e.which; // ns4 and opera
                else code = e.charCode;
                if (targetEle.hasClass("e-link") || targetEle.hasClass("e-item")) {
                    switch (code) {
                        case 39:
                        case 40:
                            {
                                e.preventDefault();
                                this.showItem(this.selectedItemIndex() + 1);
                                break;
                            }
                        case 37:
                        case 38:
                            {
                                e.preventDefault();
                                if (this.selectedItemIndex() != 0)
                                    this.showItem(this.selectedItemIndex() - 1);
                                else if (this.selectedItemIndex() == 0)
                                    this.showItem(this.getItemsCount() - 1);
                                break;
                            }
                        case 35:
                            {
                                e.preventDefault();
                                this.showItem(this.getItemsCount() - 1);
                                break;
                            }
                        case 36:
                            {
                                e.preventDefault();
                                this.showItem(0);
                                break;
                            }
                        case 13:
                            {
                                e.preventDefault();
                                this.showItem(this.selectedItemIndex());
                                break;
                            }
                    }
                }
                else if (e.ctrlKey && !targetEle.hasClass("e-tab")) {
                    switch (code) {
                        case 38:
                            e.preventDefault();
                            index = $(this.contentPanels).index(targetEle.parent(".e-content"));
                            currentEle = $(this.items[index]);
                            break;
                        case 33:
                            e.preventDefault();
                            currentEle = $(this.items[0]);
                            this.showItem(0);
                            break;
                        case 34:
                            e.preventDefault();
                            currentEle = $(this._headers[this.getItemsCount() - 1]);
                            this.showItem(this.getItemsCount() - 1);
                            break;
                    }
                }
                if (!ej.isNullOrUndefined(currentEle)) {
                    currentEle.addClass("e-focus");
                    currentEle.focus();
                }
            }
        },

        _hoverHandler: function (args) {
            args.preventDefault();
            if (this.model.enabled) {
                var index = $(this.items).index($(args.target).parent());
                if (index == -1)
                    index = $(this.items).index($(args.target));
				if(!$(this.items[index]).hasClass("e-disable")){
                args.type === "mouseout" ? $(this.element.find("div.e-tabdelete")[index]).css("visibility", "hidden") : $(this.element.find("div.e-tabdelete")[index]).css("visibility", "visible");
				args.type === "mouseout" ? $(this.element.find("div.e-reload")[index]).css("visibility", "hidden") : $(this.element.find("div.e-reload")[index]).css("visibility", "visible");
				}
                args.type === "mouseout" ? $(this.element.find("div.e-chevron-circle-right")).css("visibility", "hidden") : $(this.element.find("div.e-chevron-circle-right")).css("visibility", "visible");
                args.type === "mouseout" ? $(this.element.find("div.e-chevron-circle-left")).css("visibility", "hidden") : $(this.element.find("div.e-chevron-circle-left")).css("visibility", "visible");
            }
        },


        _wireEvents: function (event) {
            this._on(this.items, event, this._tabItemClick);
            this._on(this.itemsContainer, "mouseover", this._hoverHandler);
            this._on(this.itemsContainer, "mouseout", this._hoverHandler);
            this._on(this.element.find(">ul").eq(0).find(">li div.e-close"), "click", this._tabDeleteClick);
            this._on(this.element.find(">ul").eq(0).find("div.e-chevron-circle-left"), "click", this._tabScrollBackClick);
			if (this.model.enableTabScroll)this._on(this.items, "swipeleft swiperight", this._tabSwipe);
            this._on(this.itemsContainer, "focusin", this._focusIn);
            this._on(this.itemsContainer, "focusout", this._focusOut);
            $(window).on('resize', $.proxy(this._resize, this));
            this._on(this.element.find(">ul").eq(0).find(">li div.e-reload"), "click", this._tabReloadClick);
        },
        _resize: function () {
            if (this.model && this.model.width == null && this.model.enableTabScroll && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                this._removeScroll()
                this._addScroll()
            }
        },


        _unWireEvents: function () {
            this._off(this.items, this.model.events);
            this._off(this.element.find(">ul").eq(0).find(">li div.e-close"), "click");
            this._off(this.element.find(">ul").eq(0).find("div.e-chevron-circle-right"), "click");
            this._off(this.element.find(">ul").eq(0).find("div.e-chevron-circle-left"), "click");
			if (this.model.enableTabScroll)this._off(this.items, "swipeleft swiperight", this._tabSwipe);
            this._off(this.itemsContainer, "mouseover", this._hoverHandler);
            this._off(this.itemsContainer, "mouseout", this._hoverHandler);
            this._off(this.itemsContainer, "focusin", this._focusIn);
            this._off(this.itemsContainer, "focusout", this._focusOut);
            this._off(this.element.find(">ul").eq(0).find(">li div.e-reload"), "click");
            this._resizeEvents();
        },
        _resizeEvents: function (value) {
            if (value === "fill") $(window).on('resize', $.proxy(this._windowResized, this));
            else $(window).off('resize', $.proxy(this._windowResized, this));
        },


        _windowResized: function (e) {
            var maxHeight = this._getDimension($(this.element).parent(), "height");
            if (this._prevSize == maxHeight) return;
            else this._contentPaneSize();
            this._prevSize = maxHeight;
            if (!this.model.width && this.model.enableTabScroll)
                this._addScroll();
        },
        _contentPaneSize: function () {
            if (this.model.height != null && this.model.heightAdjustMode == "none") {
                $(this.element).height(this.model.height);
                var maxHeight = this._getDimension($(this.element), "height");
            }
            else var maxHeight = this._getDimension($(this.element).parent(), "height");
            $(this.contentPanels).height("");
            $(this.element).parent().css({ "overflow": "auto" });
            if (this.model.headerPosition === "top" || this.model.headerPosition === "bottom")
                maxHeight -= this._getDimension($(this.itemsContainer), "outerHeight");
            var maxPadding = 0;
            for (var i = 0; i < this.contentPanels.length; i++) {
                if ($(this.contentPanels[i]).hasClass("e-active-content")) {
                    padding = Math.max(maxPadding, this._getDimension($(this.contentPanels[i]), "outerHeight") - this._getDimension($(this.contentPanels[i]), "height"));
                    if (this.model.height != null && this.model.heightAdjustMode == "none") $(this.contentPanels[i]).outerHeight(maxHeight).css({ "overflow": "auto" })
                    else $(this.contentPanels[i]).height(maxHeight - padding).css({ "overflow": "auto" });
                } else {
                    maxPadding = Math.max(maxPadding, this._getDimension($(this.contentPanels[i]), "outerHeight") - this._getDimension($(this.contentPanels[i]), "height"));
                    if (this.model.height != null && this.model.heightAdjustMode == "none") $(this.contentPanels[i]).outerHeight(maxHeight).css({ "overflow": "auto" })
                    else $(this.contentPanels[i]).height(maxHeight - maxPadding).css({ "overflow": "auto" });
                }
            }
        },
        _disableItems: function (indexes) {
            if (!this.model.enabled) return false;
            if (indexes != null) {
                for (var i = 0; i < indexes.length; i++) {
                    if ($.inArray(indexes[i], this.model.disabledItemIndex) == -1)
                        this.model.disabledItemIndex.push(indexes[i]);
                }
                this.model.disabledItemIndex.sort();
                this._disableTabs();
            }
        },

        _enableItems: function (indexes) {
            if (!this.model.enabled) return false;
            for (var i = 0; i < indexes.length; i++) {
                var index = indexes[i];
                this.model.disabledItemIndex = $.grep(this.model.disabledItemIndex, function (n, i) {
                    return n != index;
                });
            }
            this._disableTabs();
        },


        disable: function () {
            var indexes = [];
            for (var index = 0; index < this.getItemsCount() ; index++) {
                indexes.push(index);
            }
            this._disableItems(indexes);
            this.model.enabledItemIndex = [];
            this._unWireEvents();
        },

        enable: function () {
            var indexes = [];
            for (var index = 0; index < this.getItemsCount() ; index++) {
                if ($.inArray(index, this.model.enabledItemIndex) < 0) {
                    this.model.enabledItemIndex.push(index);
                    indexes.push(index);
                }
                this._enableItems(index);
            }
            this.model.disabledItemIndex = [];
        },

        getItemsCount: function () {
            if (this.items) {
                return this.items.length;
            }
        },

        addItem: function (url, displayLabel, index, cssClass, id) {
            (index >= 0 && index < this.items.length) ? this._addItemIndex = index : this._addItemIndex = this.items.length;
            for (var disable_index = 0; disable_index < this.model.disabledItemIndex.length; disable_index++) {
                if (this.model.disabledItemIndex[disable_index] >= index)
                    this.model.disabledItemIndex[disable_index]++;
            }
            if (this.model.headerPosition == "left") {
                this.items.length >= 0 && this.itemsContainer.addClass("e-left");
            }
            else if (this.model.headerPosition == "right") {
                this.items.length >= 0 && this.itemsContainer.addClass("e-right");
            }
            else
                this.items.length == 0 && this.itemsContainer.addClass("e-header");
            var liTag = ej.buildTag("li.e-select e-item");
            if ((this.model.headerPosition == "top"))
                if (this.model.enableRTL)
                    $(liTag).addClass("e-rtl-top-line e-top-hover");
                else
                    $(liTag).addClass("e-bottom-line");
            if (!ej.isNullOrUndefined(cssClass)) {
                var span = ej.buildTag('span').addClass(cssClass);
                liTag.append(span);
            }
            if (index === undefined && displayLabel === undefined && url != null)
                displayLabel = "Item";
            if (index === undefined && displayLabel === undefined && id === undefined) {
                url = "#Item" + this.items.length;
                displayLabel = "Item"
            }
            if (id != undefined) {
                if (id.indexOf("#") != 0)
                    id = "#" + id;
                this.divId = id;
            }
            else if (url != undefined)
                id = url;
            var aTag = ej.buildTag("a", displayLabel, {}, { href: url });
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")
                aTag.appendTo(liTag);
            if (this.model.showCloseButton) {
                var deleteIcon = ej.buildTag('div.e-icon e-close e-tabdelete', "", {}, {}).css("visibility", "hidden");
                liTag.append(deleteIcon);
                this._on(deleteIcon, "click", this._tabDeleteClick);
            }
            if (this.model.headerPosition == "left" || this.model.headerPosition == "right")
                aTag.appendTo(liTag);
            if (index === undefined) {
                index = this.anchors.length;
            }
            var insertIndex = index >= this.items.length;
            if (insertIndex) {
                liTag.appendTo(this.itemsContainer);
            } else {
                liTag.insertBefore(this.items[index]);
            }
            if (!ej.isNullOrUndefined(this.model.headerSize))
                this._setHeaderSize(this.model.headerSize);
            if (this.selectedItemIndex() == index) {
                this.hideItem[index];
                this.selectedItemIndex(this.selectedItemIndex() + 1);
            } else {
                this.hideItem[index];
                if (index < this.selectedItemIndex())
                    this.selectedItemIndex(this.selectedItemIndex() + 1);
            }
            this._itemsRefreshing();
            this._reinitialize(true);
            if (this.model.headerPosition == "top")
                $(this.contentPanels[index]).addClass("e-hidebottom");
            if (this.model.headerPosition == "bottom") {
                $(this.contentPanels[index]).addClass("e-hidetop");
                liTag.addClass("e-top-line e-item e-select e-margine-bottom")
            }
            if (this.model.headerPosition == "left")
                $(this.contentPanels[index]).addClass("e-hideleft");
            if (this.model.headerPosition == "right")
                $(this.contentPanels[index]).addClass("e-hideright");
            var data = {
                tabHeader: this.anchors[index],
                tabContent: this.contentPanels[index]
            };
            this.refreshTabScroll();
            this._addItemIndex = null;
            this._onAdd(data);
            if (this.model.showReloadIcon) {
                var reloadIcon = ej.buildTag('div.e-icon e-reload', "", {}, { role: "presentation" }).css("visibility", "hidden");
                $(this.element.find("li")[index]).append(reloadIcon)
            }
            if (this.model.enableTabScroll && this.model.headerPosition == "right") {
                $(this.contentPanels).css("height", this.model.height + "px");
            }

        },

        _isSizeExceeded: function () {
            var eleWidth = this.element.width(), itemsWidth = 0;
            var tabcount = this.items.length;
            for (var tabVal = 0; tabVal < tabcount; tabVal++) {
                var tabWidth = $(this.items[tabVal]).width();
                itemsWidth += tabWidth;
            }
            return (itemsWidth > eleWidth ? true : false);
        },

        refreshTabScroll: function () {
            if (this._isSizeExceeded()) {
                this.element.find("div.e-chevron-circle-right").length >= 1 && this.element.find("div.e-chevron-circle-right").remove();
                if (this.model.enableTabScroll) {
                    this._checkScroll();
                    this._addScrollIcon();
                }
            }
            else {
                if ((this.model.headerPosition == "left" || this.model.headerPosition == "right" && this._tabContentsHeight() > (this.element.width() || Number(this.model.height))) || (this.model.headerPosition == "top" || this.model.headerPosition == "bottom"))
                    this._checkScroll();
            }
        },

        removeItem: function (index) {
            if (!this.model.enabled) return false;
            if (index != null && index > -1 && index < this.items.length) {
                if (this._onBrforeRemove({ index: index }) === true)
                    return false;
                var removedTab = $(this.items[index]).remove();
                this.model.disabledItemIndex = [];
                if (removedTab.hasClass("e-active")) {
                    index == 0 ? this.selectedItemIndex(index + 1) : this.selectedItemIndex(index - 1);
                    this.showItem(this.selectedItemIndex());
                }
                $(this.element.find(">div.e-content")[index]).remove();
                this.contentPanels.splice(index, 1);
                index < this.selectedItemIndex() ? this.selectedItemIndex(this.selectedItemIndex() - 1) : this.selectedItemIndex();

                if (index < 0 || index >= this.anchors.length) {
                    this.selectedItemIndex(0);
                }
                if ((this.model.headerPosition == "left" || this.model.headerPosition == "right") && this.items.length == 1)
                    this._removeVerticalClass();
                else
                    this.items.length == 1 && this.itemsContainer.removeClass("e-header");
                this._unWireEvents();
                this._itemsRefreshing();
                this._wireEvents(this.model.events);
                if (this.model.enableTabScroll)
                    this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                for (indx = 0; indx < this.items.length; indx++)
                    if ($(this.items[indx]).hasClass('e-disable'))
                        this.model.disabledItemIndex.push(indx);
                this._disableTabs();
                var data = {
                    removedTab: removedTab
                };
                this._onRemove(data);
            }
            if (this.getItemsCount() == 0) {
                this.itemsContainer.removeAttr("style")
                this.itemsContainer.find("div").remove()
            }
            if (this._tabContentsHeight() < Number(this.model.height) && this.itemsContainer.css("clip").split("px").length && this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                this._refresh();
                this.itemsContainer.removeAttr("style");
                this._leftScrollIcon ? this._leftScrollIcon.remove() : "";
                this._rightScrollIcon ? this._rightScrollIcon.remove() : "";
            }
            else if (this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                if (this._leftScrollIcon && Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]) != -(Number(this._leftScrollIcon.css("margin-top").split("px")[0]))) {
                    this._removeScroll();
                    this._addScroll();
                } else
                    this.refreshTabScroll();
                this.showItem(this.selectedItemIndex())
            }

        },

        show: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "visible");
        },

        hide: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "hidden");
        },

        _onBeforeLoad: function (link) {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, url: link, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), url: link, isInteraction: this._isInteraction };
            return this._trigger("ajaxBeforeLoad", data);
        },

        _focusIn: function () {
            if (!this.model.readOnly && this.model.allowKeyboardNavigation)
                $(this.element).on("keydown", $.proxy(this._keyPress, this));
        },

        _focusOut: function (e) {
            $(this.element).off("keydown", $.proxy(this._keyPress, this));
        },

        _onLoad: function (link) {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, url: link, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), url: link, isInteraction: this._isInteraction };
            return this._trigger("ajaxLoad", data);
        },

        _onActive: function () {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), isInteraction: this._isInteraction };
            this._isInteraction = true;
            return this._trigger("itemActive", data);

        },

        _onBeforeActive: function (index) {
            if (this.model.beforeActive != null) {
                var data;
                if (this.selectedItemIndex() == -1 && this.model.collapsible)
                    data = { prevActiveHeader: this.items[this._preTabSelectedIndex], prevActiveIndex: this._preTabSelectedIndex, activeHeader: null, activeIndex: null, isInteraction: this._isInteraction };
                else
                    data = { prevActiveHeader: this.items[this._preTabSelectedIndex], prevActiveIndex: this._preTabSelectedIndex, activeHeader: this.items[index], activeIndex: index, isInteraction: this._isInteraction };
                return this._trigger("beforeActive", data);
            }
        },

        _onAdd: function (data) {
            return this._trigger("itemAdd", data);
        },

        _onRemove: function (data) {
            return this._trigger("itemRemove", data);
        },

        _onBrforeRemove: function (data) {
            return this._trigger("beforeItemRemove", data);
        }
    });

    ej.Tab.HeightAdjustMode = {
        /**  Panel height adjusts based on the content */
        Content: "content",
        /**  All panel height will be set the tallest panel height. */
        Auto: "auto",
        /**  Content panel take based on the parent height. */
        Fill: "fill",
        /**  Content panel take based on the height property. */
        None: "none"
    };

    ej.Tab.Position = {
        /**  Tab headers display to top position. */
        Top: "top",
        /**  Tab headers display to bottom position. */
        Bottom: "bottom",
        /**  Tab headers display to left position. */
        Left: "left",
        /** Tab headers display to right position. */
        Right: "right"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the tagCloud control.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    
    ej.widget("ejTagCloud", "ej.TagCloud", {
        
        element: null,
        
        model: null,
        validTags: ["div", "span"],
        _rootCSS: "e-tagcloud",
        _setFirst: false,
        
        defaults: {
            
            cssClass : "",
			
            htmlAttributes : {},
            
            dataSource: null,
            
            query: null,
            
            fields:  { 
				
			    text: "text", 
				
			    url: "url", 
				
			    frequency: "frequency",
                
			    htmlAttributes: "htmlAttributes"
			},
            
            showTitle: true,
            
            titleText: "Title",
            
            titleImage: null,
            
            format: "cloud",
            
            enableRTL: false,
            
            minFontSize: "10px",
            
            maxFontSize: "40px",
                        
            mouseover: null,
            
            mouseout: null,
            
            click: null,
            
            create: null,
            
            destroy: null
        },
        
        dataTypes: {
            cssClass : "string",
            showTitle: "boolean",
            titleText: "string",
            titleImage: "string",
            format: "enum",
            enableRTL: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            htmlAttributes: "data"
        },

        
        
        _init: function () {
            this._initialize();
            this._render();
        },
        
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "fields":
                    case "query":
                    case "dataSource":
                    case "minFontSize":
                    case "maxFontSize":
                        this._refreshTagItems(option, options[option]); break;
                    case "showTitle": this._showTitle(options[option]); break;
                    case "titleText": this._title(options[option]); break;
                    case "titleImage": this._titleImage(options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "format": this._format(options[option]); break;
                    case "enableRTL": this._rtl(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },

        _refreshTagItems: function (key, value) {
            this.model[key] = value;
            this.ul.empty();
            this._checkDataBinding();
        },
        
        _showTitle: function (boolean) {
            if (boolean) {
                this._generateTitle();
                this.ul.removeClass("e-notitle");
            }
            else {
                this.titleText.remove();
                this.ul.addClass("e-notitle");
                this.titleText = null;
            }
        },
        
        _title: function (text) {
            if (this.titleText) {
                if (text) {
                    if (this.text) this.text.html(text);
                    else this._generateTextTag(text);
                }
                else if (this.text) {
                    this.text.remove();
                    this.text = null;
                }
            }
        },
        
        _titleImage: function (imagePath) {
            if (this.titleText) {
                if (imagePath) {
                    if (this.image) this.image.attr("src", imagePath);
                    else this._generateImageTag(imagePath);
                }
                else if (this.image) {
                    this.image.remove();
                    this.image = null;
                }
            }
        },
        
        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
            }
        },
        
        insert: function (tag) {
            if ($.trim(tag.text)) {
                this.ul.append(this._generateLi(tag, this._getMapper()));
            }
        },
        
        insertAt: function (tag, position) {
            if ($.trim(tag.text)) {
                $(this.ul.children()[position - 1]).before(this._generateLi(tag, this._getMapper()));
            }
        },
        
        remove: function (txt) {
            var li = this.ul.children(), liTag, i;
            for (i = 0; i < li.length; i++) {
                liTag = $(li[i]);
                if (liTag.children()[0].innerHTML == txt)
                    liTag.remove();
            }
        },
        
        removeAt: function (position) {
            var li = this.ul.children();
            $(li[position - 1]).remove();
        },
        
        _format: function (format) {
            if (format == "cloud") {
                this.ul.removeClass("e-list");
                this.ul.addClass("e-cloud");
            }
            else if (format == "list") {
                this.ul.removeClass("e-cloud");
                this.ul.addClass("e-list");
            }
        },
        
        _destroy: function () {
            this.element.removeClass("e-widget " + this.model.cssClass);
            this.element.empty();
        },
        
        _initialize: function () {
            this.minFreq = 0;
            this.maxFreq = 30;
            this.ul = null;
            this.titleText = null;
            this.image = null;
            this.text = null;
        },
        
        _render: function () {
            this.element.addClass("e-widget " + this.model.cssClass);
            if (this.model.showTitle) this._generateTitle();
            this._renderWrapper();
            this._checkDataBinding();
			this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
        },
        
        _generateTitle: function () {
            this.titleText = ej.buildTag("div.e-header e-title");
            if (this.model.titleImage)
                this._generateImageTag(this.model.titleImage);
            if (this.model.titleText)
                this._generateTextTag(this.model.titleText);
            if (this.ul) this.titleText.insertBefore(this.ul);
            else this.element.append(this.titleText);
        },
        
        _generateImageTag: function (titleImage) {	
			if(!this.image)
				this.image = $('<img class="e-title-img" src="' + titleImage + '" />');
			if(this.text && !this.model.titleImage) this.image.insertBefore(this.text);			
			else this.titleText.append(this.image);
        },		
        
        _generateTextTag: function (titleText) { 
			if(!this.text) this.text = ej.buildTag("span", titleText);					
			this.titleText.append(this.text);
        },		
        
        _renderWrapper: function () {
            var format;
            format = (this.model.format == "list") ? "list" : "cloud";
            this.ul = ej.buildTag("ul.e-ul e-box e-" + format);
            this.element.append(this.ul);
            if (!this.model.showTitle) this.ul.addClass("e-notitle");
        },
        
        _renderItems: function (list) {
            this._generateTagItems(list);
            this.ul.removeClass("e-load");
        },
		_addAttr: function (htmlAttr) {
			var proxy = this;
			$.map(htmlAttr, function(value, key) {
				if (key == "class") proxy.element.addClass(value);
				else proxy.element.attr(key,value)
			});
		},

        _checkProperties: function () {
            if (this.model.enableRTL) this._rtl(this.model.enableRTL);
        },
        
        _rtl: function (boolean) {
            if (boolean) this.element.addClass("e-rtl");
            else this.element.removeClass("e-rtl");
        },
        
        _checkDataBinding: function () {
            var source = this.model.dataSource;
            if (source != null) {
                this.ul.addClass("e-load");
                if (ej.DataManager && source instanceof ej.DataManager)
                    this._initDataSource(source);
                else
                    this._renderItems(source);
            }
        },
        
        _initDataSource: function (source) {
            var proxy = this;
            var queryPromise = source.executeQuery(this._getQuery());
            queryPromise.done(function (e) {
                proxy._renderItems(e.result);
            }).fail(function (e) {
                proxy.ul.removeClass("e-load");
            });
        },
        
        _setAttributes: function (data, element) {
            if (data) {
                for (var key in data)
                    if (key == "class")
                        element.addClass(data[key]);
                    else
                        element.attr(key, (key == "style" ? element.attr("style") + ";" : "") + data[key]);
            }
        },

        _getQuery: function () {
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [], queryManager = ej.Query(), mapper = this.model.fields;
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.dataSource.dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = this.model.query;
            return queryManager;
        },

        _generateTagItems: function (list) {
            var i, mapField = this._getMapper(), callback = function (o) { return o[mapField._freq]; };
            var mappedArray = list.map ? list.map(callback) : $.map(list, callback);
            this.minFreq = Math.min.apply(Math, mappedArray);
            this.maxFreq = Math.max.apply(Math, mappedArray);

            for (i = 0; i < list.length; i++) {
                this.ul.append(this._generateLi(list[i], mapField));
            }
        },
        
        _getMapper: function () {
            var mapper = this.model.fields, mapFld = { _text: null, _freq: null, _url: null };
            mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
            mapFld._freq = (mapper && mapper.frequency) ? mapper["frequency"] : "frequency";
            mapFld._url = (mapper && mapper.url) ? mapper["url"] : "url";
            mapFld._attr = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
            return mapFld;
        },
        
        _generateLi: function (list, map) {
            var li = ej.buildTag("li.e-tagitems"), aTag;
            aTag = ej.buildTag("a.e-txt", list[map._text] || list[map._url],
                    { "font-size": this._calculateFontSize(list[map._freq]) },
                    { role: "link" });
            if (list[map._url]) aTag.attr({ "href": list[map._url], "target": "blank" });
            this._setAttributes((list[map._attr]), aTag);
            li.append(aTag);
            this._on(aTag, "mouseenter", this._mouseEnter);
            this._on(aTag, "mouseleave", this._mouseLeave);
            this._on(aTag, "click", this._mouseClick);
            return li;
        },

        
        _mouseEnter: function (e) {
            $(e.target).addClass("hover");
            this._raiseEvent(e, "mouseover");
        },
        
        _mouseLeave: function (e) {
            $(e.target).removeClass("hover");
            this._raiseEvent(e, "mouseout");
        },
        
        _mouseClick: function (e) {
            $(e.target).removeClass("hover");
            this._raiseEvent(e, "click");
        },

        _raiseEvent: function (e, _type) {
            this._trigger(_type, { value: $(e.target).html(), url: $(e.target).attr('href'), eventType: _type, target: $(e.target) });
        },
        
        _calculateFontSize: function (frequency) {
            if (frequency) {
                var C = 2, k, fontRange, fontSize,
                minSize = parseInt(this.model.minFontSize, 10), maxSize = parseInt(this.model.maxFontSize, 10);
                k = (frequency - this.minFreq) / (this.maxFreq - this.minFreq);
                fontRange = maxSize - minSize;
                fontSize = minSize + (C * Math.floor(k * (fontRange / C)));
                return fontSize;
            }
            else return this.model.minFontSize;
        }
    });
    
    ej.Format = {
        /**  Render the tagCloud items in cloud format */
        Cloud: "cloud",
        /**  Render the tagCloud items in list format */
        List: "list"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html TileView elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    ej.widget("ejTileBase", "ej.TileBase", {
        defaults: {
            badge: {
                enabled: false,
                value: 1,
                text: null,
                maxValue: 100,
                minValue: 1,
                position: "bottomright"
            },

            caption: {
                enabled: true,
                text: "text",
                icon: null,
                position: "innerbottom",
                alignment: "normal"
            },

            enablePersistence: false,

            imageClass: null,

            imagePosition: "center",

            imageTemplateId: null,

            imageUrl: null,

            liveTile: {

                text: null,

                enabled: false,

                imageClass: null,

                imageTemplateId: null,

                imageUrl: null,

                type: "flip",

                updateInterval: 2000
            },

            cssClass: "",

            tileSize: "small",

            width: null,

            height: null,

            showRoundedCorner: false,

            backgroundColor: null,

            allowSelection: false,

           locale: "en-US",

            //deprecated
            showText: true,

            text: "text",

            textAlignment: "normal",

        },
        dataTypes: {
            imagePosition: "enum",
            liveTile: {
                text: "array",
                type: "enum",
                enabled: "boolean",
                updateInterval: "number",
                imageUrl: "array",
                imageClass: "array",
                imageTemplateId: "array"
            },
            alignment: "enum",
            tileSize: "enum",
            locale: "string"
        },

        observables: ["badge.value", "badge.enabled", "badge.text", "badge.position", "text", "caption.text"],
        _badgeValue: ej.util.valueFunction("badge.value"),
        _badgeEnabled: ej.util.valueFunction("badge.enabled"),
        _badgeText: ej.util.valueFunction("badge.text"),
        _badgePosition: ej.util.valueFunction("badge.position"),
        _captionText: ej.util.valueFunction("caption.text"),
        text: ej.util.valueFunction("text"),

        _setDeprecatedProperties: function () {
            this.model["caption"].enabled = (this.defaults["caption"].enabled == this.model["caption"].enabled && this.defaults.showText == this.model.showText) ? this.defaults["caption"].enabled : this.model["caption"].enabled != this.defaults["caption"].enabled ? this.model["caption"].enabled : this.model.showText;
            this._captionText((this.defaults["caption"].text == this._captionText() && this.defaults.text == this.text()) ? this.defaults["caption"].text : this._captionText() != this.defaults["caption"].text ? this._captionText() : this.text());
            this.model["caption"].alignment = (this.defaults["caption"].alignment == this.model["caption"].alignment && this.defaults.textAlignment == this.model.textAlignment) ? this.defaults["caption"].alignment : this.model["caption"].alignment != this.defaults["caption"].alignment ? this.model["caption"].alignment : this.model.textAlignment;
        },
        _tileRender: function () {
            this._setDeprecatedProperties();
            this._imagePosition = this.model.imagePosition;
            this._cssClass = this.model.cssClass;
            this.element.addClass(this.model.cssClass + " " + this._prefix + "tile-image" + this.model.imagePosition + " " + this._prefix + "tile-" + this.model.tileSize);
            if (this.model.showRoundedCorner)
                this.element.addClass(this._prefix + "tile-round-corner");
            if (this._isLiveTile())
                this._liveTile();
            else {
                this._image = ej.buildTag("div").addClass(this._prefix + "tile-image" + this.model.imagePosition + " " + this._prefix + "image-parent");
                this._innerImage = ej.buildTag("span").addClass(this._prefix + "tile-image " + this._prefix + "tile-image" + this.model.imagePosition);
                if (this.model.imageTemplateId) {
                    var imageTemp = this._isMobile() ? ej.getCurrentPage().find('#' + this.model.imageTemplateId) : $('#' + this.model.imageTemplateId);
                    this._innerImage.addClass(this._prefix + "tile-template").append(imageTemp);
                }
                else if (this.model.imageClass) 
                    this._innerImage.addClass(this.model.imageClass);
                else if (this.model.imageUrl) {
                    var url = this._isMobile() && this.model.imagePath ? (this._getAbsolutePath(this.model.imagePath) + "/" + this.model.renderMode.toLowerCase() + "/" + this.model.imageUrl) : this._getAbsolutePath(this.model.imageUrl);
                    this._innerImage.css({ "background-image": "url('" + url + "')"});
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && this.model.imagePosition == "fill")
                        this._innerImage.css({ "filter": "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + url + "',sizingMethod='scale')", "-ms-filter": "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + url + "',sizingMethod='scale')" });
                }
                this._image.append(this._innerImage);
                this.element.append(this._image);
                this._setBackgroundColor(this.model.backgroundColor);
                if (this.model.imageTemplateId && this._prefix == "e-m-" && ej.angular.defaultAppName)
                    ej.angular.compile(this._image);
            }
            if (this._isCaptionEnable()) {
                if (this.model["liveTile"].text && this._isLiveTile()) {
                    var liveTileImage = this.element.find("." + this._prefix + "image-parent");
                    for (var i = 0, tileLength = liveTileImage.length; i < tileLength; i++) {
                        this._setCaptionClass($(liveTileImage[i]));
                        $(liveTileImage[i]).addClass(this._prefix + "tile-caption-text ").attr("text", this.model["liveTile"].text[i]);
                    }
                }
                else {
                    this._setCaptionClass(this.element);
                    if (this.model["caption"].icon) {
                        this._captionIcon = this.model["caption"].icon;
                        this.element.addClass(this._prefix + "tile-caption-icon " + this._prefix + "icon-" + this._captionIcon);
                    }
                    else {
                        this.element.addClass(this._prefix + "tile-caption-text ").attr("text", this._captionText());
                    }

                }
            }
            if (this._badgeEnabled())
                this._setBadgeEnabled();
            this._selectElement = ej.buildTag("span." + this._prefix + "tile-overlay");
            this.element.append(this._selectElement);
            if(!this.model.height) this.model.height = this.model["caption"].position == "outer" ? this.element.height() - 50 : this.element.height();
            if(!this.model.width) this.model.width = this.element.width();
            if (this._isCustomizeSize())
                this._setCustomizSize();
        },

        _liveTile: function () {
            this.element.addClass(this._prefix + "livetile-enable"); var image;
            if (this.model["liveTile"].imageTemplateId) {
                for (var i = 0; i < this.model["liveTile"].imageTemplateId.length; i++) {
                    var imageTempEle = ej.buildTag("div").addClass(this._prefix + "tile-template " + this._prefix + "tile-image" + this.model.imagePosition + " " + this._prefix + "image-parent " + this._prefix + "tile-" + this.model["liveTile"].type);
                    var template = this._isMobile() ? ej.getCurrentPage().find('#' + this.model["liveTile"].imageTemplateId[i]) : $('#' + this.model["liveTile"].imageTemplateId[i]);
                    this.element.append(imageTempEle.append(template));
                }
            }
            else if (this.model["liveTile"].imageClass) {
                for (var i = 0; i < this.model["liveTile"].imageClass.length; i++) {
                    image = ej.buildTag("span").addClass(this.model["liveTile"].imageClass[i] + " " + this._prefix + "tile-image " + this._prefix + "tile-image" + this.model.imagePosition);
                    var imageClassEle = ej.buildTag("div").addClass( this._prefix + "tile-image" + this.model.imagePosition + " " + this._prefix + "tile-" + this.model["liveTile"].type + " " + this._prefix + "image-parent");
                    image.appendTo(imageClassEle);
                    this.element.append(imageClassEle);
                }
            }
            else {
                for (var i = 0; i < this.model["liveTile"].imageUrl.length; i++) {
                    var url = this._isMobile() && this.model.imagePath ? this._getAbsolutePath(this.model.imagePath) + "/windows/" + this.model["liveTile"].imageUrl[i] : this._getAbsolutePath(this.model["liveTile"].imageUrl[i]);
                    image = ej.buildTag("span").addClass(this._prefix + "tile-image " + this._prefix + "tile-image" + this.model.imagePosition).css({ "background-image": "url('" + url + "')" });
                    var imageUrlEle = ej.buildTag("div." + this._prefix + "tile-image" + this.model.imagePosition + " " + this._prefix + "tile-" + this.model["liveTile"].type + " " + this._prefix + "image-parent");
                    image.appendTo(imageUrlEle);
                    this.element.append(imageUrlEle);
                }
            }
            this._setBackgroundColor(this.model.backgroundColor);
            $(this.element.children()[0]).addClass(this._prefix + "tile-" + this.model["liveTile"].type + 'back').removeClass(this._prefix + "tile-" + this.model["liveTile"].type);
            if (this.model.imageTemplateId && this._prefix == "e-m-" && (App.angularAppName || ej.angular.defaultAppName))
                ej.angular.compile(this.element);
        },
        _setCustomizSize: function () {
            var minWidth = (this._isLiveTileMode() || this.model.renderMode == "flat") && (parseInt(this.model.width) <= 70) ? "70" :
                (this._isMobile() && this.model.renderMode == "android") && this._isBelowSmallSize() ? "85" :
                (this._isMobile() && this.model.renderMode == "ios7") && this._isBelowSmallSize() ? "74" :
                 this.model.width;
            var minHeight = (this._isLiveTileMode() || this.model.renderMode == "flat") && (parseInt(this.model.height) <= 70) ? "70" :
                (this._isMobile() && (this.model.renderMode == "android" || this.model.renderMode == "ios7")) && this._isBelowSmallSize() ? "70" :
                (this._isMobile() && this.model.renderMode == "ios7") && this._isBelowSmallSize() ? "70" : this.model.height;
            var extraSpace = (this._isLiveTileMode() || this.model.renderMode == "flat") && !this._isBelowSmallSize() ? 50 :
                 (this._isLiveTileMode() || this.model.renderMode == "flat") && this._isBelowSmallSize() ? 0 :
                (this._isMobile() && this.model.renderMode == "android") && this._isBelowSmallSize() ? 30 : 30;
            var newHeight = (this.model["caption"].enabled && this.model["caption"].position == "outer" && this.model.height) ? minHeight ? parseInt(minHeight) + extraSpace : parseInt(minHeight) + extraSpace : this.model.height;
            this.element.css({ "width": this.model.width ? this.model.width : "70", "height": this.model.height ? newHeight : this.element.height() + extraSpace });
            this.element.find("." + this._prefix + "image-parent").css({"width": this.element.css("width"), "height": this.model.height ? minHeight : this.element.height() - extraSpace });
            if (!this._isBelowSmallSize() && this.model["caption"].enabled && this.model["caption"].position == "outer") {
                this.element.find(".e-m-tile-image").css({ "width": this.model.width ? minWidth : "", "height": this.model.height ? minHeight : "" });
                this._selectElement.css({ "width": this.model.width ? minWidth : "", "height": this.model.height ? minHeight : "" });
            }
            if (this._isBelowSmallSize()) {
                this.element.addClass(this._prefix + "tile-small");
                if (!(this._isMobile() && (this.model.renderMode == "android" || this.model.renderMode == "ios7") && this.model["caption"].position == "outer"))
                    this.element.removeAttr("text");
            }
        },
        _isLiveTile: function () {
            return (this._isLiveTileMode() && this.model["liveTile"].enabled);
        },

        _isLiveTileMode: function () {
            return (!this._isMobile() || this.model.renderMode == "windows");
        },

        _setCaptionClass: function (element) {
            element.addClass(this._prefix + "tile-caption " + this._prefix + "caption-" + this.model["caption"].position + " " + this._prefix + "caption-align-" + this.model["caption"].alignment);
        },

        _isCaptionEnable: function () {
            return (this.model["caption"].enabled && !(this.model.tileSize == "small" || (this._isBelowSmallSize() && this.model.tileSize == "small")) || ((this._isMobile() && (this.model.renderMode == "ios7" || this.model.renderMode == "android") && this.model["caption"].position == "outer") || this._isMobile() && (this.model.renderMode == "android" || this.model.renderMode == "ios7") && this.model["caption"].position == "outer" && (this._isCustomizeSize() && this._isBelowSmallSize())));
        },

        _isBelowSmallSize: function () {
            var width = this.model.width ? parseInt(this.model.width) : this.model.width;
            var height = this.model.height ? parseInt(this.model.height) : this.model.height;
            var minWidthandHeight = (!this._isMobile() || (this._isMobile() && (this.model.renderMode == "windows" || this.model.renderMode == "flat"))) ? 70 : (this._isMobile() && this.model.renderMode == "android") ? 85 : 74;
            return ((width <= minWidthandHeight && width != null) || (height <= minWidthandHeight && height != null));
        },

        _isCustomizeSize: function () {
            return this.model.height || this.model.width;
        },

        _createDelegates: function () {
            this._onStartDelegate = $.proxy(this._isMobile() ? this._onTouchStartHandler : this._onMouseDownHandler, this);
            this._onEndDelegate = $.proxy(this._isMobile() ? this._onTouchEndHandler : this._onMouseUpHandler, this);
            this._onMoveDelegate = $.proxy(this._isMobile() ? this._onTouchMoveHandler : this._onMouseMoveHandler, this);
            this._onDocClickDelegate = $.proxy(this._onDocClickHandler, this);
            this._startAnimationDelegate = $.proxy(this["_" + this.model["liveTile"].type + "Tile"], this);
        },

        _wireEvents: function (remove) {
            this._createDelegates();
            ej.listenEvents([this.element, $(document)], [ej.startEvent(), ej.endEvent()], [this._onStartDelegate, this._onDocClickDelegate], remove, this);
            if (this._isLiveTile())
                remove ? this._stopTileAnimation() : this._startTileAnimation();
        },

        _onDocClickHandler: function (evt) {
            this._removeActiveClass();
        },

        _removeActiveClass: function () {
            this._isLiveTileMode() ? ej._removeSkewClass(this.element) : $(this.element).removeClass(this._prefix + "state-active");
        },

        _startTileAnimation: function () {
            this._intervalCounter = setInterval(this._startAnimationDelegate, this.model["liveTile"].updateInterval);
        },

        _stopTileAnimation: function () {
            clearInterval(this._intervalCounter);
        },

        _flipTile: function () {
            var front = this.element.find("." + this._prefix + "tile-flipback");
            var back = this.element.find("." + this._prefix + "tile-flip").first();
            front.addClass(this._prefix + "tile-flip").removeClass(this._prefix + "tile-flipback");
            back.addClass(this._prefix + "tile-flipback").removeClass(this._prefix + "tile-flip");
        },

        _slideTile: function () {
            this._animateEffect();
        },

        _carouselTile: function () {
            this._animateEffect();
        },

        _animateEffect: function () {
            var type = this.model["liveTile"].type.toLowerCase();
            var items = this.element.find("." + this._prefix + "image-parent");
            var currentitem = this.element.find("." + this._prefix + "tile-" + type + "back");
            var nextitem = currentitem.next()[0] == null ? items.first() : currentitem.next();
            var previtem = currentitem.prev()[0] == null ? items.last() : currentitem.prev();
            if ($(currentitem.next()[0]).hasClass(this._prefix + "tile-overlay") || $(currentitem.prev()[0]).hasClass(this._prefix + "tile-overlay")) {
                var currentItem = $(currentitem.next()[0]).next();
                var previousItem = $(currentitem.next()[0]).prev();
                nextitem = currentItem.next()[0] == null ? items.first() : currentItem.next();
                previtem = previousItem.prev()[0] == null ? items.last() : previousItem.prev();
            }
            previtem.addClass(this._prefix + "tile-" + type).removeClass(this._prefix + "tile-" + type + "up");
            currentitem.addClass(this._prefix + "tile-" + type + "up").removeClass(this._prefix + "tile-" + type + "back");
            nextitem.removeClass(this._prefix + "tile-" + type).addClass(this._prefix + "tile-" + type + "back");
        },

        _getAbsolutePath: function (path) {
            return this._isMobile() ? this._makeUrlAbsolute(path).toString() : path;
        },

        _makeUrlAbsolute: function (relUrl) {
            var link = $("<a href ='" + relUrl + "'></a>")[0];
            $("body").append(link);
            var pathname;
            if (link.pathname.indexOf('/') != 0)
                pathname = '/' + link.pathname;
            else
                pathname = link.pathname;
            var browser = ej.browserInfo();
            var isIE9 = (browser.name == "msie" && browser.version == "9.0");
            var newLink = (link.protocol + "//" + ((isIE9 && link.port == "80") ? (link.host).replace(":80", "") : link.host) + pathname + link.search + link.hash);
            $(link).remove();
            return newLink;
        },

        _isMobile: function () {
            return this._prefix == "e-m-" ? true : false;
        },
        /*Public Method*/
        updateTemplate: function (id, index) {
            if (this._isLiveTile()) {
                $(this.element.children()[index]).empty();
                var tempLive = (this._isMobile() ? ej.getCurrentPage().find('#' + id) : $('#' + id));
                $(this.element.children()[index]).append(tempLive);
            }
            else {
                var template = this._isMobile() ? ej.getCurrentPage().find('#' + id) : $('#' + id);
                this._image.addClass(this._prefix + "tile-template").empty().append(template);
            }
        },

        _setModel: function (options) {
            var refresh = false;
            for (var property in options) {
                var setModel = "_set" + property.charAt(0).toUpperCase() + property.slice(1);
                if (this[setModel] || property == "locale") {
                    switch (property) {
                        case "text":
                            this[setModel](ej.util.getVal(options[property]));
                            options[property] = this.text(ej.util.getVal(options[property]));
							if (ej.isNullOrUndefined(this._options)) this._options = {};
							this._options["caption"] = this.model.caption;
                            break;
						case "locale":
							if (ej.Tile.Locale[options[property]]) {
								this.model.locale = options[property];
								this._setCulture();
								this._setCaptionText(this._captionText());
							}
                            break;
                        default:
                            this[setModel](options[property]);
                    }
                }
                else
                    refresh = true
            }
            if (refresh)
                this._refresh();
        },
        /*Setmodel method*/
        _setCaption: function (options) {
            var refresh = false;
            for (var property in options) {
                var setModel = "_setCaption" + property.charAt(0).toUpperCase() + property.slice(1);
                if (this[setModel]) {
                    switch (property) {
                        case "text":
                            this[setModel](ej.util.getVal(options[property]));
                            options[property] = this._captionText(ej.util.getVal(options[property]));
                            break;
                        default:
                            this[setModel](options[property]);
                    }
                }
                else
                    refresh = true
            }
            if (refresh)
                this._refresh();
        },

        _setText: function (value) {
			this._captionText(value);
            this._setCaptionText(value)
        },
        _setCaptionText: function (value) {
            (this._isCaptionEnable() ? this.element.attr("text", value) : this.element.removeAttr("text"));
        },
        _setCaptionEnabled: function (value) {
            if (this._isCaptionEnable())
                this.element.attr("text", this._captionText())
            else
                this.element.removeAttr("text")
        },
        _setCaptionIcon: function (value) {
            if (this._isCaptionEnable()) {
                this.element.removeClass(this._prefix + "caption-text " + this._prefix + "icon-" + this._captionIcon).addClass(this._prefix + "caption-icon " + this._prefix + "icon-" + value).removeAttr("text");
                this._captionIcon = value;
            }
        },
        _setCaptionAlignment: function (value) {
            if (this._isCaptionEnable())
                this.element.removeClass(this._prefix + "caption-align-normal " + this._prefix + "caption-align-left " + this._prefix + "caption-align-center " + this._prefix + "caption-align-right").addClass(this._prefix + "caption-align-" + value)
        },
        _setShowRoundedCorner: function (value) {
            (value ? this.element.addClass(this._prefix + "tile-round-corner") : this.element.removeClass(this._prefix + "tile-round-corner"));
        },
        _setCssClass: function (value) {
            this.element.removeClass(this._cssClass).addClass(value);
            this._cssClass = value;
        },
        _setBackgroundColor: function (value) {
            ((!this._isMobile() || (this._isMobile() && this.model.renderMode == "windows")) || (this.model["caption"].position == "outer") ? this.element.find("." + this._prefix + "tile-image").css("background-color", value) : this.element.css("background-color", value));
        },
        _setTileSize: function (value) {
            if (!this._isCaptionEnable())
                this.element.removeAttr("text");
            else if (this._isCaptionEnable())
                this.element.attr("text", this._captionText());
            this.element.css({ "width": "", "height": "" });
            this.element.find("." + this._prefix + "image-parent").css({ "width": "", "height": "" });
            this.element.removeClass(this._prefix + "tile-small " + this._prefix + "tile-medium " + this._prefix + "tile-wide " + this._prefix + "tile-large").addClass(this._prefix + "tile-" + value);
            this.model.height = this.element.height();
            this.model.width = this.element.width();
        },
        _setImagePosition: function (value) {
            this.element.removeClass(this._prefix + "tile-image" + this._imagePosition).addClass(this._prefix + "tile-image" + value);
            $(this.element.find("." + this._prefix + "tile-image")).removeClass(this._prefix + "tile-image" + this._imagePosition).addClass(this._prefix + "tile-image" + value);
            this._imagePosition = this.model.imagePosition;
        },
        _setBadge: function (options) {
            for (var property in options) {
                var setModel = "_setBadge" + property.charAt(0).toUpperCase() + property.slice(1);
                if (this[setModel]) {
                    switch (property) {
                        case "value":
                        case "enabled":
                        case "text":
                            this[setModel](ej.util.getVal(options[property]));
                            if (typeof options[property] == "function")
                                options[property](this["_badge" + property.charAt(0).toUpperCase() + property.slice(1)]());
                            else
                                options[property] = this["_badge" + property.charAt(0).toUpperCase() + property.slice(1)]();
                            break;
                        default:
                            this[setModel](options[property]);
                    }
                }
            }
        },

        _setBadgeValue: function (value) {
            if (this._badgeEnabled()) {
                value = ej.isNullOrUndefined(value) ? this._badgeValue() : value;
                var badgeValue;
                if (this._badgeText())
                    badgeValue = this._badgeText();
                else {
                    if (value <= this.model["badge"].maxValue && value >= this.model["badge"].minValue) {
                        badgeValue = value.toString();
                        this._badgeValue(value);
                    }
                    else if (value > this.model["badge"].maxValue) {
                        badgeValue = this.model["badge"].maxValue.toString() + "+";
                        this._badgeValue(this.model["badge"].maxValue);
                    }
                    else {
                        badgeValue = this.model["badge"].minValue.toString();
                        this._badgeValue(this.model["badge"].minValue);
                    }
                }
                this.element.addClass(this._prefix + "tile-badge " + this._prefix + "badge-position-" + this._badgePosition());
                this.element.addClass(this._prefix + "tile-badge-value").attr("badgeValue", badgeValue);
            } else 
                this.element.removeClass(this._prefix + "tile-badge " + this._prefix + "badge-position-" + this._badgePosition() + " " + this._prefix + "tile-badge-value");
        },

        _setBadgePosition: function (value) {
            this._badgePosition(value)
            if (this._badgeEnabled())
                this.element.removeClass(this._prefix + "badge-position-bottomright " + this._prefix + "badge-position-topright").addClass(this._prefix + "badge-position-" + this._badgePosition());
        },

        _setBadgeEnabled: function (enabled) {
            this._badgeEnabled(enabled);
            this._setBadgeValue();
        },

        _setBadgeMaxValue: function (value) {
            this.model["badge"].maxValue = value;
            this._setBadgeValue();
        },

        _setBadgeMinValue: function (value) {
            this.model["badge"].minValue = value;
            if (this._badgeEnabled())
                this._setBadgeValue();
        },

        _setBadgeText: function (value) {
            this._badgeText(value);
            if (this._badgeEnabled())
                this._setBadgeValue();
        },

        _clearElement: function () {
            this.element.removeAttr("class");
            this.element.html(this._orgEle.html());
        },

        _destroy: function () {
            this._wireEvents(true);
            this._clearElement();
        }
    });
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html TileView elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejTile", "ej.Tile", {
        _setFirst: true,
        validTags: ["div"],
        _rootCSS: "e-tile",
        defaults: {

            mouseDown: null,

            mouseUp: null
        },

        _init: function (options) {
            this._options = options;
            this._setCulture();
            this._orgEle = this.element.clone();
            this._liveTileimageTemplateParent = [];
            this._cloneLiveTileImageTemplateElement = [];
            this._renderEJControl();
        },

        _renderEJControl: function () {
            if (this.model.captionTemplateId) {
                this._captionTemplateParent = $("#" + this.model.captionTemplateId).parent();
                this._cloneCaptionTemplateElement = $("#" + this.model.captionTemplateId).clone();
            }
            if (this.model.imageTemplateId) {
                this._imageTemplateParent = $("#" + this.model.imageTemplateId).parent();
                this._cloneImageTemplateElement = $("#" + this.model.imageTemplateId).clone();
            }
            if (this.model.liveTile.enabled && this.model.liveTile.imageTemplateId) {
                for (i = 0; i < this.model.liveTile.imageTemplateId.length; i++) {
                    this._liveTileimageTemplateParent[i] = $("#" + this.model.liveTile.imageTemplateId[i]).parent();
                    this._cloneLiveTileImageTemplateElement[i] = $("#" + this.model.liveTile.imageTemplateId[i]).clone();
                }
            }
            this.element.addClass("e-tile-web");
            this._prefix = "e-";
            this._tileRender();
            this._wireEvents();
        },

        _onMouseDownHandler: function (evt) {
            var item = this.element;
            item.addClass(ej._getSkewClass(item, evt.pageX, evt.pageY).replace('e-m-', 'e-'));
            this._trigger("mouseDown", { text: item.attr("text"), index: $(evt.target).index() });
            ej.listenTouchEvent(this.element, ej.moveEvent(), this._onMoveDelegate, false, this);
            ej.listenTouchEvent(this.element, ej.endEvent(), this._onEndDelegate, false, this);
            this._isMoved = false;
        },

        _onMouseMoveHandler: function (evt) {
            this._isMoved = true;
            this._removeActiveClass();
        },

        _onMouseUpHandler: function (evt) {
            if (this.model.allowSelection) {
                if (!this._selected) {
                    this._selected = true;
                    this._selectElement.addClass("e-tile-selected");
                }
                else if (this._selected) {
                    this._selected = false;
                    this._selectElement.removeClass("e-tile-selected");
                }
            }
            if (!this._isMoved && this.model.mouseUp)
                this._trigger("mouseUp", { text: this.element.attr("text"), index: $(evt.target).index(), select: this._selected });
            this._removeActiveClass();
            this._isMoved = false;
            ej.listenTouchEvent(this.element, ej.moveEvent(), this._onMoveDelegate, true, this);
            ej.listenTouchEvent(this.element, ej.endEvent(), this._onEndDelegate, true, this);
        },

        _refresh: function () {
            this._destroy();
            this.element.addClass("e-tile e-js");
            if (this.model.captionTemplateId)
                $(this._captionTemplateParent).append(this._cloneCaptionTemplateElement);
            if (this.model.imageTemplateId)
                $(this._imageTemplateParent).append(this._cloneImageTemplateElement);
            if (this.model.liveTile.enabled && this.model.liveTile.imageTemplateId) {
                for (i = 0; i < this.model.liveTile.imageTemplateId.length; i++)
                    $(this._liveTileimageTemplateParent[i]).append(this._cloneLiveTileImageTemplateElement[i]);
            }
            this._renderEJControl();
        },
		_setCulture: function () {
            if (this.model.locale != "en-US" && (ej.isNullOrUndefined(this._options) || ((ej.isNullOrUndefined(this._options["caption"]) || ej.isNullOrUndefined(this._options["caption"].text)) && ej.isNullOrUndefined(this._options["text"]))))
				this._captionText(this._getLocalizedLabels().captionText)
        },
		_getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });
	ej.Tile.Locale = ej.Tile.Locale || {};
    ej.Tile.Locale["default"] = ej.Tile.Locale["en-US"] = {
        captionText: "text"
    };
    ej.Tile.ImagePosition = {
        Center: "center",
        TopCenter: "topcenter",
        BottomCenter: "bottomcenter",
        RightCenter: "rightcenter",
        LeftCenter: "leftcenter",
        TopLeft: "topleft",
        TopRight: "topright",
        BottomRight: "bottomright",
        BottomLeft: "bottomleft",
        Fill: "fill"
    },
    ej.Tile.BadgePosition = {
        TopRight: "topright",
        BottomRight: "bottomright"
    }

    ej.Tile.CaptionAlignment = {
        Normal: "normal",
        Left: "left",
        Right: "right",
        Center: "center"
    },

    ej.Tile.CaptionPosition = {
        InnerTop: "innertop",
        InnerBottom: "innerbottom",
        Outer: "outer"
    },

    ej.Tile.TileSize = {
        Medium: "medium",
        Small: "small",
        Large: "large",
        Wide: "wide"
    },

    ej.Tile.LiveTileType = {
        Flip: "flip",
        Slide: "slide",
        Carousel: "carousel"
    }
    $.extend(true, ej.Tile.prototype, ej.TileBase.prototype);
})(jQuery, Syncfusion);;
// JavaScript source code
/**
* @fileOverview Plugin to style the Html RadialSlider elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    ej.widget("ejRadialSliderBase", "ej.RadialSliderBase", {
        defaults: {
            radius: 200,
            ticks: [0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100],
            enableRoundOff: true,
            value: 10,
            autoOpen: true,
            enableAnimation: true,
            cssClass: null,
            labelSpace: 30,
            stop: null,
            slide: null,
            start: null,
            change: null,
            create: null,
            destroy: null
        },
        dataTypes: {
            radius: "number",
            enableRoundOff: "boolean",
            enableAnimation: "boolean",
            cssClass: "string"
        },
        observables: ["value"],
        observableArray: ["ticks"],
        value: ej.util.valueFunction("value"),
        ticks: ej.util.valueFunction("ticks"),
        _outerTextCalculation: function (length, startAngle, endAngle) {
            var radius = this._isMobile() ? (this.model.radius - this.model.labelSpace) : (this.model.radius + this.model.labelSpace);
            this._point = ((endAngle - startAngle) / (length - 1));
            endAngle = startAngle + ((endAngle - startAngle) / (length - 1));
            var endValueCal = endAngle,
                startValueCal = endValueCal;
            this._textPoints = [];
            for (var j = 0; j < length; j++) {
                var line = {};
                var angleCondition = startAngle;
                startAngle = startAngle * Math.PI / 180.0;
                endAngle = endAngle * Math.PI / 180.0;
                line.X2 = (this._startXY) + (radius) * Math.cos(startAngle);
                line.Y2 = (this._startXY) + (radius) * Math.sin(startAngle);
                if (angleCondition <= 270 && 90 <= angleCondition)
                    line.textAlignment = "middle";
                else
                    line.textAlignment = "start";
                startAngle = endValueCal;
                endAngle = endValueCal + this._point;
                endValueCal += this._point;
                this._textPoints.push(line);
            }
            var line = {};
            var angleCondition = this._startValueAngle;
            this._startValueAngle = this._startValueAngle * Math.PI / 180.0;
            line.X2 = (this._startXY) + (radius) * Math.cos(this._startValueAngle);
            line.Y2 = (this._startXY) + (radius) * Math.sin(this._startValueAngle);
            if (angleCondition <= 270 && 90 <= angleCondition)
                line.textAlignment = "middle";
            else
                line.textAlignment = "start";
            this._textPoints.push(line);
            return this._textPoints;
        },

        _polarToCartesian: function (cX, cY, radius, angle, isDynamic) {
            var angleRadians = (angle) * Math.PI / 180.0;
            return {
                x: cX + (radius * Math.cos(angleRadians)),
                y: cY + (radius * Math.sin(isDynamic ? -angleRadians : angleRadians))
            };
        },
        _tapHandlerEvent: function (e) {
            var baseRect = $("#" + this._prefix + this._elementID + "-radial-slider-svg").offset();
            var y2 = e.clientY, x2 = e.clientX, y1 =( baseRect.top + (this._radialWidth / 2)) - $(window).scrollTop(), x1 = baseRect.left + (this._radialWidth / 2);
            this._dynamicAngleCalculation(x1, x2, y1, y2);
            var space = this._isMobile() && this.model.renderMode == "ios7" ? 6.5 : this._isMobile() && this.model.renderMode == "windows" ? 2.5 : 5;
            if ((!this._isMobile() && (this._angle >= (360 - this._endAngle) && this._angle <= (360 - this._startAngle))) || (this._isMobile() && (this._angle >= (360 - (this._endAngle - space)) && this._angle <= (360 - (this._startAngle + space)))) || (this._isMobile() && this.model.position.charAt(0).toLowerCase() == "l" && (this._angle > (270 + space) || this._angle < (90 - space)))) {
                this._lineAngleCalculation(true);
                this._previousAngle = this._angle;
                if (!this._isMobile()) {
                    $(this._overLine).remove();
                    this._pathBeforeAddlength = this._tickCount + 1;
                    this._pathAfterAddLength = this._directionLine.toString().replace(/[^M]/g, "").length;
                    if (this._pathBeforeAddlength < this._pathAfterAddLength) {
                        var deleteCount = this._isTapSelected ? 2 : 1;
                        this._directionLine.remove(this._tickCount, deleteCount, deleteCount);
                    }
                    else
                        this._directionLine.remove(this._tickCount, 1);
                    this._dynamicLineCalculation(this._angle, false, true, true, this._tickCount, this._tickCount + 1, true);
                    $(this._pathLineElement).attr("d", this._directionLine.toString());
                }
                if ($(this._textGroupElement).find('[id=' + this._prefix + this._elementID + "-dynamic-text" + ']').length > 0)
                    this._textGroupElement.find('[id=' + this._prefix + this._elementID + "-dynamic-text" + ']').remove();
                var selectPart = this._selectPart();
                var select = selectPart.select;
                var selectValue;
                if (this._isTicksControl()) {
                    selectValue = this._ticksCalculation();
                    if (this._isMobile() && this.model.position.charAt(0).toLowerCase() == "l")
                        this.line.textAlignment = "end";
                    else if (this._isMobile() && this.model.position.charAt(0).toLowerCase() == "r")
                        this.line.textAlignment = "start";
                    else if (this._isMobile() && (this.model.position.charAt(0).toLowerCase() == "b" || this.model.position.charAt(0).toLowerCase() == "t"))
                        this.line.textAlignment = "middle";
                    if (this._isMobile() && (this.ticks().indexOf(selectValue) == 0) || (this.ticks().indexOf(selectValue) == this._tickCount - 1))
                        this.line.textAlignment = "middle";
                    if (this.ticks().indexOf(selectValue) < 0) {
                        this._outerTextElement = this._createSVGElements("text", { "stroke-width": 0.5, "x": this.line.X2, "y": this.line.Y2, "class": this._prefix + "dynamic-text", "id": this._prefix + this._elementID + "-dynamic-text", "textContent": selectValue, "text-anchor": this.line.textAlignment });
                        this._textGroupElement.append(this._outerTextElement);
                        var dynamicText = document.getElementById(this._prefix + this._elementID + "-dynamic-text").getBoundingClientRect();
                        var x1 = this._textPoints[select.toFixed()].X2,
                            y1 = this._textPoints[select.toFixed()].Y2,
                            x2 = this.line.X2,
                            y2 = this.line.Y2;
                        var distance = Math.sqrt(Math.pow((x2 - x1), 2) + Math.pow((y2 - y1), 2));
                        if (distance < (dynamicText.width * 72 / 96)) {
                            this.line = {};
                            var value = (selectValue.toString().length)
                            var pixToDegree = (dynamicText.width * 72 / 96) - (this._isMobile() ? (value * 2) : (value * 4));
                            var degPoint = (parseFloat(select.toFixed(3).substr(0, 1)) == select.toFixed()) ? this._degPoint[select.toFixed()] + pixToDegree : this._degPoint[select.toFixed()] - pixToDegree;
                            var angle = (360 - degPoint) * (Math.PI / 180.0)
                            var radius = this._isMobile() ? (this.model.radius - (this.model.labelSpace)) : (this.model.radius + (this.model.labelSpace));
                            this.line.X2 = (this._startXY) + radius * Math.cos(angle);
                            this.line.Y2 = (this._startXY) + radius * Math.sin(-angle);
                            $("#" + this._prefix + this._elementID + "-dynamic-text").attr({ "x": this.line.X2, "y": this.line.Y2 });
                        }
                    }
                }
                else
                    selectValue = this.ticks()[select.toFixed()];
                this._trigger("change", { value: selectValue, oldValue: this.value() });
                if (this._needleStop && this.model.stop)
                    this._trigger("stop", { value: selectValue });
                this.value(selectValue);
                this._needleStop = true;
                this._needleMove = false;
                if (this._isMobile())
                    ((this.model.renderMode == "windows" || this.model.renderMode == "flat") ? this._dynamicWindowsRadial() : this._dynamicIOSandAndroidRadial());
            }
        },
        _selectPart: function () {
            var dynamicAngle = this._dynamicAngle, startAngle = this._startAngle, endAngle = this._endAngle;
            if (this._isMobile()) {
                var space = this.model.renderMode == "ios7" ? 5 : this.model.renderMode == "windows" ? 2.5 : 5;
                startAngle = this._startAngle + space, endAngle = this._endAngle - space;
                if (this.model.position.charAt(0).toLowerCase() == "l") {
                    if (this._dynamicAngle < 180)
                        dynamicAngle = this._dynamicAngle + 360;
                }
            }
            var select = (dynamicAngle - startAngle) / ((endAngle - startAngle) / (this.ticks().length - 1));
            var firstValue = this.ticks()[parseInt(select)];
            var secondValue = this.ticks()[parseInt(select) + 1];
            var difference = (secondValue - firstValue);
            return { select: select, firstValue: firstValue, space: space, difference: difference, dynamicAngle: dynamicAngle, };
        },
        _lineAngleCalculation: function (isMove) {
            var selectPart = this._selectPart();
            this._degPoint.splice(this.ticks().length, this.ticks().length + 1);
            this._degPoint.push(this._degPoint[this._degPoint.length - 1] + this._point);
            var innerValue = (((this._degPoint[parseInt(selectPart.select) + 1] - this._degPoint[parseInt(selectPart.select)]) - (this._degPoint[parseInt(selectPart.select) + 1] - (selectPart.dynamicAngle))) / (this._point / selectPart.difference));
            var startDegree = parseInt(selectPart.select) != 0 ? this._degPoint[parseInt(selectPart.select)] : this._degPoint[parseInt(selectPart.select)];
            var range;
            if (this.model.enableRoundOff && isMove) {
                var smallValue = parseFloat(innerValue.toFixed(2));
                innerValue = parseInt(innerValue.toFixed());
                range = (selectPart.difference == 0.5 && smallValue >= 0.25) ? this._point * 1 : (this._point / selectPart.difference) * innerValue;
            }
            else
                range = (this._point / selectPart.difference) * parseFloat(innerValue.toFixed(2));
            this._angle = (360 - this._degPoint[parseInt(selectPart.select)]) - Math.abs(range);
        },

        _isTicksControl: function () {
            var selectPart = this._selectPart();
            this._degPoint.splice(this.ticks().length, this.ticks().length + 1);
            this._degPoint.push(this._degPoint[this._degPoint.length - 1] + this._point);
            var innerValue = (((this._degPoint[parseInt(selectPart.select) + 1] - this._degPoint[parseInt(selectPart.select)]) - (this._degPoint[parseInt(selectPart.select) + 1] - (this._dynamicAngle))) / (this._point / selectPart.difference));
            var isSecSame = this.model.enableRoundOff ? parseInt(innerValue.toFixed()) == 0 || parseInt(innerValue.toFixed()) == (selectPart.difference) ? false : true : $.inArray(this._angle, this._degPoint) > -1 ? false : true;
            return isSecSame;
        },

        _ticksCalculation: function () {
            var selectPart = this._selectPart();
            var select = selectPart.select, dynamicAngle = selectPart.dynamicAngle, difference = selectPart.difference, firstValue = selectPart.firstValue, space = selectPart.space;
            var firstValue = this.ticks()[parseInt(select)];
            this.line = {};
            var angle = (this._angle) * (Math.PI / 180.0)
            var radius = this._isMobile() ? (this.model.radius - this.model.labelSpace) : (this.model.radius + this.model.labelSpace);
            this.line.X2 = (this._startXY) + radius * Math.cos(angle);
            this.line.Y2 = (this._startXY) + radius * Math.sin(-angle);
            if (this._angle <= 270 && 90 <= this._angle)
                this.line.textAlignment = "middle";
            else
                this.line.textAlignment = "start";
            var startDegree = parseInt(select) != 0 ? this._degPoint[parseInt(select)] : this._degPoint[parseInt(select)];
            var range = (dynamicAngle - startDegree) / (this._point / difference);
            var setValue;
            if (this.model.enableRoundOff) {
                var controlValue = parseFloat(range.toFixed(1).substr(1, 3));
                range = parseInt(range.toFixed());
                setValue = firstValue + Math.abs(range);
            }
            else {
                setValue = firstValue + Math.abs(parseFloat(range.toFixed(2)));
                setValue = parseFloat(setValue.toFixed(2));
            }
            return setValue;
        },
        _dynamicAngleCalculation: function (x1, x2, y1, y2) {
            var theta = Math.atan2((y2 - y1), (x2 - x1));
            this._angle = (360 - ((theta * 180) / Math.PI)) % 360;
            this._dynamicAngle = (360 + ((theta * 180) / Math.PI)) % 360;
        },
        _createSVGElements: function (element, attr) {
            var svgObj = document.createElementNS(this._svgLink, element);
            $.each(attr, function (attr, value) {
                if (attr == 'xlink:href')
                    svgObj.setAttributeNS('http://www.w3.org/1999/xlink', 'xlink:href', value);
                if (attr != "textContent")
                    svgObj.setAttribute(attr, value);
                else
                    svgObj.textContent = value;
            })
            return svgObj;
        },
        show: function () {
            if (this.model.enableAnimation) {
                this.element.removeClass(this._prefix + "slider-hide").addClass(this._prefix + "slider-show");
                this._radialSVG.attr("class", "").attr("class", (this._prefix + "radialslider-svg-show " + this._prefix + "rs-svg"));
            }
            this.element.css("display", "block");
            this.model.autoOpen = true;
        },
        hide: function () {
            var proxy = this;
            if (this.model.enableAnimation) {
                this.element.removeClass(this._prefix + "slider-show").addClass(this._prefix + "slider-hide");
                this._radialSVG.attr("class", "").attr("class", this._prefix + "radialslider-svg-hide " + this._prefix + "rs-svg");
               (this.model.autoOpen) ?
                setTimeout(function () {
                    proxy.element.css("display", "none");
                }, this._isMobile ? 150 : 400)
                : proxy.element.css("display", "none");
            }
            else
                proxy.element.css("display", "none");
            this.model.autoOpen = false;
        },
        _setModel: function (options) {
            if (!ej.isNullOrUndefined(options["inline"]) && !options["inline"]) this.model.radius += 50;
            if (options.ticks) this.model.ticks = options.ticks;
            this._refresh();
        },
        _clearElement: function () {
            this.element.removeAttr("class");
            this.element.html(this._orgEle.html());
        },
        _destroy: function () {
            this._wireEvents(true);
            this._clearElement();
        },
        _isMobile: function () {
            return (this._prefix == "e-m-" ? true : false);
        },
    });
})(jQuery, Syncfusion);;
// JavaScript source code
/**
* @fileOverview Plugin to style the Html Radial Slider elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRadialSlider", "ej.RadialSlider", {
        _setFirst: true,
        validTags: ["div"],
        _rootCSS: "e-radialslider",
        defaults: {
            mouseover: null,
            strokeWidth: 2,
            inline: false,
            endAngle: 360,
            startAngle: 0,
            innerCircleImageClass: null,
            innerCircleImageUrl: null,
            showInnerCircle: true,
        },
        dataTypes: {
            innerCircleImageClass: "string",
            innerCircleImageUrl: "string",
            showInnerCircle: "boolean",
            inline: "boolean",
            strokeWidth: "number",
            endAngle: "number",
            startAngle: "number"
        },
        _init: function () {
            this._orgEle = this.element.clone();
            this._renderEJControl();
        },
        _renderEJControl: function () {
            this._prefix = "e-";
            this._directionLine = this._getStringBuilder();
            this._initialization();
            this._renderControl();
            this._wireEvents(false);
        },
        _initialization: function () {
            this.element.addClass(this.model.cssClass);
            this._svgLink = "http://www.w3.org/2000/svg";
            this._startXY = this.model.radius - (this.model.inline ? 50 : 0);
            this._startAngle = this.model.startAngle;
            this._endAngle = this.model.endAngle;
            this._diameter = 2 * this.model.radius;
            this._elementID = this.element.attr("id");
            this.model.radius = this._startXY;
            this._tickCount = this.ticks().length;
            this._labelSpacing = this.model.inline ? 0 : 200;
            this._radialWidth = this._diameter + this._labelSpacing;
            this.element.css({ "width": this._diameter + this._labelSpacing, "height": this._diameter + this._labelSpacing });
            this._radialSliderWrapper = ej.buildTag("div", {}, {}, { "class": this._prefix + "radail-slider-wrapper" }).css({ "width": this._radialWidth, "height": this._radialWidth });
            if (this.model.showInnerCircle) {
                this._innerCircle = ej.buildTag("div", {}, {}, { "class": this._prefix + "inner-circle" }).css({ "left": ((this._radialWidth / 2) - (20 + this.model.strokeWidth + 1)), "top": ((this._radialWidth / 2) - (20 + this.model.strokeWidth + 1)), "border-width": this.model.strokeWidth + 1 });
                if (this.model.innerCircleImageClass)
                    this._innerCircle.addClass(this.model.innerCircleImageClass);
                else
                    this._innerCircle.css({ "background-image": "url('" + this.model.innerCircleImageUrl + "')" });
                this._radialSliderWrapper.append(this._innerCircle);
            }
            this.element.append(this._radialSliderWrapper);
        },
        _renderControl: function () {
            //svg element creaton
            this._radialSVG = $(this._createSVGElements("svg", { "id": this._prefix +this._elementID+ "-radial-slider-svg", "class": this._prefix + "rs-svg", "width": this._diameter + this._labelSpacing, "height": this._diameter + this._labelSpacing }));
            //Outer line circle group
            var pathTranslate = this.model.inline ? 50 : 100, textTranslateX = this.model.inline ? 45 : 95, textTranslateY = this.model.inline ? 55 : 105;
            this._pathLineGroupElement = $(this._createSVGElements("g", { "id": "outerLineCircle", "transform": "translate(" + pathTranslate + "," + pathTranslate + ")" }));
            this._lineDirection = this._outerLineCalculation(50, 40, this._tickCount, true, true, "path");
            //Outer test  circle group
            this._textGroupElement = $(this._createSVGElements("g", { "id": "outerTextCircle", "transform": "translate(" + textTranslateX + "," + textTranslateY + ")" }));
            //Circle group
            this._circleGroupElement = $(this._createSVGElements("g", { "id": "circlegroup", "transform": "translate(" + pathTranslate + "," + pathTranslate + ")" }));
            this._circlePath = this._createSVGElements("path", { "id": "circlepath", "d": this._circleArcDirection(this._startAngle, this._endAngle), "class": this._prefix + "radialarcdefault", "fill": "none", "stroke-width": this.model.strokeWidth });
            this._circleGroupElement.append(this._circlePath);
            this._circleGroupElement.append(this._radialCircle);
            this._outerTextDirection = this._outerTextCalculation(this._tickCount, this._startAngle, this._endAngle);
            // Text value set in corresponding point
            for (var i = 0; i < this._tickCount + 1; i++) {
                var k = (i == 0) && (this._startAngle == 0) && (this._endAngle == 360) ? (this._tickCount - 1) : i;
                this._outerTextElement;
                if (i == this._tickCount) {
                    if ((this.ticks()[0] == this.value()))
                        continue;
                    else
                        this._outerTextElement = this._createSVGElements("text", { "stroke-width": 0.5, "x": this._outerTextDirection[i].X2, "y": this._outerTextDirection[i].Y2, "id": this._prefix + this._elementID + "-dynamic-text", "class": this._prefix + "dynamic-text", "textContent": this.value(), "text-anchor": this._outerTextDirection[i].textAlignment });
                }
                else
                    this._outerTextElement = this._createSVGElements("text", { "stroke-width": 0.5, "x": this._outerTextDirection[i].X2, "y": this._outerTextDirection[i].Y2, "class": this._prefix + "ticks-text", "textContent": this.ticks()[k], "text-anchor": this._outerTextDirection[i].textAlignment });
                this._textGroupElement.append(this._outerTextElement);
            }
            this._pathLineElement = this._createSVGElements("path", { "class": this._prefix + "radial-needle", "d": this._lineDirection, "fill": "none", "stroke-width": this.model.strokeWidth });
            this._pathLineGroupElement.append(this._pathLineElement);
            this._radialSliderWrapper.append(this._radialSVG.append(this._pathLineGroupElement).append(this._textGroupElement).append(this._circleGroupElement));
            if (this.model.autoOpen)
                this.show();
            else
                this.hide();
        },
        //Circel direction calculation
        _circleArcDirection: function (startAngle, endAngle) {
            var radius = (0.5 * Math.min(this._diameter - (this.model.inline ? 100 : 0), this._diameter - (this.model.inline ? 100 : 0)));
            var startPoint = this._polarToCartesian(this._startXY, this._startXY, radius, startAngle),
            endPoint = this._polarToCartesian(this._startXY, this._startXY, radius, endAngle);
           var ArcSweep = endAngle - startAngle <= 180 ? "0" : "1";
            var direction = [
            "M", startPoint.x, startPoint.y,
            "A", radius, radius, 0, ArcSweep, 1, endPoint.x, endPoint.y - 1
            ].join(" ");
            return direction;
        },
        _overNeedleMoveHandler: function (e) {
            e.preventDefault();
            var baseRect = $("#" + this._prefix + this._elementID + "-radial-slider-svg").offset();
            var y2 = e.clientY, x2 = e.clientX, y1 = (baseRect.top + (this._radialWidth / 2)) - $(window).scrollTop(), x1 = baseRect.left + (this._radialWidth / 2);
            this._dynamicAngleCalculation(x1, x2, y1, y2);
            if ((this._angle > (360 - this._endAngle) && this._angle < (360 - this._startAngle))) {
                //Over element
                this.line = {};
                var radius = this.model.radius;
                this.line.X1 = this._startXY;
                this.line.Y1 = this._startXY;
                var cosAngle = Math.cos(this._angle * Math.PI / 180.0);
                var sinAngle = -(Math.sin(this._angle * Math.PI / 180.0));
                this.line.X2 = this._startXY + (radius - 5) * cosAngle;
                this.line.Y2 = this._startXY + (radius - 5) * sinAngle;
                if (this._overLine != undefined)
                    $(this._overLine).attr({ "d": [" M", this.line.X1, this.line.Y1, "L", this.line.X2, this.line.Y2].join(" "), "stroke-width": (this.model.strokeWidth == 1 ? this.model.strokeWidth - 0.5 : this.model.strokeWidth - 1) });
                else
                    this._overLine = this._createSVGElements("path", { "class": this._prefix + "needle-over", "d": [" M", this.line.X1, this.line.Y1, "L", this.line.X2, this.line.Y2].join(" "), "stroke-width": this.model.strokeWidth == 1 ? this.model.strokeWidth - 0.5 : this.model.strokeWidth - 1 });
                this._pathLineGroupElement.append(this._overLine);
                this._isNeedleOver = true;
                var selectValue = this._ticksCalculation();
                if (this.model.mouseover) {
                    this._trigger("mouseover", { value: selectValue, selectedValue: this.value() });
                }
            }
        },
        _needleMoveHandler: function (e) {
             ej.blockDefaultActions(e);
            if (ej.isTouchDevice())
                e = e.touches ? e.touches[0] : e;
            var baseRect = $("#" + this._prefix + this._elementID + "-radial-slider-svg").offset();
            var y2 = e.clientY, x2 = e.clientX, y1 = (baseRect.top + (this._radialWidth / 2)) - $(window).scrollTop(), x1 = baseRect.left + (this._radialWidth / 2);
            this._dynamicAngleCalculation(x1, x2, y1, y2);
            if ((this._angle > (360 - this._endAngle) && this._angle < (360 - this._startAngle))) {
                $(this._overLine).remove();
                this._lineAngleCalculation();
                var index = this._isTapSelected ? this._tickCount + 1 : this._tickCount;
                this._directionLine.remove(index, 1, 1);
                this._dynamicLineCalculation(this._angle, false, true, true, this._tickCount, this._tickCount + 1, false);
                $(this._pathLineElement).attr("d", this._directionLine.toString());
                if (this.model.slide) {
                    var selectValue = this._ticksCalculation();
                    this._trigger("slide", { value: selectValue, selectedValue: this.value() });
                }
                this._needleMove = true;
            }
        },
        _dynamicLineDirection: function (angle, lastValue, isDynamic) {
            var outerLine = {};
            var firstPoint = this._polarToCartesian(this._startXY, this._startXY, (this.model.radius), angle, isDynamic);
            var secondPoint = this._polarToCartesian(this._startXY, this._startXY, (this.model.radius + 10), angle, isDynamic);
            outerLine.X1 = firstPoint.x;
            outerLine.Y1 = firstPoint.y;
            outerLine.X2 = secondPoint.x;
            outerLine.Y2 = secondPoint.y;
            this._isTapSelected = true;
            this._directionLine.insert(lastValue + 2, [" M", outerLine.X1, outerLine.Y1, "L", outerLine.X2, outerLine.Y2].join(" "));
            return this._directionLine.toString();
        },
        _inLineCalculation: function (angle, isDynamic) {
            var line = {};
            var secondPoint = this._polarToCartesian(this._startXY, this._startXY, (this.model.radius - 5), angle, isDynamic);
            line.X1 = this._startXY, line.Y1 = this._startXY, line.X2 = secondPoint.x, line.Y2 = secondPoint.y;
            this._directionLine.append([" M", line.X1, line.Y1, "L", line.X2, line.Y2].join(" "));
            return this._directionLine.toString();
        },

        _dynamicLineCalculation: function (angle, isAppend, isRemove, isInsert, lastValue, insertValue, isOuter) {
            this.line = {};
            var radius = this.model.radius;
            this.line.X1 = this._startXY;
            this.line.Y1 = this._startXY;
            var cosAngle = Math.cos(angle * Math.PI / 180.0);
            var sinAngle = -(Math.sin(angle * Math.PI / 180.0));
            this.line.X2 = this._startXY + (radius - 5) * cosAngle;
            this.line.Y2 = this._startXY + (radius - 5) * sinAngle;
            if (isOuter) {
                this._dynamicLineDirection(angle, lastValue, true);
            }
            if (isAppend) {
                this._directionLine.append([" M", this.line.X1, this.line.Y1, "L", this.line.X2, this.line.Y2].join(" "));
            }
            if (isInsert) {
                this._directionLine.insert(lastValue + 3, [" M", this.line.X1, this.line.Y1, "L", this.line.X2, this.line.Y2].join(" "));
            }
            return this._directionLine.toString();
        },

        _getStringBuilder: function () {
            var data = [];
            var counter = 0;
            return {
                append: function (s) {
                    data[counter++] = s;
                    return this;
                },
                remove: function (i, j, k) {
                    counter = counter - (k || 1);
                    data.splice(i, j || 1);
                    return this;
                },
                insert: function (i, s) {
                    data.splice(i, 0, s);
                    counter++;
                    return this;
                },
                toString: function (s) { return data.join(s || ""); }
            }
        },
        _outerLineCalculation: function (dis1, dis2, length, isOuterLine, isinLine, element) {
            var radius = this.model.radius;
            var startAngle = this._startAngle,
                 endAngle = startAngle + ((this._endAngle - this._startAngle) / (length - 1));
            this._point = ((this._endAngle - this._startAngle) / (length - 1));
            var endValueCal = endAngle,
                startValueCal = endValueCal;
            var textPoints = [];
            this._degPoint = [];
            this._degPoint.push(startAngle);
            if (isOuterLine) {
                for (var j = 0; j < length; j++) {
                    var line = {};
                    startAngle = startAngle * Math.PI / 180.0;
                    endAngle = endAngle * Math.PI / 180.0;
                    this._degPoint.push(endValueCal);
                    if (element != "text") {
                        line.X1 = this._startXY + (radius) * Math.cos(startAngle);
                        line.Y1 = this._startXY + (radius) * Math.sin(startAngle);
                    }
                    line.X2 = this._startXY + (radius + 10) * Math.cos(startAngle);
                    line.Y2 = this._startXY + (radius + 10) * Math.sin(startAngle);
                    startAngle = endValueCal;
                    endAngle = endValueCal + this._point;
                    endValueCal += this._point;
                    element == "path" ? this._directionLine.append([" M", line.X1, line.Y1, "L", line.X2, line.Y2].join(" ")) : textPoints.push(line);
                }
            }
            if (isinLine) {
                for (var i = 0; i < this.ticks().length; i++) {
                    var k = i + 1;
                    var lastValue = i == (this.ticks().length - 1) ? this.ticks()[this.ticks().length - 1] + 0.5 : this.ticks()[k];
                    var firstValue = i == 0 ? this.ticks()[i] - 0.5 : this.ticks()[i];
                    var ticksSecond = firstValue <= 0 && firstValue >= this.value() ? true : false;
                    var ticksFirst = lastValue <= 0 && lastValue <= this.value() ? true : false;
                    var condition = ticksSecond && ticksFirst ? true : (firstValue <= this.value() && this.value() < lastValue);
                    if (condition) {
                        if (this.ticks()[i] != this.value()) {
                            var difference = this._point / (this.ticks()[k] - this.ticks()[i]);
                            var angleDifference = this.ticks()[k] - this.value();
                            this._startValueAngle = this._degPoint[k] - (difference * angleDifference);
                            this._dynamicLineDirection(this._startValueAngle, this._tickCount - 2, false);
                            this._inLineCalculation(this._startValueAngle, false);
                        }
                        else {
                            this._startValueAngle = this._degPoint[i];
                            this._inLineCalculation(this._startValueAngle, false);
                        }
                    }
                }
            }
            this._path = element == "path" ? this._directionLine.toString() : textPoints;
            return this._path;
        },
        _refresh: function () {
            this._destroy();
			if(this.model.enableRoundOff) this.model.value = Math.round(this.model.value);
            this.element.addClass("e-radialslider e-js");			
            this._renderEJControl();
        },
        //events part
        _createDelegates: function () {
            this._touchStartDelegate = $.proxy(this._touchStartHandler, this);
            this._needleMoveDelegate = $.proxy(this._needleMoveHandler, this);
            this._touchEndDelegate = $.proxy(this._touchEndHandler, this);
            this._overNeedleMoveDelegate = $.proxy(this._overNeedleMoveHandler, this);
            this._mouseOutDelegate = $.proxy(this._mouseOutHandler, this);
            this._enterMouseDelegates = $.proxy(this._entermouse, this);
        },
        _wireEvents: function (remove) {
            var eventType = remove ? "off" : "on";
            this._createDelegates();
            ej.listenEvents([this._radialSVG, this._radialSVG, this._radialSVG, this._radialSVG], [ej.endEvent(), ej.startEvent(), "mouseenter", "mouseleave"], [this._touchEndDelegate, this._touchStartDelegate, this._enterMouseDelegates, this._mouseOutDelegate], false);
        },
        _entermouse: function (e) {
            ej.listenEvents([this._radialSVG], [ej.moveEvent()], [this._overNeedleMoveDelegate], false);
        },
        _mouseOutHandler: function (e) {
            e.preventDefault();
            if (this._radialSVG.has(e.target).length == 0 && this._needleMove) {
                ej.listenEvents([this._radialSVG], [ej.moveEvent()], [this._needleMoveDelegate], true);
                var lastAngle = this._previousAngle != undefined ? this._previousAngle : this._startValueAngle;
                this._pathAfterAddLength = this._directionLine.toString().replace(/[^M]/g, "").length;
                this._directionLine.remove(this._pathAfterAddLength - 1, 1);
                this._inLineCalculation(lastAngle, true);
                $(this._pathLineElement).attr("d", this._directionLine.toString());
                this._needleMove = false;
            }
            $(this._overLine).remove();
        },
        _touchEndHandler: function (e) {
            e = e.touches ? e.changedTouches[0] : e;
            ej.listenEvents([this._radialSVG], [ej.moveEvent()], [this._needleMoveDelegate], true);
            this._tapHandlerEvent(e);
        },
        _touchStartHandler: function (e) {
            ej.blockDefaultActions(e);
            if (ej.isTouchDevice())
                e = e.touches ? e.touches[0] : e;
            this._needleStop = false;
            if (this.model.start)
                this._trigger("start", { value: this.value() });
            ej.listenEvents([this._radialSVG], [ej.moveEvent()], [this._needleMoveDelegate], false);
        }

    })
    $.extend(true, ej.RadialSlider.prototype, ej.RadialSliderBase.prototype);
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    ej.widget("ejTreeView", "ej.TreeView", {
        _rootCSS: "e-treeview",

        element: null,

        model: null,

        validTags: ["ul", "div"],
        _addToPersist: ["expandedNodes", "checkedNodes", "selectedNodes"],
       
        _setFirst: false,

        _requiresID: true,

        defaults: {

            allowMultiSelection: false,

            showCheckbox: false,

            enableAnimation: true,

            allowDragAndDrop: false,

            htmlAttributes: {},

            allowDropChild: true,

            allowDropSibling: true,

            allowDragAndDropAcrossControl: true,

            allowEditing: false,

            allowKeyboardNavigation: true,

            items: null,

            fields: {

                dataSource: null,

                query: null,

                tableName: null,

                child: null,

                id: "id",

                parentId: "parentId",

                text: "text",

                spriteCssClass: "spriteCssClass",

                expanded: "expanded",

                hasChild: "hasChild",

                selected: "selected",

                linkAttribute: "linkAttribute",

                imageAttribute: "imageAttribute",

                htmlAttribute: "htmlAttribute",

                imageUrl: "imageUrl",

                isChecked: "isChecked"

            },

            autoCheckParentNode: false,

            loadOnDemand: false,

            cssClass: "",

            template: null,

            enableRTL: false,

            expandOn: "dblclick",

            enablePersistence: false,

            enabled: true,

            expandedNodes: [],

            checkedNodes: [],

            selectedNode: -1,

            selectedNodes: [],

            width: null,

            height: null,

            autoCheck: true,

            enableMultipleExpand: true,

            fullRowSelect: false,

            sortSettings: {

                allowSorting: false,

                sortOrder: "ascending",

            },

            nodeClick: null,

            beforeExpand: null,

            nodeExpand: null,

            beforeCollapse: null,

            nodeCollapse: null,

            beforeSelect: null,

            nodeSelect: null,

            nodeUnselect: null,

            nodeCheck: null,

            nodeUncheck: null,

            inlineEditValidation: null,

            beforeEdit: null,

            nodeEdit: null,

            keyPress: null,

            nodeDragStart: null,

            nodeDrag: null,

            nodeDragStop: null,

            nodeDropped: null,

            beforeAdd: null,

            nodeAdd: null,

            beforeDelete: null,

            nodeDelete: null,

            beforeCut: null,

            nodeCut: null,

            beforePaste: null,

            nodePaste: null,

            beforeLoad: null,

            loadSuccess: null,

            loadError: null,

            ready: null,

            create: null,

            destroy: null

        },

        dataTypes: {

            allowMultiSelection: "boolean",

            cssClass: "string",

            showCheckbox: "boolean",

            enableAnimation: "boolean",

            allowDragAndDrop: "boolean",

            allowDropChild: "boolean",

            allowDragAndDropAcrossControl: "boolean",

            allowEditing: "boolean",

            allowKeyboardNavigation: "boolean",

            autoCheckParentNode: "boolean",

            loadOnDemand: "boolean",

            enableRTL: "boolean",

            expandOn: "string",

            enablePersistence: "boolean",

            enableMultipleExpand: "boolean",

            fullRowSelect: "boolean",

            items: "data",

            fields: {

                dataSource: "data",

                query: "data",

                child: "data"

            },

            expandedNodes: "array",

            checkedNodes: "array",

            selectedNode: "number",

            selectedNodes: "array",

            htmlAttributes: "data",

            sortSettings: {

                allowSorting: "boolean",

                sortOrder: "enum",

            }
        },

        observables: ["fields.dataSource"],

        dataSource: ej.util.valueFunction("fields.dataSource"),

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "allowMultiSelection":
                        this.model.allowMultiSelection = options[key];
                        if (!this.model.allowMultiSelection) {
                            var sleNode = $(this._liList[this.model.selectedNodes[0]]);
                            this._unselectAll();
                            this._isRender = false;
                            this._nodeSelectionAction(sleNode);
                            this._isRender = true;
                        }
                        break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "fields":
                        if (this._deepWatch && !ej.isNullOrUndefined(options[key]["dataSource"]) && (JSON.stringify(this._oldDataSource) == JSON.stringify(typeof options[key]["dataSource"] == "function" ? options[key]["dataSource"]() : options[key]["dataSource"])))
                            return;
                        this._unWireEvents();
                        var tempUl, f = this.element.hasClass("e-js") ? false : true, element = f ? this.element.children("ul") : this.element;
                        element.empty();
                        if (this.model.fields == null || options[key] == null)
                            this.model.fields = options[key];
                        else
                            this._extendFields(this.model.fields, options[key]);
                        this.model.expandedNodes = [];
                        this.model.checkedNodes = [];
                        this.model.selectedNodes = [];
                        this.model.selectedNode = -1;
                        this._persistValues(this.model.expandedNodes, "expandedNodes");
                        this._persistValues(this.model.checkedNodes, "checkedNodes");
                        this._persistValues(this.model.selectedNodes, "selectedNodes");
                        this._newDataSource = this.dataSource();
                        (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) ? this._checkDataBinding() : this._initialize();
                        if (f) {
                            tempUl = this.element.children(".e-treeview-ul");
                            element.append(tempUl.children());
                            tempUl.remove();
                        }
                        break;
                    case "allowDragAndDropAcrossControl":
                        this.model.allowDragAndDropAcrossControl = options[key];
                        this._enableDragDrop();
                        break;
                    case "enabled": this._enabledAction(options[key]); break;
                    case "showCheckbox":
                        if (options[key]) {
                            this.model.showCheckbox = options[key];
                            this._showCheckBox();
                            (!this.model.enabled) && this.element.find('.nodecheckbox').ejCheckBox("disable");
                        } else {
                            this.element.find('.e-item > div > .e-chkbox-wrap').remove();
                            this._updateCheckedNodes();
                        }
                        break;
                    case "autoCheck": this.model.autoCheck = options[key]; break;
                    case "autoCheckParentNode": this.model.autoCheckParentNode = options[key]; break;
                    case "expandedNodes":
                        var len = options[key].length, temp = JSON.parse(JSON.stringify(this.model.expandedNodes));
                        if (len > 0) {
                            this._expandNodes(options[key]);
                            for (var i = 0, len = temp.length; i < len; i++) {
                                if (options[key].indexOf(temp[i]) == -1) {
                                    this._collpaseNode($(this._liList[temp[i]]));
                                }
                            }
                        } else
                             (len == 0) && this._collapseAll();
                        options[key] = this.model.expandedNodes;
                        break;
                    case "checkedNodes":
                        if (this.model.showCheckbox) {
                            var len = options[key].length, temp = JSON.parse(JSON.stringify(this.model.checkedNodes));
                            if (len > 0) {
                                this._checkedNodes(options[key]);
                                for (var i = 0, len = temp.length; i < len; i++)
                                    (options[key].indexOf(temp[i]) == -1) && this._nodeUncheck($(this._liList[temp[i]]).find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                            } else
                                 (len == 0) && this._uncheckAll();
                        }
                        options[key] = this.model.checkedNodes;
                        break;
                    case "expandOn":
                        this._off(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : this.model.expandOn, this._expandEventHandler);
                        this._assignTouchExpandOn(options[key]);
                        this._on(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : options[key], this._expandEventHandler);
                        break;
                    case "allowEditing":
                        this._preventEditable();
                        (options[key]) && this._allowEditable();
                        break;
                    case "allowKeyboardNavigation":
                        var action = (options[key]) ? "_on" : "_off";
                        this[action](this.element, 'keydown', this._KeyPress);
                        break;
                    case "allowDragAndDrop":
                        this.model.allowDragAndDrop = options[key];
                        (options[key]) ? this._addDragableClass() : this._preventDraggable();
                        break;
                    case "allowDropChild":
                        this.model.allowDropChild = options[key];
                        (options[key]) ? this._addDragableClass() : this._preventDropChild();
                        break;
                    case "allowDropSibling":
                        this.model.allowDropSibling = options[key];
                        (options[key]) ? this._addDragableClass() : this._preventDropSibling();
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[key];
                        var action, ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
                        action = (this.model.enableRTL) ? "addClass" : "removeClass";
                        ele[action]("e-rtl");
                        break;
                    case "height": this.element.is("ul") ? this.element.parent().height(options[key]) : this.element.height(options[key]); break;
                    case "width": this.element.is("ul") ? this.element.parent().width(options[key]) : this.element.width(options[key]); break;
                    case "selectedNode":
                    case "selectedNodes":
                        this.model.selectedNodes = (key == "selectedNode") ? [options[key]] : options[key];
                        this.element.find('a.e-text.e-active').removeClass('e-node-focus e-active').closest('li').attr("aria-selected", false);
                        this._doSelectNodes(this.model.selectedNodes, false);
                        if (key != "selectedNode") options[key] = this.model.selectedNodes;
                        break;
                    case "htmlAttributes": this._addAttr(options[key]); break;
                    case "enableMultipleExpand":
                        (!options[key]) && this.collapseAll();
                        this.model.enableMultipleExpand = options[key];
                        break;
                    case "sortSettings":
                        $.extend(this.model.sortSettings, options[key]);
                        if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                            this.model.expandedNodes = [];
                            this.model.checkedNodes = [];
                            this.model.selectedNodes = [];
                            this._checkDataBinding();
                        }
                        break;
                    case "fullRowSelect":
                        this._wholeRowEvents("_off");
                        this.model.fullRowSelect = options[key];
                        this.model.fullRowSelect ? this._addWholeRowWrap() : this._removeWholeRowWrap();
                        this._doWholeRowAction();
                        this._wholeRowEvents("_on");
                        break;
                }
            }
        },

        _destroy: function () {
            this.element.html("");
            this._cloneElement.removeClass('e-treeview e-js e-treeview-wrap');
            var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
            ele.replaceWith(this._cloneElement);
            $("#" + this._id + "_WaitingPopup").remove();
            if (window.localStorage) {
                window.localStorage.removeItem(this._id + "_childNodes");
                window.localStorage.removeItem(this._id + "_persistedValues");
            }
            else if (window.cookie) {
                document.cookie = this._id + "_childNodes=; expires=Thu, 01 Jan 1970 00:00:00 UTC";
                document.cookie = this._id + "_persistedValues=; expires=Thu, 01 Jan 1970 00:00:00 UTC";
            }
        },

        _init: function () {
            this._cloneElement = this.element.clone(), this._dataSource = [], this._fragment = [], this._templateType = "", this._indexID = 0, this._newDataSource = this.dataSource(), this._id = this.element.prop("id"), this._treeList = [], this._isTextbox = false;
            this._isDevice = this._checkDevice();
            this._deepWatch = this.element.attr("e-deepwatch") === "true";
            var browserInfo = ej.browserInfo();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._oldDataSource = JSON.parse(JSON.stringify(this.dataSource()));
            this._assignTouchExpandOn(this.model.expandOn);
            if (this.model.enablePersistence) {
                var cookieData = this._getCookies("_persistedValues");
                if (!cookieData) {
                    var obj = { selectedNodes: [], expandedNodes: [], checkedNodes: [] };
                    obj = this._updatePersistAttr(obj);
                    this._setCookies("_persistedValues", JSON.stringify(obj));
                }
            }
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                this._checkDataBinding();
            } else {
                this._initialize();
                this._completeRendering();
            }
        },

        _initialize: function () {
            this._cutNode = null, this._beforeEditText = null, this._CurrenctSelectedNodes = [], this._isLoaded = false;
            this._renderMultiTouchDialog();
            if (this.element.is("ul")) {
                this._createWrapper();
            }
            else {
                this.element.addClass("e-treeview-wrap e-widget").attr("tabindex", 0)
                            .children('ul:first').addClass("e-ul e-box");
                (this.model.width != null) && this.element.width(this.model.width);
                (this.model.height != null) && this.element.height(this.model.height);
                (this.model.enableRTL) && this.element.addClass("e-rtl");
                (this.model.cssClass != null) && this.element.addClass(this.model.cssClass);
                this._addAttr(this.model.htmlAttributes);
            }
            this._elementSettings();
            this._beforeBaseClass();
            if (this.dataSource() == null) {
                this._addBaseClass();
                this._controlRender();
            }
            this._addWholeRowWrap();
            if (this._isIE8)
                (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap').addClass("e-ie8") : this.element.addClass("e-ie8");
            this._finalize();
        },

        _completeRendering: function () {
            if (this._treeList.length == 0 && !this._isLoaded) {
                this._finalizeNode();
                this._enabledAction(this.model.enabled);
                this._triggerEvent('ready', { element: this.element[0] });
                this._isLoaded = true;
            }
        },

        _addWholeRowWrap: function () {
            if (this.model.fullRowSelect)
                (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap').addClass("e-fullrow-wrap") : this.element.addClass("e-fullrow-wrap");
        },

        _removeWholeRowWrap: function () {
            (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap').removeClass("e-fullrow-wrap") : this.element.removeClass("e-fullrow-wrap");
        },

        _doWholeRowAction: function () {
            if (this.model.fullRowSelect) {
                for (var i = 0, len = this._liList.length; i < len; i++) {
                    var element = $(this._liList[i]);
                    if (element[0] != null) {
                        var txtEle = element.find("> .e-text-wrap");
                        this._renderWholeRow(element, txtEle);
                    }
                }
            }
            else
                this.element.find(".e-fullrow").remove();
        },

        _renderWholeRow: function (element, nestedEle) {
            if (!element) return;
            if (this.model.fullRowSelect) {
                var absolutediv = document.createElement('div');
                absolutediv.setAttribute('class', 'e-fullrow');
                nestedEle ? $(absolutediv).insertAfter(nestedEle) : element[0].appendChild(absolutediv);
            }
        },

        _extendFields: function (mapper, value) {
            if (mapper == null || value == null)
                mapper = value;
            else if (mapper.child == null || value['child'] == null)
                $.extend(mapper, value);
            else {
                this._extendFields(mapper.child, value['child']);
                var tempField = mapper.child;
                $.extend(mapper, value);
                $.extend(mapper.child, tempField);
            }
        },

        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },

        _assignTouchExpandOn: function (expandon) {
            if (expandon == "dblclick")
                this._touchExpandOn = "doubletap";
            else if (expandon == "click")
                this._touchExpandOn = "tap";
            else
                this._touchExpandOn = expandon;
        },

        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-fe-popup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSelection) {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
            this._on($content, (this._isDevice && $.isFunction($.fn.tap)) ? "touchstart" : "mousedown", this._popupClick);
        },

        _popupClick: function () {
            var $selElement = this._customPop.find(".e-rowselect");
            if ($selElement.hasClass("e-spanclicked")) {
                this._hidePopup();
            }
            else {
                this._isPopup = true;
                $selElement.addClass("e-spanclicked");
            }
        },

        _hidePopup: function () {
            if (this._customPop != null && this._customPop.is(":visible")) {
                this._customPop.find(".e-rowselect").removeClass("e-spanclicked");
                this._customPop.hide();
                this._isPopup = false;
            }
        },

        _elementSettings: function () {
            var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
            (this.element.is("ul")) ? ele.attr("role", "tree") : ele.attr("aria-activedescendant", this._id + "_active").children('ul:first').attr("role", "tree");
        },

        _beforeBaseClass: function () {
            var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap')[0] : this.element[0];
            this._ulList = $(ele.querySelectorAll('ul'));
            this._liList = $(ele.querySelectorAll('li'));
        },

        _createWrapper: function () {
            var mainWidget = ej.buildTag("div.e-treeview-wrap e-widget " + this.model.cssClass, "", "", { tabindex: 0, "aria-activedescendant": this._id + "_active" });
            (this.model.width != null) && mainWidget.width(this.model.width);
            (this.model.height != null) && mainWidget.height(this.model.height);
            (this.model.enableRTL) && mainWidget.addClass("e-rtl");
            mainWidget.insertAfter(this.element);
            mainWidget.append(this.element.addClass("e-ul e-box").attr("tabindex", 0));
            this._addAttr(this.model.htmlAttributes);
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._enabledAction(false);
                else proxy.element.attr(key, value)
            });
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
                ele.removeClass(this.model.cssClass).addClass(skin);
                ele.find('.e-item > div > .e-chkbox-wrap').removeClass(this.model.cssClass).addClass(skin);
                this._waitingPopup && this._waitingPopup.option("cssClass", skin);
            }
        },

        _enabledAction: function (flag) {
            this.model.enabled = flag;
            if (flag) {
                this.element.removeClass("e-disable");
                this._wireEvents();
            }
            else {
                this.element.addClass("e-disable");
                this._unWireEvents();
            }
        },

        _checkDataBinding: function () {
            if (this.dataSource() instanceof ej.DataManager) {
                this._initDataSource();
            } else {
                this._ensureDataSource(this.dataSource());
                this._initialize();
                this._completeRendering();
            }
        },

        _initDataSource: function () {
            this.element.ejWaitingPopup({ cssClass: this.model.cssClass });
            this._waitingPopup = this.element.ejWaitingPopup("instance");
            this._waitingPopup.maindiv.addClass("e-tree-popup");
            var proxy = this, queryPromise, queryManager;
            this.element.ejWaitingPopup("refresh");
            this.element.ejWaitingPopup("show");
            queryManager = this._columnToSelect(this.model.fields);
            queryPromise = this.dataSource().executeQuery(queryManager);
            queryPromise.done(function (e) {
                proxy.element.ejWaitingPopup("hide");
                proxy.retriveData = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                proxy._typeOfFieldId = proxy.retriveData[0] ? (typeof (proxy.retriveData[0][proxy.model.fields.id])).toLowerCase() : "";
                proxy._ensureDataSource(proxy.retriveData);
                proxy._initialize();
                if (proxy.model.loadOnDemand || ej.isNullOrUndefined(proxy.model.fields["child"])) {
                    proxy._completeRendering();
                }
            });
        },

        _columnToSelect: function (mapper) {
            var column = [], queryManager = ej.Query();
            if (!mapper.query && !ej.isNullOrUndefined(mapper.tableName)) {
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "child" && col !== "dataSource" && mapper[col])
                        column.push(mapper[col]);
                }
                (column.length > 0) && queryManager.select(column);
                if (!this.dataSource().dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = (mapper.query) ? mapper.query : queryManager;
            return queryManager;
        },

        _ensureDataSource: function (dataSource) {
            dataSource = this._getSortAndFilterList(this.model.fields, dataSource);
            this.currentSelectedData = dataSource;
            this._renderTemplate(dataSource);
            (this.element.is("ul")) ? this.element.html(this._fragment.firstChild.children) : this.element.html(this._fragment);
        },

        _getTemplateType: function (ds, mapper) {
            for (var i = 0, len = ds.length; i < len; i++) {
                if (ds[i].hasOwnProperty(mapper.parentId) || ds[i].hasOwnProperty(mapper.hasChild)) return 1;
                if (ds[i].hasOwnProperty('child')) return 2;
            }
            return 1;
        },

        _groupingObjects: function (array, f) {
            var childs = {}, keys = [];
            for (var i = 0, len = array.length; i < len; i++) {
                var child = JSON.stringify(f(array[i]));
                childs[child] = childs[child] || [];
                childs[child].push(array[i]);
            }
            for (var i in childs)
                keys.push(childs[i]);
            return keys;
        },

        _renderTemplate: function (item) {
            this._onlineData = false, this._loadOnDemandNodes = false;
            var proxy = this;
            this._templateType = this._getTemplateType(item, this.model.fields);
            this._dataSource = (this._templateType == 1) ? this._groupingObjects(item, function (item) { return [!ej.isNullOrUndefined(item) && [item[proxy.model.fields.parentId]].toString()]; }) : item;
            this._templateNodeCreation(item, this.model.fields);
        },

        _templateNodeCreation: function (data, mapper) {
            this._fragment = document.createDocumentFragment();
            var ulTag = document.createElement('ul'), fragment;
            this._fragment.appendChild(ulTag);
            fragment = this._fragment.firstChild;
            if (this._onlineData || this._loadOnDemandNodes) {
                fragment.className = "e-treeview-ul";
                fragment.setAttribute('role', "group");
                $(fragment).attr('style', 'display:none');
            }
            if (this.dataSource() != null) {
                for (var i = 0, objlen = data.length; i < objlen; i++) {
                    if (data[i]) {
                        if (ej.isNullOrUndefined(data[i][this.model.fields.parentId]) || data[i][this.model.fields.parentId] == 0 || this._loadOnDemandNodes)
                            fragment.appendChild(this._genTemplate(data[i], mapper));
                    }
                }
                $(fragment).find('.e-item:first-child:not(:last-child)').addClass('first');
                $(fragment).find('.e-item:last-child').addClass('last');
            }
        },

        _onlineDataSource: function (childItems, id, mapper) {
            this._loadOnDemandNodes = true;
            this._templateNodeCreation(childItems, mapper);
            var element = this.element.find('.e-item#' + id);
            if (element[0] != null) {
                $(element[0]).append(this._fragment);
                element.children().find('> div:first').addClass("e-icon e-plus");
                this._finalizeLoadOnDemand(element);
            }
            this._onlineData = false;
        },

        _genTemplate: function (item, mapper) {
            var liFrag = document.createDocumentFragment(), liEle, liTag, imgTag, aTag, childItems;
            liTag = document.createElement('li');
            liFrag.appendChild(liTag);
            liEle = liFrag.firstChild;
            liEle.id = (item[mapper.id]) ? item[mapper.id] : "";
            liEle.setAttribute('role', "treeitem");
            (item[mapper.htmlAttribute]) && this._setAttributes(item[mapper.htmlAttribute], liEle);
            liEle.className += ' e-item';
            aTag = document.createElement('a');
            if (item[mapper.imageUrl]) {
                imgTag = document.createElement('img');
                imgTag.className = "e-align";
                imgTag.src = item[mapper.imageUrl];
                (item[mapper.imageAttribute]) && this._setAttributes(item[mapper.imageAttribute], imgTag);
            }
            else if (item[mapper.spriteCssClass]) {
                imgTag = document.createElement('span');
                imgTag.className = item[mapper.spriteCssClass];
            }
            if (this.model.template) {
                (imgTag) && aTag.appendChild(imgTag);
                if (typeof $.fn.render != "function") throw "Error : JsRender dependecy script missing";
                aTag.innerHTML += this._renderEjTemplate(this.model.template, item);
            }
            else {
                (item[mapper.text]) ? $(aTag).text(item[mapper.text]) : $(aTag).text("undefined");
                (imgTag) && aTag.insertBefore(imgTag, aTag.lastChild);
            }
            (item[mapper.linkAttribute]) && (typeof item[mapper.linkAttribute] == "object" ? this._setAttributes(item[mapper.linkAttribute], aTag) : aTag.href = item[mapper.linkAttribute]);
            liEle.appendChild(aTag);
            (item[mapper.expanded]) && (liEle.className += ' expanded');
            (item[mapper.selected]) && (liEle.className += ' selected');
            if (!ej.isNullOrUndefined(item[mapper.isChecked]))
                liEle.className += (item[mapper.isChecked]) ? ' checked' : ' unchecked';
            liEle.setAttribute('aria-selected', false);
            liEle.setAttribute('aria-expanded', false);
            if (this.dataSource() instanceof ej.DataManager) {
                this._updateElement(liEle, true);
                this.model.showCheckbox && this._checkboxOnTemplate(liEle.children[0]);
                if (!this.model.loadOnDemand) {
                    if (!ej.isNullOrUndefined(mapper["child"]) && mapper["child"]["dataSource"] instanceof ej.DataManager) {
                        var proxy = this, queryPromise, pid, id;
                        pid = (mapper["child"]["parentId"]) ? mapper["child"]["parentId"] : proxy.model.fields.parentId, id;
                        id = (mapper.id) ? mapper.id : this.model.fields.id;
                        this._treeList.push("false");
                        queryPromise = this._executeDataQuery(mapper["child"], pid, (this._typeOfFieldId == "number" ? parseInt(item[id]) : item[id]));
                        queryPromise.done(function (e) {
                            proxy._treeList.pop();
                            childItems = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                            childItems = proxy._getSortAndFilterList(mapper.child, childItems);
                            if (childItems && childItems.length > 0) {
                                proxy._onlineData = true;
                                proxy._onlineDataSource(childItems, childItems[0][mapper["child"]["parentId"]], mapper.child);
                            }
                            if (proxy._treeList.length == 0) {
                                proxy._completeRendering();
                            }
                        });
                    } else if (ej.isNullOrUndefined(this.model.fields["child"])) {
                        this._childNodeCreation(item, liEle, mapper);
                    }
                }
                else {
                    if (item[mapper.hasChild] || item.hasOwnProperty('child'))
                        liEle.children[0].firstChild.className = "e-icon e-plus";
                }
            }
            else if (this.model.loadOnDemand) {
                this._updateElement(liEle, true);
                if (item[mapper.hasChild] || item.hasOwnProperty('child'))
                    liEle.children[0].firstChild.className = "e-icon e-plus";
                this.model.showCheckbox && this._checkboxOnTemplate(liEle.children[0]);
                (item[mapper.expanded]) && this._childNodeCreation(item, liEle, mapper);
                if (this.model.enablePersistence) {
                    var value, childObj;
                    value = this._getCookies("_childNodes");
                    if (value) {
                        childObj = JSON.parse(value);
                        for (var i = 0, objlen = childObj.length; i < objlen; i++) {
                            if (childObj[i].toString() == item[mapper.id].toString()) {
                                this._childNodeCreation(item, liEle, mapper);
                                break;
                            }
                        }
                    }
                }
            }
            else if (!this._onlineData) {
                this._updateElement(liEle, true);
                this.model.showCheckbox && this._checkboxOnTemplate(liEle.children[0]);
                this._childNodeCreation(item, liEle, mapper);
            }
            return liEle;
        },

        _childNodeCreation: function (item, liEle, mapper) {
            var childItems, tempFrag, ul, tFrag;
            childItems = (this._templateType == 2) ? (!ej.isNullOrUndefined(item.child) && item.child.length > 0) && item.child : this._getChildNodes(this._dataSource, { id: item[mapper.id] });
            if (!ej.isNullOrUndefined(childItems) && childItems.length > 0) {
                liEle.children[0].firstChild.className = "e-icon e-plus";
                tempFrag = document.createDocumentFragment();
                ul = document.createElement('ul');
                tempFrag.appendChild(ul);
                tFrag = tempFrag.firstChild;
                tFrag.className = "e-treeview-ul";
                tFrag.setAttribute('role', "group");
                $(tFrag).attr('style', 'display:none');
                for (var i = 0, objlen = childItems.length; i < objlen; i++)
                    (childItems[i]) && ([childItems[i]][this.model.fields.parentId] != 0) && tFrag.appendChild(this._genTemplate(childItems[i], mapper));
                liEle.appendChild(ul);
            }
        },

        _checkboxOnTemplate: function (element) {
            if (element.parentElement.id == "") {
                element.parentElement.id = this._id + "_" + this._indexID;
                this._indexID++;
            }
            var checkbox = document.createElement('input');
            checkbox.setAttribute('type', 'checkbox');
            checkbox.setAttribute('class', 'nodecheckbox');
            checkbox.setAttribute('name', this._id + "_Checkbox_" + element.parentElement.id);
            checkbox.setAttribute('value', element.parentElement.id);
            element.insertBefore(checkbox, element.children[1]);   // Checkbox to be inserted after the expand/collapse div            
        },

        _updateElement: function (liElement, subItem) {
            var outerdiv, exCollpasediv, linkElement, spanTag, node = liElement.firstChild, firstchild, nodeText, nText,textElement;
            if (node) {
                firstchild = node.nodeName;
                if (firstchild == 'SPAN' || firstchild == 'IMG') {
                    spanTag = node;
                    linkElement = liElement.lastChild;
                }
                else
                    linkElement = liElement.lastChild;
                if (linkElement) {
                    nText = (linkElement.lastChild != null) ? linkElement.lastChild.nodeValue : "";
                    nodeText = $.trim(linkElement.innerHTML);
                    textElement = $(linkElement).clone()[0];
                    $(linkElement).remove();
                    textElement.className += " e-text CanSelect";
                    textElement.innerHTML = nodeText;
                    liElement.innerHTML = '';
                }

                outerdiv = document.createElement('div');
                outerdiv.setAttribute('class', 'e-text-wrap');
                outerdiv.setAttribute('role', "presentation");
                if (subItem) {
                    exCollpasediv = document.createElement('div');
                    exCollpasediv.setAttribute('role', "presentation");
                    outerdiv.appendChild(exCollpasediv);
                }
                (spanTag) && outerdiv.appendChild(spanTag);
                outerdiv.appendChild(textElement);
                ($(liElement).prop('name') == undefined) && $(liElement).prop('name', $.trim(nText));
                liElement.appendChild(outerdiv);
                this._renderWholeRow($(liElement));
            }
        },

        _setAttributes: function (data, element) {
            for (var key in data) {
                $(element).attr(key, data[key]);
            }
        },

        _addDragableClass: function () {
            if (this.model.allowDragAndDrop) {
                this._anchors = this._liList.map(function () {
                    return $("a.e-text", this)[0];
                });
                this._anchors.addClass("e-draggable e-droppable");
                this._enableDragDrop();
                this._on(this.element, "mouseup touchstart pointerdown MSPointerDown", this._anchors, this._focusElement);
            }
        },

        _addBaseClass: function () {
            this._ulList.addClass("e-treeview-ul").attr("role", "group");
            this._liList.addClass("e-item").attr("role", "treeitem");
            if (!this.element.is("ul"))
                this.element.find("ul:first").removeClass("e-treeview-ul").addClass('e-ul');
        },

        _controlRender: function () {
            var element = this.element, licoll;
            if (element != null) {
                licoll = element.find('.e-item');
                for (var i = 0; i < licoll.length; i++) {
                    var listEl = $(licoll[i]), textElement, customElement, nodeText, subItems, linkElement, span, exCollpasediv, outerdiv;
                    subItems = listEl.children('ul')[0];
                    if (subItems)
                        $(listEl.children('ul')[0]).remove();
                    linkElement = listEl.children('a')[0];
                    if (linkElement) {
                        nodeText = $.trim($(linkElement).text());
                        textElement = $(linkElement).clone();
                        $(linkElement).remove();
                        customElement = listEl.clone();
                        $(textElement).prepend(customElement.children());
                        $(textElement).addClass('e-text CanSelect');
                        listEl.html('');
                    }
                    else {
                        nodeText = $.trim(this._getText(listEl));
                        customElement = listEl.clone();
                        listEl.html('');
                        textElement = ej.buildTag("a.e-text CanSelect", "", "", { alt: "" });
                        textElement.append(customElement.children());
                        textElement[0].innerHTML += nodeText;
                    }
                    exCollpasediv = ej.buildTag('div', "", {}, { role: "presentation" });
                    outerdiv = ej.buildTag('div.e-text-wrap', "", {}, { role: "presentation" });
                    $(outerdiv).append(exCollpasediv).append(textElement);
                    listEl.prepend(outerdiv);
                    this._renderWholeRow(listEl);
                    if (subItems)
                        listEl.append(subItems);
                    (listEl.prop('name') == undefined) && listEl.prop('name', nodeText);
                    (this.model.showCheckbox) && this._checkboxOnTemplate(licoll[i].children[0]);
                }
                if (this.model.showCheckbox)
                    element.find(".nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            }
            var liCollection = element.find('.e-item'), acollection;
            liCollection.find('>ul').hide();
            acollection = liCollection.find('.e-text');
            acollection.focus(function () {
                $(this).blur();
            });
            liCollection.filter('.e-item:last-child').addClass('last');
            $(liCollection[0]).addClass('first');
            if ($(liCollection[0]).hasClass('first') && $(liCollection[0]).hasClass('last'))
                $(liCollection[0]).removeClass('first');
            $(liCollection.filter(':has(ul)')).each(function () {
                $(this).attr("aria-expanded", false).attr("aria-selected", false)
                var liHasul = $(this).children('ul:first');
                if ($(liHasul).is(':hidden')) {
                    $(this).find('> div > div:first').removeClass('e-icon e-minus').addClass('e-icon e-plus');
                }
                else {
                    $(this.childNodes[1]).removeClass('e-icon e-plus').addClass('e-icon e-minus');
                }
            });
        },

        _getText: function (element) {
            return $(element)
                      .clone()
                      .children()
                      .remove()
                      .end()
                      .text();
        },

        _expandNodes: function (indexColl, _isIdBase) {
            var len = indexColl.length, element = [], temp;
            for (var i = 0; i < len; i++) {
                element = _isIdBase ? this._getNodeByID(indexColl[i]) : $(this._liList[indexColl[i]]);
                if (ej.isNullOrUndefined(element)) continue;
                if (!this.model.enableMultipleExpand) {
                    var distinctEle = element.siblings().find(">div>.e-minus").closest(".e-item");
                    if (distinctEle.length > 0) continue;
                }
                if (this.isExpanded(element)) continue;
                if (this.model.loadOnDemand && !(this.dataSource() instanceof ej.DataManager))
                    this._createChildNodesWhenExpand(element);
                else
                    this._expandNode(element);
            }
        },

        _checkedNodes: function (indexColl) {
            var node;
            if (indexColl.length > 0) this._removeField(this._newDataSource, this.model.fields.isChecked);
            for (var j = 0, len = indexColl.length; j < len; j++) {
                node = $(this._liList[indexColl[j]]);
                (node[0] != null) && this._nodeCheck(node.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
            }
        },

        _finalize: function () {
            if (this.model.showCheckbox)
                this.element.find('.e-item > div .nodecheckbox').ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            this.model.allowEditing && this._allowEditable();
        },

        _finalizeNode: function () {
            this._isRender = false;
            this._allowOnDemand = true;
            var thisElement = this.element, cookieData = this._getCookies("_persistedValues"), idColl = [], id = 0, element = [], expandList, parsedData, temp;
            if (!(this.model.expandedNodes instanceof Array && this.model.expandedNodes.length > 0)) {
                expandList = thisElement.find("li.expanded"), len = expandList.length;
                for (var i = 0; i < len; i++) {
                    var expandEle = $(expandList[i]);
                    if (!this.model.enableMultipleExpand) {
                        var distinctEle = expandEle.siblings().find(">div>.e-minus").closest(".e-item");
                        if (distinctEle.length > 0) continue;
                    }
                    this._expandNode(expandEle);
                }
            }
            if (cookieData)
                parsedData = JSON.parse(cookieData), idColl = parsedData.expandedNodes, element = [];
            if (idColl && idColl.length > 0 && !ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                for (var i = 0, len = idColl.length; i < len; i++) {
                    element = this.element.find('.e-item#' + idColl[i]);
                    if (element[0] != null) {
                        if (!this.model.enableMultipleExpand) {
                            var distinctEle = element.siblings().find(">div>.e-minus").closest(".e-item");
                            if (distinctEle.length > 0) continue;
                        }
                        if (this.model.loadOnDemand && !(this.dataSource() instanceof ej.DataManager))
                            this._createChildNodesWhenExpand(element);
                        else
                            this._expandNode(element);
                    }
                }
            } else {
                temp = JSON.parse(JSON.stringify(this.model.expandedNodes));
                this._expandNodes(temp);
            }
            if (this.model.showCheckbox) {
                if (cookieData)
                    parsedData = JSON.parse(cookieData), idColl = parsedData.checkedNodes, element = [];
                if (idColl && idColl.length > 0 && !ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                    this._removeField(this._newDataSource, this.model.fields.isChecked);
                    for (var i = 0, len = idColl.length; i < len; i++) {
                        element = this.element.find('.e-item#' + idColl[i]);
                        if (element[0] != null)
                            this._nodeCheck(element.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                    }
                } else {
                    temp = JSON.parse(JSON.stringify(this.model.checkedNodes));
                    this._checkedNodes(temp);
                }
            }
            if (!(this.model.checkedNodes instanceof Array && this.model.checkedNodes.length > 0))
                this.model.showCheckbox && this._isCheckedAction();
            var _isIdBase = false;
            if (cookieData) {
                parsedData = JSON.parse(cookieData), idColl = parsedData.selectedNodes;
                _isIdBase = true;
            }
            if (!cookieData || (idColl && idColl.length == 0)) {
                idColl = this.model.selectedNodes.length > 0 ? this.model.selectedNodes : (this.model.selectedNode == -1 ? [] : [this.model.selectedNode]);
                _isIdBase = false;
            }
            var data = { ctrlKey: true };
            if (idColl && idColl.length > 0)
                this._doSelectNodes(idColl, _isIdBase);
            else
                this._isSelectedAction(data);
            this._isRender = true;
            this._allowOnDemand = false;
            thisElement.find('.e-item.checked, .e-item.expanded, .e-item.selected').removeClass("checked expanded selected");
        },

        _doSelectNodes: function (idColl, _isIdBase) {
            var data = { ctrlKey: true };
            for (var i = 0, len = idColl.length; i < len; i++) {
                var element = _isIdBase ? this._getNodeByID(idColl[i]) : $(this._liList[idColl[i]]);
                if (element[0] != null)
                    this._nodeSelectionAction(element, data);
                if (!this.model.allowMultiSelection) break;
            }
        },

        _doUnselectNodes: function (idColl) {
            for (var i = 0, len = idColl.length; i < len; i++) {
                var element = this._getNodeByID(idColl[i]);
                if (element[0] != null)
                    this._nodeUnSelectionAction(element);
                if (!this.model.allowMultiSelection) break;
            }
        },

        _updateSelectedNode: function () {
            var node = $(this._liList).find('.e-text.e-active').closest('.e-item'), element = [];
            this.model.selectedNodes = [];
            if (!this.model.allowMultiSelection) this.model.selectedNode = null;
            if (node[0] == undefined || node.length <= 0) {
                this._persistValues(this.model.selectedNodes, "selectedNodes");
                return;
            }
            if (!this.model.allowMultiSelection) {
                this._isRender = false;
                this._nodeSelectionAction($(node[0]));
                this._isRender = true;
            }
            else {
                for (var i = 0, len = node.length; i < len; i++) {
                    var index = $(this._liList).index(node[i]);
                    this.model.selectedNodes.push(index);
                }
                this._persistValues(this.model.selectedNodes, "selectedNodes");
            }
        },

        _setCookies: function (name, value) {
            if (window.localStorage)
                window.localStorage.setItem(this._id + name, value);
            else if (document.cookie)
                ej.cookie.set(this._id + name, value);
        },

        _getCookies: function (name) {
            if (window.localStorage)
                return window.localStorage.getItem(this._id + name);
            else if (window.cookie)
                return ej.cookie.get(this._id + name);
        },

        _updateCheckedNodes: function () {
            var checkedList, chkdNodes = [];
            checkedList = this.element.find('.e-item > div > .e-chkbox-wrap > .nodecheckbox.checked').closest('.e-item');
            for (var chk = 0; chk < checkedList.length; chk++)
                chkdNodes.push($(this._liList).index(checkedList[chk]));
            (chkdNodes.length > 0 || checkedList.length == 0) && (this.model.checkedNodes = chkdNodes);
            (checkedList.length == 0) && this.model.checkedNodes.push(-1);
            this._persistValues(this.model.checkedNodes, "checkedNodes");
        },

        _updateExpandedNodes: function () {
            var expandedEle, expndedNodes = [];
            expandedEle = this.element.find('.e-item > div > .e-minus').closest('.e-item').addClass('e-collapse');
            for (var i = 0, objlen = expandedEle.length; i < objlen; i++)
                expndedNodes.push($(this._liList).index(expandedEle[i]));
            (expndedNodes.length > 0 || expandedEle.length == 0) && (this.model.expandedNodes = expndedNodes);
            (expandedEle.length == 0) && this.model.expandedNodes.push(-1);
            this._persistValues(this.model.expandedNodes, "expandedNodes");
        },

        _isCheckedAction: function () {
            var chk, checkedList = this.element.find('.e-item.checked');
            for (var chk = 0; chk < checkedList.length; chk++) {
                var _childItems = $(checkedList[chk]).find('.e-item');
                var _uncheckedItems = $(checkedList[chk]).find('.e-item.unchecked');
                if (_childItems.length == 0 || !(_childItems.length > 0 && _uncheckedItems.length == _childItems.length) || !this.model.autoCheck) {
                    this._nodeCheck($(checkedList[chk]).find("> div > .e-chkbox-wrap > input.nodecheckbox:first")[0]);
                    for (var i = 0; i < _uncheckedItems.length; i++)
                        this._nodeUncheck($(_uncheckedItems[i]).find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                }
            }
            this.element.find('.e-item.checked, .e-item.unchecked').removeClass("checked unchecked");
        },

        _isExpandedAction: function (event) {
            var expandList = this.element.find("li.expanded"), len = expandList.length;
            for (var i = 0; i < len; i++) {
                var expandEle = $(expandList[i]);
                if (!this.model.enableMultipleExpand) {
                    var distinctEle = expandEle.siblings().find(" > div > .e-minus").closest(".e-item");
                    if (distinctEle.length > 0) continue;
                }
                this._expandNode(expandEle);
            }
            this.element.find('.e-item.expanded').removeClass("expanded");
        },

        _isSelectedAction: function (event) {
            var snode = this.element.find('.e-item.selected');
            for (var i = 0, len = snode.length; i < len; i++) {
                if (snode[i] != null)
                    this._nodeSelectionAction($(snode[i]), event);
                if (!this.model.allowMultiSelection) break;
            }
            this.element.find('.e-item.selected').removeClass("selected");
        },

        _checkedChange: function (args) {
            if (!args.isInteraction) return;
            var treeview = this.element.closest(".e-treeview.e-js").data("ejTreeView");
            var action = (args.isChecked) ? "_nodeCheck" : "_nodeUncheck";
            treeview[action]($(this.element)[0], args);
        },

        _doClickAnimation: function (event) {
            var element = $(event.target);
            if (element == undefined || event.type == undefined) return;
            element.addClass("e-animate");
            if (element.is('A') && element.hasClass('e-text')) element.closest(".e-text-wrap").addClass("e-animate");
        },

        _ClickEventHandler: function (event) {
            var proxy = this, parentLi, element = $(event.target), divTag = element.closest('.e-item').find("> div > div:first");
            this._isPopup = false;
            if (divTag && !divTag.hasClass("e-process")) {
                parentLi = element.closest('.e-item');
                if (!parentLi.hasClass('e-node-disable')) {
                    this.element.find(".e-animate").removeClass("e-animate");
                    this._doClickAnimation(event);
                    var _id = (parentLi[0] != null) ? parentLi[0].getAttribute('id') : "";
                    this._triggerEvent('nodeClick', { event: event, currentElement: element[0], id: _id, parentId: parentLi.closest('ul').closest('.e-item').attr('id') });
                    if (!ej.isNullOrUndefined(element) && element.is('DIV')) {
                        if (element.hasClass('e-plus') || element.hasClass('e-minus')) {
                            var expandUl = null, args, nodeDetails, isChildLoaded;
                            if (element.is('SPAN'))
                                element = element.parent('div').find('div:first');
                            expandUl = parentLi.children('ul:first');
                            isChildLoaded = this.isChildLoaded(parentLi);
                            if (!isChildLoaded && this.model.loadOnDemand) {
                                element.removeClass('e-plus').addClass("e-load");
                                this._checkboxChecked = element.parent().find('.nodecheckbox').hasClass('checked');
                                nodeDetails = this._getNodeDetails(parentLi);
                                args = { currentElement: parentLi, targetElement: element[0], id: nodeDetails.id, value: nodeDetails.text, parentId: nodeDetails.parentId, isChildLoaded: isChildLoaded, hasParent: true, async: true };
                                this._isEventTriggered = true;
                                if(this._triggerEvent('beforeExpand', args)) {
                                    return false;
                                }
                                this._loadOnDemand(args, element[0]);
                            }
                            else
                                (element.hasClass('e-plus')) ? this._expandNode(parentLi) : this._collpaseNode(parentLi);
                        }
                        else if (this.model.fullRowSelect && (element.hasClass("e-fullrow") || element.hasClass("e-text-wrap"))) {
                            element = element.closest('.e-item').find("> .e-text-wrap .e-text");
                        }
                    }
                    (!element.is('A') && !element.hasClass('input-text')) && (element = element.closest('.e-text'));
                    if (!ej.isNullOrUndefined(element) && element.is('A') && element.hasClass('CanSelect')) {
                        if (event && event["pointerType"] == "touch" && this._customPop != null && this.model.allowMultiSelection) {
                            var $target = $(event.target);
                            if (!this._customPop.is(":visible"))
                                this._customPop.show();
                            if (this._customPop.is(":visible") && !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) {
                                var offset = $target.offset();
                                this._customPop.offset({ left: offset.left, top: offset.top - 40 });
                            }
                            else
                                event.ctrlKey = true;
                        }
                        else
                            this._hidePopup();
                        element.hasClass('e-active') ? (this.model.allowMultiSelection && this._nodeUnSelectionAction(element.closest('.e-item'), event)) : this._nodeSelectionAction(element.closest('.e-item'), event);
                    }
                }
            }
        },

        _getChildTables: function (mapper, parentLen, currentLen) {
            if (!ej.isNullOrUndefined(mapper.child))
                return (parentLen == currentLen) ? mapper.child : this._getChildTables(mapper.child, parentLen, currentLen + 1);
        },

        _loadOnDemand: function (args) {
            var childItems, parent, mapper, proxy = this, queryPromise;
            if (this.dataSource() instanceof ej.DataManager) {
                parent = args.currentElement.parents('ul').length;
                mapper = this._getChildTables(proxy.model.fields, parent, 1);
                if (ej.isNullOrUndefined(mapper) && ej.isNullOrUndefined(this.model.fields["child"]))
                    mapper = this.model.fields;
                if (!mapper) {
                    $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
                    return;
                }
                (mapper.query && mapper.query.queries.length > 0) && (mapper.query.queries = []);
                queryPromise = this._executeDataQuery(mapper, mapper["parentId"], (this._typeOfFieldId == "number" ? parseInt(args.currentElement[0].id) : args.currentElement[0].id));
                queryPromise.done(function (e) {
                    childItems = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                    childItems = proxy._getSortAndFilterList(mapper, childItems);
                    if (childItems.length > 0) {
                        proxy._onlineData = true;
                        proxy._loadChildNodeWhenOnDemand(childItems, args, mapper);
                    } else
                        $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
                });
            }
            else {
                childItems = this._getChildNodes(this._dataSource, args);
                if (!ej.isNullOrUndefined(childItems) && childItems.length > 0) {
                    setTimeout(function () {
                        proxy._createSubNodesWhenLoadOnDemand(childItems, args.targetElement, proxy.model.fields);
                    }, 400);
                }
                else
                    $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
            }
        },

        _loadChildNodeWhenOnDemand: function (childItems, args, mapper) {
            var proxy = this;
            !ej.isNullOrUndefined(childItems) && childItems.length > 0 && setTimeout(function () {
                proxy._createSubNodesWhenLoadOnDemand(childItems, args.targetElement, mapper);
            }, 100);
        },

        _createSubNodesWhenLoadOnDemand: function (childItems, element, mapper) {
            this._loadOnDemandNodes = true;
            this._templateNodeCreation(childItems, mapper);
            $(this._fragment.firstChild).attr('style', 'display:none');
            this._fragment.firstChild.className = "e-treeview-ul";
            this._fragment.firstChild.setAttribute('role', "group");
            element.parentNode.parentNode.appendChild(this._fragment);
            var liElement = $(element).closest('.e-item');
            liElement.attr({ 'aria-expanded': false, 'aria-expanded': true });
            $(element).removeClass("e-load").addClass('e-plus');
            this._expandNode(liElement);
            this._finalizeLoadOnDemand(liElement);
        },

        _finalizeLoadOnDemand: function (element) {
            this._beforeBaseClass();
            this._isRender = false;
            if (this.model.showCheckbox) {
                element.children('ul').find('li > div > input.nodecheckbox').ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
                var _childItems = element.children('ul').find('.e-item');
                var _uncheckedItems = element.children('ul').find('.e-item.unchecked');
                if (_uncheckedItems.length >= 0 && _uncheckedItems.length != _childItems.length && this._checkboxChecked)
                    _childItems.not(".unchecked").addClass('checked');
                else if (_uncheckedItems.length == _childItems.length && this.isNodeChecked(element))
                    this._nodeUncheck(element.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                if (this._isLoaded) {
                    this._isCheckedAction();
                    this._updateCheckedNodes();
                }
            }
            this._isRender = true;
            this._addDragableClass();
            this._preventEditable();
            this.model.allowEditing && this._allowEditable();
            if (this._isLoaded) {
                this._isSelectedAction();
                this._updateSelectedNode();
                this._allowOnDemand = true;
                this._isExpandedAction();
                this._updateExpandedNodes();
                this._allowOnDemand = false;
            }
            if (this.model.loadOnDemand && this.model.enablePersistence && !(this.dataSource() instanceof ej.DataManager)) {
                var obj, value = this._getCookies("_childNodes");
                if (value) obj = JSON.parse(value);
                (!ej.isNullOrUndefined(obj) && obj.indexOf(element[0].id) == -1) ? obj.push(element[0].id) : obj = [element[0].id];
                this._setCookies("_childNodes", JSON.stringify(obj));
            }
        },

        _getChildNodes: function (obj, rootNodes) {
            var childNodes = [];
            if (this._templateType == 1) {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (!ej.isNullOrUndefined(obj[i][0]) && !ej.isNullOrUndefined(obj[i][0][this.model.fields.parentId]) && obj[i][0][this.model.fields.parentId] != 0 && obj[i][0][this.model.fields.parentId] == rootNodes.id)
                        return obj[i];
                }
            }
            else {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (obj[i][this.model.fields.id] == rootNodes.id && obj[i][this.model.fields.parentId] != 0)
                        return obj[i].child;
                    if (obj[i].hasOwnProperty('child')) {
                        childNodes = this._getChildNodes(obj[i].child, rootNodes);
                        if (!ej.isNullOrUndefined(childNodes) && childNodes.length > 0)
                            break;
                    }
                }
                return childNodes;
            }
        },

        _getPath: function (element) {
            var path = element.prop('name'), liEle;
            var liEle = element.parents('.e-item:first');
            while (liEle[0] != null && liEle[0].parentNode.id != this._id) {
                path = liEle.prop('name') + '/' + path;
                liEle = liEle.parents('.e-item:first');
            }
            path = this._id + "/" + path;
            return path;
        },

        _nodeSelectionAction: function (liElement, event) {
            if (liElement[0] == null && liElement.length == 0) return;
            var nodeDetails, data, angElement = $(liElement.find('> div > .e-text')[0]), _isSelected = false, _oldSelectedNodes = this.model.selectedNodes.slice();
            var index = this._liList.index(liElement[0]);
            this._currNode = liElement;
            if (this._triggerEvent('beforeSelect', { target: liElement, nodeDetails: this._getNodeDetails(liElement) })) return;
            if (!this.model.allowMultiSelection || !event || (event && !event.ctrlKey)) {
                this.element.find('a.e-text.e-active').removeClass('e-node-focus e-active');
                this.element.find('[aria-selected=true]').attr("aria-selected", false);
                this.element.find('.e-li-active').removeClass('e-li-active');
                if (this.model.fullRowSelect) {
                    this.element.find('.e-li-focus').removeClass('e-li-focus');
                    this.element.find('.e-node-focus').removeClass('e-node-focus');
                }
                this.element.find("#" + this._id + "_active").removeAttr("id");
                this.model.selectedNodes = [];
                this._deepWatch && this._removeField(this._newDataSource, this.model.fields.selected);
            }
            if (this.model.allowMultiSelection && event && event.shiftKey) {
                if (!this._startNode)
                    this._startNode = this._currNode;
                var nodes = this.getVisibleNodes();
                var startIndex = nodes.index(this._startNode);
                var endIndex = nodes.index(liElement[0]);
                if (startIndex > endIndex) {
                    var temp = startIndex;
                    startIndex = endIndex;
                    endIndex = temp;
                }
                for (var i = startIndex ; i <= endIndex; i++) {
                    var _currLi = $(nodes.get(i));
                    var _currIndex = this._liList.index(_currLi[0]);
                    if ($.inArray(_currIndex, this.model.selectedNodes) == -1) {
                        this.model.selectedNodes.push(_currIndex);
                        var _currAng = _currLi.find('> div > a.e-text');
                        _currAng.removeClass('e-node-focus');
                        _currLi.attr("aria-selected", true);
                        _currLi.addClass('e-li-active');
                        _currAng.addClass('e-active');
                        _isSelected = true;
                        this._deepWatch && this._updateField(this._newDataSource, _currLi.attr('id'), this.model.fields.selected, true);
                    }
                }
            }
            else
                this._startNode = liElement;
            if (!this.model.allowMultiSelection) this.model.selectedNode = index;
            if (!_isSelected) {
                this.element.find('a.e-text.e-node-focus').removeClass('e-node-focus');
                liElement.attr("aria-selected", true);
                liElement.addClass('e-li-active');
                angElement.addClass('e-active');
                if (!this.model.allowMultiSelection) angElement.attr("id", this._id + "_active");
                if ($.inArray(index, this.model.selectedNodes) == -1)
                    this.model.selectedNodes.push(index);
                this._deepWatch && this._updateField(this._newDataSource, liElement.attr('id'), this.model.fields.selected, true);
            }
            if (this.model.enablePersistence)
                this._persistValues(this.model.selectedNodes, "selectedNodes");
            if (this._deepWatch) {
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
                this.dataSource(this._newDataSource);
            }
            this._triggerGivenEvent('nodeSelect', liElement);
        },

        _nodeUnSelectionAction: function (liElement, event) {
            if (this.model.allowMultiSelection && event && !event.ctrlKey) {
                this._nodeSelectionAction(liElement, event);
                return;
            }
            liElement.removeClass('e-li-active');
            liElement.attr("aria-selected", false).find('> div > .e-text').removeClass('e-active').attr("id", "");
            this._updateUnselectModel(liElement[0]);
            if (this._deepWatch) {
                this._updateField(this._newDataSource, liElement.attr('id'), this.model.fields.selected, false);
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
                this.dataSource(this._newDataSource);
            }
            this._triggerGivenEvent('nodeUnselect', liElement);
        },

        _updateUnselectModel: function (liElement) {
            var index = this._liList.index(liElement), _nodes = this.model.selectedNodes;
            if (!this.model.allowMultiSelection) this.model.selectedNode = null;
            var arrIndex = $.inArray(index, _nodes);
            if (arrIndex > -1) {
                this.model.selectedNodes.splice(arrIndex, 1);
            }
            this._persistValues(this.model.selectedNodes, "selectedNodes");
        },

        _triggerGivenEvent: function (event, element) {
            if (this._isRender) {
                var data = { currentElement: element, value: element.find('> div > a.e-text').eq(0).text(), id: element[0].getAttribute('id'), parentId: element.closest('ul').closest('.e-item').attr('id'), selectedNodes: this.model.selectedNodes };
                this._triggerEvent(event, data);
            }
        },

        _getNodesIndex: function (cnodes) {
            var cindex = [];
            for (var i = 0, len = cnodes.length; i < len; i++)
                cindex.push(this._liList.index(cnodes[i]));
            return cindex;
        },

        _nodeEnableAction: function (liElement) {
            var parent = this.getParent(liElement);
            if (parent[0] != null && parent.hasClass('e-node-disable')) return;
            if (this.model.showCheckbox)
                liElement.find('div > .e-chkbox-wrap > .nodecheckbox').ejCheckBox('enable').prop('disabled', false);
            liElement.find('.e-text').removeClass('e-node-disable')
                     .closest('.e-item')
                     .removeClass('e-node-disable')
                     .removeProp("disabled");
        },

        _nodeDisableAction: function (liElement) {
            this._collpaseNode(liElement);
            if (this.model.showCheckbox)
                liElement.find('div > .e-chkbox-wrap > .nodecheckbox').ejCheckBox('disable').prop('disabled', true);
            var snodes = liElement.find(".e-text.e-active").closest(".e-item");
            liElement.find('.e-text').addClass('e-node-disable')
                     .removeClass('e-active')
                     .attr("id", "")
                     .closest('.e-item')
                     .addClass('e-node-disable')
                     .prop('disabled', true);
            for (var i = 0, len = snodes.length; i < len; i++)
                this._updateUnselectModel(snodes[i]);
        },

        _getNodeDetails: function (liElement) {
            if (liElement[0] != null && liElement.is('LI') && liElement.hasClass('e-item')) {
                var id, text, pid, level, childs, expanded, checked, selected, index;
                id = liElement[0].getAttribute('id');
                text = liElement.children('div').find('.e-text:first').text();
                pid = liElement.closest('ul').closest('.e-item').attr('id');
                level = liElement.parents('ul').length;
                childs = liElement.find('.e-item').length;
                expanded = this._isNodeExpanded(liElement);
                checked = this._isChecked(liElement);
                selected = liElement.find('> div > .e-text').hasClass('e-active');
                index = this._liList.index(liElement);
                return { id: id, text: text, parentId: (pid) ? pid : "", level: level, count: childs, expanded: expanded, checked: checked, selected: selected, index: index };
            } else {
                return { id: "", text: "", parentId: "", level: "", count: "", expanded: "", checked: "", selected: "", index: "" };
            }
        },

        _denyMultipleExpand: function (liElement) {
            var distinctEle = liElement.siblings().find(">div>.e-minus").closest(".e-item");
            for (var i = 0, len = distinctEle.length; i < len; i++) {
                this._collpaseNode($(distinctEle[i]));
            }
        },

        _expandCollapseAction: function (element) {
            if (element && !element.hasClass("e-process")) {
                var expandUl, proxy = this, parentLi, nodeDetails, data, isChildLoaded;
                parentLi = element.closest('.e-item');
                if (element.is('SPAN'))
                    element = $(element).parent('div').find('div:first');
                expandUl = parentLi.children('ul:first');
                if (expandUl.find('> .e-item').length > 0) {
                    this.model.enableAnimation && element.addClass("e-process");
                    nodeDetails = this._getNodeDetails(parentLi);
                    isChildLoaded = this.isChildLoaded(parentLi);
                    data = { currentElement: parentLi, value: nodeDetails.text, isChildLoaded: isChildLoaded, id: nodeDetails.id, parentId: nodeDetails.parentId, async: false };
                    if (!this._isNodeExpanded(parentLi) && isChildLoaded) {
                        if (!this._isEventTriggered)
                            if (this._triggerEvent('beforeExpand', data)) return false;
                        this._isEventTriggered = false;
                        parentLi.attr("aria-expanded", true);
                        this._addExpandedNodes(this._liList.index(parentLi));
                        $(element).removeClass('e-icon e-plus').addClass('e-icon e-minus');
                        parentLi.addClass('e-collapse');
                        this._deepWatch && this._updateField(this._newDataSource, nodeDetails.id, this.model.fields.expanded, true);
                        this._doAnimation(expandUl, element, "nodeExpand", data, 350);
                    }
                    else {
                        this.element.find(".e-material-animate").removeClass("e-material-animate");
                        parentLi.attr("aria-expanded", false);
                        if (this._triggerEvent('beforeCollapse', data) === true)
                            return false;
                        this._removeExpandedNodes(this._liList.index(data.currentElement));
                        $(element).removeClass('e-icon e-minus').addClass('e-icon e-plus');
                        parentLi.removeClass('e-collapse');
                        this._deepWatch && this._updateField(this._newDataSource, nodeDetails.id, this.model.fields.expanded, false);
                        this._doAnimation(expandUl, element, "nodeCollapse", data, 200);
                    }
                    if (this._deepWatch) {
                        this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
						this.dataSource(this._newDataSource);
                    }
                }
            }
        },

        _doAnimation: function (expandUl, element, event, data, animationSpeed) {
            var proxy = this;
            if (this.model.enableAnimation) {
                expandUl.animate({ height: 'toggle' }, animationSpeed, 'linear', function () {
                    if (ej.isNullOrUndefined(proxy.model)) return;
                    proxy._doAnimateAction(element, event, data);
                });
            }
            else {
                expandUl.css("display", animationSpeed == 200 ? "none" : "block");
                this._doAnimateAction(element, event, data);
            }
        },

        _doAnimateAction: function (element, event, data) {
            element.removeClass("e-process");
            this._triggerEvent(event, data);
        },

        _isChecked: function (liElement) {
            return (liElement.find("> div > .e-chkbox-wrap:first").attr("aria-checked") === 'true') ? true : false;
        },

        _doRecursiveCheck: function (parentLi, checkedArray) {
            var chkWrapper, chkEle, liElement, textvalue, parentLi, childUl;
            childUl = this._getChildUl(parentLi);
            chkWrapper = (childUl) ? childUl.querySelectorAll('.e-chkbox-wrap[aria-checked="true"]').length : 0;
            var allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
            chkEle = parentLi.firstChild.querySelector('.nodecheckbox');
            if (chkEle && chkEle.nodeName.toUpperCase() == 'INPUT') {
                var chkboxObj = $(chkEle).data('ejCheckBox');
                if (chkWrapper == allChkEle.length || this.model.autoCheckParentNode) {
                    chkboxObj.setModel({ enableTriState: false, checked: true });
                    chkEle.className += " checked";
                    textvalue = parentLi.firstChild.getElementsByTagName('a')[0].innerHTML;
                    checkedArray.push({ id: parentLi.id, text: textvalue });
                    if (this._deepWatch && !this.model.autoCheckParentNode) this._updateField(this._newDataSource, parentLi.id, this.model.fields.isChecked, true);
                    this._addHiddenInputElement(chkEle, textvalue);
                    this._addCheckNodes(this._liList.index(parentLi));
                } else
                    chkboxObj.setModel({ enableTriState: true, checkState: "indeterminate" });
                parentLi = parentLi.parentNode.parentNode;
                if (parentLi.nodeName.toUpperCase() == 'LI')
                    this._doRecursiveCheck(parentLi, checkedArray);
            }
        },

        _nodeCheck: function (chkEle, args) {
            if ($(chkEle)[0] == null) return;
            this._CurrenctSelectedNodes = [];
            this._checkedArray = [];
            var chkObj, currentLi, textvalue, chkCollection, chklen, parentLi;
            chkEle.className += " checked";
            chkObj = $(chkEle).data('ejCheckBox');
            if (chkObj) {
                chkObj.setModel({ enableTriState: false, checked: true });
                currentLi = chkEle.parentNode.parentNode.parentNode;
                textvalue = currentLi.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                this._checkedArray.push({ id: currentLi.id, text: textvalue });
                this._deepWatch && this._updateField(this._newDataSource, currentLi.id, this.model.fields.isChecked, true);
                this._addHiddenInputElement(chkEle, textvalue);
                this._addCheckNodes(this._liList.index(currentLi));
                if (this.model.autoCheck) {
                    var allChkEle, liElement, childUl;
                    childUl = this._getChildUl(currentLi);
                    allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
                    for (var i = 0, chklen = allChkEle.length; i < chklen; i++) {
                        $(allChkEle[i]).ejCheckBox({ checked: true, enableTriState: false })[0].className += " checked";
                        liElement = allChkEle[i].parentNode.parentNode.parentNode;
                        textvalue = liElement.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                        this._checkedArray.push({ id: liElement.id, text: textvalue });
                        this._deepWatch && this._updateField(this._newDataSource, liElement.id, this.model.fields.isChecked, true);
                        this._addHiddenInputElement(allChkEle[i], textvalue);
                        this._addCheckNodes(this._liList.index(liElement));
                    }
                    parentLi = currentLi.parentNode.parentNode;
                    if (parentLi.nodeName.toUpperCase() == 'LI')
                        this._doRecursiveCheck(parentLi, this._checkedArray);
                }
                (args) && (args.checknode = this._checkedArray);
                this._onChecked($(chkEle), args);
            }
            if (this._deepWatch) {
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
				this.dataSource(this._newDataSource);
            }
            this._persistValues(this.model.checkedNodes, "checkedNodes");
        },

        _addHiddenInputElement: function (checkedElement, textVal) {
            if (checkedElement.firstChild == null) {
                var hiddenElement = document.createElement('input');
                hiddenElement.setAttribute("type", "hidden");
                hiddenElement.setAttribute("name", this._id + "_Checkbox_" + checkedElement.value + ".Text");
                hiddenElement.setAttribute("value", textVal);
                try {
                    checkedElement.appendChild(hiddenElement);
                }
                catch (err) { }
            }
        },

        _doRecursiveUncheck: function (parentLi, uncheckedArray) {
            var chkWrapper, chkEle, liElement, textvalue, parentLi, childUl;
            childUl = this._getChildUl(parentLi);
            chkWrapper = (childUl) ? childUl.querySelectorAll('.e-chkbox-wrap[aria-checked="true"]').length : 0;
            var allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
            chkEle = parentLi.firstChild.querySelector('.nodecheckbox');
            if (chkEle && chkEle.nodeName.toUpperCase() == 'INPUT') {
                var chkboxObj = $(chkEle).data('ejCheckBox');
                if (chkWrapper <= 0) {
                    chkboxObj.setModel({ enableTriState: false, checked: false });
                    $(chkEle).removeClass("checked").removeClass('checked').children().remove();
                    textvalue = parentLi.firstChild.getElementsByTagName('a')[0].innerHTML;
                    this._removeCheckNodes(this._liList.index(parentLi));
                    uncheckedArray.push({ id: parentLi.id, text: textvalue });
                    this._deepWatch && this._updateField(this._newDataSource, parentLi.id, this.model.fields.isChecked, false);
                }
                if (chkWrapper > 0 && this.model.autoCheckParentNode) {
                    chkboxObj.setModel({ checked: true });
                    chkEle.className += " checked";
                    textvalue = parentLi.firstChild.getElementsByTagName('a')[0].innerHTML;
                    this._addHiddenInputElement(parentLi, textvalue);
                    this._deepWatch && this._updateField(this._newDataSource, parentLi.id, this.model.fields.isChecked, false);
                }
                else if (chkWrapper > 0 && !this.model.autoCheckParentNode) {
                    if (allChkEle.length > 1)
                        chkboxObj.setModel({ enableTriState: true, checkState: "indeterminate" });
                    else
                        chkboxObj.setModel({ checked: false });
                    $(chkEle).removeClass("checked").removeClass('checked').children().remove();
                    this._removeCheckNodes(this._liList.index(parentLi));
                    this._deepWatch && this._updateField(this._newDataSource, parentLi.id, this.model.fields.isChecked, false);
                }
                parentLi = parentLi.parentNode.parentNode;
                if (parentLi.nodeName.toUpperCase() == 'LI')
                    this._doRecursiveUncheck(parentLi, uncheckedArray);
            }
        },

        _nodeUncheck: function (chkEle, args) {
            if ($(chkEle)[0] == null) return;
            var proxy = this; this._uncheckedArray = [];
            var currentLi = chkEle.parentNode.parentNode.parentNode;
            $(currentLi).find('div > .e-chkbox-wrap > .nodecheckbox').removeClass('checked').children().remove();
            var chkObj = $(chkEle).data('ejCheckBox');
            this._removeCheckNodes(this._liList.index(currentLi));
            if (chkObj) {
                chkObj.setModel({ enableTriState: false, checked: false });
                var textvalue = currentLi.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                this._uncheckedArray.push({ id: currentLi.id, text: textvalue });
                this._deepWatch && this._updateField(this._newDataSource, currentLi.id, this.model.fields.isChecked, false);
                if (this.model.autoCheck) {
                    var childUl = this._getChildUl(currentLi);
                    var allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
                    for (var i = 0, chklen = allChkEle.length; i < chklen; i++) {
                        $(allChkEle[i]).ejCheckBox({ enableTriState: false, checked: false });
                        var liElement = allChkEle[i].parentNode.parentNode.parentNode;
                        textvalue = liElement.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                        this._uncheckedArray.push({ id: liElement.id, text: textvalue });
                        this._deepWatch && this._updateField(this._newDataSource, liElement.id, this.model.fields.isChecked, false);
                        this._removeCheckNodes(this._liList.index(liElement));
                    }
                    var parentLi = currentLi.parentNode.parentNode;
                    if (parentLi.nodeName.toUpperCase() == 'LI')
                        this._doRecursiveUncheck(parentLi, this._uncheckedArray);
                }
                (args) && (args.unchecknode = this._uncheckedArray);
                this._onUnChecked($(chkEle), args);
            }
            if (this._deepWatch) {
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
				this.dataSource(this._newDataSource);
            }
            this._persistValues(this.model.checkedNodes, "checkedNodes");
        },

        _executeDataQuery: function(mapper, key, val) {
            var queryManager, queryPromise;
            queryManager = ej.Query();
            queryManager = this._columnToSelect(mapper);
            if (!ej.isNullOrUndefined(key) && key != "") {
                var tempQuery=$.extend(true,[],queryManager._params);
                queryManager._params = [];
                queryManager.addParams(key, val);
                for (var i = 0; i < tempQuery.length; i++)
                    (tempQuery[i].key != key) && queryManager.addParams(tempQuery[i].key, tempQuery[i].value);
                queryManager.where(key, ej.FilterOperators.equal, val);
            }
            queryPromise = mapper["dataSource"].executeQuery(queryManager);
            return queryPromise;
        },

        _createChildNodesWhenExpand: function (parentLi, expandChild, level, excludeHiddenNodes, outerLi, thisObj) {
            var nodeid, nodeText, args, element;
            if (parentLi.length > 0 && parentLi.find('ul .e-item').length == 0) {
                nodeid = parentLi.attr('id');
                nodeText = parentLi.children('div').find('.e-text:first').text();
                element = parentLi.children('div').find('div.e-plus:first');
                args = { currentElement: parentLi, targetElement: element[0], id: nodeid, value: nodeText, isChildLoaded: false, hasParent: true, async: false };
                var childItems, parent, mapper, proxy = this, queryPromise;
                this._isEventTriggered = true;
                if (this._triggerEvent('beforeExpand', args)) {
                    return false;
                }
                if (this.dataSource() instanceof ej.DataManager) {
                    parent = args.currentElement.parents('ul').length;
                    mapper = this._getChildTables(this.model.fields, parent, 1);
                    if (ej.isNullOrUndefined(mapper) && ej.isNullOrUndefined(this.model.fields["child"]))
                        mapper = this.model.fields;
                    if (!mapper) {
                        $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
                        return;
                    }
                    (mapper.query && mapper.query.queries.length > 0) && (mapper.query.queries = []);
                    this._treeList.push("false");
                    queryPromise = this._executeDataQuery(mapper, mapper["parentId"], (this._typeOfFieldId == "number" ? parseInt(args.currentElement[0].id) : args.currentElement[0].id));
                    queryPromise.done(function (e) {
                        proxy._treeList.pop();
                        childItems = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                        childItems = proxy._getSortAndFilterList(mapper, childItems);
                        proxy._appendChild(childItems, parentLi, mapper, expandChild, level, excludeHiddenNodes);
                        level && proxy._expandByLevel(parentLi.find('> ul'), level - 1, excludeHiddenNodes);
                        if (proxy._treeList.length == 0) {
                            outerLi && proxy._doAfterExpand(parentLi, outerLi, thisObj);
                            proxy._completeRendering();
                        }
                    });
                }
                else {
                    var childItems = this._getChildNodes(this._dataSource, { id: parentLi[0].id });
                    this._appendChild(childItems, parentLi, this.model.fields, expandChild, level, excludeHiddenNodes);
                }
            }
            else
                this._expandNode(parentLi);
        },

        _appendChild: function (childItems, parentLi, mapper, expandChild, level, excludeHiddenNodes) {
            if (!ej.isNullOrUndefined(childItems) && childItems.length > 0) {
                this._checkboxChecked = parentLi.find('> div > .e-chkbox-wrap > .nodecheckbox').hasClass('checked');
                this._loadOnDemandNodes = true;
                if (parentLi.find('ul .e-item').length == 0) {
                    this._templateNodeCreation(childItems, mapper);
                    parentLi.append(this._fragment);
                }
                this._finalizeLoadOnDemand(parentLi);
                this._expandNode(parentLi);
                if (expandChild && !level && !excludeHiddenNodes) {
                    var _items = parentLi.find(".e-item > div > .e-plus").closest(".e-item");
                    for (var i = 0, len = _items.length; i < len; i++)
                        this._createChildNodesWhenExpand($(_items[i]), true, null, excludeHiddenNodes);
                }
            }
            else if (expandChild)
                parentLi.find("> div > .e-plus").removeClass('e-plus e-icon');
        },

        _getSortAndFilterList: function (mapper, list) {
            var dataSource;
            if (!list || !list.length || list.length < 1) dataSource = [];
            else {
                var tempQuery = ej.Query();
                this._addSortingQuery(tempQuery, mapper);
                dataSource = ej.DataManager(list).executeLocal(tempQuery);
            }
            return dataSource;
        },

        _addSortingQuery: function (query, mapper) {
            if (this.model.sortSettings.allowSorting) {
                var key = (mapper && mapper.text) ? mapper["text"] : "text";
                var order = (this.model.sortSettings.sortOrder == ej.sortOrder.Descending) ? true : false;
                query.sortBy(key, order);
            }
        },

        _expandNode: function (liElement) {
            if (liElement[0] != null && liElement.length > 0) {
                var expandIcon = liElement.find('> div > div:first');
                if (this.model.loadOnDemand && !this.model.enablePersistence) {
                    if (liElement.find('> ul > .e-item').length > 0 && expandIcon.hasClass('e-plus')) {
                        if (!this.model.enableMultipleExpand) this._denyMultipleExpand(liElement);
                        this._expandCollapseAction(liElement.find('> div > div.e-plus:first'));
                    } else if (expandIcon.hasClass('e-icon') && !expandIcon.hasClass('e-minus')) {
                        (this._allowOnDemand) && this._createChildNodesWhenExpand(liElement);
                    }
                }
                else {
                    if (expandIcon.hasClass('e-plus')) {
                        var isExpanded = liElement.find('> ul > .e-item').length > 0 ? true : false;
                        if (isExpanded) {
                            if (!this.model.enableMultipleExpand) this._denyMultipleExpand(liElement);
                            this._expandCollapseAction(expandIcon);
                        }
                    }
                }
            }
            return true;
        },

        _collpaseNode: function (liElement) {
            if (liElement[0] != null && liElement.length > 0) {
                if (liElement.find('> ul > .e-item').length > 0) {
                    var collapseIcon = liElement.find('> div > div:first');
                    if (collapseIcon.hasClass('e-minus'))
                        this._expandCollapseAction(collapseIcon);
                }
            }
        },

        _getElement: function (level) {
            return (!this.element.is('UL')) ? this.element.find('> ul') : this.element;
        },

        _getImmediateChild: function (ele, excludeHiddenNodes) {
            return excludeHiddenNodes ? ele.find('> .e-item:not(:hidden)') : ele.find('> .e-item');
        },

        _expandByLevel: function (ele, level, excludeHiddenNodes) {
            (level > 0) && this._expandByNode(this._getImmediateChild(ele, excludeHiddenNodes), level, excludeHiddenNodes);
        },

        _expandByNode: function (cnodes, level, excludeHiddenNodes) {
            for (var i = 0, len = cnodes.length; i < len; i++) {
                if ($(cnodes[i]).find("> div > div").hasClass("e-plus"))
                    this.model.loadOnDemand ? this._createChildNodesWhenExpand($(cnodes[i]), true, level, excludeHiddenNodes) : this._expandNode($(cnodes[i]));
                this._expandByLevel($(cnodes[i]).find('> ul'), level - 1, excludeHiddenNodes);
            }
        },

        _expandAll: function (excludeHiddenNodes) {
            var element = this.element, i, cnodes;
            cnodes = element.find(excludeHiddenNodes ? '.e-item > div > .e-plus:not(:hidden)' : '.e-item > div > .e-plus').closest('.e-item');
            if (this.model.loadOnDemand) {
                for (i = 0, len = cnodes.length; i < len; i++)
                    this._createChildNodesWhenExpand($(cnodes[i]), true, null, excludeHiddenNodes);
            }
            else {
                for (i = 0, len = cnodes.length; i < len; i++)
                    this._expandNode($(cnodes[i]));
            }
        },

        _collapseByLevel: function (ele, level, excludeHiddenNodes) {
            (level > 0) && this._collapseByNode(this._getImmediateChild(ele, excludeHiddenNodes), level, excludeHiddenNodes);
        },

        _collapseByNode: function (cnodes, level, excludeHiddenNodes) {
            for (var i = 0, len = cnodes.length; i < len; i++) {
                if ($(cnodes[i]).find("> div > div").hasClass("e-minus"))
                    this._collpaseNode($(cnodes[i]));
                this._collapseByLevel($(cnodes[i]).find('> ul'), level - 1, excludeHiddenNodes);
            }
        },

        _collapseAll: function (excludeHiddenNodes) {
            var element = this.element, i, enodes;
            enodes = element.find(excludeHiddenNodes ? '.e-item > div > .e-minus:not(:hidden)' : '.e-item > div > .e-minus').closest('.e-item');
            if (enodes.length > 0) {
                for (i = 0, len = enodes.length; i < len; i++) {
                    this._collpaseNode($(enodes[i]));
                }
            }
        },

        _checkAll: function () {
            this._CurrenctSelectedNodes = [];
            var element = this.element, chkColl;
            chkColl = element.find('.e-item > div > .e-chkbox-wrap > .nodecheckbox');
            chkColl.addClass('checked');
            for (i = 0, len = chkColl.length; i < len; i++) {
                $(chkColl[i]).ejCheckBox("setModel", { checked: true });
                this._addHiddenInputElement(chkColl[i], $(chkColl[i]).parent().siblings('.e-text')[0].lastChild.nodeValue);
            }
            this.model.checkedNodes = this.getCheckedNodesIndex();
        },

        _uncheckAll: function () {
            var element = this.element, chkColl;
            chkColl = element.find('.e-item > div > .e-chkbox-wrap > .nodecheckbox');
            chkColl.removeClass("checked").children().remove();
            for (i = 0, len = chkColl.length; i < len; i++)
                $(chkColl[i]).ejCheckBox("setModel", { checked: false });
            this.model.checkedNodes = [];
            this.model.checkedNodes.push(-1);
        },

        _selectAll: function () {
            this._isRender = false;
            var data = { ctrlKey: true };
            for (var i = 0, len = this._liList.length; i < len; i++) {
                var element = $(this._liList[i]);
                if (element[0] != null)
                    this._nodeSelectionAction(element, data);
                if (!this.model.allowMultiSelection) break;
            }
            this._isRender = true;
        },

        _unselectAll: function () {
            this.element.find('a.e-text.e-active').removeClass('e-node-focus e-active');
            this.element.find('[aria-selected=true]').attr("aria-selected", false);
            this.element.find('.e-li-active').removeClass('e-li-active');
            this.element.find('.e-li-focus').removeClass('e-li-focus');
            this.element.find('.e-node-focus').removeClass('e-node-focus');
            this.model.selectedNodes = [];
            if (this.model.enablePersistence)
                this._persistValues(this.model.selectedNodes, "selectedNodes");
        },

        _isNodeExpanded: function (liElement) {
            if (liElement[0] != null)
                return liElement.children('ul:first').length > 0 && liElement.find('> div > div.e-minus').length > 0;
        },

        _showCheckBox: function () {
            var element = this.element, licoll, i, subItems;
            licoll = element.find('li');
            for (var i = 0; i < licoll.length; i++)
                this._checkboxOnTemplate(licoll[i].children[0]);
            element.find(".e-item > div > .nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            element.find(".e-item.e-node-disable > div > .e-chkbox-wrap > .nodecheckbox").ejCheckBox("disable");
        },
        _drag: function () {
            var proxy, pre = false, browserInfo = ej.browserInfo(), _clonedElement = null, _draggedElement = null, dragContainment = null, _isIE8;
            _isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            if (this.element.is("ul")) {
                this._treeView = this.element.parent();
                if (!this.model.allowDragAndDropAcrossControl)
                    dragContainment = this.element.parent();
            }
            else {
                this._treeView = this.element;
                if (!this.model.allowDragAndDropAcrossControl)
                    dragContainment = this.element;
            }
            $(this._treeView).find("ul li div a").not(".e-js").ejDraggable({
                dragArea: dragContainment,
                clone: true,
                dragStart: function (args) {
                    if (proxy && !ej.isNullOrUndefined(args.target) && !$(args.target).hasClass('e-node-disable') && proxy.element.find('.e-item > div > .e-text.e-editable').length == 0) {
                        args.element.attr('aria-grabbed', true);
                        proxy.element.closest('.e-treeview-wrap').addClass('e-dragging');
                        if ($(args.target).is('A') && !$(args.target).hasClass('e-draggable')) return false;
                        if (_isIE8) document.ondragstart = function () { return false; }
                        var data = { target: $(args.target).closest(".e-item"), targetElementData: proxy._getNodeDetails($(args.target).closest(".e-item")), dragTarget: args.target, parentElement: $(args.target).closest("ul").closest('.e-item'), parentElementData: proxy._getNodeDetails($(args.target).closest("ul").closest('.e-item')), event: args.event };
                        if (proxy._triggerEvent('nodeDragStart', data)) {
                            args.cancel = true;
                            _clonedElement && _clonedElement.remove();
                            return false;
                        }
                    } else return false;
                },
                drag: function (args) {
                    pre = false;
                    if ($(args.target).hasClass('e-sibling')) args.target = args.target.parentElement;
                    $('.e-sibling').remove();
                    var target = args.target, trgtEle = proxy._findTarget($(target)), data;
                    $(target).closest('.e-treeview-wrap').addClass('e-dragging');
                    $(_clonedElement).css({ "margin-top": args.event.clientY - 20 < 0 ? "0px" : "10px" });
                    
                    data = { draggedElement: $(args.element).closest(".e-item"), draggedElementData: proxy._getNodeDetails($(args.element).closest(".e-item")), dragTarget: target, target: trgtEle, targetElementData: proxy._getNodeDetails(trgtEle), event: args.event };
                    if (($(args.element).parent().parent().has($(target)).length == 0 || (proxy.model.allowMultiSelection && proxy.model.selectedNodes.length > 1)) && ($(target).hasClass('e-droppable') || $(target).parent().hasClass('e-droppable')) && $(target).hasClass('e-dropchild') && !$(target).hasClass('e-node-disable') &&
                       (proxy.model.allowDragAndDropAcrossControl || (!proxy.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(proxy.element)))) {
                        document.body.style.cursor = '';
                        $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                        $(target).addClass("allowDrop");
                    } else if (($(target).hasClass('e-droppable') && !$(target).hasClass('e-item') && !$(target).hasClass('e-text')) || ($(target).is("UL") && $(target).hasClass('e-ul') && $(target).find('.e-item').length == 0 && $(target).parent('.e-treeview-wrap').length > 0)) {
                        document.body.style.cursor = '';
                        $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                    }
                    else if ((!$(target).hasClass('e-sibling') && !$(target).find('a').hasClass('e-text')) || (!$(target).hasClass('e-sibling') && !$(target).parent().parent().hasClass('e-item') && !$(target).parent().hasClass('e-item') && !$(target).hasClass('e-item') && !$(target).hasClass('e-text')) || ((target.nodeName.toUpperCase() == "LI" || target.parentElement !== null && target.parentElement.nodeName.toUpperCase() == "LI") && !proxy.model.allowDropSibling) || (!proxy.model.allowDragAndDropAcrossControl && !$(target).parents('.e-treeview').is(proxy.element))) {
                        document.body.style.cursor = 'not-allowed';
                        $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-minus");
                        $(target).removeClass('showline-hover');
                        $(target).removeClass('noline-hover');
                    }
                    if (target.nodeName != 'A' && ($(args.element).parent().parent().has($(target)).length == 0 || (proxy.model.allowMultiSelection && proxy.model.selectedNodes.length > 1)) && $(args.element).parent().parent()[0] != $(target)[0]) {
                        if (target.nodeName == 'UL' && $(target).children()[0] != null)
                        { target = $(target).children()[0]; pre = true; }
                        if (target.nodeName != 'LI')
                            target = $(target).closest('.e-droppable')[0] || $(target).parent();
                        if (target.nodeName == 'LI' && $(target).hasClass("e-droppable") && $(target).hasClass("e-dropsibling") && (proxy.model.allowDragAndDropAcrossControl || (!proxy.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(proxy.element)))) {
                            var div = ej.buildTag('div.e-sibling'), targetY;
                            targetY = $(target).offset().top + $(target).find('a').height() || -1;
                            pre = (args.event.pageY > targetY) ? false : true;
                            pre ? div.insertBefore($(target).find('> div > a').parent()) : div.insertAfter($(target).find('> div > a').parent());
                            if ($(target).parents().hasClass("e-rtl")) {
                                document.body.style.cursor = '';
                                $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-insertInbetween-rtl");
                            }
                            else {
                                document.body.style.cursor = '';
                                $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-insertInbetween");
                            }
                        }
                        else if (target.nodeName == 'A' && $(target) && $(target).hasClass('e-droppable') && $(target).hasClass('e-dropchild')) {
                            document.body.style.cursor = '';
                            $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                            $(target).addClass("allowDrop");
                        } else if ($(target).hasClass('e-droppable') && !$(target).hasClass('e-item') && !$(target).hasClass('e-text')) {
                            document.body.style.cursor = '';
                            $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                        }
                    }
                    else {
                        if ($(args.element).parent().parent().has($(target)).length == 1 || $(args.element).parent().parent().is($(target))) {
                            if (!proxy.model.allowMultiSelection || (proxy.model.allowMultiSelection && proxy.model.selectedNodes.length <= 1)) {
                                document.body.style.cursor = 'not-allowed';
                                $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-minus");
                            }
                        }
                        $('.e-sibling').remove();
                    }
                    if (proxy._triggerEvent('nodeDrag', data))
                        return false;
                },
                dragStop: function (args) {
                    if (_isIE8) document.ondragstart = function () { return true; }
                    if (!args.element.dropped) {
                        _clonedElement && _clonedElement.remove();
                        document.body.style.cursor = '';
                    }
                    var target = args.target, position, data;
                    $(target).closest('.e-treeview-wrap').removeClass('e-dragging');
                    proxy.element.closest('.e-treeview-wrap').removeClass('e-dragging');
                    if (target.className == "e-sibling")
                        target = $(target).closest(".e-item")[0];
                    $('.e-sibling').remove();
                    if ($(target).hasClass('e-node-disable')) return false;
                    position = pre ? "Before" : "After", trgtEle = proxy._findTarget($(target));
                    position = target.nodeName == 'A' ? "Over" : position;
                    data = { draggedElementData: proxy._getNodeDetails($(args.element).closest('.e-item')), draggedElement: $(args.element).closest('.e-item'), dropTarget: $(target), target: trgtEle, targetElementData: proxy._getNodeDetails(trgtEle), position: position, event: args.event };
                    if (proxy._triggerEvent('nodeDragStop', data))
                        return false;
                    if (proxy.model.allowMultiSelection && $(args.element).hasClass("e-active")) {
                        var sleNodes = proxy.element.find('.e-item > div > .e-active');
                        for (var l = 0, slelen = sleNodes.length; l < slelen; l++) {
                            args.element = sleNodes[l];
                            position = proxy._dropNode(target, args, position, pre);
                        }
                    }
                    else
                        position = proxy._dropNode(target, args, position, pre);
                    $(".allowDrop").removeClass("allowDrop");
                    $(args.element).attr('aria-grabbed', false);
                    if (!$(target).hasClass('e-dropchild')) {
                        _clonedElement && _clonedElement.remove();
                    }
                    trgtEle = proxy._findTarget($(target));
                    data = { droppedElementData: proxy._getNodeDetails($(args.element).closest('.e-item')), droppedElement: $(args.element).closest('.e-item'), dropTarget: $(target), target: trgtEle, targetElementData: proxy._getNodeDetails(trgtEle), position: position, event: args.event };
                    if (proxy._triggerEvent('nodeDropped', data))
                        return false;
                    document.body.style.cursor = '';
                },
                helper: function (event, ui) {
                    if (!ej.isNullOrUndefined(event.element) && !$(event.element).hasClass('e-node-disable') && $(event.element).hasClass('e-draggable')) {
                        proxy = $(event.element).closest('.e-treeview.e-js').data('ejTreeView');
                        if (proxy) {
                            _clonedElement = ej.buildTag('div.e-dragedNode e-widget');
                            var maxZ = ej.util.getZindexPartial(proxy.element);
                            _clonedElement.css({ "z-index": maxZ });
                            _clonedElement.addClass(proxy.model.cssClass + (proxy.model.enableRTL ? ' e-rtl' : ''));
                            var sleNodes = proxy.element.find('.e-item > div > .e-active');
                            var sleNodesLen = sleNodes.length;
                            _draggedElement = $(event.element).clone().addClass("dragClone");
                            this.spanEle = ej.buildTag('span.e-icon e-plus e-dropedStatus');
                            _clonedElement.append(this.spanEle);
                            _clonedElement.append(_draggedElement);
                            var _spanEle = ej.buildTag('span.e-drop-count', sleNodesLen);
                            if (sleNodesLen > 1 && proxy.model.allowMultiSelection && $(event.element).hasClass("e-active"))
                                _clonedElement.append(_spanEle);
                            return _clonedElement.appendTo($("body"));
                        }
                    }
                }
            });
        },

        _dropNode: function (target, args, position, pre) {
            if (target.nodeName == 'A' && $(target).hasClass('e-dropchild') && $(target).hasClass('e-droppable') || (target.nodeName == 'UL' && $(target).children().length == 0)) {
                position = "Over";
                if ($(target).is("UL") && $(target).hasClass('e-ul') && $(target).find('.e-item').length == 0 && $(target).parent('.e-treeview-wrap').length > 0)
                    this._dropAsChildNode($(target), $(args.element), args.event);
                else if (($(args.element).parent().parent().has($(target)).length == 0) && ($(target).parent().parent().has($(args.element)).length == 0 || this._isDescendant($(target).parents("li:last").find('>ul>li'), $(args.element).parents("li:first")[0])) && (this.model.allowDragAndDropAcrossControl || (!this.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(this.element))))
                    this._dropAsChildNode($(target).closest('.e-item'), $(args.element), args.event);
            }
            else {
                if (target.nodeName == 'UL')
                    target = $(target).children()[0];
                if (target.nodeName != 'LI')
                    target = $(target).closest('.e-droppable')[0] || $(target).parent();
                if (target.nodeName == 'LI' && $(target).hasClass('e-dropsibling') && $(target).hasClass('e-droppable')) {
                    if ($(args.element).parent().parent().has($(target)).length < 1 && $(args.element).parent().parent()[0] != $(target)[0] && (this.model.allowDragAndDropAcrossControl || (!this.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(this.element))))
                        this._dropAsSiblingNode($(target), $(args.element), pre, args.event);
                }
                else if (target.nodeName == 'A' && $(target).hasClass('e-dropchild') && $(target).hasClass('e-droppable')) {
                    position = "Over";
                    if (($(args.element).parent().parent().has($(target)).length == 0) && ($(target).parent().parent().has($(args.element)).length == 0 || this._isDescendant($(target).parents("li:last").find('>ul>li'), $(args.element).parents("li:first")[0])))
                        this._dropAsChildNode($(target).closest('.e-item'), $(args.element), args.event);
                }
            }
            return position;
        },

        _findTarget: function (trgt) {

            if (trgt.hasClass('e-text')) return trgt.closest('.e-item')

            else if (trgt.closest("ul").closest('.e-item').length > 0) return trgt.closest("ul").closest('.e-item')

            else if (this.element.find(trgt).length > 0 && !this.model.template) return trgt.parents("ul").first()

            else if (this.element.find(trgt).length > 0 && this.model.template) return trgt.closest('.e-item');

            else return trgt;

        },

        _isDescendant: function (src, target) {
            var match = true;
            $(src).each(function (i, item) {
                if (item == target) {
                    match = false;
                    return false;
                }
                else
                    match = true;
            });
            return match;
        },

        _childDrop: function () {
            $(this._treeView).find("ul .e-item div .e-text").ejDroppable({
                accept: $(this._treeView).find("ul .e-item div .e-text").addClass('e-dropchild'),
                drop: function (event, ui) {
                    $(ui.helper).hide();
                }
            });
        },

        _siblingDrop: function () {
            $(this._treeView).find("ul .e-item").addClass('e-dropsibling').ejDroppable({
                drop: function (event, ui) {
                    $(ui.helper).hide();
                }
            });
        },

        _dropAsSiblingNode: function (target, element, pre, event) {
            var li = element.parent().parent(), li = $(li), parentNode;
            parentNode = $(element.parents('.e-item')[1]);
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager))
                this._updateDataSource(element.parents('.e-item:first'), $(target), pre, this);
            pre ? li.insertBefore(target) : li.insertAfter(target);
            (!this.model.template) && this._autoGenerateNodes(element.parents('.e-item:first'));
            this._modifyCss(parentNode);
            this._isRender = false;
            this._updateCheckState(li);
            this._updateCheckState(parentNode);
            this._isRender = true;
            (li.find('> div > .e-minus').length > 0 && !this.model.enableMultipleExpand) && this._denyMultipleExpand(li);
            this._updateChanges($(target));
        },

        _dropAsChildNode: function (target, element, event) {
            var li = element.parent().parent(), li = $(li), parentNode;
            parentNode = $(element.parents('.e-item')[1]);
            ($(target).is('UL')) ? $(target).append(li) : this._appendNode(target, li);
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager))
                this._updateDataSource(element.parents('.e-item:first'), $(target).find("> div > .e-text").first(), "", this);
            (!this.model.template) && this._autoGenerateNodes(element.parents('.e-item:first'));
            this._modifyCss(parentNode);
            this._isRender = false;
            this._updateCheckState(li);
            this._updateCheckState(parentNode);
            this._isRender = true;
            if (target.find('> div > .e-icon.e-plus:first').length > 0) this._expandNode(target);
            this._updateChanges($(target));
        },

        _updateChanges: function (dropEle) {
            if ($(dropEle)[0] != null) {
                var desTree = this, tree = 0;
                do {
                    desTree._updateNodes();
                    tree++;
                    desTree = dropEle.closest('.e-treeview.e-js').data('ejTreeView')
                } while (desTree && this._id != desTree._id && tree == 1);
            }
        },

        _updatePersistProb: function () {
            this._removeField(this._newDataSource, this.model.fields.selected);
            this._removeField(this._newDataSource, this.model.fields.expanded);
            var sleNodes = this.getSelectedNodes();
            for (var l = 0, slelen = sleNodes.length; l < slelen; l++)
                this._updateField(this._newDataSource, $(sleNodes[l]).attr('id'), this.model.fields.selected, true);
            var enodes = this.getExpandedNodes();
            for (var k = 0, nodelen = enodes.length; k < nodelen; k++) {
                this._updateField(this._newDataSource, $(enodes[k]).attr('id'), this.model.fields.expanded, true);
            }
        },

        _orderDataSource: function () {
            this._beforeBaseClass();
            var orderedData = [], datasource = this._newDataSource;
            this._updatePersistProb();
            for (var j = 0, objlen = this._liList.length; j < objlen; j++) {
                for (var i = 0, datalen = datasource.length; i < datalen; i++) {
                    if (!ej.isNullOrUndefined(datasource[i]) && !ej.isNullOrUndefined(datasource[i][this.model.fields.id]) && datasource[i][this.model.fields.id].toString() == $(this._liList[j]).attr('id')) {
                        if ($(this._liList[j]).find('> ul .e-item').length == 0)
                            delete datasource[i][this.model.fields.hasChild];
                        else if (this._templateType == 1)
                            datasource[i][this.model.fields.hasChild] = true;
                        orderedData.push(datasource[i]);
                        break;
                    }
                }
            }
            return orderedData;
        },

        _updateDataSource: function (dragEle, dropEle, before ,obj) {
            if ($(dragEle)[0] != null && $(dropEle)[0] != null) {
                var sourceTree = obj, desTree, pid, indexPos;
                desTree = dropEle.closest('.e-treeview.e-js').data('ejTreeView');

                if (sourceTree && desTree && !ej.isNullOrUndefined(desTree.model.fields) && desTree.dataSource() != null && !(desTree.dataSource() instanceof ej.DataManager)) {
                    if (dropEle.is("A")) {
                        pid = dropEle.closest('.e-item').attr('id');
                        var child = dropEle.closest('.e-item').find('> ul > .e-item');
                        indexPos = (child.length > 0) ? child.length : dropEle.closest('.e-item').index();
                    }
                    else {
                        pid = dropEle.parents('.e-item:first').attr('id');
                        var nextLi = dropEle.next('.e-item'), prevLi = dropEle.prev('.e-item');
                        if (nextLi.length > 0)
                            indexPos = (prevLi.length > 0) ? indexPos = nextLi.index() - 1 : (before) ? indexPos = dropEle.index() : indexPos = nextLi.index();
                        else
                            indexPos = (before) ? dropEle.index() : dropEle.index() + 1;
                    }
                    (desTree) && sourceTree._findAndUpdate(dragEle.attr('id'), pid, sourceTree._newDataSource, indexPos, desTree, dropEle, before);
                }
            }
        },

        _removeObject: function (data, searchId, key) {
            for (var i = 0, len = data.length; i < len; i++) {
                if (!ej.isNullOrUndefined(data[i]) && !ej.isNullOrUndefined(data[i][key]) && data[i][key].toString() == searchId) {
                    data.splice(i, 1);
                    break;
                }
            }
        },

        _getObjectPosition: function (data, searchId, key) {
            for (var i = 0, len = data.length; i < len; i++) {
                if (!ej.isNullOrUndefined(data[i]) && !ej.isNullOrUndefined(data[i][key]) && data[i][key].toString() == searchId) {
                    return i;
                }
                if (data[i].hasOwnProperty('child')) {
                    var pos = this._getObjectPosition(data[i].child, searchId, key);
                    if (pos >= 0) return pos;
                }
            }
            return -1;
        },

        _convertDataSourceTypes: function (data, resultobj) {
            for (var j = 0; j < data.child.length; j++) {
                data.child[j][this.model.fields.parentId] = data[this.model.fields.id];
                resultobj.push(data.child[j]);
                if (data.child[j].hasOwnProperty('child') && data.child[j].child.length > 0) {
                    this._convertDataSourceTypes(data.child[j], resultobj);
                }
            }
            if (data['child']) {
                delete data['child'];
                data[this.model.fields.hasChild] = true;
            }
            return resultobj;
        },

        _childObjectCollection: function (childNodes, groupedObj, resultobj, tempType) {
            for (var j = 0, len = childNodes.length; j < len; j++) {
                var temp = this._getChildNodes(groupedObj, { id: childNodes[j][this.model.fields.id] });
                if (temp) {
                    if (tempType == 2) {
                        if (!resultobj[j].hasOwnProperty('child'))
                            resultobj[j].child = [];
                        resultobj[j].child = this._childObjectCollection(temp, groupedObj, temp, tempType);
                    }
                    else {
                        resultobj = resultobj.concat(temp);
                        resultobj = this._childObjectCollection(temp, groupedObj, resultobj, tempType);
                    }
                }
            }
            return resultobj;
        },

        _updateCopyData: function (i, obj , childNodes) {
            var newTree = obj.model.fields; temp = childNodes, arr = JSON.parse(JSON.stringify(childNodes[i])), proxy = this;
            $.each(this.model.fields, function (key, value) {
                if (key !== "dataSource" || key !== "query")
                    if (temp[i][proxy.model.fields[key]] !== undefined) {
                        delete arr[proxy.model.fields[key]];
                        arr[newTree[key]] = temp[i][proxy.model.fields[key]];
                    }
            })
            var tempArr = $.extend(tempArr, arr, false);
            return tempArr;
        },

        _updateDataFields: function (obj, childNodes, searchId, tree2, templateType) {
            var childData = [];
            for (var j = 0, len = childNodes.length; j < len; j++) {
                if (templateType == 1) {
                    this._removeObject(obj, searchId, this.model.fields.parentId);
                    delete childNodes[j][this.model.fields.parentId];
                    delete childNodes[j][this.model.fields.hasChild];
                }
                if (childNodes[j].hasOwnProperty('child'))
                    childNodes[j].child = this._updateDataFields(obj, childNodes[j].child, childNodes[j][this.model.fields.id], tree2, templateType);
                childData.push(this._updateCopyData(j, tree2, childNodes));
            }
            return childData;
        },

        _findAndUpdate: function (searchId, parentId, obj, index, tree2, dropEle, before) {
            if (ej.isNullOrUndefined(obj)) return;
            if (this._templateType == 1) {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (!ej.isNullOrUndefined(obj[i]) && !ej.isNullOrUndefined(obj[i][this.model.fields.id]) && obj[i][this.model.fields.id].toString() == searchId) {
                        if (this._id == tree2._id) {
                            (!ej.isNullOrUndefined(parentId)) ? (obj[i][this.model.fields.parentId] = parentId) : (delete obj[i][this.model.fields.parentId]);
                            var list = this.dataSource(), proxy = this;
                            if (this._deepWatch) {
                                var remvObj = obj.splice(i, 1);
                                var pos = this._getObjectPosition(list, dropEle.attr("id"), this.model.fields.id);
                                (pos >= 0 && !dropEle.is("A")) ? obj.splice(before ? pos : pos + 1, 0, remvObj[0]) : obj.push(remvObj[0]);
                                this._oldDataSource = JSON.parse(JSON.stringify(obj));
								this.dataSource(obj);
                            }
                            this._templateType = this._getTemplateType(list, this.model.fields);
                            this._dataSource = (this._templateType == 1) ? this._groupingObjects(list, function (list) { return [!ej.isNullOrUndefined(list) && [list[proxy.model.fields.parentId]].toString()]; }) : list;
                        } else {
                            var remObj = [], childNodes, proxy = this, groupedObj, result = [], nodeArr = [];
                            groupedObj = this._groupingObjects(obj, function (obj) { return [!ej.isNullOrUndefined(obj) && [obj[proxy.model.fields.parentId]].toString()]; });
                            nodeArr = obj.splice(i, 1);
                            remObj.push(this._updateCopyData(0, tree2, nodeArr));
                            childNodes = this._getChildNodes(groupedObj, { id: searchId });
                            if (childNodes && childNodes.length > 0)
                                childNodes = this._childObjectCollection(childNodes, groupedObj, childNodes, tree2._templateType);
                            if (tree2._templateType == 2) {
                                if (childNodes && childNodes.length > 0) {
                                    var childData = this._updateDataFields(obj, childNodes, searchId, tree2, this._templateType);
                                    if (!remObj[0].hasOwnProperty('child'))
                                        remObj[0].child = [];
                                    remObj[0].child = childData;
                                }
                                delete remObj[0][tree2.model.fields.parentId];
                                delete remObj[0][tree2.model.fields.hasChild];
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    pos = (pos >= 0 && !dropEle.is("A")) ? (before ? pos : pos + 1) : index;
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, pos) : tree2._newDataSource.splice(pos, 0, remObj[0]);
                                }
                                else {
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, index) : tree2._newDataSource.splice(index, 0, remObj[0]);
                                }
                            } else {
                                if (childNodes && childNodes.length > 0) {
                                    for (var j = 0, len = childNodes.length; j < len; j++) {
                                        this._removeObject(obj, childNodes[j][this.model.fields.id], this.model.fields.id);
                                    }
                                    this._dataSource = (this._templateType == 1) ? this._groupingObjects(obj, function (obj) { return [!ej.isNullOrUndefined(obj) && [obj[proxy.model.fields.parentId]].toString()]; }) : obj;
                                }
                                (parentId) ? (remObj[0][tree2.model.fields.parentId] = parentId) : (delete remObj[0][tree2.model.fields.parentId]);
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    (pos >= 0 && !dropEle.is("A")) ? tree2._newDataSource.splice(before ? pos : pos + 1, 0, remObj[0]) : tree2._newDataSource.push(remObj[0]);
                                }
                                else
                                    tree2._newDataSource.push(remObj[0]);
                                var childData = [];
                                if (childNodes && childNodes.length > 0) {
                                    if (!(this.dataSource() instanceof ej.DataManager)) {
                                        for (var i = 0; i < childNodes.length; i++) {
                                            childData.push(this._updateCopyData(i, tree2, childNodes));
                                        }
                                        childNodes = childData;
                                    }
                                    var collection = tree2._newDataSource = tree2._newDataSource.concat(childNodes);
                                    tree2._dataSource = (tree2._templateType == 1) ? tree2._groupingObjects(collection, function (collection) { return [!ej.isNullOrUndefined(collection) && [collection[tree2.model.fields.parentId]].toString()]; }) : collection;
                                }
                            }
                            if (tree2._deepWatch) {
                                tree2.dataSource(tree2._newDataSource);
                                tree2._oldDataSource = JSON.parse(JSON.stringify(tree2._newDataSource));
                            }
                            if (this._deepWatch) {
                                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
								this.dataSource(this._newDataSource);
                            }
                        }
                        break;
                    }
                }
            }
            else {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (obj[i][this.model.fields.id].toString() == searchId) {
                        var remObj = obj.splice(i, 1);
                        if (this._id == tree2._id) {
                            if (this._deepWatch) {
                                var pos = this._getObjectPosition(this._newDataSource, dropEle.attr("id"), this.model.fields.id);
                                pos = (pos >= 0 && !dropEle.is("A")) ? (before ? pos : pos + 1) : index;
                                (parentId) ? this._changeObjectPos(parentId, remObj, this._newDataSource, pos) : this._newDataSource.splice(pos, 0, remObj[0]);
                                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
								this.dataSource(this._newDataSource);
                            }
                            else
                                (parentId) ? this._changeObjectPos(parentId, remObj, this._newDataSource, index) : this._newDataSource.splice(index, 0, remObj[0]);
                        } else {
                            remObj = this._updateDataFields(obj, remObj, searchId, tree2, this._templateType);
                            if (tree2._templateType == 1) {
                                // convert nested child datasource into id & parentId case datasource
                                var result = [];
                                if (remObj[0].hasOwnProperty('child')) {
                                    result = tree2._convertDataSourceTypes(remObj[0], result);
                                    remObj[0] = remObj.concat(result);
                                } else
                                    remObj[0] = remObj.concat();
                                (parentId) ? (remObj[0][0][tree2.model.fields.parentId] = parentId) : (delete remObj[0][0][tree2.model.fields.parentId]);
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    (pos >= 0 && !dropEle.is("A")) ? tree2._newDataSource.splice(before ? pos : pos + 1, 0, remObj[0][0]) : tree2._newDataSource.push(remObj[0][0]);
                                    tree2._newDataSource = tree2._newDataSource.concat(result);
                                }
                                else
                                    tree2._newDataSource = tree2._newDataSource.concat(remObj[0]);
                            } else {
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    pos = (pos >= 0 && !dropEle.is("A")) ? (before ? pos : pos + 1) : index;
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, pos) : tree2._newDataSource.splice(pos, 0, remObj[0]);
                                }
                                else
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, index) : tree2._newDataSource.splice(index, 0, remObj[0]);
                            }
                            if (tree2._deepWatch) {
                                tree2.dataSource(tree2._newDataSource);
                                tree2._oldDataSource = JSON.parse(JSON.stringify(tree2._newDataSource));
                            }
                            if (this._deepWatch) {
                                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
								this.dataSource(this._newDataSource);
                            }
                        }
                        return true;
                    }
                    else if (obj[i].hasOwnProperty('child')) {
                        if (this._findAndUpdate(searchId, parentId, obj[i].child, index, tree2, dropEle, before))
                            break;
                    }
                }
            }
        },

        _changeObjectPos: function (searchId, remObj, data, index) {
            for (var i = 0, objlen = data.length; i < objlen; i++) {
                if (data[i][this.model.fields.id].toString() == searchId) {
                    if (data[i].hasOwnProperty('child')) {
                        data[i].child.splice(index, 0, remObj[0]);
                    } else {
                        data[i].child = [];
                        data[i].child.push(remObj[0]);
                    }
                    return true;
                }
                else if (data[i].hasOwnProperty('child')) {
                    if (this._changeObjectPos(searchId, remObj, data[i].child, index))
                        break;
                }
            }
        },

        _finalizeEditing: function (element) {
            if ($(element)[0] != null) {
                var thisObj = element.closest('.e-treeview.e-js').data('ejTreeView');
                if (thisObj) {
                    thisObj._preventEditable();
                    thisObj.model.allowEditing && thisObj._allowEditable();
                }
            }
        },

        _updateCheckState: function (element) {
            if (this._isTreeElement(element)) {
                var thisObj = element.closest('.e-treeview.e-js').data('ejTreeView'), chdNodes;
                if (thisObj && thisObj.model.showCheckbox) {
                    chdNodes = element.children('ul').find('.e-item > div > .e-chkbox-wrap > .checked').closest('.e-item').addClass('checked');
                    if (chdNodes.length > 0)
                        thisObj._isCheckedAction();
                    else {
                        var action = (thisObj.isNodeChecked(element)) ? "_nodeCheck" : "_nodeUncheck";
                        thisObj[action](element.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                    }
                }
            }
        },

        _autoGenerateNodes: function (element) {
            if ($(element)[0] != null) {
                var thisObj = element.closest('.e-treeview.e-js').data('ejTreeView');
                if (thisObj && thisObj.model.showCheckbox) {
                    if (element.find(".e-chkbox-wrap").length == 0) {
                        this._checkboxOnTemplate(element[0].children[0]);
                        var subItems = element.find('.e-item');
                        for (var i = 0, len = subItems.length; i < len ; i++)
                            this._checkboxOnTemplate(subItems[i].children[0]);
                        element.find(".nodecheckbox").ejCheckBox({ cssClass: thisObj.model.cssClass, change: thisObj._checkedChange });
                    }
                } else
                    element.find('.e-chkbox-wrap').remove();
            }
        },

        _appendNode: function (element, outerLi) {
            if (this._isTreeElement(element)) {
                var thisObj, outerUl, divTag, nodeid, nodeText, data, parentId, expandList, isExpanded;
                if (element.find('ul')[0] == null) {
                    thisObj = element.closest('.e-treeview.e-js').data('ejTreeView');
                    if (thisObj) {
                        isExpanded = this._isNodeExpanded(element);
                        if (!isExpanded && thisObj.model.loadOnDemand && element.find('> div > div').first().hasClass('e-plus'))
                            thisObj._createChildNodesWhenExpand(element, null, null, null, outerLi, thisObj);
                    }
                    if (!(this.dataSource() instanceof ej.DataManager && thisObj.model.loadOnDemand && element.find('> div > div').first().hasClass('e-plus')))
                        this._doAfterExpand(element, outerLi, thisObj);
                    if (this._deepWatch && (this._templateType == 1)) {
                        this._updateField(this._newDataSource, element.attr("id"), this.model.fields.hasChild, true);
                        this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
						this.dataSource(this._newDataSource);
                    }
                }
                else
                    $(element.find('ul')[0]).append(outerLi);
                (!this.isDisabled(element)) && this._expandNode(element);
            }
            else {
                if (this.element.is('UL')) {
                    this.element.append(outerLi);
                } else if (this.element.children('ul:first').length > 0) {
                    this.element.children('ul:first').append(outerLi);
                } else {
                    outerUl = ej.buildTag("ul.e-treeview-ul", "", {}, { role: "group" });
                    outerUl.append(outerLi);
                    this.element.append(outerUl);
                }
            }
            expandList = this.element.find(".e-item.expanded");
            for (var i = 0; i < expandList.length; i++) {
                (this.model.loadOnDemand && !(this.dataSource() instanceof ej.DataManager)) ? this._createChildNodesWhenExpand($(expandList[i])) : this._expandNode($(expandList[i]));
            }
            expandList.removeClass("expanded");
            this.model.showCheckbox && this._isCheckedAction();
        },

        _doAfterExpand: function (element, outerLi, thisObj) {
            var outerUl = ej.buildTag("ul.e-treeview-ul", "", {}, { role: "group", style: "display:none" });
            $(outerUl).append($(outerLi));
            if ($(element.find('div')[1]).length == 0) {
                var divTag = document.createElement('div');
                divTag.setAttribute('role', 'presentation');
                divTag.className = 'e-icon e-minus';
                $(element.find('div')).append($(divTag));
            } else if (!$(element.find('div')[1]).hasClass('e-minus'))
                $(element.find('div')[1]).addClass('e-icon e-plus');
            if (thisObj && thisObj.model.loadOnDemand && element.find('ul').length > 0)
                element.children('ul').append($(outerLi));
            else
                element.append($(outerUl));
        },

        _modifyCss: function (liElement) {
            liElement = $(liElement);
            if (liElement[0] != null && liElement.find('.e-item').length == 0) {
                liElement.removeClass('e-collapse').attr("aria-expanded", false).find('> div > .e-icon').removeClass('e-icon e-minus').closest('.e-item').find('ul').remove();
                if (this._deepWatch) {
                    this._updateField(this._newDataSource, liElement.attr("id"), this.model.fields.expanded, false);
                    (this._templateType == 1) && this._updateField(this._newDataSource, liElement.attr("id"), this.model.fields.hasChild, false);
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					this.dataSource(this._newDataSource);
                }
            }
        },

        _applyFirstLastChildClass: function () {
            $(this._liList).removeClass('first last').filter(':first-child:not(:last-child)').addClass('first');
            $(this._liList).filter(':last-child').addClass('last');
        },

        _expandEventHandler: function (event) {
            var target = $(event.target), selectedNode, liElement;
            if (target.hasClass("e-icon") || target.closest('.e-item').hasClass("e-node-disable")) return;
            if (!(event.type === "dblclick" && this.model.allowEditing)) {
                event.preventDefault();
                selectedNode = (target.is('A')) ? $(target.siblings('div')) : $(target.parent().siblings('div'));
                if (this.model.fullRowSelect && (target.is('div.e-text-wrap') || target.is('div.e-fullrow')))
                    selectedNode = target.closest('.e-item').find("> .e-text-wrap > div");
                liElement = target.closest('.e-item');
                if (selectedNode.hasClass('e-minus'))
                    this._collpaseNode(liElement);
                else {
                    if (this.model.loadOnDemand && selectedNode.find(".e-item").length == 0) {
                        this._ClickEventHandler({ target: selectedNode[0] });
                    }
                    else this._expandNode(liElement);
                }
            }
        },

        _inlineEdit: function (event) {
            event.preventDefault();
            var target = $(event.target);
            if (!target.hasClass('input-text') && !target.hasClass("e-node-disable") ) {
                if (!target.is('A'))
                    target = target.closest('.e-text');
                if (target.is('A') && !target.hasClass("e-node-disable")) {
                    this._inlineEditAction(target);
                }
            }
            return false;
        },

        _inlineEditAction: function (element) {
            var editTextBox = this.element.find('.e-item > div > .e-text > #Edit_Input');
            (editTextBox[0] == null) && this._createEditTextBox(element);
        },

        _createEditTextBox: function (values) {
            var argsData = { currentElement: values };
            if (this._triggerEvent('beforeEdit', argsData))
                return false;
            var editTextBox = this.element.find('.e-item > div > .e-text > #Edit_Input');
            if (editTextBox[0] == null) {
                var size, textBox = ej.buildTag('Input.input-text#Edit_Input', "", "", { type: 'text', value: $.trim(values.text()).replace(/\n\s+/g, " "), name: 'inplace_value' });
                textBox.width(values.outerWidth() + 5);
                textBox.height(values.outerHeight());
                textBox.addClass("e-tree-input e-textbox");
                this._beforeEditText = values.text();
                values[0].lastChild.nodeValue = "";
                values.addClass('e-editable').append(textBox);
                editTextBox = textBox;
                size = (editTextBox.val().length == '') ? 3 : values.outerWidth() + 20;
                this._mousePositionAtEnd(editTextBox);
                this._currentEditableNode = values;
                this._on(editTextBox, 'keypress', this._editTextBoxKeyPress)
                    ._on(editTextBox, 'keydown', this, this._pressEscKey)
                    ._on(editTextBox, 'mousedown pointerdown MSPointerDown', this, this._preventPropagation)
                    ._on(editTextBox, this.model.expandOn, this, this._preventPropagation)
                    ._on(editTextBox, 'blur', this._focusout);
            }
            return editTextBox;
        },

        _preventPropagation: function (e) {
            e.stopImmediatePropagation();
            this._isTextbox = true;
        },

        _editTextBoxKeyPress: function (event) {
            event.target.size = event.target.value.length + 1;
        },

        _mousePositionAtEnd: function (ctl) {
            (ctl.focus) && ctl.focus();
            (ctl.select) && ctl.select();
            return true;
        },

        _focusElement: function (e) {
            if (this._isTextbox) return;
            if(e && (e.type == "touchstart" || e.type == "pointerdown" || e.type == "MSPointerDown")) {
                var ele = $(e.currentTarget);
                (ele.hasClass("e-text")) && this.selectNode(ele.closest('.e-item'));
            }
            this.element.focus();
        },

        _focusout: function (e) {
            var editTextBox = $(e.currentTarget), data, element;
            this._isTextbox = false;
            data = { id: editTextBox.closest('.e-item').attr('id'), oldText: this._beforeEditText, newText: editTextBox.val() };
            (this._triggerEvent('inlineEditValidation', data)) ? this._cancelAction(editTextBox) : this._saveAction(editTextBox, e);
        },

        _pressEscKey: function (event) {
            event.cancelBubble = true;
            event.returnValue = false;
            var editTextBox = $(event.currentTarget);
            if (editTextBox[0] != null) {
                if (event.keyCode == 13) {
                    event.stopPropagation();
                    this._focusout(event);
                }
                if (event.keyCode == 27)
                    this._cancelAction(editTextBox);
                if (event.keyCode == 13 || event.keyCode == 27) {
                    var browserInfo = ej.browserInfo(), _isIE8;
                    _isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
                    (_isIE8) && this.element.focus();
                }
            }
        },

        _onFocusHandler: function (event) {
            event.preventDefault();
        },

        _onKeyDown: function (currentEle, focusEle) {
            currentEle.find('> div > .e-text:first').removeClass('e-node-focus');
            focusEle.find('> div > .e-text:first').addClass('e-node-focus');
            if (this.model.fullRowSelect) {
                currentEle.removeClass("e-li-focus");
                focusEle.addClass("e-li-focus");
            }
        },

        _KeyPress: function (e) {
            var code, node, element;
            var proxy = this;
            element = (this.element.is("ul")) ? this.element : this.element.find("> ul");
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            if (proxy.model.allowKeyboardNavigation && (proxy.element.find('#Edit_Input').length < 1) && proxy.element.find(".e-chkbox-wrap.e-focus").length < 1) {
                this.element.find(".e-animate").removeClass("e-animate");
                var nextElement, selectedItem, liVisible, activeNode;
                selectedItem = $(element.find(".e-item > div > .e-text.e-active").closest('.e-item')[0]);
                liVisible = element.find('.e-item:visible');
                if (proxy._focusedNode) {
                    activeNode = proxy._focusedNode;
                    proxy._focusedNode = null;
                } else
                    activeNode = element.find('.e-text.e-node-focus').closest('.e-item');
                if (code == 113) {
                    e.preventDefault();
                    var element = (activeNode.length > 0) ? activeNode : selectedItem;
                    if (element.length > 0 && proxy.model.allowEditing && !this.model.template) {
                        e.target = element.find('> div > .e-text:first');
                        proxy._inlineEdit(e);
                    }
                }
                if (code == 40 && !e.altKey) {
                    e.preventDefault();
                    var ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    var nextEle = this._getNextEle(liVisible, ele);
                    if (proxy._KeyPressEventHandler((nextEle.length > 0) ? nextEle : null, proxy, code, e)) return;
                    if (nextEle.length > 0)
                        proxy._onKeyDown(activeNode, nextEle);
                }
                else if (code == 38 && !e.altKey) {
                    e.preventDefault();
                    var ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    var prevEle = this._getPrevEle(liVisible, ele);
                    if (proxy._KeyPressEventHandler((prevEle.length > 0) ? prevEle : null, proxy, code, e)) return;
                    if (prevEle.length > 0)
                        proxy._onKeyDown(activeNode, prevEle);
                }
                else if ((code == 39 && !this.model.enableRTL && !e.altKey) || (code == 37 && this.model.enableRTL)) {
                    e.preventDefault();
                    var nextEle, expandIcon;
                    expandIcon = (activeNode.length > 0) ? activeNode.find('> div > div').first() : selectedItem.find('> div > div').first();
                    nextEle = expandIcon.closest('.e-item');
                    if (expandIcon.hasClass('e-plus')) {
                        if (this.model.loadOnDemand && nextEle.find("> ul .e-item").length == 0) {
                            this._ClickEventHandler({ target: expandIcon[0] });
                        }
                        else this._expandNode($(liVisible[liVisible.index(nextEle)]));
                    } else {
                        var nextEle = this._getNextEle(liVisible, nextEle);
                        if (proxy._KeyPressEventHandler((nextEle.length > 0) ? nextEle : "", proxy, code, e)) return;
                        if (nextEle.length > 0 && nextEle[0] == expandIcon.closest('.e-item').find('ul > .e-item:first')[0] || nextEle.find('ul > .e-item').first().hasClass('e-node-disable'))
                            proxy._onKeyDown(activeNode, nextEle);
                    }
                }
                else if ((code == 37 && !this.model.enableRTL && !e.altKey) || (code == 39 && this.model.enableRTL)) {
                    e.preventDefault();
                    var prevEle, collapseIcon;
                    collapseIcon = (activeNode.length > 0) ? activeNode.find('> div > div').first() : selectedItem.find('> div > div').first();
                    prevEle = collapseIcon.closest('.e-item');
                    if (collapseIcon.hasClass('e-minus')) {
                        this._collpaseNode($(liVisible[liVisible.index(collapseIcon.closest('.e-item'))]));
                    } else {
                        prevEle = $(liVisible[liVisible.index(prevEle)]).closest('ul').closest('.e-item');
                        if (proxy._KeyPressEventHandler((prevEle.length > 0) ? prevEle : "", proxy, code, e)) return;
                        if (prevEle.length > 0) {
                            proxy._onKeyDown(activeNode, prevEle);
                        }
                    }
                }
                else if (code == 36 && !e.altKey) {
                    e.preventDefault();
                    var firstEle, ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    firstEle = $(liVisible).first();
                    if (firstEle.hasClass('e-node-disable') || firstEle.hasClass('hidden'))
                        firstEle = this._getNextEle(liVisible, firstEle);
                    if ((selectedItem.length > 0 && activeNode.length == 0 && selectedItem[0] != firstEle[0]) || (activeNode.length > 0 && activeNode[0] != firstEle[0])) {
                        if (proxy._KeyPressEventHandler(firstEle, proxy, code, e)) return;
                        proxy._onKeyDown(ele, firstEle);
                    }
                }
                else if (code == 35 && !e.altKey) {
                    e.preventDefault();
                    var lastEle, ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    lastEle = $(liVisible).last();
                    if (lastEle.hasClass('e-node-disable') || lastEle.hasClass('hidden'))
                        lastEle = this._getPrevEle(liVisible, lastEle);
                    if ((selectedItem.length > 0 && activeNode.length == 0 && selectedItem[0] != lastEle[0]) || (activeNode.length > 0 && activeNode[0] != lastEle[0])) {
                        if (proxy._KeyPressEventHandler(lastEle, proxy, code, e)) return;
                        proxy._onKeyDown(ele, lastEle);
                    }
                }
                else if (code == 13) {
                    e.preventDefault();
                    var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                    var angEle = currentEle.find('> div > .e-text');
                    angEle.removeClass('e-node-focus');
                    this.model.fullRowSelect && currentEle.removeClass("e-li-focus");
                    angEle.hasClass('e-active') ? (proxy.model.allowMultiSelection && proxy._nodeUnSelectionAction(currentEle, event)) : proxy._nodeSelectionAction(currentEle, e);
                    proxy._focusedNode = currentEle;
                }
                else if (code == 32) {
                    e.preventDefault();
                    var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                    if (currentEle.length > 0 && this.model.showCheckbox) {
                        var chkBoxEle = currentEle.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0];
                        if (chkBoxEle.checked)
                            this._nodeUncheck(chkBoxEle);
                        else
                            this._nodeCheck(chkBoxEle);
                        proxy._focusedNode = currentEle;
                    }
                }
                else if (code == 46) {
                    e.preventDefault();
                    var currentEle = (activeNode.length > 0) ? activeNode : (this.model.allowMultiSelection ? element.find(".e-item > div > .e-text.e-active").closest('.e-item') : selectedItem);
                    (currentEle.length > 0) && this._removeNode(currentEle, e);
                }
                else if (e && e.ctrlKey == true) {
                    if (code == 88 && this.model.allowDragAndDrop && this.model.allowDropChild) {
                        e.preventDefault();
                        var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                        if (currentEle.length > 0) {
                            var parent = currentEle.parents('.e-item:first');
							if (this._triggerEvent('beforeCut', { target: currentEle, nodeDetails: this._getNodeDetails(currentEle), keyCode: code, event: e })) return;
                            this._cutNode = $(liVisible[liVisible.index(currentEle)]).detach();
                            if ($(this._cutNode)[0] != null) {                                
                                this._isRender = false;
                                this.unselectNode(currentEle);
                                if (parent.find('> ul > .e-item').length == 0) {
                                    this.collapseNode(parent);
                                    this._modifyCss(parent);
                                }
                                this._isRender = true;
                                this._triggerEvent('nodeCut', { parentElement: parent, parentDetails: this._getNodeDetails(parent), keyCode: code, event: e });
                            }
                        }
                    }
                    else if (code == 86 && this._cutNode != null && this.model.allowDragAndDrop && this.model.allowDropChild) {
                        e.preventDefault();
                        var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                        currentEle = $(liVisible[liVisible.index(currentEle)]);
                        currentEle.length === 0 && (currentEle = this.element);
                        var element = this._cutNode.find(" > div > .e-text").first();
                        if ($(liVisible).length > 0) {
                            if (this._triggerEvent('beforePaste', { target: currentEle, nodeDetails: this._getNodeDetails(currentEle), keyCode: code, event: e })) return;
                            this._isRender = false;
                            this._dropAsChildNode(currentEle, element, e);
                            this._isRender = true;
                            this._cutNode = null;
                            var currentNode = element.closest('.e-item');
                            this._triggerEvent('nodePaste', { target: currentNode, nodeDetails: this._getNodeDetails(currentNode), keyCode: code, event: e });
                        }
                    }
                    else if (proxy.model.allowMultiSelection)
                        proxy._focusedNode = activeNode;
                }
            }
        },

        _getNextEle: function (liVisible, ele) {
            var index = liVisible.index(ele), nextEle;
            do {
                index++;
                nextEle = $(liVisible[index]);
            }
            while (nextEle.hasClass('e-node-disable') || nextEle.hasClass('hidden'))
            return nextEle;
        },

        _getPrevEle: function (liVisible, ele) {
            var index = liVisible.index(ele), prevEle;
            do {
                index--;
                prevEle = $(liVisible[index]);
            }
            while (prevEle.hasClass('e-node-disable') || prevEle.hasClass('hidden'))
            return prevEle;
        },

        _removeChildNodes: function (obj, groupedObj, id) {
            var len = 0, currentid;
            for (var i = 0; i < groupedObj.length; i++) {
                if (!ej.isNullOrUndefined(groupedObj[i][0][this.model.fields.parentId]) && (groupedObj[i][0][this.model.fields.parentId]).toString() == id) {
                    len = groupedObj[i].length; break;
                }
            }
            for (var i = 0; i < len; i++) {
                for (var j = 0; j < obj.length; j++) {
                    if (!ej.isNullOrUndefined(obj[j][this.model.fields.parentId]) && (obj[j][this.model.fields.parentId]).toString() == id) {
                        if (!ej.isNullOrUndefined(obj[j])) currentid = obj[j][this.model.fields.id].toString();
                        obj.splice(j, 1);
                        this._removeChildNodes(obj, groupedObj, currentid);
                        break;
                    }
                }
            }
        },

        _removeNode: function (node, event) {
            if (node[0] == null) return;
            if (node[0] != null && node.length > 0) {
                var parentNode, currentNode, _dataObj, id, liVisible, childNodes, proxy = this, groupedObj;
                parentNode = $(node[0]).closest('ul').closest('.e-item');
                currentNode = $(node[0]);
                if (this._triggerEvent('beforeDelete', { target: currentNode, nodeDetails: this._getNodeDetails(currentNode), parentElement: (parentNode[0] != null) ? parentNode : null, parentDetails: this._getNodeDetails(parentNode), event: event, removedNodes: node })) return;
                this._isRender = false;
                if (!ej.isNullOrUndefined(this.dataSource()) && this.dataSource().length > 0) {
                    _dataObj = this.dataSource();
                    for (var j = 0, len = node.length; j < len; j++) {
                        var currentNode = $(node[j]);
                        for (var i = 0; i < _dataObj.length; i++) {
                            id = currentNode.attr("id");
                            if ((_dataObj[i][this.model.fields.id]).toString() == id) {
                                groupedObj = this._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [_dataObj[proxy.model.fields.parentId]].toString()]; });
                                _dataObj.splice(i, 1);
                                this._removeChildNodes(_dataObj, groupedObj, id);
                                break;
                            }
                        }
                    }
                    if (this._deepWatch) {
                        this._oldDataSource = JSON.parse(JSON.stringify(_dataObj));
						this.dataSource(_dataObj);
                    }
                }
                node.remove();
                this._modifyCss(parentNode);
                this._updateNodes();
                this._updateCheckState(parentNode);
                this._isRender = true;
                if (this._triggerEvent('nodeDelete', { parentElement: (parentNode[0] != null) ? parentNode : null, parentDetails: this._getNodeDetails(parentNode), event: event, removedNodes: node })) return;
                var proxy = this, _dataObj = this.dataSource();
                setTimeout(function () {
                    if (proxy.dataSource() != null && !(proxy.dataSource() instanceof ej.DataManager))
                        proxy._dataSource = proxy._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [_dataObj[proxy.model.fields.parentId]].toString()]; });
                }, 300);
            }
        },

        _updateNodes: function () {
            this._beforeBaseClass();
            this._applyFirstLastChildClass();
            this._updateExpandedNodes();
            this._updateCheckedNodes();
            this._updateSelectedNode();
        },

        _updateField: function (obj, searchId, fieldName, fieldValue) {
            if (ej.isNullOrUndefined(this.model.fields) || this.dataSource() == null || (this.dataSource() instanceof ej.DataManager) || ej.isNullOrUndefined(obj) || ej.isNullOrUndefined(searchId) || ej.isNullOrUndefined(fieldName)) return;
            if (this._templateType == 1) {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (!ej.isNullOrUndefined(obj[i]) && !ej.isNullOrUndefined(obj[i][this.model.fields.id]) && obj[i][this.model.fields.id].toString() == searchId) {
                        obj[i][fieldName] = fieldValue;
                        if (fieldValue == false) delete obj[i][fieldName];
                        var newobj = obj[i];
                        obj.splice(i, 1, newobj);
                        break;
                    }
                }
            }
            else {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (obj[i][this.model.fields.id].toString() == searchId) {
                        obj[i][fieldName] = fieldValue;
                        if (fieldValue == false) delete obj[i][fieldName];
                        var newobj = obj[i];
                        obj.splice(i, 1, newobj);
                        break;
                    }
                    if (obj[i].hasOwnProperty('child'))
                        this._updateField(obj[i].child, searchId, fieldName, fieldValue);
                }
            }
        },

        _removeField: function (obj, fieldName) {
            if (ej.isNullOrUndefined(this.model.fields) || this.dataSource() == null || (this.dataSource() instanceof ej.DataManager) || ej.isNullOrUndefined(obj)) return;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i][fieldName] != undefined) delete obj[i][fieldName];
                if (obj[i].hasOwnProperty('child'))
                    this._removeField(obj[i].child, fieldName);
            }
        },

        _KeyPressEventHandler: function (nextElement, proxy, code, event) {
            var nodeDetails, data, path, isExpanded;
            if ($(nextElement)[0] != null) {
                isExpanded = this._isNodeExpanded(nextElement);
                nodeDetails = this._getNodeDetails(nextElement);
                path = proxy._getPath(nextElement);
                data = { keyCode: code, currentElement: nextElement, value: nodeDetails.text, isExpanded: isExpanded, path: path, event: event, id: nodeDetails.id, parentId: nodeDetails.parentId };
            } else {
                data = { keyCode: code, currentElement: nextElement, value: "", isExpanded: "", path: "", event: event, id: "", parentId: "" };
            }
            return this._triggerEvent('keyPress', data);
        },

        _documentClick: function (event) {
            if (event.target.id != 'Edit_Input')
                var editTextBox = $('#Edit_Input')[0], aTag, newText;
            if (editTextBox != null) {
                var aTag = $(editTextBox).closest('.e-text')[0], newText = editTextBox.value, parent = $(editTextBox).closest('.e-item');
                $(editTextBox).remove();
                aTag.lastChild.nodeValue = newText;
                $(aTag).removeClass('e-editable').removeAttr('style');
                this._updateField(this._newDataSource, parent.attr('id'), this.model.fields.text, newText);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					this.dataSource(this._newDataSource);
                }
                this._triggerEvent('nodeEdit', { id: parent.attr('id'), oldText: this._beforeEditText, newText: newText, target: parent, nodeDetails: this._getNodeDetails(parent), event: event });
            }
            if (this.element.find(event.target).length == 0) {
                var ele = this.element.find('.e-item > div > .e-text.e-node-focus');
                this._focusedNode = ele.closest('.e-item');
                ele.removeClass('e-node-focus');
            }
            else if ($(event.target).hasClass("e-active"))
                this._focusedNode = this.element.find(event.target).closest('.e-item');
        },

        _saveAction: function (values, event) {
            var newText = values.val(), parent = values.closest('.e-item'), aTag = values.closest('.e-text')[0];
            values.remove();
            if (aTag != null) {
                aTag.lastChild.nodeValue = newText;
                $(aTag).removeClass('e-editable');
                this._updateField(this._newDataSource, parent.attr('id'), this.model.fields.text, newText);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					this.dataSource(this._newDataSource);
                }
                this._triggerEvent('nodeEdit', { id: parent.attr('id'), oldText: this._beforeEditText, newText: newText, target: parent, nodeDetails: this._getNodeDetails(parent), event: event });
                this.element.focus();
                this._focusedNode = parent;
            }
        },

        _cancelAction: function (values) {
            var aTag = values.closest('.e-text')[0];
            values.remove();
            aTag.lastChild.nodeValue = this._beforeEditText;
            $(aTag).removeClass('e-node-hover e-editable');
            this.element.focus();
        },

        _mouseEnterEvent: function (event) {
            this.element.find('.e-node-hover').removeClass("e-node-hover");
            if ($(event.currentTarget).hasClass("e-text") && !$(event.currentTarget).hasClass("e-node-disable"))
                $(event.currentTarget).addClass("e-node-hover");
        },

        _mouseLeaveEvent: function (event) {
            $(event.currentTarget).removeClass("e-node-hover");
        },

        _liMouseEnterEvent: function (event) {
            this.element.find('.e-node-hover').removeClass("e-node-hover");
            this.element.find('.e-li-hover').removeClass("e-li-hover");
            var curLi = $(event.currentTarget).closest('.e-item');
            var curAng = curLi.find("> div .e-text");
            if (curAng.length > 0 && !curAng.hasClass("e-node-disable")) {
                curAng.addClass("e-node-hover");
                curLi.addClass("e-li-hover");
            }
        },

        _liMouseLeaveEvent: function (event) {
            var curLi = $(event.currentTarget).closest('.e-item');
            curLi.find("> div .e-text").removeClass("e-node-hover");
            curLi.removeClass("e-li-hover");
        },

        _onFocusOutHandler: function (event) {
            if (!this._isPopup) this._hidePopup();
            this._isPopup = false;
        },

        _createObjectByText: function (text, targetNode) {
            if (typeof text != "string") return;
            var obj = {};
            obj[this.model.fields.text] = text;
            ($(targetNode)[0] != null) && (obj[this.model.fields.parentId] = targetNode[0].getAttribute('id'));
            return obj;
        },

        _addNodesWhenObject: function (obj, selectedNode) {
            var tempObj = JSON.stringify(this._dataSource), _dataObj = this.dataSource(), parentId, tempType;
            this._dataSource = [];
            if (this.dataSource() != null && this.dataSource() instanceof ej.DataManager)
                _dataObj = [];
            if (selectedNode[0] != null && selectedNode.length > 0)
                parentId = selectedNode[0].getAttribute('id');
            if (ej.isNullOrUndefined(obj.length)) {
                this._dataSource.push(obj);
                if (!ej.isNullOrUndefined(this.dataSource())) {
                    this._setNodeId(obj, this.model.fields);
                    (!ej.isNullOrUndefined(parentId)) && (obj[this.model.fields.parentId] = parentId);
                    _dataObj.push(obj);
                }
            }
            else {
                this._dataSource = obj;
                if (!ej.isNullOrUndefined(this.dataSource())) {
                    for (var j = 0; j < obj.length; j++) {
                        this._setNodeId(obj[j], this.model.fields);
                        if (parentId)
                            obj[j][this.model.fields.parentId] = parentId;
                        else
                            delete obj[j][this.model.fields.parentId];
                        _dataObj.push(obj[j]);
                    }
                }
            }
            tempType = this._templateType;
            this._templateType = 2;
            if (!this._liList)
                this._liList = $("li", this.element);
            var fragmentObj = document.createDocumentFragment();
            for (var i = 0, len = this._dataSource.length ; i < len; i++) {
                fragmentObj.appendChild(this._genTemplate(this._dataSource[i], this.model.fields));
                this._liList.push($(fragmentObj).children()[0]);
            }
            this._templateType = tempType;
            if (this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager)) {
                this._dataSource = JSON.parse(tempObj);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(_dataObj));
					this.dataSource(_dataObj);
                }
            }
            return fragmentObj;
        },

        _setNodeId: function (dataObj, mapper) {
            var mapId = (mapper && mapper.id) ? mapper.id : this.model.fields.id;
            if (ej.isNullOrUndefined(dataObj[mapId]) || dataObj[mapId] == "") {
                dataObj[mapId] = this._id + "_" + this._indexID;
                this._indexID++;
            }
            if (dataObj.hasOwnProperty('child')) {
                var childObj = dataObj.child;
                for (var i = 0, len = childObj.length; i < len; i++) {
                    this._setNodeId(childObj[i], mapper.child);
                }
            }
        },

        _addExpandedNodes: function (index) {
            var _nodes = this.model.expandedNodes;
            this._removeNullInArray(_nodes);
            if ($.inArray(index, _nodes) == -1)
                this.model.expandedNodes.push(index);
            this._persistValues(this.model.expandedNodes, "expandedNodes");
        },

        _removeExpandedNodes: function (index) {
            var _nodes = this.model.expandedNodes;
            if ($.inArray(index, _nodes) > -1) {
                this.model.expandedNodes.splice($.inArray(index, _nodes), 1);
                _nodes.length == 0 && (_nodes.push(-1));
            }
            this._persistValues(this.model.expandedNodes, "expandedNodes");
        },

        _persistValues: function (indexColl, valueType) {
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                var _nodes = indexColl, idColl = [], ele, id;
                for (var i = 0, len = _nodes.length; i < len; i++) {
                    if (!ej.isNullOrUndefined(_nodes[i]) && _nodes[i] >= 0) {
                        ele = this._liList[_nodes[i]], id = $(ele).attr('id');
                        (id) && idColl.push(id);
                    }
                }
                var cookieData = this._getCookies("_persistedValues");
                if (cookieData) {
                    var parsedData = JSON.parse(cookieData);
                    parsedData[valueType] = idColl;
                    parsedData = this._updatePersistAttr(parsedData);
                    this._setCookies("_persistedValues", JSON.stringify(parsedData));
                }
            }
        },

        _updatePersistAttr: function (parsedData) {
            if (ej.isNullOrUndefined(this._ignoreOnPersist)) {
                if ($.inArray('selectedNodes', this._addToPersist) == -1) delete parsedData.selectedNodes;
                if ($.inArray('expandedNodes', this._addToPersist) == -1) delete parsedData.expandedNodes;
                if ($.inArray('checkedNodes', this._addToPersist) == -1) delete parsedData.checkedNodes;
            }
            else {
                if ($.inArray('selectedNodes', this._ignoreOnPersist) > -1) delete parsedData.selectedNodes;
                if ($.inArray('expandedNodes', this._ignoreOnPersist) > -1) delete parsedData.expandedNodes;
                if ($.inArray('checkedNodes', this._ignoreOnPersist) > -1) delete parsedData.checkedNodes;
            }
            return parsedData;
        },

        _onChecked: function (element, args) {
            var liElement = element.closest('.e-item'), isChecked, evt, checknode, data;
            var nodeDetails = this._getNodeDetails(liElement);
            this._CurrenctSelectedNodes.push(nodeDetails.text);
            isChecked = this._isChecked(liElement);
            evt = !ej.isNullOrUndefined(args) ? !ej.isNullOrUndefined(args.event) ? args.event : "" : "";
            data = { currentElement: liElement, id: nodeDetails.id, parentId: nodeDetails.parentId, value: nodeDetails.text, currentNode: this._CurrenctSelectedNodes, currentCheckedNodes: this._checkedArray, isChecked: isChecked, event: evt };
            if (this._isRender) this._triggerEvent('nodeCheck', data);
        },

        _onUnChecked: function (element, args) {
            var liElement = element.closest('.e-item'), isUnChecked, evt, unchecknode, data;
            var nodeDetails = this._getNodeDetails(liElement);
            this._CurrenctSelectedNodes.push(nodeDetails.text);
            isUnChecked = this._isChecked(liElement);
            evt = !ej.isNullOrUndefined(args) ? !ej.isNullOrUndefined(args.event) ? args.event : "" : "";
            data = { currentElement: liElement, id: nodeDetails.id, parentId: nodeDetails.parentId, value: nodeDetails.text, currentNode: nodeDetails.text, currentUncheckedNodes: this._uncheckedArray, isChecked: isUnChecked, event: evt };
            this._triggerEvent('nodeUncheck', data);
        },

        _addCheckNodes: function (item) {
            var checkedArray = this.model.checkedNodes;
            this._removeNullInArray(checkedArray);
            !checkedArray instanceof Array && (checkedArray = []);
            if (checkedArray.indexOf(item) == -1) checkedArray.push(item);
        },

        _removeCheckNodes: function (item) {
            var checkedArray = this.model.checkedNodes;
            !checkedArray instanceof Array && (checkedArray = []);
            var i = checkedArray.indexOf(item);
            if (i != -1) {
                checkedArray.splice(i, 1);
                checkedArray.length == 0 && (checkedArray.push(-1));
            }
        },

        _removeNullInArray: function (array) {
            var i = array.indexOf(-1);
            if (i != -1) array.splice(i, 1);
        },

        _afterInsertingNode: function (outerLi) {
            this._addDragableClass();
            this._finalizeEditing(outerLi);
            var parentLi = outerLi.closest('ul').closest('.e-item');
            this._modifyCss(parentLi);
            this._updateCheckState(parentLi);
            this._isSelectedAction();
            if (parentLi.length > 0 && parentLi.hasClass('e-node-disable'))
                this._nodeDisableAction(parentLi);
            this._updateSelectedNode();
        },

        _insertBeforeOrAfter: function (txtobj, afterEle, before) {
            afterEle = this._getNodeByID(afterEle);
            if (afterEle[0] != null && afterEle.is('LI') && afterEle.hasClass('e-item')) {
                if (this._triggerEvent('beforeAdd', { data: txtobj, targetParent: (afterEle[0] != null) ? afterEle : null, parentDetails: this._getNodeDetails(afterEle) })) return;
                this._isRender = false;
                if (typeof txtobj != 'object')
                    txtobj = this._createObjectByText(txtobj);
                if (typeof txtobj != "object") return;
                (txtobj[this.model.parentId]) && delete txtobj[this.model.parentId];
                outerLi = this._addNodesWhenObject(txtobj, afterEle);
                temp = document.createElement('ul');
                $(temp).append(outerLi); outerLi = $(temp.children);
                this.model.showCheckbox && outerLi.children().find(".nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
                (afterEle.parents('.e-item:first').length > 0) ? afterEle.parents('.e-item:first').append(outerLi) : this.element.append(outerLi);
                this.model.showCheckbox && this._isCheckedAction();
                this._dropAsSiblingNode(afterEle, outerLi.find("> div > .e-text"), before, "");
                this._afterInsertingNode(outerLi);
                this._isRender = true;
                this._triggerEvent('nodeAdd', { data: txtobj, nodes: outerLi, parentElement: (afterEle[0] != null) ? afterEle : null, parentDetails: this._getNodeDetails(afterEle) });
                var proxy = this, _dataObj = this.dataSource();
                setTimeout(function () {
                    if (proxy.dataSource() != null && !(proxy.dataSource() instanceof ej.DataManager))
                        proxy._dataSource = proxy._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [_dataObj[proxy.model.fields.parentId]].toString()]; });
                }, 300);
            }
        },

        _getNodeByID: function (node) {
            if (typeof node != "object" && node != "" && node != undefined) return this.element.find(this._checkValidId(node.toString()));
            node = $(node);
            (node.is("A") && node.hasClass('e-text')) && (node = node.closest('.e-item'));
            return node;
        },

        _checkValidId: function (myid) {
            return (myid[0] == "#") ? myid.replace(/(:|\.|\[|\]|,)/g, "\\$1") : "#" + myid.replace(/(:|\.|\[|\]|,)/g, "\\$1");;
        },

        _isTreeElement: function (node) {
            return $(node)[0] != null && node.is('LI') && node.hasClass('e-item');
        },

        _isUrl: function (url) {
            var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
            return regexp.test(url);
        },

        _getChildUl: function (ele) {
            return this.model.fullRowSelect ? ele.children[2] : ele.children[1];
        },

        _sendAjaxOptions: function (url, trgt) {
            var proxy = this, dataobj, ajaxOptions;
            dataobj = this._getNodeDetails(trgt);
            dataobj['mapper'] = this.model.fields;
            dataobj['model'] = this.model;
            ajaxOptions = {
                url: url, data: dataobj, type: 'POST', async: true, crossDomain: true,
                dataType: 'JSON', contentType: "application/json; charset=utf-8",
                "success": function (data) {
                    try {
                        proxy._ajaxSuccessHandler(data, trgt);
                    } catch (e) { }
                }, "error": function (data) {
                    try {
                        proxy._ajaxErrorHandler(data);
                    } catch (e) { }
                }
            };
            this._sendAjaxRequest(ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions) {
            var temp = JSON.parse(JSON.stringify(ajaxOptions));
            delete temp.success;     // To prevent user to edit ajax success and edit event handler
            delete temp.error;
            if (this._triggerEvent('beforeLoad', { ajaxOptions: temp })) return;
            delete temp.success;
            delete temp.error;
            $.extend(ajaxOptions, temp);  // The modified data will be restored in ajaxOptions
            $.ajax({
                type: ajaxOptions.type,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                async: ajaxOptions.async,
                contentType: ajaxOptions.contentType,
                crossDomain: ajaxOptions.crossDomain,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
            });
        },

        _ajaxSuccessHandler: function (data, targetNode) {
            this._isRender = false;        // To prevent event triggering
            (typeof data == "object") && this.addNode(data, targetNode);
            this._isRender = true;
            this._triggerEvent('loadSuccess', { data: data, targetParent: targetNode, parentDetails: this._getNodeDetails(targetNode) });
        },

        _ajaxErrorHandler: function (args) {
            this._triggerEvent('loadError', { error: args });
        },

        _wireEvents: function () {
            if (this._isDevice && $.isFunction($.fn.tap)) this._on(this.element.find('li'), 'tap', this._ClickEventHandler);
            else this._on(this.element, "click", this._ClickEventHandler)
            this._on(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : this.model.expandOn, this._expandEventHandler)
                ._on(this.element, "focus", this._onFocusHandler)
                ._on(this.element, "blur", this._onFocusOutHandler);
            this._wholeRowEvents("_on");
			this.model.allowEditing && this._allowEditable();
			this.model.allowDragAndDrop && this._addDragableClass();
			this.model.showCheckbox && this.element.find('.nodecheckbox').ejCheckBox("enable");
            this.model.allowKeyboardNavigation && this._on(this.element, "keydown", this._KeyPress);
        },

        _unWireEvents: function () {
            if (this._isDevice && $.isFunction($.fn.tap)) this._off(this.element.find('li'), "tap")
            else this._off(this.element, "click")
            this._off(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : this.model.expandOn)
                ._off(this.element, "focus")
                ._off(this.element, "blur");
            this._wholeRowEvents("_off");
            this._preventEditable();
            this._preventDraggable();
            this.model.allowKeyboardNavigation && this._off(this.element, 'keydown');
            this.model.showCheckbox && this.element.find('.nodecheckbox').ejCheckBox("disable");
        },

        _wholeRowEvents: function (action) {
            if (this.model.fullRowSelect) {
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchstart)) ? "touchstart" : "mouseenter", ".e-text-wrap", this._liMouseEnterEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchend)) ? "touchend" : "mouseleave", ".e-text-wrap", this._liMouseLeaveEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchstart)) ? "touchstart" : "mouseenter", ".e-fullrow", this._liMouseEnterEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchend)) ? "touchend" : "mouseleave", ".e-fullrow", this._liMouseLeaveEvent);
            }
            else {
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchstart)) ? "touchstart" : "mouseenter", ".e-text", this._mouseEnterEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchend)) ? "touchend" : "mouseleave", ".e-text", this._mouseLeaveEvent);
            }
        },

        _enableDragDrop: function () {
            if (this.model.allowDragAndDrop) {
                this._drag();
                this.model.allowDropChild && this._childDrop();
                this.model.allowDropSibling && this._siblingDrop();
            }
        },

        _allowEditable: function () {
            if (!this.model.template) {
                this.element.find('.e-item').addClass('AllowEdit');
                this._on($(document), 'click', this._documentClick)
                    ._on(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? 'doubletap' : 'dblclick', "a.e-text", this._inlineEdit);
            }
        },

        _preventEditable: function () {
            this.element.find('.e-item').removeClass('AllowEdit');
            this._off($(document), 'click')
                ._off(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? 'doubletap' : 'dblclick', "a.e-text");
        },

        _preventDraggable: function () {
            this.element.find('.e-draggable, .e-droppable').removeClass("e-draggable e-droppable");
            this._preventDropSibling();
            this._preventDropChild();
            this._off(this.element, "mouseup touchstart pointerdown MSPointerDown", this._anchors, this._focusElement);
        },

        _preventDropSibling: function () {
            this.element.find('.e-dropsibling').removeClass("e-dropsibling");
        },

        _preventDropChild: function () {
            this.element.find('.e-item > div > .e-dropchild').removeClass("e-dropchild");
        },

        _getNodeData: function (id) {
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager) && id != undefined) {
                this._updatePersistProb();
                var newList = [];
                if (this._templateType == 2) {
                    newList = ej.DataManager(this._newDataSource).executeLocal(ej.Query().where(this.model.fields.id, "equal", id, false));
                } else {
                    var predicats = [];
                    var list = this._newDataSource;
                    var query1 = ej.Query().where(this.model.fields.id, "equal", id, false);
                    var filteredList = ej.DataManager(list).executeLocal(query1);
                    var filters = this._getFilterItems(filteredList[0], list);
                    for (var i = 0, flen = filters.length; i < flen; i++) {
                        predicats.push(new ej.Predicate(this.model.fields.id, 'equal', filters[i], false));
                    }
                    var query = ej.Query().where(ej.Predicate.or(predicats));
                    newList = ej.DataManager(list).executeLocal(query);
                }
                for (var k = 0, dlen = newList.length; k < dlen; k++) {
                    if ($(document.getElementById(newList[k][this.model.fields.id])).find('> ul .e-item').length == 0)
                        delete newList[k][this.model.fields.hasChild];
                    else if (this._templateType == 1)
                        newList[k][this.model.fields.hasChild] = true;
                }
                return newList;
            }
        },

        _getFilterItems: function (fList, list) {
            var nodes = [];
            nodes.push(fList.id);
            var query2 = ej.Query().where(this.model.fields.parentId, 'equal', fList.id, false);
            var fList1 = ej.DataManager(list).executeLocal(query2);
            for (var l = 0, nlen = fList1.length; l < nlen ; l++) {
                var cNode = this._getFilterItems(fList1[l], list);
                for (var i = 0, clen = cNode.length; i < clen; i++) {
                    nodes.push(cNode[i]);
                }
            }
            return nodes;
        },

        refresh: function () {
            this._unWireEvents();
            this.element.html("");
            this._init();
        },

        expandAll: function (level, excludeHiddenNodes) {
            if (this.model.enableMultipleExpand)
                (level > 0) ? this._expandByLevel(this._getElement(), level, excludeHiddenNodes) : this._expandAll(excludeHiddenNodes);
        },

        collapseAll: function (level, excludeHiddenNodes) {
            if (this.model.enableMultipleExpand)
                (level > 0) ? this._collapseByLevel(this._getElement(), level, excludeHiddenNodes) : this._collapseAll(excludeHiddenNodes);
        },

        checkAll: function () {
            this.model.showCheckbox && this._checkAll();
        },

        unCheckAll: function () {
            this.model.showCheckbox && this._uncheckAll();
        },

        selectNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                this._unselectAll();
                this._doSelectNodes(node, true);
            }
            else {
                node = this._getNodeByID(node);
                this._isTreeElement(node) && this._nodeSelectionAction(node);
            }
        },

        unselectNode: function (node) {
            if (node && typeof node == "object" && node.length > 0)
                this._doUnselectNodes(node);
            else {
                node = this._getNodeByID(node);
                this._isTreeElement(node) && this._nodeUnSelectionAction(node);
            }
        },

        selectAll: function () {
            this.model.allowMultiSelection && this._selectAll();
        },

        unselectAll: function () {
            this.model.allowMultiSelection && this._unselectAll();
        },

        enableNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.enableNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeEnableAction(item);
            }
        },

        disableNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.disableNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeDisableAction(item);
            }
        },

        addNodes: function (collection, targetNode) {
            if (collection && typeof collection == "object" && targetNode == undefined && collection.length > 0) {
                for (var i = 0; i < collection.length; i++)
                    this.addNode(collection[i], targetNode);
            }
            else this.addNode(collection, targetNode);
        },

        addNode: function (newNodeText, targetNode) {
            if (ej.isNullOrUndefined(newNodeText)) return;
            var outerLi = null, innerUl = null, temp, activeNode, id, selectedNode, template;
            selectedNode = targetNode ? this._getNodeByID(targetNode) : (this.model.allowMultiSelection ? this.getSelectedNodes() : this.getSelectedNode());
            if (typeof newNodeText == 'object') {
                if (ej.isNullOrUndefined(newNodeText.length) && !ej.isNullOrUndefined(newNodeText[this.model.fields.parentId]))
                    id = newNodeText[this.model.fields.parentId];
                else if (!ej.isNullOrUndefined(newNodeText.length) && newNodeText.length == 1)
                    id = newNodeText[0][this.model.fields.parentId];
                if (id) selectedNode = this._getNodeByID(id);
            }
            selectedNode = (this._isTreeElement(selectedNode)) ? $(selectedNode[0]) : [];
            if (this._triggerEvent('beforeAdd', { data: newNodeText, targetParent: (selectedNode[0] != null) ? selectedNode : null, parentDetails: this._getNodeDetails(selectedNode) })) return;
            (selectedNode.length != 0 && !selectedNode.hasClass('e-node-disable')) && this._expandNode(selectedNode);
            if (typeof newNodeText != 'object')
                newNodeText = this._createObjectByText(newNodeText, selectedNode);
            if (typeof newNodeText != "object" || (ej.isNullOrUndefined(newNodeText.length) && newNodeText.length == 0)) return;
            outerLi = this._addNodesWhenObject(newNodeText, selectedNode);
            temp = document.createElement('ul');
            $(temp).append(outerLi); outerLi = $(temp.children);
            this.model.showCheckbox && outerLi.children().find(".nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            this._appendNode(selectedNode, outerLi);
            if (selectedNode[0] != null) {
                var imgTag = $(selectedNode[0].childNodes[0].childNodes[0]);
                (imgTag.hasClass('e-plus') || imgTag.hasClass('e-minus')) ? imgTag.removeClass('e-load') : imgTag.removeClass('e-icon e-load');
            }
            (selectedNode[0] != null && selectedNode.find('> div > .e-minus').length > 0 && !this.model.enableMultipleExpand) && this._denyMultipleExpand(selectedNode);
            this._updateNodes();
            this._afterInsertingNode(outerLi);
            this._triggerEvent('nodeAdd', { data: newNodeText, nodes: outerLi, parentElement: (selectedNode[0] != null) ? selectedNode : null, parentDetails: this._getNodeDetails(selectedNode) });
            var proxy = this, _dataObj = this.dataSource();
            setTimeout(function () {
                if (proxy.dataSource() != null && !(proxy.dataSource() instanceof ej.DataManager))
                    proxy._dataSource = proxy._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [_dataObj[proxy.model.fields.parentId]].toString()]; });
            }, 300);
        },

        removeNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.removeNode(node[i]);
            }
            else {
                var item = node ? this._getNodeByID(node) : (this.model.allowMultiSelection ? this.getSelectedNodes() : this.getSelectedNode());
                this._isTreeElement(item) && this._removeNode(item);
            }
        },

        removeAll: function () {
            this._liList.remove();
            this._updateNodes();
        },

        checkNode: function (node) {
            if (!this.model.showCheckbox) return;
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.checkNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeCheck(item.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
            }
        },

        uncheckNode: function (node) {
            if (!this.model.showCheckbox) return;
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.uncheckNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeUncheck(item.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
            }
        },

        expandNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                this._allowOnDemand = true;
                this._expandNodes(node, true);
                this._allowOnDemand = false;
            }
            else {
                node = this._getNodeByID(node);
                if (this._isTreeElement(node)) {
                    this._allowOnDemand = true;
                    this._expandNode(node);
                    this._allowOnDemand = false;
                }
            }
        },

        collapseNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.collapseNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._collpaseNode(item);
            }
        },

        showNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.showNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && item.css("visibility", "").removeClass('hidden');
            }
        },

        hideNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.hideNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && item.css("visibility", "hidden").addClass('hidden');
            }
        },

        show: function () {
            this.element.css("visibility", "").find('.e-item').removeClass('hidden');
        },

        hide: function () {
            this.element.css("visibility", "hidden").find('.e-item').addClass('hidden');
        },

        hasChildNode: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return node.find('> ul > .e-item').length > 0 ? true : false;
        },

        isChildLoaded: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && node.find('ul > .e-item').length > 0) ? true : false;
        },

        isNodeChecked: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return this._isChecked(node);
        },

        isExpanded: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return this._isNodeExpanded(node);
        },

        isVisible: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && node.css("visibility") != "hidden") ? true : false;
        },

        isExist: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && this._liList.index(node) != -1) ? true : false;
        },

        isSelected: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node)) return node.find('> div > .e-text').hasClass('e-active');
        },

        isDisabled: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && node.hasClass('e-node-disable')) ? true : false;
        },

        getTreeData: function (id) {
            if (id != undefined)
                return this._getNodeData(id);
            else if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager))
                return this._orderDataSource();
        },

        getText: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return $.trim(this.element.find(node).find('> div > .e-text').text());
        },

        getSelectedNode: function () {
            return !this.model.allowMultiSelection ? this.element.find('.e-item > div > .e-active').closest('.e-item') : null;
        },

        getSelectedNodes: function () {
            return this.element.find('.e-item > div > .e-active').closest('.e-item');
        },

        getCheckedNodes: function () {
            if (this.model.showCheckbox)
                return this._liList.find('> div > .e-chkbox-wrap[aria-checked="true"]').closest('.e-item');
        },

        getExpandedNodes: function () {
            return this.element.find('.e-item > div > .e-minus').closest('.e-item');
        },

        getExpandedNodesIndex: function () {
            return this._getNodesIndex(this.getExpandedNodes());
        },

        getCheckedNodesIndex: function () {
            return this._getNodesIndex(this.getCheckedNodes());
        },

        getSelectedNodeIndex: function () {
            return !this.model.allowMultiSelection ? this._getNodesIndex(this.getSelectedNode()) : null;
        },

        getSelectedNodesIndex: function () {
            return this._getNodesIndex(this.getSelectedNodes());
        },

        getVisibleNodes: function () {
            return this.element.find('.e-item:visible:not(.hidden, .e-node-disable)');
        },

        getNodeCount: function () {
            return this.element.find('.e-item').length;
        },

        getNode: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node)) ? this._getNodeDetails(node) : null;
        },

        getNodeIndex: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return this._liList.index(node);
        },

        getNodeByIndex: function (index) {
            if (typeof index == "number")
                return $(this._liList[index]);
        },

        getParent: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return node.parents('.e-item:first');
        },

        getChildren: function (node, includeNestedChild) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return includeNestedChild ? node.find('.e-item') : node.find('> ul > .e-item');
        },

        updateText: function (node, newText) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node) && !ej.isNullOrUndefined(newText)) {
                var aTag = this.element.find(node).children('div').find('> .e-text')[0], oldText, argsData;
                if (aTag != null) {
                    argsData = { currentElement: $(aTag) };
                    if (this._triggerEvent('beforeEdit', argsData))
                        return false;
                    oldText = aTag.lastChild.nodeValue;
                }
                aTag.lastChild.nodeValue = newText;
                this._updateField(this._newDataSource, node.attr('id'), this.model.fields.text, newText);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					 this.dataSource(this._newDataSource);
                }
                this._triggerEvent('nodeEdit', { id: node.attr('id'), oldText: oldText, newText: newText, target: node, nodeDetails: this._getNodeDetails(node), event: null });
            }
        },

        insertAfter: function (nodeObj, afterEle) {
            this._insertBeforeOrAfter(nodeObj, afterEle, false);
        },

        insertBefore: function (nodeObj, afterEle) {
            this._insertBeforeOrAfter(nodeObj, afterEle, true);
        },

        moveNode: function (srcNode, desNode, index) {
            srcNode = this._getNodeByID(srcNode);
            desNode = this._getNodeByID(desNode);
            if (this._isTreeElement(srcNode)) {
                if ((srcNode.parents('.e-item')[0] == desNode[0] && ej.isNullOrUndefined(index)) || desNode.find(srcNode).index() == index || (desNode[0] == null && this._liList.index(srcNode) == index)) return;
                var target = (desNode[0] != null && index >= 0) ? desNode.find("> ul > .e-item").eq(index) : this.getNodeByIndex(index);
                this._isRender = false;
                if (this._isTreeElement(target)) {
                    if (target.parents('.e-item:first')[0] == srcNode.parents('.e-item:first')[0] && target.next('.e-item')[0] == null)
                        this._dropAsSiblingNode(target, srcNode.find(" > div > .e-text"), false, "");
                    else
                        this._dropAsSiblingNode(target, srcNode.find(" > div > .e-text"), true, "");
                } else {
                    this._dropAsChildNode(desNode, srcNode.find(" > div > .e-text"), "");
                }
                if (desNode.length > 0 && desNode.hasClass('e-node-disable'))
                    this._nodeDisableAction(desNode);
                this._isRender = true;
            }
        },

        loadData: function (url, targetNode) {
            targetNode = this._getNodeByID(targetNode);
            if (this._isUrl(url) && (targetNode[0] == null || (this._isTreeElement(targetNode))))
                this._sendAjaxOptions(url, targetNode);
        },

        ensureVisible: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node) && !this.isDisabled(node) && this.isVisible(node)) {
                var parents = node.parents('.e-item'), offset;
                for (var j = 0, len = parents.length; j < len; j++)
                    this._expandNode($(parents[j]));
                offset = node.offset();
                node.animate({ scrollTop: offset.top }, this.model.enableAnimation ? 350 : 0, 'linear', function () {
                    node.find("> div > a.e-text")[0].scrollIntoView(false);
                });
                return true;
            } else
                return false;
        },

        _triggerEvent: function (e, data) {
            if (this._isRender) return this._trigger(e, data);
        },

    });
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejUploadbox", "ej.Uploadbox", {

        element: null,
		_addToPersist: [""],
        model: null,
        validTags: ["div", "span"],
        _setFirst: false,

        _rootCSS: "e-uploadbox",

        defaults: {

            buttonText: {

                browse: "Browse",

                upload: "Upload",

                cancel: "Cancel",

                close: "Close",
            },

            width: "100px",

            height: "35px",

            htmlAttributes: {},

            dialogPosition: { X: "", Y: "" },

            dialogText: {

                title: "Upload Box",

                name: "Name",

                size: "Size",

                status: "Status"
            },

            customFileDetails: {

                title: true,

                name: true,

                size: true,

                status: true,

                action: true
            },

            dialogAction: {

                modal: false,

                closeOnComplete: false,

                drag: true,

                content: null

            },

            locale: "en-US",

            asyncUpload: true,

            pushFile: null,

            enabled: true,

            multipleFilesSelection: true,

            autoUpload: false,

            showFileDetails: true,

            fileSize: 31457280,

            extensionsAllow: "",

            extensionsDeny: "",

            saveUrl: "",

            removeUrl: "",

            uploadName: "",

            cssClass: "",

            dropAreaText: "Drop files or click to upload",

            allowDragAndDrop: false,

            showBrowseButton: true,

            showRoundedCorner: true,

            dropAreaHeight: "100%",

            dropAreaWidth: "100%",

            enableRTL: false,

            create: null,

            fileSelect: null,

            begin: null,
			
			beforeSend:null,

            cancel: null,

            inProgress: null,
            
            success: null,

            complete: null,

            remove: null,

            error: null,

            destroy: null
        },


        dataTypes: {
            buttonText: "data",
            dialogText: "data",
            disbled: "boolean",
            customFileDetails: "data",
            pushFile: "data",
            dialogAction: "data",
            multipleFilesSelection: "boolean",
            autoUpload: "boolean",
            showFileDetails: "boolean",
            allowDragAndDrop: "boolean",
            showBrowseButton: "boolean",
            showRoundedCorner: "boolean",
            fileSize: "number",
            extensionsAllow: "string",
            extensionsDeny: "string",
            saveUrl: "string",
            removeUrl: "string",
            cssClass: "string",
            enableRTL: "boolean",
            htmlAttributes: "data"
        },



        disable: function () {
            this._changeState(false);
        },

        enable: function () {
            this._changeState(true);
        },
		
        _changeState: function (state) {
            state ? $(this.control).removeClass("e-disable") : $(this.control).addClass("e-disable");
            this.model.enabled = state;
            $(this._currentElement).find(".e-uploadinput")[0].disabled = !state;
            if (this.diaObj) {
                this.diaObj.option("beforeClose", this._onBeforeClose);
                this.diaObj.setModel({ enabled: state, allowDraggable: state });
            }
        },

        refresh: function () {
            if (this.diaObj) {
                if (this.diaObj.isOpened())
                    this.diaObj.close();
                else
                    this._uploadFileListDelete();
            }
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.Uploadbox", this.model.locale);
        },
        _init: function () {
            this.s = ej.browserInfo();
            this._updateLocalConstant();
            this._initialize();
            this._wireEvents();
            /*Sync Uploads*/
            if (!this.model.asyncUpload) {
                this._initObjectsSyncUpload();
            }
            this._controlStatus(this.model.enabled);
            this.model.locale == "en-US" ? this._buttonText(this.model.buttonText) : this._setLocale();
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "buttonText":
                        this._buttonText(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "dialogText":
                        this._dialogText(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._updateLocalConstant();
                        this._setLocale();
                        break;
                    case "height":
                        this.model.height = options[option];
                        this._setHeight(this.model.height);
                        break;
                    case "width":
                        this.model.width = options[option];
                        this._setWidth(this.model.width);
                        break;
                    case "dialogPosition":
                        this.model.dialogPosition = options[option];
                        this._dialogPosition();
                        break;
                    case "allowDragAndDrop":
                        this.model.allowDragAndDrop = options[option];
                        this._dragAndDrop();
                        break;
                    case "dropAreaText":
                        this.model.dropAreaText = options[option];
						this._dropAreaText(this.model.dropAreaText);
                        break;
                    case "showBrowseButton":
                        this.model.showBrowseButton = options[option];
                        this._hideBrowseButton();
						this._refreshUploadDialogParent();
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "dropAreaHeight":
                        this.model.dropAreaHeight = options[option];
                        this._setSize();
                        break;
                    case "dropAreaWidth":
                        this.model.dropAreaWidth = options[option];
                        this._setSize();
                        break;
                    case "pushFile":
                        this.model.pushFile = options[option];
                        if (this.model.pushFile != null && this.UploadType == "Xhr" && this.model.asyncUpload) this._files = this.model.pushFile; this._onXhrSelect();
                        break;
                    case "multipleFilesSelection":
                        this.model.multipleFilesSelection = options[option];
						 if (((navigator.userAgent.indexOf('Safari') != -1 )&& (navigator.userAgent.indexOf('Chrome') == -1 ))==false)
                        if (this.model.multipleFilesSelection)
                            this._currentElement.find(".e-uploadinput").attr('multiple', 'multiple');
                        else
                            this._currentElement.find(".e-uploadinput").removeAttr('multiple');
                        break;
                    case "uploadName":
                        this.model.uploadName = options[option];
                        this.inputupload.attr('name', this.model.uploadName);
                        this.refresh();
                        break;
                    case "autoUpload":
                        this.model.autoUpload = options[option];
                        break;
                    case "showFileDetails":
                        this.model.showFileDetails = options[option];
                        this.refresh();
                        break;
                    case "fileSize":
                        this.model.fileSize = options[option];
                        break;
                    case "extensionsAllow":
                        this.model.extensionsAllow = options[option];
						this._currentElement.find(".e-uploadinput").attr('accept', options[option]);
                        break;
                    case "extensionsDeny":
                        this.model.extensionsDeny = options[option];
                        break;
                    case "saveUrl":
                        this.model.saveUrl = options[option];
                        break;
                    case "removeUrl":
                        this.model.removeUrl = options[option];
                        break;
                }
                this._currentElement = this.model.allowDragAndDrop && !this.model.showBrowseButton ? this.dragWrapper : this.element;
            }
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _setRTL: function (val) {
            val ? this._currentElement.addClass("e-rtl") : this._currentElement.removeClass("e-rtl");
            if (this.updialog) this.updialog.ejDialog({ enableRTL: val });
        },
        _getLocalizedLabels: function (property) {
            var textType,targetText="";
            if (property == "browse" || property == "upload" || property == "cancel" || property == 'close')
                textType = "buttonText";
            else
                textType = "dialogText";
            if(this._localizedLabels[property])
                targetText =this._localizedLabels[property];
            else if(this._localizedLabels[textType][property])
                targetText =this._localizedLabels[textType][property];
            else if(ej.Uploadbox.Locale["en-US"][property])
                targetText =ej.Uploadbox.Locale["en-US"][property];
            else if(ej.Uploadbox.Locale["en-US"][textType][property]) 
                targetText =ej.Uploadbox.Locale["en-US"][textType][property];
            return targetText;
        },

        _setLocale: function () {
            this._buttonText(this._localizedLabels.buttonText);
            this._dialogText(this._localizedLabels.dialogText);
            this._dropAreaText(this._localizedLabels.dropAreaText);
        },

        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            this.buttondiv.val(this.model.buttonText.browse);
            if (this.updialog) {
                this.updialog.find(".e-action-container .e-uploadbtn").html(this.model.buttonText.upload);
                this.updialog.find(".e-action-container .e-uploadclosebtn").html(this.model.buttonText.cancel);
            }
        },

        _dialogText: function (data) {
            $.extend(this.model.dialogText, data);
            if (!(this.diaObj == undefined))
                this.diaObj.option('title', this.model.dialogText.title);
            if (this.updialog) {
                this.updialog.find('.e-head-name').html(this.model.dialogText.name);
                this.updialog.find('.e-head-size').html(this.model.dialogText.size);
                this.updialog.find('.e-head-status').html(this.model.dialogText.status);
            }
        },


        _destroy: function () {
            if (this._currentElement.hasClass("e-uploadbox")) {
                this._currentElement.removeClass("e-uploadbox e-widget");
                this._currentElement.empty();
                $(this.dragWrapper).after(this._currentElement);
				this.element.css({"width": "", "height": ""});
                this._bindResizeHandler(false);
                this.dragWrapper.remove();
            }
        },

        _setSkin: function (skin) {
            this._currentElement.removeClass(this.model.cssClass);
            this._currentElement.addClass(skin);
			if (this.diaObj)
                this.diaObj.setModel({ cssClass:this.model.cssClass });
			if (this.model.allowDragAndDrop) this.dragWrapper.addClass(skin);
        },


        _initialize: function () {
            this.control = this.element[0];
            this.element.addClass("e-widget " + this.model.cssClass);
            this.innerdiv = ej.buildTag('div.e-selectpart e-select e-box');
            this.element.append(this.innerdiv);
            this.buttondiv = ej.buildTag('input.e-inputbtn e-btn#' + this.control.id + '_SelectButton', '', {}, { type: 'button', "data-role": "none", value: this._getLocalizedLabels("browse") });
            this.inputupload = ej.buildTag('input.e-uploadinput', "", {}, { type: 'file', "data-role": "none", name: this.model.uploadName != "" ? this.model.uploadName : this.control.id }).attr("accept",this.model.extensionsAllow);
            if (this.model.multipleFilesSelection) 
			if (((navigator.userAgent.indexOf('Safari') != -1 )&& (navigator.userAgent.indexOf('Chrome') == -1 ))==false){
                this.inputupload.attr('multiple', 'multiple');
            }
            this.innerdiv.append(this.buttondiv);
            this.innerdiv.append(this.inputupload);
            if (this.model.allowDragAndDrop) this._dragAndDrop(true);
            this._Selector = this.buttondiv[0];
            this._currentElement = this.model.allowDragAndDrop && !this.model.showBrowseButton ? this.dragWrapper : this.element;
            this._setRTL(this.model.enableRTL);
            this._addAttr(this.model.htmlAttributes);
            this.Uploadframes = []; //For IFrame
            this.UploadForms = [];
            this._successFiles = [];
			this._errorFiles = [];
            this.UploadType = this._isXhrSupported() ? "Xhr" : "IFrame";
            if (this.model.width != "") this._setWidth(this.model.width);
            if (this.model.height != "") this._setHeight(this.model.height);
            this._hideBrowseButton();
        },		
        _refreshUploadDialogParent: function () {
            if (this.diaObj)
                this.diaObj.setModel({ target: (this.model.dialogAction.content != null && this.model.dialogAction.content != "") ? this.model.dialogAction.content : (!this.model.showBrowseButton) && (this.model.allowDragAndDrop) ? "#" + this.control.id + '_dragWrapper' : "#" + this.control.id });
        },
        _hideBrowseButton: function () {
            if ((!this.model.showBrowseButton) && (this.model.allowDragAndDrop)) {
                this.element.addClass("e-browse-hide");
                this._dropAreaSize();
            }
            else {
                if (this.element.hasClass("e-browse-hide")) {
                    this.element.removeClass("e-browse-hide");
                    this.element.width(this.model.width);
                    this.element.height(this.model.height);
                }
            }
        },
        _setSize: function () {
            if (this.model.allowDragAndDrop) {
                if (this.model.dropAreaWidth != "") this.dragWrapper.outerWidth(this.model.dropAreaWidth);
                if (this.model.dropAreaHeight != "") this.dragWrapper.outerHeight(this.model.dropAreaHeight);
                if (!this.model.showBrowseButton) this._dropAreaSize();
            }
        },

        _dropAreaSize: function () {
            if (this.model.dropAreaWidth != "") this.element.width(this.model.dropAreaWidth);
            if (this.model.dropAreaHeight != "") this.element.height(this.model.dropAreaHeight);
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },

        _dragAndDrop: function () {
            if (this.model.allowDragAndDrop) {
                this.dragWrapper = ej.buildTag("div.e-drag-wrapper e-widget-wrapper e-upload-box " + this.model.cssClass + "#" + this.control.id + '_dragWrapper')
                this.innerWrapper = ej.buildTag("div.e-drag-container");
                this._spanTag = ej.buildTag("span.e-drag-text").html(this.model.locale == "en-US" ? this.model.dropAreaText : ej.Uploadbox.Locale[this.model.locale].dropAreaText);
                this.innerWrapper.append(this._spanTag);
                this.innerWrapper.insertBefore(this.element);
                this.dragWrapper.insertBefore(this.element);
                this.innerWrapper.append(this.element);
                this.dragWrapper.append(this.innerWrapper);
                this._bindDragEvents();
                this._refreshUploadDialogParent();
                this._setSize();
            }
            else {
                this._refreshUploadDialogParent();
                this.element.insertBefore(this.dragWrapper);
                this.dragWrapper.remove();
                this._unBindDragEvents();
            }
            this._hideBrowseButton();
        },
        _resizeHandler: function () {
            if (this.diaObj) {
                if ($(window).width() > 750) {
                    $(this.updialog).closest('.e-dialog.e-uploadbox').removeClass("e-mobile-upload");
                    this.diaObj.setModel({ width: this._getDialogContentWidth(), height: "auto" });
                }
                else {
                    $(this.updialog).closest('.e-dialog.e-uploadbox').addClass("e-mobile-upload");
                    this.diaObj.setModel({ width: 250, height: "auto"});
                }
                if (this.diaObj.scroller) this.diaObj.scroller.setModel({ height: "auto" });
            }
        },
        _getDialogContentWidth: function () {
            var dialogWidth = 0;
            if (this.model.customFileDetails.name)   dialogWidth = dialogWidth + 200;
            if (this.model.customFileDetails.size)  dialogWidth = dialogWidth + 100;
            if (this.model.customFileDetails.status) dialogWidth = dialogWidth + 200; 
            else if (this.model.customFileDetails.action) dialogWidth = dialogWidth + 45;
            return dialogWidth+5;
        },
		_dropAreaText: function (areaText) {
            if (this.model.allowDragAndDrop)
                this._spanTag.html(areaText);
        },
        _bindDragEvents: function () {
            this._on(this.dragWrapper, "dragover", this._onDragOverHandler);
            this._on(this.dragWrapper, "drop", this._onDropHandler);
        },
        _unBindDragEvents: function () {
            this._off(this.dragWrapper, "dragover", this._onDragOverHandler);
            this._off(this.dragWrapper, "drop", this._onDropHandler);
        },
        _setWidth: function (value) {
            this.element.css("width", value);
        },
        _setHeight: function (value) {
            this.element.height(value);
        },
        _dialogPosition: function () {
            if (this.diaObj) {
                if ((this.diaObj.model.content == "#" + this.control.id || this.diaObj.model.content == "#" + this.control.id + "_dragWrapper") && this.model.dialogPosition.X == "" && this.model.dialogPosition.Y == "") {
                    var left = parseInt(this.diaObj.wrapper.css("left")) - ((this.diaObj.wrapper.outerWidth() - $(this.diaObj.model.content).outerWidth()) / 2);
                    this.model.dialogPosition.X = parseInt(left) > 0 ? left : parseInt(this.diaObj.wrapper.css("left"));
                    this.model.dialogPosition.Y = parseInt(this.diaObj.wrapper.css("top")) + $(this.diaObj.model.content).outerHeight();
                }
                if (this.model.dialogPosition.X != "" && this.model.dialogPosition.Y != "") this.diaObj.setModel({ position: this.model.dialogPosition });
            }
        },

        _roundedCorner: function (value) {
            if (value) {
                this.innerdiv.addClass('e-corner');
            }
            else if (this.innerdiv.hasClass('e-corner')) {
                this.innerdiv.removeClass('e-corner');
            }
        },


        _wireEvents: function () {

            this._on(this.element, "click", this._disableclickselect);
            this._on(this.element, "keydown", this._keydownselect);
            this._bindInputChangeEvent();
            this._bindResizeHandler(true);
        },
        _bindResizeHandler: function (responsive) {
            responsive ? $(window).on('resize', $.proxy(this._resizeHandler, this)) : $(window).off('resize', $.proxy(this._resizeHandler, this));
        },

        _keydownselect: function (e) {
             if (!this.element.hasClass("e-disable") && e.keyCode == 13 && (!this.diaObj || !this.diaObj.isOpened()))
               this.element.find('.e-uploadinput').click();
        },

        _onDropHandler: function (e) {
            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0" || ej.browserInfo().version === "9.0") return false;
            if (this._currentElement.hasClass("e-disable")) return false;
            e.stopPropagation();
            e.preventDefault();
            this._files = this._getAllFileInfo(e.originalEvent.dataTransfer.files);
            this._fileSelect(e);
        },


        _onDragOverHandler: function (e) {
            if (this._currentElement.hasClass("e-disable")) return false;
            e.stopPropagation();
            e.preventDefault();
        },


        _disableclickselect: function (e) {
            if (this._currentElement.hasClass("e-disable")) {
                e.preventDefault();
            }
        },


        _bindInputChangeEvent: function () {
            this._on(this.inputupload, "change", this._inputValueChange);
        },


        _inputValueChange: function (e) {
            this._files = this._getInputFileInfo($(e.target));
            return this._fileSelect(e);
        },
		_fileSelect:function(e){
			if (this._trigger("fileSelect", {files:this._files})) { this._resetFileInput(this._currentElement.find(".e-uploadinput")); return false; }
            this._fileUpload(e);
		},
        _fileUpload: function (e) {
            var filteredFiles = this._isAllowed(this._files);
            this._files = filteredFiles.files;
            if (!this.model.asyncUpload) {
                if (filteredFiles.status)
                    this._onSelectSyncUpload(e); //Sync Upload
                } else {
                    if (filteredFiles.files != null && filteredFiles.files.length > 0) {
                        if (this.UploadType == "Xhr") 
                            this._onXhrSelect(e); //removed uploadcore // For XHR Upload
                        else 
                           this._onSelectIFrame(e); //For Iframe
                        this._resetFileInput(this._currentElement.find(".e-uploadinput"));
                    }
            }
            this._renderTooltip();
        },


        __uploadButtonClick: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                var uploadbtn = this._currentElement.find(".e-uploadbtn");
                if (this._currentElement.find(".e-uploadbtn").hasClass("e-disable")) e.preventDefault();
                else {
                    if (this.UploadType == "Xhr") {
                        this._xhrOnUploadButtonClick(e); // Xhr Upload
                    } else {
                        this._onUploadButtonClickIFrame(e); //Iframe Upload
                    }
                }
                $(e.target).attr('disabled', 'disabled').addClass('e-disable');
            }
        },

        _actionClick: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                var targetAction, fileItem, file;
                targetAction = $(e.target);
                fileItem = targetAction.closest(".e-upload-file");
                this._file = $(fileItem).data("file");
                if (targetAction.hasClass("e-delete")) {

                    if (this.UploadType == "Xhr") {
                        this._xhrOnRemove(e, fileItem); //XHr Remove
                    } else {
                        this._onRemoveIFrame(e, fileItem); //IFrame File Upload
                    }
                } else if (targetAction.hasClass("e-file-cancel")) {
                    this._trigger("cancel", { fileStatus: this._file });
                    var fileclose = this.updialog.find(".e-file-cancel");
                    if (fileclose.hasClass("e-disable")) e.preventDefault();
                    else {
                        if (!this.model.asyncUpload) {
                            this._onCancelSyncUpload(e, fileItem); //sync
                        } else {
							this._removeFile($(fileItem).data("file"));
                            if (this.UploadType == "Xhr") {
                                this._xhrOnCancel(e, fileItem); //Xhr Cancel Item
                            } else {
                                this._onCancelIFrame(e, fileItem); //IFrame Cancel Item
                            }
                        }
                    }
                } else if (targetAction.hasClass("e-reload")) {//removed uploadcore
                    if (this.UploadType == "Xhr") {
                        this._xhrOnRetry(e, fileItem); //xhr remove
                    } else {
                        this._onRetryIFrame(e, fileItem); //IFrame Remove
                    }
                }
            }
        },

        _removeFileEntry: function (file) {
            file.remove();
        },
		_removeFile:function(file){
			var fileList=[];
			for(var index=0;index<this._files.length;index++)
				if(this._files[index]!=file)
					fileList.push(this._files[index]);
			this._files=fileList;
		},


        _isFileUpload: function (fileEntry) {
            if (this.model.customFileDetails.action) {
                var actiondiv = $(fileEntry).find("div.e-icon");
                return actiondiv.is(".e-file-cancel");
            }
            else return true;
        },


        _isXhrSupported: function () {
            return (((this.s.name == "msie" && parseInt(this.s.version) < 9) || ((this.s.name == "safari" && this.s.name == "chrome") && this.s.version == "536")) ? false : (typeof (FormData) != "undefined") && (typeof (File) != "undefined"));
        },


        _getFileName: function (input) {
            return $.map(this._getAllFileInfo(input), function (file) {
                return file.name;
            }).join(", ");
        },

        _getFileSize: function (input) {
            var tempProxy = this;
            return $.map(this._getAllFileInfo(input), function (file) {
                return tempProxy._formatSize(file.size);
            }).join(", ");
        },

        _pushFile: function (files, datapart) {
            var fileListDetails, addedFile, actionlist, i, action, diaObj, addedheading, addedfilesize, addname, addsize, addstatus;
            addedheading = $("<div class='e-head-content'></div>");
            addname = $("<div class='e-file-head e-head-name'>" + this._getLocalizedLabels("name") + "</div>");
            addsize = $("<div class='e-file-head e-head-size'>" + this._getLocalizedLabels("size") + "</div>");
            addstatus = $("<div class='e-file-head e-head-status'>" + this._getLocalizedLabels("status") + "</div>");
            if (this.model.customFileDetails.name) $(addname).appendTo(addedheading);
            if (this.model.customFileDetails.size) $(addsize).appendTo(addedheading);
            if (this.model.customFileDetails.status) $(addstatus).appendTo(addedheading);
            filedialog = this.updialog;
            if (filedialog && filedialog.length != 0) {
                if (this.model.showFileDetails) {
                    if (this.updialog) this.updialog.find(".e-uploadbtn").removeAttr('disabled').removeClass('e-disable');
                    this.diaObj.open();
                }
            }
            else {
                this.updialog = ej.buildTag('div.uploaddialog#' + this.element[0].id + '_dialog', "", {}, { 'title': this._getLocalizedLabels("title") });
                if (this.model.allowDragAndDrop && !this.model.showBrowseButton) {
                    this.dragWrapper.append(this.updialog);
                    DialogContentContainer = "#" + this.control.id + '_dragWrapper';
                }
                else {
                    this.element.append(this.updialog);
                    DialogContentContainer = "#" + this.control.id;
                }
            }
            fileListDetails = this.updialog.find(".e-ul");
            if ($(this.updialog.find(".e-head-content")))
                $(this.updialog.find(".e-head-content")).replaceWith(addedheading);
            if (fileListDetails.length == 0) {
                addedheading.appendTo(this.updialog);
                fileListDetails = ej.buildTag('ul.e-ul').appendTo(this.updialog);
			}
			if($(this.updialog).find('.e-file-upload').length>0)
				$(this.updialog).find('.e-file-upload').remove();
			fileListActions = ej.buildTag('div.e-file-upload').appendTo(this.updialog).append((this.model.autoUpload || !this.model.asyncUpload) ? $(ej.buildTag('div.e-action-container')).addClass("sync") : ej.buildTag('div.e-action-container'));
            dialogActions = ej.buildTag('button.e-uploadclosebtn e-btn e-select', this._getLocalizedLabels("cancel"), {}, { type: 'button', "data-role": "none" }).appendTo($(this.updialog).find(".e-action-container"));
            if (this.model.showRoundedCorner)
                dialogActions.addClass('e-corner');
            this._on(dialogActions, "click", this._dialogclose);
            this._on(dialogActions, 'keydown', this._keydownDialogClose);            
            var dialogContainer = (this.model.dialogAction.content != null && this.model.dialogAction.content != "") ? this.model.dialogAction.content : DialogContentContainer
            this.updialog.ejDialog({ showOnInit: false, closeIconTooltip: this._getLocalizedLabels("closeToolTip"), minWidth: 240, width: ($(window).width() < 750) ? 250 : this._getDialogContentWidth(), height: "auto", cssClass: "e-uploadbox " + this.model.cssClass, close: $.proxy(this._uploadFileListDelete, this), enableRTL: this.model.enableRTL, target: dialogContainer, enableResize: false, allowDraggable: this.model.dialogAction.drag, enableModal: this.model.asyncUpload ? this.model.dialogAction.modal : false, showHeader: this.model.customFileDetails.title , showRoundedCorner : this.model.showRoundedCorner});
            $(window).width() < 750 ? $(this.updialog).closest('.e-dialog.e-uploadbox').addClass("e-mobile-upload") : $(this.updialog).closest('.e-dialog.e-uploadbox').removeClass("e-mobile-upload");
			this.diaObj = this.updialog.data('ejDialog');
			if(this.model.cssClass!="")
				this.diaObj.setModel({ cssClass: "e-uploadbox " + this.model.cssClass });
            this._dialogPosition();
            if (!this.model.multipleFilesSelection) {
                this.updialog.find(".e-ul>.e-upload-file").remove();
            }
            for (i = 0; i < files.length; i++) {//localization can be given for not started
                addedFile = $("<li class='e-upload-file'></li>").appendTo(fileListDetails).data(datapart);
                addedlist = $("<div class='e-file-list'></div>");
                addedfilename = $("<div class='e-file-progress e-file-view'><div class='e-file-name e-file-view'><span class='e-file-name-txt'>" + files[i].name + "</span></div>");
                addedfilesize = "<div class='e-file-size e-file-view'><span class='e-file-name-txt'>" + this._formatSize(files[i].size) + "</span></div>";
                addedfilestatus = $("<div class='e-file-percentage e-file-view'><div class='e-file-progress-bar'><div class='e-file-progress-status'></div></div></div>");
                addedfileaction = $("<div class='e-action-perform'><div class='e-icon e-file-view'></div></div>")
                if (this.model.customFileDetails.name) $(addedfilename).appendTo(addedlist);
                if (this.model.customFileDetails.size) {
                    if (this._getFileSize(files[i]).toString().toLowerCase().match("0.0kb").length == 0 || files[i].size != null) {
                        $(addedfilesize).appendTo(addedlist);
                    }
                    else $(this.updialog).find(".e-head-size").remove();
                }
                if (this.model.customFileDetails.status) $(addedfilestatus).appendTo(addedlist);
                if (this.model.customFileDetails.action) {
                    $(addedfileaction).appendTo(addedlist);
                    action = "cancel";
                    addedlist.find(".e-icon").remove().addClass(action.toString());
                    if (action == "cancel") {
                        actionlist = ej.buildTag('div.e-icon e-file-cancel', '', {}, { "data-content": this._getLocalizedLabels("cancelToolTip") });
                    } else if (action == "remove") {
                        actionlist = ej.buildTag('div.e-icon e-delete', '', {}, { "data-content": this._getLocalizedLabels("removeToolTip") });
                    } else if (action == "retry") {
                        actionlist = ej.buildTag('div.e-icon e-reload', '', {}, { "data-content": this._getLocalizedLabels("retryToolTip") });
                    }

                    addedlist.find(".e-action-perform").append(actionlist);

                    this._on(actionlist, "click", this._actionClick);
                }
                $(addedlist).appendTo(addedFile);
            }
            if (this.model.showFileDetails) {
                this.diaObj.open();
            }
            this._buttonText(this.model.buttonText);
            this._dialogText(this.model.dialogText);
            return addedFile;
        },

        _keydownDialogClose: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                if (e.keyCode == 13) this._dialogclose();
            }
        },

        _pushFileDetails: function (files) {
            var fileListDetails, addedFile, actionlist, i, action, me, diaObj, addedlist, addedheading, addname, addsize, addstatus, addaction, addedfilename, addedfilestatus, addedfilesize, addedfileaction;
            addedheading = $("<div class='e-head-content'></div>");
            addname = $("<div class='e-file-head e-head-name'>" + this._getLocalizedLabels("name") + "</div>");
            addsize = $("<div class='e-file-head e-head-size'>" + this._getLocalizedLabels("size") + "</div>");
            addstatus = $("</div><div class='e-file-head e-head-status'>" + this._getLocalizedLabels("status") + "</div>");
            if (this.model.customFileDetails.name) $(addname).appendTo(addedheading);
            if (this.model.customFileDetails.size) $(addsize).appendTo(addedheading);
            if (this.model.customFileDetails.status) $(addstatus).appendTo(addedheading);
            me = this;
            filedialog = this.updialog;
            if (filedialog && filedialog.length != 0) {
                if (this.model.showFileDetails) {
				    this.control.id!="" ?  DialogContentContainer : DialogContentContainer = this.element;
                    if (this.updialog) this.updialog.find(".e-uploadbtn").removeAttr('disabled').removeClass('e-disable');
                    me.diaObj.open();
                }
            } else {
                this.updialog = ej.buildTag('div.uploaddialog#' + this.element[0].id + '_dialog', "", {}, { 'title': this._getLocalizedLabels("title") });
                if (this.model.allowDragAndDrop && !this.model.showBrowseButton) {
                    this.dragWrapper.append(this.updialog);
                    DialogContentContainer = "#" + this.control.id + '_dragWrapper';
                }
                else {
                    this.element.append(this.updialog);
                    DialogContentContainer = "#" + this.control.id;
                }
            }
            var fileListDetails, addedFile;
            fileListDetails = this.updialog.find(".e-ul");
            if ($(this.updialog.find(".e-head-content")))
                $(this.updialog.find(".e-head-content")).replaceWith(addedheading);
            if (fileListDetails.length == 0) {
                addedheading.appendTo(this.updialog);
                fileListDetails = ej.buildTag('ul.e-ul').appendTo(this.updialog);
			}
			if($(this.updialog).find('.e-file-upload').length>0)
				$(this.updialog).find('.e-file-upload').remove();
			fileListActions = ej.buildTag('div.e-file-upload').appendTo(this.updialog).append((this.model.autoUpload || !this.model.asyncUpload) ? $(ej.buildTag('div.e-action-container')).addClass("sync") : ej.buildTag('div.e-action-container'));
            dialogActions = ej.buildTag('button.e-uploadclosebtn e-btn e-select', this._getLocalizedLabels("cancel"), {}, { type: 'button', "data-role": "none" }).appendTo($(this.updialog).find(".e-action-container"));
            if (this.model.showRoundedCorner)
            dialogActions.addClass('e-corner');
            this._on(dialogActions, "click", this._dialogclose);            
            if (!this.model.multipleFilesSelection) {
                this.updialog.find(".e-ul>.e-upload-file").remove();
            }
            addedFile = $("<li class='e-upload-file'></li>").appendTo(fileListDetails).data("file", files);
            addedlist = $("<div class='e-file-list'></div>");
            addedfilename = $("<div class='e-file-progress e-file-view'><div class='e-file-name e-file-view'><span class='e-file-name-txt'>" + files.name + "</span></div>");
            addedfilesize = $("<div class='e-file-size e-file-view'><span class='e-file-name-txt'>" + this._formatSize(0) + "\\" + this._formatSize(files.size) + "</span></div>");
            addedfilestatus = $("<div class='e-file-percentage e-file-view'><div class='e-file-progress-bar'><div class='e-file-progress-status'></div></div></div>");
            addedfileaction = $("<div class='e-action-perform'><div class='e-icon e-file-view'></div></div></div>")
            if (this.model.customFileDetails.name) $(addedfilename).appendTo(addedlist);
            if (this.model.customFileDetails.size) $(addedfilesize).appendTo(addedlist);
            if (this.model.customFileDetails.status) $(addedfilestatus).appendTo(addedlist);
            if (this.model.customFileDetails.action) $(addedfileaction).appendTo(addedlist);
            $(addedlist).appendTo(addedFile);
            var dialogContainer = (this.model.dialogAction.content != null && this.model.dialogAction.content != "") ? this.model.dialogAction.content : DialogContentContainer;
            this.updialog.ejDialog({ showOnInit: false, closeIconTooltip: this._getLocalizedLabels("closeToolTip"), minWidth: 240, width: ($(window).width() < 750) ? 250 : this._getDialogContentWidth(), height: "auto", cssClass: "e-uploadbox " + this.model.cssClass, close: $.proxy(this._uploadFileListDelete, this), enableRTL: this.model.enableRTL, target: dialogContainer, enableResize: false, allowDraggable: this.model.dialogAction.drag, enableModal: this.model.asyncUpload ? this.model.dialogAction.modal : false, showHeader: this.model.customFileDetails.title , showRoundedCorner : this.model.showRoundedCorner })
			$(window).width() < 750 ? $(this.updialog).closest('.e-dialog.e-uploadbox').addClass("e-mobile-upload") : $(this.updialog).closest('.e-dialog.e-uploadbox').removeClass("e-mobile-upload");
			me.diaObj = this.updialog.data("ejDialog");
			if (me.model.cssClass!="")
                me.diaObj.setModel({ cssClass: "e-uploadbox " + this.model.cssClass });
            me._dialogPosition();
            if (this.model.showFileDetails) {
                me.diaObj.open();
            }
            this._buttonText(this.model.buttonText);
            this._dialogText(this.model.dialogText);
            return addedFile;
        },

        _setProgress: function (filelist, percentage, e) {
            var progressbar, progress, filesize, loaded, total;
            if (this.model.customFileDetails.status) {
                progressbar = $(filelist).find(".e-file-progress-status");
                progressbar.width(percentage + "%");
            }
            if (this.model.customFileDetails.size) {
                filesize = $(filelist).find(".e-file-size .e-file-name-txt");
                loaded = this._formatSize(e.loaded);
                total = this._formatSize(e.total);
                filesize.html(loaded + "\\" + total);
            }
        },

        _setAction: function (element, action) {
            if (this.model.customFileDetails.action) {
                var actionlist;
                element.find(".e-action-perform .e-icon,.e-file-percentage .e-icon").remove().addClass(action.toString());
                if (action == "cancel") {
                    actionlist = ej.buildTag('div.e-icon e-file-cancel', '', {}, { "data-content": this._getLocalizedLabels("cancelToolTip") });
                } else if (action == "remove") {
                    actionlist = ej.buildTag('div.e-icon e-delete', '', {}, { "data-content": this._getLocalizedLabels("removeToolTip") });
                } else if (action == "retry") {
                    actionlist = ej.buildTag('div.e-icon e-reload', '', {}, { "data-content": this._getLocalizedLabels("retryToolTip") });
                }
                element.find(".e-action-perform").append(actionlist);
                this._on(actionlist, "click", this._actionClick);
            }
        },

        _setStatus: function (element, status) {
            if (this.model.customFileDetails.status) {
                var progress, upstatus = ej.buildTag('div');
                if (status == "success") {
                    element.find(".file-status").addClass("e-file-status-success").html("Completed");
                    element.find(".e-file-percentage").html("");
                    upstatus.addClass("e-icon e-checkmark").attr("data-content", this._getLocalizedLabels("completedToolTip"));
                    element.find(".e-file-percentage").append(upstatus);
                }
                if (status == "failed") {
                    element.find(".file-status").addClass("e-file-status-failed").html("Failed");
                    element.find(".e-file-percentage").html("");
                    upstatus.addClass("e-icon e-file-percentage-failed").attr("data-content", this._getLocalizedLabels("failedToolTip"));
                    element.find(".e-file-percentage").append(upstatus);
                }
                if (status == "progress") {
                    element.find(".file-status").addClass("file-status-inprogress").html("in progress");
                }
                if (status == "uploading") {
                    element.find(".file-status").addClass("file-status-inprogress").html("uploading");
                    progress = element.find(".e-file-percentage");
                    progress.html("");
                }
            }
        },
        _renderTooltip: function () {
            var proxy = this;
            if (!ej.isNullOrUndefined(this.updialog)) {
                this.upTooltip = $(this.updialog).ejTooltip({
                    target: ".e-file-cancel, .e-delete, .e-reload, .e-checkmark, .e-close, .e-file-percentage-failed",
                    content: " ",
                    isBalloon: false,
					showRoundedCorner : this.model.showRoundedCorner,
                    enableRTL: this.model.enableRTL,
                    position: {
                        target: { horizontal: "center", vertical: "bottom" },
                        stem: { horizontal: "left", vertical: "top" }
                    }
                }).data("ejTooltip");
                $(this.upTooltip.tooltip).css({ "min-width": "auto" });
            }
        },

        _createInputandBind: function () {
            var tempInput = ej.buildTag('input', '', {}, { type: 'file', "data-role": "none" });
            tempInput.attr("name", this.model.uploadName != "" ? this.model.uploadName : this.control.id).attr("autocomplete", "off").attr("class", "e-uploadinput").attr("accept",this.model.extensionsAllow);
            if (this.model.multipleFilesSelection) 
			 if (((navigator.userAgent.indexOf('Safari') != -1 )&& (navigator.userAgent.indexOf('Chrome') == -1 ))==false){
                tempInput.attr("multiple", "multiple");
            }
            tempInput.appendTo(this.element.find(".e-selectpart"));
            this.inputupload = tempInput;
            this._bindInputChangeEvent();
        },

        _showUploadButton: function () {
            var uploadbutton = this.updialog.find(".e-uploadbtn");
            if (uploadbutton.length == 0) {
                uploadbutton = ej.buildTag('button.e-uploadbtn e-btn e-select', this._getLocalizedLabels("upload"), {}, { type: "button", "data-role": "none" });
                if (this.model.showRoundedCorner)
                    uploadbutton.addClass('e-corner');
                this.updialog.find(".e-action-container").append(uploadbutton);
                this._on(uploadbutton, "click", this.__uploadButtonClick);
                this._on(uploadbutton, 'keydown', this._keydownUpload);
                $(uploadbutton).focus();
            }
            this._buttonText(this.model.buttonText);
        },

        _keydownUpload: function (e) {
            if (e.keyCode == 13) this.__uploadButtonClick(e);
        },

        _resetFileInput: function ($element) {
            var clone = $element.clone(false, false);
            this._on(clone, "change", this._inputValueChange);
            $element.replaceWith(clone);
        },

         _isAllowed: function (files) {
            var inputfield, uploadControl, args, allowExtension,allowSize,denyExtension, proxy = this, allowedFiles = [], filteredFiles = [],status=true;
            inputfield = this.element.find(".e-uploadinput");
            uploadControl = this;
			
            if (this.model.extensionsAllow != "") {
                allowExtension = this.model.extensionsAllow.replace(/\s/g, "").toLowerCase().split(",");
				
             
                $(files).each(function () {
                    if ($.inArray((this.extension).toLowerCase(), allowExtension) == -1) {

                        args = { action: "Files Processing", error:proxy._getLocalizedLabels("allowError").replace("#Extension", allowExtension.join(", ")), files: this };
                        uploadControl._trigger('error', args);
						proxy._resetFileInput(inputfield);
                        status = false;
                    }
                    else {
                        if (this.extension != "")
                            allowedFiles.push(this);
                    }
                });
            }

            else if (this.model.extensionsDeny != "") {
                denyExtension = this.model.extensionsDeny.replace(/\s/g, "").toLowerCase().split(",");
				
				
                $(files).each(function () {
                    if ($.inArray((this.extension).toLowerCase(), denyExtension) != -1) {

                        args = { action: "Files Processing", error: proxy._getLocalizedLabels("denyError").replace("#Extension", denyExtension.join(", ")), files: this };
                        uploadControl._trigger('error', args);
						proxy._resetFileInput(inputfield);
                        status = false;
                    }
                    else {
                        if (this.extension != "")
                            allowedFiles.push(this);
                    }
                });
            }
            else {
                $(files).each(function () {
                    if (this.extension != "")
                        allowedFiles.push(this);
                });
            }
            if (this.model.fileSize != "") {
                allowSize = this.model.fileSize;
                $(allowedFiles).each(function () {
                    if ((this.size > allowSize)) {
                  
                        args = { action: "Files Processing", error: proxy._getLocalizedLabels("filedetail").replace("#fileSize", allowSize), files: this };
                        uploadControl._trigger('error', args);
						proxy._resetFileInput(inputfield);
                        status = false;
                    }
                    else {
                        filteredFiles.push(this);
                    }
                });
            }
            else
                filteredFiles = allowedFiles;
            return { files: filteredFiles, status: status };
        },

        _fileListRemove: function () {
            fileList = this.updialog.find(".e-upload-file .e-delete");
            if (fileList.length == 0) {
                this.updialog.find(".e-uploadbtn").attr('disabled', 'disabled').addClass('e-disable');
                this.updialog.ejDialog('close');
            }
        },

        _uploadHide: function () {
            fileList = this.updialog.find(".e-upload-file .e-file-cancel");
            if (fileList.length == 0) {
                this.updialog.find(".e-ul").empty();
                this.updialog.find(".e-uploadbtn").attr('disabled', 'disabled').addClass('e-disable');
                this.updialog.ejDialog('close');
                this.upTooltip.hide();
            }
        },

        _onBeforeClose: function (args) {
            if (!ej.isNullOrUndefined(args.event)) if ($(args.event.currentTarget).hasClass("e-disable")) args.cancel = true;
            else args.cancel = false;
        },

        _dialogclose: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                var closebtn = this.updialog.find(".e-uploadclosebtn");
                var file, fileItem;
                fileItem = this.updialog.find(".e-ul").children().first();
                file = $(fileItem).data("file");
                if (closebtn.hasClass("e-disable")) e.preventDefault();
                else {
                    this._uploadFileListDelete();
                    this.updialog.ejDialog('close');
                }
                this._trigger("cancel", { fileStatus: file });
            }
        },

        _uploadFileListDelete: function () {
            this.updialog.find(".e-ul").empty();
			this._currentElement.find(".e-uploadinput").val("");
            this._resetFileInput(this._currentElement.find(".e-uploadinput"));
            if (!this.model.asyncUpload)
                this._formResetSyncUpload();
        },

        _onXhrSelect: function (e) {
            var files, xhrUpload, addedFile;
            this._xhrBeforeUpload(this._files);
            xhrUpload = this;
            $.each(xhrUpload._files, function (i, fileItem) {
                addedFile = $(fileItem).data("filelist");
                xhrUpload._setAction(addedFile, "cancel"); // XhrUpload._Uploader._setAction(addedFile, "cancel");
                if (xhrUpload.model.autoUpload) {
                    xhrUpload._xhrPerformUpload(fileItem);
                } else {
                    xhrUpload._showUploadButton();
                }
            });
        },

        _xhrBeforeUpload: function (files) {
            var fileEntry, xhrUpload, formdata, addedFile;
            fileEntry = files;
            xhrUpload = this;
            $.each(fileEntry, function (i, fileItem) {
                formdata = xhrUpload._createFormObjectXhr(fileItem);
                $(fileItem).data("formobject", formdata);
                addedFile = xhrUpload._pushFileDetails(fileItem);
                $(fileItem).data("filelist", addedFile);
            });

            return fileEntry;
        },

        _xhrPerformUpload: function (fileItem) {
            var isPrevented, url, xhrUpload, formdata, xhr, args;
            xhr = new XMLHttpRequest();
            xhrUpload = this;
            args = { files: fileItem };
            if (this._trigger('begin', args)) {
                $(fileItem).data("xhr", xhr);
                xhrUpload._onRequestError(xhrUpload, undefined, fileItem);
                return;
            }
            url = this.model.saveUrl;
            formdata = $(fileItem).data("formobject");

            formdata.append(((this.model.uploadName && this.model.uploadName!="")? this.model.uploadName:this.control.id)+"_data", JSON.stringify(args.data));
            $(fileItem).data("xhr", xhr);
            xhr.addEventListener("load", function (e) {
                xhrUpload._onRequestSuccess(xhrUpload, e, fileItem);
            }, false);
            xhr.addEventListener("error", function (e) {
                xhrUpload._onRequestError(xhrUpload, e, fileItem);
            }, false);
            xhr.upload.addEventListener("progress", function (e) {
                xhrUpload._onRequestProgress(xhrUpload, e, fileItem);
            }, false);
            xhr.open("POST", url);
			args = { files: fileItem, xhr: xhr };
			if (this._trigger('beforeSend', args)) {
               $(fileItem).data("xhr", xhr);
               xhrUpload._onRequestError(xhrUpload, undefined, fileItem);
               return;
            }
            xhr.send(formdata);
        },

        _xhrOnUploadButtonClick: function (e) {
            var xhrUpload, fileEntry, started, fileCount;
            xhrUpload = this.model.showBrowseButton ? this.diaObj.wrapper : this.dragWrapper;
            fileCount = xhrUpload.find(".e-ul li.e-upload-file");
            for (i = 0; i < fileCount.length; i++) {
                fileEntry = $(this);
                started = this._isFileUpload(fileCount[i]);
                if (started) {
                    this._xhrPerformUpload($(fileCount[i]).data("file"));
                }
            }
        },

        _xhrOnRemove: function (e, fileItem) {
            var filename = $(fileItem).find(".e-file-name").text().toString().split(","), proxy = this;
            $.ajax({
                url: this.model.removeUrl,
                type: "POST",
                data: "fileNames=" + filename,
                success: function () {
                    $(fileItem).remove();
                    proxy._fileListRemove();
                    proxy._trigger("remove", { fileStatus: proxy._file });

                }
            });
			this.upTooltip.hide();
        },

        _xhrOnCancel: function (e, fileItem) {
            var file, xhr;
            file = $(fileItem).data("file");
            xhr = $(file).data("xhr");
            if (xhr) {
                $(file).data("xhr").abort();
            }
            $(file).data("xhr", null);
            $(fileItem).data("file", null);
            $(fileItem).remove();
            this._uploadHide();
        },

        _xhrOnRetry: function (e, fileItem) {
            if (!this._currentElement.hasClass("e-disable")) {
                var file = $(fileItem).data("file");
                this._xhrPerformUpload(file);
            }
        },

        _onRequestSuccess: function (xhrUpload, e, fileEntry) {
            var xhr = $(fileEntry).data("xhr");
            if (xhr.status >= 200 && xhr.status <= 299) {
                xhrUpload._onXhrUploadSuccess(xhrUpload, e, fileEntry);
            }
            else {
                xhrUpload._onRequestError(xhrUpload, e, fileEntry);
            }
			if (xhrUpload._files.length == (this._successFiles.length + this._errorFiles.length)) {
                xhrUpload._trigger('complete', { files: fileEntry, responseText: xhr.responseText,success: this._successFiles,error: this._errorFiles, xhr: xhr, e: e });
                this._onClearCompletedFiles();
            }
        },
		
		_onClearCompletedFiles: function(){
			this._successFiles.length = this._errorFiles.length = 0;
            if (this.model.dialogAction.closeOnComplete) this._dialogclose()
		},

        _onXhrUploadSuccess: function (xhrUpload, e, fileEntry) {
            var addedFile, xhr, progressbar, size, fSize, filesize, args;
            addedFile = $(fileEntry).data("filelist");
            xhr = $(fileEntry).data("xhr");
            if (xhrUpload.model.removeUrl) {
                xhrUpload._setAction(addedFile, "remove");
                xhrUpload._setStatus(addedFile, "success");
            } else {
                addedFile.find(".e-action-perform .e-icon,.e-file-percentage .e-icon").remove();
                xhrUpload._setStatus(addedFile, "success");
            }
            if ($(fileEntry).length > 0) {
                progressbar = $(addedFile).find(".e-file-progress-status");
                progressbar.width("100%");
                size = $(fileEntry)[0].size;
                fSize = this._formatSize(size);
                filesize = $(addedFile).find(".e-file-size .e-file-name-txt");
                filesize.html(fSize + "\\" + fSize);
            }
            args = { files: fileEntry,responseText: xhr.responseText, xhr: xhr, e: e };
            this.updialog.find(".e-file-upload .e-uploadclosebtn").html(this.model.buttonText.close).focus();
            xhrUpload._trigger('success', args);
            this._successFiles.push(fileEntry);
        },

        _onRequestError: function (xhrUpload, e, fileEntry) {
            var addedFile, xhr, args;
            addedFile = $(fileEntry).data("filelist");
            xhr = $(fileEntry).data("xhr");
            xhrUpload._setAction(addedFile, "retry");
            xhrUpload._setStatus(addedFile, "failed");
            args = { action: "File Processing", error: xhr.status? xhr.status+" " + xhr.statusText:"Unable to reach the server.", files: fileEntry, xhr: xhr, e: e };
            xhrUpload._trigger('error', args);
			this._errorFiles.push(fileEntry);
        },

        _onRequestProgress: function (xhrUpload, e, fileEntry) {
            var percentage, addedFile,args;
            percentage = Math.round(e.loaded * 100 / e.total);
            addedFile = $(fileEntry).data("filelist");
            xhrUpload._setProgress(addedFile, percentage, e);
            xhrUpload._setStatus(addedFile, "progress");
            args = { file: fileEntry, percentage: percentage, e: e };
            this._trigger('inProgress', args);
        },

        _createFormObjectXhr: function (file) {
            var formData = new FormData();
            formData.append(this.model.uploadName != "" ? this.model.uploadName : this.control.id, file.rawFile);
            return formData;
        },

        _getInputFileInfo: function ($input) {
            var input = $input[0];
            if (input.files) {
                return this._getAllFileInfo(input.files);
            } else {
                return [{
                    name: this._GetName(input.value),
                    extension: this._getFileExtensionType(input.value),
                    size: this._getFileSizeinIE(input.value)
                }];
            }
        },

        _getFileSizeinIE: function (fileName) {
            var actievXObj, fileSize;
            actievXObj = null;
            fileSize = null;
            try {
                actievXObj = new ActiveXObject("Scripting.FileSystemObject");
            } catch (e) {
                fileSize = null;
            }
            if (actievXObj) {
                fileSize = actievXObj.getFile(fileName).size;
            }
            return fileSize;
        },

        _getFileExtensionType: function (fileName) {
            return fileName.match ? (fileName.match(/\.([^\.]+)$/) ? fileName.match(/\.([^\.]+)$/)[0] : "" || "") : "";
        },

        _getAllFileInfo: function (rawFiles) {
            var tempProxy = this;
            return $.map(rawFiles, function (file) {
                return tempProxy._getFileInfo(file || rawFiles);
            });
        },

        _GetName: function (fullname) {
            var nameIndex = fullname.lastIndexOf("\\");
            return (nameIndex != -1) ? fullname.substr(nameIndex + 1) : fullname;
        },

        _getFileInfo: function (rawFile) {
            // Older Firefox versions (before 3.6) use fileName and fileSize
            var fileName = rawFile.name || rawFile.fileName || rawFile;
            return {
                name: fileName,
                extension: this._getFileExtensionType(fileName),
                size: rawFile.size || rawFile.fileSize,
                rawFile: rawFile
            };
        },

        _formatSize: function (bytes) {
            var i = -1;
            if (!bytes)
                return "0.0KB";
            do {
                bytes = bytes / 1024;
                i++;
            } while (bytes > 99);
            return Math.max(bytes, 0).toFixed(1) + ['KB', 'MB', 'GB', 'TB', 'PB', 'EB'][i];
        },

        _onSelectIFrame: function (e) {
            var input, files, addedFile, uploadframe;
            input = $(e.target);
            files = this._getInputFileInfo(input);
            addedFile = this._beforeUploadIFrame(files);
            uploadframe = addedFile.data("iframe");
            if (this.model.autoUpload) {
                this._performUploadIFrame(addedFile);
            } else {
                this._showUploadButton();
            }
            this._off(this.inputupload, "change");
            this._bindInputChangeEvent();
        },

        _onRemoveIFrame: function (e, fileItem) {
            var iframe, fileNames, proxy, fileDetails;
            iframe = fileItem.data("iframe");
            fileDetails = $(fileItem).data("file");
            fileNames = fileDetails[0].name;
            proxy = this;
            if (iframe) {
                this._removeFileEntry(fileItem);
                if (this.model.removeUrl) {
                    $.ajax({
                        url: this.model.removeUrl,
                        type: "POST",
                        data: "fileNames=" + fileNames,
                        success: function () {
                            proxy._fileListRemove();
                            proxy._trigger("remove", { fileStatus: proxy._file });
                        }
                    });
                }
            } else {
                this._removeFileEntry(fileItem);
                this._trigger("remove", { fileStatus: this._file });
            }
        },

        _onCancelIFrame: function (e, fileItem) {
            var iframe;
            this._trigger('cancel', { Status: fileItem });
            iframe = fileItem.data("iframe");
            if (iframe) {
                this._removeFileEntry(fileItem);
                if (typeof (iframe.stop) != "undefined") {
                    iframe.stop();
                } else if (iframe.document) {
                    iframe.document.execCommand("Stop");
                    iframe.contentWindow.location.href = iframe.contentWindow.location.href;
                }
                this._processServerResponse(iframe, "");
            }
            this._uploadHide();
        },

        _onRetryIFrame: function (e, fileItem) {
            this._performUploadIFrame(fileItem);
        },

        _beforeUploadIFrame: function (files) {
            var uploadframe, uploadform, addedfile;
            //creating iframe and adding it to the upload div block.
            uploadframe = this._createFrame(this.control.id + "_Iframe" + this.Uploadframes.length);
            this.Uploadframes.push(uploadframe);
            uploadform = this._createForm(this.model.saveUrl, uploadframe[0].id);
            this._currentElement.find("input.e-uploadinput").removeClass("e-uploadinput").css("display", "none").appendTo(uploadform);
            this._createInputandBind();
            addedfile = this._pushFile(files, { "iframe": uploadframe, "form": uploadform, "file": files });
            uploadframe.data({ "filelist": addedfile });
            this._setAction(addedfile, "cancel");
            return addedfile;
        },

        _performUploadIFrame: function (addedFile) {
            var isPrevented, files, uploadframe, uploadform, args;
            args = { files: addedFile };
            if (this._trigger('begin', args)) {
                this._failureIframeUpload(addedFile, "File upload has been denied");
                return;
            }
            files = addedFile.data("file");
            this._setStatus(addedFile, "uploading");
            uploadframe = addedFile.data("iframe");
            uploadform = addedFile.data("form");
            var hiddendata = $("<input>").attr("name", ((this.model.uploadName && this.model.uploadName!="")? this.model.uploadName:this.control.id)+"_data").attr('type', 'hidden').val(JSON.stringify(args.data));
            uploadform.append(hiddendata);
            uploadframe.appendTo(document.body);
            uploadform.appendTo(document.body);
            //error here calls the upload even if the url is wrong
            this._on(uploadframe, "load", this._removeFramesIFrame);
            uploadform.submit();
        },

        _onUploadButtonClickIFrame: function (e) {
            var iframeUpload, fileEntry, started;
            iframeUpload = this;
            $(".e-ul li.e-upload-file", iframeUpload.updialog).each(function () {
                fileEntry = $(this);
                started = iframeUpload._isFileUpload(fileEntry);
                if (started) {
                    iframeUpload._performUploadIFrame(fileEntry);
                }
            });
        },

        _removeFramesIFrame: function (e) {
            var uploadframe, response, filelist, fileEntry, args;
            uploadframe = $(e.target);
			fileEntry = this._files;
            filelist = uploadframe.data("filelist");
            try {
                response = $.trim(e.target.contentDocument.body.innerText.replace(/\n|\r/g, ' '));
            } catch (e) {
                response = "Server Error trying to get server response: " + e;
            }
            if (response.substring(0, 12) != "Server Error" && response.indexOf("HTTP Error") != 0) {
                this._processServerResponse(uploadframe, response);
                this._setIframeProgress(filelist, 100, e);
                this._setStatus(filelist, "progress");
                this._successIframeUpload(filelist, response);
            }
            else { this._failureIframeUpload(filelist, response); }
			if (filelist.length == (this._successFiles.length + this._errorFiles.length)) {
                this._trigger('complete', { files: fileEntry, responseText: response, success: this._successFiles, error: this._errorFiles });
                this._onClearCompletedFiles();
            }		
        },


        _setIframeProgress: function (filelist, percentage, e) {
            var progressbar, progress, filesize, loaded, total;
            progressbar = $(filelist).find(".e-file-progress-status");
            progressbar.width(percentage + "%");
        },

        _successIframeUpload: function (filelist, response) {
            fileEntry = filelist.data("file");
            if (this.model.removeUrl) {
                this._setAction(filelist, "remove");
                this._setStatus(filelist, "success");
            } else {
                filelist.find(".file-action").remove();
                this._setStatus(filelist, "success");
            }
            args = { files: fileEntry, responseText: response };
            this.updialog.find(".e-file-upload .e-uploadclosebtn").html(this.model.buttonText.close).focus();
            this._trigger('success', args);
            this._successFiles.push(fileEntry);
        },

        _failureIframeUpload: function (filelist, response) {
            fileEntry = filelist.data("file");
            if (this.model.saveUrl && response != "File upload has been denied") {
                this._setAction(filelist, "retry");
                this._setStatus(filelist, "failed");
            } else {
                filelist.find(".file-action").remove();
                this._setStatus(filelist, "failed");
            }
            if (response.indexOf("HTTP Error") == 0)
                args = { files: fileEntry, responseText: response, status: response.match(/\d+/).toString() };
            else
                args = { files: fileEntry, responseText: response };
            this._trigger('error', args);
			this._errorFiles.push(fileEntry);
        },

        _processServerResponse: function (uploadframe) {
            var uploadform;
            uploadform = $(document.body).find("form[target='" + $(uploadframe).attr("id") + "']");
            setTimeout(function () {
                uploadform.remove();
                uploadframe.remove();
            }, 0);
        },

        _createDivBlock: function (className) {
            return ej.buildTag('div.' + className);
        },

        _createForm: function (action, target) {
            return ej.buildTag('form', '', {}, { enctype: 'multipart/form-data', method: 'POST', action: action, target: target });
        },

        _createFrame: function (id) {
            return ej.buildTag('iframe#' + id, '', { display: 'none' }, { name: id });
        },

        _createInput: function (id) {
            return ej.buildTag('input', '', {}, { type: 'file', name: id, "data-role": "none" });
        },



        _initObjectsSyncUpload: function () {
            this._currentElement.closest("form")
                    .attr("enctype", "multipart/form-data")
                    .attr("encoding", "multipart/form-data");
            this._wireEventsSyncUpload();
        },

        _wireEventsSyncUpload: function () {
            var closestform = this._currentElement.closest("form")[0];
            this._on($(closestform), "submit", this._formSubmitSyncUpload);
            this._on($(closestform), "reset", this._formResetSyncUpload);
        },

        _onSelectSyncUpload: function (e) {
            var input, files, selection, addedfile;
            input = $(e.target);
            selection = $(".e-selectpart", this.control);
            this._currentElement.find("input.e-uploadinput").removeClass("e-uploadinput").css("display", "none").appendTo(selection);
            this._createInputandBind();
            addedfile = this._pushFile(this._files, { "file": this._files, "Input": input });
        },

        _onCancelSyncUpload: function (e, fileItem) {
            var inputfield = fileItem.data("Input");
            fileItem.data("file", null);
            fileItem.data("Input", null);
            fileItem.remove();
            inputfield.remove();
            this._uploadHide();
        },

        _formSubmitSyncUpload: function (e) {
            var input, uploader;
            input = $(".e-uploadinput", this.control);
            input.attr("name", "");
            uploader = this.model.uploadName != "" ? this.model.uploadName : this.control.id;
            setTimeout(function () {
                input.attr("name", uploader);
            }, 0);
        },

        _formResetSyncUpload: function (e) {
            $(".e-selectpart", this.control).children('input[type="file"]').each(function () {
                if (!$(this).hasClass('e-uploadinput')) {
                    $(this).remove();
                }
            });
        }
        /*Sync End*/
    });
	ej.Uploadbox.Locale = ej.Uploadbox.Locale || {} ;
    
    ej.Uploadbox.Locale['default'] = ej.Uploadbox.Locale["en-US"] = {
        buttonText: {
            upload: "Upload",
            browse: "Browse",
            cancel: "Cancel",
            close: "Close"
        },
        dialogText: {
            title: "Upload Box",
            name: "Name",
            size: "Size",
            status: "Status"
        },
		dropAreaText: "Drop files or click to upload",
        filedetail: "The selected file size is too large.  Please select a file within #fileSize",
        denyError: "Files with #Extension extensions are not allowed.",
        allowError: "Only files with #Extension extensions are allowed.",
        cancelToolTip: "Cancel",
        removeToolTip: "Remove",
        retryToolTip: "Retry",
        completedToolTip: "Completed",
        failedToolTip: "Failed",
        closeToolTip: "Close"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html TextArea
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    var xhr = null;
    ej.widget("ejRTE", "ej.RTE", {

        element: null,

        model: null,
        _rootCSS: "e-rte",
        validTags: ["textarea"],
        _addOnPersist: ["value", "height", "width"],
        _setFirst: false,
        _requiresID: true,
        _operationHandler: null,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            allowEditing: true,

            isResponsive: false,

            allowKeyboardNavigation: true,

            enableTabKeyNavigation: true,

            cssClass: "",

            height: "370",

            width: "786",

            enabled: true,

            htmlAttributes: null,

            externalCSS: null,

            enableXHTML: false,

            importSettings: { url: "" },

            exportToPdfSettings: { url: "", fileName: "PdfExport" },

            exportToWordSettings: { url: "", fileName: "WordExport" },

            validationRules: null,

            validationMessage: null,
            maxLength: 7000,

            minWidth: "400",

            maxWidth: null,

            minHeight: "280",

            maxHeight: null,

            showToolbar: true,

            showFooter: false,

            showHtmlSource: false,

            showWordCount: true,
            showCharCount: true,

            showHtmlTagInfo: true,

            showClearAll: false,

            iframeAttributes: null,

            showClearFormat: true,
            showContextMenu: true,

            showFontOption: true,
            autoFocus: false,
            enableHtmlEncode: false,
            showDimensions: false,

            showRoundedCorner: false,

            locale: "en-US",

            name: "",
            pasteCleanupSettings: {
				listConversion: false, 
				cleanCSS: false,
				removeStyles: false,
				cleanElements: false
			},
			toolbarOverflowMode:"popup",

            tools: {

                formatStyle: ["format"],

                edit: [],

                style: ["bold", "italic", "underline", "strikethrough"],

                alignment: ["justifyLeft", "justifyCenter", "justifyRight", "justifyFull"],

                lists: ["unorderedList", "orderedList"],

                indenting: ["outdent", "indent"],

                doAction: ["undo", "redo"],

                links: ["createLink", "removeLink"],

                images: ["image"],
                media: ["video"],

                tables: ["createTable", "addRowAbove", "addRowBelow", "addColumnLeft", "addColumnRight", "deleteRow", "deleteColumn", "deleteTable"],
                view: ["fullScreen"],
                customTools: [],
                print: [],
                customOrderList: [],
                customUnOrderList: [],
                font: [],
                clipboard: [],
                clear: [],
                effects: [],
                casing: [],
                importExport: [],
            },

            tooltipSettings: {
                associate: "mouseenter",
                showShadow: true,
                position: {
                    stem: { horizontal: "left", vertical: "top" }
                },
                tip: {
                    size: { width: 5, height: 5 }
                },
                isBalloon: false
            },
            toolsList: ["formatStyle", "font", "style", "effects", "alignment", "lists", "indenting", "clipboard", "doAction", "clear", "links", "images", "media", "tables", "casing", "customTools", "view", "print", "edit", "importExport"],

            colorCode: [
			            "000000", "FFFFFF", "C4C4C4", "ADADAD", "595959", "262626", "4f81bd", "dbe5f1", "b8cce4", "95b3d7", "366092", "244061", "c0504d", "f2dcdb", "e5b9b7", "d99694", "953734",
			            "632423", "9bbb59", "ebf1dd", "d7e3bc", "c3d69b", "76923c", "4f6128", "8064a2", "e5e0ec", "ccc1d9", "b2a2c7", "5f497a", "3f3151", "f79646", "fdeada", "fbd5b5", "fac08f",
			            "e36c09", "974806"
            ],

            format: [
                { text: "Paragraph", value: "<p>", spriteCssClass: "e-paragraph" },
                { text: "Quotation", value: "<blockquote>", spriteCssClass: "e-quotation" },
                { text: "Heading 1", value: "<h1>", spriteCssClass: "e-h1" },
                { text: "Heading 2", value: "<h2>", spriteCssClass: "e-h2" },
                { text: "Heading 3", value: "<h3>", spriteCssClass: "e-h3" },
                { text: "Heading 4", value: "<h4>", spriteCssClass: "e-h4" },
                { text: "Heading 5", value: "<h5>", spriteCssClass: "e-h5" },
                { text: "Heading 6", value: "<h6>", spriteCssClass: "e-h6" }
            ],

            fontName: [
                       {
                           text: "Segoe UI",
                           value: "Segoe UI"
                       },
                       {
                           text: "Arial",
                           value: "Arial,Helvetica,sans-serif"
                       },
                       {
                           text: "Courier New",
                           value: "Courier New,Courier,monospace"
                       },
                       {
                           text: "Georgia",
                           value: "Georgia,serif"
                       },
                       {
                           text: "Impact",
                           value: "Impact,Charcoal,sans-serif"
                       },
                       {
                           text: "Lucida Console",
                           value: "Lucida Console,Monaco,monospace"
                       },
                       {
                           text: "Tahoma",
                           value: "Tahoma,Geneva,sans-serif"
                       },
                       {
                           text: "Times New Roman",
                           value: "Times New Roman,Times,serif"
                       },
                       {
                           text: "Trebuchet MS",
                           value: "Trebuchet MS,Helvetica,sans-serif"
                       },
                       {
                           text: "Verdana",
                           value: "Verdana,Geneva,sans-serif"
                       }
            ],

            fontSize: [
                {
                    text: "1 (8pt)",
                    value: "8pt"
                },
                {
                    text: "2 (10pt)",
                    value: "10pt"
                },
                {
                    text: "3 (12pt)",
                    value: "12pt"
                },
                {
                    text: "4 (14pt)",
                    value: "14pt"
                },
                {
                    text: "5 (18pt)",
                    value: "18pt"
                },
                {
                    text: "6 (24pt)",
                    value: "24pt"
                },
                {
                    text: "7 (36pt)",
                    value: "36pt"
                }
            ],

            tableRows: 8,

            tableColumns: 10,

            colorPaletteRows: 6,

            colorPaletteColumns: 6,

            showCustomTable: true,

            value: null,

            undoStackLimit: 50,

            enableResize: true,

            enablePersistence: false,

            enableRTL: false,

            autoHeight: false,

            zoomStep: '0.05',

            imageBrowser: {

                filePath: "",

                extensionAllow: "*.png,*.gif,*.jpg,*.jpeg",

                ajaxAction: "",

                ajaxSettings: ""
            },

            fileBrowser: {

                filePath: "",

                extensionAllow: "*.doc,*.docx,*.pdf,*.txt",

                ajaxAction: ""
            },


            change: null,

            execute: null,

            keydown: null,

            keyup: null,

            create: null,

            destroy: null,
            contextMenuClick: null,
            preRender: null,
            select: null
        },

        dataTypes: {
            enabled: "boolean",
            autoFocus: "boolean",
            enableHtmlEncode: "boolean",
            autoHeight: "boolean",
            enableXHTML: "boolean",
            isResponsive: "boolean",
            enablePersistence: "boolean",
            showRoundedCorner: "boolean",
            showCustomTable: "boolean",
            enableResize: "boolean",
            importSettings: { url: "string" },
            exportToPdfSettings: { url: "string", fileName: "string" },
            exportToWordSettings: { url: "string", fileName: "string" },
            pasteCleanupSettings: {
				listConversion: "boolean", 
				cleanCSS: "boolean",
				removeStyles: "boolean",
				cleanElements: "boolean"
			},
            showDimensions: "boolean",
            showFontOption: "boolean",
            showClearFormat: "boolean",
            showClearAll: "boolean",
            showHtmlTagInfo: "boolean",
            showWordCount: "boolean",
            showCharCount: "boolean",
            showHtmlSource: "boolean",
            allowKeyboardNavigation: "boolean",
            enableTabKeyNavigation: "boolean",
            allowEditing: "boolean",
            showToolbar: "boolean",
            showFooter: "boolean",
            showContextMenu: "boolean",
            enableRTL: "boolean",
            toolsList: "array",
            colorCode: "array",
			toolbarOverflowMode:"enum",
            format: "data",
            fontName: "data",
            fontSize: "data",
            htmlAttributes: "data",
            iframeAttributes: "data",
            tools: {
                formatStyle: "array",
                font: "array",
                edit: "array",
                style: "array",
                effects: "array",
                alignment: "array",
                lists: "array",
                indenting: "array",
                clipboard: "array",
                doAction: "array",
                clear: "array",
                links: "array",
                media: "array",
                images: "array",
                tables: "array",
                casing: "array",
                customTools: "array",
                view: "array",
                print: "array",
                importExport: "array",
                customOrderList: "array",
                customUnOrderList: "array"
            }
        },

        _rteIconsList: {
            "format": "format",
            "bold": "e-bold_01",
            "italic": "e-italic_01",
            "underline": "e-underline_01",
            "strikethrough": "e-strikethrough_01",
            "justifyLeft": "e-align-left_01",
            "justifyCenter": "e-align-center_01",
            "justifyRight": "e-align-right_01",
            "justifyFull": "e-align-justify_01",
            "unorderedList": "e-bullets_01",
            "orderedList": "orderedList",
            "outdent": "outdent",
            "indent": "indent",
            "undo": "undo",
            "redo": "redo",
            "createLink": "e-link_01",
            "removeLink": "e-unlink_01",
            "image": "e-image",
            "video": "e-video",
            "createTable": "e-table_02",
            "addRowAbove": "e-insert-row-above_02",
            "addRowBelow": "e-insert-row-below_02",
            "addColumnLeft": "e-insert-column-left_02",
            "addColumnRight": "e-insert-column-right_02",
            "deleteRow": "e-delete-row_01",
            "deleteColumn": "e-delete-column_01",
            "deleteTable": "deleteTable",
            "fullScreen": "fullScreen",
            "superscript": "e-superscript_01",
            "subscript": "e-subscript_01",
            "upperCase": "e-uppercase_01",
            "lowerCase": "e-lowercase_01",
            "zoomIn": "e-zoom-in",
            "zoomOut": "e-zoom-out",
            "print": "print",
            "import": "e-upload",
            "wordExport": "e-icon e-word-export",
            "pdfExport": "e-icon e-pdf-export",
            "findAndReplace": "findAndReplace",
            "cut": "e-cut_01",
            "copy": "e-copy_02",
            "paste": "e-paste_01",
            "clearFormat": "clearFormat",
            "clearAll": "e-delete_05",
            "fontName": "fontName",
            "fontSize": "fontSize",
            "fontColor": "e-font",
            "backgroundColor": "e-background-color",
            "rteResize": "e-resize-handle",
            "rteSource": "e-file-code",
            "customTableImage": "e-table",
            "resize": "e-full-screen-collapse_01",
            "maximize": "e-full-screen-expand_01",
            //Added empty strings for context menu
            "openLink": "",
            "deleteTables": "",
            "insertTable": "",
            "tableProperties": "",
            "imageProperties": ""
        },

        observables: ["value"],
        value: ej.util.valueFunction("value"),

        _setModel: function (options) {
            this._isInteraction = false;
            var option;
            for (option in options) {
                switch (option) {
                    case "allowEditing": this._enableEdit(options[option]); break;
                    case "autoFocus ": { this.model.autoFocus = options[option]; if (options[option]) this._focus(); break; }
                    case "showToolbar": {
                        options[option] ? (ej.isNullOrUndefined(this._rteToolbar) ? this._renderToolBar() : (this._rteToolbar.show() , (this.model.isResponsive && this._toolBarObj._reSizeHandler()))): this._rteToolbar.hide();
                        break;
                    }
                    case "showFooter": {
                        this.model.showFooter = options[option];
                        options[option] ? ej.isNullOrUndefined(this._rteFooter) ? this._renderFooter() : this._rteFooter.show() : this._rteFooter.hide();
                        break;
                    }
                    case "pasteCleanupSettings":
                        this.model.pasteCleanupSettings = options[option];
                        if (ej.clipboardCleaner) {
                            if (!this._pasteCleaner)
                                this._enableContentCleaner();
                            this._pasteCleaner && (this._pasteCleaner.filterOptions = options[option]);
                        }						
                    case "isResponsive": {
                        this.model.isResponsive = options[option];
                        this._renderToolBarList();
                        var iframeHeight = $(this._rteIframe).outerHeight();
                        var toolListHeight = $(this._rteToolbar).outerHeight();
                        $(this._rteWapper).height(iframeHeight + toolListHeight);
                        if (!ej.isNullOrUndefined($(this._rteFooter))) {
                            var footerHeight = $(this._rteFooter).outerHeight();
                            $(this._rteWapper).height(iframeHeight + footerHeight + toolListHeight);
                        }
                        break;
                    }
                    case "enabled": this._disabled(options[option]); break;
                    case "height": { this.model.height = options[option]; this._rteWapper.height(options[option]); } break;
                    case "width": { this.model.height = options[option]; this._rteWapper.css("width", options[option]); } break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showHtmlSource": this._footerElement("div.e-rte-source", options[option]); break;
                    case "showHtmlTagInfo": this._footerElement("div.e-rte-htmltaginfo", options[option]); break;
                    case "showWordCount": {
                        this.model.showWordCount = options[option];
                        this._createCountElement(options[option], this._wordCount);
                        break;
                    }
                    case "showCharCount": {
                        this.model.showCharCount = options[option];
                        this._createCountElement(options[option], this._charCount);
                        break;
                    }
                    case "tooltipSettings": {
                        this.model.tooltipSettings = $.extend(true, this.model.tooltipSettings, options[option]);
                        if (this.model.showToolbar)
                            this._toolBarItems.ejToolbar("option", "tooltipSettings", options[option]);
                        this._renderTooltip(this.model.tooltipSettings);
                        break;
                    }
                    case "showClearAll": this._footerElement("div.clearAll", options[option]); break;
                    case "showClearFormat": this._footerElement("div.clearFormat", options[option]); break;
                    case "enableResize": this._footerElement("div.e-rte-resize", options[option]); break;
                    case "fontName": this._fontStyleDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "fontSize": this._fontSizeDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "format": this._formatDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "value":
                        if (ej.isPlainObject(options[option])) options[option] = null;
                        this._getDocument().body.innerHTML = ej.util.getVal(options[option]);
                        var args = { text: this._getText(), htmlText: this.getHtml() };
                        this._onChange();
                        break;
                    case "showDimensions":
                        if (options[option]) {
                            this._imgDialog.find("div.e-rte-imgdimensions").show();
                            this._imgDialog.find("div.e-rte-videoDimensions").show();
                        }
                        else {
                            this._imgDialog.find("div.e-rte-imgdimensions").hide();
                            this._imgDialog.find("div.e-rte-videoDimensions").hide();
                        }
                        break;
                    case "showFontOption":
                        if (options[option])
                            this._rteWapper.find("ul.e-rte-fontgroup").show();
                        else
                            this._rteWapper.find("ul.e-rte-fontgroup").hide();
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        var model = this.model;
                        this.element.ejRTE("destroy").ejRTE(model);
                        break;
                    case "importSettings": {
                        this.model.importSettings = $.extend(true, this.model.importSettings, options[option]);
                        break;
                    }
                    case "exportToPdfSettings": {
                        this.model.exportToPdfSettings = $.extend(true, this.model.exportToPdfSettings, options[option]);
                        break;
                    }
                    case "exportToWordSettings": {
                        this.model.exportToWordSettings = $.extend(true, this.model.exportToWordSettings, options[option]);
                        break;
                    }
                    case "tableRows": {
                        this.model.tableRows = options[option];
                        var tblDiv = this._createTable.find("div.e-rte-table").html("");
                        this._drawTable(tblDiv);
                        break;
                    }
                    case "iframeAttributes": {
                        this._updateIframeSkin(options[option]);
                        break;
                    }
                    case "tableColumns": {
                        this.model.tableColumns = options[option];
                        var tblDiv = this._createTable.find("div.e-rte-table").html("");
                        this._drawTable(tblDiv);
                        break;
                    }
                    case "showCustomTable": {
                        var custLink = this._createTable.find("div.customtable-group");
                        options[option] ? ej.isNullOrUndefined(this._customTableDialog) ? this._createCustomTable() : custLink.show() : custLink.hide();
                        break;
                    }
                    case "colorPaletteRows": {
                        this.model.colorPaletteRows = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "colorPaletteColumns": {
                        this.model.colorPaletteColumns = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "colorCode": {
                        this.model.colorCode = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "name": {
                        this.model.name = options[option];
                        this._checkNameAttr();
                        break;
                    }
                    case "showContextMenu":
                        this.model.showContextMenu = options[option];
                        this._showHideContextMenu();
                        break;
                    case "enableRTL": this._enableRTL(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "validationRules":
                        if (this.element.closest("form").length != 0) {
                            if (this.model.validationRules != null) {
                                this.element.rules('remove');
                                this.model.validationMessage = null;
                            }
                            this.model.validationRules = options[option];
                            if (this.model.validationRules != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "validationMessage":
                        if (this.element.closest("form").length != 0) {
                            this.model.validationMessage = options[option];
                            if (this.model.validationRules != null && this.model.validationMessage != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "autoHeight": this.model.autoHeight = options[option];
                        this._setAutoHeight();
                }
                if (option != "locale")
                    this._setIframeHeight();
            }
            this._updateCount();
        },
		_updateLocalConstant:function(){
			this._localizedLabels = ej.getLocalizedConstants("ej.RTE", this.model.locale);
		},
		_enableContentCleaner:function(){
			if(ej.clipboardCleaner && !this._isIE8()){
				!this._pasteCleaner && (this._pasteCleaner=new ej.clipboardCleaner(this._getDocument(),this._iframePaste,this));
				this._pasteCleaner.filterOptions = this.model.pasteCleanupSettings;
			}
		},
        _init: function () {
            if (!ej.isNullOrUndefined(this.element) && this.element[0].type == "textarea") {
				this._updateLocalConstant();
                this.element.hide();
                this._initialize()
                    ._render();
                this.model.allowEditing && this._wireEvents();
                this.model.pasteCleanupSettings && (this.model.pasteCleanupSettings.cleanElements || this.model.pasteCleanupSettings.removeStyles || this.model.pasteCleanupSettings.cleanCSS || this.model.pasteCleanupSettings.listConversion) && this._enableContentCleaner();
                this._updateIframeSkin(this.model.iframeAttributes);
                if (this.model.enabled == false) this._disabled(this.model.enabled);
                this._addAttr(this.model.htmlAttributes);
                if (this.model.autoFocus) {
                    this._focus();
                    this._updateToolbarStatus();
                    this._updateFontOptionStatus();
                    this._updateFormat();
                }
                if (this.model.enableHtmlEncode)
                    this.value(this._encode(this._decode(this.value())));
                if (this.model.showToolbar) {
                    this.disableToolbarItem("removeLink");
                    if (!ej.isNullOrUndefined(this._getWindow()))
                        this._updateIndentStatus();
                }
                if (this.model.enableRTL)
                    this._enableRTL(true);
                this.model.externalCSS && this._addCssToIframe(this.model.externalCSS);
                this.wrapper = this._rteWapper;
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
                if (this.model.showContextMenu) {
                    this._showHideContextMenu();
                }
                this._isInteraction = true;
            }
        },
        _hideContextMenuByItem: function (data) {
            for (index1 = 0; index1 < $(this._textMenuObj.element).children("li").length; index1++)
                ($.inArray($($(this._textMenuObj.element).children("li")[index1]).attr("id"), data) != -1) ? $($(this._textMenuObj.element).children("li")[index1]).show() : $($(this._textMenuObj.element).children("li")[index1]).hide();
        },
        _filterMenuItems: function (e) {
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode(), node = this._saveSelection().commonAncestorContainer;
            if (!ej.isNullOrUndefined(selectNode) && !ej.isNullOrUndefined(selectNode.tagName) && (selectNode.tagName.toLowerCase() === "img" || e.target.tagName.toLowerCase() == "img")) {
                this._hideContextMenuByItem(this._contextType.image);
                this._updateContextMenuItemState(true);
            }
            else if (!ej.isNullOrUndefined(selectNode) && $(selectNode).closest("table").length) {
                this._hideContextMenuByItem($(selectNode).closest("a").length ? this._contextType.table_hyper : this._contextType.table);
                this._contextValidation(node, e);
            }
            else if (!ej.isNullOrUndefined(selectNode) && $(selectNode).closest("a").length) {
                this._hideContextMenuByItem(this._contextType.hyperlink);
                this._contextValidation(node, e);
            }
            else if (this._isIE8()) {
                this._hideContextMenuByItem(this._contextType.text);
                this._updateContextMenuItemState(this._getRange().text !== "");
            }
            else {
                this._hideContextMenuByItem(this._contextType.text);
                this._contextValidation(node, e);
            }
            this._rteIframe.contents().find("body").addClass("e-cursor");
        },
        _contextmenuPosition: function (e) {
            var posX = (( e.clientX == undefined ) ? 0 : e.clientX ) + this._rteWapper.offset().left , posY = (( e.clientY == undefined ) ? 0 : e.clientY ) + this._rteWapper.offset().top + (this._rteToolbar ? this._rteToolbar.outerHeight() : 0) , menuHeight = $(this._textMenuObj.element).attr("style", "visibility: visible;display:block;").height() ,  menuWidth = $(this._textMenuObj.element).width();
            posY = ((posY + menuHeight) < ($(document).scrollTop() + $(window).height())) ? posY : ((posY - menuHeight) < 0 ? posY : (posY - menuHeight));
            posX = ((posX + menuWidth) < ($(document).scrollLeft() + $(window).width())) ? posX : (posX - menuWidth);
            $(this._textMenuObj.element).attr("style", ("width:auto;left:" + posX + "px;top:" + posY + "px;z-index:" + (this._onGetMaxZindex() + 1))).focus();
        },
        _contextValidation: function (node, e) {
            this._updateContextMenuItemState(node && (data = node.nodeValue ? node.nodeValue : node.textContent) && ((this._saveSelection().endContainer == this._saveSelection().startContainer) ? (data.substring(this._saveSelection().startOffset, this._saveSelection().endOffset) !== "") : true));
        },
        _updateContextMenuItemState: function (stauts) {
            stauts ? (this._textMenuObj.enableItemByID("cut"), this._textMenuObj.enableItemByID('copy')) : (this._textMenuObj.disableItemByID("cut"), this._textMenuObj.disableItemByID('copy'));
        },
        _contextMenuClick: function (e) {
            var action = e.ID ? e.ID.toLowerCase() : $(e.element).attr("id").toLowerCase(), _node;
            this._isIE() && this._ieSelectionRange && this.selectRange(this._ieSelectionRange);
            switch (action) {
                case "cut":
                    (!this._isIE() && this._getValidbrowser(ej.browserInfo().name)) ? this._openAlert(this._getLocalizedLabels("cutAlert")) : this._getDocument().execCommand(action, false, undefined);
                    if (this._imgOrg && this._imgDupDiv && this._imgBoxMouseMove) {
                        $(this._imgOrg).css("outline", "");
                        $(this._imgDupDiv).remove();
                        this._off($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
                    }
                    this._updateCursor();
                    break;
                case "copy":
                    (!this._isIE() && this._getValidbrowser(ej.browserInfo().name)) ? this._openAlert(this._getLocalizedLabels("copyAlert")) : this._getDocument().execCommand(action, false, undefined);
                    this.selectRange(this._getRange());
                    break;
                case "paste":
                    (!this._isIE()) ? this._openAlert(this._getLocalizedLabels("pasteAlert")) : this._getDocument().execCommand(action, false, undefined);
                    break;
                case "openlink":
                    this._onOpen();
                    break;
                case "createlink":
                    (!this._linkDialog) && this._renderLinkDialog();
                    this._hyperLinkManager(false);
                    break;
                case "imageproperties":
                    (!this._imgDialog) && this._renderImageDialog();
                    this._imageManager();
                    break;
                case "addcolumnleft":
                    _node = this.insertColumn(true, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addcolumnright":
                    _node = this.insertColumn(false, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addrowabove":
                    _node = this.insertRow(true, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addrowbelow":
                    _node = this.insertRow(false, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "deleterow":
                    this.removeRow(this._currentSelNode);
                    break;
                case "deletecolumn":
                    this.removeColumn(this._currentSelNode);
                    break;
                case "deletetable":
                    this.removeTable($(this._currentSelNode).closest('table'));
                    break;
                case "tableproperties":
                    (!this._eTblDialog) && this._renderEditTableDialog()
                    this._eTblManager();
                    this._eTblDialog.ejDialog("open");
                    break;
                case "removelink":
                    this._onUnlink();
                    break;
            }
            this._trigger("contextMenuClick", { event: e });
            this._onChange();
        },
        _updateCursor: function (node, rangeData) {
            if (!this._isIE8()) {
                var _range = this._getDocument().createRange(), _currentRange = this._getRange();
                if (node)
                    this._setRange(node, _currentRange, true);
                else if (rangeData) {
                    _range.setStart(rangeData.startContainer, rangeData.startOffset);
                    _range.setEnd(rangeData.endContainer, rangeData.endOffset);
                    this.selectRange(_range);
                }
                else {
                    _range.setStart(_currentRange.startContainer, _currentRange.startOffset);
                    _range.setEnd(_currentRange.startContainer, _currentRange.startOffset);
                    this.selectRange(_range);
                }
            }
        },
        _loadRules: function () {
            jQuery.validator.addMethod("contentRequired", function (value, element) {
                return $.trim($(element).data("ejRTE")._getText());
            }, "Please specify the value.");
            jQuery.validator.addMethod("maxWordCount", function (value, element, params) {
                return $.trim($(element).data("ejRTE")._getText()).split(/\W+/).length <= params;
            }, "Please enter the content with in max word count.");
            jQuery.validator.addMethod("minWordCount", function (value, element, params) {
                return $.trim($(element).data("ejRTE")._getText()).split(/\W+/).length >= params;
            }, "Please enter the content with min word count.");
            jQuery.validator.addMethod("minCharCount", function (value, element, params) {
                return $(element).data("ejRTE")._getText().length >= params;
            }, "Please enter the content with min length.");
            jQuery.validator.addMethod("maxCharCount", function (value, element, params) {
                return $(element).data("ejRTE")._getText().length <= params;
            }, "Please enter the content with in  max length.");
            this._customRules = { "required": "contentRequired", "maxWordCount": "maxWordCount", "minWordCount": "minWordCount", "maxlength": "maxCharCount", "minlength": "minCharCount", "equalTo": "equalTo" };
        },
        _initValidator: function () {
            this._loadRules();
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _getRuleData: function (rule, data) {
            var ruleData = null;
            switch (rule) {
                case "contentRequired":
                    ruleData = { 'contentRequired': data };
                    break;
                case "minCharCount":
                    ruleData = { 'minCharCount': data };
                    break;
                case "maxCharCount":
                    ruleData = { 'maxCharCount': data };
                    break;
                case "maxWordCount":
                    ruleData = { 'maxWordCount': data };
                    break;
                case "minWordCount":
                    ruleData = { 'minWordCount': data };
                    break;
                case "equalTo":
                    ruleData = { 'equalTo': data };
                    break;
            }
            return ruleData;
        },
        _setValidation: function () {
            if (this.element.closest("form").length != 0) {
                var validator = this.element.closest("form").validate(), rule, ruleVal, name = this.element.attr("name");
                validator.settings.messages[name] = {};
                for (var ruleName in this.model.validationRules) {
                    var message = null;
                    if (!ej.isNullOrUndefined(this.model.validationRules[ruleName]) && this._customRules[ruleName]) {
                        rule = this._customRules[ruleName], ruleVal = this.model.validationRules[ruleName];
                        this.element.rules("add", this._getRuleData(rule, ruleVal));
                        if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][rule]))
                            message = this.model.validationRules["messages"][rule];
                        else {
                            validator.settings.messages[name][rule] = $.validator.messages[rule];
                            for (var msgName in this.model.validationMessage)
                                ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                        }
                        validator.settings.messages[name][rule] = message != null ? message : $.validator.messages[rule];
                    }
                }
            }
        },
        _addAttr: function (htmlAttr) {
            if (htmlAttr != null) {
                var proxy = this;
                $.map(htmlAttr, function (value, key) {
                    if (key == "class") proxy._rteWapper.addClass(value);
                    else if (key == "name") proxy.element.attr(key, value);
                    else if (key == "required") proxy.element.attr(key, value);
                    else if (key == "disabled" && value == "disabled") proxy.disable();
                    else if (key == "readOnly" && value == "readOnly") proxy._enableEdit(false);
                    else proxy._rteWapper.attr(key, value);
                });
            }
        },
        _addCssToIframe: function (value) {
            var substr = $.isArray(value) ? value : value.split(',');
            for (var i = 0; i < substr.length; i++) {
                var linkTag = document.createElement("link");
                linkTag.href = substr[i];
                linkTag.rel = "stylesheet";
                linkTag.type = "text/css";
                this._rteIframe.contents().find("head").append(linkTag);
            }
        },
        _disabled: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _destroy: function () {
            this.element.insertBefore(this._rteWapper);
            !ej.isNullOrUndefined(this._tooltip) && $(this._rteFooter).ejTooltip("destroy");
            !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontColorSplit) && this._fontColorSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._bgColorSplit) && this._bgColorSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._unOrderSplit) && this._unOrderSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._orderSplit) && this._orderSplit.ejSplitButton("destroy");
            if (!ej.isNullOrUndefined(this._customTableDialog)) {
                !ej.isNullOrUndefined(this._customTableDialog.find(".e-rte-ddlAlignment")) && this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("destroy");
                !ej.isNullOrUndefined(this._customTableDialog.find(".e-rte-txtBorder")) && this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("destroy");
            }
            !ej.isNullOrUndefined(this._linkDialog) && $(this._linkDialog).closest("div.e-rte.e-dialog-wrap").remove();
            if (!ej.isNullOrUndefined(this._imgDialog)) {
                this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList("destroy");
                $(this._imgDialog).closest("div.e-rte.e-dialog-wrap").remove();
            }
            !ej.isNullOrUndefined(this._videoDialog) && $(this._videoDialog).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._createTable) && $(this._createTable).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._sourceDialog) && $(this._sourceDialog).closest("div.e-dialog-wrap").remove();
		    !ej.isNullOrUndefined(this._customColor )&& $(this._customColor ).closest("div.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._customTableDialog) && $(this._customTableDialog).closest("div.e-rte.e-dialog-wrap").remove();
			!ej.isNullOrUndefined(this._customTableDialog) && $(this._customTableDialog).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._alertWindow) && $(this._alertWindow).closest("div.e-rte.e-dialog-wrap").remove();
            if (!ej.isNullOrUndefined(this._eTblDialog)) {
                this._eTblDialog.find(".e-rte-dropdown").ejDropDownList("destroy");
                $(this._eTblDialog).closest("div.e-rte.e-dialog-wrap").remove();
            }
            !ej.isNullOrUndefined(this._explorerObj) && this._explorerObj.destroy();
            !ej.isNullOrUndefined(this._imgPicker) && this._imgPicker.destroy();
			!ej.isNullOrUndefined(this._tblborderPicker) && this._tblborderPicker.destroy();
            !ej.isNullOrUndefined(this._fileDialog) && $(this._fileDialog).closest("div.e-rte.e-dialog-wrap").remove();
			this._textMenuObj && this._textMenuObj.destroy();
            this._toolBarObj && this._toolBarObj.destroy();
            this._rteWapper.remove();
			if($("#"+this._rteId+"customcolor_popup").length>0)
			$("#"+this._rteId+"customcolor_popup").remove();
			if($("#"+this._rteId+"customcolor_Presets").length>0)
			$("#"+this._rteId+"customcolor_Presets").remove();
            this.element.show();
            this.element.focus();
            this._createTable = null;
            this._unwireEvents();
        },

        _initialize: function () {
            this._toolsList = this.model.toolsList;
            this._rteId = this.element[0].id;
            this._rteId = this._rteId ? this._rteId : "";
            this._backupArray = new Array();
            this._undoRedoPosition = 0;
            this._fontColor = "#000000";
            this._bgColor = "#ffffff";
            this._imgWidth = 0;
            this._imgHeight = 0;
            this._videoWidth = 0;
            this._videoHeight = 0;
            this._keypressFlag = true;
            this._styleItems = ej.isNullOrUndefined(this.model.tools["style"]) ? [] : this.model.tools["style"];
            this._alignItems = ej.isNullOrUndefined(this.model.tools["alignment"]) ? [] : this.model.tools["alignment"];
            this._listItems = ej.isNullOrUndefined(this.model.tools["lists"]) ? [] : this.model.tools["lists"];
            this._scriptsItems = ej.isNullOrUndefined(this.model.tools["effects"]) ? [] : this.model.tools["effects"];
            this._contextMenu = ["cut", "copy", "paste", "|", "insertTable", ["addColumnLeft", "addColumnRight", "addRowAbove", "addRowBelow"], "|", "deleteTables", ["deleteRow", "deleteColumn", "deleteTable"], "|", "tableProperties", "|", "createLink", "openLink", "removeLink", "imageProperties"];
            this._contextType = { text: ["cut", "copy", "paste", "createLink"], image: ["cut", "copy", "paste", "imageProperties"], hyperlink: ["cut", "copy", "paste", "createLink", "openLink", "removeLink"], table: ["cut", "copy", "paste", "insertTable", "deleteTables", "tableProperties", "createLink"], table_hyper: ["cut", "copy", "paste", "insertTable", "deleteTables", "tableProperties", "createLink", "openLink", "removeLink"] };
            return this;
        },

        _render: function () {
            this._renderWrapper()
            ._checkNameAttr();
            if (this.model.showToolbar) {
                this._renderToolBar();
            }
            this._trigger("preRender", this.element);
            this._renderEditArea();
            this.model.showFooter && this._renderFooter();
            this._setIframeHeight();
            this._rteWidth = this.model.width;
            this._rteHeight = this.model.height;
            this._renderAlertDialog();
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _initContextMenu: function () {
            var menuOptions = [], subMenuOptions = [];
            for (var i = 0; i < this._contextMenu.length; i++) {
                if (this._contextMenu[i] != "|") {
                    if (typeof this._contextMenu[i] === "object") {
                        var temp = i + 1;
                        for (var j = 0; j < this._contextMenu[i].length; j++) {
                            if (this._contextMenu[i][j] != "|") {
                                menuOptions.push({ id: this._contextMenu[i][j], parentId: this._contextMenu[i - 1], text: this._getLocalizedLabels(this._contextMenu[i][j]), sprite: "e-rte-toolbar-icon " + this._contextMenu[i][j] + " " + this._rteIconsList[this._contextMenu[i][j]], htmlAttr: (this._contextMenu[i + 1][j + 1] == "|" ? { "class": "e-rte-separator", "id": this._contextMenu[i][j] } : { "id": this._contextMenu[i][j] }) });
                            }
                        }
                    } else {
                        menuOptions.push({ id: this._contextMenu[i], parentId: null, text: this._getLocalizedLabels(this._contextMenu[i]), sprite: "e-rte-toolbar-icon " + this._contextMenu[i] + " " + this._rteIconsList[this._contextMenu[i]], htmlAttr: (this._contextMenu[i + 1] == "|" ? { "class": "e-rte-separator", "id": this._contextMenu[i] } : { "id": this._contextMenu[i] }) });
                    }
                }
            }
            return menuOptions;
        },
        _createContextMenu: function () {
            var ContextMenutag = ej.buildTag('ul.e-rte-context-menu #' + this._id + "_contextmenu");
            var proxy = this;
            ContextMenutag.ejMenu({
                menuType: ej.MenuType.ContextMenu,
                enableSeparator: true,
                width: "auto",
                enableRTL: this.model.enableRTL,
                cssClass: this.model.cssClass,
                contextMenuTarget: this._getDocument(),
                click: $.proxy(this._contextMenuClick, this),
                fields: { dataSource: this._initContextMenu(), id: "id", parentId: "parentId", text: "text", htmlAttribute: "htmlAttr", spriteCssClass: "sprite" },
                beforeOpen: function (args) {
                    (proxy._isIE() && proxy._ieSelectionRange) && proxy.selectRange(proxy._ieSelectionRange);
                    proxy.model.enabled ? this.enable() : this.disable();
                    proxy._filterMenuItems(proxy._contextMenuEventArgs = args.events);
                    $(this.element).parent().hide();
                },
                open: function () {
                    $(this.element).attr("style", ("visibility:visible;width:auto;display:block;left:0px;top:0px;"));
                    $(this.element).parent().show();
                    proxy._contextmenuPosition(proxy._contextMenuEventArgs);
                    this._showAnimation(this.element, this._showAnim);
                    $(this.element).focus();
                },
                close: function () {
                    $(proxy._getDocument()).find("body").removeClass("e-cursor");
                }
            });
            return ContextMenutag;
        },
        _showHideContextMenu: function () {
            if (this.model.allowEditing && this.model.enabled && this.model.showContextMenu && this._getDocument()) {
                this._textMenuObj = this._createContextMenu().data("ejMenu");
                //below codes unbinds the contextMenu taphold event.
                this._textMenuObj["_off"]($(this._textMenuObj.model.contextMenuTarget), "mouseup taphold", this._textMenuObj._ContextMenuHandler);
                this._textMenuObj["_on"]($(this._textMenuObj.model.contextMenuTarget), "mouseup", this._textMenuObj._ContextMenuHandler);
            }
            else
                (this._textMenuObj) && this._textMenuObj.destroy();
        },
        _checkNameAttr: function () {
            if (this.model.name)
                this.element.attr({ "name": this.model.name });
            else if (ej.isNullOrUndefined(this.element.attr("name")))
                this.element.attr({ "name": this.element[0].id });
        },
        _enableEdit: function (args) {
            this.model.allowEditing = args;
            if (args) {
                this._wireEvents();
                this.model.showToolbar && this._toolBarItems.ejToolbar("option", "click", this._toolBarClick);
                this._rteIframe.contents().find("body").attr("contenteditable", true);
            }
            else {
                this._unwireEvents();
                this.model.showToolbar && this._toolBarItems.ejToolbar("option", "click", null);
                this._rteIframe.contents().find("body").attr("contenteditable", false);
            }
            this._showHideContextMenu();
            this._disableResizeObj(args);
        },
        _disableResizeObj: function (value) {
            if (value) {
                if (!this.model.enableRTL) this._on($(this._getDocument()).find("table.e-rte-table"), "mouseover", this._tableMouseOver);
            }
            else {
                if (ej.browserInfo().name === "mozilla") this._getDocument().designMode = "off";
                this._off($(this._getDocument()).find("table.e-rte-table"), "mouseover", this._tableMouseOver);
                this._removeResizeObject();
            }
        },
        _changeSkin: function (value) {
            this._rteWapper.removeClass(this.model.cssClass).addClass(value);
            this._subControlsSetModel("cssClass", value);
        },

        _updateIframeSkin: function (htmlAttr) {
            try {
                var target = this._rteIframe.contents().find("body");
                if (htmlAttr) {
                    proxy = this;
                    $.map(htmlAttr, function (value, key) {
                        if (key == "class") target.addClass(value);
                        else if (key == "required") target.attr(key, value);
                        else if (key == "disabled" && value == "disabled") proxy.disable();
                        else if (key == "readOnly" && value == "readOnly") proxy._enableEdit(false);
                        else target.attr(key, value);
                    });
                }
            }
            catch (err) {
                return false;
            }
        },


        _renderWrapper: function () {
            if (this.model.minHeight.toString().indexOf("%") > 0)
                this.model.minHeight = (parseInt(this.model.height) * parseInt(this.model.minHeight)) / 100;
            if (!ej.isNullOrUndefined(this.model.maxHeight) && (this.model.maxHeight.toString().indexOf("%") > 0))
                this.model.maxHeight = parseInt(this.model.height) + (parseInt(this.model.height) * parseInt(this.model.maxHeight)) / 100;
            if (this.model.minWidth.toString().indexOf("%") > 0)
                this.model.minWidth = (parseInt(this.model.width) * parseInt(this.model.minWidth)) / 100;
            if (!ej.isNullOrUndefined(this.model.maxWidth) && (this.model.maxWidth.toString().indexOf("%") > 0))
                this.model.maxWidth = parseInt(this.model.width) + (parseInt(this.model.width) * parseInt(this.model.maxWidth)) / 100;
            this._rteWapper = ej.buildTag("div.e-rte e-rte-wrapper e-widget e-box " + this.model.cssClass + "#" + this._rteId + "_wrapper", "", {}, { role: "presentation" }).insertBefore(this.element);
            this._rteWapper.css("height", this.model.height).css("width", this.model.width).css("min-height", this.model.minHeight).css("min-width", this.model.minWidth).css("max-height", this.model.maxHeight).css("max-width", this.model.maxWidth);
            this._rteWapper.append(this.element.hide());
            return this;
        },

        _renderToolBar: function () {
            this._rteToolbar = ej.buildTag("div.e-rte-toolbar #" + this._rteId + "_tools").insertAfter(this.element);
            this._crateToolbarTemplate()
            ._initToolBarItems()
            ._renderToolBarList();
            this._renderToolBarItems();
            if (!ej.isNullOrUndefined(this._explorerObj))
                this._rteToolbar.find("li.e-rteItem-image").length > 0 && this._explorerObj.setModel({ showFooter: false, showTreeview: false });
            if (!ej.isNullOrUndefined(this._fileBrowserObj))
                this._rteToolbar.find("li.e-rteItem-fileBrowser").length > 0 && this._fileBrowserObj.setModel({ showFooter: false, showTreeview: false });
            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") this._toolBarObj.disableItemByID(this._rteId + "_" + "video");
        },
        _renderToolBarList: function () {
            var model = {};
            model.click = this.model.allowEditing ? this._toolBarClick : null;
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeparator = true;
			if(this.model.toolbarOverflowMode=="inline")
			model.responsiveType="inline";
            model.isResponsive = this.model.isResponsive;
            model.height = model.isResponsive ? "" : "auto";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.tooltipSettings = this.model.tooltipSettings;
            model.create = function () {
                var ddl = $(this.element).find(".e-ddl.e-widget .e-dropdownlist"), spbtn = $(this.element).find(".e-split.e-widget .e-splitbutton");
                ddl.length && ddl.ejDropDownList({ height: "30px" });
                spbtn.length && spbtn.ejSplitButton({ height: '30px' });
            }
            this._toolBarItems.ejToolbar(model);
            this._disableTabkeyNavigation(this._toolBarItems)._disableTabkeyNavigation(this._toolBarItems.find("[tabindex],.e-split-btn"));
            this._toolBarObj = this._toolBarItems.ejToolbar("instance");
            this._on($(document), "mouseup touchend", this._zoomUp);
            this._on($(this._toolBarObj.itemsContainer).find(".e-rteItem-zoomIn , .e-rteItem-zoomOut"), "mousedown touchstart", this._zoomDown);
        },
        _disableTabkeyNavigation: function (elements) {
            $(elements).attr("tabindex", '-1');
            return this;
        },
        _crateToolbarTemplate: function () {
            this._toolBarItems = ej.buildTag("div#" + this._rteId + "_toolbar").appendTo(this._rteToolbar).height(30);
            for (var items in this._toolsList) {
                items = this._toolsList[items];
                if (!ej.isNullOrUndefined(this.model.tools[items])) {
                    if (items == "customTools")
                        !ej.isNullOrUndefined(this.model.tools[items]) && this._customTools(this.model.tools[items]);
                    else
                        this.model.tools[items].length > 0 && this._createToolsItems(this.model.tools[items], items);
                }
            }
            if (this.model.fileBrowser.filePath != "") {
                var ulTag = ej.buildTag("ul#" + this._rteId + "-file-exporer"), liTag;
                liTag = $("<li id='" + this._rteId + "_fileBrowser" + "' class='e-rte-explorer e-rteItem-fileBrowser' title='" + this._getLocalizedLabels("fileBrowser") + "' ><div class='e-rte-toolbar-icon fileBrowser e-fileBrowser' unselectable = 'on'></div></li>");
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
            return this;
        },

        _createToolsItems: function (items, itemName) {
            var ulTag = ej.buildTag("ul#" + (this._rteId + "_" + itemName)), liTag;
            (itemName == "font") && ulTag.addClass("e-rte-fontgroup");
            (itemName == "formatStyle") && ulTag.addClass("e-rte-format");
            (itemName == "lists") && ulTag.addClass("e-rte-lists");
            for (var i = 0; i < items.length; i++) {
                liTag = $("<li id='" + (this._rteId + "_" + items[i].replace(/ /g, '')) + "' class='e-rteItem-" + items[i] + "' ><div class='e-rte-toolbar-icon " + items[i] + " " + this._rteIconsList[items[i]] + "' unselectable = 'on'></div></li>");
                if (items[i] === "video" && ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") liTag.attr('title', this._getLocalizedLabels("html5Support"));
                else liTag.attr('title', this._getLocalizedLabels(items[i].replace(/ /g, '')));
                if (items[i] === "fullScreen") liTag.attr('data-content', this._getLocalizedLabels("maximize")).children(".e-rte-toolbar-icon").addClass(this._rteIconsList["maximize"]);
                else if (items[i] === "findAndReplace")
                    liTag.attr('title', this._getLocalizedLabels("FindAndReplace"));
                liTag.appendTo(ulTag);
            }
            ulTag.appendTo(this._toolBarItems);
            if (itemName == "font" && !this.model.showFontOption)
                ulTag.hide();
        },

        _customTools: function (toolbarItems) {
            for (var item = 0; item < toolbarItems.length; item++) {
                var ulTag = ej.buildTag("ul"), liTag;
                liTag = $("<li id='" + toolbarItems[item].name + "' title='" + toolbarItems[item].tooltip + "' ><div class='" + (ej.isNullOrUndefined(toolbarItems[item].css) ? "" : toolbarItems[item].css) + "'>" + (ej.isNullOrUndefined(toolbarItems[item].text) ? "" : toolbarItems[item].text) + "</div></li>");
                var fn = toolbarItems[item].action;
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }
                !ej.isNullOrUndefined(toolbarItems[item].action) && this._on(liTag, "click", fn);
                $(toolbarItems[item].template).appendTo(liTag.find("div"));
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
        },

        _initToolBarItems: function () {
            this._rteToolbar.find("li.e-rteItem-format").length > 0 && this._renderFormat();
            this._rteToolbar.find("li.e-rteItem-createLink").length > 0 && this._renderLinkDialog();
            this._rteToolbar.find("li.e-rteItem-video").length > 0 && this._renderVideoDialog();
            this._rteToolbar.find("li.e-rteItem-image").length > 0 && this._renderImageDialog();
            this._rteToolbar.find("li.e-rteItem-createTable").length > 0 && this._renderTableDialog();
            this._rteToolbar.find("li.e-rteItem-fontName").length > 0 && this._renderFontStyle();
            this._rteToolbar.find("li.e-rteItem-fontSize").length > 0 && this._renderFontSize();
            this._rteToolbar.find("li.e-rteItem-fontColor").length > 0 && this._renderFontColor();
            this._rteToolbar.find("li.e-rteItem-backgroundColor").length > 0 && this._renderBGColor();
            this._rteToolbar.find("li.e-rteItem-createTable").length > 0 && this._renderEditTableDialog();
            this._rteToolbar.find("li.e-rteItem-fileBrowser").length > 0 && this._renderFileBrowserDialog();
            this._rteToolbar.find("li.e-rteItem-unorderedList").length > 0 && this._renderUnOrderList();
            this._rteToolbar.find("li.e-rteItem-orderedList").length > 0 && this._renderOrderList();
            this._rteToolbar.find("li.e-rteItem-import").length > 0 && this._renderimport();
            !this.model.showClearAll && this._rteToolbar.find("li.e-rteItem-clearAll").hide();
            return this;
        },
        _renderToolBarItems: function () {
            this._toolBarObj.disableItemByID(this._rteId + "_" + "undo");
            this._toolBarObj.disableItemByID(this._rteId + "_" + "redo");
            // Default action when render the RTE
            if (!this.model.enableRTL)
                this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft");
            else
                this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyRight");
            //Hide the editable table icons
            var items = this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
            if (this.model.isResponsive && items.length == 0) this._toolBarObj._liTemplte.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable").hide();
            else this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable").hide();
            return this;
        },

        _renderEditArea: function () {
            this._rteEditor = ej.buildTag("div.editarea #" + this._rteId + "_editor").appendTo(this._rteWapper);
            this._rteIframe = ej.buildTag("iframe.content-iframe #" + this._rteId + "_Iframe", "", {}, { frameborder: "0" }).appendTo(this._rteEditor);
            this._setIFrames();
            if (navigator.userAgent.match(/iPad/i) != null)
                this._rteEditor.addClass('e-ipadscroll');
        },

        _xhtmlTagValidation: function () {
            if (this.value() != null) {
                var htmlText = this.value();
                htmlText = htmlText.replace(/\r/gi, " ").replace(/\n/gi, "<br/> ").replace(/\r\n/gi, " ").replace(/( )+/gi, " ").replace(/&nbsp;/gi, " ").replace(/&bull;/gi, "*").replace(/&ltquo;/gi, "<").replace(/&rtquo;/gi, ">").replace(/&trze;/gi, "(tm)").replace(/&copy;/gi, "(c)").replace(/&reg;/gi, "(r)");
                if (htmlText.indexOf("<body>") != -1) {
                    var indexBody = htmlText.indexOf("<body>");
                    var delBody = htmlText.slice(0, indexBody + 6);
                    htmlText = htmlText.replace(delBody, "").replace("</body></html>", "");
                }
                htmlText = htmlText.replace(/<br>/g, "<br/>").replace(/<hr>/g, "<hr/>");
                htmlText = this._imageXhtml(htmlText);
                htmlText = this._styleXhtml(htmlText);
                htmlText = this._startXhtml(htmlText);
                if (htmlText.indexOf("alt=") != -1) {
                    var imageTag = /alt=\"(.*?)\"/ig;
                    var altTemp = new Array();
                    var tempAlt;
                    var j = 0;
                    while ((tempAlt = imageTag.exec(htmlText)) != null) {
                        altTemp[j] = tempAlt[0];
                        j++;
                    }
                    for (var i = 0; i < altTemp.length; i++) {
                        htmlText = htmlText.replace(altTemp[i], "alt=\"\"");
                    }
                }
                if (!ej.isNullOrUndefined(this._fontXhtml(htmlText))) {
                    htmlText = this._fontXhtml(htmlText);
                    if (htmlText.indexOf("ol") != -1) {
                        var olStyle = /<ol(.*)<\/ol>/ig;
                        var tempOl;
                        var k = 0;
                        var olTemp = new Array();
                        while ((tempOl = olStyle.exec(htmlText)) !== null) {
                            olTemp[k] = tempOl[0].toString();
                            k++;
                        }
                        var olEx = new Array();
                        for (var f = 0; f < olTemp.length; f++) {
                            olEx[f] = olTemp[f];
                        }
                        for (var i = 0; i < olTemp.length; i++) {
                            olTemp[i] = olTemp[i].replace(/<br\/>/gi, "");
                        }
                        for (var i = 0; i < olTemp.length; i++) {
                            htmlText = htmlText.replace(olEx[i], olTemp[i]);
                        }
                    }
                    htmlText = htmlText.replace(/<o:p>/gi, "").replace(/<\/o:p>/gi, "");
                }
                this.value(htmlText);
            }
        },

        _setIFrames: function () {
            var rteContent = null;
            if ((this.value() != null && this.value() != "")) rteContent = this.value().replace(/'/g, "\"");
            if (rteContent == null) this.value($.trim(this.element[0].value));
            var isIE8 = ej.browserInfo().name == 'msie' && parseInt(ej.browserInfo().version) == 8;
            var _htmlText = ("<!DOCTYPE html> <html> <head> <meta charset='utf-8' /> <style>html, body{height: 100%;margin: 0;}body.e-cursor{cursor:default} span.e-selected-node	{background-color: #939393;color: white;}span.e-selected-node.e-highlight{background-color: #1d9dd8;}body{font-family:Times New Roman,Times,serif;color:#5C5C5C;word-wrap:break-word;padding: 8px;box-sizing: border-box;}.e-rte-table caption{border: 1px solid;border-bottom:none}td{word-wrap:break-word;word-break:break-all;}.e-rteColumnResizer{position: absolute;bottom:0;overflow: visible;cursor: col-resize;background-repeat:repeat;background-color:transparent}.e-rteRowResizer{position: absolute;bottom:0;overflow: visible;margin-left: -4px;cursor: row-resize;background-repeat:repeat;background-color:transparent} span.e-rte-imageboxmark{width:5px;height:5px;position:absolute;display:block;background:#fff;border:1px solid #000;}</style></head><body spellcheck='false' autocorrect='off' contenteditable=" + (this.model.allowEditing ? 'true' : 'false') + ">" + ((this.value() != "" && this.value() != "<br>" ) ? $.trim(this.value()) : "<p><span>&#65279;</span></p>" ) + "</body></html>");
            this._rteIframe.css({ "width": "100%" });
            if (this.element[0].value == "<div></div>" || this.element[0].value == "")
                this.element[0].innerHTML = this.value();

            this._setContent(_htmlText);
            if (this._isIE8()) this.value(this._getDocument().body.innerHTML);
			var _tableEle = $(this._getDocument()).find("table");       
            if (!this.model.enableRTL && _tableEle.length > 0 ) this._on(_tableEle, "mouseover", this._tableMouseOver);
            if (this.model.enableXHTML) this._updateValue();
            this._setAutoHeight();
            if (!ej.isNullOrUndefined(this.model.undoStackLimit) || this.model.undoStackLimit !== "" || this.model.undoStackLimit > 0)
                this._backupArray[0] = this.getHtml();
        },


        _setIframeHeight: function () {
            var _height = (!ej.isNullOrUndefined(this._rteToolbar) && this._rteToolbar.is(':visible') ? this._rteToolbar.outerHeight() : 6) + (!ej.isNullOrUndefined(this._rteFooter) && this._rteFooter.is(':visible') ? this._rteFooter.outerHeight() : 0);
            this._rteIframe.css("height", (_height == 0 ? this.model.height : ((this._rteWapper.outerHeight() - _height) - (parseInt(this._rteEditor.css("padding-top")) + parseInt($(".e-rte-wrapper").css("border-bottom-width")) + parseInt(this.model.showFooter ? $(".e-rte-footer").css("margin-top") : 0)))));
        },

        // Footer Div render 
        _renderFooter: function () {
            var options = this.model;
            this._rteFooter = ej.buildTag("div.e-rte-footer #" + this._rteId + "_footer").appendTo(this._rteWapper);
            var _leftPan = ej.buildTag("div.e-rte-footer-left");
            this._htmlSource = ej.buildTag("div.e-rte-icons e-rte-footeritems e-rte-footericon e-rte-source " + this._rteIconsList["rteSource"], "", {}, { title: this._getLocalizedLabels("viewHtml") }).appendTo(_leftPan);
            this._htmlInfo = ej.buildTag("div.e-rte-htmltaginfo e-rte-footeritems").appendTo(_leftPan);
            _leftPan.appendTo(this._rteFooter);
            var _rightPan = ej.buildTag("div.e-rte-footer-right");
            this._wordCount = ej.buildTag("div.e-rte-wordcount e-rte-footeritems").appendTo(_rightPan);
            this._charCount = ej.buildTag("div.e-rte-charcount e-rte-footeritems").appendTo(_rightPan);
            this._clearFormat = ej.buildTag("div.e-rte-icons " + this._rteIconsList["clearFormat"] + " e-rte-footericon e-rte-footeritems", "", {}, { title: this._getLocalizedLabels("clearFormat"), "unselectable": "on" }).appendTo(_rightPan);
            this._clearAll = ej.buildTag("div.e-rte-icons clearAll " + this._rteIconsList["clearAll"] + " e-rte-footericon e-rte-footeritems", "", {}, { title: this._getLocalizedLabels("clearAll") }).appendTo(_rightPan);
            this._resize = ej.buildTag("div.e-icons e-rte-resize " + this._rteIconsList["rteResize"] + " e-rte-footeritems").appendTo(_rightPan);
            _rightPan.appendTo(this._rteFooter);
            this._footerEvents("_on");
            !this.model.showHtmlSource && this._htmlSource.hide().removeClass("e-rte-footeritems");
            !this.model.showHtmlTagInfo && this._htmlInfo.hide().removeClass("e-rte-footeritems");
            !this.model.showWordCount && this._wordCount.hide().removeClass("e-rte-footeritems");
            !this.model.showCharCount && this._charCount.hide().removeClass("e-rte-footeritems");
            !this.model.showClearAll && this._clearAll.hide().removeClass("e-rte-footeritems");
            !this.model.showClearFormat && this._clearFormat.hide().removeClass("e-rte-footeritems");
            //if (options.showFooter && this.model.enableRTL) this._rteFooter.addClass("e-rtl");
            if (options.enableResize)
                this._enableResize();
            else
                this._resize.hide().removeClass("e-rte-footeritems");
            this._updateCount();
            if (this.model.showWordCount) this._on(this._wordCount, "click", this._wordCharClick);
            if (this.model.showCharCount) this._on(this._charCount, "click", this._wordCharClick);
            this._renderTooltip(this.model.tooltipSettings);

        },
        _renderTooltip: function (options) {
            var model = $.extend(true, {}, options);
            if (!ej.isNullOrUndefined(model.cssClass))//which holds the css for the tooltip
                model.cssClass = model.cssClass + " e-rteTooltip " + this.model.cssClass;
            else
                model.cssClass = "e-rteTooltip " + this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.target = ".e-rte-icons";
            if (this.model.showFooter)
                this._tooltip = $(this._rteFooter).ejTooltip(model).data("ejTooltip");
        },
        _hideTooltip: function () {
            if (!ej.isNullOrUndefined(this._tooltip))
                this._tooltip.hide();
        },
        _footerElement: function (selector, visible) {
            if (this.model.showFooter) {
                var ele = this._rteFooter.find(selector);
                visible ? ele.show().addClass("e-rte-footeritems") : ele.hide().addClass("e-rte-footeritems");
            }
        },
        _wordCharClick: function (e) {
            this._alertWindow.ejDialog("option", { "showHeader": true, "title": "<span style='padding-left:0.4em;'>" + this._getLocalizedLabels("wordCount") + "</span>" });
            this.model.enableRTL && this._alertWindow.find(".e-alert-ok").removeClass("e-rte-alertBtnRTL");
            this._alertWindow.find(".e-rte-button").removeClass("e-fieldseparate").css({ "text-align": "center", "padding-bottom": "1em", "padding-top": "0.5em" });
            this._alertWindow.ejDialog("instance").refresh();
            this._openAlert("<div style='padding-left:0.3em;padding-right:0.3em;'><div style='" + ((this.model.enableRTL) ? 'float:right' : 'float:left') + "'>" + this._getLocalizedLabels("words") + "<p style='margin:0.875em 0em;'>" + this._getLocalizedLabels("charSpace") + "</p><p style='margin:0.875em 0em;'>" + this._getLocalizedLabels("charNoSpace") + "</p></div><div style='" + ((this.model.enableRTL) ? 'float:left;padding-right:2em;' : 'float:right;padding-left:2em;') + "'>"
			+ ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0) + "<p style='margin:0.875em 0em;'>" + this._getText().length + "</p><p style='margin:0.875em 0em;'>" + this._getText().replace(/\s/g, "").length + "</p></div></div><br/>");
        },
        _updateColorPalette: function () {
            var _fontColor = $("ul#" + this._rteId + "_colorTable");
            var _bgColor = $("ul#" + this._rteId + "_colorBGTable");
            _fontColor.find("div.e-rte-table").remove();
            _fontColor.find("li").append(this._colorTable());
            //Bg Color table Update
            _bgColor.find("div.e-rte-table").remove();
            _bgColor.find("li").append(this._colorTable());
        },
        _enableRTL: function (value) {
            try {
                if (value)
                    this._rteIframe.contents().find("body").css("direction", "rtl");
                else
                    this._rteIframe.contents().find("body").css("direction", "ltr");
            }
            catch (error) { }
            this._subControlsSetModel("enableRTL", value);
            //if (this.model.showFooter && this._rteFooter) this._rteFooter.addClass("e-rtl");
        },
        _roundedCorner: function (value) {
            if (value) this._rteWapper.toggleClass('e-corner-all');
            this._subControlsSetModel("showRoundedCorner", value);
        },
        _subControlsSetModel: function (prop, value) {
            if (!ej.isNullOrUndefined(this._tooltip)) {
                if (prop == "cssClass")
                    $(this._rteFooter).ejTooltip("option", prop, "e-rteTooltip " + value);
                else
                    $(this._rteFooter).ejTooltip("option", prop, value);
            }
            !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontColorSplit) && this._fontColorSplit.ejSplitButton("option", prop, value);
            !ej.isNullOrUndefined(this._bgColorSplit) && this._bgColorSplit.ejSplitButton("option", prop, value);
            if (!ej.isNullOrUndefined(this._toolBarItems)) {
                if ((prop == "showRoundedCorner") && this._toolBarItems.hasClass("e-corner-top"))
                    this._toolBarItems.removeClass("e-corner-top").addClass("e-corner-all");
                this._toolBarItems.ejToolbar("option", prop, value);
                if ((prop == "showRoundedCorner") && this._toolBarItems.hasClass("e-corner-all"))
                    this._toolBarItems.removeClass("e-corner-all").addClass("e-corner-top");
            }
            if (!ej.isNullOrUndefined(this._linkDialog)) {
                this._linkDialog.ejDialog("option", prop, value);
                this._linkDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkTarget.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._linkDialog.find(".e-inputtext").addClass('e-corner-all') : this._linkDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._imgDialog)) {
                this._imgDialog.ejDialog("option", prop, value);
                this._imgDialog.find("div.e-rte-imageTab").ejTab("option", prop, value);
                this._imgDialog.find(".e-rte-imgBorderPx").ejNumericTextbox("option", prop, value);
                this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList("option", prop, value);
                this._chkImgDimensions.ejCheckBox("option", prop, value);
                this._dialogchkTarget.ejCheckBox("option", prop, value);
                this._imgDialog.find(".e-rte-btn").ejButton("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._imgDialog.find(".e-inputtext").addClass('e-corner-all') : this._imgDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._videoDialog)) {
                this._videoDialog.ejDialog("option", prop, value);
                this._videoDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkvideoDimensions.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._videoDialog.find(".e-inputtext").addClass('e-corner-all') : this._videoDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("option", prop, value);
            if (!ej.isNullOrUndefined(this._sourceDialog)) {
                this._sourceDialog.ejDialog("option", prop, value);
                this._sourceDialog.find(".e-rte-btn").ejButton("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._sourceDialog.find(".e-inputtext").addClass('e-corner-all') : this._sourceDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._alertWindow)) {
                this._alertWindow.ejDialog("option", prop, value);
                this._alertWindow.find(".e-rte-btn").ejButton("option", prop, value);
            }
            if (!ej.isNullOrUndefined(this._customTableDialog)) {
                this._customTableDialog.ejDialog("option", prop, value);
                this._customTableDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._customTableDialog.find(".numerictextbox").ejNumericTextbox("option", prop, value);
                this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("option", prop, value);
                this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("option", prop, value);
                this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("option", prop, value);
                this._chkTblCaption.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._customTableDialog.find(".e-inputtext").addClass('e-corner-all') : this._customTableDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._eTblDialog)) {
                this._eTblDialog.ejDialog("option", prop, value);
                this._eTblDialog.find(".e-numerictextbox").ejNumericTextbox("option", prop, value);
                this._eTblDialog.find(".e-rte-dropdown").ejDropDownList("option", prop, value);
                this._getTableObj("_Tab").ejTab("option", prop, value);
                this._eTblDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._eTblCaption.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._eTblDialog.find(".e-inputtext").addClass('e-corner-all') : this._eTblDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._fileDialog)) {
                this._fileDialog.ejDialog("option", prop, value);
                this._fileDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkFileTarget.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._fileDialog.find(".e-inputtext").addClass('e-corner-all') : this._fileDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._explorerObj))
                this._explorerObj.option(prop, value);
            if (!ej.isNullOrUndefined(this._fileBrowserObj))
                this._fileBrowserObj.option(prop, value);
        },
        _createCountElement: function (option, element) {
            option ? element.show() : element.hide();
            element.toggleClass("e-rte-footeritems");
        },

        _enableResize: function () {
            if (this.model.enableResize && this.model.enabled) {
                this._rteWapper.addClass("e-resizable");
                this._resizeRTE();
            }
        },

        _resizeRTE: function () {
            var proxy = this;
            this._overlayElement = ej.buildTag('div.e-rte-overlay');
            this._rteEditor.css("position", "relative");
            this._rteWapper.find("div.e-rte-resize").ejResizable(
                {
                    minHeight: parseInt(proxy.model.minHeight),
                    minWidth: parseInt(proxy.model.minWidth),
                    maxHeight: parseInt(proxy.model.maxHeight),
                    maxWidth: parseInt(proxy.model.maxWidth),
                    resizeStart: function (event) {
                        proxy._rteEditor.append(proxy._overlayElement);
                        proxy._trigger("resizeStart", { event: event });
                    },
                    resize: function (event) {
					    proxy._updateCount();
                        proxy._resizeHeight(event.element);
                        proxy._trigger("resize", { event: event });
                        if (proxy.model.isResponsive && proxy.model.showToolbar) proxy._toolBarObj._reSizeHandler();
                    },
                    resizeStop: function (event) {
                        proxy._overlayElement.remove();
                        proxy._trigger("resizeStop", { event: event });
                    },
                    helper: function (event) {
                        proxy._resizeHeight(event.element);
                        return $(proxy._rteWapper);
                    }
                });
        },
        _getDocumentHandler: function () {
            (!this._operationHandler) && (this._operationHandler = new ej.editorManager(this.getDocument(), this._getWindow()));
            return this._operationHandler;
        },
        _resizeHeight: function (element) {
            var reElement = $(element).parents("div.e-rte-wrapper");
            this._rteWidth = $(reElement).width();
            this._rteHeight = $(reElement).height();
            this._rteWapper.height(this._rteHeight);
            this._rteWapper.width(this._rteWidth);
            this._setIframeHeight();
        },

        _getDialogModel: function () {
            var rtecontent = this._rteWapper;
            return dialogModel = {
                enableResize: false,
                showOnInit: false,
                enableModal: true,
                cssClass: this.model.cssClass,
                target: rtecontent,
				isResponsive:true,
                enableRTL: this.model.enableRTL
            };
        },
        _labelFor: function (val) {
            return this._rteId ? " for=" + this._rteId + val + " " : "";
        },
        _TagId: function (val) {
            return this._rteId ? " id=" + this._rteId + val + " " : "";
        },
        _renderLinkDialog: function () {
            var proxy = this;
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var createLink = this._linkDialog = ej.buildTag("div#" + this._rteId + "_link");
            var content = $("<div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_link_url") + ">" + this._getLocalizedLabels("linkWebUrl") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-linkUrl' " + this._TagId("_link_url") + "/></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_link_text") + ">" + this._getLocalizedLabels("linkText") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-linkText' " + this._TagId("_link_text") + "></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_link_title") + ">" + this._getLocalizedLabels("linkTooltipLabel") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-linkTitle' " + this._TagId("_link_title") + "></div><div class='e-rte-label " + btnDiv + "'></div>" +
                           "<div class='e-rte-field " + btnDiv + "'><input type='checkbox' class='e-rte-linkTarget'  data-role ='none' " + this._TagId("_link_target") + "><label " + this._labelFor("_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div>" +
                           "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='link_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "'type='button' data-role ='none' id='link_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(createLink);
            createLink.appendTo(this._rteWapper);
            var model = this._getDialogModel();
			model.minWidth="340px";
			model.width="auto";
            model.title = this._getLocalizedLabels("createLink");
            model.target = null;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            createLink.ejDialog(model);
            createLink.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && createLink.find(".e-inputtext").addClass('e-corner-all');
            this._chkTarget = createLink.find(".e-rte-linkTarget");
            this._chkTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            createLink.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(createLink.find(".e-rte-btn"), "click", this._linkBtnClick)
            ._on(this._linkDialog.find(".e-rte-linkUrl"), "keypress", this._urlValidation);
        },


        _renderImageDialog: function () {
            var proxy = this, pathData = "";
            this._imgDialog = ej.buildTag("div#" + this._rteId + "_Image");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = "<div " + this._TagId("_img_Tab") + " class='e-rte-imageTab'><ul><li class='e-first'><a href='#" + this._rteId + "_general'>" + this._getLocalizedLabels("general") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_advanced'>" + this._getLocalizedLabels("advanced") + " </a></li></ul>" +
                "<div id='" + this._rteId + "_general'>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_url") + ">" + this._getLocalizedLabels("imageWebUrl") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-imgUrl' " + this._TagId("_img_url") + "></div></div><div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'>" +
                         "<label " + this._labelFor("_img_text") + ">" + this._getLocalizedLabels("imageAltText") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none'  class='e-inputtext e-rte-imgText' " + this._TagId("_img_text") + "></div></div>" +
                        "<div class='e-rte-imgdimensions' " + this._TagId("_imgdimensions") + "><div class='e-rte-label " + btnDiv + "'><label>" + this._getLocalizedLabels("dimensions") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "'  data-role ='none' class='e-inputtext e-dimensions e-rte-imgX' maxlength='3' " + this._TagId("_imgX") + "><label style='padding: 5px;'>X</label><input type='text'  data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "' style='margin-right: 5px;' class='e-inputtext e-dimensions e-rte-imgY' maxlength='3' " + this._TagId("_imgY") + "></div>" +
                 "<input type='checkbox' class='e-rte-imgConsrn' data-role ='none'" + this._TagId("_img_consrn") + "<label " + this._labelFor("_img_consrn") + "  style='padding: 5px;'>" + this._getLocalizedLabels("constrainProportions") + "</label></div>" +
                "</div>" +
                "<div id='" + this._rteId + "_advanced'>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_link") + ">" + this._getLocalizedLabels("imageLink") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-imgLink' " + this._TagId("_img_link") + "></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_border_px") + ">" + this._getLocalizedLabels("imageBorder") + "</label></div><div class='e-rte-field " + btnDiv + "'><div class='e-img-border-field'><input type='text' data-role ='none' title='" + this._getLocalizedLabels("imageBorder") + "' class='e-rte-imgBorderPx' maxlength='3' " + this._TagId("_img_border_px") + "></div><div class='e-img-border-field'><select class='e-rte-imgBorderStyle'  data-role ='none' " + this._TagId("_img_border_style") + "><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input  data-role ='none' type='text' title='" + this._getLocalizedLabels("imageBorder") + "' class='e-inputtext e-rte-imgBorderColor' " + this._TagId("_img_border_color") + "></div></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_style") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none'  class='e-inputtext e-rte-imgStyle' " + this._TagId("_img_style") + "></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'></div><div class='e-rte-field " + btnDiv + "'><input type='checkbox' class='e-rte-imgLinkTarget' data-role ='none' " + this._TagId("_img_link_target") + "><label " + this._labelFor("_img_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div></div>" +
                "</div>" +

                "</div>" +
                "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none'  type='button' id='" + this._rteId + "_img_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='" + this._rteId + "_img_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>";
            if (this.model.imageBrowser.filePath != "")
                pathData = "<div " + this._TagId("_img_explorer") + " class='e-rte-explorer e-rte-imgBrowser'></div>";
            content = $(pathData + content);
            content.appendTo(this._imgDialog);
            this._imgDialog.appendTo(this._rteWapper);
            !this.model.showDimensions && this._rteWapper.find("div.e-rte-imgdimensions").hide();
            var model = this._getDialogModel();
			this.model.imageBrowser.filePath=="" ? model.maxWidth="470px" : model.maxWidth="720px";
            model.width ="auto";
		    model.title = this._getLocalizedLabels("image");
            model.target = null;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.open = function () {
                proxy._explorerObj && proxy._explorerObj.adjustSize();
                if (!ej.isNullOrUndefined(proxy._imgSplitObj))
                    proxy._imgSplitObj.option("enableAutoResize", true);
            };
            model.close = function () {
                proxy._ieCursorMaintainance();
                if (!ej.isNullOrUndefined(proxy._imgSplitObj))
                    proxy._imgSplitObj.option("enableAutoResize", false);
            };
            this._imgDialog.ejDialog(model);
            this._imgDialog.closest(".e-dialog-wrap").css({ "visibility": "hidden", "display": "block" }).addClass("e-rte");
            if (this.model.imageBrowser.filePath != "") {
                var ajaxSettings = { upload: { url: this.model.imageBrowser.uploadAction } };
                if (this.model.imageBrowser.ajaxSettings)
                    $.extend(true, ajaxSettings, this.model.imageBrowser.ajaxSettings);

                this._explorerObj = this._imgDialog.find("div.e-rte-imgBrowser").ejFileExplorer({
                    allowMultiSelection: false, enableRTL: this.model.enableRTL, showRoundedCorner: this.model.showRoundedCorner, cssClass: this.model.cssClass, maxWidth: "690px", isResponsive:true,minWidth:"330px",height: "300px", path: this.model.imageBrowser.filePath, fileTypes: this.model.imageBrowser.extensionAllow, layout: ej.FileExplorer.layoutType.LargeIcons, select: function (e) { proxy._UpdateImgDetails(e); },
                    tools: {
                        creation: ["NewFolder", "Open"],
                        navigation: ["Back", "Forward"],
                        addressBar: ["Addressbar"],
                        editing: ["Refresh", "Upload", "Delete"],
                        searchBar: ["Searchbar"]
                    }, toolsList: ["creation", "navigation", "addressBar", "editing", "searchBar"], enableResize: false, showContextMenu: false,
                    ajaxAction: this.model.imageBrowser.ajaxAction, locale: this.model.locale,
                    ajaxSettings: ajaxSettings
                }).data('ejFileExplorer');
                this._imgSplitObj = this._imgDialog.find(".e-splitter").data("ejSplitter");
                this._imgSplitObj.option("enableAutoResize", false);
            }
            this.model.showRoundedCorner && this._imgDialog.find(".e-inputtext").addClass('e-corner-all');
            this._imgDialog.find("div.e-rte-imageTab").ejTab({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-imgBorderPx").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 0, value: 0, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._chkImgDimensions = this._imgDialog.find(".e-rte-imgConsrn");
            this._chkImgDimensions.ejCheckBox({ check: true, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._imgPicker = this._imgDialog.find(".e-rte-imgBorderColor").ejColorPicker({ cssClass: this.model.cssClass, modelType: "palette", buttonText: { apply: this._getLocalizedLabels("buttonApply"), cancel: this._getLocalizedLabels("buttonCancel"), swatches: this._getLocalizedLabels("swatches") } }).data('ejColorPicker');
            this._imgDialog.parents("#" + this._rteId + "_Image_wrapper").css({ "visibility": "visible", "display": "none" });
            this._dialogchkTarget = this._imgDialog.find(".e-rte-imgLinkTarget");
            this._dialogchkTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._imgDialog.find(".e-rte-btn"), "click", this._imageBtnClick)
            this._on(this._imgDialog.find(".e-rte-imgUrl , .e-rte-imgLink"), "keypress", this._urlValidation);
            this._on(this._imgDialog.find("input.e-dimensions"), "change", this._recalcImgSize);
        },
        _renderFileBrowserDialog: function () {
            var proxy = this, pathData = "";
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            this._fileDialog = ej.buildTag("div#" + this._rteId + "_fileDialog");
            var content = "<div class='e-rte-elements'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_file_url") + ">" + this._getLocalizedLabels("linkWebUrl") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-fileUrl' " + this._TagId("_file_url") + "/></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_file_text") + ">" + this._getLocalizedLabels("linkText") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-fileText' " + this._TagId("_file_text") + "></div> </div>" +
                           "<div class='e-rte-field'><input type='checkbox' class='e-rte-fileTarget'  data-role ='none' " + this._TagId("_file_target") + "><label " + this._labelFor("_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div>" +
                           "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='" + this._rteId + "_file_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "'type='button' data-role ='none' id='" + this._rteId + "_file_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>";
            pathData = "<div " + this._TagId("_file_explorer") + " class='e-rte-explorer e-rte-fileBrowser'></div>";
            content = $(pathData + content);
            content.appendTo(this._fileDialog);
            this._fileDialog.appendTo(this._rteWapper);
            var model = this._getDialogModel();
			model.width="auto";
            model.title = this._getLocalizedLabels("fileBrowser");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.open = function () {
                proxy._fileBrowserObj.adjustSize();
                if (!ej.isNullOrUndefined(proxy._fileSplitObj))
                    proxy._fileSplitObj.option("enableAutoResize", true);
            };
            model.close = function () {
                proxy._ieCursorMaintainance();
                if (!ej.isNullOrUndefined(proxy._fileSplitObj))
                    proxy._fileSplitObj.option("enableAutoResize", false);
            };
            this._fileDialog.ejDialog(model);
            this._fileDialog.closest(".e-dialog-wrap").css({ "visibility": "hidden", "display": "block" }).addClass("e-rte");
            var ajaxSettings = { upload: { url: this.model.fileBrowser.uploadAction } };
            if (this.model.fileBrowser.ajaxSettings)
                $.extend(true, ajaxSettings, this.model.fileBrowser.ajaxSettings);

            this._fileBrowserObj = this._fileDialog.find("div.e-rte-fileBrowser").ejFileExplorer({
                allowMultiSelection: false, enableRTL: this.model.enableRTL, showRoundedCorner: this.model.showRoundedCorner, cssClass: this.model.cssClass, maxWidth:"690px", height: "300px",isResponsive:true,minWidth:"330px", path: this.model.fileBrowser.filePath, fileTypes: this.model.fileBrowser.extensionAllow, layout: "list", select: function (e) { proxy._UpdateFileDetails(e); },
                tools: {
                    creation: ["NewFolder", "Open"],
                    navigation: ["Back", "Forward"],
                    addressBar: ["Addressbar"],
                    editing: ["Refresh", "Upload", "Delete"],
                    searchBar: ["Searchbar"]
                }, toolsList: ["creation", "navigation", "addressBar", "editing", "searchBar"], enableResize: false, showContextMenu: false,
                ajaxAction: this.model.fileBrowser.ajaxAction, locale: this.model.locale,
                ajaxSettings: ajaxSettings
            }).data('ejFileExplorer');
            this._fileSplitObj = this._fileDialog.find(".e-splitter").data("ejSplitter");
            this._fileSplitObj.option("enableAutoResize", false);
            this.model.showRoundedCorner && this._fileDialog.find(".e-inputtext").addClass('e-corner-all');
            this._fileDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._fileDialog.parents("#" + this._rteId + "_fileDialog_wrapper").css({ "visibility": "visible", "display": "none" });
            this._chkFileTarget = content.find(".e-rte-fileTarget");
            this._chkFileTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._fileDialog.find(".e-rte-btn"), "click", this._fileBtnClick);
        },
        _UpdateImgDetails: function (e) {
            if ($(this._imgURL).hasClass('e-error')) this._imgURL.removeClass("e-error");
            if (e.path === "") this._imgURL.val("http://");
            else this._imgDialog.find("div.e-rte-imageTab").find('.e-rte-imgUrl').val(e.path + (e.name[0] ? e.name[0] : ""));
        },
        _UpdateFileDetails: function (e) {
            if ($(this._fileURL).hasClass('e-error')) this._fileURL.removeClass("e-error");
            if (e.path === "") this._fileURL.val("http://");
            else this._fileDialog.find('.e-rte-fileUrl').val(e.path + (e.name[0] ? e.name[0] : ""));
        },
        _fileBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_file_cancel") {
                this._clearFileFields();
                this._fileDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_file_insert") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._restoreSelection(this._selectionRange);
                if (this._fileDialog.find('e-rte-fileUrl').val() != "")
                    this._onInsertFileLink();
                else this._linkDialog.ejDialog("close");
                this._trigger("execute", { commandName: "hyperlink" });
                this._onChange();
                this._setBackupData();
            }
        },
        _clearFileFields: function () {
            this._fileURL = this._fileDialog.find(".e-rte-fileUrl");
            this._fileURL.val("http://");
            this._fileLinkText = this._fileDialog.find(".e-rte-fileText");
            this._fileLinkText.val("");
            this._chkFileTarget.ejCheckBox({ check: false });
        },
        _onGetInsertFileContent: function (Url) {
            if (this._fileLinkText.val() === "") this._selectedHTML = Url;
            else this._selectedHTML = this._fileLinkText.val();
        },
        _onInsertFileLink: function () {
            var oEl, sHtml;
            var fileVal = this._fileURL.val().match(/(ftp:|http:|https:)\/\//g);
            var fsrcUrl = (this._fileURL.val().startsWith("~")) ? this._fileURL.val().replace(this._fileURL.val().substr('0', '1'), "..") : this._fileURL.val();
            if ((ej.isNullOrUndefined(fileVal) && fsrcUrl !== "") || (!ej.isNullOrUndefined(fileVal) && fileVal[0].length < fsrcUrl.length)) {
                var selectedNode = ((this._isIE()) && $(this._currentSelNode).parents("body").length > 0) ? this._currentSelNode : this._getSelectedNode();
                if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'A') {
                    selectedNode.href = fsrcUrl;
                    selectedNode.innerHTML = this._fileLinkText.val();
                    (this._chkFileTarget.ejCheckBox("isChecked")) ? selectedNode.target = "_blank" : selectedNode.target = "_self";
                }
                else if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'IMG') {
                    var parentNode = $(selectedNode).parent('a')[0];
                    if (ej.isNullOrUndefined(parentNode)) {
                        oEl = ej.buildTag("a", "", {}, { href: fsrcUrl });
                        $(selectedNode.outerHTML).appendTo($(oEl));
                        $(selectedNode).replaceWith($(oEl));
                        (this._chkFileTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "_self";
                    } else {
                        parentNode.href = fsrcUrl;
                        (this._chkFileTarget.ejCheckBox("isChecked")) ? parentNode.target = "_blank" : parentNode.target = "_self";
                    }
                }
                else {
                    oEl = ej.buildTag("a", "", {}, { href: fsrcUrl });
                    (this._chkFileTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "_self";
                    var oSelection;
                    var oSelRange;
                    this._focus();
                    if (this._isIE()) {
                        if (!ej.isNullOrUndefined(this._selectedHTML)) {
                            if (this._selectedHTML.length == 0)
                                this._onGetInsertFileContent(fsrcUrl);
                        }
                        else
                            this._onGetInsertFileContent(fsrcUrl);
                        oEl[0].innerHTML = this._selectedHTML;
                        sHtml = oEl[0].outerHTML;
                    }
                    else {
                        if (this._fileLinkText.val() === "")
                            oEl.html(fsrcUrl);
                        else oEl.html(this._fileLinkText.val());
                        sHtml = $('<div>').append($(oEl).clone()).html();
                    }
                    if (sHtml && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length))) {
                        this._isIE() ? this._pasteHtml(sHtml) : this._getDocument().execCommand('inserthtml', false, sHtml);
                        this._focus();
                    }
                }
                this._fileDialog.ejDialog("close");
            } else {
                this._fileURL.addClass("e-error");
                return false;
            }
            this.enableToolbarItem("removeLink");
            this._updateCount();
        },
        //Render the Table selection rows and columans popup
        _renderVideoDialog: function () {
            var proxy = this;
            this._videoDialog = ej.buildTag("div#" + this._rteId + "_video");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<div><label>" + this._getLocalizedLabels("embedVideo") + "</label></div><textarea class='e-rte-video e-inputtext'  aria-label=" + this._getLocalizedLabels("embedVideo") + "></textarea>" +
               "<div class='e-rte-videoDimensions'" + this._TagId("_videodimensions") + " style='margin-top:7px'><div class='e-rte-label'><label>" + this._getLocalizedLabels("dimensions") + " </label></div><div><input type='text'  data-role ='none' title='" + this._getLocalizedLabels("dimensions") + "' class='e-inputtext e-dimensions e-rte-videoX' maxlength='3' " + this._TagId("_videoX") + "><label style='padding: 5px;'>X</label><input type='text'  data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "' style='margin-right: 5px;' class='e-inputtext e-dimensions e-rte-videoY' maxlength='3'" + this._TagId("_videoY") + ">" +
               "<input type='checkbox' class='e-rte-videoConsrn' data-role ='none'" + this._TagId("_video_consrn") + "<label " + this._labelFor("_video_consrn") + "style='padding: 5px;'>" + this._getLocalizedLabels("constrainProportions") + "</label></div></div>" +
                "<div class='e-rte-button e-fieldseparate'><button id='video_insert'type='button' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogInsert") + "</button><button id='video_cancel' type='button' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._videoDialog);
            this._videoDialog.appendTo(this._rteWapper);
            !this.model.showDimensions && this._rteWapper.find(".e-rte-videoDimensions").hide();
            var model = this._getDialogModel();
            model.width="auto";
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.title = this._getLocalizedLabels("video");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            this._videoDialog.ejDialog(model);
            this._videoDialog.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && this._videoDialog.find(".e-inputtext").addClass('e-corner-all');
            this._chkvideoDimensions = this._videoDialog.find(".e-rte-videoConsrn");
            this._chkvideoDimensions.ejCheckBox({ checked: true, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._videoDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._videoDialog.find(".e-rte-btn"), "click", this._insertVideo);
            this._on(this._videoDialog.find("input.e-dimensions"), "change", this._recalcVideoSize);
        },


        _renderTableDialog: function () {
            var proxy = this;
            this._createTable = ej.buildTag("div.e-rte-table-picker#" + this._rteId + "_table");
            var tableCell, rowDiv, colDiv, tableDiv;
            this._tblheaderDiv = ej.buildTag("div.e-rte-tableheader");
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
            this._tblheaderDiv.appendTo(this._createTable);
            var tableDiv = ej.buildTag("div.e-rte-table");
            this._drawTable(tableDiv);
            tableDiv.appendTo(this._createTable);
            this._createCustomTable();
            this._createTable.appendTo(this._rteWapper);
            var model = this._getDialogModel();
            model.enableModal = false;
            model.showHeader = false;
            model.width = "auto";
            model.minWidth = "270px";
            model.maxWidth = "270px";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function (args) {
				args.event&& args.event.clickAction && proxy._ieCursorMaintainance();
            };
            this._createTable.ejDialog(model);
        },

        _createCustomTable: function () {
            var customTable = $("<div class='customtable-group e-rte-createCustomTableLink' " + this._TagId("_createCustomTableLink") + "><span class='e-rte-toolbar-icon " + this._rteIconsList["customTableImage"] + "'></span><a class='customtable-link' role='button' title='" + this._getLocalizedLabels("customTable") + "'>" + this._getLocalizedLabels("customTable") + "</a></div>" +
               "<div class='customtable-group e-rte-eTblProperties' " + this._TagId("_eTblProperties") + "><span class='e-rte-toolbar-icon " + this._rteIconsList["customTableImage"] + "'></span><a class='customtable-link' role='button' title='" + this._getLocalizedLabels("editTable") + "'>" + this._getLocalizedLabels("editTable") + "</a></div>");
            this._on(customTable, "click", this._openCustomTable);
            customTable.appendTo(this._createTable);
            if (!this.model.showCustomTable)
                this._createTable.find("#" + this._rteId + "_createCustomTableLink").hide();
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            this._customTableDialog = ej.buildTag("div.e-rte-customtable#" + this._rteId + "_customTable");
            var content = $("<div class='e-fieldgroup'><div class='e-rte-tablefields'><label " + this._labelFor("_txtColumns") + ">" + this._getLocalizedLabels("tableColumns") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='numerictextbox e-rte-txtColumns' " + this._TagId("_txtColumns") + "></div><div class='e-rte-tablefields'>" +
                 "<label " + this._labelFor("_txtRows") + ">" + this._getLocalizedLabels("tableRows") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='numerictextbox e-rte-txtRows' " + this._TagId("_txtRows") + "></div><div class='e-rte-tablefields'>" +
                 "<label " + this._labelFor("_txtWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtWidth'" + this._TagId("_txtWidth") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtHeight'" + this._TagId("_txtHeight") + "></div></div>" +
                 "<div class='e-fieldseparate'><div class='e-rte-tablefields'><label " + this._labelFor("_txtSpacing") + ">" + this._getLocalizedLabels("tableCellSpacing") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtSpacing' " + this._TagId("_txtSpacing") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtPadding") + ">" + this._getLocalizedLabels("tableCellPadding") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtPadding'" + this._TagId("_txtPadding") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtBorder") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-tablefields'><select class='e-rte-txtBorder' data-role ='none' " + this._TagId("_txtBorder") + "><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_chkCaption") + ">" + this._getLocalizedLabels("tableCaption") + "</label></div><div class='e-rte-tablefields'><input type='checkbox' class='e-rte-chkCaption'  data-role ='none'" + this._TagId("_chkCaption") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_ddlAlignment") + ">" + this._getLocalizedLabels("tableAlignment") + "</label></div><div class='e-rte-tablefields'><select class='e-rte-ddlAlignment' data-role ='none' " + this._TagId("_ddlAlignment") + "><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div></div>" +
                 "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._customTableDialog);
			var model = this._getDialogModel();
            model.width = "auto";
			model.maxWidth="480px";
            model.title = this._getLocalizedLabels("customTable");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._customTableDialog.ejDialog(model);
            this._customTableDialog.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && this._customTableDialog.find(".e-inputtext").addClass('e-corner-all');
            this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
            this._customTableDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".numerictextbox").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 1, value: 3, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox({ maxValue: 63, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: false, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._chkTblCaption = this._customTableDialog.find(".e-rte-chkCaption");
            this._chkTblCaption.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._customTableDialog.find(".e-rte-btn"), "click", this._insertCustomTable);
        },
        _renderEditTableDialog: function () {
            var proxy = this;
            this._eTblDialog = ej.buildTag("div.e-rte-edittable#" + this._rteId + "_eTbl");
            var rteID = this._rteId;
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<div id='" + this._rteId + "_eTbl_Tab'><ul><li class='e-first'><a href='#" + this._rteId + "_eTblTable'>" + this._getLocalizedLabels("table") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_eTblRow'>" + this._getLocalizedLabels("row") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_eTblCell'>" + this._getLocalizedLabels("cell") + " </a></li></ul>" +
            "<div id='" + this._rteId + "_eTblTable'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblWidth") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblHeight") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCellSpace") + ">" + this._getLocalizedLabels("tableCellSpacing") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-numerictextbox' " + this._TagId("_eTblCellSpace") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCellPad") + ">" + this._getLocalizedLabels("tableCellPadding") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-numerictextbox' " + this._TagId("_eTblCellPad") + "></div>" +
                   "<div class='e-rte-tablefields'><label  " + this._labelFor("_eTblAlign") + ">" + this._getLocalizedLabels("tableAlignment") + "</label></div><div class='e-rte-tablefields'><select id='" + rteID + "_eTblAlign' data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCaption") + ">" + this._getLocalizedLabels("tableCaption") + "</label></div><div class='e-rte-tablefields'><input type='checkbox' data-role ='none' " + this._TagId("_eTblCaption") + "></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input  data-role ='none' type='text' title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3'  " + this._TagId("_eTblBrdrPx") + "></div><div class='e-img-border-field'><select " + this._TagId("_eTbl_border_style") + " class='e-rte-dropdown' data-role ='none' ><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTbl_border_color") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input  data-role ='none' type='text' class='e-inputtext' " + this._TagId("_eTblStyle") + "></div></div>" +
            "</div>" +
            "<div id='" + rteID + "_eTblRow'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblRHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input  data-role ='none' type='text' class='e-inputtext' " + this._TagId("_eTblRHeight") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblRAlign") + ">" + this._getLocalizedLabels("textAlign") + "</label></div><div class='e-rte-tablefields'><select " + this._TagId("_eTblRAlign") + " data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblRBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3'  " + this._TagId("_eTblRBrdrPx") + "></div><div class='e-img-border-field'><select " + this._TagId("_eTblRBrdrStyle") + " data-role ='none' class='e-rte-dropdown'><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTblRBrdrColor") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblRStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblRStyle") + "></div></div>" +
            "</div>" +
            "<div id='" + rteID + "_eTblCell'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblClWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblClWidth") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblClAlign") + ">" + this._getLocalizedLabels("textAlign") + "</label></div><div class='e-rte-tablefields'><select " + this._TagId("_eTblClAlign") + " data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblClBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3' " + this._TagId("_eTblClBrdrPx") + " ></div><div class='e-img-border-field'><select " + this._TagId("_eTblClBrdrStyle") + " data-role ='none' class='e-rte-dropdown'><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTblClBrdrColor") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblClStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblClStyle") + "></div></div>" +
            "</div>" +
            "</div>" +
            "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='" + rteID + "_eTbl_apply'>" + this._getLocalizedLabels("dialogApply") + "</button><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='" + rteID + "_eTbl_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>"
            );
            content.appendTo(this._eTblDialog);
            this._tblborderPicker = this._eTblDialog.find("#"+this._rteId +"_eTbl_border_color").ejColorPicker({ cssClass: this.model.cssClass, modelType: "palette", buttonText: { apply: this._getLocalizedLabels("buttonApply"), cancel: this._getLocalizedLabels("buttonCancel"), swatches: this._getLocalizedLabels("swatches") } }).data('ejColorPicker');
            this._eTblDialog.appendTo(this._rteWapper);
            var model = this._getDialogModel();
            model.width = "auto";
            model.title = this._getLocalizedLabels("editTable");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            this._eTblDialog.ejDialog(model);
            this._eTblDialog.closest(".e-dialog-wrap").addClass("e-rte e-edittable");
            this.model.showRoundedCorner && this._eTblDialog.find(".e-inputtext").addClass('e-corner-all');
            this._eTblDialog.find(".e-numerictextbox").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 0, value: 0, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblDialog.find(".e-rte-dropdown").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", showRoundedCorner: this.model.showRoundedCorner });
            this._eTblAlign = this._getTableObj("Align").data('ejDropDownList');
            this._eTblAlign.option('enabled', false);
            this._getTableObj("_Tab").ejTab({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblCaption = this._getTableObj("Caption");
            this._eTblCaption.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._eTblDialog.find(".e-rte-btn"), "click", this._eTblBtnClick);
        },

        _drawTable: function (tableDiv) {
            for (var row = 0; row < this.model.tableRows ; row++) {
                rowDiv = ej.buildTag("div.e-rtetablerow");
                for (var col = 0; col < this.model.tableColumns; col++) {
                    tableCell = ej.buildTag("div.e-rte-tablecell e-default");
                    tableCell.appendTo(rowDiv);
                }
                rowDiv.appendTo(tableDiv);
            }
        },


        _renderSourceDialog: function () {
            var proxy = this;
            this._sourceDialog = ej.buildTag("div.e-rte-source#" + this._rteId + "_Source");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<textarea class='e-rte-srctextarea e-inputtext'></textarea><div class='e-rte-button e-fieldseparate'><button id='src_update' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogUpdate") + "</button><button id='src_cancel' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._sourceDialog);
            var model = this._getDialogModel();
            model.title = this._getLocalizedLabels("viewHtml");
            model.width = "auto";
			model.minWidth="330px";
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._sourceDialog.ejDialog(model);
			this._sourceDialog.closest(".e-dialog-wrap").addClass("e-rte e-sourcedialog")
            this.model.showRoundedCorner && this._sourceDialog.find(".e-inputtext").addClass('e-corner-all');
            this._sourceDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._sourceDialog.find(".e-rte-btn"), "click", this._srcBtnClick)
        },


        _renderAlertDialog: function () {
            var proxy = this;
            this._alertWindow = ej.buildTag("div#" + this._rteId + "_Alert");
            var content = $("<p class='e-alerttext' style='margin:0.875em 0em;'></p><div class='e-rte-button e-fieldseparate'><button data-role ='none' class='e-rte-btn e-alert-ok' type='button'>" + this._getLocalizedLabels("dialogOk") + "</button><button class='e-rte-btn e-alert-cancel' data-role='none'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._alertWindow);
            var model = this._getDialogModel();
            model.showHeader = false;
            model.width = "auto";
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            model.minHeight = "50px";
            this._alertWindow.ejDialog(model);
            this._alertWindow.closest(".e-dialog-wrap").addClass("e-rte");
            this._alertWindow.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._alertWindow.find(".e-rte-btn"), "click", this._alertBtnClick)
            this._alertWindow.find(".e-alert-cancel").hide();
        },

        _alertBtnClick: function (e) {
            if ($.trim(this._alertWindow.find(".e-alerttext").html()) == this._getLocalizedLabels("deleteAlert") && $(e.target).hasClass("e-alert-ok")) {
                this._getDocument().body.innerHTML = " ";
				this._emptyContent();
                if (this.model.showToolbar)
                    this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft");
                this._setBackupData();
                this._updateCount();
                var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
                this._updateTagInfo(selectNode);
                this._onChange();
            }
            this._alertWindow.ejDialog("close");
            this._alertWindow.find(".e-alert-cancel").hide();
        },

		_emptyContent: function (){
			var setNode,tempSpanNode = document.createElement("span");
			tempSpanNode.innerHTML = "&#65279;"
			 var range = this._getDocument().createRange(), Selection = this._getDocument().getSelection();
			 this._getDocument().body.firstChild && this._getDocument().body.firstChild.remove();
				this._getDocument().body.appendChild(setNode=this._getDocument().createElement("p"));
				setNode.appendChild(tempSpanNode);
				Selection.removeAllRanges();
                range.setStart(tempSpanNode.firstChild, 0);
                range.setEnd(tempSpanNode.firstChild, 0);
                Selection.addRange(range);
		},
        _openAlert: function (alertText) {
            this._alertWindow.find(".e-alerttext").html(alertText);
            this._alertWindow.ejDialog("instance")._centerPosition();
            $("#" + this._rteId + "_Alert_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._alertWindow.ejDialog("open");
        },


        _renderFormat: function () {
            this._formatDDL = ej.buildTag("input#" + this._rteId + "_formatDDL", "", "", { type: "text", title: this._getLocalizedLabels("format"), "data-role": "none" });
            var defaultText = [
                { text: "paragraph", value: "<p>" },
                { text: "quotation", value: "<blockquote>" },
                { text: "heading1", value: "<h1>" },
                { text: "heading2", value: "<h2>" },
                { text: "heading3", value: "<h3>" },
                { text: "heading4", value: "<h4>" },
                { text: "heading5", value: "<h5>" },
                { text: "heading6", value: "<h6>" }];
            var model = {};
            model.dataSource = this._formatText(this.model.format, defaultText);
            model.width = "105px";
            model.enableRTL = this.model.enableRTL;
            model.popupWidth = "175px";
            model.popupHeight = "auto";
            model.selectedItemIndex = 0;
            model.select = this._formatChange;
            model.cssClass = "e-rte-format-ddl";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value", spriteCssClass: "spriteCssClass" };
            this._formatDDL.appendTo(this._rteToolbar.find("li.e-rteItem-format").html(""));
            this._formatDDL.ejDropDownList(model);
            this._formatPopupStyle();
        },

        _formatText: function (formatSource, formatText) {
            for (var i = 0; i < formatSource.length; i++)
                for (var j = 0; j < formatText.length; j++)
                    if (formatSource[i].value == formatText[j].value) {
                        formatSource[i].text = this._getLocalizedLabels(formatText[j].text) ? this._getLocalizedLabels(formatText[j].text) : formatSource[i].text;
                        break;
                    }
            return formatSource;
        },

        _formatPopupStyle: function () {
            var _liList = this._formatDDL.data("ejDropDownList").popupPanelWrapper.find("li");
            for (var i = 0; i < _liList.length; i++) {
                $(_liList[i]).addClass(this.model.format[i].spriteCssClass);
            }
        },


        _renderFontStyle: function () {
            this._fontStyleDDL = ej.buildTag("input#" + this._rteId + "_fontNameDDL", "", "", { type: "text", title: this._getLocalizedLabels("fontName"), "data-role": "none" });
            var defaultText = [
				{ text: "timesnewroman", value: "Times New Roman,Times,serif" },
			    { text: "segoeui", value: "Segoe UI" },
				{ text: "arial", value: "Arial,Helvetica,sans-serif" },
				{ text: "couriernew", value: "Courier New,Courier,monospace" },
				{ text: "georgia", value: "Georgia,serif" },
				{ text: "impact", value: "Impact,Charcoal,sans-serif" },
                { text: "lucidaconsole", value: "Lucida Console,Monaco,monospace" },
                { text: "tahoma", value: "Tahoma,Geneva,sans-serif" },
                { text: "trebuchetms", value: "Trebuchet MS,Helvetica,sans-serif" },
                { text: "verdana", value: "Verdana,Geneva,sans-serif" }
            ];
            var model = {};
            model.dataSource = this._formatText(this.model.fontName, defaultText);
            model.enableRTL = this.model.enableRTL;
            model.selectedItemIndex = 0;
			model.htmlAttributes={datafontid:""+this._rteId};
            model.select = this._fontStyleChange;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value" };
            this._fontStyleDDL.appendTo(this._rteToolbar.find("li.e-rteItem-fontName").html(""));
            this._fontStyleDDL.ejDropDownList(model);
        },


        _renderFontSize: function () {
            this._fontSizeDDL = ej.buildTag("input#" + this._rteId + "_fontSizeDDL", "", "", { type: "text", title: this._getLocalizedLabels("fontSize"), "data-role": "none" });
            var model = {};
            model.dataSource = this.model.fontSize;
            model.width = "100px";
            model.enableRTL = this.model.enableRTL
            model.selectedItemIndex = 2;
			model.htmlAttributes={datafontid:""+this._rteId};
            model.select = this._fontSizeChange;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value" };
            this._fontSizeDDL.appendTo(this._rteToolbar.find("li.e-rteItem-fontSize").html(""));
            this._fontSizeDDL.ejDropDownList(model);
        },


        _renderFontColor: function () {
            var proxy = this;
            this._fontColorSplit = ej.buildTag("button#" + this._rteId + "_fontColorbtn", "", {}, { type: "button", "data-role": "none" });
            var _liTemplte = $("<ul id='" + this._rteId + "_colorTable' class='e-rte-colorpalette'><li></li></ul>");
            _liTemplte.find("li").append(this._colorTable());
            var model = {};
            model.width = "42px";
            model.contentType = "textandimage";
            model.targetID = this._rteId + "_colorTable";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = this._rteIconsList["fontColor"];
            model.showRoundedCorner = this.model.showRoundedCorner;
            this._fontColorSplit.appendTo(this._rteToolbar.find("li.e-rteItem-fontColor").html(""));
            var oldWrapper = $("#" + this._rteId + "_colorTable").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
			 var FontColors = $("<div class='customcolor e-rte-customcolor' " + this._TagId("_customcolor") + "><a class='customcolor-link' role='button' title='" + this._getLocalizedLabels("customColor") + "'>" + this._getLocalizedLabels("customFontColor") + "</a></div>");
             _liTemplte.append(FontColors);
            _liTemplte.appendTo(this._rteToolbar.find("li.e-rteItem-fontColor"));
			 this._on(FontColors, "click", this._openColorpalette);
            this._fontColorSplit.ejSplitButton(model);
            this._splitObj = this._fontColorSplit.ejSplitButton("instance");
            this._splitObj.option("beforeOpen", function () { proxy._bindClickOperation("FontColor"); });
            this._on(this._fontColorSplit, "click", this._fontColorClick);
            this._fontColorSplit.find("span." + this._rteIconsList["fontColor"]).removeClass("e-icon");
            this._fontColorSplit.find("span.e-btntxt").css("background-color", this._fontColor);
        },
        _renderUnOrderList: function () {
            var proxy = this;
            this._unOrderSplit = ej.buildTag("button#" + this._rteId + "_unorder", "", {}, { type: "button", "data-role": "none" });
            this._unorderLiTemplate = ej.buildTag("ul#" + this._rteId + "_unorderlist", "", { "height": "auto", "width": "84px" }, { "class": "e-rte-unorderlistname" });
            $("<li id='none' title='" + this._getLocalizedLabels("none") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-nonelist-icon'></span></li><li id='disc' title='" + this._getLocalizedLabels("disc") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-disclist-icon'></span></li><li id='square' title='" + this._getLocalizedLabels("square") + "' class='square' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-squarelist-icon'></span></li><li id='circle' title='" + this._getLocalizedLabels("circle") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-circlelist-icon'></span></li>").appendTo(this._unorderLiTemplate);
            if (!ej.isNullOrUndefined(proxy.model.tools["customUnorderedList"]))
                $.each(proxy.model.tools["customUnorderedList"], function (i, val) {
                    if (i == 0) $(proxy._unorderLiTemplate).find("#circle,#square").attr("class", "e-liseparator");
                    $("<li id='" + (val["name"] ? val["name"] : ("ulcustom" + i)) + "' class='" + (val["css"] ? val["css"] : "") + "' title='" + (val["tooltip"] ? val["tooltip"] : "") + "' style='float:left;width:100%;'>" + (val["text"] ? val["text"] : "") + "</li>").appendTo(proxy._unorderLiTemplate);
                });
            var model = {};
            model.width = "42px";
            model.contentType = "imageonly";
            model.targetID = this._rteId + "_unorderlist";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = "e-icon e-rte-toolbar-icon " + this._rteIconsList["unorderedList"];
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.itemSelected = $.proxy(this._onUnorderList, this);
            this._unOrderSplit.appendTo(this._rteToolbar.find("li.e-rteItem-unorderedList").html(""));
            var oldWrapper = $("#" + this._rteId + "_unorderlist").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._unorderLiTemplate.appendTo((this._rteToolbar.parents("body").length > 0 ? this._rteToolbar.find("li.e-rteItem-unorderedList") : $('body')));
            this._unOrderSplit.ejSplitButton(model);
            this._unOrderSplitObj = this._unOrderSplit.ejSplitButton("instance");
            this._unOrderSplit.find("span.e-unorderedList-icon").removeClass("e-icon");
            this._on(this._unOrderSplit, "click", this._onUnorderList);
        },
        _renderOrderList: function () {
            var proxy = this;
            this._orderSplit = ej.buildTag("button#" + this._rteId + "_order", "", {}, { type: "button", "data-role": "none" });
            this._orderLiTemplate = ej.buildTag("ul#" + this._rteId + "_orderlist", "", { "height": "auto", "width": "124.05px" }, { "class": "e-rte-orderlistname" });
            $("<li id='none' title='" + this._getLocalizedLabels("none") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-nonelist-icon'></span></li><li id='decimal' title='" + this._getLocalizedLabels("number") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-numbering-icon'></span></li><li id='lower-alpha' title='" + this._getLocalizedLabels("loweralpha") + "'  style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-loweralpha-icon'></span></li><li id='lower-roman' title='" + this._getLocalizedLabels("lowerroman") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-lowerroman-icon'></span></li><li id='upper-alpha' title='" + this._getLocalizedLabels("upperalpha") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-upperalpha-icon'></span></li><li id='upper-roman' title='" + this._getLocalizedLabels("upperroman") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-upperroman-icon'></span></li>").appendTo(this._orderLiTemplate);
            if (!ej.isNullOrUndefined(proxy.model.tools["customOrderedList"]))
                $.each(proxy.model.tools["customOrderedList"], function (i, val) {
                    if (i == 0) $(proxy._orderLiTemplate).find("#upper-roman,#upper-alpha,#lower-roman").attr("class", "e-liseparator");
                    $("<li id='" + (val["name"] ? val["name"] : ("olcustom" + i)) + "' class='" + (val["css"] ? val["css"] : "") + "' title='" + (val["tooltip"] ? val["tooltip"] : "") + "' style='float:left;width:100%;'>" + (val["text"] ? val["text"] : "") + "</li>").appendTo(proxy._orderLiTemplate);
                });
            var model = {};
            model.width = "42px";
            model.contentType = "imageonly";
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._rteId + "_orderlist";
            model.prefixIcon = "e-icon e-rte-toolbar-icon " + this._rteIconsList["orderedList"];
            model.itemSelected = $.proxy(this._onOrderList, this);
            this._orderSplit.appendTo(this._rteToolbar.find("li.e-rteItem-orderedList").html(""));
            var oldWrapper = $("#" + this._rteId + "_orderlist").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._orderLiTemplate.appendTo((this._rteToolbar.parents("body").length > 0 ? this._rteToolbar.find("li.e-rteItem-orderedList") : $('body')));
            this._orderSplit.ejSplitButton(model);
            this._orderSplitObj = this._orderSplit.ejSplitButton("instance");
            this._on(this._orderSplit, "click", this._onOrderList);
        },
        _renderBGColor: function () {
            var proxy = this;
            this._bgColorSplit = ej.buildTag("button#" + this._rteId + "_backgroundColorbtn", "", {}, { type: "button", "data-role": "none" });
            var _liTemplte = $("<ul id='" + this._rteId + "_colorBGTable' class='e-rte-colorpalette'><li></li></ul>");
            _liTemplte.find("li").append(this._colorTable());
			var _bgTransparent=$("<button id='"+this._rteId+"_backgroundtransparentbtn'class='e-rte-transbtn' role='button' title='"+this._getLocalizedLabels("TransBGColor")+"'>"+this._getLocalizedLabels("TransBGColor") + "</button>");
			var model = {};
            model.width = "42px";
            model.contentType = "textandimage";
            model.targetID = this._rteId + "_colorBGTable";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = this._rteIconsList["backgroundColor"];
            model.showRoundedCorner = this.model.showRoundedCorner;
			var BGColors = $("<div class='customBGcolor e-rte-customcolor' " + this._TagId("_customBGcolor") + "><a class='customcolor-link ' role='button' title='" + this._getLocalizedLabels("customBGColor") + "'>" + this._getLocalizedLabels("customBGColor") + "</a></div>");
             _liTemplte.append(BGColors);
			 this._on(BGColors, "click", this._openColorpalette);
			_bgTransparent.prependTo(_liTemplte);
			this._bgColorSplit.appendTo(this._rteToolbar.find("li.e-rteItem-backgroundColor").html(""));
            var oldWrapper = $("#" + this._rteId + "_colorBGTable").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            _liTemplte.appendTo(this._rteToolbar.find("li.e-rteItem-backgroundColor"));
            this._bgColorSplit.ejSplitButton(model);
			_bgTransparent.ejButton({width:"100%",contentType:"text",targetID:this._rteId+"_colorBGTable",showRoundercorner:this.model.showRounderCorner});
			this._bgObj=_bgTransparent.ejButton("instance");
			 this._on(_bgTransparent, "click", this._bgTransClick);
            this._bgSplitObj = this._bgColorSplit.ejSplitButton("instance");
            this._bgSplitObj.option("beforeOpen", function () { proxy._bindClickOperation("BGColor"); });
            this._on(this._bgColorSplit, "click", this._bgColorClick);
            this._bgColorSplit.find("span." + this._rteIconsList["backgroundColor"]).removeClass("e-icon");
            this._bgColorSplit.find("span.e-btntxt").css("background-color", this._bgColor);
        },
        _bindClickOperation: function (toolName) {
            var proxy = this;
            var splitObj = toolName == "BGColor" ? proxy._bgSplitObj : proxy._splitObj;
            var element = toolName == "BGColor" ? "_backgroundColorbtn" : "_fontColorbtn";
			var tblelement=toolName == "BGColor" ? "_colorBGTable" : "_colorTable";
            SplitMenu = $("#" + proxy._rteId + element).ejSplitButton("instance");
            toolName == "BGColor" ? proxy._bgSplitMenu = SplitMenu : proxy._splitMenu = SplitMenu;
            SplitMenu.model.close = function () {
                splitObj.contstatus = false;
                proxy._off($("#" + proxy._rteId + tblelement).find("div.e-rte-palettetable"), "click", toolName == "BGColor" ? proxy._bgColorPaletteClick : proxy._colorPaletteClick);
            }
            proxy._on($("#" + proxy._rteId + tblelement).find("div.e-rte-palettetable"), "click", toolName == "BGColor" ? proxy._bgColorPaletteClick : proxy._colorPaletteClick);
        },
        _colorTable: function () {
            var tableDiv = ej.buildTag("div.e-rte-table");
            var color = 0, hexCode, rowDiv;
            for (var row = 0; row < this.model.colorPaletteRows ; row++) {
                rowDiv = ej.buildTag("div.e-rtetablerow");
                for (var col = 0; col < this.model.colorPaletteColumns ; col++) {
                    if (color < this.model.colorCode.length) {
                        hexCode = "#" + this.model.colorCode[color];
                        tableCell = ej.buildTag("div.e-rte-palettetable", "", { "background-color": hexCode }, { title: hexCode, "color-code": hexCode });
                        tableCell.appendTo(rowDiv);
                        color++;
                    }
                }
                rowDiv.appendTo(tableDiv);
            }
            return tableDiv;
        },

        _recalcVideoSize: function (e) {
            var txtWidth, txtheight, newWidth, newHeight;
            txtWidth = this._videoDialog.find(".e-rte-videoX");
            txtheight = this._videoDialog.find(".e-rte-videoY");

            newWidth = txtWidth.val();
            newHeight = txtheight.val();
            if (this._chkvideoDimensions.ejCheckBox("isChecked") && !!this._videoWidth && !!this._videoHeight && !!newWidth && !!newHeight) {
                if (e.target.id == txtWidth[0].id) {
                    newHeight = Math.round((newWidth / this._videoWidth) * newHeight);
                    txtheight.val(newHeight);
                } else {
                    newWidth = Math.round((newHeight / this._videoHeight) * newWidth);
                    txtWidth.val(newWidth);
                }
            }
            this._videoWidth = newWidth;
            this._videoHeight = newHeight;
        },


        _recalcImgSize: function (e) {
            var txtWidth, txtheight, newWidth, newHeight;
            txtWidth = this._imgDialog.find(".e-rte-imgX");
            txtheight = this._imgDialog.find(".e-rte-imgY");

            newWidth = txtWidth.val();
            newHeight = txtheight.val();

            if (this._chkImgDimensions.ejCheckBox("isChecked") && !!this._imgWidth && !!this._imgHeight && !!newWidth && !!newHeight) {
                if (e.target.id == txtWidth[0].id) {
                    newHeight = Math.round((newWidth / this._imgWidth) * newHeight);
                    txtheight.val(newHeight);
                } else {
                    newWidth = Math.round((newHeight / this._imgHeight) * newWidth);
                    txtWidth.val(newWidth);
                }
            }
            this._imgWidth = newWidth;
            this._imgHeight = newHeight;
        },

        _urlValidation: function (e) {
            var _target = $(e.target);
            _target.hasClass("e-error") && _target.removeClass("e-error");
        },
        _ieLinkRange: function () {
            var rang = this._getRange();
            if (!this._isIE() && !this._isIE8()) {
                !ej.isNullOrUndefined(this._currentSelNode) && this._currentSelNode.nodeName.toLowerCase() != "html"
                this._selectionRange = rang;
            }
            else {
                !ej.isNullOrUndefined(this._currentSelNode) && this._currentSelNode.nodeName.toLowerCase() != "html" && rang.setStart(this._currentSelNode, this._currentSelNode.childNodes.length)
                this._selectionRange = rang;
            }
        },
        _ieCursorMaintainance: function () {
            if (!this._isIE8()) {
                this._ieLinkRange();
                this._focus();
            }
            else
                this._setRange(this._currentSelNode, this._getDocument().body.createTextRange(), true);
        },
        _linkBtnClick: function (sender) {
            if (sender.target.id === "link_cancel") {
                this._clearLinkFields();
                this._linkDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === "link_insert") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._restoreSelection(this._selectionRange);
                if (this._txtURL.val() != "")
                    this._onInsertLink();
                else {
                    this._onUnlink();
                    this._linkDialog.ejDialog("close");
                }
                this._trigger("execute", { commandName: "hyperlink" });
                this._onChange();
                this._setBackupData();
            }
        },

        _imageBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_img_cancel") {
                this._imgDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_img_insert") {
                var imageVal = this._imgURL.val().match(/(ftp:|http:|https:)\/\//g);
                if ((ej.isNullOrUndefined(imageVal) && this._imgURL.val() !== "") || (!ej.isNullOrUndefined(imageVal) && imageVal[0].length < this._imgURL.val().length)) {
                    (this.model.maxLength != null && this.model.maxLength > $.trim(this._getText()).length) ? this._onInsertImage() : this._imgDialog.ejDialog("close");
                    this._onChange();
                    this._setBackupData();
                } else {
                    this._imgURL.addClass("e-error");
                    if (!this._isUrl($.trim(this._imageLink.val()))) this._imageLink.addClass("e-error");
                    return false;
                }
            }
        },


        _srcBtnClick: function (sender) {
            if (sender.target.id === "src_update") {
                var _editHTML = $.trim(this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value);
                if (this.model.enableHtmlEncode)
                    _editHTML = this._decode(_editHTML);
                try {
                    this._getDocument().documentElement.innerHTML = _editHTML.replace("<html>", "").replace("</html>", "");
                    if (this.model.enableXHTML)
                        this._getDocument().documentElement.innerHTML = this._updateXhtml();
                }
                catch (e) {
                    var regEX = /<body[^>]*>((.|[\n\r])*)<\/body>/i;
                    if (!ej.isNullOrUndefined(regEX.exec(_editHTML))) {
                        _editHTML = regEX.exec(_editHTML)[1];
                        this._getDocument().body.innerHTML = _editHTML;
                    }
                }
                this._onChange();
                this._updateCount();
            }
            this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value = "";
            var _tableEle = $(this._getDocument()).find("table.e-rte-table");
            if (!this.model.enableRTL) this._on(_tableEle, "mouseover", this._tableMouseOver);
            this._sourceDialog.ejDialog("close");
            this._showHideContextMenu();
        },

        _eTblBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_eTbl_cancel") {
                this._eTblDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_eTbl_apply") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._oneditTable();
                this._onChange();
                this._setBackupData();
            }
        },

        _insertCustomTable: function (sender) {
            this._customTableValidation = false;
            if (sender.target.id === "insert") {
                var cols = this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("getValue");
                var row = this._customTableDialog.find(".e-rte-txtRows").ejNumericTextbox("getValue");
                var height = this._customInputValidation(this._customTableDialog.find(".e-rte-txtHeight"));
                var width = this._customInputValidation(this._customTableDialog.find(".e-rte-txtWidth"));
                var align = this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("getSelectedValue");
                var spacing = this._customInputValidation(this._customTableDialog.find(".e-rte-txtSpacing"));
                var padding = this._customInputValidation(this._customTableDialog.find(".e-rte-txtPadding"));
                var border = this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("getSelectedValue");
                var caption = this._chkTblCaption.ejCheckBox("isChecked");
                if (!this._customTableValidation) {
                    if (!ej.isNullOrUndefined(this._tableInsertAt) && !ej.isNullOrUndefined(this._tableInsertAt.startContainer))
                        this._restoreSelection(this._tableInsertAt);
                    var tableEle = this._tableGenerator(row, cols, false, width, height, spacing, padding, align, border, caption);
                    this.executeCommand('inserthtml', tableEle);
                    var _tableEle = $(this._getDocument()).find("table.e-rte-table");
                    var drpDwnObj = this._customTableDialog.find(".e-rte-ddlAlignment").data("ejDropDownList");
                    if (drpDwnObj.option('value') == "Center")
                        _tableEle.attr('style', "margin: 0 auto");
                    if (!this.model.enableRTL) this._on(_tableEle, "mouseover", this._tableMouseOver);
                    this._onChange();
                    drpDwnObj.option({ value: "", enabled: false });
                }
                this._on(this._customTableDialog.find(".e-rte-txtHeight"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtWidth"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtSpacing"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtPadding"), "keypress", this._urlValidation);

            }
            if (!this._customTableValidation) {
                this._customTableDialog.ejDialog("close");
                this._clearTableFields();
                this._ieCursorMaintainance();
            }
        },

        _customInputValidation: function (validation) {
            var value = validation.val().toLowerCase();
            var lastPos = value.substr(value.length - 2, 2);
            var specChar = value.match(/[!@#$%^&*()_+\-=\[\]{};':"\\|,<>\/?]/gi);
            var alphaChar = value.match(/[a-z]/gi);
            if (((!isNaN(value) && (specChar == null || specChar.length == 0)) || (value.length > 1 && value.substr(value.length - 1, 1) == "%" && specChar.length == 1) && (alphaChar == null || alphaChar.length == 0)) || (value.length > 2 && (specChar == null || specChar.length == 0) && (alphaChar != null && alphaChar.length == 2) && (lastPos == "px" || lastPos == "in" || lastPos == "cm" || lastPos == "mm" || lastPos == "em" || lastPos == "ex" || lastPos == "pt" || lastPos == "pc")))
                return value;
            else {
                validation.addClass("e-error");
                this._customTableValidation = true;
                return 0;
            }
        },

        _clearTableFields: function () {
            this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("option", "value", 3);
            this._customTableDialog.find(".e-rte-txtRows").ejNumericTextbox("option", "value", 3);
            this._customTableDialog.find(".e-rte-txtHeight").val("");
            this._customTableDialog.find(".e-rte-txtWidth").val("");
            this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("clearText");
            this._customTableDialog.find(".e-rte-txtSpacing").val("");
            this._customTableDialog.find(".e-rte-txtPadding").val("");
            var border = this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("clearText");
            var caption = this._chkTblCaption.ejCheckBox({ check: false });
        },

        _clearEditTableFields: function () {
            this._eTblHeight = this._eTblDialog.find("input").val("");
            this._eTblDialog.find(".e-numerictextbox").data("ejNumericTextbox").option("value", "");
            this._eTblDialog.find(".e-rte-dropdown").data("ejDropDownList").option("value", "");
            this._eTblAlign.disable();
            this._eTblCaption.ejCheckBox({ check: false });
        },

        _clearLinkFields: function () {
            this._txtURL = this._linkDialog.find(".e-rte-linkUrl");
            this._txtURL.removeClass("e-error");
            this._txtURL.val("http://");
            this._txtLinkText = this._linkDialog.find(".e-rte-linkText");
            this._txtLinkText.val("");
            this._txtLinkTitle = this._linkDialog.find(".e-rte-linkTitle");
            this._txtLinkTitle.val("");
            this._chkTarget.ejCheckBox({ check: false });
            this._txtURL.focus();
        },
        _textFieldFocus: function (ele, start, end) {
            if (!this._isIE8()) ele.setSelectionRange(start, end);
            else {
                var range = ele.createTextRange();
                range.collapse(true);
                range.moveEnd('character', start);
                range.moveStart('character', end);
                range.select();
            }
        },
        _clearImgFields: function () {
            this._imgURL = this._imgDialog.find(".e-rte-imgUrl").val("http://").removeClass("e-error");
            this._imgDialog.find(".e-rte-imgText").val("");
            this._chkImgDimensions.ejCheckBox({ checked: true });
            this._imageLink = this._imgDialog.find(".e-rte-imgLink");
            this._imageLink.removeClass("e-error");
            this._imageLink.val("");
            this._imageBorderPx = this._imgDialog.find(".e-rte-imgBorderPx").data('ejNumericTextbox');
            this._imageBorderPx.option('value', 0);
            this._imageBorderStyle = this._imgDialog.find(".e-rte-imgBorderStyle").data('ejDropDownList');
            this._imageBorderStyle.option('value', "");
            this._imgPicker.option('value', null);
            this._imgDialog.find('.e-selected-color').removeAttr('style');
            this._imageStyle = this._imgDialog.find(".e-rte-imgStyle");
            this._imageStyle.val("");
            this._dialogchkTarget.ejCheckBox({ check: false });
        },

        _videoManager: function () {
            var selectNode = this._getSelectedNode();
            this._editVideo = null;
            this._getPasteRangeVal();
            if (selectNode && !ej.isNullOrUndefined(selectNode.tagName)) {
                this._editVideo = selectNode;
                this._videoWidth = parseInt($(selectNode).width());
                this._videoHeight = parseInt($(selectNode).width());
                if (this.model.showDimensions) {
                    this._videoDialog.find(".e-rte-videoX").val(this._videoWidth);
                    this._videoDialog.find(".e-rte-videoY").val(this._videoHeight);
                }
            }
            $("#" + this._rteId + "_video_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._videoDialog.ejDialog("open");
            this._videoDialog.find("textarea.e-rte-video").focus();
        },

        _sourceCodeManager: function () {
            ej.isNullOrUndefined(this._sourceDialog) && this._renderSourceDialog();
            this._updateTagInfo("body");
            this._hideTooltip();
            if (!ej.isNullOrUndefined(this._getDocument().documentElement)) {
                this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value = (this.model.enableHtmlEncode) ? this._encode(this._getDocument().documentElement.outerHTML) : this._getDocument().documentElement.outerHTML;
                $("#" + this._rteId + "_Source_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._sourceDialog.ejDialog("open");
                this._sourceDialog.find("textarea.e-rte-srctextarea").focus();
            }
            else
                this._htmlSource.addClass("e-disable");
        },
        _getPasteRangeVal: function () {
            if (this._isIE()) {
                this._pasteRangeVal = this._getRange();
                this._pasteFlag = true;
            }
        },
        _hyperLinkManager: function (filebrowser) {
            this._getPasteRangeVal();
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();

            this._selectedHTML = (ej.browserInfo().name === "msie" && ej.browserInfo().version === "11.0") ? this._pasteRangeVal.toString() : this._getSelText();
            if (filebrowser) {
                this._clearFileFields();
                (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toUpperCase() == 'A') ? this._fileLinkText.val($(selectNode).html()) : this._fileLinkText.val(this._selectedHTML);
                $("#" + this._rteId + "_fileDialog_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._fileDialog.ejDialog("open");
            }
            else {
                this._clearLinkFields();
                (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toUpperCase() == 'A') ? this._txtLinkText.val($(selectNode).html()) : this._txtLinkText.val(this._selectedHTML);
                $("#" + this._rteId + "_link_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._linkDialog.ejDialog("open");
                this._textFieldFocus(this._txtURL[0], this._txtURL.val().length, this._txtURL.val().length);
            }

            if (selectNode && !(/^(A)$/).test(selectNode.nodeName)) {
                if (selectNode.tagName.toUpperCase() == "IMG")
                    selectNode = $(selectNode).parent('a')[0];
            }
            if (filebrowser) {
                if (selectNode && (/^(A)$/).test(selectNode.nodeName)) this._fileURL.val(selectNode.href);
            }
            else if (selectNode && (/^(A)$/).test(selectNode.nodeName)) {
                this._txtURL.val(selectNode.href);
                this._txtLinkTitle.val(selectNode.title);
            }
        },
        _tableManager: function () {
            var tableLi = this._rteToolbar.find("li.e-rteItem-createTable"), Xpos, Ypos;
            this._getPasteRangeVal();
            if (this._getSelectedNode().nodeName.toLowerCase() == "td")
                this._createTable.find("div.e-rte-eTblProperties").removeClass('e-disable');
            if (this.model.isResponsive && tableLi.length == 0) {
                var border = $(this._toolBarObj._liTemplte).outerHeight() - $(this._toolBarObj._liTemplte).height();
                tableLi = this._toolBarObj._liTemplte.find("li.e-rteItem-createTable");
                $("#" + this._rteId + "_table_wrapper").css({ "visibility": "hidden", "display": "block" });
                Ypos = ($(this._toolBarObj._liTemplte).offset().top + $(this._toolBarObj._liTemplte).outerHeight() + border - $("#" + this._rteId + "_table_wrapper").offsetParent().offset().top);
                if($(tableLi).offset().left>230)
                   Xpos = ($(tableLi).offset().left - $("#" + this._rteId + "_table_wrapper").offsetParent().offset().left);
				else
				   Xpos =$("#" + this._rteId + "_table_wrapper").offsetParent().offset().left;
                $("#" + this._rteId + "_table_wrapper").css({ "visibility": "visible" });
            }
            else
                Xpos = $(tableLi).position().left, Ypos = $(tableLi).position().top + tableLi.height() + 7;
            if (((parseInt(Xpos) + parseInt($("#" + this._id + "_table_wrapper").css("width"))) > document.body.clientWidth) || ((parseInt(Xpos) + parseInt($("#" + this._id + "_table_wrapper").css("width"))) > parseInt($("#" + this._id + "_wrapper").css("width")) + $("#" + this._id + "_wrapper").position().left)) Xpos = (parseInt(Xpos) - (parseInt($("#" + this._id + "_table_wrapper").css("width")) - $(tableLi).width())) + "px";
            var top = (document.documentElement && document.documentElement.scrollTop) || document.body.scrollTop;
            if (top < Ypos && $(window).height() < (Ypos - top + parseInt($("#" + this._id + "_table_wrapper").css("height"))))
                Ypos = (parseInt($("#" + this._id + "_table_wrapper").css("height")) > $(window).height()) ? top : ($(window).height() - parseInt($("#" + this._id + "_table_wrapper").css("height"))) > 0 ? ($(window).height() - parseInt($("#" + this._id + "_table_wrapper").css("height")) + top) : top;
            var parentOffset=this._rteWapper.offset();
		    Xpos=parseInt(Xpos)-parseInt(parentOffset["left"]);
			Ypos=parseInt(Ypos)-parseInt(parentOffset["top"]);
			this._createTable.ejDialog("option", "position", { X: Xpos, Y: Ypos });
            this._createTable.ejDialog("open");
            this._on(ej.getScrollableParents(this._createTable), "scroll", function () {
                this._createTable.ejDialog("close");
            });
        },
        _eTblManager: function () {
            this._clearEditTableFields();
            var rteID = this._rteId;
            var isTable = $(this._getSelectedNode()).closest("td");
            var selectNode = (isTable.length > 0) ? isTable[0] : this._currentSelNode;
            if (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toLowerCase() === "td") {
                var parentTable = $(selectNode).closest('tbody').closest('table');
                this._getTableObj("Height").val($(parentTable).height());
                this._getTableObj("Width").val($(parentTable).width());
                if (!ej.isNullOrUndefined(parentTable[0])) {
                    this._getTableObj("CellSpace").data('ejNumericTextbox').option('value', parentTable[0].cellSpacing);
                    this._getTableObj("CellPad").data('ejNumericTextbox').option('value', parentTable[0].cellPadding);
                    var align = parentTable[0].align;
                }
                if (!ej.isNullOrUndefined(align) && align != "") {
                    this._eTblAlign.enable();
                    this._eTblAlign.option('value', align);
                }
                var captionEle = $($(selectNode).closest('tbody')).prev('caption');
                if (captionEle.length > 0)
                    this._eTblCaption.ejCheckBox({ checked: true });
                if (!ej.isNullOrUndefined(parentTable[0]) && parentTable[0].style != "") {
                    this._getTableObj("BrdrPx").data('ejNumericTextbox').option('value', parentTable[0].style.borderWidth.split('px')[0]);
                    var obj = this._getTableObj("_border_style").data('ejDropDownList');
                    (parentTable[0].style.borderStyle != "") ? obj.selectItemByValue(parentTable[0].style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("_border_color").val(parentTable[0].style.borderColor);
                }
                this._getTableObj("Style").val(parentTable.attr('style'));


                var parentRow = $(selectNode).closest('tr');
                this._getTableObj("RHeight").val($(parentRow).height());
                this._getTableObj("RAlign").data('ejDropDownList').option('value', parentRow[0].style.textAlign);
                if (parentRow[0].style != "") {
                    this._getTableObj("RBrdrPx").data('ejNumericTextbox').option('value', parentRow[0].style.borderWidth.split('px')[0]);
                    var obj = this._getTableObj("RBrdrStyle").data('ejDropDownList');
                    (parentRow[0].style.borderStyle != "") ? obj.selectItemByValue(parentRow[0].style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("RBrdrColor").val(parentRow[0].style.borderColor);
                }
                this._getTableObj("RStyle").val(parentRow.attr('style'));
                this._getTableObj("ClWidth").val($(selectNode).width());
                this._getTableObj("ClAlign").data('ejDropDownList').option('value', selectNode.style.textAlign);
                if (selectNode.style != "") {
                    this._getTableObj("ClBrdrPx").data('ejNumericTextbox').option('value', selectNode.style.borderLeftWidth.split('px')[0]);
                    var obj = this._getTableObj("ClBrdrStyle").data('ejDropDownList');
                    (selectNode.style.borderStyle != "") ? obj.selectItemByValue(selectNode.style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("ClBrdrColor").val(selectNode.style.borderColor);
                }
                this._getTableObj("ClStyle").val($(selectNode).attr('style'));
            }
        },

        _getTableObj: function (value) {
            return this._eTblDialog.find('#' + this._rteId + "_eTbl" + value);
        },

        _imageManager: function () {
            this._clearImgFields();
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            this._getPasteRangeVal();
            if (selectNode && !ej.isNullOrUndefined(selectNode)) {
                this._imgWidth = parseInt($(selectNode).width());
                this._imgHeight = parseInt($(selectNode).height());
                if (this.model.showDimensions) {
                    this._imgDialog.find(".e-rte-imgX").val(this._imgWidth);
                    this._imgDialog.find(".e-rte-imgY").val(this._imgHeight);
                }
                var linkNode = $(selectNode).parent('a');
                if (linkNode.length > 0)
                    this._imageLink.val(linkNode.attr('href'));
                if (selectNode.tagName.toLowerCase() === "img") {
                    this._imgDialog.find(".e-rte-imgUrl").val(selectNode.src);
                    this._imgDialog.find(".e-rte-imgText").val(selectNode.alt);
                    if (selectNode.style != "") {
                        this._imageBorderPx.option('value', selectNode.style.borderWidth.split('px')[0]);
                        this._imageBorderStyle.option('value', selectNode.style.borderStyle);
                        if (selectNode.style.borderColor.length > 0) {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") this._imgPicker.option('value', selectNode.style.borderColor);
                            else {
                                var colorCode = selectNode.style.borderColor.split("(")[1].split(")")[0];
                                colorCode = colorCode.split(",");
                                colorCode = { r: $.trim(colorCode[0]), g: $.trim(colorCode[1]), b: $.trim(colorCode[2]) };
                                this._imgPicker.option('value', this._imgPicker.RGBToHEX(colorCode));
                            }
                        }
                    }
                    this._imageStyle.val($(selectNode).attr('style'));
                }
            }
            $("#" + this._rteId + "_Image_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._imgDialog.ejDialog("open");
            this._textFieldFocus(this._imgURL[0], this._imgURL.val().length, this._imgURL.val().length);
            if (ej.isNullOrUndefined(this._explorerObj)) this._imgDialog.find(".e-rte-imgUrl").focus();
        },
        _getValidbrowser: function (name) {
            switch (name) {
                case "chrome":
                    return ej.browserInfo().version < 42
                    break;
                case "mozilla":
                    return ej.browserInfo().version < 41
                    break;
                case "opera":
                    return ej.browserInfo().version < 29
                    break;
                default:
                    return true;
                    break;
            }
        },
        _alertHeader: function (rteInstcne) {
            rteInstcne._alertWindow.ejDialog("option", "showHeader", false);
            this.model.enableRTL && !this._alertWindow.find(".e-alert-ok").hasClass("e-rte-alertBtnRTL") && this._alertWindow.find(".e-alert-ok").addClass("e-rte-alertBtnRTL");
            rteInstcne._alertWindow.find(".e-rte-button").css({ "text-align": "", "padding-bottom": "", "padding-top": "" }).addClass("e-fieldseparate");
            rteInstcne._alertWindow.ejDialog("instance").refresh();
        },
        _toolBarClick: function (sender) {
            if (sender.event && ((sender.event.which && sender.event.which == 3) || (sender.event.button && sender.event.button == 2)))
                return;
            var $rteEle = $(this.itemsContainer).closest("div.e-rte").find("textarea.e-rte"), rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
            var _itemId = ej.isNullOrUndefined(rteId) ? sender.currentTarget.id.replace("_", "") : sender.currentTarget.id.replace(rteId + "_", "");
            rteInstcne._alertHeader(rteInstcne);
            if (ej.browserInfo().name === "mozilla") rteInstcne._getDocument().designMode = "off";
            if ($(sender.currentTarget).hasClass("e-rteItem-copy") && !rteInstcne._isIE() && rteInstcne._getValidbrowser(ej.browserInfo().name))
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("copyAlert"));
            else if ($(sender.currentTarget).hasClass("e-rteItem-cut") && !rteInstcne._isIE() && rteInstcne._getValidbrowser(ej.browserInfo().name))
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("cutAlert"));
            else if ($(sender.currentTarget).hasClass("e-rteItem-paste") && !rteInstcne._isIE())
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("pasteAlert"));
            else {
                if (ej.browserInfo().name != "chrome") {
                    var index = rteInstcne._scriptsItems.indexOf(_itemId);
                    if (rteInstcne._scriptsItems.indexOf(_itemId) >= 0 && $("#" + rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]).hasClass("e-active"))
                        rteInstcne._selectCommand(rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]);
                }
                var commandName = $.grep(sender.currentTarget.children[0].className.split(/\s+/), function (a) {
                    return !/^e-(rteItem|rte-toolbar-icon)$/i.test(a)
                });
                if (commandName.indexOf("e-split") >= 0 || commandName.indexOf("e-ddl") >= 0)
                    commandName[0] = _itemId;
                rteInstcne._selectCommand(commandName[0]);
            }

            if (rteInstcne._styleItems.indexOf(_itemId) >= 0 || rteInstcne._scriptsItems.indexOf(_itemId) >= 0) {
                if (!$(sender.currentTarget).hasClass("e-isactive"))
                    this.selectItemByID(sender.currentTarget.id);
                else
                    this.deselectItemByID(sender.currentTarget.id);
                $(sender.currentTarget).hasClass("e-isactive") ? $(sender.currentTarget).removeClass("e-isactive") : $(sender.currentTarget).addClass("e-isactive");
                if (rteInstcne._scriptsItems.indexOf(_itemId) >= 0) {
                    var index = rteInstcne._scriptsItems.indexOf(_itemId);
                    $("#" + rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]).removeClass("e-isactive");
                    this.deselectItemByID(rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]);
                }
            }


            else if (rteInstcne._alignItems.indexOf(_itemId) >= 0) {
                this.selectItemByID(sender.currentTarget.id);
                var index = rteInstcne._alignItems.indexOf(_itemId)
                for (var i = 0; i < rteInstcne._alignItems.length; i++) {
                    if (i != index)
                        this.deselectItemByID(rteId + "_" + rteInstcne._alignItems[i]);
                }
            }

            else if (rteInstcne._listItems.indexOf(_itemId) >= 0) {
                if (!$(sender.currentTarget).hasClass("e-isactive"))
                    this.selectItemByID(sender.currentTarget.id);
                else
                    this.deselectItemByID(sender.currentTarget.id);
                $(sender.currentTarget).hasClass("e-isactive") ? $(sender.currentTarget).removeClass("e-isactive") : $(sender.currentTarget).addClass("e-isactive");
                var index = rteInstcne._listItems.indexOf(_itemId);
                $("#" + rteId + "_" + rteInstcne._listItems[index == 0 ? 1 : 0]).removeClass("e-isactive");
                if (index == 0)
                    this.deselectItemByID(rteId + "_" + rteInstcne._listItems[1]);
                else
                    this.deselectItemByID(rteId + "_" + rteInstcne._listItems[0]);
            }
        },

        _toggleEditTable: function () {
            if (this._isIE8())
                this._getRange().parentElement&& (this._currentSelNode = this._getRange().parentElement());
            var isTable = $(this._getSelectedNode()).closest("table");
            var selTag = (isTable.length > 0) ? isTable[0] : this._getSelectedNode(), _eTblItems;
            if (ej.isNullOrUndefined(selTag)) return false;
            if (!ej.isNullOrUndefined(this._toolBarItems)) {
                var items = this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                if (this.model.isResponsive && items.length == 0)
                    _eTblItems = this._toolBarObj._liTemplte.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                else _eTblItems = this._toolBarItems.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                if (!ej.isNullOrUndefined(selTag.tagName)) {
                    if (selTag && selTag.tagName && selTag.tagName.toLowerCase() == "td" || selTag.tagName.toLowerCase() == "table" || selTag.tagName.toLowerCase() == "tr") {
                        _eTblItems.show();
                        this._createTable && this._createTable.find("div.e-rte-eTblProperties").removeClass('e-disable');
                    }
                    else if (!ej.isNullOrUndefined(this._createTable)) {
                        _eTblItems.hide();
                        this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
                    }
                }
            }
            if (this.model.isResponsive && this.model.showToolbar) this._toolBarObj._reSizeHandler();
            if (!this.model.autoHeight ||(this._toolBarObj && $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).length))
                this._setIframeHeight();
        },


        _formatChange: function (args) {
            if (args.isInteraction) {
                var $rteEle = $(this.element).closest("div.e-rte").find("textarea.e-rte"), rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                args.value !== "" && rteInstcne._onFormatBlock(args.value);
                rteInstcne._isIE() && rteInstcne._focus();
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }

        },


        _fontStyleChange: function (args) {
            if (args.isInteraction) {
			     var $rteEle;
               ($(this.element).closest("div").hasClass("e-normal"))? $rteEle = $("textarea#"+args.model.htmlAttributes.datafontid):$rteEle = $(this.element).closest("div.e-rte").find("textarea.e-rte");
				var rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                rteInstcne._focus();
                args.value !== "" && rteInstcne._onFontName(args.value);
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }
        },


        _fontSizeChange: function (args) {
            if (args.isInteraction) {
                var $rteEle;
               ($(this.element).closest("div").hasClass("e-normal"))? $rteEle = $("textarea#"+args.model.htmlAttributes.datafontid):$rteEle = $(this.element).closest("div.e-rte").find("textarea.e-rte");
				var rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                rteInstcne._focus();
                args.value !== "" && rteInstcne._onFontSize(args.value);
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }
        },


        _colorPaletteClick: function (e) {
            var value;
            if ((value = e.target.getAttribute('color-code'))) {
                this._focus();
                this._onFontColor(value);
                this._splitMenu.hide(e);
                this._fontColor = value;
                this._fontColorSplit.find("span.e-btntxt").css("background-color", value);
				this._onChange();
				this._setBackupData();
            }
        },


        _bgColorPaletteClick: function (e) {
            var value;
            if ((value = e.target.getAttribute('color-code'))) {
                this._focus();
                this._onBGColor(value);
                this._bgSplitMenu.hide(e);
                this._bgColor = value;
                this._bgColorSplit.find("span.e-btntxt").css("background-color", value);
				this._onChange();
				this._setBackupData();
            }
        },

        _fontColorClick: function (e) {
            this._onFontColor(this._fontColor);
            if (ej.isNullOrUndefined(this._splitMenu)) return false;
            this._splitMenu.hide(e);
        },

		_bgTransClick:function(e)
		{
		    this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.backcolor, "transparent");
            this._trigger("execute", { commandName: "backColor" });
			this._bgColorSplit.find("span.e-btntxt").css("background-color", "transparent");
		    if (!ej.isNullOrUndefined(this._bgSplitMenu));
            this._bgSplitMenu.hide(e);
			this._bgColor="transparent";
		},
        _bgColorClick: function (e) {
            this._onBGColor(this._bgColor);
            if (ej.isNullOrUndefined(this._bgSplitMenu)) return false;
            this._bgSplitMenu.hide(e);
        },

        _selectCommand: function (selectedId) {
			$(this._imgDupDiv).remove();
            $(this._imgOrg).css("outline","");
                if (ej.browserInfo().name != "edge" && !(selectedId == "format" || selectedId == "fontName" || selectedId == "fontSize" || selectedId == "fontColor" || selectedId == "backgroundColor" || selectedId == "createTable" )) {
                this._focus();
            }
            switch (selectedId) {
                case "fullScreen":
                    this._onFullScreen();
                    break;
                case "print":
                    this._onPrint();
                    break;
                case "import":
                    this._onImport();
                    break;
                case "wordExport":
                    this._onExportToWord();
                    break;
                case "pdfExport":
                    this._onExportToPdf();
                    break;
                case "findAndReplace":
                    if (ej.RTE.FindAndReplace)
                        this._showFindAndReplace();
                    break;
                case "bold":
                    this._onBold();
                    break;
                case "italic":
                    this._onItalics();
                    break;
                case "underline":
                    this._onUnderLine();
                    break;
                case "strikethrough":
                    this._onStrikeThrough();
                    break;
                case "justifyLeft":
                    this._onJustifyLeft();
                    break;
                case "justifyRight":
                    this._onJustifyRight();
                    break;
                case "justifyCenter":
                    this._onJustifyCenter();
                    break;
                case "justifyFull":
                    this._onJustifyFull();
                    break;
                case "cut":
                    this._onCut();
                    break;
                case "copy":
                    this._onCopy();
                    break;
                case "paste":
                    this._onPaste();
                    break;
                case "clearFormat":
                    this._onClearFormat();
                    break;
                case "clearAll":
                    this._clearAllManager();
                    break;
                case "orderedList":
                case "unorderedList":
                    this._getPasteRangeVal();
                    break;
                case "undo":
                    this._undo();
                    break;
                case "redo":
                    this._redo();
                    break;
                case "indent":
                    this._onIndent();
                    this._indentdepth++;
                    break;
                case "outdent":
                    this._onOutdent();
                    if (this._indentdepth > 0)
                        this._indentdepth--;
                    break;
                case "createLink":
                    this._hyperLinkManager(false);
                    break;
                case "removeLink":
                    this._onUnlink();
                    break;
                case "image":
                    this._imageManager();
                    break;
                case "createTable":
                    (!this._createTable.ejDialog("isOpen")) ? this._tableManager() : this._createTable.ejDialog("close");
                    break;
                case "addRowAbove":
                    this.insertRow(true);
                    break;
                case "addRowBelow":
                    this.insertRow(false);
                    break;
                case "addColumnLeft":
                    this.insertColumn(true);
                    break;
                case "addColumnRight":
                    this.insertColumn(false);
                    break;
                case "deleteRow":
                    this.removeRow();
                    break;
                case "deleteColumn":
                    this.removeColumn();
                    break;
                case "deleteTable":
                    this.removeTable();
                    break;
                case "superscript":
                    this._onSuperScript();
                    break;
                case "subscript":
                    this._onSubScript();
                    break;
                case "upperCase":
                    this._onUpperCase();
                    break;
                case "lowerCase":
                    this._onLowerCase();
                    break;
                case "video":
                    this._videoManager();
                    break;
                case "fileBrowser":
                    this._hyperLinkManager(true);
                    break;
                default:
                    this._onChange();
                    break;
            }
            if (selectedId != "createLink" && selectedId != "image" && selectedId != "video" && selectedId != "createTable") {
                this._onChange();
            }
            if ((selectedId != "undo") && (selectedId != "redo"))
                this._setBackupData();
            var selectEle = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            this._updateTagInfo(selectEle);
        },
        _focus: function () {
            browserInfo = ej.browserInfo();
            if (browserInfo.name == "webkit")
                this._getWindow().focus();
            else
                this._getWindow().document.body.focus();
            this._restoreSelection(this._selectionRange);
        },
        _getWindow: function () {
            var iframe = $($(this._rteWapper.find(".content-iframe"))[0].contentWindow)[0];
            return iframe;
        },
        _getDocument: function () {
            var iframe = this._rteWapper.find(".content-iframe");
            try {
                return iframe.contents()[0];
            }
            catch (err) {
                return "";
            }
        },
        _onFullScreen: function () {
            if (!$(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).length) {
                this._rteOffset = $(this._rteWapper).position();
                this._rtePosition = $(this._rteWapper).css("position");
                $(this._rteWapper).css({ "top": "0px", "left": "0px", "width": "100%", "height": "100%", "position": "fixed", "z-index": this._onGetMaxZindex() });
                $("body").css("overflow", "hidden");
                $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["maximize"])).removeClass(this._rteIconsList["maximize"]).addClass(this._rteIconsList["resize"]).parent("li").attr("data-content", this._getLocalizedLabels("resize"));
            }
            else {
                $(this._rteWapper).css({ "top": this._rteOffset.top, "left": this._rteOffset.left, "width": this._rteWidth, "height": this._rteHeight, "position": this._rtePosition, "z-index": "" });
                $("body").css("overflow", "");
                $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).addClass(this._rteIconsList["maximize"]).removeClass(this._rteIconsList["resize"]).parent("li").attr("data-content", this._getLocalizedLabels("maximize"));
            }
            if ($(this._getDocument()).find("table.e-rte-table").length > 0) this._removeResizeObject();
            this._setAutoHeight();
            if (this.model.showToolbar && this.model.isResponsive) this._toolBarObj._reSizeHandler();
            this._setIframeHeight();
            if (!ej.isNullOrUndefined(this._createTable))
                this._createTableClose();
        },
        _onGetMaxZindex: function () {
            return Math.max.apply(null,
                  $.map($('body *'), function (e, n) {
                      return parseInt($(e).css('z-index')) + 1 || 1;
                  }));
        },
        _onZooming: function (_proxy) {
            _proxy._zoomValue = 0;
            var size = Number(_proxy.getDocument().body.style.zoom == "" || ej.isNullOrUndefined(_proxy.getDocument().body.style.zoom) ? 1 : _proxy.getDocument().body.style.zoom);
            var zoomStep = (isNaN(_proxy.model.zoomStep) && _proxy.model.zoomStep.indexOf("%") != -1) ? parseInt(_proxy.model.zoomStep) / 100 : Number(_proxy.model.zoomStep);
            _proxy._zoomValue = (_proxy._zoomArgs == "IN") ? size + zoomStep : ((size - zoomStep) > 0.1) ? size - zoomStep : 0.1;
            $(_proxy.getDocument().body).css({ "zoom": _proxy._zoomValue, "transform": "scale(" + _proxy._zoomValue + ")", "transform-origin": "0 0", "-o-transform": "scale(" + _proxy._zoomValue + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + _proxy._zoomValue + ")", "-webkit-transform-origin": "0 0" });
            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomIn")).attr("title", _proxy._getLocalizedLabels("zoomIn") + " " + Math.round(_proxy._zoomValue * 100) + "%");
            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomOut")).attr("title", _proxy._getLocalizedLabels("zoomOut") + " " + Math.round(_proxy._zoomValue * 100) + "%");
            if (_proxy._isIE()) return _proxy;
        },
        _onKeyZoom: function (args) {
            var _proxy = this;
            this._mouseStillDown = true;
            this._zoomArgs = args;
            this._setInterval = setInterval(_proxy._onZooming(_proxy), 100);
        },
        _onPrint: function () {
            var _proxy = this;
            if (this._isIE() || ej.browserInfo().name === "mozilla") this._getWindow().onafterprint = function () { $(_proxy.getDocument().body).css({ "zoom": ((_proxy._zoomValue) ? _proxy._zoomValue : 1), "transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "transform-origin": "0 0", "-o-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-webkit-transform-origin": "0 0" }); };
            else _proxy._getWindow().matchMedia('print').addListener(function (args) {
                if (!args.matches) $(_proxy.getDocument().body).css({ "zoom": ((_proxy._zoomValue) ? _proxy._zoomValue : 1), "transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "transform-origin": "0 0", "-o-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-webkit-transform-origin": "0 0" });
            });
            $(_proxy.getDocument().body).css({ "zoom": "", "transform": "", "-o-transform": "", "-webkit-transform": "" });
            this._getWindow().print();
        },
        _renderimport: function () {
            var divEle = ej.buildTag("div#" + this._id + "_importUpload", "", "", ""), url = this.model.importSettings.url + "?rteid=" + this._id;
            this._rteToolbar.find("li.e-rteItem-import").append(divEle);
            divEle.ejUploadbox({
                multipleFilesSelection: false, width: "0px", height: "0px", autoUpload: true, extensionsAllow: ".docx,.doc", showBrowseButton: false, buttonText: { browse: this._id }, showFileDetails: false, saveUrl: url,
                success: function (args) {
                    var rteID = args.model.buttonText.browse, rteObj = $("#" + rteID).data("ejRTE"), htmlText = args.responseText, iframe = $(rteObj._getDocument().body);
                    htmlText = htmlText.replace('<string xmlns="http://schemas.microsoft.com/2003/10/Serialization/">', '').replace('</string>', '').replace(/"/gi, '');
                    iframe.children().remove();
                    iframe.append($.parseHTML(htmlText));
                }
            });
            divEle.addClass("e-browse-hide");
        },
        _onImport: function () {
            this._toolBarItems.find("div#" + this._id + "_importUpload").find('input[type=file]').trigger("click");
        },
        _onExportToWord: function () {
            var str = this._getDocument().body, url = this.model.exportToWordSettings.url, htmlText = str.innerHTML, formAttr = { action: url + "?rteid=" + this._id, method: "post" }, formEle = ej.buildTag("form", "", null, formAttr), textAttr = { name: this._id + "_inputVal", type: "hidden", value: htmlText }, textEle = ej.buildTag("input", "", null, textAttr), textAttr2 = { name: this._id + "_inputFile", type: "hidden", value: this.model.exportToWordSettings.fileName }, textEle2 = ej.buildTag("input", "", null, textAttr2);
            $("body").append(formEle.append(textEle).append(textEle2));
            formEle.submit();
            formEle.remove();
        },
        _onExportToPdf: function () {
            var str = this._getDocument().body, url = this.model.exportToPdfSettings.url, htmlText = str.innerHTML, formAttr = { action: url + "?rteid=" + this._id, method: "post" }, formEle = ej.buildTag("form", "", null, formAttr), textAttr = { name: this._id + "_inputVal", type: "hidden", value: htmlText }, textEle = ej.buildTag("input", "", null, textAttr), textAttr2 = { name: this._id + "_inputFile", type: "hidden", value: this.model.exportToPdfSettings.fileName }, textEle2 = ej.buildTag("input", "", null, textAttr2);
            $("body").append(formEle.append(textEle).append(textEle2));
            formEle.submit();
            formEle.remove();
        },
        _zoomUp: function (e) {
            if (e && ((e.which && e.which == 3) || (e.button && e.button == 2)))
                return;
            if (this._setInterval) {
                this._mouseStillDown = false;
                clearInterval(this._setInterval);
                this._setInterval = null;
            }
        },
        _zoomDown: function (e) {
            if (e && ((e.which && e.which == 3) || (e.button && e.button == 2)))
                return;
            var _proxy = this;
            _proxy._mouseStillDown = true;
            _proxy._zoomArgs = $(e.target).hasClass("e-rte-toolbar-icon zoomIn " + this._rteIconsList["zoomIn"]) || $(e.target).hasClass("e-rteItem-zoomIn") ? "IN" : "OUT";
            if (e.type == "mousedown") _proxy._setInterval = setInterval(function () { _proxy._onZooming(_proxy); }, 100);
            else _proxy._setInterval = setInterval(_proxy._onZooming(_proxy), 100);
        },
        _onBold: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('bold', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.bold, null);
                this._trigger("execute", { commandName: "bold" });
            }
        },

        _onItalics: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('italic', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.italic, null);
                this._trigger("execute", { commandName: "italic" });
            }

        },
        _onStrikeThrough: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('strikethrough', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.strikethrough, null);
                this._trigger("execute", { commandName: "strikethrough" });
            }
        },

        _onUnderLine: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('underline', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.underline, null);
                this._trigger("execute", { commandName: "underline" });
            }
        },

        _onJustifyLeft: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('JustifyLeft', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyleft, null);
                this._trigger("execute", { commandName: "JustifyLeft" });
            }
        },

        _onJustifyRight: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('JustifyRight', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyright, null);
                this._trigger("execute", { commandName: "JustifyRight" });
            }
        },

        _onJustifyCenter: function () {
            var args;
            if ((this._isIE8()))
                this.executeCommand('JustifyCenter', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifycenter, null);
                this._trigger("execute", { commandName: "JustifyCenter" });
            }
        },

        _onJustifyFull: function () {
            this._alignFlag = true;
            if ((this._isIE8()))
                this.executeCommand('justifyfull');
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyfull, null);
                this._trigger("execute", { commandName: "justifyfull" });
            }
        },

        _onCut: function () {
            var args;
            this.executeCommand('cut', args);
        },
        _onCopy: function () {
            var args;
            this.executeCommand('copy', args);
        },
        _onOpen: function () {
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            window.open($(selectNode).attr('href'));
        },
        _onPaste: function () {
            var args;
            this.executeCommand('paste', args);

        },
        _onOrderList: function (e) {
            var _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if ((($(_listSelect).prop("tagName") != "OL" && $(_listSelect).parents("ol").length == 0 && e.ID != "none") || e.type == "click" || (($(_listSelect).prop("tagName") == "OL" || $(_listSelect).parents("ol").length > 0) && e.ID == "none")) && !(ej.isNullOrUndefined(e.ID) && this._listOrderType == "none"))
                this.executeCommand('insertorderedlist', "listItem");
            _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if (e.type == "click" && $(_listSelect).parents("ol").length >= 0) e.ID = this._listOrderType;
            if (!ej.isNullOrUndefined(e.ID)) var orderParent = ($(_listSelect).prop("tagName") == "OL") ? _listSelect : $(_listSelect).parents("ol");
            this._generateListItems(e, orderParent, !ej.isNullOrUndefined(this.model.tools["customOrderedList"]) ? this.model.tools["customOrderedList"] : []);
            this._listOrderType = e.ID;
            this._updateIndent(_listSelect);
        },
        _onUnorderList: function (e) {
            var _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if ((($(_listSelect).prop("tagName") != "UL" && $(_listSelect).parents("ul").length == 0 && e.ID != "none") || e.type == "click" || (($(_listSelect).prop("tagName") == "UL" || $(_listSelect).parents("ul").length > 0) && e.ID == "none")) && !(ej.isNullOrUndefined(e.ID) && this._listType == "none"))
                this.executeCommand('insertunorderedlist', "listItem");
            _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if (e.type == "click" && $(_listSelect).parents("ul").length >= 0) e.ID = this._listType;
            if (!ej.isNullOrUndefined(e.ID)) var unOrderParent = ($(_listSelect).prop("tagName") == "UL") ? _listSelect : $(_listSelect).parents("ul");
            this._generateListItems(e, unOrderParent, !ej.isNullOrUndefined(this.model.tools["customUnorderedList"]) ? this.model.tools["customUnorderedList"] : []);
            this._listType = e.ID;
            this._updateIndent(_listSelect);
        },
        _generateListItems: function (e, list, template) {
            $(list).css({ "list-style-type": e.ID, "list-style-image": "" });
            var proxy = this;
            if (["none", "disc", "circle", "square", "decimal", "upper-roman", "lower-roman", "upper-alpha", "lower-alpha"].indexOf(e.ID) == -1)
                $.each(template, function (i, val) {
                    if (val["name"] == e.ID) $(list).css({ "list-style-type": val["listStyle"], "list-style-image": val["listImage"] });
                });
            this._setBackupData();
            (this._isIE()) ? this.selectRange(this._pasteRangeVal) : this.selectRange(this._getRange());
            this._updateTagInfo((this._isIE()) ? this._currentSelNode : this._getSelectedNode());
        },
        _onUndo: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('undo', null);
            else
                this._undo();
        },
        _onDelete: function () {
            var args;
            this.executeCommand('delete', null);
        },

        _onRedo: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('redo', null);
            else
                this._redo();
        },

        _onClearFormat: function () {
            var args;
            this.executeCommand('removeformat', args);
            this._hideTooltip();
            this._setBackupData();
            this._onChange();
            this._updateIframeSkin(this.model.iframeAttributes);
            this._updateToolbarStatus();
        },

        _onFormatBlock: function (formatBlock) {
            this._focus();
            if ((this._isIE8())) {
                var selection, range, node;
                node = document.getSelection ? this._getSelectedNode() : this._getWindow().document.selection.createRange().parentElement();
                this._onClearFormat();
                this.executeCommand('formatBlock', formatBlock);
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.formatblock, formatBlock);
                this._trigger("execute", { commandName: "formatBlock" });
            }

            
            this._updateToolbarStatus();
            this._updateFontOptionStatus();

        },

        _onFontName: function (fontsname) {
            if ((this._isIE8()))
                this.executeCommand("fontName", fontsname);//backColor,fontName,fontSize,foreColor
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.fontname, fontsname);
                this._trigger("execute", { commandName: "fontName" });
            }
        },

        _onFontSize: function (Size) {
            if ((this._isIE8()))
                this.executeCommand('fontSize', Size);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.fontsize, Size);
                this._trigger("execute", { commandName: "fontSize" });
            }
        },

       _onFontColor: function (color) {
	        this._fontColorSplit.find("span.e-btntxt").css("background-color", color);
		     if(this._customDialogobj&&this._customDialogobj.isOpen())
			 {
			 this._customColor.ejDialog("close");
			 }
            if (this._isIE8())
                this.executeCommand('foreColor', color);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.forecolor, color);
                this._trigger("execute", { commandName: "foreColor" });
            }
            this._onChange();
            this._updateIframeSkin(this.model.iframeAttributes);
        },

       _onBGColor: function (color) {
	        this._bgColorSplit.find("span.e-btntxt").css("background-color", color);
		    if(this._customDialogobj&&this._customDialogobj.isOpen())
			{
			  this._customColor.ejDialog("close");	 
			}
            if (this._isIE8())
                this.executeCommand('backColor', color);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.backcolor, color);
                this._trigger("execute", { commandName: "backColor" });
            }
            this._onChange();
        },

        _onIndent: function () {
            if (this._isIE8()) {
                this._getWindow().document.body.style.wordWrap = "break-word";
                var node = document.getSelection ? this._getWindow().document.getSelection().focusNode : this._getWindow().document.selection.createRange().parentElement();
                if (node && (/^(OL|UL|LI)$/).test(node.nodeName))
                    this._listIndent(node);
                else if (node && (/^(#text)$/).test(node.nodeName) && (/^(OL|UL|LI)$/).test($(node).parent()[0].nodeName)) {
                    this._listIndent($(node).parents("li")[0], node);
                }
                else
                    this.executeCommand('indent', false);

                node && $(node).focus();
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.indent, null);
                this._trigger("execute", { commandName: "indent" });
            }

            this._updateIframeSkin(this.model.iframeAttributes);
            this._updateIndentStatus();
        },

        _onOutdent: function () {
            if (this._isIE8()) {
                var node = document.getSelection ? this._getWindow().document.getSelection().focusNode : this._getWindow().document.selection.createRange().parentElement();
                if (node && (/^(OL|UL|LI)$/).test(node.nodeName))
                    this._listOutdent(node);
                else if (node && (/^(#text)$/).test(node.nodeName) && (/^(OL|UL|LI)$/).test($(node).parent()[0].nodeName)) {
                    this._listOutdent($(node).parents("li")[0], node);
                }
                else
                    this.executeCommand('outdent', false);
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.outdent, null);
                this._trigger("execute", { commandName: "outdent" });
            }
            this._updateIndentStatus();
        },

        _onSelectAll: function () {
            this.executeCommand('selectall');
        },
        selectAll: function () {
            this._onSelectAll();
        },
        _onHyperLink: function (val) {
            this.executeCommand('createlink', val);
        },

        _onInsertLink: function () {
            var oEl, sHtml;
            if (!this._isUrl($.trim(this._txtURL.val()))) {
                this._txtURL.addClass("e-error");
                return false;
            }
            var selectedNode = ((ej.browserInfo().name == "msie" || ej.browserInfo().name == "chrome") && $(this._currentSelNode).parents("body").length > 0) ? this._currentSelNode : this._getSelectedNode();
            if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'A') {
                selectedNode.href = this._txtURL.val();
                selectedNode.title = this._txtLinkTitle.val();
                selectedNode.innerHTML = this._txtLinkText.val();
                (this._chkTarget.ejCheckBox("isChecked")) ? selectedNode.target = "_blank" : selectedNode.target = "";
            }
            else if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'IMG') {
                var parentNode = $(selectedNode).parent('a')[0];
                if (ej.isNullOrUndefined(parentNode)) {
                    oEl = ej.buildTag("a", "", {}, { href: this._txtURL.val(), title: this._txtLinkTitle.val() == "" ? (this._txtURL.val() + "\n" + this._getLocalizedLabels("linkTooltip")) : this._txtLinkTitle.val() });
                    (this._chkTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "";
                    $(selectedNode.outerHTML).appendTo($(oEl));
                    $(selectedNode).replaceWith($(oEl));
                } else {
                    parentNode.href = this._txtURL.val();
                    parentNode.title = this._txtLinkTitle.val();
                    (this._chkTarget.ejCheckBox("isChecked")) ? parentNode.target = "_blank" : parentNode.target = "";
                }
            }
            else {
                oEl = ej.buildTag("a", "", {}, { href: this._txtURL.val(), title: this._txtLinkTitle.val() == "" ? (this._txtURL.val() + "\n" + this._getLocalizedLabels("linkTooltip")) : this._txtLinkTitle.val() });
                (this._chkTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "";

                var oSelection;
                var oSelRange;
                this._focus();
                if (this._isIE()) {
                    if (this._selectedHTML.length == 0) {
                        if (this._txtLinkText.val() === "") this._selectedHTML = this._txtURL.val();
                        else this._selectedHTML = this._txtLinkText.val();
                    }
                    oEl[0].innerHTML = this._selectedHTML;
                    sHtml = oEl[0].outerHTML;
                }
                else {
                    if (this._txtLinkText.val() === "") oEl.html(this._txtURL.val());
                    else oEl.html(this._txtLinkText.val());
                    sHtml = $('<div>').append($(oEl).clone()).html();
                }
                if (sHtml && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length))) {
                    this._isIE() ? this._pasteHtml(sHtml) : this._getDocument().execCommand('inserthtml', false, sHtml);
                    this.selectRange(this._getRange());
                }
            }
            this._linkDialog.ejDialog("close");
            this.enableToolbarItem("removeLink");
            this._updateCount();
        },

        _setImageProperties: function (imgEle, imgX, imgY, imageStyle, borderPx, borderStyle, borderColor) {
            if (this.model.showDimensions) {
                (imgX != "") && (imgEle[0].width = imgX);
                (imgY != "") && (imgEle[0].height = imgY);
            }

            imgEle = $(imgEle).attr('style', imageStyle);

            border = borderPx + "px ";
            (!ej.isNullOrUndefined(borderStyle) && borderStyle != "") ? border += borderStyle + " " : border += "solid ";
            (!ej.isNullOrUndefined(borderColor) && borderColor != "") ? border += borderColor : border += "#000000";
            imgEle = imgEle.css('border', border);
        },
        _onInsertImage: function () {
            var url = this._imgDialog.find(".e-rte-imgUrl");
            var altText = this._imgDialog.find(".e-rte-imgText");
            var imgX = this._imgDialog.find(".e-rte-imgX").val();
            var imgY = this._imgDialog.find(".e-rte-imgY").val();
            var proxy = this;
            this._restoreSelection(this._selectionRange);
            var element, border, nodeName = "", imageLink = proxy._imageLink.val(), borderPx = proxy._imageBorderPx.getValue(), borderStyle = proxy._imageBorderStyle.getSelectedValue(), borderColor = proxy._imgPicker.getValue(), imageStyle = proxy._imageStyle.val();
            var selectedNode = (proxy._isIE()) ? proxy._currentSelNode : proxy._getSelectedNode();
            (!ej.isNullOrUndefined(selectedNode)) && (nodeName = selectedNode.nodeName.toUpperCase());
            borderColor = !ej.isNullOrUndefined(borderColor) && borderColor.length > 0 ? borderColor : "";
            var srcUrl = (url.val().startsWith("~")) ? url.val().replace(url.val().substr('0', '1'), "..") : url.val();
            if (nodeName != 'IMG') {
                //Url Validation
                var _img = $("<img>", {
                    src: srcUrl,
                    error: function () { url.addClass("e-error"); },
                    success: function () {
                        var imgEle = ej.buildTag("img", "", {}, { alt: altText.val(), src: srcUrl });
                        proxy._setImageProperties(imgEle, imgX, imgY, imageStyle, borderPx, borderStyle, borderColor);
                        if (imageLink != "") {
                            if (proxy._isUrl($.trim(imageLink))) {
                                var link = ej.buildTag("a", "", {}, { href: imageLink });
                                (proxy._dialogchkTarget.ejCheckBox("isChecked")) ? link[0].target = "_blank" : link[0].target = "_self";
                                $(imgEle[0].outerHTML).appendTo(link);
                                imgEle = link;
                            }
                            else {
                                proxy._imageLink.addClass("e-error");
                                return false;
                            }
                        }
                        var element = imgEle[0].outerHTML;
                        proxy.executeCommand('inserthtml', element);
                    }
                });
            }
            else {
                selectedNode.src = srcUrl;
                selectedNode.alt = altText.val();
                proxy._setImageProperties($(selectedNode), imgX, imgY, imageStyle, borderPx, borderStyle, borderColor);
                var linkNode = $(selectedNode).parent('a');
                if (imageLink != "") {
                    if (proxy._isUrl($.trim(imageLink))) {
                        if (linkNode.length > 0)
                            linkNode.attr('href', imageLink);
                        else {
                            var linkNode = ej.buildTag("a", "", {}, { href: imageLink });
                            $(selectedNode.outerHTML).appendTo(linkNode);
                            $(selectedNode).replaceWith(linkNode);
                        }
                    }
                    else {
                        proxy._imageLink.addClass("e-error");
                        return false;
                    }
                }
                else 
                    (linkNode.length > 0) && (linkNode.attr('href', ""));
                if (!ej.isNullOrUndefined(linkNode) && linkNode.length > 0)
                    (this._dialogchkTarget.ejCheckBox("isChecked")) ? linkNode[0].target = "_blank" : linkNode[0].target = "_self";
            }
            proxy._setAutoHeight();
            if (!proxy._imageLink.hasClass("e-error")) proxy._imgDialog.ejDialog("close");
            proxy._on(proxy._imageLink, "keypress", proxy._urlValidation)._on(proxy._imageLink, "blur", proxy._urlValidation);
        },

        _insertVideo: function (sender) {
            var videoLink = $.trim(this._videoDialog.find("textarea.e-rte-video")[0].value);
            var videoX = this._videoDialog.find(".e-rte-videoX").val();
            var videoY = this._videoDialog.find(".e-rte-videoY").val();
            this._restoreSelection(this._selectionRange);
            this._alertHeader(this);
            if (sender.target.id === "video_insert" && videoLink !== "") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                var ele = $(videoLink)[0];
                if (this.model.showDimensions && !ej.isNullOrUndefined(ele)) {
                    (videoX != "") && (ele.width = videoX);
                    (videoY != "") && (ele.height = videoY);
                }
                if (!ej.isNullOrUndefined(ele) && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)))
                    this.executeCommand('inserthtml', ele.outerHTML + "<br/>");

                this._onChange();
                this._setBackupData();
                this._videoDialog.ejDialog("close");
            }
            else if (sender.target.id === "video_cancel") {
                this._videoDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else
                this._openAlert(this._getLocalizedLabels("videoError"));
            this._videoDialog.find("textarea.e-rte-video")[0].value = "";
            this._videoDialog.find(".e-rte-videoX").val("");
            this._videoDialog.find(".e-rte-videoY").val("");
            this._chkvideoDimensions.ejCheckBox({ check: true });
            this._setAutoHeight();
        },

        _oneditTable: function () {
            //var selectedNode = this._currentSelNode;
            var isTable = $(this._getSelectedNode()).closest("td");
            var selectedNode = (isTable.length > 0) ? isTable[0] : this._currentSelNode;
            var parentTable = $(selectedNode).closest('tbody').closest('table');
            var captionEle = $($(selectedNode).closest('tbody')).prev('caption');
            (this._eTblCaption.ejCheckBox("isChecked")) ? (captionEle.length == 0) && ej.buildTag('caption').append($('<br type="_moz">')).insertBefore($($(selectedNode).closest('tbody'))) : (captionEle.length > 0) && captionEle.remove();
            var tblAlign = this._eTblAlign.getSelectedValue();
            var style = this._getTableObj("Style").val();
            if (tblAlign == 'center') style += ";margin: 0 auto;";
            (style) && parentTable.attr('style', style);
            this._customTableValidation = false;
            var tableWid = this._customInputValidation(this._getTableObj("Width"));
            var tableHgt = this._customInputValidation(this._getTableObj("Height"));
            var rowHgt = this._customInputValidation(this._getTableObj("RHeight"));
            var cellWid = this._customInputValidation(this._getTableObj("ClWidth"));
            if (!this._customTableValidation) {
                parentTable.css({
					'width': tableWid,
                    'height': tableHgt,
                    'cellPadding': this._getTableObj("CellPad").data('ejNumericTextbox').getValue(),
                    'cellSpacing': this._getTableObj("CellSpace").data('ejNumericTextbox').getValue(),
                    'float': tblAlign,
                    'border-width': this._getTableObj("BrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("_border_style").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("_border_color").val()
                });
                var parentRow = $(selectedNode).closest('tr');
                parentRow.attr({
                    style: this._getTableObj("RStyle").val()
                }).css({
                    'height': rowHgt,
                    'text-align': this._getTableObj("RAlign").data('ejDropDownList').getSelectedValue(),
                    'border-width': this._getTableObj("RBrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("RBrdrStyle").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("RBrdrColor").val()
                });
                $(selectedNode).attr({
                    style: this._getTableObj("ClStyle").val()
                }).css({
                    'width': cellWid,
                    'text-align': this._getTableObj("ClAlign").data('ejDropDownList').getSelectedValue(),
                    'border-width': this._getTableObj("ClBrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("ClBrdrStyle").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("ClBrdrColor").val()
                });
                this._eTblDialog.ejDialog("close");
            }
            this._on(this._getTableObj("Width"), "keypress", this._urlValidation)
				._on(this._getTableObj("Height"), "keypress", this._urlValidation)
				._on(this._getTableObj("RHeight"), "keypress", this._urlValidation)
				._on(this._getTableObj("ClWidth"), "keypress", this._urlValidation);
        },


        _clearAllManager: function () {
            this._hideTooltip();
            this._alertWindow.find(".e-alert-cancel").show();
            this._alertHeader(this);
            this._openAlert(this._getLocalizedLabels("deleteAlert"));
        },

        _onUnlink: function () {
            var args;
            this.executeCommand('unlink', args);
            this.disableToolbarItem("removeLink");
        },
        _onSuperScript: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('SuperScript', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.superscript, null);
                this._trigger("execute", { commandName: "SuperScript" });
            }
        },
        _onSubScript: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('SubScript', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.subscript, null);
                this._trigger("execute", { commandName: "SubScript" });
            }
        },
        _onInsertTable: function (rows, cols, designTime) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                $(this._getDocument().body).css("display", "inline-block");
                var tableEle = this._tableGenerator(rows, cols, designTime);
                this.executeCommand('inserthtml', tableEle);
                if ((ej.isNullOrUndefined($(this._getDocument().body).find("table:last")[0].nextSibling)) || ($(this._getDocument().body).find("table:last")[0].nextSibling.nodeName.toLowerCase() == "#text" && $.trim($(this._getDocument().body).find("table:last")[0].nextSibling.nodeValue) == "\n"))
                    $("<p><br/></p>").insertAfter($(this._getDocument().body).find("table"))
                $(this._getDocument().body).css("display", "");
                this._setAutoHeight();
            }
        },

        _onUpperCase: function () {
            if (this._isIE8()) {
                if (!document.getSelection) {
                    if (this._getWindow().document.selection.type.toLowerCase() == "control") {
                        return;
                    }
                    this._seleText = ej.isNullOrUndefined(this._seleText) ? "" : this._seleText;
                    this._getDocument().selection.createRange().pasteHTML(this._seleText.toUpperCase());
                }
                else {
                    var selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    var node = range.commonAncestorContainer;
                    var children = range.commonAncestorContainer.children;
                    if (children != null) {
                        var contents = range.cloneContents()
                        var result = this._changeCase(contents, "Upper");
                        var resultCopy = $(result).clone();
                        var tempDiv = document.createElement('div');
                        $(tempDiv).append($(resultCopy));
                        if (tempDiv.innerHTML != null && tempDiv.innerHTML != "")
                            this._getWindow().document.execCommand('inserthtml', false, tempDiv.innerHTML);
                    }
                    else {
                        var replaceString = node.nodeValue.substring(range.startOffset, range.endOffset).toUpperCase();
                        var startString = node.nodeValue.substr(0, range.startOffset);
                        var endString = node.nodeValue.substring(range.endOffset);
                        node.nodeValue = startString + replaceString + endString;
                    }
                }
            }
            else
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.uppercase, null);


            this._trigger("execute", { commandName: "uppercase" });
        },

        _changeCase: function (parentNode, toChangeCase) {
            var s = parentNode.childNodes;
            if (s.length > 0) {
                for (var t = 0; t < s.length; t++) {
                    if (s[t].nodeType == 3) {
                        s[t].nodeValue = toChangeCase == "Upper" ? s[t].nodeValue.toUpperCase() : s[t].nodeValue.toLowerCase();
                    }
                    else {
                        if (s[t].nodeType == 1 && s[t].tagName.toUpperCase() != "FONT") {
                            this._changeCase(s[t], toChangeCase);
                        }
                    }
                }
            }
            return s;
        },


        _onLowerCase: function () {
            if (this._isIE8()) {
                if (!document.getSelection) {
                    if (this._getWindow().document.selection.type.toUpperCase() == "control") {
                        return;
                    }
                    this._seleText = ej.isNullOrUndefined(this._seleText) ? "" : this._seleText;
                    this._getDocument().selection.createRange().pasteHTML(this._seleText.toLowerCase());
                }
                else {
                    var selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    var node = range.commonAncestorContainer;
                    var children = range.commonAncestorContainer.children;
                    if (children != null) {
                        var contents = range.cloneContents();
                        var result = this._changeCase(contents, "Lower");
                        var resultCopy = $(result).clone();
                        var tempDiv = document.createElement('div');
                        $(tempDiv).append($(resultCopy));
                        if (tempDiv.innerHTML != null && tempDiv.innerHTML != "")
                            this._getWindow().document.execCommand('inserthtml', false, tempDiv.innerHTML);
                    }
                    else {
                        var replaceString = node.nodeValue.substring(range.startOffset, range.endOffset).toLowerCase();
                        var startString = node.nodeValue.substr(0, range.startOffset);
                        var endString = node.nodeValue.substring(range.endOffset);
                        node.nodeValue = startString + replaceString + endString;
                    }
                }
            }
            else
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.lowercase, null);
            //execCommand=emphasize-contentformat-indent-contentalignment-formatblock-captionconvertion
            this._trigger("execute", { commandName: "lowercase" });
        },

        _listIndent: function (node, selection) {
            var sibling, newList;
            sibling = node.previousSibling;
            if (sibling && this._isListNode(sibling)) {
                sibling.appendChild(node);
                return true;
            }
            if (sibling && sibling.nodeName == 'LI' && this._isListNode(sibling.lastChild)) {
                sibling.lastChild.appendChild(node);
                this._combineLists(node.lastChild, sibling.lastChild, node);
                return true;
            }
            sibling = node.nextSibling;
            if (sibling && this._isListNode(sibling)) {
                sibling.insertBefore(node, sibling.firstChild);
                return true;
            }
            if (sibling && sibling.nodeName == 'LI' && this._isListNode(node.lastChild)) {
                return false;
            }
            sibling = node.previousSibling;
            if (sibling && sibling.nodeName == 'LI') {
                newList = ej.buildTag(node.parentNode.nodeName)[0];
                sibling.appendChild(newList);
                newList.appendChild(node);
                this._combineLists(node.lastChild, newList, node);
                return true;
            }
            return true;
        },

        _combineLists: function (from, to, li) {
            var node;
            if (this._isListNode(from)) {
                while ((node = li.lastChild.firstChild)) {
                    to.appendChild(node);
                }
                $(from).remove();
            }
        },
        _isListNode: function (node) {
            return node && (/^(OL|UL)$/).test(node.nodeName);
        },
        _isFirstChild: function (node) {
            return node.parentNode.firstChild == node;
        },

        _isLastChild: function (node) {
            return node.parentNode.lastChild == node;
        },
        _removeEmptyList: function (node) {
            if (node && $(node).children().length === 0)
                $(node).remove();
        },
        _listOutdent: function (node) {
            var ul = $(node.parentNode), ulParent = ul[0].parentNode, newBlock;
            node = $(node);
            if (this._isFirstChild(node[0]) && this._isLastChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                    this._removeEmptyList(ulParent);
                    ul.remove();
                } else if (this._isListNode(ulParent)) {
                    ul.remove();
                } else {
                    this.executeCommand('outdent', false);
                }

                return true;
            } else if (this._isFirstChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                    node[0].appendChild(ul[0]);
                    this._removeEmptyList(ulParent);
                } else if (this._isListNode(ulParent)) {
                    ulParent.insertBefore(node[0], ul[0]);
                } else {
                    this.executeCommand('outdent', false);
                }

                return true;
            } else if (this._isLastChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                } else if (this._isListNode(ulParent)) {
                    node.insertAfter(ul[0]);
                } else {
                    this.executeCommand('outdent', false);
                }
                return true;
            } else {
                this.executeCommand('outdent', false);
            }
            return false;
        },
        _updateIndent: function (node) {
            if (!ej.isNullOrUndefined(this._toolBarObj)) {
                if ($("#" + this._rteId + "_" + "indent").hasClass('e-disable')) this._toolBarObj.enableItemByID(this._rteId + "_" + "indent");
                if (node && (/^(LI)$/).test(node.nodeName)) {
                    if ($(node).parents(node.parentNode.nodeName).last().find("li").index(node) === 0)
                        this._toolBarObj.disableItemByID(this._rteId + "_" + "indent");
                }
            }
        },
         _updateCount: function () {
            if (!ej.isNullOrUndefined(this.model)) {
                if (this.model.showFooter && this.model.showWordCount)
				{
                   this._wordCount.html(this._getLocalizedLabels("words") + " : " + ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0));
				  if(this._rteFooter.width()<400)
				  this._wordCount.html(this._getLocalizedLabels("w") + " : " + ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0));
					}
				
                if (this.model.showFooter && this.model.showCharCount)
				{
                    this._charCount.html(this._getLocalizedLabels("characters") + " : " + this._getText().length);
					if(this._rteFooter.width()<400)
					this._charCount.html(this._getLocalizedLabels("c")+ " : " + this._getText().length);
					}
            }
        },
        _updateTagInfo: function (element) {
            var text = "", pTag, count = 1;
            if (!ej.isNullOrUndefined(element))
                if (element.localName == "body" || element.localName == "html")
                    element = this._getSelectedNode();
            if (ej.isNullOrUndefined(element)) this._curNode = "";
            else this._curNode = element.tagName ? element.tagName.toLowerCase() : "html";
            if (this.model.showFooter && this.model.showHtmlTagInfo) {
                if (this._curNode != "html" && this._curNode !== "") {
                    var parentNodes = $(element).parents();
                    for (var i = parentNodes.length - 1; i >= 0; i--) {
                        pTag = parentNodes[i].tagName.toLowerCase();
                        if (pTag != "html")
                            text += " » " + pTag;
                        else count++;
                    }
                    text += " » " + this._curNode;
                    if ($(element).parents().length > 0) {
                        if (!ej.isNullOrUndefined(parentNodes[parentNodes.length - count]))
                            this._pTag = parentNodes[parentNodes.length - count].tagName.toLowerCase();
                    }
                }
                this._tags = text;
                this._responsiveTagList();
            }
        },
        _responsiveTagList: function () {
            $(this._htmlInfo).html(this._tags);
            if ($(this._rteWapper).outerWidth() < $(this._rteWapper).find('.e-rte-footer-left').outerWidth() + $(this._rteWapper).find('.e-rte-footer-right').outerWidth())
                $(this._htmlInfo).html(" » " + this._pTag + " » ... ...  » " + this._curNode);
            else $(this._htmlInfo).html(this._tags);
        },
		_removeNoSpaceChar:function(data){
			data &&(data=data.replace(/[\uFEFF]/g,""));
			return data
		},
        _updateValue: function () {
            var updatedval = this._removeNoSpaceChar(this._updateXhtml());
            if (this.model.enableHtmlEncode)
                updatedval = this._encode(this._decode(updatedval));
            this.value(updatedval);
            this.element.val(updatedval);
        },
        _imageXhtml: function (imgVal) {
            var imgRegexp = /<img(.*?)>/ig;
            var imgTemp;
            var j = 0;
            var imgDup = new Array();
            while ((imgTemp = imgRegexp.exec(imgVal)) !== null) {
                imgDup.push(imgTemp[0].toString());
            }
            var imgEx = new Array();
            imgEx = imgDup.slice(0);
            for (var i = 0; i < imgDup.length; i++) {
                if (imgDup[i].indexOf("/") == -1) {
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length) + "/" + imgDup[i].substr(imgDup[i].length - 1, imgDup[i].length);
                }
                else if (imgDup[i].lastIndexOf("/") != imgDup[i].length - 2) {
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 1) + "/" + imgDup[i].substr(imgDup[i].length - 1, imgDup[i].length);
                }
            }
            var altReg = /(alt)=("[^"]*")/i;
            var srcReg = /(src)=("[^"]*")/g;
            var altRegS = /(alt)=('[^"]*')/i;
            var srcRegS = /(src)=('[^"]*')/g;
            for (var i = 0; i < imgDup.length; i++) {
                var temp = ej.isNullOrUndefined(altReg.exec(imgDup[i])) ? altRegS.exec(imgDup[i]) : altReg.exec(imgDup[i]);
                var dup = ej.isNullOrUndefined(srcReg.exec(imgDup[i])) ? srcRegS.exec(imgDup[i]) : srcReg.exec(imgDup[i]);
                var srcVar = ej.isNullOrUndefined(imgDup[i].match(srcReg)) ? imgDup[i].match(srcRegS) : imgDup[i].match(srcReg);
                var altVar = ej.isNullOrUndefined(imgDup[i].match(/(alt)=("[^"]*")/g)) ? imgDup[i].match(/(alt)=('[^"]*')/g) : imgDup[i].match(/(alt)=("[^"]*")/g);
                if (temp == null && altVar == null)
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 2) + " alt=\"\"" + imgDup[i].substr(imgDup[i].length - 2, imgDup[i].length);
                else {
                    for (var j = altVar.length - 1; j > 0; j--) {
                        imgDup[i] = imgDup[i].replace(altVar[j], "");
                    }
                }
                if (dup == null && srcVar == null)
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 2) + " src=\"\"" + imgDup[i].substr(imgDup[i].length - 2, imgDup[i].length);
                else {
                    for (var j = srcVar.length - 1; j > 0; j--) {
                        imgDup[i] = imgDup[i].replace(srcVar[j], "");
                    }
                }
            }
            for (var g = 0; g < imgDup.length; g++) {
                imgVal = imgVal.replace(imgEx[g], imgDup[g]);
            }
            return imgVal;
        },
        _tagCssReplace: function (styleTag, styleDup, styleRegval) {
            var tagStyle = /(style)=("[^"]*")/i;
            var tagCss = tagStyle.exec(styleDup);
            if (tagCss != null) {
                var cssTag = tagCss[0];
                if (styleTag != "")
                    cssTag = cssTag.substr(0, cssTag.length - 1) + styleTag + ";\"";
                if (!ej.isNullOrUndefined(styleTag))
                    styleDup = styleDup.replace(styleRegval[0], "").replace(tagCss[0], cssTag);
                return styleDup;
            }
        },
        _updateIndentStatus: function () {
            if (this._isIE8())
                ($(this._getSelectedNode()).closest("BLOCKQUOTE").length > 0) ? this.enableToolbarItem("outdent") : this.disableToolbarItem("outdent");
            else {
                if (this._getDocumentHandler() && this._operationHandler._validateIndent(this._getRange().startContainer))
                    this.enableToolbarItem("outdent");
                else
                    this.disableToolbarItem("outdent");
            }

        },
        _replaceHeightWidth: function (htmlTagreg, styleDup) {
            var styleRegval = htmlTagreg.exec(styleDup);
            if (!ej.isNullOrUndefined(styleRegval)) {
                var styleTag = styleRegval[0];
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":");
            }
            return (this._tagCssReplace(styleTag, styleDup, styleRegval));
        },
        _typeXhtmlValidation: function (styleDup) {
            var styleTag = styleRegval[0];
            if (styleTag == "type=\"a\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("a", "lower-alpha");
            else if (styleTag == "type=\"A\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("A", "upper-alpha");
            else if (styleTag == "type=\"1\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("1", "decimal");
            else if (styleTag == "type=\"i\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("i", "lower-roman");
            else if (styleTag == "type=\"I\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("I", "upper-roman");
            else
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type");
        },
        _getCssXhtml: function (tagReg, styleDup) {
            var styleRegval = tagReg.exec(styleDup);
            if (!ej.isNullOrUndefined(styleRegval)) {
                var styleTag = styleRegval[0];
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("valign", "text-align").replace("align", "text-align");
                styleDup = styleDup.replace(styleRegval[0], "style=\"" + styleTag + ";\"");
            }
            return styleDup;
        },
        _styleXhtml: function (styleVal) {
            var styleRegex = /<((?:(?!\/)).)*?>/ig;
            var styleTemp;
            var k = 0;
            var styleDup = new Array();
            var arr = new Array();
            while ((styleTemp = styleRegex.exec(styleVal)) !== null) {
                styleDup.push(styleTemp[0].toString());
            }
            var styleEx = new Array();
            styleEx = styleDup.slice(0);
            for (var i = 0; i < styleDup.length; i++) {
                if (styleDup[i].indexOf("style=") != -1) {
                    if (styleDup[i].indexOf("height=") != -1) {
                        var htmlTagreg = /( height)=("[^"]*")/i;
                        styleDup[i] = this._replaceHeightWidth(htmlTagreg, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("width=") != -1) {
                        var widthTag = /( width)=("[^"]*")/i;
                        styleDup[i] = this._replaceHeightWidth(widthTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("type=") != -1) {
                        var typeTag = /( type)=("[^"]*")/i;
                        var styleRegval = typeTag.exec(styleDup[i]);
                        if (!ej.isNullOrUndefined(styleRegval))
                            var styleTag = this._typeXhtmlValidation(styleDup[i]);
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                    if (styleDup[i].indexOf("valign=") != -1) {
                        var valignTag = /( valign)=("[^"]*")/i;
                        var styleRegval = valignTag.exec(styleDup[i]);
                        var styleTag = styleRegval[0];
                        if (styleDup[i].indexOf("vertical-align:") != -1)
                            styleTag = "";
                        else
                            styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("valign", "vertical-align");
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                    if (styleDup[i].indexOf("align=") != -1) {
                        var alignTag = /( align)=("[^"]*")/i;
                        var styleRegval = alignTag.exec(styleDup[i]);
                        if (!ej.isNullOrUndefined(styleRegval)) {
                            var styleTag = styleRegval[0];
                            if (styleDup[i].indexOf("text-align:") != -1)
                                styleTag = "";
                            else
                                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("align", "text-align");
                        }
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                }
                if (styleDup[i].indexOf("style=") == -1) {
                    if (styleDup[i].indexOf("height=") != -1) {
                        var htmlTagreg = /(height)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(htmlTagreg, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("width=") != -1) {
                        var widthTag = /(width)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(widthTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("type=") != -1) {
                        var typeTag = /( type)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(typeTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("valign=") != -1) {
                        var valignTag = /(valign)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(valignTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("align=") != -1) {
                        var alignTag = /(align)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(alignTag, styleDup[i]);
                    }
                }
            }
            for (var i = 0; i < styleDup.length; i++) {
                styleVal = styleVal.replace(styleEx[i], styleDup[i]);
            }
            return styleVal;
        },
        _getFormatXhtml: function (startRegex, startVal) {
            var startDup = new Array();
            var j = 0;
            var startTemp;
            while ((startTemp = startRegex.exec(startVal)) != null) {
                startDup.push(startTemp[0]);
            }
            for (var i = 0; i < startDup.length; i++) {
                startVal = startVal.replace(startDup[i], "");
            }
        },
        _startXhtml: function (startVal) {
            if (startVal.indexOf("start=") != -1) {
                var startRegex = /start=\"(.*?)\"/ig;
                startVal = this._getFormatXhtml(startRegex, startVal);
            }
            return startVal;
        },
        _fontXhtml: function (fontVal) {
            if (fontVal.indexOf("<font") != -1) {
                var fontRegex = /<font(.*?)>/ig;
                fontVal = this._getFormatXhtml(fontRegex, fontVal);
            }
            return fontVal;
        },
        _filerXhtmlNode: function (tableRegex, xhtmlVal) {
            var dupArray = new Array();
            var tableTemp;
            while ((tableTemp = tableRegex.exec(xhtmlVal)) != null) {
                dupArray.push(tableTemp[0]);
            }
            return dupArray;
        },
        _replaceXhtmlNode: function (tableDup, xhtmlVal, tableEx) {
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableEx[i], tableDup[i]);
            }
            return xhtmlVal;
        },
        _tdXhtml: function (xhtmlVal) {
            var tableRegex = /<td((?:(?!<\/td>).))*?<td/ig;
            var tableDup = new Array();
            tableDup = this._filerXhtmlNode(tableRegex, xhtmlVal);
            var tableEx = new Array();
            tableEx = tableDup.slice(0);
            for (var i = 0; i < tableDup.length; i++) {
                var z = tableDup[i].lastIndexOf("<td");
                tableDup[i] = tableDup[i].substr(0, z) + "</td>" + tableDup[i].substr(z, tableDup[i].length);
            }
            xhtmlVal = this._replaceXhtmlNode(tableDup, xhtmlVal, tableEx);
            return xhtmlVal;
        },
        _ptagXhtml: function (htmlText) {
            var ptagRegex1 = /<\/p>((?:(?!<p).))*<\/p>/ig;
            var pTemp1;
            var pEx = new Array();
            if ((pTemp1 = ptagRegex1.exec(htmlText)) != null) {
                while ((pTemp1 = ptagRegex1.exec(htmlText)) != null) {
                    pEx.push(pTemp1[0]);
                }
            }
            var ptagEx = new Array();
            ptagEx = pEx.slice(0);
            for (var i = 0; i < pEx.length; i++) {
                if (pEx[i].indexOf("<p") == -1)
                    pEx[i] = pEx[i].substr(0, pEx[i].length - 4);
            }
            for (var i = 0; i < pEx.length; i++) {
                htmlText = htmlText.replace(ptagEx[i], pEx[i]);
            }
            return htmlText;
        },
        _getUpdaeNodeXhtml: function (tableRegex, xhtmlVal, tableDup) {
            var tableTemp;
            while ((tableTemp = tableRegex.exec(xhtmlVal)) != null) {
                tableDup.push(tableTemp[0]);
            }
            return tableDup;
        },
        _replaceUpdateXhtml: function (tableRegex, xhtmlVal, value) {
            var tableDup = new Array();
            tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableDup[i], value);
            }
            return xhtmlVal;
        },
        _replaceXhtmlVal: function (tableDup, xhtmlVal, tableEx) {
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableEx[i], tableDup[i]);
            }
            return xhtmlVal;
        },
        _replaceTagUpdateXhtml: function (tagRegex, xhtmlVal, value1, value2) {
            var tempArray = new Array();
            tempArray = this._getUpdaeNodeXhtml(tagRegex, xhtmlVal, tempArray);
            var tempEx = new Array();
            tempEx = tempArray.slice(0);
            tempArray[0] = value1 + tempArray[0] + value2;
            return xhtmlVal.replace(tempEx[0], tempArray[0]);
        },
        _replaceTagXHTML: function (styleRegex, xhtmlVal) {
            var styleDup = new Array();
            styleDup = this._getUpdaeNodeXhtml(styleRegex, xhtmlVal, styleDup);
            var styleEx = new Array();
            styleEx = styleDup.slice(0);
            for (var i = 0; i < styleDup.length; i++) {
                styleDup[i] = styleDup[i].replace(/<br\/>/gi, "");
            }
            return this._replaceXhtmlVal(styleDup, xhtmlVal, styleEx);
        },
        _replaceInputParams: function (inputRegex, xhtmlVal) {
            var tableDup = new Array();
            tableDup = this._getUpdaeNodeXhtml(inputRegex, xhtmlVal, tableDup);
            var tableEx = new Array();
            tableEx = tableDup.slice(0);
            for (var i = 0; i < tableDup.length; i++) {
                var divInndex = tableDup[i].indexOf(">");
                tableDup[i] = tableDup[i].substr(0, divInndex) + "/" + tableDup[i].substr(divInndex, tableDup[i].length - 1);
            }
            return this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
        },
        _updateXhtml: function () {
            var updateVal = this._getDocument().body.innerHTML;
            if (this.model.enableXHTML) {
                updateVal = updateVal.replace(/hhh/g, "").replace(/<br>/g, "<br/>").replace(/contenteditable="false"/g, "").replace(/contenteditable="true"/g, "").replace(/&nbsp;/g, " ").replace(/<hr>/g, "<hr/>").replace(/cellspacing =[0-9]/g, "").replace(/cellpadding  =[0-9]/g, "");
                this.value(updateVal);
                this._xhtmlTagValidation();
                updateVal = this.value();
                var xhtmlVal = updateVal.replace(/\s+/g, ' ').replace(/> </gi, "><");
                if (xhtmlVal.indexOf("<?xml") != -1) {
                    var xmlRegexp = /<?xml:(.*?)>/ig;
                    var xmlDup = new Array();
                    var k = 0;
                    while ((xmlTemp = xmlRegexp.exec(xhtmlVal)) != null) {
                        var j = xhtmlVal.indexOf("<?xml");
                        xmlDup[k] = xmlTemp[0];
                        xmlDup[k] = xhtmlVal.substr(j, xmlDup[k].length + 2);
                        xhtmlVal = xhtmlVal.replace(xmlDup[k], "");
                        k++;
                    }
                }
                if (xhtmlVal.indexOf("<table") != -1) {
                    //tabletag
                    var tableRegex = /<table(.*?)<\/table>/ig;
                    var tableDup = new Array();
                    tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
                    var tableEx = new Array();
                    tableEx = tableDup.slice(0);
                    for (var i = 0; i < tableDup.length; i++) {
                        tableDup[i] = tableDup[i].replace(/<p>/gi, "").replace(/<\/p>/gi, "");
                        if (tableDup[i].indexOf("<p") != -1) {
                            for (var k = 0; k < tableDup[i].length; k++) {
                                var divInndex = tableDup[i].indexOf("<p");
                                var t = 0;
                                if (divInndex != -1) {
                                    for (var j = divInndex + 4; j < tableDup[i].length - 7; j++) {
                                        if (tableDup[i].charAt(j) == '>') {
                                            if (t == 0) {
                                                tableDup[i] = tableDup[i].substr(0, divInndex) + tableDup[i].substr(j + 1, tableDup[i].length - 1);
                                                t++;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
                }
                //td tag
                if (xhtmlVal.indexOf("<td") != -1) {
                    for (var i = 0; i < 2; i++) {
                        xhtmlVal = this._tdXhtml(xhtmlVal);
                    }
                }
                //tr tag
                if (xhtmlVal.indexOf("<tr") != -1) {
                    var trtdRegex = /<tr(.*?)>(?!<\/td>)/ig;
                    var tabletrDup = new Array();
                    tabletrDup = this._getUpdaeNodeXhtml(trtdRegex, xhtmlVal, tabletrDup);
                    var tabletrEx = new Array();
                    tabletrEx = tabletrDup.slice(0);
                    for (var i = 0; i < tabletrDup.length; i++) {
                        if (tabletrDup[i].indexOf("</td>") != -1)
                            tabletrDup[i] = tabletrDup[i].replace("</td>", "");
                    }
                    xhtmlVal = this._replaceXhtmlVal(tabletrDup, xhtmlVal, tabletrEx);
                    var tableRegex = /<tr(.*?)<\/tr>/ig;
                    var tableDup = new Array();
                    tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
                    var tableEx = new Array();
                    tableEx = tableDup.slice(0);
                    for (var i = 0; i < tableDup.length; i++) {
                        var z = tableDup[i].lastIndexOf("</tr>");
                        var w = tableDup[i].charAt(z - 5) + tableDup[i].charAt(z - 4) + tableDup[i].charAt(z - 3) + tableDup[i].charAt(z - 2) + tableDup[i].charAt(z - 1);
                        if (w != "</td>") {
                            tableDup[i] = tableDup[i].substr(0, z) + "</td>" + tableDup[i].substr(z, tableDup[i].length);
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
                }
                //input tag
                if (xhtmlVal.indexOf("<input") != -1) {
                    var inputRegex = /<input((?:(?!\/).))*?>/ig;
                    xhtmlVal = this._replaceInputParams(inputRegex, xhtmlVal);
                    xhtmlVal = xhtmlVal.replace(/<\/input>/gi, "");
                }
                if (xhtmlVal.indexOf("<param") != -1) {
                    var inputRegex = /<param((?:(?!\/).))*?>/ig;
                    xhtmlVal = this._replaceInputParams(inputRegex, xhtmlVal);
                    xhtmlVal = xhtmlVal.replace(/<\/param>/gi, "");
                }
                if (xhtmlVal.indexOf("<p ") != -1 || xhtmlVal.indexOf("<p>") != -1) {
                    var ptagRegex = /<p(.*)<\/p>/ig;
                    var pDup = new Array();
                    pDup = this._getUpdaeNodeXhtml(ptagRegex, xhtmlVal, pDup);
                    var pEx = new Array();
                    pEx.slice(0);
                    var r = pDup[0].length - 1;
                    var htmlText = pDup[0];
                    if (htmlText.indexOf("<p") != -1) {
                        for (var m = htmlText.indexOf("<p") ; m <= r; m++) {
                            var z = "";
                            var i = 0;
                            if (m < r - 3) {
                                z = htmlText.charAt(m) + htmlText.charAt(m + 1);
                            }
                            if (z == "<p") {
                                for (var s = m + 1; s <= r; s++) {
                                    var w;
                                    if ((w = htmlText.charAt(s) + htmlText.charAt(s + 1) + htmlText.charAt(s + 2) + htmlText.charAt(s + 3)) == "</p>") {
                                        i++;
                                    }
                                    if ((w = htmlText.charAt(s) + htmlText.charAt(s + 1)) == "<p") {
                                        if (i == 0) {
                                            if (htmlText.indexOf("<div") != -1) {
                                                var divSplit = htmlText.substr(m, s - m);
                                                if (divSplit.indexOf("<div") != -1) {
                                                    var divIn = divSplit.indexOf("<div");
                                                    var q = 0;
                                                    var u;
                                                    for (var l = m + divIn + 1; l < htmlText.length - 1; l++) {
                                                        var z = htmlText.charAt(l) + htmlText.charAt(l + 1) + htmlText.charAt(l + 2) + htmlText.charAt(l + 3) + htmlText.charAt(l + 4) + htmlText.charAt(l + 5);
                                                        if (z == "</div>")
                                                            if (q == 0) {
                                                                u = l;
                                                            }
                                                    }
                                                    htmlText = htmlText.substr(0, m + divIn) + "</span></p>" + htmlText.substr(m + divIn, ((-(m + divIn) + u) + 6)) + "<p><span>" + htmlText.substr(u + 6, htmlText.length - 1);
                                                    i++;
                                                }
                                            }
                                        }
                                        if (i == 0) {
                                            if (htmlText.indexOf("<table") != -1) {
                                                var divSplit = htmlText.substr(m, s - m);
                                                if (divSplit.indexOf("<table") != -1) {
                                                    var divIn = divSplit.indexOf("<table");
                                                    var q = 0;
                                                    var u;
                                                    for (var l = m + divIn + 1; l < htmlText.length - 1; l++) {
                                                        var z = htmlText.charAt(l) + htmlText.charAt(l + 1) + htmlText.charAt(l + 2) + htmlText.charAt(l + 3) + htmlText.charAt(l + 4) + htmlText.charAt(l + 5) + htmlText.charAt(l + 6) + htmlText.charAt(l + 7);
                                                        if (z == "</table>")
                                                            if (q == 0) {
                                                                u = l;
                                                            }
                                                    }
                                                    htmlText = htmlText.substr(0, m + divIn) + "</span></p>" + htmlText.substr(m + divIn, ((-(m + divIn) + u) + 8)) + "<p><span>" + htmlText.substr(u + 8, htmlText.length - 1);
                                                    i++;
                                                }
                                            }
                                            if (i == 0) {
                                                htmlText = htmlText.substr(0, s - 1) + "</p>" + htmlText.substr(s, htmlText.length - 1);
                                                r++;
                                                i++;
                                            }
                                        }
                                    }

                                }
                            }
                        }
                    }
                    htmlText = htmlText.replace(/<\/p><\/p>/gi, "</p>");
                    var pDupex = new Array();
                    pDupex = pDup.slice(0);
                    for (var i = 0; i < 2; i++) {
                        htmlText = this._ptagXhtml(htmlText);
                    }
                    var htmlRegex = /<p(.*?)<\/p>/ig;
                    var htmlDup = new Array();
                    htmlDup = this._getUpdaeNodeXhtml(htmlRegex, htmlText, htmlDup);
                    var htmlEx = new Array();
                    htmlEx.slice(0);
                    for (var j = 0; j < htmlDup.length; j++) {
                        if (htmlDup[j].indexOf("<table") != -1) {
                            var tagRegex = /<table(.*)<\/table>/ig;
                            htmlDup[j] = this._replaceTagUpdateXhtml(tagRegex, htmlDup[j], "</span></p>", "<p><span>");
                        }
                        if (htmlDup[j].indexOf("<div") != -1) {
                            var tagRegex = /<div(.*)<\/div>/ig;
                            htmlDup[j] = this._replaceTagUpdateXhtml(tagRegex, htmlDup[j], "</span></p>", "<p><span>");
                        }
                    }
                    htmlText = this._replaceXhtmlVal(htmlDup, htmlText, htmlEx);
                    xhtmlVal = xhtmlVal.replace(pEx[0], htmlText);
                }
                if (xhtmlVal.indexOf("<span") != -1) {
                    var spanRegex = /<span(.*?)<\/span>/ig;
                    //var spanTemp;                    
                    var spanDup = new Array();
                    spanDup = this._getUpdaeNodeXhtml(spanRegex, xhtmlVal, spanDup);
                    var spanEx = new Array();
                    sapnEX = spanDup.slice(0);
                    for (var j = 0; j < spanDup.length; j++) {
                        if (spanDup[j].indexOf("<table") != -1) {
                            var tagRegex = /<table(.*)<\/table>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                        if (spanDup[j].indexOf("<div") != -1) {
                            var tagRegex = /<div(.*)<\/div>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                        if (spanDup[j].indexOf("<p") != -1) {
                            var tagRegex = /<p(.*)<\/p>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(spanDup, xhtmlVal, spanEx);
                }
                if (xhtmlVal.indexOf("<ol") != -1) {
                    var styleRegex = /<ol(.*?)<\/ol>/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                if (xhtmlVal.indexOf("<table") != -1) {
                    var styleRegex = /<table(.*?)><\/table>/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                if (xhtmlVal.indexOf("style") != -1) {
                    var styleRegex = /style="(.*?)"/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                //style tag 
                if (!ej.isNullOrUndefined(this._fontXhtml(xhtmlVal)))
                    xhtmlVal = this._fontXhtml(xhtmlVal);
                if (xhtmlVal.indexOf("<br ") != -1 || xhtmlVal.indexOf("<br>") != -1) {
                    var htmlTagreg = /<br(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<br/>");
                }
                if (xhtmlVal.indexOf("<strong ") != -1 || xhtmlVal.indexOf("<strong>") != -1) {
                    var htmlTagreg = /<strong((?:(?!r).))*?>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<b>").replace(/<\/strong>/gi, "</b>");
                }
                if (xhtmlVal.indexOf("<strong ") != -1) {
                    var htmlTagreg = /<strong (.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<b>").replace(/<\/strong>/gi, "</b>");
                }
                if (xhtmlVal.indexOf("<u") != -1) {
                    var htmlTagreg = /<u((?:(?!l).))*?>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<span style=\"text-decoration: underline;\">").replace(/<\/u>/gi, "</span>");
                }
                if (xhtmlVal.indexOf("<hr") != -1) {
                    var htmlTagreg = /<hr(.*?)>/ig;
                    var htmlTagtemp = new Array();
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<hr/>");
                }
                if (!ej.isNullOrUndefined(this._startXhtml(xhtmlVal)))
                    xhtmlVal = this._startXhtml(xhtmlVal);
                if (xhtmlVal.indexOf("v:shapes=") != -1) {
                    var htmlTagreg = /v:shapes=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("v:") != -1) {
                    var htmlTagreg = /<v:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("/v:") != -1) {
                    var htmlTagreg = /<\/v:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("o:") != -1) {
                    var htmlTagreg = /<o:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("/o:") != -1) {
                    var htmlTagreg = /<\/o:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("role=") != -1) {
                    var htmlTagreg = /role=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("target=") != -1) {
                    var htmlTagreg = /target=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("language=") != -1) {
                    var htmlTagreg = /language=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("lang=") != -1) {
                    var htmlTagreg = /lang=\"(.*?)\"/ig;
					var htmlTagtemp = new Array();
                    htmlTagtemp = this._getUpdaeNodeXhtml(htmlTagreg, xhtmlVal, htmlTagtemp);
                    var height3 = new Array();
                    height3 = htmlTagtemp.slice(0);
                    for (var i = 0; i < htmlTagtemp.length; i++) {
                        xhtmlVal = xhtmlVal.replace(height3[i], htmlTagtemp[i].toLowerCase());
                    }
                }
                xhtmlVal = xhtmlVal.replace(/<\/td><\/td>/gi, "</td>").replace(/<\/th><\/td>/gi, "</th>");
                xhtmlVal = (xhtmlVal == "" || /<div class="e-xhtml">/ig.test(xhtmlVal) ) ? xhtmlVal : "<div class='e-xhtml'>" + xhtmlVal + "</div>";
                updateVal = xhtmlVal.replace(/&quot;/g, "'").replace(/cellspacing=("[0-9]")/g, '').replace(/cellSpacing=("[0-9]")/g, '').replace(/cellpadding=("[0-9]")/g, '').replace(/cellPadding=("[0-9]")/g, '').replace(/border=("[^"]")/g, '').replace(/<!--(.*?)-->/gm, '').replace(/(vAlign)=("[^"]*")/g, "").replace(/(valign)=("[^"]*")/g, "").replace(/(colspan)=("[^"]*")/g, "").replace(/(colSpan)=("[^"]*")/g, "");
                this.value(updateVal);
            }
            return updateVal;
        },
        _setClearFormat: function () {
            var selItemslength = this._rteToolbar.find(".e-active").length;
        },
        //Updates the status of the toolbar items
        _updateToolbarStatus: function () {
            try {
                var _isAligned = false;
                if (this.model.showToolbar) {
                    //Style Tools
                    for (var i = 0; i < this._styleItems.length; i++) {
                        var rtestyleid= document.getElementById(this._rteId + "_" + this._styleItems[i]);
                        if (this._getCommandStatus($.trim(this._styleItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._styleItems[i]);
                             rtestyleid.classList.add("e-isactive");
                        } else {
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._styleItems[i]);
                            rtestyleid.classList.remove("e-isactive");
                        }  
                        } 
                    for (var i = 0; i < this._alignItems.length; i++) {
                        if (this._getCommandStatus($.trim(this._alignItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._alignItems[i]);
                            _isAligned = true;
                        } else
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._alignItems[i]); 
                } 
                    if (!_isAligned) this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft"); 
                    for (var i = 0; i < this._scriptsItems.length; i++) {
                         var rtescriptid= document.getElementById(this._rteId + "_" + this._scriptsItems[i]);
                         if (this._getCommandStatus($.trim(this._scriptsItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._scriptsItems[i]);
                             rtescriptid.classList.add("e-isactive");
                        } else {
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._scriptsItems[i]);
                           rtescriptid.classList.remove("e-isactive");
                        }
                    } 
                     var rteorderid=document.getElementById(this._rteId + "_" + "orderedList"); 
                    var rteunorderid= document.getElementById(this._rteId + "_" + "unorderedList");
                    if (this._getCommandStatus('InsertOrderedList')) {
                        this._toolBarObj.selectItemByID(this._rteId + "_" + "orderedList");
                        rteorderid.classList.add("e-isactive");
                    } else {
                        this._toolBarObj.deselectItemByID(this._rteId + "_" + "orderedList");
                        rteorderid.classList.remove("e-isactive");
                    } if (this._getCommandStatus('InsertUnorderedList')) {
                        this._toolBarObj.selectItemByID(this._rteId + "_" + "unorderedList");
                        rteunorderid.classList.add("e-isactive");
                    } else {
                        this._toolBarObj.deselectItemByID(this._rteId + "_" + "unorderedList");
                        rteunorderid.classList.remove("e-isactive");
                    }
                
                   this._updateIndentStatus(); 
                }
            }
            catch (error) { }
        },

        _updateFormat: function () {
            try {
                if (this._formatDDL && this.model.showToolbar && !ej.isNullOrUndefined(this.model.tools["formatStyle"])) {
                    var formatName = $.trim(this._getCommandValue('formatblock').replace(/'/g, ""));
                    if (!this._isIE())
                        formatName = "<" + formatName + ">"; 
                    if (this._formatDDL.hasClass('e-dropdownlist')) {
                        if (ej.isNullOrUndefined(formatName) || formatName == "")
                            this._formatDDL.ejDropDownList({ "value": this._getLocalizedLabels("format") });
                        else if (!$(this._formatDDL).parents("ul.e-rte-format").length == 0)
                            this._formatDDL.ejDropDownList("setSelectedValue", formatName);
                    }
                }
            }
            catch (error) { }
        },

        _updateFontOptionStatus: function () {
            try {
                if (this.model.showFontOption && this.model.showToolbar && !ej.isNullOrUndefined(this.model.tools["font"])) {
                    var fontName = $.trim(this._getCommandValue('fontname').replace(/"/g, "").replace(/'/g, "").replace(/, /g, ","));
                    (ej.isNullOrUndefined(fontName) || fontName == "") && (fontName = "Segoe UI");
                    if (!ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.hasClass('e-dropdownlist') && !$(this._fontStyleDDL).parents("ul.e-rte-fontgroup").length == 0)
                        this._fontStyleDDL.ejDropDownList("setSelectedValue", fontName);

                    var fontSize = (this._isIE8()) ? this._getCommandValue('fontsize') : (this._getDocumentHandler() && this._operationHandler._validateFontSize(this._getRange().startContainer));
                    (ej.isNullOrUndefined(fontSize) || fontSize == "") && (fontSize = 2);
                    if (!ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.hasClass('e-dropdownlist') && !$(this._fontSizeDDL).parents("ul.e-rte-fontgroup").length == 0)
                        this._fontSizeDDL.ejDropDownList("setSelectedValue", fontSize);
                }
            }
            catch (error) { }
        },

        _getSelText: function () {
            var selectedtext = '';
            var selection;
            var textnode;
            if (!this._isIE()) {
                if (window.getSelection) {
                    selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    textnode = document.createTextNode(range.toString());
                    selectedtext = textnode.nodeValue;
                }
                else if (document.getSelection) {
                    selectedtext = this._getWindow().document.getSelection();
                }
            }
            else
                selectedtext = this._seleText;
            return selectedtext;
        },

        _isIE: function () {
            var _ie = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie') {
                _ie = true;
            }
            return _ie;
        },

        _isIE8: function () {
            var _ie8 = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == "8.0") {
                _ie8 = true;
            }
            return _ie8;
        },
        //Vaidate the input URL string
        _isUrl: function (url) {
            var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
            return regexp.test(url);
        },
        _pasteHtml: function (html, textnodeType) {
            var sel, range;
            if (this._pasteAPIFlag) {
                if (this._isIE())
                    this._focus();
            }
            else
                this._focus();
            if (window.getSelection) {
                // IE9 and non-IE
                sel = this._getWindow().getSelection();
                if (sel.getRangeAt && sel.rangeCount) {
                    range = this._pasteFlag ? this._pasteRangeVal : sel.getRangeAt(0);
                    var cnode = range.commonAncestorContainer, parentElement, i, container;
                    parentElement = cnode.nodeType == 3 ? $(cnode).parentsUntil("body") : $(cnode).children();
                    for (i = parentElement.length - 1; i >= 0; i--) {
                        if (parentElement[i].textContent == range.toString() && parentElement[i].nodeName.toLowerCase() != "li") {
                            range.selectNode(parentElement[i]);
                            break;
                        }
                    }
                    range.deleteContents();
                    // some browsers (IE9, for one)
                    var el = document.createElement("div");
                    el.innerHTML = html;
                    var frag = this._getDocument().createDocumentFragment(), node, lastNode;
                    var parent = el.firstChild;
                    if (!(this._pasteFlag || this._pasteAPIFlag)) {
                        while ((node = el.firstChild)) {
                            lastNode = frag.appendChild(node);
                        }
                    }
                    else {
                        while ((node = el.firstChild)) {
                            if (parent != node)
                                lastNode = parent.appendChild(node);
                            else
                                el.removeChild(el.firstChild);
                        }
                        lastNode = frag.appendChild(parent);
                    }
                    range.insertNode(frag);
                    // Preserve the selection
                    if (lastNode && !textnodeType) {
                        range = range.cloneRange();
                        range.setStartAfter(lastNode);
                        range.collapse(true);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                    else {
                        range = this.createRange();
                        range.setStart(lastNode, lastNode.data.length);
                        range.setEnd(lastNode, lastNode.data.length);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                }
            } else if (this._getDocument().selection && this._getDocument().selection.type != "Control") {
                // IE < 9
                if (this._ieSelectionRange && !(this._ieSelectionRange.offsetLeft == 0 && this._ieSelectionRange.offsetTop == 0 && this._ieSelectionRange.boundingHeight == 0)) {
                    if (this._pasteFlag)
                        this.selectRange(this._pasteRangeVal);
                    var ieParentElement = this._ieParents(this._getRange()), i, isParent = false;
                    if (this._pasteAPIFlag)
                        this._getRange().pasteHTML(html);
                    else {
                        var text = this._getRange().text;
                        for (i = ieParentElement.length - 1; i >= 0; i--) {
                            if (ieParentElement[i].innerText == text && ieParentElement[i].nodeName.toLowerCase() != "li") {
                                ieParentElement[i].nodeName == "BODY" ? ieParentElement[i].innerHTML = html : ieParentElement[i].outerHTML = html;
                                isParent = true;
                                break;
                            }
                        }
                        if (!isParent)
                            this._getRange().pasteHTML(html);
                    }
                }
                else
                    this._getDocument().body.insertAdjacentHTML("afterBegin", html);
            }
            this._pasteAPIFlag = this._pasteFlag = false;
        },
        _ieParents: function (range) {
            var parentElement = [];
            rangeval = this._isIE8() ? range.duplicate() : range.cloneRange();
            range.parentElement = rangeval.parentElement();
            while (range.parentElement.nodeName != "HTML") {
                if (range.parentElement.nodeName == "TD" || range.parentElement.nodeName == "TH")
                    break;
                parentElement.push(range.parentElement);
                range = range.parentElement;
            }
            return parentElement;
        },

        _getLocalizedLabels: function (property) {
			return this._localizedLabels[property] === undefined ? ej.RTE.Locale["en-US"][property] : this._localizedLabels[property];
        },


        _getSelectedNode: function () {
            var temp = this._getRange();
            var element, rng = (this._ieSelectionRange && temp.offsetLeft == 0 && temp.offsetTop == 0 && temp.boundingHeight == 0) ? this._ieSelectionRange : temp;
            var startContainer = rng.startContainer, endContainer = rng.endContainer;
            var startOffset = rng.startOffset, endOffset = rng.endOffset;
            // if (!ej.isNullOrUndefined(rng.commonAncestorContainer))
            // if (rng.commonAncestorContainer.nodeName == "BODY")
            // this._tempEle = $(rng.commonAncestorContainer);
            // else if ($(rng.cloneContents()).text() == $($($(rng.startContainer).parents("li")).contents()[0]).text() && (startOffset == 0 && endOffset == $(rng.startContainer).parents("li").text().length) || startOffset == endOffset || startOffset == 0 && endOffset == 1)
            // this._tempEle = $($(rng.startContainer).parents("li"));
            // else if ((rng.commonAncestorContainer.nodeName == "OL") && startOffset != endOffset && endOffset != 0 && endOffset != 1)
            // this._tempEle = $(rng.commonAncestorContainer);
            // else
            // this._tempEle = $(rng.startContainer);
            if (!rng) {
                return this._getDocument().selection;
            }
            if (rng.setStart) {
                element = rng.commonAncestorContainer;
                //Image tage and link selection
                if (!rng.collapsed) {
                    if (startContainer == endContainer) {
                        if (endOffset - startOffset < 2) {
                            if (startContainer.hasChildNodes()) {
                                element = startContainer.childNodes[startOffset];
                            }
                        }
                    }
                    if (startContainer.nodeType === 3 && endContainer.nodeType === 3) {
                        if (startContainer.length === startOffset) {
                            startContainer = this._skipEmptyNode(startContainer.nextSibling, true);
                        } else {
                            startContainer = startContainer.parentNode;
                        }

                        if (endOffset === 0) {
                            endContainer = this._skipEmptyNode(endContainer.previousSibling, false);
                        } else {
                            endContainer = endContainer.parentNode;
                        }

                        if (startContainer && startContainer === endContainer) {
                            return startContainer;
                        }
                    }
                }

                if (element && element.nodeType == 3) {
                    return element.parentNode;
                }
                return element;
            }
            element = rng.item ? rng.item(0) : rng.parentElement();
            return element;
        },

        _skipEmptyNode: function (node, forwards) {
            var orig = node;
            while (node && node.nodeType === 3 && node.length === 0) {
                node = forwards ? node.nextSibling : node.previousSibling;
            }
            return node || orig;
        },

        _getSelection: function () {
            var selCurrent;
            if (this._isIE()) {
                selCurrent = this._getDocument().selection.createRange();
                selCurrent.type = this._getDocument().selection.type;
            }
            else {
                selCurrent = window.getSelection();
                if (selCurrent.rangeCount) {
                    sText = selCurrent.getRangeAt(0);
                }
                selCurrent.type = this._getWindow().getSelection().type;
            }
            return selCurrent;
        },

        _saveSelection: function () {
            var win = this._getWindow();
            var doc = win.document;
            var sel = win.getSelection ? win.getSelection() : doc.selection;
            var range;

            if (sel) {
                if (sel.createRange) {
                    range = sel.createRange();
                } else if (sel.rangeCount > 0 && sel.getRangeAt(0)) {
                    range = sel.getRangeAt(0);
                } else if (sel.anchorNode && sel.focusNode && doc.createRange) {
                    // Older WebKit browsers
                    range = doc.createRange();
                    range.setStart(sel.anchorNode, sel.anchorOffset);
                    range.setEnd(sel.focusNode, sel.focusOffset);
                    if (range.collapsed !== sel.isCollapsed) {
                        range.setStart(sel.focusNode, sel.focusOffset);
                        range.setEnd(sel.anchorNode, sel.anchorOffset);
                    }
                }
                else if (doc.createRange()) {
                    range = doc.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
                else {
                    var iframe = document.getElementsByTagName("iframe")[0];
                    var win = iframe.contentWindow;
                    range = win.document.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
            }
            return range;
        },

        _restoreSelection: function (range) {
            var win = this._getWindow();
            var doc = win.document;
            var sel = win.getSelection ? win.getSelection() : doc.selection;
            if (sel && range) {
                if (range.select) {
                    range.select();
                } else if (sel.removeAllRanges && sel.addRange) {
                    sel.removeAllRanges();
                    sel.addRange(range);
                }
            }
        },

        _getRange: function () {
            if (this._isIE8()) {
                var temp = this._saveSelection();
                var rng = (this._ieSelectionRange && temp.offsetLeft == 0 && temp.offsetTop == 0 && temp.boundingHeight == 0) ? this._ieSelectionRange : temp;
                return rng;
            }
            else if (this._isIE())
                //Table Aciton Not working in IE condition (this._selectionRange.length>0)
                return this._ieSelection = (window.getSelection && (ej.isNullOrUndefined(this._selectionRange) ? false : (this._selectionRange.length > 0))) ? this._selectionRange : this._saveSelection();
            else if (this._getWindow().getSelection() && this._getWindow().getSelection().rangeCount > 0)
                return this._getWindow().getSelection().getRangeAt(0);
            else {
                var iframe = document.getElementsByTagName("iframe")[0];
                var win = iframe.contentWindow;
                var range
                try {
                    range = win.document.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
                catch (error) {
                    range = this._getDocument().createRange();
                    range.setStart(this._getDocument().body, 0);
                    range.setEnd(this._getDocument().body, 0);
                }
                return range;
            }
        },
        _setBackupData: function () {
            var htmlTxt = this.getHtml();
            var bkuplen = this._backupArray.length;
            if (bkuplen == this.model.undoStackLimit + 1)
                this._backupArray.splice(0, 1);
            if (htmlTxt != this._backupArray[bkuplen - 1] && this.model.undoStackLimit > 0)
                this._backupArray.push(htmlTxt);
            this._undoRedoPosition = this._backupArray.length - 1;
            if (this.model.showToolbar && this._rteToolbar.find("li.e-rteItem-undo") && this._backupArray.length > 1 && !$("#" + this._rteId + "_" + "undo").hasClass("e-rteTooldisable"))
                this._toolBarObj.enableItemByID(this._rteId + "_" + "undo");
        },
        _getSelectedHtmlString: function () {
            if (typeof document.selection != "undefined" && this._isIE8()) {
                var ieParentElement = this._ieParents(this._getRange()), i, isParent = false, html;
                for (i = ieParentElement.length - 1; i >= 0; i--) {
                    if (ieParentElement[i].innerText == this._getRange().text) {
                        html = ieParentElement[i].nodeName == "BODY" ? ieParentElement[i].innerHTML : ieParentElement[i].outerHTML;
                        isParent = true;
                        break;
                    }
                }
                if (!isParent)
                    html = this._getRange().htmlText.substring(0, 1) == "<" ? this._getRange().text : this._getRange().htmlText;
                return html;
            }
            else {
                var range = this._getRange(), cnode = range.commonAncestorContainer, parentElement, i, container;
                parentElement = cnode.nodeType == 3 ? $(cnode).parentsUntil("body") : $(cnode).children();
                for (i = parentElement.length - 1; i >= 0; i--) {
                    if (parentElement[i].textContent != "" && parentElement[i].textContent == range.toString()) {
                        range.selectNode(parentElement[i]);
                        break;
                    }
                }
                container = document.createElement("div");
                container.appendChild(range.cloneContents());
                return container.innerHTML;
            }
        },

        _getText: function () {
            var _body = this._getDocument().body;
            if (_body != null) {
                if (!this._isIE())
                    return _body.textContent;
                else
                    return _body.innerText;
            }
        },
        _validateMaxLength: function (e) {
            if (this.model.maxLength != null) {
                var len = this.model.maxLength;
                var usertext = this._getText();
                if (len <= usertext.length) {
                    if (!(e.keyCode < 47 || e.ctrlKey && e.keyCode == 65 || e.ctrlKey && e.keyCode == 67 || e.ctrlKey && e.keyCode == 86 || e.ctrlKey && e.keyCode == 88)) {
                        this._keypressFlag = false;
                        this._cancelEvent(e);
                    }
                }
            }
        },
        _cancelEvent: function (e) {
            e.returnValue = false;
            e.stopPropagation();
            e.preventDefault();
            return false;
        },

        _alignToolUpdate: function (name) {
            for (var i = 0; i < this._alignItems.length; i++) {
                if (this._alignItems[i] === name)
                    this._toolBarObj.selectItemByID(this._rteId + "_" + name);
                else
                    this._toolBarObj.deselectItemByID(this._rteId + "_" + this._alignItems[i]);
            }
        },


        _getCommandStatus: function (commandName) {
            var state = this._getDocument().queryCommandState(commandName);
            return state;
        },


        _getCommandValue: function (commandName) {
            var value = this._getDocument().queryCommandValue(commandName);
            if (this._isIE()) {
                if (commandName == "fontname") {
                    for (var i = 0; i < this.model.fontName.length; i++) {
                        if (value == this.model.fontName[i].text) {
                            value = this.model.fontName[i].value;
                            break;
                        }
                    }
                    if (ej.isNullOrUndefined(value) || value == "")
                        value = this.model.fontName[0].value;
                }
                if (commandName == "formatblock") {
                    for (var i = 2; i < this.model.format.length; i++) {
                        if (value == this.model.format[i].text) {
                            value = this.model.format[i].value;
                            break;
                        }
                    }
                    if (value == "Normal")
                        value = this.model.format[0].value;
                }
            }
            return value;
        },


        _undo: function () {
            if (this._undoRedoPosition > 0) {
                if (this.model.enableHtmlEncode)
                    this.setHtml(this._decode(this._backupArray[this._undoRedoPosition - 1]));
                else
                    this.setHtml(this._backupArray[this._undoRedoPosition - 1]);
                this._undoRedoPosition--;
                this._focus();
                this._updateFontOptionStatus();
                this._updateFormat();
                this._updateCount();
                this._toggleEditTable();
                if (this.model.isResponsive) this._toolBarObj._liTemplte.removeClass("e-display-none");
                this._toolBarObj.enableItemByID(this._rteId + "_" + "redo");
            }
            if (this._undoRedoPosition == 0) {
                this._toolBarObj.disableItemByID(this._rteId + "_" + "undo");
                this._toolBarObj.enableItemByID(this._rteId + "_" + "redo");
            }
            this._updateToolbarStatus();
            this._trigger("execute", { commandName: "undo" });
        },
        _getRedoContent: function () {
            if (this.model.enableHtmlEncode)
                return (this._decode(this._backupArray[this._undoRedoPosition + 1]));
            else
                return (this._backupArray[this._undoRedoPosition + 1]);
        },

        _redo: function () {
            if (this._undoRedoPosition != this._backupArray.length) {
                if (this._backupArray[this._undoRedoPosition + 1] != null) {
                    var _redoContent = this._getRedoContent();
                    this.setHtml(_redoContent)
                    this._undoRedoPosition++;
                }
                else {
                    var redoString = this._getRedoContent();
                    if (!ej.isNullOrUndefined(redoString)) this.setHtml(redoString);
                    this._undoRedoPosition = this._backupArray.length - 2;
                }
                this._focus();
                this._updateToolbarStatus();
                this._updateFontOptionStatus();
                this._updateFormat();
                this._updateCount();
                if (!ej.isNullOrUndefined(this._toolBarObj)) {
                    if (this._backupArray.length - 1 > 0)
                        this._toolBarObj.enableItemByID(this._rteId + "_" + "undo");
                    if (this._undoRedoPosition == this._backupArray.length - 1)
                        this._toolBarObj.disableItemByID(this._rteId + "_" + "redo");
                }
            }
            this._trigger("execute", { commandName: "redo" });
        },


        _setContent: function (htmltxt) {
            var editdoc = this._getDocument();
            if (editdoc != "" && !ej.isNullOrUndefined(editdoc)) {
                editdoc.open();
                editdoc.write(htmltxt);
                editdoc.close();
                editdoc.EditMode = true;
            }
        },
        _removeResizeObject: function () {
            $(this._getDocument()).find(".e-rteColumnResizer , .e-rteRowResizer , .e-rteLastcolumn").remove();
        },
        _tableMouseOver: function (e) {
            if (e.target.nodeName == "TABLE" || (ej.browserInfo().name === "mozilla" && e.target.nodeName == "TD")) {
                this._curTable = (e.target.nodeName == "TD") ? $(e.target).closest("table")[0] : e.target;
                this._removeResizeObject();
                $(this._getDocument()).find(".e-rte-tablebox").remove();
                this._tableResizeObject($(this._curTable));
            }
        },
        _preventDefaultResize: function () {
            var proxy = this._getDocument();
            (ej.browserInfo().name === "msie" && ej.browserInfo().version === "11.0") ? proxy.body.addEventListener('mscontrolselect', this._ieDefaultTableHandler) : (this._isIE()) && proxy.body.attachEvent('oncontrolselect', this._ieTableHandler);
            if (ej.browserInfo().name === "mozilla") {
                proxy.designMode = "on";
                proxy.execCommand("enableObjectResizing", false, "false");
                proxy.execCommand("enableInlineTableEditing", false, "false");
            }
        },
        _tableResizeObject: function (_tableEle) {
            if (this.model.allowEditing) this._preventDefaultResize();
            var cellspace = parseInt($(_tableEle).attr("cellspacing") ? $(_tableEle).attr("cellspacing") : 0);
            this._newcol = _tableEle.find("tr:first td").not(":first"), this._newRow = _tableEle.find("tr td:nth-child(1)"), this._newlas = _tableEle.find("tr:first td:last");
            for (var i = 0; this._newcol.length > i ; i++)
                $(this._getDocument().body).after("<div class =\"e-rteColumnResizer\"  unselectable=\"on\" contenteditable=\"false\" data-col =" + (i + 1) + " style=\"top:" + $(this._newcol[i]).closest("table").offset().top + "px;left:" + $(this._newcol[i]).offset().left + "px;height:" + $(this._newcol[i]).closest("table").outerHeight() + "px;width:" + (5 + cellspace) + "px;margin-left: " + (-4 - cellspace) + "px;\"></div>");
            for (var i = 0; this._newRow.length > i ; i++)
                $(this._getDocument().body).after("<div class =\"e-rteRowResizer\" unselectable=\"on\"  contenteditable=\"false\" data-row =" + (i) + " style=\"top:" + ($(this._newRow[i]).offset().top + $(this._newRow[i]).height()) + "px;left:" + $(this._newRow[i]).offset().left + "px;width:" + $(this._newRow[i]).closest("table").width() + "px;height:" + (5 + cellspace) + "px;\"></div>");
            $(this._getDocument().body).after("<div class =\"e-rteColumnResizer e-rtelastcol\" data-col =" + (this._newcol.length) + "  contenteditable=\"false\" style=\"top:" + $(this._newlas).closest("table").offset().top + "px;left:" + ($(this._newlas).offset().left + $(this._newlas).width()) + "px;height:" + $(this._newlas).closest("table").outerHeight() + "px;width:" + (5 + cellspace) + "px;margin-left:3px;\"></div>");
            this._botRigTab = ej.buildTag("span.e-rte-tablebox e-rte-botrig", "", { "cursor": "nwse-resize", "width": "5px", "height": "5px", "position": "absolute", "display": "block", "background": "#fff", "border": "1px solid #000" }, {});
            var tableBox = _tableEle.find("tr:last td:last:not(:has(>span.e-rte-tablebox))");
            if (tableBox.length > 0) $(this._getDocument().body).after($(this._botRigTab).css({ "left": ((parseInt(tableBox.closest("table").width())) + tableBox.closest("table").offset().left) + "px", "top": ((parseInt(tableBox.closest("table").height())) + tableBox.closest("table").offset().top) + "px" }));
        },
        _ieDefaultTableHandler: function (e) {
            e.preventDefault();
        },
        _ieTableHandler: function (e) {
            return false;
        },


        _tableCellStart: function (e) {
            this._tableInsertAt = this._saveSelection();
        },


        _tableCellSelect: function (e) {
            var cellEle, target = $(e.target);
            var row = target.parent().index();
            var col = target.index();
            this._createTable.find("div.e-rte-tablecell").each(function (index) {
                cellEle = $(this);
                if (cellEle.index() <= col && cellEle.parent().index() <= row) {
                    cellEle.addClass("e-active");
                }
                else {
                    cellEle.removeClass("e-active");
                }
            });
            this._tblheaderDiv.html((col + 1) + "x" + (row + 1) + this._getLocalizedLabels("table"));
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            if (!ej.isNullOrUndefined(this._tableInsertAt))
                this._restoreSelection(this._tableInsertAt);
        },
        _tableCellLeave: function (e) {
            this._createTable.find("div.e-rte-tablecell").removeClass("e-active");
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
        },
        _tableCellDown: function (e) {
            var target = $(e.target);
            var row = target.parent().index() + 1;
            var col = target.index() + 1;
            this._focus();
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            if (!ej.isNullOrUndefined(this._tableInsertAt)) {
                this._restoreSelection(this._tableInsertAt);
                this._onInsertTable(row, col, false);
            }
            var _tableEle = $(this._getDocument()).find("table.e-rte-table");
            //Content editable propert for table and td removed and key navigation support added in keydown           
            if (!this.model.enableRTL) this._on(_tableEle, "mouseover", this._tableMouseOver);
            this._createTable.ejDialog("close",{clickAction:true});
            this._setBackupData();
            this._onChange();
            if (this.model.isResponsive && !($(this._toolBarObj._liTemplte).hasClass("e-inline"))){
                this._toolBarObj._liTemplte.addClass("e-display-none");
                this._toolBarObj.contstatus = false;
            }
        },

        _tableGenerator: function (rows, cols, designTime, width, height, spacing, padding, align, border, caption) {
            var tblClass = "e-rte-table", colTemplate = "<td><br _moz_dirty=''/></td>";
            if (designTime)
                tblClass += " e-rte-tableremove";
            width = ej.isNullOrUndefined(width) || width == "" ? "width:99%;" : "width:" + width + ";";
            height = ej.isNullOrUndefined(height) || height == "" ? "" : "height:" + height + ";";
            spacing = ej.isNullOrUndefined(spacing) || spacing == "" ? "" : "cellspacing:" + spacing + ";";
            padding = ej.isNullOrUndefined(padding) || padding == "" ? "" : "cellpadding:" + padding + ";";
            align = ej.isNullOrUndefined(align) || align=="" ? "" : " float:" + align + ";";
            switch (border) {

                case "dotted": borderstyle = "dotted";
                    break;
                case "double":
                    this._border = "border:3px double #5C5C5C;";
                    borderstyle = "double";
                    return "<table border='1' class='" + tblClass + "' style='" + width + " " + height + " " + this._border + " " + spacing + " " + padding + " " + align + "' >" + (caption ? "<caption></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join("<td><br _moz_dirty=''/></td>") + "</tr>") + "</table>";
                    break;
                case "dashed": borderstyle = "dashed";
                    break;
                case "solid": borderstyle = "solid";
                    break;
                default: borderstyle = "solid";
                    break;
            }
            if (borderstyle != "double") {
                this._border = "border:1px " + borderstyle + "#5C5C5C;";
                return "<table border='1' class='" + tblClass + "' style='" + width + height + this._border + spacing + padding + align + "' >" + (caption ? "<caption><br type=\"_moz\"></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join("<td><br _moz_dirty=''/></td>") + "</tr>") + "</table>";
            }

            return "<table border='1' class='" + tblClass + "' style='border:1px solid #5C5C5C; " + width + height + spacing + padding + align + "' >" + (caption ? "<caption><br type=\"_moz\"></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join(colTemplate) + "</tr>") + "</table>";
        },

        _openCustomTable: function (e) {
            if (e.currentTarget.id == this._rteId + "_createCustomTableLink") {
                $("#" + this._rteId + "_customTable_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._customTableDialog.ejDialog("open");
                this._createTable.ejDialog("close");
                this._widthFocusOut();
            }
            else {
                if (!this._createTable.find("div.e-rte-eTblProperties").hasClass('e-disable')) {
                    this._eTblManager();
                    $("#" + this._rteId + "_eTbl_wrapper").css({ "z-index": this._onGetMaxZindex() });
                    this._eTblDialog.ejDialog("open");
                    this._createTable.ejDialog("close");
                    this._on(this._getTableObj("Width"), "focusout", this._widthFocusOut);
                    this._widthFocusOut();
                }
            }
        },
		_createcustomColorpalette:function(e)
		{
		    var proxy = $("#" + this._rteId).data("ejRTE");
			var palette=ej.buildTag("div.e-custom-palette");
		    this._customColor = ej.buildTag("div.e-rte-customColor#" + this._rteId + "_customColorDialog");
            var colorpalette= ej.buildTag("input.e-custom-palette#" + this._rteId + "customcolor");
            colorpalette.appendTo(this._customColor);
			this.colorobj=this._customColor.find(".e-custom-palette").ejColorPicker({ enableRTL: this.model.enableRTL,enableOpacity:true,showRecentColors:true,modelType: "picker",cssClass: this.model.cssClass,showSwitcher: false,select:function(args){ 
			
			   proxy._checkColor(args.value); 
			   
			 },
			
		    }).data("ejColorPicker");
            var model = this._getDialogModel();
            model.width = "auto";
		    model.height="auto";
			model.minWidth="220px";
		    model.htmlAttributes={"class":"e-custom-Dialog"}
            model.title = this._getLocalizedLabels("customFontColor");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._customColor.ejDialog(model);
	        this._customDialogobj=(this._customColor).ejDialog("instance");
            this._customColor.closest(".e-dialog-wrap").addClass("e-rte");
		    this.colorobj.popupContainer.appendTo(palette);
		    this.colorobj.popupContainer.css({"display":"block","border-style":"none"});
		    $("#"+this._rteId+"_customColorDialog").find("span.e-colorwidget.e-picker").remove();
		    $("#"+this._rteId+"_customColorDialog").prepend(palette);
		    this.colorobj._hidePopup=function () {
              if($("#"+this._rteId+"_customColorDialog").ejDialog("isOpen"))
			     $("#"+this._rteId+"_customColorDialog").ejDialog("close"); 
		    !this.colorobj.model.displayInline && this.colorobj.hide();
		     }
           this._on(this.colorobj._cancelTag, "click", this.colorobj._hidePopup);
            
        },
		
		_openColorpalette:function(e)
		{
		  if(!this._customColor)
				this._createcustomColorpalette();
		  if (e.currentTarget.id == this._rteId + "_customcolor") {
		       this._fontclick=true;
		   if (!ej.isNullOrUndefined(this._splitMenu));
               this._splitMenu.hide(e);
	    } 
		else if (e.currentTarget.id == this._rteId + "_customBGcolor") {
	     	     this._fontclick=false;
		    if (!ej.isNullOrUndefined(this._bgSplitMenu));
                this._bgSplitMenu.hide(e);
		
		}
		     this._customColor.ejDialog("open");

		},
		
		
		_checkColor:function(e)
		{
		  if(this._fontclick)
		  {
		  this._onFontColor(e);
		  this._fontColor=e;
		  }
		  else
		  {
		  this._onBGColor(e);
		  this._bgColor=e;		
		  }
		},
	
		
		
        _createTableClose: function (e) {
            if ((!ej.isNullOrUndefined(this._createTable)) && ((!ej.isNullOrUndefined(e) && $(e.target).parents("#" + this._rteId + "_" + "tables").length <= 0) || ej.isNullOrUndefined(e))) {
                if (!ej.isNullOrUndefined(this._createTable.data("ejDialog"))) {
                    if (ej.isNullOrUndefined(e) || (e.target != this._createTable[0] && $(e.target).parents(".e-rte-table-picker").length <= 0)) {
                        this._createTable.ejDialog("isOpened") && this._createTable.ejDialog("close");
                        this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
                    }
                    if (this._createTable.ejDialog("isOpened") && this.model.isResponsive&&(!$(e.target).find("div#" + this._toolBarObj.element[0].id + "_hiddenlist").hasClass("e-inline"))) this._toolBarObj._liTemplte.removeClass("e-display-none");
                    else if (this.model.isResponsive && !ej.isNullOrUndefined(e) && !$(e.target).is($("#" + this._toolBarObj.element[0].id + "_target")) && !($(e.target).closest("div#" + this._toolBarObj.element[0].id + "_hiddenlist").length != 0 || $(e.target).parents().hasClass("e-ddl-popup"))) this._toolBarObj._liTemplte.addClass("e-display-none");
                }
            }
            else
                $(this._createTable.find("div.e-rte-eTblProperties").hasClass('e-disable')).addClass('e-disable');
        },
        _documentClick: function (e) {
		   if($(e.target).hasClass("e-inlinearrow"))
		       this._setIframeHeight();
          if(this.model.toolbarOverflowMode!="inline")
              this._createTableClose(e);
            if (this._isIE() && !window.getSelection) {
                var checkdropdown = e.target.id;
                if (checkdropdown == "")
                    checkdropdown = e.target.parentNode.id;
                if (checkdropdown == (this._rteId + "_fontSizeDDL") || checkdropdown == (this._rteId + "_fontNameDDL") || checkdropdown == (this._rteId + "_formatDDL") || checkdropdown == (this._rteId + "_fontSizeDDL_dropdown") || checkdropdown == (this._rteId + "_fontNameDDL_dropdown") || checkdropdown == (this._rteId + "_formatDDL_dropdown"))
                    this._restoreSelection(this._selectionRange);
            }
        },


        _iframeFocus: function (e) {
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("isOpened") && this._createTable.ejDialog("close");
            !$(this._fontSizeDDL).parents("ul.e-rte-fontgroup").length == 0 && !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.hasClass("e-dropdownlist") && this._fontSizeDDL.ejDropDownList("hidePopup");
            !$(this._fontStyleDDL).parents("ul.e-rte-fontgroup").length == 0 && !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.hasClass("e-dropdownlist") && this._fontStyleDDL.ejDropDownList("hidePopup");
            !$(this._formatDDL).parents("ul.e-rte-format").length == 0 && !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.hasClass("e-dropdownlist") && this._formatDDL.ejDropDownList("hidePopup");
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("close");
            !ej.isNullOrUndefined(this._splitMenu) && this._splitMenu.hide(e);
            !ej.isNullOrUndefined(this._bgSplitMenu) && this._bgSplitMenu.hide(e);
            !ej.isNullOrUndefined(this._orderSplitObj) && this._orderSplitObj.hide(e);
            !ej.isNullOrUndefined(this._unOrderSplitObj) && this._unOrderSplitObj.hide(e);
        },
        _updateKeyDownSelectStatus: function (_toolEle, commandName) {
            if (!_toolEle.hasClass("e-active"))
                this._toolBarObj.selectItemByID(this._rteId + "_" + commandName);
            else
                this._toolBarObj.deselectItemByID(this._rteId + "_" + commandName);
        },
        _iframeKeyDown: function (e) {
            var _toolEle;
            
            if (this.model.showToolbar && this.model.allowKeyboardNavigation && e) {
                if (e.ctrlKey) {
                    e.keyCode == 65 ? this._contolAKeyfalg = true : ej.isNullOrUndefined(this._contolAKeyfalg) ? this._contolAKeyfalg : this._contolAKeyfalg = false;
                    var _proxy = this;
                    switch (e.keyCode) {
                        case 48://Reset zoom
                            e.preventDefault();
                            $(this.getDocument().body).css({ "zoom": 1, "transform": "scale(1)", "transform-origin": "0 0", "-o-transform": "scale(1)", "-o-transform-origin": "0 0", "-webkit-transform": "scale(1)", "-webkit-transform-origin": "0 0" });
                            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomIn")).attr("title", _proxy._getLocalizedLabels("zoomIn") + " 100%");
                            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomOut")).attr("title", _proxy._getLocalizedLabels("zoomOut") + " 100%");
                            _proxy._zoomValue = 1;
                            return false;
                        case 57:// Zoom in
                            e.preventDefault();
                            this._onKeyZoom("IN");
                            return false;
                        case 173:
                        case 189:// Zoom out
                            e.preventDefault();
                            this._onKeyZoom("OUT");
                            return false;
                        case 80:// Print
                            e.preventDefault();
                            this._onPrint();
                            return false;
                        case 66://B
                            if (!e.shiftKey) {//bold
                                e.preventDefault();
                                _toolEle = this._toolBarItems.find("li.e-rteItem-bold");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onBold();
                                    this._updateKeyDownSelectStatus(_toolEle, "bold");
                                    this._onChange();
                                    this._setBackupData()
                                };
                                return false;
                            }
                            break;
                        case 72:
                            if (e.shiftKey) {//sourcecode	view.
                                e.preventDefault();
                                this._getPasteRangeVal();
                                this._sourceCodeManager();
                                return false
                            }
                            break;
                        case 73://I
                            e.preventDefault();
                            if (e.shiftKey)
                                this._imageManager();
                            else {
                                _toolEle = this._toolBarItems.find("li.e-rteItem-italic");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onItalics();
                                    this._setBackupData();
                                    this._updateKeyDownSelectStatus(_toolEle, "italic");
                                    this._onChange();
                                }
                            }
                            return false;
                        case 85://U
                            e.preventDefault();
                            if (e.shiftKey)//UpperCase
                                this._onUpperCase();
                            else//Underline
                            {
                                _toolEle = this._toolBarItems.find("li.e-rteItem-underline");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onUnderLine();
                                    this._updateKeyDownSelectStatus(_toolEle, "underline");                                    
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 76://L
                            e.preventDefault();
                            if (e.shiftKey)//Lowercase
                                this._onLowerCase();
                            else {
                                if (!this._toolBarItems.find("li.e-rteItem-justifyLeft").hasClass("e-disable")) {
                                    this._onJustifyLeft();
                                    this._alignToolUpdate("justifyLeft");
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 82://R
                            e.preventDefault();
                            if (e.altKey)//Remove table row.
                                this.removeRow();
                            else if (e.shiftKey)//remove formate
                                this._onClearFormat();
                            else {//Jutfy Right.
                                _toolEle = this._toolBarItems.find("li.e-rteItem-justifyRight");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onJustifyRight();
                                    this._alignToolUpdate("justifyRight");
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 69://E
                            if (e.shiftKey) {//editable                          
                                e.preventDefault();
                                this._openCustomTable(e);
                                this._setBackupData();
                                this._onChange();
                                return false;
                            }
                            else if (!this._toolBarItems.find("li.e-rteItem-justifyCenter").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onJustifyCenter();
                                this._setBackupData();
                                this._alignToolUpdate("justifyCenter");
                                this._onChange();
                                return false;
                            }
                            break;
                        case 74://J							
                            if (!this._toolBarItems.find("li.e-rteItem-justifyFull").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onJustifyFull();
                                this._alignToolUpdate("justifyFull");
                                this._setBackupData();
                                this._onChange();
                                return false;
                            }
                            break;
                        case 90://Z							
                            if (!this._toolBarItems.find("li.e-rteItem-undo").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onUndo();
                                return false;

                            }
                            break;
                        case 89://Y

                            if (!this._toolBarItems.find("li.e-rteItem-redo").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onRedo();
                                return false;
                            }
                            break;
                        case 67://C							
                            if (e.altKey)//Remove table column
                            {
                                e.preventDefault();
                                this.removeColumn();
                                return false;
                            }
                            else if (e.shiftKey) {//custom Table
                                e.preventDefault();
                                this._getPasteRangeVal();
                                if (this._customTableDialog)
                                    this._renderTableDialog();
                                this._customTableDialog.ejDialog("open");
                                return false;
                            }
                            else if (this._toolBarItems.find("li.e-rteItem-copy").hasClass("e-disable")) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            break
                        case 88://X
                            if (this._toolBarItems.find("li.e-rteItem-cut").hasClass("e-disable")) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            this._onChange();
                            break;
                        case 86://V
                            if (this._toolBarItems.find("li.e-rteItem-paste").hasClass("e-disable") || ((this.model.maxLength <= $.trim(this._getText()).length) && (ej.isNullOrUndefined(this._contolAKeyfalg) ? true : this._contolAKeyfalg))) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            else if (e.shiftKey)//Video insertion.
                            {
                                e.preventDefault();
                                this._keypressFlag = false;
                                this._selectCommand("video");
                                return false;
                            }
                            break;
                        case 77://M
                            e.preventDefault();
                            if (e.shiftKey) {//Outdent.
                                if (!this._toolBarItems.find("li.e-rteItem-outdent").hasClass("e-disable")) {
                                    this._onOutdent();
                                    if (this._indentdepth > 0)
                                        this._indentdepth--;
                                }
                            }
                            else { //Indent.
                                if (!this._toolBarItems.find("li.e-rteItem-indent").hasClass("e-disable")) {
                                    this._onIndent();
                                    this._indentdepth++;
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 75:
                            e.preventDefault();
                            if (e.shiftKey)
                                this._onUnlink();
                            else
                                if (!this._toolBarItems.find("li.e-rteItem-createLink").hasClass("e-disable"))
                                    this._hyperLinkManager(false);
                            return false;

                        case 188://<							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._changeFontsize(false);
                                this._onChange();
                                return false;
                            }
                            this._setBackupData();
                            this._onChange();
                            break;
                        case 190://>							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._changeFontsize(true);
                                this._onChange();
                                return false;
                            }
                            this._setBackupData();
                            break;
                        case 61:
                        case 187://+
                            e.preventDefault();
                            (e.shiftKey) ? this._onSuperScript() : this._onSubScript();
                            this._onChange();
                            this._setBackupData();
                            return false;
                        case 79://O							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this.executeCommand('insertorderedlist', "listItem");
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            else if (e.altKey) {
                                e.preventDefault();
                                this.executeCommand('insertunorderedlist', "listItem");
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            break;
                        case 83://S							
                            if (e.shiftKey)//strike the content.
                            {
                                e.preventDefault();
                                this._onStrikeThrough();
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            break;
                        case 70://F							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._selectCommand("fullScreen");
                                return false;
                            }
                            else if (!e.altKey) {
                                e.preventDefault();
                                if (ej.RTE.FindAndReplace)
                                    this._showFindAndReplace();
                                return false;
                            }
                            break;
                        case 37://left arrow.							
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertColumn(true);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 39://right arrow.							
                            if (e.shiftKey  && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertColumn(false);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 38://up arrow.
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertRow(true);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 40://downarrow							
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertRow(false);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 65://A
                            if (e.altKey) {
                                e.preventDefault();
                                this.removeTable();
                                return false;
                            };
                            break
                        case 121://F10
                            e.preventDefault();
                            this._clearAllManager();
                            return false;
                        case 84://T
                            if (e.altKey && this._toolBarItems) { // Alt+ Ctrl + T.
                                this._toolBarItems.focus();
                                break;
                            }
                    }
                }
                else if ((e.keyCode == 9 ) && !(this._isIE8() ? this._currentSelNode.nodeName.toLowerCase() == "td" : this._getSelectedNode().nodeName.toLowerCase() == "td")) {
                    this._keypressFlag = true;
                    this.executeCommand('inserthtml', "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", true);
                    return false;
                }
                else if (e.keyCode == 8) {//Backspace for removing the indent.
                    ele = this._getSelectedNode();
                    if ($(ele).find("span#RTE_imgDupDiv").length > 0)
                        $(this._imgDupDiv).remove();
                    if ($(ele).parents("BLOCKQUOTE").length > 0) {
                        this._onOutdent();
                        e.preventDefault();
                    }
                }
            }
            else if (e.ctrlKey == true && (e.keyCode == 66 || e.keyCode == 73 || e.keyCode == 85 || e.keyCode == 76 || e.keyCode == 82 || e.keyCode == 69 || e.keyCode == 74 || e.keyCode == 90 || e.keyCode == 89 || e.keyCode == 67 || e.keyCode == 88 || e.keyCode == 86 || e.keyCode == 8 || e.keyCode == 46) && !this.model.allowKeyboardNavigation)
                e.preventDefault();
            if (this.model.maxLength != null && (ej.isNullOrUndefined(this._contolAKeyfalg) ? true : !this._contolAKeyfalg)) {
                try {
                    if (this._isIE8() && e.keyCode == 86 && !((this.model.maxLength) >= (window.clipboardData.getData("Text").length + $.trim(this._getText()).length)))
                        e.preventDefault();
                    else
                        this._validateMaxLength(e);
                }
                catch (error) { }
            }
            if (this._isIE8() ? (this._currentSelNode && this._currentSelNode.nodeName.toLowerCase() == "td") : this._getSelectedNode().nodeName.toLowerCase() == "td") {
                ele = this._isIE8() ? this._currentSelNode : this._getSelectedNode();
                _newElementIndex = $(ele).parent().children().index($(ele));
                if (e.keyCode == 9 && !e.shiftKey) {
                    _newElement = (!ej.isNullOrUndefined(ele.nextSibling)) ? ele.nextSibling : (!ej.isNullOrUndefined($(ele).parents("tr")[0].nextSibling) ? $(ele).parents("tr")[0].nextSibling.childNodes[0] : (!ej.isNullOrUndefined($(ele).parents("table")[0].nextSibling)) ? ($(ele).parents("table")[0].nextSibling.nodeName.toLowerCase() == "td") ? $(ele).parents("table")[0].nextSibling : ele : ele);
                    this._setTableSelection(_newElement, e);
                }
                if (e.keyCode == 9 && e.shiftKey) {
                    _newElement = (!ej.isNullOrUndefined(ele.previousSibling)) ? ele.previousSibling : (!ej.isNullOrUndefined($(ele).parents("tr")[0].previousSibling) ? $(ele).parents("tr")[0].previousSibling.childNodes[$(ele).parents("tr")[0].previousSibling.childNodes.length - 1] : (!ej.isNullOrUndefined($(ele).parents("table")[0].previousSibling)) ? ($(ele).parents("table")[0].previousSibling.nodeName.toLowerCase() == "td") ? $(ele).parents("table")[0].previousSibling : ele : ele);
                    this._setTableSelection(_newElement, e);
                }
                else if (e.keyCode == 40)
                    _newElement = (!ej.isNullOrUndefined($(ele).parents("tr")[0].nextSibling)) ? $(ele).parents("tr")[0].nextSibling.children[_newElementIndex] : ((!ej.isNullOrUndefined($(ele).parents("table")[0].nextSibling) && !this._isIE8()) ? $(ele).parents("table")[0].nextSibling : ele);
                else if (e.keyCode == 38)
                    _newElement = (!ej.isNullOrUndefined($(ele).parents("tr")[0].previousSibling)) ? $(ele).parents("tr")[0].previousSibling.children[_newElementIndex] : ((!ej.isNullOrUndefined($(ele).parents("table")[0].previousSibling)) && !this._isIE8() ? $(ele).parents("table")[0].previousSibling : ele);
                if (e.keyCode == 9 && ele == _newElement && !ej.isNullOrUndefined($(ele).parents("tr")[0])) {
                    this.insertRow(false);
                    this._setRange(this._isIE8() ? $(this._getRange().parentElement()).parents("tr").next().children().first()[0] : $(this._getRange().startContainer).parents("tr").next().children().first()[0], this._getRange(), true);
                    e.preventDefault();
                }
                else if ((e.keyCode == 9 && this._isIE8()) || e.keyCode == 40 || e.keyCode == 38) {
                    this._setRange(_newElement, this._getRange(), true);
                    e.preventDefault();
                }
                if (this._isIE8())
                    this._getRange().parentElement && (this._currentSelNode = this._getRange().parentElement());
            }
            if ($(e.target).parents("table").length == 0) $(this._getDocument()).find(".e-rte-tablebox").remove();
            this._setAutoHeight();
            this._trigger("keydown", { keyCode: e.keyCode });
        },
        _changeFontsize: function (status) {
            var fontSize = parseInt(this._getCommandValue('fontsize')) ? parseInt(this._getCommandValue('fontsize')) : 2;
            if ((!status && fontSize > this.model.fontSize[0].value) || (status && fontSize < this.model.fontSize[this.model.fontSize.length - 1].value)) {
                this._onFontSize(status ? fontSize + 1 : fontSize - 1);
                this._updateFontOptionStatus();
            }
        },
        _iframeKeypress: function (e) {
            if (!this._keypressFlag) {
                e.preventDefault();
                this._keypressFlag = true;
                return false;
            }
        },
        _setTableSelection: function (_newElement, e) {
            if (!this._isIE8() && !((_newElement.childNodes.length == 1 && _newElement.childNodes[0].nodeName == "BR") || (_newElement.childNodes.length == 0))) {
                range = this._getDocument().createRange();
                range.selectNodeContents(_newElement);
                this.selectRange(range);
            }
            else this._setRange(_newElement, this._getRange(), true);
            e.preventDefault();
        },
        _setAutoHeightValue: function (selectedtext) {
            if (selectedtext.nodeName == "#text") {
                if (selectedtext.parentNode.nodeName == "BODY") {
                    $(selectedtext).wrap("<div></div>");
                    this.selectRange(this._getRange());
                }
                range = $(selectedtext.parentNode).position().top + parseInt($(selectedtext.parentNode).css("height"));
            }
            if (selectedtext.nodeName == "DIV")
                range = $(selectedtext).position().top + parseInt($(selectedtext).css("height"));
            return range;
        },
        _setAutoHeight: function () {
            if (this.model.autoHeight)
                this._autoHeight();
            else if (!ej.isNullOrUndefined(this._getDocument())) $(this._getDocument().body).css("overflow", "");
        },
        _autoHeight: function () {
			var toolbarHeight = this._toolBarItems?this._toolBarItems.outerHeight():0;
            if (!ej.isNullOrUndefined(this._getDocument().body)) {
                $(this._getDocument().body).css("overflow", "hidden");
                var iframeTop = (!ej.isNullOrUndefined(this._getDocument().body.lastChild)) ? this._getDocument().body.lastChild.clientHeight + this._getDocument().body.lastChild.offsetTop : 0;
                if ((parseInt($(this._rteWapper[0]).css("min-height")) - toolbarHeight) <= iframeTop)
                    $(this._rteIframe[0]).css("height", (iframeTop + 30) + "px");
                else
                    $(this._rteIframe[0]).css("height", (parseInt($(this._rteWapper[0]).css("min-height")) - toolbarHeight) + "px");
                range = 0;
                range = (window.getSelection && !ej.isNullOrUndefined(this._getRange().startContainer)) ? this._setAutoHeightValue(this._getRange().startContainer) : (((this._getDocument().selection) && !ej.isNullOrUndefined(this._ieParents(this._getRange())[0])) ? this._setAutoHeightValue(this._ieParents(this._getRange())[0]) : 0);
                if (range >= (this._rteIframe.height() - 30)) {
                    if (this._rteIframe[0].contentDocument)
                        $(this._rteIframe[0]).css("height", (this._rteIframe[0].contentDocument.documentElement.scrollHeight + 20) + "px");
                    else
                        $(this._rteIframe[0]).css("height", (this._rteIframe[0].contentWindow.document.body.scrollHeight + 20) + "px");
                }
                this._rteWapper.outerHeight(this._rteEditor.outerHeight() + toolbarHeight + parseInt(this.model.showFooter ? 19 : 0));
            }
        },
        _ieSelRange: function () {
            if (this._isIE()) {
                this._selectionRange = "";
                this._ieSelectionRange = this._getRange();
                this._seleText = ej.isNullOrUndefined(this._getWindow().document.selection) ? this._selectionRange.toString() : this._getWindow().document.selection.createRange().text;
            }
            else
                this._ieSelectionRange = this._ieSelection;
        },
        _iframeSelectionChange: function (e) {
            this._trigger("select", { event: e, model: this.model });
        },
        _ignorekeyArray: [13, 32, 8, 46],
        _iframeKeyUp: function (e) {
            //if (!(e.which >= 37 && e.which <= 40))
            //    this._updateValue();
            $(this._imgDupDiv).remove();
            $(this._imgOrg).css("outline", "");
            if(this._getSelectedNode().parentNode.localName == "td" || this._getSelectedNode().parentNode.localName == "tr")this._toggleEditTable();
            if ($.inArray(e.which, this._ignorekeyArray) != -1)
                this._setBackupData();
            if (e.ctrlKey && (e.keyCode == 57 || e.keyCode == 189))
                this._zoomUp();
                if(e.keyCode == 37 ||e.keyCode == 39 || e.keyCode == 38 || e.keyCode == 40 || e.keyCode == 36 || e.keyCode == 35){               // top, left, right, left, home and end key code
            this._updateToolbarStatus();
            this._updateFontOptionStatus();
            this._updateFormat();
                }
            if(this.model.showFooter && (this.model.showWordCount||this.model.showCharCount))this._updateCount();
            var selectEle = this._isIE8() ? this._currentSelNode : this._getSelectedNode();
            if (this.model.showToolbar)
                this._isIE8() ? selectEle.nodeName.toLowerCase() : selectEle.nodeName.toLowerCase() != "a" ? this.disableToolbarItem("removeLink") : this.enableToolbarItem("removeLink");
            this._updateTagInfo(selectEle);            
            this._ieSelRange();
            this._trigger("keyup", { keyCode: e.keyCode });
            this._iframeSelectionChange(e);
            if (e.ctrlKey)
                switch (e.keyCode) {
                    case 88://X
                    case 86://V
                        this._onChange();
                        break;
                }
			if((e.keyCode==46||e.keyCode==8) && (this._getDocument().body.innerHTML==''||this._getDocument().body.innerHTML=="<br>"))
			 this._emptyContent();
			
        },
        _iframeMouseUp: function (e) {
            this._tableResizeUp(e);
			this._zoomUp(e);
            this._resizeBtnInit();
            if (!ej.isNullOrUndefined(this._imgDup) && $(this._imgOrg).parents("body").length > 0) {
                $(this._imgOrg).css({ "width": $(this._imgDup).css("width"), "height": $(this._imgDup).css("height") });
                $(this._imgOrg).position({ left: $(this._imgDup).position().left, top: $(this._imgDup).position().top });
                $(this._imgDup).css("display", "none");
                this._resizeImgPos();
                this._setAutoHeight();
            }
            if (e.target.nodeName != "IMG" && !$(e.target).hasClass("e-rte-imageboxmark")) {
                $(this._imgOrg).css("outline", "");
                $(this._imgDupDiv).remove();
                this._off($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
            }
            if (e.target.nodeName == "IMG" && $(e.target).parents("body").length > 0) {
                var range = (this._isIE8()) ? this._getDocument().body.createTextRange() : this._getDocument().createRange();
                (this._isIE8()) ? range.moveToElementText(e.target) : range.selectNode(e.target);
                this.selectRange(range);
            }
            this._currentSelNode = e.target; //For IE
            if (e.currentTarget && e.target.nodeName && e.target.nodeName.toLowerCase() == "html" && this._getDocument() && this._getDocument().body && (this._isIE8() ? true : this._getRange().startOffset == this._getRange().endOffset)) {
                this._isIE() && e.currentTarget.createRange && this._setRange(this._isIE8() ? this._getDocument().body : this._getRange().startContainer, e.currentTarget.createRange(), true);
                this._getDocument().body.focus();
            }
            this._toggleEditTable();
            this._updateToolbarStatus();
            if (e.button) isRightClick = (e.button == 2);
            else if (e.which) isRightClick = (e.which == 3);
            if (!isRightClick) {
                this._updateFormat();
                this._updateFontOptionStatus();
            }
            this._ieSelRange();
            this._iframeSelectionChange(e);
            if (this._fontStyleDDL && !ej.isNullOrUndefined(this._fontStyleDDL.data("ejDropDownList")) && this._fontStyleDDL.ejDropDownList("instance")._isPopupShown()) $(this._fontStyleDDL.ejDropDownList("instance").popupList.ejScroller("instance").element).trigger("mouseup");
            if (this._fontSizeDDL && !ej.isNullOrUndefined(this._fontSizeDDL.data("ejDropDownList")) && this._fontSizeDDL.ejDropDownList("instance")._isPopupShown()) $(this._fontSizeDDL.ejDropDownList("instance").popupList.ejScroller("instance").element).trigger("mouseup");

        },
        _iframeMouseDown: function (e) {
            if (ej.browserInfo().name === "mozilla") this._getDocument().designMode = "off";
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                this._focus();
            this._contolAKeyfalg = false;
            this._updateTagInfo(e.target);
            this._updateIndent(e.target);
            if (this.model.showToolbar)
                e.target.nodeName != "A" ? this.disableToolbarItem("removeLink") : this.enableToolbarItem("removeLink");
            if (e.target.nodeName == "VIDEO" && this.model.allowEditing) this._preventDefaultResize();
            if (e.target.nodeName == "IMG" && this.model.allowEditing) {
                this._preventDefaultResize();
                this._imageClick(e.target);
            }
            if ($(e.target).hasClass("e-rte-imageboxmark")) {
                this._resizeBtnInit();
                this._commonBoxDown = true;
                if ($(e.target).hasClass("e-rte-rigmed")) this._rigMidBox = true;
                if ($(e.target).hasClass("e-rte-toplef")) this._topLefBox = true;
                if ($(e.target).hasClass("e-rte-topmed")) this._topMidBox = true;
                if ($(e.target).hasClass("e-rte-toprig")) this._topRigBox = true;
                if ($(e.target).hasClass("e-rte-lefmed")) this._lefMidBox = true;
                if ($(e.target).hasClass("e-rte-botlef")) this._botLefBox = true;
                if ($(e.target).hasClass("e-rte-botmid")) this._botMidBox = true;
                if ($(e.target).hasClass("e-rte-botrig")) this._botRigBox = true;
                return false;
            }
            if ($(e.target).hasClass("e-rteColumnResizer")) {
                this._lastCol = $(e.target).hasClass("e-rtelastcol") ? true : false;
                this._columnEle = $(this._curTable).find("tr:first td").eq(parseInt($(e.target).attr("data-col")))[0];
                this._columnDown = true;
                this._columnIndex = this._columnEle.cellIndex;
                $(this._getDocument().body).after("<span class='colresizerline'style='cursor:col-resize;position:absolute;width:0px;border-left: 1px dashed #787878;height:" + $(this._columnEle).closest("table").height() + "px;left:" + e.pageX + "px;top:" + $(this._columnEle).offset().top + "px;'></span>");
            }
            if ($(e.target).hasClass("e-rteRowResizer")) {
                this._rowEle = $(this._curTable).find("tr").eq(parseInt($(e.target).attr("data-row")))[0];
                this._rowDown = true;
            }
            if ($(e.target).hasClass("e-rte-tablebox")) {
                this._boxDown = true;
                this._boxElement = this._curTable;
            }
            if ($(e.target).hasClass("e-rte-tablebox") || $(e.target).hasClass("e-rteRowResizer") || $(e.target).hasClass("e-rteColumnResizer"))
                this._on($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
            if ((ej.browserInfo().name == "msie" || ej.browserInfo().name == "chrome") && (e.ctrlKey == true && e.which == 1)) {
                if (e.target.tagName.toUpperCase() == 'A' && !ej.isNullOrUndefined($(e.target).attr('href')))
                    window.open($(e.target).attr('href'), "_blank");
            }
            if (this.model.isResponsive && !ej.isNullOrUndefined(this._toolBarObj) && this._toolBarObj._liTemplte.children('ul').length > 0&&(!$(this._toolBarObj._liTemplte).hasClass("e-inline"))) {
                this._toolBarObj.contstatus = true;
                this._toolBarObj._liTemplte.addClass("e-display-none");
                this._toolBarObj.contstatus = false;
            }
            this._iframeFocus();
            this._onChange();
        },
        _iframeFocusOut: function (e) {
            if (e.data) {
                e.data._proxy._onChange();
                e.data._proxy._selectionRange = e.data._proxy._isIE8() ? e.data._proxy._getRange() : e.data._proxy._saveSelection();
                e.data._proxy._seleText = ej.isNullOrUndefined(e.data._proxy._getWindow().document.selection) ? e.data._proxy._selectionRange.toString() : !e.data._proxy._isIE8() ? e.data._proxy._getWindow().getSelection().toString() : e.data._proxy._getWindow().document.selection.createRange().text;
            }
        },
        _widthFocusOut: function (e) {
            var dialog, drpdwnId, widthId;
            if (this._customTableDialog.ejDialog("isOpen")) {
                dialog = this._customTableDialog;
                drpdwnId = "#" + this._rteId + "_ddlAlignment";
                widthId = "#" + this._rteId + "_txtWidth";
            }
            else {
                dialog = this._eTblDialog;
                drpdwnId = "#" + this._rteId + "_eTblAlign";
                widthId = "#" + this._rteId + "_eTblWidth";
            }
            var val = dialog.find(widthId).val();
            var obj = $(drpdwnId).data('ejDropDownList');
            var option = (val && val != '' && !isNaN(val) || (val.slice(-2) == 'px') || (val.slice(-2) == 'em') || (val.slice(-2) == 'pt') || (val.slice(-1) == '%')) ? true : false;
            obj.option('enabled', option);
        },
        _windowResize: function (e) {
            this._setAutoHeight();
            this._setIframeHeight();
			this._updateCount();
        },
        _tableResizeUp: function (e) {
            if ($(this._getDocument()).find("table.e-rte-table").length && (this._columnDown || this._rowDown || this._boxDown)) {
                if (this._currentTable && this._columnDown && this._columnDownClick) {
                    if (!this._lastCol) {
                        this._currentTable.eq(this._columnIndex - 1).width(this.nexColIndexWid);
                        this._currentTable.eq(this._columnIndex).width(this._columnIndexWid);
                    }
                    else {
                        this._currentTable.closest("table").find("tr:first td").each(function () {
                            if (this.style.width == "") $(this).width(parseInt($(this).closest("table").width() / ($(this).siblings().length + 1)));
                        });
                        this._currentTable.eq(this._columnIndex).width(this.lasColIndexWid);
                        this._currentTable.closest("table").attr({ "width": "" });
                        $(this._getDocument()).find(".e-rte-tablebox").css({ "left": (this._currentTable.eq(this._columnIndex).offset().left + this._currentTable.eq(this._columnIndex).outerWidth()) + "px" });
                    }
                }
                this._removeResizeObject();
                $(this._getDocument()).find(".colresizerline").remove();
                $(this._getDocument()).find(".e-rte-tablebox").css("display", "none");
                this._restoreSelection(this._tableSelection);
                this._columnDown = false;
                this._rowDown = false;
                this._boxDown = false;
                this._columnDownClick = false;
            }
            else {
                $(this._getDocument()).find(".e-rte-tablebox").remove();
                this._tableSelection = this._getRange();
            }
        },
        _resizeBtnInit: function () {
            this._commonBoxDown = false;
            this._rigMidBox = false;
            this._topLefBox = false;
            this._topMidBox = false;
            this._topRigBox = false;
            this._lefMidBox = false;
            this._botLefBox = false;
            this._botMidBox = false;
            this._botRigBox = false;
        },
        _imgSpanBox: function (e) {
            this._resizeBtnInit();
            this._imgOrg = e;
            this._imgDupDiv = ej.buildTag("span#RTE_imgDupDiv");
            this._imgDup = ej.buildTag("img#RTE_imgdivspan", "", { "display": "none", "position": "absolute", "background-size": "100% 100%", "outline": "1px dashed #000", "opacity": ".64" }, {}).appendTo(this._imgDupDiv);
            this._topLef = ej.buildTag("span.e-rte-imageboxmark e-rte-toplef#RTE_toplef", "", { "cursor": "nwse-resize" }, {}).appendTo(this._imgDupDiv);
            this._topMid = ej.buildTag("span.e-rte-imageboxmark e-rte-topmed#RTE_topmed", "", { "cursor": "ns-resize" }, {}).appendTo(this._imgDupDiv);
            this._topRig = ej.buildTag("span.e-rte-imageboxmark e-rte-toprig#RTE_toprig", "", { "cursor": "nesw-resize" }, {}).appendTo(this._imgDupDiv);
            this._leftMid = ej.buildTag("span.e-rte-imageboxmark e-rte-lefmed#RTE_lefmed", "", { "cursor": "ew-resize" }, {}).appendTo(this._imgDupDiv);
            this._rigMid = ej.buildTag("span.e-rte-imageboxmark e-rte-rigmed#RTE_rigmed", "", { "cursor": "ew-resize" }, {}).appendTo(this._imgDupDiv);
            this._botLef = ej.buildTag("span.e-rte-imageboxmark e-rte-botlef#RTE_botlef", "", { "cursor": "nesw-resize" }, {}).appendTo(this._imgDupDiv);
            this._botMid = ej.buildTag("span.e-rte-imageboxmark e-rte-botmid#RTE_botmid", "", { "cursor": "ns-resize" }, {}).appendTo(this._imgDupDiv);
            this._botRig = ej.buildTag("span.e-rte-imageboxmark e-rte-botrig#RTE_botrig", "", { "cursor": "nwse-resize" }, {}).appendTo(this._imgDupDiv);
            this._resizeImgPos();
            this._resizeImgDupPos();
            $(this._getDocument().body).after(this._imgDupDiv);
            $(e).css({ "outline": "1px dashed #5C5C5C" });
            this._on($(this._getDocument()), "mousemove", this._imgBoxMouseMove);

        },
        _resizeImgPos: function () {
            this._ltPos = $(this._imgOrg).position();
            this._imgWid = $(this._imgOrg).css("width");
            this._imgHgt = $(this._imgOrg).css("height");
            this._imgDup.css({ "width": this._imgWid, "height": this._imgHgt, "left": this._ltPos.left + "px", "top": this._ltPos.top + "px", "border": $(this._imgOrg).css("border") });
            this._imgDup.attr({ "src": $(this._imgOrg).attr("src") });
            var _wid = (parseInt($(this._imgOrg).css("width")) - 2) + this._ltPos.left;
            var _midWid = ((parseInt($(this._imgOrg).css("width")) - 2) / 2) + this._ltPos.left;
            var _hgt = (parseInt($(this._imgOrg).css("height")) - 2) + this._ltPos.top;
            var _midHgt = ((parseInt($(this._imgOrg).css("height")) - 2) / 2) + this._ltPos.top;
            var _imgborder = parseInt($(this._imgOrg).css("border-width") == "" ? 0 : $(this._imgOrg).css("border-width"));
            $(this._rigMid).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (_midHgt) + "px" });
            $(this._botLef).css({ "left": (this._ltPos.left - 3) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._botRig).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._botMid).css({ "left": (_midWid) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._topRig).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._topLef).css({ "left": (this._ltPos.left - 3) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._topMid).css({ "left": (_midWid) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._leftMid).css({ "left": (this._ltPos.left - 3) + "px", "top": (_midHgt) + "px" });

        },
        _resizeImgDupPos: function () {
            this._ltDupPos = $(this._imgOrg).position();
            this._imgMidWid = $(this._imgOrg).css("width");
            this._imgDupHgt = $(this._imgOrg).css("height");
        },
        _imgBoxMouseMove: function (e) {
            if (this._commonBoxDown) {
                if (this._rigMidBox)
                    this._imgDupMouseMove(parseInt(e.pageX) - this._ltDupPos.left + "px", this._imgDupHgt, e);
                else if (this._lefMidBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", this._imgDupHgt, e);
                    $(this._imgDup).offset({ left: e.pageX });
                }
                else if (this._topMidBox) {
                    this._imgDupMouseMove(this._img_wid, ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY });
                }
                else if (this._botMidBox)
                    this._imgDupMouseMove(this._img_wid, (e.pageY - this._ltDupPos.top) + "px", e);
                else if (this._botRigBox)
                    this._imgDupMouseMove((e.pageX - this._ltDupPos.left) + "px", (e.pageY - this._ltDupPos.top) + "px", e);
                else if (this._botLefBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", (e.pageY - this._ltDupPos.top) + "px", e);
                    $(this._imgDup).offset({ left: e.pageX });
                }
                else if (this._topRigBox) {
                    this._imgDupMouseMove((e.pageX - this._ltDupPos.left) + "px", ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY });
                }
                else if (this._topLefBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY, left: e.pageX });
                }
            }
            else if (this._columnDown) {
                this._columnDownClick = true;
                this._currentTable = $(this._columnEle).closest("table").find("tr:first td");
                var prevcolwid = (this._columnEle.style.width == "") ? $(this._columnEle).width() : parseInt(this._columnEle.style.width);
                var _columnEleLeft = $(this._columnEle).offset().left, actualwid = (_columnEleLeft > e.pageX) ? prevcolwid + (_columnEleLeft - e.pageX) : prevcolwid - (e.pageX - _columnEleLeft);
                var nexnodeWid = ($(this._currentTable).eq(this._columnIndex - 1)[0].style.width == "") ? $($(this._currentTable).eq(this._columnIndex - 1)).width() : parseInt($(this._currentTable).eq(this._columnIndex - 1)[0].style.width), totalwid = prevcolwid + nexnodeWid;
                if (!this._lastCol && actualwid > 15 && totalwid - actualwid > 15) {
                    this.nexColIndexWid = totalwid - actualwid;
                    this._columnIndexWid = actualwid;
                    $(this._getDocument()).find(".colresizerline").css({ "left": e.pageX + "px" });
                }
                else if (this._lastCol && _columnEleLeft < e.pageX && e.pageX - _columnEleLeft > 15) {
                    this.lasColIndexWid = e.pageX - _columnEleLeft;
                    $(this._getDocument()).find(".colresizerline").css({ "left": e.pageX + "px" });
                }
                this._removeMouseSelection(e);
                $(this._columnEle).closest("table").find("tr:last td:last span.e-rte-tablebox").css({ "display": "none" });
            }
            else if (this._rowDown) {
                if (ej.browserInfo().name === "chrome" || ej.browserInfo().name === "mozilla") select = this._getDocument().getSelection().removeAllRanges();
                var _rowOffset = this._rowEle.offsetTop, _rowParentTop = this._rowEle.parentElement.parentElement.offsetTop;
                if ((e.pageY - (_rowOffset + _rowParentTop)) > 20)
                    this._rowEle.style.height = (e.pageY - (_rowOffset + _rowParentTop)) + "px";
                this._removeMouseSelection(e);
                $(this._getDocument()).find(".e-rte-tablebox").css({ "left": ($(this._rowEle).closest("table").width() + $(this._rowEle).closest("table").offset().left) + "px", "top": ($(this._rowEle).closest("table").height() + $(this._rowEle).closest("table").offset().top) + "px" });
            }
            else if (this._boxDown) {
                var boxEle = $(this._boxElement),boxParent = boxEle.parent(),boxPosition = boxEle.offset(), _width = (((e.pageX - boxPosition.left) / boxParent.width()) * 100), _height = (((e.pageY - boxPosition.top) / boxParent.height()) * 100);		
                if (ej.browserInfo().name === "chrome" || ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
                if(e.pageX > 0 && _width > 10 && _height > 0) {
                boxEle.attr({ "width": ( _width + "%"), "height": (_height + "%") });               
                $(this._getDocument()).find(".e-rte-tablebox").css({ "left": (boxEle.width() + boxPosition.left) + "px", "top": (boxEle.height() + boxPosition.top) + "px" });
                boxEle.find("tr:first td").each(function () {
                    var tdEle = $(this);
                    tdEle.width(parseInt(tdEle.closest("table").width() / (tdEle.siblings().length + 1))); });
                
                }
                this._removeMouseSelection(e);
            }

        },
        _removeMouseSelection: function (e) {
            if (ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
            if (e.stopPropagation) e.stopPropagation();
            if (e.preventDefault) e.preventDefault();
            e.cancelBubble = true;
            e.returnValue = false;
            return false;
        },
        _imgDupMouseMove: function (width, height, e) {
            $(this._imgDup).css({ "display": "block", "width": width, "height": height });
            this._resizeImgDupPos();
            if (this._isIE8()) this._removeMouseSelection(e);
        },
        _imageClick: function (e) {
            $(this._getDocument().body).find("img").css("outline", "");
            if (this._imgDupDiv)
                this._imgDupDiv.remove();
            this._imgSpanBox(e);
        },
        _iframePaste: function (e) {
            var _proxy = this,temp=ej;
			if(e){
				try {
					var val = ej.isNullOrUndefined(window.clipboardData) ? e.originalEvent.clipboardData.getData("text/plain") : window.clipboardData.getData("Text");
					if (val.length != 0) {
						if (!((_proxy.model.maxLength) >= (val.length + $.trim(_proxy._getText()).length)))
							e.preventDefault();
					}
					else {
						var blob = e.originalEvent.clipboardData.items[0].getAsFile();
						var reader = new FileReader();
						reader.onload = function (event) {
							_proxy.executeCommand('inserthtml', "<img src=" + event.target.result + " alt />");
						};
						reader.readAsDataURL(blob);
					}
				}
				catch (error) { }
			}
            setTimeout(function () {
				_proxy._setBackupData();
				_proxy._onChange();
                _proxy._setAutoHeight();
                _proxy._updateCount();
                _proxy._pasteTableResize();
				
			if (temp.browserInfo().name == "webkit")
                _proxy._getWindow().focus();
            else
                _proxy._getWindow().document.body.focus();
            }, 0);
        },
        _pasteTableResize: function () {
            var tableCollection = $(this._getDocument()).find("table").not(".e-rte-table"), tableElement;
            for (var tableItem = 0; tableItem < tableCollection.length; tableItem++) {
                tableElement = $(tableCollection[tableItem]);
                tableElement.addClass("e-rte-table").removeAttr("style cellspacing").attr({ "border": 1, "cellspacing": 1, "width": tableElement.width() }).css({ "border": "1px solid#5C5C5C", "border-collapse": "separate", "border-spacing": "2px" });
                tableElement.find("table tr,td").removeAttr("style width");
                this._on(tableElement, "mouseover", this._tableMouseOver);
            }
        },
        _wireEvents: function () {
            var _iframe = $(this._getDocument());
            if (this._getDocument() != "") {
                if (!ej.isNullOrUndefined(this._createTable)) {
                    this._on(this._createTable, "mouseenter", "div.e-rte-tablecell", this._tableCellStart)
                    ._on(this._createTable, "mousemove", "div.e-rte-tablecell", this._tableCellSelect)
                    ._on(this._createTable, "mouseleave", "div.e-rte-table", this._tableCellLeave)
                    ._on(this._createTable, "mousedown", "div.e-rte-tablecell", this._tableCellDown)
                    ._on($(document), "click", this._documentClick);
                }
                this._on(_iframe, "focus", this._iframeFocus)
                ._on(_iframe, "keydown", this._iframeKeyDown)
                ._on(_iframe, "keypress", this._iframeKeypress)
                ._on(_iframe, "keyup", this._iframeKeyUp)
                ._on(_iframe, "mouseup", this._iframeMouseUp)
                ._on(_iframe, "mousedown", this._iframeMouseDown)                
                ._on($(window), "resize", this._windowResize);				
                if (this._isIE8() || !(this.model.pasteCleanupSettings && (this.model.pasteCleanupSettings.cleanElements || this.model.pasteCleanupSettings.removeStyles || this.model.pasteCleanupSettings.cleanCSS || this.model.pasteCleanupSettings.listConversion)))
					this._on(_iframe, "paste", this._iframePaste);
					
                if (!ej.isNullOrUndefined((document.getElementById(this._id + "_Iframe"))))
                    $(document.getElementById(this._id + "_Iframe").contentWindow).on('blur', { _proxy: this }, this._iframeFocusOut);
                if (!ej.isNullOrUndefined(this._customTableDialog))
                    this._on(this._customTableDialog.find(".e-rte-txtWidth"), "focusout", this._widthFocusOut);
            }
        },

        _unwireEvents: function () {
            var _iframe = $(this._getDocument());
            if (!ej.isNullOrUndefined(this._createTable)) {
                this._off(this._createTable, "mousemove", "div.e-rte-tablecell")
                ._off(this._createTable, "mouseleave", "div.e-rte-table")
                ._off(this._createTable, "mousedown", "div.e-rte-tablecell")
                ._off($(document), "click", this._documentClick);
            }
            this._off(_iframe, "focus")
            ._off(_iframe, "keydown")
            ._off(_iframe, "keyup")
            ._off(_iframe, "mouseup")
            ._off(_iframe, "mousedown")
            ._off($(window), "resize", this._windowResize);
            $(document.getElementById(this._id + "_Iframe").contentWindow).off('blur', this._iframeFocusOut);
            if (!ej.isNullOrUndefined(this._customTableDialog))
                this._off(this._customTableDialog.find(".e-rte-txtWidth"), "focusout");

        },

        _footerEvents: function (val) {
            this[val](this._htmlSource, "click", this._sourceCodeManager);
            this[val](this._clearFormat, "click", this._onClearFormat);
            this[val](this._clearAll, "click", this._clearAllManager);
        },


        _onChange: function () {
            _prevhtml = $.trim(this.value());
            if (this.model.enableXHTML) {
                this._updateXhtml();
                if (this.model.enableHtmlEncode)
                    this.value(this._encode(this._removeNoSpaceChar(this.value())));
            }
            if (_prevhtml !== this._removeNoSpaceChar(this.getHtml())) {
                this._updateValue();
                var args = { text: this._getText(), htmlText: this.getHtml(), isInteraction: this._isInteraction, };
                this._trigger("change", args);
                this._isInteraction = true;
            }
        },
        _disableIframeContent: function () {
            try {
                this._rteIframe.contents().find("body,[contenteditable='true']").attr("contenteditable", false);
            }
            catch (err) { }
        },

        disable: function () {
            this.model.enabled = false; this._showHideContextMenu();
            this.element.attr("disabled", "disabled");
            this._unwireEvents();
            this.model.showToolbar && this._toolBarObj.disable();
            $(this._rteFooter).ejTooltip("option", "enabled", false);
            this._disableIframeContent();
            this._rteEditor.addClass("e-disable");
            if (this.model.showFooter) {
                this._rteFooter.addClass("e-disable");
                this._resize.removeClass("e-resizable");
                this._footerEvents("_off");
            }
            this._disableResizeObj(false);
        },

        enable: function () {
            this.model.enabled = true; this._showHideContextMenu();
            this.element.removeAttr("disabled");
            this._wireEvents();
            this.model.showToolbar && this._toolBarObj.enable();
            $(this._rteFooter).ejTooltip("option", "enabled", true);
            this._rteIframe.contents().find("body,[contenteditable='false']").attr("contenteditable", true);
            this._rteEditor.removeClass("e-disable");
            if (this.model.showFooter) {
                this._rteFooter.removeClass("e-disable");
                this._resize.addClass("e-resizable");
                this._footerEvents("_on");
            }
            this._disableResizeObj(true);
        },

        disableToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && ($(this._toolBarObj.target).find("#" + this._rteId + "_" + id).length != 0 || $(this._toolBarObj._liTemplte).find("#" + this._rteId + "_" + id).length != 0) ? this._toolBarObj.disableItemByID(this._rteId + "_" + id) : this._toolBarObj.disableItemByID(id);
            if (id == "undo") $("#" + this._rteId + "_" + id).addClass("e-rteTooldisable");
        },


        enableToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && ($(this._toolBarObj.target).find("#" + this._rteId + "_" + id).length != 0 || $(this._toolBarObj._liTemplte).find("#" + this._rteId + "_" + id).length != 0) ? this._toolBarObj.enableItemByID(this._rteId + "_" + id) : this._toolBarObj.enableItemByID(id);
            if (id == "undo" && $("#" + this._rteId + "_" + id).hasClass("e-rteTooldisable"));
            $("#" + id).removeClass("e-rteTooldisable");
        },


        removeToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && this._toolBarObj.removeItemByID(this._rteId + "_" + id);
            this._setIframeHeight();
        },

        refresh: function () {
            this._unwireEvents();
            this._setIFrames();
            this._setIframeHeight();
            if (this.model.enabled) this._wireEvents();
            else this._disableIframeContent();
            if (this.model.enableRTL) this._rteIframe.contents().find("body").css("direction", "rtl");
            this._showHideContextMenu();
        },


        show: function () {
            this._rteWapper.show();
            this._setIFrames();
        },


        hide: function () {
            this._rteWapper.hide();
        },

        setColorPickerType: function (value) {
            if (value == "palette" || value === "picker")
                this._imgPicker.option('modelType', value);
            else
                this._imgPicker.option('modelType', "default");
        },
        pasteContent: function (html) {
            this._pasteAPIFlag = true;
            this._pasteHtml(html);
            this._onChange();
        },
        getDocument: function () {
            return this._getDocument();
        },
        getHtml: function (encode) {
            if (this.model.enableXHTML) {
                if (this.model.enableHtmlEncode) {
                    if (encode == false)
                        return this._removeNoSpaceChar($.trim(this._decode(this.value())));
                    else
                        return this._removeNoSpaceChar($.trim(this.value()));
                }
                else
                    return this._removeNoSpaceChar($.trim(this.value()));
            }
            else {
                try {
                    if (this.model.enableHtmlEncode) {
                        if (encode == false)
                            return this._removeNoSpaceChar($.trim(this._getDocument().body.innerHTML));
                        else
                            return this._removeNoSpaceChar(this._encode($.trim(this._getDocument().body.innerHTML)));
                    }
                    else
                        return this._removeNoSpaceChar($.trim(this._getDocument().body.innerHTML));
                }
                catch (err) {
                    return "";
                }
            }
        },
        setHtml: function (value) {
            this._getDocument().body.innerHTML = "";
            this._getDocument().body.innerHTML = $.trim(value);
            this._onChange();
			var _tableEle = $(this._getDocument()).find("table");       
            if (!this.model.enableRTL && _tableEle.length > 0 ) this._on(_tableEle, "mouseover", this._tableMouseOver);
        },


        getText: function () {
            return this._getText();
        },


        executeCommand: function (cmdName, args, textnodeType) {
            if (this._isIE8() && ej.isNullOrUndefined(this._ieSelectionRange)) this._ieSelectionRange = this._getRange();
            else if (this._isIE() && cmdName.toLowerCase() == "inserthtml" && !this._isIE8()) {
                if (this._getRange().startContainer.nodeName.toLowerCase() != "body") {
                    this._currentSelNode = this._getRange().startContainer;
                }
                else {
                    this._ieLinkRange();
                }
            }
            if (this._trigger("execute", { commandName: cmdName })) return false;
            var anchor = "";
            if (ej.browserInfo().name == "chrome" && this._getWindow().getSelection().rangeCount == 0)
                this._restoreSelection(this._saveSelection());
            if (cmdName == "underline") {
                if (window.getSelection) {
                    anchor = $(this._getWindow().getSelection().anchorNode).parents("a");
                    if (anchor.length > 0) {
                        $(anchor).css("text-decoration", ($(anchor).css("text-decoration") == "none") ? "underline" : "none");
                        return;
                    }
                }
            }
            else if (cmdName.toLowerCase() == "inserthtml") {
                if (this._isIE()) {
                    this._pasteHtml(args, textnodeType);
                }
                else
                    this._getDocument().execCommand(cmdName, false, args);
                return;
            }
            else if (cmdName.toLowerCase() == "formatblock") {
                if (this._isIE()) {
                    if (args.charAt(0) != "<" && args.charAt(args.length - 1) != ">")
                        args = "<" + args + ">";
                }
            }
            if (ej.browserInfo().name == "msie")
                this._focus();
            if (this._isIE() && cmdName == "fontName") args = args.substring(0, args.indexOf(","));
            // if (!ej.isNullOrUndefined(this._tempEle) && this._tempEle.length > 0)
            // if ((this._tempEle.get(0).nodeName == "#text") && ($(this._tempEle.parents("li")).length > 0))
            // if ($(this._tempEle.parents("li")).prop("style")["font-size"] != "")
            // var lisize = $(this._tempEle.parents("li")).css("font-size");
            this._getDocument().execCommand(cmdName, false, args);
            this._onChange();
            if (cmdName != "fontName" && cmdName != "fontSize" && cmdName != "indent" && cmdName != "cut" && cmdName != "copy" && cmdName != "paste" && cmdName != "undo" && cmdName != "redo" && cmdName != "outdent" && !ej.isNullOrUndefined(this._toolBarObj))
                if (!this._toolBarObj.itemsContainer.find("li#" + this._rteId + "_" + cmdName).hasClass("e-active"))
                    this._toolBarObj.selectItemByID(this._rteId + "_" + cmdName);
                else
                    this._toolBarObj.deselectItemByID(this._rteId + "_" + cmdName);
            //  if (!ej.isNullOrUndefined(this._tempEle)) this._bulletsResizing(lisize, cmdName);
            if (args != "listItem") this._setBackupData();
        },
        //The commented lines behavior need to achieve in custom exec-command task if possible
        // _bulletsResizing: function (lisize, cmd) {
        // if ((!ej.isNullOrUndefined(this._tempEle.get(0))) && cmd=="fontSize")
        // var li = this._tempEle.get(0).tagName == "BODY" ? this._tempEle.find("li") : this._tempEle.get(0).nodeName != "#text" ? $(this._tempEle.parents("body")).find("li") : "";
        // if (li != "")
        // $(li).each(function (index) {
        // //refreshig the li font size after font size of li content executed
        // fonttag = $(this).find("font")[0] || "";
        // if (fonttag != "") {
        // $(this).css("font-size", $($(fonttag)[0]).css("font-size"));
        // // $(li).find("font").removeAttr("style");
        // }
        // else
        // {
        // $(this).css("font-size", $(this).css("font-size"));
        // }
        // });


        // if (cmd == "fontSize" && (this._getCommandStatus('InsertOrderedList') || this._getCommandStatus('InsertOrderedList')))
        // if (this._tempEle.get(0).tagName == "LI" || this._tempEle.get(0).tagName == "OL") {

        // this._tempEle.css("font-Size", this._tempEle.find("font").css("font-Size"));
        // $(this._tempEle.find("font")).removeProp("style")["font-size"];
        // }
        // if (lisize != null) {

        // $(this._tempEle.parents("li")).css("font-size", lisize);
        // $(this._tempEle.parents("li")).find("font").removeAttr("style");
        // }

        // },


        focus: function () {
            this._focus();
        },


        getCommandStatus: function (value) {
            if (ej.isNullOrUndefined(value) || value != "")
                return this._getCommandStatus(value);
        },


        getSelectedHtml: function () {
            return this._getSelectedHtmlString();
        },

        insertMenuOption: function (option) {
            if (option.newItem && option.targetItem && option.insertType && option.menuType) {
                var menuObj = this._textMenuObj, element, elementId = option.newItem, data = option.spriteCssClass ? [{ text: option.newItem, id: elementId, spriteCssClass: option.spriteCssClass }] : [{ text: option.newItem, id: elementId }];
                for (i = 0; i < menuObj.element.find('li a').length; i++) {
                    if ($(menuObj.element.find('li a')[i]).text() == option.targetItem) {
                        element = $(menuObj.element.find('li')[i]).attr('id');
                        break;
                    }
                }
                if (option.insertType == "insert") menuObj.insert(data, element ? "#" + element : element);
                else if (option.insertType == "insertAfter") menuObj.insertAfter(data, "#" + element);
                else if (option.insertType == "insertBefore") menuObj.insertBefore(data, "#" + element);
                (option.menuType.text && this._contextType.text.push(elementId));
                (option.menuType.image && this._contextType.image.push(elementId));
                (option.menuType.hyperlink && this._contextType.hyperlink.push(elementId));
                (option.menuType.table && (this._contextType.table.push(elementId), this._contextType.table_hyper.push(elementId)));
            }
        },
        removeMenuOption: function (targetElement) {
            var menuObj = this._textMenuObj; menuObj.remove(["#" + targetElement]);
            (index = $.inArray(targetElement, this._contextType.text)) != -1 && (this._contextType.text = this._removeContextData(index, this._contextType.text));
            (index = $.inArray(targetElement, this._contextType.image)) != -1 && (this._contextType.image = this._removeContextData(index, this._contextType.image));
            (index = $.inArray(targetElement, this._contextType.hyperlink)) != -1 && (this._contextType.hyperlink = this._removeContextData(index, this._contextType.hyperlink));
            (index = $.inArray(targetElement, this._contextType.table)) != -1 && (this._contextType.textablet = this._removeContextData(index, this._contextType.table));
            (index = $.inArray(targetElement, this._contextType.table_hyper)) != -1 && (this._contextType.textablet = this._removeContextData(index, this._contextType.table_hyper));
        },
        _removeContextData: function (index, data) {
            var temp = [];
            $(data).each(function (ind, elem) { (index != ind) && temp.push(elem); });
            return temp;
        },
        insertRow: function (before, cell) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                var seletedCell = ej.isNullOrUndefined(cell) ? this._getSelectedNode() : cell;
				var newRow =  $(seletedCell).closest("tr").clone(), curRow = $(seletedCell).closest("tr");
                var cols = newRow.find("td").html("<br _moz_dirty=''/>");
                before ? newRow.insertBefore(curRow) : newRow.insertAfter(curRow);
                newRow.find("td:first").focus();
                this._setAutoHeight();
                return seletedCell;
            }
        },


        insertColumn: function (before, cell) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                var isTable = $(this._getSelectedNode()).closest("td");
                var seletedCell = ej.isNullOrUndefined(cell) ? (isTable.length > 0) ? isTable[0] : this._getSelectedNode() : cell;
                var colTemplate = $(seletedCell).clone(), curRow = $(seletedCell).closest("tr"), curCell;
				colTemplate[0].innerHTML = "<br _moz_dirty=''/>";
                var allRows = curRow.closest("table").find("tr");
                var colIndex = curRow.find("td").index(seletedCell);
                for (var i = 0; i < allRows.length; i++) {
                    curCell = $(allRows[i]).find("td")[colIndex];
                    before ? $(colTemplate.clone()).insertBefore(curCell) : $(colTemplate.clone()).insertAfter(curCell);
                }
                return seletedCell;
            }
        },


        removeRow: function (cell) {
            var seletedCell = ej.isNullOrUndefined(cell) ? this._getSelectedNode() : cell;
            var range = this._getRange();
            var select; var node = null;
            var parentTable = $(seletedCell).closest("table");

            if (parentTable.find("tr").length == 1) {
                node = $(seletedCell).parent("tr").closest("table").next()[0] || $(seletedCell).parent("tr").closest("table").prev()[0];
                $(seletedCell).parent("tr").closest("table").remove();
            }
            else {
                node = ($(seletedCell).parent("tr").prev("tr").length != 0) ? $(seletedCell).parent("tr").prev("tr").find("td:last")[0] : $(seletedCell).parent("tr").next("tr").find("td:first")[0];
                curRow = $(seletedCell).closest("tr").remove();
            }
            if (!ej.isNullOrUndefined(node)) {
                this._setRange(node, range);
            }
            this._setAutoHeight();
        },
        selectRange: function (range, node) {
            this._focus();
            if (!this._isIE8()) {
                select = this._getDocument().getSelection();
                select.removeAllRanges();
                select.addRange(range);
            }
            else {
                range.select();
            }
        },
        _encode: function (value) {
            return $('<div/>').text(value).html();
        },
        _decode: function (value) {
            return value.replace(/&amp;/g, "&").replace(/&amp;lt;/g, "<").replace(/&lt;/g, "<").replace(/&amp;gt;/g, ">").replace(/&gt;/g, ">").replace(/&nbsp;/g, " ").replace(/&amp;nbsp;/g, " ").replace(/&quot;/g);
        },
        createRange: function () {
            if (!this._isIE8())
                return this._getRange();
            else
                return this.getDocument().body.createTextRange();
        },
        _setRange: function (node, range, collapse) {
            if (!this._isIE8()) {
                range.setStart(node, 0);
                range.collapse(true);
                if ((ej.browserInfo().name != "msie" || ej.browserInfo().version == "11.0") || !ej.isNullOrUndefined(collapse)) {
                    this.selectRange(range);
                }
                else if (ej.isNullOrUndefined(collapse)) {
                    selection = this._getDocument().body.createTextRange();
                    selection.moveToElementText(node);
                }
            }
            else if (!ej.isNullOrUndefined(node)) {
                range.collapse(true);
                range.moveToElementText(node);
                range.moveStart("character", 1);
                range.select();
            }
        },

        removeColumn: function (cell) {
            var isTable = $(this._getSelectedNode()).closest("td");
            var seletedCell = ej.isNullOrUndefined(cell) ? (isTable.length > 0) ? isTable[0] : this._getSelectedNode() : cell;
            var range = this._getRange();
            var curRow = $(seletedCell).closest("tr");
            var allRows = curRow.closest("table").find("tr");
            var colIndex = curRow.find("td").index(seletedCell);
            var node = !ej.isNullOrUndefined(seletedCell.nextElementSibling) ? $(seletedCell.nextElementSibling)[0] : $(seletedCell.previousSibling)[0];
            if (ej.isNullOrUndefined(node))
                $(seletedCell).parent("tr").parents("table").remove();
            else {
                for (var i = 0; i < allRows.length; i++) {
                    $($(allRows[i]).find("td")[colIndex]).remove();
                }
            }
            if (!ej.isNullOrUndefined(node)) {
                this._setRange(node, range);
            }
        },


        removeTable: function (table) {
            var seletedTable = ej.isNullOrUndefined(table) ? $(this._getSelectedNode()).closest("table") : table, tableAction = $(seletedTable).parent().closest('table').length < 1;
            this._currentSelNode = $(seletedTable).parent()[0];
            $(seletedTable).remove();
            if (tableAction)
                this._toggleEditTable();
            this._setAutoHeight();
            this._removeResizeObject();
            $(this._getDocument()).find(".e-rte-tablebox").remove();
        }
    });

    ej.RTE.Locale = ej.RTE.Locale || {};

    ej.RTE.Locale["default"] = ej.RTE.Locale["en-US"] = {
        bold: "Bold",
        italic: "Italic",
        underline: "Underline",
        strikethrough: "Strikethrough",
        superscript: "Superscript",
        subscript: "Subscript",
        justifyCenter: "Align text center",
        justifyLeft: "Align text left",
        justifyRight: "Align text right",
        justifyFull: "Justify",
        unorderedList: "Insert unordered list",
        orderedList: "Insert ordered list",
        indent: "Increase Indent",
        fileBrowser: "File Browser",
        outdent: "Decrease Indent",
        cut: "Cut",
        copy: "Copy",
        paste: "Paste",
        paragraph: "Paragraph",
        undo: "Undo",
        redo: "Redo",
        upperCase: "Upper Case",
        lowerCase: "Lower Case",
        clearAll: "Clear All",
        clearFormat: "Clear Format",
        createLink: "Insert/Edit Hyperlink",
        removeLink: "Remove Hyperlink",
        tableProperties: "Table Properties",
        insertTable: "Insert",
        deleteTables: "Delete",
        imageProperties: "Image Properties",
        openLink: "Open Hyperlink",
        image: "Insert image",
        video: "Insert video",
        editTable: "Edit Table Properties",
        embedVideo: "Paste your embed code below",
        viewHtml: "View HTML",
        fontName: "Select font family",
        fontSize: "Select font size",
        fontColor: "Select color",
		customFontColor:"More Colors...",
		customBGColor:"More Colors...",
        format: "Format",
        backgroundColor: "Background color",
		TransBGColor:"Transparent",
        style: "Styles",
        deleteAlert: "Are you sure you want to clear all the contents?",
        copyAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+C keyboard shortcut instead of copy operation.",
        pasteAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+V keyboard shortcut instead of paste operation.",
        cutAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+X keyboard shortcut instead of cut operation.",
        videoError: "The text area can not be empty",
        imageWebUrl: "Web Address",
        imageAltText: "Alternate text",
        dimensions: "Dimensions",
        constrainProportions: "Constrain Proportions",
        linkWebUrl: "Web Address",
        imageLink: "Image as Link",
        imageBorder: "Image Border",
        imageStyle: "Style",
        linkText: "Text",
        linkTooltipLabel: "Tooltip",
        html5Support: "This tool icon only enabled in HTML5 supported browsers",
        linkOpenInNewWindow: "Open link in new window",
        tableColumns: "No.of Columns",
        tableRows: "No.of Rows",
        tableWidth: "Width",
        tableHeight: "Height",
        tableCellSpacing: "Cell spacing",
        tableCellPadding: "Cell padding",
        tableBorder: "Border",
        tableCaption: "Caption",
        tableAlignment: "Alignment",
        textAlign: "Text align",
        dialogUpdate: "Update",
        dialogInsert: "Insert",
        dialogCancel: "Cancel",
        dialogApply: "Apply",
        dialogOk: "Ok",
        createTable: "Insert Table",
        insertTable: "Insert",
        addColumnLeft: "Insert Columns to the Left",
        addColumnRight: "Insert Columns to the Right",
        addRowAbove: "Insert Rows Above",
        addRowBelow: "Insert Rows Below",
        deleteRow: "Delete entire row",
        deleteColumn: "Delete entire column",
        deleteTable: "Delete Table",
        customTable: "Create custom table...",
        characters: "Characters",
        words: "Words",
		w:"W",
		c:"C",
        general: "General",
        advanced: "Advanced",
        table: "Table",
        row: "Row",
        column: "Column",
        cell: "Cell",
        solid: "Solid",
        dotted: "Dotted",
        dashed: "Dashed",
        doubled: "Double",
        maximize: "Maximize",
        resize: "Minimize",
        swatches: "Swatches",
        paragraph: "Paragraph",
        quotation: "Quotation",
        heading1: "Heading 1",
        heading2: "Heading 2",
        heading3: "Heading 3",
        heading4: "Heading 4",
        heading5: "Heading 5",
        heading6: "Heading 6",
        segoeui: "Segoe UI",
        arial: "Arial",
        couriernew: "Courier New",
        georgia: "Georgia",
        impact: "Impact",
        lucidaconsole: "Lucida Console",
        tahoma: "Tahoma",
        timesnewroman: "Times New Roman",
        trebuchetms: "Trebuchet MS",
        verdana: "Verdana",
        disc: "Disc",
        circle: "Circle",
        square: "Square",
        number: "Number",
        loweralpha: "Lower Alpha",
        upperalpha: "Upper Alpha",
        lowerroman: "Lower Roman",
        upperroman: "Upper Roman",
        none: "None",
        linkTooltip: "ctrl + click to follow link",
        charSpace: "Characters (with spaces)",
        charNoSpace: "Characters (no spaces)",
        wordCount: "Word Count",
        left: "Left",
        right: "Right",
        center: "Center",
        zoomIn: "Zoom In",
        zoomOut: "Zoom Out",
        print: "Print",
        'import': "Import a Document",
        wordExport: "Export as Word Document",
        pdfExport: "Export as Pdf File",
        FindAndReplace: "Find and Replace",
        Find: "Find",
        MatchCase: "Match Case",
        WholeWord: "Whole Word",
        ReplaceWith: "Replace with",
        Replace: "Replace",
        ReplaceAll: "Replace All",
        FindErrorMsg: "Couldn't find specified word.",
		FindOf: " of ", 
		ReplaceCount: " occurrences were replaced." 
		
    };
ej.RTE.ToolbarOverflowMode = {
        /**  Renders overflow popup with hamburger icon as usual. */
        Popup:"popup",
        /**  Renders overflow popup  below the toolbar as inline on clicking the arrow. */
        Inline: "inline"
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.RTE = ej.RTE || {};
    ej.RTE.FindAndReplace = {
	_findObject:null,
	_selectedIndex:-1,
	_findAndReplaceClick:function (args){
		var dialog=this._findDialog.element,text=$.trim($(dialog).find("[ej-function='findtxt']").val()),targetElement=(args.target.tagName=="SPAN"||args.target.tagName=="DIV")?$(args.target).closest("button")[0]:args.target,replacetxt=$(dialog).find("[ej-function='replacetxt']").val(),target=this.getDocument().body,findElement=$(dialog).find("[ej-function='replace'],[ej-function='replaceAll']"),navElement=$(dialog).find("[ej-function='prev'],[ej-function='next']");
		$(this._findDialog.element).children('span').html('');
		if(!$(targetElement).hasClass("e-disable"))
		switch(targetElement.getAttribute('ej-function'))
		{
			case "find":
			if(text){			
				this._findObject.find(text,target,!$(dialog).find("[ej-function='matchCase']")[0].checked,$(dialog).find("[ej-function='wholeWords']")[0].checked),this._selectedIndex=-1;
				if(this._findObject.nodeCollection.length){
					$('#'+ this._id + '_rtefindcount').html('');
					(this._findObject.nodeCollection.length>0)?findElement.ejButton("enable"):findElement.ejButton("disable");
					this._highlightNode(++this._selectedIndex,target);
					this._updateBtnStatus(this._selectedIndex,navElement);
				}
				else{
					$.merge(navElement,findElement).ejButton("disable");					
					this._findObject.revertAll();
					$(this._findDialog.element).children('span').html(this._getLocalizedLabels("FindErrorMsg"));
				}
			}
			else if(this._findObject.nodeCollection.length)
			this._findObject.revertAll();
			break;
			case "next":
			if(this._selectedIndex<this._findObject.nodeCollection.length){
				$('#'+ this._id + '_rtefindcount').html('');
			this._highlightNode(++this._selectedIndex,target);
			}
			this._updateBtnStatus(this._selectedIndex,navElement);
			break
			case "prev":
			if(this._selectedIndex>0){
				$('#'+ this._id + '_rtefindcount').html('');
				this._highlightNode(--this._selectedIndex,target);
				}
			this._updateBtnStatus(this._selectedIndex,navElement);
			break;
			case "replace":
					this._findObject.replaceByIndex(this._selectedIndex,replacetxt);
					if(!this._findObject.nodeCollection.length){
						$('#'+ this._id + '_rtefindcount').html('');	
						this._selectedIndex=-1;
					}
					else if (this._selectedIndex>this._findObject.nodeCollection.length-1) --this._selectedIndex;
					
					if(this._selectedIndex>-1){
						$('#'+ this._id + '_rtefindcount').html('');
						this._highlightNode(this._selectedIndex,target);
						this._updateBtnStatus(this._selectedIndex,navElement); 
					}
					else
						$.merge(navElement,findElement).ejButton("disable");
					this._setBackupData(); 
			break;
			case "replaceAll":
					var _replaceCount = this._findObject.replaceAll(replacetxt);this._selectedIndex=-1;
					$('#'+ this._id +'_rteReplaceCount').append(_replaceCount +this._getLocalizedLabels("ReplaceCount") );
					$.merge(navElement,findElement).ejButton("disable");					
					this._setBackupData(); 
			break;		
		}
		this._updateCount();        
	
	}, 
	_updateBtnStatus:function(_selectedIndex,element){
		(_selectedIndex<this._findObject.nodeCollection.length-1)?$(element[1]).ejButton("enable"):$(element[1]).ejButton("disable");
		(_selectedIndex>0)?$(element[0]).ejButton("enable"):$(element[0]).ejButton("disable");
	},
	_highlightNode:function(nodeIndex,target){
		$(target).find(".e-highlight").removeClass("e-highlight");
		for (var index=0;index<this._findObject.nodeCollection.length;index++){
			if(nodeIndex==index)
				for (var index1=0;index1<this._findObject.nodeCollection[index].length;index1++){
					$(this._findObject.nodeCollection[index][index1].node).addClass("e-highlight");
					$((ej.browserInfo().name=="msie"||ej.browserInfo().name=="mozilla")?target.parentElement:target).scrollTop($(this._findObject.nodeCollection[index][index1].node).offset().top - 25);
				}
				
		}
		$('#'+ this._id + '_rtefindcount').append(nodeIndex+ this._getLocalizedLabels("FindOf") + this._findObject.nodeCollection.length);		 
	},	

	_renderFindDialog:function (target){
		
	    var content = "<div id='" + this._id + "_basicDialog' title='" + this._getLocalizedLabels("FindAndReplace") + "'><div class='e-maincontent'><div class='e-fd-findcontent'><div class='e-fd-lable'><span>" + this._getLocalizedLabels("Find") + "</span></div><div class='e-txtbox'><input type='text' ej-function='findtxt' id='" + this._id + "_findtxt' class='e-js e-input'></div><div id='" + this._id + "_rtefindcount' class='e-rtefindcount'></div></div><div class='e-fd-InnerContent'><div><input type='checkbox' ej-function='matchCase' id='" + this._id + "_matchCase' value='true'><label for='" + this._id + "_matchCase' class='e-fd-checkboxlable' style=''>" + this._getLocalizedLabels("MatchCase") + "</label></div><div class='e-checkbx'><input type='checkbox' ej-function='wholeWords' id='" + this._id + "_wholeWords' value='true'><label for='" + this._id + "_wholeWords' class='e-fd-checkboxlable'>" + this._getLocalizedLabels("WholeWord") + "</label></div></div><div class='e-fd-replacecontent'><div class='e-fd-lable'><span>" + this._getLocalizedLabels("ReplaceWith") + "</span></div><div class='e-txtbox'><input type='text' ej-function='replacetxt' id='" + this._id + "_replacetxt' class='e-js e-input'></div></div></div><div id='" + this._id + "_rteReplaceCount' class='e-rteReplaceCount'></div><span style='text-align: center;'></span><div class='e-fd-btncol'><div class='e-btn-left'><button id='" + this._id + "_find' ej-function='find'>" + this._getLocalizedLabels("Find") + "</button><button id='" + this._id + "_replace' ej-function='replace'>" + this._getLocalizedLabels("Replace") + "</button><button id='" + this._id + "_replaceAll' class='ejRTE-replaceAll' ej-function='replaceAll'>" + this._getLocalizedLabels("ReplaceAll") + "</button></div><div class='e-btn-right'><button id='" + this._id + "_prev' ej-function='prev'></button><button id='" + this._id + "_next' ej-function='next'></button></div></div></div>";
		target._findDialog=$(content).ejDialog({
                width: "auto",
				minWidth:"300px",
				maxWidth:"380px",
				isResponsive:true,
                close:this._onCloseFindAndReplace,cssClass:"e-rte e-findandreplace",enableRTL:target.model.enableRTL,enableResize: false,enableModal: true				
            }).data("ejDialog");
			$(target._findDialog.element).find("input[type=text]").val("");
			$(target._findDialog.element).find("button").ejButton({height: 30});
			$(target._findDialog.element).find("[ej-function='replace'],[ej-function='replaceAll'],[ej-function='prev'],[ej-function='next']").ejButton("disable");
			$(target._findDialog.element).find("[ej-function='prev'],[ej-function='next']").ejButton({height: 30, width: 30,contentType: "imageonly"});
			$(target._findDialog.element).find("[ej-function='prev']").ejButton({ prefixIcon:"e-icon e-chevron-left_02"}).next().ejButton({ prefixIcon: "e-icon e-chevron-right_02"});
			$(target._findDialog.element).find("[ej-function='wholeWords'],[ej-function='matchCase']").ejCheckBox({enableRTL:target.model.enableRTL,checked:  false});				
			this._findObject=new ej.FindAndReplace()
			this._on(target._findDialog.element.find("button"), "click", this._findAndReplaceClick);
	},
	_onCloseFindAndReplace:function(args){
					$("#"+this._id.replace("_basicDialog","")).data("ejRTE")._findObject.revertAll();
					this.element.find("[ej-function='replace'],[ej-function='replaceAll'],[ej-function='prev'],[ej-function='next']").ejButton("disable");
					this.element.find("input[type=text]").val("");
					this.element.find("[ej-function='wholeWords'],[ej-function='matchCase']").ejCheckBox({checked:false});
					this.element.children('span').html('');
					$('.e-rteReplaceCount').html('');
					$('.e-rtefindcount').html('');
	},
	_showFindAndReplace:function (){
		this._findDialog?this._findDialog.open():this._renderFindDialog(this);
	}
	
	}
	
})(jQuery, Syncfusion);

(function() {

  ej.FindAndReplace = function() {
    this.indexLength=0,this.elements=[],this.matches=[],this.nodeCollection=[];
	this.specialChar=/([{}()|[\]\/\\.*+?^=!:$])/g,this.escapeContent='\\$1';
  }
  ej.FindAndReplace.prototype._addContentEscape=function(content){
	return String(content).replace(this.specialChar, this.escapeContent);
  }

  ej.FindAndReplace.prototype.find=function(text,node,igncase,wholeword){
	if(this.nodeCollection.length)
		this.revertAll();
	this._validateTextContent(text,this._getFormatedText(node),igncase,wholeword);
	if(this.matches.length)
	{
		this._iterateNodes(node),this.matches=[];
		return true;
	}
	else
		return false;
  }
  ej.FindAndReplace.prototype._replace=function(collection,text){
	for(var index1=0;index1<collection.length;index1++) 
		(!index1||!text)?this._elementDefragment(collection[index1].node,text):$(collection[index1].node).remove();	
}
  ej.FindAndReplace.prototype.replaceByIndex=function(Index,text){
	var tempNodes=[]
	for(var index=0;index<this.nodeCollection.length;index++) 
		(index==Index)?	this._replace(this.nodeCollection[index],text):tempNodes.push(this.nodeCollection[index]);	
	this.nodeCollection=tempNodes;
}
  ej.FindAndReplace.prototype.replaceAll=function(text){
	for(var index=0;index<this.nodeCollection.length;index++) 
		this._replace(this.nodeCollection[index],text);	
	this.nodeCollection=[];
	return index;
}

  ej.FindAndReplace.prototype.revertAll=function(){
	for(var index=0;index<this.nodeCollection.length;index++) 
	this._replace(this.nodeCollection[index]);
	this.nodeCollection=[];
}
  
 ej.FindAndReplace.prototype._elementDefragment=function (node,text){
var tempNode=node.nextSibling,tempNode1=node.previousSibling;

if(tempNode&&tempNode1&&tempNode.nodeType==3 && tempNode1.nodeType==3)
{
	tempNode=node.previousSibling;
	tempNode.data=tempNode.data+(text!= undefined ? text:node.firstChild.data)+node.nextSibling.data;	
	$(node.nextSibling).remove();
	$(node).remove();
}
else if(tempNode&&tempNode.nodeType==3)
{	
	tempNode=node.nextSibling;
	tempNode.data=(text!= undefined ? text:node.firstChild.data)+tempNode.data;
	$(node).remove();
}
else if(tempNode1&&tempNode1.nodeType==3)
{
	tempNode=node.previousSibling;
	tempNode.data=tempNode.data+(text!= undefined ? text:node.firstChild.data);
	$(node).remove();
}
else 
{
	tempNode=(text!= undefined) ? document.createTextNode(text):node.firstChild;
	$(node).replaceWith(tempNode);
}
}

  ej.FindAndReplace.prototype._validateTextContent=function(text,content,igncase,wholeword){
 	var target=this._addContentEscape(text),regx=new RegExp(wholeword ? "\\b"+target+"\\b":target,igncase?'gi':'g');
	while(data=regx.exec(content))
		this.matches.push({startIndex:data.index,endIndex:data.index+text.length});
	return this.matches;
}

 ej.FindAndReplace.prototype._traverseNode=function(element,data){

	if (element.nodeType === 3)	
	{	
		out=this._validateData(element,data);
		if(out.curNode) element=out.curNode;
			if(out.status)
			return true;
	}
	
	if(element=element.firstChild)
	do
	{	  
		if(element.nodeType === 3)
		{
			out=this._validateData(element,data);
			if(out.curNode) element=out.curNode;
			if(out.status)
				return true;
		}
		else 		
		{		
			if(this._traverseNode(element,data))
				return true;
		}
	}while(element=element.nextSibling)
	
	return false;
}

 ej.FindAndReplace.prototype._validateData=function(curNode,data){
	var startIndex=this.indexLength,endIndex=this.indexLength+curNode.length;this.indexLength=this.indexLength+curNode.length;	
	if(startIndex>=data.startIndex||data.startIndex<endIndex)
		return this._elementFragment(data,{startIndex:startIndex,endIndex:endIndex},curNode);
	else 
		return {status:false};

}

 ej.FindAndReplace.prototype._elementFragment=function(cIndex,eIndex,element){
	var tempdata=element.data,finalNode=element;
	if((cIndex.startIndex<=eIndex.startIndex)&&(cIndex.endIndex>=eIndex.endIndex))//full Element Replacement
	{
		finalNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(element.data))[0];
		$(element).replaceWith(finalNode);
		this.elements.push({node:finalNode});
	}
	else if((cIndex.startIndex<=eIndex.startIndex)&&(cIndex.endIndex<eIndex.endIndex))
	{
		var tempindex=(cIndex.endIndex-cIndex.startIndex),dataNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substr(0,tempindex)))[0];
		$(dataNode).insertBefore(element);
		element.data=tempdata.substr(tempindex);
		this.elements.push({node:dataNode});
	}	
	else if((cIndex.startIndex>eIndex.startIndex)&&(cIndex.endIndex>=eIndex.endIndex))
	{
		
		tempindex=(cIndex.startIndex-eIndex.startIndex),finalNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substr(tempindex)))[0];
		$(finalNode).insertAfter(element);
		element.data=tempdata.substr(0,tempindex);
		this.elements.push({node:finalNode});
	}
	else if((cIndex.startIndex>eIndex.startIndex)&&(cIndex.endIndex<eIndex.endIndex))
	{
		var tempstart=(cIndex.startIndex-eIndex.startIndex),tempend=tempstart+(cIndex.endIndex-cIndex.startIndex),dataNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substring(tempstart,tempend)))[0];finalNode=document.createTextNode(tempdata.substring(tempend));		
		element.data=tempdata.substr(0,tempstart);
		$(finalNode).insertAfter(element);
		$(dataNode).insertAfter(element);		
		this.elements.push({node:dataNode});
	}
	return {status:cIndex.endIndex>eIndex.startIndex && cIndex.endIndex<=eIndex.endIndex,curNode:finalNode};
}

 ej.FindAndReplace.prototype._getFormatedText=function (element){
	var text='';
	if (element.nodeType === 3) return element.data.replace(/\n/g,' ');
	
	if(element=element.firstChild)
	do
	{	  
		text+= (element.nodeType === 3)?element.data.replace(/\n/g,' '):this._getFormatedText(element);		
	}while(element=element.nextSibling)
	
	return text;
				
}

 ej.FindAndReplace.prototype._iterateNodes=function (curNode){
	temp=this;
	$(this.matches).each(function(index,data)
	{
		temp._traverseNode(curNode,data),temp.nodeCollection.push(temp.elements),temp.indexLength=0,temp.elements=[];		
	});
}
}());


if(ej.RTE.FindAndReplace)
 $.extend(ej.RTE.prototype, ej.RTE.FindAndReplace);;
var clipboardCleaner = (function () {
    function clipboardCleaner(currentDocument, callback, env) {
        this.CleanerState = true;
        this.syncLoad = false;
        this.listContents = [];
        this.blockNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
        this.flagState = true;
        this.content = null;
        this.htmlContent = "";
        this.insertCleanedContent = true;
        this.filterOptions = {
            listConversion: true, cleanCSS: true,
            removeStyles: false,
            cleanElements: true
        };
        this.Collection = [];
        this.blockqouteNodes = [];
        this.tempCleaner = [];
        this.ignorableNodes = ["A", "APPLET", "B", "BLOCKQUOTE",
            "BR", "BUTTON", "CENTER", "CODE", "COL", "COLGROUP", "DD", "DEL", "DFN", "DIR", "DIV", "DL", "DT", "EM",
            "FIELDSET", "FONT", "FORM", "FRAME", "FRAMESET", "H1", "H2", "H3", "H4", "H5", "H6", "HR", "I", "IMG",
            "IFRAME", "INPUT", "INS", "LABEL", "LI", "OL", "OPTION", "P", "PARAM", "PRE", "Q",
            "S", "SELECT", "SPAN", "STRIKE", "STRONG", "SUB", "SUP", "TABLE", "TBODY", "TD", "TEXTAREA", "TFOOT", "TH", "THEAD", "TITLE", "TR",
            "TT", "U", "UL"];
        this.listNodes = [];
        this.ulData = [
            "disc",
            "square",
            "circle",
            "disc",
            "square",
            "circle"
        ];
        this.olData = [
            "decimal",
            "lower-alpha",
            "lower-roman",
            "upper-alpha",
            "upper-roman",
            "lower-greek"
        ];
        var temp = this;
        this.callback = callback;
        this.env = env;
        this.currentDocument = currentDocument;
        if (this._isIE()) {
            if (this.currentDocument.body.addEventListener) {
                this.currentDocument.body.addEventListener("keydown", keyEventRouter);
            }
            else
                this.currentDocument.body.attachEvent("onkeydown", keyEventRouter);
        }
        if (this.currentDocument.body.addEventListener)
            this.currentDocument.body.addEventListener("paste", pasteRouter);
        else
            this.currentDocument.body.attachEvent("onpaste", pasteRouter);
        function pasteRouter(args) {
            if (temp.CleanerState) {
                temp._pasteHandler(args);
                if (temp.syncLoad) {
                    args.preventDefault();
                    args.stopPropagation();
                    return false;
                }
            }
        }
        function keyEventRouter(args) {
            if (temp.CleanerState)
                temp._keydownHandler(args);
        }
    }
    clipboardCleaner.prototype._keydownHandler = function (e, state) {
        if (state === void 0) { state = false; }
        if ((this._isIE() && e.ctrlKey && !e.shiftKey && e.keyCode == 86 && this.flagState) || state) {
            this.flagState = false;
            this._setContent();
        }
    };
    clipboardCleaner.prototype._setContent = function () {
        var temp = this;
        this.content = this.currentDocument.createElement("div");
        var tempText, tempBlock = this.currentDocument.createElement("P");
        this.content.id = "ClipboardData";
        this.content.style.position = "absolute";
        this.content.style.height = "10px";
        this.content.style.width = "10px";
        this.content.style.overflow = "hidden";
        this.content.style.top = "-3000px";
        tempText = this.currentDocument.createTextNode("PastedContent");
        if (ej.browserInfo().name == "chrome") {
            tempBlock.appendChild(tempText);
            this.content.appendChild(tempBlock);
        }
        else
            this.content.appendChild(tempText);
        if (window.getSelection) {
            var selection = this.currentDocument.getSelection();
            if (selection.rangeCount > 0) {
                var range = selection.getRangeAt(0);
                range.deleteContents();
                range.collapse(true);
                range.insertNode(this.content);
                this._updateRange(tempText, 0, tempText.textContent.length);
                this.content.focus();
                this.syncLoad = false;
            }
        }
    };
    clipboardCleaner.prototype._insertContent = function (args) {
        if (args === void 0) { args = true; }
        var tempSpanNode = this.currentDocument.createElement("span"), elemColl = [], content, blockElem = this.currentDocument.createElement("p");
        tempSpanNode.appendChild(content = this.currentDocument.createTextNode(String.fromCharCode(65279)));
        blockElem.appendChild(tempSpanNode);
        this._finalCleanup(this.Container);
        this.Container.appendChild(blockElem);
        if (this._isIE() && args) {
            elemColl = [];
            for (var gt = this.Container.childNodes.length - 1; gt > -1; gt--)
                elemColl.push(this.Container.childNodes.item(gt));
            for (var gt = 0; gt < elemColl.length; gt++)
                this._insertAfter(this.content, elemColl[gt]);
            this.content.removeNode(true);
        }
        else
            this._contentPositionHandler();
        $((ej.browserInfo().name == "msie" || ej.browserInfo().name == "mozilla") ? this.currentDocument.body.parentNode : this.currentDocument.body).scrollTop($(tempSpanNode).offset().top - 25);
        this.callback.call(this.env);
        this._updateRange(content, 0, content.textContent.length);
    };
    clipboardCleaner.prototype._insertAfter = function (elem, newElem) {
        if (elem.nextSibling) {
            elem.parentElement.insertBefore(newElem, elem.nextSibling);
        }
        else {
            elem.parentElement.appendChild(newElem);
        }
    };
    clipboardCleaner.prototype._findValidListType = function (elem) {
        if (elem.nodeType == 3 && elem.textContent.trim().length > 0) {
            this.listContents.push(elem.textContent);
        }
        if (elem = elem.firstChild) {
            do {
                this._findValidListType(elem);
            } while (elem = elem.nextSibling);
        }
    };
    clipboardCleaner.prototype._createNodeCollection = function (parentNodes) {
        var leafnode, temp = this.currentDocument.createElement(parentNodes.shift()), tagName;
        leafnode = temp;
        while (tagName = parentNodes.shift()) {
            temp = this.currentDocument.createElement(tagName).appendChild(temp);
        }
        return { leaf: leafnode, root: temp };
    };
    clipboardCleaner.prototype._contentPositionHandler = function () {
        var selection = this.currentDocument.getSelection(), elem, tempElem, parentNodes = [], childNodes = [], nodeSet;
        if (selection.rangeCount > 0) {
            if (this.content) {
                var range_1 = this.currentDocument.createRange(), Selection_1 = this.currentDocument.getSelection();
                range_1.selectNode(this.content);
                Selection_1.removeAllRanges();
                Selection_1.addRange(range_1);
            }
            var range = selection.getRangeAt(0);
            if (range.startContainer == range.endContainer) {
                if (range.startOffset != range.endOffset)
                    range.deleteContents();
                range.insertNode(this.Container);
                elem = this.Container.parentNode;
                if (elem.nodeName.toLowerCase() != "body") {
                    do
                        parentNodes.push(elem.nodeName.toLowerCase());
                    while (this.blockNode.indexOf(elem.nodeName.toLowerCase()) == -1 && (elem = elem.parentElement));
                    nodeSet = this._createNodeCollection(parentNodes);
                    if (elem)
                        if (elem.nextSibling)
                            elem.parentElement.insertBefore(nodeSet.root, elem.nextSibling);
                        else
                            elem.parentElement.appendChild(nodeSet.root);
                    elem = this.Container;
                    while (elem = elem.nextSibling)
                        nodeSet.leaf.appendChild(elem);
                    this._insertAfter(this.Container.parentElement, this.Container);
                }
                for (var index = 0; index < this.Container.childNodes.length; index++)
                    childNodes.push(this.Container.childNodes[index]);
                while (tempElem = childNodes.shift())
                    this.Container.parentElement.insertBefore(tempElem, this.Container);
            }
            else {
                range.deleteContents();
                range.insertNode(this.Container);
                for (var index = 0; index < this.Container.childNodes.length; index++) {
                    childNodes.push(this.Container.childNodes[index]);
                }
                while (tempElem = childNodes.shift())
                    this.Container.parentElement.insertBefore(tempElem, this.Container);
            }
        }
        this._remove(this.Container);
        this._remove(this.content);
        this.content = null;
    };
    clipboardCleaner.prototype._updateRange = function (node, sOffset, eOffset) {
        var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection();
        range.setStart(node, sOffset);
        range.setEnd(node, eOffset);
        Selection.removeAllRanges();
        Selection.addRange(range);
    };
    clipboardCleaner.prototype._pasteHandler = function (args) {
        this.clipboardData = { plain: null, rtf: null, html: null };
        this.syncLoad = false;
        if (this._isIE())
            this._extractClipboardIE(args);
        else {
            this._fillClipboard(args);
            this._extractClipboardNonIE(args);
        }
    };
    clipboardCleaner.prototype._isIE = function () {
        return navigator.userAgent.match(/Trident|msie/i) != null;
    };
    clipboardCleaner.prototype._extractClipboardNonIE = function (args) {
        if (this.clipboardData.html) {
            this.content = null;
            this.htmlContent = this.clipboardData.html;
            this._processContent(args);
        }
        else if (ej.browserInfo().name == "chrome" && this.clipboardData.plain) {
            var temp = this.currentDocument.createElement("div"), content, tempcontents = this.clipboardData.plain.split("\n");
            var temp2 = this.currentDocument.createElement("p");
            if (tempcontents.length) {
                while (content = tempcontents.shift()) {
                    temp2.appendChild(this.currentDocument.createTextNode(content));
                    tempcontents.length && temp2.appendChild(this.currentDocument.createElement("br"));
                }
            }
            else {
                temp2.appendChild(this.currentDocument.createTextNode(this.clipboardData.plain));
            }
            this.htmlContent = temp2.innerHTML;
            this._processContent(args, false);
        }
        else if (args && args.clipboardData && args.clipboardData.items.length) {
            this.callback.call(this.env, args);
        }
        else {
            this._setContent();
            this._contentUpdater();
        }
    };
    clipboardCleaner.prototype._extractClipboardIE = function (args) {
        this._contentUpdater();
    };
    clipboardCleaner.prototype._contentUpdater = function () {
        var temp = this;
        setTimeout(function () {
            if (temp.content)
                temp.clipboardData.html = temp.htmlContent = temp.content.innerHTML;
            !temp.flagState && (temp.flagState = true);
            temp._processContent();
        }, 0);
    };
    clipboardCleaner.prototype._fillClipboard = function (args) {
        this.clipboardData.html = args.clipboardData.getData("text/html") ? args.clipboardData.getData("text/html") : null;
        this.clipboardData.plain = args.clipboardData.getData("text/plain") ? args.clipboardData.getData("text/plain") : null;
        this.clipboardData.rtf = args.clipboardData.getData("text/rtf") ? args.clipboardData.getData("text/rtf") : null;
    };
    clipboardCleaner.prototype._processContent = function (args, state) {
        if (args === void 0) { args = null; }
        if (state === void 0) { state = true; }
        var elm = this.currentDocument.createElement("p"), temp = this, nonBlock = true;
        var patern = /class="?Mso|style="[^ ]*\bmso-/i, tempContainer = this.currentDocument.createElement("p"), ChildNode;
        if (patern.test(this.htmlContent) && state) {
            this.htmlContent = this.htmlContent.replace(/<img[^>]+>/i, "");
            elm.innerHTML = this.htmlContent;
            this.syncLoad = true;
            this.Collection = [];
            this.blockqouteNodes = [];
            this.listNodes = [];
            this._cleanup(elm);
            this._flush();
            if (this.filterOptions.listConversion) {
                this._listConverter();
            }
            if (this.filterOptions.cleanElements) {
                this._blockquoteConvert();
                this._cleanElement(elm);
                this._flush();
            }
            if (this.filterOptions.cleanCSS) {
                this._cleanStyles(elm);
                this._flush(false);
            }
            this.Container = elm;
            if (this.insertCleanedContent)
                this._insertContent();
        }
        else {
            this.syncLoad = true;
            elm.innerHTML = this.htmlContent;
            if (this.filterOptions.cleanCSS) {
                this._cleanStyles(elm);
                this._flush(false);
            }
            if (elm.childNodes.length) {
                for (var index = 0; index < elm.childNodes.length; index++) {
                    if (this.blockNode.indexOf(elm.childNodes[index].nodeName.toLowerCase()) != -1)
                        nonBlock = false;
                }
                if (nonBlock) {
                    tempContainer.appendChild(elm);
                    elm = tempContainer;
                }
            }
            this.Container = elm;
            if (this.insertCleanedContent)
                this._insertContent(!nonBlock);
        }
    };
    clipboardCleaner.prototype._flush = function (check) {
        if (check === void 0) { check = true; }
        var temp, tempColl = [];
        if (check) {
            while (temp = this.tempCleaner.shift())
                this._remove(temp);
        }
        else
            while (temp = this.tempCleaner.shift()) {
                if (temp.childNodes.length) {
                    tempColl = [];
                    for (var index = 0; index < temp.childNodes.length; index++) {
                        tempColl.push(temp.childNodes[index]);
                    }
                    for (var index = 0; index < tempColl.length; index++) {
                        temp.parentElement.insertBefore(tempColl[index], temp);
                    }
                }
                this._remove(temp);
            }
    };
    clipboardCleaner.prototype._makeConvertion = function () {
        var root = this.currentDocument.createElement("div"), temp, pLevel = 1, prevList, listCount = 0, elem;
        for (var index = 0; index < this.Collection.length; index++) {
            if ((this.Collection[index].level == 1) && listCount == 0) {
                if (this.Collection[index].content) {
                    root.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                    prevList = this.currentDocument.createElement("li");
                    prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                    temp.appendChild(prevList);
                    temp.setAttribute("level", this.Collection[index].level.toString());
                    temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
                }
            }
            else if (this.Collection[index].level == pLevel) {
                if (prevList.parentElement.tagName.toLowerCase() == this.Collection[index].type) {
                    prevList.parentElement.appendChild(prevList = this.currentDocument.createElement("li"));
                    prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                }
                else {
                    temp = this.currentDocument.createElement(this.Collection[index].type);
                    this._insertAfter(prevList.parentElement, temp);
                    prevList = this.currentDocument.createElement("li");
                    prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                    temp.appendChild(prevList);
                    temp.setAttribute("level", this.Collection[index].level.toString());
                }
            }
            else if (this.Collection[index].level > pLevel) {
                prevList.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                prevList = this.currentDocument.createElement("li");
                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                temp.appendChild(prevList);
                prevList.style.marginLeft = (this.Collection[index].level - pLevel - 1) * 40 + "px";
                temp.setAttribute("level", this.Collection[index].level.toString());
                temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
            }
            else if (this.Collection[index].level == 1) {
                if (root.lastChild.tagName.toLowerCase() == this.Collection[index].type)
                    temp = root.lastChild;
                else
                    root.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                prevList = this.currentDocument.createElement("li");
                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                temp.appendChild(prevList);
                temp.setAttribute("level", this.Collection[index].level.toString());
                temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
            }
            else {
                elem = prevList;
                while (elem = elem.parentElement) {
                    if (elem.attributes.getNamedItem("level")) {
                        if (parseInt(elem.attributes.getNamedItem("level").textContent) == this.Collection[index].level) {
                            if (elem.tagName.toLowerCase() == this.Collection[index].type) {
                                prevList = this.currentDocument.createElement("li");
                                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                                elem.appendChild(prevList);
                            }
                            else {
                                temp = this.currentDocument.createElement(this.Collection[index].type);
                                this._insertAfter(prevList.parentElement, temp);
                                prevList = this.currentDocument.createElement("li");
                                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                                temp.appendChild(prevList);
                                temp.setAttribute("level", this.Collection[index].level.toString());
                                temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
                            }
                            break;
                        }
                        else if (this.Collection[index].level > parseInt(elem.attributes.getNamedItem("level").textContent)) {
                            elem.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                            prevList = this.currentDocument.createElement("li");
                            prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                            temp.appendChild(prevList);
                            prevList.style.marginLeft = (this.Collection[index].level - parseInt(elem.attributes.getNamedItem("level").textContent) - 1) * 40 + "px";
                            temp.setAttribute("level", this.Collection[index].level.toString());
                            temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
                            break;
                        }
                    }
                    continue;
                }
            }
            pLevel = this.Collection[index].level;
            listCount++;
        }
        return root;
    };
    clipboardCleaner.prototype._listConverter = function () {
        var content, level, type, stNode, tempNode;
        var data = [], elemColl = [];
        for (var index = 0; index < this.listNodes.length; index++) {
            if (this.listNodes[index] == null) {
                data.push({ content: this._makeConvertion(), node: this.listNodes[index - 1] });
                this.Collection = [];
                continue;
            }
            content = this.listNodes[index].attributes.getNamedItem("style").textContent;
            if (content && content.indexOf("level") != -1)
                level = parseInt(content.charAt(content.indexOf("level") + 5));
            else
                level = 1;
            this.listContents = [];
            this._findValidListType(this.listNodes[index]);
            if (this.listContents[0].length > 1)
                type = "ol";
            else
                type = "ul";
            tempNode = this.listContents[1] ?
                this.currentDocument.createTextNode(this.listContents[1]) :
                this.currentDocument.createTextNode("");
            this.Collection.push({
                type: type,
                content: tempNode,
                level: level
            });
        }
        while ((stNode = this.listNodes.shift()) ? stNode : (stNode = this.listNodes.shift())) {
            elemColl = [];
            for (var temp1 = 0; temp1 < data.length; temp1++) {
                if (data[temp1].node == stNode) {
                    for (var index = 0; index < data[temp1].content.childNodes.length; index++) {
                        elemColl.push(data[temp1].content.childNodes[index]);
                    }
                    for (var index = 0; index < elemColl.length; index++) {
                        stNode.parentElement.insertBefore(elemColl[index], stNode);
                    }
                    break;
                }
            }
            stNode.remove && stNode.remove();
            stNode.removeNode && stNode.removeNode(true);
        }
    };
    clipboardCleaner.prototype._blockquoteConvert = function () {
        var temp, elemColl = [];
        for (var index = 0; index < this.blockqouteNodes.length; index++) {
            temp = this.currentDocument.createElement("blockquote");
            elemColl = [];
            if (this.blockqouteNodes[index].childNodes && this.blockqouteNodes[index].childNodes.length) {
                for (var gt = 0; gt < this.blockqouteNodes[index].childNodes.length; gt++)
                    elemColl.push(this.blockqouteNodes[index].childNodes.item(gt));
                for (var gt = 0; gt < elemColl.length; gt++)
                    temp.appendChild(elemColl[gt]);
            }
            this.blockqouteNodes[index].parentElement.insertBefore(temp, this.blockqouteNodes[index]);
            this.blockqouteNodes[index].remove && this.blockqouteNodes[index].remove();
            this.blockqouteNodes[index].removeNode && this.blockqouteNodes[index].removeNode(true);
        }
    };
    clipboardCleaner.prototype._cleanup = function (node) {
        var temp, prevflagState;
        for (var index = 0; index < node.childNodes.length; index++) {
            if (this.ignorableNodes.indexOf(node.childNodes[index].nodeName) == -1 ||
                (node.childNodes[index].nodeType == 3 && node.childNodes[index].textContent.trim() == '')) {
                this.tempCleaner.push(node.childNodes[index]);
                continue;
            }
            else if (node.childNodes[index].className &&
                node.childNodes[index].className.toLowerCase().indexOf("msoquote") != -1) {
                this.blockqouteNodes.push(node.childNodes[index]);
            }
            else if (node.childNodes[index].className &&
                node.childNodes[index].className.toLowerCase().indexOf("msolistparagraph") != -1) {
                this.listNodes.push(node.childNodes[index]);
            }
            if (prevflagState && (this.blockNode.indexOf(node.childNodes[index].nodeName.toLowerCase()) != -1) && !(node.childNodes[index].className &&
                node.childNodes[index].className.toLowerCase().indexOf("msolistparagraph") != -1))
                this.listNodes.push(null);
            if (this.blockNode.indexOf(node.childNodes[index].nodeName.toLowerCase()) != -1)
                if (node.childNodes[index].className &&
                    node.childNodes[index].className.toLowerCase().indexOf("msolistparagraph") != -1)
                    prevflagState = true;
                else
                    prevflagState = false;
        }
        if (this.listNodes.length && (this.listNodes[this.listNodes.length - 1] != null)) {
            this.listNodes.push(null);
        }
    };
    clipboardCleaner.prototype._finalCleanup = function (node) {
        var temp, elemCollection = [];
        for (var index = 0; index < node.childNodes.length; index++) {
            if (node.childNodes[index] && node.childNodes[index].nodeType != 3
                && (this.blockNode.indexOf(node.childNodes[index].nodeName.toLowerCase()) != -1)
                && node.childNodes[index].innerHTML
                && (node.childNodes[index].innerHTML.trim() == ""))
                elemCollection.push(node.childNodes[index]);
        }
        while (temp = elemCollection.shift())
            this._remove(temp);
    };
    clipboardCleaner.prototype._getlistStyle = function (listType, level) {
        level = (level > 0) ? level - 1 : level;
        if (listType == 'ol')
            return (level < this.olData.length ? this.olData[level] : this.olData[0]);
        else
            return (level < this.ulData.length ? this.ulData[level] : this.ulData[0]);
    };
    clipboardCleaner.prototype._cleanElement = function (elem) {
        var temp;
        if (elem.nodeType == 3) {
            if (elem.textContent.trim() == '')
                this.tempCleaner.push(elem);
        }
        else if (elem && this.ignorableNodes.indexOf(elem.nodeName) == -1) {
            this.tempCleaner.push(elem);
        }
        if (elem = elem.firstChild)
            do {
                this._cleanElement(elem);
            } while (elem = elem.nextSibling);
    };
    clipboardCleaner.prototype._cleanStyles = function (elem) {
        var temp;
        if (elem && elem.nodeType != 3) {
            this._cleanCSSClass(elem);
            this._cleanCSSStyle(elem);
            if ((elem.nodeName == "SPAN")
                && !elem.attributes.getNamedItem("style")
                && !elem.attributes.getNamedItem("class")) {
                this.tempCleaner.push(elem);
            }
            else if ((elem.nodeName == "FONT")
                && this.filterOptions.removeStyles) {
                this.tempCleaner.push(elem);
            }
        }
        if (elem = elem.firstChild)
            do {
                this._cleanStyles(elem);
            } while (elem = elem.nextSibling);
    };
    clipboardCleaner.prototype._cleanCSSClass = function (elem) {
        if (elem.attributes && elem.attributes.getNamedItem("class") && (this.filterOptions.cleanCSS || this.filterOptions.removeStyles)) {
            var classData = elem.className.split(" "), finalClases = '', attrib = void 0;
            for (var index = 0; index < classData.length; index++) {
                if (classData[index].toLowerCase().indexOf("mso") == -1 && this.filterOptions.cleanCSS) {
                    finalClases += classData[index] + " ";
                }
            }
            if (finalClases.length && !this.filterOptions.removeStyles) {
                attrib = this.currentDocument.createAttribute("class");
                attrib.value = finalClases;
                elem.attributes.setNamedItem(attrib);
            }
            else
                elem.attributes.removeNamedItem("class");
        }
    };
    clipboardCleaner.prototype._cleanCSSStyle = function (elem) {
        if (elem.attributes && elem.attributes.getNamedItem("style") && (this.filterOptions.cleanCSS || this.filterOptions.removeStyles)) {
            var styleData = elem.attributes.getNamedItem("style").textContent.split(";"), finalCss = '', attrib = void 0;
            for (var index = 0; index < styleData.length; index++) {
                if (styleData[index].toLowerCase().indexOf("mso") == -1) {
                    finalCss += styleData[index] + ";";
                }
            }
            if (finalCss.length && !this.filterOptions.removeStyles) {
                attrib = this.currentDocument.createAttribute("style");
                attrib.value = finalCss;
                elem.attributes.setNamedItem(attrib);
            }
            else
                elem.attributes.removeNamedItem("style");
            if (elem.attributes.getNamedItem("align") && !(elem.tagName === "FONT"))
                elem.attributes.removeNamedItem("align");
        }
    };
    clipboardCleaner.prototype._remove = function (elem) {
        if (elem)
            if (elem.remove)
                elem.remove();
            else if (elem.removeNode)
                elem.removeNode(true);
            else if (elem.textContent)
                elem.textContent = "";
    };
    return clipboardCleaner;
}());
$.extend(ej, { "clipboardCleaner": clipboardCleaner });
window["ClipboardCleaner"] = undefined;
;
"use strict";
var documentManager;
(function (documentManager) {
    var editorManager = (function () {
        function editorManager(target, win) {
            this.formatInfo = new formateDataCollection();
            this._nodeCollection = [];
            this._iterationStatus = false;
            this.filterNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this.advanceFilterNode = ["img", "video", "table", "tbody", "tr", "td", "th"];
            this.indentFilter = ["img", "video"];
            this._junkSpanNodes = [];
            this.currentDocument = target;
            this.currentWindow = win;
            this._rangeExtract = new RangeExtractor(this.currentDocument);
            this._bindEvent();
        }
        editorManager.prototype._bindEvent = function () {
            $(this.currentDocument.body).on("keydown", $.proxy(this._editorKeyUpEvent, this));
        };
        editorManager.prototype._editorKeyUpEvent = function (e) {
            if (this._junkContentStatus) {
                var range = this._getRangy(this.currentWindow, this.currentDocument), rangeContainer = range.startContainer, rangeOffset = range.startOffset;
                if (!e.shiftKey && (e.which >= 37 && e.which <= 40) && (rangeContainer.nodeType == 3)) {
                    this._junkContentStatus = false;
                    this._iterateCompleteNode(rangeContainer, e, rangeOffset);
                }
            }
        };
        editorManager.prototype._iterateCompleteNode = function (element, e, range) {
            var oldlen = element.data.length;
            this._junkSpanNodes = [];
            this._removeJunkContent(this.currentDocument.body);
            this._collectJunkSpanNodes(this.currentDocument.body);
            this._removeJunkSpanNodes();
            (oldlen > element.data.length) && range--;
            !element.data && $(element).remove();
            if (element.data.trim()) {
                this._updateCursor(element, range);
            }
        };
        editorManager.prototype._collectJunkSpanNodes = function (stNode) {
            var startNode = stNode;
            if ($(startNode).is("span") && !$(startNode).attr("style"))
                this._junkSpanNodes.push(startNode);
            if (startNode = startNode.firstChild)
                do {
                    if ($(startNode).is("span") && !$(startNode).attr("style"))
                        this._junkSpanNodes.push(startNode);
                    this._collectJunkSpanNodes(startNode);
                } while (startNode = startNode.nextSibling);
        };
        editorManager.prototype._removeJunkSpanNodes = function () {
            var temp;
            while (temp = this._junkSpanNodes.shift()) {
                if (temp.childNodes.length)
                    $(temp).replaceWith(temp.childNodes);
                else
                    $(temp).remove();
            }
        };
        editorManager.prototype._removeJunkContent = function (startNode) {
            var temp = startNode;
            if (temp.nodeType == 3)
                this._removeCursorText(temp);
            if (temp = temp.firstChild)
                do {
                    if (temp.nodeType == 3)
                        this._removeCursorText(temp);
                    else
                        this._removeJunkContent(temp);
                } while (temp = temp.nextSibling);
        };
        editorManager.prototype._removeCursorText = function (element) {
            element.data = element.data.replace(String.fromCharCode(65279), "");
        };
        editorManager.prototype.focus = function () {
            var objExec = this;
            setTimeout(function () {
                var browserInfo = ej.browserInfo();
                if (browserInfo.name == "webkit")
                    objExec.currentWindow.focus();
                else
                    objExec.currentWindow.document.body.focus();
            }, 100);
        };
        editorManager.prototype._justifyContent = function (Value) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            this._onApplyjustify(Value, this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._applyFormateBlock = function (Value) {
            var range = this._getRangy(this.currentWindow, this.currentDocument);
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._applyChanges(Value, this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
            this._selectionRange = this._getRangy(this.currentWindow, this.currentDocument);
        };
        editorManager.prototype._applyList = function (value, listType) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            this._applyOrderedList(value.toLowerCase() == "orderlist" ? "ol" : "ul", this.currentDocument, this.currentWindow, listType);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._applyIndent = function (value) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            if (value)
                this._onApplyIndent(this.currentDocument, this.currentWindow);
            else
                this._onApplyDecreaseIndent(this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._getRangy = function (_window, _document) {
            if (_window.getSelection() && _window.getSelection().rangeCount > 0)
                return _window.getSelection().getRangeAt(0);
            else {
                var range;
                try {
                    range = _window.document.createRange();
                    range.setStart(_window.document.body, 0);
                    range.setEnd(_window.document.body, 0);
                }
                catch (error) {
                    range = _document.createRange();
                    range.setStart(_document.body, 0);
                    range.setEnd(_document.body, 0);
                }
                return range;
            }
        };
        editorManager.prototype._getexactSelectedNode = function (range, parentDoc) {
            var nodeDetails = [];
            var _parentNode = [];
            this._parentDoc = parentDoc;
            var startNode = $(this._parentDoc.body).find("span#startRange");
            var that = this;
            function visit(node) {
                if (node.nodeType == 3 && (($.trim(node.nodeValue) != "" || node.nodeValue == "\ufeff") || ($.trim(node.nodeValue) == "" && node.nextSibling == startNode[0]))) {
                    nodeDetails.push(node);
                }
                else if (node.nodeValue && node.nodeName != "#comment" && node.nodeValue.trim() == "" && that.range.endContainer.parentNode.nextSibling != that._next) {
                    if ($.inArray(node.previousElementSibling, _parentNode) < 0)
                        _parentNode.push(node.previousElementSibling);
                }
                else if ((node.nodeName.toLowerCase() == "br" || ($.inArray(node.nodeName.toLowerCase(), that.filterNode) < 0)) && ($.inArray(node.parentNode, nodeDetails) < 0) && node.nodeName.toLowerCase() != "body" && $.inArray(node.nodeName.toLowerCase(), that.advanceFilterNode) < 0 && ((!ej.isNullOrUndefined(nodeDetails[nodeDetails.length - 1])) && nodeDetails[nodeDetails.length - 1].parentNode != node.parentNode) && node.previousSibling && node.previousSibling.parentNode != node.parentNode)
                    nodeDetails.push(node.parentNode);
                else if (($.inArray(node.nodeName.toLowerCase(), that.advanceFilterNode) >= 0) && ej.isNullOrUndefined(node.firstChild))
                    nodeDetails.push(node);
                else {
                    node = node.firstChild;
                    while (node) {
                        visit(node);
                        node = node.nextSibling;
                    }
                }
            }
            this._generateRange(range);
            this._traverse(visit);
            return nodeDetails;
        };
        editorManager.prototype._getStartEndElement = function (tnode, root) {
            if (this._isAncestor(root, tnode)) {
                while (tnode && tnode.parentNode != root) {
                    tnode = tnode.parentNode;
                }
            }
            return tnode;
        };
        editorManager.prototype._generateRange = function (range) {
            var root = range.commonAncestorContainer;
            this._next = range.startContainer == root && !this._isTextNode(range.startContainer) ? range.startContainer.childNodes[range.startOffset] : this._getStartEndElement(range.startContainer, root);
            this._end = range.endContainer == root && !this._isTextNode(range.endContainer) ? range.endContainer.childNodes[range.endOffset] : (this._getStartEndElement(range.endContainer, root).nodeName.toLowerCase() != "body") && this._getStartEndElement(range.endContainer, root).nextSibling;
        };
        editorManager.prototype._traverse = function (callback) {
            var that = this, current;
            function next() {
                if (that._next != ((that._isTextNode(that.range.endContainer) ? that.range.endContainer.parentNode.nextSibling : that.range.endContainer.nextElementSibling)) && that.range.endContainer.parentNode.nextSibling != that._next) {
                    that._current = that._next;
                    that._next = that._current && that._current.nextSibling != $(that._parentDoc.body).find("span#endRange")[0] && that._current.nextSibling != (ej.isNullOrUndefined(that._end) ? that.range.endContainer.nextSibling : that._end) ? that._current.nextSibling : null;
                    return that._current;
                }
                else {
                    return null;
                }
            }
            while (current = next()) {
                if (that._hasSubNodes()) {
                    that._getSubtree(that._getRangy(that.currentWindow, that.currentDocument));
                    that._traverse(callback);
                }
                else {
                    var _nextNode = current;
                    if (that.range.startContainer.nodeName.toLowerCase() != "body") {
                        if (that._next == null && _nextNode != (that.range.endContainer)) {
                            while (ej.isNullOrUndefined(that._next) && !ej.isNullOrUndefined(_nextNode)) {
                                _nextNode = _nextNode.parentNode;
                                if ((!ej.isNullOrUndefined(_nextNode)) && that._current.nextSibling != $(that._parentDoc.body).find("span#endRange")[0])
                                    that._next = _nextNode.nextSibling;
                            }
                        }
                    }
                    callback(current);
                }
            }
            return current;
        };
        editorManager.prototype._hasSubNodes = function () {
            return !this._isTextNode(this._current) && (this._isAncestorItself(this._current, this.range.startContainer) ||
                this._isAncestorItself(this._current, this.range.endContainer));
        };
        editorManager.prototype._isTextNode = function (node) {
            return node && node.nodeValue !== null && node.data !== null;
        };
        editorManager.prototype._isAncestor = function (parent, node) {
            try {
                return !this._isTextNode(parent) && ($.contains(parent, (this._isTextNode(node) ? node.parentNode : node)) || node.parentNode == parent);
            }
            catch (e) {
                return false;
            }
        };
        editorManager.prototype._isAncestorItself = function (root, node) {
            return this._isAncestor(root, node) || root == node;
        };
        editorManager.prototype._getSubtree = function (range) {
            var that = this;
            var subRange = that.range.cloneRange();
            subRange.selectNodeContents(that._current);
            if (that._isAncestorItself(that._current, that.range.startContainer)) {
                subRange.setStart(that.range.startContainer, that.range.startOffset);
            }
            if (that._isAncestorItself(that._current, that.range.endContainer)) {
                subRange.setEnd(that.range.endContainer, that.range.endOffset);
            }
            return this._generateRange(subRange);
        };
        editorManager.prototype._getModifedRange = function (range) {
            if (range.endOffset == 0 && range.startContainer != range.endContainer) {
                var ele = range.endContainer;
                do {
                    ele = ej.isNullOrUndefined(range.endContainer.previousSibling) ? ele.parentNode : ele;
                } while (ej.isNullOrUndefined(ele.previousSibling));
                if (this._isTextNode(ele.previousSibling) && $.trim(ele.previousSibling.textContent).length != 0)
                    range.setEnd(ele.previousSibling, ele.previousSibling.childNodes.length);
                else {
                    range.setEnd(ele.previousSibling, ele.previousSibling.childNodes.length);
                }
            }
        };
        editorManager.prototype._getSelectedParent = function (selNode1) {
            var _parentNode = [], selNode = selNode1;
            for (var i = 0; i < selNode.length; i++) {
                if (this._isTextNode(selNode[i])) {
                    while (selNode[i] && selNode[i].parentNode && selNode[i].parentNode.nodeName.toLowerCase() != "body" && ($.inArray(selNode[i].parentNode.nodeName.toLowerCase(), this.filterNode)) < 0) {
                        selNode[i] = selNode[i].parentNode;
                    }
                    if (selNode[i].parentNode.nodeName.toLowerCase() == "body")
                        _parentNode.push(this._updateParent(selNode[i]));
                }
                if (selNode[i] && selNode[i].parentNode && selNode[i].parentNode.nodeName.toLowerCase() != "body" && $.inArray(selNode[i].parentNode, _parentNode) < 0) {
                    if (selNode[i].parentNode.nodeName.toLowerCase() != "body" && selNode[i].nodeName.toLowerCase() != "img" && selNode[i].nodeName.toLowerCase() != "video")
                        _parentNode.push(selNode[i].parentNode);
                    else
                        _parentNode.push(selNode[i]);
                }
            }
            return _parentNode;
        };
        editorManager.prototype._updateParent = function (node) {
            var nodeColl = [node], temp = node, leftBlockNode, rightBlockNode, tempDiv = document.createElement("div");
            ;
            while (temp = temp.previousSibling) {
                if ($.inArray(temp.nodeName.toLowerCase(), this.filterNode) != -1) {
                    leftBlockNode = temp;
                    break;
                }
                else
                    nodeColl.push(temp);
            }
            nodeColl = nodeColl.reverse();
            temp = node;
            while (temp = temp.nextSibling) {
                if ($.inArray(temp.nodeName.toLowerCase(), this.filterNode) != -1) {
                    rightBlockNode = temp;
                    break;
                }
                else
                    nodeColl.push(temp);
            }
            $(nodeColl).appendTo(tempDiv);
            if (leftBlockNode)
                $(tempDiv).insertAfter(leftBlockNode);
            else if (rightBlockNode)
                $(tempDiv).insertBefore(rightBlockNode);
            else
                $(tempDiv).appendTo(this.currentDocument.body);
            return tempDiv;
        };
        editorManager.prototype._applyChanges = function (formatBlock, parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc);
            var selNode = selNode1.slice();
            var tag = (document.createElement(formatBlock.substring(formatBlock.indexOf("<") + 1, formatBlock.indexOf(">"))));
            if (selNode.length == 0 && this.range.startContainer.nodeName.toLowerCase() == "body" && this.range.endContainer.nodeName.toLowerCase() == "body" && this.range.commonAncestorContainer.nodeName.toLowerCase() == "body" && this._parentDoc.body.innerHTML == "") {
                this.focus();
                tag.innerHTML = "&nbsp;";
                this._parentDoc.body.innerHTML = tag.outerHTML;
            }
            else {
                var exatSelNode = this._getSelectedParent(selNode);
                var nodeArray = [];
                nodeArray.push(selNode[0]);
                var _prevParent = this._getSelectedParent(nodeArray)[0];
                var _childNode = [];
                var tval = 0;
                var condi = false;
                var _tdiv = document.createElement("div");
                var dummyNode = document.createElement("div");
                var _newparent = this._getSelectedParent(nodeArray)[0];
                var _prevParntNode, selVal, tnode, _isListNode, _tobj, _liNode, _liPrevious;
                for (selVal = 0; selVal < exatSelNode.length; selVal++) {
                    nodeArray = [];
                    nodeArray.push(exatSelNode[selVal]);
                    _prevParent = this._getSelectedParent(nodeArray)[0];
                    if ($(exatSelNode[selVal]).attr("style"))
                        $(tag).attr("style", $(exatSelNode[selVal]).attr("style"));
                    if ($.inArray(_prevParent, _childNode) >= 0) {
                        var node;
                    }
                    else {
                        _childNode.push(_prevParent);
                        if (tag.innerHTML.length != 0) {
                            if (_childNode[tval].nodeName.toLowerCase() != "td" && _childNode[tval].nodeName.toLowerCase() != "tr" && _childNode[tval].nodeName.toLowerCase() != "tbody" && _childNode[tval].nodeName.toLowerCase() != "li" && _childNode[tval].nodeName.toLowerCase() != "body") {
                                $(_childNode[tval]).replaceWith(tag.outerHTML);
                            }
                            else if (_childNode[tval].nodeName.toLowerCase() != "tr" && _childNode[tval].nodeName.toLowerCase() != "tbody") {
                                $(_childNode[tval]).prepend("<div></div>");
                                _tdiv.innerHTML = tag.outerHTML;
                                _childNode[tval].replaceChild(_tdiv.firstChild, _childNode[tval].firstChild);
                            }
                            tval++;
                        }
                        tag.innerHTML = "";
                        _tdiv.innerHTML = "";
                    }
                    tnode = exatSelNode[selVal];
                    _tobj = false;
                    if (!ej.isNullOrUndefined(tnode.parentNode)) {
                        _isListNode = tnode.nodeName.toLowerCase() == "li";
                    }
                    if (!ej.isNullOrUndefined(tnode)) {
                        _liNode = tnode;
                        while (_liNode.childNodes.length != 0) {
                            if ($.inArray(tnode.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                while (tnode.firstChild && $.inArray(tnode.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                    $(tag).append(_liNode.childNodes[0]);
                                }
                            }
                            else {
                                break;
                            }
                        }
                        _liPrevious = tnode.previousSibling;
                    }
                    _prevParntNode = tnode.parentNode;
                    if (tag.innerHTML.length != 0) {
                        if (tnode.nodeName.toLowerCase() != "td" && tnode.nodeName.toLowerCase() != "tr" && tnode.nodeName.toLowerCase() != "tbody" && tnode.nodeName.toLowerCase() != "li" && tnode.nodeName.toLowerCase() != "body") {
                            $(tnode).replaceWith(tag.outerHTML);
                        }
                        else if (tnode.nodeName.toLowerCase() != "tr" && tnode.nodeName.toLowerCase() != "tbody") {
                            $(tnode).prepend("<div></div>");
                            _tdiv.innerHTML = tag.outerHTML;
                            tnode.replaceChild(_tdiv.firstChild, tnode.firstChild);
                        }
                        tval++;
                    }
                    tag.innerHTML = "";
                    _tdiv.innerHTML = "";
                    $(tag).removeAttr("style");
                }
            }
        };
        editorManager.prototype._validateIndent = function (element) {
            var _indentStatus = false;
            do {
                if ($(element).attr("style") && (parseInt($(element).css("margin-left")) > 0)) {
                    _indentStatus = true;
                }
            } while ((element = element.parentNode) && !$(element).is("body"));
            return _indentStatus;
        };
        editorManager.prototype._validateFontSize = function (element) {
            var size = parseInt($(((element.nodeType == 3) ? element.parentNode : element)).css("font-size"));
            return (Math.round(size * (3 / 4))) + "pt";
        };
        editorManager.prototype._onApplyIndent = function (parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc), temp;
            var selNode = selNode1.slice();
            var exatSelNode = this._getSelectedParent(selNode);
            if (selNode.length == 0 && this.range.startContainer.nodeName.toLowerCase() == "body" && this.range.endContainer.nodeName.toLowerCase() == "body" && this.range.commonAncestorContainer.nodeName.toLowerCase() == "body" && this._parentDoc.body.innerHTML == "") {
            }
            else {
                for (var node = 0; node <= exatSelNode.length - 1; node++) {
                    if (exatSelNode[node].nodeName.toLowerCase() == "td") {
                        $(exatSelNode[node]).append($(temp = (document.createElement("p"))).append(exatSelNode[node].childNodes));
                        exatSelNode[node] = temp;
                    }
                    if (exatSelNode[node].nodeName.toLowerCase() != "li")
                        $(exatSelNode[node]).css("margin-left", 40 + parseInt($(exatSelNode[node]).css("margin-left")) + "px");
                    else {
                        if ($(exatSelNode[node]).prev().length == 0)
                            $(exatSelNode[node].parentNode).css("margin-left", parseInt($(exatSelNode[node].parentNode).css("margin-left")) + 40 + "px");
                        else
                            $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) + 40 + "px");
                    }
                }
            }
        };
        editorManager.prototype._onApplyDecreaseIndent = function (parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc);
            var selNode = selNode1.slice();
            var exatSelNode = this._getSelectedParent(selNode);
            for (var node = 0; node <= exatSelNode.length - 1; node++) {
                if (parseInt($(exatSelNode[node]).css("margin-left")) >= 40 && exatSelNode[node].nodeName.toLowerCase() != "li")
                    $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) - 40);
                else {
                    if ($(exatSelNode[node]).prev().length == 0 && parseInt($(exatSelNode[node].parentNode).css("margin-left")) >= 40)
                        $(exatSelNode[node].parentNode).css("margin-left", parseInt($(exatSelNode[node].parentNode).css("margin-left")) - 40);
                    else if (parseInt($(exatSelNode[node]).css("margin-left")) >= 40)
                        $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) - 40);
                }
            }
        };
        editorManager.prototype._getNodeName = function (node) {
            if (this._isTextNode(node))
                return "#text";
            else
                return node.nodeName.toLowerCase();
        };
        editorManager.prototype._onApplyjustify = function (justify, parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode = this._getexactSelectedNode(this.range, parentDoc);
            var _exactparentEle = this._getSelectedParent(selNode);
            for (var a = 0; a < _exactparentEle.length; a++) {
                var node = document.createElement("div");
                if (_exactparentEle[a].nodeName.toLowerCase() == "li") {
                    var _tnode = $(_exactparentEle[a]).children(), _val = 0;
                    for (var b = 0; b < _tnode.length; b++) {
                        if ($.inArray(this._getNodeName(_tnode[b]), this.filterNode) > 0)
                            _val++;
                    }
                    if (_val > 0) {
                        while (_exactparentEle[a].childNodes.length > 0) {
                            if (this._isTextNode(_exactparentEle[a].childNodes[0]) || $.inArray(this._getNodeName(_exactparentEle[a].childNodes[0]), this.filterNode) < 0)
                                node.appendChild(_exactparentEle[a].childNodes[0]);
                            else
                                break;
                        }
                    }
                    else
                        $(_exactparentEle[a]).css("text-align", justify);
                    if (node.childNodes.length > 0) {
                        $(node).css("text-align", justify);
                        _exactparentEle[a].insertBefore(node, _exactparentEle[a].childNodes[0]);
                        _val = 0;
                    }
                }
                else {
                    $(_exactparentEle[a]).css("text-align", justify);
                }
            }
        };
        editorManager.prototype._getParentNodeCollection = function (selNode) {
            var _backUpSelNode = selNode;
            var _backUpSelNodeName = _backUpSelNode.parentNode.nodeName.toLowerCase();
            var _nodeDetails = [];
            _nodeDetails.push(_backUpSelNode);
            while (_backUpSelNodeName != "body" && (_backUpSelNodeName == "li" || _backUpSelNodeName == "ol" || _backUpSelNodeName == "ul")) {
                _backUpSelNode = _backUpSelNode.parentNode;
                _backUpSelNodeName = _backUpSelNode.parentNode.nodeName.toLowerCase();
                _nodeDetails.push(_backUpSelNode);
            }
            return _nodeDetails;
        };
        editorManager.prototype._generateListParentTag = function (list, selNode, listType) {
            var tag = document.createElement(list);
            $(tag).css("list-style-type", listType);
            if (selNode.nodeName.toLowerCase() != "li")
                $(tag).insertBefore(selNode);
            else
                $(tag).insertBefore(selNode.parentNode);
            return tag;
        };
        editorManager.prototype._applyOrderedList = function (list, parentDoc, _window, listType) {
            this.range = this._getRangy(_window, parentDoc);
            var nodeArray = this._getexactSelectedNode(this.range, parentDoc);
            var beforeNode = document.createElement(list);
            var afterNode = document.createElement(list);
            var _childNode = new Array();
            var selNode = this._getSelectedParent(nodeArray);
            var _parentNode = this._getParentNodeCollection(selNode[0]);
            var _startNode = document.createElement("p");
            var replaceEle = new Array();
            var removeParent, topMostParent, innerTag, tag, elemN, _node, node, _exactParentEle = _parentNode[_parentNode.length - 1];
            if (listType != "none") {
                tag = this._generateListParentTag(list, selNode[0], listType);
            }
            for (var i = 0; i <= selNode.length - 1; i++) {
                innerTag = document.createElement("li");
                if (selNode[i].parentNode.nodeName.toLowerCase() == "li")
                    selNode[i] = selNode[i].parentNode;
                if (listType == "none") {
                    if ($(selNode[i]).closest("ul,ol").length < 1)
                        continue;
                    if ($(selNode[i]).find("ol").length != 0 || $(selNode[i]).find("ul").length != 0) {
                        removeParent = $(selNode[i]).parents(list).first();
                        var _exactLi = removeParent.parents("li:last");
                        var _prevNode = removeParent.parents("li:last").prevAll();
                        var _nexNode = removeParent.parents("li:last").nextAll();
                        node = $(selNode[i]).parents("li:last")[0];
                    }
                    else {
                        removeParent = $(selNode[i]);
                        var _exactLi = removeParent;
                        var _prevNode = removeParent.prevAll();
                        var _nexNode = removeParent.nextAll();
                        node = $(selNode[i])[0];
                    }
                    topMostParent = $(selNode[i]).parents(list).last();
                    var _selectionComplete = 0;
                    if (_prevNode.length != 0) {
                        $(afterNode).append(_exactLi);
                        $(afterNode).append(_nexNode);
                        $(afterNode).insertAfter(topMostParent);
                    }
                    var ele = document.createElement("p"), elem = elemN = document.createElement("li");
                    beforeNode.appendChild(elem);
                    var backupFirstNode = topMostParent, _removeSibling = new Array(), _inc = false, newNode;
                    while (node) {
                        if ($.inArray(node, selNode) >= 0 || $.inArray(node.firstChild, selNode) >= 0 || $.inArray(node.firstChild, nodeArray) >= 0) {
                            if (_selectionComplete == 0 && elem.firstChild && elem.firstChild.innerHTML != "") {
                                topMostParent.append(elem);
                                elem = elemN = document.createElement("li");
                            }
                            newNode = document.createElement("p");
                            while (node.firstChild && $.inArray(node.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                newNode.appendChild(node.firstChild);
                                _inc = true;
                            }
                            if (_inc) {
                                _selectionComplete++;
                                $(newNode).insertAfter(backupFirstNode);
                                backupFirstNode = $(newNode);
                                if ($(node).children().length == 0) {
                                    _removeSibling.push(node);
                                }
                            }
                            if (_selectionComplete == selNode.length) {
                                var _nextEle = document.createElement(list);
                                if ($(node).children().length != 0)
                                    $(_nextEle).append($(node).parents("li:last").nextAll());
                                else
                                    $(_nextEle).append($(node).nextAll());
                                if (node.nodeName.toLowerCase() == "ol" || node.nodeName.toLowerCase() == "ul")
                                    $(node).insertAfter(backupFirstNode);
                                else if (node.nodeName.toLowerCase() == "li") {
                                    var _tnewNode = document.createElement(list);
                                    $(_tnewNode).append(node);
                                    $(_tnewNode).insertAfter(backupFirstNode);
                                    node = _tnewNode;
                                }
                                $(_nextEle).insertAfter(node);
                                for (var _remove = 0; _remove < _removeSibling.length; _remove++) {
                                    var _removeNodeparent;
                                    _node = _removeSibling[_remove];
                                    while (_node.nodeName.toLowerCase() != "body") {
                                        _removeNodeparent = _node.parentNode;
                                        $(_node).remove();
                                        _node = _removeNodeparent;
                                    }
                                }
                                i = selNode.length;
                                break;
                            }
                        }
                        if (this._isTextNode(node.firstChild) || (node.firstChild && $.inArray(node.firstChild.nodeName.toLowerCase(), this.filterNode) < 0)) {
                            elemN.appendChild(node.firstChild);
                            if (ej.isNullOrUndefined(node.firstChild)) {
                                node = node.nextSibling;
                            }
                        }
                        else if (this._isTextNode(node)) {
                            var _tflag = 0;
                            var appendElement = node;
                            node = node.nextSibling;
                            if (ej.isNullOrUndefined(node)) {
                                node = appendElement;
                                while ($(node.parentNode).next().length == 0) {
                                    node = node.parentNode;
                                    _tflag++;
                                }
                                if (_tflag > 0) {
                                    node = $(node.parentNode).next()[0];
                                }
                            }
                            elemN.appendChild(appendElement);
                            if (_tflag == 0 && !this._isTextNode(node))
                                elemN = this._createElement(node.nodeName.toLowerCase(), elemN.parentNode, null);
                            else
                                elemN = this._createElement(node.nodeName.toLowerCase(), this._getParentnodeName(_tflag, elemN), "after");
                            _tflag = 0;
                        }
                        else {
                            if (node.firstChild) {
                                elemN = this._createElement(node.firstChild.nodeName.toLowerCase(), elemN, null);
                                node = node.firstChild;
                            }
                            else
                                node = node.nextSibling;
                        }
                    }
                }
                else if (selNode[i].nodeName.toLowerCase() != "li") {
                    if ($(selNode[i]).is("h1,h2,h3,h4,h5,h6,p,blockquote")) {
                        $(innerTag).append(selNode[i]);
                        tag.appendChild(innerTag);
                    }
                    else {
                        if ($(selNode[i]).attr("style"))
                            $(innerTag).attr("style", $(selNode[i]).attr("style"));
                        $(innerTag).append(selNode[i].childNodes);
                        tag.appendChild(innerTag);
                        $(selNode[i]).remove();
                    }
                }
                else if (selNode[i] = $(selNode[i]).closest("li")) {
                    tag = document.createElement(list);
                    $(tag).css("list-style-type", listType);
                    $(tag).append(selNode[i].parentNode.childNodes);
                    $(selNode[i].parentNode).replaceWith(tag);
                }
            }
            if (listType != "none" && _exactParentEle.childNodes.length == 0 && (_exactParentEle.nodeName.toLowerCase() == "ol" || _exactParentEle.nodeName.toLowerCase() == "ul"))
                $(_exactParentEle).remove();
        };
        editorManager.prototype._getParentnodeName = function (_tflag, elemN) {
            var node = elemN;
            for (var a = 0; a <= _tflag; a++) {
                node = node.parentNode;
            }
            return node;
        };
        editorManager.prototype._createElement = function (element, elem, place) {
            var newEle = document.createElement(element);
            if (place != "after")
                elem.appendChild(newEle);
            else
                $(newEle).insertAfter(elem);
            return newEle;
        };
        editorManager.prototype._backUpRange = function (_parentDoc, _window) {
            var nodeStart = _parentDoc.createElement("span");
            nodeStart.id = "startRange";
            var nodeEnd = _parentDoc.createElement("span");
            nodeEnd.id = "endRange";
            var rng = this._getRangy(_window, _parentDoc).cloneRange();
            rng.collapse(false);
            rng.insertNode(nodeEnd);
            rng = this._getRangy(_window, _parentDoc).cloneRange();
            rng.collapse(true);
            rng.insertNode(nodeStart);
        };
        editorManager.prototype._resetRange = function (_parentDoc, _window) {
            var a = $(_parentDoc.body).find("span#startRange");
            var b = $(_parentDoc.body).find("span#endRange");
            var len = ej.isNullOrUndefined(b[0].previousSibling) ? 0 : this._isTextNode(b[0].previousSibling) ? b[0].previousSibling.length : b[0].previousSibling.childNodes.length > 0 ? b[0].previousSibling.childNodes.length : 0;
            var rng = this._getRangy(_window, _parentDoc);
            if (a[0].nextSibling != b[0])
                rng.setStart(a[0].nextSibling, 0);
            else
                rng.setStart(a[0].nextSibling.nextSibling, 0);
            if (b[0].previousSibling != a[0])
                ej.isNullOrUndefined(b[0].previousSibling) ? rng.setEnd(b[0].parentNode, len) : rng.setEnd(b[0].previousSibling, len);
            else
                rng.setEnd(b[0].nextSibling, 0);
            a.remove();
            b.remove();
            this._selectRange(rng, _parentDoc);
        };
        editorManager.prototype._selectRange = function (range, _parentDoc) {
            var select = _parentDoc.getSelection();
            select.removeAllRanges();
            select.addRange(range);
        };
        editorManager.prototype._validateFormatData = function (target, data) {
            var nodeData = [], element = target.parentNode, childNode = target, nodeOrder = [], _tagResult, _cssResult;
            if (element)
                do {
                    nodeOrder.push(childNode);
                    if ((_tagResult = this._tagCheck(element, data)) || (_cssResult = this._styleCheck(element, data)))
                        nodeData.push(new ValidatedData(element, target, _tagResult, _cssResult));
                } while (!$(element).is("body") && (childNode = element) && (element = element.parentNode));
            return nodeData;
        };
        editorManager.prototype._tagCheck = function (element, data) {
            return this.formatInfo.getFormatData(data).Value.tag ? $(element).is(this.formatInfo.getFormatData(data).Value.tag) : false;
        };
        editorManager.prototype._styleCheck = function (element, data) {
            var tempArrayData;
            if (!$(element).is(this.formatInfo.filterNode) && this.formatInfo.getFormatData(data).Value.css && (element.getAttribute("style"))) {
                var valStatus = true;
                tempArrayData = this.formatInfo.getFormatData(data).Value.css.split(";");
                $(tempArrayData).each(function (index, styledata) {
                    styledata && (element.getAttribute("style").replace(/\s/g, "").indexOf(styledata) == -1) && (valStatus = false);
                });
                return valStatus;
            }
            return false;
        };
        editorManager.prototype._validateFormat = function (element, format) {
            var data = [], collection = { Info: null, status: null }, status;
            format = format.toLowerCase();
            if ($.inArray(format, this.formatInfo.actionList) != -1) {
                if ((data = this._validateFormatData(element, format)) && data.length)
                    collection.Info = data;
                collection.status = (data.length > 0);
            }
            return collection;
        };
        editorManager.prototype._CurrentformateStatus = function (selectedNode, format) {
            var data = { Info: null, status: null }, status = true;
            for (var index = 0; index < selectedNode.length; index++) {
                data = this._validateFormat(selectedNode[index], format);
                (!data.status) && (status = false);
            }
            return status;
        };
        editorManager.prototype._getSelectNode = function () {
            return this._rangeExtract.ProcessRange();
        };
        editorManager.prototype._getFormatedTagOrder = function (data, index) {
            data[index].currentNode = this._getNodeOrder(data[index].textNode, data[index].node);
            return (!index) ? data : data.slice(index, index + 1);
        };
        editorManager.prototype._getNodeOrder = function (endNode, targetNode) {
            var currentNode = endNode, nodeOrder = [];
            do
                nodeOrder.push(currentNode);
            while ((currentNode = currentNode.parentNode) && currentNode != targetNode);
            return nodeOrder;
        };
        editorManager.prototype._splitNode = function (node) {
            var temp = node, siblingData = { rightSide: [], leftSide: [] };
            while (temp = temp.nextSibling) {
                if (this._validateCommentNode(temp))
                    siblingData.rightSide.push(temp);
            }
            temp = node;
            while (temp = temp.previousSibling) {
                if (this._validateCommentNode(temp))
                    siblingData.leftSide.push(temp);
            }
            return siblingData;
        };
        editorManager.prototype._validateCommentNode = function (node) {
            return (node.nodeType != 8);
        };
        editorManager.prototype._validateTextNode = function (node) {
            return (node.nodeType == 3);
        };
        editorManager.prototype._validateType = function (node) {
            return (this._validateTextNode(node) && (node.data.length));
        };
        editorManager.prototype._formatechildNodes = function (nodeCollection, format, node) {
            var adjacentNodes = { rightSide: [], leftSide: [] }, cloneNode;
            for (var index = nodeCollection.length - 1; index >= 0; index--) {
                adjacentNodes = this._splitNode(nodeCollection[index]);
                (adjacentNodes.rightSide.length) && ($($(node.cloneNode(false)).append(adjacentNodes.rightSide)).insertAfter(nodeCollection[index]));
                cloneNode = node;
                (adjacentNodes.leftSide.length) && ($($(node.cloneNode(false)).append(adjacentNodes.leftSide.reverse())).insertBefore(nodeCollection[index]));
            }
        };
        editorManager.prototype._removeFormat = function (nodeData, format, matches) {
            var temp = this._getFormatedTagOrder(nodeData.Info, matches), tempcloneNode, currentNode = temp[0].currentNode.slice(temp[0].currentNode.length - 1), tempSpanNode = document.createElement("span");
            temp[0].currentNode = temp[0].currentNode.slice(0, temp[0].currentNode.length - 1);
            var adjacentNodes = this._splitNode(currentNode[0]);
            (adjacentNodes.rightSide.length) &&
                ($($(temp[0].node.cloneNode(false)).append(adjacentNodes.rightSide)).insertAfter(temp[0].node));
            if (temp[0].tag) {
                if (this._rangeExtract.cursorBasedCollection && !temp[0].textNode.data.trim().length) {
                    $(tempSpanNode).append(currentNode).insertAfter($(temp[0].node));
                }
                else
                    $(currentNode).insertAfter(temp[0].node);
                tempcloneNode = temp[0].textNode;
                if (this._rangeExtract.cursorBasedCollection)
                    this._setCursorOnNode(tempcloneNode, temp[0].textNode);
            }
            else {
                tempcloneNode = $(temp[0].node.cloneNode(false));
                tempcloneNode.css(this.formatInfo.getFormatData(format).Value.removeCSS);
                (tempcloneNode[0].getAttribute("style")) ? $(tempcloneNode.append(currentNode)).insertAfter(temp[0].node) : $(currentNode).insertAfter(temp[0].node);
                tempcloneNode = currentNode;
            }
            (temp[0].currentNode.length) && (this._formatechildNodes(temp[0].currentNode, format, temp[0].node));
            (!adjacentNodes.leftSide.length) && ($(temp[0].node).remove());
            return tempcloneNode[0] ? tempcloneNode[0] : tempcloneNode;
        };
        editorManager.prototype._applyFormat = function (node, format, styleData) {
            var adjacentNodes = this._splitNode(node), tempcloneNode, currentNode = node, tempSpanNode = document.createElement("span");
            if (adjacentNodes.leftSide.length && (adjacentNodes.leftSide[0].nodeType != 3) && (this._tagCheck(adjacentNodes.leftSide[0], format) || this._compareCSS(adjacentNodes.leftSide[0], (styleData ? (this.formatInfo.getFormatData(format).Value.css + ":" + styleData + ";") : this.formatInfo.getFormatData(format).Value.css))))
                $(adjacentNodes.leftSide[0]).append(node);
            else if (adjacentNodes.rightSide.length && (adjacentNodes.rightSide[0].nodeType != 3) && (this._tagCheck(adjacentNodes.rightSide[0], format) || this._compareCSS(adjacentNodes.rightSide[0], (styleData ? (this.formatInfo.getFormatData(format).Value.css + ":" + styleData + ";") : this.formatInfo.getFormatData(format).Value.css))))
                $(adjacentNodes.rightSide[0]).prepend(node);
            else if (!adjacentNodes.leftSide.length && !adjacentNodes.rightSide.length && $(node.parentNode).is(this.formatInfo.getFormatData(format).Value.styleParent)) {
                if (styleData)
                    $(node.parentNode).css(this.formatInfo.getFormatData(format).Value.css, styleData);
                else
                    $(node.parentNode).css(this._collectStyleData(this.formatInfo.getFormatData(format).Value.css));
            }
            else {
                tempcloneNode = document.createElement(this.formatInfo.getFormatData(format).Value.result);
                if (this._rangeExtract.cursorBasedCollection) {
                    if (this._validateTextNode(node)) {
                        if (!$(tempcloneNode).is("span") && this._rangeExtract._noContent)
                            $(tempSpanNode).append(tempcloneNode);
                        else
                            (tempSpanNode = tempcloneNode);
                        tempcloneNode.appendChild(currentNode = document.createTextNode(node.data));
                        if (this._rangeExtract.cursorBasedCollection) {
                            this._setCursorOnNode(node, currentNode);
                        }
                        $(node).replaceWith(tempSpanNode);
                    }
                    else {
                        tempcloneNode.innerHTML = "&#65279;";
                        $(tempSpanNode).append(tempcloneNode);
                        if (node.firstChild && $(node.firstChild).is("br"))
                            $(tempSpanNode).insertBefore(node.firstChild);
                        else
                            $(node).append(tempSpanNode);
                        if (this._rangeExtract.cursorBasedCollection) {
                            this._setCursorOnNode(node, tempcloneNode.firstChild);
                        }
                        currentNode = tempcloneNode;
                    }
                }
                else {
                    tempcloneNode.appendChild(currentNode = document.createTextNode(node.data));
                    $(node).replaceWith(tempcloneNode);
                }
                styleData && $(tempcloneNode).css(this.formatInfo.getFormatData(format).Value.css, styleData);
            }
            return currentNode;
        };
        editorManager.prototype._setCursorOnNode = function (node, currentNode) {
            if (this._rangeExtract._cursorData.node == node)
                this._rangeExtract._cursorData.node = currentNode;
        };
        editorManager.prototype._compareCSS = function (element, css) {
            return element.getAttribute('style') && element.getAttribute('style').toLowerCase().trim().replace(/\s/g, "") == css.toLowerCase().trim().replace(/\s/g, "");
        };
        editorManager.prototype._collectStyleData = function (styledata) {
            var styleList = styledata.replace(/\s/g, "").split(';'), data = {}, temp;
            $(styleList).each(function (index) {
                var style = styleList[index];
                temp = style.split(':');
                (temp.length > 1) && (data[temp[0].toLowerCase().trim()] = temp[1].toLowerCase().trim());
            });
            return data;
        };
        editorManager.prototype._validateStyleData = function (node, style, styleData) {
            var nodeList = node.getAttribute('style').split(';'), status = false;
            $(nodeList).each(function (index) {
                var data = nodeList[index], temp = data.split(':');
                if (temp[0].toLowerCase().trim() == style.toLowerCase().trim() && temp[1].toLowerCase().trim() == styleData.toLowerCase().trim()) {
                    status = true;
                    return false;
                }
            });
            return status;
        };
        editorManager.prototype._caseConvert = function (casing) {
            var selectedNode = this._getSelectNode(), node, startNode, endNode, tempNode;
            if (!selectedNode.length || (selectedNode.length == 1 && !selectedNode[0].data.length))
                return;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index];
                tempNode = document.createTextNode(node.data[this.formatInfo.captionConvert[casing]]());
                if (this._rangeExtract._cursorData.node == node)
                    this._rangeExtract._cursorData.node = tempNode;
                node.data && ($(node).replaceWith(tempNode));
                tempNode && (selectedNode.length == 1) ? ((startNode = tempNode) && (endNode = tempNode)) : (index == 0) ? (startNode = tempNode) : (index == selectedNode.length - 1) ? (endNode = tempNode) : null;
            }
            startNode && endNode && this._refreshRange(startNode, endNode);
        };
        editorManager.prototype._validateSelectedNode = function (selectedNode) {
            return (!selectedNode.length || (selectedNode.length == 1 && selectedNode[0].data && !selectedNode[0].data.length));
        };
        editorManager.prototype._tagFormatProcess = function (format, remove) {
            var selectedNode = this._getSelectNode();
            if (this._validateSelectedNode(selectedNode))
                return;
            var status = this._CurrentformateStatus(selectedNode, format), node, nodeData = { Info: null, status: null }, retNode, startNode, endNode;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index], nodeData = this._validateFormat(node, format), retNode = null;
                if (((remove || status) && nodeData.status))
                    for (var matches = 0; matches < nodeData.Info.length; matches++)
                        retNode = this._removeFormat(nodeData, format, matches);
                else if (!nodeData.status && !remove)
                    retNode = this._applyFormat(node, format, null);
                else
                    retNode = node;
                if (retNode) {
                    (selectedNode.length == 1) ? ((startNode = retNode) && (endNode = retNode)) : (index == 0) ? (startNode = retNode) : (index == selectedNode.length - 1) ? (endNode = retNode) : null;
                }
            }
            startNode && endNode && this._refreshRange(startNode, endNode);
            this.focus();
            return { data: nodeData, nodeStatus: status };
        };
        editorManager.prototype._refreshRange = function (startNode, endNode) {
            var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection(), cursorOnNode, cursorOffset;
            if (this._rangeExtract)
                (cursorOnNode = this._rangeExtract._cursorData.node) && (cursorOffset = this._rangeExtract._cursorData.offSet);
            if (this._rangeExtract.cursorBasedCollection && cursorOnNode && cursorOffset > -1) {
                cursorOffset = this._validateTextNode(cursorOnNode) ?
                    ((cursorOffset > cursorOnNode.data.length) ? cursorOnNode.data.length : cursorOffset) : 0;
                if (cursorOnNode.nodeType == 3 && !cursorOnNode.data.trim()) {
                    cursorOnNode.data = String.fromCharCode(65279) + cursorOnNode.data;
                    cursorOffset++;
                }
                this._updateCursor(cursorOnNode, cursorOffset);
            }
            else if (startNode && endNode) {
                if (startNode.data && !startNode.data.trim() && (startNode.data.indexOf(String.fromCharCode(65279)) == -1))
                    startNode.data = String.fromCharCode(65279) + startNode.data;
                if (endNode.data && !endNode.data.trim() && (endNode.data.indexOf(String.fromCharCode(65279)) == -1))
                    endNode.data = String.fromCharCode(65279);
                Selection.removeAllRanges();
                range.setStart(startNode, 0);
                range.setEnd(endNode, endNode.data ? endNode.data.length : 0);
                Selection.addRange(range);
            }
            $(this.currentWindow).focus();
        };
        editorManager.prototype._updateCursor = function (node, offset) {
            var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection();
            range.setStart(node, offset);
            range.setEnd(node, offset);
            Selection.removeAllRanges();
            Selection.addRange(range);
        };
        editorManager.prototype._cssFormatProcess = function (format, styleData, remove) {
            var selectedNode = this._getSelectNode(), node, nodeData = { Info: null, status: null }, retNode, startNode, endNode;
            if (this._validateSelectedNode(selectedNode))
                return;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index], nodeData = this._validateFormat(node, format);
                if (nodeData.status)
                    for (var matches = 0; matches < nodeData.Info.length; matches++) {
                        if (!remove && this._validateStyleData(nodeData.Info[matches].node, this.formatInfo.getFormatData(format).Value.css, styleData))
                            continue;
                        retNode = this._removeFormat(nodeData, format, matches);
                    }
                if (!remove)
                    retNode = this._applyFormat(node, format, styleData);
                if (retNode)
                    (selectedNode.length == 1) ? ((startNode = retNode) && (endNode = retNode)) : (index == 0) ? (startNode = retNode) : (index == selectedNode.length - 1) ? (endNode = retNode) : null;
            }
            this._refreshRange(startNode, endNode);
            this.focus();
        };
        editorManager.prototype.execCommand = function (command, value) {
            try {
                switch (command) {
                    case execCommand.bold:
                        this._tagFormatProcess("bold", false);
                        break;
                    case execCommand.italic:
                        this._tagFormatProcess("italic", false);
                        break;
                    case execCommand.underline:
                        this._tagFormatProcess("underline", false);
                        break;
                    case execCommand.strikethrough:
                        this._tagFormatProcess("strikethrough", false);
                        break;
                    case execCommand.superscript:
                        this._tagFormatProcess("subscript", true);
                        this._tagFormatProcess("superscript", false);
                        break;
                    case execCommand.subscript:
                        this._tagFormatProcess("superscript", true);
                        this._tagFormatProcess("subscript", false);
                        break;
                    case execCommand.fontsize:
                        this._cssFormatProcess("fontsize", value, false);
                        break;
                    case execCommand.fontname:
                        this._cssFormatProcess("fontname", value, false);
                        break;
                    case execCommand.forecolor:
                        this._cssFormatProcess("forecolor", value, false);
                        break;
                    case execCommand.backcolor:
                        this._cssFormatProcess("backcolor", value, false);
                        break;
                    case execCommand.uppercase:
                        this._caseConvert("uppercase");
                        break;
                    case execCommand.lowercase:
                        this._caseConvert("lowercase");
                        break;
                    case execCommand.indent:
                        this._applyIndent(true);
                        break;
                    case execCommand.outdent:
                        this._applyIndent(false);
                        break;
                    case execCommand.justifyleft:
                        this._justifyContent("left");
                        break;
                    case execCommand.justifycenter:
                        this._justifyContent("center");
                        break;
                    case execCommand.justifyright:
                        this._justifyContent("right");
                        break;
                    case execCommand.justifyfull:
                        this._justifyContent("justify");
                        break;
                    case execCommand.formatblock:
                        this._applyFormateBlock(value);
                        break;
                }
                this._junkContentStatus = true;
            }
            catch (e) {
            }
        };
        return editorManager;
    }());
    documentManager.editorManager = editorManager;
    (function (execCommand) {
        execCommand[execCommand["bold"] = 0] = "bold";
        execCommand[execCommand["italic"] = 1] = "italic";
        execCommand[execCommand["underline"] = 2] = "underline";
        execCommand[execCommand["strikethrough"] = 3] = "strikethrough";
        execCommand[execCommand["superscript"] = 4] = "superscript";
        execCommand[execCommand["subscript"] = 5] = "subscript";
        execCommand[execCommand["fontsize"] = 6] = "fontsize";
        execCommand[execCommand["fontname"] = 7] = "fontname";
        execCommand[execCommand["forecolor"] = 8] = "forecolor";
        execCommand[execCommand["backcolor"] = 9] = "backcolor";
        execCommand[execCommand["uppercase"] = 10] = "uppercase";
        execCommand[execCommand["lowercase"] = 11] = "lowercase";
        execCommand[execCommand["indent"] = 12] = "indent";
        execCommand[execCommand["outdent"] = 13] = "outdent";
        execCommand[execCommand["justifyleft"] = 14] = "justifyleft";
        execCommand[execCommand["justifycenter"] = 15] = "justifycenter";
        execCommand[execCommand["justifyright"] = 16] = "justifyright";
        execCommand[execCommand["justifyfull"] = 17] = "justifyfull";
        execCommand[execCommand["formatblock"] = 18] = "formatblock";
    })(documentManager.execCommand || (documentManager.execCommand = {}));
    var execCommand = documentManager.execCommand;
    var ValidatedData = (function () {
        function ValidatedData(node, textNode, tag, css) {
            this.textNode = textNode;
            this.node = node;
            this.css = css;
            this.tag = tag;
        }
        return ValidatedData;
    }());
    var actionType = (function () {
        function actionType(tag, css, result, removeCSS, styleParent) {
            this.tag = tag;
            this.css = css;
            this.result = result;
            this.removeCSS = removeCSS;
            this.styleParent = styleParent;
        }
        return actionType;
    }());
    var captionConvertion = (function () {
        function captionConvertion() {
            this.uppercase = "toUpperCase";
            this.lowercase = "toLowerCase";
        }
        return captionConvertion;
    }());
    var KeyDictionary = (function () {
        function KeyDictionary(target, value) {
            this.Key = target;
            this.Value = value;
        }
        return KeyDictionary;
    }());
    var formateDataCollection = (function () {
        function formateDataCollection() {
            this.filterNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this.actionList = ["bold", "italic", "underline", "strikethrough", "superscript", "subscript", "fontsize", "fontname", "forecolor", "backcolor"];
            this.captionConvert = new captionConvertion();
            this._updateData();
        }
        formateDataCollection.prototype._updateData = function () {
            var temp = Array();
            temp.push(new KeyDictionary("bold", new actionType("b,strong", "font-weight:bold;", "b", { "font-weight": '' }, "span")));
            temp.push(new KeyDictionary("italic", new actionType("i, cite, em, var, address, dfn", "font-style:italic", "i", { "font-style": '' }, "span")));
            temp.push(new KeyDictionary("underline", new actionType("u,ins", "text-decoration:underline;", "u", { "text-decoration": '' }, "span")));
            temp.push(new KeyDictionary("strikethrough", new actionType("s, strike, del", "text-decoration:line-through;", "s", { "text-decoration": '' }, "span")));
            temp.push(new KeyDictionary("superscript", new actionType("sup", "vertical-align:super;font-size:smaller;", "sup", { "vertical-align": '', "font-size": '' }, "span")));
            temp.push(new KeyDictionary("subscript", new actionType("sub", "vertical-align:sub;font-size:smaller;", "sub", { "vertical-align": '', "font-size": '' }, "span")));
            temp.push(new KeyDictionary("fontsize", new actionType(null, "font-size", "span", { "font-size": '' }, "span")));
            temp.push(new KeyDictionary("fontname", new actionType(null, "font-family", "span", { "font-family": '' }, "span")));
            temp.push(new KeyDictionary("forecolor", new actionType(null, "color", "span", { "color": '' }, "span")));
            temp.push(new KeyDictionary("backcolor", new actionType(null, "background-color", "span", { "background-color": '' }, "span")));
            this.tempCollection = temp;
        };
        formateDataCollection.prototype.getFormatData = function (format) {
            var temp;
            for (var index = 0; index < this.tempCollection.length; index++) {
                temp = this.tempCollection[index];
                if (temp.Key == format)
                    return this.tempCollection[index];
            }
        };
        return formateDataCollection;
    }());
    var RangeExtractor = (function () {
        function RangeExtractor(target) {
            this.exp = /\s/g;
            this._findStatus = { leftSide: null, rightSide: null };
            this._iterationStatus = false;
            this._cursorData = { node: null, offSet: null };
            this._nodeCollection = [];
            this._traverseData = {
                leftSide: { childNode: "lastChild", sibling: "previousSibling" },
                rightSide: { childNode: "firstChild", sibling: "nextSibling" }
            };
            this._blockNodes = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this._noContent = false;
            this.nodeCollection = { leftSide: [], rightSide: [] };
            this.currentDocument = target;
        }
        RangeExtractor.prototype.ProcessRange = function () {
            var tempRange = this._getRange();
            if (($(this.currentDocument.body).attr("contenteditable") == "true") && tempRange) {
                this._nodeCollection = [], this._noContent = false;
                this._iterationStatus = false;
                this._cursorData = { node: null, offSet: null };
                if ((tempRange.startContainer == tempRange.endContainer) && (tempRange.startOffset == tempRange.endOffset)) {
                    this._collectCursorBasedTextNode(tempRange.startContainer, tempRange.startOffset);
                    this.cursorBasedCollection = true;
                }
                else {
                    this._collectSelectionBasedTextNode(tempRange);
                    this.cursorBasedCollection = false;
                }
            }
            return this._nodeCollection;
        };
        RangeExtractor.prototype._insertCursor = function (startContainer, startOffset) {
            var firstNodeData = startContainer.data.substring(0, startOffset), middleNodeData = "", lastNodeData = startContainer.data.substr(startOffset), tempNode;
            firstNodeData.replace(String.fromCharCode(65279), "") && $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
            lastNodeData.replace(String.fromCharCode(65279), "") && $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
            $(startContainer).replaceWith(tempNode = document.createTextNode(middleNodeData));
            this._cursorData = { node: tempNode, offSet: 0 };
            this._nodeCollection.push(tempNode);
            this._noContent = true;
        };
        RangeExtractor.prototype._collectCursorBasedTextNode = function (startContainer, startOffset) {
            var tempLeftIndex, temp, validString, tempNode, tempRightIndex, regx = new RegExp(this.exp);
            while (temp = regx.exec(startContainer.data)) {
                if (startContainer.data.substring(temp.index, temp.index + 1).indexOf(" ") != -1) {
                    if (temp.index < startOffset) {
                        tempLeftIndex = temp;
                    }
                    if (!tempRightIndex && (startOffset <= temp.index)) {
                        tempRightIndex = temp;
                    }
                }
            }
            if (tempLeftIndex && tempRightIndex) {
                if ((startOffset - (tempLeftIndex.index + 1) == 0 || startOffset - (tempLeftIndex.index + 1) == startContainer.data.substring(tempLeftIndex.index + 1, tempRightIndex.index).replace("\n", '').length)) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var firstNodeData = startContainer.data.substring(0, tempLeftIndex.index + 1), lastNodeData = startContainer.data.substring(tempRightIndex.index);
                    $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
                    $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(tempLeftIndex.index + 1, tempRightIndex.index)));
                    this._cursorData = { node: tempNode, offSet: startOffset - (tempLeftIndex.index + 1) };
                    this._nodeCollection.push(tempNode);
                }
            }
            else if (tempLeftIndex) {
                var rightSideNode;
                this._collectNodeData(startContainer, false);
                rightSideNode = this._nodeCollection;
                this._nodeCollection = [];
                if ((rightSideNode.length == 0) && (((startOffset - (tempLeftIndex.index + 1)) == 0) || ((startOffset - (tempLeftIndex.index + 1)) == startContainer.data.substring(tempLeftIndex.index + 1).replace("\n", '').length))) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var firstNodeData = startContainer.data.substring(0, tempLeftIndex.index + 1);
                    $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(tempLeftIndex.index + 1)));
                    this._cursorData = { node: tempNode, offSet: startOffset - (tempLeftIndex.index + 1) };
                    this._nodeCollection.push(tempNode);
                    this._nodeCollection.concat(rightSideNode);
                }
            }
            else if (tempRightIndex) {
                var leftSideNode;
                this._collectNodeData(startContainer, true);
                leftSideNode = this._nodeCollection;
                this._nodeCollection = [];
                if (leftSideNode.length == 0 && ((startOffset == startContainer.data.substring(0, tempRightIndex.index).replace("\n", '').length) || startOffset == 0)) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var lastNodeData = startContainer.data.substring(tempRightIndex.index);
                    $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(0, tempRightIndex.index)));
                    this._cursorData = { node: tempNode, offSet: startOffset };
                    this._nodeCollection = leftSideNode.reverse();
                    this._nodeCollection.push(tempNode);
                }
            }
            else {
                if (startContainer.nodeType != 3) {
                    tempNode = document.createTextNode("");
                    if (startContainer.firstChild)
                        $(tempNode).insertBefore(startContainer.firstChild);
                    else
                        $(tempNode).appendTo(startContainer);
                    this._nodeCollection.push(tempNode);
                    this._cursorData = { node: tempNode, offSet: startOffset };
                    this._noContent = true;
                }
                else {
                    var rightSideNode, leftSideNode;
                    this._collectNodeData(tempNode = startContainer, false);
                    rightSideNode = this._nodeCollection;
                    this._nodeCollection = [];
                    this._collectNodeData(tempNode, true);
                    leftSideNode = this._nodeCollection;
                    this._nodeCollection = [];
                    if (tempNode.data == String.fromCharCode(65279) || (leftSideNode.length == 0 && startOffset == 0) || (rightSideNode.length == 0 && tempNode.data.replace(String.fromCharCode(65279), "").replace("\n", '').length == startOffset)) {
                        this._insertCursor(startContainer, startOffset);
                    }
                    else {
                        this._nodeCollection = leftSideNode.reverse();
                        this._nodeCollection.push(tempNode);
                        this._nodeCollection = this._nodeCollection.concat(rightSideNode);
                        this._cursorData = { node: tempNode, offSet: startOffset };
                    }
                }
            }
            return this._nodeCollection;
        };
        RangeExtractor.prototype._validateContent = function (node, traverse) {
            var regx = new RegExp(this.exp), temp, _matches = [], tempTxtNode, textIndex;
            while (temp = regx.exec(node.data)) {
                _matches.push(temp);
            }
            if (_matches.length) {
                temp = _matches[(traverse == "leftSide") ? _matches.length - 1 : 0], textIndex = (traverse == "leftSide") ? temp.index + 1 : temp.index;
                $(tempTxtNode = document.createTextNode(node.data.substring(textIndex))).insertAfter(node);
                node.data = node.data.substring(0, textIndex);
                if ((traverse == "rightSide") && $.trim(node.data))
                    this._nodeCollection.push(node);
                else if ((traverse == "leftSide") && $.trim(tempTxtNode.data))
                    this._nodeCollection.push(tempTxtNode);
                this._findStatus[traverse] = true;
            }
            else
                this._nodeCollection.push(node);
        };
        RangeExtractor.prototype._iterateNodes = function (element, traverse) {
            if (!this._findStatus[traverse]) {
                if (element.nodeType == 3 && element.data)
                    this._validateContent(element, traverse);
                else if ((element = element[this._traverseData[traverse]["childNode"]]) && !this._findStatus[traverse])
                    do {
                        (element.nodeType == 3 && element.data) ? this._validateContent(element, traverse) : this._iterateNodes(element, traverse);
                    } while ((element = element[this._traverseData[traverse]["sibling"]]) && !this._findStatus[traverse]);
            }
        };
        RangeExtractor.prototype._collectNodeData = function (node, leftSide) {
            this._findStatus = { leftSide: undefined, rightSide: undefined };
            var _proxy = this;
            var traverse = leftSide ? "leftSide" : "rightSide";
            do {
                this.nodeCollection = this._splitSiblingNode(node);
                $(this.nodeCollection[traverse]).each(function (index, element) { _proxy._iterateNodes(element, traverse); });
            } while (!this._validateBlockType(node.parentNode) && (node = node.parentNode) && !this._findStatus[traverse]);
        };
        RangeExtractor.prototype._validateBlockType = function (node) {
            return ($.inArray(node.tagName.toLowerCase(), this._blockNodes.concat("body")) != -1);
        };
        RangeExtractor.prototype._validateTextNode = function (node) {
            return (node.nodeType == 3);
        };
        RangeExtractor.prototype._splitSiblingNode = function (node) {
            var temp = node, nodeSiblingData = { leftSide: [], rightSide: [] };
            while (temp = temp.nextSibling) {
                if (temp.tagName && this._validateBlockType(temp)) {
                    continue;
                }
                nodeSiblingData.rightSide.push(temp);
            }
            temp = node;
            while (temp = temp.previousSibling) {
                if (temp.tagName && this._validateBlockType(temp)) {
                    continue;
                }
                nodeSiblingData.leftSide.push(temp);
            }
            return nodeSiblingData;
        };
        RangeExtractor.prototype._getRange = function () {
            var selCurrent = this.currentDocument.getSelection(), range = null;
            (selCurrent.rangeCount) && (range = selCurrent.getRangeAt(0));
            return range;
        };
        RangeExtractor.prototype._collectSelectionBasedTextNode = function (tempRange) {
            var leftData, rightData, centerData, leftNode, rightNode, centerNode, startNode = tempRange.startContainer, endNode = tempRange.endContainer;
            this._nodeCollection = [];
            if (tempRange.startContainer == tempRange.endContainer) {
                if (this._validateTextNode(tempRange.endContainer)) {
                    if (tempRange.startOffset)
                        leftData = tempRange.startContainer.data.substr(0, tempRange.startOffset);
                    if (tempRange.startContainer.data.length != tempRange.endOffset)
                        rightData = tempRange.startContainer.data.substr(tempRange.endOffset);
                    centerData = tempRange.startContainer.data.substr(tempRange.startOffset, (tempRange.endOffset - tempRange.startOffset));
                    leftData && ($((leftNode = document.createTextNode(leftData))).insertBefore(tempRange.startContainer));
                    rightData && ($((rightNode = document.createTextNode(rightData))).insertAfter(tempRange.startContainer));
                    centerData && ($(tempRange.startContainer).replaceWith(centerNode = document.createTextNode(centerData))) && this._nodeCollection.push(centerNode);
                }
                else
                    this._updateNodeCollection((tempRange.startContainer.nodeName.toLowerCase() == 'html') ? $(tempRange.startContainer).find('body')[0] : tempRange.startContainer, startNode, null);
            }
            else {
                if (tempRange.startContainer.nodeType == 3 && tempRange.startOffset) {
                    leftData = tempRange.startContainer.data.substr(0, tempRange.startOffset);
                    rightData = tempRange.startContainer.data.substr(tempRange.startOffset);
                    ($(document.createTextNode(leftData)).insertBefore(tempRange.startContainer));
                    ($(startNode).replaceWith(startNode = document.createTextNode(rightData)));
                }
                if (tempRange.endContainer.nodeType == 3 && tempRange.endContainer.data.length != tempRange.endOffset) {
                    rightData = tempRange.endContainer.data.substr(tempRange.endOffset);
                    leftData = tempRange.endContainer.data.substr(0, tempRange.endOffset);
                    ($(document.createTextNode(rightData)).insertAfter(tempRange.endContainer));
                    ($(endNode).replaceWith(endNode = document.createTextNode(leftData)));
                }
                else if (tempRange.endOffset && tempRange.endContainer.lastChild)
                    endNode = tempRange.endContainer.lastChild;
                this._updateNodeCollection(tempRange.commonAncestorContainer, startNode, endNode);
            }
        };
        RangeExtractor.prototype._updateNodeCollection = function (targetNode, startNode, endNode) {
            this._updateIterationStatus(targetNode, startNode, endNode);
            if (targetNode = targetNode.firstChild)
                do
                    this._updateNodeCollection(targetNode, startNode, endNode);
                while (targetNode = targetNode.nextSibling);
        };
        RangeExtractor.prototype._updateIterationStatus = function (targetNode, startNode, endNode) {
            (targetNode == startNode && !this._iterationStatus) && (this._iterationStatus = true);
            if (targetNode.nodeType == 3 && this._iterationStatus)
                this._nodeCollection.push(targetNode);
            (targetNode == endNode && this._iterationStatus) && (this._iterationStatus = false);
        };
        return RangeExtractor;
    }());
})(documentManager || (documentManager = {}));
$.extend(ej, documentManager);
window["documentManager"] = null;
;
/**
* @fileOverview Plugin provides support to display color picker within your web page and allows to pick the color.
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws.
* @version 12.1
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejColorPicker", "ej.ColorPicker", {
        _rootCSS: "e-colorpicker",

        element: null,

        model: null,
        validTags: ["input", "div"],
        _addToPersist: ["value", "opacityValue"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },


        defaults: {

            enableOpacity: true,

            opacityValue: 100,

            columns: 10,

            palette: "basicpalette",

            htmlAttributes: {},

            buttonMode: "split",

            custom: [],

            presetType: "basic",

            modelType: "picker",

            locale: "en-US",

            showPreview: true,

            showTooltip: false,

            showClearButton: false,

            showSwitcher: true,

            value: null,

            displayInline: false,

            buttonText: {
                apply: "Apply",
                cancel: "Cancel",
                swatches: "Swatches"
            },

            tooltipText: {
                switcher: "Switcher",
                addButton: "Add Color",
                basic: "Basic",
                monoChrome: "Mono Chrome",
                flatColors: "Flat Colors",
                seaWolf: "Sea Wolf",
                webColors: "Web Colors",
                sandy: "Sandy",
                pinkShades: "Pink Shades",
                misty: "Misty",
                citrus: "Citrus",
                vintage: "Vintage",
                moonLight: "Moon Light",
                candyCrush: "Candy Crush",
                currentColor: "Current Color",
                selectedColor: "Selected Color",
            },

            showApplyCancel: true,

            showRecentColors: false,

            toolIcon: null,

            cssClass: "",

            enabled: true,

            change: null,

            select: null,

            open: null,

            close: null,

            create: null,

            destroy: null,
        },
        dataTypes: {
            modelType: "enum",
            palette: "enum",
            presetType: "enum",
            cssClass: "string",
            displayInline: "boolean",
            locale: "string",
            showSwitcher: "boolean",
            showRecentColors: "boolean",
            enabled: "boolean",
            showPreview: "boolean",
            enableOpacity: "boolean",
            buttonText: "data",
            custom: "array",
            htmlAttributs: "data"
        },

        observables: ["value", "opacityValue"],
        value: ej.util.valueFunction("value"),
        opacityValue: ej.util.valueFunction("opacityValue"),

        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "enableOpacity":
                        this.model.enableOpacity = jsondata[key];
                        this._previewSlider(this.model.enableOpacity);
                        this._valueOperation();
                        break;
                    case "opacityValue":
                        if (this.model.enableOpacity) {
                            this._tempOpacity = parseFloat(ej.util.getVal(jsondata[key]));
                            this._opacity.option('value', this._tempOpacity);
                            !this._switch && this._changeOpacity();
                            this._updateValue();
                            this.opacityValue(this._tempOpacity);
                            typeof jsondata[key] == "function" ? jsondata[key](this.opacityValue()) : jsondata[key] = this.opacityValue();
                            break;
                        } else return false;
                    case "custom":
                        this.model.custom = jsondata[key];
                        this._reInitialize();
                        break;
                    case "palette":
                        this.model.palette = jsondata[key];
                        this._reInitialize();
                        break;
                    case "columns":
                        this.model.columns = parseFloat(jsondata[key]);
                        this._reInitialize();
                        jsondata[key] = this.model.columns;
                        break;
                    case "presetType":
                        this.model.presetType = jsondata[key];
                        if (ej.isNullOrUndefined(Colors[this.model.presetType])) return false;
                        else
                            this._reInitialize();
                        break;
                    case "buttonMode":
                        this._unBindIconClick();
                        this._buttonElement = ej.ColorPicker.ButtonMode.Split == jsondata[key] ? this.dropdownbutton : this.wrapper;
                        ej.ColorPicker.ButtonMode.Split == jsondata[key] ? this.wrapper.addClass("e-split") : this.wrapper.removeClass("e-split");
                        this._bindIconClick();
                        break;
                    case "showTooltip":
                        this._colorSlider.option('showTooltip', jsondata[key]);
                        this._opacity.option('showTooltip', jsondata[key]);
                        break;
                    case "value":
                        this._setValue(ej.util.getVal(jsondata[key]), true);
                        if (typeof jsondata[key] == "function")
                            jsondata[key](this.value());
                        else
                            jsondata[key] = this.value();
                        break;
                    case "modelType":
                        this.model.modelType = jsondata[key];
                        this._reInitialize();
                        break;
                    case "showSwitcher":
                        this.model.showSwitcher = jsondata[key];
                        this._showSwitcher();
                        break;
                    case "tooltipText":
                        this._toolTipText(jsondata[key]);
                        break;
                    case "locale": 
                        this.model.locale = jsondata[key];
                        this._localize(jsondata[key]);
                        break;
                    case "showPreview":
                        this.model.showPreview = jsondata[key];
                        this._previewPane(this.model.showPreview);
                        break;
                    case "buttonText":
                        this._buttonText(jsondata[key]);
                        break;
                    case "displayInline":
                        this._setDisplayInline(jsondata[key]);
                        break;
                    case "cssClass":
                        this._setSkin(jsondata[key]);
                        this.model.cssClass = jsondata[key];
                        break;
                    case "enabled":
                        this._enabled(jsondata[key]);
                        break;
                    case "showRecentColors":
                        this.model.showRecentColors = jsondata[key];
                        this._previewColor(this.model.showRecentColors);
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "showClearButton": this._showClearIcon(jsondata[key]); break;
                    case "showApplyCancel": this.model.showApplyCancel = jsondata[key]; this._buttonContainer(); break;
                }
            }
        },


        _setSkin: function (className) {
            if (this.wrapper)
                this.wrapper.removeClass(this.model.cssClass).addClass(className);
            else
                this.element.removeClass(this.model.cssClass).addClass(className);
        },
        _showSwitcher: function () {
            if (this.model.showSwitcher) {
                this._changeTag.removeClass('e-hide');
                this.model.modelType == "picker" ? this._switcher.addClass('e-paletteModel').removeClass('e-pickerModel') : this._switcher.addClass('e-pickerModel').removeClass('e-paletteModel');
            }
            else
                this._changeTag.addClass('e-hide');
        },
        _pickerType: function () {
            this._modelType = "picker";
            this.PaletteWrapper.removeAttr('style');
            this.PaletteWrapper.addClass('e-hide');
            this._gradient.removeClass('e-hide');
            this._gradient.fadeIn(200);
            this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            this._switcher.removeAttr('class');
            this._switcher.addClass('e-color-image e-paletteModel');
            this._switch = true;
            this._rgbValue();
            this._hueGradient();
            this._updateUI();
            this._alphaGradient(this.RGBToHEX(this.rgb));
            this._hsva.ejButton("enable");
            this._switchEvents();
            this._unSwitchEvents();
            this._hideUnBindEvents();
            this.isPopupOpen && this._showBindEvents();
            this.model.modelType == "default" ? this._changeTag.removeClass('e-hide') : this._changeTag.addClass('e-hide');
            this.popupList.prepend(this._gradient);
            this._showSwitcher();
        },
        _paletteType: function () {
            this._gradient.removeAttr('style');
            this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
            this.PaletteWrapper.removeClass('e-hide');
            this.PaletteWrapper.fadeIn(200);
            this._switch = false;
            this._disableHSVButton();
            this._cellSelect();
            this._switchEvents();
            this._unSwitchEvents();
            this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            this.popupList.prepend(this.PaletteWrapper);
            this._showSwitcher();
        },
        _reInitialize: function () {
            this._destroyPalette(false);
        },
        _destroyPalette: function (presets) {
            this.PaletteWrapper.remove();
            if (presets || this._columns != this.model.columns && this.model.palette !== "custompalette") this.PaletteWrapper = this._presetType(this._presetsId);
            if (this._temp !== this.model.presetType) this.PaletteWrapper = this._layoutType(this.model.palette);
            if (this.model.modelType == "palette") {
                this._modelType = "palette";
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._hideUnBindEvents();
                this.isPopupOpen && this._showBindEvents();
                this._gradient.addClass('e-hide');
                this._paletteType();
                presets || this.model.palette == "custompalette" ? "" : this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            }
            if (this.model.modelType == "picker") {
                this._pickerType();
                if (this.model.displayInline && !this.element.is('input'))
                    this._footer.addClass('e-hide');
            }
            this._temp = this.model.presetType; this._columns = this.model.columns;
            if (this._modelType == "picker")
                this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            else
                this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
            this.refresh();
        },
        _previewColor: function (color) {
            if (color) {
                this._swatchesArea.fadeIn(200);
                this._bindRecentEvent();
            }
            else {
                this._swatchesArea.fadeOut(200);
                this._unBindRecentEvent();
            }
        },
        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            if (!ej.isNullOrUndefined(this._buttonTag)) this._buttonTag.html(this.model.buttonText.apply);
            if (!ej.isNullOrUndefined(this._cancelTag)) this._cancelTag.html(this.model.buttonText.cancel);
            this._spnTag.html(this.model.buttonText.swatches);
        },
        _toolTipText: function (data) {
            $.extend(this.model.tooltipText, data);
            this._addTitleText();
        },
        _previewPane: function (showPreview) {
            showPreview ? this._previewTag.removeClass("e-hide") : this._previewTag.addClass("e-hide");
        },
        _previewSlider: function (slider) {
            slider ? this._opacity.enable() : this._opacity.disable();
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _localize: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._localizedLabels)) {
                if (!ej.isNullOrUndefined(this._localizedLabels.buttonText))
                    this._buttonText(this._localizedLabels.buttonText)
                if (!ej.isNullOrUndefined(this._localizedLabels.tooltipText))
                    this._toolTipText(this._localizedLabels.tooltipText)
            }
        },
        _destroy: function () {
            if (this.isPopupOpen) this.hide();
            this.popupContainer.remove();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
                this._presetContainer.parent('.e-menu-wrap').remove();
            }
            this.element.removeClass('e-colorpicker e-input e-widget').removeAttr("style name").val(this.element.attr("value"));
        },
        _init: function () {
            this._browser = ej.browserInfo();
            this._isFocused = false;
            this.isPopupOpen = false;
            this._dataBind = false;
            this._modelType = "picker";
            if (this._id)
                $("#" + this._id + "_popup").remove();
            if ("#" + this._id + "_Presets")
                $('#' + this._id + "_Presets").parent('.e-menu-wrap').remove();
            this.model.palette === "basicpalette" ? this._presetsId = "e-presets30" : "";
            if (ej.isNullOrUndefined(this.value()) && this.element[0].value !== "") this._tempValue = this.element[0].value;
            else this._tempValue = this.value();
            this._previousValue = this._previousColor = this._tempValue;
            this._renderControl();
            this._tempOpacity = this.opacityValue();
            this.model.palette === "custompalette" && this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            this.popupContainer.find('button.e-presets').ejSplitButton({ targetID: this._presetContainer.attr('id') });
            if (this._tempValue) {
                this._setValue(this._tempValue);
                if (this._switch) this._rgbValue();
            }
            this._hsvValue();
            this._hueGradient();
            this._addTitleText();
            this._showClearIcon(this.model.showClearButton);
            this._columns = this.model.columns;
            this._temp = this.model.presetType;
            if (!this._tempValue) {
                this._colorSlider.option('value', parseInt(this._hsv.h));
                this._opacity.option('value', this._tempOpacity);
                this._alphaGradient("#fff");
                this._previousValue = "";
            }
            !this.model.enabled && this._enabled(this.model.enabled);
        },
        _renderControl: function () {
            this._createWrapper();
            this._renderPopupPanelWrapper();
            this._selectedButton = this._groupTag.find('.e-click');
            this._buttonContainer();
            this._renderPopupElement();
            this._buttonElement = ej.ColorPicker.ButtonMode.Split == this.model.buttonMode ? this.dropdownbutton : this.wrapper;
            if (this.model.buttonMode == ej.ColorPicker.ButtonMode.Split && this.element.is('input')) this.wrapper.addClass("e-split");
            this._addAttr(this.model.htmlAttributes);
            this._setDisplayInline(this.model.displayInline);
            this._previewPane(this.model.showPreview);
            this._previewColor(this.model.showRecentColors);
            this._localize();
            if (this._switch) this._previewSlider(this.model.enableOpacity);
            this._wireEvents();
            this._switchEvents();
        },

        _createWrapper: function () {
            if (this.element.is("input")) {
                this.element.addClass('e-input e-widget');
                this.spanElement = ej.buildTag("span.e-selected-color");
                this.wrapper = ej.buildTag("span.e-colorwidget e-picker e-widget " + this.model.cssClass).attr({ 'tabindex': '0', "aria-expanded": false, "aria-haspopup": true, "aria-owns": "popup" });
                if (this._id) this.wrapper.attr('id', this._id + "Wrapper");
                this.container = ej.buildTag("span.e-in-wrap e-box e-splitarrowright");
                this.drpbtnspan = ej.buildTag("span.e-icon e-arrow-sans-down", "", {}, { "aria-label": "select" });
                this.dropdownbutton = ej.buildTag("span.e-select", "", {}, { "role": "button" }).append(this.drpbtnspan);
                this.iconWrapper = ej.buildTag("span.e-tool-icon " + this.model.toolIcon);
                this.colorContainer = ej.buildTag("span.e-color-container");
                this.colorContainer.append(this.spanElement);
                this.container.insertAfter(this.element);
                if (!ej.isNullOrUndefined(this.model.toolIcon)) {
                    this.colorContainer.prepend(this.iconWrapper);
                    this.container.addClass('e-tool');
                    this.container.append(this.colorContainer);
                }
                else
                    this.container.append(this.colorContainer);
                this.container.append(this.element, this.dropdownbutton);
                this.wrapper.insertBefore(this.container);
                this.wrapper.append(this.container);
                this.element.css("display", "none").val(this.value());
            }
            this._checkNameAttr();
        },
        _addTitleText: function () {
            this._switcher.attr('title', this.model.tooltipText.switcher);
            this._spanTag.attr('title', this.model.tooltipText.addButton);
            this._presetLi.find("#e-presets00").attr('title', this.model.tooltipText.webColors);
            this._presetLi.find("#e-presets01").attr('title', this.model.tooltipText.vintage);
            this._presetLi.find("#e-presets02").attr('title', this.model.tooltipText.seaWolf);
            this._presetLi.find("#e-presets10").attr('title', this.model.tooltipText.sandy);
            this._presetLi.find("#e-presets11").attr('title', this.model.tooltipText.pinkShades);
            this._presetLi.find("#e-presets12").attr('title', this.model.tooltipText.moonLight);
            this._presetLi.find("#e-presets20").attr('title', this.model.tooltipText.monoChrome);
            this._presetLi.find("#e-presets21").attr('title', this.model.tooltipText.misty);
            this._presetLi.find("#e-presets22").attr('title', this.model.tooltipText.flatColors);
            this._presetLi.find("#e-presets30").attr('title', this.model.tooltipText.basic);
            this._presetLi.find("#e-presets31").attr('title', this.model.tooltipText.candyCrush);
            this._presetLi.find("#e-presets32").attr('title', this.model.tooltipText.citrus);
            this._currentTag.attr('title', this.model.tooltipText.currentColor);
            this._previousTag.attr('title', this.model.tooltipText.selectedColor);
        },
        _renderPopupPanelWrapper: function () {
            this.popupContainer = ej.buildTag("div.e-colorpicker e-box e-popup e-widget " + this.model.cssClass, "", {}, { "role": "grid", "aria-readonly": "true", "tabindex": '0', "style": "visibility:hidden" });
            if (this._id) this.popupContainer.attr('id', this._id + "_popup");
            $('body').append(this.popupContainer);

            this.popupList = ej.buildTag("div.e-popupWrapper");

            this._gradient = ej.buildTag("div.e-container");

            this._colorArea = ej.buildTag("div.e-hsv-color");
            this._gradientArea = ej.buildTag("div.e-hsv-gradient")
            this._handleArea = ej.buildTag("div.e-draghandle e-color-image");
            this._browser == "msie" && this._handleArea.addClass('e-pinch');
            this._colorArea.append(this._gradientArea, this._handleArea);

            this._picker = ej.buildTag("div.e-gradient");
            this._hueSlider = ej.buildTag("div.e-widget e-hue e-state-default");
            this._alphaSlider = ej.buildTag("div.e-widget e-opacity e-state-default");
            this._picker.append(this._hueSlider, this._alphaSlider);

            this._gradient.append(this._colorArea, this._picker);

            this.popupList.append(this._gradient);


            this._footerBlock = ej.buildTag("div.e-footerContainer");

            this._templateWrapper = ej.buildTag("div.e-buttons");


            this._groupTag = ej.buildTag("div.e-grpbtn");

            this._formEle = ej.buildTag("div.e-form");
            this._rgb = ej.buildTag("button.e-rgbButton e-click", "", {}, { type: "button" });
            this._hexCode = ej.buildTag("button.e-hexButton", "", {}, { type: "button" });
            this._hsva = ej.buildTag("button.e-hsvButton", "", {}, { type: "button" });
            this._groupTag.append(this._rgb, this._hexCode, this._hsva);


            this._codeEditor = ej.buildTag("div.e-codeeditor");
            this._inputTag = ej.buildTag("input.e-color-code", "", {}, { "type": "text", 'tabindex': '0', "maxLength": "22" });
            this._codeEditor.append(this._inputTag);

            this._formEle.append(this._groupTag, this._codeEditor);

            this._previewTag = ej.buildTag("div.e-preview").attr({ 'tabindex': '0' });
            this._currentTag = ej.buildTag("div.e-current");
            this._previousTag = ej.buildTag("div.e-previous");
            this._previewTag.append(this._currentTag, this._previousTag);

            this._templateWrapper.append(this._formEle, this._previewTag);

            this._swatchesArea = ej.buildTag("div.e-color-labels");
            var blockCount = 11;
            this._divTag = ej.buildTag("div.e-recent-color");
            this._addTag = ej.buildTag('div.e-colorblock e-block');
            this._spanTag = ej.buildTag('div.e-color e-color-image e-add');
            this._addTag.append(this._spanTag)
            this._divTag.append(this._addTag);
            for (var count = 0; count < blockCount; count++) {
                this._liTag = ej.buildTag('div.e-colorblock e-block');
                var spanTag = ej.buildTag('div.e-color e-color-image e-empty');
                this._liTag.append(spanTag);
                this._divTag.prepend(this._liTag);
            }
            this._swatchesArea.append(this._divTag);

            this._footer = ej.buildTag('div.e-footer');
            this._swatches = ej.buildTag('div.e-element');
            this._changeTag = ej.buildTag('div.e-switcher').attr('tabindex', '0');
            this._switcher = ej.buildTag('div.e-color-image');
            this._presetTag = ej.buildTag('button.e-presets e-colorSplit');
            this._presets = ej.buildTag('div');
            this._changeTag.append(this._switcher);
            this._presetTag.append(this._presets);
            this._swatches.append(this._changeTag, this._presetTag);
            this._footer.append(this._swatches);
            this._footerBlock.append(this._templateWrapper, this._swatchesArea, this._footer);

            this.PaletteWrapper = this._layoutType(this.model.palette);
            this.popupList.append(this.PaletteWrapper, this._footerBlock);
            var oldWrapper = $("#" + this._id + "_Presets").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._presetContainer = $("<ul id='" + this._id + "_Presets' class='e-presetWrapper' style: top:87px ></ul>");
            this._presetLi = ej.buildTag('li.e-item');
            this._presetLi.append(this._renderPresets());
            this._presetContainer.append(this._presetLi);
            this.popupList.append(this._presetContainer);
            this.popupContainer.append(this.popupList);

            //IE Support
            if (this._browser.name = "msie" && (this._browser.version == "9.0" || this._browser.version == "8.0"))
                this._hueSlider.addClass('e-color-image e-filter');
            else
                this._hueSlider.addClass('e-common');
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
        },
        _buttonContainer: function () {
            if (this.model.displayInline) return;
            if (this.model.showApplyCancel) {
                this._buttonTag = ej.buildTag("button.e-applyButton", "", {}, { type: "button" });
                this._cancelTag = ej.buildTag("button.e-cancelButton", "", {}, { type: "button" });
                this._footer.append(this._buttonTag, this._cancelTag);
                this._applyObj = this.popupContainer.find('button.e-applyButton').ejButton({ text: this.model.buttonText.apply, type: "button", cssClass: "e-flat" }).data('ejButton');
                this._cancelObj = this.popupContainer.find('button.e-cancelButton').ejButton({ text: this.model.buttonText.cancel, type: "button", cssClass: "e-flat" }).data('ejButton');
                this._on(this._cancelTag, "click", this._hidePopup);
                this._on(this._buttonTag, "click", this._buttonClick);
            } else if (this._buttonTag !== undefined && this._cancelTag !== undefined) {
                this._buttonTag.remove();
                this._cancelTag.remove();
                this._off(this._cancelTag, "click", this._hidePopup);
                this._off(this._buttonTag, "click", this._buttonClick);
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._enabled(false);
                else proxy.wrapper.attr(key, value)
            });
        },
        _showClearIcon: function (bool) {
            if (bool) {
                this._clearIcon = ej.buildTag("div", {}, {}, { "class": "e-icon e-close_01" }).hide();
                this._codeEditor.append(this._clearIcon);
                this._on(this._clearIcon, "mousedown", this._clearColor);
                this._on(this._clearIcon, "click", this._clearColor);
            } else {
                this._clearIcon && this._clearIcon.remove();
                this._off(this._clearIcon, "mousedown", this._clearColor);
                this._off(this._clearIcon, "click", this._clearColor);
            }
        },
        _colorPresetsClick: function (e) {
            this._presetsId = e.currentTarget.id;
            if (this._presetsId === "e-presets00") this.model.presetType = "webcolors";
            else if (this._presetsId === "e-presets01") this.model.presetType = "vintage";
            else if (this._presetsId === "e-presets02") this.model.presetType = "seawolf";
            else if (this._presetsId === "e-presets10") this.model.presetType = "sandy";
            else if (this._presetsId === "e-presets11") this.model.presetType = "pinkshades";
            else if (this._presetsId === "e-presets12") this.model.presetType = "moonlight";
            else if (this._presetsId === "e-presets20") this.model.presetType = "monochrome";
            else if (this._presetsId === "e-presets21") this.model.presetType = "misty";
            else if (this._presetsId === "e-presets22") this.model.presetType = "flatcolors";
            else if (this._presetsId === "e-presets30") this.model.presetType = "basic";
            else if (this._presetsId === "e-presets31") this.model.presetType = "candycrush";
            else if (this._presetsId === "e-presets32") this.model.presetType = "citrus";
            this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            $("#" + this._id + "_Presets").find("li.e-preset-row").removeClass("e-presetsactive");
            $("#" + this._presetsId).addClass("e-presetsactive");
            this.PaletteWrapper.remove();
            if (this._modelType == "palette") {
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._gradient.addClass('e-hide');
                this._paletteType();
                this._switcher.addClass('e-pickerModel').removeClass('e-paletteModel');
            }
        },

        _renderPresets: function () {
            var tableDiv = ej.buildTag("div.e-presets-table");
            this._spnTag = ej.buildTag("span.e-presetHeader");
            this._spnTag.html(this.model.buttonText.swatches);
            tableDiv.append(this._spnTag);
            var color = 0, hexCode, rowDiv;
            for (var row = 0; row < 4 ; row++) {
                rowDiv = ej.buildTag("ul.e-tablerow");
                for (var col = 0; col < 3 ; col++) {
                    var tableCell = ej.buildTag("li.e-color-image e-preset-row" + "#" + "e-presets" + [row] + [col]);
                    tableCell.appendTo(rowDiv);
                }
                rowDiv.appendTo(tableDiv);
            }
            return tableDiv;
        },
        _renderPopupElement: function () {
            var proxy = this;
            this._hsv =
            {
                h: 360, s: 0, v: 100
            };
            this._rgb.ejButton({ text: "RGBA", type: "button" });
            this._hexCode.ejButton({ text: "HEX", type: "button" });
            this._hsva.ejButton({ text: "HSVA", type: "button" });
            this._splitObj = this._presetTag.ejSplitButton({ size: "normal", showRoundedCorner: true, contentType: "imageonly" }).data('ejSplitButton');
            this._splitObj.option("beforeOpen", function (e) { proxy._bindClickOperation(e); });
            this._presetTag.parents('.e-split.e-widget').css({ "height": "27px" });
            this.model.custom.length == 0 ? this._splitObj.option('prefixIcon', "e-icon e-color-image e-" + this.model.presetType) : "";
            $("#" + this._presetsId).addClass("e-presetsactive");
            this._splitObj._getXYpos = function (e) {
                $("#" + this.model.targetID).ejMenu({ animationType: "none" });
                var btnposx, btnposy, btnpos = this.dropbutton.offset();
                btnposx = btnpos.left - this.dropbutton.prev().outerWidth() - 1;
                btnposy = (btnpos.top - $("#" + this.model.targetID).outerHeight()) - 1;
                return { x: btnposx, y: btnposy }
            }
            this._colorSlider = this._hueSlider.ejSlider({ orientation: "Vertical", showTooltip: this.model.showTooltip, minValue: 0, maxValue: 360, change: function (e) { proxy._changeHue(e); }, slide: function (e) { proxy._changeHue(e); } }).data('ejSlider');
            this._opacity = this._alphaSlider.ejSlider({ value: this.opacityValue(), showTooltip: this.model.showTooltip, orientation: "Vertical", incrementStep: 5, value: 100, change: function (e) { proxy._changeAlpha(e); }, slide: function (e) { proxy._changeAlpha(e); } }).data('ejSlider');
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._handleTag = ej.buildTag("div.e-handle-wrapper");
                this._handleTag.appendTo(this._opacity.element.find("a.e-handle"));
            }
            this._colorSlider.firstHandle.css({ "height": "13px", "width": "13px" });
            this._opacity.firstHandle.css({ "height": "13px", "width": "13px" });
            this.popupContainer.css({ "visibility": "visible", "display": "none" });
            if (this.model.modelType == "picker") {
                this._modelType = "picker";
                this._gradient.removeClass('e-hide');
                this.PaletteWrapper.addClass('e-hide');
                this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
                this._showSwitcher();
                this._switch = true;
            } else if (this.model.modelType == "palette") {
                this._modelType = "palette";
                this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
                this.PaletteWrapper.removeClass('e-hide');
                this._gradient.addClass('e-hide');
                this._hsva.ejButton("disable");
                this._showSwitcher();
                this._switch = false;
            }
        },
        _layoutType: function (type) {
            if (typeof type === "string" && type == "basicpalette")
                this._collection = this._paletteGenerate(Colors[this.model.presetType], this.model.columns);
            else if (typeof type === "string" && type == "custompalette" && this.model.modelType == "palette")
                this._collection = this._paletteGenerate(this.model.custom, this.model.columns);
            type == "custompalette" ? this._collection.addClass('e-custom') : "";
            return this._collection;
        },
        _presetType: function (type) {
            if (type === "e-presets00") this._collection = this._paletteGenerate(Colors.webcolors, this.model.columns);
            else if (type === "e-presets01") this._collection = this._paletteGenerate(Colors.vintage, this.model.columns);
            else if (type === "e-presets02") this._collection = this._paletteGenerate(Colors.seawolf, this.model.columns);
            else if (type === "e-presets10") this._collection = this._paletteGenerate(Colors.sandy, this.model.columns);
            else if (type === "e-presets11") this._collection = this._paletteGenerate(Colors.pinkshades, this.model.columns);
            else if (type === "e-presets12") this._collection = this._paletteGenerate(Colors.moonlight, this.model.columns);
            else if (type === "e-presets20") this._collection = this._paletteGenerate(Colors.monochrome, this.model.columns);
            else if (type === "e-presets21") this._collection = this._paletteGenerate(Colors.misty, this.model.columns);
            else if (type === "e-presets22") this._collection = this._paletteGenerate(Colors.flatcolors, this.model.columns);
            else if (type === "e-presets30") this._collection = this._paletteGenerate(Colors.basic, this.model.columns);
            else if (type === "e-presets31") this._collection = this._paletteGenerate(Colors.candycrush, this.model.columns);
            else if (type === "e-presets32") this._collection = this._paletteGenerate(Colors.citrus, this.model.columns);
            return this._collection;
        },
        _paletteGenerate: function (colors, columns) {
            var color;
            this._PresetTable = ej.buildTag("div.e-palette-color").attr({ "role": "presentation" });
            this._tag = ej.buildTag("div.e-row");
            for (color = 0; color < colors.length; color++) {
                if (color && color % columns == 0)
                    this._tag = ej.buildTag("div.e-row");
                this._td = ej.buildTag("div.e-item").attr({ 'role': 'gridcell', "aria-label": "#" + $.trim(colors[color]), "value": "#" + $.trim(colors[color]), "style": "background-color:" + "#" + $.trim(colors[color]) });
                this._tag.append(this._td);
                this._PresetTable.append(this._tag);
            }
            return this._PresetTable;
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name")) this.element.attr({ "name": this.element[0].id });
        },
        _enabled: function (bool) {
            if (bool) this.enable();
            else {
                this.model.enabled = true;
                this.disable();
            }
        },
        _setDisplayInline: function (isDisplayInline) {
            this.model.displayInline = isDisplayInline;
            if (isDisplayInline && this.element.is("input")) {
                this.popupContainer.insertAfter(this.wrapper);
                this._footer.css({ "display": "none" });
                this._setPopupPosition();
            }
            else if (isDisplayInline) {
                this.element.append(this.popupContainer);
                this.popupContainer.find('button.e-applyButton').css({ "display": "none" });
                this.popupContainer.find('button.e-cancelButton').css({ "display": "none" });
                this._footer.css({ "display": "none" });
            }
            else {
                this.popupContainer.css('display', 'none');
                $('body').append(this.popupContainer);
                this._isOpen = false;
                if (this.element.is("input")) {
                    this._bindIconClick();
                    if (this.popupContainer.find('button.e-applyButton').length==0) {
                        this._buttonContainer();
                    }
                    this._footer.css({ "display": "block" });
                    this.wrapper.removeClass("e-focus");
                    this._off($(document), "mousedown", this._onDocumentClick);
                }
                this._isFocused = this.isPopupOpen = false;
            }
            if (isDisplayInline) {
                this.show();
                if (this.element.is("input")) this._off($(this._buttonElement), "mousedown", this._iconClick);
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            }
        },
        _bindIconClick: function () {
            var count = $._data($(this._buttonElement)[0], "events");
            if (ej.isNullOrUndefined(count) || ej.isNullOrUndefined(count.mousedown)) this._on(this._buttonElement, "mousedown", this._iconClick);
            else if (count.mousedown.length == 0) this._on(this._buttonElement, "mousedown", this._iconClick);
        },
        _unBindIconClick: function () {
            this._off(this._buttonElement, "mousedown", this._iconClick);
        },
        _setPopupPosition: function () {
            var elementObj = this.element.is('input') ? this.wrapper : this.element;
            var pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupContainer.outerHeight(),
            popupWidth = this.popupContainer.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupContainer.outerWidth() - elementObj.outerWidth();
            if (popupWidth + elementObj.offset().left > $(window).width()) left = Math.abs(popupWidth - ($(window).width()));
            this.popupContainer.css({
                "left": left + "px",
                'position': 'absolute',
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupContainer);
        },

        _setValue: function (value, isCode) {
            var reg = "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$";
            if (typeof value == "object" || (typeof value == "number") || ej.isNullOrUndefined(value.match(reg))) value = null;
            this.value(value);
            this._tempValue = value;
            ej.isNullOrUndefined(value) ? this._setEmptyValue() : this._renderModelValue(value);
            this._changeEvent(false, isCode);
            this._selectEvent();
            this.element.is("input") && this._updateValue();
        },
        _renderModelValue: function (value) {
            var color;
            if (value && typeof value === "string") {
                color = this._HexToHSV(value);
                this._oldValue = this.rgb;
                if (this._switch) {
                    this._valueOperation();
                    this._colorSlider.option('value', parseInt(this._hsv.h));
                }
                this._inputTagValue(this._selectedButton);
                if (!this._switch) {
                    this._updateUI();
                    this.element.val(this.value());
                }
                this._hueGradient();
            }
        },
        setValue: function (code) {
            this._setValue(code);
        },

        enable: function () {
            if (this.model.enabled) return false;
            if (this.wrapper && this.wrapper.hasClass("e-disable")) {
                this.wrapper.removeClass("e-disable");
                this.element.prop("disabled", false);
                if (this.container.hasClass("e-disable")) this.container.removeClass('e-disable');
                this.popupList.removeClass('e-disable');
                this.dropdownbutton.removeClass('e-disable');
            } else if (this.model.displayInline) this.element.removeClass('e-disable');
            var temp = this._switch;
            this._switch = true;
            this._cancelObj.enable();
            this._colorSlider.enable();
            this.model.enableOpacity ? this._opacity.enable() : this._opacity.disable();
            this._splitObj.enable();
            this._applyObj.enable();
            this._wireEvents();
            this._switchEvents();
            this._switch = temp;
            $(this._inputTag).prop('readonly', false);
            (this._buttonElement) && this._on(this._buttonElement, "mousedown", this._iconClick);
            this.model.enabled = true;
        },

        disable: function () {
            if (!this.model.enabled) return false;
            if (this.wrapper && !this.wrapper.hasClass("e-disable")) {
                this.wrapper.addClass("e-disable");
                this.element.attr("disabled", "disabled");
                if (!this.container.hasClass("e-disable")) this.container.addClass('e-disable');
                this.popupList.addClass('e-disable');
                this.dropdownbutton.addClass('e-disable');
            } else if (this.model.displayInline) this.element.addClass('e-disable');
            var temp = this._switch;
            this._switch = false;
            this._cancelObj.disable();
            this._colorSlider.disable();
            this._opacity.disable();
            this._splitObj.disable();
            this._applyObj.disable();
            this._unWireEvents();
            this._unSwitchEvents();
            this._switch = temp;
            this._unBindIconClick();
            $(this._inputTag).attr('readonly', 'readonly');
            if (this.isPopupOpen && !this.model.displayInline) this.hide();
            this.model.enabled = false;
        },

        getColor: function () {
            return this.rgb;
        },

        getValue: function () {
            return this.value();
        },
        _alphaGradient: function (value) {
            var browser = ej.browserInfo();
            var value = ej.isNullOrUndefined(value) ? "#000000" : value;
            if (browser.name == "mozilla")
                this._alphaSlider.attr({ "style": "background:-moz-linear-gradient(center top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if ((browser.name == "msie") || (browser.name == "edge"))
                this._alphaSlider.attr({ "style": "background:-ms-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if (browser.name == "opera" && browser.version <= "11.61")
                this._alphaSlider.attr({ "style": "background:-o-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if (browser.name == "chrome" || browser.name == "safari" || (browser.name == "opera"))
                this._alphaSlider.attr({ "style": "background:-webkit-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            if ((browser.name == "msie") && (browser.version == "8.0" || browser.version == "9.0"))
                this._alphaSlider.attr({ "style": "progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr=" + value + ", endColorstr=#ffffff)"});            
            if (browser.name == "msie" && browser.version == "8.0")
                this._handleTag.css({ "background": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
        },
        _hueGradient: function () {
            var temp = this._hsv;
            var value = { h: this._hsv.h, s: 100, v: 100 };
            this._hueSlider.children(".e-handle").css({ "background": this._formRGB(this.HSVToRGB(value)) });
            this._hsv = temp;
        },
        _updateColor: function () {
            if (this.model.displayInline || !this.model.showApplyCancel) {
                this.value(this._tempValue);
                if (this.element.is("input")) this._updateValue();
                this._trigger("select", { value: this.value() });
                this._previousColor = this._tempValue;
            }
        },
        _changeEvent: function (element, isCode) {
            if (this._change && this._previousValue !== this._tempValue) {
                this._alphaGradient(this._tempValue);
                this._previousValue = this._tempValue;
                this._trigger("change", { value: this._tempValue, changeFrom: element ? "slider" : "picker", isInteraction: !isCode });
                this._updateColor(element);
            }
        },
        _selectEvent: function () {
            if (this._previousColor !== this._tempValue || this._tempOpacity !== this.opacityValue()) {
                this.value(this._tempValue);
                if (this.element.is("input")) this._updateValue();
                this.element.val(this.value());
                this._trigger("select", { value: this.value() });
                this._previousColor = this._tempValue;
            }
        },
        _changeHue: function (e) {
            this._handleArea.css("visibility", "visible");
            if (parseInt(this._hsv.h) !== parseInt(e.value) && this._switch) {
                this._hsv.h = Math.round(e.value);
                this._hueGradient();
                this._hsvValue();
                this._tempValue = this.RGBToHEX(this.rgb);
                this._changeEvent(true);
            }
        },
        _changeAlpha: function (e) {
            this._handleArea.css("visibility", "visible");
            if (this._switch) {
                this.rgb.a = e.value / 100;
                this._tempOpacity = parseInt(this.rgb.a * 100);
                this._changeOpacity(e);
            }
        },
        _changeOpacity: function (e) {
            this.rgb.a = this._tempOpacity / 100;
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._currentTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                this._handleTag.css({ "background": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            }
            else {
                this._currentTag.css("background-color", this._formRGBA(this.rgb));
                this._alphaSlider.children(".e-handle").css({ "background": this._formRGBA(this.rgb) });
            }
            this._inputTagValue(this._selectedButton);
            if (this.model.displayInline) {
                this._trigger("change", { value: this._tempValue, changeFrom: "slider", isInteraction: !ej.isNullOrUndefined(e) ? e.isInteraction : false });
                (this._trigger("select", { value: this.value() }));
            }
        else this._trigger("change", { value: this._tempValue, changeFrom: "slider", isInteraction: !ej.isNullOrUndefined(e) ? e.isInteraction: false });
        },
        _updateValue: function () {
            if (this.value()) {
                if (this._browser.name = "msie" && this._browser.version == "8.0") this.spanElement.css({ "background-color": this._formRGB(this._HexToRGB(this.value())), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                else this.spanElement.css({ "background-color": this._formRGBA(this._HexToRGB(this.value())) });
            }
            else this.spanElement.removeAttr('style');
        },
        _bindClickOperation: function (e) {
            var proxy = this, splitMenu;
            proxy._on($("#" + this._id + "_Presets").find("li.e-preset-row"), "mousedown", proxy._colorPresetsClick);
            var SplitMenu = $("#" + proxy._presetContainer.attr('id')).ejMenu("instance");
                SplitMenu.model.close = function () {
                proxy._splitObj.contstatus = false;
                proxy._off($("#" + this._id + "_Presets").find("li.e-preset-row"), "mousedown", proxy._colorPresetsClick);
            }
        },
        _wireEvents: function () {
            if (this.element.is('input')) {
                this._on(this.wrapper, "blur", this._targetBlur);
                this._on(this.wrapper, "focus", this._targetFocus);
                this._on(this.wrapper, "keydown", this._popupShown);
                this._on(this.colorContainer, "click", this._containerClick);
            }
            this._on(this._changeTag, "click", this._switchModel);
            this._on(this._groupTag, "click", this._groupButton);
            this._on(this._addTag, "click", this._addColor);
            this._on(this._codeEditor, "mouseenter", this._inputEvent);
            this._on(this._codeEditor, "mouseleave", this._inputEvent);
            this._on(this._inputTag, "blur", this._inputEvent);
            this._on(this._inputTag, "focus", this._inputEvent);
            this._on(this._inputTag, "keyup", this._inputEvent);
            this._on(this.popupContainer, "focus", this._targetFocus);
            this._on(this.popupContainer, "blur", this._targetBlur);
        },
        _unWireEvents: function () {
            if (!this.model.displayInline && this.element.is('input')) {
                this._off(this.wrapper, "blur", this._targetBlur);
                this._off(this.wrapper, "focus", this._targetFocus);
                this._off(this.wrapper, "keydown", this._popupShown);
                this._off(this.colorContainer, "click", this._containerClick);
            }
            this._off(this._changeTag, "click", this._switchModel);
            this._off(this._groupTag, "click", this._groupButton);
            this._off(this._addTag, "click", this._addColor);
            this._off(this._codeEditor, "mouseenter", this._inputEvent);
            this._off(this._codeEditor, "mouseleave", this._inputEvent);
            this._off(this._inputTag, "blur", this._inputEvent);
            this._off(this._inputTag, "focus", this._inputEvent);
            this._off(this._inputTag, "keyup", this._inputEvent);
            this._off(this.popupContainer, "focus", this._targetFocus);
            this._off(this.popupContainer, "blur", this._targetBlur);
        },
        _inputEvent: function (e) {
            if (!this._clearIcon) return;
            if (e.type === "focus") this._off(this._codeEditor, "mouseleave", this._inputEvent);
            if (e.type === "blur") this._on(this._codeEditor, "mouseleave", this._inputEvent);
            if (e.type === "keyup") this._inputTag.val() !== "" ? (this._clearIcon.show(), this._handleArea.css("visibility", "visible")) : (this._clearIcon.hide(), this._handleArea.css("visibility", "hidden"));
            if (e.type === "mouseleave" || e.type === "blur" || this._inputTag.val() == "") this._clearIcon.hide();
            else this._clearIcon.show();
        },
        _clearColor: function (e) {
            this._tempValue = "";
            this._inputTag.val("");
            this._setEmptyValue();
            if (e.type == "click") {
                this._clearIcon.hide();
                this._inputTag.focus();
            }
        },
        _containerClick: function () {
            if (this.model.buttonMode == "split") this._trigger("select", { value: this.value() });
        },
        _popupShown: function (e) {
            if (e.keyCode == 13) {
                this._showHidePopup();
                if (!this.isPopupOpen)
                    this._buttonClick(e);
                return false;
            }
        },
        _recentColor: function (e) {
            this._divTag.find('.e-select').removeClass('e-select').addClass('e-block');
            var hexCode = e.target.attributes.value, value;
            var rgbCode = e.target.attributes.style;
            if (ej.isNullOrUndefined(hexCode) || ej.isNullOrUndefined(rgbCode)) { this._change = false; return false; }
            $(e.target.parentNode).addClass('e-select').removeClass('e-block');
            var alpha = rgbCode.value.replace(/^(background-color:rgb|background-color:rgba)\(/, '').replace(/\)$/, '').replace(/\s/g, '').split(',');
            if (!ej.isNullOrUndefined(alpha[3])) {
                this._opacity.option('value', parseInt((parseFloat(alpha[3]) * 100).toFixed(2)));
                this.rgb.a = parseFloat(parseFloat(alpha[3]).toFixed(2));
            }
            else if (this._browser.name = "msie" && this._browser.version == "8.0") {
                value = parseInt(rgbCode.nodeValue.replace(/^(FILTER: alpha)\(/, '').split('=')[1].split(')')[0]);
                this._opacity.option('value', value);
                this.rgb.a = value / 100;
            }
            else {
                this._opacity.option('value', 100);
                this.rgb.a = 1;
            }
            this._HexToHSV(hexCode.value);
            this._inputTagValue(this._selectedButton);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._valueOperation();
            this._colorSlider.option('value', parseInt(this._hsv.h));
            this._hueGradient();
            this._changeEvent(false);
            if (!this.model.displayInline || this.element.is("input"))
                this.wrapper.focus();
        },

        _handleClick: function (e) {
            e.preventDefault();
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
            if (this.model.displayInline)
                this._isFocused = true;
            this._handleArea.css("visibility", "visible");
            this.mouseDownPos = this._handlePos;
            $(document).on("mousemove touchmove", $.proxy(this._handleMovement, this));
            $(document).on("mouseup touchend", $.proxy(this._handleUp, this));
        },
        _handleMove: function (e) {
            this._handleArea.css("visibility", "visible");
            this._handleMovement(e);
            this._focusWrapper(e);
        },
        _handleMovement: function (e) {
            if (!this.model.enabled) return false;
            var clientX = e.pageX, clientY = e.pageY;
            this.element.is("input") && this.wrapper.focus();
            if (e.type == "touchstart" || e.type == "touchmove") {
                clientX = e.originalEvent.changedTouches[0].pageX;
                clientY = e.originalEvent.changedTouches[0].pageY;
            }
            this._hsv.v = parseInt(100 * (this._gradientArea.height() - Math.max(0, Math.min(this._gradientArea.height(), (clientY - this._gradientArea.offset().top)))) / this._gradientArea.height(), 10);
            this._hsv.s = parseInt(100 * (Math.max(0, Math.min(this._gradientArea.width(), (clientX - this._gradientArea.offset().left)))) / this._gradientArea.width(), 10);
            this._hsvValue();
            this._tempValue = this.RGBToHEX(this.rgb);
            this._change = true;
            this._changeEvent(false);
        },
        _handleUp: function (e) {
            $(document).off('mouseup touchend', this._handleUp);
            $(document).off('mousemove touchmove', this._handleMovement);
            this._focusWrapper(e);
            return false;
        },
        _handlePosition: function () {
            this._handlePos = this._handleArea ? {
                left: parseInt(parseInt(this._width) * this._hsv.s / 100, 10) + "px",
                top: parseInt(parseInt(this._height) * (100 - this._hsv.v) / 100, 10) + "px"
            } : "";
            this._handleArea.css({ "left": this._handlePos.left, "top": this._handlePos.top });
        },
        _addColor: function () {
            var value, collection = this._divTag.find('> div');
            value = this._selectedButton.html() != "HSVA" ? this._inputTag.val() : this._formRGBA(this.HSVToRGB(this._hsv));
            if (value !== "" && this._change) {
                if (this.model.showRecentColors && collection.length <= 12) {
                    $($(collection)[collection.length - 2]).remove();
                    this._generateLi();
                }
            }
            if (!this.model.displayInline || this.element.is("input")) this.wrapper.focus();
        },
        _buttonClick: function (e) {
            this._change = true;
            var value = this._inputTag.val(), collection = this._divTag.find('div');
            this._opacity.option('value', this._tempOpacity);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._updatePreviewColor();
            if (this._inputTag.val() === "") {
                this._tempValue = "";
                if (this.model.showClearButton) this._setValue("");
                else {
                    this._inputTag.addClass('e-error');
                    return false;
                }
            }
            this._selectEvent();
            if (this.element.is("input")) {
                this._updateValue();
                this.wrapper.focus();
            }
            !this.model.displayInline && this.hide();
            this._tempOpacity !== this.opacityValue() && this.opacityValue(this._tempOpacity);
        },
        _generateLi: function () {
            this._liTag = ej.buildTag('div.e-colorblock e-block e-colorset').attr({ "value": this.RGBToHEX(this.rgb), "tabindex": "0" });
            var spanTag = ej.buildTag('div.e-color e-set').attr({ "value": this.RGBToHEX(this.rgb), "title": this.RGBToHEX(this.rgb) });
            if (this._browser.name = "msie" && this._browser.version == "8.0") spanTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            else spanTag.css({ "background-color": this._formRGBA(this.rgb) });
            this._liTag.append(spanTag);
            this._divTag.prepend(this._liTag);
        },
        _colorCodeValue: function (e) {
            var newValue = "", codeValue = this._inputTag.val(), value, code, count;
            value = $.trim(codeValue);
            value.length == 5 ? this._inputTag.removeClass('e-error') : "";
            if ((e.shiftKey && e.keyCode >= 35 && e.keyCode <= 40 || (e.keyCode >= 65 && e.keyCode < 71) ) || (e.keyCode == 51) || (e.ctrlKey && (e.keyCode == 88 || e.keyCode == 86)) || e.keyCode == 190)
                this._keyPressFlag = 1;
            else if ((!e.crtlKey && !e.shiftKey) && ((e.keyCode >= 65 && e.keyCode < 71) || (e.keyCode >= 35 && e.keyCode <= 40) || (e.keyCode >= 96 && e.keyCode <= 105) || (e.keyCode >= 48 && e.keyCode <= 57) || e.keyCode == 13 || e.keyCode == 8 || e.keyCode == 46 || e.type === "blur"))
                this._keyPressFlag = 1;
            else this._keyPressFlag = 0;
            if (this.model.enableOpacity && (e.keyCode == 188 || e.keyCode == 71 || e.keyCode == 72 || e.keyCode == 82 || e.keyCode == 83 || e.keyCode == 86) || (e.shiftKey && (e.keyCode == 57 || e.keyCode == 48)))
                this._keyPressFlag = 1;
            if (this._keyPressFlag == 1) {
                this._inputTag.removeClass('e-error');
                if (e.keyCode === 13 || e.type === "blur") {
                    if (value === "") {
                        if (this.model.showClearButton) this._setEmptyValue();
                        else this._inputTag.addClass('e-error');
                    }
                    var regex = /^\#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/;
                    code = value.match(regex);
                    if (!ej.isNullOrUndefined(code)) {
                        if (code[1].length === 3) {
                            for (count = 0; count < code[1].length; count++) {
                                newValue += code[1][count] + code[1][count];
                            }
                        }
                        else if (code[1].length === 6)
                            newValue = code[1];
                        value = this.hexCodeToRGB("#" + newValue);
                        this._inputTag.val("#" + newValue);
                        this.rgb = this.HSVToRGB(this.RGBToHSV(value));
                        this._tempValue = this.RGBToHEX(this.rgb);
                        this._change = true;
                    }
                    else {
                        var rgbRegex = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;
                        code = value.match(rgbRegex);
                        if (!ej.isNullOrUndefined(code)) this._rgbaColor(code);
                        else {
                            var hsvRegex = /^hsva?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;
                            code = value.match(hsvRegex);
                            if (!ej.isNullOrUndefined(code)) {
                                this._hsvColor(code);
                            }
                            else {
                                value != "" && this._inputTag.addClass('e-error');
                                this._change = false;
                                return false;
                            }
                        }
                    }
                    if (this._change) {
                        this._valueOperation();
                        this._colorSlider.option('value', parseInt(this._hsv.h));
                        this._hueGradient();
                        this._changeEvent(false);
                        !this.element.is('input') && this._selectEvent();
                        if (this._inputTag.val() !== "") this._inputTag.removeClass("e-error");
                    }
                }
            }
            else {
                if (e.keyCode != 9) e.preventDefault();
                if (!e.shiftKey && !e.ctrlKey && e.keyCode !== 27 && e.keyCode !=20) this._inputTag.addClass('e-error');
            }
        },
        _setEmptyValue: function () {
            this._handleArea.css("visibility", "hidden");
            this._currentTag.css({ "background-color": "" });
            this._removeClass();
            this._tempValue = null;
            this._inputTag.val(null);
            if (this._previousValue !== this._tempValue) {
                this._trigger("change", { value: null });
                this._previousValue = this._tempValue
            }
        },
        _rgbaColor: function (code) {
            var rgb = {}, color;
            if (code[0].split('(')[0] == "rgba" && !ej.isNullOrUndefined(code[4])) {
                rgb.r = code[1]; rgb.g = code[2]; rgb.b = code[3]; rgb.a = code[4];
            }
            else if (code[0].split('(')[0] == "rgb" && ej.isNullOrUndefined(code[4])) {
                rgb.r = code[1]; rgb.g = code[2]; rgb.b = code[3]; rgb.a = this.rgb.a;
                this._inputTag.val("rgba(" + rgb.r + "," + rgb.g + "," + rgb.b + "," + rgb.a + ")");
            }
            else {
                this._inputTag.addClass('e-error');
                this._change = false;
                return false;
            }
            this.rgb.a = parseFloat(rgb.a);
            this._tempOpacity = this.rgb.a * 100;
            this._opacity.option('value', this._tempOpacity);
            this.opacityValue(this._tempOpacity);
            this._tempValue = this.RGBToHEX(rgb);
            this._HexToHSV(this._tempValue);
            this._inputTag.removeClass("e-error");
            this._change = true;
        },
        _hsvColor: function (code) {
            var hsv = {};
            if (!ej.isNullOrUndefined(code[4])) {
                hsv.h = code[1]; hsv.s = code[2]; hsv.v = code[3]; hsv.a = code[4];
            }
            else {
                this._inputTag.addClass('e-error');
                this._change = false;
                return false;
            }
            this.rgb.a = parseFloat(hsv.a);
            this._tempOpacity = this.rgb.a * 100;
            this._opacity.option('value', this._tempOpacity);
            this.opacityValue(this._tempOpacity);
            this.rgb = this.HSVToRGB(hsv);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._inputTag.removeClass("e-error");
            this._change = true;
        },
        _iconClick: function (e) {
            e.preventDefault();
            this._showHidePopup();
            this.wrapper.focus();
        },
        _showHidePopup: function () {
            if (this.model.displayInline) return false;
            if (!this.isPopupOpen) this.show();
            else {
                this.hide();
                this.wrapper.focus();
            }
        },

        hide: function () {
            var proxy = this;
            if (!this.isPopupOpen||this.model.displayInline) return false;
            this.isPopupOpen = this._dataBind = false;
            if (this.element.is('input')) {
                this.wrapper.focus();
                this.wrapper.removeClass("e-active");
            }
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
            this.popupContainer.slideUp(200, function () {
                if (proxy.model) {
                    proxy._tempOpacity = proxy.opacityValue();
                    proxy.rgb.a = proxy._tempOpacity / 100;
                    proxy._tempValue = proxy.value();
                    proxy._renderModelValue(proxy.value());
                    proxy._opacity.option('value', parseInt(proxy.opacityValue()));
                    if (!proxy.model.displayInline)
                        proxy._off($(document), "mousedown", proxy._onDocumentClick);
                    proxy._trigger("close");
                }
            });
            if (!this.model.displayInline)
                this._off($(document), "mousedown", this._onDocumentClick);
            this._off(this._inputTag, "keydown", this._colorCodeValue);
            this._off(this._inputTag, "blur", this._colorCodeValue);
            this._modelType == "palette" ? this._off($(document), "keydown", this._keyDown) : this._off($(document), "keydown", this._onKeyDown);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
        },
        _hidePopup: function () {
            !this.model.displayInline && this.hide();
        },

        show: function () {
            if (this.element.is("input")) {
                this.wrapper.focus();
                this.wrapper.addClass("e-active");
            }
            if (this.isPopupOpen || !this.model.enabled) return false;
            this.isPopupOpen = true;
            if (this.model.modelType == "palette") this._cellSelect();
            if (!this.model.displayInline && (this.value() === "" || ej.isNullOrUndefined(this.value())))
                this._setEmptyValue();
            else
                this._handleArea.css("visibility", "visible");
            this._previousColor = this._previousValue = this.value();
            this.popupContainer.children().find('.e-focus').removeClass('e-focus');
            if (!this.model.displayInline) this._setPopupPosition();
            var proxy = this;
            this.popupContainer.slideDown(200, function () {
                proxy.isFocused = true;
                proxy._on($(document), "mousedown", proxy._onDocumentClick);
                proxy._trigger("open");
            });
            if (!this._dataBind)
                this._modelType == "palette" ? this._on($(document), "keydown", this._keyDown) : this._on($(document), "keydown", this._onKeyDown);
            this._on(this._inputTag, "keydown", this._colorCodeValue);
            this._on(this._inputTag, "blur", this._colorCodeValue);
            this._dataBind = true;
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            if (!this.model.displayInline) this._on(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            if (this._prevSize !== $(window).width()) this.refresh();
        },
        _showBindEvents: function () {
            this._modelType == "palette" ? this._on($(document), "keydown", this._keyDown) : this._on($(document), "keydown", this._onKeyDown);
        },
        _hideUnBindEvents: function () {
            this._modelType == "palette" ? this._off($(document), "keydown", this._onKeyDown) : this._off($(document), "keydown", this._keyDown);
        },
        _switchEvents: function () {
            if (this._switch) {
                this._on(this._gradientArea, "mousedown touchstart", this._handleMove);
                this._on(this._handleArea, "mousedown touchstart", this._handleClick);
                this._on(this._gradientArea, "mousedown touchstart", this._handleClick);
            }
            else this._on(this._collection, "mousedown", this._onSelect);
        },
        _unSwitchEvents: function () {
            if (!this._switch) {
                this._off(this._gradientArea, "mousedown touchstart", this._handleMove);
                this._off(this._handleArea, "mousedown touchstart", this._handleClick);
                this._off(this._gradientArea, "mousedown touchstart", this._handleClick);
            }
            else this._off(this._collection, "mousedown", this._onSelect);
        },
        _groupButton: function (e) {
            if ($(e.target).hasClass('e-disable')) return false;
            if ($(e.target).hasClass("e-button")) {
                var element = this._groupTag.find('.e-btn.e-select');
                if (this._inputTag.val() !== "") this._inputTagValue($(e.target));
                else this._selectedButton = $(e.target);
                this._selectedButton.html() !== "HEX" ? this._inputTag.attr('maxLength', '22') : this._inputTag.attr('maxLength', '7');
                this._groupTag.find('.e-click').removeClass('e-click');
                $(e.target).addClass('e-click');
                this._inputTag.removeClass('e-error');
            }
        },
        _inputTagValue: function (type) {
            if (type.html() == "RGBA") this._inputTag.val(this._formRGBA(this.rgb));
            else if (type.html() == "HEX") this._inputTag.val(this.RGBToHEX(this.rgb));
            else if (type.html() == "HSVA") {
                if (this._modelType != "palette")
                    this._inputTag.val("hsva(" + Math.round(this._hsv.h) + "," + Math.round(this._hsv.s) + "," + Math.round(this._hsv.v) + "," + this.rgb.a + ")");
            }
            this._selectedButton = type;
        },
        _bindRecentEvent: function () {
            this._on(this._divTag, "click", this._recentColor);
        },
        _unBindRecentEvent: function () {
            this._off(this._divTag, "click", this._recentColor);
        },
        _handlePlacement: function (prop, value, bool) {
            this._handleArea.css("visibility", "visible");
            var hsv = this._hsv;
            hsv[prop] += value * (bool ? 1 : 3);
            if (hsv[prop] < 0) { hsv[prop] = 0; }
            prop === "s" ? this._hsv.s = hsv[prop] : this._hsv.v = hsv[prop];
            this._hsvValue();
            this._tempValue = this.RGBToHEX(this.rgb);
            this._changeEvent(false);
        },
        _onKeyDown: function (e) {
            var key = e.keyCode;
            if (!this.model.enabled) return;
            if (e.shiftKey && key == 9) if ($(this._hueSlider).find('.e-handle').hasClass('e-focus')) this._focusWrapper(e);
            if (!this._isFocused) if (key == 9 && key !== 27) return;
            this._change = true;
            if ((!e.altKey && !e.shiftKey)) {
                switch (key) {
                    case 39:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("s", 1, e.ctrlKey);
                        }
                        break;
                    case 38:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("v", 1, e.ctrlKey);
                        }
                        break;
                    case 37:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("s", -1, e.ctrlKey);
                        }
                        break;
                    case 40:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("v", -1, e.ctrlKey);
                        }
                        break;
                    case 13:
                        e.preventDefault();
                        if ($(e.target).hasClass('e-switcher')) {
                            this._switchModel();
                            $(e.target).focus();
                        }
                        else if ($(e.target).hasClass('e-applyButton')) this._buttonClick(e);
                        break;
                    case 27:
                        e.preventDefault();
                        !this.model.displayInline && this.hide();
                        this._tempValue = this.value();
                        break;
                    case 9:
                        active = document.activeElement;
                        if ($(active).is(this.wrapper)) this._focusPopup(e);
                        break;
                }
            }
        },
        _focusPopup: function (e) {
            $(this._hueSlider).find('.e-handle').focus();
            e.preventDefault();
        },
        _focusWrapper: function (e) {
            this.element.is('input') && $(this.wrapper).focus();
            e.preventDefault();
        },
        _onDocumentClick: function (e) {
            if (!$(e.target).is(this.popupContainer) && !$(e.target).parents(".e-colorpicker").is(this.popupContainer) &&
              !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-colorpickerwidget").is(this.wrapper) && !$(e.target).parents('.e-presetWrapper').is("#" + this._id + "_Presets")) {
                if (!this.model.displayInline) {
                    this.hide();
                    if (this.element.is('input')) this.wrapper.removeClass('e-focus');
                }
                this._isFocused = false;
            }
        },

        _OnWindowResize: function (e) {
            if (this.element.is('input')) this._setPopupPosition();
            this.refresh();
        },
        refresh: function () {
            var element = $(this._PresetTable.find('.e-item')[1]);
            var count = 10, paddingSize = 36; //paddingSize is fixed for  palette model cells
            if (!this.isPopupOpen) {
                this.popupContainer.css({ "display": "block", "visibility": "hidden" });
                this._modelType == "palette" && this.PaletteWrapper.css({ "display": "block", "visibility": "hidden" });
            } else if (this._modelType == "picker") {
                this.PaletteWrapper.css({ "display": "block", "visibility": "hidden" });
            }
            if (parseFloat(this._tag.outerHeight()) > element.outerHeight(true) || (($(this._tag).outerWidth() - ($(element).outerWidth(true) * count)) > element.outerWidth()) || $(this._tag).outerWidth() == 0) {
                var rowSize = parseFloat($(this._tag).outerWidth()) - paddingSize;
                var cellWidth = (rowSize / count) - (element.outerWidth() - element.width());
                this._PresetTable.find('.e-item').css('width', cellWidth);
                if (element.outerWidth(true) * count > this._tag.outerWidth()) this._PresetTable.find('.e-item').css('width', cellWidth - 1);
            }
            if (!this.isPopupOpen) {
                this.popupContainer.css({ "display": "none", "visibility": "visible" });
                this._modelType == "palette" && this.PaletteWrapper.css({ "visibility": "visible" });
            } else if (this._modelType == "picker") {
                this.PaletteWrapper.css({ "display": "none", "visibility": "visible" });
            }
            this._prevSize = $(window).width();
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
        },

        _range: function (range, value) {
            if (value === "") return value = 0;
            else if (value > range) return range;
            else return value;
        },
        _hsvValue: function () {
            var colorCode, hsv;
            this._change = true;
            this._hsv.v = this._hsv.v >= 100 ? 100 : this._hsv.v;
            this._hsv.s = this._hsv.s >= 100 ? 100 : this._hsv.s;
            this.hsv = this._hsv;
            this.rgb = this.HSVToRGB(this.hsv);
            this._valueOperation();
            this._inputTagValue(this._selectedButton);
        },
        _formRGB: function (value) {
            if (!ej.isNullOrUndefined(value)) return "rgb(" + value.r + "," + value.g + "," + value.b + ")";
        },
        _formRGBA: function (value) {
            if (!ej.isNullOrUndefined(value)) return "rgba(" + value.r + "," + value.g + "," + value.b + "," + value.a + ")";
        },
        _rgbValue: function (e) {
            var rgbColor, colorCode, value;
            value = this._HexToRGB(this._tempValue);
            if (!ej.isNullOrUndefined(value)) {
                this.rgb = value;
                this._change = true;
                this.HSVToRGB(this.RGBToHSV(this.rgb));
                this._colorSlider.option('value', parseInt(this._hsv.h));
                this._opacity.option('value', this.rgb.a * 100);
            }
            this._valueOperation();
            this._inputTagValue(this._selectedButton);
        },
        _valueOperation: function () {
            this._handlePosition();
            this._alphaGradient(this._tempValue);
            this._inputTag.removeClass("e-error");
            this._updateUI();
        },
        _HexToHSV: function (hex) {
            return this.HSVToRGB(this.RGBToHSV(this._HexToRGB(hex)));
        },
        _HexToRGB: function (hex) {
            if (!ej.isNullOrUndefined(hex)) {
                var reg = "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$", hex, validate = hex.match(reg);
                if (ej.isNullOrUndefined(validate)) { this._change = false; return false; }
                if (validate[1].length == 3)
                    hex = "#" + validate[1][0] + validate[1][0] + validate[1][1] + validate[1][1] + validate[1][2] + validate[1][2];
                this._change = true;
                hex = parseInt(((hex.indexOf('#') > -1) ? hex.substring(1) : hex), 16);
                var value = ej.isNullOrUndefined(this.rgb) ? parseFloat(this._tempOpacity) / 100 : this.rgb.a;
                return this.rgb = { r: hex >> 16, g: (hex & 0x00FF00) >> 8, b: (hex & 0x0000FF), a: value };
            }
        },

        RGBToHSV: function (rgb) {
            var hsv = { h: 0, s: 0, v: 0 };
            var min = Math.min(rgb.r, rgb.g, rgb.b);
            var max = Math.max(rgb.r, rgb.g, rgb.b);
            var differ = max - min;
            hsv.v = max;
            hsv.v *= 100 / 255;
            if (differ === 0) {
                this._hsv = hsv;
                return hsv;
            }
            hsv.s = max != 0 ? 255 * differ / max : 0;
            if (hsv.s != 0) {
                if (rgb.r == max) hsv.h = (rgb.g - rgb.b) / differ;
                else if (rgb.g == max) hsv.h = 2 + (rgb.b - rgb.r) / differ;
                else hsv.h = 4 + (rgb.r - rgb.g) / differ;
            } else hsv.h = -1;
            hsv.h *= 60;
            if (hsv.h < 0) hsv.h += 360;
            hsv.s *= 100 / 255;
            this._hsv = hsv;
            return hsv;
        },

        HSVToRGB: function (hsv) {
            var rgb = {};
            var h = Math.round(hsv.h);
            var s = Math.round(hsv.s * 255 / 100);
            var v = Math.round(hsv.v * 255 / 100);
            if (s == 0) {
                rgb.r = rgb.g = rgb.b = v;
            } else {
                var t1 = v;
                var t2 = (255 - s) * v / 255;
                var t3 = (t1 - t2) * (h % 60) / 60;
                if (h == 360) h = 0;
                if (h < 60) { rgb.r = t1; rgb.b = t2; rgb.g = t2 + t3 }
                else if (h < 120) { rgb.g = t1; rgb.b = t2; rgb.r = t1 - t3 }
                else if (h < 180) { rgb.g = t1; rgb.r = t2; rgb.b = t2 + t3 }
                else if (h < 240) { rgb.b = t1; rgb.r = t2; rgb.g = t1 - t3 }
                else if (h < 300) { rgb.b = t1; rgb.g = t2; rgb.r = t2 + t3 }
                else if (h < 360) { rgb.r = t1; rgb.g = t2; rgb.b = t1 - t3 }
                else { rgb.r = 0; rgb.g = 0; rgb.b = 0 }
            }
            this._hsv = hsv;
            var value = ej.isNullOrUndefined(this.rgb) ? parseFloat(this._tempOpacity) / 100 : this.rgb.a;
            return { r: Math.round(rgb.r), g: Math.round(rgb.g), b: Math.round(rgb.b), a: value }
        },
        _HSVToHex: function (hsv) {
            return this.RGBToHEX(this.HSVToRGB(hsv));
        },
        _toHEX: function (rgb) {
            if (rgb.indexOf("#") !== -1) return rgb;
            rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
            return "#" + this._hex(rgb[1]) + this._hex(rgb[2]) + this._hex(rgb[3]);
        },



        RGBToHEX: function (rgb) {
            if (!ej.isNullOrUndefined(rgb))
                return "#" + this._hex(rgb.r) + this._hex(rgb.g) + this._hex(rgb.b);
        },
        _hex: function (x) {
            return ("0" + parseInt(x).toString(16)).slice(-2);
        },
        _colorValue: function (value) {
            this._color = value.indexOf("#") != -1 ? this.hexCodeToRGB(value) : "";
            return "rgb(" + this._color.r + ", " + this._color.g + ", " + this._color.b + ")";
        },


        hexCodeToRGB: function (colorCode) {
            var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(colorCode);
            return result ? {
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16),
                a: this.rgb.a
            } : null;
        },

        _updatePreviewColor: function () {
            if (this._browser.name = "msie" && this._browser.version == "8.0")
                this._previousTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            else
                this._previousTag.css({ "background-color": this._formRGBA(this.rgb) });
            this._oldValue = this.rgb;
        },
        _updateUI: function () {
            var value = this._hsv;
            if (this._switch) {
                var hsv = { h: this._hsv.h, s: 100, v: 100 };
                this._gradientArea.css({ "background-color": this._colorValue(this._HSVToHex(hsv)) });
            } else this._cellSelect();
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._currentTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                this._previousTag.css({ "background-color": this._formRGB(this._oldValue), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            }
            else {
                this._currentTag.css({ "background-color": this._formRGBA(this.rgb) });
                this._previousTag.css({ "background-color": this._formRGBA(this._oldValue) });
                this._alphaSlider.children(".e-handle").css({ "background": this._formRGBA(this.rgb) });
            }
            this._hsv = value;
        },

        _targetFocus: function (e) {
            e.preventDefault();
            if (!this._isFocused) {
                this._isFocused = true;
                if (this.element.is("input")) this.wrapper.addClass("e-focus");
            }
        },
        _targetBlur: function (e) {
            this._isFocused = false;
            if (!this.isPopupOpen && this.element.is("input")) this.wrapper.removeClass("e-focus");
        },
        _switchModel: function () {
            this._tempValue = this.RGBToHEX(this.rgb);
            this.refresh();
            var proxy = this;
            this._off(this._changeTag, "click", this._switchModel);
            if (this._modelType == "palette") {
                this._modelType = "picker";
                this._switcher.removeClass("e-pickerModel").addClass("e-paletteModel");
                this.PaletteWrapper.fadeOut(300, function () {
                    proxy._presetTag.parents('.e-split.e-widget').addClass('e-hide');
                    proxy._gradient.fadeIn(300);
                    proxy._on(proxy._changeTag, "click", proxy._switchModel);
                });
                this._switch = true;
                this._rgbValue();
                this._hueGradient();
                this._hsva.ejButton("enable");
            } else {
                this.PaletteWrapper.remove();
                this._modelType = "palette";
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._gradient.addClass('e-hide');
                this._paletteType();
                this._switcher.removeClass("e-paletteModel").addClass("e-pickerModel");
                this._gradient.fadeOut(300, function () {
                    proxy._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
                    if (ej.isNullOrUndefined(proxy.PaletteWrapper)) {
                        proxy.PaletteWrapper = proxy._layoutType(proxy.model.palette);
                        proxy._splitObj.option('prefixIcon', 'e-color-image e-' + proxy.model.presetType);
                        proxy.popupList.prepend(proxy.PaletteWrapper);
                    }
                    proxy.PaletteWrapper.fadeIn(300);
                    proxy._on(proxy._changeTag, "click", proxy._switchModel);
                });
                if (this.value() !== "")
                    this._cellSelect();
                this._disableHSVButton();
            }
            this.model.palette === "custompalette" && this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            if (!this.model.displayInline || this.element.is(":input")) this.wrapper.focus();
            this._switchEvents();
            this._unSwitchEvents();
            if (this.isPopupOpen) {
                this._hideUnBindEvents();
                this._showBindEvents();
            }
        },
        _disableHSVButton: function () {
            if ($(this._groupTag.find('.e-click')).hasClass('e-hsvButton')) {
                this._inputTagValue(this._rgb);
                this._rgb.addClass('e-click');
                this._hsva.removeClass('e-click');
            }
            this._hsva.ejButton("disable");
        },

        _cellSelect: function () {
            var code, element, proxy = this;
            this._removeClass();
            this._collection.find('.e-item').each(function () {
                code = $(this).css("background-color");
                if (proxy._browser.name = "msie" && proxy._browser.version == "8.0") {
                    if (code && code.replace(/ /g, '') === proxy.RGBToHEX(proxy.rgb)) {
                        element = this;
                        $(element).addClass("e-filter");
                    }
                } else {
                    if (code && code.replace(/ /g, '') === proxy._formRGB(proxy.rgb)) element = this;
                }
            });
            $(element).addClass("e-state-selected").attr("aria-selected", true);
        },
        _removeClass: function () {
            this._collection.find('.e-item').removeClass('e-state-selected').removeClass("e-filter").removeAttr("aria-selected");
        },
        _position: function (items, element, columns) {
            items = Array.prototype.slice.call(items);
            var n = items.length,
            index = items.indexOf(element);
            if (index < 0) return columns < 0 ? items[n - 1] : items[0];
            index += columns;
            return items[index < 0 ? index += n : index %= n];
        },
        _onSelect: function (e) {
            if (!this.model.enabled) return false;
            this._isFocused = true;
            this._handleArea.css("visibility", "visible");
            if (e.target.style.backgroundColor != "") {
                this._collection.find('.e-item').removeClass("e-state-selected").removeAttr('aria-selected');
                this._HexToRGB(this._toHEX(e.target.style.backgroundColor));
                this._updateUI();
                this._inputTagValue(this._selectedButton);
                if (!this.model.displayInline || this.element.is("input")) this.wrapper.focus();
                this._tempValue = this.RGBToHEX(this.rgb);
                this._changeEvent(false);
            }
            e.preventDefault();
        },
        _keyDown: function (e) {
            if (this._isFocused) {
                this._change = true;
                if (!this.model.enabled) return false;
                var selected = "",
                    key = e.keyCode,
                    items = this._collection.find('.e-item'),
                    element = items.filter(".e-state-selected").get(0),
                    columnSize = this.model.columns;
                if (!e.altKey && (key == 37 || key == 38 || key == 39 || key == 40) && (e.target.className !== "e-color-code"))
                    this._removeClass();
                switch (!e.altKey && key) {
                    case 40:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, columnSize);
                        }
                        break;
                    case 37:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, -1);
                        }
                        break;
                    case 38:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, -columnSize);
                        }
                        break;
                    case 39:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, 1);
                        }
                        break;
                    case 13:
                        this._collection.find('.e-item').removeClass('e-state-selected').removeAttr("aria-selected");
                        if ($(e.target).hasClass('e-switcher')){
                            this._switchModel();
                            $(e.target).focus();
                        } 
                        else if ($(e.target).hasClass('e-applyButton')) {
                            this._buttonClick(e);
                            this._updateUI();
                            !this.model.displayInline && this.hide();
                            if (this.element.is("input")) this.wrapper.focus();
                        }
                        break;
                    case 27:
                        !this.model.displayInline && this.hide();
                        $(this._presetContainer).hide();
                        if (this.element.is("input")) this.wrapper.focus();
                        break;
                    case 9:
                        active = document.activeElement;
                        if ($(active).is(this.wrapper)) this._focusPalettePopup(e, true);
                        break;
                }
                if (selected) {
                    $(selected).addClass('e-state-selected').attr("aria-selected", true);
                    this._currentTag.css({ "background-color": this._formRGB(this._HexToRGB(selected.attributes.value.value)) });
                    this._inputTagValue(this._selectedButton);
                    this._tempValue = this.RGBToHEX(this.rgb);
                    this._changeEvent(false);
                }
            } else {
                if (e.keyCode == 27) {
                    this.hide();
                    $(this._presetContainer).hide();
                }
            }
        },
        _focusPalettePopup: function (e, type) {
            $(this.popupContainer).focus();
            e.preventDefault();
        },
    })

    ej.ColorPicker.Locale = ej.ColorPicker.Locale || {};

    ej.ColorPicker.Locale["default"] = ej.ColorPicker.Locale["en-US"] = {
        buttonText: {
                apply: "Apply",
                cancel: "Cancel",
                swatches: "Swatches"
            },

            tooltipText: {
                switcher: "Switcher",
                addButton: "Add Color",
                basic: "Basic",
                monoChrome: "Mono Chrome",
                flatColors: "Flat Colors",
                seaWolf: "Sea Wolf",
                webColors: "Web Colors",
                sandy: "Sandy",
                pinkShades: "Pink Shades",
                misty: "Misty",
                citrus: "Citrus",
                vintage: "Vintage",
                moonLight: "Moon Light",
                candyCrush: "Candy Crush",
                currentColor: "Current Color",
                selectedColor: "Selected Color",
            }
    }
    ej.ColorPicker.Palette = {
        /**  Represents the basic Palette. This is default Type*/
        BasicPalette: "basicpalette",
        /**  Represents the custom Palette. User will customize the palette*/
        CustomPalette: "custompalette",
    }

    ej.ColorPicker.ModelType = {
        /**  Represents Palette Type*/
        Palette: "palette",
        /** Represents Picker Type */
        Picker: "picker"
    }

    ej.ColorPicker.ButtonMode = {
        /**  Represents the default bahavior*/
        Default: "dropdown",
        /**  Represents the Split bahavior, to perform the separete operation for each button*/
        Split: "split",
    }

    ej.ColorPicker.PresetType = {
        Basic: "basic",
        MonoChrome: "monochrome",
        FlatColors: "flatcolors",
        SeaWolf: "seawolf",
        WebColors: "webcolors",
        Sandy: "sandy",
        PinkShades: "pinkshades",
        Misty: "misty",
        Citrus: "citrus",
        Vintage: "vintage",
        MoonLight: "moonlight",
        CandyCrush: "candycrush",
    }
    var Colors = {
        basic: ["ffffff", "facbcb", "fccb98", "faf39a", "fbf8cd", "a6d38b", "aadee8", "d1ecf2", "cdcae5", "eecde1", "cccbcb", "f16667", "f69668", "f8ee6b", "f7ec37", "89c987", "75cddd", "8bd3e1", "7f7fcc", "9494c8", "b3b2b3", "ec2024", "f7971d", "ffcb67", "f5ea14", "74bf44", "69c8c9", "46c7f4", "6666ad", "b76cab", "676767", "971b1e", "ca6828", "ca9732", "979937", "0d9948", "339898", "4857a6", "62449a", "973794", "000000", "2f1110", "973620", "663433", "343416", "183319", "023334", "22205f", "3b2f8d", "310e31"],
        monochrome: ["ffffff", "e3e3e3", "c6c6c6", "aaaaaa", "8e8e8e", "717171", "555555", "393939", "1c1c1c", "000000", "f9e6e7", "f4d0d2", "efbabc", "e9a4a7", "e48e92", "df787c", "da6267", "d44c52", "cf363c", "ca2027", "fff4ca", "ffeb9e", "fff0b4", "ffefb1", "ffe788", "ffe272", "ffd947", "ffd531", "ffd01b", "ffcc05", "e4f4eb", "ccead9", "b4e0c7", "9cd6b5", "84cca3", "6dc190", "55b77e", "3dad6c", "25a35a", "0d9948", "e8f4f4", "d6e3eb", "c4d1e3", "b3c0da", "a1aed1", "8f9dc9", "7d8bc0", "6c7ab7", "5a68af", "4857a6"],
        flatcolors: ["7477b8", "488bca", "18b1d4", "1db369", "78c162", "acc063", "ffe84e", "f6b757", "f79853", "ed6346", "E87F3D", "E4C45D", "B7A575", "999999", "67809F", "002228", "00A578", "F9A41F", "F3770B", "D7401B", "FFCB36", "82CC2C", "36B595", "6370AD", "D4264E", "004D8E", "22A04B", "F3A414", "C77405", "F3420B", "1ABC9C", "3498DB", "9B59B6", "E67E22", "E74C3C", "3A738A", "EBD9A7", "89AD78", "FF766D", "C76160", "BF3542", "CDC5BA", "EBE3D6", "3C3C3C", "2E2E2E", "77A7FB", "E57368", "FBCB43", "34B67A", "FFFFFF"],
        seawolf: ["0EEAFF", "15A9FA", "1B76FF", "1C3FFD", "2C1DFF", "0B3C4C", "0E5066", "13647F", "127899", "1A8BB2", "74B8E8", "659EBB", "3C9FFF", "26466F", "2472FF", "0069A4", "009BF2", "004165", "49A0B4", "274C5F", "000000", "7A5848", "E0A088", "F9DEC6", "3A2A22", "DC3522", "D9CB9E", "374140", "2A2C2B", "1E1E20", "CB3937", "FE6B2C", "654E44", "6DD16F", "70FE2C", "275673", "4681A6", "FDDEC9", "F22816", "400101", "071C2F", "388494", "E6A934", "F3DB5F", "534329", "206956", "47683B", "E1BFA6", "BF7950", "903932"],
        webcolors: ["0066aa", "00bbdd", "338800", "77bb00", "ffcc99", "990c0c", "0303c9", "336699", "669933", "cccccc", "EEEEEE", "E7C36F", "F7B230", "E35B20", "000033", "7D7A74", "BD524A", "FCB200", "8CFCC2", "2ACD6B", "666666", "666553", "FFFEEC", "B2B2A4", "AAA4B2", "9CA5E3", "5A668C", "BBA469", "CFC295", "FFFFFF", "DBBF56", "2E94B3", "808080", "E96656", "14A168", "DE185B", "D8806F", "DBE186", "D8CC63", "DCC527", "4E6C89", "E2BDAD", "EC6053", "81BBAD", "DFCDA5", "453394", "66398A", "313E7D", "336694", "788E91"],
        sandy: ["c0a986", "ecd9c3", "dfc79b", "f6d58e", "ecdaad", "fff3e0", "7f6b4a", "ffd694", "7f7a70", "ccac76", "E6E2AF", "A79A71", "EFECCA", "806F4C", "2F2F2E", "997F1A", "CCB65F", "FFD291", "6B674A", "635F3A", "7F693A", "FFEBC1", "FFD275", "7F7561", "CCA85E", "D29854", "4A4034", "C9AD8D", "4A351D", "968169", "E6E39F", "9A9757", "FFFDC9", "94909A", "E2E0E6", "960010", "EB1517", "CD7C29", "9A571C", "1F7A94", "7F6826", "7F724C", "FFE499", "FFD04C", "CCA63D", "FFA669", "92FFB6", "FFF352", "E8C269", "D7E8CB"],
        pinkshades: ["F6B1C3", "F0788C", "DE264C", "BC0D35", "A20D1E", "E12256", "BB1C48", "7B132F", "3B0917", "FA2660", "FFB7B5", "9A423F", "FF6D68", "BB5855", "CC5753", "E88161", "D66C60", "C2646E", "996072", "705262", "FFA1BD", "FF8FB7", "FF82AE", "E9719B", "CC6882", "F250C7", "BF1774", "BF2696", "AC60AA", "BB90C5", "BF1553", "F20775", "F2F2F2", "e5566d", "f2afc1", "f43fa5", "fc8c99", "FF6887", "7F3443", "CC536C", "D06AA9", "E65F41", "650017", "BC1620", "FA427E", "3B1132", "84476E", "B83D65", "E6E0E8", "FF6EE8"],
        misty: ["5C7A84", "3D5372", "7C9196", "50748A", "ADBFBF", "010735", "052159", "194073", "376B8C", "FFFFFF", "985999", "C811CC", "892EFF", "FF6852", "DBA211", "0A0D0C", "85A67C", "46593E", "BBD9AD", "202616", "BF8E63", "734327", "A66C4B", "593A2F", "BFBFBF", "8DB0B6", "1B778A", "F46C1B", "881801", "192129", "81808C", "ABAABF", "0C0E09", "6A7366", "37402F", "5D6663", "84867B", "A4A66A", "BABBB1", "20211C", "6B9695", "646E8C", "6B8196", "61787F", "648C80", "8E9FBA", "89A8C8", "799ED1", "7FAEE7", "849EBD"],
        citrus: ["FAEA41", "E7F03E", "E3C647", "FAC541", "F0AB3E", "CCCA1F", "FFF300", "FFCB0D", "FF9500", "804A00", "6A692A", "FFFCA0", "FFFFFF", "CF664E", "EFAC66", "EFF299", "F2DC6D", "F29727", "F2600C", "592202", "214001", "4F7302", "1A2601", "BCD97E", "C0D904", "AAFEFF", "359D6D", "E5FF45", "65FCCF", "ABDC4B", "42B200", "C6FF00", "F2E304", "FFB200", "FF8600", "52EC04", "04E206", "94D507", "ECE404", "E2C904", "DA321C", "FF7913", "FBD028", "C0D725", "9FC131", "547312", "ADBF26", "DEB329", "F1DB47", "E08214"],
        vintage: ["684132", "fdbe30", "eaac21", "87783c", "3e4028", "ffc706", "cd5648", "5bafa9", "828282", "363636", "424862", "fb9a63", "bfc4d5", "f6fbf4", "febc98", "657050", "FCF082", "D8D98B", "A2AB80", "4D584A", "5ADED4", "4DAAAB", "26596A", "163342", "6C98A1", "010A26", "28403B", "557359", "AEBF8A", "C7D9AD", "AFFCCB", "CB4243", "D2997E", "36857E", "4AC6BB", "28394B", "191313", "AF0A18", "DC373D", "122438", "43734A", "A6A26D", "D9B448", "BF8C2C", "734002", "26010F", "866F53", "ACBD91", "7BAB87", "546859"],
        moonlight: ["241D37", "2A233D", "322B45", "362F49", "D4BA73", "261225", "592040", "8C3063", "A64985", "73345D", "A3C8FF", "85B6FF", "000040", "213190", "050859", "FFFFFF", "6AAED9", "4184BF", "224573", "2e4154", "bcad7e", "955351", "c36a57", "9a8556", "7e6029", "dbd78e", "beae3b", "c3a04c", "58504d", "967644", "CFC496", "B3B391", "889486", "61797B", "366577", "123340", "436E73", "7B8C61", "D7D996", "F0EBB4", "341F36", "D9B5E0", "9889AB", "4D4E66", "1B2129", "5CBBE3", "FCF1BC", "5C8182", "383A47", "B4F257"],
        candycrush: ["0779f4", "30da00", "fb8006", "f9d802", "a71df7", "f70200", "fd49ae", "682e07", "9b2424", "5e7693", "F9AB3B", "EF5627", "FF0000", "00A398", "803C2C", "DE5711", "FFF026", "FF0048", "14A0CC", "00B229", "FFFFBE", "F7CD99", "FF77A1", "9886E8", "97CACB", "EAEDE5", "FFD127", "FF870C", "EC4610", "9A1900", "993460", "CC1464", "C300FF", "FFFFBC", "CCB914", "FFFEE2", "B24C5F", "FF274F", "0A94CC", "679DB2", "C2FFE6", "16B271", "5FFFBC", "B2442F", "FFA190", "E89359", "FFFB75", "F36EFF", "5999E8", "73EB86"],
    }

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejFileExplorer", "ej.FileExplorer", {

        element: null,

        model: null,
        validTags: ["div"],
        _addToPersist: ["layout", "selectedFolder", "selectedItems", "height", "width"],
        _rootCSS: "e-fileexplorer",
        _requiresID: true,
        defaults: {

            fileTypes: "*.*",

            filterSettings: {

                caseSensitiveSearch: false,

                filterType: "contains",

                allowSearchOnTyping : true

            },

            showToolbar: true,

            showCheckbox: true,

            showNavigationPane: true,

            allowDragAndDrop: true,

            showContextMenu: true,

            showFooter: true,

            layout: "grid",

            locale: "en-US",

            selectedFolder: "",

            selectedItems: "",

            gridSettings: {
                allowSorting: true,
                columns: [
                    { field: "name", headerText: "Name", width: "30%" },
                    { field: "dateModified", headerText: "Date Modified", width: "30%" },
                    { field: "type", headerText: "Type", width: "15%" },
                    { field: "size", headerText: "Size", width: "12%", textAlign: "right", headerTextAlign: "left" }],
                allowResizing:true
            },

            tools: {
                creation: ["NewFolder"],
                navigation: ["Back", "Forward", "Upward"],
                addressBar: ["Addressbar"],
                editing: ["Refresh", "Upload", "Delete", "Rename", "Download"],
                copyPaste: ["Cut", "Copy", "Paste"],
                getProperties: ["Details"],
                searchBar: ["Searchbar"],
                layout: ["Layout"],
                sortBy: ["SortBy"]
            },

            toolsList: ["layout", "creation", "navigation", "addressBar", "editing", "copyPaste", "sortBy", "getProperties", "searchBar"],

            path: "",

            height: "400px",

            width: "850px",

            minWidth: "400px",

            maxWidth: null,

            minHeight: "250px",

            maxHeight: null,

            isResponsive: false,

            uploadSettings: {

                allowMultipleFile: true,

                maxFileSize: 31457280,

                autoUpload: false

            },

            enableResize: false,

            cssClass: "",

            enableRTL: false,

            allowKeyboardNavigation: true,

            showThumbnail: true,

            enableThumbnailCompress: false,

            showRoundedCorner: false,

            ajaxAction: "",

            ajaxDataType: "json",

            ajaxSettings: {
                read: {},
                createFolder: {},
                remove: {},
                rename: {},
                paste: {},
                getDetails: {},
                download: {},
                upload: {},
                getImage: {},
                search:{}
            },

            allowMultiSelection: true,

            contextMenuSettings: {
                items: {
                    navbar: ["NewFolder", "Upload", "|", "Delete", "Rename", "|", "Cut", "Copy", "Paste", "|", "Getinfo"],
                    cwd: ["Refresh", "Paste", "|", "SortBy", "|", "NewFolder", "Upload", "|", "Getinfo"],
                    files: ["Open", "Download", "|", "Upload", "|", "Delete", "Rename", "|", "Cut", "Copy", "Paste", "|", "OpenFolderLocation", "Getinfo"]
                },
                customMenuFields: []
            },

            enablePersistence: false,

            layoutChange: null,

            getImage: null,

            select: null,

            unselect: null,

            createFolder: null,

            remove: null,

            cut: null,

            copy: null,

            paste: null,

            open: null,

            beforeOpen: null,

            beforeUpload: null,

            beforeDownload: null,

            beforeGetImage: null,

            beforeAjaxRequest: null,

            resizeStart: null,

            resize: null,

            resizeStop: null,

            templateRefresh: null,

            dragStart: null,

            drag: null,

            dragStop: null,

            drop: null,

            menuClick: null,

            menuBeforeOpen: null,

            menuOpen: null,

            create: null,

            destroy: null

        },
        dataTypes: {
            filterSettings: "data",
            showToolbar: "boolean",
            showNavigationPane: "boolean",
            showContextMenu: "boolean",
            allowDragAndDrop: "boolean",
            allowKeyboardNavigation: "boolean",
            showRoundedCorner: "boolean",
            showFooter: "boolean",
            layout: "enum",
            gridSettings: "data",
            tools: {
                creation: "array",
                navigation: "array",
                addressBar: "array",
                editing: "array",
                layout: "array",
                copyPaste: "array",
                getProperties: "array",
                searchBar: "array"
            },
            toolsList: "array",
            contextMenuSettings: {
                items: {
                    navbar: "array",
                    cwd: "array",
                    files: "array"
                },
                customMenuFields: "array"
            },
            uploadSettings: "data",
            ajaxSettings: "data",
        },
        _setModel: function (options) {
            var proxy = this;
            for (var prop in options) {
                switch (prop) {
                    case "showToolbar":
                        options[prop] ? ej.isNullOrUndefined(this._toolBarItems) ? this._updateToolbar() : this._toolBarItems.show() : this._toolBarItems.hide();
                        this.adjustSize();
                        break;
                    case "showNavigationPane":
                    case "showTreeview":
                        this.model.showNavigationPane = this.model.showTreeview = options[prop];
                        this._showHideSplitBar(this.model.showNavigationPane);
                        break;
                    case "showContextMenu":
                        this._showHideContextMenu();
                        break;
                    case "height":
                        this.element.css("height", this._getProperValue(this.model.height));
                        this.adjustSize();
                        break;
                    case "width":
                        this.element.css("width", this._getProperValue(this.model.width));
                        this.adjustSize();
                        break;
                    case "layout":
                        this._switchLayoutView(true);
                        break;
                    case "allowDragAndDrop":
                        this.model.allowDragAndDrop = options[prop];
                        this._draggableOption(options[prop] ? "_on" : "_off");
                        options[prop] ? this._allowDrag() : this._preventDrag();
                        break;
                    case "showThumbnail":
                        this.model.showThumbnail = options[prop];
                        this._switchLayoutView();
                        break;
                    case "enableThumbnailCompress":
                        this.model.enableThumbnailCompress = options[prop];
                        this.model.showThumbnail && this.model.layout != "grid" && this._renderTileView(this._fileExplorer[this._originalPath]);
                        break;
                    case "path":
                        options[prop] ? this._setPath(options[prop]) : this._getPath();
                        break;
                    case "enableRTL": this._enableRTL(options[prop]); break;
                    case "allowKeyboardNavigation":
                        this._subControlsSetModel("allowKeyboardNavigation", options[prop]);
                        this._gridObj && this._gridObj.setModel({ "allowKeyboardNavigation": options[prop] });
                        break;
                    case "showFooter":
                        if (options[prop]) {
                            if (this._statusbar.hasClass("e-statusbar")) {
                                var setHeight = this._splittag.find(".e-cont2").outerHeight() - this._statusbar.outerHeight();
                                this._tileView.height(setHeight);
                                this._gridtag.height(setHeight);
                                this._statusbar.show();
                            }
                            else {
                                this._createStatusBar();
                                this._updateData();
                                if (this.model.enableResize)
                                    this._resizeFileExplorer();
                                this._on($('#' + this._ExplorerId + '_switchGridView'), "click", this._switchView);
                                this._on($('#' + this._ExplorerId + '_swithListView'), "click", this._switchView);
                            }
                            var height = this._splittag.height() - this._gridtag.find(".e-gridheader").outerHeight();
                            this._tileContent.parent(".e-tile-wrapper").ejScroller({ height: this._splittag.outerHeight() - this._statusbar.outerHeight(), scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } });
                        } else {
                            this._tileView.height("auto");
                            this._gridtag.height("auto");
                            this._statusbar.hide();
                            var height = this._splittag.height() - this._gridtag.find(".e-gridheader").outerHeight();
                            this._tileContent.parent(".e-tile-wrapper").ejScroller({ height: this._splittag.outerHeight(), scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } });
                        }
                        break;
                    case "gridSettings":
                        var gridSettings = JSON.parse(JSON.stringify(options[prop]));
                        if (gridSettings.columns) {
                            gridSettings.columns.unshift({ field: "cssClass", headerText: "", cssClass: "e-grid-image", width: 22, template: "<script type='text/x-jsrender'><span class='e-fe-icon {{:cssClass}}' unselectable='on'></span></script>", textAlign: ej.TextAlign.Center, allowResizing: false });
                            if (this.model.showCheckbox)
                                gridSettings.columns.unshift({ field: "", headerText: "check", cssClass: "e-col-check", width: 18, template: "<script type='text/x-jsrender'><input type='checkbox' class='e-grid-row-checkbox'/></script>", textAlign: ej.TextAlign.Center, headerTextAlign: ej.TextAlign.Center, allowResizing: false, allowSorting: false });
                        }
                        this._gridObj && this._gridtag.ejGrid(gridSettings);
                        this._showHideContextMenu();
                        this._renderSortbyDrpdwn();
                        break;
                    case "locale":                        
                        this.model.locale = options[prop];                        
                        this._destroy();
                        this._init();
                        break;
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "fileTypes":
                        $.each(proxy._fileExplorer, function (itemPath, value) {
                            proxy._fileExplorer[itemPath] = "";
                        });
                        this._removeOldSelectionDetails();
                        this._refreshItems(this._selectedNode, this._currentPath);
                        this._uploadtag.ejUploadbox("option", { extensionsAllow: this.model.fileTypes == "*.*" ? "" : this.model.fileTypes.replace(/\*/g, "") });
                        break;
                    case "selectedFolder":
                        this._selectedFolder(this.model.selectedFolder);
                        break;
                    case "selectedItems":
                        this._selectedItems = options[prop];
                        this._setSelectedItems(options[prop]);
                        break;
                    case "allowMultiSelection":
                        !options[prop] && this._setSelectedItems([]);
                        this._gridtag.find(".e-gridheader").length && this._gridtag.ejGrid("option", { selectionType: (options[prop] ? "multiple" : "single") });
                        break;
                    case "isResponsive": {
                        this.model.isResponsive = options[prop];
                        if (this._toolBarObj) {
                            this._toolBarObj.option("isResponsive", this.model.isResponsive);
                            this.model.showToolbar ? this._toolBarItems.show() : this._toolBarItems.hide();
                            this.adjustSize();
                        }
                        this._wireResizing();
                        break;
                    }
                    case "tools":
                    case "toolsList":
                        if (prop == "tools")
                            $.extend(this.model.tools, options[prop]);
                        else
                            this.model.toolsList = options[prop];
                        if (this._toolBarObj) {
                            this._toolBarObj.destroy();
                            this.element.find("#" + this._ExplorerId + "_toolbar").remove();
                            this._updateToolbar();
                            this.model.showToolbar ? this._toolBarItems.show() : this._toolBarItems.hide();
                            this.adjustSize();
                        }
                        break;
                    case "enableResize":
                        if (!options[prop])
                            this._resizeItem && this._resizeItem.remove();
                        else if (options[prop] && this.model.showFooter) {
                            this._resizeItem = ej.buildTag("div.e-icon e-fe-resize e-resize-handle");
                            this._resizeItem.insertBefore(this.element.find(".e-switchView"));
                            this._resizeFileExplorer();
                        }
                        break;
                    case "minHeight":
                        this.element.css("min-height", this._getProperValue(this.model.minHeight));
                        this._refreshResizeHandler();
                        break;
                    case "maxHeight":
                        this.element.css("max-height", this._getProperValue(this.model.maxHeight));
                        this._refreshResizeHandler();
                        break;
                    case "minWidth":
                        this.element.css("min-width", this._getProperValue(this.model.minWidth));
                        this._refreshResizeHandler();
                        break;
                    case "maxWidth":
                        this.element.css("max-width", this._getProperValue(this.model.maxWidth));
                        this._refreshResizeHandler();
                        break;
                    case "showCheckbox":
                        this._changeCheckState = this.model.showCheckbox;
                        this.model.layout == "grid" ? this._renderGridView(this._fileExplorer[this._originalPath]) : this._renderTileView(this._fileExplorer[this._originalPath], true);
                        this._setSelectedItems(this.model.selectedItems);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[prop]);
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model[prop], options[prop]);
                        this._showHideContextMenu();
                        break;
                }
            }
        },

        _init: function () {
            this._cloneElement = this.element.clone();
            (!ej.isNullOrUndefined(this.model.uploadBoxSettings)) && (this.model.uploadSettings = this.model.uploadBoxSettings);
            (!ej.isNullOrUndefined(this.model.showTreeview)) && (this.model.showNavigationPane = this.model.showTreeview);
            (!ej.isNullOrUndefined(this.model.move)) && (this.model.cut = this.model.move);
            this._initialize();
            this._render();            
            this._changeLayoutActive(this.model.layout);
        },
        _postInit: function () {
            this._enablePostInit = false;
            this._enableRTL(this.model.enableRTL);
            this._wireEvents();
            this._wireResizing();
            this._setMinMaxSizeInInteger();
            if (this.model.enableResize && this.model.showFooter)
                this._resizeFileExplorer();
            this._isClicked = false;
            if (this._selectedTreeFolder && this._currentPath != this._selectedTreeFolder)
                this._selectedFolder(this._selectedTreeFolder);
            if (this._selectedNodes.length) {
                this._setSelectedItems(this._selectedNodes);
            }
            this._isClicked = true;
        },

        _initialize: function () {
            this._ExplorerId = this.element[0].id;
            this._fileExplorer = {};
            this._feParent = {};
            this._updateImages = {};
            this._selectedStates = [];
            this._updateOnNodeSelection = false;
            this._isClicked = true;
            this._toolBarObj = null;
            this._tileView = null;
            this._tileScroll = null;
            this._originalPath = null;            
            this._initPath = "";
            this._initUpdate = false;
            this._scrollerSize = 8;
            this._editingToolsState = true;
            this._renderMultiTouchDialog();
            this._ensureResolution();
            this._isDevice = this._checkDevice();
            this.element.css({ "height": this._getProperValue(this.model.height), "width": this._getProperValue(this.model.width), "min-width": this._getProperValue(this.model.minWidth), "max-width": this._getProperValue(this.model.maxWidth), "min-height": this._getProperValue(this.model.minHeight), "max-height": this._getProperValue(this.model.maxHeight) });
            this._customCssClass = this.model.cssClass;
            this.element.addClass(this.model.cssClass);            
            this._isTreeNode = false;
            this._selectedItems = [];
            this._selectedTileItems = [];
            this._downloadDialog = null;
            this._newFolderDialog = null;
            this._renameDialog = null;
            this._openDialog = null;
            this._detailsDialog = null;
            this._alertDialog = null;
            this._enablePostInit = true;
            this._initialTime = new Date().getTime();
            this._currentPath = this.model.path.replace(/\\/g, "/");
            this._rootPath = this._currentPath = this._currentPath.endsWith("/") ? this._currentPath : this._currentPath + "/";
            this._gridObj = null;
            this._setUploadLocalization();
            this._restrictedToolbarOptions = [];
            this._restrictedMenuOption = [];
            this._changeCheckState = this.model.showCheckbox;
            this._perRow = 1;
            this._suggestionItems = [];
            this._highlightedNodes = "";
            this._prevsorting = true;
            this._FilteredFiles = [];
        },

        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-fe-popup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSelection) {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
            this._on(this._customPop, "mousedown", this._popupClick);
        },

        _popupClick: function() {
            var $selElement = this._customPop.find(".e-rowselect");
            if ($selElement.hasClass("e-spanclicked")) {
                this._hidePopup();
            }
            else {
                $selElement.addClass("e-spanclicked");
            }
        },

        _hidePopup: function () {
            if (this._customPop != null && this._customPop.is(":visible")) {
                this._customPop.find(".e-rowselect").removeClass("e-spanclicked");
                this._customPop.hide();
            }
        },

        _ensureResolution: function() {
            this._isMobileOrTab = $(window).width() <= 750 ? true : false;
            if (this._isMobileOrTab) {
                this.element.addClass("e-fe-mobile");
                this._toolBarObj && this._toolBarObj._liTemplte.css("max-width", this.element.width());
            }
            else {
                this.element.removeClass("e-fe-mobile");
                if (this._splitObj && this.model.showNavigationPane && this._splitObj.element.find(".e-cont1").hasClass("collapsed")) {
                    this.model.enableRTL ? this._splitObj.expand(1) : this._splitObj.expand(0);
                }
            }
            this._toolBarObj && this._toolBarObj.option("cssClass", this.model.cssClass + " e-fe-toolbar " + (this._isMobileOrTab ? "e-fe-mobile" : ""));
            ($(window).width() <= 350 || this.element.width() <= 350) ? this.element.addClass("e-fe-small") : this.element.removeClass("e-fe-small");
            ($(window).width() <= 295 || this.element.width() <= 295) ? this.element.addClass("e-fe-short") : this.element.removeClass("e-fe-short");
        },

        _showHideNavigation: function (event) {
            if (this._splitObj.element.find(".e-cont1").hasClass("collapsed")) {
                if (this.model.enableRTL)
                    this._splitObj.collapse(0)
                else
                    this._splitObj.collapse(1);
            }
            else {
                if(this.model.enableRTL)
                    this._splitObj.expand(0)
                else
                    this._splitObj.expand(1);
            }
        },

        _renderSplitIcon: function () {
            if (!this.model.showNavigationPane) return;
            this._splitIcon = ej.buildTag('div.e-fe-split-icon');
            this._splitIcon.append("<span class='e-icon e-arrow-sans-left'></span>");
            this._splitObj.element.find(".e-splitbar").append(this._splitIcon);
            this._on(this._splitIcon, "touchend click", this._showHideNavigation);
            if (this._isMobileOrTab && this._splitObj && this.model.showNavigationPane) {
                this.model.enableRTL ? this._splitObj.collapse(1) : this._splitObj.collapse(0);
            }
        },

        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },

        _initContextMenuOptions: function (menu) {
            var menuOptions = [], items = this.model.contextMenuSettings.items[menu], customFields = this.model.contextMenuSettings.customMenuFields;
            for (var i = 0; i < items.length; i++) {
                if (items[i] != "|")
                {
                    var ele = this._getCustomItem(customFields, items[i]);
                    var attr = (items[i + 1] == "|") ? "e-fe-separator" : null;
                    this._addMenuItem(ele, items[i], attr, menuOptions, menu);
                    if (ele && ele.hasOwnProperty('child'))
                        this._getChildItems(ele['child'], menuOptions, menu, ele.id);
                }                
           }
           return menuOptions;  
        },

        _addMenuItem: function (ele, item, attr, menuOptions, menu, parentId) {
            var text = this._extendAttr(ele, "text");
            this["_menu" + item] = text ? text : this._getLocalizedLabels("ContextMenu" + item);
            var htmlAttr = this._extendAttr(ele, "htmlAttributes", attr);
            var css = this._extendAttr(ele, "spriteCssClass", "e-fileexplorer-toolbar-icon " + item);
            menuOptions.push({ id: ej.isNullOrUndefined(ele) ? (this._ExplorerId + "_" + menu + "_" + item) : item, text: this["_menu" + item], parentId: parentId, sprite: css, htmlAttr: htmlAttr });
        },

        _getChildItems: function (items, menuOptions, menu, parentId) {
            for (var i = 0, len = items.length; i < len && !ej.isNullOrUndefined(items[i]); i++) {
                var ele = items[i];
                this._addMenuItem(ele, items[i].id, null, menuOptions, menu, parentId);
                if (ele && ele.hasOwnProperty('child'))
                    this._getChildItems(ele['child'], menuOptions, menu, ele.id);
            }
        },

        _getCustomItem: function (items, id) {
            var ele;
            for (var i = 0, len = items.length; i < len && !ej.isNullOrUndefined(items[i]); i++) {
                if (items[i]["id"] == id) {
                    ele = items[i];
                    break;
                }
                if (items[i].hasOwnProperty('child')) {
                    ele = this._getCustomItem(items[i]['child'], id);
                    break;
                }
            }
            return ele;
        },

        _extendAttr: function (ele, attr, value) {
            if (!value)
                return ele ? (ele[attr] ? ele[attr] : null) : null;
            if (attr == "htmlAttributes")
                return { "class": (ele ? (ele[attr] ? (ele[attr]["class"] ? (ele[attr]["class"] + " " + value) : value) : value) : value) };
            else
                return ele ? (ele[attr] ? (ele[attr] + " " + value) : value) : value;
        },

        _render: function () {
            this._selectedTreeFolder = this.model.selectedFolder;
            this._selectedNodes = this.model.selectedItems;
            this.element.addClass('e-widget e-box').attr({ role: "fileexplorer", tabindex: 0 });
            this.model.showToolbar && this._renderToolBar();
            this._createSplitPane();
            this._read();
            this._roundedCorner(this.model.showRoundedCorner);
        },
        _read: function () {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Read", Path: this._currentPath, ExtensionsAllow: this.model.fileTypes, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(), this._selectedContent) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    if (result === undefined || result === null) return;
                    if (result.hasOwnProperty("d"))
                        result = result.d;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    proxy._feParent[proxy._currentPath] = result.cwd;
                    proxy._readSuccess(result.files);
                    proxy._enablePostInit && proxy._postInit();
                },
                successAfter: this.model.ajaxSettings.read.success
            };
            this.model.ajaxSettings.read.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.read);
            this._sendAjaxRequest(_ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions, hideWaitingState) {
            if (!ajaxOptions.dataType && this.model.ajaxDataType)
                ajaxOptions.dataType = this.model.ajaxDataType;
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            if (ajaxOptions.data.ActionType != "Read")
                this._selectedItemDetails = ajaxOptions.data.SelectedItems;
            var defaultData = { Name: "", ActionType: "", Path: "", ExtensionsAllow: "", LocationFrom: "", LocationTo: "", Action: "", NewName: "", Names:[], CaseSensitive: false, SearchString: "", FileUpload: null, CommonFiles: null };
            if (!hideWaitingState) {
                this._waitingPopup.show();
            }
            $.extend(true, defaultData, ajaxOptions.data);
            var args = { data: defaultData, ajaxSettings: ajaxOptions };
            var proxy = this;
            if (args.data.ActionType == "Paste") {
                args.data.LocationFrom = this._pathCorrection(args.data.LocationFrom);
                args.data.LocationTo  = this._pathCorrection(args.data.LocationTo);
            }
            else {
                args.data.Path = this._pathCorrection(args.data.Path);
            }
            if (this._trigger("beforeAjaxRequest", args))
                return;
            ajaxOptions = args.ajaxSettings;
            $.ajax({
                data: (((ajaxOptions.dataType && ajaxOptions.dataType.toLowerCase() == "jsonp") || ajaxOptions.contentType == "application/x-www-form-urlencoded") ? { json: JSON.stringify(args.data) } : JSON.stringify(args.data)),
                url: ajaxOptions.url,
                type:((ajaxOptions.dataType && ajaxOptions.dataType.toLowerCase() == "jsonp") ?  "GET" : ajaxOptions.type),
                async: ajaxOptions.async,
                success: function(args) {
                    proxy._waitingPopup.hide();
                    ajaxOptions.success.call(this, args);
                    if(typeof ajaxOptions.successAfter == "function")
                        ajaxOptions.successAfter.apply(this, arguments);
                },
                contentType: (ajaxOptions.contentType ? ajaxOptions.contentType : "application/json"),
                dataType: ajaxOptions.dataType,
                jsonpCallback: ajaxOptions.jsonpCallback ? ajaxOptions.jsonpCallback : ((ajaxOptions.dataType && ajaxOptions.dataType.toLowerCase() == "jsonp") ? "MyCallbackFunction" : ""),
                error: ajaxOptions.error ? ajaxOptions.error : function (xhr, textStatus, errorThrown) {
                    proxy._waitingPopup.hide();
                    var text = xhr.responseJSON ? xhr.responseJSON.ExceptionType + ", " + xhr.responseJSON.ExceptionMessage : xhr.statusText;
                    proxy._alertDialog = proxy._createDialog(ej.buildTag('div.e-fe-dialog-label', text), { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error") });
                    proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                },
                beforeSend: ajaxOptions.beforeSend,
                complete: function () {
                    proxy._waitingPopup.hide();
                    ajaxOptions.complete;
                }
            });

        },

        _pathCorrection: function(path){
            if(this.model.path == "/") {
                if (path.indexOf(":") >= 0) {
                    path = path.replace("//", "");
                }
                else if(path != "/") {
                    path = path.replace("/", "");
                }
            }
            return path;
        },

        _onBeforeOpen: function () {
            var fileUrl, selectedNodes = [], args;
            fileUrl = this._nodeType == "File" ? this._currentPath.replace("~", "..") + this._selectedFile : this._currentPath;
            if (this._selectedFile)
                selectedNodes = this._getSelectedItemDetails(this._currentPath, this._selectedFile);
            else if (this._selectedContent)
                selectedNodes = this._getSelectedItemDetails(this._getFolderPath(), this._selectedContent);
            args = { path: fileUrl, itemType: this._nodeType, selectedItems: selectedNodes };
            return this._trigger("beforeOpen", args);
        },

        _readSuccess: function (result) {
            if (result === undefined || result === null) return;
            this._update = false;
            for (var i = 0; i < result.length; i++) {
                result[i].sizeInByte = result[i].size;
                result[i].size = result[i].isFile ? this._bytesToSize(result[i].size) : "";
                result[i].cssClass = this._getCssClass(result[i]);
            }
            var sortingoption = this.model.gridSettings.columns[0];
            var sortingtype = true;
            var initialsort = true;
            this._changeActiveSortedoption(sortingoption.headerText,initialsort);
            this._sorting(sortingoption.field, sortingtype, result);
            this._fileExplorer[this._currentPath] = result;
            this._itemStatus && this._itemStatus.html(this._sorteditems.length + " " + (this._sorteditems.length == 1 ? this._getLocalizedLabels("Item") : this._getLocalizedLabels("Items")));
            if (!this._treetag.hasClass("e-treeview")) {
                this._renderTreeView(this._sorteditems);
                this._updateOnNodeSelection = true;
            }
            this.model.layout == "grid" ? this._renderGridView(this._sorteditems) : this._renderTileView(this._sorteditems);
            this._usePreviousValues();
        },
        _getCssClass: function (list) {
            var extension = list.name.substr(list.name.lastIndexOf('.') + 1).toLowerCase();
            if (list.isFile) {
                if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(list.name))
                    return 'e-fe-images';
                else if ((/\.(mp3|wav|aac|ogg|wma|aif|fla|m4a)$/i).test(list.name))
                    return 'e-fe-audio';
                else if ((/\.(webm|mkv|flv|vob|ogv|ogg|avi|wmv|mp4|3gp)$/i).test(list.name))
                    return 'e-fe-video';
                else if (!(/\.(css|exe|html|js|msi|pdf|pptx|ppt|rar|zip|txt|docx|doc|xlsx|xls|xml|rtf|php)$/i).test(list.name))
                    return 'e-fe-unknown e-fe-' + extension;
                else
                    return 'e-fe-' + extension;
            }
            else
                return (list.permission && !list.permission.Read) ? 'e-fe-folder e-fe-lock' : 'e-fe-folder';
        },
        _bytesToSize: function (bytes) {
            var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
            if (bytes == 0) return '0 Byte';
            var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
            var value = (bytes / Math.pow(1024, i));
            return value.toFixed(2) + ' ' + sizes[i];
        },

        _setPath: function (path) {
            this.model.path = path;
            this._treetag.remove();
            this._treetag = ej.buildTag('div#' + this._ExplorerId + '_treeView');
            this._splittag.find(".e-cont1 > .e-tree-wrapper").append(this._treetag);
            this._fileExplorer = this._updateImages= {};             
            this._selectedStates = [];
            this._selectedItems = [];
            this._selectedTileItems = [];
            this._initUpdate = false;
            this._initPath = "";
            this._currentPath = this.model.path.replace(/\\/g, "/");
            this._originalPath = this._rootPath = this._currentPath = this._currentPath.endsWith("/") ? this._currentPath : this._currentPath + "/";
            this._read();            
        },

        _getPath: function () {
            return this.model.path;
        },
        _changeSkin: function (value) {
            this.element.removeClass(this._customCssClass).addClass(value);
            this._customCssClass = value;
            this._waitingPopup.option("cssClass", value);
            this._subControlsSetModel("cssClass", value);
        },
        _draggableOption: function (action) {
            this._treeDragEvents(action);
            this._tileDragEvents(action);
            this._gridDragEvents(action);
            if (action=="_off") this._previousPath = null;
            this._statusbar && this[action](this._statusbar, "dragover", this._preventDropOption);
            this._toolBarItems && this[action](this._toolBarItems, "dragover", this._preventDropOption);
        },
        _swapWith : function(from, to) {
            from = $(from); to = $(to);
            var tmp = $('<span>').hide();
            from.before(tmp);
            to.before(from);
            tmp.replaceWith(to);
        },
        _enableRTL: function (value) {
		    var element1 = this._splittag.find(".e-cont1");
            var element2 = this._splittag.find(".e-cont2");            
            this.model.enableRTL = value;
            if (value) {
			    element1.index() < element2.index() && this._swapWith(element1, element2);
			    var gridColumnSettings = JSON.parse(JSON.stringify(this.model.gridSettings.columns));
			    if (!this._oldFormat)
                    this._oldFormat = JSON.parse(JSON.stringify(gridColumnSettings));
                for (var i = 0; i < gridColumnSettings.length; i++) {
                    gridColumnSettings[i].textAlign = gridColumnSettings[i].headerTextAlign = "right";
                }
                this._gridObj && this._gridObj.columns(gridColumnSettings);                                   
                this.element.addClass("e-rtl");
                this.element.find(".e-scroller").addClass("e-rtl");
            }
            else {
                element1.index() > element2.index() && this._swapWith(element2, element1);                                
                if (this._gridObj && this._oldFormat) {
                    for (var i = 0; i < this._oldFormat.length; i++) {
                        if (!this._oldFormat[i].textAlign)
                            this._oldFormat[i].textAlign = "left";
                        if (!this._oldFormat[i].headerTextAlign)
                            this._oldFormat[i].headerTextAlign = "left";
                    }
                    this._gridObj.columns(this._oldFormat);
                }
                if (this._oldFormat) {
                    this.model.gridSettings.columns = JSON.parse(JSON.stringify(this._oldFormat));
                    this._oldFormat = null;
                }
                this.element.removeClass("e-rtl");
                this.element.find(".e-scroller").removeClass("e-rtl");
                (this._gridtag) && this._gridtag.removeClass('e-rtl');
            }
            this._splitterCorrection();
            this._subControlsSetModel("enableRTL", value);
        },
        _roundedCorner: function (value) {
            var operation = value ? "addClass" : "removeClass";
            this.element[operation]('e-corner-all');
            this._treeContextMenutag && this._treeContextMenutag[operation]("e-corner");
            this._tileContextMenutag && this._tileContextMenutag[operation]("e-corner");
            this._subControlsSetModel("showRoundedCorner", value);
        },
        _destroy: function () {
            this._toolBarObj && this._toolBarObj.destroy();
            this._treeContextMenutag && this._treeContextMenutag.parent().remove();
            this._tileContextMenutag && this._tileContextMenutag.parent().remove();
            if (this._newFolderDialogObj && this._newFolderDialogObj.isOpen()) this._removeDialog(this._newFolderDialogObj);
            if (this._renameDialogObj && this._renameDialogObj.isOpen()) this._removeDialog(this._renameDialogObj);
            if (this._openDialogObj && this._openDialogObj.isOpen()) this._removeDialog(this._openDialogObj);
            if (this._detailsDialogObj && this._detailsDialogObj.isOpen()) this._removeDialog(this._detailsDialogObj);
            if (this._alertDialogObj && this._alertDialogObj.isOpen()) this._removeDialog(this._alertDialogObj);
            if (this._alertWindowObj && this._alertWindowObj.isOpen()) this._removeDialog(this._alertWindowObj);
            if (this._splitButtonObj) this._splitButtonObj.destroy();
            if (this._splitButtonObj1) this._splitButtonObj1.destroy();
            this._waitingPopup && this._waitingPopup.destroy();
            this._gridObj && this._gridObj.element.ejWaitingPopup("destroy");
            this._unwireEvents();
            this.element.html("")
            
            $(this._cloneElement).attr("style") ? this.element.attr("style", $(this._cloneElement).attr("style")) : this.element.removeAttr("style");
            this.element.removeClass('e-widget e-box e-rtl');      
            this.element.removeAttr('role');
            delete this._prevsortingoption, this._prevsorting;
        },
        _createFolder: function (_name) {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "CreateFolder", Name: _name, Path: this._originalPath, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(this._originalPath), this._treeObj.getText(this._selectedNode)) },
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (result === undefined || result === null) return;
                    if (result.hasOwnProperty("d"))
                        result = result.d;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    var selectedNode = proxy._selectedNode;
                    var nodeObj = [{ id: result.files[0].name, name: result.files[0].name, spriteCssClass: (result.files[0].permission && !result.files[0].permission.Read) ? "e-fe-icon e-fe-folder e-fe-lock" : "e-fe-icon e-fe-folder", hasChild: false }];
                    if (!proxy._treetag.ejTreeView("isExpanded", selectedNode))
                        proxy._treeObj && proxy._treeObj.expandNode(selectedNode);
                    proxy._nodeExpanded = true;
                    proxy._treeObj.addNode(nodeObj, selectedNode);
                    proxy._nodeExpanded = false;
                    proxy._update = true;
                    proxy._treeObj.selectNode(selectedNode);
                    proxy._refreshTreeScroller();
                    proxy._treetag.find("li").removeAttr("tabindex");
                    var items = proxy._treetag.find("li div a").not(".e-js");
                    if (proxy.model.allowDragAndDrop && items.length) {
                         proxy._drag(items);
                         items.addClass("e-file-draggable");
                    }
                    var args = { data: result, selectedItems: proxy._selectedItemDetails };
                    proxy._trigger("createFolder", args);
                    proxy._setSelectedItems([result.files[0].name]);
                },
                successAfter: this.model.ajaxSettings.createFolder.success
            };
            this.model.ajaxSettings.createFolder.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.createFolder);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _needToScroll: function (element, area) {
            var wrapperHeight, nodeHeight = area=="Tree" ? element.find("a").eq(0).outerHeight() :(element.outerHeight() + ((this.model.layout== "grid") ? 0 : 10));
            var elementHeight = 0;
            elementHeight += element.position().top + nodeHeight;
            if (area == "Tree") {
                while (element.parent().hasClass("e-treeview-ul")) {
                    element = element.parent();
                    elementHeight += element.position().top;
                }
                wrapperHeight = this._splittag.find(".e-cont1").height();
            } else {
                if (this.model.layout == ej.FileExplorer.layoutType.Grid) {
                    wrapperHeight = this._gridtag.find(".e-gridcontent").height();
                    elementHeight = elementHeight - this._gridtag.find(".e-gridheader").outerHeight();
                }
                else {
                    wrapperHeight = this._tileViewWrapper.height();
                }
            }
            var scrollableElement = element.closest(".e-scroller .e-content", ".e-fileexplorer");
            if (wrapperHeight < elementHeight) {
                scrollableElement.animate({
                    scrollTop: scrollableElement.scrollTop() + (nodeHeight *2)
                }, 500, 'linear');
            } else if (elementHeight < element.outerHeight()) {
                scrollableElement.animate({
                    scrollTop: scrollableElement.scrollTop() - (nodeHeight * 2)
                }, 500, 'linear');
            }
        },
        
        _cut_copy: function (maintainSourceNode) {
            var proxy = this;
            if (this._sourcePath == this._currentPath && this._option == "move") {
                this.element.find(".e-blur").removeClass("e-blur");
                this.model.layout!= "grid" && this._clearTileCheckBoxSelection();
                this._setSelectedItems(this._fileName);
                if (maintainSourceNode)
                    this._activeSource = this.model.selectedItems;
                return;
            }
            var data = this._fileExplorer[this._currentPath], _selectedFiles = (typeof this._copiedNodes == "string") ? [this._copiedNodes] : this._copiedNodes;
            this._pastedFiles = _selectedFiles.slice();
            for (var i = 0; i < _selectedFiles.length; i++) {
                if (!this._isNameExist(this._suggestionItems.length ? this._suggestionItems : this._fileExplorer[this._sourcePath], _selectedFiles[i]))
                    return;
            }
            var previousPath = proxy._currentPath;
            var successCallback = function () {
                proxy._currentPath = previousPath;
                if (ej.isNullOrUndefined(data))
                    data = proxy._fileExplorer[previousPath];
                proxy._existingItems = [];
                if (proxy._sourcePath != previousPath && data.length) {
                    proxy._getDuplicateItems(proxy._sourcePath, previousPath, (typeof proxy._fileName == "string" ? [proxy._fileName] : proxy._fileName));
                    if (proxy._existingItems.length) {
                        proxy._createReplaceConformationDiaolg("_pasteOperation", "ReplaceAlert");
                    }
                    else
                        proxy._pasteOperation();
                }
                else {
                    for (var i = 0; i < _selectedFiles.length; i++) {
                        proxy._pastedFiles[i] = proxy._getDuplicateName(proxy._fileExplorer[previousPath], _selectedFiles[i]);
                    }
                    proxy._pasteOperation();
                }
            };
            if (ej.isNullOrUndefined(data)) {
                this._getFileDetails(this._currentPath, "", "", successCallback);
            }
            else {
                successCallback();
            }
        },
        _createReplaceConformationDiaolg: function (executableFunction, alert) {
            var proxy = this;
            var i = 0;
            var viewerData = String.format(this._getLocalizedLabels(alert), this._existingItems[i].Path);
            var dialogContent = ej.buildTag('div.e-get-name');
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var divtag = ej.buildTag('div.e-fe-dialog-btn e-replace');
            var yesButton = ej.buildTag('button.e-fe-btn-yes ', this._getLocalizedLabels("YesButton"));
            var yesToAllButton = ej.buildTag('button.e-fe-btn-yes e-all ', this._getLocalizedLabels("YesToAllButton"));
            var noButton = ej.buildTag('button.e-fe-btn-no ', this._getLocalizedLabels("NoButton"));
            var noToAllButton = ej.buildTag('button.e-fe-btn-no e-all ', this._getLocalizedLabels("NoToAllButton"));
            yesButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    if ((/\.(gif|jpg|jpeg|tiff|png|bmp)$/i).test(proxy._existingItems[i].Name))
                        proxy._updateImages[proxy._existingItems[i].Path] = new Date().getTime();
                    proxy._existingItems[i].IsReplace = true;
                    i++;
                    if (i < proxy._existingItems.length)
                        proxy._alertDialog.find(".e-fe-dialog-label").text(String.format(proxy._getLocalizedLabels(alert), proxy._existingItems[i].Path));
                    else
                        proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            noButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    proxy._existingItems[i].IsReplace = false;
                    i++;
                    if (i < proxy._existingItems.length)
                        proxy._alertDialog.find(".e-fe-dialog-label").text(String.format(proxy._getLocalizedLabels(alert), proxy._existingItems[i].Path));
                    else
                        proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            yesToAllButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    for (var j = i; j < proxy._existingItems.length; j++) {
                        if ((/\.(gif|jpg|jpeg|tiff|png|bmp)$/i).test(proxy._existingItems[j].Name))
                            proxy._updateImages[proxy._existingItems[j].Path] = new Date().getTime();
                        proxy._existingItems[j].IsReplace = true;
                    }
                    proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            noToAllButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    for (var j = i; j < proxy._existingItems.length; j++) {
                        proxy._existingItems[j].IsReplace = false;
                    }
                    proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            divtag.append(yesButton, yesToAllButton, noButton, noToAllButton);
            $(dialogContent).append(labeltag, divtag);
            var open = function () {
                yesButton.focus();
            };
            this._alertDialog = this._createDialog(dialogContent, { width: 500, height: "auto", title: this._getLocalizedLabels("Error"), open: open });
            this._alertDialogObj = this._alertDialog.data("ejDialog");
        },
        _destroyReplaceConformationDiaolg: function (executableFunction) {
            this._removeDialog(this._alertDialogObj);
            this[executableFunction]();
        },
        _pasteOperation: function () {
            this._removeBlurEffect();
            var proxy = this;
            var itemIndex = -1;
            if (typeof this._fileName == "string")
                this._fileName = [this._fileName];
            for (var i = 0; i < this._fileName.length; i++) {
                var tempPath = this._sourcePath + this._fileName[i] + "/";
                if (this._currentPath.indexOf(tempPath) >= 0 ) {
                    itemIndex = i;
                    break;
                }
            }
            if (itemIndex != -1) {
                var viewerData = this._getLocalizedLabels("CancelPasteAction");
                var dialogContent = ej.buildTag('div');
                var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
                var divtag = ej.buildTag('div.e-fe-dialog-centerbtn');
                var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', this._getLocalizedLabels("CancelButton"));
                cancelButton.ejButton({
                    cssClass: "e-flat",
                    type: "button",
                    click: function () {
                        proxy._removeDialog(proxy._alertDialogObj);
                    }
                });
                var skipButton = ej.buildTag('button.e-fe-btn-skip ', this._getLocalizedLabels("SkipButton"));
                skipButton.ejButton({
                    cssClass: "e-flat",
                    type: "button",
                    click: function () {
                        proxy._fileName.splice(itemIndex, 1);
                        proxy._removeDialog(proxy._alertDialogObj);
                        proxy._performPasteOperation();
                    }
                });
                divtag.append(skipButton, cancelButton);
                $(dialogContent).append(labeltag, divtag);
                var open = function () {
                    cancelButton.focus();
                };
                this._alertDialog = this._createDialog(dialogContent, { width: 400, height: "auto", title: this._getLocalizedLabels("Error"), open: open });
                this._alertDialogObj = this._alertDialog.data("ejDialog");
            }
            else
                this._performPasteOperation();
        },
        _performPasteOperation: function () {
            var proxy = this;
            var nodes = this._currentPath.split('/')
            var _ajaxOptions = {
                data: { ActionType: "Paste", LocationFrom: this._sourcePath, LocationTo: this._currentPath, Names: (typeof this._fileName == "string") ? [this._fileName] : this._fileName, Action: this._option, CommonFiles: this._existingItems, SelectedItems: this._getSelectedItemDetails(this._sourcePath, this._fileName), TargetFolder: this._getSelectedItemDetails(this._getFolderPath(), nodes[nodes.length - 2]) },
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (!ej.isNullOrUndefined(result)) {
                        if (result.hasOwnProperty("d"))
                            result = result.d;
                        if (!ej.isNullOrUndefined(result.error)) {
                            proxy._showErrorDialog(result.error);
                            return;
                        }
                    }
                    if (typeof proxy._fileName == "string")
                        proxy._fileName = [proxy._fileName];
                    for (var i = 0; i < proxy._pastedFiles.length; i++) {
                        if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(proxy._pastedFiles[i]))
                            proxy._updateImages[proxy._currentPath + proxy._pastedFiles[i]] = new Date().getTime();
                    }
                    proxy._existingItems && proxy._existingItems.filter(function (item) {
                        if (item.IsReplace == false)
                        {
                            var index = $.inArray(item.Name, proxy._pastedFiles);
                            if (index > -1)
                                proxy._pastedFiles.splice(index, 1);
                        }
                    })
                    proxy._existingItems = [];
                    var oldPath = proxy._originalPath;
                    var oldNode = proxy._selectedNode;
                    if (proxy._option == "move") {
                        for (var i = 0; i < proxy._fileName.length; i++) {
                            proxy._modifySelectedStates(proxy._sourcePath + proxy._fileName[i], "");
                        }
                        if (proxy._fileName.length > 0) {
                            if (proxy._fileName.length == 1)
                                proxy._sourceType == "Directory" && proxy._treeObj.removeNode(proxy._refreshNode);
                            else {
                                nodes = proxy._refreshNode.siblings();
                                proxy._sourceType == "Directory" && proxy._treeObj.removeNode(proxy._refreshNode);
                                for (var i = 0; i < proxy._fileName.length; i++) {
                                    for (var j = 0; j < nodes.length; j++) {
                                        if (proxy._fileName[i] == $(nodes[j]).text())
                                            proxy._treeObj.removeNode(nodes[j]);
                                    }
                                }
                            }
                        }
                    }
                    $.each(proxy._fileExplorer, function (path, value) {
                        //display the key and value pair
                        if (path.startsWith(oldPath))
                            proxy._fileExplorer[path] = "";
                    });
                    proxy._currentPath = proxy._originalPath;
                    proxy._highlightedNodes = proxy._pastedFiles;
                    if (proxy._option == "move") {
                        proxy._refreshItems(oldNode, oldPath,
                        function () {
                            proxy._fileExplorer[proxy._sourcePath] = "";
                            proxy._getFileDetails(proxy._sourcePath);
                        });
                    }
                    else{
                        proxy._refreshItems(oldNode, oldPath);
                    }
                    var folderPath = proxy._getFolderPath();
                    if (proxy._option == "move") {
                        proxy._fileName = "";
                        proxy._option = null;
                        proxy._toolBarItems && proxy._toolBarItems.ejToolbar("disableItemByID", proxy._ExplorerId + "Paste");
                        if (proxy.model.showContextMenu) {
                            proxy._viewMenuObj.disableItem(proxy._menuPaste);
                            proxy._treeMenuObj.disableItem(proxy._menuPaste);
                        }
                        }
                        var args = { name: proxy._fileName, targetPath: proxy.model.path, selectedItems: proxy._selectedItemDetails, targetFolder: proxy._getSelectedItemDetails(folderPath, proxy._selectedContent) };
                        proxy._trigger("paste", args);
                    },
                    successAfter: this.model.ajaxSettings.paste.success
                };
                this.model.ajaxSettings.paste.success = undefined;
                $.extend(true, _ajaxOptions, this.model.ajaxSettings.paste);
                this._sendAjaxRequest(_ajaxOptions);
        },
        _deletion: function (names, path) {
            var proxy = this;
            var selectedNode = this._treeObj.getSelectedNode();
            if (!this._treeObj.isExpanded(selectedNode))
                this._treeObj && this._treeObj.expandNode(selectedNode);
            var _ajaxOptions = {
                data: { ActionType: "Remove", Names: (typeof names=="string")? [names]: names , Path: path, SelectedItems: this._getSelectedItemDetails(path, names) },
                traditional: true,
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (!ej.isNullOrUndefined(result)) {
                        if (result.hasOwnProperty("d"))
                            result = result.d;
                        if (!ej.isNullOrUndefined(result.error)) {
                            proxy._showErrorDialog(result.error);
                            return;
                        }
                    }
                    proxy._selectedItemsTag && proxy._selectedItemsTag.html("");
                    proxy._fileExplorer[proxy._ajax_folderPath] = "";
                    $.each(proxy._fileExplorer, function (path, value) {
                        //display the key and value pair
                        if (path.startsWith(proxy._ajax_folderPath))
                            proxy._fileExplorer[path] = "";
                    });
                    for (var i = 0; i < _ajaxOptions.data.SelectedItems.length; i++) {
                        _ajaxOptions.data.SelectedItems[i].isFile == false && proxy._modifySelectedStates(path + _ajaxOptions.data.SelectedItems[i].name, "");
                    }                    
                    proxy._currentPath = proxy._ajax_folderPath;
                    var node = (proxy._selectedContent == proxy._selectedTreeText) ? proxy._parentNode : proxy._selectedNode;
                    proxy._refreshItems(node, proxy._ajax_folderPath);
                    if (proxy._treeObj.getSelectedNode().length == 0)
                        proxy._treeObj.selectNode(proxy._parentNode);
                    else  (proxy.model.layout == "grid") ? proxy._gridtag.find(".e-gridcontent").click() : proxy._tileViewWrapper.click();
                    var args = { data: result, path: proxy._ajax_folderPath, name: names, selectedItems: proxy._selectedItemDetails };
                    proxy._trigger("remove", args);
                },
                successAfter: this.model.ajaxSettings.remove.success
            };
            this.model.ajaxSettings.remove.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.remove);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _rename: function () {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Rename", Path: proxy._currentPath, Name: proxy._selectedContent, NewName: proxy._ajax_person, CommonFiles: proxy._existingItems, SelectedItems: this._getSelectedItemDetails(proxy._currentPath, this._selectedContent) },
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (!ej.isNullOrUndefined(result)) {
                        if (result.hasOwnProperty("d"))
                            result = result.d;
                        if (!ej.isNullOrUndefined(result.error)) {
                            proxy._showErrorDialog(result.error);
                            return;
                        }
                    }
                    proxy._existingItems = [];
                    proxy._fileExplorer[proxy._currentPath] = "";
                    proxy._nodeType != "File" && proxy._modifySelectedStates(proxy._currentPath + proxy._selectedContent, proxy._currentPath + proxy._ajax_person);
                    if (proxy._splittag.find(".e-cont2 .e-active").length <= 0) {
                        $.each(proxy._fileExplorer, function (itemPath, value) {
                            if (itemPath.startsWith(proxy._currentPath + proxy._selectedContent + "/"))
                                proxy._fileExplorer[itemPath] = "";
                        });
                        proxy._selectedNode.find("> div > .e-text")[0].lastChild.nodeValue = proxy._selectedContent = proxy._ajax_person;
                        proxy._originalPath = proxy._currentPath += proxy._ajax_person + "/";
                        proxy._updateAddressBar();
                    }
                    else {
                        if (proxy.model.selectedItems.length > 0) {
                            proxy.model.selectedItems[proxy.model.selectedItems.length - 1] = proxy._getOriginalName(proxy._ajax_person);
                            proxy._selectedItems[0] = proxy._ajax_person;
                            proxy._highlightedNodes = proxy.model.selectedItems;
                            proxy._refreshItems(proxy._selectedNode, proxy._currentPath);
                        }
                        else
                            proxy._refreshItems(proxy._parentNode, proxy._currentPath);
                        if (proxy._treeObj.getSelectedNode().length == 0) {
                            $(proxy._parentNode).find('li a').each(function () {
                                if ($(this).text() == proxy._ajax_person) {
                                    proxy._treeObj.selectNode($(this).closest('li.e-item'));
                                    return false;
                                }
                            });
                        }
                    }
                },
                successAfter: this.model.ajaxSettings.rename.success
            };
            this.model.ajaxSettings.rename.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.rename);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _downloadFile: function () {
            var selectedItems = this._getSelectedItemDetails(this._currentPath, this._selectedItems);
            var dataObj = {
                Path: this._pathCorrection(this._currentPath),
                ActionType: "Download",
                SelectedItems: JSON.stringify(selectedItems),
                Names: this._selectedItems
            };            
            var url = this.model.ajaxAction + "?" + ($.param(dataObj, true));            
            if (this.model.ajaxSettings.download.url) {
                if (this.model.ajaxSettings.download.url.indexOf("{") >= 0)
                    url = String.format(this.model.ajaxSettings.download.url, "?" + ($.param(dataObj, true)));
                else
                    url = this.model.ajaxSettings.download.url;
            }
            var args = { path: this._pathCorrection(this._currentPath), files: this._selectedItems, selectedItems: selectedItems };
            if (this._trigger("beforeDownload", args))
                return false;
            window.location = url;
        },
        _removeBlurEffect: function () {
            if (this._currntNode) {
                this._currntNode.hasClass("e-active") && this._currntNode.removeClass("e-blur");
                this._currntNode.find(".e-active").length && this._currntNode.find(".e-active").removeClass("e-blur");
            }
        },
        _renderTreeView: function (result) {
            var rootDIRID = 1, _hasChild = result.length > 0 ? true : false;
            this._collapse = false;
            var proxy = this;
            var nodes = this._currentPath.split("/");
            for (var i = 0; i < nodes.length - 2; i++) {
                this._initPath += nodes[i] + "/";
            }
            var startNode = nodes[nodes.length - 2];
            this._localData = [{ id: rootDIRID, name: (startNode ? startNode : this._currentPath), spriteCssClass: this._hasReadPermission(this._currentPath) ? "e-fe-icon e-fe-folder" : "e-fe-icon e-fe-folder e-fe-lock", hasChild: _hasChild }];
            this._treetag._collapse = false;
            this._treetag.ejTreeView(
               {
                   loadOnDemand: true,
                   cssClass: proxy.model.cssClass,
                   enableRTL: proxy.model.enableRTL,
                   allowKeyboardNavigation: proxy.model.allowKeyboardNavigation,
                   fields: { dataSource: proxy._localData, id: "id", parentId: "pid", text: "name", hasChild: "hasChild", spriteCssClass: "spriteCssClass" },
                   nodeCollapse: function (e) { proxy._refreshTreeScroller(e); },
                   nodeExpand: function (e) { proxy._refreshTreeScroller(e); },
                   nodeClick: function (e) { proxy._treenodeClicked(e); },
                   beforeExpand: function (e) { proxy._treeNodeBeforeExpand(e); },
                   nodeSelect: function (e) { proxy._updateTreePath(e); },
                   beforeCollapse: function (e) { proxy._onBeforeCollapse(e); },
                   beforeDelete: function (e) { proxy._treeBeforeDelete(e); },
               }
           );
            this._treeObj = this._treetag.data("ejTreeView");
            this._treeViewEvents("_off");
            this._treeViewEvents("_on");
            this._isClicked = false;
            this._treetag.ejTreeView("selectNode", $(this._treetag).find("li")[0]);
            this._isClicked = true;
            this._treeScroll = this._treetag.parent(".e-tree-wrapper").ejScroller({ height: this._splittag.height(), width: parseInt(this._splittag.find(".e-cont1").width()), buttonSize: 0, scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } }).data("ejScroller");
            this._addChild(result);
        },
        _treeViewEvents: function (action) {
            this[action](this._treetag, "focus", this._focusTreeView);
            this[action](this._treetag, "blur", this._blurTreeView);
            this.model.allowDragAndDrop && this._treeDragEvents(action);
        },
        _treeDragEvents: function (action) {
            var treeWraper = this._treetag.parent(".e-tree-wrapper");
            if (treeWraper) {
                this[action](treeWraper, "dragover", this._onDragOverHandler);
                this[action](treeWraper, "drop", this._onDropHandler);
                this[action](treeWraper, "dragleave", this._onDragLeave);
            }
        },
        _focusTreeView: function (e) {
            if (!this._treetag.hasClass("e-focus")) {
                this._treetag.addClass("e-focus");
                this._itemList = [];
                this._on(this._treetag, "keydown", this._OnKeyUp);
                this._hidePopup();
            }
        },
        _blurTreeView: function (e) {
            this._treetag.removeClass("e-focus");
            this._off(this._treetag, "keydown", this._OnKeyUp);
        },
        _treeBeforeDelete: function (args) {
            if (ej.isNullOrUndefined(args.event)) return;
            var code = this._getKeyCode(args.event);
            if (code == 46) // Prevent the treeview Delete action
                args.cancel = true;
        },
        _treeNodeBeforeExpand: function (args) {
            if (!this._nodeExpanded) {
                var path = this._updatePath(args.currentElement, args.value);
                !this._fileExplorer[path] && this._getFileDetails(path, args.currentElement);
                if (!this._treetag.ejTreeView("hasChildNode", args.currentElement)) {
                    this._fileExplorer[path] && this._addChild(this._fileExplorer[path], args.currentElement);
                }
            }
        },
        _treenodeClicked: function (args) {
            args.event.currentTarget && args.event.currentTarget.focus();
            if ($(args.currentElement).hasClass("e-text") && args.currentElement != this._selectedNode.find('> div > .e-text')[0]) {
                this._selectedContent = args.currentElement.text;
                this._selectedNode = $(args.currentElement).closest('li.e-item');
                var node = $(this._selectedNode.parents('li.e-item')[0]);
                this._parentNode = node.length != 0 ? node : this._selectedNode;
                this._nodeType = "Directory";
                this._isTreeNode = true;
            }
        },
        _showHideContextMenu: function () {
            if (this.model.showContextMenu) {
                var events = { beforeOpen: "", click: "" }, menuDetails = { id: "", targetId: "" };
                this._treeMenuOptions = this._initContextMenuOptions("navbar");
                menuDetails.id = this._ExplorerId + "_treeView";
                menuDetails.targetId = "#" + this._ExplorerId + "_treeView";
                events.beforeOpen = $.proxy(this._beforeOpenContextMenu, this);
                events.open = $.proxy(this._contextMenuOpen, this);
                events.close = $.proxy(this._onHideContextMenu, this);
                events.click = $.proxy(this._contextMenuClick, this);
                this._treeContextMenutag = this._createContextMenuTag(this._treeMenuOptions, menuDetails, events);
                this._treeMenuObj = this._treeContextMenutag.ejMenu('instance');
                this._cwdMenuOptions = this._initContextMenuOptions("cwd");
                this._addSortbyoptions();
                menuDetails.id = this._ExplorerId + "_tileView";
                menuDetails.targetId = "#" + this._ExplorerId + "_tileWrapper,#" + this._ExplorerId + "_grid";
                events.beforeOpen = $.proxy(this._beforeOpenTileContextMenu, this);
                events.open = $.proxy(this._contextMenuOpen, this);
                events.click = $.proxy(this._fileContextMenuClick, this);
                this._tileContextMenutag = this._createContextMenuTag(this._cwdMenuOptions, menuDetails, events);
                this._viewMenuObj = this._tileContextMenutag.ejMenu('instance');
                if (ej.isNullOrUndefined(this._fileName) || this._fileName == "") {
                    this._treeMenuObj.disableItem(this._menuPaste);                    
                }
                this._fileMenuOptions = this._initContextMenuOptions("files");                
            }
            else {
                if (this._treeContextMenutag && this._tileContextMenutag) {
                    this._treeMenuObj.destroy();
                    this._viewMenuObj.destroy();
                    $("#" + this._ExplorerId + "_treeViewContextMenu").remove();
                    $("#" + this._ExplorerId + "_tileViewContextMenu").remove();
                    this._viewMenuObj= this._treeMenuObj = null;                     
                }
            }
        },
        _addSortbyoptions: function () {
            var length = this.model.contextMenuSettings.items.cwd.length;
            var items = this.model.contextMenuSettings.items.cwd;
            if (items.indexOf('SortBy') > -1) {
                    var itemslength = this.model.gridSettings.columns.length;
                    for (var j = 0; j < itemslength; j++) {
                        var css = "e-fileexplorer-toolbar-icon " + this.model.gridSettings.columns[j].field;
                        this._cwdMenuOptions.push({ id: this._ExplorerId + "_cwd_" + this.model.gridSettings.columns[j].field, text: this.model.gridSettings.columns[j].headerText, parentId: this._ExplorerId + "_cwd_" + "SortBy", sprite: css});
                    }
                }
        },
        enableMenuItem: function (operation) {            
            operation = this._findCommand(operation, this.model.contextMenuSettings.items, true);
            for(var i=0; i < this._restrictedMenuOption.length; i++){
                if (this._restrictedMenuOption[i] == operation) {
                    this._restrictedMenuOption.splice(i, 1);
                    break;
                }                    
            }                        
            this._treeMenuObj && this._treeMenuObj.enableItem(operation);
            this._viewMenuObj && this._viewMenuObj.enableItem(operation);
        },
        disableMenuItem: function (operation) {
            operation = this._findCommand(operation, this.model.contextMenuSettings.items, true);
            if ($.inArray(operation, this._restrictedMenuOption) == -1)
                this._restrictedMenuOption.push(operation);
            this._treeMenuObj && this._treeMenuObj.disableItem(operation);
            this._viewMenuObj && this._viewMenuObj.disableItem(operation);
        },
        _renderGridView: function (result) {
            var columnSettings = JSON.parse(JSON.stringify(this.model.gridSettings.columns));
            var sortSettings = null;
            for (var i = 0; i < columnSettings.length; i++) {
                if (!columnSettings[i]["template"]) {
                    columnSettings[i]["template"] = "<script type='text/x-jsrender'><span title= '{{:" + columnSettings[i]["field"] + "}}'>{{:" + columnSettings[i]["field"] + "}}</span></script>";
                }
            }
            if (this._suggestionItems.length) 
                columnSettings.push({ field: "filterPath", headerText: this._getLocalizedLabels("Folder"), width: "20%" });
            columnSettings.unshift({ field: "cssClass", headerText: "", cssClass: "e-grid-image", width: 22, template: "<script type='text/x-jsrender'><span class='e-fe-icon {{:cssClass}}' unselectable='on'></span></script>", textAlign: ej.TextAlign.Center, allowResizing: false });
            if (this.model.showCheckbox)
                columnSettings.unshift({ field: "", headerText: "check", cssClass: "e-col-check", width: 22, template: "<script type='text/x-jsrender'><input type='checkbox' class='e-grid-row-checkbox'/></script>", textAlign: ej.TextAlign.Center, headerTextAlign: ej.TextAlign.Center, allowResizing: false, allowSorting: false });
            var proxy = this;
            var lastcolumn = columnSettings[columnSettings.length - 1];
            if (lastcolumn) {
                if (lastcolumn["customAttributes"]) {
                    if (lastcolumn["customAttributes"]["class"]) {
                        if (lastcolumn["customAttributes"]["class"].search("e-rowcell e-last-rowcell") == -1)
                            lastcolumn["customAttributes"]["class"] = lastcolumn["customAttributes"]["class"] + " e-rowcell e-last-rowcell";
                    }
                    else
                        lastcolumn["customAttributes"]["class"] = " e-rowcell e-last-rowcell";
                }
                else {
                    lastcolumn["customAttributes"] = { 'class': "e-rowcell e-last-rowcell" };
                }
            }
            if (this._gridObj) {
                if (columnSettings.length != this._gridObj.model.columns.length) {
                    this._gridObj.model.columns = columnSettings;
                    this._gridObj.columns(this._gridObj.model.columns);
                }
                sortSettings = JSON.parse(JSON.stringify(this._gridObj.model.sortSettings));
                this._gridObj.option('dataSource', result);
                this._gridObj.option('enableRTL', this.model.enableRTL);
                this._gridObj.option('sortSettings', sortSettings);
            } else {
                this._gridtag.ejGrid({
                       cssClass: proxy.model.cssClass,
                       enableRTL: proxy.model.enableRTL,
                       allowKeyboardNavigation: this.model.allowKeyboardNavigation,
                       dataSource: result,
                       selectionType: (proxy.model.allowMultiSelection ? "multiple" : "single"),
                       allowSorting: proxy.model.gridSettings.allowSorting,
                       columns: columnSettings,
                       isResponsive: true,
                       scrollSettings: { width: 186, height: 200, buttonSize: 0, scrollerSize: proxy._scrollerSize},
                       allowScrolling: true,
                       enableResponsiveRow: false,
                       rowSelected: function (e) { proxy._updatePathFromGrid(e); },
                       recordDoubleClick: function (e) { proxy._openAction(e); },
                       templateRefresh: function (args) { proxy._templateRefresh(args); },
                       create: (this.model.showCheckbox ? function (e) { proxy._gridCheckboxState(e); } : null),
                       actionBegin: function (e) { proxy._gridActionBegin(e); },
                       actionComplete: function (e) { proxy._gridActionComplete(e); },
                       allowResizing:proxy.model.gridSettings.allowResizing
                  }
               );
            }
            if (result.length && result[0].filterPath) {
                this._setFilteredContent();
            }   
            this._gridObj = this._gridtag.ejGrid("instance");
            var permission = this._getFilePermission(this._currentPath);
            if ((permission) && !(permission.Read)) this._gridObj.getContentTable().find(".emptyrecord").html(this._getLocalizedLabels("ProtectedFolder")).addClass("e-fe-center");
            else if (this._gridObj.model.dataSource.length == 0 && (this._searchbar && $.trim(this._searchbar.val()))) this._gridObj.getContentTable().find(".emptyrecord").html(this._getLocalizedLabels("EmptyResult")).addClass("e-fe-center");
            else if(this._gridObj.model.dataSource.length == 0) this._gridObj.getContentTable().find(".emptyrecord").html(this._getLocalizedLabels("EmptyFolder")).addClass("e-fe-center");
            this.gridItems = this._gridObj.getRows();
            if (this.model.allowDragAndDrop) {
                this._gridtag.children(".e-gridcontent").addClass("e-droppable");
                this._drag($(this.gridItems));
                $(this.gridItems).addClass("e-file-draggable");
            }
            this._reSizeHandler();
            var gridScrollObj = this._gridObj.getScrollObject();
            if (gridScrollObj && (gridScrollObj.isVScroll() || gridScrollObj.isVScroll())) {
                gridScrollObj.element.ejScroller({ thumbStart: function (e) { proxy._onThumbStart(e); } });
            }
            this._gridtag.attr("tabindex", -1);
            this._gridViewEvents("_off");
            this._gridViewEvents("_on");
            this._gridupdate(this._prevsortingoption);
        },
        _setFilteredContent: function(){
            var rows = this._gridtag.find(".e-gridcontent tr");
            for (var i = 0; i < rows.length; i++) {
                var node = $(rows[i]).find("td:last");
                $(rows[i]).attr("data-parent-path", node.text());
                node.attr("title", node.text());
                node.text("/" + node.text().replace(this._rootPath, ""));
            }
        },
        _templateRefresh: function (args) {
            this._trigger("templateRefresh", args);
        },
        _gridActionBegin: function (args) {
            if (args.requestType == "sorting") {
                args.cancel = true;
                var length = this.model.gridSettings.columns.length;
                for (i = 0; i < length; i++) {
                    if (args.columnName == this.model.gridSettings.columns[i].field) {
                        this._changeActiveSortedoption(this.model.gridSettings.columns[i].headerText);
                        this._sorting(this._prevsortingoption, this._prevsorting);
                        this._sortingActioncomplete();
                        break;
                    }
                }
                    if (this._suggestionItems.length && args.columnName == "filterPath") {
                        this.removeSortingIcons();
                        this._suggestionitemsSorting("filterPath", this._prevsorting);
                        this._sortingActioncomplete(); 
            }
                    this._suggestionItems.length && this._setFilteredContent();
                }
        },
        _gridActionComplete: function (args) {
            this.model.showCheckbox && this._gridCheckboxState(args);
            if (!ej.isNullOrUndefined(this._gridObj) && this.model.gridSettings.allowSorting) {
                this._gridupdate(this._prevsortingoption);
            }
        },

        _gridCheckboxState: function (args) {
            var proxy = this;
            this._gridtag.find(".e-headercelldiv:first").html(" <input type='checkbox' id='headchk' />").addClass("e-col-check");
            this._headCheckObj = this._gridtag.find("#headchk").ejCheckBox({showRoundedCorner: proxy.model.showRoundedCorner, change: function (e) { proxy._headCheckChange(e); } }).data("ejCheckBox");
            this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ showRoundedCorner: proxy.model.showRoundedCorner });
            this._gridtag.find(".e-chkbox-wrap").removeAttr("tabindex");
        },
        _checkChange: function (target) {
            if (!target.isInteraction && target.isInteraction != undefined) return;
            var rows = this._gridtag.find(".e-grid-row-checkbox");
            var checkedElements = this._gridtag.find(" .e-gridcontent .e-checkbox:checked");
            var rowCheck = [];
            for (var i = 0 ; i < checkedElements.length; i++) {
                rowCheck.push($(checkedElements[i]).closest("tr").index());
            }
            if (target && !target.type) {
                var index = $.inArray(target.index(), rowCheck);
                target.find(".e-chk-act").length == 1 ? rowCheck.splice(index, 1) : rowCheck.push(target.index());
            }
            this._changeCheckState = false;
            this._gridObj.clearSelection();
            if (rowCheck.length == rows.length)//check if all checkboxes in the current page are checked
                this._gridtag.find("#headchk").ejCheckBox({ "checked": true });
            else
                this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
            this._isClicked = false;
            for (i = 0; i < rowCheck.length; i++) {
                if (true) {
                    this._gridObj.multiSelectCtrlRequest = true;
                    this._gridObj.selectRows(rowCheck[i]);// To prevent unselection of other rows when a checkbox is unchecked after selectAll rows
                }
            }
            this._isClicked = true;
            if (this.model.checked == false) {
                this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
            }
            this._changeCheckState = true;
        },
        _recordClick: function () {
            var rows = this._gridtag.find(".e-grid-row-checkbox");
            for (var i = 0; i < rows.length; i++) {
                if ($.inArray(i, this._gridObj.selectedRowsIndexes) < 0) {
                    $(rows[i]).ejCheckBox({ "checked": false })  //To clear checkbox when we select row by recordclick rather than checkbox
                    this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
                    !this._gridObj.multiSelectCtrlRequest && this._unselectEvent();
                }
                else {
                    $(rows[i]).ejCheckBox({ "checked": true });
                    var rowCheck = this._gridtag.find(".e-grid-row-checkbox:checked");
                    if (rowCheck.length == rows.length)
                        this._gridtag.find("#headchk").ejCheckBox({ "checked": true });
                }
            }
        },
        _headCheckChange: function (args) {
            if (!args.isInteraction) return;
            var proxy = this;
            var rows = this._gridtag.find(".e-grid-row-checkbox");
            rows.ejCheckBox({ "change": function (e) { proxy._checkChange(e); } });
            if (this._gridtag.find("#headchk").is(':checked')) {
                rows.ejCheckBox({ "checked": true });
                this._gridObj.selectRows(0, rows.length);  // To Select all rows in Grid Content
            }
            else {
                rows.ejCheckBox({ "checked": false });
                this._setSelectedItems([]); // To remove selection for all rows
                this._unselectEvent();
            }
        },

        _unselectEvent : function(){
            var prevSelecteditems = this._getSelectedItemDetails(this.model.selectedFolder, this._filteredItemsName);
            this._filteredItemsName = [];
            if (this._gridObj && this._gridObj.multiSelectCtrlRequest)
                return;
            if (prevSelecteditems.length > 0 ) {
                this._unselectedItems = [];
                for (var record = 0; record < prevSelecteditems.length; record++) {
                    name = prevSelecteditems[record].name;
                    this._unselectedItems.push(name);
                }

                var index = $.inArray(undefined, this.model.selectedItems), _nodeType;
                $.each(this._fileExplorer[this._originalPath], function (index, value) {
                    if (!value.isFile) _nodeType = "Directory";
                    else _nodeType = "File";
                });
                var data = { name: this._unselectedItems[this._unselectedItems.length - 1], names: this._unselectedItems, path: this.model.selectedFolder, nodeType: _nodeType, unselectedItem: prevSelecteditems[prevSelecteditems.length-1], unselectedItems: prevSelecteditems };
                this._trigger("unselect", data);
            }
        },

        _gridViewEvents: function (action) {
            this[action](this._gridtag.find(".e-gridcontent"), "focusin", this._focusGridView);
            this[action](this._gridtag.find(".e-gridcontent"), "focusout", this._blurGridView);
            this.model.allowDragAndDrop && this._gridDragEvents(action);
        },
        _gridDragEvents: function (action) {
            var gridContent = this._gridtag.children(".e-gridcontent")
            if (gridContent) {
                this[action](gridContent, "dragover", this._onDragOverHandler);
                this[action](gridContent, "drop", this._onDropHandler);
                this[action](gridContent, "dragleave", this._onDragLeave);
                this[action](this._gridtag.find(".e-gridheader"), "dragover", this._preventDropOption);
            }
        },
        _focusGridView: function (e) {
            if (!this._gridtag.find(".e-gridcontent").hasClass("e-focus")) {
                this._gridtag.find(".e-gridcontent").addClass("e-focus");
                this._itemList = [];
                this._on(this._gridtag.find(".e-gridcontent"), "keydown", this._OnKeyUp);
                this._hidePopup();
            }
        },
        _blurGridView: function (e) {
            this._gridtag.find(".e-gridcontent").removeClass("e-focus");
            this._off(this._gridtag.find(".e-gridcontent"), "keydown", this._OnKeyUp);
        },
        _setThumbImageHeight: function () {
            var perRow = this._perRow = 1;
            if (this.items) {
                for (var i = 0; i < this.items.length - 1; i++) {
                    if (this.items[i].getBoundingClientRect().top == this.items[i + 1].getBoundingClientRect().top)
                        perRow++;
                    else
                        break;
                }
                if (!(perRow == null || perRow < 2)) {
                    for (var i = 0, j = this.items.length; i < j; i += perRow) {
                        var maxHeight = 0,
                        row = this.items.slice(i, i + perRow);
                        row.each(function () {
                            var itemHeight = parseInt($(this).find(".e-thumb-image").outerHeight());
                            if (itemHeight > maxHeight) maxHeight = itemHeight;
                        });
                        row.find(".e-thumb-image.e-image").css('height', maxHeight);
                    }
                }
                this._tileScroll && this._tileScroll.refresh();
            }            
            this._perRow = perRow;
        },
        _renderTileView: function (result,path) {
            this._tileView.children() && this._tileView.children().remove() && this._tileView.removeClass("e-tileview");
            this._tileView.appendTo(this._tileContent);
            this._tileView.addClass("e-tileview").attr("role", "tileview");
            var permission = this._getFilePermission(this._currentPath);
            if ((permission) && !(permission.Read)) this._tileView.html(this._getLocalizedLabels("ProtectedFolder")).addClass("e-fe-center");
            else if ((this._searchbar && $.trim(this._searchbar.val())) && result.length == 0) this._tileView.html(this._getLocalizedLabels("EmptyResult")).addClass("e-fe-center");
            else if(result.length == 0) this._tileView.html(this._getLocalizedLabels("EmptyFolder")).addClass("e-fe-center");
            else this._tileView.html("").removeClass("e-fe-center");
            var proxy = this;
            var pathdetail = path;
            var spantag = null;
            $.each(result, function (index, value) {
                if (value.filterPath)
                    var liTag = $("<li class='e-tilenode' data-parent-path='" + value.filterPath + "'></li>");
                else
                    var liTag = $("<li class='e-tilenode'></li>");
                var imageWrapper = $("<div class='e-align'><div class='e-thumb-image e-image ' unselectable='on'></div></div>");
                if (value.isFile) {
                    imageWrapper.appendTo(liTag);
                    var extension = value.name.substr(value.name.lastIndexOf('.') + 1).toLowerCase();
                    if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(value.name)) {
                        if (proxy.model.showThumbnail) {
                            var path = value.filterPath ? value.filterPath.replace("~", "..") + value.name : (pathdetail ? proxy._originalPath.replace("~", "..") + value.name : proxy._currentPath.replace("~", "..") + value.name);
                            var url = proxy._getImage(path, value.name, proxy.model.enableThumbnailCompress);
                            spantag = ej.buildTag('img.e-thumbImage', "", "", { src: (url ? url : (path + "?" + (proxy._updateImages[path] ? proxy._updateImages[path] : proxy._initialTime))), "unselectable": "on" });
                        } else spantag = $("<span class='e-thumbImage e-fe-icon' unselectable='on'></span>").addClass('e-fe-images');
                    }
                    else if ((/\.(mp3|wav|aac|ogg|wma|aif|fla|m4a)$/i).test(value.name)) spantag = $("<span class='e-thumbImage e-fe-icon' unselectable='on'></span>").addClass('e-fe-audio');
                    else if ((/\.(webm|mkv|flv|vob|ogv|ogg|avi|wmv|mp4|3gp)$/i).test(value.name)) spantag = $("<span class='e-thumbImage e-fe-icon' unselectable='on'></span>").addClass('e-fe-video');
                    else if (!(/\.(css|exe|html|js|msi|pdf|pptx|ppt|rar|zip|txt|docx|doc|xlsx|xls|xml|rtf|php)$/i).test(value.name)) spantag = $("<span class='e-thumbImage e-fe-icon e-fe-unknown' unselectable='on'></span>").addClass('e-fe-' + extension);
                    else spantag = $("<span class='e-thumbImage e-fe-icon' unselectable='on'></span>").addClass('e-fe-' + extension);
                }
                else {
                    imageWrapper.appendTo(liTag);
                    liTag.addClass("e-folder");
                    spantag = $("<span class='e-thumbImage e-fe-icon e-fe-folder' unselectable='on'></span>");
                    if (value.permission && !value.permission.Read)
                        spantag.addClass("e-fe-lock");
                }
                spantag.appendTo(imageWrapper.find(".e-thumb-image"));
                if (proxy.model.showCheckbox)
                    var checkBox = $("<input type='checkbox' class='e-tile-checkbox' />");
                var divtag1 = $("<div class='e-name-wrap' unselectable='on' </div>");
                var divtag = $("<div class='e-name e-name-in-wrap' unselectable='on'></div>");
                var fname = $("<div class='e-file-name' unselectable='on'><span class='e-file-info' title= '" + value.name + "'>" + value.name + "</span></div>");
                fname.appendTo(divtag);
                if (value.isFile && proxy.model.layout == "tile") {
                    var fntype = $("<div class='e-file-type' unselectable='on'><span class='e-file-info'>" + value.type + "</span></div>");
                    fntype.appendTo(divtag);
                    var fnsize = $("<div class='e-file-size' unselectable='on'><span class='e-file-info'>" + value.size + "</span></div>");
                    fnsize.appendTo(divtag);
                }
                divtag.appendTo(divtag1);
                liTag.attr({
                    "aria-selected": false,
                    "title": (value.isFile) ? value.dateModified + " (" + value.size + ")" : value.dateModified,
                    "role": "tileitem"
                });
                proxy.model.showCheckbox && checkBox.prependTo(liTag);
                divtag1.appendTo(liTag);
                liTag.appendTo(proxy._tileView);
                proxy.model.showCheckbox && proxy._tileView.find(".e-tile-checkbox").ejCheckBox({ size: "mini", showRoundedCorner : proxy.model.showRoundedCorner });
                proxy._tileView.find(".e-chkbox-wrap").removeAttr("tabindex");
            });
            this._activeItem = 0;
            this.items = this._tileView.children("li.e-tilenode");
            if (this.model.allowDragAndDrop) {
                this._tileViewWrapper.addClass("e-droppable");
                this._drag(this.items);
                this.items.addClass("e-file-draggable");
            }
            this._tileViewEvents("_off");
            this._tileViewEvents("_on");
            this._tileContent.addClass("e-content");
            var _tileHeight = this.model.showFooter ? this._splittag.outerHeight() - this._statusbar.outerHeight() : this._splittag.outerHeight();
            var _tileWidth = parseInt(this._splittag.find(".e-cont2").width());
            if (ej.isNullOrUndefined(this._tileScroll))
                this._tileScroll = this._tileContent.parent(".e-tile-wrapper").ejScroller({ height: _tileHeight, width: _tileWidth, buttonSize: 0, scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } }).data("ejScroller");
            else {
                this._tileScroll.option({ "height": _tileHeight, "width": _tileWidth });
                this._tileScroll && this._tileScroll.refresh();
            }
            if (!proxy._tileView.find(".e-image > img").length)
                proxy._setThumbImageHeight();
            else {
                var images = proxy._tileView.find(".e-image > img");
                var increament = 0;
                for (var i = 0; i < images.length; i++) {
                    var img = new Image();
                    img.onload = img.onabort = img.onerror = function (args) {
						if(args){
							++increament == images.length && proxy._setThumbImageHeight();
							var myargs = { path: args.target.src, element: args.target, originalArgs: args, action: "thumbnailPreview" };
							proxy._trigger("getImage", myargs);
						}
                        
                    };
                    img.src = $(images[i]).attr('src');
                }
            }
        },
        _getImage: function (path, name, canCompress) {
            path = path.replace("..", "~");
            var selectedItems = this._getSelectedItemDetails(this._currentPath, name);
            var args = { path: path, canCompress: canCompress, size: (canCompress ? { Height: 104, Width: 116 } : null), selectedItems: selectedItems };
            args.path = this._pathCorrection(args.path);
            if (this._trigger("beforeGetImage", args))
                return "";
            if (this._currentPath.indexOf(":") == 1 || this.model.ajaxSettings.getImage.url || (this._currentPath.startsWith("//") && this.model.path == "/") ) {
                var url = this.model.ajaxAction + "?Path=" + args.path + "&ActionType=GetImage&CanCompress=" + args.canCompress + "&Size=" + JSON.stringify(args.size) + "&SelectedItems=" + JSON.stringify(args.selectedItems);
                if (this.model.ajaxSettings.getImage.url) {
                    if (this.model.ajaxSettings.getImage.url.indexOf("{") >= 0)
                        url = String.format(this.model.ajaxSettings.getImage.url, "?CanCompress=" + args.canCompress + "&Size=" + JSON.stringify(args.size) + "&Path=" + args.path + "&SelectedItems=" + JSON.stringify(args.selectedItems));
                    else
                        url = this.model.ajaxSettings.getImage.url;
                }
            }
            return url ? url : (canCompress ? this.model.ajaxAction + "?ActionType=GetImage&CanCompress=" + args.canCompress + "&Size=" + JSON.stringify(args.size) + "&Path=" + args.path + "&SelectedItems=" + JSON.stringify(args.selectedItems): "");
        },
        _gridtagClick: function (event) {
            event.stopPropagation();
            if ($(event.target).hasClass("e-gridcontent") || $(event.target).hasClass("e-content") || $(event.target).hasClass("e-table")) {
                this._addFocus(this._gridtag.find(".e-gridcontent"));
                if (this.model.showCheckbox) {
                    this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ "checked": false });
                    this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
                }
                this._gridObj.clearSelection();
                this._unselectEvent();
                this._updateCurrentPathPermission();
                this._activeSource && this._activeSource.length && this._setSelectedItems(this._activeSource);
            }
            this._activeSource = null;
        },

        _updateGridSelection: function (args) {
            if (args.events && !args.events.ctrlKey && $(args.target)[0] != null) {
                this._gridObj.selectRows($(args.target).closest('td').parent().index(), null, $(args.target).closest('td'));
            }
        },

        _updateTileSelection: function (args) {
            if (args.events && !args.events.ctrlKey && $(args.target)[0] != null) {
                this._triggerClick(args.target);
            }
        },

        _tileViewEvents: function (action) {
            this[action](this.items, "mousedown", this._preventDefaultSelection);
            this[action](this.items, (this._isDevice && $.isFunction($.fn.tap)) ? "tap" : "click", this._upDatePathFromTileView);
            this[action](this.items, (this._isDevice && $.isFunction($.fn.tap)) ? "doubletap" : "dblclick", this._openAction);
            this[action](this.items, "mouseenter", this._onItemHover);
            this[action](this.items, "mouseleave", this._onItemLeave);
            this[action](this._tileViewWrapper, "focusin", this._focusTileView);
            this[action](this._tileViewWrapper, "focusout", this._blurTileView);
            this.model.allowDragAndDrop && this._tileDragEvents(action);
        },
        _tileDragEvents: function (action) {
            if (this._tileViewWrapper) {
                this[action](this._tileViewWrapper, "dragover", this._onDragOverHandler);
                this[action](this._tileViewWrapper, "drop", this._onDropHandler);
                this[action](this._tileViewWrapper, "dragleave", this._onDragLeave);
            }
        },
        _preventDefaultSelection: function(event){
            event.shiftKey && event.preventDefault();
        },
        _tileViewWrapperClick: function (event) {
            if ($(event.target).hasClass("e-tile-wrapper") || $(event.target).hasClass("e-tile-content") || $(event.target).hasClass("e-tileview")) {
                this._lastItemIndex = this._lastItemIndex ? this._lastItemIndex : (this._itemList ? this._itemList.filter(".e-active").index(): -1);
                this._addFocus(this._tileViewWrapper);
                if (this.items.hasClass("e-active"))
                    this.items.removeClass("e-active").attr("aria-selected", false);
                this._updateCurrentPathPermission();
                this.model.showCheckbox && this._clearTileCheckBoxSelection();
                this._hidePopup();
                this._activeSource && this._activeSource.length && this._setSelectedItems(this._activeSource);
                this._unselectEvent();
            }
            this._activeSource = null;
        },
        _onItemHover: function (e) {
            var currentItem = e.currentTarget, targetItem = e.target;
            if (!$(currentItem).hasClass("e-disable")) {
                this.items.removeClass("e-hover");
                $(currentItem).addClass("e-hover");
            }
        },
        _onItemLeave: function (e) {
            var currentItem = e.currentTarget, targetItem = e.target;
            if (!$(currentItem).hasClass("e-disable")) {
                $(currentItem).removeClass("e-hover");
            }
        },
        _focusTileView: function (e) {
            if (!this._tileViewWrapper.hasClass("e-focus")) {
                this._tileViewWrapper.addClass("e-focus");
                this._itemList = this.items;
                this._on(this._tileViewWrapper, "keydown", this._OnKeyUp);
                this._on(this._tileViewWrapper, "keydown", this._OnKeyDown);
            }
        },
        _blurTileView: function (e) {
            this._tileViewWrapper.removeClass("e-focus");
            this._off(this._tileViewWrapper, "keydown", this._OnKeyUp);
            this._off(this._tileViewWrapper, "keydown", this._OnKeyDown);
        },
        _OnKeyDown: function (e) {
            var itemsLength = this._itemList.length - 1, activeItem;
            this._activeItem = this._lastItemIndex ? this._lastItemIndex : (this._itemList ? this._itemList.filter(".e-active").index() : -1);
            var code = this._getKeyCode(e);
            if (!this.model.allowKeyboardNavigation) return;
            switch (code) {
                case 38:
                    e.preventDefault();
                    if ($(e.target).hasClass("e-statusbar")) {
                        this._focusLayout(this.model.layout);
                        return;
                    }
                    if (this._activeItem < this._perRow-1)
                        return;
                    this._activeItem -= this._perRow;
                    this._beforeListHover(e);
                    break;
                case 37:
                    e.preventDefault();
                    if (this._activeItem == 0)
                        return;
                    if ((this._activeItem < 0) || (this._activeItem == null) || (this._activeItem > itemsLength))
                        this._activeItem = 0;
                    else if (this._activeItem == 0)
                        this._activeItem = itemsLength;
                    else
                        this._activeItem -= 1;
                    this._beforeListHover(e);
                    break;
                case 40:
                    e.preventDefault();
                    if (this._activeItem + this._perRow >= this._itemList.length)
                        return;
                    this._activeItem += this._perRow;
                    this._beforeListHover(e);
                    break;
                case 39:
                    e.preventDefault();
                    if (this._activeItem == itemsLength)
                        return;                    
                    if ((this._activeItem > itemsLength) || (this._activeItem == null) || (this._activeItem < 0))
                        this._activeItem = itemsLength;
                    else if (this._activeItem == itemsLength)
                        this._activeItem = 0;
                    else
                        this._activeItem += 1;
                    this._beforeListHover(e);
                    break;
                case 33:
                case 36:
                    e.preventDefault();
                    this._activeItem = 0;
                    this._beforeListHover(e);
                    break;
                case 34:
                case 35:
                    e.preventDefault();
                    this._activeItem = itemsLength;
                    this._beforeListHover(e);
                    break;
            }
            this._lastItemIndex= e.shiftKey ? this._activeItem : null;
        },
        _OnKeyUp: function (e) {
            var activeItem;
            var code = this._getKeyCode(e);
            if (!this.model.allowKeyboardNavigation) return;
            if (this._KeydownEventHandler(e)) return;
            switch (code) {
                case 13:
                    e.preventDefault();
                    if (e.altKey) {
                        this._lastFocusedElement = e.currentTarget;
                        this._getDetails();
                    }
                    else {
                        e.preventDefault();
                        this._lastFocusedElement = e.currentTarget;
                        if (!$(e.currentTarget).hasClass("e-treeview")) {
                            var isPresent = false;
                            if ($(e.currentTarget).hasClass("e-tile-wrapper"))
                                isPresent = this.items.hasClass("e-active");
                            else if ($(e.currentTarget).hasClass("e-gridcontent"))
                                isPresent = $(this.gridItems).find("td").hasClass("e-active");
                            if (isPresent && this._selectedContent)
                                this._openAction();
                        }
                    }
                    break;
                case 86:
                    if (e.ctrlKey) {
                        e.preventDefault();
                        if (!ej.isNullOrUndefined(this._option) && this._selectedContent) {
                            if (this._currentPath != this._originalPath) {
                                this._currentPath = this._originalPath;
                            }
                            this._lastFocusedElement = e.currentTarget;
                            this._cut_copy();
                        }
                    }
                    break;
                case 46:
                case 67:
                case 68:
                case 88:
                case 113:
                    e.preventDefault();
                    this._lastFocusedElement = e.currentTarget;
                    var isPresent = false;
                    if ($(e.currentTarget).hasClass("e-treeview")) {
                        if (this._rootPath != this._currentPath)
                            isPresent = (this._treetag.find(".e-active").length > 0) ? true : false;
                    }
                    else {
                        if ($(e.currentTarget).hasClass("e-tile-wrapper"))
                            isPresent = this.items.hasClass("e-active");
                        else if ($(e.currentTarget).hasClass("e-gridcontent"))
                            isPresent = $(this.gridItems).find("td").hasClass("e-active");
                    }
                    if (isPresent && this._selectedContent && this._toRead) {
                        if (code == 67 && this._toCopy) {
                            if (e.ctrlKey)
                                this._copyMoveNode("copy");
                        }
                        if (this._toEdit) {
                            switch (code) {
                                case 46:
                                    this._deleteFolder();
                                    break;
                                case 68:
                                    if (e.ctrlKey)
                                        this._deleteFolder();
                                    break;
                                case 88:
                                    if (e.ctrlKey)
                                        this._copyMoveNode("move");
                                    break;
                                case 113:
                                    this._renameFolder();
                                    break;
                            }
                        }
                    }
                    break;
                case 93:
                case 121:
                    if ((e.shiftKey || code == 93) && this.model.showContextMenu) {
                        e.preventDefault();
                        this._lastFocusedElement = e.currentTarget;
                        var pos = null, _target, _element;
                        if ($(e.currentTarget).hasClass("e-treeview")) {
                            _element = this._treeObj.getSelectedNode().find(".e-active");
                            pos = this._getMenuPosition(_element);
                            this._treeMenuObj.show(pos.left, pos.top, _element, e, true);
                        }
                        else {
                            if ($(e.currentTarget).hasClass("e-tile-wrapper")) {
                                for (var i = 0; i < this.items.length; i++) {
                                    _element = $(this.items[i]);
                                    if (_element.text() == this._selectedContent) {
                                        pos = this._getMenuPosition(_element);
                                        _target = _element;
                                        break;
                                    }
                                }
                            } else if ($(e.currentTarget).hasClass("e-gridcontent")) {
                                for (var i = 0; i < this.gridItems.length; i++) {
                                    _element = $(this.gridItems[i]).find("td.e-grid-image").next();
                                    if (_element.text() == this._selectedContent) {
                                        pos = this._getMenuPosition(_element);
                                        _target = _element;
                                        break;
                                    }
                                }
                            }
                            if (pos == null) {
                                pos = $(e.currentTarget).offset();
                                _target = $(e.currentTarget);
                            }
                            this._viewMenuObj.show(pos.left, pos.top, _target, e, true);
                        }
                    }
                    break;
            }
        },
        _KeydownEventHandler: function (e) {
            data = { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e };
            return this._trigger('keydown', data);
        },
        _getMenuPosition: function (element) {
            var height = element.outerHeight() / 2;
            var width = element.outerWidth() / 2;
            var pos = element.offset();
            pos = { top: pos.top + height, left: pos.left + width };
            return pos;
        },

        _beforeListHover: function (args) {
            var activeItem = this._getActiveItem();
            if (!activeItem.hasClass("e-disable")) {
                if ($(args.target).hasClass("e-statusbar")) {
                    this.model.layout = activeItem.hasClass("e-switchGridView") ? ej.FileExplorer.layoutType.Grid : ej.FileExplorer.layoutType.LargeIcons;
                    this._switchLayoutView(this.model.layout);
                    this._addFocus(this._statusbar);
                }
                else {
                    var e = { keyCode: 91, shiftKey: args.shiftKey, innerEvent: true, currentTarget: activeItem[0], target: activeItem[0] };
                    this._upDatePathFromTileView(e);
                }
            }
        },
        _getActiveItem: function () {
            return $($(this._itemList)[this._activeItem]);
        },
        _getURL: function () {
            var url = this.model.ajaxAction + "?Path=" + this._pathCorrection(this._currentPath) + "&ActionType=Upload" + (this._selectedContent ? "&SelectedItems=" + JSON.stringify(this._getSelectedItemDetails(this._getFolderPath(), [this._selectedContent])) : "");
            if (this.model.ajaxSettings.upload.url) {
                if (this.model.ajaxSettings.upload.url.indexOf("{") >= 0)
                    url = String.format(this.model.ajaxSettings.upload.url, "?Path=" + this._pathCorrection(this._currentPath) + (this._selectedContent ? "&SelectedItems=" + JSON.stringify(this._getSelectedItemDetails(this._getFolderPath(), [this._selectedContent])) : ""));
                else
                    url = this.model.ajaxSettings.upload.url;
            }
            return url;
        },

        _renderUploadBox: function () {
            var proxy = this;
            var url = this._getURL();
            this._uploadtag.ejUploadbox({
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                height: "0px",
                width: "0px",
                uploadName: "FileUpload",
                /* For Automatic Upload */
                autoUpload: this.model.uploadSettings.autoUpload,
                showFileDetails: !this.model.uploadSettings.autoUpload,

                dialogText: { title: proxy._getLocalizedLabels("Upload") },
                dialogAction: { modal: true, content: proxy.element },
                showRoundedCorner: this.model.showRoundedCorner,
                extensionsAllow: this.model.fileTypes == "*.*" ? "" : this.model.fileTypes.replace(/\*/g, ""),
                multipleFilesSelection: this.model.uploadSettings.allowMultipleFile,
                fileSize: this.model.uploadSettings.maxFileSize,
                buttonText: { browse: "Upload file" },
                saveUrl: url,
                removeUrl: this.model.ajaxAction + "?Path=" + this._currentPath + "&ActionType=Remove",
                locale: ej.Uploadbox.Locale[this.model.locale] ? this.model.locale : "en-US",
                complete: function (e) { proxy._uploadSuccess(e); },
                remove: function (e) { proxy._uploadSuccess(e); },
                fileSelect: function (e) {
                    !proxy._fileExplorer[proxy._currentPath] && proxy._getFileDetails(proxy._currentPath);
                    var targetFiles = proxy._fileExplorer[proxy._currentPath];
                    proxy._existingItems = [];
                    var files = proxy._files = e.files;
                    for (var j = 0; j < files.length; j++) {
                        for (var i = 0; i < targetFiles.length; i++) {
                            if (files[j].name == targetFiles[i].name) {
                                proxy._existingItems.push({ Name: files[j].name, Path: proxy._currentPath + files[j].name, IsReplace: true });
                                break;
                            }
                        }
                    }
                    if (proxy._existingItems.length) {
                        proxy._createReplaceConformationDiaolg("_customUpload", "ReplaceAlert");
                        e.cancel = true;
                    }

                },
                error: function (e) {
                    if (!proxy._alertDialog || !proxy._alertDialog.is(":visible")) {
                        proxy._alertDialog = proxy._createDialog(ej.buildTag('div.e-fe-dialog-label', (e.error ? e.error : e.responseText)), { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error") });
                        proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                    }
                },
                begin: function (e) {
                    var nodes = proxy._currentPath.split('/');
                    var args = { path: proxy._currentPath, selectedItems: proxy._getSelectedItemDetails(proxy._getFolderPath(), nodes[nodes.length - 2]), uploadItemDetails: e.files };
                    if (proxy._trigger("beforeUpload", args))
                        e.cancel = true;
                    proxy._uploadtag.ejUploadbox({ saveUrl: proxy._getURL() });
                },
                cancel: function (e) { proxy._usePreviousValues(); }
            });
        },
        _usePreviousValues: function(){
            if (this._previousPath) {
                this._currentPath = this._previousPath;
                this._selectedContent = this._previousSelectedContent;
                this._previousPath = null;
            }
        },
        _isRestrictedUpload: function (element, text, hoverPath) {
            var path = null;
            if(element.find(".e-fe-lock").length){
                path = hoverPath ? hoverPath : this._getFolderPath(this._updatePath(element, text));
                if (this._fileExplorer[path] && this._fileExplorer[path].length) {
                    for (var i = 0; i < this._fileExplorer[path].length; i++) {
                        if (this._fileExplorer[path][i].name == text && this._fileExplorer[path][i].permission)
                            return !this._fileExplorer[path][i].permission.Upload;
                    }
                }
                return false;
            }
            return false;
        },
        _onDragOverHandler: function (args) {
            var highlightedElement = "";
            var hoverPath = "";
            var element = $(args.target);
            var hoverElementName = element.hasClass("e-js") || element.hasClass("e-tileview") ? "" : element.text();
            args.originalEvent.dataTransfer.dropEffect = "copy";
            args.stopPropagation();
            args.preventDefault();
            if (!element.hasClass("e-file-droppable")) {
                highlightedElement = this._splittag.find(".e-file-droppable");
                highlightedElement && highlightedElement.removeClass("e-file-droppable");                
                if ($(args.currentTarget).hasClass("e-tree-wrapper")) {
                    if (!ej.isNullOrUndefined(element) && element.is('A')) {
                        this._droppableElement = element;
                        this._droppableElement.length && this._droppableElement.addClass("e-file-droppable");
                        var nodeItem = element.closest("li.e-item");
                        if (nodeItem.find(".e-icon").length && !this._treeObj.isExpanded(nodeItem)) {
                            this._expandTimer = window.setTimeout(function () {
                                this._treeObj && this._treeObj.expandNode(nodeItem);
                            }, 800);
                        }
                    }
                    else {
                        args.originalEvent.dataTransfer.dropEffect = "none";
                    }
                }
                else {
                    if (this.model.layout == "grid") {
                        this._droppableElement = element.closest("tr", "table.e-table");
                        if (this._droppableElement.length) {
                            this._droppableElementData = this._gridObj.model.currentViewData[this._gridObj.getIndexByRow(this._droppableElement)];
                            if (this._droppableElementData.isFile) {
                                this._gridtag.find(".e-gridcontent").addClass("e-file-droppable");
                                this._droppableElement = null;
                            }
                        }
                        else
                            this._gridtag.find(".e-gridcontent").addClass("e-file-droppable");
                    }
                    else {
                        this._droppableElement = element.closest("li", ".e-tileview").has(".e-fe-folder");
                        !this._droppableElement.length && this._tileViewWrapper.addClass("e-file-droppable");
                    }
                    this._droppableElement && this._droppableElement.length && this._droppableElement.addClass("e-file-droppable");
                    hoverPath = this._getHoverTreeElementPath(element);
                    if (this._droppableElement && this._droppableElement.length)
                        hoverElementName = (this.model.layout == "grid" ? this._droppableElementData.name : this._droppableElement.find(".e-file-name").text());
                }
            }
            if (this._droppableElement && this._droppableElement.length && this._isRestrictedUpload(this._droppableElement, hoverElementName? hoverElementName: args.target.textContent, hoverPath)) {
                args.originalEvent.dataTransfer.dropEffect = "none";
            }
            var eventArgs = { target: (this._droppableElement && this._droppableElement.length ? this._droppableElement : element), targetElementName: hoverElementName, targetPath: this._getHoverTreeElementPath(element) + hoverElementName };
            this._trigger("drag", eventArgs);
        },

        _getHoverTreeElementPath: function (element) {
            if (element.hasClass("e-text")) {
                return this._updatePath(element, element.text());
            }
            else
            {
                return this._originalPath;
            }
        },

        _onDropHandler: function (args) {
            if ( !args.originalEvent.dataTransfer.files || !args.originalEvent.dataTransfer.files.length)
                return;
            args.stopPropagation();
            args.preventDefault();
            if (this._expandTimer != null) {
                window.clearTimeout(this._expandTimer);
                this._expandTimer = null;
            }
            this.element.find(".e-file-droppable").removeClass("e-file-droppable");
            var uploadObj = this._uploadtag.ejUploadbox("instance");
            if (this._droppableElement && this._droppableElement.length) {
                this._previousPath = this._currentPath;
                this._previousSelectedContent = this._selectedContent;
                if ($(args.currentTarget).hasClass("e-tree-wrapper")) {
                    this._selectedContent = args.target.text;
                    this._currentPath = this._updatePath($(args.target), this._selectedContent);
                }
                else {
                    this._selectedContent = this.model.layout == "grid" ? this._droppableElementData.name : $(args.target).closest("li", "e-tileview").find(".e-file-name").text();
                    this._currentPath = this._originalPath + this._selectedContent + "/";
                }
            }
            else {
                if (this._droppableElement && !this._droppableElement.length) {
                    if (this._isRestrictedUpload(this._selectedNode, this._selectedTreeText, this._getFolderPath(this._originalPath))) {
                        args.originalEvent.dataTransfer.dropEffect = "none";
                        return null;
                    }
                }
                this._currentPath = this._originalPath;
                this._selectedContent = this._selectedTreeText;
            }
            var eventArgs = { dropAction: "upload", fileInfo: args.originalEvent.dataTransfer.files, target: this._droppableElement && this._droppableElement.length ? this._droppableElement : $(args.currentTarget), targetPath: this._currentPath, targetElementName: this._selectedContent };
            if (this._trigger("dragStop", eventArgs))
                return;
            uploadObj._onDropHandler(args);
            var eventArgs = { dropAction: "upload", fileInfo: args.originalEvent.dataTransfer.files, target: this._droppableElement && this._droppableElement.length ? this._droppableElement : $(args.currentTarget), targetPath: this._currentPath, targetFolder: this._selectedContent };
            this._trigger("drop", eventArgs);
        },
        _onDragLeave: function (args) {
            if (this._expandTimer!= null) {
                window.clearTimeout(this._expandTimer);
                this._expandTimer = null;
            }
            if (this._gridtag.find(".e-gridcontent").hasClass("e-file-droppable")||$(args.target).hasClass("e-tile-wrapper") || $(args.target).hasClass("e-gridcontent") || ($(args.target).closest(".e-fileexplorer .e-tile-wrapper") || $(args.target).closest(".e-fileexplorer .e-gridcontent")))
                this.model.layout == "grid" ? this._gridtag.find(".e-gridcontent").removeClass("e-file-droppable") : this._tileViewWrapper.removeClass("e-file-droppable");
        },
        _customUpload: function () {
            for (var i = 0; i < this._existingItems.length; i++) {
                if (!this._existingItems[i].IsReplace) {
                    for (var k = 0; k < this._files.length; k++) {
                        if (this._files[k].name == this._existingItems[i].Name) {
                            this._files.splice(k, 1);
                            break;
                        }
                    }
                }
            }
            this._uploadtag.ejUploadbox({ pushFile: this._files });
        },
        _uploadSuccess: function (args) {
            var oldPath = this._currentPath;
            var uploadedItems = [];
            for (var i = 0; i < args.success; i++) {
                uploadedItems.push(args.success[i].name);
            }
            this.element.find(".e-dialog.e-js .e-action-perform").remove();
            this._fileExplorer[this._currentPath] = "";
            this._treeObj.selectNode(this._selectedNode);
            (oldPath == this._currentPath) && this._setSelectedItems(uploadedItems);
        },
        _preventDrag: function () {
            var items = this._treetag.find("li div a");
            items.removeClass("e-file-draggable");
            if (this.gridItems && this.gridItems.length) {
                $(this.gridItems).removeClass("e-file-draggable");
            }
            if (this.items && this.items.length) {
                this.items.removeClass("e-file-draggable");
            }
        },
        _allowDrag: function () {
            this._gridtag.children(".e-gridcontent").addClass("e-droppable");
            this._tileViewWrapper.addClass("e-droppable");
            var unbindedTreeItems = this._treetag.find("li div a").not(".e-js");
            unbindedTreeItems.length && this._drag(unbindedTreeItems);
            var unbindedGridItems = $(this.gridItems).not(".e-js");
            unbindedGridItems.length && this._drag($(this.gridItems));
            var unbindedTileItems = this.items.not(".e-js");
            unbindedTileItems.length && this._drag(unbindedTileItems);
            var items = this._treetag.find("li div a");
            items.addClass("e-file-draggable");
            if (this.gridItems && this.gridItems.length) {
                $(this.gridItems).addClass("e-file-draggable");
            }
            if (this.items && this.items.length) {
                this.items.addClass("e-file-draggable");
            }
        },
        _drag: function (nodes, area) {
            var _clonedElement, _previousDroppable, hoverElementName, _defaultCursor, _targetNode, _preventDrop, _oldElement, hoverPath, proxy = this;
            nodes.ejDraggable(
           {
               dragOnTaphold: true,
               clone: true,
               dragStart: function (args) {
                   var preventMoveFunction = false;
                   proxy._previousElement = proxy._selectedNode;
                   if ($(args.target).hasClass("e-text")) {
                       preventMoveFunction = true;
                       proxy._copiedNodes = [$(args.target).text()];
                       proxy._option = "move";
                       proxy._sourcePath = proxy._getFolderPath(proxy._getHoverTreeElementPath($(args.target)));
                       proxy._sourceType = "Directory";
                       proxy._fileName = $(args.target).text();
                       proxy._refreshNode = $(args.target).closest("li");
                   }
                   else {
                       if (proxy.model.selectedItems.length <= 1) {
                           if (proxy.model.layout == "grid") {
                               proxy._gridObj.selectRows($(args.target).closest("tr").index());
                           }
                           else {
                               proxy._triggerClick(args.target);
                           }
                       }
                   }
                   if (!proxy.model.selectedItems.length) {
                       if ($(args.target).hasClass("e-text")) {
                           hoverElementName = args.target.textContent;
                       }
                       if (args.target && hoverElementName && proxy._isRestrictedMove(args.element, hoverElementName, "")) {
                           _clonedElement.remove();
                           args.cancel = true;
                           return null;
                       }
                   }
                   else {
                       for (var i = 0; i < proxy.model.selectedItems.length ; i++) {
                           if (args.target && proxy._isRestrictedMove(args.element, proxy.model.selectedItems[i], proxy.model.selectedFolder)) {
                               _clonedElement.remove();
                               args.cancel = true;
                               return null;
                           }
                       }
                   }
                   !preventMoveFunction && proxy._copyMoveNode("move");
                   proxy._previousElement.find("a").eq(0).click();
                   var eventArgs = { target: args.element, targetPath: proxy._currentPath, selectedItems: proxy._getSelectedItemDetails(proxy._sourcePath, proxy._fileName) };
                   proxy._trigger("dragStart", eventArgs);
               },
               drag: function (args) {
                   var timeDelay, _oldElement = _targetNode;
                   var target =  $(args.target).closest(".e-droppable", ".e-fileexplorer");
                   if ($(args.target).hasClass("e-droppable")) {
                       _targetNode = $(args.target);
                   }
                   else if (target.length) {
                       _targetNode = target;
                   }
                   else if ($(args.target).hasClass("e-text"))
                       _targetNode = $(args.target).find(".e-droppable");
                   else
                       proxy._clearExpand($(args.target).closest("li.e-item"));
                   document.body.style.cursor = 'no-drop';
                   if (_previousDroppable)
                       _previousDroppable.style.cursor = _defaultCursor;
                   _previousDroppable = args.target;
                   _defaultCursor = args.target.style.cursor;
                   $(_clonedElement).css({ "margin-left": "10px" });
                   if (_targetNode && _oldElement && _targetNode.hasClass("e-draggable")) {
                       if (_targetNode.text() != _oldElement.text()) {
                           var nodeItem = $(args.target).closest("li.e-item");
                           proxy._clearExpand(nodeItem);
                           if (nodeItem && nodeItem.find(".e-icon").length && !proxy._treeObj.isExpanded(nodeItem)) {
                               proxy._expandTimer = window.setTimeout(function () {
                                   proxy._treeObj && proxy._treeObj.expandNode(nodeItem);
                               }, 800);
                           }
                           clearTimeout(timeDelay);
                           timeDelay = setTimeout(function () {
                               if ($(_previousDroppable).hasClass("e-text")) {
                                   proxy._needToScroll($(_previousDroppable).closest("li"), "Tree");
                               }
                               else {
                                   _targetNode && proxy._needToScroll($(_targetNode), "");
                               }
                           }, 100);
                       }
                       args.target.style.cursor = "pointer";
                   }
                   else {
                       args.target.style.cursor = "no-drop";
                   }
                   if ($(_previousDroppable).hasClass("e-text")) {
                       hoverElementName = _previousDroppable.textContent;
                       hoverPath = "";
                   }
                   else {
                       hoverElementName = proxy.model.layout == "grid" ? (_targetNode ? _targetNode.find("[data-cell='" + proxy._gridObj.getColumnByField("name").headerText + "']").text() :"") : (_targetNode ? (_targetNode.hasClass("e-tile-wrapper") ? "" : _targetNode.text()) : "");
                       hoverPath = proxy._getHoverTreeElementPath($(_previousDroppable));
                   }
                   if (_previousDroppable && proxy._isRestrictedMove(_targetNode, hoverElementName, hoverPath)) {
                       args.target.style.cursor = "no-drop";
                       _preventDrop = true;
                   }
                   else
                       _preventDrop = false;
                   if (hoverPath + (hoverElementName ? (hoverElementName + "/") : "") != proxy._sourcePath)
                       args.target.style.cursor = "pointer";
                   var eventArgs = { target: (_targetNode && _targetNode.length ? _targetNode : $(args.target)), targetElementName: hoverElementName, targetPath: (hoverPath ? hoverPath : proxy._originalPath ) + hoverElementName };
                   proxy._trigger("drag", eventArgs);
               },
               dragStop: function (args) {
                   var isWrapper= false;
                   if(proxy.model.layout == "grid"){
                       isWrapper = ($(args.target).hasClass("e-gridcontent") || ($(args.target).find("table").length && $(args.target).closest(".e-gridcontent", ".e-fileexplorer").length));
                   }
                   else{
                       isWrapper = ($(args.target).hasClass("e-tileview") || ($(args.target).find(".e-tileview").length && $(args.target).closest(".e-fileexplorer").length));
                   }
                   if (isWrapper && proxy._sourcePath == proxy._originalPath)
                       proxy._activeSource = proxy.model.selectedItems;
                   if (isWrapper) {
                       proxy._setSelectedItems([]);
                       if (ej.isNullOrUndefined(proxy._copiedNodes) || !args.element.hasClass("e-file-draggable"))
                           return;
                       _clonedElement.hide();
                       proxy.element.find(".e-blur").removeClass("e-blur");
                       if (proxy._currentPath == proxy._sourcePath + proxy._fileName + "/")
                           return;
                       proxy._cut_copy();
                       _clonedElement && _clonedElement.remove();
                   }
                   if (proxy._expandTimer != null) {
                       window.clearTimeout(proxy._expandTimer);
                       proxy._expandTimer = null;
                   }
                   if (_previousDroppable)
                    _previousDroppable.style.cursor = _defaultCursor;
                   document.body.style.cursor = '';
                   proxy.element.find(".e-blur").removeClass("e-blur");
                   if (!args.element.dropped && ((($(args.event.target).hasClass('e-tree-wrapper') || $(args.event.target).parents('.e-tree-wrapper').length > 0) && !$(args.event.target).is('a'))
                       || (!$(args.event.target).hasClass("e-tile-wrapper") && !$(args.event.target).parents(".e-tile-wrapper").length > 0 && !$(args.event.target).hasClass("e-gridcontent") &&
                       !$(args.event.target).parents(".e-gridcontent").length > 0 && !$(args.event.target).hasClass('e-tree-wrapper') && !$(args.event.target).parents('.e-tree-wrapper').length > 0))) {
                       _clonedElement && _clonedElement.remove();
                   }
                   var eventArgs = { dropAction: "move", fileInfo: proxy._getSelectedItemDetails(proxy._sourcePath, proxy._copiedNodes), target: (_targetNode && _targetNode.length ? _targetNode : $(args.target)), targetElementName: proxy._selectedContent, targetPath: proxy._currentPath };
                   proxy._trigger("dragStop", eventArgs);
               },
               helper: function (event, ui) {
                   var _draggedElement, imgTag, innerEle, itemCount;
                   if (!ej.isNullOrUndefined(event.element)) {
                       if (!event.element.hasClass("e-file-draggable")) {
                           event.cancel = true;
                           return null;
                       }
                       if (proxy) {
                           _clonedElement = ej.buildTag('div.e-dragedNode e-fe');
                           var maxZ = ej.util.getZindexPartial(proxy.element);
                           _clonedElement.css({ "z-index": maxZ });
                           _clonedElement.addClass(proxy.model.cssClass + (proxy.model.enableRTL ? ' e-rtl' : ''));
                           _draggedElement = $(event.element).clone().addClass("dragClone");
                           imgTag = _draggedElement.find("img")
                           if (imgTag.length) {
                               innerEle = ej.buildTag('img.e-thumbImage', "", "", { src: imgTag.attr("src") });
                           } else {
                               innerEle = ej.buildTag('span', "", "", { "class": _draggedElement.find(".e-fe-icon").attr("class") });
                           }
                           if (proxy.model.selectedItems.length > 1) {
                               itemCount = ej.buildTag('div.e-count');
                               itemCount.text(proxy.model.selectedItems.length);
                               _clonedElement.append(itemCount);
                           }
                           _clonedElement.append(innerEle);
                           return _clonedElement.appendTo($("body"));
                       }
                   }
               }
           });
            nodes.ejDroppable({
                accept: nodes,
                drop: function (args, ui) {
                    if (_preventDrop || ej.isNullOrUndefined(proxy._copiedNodes) || !ui.draggable.hasClass("e-file-draggable"))
                        return;
                    $(ui.helper).hide();
                    var successCallback = function (preventClick) {
                        !preventClick && proxy._clickTarget(args);
                        if (proxy._currentPath == proxy._sourcePath + proxy._fileName + "/")
                            return;
                        var selectedFileDetails = proxy._getSelectedItemDetails(proxy._sourcePath, proxy._fileName);
                        proxy._cut_copy(true);
                        var eventArgs = { dropAction: "move", fileInfo: selectedFileDetails, target: $(args.dropTarget), targetPath: proxy._currentPath, targetFolder: proxy._selectedContent };
                        proxy._trigger("drop", eventArgs);
                    }
                    if (proxy.model.layout == "grid" && !$(args.dropTarget).hasClass("e-text")) {
                        proxy._gridObj.selectRows($(args.dropTarget).closest("tr").index());
                        successCallback(true);
                    }
                    else {
                        var treePath = proxy._getHoverTreeElementPath($(args.dropTarget));
                        !proxy._fileExplorer[treePath] ? proxy._getFileDetails(treePath, "", "", successCallback) : successCallback();
                    }
                    if ($("body").find('.e-dragedNode').length > 0) $("body").find('.e-dragedNode').remove();
                }
            });
        },

        _clickTarget: function (args) {
            if (!$(args.dropTarget).hasClass("e-text")) {
                if (this.model.layout == "grid") {
                    var index = $(args.dropTarget).closest("tr").index();
                    (index >= 0) ? this._gridObj.selectRows($(args.dropTarget).closest("tr").index()) : $(args.dropTarget).click();
                }
                else
                    this._triggerClick(args.dropTarget);
            }
            else
                this._treeObj && this._treeObj.selectNode(args.dropTarget);
        },

        _triggerClick: function (ele) {
            var tnode = $(ele).closest(".e-tilenode");
            (tnode.length > 0 && this._isDevice && $.isFunction($.fn.tap)) ? $(ele).trigger("tap") : $(ele).click();
        },

        _clearExpand: function (node) {
            if (this._expandTimer != null) {
                window.clearTimeout(this._expandTimer);
                this._expandTimer = null;
            }
        },
        
        _isRestrictedMove: function (element, text, hoverPath) {
            var path = null;
            if (element && element.find(".e-fe-lock").length) {
                path = hoverPath ? hoverPath : this._getFolderPath(this._updatePath(element, text));
                if (this._fileExplorer[path] && this._fileExplorer[path].length) {
                    for (var i = 0; i < this._fileExplorer[path].length; i++) {
                        if (this._fileExplorer[path][i].name == text && this._fileExplorer[path][i].permission)
                            return !this._fileExplorer[path][i].permission.Copy;
                    }
                }
                return false;
            }
            return false;
        },
        _createAddressBar: function () {
            this._addresstag = ej.buildTag('input.e-addressBar e-tool-input', "", {}, { id: this._ExplorerId + '_addressbar', type: "text" });
            this._addresstag.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Addressbar").html(""));
            var spanTag = $("<span class='e-fe-icon e-fe-folder'></span>");
            spanTag.insertBefore(this._addresstag);
            ej.browserInfo().name == "msie" && ej.ieClearRemover(this._addresstag[0]);
            this._addressBarEvents("_on");
        },
        _addressBarEvents: function (action) {
            this[action]($('#' + this._ExplorerId + '_addressbar'), "focus", this._inputFocusin);
            this[action]($('#' + this._ExplorerId + '_addressbar'), "keydown", this._searchPath);
            this[action]($('#' + this._ExplorerId + '_addressbar'), "blur", this._addressbarFocusout);
        },
        _inputFocusin: function (e) {
            $(e.target).select();
        },
        _updateAddressBar: function () {
            if (this._addresstag) {
                var temp = this._currentPath;
                this._addresstag.val(temp.replace(this._initPath, ""));
            }
        },
        _onEpand: function (args) {
            if (this._splitObj.element.find(".e-cont1").hasClass("collapsed")) {
                if (this._splitIcon && this._splitIcon.find('.e-icon').hasClass("e-arrow-sans-left"))
                    this._splitIcon.find('.e-icon').addClass('e-arrow-sans-right').removeClass("e-arrow-sans-left");
            }
            else {
                if (this._splitIcon && this._splitIcon.find('.e-icon').hasClass("e-arrow-sans-right"))
                    this._splitIcon.find('.e-icon').addClass('e-arrow-sans-left').removeClass("e-arrow-sans-right");
            }
            this._reSizeHandler(args);
        },
        _createSplitPane: function () {
            var proxy = this;
            var pane1 = ej.buildTag('div');
            var pane2 = ej.buildTag('div');
            this._splittag = ej.buildTag('div#' + this._ExplorerId + '_splitter');
            pane1.addClass('e-cont1');
            pane2.addClass('e-cont2');
            this.model.enableRTL ? this._splittag.append(pane2, pane1) : this._splittag.append(pane1, pane2);
            var panesize = this.model.enableRTL ? [{}, { paneSize: this._isMobileOrTab ? "150px" : "25%" }] : [{ paneSize: this._isMobileOrTab ? "150px" : "25%" }, {}];
            this.element.append(this._splittag);
            this._splitObj = this._splittag.ejSplitter({
                enableAutoResize: true,
                animationSpeed: 50,
                width: "100%",
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                allowKeyboardNavigation: this.model.allowKeyboardNavigation,
                height: this.element.height() - (this._toolBarItems ? this._toolBarItems.outerHeight() : 0),
                properties: panesize,
                expandCollapse: function (e) { proxy._onEpand(e); },
                resize: function (e) { proxy._reSizeHandler(e); }
            }).data('ejSplitter');
            var splitbar = this._splitObj.element.find(".e-splitbar");
            var borderWidth = splitbar.css("border-width");
            var splitterWidth = splitbar.css("width");
            splitbar.css({"width" : "0px", "border-width": "0px" });
            this._splitObj.refresh();
            splitbar.css({ "width": splitterWidth, "border-width": borderWidth });
            this._renderSplitIcon();
            var treeWrapper = ej.buildTag('div.e-tree-wrapper');
            pane1.append(treeWrapper);
            this._treetag = ej.buildTag('div#' + this._ExplorerId + '_treeView');
            treeWrapper.append(this._treetag);
            this._gridtag = ej.buildTag('div#' + this._ExplorerId + '_grid');
            pane2.append(this._gridtag);
            this._tileViewWrapper = ej.buildTag('div.e-tile-wrapper' + "#" + this._ExplorerId + '_tileWrapper', "", "", { tabindex: 0 });
            if (this.model.layout == "tile")
                this._tileViewWrapper.addClass("e-tileInfo-view");
            pane2.append(this._tileViewWrapper);
            this._tileViewWrapper.append("<div class='e-tile-content' > </div>");
            this._tileContent = this._tileViewWrapper.find(".e-tile-content");
            this._tileView = ej.buildTag('ul#' + this._ExplorerId + '_tileView');
            this._tileContent.append(this._tileView);

            this._statusbar = ej.buildTag('div', "", "", { tabindex: 0 });
            this._statusbar.insertAfter(this._tileView);
            pane2.append(this._statusbar);
            this.model.showFooter && this._createStatusBar();
            this._waitingPopup = this._splittag.find(".e-cont2").ejWaitingPopup({ showOnInit: false, cssClass: this.model.cssClass }).data("ejWaitingPopup");
            this._showHideSplitBar(false);
            this._showHideContextMenu();
            if (this.model.layout == "grid") {
                this._tileContent.parent().hide();
            }
            else {
                this._gridtag.hide();
            }
            this._createUploadBox();

        },
        _selectedFolder: function (targetNavigationPath) {
            this._isClicked = false;
            var navigationPath = targetNavigationPath.replace(this._initPath, "");
            var selectedNode = this._treeObj.getSelectedNode();          
            var folders = navigationPath.split("/");
            navigationPath && this._treeObj.selectNode(this._treeObj.element.find("li:first"));
            for (var j = 0; j < folders.length; j++) {
                if (folders[j] != "") {
                    selectedNode = this._treeObj.getSelectedNode();
                    if (!this._treeObj.isExpanded(selectedNode))
                        this._treeObj && this._treeObj.expandNode(selectedNode);
                    var childItems = selectedNode.find('ul:first>li').find('div:first .e-text');
                    for (var i = 0; i < childItems.length; i++) {
                        if (childItems[i].text == folders[j]) {
                            var newFolders = folders.filter(function (val) { return val != ""; });
                            if (newFolders[newFolders.length - 1] == childItems[i].text)
                                this._isClicked = true;
                            this._treeObj.selectNode(childItems[i].parentNode.parentNode);
                        }
                    }
                }
            }
            this._isClicked = true;
        },
        _setSelectedItems: function (selectedItems) {
            var realName;
            if (this._suggestionItems.length) {
                realName = selectedItems;
                selectedItems = this._selectedItems;
            }
            if (typeof selectedItems == "string")
                selectedItems = [selectedItems];
            this._removeOldSelectionDetails();
            if (this.model.layout == "grid") {
                this._gridObj.clearSelection();
                var _ctrlKey = this._gridObj.multiSelectCtrlRequest;
                this._gridObj.multiSelectCtrlRequest = true;
                var nodes = this._gridtag.find(".e-gridcontent tr");
                for (var j = 0; j < selectedItems.length; j++) {
                    var nodes = $("#" + this._ExplorerId + " .e-gridcontent td:contains(" + (realName ? realName[j] : selectedItems[j]) + ")");
                    for (var i = 0; i < nodes.length; i++) {
                        if (this._suggestionItems.length ? this._originalPath + selectedItems[j] == $(nodes[i]).closest("tr").attr("data-parent-path") + $(nodes[i]).text()  : selectedItems[j] == $(nodes[i]).text()) {
                            this._gridObj.selectRows($(nodes[i]).closest("tr").index());
                            break;
                        }
                    }
                }
                this._recordClick();
                this._gridObj.multiSelectCtrlRequest = _ctrlKey;
            }
            else {
                this.items.removeClass("e-active").attr("aria-selected", false);
                var nodes = this._tileView.find(".e-tilenode");
                for (var j = 0; j < selectedItems.length; j++) {
                    for (var i = 0; i < nodes.length; i++) {
                        var name = this.model.layout == "tile" ? $(nodes[i]).find(".e-file-name").text() : $(nodes[i]).text();
                        if (this._suggestionItems.length ? this._originalPath + selectedItems[j] == $(nodes[i]).attr("data-parent-path") + name : selectedItems[j] == name) {
                            var e = { keyCode: 91, ctrlKey: true, currentTarget: nodes[i], target: nodes[i] };
                            this._upDatePathFromTileView(e);
                            break;
                        }
                    }
                }
            }
        },
        _refreshTreeScroller: function (args) {
            if (ej.isNullOrUndefined(this.element)) return;
            if (this.model.enableRTL) {
                this._treeScroll.model.scrollLeft = 0;
            }
            this._treeScroll && this._treeScroll.refresh();
        },
        _createStatusBar: function () {
            this._statusbar.addClass("e-statusbar");
            this._itemStatus = ej.buildTag('div.e-itemStaus');
            this._selectedItemsTag = ej.buildTag('div.e-itemStaus e-selected-items');
            this._switchBtn = ej.buildTag('div.e-switchView');
            this._statusbar.append(this._switchBtn, this._itemStatus, this._selectedItemsTag);
            if (this.model.enableResize) {
                this._resizeItem = ej.buildTag("div.e-icon e-fe-resize e-resize-handle");
                this._resizeItem.insertBefore(this._switchBtn);
            }
            var setHeight = this._splittag.find(".e-cont2").outerHeight() - this._statusbar.outerHeight();
            this._gridtag.height(setHeight);
            var button = ej.buildTag('button.e-switchGridView#' + this._ExplorerId + '_switchGridView', "", {}, { title: this._getLocalizedLabels("Grid"), tabindex: 0 });
            this._switchBtn.append(button);
            button.ejButton({ type: "button",  size: "normal", contentType: "imageonly", prefixIcon: "e-icon e-fe-grid" });
            button = ej.buildTag('button.e-swithListView#' + this._ExplorerId + '_swithListView', "", {}, { title: this._getLocalizedLabels("LargeIcons"), tabindex: 0 });
            this._switchBtn.append(button);
            button.ejButton({ type: "button",  size: "normal", contentType: "imageonly", prefixIcon: "e-icon e-fe-largeicons" });
            this.model.layout == "grid" && this._statusbar.find(".e-switchGridView").addClass("e-active");
            this.model.layout == "largeicons" && this._statusbar.find(".e-swithListView").addClass("e-active");
            this._statusBarEvents("_off");
            this._statusBarEvents("_on");
        },
        _statusBarEvents: function (action) {
            this[action](this._statusbar, "focus", this._focusStatusBar);
            this[action](this._statusbar.find("button"), "focus", this._focusStatusBarButton);
            this[action](this._statusbar.find("button"), "blur", this._blurStatusBarButton);
            this[action](this._statusbar, "blur", this._blurStatusBar);
            this.model.allowDragAndDrop && this[action](this._statusbar, "dragover", this._preventDropOption);
        },
        _focusStatusBar: function (e) {
            if (!this._statusbar.hasClass("e-focus")) {
                this._statusbar.addClass("e-focus");
                this._itemList = this._switchBtn.find("button");
                this._on(this._statusbar, "keydown", this._OnKeyDown);
                this._hidePopup();
            }
        },
        _focusStatusBarButton: function(args){
            this._on(this._statusbar.find("button"), "keydown", this._check);
        },
        _blurStatusBarButton: function (args) {
            this._off(this._statusbar.find("button"), "keydown", this._check);
        },
        _blurStatusBar: function (e) {
            this._statusbar.removeClass("e-focus");
            this._off(this._statusbar, "keydown", this._OnKeyDown);
        },
        _check: function (args) {
			var changed;
			if (this.model.layout == ej.FileExplorer.layoutType.Grid) {
                this.model.layout = ej.FileExplorer.layoutType.LargeIcons;
                changed = true;
            }
			else if (this.model.layout == ej.FileExplorer.layoutType.LargeIcons) {
                this.model.layout = ej.FileExplorer.layoutType.Grid;
                changed = true;
			}
			if (changed) {
                this._switchLayoutView();
            }
        },
        _refreshResizeHandler: function () {
            this._setMinMaxSizeInInteger();
            this.adjustSize();
            if (this.model.showFooter && this.model.enableResize)
                this._resizeFileExplorer();
        },
        _refreshResizeEventHandler: function (event) {
            var reElement = $(event.element).parents("div.e-fileexplorer");
            this.model.height = $(reElement).outerHeight();
            this.model.width = $(reElement).outerWidth();
            this.element.css({ "height": this.model.height, "width": this.model.width });
            this.adjustSize();
        },
        _convertPercentageToPixel: function (parent, child) {
            return Math.round((child * parent) / 100);
        },
        _getProperValue: function (value) {
            if (value == null) return null;
            else return !isNaN(value) ? value : value;
        },
        _setMinMaxSizeInInteger: function () {
            var parentObj;
            this._minWidth = parseInt(this.model.minWidth);
            this._minHeight = parseInt(this.model.minHeight);
            this._maxWidth = parseInt(this.model.maxWidth);
            this._maxHeight = parseInt(this.model.maxHeight);
            parentObj = this.element.parent()[0].nodeName == "BODY" ? $(window) : $(this.element.parent()[0]);
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                this._minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), this._minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                this._minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), this._minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                this._maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), this._maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                this._maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), this._maxHeight);
        },
        _resizeFileExplorer: function () {
            var proxy = this;
            this.element.find("div.e-fe-resize").ejResizable(
                {
                    minHeight: proxy._minHeight,
                    minWidth: proxy._minWidth,
                    maxHeight: proxy._maxHeight,
                    maxWidth: proxy._maxWidth,
                    resizeStart: function (event) {
                        proxy._trigger("resizeStart", { event: event });
                    },
                    resize: function (event) {
                        proxy._refreshResizeEventHandler(event);
                        proxy._trigger("resize", { event: event });                       
                    },
                    resizeStop: function (event) {
                        proxy._refreshResizeEventHandler(event);
                        proxy._trigger("resizeStop", { event: event });
                    },
                    helper: function (event) {
                        return $(proxy.element);
                    }
                });
        },
        _showHideSplitBar: function (option) {
            this._splittag.show();
            if (this._splitObj.model.properties[1].paneSize == 0) {
                this.element.find(".e-splitbar").show();
                this._splitObj.expand(1);
                if (!this._gridtag.hasClass("e-grid") && option) {
                    this._updateData();
                }
            }
            else if (this._splitObj.model.properties[0].paneSize == 0) {
                this.element.find(".e-splitbar").show();
                this._splitObj.expand(0);
                this._treetag.parent(".e-tree-wrapper").css("display", "block");
            }
            if (!this.model.showNavigationPane) {
                this.model.enableRTL?this._splitObj.collapse(1):this._splitObj.collapse(0);
                this.element.find(".e-splitbar").hide();
                if (!this._gridtag.hasClass("e-grid") && option) {
                    this._updateData();
                }
            }
        },
        _updateTreePath: function (args) {
            this._suggestionItems = [];
            this._toDownload = false; this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
            this._removeBlurEffect();
            this._searchbar && this._searchbar.val("");
            this._selectedTreeText = this._selectedContent = args.value;
            this._selectedNode = args.currentElement;
            var node = $(this._selectedNode.parents('li.e-item')[0]);
            this._parentNode = node.length != 0 ? node : this._selectedNode;
            this._nodeType = "Directory";
            if (this._initUpdate) {
                this._currentPath = this._updatePath(args.currentElement, args.value);
            } else
                this._initUpdate = true;            
            this._updateOnNodeSelection && this._updateData();
            this._originalPath = this._currentPath;
            if (!this._isStateNavigation) {
                if (!ej.isNullOrUndefined(this._currentState)) {
                    for (var i = this._selectedStates.length - 1; i > this._currentState; i--)
                        this._selectedStates.pop();
                    this._toolBarItems && this._disableToolbarItem("Forward");
                }
                if (this._selectedStates[this._selectedStates.length - 1] != this._originalPath) {
                    this._currentState = this._selectedStates.length;
                    this._selectedStates.push(this._originalPath);
                    this._selectedStates.length == 2 && this._toolBarItems && this._enableToolbarItem("Back");
                }
            }
            this._updateAccessRules(this._originalPath);
            this._updateToolbarItems();
            this._updateNewFolderTool(this._toRead && this._toEditContents);
            if (!node.length) {
                this._disableEditingTools();
                this._toolBarItems && this._disableToolbarItem("Copy");
            }
            this.model.selectedFolder = this._currentPath;
            this._updateAddressBar();
            this._currntNode = this._selectedNode.find("> div > .e-text");
            this.model.selectedItems = [];
            this._filteredItemsName = [];
            this._selectedItems = [];
            this._selectedTileItems = [];
            var parentPath = this._getFolderPath();
            if (this._isClicked) {
                var args = { name: [args.value], names: [args.value], path: parentPath, nodeType: this._nodeType, selectedItems: this._getSelectedItemDetails(parentPath, this._selectedContent) };
                this._trigger("select", args);
            }
        },
        _modifySelectedStates: function (startsWith, replace) {
            var proxy = this;            
            $.each(proxy._selectedStates, function (index, path) {
                if (path && path.startsWith(startsWith))
                    proxy._selectedStates[index]= (replace ? proxy._selectedStates[index].replace(startsWith, replace): replace);                                                            
            });            
        },
        _onBeforeCollapse: function (args) {           
           this._collapse = true;
        },
        _updatePath: function (node, val) {
            var parentPath = "";
            var unnecesaryULtags = 1;
            for (var i = 0; i < node.parents("ul").length - unnecesaryULtags; i++) {
                if ($(node.parents("ul")[i]).siblings("div").find("a").text())
                    parentPath = $(node.parents("ul")[i]).siblings("div").find("a").text() + "/" + parentPath;
            }
            return this._initPath + parentPath + val + "/";
        },
        _updatePathFromGrid: function (args) {
            if (!(this._searchbar && $.trim(this._searchbar.val())))
                this._suggestionItems = [];
            if (this.model.showCheckbox && this._changeCheckState) {
                if (!this.model.allowMultiSelection) {
                    this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ "checked": false });
                }
                $(args.target).closest(".e-chkbox-wrap").length && this._checkChange(args.row);
                if ((args.target && $(args.target).closest(".e-chkbox-wrap").length == 0) || ej.isNullOrUndefined(args.target))
                    this._recordClick();
            }
            this._FilteredFiles = [];
            var proxy = this, target = $(args.target).closest("td.e-rowcell");
            this._addFocus(this._gridtag.find(".e-gridcontent"));
            var isFolder, _isUpdate = true;
            this._toDownload = this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
            this._isTreeNode = false;
            var _childItems;
            this._selectedItems = [];
            var sizeInByte = 0;
            this._selectedRecords = this._gridtag.ejGrid("getSelectedRecords");
            var index = $.inArray(undefined, this._selectedRecords);
            if (index > -1)
                this._selectedRecords.splice(index, 1);
            for (var record = 0; record < this._selectedRecords.length; record++) {
                if (this._suggestionItems && this._suggestionItems.length) {
                    name = this._selectedRecords[record].filterPath.replace(this._originalPath, "") + this._selectedRecords[record].name;
                    this._selectedItems.push(name);
                    var filename = this._selectedRecords[record].filterPath + this._selectedRecords[record].name;
                    if ($.inArray(filename, this._FilteredFiles) < 0) this._FilteredFiles.push(this._selectedRecords[record].filterPath + this._selectedRecords[record].name);
                }
                else
                    this._selectedItems.push(this._selectedRecords[record].name);
                sizeInByte += this._selectedRecords[record].sizeInByte;
                if (!this._selectedRecords[record].isFile) {
                    _isUpdate = false;
                    this._toDownload = false;
                }
                this._updateAccessValue(this._selectedRecords[record]);
            }
            if (this._currentPath != this._originalPath) {
                this._currentPath = this._originalPath;
            }
            $.each((proxy._suggestionItems.length > 0 ? proxy._suggestionItems : proxy._fileExplorer[proxy._originalPath]), function (index, value) {
                if (value.name == args.data.name && !value.isFile)
                    isFolder = true;
            });
            if (isFolder) {
                this._nodeType = "Directory";
                if (target.hasClass('e-active'))
                    this._updateNode(args.data.name);
            }
            else {
                this._nodeType = "File";
            }
            var _nodeType = this._nodeType;
            this._currntNode = target[0] != null && target.parent("tr");
            this._selectedContent = this._selectedItems[this._selectedItems.length - 1];
            if (!target.hasClass('e-active') && this._selectedRecords.length > 0) {
                this._selectedContent = this._selectedItems[this._selectedItems.length - 1];
                this._nodeType = this._selectedRecords[this._selectedRecords.length - 1].isFile ? "File" : "Directory";
                if (this._nodeType == "Directory")
                    this._updateNode(this._selectedContent);
            }
            this._selectedItemsTag && this._selectedItemsTag.html((this._selectedItems.length > 0 ? (this._selectedItems.length + " " + (this._selectedItems.length > 1 ? this._getLocalizedLabels("Items") : this._getLocalizedLabels("Item")) + " " + this._getLocalizedLabels("Selected")) : "") + (sizeInByte ? (_isUpdate ? "  " + this._bytesToSize(sizeInByte) : "") : ""));
            this._setFilteredItemsName();
            this.model.selectedItems = this._filteredItemsName;
            var data = { name: this._selectedItems, names: this._selectedItems, path: this.model.selectedFolder, nodeType: this._nodeType, selectedItems: this._getSelectedItemDetails(this.model.selectedFolder, this._filteredItemsName) };
            this._urlTag && this._urlTag.find("input").val(data.path);
            this._nameTag && this._nameTag.find("input").val(data.name);
            this._updateSelectionDetails(this._nodeType);
            if (this._isClicked)
                if (!args.target || (target && target.hasClass("e-active")))
                    this._trigger("select", data);
                else {
                    var name = (this._suggestionItems && this._suggestionItems.length) ? (args.data.filterPath.replace(this._originalPath, "") + args.data.name) : args.data.name;
                    var data = { name: name, names: [name], path: this.model.selectedFolder, nodeType: _nodeType, unselectedItem: args.data, unselectedItems: [args.data] };
                    this._trigger("unselect", data);
                }
        },
        _enableEditingTools: function () {
            if (!this._editingToolsState && this._toolBarItems) {
                var items = ["Rename", "Delete", "Cut"];
                for (var i = 0; i < items.length; i++) {
                    this._enableToolbarItem(items[i]);
                }
                this._editingToolsState = true;
            }
        },
        _enableToolbarItem: function (suffixID) {
            if (this._restrictedToolbarOptions.indexOf(suffixID) < 0)
            {
                var id = this._ExplorerId + suffixID.replace(/ /g, '');
                if (this._toolBarObj && this._toolBarObj.itemsContainer.find("li#" + id).hasClass("e-disable"))
                    this._toolBarObj.enableItemByID(id);
            }            
        },
        _disableToolbarItem: function (suffixID) {
            var id = this._ExplorerId + suffixID.replace(/ /g, '');
            if (this._toolBarObj && !this._toolBarObj.itemsContainer.find("li#" + id).hasClass("e-disable"))
                this._toolBarObj.disableItemByID(id);
        },

        _disableEditingTools: function () {
            if (this._toolBarItems) {
                var items = ["Rename", "Delete", "Cut"];
                for (var i = 0; i < items.length; i++) {
                    this._disableToolbarItem(items[i]);
                }
                this._editingToolsState = false;
            }
        },
        _clearTileCheckBoxSelection: function () {
            if (this.model.showCheckbox) {
                this._tileView.find(".e-tile-checkbox ").ejCheckBox({ "checked": false });
            }
        },
        _upDatePathFromTileView: function (event) {
            var $target = $(event.target);
            if (event["pointerType"] == "touch" && this._customPop != null && this.model.allowMultiSelection) {
                if (!this._customPop.is(":visible"))
                    this._customPop.show();
                if (this._customPop.is(":visible") && !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) {
                    var offset = $target.offset();
                    this._customPop.offset({ left: offset.left - 40, top: offset.top - 40 });
                }
                else
                    event.ctrlKey = true;
            }
            else
                this._hidePopup();
            if (!(this._searchbar && $.trim(this._searchbar.val())))
                this._suggestionItems = [];
            if (!event.innerEvent)
                this._lastItemIndex = $(event.currentTarget).index();
            this._addFocus(this._tileViewWrapper);
            this._isTreeNode = false;
            var proxy = this;
            var checkboxObj;
            if(this.model.showCheckbox){
                checkboxObj = $(event.target).closest(".e-tilenode").find(".e-tile-checkbox").data("ejCheckBox");
                if ($(event.target).hasClass("e-chk-image"))
                    event.ctrlKey = this.model.showCheckbox;
            }
            if (!event.shiftKey) {
                var _unselectedItem = [];
                if (!event.ctrlKey || !this.model.allowMultiSelection) {
                    this._sizeInByte = 0;
                    this._selectedItems = [];
                    this._selectedTileItems = [];
                    $(event.currentTarget).siblings().removeClass("e-active").attr("aria-selected", false);
                    $(event.currentTarget).removeClass("e-active").attr("aria-selected", false);
                    this._clearTileCheckBoxSelection();
                    this._unselectEvent();
                }
                if ($(event.currentTarget).hasClass("e-active")) {
                    $(event.currentTarget).removeClass("e-active").attr("aria-selected", false);
                    checkboxObj && checkboxObj.option("checked", false);
                }
                else {
                    $(event.currentTarget).addClass("e-active").attr("aria-selected", true);
                    checkboxObj && checkboxObj.option("checked", true);
                }
                var nodeType = "File", _childItems, _isUpdate = true;
                this._toDownload = this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
                var name = $(event.currentTarget).find(".e-file-name").text();
                if (this._currentPath != this._originalPath) {
                    this._currentPath = this._originalPath;
                }
                var items = this._suggestionItems.length ? this._suggestionItems : this._fileExplorer[this._originalPath];
                if (items) {
                    for (var i = 0; i < items.length; i++) {
                        if ((this._suggestionItems < 1 && items[i].name == name) || (this._suggestionItems.length > 0 && items[i].filterPath == $(event.currentTarget).attr('data-parent-path') && items[i].name == name)) {
                            if ($(event.currentTarget).hasClass("e-active")) {
                                this._sizeInByte += items[i].sizeInByte;
                                this._selectedTileItems.push(items[i]);
                            } else if (event.ctrlKey) {
                                this._sizeInByte -= items[i].sizeInByte;
                                var index = $.inArray(items[i], this._selectedTileItems);
                                if (index > -1) {
                                    _unselectedItem.push(this._selectedTileItems[index]);
                                    this._selectedTileItems.splice(index, 1);
                                }
                            }
                            break;
                        }
                    }
                }
                $.each(this._selectedTileItems, function (index, value) {
                    if (!value.isFile) {
                        proxy._update = false;
                        _isUpdate = false;
                        proxy._toDownload = false;
                    }
                    proxy._updateAccessValue(value);
                });

                this._FilteredFiles = [];
                for (var i = 0; i < this._selectedTileItems.length; i++) {
                    this._FilteredFiles.push(this._selectedTileItems[i].filterPath + this._selectedTileItems[i].name)
                }

                if ($(event.currentTarget).find(".e-fe-folder").length) {
                    nodeType = "Directory";
                    if ($(event.currentTarget).hasClass("e-active"))
                        this._updateNode(name);
                }
                this._currntNode = $(event.currentTarget);
                if (this._currntNode.attr("data-parent-path")) {                    
                    name = this._currntNode.attr("data-parent-path").replace(this._originalPath, "") + name;
                }                
                this._selectedContent = name;
                if ($(event.currentTarget).hasClass("e-active"))
                    this._selectedItems.push(this._selectedContent);
                else {
                    var index = $.inArray(this._selectedContent, this._selectedItems), _unselectedContent = this._selectedContent, _nodeType = nodeType;
                    if (index > -1)
                        this._selectedItems.splice(index, 1);
                    if (this._selectedTileItems.length > 0) {
                        this._selectedContent = this._selectedItems[this._selectedItems.length - 1];
                        nodeType = this._selectedTileItems[this._selectedTileItems.length - 1].type;
                        if (nodeType == "Directory")
                            this._updateNode(this._selectedContent);
                    }
                }                
                if ((!this._startNode) || this._selectItems.length == 0 || this._selectItems.length == this._selectedItems.length) {
                    if (!this._selectItems || this._selectItems.length <= 0)
                        this._startNode = null;
                    this._selectedItemsTag && this._selectedItemsTag.html((this._selectedItems.length > 0 ? (this._selectedItems.length + " " + (this._selectedItems.length > 1 ? this._getLocalizedLabels("Items") : this._getLocalizedLabels("Item")) + " " + this._getLocalizedLabels("Selected")) : "") + (this._sizeInByte ? (_isUpdate ? "  " + this._bytesToSize(this._sizeInByte) : "") : ""));
                    this._nodeType = nodeType;
                    this._setFilteredItemsName();
                    this.model.selectedItems = this._filteredItemsName;
                    var args = { name: this._selectedItems, names: this._selectedItems, path: this.model.selectedFolder, nodeType: this._nodeType, selectedItems: this._getSelectedItemDetails(this.model.selectedFolder, this._filteredItemsName) };
                    this._urlTag && this._urlTag.find("input").val(args.url);
                    this._nameTag && this._nameTag.find("input").val(args.name);
                    this._updateSelectionDetails(this._nodeType);
                    if (this._isClicked)
                        if ($(event.currentTarget).hasClass("e-active"))
                            this._trigger("select", args);
                        else {
                            var args = { name: _unselectedContent, names: [_unselectedContent], path: this.model.selectedFolder, nodeType: _nodeType, unselectedItem: _unselectedItem[0], unselectedItems: _unselectedItem };
                            this._trigger("unselect", args);
                        }
                    this._selectItems = [];
                }                
            } else {
                this._selectItems = [];
                if (!this._startNode)
                    this._startNode = this._currntNode;
                var startIndex = $(event.currentTarget).index();
                var endIndex = this._startNode.index();
                if (startIndex > endIndex) {
                    var temp = startIndex;
                    startIndex = endIndex;
                    endIndex = temp;
                }
                var items = this._tileContent.find(".e-tilenode");
                items.removeClass("e-active").attr("aria-selected", false);
                for (var i = startIndex ; i <= endIndex; i++) {
                    this._selectItems.push($(items.get(i)).find(".e-file-name").text());
                }
                this._setSelectedItems(this._selectItems);
            }
        },
        _setFilteredItemsName: function () {
            this._filteredItemsName = [];
            for (var i = 0; i < this._selectedItems.length; i++) {
                var names = this._selectedItems[i].split('/');
                this._filteredItemsName.push(names[names.length - 1] ? names[names.length - 1] : names[names.length - 2]);
            }
        },
        _getOriginalName: function(path){
            var names = path.split('/');
             return (names[names.length - 1] ? names[names.length - 1] : names[names.length - 2]);
        },
        _updateNode: function (name) {
            this._currentPath += name + "/";
        },
        _getFileURL: function () {
            if (this._nodeType == "File") {
                if ((/\.(gif|jpg|jpeg|tiff|png|bmp)$/i).test(this._selectedContent)) {
                    this._widthTag && this._widthTag.show().removeClass("e-hide");
                    this._heightTag && this._heightTag.show().removeClass("e-hide");
                } else {
                    this._widthTag && this._widthTag.hide().addClass("e-hide");
                    this._heightTag && this._heightTag.hide().addClass("e-hide");
                }
                return (this._currentPath.replace("~", "..") + this._selectedContent);
            }
            else
                return "";
        },
        _updateData: function () {
            var data = this._fileExplorer[this._currentPath];
            this._selectedItemsTag && this._selectedItemsTag.html("");
            if (data && !this._update) {
                this._itemStatus && this._itemStatus.html(data.length + " " + (data.length == 1 ? this._getLocalizedLabels("Item") : this._getLocalizedLabels("Items")));
                var sortingoption = this.model.gridSettings.columns[0];
                var sortingtype = true;
                var initialsort = true;
                this._changeActiveSortedoption(sortingoption.headerText, initialsort);
                this._sorting(sortingoption.field, sortingtype, data);
                var details = this._sorteditems;
                this.model.layout == "grid" ? this._renderGridView(details) : this._renderTileView(details);
            }
            else {
                this._read();
            }
        },

        _addChild: function (result, targetNode) {
            var directories = [];
            if (result) {
                for (var i = 0; i < result.length; i++) {
                    if (!result[i].isFile) {
                        result[i].id = result[i].name;
                        result[i].spriteCssClass = (result[i].permission && !result[i].permission.Read) ? "e-fe-icon e-fe-folder e-fe-lock" : "e-fe-icon e-fe-folder";
                        directories.push(result[i]);
                    }
                }
            }
            this._nodeExpanded = true;
            var selectedNode = targetNode ? $(targetNode).closest('li.e-item') : this._treeObj.getSelectedNode();
            directories.length && this._treeObj.addNode(directories, selectedNode);
            var ele = selectedNode.find(".e-load");
            ele && ((ele.hasClass('e-plus') || ele.hasClass('e-minus')) ? ele.removeClass('e-load') : ele.removeClass('e-icon e-load'));
            this._nodeExpanded = false;
            this._treetag.find("li").removeAttr("tabindex");
            var items = this._treetag.find("li div a").not(".e-js");
            if (items.length && this.model.allowDragAndDrop) {
                this._drag(items);
                items.addClass("e-file-draggable");
            }
        },

        _createContextMenuTag: function (menuOptions, menuDetails, events) {
            var contextMenu = $("body").find('#' + menuDetails.id + 'ContextMenu');
            var ContextMenutag = contextMenu.length ? contextMenu : ej.buildTag('ul.fe-context-menu #' + menuDetails.id + 'ContextMenu');
            ContextMenutag.ejMenu({
                menuType: ej.MenuType.ContextMenu,
                enableSeparator: true,
                enableRTL: this.model.enableRTL,
                cssClass: this.model.cssClass,
                contextMenuTarget: menuDetails.targetId,
                beforeOpen: events.beforeOpen,
                open: events.open,
                close: events.close,
                click: events.click,
                fields: { dataSource: menuOptions, id: "id", text: "text", htmlAttribute: "htmlAttr", spriteCssClass: "sprite" },
            });
            ContextMenutag.hide();
            return ContextMenutag;
        },

        _beforeOpenContextMenu: function (args) {
            if (!$(args.target).hasClass("e-text"))
                args.cancel = true;
            else {
                this._menuNode = $(args.target).closest('li.e-item');
                (this._treeObj) && this._treeObj.element.find('.e-node-focus').removeClass('e-node-focus');
                this._menuNode.find('> div > .e-text:first').addClass('e-node-focus');
                args.dataSource = this._treeMenuOptions.slice();
                args.contextMenu = "navbar";
                args.element = this._treeMenuObj.element;
                if (this._trigger("menuBeforeOpen", args)) return false;
                (JSON.stringify(this._treeMenuObj.model.fields.dataSource) != JSON.stringify(this._treeMenuOptions)) && this._treeMenuObj.option("fields", { dataSource: args.dataSource });
                for (var i = 0; i < this._restrictedMenuOption.length; i++) {
                    this._treeMenuObj && this._treeMenuObj.disableItem(this._restrictedMenuOption[i]);
                }
                (this._toRead && this._toEdit) ? this._enableEditingMenus() : this._disableEditingMenus();
                (this._toRead && this._toCopy) ? (this._restrictedMenuOption.indexOf(this._menuCopy) < 0 && this._treeMenuObj.enableItem(this._menuCopy)) : this._treeMenuObj.disableItem(this._menuCopy);
                this._toRead ? (this._restrictedMenuOption.indexOf(this._menuOpen) < 0 && this._treeMenuObj.enableItem(this._menuOpen)) : this._treeMenuObj.disableItem(this._menuOpen);
                (this._toRead && this._toEditContents) ? (this._restrictedMenuOption.indexOf(this._menuNewFolder) < 0 && this._treeMenuObj.enableItem(this._menuNewFolder)) : this._treeMenuObj.disableItem(this._menuNewFolder);
                (this._toRead && this._toUpload) ? (this._restrictedMenuOption.indexOf(this._menuUpload) < 0 && this._treeMenuObj.enableItem(this._menuUpload)) : this._treeMenuObj.disableItem(this._menuUpload);
                if ($(args.target).parents("li.e-item:first").attr("id") == 1) {
                    this._disableEditingMenus();
                }
            }
        },

        _beforeOpenTileContextMenu: function (args) {
            if ($(args.target).closest('th.e-headercell').hasClass('e-col-check'))
                this._headCheckObj.wrapper.click();
            if ($(args.target).hasClass("e-scrollbar") || $(args.target).parents().hasClass("e-scrollbar") || $(args.target).closest('th.e-headercell').hasClass('e-col-check')) {
                args.cancel = true;
                return;
            }
            if (!$(args.target).hasClass('e-rowcell') && !$(args.target).closest('td.e-rowcell').hasClass('e-col-check') && $(args.target).closest('td.e-rowcell').length > 0 && !$(args.target).closest('td.e-rowcell').hasClass('e-active') && args.events && (args.events.button == 2 || args.events.which == 3))
                this._updateGridSelection(args);
            else if (($(args.target).hasClass("e-file-info") || $(args.target).hasClass("e-thumb-image") || $(args.target).closest(".e-thumb-image").length > 0 || $(args.target).closest(".e-tilenode").length > 0) && $(args.target).closest('.e-chkbox-wrap').length == 0 && !$(args.target).closest(".e-tilenode").hasClass("e-active"))
                this._updateTileSelection(args);
            if ($(args.target).is(".e-tilenode.e-active") || $(args.target).closest(".e-tilenode").hasClass("e-active") || $(args.target).closest('td.e-rowcell').is(".e-active") || ((args.events.ctrlKey || args.events.shiftKey || $(args.target).closest('td.e-rowcell').hasClass('e-col-check') || $(args.target).closest('.e-chkbox-wrap').length > 0) && ($(this.items).hasClass('e-active') || $(this.gridItems).find('td').hasClass('e-active')))) {
                args.dataSource = this._fileMenuOptions.slice();
                args.contextMenu = "files";
                args.element = this._viewMenuObj.element;
            }
            else {
                if ($(args.events.currentTarget).hasClass("e-grid") && ($(args.target).hasClass("e-gridcontent") || $(args.target).hasClass("e-content") || $(args.target).hasClass("e-table") || !$(args.target).is(".e-rowcell.e-active"))) {
                    this._gridObj.clearSelection();
                    if (this.model.showCheckbox) {
                        this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ "checked": false });
                        this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
                    }
                }
                if ($(args.events.currentTarget).hasClass("e-tile-wrapper") && ($(args.target).hasClass("e-tile-wrapper") || $(args.target).hasClass("e-tile-content") || $(args.target).hasClass("e-tileview") || !($(args.target).is(".e-tilenode.e-active") || $(args.target).parent(".e-tilenode").hasClass("e-active")))) {
                    this.model.showCheckbox && this._clearTileCheckBoxSelection();
                    if (this.items.hasClass("e-active"))
                        this.items.removeClass("e-active").attr("aria-selected", false);
                }
                this._updateCurrentPathPermission();
                args.dataSource = this._cwdMenuOptions.slice();
                args.contextMenu = "cwd";
                args.element = this._viewMenuObj.element;
            }
            if (this._trigger("menuBeforeOpen", args)) return false;
            (JSON.stringify(this._viewMenuObj.model.fields.dataSource) != JSON.stringify(args.dataSource)) && this._viewMenuObj.option("fields", { dataSource: args.dataSource });
            for (var i = 0; i < this._restrictedMenuOption.length; i++) {
                this._viewMenuObj && this._viewMenuObj.disableItem(this._restrictedMenuOption[i]);
            }
            if (!this._toRead || (!(/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(this.model.selectedItems) && this._nodeType == "File"))
                this._viewMenuObj && this._viewMenuObj.disableItem("Open");            
            else
                (this._restrictedMenuOption.indexOf(this._menuOpen) < 0) && this._viewMenuObj.enableItem("Open");
            if (!this._option || !this._toRead)
                this._viewMenuObj.disableItem(this._menuPaste);
            this._isupdate ? (this._restrictedMenuOption.indexOf(this._menuDownload) < 0 && this._viewMenuObj.enableItem(this._menuDownload)) : this._viewMenuObj.disableItem(this._menuDownload);
            (this._searchbar && $.trim(this._searchbar.val())) ? (this._restrictedMenuOption.indexOf(this._menuOpenFolderLocation) < 0 && this._viewMenuObj.enableItem(this._menuOpenFolderLocation)) : this._viewMenuObj.disableItem(this._menuOpenFolderLocation);
            (this._toRead && this._toDownload) ? (this._restrictedMenuOption.indexOf(this._menuDownload) < 0 && this._viewMenuObj.enableItem(this._menuDownload)) : this._viewMenuObj.disableItem(this._menuDownload);
            (this._toRead && this._toUpload) ? (this._restrictedMenuOption.indexOf(this._menuUpload) < 0 && this._viewMenuObj.enableItem(this._menuUpload)) : this._viewMenuObj.disableItem(this._menuUpload);
            (this._toRead && this._toEdit) ? this._enableEditingMenus() : this._disableEditingMenus();
            (this._toRead && this._toCopy) ? (this._restrictedMenuOption.indexOf(this._menuCopy) < 0 && this._viewMenuObj.enableItem(this._menuCopy)) : this._viewMenuObj.disableItem(this._menuCopy);
            this._hasEditContentsPermission(this._originalPath) ? (this._restrictedMenuOption.indexOf(this._menuNewFolder) < 0 && this._viewMenuObj.enableItem(this._menuNewFolder)) : this._viewMenuObj.disableItem(this._menuNewFolder);
        },

        _contextMenuOpen: function (args) {
            args.contextMenu = (args.model.contextMenuTarget == this._ExplorerId + "_treeView") ? "navbar" : (this.model.selectedItems.length > 0 ? "files" : "cwd");
            args.element = args.contextMenu == "navbar" ? this._treeMenuObj.element : this._viewMenuObj.element;
            if (args.contextMenu == "cwd")
                var length=this.model.gridSettings.columns.length;
                for (i = 0; i < length; i++) {
                    if (this._prevsortingoption == this.model.gridSettings.columns[i].field) {
                        this._changeActiveSortedoption(this.model.gridSettings.columns[i].headerText,false,true);
                    }
                }
            this._trigger("menuOpen", args);
        },

        _removeOldSelectionDetails: function (nodeType) {
            if (this._currentPath != this._originalPath) {
                this._currentPath = this._originalPath;
            }
            this._sizeInByte = 0;
            this._selectedItems = [];
            this._selectedTileItems = [];
            this.model.selectedItems = [];
            this._selectedContent = this._selectedTreeText;
            if (nodeType) this._nodeType = nodeType;
            else this._nodeType = "Directory";
            this._selectedItemsTag && this._selectedItemsTag.html("");
            this._toolBarItems && this._disableToolbarItem("Download");            
            this._viewMenuObj && this._viewMenuObj.disableItem(this._menuDownload);
            this._disableEditingTools();
        },
        _contextMenuClick: function (args) {
            this._treeObj.selectNode(this._menuNode);
            this._fileContextMenuClick(args);
        },
        _fileContextMenuClick: function (args) {
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            args.contextMenu = (args.model.contextMenuTarget == this._ExplorerId + "_treeView") ? "navbar" : (this.model.selectedItems.length > 0 ? "files" : "cwd");
            if ((!ej.isNullOrUndefined(args.selectedItem) && args.selectedItem.attr('id') == this._ExplorerId + "_cwd_" + "SortBy") || (!ej.isNullOrUndefined(args.element) && args.element.parentElement.parentElement.id == this._ExplorerId + "_cwd_" + "SortBy")) {
                this._changeActiveSortedoption(args.text);
                this._sorting(this._prevsortingoption, this._prevsorting);
                this._sortingActioncomplete();
            }
            else {
                switch (args.text) {
                    case this._menuOpen:
                        this._openAction();
                        break;
                    case this._menuNewFolder:
                        this._createNewFolder();
                        break;
                    case this._menuDelete:
                        this._deleteFolder();
                        break;
                    case this._menuRefresh:
                        this.refresh();
                        break;
                    case this._menuRename:
                        this._renameFolder();
                        break;
                    case this._menuUpload:
                        this.element.find(".e-uploadinput").click();
                        break;
                    case this._menuDownload:
                        this._downloadFile();
                        break;
                    case this._menuCut:
                        this._copyMoveNode("move");
                        break;
                    case this._menuCopy:
                        this._copyMoveNode("copy");
                        break;
                    case this._menuPaste:
                        this._cut_copy();
                        break;
                    case this._menuGetinfo:
                        this._getDetails();
                        break;
                    case this._menuOpenFolderLocation:
                        this._setFilteredItemsName();
                        var selectedItems = this.model.selectedItems;
                        this._selectedFolder(this._originalPath + this._selectedContent.replace(this._filteredItemsName, ""));
                        this._setSelectedItems(selectedItems);
                        break;
                    case args.text:
                        var customFields = this.model.contextMenuSettings.customMenuFields
                        var fn, customItem = this._getCustomItem(customFields, args.ID);
                        if (customItem) fn = customItem.action;
                        if (typeof fn === "string") {
                            fn = ej.util.getObject(fn, window);
                        }
                        fn && fn(args);
                        break;
                }
            }
                this._trigger("menuClick", args);
        },


        _createNewFolder: function () {
            var proxy = this;
            var name = "";
            var viewerData = this._getLocalizedLabels("NewFolderAlert");
            var dialogContent = ej.buildTag('div.e-get-name');
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var inputtag = ej.buildTag('input.e-fe-dialog-text e-ejinputtext e-textbox', "", "", { type: "text" });
            var errDiv= ej.buildTag('div.e-fe-dialog-label e-error-msg');
            inputtag.val("New folder");
            var divtag = ej.buildTag('div.e-fe-dialog-btn');
            var okButton = ej.buildTag('button.e-fe-btn-ok ', this._getLocalizedLabels("OkButton"));
            var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', this._getLocalizedLabels("CancelButton"));
            okButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    proxy._removeDialog(proxy._newFolderDialogObj);
                    name = inputtag.val();
                    if (!$.trim(name)) {
                        name = "New folder";
                    }
                    !proxy._fileExplorer[proxy._currentPath] && proxy._getFileDetails(proxy._currentPath);
                    var data = proxy._fileExplorer[proxy._currentPath];
                    if (!data.length)
                        name && proxy._createFolder(name);
                    else {
                        for (var i = 0; i < data.length; i++) {
                            if (!data[i].isFile && data[i].name == name) {
                                var dialogContent = ej.buildTag('div.e-get-name');
                                var labeltag = ej.buildTag('div.e-fe-dialog-label', String.format(proxy._getLocalizedLabels("ErrorOnFolderCreation"), name));
                                var divtag = ej.buildTag('div.e-fe-dialog-btn');
                                var okButton = ej.buildTag('button.e-fe-btn-ok ', proxy._getLocalizedLabels("YesButton"));
                                var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', proxy._getLocalizedLabels("NoButton"));
                                okButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                    }
                                });
                                cancelButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                        proxy._createFolder(proxy._getDuplicateName(data, "New folder"));
                                    }
                                });
                                divtag.append(okButton, cancelButton);
                                $(dialogContent).append(labeltag, divtag);
                                var open = function () {
                                    okButton.focus();
                                };
                                proxy._alertDialog = proxy._createDialog(dialogContent, { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error"), open: open });
                                proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                                break;
                            }
                            else if (i == data.length - 1) {
                                name && proxy._createFolder(name);
                            }
                        }
                    }
                }
            });
            cancelButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    proxy._removeDialog(proxy._newFolderDialogObj);
                }
            });
            divtag.append(okButton, cancelButton);
            $(dialogContent).append(labeltag, inputtag, errDiv, divtag);
            this._newFolderDialog = this._createDialog(dialogContent, { width: 350, height: "auto", open: function (e) { proxy._openInputDialog(inputtag, okButton, errDiv, this); }, title: this._getLocalizedLabels("NewFolder") });
            this._newFolderDialogObj = this._newFolderDialog.data("ejDialog");
        },
        _openInputDialog: function (inputtag, okButton, errDiv, obj) {
            var proxy = this;
            inputtag.focus();
            !this._isDevice && inputtag.select();
            if (this._isMobileOrTab || this._isDevice) obj.option("position", { Y: "20%" });
            inputtag.keyup(function (e) {
                var code = proxy._getKeyCode(e);
                if (code == 13)
                    okButton.click();
            });
            inputtag.keypress(function (e) {
                var code = proxy._getKeyCode(e);
                if (/[/\\|*?"<>:]/.test(String.fromCharCode(code))) {
                    errDiv.html(proxy._getLocalizedLabels("InvalidFileName"));
                    return false;
                }
                return true;
            });
            inputtag.keydown(function (e) {
                errDiv.html("");
            });
        },

        _deleteFolder: function () {
            this._alertWindow = ej.buildTag("div#" + "e-fe_deleteAlert");
            var viewerData;
            if (this._selectedItems.length > 1)
                viewerData = String.format(this._getLocalizedLabels("DeleteMultipleFolder"), this._selectedItems.length);
            else
                viewerData = this._getLocalizedLabels("DeleteFolder") + this._selectedContent + "?";
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var divTag = ej.buildTag('div.e-fe-dialog-btn');
            var okButton = ej.buildTag('button.e-fe-btn-ok', this._getLocalizedLabels("OkButton"));
            var cancelButton = ej.buildTag('button.e-fe-btn-cancel', this._getLocalizedLabels("CancelButton"));
            divTag.append(okButton, cancelButton);
            this._alertWindow.append(labeltag, divTag);
            proxy = this;
            okButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    proxy._removeDialog(proxy._alertWindowObj);
                    proxy._ajax_folderPath = proxy._nodeType == "Directory" ? proxy._getFolderPath() : proxy._currentPath;
                    proxy._deletion(proxy._selectedItems.length > 1 ? proxy._selectedItems : proxy._selectedContent, proxy._ajax_folderPath);
                    proxy._disableEditingTools();
                    proxy._disableToolbarItem("Copy");
                }
            });
            cancelButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    proxy._removeDialog(proxy._alertWindowObj);
                }
            });
            var open = function () {
                okButton.focus();
            };
            this._alertWindow = this._createDialog(this._alertWindow, { width: 350, height: "auto", title: this._getLocalizedLabels("Delete"), open: open });
            this._alertWindowObj = this._alertWindow.data("ejDialog");
        },
        _getFileDetails: function (path, updateTreeNode, updateLayoutContent, successCallback) {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Read", Path: path, ExtensionsAllow: this.model.fileTypes, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(path), (updateTreeNode ? updateTreeNode.text() : (this.model.selectedItems.length ? this.model.selectedItems : this._selectedContent))) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    result = (result.hasOwnProperty("d")) ? result.d : result;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    for (var i = 0; i < result.files.length; i++) {
                        result.files[i].sizeInByte = result.files[i].size;
                        result.files[i].size = result.files[i].size ? proxy._bytesToSize(result.files[i].size) : "";
                        result.files[i].cssClass = proxy._getCssClass(result.files[i]);
                    }
                    proxy._feParent[path] = result.cwd;
                    proxy._fileExplorer[path] = result.files;
                    updateTreeNode && proxy._addChild(proxy._fileExplorer[path], $(updateTreeNode));
                    if (updateLayoutContent) {
                        proxy._sorting(proxy._prevsortingoption, proxy._prevsorting, result.files);
                        (proxy.model.layout == "grid" ? proxy._renderGridView(proxy._sorteditems) : proxy._renderTileView(proxy._sorteditems));
                        proxy._updateItemStatus(proxy._sorteditems);
                    }                    
                    if (proxy._highlightedNodes && (!proxy._suggestionItems.length)) {
                        proxy._setSelectedItems(proxy._highlightedNodes);                        
                        proxy._highlightedNodes = "";
                    }
                    proxy._searchbar && $.trim(proxy._searchbar.val()) && proxy._searchFiles(proxy._originalPath);
                    successCallback && typeof successCallback === "function" && successCallback();
                },
                successAfter: this.model.ajaxSettings.read.success
            };
            this.model.ajaxSettings.read.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.read);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _searchFiles: function (path) {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Search", SearchString: this._queryString, Path: path, CaseSensitive: this.model.filterSettings.caseSensitiveSearch, ExtensionsAllow: this.model.fileTypes, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(path), (this.model.selectedItems.length ? this.model.selectedItems : this._selectedContent)) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    result = (result.hasOwnProperty("d")) ? result.d : result;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    for (var i = 0; i < result.files.length; i++) {
                        result.files[i].sizeInByte = result.files[i].size;
                        result.files[i].size = result.files[i].size ? proxy._bytesToSize(result.files[i].size) : "";
                        result.files[i].cssClass = proxy._getCssClass(result.files[i]);                        
                        result.files[i].filterPath = proxy._originalPath + result.files[i].filterPath.replace(/\\/g, "/");                        
                    }
					proxy._sorting(proxy._prevsortingoption, proxy._prevsorting, result.files);
					proxy._suggestionItems = result.files = proxy._sorteditems;
                    proxy._suggestionItems = result.files;                                                                                   
                    proxy.model.layout == "grid" ? proxy._renderGridView(result.files) : proxy._renderTileView(result.files);
                    proxy._updateItemStatus(result.files);                                       
                    proxy._setSelectedItems(proxy._highlightedNodes);
                    proxy._highlightedNodes = "";                                        
                },
                successAfter: this.model.ajaxSettings.search.success
            };
            this.model.ajaxSettings.search.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.search);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _getDuplicateName: function (fileDetails, name) {
            var directoryCount = 0;
            var initialName = name;
            while (this._isNameExist(fileDetails, name)) {
                directoryCount++;
                name = initialName.split(".")[0] + (directoryCount > 0 ? "(" + directoryCount + ")" : "") + (name.split(".")[1] ? "." + name.split(".")[1] : "");
            }
            return name;
        },
        _isNameExist: function (fileDetails, name) {
            for (var i = 0; fileDetails && i < fileDetails.length; i++) {
                if (name == fileDetails[i].name)
                    return true;
            }
            return false;
        },

        _renameFolder: function () {
            var proxy = this;
            var viewerData = this._getLocalizedLabels("RenameAlert");
            var dialogContent = ej.buildTag('div.e-rename');
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var selectedFilename;
            if (proxy._nodeType == "Directory")
                selectedFilename = this._selectedContent
            else
                selectedFilename = this._selectedContent.substr(0, this._selectedContent.lastIndexOf('.'));
            var inputtag = ej.buildTag('input.e-fe-dialog-text e-ejinputtext e-textbox', "", "", { type: "text", value: selectedFilename });
            var errDiv = ej.buildTag('div.e-fe-dialog-label e-error-msg');
            var divtag = ej.buildTag('div.e-fe-dialog-btn');
            var okButton = ej.buildTag('button.e-fe-btn-ok', this._getLocalizedLabels("OkButton"));
            var cancelButton = ej.buildTag('button.e-fe-btn-cancel', this._getLocalizedLabels("CancelButton"));
            okButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    var person = inputtag.val(), _oldName = selectedFilename;
                    proxy._removeDialog(proxy._renameDialogObj);
                    if ($.trim(person) && person != _oldName) {
                        proxy._currentPath = proxy._nodeType == "Directory" ? proxy._getFolderPath() : proxy._currentPath;
                        !proxy._fileExplorer[proxy._currentPath] && proxy._getFileDetails(proxy._currentPath);
                        var data = proxy._fileExplorer[proxy._currentPath];
                        proxy._ajax_person = proxy._selectedContent.replace(_oldName, person);
                        if (proxy._nodeType == "File" && (/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(proxy._ajax_person))
                            proxy._updateImages[proxy._currentPath + proxy._ajax_person] = new Date().getTime();
                        for (var i = 0; i < data.length; i++) {
                            if (data[i].name == person) {
                                if (proxy._nodeType == "File") {
                                    person = proxy._getDuplicateName(proxy._fileExplorer[proxy._currentPath], person);
                                    proxy._ajax_person = proxy._selectedContent.replace(_oldName, person);
                                }
                                var dialogContent = ej.buildTag('div.e-get-name');
                                var labeltag = ej.buildTag('div.e-fe-dialog-label', String.format(proxy._getLocalizedLabels(proxy._nodeType == "File" ? "DuplicateFileCreation" : "ErrorOnFolderCreation"), person));
                                var divtag = ej.buildTag('div.e-fe-dialog-btn');
                                var okButton = ej.buildTag('button.e-fe-btn-ok ', proxy._getLocalizedLabels("OkButton"));
                                var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', proxy._getLocalizedLabels("CancelButton"));
                                okButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                        if (proxy._nodeType == "File")
                                            proxy._rename();
                                        else {
                                            proxy._existingItems = [];
                                            proxy._getDuplicateItems(proxy._currentPath + proxy._selectedContent + "/", proxy._currentPath + person + "/", true);
                                            if (proxy._existingItems.length) {
                                                proxy._createReplaceConformationDiaolg("_rename", "DuplicateAlert");
                                            }
                                            else
                                                proxy._rename();
                                        }
                                    }
                                });
                                cancelButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                    }
                                });
                                divtag.append(okButton, cancelButton);
                                $(dialogContent).append(labeltag, divtag);
                                var open = function () {
                                    okButton.focus();
                                };
                                proxy._alertDialog = proxy._createDialog(dialogContent, { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error"), open: open });
                                proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                                break;
                            }
                            else if (i == data.length - 1) {
                                proxy._rename();
                            }
                        }
                    }
                }
            });
            cancelButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    proxy._removeDialog(proxy._renameDialogObj);
                }
            });

            divtag.append(okButton, cancelButton);
            $(dialogContent).append(labeltag, inputtag, errDiv, divtag);
            this._renameDialog = this._createDialog(dialogContent, { width: 350, height: "auto", open: function (e) { proxy._openInputDialog(inputtag, okButton, errDiv, this); }, title: this._getLocalizedLabels("Rename") });
            this._renameDialogObj = this._renameDialog.data("ejDialog");
        },

        _isSelectedFile: function (files, name) {
            for (var i = 0; i < files.length; i++) {
                if (name == files[i])
                    return true;
            }
            return false;
        },
        _refreshItems: function (node, path, successCallback) {
            if (!this._treeObj) {
                this._currentPath = this.model.path;
                this._read();
            }
            else {
                node = $(node);
                !this._treeObj.isExpanded(node) && this._treeObj.hasChildNode(node) && this._treeObj.expandNode(node);
                this._fileExplorer[path] = "";
                var proxy = this;
                $.each(proxy._fileExplorer, function (itemPath, value) {
                    //display the key and value pair
                    if (itemPath.startsWith(path))
                        proxy._fileExplorer[itemPath] = "";
                });
                var childNodes = node.find('ul:first > li');
                for (var i = 0; i < childNodes.length; i++) {
                    node.find(childNodes[i]).length && this._treeObj.removeNode($(childNodes[i]));
                }
                var processNode = node.find(".e-process");
                processNode.length && processNode.removeClass("e-process");
                this._getFileDetails(path, node.find('> div > .e-text'), true, successCallback);
            }
        },
        _getDuplicateItems: function (source, target, files) {
            !this._fileExplorer[target] && this._getFileDetails(target);
            var targetFiles = this._fileExplorer[target];
            !this._fileExplorer[source] && this._getFileDetails(source);
            var sourceFiles = this._fileExplorer[source];
            if (sourceFiles && targetFiles) {
                for (var s = 0; s < sourceFiles.length; s++) {
                    for (var t = 0; t < targetFiles.length; t++) {
                        if (sourceFiles[s].name == targetFiles[t].name) {
                            if (files == true || this._isSelectedFile(files, targetFiles[t].name)) {
                                this._existingItems[this._existingItems.length] = { Name: targetFiles[t].name, Path: target + targetFiles[t].name + (!targetFiles[t].isFile ? "/" : ""), IsReplace: true };
                                if (!targetFiles[t].isFile)
                                    this._getDuplicateItems(source + sourceFiles[s].name + "/", target + targetFiles[t].name + "/", true);
                            }
                        }
                    }
                }
            }
        },
        _backward: function () {
            if (this._currentState > 0) {
                //minimum number of states to show forward icon
                var minState = 2;
                var update = true;
                var disableBackwardPosition = 0;
                this._isStateNavigation = true;
                var oldIndex = this._currentState;
                --this._currentState;
                while (this._selectedStates[this._currentState] == "" || this._selectedStates[this._currentState] == this._selectedStates[oldIndex]) {
                    if (this._currentState)
                        --this._currentState;
                    else
                        update = false;                        
                }
                update && this._selectedFolder(this._selectedStates[this._currentState]);
                this._isStateNavigation = false;                
                (this._currentState == disableBackwardPosition || this._selectedStates.length - minState == this._currentState) && this._toolBarItems && this._enableToolbarItem("Forward");
                this._currentState == disableBackwardPosition && this._toolBarItems && this._disableToolbarItem("Back");
            }
        },
        _forward: function () {
            if (this._currentState + 1 < this._selectedStates.length) {
                //used to get index from array length
                var update = true;
                var reduceIndex = 1;
                var disableState = 0;
                var enableState = 1;
                this._isStateNavigation = true;
                var oldIndex = this._currentState;
                ++this._currentState;
                while (this._selectedStates[this._currentState] == "" || this._selectedStates[this._currentState] == this._selectedStates[oldIndex]) {
                    if (this._currentState < this._selectedStates.length - 1)
                        ++this._currentState;
                    else
                        update = false;                        
                }
                update && this._selectedFolder(this._selectedStates[this._currentState]);
                this._isStateNavigation = false;
                this._selectedStates.length - reduceIndex == this._currentState && this._toolBarItems && this._disableToolbarItem("Forward");
                this._currentState == 0 && this._toolBarItems && this._disableToolbarItem("Back");
                this._currentState == 1 && this._toolBarItems && this._enableToolbarItem("Back");
            }
        },
        _copyMoveNode: function (action) {
            if (action == "move") {
                this.element.find(".e-blur").removeClass("e-blur");
                var activeElement = this.element.find(".e-splitter .e-active");
                activeElement.length && activeElement.length == 1 ? activeElement.addClass("e-blur") : this.element.find(".e-cont2 .e-active").addClass("e-blur");
            }
            this._copiedNodes = this._filteredItemsName;
            this._option = action;
            this._sourcePath = this._nodeType == "Directory" ? this._getFolderPath() : this._currentPath;
            this._sourceType = this._nodeType;
            this._fileName = this._selectedItems.length > 1 ? this._selectedItems : this._selectedContent;
            this._refreshNode = this._originalPath != this._currentPath ? this._findMatchingElement(this._selectedNode.find("ul:first"), this._selectedContent) : this._selectedNode;
            this._toolBarItems && this._enableToolbarItem("Paste");
            if (this.model.showContextMenu) {
                this._restrictedMenuOption.indexOf(this._menuPaste) < 0 && this._viewMenuObj.enableItem(this._menuPaste);
                this._restrictedMenuOption.indexOf(this._menuPaste) < 0 && this._treeMenuObj.enableItem(this._menuPaste);
            }
            var args = { name: this._fileName, sourcePath: this._sourcePath, selectedItems: this._getSelectedItemDetails(this._sourcePath, this._fileName) };
            if (action == "move")
                this._trigger("cut", args);
            else
                this._trigger("copy", args);
        },
        _openAction: function () {
            if (!this._toRead) return;
            var proxy = this;
            var selectedNodes;
            if (this._nodeType == "File")
                this._selectedFile = this._selectedContent;
            if (this._onBeforeOpen()) return;
            if (this._nodeType == "Directory") {
                if (this._suggestionItems.length) {                    
                    this._selectedFolder(this._originalPath + this._selectedContent);                    
                }
                else {
                    var selectedNode = this._treeObj.getSelectedNode(), _selectedContent = this._selectedContent;
                    if (!this._treeObj.isExpanded(selectedNode))
                        this._treeObj && this._treeObj.expandNode(selectedNode);
                    var _childItems = selectedNode.find('ul:first>li').find('div:first .e-text');
                    if (!this._treeObj.hasChildNode(selectedNode)) {
                        var path = (this._isTreeNode == true ? this._currentPath : this._currentPath.replace(this._selectedContent + "/", ""));
                        this._isTreeNode = false;
                        this._addChild(this._fileExplorer[path]);
                    }
                    for (var i = 0; i < _childItems.length; i++) {
                        if ($(_childItems[i]).text() == _selectedContent) {
                            this._treeObj.selectNode(_childItems[i].parentNode.parentNode);
                            break;
                        }
                    }
                    selectedNodes = this._getSelectedItemDetails(this._getFolderPath(), _selectedContent);
                    this._selectedItems = [];
                    this._selectedTileItems = [];
                }
            }
            else if (this._nodeType == "File") {
                if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(this._selectedFile)) {
                    proxy._openDialog = ej.buildTag('div.e-imageViewer', "", "", { id: proxy._ExplorerId + '_basicDialog', title: proxy._selectedFile });
                    var path = proxy._currentPath.replace("~", "..") + this._selectedFile;
                    var url = this._getImage(path, this._selectedFile, false);
                    var imagetag = ej.buildTag('img', "", "", { src: (url ? url : path) });
                    $(proxy._openDialog).append(imagetag);
                    $(proxy.element).append(proxy._openDialog);
                    var img = new Image();
                    img.onload = img.onabort = img.onerror = function (args) {
						if(args){
							var myargs = { path: args.target.src, element: args.target, originalArgs: args, action: "open" };
							proxy._trigger("getImage", myargs);
						}
                        
                    };
                    img.src = imagetag.attr('src');
                    proxy._openDialog.ejDialog({
                        width: 450,
                        height: 350,
                        minHeight: 200,
                        minWidth: 300,
                        maxWidth: "100%",
                        isResponsive: proxy.model.isResponsive,
                        target: proxy.element,
                        closeIconTooltip: proxy._getLocalizedLabels("DialogCloseToolTip"),
                        enableRTL: proxy.model.enableRTL,
                        showRoundedCorner: proxy.model.showRoundedCorner,
                        cssClass: proxy.model.cssClass,
                        close: function (e) { proxy._onDialogClose(e); }
                    }).parents(".e-dialog-wrap").addClass("e-imageViewer-wrap");
                    proxy._openDialog.css("height", "90%");
                    proxy._openDialogObj = proxy._openDialog.data("ejDialog");
                }
                selectedNodes = proxy._getSelectedItemDetails(proxy._currentPath, proxy._selectedContent);
            }
            var fileUrl;
            fileUrl = this._nodeType == "File" ? path : this._currentPath;
            var args = { path: fileUrl, itemType: this._nodeType, selectedItems: selectedNodes };
            this._trigger("open", args);
        },
        _getSelectedItemDetails: function (path, names) {
            if (typeof names == "string")
                names = [names];
            var itemDetails = [], items, file;
            if (this.model.layout == 'grid') items = this._selectedRecords;
            else items = this._suggestionItems;
            var data = this._suggestionItems && this._suggestionItems.length ? items : this._fileExplorer[path];
            if (data) {
                for (var j = 0; j < names.length; j++) {
                    for (var i = 0; i < data.length; i++) {
                        if (this._suggestionItems.length > 0) file = data[i].filterPath + data[i].name;
                        else file = names[j];
                        if ((this._suggestionItems.length < 1 && data[i].name == this._getOriginalName(names[j])) || (this._suggestionItems.length > 0 && file == this._FilteredFiles[j] && data[i].name == this._getOriginalName(names[j]))) {
                            itemDetails.push(data[i]);
                            break;
                    }
                }
            }
            }
            return itemDetails;
        },
        _getDetails: function () {
            var _path = this._nodeType == "Directory" ? this._getFolderPath() : this._currentPath;
            var proxy = this;
            var names = (typeof this._selectedContent == "string") ? [this._selectedContent] : this._selectedContent;
            if (names[0].endsWith('/'))
                names[0] = names[0].substring(0, names[0].length - 1);
            var _ajaxOptions = {

                data: { ActionType: "GetDetails", Path: _path, Names: names, SelectedItems: this._getSelectedItemDetails(_path, (this.model.selectedItems.length ? this.model.selectedItems : this._selectedContent)) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    if (result.hasOwnProperty("d"))
                        result = result.d;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    var dialogContent = ej.buildTag('div.e-fe-table');
                    var tabletag = ej.buildTag('table'), trtag, tdtag1, tdtag2, wrapDiv, inputtag, kbsize, tdata;
                    $.each(result.details[0], function (name, value) {
                        trtag = ej.buildTag('tr');
                        tdtag1 = ej.buildTag('td', ej.isNullOrUndefined(proxy._getLocalizedLabels(name)) ? name : proxy._getLocalizedLabels(name));
                        tdtag2 = ej.buildTag('td');
                        if (name == "Name" || name == "Location") {
                            wrapDiv = ej.buildTag('div');
                            inputtag = ej.buildTag('input.e-readonly', "", "", { style: "border:none;", type: 'text', value: value, title: value, readonly: true });
                            inputtag.focus(function () {
                                $(this).blur();
                            });
                            wrapDiv.append(inputtag);
                        } else if (name == "Size") {
                            kbsize = proxy._bytesToSize(value);
                            wrapDiv = ej.buildTag('span', kbsize + " (" + value + " Bytes)");
                        } else if (name == "Permission") {
                            wrapDiv = (value != undefined) ? ej.buildTag('span', proxy._objToString(value), "", { style: "word-break: break-word;" }) : null;
                        } else {
                            wrapDiv = ej.buildTag('span', value);
                        }
                        if (wrapDiv != undefined) {
                            (name == "Permission") && $(tabletag).find("tr:last").addClass('e-border');
                            tdtag2.append(wrapDiv);
                            $(tabletag).append(trtag);
                            $(trtag).append(tdtag1, tdtag2);
                            (name == "Name" || name == "Size") && trtag.addClass('e-border');
                        }
                    });
                    $(dialogContent).append(tabletag);
                    proxy._detailsDialog = proxy._createDialog(dialogContent, { width: 500, height: "auto", title: proxy._getLocalizedLabels("Details") });
                    proxy._detailsDialogObj = proxy._detailsDialog.data("ejDialog");
                    proxy._detailsDialogObj.focus();
                },
                successAfter: this.model.ajaxSettings.getDetails.success
            };
            this.model.ajaxSettings.getDetails.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.getDetails);
            this._sendAjaxRequest(_ajaxOptions, true);
        },
        _objToString: function (obj) {
            var str = '';
            for (var prop in obj) {
                if (obj.hasOwnProperty(prop)) {
                    str += prop + ': ' + obj[prop] + ', ';
                }
            }
            return str;
        },
        _uploadFile: function () {
            proxy = this.element.find(".e-uploadbox");
            proxy = proxy.ejUploadbox("instance");
        },

        _getFolderPath: function (path) {
            var str_array = path? path.split('/'):this._currentPath.split('/');            
            var editedPath = "";
            for (var i = 0; i < str_array.length - 2; i++) {
                editedPath += str_array[i] + "/";
            }
            return editedPath;
        },
        _renderToolBar: function () {
            this._crateToolbarTemplate();
            this._initToolbarItems();
            var model = {};
            model.click = $.proxy(this._toolBarClick, this);
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeparator = true;
            model.isResponsive = this.model.isResponsive;
            model.height = model.isResponsive ? "" : "auto";
            model.cssClass = this.model.cssClass + " e-fe-toolbar " + (this._isMobileOrTab ? "e-fe-mobile" : "");
            model.enableRTL = this.model.enableRTL;
            this._toolBarItems.ejToolbar(model);
            this._toolBarObj = this._toolBarItems.ejToolbar("instance");
            if (this._isMobileOrTab && this._toolBarObj.model.isResponsive) this._toolBarObj._liTemplte.css("max-width", this.element.width());
            this._disableToolbarItem("Paste");
            this._disableToolbarItem("Download");
            this._disableToolbarItem("Back");
            this._disableToolbarItem("Forward");
            this._disableEditingTools();
        },
        _initToolbarItems: function () {
            this._toolBarItems.find("#" + this._ExplorerId + "Addressbar").length > 0 && this._createAddressBar();
            this._toolBarItems.find("#" + this._ExplorerId + "Searchbar").length > 0 && this._searchDetails();
            this._toolBarItems.find("#" + this._ExplorerId + "Layout").length > 0 && this._renderLayoutDrpdwn();
            this._toolBarItems.find("#" + this._ExplorerId + "SortBy").length > 0 && this._renderSortbyDrpdwn();
        },
        _renderSortbyDrpdwn: function () {
            this._showSortbyDDL = ej.buildTag("button#" + this._ExplorerId + "_sortby", "", "", { "data-role": "none", "type": "button" });
            var ultag = $("<ul id=" + this._ExplorerId + "_splitMenu1 class='e-fe-split-context'>");
            var itemslength = this.model.gridSettings.columns.length;
            for (var i = 0; i < itemslength; i++) {
                ultag.append($("<li><a class=' e-arrow-space'><span class='e-icon'></span>" + this.model.gridSettings.columns[i].headerText + "</a></li>"));
            }
            ultag.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "SortBy").html(""));
            var model = {};
            var proxy = this;
            var selectedoption;
            model.height = "24px",
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._ExplorerId + "_splitMenu1";
            model.contentType = "imageonly";
            model.buttonMode = "dropdown";
            model.itemSelected = function (args) {
                proxy._changeActiveSortedoption(args.text);
                proxy._sorting(proxy._prevsortingoption, proxy._prevsorting)
                proxy._sortingActioncomplete();
            }
            model.prefixIcon = 'e-icon e-fe-sortby';
            this._showSortbyDDL.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "SortBy").addClass("e-fe-split-button"));
            this._showSortbyDDL.ejSplitButton(model);
            this._splitButtonObj1 = this._showSortbyDDL.data("ejSplitButton");
        },
        _gridupdate: function (type) {
            var option;
            this._prevsorting ? option = "ascending" : option = "descending";
            if (!ej.isNullOrUndefined(this._gridObj)) {
                this._gridObj.getHeaderTable().find("[ej-mappingname=" + type + "]").parent().attr('aria-sort', option);
                this._gridObj._addSortElementToColumn(type, option);
            }
        },
        removeSortingIcons:function(){
            $("#" + this._ExplorerId + "_tileViewContextMenu").find("li span").removeClass("e-fe-ascending e-fe-descending");
            $("#" + this._ExplorerId + "_splitMenu1").find("li span").removeClass("e-fe-ascending e-fe-descending");
            var gridSoringCol=this._gridObj.getHeaderTable().find("[ej-mappingname=" + "filterPath" + "]").parent();
            if (this._prevsortingoption == "filterPath") {
                if (this._prevsorting) {
                    gridSoringCol.attr('aria-sort', "descending");
                    this._gridObj._addSortElementToColumn("filterPath", "descending");
                }
                else {
                    gridSoringCol.attr('aria-sort', "ascending");
                    this._gridObj._addSortElementToColumn("filterPath", "ascending");
                }
            }
            else
            {
                if (this._prevsorting) {
                    gridSoringCol.attr('aria-sort', "ascending");
                    this._gridObj._addSortElementToColumn("filterPath", "ascending");
                }
                else {
                    gridSoringCol.attr('aria-sort', "descending");
                    this._gridObj._addSortElementToColumn("filterPath", "descending");
                }
            }
            this._prevsorting = this._gridObj.getHeaderContent().find('span').hasClass("e-icon e-ascending") ? true : false;
        },
        _changeActiveSortedoption: function (args, initialsort, menuopen) {
            if (menuopen == true)
                this._prevsorting = !this._prevsorting
            var sortedoptionlength = this.model.gridSettings.columns.length, tilecontextelement;
            var menulength=$("#" + this._ExplorerId + "_tileViewContextMenu").find("li").length;
            for (var j = 0; j < menulength; j++)
            {
                var liElement=$("#" + this._ExplorerId + "_tileViewContextMenu").find("li")[j];
                if (liElement.id == this._ExplorerId + "_cwd_" + "SortBy")
                    tilecontextelement = $(liElement).find("ul li");
            }
            var splitmenuelement = $("#" + this._ExplorerId + "_splitMenu1").find("li");
            $(tilecontextelement).find('span').removeClass("e-fe-ascending e-fe-descending");
            $(splitmenuelement).find('span').removeClass("e-fe-ascending e-fe-descending");
            var tilemenuli, contextmenuliElement, toolbarliElement, contextactiveElement, toolbaractiveElement;
            for (var i = 0; i < sortedoptionlength; i++) {
                contextmenuliElement = !ej.isNullOrUndefined(tilecontextelement) && tilecontextelement[i];
                toolbarliElement = !ej.isNullOrUndefined(splitmenuelement) && splitmenuelement[i];
                contextactiveElement = $(contextmenuliElement).find('span');
                toolbaractiveElement = $(toolbarliElement).find('span');
                if ((!ej.isNullOrUndefined(contextmenuliElement) && $(contextmenuliElement).text() == args ) || (!ej.isNullOrUndefined(toolbarliElement) && $(toolbarliElement).find('a').text() == args)) {
                    if (initialsort) {
                        contextactiveElement.addClass("e-fe-ascending");
                        toolbaractiveElement.addClass("e-fe-ascending");
                    }
                    else if (this._prevsortingoption == this.model.gridSettings.columns[i].field) {
                        if (this._prevsorting) {
                            contextactiveElement.addClass("e-fe-descending");
                            toolbaractiveElement.addClass("e-fe-descending");
                        }
                        else {
                            contextactiveElement.addClass("e-fe-ascending");
                            toolbaractiveElement.addClass("e-fe-ascending");
                        }
                    }
                    else {
                        if (this._prevsorting) {
                            contextactiveElement.addClass("e-fe-ascending");
                            toolbaractiveElement.addClass("e-fe-ascending");
                        }
                        else {
                            contextactiveElement.addClass("e-fe-descending");
                            toolbaractiveElement.addClass("e-fe-descending");
                        }
                    }
                    this._prevsortingoption = this.model.gridSettings.columns[i].field;
                    this._prevsorting = contextactiveElement.hasClass("e-fe-ascending") || toolbaractiveElement.hasClass("e-fe-ascending") ? true : false;
                    break;
                }
            }
        },
        _suggestionitemsSorting: function (sortingType,sortingOption) {
            var items = this._suggestionItems;
            var dataMgr = ej.DataManager(items);
            this._prevsortingoption = sortingType;
            this._sorteditems = sortingOption ? (dataMgr.executeLocal(ej.Query().sortBy(sortingType))) : (dataMgr.executeLocal(ej.Query().sortByDesc(sortingType)));
        },
        _sorting: function (type, option,data) {
            var items,sortingoption;
            if (ej.isNullOrUndefined(data))
                items = (this._searchbar && this._searchbar.val() != "") ? (this._suggestionItems.length >= 0 ? this._suggestionItems : this._fileExplorer[this._originalPath]) : this._fileExplorer[this._originalPath];
            else
                items = data;
            type == "type" ? sortingoption = "name" : type == "size" ? sortingoption = 'sizeInByte' : sortingoption = type;
            var dataMgr=ej.DataManager(items);
            switch (type) {
                case "type":
                case "dateModified":
                    if (option) {
                        var ascendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortBy(sortingoption)));
                        var ascendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortBy(sortingoption)));
                        this._sorteditems = ascendingdir.concat(ascendingfile);
                    }
                    else {
                        var descendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortByDesc(sortingoption)));
                        var descendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortByDesc(sortingoption)));
                        this._sorteditems = descendingdir.concat(descendingfile);
                    }
                    break;
                case "name":
                case "size":
                default:
                    if (option) {
                        var ascendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortBy(sortingoption)));
                        var ascendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortBy(sortingoption)));
                        this._sorteditems = ascendingdir.concat(ascendingfile);
                    }
                    else {
                        var descendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortByDesc(sortingoption)));
                        var descendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortByDesc(sortingoption)));
                        this._sorteditems = descendingfile.concat(descendingdir);
                    }
                    break;
            }
        },
        _sortingActioncomplete: function () {
            switch (this.model.layout) {
                case ej.FileExplorer.layoutType.Grid:
                    this._gridObj.option('dataSource', this._sorteditems);
                    break;
                case ej.FileExplorer.layoutType.LargeIcons:
                case ej.FileExplorer.layoutType.Tile:
                default:
                    this._renderTileView(this._sorteditems,true);
            }
            if (!ej.isNullOrUndefined(this._selectedItems) && this._selectedItems.length == 1)
                this._setSelectedItems(this._selectedContent);
        },
        _renderLayoutDrpdwn: function () {
            this._showLayoutDDL = ej.buildTag("button#" + this._ExplorerId + "_layout", "", "", { "data-role": "none","type":"button" });
            var ultag = $("<ul id="+this._ExplorerId+"_splitMenu class='e-fe-split-context'>");
            this._layoutList = ["Tile","Grid","LargeIcons"];
            for (var i = 0; i < this._layoutList.length; i++) {
                ultag.append($("<li><a class=' e-arrow-space'><span class='e-icon e-fe-activeicon'></span>" + this._getLocalizedLabels(this._layoutList[i]) + "</a></li>"));
            }
            ultag.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Layout").html(""));
          
            var model = {};
            var proxy = this;
            model.height = "24px",
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._ExplorerId+"_splitMenu";
            model.contentType = "imageonly";
            model.buttonMode = "dropdown";
            model.itemSelected = function (args) {
                switch (args.text) {
                    case proxy._getLocalizedLabels("LargeIcons"):
                        proxy.model.layout = "largeicons";
                        break;
                    case proxy._getLocalizedLabels("Tile"):
                        proxy.model.layout = "tile";
                        break;
                    case proxy._getLocalizedLabels("Grid"):
                    default:
                        proxy.model.layout = "grid";
                        break;
                }
                proxy._switchLayoutView();
            }
            model.prefixIcon = 'e-icon e-fe-' + this.model.layout;
            this._showLayoutDDL.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Layout").addClass("e-fe-split-button"));
            this._showLayoutDDL.ejSplitButton(model);
            this._splitButtonObj = this._showLayoutDDL.data("ejSplitButton");
        },
        _changeLayoutActive: function (layout) {
            this._splitButtonObj && this._splitButtonObj.option('prefixIcon', 'e-icon e-fe-' + layout);
            if (this._toolBarItems && this._toolBarItems.find("#" + this._ExplorerId + "Layout").length > 0) {
                $($("#" + this._ExplorerId + "_splitMenu").find("li span").removeClass('e-fe-activeicon'));
                switch (layout) {
                    case ej.FileExplorer.layoutType.LargeIcons:
                        $($("#" + this._ExplorerId + "_splitMenu").find("li")[2]).find("span").addClass('e-fe-activeicon'); break;
                    case ej.FileExplorer.layoutType.Tile:
                        $($("#" + this._ExplorerId + "_splitMenu").find("li")[0]).find("span").addClass('e-fe-activeicon'); break;
                    case ej.FileExplorer.layoutType.Grid:
                    default:
                        $($("#" + this._ExplorerId + "_splitMenu").find("li")[1]).find("span").addClass('e-fe-activeicon'); break;
                }
            }
        },
        _createUploadBox: function () {
            this._uploadtag = ej.buildTag('div#' + this._ExplorerId + 'FileUpload', "", { padding: "0px", height: "0px", width: "0px" });
            this.element.prepend(this._uploadtag);
            this._renderUploadBox();
            this._uploadtag.find(".e-inputbtn").hide();
            this._uploadtag.find(".e-uploadinput").attr("tabindex", -1);
        },
        _searchDetails: function () {
            this._isWatermark = 'placeholder' in document.createElement('input');
            var waterMark = this._getLocalizedLabels("Search");
            this._searchbar = ej.buildTag('input.e-searchBar e-tool-input', "", {}, { id: this._ExplorerId + '_searchbar', type: "text", placeholder: waterMark });
            this._searchbar.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Searchbar").html(""));
            ej.browserInfo().name == "msie" && ej.ieClearRemover(this._searchbar[0]);
            if (!this._isWatermark)
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ", waterMark, {display: "block"}).insertAfter(this._searchbar);
            this._on($('#' + this._ExplorerId + '_searchbar'), "focus", this._inputFocusin);
            this._on($('#' + this._ExplorerId + '_searchbar'), "keyup", this._onSearchKeyup);
        },
        _setUploadLocalization: function () {
            $.each(ej.FileExplorer.Locale, function (locale, value) {
                if (value.UploadSettings) {
                    ej.Uploadbox.Locale[locale] = value.UploadSettings;
                }                
            });            
        },
        _getLocalizedLabels: function (property) {
            return ej.FileExplorer.Locale[this.model.locale] === undefined || ej.FileExplorer.Locale[this.model.locale][property] === undefined ? (ej.FileExplorer.Locale["en-US"][property] ? ej.FileExplorer.Locale["en-US"][property] : property) : ej.FileExplorer.Locale[this.model.locale][property];
        },
        _crateToolbarTemplate: function () {
            this._toolBarItems = ej.buildTag("div#" + this._ExplorerId + "_toolbar").prependTo(this.element);
            for (var item = 0; item < this.model.toolsList.length; item++) {
                var items = this.model.toolsList[item];
                if (!ej.isNullOrUndefined(this.model.tools[items])) {
                    if (items == "customTool")
                        !ej.isNullOrUndefined(this.model.tools[items]) && this._customTools(this.model.tools[items]);
                    else
                        this.model.tools[items].length > 0 && this._createToolsItems(this.model.tools[items], items);
                }
            }
        },

        _createToolsItems: function (items, itemName) {
            var ulTag = ej.buildTag("ul#" + (this._ExplorerId + itemName)), liTag;
            ulTag.addClass("e-ul-" + itemName);
            for (var i = 0; i < items.length; i++) {
                liTag = $("<li id='" + (this._ExplorerId + items[i].replace(/ /g, '')) + "' class='e-feItem-" + items[i] + "' title='" + this._getLocalizedLabels(items[i].replace(/ /g, '')) + "' ><div class='e-fileexplorer-toolbar-icon " + items[i] + "'></div></li>");
                liTag.appendTo(ulTag);
            }
            ulTag.appendTo(this._toolBarItems);
        },
        _customTools: function (toolbarItems) {
            for (var item = 0; item < toolbarItems.length; item++) {
                var ulTag = ej.buildTag("ul"), liTag;
                liTag = $("<li id='" + (this._ExplorerId + toolbarItems[item].name.replace(/ /g, '')) + "' title='" + toolbarItems[item].tooltip + "' ><div class='" + (ej.isNullOrUndefined(toolbarItems[item].css) ? "" : toolbarItems[item].css) + "'></div></li>");
                var fn = toolbarItems[item].action;
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }
                !ej.isNullOrUndefined(toolbarItems[item].action) && this._on(liTag, "click", fn);
                $(toolbarItems[item].template).appendTo(liTag.find("div"));
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
        },
        _toolBarClick: function (args) {
            this._hidePopup();
            var proxy = this;
            if ((args.event.which && (args.event.which == 3 || args.event.which == 2)) || (args.event.button && args.event.button == 2))
                return false;
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            this._lastFocusedElement = $(args.currentTarget);
            var currrentElement = $(args.currentTarget);
            var selected = currrentElement.attr("id");
            switch (selected) {
                case this._ExplorerId + "Addressbar":
                case this._ExplorerId + "Searchbar":
                    if (this._searchbar && !this._isWatermark) {
                        this._searchbar.blur(function () {
                            !proxy._searchbar.val() && proxy._hiddenSpan.css("display", "block");
                        });
                        this._hiddenSpan.css("display", "none");
                    }
                    if (args.event.type == "keyup")
                        currrentElement.find("input").focus();
                    break;
                case this._ExplorerId + "Download":
                    this._downloadFile();
                    break;
                case this._ExplorerId + "Upward":
                    this._upward();
                    break;
                case this._ExplorerId + "NewFolder":
                    this._createNewFolder();
                    break;
                case this._ExplorerId + "Delete":
                    this._deleteFolder();
                    break;
                case this._ExplorerId + "Rename":
                    this._renameFolder();
                    break;
                case this._ExplorerId + "Refresh":
                    this._currentPath = this._originalPath;
                    this._highlightedNodes = this.model.selectedItems;
                    this._refreshItems((this._treeObj ? this._treeObj.getSelectedNode(): ""), this._originalPath);
                    break;
                case this._ExplorerId + "Back":
                    this._backward();
                    break;
                case this._ExplorerId + "Forward":
                    this._forward();
                    break;
                case this._ExplorerId + "Cut":
                    this._copyMoveNode("move");
                    break;
                case this._ExplorerId + "Copy":
                    this._copyMoveNode("copy");
                    break;
                case this._ExplorerId + "Paste":
                    this._currentPath = this._originalPath;
                    this._cut_copy();
                    break;
                case this._ExplorerId + "Open":
                    this._openAction();
                    break;
                case this._ExplorerId + "Details":
                    this._getDetails();
                    break;
                case this._ExplorerId + "Upload":
                    this.element.find(".e-uploadinput").click();
                    break;
            }
        },
        _upward: function () {            
            this._treeObj && this._treeObj.selectNode(this._treeObj.getSelectedNode().parent().closest('li.e-item'));            
        },
        _getFilteredList: function (list) {
            var w_char;
            var searchItems = [];
            this._suggestionItems = [];                       
            if ($.trim(this._queryString)) {
                switch (this.model.filterSettings.filterType) {
                    case ej.FileExplorer.filterType.StartsWith:
                        this._queryString = this._queryString + "*";
                        break;
                    case ej.FileExplorer.filterType.EndsWith:
                        this._queryString = "*" + this._queryString;
                        break;
                    case ej.FileExplorer.filterType.Contains:
                        this._queryString =  "*" + this._queryString + "*";
                        break;
                }
                this._searchFiles(this._originalPath);
            }                
            else {
                this._suggestionItems = [];
                this._sorting(this._prevsortingoption, this._prevsorting, this._fileExplorer[this._originalPath]);
                this.model.layout == "grid" ? this._renderGridView(this._sorteditems) : this._renderTileView(this._sorteditems);
                this._updateItemStatus(this._fileExplorer[this._originalPath]);
            }
            this._gridupdate(this._prevsortingoption);
        },
        
        _updateItemStatus: function (items) {
            if (items) {
                this._itemStatus && this._itemStatus.html(items.length + " " + (items.length == 1 ? this._getLocalizedLabels("Item") : this._getLocalizedLabels("Items")));
            }            
        },
        _onSearchKeyup: function (event) {
            var proxy = this;
            var event = event;
            clearTimeout(this._searchTimer);
            this._searchTimer = setTimeout(function () {
                proxy._validateKeyCode(event);
            }, 300);
        },
        _validateKeyCode: function (event) {
            switch (event.which) {
                case 38:
                case 40:
                case 37:
                case 39:
                case 20:
                case 16:
                case 17:
                case 18:
                case 35:
                case 36:
                case 144: break;
                case 27:
                    this._searchbar && this._searchbar.val("");
                    this._queryString = "";
                    var address = this._addresstag.val();
                    this._removeOldSelectionDetails();
                    this._currentPath = this._currentPath.split(address)[0] + address;
                    this._getFilteredList(this._fileExplorer[this._currentPath]);
                    this.model.layout == 'grid' ? this._addFocus(this._gridtag.find(".e-gridcontent")) : this._addFocus(this._tileViewWrapper);
                    break;
                case 9:
                case 46:
                case 8:
                case 13: 
                default:
                    if ((!this.model.filterSettings.allowSearchOnTyping && event.which == (13 || 46 || 9 || 8)) || (this.model.filterSettings.allowSearchOnTyping)) {
                    this._queryString = event.currentTarget.value;
                    var address = this._addresstag.val();
                    this._removeOldSelectionDetails();
                    this._currentPath = this._currentPath.split(address)[0] + address;
                    this._getFilteredList(this._fileExplorer[this._currentPath]);
                    break;
                  }
            }
        },
        _onDialogClose: function (args) {
            $("body").find("#" + this._ExplorerId + "_basicDialog_wrapper").remove();
            this._lastFocusedElement && this._lastFocusedElement.focus();
        },
        _switchView: function (event) {
            var changed = false;
            if (event.currentTarget.getAttribute("id") == this._ExplorerId + '_swithListView') {
                if (this.model.layout != ej.FileExplorer.layoutType.LargeIcons) {
                    this.model.layout = ej.FileExplorer.layoutType.LargeIcons;
                    changed = true;
                }
            } else {
                if (this.model.layout != ej.FileExplorer.layoutType.Grid) {
                    this.model.layout = ej.FileExplorer.layoutType.Grid;
                    changed = true;
                }
            }
            if (changed) {
                this._switchLayoutView();
            }
        },
        _switchLayoutView: function (isCode) {
            var changed = false;
            var items = this._sorteditems;
            this._currentPath = this._originalPath;
            switch (this.model.layout) {
                case ej.FileExplorer.layoutType.LargeIcons:
                case ej.FileExplorer.layoutType.Tile:
                    this._gridtag.hide();
                    this._tileContent.parent().show();
                    this._tileViewWrapper.removeClass("e-tileInfo-view");
                    if (this._statusbar) {
                        this._statusbar.find(".e-swithListView").removeClass("e-active");
                        this._statusbar.find(".e-switchGridView").removeClass("e-active");
                    }
                    if (this.model.layout == ej.FileExplorer.layoutType.LargeIcons)
                        this._statusbar && this._statusbar.find(".e-swithListView").addClass("e-active");
                    else {
                        this._tileViewWrapper.addClass("e-tileInfo-view");
                        this.items = this._tileView.find("li.e-tilenode");
                        this._setThumbImageHeight();
                    }                        
                    this._renderTileView(items);
                    changed = true;
                    break;
                case ej.FileExplorer.layoutType.Grid:
                default:
                    this._tileView && this._tileContent.parent().hide();
                    this._gridtag.show();
                    this._renderGridView(items);
                    if (this._statusbar) {
                        this._statusbar.find(".e-swithListView").removeClass("e-active");
                        this._statusbar.find(".e-switchGridView").addClass("e-active");
                    }
                    changed = true;
                    break;
            }
            this._changeLayoutActive(this.model.layout);
            if (changed) {
                this._updateItemStatus(items);
                this._setSelectedItems(this.model.selectedItems);
                var args = { layoutType: this.model.layout, isInteraction: !isCode };
                this._trigger("layoutChange", args);
            }
        },
        _wireEvents: function () {
            this._on($('#' + this._ExplorerId + '_newFolder'), "click", this._createNewFolder);
            this._on($('#' + this._ExplorerId + '_switchGridView'), "click", this._switchView);
            this._on($('#' + this._ExplorerId + '_swithListView'), "click", this._switchView);
            this._on(this.element, "keydown", this._keyDownOnInput);
            this._on(this._gridtag, "click", this._gridtagClick);
            this._on(this._tileViewWrapper, "click", this._tileViewWrapperClick);
            this.model.allowDragAndDrop && this._toolBarItems && this._on(this._toolBarItems, "dragover", this._preventDropOption);
        },
        _preventDropOption: function (e) {
                e.preventDefault();
                e.stopPropagation();
                e.originalEvent.dataTransfer.dropEffect = "none";
        },
        _onHideContextMenu: function() {
            (this._treeObj) && this._treeObj.element.find('.e-node-focus').removeClass('e-node-focus');
        },

        _adjustSize: function(args){
            this._isWindowResized = args ? true : false;
            this.adjustSize();
        },
        _closeDialog: function (event) {
            this._unwireDialogEvent(event);
            $(event.target).closest("div.e-dialog").find(".e-dialog").ejDialog("close");
        },

        _searchPath: function (event) {
            var code = this._getKeyCode(event);
            switch (code) {
                case 13:
                    this._searchbar && this._searchbar.val("");
                    var text = this._addresstag.val(), Items = text.split("/"), element = this._treetag;
                    if(this.model.path == "/")
                        Items[0] = "/";
                    for (var i = 0; i < Items.length; i++) {
                        if (Items[i]) {
                            element = this._findMatchingElement($(element).children("ul"), Items[i]);
                            if(element.length)
                                this._treetag.ejTreeView("selectNode", element) 
                            else {
                                this._setSelectedItems([Items[i]]);
                                if (this.model.selectedItems.length) {
                                    this._openAction();
                                }
                                else {
                                    this._alertDialog = this._createDialog(ej.buildTag('div.e-fe-dialog-label', String.format(this._getLocalizedLabels("ErrorPath"), text)), { width: 400, height: "auto", title: this._getLocalizedLabels("Error") });
                                    this._alertDialogObj = this._alertDialog.data("ejDialog");
                                }
                            }
                        }
                    }
                    break;
                case 27:
                    event.preventDefault();
                    this._updateAddressBar();
                    this._toolBarItems.focus();
                    break;
            }
        },

        _addressbarFocusout: function (event) {
            this._updateAddressBar();
        },

        _createDialog: function (contentTag, model) {
            var proxy = this;
            var dialog = ej.buildTag('div#' + this._ExplorerId + '_basicDialog.e-fe-dialog');
            $(contentTag).css("overflow", "hidden");
            $(dialog).append(contentTag);
            dialog.ejDialog({
                title: (model.title) ? model.title : "",
                width: model.width,
                maxWidth: "100%",
                isResponsive: proxy.model.isResponsive,
                target: proxy.element,
                closeIconTooltip: proxy._getLocalizedLabels("DialogCloseToolTip"),
                height: model.height,
                enableModal: true,
                showHeader: true,
                enableResize: false,
                enableAnimation: false,
                allowKeyboardNavigation: proxy.model.allowKeyboardNavigation,
                enableRTL: proxy.model.enableRTL,
                showRoundedCorner: proxy.model.showRoundedCorner,
                cssClass: this.model.cssClass + " e-fe-dialog",
                open: model.open,
                close: function (e) {  proxy._onDialogClose(e); }
            });
            return dialog;
        },
        _showErrorDialog: function (error) {
            this._alertDialog = this._createDialog(ej.buildTag('div.e-fe-dialog-label', error), { width: 400, height: "auto", title: this._getLocalizedLabels("Error") });
            this._alertDialogObj = this._alertDialog.data("ejDialog");
        },
        _findMatchingElement: function (element, text) {
            return $(element).children("li").filter(function (index) {
                if ($(this).find(".e-text:first").text() == text)
                    return $(this)
            });
        },
        _getKeyCode: function (e) {
            var code;
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            return code
        },


        _keyDownOnInput: function (e) {
            if ($(e.target).hasClass("e-tool-input"))
                return;
            var code = this._getKeyCode(e);
            if (!this.model.allowKeyboardNavigation) return;
            if (this._KeydownEventHandler(e)) return;
            switch (code) {
                case 49: // Ctrl + Shift + 1 for toolbar focus
                    if (e.shiftKey && e.ctrlKey && this.model.showToolbar) {
                        e.preventDefault();
                        this._addFocus(this._toolBarItems);
                    }
                    break;
                case 50: // Ctrl + Shift + 2 for treeview focus
                    if (e.shiftKey && e.ctrlKey && this.model.showNavigationPane) {
                        e.preventDefault();
                        this._addFocus(this._treetag);
                    }
                    break;
                case 51: // Ctrl + Shift + 3 for splitter focus
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._addFocus($(this._splittag.find(".e-splitbar")[0]));
                    }
                    break;
                case 52: // Ctrl + Shift + 4 for gridview focus
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._changeLayout(ej.FileExplorer.layoutType.Grid);
                    }
                    break;
                case 53: // Ctrl + Shift + 5 for tileview focus
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._changeLayout(ej.FileExplorer.layoutType.Tile);
                    }
                    break;
                case 54: // Ctrl + Shift + 6 for largeicons view
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._changeLayout(ej.FileExplorer.layoutType.LargeIcons);
                    }
                    break;
                case 55: // Ctrl + Shift + 7 for Statusbar focus
                    if (e.shiftKey && e.ctrlKey && this.model.showFooter) {
                        e.preventDefault();
                        this._addFocus(this._statusbar);
                    }
                    break;
                case 65: // Ctrl + A for select all file
                    if (e.ctrlKey) {
                        e.preventDefault();
                        var _items;
                        if (this.model.layout == "grid") {
                            _items = this.gridItems;
                            this._gridObj.clearSelection();
                            this._removeOldSelectionDetails();
                            this._addFocus(this._gridtag.find(".e-gridcontent"));
                            this._gridObj.selectRows(0, _items.length - 1, $(_items[_items.length - 1]).find("td:first"));
                        } else {
                            _items = this.items;
                            if (this.items.hasClass("e-active"))
                                this.items.removeClass("e-active").attr("aria-selected", false);
                            this._removeOldSelectionDetails();
                            this._addFocus(this._tileViewWrapper);
                            for (var i = 0; i < _items.length; i++) {
                                var e = { keyCode: 91, ctrlKey: true, currentTarget: _items[i], target: _items[i] };
                                this._upDatePathFromTileView(e);
                            }
                        }
                    }
                    break;
                case 78: // Alt + N for Create newfolder
                    if (e.altKey && this._hasEditContentsPermission(this._originalPath)) {
                        e.preventDefault();
                        this._createNewFolder();
                    }
                    break;
                case 85: // Ctrl + U for upload
                    if (e.ctrlKey && this._toUpload) {
                        e.preventDefault();
                        this.element.find(".e-uploadinput").click();
                    }
                    break;
                case 116: // F5 for refresh
                    e.preventDefault();
                    this._currentPath = this._originalPath;
                    this._highlightedNodes = this.model.selectedItems;
                    this._refreshItems((this._treeObj ? this._treeObj.getSelectedNode(): ""), this._originalPath);
                    break;
            }
        },
        _changeLayout: function (layout) {
            if (this.model.layout != layout) {
                this.model.layout = layout;
                this._removeFocus();
                this._switchLayoutView(layout);
            }
            this._focusLayout(layout);
        },
        _focusLayout: function (layout) {
            switch (layout) {
                case ej.FileExplorer.layoutType.Grid:
                    this._addFocus(this._gridtag.find(".e-gridcontent"));
                    break;
                case ej.FileExplorer.layoutType.Tile:
                case ej.FileExplorer.layoutType.LargeIcons:
                default:
                    this._addFocus(this._tileViewWrapper);
                    break;
            }
        },
        _getFocusedElement: function () {
            var focusedElement = this.element.find(".e-focus");
            return focusedElement = focusedElement ? focusedElement : $(':focus');
        },

        _addFocus: function (target) {
            if (!target.hasClass("e-focus")) {
                this._removeFocus();
                target.focus();
            }
        },
        _removeFocus: function () {
            var target = this._getFocusedElement();
            if (target.length > 0) {
                target.blur();
            }
        },

        _subControlsSetModel: function (prop, value) {
            var propObj = {};
            propObj[prop] = value;
            this._treeObj && this._treeObj.option(prop, value);
            if (this._downloadDialogObj && this._downloadDialogObj.isOpen()) this._downloadDialogObj.option(prop, value);
            if (this._newFolderDialogObj && this._newFolderDialogObj.isOpen()) this._newFolderDialogObj.option(prop, value);
            if (this._renameDialogObj && this._renameDialogObj.isOpen()) this._renameDialogObj.option(prop, value);
            if (this._openDialogObj && this._openDialogObj.isOpen()) this._openDialogObj.option(prop, value);
            if (this._detailsDialogObj && this._detailsDialogObj.isOpen()) this._detailsDialogObj.option(prop, value);
            if (this._alertDialogObj && this._alertDialogObj.isOpen()) this._alertDialogObj.option(prop, value);
            if (this._alertWindowObj && this._alertWindowObj.isOpen()) this._alertWindowObj.option(prop, value);
            this._treeContextMenutag && this._treeMenuObj.option(prop, value);
            this._tileContextMenutag && this._viewMenuObj.option(prop, value);
            this._toolBarObj && this._toolBarObj.option(prop, value);
            this._uploadtag && this._uploadtag.data("ejUploadbox").option(prop, value);
            this._splitObj && this._splitObj.option(prop, value);
            this._splitButtonObj && this._splitButtonObj.option(prop, value);
            this._splitButtonObj1 && this._splitButtonObj1.option(prop, value);
            this._statusbar.find("button").length && this._statusbar.find("button").ejButton(propObj);
            this._headCheckObj && this._headCheckObj.option(prop, value);
            this._tileView.find(".e-tile-checkbox").length && this._tileView.find(".e-tile-checkbox").ejCheckBox(propObj);
            this._gridtag.find(".e-grid-row-checkbox").length && this._gridtag.find(".e-grid-row-checkbox").ejCheckBox(propObj);
        },
        _removeDialog: function (obj) {
            obj.close();
            var isOverLay = obj._overLay;
            isOverLay && isOverLay.remove();
            obj._ejDialog.remove();
        },
        _reSizeHandler: function (args) {
            this._splitterCorrection();
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            if (this.model.layout == "grid") {
                var height = this._splittag.outerHeight() - this._gridtag.find(".e-gridheader").outerHeight();
                this._gridObj && this._gridObj.option("scrollSettings", { height: this.model.showFooter ? height - this._statusbar.outerHeight() : height, width: this._splittag.find(".e-cont2").width() });
            }
            else {
                this._tileScroll && this._tileScroll.option("width", parseInt(this._splittag.find(".e-cont2").width()));
                this._setThumbImageHeight();
            }
            this._treeScroll && this._treeScroll.option("width", parseInt(this._splittag.find(".e-cont1").width()));
            this._waitingPopup && this._waitingPopup.refresh();
        },
        _splitterCorrection: function () {
            var left = this._splittag.find(this.model.enableRTL ? ".e-cont2" : ".e-cont1").width() - 1;
            this._splittag.find(".e-split-divider").css("left", left).css("z-index", 1);
        },
        _findCommand: function (command, obj, isMenu) {
            var proxy = this;
            $.each(obj, function(key, val) {
                for(var j = 0, leng = val.length; j < leng; j++) {
                    if(val[j].toLowerCase() == command.toLowerCase()) {
                        command = isMenu ? proxy["_menu" + val[j]] : val[j];
                        return false;
                    }
                }
            });
            return command;
        },
        _getElement: function (node) {
            typeof node == "string" && (node = this._findCommand(node, this.model.tools));
            (typeof node != "object") && (node = (typeof node == "string") ? (this._toolBarObj.itemsContainer.find("li#" + node).length > 0 ? this._toolBarObj.itemsContainer.find("li#" + node) : this._toolBarObj.itemsContainer.find("li#" + this._ExplorerId + node.replace(/ /g, ''))) : this._toolBarObj.itemsContainer.find('li').eq(node));
            node = $(node);
            return $(node[0]);
        },
        _updateToolbar: function () {
            this._renderToolBar();
            this._selectedStates.length >= 2 && this._enableToolbarItem("Back");
            this._updateAddressBar();
            if (this._selectedItems.length > 0) {
                if (this._toRead) {
                    this._toDownload && this._enableToolbarItem("Download");
                    this._enableEditingTools();
                    this._toCopy && this._enableToolbarItem("Copy");
                }
            }
            if (!ej.isNullOrUndefined(this._fileName) && this._fileName != "")
                this._toRead && this._enableToolbarItem("Paste");
        },
        _enableEditingMenus: function () {
            var items = [this._menuRename, this._menuDelete, this._menuCut];
            for (var i = 0; i < items.length; i++) {
                if (this._restrictedMenuOption.indexOf(items[i]) < 0) {
                    this._viewMenuObj && this._viewMenuObj.enableItem(items[i]);
                    this._treeMenuObj && this._treeMenuObj.enableItem(items[i]);
                }
            }
        },
        _disableEditingMenus: function () {
            var items = [this._menuRename, this._menuDelete, this._menuCut];
            for (var i = 0; i < items.length; i++) {
                this._viewMenuObj && this._viewMenuObj.disableItem(items[i]);
                this._treeMenuObj && this._treeMenuObj.disableItem(items[i]);
            }
        },
        _updateSelectionDetails: function (nodeType) {
            if (this._selectedItems.length == 0)
                this._removeOldSelectionDetails(nodeType);
            else {
                this._updateToolbarItems();
                this._updateNewFolderTool(this._hasEditContentsPermission(this._originalPath));
            }
        },
        _updatePasteTool: function () {
            this._toolBarItems && ((this._option && this._toRead) ? this._enableToolbarItem("Paste") : this._disableToolbarItem("Paste"));
        },
        _updateAccessRules: function (path) {
            var _value = this._feParent[path];
            this._updateAccessValue(_value);
        },
        _updateAccessValue: function (_value) {
            if (!ej.isNullOrUndefined(_value) && !ej.isNullOrUndefined(_value.permission)) {
                if (!_value.permission.Copy) this._toCopy = false;
                if (!_value.permission.Download) this._toDownload = false;
                if (!_value.permission.Edit) this._toEdit = false;
                if (!_value.permission.EditContents) this._toEditContents = false;
                if (!_value.permission.Read) this._toRead = false;
                if (!_value.permission.Upload) this._toUpload = false;
            }
        },
        _updateToolbarItems: function () {
            if (this._toolBarItems) {
                (this._toRead && this._toDownload) ? this._enableToolbarItem("Download") : this._disableToolbarItem("Download");
                (this._toRead && this._toUpload) ? this._enableToolbarItem("Upload") : this._disableToolbarItem("Upload");
                (this._toRead && this._toEdit) ? this._enableEditingTools() : this._disableEditingTools();
                (this._toRead && this._toCopy) ? this._enableToolbarItem("Copy") : this._disableToolbarItem("Copy");
                this._updatePasteTool();
            }
        },
        _getFilePermission: function (path) {
            return this._feParent[path] ? this._feParent[path].permission : null;
        },
        _updateCurrentPathPermission: function () {
            this._removeOldSelectionDetails();
            this._toDownload = false; this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
            this._updateAccessRules(this._originalPath);
            this._toolBarItems && (this._toUpload ? this._enableToolbarItem("Upload") : this._disableToolbarItem("Upload"));
            this._updateNewFolderTool(this._hasEditContentsPermission(this._originalPath));
            this._disableToolbarItem("Copy");
            this._updatePasteTool();
        },
        _updateNewFolderTool: function (value) {
            this._toolBarItems && (value ? this._enableToolbarItem("NewFolder") : this._disableToolbarItem("NewFolder"));
        },
        _hasEditContentsPermission: function (path) {
            var permission = this._getFilePermission(path);
            return permission ? ((permission.Read && permission.EditContents) ? true : false) : true;
        },
        _hasReadPermission: function (path) {
            var permission = this._getFilePermission(path);
            return (permission && !permission.Read) ? false : true;
        },
        _unwireEvents: function () {
            this._off($('#' + this._ExplorerId + '_newFolder'), "click", this._createNewFolder);
            this._off($('#' + this._ExplorerId + '_switchGridView'), "click", this._switchView);
            this._off($('#' + this._ExplorerId + '_swithListView'), "click", this._switchView);
            this._addressBarEvents("_off");
            this._off($('#' + this._ExplorerId + '_searchbar'), "focus", this._inputFocusin);
            this._off($('#' + this._ExplorerId + '_searchbar'), "keyup", this._onSearchKeyup);
            this._off(this.element, "keydown", this._keyDownOnInput);
            this._off(this._gridtag, "click");
            this._off(this._tileViewWrapper, "click");
            this.model.isResponsive &&this._off($(window),'resize',this._adjustSize);
            this._toolBarItems && this._off(this._toolBarItems, "dragover", this._preventDropOption);
        },

        _wireResizing: function () {
            this.model.isResponsive ? this._on($(window),'resize',this._adjustSize) :this._off($(window),'resize',this._adjustSize);
        },
        adjustSize: function () {
            this._ensureResolution();
            (!this._isWindowResized) && this.model.showToolbar && this.model.isResponsive && this._toolBarObj._reSizeHandler();
            this._isWindowResized = false;
            this._splittag.css('height', (this.element.height() - ((this.model.showToolbar && this._toolBarItems) ? this._toolBarItems.outerHeight() : 0)));
            var layoutHeight = this._splittag.outerHeight() - (this.model.showFooter ? this._statusbar.outerHeight() : 0);
            this._tileContent && this._tileContent.parent(".e-tile-wrapper").height(layoutHeight);
            this._tileScroll && this._tileScroll.option("height", layoutHeight);
            this._gridtag && this._gridtag.height(layoutHeight);
            this._splitObj && this._splitObj._windowResized();
            this._treeScroll && this._treeScroll.option("height", this._splittag.height());
            this._reSizeHandler();
        },
        refresh: function () {
            this._refreshItems(this._selectedNode, this._currentPath);
        },
        enableToolbarItem: function (liElement) {
            this._removeRestrictedToolItem(liElement);
            liElement = this._getElement(liElement);
            (liElement[0] != null && this._toolBarObj) && this._toolBarObj.enableItem(liElement);
        },
        disableToolbarItem: function (liElement) {
            liElement = this._getElement(liElement);
            if(liElement[0] != null && this._toolBarObj) {
                var operation = liElement.attr("id").replace(this._ExplorerId, "");
                this._restrictedToolbarOptions.push(operation);
                this._toolBarObj.disableItem(liElement);
            }
        },
        removeToolbarItem: function (liElement) {
            this._removeRestrictedToolItem(liElement);
            liElement = this._getElement(liElement);
            (liElement[0] != null && this._toolBarObj) && this._toolBarObj.removeItem(liElement);
        },
        _removeRestrictedToolItem: function (item) {
            var operation = typeof item == "string" ? item : item.attr("id").replace(this._ExplorerId, "");
            for (var i = 0; i < this._restrictedToolbarOptions.length; i++) {
                if (this._restrictedToolbarOptions[i] == operation) {
                    this._restrictedToolbarOptions.splice(i, 1);
                    break;
                }
            }
        },
        _onThumbStart: function (args) {
            var dragElement= $(args.originalEvent.target);
            if (dragElement.hasClass("e-draggable") || dragElement.closest(".e-draggable").length) {
                args.cancel = true;
                return false;
            }
        }
    });
    ej.FileExplorer.Locale = {};

    ej.FileExplorer.Locale["en-US"] = {
        Folder: "Folder",
        EmptyFolder: "This folder is empty",
        ProtectedFolder:"You don't currently have permission to access this folder",
        EmptyResult:"No items match your search",
        Back: "Backward",
        Forward: "Forward",
        Upward:"Upward",
        Refresh: "Refresh",
        Addressbar: "Address bar",
        Upload: "Upload",
        Rename: "Rename",
        Delete: "Delete",
        Download: "Download",
        Error: "Error",
        Cut: "Cut",
        Copy: "Copy",
        Paste: "Paste",
        Details: "Details",
        Searchbar: "Search bar",
        Open: "Open",
        Search: "Search",
        NewFolder: "New folder",
        SortBy: "Sort by",
        Size: "Size",
        RenameAlert: "Please enter new name",
        NewFolderAlert: "Please enter new folder name",        
        ContextMenuOpen: "Open",
        ContextMenuNewFolder: "New folder",
        ContextMenuDelete: "Delete",
        ContextMenuRename: "Rename",
        ContextMenuUpload: "Upload",
        ContextMenuDownload: "Download",
        ContextMenuCut: "Cut",
        ContextMenuCopy: "Copy",
        ContextMenuPaste: "Paste",
        ContextMenuGetinfo: "Get info",
        ContextMenuRefresh: "Refresh",
        ContextMenuOpenFolderLocation: "Open folder location",
        Item: "item",
        Items: "items",
        Selected: "selected",
        ErrorOnFolderCreation: "This destination already contains a folder named '{0}'. Do you want to merge this folder content with already existing folder '{0}'?",
        InvalidFileName: "A file name can't contain any of the following characters: \\/:*?\"<>|",
        GeneralError: "Please see browser console window for more information",
        ErrorPath: "FileExplorer can't find '{0}'. Check the spelling and try again.",
        ReplaceAlert: "File named '{0}' already exists. Replace old file with new one?",
        DuplicateAlert: "There is already a file with the same name '{0}'. Do you want to create file with duplicate name",
        DuplicateFileCreation: "There is already a file with the same name in this location. Do you want to rename '{0}' to '{1}'?",
        DeleteFolder: " Are you sure you want to delete ",
        DeleteMultipleFolder: "Are you sure you want to delete these {0} items?",
        CancelPasteAction: "The destination folder is a subfolder of source folder.",
        OkButton: "OK",
        ContextMenuSortBy: "Sort by",
        CancelButton: "Cancel",
        YesToAllButton: "Yes to all",
        NoToAllButton: "No to all",
        YesButton: "Yes",
        NoButton: "No",
        SkipButton:"Skip",
        Grid: "Grid view",
        Tile: "Tile view",
        LargeIcons: "Large icons",
        Name: "Name",
        Location: "Location",
        Type: "Item type",
        Layout:"Layout",
        Created: "Created",
        Accessed: "Accessed",
        Modified: "Modified",
        Permission: "Permission",
        DialogCloseToolTip: "Close",
        UploadSettings: {
            buttonText: {
                upload: "Upload",
                browse: "Browse",
                cancel: "Cancel",
                close: "Close"
            },
            dialogText: {
                title: "Upload Box",
                name: "Name",
                size: "Size",
                status: "Status"
            },
            dropAreaText: "Drop files or click to upload",
            filedetail: "The selected file size is too large. Please select a file within the valid size.",
            denyError: "Files with #Extension extensions are not allowed.",
            allowError: "Only files with #Extension extensions are allowed.",
            cancelToolTip: "Cancel",
            removeToolTip: "Remove",
            retryToolTip: "Retry",
            completedToolTip: "Completed",
            failedToolTip: "Failed",
            closeToolTip: "Close"
        }
    };


    ej.FileExplorer.filterType = {
        /**  Supports to search text with startswith  */
        StartsWith: "startswith",
        /**  Supports to search text with contains */
        Contains: "contains",
        /**  Supports to search text with endswith */
        EndsWith: "endswith"        
    };
    ej.FileExplorer.layoutType = {
        Tile: "tile",
        Grid: "grid",
        LargeIcons: "largeicons"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html Captcha elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejCaptcha", "ej.Captcha", {

        element: null,

        model: null,
        validTags: ["div"],
        _setFirst: false,

        _rootCSS: "e-captcha",

        defaults: {

            enablePattern: true,

            targetInput: "",

            targetButton: "",

            height: 50,

            width: 150,

            characterSet: "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",

            maximumLength: 8,

            minimumLength: 4,

            enableCaseSensitivity: true,

            enableAutoValidation: false,

            encryptedCode: "",

            customErrorMessage: "Invalid Captcha",

            showAudioButton: false,

            showRefreshButton: false,
			
			locale: "en-US",

            enableRTL: false,

            requestMapper: "",

            refreshBegin: "",

            refreshSuccess: "",

            refreshFailure: "",

            refreshComplete: "",

            mapper: "",

            hatchStyle: "BackwardDiagonal"
        },


        dataTypes: {
            targetInput: "string",
            targetButton: "string",
            height: "number",
            width: "number",
            characterSet: "string",
            maximumLength: "number",
            minimumLength: "number",
            enableCaseSensitivity: "boolean",
            enableAutoValidation: "boolean",
            encryptedCode: "string",
            customErrorMessage: "string",
            requestMapper: "string",
            showAudioButton: "boolean",
			locale: "string",
            showRefreshButton: "boolean",
            enableRTL: "boolean",
            mapper: "string",
            hatchStyle: "enum",
            enablePattern: "boolean"
        },
		_updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.Captcha", this.model.locale);
        },

		_getLocalizedLabels: function (property) {
            return this._localizedLabels[property] === undefined ? ej.Captcha.Locale["en-US"][property] : this._localizedLabels[property];
        },
        _init: function () {
            this._initialize();
            this._wireEvents();
        },

        _initialize: function () {
			this._updateLocalConstant();
            $("#" + this._id + "_RefreshButton").ejButton({ size: "normal", showRoundedCorner: true, contentType: "imageonly", prefixIcon: "e-icon e-captcha e-reload", type: "button" });
            $("#" + this._id + "_PlayAudio").ejButton({ size: "normal", showRoundedCorner: true, contentType: "imageonly", prefixIcon: "e-icon e-captcha e-volume-up", type: "button" });
			$("#" + this._id +  "_ValidText").attr("placeholder", this._getLocalizedLabels("placeHolderText"));
            this._control = $("#" + this._id).get(0);
            if (!this.model.targetInput)
                this.model.targetInput = this._id + "_ValidText";
            this._target = $("#" + this.model.targetInput).get(0);
            this._captchaImage = $("#" + this._id + "_CaptchaImage").get(0);
            this._message = $("#" + this._id + "_CaptchaMessage").get(0);
            this._refreshButton = $("#" + this._id + "_RefreshButton").get(0);
            this._form = $(this._target).parents('form')[0];
            this._audioObject = $("#" + this._id + "_AudioObject").get(0);
            this._audioButton = $("#" + this._id + "_PlayAudio").get(0);
            this._audioPluginObject = null;
            this._audioType = "audio/wav";
			if(!ej.isNullOrUndefined(this.model.targetButton) &&  !(this.model.targetButton === "")){
				this._submitButton = $("#" + this.model.targetButton).get(0);
				if (!this._submitButton)
					this._submitButton = $("[id$='" + this.model.targetButton + "']").get(0);
			}
            this._hiddenField = $("#" + this._id + "_Hidden").get(0);

            if (this._audioObject) {
                if (!this._isSupportAudio(this._audioType)) {
                    this._appendAudioPlugin();
                }
            }
        },


        _wireEvents: function (val) {
            this._FormSubmitDelegate = $.proxy(this.formSubmit, this);
            this._CaptchaRefreshDelegate = $.proxy(this.refresh, this);
            this._PlayAudioDelegate = $.proxy(this.playAudio, this);
            if (this._audioButton)
                $(this._audioButton).on('click', this._PlayAudioDelegate);
            if (this._submitButton)
                $(this._submitButton).on('click', this._FormSubmitDelegate);
            if (this._refreshButton)
                $(this._refreshButton).on('click', this._CaptchaRefreshDelegate);
        },


        _unwireEvents: function () {
            if (this._audioButton)
                $(this._audioButton).off('click', this._PlayAudioDelegate);
            if (this._submitButton)
                $(this._submitButton).off('click', this._FormSubmitDelegate);
            if (this._refreshButton)
                $(this._refreshButton).off('click', this._CaptchaRefreshDelegate);
        },


        playAudio: function () {
            try {
                if (this._audioPluginObject) {
                    this._audioPluginObject.Play();
                } else {
                    if (this._audioObject && this._audioObject.play) {
                        this._audioObject.play();
                    }
                }
            } catch (e) { }
        },


        _isSupportAudio: function (type) {
            if (!document.createElement("audio").canPlayType) {
                return false;
            } else {
                return document.createElement("audio").canPlayType(type).match(/maybe|probably/i) ? true : false;
            }
        },

        _appendAudioPlugin: function () {
            $(this._audioPluginObject).remove();
            var obj = this._createAudioPluginObject();
            this._audioObject.parentNode.appendChild(obj);
            this._audioPluginObject = $("#" + this._id + "_AudioPlugin").get(0);
        },

        _createAudioPluginObject: function () {
            var a = document.createElement("embed");
            a.setAttribute("id", this._id + "_AudioPlugin");
            a.setAttribute("src", this.model.audioUrl);
            a.setAttribute("name", "AudioPlugin");
            a.setAttribute("enablejavascript", "true");
            a.setAttribute("type", "audio/wav");
            a.setAttribute("autostart", "false");
            a.setAttribute("pluginspage", "http://www.apple.com/quicktime/download/");
            a.style.top = 0;
            a.style.left = 0;
            a.style.width = "0px";
            a.style.height = "0px";
            a.style.position = "absolute";
            return a;
        },


        _onSuccess: function (captchaResult) {
            var jsonCaptcha = captchaResult.d ? JSON.parse(captchaResult.d) : captchaResult;
            try {
                if (this._audioPluginObject) {
                    this._audioPluginObject.Pause();
                } else if (this._audioObject && this._audioObject.pause) {
                    this._audioObject.pause();
                }
            } catch (e) { }

            this._captchaImage.src = jsonCaptcha.NewChallenge;
            if (this._audioObject)
                this._audioObject.src = jsonCaptcha.AudioLink;

            this.model.audioURL = jsonCaptcha.AudioLink;

            if (this._audioPluginObject) {
                this._appendAudioPlugin();
            }

            if (jsonCaptcha.Validation == "False")
                this.model.isValid = false;
            else
                this.model.isValid = true;
            if (this.model.enableAutoValidation)
                this._displayMessages();
            if ($("#" + this._id + "_ValidText"))
                $("#" + this._id + "_ValidText").val("");
            this.model.encryptedCode = jsonCaptcha.Script;
            $(this._hiddenField).val(this.model.encryptedCode);
        },


        _displayMessages: function () {
            if (this.model.isValid) {
                $("#" + this._id + "_CaptchaMessage").html("");
            }
            else {
                $("#" + this._id + "_CaptchaMessage").html(this.model.locale == "en-US" ? this.model.customErrorMessage : ej.Captcha.Locale[this.model.locale].customErrorMessage);
                $("#" + this._id + "_ValidText").addClass("error");
            }

        },
            //On captcha refresh ajax Success
        _onRefreshSuccess: function (captchaRefresh) {
            var jsonCaptcha = captchaRefresh.d ? JSON.parse(captchaRefresh.d) : captchaRefresh;
            try {
                if (this._audioPluginObject) {
                    this._audioPluginObject.Pause();
                } else if (this._audioObject && this._audioObject.pause) {
                    this._audioObject.pause();
                }
            } catch (e) { }

            this._captchaImage.src = jsonCaptcha.NewChallenge;
            if (this._audioObject) {
                this._audioObject.src = jsonCaptcha.AudioLink;
            }
            this.model.audioUrl = jsonCaptcha.AudioLink;

            if (this._audioPluginObject) {
                this._appendAudioPlugin();
            }
            this.model.encryptedCode = jsonCaptcha.EncryptedText;
            $(this._hiddenField).val(jsonCaptcha.EncryptedText);
        },


            //Hanldes the form submit event
        formSubmit: function (event) {
            var proxy = this;
            var data = {
                Height: this.model.height,
                Width: this.model.width,
                CharacterSet: this.model.characterSet,
                MaximumLength: this.model.maximumLength,
                MinimumLength: this.model.minimumLength,
                CaseSensitive: this.model.enableCaseSensitivity,
                ShowRefreshButton: this.model.showRefreshButton,
                ShowAudioButton: this.model.showAudioButton,
                EncryptedText: this.model.encryptedCode,
                ResponseText: $(this._target).val(),
                Id: this._id,
                HatchStyle: this.model.hatchStyle,
                EnablePattern: this.model.enablePattern,
                RequestType: "CaptchaRequest",
                ActionType: "Validation"
            };
            $.ajax({
                type: 'POST',
                url: this.model.requestMapper ? this.model.requestMapper : this.model.pathName + "/" + this.model.mapper,
                data: JSON.stringify({ captchaModel: data }),
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                async: false,
                success: function (CaptchaResult) {
                    if (CaptchaResult)
                        proxy._onSuccess(CaptchaResult);
                    return;
                },
                error: function (e) {
                    proxy._trigger("refreshFailure");
                    return;
                }
            });
                //Check if invalid and stop form submit
            if (!this.model.isValid && this.model.enableAutoValidation) {
                event.preventDefault();
                event.stopPropagation();
                return false;
            }
        },
            //Hanlder for captcha refresh event
        refresh: function (event) {
            var proxy = this;
            var data = {
                Height: this.model.height,
                Width: this.model.width,
                CharacterSet: this.model.characterSet,
                MaximumLength: this.model.maximumLength,
                MinimumLength: this.model.minimumLength,
                CaseSensitive: this.model.enableCaseSensitivity,
                EncryptedText: this.model.encryptedCode,
                ShowRefreshButton: this.model.showRefreshButton,
                ShowAudioButton: this.model.showAudioButton,
                Id: this._id,
                HatchStyle: this.model.hatchStyle,
                EnablePattern: this.model.enablePattern,
                RequestType: "CaptchaRequest",
                ActionType: "Refresh"
            };
            if (proxy._trigger("refreshBegin"))
                return false;
            $.ajax({
                type: 'POST',
                url: this.model.requestMapper ? this.model.requestMapper : this.model.pathName + "/" + this.model.mapper,
                data: JSON.stringify({ captchaModel: data }),
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                async: false,
                success: function (CaptchaRefresh) {
                    if (CaptchaRefresh) {
                        proxy._onRefreshSuccess(CaptchaRefresh);
                        proxy._trigger("refreshSuccess");
                    }
                    return;
                },
                error: function (errData) {
                    proxy._trigger("refreshFailure")
                    return;
                },
                complete: function (jqXHR, textStatus) {
                    proxy._trigger("refreshComplete")
                    return;
                }
            });
        }
    });
    ej.HatchStyle = {
         None:"none",        
         BackwardDiagonal:"backwardDiagonal",        
         Cross:"cross",
         DarkDownwardDiagonal:"darkDownwardDiagonal",
         DarkHorizontal:"darkHorizontal",
         DarkUpwardDiagonal:"darkUpwardDiagonal",
         DarkVertical:"darkVertical",
         DashedDownwardDiagonal:"dashedDownwardDiagonal",
         DashedHorizontal:"dashedHorizontal",
         DashedUpwardDiagonal:"dashedUpwardDiagonal",
         DashedVertical:"dashedVertical",
         DiagonalBrick:"diagonalBrick",
         DiagonalCross:"diagonalCross",
         Divot:"divot",
         DottedDiamond:"dottedDiamond",       
         DottedGrid:"dottedGrid",
         ForwardDiagonal:"forwardDiagonal",
         Horizontal:"horizontal",
         HorizontalBrick:"horizontalBrick",
         LargeCheckerBoard:"largeCheckerBoard",
         LargeConfetti:"largeConfetti",
         LargeGrid:"largeGrid",
         LightDownwardDiagonal:"lightDownwardDiagonal",
         LightHorizontal:"lightHorizontal",
         LightUpwardDiagonal:"lightUpwardDiagonal",
         LightVertical:"lightVertical",
         Max:"max",
         Min:"min",
         NarrowHorizontal:"narrowHorizontal",
         NarrowVertical:"narrowVertical",
         OutlinedDiamond:"outlinedDiamond",
         Percent90:"percent90",
         Wave:"wave",
         Weave:"weave",
         WideDownwardDiagonal:"wideDownwardDiagonal",
         WideUpwardDiagonal:"wideUpwardDiagonal",
         ZigZag:"zigZag"    
    };
	ej.Captcha.Locale = ej.Captcha.Locale || {};
    ej.Captcha.Locale["default"] = ej.Captcha.Locale["en-US"] = {        
        placeHolderText: "Type the code shown",
		CustomErrorMessage: "Invalid Captcha"
    };
})(jQuery, Syncfusion);;
(function ($, ej) {
    "use strict";
    var HeatMapGrid = (function () {
        function HeatMapGrid(name, heatmap) {
            this._heatmap = heatmap ? heatmap : null;
            if (heatmap) {
                heatmap._grid = this;
            }
            this._rootCSS = "e-grid",
            // widget element will be automatically set in this
	       this.element = null,
	       this.validTags = ["div"],
            // user defined model will be automatically set in this
	       this.model = null,
	      this._requiresID = true,
	       this.keyConfigs = /** @lends ejGrid# */{
	           focus: "e",
	           insertRecord: "45", //Insert
	           deleteRecord: "46", // delete
	           editRecord: "113", //F2
	           saveRequest: "13", // enter
	           cancelRequest: "27", //Esc
	           nextPage: "34", // PgDn
	           previousPage: "33", // PgUp
	           lastPage: "ctrl+alt+34", //"CtrlAltPgDn",
	           firstPage: "ctrl+alt+33", //"CtrlPlusAltPlusPgUp",
	           nextPager: "alt+34", //"AltPlusPgDown",
	           previousPager: "alt+33", //"AltPlusPgUp",
	           firstCellSelection: "36", //"Home",
	           lastCellSelection: "35", //"End",
	           firstRowSelection: "ctrl+36", //"CtrlPlusHome",
	           lastRowSelection: "ctrl+35", //"CtrlPlusEnd",
	           upArrow: "38", //Up arrow
	           downArrow: "40", //Down arrow
	           rightArrow: "39", //Right arrow
	           leftArrow: "37", //Left arrow
	           moveCellRight: "9", //tab
	           moveCellLeft: "shift+9", //shifttab
	           selectedGroupExpand: "alt+40", //"AltPlusDownArrow",
	           totalGroupExpand: "ctrl+40", //"CtrlPlusDownArrow",
	           selectedGroupCollapse: "alt+38", //"AltPlusUpArrow",
	           totalGroupCollapse: "ctrl+38", //"CtrlPlusUpArrow",
	           multiSelectionByUpArrow: "shift+38",//"shiftPlusUpArrow",
	           multiSelectionByDownArrow: "shift+40",//"shiftPlusDownArrow"
	       },
            this._ignoreOnPersist = [
                "query", "isEdit", "toolbarClick", "queryCellInfo", "mergeCellInfo", "currentViewData", "enableAltRow", "enableRTL", "contextClick", "contextOpen",
                "rowDataBound", "rowTemplate", "detailsDataBound", "detailsTemplate", "childGrid", "summaryRows", "toolbarSettings",
                "editSettings", "allowMultiSorting", "enableAutoSaveOnSelectionChange", "locale", "allowCellMerging",
                "allowTextWrap", "textWrapSettings", "cssClass", "dataSource", "groupSettings.enableDropAreaAnimation", "enableRowHover", "showSummary", "allowGrouping",
                "enableHeaderHover", "allowKeyboardNavigation", "scrollSettings.frozenRows", "scrollSettings.frozenColumns", "enableTouch", "contextMenuSettings.enableContextMenu",
                "exportToExcelAction", "exportToWordAction", "exportToPdfAction"
            ],
           this.ignoreOnExport = [
                "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "rowDataBound", "rowTemplate",
                "detailsDataBound", "detailsTemplate", "editSettings", "pageSettings", "enableAutoSaveOnSelectionChange", "localization", "allowScrolling",
                "cssClass", "dataSource", "groupSettings.enableDropAreaAnimation", "enableRowHover", "allowSummary",
                "enableHeaderHover", "allowKeyboardNavigation"
           ],
            this.observables = ["dataSource", "selectedRowIndex", "pageSettings.currentPage"],
            this._tags = [{
                tag: "columns",
                attr: ["allowEditing", "allowFiltering", "allowGrouping", "allowResizing", "allowSorting", "cssClass", "customAttributes", "dataSource", "defaultValue",
                "disableHtmlEncode", "editTemplate", "editType", "foreignKeyField", "foreignKeyValue", "headerTemplateID", "headerText", "isFrozen",
                "isIdentity", "isPrimaryKey", "filterBarTemplate", "textAlign", "templateID", "textAlign", "headerTextAlign", "tooltip", "clipMode",
                "validationRules.minlength", "validationRules.maxlength", "validationRules.range", "validationRules.number", "validationRules.required",
                "editParams.decimalPlaces", [{ tag: "commands", attr: ["type", "buttonOptions"] }]
                ],
                content: "template"
            }, {
                tag: "summaryRows",
                attr: ["showCaptionSummary", "showTotalSummary", [{
                    tag: "summaryColumns", attr: ["customSummaryValue", "dataMember", "displayColumn", "summaryType", "template"]
                }]]
            }, {
                tag: "stackedHeaderRows",
                attr: [
                [{
                    tag: "stackedHeaderColumns", attr: ["headerText", "column"]
                }]]
            }, {
                tag: "filterSettings.filteredColumns", attr: []
            }, {
                tag: "sortSettings.sortedColumns", attr: []
            }],
            this._dataSource = ej.util.valueFunction("dataSource"),
            this._selectedRow = ej.util.valueFunction("selectedRowIndex"),
            this._currentPage = ej.util.valueFunction("pageSettings.currentPage"),
            this.dataTypes = {
                dataSource: "data",
                query: "data",
                columns: "array",
                childGrid: "parent",
                gridLines: "enum",
                summaryRows: "array",
                stackedHeaderRows: "array",
                toolbarSettings: {
                    toolbarItems: "array",
                    customToolbarItems: "array"
                },
                contextMenuSettings: {
                    contextMenuItems: "array",
                    customContextMenuItems: "array",
                    subContextMenu: "array"
                },
                selectionSettings: {
                    selectionMode: "array",
                    selectedRecords: "array"
                },
                sortSettings: {
                    sortedColumns: "array"
                },
                filterSettings: {
                    filteredColumns: "array",
                    filterType: "enum",
                    filterBarMode: "enum",
                },
                groupSettings: {
                    groupedColumns: "array"
                },
                editSettings: {
                    editMode: "enum",
                    formPosition: "enum",
                    rowPosition: "enum",
                },
                searchSettings: {
                    fields: "array"
                },
                textWrapSettings: {
                    wrapMode: "enum"
                }
            },
			this.model = {
			    allowPaging: false,
			    showColumnChooser: false,
			    gridLines: "both",
			    allowSorting: false,
			    showStackedHeader: false,
			    selectedRecords: [],
			    stackedHeaderRows: [],
			    allowFiltering: false,
			    allowMultipleExporting: false,
			    allowSelection: true,
			    allowGrouping: false,
			    showSummary: false,
			    allowResizing: false,
			    allowResizeToFit: false,
			    allowTextWrap: false,
			    allowCellMerging: false,
			    enableRowHover: true,
			    enablePersistence: false,
			    enableFocusout: false,
			    selectedRowIndex: -1,
			    allowSearching: false,
			    enableToolbarItems: false,
			    enableHeaderHover: false,
			    allowReordering: false,
			    allowKeyboardNavigation: true,
			    allowRowDragAndDrop: false,
			    enableTouch: true,
			    columnLayout: 'auto',
			    selectionType: "single",
			    dataSource: null,
			    cssClass: "",
			    allowScrolling: false,
			    locale: "en-US",
			    enableAutoSaveOnSelectionChange: true,
			    allowMultiSorting: false,
			    exportToExcelAction: "",
			    exportToWordAction: "",
			    exportToPdfAction: "",
			    _groupingCollapsed: [],
			    editSettings: {
			        allowEditing: false,
			        showAddNewRow: false,
			        allowAdding: false,
			        allowDeleting: false,
			        editMode: "normal",
			        rowPosition: "top",
			        dialogEditorTemplateID: null,
			        allowEditOnDblClick: true,
			        externalFormTemplateID: null,
			        inlineFormTemplateID: null,
			        formPosition: "bottomleft",
			        titleColumn: null,
			        showConfirmDialog: true,
			        showDeleteConfirmDialog: false
			    },
			    selectionSettings: {
			        selectionMode: ["row"],
			        enableToggle: false,
			        cellSelectionMode: "flow"
			    },
			    pageSettings: {
			        pageSize: 12,
			        pageCount: 8,
			        currentPage: 1,
			        totalPages: null,
			        enableTemplates: false,
			        showDefaults: false,
			        template: null,
			        totalRecordsCount: null,
			        enableQueryString: false,
			        printMode: "allpages"
			    },
			    groupSettings: {
			        showDropArea: true,
			        showToggleButton: false,
			        showGroupedColumn: true,
			        showUngroupButton: true,
			        enableDropAreaAutoSizing: true,
			        captionFormat: null,
			        groupedColumns: []
			    },
			    contextMenuSettings: {
			        enableContextMenu: false,
			        contextMenuItems: ["Add Record", "Edit Record", "Delete Record", "Sort In Ascending Order", "Sort In Descending Order", "Next Page", "Last Page", "Previous Page", "First Page", "Save", "Cancel", "Grouping", "Ungrouping"],
			        customContextMenuItems: [],
			        subContextMenu: [],
			        disableDefaultItems: false
			    },
			    filterSettings: {
			        filterType: "filterbar",
			        filterBarMode: "immediate",
			        showFilterBarStatus: true,
			        statusBarWidth: 450,
			        showPredicate: false,
			        filteredColumns: [],
			        enableInterDeterminateState: true,
			        maxFilterChoices: 1000,
			        enableCaseSensitivity: false,
			        immediateModeDelay: 1500,
			        enableComplexBlankFilter: true,
			        blankValue: ""
			    },
			    searchSettings: {
			        fields: [],
			        key: "",
			        operator: "contains",
			        ignoreCase: true
			    },
			    sortSettings: {
			        sortedColumns: []
			    },
			    toolbarSettings: {
			        showToolbar: false,
			        toolbarItems: [],
			        customToolbarItems: []
			    },
			    minWidth: 0,
			    currentIndex: 0,
			    rowDropSettings: {
			        dropMapper: null,
			        dragMapper: null,
			        dropTargetID: null,
			    },
			    scrollSettings:
                {
                    width: "auto",
                    height: 0,
                    enableTouchScroll: true,
                    allowVirtualScrolling: false,
                    virtualScrollMode: "normal",
                    frozenRows: 0,
                    frozenColumns: 0,
                    buttonSize: 18,
                    autoHide: false,
                    scrollerSize: 18,
                    scrollOneStepBy: 57,
                    enableVirtualization: false
                },
			    textWrapSettings: {
			        wrapMode: "both"
			    },
			    summaryRows: [],
			    enableRTL: false,
			    enableAltRow: true,
			    currentViewData: null,
			    detailsTemplate: null,
			    childGrid: null,
			    keySettings: null,
			    rowTemplate: null,
			    detailsDataBound: null,
			    rowDataBound: null,
			    queryCellInfo: null,
			    mergeCellInfo: null,
			    create: null,
			    actionBegin: null,
			    actionComplete: null,
			    actionFailure: null,
			    beginEdit: null,
			    endEdit: null,
			    endAdd: null,
			    endDelete: null,
			    beforeBatchAdd: null,
			    beforeBatchSave: null,
			    beforeBatchDelete: null,
			    batchAdd: null,
			    batchDelete: null,
			    cellSave: null,
			    cellEdit: null,
			    resizeStart: null,
			    resizeEnd: null,
			    resized: null,
			    load: null,
			    destroy: null,
			    rowSelecting: null,
			    rowSelected: null,
			    cellSelecting: null,
			    cellSelected: null,
			    columnSelecting: null,
			    columnSelected: null,
			    columnDragStart: null,
			    columnDrag: null,
			    columnDrop: null,
			    dataBound: null,
			    recordClick: null,
			    recordDoubleClick: null,
			    templateRefresh: null,
			    rightClick: null,
			    detailsCollapse: null,
			    detailsExpand: null,
			    toolbarClick: null,
			    contextOpen: null,
			    contextClick: null,
			    columns: [],
			    query: null,
			    isEdit: false,
			    isResponsive: false,
			    enableResponsiveRow: false,
			    virtualLoading: null
			}
        };
        HeatMapGrid.prototype._dataSource = ej.util.valueFunction("dataSource");
        HeatMapGrid.prototype._selectedRow = ej.util.valueFunction("selectedRowIndex");
        HeatMapGrid.prototype._currentPage = ej.util.valueFunction("pageSettings.currentPage");

        HeatMapGrid.prototype._mapValues = function (args) {

        };
        HeatMapGrid.prototype._createElement = function (element, options) {
            this.element = element.jquery ? element : $(element);
            this.sfType = "ej-grid";
            this.pluginName = "ej.Grid";
            this.model = ej.copyObject(true, {}, this.model, options);
            this.model.keyConfigs = ej.copyObject(this.keyConfigs);
            this.element.addClass("e-grid e-js").data("ej.Grid", this);


        };
        HeatMapGrid.prototype._init = function (element, options, heatmap) {
            this._createElement(element, options);
            if (ej.isNullOrUndefined(this.model.query) || !(this.model.query instanceof ej.Query))
                this.model.query = ej.Query();
            if (!ej.isNullOrUndefined(this.model.parentDetails)) {
                var temp = this.model.queryString, ftemp = this.model.foreignKeyField;
                this.model.query = this.model.query.clone();
                var val = (this.model.parentDetails.parentKeyFieldValue === undefined) ? "undefined" : this.model.parentDetails.parentKeyFieldValue;
                this.model.query.where(ej.isNullOrUndefined(ftemp) ? temp : ftemp, "equal", val, true);
            }
            this._initPrivateProperties();

            this._initScrolling();
            if (this.model.enableResponsiveRow)
                this.element.addClass("e-responsive");
            this._checkForeignKeyBinding();
            this._checkDataBinding(heatmap);
            this._refreshScroller({});
        };
        HeatMapGrid.prototype._checkDataBinding = function (heatmap) {
            //if (!this.model.columns.length && (((this._dataSource() == null || !this._dataSource().length) && !(this._dataSource() instanceof ej.DataManager)) || ((this._dataSource() instanceof ej.DataManager) && this._dataManager.dataSource.url == undefined && !this._dataSource().dataSource.json.length))) {

            //    return;
            //}

            //if (this.model.editSettings.allowDeleting && this.model.selectionType == "multiple")
            //    this.multiDeleteMode = true;
            //this.initialRender = true;
            //this.model.enableRTL && this.element.addClass("e-rtl");

            //if (this.model.cssClass != null)
            //    this.element.addClass(this.model.cssClass);
            //if (this.model.allowGrouping)
            //    this.element.append(this._renderGroupDropArea());

            //var columns = this.model.columns;
            //if (columns && columns.length) {
            //    var expands = this.model.query._expands;
            //    if (typeof columns[0] === "string")
            //        for (var i = 0; i < columns.length; i++)
            //            columns[i] = { field: columns[i] };
            //    for (var i = 0; i < columns.length; i++) {
            //        if (!columns[i].field || columns[i].field.indexOf('.') === -1) continue;
            //        this._getExpands(columns[i].field, expands);
            //    }
            //    this.model.query.expand(expands);
            //    this.commonQuery.expand(expands);
            //    this._renderAfterColumnInitialize();
            //}

            //if (this.model.scrollSettings.allowVirtualScrolling) {
            //    this._loadedJsonData = [];
            //    this._prevPage = 1;
            //}
            //this._ensureDataSource();
            ////this._trigger("actionBegin");
            //this._setForeignKeyData();

            //this._relationalColumns.length == 0 && this._initGridRender(heatmap);
            //this._vRowHeight = Math.floor(this.getRowHeight());


            if (!this.model.columns.length && (((this._dataSource() == null || !this._dataSource().length) && !(this._dataSource() instanceof ej.DataManager)) || ((this._dataSource() instanceof ej.DataManager) && this._dataManager.dataSource.url == undefined && !this._dataSource().dataSource.json.length))) {
                //this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this.localizedLabels.EmptyDataSource);
                this._alertDialog.ejDialog("open");
                return;
            }
            this._initialRenderings();
            if (this.model.editSettings.allowDeleting && this.model.selectionType == "multiple")
                this.multiDeleteMode = true;
            this.initialRender = true;
            this.model.enableRTL && this.element.addClass("e-rtl");
            if (this.model.allowFiltering && this._isExcelFilter)
                this._renderExcelFilter();
            if (this.model.cssClass != null)
                this.element.addClass(this.model.cssClass);
            if (this.model.allowGrouping)
                this.element.append(this._renderGroupDropArea());
            if (this.model.toolbarSettings.showToolbar || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow))
                this.element.append(this._renderToolBar());
            var columns = this.model.columns;
            if (columns && columns.length) {
                var expands = this.model.query._expands;
                if (typeof columns[0] === "string")
                    for (var i = 0; i < columns.length; i++)
                        columns[i] = { field: columns[i] };
                for (var i = 0; i < columns.length; i++) {
                    if (!columns[i].field || columns[i].field.indexOf('.') === -1) continue;
                    this._getExpands(columns[i].field, expands);
                }
                this.model.query.expand(expands);
                this.commonQuery.expand(expands);
                this._renderAfterColumnInitialize();
            }
            if (this.model.allowPaging)
                this.element.append(this._renderGridPager());
            if (this.model.contextMenuSettings.enableContextMenu)
                this.element.append(this._renderContext());
            if (this.model.scrollSettings.allowVirtualScrolling) {
                this._loadedJsonData = [];
                this._prevPage = 1;
            }
            if (this._dataSource() instanceof ej.DataManager) {
                if (this._dataSource().ready != undefined) {
                    var proxy = this;
                    this._dataSource().ready.done(function (args) {
                        proxy._initDataSource();
                        proxy.model.dataSource = ej.DataManager(args.result);
                    });
                } else {
                    this._initDataSource();
                }
            } else {
                this._ensureDataSource();
                //this._trigger("actionBegin");
                this._setForeignKeyData();
                this._relationalColumns.length == 0 && this._initGridRender(heatmap);
                this._vRowHeight = Math.floor(this.getRowHeight());
            }
            if (this.model.showColumnChooser)
                this._renderColumnChooser();

        };
        HeatMapGrid.prototype._initialRenderings = function () {
            if (this.model.groupSettings.groupedColumns.length) {
                var sortedColumns = new Array();
                for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                    if (ej.isNullOrUndefined(this.model.sortSettings.sortedColumns[i].direction))
                        this.model.sortSettings.sortedColumns[i].direction = ej.sortOrder.Ascending;
                    sortedColumns.push(this.model.sortSettings.sortedColumns[i].field);
                }
                if (this.model.allowGrouping) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                        if ($.inArray(this.model.groupSettings.groupedColumns[i], sortedColumns) == -1)
                            this.model.sortSettings.sortedColumns.push({ field: this.model.groupSettings.groupedColumns[i], direction: ej.sortOrder.Ascending });
                    }
                }
            }
        };
        HeatMapGrid.prototype._renderAfterColumnInitialize = function () {
            this.element.append(this._renderGridHeader());
        };
        HeatMapGrid.prototype.setGridHeaderContent = function (value) {
            this._gridHeaderContent = value;
        };
        HeatMapGrid.prototype._renderGridHeader = function () {
            var $div = ej.buildTag('div.e-gridheader'), temp, $frozenDiv, $movableDiv;
            var $innerDiv = ej.buildTag('div');
            if (this.model.allowScrolling)
                $innerDiv.addClass("e-headercontent");
            this.setGridHeaderContent($div);
            if (this.initialRender) {
                this.columnsWidthCollection = [];
                this._hiddenColumns = [];
                this._hiddenColumnsField = [];
            }
            this._visibleColumns = [];
            this._visibleColumnsField = [];
            this._disabledGroupableColumns = [];
            this._fieldColumnNames = {};
            this._headerColumnNames = {};
            if (this.model.scrollSettings.frozenColumns > 0) {
                $frozenDiv = ej.buildTag("div.e-frozenheaderdiv", this._renderGridHeaderInternalDesign(this.model.columns.slice(0, this.model.scrollSettings.frozenColumns), true));
                $movableDiv = ej.buildTag("div.e-movableheader", ej.buildTag("div.e-movableheaderdiv", this._renderGridHeaderInternalDesign(this.model.columns.slice(this.model.scrollSettings.frozenColumns), false)));
                $innerDiv.append($frozenDiv).append($movableDiv);
            } else
                $innerDiv.append(this._renderGridHeaderInternalDesign(this.model.columns));
            $div.html($innerDiv);
            if (this.model.isResponsive)
                $div.addClass("e-textover");
            this.setGridHeaderTable(this.getHeaderContent().find(".e-table"));
            return $div;
        };
        HeatMapGrid.prototype.setGridHeaderTable = function (value) {
            this._gridHeaderTable = value;
        };
        HeatMapGrid.prototype._renderGridHeaderInternalDesign = function (columns, frozenHeader) {
            var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: "0.25px", role: "heatmap" });
            var $thead = ej.buildTag('thead');
            var $tbody = ej.buildTag('tbody.e-hide');
            var $columnHeader = ej.buildTag('tr.e-columnheader');
            var $colGroup = $(document.createElement('colgroup'));
            var $rowBody = $(document.createElement('tr'));
            if (this.model.childGrid || this.model.detailsTemplate) {
                $columnHeader.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div></div>'));
                $colGroup.append(this._getIndentCol());
            }
            if (this.model.showStackedHeader) {
                for (var index = 0; index < this.model.stackedHeaderRows.length; index++) {
                    var $tr = this._createStackedRow(this.model.stackedHeaderRows[index], frozenHeader);
                    $thead.append($tr);
                }
            }
            for (var columnCount = 0; columnCount < columns.length; columnCount++) {
                var $headerCell = ej.buildTag('th.e-headercell e-default', "", {}, { role: "columnheader" });
                var bodyCell = document.createElement('td');
                var $headerCellDiv = ej.buildTag('div.e-headercelldiv', columns[columnCount]["headerText"] === undefined ? columns[columnCount]["headerText"] = columns[columnCount]["field"] : columns[columnCount]["headerText"], {}, { "ej-mappingname": columns[columnCount]["field"] });
                if (columns[columnCount].disableHtmlEncode)
                    $headerCellDiv.text(columns[columnCount]["headerText"]);
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTooltip"]))
                    $headerCellDiv.addClass("e-headertooltip");
                if (!ej.isNullOrUndefined(columns[columnCount]["tooltip"]))
                    $headerCellDiv.addClass("e-gridtooltip");
                if (columns[columnCount]["clipMode"] == ej.HeatMapGrid.ClipMode.Ellipsis || columns[columnCount]["clipMode"] == ej.HeatMapGrid.ClipMode.EllipsisWithTooltip)
                    $headerCellDiv.addClass("e-gridellipsis");
                $headerCell.append($headerCellDiv);
                if (this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel") &&
                                (columns[columnCount]["allowFiltering"] == undefined || columns[columnCount]["allowFiltering"] === true) && (!ej.isNullOrUndefined(columns[columnCount].field) || columns[columnCount].field == "")) {
                    var filtericon = 'e-filterset';
                    if (!this.initialRender && this.model.filterSettings.filteredColumns) {
                        for (var i = 0; i < this.model.filterSettings.filteredColumns.length; i++) {
                            if (this.model.filterSettings.filteredColumns[i].field == columns[columnCount].field) {
                                filtericon = 'e-filterset e-filteredicon e-filternone';
                            }
                        }
                    }
                    $headerCell.append(ej.buildTag('div.e-filtericon e-icon ' + filtericon));
                    $headerCell.addClass("e-headercellfilter");
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0" && this.model.enableRTL)
                        $($headerCellDiv).css("padding", "0 0 0 2em");
                }
                var col = document.createElement('col');
                if (columns[columnCount]["priority"])
                    $(bodyCell).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                $rowBody.append(bodyCell);
                $columnHeader.append($headerCell);
                $colGroup.append(col);
                if (columns[columnCount]["visible"] === false) {
                    $headerCell.addClass("e-hide") && $(col).css("display", "none")
                    if ($.inArray(columns[columnCount].headerText, this._hiddenColumns) == -1 && $.inArray(columns[columnCount].field, this._hiddenColumnsField) == -1)
                        this._hiddenColumns.push(columns[columnCount].headerText) && columns[columnCount].field != ("" || undefined) ? this._hiddenColumnsField.push(columns[columnCount].field) : this._hiddenColumnsField.push(columns[columnCount].headerText);
                    if ($.inArray(columns[columnCount].field, this._visibleColumnsField) != -1)
                        this._visibleColumnsField.splice($.inArray(columns[columnCount].field, this._visibleColumnsField), 1) && this._visibleColumns.splice($.inArray(columns[columnCount].headerText, this._visibleColumns), 1)
                }
                else {
                    this._visibleColumns.push(columns[columnCount].headerText) && columns[columnCount].field != ("" || undefined) ? this._visibleColumnsField.push(columns[columnCount].field) : this._visibleColumnsField.push(columns[columnCount].headerText);
                    columns[columnCount]["visible"] = true;
                    if ($.inArray(columns[columnCount].field == "" ? columns[columnCount].headerText : columns[columnCount].field, this._hiddenColumnsField) != -1)
                        this._hiddenColumnsField.splice($.inArray(columns[columnCount].field == "" ? columns[columnCount].headerText : columns[columnCount].field, this._hiddenColumnsField), 1) && this._hiddenColumns.splice($.inArray(columns[columnCount].headerText, this._hiddenColumns), 1)
                }
                if (this.model.showColumnChooser && columns[columnCount]["showInColumnChooser"] !== false)
                    columns[columnCount]["showInColumnChooser"] = true;
                if (this.model.allowResizing && columns[columnCount]["allowResizing"] !== false)
                    columns[columnCount]["allowResizing"] = true;
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTextAlign"]))
                    $headerCellDiv.css("text-align", columns[columnCount]["headerTextAlign"]);
                else if (columns[columnCount]["textAlign"] != undefined)
                    $headerCellDiv.css("text-align", columns[columnCount]["textAlign"]);
                else if (this.model.enableRTL)
                    $headerCellDiv.css("text-align", columns[columnCount]["textAlign"] = "right");
                columns[columnCount]["allowResizing"] === false && this._disabledResizingColumns.push(columns[columnCount].field);
                columns[columnCount]["allowSorting"] === false && this._disabledSortableColumns.push(columns[columnCount].field);
                columns[columnCount]["allowGrouping"] === false && this._disabledGroupableColumns.push(columns[columnCount].field);
                columns[columnCount]["allowEditing"] === false && this._disabledEditableColumns.push(columns[columnCount].field);
                if (!ej.isNullOrUndefined(columns[columnCount]["cssClass"])) {
                    $headerCell.addClass(columns[columnCount]["cssClass"]);
                    $(col).addClass(columns[columnCount]["cssClass"]);
                }
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTemplateID"])) {
                    $headerCellDiv.html($(columns[columnCount]["headerTemplateID"]).hide().html()).parent().addClass("e-headertemplate");
                    var index = $.inArray(columns[columnCount].field, this._disabledGroupableColumns);
                    index == -1 && ej.isNullOrUndefined(columns[columnCount].field) && this._disabledGroupableColumns.push(columns[columnCount].field);
                }

                if (this.model.isResponsive)
                    $headerCell.attr("title", this._decode(columns[columnCount].headerText));
                if (columns[columnCount]["priority"]) {
                    $headerCell.attr("data-priority", columns[columnCount]["priority"]).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                    $(col).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                }
                if (this.initialRender) {
                    if (typeof (columns[columnCount].width) == "string" && columns[columnCount].width.indexOf("%") != -1)
                        this.columnsWidthCollection.push(parseInt(columns[columnCount]["width"]) / 100 * this.element.width());
                    else
                        this.columnsWidthCollection.push(columns[columnCount]["width"]);
                }
                if (columns[columnCount]["width"] == undefined && this.model.commonWidth !== undefined)
                    this.columnsWidthCollection[columnCount] = this.model.commonWidth;
                this._fieldColumnNames[columns[columnCount].headerText] = columns[columnCount].field;
                this._headerColumnNames[columns[columnCount].field] = columns[columnCount].headerText;
            }
            $thead.append($columnHeader);
            $tbody.append($rowBody);
            $table.append($colGroup).append($thead).append($tbody);
            return $table;
        };
        HeatMapGrid.prototype._decode = function (value) {
            return $('<div/>').html(value).text();
        };
        HeatMapGrid.prototype._checkForeignKeyBinding = function () {
            if (!this.model.columns.length)
                return;
            var c, _cols, _len, _col;
            for (c = 0, _cols = this.model.columns, _len = _cols.length; c < _len; c++) {
                _col = _cols[c];
                if (_col.hasOwnProperty("foreignKeyField") && _col["dataSource"] instanceof ej.DataManager)
                    this._relationalColumns.push({ field: _col["field"], key: _col["foreignKeyField"], value: _col["foreignKeyValue"], dataSource: _col["dataSource"] });
            }
            this._$fkColumn = true;
        };
        HeatMapGrid.prototype._initScrolling = function () {
            var frozen = [], unfrozen = [], hideColumns = 0;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount].visible === false && columnCount < this.model.scrollSettings.frozenColumns)
                    hideColumns++;
                if (this.model.columns[columnCount]["isFrozen"] === true)
                    frozen.push(this.model.columns[columnCount]);
                else
                    unfrozen.push(this.model.columns[columnCount]);
            }
            if (frozen.length > 0) {
                var freeze = this.model.scrollSettings.frozenColumns;
                this.model.columns = $.merge($.merge([], frozen), unfrozen);
                this.model.scrollSettings.frozenColumns = frozen.length;
                if (frozen.length != freeze && freeze != 0)
                    this.model.scrollSettings.frozenColumns = freeze;
            }
            if ((this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) && (this.model.allowGrouping || this.model.rowTemplate != null || this.model.detailsTemplate != null || this.model.childGrid != null || this.model.scrollSettings.allowVirtualScrolling || this.model.editSettings.editMode == "batch")) {

                return;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling) {
                if (!this.model.scrollSettings.enableVirtualization) {
                    this.model.pageSettings.pageSize = this.model.pageSettings.pageSize == 12 ? Math.round(this.model.scrollSettings.height / 32) + 1 : this.model.pageSettings.pageSize;
                    this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
                }
                else {
                    this._vRowHeight = Math.floor(this.getRowHeight() + 1);
                    this._virtualRowCount = Math.round(this.model.scrollSettings.height / this._vRowHeight) + 1;
                    if (this.model.pageSettings.pageSize < this._virtualRowCount * 5)
                        this.model.pageSettings.pageSize = this._virtualRowCount * 5;
                }
            }
            if (this.model.width || this.model.height) {
                this.model.allowScrolling = true;
                if (this.model.width) this.model.scrollSettings.width = this.model.width;
                if (this.model.height) this.model.scrollSettings.height = this.model.height;
            }
            this._originalScrollWidth = ej.isNullOrUndefined(this.model.scrollSettings.previousStateWidth) ? this.model.scrollSettings.width : this.model.scrollSettings.previousStateWidth;
        };
        HeatMapGrid.prototype._initPrivateProperties = function () {
            this._click = 0;
            this._tabKey = false;
            this._gridHeaderTable = null;
            this._gridWidth = this.element.width();
            this._id = this.element.attr("id");
            this._gridRows = null;
            this._unboundRow = null;
            this._gridContentTable = null;
            this._gridContent = null;
            this._remoteSummaryData = null;
            this._gridSort = null;
            this._gridHeaderContent = null;
            this._gridFooterContent = null;
            this._gridFooterTable = null;
            this._gridRecordsCount = this._dataSource() !== null ? (this.model.pageSettings.totalRecordsCount == null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount) : 0;
            this._links = null;
            this._gridPager = null;
            this._cSortedColumn = null;
            this._cSortedDirection = null;
            this._$curSElementTarget = null;
            this._gridFilterBar = null;
            this._$curFieldName = null;
            this._$prevFieldName = null;
            this._mediaStatus = false;
            this._$fDlgIsOpen = false;
            this._$menuDlgIsOpen = false;
            this._$colType = null;
            this._$colFormat = null;
            this._$prevColType = null;
            this._$prevSElementTarget = null;
            this._currentFilterColumn = null;
            this._filteredRecordsCount = null;
            this._filteredRecords = [];
            this._validatedColumns = [];
            this.filterColumnCollection = [];
            this._previousFilterCount = null;
            this._excelFilter = null;
            this._isExcelFilter = this.model.filterSettings.filterType == "excel";
            this._$fkColumn = false;
            this._fkParentTblData = [];
            this._primaryKeys = [];
            this._identityKeys = [];
            this._primaryKeyValues = [];
            this._modifiedRecords = [];
            this._addedRecords = [];
            this._tdsOffsetWidth = [];
            this._deletedRecords = [];
            this._disabledToolItems = $();
            this._validationRules = {};
            this._groupedColumns = [];
            this._scolumns = [];
            this._currentJsonData = [];
            this._groupingColumnIndex = 0;
            this._dataManager = this._dataSource() instanceof ej.DataManager ? this._dataSource() : this._dataSource() != null ? ej.DataManager(this._dataSource()) : null;
            if (this._dataManager != null && this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.pageSettings.totalRecordsCount != null && this._dataManager.dataSource.json != null)
                this._dataManager.dataSource.json.splice(this.model.pageSettings.totalRecordsCount);
            this._isRemoteSaveAdaptor = (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.remoteSaveAdaptor);
            this._isLocalData = true;
            this._disabledResizingColumns = [];
            this._disabledSortableColumns = [];
            this._disabledGroupableColumns = [];
            this._disabledFilterableColumns = [];
            this._disabledEditableColumns = [];
            this._hiddenColumns = [];
            this._visibleColumns = [];
            this._visibleColumnsField = [];
            this._hiddenColumnsField = [];
            this._ccVisibleColumns = [];
            this._ccHiddenColumns = [];
            this._sortedColumns = [];
            this.multiSortRequest = false;
            this.multiSelectCtrlRequest = false;
            this.multiSelectShiftRequest = false;
            this._enableSelectMultiTouch = false;
            this._enableSortMultiTouch = false;
            this._templateRefresh = false;
            this.initialRender = false;
            this._selectDrag = false;
            this._isAddNew = false;
            this._fieldColumnNames = {};
            this._headerColumnNames = {};
            this._virtualLoadedRecords = {};
            this._virtualLoadedRows = {};
            this._virtualPageRecords = {};
            this._queryCellView = [];
            this._currentPageViews = [];
            this._virtualLoadedPages = [];
            this._currentLoadedIndexes = [];
            this._prevVirtualSort = [];
            this._prevVirtualFilter = [];
            this._prevVirtualIndex = 0;
            this._currentVirtualIndex = 1;
            this._virtualRowCount = 0;
            this._virtualSelectedRecords = {};
            this.selectedRowsIndexes = [];
            this._isReorder = false;
            this._searchString = "";
            this._searchCount = null;
            this.columnsWidthCollection = [];
            this._Indicator = null;
            this._resizer = null;
            this._bulkEditCellDetails = {
                cellValue: null,
                rowIndex: -1,
                columnIndex: -1,
                fieldName: null,
                _data: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                rowData: null
            };
            this.batchChanges = {
                added: [],
                deleted: [],
                changed: []
            };
            this._bulkEditTemplate = $();
            this._confirmDialog = null;
            this._confirmedValue = false;
            this._lastRow = false;
            this._isVirtualRecordsLoaded = false;
            this._scrollValue = 0;
            this._currentTopFrozenRow = this.model.scrollSettings.frozenRows;
            this._rowHeightCollection = [];
            this._scrollObject = null;
            this._customPop = null;
            this.selectedRowCellIndexes = [];
            this._rowIndexesColl = [];
            this.selectedColumnIndexes = [];
            this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
            this.commonQuery = $.extend(true, {}, this.model.query);

            this.phoneMode = this.model.isResponsive && document.documentElement.clientWidth < 360 ? true : false;
            if (this.model.selectionSettings.selectionMode.length > 0 && this.model.allowSelection)
                this._initSelection();
            this._mediaQuery = false;
            this._columnChooserList = null;
            this._$headerCols = null;
            this._$contentCols = null;
            this._detailsOuterWidth = null;
            this._editForm = null;
            this._cloneQuery = null;
            this.localizedLabels = this._getLocalizedLabels();
            this._searchBar = null;
            this._relationalColumns = [];
            this._dropDownManager = {};
            this._isUngrouping = false;
            this._columnChooser = false;

        };
        HeatMapGrid.prototype._getLocalizedLabels = function (property) {
            return ej.getLocalizedConstants("ej.HeatMapGrid", this.model.locale);
        };
        HeatMapGrid.prototype._initSelection = function () {
            var mode = this.model.selectionSettings.selectionMode;
            for (var i = 0; i < mode.length; i++) {
                this["_allow" + mode[i] + "Selection"] = true;
            }
        };
        HeatMapGrid.prototype._getSelectedViewData = function (rowIndex, target, currentViewIndex) {
            var index = rowIndex % this._virtualRowCount, viewIndex, result = {};
            if (target)
                viewIndex = parseInt($(target).closest("tr").attr("name"), 32);
            else if (currentViewIndex)
                viewIndex = currentViewIndex;
            else
                viewIndex = rowIndex > 1 ? Math.ceil((rowIndex + 1) / this._virtualRowCount) : 1;
            result["viewIndex"] = viewIndex;
            if (this._virtualLoadedRecords[viewIndex])
                result["data"] = this._virtualLoadedRecords[viewIndex][index];
            var remain = rowIndex % this._virtualRowCount;
            result["rowIndex"] = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
            return result;
        };
        HeatMapGrid.prototype._frozenCell = function (rowIndex, cellIndex) {
            var currentIndex = cellIndex, frozenDiv = 0, row = this.getRowByIndex(rowIndex), cell;
            if (cellIndex >= this.model.scrollSettings.frozenColumns) {
                frozenDiv = 1;
                currentIndex = currentIndex - this.model.scrollSettings.frozenColumns;
            }
            cell = $(row.eq(frozenDiv).find(".e-rowcell:eq(" + currentIndex + ")"));
            return cell;
        };
        HeatMapGrid.prototype.selectCells = function (rowCellIndexes) {
            if (!this._allowcellSelection)
                return false;
            var $cell = null, previousRowCell, prevRowCellIndex;
            var gridRows = this._excludeDetailRows();
            if (this.model.scrollSettings.frozenColumns)
                $cell = this._frozenCell(rowCellIndexes[0][0], rowCellIndexes[0][1][0]);
            else
                $cell = gridRows.eq(rowCellIndexes[0][0]).find(".e-rowcell:eq(" + rowCellIndexes[0][1] + ")");
            if (!ej.isNullOrUndefined(this._previousRowCellIndex) && this._previousRowCellIndex.length != 0) {
                if (this.model.scrollSettings.enableVirtualization) {
                    previousRowCell = this._prevRowCell;
                    prevRowCellIndex = this._preVirRowCellIndex;
                }
                else {
                    previousRowCell = $(this.getRowByIndex(this._previousRowCellIndex[0][0]).find(".e-rowcell:eq(" + this._previousRowCellIndex[0][1] + ")"));
                    prevRowCellIndex = this._previousRowCellIndex;
                }
            }
            var $data = this._currentJsonData[rowCellIndexes[0][0]], $rowIndex = rowCellIndexes[0][0], viewDetails;
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                viewDetails = this._getSelectedViewData(rowCellIndexes[0][0], $cell);
                $data = viewDetails.data;
                $rowIndex = viewDetails.rowIndex;
            }
            var args = { currentCell: $cell, cellIndex: rowCellIndexes[0][1], data: $data, previousRowCellIndex: prevRowCellIndex, previousRowCell: previousRowCell };
            if (this.model.selectionType == "multiple") {
                args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                args["isShiftPressed"] = this.multiSelectShiftRequest;
            }
            //if (this._trigger("cellSelecting", args))
            //return;
            switch (this.model.selectionType) {
                case ej.HeatMapGrid.SelectionType.Single:
                    this.clearCellSelection();
                    this.clearColumnSelection();
                    this.selectedRowCellIndexes = [];
                    this._virtualRowCellSelIndex = [];
                    if ($.inArray($rowIndex, this._rowIndexesColl) == -1)
                        this._rowIndexesColl.push($rowIndex);
                    this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[0][1] });
                    if (this.model.scrollSettings.frozenColumns)
                        this._frozenCell(rowCellIndexes[0][0], rowCellIndexes[0][1][0]).addClass("e-cellselectionbackground e-activecell");
                    else
                        $(this.getRowByIndex(rowCellIndexes[0][0]).find(".e-rowcell:eq(" + rowCellIndexes[0][1] + ")")).addClass("e-cellselectionbackground e-activecell");
                    break;
            }
            var args = { currentCell: $cell, cellIndex: rowCellIndexes[0][1], data: $data, selectedRowCellIndex: this.selectedRowCellIndexes, previousRowCellIndex: prevRowCellIndex, previousRowCell: previousRowCell };
            if (!this.multiSelectShiftRequest || ej.isNullOrUndefined(this._previousRowCellIndex)) {
                this._previousRowCellIndex = rowCellIndexes;
                if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                    this._preVirRowCellIndex = $.extend(true, [], rowCellIndexes);
                    this._preVirRowCellIndex[0][0] = $rowIndex;
                }
                this._prevRowCell = $cell;
            }
            if (this._heatmap)
                this._heatmap._cellSelected(args);
            return;
        };
        HeatMapGrid.prototype.clearSelection = function (index) {
            var $gridRows, index;
            if (this._selectedRow() >= -1) {
                if (this.model.scrollSettings.frozenColumns)
                    $gridRows = this._excludeDetailRows();
                else
                    $gridRows = $(this.element.find("tr[aria-selected='true']"));
                if (!ej.isNullOrUndefined(index)) {
                    this.getRowByIndex(index).removeAttr("aria-selected").find(".e-selectionbackground").removeClass("e-selectionbackground").removeClass("e-active");
                    var row = this.getRowByIndex(index);
                    if (this.model.scrollSettings.enableVirtualization && this.multiSelectCtrlRequest && $.inArray(index, this.selectedRowsIndexes) == -1) {
                        var limit = parseInt(row.attr("name"), 32) * this._virtualRowCount;
                        var remain = this._virtualRowCount - row.index() % this._virtualRowCount;
                        index = limit - remain;
                    }
                    index = $.inArray(index, this.selectedRowsIndexes);
                    if (index != -1)
                        this.selectedRowsIndexes.splice(index, 1);
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0)
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.removeAttr("aria-selected").find(".e-rowcell, .e-detailrowcollapse, .e-detailrowexpand").removeClass("e-selectionbackground").removeClass("e-active");
                    if (!this._clearVirtualSelection) {
                        this.selectedRowsIndexes = [];
                        this.model.selectedRecords = [];
                    }
                }
                if (!this.selectedRowsIndexes.length)
                    this._selectedRow(-1);
            }
            return true;
        };
        HeatMapGrid.prototype._excludeDetailRows = function () {
            var $gridRows;
            if (!ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid || this.model.showSummary))
                $gridRows = $(this.getRows()).not(".e-detailrow,.e-gridSummaryRows");
            else
                $gridRows = $(this.getRows());
            return $gridRows;
        };
        HeatMapGrid.prototype.clearCellSelection = function (rowIndex, columnIndex) {
            var $gridRows, cellIndex;
            if (this._allowcellSelection) {
                if (this.model.scrollSettings.frozenColumns || !ej.isNullOrUndefined(rowIndex))
                    $gridRows = this._excludeDetailRows();
                else
                    $gridRows = $(this.element.find(".e-cellselectionbackground")).parent();
                if (ej.isNullOrUndefined(rowIndex)) {
                    if (this.model.scrollSettings.frozenColumns)
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.find(".e-rowcell, .e-detailrowcollapse, .e-detailrowexpand").removeClass("e-cellselectionbackground").removeClass("e-activecell");
                    this.selectedRowCellIndexes = [];
                    this._rowIndexesColl = [];
                }
                else {
                    for (var i = 0; i < this.selectedRowCellIndexes.length ; i++) {
                        if (this.selectedRowCellIndexes[i].rowIndex == rowIndex) {
                            cellIndex = $.inArray(columnIndex, this.selectedRowCellIndexes[i].cellIndex);
                            if (this.model.scrollSettings.frozenColumns)
                                this._frozenCell(rowIndex, columnIndex).removeClass("e-cellselectionbackground").removeClass("e-activecell");
                            else
                                $gridRows.eq(rowIndex).find(".e-rowcell").eq(columnIndex).removeClass("e-cellselectionbackground").removeClass("e-activecell");
                            break;
                        }
                    }
                    if (i != this.selectedRowCellIndexes.length) {
                        this.selectedRowCellIndexes[i].cellIndex.splice(cellIndex, 1);
                        if (this.selectedRowCellIndexes[i].cellIndex.length == 0) {
                            this.selectedRowCellIndexes.splice(i, 1);
                            this._rowIndexesColl.splice($.inArray(rowIndex, this._rowIndexesColl), 1);
                        }
                    }
                }
            }
            return true;
        };
        HeatMapGrid.prototype.clearColumnSelection = function (index) {
            if (this._allowcolumnSelection) {
                var $gridRows = $(this._excludeDetailRows());
                if (!ej.isNullOrUndefined(index)) {
                    var indent = 0;
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                        ++index; indent = 1;
                    }
                    if (this.model.scrollSettings.frozenColumns) {
                        var frozenDiv = 0, currentIndex = index;
                        if (index >= this.model.scrollSettings.frozenColumns) {
                            frozenDiv = 1;
                            currentIndex = index - this.model.scrollSettings.frozenColumns;
                        }
                        for (var j = 0; j < $gridRows[frozenDiv].length; j++) {
                            $($gridRows[frozenDiv][j].cells[currentIndex]).removeClass("e-columnselection");
                        }
                    }
                    else
                        for (var i = 0; i < $gridRows.length; i++) {
                            $($gridRows[i].cells[index]).removeClass("e-columnselection");
                        }
                    $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)")[index]).removeClass("e-columnselection");
                    this.selectedColumnIndexes.splice(0, index - indent);

                } else {
                    if (this.model.scrollSettings.frozenColumns)
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.find(".e-rowcell").removeClass("e-columnselection");
                    $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)")).removeClass("e-columnselection");
                    this.selectedColumnIndexes = [];
                }
            }
            return true;
        };
        HeatMapGrid.prototype.getSelectedRecords = function () {
            var records = [];
            if (this._virtualScrollingSelection)
                return this._virtualSelRecords;
            for (var i = 0; i < this.selectedRowsIndexes.length; i++) {
                if (this.selectedRowsIndexes[i] != -1) {
                    if (this.model.scrollSettings.allowVirtualScrolling)
                        records.push(this._virtualSelectedRecords[this.selectedRowsIndexes[i]]);
                    else
                        records.push(this._currentJsonData[this.selectedRowsIndexes[i]]);
                }
            }
            return records;
        };
        HeatMapGrid.prototype._setCurrentRow = function (requestType) {
            if (requestType == ej.HeatMapGrid.Actions.Refresh || requestType == ej.HeatMapGrid.Actions.Ungrouping || requestType == ej.HeatMapGrid.Actions.Grouping || requestType == ej.HeatMapGrid.Actions.Filtering || requestType == ej.HeatMapGrid.Actions.Sorting || requestType == ej.HeatMapGrid.Actions.Delete || requestType == ej.HeatMapGrid.Actions.Save || requestType == ej.HeatMapGrid.Actions.Cancel || requestType == ej.HeatMapGrid.Actions.Paging) {
                this._selectedRow(-1);
                if (!this._virtualDataRefresh)
                    this.selectedRowsIndexes = [];
            }
        };
        HeatMapGrid.prototype.refreshContent = function (refreshTemplate) {
            var args = {};
            args.requestType = ej.HeatMapGrid.Actions.Refresh;
            this._processBindings(args);
        };
        HeatMapGrid.prototype.rowHeightRefresh = function () {
            if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.model.currentViewData) && this.model.currentViewData.length) {
                var frozenRows = this.getContentTable().get(0).rows;
                var movableRows = this.getContentTable().get(1).rows, height = 0;
                if (this.getContent().find(".e-frozencontentdiv").is(":visible"))
                    for (var i = 0; i < frozenRows.length; i++) {
                        if ($(frozenRows[i]).css("display") == "none")
                            continue;
                        height = ej.max([frozenRows[i].getClientRects()[0].height, movableRows[i].getClientRects()[0].height]);
                        $(frozenRows[i]).height(height); $(movableRows[i]).height(height);
                        if (i && (i == this.model.scrollSettings.frozenRows - 1 || i == frozenRows.length - 1))
                            height = height + 1;
                        if (!this.model.allowTextWrap) {
                            if (!i || i == this.model.scrollSettings.frozenRows - 1)
                                height = height - 1;
                        }
                        if (this.model.isEdit && $(frozenRows[i]).find("#" + this._id + "EditForm").length && i)
                            $(frozenRows[i]).find("#" + this._id + "EditForm td").css("height", height); $(movableRows[i]).find("#" + this._id + "EditForm td").css("height", height);
                    }
                this._getRowHeights()
                if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && this.getScrollObject().isVScroll()) {
                    var scroller = this.getScrollObject()._vScrollbar;
                    if (scroller && scroller.value() != scroller.model.maximum)
                        this._scrollObject.refresh(this.model.scrollSettings.frozenColumns > 0);
                }

            }
        };
        HeatMapGrid.prototype._refreshDataSource = function (dataSource) {
            if (dataSource instanceof ej.DataManager)
                this._dataManager = dataSource;
            else
                this._dataManager = ej.DataManager(dataSource);
            this._isLocalData = (!(this._dataSource() instanceof ej.DataManager) || (this._dataManager.dataSource.offline || this._isRemoteSaveAdaptor));
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                this._refreshVirtualViewData();
                this._virtualDataRefresh = true;
            }
            this.refreshContent(true);
            this._refreshScroller({ requestType: "refresh" });
        };
        HeatMapGrid.prototype.dataSource = function (dataSource, templateRefresh) {
            if (templateRefresh)
                this._templateRefresh = true;
            this._dataSource(dataSource);
            if (!this.model.scrollSettings.enableVirtualization) {
                if (dataSource.length > 0)
                    this._currentPage(1);
                else
                    this._currentPage(0);
            }
            this._refreshDataSource(dataSource);
            var model = this._refreshVirtualPagerInfo();
            if (this.model.allowPaging || this.model.scrollSettings.allowVirtualScrolling)
                this._showPagerInformation(model)
            if (this.model.scrollSettings.allowVirtualScrolling) {
                if (this.model.scrollSettings.enableVirtualization && this._isLocalData)
                    this._refreshVirtualView();
                else
                    this._refreshVirtualContent();
                if (this.getContent().ejScroller("isHScroll"))
                    this.getContent().ejScroller("scrollX", 0, true);
                if (this.getContent().ejScroller("isVScroll")) {
                    if (!this.model.scrollSettings.enableVirtualization)
                        this.getContent().ejScroller("scrollY", 0, true);
                    this.element.find(".e-gridheader").addClass("e-scrollcss");
                }
                else
                    this.element.find(".e-gridheader").removeClass("e-scrollcss");
            }
            if (!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount)
                this._addLastRow();
            this._trigger("dataBound", {});
        };
        HeatMapGrid.prototype._trigger = function (type, args) {

        };
        HeatMapGrid.prototype.getFooterContent = function () {
            return this._gridFooterContent;
        };
        HeatMapGrid.prototype.getScrollObject = function () {
            if (this._scrollObject == null || ej.isNullOrUndefined(this._scrollObject.model))
                this._scrollObject = this.getContent().ejScroller("instance");
            return this._scrollObject;
        };
        HeatMapGrid.prototype.getRowHeight = function () {
            var rowHeight = -1;
            if (this.getContentTable() != null) {
                var trColl = this.getContentTable().find('tr:not(.e-virtualrow)'), index = trColl.length > 2 ? 1 : 0;
                if (trColl.length)
                    var $trBound = trColl[index].getBoundingClientRect();
                if (trColl.length > 1) {
                    if ($trBound && $trBound.height) {
                        rowHeight = $trBound.height;
                    } else
                        rowHeight = trColl[index].offsetHeight;
                }
            }
            return rowHeight == -1 ? 32 : rowHeight;
        };
        HeatMapGrid.prototype.getCurrentIndex = function () {
            return ((this._currentPage() - 1) * (this.model.pageSettings.pageSize));
        };
        HeatMapGrid.prototype.getColumnByIndex = function (index) {
            if (index < this.model.columns.length)
                return this.model.columns[index];
            return null;
        };
        HeatMapGrid.prototype.set_currentPageIndex = function (val) {
            var pageSetting = this.model.pageSettings;
            var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (pageSetting.totalPages == null)
                pageSetting.totalPages = Math.ceil(recordCount / pageSetting.pageSize);
            if (val > pageSetting.totalPages || val < 1 || val == this._currentPage())
                return false;
            if (ej.isNullOrUndefined(this._prevPageNo))
                this._prevPageNo = this._currentPage();
            this._currentPage(val);
            if (this._currentPage() != this._prevPageNo) {
                var args = {};
                args.requestType = "paging";
                this.gotoPage(this._currentPage(), args);
                return true;
            }
            else
                return false;
        };
        HeatMapGrid.prototype.set_currentVirtualIndex = function (currentViewIndex) {
            if (currentViewIndex < 1 || (currentViewIndex != 1 && currentViewIndex != this._totalVirtualViews && currentViewIndex == this._currentVirtualIndex && this._checkCurrentVirtualView(this._virtualLoadedRows, currentViewIndex)))
                return false;
            this._prevVirtualIndex = this._currentVirtualIndex;
            this._currentVirtualIndex = currentViewIndex;
            var currentPage = this._calculateCurrentViewPage();
            if (currentPage <= this.model.pageSettings.totalPages && !this._checkCurrentVirtualView(this._virtualLoadedRecords, this._currentVirtualIndex)) {
                if (this._prevVirtualIndex < currentViewIndex && currentViewIndex != 1) {
                    var setPage = this._isThumbScroll && currentPage != 1 ? currentPage : currentPage + 1;
                    if (!this._virtualPageRecords[setPage] && setPage <= this.model.pageSettings.totalPages)
                        this._setCurrentViewPage(setPage);
                    else
                        this._renderVirtulViewContent(currentPage);
                }
                else if (this._prevVirtualIndex > currentViewIndex) {
                    var setPage = this._isThumbScroll ? currentPage : currentPage - 1;
                    if (this._virtualPageRecords[setPage] && !this._virtualLoadedRecords[currentViewIndex - 1])
                        setPage = currentPage - 1;
                    if (!this._virtualPageRecords[setPage] && setPage >= 1)
                        this._setCurrentViewPage(setPage);
                }
                else
                    this._renderVirtulViewContent(currentPage);
            }
            else
                this._renderVirtulViewContent(currentPage);
            return true;
        };
        HeatMapGrid.prototype._setCurrentViewPage = function (currentPage) {
            this._needPaging = true;
            this._prevPageNo = this._currentPage();
            this.gotoPage(currentPage);
        };
        HeatMapGrid.prototype._renderVirtulViewContent = function (currentPage) {
            this._needPaging = false;
            this._refreshVirtualView(this._currentVirtualIndex);
        };
        HeatMapGrid.prototype._checkCurrentVirtualView = function (virtualContent, viewIndex) {
            var virtualRowCount = this._virtualRowCount;
            var prevView = viewIndex - 1, nextView = viewIndex + 1;
            if (virtualContent instanceof Array) {
                if (virtualContent.length) {
                    if (((prevView == 0 || nextView == this._totalVirtualViews + 1) && $.inArray(viewIndex, virtualContent) != -1) || ($.inArray(prevView, virtualContent) != -1 &&
					$.inArray(viewIndex, virtualContent) != -1 && $.inArray(nextView, virtualContent) != -1))
                        return true;
                }
            }
            else {
                var nextViewData = nextView == this._totalVirtualViews ? this._lastViewData : virtualRowCount;
                if ((!this.initialRender && (viewIndex == 1 && this._virtualLoadedRows[viewIndex]) || viewIndex == this._totalVirtualViews && virtualContent == this._virtualLoadedRows && virtualContent[viewIndex]) ||
					((prevView == 0 && virtualContent[viewIndex] && virtualContent[viewIndex].length == virtualRowCount) || (nextView == this._totalVirtualViews + 1 && virtualContent[viewIndex] && virtualContent[viewIndex].length == this._lastViewData)) ||
					(virtualContent[prevView] && virtualContent[prevView].length == virtualRowCount && virtualContent[viewIndex] && virtualContent[viewIndex].length == virtualRowCount && virtualContent[nextView] && virtualContent[nextView].length == nextViewData))
                    return true;
            }
            return false;
        };
        HeatMapGrid.prototype._refreshStackedHeader = function () {
            if (this.model.showStackedHeader) {
                var stackedRows = this.model.stackedHeaderRows;
                for (var i = 0; i < stackedRows.length; i++) {
                    if (this.model.scrollSettings.frozenColumns != 0) {
                        var frznHeader = $(this.getHeaderContent().find(".e-frozenheaderdiv"));
                        var movHeader = $(this.getHeaderContent().find(".e-movableheader"));
                        var newFrzn = this._createStackedRow(stackedRows[i], true);
                        var newMov = this._createStackedRow(stackedRows[i], false);
                        $(frznHeader.find("tr.e-stackedHeaderRow")[i]).replaceWith(newFrzn);
                        $(movHeader.find("tr.e-stackedHeaderRow")[i]).replaceWith(newMov);
                    }
                    else {
                        var stackedTR = this._createStackedRow(stackedRows[i], false);
                        if (this.getHeaderTable().find("tr.e-stackedHeaderRow")[i])
                            $(this.getHeaderTable().find("tr.e-stackedHeaderRow")[i]).replaceWith(stackedTR);
                        else
                            stackedTR.insertBefore(this.getHeaderTable().find("tr.e-columnheader:last"));
                    }
                }
                var args = {};
                args.requestType = "refresh";
                if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                        this.getHeaderTable().find(".e-stackedHeaderRow").prepend(this._getGroupTopLeftCell());
                }
                this.model.allowScrolling && this._refreshScroller(args);
            }

        };
        HeatMapGrid.prototype._getStackedColumnByTarget = function (target) {
            var cls = (target.get(0) || {}).className, match = /e-row([0-9])-column([0-9])/.exec(cls),
                rIndx = match[1], cIndx = match[2], key = [rIndx, "stackedHeaderColumns", cIndx].join(".");

            return ej.getObject(key, this.model.stackedHeaderRows);
        };
        HeatMapGrid.prototype._checkSkipAction = function (args) {
            switch (args.requestType) {
                case ej.HeatMapGrid.Actions.Save:
                case ej.HeatMapGrid.Actions.Delete:
                    return true;
            }
            return false;
        };
        HeatMapGrid.prototype._processBindings = function (args) {
            this._requestType = args.requestType;
            this.model.query = this.commonQuery.clone();
            //if (!this._checkSkipAction(args))
            //    return true;
            if (this.model.editSettings.editMode == "batch" && args.requestType != "batchsave" && args.requestType != "cancel" && !this._confirmedValue && this._bulkChangesAcquired()) {
                this._requestArgs = args;
                return false;
            }
            if (!ej.isNullOrUndefined(this.model.dataSource) && args.requestType == "refresh" && this.model.scrollSettings.allowVirtualScrolling) {
                this._currentPage(1);
                this._scrollValue = 0;
                this._loadedJsonData = [];
                this._prevPage = this._currentPage();
            }
            this._ensureDataSource(args);
            if (this.model.scrollSettings.allowVirtualScrolling) {
                if (args.requestType == "virtualscroll") {
                    this._loadedJsonData.push({ pageIndex: this._prevPage, data: this._currentJsonData });
                    this._prevPage = this._currentPage();
                }
                else if (!this.model.scrollSettings.enableVirtualization)
                    this._virtualLoadedRecords[this._currentPage()] = this.model.currentViewData;
                if (args.requestType == "filtering") {
                    this._loadedJsonData = [];
                    this._prevPage = this._currentPage();
                }
            }
            if (this.model.scrollSettings.allowVirtualScrolling && args.requestType == "filtering" && this.model.filterSettings.filteredColumns.length > 0)
                this.getScrollObject().scrollY(0);
            if (this.model.enableRTL) {
                !this.element.hasClass("e-rtl") && this.element.addClass("e-rtl");
            } else {
                this.element.hasClass("e-rtl") && this.element.removeClass("e-rtl")
            }
            if (args.requestType == ej.HeatMapGrid.Actions.Delete && this.model.groupSettings.groupedColumns.length == 0) {
                if (this.model.editSettings.showAddNewRow)
                    this.getContentTable().find(".e-addedrow").remove();
                args.tr.remove();
            }
            this._editForm = this.model.scrollSettings.frozenColumns > 0 || this.model.editSettings.showAddNewRow ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
            if (!(this.model.editSettings.showAddNewRow && args.requestType == "beginedit") && this._editForm.length != 0) {
                if (this._editForm.length > 1 && (args.requestType == "save" && args.action == "edit" || args.requestType == "cancel"))
                    this._editForm = this.model.editSettings.rowPosition == "top" ? this._editForm[1] : this._editForm[0];
            }
            if (this._dataSource() instanceof ej.DataManager && !this._isRemoteSaveAdaptor && args.requestType != ej.HeatMapGrid.Actions.BeginEdit && args.requestType != ej.HeatMapGrid.Actions.Cancel && args.requestType != ej.HeatMapGrid.Actions.Add) {
                if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && this.model.pageSettings.totalPages == this.model.pageSettings.currentPage) {
                    var pageQuery = ej.pvt.filterQueries(this.model.query.queries, "onPage");
                    this.model.query.queries.splice($.inArray(pageQuery[0], this.model.query.queries), 1);
                    this.model.query.page(this._currentPage() - 1, this.model.pageSettings.pageSize);
                    var lastQueryPromise = this._dataSource().executeQuery(this.model.query);
                    this.model.query.queries.splice($.inArray(pageQuery[0], this.model.query.queries), 1);
                    this.model.query.page(this._currentPage(), this.model.pageSettings.pageSize);
                }
                if (this._virtualSelectedRows && this._virtualSelectedRows.length > 0) {
                    this.model.query.addParams('virtualSelectRecords', this._virtualSelectedRows)
                }
                var queryPromise = this._queryPromise = this._dataSource().executeQuery(this.model.query);
                if (proxy._dataSource().ready) {
                    proxy._dataSource().ready.done(function () {
                        proxy._processDataRequest(proxy, args, queryPromise, lastQueryPromise)
                    });
                }
                else {
                    proxy._processDataRequest(proxy, args, queryPromise, lastQueryPromise)
                }
            } else {
                if (this._isRelationalRendering(args))
                    this._setForeignKeyData(args);
                else
                    this.sendDataRenderingRequest(args);
            }
        };
        HeatMapGrid.prototype._processDataRequest = function (proxy, args, queryPromise, lastQueryPromise) {
            queryPromise.done(ej.proxy(function (e) {
                proxy._relationalColumns.length == 0;
                if (lastQueryPromise && !proxy._previousPageRendered) {
                    if (proxy.model.previousViewData && proxy.model.previousViewData.length != 0) {
                        proxy.model.previousViewData.splice(0, e.result.length);
                        proxy._previousPageLength = e.result.length;
                        proxy._currentPageData = e.result;
                        ej.merge(proxy.model.previousViewData, e.result);
                        proxy.model.currentViewData = proxy.model.previousViewData;
                        proxy._remoteLastPageRendered = true;
                    }
                }
                else if (proxy._remoteLastPageRendered && proxy.model.pageSettings.currentPage == proxy.model.pageSettings.totalPages - 1 && !proxy.model.scrollSettings.enableVirtualization) {
                    var count = proxy.model.pageSettings.pageSize - proxy._previousPageLength;
                    for (var dupRow = 0; dupRow < count; dupRow++) {
                        var removeEle = proxy.getRows()[proxy.getRows().length - (proxy.model.pageSettings.pageSize - dupRow)];
                        removeEle.remove();
                    }
                    proxy._tempPageRendered = true;
                    proxy.model.currentViewData = e.result;
                }
                else {
                    if (proxy.model.pageSettings.currentPage == proxy.model.pageSettings.totalPages - 1 && !proxy._remoteLastPageRendered)
                        proxy._previousPageRendered = true;
                    proxy.model.currentViewData = e.result == null ? [] : e.result;
                    if (proxy._$fkColumn && proxy.model.filterSettings.filterType == "excel" && proxy.model.filterSettings.filteredColumns.length > 0)
                        proxy._fkParentTblData = e.result;
                }
                if (proxy.model.allowScrolling && proxy.model.scrollSettings.allowVirtualScrolling && proxy.model.scrollSettings.enableVirtualization) {
                    if (args.requestType == "filtering") {
                        proxy._gridRecordsCount = proxy._filteredRecordsCount = e.count;
                        proxy._refreshVirtualViewDetails();
                    }
                    if (e.result.length) {
                        if (proxy._isInitNextPage || proxy._isLastVirtualpage) {
                            proxy._setInitialCurrentIndexRecords(e.result, proxy._currentPage());
                            proxy._isInitNextPage = proxy._isLastVirtualpage = false;
                        }
                        else
                            proxy._setVirtualLoadedRecords(e.result, proxy._currentPage());
                        if (proxy._isThumbScroll && !proxy._checkCurrentVirtualView(proxy._virtualLoadedRecords, proxy._currentVirtualIndex))
                            proxy._checkPrevNextViews();
                        proxy._remoteRefresh = true;
                    }
                    else
                        proxy.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
                }
                if (!ej.isNullOrUndefined(e.aggregates))
                    proxy._remoteSummaryData = e.aggregates;
                if (!ej.isNullOrUndefined(proxy._unboundRow) && args.selectedRow != proxy._unboundRow && args.requestType == "save") {
                    proxy._unboundRow.find(".e-editbutton").trigger("click");
                    proxy._unboundRow = null;
                }
            }));
            queryPromise.fail(ej.proxy(function (e) {
                args.error = e.error;
                e = [];
                proxy.model.currentViewData = [];
                proxy._trigger("actionFailure", args);
            }));
        };
        HeatMapGrid.prototype._createUnboundElement = function (column) {
            var divElement = document.createElement("div");
            column.headerText = ej.isNullOrUndefined(column.headerText) ? column.field : column.headerText;
            if (!ej.isNullOrUndefined(column.headerText))
                divElement.id = this._id + column.headerText.replace(/[^a-z0-9|s_]/gi, '') + "_UnboundTemplate";
            var $div = ej.buildTag("div.e-unboundcelldiv"), commands = column["commands"];
            for (var unbounType = 0; unbounType < commands.length; unbounType++) {
                var $button = ej.buildTag("button.e-" + commands[unbounType].type.replace(/\s+/g, "") + "button", "", {}, { type: "button" });
                $button.val(commands[unbounType].type);
                $div.append($button);
            }
            $("body").append($(divElement).html($div).hide());
            return divElement;
        };
        HeatMapGrid.prototype._gridTemplate = function (self, templateId, index) {
            var $column = self.model.columns[index];
            if (self._isGrouping)
                this.index = self._currentJsonData.indexOf(this.data);
            return self._renderEjTemplate("#" + templateId, this.data, this.index, $column);
        };
        HeatMapGrid.prototype._renderEjTemplate = function (selector, data, index, prop) {
            var type = null;
            if (typeof selector === "object" || selector.startsWith("#") || selector.startsWith("."))
                type = $(selector).attr("type");
            if (type) {
                type = type.toLowerCase();
                if (ej.template[type])
                    return ej.template[type](this, selector, data, index, prop);
            }
            return ej.template.render(this, selector, data, index, prop);
        };
        HeatMapGrid.prototype._createTemplateElement = function (column, appendTo /* container to append */, text) {
            var tmpl = column["templateID" in column ? "templateID" : "template"], quickReg = /^#([\w-]*)/,
                match = quickReg.exec(tmpl), scriptReg = /^<script/i, appendTo = appendTo || $("body"), scripEle,
                idText = text ? "Pager" : (column.headerText + $.inArray(column, this.model.columns) + "_") + "Template";

            var options = {
                name: "SCRIPT",
                type: "text/x-template",
                text: tmpl,
                id: (this._id + idText).replace(/[^0-9A-z-_]/g, "")
            };

            if (match && match[1])
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(tmpl)) // branch here to handle tmpl string with SCRIPT. 
                    scripEle = $(tmpl).get(0);
                else
                    scripEle = ej.buildTag(options.name, options.text).get(0);
            }

            scripEle.id = scripEle.id || options.id; // Update Id and type if not in scriptElement template string.
            scripEle.type = scripEle.type || options.type;

            appendTo.append(text ? scripEle.innerHTML : scripEle); //if `text` then append innerHTML instead of element.

            return scripEle;
        };
        HeatMapGrid.prototype._page = function (send) {
            if (send.events.text == this.localizedLabels.NextPage) {
                var b = this.model.pageSettings.currentPage;
                ++b;
                this.gotoPage(b);
            }
            else if (send.events.text == this.localizedLabels.PreviousPage) {
                var b = this.model.pageSettings.currentPage;
                if (b > 1) {
                    --b;
                    this.gotoPage(b);
                }
                else
                    this.gotoPage(b);
            }
            else if (send.events.text == this.localizedLabels.LastPage) {
                var b = this.model.pageSettings.totalPages
                this.gotoPage(b);
            }
            else
                this.gotoPage(1);


        };
        HeatMapGrid.prototype.gotoPage = function (pageIndex) {
            if (!this.model.allowPaging && (!this.model.allowScrolling && !this.model.scrollSettings.allowVirtualScrolling))
                return;
            var args = {}, returnValue;
            args.previousPage = this._currentPage();
            this._currentPage(pageIndex);
            args.endIndex = ((this._currentPage() * this.model.pageSettings.pageSize) > this._gridRecordsCount) ? (this._gridRecordsCount) : (this._currentPage() * this.model.pageSettings.pageSize);
            args.startIndex = (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
            args.currentPage = pageIndex;
            if (this.model.allowPaging) {
                args.requestType = ej.HeatMapGrid.Actions.Paging;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling) {
                this._isVirtualRecordsLoaded = false;
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
                args.requestType = ej.HeatMapGrid.Actions.VirtualScroll;
            }
            returnValue = this._processBindings(args);
            if (returnValue)
                this._currentPage(args.previousPage);
            this._primaryKeyValues = [];
        };
        HeatMapGrid.prototype._checkScrollActions = function (requestType) {
            if ((!this.model.scrollSettings.allowVirtualScrolling && (requestType == ej.HeatMapGrid.Actions.Sorting || requestType == ej.HeatMapGrid.Actions.Reorder)) || requestType == ej.HeatMapGrid.Actions.Grouping || requestType == ej.HeatMapGrid.Actions.Ungrouping || requestType == ej.HeatMapGrid.Actions.Add || requestType == ej.HeatMapGrid.Actions.Cancel
                || requestType == ej.HeatMapGrid.Actions.Save || requestType == ej.HeatMapGrid.Actions.BatchSave || requestType == ej.HeatMapGrid.Actions.Delete || requestType == ej.HeatMapGrid.Actions.Filtering || requestType == ej.HeatMapGrid.Actions.Paging || requestType == ej.HeatMapGrid.Actions.Refresh || requestType == ej.HeatMapGrid.Actions.Search)
                return true;
            return false;
        },
        HeatMapGrid.prototype._frozenAlign = function () {
            var gridContent = this.getContent().first(), browserDetails = this.getBrowserDetails(), direction;
            direction = this.model.enableRTL ? "margin-right" : "margin-left";
            gridContent.find(".e-movablecontent").css(direction, browserDetails.browser === "safari" ? "auto" : gridContent.find(".e-frozencontentdiv").width() + "px");
            this.getHeaderContent().find(".e-movableheader").removeAttr("style").css(direction, browserDetails.browser === "safari" ? "auto" : this.getHeaderContent().find(".e-frozenheaderdiv").width() + "px");
        },
        HeatMapGrid.prototype._refreshScroller = function (args) {
            var gridContent = this.getContent().first(), temp;
            if (ej.isNullOrUndefined(gridContent.data("ejScroller")))
                return;
            if (this.model.scrollSettings.frozenColumns > 0) {
                this._frozenAlign();
                this.refreshScrollerEvent();
                gridContent.find(".e-movablecontent").scrollLeft(this.getHeaderContent().find(".e-movableheader").scrollLeft());
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && this.getScrollObject()._vScrollbar.value() > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
            }
            if (this.model.scrollSettings.frozenRows > 0) {
                this._initFrozenRows();
                var temp = this.getScrollObject().model.scrollTop;
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && temp > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
                if ((args.requestType == "cancel" || args.requestType == "save") && temp > this._editFormHeight && this.model.editSettings.editMode.indexOf("inlineform") != -1)
                    temp = temp - this._editFormHeight;
                if (args.requestType == ej.Grid.Actions.Add)
                    this.getScrollObject().scrollY(0, true);
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar._scrollData))
                    this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
            }
            if (args.requestType == "beginedit") {
                var temp = this.getScrollObject().model.scrollTop;
                this.getScrollObject().scrollY(0, true);
            }
            if (!ej.isNullOrUndefined(this.model.dataSource) && (args.requestType == "refresh" || args.requestType == "searching") && this.model.scrollSettings.allowVirtualScrolling) {
                if (this.model.scrollSettings.enableVirtualization && this._isLocalData && this._gridRecordsCount > 0)
                    this._refreshVirtualView(this._currentVirtualIndex);
                else
                    this._refreshVirtualContent(1);
                if (this._currentVirtualIndex == 1)
                    this.getScrollObject().scrollY(0);
            }
            if (this.model.scrollSettings.frozenColumns > 0 && args.requestType != "filtering")
                this.rowHeightRefresh();
            else
                this.getScrollObject().refresh();
            gridContent.ejScroller("model.enableRTL", this.model.enableRTL);
            if (this.model.isResponsive && (args.requestType == 'searching' || args.requestType == "filtering")) {
                var scrollObj = this.getScrollObject();
                var height = scrollObj.isHScroll() ? this.getContentTable().height() + scrollObj.model.buttonSize : this.getContentTable().height();
                if (height > this.model.scrollSettings.height)
                    height = this.model.scrollSettings.height;
                var scrollWidth = typeof (this.model.scrollSettings.width) == "string" ? this.element.width() - scrollObj.model.buttonSize : this.model.scrollSettings.width;
                var width = scrollWidth;
                this.getContent().ejScroller({ height: height, width: width });
            }
            if (gridContent.ejScroller("isVScroll") && !this.getScrollObject().model.autoHide) {
                this.getHeaderContent().addClass("e-scrollcss");
                !this.getHeaderContent().find(".e-headercontent").hasClass("e-hscrollcss") && this.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
            }
            else
                this._showHideScroller();
            this._getRowHeights();
            if (temp && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && args.requestType != ej.Grid.Actions.Add) {
                this._currentTopFrozenRow = 0;
                if (temp > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
                this.getScrollObject()._vScrollbar.scroll(temp);
            }
            if (args.requestType == "virtualscroll") {
                var top = this.getScrollObject().model.scrollTop + this.getScrollObject().model.height - (this.getScrollObject().model.height * .3);
                this.getScrollObject().scrollY(top, true);
            }
        },
        HeatMapGrid.prototype._isFrozenColumnVisible = function () {
            for (var i = 0; i < this.model.scrollSettings.frozenColumns; i++) {
                if (this.model.columns[i].visible)
                    return true;
            }
            return false;
        },
        HeatMapGrid.prototype._frozenPaneRefresh = function () {
            this.getContent().find(".e-frozencontentdiv").css("display", "none");
            this.getHeaderContent().find(".e-frozenheaderdiv").css("display", "none");
            this.getHeaderContent().find(".e-movableheader")[0].style["margin-left"] = "";
            this.getContent().find(".e-movablecontent")[0].style["margin-left"] = "";
            var scrollWidth = ej.isNullOrUndefined(this._scrollObject._vScrollbar) ? 0 : this._scrollObject._vScrollbar["e-vscroll"].width();
            var movableWidth = this.model.scrollSettings.width - scrollWidth - 1;
            if (this.model.scrollSettings.width > this.getContent().find(".e-movablecontentdiv").width()) {
                this.getContent().find(".e-movablecontentdiv").width(movableWidth);
                this.getHeaderContent().find(".e-movableheaderdiv").width(movableWidth);
            }
            this._scrollObject.option("scrollLeft", 0);
        },
        HeatMapGrid.prototype._renderScroller = function () {

            if (!this.model.scrollSettings)
                this.model.scrollSettings = {};
            if (this.model.enablePersistence && (ej.isNullOrUndefined(this.model.scrollSettings.previousStateWidth) || !this.model.scrollSettings.previousStateWidth) && this.model.isResponsive)
                this.model.scrollSettings.previousStateWidth = this.model.scrollSettings.width;
            if (typeof (this._originalScrollWidth) == "string" && !this.model.isResponsive) {
                this.element.css("width", "auto");
                var width = this.element.width();
                if (this.model.scrollSettings.width == "auto" || this._originalScrollWidth == "auto")
                    this._originalScrollWidth = "100%";
                this.model.scrollSettings.width = width * (parseFloat(this._originalScrollWidth) / 100)
            }

            if (typeof (this.model.scrollSettings.height) == "string" && !this.model.isResponsive) {
                var height = this.element.height();
                if (this.model.scrollSettings.height == "auto")
                    this.model.scrollSettings.height = "100%";
                this.model.scrollSettings.height = height * (parseFloat(this.model.scrollSettings.height) / 100)
            }

            if ((this.model.scrollSettings.width || this.model.width) && !this._mediaQuery)
                this.element.width(this.model.scrollSettings.width || this.model.width);

            var $content = this.getContent().attr("tabindex", "0"), staticWidth, direction, gridRows = this.getRows();

            if (this.model.scrollSettings.frozenColumns > 0) {
                var scrollWidth = this.getContent().find(".e-frozencontentdiv").width() + 20;
                if (scrollWidth > this.model.scrollSettings.width) {
                    this.getContent().remove();
                    this.getHeaderTable().eq(1).remove();
                    return;
                }
                staticWidth = this.getContent().find(".e-frozencontentdiv").width();
                direction = this.model.enableRTL ? "margin-right" : "margin-left";
                this.getContent().find(".e-movablecontent").css(direction, staticWidth + "px");
                this.getHeaderContent().find(".e-movableheader").css(direction, staticWidth + "px");
                this.model.scrollSettings["targetPane"] = ".e-movablecontent";
            }
            this._initFrozenRows();
            if (this.model.scrollSettings.autoHide)
                this.model.scrollSettings["show"] = $.proxy(this._showHideScroller, this);
            var proxy = this;
            if (!this.model.scrollSettings.frozenRows)
                this.model.scrollSettings["scroll"] = function (e) {
                    if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.handler == "e-hhandle") {
                        if (proxy.model.allowFiltering && (proxy.model.filterSettings.filterType == "menu" || proxy._isExcelFilter))
                            !proxy._isExcelFilter ? proxy._closeFilterDlg() : proxy._excelFilter.closeXFDialog();
                        proxy._checkScroller(e, this);
                    }
                    else {
                        proxy._scrollValue = e.scrollTop;
                        proxy.model.currentIndex = e.scrollTop == 0 ? e.scrollTop : Math.floor(e.scrollTop / proxy._vRowHeight);
                    }
                };
            if (!this.model.scrollSettings.allowVirtualScrolling && this.model.currentIndex > 0 && !this.model.scrollSettings.scrollTop) {
                var sTop = this.model.currentIndex * this.getRowHeight();
                this.model.scrollSettings["scrollTop"] = sTop;
            }
            if (this.model.scrollSettings && !this.model.scrollSettings.height)
                this.model.scrollSettings.height = 0;
            $content.ejScroller(this.model.scrollSettings);
            if (this.model.rowTemplate != null && (this.getBrowserDetails().browser == "msie" || this.getBrowserDetails().browser == "safari"))
                this.getScrollObject().refresh();
            if (this.model.scrollSettings.frozenColumns > 0 && this.model.scrollSettings.frozenRows == 0 && this.getScrollObject()._vScrollbar && this.getScrollObject()._hScrollbar)
                this.getScrollObject()._vScrollbar._scrollData.skipChange = this.getScrollObject()._hScrollbar._scrollData.skipChange = true;
            if (!this.model.scrollSettings.autoHide)
                this._showHideScroller();
            if (this.getBrowserDetails().browser == "safari" && this.model.scrollSettings.frozenColumns > 0)
                this.getHeaderContent().find(".e-movableheader").add(this.getContent().find(".e-movablecontent")).css(direction, "auto");
            this.refreshScrollerEvent();
            if (this.model.scrollSettings.frozenColumns > 0 && !this._isFrozenColumnVisible())
                this._frozenPaneRefresh();
            if (proxy.model.scrollSettings.allowVirtualScrolling) {
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
                $content.ejScroller({
                    scroll: function (e) {
                        if (proxy.model.scrollSettings.enableVirtualization && e.scrollData != null && e.scrollData.handler != "e-hhandle") {
                            e["reachedEnd"] = e.scrollData.scrollable - e.scrollTop == 0;
                            if (e.source == "thumb") {
                                var keys = Object.keys(proxy._virtualLoadedRows);
                                var index = (proxy._currentVirtualIndex + 2).toString();
                                if (proxy.model.scrollSettings.virtualScrollMode == "continuous" && $.inArray(index, keys) == -1 && index < proxy._totalVirtualViews)
                                    proxy._isContinuous = true;
                                else {
                                    e.model.scrollTop = e.scrollTop;
                                    proxy._isContinuous = false;
                                    e.cancel = true;
                                }
                            }
                            if (e.source == "button" || e.source == "key" || e.source == "wheel") {
                                proxy._isThumbScroll = false;
                                proxy._virtualViewScroll(e);
                                if (proxy.model.scrollSettings.virtualScrollMode == "continuous" && e["reachedEnd"])
                                    this.refresh();
                            }
                            proxy.model.currentIndex = e.scrollTop == 0 ? e.scrollTop : Math.floor(e.scrollTop / proxy._vRowHeight);
                        }
                        else {
                            if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.handler == "e-hhandle" && proxy.model.allowFiltering && (proxy.model.filterSettings.filterType == "menu" || proxy._isExcelFilter))
                                !proxy._isExcelFilter ? proxy._closeFilterDlg() : proxy._excelFilter.closeXFDialog();
                            e["reachedEnd"] = this.content()[0].scrollHeight - e.scrollTop == this.content()[0].clientHeight;
                            if ((e.source == "button" || e.source == "key" || e.source == "wheel") && proxy.model != null)
                                proxy._virtualScroll(e);
                            if (e.source == "wheel" && e.scrollTop != proxy._scrollValue)
                                e.scrollTop = proxy._scrollValue;
                            proxy._checkScroller(e, this);
                        }
                    },
                    thumbEnd: function (e) {
                        if (proxy.model.scrollSettings.enableVirtualization && proxy.model.scrollSettings.virtualScrollMode == "continuous")
                            e["reachedEnd"] = e.scrollData.scrollable - e.model.scrollTop == 0;
                        else if (e.originalEvent && !$(e.originalEvent.target).hasClass("e-rowcell"))
                            e["reachedEnd"] = this.content()[0].scrollHeight - e.scrollData.sTop == this.content()[0].clientHeight;
                        if (e.scrollData.handler == "e-hhandle")
                            return;
                        if (proxy.model != null && e.originalEvent) {
                            if (proxy.model.scrollSettings.enableVirtualization) {
                                proxy._isThumbScroll = true;
                                proxy._virtualViewScroll(e);
                                if (proxy.model.scrollSettings.virtualScrollMode == "continuous" && e["reachedEnd"])
                                    this.refresh();
                            }
                            else
                                proxy._virtualScroll(e);
                        }
                    },
                    scrollEnd: function (e) {
                        if (e.scrollData.type == "mousewheel" || (e.scrollData.model != null && e.scrollData.model.orientation == "horizontal")) return;
                        if (proxy.model.scrollSettings.enableVirtualization && !proxy._isContinuous) {
                            var currentPage = proxy._calculateCurrentViewPage(e.model);
                            var isVirtualPage = $.inArray(currentPage, proxy._virtualLoadedPages) != -1;
                            if (isVirtualPage) {
                                proxy._isThumbScroll = true;
                                proxy._virtualViewScroll(e);
                                if (proxy._totalVirtualViews <= proxy._maxViews * 3)
                                    this._content[0].scrollTop = e.scrollData.scrollTop;
                            }
                            else {
                                e.cancel = true;
                            }
                        }
                    }
                });
            }
        },
        HeatMapGrid.prototype._checkScroller = function (e, scrollObj) {
            var scrollLeft = e.scrollLeft > 0 ? e.scrollLeft : Math.abs(e.scrollLeft);
            if (e.source == "thumb" && (scrollObj.content()[0].scrollWidth - scrollLeft == scrollObj.content()[0].clientWidth || scrollLeft == 0)) {
                if (this.model.enableRTL) {
                    var hLeft = scrollLeft == 0 ? e.scrollData.scrollable : 0;
                    e.scrollData.sTop = e.model.scrollLeft = hLeft;
                    scrollObj.content().scrollLeft(hLeft);
                }
                scrollObj.refresh();
            }
        },
        HeatMapGrid.prototype._showHideScroller = function () {
            if (this.getContent().ejScroller("isVScroll")) {
                this.getHeaderContent().find("div").first().addClass("e-headercontent");
                !this.model.scrollSettings.autoHide && this.getHeaderContent().addClass("e-scrollcss")
            } else
                this.element.find(".e-gridheader").removeClass("e-scrollcss");
            if (this.getBrowserDetails().browser != "msie" && this.model.scrollSettings.frozenColumns == 0 && !this._mediaQuery) {
                if (!this.element.find(".e-gridheader").hasClass("e-scrollcss") && (this.model.filterSettings.filteredColumns.length || this._hiddenColumns.length)) {
                    this.getHeaderTable().removeAttr('style');
                    this.getContentTable().removeAttr('style');
                }
                else {
                    this.getHeaderContent().find("div table").first().width(this.getContentTable().width());
                    this.getContent().find("div table").first().width(this.getContentTable().width());
                    this.getHeaderTable().width(this.getContentTable().width());
                }
            }
            if (this.getBrowserDetails().browser == "msie" && this.model.scrollSettings.frozenColumns == 0)
                !this.getContent().ejScroller("isVScroll") ? this.getContent().width(this.getHeaderContent().width()) : this.getContent().width(this.getHeaderContent().width() + 18);
            this._isHscrollcss();
        };
        HeatMapGrid.prototype._isHscrollcss = function () {
            var scroller = this.getContent().data("ejScroller"), css = scroller && (scroller.isHScroll() || scroller.isVScroll()) ? "addClass" : "removeClass";
            this.getHeaderContent().find(".e-headercontent")[css]("e-hscrollcss")
        };
        HeatMapGrid.prototype._initFrozenRows = function () {
            var gridRows = this.getRows();
            if (!this.model.currentViewData || this.model.currentViewData.length == 0)
                return;
            if (this.model.scrollSettings.frozenRows > 0 && gridRows != null) {
                this.model.scrollSettings["scroll"] = $.proxy(this._scroll, this);
                this.getContent().find(".e-frozeny").removeClass("e-frozeny")
                    .end().find(".e-frozenrow").removeClass("e-frozenrow");
                if (!ej.isNullOrUndefined(gridRows[0][this.model.scrollSettings.frozenRows - 1]) && !ej.isNullOrUndefined(gridRows[1][this.model.scrollSettings.frozenRows - 1]) && this.model.scrollSettings.frozenColumns > 0)
                    $(gridRows[0][this.model.scrollSettings.frozenRows - 1].cells).add(gridRows[1][this.model.scrollSettings.frozenRows - 1].cells).addClass("e-frozeny").parent().addClass("e-frozenrow");
                else if (!ej.isNullOrUndefined(this.getRowByIndex(this.model.scrollSettings.frozenRows - 1)[0]))
                    $(gridRows[this.model.scrollSettings.frozenRows - 1].cells).addClass("e-frozeny").parent().addClass("e-frozenrow");
                this.model.scrollSettings.height = this._rowHeightCollection[Math.floor(this.model.scrollSettings.height / this._rowHeightCollection[1])] + 18;
            }
            else
                delete this.model.scrollSettings["scroll"];
        };
        HeatMapGrid.prototype.refreshScrollerEvent = function () {
            var proxy = this;
            this.getContent().find(".e-content:first,.e-movablecontent").scroll(ej.proxy(function (e) {
                if (this.model.scrollSettings.targetPane)
                    this.getHeaderContent().find(".e-movableheader").scrollLeft($(e.currentTarget).scrollLeft());
                else
                    this.getHeaderContent().find("div").first().scrollLeft($(e.currentTarget).scrollLeft());
                if (this.model.scrollSettings.frozenRows > 0 && this.model.editSettings.editMode.indexOf("inlineform") != -1 && this.model.isEdit) {
                    var scrollTop = e.target.scrollTop;
                    this.getContent().find(".e-content").scrollTop(0);
                    this.getScrollObject().scrollY(this.getScrollObject().model.scrollTop + scrollTop, true);
                }
            }, this));
            this.element.find(".e-gridheader").find(".e-headercontent,.e-movableheader").scroll(ej.proxy(function (e) {
                var $currentTarget = $(e.currentTarget);
                if (this.model.scrollSettings.targetPane) {
                    this.getContent().find(".e-movablecontent").scrollLeft($currentTarget.scrollLeft());
                    this.model.showSummary && this.getFooterContent().find(".e-movablefooter").scrollLeft($currentTarget.scrollLeft());;
                }
                else {
                    this.model.showSummary && this.getFooterContent().scrollLeft($currentTarget.scrollLeft());
                    this.getContent().find(".e-content").first().scrollLeft($currentTarget.scrollLeft());
                }
            }, this));
        };
        HeatMapGrid.prototype._renderByFrozenDesign = function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this.model.scrollSettings.frozenColumns))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            this.getContent().find("div").first().get(0).innerHTML = $.render[this._id + "_FrozenTemplate"]({ datas: this.model.currentViewData }, colgroups);
            this.setGridContentTable(this.getContent().find(".e-table").attr("role", "heatmap"));
        };
        HeatMapGrid.prototype.addFrozenTemplate = function () {
            var template = "<div class='e-frozencontentdiv'>"
            + "<table cellspacing='0.25px' class='e-table'>{{:~colgroup1}}<tbody>"
            + "{{for datas tmpl='" + this._id + "_JSONFrozenTemplate'/}}"
            + "</tbody></table></div>"
            + "<div class='e-movablecontent'><div class='e-movablecontentdiv'><table cellspacing='0.25px' class='e-table'>{{:~colgroup2}}<tbody>"
            + "{{for datas tmpl='" + this._id + "_JSONTemplate'/}}"
            + "</tbody></table></div></div>", templates = {};
            templates[this._id + "_FrozenTemplate"] = template;
            $.templates(templates);
        };
        HeatMapGrid.prototype._getTopRow = function (offsetTop) {
            var currentTopRow = this.model.scrollSettings.frozenRows, i = 0;
            if (offsetTop > 10) {
                for (var i = 0; i < this._rowHeightCollection.length; i++) {
                    if (this._rowHeightCollection[i] > offsetTop) {
                        currentTopRow = this.model.scrollSettings.frozenRows + i - 1;
                        break;
                    }
                }
            }
            return { imaginaryIndex: currentTopRow, actualIndex: i };
        };
        HeatMapGrid.prototype._showHideRow = function (from, to, action, scrollPosition) {
            var rows = this.getRows();
            if (this.model.scrollSettings.frozenColumns > 0)
                $(rows[0]).slice(from, to).add($(rows[1]).slice(from, to).toArray())[action]();
            else
                $(rows).slice(from, to)[action]();
            this._currentTopFrozenRow = action == "show" ? from : to;
            this.getScrollObject()._changevHandlerPosition(scrollPosition);
        };
        HeatMapGrid.prototype._scroll = function (args) {
            if (args.scrollData != null && args.scrollData.dimension != "width") {
                args.cancel = true;
                var rows = this.getRows(), indexes = this._getTopRow(args.scrollTop), currentTopRow = indexes.imaginaryIndex, frozenRows;
                if (currentTopRow > this._currentTopFrozenRow)
                    this._showHideRow(this.model.scrollSettings.frozenRows, currentTopRow, "hide", args.scrollTop);
                else if (currentTopRow < this._currentTopFrozenRow)
                    this._showHideRow(currentTopRow, this._currentTopFrozenRow + 1, "show", args.scrollTop);
                var movableContent = this.getContentTable().last().find("tr");
                var border = (parseInt(movableContent.last().find("td:first").css("border-top-width")) * 2) + 1;
                if (args.scrollTop == this.getScrollObject()._vScrollbar.model.maximum && ((movableContent.last()[0].offsetTop + movableContent.last().height() - border) > this.element.find(".e-content").height())) {
                    var totalHeight = movableContent.last().prev()[0].offsetTop + movableContent.last().prev().height();
                    var count = 1;
                    for (var i = (movableContent.length - 2) ; totalHeight - border > this.element.find(".e-content").height() ; i++) {
                        totalHeight = movableContent[i].offsetTop + movableContent.eq(i).height();
                        count++;
                        break;
                    }
                    this._showHideRow(this.model.scrollSettings.frozenRows, currentTopRow + count, "hide", args.scrollTop);
                }
                args.model.scrollTop = args.scrollTop;
            }
            else {
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar._scrollData))
                    this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
            }
        };
        HeatMapGrid.prototype._virtualScroll = function (e) {
            if (e != null) {
                var flag = 0;
                var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
                var pageInfo = this.model.pageSettings;
                var tbody = this.getContentTable()[0].tBodies[0];
                var virtualRows = $(tbody).find('tr.e-virtualrow');
                pageInfo.totalPages = Math.ceil(recordCount / pageInfo.pageSize);
                if (e.scrollTop !== undefined)
                    e.model.scrollTop = e.scrollTop;
                if (e.reachedEnd != undefined) e.model.reachedEnd = e.reachedEnd;
                var currentPageNo = this._calculateCurrenPage(virtualRows, this.getContentTable(), e.model);
                if (currentPageNo > pageInfo.totalPages)
                    currentPageNo = pageInfo.totalPages;
                if (pageInfo.currentPage != currentPageNo && $.inArray((currentPageNo - 1) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                    this._isVirtualRecordsLoaded = false;
                }
                if (!this._isVirtualRecordsLoaded) {
                    if ($.inArray((currentPageNo - 1) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                        if (this.model.scrollSettings.virtualScrollMode == "continuous" && !e.reachedEnd)
                            return
                        if (currentPageNo == pageInfo.totalPages && $.inArray((currentPageNo - 2) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                            flag++;
                            this.set_currentPageIndex(currentPageNo);
                        }
                        if (flag == 1) this._lastRow = true;
                        this.set_currentPageIndex(currentPageNo);
                    }
                    pageInfo.currentPage = currentPageNo;
                }
                else
                    pageInfo.currentPage = currentPageNo;
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
        };
        HeatMapGrid.prototype._virtualViewScroll = function (e) {
            if (e != null) {
                if (e.scrollTop !== undefined)
                    e.model.scrollTop = e.scrollTop;
                if (e.reachedEnd != undefined) e.model.reachedEnd = e.reachedEnd;
                var currentVirtualIndex = this._calculateCurrentVirtualIndex(e);
                if ($.inArray(currentVirtualIndex, this._currentLoadedIndexes) == -1)
                    this._isVirtualRecordsLoaded = false;
                if (!this._isVirtualRecordsLoaded)
                    this.set_currentVirtualIndex(currentVirtualIndex);
            }
        };

        HeatMapGrid.prototype._refreshVirtualContent = function (currentPage) {
            var rowHeight = this.getRowHeight();
            var recordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (currentPage != null) {
                this._currentPage(currentPage);
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
            var currentIndex = this.getCurrentIndex();
            var tbody = this.getContentTable()[0].tBodies[0];
            if (currentIndex > 0) {
                var virtualTRTop = document.createElement("tr");
                $(virtualTRTop).addClass("e-virtualrow").css("height", rowHeight * currentIndex).prependTo(tbody);
            } if (currentIndex + this.model.pageSettings.pageSize <= recordsCount && this.getContentTable().find("tr").last().hasClass("e-virtualrow") != true && this.model.scrollSettings.frozenColumns == 0) {
                var virtualTRBottom = document.createElement("tr");
                var virtualHeight = this.model.scrollSettings.virtualScrollMode == "normal" ? rowHeight * (recordsCount - (currentIndex + this.model.pageSettings.pageSize)) : 1;
                $(virtualTRBottom).addClass("e-virtualrow").css("height", virtualHeight).appendTo($(tbody));
            }
            this.virtualLoadedPages = new Array();
            this.orderedVirtualLoadedPage = [];
            this.virtualLoadedPages.push(currentIndex >= 0 ? currentIndex : 0);
            this.orderedVirtualLoadedPage.push(currentIndex >= 0 ? currentIndex : 0);
            var focusTR = $(tbody).find('tr:not(.e-virtualrow)').attr('name', currentIndex >= 0 ? currentIndex : 0)[0];
            if (focusTR && focusTR.previousSibling && ($(focusTR.previousSibling).hasClass("e-virtualrow") || focusTR.previousSibling.offsetTop > (currentIndex * this.getContent().height()))) {
                this.getContent().children("div").first().scrollTop(this.getContent().find(".content").scrollTop() - (this.getContent().find(".content").scrollTop() - focusTR.offsetTop));
                this._isVirtualRecordsLoaded = true;
            }
        };
        HeatMapGrid.prototype._refreshVirtualView = function (currentIndex) {
            if (!this._singleView) {
                var virtualRowCount = this._virtualRowCount;
                if (currentIndex) {
                    var scrollRefresh, currentPage;
                    if (currentIndex > this._totalVirtualViews) {
                        currentIndex = 1;
                        scrollRefresh = true;
                    }
                    this._currentVirtualIndex = currentIndex;
                    if (!this._virtualLoadedRecords[currentIndex]) {
                        if (!this._virtualDataRefresh && this._currentVirtualIndex != this._totalVirtualViews) scrollRefresh = true;
                        currentPage = Math.ceil(currentIndex * this._virtualRowCount / this.model.pageSettings.pageSize);
                    }
                    else
                        currentPage = Math.ceil(this.model.currentIndex / this.model.pageSettings.pageSize);
                    this._refreshVirtualViewScroller(scrollRefresh);
                    if (currentPage > this.model.pageSettings.totalPages) currentPage = this.model.pageSettings.totalPages;
                    if (currentPage <= 0) currentPage = 1;
                    if ($.inArray(currentPage, this._virtualLoadedPages) == -1)
                        this.gotoPage(currentPage);
                    else {
                        this._currentPage(currentPage);
                        if (!this._checkCurrentVirtualView(this._virtualLoadedRecords, currentIndex))
                            this._needPaging = true;
                        else
                            this._needPaging = false;
                        this._getVirtualLoadedRecords(this.model.query);
                        this._replacingVirtualContent();
                    }
                }
                else {
                    this._refreshVirtualViewDetails();
                    var rows = $(this.getContentTable()[0].rows);
                    this._setVirtualTopBottom();
                    if (this.initialRender) {
                        for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                            var currentLoadedIndex = this._currentLoadedIndexes[i]; var viewIndex = (i + 1) * virtualRowCount, viewCount = i * virtualRowCount;
                            $(rows[viewIndex - 1]).addClass("e-virtualview" + currentLoadedIndex);
                            var hex = currentLoadedIndex.toString(32);
                            var vRows = rows.slice(viewCount, viewCount + virtualRowCount).attr('name', hex).detach();
                            this._virtualLoadedRows[currentLoadedIndex] = vRows;
                            vRows.appendTo(this.getContentTable());
                        }
                        if (this._currentVirtualIndex > 1)
                            this._refreshVirtualViewScroller();
                    }
                    this._eventBindings();
                }
                if ($.inArray(this._currentPage(), this._virtualLoadedPages) == -1)
                    this._virtualLoadedPages.push(this._currentPage());
            }
            else {
                this._singleView = false;
                this._addLastRow();
                this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
                var hex = this._currentVirtualIndex.toString(32);
                $(this._gridRows).attr('name', hex);
                this._virtualLoadedRows[this._currentVirtualIndex] = this._gridRows;
                this._eventBindings();
            }
            if (!currentIndex && (this.model.queryCellInfo || this.model.rowDataBound)) {
                for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                    if ($.inArray(this._currentLoadedIndexes[i], this._queryCellView) == -1)
                        this._queryCellView.push(this._currentLoadedIndexes[i]);
                }
            }
            this._isThumbScroll = false;
            this._virtualDataRefresh = false;
        };
        HeatMapGrid.prototype._refreshVirtualViewData = function () {
            this._virtualLoadedRecords = {};
            this._virtualLoadedRows = {};
            this._virtualLoadedPages = [];
            this._virtualPageRecords = {};
            this._queryCellView = [];
            if (this.model.pageSettings.totalPages != null && this._currentPage() > this.model.pageSettings.totalPages) {
                this._currentPage(1);
                this._currentVirtualIndex = 1;
            }
        };
        HeatMapGrid.prototype.setCurrentPageData = function (currentData) {
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                this._refreshVirtualViewData();
                this._refreshVirtualViewDetails();
                this._setVirtualLoadedRecords(currentData, this._currentPage());
                this._refreshVirtualView(this._currentVirtualIndex);
            }
        };
        HeatMapGrid.prototype._refreshVirtualViewScroller = function (needRefresh) {
            var scrollValue;
            if ((this.initialRender && !this.model.scrollSettings.scrollTop) || needRefresh) {
                var rowHeight = this._vRowHeight;
                scrollValue = this.model.currentIndex * this._vRowHeight;
            }
            else
                scrollValue = this._scrollObject.model.scrollTop;
            this.getContent().ejScroller("model.scrollTop", scrollValue);
            this._scrollValue = scrollValue;
        };
        HeatMapGrid.prototype._calculateCurrentViewPage = function (args) {
            if (!args) args = this._scrollObject.model;
            var pageSize = this.model.pageSettings.pageSize;
            var currentPage = Math.ceil((args.scrollTop + this.model.scrollSettings.height) / this._vRowHeight / pageSize);
            // if(this.model.scrollSettings.virtualScrollMode == "continuous")
            // currentPage = Math.ceil(this._currentVirtualIndex * this._virtualRowCount / this.model.pageSettings.pageSize);
            if (this.model.pageSettings.totalPages == null)
                this.model.pageSettings.totalPages = Math.ceil(this._getVirtualTotalRecord() / pageSize);
            if (currentPage > this.model.pageSettings.totalPages)
                currentPage = this.model.pageSettings.totalPages;
            return currentPage;
        };
        HeatMapGrid.prototype._calculateCurrentVirtualIndex = function (e) {
            var args = e.model, recordCount = this._getVirtualTotalRecord();
            var currentIndex, trEle, isLast, viewTr = [], cur, oTop, len, sTop = args.scrollTop;
            var index = sTop + this.model.scrollSettings.height;
            currentIndex = index / this._vRowHeight / this._virtualRowCount;
            if (this._prevVirtualIndex > this._currentVirtualIndex && sTop <= this._scrollValue)
                currentIndex = Math.floor(currentIndex);
            else
                currentIndex = Math.ceil(currentIndex);
            if (sTop >= this._scrollValue && args.virtualScrollMode == "continuous" && args.reachedEnd)
                currentIndex = currentIndex + 1;
            if (currentIndex > this._totalVirtualViews) currentIndex = this._totalVirtualViews;
            if (currentIndex <= 0) currentIndex = 1;
            if ($.inArray(currentIndex, this._currentLoadedIndexes) !== -1 && this._virtualLoadedRows[currentIndex] && sTop != e.scrollData.scrollable) {
                var viewTrs = this.getContentTable()[0].rows; len = viewTrs.length;
                var virtualTopHeight = this.getContent().find(".e-virtualtop").height();
                isLast = sTop >= this._scrollValue;
                for (var i = 0; i < len; i++) {
                    cur = viewTrs[i];
                    oTop = cur.offsetHeight + cur.offsetTop + virtualTopHeight;
                    if (oTop > sTop + this.model.scrollSettings.height) {
                        if (viewTr.length === 0 && i !== 0)
                            viewTr = [viewTrs[cur.offsetTop <= sTop + this.model.scrollSettings.height ? i : i - 1]];
                        break;
                    }
                    if (oTop >= sTop && oTop <= sTop + this.model.scrollSettings.height) {
                        viewTr.push(cur);
                        if (isLast === false && viewTr.length > 1)
                            break;
                    }
                }
                trEle = $(sTop >= this._scrollValue ? viewTr[viewTr.length - 1] : viewTr[0]);
                if (trEle.length)
                    currentIndex = parseInt(trEle.attr("name"), 32);
            }
            this._scrollValue = sTop;
            return currentIndex;
        };
        HeatMapGrid.prototype._calculateCurrenPage = function (virtualRows, target, args) {
            var pageSize = this.model.pageSettings.pageSize;
            var currentPage, tempCPage, diff, proxy = this, trEle, isLast, viewTr = [], cur, oTop, len, currentRowValue, $currentRow;
            var rowHeight = this.getRowHeight();
            currentPage = (args.scrollTop + this.model.scrollSettings.height) / rowHeight / pageSize;
            currentRowValue = (this.model.pageSettings.pageSize * (this.model.pageSettings.currentPage - 1));
            $currentRow = this.getContentTable().find("tr[name=" + currentRowValue + "]").eq(0);
            if ($currentRow.length && $currentRow.offset().top > 0 && currentPage >= 1 && args.scrollTop < this._scrollValue && this.virtualLoadedPages.indexOf(Math.ceil(currentPage - 1) * pageSize) !== -1)
                currentPage = Math.floor(currentPage);
            else
                currentPage = Math.ceil(currentPage);

            if (args.scrollTop >= this._scrollValue && args.virtualScrollMode == "continuous" && args.reachedEnd) {
                currentPage = this.virtualLoadedPages[this.virtualLoadedPages.length - 1] / pageSize + 2;
            }

            if ($.inArray((currentPage - 1) * pageSize, this.virtualLoadedPages) !== -1) {
                var viewTrs = this.getContentTable().children("tbody").children("tr"); len = viewTrs.length;
                isLast = args.scrollTop >= this._scrollValue;
                for (var i = 0; i < len; i++) {
                    cur = viewTrs[i];
                    oTop = cur.offsetHeight + cur.offsetTop;
                    if (oTop > args.scrollTop + proxy.model.scrollSettings.height) {
                        if (viewTr.length === 0 && i !== 0)
                            viewTr = [viewTrs[cur.offsetTop <= args.scrollTop + proxy.model.scrollSettings.height ? i : i - 1]];
                        break;
                    }
                    if (oTop >= args.scrollTop && oTop <= args.scrollTop + proxy.model.scrollSettings.height) {
                        viewTr.push(cur);
                        if (isLast === false && viewTr.length > 1)
                            break;
                    }
                }
                trEle = $(args.scrollTop >= this._scrollValue ? viewTr[viewTr.length - 1] : viewTr[0]);
                if (trEle.hasClass('e-virtualrow')) {
                    if (viewTr.length === 1) {
                        currentPage++;
                    }
                }
                else
                    currentPage = parseInt(trEle.attr("name"), 10) / pageSize + 1;
            }
            this._scrollValue = args.scrollTop;
            for (var index = 0; index < virtualRows.length; index++) {
                var val = virtualRows[index];
                if (val.offsetTop + val.offsetHeight >= args.scrollTop) {
                    var prevVirtualPage = this._calculatePrevPage(virtualRows, target, args);
                    this._prevPageNo = prevVirtualPage;
                    if (currentPage == 0)
                        currentPage = 1;
                    currentPage = currentPage > this.model.pageSettings.totalPages ? this.model.pageSettings.totalPages : currentPage;
                    return currentPage;
                }
            }
            return currentPage;
        };
        HeatMapGrid.prototype._calculatePrevPage = function (virtualRows, target, args) {
            for (var i = 0; i < virtualRows.length; i++) {
                var val = virtualRows[i];
                if (val.offsetTop + val.offsetHeight >= args.scrollTop) {
                    var trElement = $(val).prevAll('tr[name]')[0];
                    if (trElement != null) {
                        return Math.ceil(parseInt($(trElement).attr('name'), 10) / this.model.pageSettings.pageSize) + 1;
                    }
                }
            }
            return -1;
        };
        HeatMapGrid.prototype._refreshVirtualPagerInfo = function () {
            var model = {};
            model.pageSize = this.model.pageSettings.pageSize;
            model.currentPage = this._currentPage();
            model.totalRecordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            model.totalPages = Math.ceil(model.totalRecordsCount / model.pageSize);

            return model;
        };
        HeatMapGrid.prototype._showPagerInformation = function (model) {
            var from = (model.currentPage - 1) * model.pageSize;
            $(this.$pagerStatusBarDiv).find("div:first").html(String.format("{0} of {1} pages ({2} items)", model.currentPage, model.totalPages, model.totalRecordsCount), from, from + model.pageSize);
            $(this.$pagerStatusBarDiv).css('display', 'block');
        };
        HeatMapGrid.prototype._replacingContent = function () {
            var temp = document.createElement('div');
            var currentIndex = this.getCurrentIndex();
            var contentTable = this.getContentTable()[0];
            var colGroup = $(contentTable).find("colgroup").first();
            var rowHeight = this.getRowHeight();
            colGroup.replaceWith(this._getMetaColGroup());
            (this.model.detailsTemplate != null || this.model.childGrid != null) && colGroup.prepend(this._getIndentCol());
            var tbody = contentTable.tBodies[0];
            var currentData = this.model.currentViewData;
            if (!ej.isNullOrUndefined(this._currentPageData)) {
                this._virtualLoadedRecords[this._currentPage()] = this._currentPageData;
                this._currentPageData = null;
            }
            else
                this._virtualLoadedRecords[this._currentPage()] = currentData;
            var elementTbody = $("<tbody></tbody>").append($.render[this._id + "_JSONTemplate"](currentData));
            var proxy = this;
            var $elementTbody = elementTbody.children("tr");
            if (this._allowcolumnSelection && this.selectedColumnIndexes.length > 0) {
                for (var index = 0; index < this.selectedColumnIndexes.length; index++) {
                    var ind = this.selectedColumnIndexes[index] + 1;
                    $elementTbody.find('td:nth-of-type(' + ind + ')').addClass("e-columnselection");
                }
            }
            this.virtualLoadedPages.push(currentIndex >= 0 ? currentIndex : 0);
            var orderedVirtualPages = ej.dataUtil.mergeSort(ej.distinct(this.virtualLoadedPages));
            $($elementTbody).attr('name', currentIndex);
            var minValue = ej.dataUtil.min(orderedVirtualPages);
            var maxValue = ej.dataUtil.max(orderedVirtualPages);
            $(tbody).children(".e-virtualrow").remove();
            for (var i = 0; i < orderedVirtualPages.length; i++) {
                var val = orderedVirtualPages[i];
                var pVal = orderedVirtualPages[i - 1];
                if (val != this.orderedVirtualLoadedPage[i] || this.orderedVirtualLoadedPage[i] == undefined) {
                    if (pVal != undefined)
                        $elementTbody.insertAfter($(tbody).children('[name=' + pVal + ']:last'));
                    else
                        $elementTbody.insertBefore($(tbody).children('[name=' + this.orderedVirtualLoadedPage[i] + ']:first'));
                    this.orderedVirtualLoadedPage = orderedVirtualPages;
                }
                if (val != 0) {
                    var prevValue = val == minValue ? minValue : pVal;
                    var middleRows = val - prevValue - proxy.model.pageSettings.pageSize;
                    if (middleRows > 0) {
                        var virtualTRMiddle = document.createElement("tr");
                        $(virtualTRMiddle).addClass("e-virtualrow").css("height", rowHeight * middleRows).insertBefore($(tbody).children('[name=' + val + ']:first'));
                    }
                }
                if (val == maxValue) {
                    var bottomRows = proxy._gridRecordsCount - maxValue - proxy.model.pageSettings.pageSize;
                    if (bottomRows > 0) {
                        var virtualTRBottom = document.createElement("tr");
                        $(virtualTRBottom).addClass("e-virtualrow").css("height", rowHeight * bottomRows).appendTo(tbody);
                    }
                }
            }
            if (minValue > 0) {
                var virtualTRTop = document.createElement("tr");
                $(virtualTRTop).addClass("e-virtualrow").css("height", rowHeight * minValue).prependTo(tbody);
            }
            var $content = this.getContent();
            var focusTR = $(tbody).children("tr[name=" + currentIndex + "]")[0];
            var focusPrev = focusTR.previousSibling;
            var con = $content.height();
            var focus = focusTR.offsetTop
            if (this._virtaulUnSel) {
                var virtualClone = $.extend(true, [], this._virtaulUnSel);
                for (var i = 0; i < virtualClone.length; i++) {
                    var row = virtualClone[i];
                    var page = this.model.pageSettings.currentPage;
                    var corresPage = row % this.model.pageSettings.pageSize == 0 ? parseInt(row / this.model.pageSettings.pageSize) : parseInt(row / this.model.pageSettings.pageSize) + 1;
                    if (corresPage == page) {
                        var index = row % this.model.pageSettings.pageSize;
                        var $row = $(tbody).find("tr[name=" + currentIndex + "]").eq(index);
                        $row.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                        var removeIndex = this._virtaulUnSel.indexOf(row);
                        if (removeIndex != -1)
                            this._virtaulUnSel.splice(removeIndex, 1);
                    }
                }
            }
            if ((focusTR && focusPrev && ((this._virIndex || $(focusPrev).hasClass("e-virtualrow")) || focusPrev.offsetTop > (currentIndex * con))
            && (this._gridRecordsCount - currentIndex >= this.model.pageSettings.pageSize || focusTR.offsetParent.offsetHeight - focus < con)) || this._lastRow) {
                if (this._lastRow) this._lastRow = false;
                if (this._virIndex) this._virIndex = false;
                this._isVirtualRecordsLoaded = true;
                //this.getContent().children("div").first().scrollTop(this.getContent().find(".content").scrollTop() - (this.getContent().find(".content").scrollTop() - focusTR.offsetTop));
                $content.find(".e-content").scrollTop(focus);
                this._scrollValue = this.getContent()[0].firstChild.scrollTop;
            }
            var $contentTableTr = $(contentTable).get(0);
            var tFirst = temp.firstChild;
            this._currentJsonData = currentData;
            this._gridRows = $(contentTable).get(0).rows;
            var lastVirtualRow = $(contentTable).find(".e-virtualrow").last();
            var lastVirtualRowHeight = this.model.scrollSettings.virtualScrollMode == "normal" ? (lastVirtualRow.height() - ($(contentTable).height() - (this._gridRecordsCount * rowHeight))) : 1;
            lastVirtualRow.css("height", lastVirtualRowHeight);
            this._eventBindings();
        };
        HeatMapGrid.prototype._replacingVirtualContent = function () {
            var contentTable = this.getContentTable()[0];
            var currentLoadedIndexes = this._currentLoadedIndexes;
            var tempTbody = $("<tbody></tbody>");
            if (this._checkCurrentVirtualView(this._virtualLoadedRows, this._currentVirtualIndex)) {
                var currentRows = [];
                for (var i = 0; i < currentLoadedIndexes.length; i++) {
                    $.merge(currentRows, this._virtualLoadedRows[currentLoadedIndexes[i]]);
                }
                $(tempTbody).append(currentRows);
            }
            else {
                var elementTbody = $("<tbody></tbody>");
                for (var i = 0; i < currentLoadedIndexes.length; i++) {
                    var currentIndex = currentLoadedIndexes[i], virtualRow = this._virtualLoadedRows[currentIndex];
                    if (!virtualRow) {
                        var elementTbody = $("<tbody></tbody>").append($.render[this._id + "_JSONTemplate"](this._virtualLoadedRecords[currentIndex]));
                        var $elementTbody = elementTbody[0].rows, length = $elementTbody.length - 1;
                        $($elementTbody[length]).addClass("e-virtualview" + currentIndex);
                        var hex = currentIndex.toString(32);
                        var vRows = $($elementTbody).attr('name', hex);
                        if (vRows.length == this._virtualRowCount || currentIndex == this._totalVirtualViews) {
                            this._virtualLoadedRows[currentIndex] = vRows;
                            tempTbody.append($elementTbody);
                        }
                    }
                    else {
                        if (currentIndex < this._currentVirtualIndex) {
                            var vRow = tempTbody.find(".e-virtualview" + currentIndex);
                            if (vRow.length)
                                $(virtualRow).insertBefore(vRow);
                            else
                                tempTbody.prepend(virtualRow);
                        }
                        else
                            $(virtualRow).insertAfter(tempTbody.find(".e-virtualview" + (currentIndex - 1)));
                    }
                }
            }
            contentTable.replaceChild(tempTbody[0], contentTable.lastChild);
            $(contentTable.rows).removeClass("e-hover");
            this._setVirtualTopBottom();
            if (this._isThumbScroll || this._remoteRefresh) {
                //this._scrollObject.refresh();				
                this._scrollObject._content[0].scrollTop = this._scrollObject.scrollTop();
                this._isThumbScroll = this._remoteRefresh = false;
            }
            if (this.model.allowSelection)
                this._checkVirtualSelection();
            this._gridRows = contentTable.rows;
            if (!this._checkCurrentVirtualView(this._queryCellView, this._currentVirtualIndex))
                this._eventBindings();
            if (this.model.queryCellInfo || this.model.rowDataBound) {
                for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                    if ($.inArray(this._currentLoadedIndexes[i], this._queryCellView) == -1)
                        this._queryCellView.push(this._currentLoadedIndexes[i]);
                }
            }
        };
        HeatMapGrid.prototype._setVirtualTopBottom = function () {
            var contentTable = this.getContentTable()[0];
            var rowHeight = this._vRowHeight;
            var orderedVirtualNames = ej.dataUtil.mergeSort(ej.distinct(this._currentLoadedIndexes));
            var minValue = ej.dataUtil.min(orderedVirtualNames);
            var maxValue = ej.dataUtil.max(orderedVirtualNames);
            var recordsCount = this._getVirtualTotalRecord(), botHeight, maxViewValue;
            if (this.model.scrollSettings.virtualScrollMode == "continuous" && this._virtualLoadedRows[maxValue + 1]) {
                var keys = Object.keys(this._virtualLoadedRows);
                maxViewValue = parseInt(ej.dataUtil.max(keys), 10);
                maxValue = maxViewValue - maxValue;
            }
            botHeight = (maxValue * this._virtualRowCount * rowHeight);
            if ($.inArray(this._totalVirtualViews, this._currentLoadedIndexes) != -1 && this._currentVirtualIndex != this._totalVirtualViews)
                botHeight = (recordsCount - (this._virtualRowCount - this._lastViewData)) * rowHeight;
            var vBot = (recordsCount * rowHeight) - botHeight;
            if (this.model.scrollSettings.virtualScrollMode == "continuous" && !this._virtualLoadedRows[maxValue + 1]) {
                vBot = maxViewValue && maxViewValue <= maxValue + 1 ? vBot : 1;
            }
            this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
            var max = 1000000;
            if (vBot > 0 && this._getVirtualTotalRecord() > this._virtualRowCount * 2) {
                if (Math.round(vBot).toString().length < 7)
                    ej.buildTag("div.e-virtualbottom", "", { height: vBot }).insertAfter(contentTable);
                else {
                    ej.buildTag("div.e-virtualbottom").insertAfter(contentTable);
                    var length = Math.ceil(vBot / max);
                    for (var i = 0; i < length; i++) {
                        var divHeight = max;
                        if (i == length - 1) divHeight = vBot % max;
                        $(contentTable).next().append(ej.buildTag("div", "", { height: divHeight }));
                    }
                }
            }
            if (minValue > 1) {
                var vTop = (minValue - 1) * this._virtualRowCount * rowHeight;
                if (Math.round(vTop).toString().length < 7)
                    ej.buildTag("div.e-virtualtop", "", { height: vTop }).insertBefore(contentTable);
                else {
                    ej.buildTag("div.e-virtualtop").insertBefore(contentTable);
                    var length = Math.ceil(vTop / max);
                    for (var i = 0; i < length; i++) {
                        var divHeight = max;
                        if (i == length - 1) divHeight = vTop % max;
                        $(contentTable).prev().append(ej.buildTag("div", "", { height: divHeight }));
                    }
                }
            }
            if (this._scrollObject.model.scrollTop != this._scrollValue)
                this.getContent().ejScroller("model.scrollTop", this._scrollValue);
        };
        HeatMapGrid.prototype._checkVirtualSelection = function () {
            var contentTable = this.getContentTable()[0];
            for (var i = 0; i < this.selectedRowsIndexes.length; i++) {
                var selectedIndex = this.selectedRowsIndexes[i];
                var viewIndex = this._getSelectedViewData(selectedIndex).viewIndex;
                if ($.inArray(viewIndex, this._currentLoadedIndexes) != -1) {
                    var selIndex = selectedIndex % this._virtualRowCount + this._currentLoadedIndexes.indexOf(viewIndex) * this._virtualRowCount;
                    if (!$(contentTable.rows[selIndex].cells).hasClass("e-selectionbackground")) {
                        $($(contentTable.rows[selIndex]).attr("aria-selected", "true")[0].cells).addClass("e-selectionbackground e-active");
                        this.model.selectedRecords[i] = this._virtualLoadedRecords[viewIndex][selIndex % this._virtualRowCount];
                    }
                }
            }
            for (var i = 0; i < this._rowIndexesColl.length; i++) {
                var selectedIndex = this._rowIndexesColl[i];
                var viewIndex = this._getSelectedViewData(selectedIndex).viewIndex;
                if (($.inArray(viewIndex, this._currentLoadedIndexes) != -1 && $.inArray(selectedIndex, this._virtualRowCellSelIndex) == -1) || this._virtualDataRefresh) {
                    var curIndex = $.inArray(selectedIndex, this._rowIndexesColl);
                    var cellIndexes = this.selectedRowCellIndexes[curIndex].cellIndex;
                }
            }
            var selectedRows = $(contentTable.rows).find(".e-active, .e-cellselectionbackground").closest("tr");
            for (var i = 0; i < selectedRows.length; i++) {
                var limit = parseInt($(selectedRows[i]).attr("name"), 32) * this._virtualRowCount;
                var remain = this._virtualRowCount - $(selectedRows[i]).index() % this._virtualRowCount;
                var current = limit - remain;
                var rowIndex = $(selectedRows[i]).index();
                if (this.selectedRowsIndexes.length && $.inArray(current, this.selectedRowsIndexes) == -1) {
                    this._clearVirtualSelection = true;
                    this.clearSelection(rowIndex);
                }
                if (this._rowIndexesColl.length && $.inArray(current, this._rowIndexesColl) == -1)
                    $(this.getRowByIndex(rowIndex)[0].cells).removeClass("e-cellselectionbackground e-activecell");
            }
            $(contentTable.rows).find('.e-columnselection').removeClass('e-columnselection');
            for (var index = 0; index < this.selectedColumnIndexes.length; index++) {
                var ind = this.selectedColumnIndexes[index] + 1;
                $(contentTable.rows).find('td:nth-of-type(' + ind + ')').addClass("e-columnselection");
            }
            this._clearVirtualSelection = false;
        };
        HeatMapGrid.prototype._calculateWidth = function () {
            var j = this.getHeaderTable().find(".e-columnheader").last().find("th:visible"), width = 0;
            for (var i = 0; i < j.length; i++)
                width += j.eq(i).outerWidth();
            return width;

        };
        HeatMapGrid.prototype.columns = function (details, action) {
            if (ej.isNullOrUndefined(details)) return;
            var isString = false;
            if (typeof details === "string") {
                details = [details];
                isString = true;
            }
            else if (details instanceof Array && details.length && typeof details[0] === "string")
                isString = true;
            for (var i = 0; i < details.length; i++) {
                var index = $.inArray(this.getColumnByField(isString ? details[i] : details[i]["field"]), this.model.columns);
                if (action == "add" || ej.isNullOrUndefined(action)) {
                    if (index == -1)
                        this.model.columns.push(isString ? { field: details[i] } : details[i]);
                    else
                        this.model.columns[index] = isString ? { field: details[i] } : details[i];
                }
                else {
                    if (index != -1)
                        this.model.columns.splice(index, 1);
                }
            }
            this.columnsWidthCollection = [];
            var tooltip = false;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                this.columnsWidthCollection.push(this.model.columns[columnCount]["width"]);
                if (!ej.isNullOrUndefined(tooltip))
                    tooltip = true;
            }
            this._enableRowHover(tooltip);
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding)
                this._processEditing();
            this.refreshContent(true);
            if (this.model.allowScrolling) {
                this.refreshScrollerEvent();
                if (this.model.allowResizeToFit && this.getContent().ejScroller("isVScroll"))
                    this._showHideScroller();
            }
        };
        HeatMapGrid.prototype._enableRowHover = function (isTooltip, heatmap) {
            var tooltip = true;
            if (ej.isNullOrUndefined(isTooltip)) {
                for (var i = 0 ; i < this.model.columns.length; i++) {
                    if (!ej.isNullOrUndefined(this.model.columns[i]['tooltip'])) {
                        tooltip = true;
                        break;
                    }
                }
            }
            else
                tooltip = isTooltip;
            if (this.model.enableRowHover || tooltip)
                heatmap._on(this.element, "mouseenter mouseleave", ".e-gridcontent tr td", $.proxy(this._rowHover, this));
            else
                heatmap._off(this.element, "mouseenter mouseleave", ".e-gridcontent tr td");
        };
        HeatMapGrid.prototype._rowHover = function (e) {
            var $target = $(e.target);
            if (this.model.scrollSettings.frozenColumns)
                var $gridRows = $(this.getRows());
            else
                var $gridRows = this.element.find(".e-row.e-hover,.e-alt_row.e-hover");
            if (($target.closest("#" + this._id + "EditForm").length && $target.hasClass("e-rowcell")) || !$target.hasClass("e-rowcell"))
                return;
            if (e.type == "mouseenter" && $target.hasClass("e-gridtooltip"))
                this._showTooltip($target);
            if (this.model.enableRowHover) {
                if (e.type == "mouseenter" && !this._dragActive) {
                    if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined($gridRows[0]) && !ej.isNullOrUndefined($gridRows[1])) {
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                        $gridRows.removeClass("e-hover");
                        var index = this.getIndexByRow($target.parent());
                        index != -1 && this.getRowByIndex(index).addClass("e-hover");
                    }
                    else {
                        $gridRows.removeClass("e-hover");
                        if ($target.parent().hasClass('e-row') || $target.parent().hasClass('e-alt_row'))
                            $target.parent().addClass("e-hover");
                    }
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined($gridRows[0]) && !ej.isNullOrUndefined($gridRows[1]))
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.removeClass("e-hover");
                }
            }
            return false;
        };
        HeatMapGrid.prototype._showTooltip = function ($target, isHeaderTooltip) {
            var index = $target.index(), isStack = $target.hasClass("e-stackedHeaderCell");
            if ($target.hasClass("e-headercelldiv"))
                index = $target.parent(".e-headercell").index() - this.model.groupSettings.groupedColumns.length;
            if (!isStack && (this.model.childGrid || this.model.detailsTemplate))
                index--;
            if (this.model.scrollSettings.frozenColumns > 0 && ($target.closest(".e-movableheaderdiv").length || $target.closest(".e-movablecontentdiv").length))
                index = index + this.model.scrollSettings.frozenColumns;
            var col = !isStack ? this.getColumnByIndex(index) : this._getStackedColumnByTarget($target);
            if (col["clipMode"] != ej.HeatMapGrid.ClipMode.Ellipsis) {
                if (col["clipMode"] == ej.HeatMapGrid.ClipMode.EllipsisWithTooltip) {
                    var td = $target;
                    if (!$target.find("span").hasClass("e-tooltip")) {
                        var $span = ej.buildTag('span.e-tooltip', {}, {})
                        $span.html($target.html());
                        td.html($span);
                    }
                    td.find('span.e-tooltip').css('display', 'inline-block')
                    var width = td.find('span:first')[0].getBoundingClientRect().width;
                    td.find('span.e-tooltip').css('display', 'inline');
                    if ($target.width() > (width)) {
                        $target.removeAttr('title');
                        return;
                    }
                }

                var scriptElement = document.createElement("script");
                if (ej.isNullOrUndefined(col["tooltip"]) && ej.isNullOrUndefined(col["headerTooltip"]))
                    return;
                else {
                    var t;
                    scriptElement.id = (this._id + col.headerText + $.inArray(col, this.model.columns) + "_TemplateToolTip").split(" ").join("");
                    scriptElement.type = "text/x-template";
                    var tooltipType = !isHeaderTooltip ? "tooltip" : "headerTooltip";
                    if (!ej.isNullOrUndefined(col[tooltipType]) && col[tooltipType].slice(0, 1) !== "#")
                        scriptElement.text = col[tooltipType];
                    else
                        t = $(col[tooltipType]);
                    if (t) {
                        scriptElement.text = t.html();
                        scriptElement.type = t.attr("type") || scriptElement.type;
                    }
                    $("body").append(scriptElement);
                }
                var str = $(scriptElement).render({ value: $target.text() });
                $target.attr('title', str);
            }
            else
                $target.removeAttr('title');

        };
        HeatMapGrid.prototype._colgroupRefresh = function () {
            if ((this.model.allowResizing || this.model.allowResizeToFit) && this.model.scrollSettings.frozenColumns > 0) {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                var gridcontentCol = $(this.getContentTable()).find('colgroup');
            }
            else {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup')[0];
                var gridcontentCol = $(this.getContentTable()).find('colgroup')[0];
            }
            var headerColClone = $(gridheaderCol).clone();
            var contentColClone = $(gridcontentCol).clone();
            $(gridcontentCol).remove();
            $(gridheaderCol).remove();
            if ((this.model.allowResizing || this.model.allowResizeToFit) && this.model.scrollSettings.frozenColumns > 0) {
                $(headerColClone[0]).prependTo(this.getHeaderTable()[0]);
                $(headerColClone[1]).prependTo(this.getHeaderTable()[1]);
                $(contentColClone[0]).prependTo(this.getContentTable()[0]);
                $(contentColClone[1]).prependTo(this.getContentTable()[1]);
            }
            else {
                $(headerColClone).prependTo(this.getHeaderTable());
                $(contentColClone).prependTo(this.getContentTable());
            }
        };
        HeatMapGrid.prototype._detailColsRefresh = function () {
            this._$headerCols = this.getHeaderTable().children("colgroup").find("col");
            this._$contentCols = this.getContentTable().children("colgroup").find("col");
            var colCount = this.model.columns.length;
            if (this._$headerCols.length > colCount) this._$headerCols.splice(0, (this._$headerCols.length - colCount));
            if (this._$contentCols.length > colCount) this._$contentCols.splice(0, (this._$contentCols.length - colCount));
        };
        HeatMapGrid.prototype._htmlEscape = function (str) {
            var regx = /[&<>"']/g, charEntities = {
                "&": "&amp;",
                "<": "&lt;",
                ">": "&gt;",
                "\"": "&#34;",
                "'": "&#39;"
            };
            return str.replace(regx, function (c) {
                return charEntities[c];
            });
        };
        HeatMapGrid.prototype._getForeignKeyData = function (data) {
            var proxy = this;
            var column = {};
            for (var i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i].foreignKeyValue && this.model.columns[i].dataSource) {
                    var fieldName = ej.isNullOrUndefined(proxy.model.columns[i]["foreignKeyField"]) ? proxy.model.columns[i]["field"] : proxy.model.columns[i]["foreignKeyField"];
                    var dataSource = this.model.columns[i].dataSource instanceof ej.DataManager ? this.model.columns[i].foreignKeyData : this.model.columns[i].dataSource;
                    dataSource.filter(function (col) {
                        var value = data[proxy.model.columns[i]["field"]];
                        var fValue = !isNaN(parseFloat(value)) && isFinite(value) ? parseFloat(value) : value;
                        if (col[fieldName] == fValue) {
                            column[fieldName] = col;
                        }
                    });
                }
            }
            return column;
        };
        HeatMapGrid.prototype._foreignKeyBinding = function (curColumn, cellValue, gridId) {
            var cellData, val;
            var gridObj = $("#" + gridId).ejGrid('instance');
            curColumn = gridObj.model.columns[curColumn];
            var dataSource = curColumn.dataSource instanceof ej.DataManager ? curColumn.foreignKeyData : curColumn.dataSource;
            dataSource.filter(function (col) {
                if (ej.getObject(curColumn.foreignKeyField, col) == cellValue) {
                    val = ej.getObject(curColumn.foreignKeyValue, col);
                    return cellData = curColumn.type == "date" ? new Date(val) : val;
                }
            });
            if (curColumn.format) {
                cellData = gridObj.formatting(curColumn.format, cellData, gridObj.model.locale);
            }
            return cellData;
        };
        HeatMapGrid.prototype._setForeignKeyData = function (args) {
            if (!this._relationalColumns.length)
                return;
            var arr = this._relationalColumns, len = this._relationalColumns.length,
                promises = [], viewData = this.model.currentViewData, e = {};
            var obj, qry, pred, dist, qPromise, proxy = this;

            var failFn = ej.proxy(function (e) { /*Separate fail handler to get more control over request*/
                this._trigger("actionFailure", { requestType: "fetchingforeigndata", error: e.error });
            }, this);

            for (var i = 0; i < len; i++) {
                if (!(0 in viewData)) continue;
                obj = arr[i], e.field = obj["field"], e.keyField = obj["key"], e.valueField = obj["value"], e.dataSource = obj["dataSource"],
                            e.query = new ej.Query().select([e.valueField, e.keyField]).foreignKey(e.keyField),
                            dist = ej.distinct(viewData.level ? viewData.records : viewData, e.keyField, true);

                pred = ej.UrlAdaptor.prototype.getFiltersFrom(dist, e.query);
                e.query.where(pred);

                if (this._trigger("actionBegin", $.extend(e, { requestType: "fetchingforeigndata", column: this.getColumnByField(e.field) })))
                    return;
                qPromise = e.dataSource.ready === undefined ? e.dataSource.executeQuery(e.query, null, failFn) : e.dataSource.ready.fail(failFn);
                promises.push(qPromise);
            }
        };
        HeatMapGrid.prototype._isRelationalRendering = function (args) {
            return (0 in this._relationalColumns) && ["add", "beginedit", "cancel"].indexOf(args.requestType) == -1;
        };
        HeatMapGrid.prototype._columns = function (index, property, value, old) {
            var $header = this.element.find(".e-gridheader");
            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
            this._headerCellgDragDrop();
            this.refreshContent(true);
            this._trigger("refresh");
        };
        HeatMapGrid.prototype._summaryRows = function (index, property, value, old) {
            if (property == "showTotalSummary" || property == "showCaptionSummary") {
                var indx = index.summaryRows;
                var val = value.toLowerCase() == "true" || value.toLowerCase() == "false" ? ej.parseJSON(value) : false;
                this.option("summaryRows")[indx][property] = val;
            }
            this.element.find(".e-gridfooter").remove();

            if (property == "showCaptionSummary" || property == "title") {
                this._isCaptionSummary = this.option("summaryRows")[indx]["showCaptionSummary"];
                this.model.showSummary = this._isCaptionSummary;
                if (this.model.groupSettings.groupedColumns.length != 0)
                    this._refreshCaptionSummary();
            }
        };
        HeatMapGrid.prototype._summaryRows_summaryColumns = function (index, property, value, old) {
            if (property == "displayColumn" || property == "dataMember") {
                if (ej.isNullOrUndefined(this.getColumnByField(value)))
                    return;
            }

            if (this.element.find(".e-groupcaptionsummary").length != 0)
                this._refreshCaptionSummary();
        };
        HeatMapGrid.prototype._stackedHeaderRows_stackedHeaderColumns = function (index, property, value, old) {
            this._refreshStackedHeader();
        };
        HeatMapGrid.prototype._sortSettings_sortedColumns = function (index, property, value, old) {
            var colName, direction;
            var sortObj = this.model.sortSettings.sortedColumns[index["sortSettings.sortedColumns"]];
            if (property == "field") {
                colName = this.getColumnByField(value) != null ? value : null;
                direction = (sortObj.direction == "ascending" || sortObj.direction == "descending") ? sortObj.direction : null;
            }
            else if (property == "direction") {
                colName = this.getColumnByField(sortObj.field) != null ? sortObj.field : null;
                direction = (value == "ascending" || value == "descending") ? value : null;
            }
            if (colName != null && direction != null)
                this.sortColumn(colName, direction);
        };
        HeatMapGrid.prototype._filterSettings_filteredColumns = function (index, property, value, old) {
            var field, operator, matchcase, predicate, filtervalue;
            var filterObj = this.model.filterSettings.filteredColumns[index["filterSettings.filteredColumns"]];
            switch (property) {
                case "field":
                    field = this.getColumnByField(value) != null ? value : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "matchcase":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = value.toLowerCase() == "true" || value.toLowerCase() == "false" ? ej.parseJSON(value) : false;
                    break;
                case "operator":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, value);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "predicate":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (value == "and" || value == "or") ? value : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "value":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
            }
            if (field != null && operator != null && filtervalue != null && predicate != null && matchcase != null)
                this.filterColumn(field, operator, filtervalue, predicate, matchcase);
        };
        HeatMapGrid.prototype._map = function (object, value) {
            var data = $.map(object, function (obj) {
                if (obj === value)
                    return obj;
            });
            return data.length != 0 ? data[0] : null;
        };
        HeatMapGrid.prototype._refreshCaptionSummary = function () {
            var temp = document.createElement('div');
            temp.innerHTML = ['<table>', $.render[this._id + "_GroupingTemplate"](this.model.currentViewData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
            this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
            this.refreshContent();
        };
        HeatMapGrid.prototype.getContentTable = function () {
            return this._gridContentTable;
        };
        HeatMapGrid.prototype.setGridContentTable = function (value) {
            this._gridContentTable = value;
        };
        HeatMapGrid.prototype.getContent = function () {
            return this._gridContent;
        };
        HeatMapGrid.prototype.setGridContent = function (value) {
            this._gridContent = value;
        };
        HeatMapGrid.prototype.getHeaderContent = function () {
            return this._gridHeaderContent;
        };
        HeatMapGrid.prototype.getHeaderTable = function () {
            return this._gridHeaderTable;
        };
        HeatMapGrid.prototype.getRows = function () {
            return this._gridRows;
        };
        HeatMapGrid.prototype.getFilteredRecords = function () {
            return this._filteredRecords;
        };
        HeatMapGrid.prototype.getRowByIndex = function (from, to) {
            try {
                var gridRows = this.getRows(), $gridRows = this._excludeDetailRows(), $row = $();
                if ($.isArray(from)) {
                    for (var i = 0; i < from.length; i++) {
                        if (this.model.scrollSettings.frozenColumns > 0) {
                            $row.push(gridRows[0][from[i]]);
                            $row.push(gridRows[1][from[i]]);
                        }
                        else
                            $row.push(gridRows[from[i]]);
                    }
                    return $row;
                }
                else if (ej.isNullOrUndefined(to)) {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $row.push(gridRows[0][from]);
                        $row.push(gridRows[1][from]);
                        return $row;
                    }
                    return $(($gridRows).not(".e-virtualrow")[from]);
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $row.push($(gridRows[0]).slice(from, to));
                        $row.push($(gridRows[1]).slice(from, to));
                        return $row;
                    }
                    return $($gridRows.not(".e-virtualrow").slice(from, to));
                }
            } catch (e) {
                return $();
            }
        };
        HeatMapGrid.prototype.getColumnIndexByField = function (field) {
            for (var i = 0, col = this.model.columns, len = col.length ; i < len ; i++) {
                if (col[i]["field"] === field)
                    return i;
            }
            return -1;
        };
        HeatMapGrid.prototype.getColumnIndexByHeaderText = function (headerText, field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["headerText"] == headerText) {
                    if (field) {
                        if (ej.isNullOrUndefined(this.model.columns[column]["field"]) || this.model.columns[column]["field"] == "")
                            break;
                    }
                    else
                        break;
                }
            }
            return column;
        };
        HeatMapGrid.prototype.getIndexByRow = function ($tr) {
            var gridRows = this.getRows(), $gridRows = this._excludeDetailRows(), rowIndex;
            if (this.model.scrollSettings.frozenColumns > 0) {
                rowIndex = $(gridRows[0]).index($tr);
                if (rowIndex == -1)
                    rowIndex = $(gridRows[1]).index($tr);
                return rowIndex;
            } else
                return $gridRows.not(".e-virtualrow").index($tr);
        };
        HeatMapGrid.prototype.getPrimaryKeyFieldNames = function () {
            if (this._primaryKeys.length != 0)
                return this._primaryKeys;
            for (var key = 0, col = this.model.columns, cLen = col.length; key < cLen; key++) {
                if (col[key]["isPrimaryKey"])
                    this._primaryKeys.push(col[key]["field"]);
            }
            return this._primaryKeys;
        };
        HeatMapGrid.prototype.getVisibleColumnNames = function (headerText) {
            return this._visibleColumns;
        };
        HeatMapGrid.prototype.getHiddenColumnNames = function (headerText) {
            return this._hiddenColumns;
        };
        HeatMapGrid.prototype.getColumnByField = function (field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["field"] == field)
                    break;
            }
            return column == this.model.columns.length ? null : this.model.columns[column];
        };
        HeatMapGrid.prototype.getsortColumnByField = function (field) {
            for (var column = 0; column < this.model.sortSettings.sortedColumns.length; column++) {
                if (this.model.sortSettings.sortedColumns[column]["field"] == field)
                    break;
            }
            return column == this.model.sortSettings.sortedColumns.length ? null : this.model.sortSettings.sortedColumns[column];
        };
        HeatMapGrid.prototype.getColumnByHeaderText = function (headerText, field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["headerText"] == headerText) {
                    if (field) {
                        if (ej.isNullOrUndefined(this.model.columns[column]["field"]) || this.model.columns[column]["field"] == "")
                            break;
                    }
                    else
                        break;
                }
            }
            return column == this.model.columns.length ? null : this.model.columns[column];
        };
        HeatMapGrid.prototype.getCurrentViewData = function () {
            return this._currentJsonData;
        };
        HeatMapGrid.prototype.getColumnFieldNames = function () {
            var columnNames = [];
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["field"])
                    columnNames.push(this.model.columns[column]["field"]);
            }
            return columnNames;
        };
        HeatMapGrid.prototype.getBrowserDetails = function () {
            var b = navigator.userAgent.match(/(firefox|mozilla|chrome|opera|msie|safari)\s?\/?(\d+(.\d+)*)/i);
            if (!!navigator.userAgent.match(/Trident\/7\./))
                return { browser: "msie", version: $.uaMatch(navigator.userAgent).version };
            return { browser: b[1].toLowerCase(), version: b[2] };
        };
        HeatMapGrid.prototype._initComplexColumn = function (obj, field, cxField) {
            var complexField = cxField || field;
            for (var field1 in obj) {

                if (typeof obj[field1] == "object" && !ej.isNullOrUndefined(obj[field1])) {
                    complexField = complexField.concat(".").concat(field1);
                    this._initComplexColumn(obj[field1], field1, complexField);
                }
                else {
                    var cxFieldName = (complexField).concat(".").concat(field1), value = obj[field1];;
                    this.model.columns.push({
                        field: cxFieldName,
                        type: value != null ? (value.getDay ? (value.getHours() > 0 || value.getMinutes() > 0 || value.getSeconds() > 0 || value.getMilliseconds() > 0 ? "datetime" : "date") : typeof (value)) : null
                    });
                }
            }
        };
        HeatMapGrid.prototype._initColumns = function (object) {
            while (object.items != undefined)
                object = object.items[0];
            if (this.model.columns.length == 0 && object) {
                for (var field in object) {
                    if (object.hasOwnProperty(field) && (typeof (object[field]) != "object" || object[field] instanceof Date || object[field] == null)) {
                        var value = object[field];
                        this.model.columns.push({
                            field: field,
                            type: value != null ? (value.getDay ? (value.getHours() > 0 || value.getMinutes() > 0 || value.getSeconds() > 0 || value.getMilliseconds() > 0 ? "datetime" : "date") : typeof (value)) : null
                        });
                    }
                    else if (typeof (object[field]) == "object") {
                        this._initComplexColumn(object[field], field);
                    }
                }
                this.model.columns.length && this._renderAfterColumnInitialize();
            } else {
                for (var index = 0; index < this.model.columns.length; index++) {
                    this.model.columns[index].field = ej.isNullOrUndefined(this.model.columns[index].field) ? "" : this.model.columns[index].field;
                    if (!ej.isNullOrUndefined(this.model.columns[index].validationRules))
                        this._validatedColumns.push(this.model.columns[index].field);
                    if (ej.isNullOrUndefined(this.model.columns[index].type)) {
                        var $field = !ej.isNullOrUndefined(this.model.columns[index].field) ? ej.getObject(this.model.columns[index].field, object) : null, coldata = this.model.columns[index].dataSource;
                        if (!!coldata && this.model.columns[index].foreignKeyValue) {
                            this.model.columns[index].originalType = $field != null ? ($field.getDay ? ($field.getHours() > 0 || $field.getMinutes() > 0 || $field.getSeconds() > 0 || $field.getMilliseconds() > 0 ? "datetime" : "date") : typeof ($field)) : null;
                            $field = !(coldata instanceof ej.DataManager) ? ej.getObject("0." + this.model.columns[index].foreignKeyValue, coldata) : ej.getObject("0." + this.model.columns[index].foreignKeyValue, this.model.columns[index].foreignKeyData);
                        }
                        this.model.columns[index].type = $field != null ? ($field.getDay ? ($field.getHours() > 0 || $field.getMinutes() > 0 || $field.getSeconds() > 0 || $field.getMilliseconds() > 0 ? "datetime" : "date") : typeof ($field)) : null;
                    }
                    else if (this.model.columns[index]["type"] == "date" && this.model.columns[index].format == undefined && this._isReorder != true && this.model.allowGrouping != true && !this._showHideColumns)
                        if (ej.isNullOrUndefined(ej.globalize))
                            $.extend(this.model.columns[index], { format: "{0:" + ej.preferredCulture().calendars.standard.patterns.d + "}" });
                        else
                            $.extend(this.model.columns[index], { format: "{0:M/d/yyyy}" });
                    else if (this.model.columns[index]["type"] == "datetime" && this.model.columns[index].format == undefined && this._isReorder != true && this.model.allowGrouping != true && !this._showHideColumns)
                        if (ej.isNullOrUndefined(ej.globalize))
                            $.extend(this.model.columns[index], { format: "{0:" + ej.preferredCulture().calendars.standard.patterns.d + " " + ej.preferredCulture().calendars.standard.patterns.t + "}" });
                        else
                            $.extend(this.model.columns[index], { format: "{0:M/d/yyyy h:mm tt}" });
                }
            }
        };
        HeatMapGrid.prototype._getExpands = function (field, arr) {
            var splits = field.split('.'), tmp = "";
            splits.splice(splits.length - 1, 1);
            for (var i = 0; i < splits.length; i++, tmp = "") {
                for (var j = 0; j < i; j++)
                    tmp += splits[j] + "/";
                tmp = tmp + splits[i];
                if (arr.indexOf(tmp) === -1)
                    arr.push(tmp);
            }
        };
        HeatMapGrid.prototype._ensureDataSource = function (args) {
            if (this._dataSource() == null && !(this._dataSource() instanceof ej.DataManager)) {
                if (!ej.isNullOrUndefined(args) && args.requestType == "add")
                    this.dataSource([]);
                else
                    return;
            }
            this.model.query.requiresCount();
            var queryManagar = this.model.query;
            var cloneQuery = queryManagar.clone();
            if (!(this._dataSource() instanceof ej.DataManager))
                this.model.currentViewData = this._dataSource();
            if (this._isLocalData && (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) && (!ej.isNullOrUndefined(this._cModifiedData) || !ej.isNullOrUndefined(this._cAddedRecord))) {
                if (ej.isNullOrUndefined(this._cAddedRecord)) {
                    for (var index = 0; index < this._primaryKeys.length; index++)
                        queryManagar = queryManagar.where(this._primaryKeys[index], ej.FilterOperators.equal, this._primaryKeyValues[index]);
                    var currentData = this._dataManager.executeLocal(queryManagar);
                    if (!(this._dataSource() instanceof ej.DataManager))
                        $.extend(this._dataSource()[$.inArray(currentData.result[0], this._dataSource())], this._cModifiedData);
                    else
                        $.extend(this._dataSource().dataSource.json[$.inArray(currentData.result[0], this._dataSource().dataSource.json)], this._cModifiedData);
                    this._cModifiedData = null;
                } else {
                    var tmpRcrd = this._cAddedRecord;
                    this._cAddedRecord = null;
                    (this._dataSource() instanceof ej.DataManager) ? this._dataSource().dataSource.json.unshift(tmpRcrd) : this._dataSource(undefined, true).splice(0, 0, tmpRcrd);
                }
                queryManagar.queries = cloneQuery.queries;
                if (!this.model.editSettings.showAddNewRow)
                    this.model.isEdit = false;
            }
            if (args && this.model.editSettings.allowDeleting && args.requestType == "delete" && (this._excludeDetailRows().length == 1 || (this.multiDeleteMode == "multiple" && this.selectedRowsIndexes.length == this._excludeDetailRows().length)) && this.model.pageSettings.currentPage != 1)
                this._currentPage(this.model.pageSettings.totalPages - 1)
            if (args && this.model.editSettings.allowDeleting && args.requestType == "delete" && !ej.isNullOrUndefined(this._cDeleteData) && this._isLocalData) {
                if (!(this._dataSource() instanceof ej.DataManager)) {
                    var index = $.inArray(this._cDeleteData[0], this._dataSource());
                    this._dataSource(undefined, true).splice(index, 1);
                }
                else {
                    var index = $.inArray(this._cDeleteData[0], this._dataSource().dataSource.json);
                    this._dataSource().dataSource.json.splice(index, 1);
                }
            }
            if (this.model.sortSettings.sortedColumns.length) {
                var sortedGrp = [], sortedColumns = this.model.sortSettings.sortedColumns;
                for (var i = sortedColumns.length - 1; i >= 0; i--) {
                    if (this.model.groupSettings.groupedColumns.indexOf(sortedColumns[i].field) == -1) {
                        queryManagar.sortBy(sortedColumns[i].field, sortedColumns[i].direction);
                        if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization && $.inArray(sortedColumns[i], this._prevVirtualSort) == -1) {
                            for (var j = 0; j < this._prevVirtualSort.length; j++) {
                                if (sortedColumns[i].field == this._prevVirtualSort[j].field)
                                    this._prevVirtualSort.splice(j, 1);
                            }
                            this._needVPaging = this._currentVirtualIndex * this._virtualRowCount % this.model.pageSettings.pageSize <= this._virtualRowCount;
                            this._prevVirtualSort.push(sortedColumns[i]);
                            this._virtualDataRefresh = true;
                            this._refreshVirtualViewData();
                        }
                    }
                    else
                        sortedGrp.push({ field: sortedColumns[i].field, direction: sortedColumns[i].direction })
                }
                for (var j = 0; j < sortedGrp.length ; j++) {
                    queryManagar.sortBy(sortedGrp[j].field, sortedGrp[j].direction);
                }
            }
            if (this.model.allowPaging || (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling && !this.model.scrollSettings.enableVirtualization)) {
                if (this._isLocalData) {
                    var fresults = this._dataManager.executeLocal(queryManagar);
                    this._recordsCount = fresults.count;
                    var lastPage = (this._recordsCount % this.model.pageSettings.pageSize == 0) ? (this._recordsCount / this.model.pageSettings.pageSize) : (parseInt(this._recordsCount / this.model.pageSettings.pageSize, 10) + 1);
                    if (this._currentPage() > lastPage)
                        this._currentPage(lastPage);
                } else if (ej.isNullOrUndefined(args)) {
                    this._currentPage(1);
                }
                if (this._currentPage() == 0) {
                    if (this._prevPageNo == 0 || this._prevPageNo == null)
                        this._currentPage(1);
                    else
                        this._currentPage(this._prevPageNo);
                }

                queryManagar.page(this._currentPage(), this.model.pageSettings.pageSize);
            }
            if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                this._needPaging = true;
                if (this.initialRender && this.model.currentIndex > 1 && (this.model.currentIndex <= this._getVirtualTotalRecord() || !this._isLocalData)) {
                    if (this.model.scrollSettings.virtualScrollMode == "continuous")
                        this.model.currentIndex = 1;
                    this._currentVirtualIndex = Math.ceil(this.model.currentIndex / this._virtualRowCount);
                    this._isThumbScroll = true;
                    this._currentPage(Math.ceil(this.model.currentIndex / this.model.pageSettings.pageSize));
                    this._virtualLoadedPages.push(this._currentPage());
                }
                if (this._virtualDataRefresh) {
                    this._isThumbScroll = true;
                    this._refreshVirtualViewData(true);
                    this._gridRecordsCount = this._dataSource() !== null ? (this.model.pageSettings.totalRecordsCount == null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount) : 0;
                    this._currentPage(Math.ceil(this._currentVirtualIndex * this._virtualRowCount / this.model.pageSettings.pageSize));
                    this._virtualLoadedPages.push(this._currentPage());
                }
                if (this.model.virtualLoading != null)
                    this._gridRecordsCount = this.model.pageSettings.totalRecordsCount;
                if (this.model.filterSettings.filteredColumns == 0 && this._prevVirtualFilter.length) {
                    this._refreshVirtualViewData();
                    this._prevVirtualFilter = [];
                }
                if (this._isLocalData && this.initialRender)
                    this._refreshVirtualViewDetails();
                this._getVirtualLoadedRecords(queryManagar);
            }
            if (args != undefined && args.requestType == "add" && this._isLocalData && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0)
                !(this._dataSource() instanceof ej.DataManager) ? this._dataSource().unshift(args.data) : this._dataSource().dataSource.json.unshift(args.data);
            if ((!ej.isNullOrUndefined(args) && args.action == "add") && !ej.isNullOrUndefined(this.model.parentDetails)) {
                var column = this.getColumnByField(this.model.parentDetails.parentKeyField);
                var ix = $.inArray(column, this.model.columns)
                if (ix == -1) {
                    var newdata = {};
                    newdata[this.model.parentDetails.parentKeyField] = this.model.parentDetails.parentKeyFieldValue;
                    $.extend(true, this.model.currentViewData[0], newdata);
                }
            }
            this._cloneQuery = queryManagar.clone();
            if (this._isLocalData && (!this.model.scrollSettings.enableVirtualization || this._virtualDataRefresh)) {
                var dataMgrJson = this._dataManager.dataSource.json;
                var dataSource = this._dataSource().dataSource;
                if (!ej.isNullOrUndefined(dataSource) && this._dataSource() instanceof ej.DataManager)
                    this._dataManager.dataSource.json = dataMgrJson != dataSource.json ? dataSource.json : dataMgrJson;
                var result = this._dataManager.executeLocal(queryManagar);
                if (this.model.scrollSettings.allowVirtualScrolling && this.model.pageSettings.currentPage == this.model.pageSettings.totalPages - 1)
                    this._prevPageRendered = true;
                if (this.model.scrollSettings.allowVirtualScrolling && !this._prevPageRendered && result.result.length != this.model.pageSettings.pageSize && this.model.pageSettings.totalPages == this.model.pageSettings.currentPage) {
                    var pageQuery = ej.pvt.filterQueries(queryManagar.queries, "onPage");
                    queryManagar.queries.splice($.inArray(pageQuery[0], queryManagar.queries), 1);
                    queryManagar.page(this._currentPage() - 1, this.model.pageSettings.pageSize);
                    var lastPageResult = this._dataManager.executeLocal(queryManagar);
                    lastPageResult.result.splice(0, result.result.length);
                    this._previousPageRecords = $.extend(true, [], lastPageResult.result);
                    this._previousPageLength = result.result.length;
                    this._currentPageData = result.result;
                    ej.merge(lastPageResult.result, result.result);
                    this.model.currentViewData = lastPageResult.result;
                    this._lastPageRendered = true;
                }
                else if (this._lastPageRendered && this.model.pageSettings.currentPage == this.model.pageSettings.totalPages - 1 && !this.model.scrollSettings.enableVirtualization) {
                    var count = this.model.pageSettings.pageSize - this._previousPageLength;
                    for (var dupRow = 0; dupRow < count; dupRow++) {
                        var removeEle = this.getRows()[this.getRows().length - (this.model.pageSettings.pageSize - dupRow)];
                        removeEle.remove();
                    }
                    this._tempPageRendered = true;
                    this.model.currentViewData = result.result;
                }
                else
                    this.model.currentViewData = result.result;
                this._gridRecordsCount = result.count;
                this._remoteSummaryData = result.aggregates;
                this._searchCount = this._searchString.length ? result.count : null;
                this.model.groupSettings.groupedColumns.length && this._setAggregates();
            }
        };
        HeatMapGrid.prototype._refreshViewPageDetails = function () {
            this._currentPage(1);
            this.model.currentIndex = 0;
            this._currentVirtualIndex = 1;
            this.getContent().ejScroller("model.scrollTop", 0);
        };
        HeatMapGrid.prototype._refreshVirtualViewDetails = function (dataRefreshed) {
            if (dataRefreshed)
                this._gridRecordsCount = this._dataSource() !== null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount;
            this._totalVirtualViews = Math.ceil(this._getVirtualTotalRecord() / this._virtualRowCount);
            this._maxViews = Math.ceil(this.model.pageSettings.pageSize / this._virtualRowCount);
            this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
            this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;
            this._lastViewData = this._virtualRowCount - ((this._totalVirtualViews * this._virtualRowCount) - this._getVirtualTotalRecord());
        };
        HeatMapGrid.prototype._getVirtualLoadedRecords = function (queryManagar) {
            var currentPage = this._currentPage();
            if (this._needPaging) {
                var needTwoPage;
                this._isLastVirtualpage = needTwoPage = this._isThumbScroll && currentPage == this.model.pageSettings.totalPages && !this._virtualPageRecords[currentPage];
                if (this.initialRender || this._virtualDataRefresh) needTwoPage = true;
                if (this.model.virtualLoading && this._isLocalData && (this.model.currentIndex != 0 || currentPage != 1) && this.model.currentIndex < this.model.pageSettings.totalRecordsCount)
                    this._getVirtualOnLoadingData(currentPage, !needTwoPage);
                else
                    this._setVirtualPaging(queryManagar, currentPage, !needTwoPage);
                if (!this.initialRender && this._isThumbScroll && this._virtualPageRecords[currentPage] && !this._virtualDataRefresh)
                    this._checkPrevNextViews(currentPage, queryManagar);
            }
            this._needPaging = false;
            this._setVirtualLoadedIndexes(this._currentVirtualIndex);
            if (this.initialRender && this._isLocalData) {
                this.model.currentViewData = [];
                for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                    var currentView = this._currentLoadedIndexes[i];
                    if (this._virtualLoadedRecords[currentView])
                        $.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView]);
                }
            }
        };
        HeatMapGrid.prototype._setVirtualPaging = function (queryManagar, currentPage, isCurrentIndex) {
            var pageQuery = ej.pvt.filterQueries(queryManagar.queries, "onPage");
            if (pageQuery.length)
                queryManagar.queries.splice($.inArray(pageQuery[0], queryManagar.queries), 1);
            if ((!isCurrentIndex || this._needVPaging) && this.model.currentIndex > this._virtualRowCount) {
                this._initCurrentIndex(queryManagar, currentPage);
                this._needVPaging = false;
            }
            else
                queryManagar.page(currentPage, this.model.pageSettings.pageSize);
            if (this._isLocalData && !this._virtualPageRecords[currentPage]) {
                var result = this._dataManager.executeLocal(queryManagar);
                if (!this.initialRender) this.model.currentViewData = result.result;
                if (result.result.length) {
                    this._setVirtualLoadedRecords(result.result, currentPage);
                    if ($.inArray(currentPage, this._virtualLoadedPages) == -1)
                        this._virtualLoadedPages.push(currentPage);
                }
                else
                    this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
            }
        };
        HeatMapGrid.prototype._checkPrevNextViews = function (currentPage) {
            var currentVirtualIndex = this._currentVirtualIndex;
            var prevView = this._virtualLoadedRecords[currentVirtualIndex - 1], nextView = this._virtualLoadedRecords[currentVirtualIndex + 1];
            var adjust = this._maxViews == 3 ? 1 : 2, sTop;
            if (currentVirtualIndex != 1 && currentVirtualIndex != this._totalVirtualViews) {
                if (!prevView || prevView.length != this._virtualRowCount) {
                    var currentIndex = currentVirtualIndex + adjust;
                    this._currentVirtualIndex = this._virtualLoadedRecords[currentVirtualIndex] ? currentIndex : currentIndex + 1;
                    sTop = this._scrollValue + (adjust * this._virtualRowCount * this._vRowHeight);
                }
                else if ((!nextView || nextView.length != this._virtualRowCount) && this._totalVirtualViews != currentVirtualIndex - 1) {
                    var currentIndex = currentVirtualIndex - adjust;
                    this._currentVirtualIndex = this._virtualLoadedRecords[currentVirtualIndex] ? currentIndex : currentIndex - 1;
                    sTop = this._scrollValue - (adjust * this._virtualRowCount * this._vRowHeight);
                }
                if (sTop) {
                    this._scrollValue = sTop;
                    this._setVirtualLoadedIndexes(this._currentVirtualIndex);
                    this.model.currentIndex = sTop == 0 ? sTop : Math.floor(sTop / this._vRowHeight);
                }
            }
        };
        HeatMapGrid.prototype._initCurrentIndex = function (queryManagar, currentPage) {
            var pageResultCount = currentPage * this.model.pageSettings.pageSize;
            var nextDataCount = (this._currentVirtualIndex * this._virtualRowCount) + this._virtualRowCount;
            var prevDataCount = (this._currentVirtualIndex * this._virtualRowCount) - (this._virtualRowCount * 2);
            var needTwoPage = nextDataCount > pageResultCount || prevDataCount < pageResultCount - this.model.pageSettings.pageSize;
            if (needTwoPage || this._isLastVirtualpage) {
                if (nextDataCount > pageResultCount) {
                    var skipValue = (currentPage - 1) * this.model.pageSettings.pageSize, takeValue = this.model.pageSettings.pageSize * 2;
                    this._isInitNextPage = true;
                }
                else if (prevDataCount < pageResultCount - this.model.pageSettings.pageSize || this._isLastVirtualpage) {
                    var skipValue = (currentPage - 2) * this.model.pageSettings.pageSize, takeValue = this.model.pageSettings.pageSize * 2;
                    this._isInitNextPage = false; this._remoteRefresh = true;
                }
                if (this.model.virtualLoading && this._isLocalData) {
                    var args = {};
                    args.endIndex = skipValue + takeValue;
                    args.endIndex = args.endIndex > this._getVirtualTotalRecord() ? this._getVirtualTotalRecord() : args.endIndex;
                    args.startIndex = skipValue;
                    args.currentPage = this._currentPage();
                    args.result = null;
                    this._trigger("virtualLoading", args);
                    var currentData = args.result;
                    this._setInitialCurrentIndexRecords(currentData, currentPage);
                }
                else {
                    queryManagar.skip(skipValue).take(takeValue);
                    if (this._isLocalData) {
                        var result = this._dataManager.executeLocal(queryManagar);
                        var currentData = result.result;
                        this._isLastVirtualpage = false;
                        this._setInitialCurrentIndexRecords(currentData, currentPage);
                    }
                }
            }
            else {
                this._needVPaging = false;
                if (this.model.virtualLoading && this._isLocalData && (this.model.currentIndex != 0 || currentPage != 1))
                    this._getVirtualOnLoadingData(currentPage, true);
                else
                    this._setVirtualPaging(queryManagar, currentPage, true);
            }
        };
        HeatMapGrid.prototype._setInitialCurrentIndexRecords = function (currentData, currentPage) {
            for (var i = 0; i < 2; i++) {
                var start = i * this.model.pageSettings.pageSize, end = start + this.model.pageSettings.pageSize;
                var data = currentData.slice(start, end), page;
                if (this._isInitNextPage)
                    page = i == 0 ? currentPage : currentPage + 1;
                else
                    page = i == 0 ? currentPage - 1 : currentPage;
                this._setVirtualLoadedRecords(data, page);
            }
        };
        HeatMapGrid.prototype._getVirtualOnLoadingData = function (currentPage, isCurrentIndex) {
            if (currentPage > 0) {
                if (this.model.currentIndex > this._virtualRowCount && (!isCurrentIndex || this._needVPaging) && this.model.currentIndex < this.model.pageSettings.totalRecordsCount)
                    this._initCurrentIndex(undefined, currentPage);
                else {
                    var args = {};
                    args.endIndex = (currentPage * this.model.pageSettings.pageSize) > this._gridRecordsCount ? this._gridRecordsCount : currentPage * this.model.pageSettings.pageSize;
                    args.startIndex = (currentPage * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                    args.currentPage = this._currentPage(); args.result = null;
                    this._trigger("virtualLoading", args);
                    var currentData = args.result;
                    this._setVirtualLoadedRecords(currentData, currentPage);
                }
            }
        };
        HeatMapGrid.prototype._setVirtualLoadedRecords = function (currentData, currentPage) {
            var virtualRowCount = this._virtualRowCount, pageSize = this.model.pageSettings.pageSize;
            var pageIndex = pageSize / virtualRowCount, prevIndex;
            var maxIndex = Math.ceil(currentPage * pageSize / virtualRowCount);
            var lastPage = currentPage == this.model.pageSettings.totalPages;
            if (!this._virtualPageRecords[currentPage])
                this._virtualPageRecords[currentPage] = currentData;
            if (lastPage) {
                var lastPageData = this._getVirtualTotalRecord() % pageSize;
                if ((!this._virtualLoadedRecords[this._totalVirtualViews] || this._virtualLoadedRecords[this._totalVirtualViews].length != this._lastViewData) && lastPageData < this._lastViewData && lastPageData != 0)
                    maxIndex = this._totalVirtualViews + 1;
                else
                    maxIndex = this._totalVirtualViews;
                if (this._getVirtualTotalRecord() < virtualRowCount)
                    this._singleView = true;
            }
            for (var i = 0; i < pageIndex; i++) {
                var startIndex, endIndex;
                var viewIndex = Math.ceil((currentPage - 1) * pageIndex + (i + 1));
                if ((viewIndex <= this._totalVirtualViews || lastPage) && viewIndex <= maxIndex) {
                    if (this._virtualLoadedRecords[viewIndex - 1] && this._virtualLoadedRecords[viewIndex - 1].length != virtualRowCount) {
                        var start = this._virtualLoadedRecords[viewIndex - 1].length + (i * virtualRowCount);
                        startIndex = virtualRowCount - start + (i * virtualRowCount);
                        $.merge(this._virtualLoadedRecords[viewIndex - 1], currentData.slice(0, startIndex));
                        prevIndex = endIndex = startIndex + virtualRowCount;
                        if (viewIndex <= this._totalVirtualViews)
                            this._virtualLoadedRecords[viewIndex] = currentData.slice(startIndex, prevIndex);
                    }
                    else {
                        if (viewIndex != 1 && !this._virtualLoadedRecords[viewIndex - 1]) {
                            var prevEnd = endIndex = (viewIndex - 1) * virtualRowCount % pageSize;
                            if (prevEnd != 0)
                                this._virtualLoadedRecords[viewIndex - 1] = currentData.slice(0, prevEnd);
                            startIndex = prevEnd, endIndex = prevIndex = prevEnd + virtualRowCount;
                        }
                        else {
                            startIndex = prevIndex ? prevIndex : i * virtualRowCount % pageSize;
                            prevIndex = endIndex = startIndex + virtualRowCount;
                        }
                    }
                    if (this._virtualLoadedRecords[viewIndex] && this._virtualLoadedRecords[viewIndex].length != virtualRowCount) {
                        var data = currentData.slice(startIndex, endIndex);
                        if (data.length + this._virtualLoadedRecords[viewIndex].length <= virtualRowCount) {
                            var viewData = $.merge(data, this._virtualLoadedRecords[viewIndex]);
                            this._virtualLoadedRecords[viewIndex] = viewData;
                        }
                    }
                    else if (!this._virtualLoadedRecords[viewIndex] && viewIndex <= this._totalVirtualViews)
                        this._virtualLoadedRecords[viewIndex] = currentData.slice(startIndex, endIndex);
                }
            }
            if ($.inArray(currentPage, this._virtualLoadedPages) == -1)
                this._virtualLoadedPages.push(currentPage);
        };
        HeatMapGrid.prototype._setVirtualLoadedIndexes = function (currentIndex) {
            this._currentLoadedIndexes = [];
            var virtualCount = currentIndex == this._totalVirtualViews ? currentIndex : currentIndex + 1;
            if (currentIndex != 1)
                currentIndex = currentIndex - 1;
            for (var i = currentIndex; i <= virtualCount; i++) {
                this._currentLoadedIndexes.push(i);
            }
        };
        HeatMapGrid.prototype._getVirtualTotalRecord = function () {
            var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            return recordCount;
        };
        HeatMapGrid.prototype._initGridRender = function (heatmap) {

            this.addInitTemplate();
            if (this.model.scrollSettings.frozenColumns > 0)
                this.addFrozenTemplate();
            this.model.allowGrouping && this.addGroupingTemplate();
            this.model.showSummary && this.addSummaryTemplate();

            if (this.model.keySettings)
                $.extend(this.model.keyConfigs, this.model.keySettings);
            this.render();
            this._setTextWrap();
            this._wireEvents(heatmap);
            this.initialRender = false;
            if (this.model.width && !this.model.allowScrolling)
                this.element.width(this.model.width);
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding)
                this._processEditing();
            //this._trigger("dataBound", {});
            //this._trigger("refresh");
            if (this.model.parentDetails) {  //refreshes parent scroller on child expand
                var id = this.model.parentDetails.parentID, parentObj = $("#" + id).data("ejGrid");
                parentObj.model.allowScrolling && parentObj._refreshScroller({ requestType: "refresh" });
            }
            if (this.element.closest('tr').hasClass('e-detailrow') && !this.model.parentDetails) {
                var parentObj = this.element.closest('tr.e-detailrow').closest('.e-grid').data("ejGrid");
                parentObj.model.allowScrolling && parentObj.getScrollObject().refresh();
            }
        };
        HeatMapGrid.prototype._setTextWrap = function () {
            if (this.model.allowTextWrap == true) {
                switch (this.model.textWrapSettings.wrapMode) {
                    case "content":
                        this.element.find(".e-columnheader").removeClass("e-wrap");
                        this.element.removeClass("e-wrap");
                        this.getContent().addClass("e-wrap");
                        break;
                    case "header":
                        this.element.removeClass("e-wrap");
                        this.getContent().removeClass("e-wrap");
                        this.element.find(".e-columnheader").addClass("e-wrap");
                        break;
                    default:
                        this.getContent().removeClass("e-wrap");
                        this.element.find(".e-columnheader").removeClass("e-wrap");
                        this.element.addClass("e-wrap");
                        break;
                }
            }
            else {
                this.getContent().removeClass("e-wrap");
                this.element.find(".e-columnheader").removeClass("e-wrap");
                this.element.removeClass("e-wrap");
            }
        };
        HeatMapGrid.prototype._getMetaColGroup = function () {
            var $colgroup = ej.buildTag("colgroup");
            for (var i = 0; i < this.model.columns.length; i++) {
                var $col = $(document.createElement("col"));
                this.model.columns[i]["visible"] === false && $col.css("display", "none");
                if (this.model.rowTemplate != null && !ej.isNullOrUndefined(this.model.columns[i]["cssClass"]))
                    $col.addClass(this.model.columns[i]["cssClass"]);
                if (this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && $.inArray(this.model.columns[i]["field"], this.model.groupSettings.groupedColumns) != -1)
                    $col.css("display", "none");
                $colgroup.append($col);
            }
            return $colgroup;
        };
        HeatMapGrid.prototype._alternateRow = function () {
            return this.getIndex() % 2 == 0 ? "e-row" : "e-alt_row";
        };
        HeatMapGrid.prototype.formatting = function (formatstring, str, locale) {
            formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
            locale = ej.preferredCulture(locale) ? locale : "en-US";
            var s = formatstring;
            var frontHtmlidx, FrontHtml, RearHtml, lastidxval;
            frontHtmlidx = formatstring.split("{0:");
            lastidxval = formatstring.split("}");
            FrontHtml = frontHtmlidx[0];
            RearHtml = lastidxval[1];
            if (typeof (str) == "string" && $.isNumeric(str))
                str = Number(str);
            if (formatstring.indexOf("{0:") != -1) {
                var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                var formatVal = toformat.exec(formatstring);
                if (formatVal != null && str != null) {
                    if (FrontHtml != null && RearHtml != null)
                        str = FrontHtml + ej.format(str, formatVal[2], locale) + RearHtml;
                    else
                        str = ej.format(str, formatVal[2], locale);
                } else if (str != null)
                    str = str;
                else
                    str = "";
                return str;
            } else if (s.startsWith("{") && !s.startsWith("{0:")) {
                var fVal = s.split(""), str = (str || "") + "", strSplt = str.split(""), formats = /[0aA\*CN<>\?]/gm;
                for (var f = 0, f, val = 0; f < fVal.length; f++)
                    fVal[f] = formats.test(fVal[f]) ? "{" + val++ + "}" : fVal[f];
                return String.format.apply(String, [fVal.join("")].concat(strSplt)).replace('{', '').replace('}', '');
            } else if (this.data != null && this.data.Value == null) {
                $.each(this.data, function (dataIndex, dataValue) {
                    s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
                });
                return s;
            } else {
                return this.data.Value;
            }
        };
        HeatMapGrid.prototype.addInitTemplate = function () {
            var headerCellDiv = this.element.find(".e-headercelldiv:not(.e-emptyCell)"), templates = {}, firstVisible = true;
            var tbody = document.createElement('tbody'), $tbody = $(tbody);
            if (this.model.rowTemplate == null) {
                var tr = document.createElement('tr'),
                    $tr = $(tr),
                    columns = this.model.columns,
                    i;
                if (this._gridRecordsCount && !this._virtualDataRefresh)
                    this._initColumns(this.model.currentViewData[0] != undefined ? this.model.currentViewData[0] : this.model.currentViewData.value);
                else if (this._isLocalData && (this._dataSource() != null && this._dataSource().length || (this._dataManager && this._dataManager.dataSource.json.length)))
                    this._initColumns(this._dataSource()[0] != undefined ? this._dataSource()[0] : this._dataManager.dataSource.json[0]);
                var helpers = { _gridFormatting: this.formatting };

                $.views.helpers(helpers);

                var viewHelper = {};
                viewHelper["_foreignKey"] = this._foreignKeyBinding;
                $.views.helpers(viewHelper);

                if (this.model.childGrid || this.model.detailsTemplate) {
                    var $tdDetailCell = ej.buildTag("td.e-detailrowcollapse", "<div class='e-icon e-gnextforward'></div>");
                    $tr.append($tdDetailCell);
                }
                for (i = 0; i < this.model.columns.length; i++) {
                    var $tdCell = ej.buildTag("td.e-rowcell");
                    if (!ej.isNullOrUndefined(columns[i]["tooltip"]) || columns[i]["clipMode"] == ej.HeatMapGrid.ClipMode.EllipsisWithTooltip)
                        $tdCell.addClass("e-gridtooltip")
                    if (columns[i]["clipMode"] == ej.HeatMapGrid.ClipMode.Ellipsis || columns[i]["clipMode"] == ej.HeatMapGrid.ClipMode.EllipsisWithTooltip)
                        $tdCell.addClass("e-gridellipsis");
                    if (this.model.isResponsive)
                        $tdCell.attr("data-cell", this._decode(this.model.columns[i]["headerText"]));
                    if (columns[i]["visible"] == false)
                        $tdCell.addClass("e-hide");
                    else {
                        if (firstVisible && (this.model.detailsTemplate != null || this.model.childGrid != null))
                            $tdCell.addClass('e-detailrowvisible');
                        firstVisible = false;
                    }
                    !this.model.groupSettings.showGroupedColumn && $tdCell.addClass("{{for ~groupedColumns}}" +
                        " {{if #data == '" + this.model.columns[i]["field"] + "'}}e-hide{{/if}}" +
                        "{{/for}}");
                    if (!ej.isNullOrUndefined(columns[i]["templateID"] || columns[i]["template"])) {
                        var viewHelper = {}, index, htxt = columns[i].headerText;
                        viewHelper["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this, index);
                        $.views.helpers(viewHelper);
                        if (!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                            htxt = htxt.replace(/[^0-9\s\w]/g, "_");
                        $("#" + this._id + htxt + i + "_Template").remove();
                        var scriptElement = this._createTemplateElement(columns[i]);
                        if ((columns[i].field == "") || ej.isNullOrUndefined(columns[i].field))
                            this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                        if (columns[i]["template"] != false)
                            $tdCell.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "','" + i + "')}}");
                    } else {
                        var splits = (columns[i].field || "").split("."), sLen = splits.length - 1, braces = "";
                        while (sLen) {
                            braces += "(";
                            sLen--;
                        }
                        var columnType = columns[i].type || columns[i].editType
                        switch (columnType) {
                            default:
                                if (columns[i].disableHtmlEncode)
                                    $tdCell.html("{{html:" + braces + "#data['" + splits.join("'] || {})['") + "']}}");
                                else
                                    $tdCell.html("{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}");
                        }
                        if (columns[i]["format"] != undefined && (!columns[i]["foreignKeyValue"]))
                            $tdCell.html("{{:~_gridFormatting('" + columns[i]["format"] + "'," + braces + "#data['" + splits.join("'] || {})['") + "'],'" + this.model.locale + "')}}");
                        if (columns[i]["foreignKeyValue"] && columns[i]["dataSource"]) {
                            $tdCell.html("{{:~_foreignKey(" + i + "," + braces + "#data['" + splits.join("'] || {})['") + "'],'" + this._id + "')}}");
                        }
                        if (columns[i]["commands"]) {
                            var viewHelper = {};

                            $.views.helpers(viewHelper);
                            if ((ej.isNullOrUndefined(columns[i]["field"])) || (columns[i].field == ""))
                                this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                            if (!ej.isNullOrUndefined(columns[i].headerText))
                                $("#" + this._id + columns[i].headerText.replace(/[^a-z0-9|s_]/gi, '') + "_UnboundTemplate").remove();
                            var divElement = this._createUnboundElement(columns[i]);
                            if (!ej.isNullOrUndefined(columns[i].headerText))
                                $tdCell.addClass("e-unboundcell").addClass("e-" + columns[i]["headerText"].replace(/[^a-z0-9|s_]/gi, '') + i).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                            this.model.scrollSettings.frozenColumns > 0 && $tdCell.addClass("e-frozenunbound");
                            this._isUnboundColumn = true;
                        }

                    }
                    if (columns[i]["textAlign"] == undefined)
                        columns[i]["textAlign"] = "left";
                    if (columns[i]["isPrimaryKey"] === true) {
                        this._primaryKeys.push($.trim(columns[i].field));
                        this._primaryKeys = $.unique(this._primaryKeys);
                    }
                    if (!(this.phoneMode && this.model.enableResponsiveRow) && columns[i]["textAlign"] != undefined) {
                        $tdCell.css("text-align", columns[i]["textAlign"]);
                        $(headerCellDiv[i]).css("text-align", columns[i]["textAlign"]);
                    }
                    if (!this.phoneMode && !ej.isNullOrUndefined(columns[i]["headerTextAlign"])) {
                        $(headerCellDiv[i]).css("text-align", columns[i]["headerTextAlign"]);
                    }
                    if (!ej.isNullOrUndefined(columns[i]["cssClass"])) {
                        $tdCell.addClass(columns[i]["cssClass"]);
                    }
                    if (!ej.isNullOrUndefined(columns[i]["priority"]))
                        $tdCell.addClass("e-table-priority-" + columns[i]["priority"]);
                    if (!ej.isNullOrUndefined(columns[i]["customAttributes"]))
                        $tdCell.attr(columns[i]["customAttributes"]);

                    $tdCell.addClass("sf-ht-heatmapcell");
                    $tdCell.attr("role", "heatmapcell");
                    $tr.append($tdCell);
                    if (this.model.enableAltRow) {
                        helpers["_" + this._id + "AlternateRow"] = this._alternateRow;
                        $.views.helpers(helpers);
                        $tr.addClass("{{:~_" + this._id + "AlternateRow()}}");
                    }
                    else
                        $tr.addClass("e-row");
                    $tr.attr("role", "row");
                    if (this.model.scrollSettings.frozenColumns > 0 && this.model.scrollSettings.frozenColumns == i + 1) {
                        tbody.appendChild(tr);
                        templates[this._id + "_JSONFrozenTemplate"] = $tbody.html();
                        $tr.empty();
                        $tbody.empty();
                    }
                }
                tbody.appendChild(tr);
            }
            templates[this._id + "_JSONTemplate"] = this.model.rowTemplate != null ? $(this.model.rowTemplate).html() : $tbody.html();
            $.templates(templates);
        };
        HeatMapGrid.prototype.render = function () {
            this.model.showSummary = this.model.summaryRows.length > 0 || this.model.showSummary;
            this._renderGridContent().insertAfter(this.element.children(".e-gridheader"));
            this.model.allowResizeToFit && this.setWidthToColumns();
            this._initialEndRendering();
        };
        HeatMapGrid.prototype._createStackedRow = function (stackedHeaderRow, frozenHeader) {
            var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow');
            var sHeader = [], sCss = [], tAl = [], tp = [];
            for (var c = 0; c < this.model.columns.length; c++) {
                var column = this.model.columns[c];
                if (column.visible != false) {
                    if (this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && this.model.groupSettings.groupedColumns.length > 0) {
                        if ($.inArray(column.field, this.model.groupSettings.groupedColumns) != -1)
                            continue;
                    }
                    var headerText = '', cssClass = '', txtAlign = '', ttp = "";
                    var sColumn = stackedHeaderRow.stackedHeaderColumns;
                    for (var col = 0; col < sColumn.length; col++) {
                        var _column = $.isArray(sColumn[col].column) ? sColumn[col].column : $.map(sColumn[col].column.split(","), $.trim),
                            className = "e-row" + $.inArray(stackedHeaderRow, this.model.stackedHeaderRows) + "-column" + col;
                        if ($.inArray(column.field, _column) != -1) {
                            headerText = sColumn[col].headerText;
                            cssClass = sColumn[col]["cssClass"];
                            txtAlign = sColumn[col].textAlign;
                            ttp = sColumn[col]["tooltip"] ? " e-gridtooltip " + className : '';
                        }
                    }
                    sHeader.push(headerText);
                    sCss.push(cssClass);
                    tAl.push(txtAlign);
                    tp.push(ttp);
                }
            }
            var colsPanList = []
            for (var i = 0; i < sHeader.length; i++) {
                var colSpan = 1;
                for (var j = i + 1; j < sHeader.length; j++) {
                    if (sHeader[i] == sHeader[j]) {
                        colSpan++;
                    }
                    else
                        break;
                }
                colsPanList.push({ sapnCount: colSpan, headerText: sHeader[i], cssClass: sCss[i], txtAlign: tAl[i], tooltip: tp[i] });
                i += colSpan - 1;
            }
            var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow');
            var frzCol = this.model.scrollSettings.frozenColumns;
            if (this.model.allowScrolling && frzCol > 0) {
                var frozenColspanList = [];
                var forzenColumn = 0, index = 0, frzHideCol = 0;
                for (var i = 0; i < this.model.columns.length; i++) {
                    var col = this.model.columns[i];
                    if (i < frzCol && col.visible == false)
                        frzHideCol++;
                }
                forzenColumn = frzCol - frzHideCol;
                while (forzenColumn > 0) {
                    var spanC = colsPanList[index].sapnCount;
                    if (colsPanList[index].sapnCount < forzenColumn) {
                        frozenColspanList.push(colsPanList[index])
                        if (!frozenHeader)
                            colsPanList.splice(index, 1);
                        else
                            index++;
                    }
                    else if (colsPanList[index].sapnCount > forzenColumn) {
                        colsPanList[index].sapnCount = colsPanList[index].sapnCount - forzenColumn
                        if (frozenHeader)
                            frozenColspanList.push({ sapnCount: forzenColumn, headerText: colsPanList[index].headerText });
                    }
                    else {
                        frozenColspanList.push(colsPanList[index])
                        if (!frozenHeader)
                            colsPanList.splice(index, 1);
                    }
                    forzenColumn -= spanC;
                }
                if (frozenHeader)
                    colsPanList = frozenColspanList
            }
            if (this.model.detailsTemplate || this.model.childGrid)
                $tr.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div></div>'));
            for (var c = 0; c < colsPanList.length; c++) {
                var $th = ej.buildTag('th.e-headercell e-stackedHeaderCell e-default' + colsPanList[c].tooltip, colsPanList[c].headerText, {}, { 'colspan': colsPanList[c].sapnCount });
                $th.css("textAlign", colsPanList[c].txtAlign);
                $tr.append($th);
                if (colsPanList[c]["cssClass"] != undefined)
                    $th.addClass(colsPanList[c]["cssClass"]);
            }
            return $tr;
        };
        HeatMapGrid.prototype._renderGridContent = function () {
            var $div = ej.buildTag('div.e-gridcontent');
            var $innderDiv = ej.buildTag('div');
            var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: "0.25px" });
            var $tbody = $(document.createElement('tbody'));
            $table.append(this.getHeaderTable().find('colgroup').clone()).append($tbody);
            $innderDiv.html($table);
            $div.html($innderDiv);
            this.setGridContentTable($table);
            this.setGridContent($div);
            $table.attr("role", "heatmap");
            var args = {};
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length) {
                if (this.initialRender) {
                    args.columnName = this.model.groupSettings.groupedColumns[this.model.groupSettings.groupedColumns.length - 1];
                    if (!this.model.groupSettings.showGroupedColumn) {
                        for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                            var col = this.model.groupSettings.groupedColumns[i];
                            if ($.inArray(col, this._hiddenColumnsField) == -1) {//updated for
                                this._hiddenColumnsField.push(col);//updated for
                                this.getColumnByField(col).visible = false;
                            }
                        }
                    }
                }
                args.requestType = ej.HeatMapGrid.Actions.Grouping;
            } else
                args.requestType = ej.HeatMapGrid.Actions.Refresh;
            if (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0) {
                var $emptyTd = ej.buildTag('td.emptyrecord', this.localizedLabels.EmptyRecord, {}, { colSpan: this.model.columns.length });
                $tbody.append($(document.createElement("tr")).append($emptyTd));
                this.setWidthToColumns();
                if (this.initialRender)
                    this.sendDataRenderingRequest(args)
            } else
                this.sendDataRenderingRequest(args);
            if (this._isCaptionSummary && args.requestType == "grouping" && this.model.groupSettings.groupedColumns.length > 1) {
                var colgroup = this.getContentTable().find(".e-table").not(".e-recordtable").children("colgroup");
                var $cols1 = $(this.getContentTable().find(".e-recordtable")[0]).children("colgroup").find("col");
                for (i = 0; i < colgroup.length; i++) {
                    var colCount = $(colgroup[i]).find("col").length;
                    $(colgroup[i]).find("col:gt(" + (colCount - $cols1.length - 1) + ")").remove();
                    $(colgroup[i]).append($cols1.clone());
                }
            }
            return $div;
        };



        HeatMapGrid.prototype.sendDataRenderingRequest = function (args) {
            if (this._templateRefresh) {
                this.refreshTemplate();
                this._templateRefresh = false;
            }
            this.setFormat();
            if (!this.model.scrollSettings.enableVirtualization) {
                this._previousColumnIndex = null;
                this._previousRowCellIndex = null;
                this._previousIndex = null;
            }
            if (args.requestType == "add" || args.requestType == "grouping" || (this.model.currentViewData != null && this.model.currentViewData.length)) {
                switch (args.requestType) {
                    case ej.HeatMapGrid.Actions.Refresh:
                    case ej.HeatMapGrid.Actions.Paging:
                    case ej.HeatMapGrid.Actions.Sorting:
                    case ej.HeatMapGrid.Actions.Filtering:
                    case ej.HeatMapGrid.Actions.Save:
                    case ej.HeatMapGrid.Actions.Cancel:
                    case ej.HeatMapGrid.Actions.Delete:
                    case ej.HeatMapGrid.Actions.Search:
                    case ej.HeatMapGrid.Actions.Reorder:
                    case ej.HeatMapGrid.Actions.BatchSave:
                        var cloneGroupedColumns = this.model.groupSettings.groupedColumns
                        if (this.model.allowGrouping && args.requestType == ej.HeatMapGrid.Actions.Refresh && cloneGroupedColumns.length == 0 && this.element.find(".e-grouptopleftcell").length > 0) {
                            var $header = this.element.children(".e-gridheader");
                            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
                        }
                        if (!this.model.allowGrouping)
                            cloneGroupedColumns = [];
                        if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                            $("#" + this._id + "_externalEdit").css("display", "none");
                        if (cloneGroupedColumns.length == 0) {
                            var temp = document.createElement('div'), temp1, insertIndex = -1, isRemoteAdaptor = false;
                            if (!this.phoneMode)
                                this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                            (this.model.childGrid != null || this.model.detailsTemplate != null) && this.getContentTable().find("colgroup").first().prepend(this._getIndentCol());
                            var currentPage = this._currentPage();
                            if ((this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate" || this.model.editSettings.editMode == "normal") && (args.requestType == "cancel" || args.requestType == "save"))
                                this._editFormHeight = this.element.find(".gridform").closest("tr").height();

                            if (this.model.scrollSettings.frozenColumns > 0)
                                temp.innerHTML = this._renderByFrozenDesign();
                            else {
                                if (args.data) {
                                    temp1 = document.createElement('div');
                                    temp1.innerHTML = ['<table>', $.render[this._id + "_JSONTemplate"](args.data), '</table>'].join("");
                                    if (this._dataSource() instanceof ej.DataManager && args.requestType == ej.HeatMapGrid.Actions.Save) {
                                        insertIndex = this._getDataIndex(this.model.currentViewData, args.data);
                                        isRemoteAdaptor = this._dataSource().adaptor instanceof ej.remoteSaveAdaptor;
                                    }
                                }
                                temp.innerHTML = ['<table>', $.render[this._id + "_JSONTemplate"](this.model.currentViewData), '</table>'].join("");
                                var tableEle = this.getContentTable().get(0);
                                var tbodyEle = tableEle.lastChild;
                                var rindex = this.getContentTable().first().find('tbody').first();
                                if ((args.requestType == "save" || args.requestType == "cancel") && this.model.editSettings.editMode != "batch") {
                                    if (this.model.editSettings.editMode.indexOf("inlineform") != -1)
                                        var rowIndex = !ej.isNullOrUndefined(args.selectedRow) ? args.selectedRow : this._selectedRow();
                                    else
                                        var rowIndex = this.getContentTable().find('.e-' + args.action + 'edrow').index();
                                    var a = this._currentTrIndex;
                                    if (rowIndex == -1)
                                        rowIndex = a;
                                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                                        if (this.model.editSettings.editMode == "inlineform")
                                            var rowTr = $($(tbodyEle.childNodes).not('.e-detailrow')[rowIndex]);
                                        else
                                            var rowTr = $(tbodyEle.childNodes[rowIndex]);
                                        var rowEle = $(tbodyEle.childNodes).not('.e-detailrow');
                                        for (var i = 0; i < rowEle.length; i++) {
                                            if (rowTr.is(rowEle[i]))
                                                rowIndex = i;
                                        }
                                    }

                                    if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                        if (args.action == "add" && !this.getContentTable().find(".e-addedrow").length) break;
                                        var $oldChild = this.getContentTable().find('.e-addedrow').get(0);
                                        var $editedTr = this.getContentTable().find('.e-editedrow');
                                        var $newChild = ($editedTr.length || args.requestType == "cancel") ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;
                                        if ($editedTr.length) {
                                            if (this.model.editSettings.showAddNewRow && this.model.editSettings.rowPosition == "top")
                                                rowIndex = rowIndex - 1;
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                                $oldChild = $editedTr.prev('tr').get(0);
                                                $editedTr.remove();
                                            } else
                                                $oldChild = $editedTr.get(0);
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('tr.e-detailrow:visible').length) {
                                                var $target = $newChildObj.find('.e-detailrowcollapse');
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            if (args.requestType == "cancel") {
                                                if (this.model.editSettings.showAddNewRow)
                                                    this.getContentTable().find('.e-addedrow').addClass("e-showaddrow");
                                                $oldChildObj.replaceWith($newChildObj);
                                            } else if (!ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount < this._previousFilterCount) {
                                                if (this.model.detailsTemplate != null && $oldChildObj.next('tr.e-detailrow').length)
                                                    tbodyEle.removeChild($oldChildObj.next('tr.e-detailrow').get(0));
                                                $oldChildObj.remove();
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && cloneGroupedColumns.length == 0)
                                                    tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            else {
                                                tbodyEle.replaceChild($newChild, $oldChild);
                                            }
                                        } else {
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if (args.action == "add" && args.requestType == "save" && this.model.editSettings.showAddNewRow && this.model.allowPaging && this.model.pageSettings.pageSize <= this._currentJsonData.length)
                                                this.model.editSettings.rowPosition == "bottom" ? tbodyEle.lastChild.previousSibling.remove() : tbodyEle.lastChild.remove();
                                            if (args.requestType == "cancel" || this._dataSource() instanceof ej.DataManager || this._currentPage() != 1 || (args.requestType == "save" && !ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount == this._previousFilterCount)) {
                                                if (!ej.isNullOrUndefined($oldChild)) {
                                                    $oldChildObj.remove();
                                                    if (this._dataSource() instanceof ej.DataManager && insertIndex != -1) {
                                                        if (insertIndex == 0)
                                                            tbodyEle.insertBefore($newChild, tbodyEle.children[insertIndex]);
                                                        else
                                                            $newChildObj.insertAfter(tbodyEle.children[insertIndex - 1]);
                                                    }
                                                    else if ((!(this._dataSource() instanceof ej.DataManager) || isRemoteAdaptor) && this._currentPage() != 1 && args.requestType == "save")
                                                        $(tbodyEle).prepend($(temp.firstChild.firstChild.firstChild));
                                                    if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && cloneGroupedColumns.length == 0 &&
                                                        ((this._dataSource() instanceof ej.DataManager && insertIndex == -1 && (!isRemoteAdaptor && args.requestType != "save")) ||
                                                        (args.requestType != "save" && !(this._dataSource() instanceof ej.DataManager))) && (args.requestType == "cancel" && !this.model.editSettings.showAddNewRow))
                                                        tableEle.lastChild.appendChild(temp.firstChild.firstChild.lastChild);
                                                }
                                                if (args.requestType == "cancel" && this._selectedRow() != -1)
                                                    this.clearSelection();

                                            } else if (this.model.currentViewData.length == 1) {
                                                $(tbodyEle).empty();
                                                tbodyEle.appendChild($newChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount)) {
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            } else if (this.model.editSettings.rowPosition == "bottom") {
                                                rindex.prepend($oldChild);
                                                tbodyEle.replaceChild($newChild, $oldChild);
                                            } else
                                                tbodyEle.replaceChild($newChild, $oldChild);
                                        }
                                    } else if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                                        if (args.action == "add" && !this.element.find(".e-addedrow").length) break;
                                        $editedTr = this.element.find('.e-editedrow');
                                        if (args.requestType == "cancel" || (!$editedTr.length && !ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount == this._previousFilterCount)) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            $oldChild = tbodyEle.childNodes[rowIndex];
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('.e-detailrow:visible').length) {
                                                var $target = $newChildObj.find('.e-detailrowcollapse');
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            $oldChildObj.replaceWith($newChildObj);
                                            this.clearSelection();


                                        } else if ($editedTr.length) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            $oldChild = this._excludeDetailRows(tbodyEle.childNodes)[rowIndex];
                                            if (this.model.allowCellMerging != null) {
                                                var $oldChildObj = $($oldChild);
                                                if ($($oldChild.childNodes).hasClass("e-merged")) {
                                                    var index = $oldChildObj.children('.e-merged').index();
                                                    var count = $oldChild.children[index].colSpan;
                                                    for (var i = 0 ; i < count; i++) {
                                                        $newChild.childNodes[index + i].className += " e-merged e-hide";
                                                        $newChild.childNodes[index].colSpan = i + 1;
                                                    }
                                                }
                                            }
                                            if (this.model.detailsTemplate != null)
                                                $oldChild = $(tbodyEle.childNodes).not('.e-detailrow').eq(rowIndex).get(0);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('tr.e-detailrow:visible').length) {
                                                var $target = $($newChild).find(".e-detailrowcollapse");
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            if (!ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount < this._previousFilterCount) {
                                                var $oldChildObj = $($oldChild);
                                                if (this.model.detailsTemplate != null && $oldChildObj.next('tr.e-detailrow').length)
                                                    tbodyEle.removeChild($oldChildObj.next('tr.e-detailrow').get(0));
                                                $oldChildObj.remove();
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length)
                                                    tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            else
                                                tbodyEle.replaceChild($newChild, $oldChild);
                                        } else if (this.model.currentViewData.length == 1 && this.getContentTable().find('td.e-rowcell').length == 0) {
                                            $newChild = temp.firstChild.firstChild.firstChild;
                                            $(tbodyEle).empty();
                                            tbodyEle.appendChild($newChild);
                                        } else {
                                            var newChild = ($editedTr.length || args.requestType == "cancel") ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;
                                            if (!(this._dataSource() instanceof ej.DataManager)) {
                                                if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                    this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                                else if (this._currentPage() == 1)
                                                    this.getContentTable().find('tbody').first().prepend($(newChild));
                                                else
                                                    this.getContentTable().find('tbody').first().prepend($(temp.firstChild.firstChild.firstChild));
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length)
                                                    tbodyEle.removeChild(tbodyEle.lastChild);
                                            }
                                            else if (insertIndex != -1) {
                                                if (insertIndex == 0)
                                                    tbodyEle.insertBefore(newChild, tbodyEle.children[insertIndex]);
                                                else
                                                    $(newChild).insertAfter(tbodyEle.children[insertIndex - 1]);
                                                if (this.model.allowPaging && (this.model.pageSettings.pageSize <= this.model.currentViewData.length || insertIndex == this.model.pageSettings.pageSize - 1))
                                                    tbodyEle.removeChild(tbodyEle.lastChild);
                                            }
                                            if (this.model.detailsTemplate != null && $(tableEle.lastChild.lastChild).children('.e-detailrowexpand').length)
                                                tbodyEle.removeChild(tbodyEle.lastChild);
                                        }
                                    }
                                    if (this.model.editSettings.showAddNewRow)
                                        this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                                    else
                                        this._gridRows = tableEle.rows;
                                    if (this.model.enableAltRow)
                                        this._refreshAltRow();
                                } else if (args.requestType == "delete") {
                                    if (this._isUnboundColumn) {
                                        var $editedrow = this.element.find('.e-editedrow');
                                        var $oldChild = this.getContentTable().find('.e-editedrow').get(0);
                                        var $newChild = ($editedrow.length) ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;

                                        if ($editedrow.length != 0 && (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")) {
                                            $($oldChild).replaceWith($($newChild));
                                        }
                                        else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                            $oldChild = $editedrow.prev('tr').get(0);
                                            $editedrow.remove();
                                        }
                                        else
                                            $oldChild = $editedrow.get(0);
                                    }
                                    if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && this.getContentTable()[0].rows.length != this.model.currentViewData.length) {
                                        if (this.getContentTable().find("tr").length && this._excludeDetailRows().length) {
                                            if (this.multiDeleteMode) {
                                                var rowLength = temp.firstChild.firstChild.rows.length;
                                                var rows = $(temp.firstChild.firstChild.rows).slice(rowLength - this.selectedRowsIndexes.length, rowLength);
                                                $(tbodyEle).append(rows);
                                            }
                                            else
                                                tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);

                                        }
                                        else
                                            $(tbodyEle).prepend(temp.firstChild.firstChild.rows);
                                    }
                                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                                        var visibleRow = this.getContentTable().find('.e-detailrow:visible');
                                        $.each(visibleRow, function (indx, item) {
                                            if (visibleRow.eq(indx).closest('tr').prev().children('.e-detailrowexpand').length == 0)
                                                visibleRow.eq(indx).remove();
                                        });
                                    }
                                    this._gridRows = tableEle.rows;
                                    if (this.model.enableAltRow)
                                        this._refreshAltRow();
                                } else
                                    this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);

                            }
                            this._currentJsonData = this.model.currentViewData;
                            if (this.model.editSettings.showAddNewRow)
                                this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                            else
                                this._gridRows = this.getContentTable().get(0).rows;
                            if (this.model.scrollSettings.frozenColumns > 0)
                                this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

                            var model = {};
                            if ((args.requestType == "sorting" || args.requestType == "filtering") && this.model.scrollSettings.allowVirtualScrolling) {
                                if (args.requestType == "filtering") {
                                    this.getContent().first().ejScroller("refresh").ejScroller("isVScroll") ? this.element.find(".gridheader").addClass("e-scrollcss") : this.element.find(".gridheader").removeClass("e-scrollcss");
                                    var model = this._refreshVirtualPagerInfo();
                                }
                                if (this.model.scrollSettings.enableVirtualization)
                                    this._refreshVirtualView(this._currentVirtualIndex);
                                else
                                    this._refreshVirtualContent(currentPage);
                                args.requestType == "filtering" && this.getContent().first().ejScroller("refresh");
                            }
                            if (!this.model.scrollSettings.enableVirtualization)
                                this._eventBindings();
                            break;
                        }
                    case ej.HeatMapGrid.Actions.Grouping:
                        this._group(args);
                        this._refreshStackedHeader();
                        break;
                    case ej.HeatMapGrid.Actions.BeginEdit:
                        this._edit(args);
                        break;
                    case ej.HeatMapGrid.Actions.Add:
                        this._add(args);
                        break;
                    case ej.HeatMapGrid.Actions.Ungrouping:
                        this._ungroup(args);
                        break;
                    case ej.HeatMapGrid.Actions.VirtualScroll:
                        if (!this._isVirtualRecordsLoaded) {
                            if (!this.model.scrollSettings.enableVirtualization)
                                this._replacingContent();
                            else
                                this._replacingVirtualContent();
                        }
                        break;
                }
            } else {
                if (args.requestType == "refresh" && this.model.currentViewData == 0 && !this.phoneMode)
                    this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                this._newungroup(args);
            }
            this._showGridLines();
            this._completeAction(args);
        }
        HeatMapGrid.prototype._showGridLines = function () {
            var $lines = this.model.gridLines;
            if ($lines != "both") {
                this.getContent().addClass($lines != "none" ? "e-" + $lines + "lines" : "e-hidelines");
            }
        };
        HeatMapGrid.prototype._newungroup = function (args) {
            if (args.requestType == "ungrouping")
                this._ungroup(args);
            else
                this.getContentTable().find('tbody').empty().first().append(this._getEmptyTbody());
        };
        HeatMapGrid.prototype.setFormat = function () {
            var column = [];
            for (var i = 0 ; i < this.model.columns.length ; i++) {
                if (this.model.columns[i].type == "date") {
                    column.push(this.model.columns[i]);
                }
            }
            if (column.length > 0) {
                for (var i = 0 ; i < this.model.currentViewData.length ; i++) {
                    for (var j = 0 ; j < column.length ; j++) {
                        var data = this.model.currentViewData[i][column[j].field];
                        if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*)?)([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(data))
                            this.model.currentViewData[i][column[j].field] = new Date(this.model.currentViewData[i][column[j].field]);
                    }
                }
            }
        };
        HeatMapGrid.prototype._completeAction = function (args) {

            if (!this.model.editSettings.showAddNewRow)
                this.model.isEdit = false;
            this._confirmedValue = false;
            if (ej.HeatMapGrid.Actions.Grouping == args.requestType && ej.isNullOrUndefined(args.columnName))
                return;
            if ((args.columnSortDirection == "ascending" || args.columnSortDirection == "descending") && !ej.isNullOrUndefined(args.columnName)) {
                var scolumn = this.getColumnByField(args.columnName);
                if (this.model.allowSorting && this.model.allowMultiSorting)
                    this._scolumns.push(scolumn.field);
                else
                    this._gridSort = scolumn.field;
            }
            if (args.requestType != 'beginedit' && args.requestType != 'add')
                this.setWidthToColumns();
            if (args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete") {
                this._isAddNew = false;
                if (this.model.isResponsive && this.model.minWidth)
                    this.windowonresize();
            }
            if (!this.initialRender && (ej.HeatMapGrid.Actions.UnGrouping == args.requestType || this.model.groupSettings.groupedColumns.length > 0) && !$("#" + this._id + "EditForm").length)
                this._recalculateIndentWidth();

            else if ((ej.HeatMapGrid.Actions.Sorting == args.requestType && this.model.allowSorting) || ej.HeatMapGrid.Actions.Refresh == args.requestType || ej.HeatMapGrid.Actions.Cancel == args.requestType) {
                //if (ej.gridFeatures && ej.gridFeatures.sort && this.getHeaderTable() !== null)
                //    this._sortCompleteAction(args);

                if (!this.initialRender && (this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
                    this._refreshScroller(args);

            } else if (ej.HeatMapGrid.Actions.Delete == args.requestType || ej.HeatMapGrid.Actions.Save == args.requestType || ej.HeatMapGrid.Actions.Search == args.requestType) {
                this._editEventTrigger(args);
                if (!this.initialRender && (this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
                    this._refreshScroller(args);
            } else if (ej.HeatMapGrid.Actions.Filtering == args.requestType)
                this._filterCompleteAction();
            else if (ej.HeatMapGrid.Actions.BeginEdit == args.requestType || ej.HeatMapGrid.Actions.Add == args.requestType)
                this._editCompleteAction(args);
            else if (ej.HeatMapGrid.Actions.Grouping == args.requestType || ej.HeatMapGrid.Actions.Ungrouping == args.requestType)
                this["_" + args.requestType + "CompleteAction"](args);

            if (!this.initialRender && this.model.showSummary && this.model.summaryRows.length > 0) {
                if (this.model.currentViewData.length) {
                    //if (!this.element.children(".e-gridfooter").length)
                    //    this._renderGridFooter().insertAfter(this.getContent());
                    //this.getFooterTable().find('colgroup').remove();
                    //this.getFooterTable().append(this.getHeaderTable().find("colgroup").clone());
                }
                else
                    this.element.children(".e-gridfooter").remove();
            }
            if (!this.initialRender) {
                if (!this.getContent().find("td.e-selectionbackground").length)
                    this._setCurrentRow(args.requestType);
                if (args.requestType != "virtualscroll" && this.clearColumnSelection())
                    $(this.getHeaderTable().find("th.e-headercell")).removeClass("e-columnselection");
            }
            this.model.editSettings.editMode == "batch" && this.refreshBatchEditMode();
            if (!this.initialRender && (this.model.allowScrolling || this.model.isResponsive) && (this._checkScrollActions(args.requestType) || (this.model.editSettings.editMode.indexOf("inline") != -1 && args.requestType == "beginedit")) ||
                (this.model.scrollSettings.virtualScrollMode == "continuous" && args.requestType == "virtualscroll")) {
                if (this.model.isResponsive && this.model.minWidth)
                    this.windowonresize()
                else
                    this._refreshScroller(args);
            }
            if (this.model.scrollSettings.virtualScrollMode == "normal" && args.requestType == "virtualscroll")
                this.getContent().find("div:first").scrollLeft(this.getScrollObject().scrollLeft());
            if (this._customPop != null && args.requestType != "sorting") {
                this._customPop.hide();
            }
            if (this.model.allowScrolling && !this.initialRender && !this.model.scrollSettings.enableVirtualization)
                this.getContentTable().find("tr:last").find("td").addClass("e-lastrowcell");


            if (ej.HeatMapGrid.Actions.Refresh == args.requestType && !this.initialRender && this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0)
                this._groupingCompleteAction(args);
            if (ej.HeatMapGrid.Actions.Refresh == args.requestType && !this.initialRender && this.model.allowGrouping && this.model.groupSettings.groupedColumns.length < 1)
                this._ungroupingCompleteAction(args);
            if (this.model.textWrapSettings)
                this._setTextWrap();
            if (!((this._isUngrouping || this._columnChooser) && (args.requestType == "refresh"))) {
                //this._trigger("actionComplete", args);
                this._isUngrouping = false;
                this._columnChooser = false;
            }
            //if (args.requestType != "refresh")
            //this._trigger("refresh");
            if ((this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")) {

                if (!this.initialRender && this.getContentTable().find("tr.e-addedrow").length == 0 && this.element.find(".e-gridcontent").find("tr").length != 0)
                    this._startAdd();
            }

            if ((ej.HeatMapGrid.Actions.BeginEdit == args.requestType || ej.HeatMapGrid.Actions.Add == args.requestType) && $.isFunction($.validator))
                this.setValidation();
            if (!this.initialRender)
                this.model._groupingCollapsed = [];
            if (!this.initialRender && args.requestType == "refresh") {
                for (var i = 0 ; i < this.model.filterSettings.filteredColumns.length; i++)
                    this.getHeaderTable().find('.e-headercelldiv').eq(this.getColumnIndexByField(this.model.filterSettings.filteredColumns[i].field)).parent().find('.e-filtericon').addClass("e-filteredicon e-filternone");
            };
            if (this.model.columnLayout == "fixed" && !this.model.isEdit)
                this.setWidthToColumns();

        };
        HeatMapGrid.prototype._getDataIndex = function (data, item) {
            var flag = 0, _plen;
            for (var d = 0, len = data.length; d < len; d++) {
                for (var key = 0, _plen = this._primaryKeys.length; key < _plen; key++) {
                    if (this._checkPrimaryValue(data[d][this._primaryKeys[key]], item[this._primaryKeys[key]], this._primaryKeys[key]))
                        continue;
                    else if (key == _plen - 1)
                        flag = 1;
                }
                if (flag) return d;
            }
            return -1;
        };
        HeatMapGrid.prototype._checkPrimaryValue = function (keyData, keyItem, field) {
            if (this.getColumnByField(field).type == "string")
                keyData = keyData.trim();
            if (keyData != keyItem)
                return true;
            else
                return false;
        };
        HeatMapGrid.prototype._eventBindings = function () {
            var rowLength = this.model.scrollSettings.frozenColumns > 0 ? this._gridRows[0].length : this._gridRows.length;
            var trIndex = 0;
            var prev;
            var pageSize = this.model.pageSettings.pageSize;

            if (this._gridRecordsCount != 0) {
                if (this.model.queryCellInfo != null || this.model.rowDataBound != null || this.model.mergeCellInfo != null || this.model.templateRefresh != null) {
                    for (var row = 0; row < rowLength; row++) {
                        var rowIndex = null, trIndex = row, viewIndex, viewData;
                        if (this.model.scrollSettings.allowVirtualScrolling && row < pageSize) {
                            if (!this.model.scrollSettings.enableVirtualization) {
                                for (var i = 0; i < this._cloneQuery.queries.length; i++)
                                    prev = this._cloneQuery.queries[i].fn == "onPage" && this._cloneQuery.queries[i].e.pageIndex - 1;
                                var value = pageSize * prev;
                                if (value != 0) {
                                    rowIndex = this.getContentTable().find("tr[name=" + value + "]").eq(row);
                                    trIndex = rowIndex.index();
                                }
                            }
                            else {
                                rowIndex = $(this._gridRows).eq(row);
                                viewIndex = parseInt($(rowIndex).attr("name"), 32);
                                if ($.inArray(viewIndex, this._queryCellView) != -1)
                                    continue;
                                if (this._virtualLoadedRecords[viewIndex])
                                    viewData = this._virtualLoadedRecords[viewIndex][row % this._virtualRowCount];
                                trIndex = viewIndex * this._virtualRowCount + (row % this._virtualRowCount);
                            }
                        }
                        else if (this.model.scrollSettings.enableVirtualization)
                            rowIndex = $(this._gridRows).eq(row);
                        rowIndex = rowIndex || this.getRowByIndex(trIndex);
                        if (rowIndex.hasClass("e-virtualrow") || ej.isNullOrUndefined(this._currentJsonData[row] || viewData))
                            break;
                        var rowData = this.model.scrollSettings.enableVirtualization ? viewData : this._currentJsonData[row];
                        this._rowEventTrigger(rowIndex, rowData);
                    }
                }
            }
        };
        HeatMapGrid.prototype._rowEventTrigger = function (row, data) {
            var args = { row: row, data: data };
            //this._trigger("rowDataBound", args);
            var tdCells = row.cells;
            var $tdRowcells = $(row).find(".e-rowcell");
            for (var cellIndex = 0; cellIndex < $tdRowcells.length; cellIndex++) {
                var args = { cell: $tdRowcells[cellIndex], data: data, text: $tdRowcells[cellIndex].innerHTML };
                var foreignKeyData = this._getForeignKeyData(args.data);
                if ($($tdRowcells[cellIndex]).hasClass("e-rowcell"))
                    args.column = this.model.columns[cellIndex];
                if (!ej.isNullOrUndefined(foreignKeyData))
                    args.foreignKeyData = foreignKeyData;


                //this._heatmap["queryCellInfo")( args);
                this._heatmap._setBinding(args);
                if ($($tdRowcells[cellIndex]).hasClass("e-templatecell")) {
                    var args = { cell: $tdRowcells[cellIndex], column: this.model.columns[cellIndex], data: data, rowIndex: $(row).index() };
                    //this._trigger("templateRefresh", args);
                }
            }

        };
        HeatMapGrid.prototype.setWidthToColumns = function () {
            var $cols1 = this.getContentTable().children("colgroup").find("col");
            var $cols2 = this.getHeaderTable().children("colgroup").find("col");
            var width = this.element.width(), frozenWidth = 0, columnsTotalWidth = 0, finalWidth = 0;
            if (this.model.groupSettings.groupedColumns.length && !this.model.allowScrolling && this.model.groupSettings.showGroupedColumn) {
                var browserDetails = this.getBrowserDetails();
                if (browserDetails.browser == "msie" && parseInt(browserDetails.version, 10) > 8)
                    $cols1.first().css("width", ((30 / width) * 100) + "%");
            }
            if (!ej.isNullOrUndefined(this.model.detailsTemplate)) {
                var headerIndx = this.model.groupSettings.groupedColumns.length;
                var contentIndx = this.model.groupSettings.groupedColumns.length != 0 ? 1 : 0;
                $cols1.eq(contentIndx).css("width", this._detailsOuterWidth);
                $cols2.eq(headerIndx).css("width", this._detailsOuterWidth);
            }
            this._detailColsRefresh();
            $cols1 = this._$headerCols;
            $cols2 = this._$contentCols;

            for (var i = 0; i < $cols2.length; i++) {
                if (this.model.allowResizeToFit && this.model.columns[i]["width"] === undefined && this.columnsWidthCollection[i] === undefined) {
                    var hCellIndex = this.model.groupSettings.groupedColumns.length ? (i + this.model.groupSettings.groupedColumns.length) : i;
                    var contentWidth = this._resizer._getContentWidth(i);
                    var cellDiv = this.getHeaderTable().find('.e-headercelldiv').eq(hCellIndex);
                    var headerWidth = this._resizer._getHeaderContentWidth(cellDiv);
                    if (this.model.editSettings.editMode == "normal" && (this.model.isEdit || this._isAddNew))
                        finalWidth = $cols1.eq(i).width();
                    else {
                        finalWidth = contentWidth > headerWidth ? contentWidth : headerWidth;
                        finalWidth += parseInt(cellDiv.css("padding-left"), 10)
                    }
                    this.columnsWidthCollection[i] = finalWidth;
                    columnsTotalWidth += this.model.columns[i].visible ? finalWidth : 0;
                } else
                    columnsTotalWidth += this.model.columns[i].visible ? parseInt(this.model.columns[i]["width"], 10) : 0;
                if (!ej.isNullOrUndefined(this.columnsWidthCollection[i])) {
                    $cols1.eq(i).width(this.columnsWidthCollection[i]);
                    $cols2.eq(i).width(this.columnsWidthCollection[i]);
                    if (this.model.columns[i]["priority"])
                        $cols2.eq(i).addClass("e-table-priority-" + this.model.columns[i]["priority"]);
                } else if (this.model.allowScrolling) {
                    var colWidth = (width / this.model.columns.length).toFixed(2), bSize = (width / (this.model.scrollSettings.buttonSize || 18) / 100).toFixed(2), cWidth = colWidth - bSize;
                    $cols1.eq(i).css("width", cWidth + "px");
                    $cols2.eq(i).css("width", cWidth + "px");
                    this.model.columns[i].width = cWidth;
                    this.columnsWidthCollection[i] = parseFloat(cWidth);
                }
            }
            if (this.model.columnLayout == "fixed") {
                if (this.model.scrollSettings && this.model.scrollSettings.frozenColumns == 0) {
                    this.getHeaderTable().width(columnsTotalWidth);
                    this.getContentTable().width(columnsTotalWidth);
                }
                var headerTableWidth = this.model.scrollSettings.frozenColumns > 0 ? this.getHeaderTable().eq(0).width() + this.getHeaderTable().eq(1).width() : this.getHeaderTable().width();
                var operation = this.getHeaderContent().width() > headerTableWidth ? 'addClass' : 'removeClass';
                var headerTable = this.getHeaderTable();
                var contentTable = this.getContentTable();
                if (this.model.scrollSettings.frozenColumns > 0) {
                    headerTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getHeaderTable().eq(1) : this.getHeaderTable().eq(0);
                    contentTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getContentTable().eq(1) : this.getContentTable().eq(0);
                }
                headerTable[operation]('e-tableLastCell');
                contentTable[operation]('e-tableLastCell');
            }
            if (!this.model.allowScrolling && this.model.allowResizeToFit && columnsTotalWidth > width) {
                this.model.allowScrolling = true;
                this.model.scrollSettings.width = width;
                this.getHeaderTable().parent().addClass("e-headercontent");
                if (!this.model.scrollSettings.frozenColumns > 0)
                    this.getHeaderTable().width(width);
            }
            if (this.model.isEdit) {
                var clonedCol = $cols1.clone();
                var editedTr;
                if (this.model.editSettings.showAddNewRow)
                    editedTr = this.getContentTable().find(".e-editedrow");
                var $colGroup = this.model.scrollSettings.frozenColumns > 0 ? this.getContent().find(".gridform").find("colgroup") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr.find("colgroup") : $("#" + this._id + "EditForm").find("colgroup");
                this.model.scrollSettings.frozenColumns > 0 && $colGroup.first().empty().append(clonedCol.splice(0, this.model.scrollSettings.frozenColumns));
                $colGroup.last().empty().append(clonedCol);
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $colGroup.prepend(this._getIndentCol());
            }
            if (this.model.groupSettings.groupedColumns.length) {
                var $grouedColGroup = this.getContentTable().find(".e-recordtable").children("colgroup");
                for (var i = 0; i < $grouedColGroup.length; i++) {
                    var clonedCol = $cols1.clone();
                    var detailsWidth = this._detailsOuterWidth != null ? this._detailsOuterWidth : "30px";
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) clonedCol.splice(0, 0, $(this._getIndentCol()).width(detailsWidth)[0]);
                    $grouedColGroup.eq(i).empty().append(clonedCol);
                }
            }
            if (this.model.scrollSettings.frozenColumns > 0) {
                var totalWidth = 0, frozenWidth;
                for (var i = 0; i < this.columnsWidthCollection.length; i++) {
                    totalWidth += parseInt(this.columnsWidthCollection[i], 10);
                    if (this.model.scrollSettings.frozenColumns - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                }
                this.getContent().find(".e-frozencontentdiv").outerWidth(frozenWidth)
                    .end().find(".e-movablecontentdiv").outerWidth(totalWidth - frozenWidth);
                this.getHeaderContent().find(".e-frozenheaderdiv").outerWidth(frozenWidth)
                    .end().find(".e-movableheaderdiv").outerWidth(totalWidth - frozenWidth);
            }
        };
        HeatMapGrid.prototype._initialEndRendering = function () {
            // use this method to add behaviour after grid render.


            if (this.model.scrollSettings.frozenColumns > 0 && !this.model.allowScrolling) {
                this.getContent().remove();
                this.getHeaderTable().eq(1).remove();

                return;
            }
            this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization;
            this._getRowHeights();
            if (this.element.width() != 0)
                this.model.allowScrolling && this._renderScroller();
            else if (this.model.allowScrolling && this.element.width() == 0) {
                var proxy = this, myVar = setInterval(function () {
                    if (proxy.element.width() != 0 && !ej.isNullOrUndefined(proxy.element.width())) {
                        proxy._renderScroller();
                        proxy._endRendering();
                        clearInterval(myVar);
                    }
                }, 100);
                return;
            }
            this._endRendering();
        };
        HeatMapGrid.prototype._endRendering = function () {
            if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && this.model.allowScrolling)
                var scroller = this.getScrollObject();
            var css = this.model.enableRTL ? "e-summaryscroll e-rtl" : "e-summaryscroll";
            if (this.model.allowScrolling && this.model.showSummary && scroller._vScroll)
                this.element.find(".e-summaryrow.e-scroller").addClass(css);
            this._addMedia();
            if (this.model.allowScrolling && this.model.allowTextWrap && !this.model.scrollSettings.allowVirtualScrolling) this.getContent().first().ejScroller("refresh");
            if (this.model.scrollSettings.allowVirtualScrolling) {
                if (this._currentPage() == 1 && !this.model.scrollSettings.enableVirtualization)
                    this._virtualLoadedRecords[this._currentPage()] = this._currentJsonData;
                if (this.model.scrollSettings.enableVirtualization)
                    this._refreshVirtualView();
                else
                    this._refreshVirtualContent();
                this.getContent().first().ejScroller("refresh");
                if (this.getContent().ejScroller("isVScroll")) {
                    this.element.find(".e-gridheader").addClass("e-scrollcss");
                    this.getHeaderTable().first().width(this.getContentTable().width());
                }
                else
                    this.element.find(".e-gridheader").removeClass("e-scrollcss");
            }
            if (this._selectedRow() != -1) {
                this.model.currentIndex = this._selectedRow();
            }
            this.rowHeightRefresh()
            if (this.initialRender && (!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount))
                this._addLastRow();
        };
        HeatMapGrid.prototype._addLastRow = function () {
            var lastRowtd = this.getContentTable().find("tr:last").find("td"), rowHeight = 0;

            if (this.model.allowScrolling && !this.model.scrollSettings.allowVirtualScrolling && !ej.isNullOrUndefined(this.model.dataSource) && !ej.isNullOrUndefined(this.getRows())) {
                for (var i = 0; i < this.getRows().length; i++)
                    rowHeight += $(this.getRows()[i]).height();

                if (rowHeight < this.getContent().height() - 1)
                    lastRowtd.addClass("e-lastrowcell");
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.getContentTable().height() < this.getContent().height())
                lastRowtd.addClass("e-lastrowcell");
        };
        HeatMapGrid.prototype._addMedia = function () {
            if (typeof (this.model.scrollSettings.width) != "string" && this.model.scrollSettings.width > 0) {
                this._responsiveScrollWidth = this._originalScrollWidth = this.model.scrollSettings.width;
            }
            else
                this._originalScrollWidth = this.element.width();
            if (typeof (this.model.scrollSettings.height) != "string" && this.model.scrollSettings.height > 0)
                this._responsiveScrollHiehgt = this.model.scrollSettings.height;
            if (this.model.minWidth && this.model.isResponsive) {
                this._$onresize = $.proxy(this.windowonresize, this);
                $(window).bind("resize", this._$onresize);
                if ($.isFunction(window.matchMedia)) {
                    var mediaFilterObj = window.matchMedia("(max-width: 768px)");
                    this._mediaStatus = mediaFilterObj.matches;
                }
                this.windowonresize();
            }
        };
        HeatMapGrid.prototype._getNoncontentHeight = function () {
            var height = this.getHeaderContent().outerHeight();
            if (this.model.allowGrouping && this.model.groupSettings.showDropArea)
                height += this.element.find('.e-groupdroparea').outerHeight();
            return height;
        };
        HeatMapGrid.prototype._mediaQueryUpdate = function (isScroller, elemHeight, width, winHeight) {
            if (window.innerWidth <= 320 && this.model.enableResponsiveRow) {
                var contentStyle = this.getContentTable()[0].style;
                if (contentStyle.removeAttribute)
                    contentStyle.removeAttribute('min-width');
                else
                    contentStyle.removeProperty('min-width');
                var scrollObj = this.getContent().data('ejScroller');
                if (scrollObj)
                    this.getContent().ejScroller('destroy');
                return;
            }
            if (isScroller) {
                this.model.scrollSettings.width = ej.isNullOrUndefined(this._responsiveScrollWidth) ? width : Math.min(this._responsiveScrollWidth, width);
                var height = Math.min(winHeight, elemHeight) - this._getNoncontentHeight();
                height = ej.isNullOrUndefined(this._responsiveScrollHiehgt) ? height : Math.min(this._responsiveScrollHiehgt, height);
                height = this.model.scrollSettings.height != "auto" ? height - (parseInt(this.element.parent().css('margin-bottom')) + 1) : this.model.scrollSettings.height;
                if (this.model.minWidth > width && elemHeight > winHeight)
                    height = height != "auto" ? height + this.model.scrollSettings.buttonSize : height;
                if (ej.isNullOrUndefined(this.getRows()))
                    height = '100%';
                this.model.scrollSettings.height = height;
                this.element.find(".e-gridheader").first().find("div").first().addClass("e-headercontent");
                this._renderScroller();
            }
            else {
                this.model.scrollSettings.width = '100%';
                if (!ej.isNullOrUndefined(this._responsiveScrollWidth))
                    this.model.scrollSettings.width = Math.min(this._responsiveScrollWidth, width);
                var modifyHeight = Math.min(winHeight, elemHeight);
                var height = modifyHeight - this._getNoncontentHeight();
                if (!ej.isNullOrUndefined(this._responsiveScrollHiehgt))
                    height = Math.min(this._responsiveScrollHiehgt, winHeight);
                height = this.model.scrollSettings.height != "auto" ? height - parseInt(this.element.parent().css('margin-bottom')) : this.model.scrollSettings.height;
                if (ej.isNullOrUndefined(this.getRows()))
                    height = '100%';
                this.model.scrollSettings.height = height;
                this.element.find(".e-gridheader").first().find("div").first().addClass("e-headercontent");
                this._renderScroller();
            }
        };
        HeatMapGrid.prototype.windowonresize = function () {
            this.model.scrollSettings.width = this._responsiveScrollWidth;
            var width, height;
            this.element.width('100%');
            this.getContentTable().width('100%');
            this.getHeaderTable().width('100%');
            this.getContentTable().css('minWidth', this.model.minWidth);
            width = this.element.width();
            var winHeight = $(window).height() - this.element.offset()['top'];
            var rowCount = !ej.isNullOrUndefined(this.getRows()) ? this.getRows().length : 1;
            var isBody = this.element.parent().is($('body')) || this.element.parent().height() == $('body').height() || this.element.parent()[0].style.height == "";
            var originalElemHeight = this.getContentTable()[0].scrollHeight + this._getNoncontentHeight();
            var elemHeight = isBody ? winHeight : this.element.parent().height();
            originalElemHeight += parseInt(this.element.parent().css('margin-top'));
            var isScroller = this.model.minWidth > width || elemHeight <= originalElemHeight;
            this._mediaQueryUpdate(isScroller, elemHeight, width, originalElemHeight)
            this._refreshScroller({});
        };
        HeatMapGrid.prototype._getRowHeights = function () {
            var trs = this.getRows();
            if (trs !== null) {
                this._rowHeightCollection = [];
                if (trs[1] !== undefined && trs[1].length && ((this.model.scrollSettings.frozenColumns > 0 && trs[0] !== undefined) || (trs[0] !== undefined && typeof trs[0].item !== "undefined" && typeof trs[0].length == "number" && typeof trs[1].item !== "undefined" && typeof trs[1].length == "number"))) {
                    var frotrs = trs[0];
                    var movtrs = trs[1];
                    for (var i = 0 ; i < frotrs.length ; i++) {
                        this._rowHeightCollection[i] = frotrs[i].offsetTop >= movtrs[i].offsetTop ? frotrs[i].offsetTop : movtrs[i].offsetTop;
                    }
                }
                else {
                    for (var i = 0 ; i < trs.length ; i++) {
                        this._rowHeightCollection[i] = trs[i].offsetTop;
                    }
                }
            }
            return this._rowHeightCollection;
        };
        HeatMapGrid.prototype._getEmptyTbody = function () {
            var $emptyTd = ej.buildTag('td.emptyrecord', this.localizedLabels.EmptyRecord, {}, { colSpan: this.model.columns.length });
            return $(document.createElement("tr")).append($emptyTd);
        };
        HeatMapGrid.prototype._getIndentCol = function () {
            return ej.buildTag("col", "", { width: "30px" });
        };
        HeatMapGrid.prototype._wireEvents = function (heatmap) {
            heatmap._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", $.proxy(this._clickHandler, this));



            this._enableRowHover(undefined, heatmap);


            if (this.model.allowGrouping) {
                this._enableGroupingEvents();
                this._on(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", $.proxy(this._dropAreaHover, this));
            }
        };
        HeatMapGrid.prototype._clickHandler = function (e) {
            var $target = $(e.target), tempChooser = $("[id$='ccDiv'].e-grid.e-columnChooser"), fieldName, $form = $("#" + this._id + "EditForm"), index, columnIndex, rowIndex;
            if (tempChooser.length) {
                var flag = true;
                for (var i = 0; i < tempChooser.length; i++) {
                    if ($target.parents(".e-ccButton").length || $target.hasClass('e-ccButton')) flag = $(e.target).closest(".e-grid").attr("id") + "ccDiv" != tempChooser[i].id;
                }
            }

            if ($target.closest(".e-grid").attr("id") !== this._id) return;
            if ($target.closest("#" + this._id + "EditForm").length)
                return;
            if ($target.hasClass("e-rowcell") || $target.closest("td").is(".e-rowcell") || ($target.hasClass("e-headercell") && ((e.clientY - $target.offset().top) < ($target.height() / 4)))) {
                if (this._bulkEditCellDetails.cancelSave) {
                    this._bulkEditCellDetails.cancelSave = false;
                    return;
                }
                if (this.model.editSettings.editMode == "batch" && ($.isFunction($.validator) && $form.length && $form.validate().errorList.length > 0))
                    return;
                this.model.editSettings.editMode == "batch" && this.element.focus();
                index = $target.closest("tr").hasClass("e-insertedrow") ? this.model.groupSettings.groupedColumns.length : 0;
                var tempIndex = $target.closest(".e-rowcell").index() != -1 ? $target.closest(".e-rowcell").index() : $target.closest(".e-headercell").index() - this.model.groupSettings.groupedColumns.length;
                columnIndex = $target.hasClass("e-rowcell") ? $target.index() - index : tempIndex - index;
                columnIndex = (this.model.detailsTemplate != null || this.model.childGrid != null) ? columnIndex - 1 : columnIndex;
                if (this.model.scrollSettings.frozenColumns && ($target.closest(".e-movableheaderdiv").length || $target.closest(".e-movablecontentdiv").length))
                    columnIndex = columnIndex + this.model.scrollSettings.frozenColumns;
                rowIndex = this.getIndexByRow($target.closest("tr"));
                this._bulkEditCellDetails.columnIndex = columnIndex;
                this._bulkEditCellDetails.rowIndex = rowIndex;
                if (this.model.allowSelection) {
                    if (this.model.selectionType == "multiple") {
                        if (e.ctrlKey || this._enableSelectMultiTouch) {
                            this.multiSelectCtrlRequest = true;
                        }
                        if (e.shiftKey) {
                            this.multiSelectShiftRequest = true;
                            if (this._allowcellSelection && rowIndex > -1)
                                this.selectCells([[rowIndex, [columnIndex]]]);
                            this._selectedRow(this.getIndexByRow($target.closest('tr')));

                        }
                        if (e["pointerType"] == "touch" && this._customPop != null && !this._customPop.is(":visible") && this._customPop.find(".e-rowselect").hasClass("e-spanclicked") && this.model.selectionSettings.selectionMode == "row")
                            this._customPop.show();
                        if (e["pointerType"] == "touch" && this._customPop != null && (this._customPop.find(".e-sortdirect").is(":visible") || !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) && this.model.selectionType == "multiple") {
                            this._customPop.removeAttr("style");
                            var offset = $target.offset();
                            this._customPop.offset({ top: 0, left: 0 }).offset({ left: offset.left, top: offset.top - this.getRowHeight() }).find(".e-sortdirect").hide().end()
                                .find(".e-rowselect").show().end().show();
                        }
                    }
                    if (!this.multiSelectShiftRequest) {
                        if (this._allowcellSelection && rowIndex > -1) {
                            var cellProto = this._checkCellSelectionByRow(rowIndex, columnIndex);
                            if ((this.model.selectionSettings.enableToggle && this.selectedRowCellIndexes.length == 1 && this.selectedRowCellIndexes[0].cellIndex.length == 1 || (e.ctrlKey && this.model.selectionType == 'multiple')) && (cellProto != -1 && this.selectedRowCellIndexes.length > 0 && this.selectedRowCellIndexes[0].cellIndex.length > 0))
                                this.clearCellSelection(cellProto.rowIndex, columnIndex);
                            else
                                this.selectCells([[rowIndex, [columnIndex]]]);
                        }
                        if (this._allowrowSelection && rowIndex > -1) {
                            var selectedIndex = this.getIndexByRow($target.closest('tr'));
                            if (this.model.scrollSettings.enableVirtualization) {
                                var remain = rowIndex % this._virtualRowCount, viewIndex;
                                viewIndex = parseInt($($target).closest("tr").attr("name"), 32);
                                selectedIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
                            }
                            if (this.model.selectionSettings.enableToggle && this.getSelectedRecords().length == 1 && $.inArray(this.getIndexByRow($target.closest('tr')), this.selectedRowsIndexes) != -1)
                                this.clearSelection(selectedIndex);
                        }
                        if (this._allowcolumnSelection && $target.hasClass("e-headercell") && !$target.hasClass("e-stackedHeaderCell") && ((e.clientY - $target.offset().top) < ($target.height() / 4))) {
                            if (this.model.selectionSettings.enableToggle && this.selectedColumnIndexes.length == 1 && $.inArray(columnIndex, this.selectedColumnIndexes) != -1)
                                this.clearColumnSelection(columnIndex);
                        }
                        this.multiSelectCtrlRequest = false;
                    }
                    this.multiSelectShiftRequest = false;
                }

                fieldName = this.model.columns[this._bulkEditCellDetails.columnIndex]["field"];
                if ($target.closest(".e-rowcell").length && fieldName) {
                    this._tabKey = false;
                    this.model.editSettings.allowEditing && this.model.editSettings.editMode == "batch" && this.editCell($.inArray($target.closest("tr").get(0), this.getRows()), fieldName);
                }
            }
            if ($target.hasClass("e-rowselect") || $target.hasClass("e-sortdirect")) {
                if (!$target.hasClass("e-spanclicked")) {
                    $target.addClass("e-spanclicked");
                    if ($target.hasClass("e-rowselect"))
                        this._enableSelectMultiTouch = true;
                    if ($target.hasClass("e-sortdirect"))
                        this._enableSortMultiTouch = true;
                } else {
                    $target.removeClass("e-spanclicked");
                    if ($target.hasClass("e-rowselect"))
                        this._enableSelectMultiTouch = false;
                    if ($target.hasClass("e-sortdirect"))
                        this._enableSortMultiTouch = false;
                    this._customPop.hide();
                }
            }

            if ($target.is(".e-filtericon") && $target.closest(".e-detailrow").length != 0)
                e.preventDefault();

            if (this.model.allowSearching && this._searchBar != null) {
                if ($target.is(this._searchBar.find(".e-cancel")))
                    this._searchBar.find("input").val("");
                else {
                    if (e.target.id == this._id + "_searchbar")
                        this._searchBar.find(".e-cancel").removeClass("e-hide");
                    else if (!this._searchBar.find(".e-cancel").hasClass("e-hide"))
                        this._searchBar.find(".e-cancel").addClass("e-hide");
                }
            }
        };
        HeatMapGrid.prototype._checkCellSelectionByRow = function (rowIndex, columnIndex) {
            for (var i = 0; i < this.selectedRowCellIndexes.length; i++) {
                if (this.selectedRowCellIndexes[i].rowIndex == rowIndex)
                    break;
            }
            if (i != this.selectedRowCellIndexes.length && $.inArray(columnIndex, this.selectedRowCellIndexes[i].cellIndex) != -1)
                return this.selectedRowCellIndexes[i];
            return -1;
        };
        HeatMapGrid.prototype._destroy = function () {
            /// <summary>This function is  used to destroy the Grid Object</summary>
            this.element.off();
            this.element.find(".e-gridheader").find(".e-headercontent,.e-movableheader")
                .add(this.getContent().find(".e-content,.e-movablecontent")).unbind('scroll');
            var editForm = $("#" + this._id + "EditForm");
            if (editForm.length) {
                var $formEle = editForm.find('.e-field'), $element;
                for (var i = 0; i < $formEle.length; i++) {
                    $element = $($formEle[i]);
                }
                editForm.remove();
            }

            if (this.model.showColumnChooser) {

                $("#" + this._id + "ccDiv").remove();
                $("#" + this._id + "_ccTail").remove();
                $("#" + this._id + "_ccTailAlt").remove();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "excel")
                this._excelFilter.resetExcelFilter()
            if (this.model.allowReordering)
                $(".e-columndropindicator").remove();

            if (this._$onresize)
                $(window).unbind("resize", this._$onresize);
            this.element.empty().removeClass("e-grid " + this.model.cssClass);
        };
        return HeatMapGrid;
    })();

    ej.HeatMapGrid = function (args, heatmap) {
        return new HeatMapGrid(args, heatmap);
    };


    ej.HeatMapGrid.Locale = ej.HeatMapGrid.Locale || {};
    ej.HeatMapGrid.Actions = {
        /** Used to specify paging action in grid   */
        Paging: "paging",
        /** Used to specify sorting action in grid   */
        Sorting: "sorting",
        /** Used to specify filtering action in grid   */
        Filtering: "filtering",
        /** Used to specify begin edit action in grid   */
        BeginEdit: "beginedit",
        /** Used to specify saving action in grid   */
        Save: "save",
        /** Used to specify adding action in grid   */
        Add: "add",
        /** Used to specify deleting action in grid   */
        Delete: "delete",
        /** Used to specify cancelling action in grid   */
        Cancel: "cancel",
        /** Used to specify grouping action in grid   */
        Grouping: "grouping",
        /** Used to specify un-grouping action in grid   */
        Ungrouping: "ungrouping",
        /** Used to specify refresh action in grid   */
        Refresh: "refresh",
        /** Used to specify reordering action in grid   */
        Reorder: "reorder",
        /** Used to specify searching action in grid   */
        Search: "searching",
        /** Used to specify batch save action in grid   */
        BatchSave: "batchsave",
        /** Used to specify virtual scroll action in grid   */
        VirtualScroll: "virtualscroll"
    };
    ej.HeatMapGrid.ClipMode = {
        /** Render an ellipsis ("...") to represent clipped text **/
        Ellipsis: "ellipsis",
        /** Clips the text **/
        Clip: "clip",
        /** Render an ellipsis ("...") to represent clipped text and tooltip would be shown **/
        EllipsisWithTooltip: "ellipsiswithtooltip"
    };
    ej.HeatMapGrid.SelectionType = {
        /**  Support for Single selection only in grid */
        Single: "single",
        /**  Support for multiple selections in grid */
        Multiple: "multiple"
    };
    ej.HeatMapGrid.SelectionMode = {
        /**  Support for Row selection in grid */
        Row: "row",
        /**  Support for Cell selection in grid */
        Cell: "cell",
        /**  Support for Column selection in grid */
        Column: "column"
    };
    ej.HeatMapGrid.Locale["default"] = ej.HeatMapGrid.Locale["en-US"] = {
        EmptyRecord: "No records to display",
        GroupDropArea: "Drag a column header here to group its column",
        DeleteOperationAlert: "No records selected for delete operation",
        EditOperationAlert: "No records selected for edit operation",
        SaveButton: "Save",
        OkButton: "OK",
        CancelButton: "Cancel",
        EditFormTitle: "Details of ",
        AddFormTitle: "Add New Record",
        Notactionkeyalert: "This Key-Combination is not available",
        Keyconfigalerttext: "This Key-Combination has already been assigned to ",
        GroupCaptionFormat: "{{:headerText}}: {{:key}} - {{:count}} {{if count == 1 }} item {{else}} items {{/if}} ",
        BatchSaveConfirm: "Are you sure you want to save changes?",
        BatchSaveLostChanges: "Unsaved changes will be lost. Are you sure you want to continue?",
        ConfirmDelete: "Are you sure you want to Delete Record?",
        CancelEdit: "Are you sure you want to Cancel the changes?",
        PagerInfo: "{0} of {1} pages ({2} items)",
        FrozenColumnsViewAlert: "Frozen columns should be in grid view area",
        FrozenColumnsScrollAlert: "Enable allowScrolling while using frozen Columns",
        FrozenNotSupportedException: "Frozen Columns and Rows are not supported for Grouping, Row Template, Detail Template, Hierarchy Grid and Batch Editing",
        Add: "Add",
        Edit: "Edit",
        Delete: "Delete",
        Update: "Update",
        Cancel: "Cancel",
        Done: "Done",
        Columns: "Columns",
        SelectAll: "(Select All)",
        PrintGrid: "Print",
        ExcelExport: "Excel Export",
        WordExport: "Word Export",
        PdfExport: "PDF Export",
        StringMenuOptions: [{ text: "StartsWith", value: "StartsWith" }, { text: "EndsWith", value: "EndsWith" }, { text: "Contains", value: "Contains" }, { text: "Equal", value: "Equal" }, { text: "NotEqual", value: "NotEqual" }],
        NumberMenuOptions: [{ text: "LessThan", value: "LessThan" }, { text: "GreaterThan", value: "GreaterThan" }, { text: "LessThanOrEqual", value: "LessThanOrEqual" }, { text: "GreaterThanOrEqual", value: "GreaterThanOrEqual" }, { text: "Equal", value: "Equal" }, { text: "NotEqual", value: "NotEqual" }],
        PredicateAnd: "AND",
        PredicateOr: "OR",
        Filter: "Filter",
        FilterMenuCaption: "Filter Value",
        FilterbarTitle: "'s filter bar cell",
        MatchCase: "Match Case",
        Clear: "Clear",
        ResponsiveFilter: "Filter",
        ResponsiveSorting: "Sort",
        Search: "Search",
        DatePickerWaterMark: "Select date",
        EmptyDataSource: "DataSource must not be empty at initial load since columns are generated from dataSource in AutoGenerate Column Grid",
        ForeignKeyAlert: "The updated value should be a valid foreign key value",
        True: "true",
        False: "false",
        UnGroup: "Click here to ungroup",
        AddRecord: "Add Record",
        EditRecord: "Edit Record",
        DeleteRecord: "Delete Record",
        Save: "Save",
        Grouping: "Group",
        Ungrouping: "Ungroup",
        SortInAscendingOrder: "Sort In Ascending Order",
        SortInDescendingOrder: "Sort In Descending Order",
        NextPage: "Next Page",
        PreviousPage: "Previous Page",
        FirstPage: "First Page",
        LastPage: "Last Page",
        EmptyRowValidationMessage: "Atleast one field must be updated",
        NoResult: "No Matches Found"
    };
})(jQuery, Syncfusion);;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Heatmap = (function (_super) {
    __extends(Heatmap, _super);
    function Heatmap(element, options) {
        _super.call(this);
        this._rootCSS = "e-heatmap";
        this._grid = null;
        this.PluginName = "ejHeatMap";
        this._setFirst = false;
        this.id = "null";
        this.model = null;
        this.validTags = ['div'];
        this.defaults = {
            itemsSource: null,
            itemsMapping: {
                itemsSource: null,
                columnStyle: {
                    headerTemplateID: "",
                    templateID: "",
                    textAlign: "",
                    width: null
                },
                headerMapping: {
                    columnStyle: {
                        headerTemplateID: "",
                        templateID: "",
                        textAlign: "",
                        width: null
                    },
                    displayName: "",
                    propertyName: ""
                },
                column: {
                    displayName: "",
                    propertyName: ""
                },
                columnMapping: null,
                row: {
                    displayName: "",
                    propertyName: ""
                },
                value: {
                    displayName: "",
                    propertyName: ""
                },
            },
            colorMappingCollection: null,
            selectedItem: null,
            legendCollection: [],
            heatMapCell: {
                showContent: "visible",
                showColor: true,
            },
            cellMouseOver: null,
            cellMouseEnter: null,
            cellMouseLeave: null,
            cellSelected: null,
            isResponsive: false,
            enableVirtualization: false,
            enableRTL: false,
            defaultColumnStyle: {
                textAlign: "center",
                headerTemplateID: "",
                templateID: "",
            },
            enableTooltip: false,
            tooltipSettings: {
                templateId: null,
                position: {
                    stem: { horizontal: "left", vertical: "center" },
                    target: { horizontal: "right", vertical: "center" }
                },
                isBalloon: true,
                animation: {
                    effect: "none",
                    speed: 0
                },
                associate: "mouseFollow",
                trigger: "hover"
            },
            width: null,
            height: null
        };
        this.observables = [
            "heatMapCell.showContent",
            "heatMapCell.showColor",
        ];
        this.dataTypes = {
            colorMappingCollection: "data",
            itemsMapping: {
                columnMapping: "data"
            },
            itemsSource: "data",
            legendCollection: "data"
        };
        this._tags = [
            {
                tag: "colorMappingCollection",
                attr: [
                    "value",
                    "color",
                    "label.bold",
                    "label.italic",
                    "label.text",
                    "label.textDecoration",
                    "label.fontSize",
                    "label.fontFamily",
                    "label.fontColor",
                ],
                singular: "colorMapping"
            }
        ];
        this._heatmapShowContent = ej.util.valueFunction("heatMapCell.showContent");
        this._heatmapShowColor = ej.util.valueFunction("heatMapCell.showColor");
        if (element) {
            if (!element["jquery"]) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejHeatMap(options).data(this.PluginName);
            }
        }
    }
    Heatmap.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    Heatmap.prototype._setModel = function (options) {
        var update = false;
        var grid = this._grid;
        if (grid) {
            for (var item in options) {
                switch (item) {
                    case "colorMappingCollection":
                        if (options.colorMappingCollection && options.colorMappingCollection.length > 0) {
                            this.model.colorMappingCollection = options.colorMappingCollection;
                            update = true;
                        }
                        break;
                    case "itemsSource":
                        if (options.itemsSource) {
                            this.model.itemsSource = options.itemsSource;
                            var data = void 0;
                            if (this.model.itemsMapping && this.model.itemsMapping.column && this.model.itemsMapping.row)
                                data = this._bindCellMapValues();
                            else
                                data = this._bindTableMapValues();
                            grid.dataSource(data.dataTableMapping, false);
                            update = true;
                        }
                        break;
                    case "legendCollection":
                        if (options.legendCollection && options.legendCollection > 0) {
                            this.model.legendCollection = options.legendCollection;
                        }
                        break;
                    case "heatMapCell":
                    case "heatmapCell":
                        if (options.heatmapCell) {
                            if (options.heatmapCell.showContent != undefined)
                                options.heatMapCell.showContent = options.heatmapCell.showContent;
                            if (options.heatmapCell.showColor != undefined)
                                options.heatMapCell.showColor = options.heatmapCell.showColor;
                        }
                        if (options.heatMapCell) {
                            if (options.heatMapCell.showColor) {
                                if (typeof (options.heatMapCell.showColor()) === "boolean")
                                    this._heatmapShowColor(options.heatMapCell.showColor());
                                else
                                    this.model.heatMapCell.showColor = (options.heatMapCell.showColor || options.heatMapCell.showColor === false) ? options.heatMapCell.showColor : this.model.heatMapCell.showColor;
                            }
                            if (options.heatMapCell.showContent) {
                                if (typeof (options.heatMapCell.showContent()) === "function")
                                    this._heatmapShowContent(options.heatMapCell.showContent());
                                else
                                    this.model.heatMapCell.showContent = (options.heatMapCell.showContent || options.heatMapCell.showContent === false) ? options.heatMapCell.showContent : this.model.heatMapCell.showContent;
                            }
                            update = true;
                        }
                        break;
                    case "tooltipSettings":
                    case "enableTooltip":
                        if (options.enableTooltip != undefined)
                            this.model.enableTooltip = options.enableTooltip;
                        if (options.tooltipSettings) {
                            if (options.tooltipSettings.position)
                                this.model.tooltipSettings.position = options.tooltipSettings.position;
                            if (options.tooltipSettings.isBalloon != undefined)
                                this.model.tooltipSettings.isBalloon = options.tooltipSettings.isBalloon;
                            if (options.tooltipSettings.animation)
                                this.model.tooltipSettings.animation = options.tooltipSettings.animation;
                            if (options.tooltipSettings.associate)
                                this.model.tooltipSettings.associate = options.tooltipSettings.associate;
                            if (options.tooltipSettings.trigger)
                                this.model.tooltipSettings.trigger = options.tooltipSettings.trigger;
                            if (options.tooltipSettings.templateId !== undefined && options.tooltipSettings.templateId !== null)
                                this.model.tooltipSettings.templateId = options.tooltipSettings.templateId;
                        }
                        if (this._hasClass(this.element[0], "e-tooltip")) {
                            $("#" + this.element[0].id).data("ejTooltip").destroy();
                            this.element.addClass("e-js");
                        }
                        this._renderTooltip();
                        break;
                }
            }
            if (update) {
                grid.refreshContent();
                this._updateResponsiveSize(grid);
            }
        }
    };
    Heatmap.prototype._hasClass = function (el, cn) {
        var classes = el.classList;
        for (var j = 0; j < classes.length; j++) {
            if (classes[j] == cn) {
                return true;
            }
        }
    };
    Heatmap.prototype._init = function () {
        var availSpace = this._getSpace();
        this._initData();
        this._updateDataSource();
        this._wireEvents();
        this._renderMapGrid();
        this._renderTooltip();
    };
    Heatmap.prototype._wireEvents = function () {
        this._on($(window), "resize", this._updateResponsiveSize);
        this._on($(window), "load", this._updateResponsiveSize);
        $(window).bind("mousewheel DOMMouseScroll", $.proxy(this._hideLegendMarker, this));
    };
    Heatmap.prototype._hideLegendMarker = function () {
        var triangles = $(".gradient_scale_marker");
        for (var i = 0; triangles.length > 0 && i < triangles.length; i++) {
            if (triangles[i]) {
                var tri = triangles[i];
                tri.style.visibility = "hidden";
            }
        }
    };
    Heatmap.prototype._getBoundingClientRect = function (element) {
        var rect = element.getBoundingClientRect();
        if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") {
            rect = { left: rect.left, top: rect.top, right: rect.right, bottom: rect.bottom, width: $(element).width(), height: $(element).height() };
        }
        return rect;
    };
    Heatmap.prototype._getSpace = function () {
        var availSapace = this._getBoundingClientRect(this.element[0]);
    };
    Heatmap.prototype._initData = function () {
        if (typeof this.model.legendCollection === 'string') {
            this.model.legendCollection = JSON.parse(this.model.legendCollection);
        }
        ;
        this._updateHeatMapCellData(this.model);
        if (this.model.enableTooltip && this.model.tooltipSettings && !this.model.tooltipSettings.templateId)
            this.model.tooltipSettings.templateId = this.element[0].id + "_DefaultTooltipDiv";
    };
    Heatmap.prototype._updateHeatMapCellData = function (options) {
        if (options && options.heatmapCell) {
            if (options.heatmapCell.showContent != undefined)
                this.model.heatMapCell.showContent = options.heatmapCell.showContent;
            if (options.heatmapCell.showColor != undefined)
                this.model.heatMapCell.showColor = options.heatmapCell.showColor;
        }
    };
    Heatmap.prototype._updateDataSource = function () {
    };
    Heatmap.prototype._bindTableMapValues = function () {
        var dataTableMapping = [];
        var columns = [];
        if (this.model.itemsSource && this.model.itemsSource.length > 0) {
            var itemsSource = this.model.itemsSource;
            for (var i = 0; i < itemsSource.length; i++) {
                dataTableMapping.push(itemsSource[i]);
            }
        }
        var headerMapping = this.model.itemsMapping.headerMapping;
        var columnStyle = headerMapping.columnStyle;
        columnStyle = this._mergeDefaultSettings(columnStyle, true);
        var freeze = true;
        freeze = this.model.enableVirtualization ? false : freeze;
        if (headerMapping) {
            columns.push({
                field: headerMapping.propertyName,
                headerText: headerMapping.displayName,
                isFrozen: freeze,
                width: columnStyle && columnStyle.width ? columnStyle.width : null,
                textAlign: columnStyle && columnStyle.textAlign ? columnStyle.textAlign : "center",
                headerTemplateID: columnStyle && columnStyle.headerTemplateID ? columnStyle.headerTemplateID : "",
                templateID: columnStyle && columnStyle.templateID ? columnStyle.templateID : ""
            });
        }
        var columnMapping = this.model.itemsMapping.columnMapping;
        for (var i = 0; columnMapping && i < columnMapping.length; i++) {
            columnStyle = columnMapping[i].columnStyle;
            columnStyle = this._mergeDefaultSettings(columnStyle, false);
            columns.push({
                field: columnMapping[i].propertyName,
                headerText: columnMapping[i].displayName,
                width: columnStyle && columnStyle.width ? columnStyle.width : null,
                textAlign: columnStyle && columnStyle.textAlign ? columnStyle.textAlign : "center",
                headerTemplateID: columnStyle && columnStyle.headerTemplateID ? columnStyle.headerTemplateID : "",
                templateID: columnStyle && columnStyle.templateID ? columnStyle.templateID : "",
            });
        }
        return { dataTableMapping: dataTableMapping, columns: columns };
    };
    Heatmap.prototype._renderMapGrid = function () {
        var data = null;
        if (this.model.itemsMapping && this.model.itemsMapping.column && this.model.itemsMapping.column.propertyName != "" && this.model.itemsMapping.row && this.model.itemsMapping.row.propertyName != "")
            data = this._bindCellMapValues();
        else
            data = this._bindTableMapValues();
        var dd = null;
        if (this.model.height === null) {
            delete this.model.height;
        }
        if (this.model.width === null) {
            delete this.model.width;
        }
        if (data && $("#" + this.element[0].id)[0]) {
            var hGrid = ej.HeatMapGrid({}, this);
            var scrollSettings = {
                height: (this.model.height !== undefined) ? (this.model.height - 40) : "auto",
                width: (this.model.width !== undefined) ? Number(this.model.width) : "100%",
                allowVirtualScrolling: this.model.enableVirtualization ? true : false,
                virtualScrollMode: "normal",
                enableVirtualization: this.model.enableVirtualization ? true : false,
            };
            if (this.model.width === undefined) {
                delete scrollSettings["width"];
            }
            var options = {
                dataSource: data.dataTableMapping ? data.dataTableMapping : [],
                columns: data.columns ? data.columns : [],
                enableRowHover: false,
                allowScrolling: true,
                selectionSettings: { selectionMode: [ej.HeatMapGrid.SelectionMode.Cell] },
                queryCellInfo: $.proxy(this._setBinding, this),
                cellSelected: $.proxy(this._cellSelected, this),
                isResponsive: this.model.isResponsive ? this.model.isResponsive : false,
                enableResponsiveRow: false,
                scrollSettings: scrollSettings,
                minWidth: 10,
                enableRTL: this.model.enableRTL ? this.model.enableRTL : false,
            };
            hGrid._init($("#" + this.element[0].id), options, this);
            this._updateResponsiveSize(hGrid);
        }
    };
    Heatmap.prototype._updateResponsiveSize = function (hGrid) {
        if (this.model.isResponsive) {
            var header = $(".e-movableheaderdiv");
            var content = $(".e-movablecontentdiv");
            header.css("width", "100%");
            content.css("width", "100%");
            if (header[0]) {
                var headerColGroup = header[0].getElementsByTagName('colgroup')[0];
                if (headerColGroup && headerColGroup.childNodes && headerColGroup.childNodes.length > 0) {
                    for (var i = 0; this.model.itemsMapping.columnMapping && i < this.model.itemsMapping.columnMapping.length; i++) {
                        var column = this.model.itemsMapping.columnMapping[i];
                        if (column && (!column.columnStyle || !column.columnStyle.width)) {
                            var child = $(headerColGroup.childNodes[i]);
                            if (child && child[0])
                                child[0].style.width = "";
                        }
                    }
                }
            }
            if (content[0]) {
                var contentColGroup = content[0].getElementsByTagName('colgroup')[0];
                if (contentColGroup && contentColGroup.childNodes && contentColGroup.childNodes.length > 0) {
                    for (var i = 0; this.model.itemsMapping.columnMapping && i < this.model.itemsMapping.columnMapping.length; i++) {
                        var column = this.model.itemsMapping.columnMapping[i];
                        if (column && (!column.columnStyle || !column.columnStyle.width)) {
                            var child = $(contentColGroup.childNodes[i]);
                            if (child && child[0])
                                child[0].style.width = "";
                        }
                    }
                }
            }
            if (hGrid && hGrid._refreshScroller) {
                if ($(".e-scrollbar")[0]) {
                    if (!this.model.enableVirtualization)
                        $(".e-scrollbar")[0].parentNode.removeChild($(".e-scrollbar")[0]);
                    hGrid._initScrolling();
                }
            }
        }
    };
    Heatmap.prototype._cellSelected = function (evt) {
        this.model.selectedItem = { cellValue: evt.currentCell[0].ejHeatMapData.cellValue, source: evt.currentCell[0].ejHeatMapData.data, cell: evt.currentCell[0] };
        this._raiseEvent("cellSelected", { cellValue: evt.currentCell[0].ejHeatMapData.cellValue, source: this._getTableData(evt.currentCell[0].ejHeatMapData), cell: evt.currentCell[0] });
    };
    Heatmap.prototype._componentToHex = function (c) {
        var hex = c.toString(16);
        return hex.length === 1 ? "0" + hex : hex;
    };
    Heatmap.prototype._rgbToHex = function (r, g, b) {
        if (isNaN(r) && isNaN(g) && isNaN(b))
            return "";
        else
            return "#" + this._componentToHex(r) + this._componentToHex(g) + this._componentToHex(b);
    };
    Heatmap.prototype._setBinding = function (args) {
        var $element = $(args.cell);
        var rbg = this._convertToRBG(ej.parseFloat(ej.format(args.text, "c")), this.model.colorMappingCollection);
        var rgb = this._rgbToHex(rbg.R, rbg.G, rbg.B);
        var columnStyle = this.model.itemsMapping.columnStyle && this.model.itemsMapping.columnStyle[args.column.field] ? this.model.itemsMapping.columnStyle[args.column.field] : null;
        if (this._heatmapShowColor() != undefined) {
            if (args.column.field && columnStyle && columnStyle.fillColor) {
                var fColor = this._getForeGroundColor(columnStyle.fillColor);
                $element.css("background-color", columnStyle.fillColor).css("color", fColor ? fColor : "black");
            }
            else {
                if (this._heatmapShowColor() === false)
                    $element.css("background-color", "white");
                else {
                    var fColor = this._getForeGroundColor(rbg);
                    $element.css("background-color", rgb).css("color", fColor ? fColor : "");
                }
                if (this._setClassOnForzen(args.cell) && $element.index() === 0) {
                    $element.css("font-weight", "normal").css("font-size", 12);
                }
            }
        }
        if (this._canEnableContent(args))
            $element[0].innerHTML = "&nbsp;";
        this._bindHoverOutEvents(args, rgb);
        if (!(this.model.itemsMapping.headerMapping && args.column.field && this.model.itemsMapping.headerMapping.propertyName === args.column.field)) {
            $element.addClass("sf-ht-enabletooltip");
        }
    };
    Heatmap.prototype._canEnableContent = function (args) {
        if (this._heatmapShowContent() === ej.datavisualization.HeatMap.CellVisibility.Hidden) {
            if (this.model.itemsMapping.headerMapping && args.column && this.model.itemsMapping.headerMapping.propertyName === args.column.field)
                return false;
            return true;
        }
    };
    Heatmap.prototype._setClassOnForzen = function (cell) {
        do {
            if (cell) {
                cell = cell.parentNode;
                if (cell) {
                    if (cell.className === "e-movablecontent") {
                        return true;
                    }
                }
                else
                    break;
            }
        } while (cell && cell.className !== "e-gridcontent");
        return false;
    };
    Heatmap.prototype._getForeGroundColor = function (rgb) {
        if (rgb.R !== undefined && rgb.G !== undefined && rgb.B !== undefined) {
            var average = (rgb.R + rgb.G + rgb.B) / 3;
            if (average < 255 * .5) {
                return "white";
            }
            else if (isNaN(rgb.R) && isNaN(rgb.G) && isNaN(rgb.B))
                return "";
            else
                return "black";
        }
        else
            return null;
    };
    Heatmap.prototype._getTableData = function (ejData) {
        var heatmapData = ejData.data;
        if (this.model.itemsMapping && this.model.itemsMapping.column && this.model.itemsMapping.row) {
            var row = this.model.itemsMapping.row;
            var column = this.model.itemsMapping.column;
            if (ejData.column.field) {
                var field = ejData.column.field;
                var obj = {};
                obj[row.propertyName] = heatmapData[row.propertyName];
                obj["value"] = ejData.cellValue;
                obj[column.propertyName] = field;
                return obj;
            }
        }
        else
            return ejData.data;
    };
    Heatmap.prototype._bindHoverOutEvents = function (args, rgb) {
        $(args.cell)
            .mouseenter($.proxy(this._cellMouseEnter, this))
            .mousemove($.proxy(this._cellMouseHover, this))
            .mouseleave($.proxy(this._cellMouseOut, this));
        args.cell.ejHeatMapData = { column: args.column, cellValue: args.text, data: args.data, rgb: rgb };
    };
    Heatmap.prototype._cellMouseOut = function (evt) {
        this._raiseEvent("cellMouseLeave", { cellValue: evt.currentTarget.ejHeatMapData.cellValue, source: this._getTableData(evt.currentTarget.ejHeatMapData), cell: evt.currentTarget });
        var triangles = $(".gradient_scale_marker");
        for (var i = 0; triangles.length > 0 && i < triangles.length; i++) {
            if (triangles[i]) {
                var tri = triangles[i];
                tri.style.visibility = "hidden";
            }
        }
    };
    Heatmap.prototype._cellMouseHover = function (evt) {
        this._raiseEvent("cellMouseOver", { cellValue: evt.currentTarget.ejHeatMapData.cellValue, source: this._getTableData(evt.currentTarget.ejHeatMapData), cell: evt.currentTarget });
    };
    Heatmap.prototype._cellMouseEnter = function (evt) {
        if (this.model.legendCollection.length > 0) {
            var i = 0;
            var value = null;
            for (; i < this.model.legendCollection.length; i++) {
                var legend = this.model.legendCollection[i];
                if (legend) {
                    if ($("#" + legend)[0]) {
                        var gridLegend = $("#" + legend).data("ejHeatMapLegend");
                        if (gridLegend) {
                            if (evt.currentTarget.ejHeatMapData)
                                value = evt.currentTarget.ejHeatMapData.cellValue;
                            if (value && gridLegend.model.legendMode === (ej.datavisualization.HeatMap.LegendMode.Gradient).toString()) {
                                value = Number(value);
                                if (this.model.itemsMapping.headerMapping && evt.currentTarget.ejHeatMapData && evt.currentTarget.ejHeatMapData.column.field && this.model.itemsMapping.headerMapping.propertyName === evt.currentTarget.ejHeatMapData.column.field)
                                    this._hideLegendMarker();
                                else
                                    this._drawLegendMarker(gridLegend, value);
                            }
                        }
                    }
                }
            }
        }
        this._raiseEvent("cellMouseEnter", { cellValue: evt.currentTarget.ejHeatMapData.cellValue, source: this._getTableData(evt.currentTarget.ejHeatMapData), cell: evt.currentTarget });
    };
    Heatmap.prototype._raiseEvent = function (type, args) {
        if (this.model[type]) {
            return this._trigger(type, args);
        }
    };
    Heatmap.prototype._drawDefaultTooltip = function (args) {
        var tooltipDiv = document.getElementById(this.element[0].id + "_DefaultTooltipDiv");
        if (!tooltipDiv) {
            tooltipDiv = this._createDefaultTooltip(args);
        }
        return tooltipDiv;
    };
    Heatmap.prototype._createDefaultTooltip = function (args) {
        var div = document.createElement("div"), attr, disText, data, disVal;
        attr = {
            "id": this.element[0].id + "_DefaultTooltipDiv",
            "class": "e-heatmap-tooltip-default",
            "style": "padding-top:3px; height: 24px;pointer-events:none;position: absolute",
        };
        disText = this.model.itemsMapping.headerMapping && this.model.itemsMapping.headerMapping.displayName ? this.model.itemsMapping.headerMapping.displayName : "";
        if (disText == "")
            disText = this.model.itemsMapping.row && this.model.itemsMapping.row.displayName ? this.model.itemsMapping.headerMapping.displayName : "";
        if (args.event.currentTarget && args.event.currentTarget.ejHeatMapData) {
            if (this.model.itemsMapping.headerMapping && this.model.itemsMapping.headerMapping.propertyName) {
                data = args.event.currentTarget && args.event.currentTarget.ejHeatMapData;
                disVal = data.data[this.model.itemsMapping.headerMapping.propertyName];
            }
        }
        div.innerHTML = "<table><tr><td style='min-width:50px;padding-right: 10px;'>" + disText + "</td><td>" + disVal + "</td></tr><tr><td>Value</td><td>" + data.cellValue + "</td></tr></table>";
        return div;
    };
    Heatmap.prototype._renderTooltip = function () {
        var context = this;
        if (context.model.enableTooltip) {
            $("#" + this.element[0].id).ejTooltip({
                target: ".sf-ht-enabletooltip",
                position: this.model.tooltipSettings.position,
                isBalloon: this.model.tooltipSettings.isBalloon,
                animation: this.model.tooltipSettings.animation,
                associate: this.model.tooltipSettings.associate,
                trigger: this.model.tooltipSettings.trigger,
                beforeOpen: function (args) {
                    if (context.model.enableTooltip) {
                        $("#" + context.element[0].id).ejTooltip("instance").hide();
                        if (args.event.currentTarget && args.event.currentTarget.ejHeatMapData && context.model.tooltipSettings.templateId != this.element[0].id + "_DefaultTooltipDiv") {
                            $("#" + context.element[0].id).ejTooltip({
                                content: $.templates("#" + context.model.tooltipSettings.templateId).render(args.event.currentTarget.ejHeatMapData)
                            });
                        }
                        else {
                            var defDiv = context._drawDefaultTooltip(args);
                            $("#" + context.element[0].id).ejTooltip({
                                content: $.templates(defDiv).render(args.event.currentTarget.ejHeatMapData)
                            });
                        }
                    }
                }
            });
        }
    };
    Heatmap.prototype._drawLegendMarker = function (legend, value) {
        if (legend && value !== undefined && !isNaN(value)) {
            var scaleDiv = $("#" + legend._id + "_gradient_scale")[0];
            if (scaleDiv) {
                var style = "position:absolute;visibility:visible;box-sizing:border-box;";
                var triangle = $("#" + legend._id + "_gradient_scale_marker")[0];
                if (!triangle) {
                    triangle = document.createElement("div");
                    triangle.setAttribute("id", legend._id + "_gradient_scale_marker");
                    triangle.setAttribute("class", "gradient_scale_marker");
                    scaleDiv.appendChild(triangle);
                }
                var bbox = this._getBoundingClientRect(scaleDiv);
                var tbox = this._getBoundingClientRect(triangle);
                var scrollValue = this._getScroll();
                var colorMapping = this.model.colorMappingCollection;
                var lastValue = colorMapping[colorMapping.length - 1].value;
                if (legend.model.orientation === "horizontal")
                    style += "width: 0;height: 0;border-left:" + bbox.height / 2 + "px solid transparent;border-right: " + bbox.height / 2 + "px solid transparent;border-bottom: " + bbox.height + "px solid green;";
                else
                    style += "border-left: none;border-right: " + bbox.width + "px solid green;border-bottom: " + bbox.width / 2 + "px solid transparent;border-top: " + bbox.width / 2 + "px solid transparent;";
                var fValue = colorMapping[0].value;
                var lValue = colorMapping[colorMapping.length - 1].value;
                var diff = lValue - fValue;
                if (legend.model.orientation === "horizontal") {
                    if (this.model.enableRTL)
                        style += "left:" + (Math.round((bbox.left + scrollValue.x - (tbox.width / 2)) + 1) + (((Number(((lValue - value) * 100) / lastValue) / 100) * bbox.width) - 3)) + "px;";
                    else
                        style += "left:" + (Math.round((bbox.left + scrollValue.x - (tbox.width / 2)) + 1) + (((Number(((value) * 100) / lastValue) / 100) * bbox.width) - 3)) + "px;";
                    style += "top:" + ((bbox.top + scrollValue.y) + 2) + "px;";
                }
                else {
                    style += "left:calc(" + ((bbox.left + scrollValue.x)) + "px + " + (0) + "px);";
                    if (this.model.enableRTL)
                        style += "top: calc( " + Math.round((bbox.top + scrollValue.y - (tbox.height / 2)) + 1) + "px + " + (((Number(((lValue - value) * 100) / lastValue) / 100) * bbox.height) - 3) + "px);";
                    else
                        style += "top: calc( " + Math.round((bbox.top + scrollValue.y - (tbox.height / 2)) + 1) + "px + " + (((Number((value * 100) / lastValue) / 100) * bbox.height) - 3) + "px);";
                }
                triangle.setAttribute("style", style);
            }
        }
        else {
            this._hideLegendMarker();
        }
    };
    Heatmap.prototype._getScroll = function () {
        if (window.pageYOffset !== undefined) {
            return { x: pageXOffset ? pageXOffset : 0, y: pageYOffset ? pageYOffset : 0 };
        }
        else {
            var sx = void 0, sy = void 0, d = document, r = d.documentElement, b = d.body;
            sx = r.scrollLeft || b.scrollLeft || 0;
            sy = r.scrollTop || b.scrollTop || 0;
            return { x: sx ? sx : 0, y: sy ? sy : 0 };
        }
    };
    Heatmap.prototype._convertToRBG = function (value, ColorMapping) {
        var num = 0;
        if (typeof (value) === "number") {
            num = Number(value);
        }
        else if (typeof (value) === "string") { }
        else if (value == null) { }
        else { }
        var offsets = [];
        var previousOffset = 0;
        var nextOffset = 0;
        ColorMapping = this._orderbyOffset(ColorMapping);
        for (var i in ColorMapping) {
            var offset = Number(ColorMapping[i].value);
            if (offset !== undefined) {
                if (num <= offset) {
                    nextOffset = offset;
                    break;
                }
                else {
                    nextOffset = offset;
                    previousOffset = offset;
                }
            }
        }
        if (num < previousOffset) { }
        else if (num > nextOffset) { }
        else { }
        var percent = 0;
        if (previousOffset !== undefined) {
            var full = nextOffset - previousOffset;
            percent = (num - previousOffset) / full;
            (isNaN(percent) && num === 0) ? percent = 0 : percent = percent;
        }
        else {
            previousOffset = nextOffset;
        }
        if (percent < 0 || percent > 1) { }
        var previousColor = this._getEqualColor(ColorMapping, previousOffset);
        var nextColor = this._getEqualColor(ColorMapping, nextOffset);
        return this._getPercentageColor(percent, previousColor, nextColor);
    };
    Heatmap.prototype._hashCode = function (str) {
        var hash = 0;
        for (var i = 0; i < str.length; i++) {
            hash = str.charCodeAt(i) + ((hash << 5) - hash);
        }
        return hash;
    };
    Heatmap.prototype._intToRGB = function (i) {
        var c = (i & 0x00FFFFFF)
            .toString(16)
            .toUpperCase();
        return "00000".substring(0, 6 - c.length) + c;
    };
    Heatmap.prototype._getPercentageColor = function (percent, previousValue, nextValue) {
        var next = nextValue, nextColor;
        var previous = previousValue;
        if (next.split("#").length > 1) {
            nextColor = next.split("#")[1];
        }
        else {
            var color = this._intToRGB(this._hashCode(next));
            nextColor = color;
        }
        var prevColor = null;
        if (previous.split("#").length > 1) {
            prevColor = previous.split("#")[1];
        }
        else {
            var color = this._intToRGB(this._hashCode(previous));
            prevColor = color;
        }
        var r = this._getPercentage(percent, parseInt(prevColor.substr(0, 2), 16), parseInt(nextColor.substr(0, 2), 16));
        var g = this._getPercentage(percent, parseInt(prevColor.substr(2, 2), 16), parseInt(nextColor.substr(2, 2), 16));
        var b = this._getPercentage(percent, parseInt(prevColor.substr(4, 2), 16), parseInt(nextColor.substr(4, 2), 16));
        return { R: r, G: g, B: b };
    };
    Heatmap.prototype._getPercentage = function (percent, previous, next) {
        var full = next - previous;
        return Math.round((previous + (full * percent)));
    };
    Heatmap.prototype._getEqualColor = function (list, offset) {
        for (var i = 0; i < list.length; i++) {
            var item = list[i];
            if (item) {
                if (Number(item.value) === offset)
                    return item.color;
            }
        }
        return "#00000";
    };
    Heatmap.prototype._orderbyOffset = function (offsets) {
        var offset1, offset2;
        for (var i = 0; i < offsets.length - 1; i++) {
            offset1 = offsets[i];
            offset2 = offsets[i + 1];
            if (offset1 && offset2 && offset1.value && offset2.value) {
                if (offset1.value > offset2.value) {
                    var temp = offset1;
                    offset1 = offset2;
                    offset2 = temp;
                }
            }
        }
        return offsets;
    };
    Heatmap.prototype._mergeDefaultSettings = function (args, header) {
        var wState;
        if (args) {
            wState = args.width === undefined ? true : false;
        }
        var columnStyle = $.extend(true, {}, this.model.defaultColumnStyle, args);
        if (header && this.model.enableRTL)
            columnStyle.textAlign = (!args || (args && !args.textAlign)) ? "right" : args.textAlign;
        if (wState)
            delete columnStyle["width"];
        return columnStyle;
    };
    Heatmap.prototype._bindCellMapValues = function () {
        var dataTableMapping = [];
        var columns = [];
        var columnBind = {
            prLeft: this.model.itemsMapping.row.propertyName,
            prTop: this.model.itemsMapping.column.propertyName,
            prValue: this.model.itemsMapping.value.propertyName
        };
        var dataValues = this._convertToCellBindingData(this.model.itemsSource, columnBind);
        var row = this.model.itemsMapping.row;
        var column = this.model.itemsMapping.column;
        var columnStyle = this._getCellBingingColumnData(row.propertyName, true);
        columnStyle = this._mergeDefaultSettings(columnStyle, false);
        if (row) {
            var freeze = true;
            freeze = this.model.enableVirtualization ? false : freeze,
                columns.push({
                    field: row.propertyName,
                    headerText: row.displayName,
                    isFrozen: freeze,
                    width: columnStyle && columnStyle.width ? columnStyle.width : null,
                    textAlign: columnStyle && columnStyle.textAlign ? columnStyle.textAlign : "center",
                    headerTemplateID: columnStyle && columnStyle.headerTemplateID ? columnStyle.headerTemplateID : "",
                    templateID: columnStyle && columnStyle.templateID ? columnStyle.templateID : ""
                });
        }
        for (var i = 0; i < dataValues.items.length; i++) {
            columnStyle = this._getCellBingingColumnData(dataValues.items[i], false);
            columnStyle = this._mergeDefaultSettings(columnStyle, false);
            columns.push({
                field: dataValues.items[i],
                headerText: dataValues.items[i],
                width: columnStyle && columnStyle.width ? columnStyle.width : null,
                textAlign: columnStyle && columnStyle.textAlign ? columnStyle.textAlign : "center",
                headerTemplateID: columnStyle && columnStyle.headerTemplateID ? columnStyle.headerTemplateID : "",
                templateID: columnStyle && columnStyle.templateID ? columnStyle.templateID : ""
            });
        }
        return { dataTableMapping: dataValues.dataTableMapping, columns: columns };
    };
    Heatmap.prototype._getCellBingingColumnData = function (field, isRow) {
        if (isRow) {
            var headerMapping = this.model.itemsMapping && this.model.itemsMapping.headerMapping;
            if (headerMapping.propertyName === field) {
                return this._mergeColumnStyle(headerMapping.columnStyle, true);
            }
        }
        else {
            var columnMapping = this.model.itemsMapping && this.model.itemsMapping.columnMapping;
            if (columnMapping && columnMapping.length > 0) {
                for (var i = 0; i < columnMapping.length; i++) {
                    var column = this._mergeDefaultSettings(columnMapping[i], false);
                    if (column.propertyName === field) {
                        return this._mergeColumnStyle(column.columnStyle, false);
                    }
                }
            }
        }
        return null;
    };
    Heatmap.prototype._mergeColumnStyle = function (style, header) {
        style = this._mergeDefaultSettings(style, header);
        style = $.extend(true, {}, {
            textAlign: style && style.textAlign ? style.textAlign : "center"
        }, style);
        return style;
    };
    Heatmap.prototype._convertToCellBindingData = function (data, columnBind) {
        var list = [];
        var itemsList = [];
        for (var i in data) {
            var item = data[i];
            if (item) {
                var newData = {};
                if (item[columnBind.prLeft]) {
                    if (list.length === 0) {
                        var state = false;
                        if (!newData.hasOwnProperty(item[columnBind.prLeft])) {
                            newData[columnBind.prLeft] = item[columnBind.prLeft];
                            list.push(newData);
                            state = true;
                        }
                        if (state) {
                            newData[item[columnBind.prTop].toString()] = item[columnBind.prValue];
                        }
                    }
                    else {
                        var state = false;
                        for (var j = 0; j < list.length; j++) {
                            var lchild = list[j];
                            if (lchild && lchild[columnBind.prLeft] === item[columnBind.prLeft]) {
                                lchild[item[columnBind.prTop]] = item[columnBind.prValue];
                                if (itemsList.indexOf(item[columnBind.prTop]) === -1)
                                    itemsList.push(item[columnBind.prTop].toString());
                                state = true;
                            }
                        }
                        if (!state) {
                            var colState = false;
                            if (!newData.hasOwnProperty(item[columnBind.prLeft])) {
                                newData[columnBind.prLeft] = item[columnBind.prLeft];
                                list.push(newData);
                                colState = true;
                            }
                            if (colState) {
                                newData[item[columnBind.prTop].toString()] = item[columnBind.prValue];
                                if (itemsList.indexOf(item[columnBind.prTop]) === -1)
                                    itemsList.push(item[columnBind.prTop].toString());
                            }
                        }
                    }
                }
            }
        }
        return { dataTableMapping: list, items: itemsList };
    };
    return Heatmap;
}(ej.WidgetBase));
window.ej.widget("ejHeatMap", "ej.datavisualization.HeatMap", new Heatmap());
ej.datavisualization.HeatMap.CellVisibility = {
    Visible: "visible",
    Hidden: "hidden",
};
ej.datavisualization.HeatMap.Effect = {
    Slide: "slide",
    Fade: "fade",
    None: "none"
};
ej.datavisualization.HeatMap.Trigger = {
    Hover: "hover",
    Click: "click"
};
ej.datavisualization.HeatMap.Associate = {
    MouseFollow: "mouseFollow",
    MouseEnter: "mouseEnter",
    Target: "target"
};
ej.datavisualization.HeatMap.Horizontal = {
    Left: "left",
    Center: "center",
    Right: "right"
};
ej.datavisualization.HeatMap.Vertical = {
    Top: "top",
    Center: "center",
    Bottom: "bottom"
};
ej.datavisualization.HeatMap.TextAlign = {
    Right: "right",
    Left: "left",
    Center: "center",
};
ej.datavisualization.HeatMap.LegendMode = {
    Gradient: "gradient",
    List: "list",
};
ej.datavisualization.HeatMap.LegendOrientation = {
    Horizontal: "horizontal",
    Vertical: "vertical",
};
ej.datavisualization.HeatMap.TextDecorations = {
    Underline: "underline",
    Overline: "overline",
    LineThrough: "line-through",
    None: "none"
};
"use strict";
var HeatmapLegend = (function (_super) {
    __extends(HeatmapLegend, _super);
    function HeatmapLegend(element, options) {
        _super.call(this);
        this.defaults = {
            colorMappingCollection: null,
            orientation: ej.datavisualization.HeatMap.LegendOrientation.Horizontal,
            showLabel: true,
            legendMode: "gradient",
            height: null,
            width: null,
            isResponsive: false,
            enableRTL: false,
        };
        this.validTags = ['div'];
        this._rootCSS = "e-heatmaplegend";
        this._id = "";
        this.setFirst = false;
        this.PluginName = "ejHeatMapLegend";
        this.id = "null";
        this.model = null;
        this.dataTypes = {
            colorMappingCollection: "data"
        };
        this._tags = [
            {
                tag: "colorMappingCollection",
                attr: [
                    "value",
                    "color",
                    "label.bold",
                    "label.italic",
                    "label.text",
                    "label.textDecoration",
                    "label.fontSize",
                    "label.fontFamily",
                    "label.fontColor",
                ],
                singular: "colorMapping"
            }
        ];
        if (element) {
            if (!element["jquery"])
                element = $("#" + element);
            if (element.length) {
                return $(element).ejHeatMapLegend(options).data(this.PluginName);
            }
        }
    }
    HeatmapLegend.prototype._init = function () {
        this._initLegendData();
        this._wireEvents();
        this._renderLegend();
    };
    HeatmapLegend.prototype._setLabel = function (options) {
        var label = options ? options : {};
        label.bold = (label && label.bold !== undefined) ? label.bold : false;
        label.italic = (label && label.italic !== undefined) ? label.italic : false;
        label.text = (label && label.text) ? label.text : "";
        label.textDecoration = (label && label.textDecoration) ? label.textDecoration : ej.datavisualization.HeatMap.TextDecorations.None;
        label.fontSize = (label && label.fontSize) ? label.fontSize : 10;
        label.fontFamily = (label && label.fontFamily) ? label.fontFamily : "Arial";
        label.fontColor = (label && label.fontColor) ? label.fontColor : "black";
        return label;
    };
    HeatmapLegend.prototype._initLegendData = function () {
        this.model.colorMappingCollection = this._getSortedMappingList(this.model.colorMappingCollection);
        for (var i = 0; i < this.model.colorMappingCollection.length; i++)
            this.model.colorMappingCollection[i].label = this._setLabel(this.model.colorMappingCollection[i].label);
    };
    HeatmapLegend.prototype._wireEvents = function () {
        this._on($(window), "resize", this._updateLegendSize);
        $(this.element[0].parentNode).scroll($.proxy(this._hideLegendMarker, this));
    };
    HeatmapLegend.prototype._hideLegendMarker = function (args) {
        var triangles = $(".gradient_scale_marker");
        for (var triangle in triangles)
            if (triangles[triangle] && triangles[triangle].parentNode) {
                triangles[triangle].parentNode.removeChild(triangles[triangle]);
            }
    };
    HeatmapLegend.prototype._scrollElement = function () {
        var triangle = $("#" + this._id + "_gradient_scale_marker")[0];
        if (triangle) {
            triangle.parentNode.removeChild(triangle);
        }
    };
    HeatmapLegend.prototype._getLargerGradientLabel = function () {
        var rect1, bounds = { left: 0, top: 0, width: 0, height: 0 };
        var clrCollection = this.model.colorMappingCollection;
        for (var i = 0; clrCollection && i < clrCollection.length; i++) {
            var child = clrCollection[i];
            var span = document.createElement("span");
            this.element[0].appendChild(span);
            this._mergeLabelProperties(span, child);
            if (child.label) {
                rect1 = this._getBoundingClientRect(span);
                bounds = this._union(bounds, rect1);
            }
            span.parentNode.removeChild(span);
        }
        return bounds;
    };
    HeatmapLegend.prototype._getBoundingClientRect = function (element) {
        var rect = element.getBoundingClientRect();
        if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") {
            rect = { left: rect.left < 0 ? 0 : rect.left, top: rect.top < 0 ? 0 : rect.top, right: rect.right < 0 ? 0 : rect.right, bottom: rect.bottom < 0 ? 0 : rect.bottom, width: $(element).outerWidth(), height: $(element).outerHeight() };
        }
        return { left: rect.left < 0 ? 0 : rect.left, top: rect.top < 0 ? 0 : rect.top, right: rect.right < 0 ? 0 : rect.right, bottom: rect.bottom < 0 ? 0 : rect.bottom, width: rect.width, height: rect.height };
    };
    HeatmapLegend.prototype._getSpace = function (resize) {
        var lBBox = this._getLargerGradientLabel();
        var bbox = this._getBoundingClientRect(this.element[0]);
        bbox = { bottom: bbox.bottom, height: bbox.height - (lBBox.height / 2 + 2), left: bbox.left, right: bbox.right, top: bbox.top, width: this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal ? bbox.width - 10 : bbox.width };
        if (this.model.legendMode === ej.datavisualization.HeatMap.LegendMode.Gradient)
            this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal ? bbox.width = bbox.width - lBBox.width / 2 : bbox.height = bbox.height - lBBox.height / 2;
        return bbox;
    };
    HeatmapLegend.prototype._renderLegend = function () {
        var gridLegend = $("#" + this.element[0].id)[0];
        if (gridLegend) {
            $("div." + this.element[0].id).find("*").removeAttr("style");
            $("#" + this.element[0].id).empty();
        }
        var height = this.model.height ? this.model.height : "100%";
        var width = this.model.width ? this.model.width : "100%";
        $("#" + this.element[0].id).attr("role", "heatmap-legend").css("height", height).css("width", width).css("overflow", "hidden");
        var size = this._getSpace(null);
        if (this.model.legendMode === ej.datavisualization.HeatMap.LegendMode.Gradient) {
            this._renderGradient(size, gridLegend, null);
        }
        else
            this._renderList(size, gridLegend, null);
    };
    HeatmapLegend.prototype._mergeLabelProperties = function (element, colorMap) {
        if (element && colorMap && colorMap.label) {
            var label = colorMap.label;
            if (label) {
                element.innerHTML = (this.model.legendMode !== "gradient" && label.text) ? label.text : colorMap.value;
                element.style.fontFamily = label.fontFamily;
                element.style.fontSize = label.fontSize + "px";
                element.style.fontColor = label.fontColor;
                element.style.textDecoration = label.textDecoration;
                if (label.bold)
                    element.style.fontWeight = "bold";
                else
                    element.style.fontWeight = "";
                if (label.italic)
                    element.style.fontStyle = "italic";
                else
                    element.style.fontStyle = "";
            }
        }
    };
    HeatmapLegend.prototype._union = function (rect1, rect2) {
        var left = Math.min(rect1.left, rect2.left);
        var top = Math.min(rect1.top, rect2.top);
        var width = Math.max(rect1.width, rect2.width);
        var height = Math.max(rect1.height, rect2.height);
        return { left: left, top: top, width: width - left, height: height - top };
    };
    HeatmapLegend.prototype._updateLegendSize = function (update) {
        if (this.model.isResponsive) {
            var height = this.model.height ? this.model.height : "100%";
            var width = this.model.width ? this.model.width : "100%";
            var gridLegend = $("#" + this.element[0].id)[0];
            var size = this._getSpace(true);
            if (this.model.legendMode === ej.datavisualization.HeatMap.LegendMode.Gradient) {
                this._renderGradient(size, gridLegend, update);
            }
            else {
                this._renderList(size, gridLegend, update);
            }
        }
    };
    HeatmapLegend.prototype._renderListBox = function (legend, id, colorMap, width, height, lastlist) {
        var div = $("#" + id)[0];
        if (!div) {
            div = document.createElement("div");
            div.setAttribute("id", id);
            this.model.enableRTL ? $(legend).prepend(div) : legend.appendChild(div);
            div.setAttribute("style", "height:auto;height:auto;float:left;vertical-align: middle;");
        }
        div.setAttribute("role", "list");
        var style = "";
        var listdiv = $("#" + div.id + "_colordiv_")[0];
        if (!listdiv) {
            listdiv = document.createElement("div");
            listdiv.setAttribute("id", div.id + "_colordiv_");
            div.appendChild(listdiv);
        }
        style = "background-color:" + colorMap.color + ";";
        listdiv.setAttribute("style", style + "height:" + height + "px;width:" + width + "px;float:left");
        if (this.model.showLabel) {
            var lBBox = this._getBoundingClientRect(div);
            var spanDiv = $("#" + div.id + "_labelSpan_")[0];
            if (!spanDiv) {
                spanDiv = document.createElement("span");
                spanDiv.setAttribute("id", div.id + "_labelSpan_");
                spanDiv.setAttribute("aria-label", "label");
                spanDiv.setAttribute("class", "sf-ht-label");
                spanDiv.innerHTML = colorMap.label && colorMap.label.text ? colorMap.label.text : colorMap.value;
                div.appendChild(spanDiv);
            }
            spanDiv.setAttribute("style", "float:left;margin-left:3px;margin-right:3px;margin-right:3px;margin-bottom:3px;");
            this._mergeLabelProperties(spanDiv, colorMap);
            var sBBBox = this._getBoundingClientRect(spanDiv);
            spanDiv.style.marginTop = ((lBBox.height / 2) - (sBBBox.height / 2)) + "px";
        }
        if (this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal) {
            div.style.margin = "10px";
        }
        else {
            if (!lastlist || this.model.enableRTL) {
                if (!$("#" + div.id + "_colordiv_br")[0])
                    $(div).after("<div id=" + div.id + "_colordiv_br" + "> </br></br></div> ");
            }
        }
    };
    HeatmapLegend.prototype._renderList = function (size, legend, update) {
        var div = $("#" + legend.id + "_list")[0];
        if (!div) {
            div = document.createElement("div");
            div.setAttribute("id", legend.id + "_list");
            legend.appendChild(div);
            div.setAttribute("style", "height:auto;height:auto;float:left;");
        }
        else if (update) {
            div.innerHTML = "";
        }
        var colorMapping = this.model.colorMappingCollection;
        for (var i = 0; i < colorMapping.length; i++) {
            this._renderListBox(div, legend.id + "_listBox_" + i, colorMapping[i], 15, 15, i === colorMapping.length - 1 ? true : false);
        }
        var legBBox = this._getBoundingClientRect(legend);
        var bbox = this._getBoundingClientRect(div);
        var left = legBBox.width / 2 - bbox.width / 2;
        div.style.marginLeft = left <= 0 ? "0px" : left + "px";
        var top = legBBox.height / 2 - bbox.height / 2;
        div.style.marginTop = top <= 0 ? "0px" : top + "px";
    };
    HeatmapLegend.prototype._setAttribute = function (element, attrs) {
        if (element) {
            for (var att in attrs) {
                element.setAttribute(att, attrs[att]);
            }
        }
    };
    HeatmapLegend.prototype._renderGradient = function (size, legend, update) {
        var grValdiv = $("#" + this.element[0].id + "_gradient_scale_line")[0];
        if (!grValdiv) {
            grValdiv = document.createElement("div");
            legend.appendChild(grValdiv);
        }
        var style1 = this.model.orientation === "horizontal" ? "" : "float:left;";
        if (this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal) {
            style1 += "height:" + (((40 / 100) * size.height) + ((20 / 100) * size.height)) + "px;width:" + (size.width) + "px; ";
        }
        else {
            style1 += "height:" + (size.height) + "px;width:" + (((40 / 100) * size.width) + ((20 / 100) * size.width)) + "px;";
        }
        var stlblBounds = this._getStartlabelOffset();
        if (this.model.orientation === "horizontal")
            style1 += "padding-left:" + stlblBounds.width + "px;";
        else
            style1 += "padding-top:" + (stlblBounds.height / 2 - 1) + "px;";
        grValdiv.setAttribute("style", style1);
        this._setAttribute(grValdiv, {
            "id": "#" + this.element[0].id + "_gradient_scale_line",
        });
        grValdiv.setAttribute("style", style1);
        var div = $("#" + this.element[0].id + "_gradient")[0];
        if (!div) {
            div = document.createElement("div");
            grValdiv.appendChild(div);
        }
        else if (update) {
            div.innerHTML = "";
        }
        this._setAttribute(div, {
            "id": this.element[0].id + "_gradient",
            "role": "gradient"
        });
        var background = "to right , ";
        var style = "float:left; ";
        if (this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal) {
            style += "height:" + ((40 / 100) * size.height - 2) + "px; width:" + (size.width) + "px; ";
        }
        else {
            background = "to bottom , ";
            style += "height:" + (size.height) + "px;width:" + ((40 / 100) * size.width - 2) + "px;";
        }
        div.setAttribute("style", style);
        this._renderGradientElements(div);
        this._renderGradientScale(size, grValdiv, update);
        this._renderGradientScaleValue(size, legend, update);
    };
    HeatmapLegend.prototype._renderGradientElements = function (div) {
        var ColorMapping = this.model.colorMappingCollection;
        var firstValue = Number(ColorMapping[0].value);
        var length = ColorMapping.length;
        var lastValue = Number(ColorMapping[ColorMapping.length - 1].value);
        if (length > 0) {
            var prevWidth = 0;
            var prevHeight = 0;
            var bbox = this._getBoundingClientRect(div);
            for (var i = 1; ColorMapping && i < length; i++) {
                {
                    var style = "float:left;border:none;";
                    var inGrad = $("#" + this.element[0].id + "_inner_gradient" + i)[0];
                    var tWidth = this._childElementsBounds(div).width ? this._childElementsBounds(div).width : 0;
                    if (!inGrad) {
                        inGrad = document.createElement("div");
                        this.model.enableRTL ? $(div).prepend(inGrad) : div.appendChild(inGrad);
                    }
                    if (this.model.orientation === "horizontal") {
                        var w = (((ColorMapping[i].value * 100) / lastValue));
                        var w1 = (bbox.width * (w / 100)) - prevWidth;
                        if (i === length - 1)
                            w1 = bbox.width - tWidth - 1;
                        style += "height:100%;width:" + w1 + "px;";
                        if (this.model.enableRTL) {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0" || ej.browserInfo().version === "9.0")
                                style += "filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=" + ColorMapping[i].color + ", endColorstr=" + ColorMapping[i - 1].color + ",GradientType=1 );";
                            else
                                style += "background:linear-gradient(to right ," + ColorMapping[i].color + ", " + ColorMapping[i - 1].color + ");";
                        }
                        else {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0" || ej.browserInfo().version === "9.0")
                                style += "filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=" + ColorMapping[i - 1].color + ", endColorstr=" + ColorMapping[i].color + ",GradientType=1 );";
                            else
                                style += "background:linear-gradient(to right ," + ColorMapping[i - 1].color + ", " + ColorMapping[i].color + ");";
                        }
                    }
                    else {
                        var h = (((ColorMapping[i].value * 100) / lastValue));
                        var h1 = (bbox.height * (h / 100)) - prevHeight;
                        style += "width:100%;height:" + h1 + "px;";
                        if (this.model.enableRTL) {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0" || ej.browserInfo().version === "9.0")
                                style += "filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=" + ColorMapping[i].color + ", endColorstr=" + ColorMapping[i - 1].color + ",GradientType=0 );";
                            else
                                style += "background:linear-gradient(to bottom ," + ColorMapping[i].color + ", " + ColorMapping[i - 1].color + ");";
                        }
                        else {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0" || ej.browserInfo().version === "9.0")
                                style += "filter: progid:DXImageTransform.Microsoft.gradient( startColorstr=" + ColorMapping[i - 1].color + ", endColorstr=" + ColorMapping[i].color + ",GradientType=0 );";
                            else
                                style += "background:linear-gradient(to bottom ," + ColorMapping[i - 1].color + ", " + ColorMapping[i].color + ");";
                        }
                    }
                    this._setAttribute(inGrad, {
                        "id": this.element[0].id + "_inner_gradient" + i,
                        "style": style
                    });
                    prevWidth = this._childElementsBounds(div).width;
                    prevHeight = this._childElementsBounds(div).height;
                }
            }
        }
    };
    HeatmapLegend.prototype._getStartlabelOffset = function () {
        var span = document.createElement("span");
        this.element[0].appendChild(span);
        var child = this.model.colorMappingCollection[0];
        this._mergeLabelProperties(span, child);
        var bounds = null;
        if (child.label) {
            bounds = this._getBoundingClientRect(span);
        }
        span.parentNode.removeChild(span);
        return bounds;
    };
    HeatmapLegend.prototype._renderGradientScaleValue = function (size, legend, update) {
        var div = $("#" + this.element[0].id + "_gradient_scale_value")[0];
        if (!div) {
            div = document.createElement("div");
            legend.appendChild(div);
        }
        else if (update) {
            div.innerHTML = "";
        }
        this._setAttribute(div, {
            "id": this.element[0].id + "_gradient_scale_value",
        });
        var style = "float:left;";
        if (this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal) {
            style += "width: 100%;";
        }
        else {
            style += "height:100%;width:" + 12 + "px;margin-left:2px;";
        }
        div.setAttribute("style", style);
        var colorMapping = this.model.colorMappingCollection;
        var bbox = this._getBoundingClientRect(div);
        var prevMargin = null;
        var stlblBounds = this._getStartlabelOffset();
        if (this.model.enableRTL) {
            for (var i = colorMapping.length - 1; i >= 0; i--)
                prevMargin = this._createGradientLabel(size, colorMapping[i], div, this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal ? true : false, i, prevMargin, i === 0 ? stlblBounds.width / 2 : 0, 0);
        }
        else {
            for (var i = 0; i < colorMapping.length; i++)
                prevMargin = this._createGradientLabel(size, colorMapping[i], div, this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal ? true : false, i, prevMargin, i === 0 ? stlblBounds.width / 2 : 0, 0);
        }
    };
    HeatmapLegend.prototype._createGradientLabel = function (size, colorMap, div, ishorizontal, i, prevMargin, sx, sy) {
        if (this.model.showLabel) {
            var bbox = this._getBoundingClientRect(div);
            var span = $("#" + this.element[0].id + "_gradient_scale_value" + colorMap.value)[0];
            if (!span) {
                span = document.createElement("span");
                div.appendChild(span);
            }
            span.setAttribute("id", this.element[0].id + "_gradient_scale_value" + colorMap.value);
            var style = "float:left;";
            style += "height:auto;";
            style += "width:auto;";
            span.setAttribute("style", style);
            span.innerHTML = colorMap.value;
            this._mergeLabelProperties(span, colorMap);
            var spanBBox = this._getBoundingClientRect(span);
            var colorMapping = this.model.colorMappingCollection;
            var lastValue = colorMapping[colorMapping.length - 1].value;
            var scrollValue = this._getScroll();
            var gdiv = $("#" + this.element[0].id + "_gradient")[0];
            var fValue = colorMapping[0].value;
            var lValue = colorMapping[colorMapping.length - 1].value;
            var diff = lValue - fValue;
            var x = 0, y = 0;
            if (gdiv)
                bbox = this._getBoundingClientRect(gdiv);
            if (ishorizontal) {
                if (this.model.enableRTL)
                    x = Math.round(ishorizontal ? (((lValue - colorMap.value) / diff) * bbox.width) : 0);
                else
                    x = Math.round(ishorizontal ? (((colorMap.value / diff) * bbox.width)) : 0);
                style += "margin-left:" + (x + (sx ? sx : 0) - (prevMargin && prevMargin.x ? prevMargin.x : 0)) + "px;";
            }
            else {
                if (this.model.enableRTL)
                    y = Math.round(((lValue - colorMap.value) / diff) * bbox.height);
                else
                    y = Math.round(((colorMap.value / diff) * bbox.height));
                style += "margin-top:" + (y + (i === 1 ? -3 : 0) + (sy ? sy : 0) - (prevMargin && prevMargin.y ? prevMargin.y : 0)) + "px;";
            }
            if (!ishorizontal) {
                x = 0;
            }
            else {
                y = 0;
            }
            span.setAttribute("style", style);
            span.setAttribute("aria-label", "label");
            span.setAttribute("class", "sf-ht-label");
            this._mergeLabelProperties(span, colorMap);
            var spanBox = this._getBoundingClientRect(span);
            return { x: x + spanBox.width + (sx ? (spanBox.width / 2) : 0), y: y + spanBox.height - (i === 0 ? 0 : 0) + (sy ? (spanBox.height / 2) : 0) };
        }
    };
    HeatmapLegend.prototype._renderGradientScale = function (size, legend, update) {
        var div = $("#" + this.element[0].id + "_gradient_scale")[0];
        if (!div) {
            div = document.createElement("div");
            legend.appendChild(div);
        }
        else if (update) {
            div.innerHTML = "";
        }
        this._setAttribute(div, {
            "id": this.element[0].id + "_gradient_scale",
        });
        var style = "float:left;";
        if (this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal) {
            style += "height:" + ((20 / 100) * size.height) + "px; width:" + (size.width) + "px; margin-top:2px;";
        }
        else {
            style += "height:" + (size.height) + "px;width:" + ((20 / 100) * size.width) + "px; margin-left:2px";
        }
        div.setAttribute("style", style);
        if (this.model.legendMode === ej.datavisualization.HeatMap.LegendMode.Gradient) {
            var colorMapping = this.model.colorMappingCollection;
            var bbox = this._getBoundingClientRect(div);
            var lastValue = colorMapping[colorMapping.length - 1].value;
            if (this.model.orientation === ej.datavisualization.HeatMap.LegendOrientation.Horizontal) {
                var preWidth = this._createValueLine(this.element[0].id + "_gradient_scale_first", true, size, "", div);
                for (var i = 1; i < colorMapping.length; i++) {
                    preWidth += this._createSpaceLine(this.element[0].id + i + "space", true, size, "", div, preWidth, colorMapping[i], i);
                    preWidth += this._createValueLine(this.element[0].id + i + "value", true, size, "", div);
                }
            }
            else {
                var preWidth = this._createValueLine(this.element[0].id + "_gradient_scale_first", false, size, "", div);
                for (var i = 1; i < colorMapping.length; i++) {
                    preWidth += this._createSpaceLine(this.element[0].id + i + "space", false, size, "", div, preWidth, colorMapping[i], i);
                    preWidth += this._createValueLine(this.element[0].id + i + "value", false, size, "", div);
                }
            }
        }
    };
    HeatmapLegend.prototype._childElementsBounds = function (element) {
        var childNodes = element.childNodes;
        var rect = { left: 0, top: 0, right: 0, bottom: 0, width: 0, height: 0 };
        var rect1;
        if (childNodes.length > 0) {
            for (var i = 0; i < childNodes.length; i++) {
                if (childNodes[i]) {
                    rect1 = this._getBoundingClientRect(childNodes[i]);
                    if (rect1) {
                        rect.width += rect1.width;
                        rect.height += rect1.height;
                    }
                }
            }
        }
        return rect;
    };
    ;
    HeatmapLegend.prototype._createSpaceLine = function (id, isHorizontal, size, cStyle, div, preWidth, colorMap, i) {
        var bbox = this._getBoundingClientRect(div);
        var childBounds = this._childElementsBounds(div);
        var line = $("#" + id)[0];
        if (!line) {
            line = document.createElement("div");
            line.setAttribute("id", id);
            this.model.enableRTL ? $(div).prepend(line) : div.appendChild(line);
        }
        var style = "float:left;";
        style += "border: 1px solid gray; ";
        var colorMapping = this.model.colorMappingCollection;
        var fValue = colorMapping[0].value;
        var lValue = colorMapping[colorMapping.length - 1].value;
        var diff = lValue - fValue;
        var width = isHorizontal ? ((colorMap.value / diff) * bbox.width) : 0;
        if (i === 1 || i === colorMapping.length - 1)
            width -= 5;
        else
            width -= 4;
        if (isHorizontal)
            width -= childBounds.width;
        var height = Math.round(isHorizontal ? 0 : (((colorMap.value / diff) * bbox.height) - (i === 1 ? 6 : 4)));
        if (!isHorizontal)
            height -= preWidth;
        style += "height:" + Math.floor(height) + "px;";
        style += "width:" + Math.floor(width) + "px;";
        line.setAttribute("style", style);
        var lineBBox = this._getBoundingClientRect(line);
        return isHorizontal ? lineBBox.width : lineBBox.height;
    };
    HeatmapLegend.prototype._createValueLine = function (id, isHorizontal, size, cStyle, div) {
        var bbox = this._getBoundingClientRect(div);
        var line = $("#" + id)[0];
        if (!line) {
            line = document.createElement("div");
            line.setAttribute("id", id);
            this.model.enableRTL ? $(div).prepend(line) : div.appendChild(line);
        }
        var style = "float:left;";
        var width = isHorizontal ? 0 : bbox.width;
        var height = isHorizontal ? bbox.height : 0;
        style += "height:" + height + "px;";
        style += "width:" + width + "px;";
        style += "border: 1px solid gray; ";
        if (cStyle)
            style += cStyle;
        line.setAttribute("style", style);
        var lineBBox = this._getBoundingClientRect(line);
        return isHorizontal ? lineBBox.width : lineBBox.height;
    };
    HeatmapLegend.prototype._getScroll = function () {
        if (window.pageYOffset !== undefined) {
            return { x: pageXOffset ? pageXOffset : 0, y: pageYOffset ? pageYOffset : 0 };
        }
        else {
            var sx = void 0, sy = void 0, d = document, r = d.documentElement, b = d.body;
            sx = r.scrollLeft || b.scrollLeft || 0;
            sy = r.scrollTop || b.scrollTop || 0;
            return { x: sx ? sx : 0, y: sy ? sy : 0 };
        }
    };
    HeatmapLegend.prototype._getSortedMappingList = function (list) {
        if (list) {
            for (var i = 0; i < list.length; i++) {
                for (var j = i + 1; j < list.length; j++) {
                    if (Number(list[i].value) > Number(list[j].value)) {
                        var temp = list[i];
                        list[i] = list[j];
                        list[j] = temp;
                    }
                }
            }
            return list;
        }
    };
    HeatmapLegend.prototype._setModel = function (options) {
        for (var item in options) {
            switch (item) {
                case "colorMappingCollection":
                    this.model.colorMappingCollection = options.colorMappingCollection ? options.colorMappingCollection : this.model.colorMappingCollection;
                    this.model.colorMappingCollection = this._getSortedMappingList(this.model.colorMappingCollection);
                    var i = 0;
                    for (; i < this.model.colorMappingCollection.length; i++)
                        this.model.colorMappingCollection[i].label = this._setLabel(this.model.colorMappingCollection[i].label);
                    this._updateLegendSize(true);
                    break;
                case "legendMode":
                    this._renderLegend();
                    break;
            }
        }
    };
    return HeatmapLegend;
}(ej.WidgetBase));
window.ej.widget("ejHeatMapLegend", "ej.datavisualization.HeatMapLegend", new HeatmapLegend());
;
(function ($, ej, undefined) {
    "use strict"
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.common = {
        
        refreshContent: function (refreshTemplate) {
            if (refreshTemplate) {
                this.refreshTemplate();
                this.refreshHeader();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                this._renderFilterBarTemplate();
            var args = {};
            this._initialRenderings();
            args.requestType = ej.Grid.Actions.Refresh;
            if (this.model.scrollSettings.enableVirtualization) {
                this._refreshVirtualViewData();
                this._virtualDataRefresh = true;
            }
            this._processBindings(args);
        },

        
        rowHeightRefresh: function () {
            if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.model.currentViewData) && this.model.currentViewData.length) {
                var frozenRows = this.getContentTable().get(0).rows;
                var movableRows = this.getContentTable().get(1).rows, height = 0;
                if (this.getContent().find(".e-frozencontentdiv").is(":visible"))
                    for (var i = 0; i < frozenRows.length; i++) {
                        if ($(frozenRows[i]).css("display") == "none")
                            continue;
                        var frozenHeight = frozenRows[i].getClientRects()[0].height;
                        var movableHeight = movableRows[i].getClientRects()[0].height;
                        if (ej.isNullOrUndefined(frozenHeight) || ej.isNullOrUndefined(movableHeight))
                            height = ej.max([frozenRows[i].offsetHeight, movableRows[i].offsetHeight]);
                        else
                            height = ej.max([frozenHeight, movableHeight]);
                        $(frozenRows[i]).height(height); $(movableRows[i]).height(height);
                        if (i && (i == this.model.scrollSettings.frozenRows - 1 || i == frozenRows.length - 1))
                            height = height + 1;
                        if (!this.model.allowTextWrap) {
                            if (!i || i == this.model.scrollSettings.frozenRows - 1)
                                height = height - 1;
                        }
                        if (this.model.isEdit && $(frozenRows[i]).find("#" + this._id + "EditForm").length && i)
                            $(frozenRows[i]).find("#" + this._id + "EditForm td").css("height", height); $(movableRows[i]).find("#" + this._id + "EditForm td").css("height", height);
                    }
                if (this.model.showSummary && this.model.summaryRows.length > 0) {
                    var frozenFooterRows = this.getFooterTable().get(0).rows;
                    var movableFooterRows = this.getFooterTable().get(1).rows, footerHeight = 0;
                    for (var j = 0; j < frozenFooterRows.length ; j++) {
                        footerHeight = ej.max([frozenFooterRows[j].getClientRects()[0].height, movableFooterRows[j].getClientRects()[0].height]);
                        $(frozenFooterRows[j]).height(footerHeight); $(movableFooterRows[j]).height(footerHeight);
                    }
                }
                this._getRowHeights()
                if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && (this.getScrollObject()._vScrollbar != null || this.getScrollObject().isVScroll())) {
                    var scroller = this.getScrollObject()._vScrollbar;
                    if (ej.isNullOrUndefined(scroller) || scroller.value() != scroller.model.maximum)
						this._scrollObject.refresh(this.model.scrollSettings.frozenColumns > 0);                        
                }

            }
        },
                
        dataSource: function (dataSource, templateRefresh) {
            if (templateRefresh)
                this._templateRefresh = true;
            this._dataSource(dataSource);
			if(!this.model.scrollSettings.enableVirtualization){
				this._currentPage(1);
			}
			this._updateDataSource = true;
			this._refreshDataSource(dataSource, templateRefresh);			
			if (this.model.allowPaging || this.model.scrollSettings.allowVirtualScrolling) {
			    var model = this._refreshVirtualPagerInfo();
			    this._showPagerInformation(model);
			}
            if (this.model.scrollSettings.allowVirtualScrolling) {
				if(this.model.scrollSettings.enableVirtualization && this._isLocalData)
					this._refreshVirtualView(); 
				else
					this._refreshVirtualContent(); 
                if (this.getContent().ejScroller("isHScroll"))
                    this.getContent().ejScroller("scrollX", 0, true);
                if (this.getContent().ejScroller("isVScroll")) {
					if(!this.model.scrollSettings.enableVirtualization)
						this.getContent().ejScroller("scrollY", 0, true);
                    this.element.find(".e-gridheader").addClass("e-scrollcss");
                }
                else
                    this.element.find(".e-gridheader").removeClass("e-scrollcss");
            }
			if(!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount)
				this._addLastRow();
			this._trigger("dataBound", {});
        },
        _refreshDataSource: function (dataSource, refreshTemplate) {
            if (dataSource instanceof ej.DataManager)
                this._dataManager = dataSource;
            else
                this._dataManager = ej.DataManager(dataSource);
			this._isRemoteSaveAdaptor = (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.remoteSaveAdaptor);
            this._isLocalData = (!(this._dataSource() instanceof ej.DataManager) || (this._dataManager.dataSource.offline || this._isRemoteSaveAdaptor || this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor));
			if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
				this._refreshVirtualViewData();
				this._virtualDataRefresh = true;
				this._isLocalData && this._refreshVirtualViewDetails(true);
			}
			this.refreshContent(ej.isNullOrUndefined(refreshTemplate) ? true : refreshTemplate);
            if (!ej.isNullOrUndefined(this.getPager())) {
                this.getPager().ejPager("model.currentPage", 1);
                this._refreshGridPager();
            }
        },
        
        hideColumns: function (c) {
            var i, count = 0, args = {}, index, colIndex, newHideCol = []; var htext, field, hiddenFrozenCount = 0;
            htext = typeof (c) == "string" ? this.getColumnByHeaderText(c) : this.getColumnByHeaderText(c[0]);
			colIndex = typeof (c) == "number"? this.getColumnByIndex(c) : this.getColumnByIndex(c[0]);
            field = typeof (c) == "string" ? this.getColumnByField(c) : this.getColumnByField(c[0]);
            this._showHideColumns = true;
            var duparr = this._isDuplicate($.merge($.merge([], this._visibleColumns), this._hiddenColumns));
            var hidden = !duparr ? "_hiddenColumns" : "_hiddenColumnsField";
            var visible = !duparr ? "_visibleColumns" : "_visibleColumnsField";
			if (!duparr && (field != null || colIndex != null)){
                if ($.isArray(c)) {
                    for (var i = 0; i < c.length; i++) {
                      var cfield = (colIndex != null) ? this.getColumnByIndex(c[i]):this.getColumnByField(c[i]); 
                        c[i] = cfield != null ? cfield.headerText : c[i];
                    }
                }
                else
                    c = (colIndex != null) ? colIndex.headerText: field.headerText;
            }
		    var getColumnMethod = (colIndex != null) ? "getColumnByIndex": "getColumnByHeaderText";
            if ($.isArray(c)) {
                for (i = 0; i < c.length; i++) {
                    index = $.inArray(c[i], this[visible]);
                    
                    if (index != -1) {
                        this[hidden].push(c[i]);
                        this[visible].splice(index, 1);
                    }
					else if(index==-1 && visible=="_visibleColumnsField" && $.inArray(c[i],this[hidden])==-1 && ej.isNullOrUndefined(this.getColumnByField(c[i]))){
					    this[hidden].push(this[getColumnMethod](c[i]).field) && this["_hiddenColumns"].push(this[getColumnMethod](c[i]).field);
					    this[visible].splice($.inArray(this[getColumnMethod](c[i]).field, this[visible]), 1) && this["_visibleColumns"].splice($.inArray(c[i], this["_visibleColumns"]), 1);
					 }
				}
            } else {
                index = $.inArray(c, this[visible]);
                if (index != -1) {
                    this[hidden].push(c);
                    this[visible].splice(index, 1);
                }
				else if(index==-1 && visible=="_visibleColumnsField" && $.inArray(c,this[hidden])==-1 && ej.isNullOrUndefined(this.getColumnByField(c))){
				    this[hidden].push(this[getColumnMethod](c).field) && this["_hiddenColumns"].push(this[getColumnMethod](c).field);
				    this[visible].splice($.inArray(this[getColumnMethod](c).field, this[visible]), 1) && this["_visibleColumns"].splice($.inArray(c, this["_visibleColumns"]), 1);
				}
            }
            for (i = 0; i < this.model.columns.length; i++) {
                var com = !duparr ? "headerText" : "field";
                if ($.inArray(ej.isNullOrUndefined(this.model.columns[i][com]) || this.model.columns[i][com] == "" ? this.model.columns[i]["headerText"] : this.model.columns[i][com], this[hidden]) != -1) {
                    this.model.columns[i].visible && newHideCol.push(this.model.columns[i]);
                    this.model.columns[i].visible = false;
                    if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0 && this.model.columns.indexOf(this.model.columns[i]) < this.model.scrollSettings.frozenColumns)
                        hiddenFrozenCount++;
                    count++;
                }
                if (this[hidden].length == count)
                    break;
            }
            args.requestType = "refresh";
            this._hideHeaderColumn(this[hidden], duparr);
            if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0) {
                var $table = this._renderGridHeader();
                this.element.find('.e-gridheader').replaceWith($table[0])
                if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") this._renderFiltering();
                if (this.model.allowReordering)
                   this._headerCellreorderDragDrop();
            }
            this.refreshTemplate();
            if (this.model.scrollSettings.allowVirtualScrolling)
                this._virtualShowHide(args);
            if(this._isAddNew && this.model.isEdit){
                this.model.query = this.commonQuery.clone();
                this._ensureDataSource(args);
                this._isAddNew = false;
            }
            this.sendDataRenderingRequest(args);
            this.rowHeightRefresh();
            if (this.model.allowScrolling) {
                if (this.model.scrollSettings.frozenColumns == 0 && !ej.isIOSWebView() && this.getBrowserDetails().browser == "msie") {
                    var tableWidth = this._calculateWidth();
                    this.getHeaderTable().width(tableWidth);
                    this.getContentTable().width(tableWidth);
                }
                if (!ej.isNullOrUndefined(this._scrollObject))
                this.getScrollObject().refresh();
            }
            if (this.model.showColumnChooser)
                this._refreshColumnChooserList();
             if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0) {
				if(hiddenFrozenCount == this.model.scrollSettings.frozenColumns){
				    this._frozenPaneRefresh();
				}				
                 this.getScrollObject().refresh();
             }
			this._showHideColumns = false;
        },
        
        showColumns: function (c) {
            var i, count = 0, args = {}, index, colIndex, column, newVisColumns = []; var htext, field;
            htext = typeof (c) == "string" ? this.getColumnByHeaderText(c) : this.getColumnByHeaderText(c[0]);
			colIndex = typeof (c) == "number"? this.getColumnByIndex(c) : this.getColumnByIndex(c[0]);
            field = typeof (c) == "string" ? this.getColumnByField(c) : this.getColumnByField(c[0]);
            
			this._showHideColumns = true;
            var duparr = this._isDuplicate($.merge($.merge([], this._visibleColumns), this._hiddenColumns));//updated for
            var hidden = !duparr ? "_hiddenColumns" : "_hiddenColumnsField";
            var visible = !duparr ? "_visibleColumns" : "_visibleColumnsField";
			if (!duparr && (field != null || colIndex != null)){
                if ($.isArray(c)) {
                    for (var i = 0; i < c.length; i++) {
                      var cfield = (colIndex != null) ? this.getColumnByIndex(c[i]):this.getColumnByField(c[i]); 
                        c[i] = cfield != null ? cfield.headerText : c[i];
                    }
                }
                else
                    c = (colIndex != null) ? colIndex.headerText: field.headerText;
             }
		    var getColumnMethod = (colIndex != null) ? "getColumnByIndex": "getColumnByHeaderText";
            if ($.isArray(c)) {
                for (i = 0; i < c.length; i++) {
                    index = $.inArray(c[i], this[hidden]);
                    
                    if (index != -1) {
                        this[hidden].splice(index, 1);
                        this[visible].push(c[i]);
                    }
					else if(index==-1 && hidden=="_hiddenColumnsField" && $.inArray(c[i],this[visible])==-1 && ej.isNullOrUndefined(this.getColumnByField(c[i]))){
					    this[visible].push(this[getColumnMethod](c[i]).field) && this["_visibleColumns"].push(c[i]);
					    this[hidden].splice($.inArray(this[getColumnMethod](c[i]).field, this[hidden]), 1) && this["_hiddenColumns"].splice($.inArray(c[i], this["_hiddenColumns"]), 1);
					}
                }
            } else {
                index = $.inArray(c, this[hidden]);
                if (index != -1) {
                    this[hidden].splice(index, 1);
                    this[visible].push(c);
                }
				else if(index==-1 && hidden=="_hiddenColumnsField" && $.inArray(c,this[visible])==-1 && ej.isNullOrUndefined(this.getColumnByField(c))){
				    this[visible].push(this[getColumnMethod](c).field) && this["_visibleColumns"].push(c);
				    this[hidden].splice($.inArray(this[getColumnMethod](c).field, this[hidden]), 1) && this["_hiddenColumns"].splice($.inArray(c, this["_hiddenColumns"]), 1);
				}
            }
            for (i = 0; i < this.model.columns.length; i++) {
                var com = !duparr ? "headerText" : "field";
                if ($.inArray(ej.isNullOrUndefined(this.model.columns[i][com]) || this.model.columns[i][com] == "" ? this.model.columns[i]["headerText"] : this.model.columns[i][com], this[visible]) != -1) {
                    !this.model.columns[i].visible && newVisColumns.push(this.model.columns[i])
                    this.model.columns[i].visible = true;
                    count++;
                }
                if (this[visible].length == count)
                    break;
            }


            if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0) {
                var frozenHide = false;
                for (var i = 0; i < newVisColumns.length; i++) {
                    var index = this.model.columns.indexOf(newVisColumns[i]);
                    if (index < this.model.scrollSettings.frozenColumns)
                        frozenHide = true;
                }
                if (frozenHide) {
					for(var i = 0; i < this.model.columns.length; i++){
						if($.inArray(this.model.columns[i].headerText, this["_hiddenColumns"]) != -1)
							this.model.columns[i].visible = false;
						else if($.inArray(this.model.columns[i].headerText, this["_visibleColumns"]) != -1)
							this.model.columns[i].visible = true;
					}
                    var $table = this._renderGridHeader();
                    this.element.find('.e-gridheader').replaceWith($table[0])
                    if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") this._renderFiltering();
                    if (this.model.allowReordering)
                        this._headerCellreorderDragDrop();
                }
            }

            args.requestType = "refresh";
            this._showHeaderColumn(this[visible], duparr);

            this.refreshTemplate();
            if (this.model.scrollSettings.allowVirtualScrolling)
                this._virtualShowHide(args);
            if (this._isAddNew && this.model.isEdit) {
                this.model.query = this.commonQuery.clone();
                this._ensureDataSource(args);
                this._isAddNew = false;
            }
            this.sendDataRenderingRequest(args);
            this.rowHeightRefresh();
            if (this.model.allowScrolling && !ej.isNullOrUndefined(this._scrollObject)) {
                this.getScrollObject().refresh();
            }
            if (this.model.showColumnChooser)
                this._refreshColumnChooserList();
			this._showHideColumns = false;
        },
        _virtualShowHide: function (args) {
            this._currentPage(1);
            this.model.query = this.commonQuery.clone();
            this._ensureDataSource(args);
            this._loadedJsonData = [];
            this._prevPage = this._currentPage();
        },
        
        resizeColumns: function (column, width) {
            if (column instanceof Array) {
                for (var i = 0; i < column.length; i++) {
                    var colWidth = width instanceof Array ? width[i] : width;
                    this._setWidthColumnCollection(column[i], colWidth);
                }
            }
            else
                this._setWidthColumnCollection(column, width);
            this.setWidthToColumns();
            if (this.model.scrollSettings.frozenColumns){
                this._frozenAlign();
                this.rowHeightRefresh();
            }
        },
        _setWidthColumnCollection: function (column, width) {
            var col = this.getColumnByHeaderText(column) || this.getColumnByField(column);
            col.width = width;
            if ($.inArray(col.field, this._disabledResizingColumns) == -1)
                this.columnsWidthCollection[$.inArray(col, this.model.columns)] = width;
        },
        
        refreshTemplate: function () {
            this.addInitTemplate();
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
				this._processEditing();
            }
            if (this.model.allowGrouping) this.addGroupingTemplate();
        },
        refreshHeader: function () {
            var $header = this.element.find(".e-gridheader");
            this.element[0].replaceChild(this._renderGridHeader()[0], $header[0]);           
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                this._renderFiltering();
            this.model.allowGrouping && this._headerCellgDragDrop(); 
            this.model.allowReordering && this._headerCellreorderDragDrop();
            this.model.showColumnChooser && this._renderColumnChooserData(true);
			if(this.model.gridLines != "both")
			    this._showHeaderGridLines();
			if (this.model.mergeHeaderCellInfo != null) {
			    this.setWidthToColumns();
			    var args = { columnHeaders: this.getHeaderContent().find(".e-columnheader"), model: this.model }, proxy = this;
			    this._headerCellMerge(args);
			    this._trigger("mergeHeaderCellInfo", args);
			}
        },        
        set_dropColumn: function (from, to) {
            if (this.model.allowReordering && from != to) {
                this.model.columns.splice(to, 0, this.model.columns.splice(from, 1)[0]);
                var columns = this.model.columns;
                var $header = this.getHeaderTable().find(".e-columnheader:last .e-headercell").not(".e-stackedHeaderCell");
                var $headerCell = $header.find(".e-headercelldiv");
                var scrollLeft = this.getHeaderContent().find("div").first().scrollLeft();
                if (!this.model.scrollSettings.frozenColumns)
                    this.getHeaderTable().find("colgroup").replaceWith(this._getMetaColGroup());
                (this.model.detailsTemplate != null || this.model.childGrid != null) && this.getHeaderTable().find("colgroup").prepend(this._getIndentCol());

                //Remove and Returns name/value pair of element attributes
                var removeAttr = function (ele) {
                    var names = []; if (ele == undefined) return;
                    if (["", undefined].indexOf(ele.value) == -1) {
                        names.push({ name: "value", value: ele.value }); ele.value = "";
                    }
                    for (var e = 0, eAttr = ele.attributes, eLen = eAttr.length; e < eLen; e++) {
                        var regex = /^jQuery[0-9]+$/;
                        !eAttr[e].name.match(regex) && names.push({ name: eAttr[e].name, value: eAttr[e].value });
                    }
                    for (var a = 0, aLen = names.length; a < aLen; a++) {
                        $(ele).removeAttr(names[a].name);
                    }
                    return names;
                };
                //Add attributes to the ele
                var addAttr = function (coll, ele) {
                    if (ele == undefined) return;
                    for (var e = 0, eLen = coll.length; e < eLen; e++) {
                        if (coll[e].name == "value") ele.value = coll[e].value;
                        $(ele).attr(coll[e].name, coll[e].value);
                    }
                };

                if (this.getHeaderTable().find(".e-fltrtempdiv").length == 0 && this.getHeaderTable().find(".e-filterdiv").length > 0)
                    var $filterCell = this.getHeaderTable().find(".e-filterdiv input");
                var $fState = ej.isNullOrUndefined($filterCell);
                var $attributeCollection = { "cellattributes": [], "headerattributes": [], "filtercellattributes": [], "filterThattributes": [] };
                var fromIndex = from < to ? from : to;
                var toIndex = from < to ? to : from;
                
                for (var i = fromIndex, j = 0; i <= toIndex; i++) {
                    var hIndx = (this.model.detailsTemplate != null || this.model.childGrid != null) ? i + 1 : i;
                    $attributeCollection.headerattributes[j] = removeAttr($header[hIndx]);
                    $attributeCollection.cellattributes[j] = removeAttr($headerCell[i]);
                    $attributeCollection.filtercellattributes[j] = !$fState ? removeAttr($filterCell[i]) : [];
                    $attributeCollection.filterThattributes[j] = !$fState ? removeAttr($($filterCell[i]).closest("th")[0]) : [];
                    j++;
                }

                var spliceFrom = from < to ? $attributeCollection.cellattributes.length - 1 : 0;
                var spliceTo = from < to ? 0 : $attributeCollection.cellattributes.length - 1;

                for (var prop in $attributeCollection)
                    $attributeCollection[prop].splice(spliceFrom, 0, $attributeCollection[prop].splice(spliceTo, 1)[0]);

                
                for (var i = fromIndex, j = 0; i <= toIndex; i++) {
                    var indx = (this.model.detailsTemplate != null || this.model.childGrid != null) ? i + 1 : i;
                    addAttr($attributeCollection.headerattributes[j], $header[indx]);
                    addAttr($attributeCollection.cellattributes[j], $headerCell[i]);
                    !$fState && addAttr($attributeCollection.filtercellattributes[j], $filterCell[i]);
                    !$fState && addAttr($attributeCollection.filterThattributes[j], $($filterCell[i]).closest("th")[0]);
                    j++;
                }
                if (this.model.allowFiltering && ["menu", "excel"].indexOf(this.model.filterSettings.filterType) != -1) {
                    if (this._$fDlgIsOpen)
                        this._closeFDialog();
                    var col = this.model.columns;
                    $header.find(".e-filtericon").remove();
                    for (var i = 0; i < col.length; i++) {
                        if (col[i]["allowFiltering"] || ej.isNullOrUndefined(col[i]["allowFiltering"])) {
                            var filterHeader = $header.find(".e-headercelldiv[ej-mappingname=" + col[i].field + "]").closest(".e-headercell")
                            filterHeader.append(ej.buildTag('div.e-filtericon e-icon e-filterset'));
                        }
                    }
                    this._refreshFilterIcon();
                }

                this.columnsWidthCollection.splice(to, 0, this.columnsWidthCollection.splice(from, 1)[0]);
                var headerCell;
                this._fieldColumnNames = this._headerColumnNames = [];
                for (var count = 0; count < columns.length; count++) {
                    this._fieldColumnNames[columns[count].headerText] = columns[count].field;
                    this._headerColumnNames[columns[count].field] = columns[count].headerText;
                    headerCell = $($headerCell[count]);
                    if (!ej.isNullOrUndefined(columns[count].headerTemplateID))
                        headerCell.html($(columns[count]["headerTemplateID"]).html());
                    else if (columns[count].type == "checkbox")
                        headerCell.html("<input type = 'checkbox' class = 'e-checkselectall'></input>");
                    else
                    columns[count].disableHtmlEncode ? headerCell.text(columns[count].headerText) : headerCell.html(columns[count].headerText);
                    if (this.model.groupSettings.showToggleButton && (ej.isNullOrUndefined(columns[count].allowGrouping) || columns[count].allowGrouping)) {
                        if ($.inArray(columns[count].field, this.model.groupSettings.groupedColumns) != -1)
                            headerCell.append(this._getToggleButton().addClass("e-toggleungroup"));
                        else
                            headerCell.append(this._getToggleButton().addClass("e-togglegroup"));
                    }
                }
                if (this.model.allowGrouping && this.model.allowSorting != true) {
                    for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                        this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
                }
                if (this.model.allowSorting) {
                    for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                        var opacity = 1;
                        var $sCol = this.model.sortSettings.sortedColumns[i];
                        var sortcolumn = this.getsortColumnByField($sCol.field);
                        var index = this.getColumnIndexByField($sCol.field);
                        var sortindex = $.inArray(sortcolumn, this.model.sortSettings.sortedColumns),
                        imageDirection = $sCol.direction != "descending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
                        if (this.model.allowMultiSorting) {
                            for (var j = 1; j <= sortindex; j++) {
                                opacity = opacity + 1;
                            }
                            if ($headerCell.eq(index).css("text-align") == "right") {
                                if(this.model.sortSettings.sortedColumns.length > 1)
                                    $headerCell.eq(index).prepend(this._createSortNumber(opacity, $headerCell.eq(index)).addClass("e-sortnumber"));
                                $headerCell.eq(index).append(this._createSortElement().addClass("e-" + ($sCol.direction || "ascending") + " " + imageDirection));
                            }
                            else {
                                $headerCell.eq(index).append(this._createSortElement().addClass("e-" + ($sCol.direction || "ascending") + " " + imageDirection));
                                if (this.model.sortSettings.sortedColumns.length > 1)
                                    $headerCell.eq(index).append(this._createSortNumber(opacity, $headerCell.eq(index)).addClass("e-sortnumber"));
                            }
                        }
                        else {
                            imageDirection = $sCol.direction != "descending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
                            $headerCell.eq(index).append(this._createSortElement().addClass("e-" + ($sCol.direction || "ascending") + " " + imageDirection));
                        }
                    }
                }
                if(this.getHeaderTable().find(".e-fltrtempdiv").length > 0 ){
                    this.getHeaderTable().find(".e-filterbar").first().remove();
					this._renderFiltering();
					this._renderFilterBarTemplate();
				}
                var args = {};
                args.requestType = ej.Grid.Actions.Reorder;
                this._isReorder = true;
                this.refreshTemplate();
				if(this._isAddNew && this.model.isEdit){
					this.model.query = this.commonQuery.clone();
					this._ensureDataSource(args);
					this._isAddNew = false;
				}
				this.setWidthToColumns();
				if (!this.model.scrollSettings.frozenColumns)
				    this.getHeaderContent().find("div").first().scrollLeft(scrollLeft);
                this.sendDataRenderingRequest(args);
                this._isReorder = false;
            }
        },
        
        getPager: function () {
            return this._gridPager;
        },
        
        getFooterTable: function () {
            return this._gridFooterTable;
        },

        setGridFooterTable: function (value) {
            this._gridFooterTable = value;
        },
        
        getFooterContent: function () {
            return this._gridFooterContent;
        },

        setGridFooterContent: function (value) {
            this._gridFooterContent = value;
        },
        
        getScrollObject: function () {
            if (this._scrollObject == null || ej.isNullOrUndefined(this._scrollObject.model))
                this._scrollObject = this.getContent().ejScroller("instance");
            return this._scrollObject;
        },
        setGridPager: function (value) {
            this._gridPager = value;
        },
        
        getRowHeight: function () {
            var rowHeight = -1;
			if (this.getContentTable() != null) {
				var trColl = this.getContentTable().find('tr:not(.e-virtualrow)'), index = trColl.length > 2 ? 1 : 0;
				if(trColl.length)
					var $trBound = trColl[index].getBoundingClientRect();
				if (trColl.length > 1) {
					if ($trBound && $trBound.height) {
						rowHeight = $trBound.height;
					} else
						rowHeight = trColl[index].offsetHeight;
				}
			}
			else if (!ej.isNullOrUndefined(this.model.rowTemplate) && !ej.isNullOrUndefined(this._dataSource()) && this._dataSource().length > 0) {
			    var temp = document.createElement('div');
			    var myTemplate = $.templates(this.model.rowTemplate);
			    var data = this._dataSource()[0];
			    temp.innerHTML = ['<table class="e-template-table">', myTemplate.render(data), '</table>'].join("");
			    $("body").append(temp.firstChild);
			    var tr = $("body").find(".e-template-table").find("tr")[0];
			    rowHeight = tr.offsetHeight;
			    $("body").find(".e-template-table").remove();
			}
            return rowHeight == -1 ? 32 : rowHeight;
        },
        
        getCurrentIndex: function () {
            return ((this._currentPage() - 1) * (this.model.pageSettings.pageSize));
        },
        
        getColumnByIndex: function (index) {
            if (index < this.model.columns.length)
                return this.model.columns[index];
            return null;
        },
        set_currentPageIndex: function (val) {
            var pageSetting = this.model.pageSettings;
            var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (pageSetting.totalPages == null)
                pageSetting.totalPages = Math.ceil(recordCount / pageSetting.pageSize);
            if (val > pageSetting.totalPages || val < 1 || val == this._currentPage())
                return false;
            if (ej.isNullOrUndefined(this._prevPageNo))
                this._prevPageNo = this._currentPage();
            this._currentPage(val);
            if (this._currentPage() != this._prevPageNo) {
                var args = {};
                args.requestType = "paging";
                this.gotoPage(this._currentPage(), args);
                return true;
            }
            else
                return false;
        },
        set_currentVirtualIndex: function (currentViewIndex) {                          
            if (currentViewIndex < 1 || (currentViewIndex != 1 && currentViewIndex != this._totalVirtualViews && currentViewIndex == this._currentVirtualIndex && this._checkCurrentVirtualView(this._virtualLoadedRows, currentViewIndex)))
                return false;                      
            this._prevVirtualIndex = this._currentVirtualIndex;							
            this._currentVirtualIndex = currentViewIndex;
			var currentPage = this._calculateCurrentViewPage();
			if(currentPage <= this.model.pageSettings.totalPages && !this._checkCurrentVirtualView(this._virtualLoadedRecords, this._currentVirtualIndex)){				
				if(this._prevVirtualIndex < currentViewIndex && currentViewIndex != 1){
					var setPage = this._isThumbScroll && currentPage != 1 ? currentPage : currentPage + 1;
                    if(!this._virtualPageRecords[setPage] && setPage <= this.model.pageSettings.totalPages)
                        this._setCurrentViewPage(setPage); 
					else	
						this._renderVirtulViewContent(currentPage);	
				}
				else if(this._prevVirtualIndex > currentViewIndex){
					var setPage = this._isThumbScroll ? currentPage : currentPage - 1;
                    if(this._virtualPageRecords[setPage] && !this._virtualLoadedRecords[currentViewIndex - 1])
                        setPage = currentPage - 1;
                    if(!this._virtualPageRecords[setPage] && setPage >= 1)
                        this._setCurrentViewPage(setPage);                                                     
				}                                                
                else 
                    this._renderVirtulViewContent(currentPage);
            }
            else 
                this._renderVirtulViewContent(currentPage);
            return true;            
        },
		_setCurrentViewPage: function(currentPage){
			this._needPaging = true;                
			this._prevPageNo = this._currentPage();             
            this.gotoPage(currentPage);
		},
		_renderVirtulViewContent: function(currentPage){
            this._needPaging = false;                      
            this._refreshVirtualView(this._currentVirtualIndex);
            this.element.ejWaitingPopup("hide");
        },
        _checkCurrentVirtualView: function(virtualContent, viewIndex){
            var virtualRowCount = this._virtualRowCount;            
            var prevView = viewIndex - 1, nextView = viewIndex + 1;
			if(virtualContent instanceof Array){
				if(virtualContent.length){
					if(((prevView == 0 || nextView == this._totalVirtualViews + 1) && $.inArray(viewIndex, virtualContent) != -1) || ($.inArray(prevView, virtualContent) != -1 && 
					$.inArray(viewIndex, virtualContent) != -1 && $.inArray(nextView, virtualContent) != -1))
						return true;					
				}				
			}
			else{
				var nextViewData = nextView == this._totalVirtualViews ? this._lastViewData : virtualRowCount;
				if((!this.initialRender && (viewIndex == 1 && this._virtualLoadedRows[viewIndex]) || viewIndex == this._totalVirtualViews && virtualContent == this._virtualLoadedRows && virtualContent[viewIndex]) ||
					((prevView == 0  && virtualContent[viewIndex] && virtualContent[viewIndex].length == virtualRowCount) || (nextView == this._totalVirtualViews + 1 && virtualContent[viewIndex] && virtualContent[viewIndex].length == this._lastViewData)) ||
					(virtualContent[prevView] && virtualContent[prevView].length == virtualRowCount && virtualContent[viewIndex] && virtualContent[viewIndex].length == virtualRowCount && virtualContent[nextView] && virtualContent[nextView].length == nextViewData))
						return true;								
			}
			return false;
        },
        expandCollapse: function ($target) {
            if ($target.prop("tagName") == "DIV" && ($target.parent().hasClass("e-recordplusexpand") || $target.parent().hasClass("e-recordpluscollapse") || $target.parent().hasClass("e-detailrowcollapse") || $target.parent().hasClass("e-detailrowexpand")))
                $target = $target.parent();
            var index = -1, fieldName, fieldValue, parentGroup, collapsed;
            if (this.model.allowGrouping && (ej.isOnWebForms || this.initialRender)) {
                fieldName = $target.attr("ej-mappingname");
                fieldValue = $target.attr("ej-mappingvalue");
                if ($target.parents(".e-tabletd").length)
                    parentGroup = $target.parents(".e-tabletd").parent("tr").prev("tr").find(".e-recordplusexpand").attr("ej-mappingvalue");
                collapsed = this.model._groupingCollapsed;
                for (var i = 0; i < collapsed.length; i++) {
                    if (collapsed[i].key == fieldName && collapsed[i].value == fieldValue && (collapsed[i].parent == undefined || collapsed[i].parent == parentGroup)) {
                        index = i;
                        break;
                    }
                }
            }
            if (!($target.hasClass("e-recordplusexpand") || $target.hasClass("e-recordpluscollapse") || $target.hasClass("e-detailrowcollapse") || $target.hasClass("e-detailrowexpand")))
                return;
            if ($target.hasClass("e-recordplusexpand") && this.model.groupSettings.groupedColumns.length) {
                var cellIndex = $target.index();
                var $rows = $target.closest('tr').next();
                $rows.hide();
                $target.removeClass("e-recordplusexpand").addClass("e-recordpluscollapse").find("div").removeClass("e-gdiagonalnext").addClass("e-gnextforward");
                if ((ej.isOnWebForms || this.initialRender) && index == -1)
                    this.model._groupingCollapsed.push({ key: fieldName, value: fieldValue, parent: parentGroup })
            } else if ($target.hasClass("e-recordpluscollapse") && this.model.groupSettings.groupedColumns.length) {
                var cellIndex = $target.index();
                var $rows = $target.closest('tr').next();
                var toExpandRows = [];
                var $row = $rows;
                if ($($row[0].cells[cellIndex]).hasClass("e-indentcell")) {
                    if ($row.children(".e-indentcell").length == ($target.parent().children('.e-indentcell').length) + 1) {
                        $row.show();
                        var $expand = $row.children(".e-recordplusexpand");
                        if ($expand != null && $expand.length > 0) {
                            toExpandRows.push($expand);
                        }
                    }
                }
                $target.removeClass("e-recordpluscollapse").addClass("e-recordplusexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                for (var i = 0; i < toExpandRows.length; i++) {
                    toExpandRows[i].removeClass("e-recordplusexpand").addClass("e-recordpluscollapse").find("div").removeClass("e-gdiagonalnext").addClass("e-gnextforward");
                    this.expandCollapse(toExpandRows[i]);
                }
                if ((ej.isOnWebForms || this.initialRender) && index != -1)
                    this.model._groupingCollapsed.splice(index, 1);
            } else if ($target.hasClass("e-detailrowexpand")) {
                var cellIndex = $target.index(), proxy = this;
                var rowIndexValue = this.getIndexByRow($target.closest('tr'));
                var $rows = $target.closest('tr').next();
                $rows.hide(0, function () {
                    var args = { masterRow: $target.closest('tr'), detailsRow: $rows, masterData: proxy._currentJsonData[rowIndexValue] };
                    var foreignKeyData = proxy._getForeignKeyData(args.masterData);
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    proxy._trigger("detailsCollapse", args);
                    proxy.model.childGrid != null && proxy.model.allowScrolling && proxy._refreshScroller({ requestType: "refresh" });
                });
                $target.removeClass("e-detailrowexpand").addClass("e-detailrowcollapse").find("div").addClass("e-gnextforward").removeClass("e-gdiagonalnext");
            } else if ($target.hasClass("e-detailrowcollapse")) {
                var cellIndex = $target.index(), proxy = this;
                var rowIndexValue = this.getIndexByRow($target.closest('tr'));
                var detailrow = $target.closest('tr').next();
                if (detailrow.hasClass("e-detailrow"))
                    $rows = detailrow;
                else {
                    var detailtr = ej.buildTag("tr.e-detailrow", "", { 'display': 'none' }, {});
                    var indenttd = ej.buildTag("td.e-detailindentcell");
                    var hideGroupColumnCount = !this.model.groupSettings.showGroupedColumn ? this.model.groupSettings.groupedColumns.length : 0;
                    var detailstd = ej.buildTag("td.e-detailcell", "", {}, { colspan: this._visibleColumns.length });
                    var detaildiv = ej.buildTag("div");
                    var count = $($target.closest('tr')).parents('.e-grid').length;
                    detaildiv.attr("id", "child" + count + "_grid" + rowIndexValue + Math.round(Math.random() * 1000));
                    $(detailtr).append(indenttd);
                    $(detailtr).append(detailstd);
                    var rowData = this._currentJsonData[rowIndexValue];
                    if (this.model.detailsTemplate)
                        $(detailtr).append(detailstd.append(this._renderEjTemplate(this.model.detailsTemplate, rowData, rowIndexValue)));
                    $($target.closest('tr')).after(detailtr);
                    if (this.model.childGrid) {
                        this.model.childGrid["parentDetails"] = {
                            parentID: this._id,
                            parentPrimaryKeys: this.getPrimaryKeyFieldNames(),
                            parentKeyField: this.model.childGrid.queryString,
                            parentKeyFieldValue: rowData[this.model.childGrid.queryString],
                            parentRowData: rowData
                        }
                        $(detailtr).append(detailstd.append(detaildiv));
                    }
                    $rows = detailtr;
                }
                this._showGridLines();
                var toExpandRows = [];
                var $row = $rows;
                if ($($row[0].cells[cellIndex]).hasClass("e-detailindentcell")) {
                    $row.show(0, function () {
                        var args = { masterRow: $target.closest('tr'), detailsRow: $rows, masterData: proxy._currentJsonData[rowIndexValue] };
                        var foreignKeyData = proxy._getForeignKeyData(args.masterData);
                        if (!ej.isNullOrUndefined(foreignKeyData))
                            args.foreignKeyData = foreignKeyData;
                        proxy._trigger("detailsExpand", args);
                        proxy.model.childGrid != null && proxy.model.allowScrolling && proxy._refreshScroller({ requestType: "refresh" });
                    });					
				    if (!detailrow.hasClass("e-detailrow")) {
                        this._trigger("detailsDataBound", { detailsElement: detailtr, data: rowData, rowData: rowData }); // $(tbody).append(trchild);
                       this._trigger("refresh");
                    }
                    this.model.childGrid && !ej.isNullOrUndefined(detaildiv) && detaildiv.ejGrid(this.model.childGrid);
                    var $expand = $row.children(".e-detailrowexpand");
                    if ($expand != null && $expand.length > 0) {
                        toExpandRows.push($expand);
                    }
                }
                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").addClass("e-gdiagonalnext").removeClass("e-gnextforward");
                for (var i = 0; i < toExpandRows.length; i++) {
                    toExpandRows[i].removeClass("e-detailrowexpand").addClass("e-detailrowcollapse").find("div").removeClass("e-gdiagonalnext").addClass("e-gnextforward");
                    this.expandCollapse(toExpandRows[i]);
                }
            }
            if (this.model.allowScrolling && !ej.isNullOrUndefined(this._scrollObject && this._scrollObject.model) && !$target.closest(".e-hscroll").length)
                this.getScrollObject().refresh();
            if (this.model.isResponsive)
                this.windowonresize();

        },
        _refreshGridPager: function () {
            if (this.getPager() != null) {
                var pagerModel = this.getPager().ejPager("model"), model = {};
                model.currentPage = this._currentPage();
                if (this._filteredRecordsCount == 0 && this.model.currentViewData.length == 0 && (ej.isNullOrUndefined(this._prevPageNo) || this._prevPageNo)) {
                    model.currentPage = 0;
                    this._prevPageNo = pagerModel.currentPage;
                    this.model.pageSettings.currentPage = 0;
                } else if (pagerModel.currentPage == 0 && (ej.isNullOrUndefined(this._prevPageNo) || this._prevPageNo))
                    model.currentPage = this._prevPageNo;
                 var excludeTr = this.model.editSettings.showAddNewRow  && this.model.groupSettings.groupedColumns.length ==  0 ? 1 : 0;
                model.totalRecordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount - excludeTr : this._searchCount : this._filteredRecordsCount;
                if (ej.util.isNullOrUndefined(model.currentPage))
                    model.currentPage = this._currentPage();
                this.getPager().ejPager("option", model).ejPager("refreshPager");
                this.model.pageSettings.totalPages = pagerModel.totalPages || null;
				this.model.pageSettings.totalRecordsCount = pagerModel.totalRecordsCount || null;
            }
        },
        _showHeaderColumn: function (showColumns, field) {
            var $head = this.getHeaderTable().find("thead");
            var $headerCell = $head.find("tr").not(".e-stackedHeaderRow").find(".e-headercell");
            var $filterBarCell = $head.find(".e-filterbar").find(".e-filterbarcell");
            var $col = this.getHeaderTable().find("colgroup").find("col"), column;
            for (var i = 0; i < showColumns.length; i++) {
                if (field)
                    column = ej.isNullOrUndefined(this.getColumnByField(showColumns[i])) ? this.getColumnByHeaderText(showColumns[i], ej.isNullOrUndefined(this.getColumnByField(showColumns[i]))) : this.getColumnByField(showColumns[i]);
                else
                    column = this.getColumnByHeaderText(showColumns[i]);
                var index = $.inArray(column, this.model.columns);
                index = (this.model.detailsTemplate != null || this.model.childGrid) ? index + 1 : index;
                var frznCol = this.model.scrollSettings.frozenColumns;
                if (frznCol != 0 && index >= frznCol)
                    var thIndex = $headerCell.eq(index).removeClass("e-hide").index() + frznCol;
                else
                    var thIndex = $headerCell.eq(index).removeClass("e-hide").index();
                $filterBarCell.eq(thIndex).removeClass("e-hide");
				 if ($col.length > this.model.columns.length && this.model.groupSettings.groupedColumns.length){
					var len = $col.length - this.model.columns.length;
					$col = $col.slice((this.model.detailsTemplate || this.model.childGrid) ? len + 1 : len);				
				}
                $col.eq(index).css("display", "");
            }
            if (this.model.showStackedHeader)
                this._refreshStackedHeader();
        },
        _hideHeaderColumn: function (hiddenColumns, field) {
            var $head = this.getHeaderTable().find("thead");
            var $headerCell = $head.find("tr").not(".e-stackedHeaderRow").find(".e-headercell");
            var $filterBarCell = $head.find(".e-filterbar").find(".e-filterbarcell");
            var $col = this.getHeaderTable().find("colgroup").find("col"), column;
            for (var i = 0; i < hiddenColumns.length; i++) {
                if (field)
                    column = ej.isNullOrUndefined(this.getColumnByField(hiddenColumns[i])) ? this.getColumnByHeaderText(hiddenColumns[i], ej.isNullOrUndefined(this.getColumnByField(hiddenColumns[i]))) : this.getColumnByField(hiddenColumns[i]);
                else
                    column = this.getColumnByHeaderText(hiddenColumns[i]);
                var index = $.inArray(column, this.model.columns);
                var dindex = (this.model.detailsTemplate != null || this.model.childGrid) ? index + 1 : index;
                var frznCol = this.model.scrollSettings.frozenColumns;
                if (frznCol != 0 && index >= frznCol)
                    var thIndex = $headerCell.eq(dindex).addClass("e-hide").index() + frznCol;
                else
                    var thIndex = $headerCell.eq(dindex).addClass("e-hide").index();
                $filterBarCell.eq(thIndex).addClass("e-hide");
                if ($col.length > this.model.columns.length)
                    $col = $col.slice($col.length - this.model.columns.length);
                $col.eq(index).css("display", "none");
            }
            if (this.model.showStackedHeader) {
                this._refreshStackedHeader();
                this._colgroupRefresh();
            }
        },
        _refreshStackedHeader: function () {
			if(this.model.showStackedHeader){
            var stackedRows = this.model.stackedHeaderRows;
            for (var i = 0; i < stackedRows.length; i++) {
                if (this.model.scrollSettings.frozenColumns != 0) {
                    var frznHeader = $(this.getHeaderContent().find(".e-frozenheaderdiv"));
                    var movHeader = $(this.getHeaderContent().find(".e-movableheader"));
                    var newFrzn = this._createStackedRow(stackedRows[i], true);
                    var newMov = this._createStackedRow(stackedRows[i], false);
                    $(frznHeader.find("tr.e-stackedHeaderRow")[i]).replaceWith(newFrzn);
                    $(movHeader.find("tr.e-stackedHeaderRow")[i]).replaceWith(newMov);
                }
                else {
                    var stackedTR = this._createStackedRow(stackedRows[i], false);
                    if (this.getHeaderTable().find("tr.e-stackedHeaderRow")[i])
                        $(this.getHeaderTable().find("tr.e-stackedHeaderRow")[i]).replaceWith(stackedTR);
                    else
                        stackedTR.insertBefore(this.getHeaderTable().find("tr.e-columnheader:last"));
                }
            }
            var args = {};
            args.requestType = "refresh";
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0) {
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                    this.getHeaderTable().find(".e-stackedHeaderRow").prepend(this._getGroupTopLeftCell());
            }
            this.model.allowScrolling && this._refreshScroller(args);
			}

        },
        _getStackedColumnByTarget: function (target) {
            var cls = (target.get(0) || {}).className, match = /e-row([0-9])-column([0-9])/.exec(cls),
                rIndx = match[1], cIndx = match[2], key = [rIndx, "stackedHeaderColumns", cIndx].join(".");

            return ej.getObject(key, this.model.stackedHeaderRows);
        },
        _checkSkipAction: function (args) {
            switch (args.requestType) {
                case ej.Grid.Actions.Save:
                case ej.Grid.Actions.Delete:
                    return true;
            }
            return false;
        },
        _unboundTemplateRendering: function (unboundTemplateId) {
            return $("#" + unboundTemplateId).html();
        },
        _processBindings: function (args) {
            this._requestType = args.requestType;
            this.model.query = this.commonQuery.clone();
            if (!this._checkSkipAction(args) && this._trigger("actionBegin", args))
                return true;
            if (this.model.editSettings.editMode == "batch" && args.requestType != "batchsave" && args.requestType != "cancel" && !this._confirmedValue && this._bulkChangesAcquired() && this.model.editSettings.showConfirmDialog) {
                this._confirmDialog.find(".e-content").html(this.localizedLabels.BatchSaveLostChanges);
                this._confirmDialog.ejDialog("open");
                this._requestArgs = args;
                return false;
            }
            if (!ej.isNullOrUndefined(this.model.dataSource) && args.requestType == "refresh" && this.model.scrollSettings.allowVirtualScrolling) {
                this._currentPage(1);
                this._scrollValue = 0;
                this._loadedJsonData = [];
                this._prevPage = this._currentPage();
            }
            this._ensureDataSource(args);
            if (this.model.scrollSettings.allowVirtualScrolling) {
                if (args.requestType == "virtualscroll") {
                    this._loadedJsonData.push({ pageIndex: this._prevPage, data: this._currentJsonData });
                    this._prevPage = this._currentPage();
                }
                else if (!this.model.scrollSettings.enableVirtualization) {
                    this._virtualLoadedRecords[this._currentPage()] = !ej.isNullOrUndefined(this._currentPageData) ? this._currentPageData : this.model.currentViewData;
                    this._currentPageData = null;
                }
                if (args.requestType == "filtering") {
                    this._loadedJsonData = [];
                    this._prevPage = this._currentPage(); $("#" + this._id + "_externalEdit").remove();
                }
                if (args.requestType == ej.Grid.Actions.Delete || args.requestType == ej.Grid.Actions.Add)
                    this._refreshVirtualViewDetails();
            }
            if (this.model.scrollSettings.allowVirtualScrolling && args.requestType == "filtering" && this.model.filterSettings.filteredColumns.length >0) 
                this.getScrollObject().scrollY(0);
            if (this.model.enableRTL) {
                !this.element.hasClass("e-rtl") && this.element.addClass("e-rtl");
            } else {
                this.element.hasClass("e-rtl") && this.element.removeClass("e-rtl")
            }
            if (args.requestType == ej.Grid.Actions.Delete && this.model.groupSettings.groupedColumns.length == 0) {
                if (this.model.editSettings.showAddNewRow)
                    this.getContentTable().find(".e-addedrow").remove();
                args.tr.remove();
            }
            this._editForm = this.model.scrollSettings.frozenColumns > 0 || this.model.editSettings.showAddNewRow ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
			if (!(this.model.editSettings.showAddNewRow && args.requestType == "beginedit") && this._editForm.length != 0) {
                for(var i=0;i<this._editForm.length;i++){
					$(this._editForm[i]).find("select.e-dropdownlist").ejDropDownList("destroy");
					$(this._editForm[i]).find(".e-datepicker").ejDatePicker("destroy");
					$(this._editForm[i]).find(".e-datetimepicker").ejDateTimePicker("destroy");
					$(this._editForm[i]).find(".e-numerictextbox").ejNumericTextbox("destroy");
				}
            }
			if ((this._dataSource() instanceof ej.DataManager && !this._isRemoteSaveAdaptor && args.requestType != ej.Grid.Actions.BeginEdit && args.requestType != ej.Grid.Actions.Cancel && args.requestType != ej.Grid.Actions.Add) && (!(this._dataSource().adaptor instanceof ej.SqlDataSourceAdaptor) || (args.requestType != ej.Grid.Actions.Save && args.requestType != ej.Grid.Actions.Delete))) {
                if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && this.model.pageSettings.totalPages == this.model.pageSettings.currentPage && this.virtualLoadedPages.indexOf(((this._prevPageNo - 1) * (this.model.pageSettings.pageSize))) == -1) {
                    var pageQuery = ej.pvt.filterQueries(this.model.query.queries, "onPage");
                    this.model.query.queries.splice($.inArray(pageQuery[0], this.model.query.queries), 1);
                    this.model.query.page(this._currentPage() - 1, this.model.pageSettings.pageSize);
                    var lastQueryPromise = this._dataSource().executeQuery(this.model.query);
                    this.model.query.queries.splice($.inArray(pageQuery[0], this.model.query.queries), 1);
                    this.model.query.page(this._currentPage(), this.model.pageSettings.pageSize);
                }
                if (this._virtualSelectedRows && this._virtualSelectedRows.length > 0) {
                    this.model.query.addParams('virtualSelectRecords', this._virtualSelectedRows)
                }
                var queryPromise = this._queryPromise = this._dataSource().executeQuery(this.model.query);
                var waitingPopup = this.element.ejWaitingPopup("instance");
                var proxy = this;
                this.element.ejWaitingPopup("show");
                if (proxy._dataSource().ready) {
                    proxy._dataSource().ready.done(function () {
                        proxy._processDataRequest(proxy, args, queryPromise, lastQueryPromise)
                    });
                }
                else {
                    proxy._processDataRequest(proxy, args, queryPromise, lastQueryPromise)
                }
            } else {
                if (this._isRelationalRendering(args))
                    this._setForeignKeyData(args);
                else
                    this.sendDataRenderingRequest(args);
            }
        },
        _processDataRequest: function (proxy, args, queryPromise, lastQueryPromise) {
            queryPromise.done(ej.proxy(function (e) {
                if (ej.isNullOrUndefined(proxy.element))
                    return;
                proxy._relationalColumns.length == 0 && proxy.element.ejWaitingPopup("hide");
                if (lastQueryPromise && !proxy._previousPageRendered) {
                    proxy._processLastPageData(proxy, args, e.result, lastQueryPromise);
                    if (proxy.model.previousViewData && proxy.model.previousViewData.length != 0) {
                        proxy.model.previousViewData.splice(0, e.result.length);
                        proxy._previousPageLength = e.result.length;
                        proxy._currentPageData = e.result;
                        ej.merge(proxy.model.previousViewData, e.result);
                        proxy.model.currentViewData = proxy.model.previousViewData;
                        proxy._remoteLastPageRendered = true;
                    }
                }
                else if (proxy._remoteLastPageRendered && proxy.model.pageSettings.currentPage == proxy.model.pageSettings.totalPages - 1 && !proxy.model.scrollSettings.enableVirtualization) {
                    var count = proxy.model.pageSettings.pageSize - proxy._previousPageLength;
                    for (var dupRow = 0; dupRow < count; dupRow++) {
                        var removeEle = proxy.getRows()[proxy.getRows().length - (proxy.model.pageSettings.pageSize - dupRow)];
                        removeEle.remove();
                    }
                    proxy._tempPageRendered = true;
                    proxy.model.currentViewData = e.result;
                }
                else {
                    if (proxy._identityKeys.length && args.action == "add" && this.adaptor instanceof ej.ODataAdaptor)
                        proxy._processIdentityField(e.result, args);
                    if (proxy.model.pageSettings.currentPage == proxy.model.pageSettings.totalPages - 1 && !proxy._remoteLastPageRendered)
                        proxy._previousPageRendered = true;
                    proxy.model.currentViewData = e.result == null ? [] : e.result;
                    if (proxy._$fkColumn && proxy.model.filterSettings.filterType == "excel" && proxy.model.filterSettings.filteredColumns.length > 0)
                        proxy._fkParentTblData = e.result;
                }
				if(proxy.model.allowScrolling && proxy.model.scrollSettings.allowVirtualScrolling && proxy.model.scrollSettings.enableVirtualization){
					if(args.requestType == "filtering"){
						proxy._gridRecordsCount = proxy._filteredRecordsCount = e.count;
						proxy._refreshVirtualViewDetails();
					}
					if(e.result.length){
					    if (proxy._isInitNextPage || proxy._isLastVirtualpage) {
					        proxy._setInitialCurrentIndexRecords(e.result, proxy._currentPage());
					        proxy._isInitNextPage = proxy._isLastVirtualpage = false;
					    }
					    else {
					        proxy._gridRecordsCount = e.count;
                            proxy._refreshVirtualViewDetails();
					        proxy._setVirtualLoadedRecords(e.result, proxy._currentPage());
					    }
						if(proxy._isThumbScroll && !proxy._checkCurrentVirtualView(proxy._virtualLoadedRecords, proxy._currentVirtualIndex))
							proxy._checkPrevNextViews();																										
						proxy._remoteRefresh = true;
					}
					else
						proxy.getContent().find(".e-virtualtop, .e-virtualbottom").remove();					
				}
                if (!ej.isNullOrUndefined(e.aggregates))
                    proxy._remoteSummaryData = e.aggregates;
                proxy._processData(e, args);
				if (!ej.isNullOrUndefined(proxy._unboundRow) && args.selectedRow != proxy._unboundRow && args.requestType == "save") {
                    proxy._unboundRow.find(".e-editbutton").trigger("click");
                    proxy._unboundRow = null;
                }
            }));
            queryPromise.fail(ej.proxy(function (e) {
                if (ej.isNullOrUndefined(proxy.element))
                    return;
                proxy.element.ejWaitingPopup("hide");
                args.error = e.error;
                e = [];
                proxy.model.currentViewData = [];
                proxy._processData(e, args);
                if (!ej.isNullOrUndefined(proxy.getPager())) {
                    proxy.getPager().ejPager({ currentPage: 0, totalRecordsCount: 0 });
                }
                proxy._trigger("actionFailure", args);
            }));
        },
        _processIdentityField: function (result, args) {
            var _pKey = this._primaryKeys[0];
            var resultPK = ej.distinct(result, _pKey);
            var curPK = ej.distinct(this.model.currentViewData, _pKey);
            var addPK = $.grep(resultPK, function (value) {
                if ($.inArray(value, curPK) == -1)
                    return true;
                return false;
            });
            var data = ej.DataManager(result).executeLocal(new ej.Query().where(_pKey, "equal", addPK))[0]
            args.data = ej.isNullOrUndefined(data) ? args.data : data;
        },
        _processLastPageData: function (proxy, args, currentData, lastQueryPromise) {
            lastQueryPromise.done(ej.proxy(function (e) {
                proxy.model.previousViewData = e.result;
            }));
            lastQueryPromise.fail(ej.proxy(function (e) {
                proxy.element.ejWaitingPopup("hide");
                args.error = e.error;
                e = [];
                proxy.model.previousViewData = [];
                proxy._processData(e, args);
                proxy._trigger("actionFailure", args);
            }));
        },
        _createUnboundElement: function (column,count) {
            var divElement = document.createElement("div");
            column.headerText = !ej.isNullOrUndefined(column.headerText) ? column.headerText : ej.isNullOrUndefined(column.field) ? "" : column.field;
            if (!ej.isNullOrUndefined(column.headerText))
                divElement.id = this._id + column.headerText.replace(/[^a-z0-9|s_]/gi, '') + count + "_UnboundTemplate";
            var $div = ej.buildTag("div.e-unboundcelldiv"), commands = column["commands"];
            for (var unbounType = 0; unbounType < commands.length; unbounType++) {
                var $button = ej.buildTag("button.e-flat e-" + commands[unbounType].type.replace(/\s+/g, "") + "button", "", {}, { type: "button" });
                $button.val(commands[unbounType].type);
                if (commands[unbounType].type == "save" || commands[unbounType].type == "edit")
                    $button.addClass("e-btnsub")
                if (commands[unbounType].type == "cancel" || commands[unbounType].type == "delete")
                    $button.addClass("e-btncan")
                $div.append($button);
            }
            $("body").append($(divElement).html($div).hide());
            return divElement;
        },
        _refreshUnboundTemplate: function ($target) {
            if (this._isUnboundColumn) {
                var index = 0;
                for (var column = 0; column < this.model.columns.length; column++) {
                    if (this.model.columns[column]["commands"]) {
                        var $unboundDivs = $target.find(".e-unboundcell.e-" + this.model.columns[column]["headerText"].replace(/[^a-z0-9|s_]/gi, '')+column).find(".e-unboundcelldiv");
                        var commands = $.extend(true, [], this.model.columns[column].commands);
                        for (var j = 0; j < commands.length; j++) {
                            if (ej.isNullOrUndefined(commands[j].buttonOptions))
                            commands[j].buttonOptions = {};
                            commands[j].buttonOptions.width = ej.isNullOrUndefined(commands[j].buttonOptions.width) ? "52" : commands[j].buttonOptions.width;
                            commands[j].buttonOptions.height = ej.isNullOrUndefined(commands[j].buttonOptions.height) ? "28" : commands[j].buttonOptions.height;
                            commands[j].buttonOptions.cssClass = ej.isNullOrUndefined(commands[j].buttonOptions.cssClass) ? this.model.cssClass : commands[j].buttonOptions.cssClass;
                            commands[j].buttonOptions.enableRTL = this.model.enableRTL;
                            var $buttons = $unboundDivs.find(".e-" + commands[j].type.replace(/\s+/g, "") + "button");
                            if (!this.model.isEdit || this._requestType == "cancel") {
								if ($target.closest(".e-editcell").length) {
									if (commands[j].type == "save" || commands[j].type == "cancel")
										$buttons.show();
									else {
										$buttons.hasClass("e-deletebutton") && $buttons.hide();
										$buttons.hasClass("e-editbutton") && $buttons.hide();
									}
								} else {
									if (commands[j].type == "save" || commands[j].type == "cancel")
										$buttons.hide();
									else {
										$buttons.hasClass("e-deletebutton") && $buttons.show();
										$buttons.hasClass("e-editbutton") && $buttons.show();
									}
								}
                            }
                            for (var i = 0; i < $buttons.length; i++) {
                                if ($($buttons[i]).data("ejButton"))
                                    $($buttons[i]).ejButton("destroy");
                            }
                            $buttons.ejButton(commands[j].buttonOptions);
                        }
                    } else
                        continue;
                }
            }
        },
        _gridTemplate: function (self, templateId, index) {
            var $column = self.model.columns[index];
            if (self.model.scrollSettings.enableVirtualization)
                this.index += self._currentVirtualRowIndex;
            if (self._isGrouping)
                this.index = self._currentJsonData.indexOf(this.data);
            return self._renderEjTemplate("#" + templateId, this.data, this.index, $column);
        },
        _createTemplateElement: function (column, appendTo /* container to append */, text) {
            var tmpl = column["templateID" in column ? "templateID" : "template"], quickReg = /^#([\w-]*)/,
                match = quickReg.exec(tmpl), scriptReg = /^<script/i, appendTo = appendTo || $("body"), scripEle,
                idText = text ? "Pager" : (column.headerText + $.inArray(column, this.model.columns) + "_") + "Template";

            var options = {
                name: "SCRIPT",
                type: "text/x-template",
                text: tmpl,
                id: (this._id + idText).replace(/(\\|[^0-9A-z-_])/g, "")
            };

            if ( match && match[1] )
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(tmpl)) // branch here to handle tmpl string with SCRIPT. 
                    scripEle = $(tmpl).get(0);
                else
                    scripEle = ej.buildTag(options.name, options.text).get(0);
            }

            scripEle.id = scripEle.id || options.id; // Update Id and type if not in scriptElement template string.
            scripEle.type = scripEle.type || options.type;

            appendTo.append(text ? scripEle.innerHTML : scripEle); //if `text` then append innerHTML instead of element.

            return scripEle;
        },
        _renderGridPager: function () {
            var $div = $(document.createElement('div'));
            var pagerModel = {};
            this.model.pageSettings.click = this._gPagerClickHandler;
            this.model.pageSettings.totalRecordsCount = this._gridRecordsCount || null;
            this.model.pageSettings.enableRTL = this.model.enableRTL;
            this.model.pageSettings.locale = this.model.locale;
            this.model.pageSettings.enableQueryString = this.model.pageSettings.enableQueryString;
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                pagerModel.enableExternalMessage = this.model.filterSettings.showFilterBarStatus;
            $.extend(pagerModel, this.model.pageSettings);
            pagerModel.currentPage = this._currentPage();
            pagerModel.masterObject = this;
            this.setGridPager($div);
            $div.ejPager(pagerModel);
            $div.ejPager("refreshPager");
            pagerModel = $div.ejPager("model");
            this.model.pageSettings.totalPages = pagerModel.totalPages || null;
            if (this._currentPage() !== pagerModel.currentPage)
                this._currentPage(pagerModel.currentPage);
            this._renderPagerTemplate($div);
            return $div;
        },
        _renderPagerTemplate: function (pager, showDefaults) {
            var model = this.model.pageSettings, defaults = pager.find(".e-pagercontainer").not(".e-template").length == 0;            
            pager.find(".e-pagercontainer.e-template").remove();

            if ((showDefaults || !model.enableTemplates) && defaults) //Used to enable default pager from disabled
                pager.ejPager("renderPager");

            if (model.enableTemplates) {                

                if (!model.showDefaults)
                    pager.children().remove();               

                var $customDiv = ej.buildTag('div', null, null, { "class": "e-pagercontainer e-template" });                
                this._createTemplateElement(this.model.pageSettings, $customDiv, true);                
                pager.append($customDiv)
            }          
           
        },
        _renderContext: function (e) {
            var menuitems = this.model.contextMenuSettings.contextMenuItems;
            var item, item2, i = 0;
            var ul = ej.buildTag('ul', "", {}, { id: this._id + '_Context' });
            if (!this.model.contextMenuSettings.disableDefaultItems) {
                for (i; i < menuitems.length; i++) {
                    item = menuitems[i];
                    item2 = this._items(item, "contextMenuItem");
                    ul.append(item2);
                }
            }
            var customitems = this.model.contextMenuSettings.customContextMenuItems;
            var subMenuItems = this.model.contextMenuSettings.subContextMenu;
            var custom, custom2, j = 0;
            for (j; j < customitems.length; j++) {
                custom = customitems[j];
                custom2 = this._items(custom, "customContextMenuItem");                
                for (var k = 0 ; k < subMenuItems.length; k++)
                    if ((typeof custom == "string" && custom ==  subMenuItems[k].contextMenuItem) || (typeof custom == "object" && custom.id ==  subMenuItems[k].contextMenuItem )) {
                        var ul1 = ej.buildTag('ul', "", {}, { id: this._id + '_subMenuContext' + k }), menuItem, menuItem1;
                        for (var l = 0; l < subMenuItems[k].subMenu.length; l++) {
                            menuItem = subMenuItems[k].subMenu[l];
                            menuItem1 = this._items(menuItem, "subMenuItems");
                            ul1.append(menuItem1);
                        }
                        custom2.append(ul1);
                    }
                ul.append(custom2);
            }
            if (ul.find("li").length > 0) {
                this.element.append(ul);
                var parentControl = this.element.parents("div.e-grid");
                var native = ej.Menu.prototype._showContextMenu;
                ej.Menu.prototype._showContextMenu = function (locationX, locationY, target, evt) {
                    $(this.model.contextMenuTarget).hasClass("e-grid") && (++locationX, ++locationY)
                    native.apply(this, [locationX, locationY, target, evt]);
                };
                $(ul).ejMenu({
                    menuType: ej.MenuType.ContextMenu,
                    openOnClick: false,
                    contextMenuTarget: "#" + this._id,
                    click: $.proxy(this._clickevent, this),
                    width: "auto",
                    beforeOpen: $.proxy(this._menu, this)
                });
                if (parentControl.length) {
                    var parentElement = $("#" + parentControl[0].id + '_Context');
                    var target = parentElement.ejMenu("model.excludeTarget");
                    parentElement.ejMenu({ excludeTarget: !ej.isNullOrUndefined(target) && target.length != 0 ? target.concat(",#" + this._id) : "#" + this._id });
                }
                this._conmenu = ul.data("ejMenu");
            }
        },
        _clickevent: function (sender) {
            var args = sender.events.text;
            var tr = $(this._contexttarget.parentNode);
            var c = $(this._contexttarget);
            if (c.hasClass("e-filterset"))
                c = c.siblings();
            else if (c.hasClass("e-icon") || c.hasClass("e-number"))
                c = c.parent();
            var columnName = c.attr("ej-mappingname")|| c.find(".e-headercelldiv").attr("ej-mappingname");
            if (this._trigger("contextClick", sender))
                return;
            switch (args) {
                case this.localizedLabels.AddRecord: this._startAdd();
                    break;
                case this.localizedLabels.EditRecord:
                    if (this.model.editSettings.editMode == "batch") {
                        var colindex = $(this._contexttarget.parentNode).find(".e-rowcell").index(c), index = this._excludeDetailRows().index(tr), fieldName = this.model.columns[colindex]["field"];
                        this.editCell(index, fieldName);
                    }
                    else
                        this.startEdit(tr);
                    break;
                case this.localizedLabels.DeleteRecord:
                    if (this.model.editSettings.showDeleteConfirmDialog)
                        this._confirmDialog.find(".e-content").html(this.localizedLabels.ConfirmDelete).end().ejDialog("open");
					else if (this.multiDeleteMode && this.selectedRowsIndexes.length > 1)
                       this._multiRowDelete();
                    else
                       this.deleteRow(tr);
                    break;
                case this.localizedLabels.Save:
                    if (this.model.editSettings.editMode == "batch")
                        this.batchSave();
                    else
                        this.endEdit();
                    break;
                case this.localizedLabels.Cancel: this.cancelEdit();
                    break;
                case this.localizedLabels.SortInDescendingOrder: var columnSortDirection = ej.sortOrder.Descending;
                    this.sortColumn(columnName, columnSortDirection);
                    break;
                case this.localizedLabels.SortInAscendingOrder: var columnSortDirection = ej.sortOrder.Ascending;
                    this.sortColumn(columnName, columnSortDirection);
                    break;
                case this.localizedLabels.Grouping: this.groupColumn(columnName);
                    break;
                case this.localizedLabels.Ungrouping: this.ungroupColumn(columnName);
                    break;
                case this.localizedLabels.NextPage:
                case this.localizedLabels.PreviousPage:
                case this.localizedLabels.LastPage:
                case this.localizedLabels.FirstPage: this._page(sender);
                    break;
            }

        },

        _menu: function (sender) {
            var context = this._conmenu.element;
            this._contexttarget = sender.target;
            var targetelement = $(sender.target), element, value;
            var td = $(this._contexttarget);
            if (this.model.allowSelection && (td.hasClass("e-rowcell") || td.closest(".e-rowcell").length)  && !targetelement.hasClass("e-selectionbackground")) {
                var tr = td.hasClass("e-rowcell") ? td.parent() : td.closest(".e-rowcell").parent();
                if (!this.model.isEdit)
                    this.selectRows(this.getIndexByRow(tr), null, td);
            }
            if ((targetelement.hasClass("e-ascending") || targetelement.hasClass("e-descending")) && !targetelement.parent().hasClass("e-headercelldiv"))
                return false;
            if (targetelement.hasClass("e-filtericon") || targetelement.hasClass("e-headercelldiv"))
                element = sender.target.parentNode.getAttribute("aria-sort");
			else if (targetelement.hasClass("e-headercell"))
				element = sender.target.getAttribute("aria-sort");
            else
                element = targetelement.parent().parent().attr("aria-sort");
            var target = sender.target.className;
            var sorting = $(context);
            if (targetelement.hasClass("e-filterset"))
                value = targetelement.siblings().attr("ej-mappingname");
            else if (targetelement.hasClass("e-icon") || targetelement.hasClass("e-number"))
                value = targetelement.parent().attr("ej-mappingname");
            else if(targetelement.hasClass("e-headercell"))
				value=targetelement.find(".e-headercelldiv").attr("ej-mappingname");
			else
                value = targetelement.attr("ej-mappingname");            
            context.css("visibility", "visible");            
            var index = targetelement.closest("tr").hasClass("e-insertedrow") ? this.model.groupSettings.groupedColumns.length : 0;
            var rowCell = targetelement.closest(".e-rowcell");
            var headerCell = targetelement.closest(".e-headercell");
            var tempIndex = rowCell.index() != -1 ? rowCell.index() : headerCell.index() - this.model.groupSettings.groupedColumns.length;
            var columnIndex = targetelement.hasClass("e-rowcell") ? targetelement.index() - index : tempIndex - index;
            columnIndex = (this.model.detailsTemplate != null || this.model.childGrid != null) ? columnIndex - 1 : columnIndex;
            var col = this.model.columns[columnIndex];
            var mapObj = {
                "allowGrouping": ".e-contextgrouping",
                "allowSorting": ".e-contextascending, .e-contextdescending",
                "editSettings.allowAdding": ".e-contextadd",
                "editSettings.allowEditing": ".e-contextedit",
                "editSettings.allowDeleting": ".e-contextdelete",
            };         
            for (var prop in mapObj) {
                var ele = context.find(mapObj[prop]).parent();
                if (ej.getObject(prop, this.model) == false || (ej.getObject(prop, col) === false))
                    ele.css("display", "none");
                else if (ele.css("display") == "none")
                    ele.css("display", "block");
           }
            if (targetelement.closest(".e-grid").attr("id") !== this._id || targetelement.is("input")) {
                context.css("visibility", "hidden");
                return;
            }
            else if (this.getHeaderTable().find(targetelement).length > 0) {
                if (!(headerCell.length != 0 && headerCell.children().hasClass("e-headercelldiv"))) {
                    context.css("visibility", "hidden");
                    return;
                }
                var a = $(context.find(".e-head"));
                context.find(".e-page").css("display", "none");
                context.find(".e-content").css("display", "none");
                context.find(".e-savcan").css("display", "none");
                a.css("display", "block");                
                if(ej.isNullOrUndefined(col.field) || col.field == "") {
                     a.css("display","none");
                     if (context.find(".e-customitem").length == 0)
                        context.css("visibility", "hidden")
               }
			   var exarg = { columnIndex: columnIndex, headerText: col.headerText }
			   $.extend(sender,exarg);
             }
            else if (this.getContentTable().find(targetelement).length > 0) {
			    var rowIndex = this.getIndexByRow($(sender.target.parentElement));
               var rowData = this.model.editSettings.editMode == "batch"?this.getDataByIndex(rowIndex):this.getSelectedRecords();
                if (rowCell.length == 0) {
                    context.css("visibility", "hidden");
                    return;
                }
                var a = $(context.find(".e-content"));
                context.find(".e-head").css("display", "none");
                context.find(".e-page").css("display", "none");
                context.find(".e-savcan").css("display", "none");
                a.css("display", "block");                
                if ((ej.isNullOrUndefined(col.field) || col.field == "") && this.model.editSettings.editMode == "batch") {
                    a.css("display","none");
                    if (context.find(".e-customitem").length == 0)
                       context.css("visibility", "hidden")
               }
		    if(this.model.editSettings.editMode =="batch")
			   {
			     var exarg = { columnIndex: columnIndex, rowIndex: rowIndex, rowData:rowData , headerText: col.headerText,cellValue:ej.getObject(ej.isNullOrUndefined(col.field) ? "" : col.field, rowData) }
			   }
		     else
			     var exarg = { columnIndex: columnIndex, rowIndex: rowIndex, rowData:rowData, headerText: col.headerText, }
				 $.extend(sender,exarg);
             }
            else if (this.getPager().find(targetelement).length > 0 || targetelement.hasClass("e-pager")) {
                var a = $(context.find(".e-page"));
                context.find(".e-head").css("display", "none");
                context.find(".e-content").css("display", "none");
                context.find(".e-savcan").css("display", "none");
                a.css("display", "block");
            }
            else {
                var a = $(context);
                context.css("visibility", "hidden");
                return false;
            }
            switch (element) {
                case "ascending": sorting.find(".ascending").parent().css("display", "none");
                    break;
                case "descending": sorting.find(".descending").parent().css("display", "none");
                    break;
            }
            if (targetelement.hasClass("e-rowcell") && this.model.editSettings.showAddNewRow) {
                var a = $(context.find(".e-savcan"));
                context.find(".e-contextadd").parent().css("display", "none");
                a.css("display", "block");
            }
            if (this.model.editSettings.editMode == "batch" && (this.batchChanges.changed.length || this.batchChanges.deleted.length || this.batchChanges.added.length)) {
                var a = $(context.find(".e-savcan"));
                context.find(".e-head").css("display", "none");
                context.find(".e-page").css("display", "none");
                a.css("display", "block");
            }
            if (this.model.isEdit && targetelement.hasClass("e-rowcell") && (!this.model.editSettings.showAddNewRow || $(".e-editedrow").length > 0)) {
                var a = $(context.find(".e-savcan"));
                context.find(".e-head").css("display", "none");
                context.find(".e-content").css("display", "none");
                context.find(".e-page").css("display", "none");
                a.css("display", "block");
            }
            if (this.model.pageSettings.totalPages == 1 && a.hasClass("e-page")) {
                if (context.find(".e-customitem").length == 0)
                    context.css("visibility", "hidden");
                else
                    context.find(".e-page").css("display", "none");
            }            
            else if (this.model.pageSettings.currentPage == 1) {
                sorting.find(".previous").parent().css("display", "none");
                sorting.find(".first").parent().css("display", "none");
            }
            else if (this.model.pageSettings.currentPage == this.model.pageSettings.totalPages) {
                sorting.find(".last").parent().css("display", "none");
                sorting.find(".nextpage").parent().css("display", "none");
            }
            if (this.model.groupSettings.groupedColumns.indexOf(value) != -1)
                a.find(".group").parent().css("display", "none");
            else if (this.model.groupSettings.groupedColumns.indexOf(value) == -1)
                a.find(".ungroup").parent().css("display", "none");
			if (this.model.contextOpen)
                this._trigger("contextOpen", sender);
        },

        _items: function (item, type) {
            if (item == "")
                return false;
            if (type == "contextMenuItem") {
                if (item.indexOf("Record") != -1) {
                    var li = ej.buildTag('li', "", {}, { "class": "e-content" });
                    li.css("display", "none");
                }
                else if (item.indexOf("Page") != -1) {
                    var li = ej.buildTag('li', "", {}, { "class": "e-page" });
                    if (item.indexOf("Next") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "nextpage" });
                    else if (item.indexOf("Previous") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "previous" });
                    else if (item.indexOf("Last") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "last" });
                    else if (item.indexOf("First") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "first" });
                    li.css("display", "none");
                }
                else if (item == "Save" || item == "Cancel") {
                    var li = ej.buildTag('li', "", {}, { "class": "e-savcan" });
                    li.css("display", "none");
                }
                else if (item.indexOf("Order") != -1 || item == "Grouping" || item == "Ungrouping") {
                    var li = ej.buildTag('li', "", {}, { "class": "e-head" });
                    if (item.indexOf("Ascending") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "ascending" });
                    else if (item.indexOf("Descending") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "descending" });
                    else if (item == "Grouping")
                        var div = ej.buildTag('div', "", {}, { "class": "group" });
                    else if (item == "Ungrouping")
                        var div = ej.buildTag('div', "", {}, { "class": "ungroup" });
                    li.css("display", "none");
                }
            }
            if (ej.isNullOrUndefined(li)) {
                var li = ej.buildTag('li', "", {}, { "class": "e-customitem" });
                li.css("display", "block");
            }
            li.append(div);
            var a = document.createElement("a"), classElement = "";
            if (typeof item == "string") {
                if (item.indexOf("Ascending") != -1)
                    classElement = "ascending";
                else if (item.indexOf("Descending") != -1)
                    classElement = "descending";
                else
                    classElement = item.split(" ")[0].toLowerCase();
                a.innerHTML = !ej.isNullOrUndefined(this.localizedLabels[item.replace(/\s+/g, '')]) ? this.localizedLabels[item.replace(/\s+/g, '')] : item;
            }
            if (typeof item == "object") {
                if (item.id == "Ascending")
                    classElement = "ascending";
                else if (item.id == "Descending")
                    classElement = "descending";
                else
                    classElement = item.id.split(" ")[0].toLowerCase();
                a.innerHTML = !ej.isNullOrUndefined(this.localizedLabels[item.text.replace(/\s+/g, '')]) ? this.localizedLabels[item.text.replace(/\s+/g, '')] : item.text;
                li.attr('id', item.id);
            }
			$(a).append(ej.buildTag('span', "", {}, { "class": "e-gridcontext e-icon e-context" + classElement }));
            li.append(a);
            return li;
        },

        _page: function (send) {
            if (send.events.text == this.localizedLabels.NextPage) {
                var b = this.model.pageSettings.currentPage;
                ++b;
                this.gotoPage(b);
            }
            else if (send.events.text == this.localizedLabels.PreviousPage) {
                var b = this.model.pageSettings.currentPage;
                if (b > 1) {
                    --b;
                    this.gotoPage(b);
                }
                else
                    this.gotoPage(b);
            }
            else if (send.events.text == this.localizedLabels.LastPage) {
                var b = this.model.pageSettings.totalPages
                this.gotoPage(b);
            }
            else
                this.gotoPage(1);


        },

        
        gotoPage: function (pageIndex) {
            if (!this.model.allowPaging && (!this.model.allowScrolling && !this.model.scrollSettings.allowVirtualScrolling))
                return;
            var args = {}, returnValue;
            args.previousPage = this._currentPage();
            this._currentPage(pageIndex);
            args.endIndex = ((this._currentPage() * this.model.pageSettings.pageSize) > this._gridRecordsCount) ? (this._gridRecordsCount) : (this._currentPage() * this.model.pageSettings.pageSize);
            args.startIndex = (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
            args.currentPage = pageIndex;
            if (this.model.allowPaging) {
                //this.model.pageSettings.currentPage = pageIndex;
                //this. getPager().ejPager("refreshPager");
                args.requestType = ej.Grid.Actions.Paging;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling) {
                this._isVirtualRecordsLoaded = false;
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
                args.requestType = ej.Grid.Actions.VirtualScroll;
            }
            returnValue = this._processBindings(args);
            if (returnValue)
                this._currentPage(args.previousPage);
            this._primaryKeyValues = [];
        },
        _gPagerClickHandler: function (sender) {
            if (this._prevPageNo == sender.currentPage)
                return;
            this.model.masterObject.gotoPage(sender.currentPage);
            return false;
        },
        _processData: function (e, args) {
            if (this.initialRender) {
                this._initDataProcessed = true;
                this._initDataProcess(e, args);
            }
            else {
                if (e.count == 0 && this.model.currentViewData.length)
                    this._gridRecordsCount = e.result.length;
                else
                    this._gridRecordsCount = e.count;
                if (this.getPager() != null)
                    this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;
                if ((args.requestType == ej.Grid.Actions.Filtering || ej.Grid.Actions.Save || (this.model.filterSettings.filteredColumns.length > 0 && args.requestType == ej.Grid.Actions.Refresh)))
                    this._filteredRecordsCount = e.count;
                if (this.model.allowScrolling && this.model.scrollSettings.enableVirtualization) {
                    this.model.currentViewData = [];
                    for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                        var currentView = this._currentLoadedIndexes[i];
                        $.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView] || []);
                    }
                }
                this._setForeignKeyData(args);
                this._relationalColumns.length == 0 && this.sendDataRenderingRequest(args);
            }
        },

        _frozenCell: function (rowIndex, cellIndex) {
            var currentIndex = cellIndex, frozenDiv = 0, row = this.getRowByIndex(rowIndex), cell;
            if (cellIndex >= this.model.scrollSettings.frozenColumns) {
                frozenDiv = 1;
                currentIndex = currentIndex - this.model.scrollSettings.frozenColumns;
            }
            cell = $(row.eq(frozenDiv).find(".e-rowcell:eq(" + currentIndex + ")"));
            return cell;
        },
        _frozenColumnSelection: function (gridRows, columnIndex, endIndex) {
            var currentIndex = columnIndex, frozenDiv = 0;
            if (endIndex) {
                for (var i = columnIndex; i < endIndex; i++) {
                    currentIndex = i;
                    if (i >= this.model.scrollSettings.frozenColumns) {
                        frozenDiv = 1;
                        currentIndex = i - this.model.scrollSettings.frozenColumns;
                    }
                    for (var j = 0; j < gridRows[frozenDiv].length; j++) {
                        $(gridRows[frozenDiv][j].cells[currentIndex]).addClass("e-columnselection");
                    }
                    $(this.getHeaderTable().find("th.e-headercell")[i]).addClass("e-columnselection");
                    this.selectedColumnIndexes.push(i);
                }
            }
            else {
                if (columnIndex >= this.model.scrollSettings.frozenColumns) {
                    frozenDiv = 1;
                    currentIndex = columnIndex - this.model.scrollSettings.frozenColumns;
                }
                for (var i = 0; i < gridRows[frozenDiv].length; i++) {
                    $(gridRows[frozenDiv][i].cells[currentIndex]).addClass("e-columnselection");
                }
            }

        },
        _renderGridFooter: function () {
            if (this.model.summaryRows.length > 0) {
                var _$gridFooter = ej.buildTag("div.e-gridfooter");
                var $table = ej.buildTag("table.e-gridsummary", "", {}, { cellspacing: "0.25px" });
                this.setGridFooterContent(_$gridFooter);
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var $frozenFooterDiv = ej.buildTag("div.e-frozenfooterdiv"), $movableFooter = ej.buildTag("div.e-movablefooter")
                        , $tableClone = $table.clone(), $movableFooterDiv = ej.buildTag("div.e-movablefooterdiv");
                    $movableFooter.append($movableFooterDiv);
                    $table.append(this.getHeaderTable().first().find('colgroup').clone());
                    $tableClone.append(this.getHeaderTable().last().find('colgroup').clone());
                    $frozenFooterDiv.append($table);
                    $movableFooterDiv.append($tableClone);
                    this.setGridFooterTable($table.add($tableClone));
                    this._createSummaryRows(this.getFooterTable());
                    _$gridFooter.append($frozenFooterDiv.add($movableFooter));
                    _$gridFooter.find(".e-frozenfooterdiv").outerWidth(this.getHeaderContent().find(".e-frozenheaderdiv").width())
                          .end().find(".e-movablefooterdiv").outerWidth(this.getContent().find(".e-movablecontentdiv").width());
                }
                else {
                    $table.append(this.getHeaderTable().find('colgroup').clone());
                    this.setGridFooterTable($table);
                    this._createSummaryRows(this.getFooterTable());
                    _$gridFooter.append($table);
                }
                return _$gridFooter;
            } else
                throw "summary row collection is missing";
        },
        _setSummaryAggregate: function (queryManager) {
            var rows = this.model.summaryRows, scolumns, sCol = [];
            for (var row = 0, rlen = rows.length; row < rlen; row++) {
                scolumns = rows[row].summaryColumns;
                for (var col = 0, clen = scolumns.length; col < clen; col++) {
                    queryManager.aggregate(scolumns[col].summaryType, scolumns[col].dataMember);
                }
            }
        },
        _createSummaryRows: function (table, summaryData, aggregates, item, showGroup) {
            var col = table.find("col");
            if (table.find("tbody").length > 0)
                table.find("tbody").remove();
            var $tBody = ej.buildTag('tbody'), proxy = this, $tBodyClone = $tBody.clone();
            var summaryCol = this.model.summaryRows;
            if (!ej.isNullOrUndefined(summaryData) && this._isCaptionSummary)
                summaryCol = this._captionSummary(showGroup);
            $.each(summaryCol, function (indx, row) {
                if (row.showTotalSummary === false && ej.isNullOrUndefined(summaryData)) return true;
                if (row.showGroupSummary === false && showGroup && !ej.isNullOrUndefined(summaryData)) return true;
                var $tr = ej.buildTag('tr.e-gridSummaryRows');
                if (ej.isNullOrUndefined(item && item.level)) {
                    for (var i = 0; i < proxy.model.groupSettings.groupedColumns.length; i++) {
                        $tr.prepend(ej.buildTag('td').addClass("e-indentcell"));
                    }
                }
                var gc = showGroup ? " e-gcsummary" : "";
                if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                    if (proxy.model.groupSettings.groupedColumns.length != 0)
                        $tr.children("td.e-indentcell").last().after("<td class='e-summaryrow" + gc + "'></td>");
                    else
                        $tr.prepend("<td class='e-summaryrow'></td>");
                }
                var $cells = proxy.getHeaderTable().find('td').clone().addClass("e-summaryrow" + gc + ""), count = 0;
                var index = 0;
                if (!ej.isNullOrUndefined(row.titleColumn)) {
                    var index = proxy.getColumnIndexByField(row.titleColumn);
                    if (index == -1)
                        index = proxy.getColumnIndexByHeaderText(row.titleColumn);
                }
				if(index != -1)
					$cells = proxy._assignTitleColumn(index, row.title, $cells, count);
                proxy._hideSummaryColumn($cells, col);
                if (proxy.model.scrollSettings.frozenColumns > 0) {
                    var $trClone = $tr.clone();
                    $tBody.append($tr.append($cells.slice(0, proxy.model.scrollSettings.frozenColumns)));
                    $tBodyClone.append($trClone.append($cells.slice(proxy.model.scrollSettings.frozenColumns)));
                }
                else {
                    if ((!proxy._isCaptionSummary || showGroup) && !ej.isNullOrUndefined(item && item.level)) {
                        var level = proxy.model.groupSettings.groupedColumns.length - item.level + 1, tableClone = table.clone().addClass("e-groupsummary"), captionData = {};
                        captionData["data"] = { items: item };
                        $tr.prepend("<td class='e-summaryrow" + gc + "' colspan=" + proxy._colSpanAdjust(null, null, captionData) + " style = 'padding:0;' ></td>");
                        $($tr[0].cells).filter(".e-summaryrow").html(tableClone.append(ej.buildTag("tr", $cells)));
                        var len = tableClone.find("col").length - (proxy.model.columns.length + level);
                        if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null)
                            $tr.find("tr").prepend("<td class='e-summaryrow'></td>");
                        for (var i = 0; i < len; i++) {
                            tableClone.find("col").first().remove();
                        }
                        for (var i = 0; i < level; i++) {
                            $(tableClone[0].rows).prepend("<td class='e-indentcell'></td>");
                            $(tableClone.find("col")[i]).addClass("e-summary");
                        }
                        $tBody.append($tr);
                    }
                    else
                        $tBody.append($tr.append($cells));
                }
                $.each(row.summaryColumns, function (cindx, col) {
                    var value;
                    if (col.summaryType != "custom")
                        value = aggregates ? aggregates[col.dataMember + " - " + col.summaryType] : proxy._remoteSummaryData[col.dataMember + " - " + col.summaryType];
                    else
                        value = proxy.getSummaryValues(col, summaryData);
                    var prefix = col.prefix ? col.prefix : "",
                    index = proxy.getColumnIndexByField(col.displayColumn), suffix = col.suffix ? col.suffix : "";
                    if (proxy.model.allowScrolling)
                        $($cells[index]).addClass("e-scroller");
                    if ($($cells[index]).html() != "" && prefix == "")
                        prefix = $($cells[index]).html();
                    if (!ej.isNullOrUndefined(col.template)) {
                        var obj = {
                            summaryValue: col.format ? proxy.formatting(col.format, value, proxy.model.locale) : value,
							summaryColumn: col
                        };
                        $($cells[index]).html(proxy._renderEjTemplate(obj.summaryColumn.template, obj,index)).css("text-align", proxy.model.columns[index].textAlign)
                        $($cells[index]).addClass("e-summarytemplate")
                    }
                    else if (index != -1)
                        $($cells[index]).html(prefix + (col.format ? proxy.formatting(col.format, value, proxy.model.locale) : value) + suffix).css("text-align", proxy.model.columns[index].textAlign);
                });
            });
            if (this.model.scrollSettings.frozenColumns > 0) {
                table.first().append($tBody);
                table.last().append($tBodyClone);
            }
            else
                table.append($tBody);
        },
        _assignTitleColumn: function (index, title, $cells, count) {
            for (var i = index; i < this.model.columns.length; i++) {
                var colindex = this.model.columns[i];
                if (count == 0 && colindex.visible != false) {
                    $cells.eq(i).html(title);
                    break;
                }
            }
            return $cells;
        },
        getSummaryValues: function (summaryCol, summaryData) {
            var $value, jsonData;
            if (!ej.isNullOrUndefined(summaryData))
                jsonData = summaryData;
            else if (this.model.filterSettings.filteredColumns.length > 0)
                jsonData = this._filteredRecords;
            else
                jsonData = this._dataSource();

            var dbMgr;
            if (jsonData instanceof ej.DataManager) {
                dbMgr = jsonData;
                jsonData = jsonData.dataSource.json;
            } else
                dbMgr = ej.DataManager(jsonData);

            switch (summaryCol.summaryType) {
                case ej.Grid.SummaryType.Maximum:
                    var obj = ej.max(jsonData, summaryCol.dataMember);
                    $value = ej.getObject(summaryCol.dataMember, obj);
                    break;
                case ej.Grid.SummaryType.Minimum:
                    var obj = ej.min(jsonData, summaryCol.dataMember);
                    $value = ej.getObject(summaryCol.dataMember, obj);
                    break;
                case ej.Grid.SummaryType.Average:
                    $value = ej.avg(jsonData, summaryCol.dataMember);
                    break;
                case ej.Grid.SummaryType.Sum:
                    $value = ej.sum(jsonData, summaryCol.dataMember);
                    break;
                case ej.Grid.SummaryType.Count:
                    $value = jsonData.length;
                    break;
                case ej.Grid.SummaryType.TrueCount:
                    var predicate = ej.Predicate(summaryCol.dataMember, "equal", true);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
                case ej.Grid.SummaryType.FalseCount:
                    var predicate = ej.Predicate(summaryCol.dataMember, "equal", false);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
                case ej.Grid.SummaryType.Custom:
                    var fn = summaryCol.customSummaryValue;
                    if (fn) {
                        if (typeof fn === "string")
                            fn = ej.util.getObject(fn, window);
                        if ($.isFunction(fn))
                            $value = fn.call(this, summaryCol, jsonData);
                    }
                    break;
            }
            return $value;
        },
        _hideCaptionSummaryColumn: function () {
            var headerColumn = this.getHeaderTable().find('.e-headercelldiv[ej-mappingname]').first();
            var captionTd = this.getContentTable().find('.e-groupcaption').clone();
            var groupCaptionParent = this.getContentTable().find('.e-groupcaption').parent();
            var colLength = this.model.columns.length - 1;
            if (this._isCaptionSummary) {
                this.getContentTable().find('.e-summaryrow:not(.e-gcsummary)').remove();
                this.getFooterTable().find("tbody td").slice(-colLength).removeClass("e-groupcaptionsummary").addClass("e-summaryrow");
                if (this.getFooterTable() != null) {
                    this.getContentTable().find('.e-recordplusexpand').parent().children('.e-indentcell').remove();
                }
                if (!this.model.groupSettings.showGroupedColumn && this.getContentTable().find(".e-groupcaptionsummary").not(".e-hide").length) {
                    var sumColumn = +this.getContentTable().find(".e-recordtable:first").parents("tbody:first").find(".e-groupcaption").attr("colspan");
                    if (this._hiddenColumnsField.length == this.model.columns.length - 1 && headerColumn.parent().hasClass("e-hide") || !sumColumn) {
                        for (var i = 0; i < captionTd.length; i++) {
                            groupCaptionParent.eq(i).children().not('.e-hide,.e-recordplusexpand').filter('td.e-groupcaptionsummary:first').addClass("e-hide");
                            var caption = groupCaptionParent.eq(i).find(".e-groupcaption");
                            var colspan = parseInt(caption.attr("colspan"));
                            caption.attr("colspan", ++colspan)
                        }
                    }
                }
            }
            this.getContentTable().find('.e-recordtable').find('.e-indentcell').remove();
        },
        _hideSummaryColumn: function (td, col) {
            var i,j;
            if (col.length > this.model.columns.length)
                col = col.slice(col.length - this.model.columns.length);
            if (!this.model.groupSettings.showGroupedColumn && this.model.showSummary) {
                for (i = 0; i < this.model.columns.length; i++) {
                    for (j = 0; j < this.model.groupSettings.groupedColumns.length || j < this._hiddenColumnsField.length; j++) {
                        var headerColumn = this.getHeaderTable().find('.e-headercelldiv:not(.e-emptyCell)');
                        if (headerColumn.eq(i).parent().hasClass('e-hide')) {
                            col.eq(i).css("display", "none");
                            $(td[i]).addClass("e-hide");
                            break;
                        }
                        else {
                            if (col.eq(i).css("display") == "none")
                                col.eq(i).css("display", "");
                        }
                    }
                }
            }
            else {
                for (i = 0; i < this.model.columns.length; i++) {
                    if (!this.model.columns[i]["visible"]) {
                        col.eq(i).css("display", "none");
                        $(td[i]).addClass("e-hide");
                    }
                    else {
                        if (col.eq(i).css("display") == "none")
                            col.eq(i).css("display", "");
                    }
                }
            }
        },

        _initScrolling: function () {
            var frozen = [], unfrozen = [], hideColumns = 0;
            if (this.model.scrollSettings.enableVirtualization)
                this.model.scrollSettings.allowVirtualScrolling = true;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount].visible === false && columnCount < this.model.scrollSettings.frozenColumns)
                    hideColumns++;
                if (this.model.columns[columnCount]["isFrozen"] === true)
                    frozen.push(this.model.columns[columnCount]);
                else
                    unfrozen.push(this.model.columns[columnCount]);
            }            
            if (frozen.length > 0) {
                var freeze = this.model.scrollSettings.frozenColumns;
                this.model.columns = $.merge($.merge([], frozen), unfrozen);
                this.model.scrollSettings.frozenColumns = frozen.length;
                if (frozen.length != freeze && freeze != 0)
                    this.model.scrollSettings.frozenColumns = freeze;
            }
            if ((this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) && (this.model.allowGrouping || this.model.rowTemplate != null || this.model.detailsTemplate != null || this.model.childGrid != null || this.model.scrollSettings.allowVirtualScrolling || this.model.editSettings.editMode == "batch")) {
                this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this._getLocalizedLabels()["FrozenNotSupportedException"]);
                this._alertDialog.ejDialog("open");
                return;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling) {
				if(!this.model.scrollSettings.enableVirtualization){
					this.model.pageSettings.pageSize = this.model.pageSettings.pageSize == 12 ? Math.round(this.model.scrollSettings.height / 32) + 1 : this.model.pageSettings.pageSize;
					this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
				}
				else{					
					this._vRowHeight = Math.floor(this.getRowHeight() + 1);
					this._virtualRowCount = Math.round(this.model.scrollSettings.height / this._vRowHeight) + 1; 					
					this.model.pageSettings.pageSize  = this.model.pageSettings.pageSize <= 50? 50 :  this.model.pageSettings.pageSize ;
				}
            }
            if (this.model.width || this.model.height) {
                this.model.allowScrolling = true;
                if (this.model.width) this.model.scrollSettings.width = this.model.width;
                if (this.model.height) this.model.scrollSettings.height = this.model.height;
            }
            this._originalScrollWidth = ej.isNullOrUndefined(this.model.scrollSettings.previousStateWidth) ? this.model.scrollSettings.width : this.model.scrollSettings.previousStateWidth;
        },
        _checkScrollActions: function (requestType) {
            if ((!this.model.scrollSettings.allowVirtualScrolling && (requestType == ej.Grid.Actions.Sorting || requestType == ej.Grid.Actions.Reorder)) || requestType == ej.Grid.Actions.Grouping || requestType == ej.Grid.Actions.Ungrouping || requestType == ej.Grid.Actions.Add || requestType == ej.Grid.Actions.Cancel
                || requestType == ej.Grid.Actions.Save || requestType == ej.Grid.Actions.BatchSave || requestType == ej.Grid.Actions.Delete || requestType == ej.Grid.Actions.Filtering || requestType == ej.Grid.Actions.Paging || requestType == ej.Grid.Actions.Refresh || requestType == ej.Grid.Actions.Search)
                return true;
            return false;
        },
        _frozenAlign: function () {
             var gridContent = this.getContent().first(), browserDetails = !ej.isIOSWebView() && this.getBrowserDetails(), direction;
             direction = this.model.enableRTL ? "margin-right" : "margin-left";
             gridContent.find(".e-movablecontent").css(direction, browserDetails && browserDetails.browser === "safari" ? "auto" : gridContent.find(".e-frozencontentdiv").width() + "px");
             this.getHeaderContent().find(".e-movableheader").removeAttr("style").css(direction,browserDetails && browserDetails.browser === "safari" ? "auto" : this.getHeaderContent().find(".e-frozenheaderdiv").width() + "px");
          },
        _refreshScroller: function (args) {
            var gridContent = this.getContent().first(), temp;
            if (ej.isNullOrUndefined(gridContent.data("ejScroller")))
                return;
            if (this.model.scrollSettings.frozenColumns > 0) {
                if (!this._isFrozenColumnVisible()) {
                    gridContent.find(".e-movablecontentdiv").removeAttr("style");
                    this.getHeaderContent().find(".e-movableheaderdiv").removeAttr("style");
                    gridContent.find(".e-frozencontent").width(0);
                    gridContent.find(".e-frozencontentdiv").width(0);
                    gridContent.find(".e-frozencontent").height(0);
                    gridContent.find("e-frozencontentdiv").height(0);
                }
                else if (this._visibleColumns.length <= this.model.scrollSettings.frozenColumns) {
                    var isMovableCol = false;
                    for (var i = this.model.scrollSettings.frozenColumns; i < this.model.columns.length; i++) {
                        if (this._visibleColumns.indexOf(this.model.columns[i].headerText) != -1) {
                            isMovableCol = true;
                            break;
                        }
                    }
                    if (!isMovableCol) {
                        gridContent.find(".e-frozencontentdiv").removeAttr("style");
                        this.getHeaderContent().find(".e-frozenheaderdiv").removeAttr("style");
                        gridContent.find(".e-movablecontent").width(0);
                        gridContent.find(".e-movablecontentdiv").width(0);
                        gridContent.find(".e-movablecontent").height(0);
                        gridContent.find(".e-movablecontentdiv").height(0);
                    }
                }
                else {
                    this._frozenAlign();
                    gridContent.find(".e-movablecontent").scrollLeft(this.getHeaderContent().find(".e-movableheader").scrollLeft());
                    if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && this.getScrollObject()._vScrollbar.value() > this.getScrollObject()._vScrollbar.model.maximum)
                        temp = this.getScrollObject()._vScrollbar.model.maximum;
                }
                this.refreshScrollerEvent();
            }
            if (this.model.scrollSettings.frozenRows > 0) {
                this._initFrozenRows();
                for (var i = 0 ; i < this.getRows().length ; i++) {
                                       $(this.getRows()[i]).filter(":hidden").css("display", "table-row");
                                    }
                if (!this.initialRender && ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && (this.element.height() > this.model.scrollSettings.height))
                    this.getContent().attr("tabindex", "0").ejScroller(this.model.scrollSettings);
                var temp = this.getScrollObject().model.scrollTop;
                var tempLeft = this.getScrollObject().model.scrollLeft;
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && temp > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
                if ((args.requestType == "cancel" || args.requestType == "save") && temp > this._editFormHeight && this.model.editSettings.editMode.indexOf("inlineform") != -1)
                    temp = temp - this._editFormHeight;
                if (args.requestType == ej.Grid.Actions.Add)
                    this.getScrollObject().scrollY(0, true);
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar._scrollData))
                    this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
            }
            if (args.requestType == "beginedit" || args.requestType == "save") {
                var temp = this.getScrollObject().model.scrollTop;
                this.getScrollObject().scrollY(0, true);
            }
            if (!ej.isNullOrUndefined(this.model.dataSource) && (args.requestType == "refresh" || args.requestType=="searching") && this.model.scrollSettings.allowVirtualScrolling) {
                if (this.model.scrollSettings.enableVirtualization && (this._isLocalData || this._virtualDataRefresh) && this._gridRecordsCount > 0)
					this._refreshVirtualView(this._currentVirtualIndex);
				else
					this._refreshVirtualContent(1);
				if(this._currentVirtualIndex == 1)
					this.getScrollObject().scrollY(0);
            }            
            if (this.model.scrollSettings.frozenColumns > 0)
				this.rowHeightRefresh();
			this.getScrollObject().refresh();
            gridContent.ejScroller("model.enableRTL", this.model.enableRTL);
            if (this.model.isResponsive && (args.requestType == 'searching' || args.requestType == "filtering")) {
                var scrollObj = this.getScrollObject();
                var height = scrollObj.isHScroll() ? this.getContentTable().height() + scrollObj.model.buttonSize : this.getContentTable().height();
                height = typeof (this.model.scrollSettings.height) == "string" || height > this.model.scrollSettings.height ? this.model.scrollSettings.height : height
                var scrollWidth= typeof (this.model.scrollSettings.width) == "string" ? this.element.width():this.model.scrollSettings.width;
                var width = scrollWidth;
                this.getContent().ejScroller({ height: height, width: width });
            }
            if (this.getScrollObject().isVScroll() && !this.getScrollObject().model.autoHide) {
                this.getHeaderContent().addClass("e-scrollcss");
				this.getHeaderTable().first().width(this.getContentTable().width());
                !this.getHeaderContent().find(".e-headercontent").hasClass("e-hscrollcss") && this.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
            }
            else
                this._showHideScroller();
            if(this.model.allowPaging && !this.getScrollObject().isVScroll() && !this.getScrollObject().isHScroll() && this.getContentTable().width() != this.getContent().width()){
				this.getContentTable().width(this.getContent().width());
				this.getHeaderTable().width(this.getContentTable().width());
			}
            this._getRowHeights();
            if (temp && !ej.isNullOrUndefined( this.getScrollObject()._vScrollbar) && args.requestType != ej.Grid.Actions.Add) {
                this._currentTopFrozenRow = 0;
                if (temp > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
                this.getScrollObject()._vScrollbar.scroll(temp);
            }
            if(tempLeft && this.model.scrollSettings.frozenColumns > 0 && args.requestType == ej.Grid.Actions.BeginEdit)
            {
                this.getScrollObject()._hScrollbar.scroll(tempLeft);
            }
            if (args.requestType == "virtualscroll") {
                var top = this.getScrollObject().model.scrollTop + this.getScrollObject().model.height - (this.getScrollObject().model.height * .3);
                this.getScrollObject().scrollY(top, true);
            }
        },
        _isFrozenColumnVisible: function () {
            for (var i = 0; i < this.model.scrollSettings.frozenColumns; i++) {
                if (this.model.columns[i].visible)
                    return true;
            }
            return false;
        },
        _frozenPaneRefresh: function () {
            this.getContent().find(".e-frozencontentdiv").css("display", "none");
            this.getHeaderContent().find(".e-frozenheaderdiv").css("display", "none");
            this.getHeaderContent().find(".e-movableheader")[0].style["margin-left"] = "";
            this.getContent().find(".e-movablecontent")[0].style["margin-left"] = "";
            var scrollWidth = ej.isNullOrUndefined(this._scrollObject._vScrollbar) ? 0 : this._scrollObject._vScrollbar["e-vscroll"].width();
            var movableWidth = this.model.scrollSettings.width - scrollWidth - 1;
            if (this.model.scrollSettings.width > this.getContent().find(".e-movablecontentdiv").width()) {
                this.getContent().find(".e-movablecontentdiv").width(movableWidth);
                this.getHeaderContent().find(".e-movableheaderdiv").width(movableWidth);
            }
            this._scrollObject.option("scrollLeft", 0);
        },
        _renderScroller: function () {
            if (!this.model.scrollSettings)
                this.model.scrollSettings = {};
            if (this.model.enablePersistence && (ej.isNullOrUndefined(this.model.scrollSettings.previousStateWidth) || !this.model.scrollSettings.previousStateWidth) && this.model.isResponsive)
                this.model.scrollSettings.previousStateWidth = this.model.scrollSettings.width;
            if (typeof (this._originalScrollWidth) == "string" && !this.model.isResponsive) {
                this.element.css("width", "auto");
                var width = this.element.width();
                if (this.model.scrollSettings.width == "auto" || this._originalScrollWidth == "auto")
                    this._originalScrollWidth = "100%";
                this.model.scrollSettings.width = width * (parseFloat(this._originalScrollWidth) / 100)
            }

            if (typeof (this.model.scrollSettings.height) == "string" && !this.model.isResponsive) {
                var height = this.element.height();
                if (this.model.scrollSettings.height == "auto")
                    this.model.scrollSettings.height = "100%";
                this.model.scrollSettings.height = height * (parseFloat(this.model.scrollSettings.height) / 100)
            }

            if ((this.model.scrollSettings.width || this.model.width) && !this._mediaQuery) {
                var width = this.model.scrollSettings.width || this.model.width;
                if (typeof width == "string")
                    this.element.css("width", this.model.scrollSettings.width || this.model.width);
                else
                    this.element.width(this.model.scrollSettings.width || this.model.width);
            }

            var $content = this.getContent().attr("tabindex", "0"), staticWidth, direction, gridRows = this.getRows();

            if (this.model.scrollSettings.frozenColumns > 0) {
                for (var i = 0 ; i < this.getRows().length ; i++) {
                                       $(this.getRows()[i]).filter(":hidden").css("display", "table-row");
                                   }
                var scrollWidth = this.getContent().find(".e-frozencontentdiv").width() + 20;
                if (scrollWidth > this.model.scrollSettings.width) {
                    this.getContent().remove();
                    this.getHeaderTable().eq(1).remove();
                    this._alertDialog.find(".e-content").text(this.localizedLabels.FrozenColumnsViewAlert);
                    this._alertDialog.ejDialog("open");
                    return;
                }
                staticWidth = this.getContent().find(".e-frozencontentdiv").width();
                direction = this.model.enableRTL ? "margin-right" : "margin-left";
                this.getContent().find(".e-movablecontent").css(direction, staticWidth + "px");
                this.getHeaderContent().find(".e-movableheader").css(direction, staticWidth + "px");
                this.model.scrollSettings["targetPane"] = ".e-movablecontent";
            }
            this._initFrozenRows();
            if (this.model.scrollSettings.autoHide)
                this.model.scrollSettings["show"] = $.proxy(this._showHideScroller, this);
            var proxy = this;
            if (!this.model.scrollSettings.frozenRows)
                this.model.scrollSettings["scroll"] = function (e) {
				if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.handler == "e-hhandle"){
					if (proxy.model.allowFiltering && (proxy.model.filterSettings.filterType == "menu" || proxy._isExcelFilter)) 				
						!proxy._isExcelFilter ? proxy._closeFilterDlg() : proxy._excelFilter.closeXFDialog();	
					proxy._checkScroller(e, this);
				}
				else{
					proxy._scrollValue = e.scrollTop;
					proxy.model.currentIndex = e.scrollTop == 0 ? e.scrollTop : Math.floor(e.scrollTop / proxy._vRowHeight);	
				}
			};
			if(!this.model.scrollSettings.allowVirtualScrolling && this.model.currentIndex > 0 && !this.model.scrollSettings.scrollTop){
				var sTop = this.model.currentIndex * this.getRowHeight();
				this.model.scrollSettings["scrollTop"] = sTop;
			}
			$content.ejScroller(this.model.scrollSettings);
			if (this.model.allowRowDragAndDrop && this.model.allowScrolling && ej.gridFeatures.dragAndDrop)
			    $content.ejScroller({ thumbStart: function () { return false } });
            if (this.model.rowTemplate != null && ((!ej.isIOSWebView()) && (this.getBrowserDetails().browser == "msie" || this.getBrowserDetails().browser == "safari")))
                this.getScrollObject().refresh();            
            if (this.model.scrollSettings.frozenColumns > 0 && this.model.scrollSettings.frozenRows == 0 && this.getScrollObject()._vScrollbar && this.getScrollObject()._hScrollbar)
                this.getScrollObject()._vScrollbar._scrollData.skipChange = this.getScrollObject()._hScrollbar._scrollData.skipChange = true;
            if (!this.model.scrollSettings.autoHide)
                this._showHideScroller();
            if ((!ej.isIOSWebView() && this.getBrowserDetails().browser == "safari") && this.model.scrollSettings.frozenColumns > 0)
                this.getHeaderContent().find(".e-movableheader").add(this.getContent().find(".e-movablecontent")).css(direction, "auto");
            this.refreshScrollerEvent();
            if (this.model.scrollSettings.frozenColumns > 0 && !this._isFrozenColumnVisible())
                this._frozenPaneRefresh();
            if (proxy.model.scrollSettings.allowVirtualScrolling) {
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
                $content.ejScroller({
                    scroll: function (e) {
						if(proxy.model.scrollSettings.enableVirtualization && e.scrollData != null && e.scrollData.handler != "e-hhandle"){
							e["reachedEnd"] = e.scrollData.scrollable - e.scrollTop == 0;							
							if(e.source == "thumb"){
							    var keys = ej._getObjectKeys(proxy._virtualLoadedRows);
								var index = (proxy._currentVirtualIndex + 2).toString();
								if(proxy.model.scrollSettings.virtualScrollMode == "continuous" && $.inArray(index, keys) == -1 && index < proxy._totalVirtualViews)
									proxy._isContinuous = true;
								else {									
									e.model.scrollTop = e.scrollTop;	
									proxy._isContinuous = false;
									e.cancel = true;									
								}								
							}
							if(e.source == "button" || e.source == "key" || e.source == "wheel"){
								if($("#" + proxy._id + "_WaitingPopup").is(":visible"))	
									e.cancel = true;
								else{
									proxy._isThumbScroll = false;
									proxy._virtualViewScroll(e);
								}
								if(proxy.model.scrollSettings.virtualScrollMode == "continuous" && e["reachedEnd"])
									this.refresh();
							}
							proxy.model.currentIndex = e.scrollTop == 0 ? e.scrollTop : Math.floor(e.scrollTop / proxy._vRowHeight);
						}
						else{
							if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.handler == "e-hhandle" && proxy.model.allowFiltering && (proxy.model.filterSettings.filterType == "menu" || proxy._isExcelFilter))
								!proxy._isExcelFilter ? proxy._closeFilterDlg() : proxy._excelFilter.closeXFDialog();
							e["reachedEnd"] = this.content()[0].scrollHeight - e.scrollTop == this.content()[0].clientHeight;
							if ((e.source == "button" || e.source == "key" || e.source == "wheel") && proxy.model != null)
								proxy._virtualScroll(e);
							if (e.source == "wheel" && e.scrollTop != proxy._scrollValue)
								e.scrollTop = proxy._scrollValue;
							proxy._checkScroller(e, this);
						}
                    },
                    thumbEnd: function (e) {
						if(proxy.model.scrollSettings.enableVirtualization && proxy.model.scrollSettings.virtualScrollMode == "continuous")
							e["reachedEnd"] = e.scrollData.scrollable - e.model.scrollTop == 0;
                        else if (e.originalEvent && !$(e.originalEvent.target).hasClass("e-rowcell"))
                            e["reachedEnd"] = this.content()[0].scrollHeight - e.scrollData.sTop == this.content()[0].clientHeight;
                        if (e.scrollData.handler == "e-hhandle")
                            return;
                        if (proxy.model != null && e.originalEvent){
                            if(proxy.model.scrollSettings.enableVirtualization){
								proxy._isThumbScroll = true;															
								proxy._virtualViewScroll(e);
								if(proxy.model.scrollSettings.virtualScrollMode == "continuous" && e["reachedEnd"])
									this.refresh();
								if(proxy._isLocalData)																															
									proxy.element.ejWaitingPopup("hide");
							}
							else
								proxy._virtualScroll(e);
						}						
                    },
					scrollEnd: function(e){
						if(e.scrollData.type == "mousewheel" || (e.scrollData.model != null && e.scrollData.model.orientation == "horizontal")) return;			
						if(proxy.model.scrollSettings.enableVirtualization && !proxy._isContinuous){												
							var currentPage = proxy._calculateCurrentViewPage(e.model);
							var isVirtualPage = $.inArray(currentPage, proxy._virtualLoadedPages) != -1;
							if(isVirtualPage){
								proxy._isThumbScroll = true;											
								proxy._virtualViewScroll(e);								
								proxy.element.ejWaitingPopup("hide");	
								if(proxy._totalVirtualViews <= proxy._maxViews * 3)
									this._content[0].scrollTop = e.scrollData.scrollTop;															
							}
							else {                             
								if(!isVirtualPage)
									proxy.element.ejWaitingPopup("show");							
								e.cancel = true;
							}
						}						
					}
                });
            }
        },
		_checkScroller: function(e, scrollObj){
			var scrollLeft = e.scrollLeft > 0 ? e.scrollLeft : Math.abs(e.scrollLeft);
			if(e.source == "thumb" && (scrollObj.content()[0].scrollWidth - scrollLeft == scrollObj.content()[0].clientWidth || scrollLeft == 0)){
				if(this.model.enableRTL){
					var hLeft = scrollLeft == 0 ? e.scrollData.scrollable: 0;
					e.scrollData.sTop = e.model.scrollLeft = hLeft;
					scrollObj.content().scrollLeft(hLeft);	
				}
				scrollObj._hScrollbar.refresh();
			}
		},
        _showHideScroller: function () {
            if (this.getScrollObject().isVScroll()) {
                this.getHeaderContent().find("div").first().addClass("e-headercontent");
                !this.model.scrollSettings.autoHide && this.getHeaderContent().addClass("e-scrollcss")
            } else
                this.element.find(".e-gridheader").removeClass("e-scrollcss");
             if (this.model.scrollSettings.frozenColumns == 0 && !this._mediaQuery) {
                if (!this.element.find(".e-gridheader").hasClass("e-scrollcss") && (this.model.filterSettings.filteredColumns.length || (this._hiddenColumns.length&&!this.model.minWidth))) {
                    this.getHeaderTable().removeAttr('style');
                    this.getContentTable().removeAttr('style');
                }
                else {
                    this.getHeaderContent().find("div table").first().width(this.getContentTable().width());
                    this.getContent().find("div table").first().width(this.getContentTable().width());
                    this.getHeaderTable().width(this.getContentTable().width());
                }
            }
            this._isHscrollcss();
        },
        _isHscrollcss: function () {
            var scroller = this.getContent().data("ejScroller"), css = scroller && (scroller.isHScroll() || scroller.isVScroll()) ? "addClass" : "removeClass";
            this.getHeaderContent().find(".e-headercontent")[css]("e-hscrollcss")
        },
        _initFrozenRows: function () {
            var gridRows = this.getRows();
            if (!this.model.currentViewData || this.model.currentViewData.length == 0)
                return;
            if (this.model.scrollSettings.frozenRows > 0 && gridRows != null) {
                this.model.scrollSettings["scroll"] = $.proxy(this._scroll, this);
                this.getContent().find(".e-frozeny").removeClass("e-frozeny")
                    .end().find(".e-frozenrow").removeClass("e-frozenrow");
                if (!ej.isNullOrUndefined(gridRows[0][this.model.scrollSettings.frozenRows - 1]) && !ej.isNullOrUndefined(gridRows[1][this.model.scrollSettings.frozenRows - 1]) && this.model.scrollSettings.frozenColumns > 0)
                    $(gridRows[0][this.model.scrollSettings.frozenRows - 1].cells).add(gridRows[1][this.model.scrollSettings.frozenRows - 1].cells).addClass("e-frozeny").parent().addClass("e-frozenrow");
                else if (!ej.isNullOrUndefined(this.getRowByIndex(this.model.scrollSettings.frozenRows - 1)[0]))
                    $(gridRows[this.model.scrollSettings.frozenRows - 1].cells).addClass("e-frozeny").parent().addClass("e-frozenrow");
                if (this.getContent().height() > this.model.scrollSettings.height) {
					 var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null;
                    if (!this.initialRender && !ej.isNullOrUndefined(scrollObj) && ej.isNullOrUndefined(scrollObj._vScrollbar))
                        this._getRowHeights();
                    this.model.scrollSettings.height = this._rowHeightCollection[Math.floor(this.model.scrollSettings.height / this._rowHeightCollection[1])] + 18;
                }
            }
            else
                delete this.model.scrollSettings["scroll"];            
        },
        refreshScrollerEvent: function () {
            var proxy = this;
            this.getContent().find(".e-content:first,.e-movablecontent").scroll(ej.proxy(function (e) {
                if (this.model.scrollSettings.targetPane){
                    var $movablecontent = $(e.currentTarget).hasClass("e-movablecontent") || !this.model.currentViewData || this.model.currentViewData.length == 0 ? $(e.currentTarget):$(e.currentTarget).find(".e-movablecontent");
                    this.getHeaderContent().find(".e-movableheader").scrollLeft($movablecontent.scrollLeft());
                }
                else
                    this.getHeaderContent().find("div").first().scrollLeft($(e.currentTarget).scrollLeft());                
                if (this.model.scrollSettings.frozenRows > 0 && this.model.editSettings.editMode.indexOf("inlineform") != -1 && this.model.isEdit) {
                    var scrollTop = e.target.scrollTop;
                    this.getContent().find(".e-content").scrollTop(0);
                    this.getScrollObject().scrollY(this.getScrollObject().model.scrollTop + scrollTop, true);
                }
            }, this));
            this.element.find(".e-gridheader").find(".e-headercontent,.e-movableheader").scroll(ej.proxy(function (e) {
                var $currentTarget = $(e.currentTarget);
                if (this.model.scrollSettings.targetPane) {
                    this.getContent().find(".e-movablecontent").scrollLeft($currentTarget.scrollLeft());
                    this.model.showSummary && this.getFooterContent().find(".e-movablefooter").scrollLeft($currentTarget.scrollLeft());;
                }
                else {
                    this.model.showSummary && this.getFooterContent().scrollLeft($currentTarget.scrollLeft());
                    this.getContent().find(".e-content").first().scrollLeft($currentTarget.scrollLeft());
                }
            }, this));
        },
		clearFiltering: function(field){
		    if (field) {
		        this._clearFilter(field);
		        if (this.model.filterSettings.filterType != "filterbar")
		            for (var i = 0; i < this.filterColumnCollection.length; i++) {
		                if (this.filterColumnCollection[i].field == field)
		                    this.filterColumnCollection.splice(i, 1);
		            }
		    }
		    else {
		        var fltrCols = this.model.filterSettings.filteredColumns, i = 0;
		        while (i < fltrCols.length) {
		            this._clearFilter(fltrCols[i].field);
		        }
		        this.filterColumnCollection = [];
		        if (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel")
		            this.getHeaderTable().find(".e-filtericon").removeClass("e-filteredicon e-filternone");
		    }
		},
		_clearFilter: function (field) {
		    var filterType = this.model.filterSettings.filterType;
		    if (!ej.isNullOrUndefined(this.getColumnByField(field).filterType))
		        filterType = this.getColumnByField(field).filterType;
		    switch (filterType) {
		        case ej.Grid.FilterType.FilterBar:
		            if ($.inArray(this.getColumnByField(field), this.filterColumnCollection) != -1) {
		                this.getHeaderTable().find("#" + field + "_filterBarcell").val("");
		                this._currentFilterbarValue = "";
		                var index = $.inArray(field, this.filterColumnCollection);
		                this._currentFilterColumn = this.getColumnByField(field);
		                this._showFilterMsg();
		            }
		            break;
		        case ej.Grid.FilterType.Menu:
					var id = "#" + this._id + "_" + this._$colType + "Dlg";
					if (this._$colType == "boolean")
						$(id).find('.e-value .e-js').ejCheckBox("model.checked", false);
					else
						if (this._$colType == "number")
							$(id).find('.e-numerictextbox').ejNumericTextbox("model.value", "");
						else
							$(id).find(".e-value input").val("");					
					if (this._excelFilterRendered || this._isExcelFilter)
					    delete this._excelFilter._predicates[0][field];
					this._$curFieldName = field;						
					break;
				case ej.Grid.FilterType.Excel:
					delete this._excelFilter._predicates[0][field];						
					this._excelFilter.closeXFDialog();
					this._$curFieldName = field;
					break;
			}
			this.filterColumn(field, "", "", "or");							
		},
		clearSearching: function(){
			this.element.find(".e-gridtoolbar #" + this._id + "_search").val("");
			this.search("");
			$.extend(this.model.searchSettings, this.defaults.searchSettings);
		},
        _renderByFrozenDesign: function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this.model.scrollSettings.frozenColumns))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            this.getContent().find("div").first().get(0).innerHTML = $.render[this._id + "_FrozenTemplate"]({ datas: this.model.currentViewData }, colgroups);
            this.setGridContentTable(this.getContent().find(".e-table").attr("role", "grid"));
        },
        addFrozenTemplate: function () {
            var template = "<div class='e-frozencontentdiv'>"
            + "<table cellspacing='0.25px' class='e-table'>{{:~colgroup1}}<tbody>"
            + "{{for datas tmpl='" + this._id + "_JSONFrozenTemplate'/}}"
            + "</tbody></table></div>"
            + "<div class='e-movablecontent'><div class='e-movablecontentdiv'><table cellspacing='0.25px' class='e-table'>{{:~colgroup2}}<tbody>"
            + "{{for datas tmpl='" + this._id + "_JSONTemplate'/}}"
            + "</tbody></table></div></div>", templates = {};
            templates[this._id + "_FrozenTemplate"] = template;
            $.templates(templates);
        },
        _getTopRow: function (offsetTop) {
            var currentTopRow = this.model.scrollSettings.frozenRows, i = 0;
            if (offsetTop > 10) {
                for (var i = 0; i < this._rowHeightCollection.length; i++) {
                    if (this._rowHeightCollection[i] > offsetTop) {
                        currentTopRow = this.model.scrollSettings.frozenRows + i - 1;
                        break;
                    }
                }
            }
            return { imaginaryIndex: currentTopRow, actualIndex: i };
        },
        _showHideRow: function (from, to, action, scrollPosition) {
            var rows = this.getRows();
            if (this.model.scrollSettings.frozenColumns > 0)
                $(rows[0]).slice(from, to).add($(rows[1]).slice(from, to).toArray())[action]();
            else
                $(rows).slice(from, to)[action]();
            this._currentTopFrozenRow = action == "show" ? from : to;
            this.getScrollObject()._changevHandlerPosition(scrollPosition);
        },
        _scroll: function (args) {
            if (args.scrollData != null && args.scrollData.dimension != "width") {
                args.cancel = true;
                var rows = this.getRows(), indexes = this._getTopRow(args.scrollTop), currentTopRow = indexes.imaginaryIndex, frozenRows;
                if (currentTopRow > this._currentTopFrozenRow)
                    this._showHideRow(this.model.scrollSettings.frozenRows, currentTopRow, "hide", args.scrollTop);
                else if (currentTopRow < this._currentTopFrozenRow)
                    this._showHideRow(currentTopRow, this._currentTopFrozenRow + 1, "show", args.scrollTop);
                var movableContent = this.getContentTable().last().find("tr");
                var border = (parseInt(movableContent.last().find("td:first").css("border-top-width")) * 2) + 1;
                if (args.scrollTop == this.getScrollObject()._vScrollbar.model.maximum && ((movableContent.last()[0].offsetTop + movableContent.last().height() - border) > this.element.find(".e-content").height())) {
                    var totalHeight = movableContent.last().prev()[0].offsetTop + movableContent.last().prev().height();
                    var count = 1;
                    for (var i = (movableContent.length - 2) ; totalHeight - border > this.element.find(".e-content").height() ; i++) {
                        totalHeight = movableContent[i].offsetTop + movableContent.eq(i).height();
                        count++;
                        break;
                    }
                    this._showHideRow(this.model.scrollSettings.frozenRows, currentTopRow + count, "hide", args.scrollTop);
                }
                args.model.scrollTop = args.scrollTop;
            }
            else {
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar._scrollData))
                    this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
            }
        },
        _renderAlertDialog: function () {
            var $contentDiv = ej.buildTag('div.e-content', this._getLocalizedLabels()["frozenColumnsMessage"])
                , $buttons = ej.buildTag('span.e-buttons', "<input type='button' class='e-flat' id=" + this._id + 'ConfirmDialogOK' + " value='" + this._getDeprecatedLocalizedLabel("OKButton") + "'/>");
            this._alertDialog = ej.buildTag('div#' + this._id + 'AlertDialog');
            this._alertDialog.append($contentDiv).append($buttons);
            this.element.append(this._alertDialog);
            $buttons.find("input").ejButton({
                cssClass: this.model.cssClass,
                showRoundedCorner: true,
                size: "mini",
                click: $.proxy(function (args) {
                    this._alertDialog.ejDialog("close");
                }, this)
            });
            this._renderFDialog(this._id + 'AlertDialog');
            this._alertDialog.ejDialog({ width: "auto", enableModal: true });
        },
        _renderFDialog: function (id) {
            $("#" + id).ejDialog({ showOnInit: false, "enableRTL": this.model.enableRTL, "cssClass": this.model.cssClass, "showHeader": false, width: 260, enableResize: false, allowKeyboardNavigation: false, content: "#" + this._id });
        },
        _virtualScroll: function (e) {
			if (this.selectedRowsIndexes.length == this._gridRecordsCount)
                this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").prop("checked", "checked");
            if (e != null) {
                var flag = 0;
                var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
                var pageInfo = this.model.pageSettings;
                var tbody = this.getContentTable()[0].tBodies[0];
                var virtualRows = $(tbody).find('tr.e-virtualrow');
                pageInfo.totalPages = Math.ceil(recordCount / pageInfo.pageSize);
                if (e.scrollTop !== undefined)
                    e.model.scrollTop = e.scrollTop;
                if (e.reachedEnd != undefined) e.model.reachedEnd = e.reachedEnd;
                var currentPageNo = this._calculateCurrenPage(virtualRows, this.getContentTable(), e.model);
                if (currentPageNo > pageInfo.totalPages)
                    currentPageNo = pageInfo.totalPages;
                if (pageInfo.currentPage != currentPageNo && $.inArray((currentPageNo - 1) * pageInfo.pageSize, this.virtualLoadedPages) == -1 && this.element.find(".gridform:visible").length == 0) {
                    this._isVirtualRecordsLoaded = false;
                }
                if (!this._isVirtualRecordsLoaded) {
                    if ($.inArray((currentPageNo - 1) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                        if (this.model.scrollSettings.virtualScrollMode == "continuous" && !e.reachedEnd)
                            return
                        if (currentPageNo == pageInfo.totalPages && $.inArray((currentPageNo - 2) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                            flag++;
                            this.set_currentPageIndex(currentPageNo);
                        }
                        if (flag == 1) this._lastRow = true;
                        this.set_currentPageIndex(currentPageNo);
                    }
                    pageInfo.currentPage = currentPageNo;
                }
                else
                    pageInfo.currentPage = currentPageNo;
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
        },
		_virtualViewScroll: function (e) {
            if (e != null) {                
                if (e.scrollTop !== undefined)
                    e.model.scrollTop = e.scrollTop;
                if (e.reachedEnd != undefined) e.model.reachedEnd = e.reachedEnd;
                var currentVirtualIndex = this._calculateCurrentVirtualIndex(e);
                if (this.model.isEdit)
                    this.cancelEdit();
                if ($.inArray(currentVirtualIndex, this._currentLoadedIndexes) == -1)
                    this._isVirtualRecordsLoaded = false;                               
                if (!this._isVirtualRecordsLoaded)                     
                    this.set_currentVirtualIndex(currentVirtualIndex);                							
            }
		},
        _createPagerStatusBar: function () {
            var $statusBar = this.element.find(".e-pagerstatusbar");
            if ($statusBar.length)
                $statusBar.remove();
            var $pagermsgDiv = ej.buildTag('div.e-pagermsgdiv');
            this.$pagerStatusBarDiv = ej.buildTag('div.e-pagerstatusbar').append($pagermsgDiv);
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") {
                var $messageDiv = ej.buildTag('div.e-pagerfiltermsg').css("display", "none");;
                this.$pagerStatusBarDiv.append($messageDiv);
            }
            this.$pagerStatusBarDiv.appendTo(this.element);
            this.$pagerStatusBarDiv.css("display", "none");
        },
        _refreshVirtualContent: function (currentPage) {
            var rowHeight = this.getRowHeight();
            var recordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (currentPage != null) {
                this._currentPage(currentPage);
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
            var currentData = this.model.currentViewData;
            if (!this.model.scrollSettings.enableVirtualization)
                this._virtualLoadedRecords[currentPage] = currentData;
            var isVirtualization = 0;
            if (this.model.scrollSettings.enableVirtualization)
                isVirtualization = 1;
            var currentIndex = isVirtualization == 1 ? this.getCurrentIndex() + 1 : this.getCurrentIndex();
            var tbody = this.getContentTable()[0].tBodies[0];
            if (currentIndex > 1) {
                var virtualTRTop = document.createElement("tr");
                $(virtualTRTop).addClass("e-virtualrow").css("height", rowHeight * currentIndex).prependTo(tbody);
            } if (currentIndex + this.model.pageSettings.pageSize <= recordsCount && this.getContentTable().find("tr").last().hasClass("e-virtualrow") != true && this.model.scrollSettings.frozenColumns == 0) {
                var virtualTRBottom = document.createElement("tr");
                var virtualHeight = this.model.scrollSettings.virtualScrollMode == "normal" ? rowHeight * (recordsCount - (currentIndex + this.model.pageSettings.pageSize)) : 1;
                $(virtualTRBottom).addClass("e-virtualrow").css("height", virtualHeight).appendTo($(tbody));
            }
            this.virtualLoadedPages = new Array();
            this.orderedVirtualLoadedPage = [];
            this.virtualLoadedPages.push(currentIndex >= isVirtualization ? currentIndex : isVirtualization);
            this.orderedVirtualLoadedPage.push(currentIndex >= isVirtualization ? currentIndex : isVirtualization);
            var focusTR = $(tbody).find('tr:not(.e-virtualrow)').attr('name', currentIndex >= isVirtualization ? currentIndex : isVirtualization)[0];
            if (focusTR && focusTR.previousSibling && ($(focusTR.previousSibling).hasClass("e-virtualrow") || focusTR.previousSibling.offsetTop > (currentIndex * this.getContent().height()))) {
                this.getContent().children("div").first().scrollTop(this.getContent().find(".content").scrollTop() - (this.getContent().find(".content").scrollTop() - focusTR.offsetTop));
                this._isVirtualRecordsLoaded = true;
            }
        },
        isIntermediate: function(){
            if (this.model.currentIndex < this.model.pageSettings.pageSize * (this.model.pageSettings.currentPage - 1))
                return true;
            else
                return false;
        },
        _refreshVirtualView: function (currentIndex, isSelection, rowIndex) {
			if(!this._singleView){			
				var virtualRowCount = this._virtualRowCount;				
				if(currentIndex){     
					var scrollRefresh, currentPage;
					if(currentIndex > this._totalVirtualViews){						
						currentIndex = 1;					
						scrollRefresh = true;						
					}
					if (isSelection == "selectRows") {
					    scrollRefresh = true;
					}
					this._currentVirtualIndex = currentIndex;
					if (!this._virtualLoadedRecords[currentIndex]) {
					    if (!this._virtualDataRefresh && this._currentVirtualIndex != this._totalVirtualViews) scrollRefresh = true;
					    currentPage = Math.ceil(currentIndex * this._virtualRowCount / this.model.pageSettings.pageSize);
					}
					else {
					    var scrollObj = this.getScrollObject();
					    currentPage = Math.ceil((scrollObj.scrollTop() + this.model.scrollSettings.height) / this._vRowHeight / this.model.pageSettings.pageSize);
					}
					this._refreshVirtualViewScroller(scrollRefresh, isSelection, rowIndex);
					if(currentPage > this.model.pageSettings.totalPages) currentPage = this.model.pageSettings.totalPages;
					if(currentPage <= 0) currentPage = 1;
					if($.inArray(currentPage, this._virtualLoadedPages) == -1)
						this.gotoPage(currentPage);
					else{
						this._currentPage(currentPage);
						if(!this._checkCurrentVirtualView(this._virtualLoadedRecords, currentIndex))
							this._needPaging = true;
						else
							this._needPaging = false;
						this._getVirtualLoadedRecords(this.model.query);
						this._replacingVirtualContent();				
					}
				}
				else{               					
					this._refreshVirtualViewDetails();					
					var rows = $(this.getContentTable()[0].rows);
					this._setVirtualTopBottom();
					if (this.initialRender){
						for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
							var currentLoadedIndex = this._currentLoadedIndexes[i], viewIndex = (i + 1) * virtualRowCount, viewCount = i * virtualRowCount;
							$(rows[viewIndex - 1]).addClass("e-virtualview" + currentLoadedIndex);
							var hex = currentLoadedIndex.toString(32);
							var vRows = rows.slice(viewCount, viewCount + virtualRowCount).attr('name', hex).detach();
							this._virtualLoadedRows[currentLoadedIndex] = vRows;
							vRows.appendTo(this.getContentTable());
						}
						if(this._currentVirtualIndex > 1) 
							this._refreshVirtualViewScroller();											
					}			
					this._eventBindings();
				}
				if($.inArray(this._currentPage(), this._virtualLoadedPages) == -1)
					this._virtualLoadedPages.push(this._currentPage());				
			}
			else {
				this._singleView = false;				
				this._addLastRow();	
				this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
				var hex = this._currentVirtualIndex.toString(32);				
				$(this._gridRows).attr('name', hex);
				this._virtualLoadedRows[this._currentVirtualIndex] = this._gridRows;				
				this._eventBindings();
			}
			if(!currentIndex && (this.model.queryCellInfo || this.model.rowDataBound)){
				for(var i = 0; i < this._currentLoadedIndexes.length; i++){					
					if($.inArray(this._currentLoadedIndexes[i], this._queryCellView) == -1)
						this._queryCellView.push(this._currentLoadedIndexes[i]);						
				}
			}
			this._isThumbScroll = false;
			this._virtualDataRefresh = false;
        },
		_refreshVirtualViewData: function(){
			this._virtualLoadedRecords = {};
			this._virtualLoadedRows = {};	
			this._virtualLoadedPages = [];	
			this._virtualPageRecords = {};
			this._queryCellView	= [];									
			if(this.model.pageSettings.totalPages != null && this._currentPage() > this.model.pageSettings.totalPages){
				this._currentPage(1);
				this._currentVirtualIndex = 1;
			}			
		},
		setCurrentPageData: function(currentData){
			if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
				this._refreshVirtualViewData();
				this._refreshVirtualViewDetails();										
				this._setVirtualLoadedRecords(currentData, this._currentPage());
				this._refreshVirtualView(this._currentVirtualIndex);
			}
		},
		_refreshVirtualViewScroller: function (needRefresh, isSelection, rowIndex) {
			var scrollValue;
			if ((this.initialRender && !this.model.scrollSettings.scrollTop) || needRefresh) {
			    var rowHeight = this._vRowHeight;
			    scrollValue = this.model.currentIndex * this._vRowHeight;
			}
			if (isSelection == "selectRows") {
			    scrollValue = rowIndex * this._vRowHeight;
			}
			else
				scrollValue = this._scrollObject.model.scrollTop;
			this.getContent().ejScroller("model.scrollTop", scrollValue);           
            this._scrollValue = scrollValue;
        },
		_calculateCurrentViewPage: function (args) {
			if(!args) args = this._scrollObject.model;
            var pageSize = this.model.pageSettings.pageSize;                                
            var currentPage =  Math.ceil((args.scrollTop + this.model.scrollSettings.height) / this._vRowHeight / pageSize);
			// if(this.model.scrollSettings.virtualScrollMode == "continuous")
				// currentPage = Math.ceil(this._currentVirtualIndex * this._virtualRowCount / this.model.pageSettings.pageSize);
            if(this.model.pageSettings.totalPages == null)
                this.model.pageSettings.totalPages = Math.ceil(this._getVirtualTotalRecord() / pageSize);                         
            if(currentPage > this.model.pageSettings.totalPages)
                currentPage = this.model.pageSettings.totalPages;
            this.model.pageSettings.currentPage = currentPage;
            return currentPage;
        },
		_calculateCurrentVirtualIndex: function (e) {
            var args = e.model, recordCount = this._getVirtualTotalRecord();
            var currentIndex, trEle, isLast, viewTr = [], cur, oTop, len, sTop = args.scrollTop;
            var index = sTop + this.model.scrollSettings.height;
            currentIndex = (sTop + this._vRowHeight) / this._vRowHeight / this._virtualRowCount;
            currentIndex = Math.ceil(currentIndex);
            if (sTop >= this._scrollValue && args.virtualScrollMode == "continuous" && args.reachedEnd) 
                currentIndex = currentIndex + 1;                      
            if(currentIndex > this._totalVirtualViews) currentIndex = this._totalVirtualViews;
            if(currentIndex <= 0) currentIndex = 1;                
            if ($.inArray(currentIndex, this._currentLoadedIndexes) !== -1 && this._virtualLoadedRows[currentIndex] && sTop != e.scrollData.scrollable) {
                var viewTrs = this.getContentTable()[0].rows; len = viewTrs.length;
                var virtualTopHeight = this.getContent().find(".e-virtualtop").height();
                isLast = sTop >= this._scrollValue;
                for (var i = 0; i < len; i++) {
                    cur = viewTrs[i];
                    oTop = cur.offsetHeight + cur.offsetTop + virtualTopHeight;
                    if (oTop > sTop + this.model.scrollSettings.height) {
                        if (viewTr.length === 0 && i !== 0)
                            viewTr = [viewTrs[cur.offsetTop <= sTop + this.model.scrollSettings.height ? i : i - 1]];
                        break;
                    }
                    if (oTop >= sTop && oTop <= sTop + this.model.scrollSettings.height) {
                        viewTr.push(cur);
                        if (isLast === false && viewTr.length > 1)
                            break;
                    }
                }
                trEle = $(sTop >= this._scrollValue ? viewTr[viewTr.length - 1] : viewTr[0]);
                if(trEle.length)
                    currentIndex = parseInt(trEle.attr("name"), 32);
            }						
            this._scrollValue = sTop;           
            return currentIndex;
        },
        _calculateCurrenPage: function (virtualRows, target, args) {
            var pageSize = this.model.pageSettings.pageSize;
            var currentPage, tempCPage, diff, proxy = this, trEle, isLast, viewTr = [], cur, oTop, len,currentRowValue,$currentRow;
            var rowHeight = this.getRowHeight();
            currentPage = (args.scrollTop + this.model.scrollSettings.height) / rowHeight / pageSize;            
            currentRowValue = (this.model.pageSettings.pageSize * (this.model.pageSettings.currentPage -1 ));
			 $currentRow = this.getContentTable().find("tr[name="+currentRowValue+"]").eq(0);
			if ($currentRow.length && $currentRow.offset().top > 0 && currentPage >= 1 &&  args.scrollTop < this._scrollValue && this.virtualLoadedPages.indexOf(Math.ceil(currentPage - 1) * pageSize) !== -1)
                currentPage = Math.floor(currentPage);
            else
                currentPage = Math.ceil(currentPage);

            if (args.scrollTop >= this._scrollValue && args.virtualScrollMode == "continuous" && args.reachedEnd) {
                currentPage = this.virtualLoadedPages[this.virtualLoadedPages.length - 1] / pageSize + 2;
            }

            if ($.inArray((currentPage - 1) * pageSize, this.virtualLoadedPages) !== -1) {
                var viewTrs = this.getContentTable().children("tbody").children("tr"); len = viewTrs.length;
                isLast = args.scrollTop >= this._scrollValue;
                for (var i = 0; i < len; i++) {
                    cur = viewTrs[i];
                    oTop = cur.offsetHeight + cur.offsetTop;
                    if (oTop > args.scrollTop + proxy.model.scrollSettings.height) {
                        if (viewTr.length === 0 && i !== 0)
                            viewTr = [viewTrs[cur.offsetTop <= args.scrollTop + proxy.model.scrollSettings.height ? i : i - 1]];
                        break;
                    }
                    if (oTop >= args.scrollTop && oTop <= args.scrollTop + proxy.model.scrollSettings.height) {
                        viewTr.push(cur);
                        if (isLast === false && viewTr.length > 1)
                            break;
                    }
                }
                trEle = $(args.scrollTop >= this._scrollValue ? viewTr[viewTr.length - 1] : viewTr[0]);
                if (trEle.hasClass('e-virtualrow')) {
                    if (viewTr.length === 1) {
                        currentPage++;
                    }
                }
                else
                    currentPage = parseInt(trEle.attr("name"), 10) / pageSize + 1;
            }
            this._scrollValue = args.scrollTop;
            for (var index = 0; index < virtualRows.length; index++) {
                var val = virtualRows[index];
                if (val.offsetTop + val.offsetHeight >= args.scrollTop) {
                    var prevVirtualPage = this._calculatePrevPage(virtualRows, target, args);
                    this._prevPageNo = prevVirtualPage;
                    if (currentPage == 0)
                        currentPage = 1;
                    currentPage = currentPage > this.model.pageSettings.totalPages ? this.model.pageSettings.totalPages : currentPage;
                    return currentPage;
                }
            }
            return currentPage;
        },
        _calculatePrevPage: function (virtualRows, target, args) {
            for (var i = 0; i < virtualRows.length; i++) {
                var val = virtualRows[i];
                if (val.offsetTop + val.offsetHeight >= args.scrollTop) {
                    var trElement = $(val).prevAll('tr[name]')[0];
                    if (trElement != null) {
                        return Math.ceil(parseInt($(trElement).attr('name'), 10) / this.model.pageSettings.pageSize) + 1;
                    }
                }
            }
            return -1;
        },
        _refreshVirtualPagerInfo: function () {
            var model = {};
            model.pageSize = this.model.pageSettings.pageSize;            
            model.totalRecordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (model.totalRecordsCount == 0)
                this._currentPage(0);
            model.currentPage = this._currentPage();
            model.totalPages = Math.ceil(model.totalRecordsCount / model.pageSize);

            return model;
        },
        _showPagerInformation: function (model) {
            var from = (model.currentPage - 1) * model.pageSize;
            $(this.$pagerStatusBarDiv).find("div:first").html(String.format(this.localizedLabels.PagerInfo, model.currentPage, model.totalPages, model.totalRecordsCount), from, from + model.pageSize);
            $(this.$pagerStatusBarDiv).css('display', 'block');
        },
        _headerCellMerge: function(args){
            args.headerCellMerge = function(index, colspan){
                var thead = this.columnHeaders;
                thead.find("th").eq(index).attr("colspan", colspan);
                for (var i = 1; i < colspan; i++) {
                    if (!ej.isNullOrUndefined(thead[0].children[index + i]))
                        thead[0].children[index + i].className += " e-hide";
                }
            };
        },
        _cellMerging: function (args) {
            args.colMerge = function (range) {
                if (this.cell.className.indexOf("e-colmerge") == -1) {
                    this.cell.className += " e-colmerge";
                    if (this.model.columns.length - this.cell.cellIndex < range)
                        range = this.model.columns.length - this.cell.cellIndex;
                    this.cell.colSpan = range;
                    for (var i = 1; i < range; i++) {
                        if (!ej.isNullOrUndefined(this.cell.parentElement.children[this.cell.cellIndex + i]))
                            this.cell.parentElement.children[this.cell.cellIndex + i].className += " e-hide";
                    }
                }
            };
            args.rowMerge = function (range) {
                if (this.cell.className.indexOf("e-rowmerge") == -1) {
                    this.cell.className += " e-rowmerge";
                    var ele = this.cell.parentNode.parentNode;
                    if (ele.rows.length - this.cell.parentElement.rowIndex < range)
                        range = ele.rows.length - this.cell.parentElement.rowIndex;
                    this.cell.rowSpan = range;
                    for (var i = 0; i < range - 1; i++) {
                        if (!ej.isNullOrUndefined(ele.children[this.cell.parentElement.rowIndex + i].nextSibling)) {
                            if (!($(".e-grid").children().is('.e-dialog')) || ($(".e-grid").find('.e-dialog').attr("style").indexOf("display: none")) != -1 || this.model.allowFiltering)
                                ele.children[this.cell.parentElement.rowIndex + i].nextSibling.children[this.cell.cellIndex].className += " e-merged e-hide";
                        }
                        else
                            break;
                    }
                }
            };
            args.merge = function (col, row) {
                if (col > 1 && row > 1) {
                    if (this.cell.className.indexOf("e-colmerge") == -1) {
                        this.cell.className += " e-colmerge";
                        var ele = this.cell.parentNode.parentNode;
                        if (ele.rows.length - this.cell.parentElement.rowIndex < row)
                            row = ele.rows.length - this.cell.parentElement.rowIndex;
                        if (!($(".e-grid").children().is('.e-dialog')) || ($(".e-grid").find('.e-dialog').attr("style").indexOf("display: none")) != -1 || this.model.allowFiltering) {
                            for (var i = 0; i < row ; i++) {
                                if (!ej.isNullOrUndefined(ele.children[this.cell.parentElement.rowIndex + i])) {
                                    var selectCell = ele.children[this.cell.parentElement.rowIndex + i].children[this.cell.cellIndex];
                                    if (this.model.columns.length - selectCell.cellIndex < col)
                                        col = this.model.columns.length - selectCell.cellIndex;
                                    selectCell.colSpan = col;
                                    for (var j = 1; j < col; j++) {
                                        if (!ej.isNullOrUndefined(selectCell.parentElement.children[this.cell.cellIndex + j]))
                                            selectCell.parentElement.children[this.cell.cellIndex + j].className += " e-hide";
                                    }
                                }
                                else
                                    break;
                            }
                        }
                        else {
                            this.cell.colSpan = col;
                            for (var j = 1; j < col; j++) {
                                if (!ej.isNullOrUndefined(this.cell.nextSibling))
                                    this.cell.parentElement.children[this.cell.cellIndex + j].className += " e-hide";
                            }
                        }
                        args.rowMerge(row);
                    }
                }
                else {
                    if (col > 1)
                        args.colMerge(col);
                    if (row > 1)
                        args.rowMerge(row);
                }
            };
        },
        _replacingContent: function () {
            var temp = document.createElement('div');
            var isVirtualization = 0;
            if (this.model.scrollSettings.enableVirtualization)
                isVirtualization = 1;
            var currentIndex = isVirtualization == 1 ? this.getCurrentIndex() + 1 : this.getCurrentIndex();
            var contentTable = this.getContentTable()[0];
            var colGroup = $(contentTable).find("colgroup").first();
            var rowHeight = this.getRowHeight();
            colGroup.replaceWith(this._getMetaColGroup());
           (this.model.detailsTemplate != null || this.model.childGrid!=null)&& colGroup.prepend(this._getIndentCol());
            var tbody = contentTable.tBodies[0];
            var currentData = this.model.currentViewData;
            if (!ej.isNullOrUndefined(this._currentPageData)) {
                this._virtualLoadedRecords[this._currentPage()] = this._currentPageData;
                this._currentPageData = null;
            }
            else
                this._virtualLoadedRecords[this._currentPage()] = currentData;
            var elementTbody = $("<tbody></tbody>").append($.render[this._id + "_JSONTemplate"](currentData));
            var proxy = this;
            var $elementTbody = elementTbody.children("tr");
            if (this._allowcolumnSelection && this.selectedColumnIndexes.length > 0) {
                for (var index = 0; index < this.selectedColumnIndexes.length; index++) {
                    var ind = this.selectedColumnIndexes[index] + 1;
                    $elementTbody.find('td:nth-of-type(' + ind + ')').addClass("e-columnselection");
                }
            }
            this.virtualLoadedPages.push(currentIndex >= isVirtualization ? currentIndex : isVirtualization);
            var orderedVirtualPages = ej.dataUtil.mergeSort(ej.distinct(this.virtualLoadedPages));
            $($elementTbody).attr('name', currentIndex);
            var minValue = ej.dataUtil.min(orderedVirtualPages);
            var maxValue = ej.dataUtil.max(orderedVirtualPages);
            $(tbody).children(".e-virtualrow").remove();
            for (var i = 0; i < orderedVirtualPages.length; i++) {
                var val = orderedVirtualPages[i];
                var pVal = orderedVirtualPages[i - 1];
                if (val != this.orderedVirtualLoadedPage[i] || this.orderedVirtualLoadedPage[i] == undefined) {
                    if (pVal != undefined)
                        $elementTbody.insertAfter($(tbody).children('[name=' + pVal + ']:last'));
                    else
                        $elementTbody.insertBefore($(tbody).children('[name=' + this.orderedVirtualLoadedPage[i] + ']:first'));
                    this.orderedVirtualLoadedPage = orderedVirtualPages;
                }
                if (val != 0) {
                    var prevValue = val == minValue ? minValue : pVal;
                    var middleRows = val - prevValue - proxy.model.pageSettings.pageSize;
                    if (middleRows > 0) {
                        var virtualTRMiddle = document.createElement("tr");
                        $(virtualTRMiddle).addClass("e-virtualrow").css("height", rowHeight * middleRows).insertBefore($(tbody).children('[name=' + val + ']:first'));
                    }
                }
                if (val == maxValue) {
                    var bottomRows = proxy._gridRecordsCount - maxValue - proxy.model.pageSettings.pageSize;
                    if (bottomRows > 0) {
                        var virtualTRBottom = document.createElement("tr");
                        $(virtualTRBottom).addClass("e-virtualrow").css("height", rowHeight * bottomRows).appendTo(tbody);
                    }
                }
            }
            if (minValue > 0) {
                var virtualTRTop = document.createElement("tr");
                $(virtualTRTop).addClass("e-virtualrow").css("height", rowHeight * minValue).prependTo(tbody);
            }
            var $content = this.getContent();
            var focusTR = $(tbody).children("tr[name=" + currentIndex + "]")[0];
            var focusPrev = focusTR.previousSibling;
            var con = $content.height();
            var focus = focusTR.offsetTop
            if (this._virtaulUnSel) {
                var virtualClone = $.extend(true, [], this._virtaulUnSel);
                for (var i = 0; i < virtualClone.length; i++) {
                    var row = virtualClone[i];
                    var page = this.model.pageSettings.currentPage;
                    var corresPage = row % this.model.pageSettings.pageSize == 0 ? parseInt(row / this.model.pageSettings.pageSize) : parseInt(row / this.model.pageSettings.pageSize) + 1;
                    if (corresPage == page) {
                        var index = row % this.model.pageSettings.pageSize;
                        var $row = $(tbody).find("tr[name=" + currentIndex + "]").eq(index);
                        $row.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                        var removeIndex = this._virtaulUnSel.indexOf(row);
                        if (removeIndex != -1)
                            this._virtaulUnSel.splice(removeIndex, 1);
                    }
                }
            }
            if ((focusTR && focusPrev && ((this._virIndex || $(focusPrev).hasClass("e-virtualrow")) || focusPrev.offsetTop > (currentIndex * con))
            && (this._gridRecordsCount - currentIndex >= this.model.pageSettings.pageSize || focusTR.offsetParent.offsetHeight - focus < con)) || this._lastRow) {
                if (this._lastRow) this._lastRow = false;
                if (this._virIndex) this._virIndex = false;
                this._isVirtualRecordsLoaded = true;
                //this.getContent().children("div").first().scrollTop(this.getContent().find(".content").scrollTop() - (this.getContent().find(".content").scrollTop() - focusTR.offsetTop));
                $content.find(".e-content").scrollTop(focus);
                this._scrollValue = this.getContent()[0].firstChild.scrollTop;
            }
            var $contentTableTr = $(contentTable).get(0);
            var tFirst = temp.firstChild;
            this._currentJsonData = currentData;
            this._gridRows = $(contentTable).get(0).rows;
            var lastVirtualRow = $(contentTable).find(".e-virtualrow").last();
            var lastVirtualRowHeight = this.model.scrollSettings.virtualScrollMode == "normal" ? (lastVirtualRow.height() - ($(contentTable).height() - (this._gridRecordsCount * rowHeight))) : 1;
            lastVirtualRow.css("height", lastVirtualRowHeight);
			if(this._enableCheckSelect )
				this._virtualCheckSelection(currentIndex);
            this._eventBindings();
        },
		_virtualCheckSelection:function(index){
			var tbody = this.getContentTable()[0].tBodies[0];
		    $(tbody).find("tr[name=" + index + "]").find('.e-checkcelldiv input').prop("checked","checked")
			$(tbody).find("tr[name=" + index + "]").attr("aria-selected", "true").find("td").addClass("e-selectionbackground e-active");
		},
		_replacingVirtualContent: function () {                  
            var contentTable = this.getContentTable()[0];                            
            var currentLoadedIndexes = this._currentLoadedIndexes;            
            var tempTbody = $("<tbody></tbody>");		                   
            if (this._checkCurrentVirtualView(this._virtualLoadedRows, this._currentVirtualIndex)) {
				var currentRows = [];
                for (var i = 0; i < currentLoadedIndexes.length; i++) {
					$.merge(currentRows, this._virtualLoadedRows[currentLoadedIndexes[i]]);                    					
                }
				$(tempTbody).append(currentRows);
            }
            else {
				var elementTbody = $("<tbody></tbody>"); 				
                for (var i = 0; i < currentLoadedIndexes.length; i++) {					
                    var currentIndex = currentLoadedIndexes[i], virtualRow = this._virtualLoadedRows[currentIndex];                  
                    if (!virtualRow) {
                        this._currentVirtualRowIndex = currentIndex > 0 ? (currentIndex - 1) * (this._virtualRowCount) : 0;
                        var elementTbody = $("<tbody></tbody>").append($.render[this._id + "_JSONTemplate"](this._virtualLoadedRecords[currentIndex]));                        
                        var $elementTbody = elementTbody[0].rows, length = $elementTbody.length - 1;                        
                        $($elementTbody[length]).addClass("e-virtualview" + currentIndex);
						var hex = currentIndex.toString(32);
                        var vRows = $($elementTbody).attr('name', hex);                        
                        if (vRows.length == this._virtualRowCount || currentIndex == this._totalVirtualViews){
                            this._virtualLoadedRows[currentIndex] = vRows;
                            tempTbody.append($elementTbody);
                        }
                    }
                    else {
                        if (currentIndex < this._currentVirtualIndex) {
                            var vRow = tempTbody.find(".e-virtualview" + currentIndex);
                            if (vRow.length)
                                $(virtualRow).insertBefore(vRow);
                            else
                                tempTbody.prepend(virtualRow);
                        }
                        else
                            $(virtualRow).insertAfter(tempTbody.find(".e-virtualview" + (currentIndex - 1)));
                    }					
                }				
            }						   						
            contentTable.replaceChild(tempTbody[0], contentTable.lastChild);
            if (this.selectedRowsIndexes.length) {
                var loadedIndex = $.inArray(this._prevVirtualIndex, this._currentLoadedIndexes);
                var prevLoadedIndex = $.inArray(this._prevVirtualIndex, this._prevLoadedIndexes);
                if (loadedIndex != -1 && loadedIndex != prevLoadedIndex) {
                    var changes = this._prevVirtualIndex > this._currentVirtualIndex ? this._virtualRowCount : -this._virtualRowCount;
                    this.selectedRowsIndexes = this.selectedRowsIndexes.map(function (val) { return val + changes; });
                    var selectIndex = this._selectedRow() + changes;
                    selectIndex = selectIndex >= 0 ? selectIndex : -1;
                    this._selectedRow(selectIndex);
                }
            }
            $(contentTable.rows).removeClass("e-hover");
			this._setVirtualTopBottom();
			if(this._isThumbScroll || this._remoteRefresh){				
				//this._scrollObject.refresh();				
				this._scrollObject._content[0].scrollTop = this._scrollObject.scrollTop();
                this._isThumbScroll = this._remoteRefresh = false;
            }
			if(this.model.allowSelection)							
				this._checkVirtualSelection();																						
			this._gridRows = contentTable.rows;
			this._currentJsonData = this.model.currentViewData;
			if(!this._checkCurrentVirtualView(this._queryCellView, this._currentVirtualIndex))            
				this._eventBindings();			
			if(this.model.queryCellInfo || this.model.rowDataBound){
				for(var i = 0; i < this._currentLoadedIndexes.length; i++){
					if($.inArray(this._currentLoadedIndexes[i], this._queryCellView) == -1)
						this._queryCellView.push(this._currentLoadedIndexes[i]);						
				}
			}
			this._trigger("refresh");
        },
		_setVirtualTopBottom: function(){
			var contentTable = this.getContentTable()[0];
			var rowHeight = this._vRowHeight;
			var orderedVirtualNames = ej.dataUtil.mergeSort(ej.distinct(this._currentLoadedIndexes));				
			var minValue = ej.dataUtil.min(orderedVirtualNames);
			var maxValue = ej.dataUtil.max(orderedVirtualNames);
			var recordsCount = this._getVirtualTotalRecord(), botHeight, maxViewValue;
			if(this.model.scrollSettings.virtualScrollMode == "continuous" && this._virtualLoadedRows[maxValue + 1]	){
				var keys = Object.keys(this._virtualLoadedRows);
				maxViewValue =  parseInt(ej.dataUtil.max(keys), 10);
				maxValue = maxViewValue - maxValue;
			}			
			botHeight = (maxValue * this._virtualRowCount * rowHeight);
			if($.inArray(this._totalVirtualViews, this._currentLoadedIndexes) != -1 && this._currentVirtualIndex != this._totalVirtualViews)
				botHeight = (recordsCount - (this._virtualRowCount - this._lastViewData)) * rowHeight;										
			var vBot = (recordsCount * rowHeight) - botHeight;	
			if(this.model.scrollSettings.virtualScrollMode == "continuous" && !this._virtualLoadedRows[maxValue + 1]){				
				vBot = maxViewValue && maxViewValue <=  maxValue + 1 ? vBot : 1;			 				
			}
			this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
			var max = 1000000;							
			if (vBot > 0 && this._getVirtualTotalRecord() > this._virtualRowCount * 2){ 
				if(Math.round(vBot).toString().length < 7)
					ej.buildTag("div.e-virtualbottom", "", { height: vBot }).insertAfter(contentTable);
				else {					
					ej.buildTag("div.e-virtualbottom").insertAfter(contentTable);
					var length = Math.ceil(vBot / max);
					for(var i = 0; i < length; i++){
						var divHeight = max;
						if(i == length - 1) divHeight = vBot % max;
						$(contentTable).next().append(ej.buildTag("div", "", { height: divHeight }));
					}
				}							
			}
			if (minValue > 1) {				
				var vTop =  (minValue - 1) * this._virtualRowCount * rowHeight;																	
				if(Math.round(vTop).toString().length < 7)
					ej.buildTag("div.e-virtualtop", "", { height: vTop }).insertBefore(contentTable);			
				else {					
					ej.buildTag("div.e-virtualtop").insertBefore(contentTable);
					var length = Math.ceil(vTop / max);
					for(var i = 0; i < length; i++){
						var divHeight = max;
						if(i == length - 1) divHeight = vTop % max;
						$(contentTable).prev().append(ej.buildTag("div", "", { height: divHeight }));
					}
				}								
			}      				
			if(this._scrollObject.model.scrollTop != this._scrollValue)
				this.getContent().ejScroller("model.scrollTop", this._scrollValue);				
        },
		_checkVirtualSelection: function(){
			var contentTable = this.getContentTable()[0];
			for(var i = 0; i < this.selectedRowsIndexes.length; i++){
				var selectedIndex = this.selectedRowsIndexes[i];
				var viewIndex = this._getSelectedViewData(selectedIndex).viewIndex;
				if($.inArray(viewIndex, this._currentLoadedIndexes) != -1){					
					var selIndex = selectedIndex % this._virtualRowCount + this._currentLoadedIndexes.indexOf(viewIndex) * this._virtualRowCount;	
					if (!ej.isNullOrUndefined(contentTable.rows[selIndex]) && !$(contentTable.rows[selIndex].cells).hasClass("e-selectionbackground")) {
						$($(contentTable.rows[selIndex]).attr("aria-selected", "true")[0].cells).addClass("e-selectionbackground e-active");							
						this.model.selectedRecords[i] = this._virtualLoadedRecords[viewIndex][selIndex % this._virtualRowCount];
					}
				}
			}
			for(var i = 0; i < this._rowIndexesColl.length; i++){
				var selectedIndex = this._rowIndexesColl[i];
				var viewIndex = this._getSelectedViewData(selectedIndex).viewIndex;
				if(($.inArray(viewIndex, this._currentLoadedIndexes) != -1 && $.inArray(selectedIndex, this._virtualRowCellSelIndex) == -1) || this._virtualDataRefresh){
					var curIndex = $.inArray(selectedIndex, this._rowIndexesColl);
					var cellIndexes = this.selectedRowCellIndexes[curIndex].cellIndex;
					for(var j = 0; j < cellIndexes.length; j++)
						this._selectMultipleCells(selectedIndex, cellIndexes[j]);						
				}
			}
			var selectedRows = $(contentTable.rows).find(".e-active, .e-cellselectionbackground").closest("tr");
			for(var i = 0; i < selectedRows.length; i++){
				var limit = parseInt($(selectedRows[i]).attr("name"), 32) * this._virtualRowCount;
				var remain = this._virtualRowCount - $(selectedRows[i]).index() % this._virtualRowCount;	
				var current = limit - remain;
				var rowIndex = $(selectedRows[i]).index();
				if (this.selectedRowsIndexes.length && $.inArray(rowIndex, this.selectedRowsIndexes) == -1) {
					this._clearVirtualSelection = true;
					this.clearSelection(rowIndex);					
				}				
				if(this._rowIndexesColl.length && $.inArray(current, this._rowIndexesColl) == - 1)											
					$(this.getRowByIndex(rowIndex)[0].cells).removeClass("e-cellselectionbackground e-activecell");											
			}	
			$(contentTable.rows).find('.e-columnselection').removeClass('e-columnselection');
            for (var index = 0; index < this.selectedColumnIndexes.length; index++) {
				var ind = this.selectedColumnIndexes[index] + 1;
                $(contentTable.rows).find('td:nth-of-type(' + ind + ')').addClass("e-columnselection");
            }  				
			this._clearVirtualSelection = false;
		},
        _refreshPagerTotalRecordsCount: function () {
            if (this.model.filterSettings.filteredColumns.length)
                this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._filteredRecordsCount : this._searchCount, currentPage: this._currentPage() });
            else
                this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._gridRecordsCount : this._searchCount, currentPage: this._currentPage() });
        },
        _maxZindex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute')
                    return parseInt($(e).css('z-index')) || 1;
            }));
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },
        _keyPressed: function (action, target, e, event) {
            var $target = $(target), toolbarId;
            if ($target.hasClass('e-tooltxt') && e.code == 13) {
                var args = { currentTarget: target, target: target.firstChild }, $toolbar = $(target).closest(".e-gridtoolbar");
                $toolbar.ejToolbar("instance")._trigger("click", args);
                return false;
            }
            if(this._allowcellSelection && !(this._previousRowCellIndex && this._previousRowCellIndex.length != 0)){		
				this._previousRowCellIndex = [];
				this._previousRowCellIndex.push([0, [0]]);
			}
            if ($target.hasClass('e-ddl') && e.code == 13 && $(document.activeElement).parents('td').hasClass("e-templatecell") )
            return true;
            if (!this.model.allowKeyboardNavigation || ((target.tagName == 'INPUT' || target.tagName == 'TEXTAREA') && this.model.keyConfigs[action].indexOf(",") == -1 && e.code != 40 && e.code != 38 && e.code != 13 && e.code != 27 && e.code != 9) || String.fromCharCode(e.code).toLowerCase() == this.element[0].accessKey.toLowerCase())
                return true;
            if ($(target).prop("type") == "checkbox" && (e.code != 13 && e.code != 9 && e.code!=27))
                return true;
            if (this.model.editSettings.editMode == "batch" && ((target.tagName == 'INPUT' || target.tagName == 'TEXTAREA') && e.code != 13 && e.code != 9 && e.code!=27) && ((target.selectionStart != 0 && action != "moveCellRight") || (target.selectionEnd != target.value.length && action != "moveCellLeft")))
				return true;
            if (this.model.allowFiltering && ($target.hasClass('e-filtertext') && e.code == 13) || ($target.hasClass('e-fltrbtn') && e.code == 13))
                return true;
            if ((this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") && $(target).closest("#" + this._id + "EditForm").length)
                return true;
            else if ($(target).parent().siblings("#" + this._id + "EditForm").length)
                return true;
            if (e.code == 13 && $target.parent().hasClass("e-unboundcelldiv"))
                return true;
            if (e.code == 13 && target.tagName == 'INPUT' && $target.closest("#" + this._id + "_search").length)
                action = "searchRequest";
            if (e.code == 13 && this._excelFilter != null && !ej.isNullOrUndefined(this._excelFilter._openedFltr) && this._excelFilter._openedFltr.length && this._excelFilter._openedFltr.is(":visible"))
                action = "excelfilter";
            if (e.code == 13 && $(target).hasClass("e-gridtoolbar")) {
                var toolbarId = $target.find(".e-hover").attr("Id");
                action = "toolbarOperationRequest";
            }
            if (!this.model.isEdit && action == "cancelRequest") {
                this.clearSelection();
                this.clearCellSelection();
				this.clearColumnSelection();
                return true;
            }
            if ($(target).find("input.e-dropdownlist").attr("aria-expanded") == "true" && this.model.isEdit && action == "saveRequest")
                return true;
            if (this.getPager() != null)
                var pager = this.getPager().ejPager("model"), pageIndex = pager.currentPage;
            var returnValue = false, curEl, $target = $(target);
            if ($target.closest(".e-grid").attr("Id") !== this._id)
                return;
            switch (action) {
                case "insertRecord":
                    if (ej.gridFeatures.edit && (!this.model.isEdit && (!this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")))
                        this._toolbarOperation(this._id + "_add");
                    if(pageIndex == 0) pageIndex = 1;
                    break;
                case "toolbarOperationRequest":
                    this._toolbarOperation(toolbarId);
                    this.element.focus();
                    break;
                case "searchRequest":
                    this.search($target.val());
                    break;
                case "excelfilter":
                    var dlgID = this._id + this._excelFilter._$colType;
                    if (this._excelFilter._openedFltr.hasClass("e-dlgcustom"))
                        dlgID += "Custom";
                    this._excelFilter._openedFltr.find("#" + dlgID + "_OkBtn").trigger("click");
                    break;
                case "saveRequest":
                    if (ej.gridFeatures.edit) {
                        $target.blur();
                        if (this.model.editSettings.editMode == "batch") {
                            var tr = $(this.getRowByIndex(this._bulkEditCellDetails.rowIndex))
                            if(this.model.isEdit && tr.hasClass('e-insertedrow'))
                                this._batchCellValidation(this._bulkEditCellDetails.rowIndex);
                            this._moveCurrentCell("down");
                        }
                        else
                            this._toolbarOperation(this._id + "_update");
                            event.stopPropagation();
                    }
                    break;
                case "cancelRequest":
                    if (ej.gridFeatures.edit)
                        this._toolbarOperation(this._id + "_cancel");
                    break;
                case "deleteRecord":
                    if (ej.gridFeatures.edit)
                        this._toolbarOperation(this._id + "_delete");
                    break;
                case "editRecord":
                    if (ej.gridFeatures.edit && (!this.model.isEdit || (this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")))
                        this._toolbarOperation(this._id + "_edit");
                    break;
                case "totalGroupCollapse":
                    if (ej.gridFeatures.group) {
                        this.collapseAll();
                        this.element.focus();
                    }
                    break;
                case "totalGroupExpand":
                    if (ej.gridFeatures.group) {
                        this.expandAll();
                        this.element.focus();
                    }
                    break;
                case "selectedGroupExpand":
                    if (ej.gridFeatures.group) {
                        this._$currentTr = $(this.getRows()).eq(this._selectedRow());
                        curEl = this._$currentTr.parents("tr").first().prev().find(".e-recordpluscollapse");
                        this.expandCollapse(curEl);
                    }
                    break;
                case "selectedGroupCollapse":
                    if (ej.gridFeatures.group) {
                        this._$currentTr = $(this.getRows()).eq(this._selectedRow());
                        curEl = this._$currentTr.parents("tr").first().prev().find(".e-recordplusexpand");
                        this.expandCollapse(curEl);
                    }
                    break;
                case "firstRowSelection":
                    if (ej.gridFeatures.selection)
                        this.selectRows(0);
                    break;
                case "lastRowSelection":
                    var lastRow;
                    if (ej.gridFeatures.selection)
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = $(this.getRows()[0]).length - 1;
                        else
                            lastRow = $(this._excludeDetailRows()).length - 1;
                        this.selectRows(lastRow);
                    break;
                case "rowUpSelection":
                    this.element.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    var index = this._traverseRow != null ? this._traverseRow : this._selectedRow();
                    if (index > 0) {
                        this._nextRow = index;
                        this._prevRow = index - 1;
                        var $removeHover = $(this.getContent().find("tr.e-traverse")[0]);
                        $removeHover.removeClass("e-traverse");
                        this.getRowByIndex(this._prevRow).addClass("e-traverse");
                        var selectedRows = this.getContent().find("tr.e-traverse");
                        this._traverseRow = this.getIndexByRow(selectedRows);
                    }
                    break;
                case "rowDownSelection":
                    this.element.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    var index = this._traverseRow != null ? this._traverseRow : this._selectedRow();
                    if ((index + 1 < this.model.currentViewData.length) || (this.model.scrollSettings.allowVirtualScrolling)) {
                        this._prevRow = index;
                        this._nextRow = index + 1;
                        var $removeHover = $(this.getContent().find("tr.e-traverse")[0]);
                        $removeHover.removeClass("e-traverse");
                        this.getRowByIndex(this._nextRow).addClass("e-traverse");
                        var selectedRows = this.getContent().find("tr.e-traverse");
                        this._traverseRow = this.getIndexByRow(selectedRows);
                    }
                    break;
                case "randomSelection":
                    this.element.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    if (this.model.selectionType == "multiple")
                        this.multiSelectCtrlRequest = true;
                    var selectedRows = this.getContent().find("tr.e-traverse");
                    this._traverseRow = this.getIndexByRow(selectedRows);
                    if (this._traverseRow != -1) {
                        if (this.model.selectionSettings.enableToggle && this.getSelectedRecords().length == 1 && $.inArray(this._traverseRow, this.selectedRowsIndexes) != -1)
                            this.clearSelection(selectedIndex);
                        else
                            this.selectRows(this._traverseRow);
                    }
                    this.getRowByIndex(index).removeClass("e-traverse");
                    this.multiSelectCtrlRequest = false;
                    break;
                case "upArrow":
                    this.multiSelectCtrlRequest = false;
                    this._traverseRow = null;
					if( this.model.isEdit && $target.hasClass('e-ddl'))
						break;
					if (ej.gridFeatures.selection && (this._selectedRow() != -1 || this._previousRowCellIndex != undefined) && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if (this._selectedRow() > 0) {
                            var row = this.getRowByIndex(this._selectedRow() - 1);
                            !this._enableCheckSelect && this.selectRows(this._selectedRow() - 1, null, row);
                            if (this.model.editSettings.editMode == "batch" && !this.model.scrollSettings.enableVirtualization)
                                this._moveCurrentCell("up");
                        }
                        if (this._previousRowCellIndex && this._previousRowCellIndex.length != 0 && this._previousRowCellIndex[0][0] != 0 && this._allowcellSelection) {
                            this.selectCells([[this._previousRowCellIndex[0][0] - 1, this._previousRowCellIndex[0][1]]]);
                            if (this.model.editSettings.editMode == "batch")
                                this._moveCurrentCell("down");
                        }
                    }
                    break;
                case "downArrow":
                    this.multiSelectCtrlRequest = false;
                    this._traverseRow = null;
					if( this.model.isEdit && $target.hasClass('e-ddl'))
						break;
					if (ej.gridFeatures.selection && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if(this._selectedRow() == -1)
							this.model.selectedRowIndex=0;
                        var lastRow = this._excludeDetailRows().length - 1;
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = this.getRows()[0].length - 1;
                        if (this._selectedRow() != lastRow && this._selectedRow() != -1) {
                            var row = this.getRowByIndex(this._selectedRow() - 1);
                            !this._enableCheckSelect && this.selectRows(this._selectedRow() + 1, null, row);
                            if (this.model.editSettings.editMode == "batch" && !this.model.scrollSettings.enableVirtualization)
                                this._moveCurrentCell("down");
                        }
                        if (this._previousRowCellIndex && this._previousRowCellIndex.length != 0 && this._previousRowCellIndex[0][0] != lastRow && this._allowcellSelection) {
                            this.selectCells([[this._previousRowCellIndex[0][0] + 1, this._previousRowCellIndex[0][1]]]);
                            if (this.model.editSettings.editMode == "batch")
                                this._moveCurrentCell("down");
                        }
                    }
                    break;
                case "rightArrow":
                    if (ej.gridFeatures.selection && this._allowcellSelection && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        var lastRow = $(this.getRows()).length - 1;
                        if (this._previousRowCellIndex && this._previousRowCellIndex[0][1] == this.model.columns.length - 1 && this._previousRowCellIndex[0][0] != lastRow) {
                            this.selectCells([[this._previousRowCellIndex[0][0] + 1, [0]]]);
                        } else if (this._previousRowCellIndex && this._previousRowCellIndex[0][1] != this.model.columns.length - 1)
                            this.selectCells([[this._previousRowCellIndex[0][0], [parseInt(this._previousRowCellIndex[0][1]) + 1]]]);

                    }
                    break;
                case "leftArrow":
                    if (ej.gridFeatures.selection && this._allowcellSelection && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if (this._previousRowCellIndex && this._previousRowCellIndex[0][1] == 0 && this._previousRowCellIndex[0][0] != 0)
                            this.selectCells([[this._previousRowCellIndex[0][0] - 1, [this.model.columns.length - 1]]]);
                        else if (this._previousRowCellIndex && this._previousRowCellIndex[0][1] != 0)
                            this.selectCells([[this._previousRowCellIndex[0][0], [parseInt(this._previousRowCellIndex[0][1]) - 1]]]);

                    }
                    break;
                case "firstCellSelection":
                    if (ej.gridFeatures.selection && this._allowcellSelection) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        var lastRow = $(this.getRows()).length - 1;
                        lastRow > -1 && this.selectCells([[0, [0]]]);
                    }
                    break;
                case "lastCellSelection":
                    var lastRow;
                    if (ej.gridFeatures.selection && this._allowcellSelection) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = this.getRows()[0].length - 1;
                        else
                            lastRow = $(this._excludeDetailRows()).length - 1;
                        lastRow > -1 && this.selectCells([[lastRow, [this.model.columns.length - 1]]]);
                    }
                    break;
                case "nextPage":
                    if (this.getPager() != null)
                        pageIndex = pageIndex + 1;
                    if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "msie")
                        this.element.focus();
                    break;
                case "previousPage":
                    if (this.getPager() != null)
                        pageIndex = pageIndex - 1;
                    if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "msie")
                        this.element.focus();
                    break;
                case "lastPage":
                    if (this.getPager() != null)
                        pageIndex = pager.totalPages;
                    break;
                case "firstPage":
                    if (this.getPager() != null)
                        pageIndex = 1;
                    break;
                case "nextPager":
                    if (this.getPager() != null)
                        pageIndex = Math.ceil(pager.currentPage / pager.pageCount) * pager.pageCount + 1;
                    break;
                case "previousPager":
                    if (this.getPager() != null)
                        pageIndex = (Math.floor(pager.currentPage / pager.pageCount) - 1) * pager.pageCount + 1;
                    break;
                case "moveCellLeft":
                    if (this.model.editSettings.editMode == "batch"){
						this._tabKey = true;
                        returnValue = this._moveCurrentCell("left");
					}
                    else
                        returnValue = true;
                    break;
                case "moveCellRight":
                    if (this.model.editSettings.editMode == "batch" && $target){
						this._tabKey = true;
                        returnValue = this._moveCurrentCell("right");
					}
                    else
                        returnValue = true;
                    break;
                case "multiSelectionByDownArrow":
                    if (ej.gridFeatures.selection && (this._selectedRow() != -1 || this._previousRowCellIndex != undefined)) {
                        var lastRow = this._excludeDetailRows().length - 1, $target = this.element.find('.e-gridcontent').find('.e-rowcell');
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = this.getRows()[0].length - 1;
                        if (this._selectedRow() <= lastRow && this._selectedRow() != -1) {
                            var selectedRow = this._selectedRow() + 1, fromIndex = this._previousIndex;
                            this.selectRows(fromIndex, selectedRow, $target);
                            if ((selectedRow - 1) == lastRow) {
                                this.selectRows(fromIndex, lastRow);
                                selectedRow = lastRow;
                            }
                        }
                        this._selectedRow(selectedRow);
                        this._previousIndex = fromIndex;
                    }
                    this.model.editSettings.editMode == "batch" && this.element.focus();
                    break;
                case "multiSelectionByUpArrow":
                    var firstRow = 0;
                    if (ej.gridFeatures.selection && (this._selectedRow() != -1 || this._previousRowCellIndex != undefined)) {
                        var lastRow = this._excludeDetailRows().length - 1, $target = this.element.find('.e-gridcontent').find('.e-rowcell');
                        if (this._selectedRow() >= 0 && this._selectedRow() >= -1) {

                            var selectedRow = this._selectedRow() - 1, fromIndex = this._previousIndex;
                            this.selectRows(fromIndex, selectedRow, $target);
                            if (selectedRow < 0) {
                                this.selectRows(fromIndex, firstRow);
                                selectedRow = firstRow;
                            }
                        }
                        this._selectedRow(selectedRow);
                        this._previousIndex = fromIndex;
                    }
                    this.model.editSettings.editMode == "batch" && this.element.focus();
                    break;
                default:
                    returnValue = true;
            }
            if (this.getPager() != null && pageIndex <= pager.totalPages && pager.currentPage !== pageIndex && action != "searchRequest" && action !== "deleteRecord")
                this.getPager().ejPager("goToPage", pageIndex);
            return returnValue;
        },
        _findColumnsWidth: function () {
            var j = this.getHeaderTable().find(".e-headercell").not(".e-stackedHeaderCell, .e-detailheadercell"), index = 0;           
            for (var i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i]["visible"])
                    this.columnsWidthCollection[i] = j.eq(i + index).outerWidth();
            }
        },
        _calculateWidth: function () {
            var j = this.getHeaderTable().find(".e-columnheader").last().find("th:visible"), width = 0;
            for (var i = 0; i < j.length; i++)
                width += j.eq(i).outerWidth();
            return width;

        },
        _initIndicators: function () {
            var indicatorId = this._id + "_ColumnDropIndicator";
            if ($("#" + indicatorId).length)
                $("#" + indicatorId).remove();
            this._Indicator = document.createElement("DIV");
            $(this._Indicator).attr('id', indicatorId).addClass("e-columndropindicator").addClass("e-dropAcceptor").appendTo(document.body);
            $(this._Indicator).css({ "display": "none" });

        },
        _refreshGridFooterColGroup: function () {
            this.getFooterTable().find("colgroup").remove();
            if (this.model.scrollSettings.frozenColumns > 0) {
                this.getFooterTable().eq(0).append(this.getHeaderTable().eq(0).find("colgroup").clone());
                this.getFooterTable().eq(1).append(this.getHeaderTable().eq(1).find("colgroup").clone());
            }
            else
                this.getFooterTable().append(this.getHeaderTable().find("colgroup").clone());
        },
        _refreshGroupSummary: function () {
            var headerCols = this.getHeaderContent().find("colgroup col").clone();
            headerCols.splice(0, this.model.groupSettings.groupedColumns.length);
            var $gsColgroup = this.getContentTable().find(".e-groupsummary colgroup");
            for (var i = 0; i < $gsColgroup.length; i++) {
                if (!$($gsColgroup[i]).find(".e-summary").is("visible"))
                    $($gsColgroup[i]).find(".e-summary").show();
                $($gsColgroup[i]).find("col:not('.e-summary')").remove();
                $($gsColgroup[i]).append(headerCols.clone());
            }
        },
        
        reorderColumns: function (fromfname, tofname) {
            var fromindex, toindex;
            if (typeof (fromfname) == "string" && typeof (tofname) == "string") {
                fromindex = this.getColumnIndexByField(fromfname);
                toindex = this.getColumnIndexByField(tofname);
            }
            else {
                fromindex = fromfname;
                toindex = tofname;
            }
            if (fromindex == -1 || toindex == -1 || typeof (fromindex) == "string" || typeof (toindex) == "string") return;
            this.set_dropColumn(fromindex, toindex);
            if (this.model.showStackedHeader)
                this._refreshStackedHeader();
            if (this.model.scrollSettings.allowVirtualScrolling){
				if(this.model.scrollSettings.enableVirtualization){
					this._virtualDataRefresh = true;
					this._queryCellView = [];
					this._virtualLoadedRows = {};
					this._refreshVirtualView(this._currentVirtualIndex);								
				}
				else
					this._refreshVirtualContent(); 
			}
        },
        
        columns: function (details, action) {
            if (ej.isNullOrUndefined(details)) return;
            var isString = false;
            if (typeof details === "string") {
                details = [details];
                isString = true;
            }
            else if (details instanceof Array && details.length && typeof details[0] === "string")
                isString = true;
            for (var i = 0; i < details.length; i++) {
                var field = isString ? details[i] : details[i].field, headerText = isString ? details[i] : details[i].headerText, index;
                if ((ej.isNullOrUndefined(field) || field == "") && (ej.isNullOrUndefined(headerText) || headerText == ""))
                    index = -1;
                else if (ej.isNullOrUndefined(field) || field == "")
                    index = $.inArray(this.getColumnByHeaderText(headerText), this.model.columns);
                else
                    index = $.inArray(this.getColumnByField(field), this.model.columns);
                if (action == "add" || ej.isNullOrUndefined(action)) {
                    if (index == -1)
                        this.model.columns.push(isString ? { field: details[i] } : details[i]);
                    else
                        this.model.columns[index] = isString ? { field: details[i] } : details[i];
                }
                else {
                    if (index != -1)
                        this.model.columns.splice(index, 1);
                }
            }            
            this.columnsWidthCollection = []; var tooltip = false;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                this.columnsWidthCollection.push(this.model.columns[columnCount]["width"]);
                if (!ej.isNullOrUndefined(tooltip))
                    tooltip = true;
            }
            this._enableRowHover(tooltip);
            this.refreshHeader();
			if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) 
				this._processEditing();
            this.refreshContent(true);
            if (this.model.allowScrolling) {
                this.refreshScrollerEvent();
                if (this.model.allowResizeToFit && this.getContent().ejScroller("isVScroll"))
                    this._showHideScroller();
            }
        },
        _enableRowHover: function (isTooltip) {
            var tooltip = true;
            if (ej.isNullOrUndefined(isTooltip)) {
                for (var i = 0 ; i < this.model.columns.length; i++) {
                    if (!ej.isNullOrUndefined(this.model.columns[i]['tooltip'])) {
                        tooltip = true;
                        break;
                    }
                }
            }
            else
                tooltip = isTooltip;
            if (this.model.enableRowHover || tooltip)
                this._on(this.element, "mouseenter mouseleave", ".e-gridcontent tr td", this._rowHover);
            else
                this._off(this.element, "mouseenter mouseleave", ".e-gridcontent tr td");
        },
        _rowHover: function (e) {
            var $target = $(e.target);
            if (!$target.hasClass("e-rowcell"))
                $target = $target.closest(".e-rowcell");
            if (this.model.scrollSettings.frozenColumns)
                var $gridRows = $(this.getRows());
            else
                var $gridRows = this.element.find(".e-row.e-hover,.e-alt_row.e-hover");
            if (($target.closest("#" + this._id + "EditForm").length && $target.hasClass("e-rowcell")) || !$target.hasClass("e-rowcell"))
                return;
            if (e.type == "mouseenter" && $target.hasClass("e-gridtooltip"))
                this._showTooltip($target);
            if (this.model.enableRowHover) {
                this.element.find(".e-traverse").removeClass("e-traverse");
                this._traverseRow=null;
                if (e.type == "mouseenter" && !this._dragActive) {
                     if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined($gridRows[0]) && !ej.isNullOrUndefined($gridRows[1]))	
					 {
						$gridRows = $($gridRows[0]).add($gridRows[1]);
						$gridRows.removeClass("e-hover");
						var index = this.getIndexByRow($target.parent());
						index != -1 && this.getRowByIndex(index).addClass("e-hover");
					}
                 else {
                     $gridRows.removeClass("e-hover");
                     if( $target.parent().hasClass('e-row') ||$target.parent().hasClass ('e-alt_row'))
                         $target.parent().addClass("e-hover");
					}
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined($gridRows[0]) && !ej.isNullOrUndefined($gridRows[1]))
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.removeClass("e-hover");
                }
                var gridRows = $target.parent();
                var index = this.getIndexByRow(gridRows);
                var data = this._currentJsonData[index];
                if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization) {
                    index = (index % this.model.pageSettings.pageSize);
                    data = this._currentJsonData[index];
                }
                else if (this.model.scrollSettings.enableVirtualization) {
                    var viewDetails = this._getSelectedViewData(index, $target);
                    data = viewDetails.data;
                    index = viewDetails.rowIndex;
                }
                var args = { row: gridRows, rowIndex: index, rowData: data, cell: $target };
                this._trigger("rowHover", args);
            }
            return false;
        },
        _showTooltip: function ($target, isHeaderTooltip) {
            var index = $target.index(), isStack = $target.hasClass("e-stackedHeaderCell"), data = {};
            if ($target.hasClass("e-headercelldiv"))
                index = $target.parent(".e-headercell").index() - this.model.groupSettings.groupedColumns.length;
            if (!isStack && (this.model.childGrid || this.model.detailsTemplate))
                index--;
            if (this.model.scrollSettings.frozenColumns > 0 && ($target.closest(".e-movableheaderdiv").length || $target.closest(".e-movablecontentdiv").length))
                index = index + this.model.scrollSettings.frozenColumns;
            var col =  !isStack ? this.getColumnByIndex(index) : this._getStackedColumnByTarget($target);            
            if (col["clipMode"] != ej.Grid.ClipMode.Ellipsis) {
                if (col["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip) {
                    var td = $target;
                    if (!$target.find("span").hasClass("e-ellipsistooltip")) {
                        var $span = ej.buildTag('span.e-ellipsistooltip', {}, {})
                        $span.html($target.html());
                        td.append($span);
                    }
                    td.find('span.e-ellipsistoottip').css('display', 'inline-block')
                    var width = td.find('span:first')[0].getBoundingClientRect().width;
                    td.find('span.e-ellipsistooltip').remove();
                    if ($target.width() > (width)) {
                        $target.removeAttr('title');
                        return;
                    }
                }

                var scriptElement = document.createElement("script");
                if (ej.isNullOrUndefined(col["tooltip"]) && ej.isNullOrUndefined(col["headerTooltip"]))
                    return;
                else {
                    var t;
                    scriptElement.id = (this._id + col.headerText + $.inArray(col, this.model.columns) + "_TemplateToolTip").split(" ").join("");
                    scriptElement.type = "text/x-template";
                    var tooltipType = !isHeaderTooltip ? "tooltip" : "headerTooltip";
                    if (!ej.isNullOrUndefined(col[tooltipType]) && col[tooltipType].slice(0, 1) !== "#")
                        scriptElement.text = col[tooltipType];
                    else
                        t = $(col[tooltipType]);
                    if (t) {
                        scriptElement.text = t.html();
                        scriptElement.type = t.attr("type") || scriptElement.type;
                    }
                   if(!ej.isNullOrUndefined(t) && col[tooltipType].slice(0, 1) !== "#")
                    $("body").append(scriptElement);
                }
                var rowElement = $target.closest("tr");
                if (!$(rowElement).hasClass("e-columnheader") && !$target.hasClass("e-gridheader")) {
                    var index = this.getIndexByRow(rowElement);//get the target rowIndex
                    if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling) {
                        if (!this.model.scrollSettings.enableVirtualization)
                            index = index % this.model.pageSettings.pageSize;
                        else {
                            var nameAttr = rowElement.attr("name");
                            index = index % this._virtualRowCount;
                            var virtualIndex = parseInt(nameAttr, 32);
                            data = this._virtualLoadedRecords[virtualIndex][index];
                        }
                    }
                    else
                        data = this.getCurrentViewData()[index];//get the data corresponding to row hovered
                }
                data.value = !$target.hasClass("e-headercell") || isStack ? $target.text() : $target.find("e-gridheadertooltip").text();
                var str = $(scriptElement).render(data);
                $target.attr('title', str);
            }
            else
                $target.removeAttr('title');

        },
        _rightClickHandler: function (e) {
            e.preventDefault(); var browser = ej.browserInfo();
            if (e.which == 3 || (browser.name == "msie" && browser.version == "8.0")) {
                var args = {},
                $target = $(e.target),
                $gridRow = $(this.getRows());
                if (this.getContentTable().has($target).length) {
                    var index = $gridRow.index($target.parent());					
					var $row = this.getRowByIndex(index);
					var $data = this._currentJsonData[index];
					if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){	
						var viewDetails = this._getSelectedViewData(index, $target);					
						$data = viewDetails.data;				
						index = viewDetails.rowIndex;					
					}
                    if (index == -1)
                        return;
                    args = { rowIndex: index, row: $row, data: $data, rowData: $data, cellIndex: $target.index(), cellValue: $target.html(), cell: $target };
                }
                else if (this.getHeaderTable().has($target).length) {
                    var index = 0,
                    $th = this.getHeaderTable().find('th').not('.e-detailheadercell,.e-grouptopleftcell,.e-filterbarcell');
                    if ($target.is('.e-headercelldiv'))
                        index = $th.index($target.closest('.e-headercell'));
                    else
                        index = $th.index($target);
                    if (index == -1)
                        return;
                    args = { headerIndex: index, headerText: this.getColumnFieldNames()[index], headerCell: $th.eq(index), column: this.getColumnByIndex(index) }
                }
                else if ($target.is('.e-pager') || (this.getPager() != null && this.getPager().has($target).length)) {
                    args = { pager: this.model.pageSettings }
                }
                this._trigger("rightClick", args);
            }
        },
        _touchGrid: function (e) {
            var curPage = this._currentPage(), doPage = true;
            if (this.model.allowScrolling || (this.model.isResponsive && this.model.minWidth != 0)) {
                var d = (this.getScrollObject() || {})._scrollXdata;
                if (d)
                    doPage = e.type == "swipeleft" ? d.scrollable - d.sTop == 0 : d.sTop == 0;
            }
            switch (e.type) {
                case "swipeleft":
                    if (this.model.allowPaging && curPage != this.model.pageSettings.totalPages && !this.model.isEdit)
                        doPage && this.element.ejGrid("gotoPage", curPage + 1);
                    break;
                case "swiperight":
                    if (this.model.allowPaging && curPage > 1 && !this.model.isEdit)
                        doPage && this.element.ejGrid("gotoPage", curPage - 1);
                    break;
            }
        },
        _recorddblClickHandler: function (e) {
            this._recordClickProcess(e, this, "recordDoubleClick");
        },
        _recordClickProcess: function (e, proxy, eventName) {
            var args = {}, $target = $(e.target).is(".e-rowcell") ? $(e.target) : $(e.target).closest("td");
            if ($target.closest(".e-grid").attr("id") !== proxy._id || (!$target.is('.e-rowcell') && !$target.closest("td").is(".e-rowcell")) || ($target.closest('.e-editcell,.e-insertedrow')).length > 0)
                return;
            var cellIndx = (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) ? $target.index() - 1 : $target.index();
            var column = proxy.getColumnByIndex(cellIndx);
            if (proxy.model.editSettings.editMode == "batch" && !(column.allowEditing == false) && !(column.isPrimaryKey == true))
                return;
            var index = proxy.getIndexByRow($target.closest('tr'));
            var $row = proxy.getRowByIndex(index);
            var $data = proxy._currentJsonData[index];
            if (proxy.model.scrollSettings.allowVirtualScrolling) {
                if (proxy.model.scrollSettings.enableVirtualization) {
                    var viewDetails = proxy._getSelectedViewData(index, $target);
                    $data = viewDetails.data;
                    index = viewDetails.rowIndex;
                }
                else {
                    var trIndex = index % proxy.model.pageSettings.pageSize;
                    var virtualIndex = (parseFloat($row.attr("name")) - (this.model.scrollSettings.enableVirtualization ? 1 : 0)) / proxy.model.pageSettings.pageSize + 1;
                    $data = proxy._virtualLoadedRecords[virtualIndex][trIndex];
                }
            }
            args = { rowIndex: index, row: $row, data: $data, rowData: $data, cell: $target, cellIndex: cellIndx, columnName: column["headerText"], cellValue: $target.text() };
            proxy._trigger(eventName, args);
        },
        _invokeRecordClick: function (e, proxy) {
            this._recordClickProcess(e, proxy, "recordClick");
        },
        _recordClick: function (e) {
            this._click++;
            var proxy = this, singleClickTimer = null;
            if (proxy._click == 1) {
                if ($.inArray("recordClick", this.model.serverEvents) !== -1 && $.inArray("recordDoubleClick", this.model.serverEvents) !== -1) {
                    singleClickTimer = setTimeout(function () {
                        proxy._click = 0;
                        proxy._invokeRecordClick(e, proxy);
                    }, 400);
                }
                else {
					proxy._click = 0;
                    !ej.isNullOrUndefined(singleClickTimer) && clearTimeout(singleClickTimer);
                    proxy._invokeRecordClick(e, proxy);
                }
            }
            else if (proxy._click == 2) {
                !ej.isNullOrUndefined(singleClickTimer) && clearTimeout(singleClickTimer);
                proxy._click = 0;
            }
        },
        _headerMouseDown: function (e) {
            if (($(e.target).hasClass("e-headercelldiv") && !$(e.target).parent().hasClass("e-grouptopleftcell")) || $(e.target).hasClass("e-headercell")) {
                var $headercell = $(e.target).hasClass("e-headercelldiv") ? $(e.target).parent() : $(e.target);
                this.model.enableHeaderHover && $headercell.removeClass("e-hover e-headercell-hover").addClass("e-headercellactive e-active");
            }
            if (this.model.allowResizing)
                return this._resizer._mouseDown(e);
        },
        _contentMouseDown: function (e) {
            if ($(e.target).closest("td").hasClass("e-selectionbackground"))
                return;
            if ($(e.target).closest("tr").length) {
                var xPos = e.type == "touchstart" ? e.originalEvent.touches[0].pageX : e.pageX;
                var yPos = e.type == "touchstart" ? e.originalEvent.touches[0].pageY : e.pageY;
                this._dragDiv = ej.buildTag("div.e-griddragarea", "", { "position": "absolute", "width": "0px", "height": "0px" })
                this.getContent().append(this._dragDiv);
                var tr = $(e.target).closest("tr.e-row");
                if (!tr.length)
                    tr = $(e.target).closest("tr.e-alt_row");
                this._startIndex = tr.length ? this.getIndexByRow(tr) : null;
                this._on($(document), "touchmove mousemove", this._mouseMoveDragHandler);
                if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "safari") {
                    if (!this.model.contextMenuSettings.enableContextMenu)
                        this._on(this.element, "contextmenu", function (e) { e.preventDefault() });
                }
                this._on($(document), "touchend mouseup", this._mouseUpDragHandler);
                this._startDrag = { _x: xPos, _y: yPos };
            }
        },
        _mouseMoveDragHandler: function (e) {
            if (e.pageY != this._startDrag._y) {
                var xPos = e.type == "touchmove" ? e.originalEvent.touches[0].pageX : e.pageX;
                var yPos = e.type == "touchmove" ? e.originalEvent.touches[0].pageY : e.pageY;
                this._selectDrag = true;
                var left = this._dragDiv[0].offsetLeft;
                var top = this._dragDiv[0].offsetTop;

                var x1 = this._startDrag._x,
                y1 = this._startDrag._y,
                x2 = xPos,
                y2 = yPos, tmp, eleLocation = yPos + 2;

                if (x1 > x2) { tmp = x2; x2 = x1; x1 = tmp; }
                if (y1 > y2) { tmp = y2; y2 = y1; y1 = tmp; eleLocation = yPos - 2 }
                var height = this._dragDiv.height();
                this._dragDiv.css({ left: x1, top: y1, width: x2 - x1, height: y2 - y1 });
                var element = $(document.elementFromPoint(xPos, eleLocation));
                var tr = element.closest("tr.e-row");
                if (!tr.length)
                    tr = element.closest("tr.e-alt_row");
                if (tr.length) {
                    this._endIndex = this.getIndexByRow(tr);
                    if (ej.isNullOrUndefined(this._startIndex))
                        this._startIndex = this._endIndex;
                    this.selectRows(this._startIndex, this._endIndex);
                }
            }
        },
        _mouseUpDragHandler: function (e) {
            this._off($(document), "touchend mouseup", this._mouseUpDragHandler);
            this._off($(document), "touchmove mousemove", this._mouseMoveDragHandler);
            if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "safari") {
                if (!this.model.contextMenuSettings.enableContextMenu)
                    this._off(this.element, "contextmenu", function (e) { e.preventDefault() })
            }
            e.stopPropagation();
            this._selectDrag = false;
            this._dragDiv.remove();
        },
        _headerHover: function (e) {
            var $target = $(e.target);
            if (e.type == "mouseover" || e.type == "mousemove" || e.type == "touchmove" || e.type == "MSPointerMove") {
                if (this.model.allowResizing || this.model.allowResizeToFit)
                    this._resizer._mouseHover(e);

                if (this.model.enableHeaderHover && !this._dragActive && (($target.hasClass("e-headercelldiv") && !$target.parent().hasClass("e-grouptopleftcell")) || $target.hasClass("e-headercell"))) {
                    if ($target.hasClass("e-headercelldiv"))
                        $target = $target.parent();
                    this.getHeaderTable().find(".e-columnheader").find(".e-headercell-hover").removeClass("e-headercell-hover").removeClass("e-hover");
                    $target.addClass("e-headercell-hover e-hover");
                }
                if ($target.hasClass("e-gridtooltip"))
                    this._showTooltip($target);
                if ($target.hasClass("e-gridheadertooltip") || $target.find(".e-gridheadertooltip").length)
                    this._showTooltip($target, true);
                if (e.type == "mouseover")
                    this._addCursor();
            } else
                this.model.enableHeaderHover && this.getHeaderTable().find(".e-columnheader").find(".e-headercell-hover").removeClass("e-headercell-hover").removeClass("e-hover");
        },
        _addCursor: function () {
            var flag = (this.model.allowResizing || this.model.allowResizeToFit || this.model.allowGrouping || this.model.allowFiltering || this.model.allowSorting || this.model.allowReordering || this.model.contextMenuSettings.enableContextMenu || this._allowcolumnSelection), isTempCol;
            if (!flag) {
                this.getHeaderTable().find(".e-columnheader").addClass("e-defaultcursor");
                this.getHeaderTable().find(".e-headercell").removeClass("e-defaultcursor");
            }
            else {
                this.getHeaderTable().find(".e-columnheader").removeClass("e-defaultcursor");
                if (!(this.model.contextMenuSettings.enableContextMenu || this.model.selectionSettings.selectionMode == "column")) {
                    var propArray = [{ val: this.model.allowSorting, str: "sort" }, { val: this.model.allowGrouping, str: "group" }, { val: this.model.allowReordering, str: "reorder" }, { val: this.model.allowFiltering, str: "filter" }];
                    var colpropcount = 0;
                    for (var i = 0; i < propArray.length; i++) {
                        if (propArray[i].val == false) {
                            propArray.splice(i, 1);
                            i--;
                        }
                    }

                    for (i = 0; i < this.model.columns.length && propArray.length > 0 ; i++) {
                        for (var j = 0; j < propArray.length; j++) {
                            switch (propArray[j].str) {
                                case "sort":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowSorting) && !this.model.columns[i].allowSorting)
                                        colpropcount++;
                                    break;
                                case "group":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowGrouping) && !this.model.columns[i].allowGrouping)
                                        colpropcount++
                                    break;
                                case "reorder":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowReordering) && !this.model.columns[i].allowReordering)
                                        colpropcount++
                                    break;
                                case "filter":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowFiltering) && !this.model.columns[i].allowFiltering)
                                        colpropcount++;
                                    break;
                            }
                        }
						if(!ej.isNullOrUndefined(this.model.columns[i].template) || !ej.isNullOrUndefined(this.model.columns[i].templateID))
							isTempCol = true;
						else 
							isTempCol = false;
						if (colpropcount == propArray.length && !(isTempCol))
                            this.getHeaderTable().find(".e-headercell").eq(i).addClass("e-defaultcursor");
                        colpropcount = 0;
                    }
                }
            }
        },
        _colgroupRefresh: function () {
            if ((this.model.allowResizing || this.model.allowResizeToFit) && this.model.scrollSettings.frozenColumns > 0) {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                var gridcontentCol = $(this.getContentTable()).find('colgroup');
            }
            else {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup')[0];
                var gridcontentCol = $(this.getContentTable()).find('colgroup')[0];
            }
            var headerColClone = $(gridheaderCol).clone();
            var contentColClone = $(gridcontentCol).clone();
            $(gridcontentCol).remove();
            $(gridheaderCol).remove();
            if ((this.model.allowResizing || this.model.allowResizeToFit) && this.model.scrollSettings.frozenColumns > 0) {
                $(headerColClone[0]).prependTo(this.getHeaderTable()[0]);
                $(headerColClone[1]).prependTo(this.getHeaderTable()[1]);
                $(contentColClone[0]).prependTo(this.getContentTable()[0]);
                $(contentColClone[1]).prependTo(this.getContentTable()[1]);
            }
            else {
                $(headerColClone).prependTo(this.getHeaderTable());
                $(contentColClone).prependTo(this.getContentTable());
            }
        },
        _detailColsRefresh: function () {
            this._$headerCols = this.getHeaderTable().children("colgroup").find("col");
            this._$contentCols = this.getContentTable().children("colgroup").find("col");
            var colCount = this.model.columns.length;
            if (this._$headerCols.length > colCount) this._$headerCols.splice(0, (this._$headerCols.length - colCount));
            if (this._$contentCols.length > colCount) this._$contentCols.splice(0, (this._$contentCols.length - colCount));
        },
        _summaryColRrefresh: function () {
            var table = this.getFooterContent().find('.e-gridsummary');
            for (var i = 0; i < this.columnsWidthCollection.length; i++) 
                table.find('col').eq(i).width(this.columnsWidthCollection[i]);
        },
        _headerdblClickHandler: function (e) {
            if (this.model.allowResizeToFit)
                this._resizer._columnResizeToFit(e);
            if (this.model.allowScrolling)			
                this.getScrollObject().refresh(this.model.scrollSettings.frozenColumns > 0);			
        },

        _mouseUp: function (e) {
            if (this.model.allowResizing)
                this._resizer._mouseUp(e);
        },

        _mouseMove: function (e) {
            if (this.model.allowResizing)
                this._resizer._mouseMove(e);
        },
        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "enableResponsiveRow":
                        if (options[prop]) {
                            this.element.addClass("e-responsive");
                            if (this.model.minWidth) {
                                this._removeMedia();
                                this._scrollerAddedOnMedia = false;
                            }
                            if (this.model.allowFiltering) {
                                this.element.find('.e-filterDialog').remove();
                                this._renderFilterDialogs();
                                this._renderResponsiveFilter();
                                this.element.find('.e-gridtoolbar').remove();
                            }
                        } else {
                            if (this.model.allowFiltering) {
                                $('body').find('.e-filterDialog').remove();
                                this._renderFilterDialogs();
                            }
                            if (this.element.css("display") == "none")
                                this.element.css("display", "block");
                            this.element.removeClass("e-responsive");
                            if (this.model.minWidth)
                                this._addMedia();
                            if (this.model.allowScrolling) {
                                this.getScrollObject().refresh();
                                if (!this.getScrollObject().isVScroll()) {
                                    this.getHeaderContent().removeClass("e-scrollcss");
                                    this.getHeaderContent().find(".e-headercontent").removeClass("e-hscrollcss");
                                }
                                else if (this.getScrollObject().isVScroll()) {
                                    this.getHeaderContent().addClass("e-scrollcss");
                                    this.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
                                }
                            }
                        }
                        this._tdsOffsetWidth = [];
                        if (this.model.allowFiltering || this.model.allowSorting) {
                            var index = this.model.toolbarSettings.toolbarItems.indexOf('responsiveFilter');
                            index != -1 && this.model.toolbarSettings.toolbarItems.splice(index, 1);
                            var sortIndex = this.model.toolbarSettings.toolbarItems.indexOf('responsiveSorting');
                            sortIndex != -1 && this.model.toolbarSettings.toolbarItems.splice(sortIndex, 1);
                            this.element.find('.e-gridtoolbar').remove();
                            this._renderToolBar().insertBefore(this.element.find(".e-gridheader").first());
                        }
                        break;
                    case "showColumnChooser":
                        if (options[prop]) {
                            this._visibleColumns = [];
                            this._hiddenColumns = [];
                            this._visibleColumnsField = [];
                            this._hiddenColumnsField = [];
                            this._renderGridHeaderInternalDesign(this.model.columns);
                            this._renderColumnChooser();
                        }
                        else {
                            var dlgObj = $("#" + this._id + "ccDiv").data("ejDialog");
                            if (dlgObj.isOpened())
                                $("#" + this._id + "_ccTail").remove();
                            var ccBtnHeight = 0;
                            if (!ej.isNullOrUndefined(this.element.find(".e-ccButton").outerHeight()))
                                ccBtnHeight += this.element.find(".e-ccButton").outerHeight();
                            this.element.find(".e-ccButton").remove();
                            $("#" + this._id + 'ccDiv_wrapper').remove();
                            this.element.css('margin-top', (parseInt(this.element.css('margin-top'), 10) - ccBtnHeight));
                        }
                        break;
                    case "gridLines":
                        this.getContent().removeClass("e-horizontallines e-verticallines e-hidelines");
						this.getHeaderContent().removeClass("e-horizontallines e-verticallines e-hidelines");
						this._showHeaderGridLines();
                        this._showGridLines();
                        break;
                    case "showDeleteConfirmDialog":
                        this.model.editSettings.showDeleteConfirmDialog = options[prop];
                        if (options[prop])
                            this._renderConfirmDialog();
                        else
                            this.element.find("#" + this._id + 'ConfirmDialog_wrapper').remove()
                        break;
                    case "showConfirmDialog":
                        this.model.editSettings.showConfirmDialog = options[prop];
                        if (options[prop])
                            this._renderConfirmDialog();
                        else
                            this.element.find("#" + this._id + 'ConfirmDialog_wrapper').remove()
                        break;
                    case "pageSettings":
                        var pageModel = this.getPager().ejPager("model");
                        if (ej.isNullOrUndefined(options[prop]["currentPage"]) || pageModel.currentPage != this._currentPage()) {
                            for (var pageProp in options[prop]) {
                                if (pageProp != "currentPage" && options[prop][pageProp] === pageModel[pageProp])
                                    delete options[prop][pageProp];
                            }
                            if ($.isEmptyObject(options[prop]))
                                break;
                            options[prop]["currentPage"] = this._currentPage();
                            this.getPager().ejPager("option", options[prop]);
                            this._renderPagerTemplate(this.getPager(), options[prop]["showDefaults"]);
                            this._currentPage(this._currentPage() > pageModel.totalPages ? pageModel.totalPages : this._currentPage());
                            this.refreshContent();
                        }
                        break;
                    case "columns":
                        var columns = options.columns;
                        this.model.columns = [];
                        this.columns(columns, "add");
                        break;
                    case "allowPaging":
                        this.model.allowPaging = options[prop];
                        if (options[prop] && this.element.children(".e-pager").length == 0) {
                            this.element.append(this._renderGridPager());
                            this.refreshContent();
                            this.getPager().ejPager("refreshPager");
                        } else {
                            this.getPager().remove();
                            this.setGridPager(null);
                            this.refreshContent();
                            if (this.model.filterSettings.filterType == "filterbar" && this.model.allowFiltering)
                                this._createPagerStatusBar();
                        }
                        break;
                    case "allowSearching":
                        this.model.allowSearching = options[prop];
                        break;
                    case "searchSettings":
                        $.extend(this.model.searchSetings, options[prop]);
                        this.refreshContent();
                        break;
                    case "allowGrouping":
                        if (options[prop] && this.element.children(".e-groupdroparea").length == 0) {
                            this.model.allowGrouping = options[prop];
                            this.addGroupingTemplate();
							this.model.showColumnChooser && this.element.find(".e-ccButton").length > 0 ? this.element.find(".e-ccButton").after(this._renderGroupDropArea()) : this.element.prepend(this._renderGroupDropArea());
                            this._enableGroupingEvents();
                            this._headerCellgDragDrop();
                            this._off(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", this._dropAreaHover);
                            this._on(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", this._dropAreaHover);
                        } else
                            this.element.children(".e-groupdroparea").remove();
                        if (this.model.allowGrouping) {
                            !ej.isNullOrUndefined(options["groupSettings"]) && $.extend(this.model.groupSettings, options["groupSettings"]);
                            this._enableGrouping();
                        }
                        
                        break;
                    case "groupSettings":
                        $.extend(this.model.groupSettings, options[prop]);
                        if(this.model.allowGrouping && ej.isNullOrUndefined(options["allowGrouping"]))
                            this._enableGrouping();
                        if(!ej.isNullOrUndefined(this.model.groupSettings.enableDropAreaAnimation))
                            this.model.groupSettings.enableDropAreaAutoSizing = this.model.groupSettings.enableDropAreaAnimation;
                        break;
                    case "cssClass":
                        this.element.removeClass(this.model.cssClass).addClass(options[prop]);
                        break;
                    case "allowFiltering":
                    case "filterSettings":
                        if (prop == "filterSettings")
                            $.extend(this.model.filterSettings, options[prop]);
                        else
                            this.model.allowFiltering = options[prop];
                        this.filterColumnCollection = [];
                        if (this._$fDlgIsOpen)
                            this._closeFDialog();
                        if (!this.model.allowFiltering) {
                            if (this.model.filterSettings.filterType == ej.Grid.FilterType.FilterBar)
                                this.getHeaderTable().find(".e-filterbar").remove();
                            else if (this.model.filterSettings.filterType == ej.Grid.FilterType.Menu || this.model.filterSettings.filterType == ej.Grid.FilterType.Excel)
                                this.getHeaderTable().find(".e-columnheader").find(".e-filtericon").remove()
                                    .end().find(".e-headercellfilter").removeClass("e-headercellfilter");
                            if (this._isExcelFilter || this._excelFilterRendered) {
                                this._isExcelFilter = this._excelFilterRendered = false;
                                this._excelFilter.resetExcelFilter();
                                this._excelFilter = null;
                            }
                            this.model.filterSettings.filteredColumns = [];
                            this.refreshContent();
                        } else {
                            if (this.model.filterSettings.filterType == ej.Grid.FilterType.FilterBar) {
                                this.getHeaderTable().find(".e-filterbar").remove();
                                this.getHeaderTable().find(".e-columnheader").find(".e-filtericon").remove()
                                    .end().find(".e-headercellfilter").removeClass("e-headercellfilter");
                                this._renderFiltering();
                                this._renderFilterBarTemplate();
                                if (this.model.filterSettings.showFilterBarStatus && !this.model.allowPaging)
                                    this._createPagerStatusBar();
                                else if (this.model.allowPaging)
                                    this.getPager().ejPager({ enableExternalMessage: this.model.filterSettings.showFilterBarStatus });
                                var $filterbar = this.getHeaderTable().find(".e-filterbar");
                                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                                    $filterbar.prepend(this._getEmptyFilterBarCell());
                            } else if (!_filter && (this.model.filterSettings.filterType == ej.Grid.FilterType.Menu || this.model.filterSettings.filterType == ej.Grid.FilterType.Excel)) {
                                var _filter = 1;
                                this.getHeaderTable().find(".e-columnheader").find(".e-filtericon").remove()
                                    .end().find(".e-headercellfilter").removeClass("e-headercellfilter");
                                this.getHeaderTable().find(".e-filterbar").remove();
                                var columnHeader = this.getHeaderTable().find(".e-columnheader").find(".e-headercell").not(".e-detailheadercell");
                                for (var i = 0; i < columnHeader.length; i++) {
                                    var columnName = columnHeader.eq(i).find(".e-headercelldiv").attr("ej-mappingname");
									if(!ej.isNullOrUndefined(columnName)){
										var column = this.getColumnByField(columnName);
										if (!ej.isNullOrUndefined(column) && (ej.isNullOrUndefined(column.allowFiltering) || column.allowFiltering))
											columnHeader.eq(i).addClass("e-headercellfilter").append(ej.buildTag('div.e-filtericon e-icon e-filterset'));
									}
								}                               
							   if (this.model.filterSettings.filterType == ej.Grid.FilterType.Excel) {
                                    this._isExcelFilter = true;
                                    this._renderExcelFilter();
                                } else if (this._isExcelFilter) {
                                    this._isExcelFilter = false;
                                    this._excelFilter.resetExcelFilter();
                                    this._excelFilter = null;
                                }
							   if (this.model.filterSettings.filterType == ej.Grid.FilterType.Menu)
							       this._renderFilterDialogs();
                                this.model.filterSettings.filteredColumns = [];
                                this.refreshContent();
                            }
                            this._enableFilterEvents();
                        }
                        if (this.model.isResponsive && this.model.allowScrolling) {
                            var args = {};
                            args.requestType = "filtering"
                            this._refreshScroller(args);
                        }
                        break;
                    case "enableRowHover":
                        this.model.enableRowHover = options[prop];
                        this._enableRowHover();
                        break;
                    case "allowScrolling":
                    case "scrollSettings":
                        var isDestroy = false;
                        this._columnsPixelConvert();
                        var $content = this.getContent();
                        if (prop != "allowScrolling") {
                            if (!ej.util.isNullOrUndefined(options["scrollSettings"])) {
                                if ($.isEmptyObject(options["scrollSettings"])) break;
                                if (!ej.util.isNullOrUndefined(options["scrollSettings"]["enableVirtualization"]) && !ej.util.isNullOrUndefined(options["scrollSettings"]["allowVirtualScrolling"]))
                                    options["scrollSettings"]["allowVirtualScrolling"] = options["scrollSettings"]["enableVirtualization"];
                                $.extend(this.model.scrollSettings, options["scrollSettings"]);
                            }
                            this._initHeight = this.model.scrollSettings.height;
                            this._isHeightResponsive = this.model.scrollSettings.height == "100%" ? true : false;
							if(this.model.scrollSettings.allowVirtualScrolling){
								this._currentPage(1);
								this.model.currentIndex = 1;
								if(this.model.scrollSettings.enableVirtualization){								
									this._virtualRowCount = Math.round(this.model.scrollSettings.height / this.getRowHeight()) + 1; 
									this._refreshVirtualViewDetails();
									this._refreshVirtualViewData();
								}
								else {
									this._createPagerStatusBar();
									this._showPagerInformation(this.model.pageSettings);
								}
							}
                            if (options["scrollSettings"]["frozenColumns"] !== undefined || options["scrollSettings"]["frozenRows"] !== undefined ||
                                options["scrollSettings"]["allowVirtualScrolling"] !== undefined || options["scrollSettings"]["virtualScrollMode"] !== undefined ||
								options["scrollSettings"]["enableVirtualization"] != undefined) {
                                var model = this.model;
                                model.query = this.commonQuery.clone();
                                if (this._selectedRow() != -1)
                                    this.clearSelection(this._selectedRow());
                                if (options["scrollSettings"]["virtualScrollMode"] != undefined)
                                    model.pageSettings.currentPage = 1;
                                isDestroy = true;
                                this.element.ejGrid("destroy").ejGrid(model);
                            }
                            else {
                                if (!ej.util.isNullOrUndefined(options["allowScrolling"]))
                                    this.model.allowScrolling = options["allowScrolling"];
                                !ej.util.isNullOrUndefined($content.data("ejScroller")) && $content.ejScroller("destroy");
                                this.getContentTable().css("width", "100%");
                                this.getHeaderTable().css("width", "100%");
                                if (this.model.allowScrolling) {
                                    this.getHeaderContent().find("div").first().addClass("e-headercontent");
									 this._originalScrollWidth = this.model.scrollSettings.width;
									 this._renderScroller();
									 this.setWidthToColumns();
									 !ej.util.isNullOrUndefined($content.data("ejScroller")) && this.getScrollObject().refresh();
									 this.refreshScrollerEvent();
                                } else {
                                    this.element.children(".e-gridheader").removeClass("e-scrollcss");
                                    this.element.get(0).style.width.length == 0 && this.element.css("width", "auto");
                                    this.setWidthToColumns();
                                }
                                this._addLastRow();
                            }
                        }
                        if (!isDestroy) {
                            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0) {
                                this._groupingAction(true);
                                this._recalculateIndentWidth();
                            }
                            if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && this.model.allowScrolling)
                                var scroller = this.getScrollObject();
                            var css = this.model.enableRTL ? "e-summaryscroll e-rtl" : "e-summaryscroll";
                            if (this.model.allowScrolling && this.model.showSummary) {
                                if (scroller._vScroll)
                                    this.element.find(".e-summaryrow.e-scroller").addClass(css);
                                this.getFooterTable() && this.getFooterTable().find("colgroup").first().replaceWith(this.getHeaderTable().find("colgroup").clone());
                            }
                        }
                        break;
					case "currentIndex":
						if(this.model.allowScrolling &&  this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
							var currentView = Math.ceil(options["currentIndex"] / this._virtualRowCount);
							this._isThumbScroll = true;
							this._refreshVirtualView(currentView);
							this._refreshVirtualViewScroller(true);
						}
						else
							this._scrollObject.option("scrollTop", options["currentIndex"] * this.getRowHeight());						
						break;
                    case "locale":
                        this.model.locale = options[prop];
                        this.model.query = this.commonQuery.clone();                       
                        this._destroy();
                        this.element.css("margin-top", "0px").addClass("e-grid" + this.model.cssClass);
                        this._init();
                        break;
                    case "dataSource":
                        var $content = this.element.find(".e-gridcontent").first();
                        if (!$.isFunction(options["dataSource"]))
                            this.resetModelCollections();
						if(this._gridRecordsCount == 1 && !ej.isNullOrUndefined(this._cDeleteData) && $.inArray(this._cDeleteData[0], this._dataSource()) == -1 && this.model.editSettings.allowDeleting)
						    this._gridRecordsCount = this._dataSource().length;
						for (var i = 0; i < this.model.columns.length; i++) {
						    if (this.model.columns[i].template !== undefined)
						        this._columntemplaterefresh = true;
						}
                        this._updateDataSource = true;
						this._refreshDataSource(this._dataSource());
						this.element.children(".e-gridfooter").remove();
						if (this.model.showSummary && this.model.currentViewData.length > 0) {
						    this._renderGridFooter().insertAfter($content);
						}
						if(!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount)
							this._addLastRow();
                        break;
                    case "selectedRowIndex":
                        if (this._selectedRow() != -1 && $.inArray(this._selectedRow(), this.selectedRowsIndexes) == -1){
							this.model.currentIndex = this._selectedRow();
                            this.selectRows(this._selectedRow());
						}
                        else if (this._selectedRow() == -1) {
                            this.clearSelection();
                            this.selectedRowsIndexes = [];
                        }
                        break;
                    case "selectedRowIndices":
                        if (this.model.allowSelection == true && this.model.selectionType == "multiple" && this._selectedMultipleRows().length > 0) {
                            this.clearSelection();
							this.selectedRowsIndexes = this._selectedMultipleRows();
                            this._selectedMultipleRows(this.selectedRowsIndexes);
                            for (var i = 0 ; i < this.selectedRowsIndexes.length; i++) {
                                var tr = this.getRowByIndex(this.selectedRowsIndexes[i]);
                                tr.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                            }
							this.model.selectedRecords = this.getSelectedRecords();
                        }
                        else if (this._selectedMultipleRows().length == 0) {
                            this.clearSelection();
                            this.selectedRowsIndexes = [];
                        }
                        break;
                    case "editType":
                        if (this._selectedRow() != -1 && $.inArray(this._selectedRow(), this.selectedRowsIndexes) == -1)
                            this.selectRows(this._selectedRow());
                        break;
                    case "editSettings":
                        $.extend(this.model.editSettings, options[prop]);
                        this.refreshToolbar();
                        this.refreshContent(true);
                        this.refreshBatchEditMode();
                        this._tdsOffsetWidth = [];
                        $("#" + this._id + "_dialogEdit").data("ejDialog") && $("#" + this._id + "_dialogEdit").ejDialog("destroy");
                        $("#" + this._id + "_dialogEdit_wrapper,#" + this._id + "_dialogEdit").remove();
                        $("#" + this._id + "_externalEdit").remove();
                        this.getContentTable().find(".e-insertedrow").remove();
                        this.model.isEdit = false;
                        if (this.model.editSettings.editMode != 'normal')
                            this.model.editSettings.showAddNewRow = false;
                        if (!this.model.editSettings.showAddNewRow) 
                            this.getContentTable().find(".e-addedrow").length && this.cancelEdit();
                        if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
                            if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate")
                                this.element.append(this._renderDialog());
                            else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                                this.element.append(this._renderExternalForm());
                       }
                        if ((this.model.editSettings.allowDeleting && this.model.editSettings.showDeleteConfirmDialog) ||
                            this.model.editSettings.editMode == "batch" && this.model.editSettings.showConfirmDialog)
                            ej.isNullOrUndefined(this._confirmDialog) && this._renderConfirmDialog();
                        this._enableEditingEvents();
						this.refreshToolbar();
                        break;
                    case "allowResizing":
                        this.model.allowResizing = options[prop];
                        if (this.model.allowResizing) {
                            this._on(this.element, ej.eventType.mouseMove, this._mouseMove);
                            this._on(this.element, "mouseup", this._mouseUp);
                            this._resizer = this._resizer || new ej.gridFeatures.gridResize(this);
                        }
                        else {
                            this._off(this.element, ej.eventType.mouseMove, this._mouseMove);
                            this._off(this.element, "mouseup", this._mouseUp);
                            if (!this.model.allowResizeToFit)
                                this._resizer = null;
                        }
                        break;
                    case "allowResizeToFit":
                        if (this.model.allowResizeToFit) {
                            this._on(this.element, "dblclick", ".e-gridheader", this._headerdblClickHandler);
                            this._resizer = this._resizer || new ej.gridFeatures.gridResize(this);
                            this.setWidthToColumns();
                        }
                        else {
                            this._off(this.element, "dblclick", ".e-gridheader", this._headerdblClickHandler);
                            if (!this.model.allowResizing)
                                this._resizer = null;
                        }
                        break;
                    case "allowReordering":
                        this.model.allowReordering = options[prop];
                        if (this.model.allowReordering)
                            this._headerCellreorderDragDrop();
                        break;
                    case "allowRowDragAndDrop":
                        if (this.model.allowRowDragAndDrop) {
                            this._rowsDragAndDrop();
                            if (this.model.selectionType == "multiple")
                                this._on(this.element, "touchstart mousedown", ".e-gridcontent", this._contentMouseDown)
                            this.model.allowScrolling && this.getContent().ejScroller({ thumbStart: function () { return false } });
                        } else {
                            this._off(this.element, "touchstart mousedown", ".e-gridcontent", this._contentMouseDown)
                            this.getContentTable().ejDroppable("destroy");
                            $(this.getRows()).ejDraggable("destroy");
                            this.getContent().ejScroller({ thumbStart: null });
                        }
                        break;
                    case "showSummary":
                    case "summaryRows":
                        if (prop == "showSummary" && options[prop]) this.addSummaryTemplate();
                        if (prop == "showSummary" && !options[prop])
                            this.element.children(".e-gridfooter").remove();
                        else if (prop == "summaryRows" && this.model.showSummary || prop == "showSummary") {
                            this.element.children(".e-gridfooter").remove();
                            this.element.children(".e-gridfooter").remove();
                            var $content = this.element.find(".e-gridcontent").first();
                            var query = this.model.query.queries;
                            var pageQuery = [];
                            for (var i = 0; i < query.length; i++) {
                                if (query[i].fn === "onPage") {
                                    pageQuery = query.splice(i, 1);
                                }
                            }
                            var queryManager = this.model.query;
                            this._setSummaryAggregate(queryManager);
                            if(pageQuery.length)
                                queryManager.queries.push(pageQuery[0]);
                            if (this.model.currentViewData.length) {
                                if (this._isLocalData) {
                                    this._remoteSummaryData = this._dataManager.executeLocal(queryManager).aggregates;
                                    this._renderGridFooter().insertAfter($content);
                                }
                                else {
                                    var proxy = this;
                                    var promise = this._dataManager.executeQuery(queryManager);
                                    promise.done(function (e) {
                                        proxy.element.children(".e-gridfooter").remove();
                                        proxy._remoteSummaryData = e.aggregates
                                        proxy._renderGridFooter().insertAfter($content);
                                    });
                                }
                            }
                            if (this.model.allowGrouping) {
                                this._rowCol = this._captionSummary();
                                this._isCaptionSummary = (this._rowCol != null && this._rowCol.length) > 0 ? true : false;
                                this.refreshContent(true);
                            }
                        }
                        break;
                    case "enableAltRow":
                        this.model.enableAltRow = options[prop];
                        this.addInitTemplate();
                        this.refreshContent();
                        break;
                    case "toolbarSettings":
                        $.extend(this.model.toolbarSettings, options[prop]);
                        this.element.children(".e-gridtoolbar").remove();
                        if (this.model.toolbarSettings.showToolbar)
                            this._renderToolBar().insertBefore(this.element.find(".e-gridheader").first());
                        break;
                    case "allowSorting":
                        this.model.allowSorting = options[prop];
                        if (!this.model.allowSorting) 
                            this.clearSorting();
                        break;
                    case "selectionSettings":
                        $.extend(this.model.selectionSettings, options[prop]);
                        this.clearSelection();
                        this.clearCellSelection();
                        this.clearColumnSelection();
                        this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
						if(this.model.selectionSettings.selectionMode.length > 0 && this.model.allowSelection)
							this._initSelection();
                        break;
                    case "sortSettings":
                        $.extend(this.model.sortSettings, options[prop]);
                        this.refreshContent();
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model.contextMenuSettings, options[prop]);
                        !ej.isNullOrUndefined($("#" + this._id + "_Context").data("ejMenu")) && $("#" + this._id + "_Context").ejMenu("destroy") && $("#" + this._id + "_Context").remove();
                        if (this.model.contextMenuSettings.enableContextMenu)
                            this._renderContext()
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[prop];
                        var model = this.model;
                        model.query = this.commonQuery.clone();
                        this.element.ejGrid("destroy");
                        model.enableRTL ? $("#" + this._id).addClass("e-rtl") : $("#" + this._id).removeClass("e-rtl");
                        $("#" + this._id).ejGrid(model);
                        break;
                    case "enableTouch":
                        this.model.enableTouch = options[prop];
                        if (!this.model.enableTouch) {
                            this.element.addClass("e-touch");
                            this._off(this.element, "swipeleft swiperight", ".e-gridcontent .e-table");
                        }
                        else {
                            this._on(this.element, "swipeleft swiperight", ".e-gridcontent .e-table", $.proxy(this._touchGrid, this));
                            this.element.removeClass("e-touch");
                        }
                        break;
                    case "allowSelection":
                        if (options[prop]) {
                            this._off(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", this._clickHandler);
                            this._on(this.element, "click", this._clickHandler);
							this._initSelection();
                        }
                        else {
                            this.clearSelection();
                            this.clearCellSelection();
                            this.clearColumnSelection();
                            this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
                        }
                        break;
                    case "query":
                        this.commonQuery = $.extend(true, {}, options[prop]);
                        break;
                    case "showStackedHeader":
                    case "stackedHeaderRows":
                        if (this.model.showStackedHeader && options["stackedHeaderRows"] && options.stackedHeaderRows.length > 0) {
                            if (ej.getObject("stackedHeaderRows.length", options))
                                this.model.stackedHeaderRows = options["stackedHeaderRows"];                            
                            this._refreshStackedHeader();
                         }
                          else
                            this.getHeaderTable().find(".e-stackedHeaderRow").remove();
                        break;
                    case "allowTextWrap":
                    case "textWrapSettings":
                        $.extend(this.model.textWrapSettings, options[prop]);
                            this._setTextWrap();
                        break;
                    case "rowTemplate":
                        this.refreshContent(true);
                        break;
                    case "detailsTemplate":
                        if (this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) {
                            this._renderAlertDialog();
                            this._alertDialog.find(".e-content").text(this._getLocalizedLabels("FrozenNotSupportedException"));
                            this._alertDialog.ejDialog("open");
                        }
                        else {
                            var $header = this.element.children(".e-gridheader");
                            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
                            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                                this._renderFiltering();
                            this.setGridHeaderContent($header);
                            this.refreshContent(true);
                            if (this.model.allowReordering)
                                this._headerCellreorderDragDrop();
                            if (this.model.allowGrouping)
                                this._headerCellgDragDrop();
                        }
                        break;
                }
            }

        },
        
        resetModelCollections: function () {
            this.model.groupSettings.groupedColumns = [];
            this.model.filterSettings.filteredColumns = [];
            this.filterColumnCollection = [];
            this.model.sortSettings.sortedColumns = [];
            this.model.pageSettings.currentPage = this.defaults.pageSettings.currentPage;
        },
        _enableGrouping: function(){
			this.refreshTemplate();
			if (this.model.groupSettings.showToggleButton) {
			    for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
			        var headercell = this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").eq(columnCount);
 					var field = this.model.columns[columnCount].field;
			        if ($.inArray(field, this._disabledGroupableColumns) == -1 && !ej.isNullOrUndefined(field) && field != "") {
			            if (!headercell.find(".e-gridgroupbutton").length) {
			                if ($.inArray(field, this.model.groupSettings.groupedColumns) != -1)
			                    headercell.append(this._getToggleButton().addClass("e-toggleungroup"));
			                else
			                    headercell.append(this._getToggleButton().addClass("e-togglegroup"));
			            }
			        }
			    }
			}
			if (!this.model.groupSettings.showToggleButton)
			    this.getHeaderTable().find(".e-gridgroupbutton").remove();
			this.element.find(".e-groupdroparea").remove();
			if (this.model.groupSettings.showDropArea) {
			    this.model.showColumnChooser && this.element.find(".e-ccButton").length > 0 ? this.element.find(".e-ccButton").after(this._renderGroupDropArea()) : this.element.prepend(this._renderGroupDropArea());
			    if (ej.gridFeatures.dragAndDrop) {
			        this._groupHeaderCelldrag();
			        this._headerCellgDragDrop();
			    }
			}
			if (!ej.isNullOrUndefined(this.model.groupSettings.groupedColumns.length) && this.model.groupSettings.groupedColumns.length) {
				var args = {};
			    args.columnName = this.model.groupSettings.groupedColumns[this.model.groupSettings.groupedColumns.length - 1];
			    args.requestType = ej.Grid.Actions.Grouping;
			    this.element.find(".e-groupdroparea").empty();
				for (var i = 0; i < this.model.groupSettings.groupedColumns.length - 1; i++)
					this._addColumnToGroupDrop(this.model.groupSettings.groupedColumns[i]);
				for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
					if (ej.isNullOrUndefined(this.getsortColumnByField(this.model.groupSettings.groupedColumns[i])))
						this.model.sortSettings.sortedColumns.push({ field: this.model.groupSettings.groupedColumns[i], direction: ej.sortOrder.Ascending});
				}
				this._processBindings(args);
			}
        },
        
        addIgnoreOnExport: function (args) {
            if (typeof (args) == 'string')
                this.ignoreOnExport.push(args);
            else
                this.ignoreOnExport = this.ignoreOnExport.concat(args);
        },
        addIgnoreOnToolbarServerClick: function (args) {
            if (typeof (args) == 'string')
                this.ignoreOnToolbarServerClick.push(args);
            else
                this.ignoreOnToolbarServerClick = this.ignoreOnToolbarServerClick.concat(args);
        },
        _decode: function (value) {
            return $('<div/>').html(value).text();
        },
        _htmlEscape: function (str) {
            var regx = /[&<>"']/g, charEntities = {
                "&": "&amp;",
                "<": "&lt;",
                ">": "&gt;",
                "\"": "&#34;",
                "'": "&#39;"
            };
            return str.replace(regx, function (c) {
                return charEntities[c];
            });
        },
        _mappingSelection: function () {
            if (ej.gridFeatures.selection && this._enableCheckSelect) {
                this.multiSelectCtrlRequest = true;
                var rowIndexes = [];
                for (var i = 0; i < this._currentJsonData.length; i++) {
                    if (ej.pvt.getObject(this._selectionMapColumn, this._currentJsonData[i]) == true)
                        rowIndexes.push(i)
                }
                this.selectedRowsIndexes = [];
                this._selectedRow(-1);
                this._selectionByGrid = true;
                rowIndexes.length && this.selectRows(rowIndexes);
                this._selectionByGrid = false;
            }
        },
        _headerCheckUpdateAll: function (val) {
            var data = [];
            if (this._isLocalData)
                data = this._dataSource() instanceof ej.DataManager ? this._dataSource().dataSource.json : this._dataSource();
            else
                data = this._currentJsonData;
            for (var i = 0; i < data.length; i++) {
                data[i][this._selectionMapColumn] = val;
                this.batchChanges.changed.push(data[i]);
            }
            this.batchSave();
            return;
        },
        _getForeignKeyData: function (data) {
            var proxy = this;
            var column = {},i;
            for (i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i].foreignKeyValue && this.model.columns[i].dataSource) {
                    var fieldName = ej.isNullOrUndefined(proxy.model.columns[i]["foreignKeyField"]) ? proxy.model.columns[i]["field"] : proxy.model.columns[i]["foreignKeyField"];
                    var dataSource = this.model.columns[i].dataSource instanceof ej.DataManager ? this.model.columns[i].foreignKeyData : this.model.columns[i].dataSource;
                    dataSource.filter(function (col) {
                        var value = ej.getObject(proxy.model.columns[i]["field"], data);
                        var fValue = !isNaN(parseFloat(value)) && isFinite(value) ? parseFloat(value) : value;
                        if (col[fieldName] == fValue) {
                            column[fieldName] = col;
                        }
                    });
                }
            }
            return column;
        },
        _foreignKeyBinding: function (curColumn, cellValue, gridId) {
            var cellData, val;
            var gridObj = $("#" + gridId).ejGrid('instance');
            curColumn = gridObj.model.columns[curColumn];
            var dataSource = curColumn.dataSource instanceof ej.DataManager ? curColumn.foreignKeyData : curColumn.dataSource;
            dataSource.filter(function (col) {
                if (ej.getObject(curColumn.foreignKeyField, col) == cellValue) {
                    val = ej.getObject(curColumn.foreignKeyValue, col);
                    return cellData = curColumn.type == "date" ? new Date(val) : val;
                }
            });
            if (curColumn.format) {
                cellData = gridObj.formatting(curColumn.format, cellData, gridObj.model.locale);
            }
            return cellData;
        },
        _checkForeignKeyBinding: function () {
            if (!this.model.columns.length)
                return;
            var c, _cols, _len, _col;
            for (c = 0, _cols = this.model.columns, _len = _cols.length; c < _len; c++) {
                _col = _cols[c];
                if (_col.hasOwnProperty("foreignKeyField") && _col["dataSource"] instanceof ej.DataManager)
                    this._relationalColumns.push({ field: _col["field"], key: _col["foreignKeyField"], value: _col["foreignKeyValue"], dataSource: _col["dataSource"] });
            }
            this._$fkColumn = true;
        },  
        _setForeignKeyData: function (args) {
            if (!this._relationalColumns.length)
                return;
            var arr = this._relationalColumns, len = this._relationalColumns.length,
                promises = [], viewData = this.model.currentViewData, e = {};
            var obj, qry, pred, dist, qPromise, proxy = this;
            if (viewData.length == 0) {
                for (var c = 0, clen = this.model.columns.length; c < clen; c++) {
                    var column = this.model.columns[c];
                    if (!ej.isNullOrUndefined(column["foreignKeyField"]) && column.dataSource instanceof ej.DataManager)
                        column["foreignKeyData"] = [];
                }
            }
            var failFn = ej.proxy(function (e) { /*Separate fail handler to get more control over request*/
                this._trigger("actionFailure", { requestType: "fetchingforeigndata", error: e.error });
            }, this);
            if (!this.element.ejWaitingPopup("model.showOnInit"))
                this.element.ejWaitingPopup("show");
                
            for (var i = 0; i < len; i++) {
                if (!(0 in viewData)) continue;
                obj = arr[i], e.field = obj["field"], e.keyField = obj["key"], e.valueField = obj["value"], e.dataSource = obj["dataSource"],
                            e.query = new ej.Query().select([e.valueField, e.keyField]).foreignKey(e.keyField),
                            dist = ej.distinct(viewData.level ? viewData.records : viewData, e.keyField, true);
                       
                pred = ej.UrlAdaptor.prototype.getFiltersFrom(dist, e.query);
                e.query.where(pred);
                        
                if (this._trigger("actionBegin", $.extend(e, { requestType: "fetchingforeigndata", column: this.getColumnByField(e.field) })))
                    return;
                qPromise = e.dataSource.ready === undefined ? e.dataSource.executeQuery(e.query, null, failFn) : e.dataSource.ready.fail(failFn);
                promises.push(qPromise);
            }
                
            $.when.apply(this, promises).then(function () {
                proxy.element.ejWaitingPopup("hide");
                var arg = [].slice.call(arguments, 0, arguments.length), column;
                for (var i = 0, plen = promises.length; i < plen; i++) {
                    obj = arr[i];
                    for (var c = 0, clen = proxy.model.columns.length; c < clen; c++) {
                        column = proxy.model.columns[c];
                        if (column["foreignKeyField"] == obj["key"] && column["foreignKeyValue"] == obj["value"])
                            column["foreignKeyData"] = arg[i].result;
                    }
                }
                proxy.initialRender ? proxy._initGridRender() : proxy.sendDataRenderingRequest(args);
            });
                
        },
        _isRelationalRendering: function (args) {
            return (0 in this._relationalColumns) && ["add", "beginedit", "cancel"].indexOf(args.requestType) == -1;
        }        
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    "use strict"
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.edit = {
        _processEditing: function () {
            var colInfo = this._columnToSelect(), query = colInfo.query, dropObj = [], dropField = colInfo.fields, promises = [], qPromise,
                            e = this._relationalColumns, len = e.length, req;
            this.model.query._fromTable != "" && query.from(this.model.query._fromTable);
            req = dropField.length;
            if (req) 
                promises.push(this._dataManager.executeQuery(query));
            if (len != 0) {
                var obj, qry;
                for (var i = 0; i < len; i++) {
                    obj = e[i], qry = new ej.Query().select([obj.key, obj.value]);
                    qPromise = obj["dataSource"].ready === undefined ? obj["dataSource"].executeQuery(qry) : obj["dataSource"].ready;
                    promises.push(qPromise);
                }
            }
            if (colInfo.fieldsDrop.length) {
                var colLen = colInfo.fieldsDrop.length, fields = colInfo.fieldsDrop;
                for (var col = 0; col < colLen; col++) {
                    var tempobj = [];
                    var colObj = this.getColumnByField(fields[col]);
                    if (!ej.isNullOrUndefined(ej.getObject("editParams.fields.text", colObj))) {
                        var params = colObj.editParams;
                        dropObj.push(params.fields);
                    }
                    else
                        dropObj.push(fields[col]);
                    if (dropObj[col] instanceof Object) {
                        tempobj.push(dropObj[col].text);
                        tempobj.push(dropObj[col].value);
                    }
                    else tempobj.push(dropObj[col]);
                    var query = new ej.Query().select(tempobj);
                    promises.push(colObj.dataSource.executeQuery(query));
                }
            }
            if (promises.length != 0) {
                $.when.apply(this, promises).then(ej.proxy(function () {
                    var arg = [].slice.call(arguments, 0, arguments.length);
                    for (var i = 0, j = 0, k = 0, s = req, flag, plen = promises.length; i < plen; i++) {
                        while (s > 0) {
                            ej.createObject(dropField[--s], arg[i].result, this._dropDownManager);
                            flag = true;
                        }
                        if (flag && i == 0) continue; /* i == 0 - since one req will be made for all Ddl columns*/
                        if (e.length != j) {
                            var obj = e[j], key = obj.key + "." + obj.value;
                            ej.createObject(key, arg[i].result, this._dropDownManager);
                            j++;
                            continue;
                        }
                        if (e.length == j && dropObj.length) {
                            if (dropObj[k] instanceof Object) {
                                ej.createObject(dropObj[k].text, arg[i].result, this._dropDownManager);
                                ej.createObject(dropObj[k].value, arg[i].result, this._dropDownManager);
                            }
                            else
                                ej.createObject(dropObj[k], arg[i].result, this._dropDownManager);
                            k++;
                        };
                    }
                    this._initiateTemplateRendering();
                }, this));
            }
            else
                this._initiateTemplateRendering();
        },
        _initiateTemplateRendering: function() {
            if (this.model.editSettings.editMode == "normal") this.addEditingTemplate();
            else if (this.model.editSettings.editMode == "batch") this.addBatchEditTemplate();
            else if (this.model.editSettings.editMode == "dialog" ||
                this.model.editSettings.editMode == "externalform" ||
               this.model.editSettings.editMode == "inlineform")
                this.addDialogEditingTemplate();
            else this.addExternalDialogEditingTemplate();
            if ((this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal"))
                this._startAdd();
        },
        addEditingTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $tbody = ej.buildTag('tbody');
            var $tr = ej.buildTag('tr');
            var $td = ej.buildTag('td', "", {}, { colSpan: this.model.scrollSettings.frozenColumns > 0 ? this.model.scrollSettings.frozenColumns : this.model.columns.length });
            var $form = ej.buildTag('form', "", {}, { id: this._id + "EditForm", "class": "gridform" });
            var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: 0.25 });
            var $innerTbody = ej.buildTag('tbody');
            var $innerTr = ej.buildTag('tr');
            $tbody.append($tr);
            $tr.append($td);
            $td.append($form);
            var $colGroup = $(document.createElement('colgroup'));
            $form.append($table);
            $table.append($colGroup);
            $innerTbody.append($innerTr).appendTo($table);
            if (this.model.scrollSettings.frozenColumns > 0) {
                var $tbodyClone = $tbody.clone();
                $tbodyClone.find("td").first().prop("colSpan", this.model.columns.length - this.model.scrollSettings.frozenColumns);
            }
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                var $innerTd = ej.buildTag('td.e-rowcell');
                $innerTr.append($innerTd.get(0));
                if (this.model.columns[columnCount]["type"] == "checkbox" && !this._isMapSelection)
                    continue;
                if (ej.isNullOrUndefined(this.model.columns[columnCount]["commands"]) &&
                 (!this.model.columns[columnCount]["template"] || (this.model.columns[columnCount]["template"] && this.model.columns[columnCount]["allowEditing"] != false && this.model.columns[columnCount]["field"]))) {
                    this._initCellEditType(columnCount, $innerTd);
                } else if (this.model.columns[columnCount]["template"]) {
                    var helpers = {}, htxt = this.model.columns[columnCount].headerText;
                    helpers["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this);
                    $.views.helpers(helpers);
                    if (!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                        htxt = htxt.replace(/[^0-9\s\w]/g, "_");
                    $("#" + this._id + htxt + columnCount + "_Template").remove();
                    var scriptElement = this._createTemplateElement(this.model.columns[columnCount]);
                    $innerTd.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "')}}");
                } else if (this.model.columns[columnCount]["commands"]) {
                    var helpers = {};
                    helpers["_" + this._id + "UnboundTemplate"] = this._unboundTemplateRendering;
                    $.views.helpers(helpers);
                    $("#" + this._id + this.model.columns[columnCount].headerText.replace(/[^a-z0-9|s_]/gi, '')+ columnCount + "_UnboundTemplate").remove();
                    var divElement = this._createUnboundElement(this.model.columns[columnCount], columnCount);
                    $innerTd.addClass("e-unboundcell").addClass("e-" + this.model.columns[columnCount]["headerText"].replace(/[^a-z0-9|s_]/gi, '') + columnCount).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                    this.model.scrollSettings.frozenColumns > 0 && $innerTd.addClass("e-frozenunbound");
                    this._isUnboundColumn = true;
                }
                if (this.model.columns[columnCount]["textAlign"] != undefined)
                    $innerTd.css("text-align", this.model.columns[columnCount]["textAlign"]);
                this.model.columns[columnCount]["allowEditing"] == false && $innerTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                if (this.model.columns[columnCount]["isPrimaryKey"] === true)
                    $innerTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                if (this.model.columns[columnCount]["isIdentity"] === true) {
                    $innerTd.find(".e-field").addClass("e-identity");
                    this._identityKeys.push($.trim(this.model.columns[columnCount].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
                var $col = $(document.createElement('col'));
                if (this.model.columns[columnCount]["priority"]) {
                    $innerTd.addClass("e-table-priority-" + this.model.columns[columnCount]["priority"]);
                    $col.addClass("e-table-priority-" + this.model.columns[columnCount]["priority"]);
                }
                if (this.model.columns[columnCount]["visible"] === false) {
                    $col.css("display", "none");
                    $innerTd.addClass("e-hide");
                }
                if (!ej.isNullOrUndefined(this.model.columns[columnCount]["cssClass"])) {
                    $innerTd.addClass(this.model.columns[columnCount]["cssClass"]);
                }
                !this.model.groupSettings.showGroupedColumn && $innerTd.addClass("{{for ~groupedColumns}}" +
                    " {{if #data == '" + this.model.columns[columnCount]["field"] + "'}}e-hide{{/if}}" +
                    "{{/for}}") && $col.css("display", "none");
                $colGroup.append($col);
                if (columnCount == this.model.scrollSettings.frozenColumns - 1) {
                    $innerTr = $tbodyClone.find("tr").last();
                    $colGroup = $tbodyClone.find("colgroup");
                    $.templates(this._id + "_JSONFrozenEditingTemplate", $tbody.html());
                    $tbody = $tbodyClone;
                }
            }
            $.templates(this._id + "_JSONEditingTemplate", $tbody.html());
        },

        addDialogEditingTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $tbody = ej.buildTag('div');
            var $form = ej.buildTag('form.gridform', "", {}, { id: this._id + "EditForm" });
            var $table = ej.buildTag('table', "", {}, { cellspacing: "14px" });
            var $innerTr, $labelTd, $valueTd, trElement, tdElement;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount]["type"] == "checkbox" && !this._isMapSelection)
                    continue;
                if (this.model.editSettings.editMode == "dialog") {
                    trElement = 'tr';
                    tdElement = 'td';
                }
                else trElement = tdElement = 'div';
                $innerTr = ej.buildTag(trElement);
                $labelTd = ej.buildTag(tdElement, "", { "text-align": "right" }).addClass("e-label");
                $valueTd = ej.buildTag(tdElement, "", { "text-align": "left" }).addClass("e-rowcell");
				if($innerTr.is('div'))
                    $innerTr.addClass("e-gridFromDiv")
                 if (this.model.columns[columnCount]["priority"] && this.model.editSettings.editMode == "inlineform") 
                    $innerTr.addClass("e-table-priority-" + this.model.columns[columnCount]["priority"]);
                $innerTr.append($labelTd.get(0)).append($valueTd.get(0));
                if (this.model.columns[columnCount].headerText == undefined)
                    this.model.columns[columnCount].headerText = this.model.columns[columnCount].field;
                $labelTd.append("<label for='" + this.model.columns[columnCount].field + "'>" + this.model.columns[columnCount].headerText + "</label>");
                if (ej.isNullOrUndefined(this.model.columns[columnCount]["commands"]) &&
				(!this.model.columns[columnCount]["template"] || (this.model.columns[columnCount]["template"] && this.model.columns[columnCount]["allowEditing"] !=false && this.model.columns[columnCount]["field"])))
                    this._initCellEditType(columnCount, $valueTd);
                else if (this.model.columns[columnCount]["template"]) {
                    var helpers = {}, htxt = this.model.columns[columnCount].headerText;
                    helpers["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this);
                    $.views.helpers(helpers);
                    if (!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                        htxt = htxt.replace(/[^0-9\s\w]/g, "_");
                    $("#" + this._id + htxt + columnCount + "_Template").remove();
                    var scriptElement = this._createTemplateElement(this.model.columns[columnCount]);
                    $valueTd.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "')}}");
                } else if (this.model.columns[columnCount]["commands"]) {
                    var helpers = {};
                    helpers["_" + this._id + "UnboundTemplate"] = this._unboundTemplateRendering;
                    $.views.helpers(helpers);
                    $("#" + this._id + this.model.columns[columnCount].headerText.replace(/[^a-z0-9|s_]/gi, '')+columnCount+ "_UnboundTemplate").remove();
                    var divElement = this._createUnboundElement(this.model.columns[columnCount], columnCount);
                    $valueTd.addClass("e-unboundcell").addClass("e-" + this.model.columns[columnCount]["headerText"].replace(/[^a-z0-9|s_]/gi, '')+columnCount).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                    this.model.scrollSettings.frozenColumns > 0 && $valueTd.addClass("e-frozenunbound");
                    this._isUnboundColumn = true;
                    $innerTr.addClass("e-hide");
                }
                this.model.columns[columnCount]["allowEditing"] == false && $valueTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                if (this.model.columns[columnCount]["isIdentity"] === true) {
                    $valueTd.find(".e-field").addClass("e-identity");
                    this._identityKeys.push($.trim(this.model.columns[columnCount].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
                if (this.model.columns[columnCount]["visible"] === false)
                    $innerTr.addClass("e-hide");
                 if (!ej.isNullOrUndefined(this.model.columns[columnCount]["cssClass"])) {
                     $valueTd.addClass(this.model.columns[columnCount]["cssClass"]);
                }
                if (this.model.editSettings.editMode == "dialog") {
                    $form.append($table);
                    $table.append($innerTr);
                } else
                    $form.append($innerTr);
                $form.appendTo($tbody);
                if (this.model.columns[columnCount]["isPrimaryKey"] === true) {
                    $valueTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                    this._primaryKeys.push($.trim(this.model.columns[columnCount].field));
                    this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                }
            }
            if (this.model.editSettings.editMode == "dialog") $form.append($table);
            $tbody = this.renderDiaglogButton($form, $tbody);
            $.templates(this._id + "_JSONDialogEditingTemplate", $tbody.html());
        },
        _editEventTrigger: function (args) {
            if (args.requestType == "save" || args.requestType == "delete") {
                var params = {
                    data: args.data,
                    rowData: args.data,
                    previousData: args.previousData,
                    action: args.action !== undefined ? args.action : args.requestType,
                };
                if (!ej.isNullOrUndefined(args.foreignKeyData))
                    params.foreignKeyData = args.foreignKeyData;
				this._trigger("end" + params.action.charAt(0).toUpperCase() + params.action.slice(1), params);
            }
        },
        _compiledDropDownTemplate: function (valueField, textField, colType, format) {
            var helpers = { _gridFormatting: this.formatting };
            $.views.helpers(helpers);
            var $select = ej.buildTag('select');
            var $option = ej.buildTag("option", format != null ? "{{:~_gridFormatting('" + format + "'," + textField + ",'" + this.model.locale + "')}}" : "{{:" + textField + "}}", {}, { value: "{{:" + valueField + "}}" });
            $select.append($option);
            return $.templates($select.html());
        },
        _initCellEditType: function (columnCount, element) {
            var fName = this.model.columns[columnCount].field;
            if (this.model.columns[columnCount]["foreignKeyValue"])
                this.model.columns[columnCount]["editType"] = "dropdownedit";
            if (this._dataSource() instanceof ej.DataManager  && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) {
                var index = $.inArray(this.model.columns[columnCount].field,this._dataSource().adaptor.value),fk_Value,fk_fieldName;
				 if(index != -1){
						fk_Value = this._dataSource().adaptor.value[index];
						fk_fieldName = this._dataSource().adaptor.key[index];	 
				 }
            }
            if (this.model.columns[columnCount]["editTemplate"])
                this.model.columns[columnCount]["editType"] = "edittemplate";
            if (ej.isNullOrUndefined(this.model.columns[columnCount]["editType"]))
                if (this.model.columns[columnCount]["type"] == "date" || this.model.columns[columnCount]["type"] == "datetime")
                    this.model.columns[columnCount]["editType"] = this.model.columns[columnCount]["type"] + "picker";
                else
                    this.model.columns[columnCount]["editType"] = "stringedit";
            if (this.model.isResponsive)
                element.attr("data-cell",this._decode(this.model.columns[columnCount]["headerText"]));
            var splits = (fName || "").split("."), sLen = splits.length - 1, braces = "";
            if (!ej.isNullOrUndefined(fName))
                fName = fName.replace(/[^a-z0-9\s_]/gi, '');
            while (sLen) {
                braces += "(";
                sLen--;
            }
            switch (this.model.columns[columnCount]["editType"]) {
                case "edittemplate":
                    var temp = this.model.columns[columnCount].editTemplate.create;
                    if (typeof temp == "string") {
                        var temp1 = ej.util.getObject(temp, window);
                        if (!$.isFunction(temp1)) {
                            if ($(temp).length == 1 && $(temp).get(0).tagName == "SCRIPT")
                                var $edittemplate = $($(temp).html()).attr({ id: this._id + fName, name: this.model.columns[columnCount].field });
                            else
                                var $edittemplate = $(temp).attr({ id: this._id + fName, name: this.model.columns[columnCount].field });
                        }
                        else
                            var $edittemplate = $(temp1()).attr({ id: this._id + fName, name: this.model.columns[columnCount].field });
                    }
                    else
                        var $edittemplate = $(temp()).attr({ id: this._id + fName, name: this.model.columns[columnCount].field });
                    element.append($edittemplate);
                    break;
                case "stringedit":
                    element.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{html:" + braces + "#data['" + splits.join("'] || {})['") + "']}}", id: this._id + fName, name: this.model.columns[columnCount].field }));
                    break;
                case "booleanedit":
                    element.html('{{if #data["' + splits.join('"]["') + '"]}} <input class="e-field e-checkbox" type ="checkbox" id=' + this._id + fName + ' name=' + this.model.columns[columnCount].field + ' checked="checkbox"></input>{{else}} <input class="e-field e-checkbox" type ="checkbox" id=' + this._id + fName + ' name=' + this.model.columns[columnCount].field + ' > {{/if}}');
                    if (this.model.editSettings.editMode == "normal")
                        element.addClass("e-boolcell");
                    break;
                case "numericedit":
                    var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", {}, { type: "text", value: "{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}", id: this._id + fName, name: this.model.columns[columnCount].field });
                    element.append($numericText);
                    break;
                case "datepicker":
                case "datetimepicker":
                    var $datePicker = ej.buildTag('input.e-' + this.model.columns[columnCount]["editType"] + ' e-field', "", {}, { type: "text", value: "{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}", id: this._id + fName, name: this.model.columns[columnCount].field });
                    element.append($datePicker);
                    break;
                case "dropdownedit":
                    var currColumn = this.model.columns[columnCount], selectedItems = [], $foreignkeyfield, $foreignkeyvalue;
                    if (ej.isNullOrUndefined(currColumn.dataSource)) {
                        var arrayOfDatas;
                        if (ej.isNullOrUndefined(currColumn.dataSource) && (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && currColumn.field == fk_Value)) {
                            var data = this.model.dataSource.adaptor.foreignData[index];
                            $foreignkeyfield = this.model.dataSource.adaptor.key[index];
                            $foreignkeyvalue = this.model.dataSource.adaptor.value[index];
                            selectedItems = data;
                        }
                        var arrayOfDatas, field = currColumn.field;
                        if (ej.isNullOrUndefined(ej.getObject(field, this._dropDownManager)))
                            return;
                        arrayOfDatas = ej.getObject(field, this._dropDownManager);
                        var isObj = 0 in arrayOfDatas && typeof arrayOfDatas[0] == "object";
                        var uniqueData = uniqueData = ej.dataUtil.mergeSort(ej.distinct(arrayOfDatas, isObj ? field : undefined, isObj ? false : undefined));
                        if (selectedItems.length == 0) {
                            if (ej.isNullOrUndefined(currColumn.dataSource) && (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && currColumn.field == fk_Value)) {
                                for (var index = 0; index < uniqueData.length; index++)
                                    selectedItems.push({ text: uniqueData[index][0], value: uniqueData[index][1] });
                            }
                            else {
                                for (var index = 0; index < uniqueData.length; index++)
                                    selectedItems.push({ text: uniqueData[index], value: uniqueData[index] });
                            }
                        }
                    }
                    else {
                        if (ej.isNullOrUndefined(currColumn.foreignKeyField) && currColumn.dataSource instanceof ej.DataManager) {
                            var field = currColumn.field, arrData = ej.getObject(field, this._dropDownManager);
                            var isObj = 0 in arrData && typeof arrData[0] == "object";
                            var uniqueData = uniqueData = ej.dataUtil.mergeSort(ej.distinct(arrData, isObj ? field : undefined, isObj ? false : undefined));
                            if (!ej.isNullOrUndefined(ej.getObject("editParams.fields.text", currColumn)))
                                selectedItems = arrData;
                            if (selectedItems.length == 0) {
                                for (var index = 0; index < uniqueData.length; index++) {
                                    selectedItems.push({ text: uniqueData[index], value: uniqueData[index] });
                                }
                            }
                        }
                        else if(ej.isNullOrUndefined(currColumn.foreignKeyField) || !(currColumn.field in this._dropDownManager))
                            selectedItems = currColumn.dataSource
                        else
                            selectedItems = ej.getObject(currColumn.foreignKeyField + "." + currColumn.foreignKeyValue, this._dropDownManager);
                    }
                    var dropDownTemplate;
                    var fieldName = ej.isNullOrUndefined(currColumn.foreignKeyField) ? currColumn.field : currColumn.foreignKeyField;
                    if (currColumn.foreignKeyValue)
                        dropDownTemplate = this._compiledDropDownTemplate(fieldName, currColumn.foreignKeyValue, currColumn.type, currColumn.format);
                    else if ((this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) && (currColumn.field == fk_Value)) {
                        dropDownTemplate = this._compiledDropDownTemplate($foreignkeyfield ? $foreignkeyfield : "value", $foreignkeyvalue ? $foreignkeyvalue : "text", currColumn.type, currColumn.format);
                    }
                    else {
                        var value = ej.getObject("editParams.fields.value", currColumn) || "value";
                        var text = ej.getObject("editParams.fields.text", currColumn) || "text";
                        dropDownTemplate = this._compiledDropDownTemplate(value, text, currColumn.type, currColumn.format);
                    }
                    if (!ej.isNullOrUndefined(currColumn.editParams) && ((this._dataSource() instanceof ej.DataManager && (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor)) && (currColumn.field == fk_Value)))
                        element.get(0).innerHTML = "<input data-value='{{:" + fk_fieldName + "}}'/>";
                    else
                        element.get(0).innerHTML = ["<select>", dropDownTemplate.render(selectedItems), "</select>"].join("");
                    element.find("select,input").prop({ id: this._id + fName, name: currColumn.field }).addClass("e-field e-dropdownlist");
                    break;
            }
        },
        addBatchEditTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $outerDiv = ej.buildTag('div', "", { display: "none" }, { id: this._id + "_BulkEditTemplate" }), i, columnCount, $innerDiv;
            for (i = 0, columnCount = this.model.columns.length; i < columnCount; i++) {
                if (ej.isNullOrUndefined(this.model.columns[i]["commands"]) && (ej.isNullOrUndefined(this.model.columns[i]["template"])) ||
                    (this.model.columns[i]["template"] && this.model.columns[i]["allowEditing"] != false && this.model.columns[i]["field"])) {				 
                    $innerDiv = ej.buildTag('div', "", {}, { id: this.model.columns[i].field.replace(/\./g, ej.pvt.consts.complexPropertyMerge) + "_BulkEdit" });
                    this._initCellEditType(i, $innerDiv);
                    $outerDiv.append($innerDiv);
                }
                if (this.model.columns[i]["isPrimaryKey"] === true) {
                    this._primaryKeys.push($.trim(this.model.columns[i].field));
                    this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                }
                if (this.model.columns[i]["isIdentity"] === true) {
                    $innerDiv.find(".e-field").addClass("e-identity");
                    this._identityKeys.push($.trim(this.model.columns[i].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
            }
            if ($outerDiv.children().length)
                this._bulkEditTemplate = $outerDiv;

        },
        addExternalDialogEditingTemplate: function () {
            if (this.model.columns.length == 0)
                return;
			  var  $valueTd;
			   $valueTd = ej.buildTag('td', "", { "text-align": "left" }).addClass("e-rowcell");
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount]["type"] == "checkbox" && !this._isMapSelection)
                    continue;
                if (ej.isNullOrUndefined(this.model.columns[columnCount]["commands"]) && (!ej.isNullOrUndefined(this.model.columns[columnCount]["template"]) && this.model.columns[columnCount]["allowEditing"] != false && this.model.columns[columnCount]["field"]) && !ej.isNullOrUndefined(this.model.columns[columnCount].editTemplate))
                    this._initCellEditType(columnCount, $valueTd);
                if (this.model.columns[columnCount]["isPrimaryKey"] === true) {
                    this._primaryKeys.push($.trim(this.model.columns[columnCount].field));
                    this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                }
            }
            var $tbody = ej.buildTag('div', "", { 'display': 'none' });
            var $form = ej.buildTag('form.gridform', "", {}, { id: this._id + "EditForm" });
            var cloneElement;
            if (this.model.editSettings.editMode == "dialogtemplate" && this.model.editSettings.dialogEditorTemplateID != null)
                cloneElement = this.model.editSettings.dialogEditorTemplateID;
            else if (this.model.editSettings.editMode == "externalformtemplate" && this.model.editSettings.externalFormTemplateID != null) {
                cloneElement = this.model.editSettings.externalFormTemplateID;
                $form.addClass("e-display");
            }
            else {
                cloneElement = this.model.editSettings.inlineFormTemplateID;
                $form.addClass("e-display");
            }

            $form.html($(cloneElement).html());
            $tbody = this.renderDiaglogButton($form, $tbody);
            $.templates(this._id + "_JSONdialogTemplateMode", $tbody.html());
        },
        _editdblClickHandler: function (e) {
            var $target = $(e.target);
			if ($target.closest(".e-grid").attr("id") !== this._id) return;
            if ($target.hasClass("e-rowcell") || $target.closest("td").hasClass("e-rowcell")) {
                if (!this.model.isEdit || (this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")) {
                    this._$currentTr = (this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0)
                        ? this.getRowByIndex($target.closest('tr').index())
                        : $target.closest('tr');
                    this.startEdit(this._$currentTr);
                }
            }
        },
        _columnToSelect: function () {
            var column = [], columnDrop = [], cols = this.model.columns;
            for (var i = 0; i < this.model.columns.length; i++) {
                if (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) {
                    if ($.inArray(this.model.columns[i].field, this._dataSource().adaptor.value) != -1)
                        if (ej.isNullOrUndefined(this.model.columns[i]["editType"]))
                        this.model.columns[i]["editType"] = "dropdownedit";
                }
                if (this.model.columns[i]["editType"] === ej.Grid.EditingType.Dropdown && ej.isNullOrUndefined(this.model.columns[i]["dataSource"]))
                    column.push(this.model.columns[i].field);
                if (cols[i]["editType"] === ej.Grid.EditingType.Dropdown && ej.isNullOrUndefined(cols[i].foreignKeyField) && cols[i]["dataSource"] instanceof ej.DataManager)
                    columnDrop.push(this.model.columns[i].field);
            }
            if (column.length)
                return { query: ej.Query().select(column), fields: column, fieldsDrop: columnDrop };
            return { query: ej.Query(), fields: [], fieldsDrop: columnDrop };
        },
        _renderExternalForm: function () {
            var $externalform = ej.buildTag("div", "", { display: "none" }, { id: this._id + "_externalEdit", 'class': "e-form-container" });
            var $eformHeader = ej.buildTag("div", "", "", { id: this._id + "_eFormHeader", 'class': "e-form-titlebar" });
            var $eformTitle = ej.buildTag("span", "", "", { 'class': "e-form-title" });
            var $eformToggleBtn = ej.buildTag("div", "", "", { id: this._id + "_eFormToggleBtn", 'class': "e-form-togglebtn" });
            var $eformToggleIcon = ej.buildTag("span", "", "", { 'class': "e-form-toggle-icon e-icon" });
            $eformToggleBtn.append($eformToggleIcon);
            $eformHeader.append($eformTitle).append($eformToggleBtn);

            var $eformContent = ej.buildTag("div", "", "", { id: this._id + "_eFormContent", 'class': "e-form-content" });
            var $eform = ej.buildTag("div", "", "", { id: this._id + "_externalForm", 'class': "e-externalform" });
            var $contentOuterDiv = ej.buildTag("div", "", "", { 'class': "e-externalformedit" });
            $eform.append($contentOuterDiv);
            $eformContent.append($eform);
            return $externalform.append($eformHeader).append($eformContent);;
        },
        _buttonClick: function (e) {
            if (e.type == "close") {
                if (!this.model.isEdit)
                    return;
                this.model.isEdit = false;
                this.element.ejGrid("cancelEdit");
                this.refreshToolbar();
                return;
            }
            if (e.keyCode !== undefined && e.keyCode != 13 || this.model == null)
                return true;
            if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                if (e.target.id == "EditDialog_" + this._id + "_Save") 
                    this.element.ejGrid("endEdit");
                 else if (e.target.id == "EditDialog_" + this._id + "_Cancel") {
                    this.element.ejGrid("cancelEdit");
                    $("#" + this._id + "_dialogEdit").ejDialog("close");
                }
            }
            else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                if ($(e.target).hasClass("e-form-toggle-icon")) {
                    this.element.ejGrid("cancelEdit");
                    $("#" + this._id + "_externalEdit").css("display", "none");
                }
                else {
                    if (e.target.id == "EditExternalForm_" + this._id + "_Save") {
                        if (this.element.ejGrid("endEdit").length !== undefined)
                            $("#" + this._id + "_externalEdit").css("display", "none");
                    } else if (e.target.id == "EditExternalForm_" + this._id + "_Cancel") {
                        this.element.ejGrid("cancelEdit");
                        $("#" + this._id + "_externalEdit").css("display", "none");
                    }
                }
            }
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                if (e.target.id == "InlineEditForm_" + this._id + "_Save")
                    this.element.ejGrid("endEdit");
                else if (e.target.id == "InlineEditForm_" + this._id + "_Cancel")
                    this.element.ejGrid("cancelEdit");
            }
            else
                this.element.ejGrid("cancelEdit");
        },
        _enableEditingEvents: function () {
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
                if (this.model.editSettings.allowEditing && this.model.editSettings.editMode != "batch" && this.model.editSettings.allowEditOnDblClick) 
                    this._on(this.element, ($.isFunction($.fn.doubletap) && this.model.enableTouch) ? "doubletap" : "dblclick", ".e-gridcontent", this._editdblClickHandler);
                else {
                    this._off(this.element, "dblclick", ".e-gridcontent");
                    this._off(this.element, "doubletap", ".e-gridcontent");
                }
                this._off($("#" + this._id + "_dialogEdit"), "click ", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel");
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                    this._on($("#" + this._id + "_dialogEdit"), "click ", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel", this._buttonClick);
                }
                else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                    this._on($("#" + this._id + "_externalEdit"), "click ", "#EditExternalForm_" + this._id + "_Save ,#EditExternalForm_" + this._id + "_Cancel", this._buttonClick);
                    $(this.element).on("click", ".e-form-toggle-icon", $.proxy(this._buttonClick, this));
                }
                else if (this.model.editSettings.editMode == "batch") {
                    this._on($(document), "mousedown", this._saveCellHandler);
					this._batchEnabled = true;
				}

                else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate")
                    $(this.element).on("click ", "#InlineEditForm_" + this._id + "_Save ,#InlineEditForm_" + this._id + "_Cancel", $.proxy(this._buttonClick, this));
				
				if (this.model.editSettings.editMode != "batch" && this._batchEnabled) {
                    this._off($(document), "mousedown", this._saveCellHandler);
					this._batchEnabled = false;
				}

            } else {
                this._off($("#" + this._id + "_dialogEdit"), "click", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel");
                $(this.element).off("click", ".e-icon");
                this._off($("#" + this._id + "_externalEdit"), "click", "#EditExternalForm_" + this._id + "_Save ,#EditExternalForm_" + this._id + "_Cancel");
                $(this.element).off("click", ".e-form-toggle-icon");
                $(this.element).off("click", "#InlineEditForm_" + this._id + "_Save ,#InlineEditForm_" + this._id + "_Cancel");
            }
        },
        _multiRowDelete: function () {
            var changes = {};
            changes.added = []; changes.deleted = [], changes.changed = [];
            changes.deleted = this.getSelectedRecords();
            var args = {};
			args.data = this.getSelectedRecords();
            args.tr = this.getSelectedRows();
            var foreignKeyData = this._getForeignKeyData(args.data);
            if (!ej.isNullOrUndefined(foreignKeyData))
                args.foreignKeyData = foreignKeyData;
                args.requestType = "delete";
            if (this._trigger("actionBegin", args))
                return true;
            var gridObject = this;
            this._sendBulkReuqest(changes, args);
        },
        deleteRow: function ($tr) {
            if (!this.model.editSettings.allowDeleting || (this.model.isEdit && this.model.editSettings.editMode != "batch" && !this.model.editSettings.showAddNewRow))
                return;
            if (this.model.editSettings.showDeleteConfirmDialog && !(this._confirmDialog).is(":visible")) {
                this._cDeleteData = $tr;
                this._confirmDialog.find(".e-content").html(this.localizedLabels.ConfirmDelete).end().ejDialog("open");
                return;
            }
            if ($.isArray($tr)) {
                this.selectRows($tr);
                this._multiRowDelete();
            }
            else {
                if (this.model.editSettings.editMode == "batch")
                    this._bulkDelete(this.getIndexByRow($tr));
                else {
                    if (this._primaryKeys.length == 0 && !this.model.editSettings.allowEditing && !this.model.editSettings.allowAdding) {
                        for (var i = 0; i < this.model.columns.length; i++) {
                            if (this.model.columns[i]["isPrimaryKey"] === true) {
                                this._primaryKeys.push($.trim(this.model.columns[i].field));
                                this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                            }
                        }
                    }
                    if (this._selectedRow() == -1 && ej.isNullOrUndefined($tr)) {
                        alert(this.localizedLabels.DeleteOperationAlert);
                        return;
                    }
                    if (ej.isNullOrUndefined($tr))
                        $tr = this.model.scrollSettings.enableVirtualization ? this.getContentTable().find("tr[aria-selected='true']") : this.getRowByIndex(this._selectedRow());
                    this._primaryKeyValues = [];
                    this._getPrimaryKeyValues($tr);
                    var deleteManager = ej.DataManager(this._currentJsonData);
                    var query = new ej.Query();
                    for (var i = 0; i < this._primaryKeys.length; i++)
                        query = query.where(this._primaryKeys[i], ej.FilterOperators.equal, this._primaryKeyValues[i]);
                    var currentData = deleteManager.executeLocal(query);
                    var args = {};
                    args.tr = $tr;
                    args.data = args.rowData = currentData[0];
                    var foreignKeyData = this._getForeignKeyData(args.data);
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    args.requestType = ej.Grid.Actions.Delete;
                    if (this._trigger("actionBegin", args))
                        return true;
                    this._cDeleteData = currentData;
                    var promise;
                    if (!(ej.isOnWebForms && this.model.serverEvents && this.model.serverEvents.indexOf("endDelete") != -1) && this._dataSource() instanceof ej.DataManager && (!this._dataManager.dataSource.offline && this._dataManager.dataSource.json !== undefined) || (this._dataSource().adaptor instanceof ej.remoteSaveAdaptor)) {
                        promise = this._dataManager.remove(this._primaryKeys[0], this._primaryKeys.length ? ej.getObject(this._primaryKeys[0], currentData[0]) : null, this.model.query);
                        var proxy = this;
                        if ($.isFunction(promise.promise)) {
                            promise.done(function (e) {
                                proxy._processBindings(args);
                                proxy._primaryKeyValues = [];
                                proxy._cDeleteData = null;
                            });
                            promise.fail(function (e) {
                                args.error = e
                                proxy._trigger("actionFailure", args)
                            });
                        } else
                            this._processBindings(args);
                    } else
                        this._processBindings(args);
                    if (promise == undefined || !$.isFunction(promise.promise)) {
                        this._primaryKeyValues = [];
                        this._cDeleteData = null;
                    }
                }
            }
        },
        
        _htmlEncode: function (html) {
            var str = html;
            if (!ej.isNullOrUndefined(str))
                str = isNaN(str) ? str.replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&apos;/g, '\'') : str;
            return str;
        },
        startEdit: function ($tr) {
		    if (!this.model.editSettings.allowEditing || (this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal" && this._excludeDetailRows().hasClass("e-editedrow")))
		        return;
		    if (this.element.ejWaitingPopup("model.showOnInit"))
		        return;
            if (this._selectedRow() == -1 && ej.isNullOrUndefined($tr)) {
                alert(this.localizedLabels.EditOperationAlert);
                return;
            }
            if (this.model.scrollSettings.enableVirtualization && ej.isNullOrUndefined($tr))
                $tr = this.getContentTable().find("tr[aria-selected='true']");
            if (ej.isNullOrUndefined($tr)) {
                this._currentTrIndex = this._selectedRow();
                this._$currentTr = this.getRowByIndex(this._currentTrIndex);
            } else {
                this._currentTrIndex = this.getIndexByRow($tr);
                this._$currentTr = $tr;
            }
            if (!$(this._$currentTr).is(":visible"))
                return false;
            this._primaryKeyValues = [];
            this._getPrimaryKeyValues(this._$currentTr);
            var editedData = this._editedData = this._currentJsonData[this._currentTrIndex];
            var args = { row: this._$currentTr, rowIndex: this._currentTrIndex, primaryKey: this._primaryKeys, primaryKeyValue: this._primaryKeyValues, rowData: editedData };
            var cancel = this._trigger("beginEdit", args);
            if (cancel) {
                this._primaryKeyValues = [];
                return;
            }
            args.requestType = ej.Grid.Actions.BeginEdit;
            this._processBindings(args);

        },
        _getPrimaryKeyValues: function ($tr) {
            var trIndex, pkVal, nameAttr = $tr.attr("name"), column, virtualIndex, lastPageVal, isLastPage = false;
            this._lastVirtualPage = null;
            for (var index = 0; index < this._primaryKeys.length; index++) {
                column = this.getColumnByField(this._primaryKeys[index]);
                trIndex = this.getIndexByRow($tr);
                pkVal = this._currentJsonData;
                if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling) {
                    if (!this.model.scrollSettings.enableVirtualization) {
                        trIndex = trIndex % this.model.pageSettings.pageSize;
                        virtualIndex = parseFloat(nameAttr) / this.model.pageSettings.pageSize + 1;
                        this._currentJsonData = this._virtualLoadedRecords[virtualIndex];
                        if (virtualIndex == this.model.pageSettings.totalPages && !this._prevPageRendered && this._virtualLoadedRecords[virtualIndex].length != this.model.pageSettings.pageSize) {
                            pkVal = $.extend(true, [], this._previousPageRecords);
                            lastPageVal = $.extend(true, [], this._virtualLoadedRecords[virtualIndex]);
                            ej.merge(pkVal, lastPageVal);
                            this._lastVirtualPage = this._currentJsonData = $.extend(true, [], pkVal);
                            isLastPage = true;
                        }

                    }
                    else {
                        trIndex = trIndex % this._virtualRowCount;
                        virtualIndex = parseInt(nameAttr, 32);
                    }
                    pkVal = isLastPage ? pkVal : this._virtualLoadedRecords[virtualIndex];
                    this._vCurrentTrIndex = trIndex;
                    this._currentVIndex = virtualIndex;
                }
                this._primaryKeyValues.push(this._htmlEncode(ej.getObject(column.field, pkVal[trIndex])));
            }
        },
         _startAdd: function() {
            if (!this.model.editSettings.allowAdding)
                return;
			this._isAddNew = true;
            if (this.model.editSettings.editMode == "batch")
                this._bulkAddRow();
            else {
                var cloneData = {}, cols = this.model.columns;
                for (var i = 0; i < cols.length; i++) {
                    if (!ej.isNullOrUndefined(this.model.parentDetails) && cols[i].field == this.model.parentDetails.parentKeyField)
                        cols[i].defaultValue = this.model.parentDetails.parentKeyFieldValue;
                    if (!ej.isNullOrUndefined(cols[i].field) && cols[i].field.indexOf(".") > 0)
                        ej.createObject(cols[i].field, cols[i].defaultValue || "", cloneData);
                    else
                        cloneData[cols[i].field] = !ej.isNullOrUndefined(cols[i].defaultValue) ? cols[i].defaultValue : (cols[i].type == "date" || cols[i].type == "datetime") ? null : "";
                }
                var args = {}, complexObject = {};
                args.data = args.rowData = cloneData;
                if (this.model.editSettings.editMode.indexOf('template') != -1) {
                    for (var i = 0; i < this.model.columns.length; i++) {
                        if (!ej.isNullOrUndefined(this.model.columns[i].field) && this.model.columns[i].field.indexOf(".") != -1) {
                            var splits = this.model.columns[i].field.split('.');
                            ej.createObject(this.model.columns[i].field, args.data[this.model.columns[i].field], complexObject);
                            args.data[splits[0]] = complexObject;
                            delete args.data[this.model.columns[i].field];
                        }
                    }
                }
                var foreignKeyData = this._getForeignKeyData(args.data);
                if (!ej.isNullOrUndefined(foreignKeyData))
                    args.foreignKeyData = foreignKeyData;
                args.requestType = "add";
                this.clearSelection();
				if(this.model.selectionSettings.selectionMode.indexOf('cell') != -1)
					this.clearCellSelection();
                if (this.model.scrollSettings.allowVirtualScrolling) {
                    this._currentVIndex = null;
                    this._lastVirtualPage = null;
                    if (this.model.scrollSettings.enableVirtualization)
                        this._refreshVirtualView(1);
                    else
                        !this._virtualLoadedRecords[1] ? this.gotoPage(1) : this._currentPage(1);
                    this.getScrollObject().scrollY(0);
                }
                var returnValue = this._processBindings(args);
                if (!returnValue)
                    this.model.editSettings.showAddNewRow ? this._selectedRow(-1) : this._selectedRow(0);
                var groupedColumns = this.model.groupSettings.groupedColumns.length;
                if (groupedColumns > 1) {
                    var $editCol = this.getContentTable().find(".e-addedrow").find("table").find("colgroup").children();
                    $($editCol.slice(0, groupedColumns - 1)).css('width', this.getHeaderTable().find('colgroup').children()[0].style.width);
                }
            }
        },
        
        endEdit: function () {
            if (this.model.isEdit) {
                var formElement, $formElement, editedTr, count = 0;
                if (!this.editFormValidate())
                    return true;
                var obj = {};
                var editedRowWrap, type;
                if (this.model.editSettings.editMode == "batch")
                    this.saveCell();
                else {
					if(this._isAddNew|| this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineformtemplate" ||this.model.editSettings.editMode == "dialogtemplate" )
						this._isEditChangesApplied = true
					if(this.model.editSettings.showAddNewRow)
						editedTr = this.getContentTable().find(".e-editedrow");
                    formElement = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr[0].lastChild.lastChild: document.getElementById(this._id + "EditForm");
                    $formElement = $(formElement);
                    if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate")
                        editedRowWrap = $formElement.closest('tr');
                    else
                        editedRowWrap = $formElement.closest('div');
                    editedRowWrap.find('td.e-rowcell').removeClass('e-validError');
                    formElement = this.model.scrollSettings.frozenColumns > 0 ? formElement[0] : formElement;
                    for (var index = 0; index < formElement.length; index++) {
                        if (editedRowWrap.hasClass("e-addedrow") && $(formElement[index]).hasClass("e-identity"))
                            continue;
                        var columnName = formElement[index].name, $element = $(formElement[index]), column = this.getColumnByField(columnName);
                        if ($element.hasClass("e-dropdownlist e-input") && $element.attr("id").indexOf("_input") != -1 && ej.isNullOrUndefined($formElement[1]))
                            continue;
                        if (columnName != undefined) {
                            if (columnName != "" && obj[columnName] == null) {
                                column = this.getColumnByField(columnName);
                                var  value = formElement[index].value, checkType = formElement[index].type, checkState = $(formElement[index]).is(':checked'),
                                    type = column ? column.originalType : null,colFormat;
                                if ($(formElement[index]).attr("type") == "hidden" && ej.isNullOrUndefined($element.attr("value")))
                                    continue;
                                if (!ej.isNullOrUndefined(column) && (column.editType == "edittemplate")) {
									this._isEditChangesApplied = true;
                                    var isHidden = $(formElement[index]).attr("type") == "hidden";
                                    if ($(formElement[index]).is("#" + this._id + columnName) || isHidden) {
                                        var temp1 = column.editTemplate.read; $element = $(formElement[index]);
                                        $element = isHidden ? $(formElement[index]).siblings("#" + this._id + columnName).length ? $(formElement[index]).siblings("#" + this._id + columnName) : $element : $element;
                                        if (typeof temp1 == "string")
                                            temp1 = ej.util.getObject(temp1, window);
                                        value = temp1($element);
                                       }
                                    else
                                        continue;
                                }
                                else if ($(formElement[index]).hasClass("e-datepicker")) {
                                    value = $element.ejDatePicker("model.value");
                                    if (!this._isEditChangesApplied) {
                                        colFormat = !ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.format) ? column.format : "{0:MM/dd/yyyy}";
                                        if (this.formatting(colFormat, value, this.model.locale) != this.formatting(colFormat, this._editedData[columnName], this.model.locale))
                                            this._isEditChangesApplied = true;
                                    }
                                }
                                else if ($(formElement[index]).hasClass("e-datetimepicker")) {
                                    value = $element.ejDateTimePicker("model.value");
                                    if (!this._isEditChangesApplied) {
                                        colFormat = !ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.format) ? column.format : "{0:MM/dd/yyyy hh:mm:ss}";
                                        if (this.formatting(colFormat, value, this.model.locale) != this.formatting(colFormat, this._editedData[columnName], this.model.locale))
                                            this._isEditChangesApplied = true;
                                    }
                                }
                                else if ($element.is(".e-numerictextbox")) {
                                    value = $element.ejNumericTextbox("getValue");
                                    if (!ej.isNullOrUndefined(column) && column.type == "string" && !ej.isNullOrUndefined(value))
                                        value = value.toString();
                                    if (!this._isEditChangesApplied && this._editedData[columnName] != value)
                                        this._isEditChangesApplied = true;
								}
                                else if ($element.data("ejDropDownList") || $element.is(".e-dropdownlist")) {
                                    if ($element.is(":hidden") && $element.is("input") && ej.isNullOrUndefined($element.data("ejDropDownList")))
                                        $element = $element.siblings(".e-dropdownlist");
                                    value = $element.ejDropDownList("getSelectedValue");
                                    if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.format) && (column.type == "date" || column.type == "datetime"))
                                        value = value.length > 0 ? new Date(value) : value;
                                    if (!this._isEditChangesApplied && this._editedData[columnName] != value)
                                        this._isEditChangesApplied = true;
                                
								}
                                if (type)
                                    value = type == "number" ? +value : type == "boolean" ? (value === this.localizedLabels.True ? true : false) : type === "date" ? new Date(value) : value;
                                if (column == null)
                                    value = !isNaN(parseFloat(value)) && isFinite(value) ? parseFloat(value) : value;
                                else if (column.type == "number" && !ej.isNullOrUndefined(value) && value.length) {
                                    value = ej.parseFloat(value, this.model.locale);
                                    if (!this._isEditChangesApplied && this._editedData[columnName] != value)
                                        this._isEditChangesApplied = true;
                                }
                                if (typeof value == "string" && !value.length)
                                    value = null;
                                if (!this._isEditChangesApplied && (!ej.isNullOrUndefined(column)&& column.type=="string")  && this._editedData[columnName] != value)
                                    this._isEditChangesApplied = true;
                                 if(!this._isEditChangesApplied && (!ej.isNullOrUndefined(column)&& column.type=="date" && column.editType == 'stringedit')){	
                                     if (column.format != null && this.formatting(column.format, this._editedData[columnName], this.model.locale) != value)
											this._isEditChangesApplied = true;
								}
								if ((checkType != "checkbox" && !ej.isNullOrUndefined(value) && value !== "") || checkState)
                                    count++;
                                var originalvalue;
                                if (checkType != "checkbox" || (!ej.isNullOrUndefined(column) && column.type!="boolean" ) )
                                    originalvalue = value;
                            	else
                                    originalvalue = checkState;
                                if ( !this._isEditChangesApplied && (!ej.isNullOrUndefined(column) && column.type == "boolean" )){
									  var colValue =  checkType == "checkbox" ?checkState :  JSON.parse(value);
									  if( this._editedData[columnName] != colValue)
										this._isEditChangesApplied = true;
                                }
                                if (!this._isEditChangesApplied && typeof originalvalue == "string" && typeof this._editedData[columnName] == "string" && this._editedData[columnName] != originalvalue)
                                    this._isEditChangesApplied = true;
                            if (columnName.indexOf(".") != -1)
                                ej.createObject(columnName, originalvalue, obj);
                            else
                                obj[columnName] = originalvalue;
                            }
                        }
                        if (index == formElement.length - 1 && $formElement.length > 1 && $formElement.index(formElement) == 0) {
                            formElement = $formElement[1];
                            index = -1;
                        }

                    }
                    var args = { data: obj, rowData: obj };
                    var foreignKeyData = this._getForeignKeyData(args.data);
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    args.requestType = ej.Grid.Actions.Save;
                    args.selectedRow = this._selectedRow();
                    args.previousData = jQuery.extend({}, this.model.currentViewData[args.selectedRow]);
                    var currentData;
                    if (this._trigger("actionBegin", args))
                        return true;
                    if (editedRowWrap.hasClass("e-editedrow")) {
                        this._cModifiedData = obj;
                        args.action = "edit";
                    } else if (editedRowWrap.hasClass("e-addedrow")) {
                        if (count)
                            this._cAddedRecord = obj;
                        args.action = "add";
                    }
                    if (args.action == "add" && this.editFormValidate()) {
                        if (!ej.isNullOrUndefined(this.model.queryString)) {
                            var keyField = this.model.foreignKeyField || this.model.queryString;
                            args.data[keyField] = this.model.parentDetails.parentRowData[this.model.queryString]
                        }
                        if (!count) {
                            var elements = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
                            var error = ej.buildTag("div");
                            elements.addClass("field-validation-empty");
                            var element = elements.find("input:visible").not(".e-identity").first();
                            this._renderValidator(error, element);
                            error.width("auto");
                            var $errorMessage = ej.buildTag("div.e-field-validation-error", this.localizedLabels.EmptyRowValidationMessage),
                            $tail = $(error).find(".e-errortail");
                            $errorMessage.insertAfter($tail);
                            $errorMessage.css("display", "block");
                            return false;
                        }
                    }
                    if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                        $("#" + this._id + "_externalEdit").css("display", "none");
                    if (!this._isAddNew && !this._isEditChangesApplied)
                        this.cancelEdit();
                    else {
                        this._isEditChangesApplied = false;
                        this._updateAction(args);
                    }
                }
            }
        },
        _updateAction: function (args) {
            var promise;
            if (this._dataSource() instanceof ej.DataManager && (!this._dataManager.dataSource.offline && this._dataManager.dataSource.json !== undefined) || (this._dataSource().adaptor instanceof ej.remoteSaveAdaptor) || this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) {
                if (this.model.editSettings.editMode == 'batch') {
                    this.batchChanges.added.push(args.data);
                    this.batchSave();
                }
                else {
                    if (!ej.isNullOrUndefined(this._cModifiedData) && !(ej.isOnWebForms && this.model.serverEvents && this.model.serverEvents.indexOf("endEdit") != -1))
                        promise = this._dataManager.update(this._primaryKeys[0], args.data, this.model.query);
                    else if (!(ej.isOnWebForms && this.model.serverEvents && this.model.serverEvents.indexOf("endAdd") != -1))
                        promise = this._dataManager.insert(args.data, this.model.query);
                    var proxy = this;
                    this.element.ejWaitingPopup("show");
                    if (promise && $.isFunction(promise.promise)) {
                        promise.done(function (e) {
                            proxy.model.isEdit = false;
                            if (!ej.isNullOrUndefined(e) && $.isPlainObject(e.record)) {
                                $.extend(args.data, e.record);
                                if (args.action == "add")
                                    proxy._cAddedRecord = args.data;
                                if (args.action == "edit")
                                    proxy._cModifiedData = args.data;
                            }
                            proxy._processBindings(args);
                            if (proxy._isRemoteSaveAdaptor) {
                                proxy.element.ejWaitingPopup("hide");
                                if (!ej.isNullOrUndefined(proxy._unboundRow) && args.selectedRow != proxy._unboundRow && args.requestType == "save") {
                                    proxy._unboundRow.find(".e-editbutton").trigger("click");
                                    proxy._unboundRow = null;
                                }
                            }
                            proxy._cModifiedData = null;
                            proxy._cAddedRecord = null;
                            proxy._primaryKeyValues = [];
                        });
                        promise.fail(function (e) {
                            args.error = (e && e.error) ? e.error : e;
                            proxy._cModifiedData = null;
                            proxy._cAddedRecord = null;
                            proxy.element.ejWaitingPopup("hide");
                            proxy._trigger("actionFailure", args)
                        });
                    } else {
                        proxy.model.isEdit = false;
                        proxy._processBindings(args);
                    }
                }
            } else
                this._processBindings(args);
            if (promise == undefined || !$.isFunction(promise.promise)) {
                this._cModifiedData = null;
                this._cAddedRecord = null;
                this._primaryKeyValues = [];
            }
        },
        
        cancelEdit: function () {
            var args = {};
            args.requestType = ej.Grid.Actions.Cancel;
            this._cModifiedData = null;
            this._processBindings(args);
            this._primaryKeyValues = [];
            this._currentData = null;
            if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                $("#" + this._id + "_externalEdit").css("display", "none");
        },
        
        refreshToolbar: function () {
            var $toolbar = $("#" + this._id + "_toolbarItems");
            var lis = $toolbar.find("li");
            $toolbar.ejToolbar("enableItem", lis);
			var editedTr = this.getContentTable().find(".e-editedrow");
			if(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal" && editedTr.length==0)
				this._disabledToolItems.push(lis.filter('[id='+this._id+'_add]'));
			else
			{
			    for (var i = 0; i < lis.length; i++) {
			        switch (lis[i].id) {
			            case this._id + "_add":
			            case this._id + "_edit":
			            case this._id + "_delete":
			            case this._id + "_responsiveFilter":
			            case this._id + "_responsiveSorting":
			            case this._id + "_search":
			                if (this.model.isEdit) {
			                    if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal") || editedTr.length != 0) {
			                        $(lis[i]).hasClass("e-hover") && $(lis[i]).removeClass("e-hover");
			                        this._disabledToolItems.push(lis[i]);
			                    }
			                }
			                else if (!this.model.enableToolbarItems && !this.model.editSettings.allowAdding && lis[i].id == this._id + "_add")
			                        this._disabledToolItems.push(lis[i]);
                            else if (!this.model.enableToolbarItems && !this.model.editSettings.allowEditing && lis[i].id == this._id + "_edit")
                                    this._disabledToolItems.push(lis[i]);
                            else if (!this.model.enableToolbarItems && !this.model.editSettings.allowDeleting && lis[i].id == this._id + "_delete")
                                    this._disabledToolItems.push(lis[i]);
			                break;
			            case this._id + "_update":
			            case this._id + "_cancel":
			                if (!this.model.isEdit && (this.getContentTable().find(".e-updatedtd.e-icon.e-gupdatenotify").length == 0 && !this._isBatchDeleteApplied)) {
			                    $(lis[i]).hasClass("e-hover") && $(lis[i]).removeClass("e-hover");
			                    this._disabledToolItems.push(lis[i]);
			                }
			                break;
			        }
			    }
			}
            $toolbar.ejToolbar("disableItem", this._disabledToolItems);
            $toolbar.ejToolbar("model.enableRTL", this.model.enableRTL);
            this._disabledToolItems = $();

        },
        _getHiddenCount: function (elements) {
            var count = 0;
            for (var i = 0; i < elements.length; i++) {
                if (elements.eq(i).hasClass("e-hide"))
                    count++;
            }
            return count;
        },
        _refreshTemplateCell: function (temp, data) {
            var tempcell = temp.find('.e-templatecell');
			for(var i =0; i< tempcell.length;i++){						
				var args = { cell: tempcell[i], data: data, column: this.model.columns[$(tempcell[i]).index()], rowIndex: temp.index()};
				this._trigger("templateRefresh", args);	
			}			
        },
        _edit: function (args) {
            var editingManager = this.model.scrollSettings.enableVirtualization ? ej.DataManager(this._virtualLoadedRecords[this._currentVIndex]) : ej.DataManager(this._currentJsonData), $tempFirstTR;
            var queryManager = new ej.Query();
            if (this.model.allowFiltering)
                this._previousFilterCount = this._filteredRecordsCount;
            for (var index = 0; index < this._primaryKeys.length; index++)
                queryManager = queryManager.where(this._primaryKeys[index], ej.FilterOperators.equal, this._primaryKeyValues[index]);
            this._currentData = editingManager.executeLocal(queryManager);
            var temp = document.createElement('div');
            var formTitle = !ej.isNullOrUndefined(this.model.editSettings.titleColumn) ? this.model.editSettings.titleColumn : this._primaryKeys[0];
            var $temp = $(temp), $tempSecondTR, $tempFirstTR;
            if (this.model.editSettings.editMode == "normal") {
                temp.innerHTML = ['<table>', $.render[this._id + "_JSONEditingTemplate"](this._currentData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
                var $tr = $temp.find("tr").first(), detailCount = 0, firstHidden = this.model.columns.length
                , $currentTrFr = args.row.first(), $currentTrLa, $tempLastTR;
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $temp.prepend(['<table>', $.render[this._id + "_JSONFrozenEditingTemplate"](this._currentData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join(""));
                    $tr.splice(0, 0, $temp.find("table").first().find("tr").first().get(0));
                    $currentTrLa = args.row.last();
                    $tempLastTR = $tr.last();
                }
                $tempFirstTR = $temp.find("tr").first();
                $temp.find('td').not(".e-rowcell").addClass("e-editcell e-normaledit");
                this._setEditDropdownValue($temp);
                if (this.model.groupSettings.groupedColumns.length >= 2) {
                    var $indentCell = args.row.find("td.e-indentcell");
                    $temp.find("tr").first().prepend($indentCell);
                }
                if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                    detailCount++;                    
                    $temp.find(".e-editcell").find("tr").prepend(args.row.find("[class*=e-detailrow]").eq(0).removeClass("e-selectionbackground e-active"));
                    if (this.model.gridLines != "both")
                        $temp.find(".e-editcell .e-rowcell:first").addClass("e-detailrowvisible");
                }
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $temp.find(".e-editcell").get(1).colSpan = this.model.columns.length - this.model.scrollSettings.frozenColumns - args.row.last().find(".e-hide").length + detailCount;
                    firstHidden = this.model.scrollSettings.frozenColumns;
                    $currentTrLa.hasClass("e-alt_row") && $tempLastTR.addClass("e-alt_row")
                }
                $temp.find(".e-editcell").get(0).colSpan = firstHidden - $currentTrFr.find("td").not(":visible").length + detailCount;
                $currentTrFr.hasClass("e-alt_row") && $tempFirstTR.addClass("e-alt_row");                
                $currentTrFr.empty().replaceWith($tempFirstTR.addClass("e-editedrow"));
                args.row = $tempFirstTR;
                if (!$tempFirstTR.is(":last-child"))
                    $tempFirstTR.find('td.e-rowcell').addClass('e-validError');
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $currentTrLa.empty().replaceWith($tempLastTR.addClass("e-editedrow"));
                    args.row = $tempLastTR;
                }
                this._refreshUnboundTemplate($tr.find(".gridform"));
                if(this.model.scrollSettings.frozenColumns == 0)
					this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row, tr.e-editedrow").toArray();
				else
					this._gridRows = $(this.getContentTable().get(0).rows).toArray();                 
                if (this.model.scrollSettings.frozenColumns > 0) {
					this.getScrollObject().scrollY(this.getScrollObject().model.scrollTop, true);
                    this._gridRows = [this._gridRows, $(this.getContentTable().get(1).rows).toArray()];
				}
            }
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                var detailCount = 0;
                temp.innerHTML = this.model.editSettings.editMode == "inlineform" ? $.render[this._id + "_JSONDialogEditingTemplate"](this._currentData) : this._renderEjTemplate(this.model.editSettings.inlineFormTemplateID, this._currentData, args.rowIndex);
                if (this.model.editSettings.editMode == "inlineformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
				this._setEditDropdownValue($temp);
                var tr = ej.buildTag('tr');
                var td = ej.buildTag('td');
                tr.addClass("e-editedrow");
                td.addClass("e-inlineformedit");
                temp = $(temp).clone(true).children();
                td.html(temp);
                tr.append(td);
                if (!tr.is(":last-child"))
                    tr.find('.e-rowcell').addClass('e-validError');
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var $trClone = tr.clone();
                    $trClone.find("td").empty().prop("colspan", this.model.scrollSettings.frozenColumns);
                    args.row.eq(1).after(tr).end().eq(0).after($trClone);
                    this._gridRows = [this._gridRows, this.getContentTable().last().find("tr").toArray()];
                }
                else
                    args.row.after(tr);
                this._gridRows = this.getContentTable().first().find(".e-rowcell,.e-inlineformedit").closest("tr").toArray();
				if (this.model.detailsTemplate != null || this.model.childGrid != null)
                        detailCount++;
                if (this.model.scrollSettings.frozenColumns > 0)
                    td.prop("colspan", this.model.columns.length - this.model.scrollSettings.frozenColumns - tr.find("form").children().not(":visible").length + detailCount);
                else
                    td.prop("colspan", this.model.columns.length - this._hiddenColumns.length + detailCount);
                if (this.model.scrollSettings.frozenColumns > 0)
                    this._gridRows = [this._gridRows, this.getContentTable().last().find("tr").toArray()];
                $("#" + this._id + "_inlineFormTitle").text(this.localizedLabels.EditFormTitle + this._currentData[0][formTitle]);
                args.row.find("input").attr('disabled', 'disabled').addClass("e-disable");
            }
            else {
                $temp.addClass("e-editedrow");
                var templateID;
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate")
                    templateID = this.model.editSettings.editMode == "dialogtemplate" ? this.model.editSettings.dialogEditorTemplateID : this.model.editSettings.externalFormTemplateID;
                temp.innerHTML = this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "externalform" ? $.render[this._id + "_JSONDialogEditingTemplate"](this._currentData) : this._renderEjTemplate(templateID, this._currentData, args.rowIndex);
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
                this._setEditDropdownValue($temp);
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                    $("#" + this._id + "_dialogEdit").html($(temp));
                    var model = {};
                    model.cssClass = this.model.cssClass;
                    model.enableRTL = this.model.enableRTL;
                    model.width = "auto";
                    model.enableResize = this.phoneMode;
                    model.close = $.proxy(this._buttonClick, this);
                    model.content = "#" + this._id;
                    model.enableModal = true;
                    model.allowKeyboardNavigation = false;
                    model.title = this.localizedLabels.EditFormTitle + this._currentData[0][formTitle];
                    $("#" + this._id + "_dialogEdit").ejDialog(model);
                    $("#" + this._id + "_dialogEdit").ejDialog("open");
                }
                else {
                    $("#" + this._id + "_externalEdit").css("display", "block").css('z-index', this._maxZindex() + 1);
                    $("#" + this._id + "_externalForm").find(".e-externalformedit").html($(temp));
                    $("#" + this._id + "_eFormHeader").find(".e-form-title").text(this.localizedLabels.EditFormTitle + this._currentData[0][formTitle]);
                    this._externalFormPosition();
                    args.row.find("input").attr('disabled', 'disabled').addClass("e-disable");
                }
            }
            if (this.model.editSettings.editMode != "normal")
                $tempFirstTR = $(temp);
			if(!ej.isNullOrUndefined(this.model.templateRefresh) && $tempFirstTR.find(".e-templatecell").length != 0) 
				this._refreshTemplateCell($tempFirstTR, this.model.currentViewData[$tempFirstTR.index()]);
        },
        _appendForm: function (temp) {
            var $form = ej.buildTag('form.gridform', "", {}, { id: this._id + "EditForm" });
            $form.addClass("e-display");
            var $tbody = ej.buildTag('div', "", { 'display': 'none' });
            $form.html(temp);
            $tbody = this.renderDiaglogButton($form, $tbody);
            return $tbody.html();
        },
        _setEditDropdownValue: function ($temp) {
            var $select = $temp.find("select.e-field"), x, inputDrop = $temp.find("input.e-field.e-dropdownlist");
            for (var i = 0; i < $select.length; i++) {
                var ddlTemplate = {}, opPara = "";
                if ($select[i].name.indexOf('.') != -1) {
                    for (var j = 1; j < $select[i].name.split(".").length; j++)
                        opPara = opPara.concat("(");
                    ddlTemplate[this._id + "ddlTemp"] = "{{:" + opPara + "#data['" + $select[i].name.split('.').join("'] || {})['") + "']}}";
                }
                else
                    ddlTemplate[this._id + "ddlTemp"] = "{{:" + $select[i].name.replace(/[^a-z0-9\s_]/gi, '') + "}}"
                $.templates(ddlTemplate);
                x = $.render[this._id + "ddlTemp"](this._currentData);
                var $selOptions = $temp.find('select:eq(' + i + ') option[value="' + x + '"]');
                $select.eq(i).data("ej-value", x);
                var curColumn = this.getColumnByField($select[i].name);
                if (this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && this._dataSource().adaptor.value.indexOf(curColumn.field) != -1){
				    $selOptions = $temp.find('select:eq(' + i + ') option:contains("' + x + '")');
				    $select.eq(i).val($selOptions[0].value);
				    $select.eq(i).data("ej-value", $selOptions[0].value);
				}
                $selOptions.attr("selected", "selected");
            }
            for (var j = 0; j < inputDrop.length; j++) {
                inputDrop.eq(j).data("ej-value", ej.getObject(inputDrop.eq(j).attr("name"), this._currentData[0]));
            }
        },
        _add: function (args) {
            var temp = document.createElement('div'), $editTr;
            if (this._isLocalData && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0)
                !(this._dataSource() instanceof ej.DataManager) ? this._dataSource().splice(0, 1) : this._dataSource().dataSource.json.splice(0, 1);
            this._previousFilterCount = this._filteredRecordsCount;
            if (this.model.editSettings.editMode == "normal") {
                var $tempFirstTR, $temp = $(temp), frozenColSpan = this.model.columns.length, $tempLastTR;
                temp.innerHTML = ['<table>', $.render[this._id + "_JSONEditingTemplate"](args.data, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
                var $select = $(temp).find('select.e-field');
                for (var i = 0; i < $select.length; i++) {
                    $select.eq(i).val(args.data[$select[i].name]);
                    $select.eq(i).data('ej-value', args.data[$select[i].name]);
                }
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $tempLastTR = $temp.find("table").first().find("tr").first();
                    $temp.prepend(['<table>', $.render[this._id + "_JSONFrozenEditingTemplate"](args.data, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join(""));
					$($tempLastTR).find("td").first().addClass("e-editcell");
                }
                $tempFirstTR = $temp.find("tr").first();
                var td = $(temp).find(".e-editcell").get(0);
                $(temp).find('td').first().addClass("e-editcell");
                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this._currentJsonData.length && this.model.groupSettings.groupedColumns.length == 0 && !this.model.editSettings.showAddNewRow)
                    this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $(this.getContentTable().get(0).lastChild.lastChild).children('.e-detailrowexpand').length)
                    this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                if ((this.model.currentViewData.length == 0 || this.getContentTable().find('td.e-rowcell').length == 0) && this.model.scrollSettings.frozenColumns == 0) {
                    this.getContentTable().find('tr').first().replaceWith($(temp).find("tr").first().addClass("e-addedrow e-normaledit"));
					if(this.getContentTable().find('tr').length == 0) 
						this.getContentTable().append($(temp).find("tr").first().addClass("e-addedrow e-normaledit"));
				}
                else {
                    if (this.model.scrollSettings.frozenColumns > 0)
                        this._renderByFrozenDesign();
					var  $contentTbody = this.getContentTable().first().find('tbody').first();
                    if (this.model.editSettings.rowPosition == "top")
                        $contentTbody.prepend($tempFirstTR.addClass("e-addedrow e-normaledit"));
                    else if (this.model.editSettings.rowPosition == "bottom")
                        $contentTbody.append($tempFirstTR.addClass("e-addedrow e-normaledit"));
                    if (this.model.scrollSettings.frozenColumns > 0)
                        this.getContentTable().last().find('tbody').first().prepend($tempLastTR.addClass("e-addedrow e-normaledit"));
                }
                $editTr = this.getContentTable().find("tr.e-addedrow");
                if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling)
                    $editTr.attr("name", 0);
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $editTr.find('tr').first().prepend(ej.buildTag('td.e-detailrowcollapse'));
                if (this.model.groupSettings.groupedColumns.length) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                        if (i == 0)
                            $editTr.prepend(ej.buildTag("td.e-indentcell"));
                        else {
                            $editTr.find("tr").prepend(ej.buildTag("td.e-indentcell"));
                        }
                    }
                    if (this.model.groupSettings.groupedColumns.length > 0 && (this.model.detailsTemplate != null || this.model.childGrid != null))
                        $editTr.find("td.e-editcell").prop("colspan", (this.model.columns.length + (this.model.groupSettings.groupedColumns.length) - this._hiddenColumns.length));
                    else if (this.model.groupSettings.groupedColumns.length >= 2)
                        $editTr.find("td.e-editcell").prop("colspan", (this.model.columns.length + (this.model.groupSettings.groupedColumns.length - 1) - this._hiddenColumns.length));
                    else
                        $editTr.find("td.e-editcell").prop("colspan", (this.model.columns.length - this._hiddenColumns.length));
                } else if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $editTr.find(".e-editcell").prop("colspan", (this.model.columns.length - this._hiddenColumns.length + 1));
                else {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $editTr.find(".e-editcell").last().prop("colspan", (this.model.columns.length - this.model.scrollSettings.frozenColumns - this._hiddenColumns.length));
                        frozenColSpan = this.model.scrollSettings.frozenColumns;
                    }
                    $editTr.find(".e-editcell").first().prop("colspan", (frozenColSpan - this._hiddenColumns.length));

                }
                if (!$editTr.is(":last-child"))
                    $editTr.find('td.e-rowcell').addClass('e-validError');
                if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "msie" && this.model.editSettings.rowPosition == "bottom")
					this._colgroupRefresh();
                this._refreshUnboundTemplate($editTr.find(".gridform"));
                this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                if (this.model.scrollSettings.frozenColumns > 0)
                    this._gridRows = [this._gridRows, this.getContentTable().last().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray()];
            }
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                temp.innerHTML = this.model.editSettings.editMode == "inlineform" ? $.render[this._id + "_JSONDialogEditingTemplate"](args.data) : this._renderEjTemplate(this.model.editSettings.inlineFormTemplateID, args.data, 0);
                if (this.model.editSettings.editMode == "inlineformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
                var detailCount = 0;
                var tr = ej.buildTag('tr');
                var td = ej.buildTag('td');
                tr.addClass("e-addedrow");
                td.addClass("e-inlineformedit e-editcell");
                temp = $(temp).clone(true).children();
				var $select = $(temp).find('select.e-field');
                for (var i = 0; i < $select.length; i++){
                    $select.eq(i).val(args.data[$select[i].name]);
                    $select.eq(i).data('ej-value', args.data[$select[i].name]);
                    }
                td.html(temp);
                tr.append(td);
                if (!tr.is(":last-child"))
                    tr.find('.e-rowcell').addClass('e-validError');
                if (this.model.groupSettings.groupedColumns.length) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                        tr.prepend(ej.buildTag("td.e-indentcell"));
                    }
                } else
                    tr.find("td.e-editcell").prop("colspan", (this.model.columns.length - this._hiddenColumns.length));
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var $trClone = tr.clone(), $divs = td.find(".gridform").children();
                    $trClone.find("td").empty().prop("colSpan", this.model.scrollSettings.frozenColumns - this._getHiddenCount($divs.slice(0, this.model.scrollSettings.frozenColumns)));
                    td.prop("colSpan", this.model.columns.length - this.model.scrollSettings.frozenColumns - this._getHiddenCount($divs.slice(this.model.scrollSettings.frozenColumns)));
                    if (this.model.currentViewData.length == 0 || this.getContentTable().find('td.e-rowcell').length == 0)
                        this._renderByFrozenDesign();
                    this.getContentTable().first().find('tbody').first().prepend($trClone);
                    this.getContentTable().last().find('tbody').first().prepend(tr);
                }
                else {
					if (this.model.detailsTemplate != null || this.model.childGrid != null)
                        detailCount++;
                    td.prop("colspan", this.model.columns.length - this._hiddenColumns.length + detailCount);
                    if (this.model.currentViewData.length == 0 || this.getContentTable().find('td.e-rowcell').length == 0)
                        this.getContentTable().find('tr').first().replaceWith($(tr));
                    else
                        if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && this.model.groupSettings.groupedColumns.length == 0)
                            this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                    if (this.model.editSettings.rowPosition == "top")
                        this.getContentTable().first().find('tbody').first().prepend(tr);
                    else if (this.model.editSettings.rowPosition == "bottom")
                        this.getContentTable().first().find('tbody').first().append(tr);
                }
                
                if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $(this.getContentTable().get(0).lastChild.lastChild).children('.e-detailrowexpand').length)
                    this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                $("#" + this._id + "_inlineFormTitle").text(this.localizedLabels.AddFormTitle);
                this._refreshUnboundTemplate($("#" + this._id + "EditForm"));
                this._gridRows = this.getContentTable().first().find(".e-rowcell,.e-inlineformedit").closest("tr.e-row, tr.e-alt_row").toArray();
                if (this.model.scrollSettings.frozenColumns > 0)
                    this._gridRows = [this._gridRows, this.getContentTable().last().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray()];
            }
            else {
                $(temp).addClass("e-addedrow");
                var templateID;
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate")
                    templateID = this.model.editSettings.editMode == "dialogtemplate" ? this.model.editSettings.dialogEditorTemplateID : this.model.editSettings.externalFormTemplateID;
                temp.innerHTML = this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "externalform" ? $.render[this._id + "_JSONDialogEditingTemplate"](args.data) : this._renderEjTemplate(templateID, args.data, 0);
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
                var $select = $(temp).find('select.e-field');
                for (var i = 0; i < $select.length; i++){
                    $select.eq(i).val(args.data[$select[i].name]);
                    $select.eq(i).data('ej-value', args.data[$select[i].name]);
                    }
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                    $("#" + this._id + "_dialogEdit").html($(temp));
                    var model = {};
                    model.cssClass = this.model.cssClass;
                    model.width = "auto";
                    model.enableResize = this.phoneMode;
                    model.content = "#" + this._id;
                    model.enableModal = true;
                    model.close = $.proxy(this._buttonClick, this);
                    model.enableRTL = this.model.enableRTL;
                    model.allowKeyboardNavigation = false;
                    model.title = this.localizedLabels.AddFormTitle;
                    $("#" + this._id + "_dialogEdit").ejDialog(model);
                    $("#" + this._id + "_dialogEdit").ejDialog("open");
                }
                else {
                    $("#" + this._id + "_externalEdit").css("display", "block").css('z-index', this._maxZindex() + 1);
                    $("#" + this._id + "_externalForm").find(".e-externalformedit").html($(temp));
                    $("#" + this._id + "_eFormHeader").find(".e-form-title").text(this.localizedLabels.AddFormTitle);
                    this._externalFormPosition();
                }
            }
            if (this.model.editSettings.editMode != "normal")
                $editTr = $(temp);
			if(!ej.isNullOrUndefined(this.model.templateRefresh) && $editTr.find(".e-templatecell").length != 0) 
				this._refreshTemplateCell($editTr, args.data);
            if (this.model.allowPaging) {
                if (this.model.filterSettings.filteredColumns.length)
                    this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._filteredRecordsCount : this._searchCount, currentPage: this._currentPage() });
                else
                    this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._gridRecordsCount : this._searchCount, currentPage: this._currentPage() });
                this._refreshGridPager();
            }
        },
        editFormValidate: function () {
            if ($.isFunction($.validator)) {
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var forms = this.element.find(".gridform");
                    if (forms.length > 1) {
                        var form1, form2;
                        form1 = forms.eq(0).validate().form();
                        form2 = forms.eq(1).validate().form();
                        if (!(form1 && form2))
                            return false;
                        else
                            return true;
                    }
                    else
                        return forms.validate().form();
                }
                else if (this.model.editSettings.showAddNewRow) {
                   return $(this.getRows()).hasClass("e-editedrow") ? this.element.find(".e-editedrow .gridform").validate().form() : this.element.find(".e-addedrow .gridform").validate().form();
                }
                return $("#" + this._id + "EditForm").validate().form();
            }
            return true;
        },
        _refreshAltRow: function () {
            var $gridRows = this._excludeDetailRows();
            for (var r = 0; r < $gridRows.length; r++) {
                var $row = $($gridRows[r]);
                $row.hasClass("e-alt_row") && $row.removeClass("e-alt_row");
                (r % 2 != 0) ? $row.addClass("e-alt_row") : $row.addClass("e-row")
            }
        },
        _editCompleteAction: function (args) {
            var $form = this.element.find(".gridform");
            this.model.isEdit = true;
            var $cols1 = this.getContentTable().children("colgroup").find("col");
            var width = this.element.width()
            this.setWidthToColumns();
            if (ej.Grid.Actions.Add == args.requestType) {
                var disabledElements = $form.find(".e-field:disabled");
                for (var j = 0; j < disabledElements.length; j++) {
                    var fieldName = $(disabledElements[j]).attr("name");
                    if (!$(disabledElements[j]).hasClass("e-identity"))
                        if ($.inArray(fieldName, this._disabledEditableColumns) == -1 || $.inArray(fieldName, this._primaryKeys) !== -1)
                            $(disabledElements[j]).prop("disabled",false).removeClass("e-disable");
                }
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length - 1; i++)
                    $form.find("colgroup").prepend(this._getIndentCol());
            }
            if (this._tdsOffsetWidth.length == 0 || this.model.groupSettings.groupedColumns.length || $.inArray(0, this._tdsOffsetWidth) != -1 || this._hiddenColumns.length > 0)
                this._setoffsetWidth();
            this._refreshEditForm(args);
            if (this.model.scrollSettings.frozenColumns > 0 && (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate")) {
                if (args.requestType == "beginedit")
                    args.row.eq(0).next().find("td").height(args.row.eq(1).next().find("td").height());
                else
                    this.getContentTable().first().find("tr").first().find("td").height(this.getContentTable().last().find("tr").first().find("td").height());
            }
            if (this.model.scrollSettings.frozenRows > 0 && args.requestType == "beginedit"){
				this._initFrozenRows();
				if (ej.getObject("_vScrollbar._scrollData", this.getScrollObject()))
					this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
			}
            if (this.model.scrollSettings.frozenColumns > 0) {
                this.rowHeightRefresh();
                this._refreshScroller(args);
            }
            if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns <= 0 && this.getScrollObject()
                && this.getScrollObject().isHScroll())
                this.getScrollObject().refresh();
            if ($.isFunction($.validator))
                this.initValidator();
        },
        _refreshEditForm: function (args) {
			var editedTr; 
			if(this.model.editSettings.showAddNewRow)
				editedTr = this.getContentTable().find(".e-editedrow");
            var form = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr[0].lastChild.lastChild : document.getElementById(this._id + "EditForm");
            var elementFocused = false, columnIndex, matchMedia;
            if (this.model.enableResponsiveRow && $.isFunction(window.matchMedia))
                matchMedia = window.matchMedia("(max-width: 320px)");
            var $formElement = $(form).find("input,select,div.e-field,textarea"), percent = 86;
            if ((this._isUnboundColumn || this.getContentTable().find(".e-templatecell") != null) && this.model.editSettings.editMode != "batch")
                $formElement = $formElement.filter(function () { return (!$(this).closest(".e-rowcell").hasClass("e-unboundcell") && !$(this).closest(".e-rowcell").hasClass("e-templatecell")) })
            var focusEle = null;
            for (var i = 0; i < $formElement.length; i++) {
                var $element = $formElement.eq(i);
                var inputWidth, column = this.getColumnByField(!ej.isNullOrUndefined($element.prop("name")) ? $element.prop("name") : $element.attr("name"));
                if (column != null)
                    columnIndex = $.inArray(column, this.model.columns);
                if (this.model.editSettings.editMode == "batch") {
                    percent = 95;
                }
                else if (this.model.editSettings.editMode == "normal")
                    percent = 96;
                if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                    $element.parent().css("width", ej.dataUtil.max(this._tdsOffsetWidth) + "px");
                    inputWidth = ej.max(this._tdsOffsetWidth) * (percent / 100);
                }
                else
                    inputWidth = this._tdsOffsetWidth[i] * (percent / 100);
                if ((this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "batch" || this.model.allowResizing || this.model.allowResizeToFit) && !$element.hasClass("e-checkbox"))
                    inputWidth = "100%";
                if (column !=null && columnIndex !== undefined && (columnIndex < this.model.columns.length && this.model.columns[columnIndex].editTemplate)) {
                    var temp = { rowdata: this.model.editSettings.editMode == "batch" ? this._batchEditRowData : this._currentJsonData[this._selectedRow()], column: this.model.columns, element: $element, requestType: args.requestType, type: args.type };
                    var temp1 = this.model.columns[columnIndex].editTemplate.write;
                    if (!ej.isNullOrUndefined(args) && args.requestType == "add") temp.rowdata = {};
                    if (typeof temp1 == "string")
                        temp1 = ej.util.getObject(temp1, window);
                    temp1(temp);
					if(this.model.columns[columnIndex].isPrimaryKey && args.requestType == "beginedit")
						$element.addClass("e-disable").attr("disabled", "disabled");
                }
                else if ($element.hasClass("e-numerictextbox") || $element.hasClass("e-datepicker") || $element.hasClass("e-datetimepicker") || $element.hasClass("e-dropdownlist")) {
                    var customParams = this.getColumnByField($element.prop("name")), value = $element.val();
                    if ((!ej.isNullOrUndefined(matchMedia) && matchMedia.matches) || customParams["width"] && typeof customParams["width"] == "string" && customParams["width"].indexOf("%") != -1 && (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "batch"))
                        inputWidth = "100%";
                    $element.css("width", inputWidth);
                    if ($element.hasClass("e-numerictextbox")) {

                        if (value.length)
                            $element.attr("value", parseFloat(value));
                        $element.prop("name", $element.prop("name").replace(this._id, ""));
                    }
                    if ($element.hasClass("e-disable"))
                        $element.attr("disabled", "disabled");
                }
				 else if ($element.hasClass("e-save e-button") || $element.hasClass("e-cancel e-button") )
					 $element.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, width: "100","text-align":"centre",height:"35px"});
                    //else if ($element.hasClass("checkbox"))
                    //{
                    //    var value = $element.prop("checked");
                    //    $element.ejCheckBox({
                    //        id: $element[0].id,
                    //        checked: value
                    //    });
                    //}
                else {
                    switch ($element.prop('tagName')) {
                        case "INPUT":
                            if (!ej.isNullOrUndefined(column) && column.format && $element.val() != "") {
                                switch (column.type) {
                                    case ("date" || "datetime"):
                                        var value = $element.val();
                                        var date = new Date(value);
                                        var format = column.format.replace("{0:", "").replace("}", "");
                                        var newformat = ej.format(date, format, this.model.locale);
                                        $element.val(newformat);
                                        break;
                                    case "number":
                                        var value = $element.val();
                                        var format = new RegExp("\\{0(:([^\\}]+))?\\}", "gm").exec(column.format);
                                        format[2].toLowerCase().split("")[0] == "c" ? format[2] = format[2].toLowerCase().replace("c", "n") : format[2];
                                        $element.val(ej.format(parseFloat(value), format[2], this.model.locale));
                                        break;
                                }
                            }
                            if ($element.attr("type") != "checkbox") {
                                $element.css("text-align", $element.attr("name") != null && this.getColumnByField($element.attr("name")) != null ?
                                this.getColumnByField($element.attr("name")).textAlign : "center");
                                if (this.model.editSettings.editMode == "batch"){
                                    $element.css('width', '100%').css("height", "28px");
									if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
									   $element.css("line-height", "22px");
							    }
                                else if (this.model.editSettings.editMode == "normal"){
                                    $element.css('width', '100%').css("height", "30px");
									if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
									   $element.css("line-height", "24px");
								}	
                                else{
                                    $element.outerWidth(inputWidth).height(28);
									if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
									   $element.css("line-height", "26px");
								}

                            }
                            else
                                $element.width(inputWidth > 0 ? ($element.width() > inputWidth ? inputWidth : $element.width()) : this.model.editSettings.editMode.indexOf("template") != -1 ? $element.width() : 1);
								if(this.model.editSettings.editMode == "batch" && !this._tabKey)
									$element.is(':checked') ? $element.prop("checked",false) : $element.prop("checked",true);
                            break;
                        case "SELECT":
                            $element.width(inputWidth).height(28);
                            break;
                    }
                }
                if (column != null && !column.visible && column.validationRules && !(this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineformtemplate")){				
					$element.addClass("e-hide");
				}
                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof ($element.data("ejDropDownList") || $element.data("ejNumericTextbox")) == "object")) {
                    focusEle = $element;
                    elementFocused = true;
                }
            }
            var params2 = {};
            params2.enableRTL = this.model.enableRTL;
            params2.cssClass = this.model.cssClass;
            params2.watermarkText = this.localizedLabels.NumericTextBoxWaterMark;
            params2.locale = this.model.locale;
            $formElement.filter(".e-numerictextbox").ejNumericTextbox($.extend({ showSpinButton: true }, params2));
            params2.watermarkText = this.localizedLabels.DatePickerWaterMark;
            $formElement.filter(".e-datepicker").ejDatePicker($.extend({ displayDefaultDate: true, showPopupButton: false }, params2));
            delete params2["watermarkText"];

            $formElement.filter(".e-datetimepicker").ejDateTimePicker($.extend({ showPopupButton: false }, params2));
            $formElement.filter(".e-dropdownlist").ejDropDownList($.extend({ enableIncrementalSearch: true, htmlAttributes: {style: "width: 100%"} }, params2));
            for (var i = 0; i < this.model.columns.length; i++) {
                var col = this.model.columns[i];
                if (!ej.isNullOrUndefined(col.editParams)) {

                    switch (col.editType) {
                        case ej.Grid.EditingType.DateTimePicker:
                            $formElement.filter("#" + this._id + col.field + ".e-datetimepicker").ejDateTimePicker(col.editParams);
                            break;
                        case ej.Grid.EditingType.DatePicker:
                            $formElement.filter("#" + this._id + col.field + ".e-datepicker").ejDatePicker(col.editParams);
                            break;
                        case ej.Grid.EditingType.Numeric:
                            $formElement.filter("#" + this._id + col.field + ".e-numerictextbox").ejNumericTextbox(col.editParams);
                            break;
                        case ej.Grid.EditingType.Dropdown:
                            $formElement.filter("#" + this._id + col.field + ".e-dropdownlist").ejDropDownList(col.editParams);
                            break;
                    }
                }

                if (col.editType == ej.Grid.EditingType.Dropdown) {
                    var f_index = -1;
                    if (this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor)
                        f_index = this._dataSource().adaptor.value.indexOf(col.field)
                    var ele = $formElement.filter("#" + this._id + col.field.replace(/\./g, "") + ".e-dropdownlist");
                    var dataSource = null;
                    if (!ej.isNullOrUndefined(col.dataSource) && !ej.isNullOrUndefined(col.editParams) && ej.isNullOrUndefined(col.foreignKeyField) && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && f_index != -1)
                        dataSource = col.dataSource;
                    else if (ej.isNullOrUndefined(col.dataSource) && f_index != -1 && !ej.isNullOrUndefined(col.editParams))
                        dataSource = this._dataSource().adaptor.foreignData[f_index];
                    else if (!ej.isNullOrUndefined(col.editParams) && 'fields' in col.editParams && ej.isNullOrUndefined(col.foreignKeyField))
                        dataSource = col.dataSource; //when field is present in 'editParams' then dataSource is needed.
                    if (dataSource != null)
                        ele.ejDropDownList({ dataSource: dataSource });
                    var val = ele.data("ej-value");
                    if ((this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) && f_index != -1 && !ej.isNullOrUndefined(col.editParams))
                        ele.ejDropDownList("setSelectedText", args.requestType == "add" && ej.isNullOrUndefined(col.defaultValue) && ej.isNullOrUndefined(val) ? ele.val("") : val);
                    else
                        ele.ejDropDownList("setSelectedValue", args.requestType == "add" && ej.isNullOrUndefined(col.defaultValue) && ej.isNullOrUndefined(val) ? ele.val("") : val);
                    if (col != null && !col.visible && col.validationRules && !(this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineformtemplate")) {
                        if (col.editType == ej.Grid.EditingType.Dropdown)
                            ele.closest(".e-rowcell").find("input").addClass("e-hide");
                    }
                }
                var format = null;
                if (col["format"] !== undefined && (col.format.length > 0)) {
                    var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                    var formatVal = toformat.exec(col.format);
                    format = formatVal[2];
                }

                if ([ej.Grid.EditingType.DatePicker, ej.Grid.EditingType.DateTimePicker].indexOf(col.editType) != -1) {
                    var picker = col.editType == ej.Grid.EditingType.DatePicker ? "datePicker" : "dateTimePicker";
                    var pickerControl = "ej" + picker.replace(/\b\w/g, function (m) { return m.toUpperCase(); });
                    var eleID = this._id + col.field;
                    var dateElement = $formElement.filter(function (e, k) { return k.id == eleID && ($(k).hasClass("e-datepicker") || $(k).hasClass("e-datetimepicker")); });
                    var dateParams = {};
                    if (format != null && !(!ej.isNullOrUndefined(col["editParams"]) && (col["editParams"].dateFormat || col["editParams"].dateTimeFormat)))
                        dateParams[picker.replace("Picker", "") + "Format"] = format;
                    if (dateElement.hasClass("e-disable")) dateParams["enabled"] = false;
                    dateElement[pickerControl](dateParams);
                    if (this.model.editSettings.editMode == "batch")
                        dateElement[pickerControl]("show");
                }
            }
            if (focusEle != null) {
                this._focusElements(focusEle);
            }

        },
        _focusElements: function ($currentCell) {
            if ($currentCell.length) {
                var $childElem = $currentCell;
                if (($childElem[0].tagName.toLowerCase() == "select" && !$childElem.hasClass("e-field e-dropdownlist")) || ($childElem[0].tagName.toLowerCase() == "input") && !$childElem.hasClass("e-numerictextbox")) {
                    $childElem.focus().select();
                    $childElem[0].focus();
                }
                else if ($childElem.hasClass("e-field e-dropdownlist"))
                     $childElem.closest(".e-ddl").focus();
				else if ($childElem.hasClass('e-numerictextbox'))
					 $childElem.siblings('input:visible').first().select().focus();
                else
                    $childElem.find('input:visible,select').first().select().focus();
            }
        },
        _renderToolBar: function () {
            var $div = ej.buildTag('div.e-gridtoolbar', "", {}, { id: this._id + "_toolbarItems" });
            var $ul = ej.buildTag("ul");
            ((!ej.isNullOrUndefined(this.model.toolbarSettings.toolbarItems) && this.model.toolbarSettings.toolbarItems.length) || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow)) && this._renderLi($ul);
            $div.append($ul);
            var $customUl = ej.buildTag("ul");
            $div.append($customUl);
            (!ej.isNullOrUndefined(this.model.toolbarSettings.customToolbarItems) && this.model.toolbarSettings.customToolbarItems.length) && this._renderCustomLi($customUl);
            var model = {};
            model.click = this._toolBarClick;
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeprator = false;
            $div.ejToolbar(model);
            $div.ejToolbar("disableItem", this._disabledToolItems);
            this._disabledToolItems = $();
            return $div;
        },
        _renderCustomLi: function ($ul) {
            var $li; var customToolbar;
            for (var i = 0; i < this.model.toolbarSettings.customToolbarItems.length; i++) {
                customToolbar = this.model.toolbarSettings.customToolbarItems[i]["templateID"] ? this.model.toolbarSettings.customToolbarItems[i]["templateID"].replace("#", "") : this.model.toolbarSettings.customToolbarItems[i];
                $li = ej.buildTag("li", "", {}, { id: this._id + "_" + customToolbar, title: customToolbar });
                switch (typeof this.model.toolbarSettings.customToolbarItems[i]) {
                    case "string":
                        var $item = ej.buildTag("a.e-toolbaricons e-icon", "", {}).addClass(this.model.toolbarSettings.customToolbarItems[i]);
                        break;
                    case "object":
                        var templi = this.model.toolbarSettings.customToolbarItems[i];
                        $li.attr("title", !ej.isNullOrUndefined(templi["tooltip"]) ? templi["tooltip"] : templi["templateID"].replace("#", ""));
                        var $item = $(templi["templateID"]).hide().html();
                        break;
                }
                $li.html($item);
                $ul.append($li);
            }
        },
        _renderLi: function ($ul) {
            if ($.isFunction(window.matchMedia)) {
                if (this.model.enableResponsiveRow ) {
                    var searchIndex = this.model.toolbarSettings.toolbarItems.indexOf('search');
                    searchIndex != -1 && this.model.toolbarSettings.toolbarItems.splice(searchIndex, 1);
                    if (this.model.allowFiltering)
                        this.model.toolbarSettings.toolbarItems.push('responsiveFilter');
                    if (this.model.allowSorting) {
                        this.model.toolbarSettings.toolbarItems.push('responsiveSorting');
                    }
                    searchIndex != -1 && this.model.toolbarSettings.toolbarItems.push('search');
                }
            }
            for (var i = 0; i < this.model.toolbarSettings.toolbarItems.length; i++) {
                var $li = ej.buildTag("li", "", {}, { id: this._id + "_" + this.model.toolbarSettings.toolbarItems[i], title: this.localizedLabels[this.model.toolbarSettings.toolbarItems[i].slice(0, 1).toUpperCase() + this.model.toolbarSettings.toolbarItems[i].slice(1)] });
                this._renderLiContent($li, this.model.toolbarSettings.toolbarItems[i]);
                var item = this.model.toolbarSettings.toolbarItems[i];
                if (this.model.enableResponsiveRow && (item === "responsiveFilter" || item === "responsiveSorting")) {
                    $li.addClass("e-gridresponsiveicons");
                    $li.css("display", "none");
                }
                $ul.append($li);
            }
        },
        _renderLiContent: function ($li, item) {
            var $a, $input, $div, $span;
            switch (item) {
                case "add":
                    $a = ej.buildTag("a.e-addnewitem e-toolbaricons e-icon e-addnew", "", {});
                    break;
                case "edit":
                    $a = ej.buildTag("a.e-edititem e-toolbaricons e-icon e-edit", "", {});
                    break;
                case "delete":
                    $a = ej.buildTag("a.e-deleteitem e-toolbaricons e-icon e-delete", "", {});
                    break;
                case "update":
                    $a = ej.buildTag("a.e-saveitem e-toolbaricons e-disabletool e-icon e-save", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;
                case "cancel":
                    $a = ej.buildTag("a.e-cancel e-toolbaricons e-disabletool e-icon e-gcancel", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;
				
                case "search":
                    $a = ej.buildTag("a.e-searchitem e-toolbaricons e-disabletool e-icon e-searchfind", "", {});
                    if (!this.model.enableResponsiveRow) {
                        $input = ej.buildTag("input.e-ejinputtext e-gridsearchbar", "", {}, { type: "text", id: this._id + "_searchbar" });
                        $span = ej.buildTag('span.e-cancel e-icon e-hide', "", { 'right': '1%' });
                        $div = ej.buildTag('div.e-filterdiv e-searchinputdiv', "", { 'display': 'inline-table', 'width': '83%' });
                        $div.append($input).append($span);
                        $li.append($div);
                        if (!ej.isNullOrUndefined(this.model.searchSettings.key))
                            $input.val(this.model.searchSettings.key);
                    }
                    this.model.allowSearching = true;
                    break;
				case "printGrid":
					 $a = ej.buildTag("a.e-print e-toolbaricons e-icon", "", {});
					 break;
                case "excelExport":
                    $a = ej.buildTag("a.e-toolbaricons e-excelIcon e-icon", "", {});
                    break;
                case "wordExport":
                    $a = ej.buildTag("a.e-toolbaricons e-wordIcon e-icon", "", {});
                    break;
                case "pdfExport":
                    $a = ej.buildTag("a.e-toolbaricons e-pdfIcon e-icon", "", {});
                    break;
                case "responsiveFilter":
                    $a = ej.buildTag("a.e-toolbaricons e-filterset e-icon", "", {});
                    break;
                case "responsiveSorting":
                    $a = ej.buildTag("a.e-toolbaricons e-respponsiveSorting e-icon", "", {});
                    break;
            }
            $li.append($a);
            if (item == "search"){
                this._searchBar = $li;
				$li.css('display','flex');
			}
        },
        _toolBarClick: function (Sender) {
            var $gridEle = $(this.itemsContainer).closest(".e-grid"), gridInstance = $gridEle.ejGrid("instance"), gridId = $gridEle.attr('id');
            if (Sender.event == undefined && Sender.target.tagName == "INPUT" && Sender.currentTarget.id == gridId + "_search")
                return;
            $.isFunction($.fn.ejDatePicker) && $("#" + gridId + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            var currentTarget = Sender.currentTarget; var target = Sender.target;
            var gridModelClone = $.extend({}, gridInstance.model);
            if (gridInstance.ignoreOnToolbarServerClick.length) {
                for (var i = 0; i < gridInstance.ignoreOnToolbarServerClick.length; i++)
                    delete gridModelClone[gridInstance.ignoreOnToolbarServerClick[i]];
            }
            var args = { itemName: $(currentTarget).attr("data-content"), itemId: currentTarget.id, currentTarget: currentTarget, target: target, itemIndex: $(currentTarget).index(), itemCurrentTarget: currentTarget.outerHTML, gridModel: gridModelClone, itemTarget: target.outerHTML, toolbarData: Sender };
            if ($gridEle.ejGrid("instance")._trigger("toolbarClick", args))
                return;
            switch (args.itemId) {
                case gridId + "_add":
                    gridInstance._toolbarOperation(gridId + "_add");
                    break;
                case gridId + "_edit":
                    gridInstance._toolbarOperation(gridId + "_edit");
                    break;
                case gridId + "_delete":
                    gridInstance._toolbarOperation(gridId + "_delete");
                    break;
                case gridId + "_update":
                    gridInstance._toolbarOperation(gridId + "_update");
                    break;
                case gridId + "_cancel":
                    if (gridInstance.model.editSettings.editMode == "batch"){
                        if(gridInstance.model.editSettings.showConfirmDialog)
                             gridInstance._confirmDialog.find(".e-content").html(gridInstance.localizedLabels.CancelEdit).end().ejDialog("open");
                        else    
                             gridInstance.cancelEdit();
                    }
                    else
                        gridInstance._toolbarOperation(gridId + "_cancel");
                    break;
                case gridId + "_search":
                    if (gridInstance.model.enableResponsiveRow) {
                        if (ej.isNullOrUndefined(gridInstance.element.find('.e-responsesearch')[0])) {
                            var $div = ej.buildTag('div.e-gridtoolbar', "", {}, { id: this._id + "_toolbarItems" });
                            var $ul = ej.buildTag('div.e-responsesearch', '', { 'width': '95%', 'height': '38px', 'margin-top': '7px', 'margin-left': '6px' });
                            var $span = ej.buildTag('span.e-ttoltxt', '', { width: '98%', 'margin-left': '2%' }, { id: gridInstance._id + "_search" });
							var $a = ej.buildTag("span.e-searchitem e-toolbaricons e-disabletool e-icon e-searchfind", "", { 'position': 'absolute', 'right': '2%', 'margin-top': '1%' });
                            if (ej.browserInfo().name === "webkit")
                                $a.css("margin-top", "-2px");
                            var $input = ej.buildTag("input.e-ejinputtext", "", { width: '97%', 'height': '30px' }, { type: "search", id: gridInstance._id + "_searchInput" });
                            if (!ej.isNullOrUndefined(gridInstance.model.searchSettings.key))
                                $input.val(gridInstance.model.searchSettings.key);
                            $span.append($input);
                            $span.append($a);
                            $ul.append($span);
                            $div.append($ul);
                            $div.ejToolbar({
                                click: function (sender) {
                                    gridInstance._toolbarOperation(gridId + "_search", $(sender.currentTarget).find("input").val());
                                }
                            });
                            $input.on('keyup', function (e) {
                                if ($input.val() != '') {
                                    $a.removeClass('e-searchfind');
                                    $a.addClass('e-cancel')
                                }
                                else {
                                    $a.removeClass('e-cancel');
                                    $a.addClass('e-searchfind');
                                }
                            });
                            $a.click(function () {
                                if ($a.hasClass('e-cancel')) {
                                    $input.val('');
                                    $a.removeClass('e-cancel');
                                    $a.addClass('e-searchfind');
                                    gridInstance._toolbarOperation(gridId + "_search", $("#" + gridId + "_searchInput").val());
                                }
                            })
                            $div.insertBefore(gridInstance.getHeaderContent());
                        }
                        else {
                            if (gridInstance.element.find('.e-responsesearch').css('display') == 'block')
                                gridInstance.element.find('.e-responsesearch').css('display', 'none');
                            else
                                gridInstance.element.find('.e-responsesearch').css('display', 'block');
                        }
                    }
                    else
                        gridInstance._toolbarOperation(gridId + "_search", $(Sender.target).hasClass("e-cancel") ? "" : $(Sender.currentTarget).find("input").val());
                    break;
				case gridId + "_printGrid":
                    gridInstance._toolbarOperation(gridId + "_printGrid");
                    break;
                case gridId + "_excelExport":
                    gridInstance._toolbarOperation(gridId + "_excelExport");
                    break;
                case gridId + "_wordExport":
                    gridInstance._toolbarOperation(gridId + "_wordExport");
                    break;
                case gridId + "_pdfExport":
                    gridInstance._toolbarOperation(gridId + "_pdfExport");
                    break;
                case gridId + "_responsiveFilter":
                    gridInstance._toolbarOperation(gridId + "_responsiveFilter");
                    break;
                case gridId + "_responsiveSorting":
                    gridInstance._toolbarOperation(gridId + "_responsiveSorting");
                    break;
            }
            return false;
        },

        _toolbarOperation: function (operation, searchEle) {
            var $gridEle = this.element, gridObject = $gridEle.ejGrid("instance"), batchEnable = gridObject.model.editSettings.editMode == "batch", gridId = $gridEle.attr('id'), fieldName;
            gridObject._exportTo = gridObject["export"];
            switch (operation) {
                case gridId + "_add":
                    if (batchEnable)
                        gridObject._bulkAddRow();
                    else
                        gridObject._startAdd();
                    break;
                case gridId + "_edit":
                    if (batchEnable && gridObject.model.editSettings.allowEditing) {
					    if (gridObject._bulkEditCellDetails.columnIndex == -1) {
					        alert(this.localizedLabels.EditOperationAlert);
                            return;
                        }
                        fieldName = gridObject.model.columns[gridObject._bulkEditCellDetails.columnIndex].field;
                        fieldName && gridObject.editCell(gridObject._bulkEditCellDetails.rowIndex, fieldName);
                    }
                    else
                        gridObject.startEdit();
                    break;
                case gridId + "_delete":
                    if (this._selectedRow() == -1) {
                        alert(this.localizedLabels.DeleteOperationAlert);
                        return;
                    }
                    if (this.model.editSettings.showDeleteConfirmDialog)
                        this._confirmDialog.find(".e-content").html(this.localizedLabels.ConfirmDelete).end().ejDialog("open");
                    else {
                        if (batchEnable)
                            this._bulkDelete()
                        else {
                            if (this.multiDeleteMode)
                                this._multiRowDelete();
                            else
                                this.deleteRow();
                        }
                    }
                    break;
                case gridId + "_update":
                    if (batchEnable && $("#" + this._id + "EditForm").children().find(".e-field-validation-error").length == 0)
                        this.model.editSettings.showConfirmDialog ? this._confirmDialog.find(".e-content").html(this.localizedLabels.BatchSaveConfirm).end().ejDialog("open") : this.batchSave();
                    else
                        gridObject.endEdit();
                    break;
                case gridId + "_cancel":
                    if (batchEnable) {
                        if ($("#" + gridId + "ConfirmDialog").ejDialog("isOpened") === true)
                            this._triggerConfirm();
                        else
                            gridObject.cancelEditCell();
                    }
                    else
                        gridObject.cancelEdit();
                    break;
                case gridId + "_search":
                    if (args.type == 'click' && (args.target.nodeName == "A" || args.target.nodeName == "SPAN"))
                        $gridEle.ejGrid("search", searchEle);
                    break;
				case gridId + "_printGrid":
                    this.print();
                    break;
                case gridId + "_excelExport":
                    gridObject._exportTo(gridObject.model.exportToExcelAction, 'excelExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_wordExport":
                    gridObject._exportTo(gridObject.model.exportToWordAction, 'wordExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_pdfExport":
                    gridObject._exportTo(gridObject.model.exportToPdfAction, 'pdfExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_responsiveFilter":
                    $("#responsiveFilter").css('display', 'block');
                    setTimeout(function () { gridObject.element.css('display', 'none'), 0 });
                    break;
                case gridId + "_responsiveSorting":
                    this._sortColumns = []; this._removeSortCol = []
                    for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                        this._sortColumns.push({ field: this.model.sortSettings.sortedColumns[i].field, direction: this.model.sortSettings.sortedColumns[i].direction });
                    }
                    if (ej.isNullOrUndefined($("#responsiveSort")[0])) {
                        var $dlg = $("#responsiveFilter").clone().css('display', 'block');
                        $dlg.insertAfter(this.element);
                        $dlg.attr('id', 'responsiveSort');
                        gridObject._setSortingButton();
                        var $btnDiv = ej.buildTag('div.btnContainer', '', { width: '100%', 'bottom': '0px', 'position': 'absolute' });
                        var $inputOk = ej.buildTag('input.e-resposnsiveFilterBtnLeft e-flat e-btnsub', 'OK', { 'width': '45.6%' });
                        var $inputCancel = ej.buildTag('input.e-resposnsiveFilterBtnRight e-flat e-btncan', 'Cancel', { 'width': '46%' });
                        var $closeIcon = ej.buildTag('div.e-resFIlterRigthIcon');
                        var $cspanIcon = ej.buildTag('span.e-icon e-responsiveClose e-resIcon');
                        $dlg.find('.e-resFilterleftIcon').remove();
                        $dlg.find('.labelRes').text('Sorting');
                        $dlg.find('.e-resFilterDialogHeaderDiv').append($closeIcon.append($cspanIcon))
                        $dlg.find('.e-resFilterDialogHeaderDiv').find('.e-resFIlterRigthIcon').click(function (e) {
                            $("#responsiveSort").css('display', 'none');
                            gridObject.element.css('display', 'block');
                        })
                        var $divIcon = ej.buildTag('div.e-resFilterleftIcon', '', { 'margin-top': '3%' });
                        var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responsiveSortClear');
                        $divIcon.click(function () {
                            $dlg.find('.e-responsivefilterColDiv').find('.e-button').remove();
                            gridObject._setSortingButton(true);
                            for (var i = 0; i < gridObject._sortColumns.length; i++) {
                                if (gridObject._removeSortCol.indexOf(gridObject._sortColumns[i].field) == -1)
                                    gridObject._removeSortCol.push(gridObject._sortColumns[i].field);
                            }
                            gridObject._sortColumns = [];
							gridObject._removeSortCol = [];
                        });
                        $dlg.find('.e-resFilterDialogHeaderDiv').prepend($divIcon.append($spanIcon));
                        $dlg.append($btnDiv);
                        $btnDiv.append($inputOk).append($inputCancel);
                        $inputOk.ejButton({
                            text: 'OK', type: 'button',
                            click: $.proxy(this._resSortOperation, this)
                        })
                        $inputCancel.ejButton({
                            text: 'Cancel', type: 'button',
                            click: function () {
                                $("#responsiveSort").css('display', 'none');
                                gridObject.element.css('display', 'block');
                                gridObject._sortColumns = [];
                                $dlg.find('.e-responsivefilterColDiv').find('.e-button').remove();
                                gridObject._setSortingButton();
                            }
                        })
                    }
                    else {
                        $("#responsiveSort").find('.e-responsivefilterColDiv').find('.e-button').remove();
                        this._setSortingButton();
                    }
                    $("#responsiveSort").find('.e-responsivefilterColDiv').find('.e-filternone').remove();
                    $("#responsiveSort").css('display', 'block');
                    setTimeout(function () { gridObject.element.css('display', 'none'), 0 });
                    break;
            }
            return false;
        },
        _resSortOperation: function (sender) {
            var rCol=[];
			for(var i=0; i< this.model.sortSettings.sortedColumns.length;i++)
				rCol.push(this.model.sortSettings.sortedColumns[i].field);
            for (var i = 0; i < rCol.length; i++)
                this.removeSortedColumns(rCol[i]);
            for (var i = 0 ; i < this._sortColumns.length; i++) {
                if (this.model.allowMultiSorting)
                    this.multiSortRequest = true;
                this.sortColumn(this._sortColumns[i].field, this._sortColumns[i].direction);
            }
            $("#responsiveSort").css('display', 'none');
            this.element.css('display', 'block');
        },
        _setSortingButton: function (clear) {
            var $sortDiv = $("#responsiveSort");
            var gridObj = this;
            this._sortCols = [];
            if (ej.isNullOrUndefined($sortDiv.find('.e-responsivefilterColDiv').find('.e-button')[0])) {
                $sortDiv.find('.e-responsivefilterColDiv').each(function (index, object) {
                    var $btnDiv = ej.buildTag('div', '', { 'float': 'right', 'margin-right': '2%', 'margin-top': '-1%' })
                    var fieldName = $(object).attr('ej-MappingName');
                    var $but = ej.buildTag('button#' + fieldName + ".e-sortingBtn e-flat", '');
                    $(object).append($btnDiv.append($but));
                    var btnText = 'None', icon = '';
                    if (!clear) {
                        for (var sortC = 0; sortC < gridObj.model.sortSettings.sortedColumns.length; sortC++) {
                            if (gridObj.model.sortSettings.sortedColumns[sortC].field == fieldName) {
                                btnText = gridObj.model.sortSettings.sortedColumns[sortC].direction == 'ascending' ? 'Ascending' : 'Descending';
                                icon = btnText == 'Ascending' ? 'e-resIcon e-respponsiveSortingAsc' : 'e-resIcon e-respponsiveSortingDesc';
                            }
                        }
                        if (icon != '') {
                            $but.ejButton({
                                text: btnText, type: 'button',
                                height: 28,
                                width: 120,
                                cssClass: 'e-resSortIconBtn',
                                id: fieldName,
                                prefixIcon: icon,
                                imagePosition: "imageright",
                                contentType: "textandimage",
                                showRoundedCorner: true,
                                click: $.proxy(gridObj._resSortButClick, gridObj)
                            })
                        }
                        else {
                            $but.ejButton({
                                text: btnText, type: 'button',
                                height: 28,
                                cssClass: 'e-resSortIconBtn',
                                width: 120,
                                id: fieldName,
                                showRoundedCorner: true,
                                click: $.proxy(gridObj._resSortButClick, gridObj)
                            })
                        }
                    }
                    else {
                        $but.ejButton({
                            text: btnText, type: 'button',
                            height: 28,
                            width: 120,
                            id: fieldName,
                            showRoundedCorner: true,
                            click: $.proxy(gridObj._resSortButClick, gridObj)
                        })
                    }
                });
            }
        },
        _sortOperation: function (field, direction) {
            if (this._removeSortCol.indexOf(field) != -1) {
                this._sortColumns.splice(this._removeSortCol.indexOf(field), 0);
				this._removeSortCol.splice(this._removeSortCol.indexOf(field), 0);
            }
            for (var column = 0; column < this._sortColumns.length; column++) {
                if (this._sortColumns[column]["field"] == field)
                    break;
            }
            if (this.model.allowMultiSorting) {
                this.multiSortRequest = true;
                if (column != -1) {
                    this._sortColumns.splice(column, 1);
					if (this._removeSortCol.indexOf(field) == -1)
						this._removeSortCol.push(field);
                }
            }
            else {
                $("#responsiveFilter").find('.e-responsivefilterColDiv').find('.e-button').removeClass('e-disable');
                var $divColg = $("#responsiveFilter").find('.e-responsivefilterColDiv').not(".e-responsivefilterColDiv[ej-mappingname='" + field + "']");
                var $btn = $divColg.find('.e-button').addClass('e-disable');
                $btn.text('None');
                if (this._sortColumns.length > 0) {
                    this._removeSortCol.push(this._sortColumns[0].field);
                    this._sortColumns = [];
                }
            }
            this._sortColumns.push({ field: field, direction: direction });
        },
        _resSortButClick: function (sender) {
            var text = '', prefixIcon = '', fieldName = sender.model.id;
            var obj = $("#" + sender.model.id).ejButton('instance');
            if (sender.model.text == 'None') {
                text = 'Ascending';
                prefixIcon = 'e-resIcon e-respponsiveSortingAsc';
                this._sortOperation(fieldName, 'ascending');
            }
            else if (sender.model.text == 'Ascending') {
                text = 'Descending';
                prefixIcon = 'e-resIcon e-respponsiveSortingDesc';
                this._sortOperation(fieldName, 'descending');
            }
            else {
                obj.model.text = 'None';
                obj.model.prefixIcon = '';
                obj.type = 'button';
                obj.model.contentType = "text";
                obj._render();
                for (var column = 0; column < this._sortColumns.length; column++) {
                    if (this._sortColumns[column]["field"] == fieldName)
                        break;
                }
                this._removeSortCol.push(fieldName);
                this._sortColumns.splice(column, 1);
                $("#responsiveFilter").find('.e-responsivefilterColDiv').find('.e-button').removeClass('e-disable');
                return;
            }
            obj.model.text = text; obj.model.prefixIcon = 'e-resIcon ' + prefixIcon; obj.model.imagePosition = "imageright";
            obj.model.contentType = "textandimage"; obj._render();
        },
        renderDiaglogButton: function (form, tbody) {
            var btnId;
            if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                btnId = "EditExternalForm_";
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                btnId = "InlineEditForm_";
                var inlineTitleBar = ej.buildTag("div", "", "", { id: this._id + "_inlineFormTitle", 'class': "e-inlineform-titlebar" });
                inlineTitleBar.appendTo(tbody);
                    }
					
            else
                btnId = "EditDialog_";
            var savebtn = ej.buildTag('input.e-save e-button e-btnsub e-flat', "", { 'margin-left': '30px' }, { type: "button", id: btnId + this._id + "_Save" });
            savebtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: this.localizedLabels.SaveButton, width: "100" });
            var cancelbtn = ej.buildTag('input.e-cancel e-button e-btncan e-flat', "", { 'margin-left': '19px', 'margin-right': '13px' }, { type: "button", id: btnId + this._id + "_Cancel" });
            cancelbtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: this.localizedLabels.CancelButton, width: "100" });
            var btnDiv = (this.model.editSettings.editMode != "dialog" && this.model.editSettings.editMode != "dialogtemplate") ? ej.buildTag('div', "", "", { 'class': "e-editform-btn" }) : ej.buildTag('div');
            btnDiv.append(savebtn);
            btnDiv.append(cancelbtn);
            form.appendTo(tbody);
            if (this.model.editSettings.editMode != "dialog" && this.model.editSettings.editMode != "dialogtemplate")
                btnDiv.appendTo(tbody);
            else
                form.append(btnDiv);
            return tbody;
        },
        _externalFormPosition: function () {
            var pos = $(this.element).offset();
            var width = $(this.element).width();
            var height = $(this.element).height();
            var DivElement = $("#" + this._id + "_externalEdit");
            switch (this.model.editSettings.formPosition) {
                case "topright":
                    $(DivElement).find('.e-form-toggle-icon').removeClass('e-bottomleft').addClass('e-topright');
                    $(DivElement).css({ "left": (pos.left + width + 1) + "px", "top": pos.top + "px", "position": "absolute", "width": "290px" });
                    $("#" + this._id + "_eFormContent").height("auto");
                    break;
                case "bottomleft":
                    $(DivElement).find('.e-form-toggle-icon').removeClass('e-topright').addClass('e-bottomleft');
                    $(DivElement).css({ "left": (pos.left) + "px", "top": (pos.top + height + 1) + "px" });
                    $("#" + this._id + "_eFormContent").width("100%");
                    break;
            }
        },
        _setoffsetWidth: function () {
            var tds, $form = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
            if (this._gridRecordsCount == 0 && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0 && this.model.editSettings.editMode != "batch" && (!($form.find(".e-checkbox").length > 0 && this._dataSource() instanceof ej.DataManager)))
                return;
            if (this.model.editSettings.editMode == "batch")
                tds = $form.closest("td");
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                tds = $form.find(".e-rowcell").not(".e-unboundcell,.e-templatecell");
            else
                tds = $form.find("tr").find(".e-rowcell").not(".e-unboundcell,.e-templatecell");
            for (var i = 0; i < tds.length; i++)
                this._tdsOffsetWidth[i] = tds.get(i).offsetWidth;
        },
        _bulkChangesAcquired: function () {
            if (this.batchChanges.added.length > 0 || this.batchChanges.changed.length || this.batchChanges.deleted.length)
                return true;
            return false;
        },
        _renderDialog: function () {
            var $dialog = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none" }, { id: this._id + "_dialogEdit" });
            return $dialog;
        },
        
        getCurrentEditCellData: function () {
            if (this.model.isEdit && $("#" + this._id + "EditForm").length) {
                var $element = $("#" + this._id + this._bulkEditCellDetails.fieldName.replace(/[^a-z0-9\s_]/gi, '')), cellValue,
                    column = this.model.columns[this._bulkEditCellDetails.columnIndex], temp1;
                switch (this._bulkEditCellDetails.cellEditType) {
                    case ej.Grid.EditingType.String:
					case ej.Grid.EditingType.Numeric:
                        cellValue = $element.val();
                        break;                                          
                    case ej.Grid.EditingType.Dropdown:
                        cellValue = this._bulkEditCellDetails.isForeignKey ? { "value": $element.ejDropDownList("getSelectedValue"), "text": $element.ejDropDownList("getValue") } : $element.ejDropDownList("getSelectedValue");
                        if ( this._bulkEditCellDetails.isForeignKey && column.originalType == "number" && cellValue.value !="" )
							cellValue.value = JSON.parse(cellValue.value);
						break;
                    case ej.Grid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;
                    case ej.Grid.EditingType.DatePicker:                       
                        var val = $.trim($element.val());
                        var dropObj = $element.ejDatePicker("instance");
                        dropObj._setDateValue(val);//to update dropdownlist model when manually entering value
                        cellValue = val == "" ? val : dropObj.model.value;
                        break;
                    case ej.Grid.EditingType.DateTimePicker:
                        cellValue = $.trim($element.val()) == "" ? $.trim($element.val()) :$element.ejDateTimePicker("model.value");
                        break;
                    case "edittemplate":
                        temp1 = column.editTemplate.read;
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        cellValue = temp1($element);
                        break;
                }
                if (typeof cellValue == "string" && cellValue.length && column.type == "number")
                   cellValue = ej.globalize.parseFloat(cellValue,this.model.locale);
                return cellValue;
            }
            return null;
        },
        cancelEditCell: function () {
            if (this.model.isEdit) {
                var tr = this.getRows()[this._bulkEditCellDetails.rowIndex], cellData = {}, cell;
                ej.createObject(this._bulkEditCellDetails.fieldName, this._bulkEditCellDetails.cellValue, cellData);
                if ($(tr).hasClass("e-insertedrow"))
                    cell = $(tr).find('.e-rowcell').get(this._bulkEditCellDetails.columnIndex + this.model.groupSettings.groupedColumns.length);
                else
                    cell = $(tr).find('.e-rowcell').get(this._bulkEditCellDetails.columnIndex);
                $(cell).removeClass("e-validError");
                if ($(cell).hasClass("e-updatedtd"))
                    $(cell).addClass("e-gupdatenotify");
                $(cell).removeClass("e-editedbatchcell").empty().html($($.templates[this._id + "_JSONTemplate"].render(cellData)).find('.e-rowcell').get(this._bulkEditCellDetails.columnIndex).innerHTML);
                this.model.isEdit = false;
                this.element.focus();
            }
        },
        saveCell: function (preventSaveEvent) {
            if (this.model.isEdit) {
                if (!this.editFormValidate())
                    return true;
                var $form = $("#" + this._id + "EditForm"), $targetTR = $form.closest("tr"), $targetTD = $form.closest("td"), $toolBar, tempVal, formattedValue
                , args = {}, column = this.model.columns[this._bulkEditCellDetails.columnIndex], $element = $("#" + this._id + this._bulkEditCellDetails.fieldName.replace(/[^a-z0-9\s_]/gi,'')), getVal, setVal;
                args = {
                    columnName: column.field,
                    value: this.getCurrentEditCellData(),
                    rowData: this._bulkEditCellDetails.rowData,
                    previousValue: this._bulkEditCellDetails.cellValue,
                    columnObject: column,
                    cell: $targetTD,
                    isForeignKey: this._bulkEditCellDetails.isForeignKey
                };
                if (!preventSaveEvent && this._trigger("cellSave", args)) {
                    this._focusElements(args.cell);
                    this._bulkEditCellDetails.cancelSave = true;
                    return;
                }
                if (this.model.allowTextWrap)
                    args.cell.addClass("e-nowrap");
                if (this._bulkEditCellDetails.cellEditType == "datetimepicker" || this._bulkEditCellDetails.cellEditType == "dropdownedit" || this._bulkEditCellDetails.cellEditType == "datepicker")
                    $element[$element.data("ejWidgets")[0]]("destroy");
                if (!ej.isNullOrUndefined(column.format)) {
                    if ((column.type == "date" || column.type == "datetime") && !ej.isNullOrUndefined(args.value))
                        (!args.isForeignKey) ? args.value = args.value.length > 0 ? new Date(args.value) : args.value : args.value.text = args.value.text.length > 0 ? new Date(args.value.text) : args.value.text;
                
                    formattedValue = this.formatting(column.format, args.isForeignKey ?
                                              (!isNaN(parseFloat(args.value.text)) && isFinite(args.value.text)
                                              ? parseFloat(args.value.text)
                                              : args.value.text) : args.value,this.model.locale);
                    args.cell.empty().html(formattedValue);
                }
                ej.createObject(this._bulkEditCellDetails["fieldName"], args.isForeignKey ? args.value.value : args.value, args.rowData);
                if (ej.isNullOrUndefined(column.format))
                    formattedValue = args.isForeignKey ? args.value.text : args.value;
                if (!ej.isNullOrUndefined(column.template)) {
                    var rowData = ej.copyObject({}, args.rowData);
                    ej.createObject(this._bulkEditCellDetails["fieldName"], args.isForeignKey ? args.value.value : args.value, rowData);
                    formattedValue = $.templates(column.template).render(rowData);
                }
                if (this._bulkEditCellDetails.cellEditType == "edittemplate") {                
                    if (args.value instanceof Array)
                        formattedValue = args.value.join();
                    args.cell.empty().html(formattedValue);
                }
                else {
                    if (args.columnObject.type == "boolean" || args.columnObject.editType == "booleanedit") {
                        var cellData = {};
                        ej.createObject(args.columnObject.field, args.value, cellData);
                        args.cell.empty().html($($.templates[this._id + "_JSONTemplate"].render(cellData))[0].cells[this._bulkEditCellDetails.columnIndex].innerHTML);						
					}
                    else if ((args.columnObject.editType == "datepicker" || args.columnObject.editType == "datetimepicker") && !ej.isNullOrUndefined(column.format))
						args.cell.empty().html(formattedValue);
                    else {
                        if (args.columnObject.disableHtmlEncode)
                            args.cell.text(formattedValue).html();
                        else
                            args.cell.empty().html(formattedValue);
                    }
                }
                args.cell.removeClass('e-validError');
                if (args.cell.hasClass('e-updatedtd'))
                    args.cell.addClass("e-gupdatenotify");
                args.previousValue = !ej.isNullOrUndefined(args.previousValue) ? (column.type == "date" || column.type == "datetime") ? new Date(args.previousValue) : args.previousValue : "";
                tempVal = args.isForeignKey ? args.value.value : args.value;
                var isValueModified = false, gridColData = this.model.editSettings.rowPosition == "bottom" && this._currentJsonData.length ==  this._bulkEditCellDetails.rowIndex ? this._currentJsonData[this._bulkEditCellDetails.rowIndex-1] : this._currentJsonData[this._bulkEditCellDetails.rowIndex] ;
                if(this._currentJsonData.length>0){
				    if ((this._bulkEditCellDetails.type == "date" || this._bulkEditCellDetails.type == "datetime") && !ej.isNullOrUndefined(this._bulkEditCellDetails.format))
				       isValueModified = this._bulkEditCellDetails.cellValue instanceof Date ? this.formatting(this._bulkEditCellDetails.format, tempVal) != this.formatting(this._bulkEditCellDetails.format, ej.getObject(args.columnName, gridColData)) : true;
                    else if (!ej.isNullOrUndefined(ej.getObject(args.columnName, gridColData)))
                       isValueModified = ((this._bulkEditCellDetails.cellEditType == "datepicker" || this._bulkEditCellDetails.cellEditType == "datetimepicker" || this._bulkEditCellDetails.cellEditType == "dropdownedit")
						  && tempVal instanceof Date && args.previousValue instanceof Date) ? (tempVal.getTime() !== ej.getObject(args.columnName, gridColData).getTime()) : (typeof (tempVal) == "number" ? tempVal !== parseFloat(ej.getObject(args.columnName, gridColData)) : typeof (tempVal) == "boolean" ? tempVal != ej.getObject(args.columnName, gridColData) : tempVal !== ej.getObject(args.columnName, gridColData).toString());
				    else
				        isValueModified = !ej.isNullOrUndefined(tempVal);
                }
				else
					isValueModified = true;
				this.model.isEdit = false;
                if (isValueModified) {
                    args.cell.addClass("e-updatedtd e-icon e-gupdatenotify");
                    this._enableSaveCancel();
                    getVal = ej.getObject(this._bulkEditCellDetails["fieldName"], args.rowData);
                    if (typeof getVal == "string" && getVal.length)
                        setVal = args.isForeignKey ? args.value.value.toString() : args.value.toString();
                    else
                        setVal = args.isForeignKey ? (!isNaN(parseInt(args.value.value)) ? parseInt(args.value.value) : args.value.value) : args.value;
                    if (typeof args.value == "string" && !setVal.length)
                        setVal = null;
                    ej.createObject(this._bulkEditCellDetails["fieldName"], setVal, args.rowData);
                    if ($.inArray(args.rowData, this.batchChanges.changed) == -1 && $.inArray(args.rowData, this.batchChanges.added) == -1)
                        this.batchChanges.changed.push(args.rowData);
					if(this.isejObservableArray){
                        var batchAction;
                        if (args.cell.closest("tr").hasClass("e-insertedrow"))
                            batchAction = "insert";
                        else
                            batchAction = "update";                                                                             
                        this._refreshViewModel(args, batchAction);
                    }
                }
                else{
                    args.cell.removeClass("e-updatedtd e-icon e-gupdatenotify");
                    this._enableSaveCancel();
                    if(this.batchChanges.changed.length >0 &&  !args.cell.hasClass("e-editedbatchcell e-updatedtd e-icon e-gupdatenotify") && !args.cell.parent().children().hasClass("e-updatedtd e-icon e-gupdatenotify")){
						for(var index = 0 ; index < this.batchChanges.changed.length; index++){
							if(args.rowData[this._primaryKeys[0]] == this.batchChanges.changed[index][this._primaryKeys[0]])
								this.batchChanges.changed.splice(index,1)
						}
					}
                }
                $targetTR.removeClass("e-editedrow").removeClass("e-batchrow");
                args.cell.removeClass("e-editedbatchcell");
            }
        },
		_refreshViewModel:function(args, batchAction){
            var dm;
            if (!(this._dataSource() instanceof ej.DataManager))
                dm = ej.DataManager(this._dataSource());
            else 
                dm = this._dataSource();
            var query = new ej.Query();
            for (var i = 0; i < this._primaryKeys.length; i++)
                query = query.where(this._primaryKeys[i], ej.FilterOperators.equal, this._primaryKeys.length ? ej.getObject(this._primaryKeys[i], args.rowData) : null);
            var currentData = dm.executeLocal(query);
            var $dataSource = this._dataSource(undefined, true);
            var index = $.inArray(currentData[0], this._dataSource());
            this.model.editSettings.showConfirmDialog = false;
            switch (batchAction) {
                case "update":                
                $dataSource(args.rowData, index, batchAction);
                break;
                case "remove":
                $dataSource(args.rowData, index, batchAction);               
                break;
                case "insert":
                $dataSource(args.rowData, 0, batchAction);                  
                break;
            }            
        },
        _enableSaveCancel: function () {
            if (this.model.toolbarSettings.showToolbar) {
                var toolbarState = this.getContentTable().find(".e-updatedtd.e-icon.e-gupdatenotify").length > 0 ||  this._isBatchDeleteApplied  ? "enableItemByID" : "disableItemByID";
                var $toolBar = this.element.find("#" + this._id + "_toolbarItems");
                $toolBar.ejToolbar(toolbarState, this._id + "_update");
                $toolBar.ejToolbar(toolbarState, this._id + "_cancel");
            }
        },
        setCellText: function (rowIndex, cellIndex, value) { /*Supports only local datasource*/
            var byField = typeof cellIndex == "string", rows = this._excludeDetailRows(), cell,
                isGrouped = this.model.groupSettings.groupedColumns.length != 0, isVirtualized = this.model.scrollSettings.allowVirtualScrolling,
                column = this[byField ? "getColumnByField" : "getColumnByIndex"](cellIndex), current = ej.getObject(["currentViewData", (isGrouped ? ".records" : "")].join(""), this.model),
                edited = {}, dm = isVirtualized ? this._dataManager : new ej.DataManager(current),
                key = this._primaryKeys[0], keyValue = byField || ej.getObject(rowIndex + "." + key, isVirtualized ? this._dataManager.dataSource.json : current),
                editedValue = value, valid = false;

            ej.createObject(column.field, value, edited);

            if (byField) {
                keyValue = rowIndex;
                rowIndex = dm.executeLocal(new ej.Query().select(key)).indexOf(rowIndex);
                cellIndex = this.getColumnIndexByField(column.field);
            }
            if (isVirtualized) {
                var pageSize = this.model.pageSettings.pageSize, page, name, mod = rowIndex % pageSize, isCached;
                page = (rowIndex + pageSize - mod)/ pageSize;        
                name = (page - 1) * pageSize; isCached = $.inArray(name, this.virtualLoadedPages) != -1
                if (isCached) {
                    cell = this.getContentTable().find("tr[name=" + name + "]")[mod].cells[cellIndex];
                }
            }

            var tr = this._excludeDetailRows()[rowIndex], proxy = this;
            if (!ej.isNullOrUndefined(column) && !column.isPrimaryKey && column.allowEditing != false) {

                if (!ej.isNullOrUndefined(column.validationRules)) {

                    var $form = ej.buildTag("form", "", {}, { id: this._id + "EditForm" }), $valElem = ej.buildTag("input", "", {}, { id: this._id + column.field, value: value, name: column.field });
                    $form.addClass("gridform");
                    $form.append($valElem);
                    this.element.append($form);
                    $form.validate({
                        errorPlacement: function (error, element) {
                            if (!proxy._alertDialog) proxy._renderAlertDialog();
                            $("#" + proxy._id + "AlertDialog_wrapper").css("min-height", "");
                            proxy._alertDialog.find(".e-content").text(error.text());
                            proxy._alertDialog.ejDialog("open");
                            proxy.element.find($form).remove();
                            valid = true;
                            return true;
                        },
                    });
                    this.setValidationToField(column.field, column.validationRules);
                }
                if (!ej.isNullOrUndefined(column.format)) {
                    var formattedValue = this.formatting(column.format, column.foreignKeyValue ?
                                                (!isNaN(parseFloat(value)) && isFinite(value)
                                                ? parseFloat(value)
                                                : value) : value, this.model.locale);
                    editedValue = formattedValue;
                }
                if (!ej.isNullOrUndefined(column.validationRules)) {
                    $($form).validate().form();
                    this.element.find($form).remove();
                }
                if (!valid) {
                    var canSkip = rowIndex == -1 || cellIndex == -1 || (isVirtualized && !isCached)
                       || rowIndex > (isVirtualized ? this._dataSource() : current).length || cellIndex > this.model.columns.length;
                    if (!canSkip) { /*Skip when not in current page*/
                        if (this.model.scrollSettings.frozenColumns)
                            cell = this._frozenCell(rowIndex, cellIndex)[0];
                        else
                            cell = cell || this._excludeDetailCells(rows[rowIndex])[cellIndex];
                        value = column.format === undefined ? value : this.formatting(column.format, value, this.model.locale);
                        if (!ej.isNullOrUndefined(column.foreignKeyField) && !ej.isNullOrUndefined(column.foreignKeyValue))
                            value = this._getForeignKeyData(edited)[column.foreignKeyField][column.foreignKeyValue];
                        if (column.disableHtmlEncode)
                            $(cell).text(value);
                        else
                            cell.innerHTML = value;
                        this._trigger("queryCellInfo", { cell: cell, text: cell.innerHTML, column: column, data: edited });
                    }
                    if (key) {
                        ej.createObject(key, keyValue, edited);
                        this._dataManager.update(key, edited);
                    }
                }
            }
        },
        _excludeDetailCells: function ($tr) {
            var $gridCells;
            if (!ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid || this.model.showSummary))
                $gridCells = $($tr.cells).not(".e-detailrowexpand, .e-detailrowcollapse");
            else
                $gridCells = $($tr.cells);
            return $gridCells;
        },
        setCellValue: function (index, fieldName, cellValue) {
            if ($("#" + this._id + "EditForm").length > 0)
                $("#" + this._id + "EditForm").attr("id", "EditForm1");
            if (this.model.editSettings.editMode == "batch" && !this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.frozenColumns) {
                var data = this.getDataByIndex(index), tr = this._excludeDetailRows()[index], dataIndex, columnIndex = this.getColumnIndexByField(fieldName), proxy = this, editedValue = cellValue, valid = false;
                var column = this.getColumnByField(fieldName), editedTd;
                if ($(tr).hasClass("e-insertedrow"))
                    editedTd = $(tr.cells).not(".e-detailrowcollapse, .e-detailrowexpand")[columnIndex + this.model.groupSettings.groupedColumns.length];
                else
                    editedTd = $(tr.cells).not(".e-detailrowcollapse, .e-detailrowexpand")[columnIndex];
                if (!ej.isNullOrUndefined(column) && !column.isPrimaryKey && column.allowEditing != false) {
                    if (!ej.isNullOrUndefined(column.validationRules)) {/*Check for validation*/
                        var $form = ej.buildTag("form", "", {}, { id: this._id + "EditForm" }), $valElem = ej.buildTag("input", "", {}, { id: this._id + column.field, value: cellValue, name: column.field });
                        $form.append($valElem);
                        this.element.append($form);
                        $form.validate({/*Validate the form*/
                            errorPlacement: function (error, element) {
                                if (!proxy._alertDialog) proxy._renderAlertDialog();
                                $("#" + proxy._id + "AlertDialog_wrapper").css("min-height", "");
                                proxy._alertDialog.find(".e-content").text(error.text());
                                proxy._alertDialog.ejDialog("open");
                                proxy.element.find($form).remove();
                                valid = true;
                                return true;
                            },
                        });
                        this.setValidationToField(column.field, column.validationRules);
                    }

                    if (column.foreignKeyValue) {
                        editedValue = this._foreignKeyBinding(columnIndex, cellValue, this._id);/*Get the corresponding foreign key value*/

                        if (editedValue == undefined) {
                            if (!this._alertDialog) this._renderAlertDialog();
                            $("#" + this._id + "AlertDialog_wrapper").css("min-height", "");
                            this._alertDialog.find(".e-content").text(this.localizedLabels.ForeignKeyAlert);
                            this._alertDialog.ejDialog("open");
                            if (!ej.isNullOrUndefined(column.validationRules)) this.element.find($form).remove();
                            return;
                        }
                    }

                    if (!ej.isNullOrUndefined(column.format)) {/*Get the formatted value*/
                        var formattedValue = this.formatting(column.format, column.foreignKeyValue ?
                                                    (!isNaN(parseFloat(cellValue)) && isFinite(cellValue)
                                                    ? parseFloat(cellValue)
                                                    : cellValue) : cellValue, this.model.locale);
                        editedValue = formattedValue;
                    }
                    


                    if (!ej.isNullOrUndefined(column.validationRules)) {
                        $($form).validate().form();
                        this.element.find($form).remove();
                    }
                    $("#EditForm1").attr("id", this._id + "EditForm");
                    if (!valid && editedTd.innerHTML != editedValue) {
                        if ($(editedTd).has("form").length > 0) this.model.isEdit = false;
                        if ($(editedTd).hasClass("e-boolrowcell"))
                            $(editedTd).find("input").attr("checked", editedValue);
                        else
                            editedTd.innerHTML = editedValue;
                        $(editedTd).addClass("e-updatedtd e-icon e-gupdatenotify");
                        $(editedTd).removeClass("e-validError e-editedbatchcell");
                        ej.createObject(fieldName, cellValue, data);
                        $.inArray(data, this.batchChanges.changed) == -1 && this.batchChanges.changed.push(data);
                        this._enableSaveCancel();
                    }
                }
            }
        },
        setDefaultData: function (defaultData) {
            if (ej.isNullOrUndefined(defaultData)) {
                var fieldNames = [];
                var columns = this.model.columns;
                for (var column = 0; column < this.model.columns.length; column++)
                    fieldNames.push(this.model.columns[column]["field"]);
                if (ej.isNullOrUndefined(this._bulkEditCellDetails._data))
                    this._bulkEditCellDetails._data = [];
                defaultData = {};
                var setter = function (field, value) { ej.createObject(field, value, defaultData) };
                for (var i = 0; i < fieldNames.length; i++) {
                    var index = i, field = fieldNames[i], columnType = columns[i].type, val = ej.getObject(field, this._bulkEditCellDetails._data[0]);
                    var isChild = !ej.isNullOrUndefined(this.model.parentDetails) ? this.model.parentDetails.parentKeyField : null;
                    if (field === isChild)
                        this.model.columns[index].defaultValue = this.model.parentDetails.parentKeyFieldValue;
                    if (!ej.isNullOrUndefined(this.model.columns[index]["defaultValue"])) {
                        setter(field, this.model.columns[index]["defaultValue"]);
                    }
                    else {
                        switch (columnType) {
                            case "number":
                                setter(field, 0);
                                break;
                            case "string":
                                setter(field, null);
                                break;
                            case "boolean":
                                setter(field, false);
                                break;
                            case "object":
                                if ($.isArray(val))
                                    setter(field, new Array());
                                else
                                    setter(field, null);
                            case "datetime":
                            case "date":
                                setter(field, null);
                        }
                    }
                }
                if (!ej.isNullOrUndefined(this.model.queryString)) {
                    var keyField = this.model.foreignKeyField || this.model.queryString;
                    defaultData[keyField] = this.model.parentDetails.parentRowData[this.model.queryString]
                }
            }
            this._bulkEditCellDetails.defaultData = defaultData;
        },
        _bulkDelete: function (index) {
            if (this.model.editSettings.allowDeleting) {
                if (ej.isNullOrUndefined(index))
                    index = this._selectedRow();
                if (index == -1) {
                    alert(this.localizedLabels.DeleteOperationAlert);
                    return;
                }
                var tr, $tr, data, args = {};
                if (this.multiDeleteMode && this.selectedRowsIndexes.length > 1) {
                    data = [];
                    $tr = this.getSelectedRows();
                    Array.prototype.push.apply(data, this.getSelectedRecords());
                    Array.prototype.push.apply(this.batchChanges.deleted, this.getSelectedRecords());
                }
                else
                    tr = this.getRows()[index], $tr = $(tr), data = this.getDataByIndex(index);
                args = {
                    primaryKey: this._primaryKeys,
                    rowIndex: index,
                    rowData: data,
                    row: $tr
                };
                if (this._trigger("beforeBatchDelete", args))
                    return;
				if(this.isejObservableArray)                   
                    this._refreshViewModel(args, "remove");
                if (this.model.isEdit)
                     this.cancelEditCell();
                if ($tr.hasClass("e-insertedrow")) {
                    $tr.remove();
                    index = $.inArray(tr, this._bulkEditCellDetails.insertedTrCollection);
                    if (index != -1) {
                        this._bulkEditCellDetails.insertedTrCollection.splice(index, 1);
                        this.batchChanges.added.splice(index, 1);
                    }
                }
                else {
                    $tr.hide();
					if(args.rowIndex == 0 || $tr.hasClass("e-firstrow")){
						$tr.hasClass("e-firstrow") && this.getContentTable().find("tr").removeClass("e-firstrow");
						this.getContentTable().find("tr:visible").first().addClass("e-firstrow");
					}
                    if (!$.isArray(data))
                        this.batchChanges.deleted.push(data);
                }
                this._gridRows = this.getContentTable().find("td.e-rowcell").closest("tr").toArray();
				if (this.model.allowScrolling)
                  this._refreshScroller(args);
			  this._isBatchDeleteApplied = true;
                this._enableSaveCancel();
                this._selectedRow(-1);
                args = {
                    primaryKey: this._primaryKeys,
                    rowIndex: index,
                    rowData: data
                };
                this._trigger("batchDelete", args);
            }
        },
        _bulkAddRow: function (defaultData) {
            var  $form = $("#" + this._id + "EditForm");
            if ($form.length && !this.editFormValidate())
                return true;
			if (this.model.editSettings.allowAdding) {
                var args = {}, $tr, editCellIndex, rows = this.getRows();
                if (!ej.isNullOrUndefined(defaultData))
                    this._bulkEditCellDetails.defaultData = defaultData;
                ej.isNullOrUndefined(this._bulkEditCellDetails.defaultData) && this.setDefaultData();
                args = {
                    defaultData: $.extend(true, {}, this._bulkEditCellDetails.defaultData),
                    primaryKey: this._primaryKeys,
                };
                if (this._trigger("beforeBatchAdd", args))
                    return;
                $tr = $($.render[this._id + "_JSONTemplate"](args.defaultData)).addClass("e-insertedrow");
                rows != null && $(rows[0]).hasClass("e-alt_row") && $tr.removeClass("e-alt_row");
                if (this.model.editSettings.rowPosition == "top")
                    this.getContentTable().first().find('tbody').first().prepend($tr);
                else if (this.model.editSettings.rowPosition == "bottom")
                    this.getContentTable().first().find('tbody').first().append($tr);
				if (this.model.allowScrolling)
                    this._refreshScroller(args);
                if (this._gridRecordsCount === 0)
                    this.getContentTable().find("tbody .emptyrecord").first().remove();
                this._gridRows = this.getContentTable().find("td.e-rowcell").closest("tr").toArray();
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                    $tr.prepend(ej.buildTag("td.e-indentcell"));
                this._bulkEditCellDetails.insertedTrCollection.push($tr.get(0));
                this.batchChanges.added.push(args.defaultData);
                var rowindex = this._gridRows.length - 1;
                if (this.model.editSettings.rowPosition == "bottom") {
                    editCellIndex = this._findNextEditableCell(0);
                    this.selectRows(rowindex);
                    this.editCell(rowindex, this.model.columns[editCellIndex].field);
                }
                else {
                    editCellIndex = this._findNextEditableCell(0);
                    this.selectRows(0);
                    this.editCell(0, this.model.columns[editCellIndex].field);
                }
                $tr.find(".e-rowcell").addClass("e-updatedtd e-icon e-gupdatenotify");
                this._enableSaveCancel();
                args = { defaultData: args.defaultData };
                $.extend(args, {
                    columnObject: this.model.columns[editCellIndex],
                    columnIndex: editCellIndex,
                    row: $tr,
                    primaryKey: this._primaryKeys,
                    cell: $($tr[0].cells[editCellIndex])
                });
                this._trigger("batchAdd", args);
            }
        },
        getDataByIndex: function (rowIndex) {
            var $tr = $(this._excludeDetailRows()[rowIndex]), insertedRowIndex, currentRowData, index;
            if ($tr.hasClass("e-insertedrow")) {
                insertedRowIndex = $.inArray($tr[0], this._bulkEditCellDetails.insertedTrCollection);
                return this.batchChanges.added[insertedRowIndex];
            }
            else
                return this._bulkEditCellDetails._data[this.model.editSettings.rowPosition == "top" ? rowIndex - this._bulkEditCellDetails.insertedTrCollection.length : rowIndex];

        },
        
        refreshBatchEditChanges: function () {
            this._bulkEditCellDetails = {
                cellValue: null,
                rowIndex: -1,
                _data: null,
                columnIndex: -1,
                fieldName: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                rowData: null,
                isForeignKey: false
            };
            this.batchChanges = {
                added: [],
                deleted: [],
                changed: []
            };
        },
        refreshBatchEditMode: function () {
            if (this.model.editSettings.editMode == "batch") {
                this.refreshBatchEditChanges();
                this._bulkEditCellDetails._data = $.extend(true, [], this.getCurrentViewData());
            }
        },
        
        batchCancel: function () {
            this.cancelEdit();
        },
        
        batchSave: function () {
            var args = {}, deferedObject, gridObject = this;
            this.saveCell();
            args["batchChanges"] = this.getBatchChanges();
            if (this._trigger("beforeBatchSave", args))
                return;
            args = {};
            args.requestType = "batchsave";
            this._sendBulkReuqest(this.getBatchChanges(), args);
        },
        _sendBulkReuqest: function (batchChanges, args) {
            var deferedObject = this._dataManager.saveChanges(batchChanges, this._primaryKeys[0], this.model.query._fromTable, this.model.query), gridObject = this;
            this._isBatchDeleteApplied=false;
			if (this._dataManager instanceof ej.DataManager && !this._dataManager.dataSource.offline) {
                deferedObject.done(function (e) {
                    gridObject._processBindings(args);
                });
                deferedObject.fail(function (e) {
                    var args = { error: e.error };
                    gridObject._trigger("actionFailure", args);
                });
            }
            else
                this._processBindings(args);

        },
        
        getBatchChanges: function () {
            return this.batchChanges;
        },
        
        editCell: function (index, fieldName) {
            if (this.element.ejWaitingPopup("model.showOnInit"))
                return;
            if (this.model.editSettings.allowEditing && $.inArray(fieldName, this._disabledEditableColumns) == -1) {
                var $form = $("#" + this._id + "EditForm");
                this.model.isEdit && this.saveCell();
                if ($.isFunction($.validator) && $form.length && $form.validate().errorList.length)
                    return;
                var $targetTR = $(this._excludeDetailRows()[index]), columnIndex = this.getColumnIndexByField(fieldName), $targetTd = $targetTR.find(".e-rowcell").eq(columnIndex), column = this.model.columns[columnIndex], rowData = this.getDataByIndex(index);
                var args = {
                    validationRules: ej.isNullOrUndefined(column.validationRules) ? {} : $.extend(true, {}, column.validationRules),
                    columnName: column.field,
                    value: ej.getObject(ej.isNullOrUndefined(fieldName) ? "" : fieldName, rowData),
                    rowData: rowData,
                    row: $targetTR,
                    primaryKey: this._primaryKeys,
                    columnObject: column,
                    cell: $targetTd,
                    isForeignKey: !ej.isNullOrUndefined(column.foreignKeyValue) && this.model.editSettings.editMode == "batch" ? true : false,
                }, isEditable = true;
                if (this.model.allowTextWrap)
                    this.element.find(".e-rowcell").removeClass("e-nowrap");
                if (this.model.allowScrolling)
                    this._refreshScroller(args);
                this._batchEditRowData = rowData;
                if (this._trigger("cellEdit", args))
                    return;
                if ($targetTR.hasClass("e-insertedrow")) args.requestType = "add";
                if ($.inArray(fieldName, this._primaryKeys) != -1 || args.columnObject.allowEditing === false || ((args.columnObject.template || args.columnObject.type=="checkbox") && (args.columnObject["allowEditing"] == false || !args.columnObject["field"])) || args.columnObject.commands) {
                    $.extend(this._bulkEditCellDetails, {
                        cellValue: args.value,
                        rowIndex: index,
                        fieldName: fieldName,
                        rowData: args.rowData,
                        columnIndex: columnIndex,
                        isForeignKey: ej.isNullOrUndefined(args.columnObject.foreignKeyValue) ? false : true
                    });
                    isEditable = false;
                }
                if ($targetTR.hasClass("e-insertedrow") && (args.columnObject.isPrimaryKey))
                    isEditable = true;
                if (isEditable) {
                    $.extend(this._bulkEditCellDetails, {
                        rowIndex: index,
                        cellValue: args.value,
                        columnIndex: columnIndex,
                        format: column.format == undefined ? null : column.format,
                        type: column.type,
                        fieldName: fieldName,
                        cellEditType: args.columnObject.editType,
                        rowData: rowData,
                        isForeignKey: ej.isNullOrUndefined(args.columnObject.foreignKeyValue) ? false : true
                    });
                    this._renderBulkEditObject(args, $targetTd);
                    $targetTR.addClass("e-editedrow").addClass("e-batchrow");
                    args.cell.addClass("e-editedbatchcell");
                    if (args.columnObject.editType == "booleanedit")
                        args.cell.addClass("e-boolrowcell");
                }
            }
        },
        _findNextEditableCell: function (columnIndex) {
            var endIndex = this.model.columns.length;
            for (var i = columnIndex; i < endIndex; i++) {
                if (!this.model.columns[i].template && !this.model.columns[i].commands && this.model.columns[i].visible)
                    return i;
            }
            return -1;
        },
        _findNextCell: function (columnIndex, direction) {
            var splittedColumn, visibleColumns = [], predicate, rows = this.getRows();
			if (this.model.columns[columnIndex].template) 
                this.model.columns[columnIndex].__isTemplate = true;  
			if(this.model.columns[columnIndex].commands)
				this.model.columns[columnIndex].__isCommand = true; 
            predicate = ej.Predicate("visible", "equal", true).and("__isTemplate", "notequal", true).and("__isCommand", "notequal", true).and("allowEditing", "notequal", false);
            splittedColumn = direction == "right" ? this.model.columns.slice(columnIndex) : this.model.columns.slice(0, columnIndex + 1).reverse();
            visibleColumns = ej.DataManager(splittedColumn).executeLocal(ej.Query().where(predicate));
            if (visibleColumns.length == 0 && (!(direction == "left" && this._bulkEditCellDetails.rowIndex == 0) && !(direction == "right" && this._bulkEditCellDetails.rowIndex + 1 == this.getRows().length))) {
                splittedColumn = direction == "right" ? this.model.columns.slice(0, columnIndex) : this.model.columns.slice(columnIndex).reverse();
                visibleColumns = ej.DataManager(splittedColumn).executeLocal(ej.Query().where(predicate));
                this._bulkEditCellDetails.rowIndex = visibleColumns.length && direction == "right" ? this._bulkEditCellDetails.rowIndex + 1 : this._bulkEditCellDetails.rowIndex - 1;
            }
            return visibleColumns.length ? $.inArray(visibleColumns[0], this.model.columns) : -1;
        },
        _moveCurrentCell: function (direction) {
            var editCellIndex, rowIndex = this._bulkEditCellDetails.rowIndex, currentRow, $form = $("#" + this._id + "EditForm");
            if (this._bulkEditCellDetails.rowIndex == -1 && this._bulkEditCellDetails.columnIndex == -1)
                return true;
            switch (direction) {
                case "right":
                    if ((this._bulkEditCellDetails.rowIndex == this.getRows().length - 1 && this._bulkEditCellDetails.columnIndex == this.model.columns.length - 1) || (!this.element.is(document.activeElement) && $form.length == 0))
                        return true;
                    if (this._bulkEditCellDetails.columnIndex == this.model.columns.length - 1) {
                        editCellIndex = 0;
                        this._bulkEditCellDetails.rowIndex = this._bulkEditCellDetails.rowIndex + 1;
                    }
                    else
                        editCellIndex = this._bulkEditCellDetails.columnIndex + 1;
                    if ((!ej.isNullOrUndefined(this.model.columns[editCellIndex].template) && ej.isNullOrUndefined(this.model.columns[editCellIndex].field)) || !ej.isNullOrUndefined(this.model.columns[editCellIndex].commands) || this.model.columns[editCellIndex].visible === false || this.model.columns[editCellIndex].allowEditing === false)
                        editCellIndex = this._findNextCell(editCellIndex, direction);
                    this._bulkEditCellDetails.rowIndex != rowIndex && this.selectRows(this._bulkEditCellDetails.rowIndex);
                    editCellIndex != -1 && this.editCell(this._bulkEditCellDetails.rowIndex, this.model.columns[editCellIndex].field);
                    break;
                case "left":
                    if ((this._bulkEditCellDetails.rowIndex == 0 && this._bulkEditCellDetails.columnIndex == 0) || (!this.element.is(document.activeElement) && $form.length == 0))
                        return true;
                    if (this._bulkEditCellDetails.columnIndex == 0) {
                        editCellIndex = this.model.columns.length - 1;
                        this._bulkEditCellDetails.rowIndex = this._bulkEditCellDetails.rowIndex - 1;
                        this.selectRows(this._bulkEditCellDetails.rowIndex);
                    }
                    else
                        editCellIndex = this._bulkEditCellDetails.columnIndex - 1;
                    if ((!ej.isNullOrUndefined(this.model.columns[editCellIndex].template) && ej.isNullOrUndefined(this.model.columns[editCellIndex].field)) || !ej.isNullOrUndefined(this.model.columns[editCellIndex].commands) || this.model.columns[editCellIndex].visible === false || this.model.columns[editCellIndex].allowEditing === false)
                        editCellIndex = this._findNextCell(editCellIndex, direction);
                    this._bulkEditCellDetails.rowIndex != rowIndex && this.selectRows(this._bulkEditCellDetails.rowIndex);
                    editCellIndex != -1 && this.editCell(this._bulkEditCellDetails.rowIndex, this.model.columns[editCellIndex].field);
                    break;
                case "up":
                    if (this._bulkEditCellDetails.rowIndex == 0)
                        return;
                    editCellIndex = this._bulkEditCellDetails.columnIndex;
                    !this._enableCheckSelect && this.selectRows(this._bulkEditCellDetails.rowIndex - 1);
                    this.editCell(this._bulkEditCellDetails.rowIndex - 1, this.model.columns[this._bulkEditCellDetails.columnIndex].field);
                    break;
                case "down":
                    if (this._bulkEditCellDetails.rowIndex == this.getRows().length - 1) {
                        this.endEdit();
                        return;
                    }
                    editCellIndex = this._bulkEditCellDetails.columnIndex;
                    !this._enableCheckSelect && this.selectRows(this._bulkEditCellDetails.rowIndex + 1);
					if(this._bulkEditCellDetails.columnIndex != -1)
						this.editCell(this._bulkEditCellDetails.rowIndex + 1, this.model.columns[this._bulkEditCellDetails.columnIndex].field);
                    break;

            }
            var addedRow = !$(this.getRows()[this._bulkEditCellDetails.rowIndex]).hasClass("e-insertedrow");
            if (editCellIndex != -1 && (this.model.columns[editCellIndex].commands || (this.model.columns[editCellIndex].isPrimaryKey && addedRow) || this.model.columns[editCellIndex].template))
                this.element.focus();
            return false;
        },
        _renderBulkEditObject: function (cellEditArgs, $td) {
            var $form = ej.buildTag("form", "", {}, { id: this._id + "EditForm" }), $bulkEditTemplate = this._bulkEditTemplate, mappingName = this._id + cellEditArgs.columnObject.field, $element, htmlString, cellData = {};
            ej.createObject(cellEditArgs.columnObject.field, cellEditArgs.value, cellData);
            var args = { requestType: cellEditArgs.requestType };
            $td.empty();
            if (!$td.parent().is(":last-child")){
                $td.addClass('e-validError');
                $td.removeClass('e-gupdatenotify');
             }
            htmlString = $bulkEditTemplate.find("#" + cellEditArgs.columnObject.field.replace(/\./g, ej.pvt.consts.complexPropertyMerge) + "_BulkEdit").html();
            $element = $($.templates(htmlString).render(cellData));
            if ($element.get(0).tagName == "SELECT") {
                var cellValue = ej.getObject(cellEditArgs.columnObject.field, cellData);
                $element.val(ej.isNullOrUndefined(cellValue) ? "" : cellValue.toString());
                $element.val() == null && $element.val($element.find("option").first().val());
                $element.data('ej-value', cellValue);
            }
            $form.append($element);
            $td.append($form);
            this._setoffsetWidth();
            this._refreshEditForm(args);
            if ($.isFunction($.validator) && !$.isEmptyObject(cellEditArgs.validationRules)) {
                this.initValidator();
                this.setValidationToField(cellEditArgs.columnObject.field, cellEditArgs.validationRules);
            }
            this.model.isEdit = true;
        },
        _triggerConfirm: function (args) {
            if (args !== undefined && args.model.text == this._getDeprecatedLocalizedLabel("OKButton")) {
                if (this._confirmDialog.find(".e-content").text() == this.localizedLabels.BatchSaveConfirm)
                    this.batchSave();
                else if (this._confirmDialog.find(".e-content").text() == this.localizedLabels.ConfirmDelete) {
                    if (this.model.editSettings.editMode == "batch")
                        this._bulkDelete()
                    else {
                        if (this.multiDeleteMode)
                            this._multiRowDelete();
                      else
                        if (!ej.isNullOrUndefined(this._cDeleteData)) {
                            this.deleteRow(this._cDeleteData);
                            this._cDeleteData = null;
                          }
                        else
                            this.deleteRow();
                    }
                }
                else if (this._confirmDialog.find(".e-content").text() == this.localizedLabels.CancelEdit)
                    this.cancelEdit();
                else {
                    this._confirmedValue = true;
                    this._processBindings(this._requestArgs);
                }
				this._isBatchDeleteApplied=false;
				this.clearSelection();
            }
            else {
                if (this._confirmDialog.find(".e-content").text() != this.localizedLabels.BatchSaveConfirm && this._confirmDialog.find(".e-content").text() != this.localizedLabels.ConfirmDelete) {
                    if (this._confirmDialog.find(".e-content").text() != this.localizedLabels.CancelEdit) {
                        switch (this._requestArgs.requestType) {
                            case "grouping":
                                this.model.groupSettings.groupedColumns.pop();
                                break;
                            case "ungrouping":
                                this.model.groupSettings.groupedColumns.push(this._requestArgs.columnName);
                                break;
                            case "sorting":
                                this._cSortedDirection = this._cSortedColumn = null;
                                break
                            case "filtering":
                                this.model.filterSettings.filteredColumns.reverse().splice(0, this._requestArgs.currentFilterObject);
                                this.model.filterSettings.filteredColumns.reverse();
                                break;
                            case "paging":
                                this._currentPage(this._requestArgs.previousPage);
                                this.getPager().ejPager("model.currentPage", this._requestArgs.previousPage);
                                break

                        }
                    }
                }
                this._confirmedValue = false;
            }
            this._requestArgs = null;
            this._confirmDialog.ejDialog("close");
        },
        _batchCellValidation:function(index) {
            var $row = this.getRowByIndex(index),i;
            if (this.model.editSettings.editMode=="batch" && this.model.isEdit && $row.hasClass('e-insertedrow') ){              
                for (i = 0; i < this._validatedColumns.length; i++) {
                      var colindex = this.getColumnIndexByField(this._validatedColumns[i])
                           if (!this.editFormValidate())
                                 return true;                         
                 this.editCell(index, this.model.columns[colindex].field);                          
                    }
               }
         },
        _saveCellHandler: function (e) {
            var $target = $(e.target);
            e.stopPropagation();
            var index=(this.model.editSettings.rowPosition == "top" || this._gridRows == null)?0:this._gridRows.length - 1;
            if ($target.closest(".e-popup").length == 0 && $target.closest(".e-rowcell").find("#" + this._id + "EditForm").length == 0) {
                if ($(this.getRows()).hasClass("e-insertedrow"))
                    this._batchCellValidation(index);
                this.saveCell();
            }
        },
        initValidator: function () {
            var gridObject = this, elements = this.model.scrollSettings.frozenColumns > 0 || this.model.editSettings.showAddNewRow ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
            for (var i = 0; i < elements.length ; i++) {
                elements.eq(i).validate({
                    ignore: ".e-hide",
                    errorClass: 'e-field-validation-error',
                    errorElement: 'div',
                    wrapper: "div",
                    errorPlacement: function (error, element) {
                        gridObject._renderValidator(error, element);
                    },

                });
            }
        },
        _renderValidator: function (error, element) {          
            if (element.is(":hidden"))
                element = element.siblings("input:visible");
            if (!element.length)
                return;
            var $td = element.closest(".e-rowcell"), $container = $(error).addClass("e-error"),
             $tail = ej.buildTag("div.e-errortail e-toparrow");
            var isScrolling = this.model.isResponsive || this.model.allowScrolling;
            var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null; var scrollTop = 0;
            $td = !$td.length ? $td = element.closest("td") : $td;
            $td.find(".e-error").remove();

            if (element.parent().hasClass("e-in-wrap"))
                $container.insertAfter(element.closest(".e-widget"));
            else
                $container.insertAfter(element);
            var doInvert = (this.model.scrollSettings.frozenRows > 0 && (this._currentTrIndex >= this.model.scrollSettings.frozenRows)) ? true : false
            var operation = doInvert ? "append" : "prepend";
            $container[operation]($tail);
           if (isScrolling && (!ej.isNullOrUndefined(scrollObj) && (scrollObj._hScrollbar || scrollObj._vScrollbar))) {
                $td.addClass("e-validError");
                scrollTop = scrollObj._hScrollbar ? scrollObj._hScrollbar.element[0].offsetTop : 0;
            }
            var heightExpected = $td[0].offsetTop + $td[0].offsetHeight + error[0].offsetHeight;
            var eleExceed = false, hScrollerSize = scrollObj && scrollObj._hScrollbar ? scrollObj._hScrollbar.model.height : 0;
            if ((scrollObj && scrollObj.isHScroll() && heightExpected > scrollTop) || (heightExpected > (this.getContent()[0].offsetTop + this.getContent().find(".e-content").height())))
                eleExceed = true;
            if (!isScrolling || !(!ej.isNullOrUndefined(scrollObj) && (scrollObj._hScrollbar || scrollObj._vScrollbar))) {
                error.width(error.width());
                element.closest(".e-validError").removeClass("e-validError");
            }
            if (this.model.enableRTL)
                this.model.editSettings.editMode != "dialog" && $container.offset({ top: element.offset().top + element.height() });
            else
                this.model.editSettings.editMode != "dialog" && $container.offset({ left: element.offset().left, top: element.offset().top + element.height() });
            if (this.model.scrollSettings.frozenRows <= 0 && $.inArray(this.model.editSettings.editMode, ["externalform", "externalformtemplate", "dialog", "dialogtemplate"]) == -1) {
                var content = this.getContent();
                var scrollContent = content.find(".e-content");
                var cntHeight = scrollContent.height();
                var contentTop = content[0].offsetTop;
                if (eleExceed && scrollObj != null && scrollObj._vScrollbar && (this.model.scrollSettings.frozenColumns)) {
                    var val = scrollObj._vScrollbar.model.value - (heightExpected - (contentTop + scrollContent[0].scrollHeight));
                    var contentScrollHeight = contentTop + scrollContent[0].scrollHeight;
                    var contentHeight = contentTop + cntHeight;
                    if ((!this.model.scrollSettings.frozenColumns && heightExpected > contentScrollHeight) || (this.model.scrollSettings.frozenColumns && heightExpected > contentHeight)) {
                        scrollObj._vScrollbar.model.maximum += (heightExpected - (contentTop + cntHeight));;
                        scrollObj._vScrollbar.refresh(true);
                    }
                    if (this.model.scrollSettings.frozenColumns) {
                        var movableContent = this.getContent().find(".e-movablecontent");
                        movableContent.height(movableContent[0].scrollHeight);
                    }
                    scrollObj.scrollY(element.offset().top - contentTop + scrollContent[0].scrollTop);
                }
                else if (eleExceed && isScrolling && scrollObj != null) {
                    if (!scrollObj.isVScroll()) {
                        var eleHeight = heightExpected - (contentTop + cntHeight);
                        scrollContent.height(cntHeight + eleHeight);
                    }
                    else if (scrollObj.isVScroll()) {
                        scrollObj.refresh();
                        this._showHideScroller();
                        if (scrollObj._vScroll) {
                            var value = scrollObj._vScrollbar.model.value + (heightExpected - (contentTop + cntHeight + hScrollerSize - hScrollerSize));
                            scrollObj.scrollY(value);
                        }
                    }
                }
            }
            else if (doInvert) {
				if(eleExceed){
					var top = $container.css('top');
					$tail.addClass("e-bottomarrow");
					$container.css({
						'bottom': top,
						'top': 'auto'
					});
				}
				else{
					$tail.prependTo($tail.parent());
				}
            }
            $container.show("slow");
        },

        setValidation: function () {
            for (var i = 0; i < this.model.columns.length; i++) {
                if (!ej.isNullOrUndefined(this.model.columns[i]["validationRules"])) {
                    this.setValidationToField(this.model.columns[i].field, this.model.columns[i].validationRules);
                }
            }
        },
        
        setValidationToField: function (name, rules) {
            var fName = name, ele;
            if (!ej.isNullOrUndefined(name))
                fName = fName.replace(/[^a-z0-9\s_]/gi, '');
            if (this.model.editSettings.editMode == "batch")
                var form = this.element.find("#" + this._id + "EditForm");
            else if(this.model.editSettings.showAddNewRow)
                var form = $(this.getRows()).hasClass("e-editedrow") ? this.element.find(".e-editedrow .gridform") : this.element.find(".e-addedrow .gridform");
            else
                var form = this.element.find(".gridform");
            ele = form.find("#" + this._id + fName).length > 0 ? form.find("#" + this._id + fName) : form.find("#" + fName);
            if (rules["regex"]) {
                rules[name + "regex"] = rules["regex"]; delete rules["regex"];
                $.validator.addMethod(fName + "regex", function (value, element, options) {
                    var ptn = options instanceof RegExp ? options : new RegExp(options);
                    return ptn.test(value);
                }, ej.getObject("messages.regex", rules) || this.getColumnByField(name).headerText + " should match the given pattern");
            }
            !ele.attr("name") && ele.attr("name", name);
            ele.rules("add", rules);
            var validator = $("#" + this._id + "EditForm").validate();
            validator.settings.messages[name] = validator.settings.messages[name] || {};
            if (!ej.isNullOrUndefined(rules["required"])) {
                if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"]))
                    var message = rules["messages"]["required"];
                else
                    var message = $.validator.messages.required;
                if (message.indexOf("This field") == 0)
                    message = message.replace("This field", this.getColumnByField(name).headerText);               
                validator.settings.messages[name]["required"] = message;
                if (ele.hasClass("e-datepicker"))
                    ele.ejDatePicker({watermarkText: ""});
            }
        },
        _renderConfirmDialog: function () {
            var $contentDiv = ej.buildTag('div.e-content', this.localizedLabels.BatchSaveConfirm)
            , $buttons = ej.buildTag('span.e-buttons', '<input type="button" class="e-flat e-btnsub" id=' + this._id + "ConfirmDialogOK" + ' value="' + this._getDeprecatedLocalizedLabel("OKButton") + '" /> '
                + "<input type='button' class='e-flat e-btncan' id=" + this._id + 'ConfirmDialogCancel' + " value='" + this.localizedLabels.CancelButton + "' />");

            this._confirmDialog = ej.buildTag('div#' + this._id + 'ConfirmDialog', { float: "left" });
            this._confirmDialog.append($contentDiv).append($buttons);
            this.element.append(this._confirmDialog);
            $buttons.find("input").ejButton({
                cssClass: this.model.cssClass,
                showRoundedCorner: true,
                size: "mini",
                click: $.proxy(this._triggerConfirm, this)
            });
            this._renderFDialog(this._id + 'ConfirmDialog');
            this._confirmDialog.ejDialog({ width: "auto",minWidth:0,minHeight:0, enableModal: true });
        },
        _unboundClickHandler: function (e) {
            var $target = $(e.target).closest("button");
            if (($target.hasClass("e-button") && ($target.hasClass("e-disable") || $target.prop("disabled"))) || $target.closest(".e-grid").attr("id") !== this._id) return;
            var $editTrLen = 0, params = {};
            if ($(e.target).hasClass("e-unboundcelldiv"))
                return;
            var index = $target.hasClass("e-savebutton") ? this.getIndexByRow($(".e-editedrow")) : this.getIndexByRow($target.closest("tr"));
            if (this.model.isEdit && (!this._isLocalData || this._isRemoteSaveAdaptor) && $target.hasClass("e-editbutton")) {
                this._unboundRow = $target.closest("tr");
                return;
            }
            var rowData = this._currentJsonData[index];
            var btnObj = $($target).ejButton("instance");
			 if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlinetemplate")
                $editTrLen = $("#" + this._id).find(".e-editedrow").length;
            this.model.allowSelection && !this.model.isEdit && this.selectRows(this.getIndexByRow($target.closest("tr")) - $editTrLen);
            if ($target.hasClass("e-cancelbutton"))
                this.model.isEdit = false;
            $.isFunction($.fn.ejDatePicker) && $("#" + this._id + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            if ($target.hasClass("e-editbutton") && this.model.editSettings.editMode != "batch") {
                if (this.model.isEdit)
                    this.cancelEdit();
                var $tr = this.getRowByIndex(index);
                this.startEdit($tr);
            } else if ($target.hasClass("e-deletebutton")) {
                var $tr = this.getRowByIndex(index);
                if (this.model.editSettings.showDeleteConfirmDialog && !this._isUnboundColumn) {
                    this._toolbarOperation(this._id + "_delete");
                    return;
                }
                this.deleteRow($tr);
            }
            else if ($target.hasClass("e-savebutton")) {
                this.endEdit();
                rowData = this._currentJsonData[index];
            }
            else if ($target.hasClass("e-cancelbutton"))
                this.cancelEdit();
            params = { rowIndex: index, data: rowData, buttonModel: btnObj.model, commandType: $target.val() };
            if (ej.raiseWebFormsServerEvents) {
                var serverArgs = { model: this.model, originalEventType: "commandButtonClick" };
                var clientArgs = params;
				if(!ej.isNullOrUndefined(this.model.serverEvents) && $.inArray("commandButtonClick",this.model.serverEvents) != -1)
                  ej.raiseWebFormsServerEvents("commandButtonClick", serverArgs, clientArgs);
            }
        },
          
        addRecord: function (data, serverChange) {
            if (this.model.editSettings.allowAdding && (this.element.find(".e-gridcontent .gridform").length == 0)) {
            if (data) {
                if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                    var $addRow = ej.buildTag('tr.e-addedrow');
                    this.getContentTable().find('tbody').first().prepend($addRow);
                }
                var args = { data: data };
                args.action = "add";
                args.selectedRow = this._selectedRow();
                this._cAddedRecord = data;
                args.requestType = ej.Grid.Actions.Save;
                this._updateAction(args);
                args.selectedRow  != -1 && this.selectRows( args.selectedRow + 1)
                if (this._isUnboundColumn)
                    this._refreshUnboundTemplate(this.getContentTable());
                if (!serverChange) {
                    if ((this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") && this.model.allowPaging && this.model.pageSettings.pageSize < this.model.currentViewData.length && this.model.groupSettings.groupedColumns.length == 0 && !this.model.editSettings.showAddNewRow)
                        this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                }
            } else
                    this._startAdd();
            }
        },
        
        updateRecord: function (keyField, data, action) {
            this._updateDeleteRecord(keyField, data, "update");
        },
        _updateDeleteRecord: function (keyField, data, action) {
            var dataMgr = ej.DataManager(this._currentJsonData), dataFilter = [], index, $row, $newrow;
            if (!ej.isNullOrUndefined(keyField))
                dataFilter = dataMgr.executeLocal(ej.Query().where(keyField, ej.FilterOperators.equal, ej.getObject(keyField,data)));
            if (dataFilter.length) {
                index = $.inArray(dataFilter[0], this._currentJsonData);
                var args = { data: data, rowData: data, requestType: ej.Grid.Actions.Save, previousData: dataFilter[0], rowIndex: index };
                var foreignKeyData = this._getForeignKeyData(args.data);
                if (!ej.isNullOrUndefined(foreignKeyData))
                    args.foreignKeyData = foreignKeyData;
                this._trigger("actionBegin", args);
                if (index != -1) {
                    $row = this.getRowByIndex(index);
                    if (action == "update") {
                        ej.copyObject(dataFilter[0], data);
                        $newrow = $($.render[this._id + "_JSONTemplate"](dataFilter));
                        $row.hasClass("e-alt_row") ? $newrow.addClass("e-alt_row") : $newrow.removeClass("e-alt_row");
                        $row.replaceWith($newrow);
                        if (this._isUnboundColumn)
                            this._refreshUnboundTemplate(this.getContentTable());
                        if (this.model.editSettings.editMode == 'batch')
                            this.batchChanges.changed.push(dataFilter[0]);
                        else {
                            var promise = this._dataManager[action](keyField, data);
                            var proxy = this;
                            if (promise && $.isFunction(promise.promise)) {
                                promise.done(function (e) {
                                    if (proxy.model.editSettings.editMode != 'batch' && (proxy.model.sortSettings.sortedColumns.length || proxy.model.summaryRows.length > 0 || proxy.model.groupSettings.groupedColumns.length || !ej.isNullOrUndefined(proxy._searchCount) || proxy.filterColumnCollection.length))
                                        proxy._processBindings(args);
                                    else
                                        proxy._trigger("actionComplete", args);
                                });
                                promise.fail(function (e) {
                                    proxy._trigger("actionFailure", args);
                                });
                            }
                            else {
                                if (proxy.model.editSettings.editMode != 'batch' && (proxy.model.sortSettings.sortedColumns.length || proxy.model.summaryRows.length > 0 || proxy.model.groupSettings.groupedColumns.length || !ej.isNullOrUndefined(proxy._searchCount) || proxy.filterColumnCollection.length))
                                    proxy._processBindings(args);
                                else
                                    proxy._trigger("actionComplete", args);
                            }
                        }
                        if (this._isMapSelection) {
                            this._selectionByGrid = true;
                            this.multiSelectCtrlRequest = true;
                            data[this._selectionMapColumn] ? this.selectRows(index) : this.clearSelection(index);
                            this._selectionByGrid = false;
                        }
                    }
                    else {
                        if ($.inArray(index, this.selectedRowsIndexes)==-1) 
                            this.selectedRowsIndexes.push(index);
                        this.deleteRow($row);
                    }
                    if (this.model.editSettings.editMode == 'batch') {
                        this.batchSave();
                        this._confirmedValue=true;
                    }
                }
            }
            else {
                if (this.model.editSettings.editMode == 'batch') {
                    this.batchChanges[action == "update" ? "changed":"deleted"].push(data);
                    this.batchSave();
                    this._confirmedValue=true;
                }
                else
                    this._dataManager[action](keyField, data);
            }
           
        },
        
        deleteRecord: function (keyField, data) {
            this._updateDeleteRecord(keyField, data, "remove");
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    "use strict"
    ej.gridFeatures.sort = {
        _addSortElementToColumn: function (field, direction) {
            var duplicateColumn = ej.DataManager(this.model.columns).executeLocal(ej.Query().where("field", "equal", field)), imageDirection;
            if (duplicateColumn.length > 1)
                var column = this.getColumnByHeaderText(this._$curSElementTarget.text());
            else
                var column = this.getColumnByField(field);
            if (ej.isNullOrUndefined(column))
                return;
            var index = $.inArray(column, this.model.columns);
            var sortcolumn = this.getsortColumnByField(field);
            var sortindex = $.inArray(sortcolumn, this.model.sortSettings.sortedColumns);
            var $headerCellDiv = this.getHeaderTable().find("thead tr:not('.e-stackedHeaderRow')").find(".e-headercell").not(".e-detailheadercell").eq(index).find(".e-headercelldiv");
            direction = ej.isNullOrUndefined(direction) ? "ascending" : direction.toLowerCase();
            $headerCellDiv.find(".e-ascending,.e-descending").remove();
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this.element.find(".e-groupdroparea").find("div[ej-mappingname='" + field + "']").find(".e-ascending,.e-descending").not(".e-ungroupbutton").remove();
            imageDirection = direction != "descending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
            var opacity = 1;
            if (this.model.allowSorting && this.model.allowMultiSorting && this.model.sortSettings.sortedColumns.length > 1) {
                for (var i = 1; i <= sortindex; i++) {
                    opacity = opacity + 1;
                }
                if ($headerCellDiv.css("text-align") == "right") {
                    $headerCellDiv.prepend(this._createSortNumber(opacity, $headerCellDiv).addClass("e-sortnumber"));
                    $headerCellDiv.append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
                }
                else {
                    $headerCellDiv.prepend(this._createSortNumber(opacity, $headerCellDiv).addClass("e-sortnumber"));
                    $headerCellDiv.append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
                }
            }
            else
                $headerCellDiv.append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this.element.find(".e-groupdroparea").find("div[ej-mappingname='" + field + "']").append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
            $headerCellDiv.parent().attr("aria-sort", direction);
        },
        _removeSortElementFromColumn: function (field) {
            var column = this.getColumnByField(field);
            var index = $.inArray(column, this.model.columns);
            var $headerCellDiv = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell").eq(index).find(".e-headercelldiv");
            $headerCellDiv.find(".e-ascending,.e-descending").remove();
            $headerCellDiv.parent().prop("aria-sort",false);
        },
        _sortCompleteAction: function (args) {
            var imageDirection, prevCol;
            prevCol = this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").find(".e-ascending,.e-descending,.e-number").parent().attr('ej-mappingname');
            this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv")
                    .find(".e-ascending,.e-descending,.e-number").remove();
            $(this.getHeaderTable().find(".e-columnheader").find(".e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell,.e-hide)")[this.getColumnIndexByField(prevCol)]).removeAttr("aria-sort");
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this.element.find(".e-groupdroparea").find("div[ej-mappingname='" + args.columnName + "']").find(".e-ascending,.e-descending,.e-number").not(".e-ungroupbutton").remove();
            this.getHeaderTable().find("[aria-sort]").prop("aria-sort",false);
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
            if (this.model.groupSettings.groupedColumns.length && this._$curSElementTarget != null) {
                var $element = this._checkEinGroupDrop($.trim(this._$curSElementTarget.attr("ej-mappingname")));
                if (!ej.isNullOrUndefined($element)) {
                    imageDirection = (ej.isNullOrUndefined(args.columnSortDirection) || args.columnSortDirection == "" ? this.getsortColumnByField(this._$curSElementTarget.attr("ej-mappingname")).direction.toLowerCase() : args.columnSortDirection) == "ascending" ? "e-rarrowup-2x" : "e-rarrowdown-2x"
                    $element.find(".e-ascending,.e-descending").removeClass().addClass("e-icon e-" + (ej.isNullOrUndefined(args.columnSortDirection) || args.columnSortDirection == "" ? this.getsortColumnByField(this._$curSElementTarget.attr("ej-mappingname")).direction.toLowerCase() : args.columnSortDirection) + " " + imageDirection);
                }
            }
            this.multiSortRequest = false;
            if (!this.model.allowScrolling || !this.initialRender || this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0)
                this.setWidthToColumns();
        },
        
        removeSortedColumns: function (fieldName) {
            if ($.isArray(fieldName)) {
                for (var i = 0; i < fieldName.length; i++) {
                    this._removeSortedColumnFromCollection(fieldName[i]);
                }
            }
            else
                this._removeSortedColumnFromCollection(fieldName);
            this.multiSortRequest = true;
            this.sortColumn(null, null);
        },
        _removeSortedColumnFromCollection: function (fieldName) {
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                if (this.model.sortSettings.sortedColumns[i].field == fieldName) {
                    this.model.sortSettings.sortedColumns.splice(i, 1);
                    break;
                }
            }
        },
        
        clearSorting: function () {
            var proxy = this;
            this.model.sortSettings.sortedColumns = $.grep(this.model.sortSettings.sortedColumns, function (value, index) {
                if ($.inArray(value.field, proxy.model.groupSettings.groupedColumns) != -1)
                    return true;
                return false;
            });
            this._$prevSElementTarget = null;
            this._$curSElementTarget = null;
            this.refreshContent();
        },
        
        sortColumn: function (columnName, columnSortDirection) {
            if (!this.model.allowSorting || $.inArray(columnName, this._disabledSortableColumns) != -1 || (columnName != null && columnName.length == 0))
                return;
            var args = {};
            if (!this.multiSortRequest) {
                var proxy = this;
                this.model.sortSettings.sortedColumns = $.grep(this.model.sortSettings.sortedColumns, function (value, index) {
                    if ($.inArray(value.field, proxy.model.groupSettings.groupedColumns) != -1)
                        return true;
                    return false;
                });
            }
            args.requestType = ej.Grid.Actions.Sorting;
            this._cSortedColumn = args.columnName = columnName;
            this._cSortedDirection = args.columnSortDirection = ej.isNullOrUndefined(columnSortDirection) ? ej.sortOrder.Ascending : columnSortDirection.toLowerCase();
            if (this._cSortedColumn !== null) {
                this._removeSortedColumnFromCollection(columnName);
                this.model.sortSettings.sortedColumns.push({ field: this._cSortedColumn, direction: this._cSortedDirection });
            }
            var returnValue = this._processBindings(args);
            if (returnValue)
                this._cSortedDirection = this._cSortedColumn = null;
            this._primaryKeyValues = [];
        },
        _createSortElement: function () {
            return ej.buildTag('span.e-icon', "&#160;");
        },
        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-gridpopup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSorting) {
                var $selElement = ej.buildTag("span.e-sortdirect e-icon");
                $content.append($selElement);
            }
            if (this.model.selectionType == "multiple") {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
        },

    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    "use strict"
    ej.gridFeatures.filter = {
        
        getFilterBar: function () {
            return this._gridFilterBar;
        },

        setGridFilterBar: function (value) {
            this._gridFilterBar = value;
        },
        
        filterColumn: function (fieldName, filterOperator, filterValue, predicate, matchcase, actualFilterValue, actualOperator) {
            if (!this.model.allowFiltering)
                return;
            var column = this.getColumnByField(fieldName), _format;
            if(!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.filterBarTemplate) && column.type == "boolean" && filterValue == "true" || filterValue == "false")
                filterValue = JSON.parse(filterValue);
            if (column && ej.isNullOrUndefined(column.format)) {
                if (column.type == "date")
                    _format = ej.preferredCulture().calendar.patterns.d; //System Date format
                else if (column.type == "datetime")
                    _format = ej.preferredCulture().calendar.patterns.f; //System DateTime format
            }
            else if(column)
                _format = column.format.replace("{0:", "").replace('}', "");
            if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.filterBarTemplate) && (column.type == "date" || column.type == "datetime") && filterValue.length > 0) {
                filterValue = ej.parseDate(filterValue, _format, this.model.locale);
            }
            var filterCollection = [];
            if (typeof (fieldName) == "object")
                filterCollection = fieldName;
            else
                filterCollection.push({ field: fieldName, operator: filterOperator, value: filterValue, predicate: predicate, matchcase: matchcase, actualFilterValue: actualFilterValue });

            for (var i = 0; i < filterCollection.length; i++) {
                var fieldName = filterCollection[i].field, filterOperator = filterCollection[i].operator,
                filterValue = filterCollection[i].value, predicate = filterCollection[i].predicate,
                matchcase = !ej.isNullOrUndefined(filterCollection[i].matchcase) ? filterCollection[i].matchcase : false, actualFilterValue = filterCollection[i].actualFilterValue;
                var args = {};
                args.requestType = ej.Grid.Actions.Filtering;
                args.currentFilterObject = [];
                this._$curFieldName = fieldName;
                if (!$.isArray(filterOperator))
                    filterOperator = $.makeArray(filterOperator);
                if (!$.isArray(filterValue))
                    filterValue = $.makeArray(filterValue);
                if (!$.isArray(predicate))
                    predicate = $.makeArray(predicate);
                var firstLoop = false;
                var filterCol = this._filterCollection;
                if (ej.util.isNullOrUndefined(this._currentFilterColumn))
                    this._currentFilterColumn = this.getColumnByField(fieldName);
                for (var index = 0; index < filterOperator.length; index++) {
                    var filterObject = {
                        field: fieldName,
                        operator: filterOperator[index],
                        value: filterValue[index],
                        matchcase: matchcase,
                        predicate: predicate[index],
                        actualFilterValue: ej.getObject("value", actualFilterValue),
                        actualOperator: ej.getObject("operator", actualFilterValue)
                    };
                    var predicated = ej.getObject("ejpredicate", actualFilterValue);
                    if (predicated)
                        filterObject = predicated;
                    if ((this._$colType == null || this.model.filterSettings.filterType == "filterbar") && !ej.isNullOrUndefined(this._currentFilterColumn))
                        this._$colType = this._currentFilterColumn.type;
                    if (this.model.filterSettings.filteredColumns.length == 0 && filterObject.value !== "") {
                        if ((this._$colType == "date" || this._$colType == "datetime") && this.model.filterSettings.filterType !== "excel" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                            this._setDateFilters(filterObject);
                        else
                            this.model.filterSettings.filteredColumns.push(filterObject);
                    } else {
                        var proxy = this;
                        if (!firstLoop) {
                            var dataManger = ej.DataManager(this.model.filterSettings.filteredColumns);
                            var query = new ej.Query().where("field", ej.FilterOperators.equal, filterObject.field);
                            var object = dataManger.executeLocal(query);
                            for (var j = 0; j < object.length; j++) {
                                var objectIndex = $.inArray(object[j], this.model.filterSettings.filteredColumns)
                                if (objectIndex != -1)
                                    this.model.filterSettings.filteredColumns.splice(objectIndex, 1);
                            }
                        }
                        if (filterObject.value !== "") {
                            if ((this._$colType == "date" || this._$colType == "datetime") && this.model.filterSettings.filterType !== "excel" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                                this._setDateFilters(filterObject);
                            else
                                this.model.filterSettings.filteredColumns.push(filterObject);
                        }
                    }
                    firstLoop = true;
                    args.currentFilterObject.push(filterObject);
                }
                args.filterCollection = this.model.filterSettings.filteredColumns;
                args.currentFilteringColumn = fieldName;
                var returnValue = this._processBindings(args);
                if (returnValue) {
                    this.model.filterSettings.filteredColumns.reverse().splice(0, filterOperator.length);
                    this.model.filterSettings.filteredColumns.reverse();
                }
                if (this.model.filterSettings.filterType == "filterbar") {
                    var filterBarCell = this.getHeaderTable().find("#" + fieldName + "_filterBarcell");
                    if (filterBarCell.val() == "" || (filterBarCell.val() != filterValue) && !this._fltrBarcell) {
                        if (filterValue[0] instanceof Date)
                            filterBarCell.val(ej.format(filterValue[0], _format, this.model.locale));
                        else
                            filterBarCell.val(filterValue[0]);
                        this._currentFilterbarValue = filterValue;
                        this.filterStatusMsg = "";
                        this._showFilterMsg();
                    }
                }
                if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.filterBarTemplate)) {
					this.filterStatusMsg = "";
					this._currentFilterbarValue = args.currentFilterObject[0].value;
					if(this._oldFilterColumn != column &&  (this.filterColumnCollection.length > 0 && $.inArray(column,this.filterColumnCollection) == -1 ))
					this.filterColumnCollection.push(column);
					this._oldFilterColumn = this._currentFilterColumn = column;
					this._showFilterMsg();
                }
                this._fltrBarcell = false;
            }
        },
        
        search: function (searchString) {
            var args = {};
            if ($("#" + this._id + "_search").find("input").val() != searchString);
                $("#" + this._id + "_search").find("input").val(searchString);
            args.requestType = ej.Grid.Actions.Search;
            args.keyValue = searchString;
            this.model.searchSettings.fields = this.model.searchSettings.fields.length != 0 ? this.model.searchSettings.fields : this.getColumnFieldNames();
            if (searchString != "" || this.model.searchSettings.key != "") {                
                this.model.searchSettings.key = searchString.toLowerCase() == this.localizedLabels.True.toLowerCase() ? "true" : searchString.toLowerCase() == this.localizedLabels.False.toLowerCase() ? "false" : searchString;
                this._processBindings(args);
            }
            this._primaryKeyValues = [];
        },
        _filterBarHandler: function (e) {
            var keycode = e.keyCode, $target = $(e.target);
            if ($target.closest(".e-grid").attr("id") !== this._id)
                return;
            if ((this.model.filterSettings["filterBarMode"] == "immediate" || keycode == 13) && keycode != 9) {
                var $target = $(e.target);
                this.filterStatusMsg = "";
                var fieldName = $target.prop("id").replace("_filterBarcell", "");
                var column;
                for (var k = 0; k < this.model.columns.length; k++) {
                    if (!ej.isNullOrUndefined(this.model.columns[k].foreignKeyValue) && fieldName.indexOf("_" + this.model.columns[k].foreignKeyValue) != -1) {
                        column = this.model.columns[k];
                        break;
                    }
                    else
                        if (this.model.columns[k].field == fieldName) {
                            column = this.model.columns[k];
                            break;
                        }
                }
                if (column == null)
                    return;
                this._currentFilterColumn = column;
                this._$curFieldName = column.field;
                if (this._currentFilterColumn != this._oldFilterColumn)
                    this.filterValueOldLength = 0;				
                this._currentFilterbarValue = $target.val().toLowerCase() == this.localizedLabels.True.toLowerCase() ? "true" : $target.val().toLowerCase() == this.localizedLabels.False.toLowerCase() ? "false" : $target.val();
                this.filterValueCurrentLength = this._currentFilterbarValue.length;
                if (((this.filterValueCurrentLength == 0 && this.filterValueOldLength == 0) || this._currentFilterbarValue == this.OldfilterValue) && this._currentFilterColumn == this._oldFilterColumn && !this.model.scrollSettings.enableVirtualization) {
                    this._showFilterMsg();
                    return;
                }
                this._skipFilterProcess = this._checkForSkipInput();
                if (!this._skipFilterProcess) {
                    this._processFilter(e);
                } else {
                    if (this._currentFilterColumn.type == "string") {
                        this.filterStatusMsg = "Invalid Filter Data";
                        this._showFilterMsg();
                    } else {
                        this._skipFilterProcess = false;
						if(!this.model.scrollSettings.enableVirtualization)
							this._showFilterMsg();
                        return;
                    }
                }
            }
        },
        _renderResponsiveFilter: function () {
            var $outerDiv = ej.buildTag('div#responsiveFilter.resFilterDiv', '', { 'width': '100%', 'padding': '0px' });
            var height = $(window).height() + 1;
            var headerHieght = height * (8 / 100);
            var width = this.element.height() > height ? $(window).width() + 16.5 : $(window).width();
            var $columnDiv = ej.buildTag('div.columnDiv', '', { width: '100%' });
            for (var i = 0; i < this.model.columns.length; i++) {
                var $cDiv = ej.buildTag('div.e-responsivefilterColDiv', '', { width: '100%' }, { 'ej-MappingName': this.model.columns[i].field });
                var $span = ej.buildTag('span', this.model.columns[i].headerText, { 'margin-left': '4%' });
                $cDiv.append($span);
                $columnDiv.append($cDiv);
            }
            $outerDiv.append($columnDiv);
            this.element.append($outerDiv);
            var gridObj = this;
            var widt = this.element.outerWidth();
            var $headerDiv = ej.buildTag('div.e-resFilterDialogHeaderDiv', '', { 'height': headerHieght });
            var $span = ej.buildTag('div.labelRes', '<span>Filter</span>');
            var $resIcon = ej.buildTag('div.e-resFilterleftIcon', '', { 'margin-top': '3%' });
            var $resspan = ej.buildTag('span.e-icon e-responsiveFilterClear e-resIcon', '', { 'font-size': '23px' });
            var $divIcon = ej.buildTag('div.e-resFIlterRigthIcon', '', { 'float': 'right', 'margin-top': '3%' }, { closeDialogue: 'responsiveFilter', gridEle: true });
            var $spanIcon = ej.buildTag('span.e-icon e-responisveClose e-resIcon', '', { 'font-size': '23px' }, { closeDialogue: 'responsiveFilter', gridEle: true });
            $divIcon.click(function (e) {
                $("#responsiveFilter").css('display', 'none');
                gridObj.element.css('display', 'block');
            });
            $resIcon.click(function (e) {
                $("#responsiveFilter").find('.e-responsivefilterColDiv').find('.e-filternone').click();
            });
            $headerDiv.append($resIcon.append($resspan));
            $headerDiv.append($span).append($divIcon.append($spanIcon));
            $outerDiv.prepend($headerDiv);
            $outerDiv.insertAfter(this.element);
            $(".resFilterDiv").on('keydown', $.proxy(this._responsiveDialogueKeyUp, this))
            $outerDiv.css('display', 'none');
            $(".e-responsivefilterColDiv").on('click', $.proxy(this._mouseClickHandler, this));
        },
        _closeDivIcon: function (sender) {
            var $div = $(sender.target);
            if (!ej.isNullOrUndefined($div.attr('closeDialogue'))) {
                var $dialog = $("#" + $div.attr('closeDialogue'));
                if (!ej.isNullOrUndefined($dialog.data('ejDialog')))
                    $dialog.ejDialog('close');
                else
                    $dialog.css('display', 'none');
            }
            if (!ej.isNullOrUndefined($div.attr('gridEle'))) {
                this.element.css('display', 'block');
            }
            if (!ej.isNullOrUndefined($div.attr('openDialogue'))) {
                if (this.model.enableResponsiveRow || $div.attr('closeDialogue').indexOf('Custom') != -1) {
                    var $dialog = $("#" + $div.attr('openDialogue'));
                    if (!ej.isNullOrUndefined($dialog.data('ejDialog')))
                        $dialog.ejDialog('open');
                    else
                        $dialog.css('display', 'block');
                }
                else
                    this.element.css('display', 'block');
            }
        },
        _setResponsiveFilterIcon: function () {
            var $div = $("#responsiveFilter").find('.columnDiv'), $proxy = this;
            $div.find('.e-filtericon').remove();
            for (var i = 0; i < this.model.filterSettings.filteredColumns.length; i++) {
                var column = this.model.filterSettings.filteredColumns[i];
                var $selcDiv = $div.find('.e-responsivefilterColDiv[ej-MappingName=' + column.field + ']');
                var $divIcon = ej.buildTag('div.e-filtericon e-icon e-resIcon e-filterset e-filternone e-filterreset', '', { float: 'right', height: '22px', width: '21px', 'font-size': '20px', 'margin-right': '3%', 'margin-top': '2%' });
                var $iconSapn = ej.buildTag('span.e-filtericon e-icon e-resIcon e-filterset e-filternone', '', {}, { 'colType': column.type });
                $selcDiv.find('.e-filternone').remove();
                $selcDiv.append($divIcon);
                $iconSapn.click(function (e) {
                    var $target = e.target;
                    $proxy._$colType = $target.attr('colType');
                    $proxy._fltrClrHandler();
                    $target.remove();
                })
            }
        },
        _renderExcelFilter: function () {
            var filterCol = this.model.filterSettings.filteredColumns.length != 0 ? this.model.filterSettings.filteredColumns[0].field : null;
            var model = {
                instance: this,
                showSortOptions: this.model.allowSorting,
                allowFormatFiltering: this.model.filterSettings.allowFormatFiltering,
                allowCaseSensitive: this.model.filterSettings.enableCaseSensitivity,
                maxFilterLimit: this.model.filterSettings.maxFilterChoices,
                interDeterminateState: this.model.filterSettings.enableInterDeterminateState,
                enableComplexBlankFilter: this.model.filterSettings.enableComplexBlankFilter,
                blankValue: this.model.filterSettings.blankValue,
                filterHandler: ej.proxy(this._filterHandler, this),
                initFilterCol: filterCol,
                actionBegin: "actionBegin",
                actionComplete: "actionComplete"
            };
            this._excelFilter = new ej.excelFilter(model);
            $.extend(this._excelFilter, this.model.filterSettings);
        },
        _filterHandler: function (args) {
            var arg = {}, fQMgr;
            arg.requestType = args.action == "sorting" ? args.action : "filtering";
            var temp = this.model.filterSettings.filteredColumns;
            if (args.action == "filtering") {
                fQMgr = ej.DataManager(this.model.filterSettings.filteredColumns);
                var query = new ej.Query().where("field", ej.FilterOperators.equal, args.fieldName);
                var object = fQMgr.executeLocal(query);
                for (var i = 0; i < object.length; i++) {
                    var objectIndex = $.inArray(object[i], this.model.filterSettings.filteredColumns)
                    if (objectIndex != -1)
                        this.model.filterSettings.filteredColumns.splice(objectIndex, 1);
                }
                ej.merge(this.model.filterSettings.filteredColumns, args.filterCollection);
                args.currentFilterCollection = args.filterCollection;
            }
            else if (args.action == "clearfiltering") {
                var filterObj = args.filterDetails;
                delete this._excelFilter._predicates[0][args.fieldName];
                this.filterColumn(filterObj.field, filterObj.operator, filterObj.value, filterObj.predicate);
                for (var i = 0; i < this.filterColumnCollection.length; i++) {
                    if (this.filterColumnCollection[i].field == filterObj.field)
                        this.filterColumnCollection.splice(i, 1);
                }
                return;
            }
            else if (args.action == "sorting") {
                var sortObj = args.sortDetails;
                if (ej.gridFeatures.sort)
                    this.sortColumn(sortObj.field, sortObj.direction);
                this._excelFilter.closeXFDialog();
                return;
            }

            arg.currentFilteringColumn = args.fieldName;
            arg.predicated = args.ejpredicate;
            var returnValue = this._processBindings(arg);
            if (returnValue)
                this.model.filterSettings.filteredColumns = temp;
        },
        _renderFiltering: function () {
            var $headerTable = this.getHeaderTable(),args,temp;
            var $tr = ej.buildTag('tr.e-filterbar'), $trClone, filteredFields = [],$input;
            if (this.model.detailsTemplate || this.model.childGrid) $tr.append(ej.buildTag('th.e-filterbarcell e-mastercell'));
            for (var column = 0; column < this.model.columns.length; column++) {
                var $th = ej.buildTag('th.e-filterbarcell'), $div = ej.buildTag('div.e-filterdiv'), $span = ej.buildTag('span.e-cancel e-icon e-hide');
                var fltrField = ej.isNullOrUndefined(this.model.columns[column]["field"]) ? this.model.columns[column]["field"] : this.model.columns[column].field.replace(/[^a-z0-9|s_]/gi, ''), fltrId = ej.isNullOrUndefined(this.model.columns[column]["foreignKeyValue"]) ? fltrField + "_filterBarcell" : fltrField + "_" + this.model.columns[column]["foreignKeyValue"] + "_filterBarcell";
                if (this.model.columns[column]["allowFiltering"] != false && !ej.isNullOrUndefined(this.model.columns[column].filterBarTemplate) && !ej.isNullOrUndefined(this.model.columns[column]["field"])) {
                    $th.addClass('e-fltrtemp');
                    $div.addClass('e-fltrtempdiv');
                    if (ej.isNullOrUndefined(this.model.columns[column].filterBarTemplate.create)) {
                        $input = ej.buildTag('input e-filtertext', "", {}, { title: this.model.columns[column]["headerText"] + this.localizedLabels.FilterbarTitle, id: fltrId, "class": "e-filterUi_input e-filtertext e-fltrTemp" });
                    }
                    else {
                        args = { columnIndex: column, column: this.model.columns[column] }
                        temp = this.model.columns[column].filterBarTemplate.create;
                        if (typeof temp == "string")
                            temp = ej.util.getObject(temp, window);
                        $input = temp(args)
                        $input = $($input).attr({ title: this.model.columns[column]["headerText"] + this.localizedLabels.FilterbarTitle, id: fltrId, "class": "e-filterUi_input e-filtertext e-fltrTemp" });
                    }
                }
                else{
                    $div.addClass('e-fltrinputdiv');
                    var fltrField = this.model.columns[column]["field"], fltrId = ej.isNullOrUndefined(this.model.columns[column]["foreignKeyValue"]) ? fltrField + "_filterBarcell" : fltrField + "_" + this.model.columns[column]["foreignKeyValue"] + "_filterBarcell";
                    $input = ej.buildTag('input.e-ejinputtext e-filtertext', "", {}, { title: this.model.columns[column]["headerText"] + this.localizedLabels.FilterbarTitle, type: "search", id: fltrId });
				}
                if (this.model.filterSettings.filteredColumns.length > 0 && this.model.filterSettings.filterType == "filterbar" && $.inArray(this.model.columns[column].field, filteredFields) == -1) {
                    for (var fColumn = 0; fColumn < this.model.filterSettings.filteredColumns.length; fColumn++) {
                        if (this.getColumnIndexByField(this.model.filterSettings.filteredColumns[fColumn].field) == column) {
                            if (this.model.filterSettings.filteredColumns[fColumn].operator == "greaterthan")
                                $input.val(">" + this.model.filterSettings.filteredColumns[fColumn].value);
                            else if (this.model.filterSettings.filteredColumns[fColumn].operator == "lessthan")
                                $input.val("<" + this.model.filterSettings.filteredColumns[fColumn].value);
                            else if (this.model.filterSettings.filteredColumns[fColumn].operator == "notequal")
                                $input.val("!=" + this.model.filterSettings.filteredColumns[fColumn].value);
                            else
                                $input.val(this.model.filterSettings.filteredColumns[fColumn].value);
                            if ($.inArray(this.model.filterSettings.filteredColumns[fColumn].field, filteredFields) == -1) filteredFields.push(this.model.filterSettings.filteredColumns[fColumn].field);
                        }
                    }
                }
                if (this.model.columns[column]["allowFiltering"] === false || this.model.columns[column]["field"] == "" || ej.isNullOrUndefined(this.model.columns[column]["field"])) {
                    $input.attr("disabled", true).addClass("e-disable");
                    this._disabledFilterableColumns.push(this.model.columns[column]["headerText"]);
                }
                this.model.columns[column]["visible"] === false && $th.addClass("e-hide");
                !ej.isNullOrUndefined(this.model.columns[column]["cssClass"]) && $th.addClass(this.model.columns[column]["cssClass"]);
                if (this.model.columns[column]["allowFiltering"] != false && !ej.isNullOrUndefined(this.model.columns[column].filterBarTemplate))
                    $div.append($input);
                else
                $div.append($input).append($span);
                $tr.append($th.append($div));
                if (column == this.model.scrollSettings.frozenColumns - 1) {
                    $trClone = $tr.clone();
                    $headerTable.find("thead").first().append($trClone);
                    $tr.empty();
                }
            }
            $headerTable.find("thead").last().append($tr);
			if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10) {
                var filterBarCell = $headerTable.find("thead").find(".e-ejinputtext.e-filtertext");
                for (var cell = 0; cell < filterBarCell.length; cell++)
                    ej.ieClearRemover(filterBarCell[cell]);
            }
            this.setGridFilterBar($tr);
        },
        _renderFilterBarTemplate: function () {
            var args, temp1, temp2,flag = false;
            for (var count = 0 ; count < this.model.columns.length; count++) {
                if (this.model.columns[count]["allowFiltering"] != false && !ej.isNullOrUndefined(this.model.columns[count].filterBarTemplate) && !ej.isNullOrUndefined(this.model.columns[count]["field"])) {
                    temp1 = this.model.columns[count].filterBarTemplate.read;
                    if (typeof temp1 == "string")
                        temp1 = ej.util.getObject(temp1, window);
                    if (this.model.columns[count].foreignKeyField)
                        args = { element: this.getHeaderTable().find('.e-filterbar').find('.e-fltrtemp').find("#" + this.model.columns[count].field.replace(/[^a-z0-9|s_]/gi, '') + "_" + this.model.columns[count].foreignKeyValue.replace(/[^a-z0-9|s_]/gi, '') + "_filterBarcell"), columnIndex: count, column: this.model.columns[count] }
                    else
                        args = { element: this.getHeaderTable().find('.e-filterbar').find('.e-fltrtemp').find("#" + this.model.columns[count].field.replace(/[^a-z0-9|s_]/gi, '') + "_filterBarcell"), columnIndex: count, column: this.model.columns[count] }
                    if (typeof args.column.filterBarTemplate.read == "string")
                        args.column.filterBarTemplate.read = temp1;
                    temp2 = this.model.columns[count].filterBarTemplate.write;
                    if (typeof temp2 == "string")
                        temp2 = ej.util.getObject(temp2, window);
                    if(this.model.filterSettings.filteredColumns.length >0){
                        for(var index =0 ; index< this.model.filterSettings.filteredColumns.length; index++){
                            if(this.model.columns[count].field == this.model.filterSettings.filteredColumns[index].field)
                            args.modelVal = this.model.filterSettings.filteredColumns[index].value;
                        }
                    }
                    temp2.call(this, args);
					flag = true
                }
            }
			if(flag)
            this.model.filterSettings.filterBarMode = ej.Grid.FilterBarMode.OnEnter;
        },
        _closeFilterDlg: function () {
            if (!ej.isNullOrUndefined($("#" + this._id + "_" + this._$colType + "Dlg").data('ejDialog')))
                $("#" + this._id + "_" + this._$colType + "Dlg").ejDialog('close');
            else
                $("#" + this._id + "_" + this._$colType + "Dlg").css('display', 'none');
            this._$fDlgIsOpen = false;
            this._$menuDlgIsOpen = false;
        },
        _filterBarClose: function (e) {
            var $target = $(e.target);
            if ($target.closest(".e-grid").attr("id") !== this._id)
                return;
            if (e.type == "click" && $target.hasClass("e-cancel")) {
                var $targetText = $target.prev();
                $targetText.focus().val("");
                $targetText.trigger("keyup");
                e.stopPropagation();
            }
            if (e.type == "focusin" && $target.hasClass("e-filtertext")) {
                $target = $(e.target).next();
                this.getFilterBar().find(".e-cancel").addClass("e-hide");
                $target.removeClass("e-hide");
            }
        },
        _processFilter: function (e) {
            if (!this._alreadyFilterProcessed) {
                this._alreadyFilterProcessed = true;
                this._startTimer(e);
            } else {
                this._stopTimer();
                this._startTimer(e);
            }
        },
        _startTimer: function (e) {
            var proxy = this;
            var delay = e.keyCode == 13 ? 0 : proxy.model.filterSettings.immediateModeDelay;
            this._timer = window.setTimeout(
                function () {
                    proxy._onTimerTick();
                },
                delay);
        },
        _stopTimer: function () {
            if (this._timer != null)
                window.clearTimeout(this._timer);
        },

        _onTimerTick: function () {
            this.OldfilterValue = this._currentFilterbarValue;
            this._oldFilterColumn = this._currentFilterColumn;
            this.filterValueOldLength = this.filterValueCurrentLength;
            this._findPredicate();
            var result = null;
            var matchcase = this._currentFilterColumn.type == "string" ? false : true;            
            var collection = $.extend([], this.model.filterSettings.filteredColumns);
            for (var i = 0; i < collection.length; i++) {
                if (this.getHeaderContent().find(".e-filterbar #" + collection[i].field + "_filterBarcell").val() == "") {
                        if ($.inArray(this.model.filterSettings.filteredColumns[i], this.filterColumnCollection) != -1)
                            this.filterColumnCollection.splice(i, 1);
                        this.model.filterSettings.filteredColumns.splice(i, 1);
                }
            }
			if (this._currentFilterColumn.type == "date" || this._currentFilterColumn.type == "datetime") {
                for (var j = 0; j < this.model.filterSettings.filteredColumns.length; j++) {
                    if (this.model.filterSettings.filteredColumns[j].isComplex) {
                        var preobject = this.model.filterSettings.filteredColumns[j].predicates;
                        if (this.model.filterSettings.filteredColumns.length == 1) {
                           this.model.filterSettings.filteredColumns = preobject;
                        }
                        else {
                            this.model.filterSettings.filteredColumns[j] = preobject[0];
                            this.model.filterSettings.filteredColumns.push(preobject[1]);
                        }
                    }
                }
            }
            if (!this._skipFilterProcess) {
                if (this._currentFilterColumn.foreignKeyValue && this._currentFilterColumn.dataSource && this._currentFilterbarValue != "")
                    this._fltrForeignKeyValue(this._operator, this._currentFilterbarValue, matchcase,
                                              this._currentFilterColumn.dataSource, this._currentFilterColumn.foreignKeyField,
                                              this._currentFilterColumn.foreignKeyValue, this._currentFilterColumn.type);
                else{
                    if (ej.isNullOrUndefined(this._currentFilterColumn.filterBarTemplate)) {
                        this._fltrBarcell = true;
                        this.filterColumn(this._currentFilterColumn.field, this._operator, this._currentFilterbarValue, this._predicate, matchcase);
                    }
                }
            }
            else
                this.filterStatusMsg = "Invalid Filter Data";
            if(!this.model.scrollSettings.enableVirtualization && ej.isNullOrUndefined(this._currentFilterColumn.filterBarTemplate))
				this._showFilterMsg();
            this._stopTimer();
        },

        _findPredicate: function () {
            var _value = this._currentFilterbarValue.replace(/ && /i, " and ").replace(" || ", " or ");
            var _predicateFinder = _value.split(' ');
            this._predicate = "and";
            if (_predicateFinder.length != 0) {
                if ($.isFunction(ej.Predicate[_predicateFinder[1]])) {
                    this._skipFilterProcess = false;
                    this._predicate = _predicateFinder[1];
                    var valuesArray = _value.split(" " + _predicateFinder[1] + " ");
                    var tempOperator = [];
                    var filterValues = [];
                    for (var i = 0; i < valuesArray.length; i++) {
                        this._validateFilterValue(valuesArray[i]);
                        tempOperator.push(this._operator);
                        if (this._currentFilterColumn.type == "number")
                            filterValues.push(this._currentFilterbarValue);
                        else if (this._currentFilterColumn.type == "string")
                            filterValues.push(valuesArray[i]);
                    }
                    this._currentFilterbarValue = filterValues;
                    this._operator = tempOperator;
                } else
                    this._validateFilterValue($.trim(this._currentFilterbarValue));
            } else
                this._validateFilterValue($.trim(this._currentFilterbarValue));
        },

        _validateFilterValue: function (_value) {
            switch (this._currentFilterColumn.type) {
                case "number":
                    this._operator = ej.FilterOperators.equal;
                    var stringSkipInput = new Array(">", "<", "=", "!");
                    for (var i = 0; i < _value.length; i++) {
                        if (jQuery.inArray(_value[i], stringSkipInput) != -1) {
                            break;
                        }
                    }
                    if (i != _value.length) {
                        this._getOperator(_value.substring(i));
                        if (i != 0)
                            this._currentFilterbarValue = _value.substring(0, i);
                    }
                    if (this._currentFilterbarValue != "" && _value.length >= 1)
                        this._currentFilterbarValue = ej.parseFloat(this._currentFilterbarValue, this.model.locale);
                    else
                        this._currentFilterbarValue = _value.length > 1 ? ej.parseFloat(_value, this.model.locale) : _value;
                    break;
                case "date":
                case "datetime":
                    this._operator = ej.FilterOperators.equal;
                    this._getOperator(_value);
                    var _format;
                    if (ej.isNullOrUndefined(this._currentFilterColumn.format)) {
                        if (this._currentFilterColumn.type == "date")
                            _format = ej.preferredCulture().calendar.patterns.d; //System Date format
                        else
                            _format = ej.preferredCulture().calendar.patterns.f; //System DateTime format
                    }
                    else
                        _format = this._currentFilterColumn.format.replace("{0:","").replace('}', "");
                    if (this._currentFilterbarValue != "") {
                        var filterbarValue = ej.parseDate(this._currentFilterbarValue, _format, this.model.locale);
                        if (!ej.isNullOrUndefined(filterbarValue))
                            this._currentFilterbarValue = ej.parseDate(this._currentFilterbarValue, _format, this.model.locale);
                        else
                            this.filterStatusMsg = "Invalid Filter Data";
                    }
                    break;
                case "string":
                    if (_value.charAt(0) == '*') {
                        this._currentFilterbarValue = this._currentFilterbarValue.slice(1);
                        this._operator = ej.FilterOperators.startsWith;
                    }
                    else if (_value.charAt(_value.length - 1) == '%') {
                        this._currentFilterbarValue = this._currentFilterbarValue.slice(0, -1);
                        this._operator = ej.FilterOperators.startsWith;
                    }
                    else if (_value.charAt(0) == '%') {
                        this._currentFilterbarValue = this._currentFilterbarValue.slice(1);
                        this._operator = ej.FilterOperators.endsWith;
                    }
                    else
                        this._operator = ej.FilterOperators.startsWith;
                    break;
                case "boolean":
                case "checkbox":
                    if (this._currentFilterbarValue.toLowerCase() == "true" || this._currentFilterbarValue == "1")
                        this._currentFilterbarValue = true;
                    else if (this._currentFilterbarValue.toLowerCase() == "false" || this._currentFilterbarValue == "0")
                        this._currentFilterbarValue = false;
                    this._operator = ej.FilterOperators.equal;
                    break;
                default:
                    this._operator = ej.FilterOperators.equal;
            }
        },
        _getOperator: function (_value) {
            if (_value.charAt(0) == "=") {
                this._operator = ej.FilterOperators.equal;
                this._currentFilterbarValue = _value.substring(1);
            }
            if (ej.data.operatorSymbols[_value.charAt(0)] !== undefined || ej.data.operatorSymbols[_value.slice(0, 2)] !== undefined) {
                this._operator = ej.data.operatorSymbols[_value.charAt(0)];
                this._currentFilterbarValue = _value.substring(1);
                if (this._operator === undefined) {
                    this._operator = ej.data.operatorSymbols[_value.slice(0, 2)];
                    this._currentFilterbarValue = _value.substring(2);
                }
            }
            if (this._operator == ej.FilterOperators.lessThan || this._operator == ej.FilterOperators.greaterThan) {
                if (this._currentFilterbarValue.charAt(0) == "=") {
                    this._operator = this._operator + "orequal";
                    this._currentFilterbarValue = this._currentFilterbarValue.substring(1);
                }
            }

        },

        _checkForSkipInput: function () {
            var isSkip = false;
            var skipInput = new Array("=", " ", "!");
            var context = this;
            if (this._currentFilterColumn.type == "number") {
                if (ej.data.operatorSymbols[this._currentFilterbarValue] !== undefined || $.inArray(this._currentFilterbarValue, skipInput) != -1)
                    isSkip = true;
            }
            if (this._currentFilterColumn.type == "string") {
                var stringSkipInput = new Array(">", "<", "=", "!");
                for (var i = 0; i < this._currentFilterbarValue.length; i++) {
                    if ($.inArray(this._currentFilterbarValue[i], stringSkipInput) != -1)
                        isSkip = true;
                }
            }
            return isSkip;
        },
        _showFilterMsg: function () {
            var index = $.inArray(this._currentFilterColumn, this.filterColumnCollection);
            if (this._currentFilterbarValue !== "" && index == -1)
                this.filterColumnCollection.push(this._currentFilterColumn);
            if (this._currentFilterbarValue === "" && index != -1) {
                this.filterColumnCollection.splice(index, 1);
            }
            if ((!this._skipFilterProcess || this.filterColumnCollection.length > 0) && this.filterStatusMsg != "Invalid Filter Data") {
                for (var index = 0; index < this.filterColumnCollection.length; index++) {
                    if (!ej.isNullOrUndefined(this.filterColumnCollection[index])) {
                        var val, filterColumnName, hTxt = this.filterColumnCollection[index].headerText;
                        if (this.filterColumnCollection[index].disableHtmlEncode)
                            hTxt = this._htmlEscape(hTxt);
                        if (this.filterColumnCollection[index].field.indexOf('.') != -1) {
                            var spltClmn = (this.filterColumnCollection[index].field).split(".");
                            filterColumnName = spltClmn.join("\\.");
                            val = $("#" + filterColumnName + "_filterBarcell").val();
                        }
                        else {
                            var fltrId = ej.isNullOrUndefined(this.filterColumnCollection[index]["foreignKeyValue"]) ? this.filterColumnCollection[index].field + "_filterBarcell" : this.filterColumnCollection[index].field + "_" + this.filterColumnCollection[index]["foreignKeyValue"] + "_filterBarcell";
                            if (this._currentFilterColumn.type == "boolean" && !ej.isNullOrUndefined(this._currentFilterColumn.filterBarTemplate) && this.element.find("#" + fltrId).hasClass('e-checkbox e-js'))
                                val = this.element.find("#" + fltrId).parent().attr('aria-checked');
                            else
                                val = this.element.find("#" + fltrId).val();
                        }
                        if (val != "") {
                            if (index > 0 && this.filterStatusMsg != "")
                                this.filterStatusMsg += " && ";
                            this.filterStatusMsg += hTxt + ": " + val;
                        }
                    }
                }
            }

            if (this.model.allowPaging)
                this.getPager().ejPager("model.externalMessage", this.filterStatusMsg);
            else {
                if (this.model.scrollSettings.allowVirtualScrolling)
                    this.$pagerStatusBarDiv.find(".e-pagerfiltermsg").html(this.filterStatusMsg).css("display", "block");
                else
                    this.$pagerStatusBarDiv.find("div").html(this.filterStatusMsg);
                if (this.filterStatusMsg.length)
                    this.$pagerStatusBarDiv.css("display", "block");
                else
                    this.model.scrollSettings.allowVirtualScrolling ? this.$pagerStatusBarDiv.find(".e-pagerfiltermsg").hide() : this.$pagerStatusBarDiv.hide();
            }
            if (this.filterStatusMsg == "Invalid Filter Data") {
                index = $.inArray(this._currentFilterColumn, this.filterColumnCollection);
                this.filterColumnCollection.splice(index, 1);
            }
            this.filterStatusMsg = "";
        },
        _renderFilterDialogs: function () {
            var $strDlg, $numDlg, $boolDlg, $dateDlg, $datetimeDlg,$guidDlg;

            $.each(this.model.columns, ej.proxy(function (indx, col) {
                if (col.type == "string" && (!$strDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $strDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "guid" && (!$guidDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $guidDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "number" && (!$numDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $numDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "date" && (!$dateDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $dateDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "datetime" && (!$datetimeDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $datetimeDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "boolean" && (!$boolDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $boolDlg = true;
                    this._renderFilters(col);
                }
            }, this));
        },
        _renderFilters: function (col) {
            if ((this._isExcelFilter && col.filterType != "menu") || col.filterType == "excel") {
                if (ej.isNullOrUndefined(this._excelFilter)) {
                    this._renderExcelFilter();
                    this._excelFilterRendered = true;
                }
                this._excelFilter.renderDialog(col.type);
            }
            else
                eval(this["_render" + col.type.substring(0, 1).toUpperCase() + col.type.substring(1) + "Dialog"](col));
        },
        _renderStringDialog: function () {
            var $id = this._id + "_stringDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "string");
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderBooleanDialog: function () {
            var $id = this._id + "_booleanDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "boolean");
            if (!this.model.isResponsive || !this._mediaStatus) {
                this._renderFDialog($id);
                if (!this.model.filterSettings.showPredicate)
                    $("#" + $id).ejDialog({ minHeight: 90, width: "100%" });
                else
                    $("#" + $id).ejDialog({ minHeight: 136, width: "100%" });
            }
        },
		 _renderGuidDialog: function () {
            var $id = this._id + "_guidDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "guid");
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderNumberDialog: function () {
            var $id = this._id + "_numberDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "number");
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderDateDialog: function (col) {
            var $id = this._id + "_dateDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "date", col);
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderDatetimeDialog: function (col) {
            var $id = this._id + "_datetimeDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "datetime", col);
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderFDialog: function (id) {
            $("#" + id).ejDialog({ showOnInit: false, "enableRTL": this.model.enableRTL, "cssClass": this.model.cssClass, "showHeader": false, width: 260, enableResize: false, allowKeyboardNavigation: false, content: "#" + this._id });
        },
        _closeFDialog: function () {
            if (this._isExcelFilter || this._excelFilterRendered)
                this._excelFilter.closeXFDialog();
            if (this._$menuDlgIsOpen)
                this._closeFilterDlg();
        },
        _renderDlgContent: function (content, type, col) {
            content.addClass("e-grid");
            var $predicate = ej.buildTag("div.e-predicate"), $operator = ej.buildTag("div.e-operator"), $value = ej.buildTag("div.e-value");
            var $strOp = this.localizedLabels.StringMenuOptions;
            var $numOp = this.localizedLabels.NumberMenuOptions;
            var $drdown = ej.buildTag("input#" + this._id + type + "_ddinput", {}, {}, { "type": "text" });
            var $drdownDiv = ej.buildTag("div#" + this._id + type + "_dropdown");
            var $drdownUl = ej.buildTag("ul");
            var $radio = ej.buildTag("input", {}, {}, { "type": "radio", "name": this._id + "_predicate" + type, "value": "or" });
            var $andRadio = ej.buildTag("input", {}, {}, { "type": "radio", "name": this._id + "_predicate" + type, "value": "and", "checked": "checked" });
            var $cbox;
            $predicate.append($andRadio)
                .append(ej.buildTag("span.e-caption").html(this.localizedLabels.PredicateAnd))
                .append($radio)
                .append(ej.buildTag("span.e-caption").html(this.localizedLabels.PredicateOr));
            !this.model.filterSettings.showPredicate && $predicate.hide();
            if (type == "string") {
                $cbox = ej.buildTag("input", {}, {}, { "type": "checkbox" });
                $predicate.append($cbox)
                    .append(ej.buildTag("span.e-caption").html(this.localizedLabels.MatchCase));
                $.each($strOp, function (indx, operator) {
                    $drdownUl.append(ej.buildTag("li", {}, {}, { "value": operator.value }).html(operator.text));
                });
            }
            if (type == "number" || type == "date" || type == "datetime"|| type == "guid" ) {
                if(type=="guid")
                $numOp = $numOp.slice(4,6);
                $.each($numOp, function (indx, operator) {
                $drdownUl.append(ej.buildTag("li", {}, {}, { "value": operator.value }).html(operator.text));
                });
            }
            if (type != "boolean") {
                $drdownDiv.append($drdownUl);
                $operator.append($drdown);
                $operator.append($drdownDiv);
            }
            var $tBox = ej.buildTag("input", {}, {}, { "type": "text" });
            var $tchkBox = ej.buildTag("input", {}, {}, { "type": "checkbox" });
            var filterVal = this.model.enableResponsiveRow ? 'OkButton' : 'Filter';
            var clearVal = this.model.enableResponsiveRow ? 'CancelButton' : 'Clear';
            var $filter = ej.buildTag("input.e-filter e-flat e-btnsub", {}, {}, { "type": "button", "value":this.localizedLabels[filterVal] });
            var $clear = ej.buildTag("input.e-clear e-flat e-btncan", {}, {}, { "type": "button", "value": this.localizedLabels[clearVal] });
            $value.append(ej.buildTag("span.e-caption").html(this.localizedLabels.FilterMenuCaption));
            content.append($predicate);
            if (type == "boolean") {
                $value.find("span.e-caption").css("top","1px");
                $value.append($tchkBox);
            }
            else {
                $value.append(ej.buildTag("br")).append($tBox);
                content.append($operator);
            }
            content.append($value);
            content.append(ej.buildTag("div.e-dlgBtns").append($filter)
                .append($clear));
            if (type != "boolean")
                $drdown.ejDropDownList({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, "targetID": this._id + type + "_dropdown", width: "100%", height: "26px", selectedItemIndex: 0 });
            $radio.ejRadioButton({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL });
            $andRadio.ejRadioButton({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, checked: true });
            if ($cbox)
                $cbox.ejCheckBox({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL });
            content.css("display", "none");
            this._createButton("filter", $filter);
            this._createButton("clear", $clear);
            if (type == "number")
                $tBox.ejNumericTextbox({ "cssClass": this.model.cssClass,locale: this.model.locale, "enableRTL": this.model.enableRTL, "value": 0, showSpinButton: false, height: "26px", decimalPlaces: 2, width: "100%" });
            else if (type == "guid" )
                $tBox.css({  "height": "26px", "width": "100%" });
			else if (type == "date") {
                $tBox.attr("id", this._id + "_dpDate")
                $tBox.ejDatePicker({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, enableStrictMode: true, width: "100%", watermarkText: this.localizedLabels.DatePickerWaterMark, locale: this.model.locale });
                if (!ej.isNullOrUndefined(col.format))
                    $tBox.ejDatePicker({ dateFormat: col.format.replace(/{0:|}/g, function () { return "" }) });
            }
			else if (type == "datetime") {
			    $tBox.attr("id", this._id + "_dpDateTime")
			    $tBox.ejDateTimePicker({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, enableStrictMode: true, width: "100%", locale: this.model.locale });
			    if (!ej.isNullOrUndefined(col.format))
			        $tBox.ejDateTimePicker({ dateTimeFormat: col.format.replace(/{0:|}/g, function () { return "" }) });
			}
			else if (type == "boolean")
                $tchkBox.ejCheckBox({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL });
            else if (type == "string") {
                $tBox.attr("id", this._id + "_acString");
                $tBox.ejAutocomplete({
                    "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, "dataSource": this._dataSource(), width: "100%", height: 26, enableDistinct: true, focusIn: function (args) {
                        var $dropdown = this.element.closest(".e-dialog").find(".e-dropdownlist");
                        var $matchcase = this.element.closest(".e-dialog").find(".e-checkbox").prop("checked");
                        this.model.filterType = $dropdown.ejDropDownList("model.value");
                        this.model.caseSensitiveSearch = $matchcase;
                    },
                    open: function (args) {
                        var doped = !this.element.closest(".e-dialog").ejDialog("isOpened")
                        this.suggestionList.css({ visibility: (doped ? "hidden" : "visible") });
                    }
                    
                });
            }
        },
        _createButton: function (name, element) {
            var $func = name == "filter" ? ej.proxy(this._fltrBtnHandler, this) : ej.proxy(this._fltrClrHandler, this);
            element.ejButton({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, "click": $func });
        },
        _getIdField: function () {
            var $key;
            $.each(this.model.columns, function (indx, col) {
                if (col.key) {
                    $key = col.field;
                    return false;
                }
            });
            return $key;
        },
        _filterCompleteAction: function () {
            if (this.model.allowPaging)
                this._refreshGridPager();
            if(this.model.scrollSettings.allowVirtualScrolling){
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
            if (this.model.filterSettings.filterType == "menu" || this._isExcelFilter) {
                this._closeFDialog();
                var column = this.getColumnByField(this._$curFieldName);
                var index = $.inArray(column, this.model.columns), proxy = this, _addicon = false;
                $.each(this.model.filterSettings.filteredColumns, function (indx, col) {
                    if (col.field == proxy._$curFieldName) {
                        _addicon = true;
                        return false;
                    }
                    else if (col.isComplex == true) {
                        if (col.predicates[0].field == proxy._$curFieldName) {
                            _addicon = true;
                            return false;
                        }
                    }
                });
                var $fIcon = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell").eq(index).find(".e-filtericon");
                if (_addicon)
                    $fIcon.addClass("e-filteredicon e-filternone");
                else
                    $fIcon.removeClass("e-filteredicon e-filternone");
            }
        },
        _refreshFilterIcon: function () {
            if (!this.model.filterSettings.filteredColumns.length)
                return;
            var filteredCols = ej.distinct(this.model.filterSettings.filteredColumns, "field", true), _$headerCells = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell"), index, col;
            if (this.model.showStackedHeader)
                _$headerCells = _$headerCells.not(".e-stackedHeaderCell");
            if (this.model.allowReordering)
                _$headerCells.find(".e-filtericon").removeClass("e-filteredicon e-filternone");
            for (var i = 0, flen = filteredCols.length; i < flen; i++) {
                col = filteredCols[i]
                index = this.getColumnIndexByField(col.isComplex === true? col.predicates[0].field : col.field);
                _$headerCells.eq(index).find(".e-filtericon").addClass("e-filteredicon e-filternone");
            }
        },
        _setFilterFieldValues: function (id) {
            var $fVal = "", proxy = this;
            var flchk = -1, optr;
            $.each(this.model.filterSettings.filteredColumns, function (indx, value) {
                if (value.field == proxy._$curFieldName)
                    flchk = indx;
            });
            if (flchk == -1 && this._$colType != "boolean") {
                if (this._$colType == "string") {
                    $(".e-predicate input.e-js[type='checkbox']").ejCheckBox({
                        checked: false
                    });
                }
                $(".e-predicate input[name =" + this._id + "_predicate" + this._$colType + "]:first").ejRadioButton({ checked: true });
                $("#" + this._id + this._$colType + "_ddinput").ejDropDownList({
                    selectedItemIndex: 0, change: function (args) {
                        this.element.closest(".e-dialog").find(".e-autocomplete").val($fVal);
                    }
                });
            }
            var filteredFields = $(this.model.filterSettings.filteredColumns).map(function () {
                return this.field;
            }).get();
            if (this._$curFieldName != this._$prevFieldName || $.inArray(this._$curFieldName, filteredFields) != -1) {
                $.each(this.model.filterSettings.filteredColumns, function (indx, col) {
                    if (col.field == proxy._$curFieldName) {
                        var index;
                        var option = proxy._$colType == "number" || proxy._$colType == "date" || proxy._$colType == "datetime" ? "Number" : "String";
                        var $dlist = proxy.localizedLabels[option + "MenuOptions"];                        
                        var optr = ej.isNullOrUndefined(col.actualOperator) ? col.operator : col.actualOperator
                        for (index = 0; index < $dlist.length; index++) {
                            if ($dlist[index].value.toLowerCase() == optr)
                                break;
                        }
                        if (proxy._$colType == "string")
                            $(".e-predicate input.e-js[type='checkbox']").ejCheckBox({ checked: col.matchcase });
                        $("input[value=" + col.predicate + "]").ejRadioButton({ checked: true });
                        $("#" + proxy._id + proxy._$colType + "_ddinput").ejDropDownList({ selectedItemIndex: index });
                        $fVal = col.actualFilterValue != null ? col.actualFilterValue : col.value;
                        return false;
                    }
                });
                if (this._$colType == "boolean") {
                    if ($fVal && $fVal != "")
                        $(id).find(".e-value input:checkbox.e-js").ejCheckBox({checked: true});
                    else
                        $(id).find(".e-value input:checkbox.e-js").ejCheckBox({checked: false});
                } else if (this._$colType == "date" || this._$colType == "datetime") {
                    $(id).find(".e-value .e-datepicker")[this._$colType == "date" ? "ejDatePicker" : "ejDateTimePicker"]("model.value", $fVal);
                } else if(this._$colType == "number"){
					$(id).find(".e-value .e-numerictextbox").ejNumericTextbox("model.value", $fVal);
				} else
                    $(id).find(".e-value input").val($fVal);
            }
        },
        _fltrBtnHandler: function (e) {
            if (this.model.isResponsive && this._mediaStatus)
                this._responsiveFilterClose();
            var id = this._id + "_" + this._$colType + "Dlg";
            var $par = $("#" + id);
            var $input = $par.find(".e-value input.e-js"), $operator, result, predicateEle;
            var value = $input.val(), matchcase = undefined, filterValue;
            if (this._$colType == "number") {
                $input = $input.filter(".e-numerictextbox");
                value = parseFloat($input.ejNumericTextbox("getValue"));
                matchcase = true;
            }
            if (this._$colType == "string")
                matchcase = $par.find(".e-predicate input[type='checkbox']").is(":checked");
            if (this._$colType == "date" || this._$colType == "datetime") {
                value = ej.parseDate(value, this._$colFormat, this.model.locale);
                matchcase = true;
            }
            if (this._$colType == "boolean") {
                value = $input.ejCheckBox("model.checked") != null ? $input.ejCheckBox("model.checked") : false;
                $operator = "equal";
            } else
                $operator = $("#" + this._id + this._$colType + "_ddinput").ejDropDownList("getSelectedValue").toLowerCase();
            predicateEle = $par.find(".e-predicate input[type='radio']:checked");
            if (this._$colForeignKeyValue && this._$colDropdownData)
                this._fltrForeignKeyValue($operator, value, matchcase, this._$colDropdownData, this._$colForeignKeyField, this._$colForeignKeyValue, this._$colType, predicateEle);
            else
                this.filterColumn(this._$curFieldName, $operator, value, $par.find(".e-predicate input[type='radio']:checked").attr("value"), matchcase);
            if (this.model.isResponsive) {
                $par.css('display', 'none');
                this._setResponsiveFilterIcon();
                this.element.css('display', 'block');
                if (this.model.allowScrolling && (!this.model.enableResponsiveRow || !this.model.minWidth)) {
                    var args = {};
                    args.requestType = 'refresh';
                    this._refreshScroller(args);
                }
            }
        },
        _fltrClrHandler: function (e) {                        
			this.clearFiltering(this._$curFieldName);
        },

        _fltrForeignKeyValue: function (operator, value, matchcase, dataSource, fieldName, mapFieldName, colType, predicateEle) {
            if (ej.isNullOrUndefined(matchcase))
                matchcase = true;
            var operatorCol = [], predicateCol = [], query, filterValue, visible = predicateEle ? predicateEle.css("display") == "none" : true, condition = predicateEle ? predicateEle.attr("value") : "and", predicate;
            var data = dataSource, val;
			var filterCollection={ mapFieldName: mapFieldName, fieldName: fieldName, operator: operator, value: value, predicate: predicateEle, matchcase: matchcase};
			var args = { requestType:ej.Grid.Actions.Filtering, action:"fetchingForeignKeyField",currentFilteringColumn:fieldName,currentFilterObject:filterCollection };
			  this._trigger("actionBegin", args);
            if (!(dataSource instanceof ej.DataManager))
                data = new ej.DataManager(dataSource);
            if (colType == "date") {
                var $prevDate = new Date(value.setDate(value.getDate() - 1));
                var $nextDate = new Date(value.setDate(value.getDate() + 2));
                if (operator == "equal" || operator == "notequal") {
                    if (operator == "equal")
                        query = new ej.Query().where(ej.Predicate(filterCollection.mapFieldName, ">", $prevDate, !filterCollection.matchcase).and(filterCollection.mapFieldName, "<", $nextDate, !filterCollection.matchcase)).select(filterCollection.fieldName);
                    else
                        query = new ej.Query().where(ej.Predicate(filterCollection.mapFieldName, "<=", $prevDate, !filterCollection.matchcase).or(filterCollection.mapFieldName, ">=", $nextDate, !filterCollection.matchcase)).select(filterCollection.fieldName);
                }
                else
                    query = new ej.Query().where(filterCollection.mapFieldName, filterCollection.operator, filterCollection.value, !filterCollection.matchcase).select(filterCollection.fieldName);
            }
            else
                query = new ej.Query().where(filterCollection.mapFieldName, filterCollection.operator, filterCollection.value, !filterCollection.matchcase).select(filterCollection.fieldName);
            filterValue = { actualFilterValue: filterCollection.value, actualOperator: filterCollection.operator, ejpredicate: undefined, predicate: condition };
            data.executeQuery(query).done(ej.proxy(function (e) {
                val = e.result;
                var requireProc = $.isPlainObject(val[0]), preds = [], merge = false, field = this._$curFieldName;
                val = requireProc ? ej.distinct(val, fieldName, false) : val, 
                predicate = new ej.Predicate(field, "equal", val[0], matchcase);
                for (var i = 1, vlen = val.length; i < vlen; i++) {
                    preds.push(new ej.Predicate(field, "equal", val[i], matchcase));
                    merge = true;
                }
                if (merge) {
                    preds.unshift(predicate);
                    predicate = ej.Predicate.or(preds); /*ensure same level for multiple predicates*/
                }
                $.extend(filterValue, { ejpredicate: $.extend(predicate, { field: field }, filterValue) });
                this.filterColumn(filterCollection.fieldName, filterCollection.operator, filterCollection.value, predicateCol, filterCollection.matchcase, filterValue);
            }, this));
        },
        _setDateFilters: function (filterObject, forGrouping) {
            var $prevDate, $nextDate, pred, predicate;
            if (!forGrouping && !ej.isNullOrUndefined(this.getColumnByField(filterObject.field).format)) {
                var formatString = this.getColumnByField(filterObject.field).format;
                if (formatString.indexOf("s") != -1) {
                    $prevDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() - 1));
                    $nextDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() + 2));
                }
                else if (formatString.indexOf("m") != -1) {
                    $prevDate = new Date(filterObject.value.setMinutes(filterObject.value.getMinutes() - 1));
                    $nextDate = new Date(filterObject.value.setMinutes(filterObject.value.getMinutes() + 2));
                }
                else if (formatString.indexOf("h") != -1) {
                    $prevDate = new Date(filterObject.value.setHours(filterObject.value.getHours() - 1));
                    $nextDate = new Date(filterObject.value.setHours(filterObject.value.getHours() + 2));
                }
                else {
                    $prevDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() - 1));
                    $nextDate = new Date(filterObject.value.setDate(filterObject.value.getDate() + 1));
                }
            }
            else {
                $prevDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() - 1));
                $nextDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() + 2));
            }
            var $prevObj = $.extend({}, filterObject);
            var $nextObj = $.extend({}, filterObject);
            $prevObj.value = $prevDate;
            $nextObj.value = $nextDate;
            if (filterObject.operator == "equal") {
                $prevObj.operator = "greaterthan";
                $prevObj.predicate = "and";
                $nextObj.operator = "lessthan";
                $nextObj.predicate = "and";
            } else {
                $prevObj.operator = "lessthanorequal";
                $prevObj.predicate = "or";
                $nextObj.operator = "greaterthanorequal";
                $nextObj.predicate = "or";
            }
            pred = ej.Predicate($prevObj.field, $prevObj.operator, $prevObj.value, false);
            predicate = pred[$nextObj.predicate](ej.Predicate($nextObj.field, $nextObj.operator, $nextObj.value, false));
            filterObject.value = new Date(filterObject.value.setSeconds($nextObj.value.getSeconds() - 1));
            if (forGrouping)            
                return predicate;            
            else
            this.model.filterSettings.filteredColumns.push($.extend(predicate, { field: filterObject.field, operator: filterObject.operator,value:filterObject.value}));
        }       
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    "use strict"
    ej.gridFeatures.group = {
        _renderGroupDropArea: function () {
            if(!ej.isNullOrUndefined(this.model.groupSettings.enableDropAreaAnimation))
                this.model.groupSettings.enableDropAreaAutoSizing = this.model.groupSettings.enableDropAreaAnimation;
            var dragLabel = this.model.groupSettings.enableDropAreaAutoSizing ? "" : this.localizedLabels.GroupDropArea;
            if (this.model.groupSettings.showDropArea) {
                var $div = ej.buildTag("div.e-groupdroparea", dragLabel);
				$div.addClass("e-default");
                this.model.groupSettings.enableDropAreaAutoSizing && $div.append(ej.buildTag("div.e-animatebutton e-icon").addClass(this.model.groupSettings.enableDropAreaAutoSizing ? "e-animatebuttondown e-gdownarrow" : "e-animatebuttonup e-guparrow"));
                return $div;
            }
        },
        _getColGroup: function (gridObjectId) {
            var gridObject = this.getRsc("helpers", gridObjectId);
            if (gridObject.model.groupSettings.groupedColumns.length == 1)
                var level = this.data.items.level === undefined ? 0 : this.data.items.level - 1;
            else
                var level = this.data.items.level === undefined ? gridObject.model.groupSettings.groupedColumns.length : this.data.items.level - 1;
            var $div = $(document.createElement("div"));
            var $colGroup;
            if (gridObject._isCaptionSummary)
                $colGroup = gridObject._getCaptionColGroup(level);
            else {
                $colGroup = gridObject._getMetaColGroup();
                if (level != gridObject.model.groupSettings.groupedColumns.length && gridObject.model.groupSettings.groupedColumns.length > 1)
                    $colGroup.prepend(gridObject._getIndentCol());
            }
            $div.html($colGroup);
            return $div.html();
        },
        _colSpanAdjust: function (gridObjectId, type, captionDetails) {
            var gridObject, groupData;
            if (ej.isNullOrUndefined(gridObjectId)) {
                gridObject = this;
                groupData = captionDetails;
            }
            else {
                gridObject = this.getRsc("helpers", gridObjectId);
                groupData = this;
            }
            if (gridObject.model.groupSettings.groupedColumns.length == 1) {
                var level = groupData.data.items.level === undefined ? 1 : groupData.data.items.level - 1;
                if (type == "groupcaption")
                    gridObject._currentJsonData = gridObject._currentJsonData.concat(groupData.data.items);
            } else {
                var level = groupData.data.items.level === undefined ? gridObject.model.groupSettings.groupedColumns.length : groupData.data.items.level - 1;
                if (type == "groupcaption" && groupData.data.items.level === undefined)
                    gridObject._currentJsonData = gridObject._currentJsonData.concat(groupData.data.items);
            }            
            gridObject._isGrouping = true;
            var hideGroupColumnCount = !gridObject.model.groupSettings.showGroupedColumn ? gridObject.model.groupSettings.groupedColumns.length : 0;
            var count = 0;
            $.each(gridObject._hiddenColumnsField, function (indx, col) {
                var tempIndex = $.inArray(col, gridObject.model.groupSettings.groupedColumns);
                if (tempIndex != -1) {
                    count = count + 1;
                    if (gridObject.model.groupSettings.showGroupedColumn)
                        hideGroupColumnCount = hideGroupColumnCount + 1;
                }
            })
            var colspan = gridObject.model.columns.length + gridObject.model.groupSettings.groupedColumns.length - level - gridObject._hiddenColumnsField.length - hideGroupColumnCount + count;
            colspan = (gridObject.model.detailsTemplate != null || gridObject.model.childGrid != null) ? colspan + 1 : colspan;

            if (gridObject._isCaptionSummary && type == "groupcaption") {
                var index = [], cIndex = 0;
                var row = gridObject._captionSummary();
                var hiddenIndexCount = 0, summaryColIndexes = [];
                $.each(row[0].summaryColumns, function (cindx, col) {
                    if ($.inArray(col.displayColumn, gridObject._hiddenColumnsField) != -1)
                        cIndex++;
                    summaryColIndexes.push(gridObject.getColumnIndexByField(col.displayColumn));
                    index.push(gridObject.getColumnIndexByField(col.displayColumn) + gridObject.model.groupSettings.groupedColumns.length - level);
                });
                var sumColIndex = ej.min(summaryColIndexes)
                for (var i = 0; i < gridObject._hiddenColumnsField.length; i++) {
                    var colIndex = ej.isNullOrUndefined(gridObject.getColumnByField(gridObject._hiddenColumnsField[i])) ? gridObject.getColumnIndexByHeaderText(gridObject._hiddenColumnsField[i], ej.isNullOrUndefined(gridObject.getColumnByField(gridObject._hiddenColumnsField[i]))) : gridObject.getColumnIndexByField(gridObject._hiddenColumnsField[i]);
                    if (sumColIndex > colIndex)
                        hiddenIndexCount++;
                }
                if (index.length > 0)
                    colspan = ej.min(index);
                colspan = colspan - hiddenIndexCount;
                colspan = (gridObject.model.detailsTemplate != null || gridObject.model.childGrid != null) ? colspan + 1 : colspan;
            }
            return colspan;
        },
        _captionEncode: function (gridObjectId) {
            var gridObject = this.getRsc("helpers", gridObjectId);
            var column = gridObject.getColumnByField(this.data.field);
            return column.disableHtmlEncode;
        },
        _captionFormat: function (gridObjectId) {
            var gridObject = this.getRsc("helpers", gridObjectId);
            var keyValue, captionData = $.extend({}, this.data);
			var capationFormat = !ej.isNullOrUndefined(gridObject.model.groupSettings.captionFormat)? gridObject.model.groupSettings.captionFormat: gridObject.localizedLabels.GroupCaptionFormat;
            var column = gridObject.getColumnByField(captionData.field);
            if (column.foreignKeyValue && column.dataSource)
                keyValue = gridObject._foreignKeyBinding(gridObject.getColumnIndexByField(captionData.field), captionData.key, gridObject._id);
            else
                keyValue = captionData.key;
			if(!ej.isNullOrUndefined(column.format) && column.format.indexOf("{0:") == -1){
				captionData[captionData.field] = captionData.key;
				gridObject.data = captionData;
			}
            captionData.key = column.format ? gridObject.formatting(column.format, keyValue, gridObject.model.locale) : keyValue;
            captionData.headerText = column.headerText;
            if (capationFormat.startsWith("#") || capationFormat.startsWith(".") || typeof capationFormat === "object")
                return gridObject._renderEjTemplate(capationFormat, captionData, gridObject.getColumnIndexByField(captionData.field));
            else
                return $.render[gridObject._id + "_CaptionTemplate"](captionData);
        },
        _getCaptionColGroup: function (level) {
            var cloneColGroup = this.getHeaderTable().find("colgroup").clone();
            var colColl = cloneColGroup.find("col");
            var indentCol = colColl.length - this.model.columns.length;
            if (this.model.detailsTemplate != null || this.model.childGrid != null)
                indentCol = indentCol - 1;
            cloneColGroup.find("col:lt(" + indentCol + ")").remove();
            if (level > 0 && level != this.model.groupSettings.groupedColumns.length) {
                if (this.model.groupSettings.groupedColumns.length > 2 && level != this.model.groupSettings.groupedColumns.length - 1) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length - level; i++) {
                        cloneColGroup.prepend(this._getIndentCol());
                    }
                }
                else
                    cloneColGroup.prepend(this._getIndentCol());
            }
            return cloneColGroup;
        },
        _groupSummaryRow: function (item, aggregates, gridObjectId, showGroup) {
            var gridObject = this.getRsc("helpers", gridObjectId), showGroup = !ej.isNullOrUndefined(showGroup), colIndex;
            if (gridObject.model.showSummary) {
                if (gridObject.getFooterTable() == null)
                    gridObject._renderGridFooter();
                gridObject._createSummaryRows(gridObject.getFooterTable(), item.records == null ? item : item.records, aggregates, item, showGroup);
                if (gridObject._isCaptionSummary && !showGroup) {
                    var index = [];
                    var row = gridObject._captionSummary();
                    $.each(row[0].summaryColumns, function (cindx, col) {
                        index.push(gridObject.getColumnIndexByField(col.displayColumn));
                    });
                    if (index.length > 0)
                        colIndex = ej.min(index);
                    var colLength = gridObject.model.columns.length;
                    gridObject.getFooterTable().find("tbody td").slice(-(colLength - colIndex)).removeClass("e-summaryrow").addClass("e-groupcaptionsummary");
                }
                if (!gridObject.model.groupSettings.showGroupedColumn) {
                    var groupedcolumns = gridObject.model.groupSettings.groupedColumns;
                    var count = 0;
                    var gridfooterrow = gridObject.getFooterTable().children('tbody').find('tr');
                    for (var j = 0; j < gridObject.model.summaryRows.length; j++) {
                        for (var k = 0; k < gridObject.model.summaryRows[j].summaryColumns.length; k++) {
                            for (var i = 0; i < groupedcolumns.length; i++) {
                                if (groupedcolumns[i] == gridObject.model.summaryRows[j].summaryColumns[k].displayColumn) {
                                    count++;
                                    if (gridObject.model.summaryRows[j].summaryColumns.length == count) {
                                        $(gridfooterrow[j]).addClass("e-hide")
                                    }
                                }
                            }
                        }
                        count = 0;
                    }
                }
                return !showGroup ? gridObject.getFooterTable().find("tbody").find("tr").html() : gridObject.getFooterTable().find("tbody").html();
            }
        },
        addGroupingTemplate: function () {
            var tbody = document.createElement('tbody');
            var expandTd = "<td class='e-recordplusexpand' ej-mappingname='{{:field}}' ej-mappingvalue='{{:key}}'><div class='e-icon e-gdiagonalnext'></div></td>";
            var proxy = this;
            var helpers = {};
            helpers["_" + proxy._id + "ColSpanAdjust"] = this._colSpanAdjust;
            helpers["_" + proxy._id + "Colgroup"] = this._getColGroup;
            if (ej.isNullOrUndefined(this.model.groupSettings.captionFormat))
                $.templates(proxy._id + "_CaptionTemplate", this.localizedLabels.GroupCaptionFormat);
            else
                $.templates(proxy._id + "_CaptionTemplate", this.model.groupSettings.captionFormat);
            helpers["_" + proxy._id + "CaptionFormat"] = this._captionFormat;
            helpers["_" + proxy._id + "GroupSummaryRow"] = this._groupSummaryRow;
            helpers["_" + proxy._id + "CaptionEncode"] = this._captionEncode;
            helpers[proxy._id + "Object"] = this;
            $.views.helpers(helpers);
            var caption = " ~_" + proxy._id + "CaptionFormat('" + proxy._id + "Object')";
            var cpationTd = expandTd + "<td class='e-groupcaption' colspan='{{:~_" + proxy._id + "ColSpanAdjust('" + proxy._id + "Object" + "','groupcaption') }}'>{{if ~_" + proxy._id + "CaptionEncode('" + proxy._id + "Object')}}{{html:" + caption + "}}{{else}}{{:" + caption + "}}{{/if}}</td>";
            if (this._isCaptionSummary && this.model.showSummary)
                cpationTd = cpationTd + "{{:~_" + proxy._id + "GroupSummaryRow(items, aggregates,'" + proxy._id + "Object')}}";
            var captionTr = "<tr class='e-groupcaptionrow'>" + cpationTd + "</tr>";
            var $tbody = ej.buildTag("tbody");
            $tbody.html("{{if items.GROUPGUID}}" +
                "{{for items tmpl='" + proxy._id + "_GroupingTemplate'/}}" +
                "{{else}}" +
                "{{for items tmpl='" + proxy._id + "_JSONTemplate'/}}" +
                "{{/if}}");
            var indentTd = "<td class='e-indentcell'></td>";
            var table = "<table class='e-table {{if items.GROUPGUID}}{{else}}e-recordtable{{/if}}' cellspacing='0.25px' >" +
                "{{:~_" + proxy._id + "Colgroup('" + proxy._id + "Object')}}" +
                $tbody.html() + "{{:~_" + proxy._id + "GroupSummaryRow(items, aggregates,'" + proxy._id + "Object', '" + proxy._id + "showGroupCaption')}}" +
            "</table>";
            var tableTd = "<td class='e-tabletd' colspan='{{:~_" + proxy._id + "ColSpanAdjust('" + proxy._id + "Object" + "','table')}}'>" + table + "</td>";
            var tr = "<tr>" + indentTd + tableTd + "</tr>";
            $.templates(proxy._id + "_GroupingTemplate", captionTr + tr);
        },
        addSummaryTemplate: function () {
            var proxy = this;
            $.each(proxy.model.summaryRows, function (cindx, row) {
                $.each(row.summaryColumns, function (cindx, cols) {
                    if (!ej.isNullOrUndefined(cols.template))
                        $.templates(proxy._id + "_summaryTemplate" + cols.template, cols.template)
                });
            });
        },
        _getGroupTopLeftCell: function () {
            var $th = ej.buildTag("th.e-grouptopleftcell");
            $th.append(ej.buildTag("div.e-headercelldiv e-emptyCell", "&#160;"));
            return $th;
        },
        _getEmptyFilterBarCell: function () {
            var $th = ej.buildTag("th.e-filterbarcell e-grouptopleftcell");
            return $th;
        },
        _groupingAction: function (refWidth) {
            var $groupTopCell = this.getHeaderTable().find("thead").find(".e-columnheader:not(.e-stackedHeaderRow)").find(".e-grouptopleftcell"), $col = this.getHeaderTable().find("colgroup").find("col");
            var groupColumn = $groupTopCell.length;
            if (groupColumn) {
                this.getHeaderTable().find("colgroup").replaceWith(this._getMetaColGroup());
                (this.model.detailsTemplate != null || this.model.childGrid != null) && this.getHeaderTable().find("colgroup").prepend(this._getIndentCol());
                $groupTopCell.remove();
                this.getHeaderTable().find("thead").find(".e-filterbar").find(".e-filterbarcell:lt(" + groupColumn + ")").remove();
            }
            if (!this.model.allowResizeToFit || refWidth)
                this.setWidthToColumns();
            for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                this.getHeaderTable().find("colgroup").prepend(this._getIndentCol());
                this.getHeaderTable().find("thead").find(".e-columnheader").prepend(this._getGroupTopLeftCell());
                this.getHeaderTable().find("thead").find(".e-filterbar").prepend(this._getEmptyFilterBarCell());
            }
            this.getHeaderTable().find(".e-columnheader").find("th.e-grouptopleftcell").last().addClass("e-lastgrouptopleftcell");
        },
        
        groupColumn: function (columnName) {
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel"))
                this._closeFDialog();
            if (!this.model.allowGrouping || $.inArray(columnName, this._disabledGroupableColumns) != -1)
                return;
            if (ej.isNullOrUndefined(this.getColumnByField(columnName)) || $.inArray(columnName, this.model.groupSettings.groupedColumns) != -1)
                return;
            this.model.groupSettings.groupedColumns.push(columnName);
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                if (this.model.sortSettings.sortedColumns[i].field == columnName) {
                    break;
                }
            }
            this.model.sortSettings.sortedColumns.length == i && this.model.sortSettings.sortedColumns.push({ field: columnName, direction: ej.sortOrder.Ascending });
            var args = {};
            args.columnName = columnName;
            args.requestType = ej.Grid.Actions.Grouping;
            var returnValue = this._processBindings(args);
            if (returnValue) {
                if (!($.inArray(columnName, this._scolumns) != -1 || this._gridSort == columnName))
                    this.model.sortSettings.sortedColumns.pop();
                this.model.groupSettings.groupedColumns.pop();
            }
            this._primaryKeyValues = [];
        },
        
        ungroupColumn: function (columnName) {
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel"))
                this._closeFDialog();
            if (!this.model.allowGrouping)
                return;
            if ($.inArray(columnName, this.model.groupSettings.groupedColumns) != -1)
                this.model.groupSettings.groupedColumns.splice($.inArray(columnName, this.model.groupSettings.groupedColumns), 1);
            else
                return null;
            if (this.model.groupSettings.groupedColumns.length == 0)
                this._LastColumnUnGroup = true;
            var column = this.getColumnByField(columnName)
            if (!this.model.groupSettings.showGroupedColumn && !column["visible"]) {
                var index = this._hiddenColumnsField.indexOf(columnName), hTxt = this.getColumnByField(columnName).headerText;
                this._hiddenColumnsField.splice(index, 1);
                this._hiddenColumns.splice(this._hiddenColumns.indexOf(hTxt), 1);
                this._visibleColumns.push(hTxt);
                this._visibleColumnsField.push(columnName);
                column["visible"] = true;
            }
            var args = {};
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                if (this.model.sortSettings.sortedColumns[i].field == columnName) {
                    if (this._scolumns.indexOf(columnName) != -1 && this.model.allowSorting && this.model.allowMultiSorting || this._gridSort == columnName)
                        if (this.model.allowSorting && this.model.allowMultiSorting) {
                            var no = $.inArray(columnName, this._scolumns);
                            this._scolumns.splice(no, 1);
                            break;
                        }
                        else {
                            this._gridSort = null;
                            break;
                        }
                    else
                        this.model.sortSettings.sortedColumns.splice(i, 1);
                    break;
                }
            }
            args.columnName = columnName;
            args.requestType = ej.Grid.Actions.Ungrouping;
			this._isUngrouping = true;
            var returnValue = this._processBindings(args);
            if (returnValue)
                this.model.groupSettings.groupedColumns.push(columnName);
            this._primaryKeyValues = [];
        },
        
        collapseGroupDropArea: function () {
            var $groupDropArea = this.element.find(".e-groupdroparea").first(), proxy = this;
            this.model.groupSettings.groupedColumns.length == 0 && this.model.groupSettings.enableDropAreaAutoSizing && $groupDropArea.animate({ height: "10px" }, 200, function () {
                if (proxy.model != null && proxy.model.groupSettings.groupedColumns.length == 0) {
                    $(this).html("").append(ej.buildTag("div.e-animatebutton e-animatebuttondown e-icon e-gdownarrow"));
                    $(this).dequeue().css("height", "auto");
                }
            });
            
        },
        
        expandGroupDropArea: function () {
            var $groupDropArea = this.element.find(".e-groupdroparea").first(), proxy = this;
            this.model.groupSettings.groupedColumns.length == 0 && proxy.model.groupSettings.enableDropAreaAutoSizing && $groupDropArea.animate({ height: "30px" }, 150, function () {
                proxy.model.groupSettings.groupedColumns.length == 0 && $groupDropArea.html(proxy.localizedLabels.GroupDropArea).append(ej.buildTag("div.e-animatebutton e-animatebuttonup e-icon e-guparrow"));
                $groupDropArea.dequeue().css("height", "30px");
            });
        },
        _enableGroupingEvents: function () {
            if (this.model.allowGrouping) {
                this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", ".e-groupdroparea", this._groupHeaderCellClick);
            }
        },
        _recalculateIndentWidth: function () {
            var proxy = this;
            var browserDetails = !ej.isIOSWebView() && this.getBrowserDetails();
            var indentWidth = this.getHeaderTable().find(".e-lastgrouptopleftcell").width(), newWidth = indentWidth, perPixel = indentWidth / 30, $col;
            if (perPixel >= 1)
                newWidth = (30 / perPixel);
            this.getHeaderTable().find("colgroup").find("col").slice(0, this.model.groupSettings.groupedColumns.length).css("width", newWidth + "px");
            var $conCol = this.getContentTable().find("table").filter(":not(.e-recordtable)");
            indentWidth = this.getHeaderTable().find(".e-lastgrouptopleftcell").width();
            if (indentWidth > 30 || (this._isCaptionSummary && (indentWidth >= 30 || (indentWidth > newWidth)))) {
                if (this._isCaptionSummary) {
                    var colgroup = this.model.isEdit ? $conCol.parent(":not(.gridform)").children("colgroup") : $conCol.children("colgroup");
                    $.each(colgroup, function (index, item) {
                        var indentCol = $(item).find("col").length - proxy.model.columns.length;
                        if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                            if (indentCol > 0)
                                indentCol = indentCol - 1;
                        }
                        $(item).find("col").slice(0, indentCol).css("width", newWidth + "px");
                    });
                }
                else {
                    if (this.model.isEdit) {
                        var colgroup = $conCol.parent(".gridform").find("colgroup");
                        this._setEditColGroup(colgroup, proxy, newWidth);
                    }
                    else
                        $conCol.children("colgroup").find("col:first-child").css("width", indentWidth + "px");
                }$col = this.getContentTable().find("colgroup").first().find("col").slice(0, this.model.groupSettings.groupedColumns.length);
                if (browserDetails && browserDetails.browser != "msie")
                    $col.css("width", newWidth + "px");
                else{
                    if (this._isCaptionSummary) 
						$col.css("width", newWidth + "px");
					else
						$col.first().css("width", ((indentWidth / this.element.width()) * 100) + "%");
				}
            } else {
                this.getContentTable().find("colgroup").first().find("col").slice(0, this.model.groupSettings.groupedColumns.length).css("width", newWidth + "px");
                if (this.model.isEdit) {
                    var colgroup = this.getContentTable().find(".gridform table").find("colgroup");
                    this._setEditColGroup(colgroup, proxy, newWidth);
                }
                this.getContentTable().find("table").filter(":not(.e-recordtable)").parent(":not(.gridform)").children("colgroup").find("col:first-child").css("width", indentWidth + "px");
            }
            if (this.model.showSummary) {
                var sumCols = this.getContentTable().find("table").filter(".e-groupsummary").find(".e-summary");
                sumCols.css("width", newWidth + "px");
            }
        },
        _setEditColGroup: function (colgroup, proxy, newWidth) {
            $.each(colgroup, function (index, item) {
                var indentCol = $(item).find("col").length - proxy.model.columns.length;
                if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                    if (indentCol > 0)
                        indentCol = indentCol - 1;
                }
                $(item).find("col").slice(0, indentCol).css("width", newWidth + "px");
            });
        },
        getFieldNameByHeaderText: function (headerText) {
            if (ej.isNullOrUndefined(this._fieldColumnNames[headerText]))
                return null;
            return this._fieldColumnNames[headerText];
        },
        
        getHeaderTextByFieldName: function (field) {
            if (ej.isNullOrUndefined(this._headerColumnNames[field]))
                return null;
            return this._headerColumnNames[field];
        },
        
        expandAll: function () {
            var recordPlus = this.element.find(".e-recordpluscollapse");
            var detailRow = this._excludeDetailRows().find(".e-detailrowcollapse");
            if (recordPlus.length != 0) {
                for (var i = 0; i < recordPlus.length; i++)
                    this.expandCollapse($(recordPlus[i]));
            }
            if (detailRow.length != 0) {
                for (var i = 0; i < detailRow.length; i++)
                    this.expandCollapse($(detailRow[i]));
            }
        },
        
        collapseAll: function () {
            var recordPlus = this.element.find(".e-recordplusexpand");
            var detailRow = this.element.find(".e-detailrowexpand");
            if (recordPlus.length != 0) {
                for (var i = 0; i < recordPlus.length; i++)
                    this.expandCollapse($(recordPlus[i]));
            }
            if (detailRow.length != 0) {
                for (var i = 0; i < detailRow.length; i++)
                    this.expandCollapse($(detailRow[i]));
            }
        },
        _group: function (args) {
            if (this.model.groupSettings.groupedColumns.length && this.model.currentViewData) {
                this._currentJsonData = [];
                var temp = document.createElement('div');
                if (!this.model.groupSettings.showGroupedColumn) {
                    if (!this.initialRender && !ej.isNullOrUndefined(args.columnName) && args.requestType == "grouping") {
                        var col = this.getColumnByField(args.columnName);
                        if ($.inArray(args.columnName, this._hiddenColumnsField) == -1) {
                            var hTxt = this.getColumnByField(args.columnName).headerText;
                            this._hiddenColumnsField.push(args.columnName)
                            this._hiddenColumns.push(hTxt);
                            this._visibleColumns.splice(this._visibleColumns.indexOf(hTxt), 1);
                            this._visibleColumnsField.splice(this._visibleColumnsField.indexOf(args.columnName), 1);
                            col.visible = false;
                        }
                    }
                    else {
                        for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                            if ($.inArray(this.model.groupSettings.groupedColumns[i], this._hiddenColumnsField) == -1) {
                                this._hiddenColumnsField.push(this.model.groupSettings.groupedColumns[i]);
								this._hiddenColumns.push(this.getColumnByField(this.model.groupSettings.groupedColumns[i]).headerText);
                                this.getColumnByField(this.model.groupSettings.groupedColumns[i]).visible = false;
                            }
                        }
                    }
                    this._hideHeaderColumn(this.model.groupSettings.groupedColumns, true);
                    this.getContentTable().children("colgroup").replaceWith(this.getHeaderTable().find('colgroup').clone());
                }
                if (args.requestType == "reorder")
                    this._isReorder = true;
                else
                    this._isReorder = false;
                var $col = this.getContentTable().children("colgroup").find('col');
                var length = $col.length - this.model.columns.length;
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    length--;
                if ($col.length > this.model.columns.length)
                    this.getContentTable().children("colgroup").find('col:lt(' + length + ')').remove();
                this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                var dlen;
                if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                    dlen = this.model.groupSettings.groupedColumns.length + 1;
                }
                else
                    dlen = this.model.groupSettings.groupedColumns.length;
                for (var i = 0; i < dlen; i++)
                    this.getContentTable().children("colgroup").prepend(this._getIndentCol());
                if (this.model.currentViewData.length) {
                    var $tbody = this.getContentTable().children('tbody');
                    $tbody.empty();
                    temp.innerHTML = ['<table><tbody>', $.render[this._id + "_GroupingTemplate"](this.model.currentViewData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</tbody></table>'].join("");
                    this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                    this._hideCaptionSummaryColumn();
                }
				else if (this.model.isEdit)
                    this.cancelEdit();
                this._groupingAction();
                this._gridRows = this.getContentTable().find(".e-recordtable").find("tbody").find("tr").not(".e-gridSummaryRows");
                this._eventBindings();
            }
        },
        _ungroup: function () {
            this._isGrouping = false;
            if (!ej.isNullOrUndefined(this.model.detailsTemplate))
                this._detailsOuterWidth = null;
            var $header = this.element.children(".e-gridheader");
            var $filterInput = $header.find(".e-filterbar").find("th").find("input");
            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
            this.setGridHeaderContent($header);
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") {
                this._renderFiltering();
                this._renderFilterBarTemplate();

                var filterThNew = this.element.children(".e-gridheader").find(".e-filterbar").find("th").find("input");
                for (var i = 0; i < $filterInput.length; i++)
                    filterThNew.eq(i).val($filterInput.eq(i).val());
            }
            if (!this.model.groupSettings.showGroupedColumn)
                this._hideHeaderColumn(this.model.groupSettings.groupedColumns, true);
            this.refreshTemplate();
            this.element.find(".e-gridcontent").children("div").first().empty().append(this._renderGridContent().find("table").first());
            this.setGridContent(this.element.find(".e-gridcontent"));
            if (this.model.groupSettings.groupedColumns.length != 0)
                this._gridRows = this.getContentTable().find(".e-recordtable").find("tbody").find("tr").toArray();
            else
                this._gridRows = this.getContentTable().get(0).rows;
           if(this.element.find('.e-groupdroparea').first().hasClass('e-allowDrop'))
				this.element.find('.e-groupdroparea').first().removeClass('e-allowDrop');
        },
        _groupHeaderCellClick: function (e) {
            var $target = $(e.target);
            if ($target.hasClass('e-groupdroparea'))
                return;
            if ($target.hasClass("e-ungroupbutton")) {
                var field = $target.parent().attr("ej-mappingname");
                this.ungroupColumn(field);
            } else if ($target.hasClass("e-togglegroupbutton")) {
                var field = $target.parent().attr("ej-mappingname");
                $target.hasClass("e-toggleungroup") && this.ungroupColumn(field);
            } else if ($target.hasClass("e-animatebutton")) {
                if (!$(e.target).hasClass("e-animatebuttondown")) {
                    this.collapseGroupDropArea();
                } else {
                    this.expandGroupDropArea();
                }
            }
            else {
                $target.addClass("e-headercelldiv");
                this._mouseClickHandler(e);
                $target.removeClass("e-headercelldiv");
            }           
        },
        _captionSummary: function (nocaption) {
            var summary = null, cols = this.model.summaryRows, k, len = cols.length;
            for (k = 0; k < len; k++) {
                if (cols[k].showCaptionSummary == true) {
                    summary = $(cols[k]);
                    break;
                }
            }
            
            if (nocaption) {
                var left = cols.slice(0, k), right = cols.slice(k + 1, len);
                ej.merge(summary = left, right);
            }

            return summary;
        },
        _dropAreaHover: function (e) {
            var $target = $(e.target), proxy = this;
            if (e.type == "mouseenter") {
                if (this._dragActive) {
                    if ($target.hasClass("e-groupdroparea"))
                        $target.addClass("e-hover");
                } else
                    $target.removeClass("e-hover");
                $target.hasClass("e-groupheadercell") && this.model.groupSettings.showUngroupButton && $target.find(".e-ungroupbutton").show(150);
            } else if (e.type == "mouseleave") {
                if ($target.hasClass("e-groupdroparea")) {
                    $target.find(".e-ungroupbutton").hide(150);
                    $target.removeClass("e-hover");
                }
                $target.hasClass("e-groupheadercell") && this.model.groupSettings.showUngroupButton && $target.find(".e-ungroupbutton").hide(150);
            }
            return false;
        },
        _groupingCompleteAction: function (args) {
            var $groupDrop = this.element.children(".e-groupdroparea");
            if (this.model.groupSettings.groupedColumns.length && $groupDrop.find(".e-grid-icon").length == 0 || ej.Grid.Actions.Refresh == args.requestType)
                $groupDrop.empty();
            if (this.initialRender || ej.Grid.Actions.Refresh == args.requestType) {
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                    this._addColumnToGroupDrop(this.model.groupSettings.groupedColumns[i]);
                this._refreshGridPager();
            } else
                this._addColumnToGroupDrop(args.columnName);
            this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").find(".e-ascending,.e-descending,.e-number").remove();
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
            if (!this.initialRender && ej.gridFeatures.dragAndDrop)
                this._groupHeaderCelldrag();
            this.model.allowScrolling && this.getContentTable().parent().scrollLeft(this.getHeaderTable().parent().scrollLeft() - 1);
            this.element.children(".e-cloneproperties").remove();
            if (ej.gridFeatures.filter && ["menu", "excel"].indexOf(this.model.filterSettings.filterType))
                this._refreshFilterIcon();
        },
        _ungroupingCompleteAction: function (args) {
            var $groupDrop = this.element.children(".e-groupdroparea");
            if (args.requestType != ej.Grid.Actions.Refresh)
               this._removeColumnFromDrop(args.columnName);
            this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").find(".e-ascending,.e-descending,.e-number").remove();
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
            if (this.model.groupSettings.groupedColumns.length == 0) {
                $groupDrop.html(this.model.groupSettings.enableDropAreaAutoSizing ? "" : this.localizedLabels.GroupDropArea);
                this.model.groupSettings.enableDropAreaAutoSizing && $groupDrop.append(ej.buildTag("div.e-animatebutton e-icon").addClass(this.model.groupSettings.enableDropAreaAutoSizing ? "e-animatebuttondown e-gdownarrow" : "e-animatebuttonup e-guparrow"));
                $groupDrop.css("height", "auto");
            }
            if (ej.gridFeatures.dragAndDrop)
                this._headerCellgDragDrop();
            if (this.model.allowReordering && ej.gridFeatures.dragAndDrop)
                this._headerCellreorderDragDrop();
            this.model.allowScrolling && this.getContentTable().parent().scrollLeft(this.getHeaderTable().parent().scrollLeft() -1);
            this.element.children(".e-cloneproperties").remove();
            if (ej.gridFeatures.filter && ["menu", "excel"].indexOf(this.model.filterSettings.filterType))
                this._refreshFilterIcon();
        },
        _getToggleButton: function () {
            return ej.buildTag("span.e-togglegroupbutton e-icon e-gridgroupbutton", "&#160;");
        },
        _checkEinHeader: function (field) {
            var $headerCell = this.element.children(".e-gridheader").find("thead").find(".e-columnheader").find(".e-headercell");
            for (var i = 0; i < $headerCell.length; i++) {
                if ($.trim($headerCell.eq(i).find("div").attr("ej-mappingname")) == field)
                    return $headerCell.eq(i);
                else if (this.model.allowSorting && this.model.allowMultiSorting) {
                    var header = $($headerCell.eq(i)).clone();
                    header.find(".e-number").remove();
                    if ($.trim(header.find("div").attr("ej-mappingname")) == field)
                        return header;
                }
            }
            return null;

        },

        _checkEinGroupDrop: function (field) {
            var $groupHeaderCell = this.element.children(".e-groupdroparea").find(".e-grid-icon");
            for (var i = 0; i < $groupHeaderCell.length; i++) {
                if ($.trim($groupHeaderCell.eq(i).find("div").attr("ej-mappingname")) == field)
                    return $groupHeaderCell.eq(i);
            }
            return null;
        },

        _addColumnToGroupDrop: function (field) {
            var $groupedColumn = ej.buildTag("div.e-grid-icon e-groupheadercell"), $groupDropArea = this.element.find(".e-groupdroparea").first();
            var $childDiv = ej.buildTag("div", {}, {}, { "ej-mappingname": field }), imageDirection = "e-rarrowup-2x";
            var column = this.getColumnByField(field)
            if (column.disableHtmlEncode)
                $groupedColumn.append($childDiv.text(column.headerText));
            else if (column.headerTemplateID)
                $groupedColumn.append($childDiv.html($(column.headerTemplateID).html()))
            else
                $groupedColumn.append($childDiv.html(column.headerText));
            var $headerCell = this._checkEinHeader(field);
            if (this.model.groupSettings.showToggleButton) {
                $childDiv.append(this._getToggleButton().addClass("e-toggleungroup"));
                $headerCell.find(".e-headercelldiv").find(".e-togglegroupbutton").remove().end().append(this._getToggleButton().addClass("e-toggleungroup"));
            }
            var direction = "ascending";
            if ($headerCell.find(".e-ascending,.e-descending").length) {
                direction = $headerCell.find(".e-ascending,.e-descending").hasClass("e-ascending") ? "ascending" : "descending";
                imageDirection = direction == "ascending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
            }
            $childDiv.append(this._createSortElement().addClass("e-" + direction + " " + imageDirection));
            this.model.groupSettings.showUngroupButton && $childDiv.append(ej.buildTag("span.e-ungroupbutton e-icon e-cancel", " ", {}, { title: this.localizedLabels.UnGroup }));
            $groupDropArea.append($groupedColumn).css("height", "auto");
            var left = $groupedColumn.offset().left, $cloned = $groupedColumn.clone().css("position", "absolute"), proxy = this;
            $groupedColumn.css("visibility", "hidden")
            $groupDropArea.append($cloned).dequeue();
            $cloned.css({ "left": left + 150 }).animate({ left: left }, 150, function (e) {
                $groupedColumn.css("visibility", "visible");
                $cloned.remove();
            });
        },
        _removeColumnFromDrop: function (field) {
            var headerText = this.getHeaderTextByFieldName(field), proxy = this, $groupDropArea = this.element.children(".e-groupdroparea");
            var $groupHeaderCell = $groupDropArea.css("height", "30px").find(".e-grid-icon");
            for (var i = 0; i < $groupHeaderCell.length; i++) {
                if ($.trim($groupHeaderCell.eq(i).find("div").attr("ej-mappingname")) == field) {
                    if (this.model.groupSettings.groupedColumns.length == 0) {
                        this.collapseGroupDropArea();
                    } else
                        $groupHeaderCell.eq(i).remove();
                }
            }
        },
        _setAggreatedCollection: function (clonedQuery) {
            if ((this._dataSource() instanceof ej.DataManager && this._dataManager.dataSource.url != undefined && !this._isRemoteSaveAdaptor && !this._dataManager.dataSource.offline) || this.model.enableLoadOnDemand)
                return;
            var data;
            data = this._dataManager.executeLocal(clonedQuery).result;
            this._aggregatedCollection = data;
        },
        _setAggregates: function (data, collection) {
            var indx, pred, query = new ej.Query();
            data = data || this.model.currentViewData, collection = collection || this._aggregatedCollection;
            var dLen = data.length, cLen;
            if (dLen != 0){
                var fieldPred = ej.Predicate("field", "equal", data[0].field), keyPred = ej.Predicate("key", "equal", data[0].key);
                if(data[0].key instanceof Date) {
                    var dateObject = { value: data[0].key, operator : "equal", field : "key" };
                    keyPred = this._setDateFilters(dateObject,true);
                }
                pred = (fieldPred["and"](keyPred));
            }
            for (indx = 1; indx < dLen; indx++) {
                var fieldPred = ej.Predicate("field", "equal", data[indx].field), keyPred = ej.Predicate("key", "equal", data[indx].key);
                if(data[indx].key instanceof Date) {
                    var dateObject = { value: data[indx].key, operator : "equal", field : "key" };
                    keyPred = this._setDateFilters(dateObject,true);
                }
                pred = pred["or"](fieldPred["and"](keyPred));
            }
            collection = pred ? new ej.DataManager(collection).executeLocal(query.where(pred)) : collection;
            cLen = collection.length;
            if (data.length > 0) {
                for (indx = 0; indx < cLen; indx++) {
                    if (indx > 0 && indx < cLen - 1) continue;
                    data[indx].count = collection[indx].count; 
                    if (data[indx].items.GROUPGUID)
                        this._setAggregates(data[indx].items, collection[indx].items);
                    if (this.model.showSummary) { 
                        var agg = data[indx]["aggregates"] = [];
                        var rows = this.model.summaryRows, scolumns, summaryData;
                        for (var row = 0, rlen = rows.length; row < rlen; row++) {
                            scolumns = rows[row].summaryColumns;
                            for (var col = 0, clen = scolumns.length; col < clen; col++) {
                                summaryData = collection[indx].items.level ? collection[indx].items.records : collection[indx].items;
                                agg[scolumns[col].dataMember + " - " + scolumns[col].summaryType] = this.getSummaryValues(scolumns[col], summaryData);
                            }
                        }
                    }
                }
            }
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    "use strict"
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.dragAndDrop = {
        _headerCellgDragDrop: function () {
            var proxy = this;
            this.dragHeaderElement();
            var $droppableElements = this.element.children("div.e-groupdroparea");
            $droppableElements.ejDroppable({
                accept: $droppableElements,
                drop: function (event, ui) {
                    if (ej.isNullOrUndefined(ui.helper) || !ui.helper.is(":visible"))
                        return;
                    var column = proxy.getColumnByField($.trim($(ui.draggable[0]).find("div").attr("ej-mappingname")));
                    ui.helper.remove();
                    if (proxy._disabledGroupableColumns.length && $.inArray(column["field"], proxy._disabledGroupableColumns) != -1)
                        return;
                    if (!(ej.isNullOrUndefined(column)) && (!(ej.isNullOrUndefined(column.field) || column.field == "")))
                        proxy.groupColumn(column.field);
                    if (proxy.model.allowGrouping)
                        proxy.collapseGroupDropArea();
                }
            });
        },
        _headerCellreorderDragDrop: function () {
            var proxy = this;
            this.dragHeaderElement();
            var $droppableElements = this.element.find(".e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell");
            $droppableElements.ejDroppable({
                accept: $droppableElements,
                drop: function (event, ui) {
                    if (ej.isNullOrUndefined(ui.helper) || !ui.helper.is(":visible") || $(ui.draggable[0]).closest('.e-grid').attr("id") != proxy._id)
                        return;
                    if (ui.draggable.attr("aria-sort") == "ascending" || ui.draggable.attr("aria-sort") == "descending") {
                        var scolumn = proxy.getColumnByField($.trim($(ui.draggable[0]).find("div").attr("ej-mappingname")));
                        if (proxy.model.allowSorting && proxy.model.allowMultiSorting)
                            proxy._scolumns.push(scolumn.field);
                        else
                            proxy._gridSort = scolumn.field;
                    }
                    var column, dropcolumn, fromindex, toindex, droppedIndex;
                    var draggedIndex = ui.draggable.index();
                    if (event.dropTarget.hasClass("e-headercelldiv"))
                        droppedIndex = event.dropTarget.parent().index();
                    else if (event.dropTarget.parent().hasClass("e-headercell") || event.dropTarget.hasClass("e-headercell"))
                        droppedIndex = event.dropTarget.index();
                    if ($(event.dropTarget).hasClass("e-number") || $(event.dropTarget).hasClass("e-icon"))
                        droppedIndex = event.dropTarget.closest(".e-headercell").index();
                    if (proxy.model.scrollSettings.frozenColumns > 0) {
                        fromindex = ui.draggable.closest('.e-frozenheaderdiv').length > 0 ? draggedIndex : draggedIndex + proxy.model.scrollSettings.frozenColumns;
                        toindex = event.dropTarget.closest('.e-frozenheaderdiv').length > 0 ? droppedIndex : droppedIndex + proxy.model.scrollSettings.frozenColumns;
                    }
                    else {
                        fromindex = draggedIndex;
                        toindex = droppedIndex;
                    }
                    if (proxy.model.allowGrouping && proxy.model.groupSettings.groupedColumns.length > 0) {
                        fromindex = fromindex - proxy.model.groupSettings.groupedColumns.length;
                        toindex = toindex - proxy.model.groupSettings.groupedColumns.length;
                    }
                    else if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                        fromindex = fromindex - 1;
                        toindex = toindex - 1;
                    }
                    column = proxy.getColumnByIndex(fromindex);
                    dropcolumn = proxy.getColumnByIndex(toindex);
                    var field = !ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.field) && column.field != "" ? column.field : null;
                    var field2 = !ej.isNullOrUndefined(dropcolumn.field) && dropcolumn.field != "" ? dropcolumn.field : null;
                    ui.helper.remove();
                    var header = $(event.dropTarget).clone();
                    header.find(".e-number").remove();
                    if (!ej.isNullOrUndefined(field) && !ej.isNullOrUndefined(field2)) {
                        if ($(event.dropTarget).hasClass("e-droppable")) {
                            header = header.children(".e-headercelldiv");
                            var eDropTarget = $(event.dropTarget).children(".e-headercelldiv");
                        }
                        else {
                            header = $(event.dropTarget).parent();
                            var eDropTarget = $(event.dropTarget);
                            if ($(eDropTarget).hasClass("e-filtericon"))
                                eDropTarget = header = $(eDropTarget).siblings(".e-headercelldiv");
                        }
                        if (proxy.model.allowSorting && proxy.model.allowMultiSorting)
                            if (event.dropTarget.hasClass("e-number") || event.dropTarget.hasClass("e-icon")) {
                                var toColumn = proxy.getColumnByField($.trim(header.attr("ej-mappingname")));
                            }
                            else {
                                var toColumn = proxy.getColumnByField($.trim(eDropTarget.attr("ej-mappingname")));
                            }
                        else {
                            if (event.dropTarget.hasClass("e-icon") && !event.dropTarget.hasClass("e-filtericon"))
                                var toColumn = proxy.getColumnByField($.trim(header.attr("ej-mappingname")));
                            else
                                var toColumn = proxy.getColumnByField($.trim(eDropTarget.attr("ej-mappingname")));
                        }
                        proxy.reorderColumns(column.field, toColumn.field);
                    }
                    else {
                        proxy.reorderColumns(fromindex, toindex);
                    }
                    if (proxy.model.allowGrouping)
                        proxy.collapseGroupDropArea();
                }
            });
        },

        dragHeaderElement: function () {
            var proxy = this;
            var $dragableElements = this.element.children("div.e-gridheader").find("th.e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell");
            var $visualElement = ej.buildTag('div.e-cloneproperties e-grid', "", { 'height': '20px', 'z-index': 2 }), column;
            //header element columnDrag
            $dragableElements.ejDraggable({
                cursorAt: { top: 0, left: 0 },
                helper: function (event, ui) {
                    if (proxy.element.find(".e-dragclone").length > 0) proxy.element.find(".e-dragclone").remove();
                    var $th, hcell;
                    if ($(event.element).hasClass("e-headercell"))
                        $th = $(event.element);
                    else
                        $th = $(event.element).closest("th");
                    hcell = $th.find(".e-headercelldiv");
                    var columnIndex = $(event.element).index();
                    if (proxy.model.allowGrouping && proxy.model.groupSettings.groupedColumns.length > 0)
                        columnIndex = columnIndex - proxy.model.groupSettings.groupedColumns.length;
                    else if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null)
                        columnIndex = columnIndex - 1;
                    column = proxy.getColumnByIndex(columnIndex);
                    proxy._$curSElementTarget = hcell; 
                    if (proxy.model.allowSorting && proxy.model.allowMultiSorting) {
                        var header = $($th).clone();
                        header.find(".e-number").remove();
                        return $visualElement.text(header.text()).clone().width($th.outerWidth() + 2).height($th.height() + 2).css({ "font-size": parseInt(($th.height() + 3) / 2) }).addClass("e-dragclone").appendTo(proxy.element);
                    }
                    else
                        return $visualElement.text($th.text()).clone().width($th.outerWidth() + 2).height($th.height() + 2).css({ "font-size": parseInt(($th.height() + 3) / 2) }).addClass("e-dragclone").appendTo(proxy.element);
                },
                dragStart: function (args) {
                    var target = args.target , $target = $(target);
                    var data = { target: target, draggableType: "headercell", column: column }, isGrouped, toggleClass, dragOnToggle = false;
                    if (proxy.model.groupSettings.showToggleButton && column && column.allowGrouping) {
                        isGrouped = $.inArray(column.field, proxy.model.groupSettings.groupedColumns);
                        toggleClass = $(args.element).find(".e-togglegroupbutton").hasClass("e-togglegroup");
                        if ((isGrouped != -1 && toggleClass) || (isGrouped == -1 && !toggleClass))
                            dragOnToggle = true;
                    }
                    if ((proxy._resizer != null && proxy._resizer._expand) || dragOnToggle || $target.eq(0).hasClass("e-filtericon") || (column && column.allowGrouping == false && column.allowReordering == false)) {
                        $(".e-dragclone").remove();
                        return false;
                    }
                    proxy._dragActive = true; 
                    if (proxy.model.allowGrouping)
                        proxy.expandGroupDropArea();
                    if (proxy._trigger("columnDragStart", data))
                        return false;
                },
                drag: function (args) {
                    var $target = $(args.target);
                    var data = { target: $target, draggableType: "headercell", column: column };
                    if (proxy._trigger("columnDrag", data))
                        return false;
                    if ($target.closest(".e-grid").attr("id") !== proxy._id)
                        return;
                    proxy.getHeaderTable().find(".e-headercell").removeClass("e-reorderindicate");
                    if (proxy.model.allowReordering && ($target.hasClass('e-headercelldiv') || $target.hasClass('e-headercell')) && !$target.hasClass('e-detailheadercell') && !$target.hasClass('e-stackedHeaderCell') && !$target.parent().hasClass("e-grouptopleftcell")) {
                        document.body.style.cursor = '';
                        $target.addClass("e-allowDrop");
                        proxy.getHeaderTable().find(".e-reorderindicate").removeClass("e-reorderindicate");
                        if ($target.hasClass('e-headercell')) $target.addClass("e-reorderindicate");
                        else $target.parent().addClass("e-reorderindicate");
                    }
                    if (proxy.model.allowScrolling) {
                        var pos = args.event.type == "touchmove" ? args.event.originalEvent.touches[0].pageX : args.event.pageX;
                        proxy._dragAutoScrollX(pos, args);
                    }
                    if ($target.hasClass('e-groupdroparea') || $target.closest('.e-groupdroparea').length) {
                        document.body.style.cursor = 'default';
                        $target.addClass("e-allowDrop");
                    }
                    else if ($target.hasClass('e-headercelldiv') || $target.hasClass('e-headercell')) {
                        document.body.style.cursor = 'pointer';
                    } else if ($target.hasClass("e-rowcell"))
                        document.body.style.cursor = 'not-allowed';
                },
                dragStop: function (args) {
                    if (!args.element.dropped) {
                        var $target = $(args.target);
                        var data = { target: $target, draggableType: "headercell", column: column };
                        proxy._trigger("columnDrop", data);
                        proxy.element.find(".e-groupdroparea").removeClass("e-hover");
                        proxy.getHeaderTable().find(".e-columnheader").find(".e-headercellactive").removeClass("e-headercellactive").removeClass("e-active");
                        if (!($(args.target).closest(".e-groupdroparea").length || ($(args.target).closest(".e-columnheader").length && proxy.model.allowReordering && !$(args.target).hasClass("e-stackedHeaderCell"))))
                            $(".e-dragclone").remove();
                        if ($(args.target).hasClass("e-rowcell") || $(args.target).hasClass("e-stackedHeaderCell"))
                            proxy.collapseGroupDropArea();
                        proxy._dragActive = false;
                        proxy.getHeaderTable().find(".e-reorderindicate").removeClass("e-reorderindicate");
                        document.body.style.cursor = '';
                        $(proxy._Indicator).css('display', 'none');
                    }
                }
            });
        },
        _groupHeaderCelldrag: function () {
            //grouped header cell drag.
            var $visualElement = ej.buildTag('div.e-cloneproperties e-grid', "", { 'height': '20px', 'z-index': 2 }), proxy;
            proxy = this;
            var $groupedHeaderCells = this.element.children(".e-groupdroparea").find(".e-groupheadercell");
            $groupedHeaderCells.ejDraggable({
                cursorAt: { top: 0, left: 0 },
                helper: function (event, ui) {
                    var $div = $(event.sender.target).closest(".e-grid-icon");
                    return $visualElement.text($(event.sender.target).closest(".e-groupheadercell").text()).clone().width($div.width() + 2).height($div.height() + 2).addClass("e-dragclone").appendTo(proxy.element);
                },
                dragStart: function (args) {
                    var target = args.target;
                    args.model.cursorAt = { top: 0, left: 0 };
                    var data = { target: target, draggableType: "groupheadercell" };
                    if (proxy._trigger("columnDragStart", data))
                        return false;
                },
                drag: function (args) {
                    $(".Sibling").remove();
                    var $target = $(args.target);
                    var data = { target: $target, draggableType: "groupheadercell" };
                    if (proxy._trigger("columnDrag", data))
                        return false;
                    if ($target.closest('div.e-gridcontent').length) {
                        document.body.style.cursor = '';
                        $target.addClass("e-allowDrop");
                    }
                    else if ($(args.target).closest(".e-columnheader").length > 0) {
                        document.body.style.cursor = 'pointer';
                    }
                    else
                        document.body.style.cursor = 'not-allowed';
                },
                dragStop: function (args) {
                    $(args.element).data("targetInstance", proxy);
                    if (!args.element.dropped) {
                        var $target = $(args.target);
                        var data = { target: $target, draggableType: "groupheadercell" };
                        if (!($(args.target).closest(".e-rowcell").length || $(args.target).closest(".e-groupcaption").length || $(args.target).closest(".e-columnheader").length ))
                            $(".e-dragclone").remove();
                        document.body.style.cursor = '';
                    }
                }
            });

            //grid content drop
            var $contentDroppableElements = this.element.children(".e-gridcontent, .e-gridheader");
            $contentDroppableElements.ejDroppable({
                accept: proxy.element.children("div.e-groupdroparea").find(".e-groupheadercell"),
                drop: function (event, ui) {
                    if (ej.isNullOrUndefined(ui.helper) || !ui.helper.is(":visible") || !ui.draggable.hasClass("e-groupheadercell"))
                        return;
                    var field = $(ui.draggable[0]).find("div").attr("ej-mappingname");
                    ui.helper.remove();
                    if (!ej.isNullOrUndefined(field)) {
                        var childProxy = $(ui.draggable).data("targetInstance");
                        childProxy.ungroupColumn(field);
                    }
                }
            });
        },

        //Rows DragAndDrop
        _rowsDragAndDrop: function () {
            this.dragRowElement();
            var $droppableElements = this.getContentTable();
            var proxy = this;
            $droppableElements.ejDroppable({
                accept: $droppableElements,
                drop: function (event, ui) {
                    var targetRow = $(event.dropTarget).closest("tr"), srcControl, currentPageIndex;
                    if (!ui.helper.find("tr.e-srcgridinfo").length)
                        return false;
                    proxy._draggedGridID = ui.helper.find("tr.e-srcgridinfo").children("td").text();
                    if (proxy._draggedGridID != proxy._id)
                        srcControl = $("#" + proxy._draggedGridID).ejGrid("instance");
                    else
                        srcControl = proxy;
                    if (srcControl._id != proxy._id && srcControl.model.rowDropSettings.dropTargetID != "#" + proxy._id)
                        return false;
                    var records =srcControl.selectedRowsIndexes.length >0 ? srcControl.getSelectedRecords():$(srcControl._currentJsonData[srcControl._dragIndex]);
                    if(!ej.isNullOrUndefined(srcControl._dragIndex))
					  srcControl._dragIndex = null;
					var targetIndex = currentPageIndex = proxy.getIndexByRow(targetRow), count = 0;
                     if (targetIndex == -1)
                        targetIndex = currentPageIndex = 0
                    targetIndex = targetIndex + (proxy._currentPage() * proxy.model.pageSettings.pageSize) - proxy.model.pageSettings.pageSize;
                    var dropDetails = { sourceID: srcControl._id, destinationID: proxy._id, destinationRowIndex: targetIndex };
                    var args = { target: targetRow, targetIndex: targetIndex, draggedRecords: records, dropDetails: dropDetails };
                    if (proxy._trigger("beforeRowDrop", args))
                        return;
                    var dataSource = proxy._dataSource() instanceof ej.DataManager ? proxy._dataSource().dataSource : proxy._dataSource();
                    if (!ej.isNullOrUndefined(proxy.model.rowDropSettings.dropMapper)) {
                        if (ej.isNullOrUndefined(dataSource.headers))
                            dataSource.headers = [];
                        dataSource.headers.push({ rowDropDetails: JSON.stringify(dropDetails) });
                    }
                    if (proxy._id != srcControl._id) {
                        var dm = proxy._dataManager, adaptor = proxy._dataSource().adaptor;
                        var srcBatch = srcControl.getBatchChanges();
                        srcBatch["deleted"] = records;
                        var args = { dropDetails: dropDetails, records: records, requestType: ej.Grid.Actions.Refresh, targetIndex: targetIndex, action: "rowDragged" };
                        proxy._processDropRequest(srcControl, srcBatch, "drag", args);

                        var batch = proxy.getBatchChanges(); batch["added"] = records;
                        args.action = "rowDropped";
                        proxy._processDropRequest(proxy, batch, "drop", args);
                    }
                    else {
                        if (proxy._draggedGridID == proxy._id) {
                            proxy.reorderRows(srcControl.selectedRowsIndexes, currentPageIndex);
                            $(".e-dragclone").remove();
                        }
                    }
                }
            });
        },
        _dragAutoScrollX: function (pos, args) {
            var Position = pos - this.element.offset().left;
            var contentwidth = this.element.width() - this.model.scrollSettings.scrollerSize;
            var scrollObj = this.getScrollObject();
            var proxy = this;
            if (scrollObj && scrollObj._hScrollbar) {
                if (Position < 5) {
                    this._dragLeftInterval = setInterval(function () {
                        if (proxy._dragLeftInterval) {
                            var scrolLeft = scrollObj.scrollLeft();
                            var AvgWidth = ej.sum(proxy.columnsWidthCollection) / proxy.model.columns.length;
                            if (scrolLeft > scrollObj._hScrollbar.model.minimum) {
                                if (scrolLeft > AvgWidth)
                                    scrollObj.scrollX(scrollObj.scrollLeft() - AvgWidth, true);
                                else
                                    scrollObj.scrollX(scrollObj._hScrollbar.model.minimum, true);
                            }
                            else
                                proxy._dragLeftInterval && (proxy._dragLeftInterval = clearInterval(proxy._dragLeftInterval));
                        }
                    }, 500);
                }
                else if (Position > (contentwidth - 5)) {
                    this._dragRightInterval = setInterval(function () {
                        if (proxy._dragRightInterval) {
                            var scrollLeft = scrollObj.scrollLeft();
                            var AvgWidth = ej.sum(proxy.columnsWidthCollection) / proxy.model.columns.length;
                            if (Math.round(scrollLeft) < scrollObj._hScrollbar.model.maximum)
                                scrollObj.scrollX(scrollObj.scrollLeft() + AvgWidth, true);
                            else
                                proxy._dragRightInterval && (proxy._dragRightInterval = clearInterval(proxy._dragRightInterval));
                        }
                    }, 500);
                }
                else {
                    this._dragLeftInterval && (this._dragLeftInterval = clearInterval(this._dragLeftInterval));
                    this._dragRightInterval && (this._dragRightInterval = clearInterval(this._dragRightInterval));
                }
            }
        },
        _dragAutoScroll: function (proxy, args) {
            var scrollObj = proxy.getContent().data("ejScroller");
            var contentOffset = proxy.getContent()[0].getBoundingClientRect();
            if (!contentOffset)
                contentOffset = proxy.getContent().offset();
            if (scrollObj && scrollObj._vScrollbar) {
                if (contentOffset.top >= args.event.clientY) {
                    proxy._dragUpInterval = setInterval(function () {
                        if (proxy._dragUpInterval) {
                            var scrollPixel = -proxy.getRowHeight();
                            var scrolTop = scrollObj.scrollTop();
                            if (scrolTop != 0)
                                scrollObj.scrollY(scrollObj.scrollTop() + scrollPixel, true);
                            else
                                proxy._dragUpInterval && (proxy._dragUpInterval = clearInterval(proxy._dragUpInterval));

                        }
                    }, 500);

                }
                else if (contentOffset.top + proxy.getContent().height() <= args.event.clientY) {
                    proxy._dragDownInterval = setInterval(function () {
                        if (proxy._dragDownInterval) {
                            var scrollPixel = proxy.getRowHeight();
                            var scrolTop = scrollObj.scrollTop();
                            if (Math.round(scrolTop) <= scrollObj._vScrollbar.model.maximum)
                                scrollObj.scrollY(scrollObj.scrollTop() + scrollPixel, true);
                            else
                                proxy._dragDownInterval && (proxy._dragDownInterval = clearInterval(proxy._dragDownInterval));

                        }
                    }, 500);

                }
                else {
                    proxy._dragUpInterval && (proxy._dragUpInterval = clearInterval(proxy._dragUpInterval));
                    proxy._dragDownInterval && (proxy._dragDownInterval = clearInterval(proxy._dragDownInterval));
                }
            }
        },
        dragRowElement: function () {
            var proxy = this;
            var $dragableElements = $(this.getRows());
            var column;
            //header element columnDrag
            $dragableElements.ejDraggable({
                cursorAt: { top: -8, left: -8 },
                helper: function (event, ui) {
                    this.clone = true;
                    var tr = $(event.element).closest("tr"),$tr;
                    if (proxy._selectDrag || !tr.length || ($.inArray(proxy.getIndexByRow(tr), proxy.selectedRowsIndexes) == -1 && proxy.model.selectionType != "single") )
                        return false;
                    var $visualElement = ej.buildTag('div.e-cloneproperties e-draganddrop e-grid', "", { 'height': 'auto', 'z-index': 2, 'position': 'absolute', 'width': proxy.element.width() }), $tr;
                    $visualElement.append(ej.buildTag("table", "", { 'width': proxy.element.width() }));
                    var rows = $(proxy.getRows()).clone().removeClass();
                    var height = 0;
					if(proxy.model.selectionType != "single" && proxy.selectedRowsIndexes.length >0){
						$tr = $.map(rows, function (ele, idx) {
						if ($.inArray(idx, proxy.selectedRowsIndexes) != -1) {
                            return ele
                        }
						$($tr).find("td").removeClass("e-selectionbackground e-active");
						if (!tr.find("td.e-selectionbackground").length)
							$visualElement.css("display", "none");
						});
					}
					else
						$tr = tr.clone();
                    var infoTr = ej.buildTag('tr.e-srcgridinfo e-grid', "", { 'display': 'none', 'height': 'auto' }).append("<td>" + proxy._id + "</td>");
                    $tr.push(infoTr[0]);
                    $visualElement.find("table").append($tr);
                      return $visualElement.addClass("e-dragclone").appendTo($('body'));
                },
                dragStart: function (args) {
                    var tr = $(args.target).closest("tr");
                    if (proxy._selectDrag ||($.inArray(proxy.getIndexByRow(tr), proxy.selectedRowsIndexes) == -1 && proxy.model.selectionType != "single"))
                        return false;
                    var target = args.target;
                    var rows = proxy.selectedRowsIndexes.length >0  ?proxy.getRowByIndex(proxy.selectedRowsIndexes[0], proxy.selectedRowsIndexes[proxy.selectedRowsIndexes.length]):tr;
                    if(proxy.model.selectionType != "single" && proxy.selectedRowsIndexes.length >0)
					{
						var records = proxy.getSelectedRecords();	
					}
					 else{
						proxy._dragIndex=proxy.getIndexByRow(tr);
						var records = proxy._currentJsonData[proxy._dragIndex];				
					}	
                    var data = { target: rows, currentTarget: target, draggableType: "rows", data: records, draggedRecords: records };
                    if (proxy._trigger("rowDragStart", data))
                        return false;
                },
                drag: function (args) {
                    var $target = $(args.target);
                    var rows = proxy.selectedRowsIndexes.length >0?proxy.getRowByIndex(proxy.selectedRowsIndexes[0], proxy.selectedRowsIndexes[proxy.selectedRowsIndexes.length]):proxy.getRowByIndex(proxy._dragIndex);
					var records = proxy.selectedRowsIndexes.length >0?proxy.getSelectedRecords():proxy._currentJsonData[proxy._dragIndex];
					var data = { target: rows, currentTarget: $target, draggableType: "rows", data: records, draggedRecords: records};
                    proxy._dragAutoScroll(proxy, args);
                    if (proxy._trigger("rowDrag", data))
                        return false;
                    document.body.style.cursor = 'not-allowed';
                    var dropEle = $(proxy.model.rowDropSettings.dropTargetID);
                    if ($target.closest(proxy.model.rowDropSettings.dropTargetID).length || $target.closest("#" + proxy._id).length) {
                        if ($target.closest(".e-grid").length && ($target.closest(".e-rowcell").length || $target.closest(".emptyrecord").length))
                            $target.closest("table").addClass("e-allowRowDrop")
                        else if (!dropEle.hasClass("e-grid"))
                            dropEle.addClass("e-allowRowDrop");
                    }
                },
                dragStop: function (args) {
                    if (!args.element.dropped) {
                        proxy._dragUpInterval && (proxy._dragUpInterval = clearInterval(proxy._dragUpInterval));
                        proxy._dragDownInterval && (proxy._dragDownInterval = clearInterval(proxy._dragDownInterval));
                        var $target = $(args.target);
                        var rows = proxy.selectedRowsIndexes.length >0?proxy.getRowByIndex(proxy.selectedRowsIndexes[0], proxy.selectedRowsIndexes[proxy.selectedRowsIndexes.length]):proxy.getRowByIndex(proxy._dragIndex);
                        var records = proxy.selectedRowsIndexes.length >0?proxy.getSelectedRecords():proxy._currentJsonData[proxy._dragIndex];
 						document.body.style.cursor = '';
                        var dropEle = $(proxy.model.rowDropSettings.dropTargetID);
                        dropEle.hasClass("e-grid") ? dropEle.find(".e-gridcontent").find("table").removeClass("e-allowRowDrop") : dropEle.removeClass("e-allowRowDrop");
                        proxy.getContent().find("table").removeClass("e-allowRowDrop");
                        var data = { rows: rows, target: $target, draggableType: "rows", data: records, droppedRecords: records };
						if(ej.isNullOrUndefined(this._checkTargetElement(args.event)))
						  $(".e-dragclone").remove();
                        if (proxy._trigger("rowDrop", data))
                            return false;
                    }
                }
            });
        },
        _processDropRequest: function (cntrl, batch, action, args) {
			if(args.action == "rowDragged")
				$(".e-dragclone").remove();
            var mapper = cntrl._dataManager.dataSource.batchUrl;
            cntrl._dataManager.dataSource.batchUrl = cntrl.model.rowDropSettings[action + "Mapper"];
            var dragPromise = cntrl._dataManager.saveChanges(batch, cntrl._primaryKeys[0], cntrl.model.query._fromTable);
            if ($.isFunction(dragPromise.promise) && cntrl._dataManager.dataSource.batchUrl != null) {
                $("#" + cntrl._id).data("ejWaitingPopup").show();
                dragPromise.done(function (e) {
                    if (cntrl._isLocalData && (action == "drop")) {
                        if (args.dropDetails.sourceID == args.dropDetails.destinationID)
                            cntrl._moveDroppedRowIndex(args.targetIndex, args.records, args.draggedRowIndexes);
                        else
                            cntrl._moveDroppedRowIndex(args.targetIndex, args.records);
                    }
                    if (action == "drop")
                        cntrl._dataSource() instanceof ej.DataManager ? cntrl._dataSource().dataSource.headers.pop() : cntrl._dataSource().headers.pop();
                    cntrl._dataManager.dataSource.batchUrl = mapper;
                    cntrl.refreshBatchEditChanges();
                    $("#" + cntrl._id).data("ejWaitingPopup").hide();
                    cntrl._processBindings(args);
                });
                dragPromise.fail(function (e) {
                    cntrl._dataManager.dataSource.batchUrl = mapper;
                    $("#" + cntrl._id).data("ejWaitingPopup").hide();
                    args.error = (e && e.error) ? e.error : e;
                    cntrl._trigger("actionFailure", args)
                });
            }
            else {
                cntrl.refreshBatchEditChanges();
                cntrl._dataManager.dataSource.batchUrl = mapper;
                if (action == "drop")
                    cntrl._moveDroppedRowIndex(args.targetIndex, args.records);
                if (!(args.dropDetails.sourceID == args.dropDetails.destinationID && action == "drag"))
                    cntrl._processBindings(args);
            }
        },
        reorderRows: function (indexes, toIndex) {
            if (!this.model.sortSettings.sortedColumns.length) {
                var records = this.getSelectedRecords();
                this.selectedRowsIndexes = [];
                var args = { requestType: ej.Grid.Actions.Refresh, action: "rowReordering", draggedRowIndexes: indexes, targetIndex: toIndex, dropDetails: { sourceID: this._id, destinationID: this._id, DestinationRowIndex: toIndex }, records: records };
                if (ej.isNullOrUndefined(this.model.rowDropSettings.dropMapper)) {
                    if (this._trigger("actionBegin", args))
                        return false;
                    this._moveDroppedRowIndex(toIndex, records, indexes);
                    this._trigger("actionComplete", args)
                } else {
                    var batch = this.getBatchChanges();
                    batch["changed"] = records;
                    this._processDropRequest(this, batch, "drop", args);
                }
            }
        },
        _moveDroppedRowIndex: function (targetIndex, records, reorderFrom) {
            if (!ej.isNullOrUndefined(reorderFrom)) {
                var reorderFrom = reorderFrom.sort(function (a, b) { return a - b });
                var currentargetIndex = targetIndex, skip, index, count = 0;
                var currentRecords = this.model.currentViewData.slice();
                var targetRow = this.getRowByIndex(targetIndex);
                targetIndex += (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                for (var i = 0; i < reorderFrom.length; i++) {
                    var data = currentRecords[reorderFrom[i]];
                    index = reorderFrom[i] - count;
                    skip = 0;
                    var rows = this._excludeDetailRows();
                    var srcRow = $(rows[index]);
                    if (currentargetIndex > index)
                        count++;
                    if (this.model.allowPaging)
                        skip = (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                    index = skip + index;
                    this.selectedRowsIndexes.push(currentargetIndex - count);
                    if (i == reorderFrom.length - 1)
                        this.model.selectedRowIndex = this.selectedRowsIndexes[0];
                    if ((this.model.detailsTemplate != null || this.model.childGrid != null) && srcRow.next().hasClass("e-detailrow"))
                        srcRow = srcRow.add(srcRow.next()[0]);
                    targetRow.before(srcRow);
                    if (currentargetIndex < reorderFrom[i] - count)
                        currentargetIndex++
                    else
                        targetIndex--;
                    if (!(this._dataSource() instanceof ej.DataManager))
                        this._dataSource().splice(targetIndex + i, 0, this._dataSource().splice(index, 1)[0])
                    else
                        this._dataSource().dataSource.json.splice(targetIndex + i, 0, this._dataSource().dataSource.json.splice(index, 1)[0])
                    this.model.currentViewData.splice(targetIndex + i - skip, 0, this.model.currentViewData.splice(index - skip, 1)[0])
                }
            }
            else if (targetIndex > -1) {
                var data = this._dataSource() instanceof ej.DataManager ? this._dataSource().dataSource.json : this._dataSource();
                var currentIndex = targetIndex + (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                for (var i = 0; i < records.length; i++) {
                    data.splice(targetIndex++, 0, data.splice(data.length - records.length + i, 1)[0]);
                }
            }
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    "use strict"
    ej.gridFeatures.selection = {
        
        selectRows: function (rowIndex, toIndex, target) {
            if (!this._allowrowSelection)
                return false;
            if (this._traverseRow != rowIndex)
                $(".e-traverse").removeClass("e-traverse");
            this._traverseRow = null;
            var rowIndexCollection = [];
			if(this.initialRender)
				this.model.currentIndex = rowIndex;
			if(this.model.scrollSettings.enableVirtualization){
				if ($.isArray(rowIndex))
					this.model.currentIndex = rowIndex[0];
				else if(toIndex){
					this.model.currentIndex = rowIndex > toIndex ? toIndex : rowIndex;
				}							
			}
            if (!this.multiSelectCtrlRequest && this.model.scrollSettings.allowVirtualScrolling) {
                if (!this._virtuaOtherPage) {
                    this.clearSelection();
                    this._virtualScrollingSelection = false;
                }
                else
                    this._virtualScrollingSelection = true;
            }
            if ($.isArray(rowIndex)) {
                rowIndexCollection = rowIndex;
				rowIndex = rowIndexCollection[0];
				this._virtaulSel = [];
				if(this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization){										
					this._virtualScrollingSelection = true;
					this._virtualSelectedRows = rowIndexCollection;
					var from = (parseInt(rowIndex / this.model.pageSettings.pageSize)) * this.model.pageSettings.pageSize;
					var to = (parseInt((rowIndex / this.model.pageSettings.pageSize)) + 1) * this.model.pageSettings.pageSize;
					this._virtaulSel.push(rowIndex);
					if (!this._virtuaOtherPage)
						this._virtaulUnSel = []
					for (var i = 1; i < rowIndexCollection.length; i++) {
						if (from < rowIndexCollection[i] && rowIndexCollection[i] < to)
							this._virtaulSel.push(rowIndexCollection[i]);
						else
							this._virtaulUnSel.push(rowIndexCollection[i]);
					}										
				}
            }

            var $gridRows = $(this.getRows()),Data;
            if (this.model.allowScrolling && (this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows ==0 )) {
                var selectedRow = $gridRows.eq(rowIndex)[0];
                if (!ej.isNullOrUndefined(selectedRow) && this.model.groupSettings.groupedColumns.length == 0) {
                    var scrollTop = this.getScrollObject().scrollTop();
                    var ContentViewHeight = scrollTop + this.getScrollObject().content()[0].clientHeight;
                    var selectedRowPos = selectedRow.offsetTop + selectedRow.offsetHeight;
                    var pixel = selectedRow.offsetTop, scrollObj = this.getScrollObject();
                    if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                        selectedRowPos += (ej.min(this._currentLoadedIndexes) - 1) * this._virtualRowCount * this._vRowHeight;
                        pixel = (this.model.currentIndex * this._vRowHeight) + rowIndex + selectedRow.offsetHeight;
                    }
                    var scrollBottom = ((selectedRowPos - this._vRowHeight) <= scrollTop && selectedRowPos < ContentViewHeight);
                    if (!ej.isNullOrUndefined(selectedRow) && ContentViewHeight < selectedRowPos || scrollBottom) {
                        if (scrollBottom) pixel = selectedRowPos - selectedRow.offsetHeight;
                        scrollObj.scrollY(pixel);
                    }
                }
            }
            var args = {}, ascend, res, currentPage = this._currentPage() - 1, pageSize = this.model.pageSettings.pageSize;
            if (!this.model.scrollSettings.enableVirtualization) {
                var nameIndx = this.getRowByIndex(rowIndex).attr("name");
                var pageIndex = !ej.isNullOrUndefined(nameIndx) ? (parseInt(nameIndx) / pageSize) + 1 : rowIndex;
            }
            if (!ej.isNullOrUndefined(rowIndex)) {
                if (this.model.editSettings.editMode == "batch" && $($gridRows[rowIndex]).hasClass("e-insertedrow")) {
                    var addedrows = this.batchChanges.added.reverse();
                    Data = addedrows[rowIndex];
                    this.batchChanges.added.reverse();
                }
                else
                    Data = this.model.editSettings.editMode == "batch"?this._currentJsonData[rowIndex - this.batchChanges.added.length]:this._currentJsonData[ej.isNullOrUndefined(rowIndex) ? toIndex : rowIndex];
            }
            var $rowIndex = rowIndex, $prevIndex = this._previousIndex, $prevRow = this.getRowByIndex(this._previousIndex), isSelection = "selectRows";
            args = { rowIndex: $rowIndex, row: $gridRows.eq(rowIndex), data: Data, selectedData: Data, target: target, prevRow: $prevRow, prevRowIndex: $prevIndex };
            if (this.model.scrollSettings.allowVirtualScrolling) {
                args = this._getVirtualRows(rowIndex, target, isSelection, rowIndexCollection);
                if (!this.model.scrollSettings.enableVirtualization)
                    rowIndex = args.rowIndex;
                Data = args.data;
                $rowIndex = args.rowIndex;
                $prevIndex = args.prevRowIndex;
                $prevRow = args.prevRow;
            }
            if (this._trigger("rowSelecting", args))
                return;
            if (target && target.hasClass("e-checkselectall") && this._isLocalData && this._isMapSelection)
                return this._headerCheckUpdateAll(!target[0].checked);
            var $gridRows = $(this.getRows());
            if (this._isMapSelection && !this._selectionByGrid && ej.isNullOrUndefined(toIndex)) {
                if (!rowIndexCollection.length) {
                    Data[this._selectionMapColumn] = !args.row.find(".e-checkcelldiv input").prop("checked");
                    this.updateRecord(this._primaryKeys[0], Data, "update");
                    return;
                }
            }
            if ((this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) && this.model.isEdit && this.model.enableAutoSaveOnSelectionChange) {
                if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal") || this.getContentTable().find(".e-editedrow").length != 0) {
                    if (this.endEdit())
                        return; 
                    else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                        $("#" + this._id + "_externalEdit").css("display", "none");
                }
            }
            if (this.checkSelectedRowsIndexes[currentPage] == undefined && !this._isMapSelection)
                this.checkSelectedRowsIndexes[currentPage] = [];
            if (rowIndexCollection.length > 0) {
                for (var i = 0; i < rowIndexCollection.length; i++) {
                    this.selectedRowsIndexes.indexOf(rowIndexCollection[i]) == -1 && this.selectedRowsIndexes.push(rowIndexCollection[i]);
                    this._selectedMultipleRows(this.selectedRowsIndexes);
                    if (this._isMapSelection && !this._selectionByGrid) {
                        var cData = this._currentJsonData[rowIndexCollection[i]];
                        cData[this._selectionMapColumn] = true;
                        this.batchChanges.changed.push(cData);
                    }
                }
				if( !this.model.scrollSettings.enableVirtualization){
					var diff = this._virtaulSel[0] - rowIndex;
					for (var i = 0; i < this._virtaulSel.length; i++) {
						this._virtaulSel[i] -= diff;
					}
				}
                var rows = this.getRowByIndex(this.model.scrollSettings.allowVirtualScrolling ? this._virtaulSel : rowIndexCollection);
                if (this.model.scrollSettings.frozenColumns)
                    rows = $(rows[0]).add(rows[1]);
                $(rows).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                if (this._enableCheckSelect && !this._isMapSelection) {
                    $(rows).find(".e-checkcelldiv input").prop("checked", "checked");
                }
                Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                if (this._isMapSelection && !this._selectionByGrid) {
                    this.batchSave();
                    return;
                }
            }
            else if (ej.isNullOrUndefined(toIndex) || ej.isNullOrUndefined(rowIndex)) {
                rowIndex = ej.isNullOrUndefined(rowIndex) ? toIndex : rowIndex;
                $rowIndex = rowIndex;
                switch (this.model.selectionType) {
                    case ej.Grid.SelectionType.Multiple:
                        if (this.multiSelectCtrlRequest) {
							this.model.selectedRecords = [];
                            var selectedRowIndex = $.inArray($rowIndex, this.selectedRowsIndexes);
                            selectedRowIndex != -1 && !this._isMapSelection && this.clearSelection($rowIndex, target) && this.selectedRowsIndexes.splice(selectedRowIndex, 0);
                            if (selectedRowIndex == -1) {
                                this.selectedRowsIndexes.push($rowIndex);
								this._selectedMultipleRows(this.selectedRowsIndexes);
                                var tr = this.getRowByIndex(rowIndex);
                                tr.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                                if(!this.model.scrollSettings.enableVirtualization)
									this._virtualSelectAction(pageIndex, rowIndex, pageSize);
								else
                                    this._virtualSelectedRecords[$rowIndex] = this._getSelectedViewData(rowIndex, target).data;
                                if ((this._enableCheckSelect && target && !target.parent().hasClass("e-checkcelldiv")) || (ej.isNullOrUndefined(target) && this._enableCheckSelect))
                                    tr.find(".e-checkcelldiv input").prop("checked", "checked");
                            }
                            Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                            break;
                        }
                    case ej.Grid.SelectionType.Single:
                        this.clearSelection();
                        this.clearColumnSelection();
                        this.selectedRowsIndexes = [];
                        this.model.selectedRecords = [];
                        this._virtualSelectedRecords = {};
                        this.selectedRowsIndexes.push($rowIndex);
						this._selectedMultipleRows(this.selectedRowsIndexes);
                        this.getRowByIndex(rowIndex).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                        if(!this.model.scrollSettings.enableVirtualization)
							this._virtualSelectAction(pageIndex, rowIndex, pageSize);
						else
							this._virtualSelectedRecords[$rowIndex] = Data;
                        Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                        this._enableCheckSelect && this.getRowByIndex(rowIndex).find(".e-checkcelldiv [type=checkbox]").prop("checked", true);
                        break;
                }
            } else {
                if (this.model.selectionType == ej.Grid.SelectionType.Multiple) {
                    !this._isMapSelection && this.clearSelection();
                    this.clearColumnSelection();
                    this.selectedRowsIndexes = [];
                    this.model.selectedRecords = [];                  
					this._virtualSelectedRecords = {};
					var $toIndex = toIndex;					
					this._virtualUnSel = [];
					this._virtualUnSelIndexes = [];
					if (this._isMapSelection || !(target && target.hasClass("e-checkselectall") && target[0].checked)) {
					    if (this.model.scrollSettings.enableVirtualization && target) {
					        var viewIndex = this._getSelectedViewData(toIndex, target).viewIndex;
					        var remain = toIndex % this._virtualRowCount;
					        $toIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
					        if ($rowIndex != this._prevSelIndex) $rowIndex = this._prevSelIndex;
					    }
					    ascend = $rowIndex - $toIndex < 0;
                        var rows;
					    if (!this.model.scrollSettings.enableVirtualization)
					        rows = ascend ? this.getRowByIndex(rowIndex, toIndex + 1) : this.getRowByIndex(toIndex, rowIndex + 1);
					    if (this.model.scrollSettings.frozenColumns)
					        rows = $(rows[0]).add(rows[1]);
					    var rowIndexes = [];
					    for (var i = ascend ? $rowIndex : $toIndex, to = ascend ? $toIndex : $rowIndex; i <= to; i++) {
					        if (this.model.scrollSettings.allowVirtualScrolling) {
					            if (!this.model.scrollSettings.enableVirtualization) {
					                var nameIndx = this.getRowByIndex(i).attr("name");
					                var pageIndex = !ej.isNullOrUndefined(nameIndx) ? (parseInt(nameIndx) / pageSize) + 1 : rowIndex;
					                this._virtualSelectAction(pageIndex, i, pageSize);
					            }
					            else {
					                this._virtualSelectedRecords[i] = this._getSelectedViewData(i).data;
					                var viewIndex = this._getSelectedViewData(i).viewIndex;
					                if ($.inArray(viewIndex, this._currentLoadedIndexes) != -1) {
					                    var indx = this._currentLoadedIndexes.indexOf(viewIndex);
					                    var selIndex = i % this._virtualRowCount + indx * this._virtualRowCount;
					                    if (selIndex == 0) indx * this._virtualRowCount;
					                    rowIndexes.push(selIndex);
					                }
					                else {
					                    this._virtualUnSel.push(i);
					                    if ($.inArray(viewIndex, this._virtualUnSelIndexes) == -1)
					                        this._virtualUnSelIndexes.push(viewIndex);
					                }
					            }
					        }
					        this.selectedRowsIndexes.push(i);
                            this._selectedMultipleRows(this.selectedRowsIndexes);
					        if (this._isMapSelection && !this._selectionByGrid) {
					            var cData = this._currentJsonData[i];
					            cData[this._selectionMapColumn] = true;
					            this.batchChanges.changed.push(cData);
					        }
					    }
					    if (this._isMapSelection) {
					        this.batchSave();
					        return;
					    }
					    if (this.model.scrollSettings.enableVirtualization)
					        rows = this.getRowByIndex(rowIndexes[0], rowIndexes[rowIndexes.length - 1] + 1);
					    $(rows).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
					    Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
					    if (this._enableCheckSelect)
					        $(rows).find(".e-checkcelldiv input").prop("checked", "checked");
					}
                }
            }
            if (this._enableCheckSelect) {
                this.checkSelectedRowsIndexes[currentPage] = this.selectedRowsIndexes;
                if (!this._selectAllCheck) {
                    if (this.selectedRowsIndexes.length == this._currentJsonData.length || this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.selectedRowsIndexes.length == this._gridRecordsCount)
                        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").prop("checked", "checked");
                    else if (this._selectionByGrid)
                        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").prop("checked", false);
                }
            }
            if (this._selectedRow() !== $rowIndex && $(this.getRowByIndex($rowIndex)).attr("aria-selected") == "true")
                this._selectedRow($rowIndex);
            if (target && target.hasClass("e-checkselectall") && !this._isMapSelection) {
                var gridInstance = this;
				var totalPage = this._dataSource() instanceof ej.DataManager && this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling && !this.model.scrollSettings.enableVirtualization ? Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize) :this.model.pageSettings.totalPages;
                this.checkSelectedRowsIndexes = !target.is(":checked") ? $.map(Array(totalPage), function (x, i) {  x= Array($.map(Array(gridInstance.model.pageSettings.pageSize), function (x2,i2){ return i2})); return x;}) : [];
            }
            Data = this._virtualScrollingSelection ? this._virtualSelRecords : Data;
			var selectedIndex = this.model.scrollSettings.enableVirtualization ? $rowIndex : this._selectedRow();
            var args = { rowIndex: selectedIndex, row: this.getRowByIndex(this._selectedRow()), data: Data, selectedData: Data, target: target, prevRow: $prevRow, prevRowIndex : $prevIndex };
            this._previousIndex = this.selectedRowsIndexes.length ? rowIndex :this._previousIndex;
			if(this.model.scrollSettings.enableVirtualization){
				this._prevSelIndex = $rowIndex; 
				this._prevSelRow = this.getRowByIndex(rowIndex);
			}
			this.model._checkSelectedRowsIndexes = this.checkSelectedRowsIndexes;
			if ($(this.getRowByIndex(rowIndex)).is('[role="row"]') && $(this.getRowByIndex($rowIndex)).attr("aria-selected") == "true")
                this._trigger("rowSelected", args);            
        },
        _getVirtualRows: function (rowIndex, target, isSelection, rowIndexCollection) {
		    var $rowIndex = rowIndex,$prevIndex = this._previousIndex, $prevRow = this.getRowByIndex(this._previousIndex),res,Data,args = {};
		    var $gridRows = $(this.getRows());
		     if(this.model.scrollSettings.enableVirtualization){					
					var virtualRowCount = this._virtualRowCount;
					var currentIndex = !target ? Math.ceil((rowIndex + 1) / virtualRowCount) : parseInt($(this._gridRows[rowIndex]).attr("name"), 32);
					var rowCount = currentIndex > 1 ? this._virtualRowCount: 0;					
					if (this.initialRender || (currentIndex != this._currentVirtualIndex && !target)) {
					    this._isThumbScroll = true;
					    if ($.inArray(currentIndex, this._currentLoadedIndexes) == -1 && isSelection != "clearSelection")
						    this._refreshVirtualView(currentIndex, isSelection, rowIndex);
						rowIndex = rowIndex != 0 ? rowIndex % this._virtualRowCount + rowCount : rowIndex;			
						}					
					else {						
					    if (rowIndex > this._virtualRowCount * 3 || !ej.isNullOrUndefined(target) && !$(target).parent().hasClass("e-headercelldiv") && !ej.isNullOrUndefined(target[0]) && !target[0].checked) {
							var viewIndex = this._getSelectedViewData(rowIndex, target).viewIndex;
							var remain = rowIndex % this._virtualRowCount;
							$rowIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
						}
						else 
							rowIndex = rowIndex % this._virtualRowCount + rowCount;						
						if(rowIndex == $rowIndex && !target)
							rowIndex = rowIndex != 0 ? rowIndex % this._virtualRowCount + rowCount : rowIndex;			
						}
					if(rowIndexCollection.length){												
						for(var i = 0; i < rowIndexCollection.length; i++){
							var viewIndex = this._getSelectedViewData(rowIndexCollection[i]).viewIndex;
							if($.inArray(viewIndex, this._currentLoadedIndexes) != -1)
								this._virtaulSel.push(rowIndexCollection[i]);
							if(!this._virtualSelectedRecords[rowIndexCollection[i]])
								this._virtualSelectedRecords[rowIndexCollection[i]] =  this._getSelectedViewData(rowIndexCollection[i]).data;
						}					
					}
					Data = this._getSelectedViewData(rowIndex, target, currentIndex).data;
					$prevIndex = this._prevSelIndex;
					$prevRow = this._prevSelRow;
				}
				else{
					var pageSize = this.model.pageSettings.pageSize;
					var nameIndx = this.getRowByIndex(rowIndex).attr("name");
					var pageIndex = !ej.isNullOrUndefined(nameIndx) ? (parseInt(nameIndx) / pageSize) + 1 : rowIndex;
					var trIndex = (rowIndex) % (pageSize);
					var pageto = parseInt(rowIndex / pageSize);
					var nameattr = pageto * pageSize;
					if ((!ej.isNullOrUndefined(pageto) && pageto > 0 && $.inArray(nameattr, this.virtualLoadedPages) == -1) && ej.isNullOrUndefined(target)) {
						trIndex--; this._virIndex = true;
						this._virtualTrIndex=trIndex;
						this.gotoPage(pageto + 1);
						var proxy = this;
						if (this._dataSource() instanceof ej.DataManager) {
							this._queryPromise.done(function (e) {
								proxy._virtuaOtherPage=true;
								proxy._virtualdata = proxy._currentJsonData;
								proxy._pageTo = pageto;
								if(proxy._virtualScrollingSelection)
									proxy._virtualSelRecords = e.virtualSelectRecords;
								var from = (parseInt(rowIndex / proxy.model.pageSettings.pageSize)) * proxy.model.pageSettings.pageSize;
								var to = (parseInt((rowIndex / proxy.model.pageSettings.pageSize)) + 1) * proxy.model.pageSettings.pageSize;
								var _selctRow = []
								_selctRow.push(rowIndex);
								for (var i = 1; i < rowIndexCollection.length; i++)
									if (from < rowIndexCollection[i] && rowIndexCollection[i] < to)
										_selctRow.push(rowIndexCollection[i]);
								proxy.selectRows(_selctRow);
								return false;
							});
							if(proxy._virtualScrollingSelection)
								return;
						}
						else {
							proxy._virtualdata = proxy._currentJsonData;
							if (rowIndexCollection.length > 0) {
								proxy._virtualSelRecords = [];
								for (var i = 0; i < rowIndexCollection.length; i++) {
									proxy._virtualSelRecords.push(this.model.dataSource[rowIndexCollection[i]]);
								}
							}
							proxy._pageTo = pageto;
						}
					}
					if (this._virtuaOtherPage) {
						this._virtuaOtherPage=false;
					}
					for (var i = 0; i < this._loadedJsonData.length; i++) {
						if (this._loadedJsonData[i].pageIndex == pageIndex)
							res = this._loadedJsonData[i].data;
					}
					Data = ej.isNullOrUndefined(res) ? this._currentJsonData[trIndex] : res[trIndex];
					Data = this._virtualScrollingSelection ? this._virtualSelRecords : Data;
					var nameattr = this._pageTo * pageSize;
					if (!ej.isNullOrUndefined(this._virtualdata) && this._virtualdata.length > 0) {
						rowIndex = $(document.getElementsByName(nameattr)[trIndex]).index();
						Data = this._virtualdata[trIndex];
						this._virtualdata = [];
					}
					else if ($(document.getElementsByName(pageto * pageSize)).length > 0 && !ej.isNullOrUndefined(this._pageTo))
						rowIndex = $(document.getElementsByName(pageto * pageSize)[rowIndex % pageSize]).index();
				}
		     args = { rowIndex: this.model.scrollSettings.enableVirtualization ? $rowIndex : rowIndex, row: $gridRows.eq(rowIndex), data: Data, selectedData: Data };
			   if (isSelection == "selectRows") {
			       args.prevRow = $prevRow;
			       args.prevRowIndex = $prevIndex;
			   }
		       return args; 
          },
        _selectingMultipleRows: function (selectedIndexes) {
            this._modelMultiSelectedIndexes = selectedIndexes;
            this.clearSelection();
            this.multiSelectCtrlRequest = true;
            for (var index = 0; index < selectedIndexes.length; index++)
                this.selectRows(selectedIndexes[index])
            this.multiSelectCtrlRequest = false;
            this._modelMultiSelectedIndexes = [];
        },
        _virtualSelectAction: function (pageIndex, rowIndex, pageSize) {
            if (this.model.scrollSettings.allowVirtualScrolling && !ej.isNullOrUndefined(rowIndex)) {
                if (!ej.isNullOrUndefined(this._virtualLoadedRecords[pageIndex]))
                    this._virtualSelectedRecords[rowIndex] = this._virtualLoadedRecords[pageIndex][rowIndex % pageSize];
                else
                    this._virtualSelectedRecords[rowIndex] = this._currentJsonData[rowIndex % pageSize];
            }
        },
		_getSelectedViewData: function(rowIndex, target, currentViewIndex){
			var index = rowIndex % this._virtualRowCount, viewIndex, result = {};
			if(target)
				viewIndex = parseInt($(target).closest("tr").attr("name"), 32);
			else if(currentViewIndex)
				viewIndex = currentViewIndex;
			else
				viewIndex = rowIndex > 1 ? Math.ceil((rowIndex + 1) / this._virtualRowCount) : 1;
			result["viewIndex"] = viewIndex;
			if(this._virtualLoadedRecords[viewIndex])
				result["data"] = this._virtualLoadedRecords[viewIndex][index];
			var remain = rowIndex % this._virtualRowCount;	
			result["rowIndex"] = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
			return result;
		},
        selectCells: function (rowCellIndexes) {
            if (!this._allowcellSelection)
                return false;
            var $cell = null, previousRowCell, prevRowCellIndex;
            var gridRows = this._excludeDetailRows();
            if (this.model.scrollSettings.frozenColumns)
                $cell = this._frozenCell(rowCellIndexes[0][0], rowCellIndexes[0][1][0]);
            else
                $cell = gridRows.eq(rowCellIndexes[0][0]).find(".e-rowcell:eq(" + rowCellIndexes[0][1] + ")");				
            if(!ej.isNullOrUndefined(this._previousRowCellIndex) && this._previousRowCellIndex.length != 0 ){
				if(this.model.scrollSettings.enableVirtualization){
					previousRowCell = this._prevRowCell;
					prevRowCellIndex = this._preVirRowCellIndex;
				}
				else{
					previousRowCell = $(this.getRowByIndex(this._previousRowCellIndex[0][0]).find(".e-rowcell:eq("+this._previousRowCellIndex[0][1]+")"));
					prevRowCellIndex = this._previousRowCellIndex;
				}
			}			
			var $data = this._currentJsonData[rowCellIndexes[0][0]], $rowIndex = rowCellIndexes[0][0], viewDetails;
			if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
				viewDetails = this._getSelectedViewData(rowCellIndexes[0][0], $cell);
				$data = viewDetails.data;
				$rowIndex = viewDetails.rowIndex;
			}				
            var args = { currentCell: $cell, cellIndex: rowCellIndexes[0][1], data: $data, selectedData: $data, previousRowCellIndex: prevRowCellIndex, previousRowCell: previousRowCell };
            if (this.model.selectionType == "multiple") {
                args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                args["isShiftPressed"] = this.multiSelectShiftRequest;
            }
            if (this._trigger("cellSelecting", args))
                return;
            switch (this.model.selectionType) {
                case ej.Grid.SelectionType.Multiple:
                    if (this.multiSelectCtrlRequest) {
                        var selectedCellIndex = $.inArray($rowIndex, this._rowIndexesColl);
                        if (selectedCellIndex != -1)
                            this.selectedRowCellIndexes[selectedCellIndex].cellIndex.push(parseInt(rowCellIndexes[0][1].toString()));
                        else {
                            if ($.inArray($rowIndex, this._rowIndexesColl) == -1)
                                this._rowIndexesColl.push($rowIndex);
                            this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[0][1] });
                        }
                        $cell.addClass("e-cellselectionbackground e-activecell");
                        break;
                    }
                    else if (this.multiSelectShiftRequest && this._previousRowCellIndex != undefined) {
                        this.clearCellSelection();
                        this.clearColumnSelection();
                        this.selectedRowCellIndexes = [];
                        var previousRowIndex = this._previousRowCellIndex[0][0];
                        var previousCellIndex = parseInt(this._previousRowCellIndex[0][1]);
                        var currentRowIndex = rowCellIndexes[0][0];
                        var currentCellIndex = parseInt(rowCellIndexes[0][1]);
						if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
							previousRowIndex = this._preVirRowCellIndex[0][0];
							currentRowIndex = this._getSelectedViewData(currentRowIndex, this.getRowByIndex(currentRowIndex).find(".e-rowcell")).rowIndex;
						}
                        var newCellColl = [];
                        var min, max;
                        if(this.model.selectionSettings.cellSelectionMode == "box"){
							var $rowCount =  this.model.scrollSettings.frozenColumns ? this.getRows()[0].length - 1 : this.getRows().length - 1;
							var pCellIndex = previousCellIndex < currentCellIndex ? previousCellIndex : currentCellIndex;
							var cCellIndex = pCellIndex == currentCellIndex ? previousCellIndex : currentCellIndex;	
							var newRowColl = [], newCellColl = [];							
							for (var i = pCellIndex; i <= cCellIndex; i++) {								
								min = previousRowIndex;									
								max = currentRowIndex;
								if( min < max ){
									for (var j = min; j <= max; j++) {
										$.inArray(j, newRowColl) == -1 && newRowColl.push(j);											
										this._selectMultipleCells(j, i, currentCellIndex, previousCellIndex);										
									}
								}
								else{
									for (var j = max; j <= min; j++) {
										$.inArray(j, newRowColl) == -1 && newRowColl.push(j);											
										this._selectMultipleCells(j, i, currentCellIndex, previousCellIndex);										
									}
								}
								newCellColl.push(i);								
							}							
							for(var i = 0; i < newRowColl.length; i++){								
								this.selectedRowCellIndexes.push({ rowIndex: newRowColl[i], cellIndex: newCellColl });										
							}
							this._rowIndexesColl = ej.distinct(newRowColl);
						}
                        else if (currentRowIndex > previousRowIndex) {
                            for (var i = previousRowIndex; i <= currentRowIndex; i++) {
                                newCellColl = [];
                                min = i == previousRowIndex ? previousCellIndex : 0;
                                max = i == currentRowIndex ? currentCellIndex : this.model.columns.length - 1;
                                for (var j = min; j <= max; j++) {
                                    newCellColl.push(j);
                                    this._selectMultipleCells(i, j, currentCellIndex, previousCellIndex);
                                }								
                                this.selectedRowCellIndexes.push({ rowIndex: i, cellIndex: newCellColl });
                                this._rowIndexesColl.push(i);
                            }
                        } 						 						
						else {
                            for (var i = previousRowIndex; i >= currentRowIndex; i--) {
                                newCellColl = [];
                                min = i == previousRowIndex ? previousCellIndex : this.model.columns.length - 1;
                                max = i == currentRowIndex ? currentCellIndex : 0;
								if( min > max ){
									for (var j = min; j >= max; j--) {
										newCellColl.push(j);
										this._selectMultipleCells(i, j, currentCellIndex, previousCellIndex);
									}
								}
								else{
									for (var j = max; j >= min; j--) {
										newCellColl.push(j);
										this._selectMultipleCells(i, j, currentCellIndex, previousCellIndex);
									}
								}                                
                                this.selectedRowCellIndexes.push({ rowIndex: i, cellIndex: newCellColl });
                                this._rowIndexesColl.push(i);
                            }
                        }
                        break;
                    }
                    else {
                        this.clearCellSelection();
						this._virtualRowCellSelIndex = [];
                        for (var i = 0; i < rowCellIndexes.length; i++) {
                            if (rowCellIndexes[i][1].length > 1) {
                                var td = gridRows.eq(rowCellIndexes[i][0]).find(".e-rowcell");
                                if (this.model.scrollSettings.frozenColumns)
                                    td = $(gridRows[0]).eq(rowCellIndexes[i][0]).find(".e-rowcell").add($(gridRows[1]).eq(rowCellIndexes[i][0]).find(".e-rowcell"));
                                for (var j = 0; j < td.length; j++) {
                                    var index = (this.model.detailsTemplate != null || this.model.childGrid != null) ? td[j].cellIndex - 1 : j;
                                    if ($.inArray(index, rowCellIndexes[i][1]) != -1) {
                                        $(td[j]).addClass("e-cellselectionbackground e-activecell");
                                        var selectedCellIndex = $.inArray(rowCellIndexes[i][0], this._rowIndexesColl);
                                        if (selectedCellIndex != -1)
                                            this.selectedRowCellIndexes[selectedCellIndex].cellIndex.push(td[j].cellIndex);
                                        else {
											$rowIndex = rowCellIndexes[i][0];
											if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
												viewDetails = this._getSelectedViewData($rowIndex, td);
												$data = viewDetails.data;
												$rowIndex = viewDetails.rowIndex;
											}
                                            this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: [td[j].cellIndex] });
                                            this._rowIndexesColl.push(rowCellIndexes[i][0]);
                                        }
                                    }
                                }
                            }
                            else {
                                if (this.model.scrollSettings.frozenColumns)
                                    this._frozenCell(rowCellIndexes[i][0], rowCellIndexes[i][1][0]).addClass("e-cellselectionbackground e-activecell");
                                else
                                    $(this.getRowByIndex(rowCellIndexes[i][0]).find(".e-rowcell:eq(" + rowCellIndexes[i][1] + ")")).addClass("e-cellselectionbackground e-activecell");
                                this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[i][1] });
                                this._rowIndexesColl.push($rowIndex);
                            }
                        }
                        break;

                    }
                case ej.Grid.SelectionType.Single:
                    this.clearCellSelection();
                    this.clearColumnSelection();
                    this.selectedRowCellIndexes = [];
					this._virtualRowCellSelIndex = [];
                    if ($.inArray($rowIndex, this._rowIndexesColl) == -1)
                       this._rowIndexesColl.push($rowIndex);
                    this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[0][1] });
                    if (this.model.scrollSettings.frozenColumns)
                        this._frozenCell(rowCellIndexes[0][0], rowCellIndexes[0][1][0]).addClass("e-cellselectionbackground e-activecell");
                    else
						$(this.getRowByIndex(rowCellIndexes[0][0]).find(".e-rowcell:eq(" + rowCellIndexes[0][1] + ")")).addClass("e-cellselectionbackground e-activecell");
                    break;
            }
            var args = { currentCell: $cell, cellIndex: rowCellIndexes[0][1], data: $data, selectedData: $data, selectedRowCellIndex: this.selectedRowCellIndexes, previousRowCellIndex: prevRowCellIndex, previousRowCell: previousRowCell};
            if (!this.multiSelectShiftRequest || ej.isNullOrUndefined(this._previousRowCellIndex)){
				this._previousRowCellIndex = rowCellIndexes;
				if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){					
					this._preVirRowCellIndex = $.extend(true, [], rowCellIndexes);
					this._preVirRowCellIndex[0][0] = $rowIndex;
				}											
				this._prevRowCell = $cell;
			} 
            if (this._trigger("cellSelected", args))
                return;			
        },
		_selectMultipleCells: function(i, j, currentCellIndex, previousCellIndex){			
			if (this.model.scrollSettings.frozenColumns)
				this._frozenCell(i, j).addClass("e-cellselectionbackground e-activecell");
			else{				
				if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
					var viewIndex = this._getSelectedViewData(i).viewIndex;
					if($.inArray(viewIndex, this._currentLoadedIndexes) != -1){
						var indx = this._currentLoadedIndexes.indexOf(viewIndex);
						var selIndex = i % this._virtualRowCount + indx * this._virtualRowCount;						
						$(this.getRowByIndex(selIndex).find(".e-rowcell:eq(" + j + ")")).addClass("e-cellselectionbackground e-activecell");
						if($.inArray(i, this._virtualRowCellSelIndex) == -1 && $.inArray(i, this._rowIndexesColl) != -1 && i != this._preVirRowCellIndex[0][0])
							this._virtualRowCellSelIndex.push(i);
					}					
				}
				else
					$(this.getRowByIndex(i).find(".e-rowcell:eq(" + j + ")")).addClass("e-cellselectionbackground e-activecell");
			}
		},

        
        selectColumns: function (columnIndex, toIndex) {
            if (!this._allowcolumnSelection)
                return false;
            this._allowcolumnSelection = true;
            var gridRows = this.getRows();            
            var prevColumnHeaderCell = this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[this._previousColumnIndex];
            var args = { columnIndex: columnIndex == undefined ? toIndex : columnIndex, headerCell: $(this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[columnIndex]), column: this.model.columns[columnIndex], previousColumnIndex: this._previousColumnIndex, prevColumnHeaderCell: prevColumnHeaderCell };
            var $precolIndex = this._previousColumnIndex;
            if ((args["isShiftPressed"] = this.multiSelectShiftRequest) == true)
                this._previousColumnIndex = columnIndex == undefined ? toIndex : columnIndex;
            else
                this._previousColumnIndex = toIndex;
            if (this.model.selectionType == "multiple") {
                args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                args["isShiftPressed"] = this.multiSelectShiftRequest;
            }
            if (this._trigger("columnSelecting", args))
                return;
            if (ej.isNullOrUndefined(toIndex) || ej.isNullOrUndefined(columnIndex)) {
                columnIndex = ej.isNullOrUndefined(columnIndex) ? toIndex : columnIndex;
                switch (this.model.selectionType) {
                    case ej.Grid.SelectionType.Multiple:
                        if (this.multiSelectCtrlRequest) {
                            var selectedColumnIndex = $.inArray(columnIndex, this.selectedColumnIndexes);
                            selectedColumnIndex != -1 && this.clearColumnSelection(columnIndex) && this.selectedColumnIndexes.splice(selectedColumnIndex, 0);
                            if (selectedColumnIndex == -1) {
                                this.selectedColumnIndexes.push(columnIndex);
                                this._previousColumnIndex = this.selectedColumnIndexes.length ? columnIndex : undefined;
                                if (this.model.scrollSettings.frozenColumns)
                                    this._frozenColumnSelection(gridRows, columnIndex);
                                else
                                    for (var i = 0; i < gridRows.length; i++) {
                                        $(this._excludeDetailCells(gridRows[i])[columnIndex]).addClass("e-columnselection");
                                    }
                                $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell)")[columnIndex]).addClass("e-columnselection");
                            }
                            break;
                        }
                    case ej.Grid.SelectionType.Single:
                        this.clearSelection();
                        this.clearCellSelection();
                        this.clearColumnSelection();
                        this.selectedColumnIndexes = [];
                        this.selectedColumnIndexes.push(columnIndex);
                        this._previousColumnIndex = this.selectedColumnIndexes.length ? columnIndex : undefined;
                        if (this.model.scrollSettings.frozenColumns)
                            this._frozenColumnSelection(gridRows, columnIndex);
                        else
                        for (var i = 0; i < gridRows.length; i++) {
                            $(this._excludeDetailCells(gridRows[i])[columnIndex]).addClass("e-columnselection");
                        }
                        $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell)")[columnIndex]).addClass("e-columnselection");
                        break;
                }
            } else {
                if (this.model.selectionType == ej.Grid.SelectionType.Multiple) {
                    this.clearColumnSelection();
                    this.selectedColumnIndexes = [];
                    var indent = 0;
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                        indent = 1;
                    }
                    var startIndex = columnIndex > toIndex ? toIndex : columnIndex;
                    var endIndex = columnIndex > toIndex ? columnIndex + 1 : toIndex + 1;
                    if (this.model.scrollSettings.frozenColumns)
                        this._frozenColumnSelection(gridRows, startIndex, endIndex);
                    else
                    for (var i = startIndex; i < endIndex; i++) {
                        for (var j = 0; j < gridRows.length; j++) {
                            $(this._excludeDetailCells(gridRows[j])[i]).addClass("e-columnselection");
                        }
                        $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell)")[i]).addClass("e-columnselection");
                        this.selectedColumnIndexes.push(i);
                    }
                }
            }
            var args = { columnIndex: columnIndex == undefined ? toIndex : columnIndex, headerCell: $(this.getHeaderTable().find('.e-columnheader').last().find('th').not('.e-detailheadercell')[columnIndex]), column: this.model.columns[columnIndex], selectedColumnIndex: this.selectedColumnIndexes, previousColumnIndex: $precolIndex, prevColumnHeaderCell: prevColumnHeaderCell };
            if (this._trigger("columnSelected", args))
                return;
        },
        
        clearSelection: function (index, $target) {
            var rIndex = index, cSelection = "clearSelection", gridRows = $(this.getRows()), Data;
            var $gridRows = $(this.getRows()), index;
            if (this._selectedRow() >= -1) {
                if (this.model.scrollSettings.frozenColumns || !ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid))
                    $gridRows = this._excludeDetailRows();
                else
                    $gridRows = $(this.element.find("tr[aria-selected='true']"));
                var isSelected = $gridRows.find("td").hasClass("e-selectionbackground e-active");
                if (isSelected) {
                    var args = {},$gRows = $(this.getContent().find("tr[aria-selected='true']"));
                    if (!this.model.scrollSettings.allowVirtualScrolling) {
                        if (!ej.isNullOrUndefined(index)) {
                            if (this.model.editSettings.editMode == "batch" && $($gridRows[index]).hasClass("e-insertedrow")) {
                                var addedrows = this.batchChanges.added.reverse();
                                Data = addedrows[index];
                                this.batchChanges.added.reverse();
                            }
                            else
                                Data = this.model.editSettings.editMode == "batch" ? this._currentJsonData[index - this.batchChanges.added.length] : this._currentJsonData[ej.isNullOrUndefined(index) ? toIndex : index];
                        }
                        var srow = [];
                        for (var j = 0; j < this.selectedRowsIndexes.length; j++) {
                            srow.push(this._currentJsonData[this.selectedRowsIndexes[j]]);
                        }
                        args = { rowIndex: index == undefined ? this.selectedRowsIndexes : index, row: index == undefined ? $gRows : gridRows.eq(index), data: index == undefined ? srow : Data, selectedData: index == undefined ? srow : Data };
                    }
                    else{
                     var vIndex, $target;
                     if (ej.isNullOrUndefined(index)) {
                        vIndex = this.selectedRowsIndexes[0];
                        $target = this.getSelectedRecords().length && this._enableCheckSelect && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization?this.element.find('.e-headercheckcelldiv .e-checkselectall') :$gRows[0];
                    }
                    else
                        vIndex = index;
                    var vrowIndexCollection = this.selectedRowsIndexes;
                    args = this._getVirtualRows(vIndex, $target, cSelection, vrowIndexCollection);
                    }
                    if (this._trigger("rowDeselecting", args))
                        return;
                }
                if (!ej.isNullOrUndefined(index)) {
                    this.getRowByIndex(index).removeAttr("aria-selected").find(".e-selectionbackground").removeClass("e-selectionbackground").removeClass("e-active");
					var row = this.getRowByIndex(index);
					if(this.model.scrollSettings.enableVirtualization && this.multiSelectCtrlRequest){
						var limit = parseInt(row.attr("name"), 32) * this._virtualRowCount;
						var remain = this._virtualRowCount - row.index() % this._virtualRowCount;	
						index = limit - remain;
					}
                    index = $.inArray(index, this.selectedRowsIndexes);
                    if (index != -1) {
                        this.selectedRowsIndexes.splice(index, 1);
                        this._selectedMultipleRows(this.selectedRowsIndexes);
                        this.model.selectedRecords.splice(index, 1);
                    }
                    if (this._enableCheckSelect && !$target)
                        row.find(".e-checkcelldiv [type=checkbox]").prop("checked", false);
                    if (this._isMapSelection) {
                        if (!this._selectionByGrid && !ej.isNullOrUndefined(index) && index != -1) {
                            var Data = this._currentJsonData[rIndex];
                            Data[this._selectionMapColumn] = false;
                            this.updateRecord(this._primaryKeys[0], Data, "update");
                        }
                        Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                    }
                } else {
                    $gridRows.removeAttr("aria-selected").find(".e-rowcell, .e-detailrowcollapse, .e-detailrowexpand").removeClass("e-selectionbackground").removeClass("e-active");
                    if(!this._clearVirtualSelection){
						this.selectedRowsIndexes = [];
						this.model.selectedRecords = [];
                    }
                    if (!this._selectionByGrid) {
                        $gridRows.find(".e-checkcelldiv [type=checkbox]").prop("checked", false);
                        var data = null;
                        if (this._isMapSelection) {
                            this._headerCheckUpdateAll(false);
                        }
                        Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                    }
                }
                if (this._enableCheckSelect) {
                    if (this.selectedRowsIndexes.length != this._currentJsonData.length && !this._selectAllCheck)
                        this.getHeaderTable().find(".e-headercheckcelldiv .e-checkselectall").prop("checked", false);
                    var i, curPage = this._currentPage() - 1;
                    checkBoxIndex = $.inArray(rIndex, this.checkSelectedRowsIndexes[curPage]);
                    if (checkBoxIndex != -1) {
                        this.checkSelectedRowsIndexes[curPage].splice(index, 1);
                    }
                    if (!this.selectedRowsIndexes.length && !this._isMapSelection && !$target) {
                        this.checkSelectedRowsIndexes[curPage] = [];
                        $gridRows.find(".e-checkcelldiv [type=checkbox]").prop("checked", false);
                    }
                }
                if (!this.selectedRowsIndexes.length)
                    this._selectedRow(-1);
            }
            this.model._checkSelectedRowsIndexes = this.checkSelectedRowsIndexes;
            if (isSelected && this._trigger("rowDeselected", args))
                return true;
        },

        _excludeDetailRows:function()
		{
			var $gridRows;
			if (!ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid || this.model.showSummary) && !this.model.scrollSettings.frozenColumns)
			    $gridRows = $(this.getRows()).not(".e-detailrow,.e-gridSummaryRows");
			else if (this.model.scrollSettings.frozenColumns > 0 && this.getRows() != null && this.getRows().length > 1)
			    $gridRows = $(this.getRows()[0]).not(".e-detailrow,.e-gridSummaryRows").add($(this.getRows()[1]).not(".e-detailrow,.e-gridSummaryRows"));
			else
			    $gridRows = $(this.getRows());
            return $gridRows;
		},
        
        clearCellSelection: function (rowIndex, columnIndex) {
            var $gridRows,$cell, cellIndex;
            if (this._allowcellSelection) {
                if (!ej.isNullOrUndefined(rowIndex) || !ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid))
                    $gridRows = this._excludeDetailRows();
                else
                    $gridRows = $(this.element.find(".e-cellselectionbackground")).parent();
                var isCellSelected = $gridRows.find("td").hasClass("e-cellselectionbackground e-activecell");
                if (isCellSelected) {
                    if (this.model.scrollSettings.frozenColumns && !ej.isNullOrUndefined(rowIndex))
                        $cell = this._frozenCell(rowIndex, columnIndex);
                    else
                        $cell = this.getContent().find(".e-cellselectionbackground");
                    var $data = [], cIndex = [columnIndex], vCell = [];
                    for (var j = 0; j < this.selectedRowCellIndexes.length; j++) {
                        $data.push(this._currentJsonData[this.selectedRowCellIndexes[j].rowIndex]);
                        for (var i = 0; i < this.selectedRowCellIndexes[j].cellIndex.length; i++) {
                            vCell.push(this.selectedRowCellIndexes[j].cellIndex[i]);
                        }
                    }
                    var args = { currentCell: (rowIndex || columnIndex) == undefined ? $cell : $gridRows.eq(rowIndex).find(".e-rowcell").eq(columnIndex), cellIndex: (rowIndex || columnIndex) == undefined ? vCell : cIndex, data: (rowIndex || columnIndex) == undefined ? $data : this._currentJsonData[rowIndex], selectedData: (rowIndex || columnIndex) == undefined ? $data : this._currentJsonData[rowIndex] };
                    if (this.model.selectionType == "multiple") {
                        args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                        args["isShiftPressed"] = this.multiSelectShiftRequest;
                    }
                    if (this._trigger("cellDeselecting", args))
                        return true;
                }
                if (ej.isNullOrUndefined(rowIndex)) {
                    if (this.model.scrollSettings.frozenColumns)
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.find(".e-rowcell, .e-detailrowcollapse, .e-detailrowexpand").removeClass("e-cellselectionbackground").removeClass("e-activecell");
                    this.selectedRowCellIndexes = [];
                    this._rowIndexesColl = [];
                }
                else {
                    for (var i = 0; i < this.selectedRowCellIndexes.length ; i++) {
                        if (this.selectedRowCellIndexes[i].rowIndex == rowIndex) {
                            cellIndex = $.inArray(columnIndex, this.selectedRowCellIndexes[i].cellIndex);
                            if (this.model.scrollSettings.frozenColumns)
                                this._frozenCell(rowIndex, columnIndex).removeClass("e-cellselectionbackground").removeClass("e-activecell");
                            else
                            $gridRows.eq(rowIndex).find(".e-rowcell").eq(columnIndex).removeClass("e-cellselectionbackground").removeClass("e-activecell");
                            break;
                        }
                    }
                    if (i != this.selectedRowCellIndexes.length) {
                        this.selectedRowCellIndexes[i].cellIndex.splice(cellIndex, 1);
                        if (this.selectedRowCellIndexes[i].cellIndex.length == 0) {
                            this.selectedRowCellIndexes.splice(i, 1);
                            this._rowIndexesColl.splice($.inArray(rowIndex, this._rowIndexesColl), 1);
                        }
                    }
                }
            }
            if (isCellSelected && this._trigger("cellDeselected", args))
                return true;
        },

        
        clearColumnSelection: function (index) {
             if (this._allowcolumnSelection) {
                var $gridRows = $(this._excludeDetailRows());
				var cIndex = $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)"));
				var isColumnSelected = cIndex.hasClass("e-columnselection");
                if(isColumnSelected){
                var scol = [],hcell = [];
                for (var j = 0; j < this.selectedColumnIndexes.length; j++) {
                    scol.push(this.model.columns[this.selectedColumnIndexes[j]]);
                    hcell.push($(this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[this.selectedColumnIndexes[j]]));
                }
                var args = { columnIndex: index == undefined ? this.selectedColumnIndexes : index, headerCell: index == undefined ? hcell : $(this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[index]), column: index == undefined ? scol : this.model.columns[index] };
                if (this.model.selectionType == "multiple") {
                   args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                   args["isShiftPressed"] = this.multiSelectShiftRequest;
                 }
               if (this._trigger("columnDeselecting", args))
                   return;
                }
                if (!ej.isNullOrUndefined(index)) {
                    var indent = 0;
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                        ++index; indent = 1;
                    }
                    if (this.model.scrollSettings.frozenColumns) {
                        var currentIndex = index;
                        if (index >= this.model.scrollSettings.frozenColumns) {
                            currentIndex = index - this.model.scrollSettings.frozenColumns;
							 $gridRows=$(this.getContent).find(".e-movablecontent").find('tr');
                        }
                        else
                            $gridRows=$(this.getContent).find(".e-frozencontentdiv").find('tr');
                        for (var j = 0; j < $gridRows.length; j++) {
                            $($gridRows[j].cells[currentIndex]).removeClass("e-columnselection");
                        }
                    }
                    else
                        for (var i = 0; i < $gridRows.length; i++) {
                            $($gridRows[i].cells[index]).removeClass("e-columnselection");
                        }
                    $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)")[index]).removeClass("e-columnselection");
                    this.selectedColumnIndexes.splice(0, index - indent);

                } else {
                    $gridRows.find(".e-rowcell").removeClass("e-columnselection");
                    $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)")).removeClass("e-columnselection");
                    this.selectedColumnIndexes = [];
                }
            }
            if (isColumnSelected && this._trigger("columnDeselected", args))
                return true;
        },
        getSelectedRows:function(){
            var $rows = $();
            for (var i = 0; i < this.selectedRowsIndexes.length; i++) {
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $rows.push(this.getRowByIndex(this.selectedRowsIndexes[i])[0]);
                    $rows.push(this.getRowByIndex(this.selectedRowsIndexes[i])[1]);
                }
                else
                    $rows.push(this.getRowByIndex(this.selectedRowsIndexes[i])[0]);
            }
            return $rows;
        },
        getSelectedRecords: function () {
            var records = [], $gridRows = this.getRows();
            if (this._virtualScrollingSelection)
                return this._virtualSelRecords;
            for (var i = 0; i < this.selectedRowsIndexes.length; i++) {
                if (this.selectedRowsIndexes[i] != -1) {
                    if (this.model.editSettings.editMode == "batch" && $($gridRows[this.selectedRowsIndexes[i]]).hasClass("e-insertedrow")) {
                        var addedrecords = this.batchChanges.added.reverse();
                        records.push(addedrecords[this.selectedRowsIndexes[i]])
                        this.batchChanges.added.reverse();
                    }
                    else if (this.model.scrollSettings.allowVirtualScrolling)
                        records.push(this._virtualSelectedRecords[this.selectedRowsIndexes[i]]);
                    else
                        this.model.editSettings.editMode == "batch" ? records.push(this._currentJsonData[this.selectedRowsIndexes[i] - this.batchChanges.added.length]) : records.push(this._currentJsonData[this.selectedRowsIndexes[i]]);

                }
            }
            return records;
        },
        _setCurrentRow: function (requestType) {
            if (requestType == ej.Grid.Actions.Refresh || requestType == ej.Grid.Actions.Ungrouping || requestType == ej.Grid.Actions.Grouping || requestType == ej.Grid.Actions.Filtering || requestType == ej.Grid.Actions.Sorting || requestType == ej.Grid.Actions.Delete || requestType == ej.Grid.Actions.Save || requestType == ej.Grid.Actions.Paging || requestType == ej.Grid.Actions.Search || (requestType == ej.Grid.Actions.Cancel && this.model.currentViewData != null && this.model.currentViewData.length == 0)) {
                this._selectedRow(-1);
                this._selectedMultipleRows([]);
				if(!this._virtualDataRefresh || requestType == ej.Grid.Actions.Refresh )
					this.selectedRowsIndexes = [];
            }
        },
        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-gridpopup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSorting) {
                var $selElement = ej.buildTag("span.e-sortdirect e-icon");
                $content.append($selElement);
            }
            if (this.model.selectionType == ej.Grid.SelectionType.Multiple) {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    "use strict"
    ej.widget("ejGrid", "ej.Grid",  {
        
        _rootCSS: "e-grid",
        // widget element will be automatically set in this
        element: null,
        validTags: ["div"],
        // user defined model will be automatically set in this
        model: null,
        _requiresID: true,
        keyConfigs: /** @lends ejGrid# */{
            focus: "e",
            insertRecord: "45", //Insert
            deleteRecord: "46", // delete
            editRecord: "113", //F2
            saveRequest: "13", // enter
            cancelRequest: "27", //Esc
            nextPage: "34", // PgDn
            previousPage: "33", // PgUp
            lastPage: "ctrl+alt+34", //"CtrlAltPgDn",
            firstPage: "ctrl+alt+33", //"CtrlPlusAltPlusPgUp",
            nextPager: "alt+34", //"AltPlusPgDown",
            previousPager: "alt+33", //"AltPlusPgUp",
            firstCellSelection: "36", //"Home",
            lastCellSelection: "35", //"End",
            firstRowSelection: "ctrl+36", //"CtrlPlusHome",
            lastRowSelection: "ctrl+35", //"CtrlPlusEnd",
            rowUpSelection: "ctrl+shift+38", //"CtrlPlusShiftplusUpArrow",
            rowDownSelection: "ctrl+shift+40", //"CtrlPlusShiftplusDownArrow",
            randomSelection: "ctrl+shift+83", // "CtrlPlusShiftplusSkey",
            upArrow: "38", //Up arrow
            downArrow: "40", //Down arrow
            rightArrow: "39", //Right arrow
            leftArrow: "37", //Left arrow
            moveCellRight: "9", //tab
            moveCellLeft: "shift+9", //shifttab
            selectedGroupExpand: "alt+40", //"AltPlusDownArrow",
            totalGroupExpand: "ctrl+40", //"CtrlPlusDownArrow",
            selectedGroupCollapse: "alt+38", //"AltPlusUpArrow",
            totalGroupCollapse: "ctrl+38", //"CtrlPlusUpArrow",
            multiSelectionByUpArrow: "shift+38",//"shiftPlusUpArrow",
            multiSelectionByDownArrow:"shift+40",//"shiftPlusDownArrow"
        },
        _ignoreOnPersist: [
            "actionBegin", "actionComplete", "actionFailure", "batchAdd", "batchDelete", "beforeBatchSave", "beforeBatchAdd", "beforeBatchDelete", "beginEdit",
            "cellEdit", "cellSave", "cellSelecting", "cellSelected", "cellDeselecting", "cellDeselected", "columnDrag", "columnDragStart", "columnDrop", "columnSelecting",
            "columnSelected", "columnDeselecting", "columnDeselected", "create", "dataBound", "destroy", "detailsCollapse", "detailsExpand", "endAdd", "endDelete",
            "endEdit", "recordClick", "recordDoubleClick", "load", "resized", "resizeEnd", "resizeStart", "rightClick", "rowSelected", "rowSelecting", "rowDeselected",
            "rowDeselecting", "rowDrag", "rowDragStart", "rowDrop", "templateRefresh", "beforePrint", "beforeRowDrop", "query", "isEdit", "toolbarClick", "queryCellInfo",
            "mergeCellInfo", "mergeHeaderCellInfo","currentViewData", "enableAltRow", "enableRTL", "contextClick", "contextOpen", "rowDataBound", "rowTemplate", "detailsDataBound",
            "detailsTemplate", "childGrid", "summaryRows", "toolbarSettings", "editSettings", "allowMultiSorting", "enableAutoSaveOnSelectionChange", "locale",
            "allowCellMerging", "allowTextWrap", "textWrapSettings", "cssClass", "dataSource", "groupSettings.enableDropAreaAutoSizing", "enableRowHover", "showSummary",
            "allowGrouping", "enableHeaderHover", "allowKeyboardNavigation", "scrollSettings.frozenRows", "scrollSettings.frozenColumns", "enableTouch",
            "contextMenuSettings.enableContextMenu", "exportToExcelAction", "exportToWordAction", "exportToPdfAction"
        ],
        ignoreOnExport: [
            "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "rowDataBound", "rowTemplate",
            "detailsDataBound", "detailsTemplate", "editSettings", "pageSettings", "enableAutoSaveOnSelectionChange", "localization", "allowScrolling",
            "cssClass", "dataSource", "groupSettings.enableDropAreaAnimation", "enableRowHover", "allowSummary",
            "enableHeaderHover", "allowKeyboardNavigation"
        ],
        ignoreOnToolbarServerClick: [],
        observables: ["dataSource", "selectedRowIndex", "pageSettings.currentPage", "selectedRowIndices"],
        _tags: [{
            tag: "columns",
            attr: ["allowEditing", "allowFiltering","allowTextWrap", "filterType", "allowGrouping","allowResizing","allowSorting", "cssClass", "customAttributes", "dataSource", "defaultValue",
			"disableHtmlEncode", "editTemplate", "editType", "foreignKeyField", "foreignKeyValue", "headerTemplateID", "headerText", "isFrozen",
			"isIdentity", "isPrimaryKey","filterBarTemplate", "textAlign", "templateID", "textAlign", "headerTextAlign", "tooltip", "clipMode",
            "validationRules.minlength", "validationRules.maxlength", "validationRules.range", "validationRules.number", "validationRules.required",
            "editParams.decimalPlaces", [{ tag: "commands", attr: ["type", "buttonOptions"] }]
            ],
            content: "template"
        }, {
            tag: "summaryRows",
            attr: ["showCaptionSummary", "showTotalSummary", [{
                tag: "summaryColumns", attr: ["customSummaryValue", "dataMember", "displayColumn", "summaryType", "template"]
            }]]
        }, {
            tag: "stackedHeaderRows",
            attr: [
            [{
                tag: "stackedHeaderColumns", attr: ["headerText", "column"]
            }]]
        }, {
            tag: "filterSettings.filteredColumns", attr: []
        }, {
            tag: "sortSettings.sortedColumns", attr: []
        }],
        _dataSource: ej.util.valueFunction("dataSource"),
        _selectedRow: ej.util.valueFunction("selectedRowIndex"),
        _selectedMultipleRows: ej.util.valueFunction("selectedRowIndices"),
        _currentPage: ej.util.valueFunction("pageSettings.currentPage"),
        // default model
        defaults: /** @lends ejGrid# */ {            
            allowPaging: false,            
            showColumnChooser: false,            
            gridLines: "both",            
            allowSorting: false,            
            showStackedHeader: false,            
            selectedRecords: [],
            stackedHeaderRows: [],
            allowFiltering: false,
            allowMultipleExporting: false,            
            allowSelection: true,            
            allowGrouping: false,            
            showSummary: false,            
            allowResizing: false,            
            allowResizeToFit: false,            
            allowTextWrap: false,            
            allowCellMerging: false,            
            enableRowHover: true,            
            enablePersistence: false,
            enableFocusout: false,
            selectedRowIndex: -1,
            selectedRowIndices: [],
            allowSearching: false,
            enableToolbarItems:false,            
            enableHeaderHover: false,            
            allowReordering: false,            
            allowKeyboardNavigation: true,
            allowRowDragAndDrop: false,
            enableTouch: true,
			enableLoadOnDemand: false,
            columnLayout:'auto',            
            selectionType: "single",            
            dataSource: null,            
            cssClass: "",            
            allowScrolling: false,            
            locale: "en-US",            
            enableAutoSaveOnSelectionChange: true,            
            allowMultiSorting: false,
            exportToExcelAction: "ExportToExcel",
            exportToWordAction: "ExportToWord",
            exportToPdfAction: "ExportToPdf",
            _groupingCollapsed: [],
            _checkSelectedRowsIndexes: [],
            editSettings:  {                
                allowEditing: false,                
                showAddNewRow: false,                
                allowAdding: false,                
                showAddNewRow: false,                
                allowDeleting: false,                
                editMode: "normal",                
                rowPosition: "top",                
                dialogEditorTemplateID: null,                
                allowEditOnDblClick: true,                
                externalFormTemplateID: null,                
                inlineFormTemplateID: null,                
                formPosition: "bottomleft",               
				titleColumn: null,			   
                showConfirmDialog: true,                
                showDeleteConfirmDialog: false
            },            
            selectionSettings:  {                
                selectionMode: ["row"],                
                enableToggle: false,                
                cellSelectionMode: "flow"
            },
            resizeSettings: {
                resizeMode: 'normal'
            },
            pageSettings:  {               
                pageSize: 12,                
                pageCount: 8,                
                currentPage: 1,                
                totalPages: null,                
                enableTemplates: false,                
                showDefaults: false,                
                template: null,                
                totalRecordsCount: null,                
                enableQueryString: false,
                printMode: "allpages"
            },            
            groupSettings:  {               
                showDropArea: true,                
                showToggleButton: false,                     
                showGroupedColumn: true,                
                showUngroupButton: true,                
                enableDropAreaAutoSizing: true,                
                captionFormat: null,                
                groupedColumns: []
            },          
            contextMenuSettings: {                
                enableContextMenu: false,                
                contextMenuItems: ["Add Record", "Edit Record", "Delete Record", "Sort In Ascending Order", "Sort In Descending Order", "Next Page", "Last Page", "Previous Page", "First Page", "Save", "Cancel", "Grouping", "Ungrouping"],
                customContextMenuItems: [],
                subContextMenu: [],
                disableDefaultItems: false
            },            
            filterSettings:  {                
                filterType: "filterbar",                
                filterBarMode: "immediate",                
                showFilterBarStatus: true,
                statusBarWidth: 450,                
                showPredicate: false,                
                filteredColumns: [],
                enableInterDeterminateState: true,                
                maxFilterChoices: 1000,                
                enableCaseSensitivity: false,
                immediateModeDelay: 1500,
                enableComplexBlankFilter: true,
                blankValue: ""
            },
            searchSettings:  {                
                fields: [],                
                key: "",                
                operator: "contains",                
                ignoreCase: true
            },            
            sortSettings:  {                                             
                sortedColumns: []
            },            
            toolbarSettings:  {                
                showToolbar: false,                
                toolbarItems: [],                
                customToolbarItems: []
            },            
            minWidth: 0,
            currentIndex: 0,
            rowDropSettings: {
                dropMapper: null,
                dragMapper: null,
                dropTargetID: null,
            },
            scrollSettings: 
            {                
                width: "auto",                
                height: 0,                
                enableTouchScroll: true,                
                allowVirtualScrolling: false,                
                virtualScrollMode: "normal",                
                frozenRows: 0,                
                frozenColumns: 0,
                buttonSize: 18,
                autoHide: false,
                scrollerSize: 18,
                scrollOneStepBy: 57,
				enableVirtualization: false
            },  
            textWrapSettings: {
                wrapMode: "both"
            },                    
            summaryRows: [],            
            enableRTL: false,            
            enableAltRow: true,
            currentViewData: null,            
            detailsTemplate: null,            
            childGrid: null,            
            keySettings: null,            
            rowTemplate: null,            
            detailsDataBound: null,            
            rowDataBound: null,            
            queryCellInfo: null,                      
            mergeCellInfo: null,
            mergeHeaderCellInfo:null,
            create: null,            
            actionBegin: null,            
            actionComplete: null,            
            actionFailure: null,            
            beginEdit: null,            
            endEdit: null,            
            endAdd: null,            
            endDelete: null,            
            beforeBatchAdd: null,            
            beforeBatchSave: null,            
            beforeBatchDelete: null,
            beforePrint: null,
            batchAdd: null,            
            batchDelete: null,            
            cellSave: null,            
            cellEdit: null,            
            resizeStart: null,            
            resizeEnd: null,            
            resized: null,            
            load: null,            
            destroy: null,            
            rowSelecting: null,            
            rowSelected: null,
            rowHover: null,
            rowDeselecting:null,
            rowDeselected:null,	            
            cellSelecting: null,            
            cellSelected: null, 
            cellDeselecting:null,
      	    cellDeselected:null,				
            columnSelecting: null,            
            columnSelected: null, 
            columnDeselecting: null,            
            columnDeselected: null,		         
            columnDragStart: null,            
            columnDrag: null,            
            columnDrop: null,
            rowDrag: null,
            rowDragStart: null,
            rowDrop: null,
            beforeRowDrop: null,
            dataBound: null,            
            recordClick: null,            
            recordDoubleClick: null,            
            templateRefresh: null,            
            rightClick: null,            
            detailsCollapse: null,            
            detailsExpand: null,            
            toolbarClick: null,           
            contextOpen: null,            
            contextClick: null,       
            columns: [],            
            query: null,
            isEdit: false,            
            isResponsive: false,            
            enableResponsiveRow: false,
			virtualLoading: null
        },
        dataTypes: {
            dataSource: "data",
            query: "data",
            columns: "array",
            childGrid: "parent",
            gridLines: "enum",
            summaryRows: "array",
            stackedHeaderRows: "array",
            toolbarSettings: {
                toolbarItems: "array",
                customToolbarItems: "array"
            },
            contextMenuSettings: {
                contextMenuItems: "array",
                customContextMenuItems: "array",
                subContextMenu: "array"
            },
            selectionSettings: {
                selectionMode: "array",
                selectedRecords: "array"
            },
            sortSettings: {
                sortedColumns: "array"
            },
            filterSettings: {
                filteredColumns: "array",
                filterType: "enum",
                filterBarMode: "enum",
            },
            groupSettings: {
                groupedColumns: "array"
            },
            editSettings: {
                editMode: "enum",
                formPosition: "enum",
                rowPosition: "enum",
            },
            searchSettings: {
                fields: "array"
            },
            textWrapSettings: {
                wrapMode: "enum"
            }
        },

        _columns: function (index, property, value, old) {
            var $header = this.element.find(".e-gridheader");
            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
            this._headerCellgDragDrop();
            this.refreshContent(true);
            this._trigger("refresh");
        },
        _summaryRows: function (index, property, value, old) {
            if (property == "showTotalSummary" || property == "showCaptionSummary") {
                var indx = index.summaryRows;
                var val = value.toLowerCase() == "true" || value.toLowerCase() == "false" ? ej.parseJSON(value) : false;
                this.option("summaryRows")[indx][property] = val;
            }
            this.element.find(".e-gridfooter").remove();
            this._renderGridFooter().insertAfter(this.getContent());
            if (property == "showCaptionSummary" || property == "title") {
                this._isCaptionSummary = this.option("summaryRows")[indx]["showCaptionSummary"];
                this.model.showSummary = this._isCaptionSummary;
                if (this.model.groupSettings.groupedColumns.length != 0)
                    this._refreshCaptionSummary();
            }
        },
        _summaryRows_summaryColumns: function (index, property, value, old) {
            if (property == "displayColumn" || property == "dataMember") {
                if (ej.isNullOrUndefined(this.getColumnByField(value)))
                    return;
            }
            this._createSummaryRows(this.getFooterTable());
            if (this.element.find(".e-groupcaptionsummary").length != 0)
                this._refreshCaptionSummary();
        },
        _stackedHeaderRows_stackedHeaderColumns: function (index, property, value, old) {
            this._refreshStackedHeader();
        },
        _sortSettings_sortedColumns: function (index, property, value, old) {
            var colName, direction;
            var sortObj = this.model.sortSettings.sortedColumns[index["sortSettings.sortedColumns"]];
            if (property == "field") {
                colName = this.getColumnByField(value) != null ? value : null;
                direction = (sortObj.direction == "ascending" || sortObj.direction == "descending") ? sortObj.direction : null;
            }
            else if (property == "direction") {
                colName = this.getColumnByField(sortObj.field) != null ? sortObj.field : null;
                direction = (value == "ascending" || value == "descending") ? value : null;
            }
            if (colName != null && direction != null)
                this.sortColumn(colName, direction);
        },
        _filterSettings_filteredColumns: function (index, property, value, old) {
            var field, operator, matchcase, predicate, filtervalue;
            var filterObj = this.model.filterSettings.filteredColumns[index["filterSettings.filteredColumns"]];
            switch (property) {
                case "field":
                    field = this.getColumnByField(value) != null ? value : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "matchcase":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = value.toLowerCase() == "true" || value.toLowerCase() == "false" ? ej.parseJSON(value) : false;
                    break;
                case "operator":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, value);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "predicate":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (value == "and" || value == "or") ? value : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "value":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
            }
            if (field != null && operator != null && filtervalue != null && predicate != null && matchcase != null)
                this.filterColumn(field, operator, filtervalue, predicate, matchcase);
        },
        _map: function (object, value) {
            var data = $.map(object, function (obj) {
                if (obj === value)
                    return obj;
            });
            return data.length != 0 ? data[0] : null;
        },
        _refreshCaptionSummary: function () {
            var temp = document.createElement('div');
            temp.innerHTML = ['<table>', $.render[this._id + "_GroupingTemplate"](this.model.currentViewData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
            this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
            this.refreshContent();
        },
        
        getContentTable: function () {
            return this._gridContentTable;
        },

        setGridContentTable: function (value) {
            this._gridContentTable = value;
        },
        
        getContent: function () {
            return this._gridContent;
        },

        setGridContent: function (value) {
            this._gridContent = value;
        },
        
        getHeaderContent: function () {
            return this._gridHeaderContent;
        },

        setGridHeaderContent: function (value) {
            this._gridHeaderContent = value;
        },
        
        getHeaderTable: function () {
            return this._gridHeaderTable;
        },

        setGridHeaderTable: function (value) {
            this._gridHeaderTable = value;
        },
        
        getRows: function () {
            return this._gridRows;
        },
        
        getFilteredRecords: function () {
            return this._filteredRecords;
        },
        
        getRowByIndex: function (from, to) {
            try {
                var gridRows = this.getRows(), $gridRows = this._excludeDetailRows(), $row = $();
                if ($.isArray(from)) {
                    for (var i = 0; i < from.length; i++) {
                        if (this.model.scrollSettings.frozenColumns > 0) {
                            $row.push(gridRows[0][from[i]]);
                            $row.push(gridRows[1][from[i]]);
                        }
                        else
                            $row.push(gridRows[from[i]]);
                    }
                    return $row;
                }
                else if (ej.isNullOrUndefined(to)) {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $row.push(gridRows[0][from]);
                        $row.push(gridRows[1][from]);
                        return $row;
                    }
                    return $(($gridRows).not(".e-virtualrow")[from]);
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $row.push($(gridRows[0]).slice(from, to));
                        $row.push($(gridRows[1]).slice(from, to));
                        return $row;
                    }
                    return $($gridRows.not(".e-virtualrow").slice(from, to));
                }
            } catch (e) {
                return $();
            }
        },
        
        getColumnIndexByField: function (field) {
            for (var i = 0, col = this.model.columns, len = col.length ; i < len ; i++) {
                if (col[i]["field"] === field)
                    return i;
            }
            return -1;
        },
        
        getColumnIndexByHeaderText: function (headerText, field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["headerText"] == headerText) {
                    if (field) {
                        if (ej.isNullOrUndefined(this.model.columns[column]["field"]) || this.model.columns[column]["field"] == "")
                            break;
                    }
                    else
                        break;
                }
            }
            return column;
        },
        
        getIndexByRow: function ($tr) {
            var gridRows = this.getRows(), $gridRows = this._excludeDetailRows(), rowIndex;
            if (this.model.scrollSettings.frozenColumns > 0) {
                rowIndex = $(gridRows[0]).index($tr);
                if (rowIndex == -1)
                    rowIndex = $(gridRows[1]).index($tr);
                return rowIndex;
            } else
                return $gridRows.not(".e-virtualrow").index($tr);
        },
        
        getPrimaryKeyFieldNames: function () {
            if (this._primaryKeys.length != 0)
                return this._primaryKeys;
            for (var key = 0, col = this.model.columns, cLen = col.length; key < cLen; key++) {
                if (col[key]["isPrimaryKey"])
                    this._primaryKeys.push(col[key]["field"]);
            }
            return this._primaryKeys;
        },
        
        getVisibleColumnNames: function (headerText) {
            return this._visibleColumns;
        },
        
        getHiddenColumnNames: function (headerText) {
            return this._hiddenColumns;
        },
        
        getColumnByField: function (field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["field"] == field)
                    break;
            }
            return column == this.model.columns.length ? null : this.model.columns[column];
        },
        
        getsortColumnByField: function (field) {
            for (var column = 0; column < this.model.sortSettings.sortedColumns.length; column++) {
                if (this.model.sortSettings.sortedColumns[column]["field"] == field)
                    break;
            }
            return column == this.model.sortSettings.sortedColumns.length ? null : this.model.sortSettings.sortedColumns[column];
        },
        
        getColumnByHeaderText: function (headerText, field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["headerText"] == headerText) {
                    if (field) {
                        if (ej.isNullOrUndefined(this.model.columns[column]["field"]) || this.model.columns[column]["field"] == "")
                            break;
                    }
                    else
                        break;
                }
            }
            return column == this.model.columns.length ? null : this.model.columns[column];
        },
        
        getCurrentViewData: function () {
            return this._currentJsonData;
        },
        
        getColumnFieldNames: function () {
            var columnNames = [];
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["field"])
                    columnNames.push(this.model.columns[column]["field"]);
            }
            return columnNames;
        },
        
        getBrowserDetails: function () {
            var b = navigator.userAgent.match(/(firefox|chrome|opera|msie|safari)\s?\/?(\d+(.\d+)*)/i);
            if (!!navigator.userAgent.match(/Trident\/7\./) || !!navigator.userAgent.match(/Edge/))
                return { browser: "msie", version: $.uaMatch(navigator.userAgent).version };
            return { browser: b[1].toLowerCase(), version: b[2] };
        },
        _initPrivateProperties: function () {
            this._showInColumnchooserCol = [];
            this._currentVirtualRowIndex = 0;
            this._click = 0;
            this._gridPhoneMode = 320;
            this._columntemplaterefresh = false;
			this._tabKey = false;
            this._gridHeaderTable = null;
            this._gridWidth = this.element.width();
            this._id = this.element.attr("id");
            this._gridRows = [];
            this._fltrBarcell = false;
			this._unboundRow = null;
            this._gridContentTable = null;
            this._gridContent = null;
            this._remoteSummaryData = null;
            this._gridSort = null;
            this._gridHeaderContent = null;
            this._gridFooterContent = null;
            this._gridFooterTable = null;
            this._gridRecordsCount = this._dataSource() !== null ? (this.model.pageSettings.totalRecordsCount == null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount) : 0;
            this._links = null;
            this._gridPager = null;
            this._cSortedColumn = null;
            this._cSortedDirection = null;
            this._$curSElementTarget = null;
            this._gridFilterBar = null;
            this._$curFieldName = null;
            this._$prevFieldName = null;
            this._editedData = {};
            this._isEditChangesApplied = false;
            this._mediaStatus = false;
            this._$fDlgIsOpen = false;
            this._$menuDlgIsOpen = false;
            this._$colType = null;
            this._$colFormat = null;
            this._$prevColType = null;
            this._$prevSElementTarget = null;
            this._currentFilterColumn = null;
            this._filteredRecordsCount = null;
            this._filteredRecords = [];
            this._validatedColumns = [];
            this.filterColumnCollection = [];
            this._previousFilterCount = null;
            this._excelFilter = null;
            this._isExcelFilter = this.model.filterSettings.filterType == "excel";
            this._$fkColumn = false;
			this._fkParentTblData =[];
            this._primaryKeys = [];
            this._identityKeys = [];
            this._primaryKeyValues = [];
            this._modifiedRecords = [];
            this._addedRecords = [];
            this._tdsOffsetWidth = [];
            this._deletedRecords = [];
            this._disabledToolItems = $();
            this._validationRules = {};
            this._groupedColumns = [];
            this._LastColumnUnGroup = false;
            this._scolumns = [];
            this._currentJsonData = [];
            this._groupingColumnIndex = 0;
            this._dataManager = this._dataSource() instanceof ej.DataManager ? this._dataSource() : this._dataSource() != null ? ej.DataManager(this._dataSource()) : null;
            if (this._dataManager != null && this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.pageSettings.totalRecordsCount != null && this._dataManager.dataSource.json != null)
                this._dataManager.dataSource.json.splice(this.model.pageSettings.totalRecordsCount);
            this._isRemoteSaveAdaptor = (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.remoteSaveAdaptor);
            this._isLocalData = true;
            this._disabledResizingColumns = [];
            this._disabledSortableColumns = [];
            this._disabledGroupableColumns = [];
            this._disabledFilterableColumns = [];
            this._disabledEditableColumns = [];
            this._hiddenColumns = [];
            this._visibleColumns = [];
            this._visibleColumnsField = [];
            this._hiddenColumnsField = [];
            this._ccVisibleColumns = [];
            this._ccHiddenColumns = [];
            this._sortedColumns = [];
            this.multiSortRequest = false;
            this.multiSelectCtrlRequest = false;
            this.multiSelectShiftRequest = false;
            this._enableSelectMultiTouch = false;
            this._enableSortMultiTouch = false;
            this._templateRefresh = false;
            this.initialRender = false;
            this._selectDrag = false;
            this._isAddNew = false;
            this._fieldColumnNames = {};
            this._headerColumnNames = {};
             this._virtualLoadedRecords = {};
            this._virtualLoadedRows = {};
			this._virtualPageRecords = {};
			this._virtaulSel = [];
            this._singleView = false;
			this._dragIndex = null;
			this._dragUpInterval = null;
			this._dragDownInterval = null;
			this._queryCellView = [];
			this._currentPageViews = [];
            this._virtualLoadedPages = [];                                  
            this._currentLoadedIndexes = [];
            this._prevLoadedIndexes = [];
			this._prevVirtualSort = [];
			this._prevVirtualFilter = [];
            this._prevVirtualIndex = 0;
            this._currentVirtualIndex = 1;
            this._virtualRowCount = 0;
            this._virtualSelectedRecords = {};
            this._selectionByGrid = false;
            this._enableCheckSelect = false;
            this.checkSelectedRowsIndexes = [];
            this._isMapSelection = false;
            this._selectionMapColumn = null;
            this._selectAllCheck = false;
            this.selectedRowsIndexes = [];
            this._isReorder = false;
            this._searchString = "";
            this._searchCount = null;
            this.columnsWidthCollection = [];
            this._Indicator = null;
            this._resizer = null;
            this._bulkEditCellDetails = {
                cellValue: null,
                rowIndex: -1,
                columnIndex: -1,
                fieldName: null,
                _data: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                rowData: null
            };
            this.batchChanges = {
                added: [],
                deleted: [],
                changed: []
            };
            this._bulkEditTemplate = $();
            this._confirmDialog = null;
            this._confirmedValue = false;
            this._lastRow = false;
            this._isVirtualRecordsLoaded = false;
            this._scrollValue = 0;
            this._currentTopFrozenRow = this.model.scrollSettings.frozenRows;
            this._rowHeightCollection = [];
            this._scrollObject = null;
            this._customPop = null;
            this.selectedRowCellIndexes = [];
            this._rowIndexesColl = [];
            this.selectedColumnIndexes = [];
			this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
			this.commonQuery = this.model.query.clone();
            if (ej.gridFeatures.group) {
                this._rowCol = this._captionSummary();
                this._isCaptionSummary = (this._rowCol != null && this._rowCol.length) > 0 ? true : false;
            }
            this.phoneMode = this.model.isResponsive && document.documentElement.clientWidth < 360 ? true : false;
            if (this.model.selectionSettings.selectionMode.length > 0 && this.model.allowSelection)
                this._initSelection();
            this._mediaQuery = false;
            this._columnChooserList = null;
            this._$headerCols = null;
            this._$contentCols = null;
            this._detailsOuterWidth = null;
            this._editForm = null;
            this._cloneQuery = null;
            this.localizedLabels = this._getLocalizedLabels();
            this._searchBar = null;
            this._relationalColumns = [];
            this._dropDownManager = {};
			this._isUngrouping = false;
			this._columnChooser = false;
			this._showHideColumns = false;
			this._vCurrentTrIndex = null;
			this._lastVirtualPage = null;
			this._currentVIndex = null;
			if (!this.model.enablePersistence || ej.isNullOrUndefined(this._isHeightResponsive))
	           this._isHeightResponsive = false;
			this._resize = false;
			this._initHeight = 0;
			this._initDataProcessed = false;
			this._menuColTypes = [];
			this._excelColTypes = [];
        },
        _init: function () {
            this._trigger("load");
            if (ej.isNullOrUndefined(this.model.query) || !(this.model.query instanceof ej.Query))
                this.model.query = ej.Query();
            if (!ej.isNullOrUndefined(this.model.parentDetails)) {
                var temp = this.model.queryString, ftemp = this.model.foreignKeyField;
                this.model.query = this.model.query.clone();
                var val = (this.model.parentDetails.parentKeyFieldValue === undefined) ? "undefined" : this.model.parentDetails.parentKeyFieldValue;
                this.model.query.where(ej.isNullOrUndefined(ftemp) ? temp : ftemp, "equal", val, true);
            }
			this._initPrivateProperties();
            if (ej.gridFeatures.common)
                this._initScrolling();            
            if (this.model.enableResponsiveRow)
                this.element.addClass("e-responsive");
            this._checkForeignKeyBinding();
            this._checkDataBinding();
        },
        _initComplexColumn: function (obj, field, cxField) {
            var complexField = cxField || field;
            for (var field1 in obj) {

                if (typeof obj[field1] == "object" && !ej.isNullOrUndefined(obj[field1])) {
                    complexField = complexField.concat(".").concat(field1);
                    this._initComplexColumn(obj[field1], field1, complexField);
                }
                else {
                    var cxFieldName = (complexField).concat(".").concat(field1), value = obj[field1];;
                    this.model.columns.push({
                        field: cxFieldName,
                        type: value != null ? (value.getDay ? (value.getHours() > 0 || value.getMinutes() > 0 || value.getSeconds() > 0 || value.getMilliseconds() > 0 ? "datetime" : "date") : typeof (value)) : null
                    });
                }
            }
        },
        _initColumns: function (object) {
            while (object.items != undefined)
                object = object.items[0];
            if (this.model.columns.length == 0 && object) {
                for (var field in object) {
                    if (object.hasOwnProperty(field) && (typeof (object[field]) != "object" || object[field] instanceof Date || object[field] == null)) {
                        var value = object[field];
                        this.model.columns.push({
                            field: field,
                            type: value != null ? (value.getDay ? (value.getHours() > 0 || value.getMinutes() > 0 || value.getSeconds() > 0 || value.getMilliseconds() > 0 ? "datetime" : "date") : typeof (value)) : null
                        });
                    }
                    else if (typeof (object[field]) == "object") {
                        this._initComplexColumn(object[field], field);
                    }
                }
                this.model.columns.length && this._renderAfterColumnInitialize();
            } else {
                for (var index = 0; index < this.model.columns.length; index++) {
                    this.model.columns[index].field = ej.isNullOrUndefined(this.model.columns[index].field) ? "" : this.model.columns[index].field;
                    if (!ej.isNullOrUndefined(this.model.columns[index].validationRules))
                        this._validatedColumns.push(this.model.columns[index].field);
                    if (ej.isNullOrUndefined(this.model.columns[index].type)) {
                        var $field = !ej.isNullOrUndefined(this.model.columns[index].field) ? ej.getObject(this.model.columns[index].field, object) : null, coldata = this.model.columns[index].dataSource;
                        if (!!coldata && this.model.columns[index].foreignKeyValue) {
                            this.model.columns[index].originalType = $field != null ? ($field.getDay ? ($field.getHours() > 0 || $field.getMinutes() > 0 || $field.getSeconds() > 0 || $field.getMilliseconds() > 0 ? "datetime" : "date") : typeof ($field)) : null;
                            $field = !(coldata instanceof ej.DataManager) ? ej.getObject("0." + this.model.columns[index].foreignKeyValue, coldata) : ej.getObject("0." + this.model.columns[index].foreignKeyValue, this.model.columns[index].foreignKeyData);
                        }
                        this.model.columns[index].type = $field != null ? ($field.getDay ? ($field.getHours() > 0 || $field.getMinutes() > 0 || $field.getSeconds() > 0 || $field.getMilliseconds() > 0 ? "datetime" : "date") : typeof ($field)) : null;
                    }
                    else if (this.model.columns[index]["type"] == "date" && this.model.columns[index].format == undefined && this._isReorder != true && this.initialRender && !this._showHideColumns)
                        $.extend(this.model.columns[index], { format: "{0:" + ej.preferredCulture(this.model.locale).calendars.standard.patterns.d + "}" });
                    else if (this.model.columns[index]["type"] == "datetime" && this.model.columns[index].format == undefined && this._isReorder != true && this.initialRender && !this._showHideColumns)
                        $.extend(this.model.columns[index], { format: "{0:" + ej.preferredCulture(this.model.locale).calendars.standard.patterns.d + " " + ej.preferredCulture(this.model.locale).calendars.standard.patterns.t + "}" });
                  }
            }
        },
        _initSelection: function () {
            var mode = this.model.selectionSettings.selectionMode,i;
            for (i = 0; i < mode.length; i++) {
                this["_allow" + mode[i] + "Selection"] = true;
            }
        },
        _checkDataBinding: function () {
            if (!this.model.columns.length && (((this._dataSource() == null || !this._dataSource().length) && !(this._dataSource() instanceof ej.DataManager)) || ((this._dataSource() instanceof ej.DataManager) && this._dataManager.dataSource.url == undefined && !this._dataSource().dataSource.json.length))) {
                this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this.localizedLabels.EmptyDataSource);
                this._alertDialog.ejDialog("open");
                return;
            }
            this._initialRenderings();
            if (this.model.editSettings.allowDeleting && this.model.selectionType == "multiple")
                this.multiDeleteMode = true;
            this.initialRender = true;
            this.model.enableRTL && this.element.addClass("e-rtl");
            if (this.model.allowFiltering && this._isExcelFilter)
                this._renderExcelFilter();
            if (this.model.cssClass != null)
                this.element.addClass(this.model.cssClass);
            if (this.model.allowGrouping)
                this.element.append(this._renderGroupDropArea());
            if (this.model.toolbarSettings.showToolbar || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow)) {
                this.element.append(this._renderToolBar());
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10 && $.inArray("search", this.model.toolbarSettings.toolbarItems) != -1) {
                    var searching = this.element.find('.e-toolbar.e-toolbarspan .e-gridsearchbar');
                    ej.ieClearRemover(searching[0]);
                }
            }
            var columns = this.model.columns;
            if (columns && columns.length) {
                var expands = this.model.query._expands;                
                if (typeof columns[0] === "string")
                    for (var i = 0; i < columns.length; i++)
                        columns[i] = { field: columns[i] };
                for (var i = 0; i < columns.length; i++) {
                    if (!columns[i].field || columns[i].field.indexOf('.') === -1) continue;
                    this._getExpands(columns[i].field, expands);
                }
                this.model.query.expand(expands);
                this.commonQuery.expand(expands);
                this._renderAfterColumnInitialize();
            }
            if (this.model.allowPaging){
                this.element.append(this._renderGridPager());
				if(this.model.pageSettings.isResponsive)
					$(this.element.find(".e-pager")).ejPager('instance')._reSizeHandler();
			}
            if (this.model.contextMenuSettings.enableContextMenu)
                this.element.append(this._renderContext());
            if ($.isFunction($.fn.ejWaitingPopup)) {
                this.element.ejWaitingPopup({ showOnInit: false });
                $("#" + this._id + "_WaitingPopup").addClass("e-gridwaitingpopup");
            }
            if (this.model.scrollSettings.allowVirtualScrolling) {
                this._loadedJsonData = [];
                this._prevPage = 1;
            }
            if (this._dataSource() instanceof ej.DataManager) {
                this.element.ejWaitingPopup("show");
                if (this._dataSource().ready != undefined) {
                    var proxy = this;
                    this._dataSource().ready.done(function (args) {
                        proxy._initDataSource();
                        proxy.model.dataSource = ej.DataManager(args.result);
                    });
                } else {
                    this.element.ejWaitingPopup("show");
                    this._initDataSource();
                }
            } else {
                this._ensureDataSource();
                this._trigger("actionBegin");
                this._setForeignKeyData();
                this._relationalColumns.length == 0 && this._initGridRender();
				this._vRowHeight = Math.floor(this.getRowHeight());
            }
        },
        _renderColumnChooser: function () {
            var $columnButton = ej.buildTag("button .e-ccButton", this.localizedLabels.Columns, { 'float': (this.model.enableRTL ? 'left' : 'right') }).attr("type", "button");
            this.element.prepend($columnButton);
            $columnButton.ejButton({
                prefixIcon: "e-icon e-down-arrow",
                imagePosition: "imageright",
                contentType: "textandimage",
                type: 'button',
                click: $.proxy(this._ccClickHandler, this),
                width: 90
            });
            var buttHeight = $columnButton.outerHeight();
            $columnButton.css('margin-top', 0 - (buttHeight));
            var elementTop = parseInt(this.element.css('margin-top'),10);
            this.element.css('margin-top', elementTop + buttHeight);
            var $mainDiv = ej.buildTag("div");
            var $outerDiv = ej.buildTag("div .e-grid e-columnChooser", '', {}, { id: this._id + "ccDiv" });
            if ($("#" + this._id + "ccDiv").data("ejDialog") != undefined) {
                $("#" + this._id + "ccDiv").ejDialog("destroy");
                $("#" + this._id + "ccDiv").remove();
            }
            var $searchBox = ej.buildTag("div.e-searchbox e-fields").append(ej.buildTag("input#" + this._id + "_ccSearchBox.e-ejinputtext e-filtertext", {}, {}, { "type": "text" }))
            var $sapnDiv = ej.buildTag('span .e-searchfind e-icon')
            $searchBox.append($sapnDiv);
            var $listOuterDiv = ej.buildTag('div', '', { 'height': '228px' }, { id: this._id + "liScrollerDiv" })
            this._renderColumnChooserData(false);
            $listOuterDiv.append(this._columnChooserList);
            $outerDiv.append($searchBox);
            $outerDiv.append($listOuterDiv);

            var $splitterDiv = ej.buildTag('div .e-columnChooserSplitter', '', { 'border-bottom': '0px' }), $buttonDiv;
            $outerDiv.append($splitterDiv);
            if (this.model.enableRTL) {
                $buttonDiv = ej.buildTag('div .e-ccBtndiv', '', { 'float': 'left', 'margin-top': '7px', 'margin-right': '-13px' });
                var $cancelButton = ej.buildTag("button .e-ccformbtn e-btncan e-flat", this.localizedLabels.Cancel, { 'margin-right': '7px', 'margin-left': '9px' });
                $($sapnDiv).addClass("e-rtl");
            }
            else {
                $buttonDiv = ej.buildTag('div .e-ccBtndiv', '', { 'float': 'right', 'margin-top': '7px' });
                var $cancelButton = ej.buildTag("button .e-ccformbtn e-btncan e-flat", this.localizedLabels.Cancel, { 'margin-right': '7px', 'margin-left': '6px' });
            }
            var $addButton = ej.buildTag("button .e-ccformbtn e-btnsub e-flat", this.localizedLabels.Done);
            $buttonDiv.append($addButton);
            $buttonDiv.append($cancelButton);
            $outerDiv.append($buttonDiv);
            $addButton.ejButton({
                click: $.proxy(this._addButtonCC, this),
                showRoundedCorner: true,
                width: 66
            });
            $cancelButton.ejButton({
                click: $.proxy(this._cancelButtonHandler, this),
                showRoundedCorner: true,
                width: 66
            });
            $outerDiv.insertBefore(this.element)
            $outerDiv.ejDialog({ width: 'auto', beforeClose: $.proxy(this._columnChooserBeforeClose, this), showOnInit: false, allowKeyboardNavigation: false, enableResize: false, "enableRTL": this.model.enableRTL, "cssClass": this.model.cssClass, showHeader: false, width: 260 });
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10) {
                var searchBox = $(".e-columnChooser").find("input#" + this._id + "_ccSearchBox")[0];
                ej.ieClearRemover(searchBox);
            }
        },
        _renderColumnChooserData: function (refresh) {
            var selectAllCheck = this.model.columns.length == this.getVisibleColumnNames().length;            
            this._ccCheckBoxList = [];
            var $listBox = ej.buildTag("div", '', { 'margin-left': '0px', 'width': '250px' }), count = 0;
            for (var index = -1; index < this.model.columns.length; index++) {
                var isSelectAll = index == -1;
                if (isSelectAll || this.model.columns[index].showInColumnChooser) {
                    var column = this.model.columns[index];
                    var colValue = isSelectAll ? this.localizedLabels["SelectAll"] : ej.isNullOrUndefined(column.headerText) || column.headerText == "" ? column.field == "" ? null : column.field : column.headerText,
                        labelValue = column && column.disableHtmlEncode ? this._htmlEscape(colValue) : colValue;
                    if (!ej.isNullOrUndefined(colValue) || isSelectAll) {
                        var $innerDiv = ej.buildTag('div', '', {}, { 'class': 'e-columnChooserListDiv' });
                        var styleAttr = {};
                        var id = isSelectAll ? this._id + 'selectAll' : this._id + colValue.replace(/\s|\.|[^a-zA-Z0-9]|&nbsp/g, "_");
                        var inDom = $listBox.find("#" + id).length; inDom && count++;
                        var $input = ej.buildTag('input', '', styleAttr, { 'id': (!inDom ? id : id + count + ""), 'value': colValue, 'type': 'checkbox', "ej-field": isSelectAll ? '' : column.field, "ej-headertext": isSelectAll ? '' : column.headerText, 'class': isSelectAll ? 'e-selectall' : '' });
                        var label = ej.buildTag('label', labelValue, { 'font-size': '13px' }, { 'for': (!inDom ? id : id + count + "") });
                        $innerDiv.append($input);
                        $innerDiv.append(label);
                        $listBox.append($innerDiv);
                        var checked = !isSelectAll && !ej.isNullOrUndefined(column.visible) ? column.visible : true;
                        $input.ejCheckBox({
                            checked: isSelectAll ? selectAllCheck : checked,
                            change: $.proxy(this._columnChooserCheckChange, this)
                        });
                        if (!isSelectAll && !ej.isNullOrUndefined(column.visible))
                            $input[column.visible ? "attr" : "removeAttr"]("checked", true);
                    }
                }
                else if(this.model.columns[index].showInColumnChooser != undefined)
                    this._showInColumnchooserCol.push(this.model.columns[index]);
            }
            if (!refresh)
                this._columnChooserList = $listBox;
            else {
                this._columnChooserList.empty().append($listBox.children());
                $("#" + this._id + "liScrollerDiv").is(":visible") && $("#" + this._id + "liScrollerDiv").ejScroller('refresh');
            }
            this._ccCheckBoxList = this._columnChooserList.find("input:checkbox.e-js").not(".e-selectall");
        },
        _checkFinder: function () {
            var $this = $(this), $parent = $this.closest(".e-columnChooserListDiv");
            if ($this.hasClass("e-checkbox") && !$parent.hasClass("e-hide") && $this.prop("checked"))
                return true;
        },
        _displayFinder: function () {            
            return !$(this).closest(".e-columnChooserListDiv").hasClass("e-hide");
        },
        _columnChooserCheckChange: function (args) {
            if (!args.isInteraction) {
                if (args.isChecked)
                    $("#" + this._id + "ccDiv").find("button[aria-describedby = '" + this.localizedLabels.Done + "']").removeClass("e-disable");
             return;
            }
            var checked = args.isChecked, displayedCheckBoxes = this._ccCheckBoxList.filter(this._displayFinder), checkedBoxes = this._ccCheckBoxList.filter(this._checkFinder),
                totalChecks = displayedCheckBoxes.length, checkedLen = checkedBoxes.length;
            if (args.model.id == this._id + 'selectAll') {
                if (!checked)
                    checkedBoxes.ejCheckBox({ checked: checked });                
                else           
                    displayedCheckBoxes.not(":checked").ejCheckBox({ checked: checked });                
            }
            else {
                this._columnChooserList.find('input.e-selectall').ejCheckBox('model.checked', totalChecks == checkedLen);
                checked = checkedLen != 0;
                this.element[checked ? "attr" : "removeAttr"]("checked", true);
            }
            var operation = !checked ? "addClass" : "removeClass";
            $("#" + this._id + "ccDiv").find("button[aria-describedby = '" + this.localizedLabels.Done + "']")[operation]("e-disable");
        },
        _columnChooserBeforeClose: function () {
            $(".e-columnChoosertail").remove();
            $(".e-columnChoosertailAlt").remove();
            $("#" + this._id + "ccDiv").find("button[aria-describedby = '" + this.localizedLabels.Done + "']").removeClass("e-disable");
            $("#" + this._id + "_ccSearchBox").val('');
            var args = {};
            args.target = {}; args.target.value = '';
            this._columnChooserSearch(args);
        },
        _columnChooserSearch: function (e) {
            if (e.type == 'click') {
                e.target.value = '';
                $("#" + this._id + "_ccSearchBox").val('');
            }
            var val = e.target.value;
            var span = $("#" + this._id + "_ccSearchBox").next('span');
            if (val != '') {
                span.removeClass("e-searchfind");
                span.addClass("e-cancel");
            }
            else {
                span.removeClass("e-cancel");
                span.addClass("e-searchfind");
            }
            $(".e-cancel").on('click', $.proxy(this._columnChooserSearch, this));
            var currentCheckedItemsData = this.model.columns;
            var columnCollection = [], gridColumns = [], tempCollection = [], proxy = this, 
                isHiddenByGroup = function (field) {
                    var model = proxy.model.groupSettings;
                    return !model.showGroupedColumn && $.inArray(field, model.groupedColumns) > -1;
                };
            if (val != '') {
                currentCheckedItemsData = ej.DataManager(this.model.columns).executeLocal(ej.Query().where("headerText", ej.FilterOperators.startsWith, val, true));
                tempCollection = ej.DataManager(this.model.columns).executeLocal(ej.Query().where("field", ej.FilterOperators.startsWith, val, true));
                tempCollection.forEach(function (obj) {
                    if (obj.headerText == "" && $.inArray(obj, currentCheckedItemsData) == -1)
                        currentCheckedItemsData.push(obj);
                })
            }
             currentCheckedItemsData.forEach(function (obj) {
                 if (obj.showInColumnChooser && !isHiddenByGroup(obj.field)) {
                    var headerText = ej.isNullOrUndefined(obj.headerText) || obj.headerText == "" ? obj.field == "" ? null : obj.field : obj.headerText;
                    columnCollection.push(headerText);
                }
            });
            if (!ej.isNullOrUndefined($("#nomatches")[0]))
                $("#nomatches").remove();
       
            var divs = this._columnChooserList.find(".e-columnChooserListDiv");

            for (var i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i].showInColumnChooser && !ej.isNullOrUndefined(this.model.columns[i].headerText)) {
                    if (this.model.columns[i].headerText != "")
                        gridColumns.push(this.model.columns[i].headerText)
                    else if (this.model.columns[i].field != "")
                        gridColumns.push(this.model.columns[i].field)
                }
            }

            for (var index = 0; index < gridColumns.length; index++) {
                var colValue = gridColumns[index];
                var indx = columnCollection.indexOf(colValue)
                if (!ej.isNullOrUndefined(colValue))
                    divs.eq(index + 1)[indx == -1 ? "addClass" : "removeClass"]("e-hide");
            }

            if (columnCollection.length == 0) {
               this._emptyColumnChooserData();
            }
            var checkDisplay = this._ccCheckBoxList.filter(this._displayFinder).length, checkChecked = this._ccCheckBoxList.filter(this._checkFinder).length, isChk = checkChecked == checkDisplay;
            if (columnCollection.length)
                divs.eq(0).find("input.e-js").ejCheckBox({ checked: isChk });
            divs.eq(0)[columnCollection.length == 0 ? "addClass" : "removeClass"]("e-hide");
            $("#" + this._id + "ccDiv").find("button[aria-describedby = '" + this.localizedLabels.Done + "']")[!checkChecked ? "addClass" : "removeClass"]("e-disable");
            $("#" + this._id + "liScrollerDiv").ejScroller('refresh');
        },
        _addButtonCC: function () {
            this._visibleColumns = [];
            this._hiddenColumns = [];
            this._visibleColumnsField = [];
            this._hiddenColumnsField = [];
            this._columnChooserClick = true;
            var args = {}; args.requestType = "columnchooser";
			this._columnChooser = true;
            var chbxs = this._columnChooserList.find("input:checkbox.e-js").not('.e-selectall');
            for (var i = 0, len = chbxs.length; i < len; i++) {
                var ele = $(chbxs[i]), hTxt = ele.attr("ej-headertext"), field = ele.attr("ej-field");
                if(this._id+"selectAll"!=ele.attr("id")){
                    this[chbxs[i].checked ? "_visibleColumns" : "_hiddenColumns"].push(hTxt);
                    this[chbxs[i].checked ? "_visibleColumnsField" : "_hiddenColumnsField"].push(field != "" ? field : hTxt);
                }
            }
            for (var i = 0, len = this._showInColumnchooserCol.length; i < len; i++) {
                var column = this._showInColumnchooserCol[i], htext = column.headerText, field = column.field;
                this[column["visible"] ? "_visibleColumns" : "_hiddenColumns"].push(htext);
                this[column["visible"] ? "_visibleColumnsField" : "_hiddenColumnsField"].push(field != "" ? field : htext);
            }
            var array1 = this._visibleColumns;
            var array2 = this._hiddenColumns;
            var arr = [], obj, duparr;
            obj = $.merge($.merge([], array1), array2);
            duparr = this._isDuplicate(obj);
            this._trigger("actionBegin", args);
            if (duparr) {
                this.showColumns(this._visibleColumnsField);
                this.hideColumns(this._hiddenColumnsField);
            }
            else {
                this.showColumns(this._visibleColumns);
                this.hideColumns(this._hiddenColumns);
            }
            $("#" + this._id + "ccDiv").ejDialog('close');
            $(".e-columnChoosertail").remove();
            this.refreshScrollerEvent();
            args = { requestType: "columnchooser", removedcolumns: [], addedcolumns: [], visiblecolumns: this.getVisibleColumnNames(), hiddencolumns: this.getHiddenColumnNames() };
            this._ccColumnUpdate(args.addedcolumns, this.getVisibleColumnNames(), this._ccVisibleColumns);
            this._ccColumnUpdate(args.removedcolumns, this.getHiddenColumnNames(), this._ccHiddenColumns);
            this._trigger("actionComplete", args);
            this._columnChooser = false;
        },
        _ccColumnUpdate: function (args, getColumns, ccColumns) {
            for (var i = 0; i < getColumns.length; i++) {
                if ($.inArray(getColumns[i], ccColumns) == -1)
                    args.push(getColumns[i]);
            }
        },
        _isDuplicate: function (arr) {
            var temp, count = [], duplicate = [];
            for (var i = 0; i < arr.length; i++) {
                temp = arr[i];
                if (count[temp] >= 1)
                    count[temp] = count[temp] + 1;
                else
                    count[temp] = 1;
            }
            for (temp in count) {
                if (count[temp] > 1)
                    return true;
            }
            return false;
        },
        _cancelButtonHandler: function () {
            $("#" + this._id + "ccDiv").ejDialog('close');
            $(".e-columnChoosertailAlt").remove();
            $(".e-columnChoosertail").remove();
        },
        _ccClickHandler: function (e) {
            var dlgWidth = 230, xPos;
            var chooserButton = this.element.find(".e-ccButton");
            xPos = chooserButton.offset().left + chooserButton.width();
            var dialogObj = $("#" + this._id + "ccDiv").data('ejDialog')
            if (dialogObj && dialogObj.isOpened()) {
                dialogObj.close();
                $(".e-columnChoosertail").remove();
                $(".e-columnChoosertailAlt").remove();
            }
            else {
                $("#" + this._id + "ccDiv").ejDialog({ width: '230px', height: '310px', position: { X: (this.model.enableRTL ? (xPos - dlgWidth + 143) : (xPos - dlgWidth)), Y: chooserButton.offset().top + 35 } })
                   .ejDialog("open");
                var maxZindex = parseInt($("#" + this._id + "ccDiv_wrapper").css('z-index'));
                var $tailDiv = ej.buildTag("div #" + this._id + "_ccTail .e-columnChoosertail", '', { 'display': 'block', 'position': 'absolute', 'left': (this.model.enableRTL ? (xPos - 78) : (xPos - 29)), 'top': chooserButton.offset().top + 15 });
                var $tailDiv2 = ej.buildTag("div #" + this._id + "_ccTailAlt .e-columnChoosertailAlt", '', { 'display': 'block', 'z-index': maxZindex + 2, 'position': 'absolute', 'left': (this.model.enableRTL ? (xPos - 78) : (xPos - 29)), 'top': chooserButton.offset().top + 16 });
                $tailDiv.insertBefore($("#" + this._id + "ccDiv_wrapper"));
                $tailDiv2.insertBefore($("#" + this._id + "ccDiv_wrapper"));
            }
            this._refreshColumnChooserList();
            this._ccVisibleColumns = this.getVisibleColumnNames();
            this._ccHiddenColumns = this.getHiddenColumnNames();
            $("#" + this._id + "liScrollerDiv").ejScroller({ height: '228', width: '228', buttonSize: 0 });
            $("#" + this._id + "liScrollerDiv").ejScroller('refresh');
            if (!ej.isIOSWebView() && this.getBrowserDetails().browser == 'chrome')
                $('.e-columnChooser .e-hscrollbar').attr('style', 'height: 10px !important;');
            $(".e-ejinputtext").on('keyup', $.proxy(this._columnChooserSearch, this))
        },
        _refreshColumnChooserList: function (collection) {
            var chbxs = this._columnChooserList.find("input:checkbox.e-js").not('.e-selectall');
			var duparr = this._isDuplicate($.merge($.merge([], this._visibleColumns), this._hiddenColumns));
            for (var i = 0, len = chbxs.length; i < len; i++) {
                var ele = $(chbxs[i]), hTxt = ele.attr("ej-headertext"), field = ele.attr("ej-field"), flag = undefined, isDup = chbxs.filter('[ej-headertext="' + hTxt + '"]').length;
                if (this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && $.inArray($(chbxs[i]).attr("ej-field"), this.model.groupSettings.groupedColumns) != -1) {
                    $(chbxs[i]).parents(".e-columnChooserListDiv").addClass("e-hide");
                    chbxs[i].checked = false;
				if(this._columnChooserList.find(".e-columnChooserListDiv").eq(0).hasClass("e-hide") && this.model.columns.length > this.model.groupSettings.groupedColumns.length)
					this._columnChooserList.find(".e-columnChooserListDiv").eq(0).removeClass("e-hide")
             
                }
                else {
                    $(chbxs[i]).parents(".e-columnChooserListDiv").removeClass("e-hide");
                    chbxs[i].checked = true;
                }
                var colValue = duparr ? (field == "" ? hTxt : field) : hTxt;
				flag = this[duparr ? "_hiddenColumnsField" : "_hiddenColumns"].indexOf(colValue) != -1;
                ele["prop"]("checked", !flag);
                ele.ejCheckBox("model.checked", !flag);
            }
            var chkSelectAll = chbxs.filter(this._displayFinder).length == chbxs.filter(this._checkFinder).length && chbxs.filter(this._displayFinder).length ? true : false;
            this._columnChooserList.find("input:checkbox.e-selectall").ejCheckBox({ checked: chkSelectAll });
            if (!this.model.groupSettings.showGroupedColumn) {
				if (!ej.isNullOrUndefined($("#nomatches")[0]))
					$("#nomatches").remove();
			if(this.model.columns.length == this.model.groupSettings.groupedColumns.length){
					this._columnChooserList.find(".e-columnChooserListDiv").eq(0).addClass("e-hide")
					this._emptyColumnChooserData();
				}
                var enable = chbxs.filter(this._displayFinder).length > 0 ? true : false;
                $("#" + this._id + "ccDiv").find("button[aria-describedby='Done']").ejButton({ enabled: enable })
            }
        },
		_emptyColumnChooserData:function(){
            var $labeldiv = ej.buildTag('div#nomatches', '', { 'padding-left': '13px' });
			var div = $("#" + this._id + "ccDiv").find("#" + this._id + "liScrollerDiv")
            var $label = ej.buildTag('span', this.localizedLabels.NoResult);
            $labeldiv.append($label);
            $(div).append($labeldiv);
		},
        _initDataSource: function () {
            this._isLocalData = (!(this._dataSource() instanceof ej.DataManager) || (this._dataSource().dataSource.offline || this._isRemoteSaveAdaptor || this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor));
            if (this._dataSource().adaptor instanceof ej.SqlDataSourceAdaptor) this._isLocalData = false;
            this._ensureDataSource();
            this._trigger("actionBegin");
            var queryPromise = this._dataSource().executeQuery(this.model.query), subPromises, proxy = this;
            if (this._dataManager.dataSource.table != null)
                this._dataManager.dataSource.table.css("display", "none");
            if (!this.element.is(":visible"))
                this.element.ejWaitingPopup("hide");
            queryPromise.done(ej.proxy(function (e) {
                if (!this._initDataProcessed) {
                    this._initDataProcess(e);
                    this._initDataProcessed = true;
                }
            }, this));
            var proxy = this;
            queryPromise.fail(function (e) {
                if (ej.isNullOrUndefined(proxy.element))
                    return;
                proxy.element.ejWaitingPopup("hide");
                proxy.model.currentViewData = [];
                proxy._gridRecordsCount = 0;
                proxy._renderGridContent().insertAfter(proxy.element.children(".e-gridheader"));
                var args = { error: e.error };
                proxy._trigger("actionFailure", args)
            })
        },
        _initDataProcess: function(e, args){
            if (ej.isNullOrUndefined(this.element))
                return;
            this._relationalColumns.length == 0 && this.element.ejWaitingPopup("hide");
            if (!this.model.columns.length && !e.count) {
                var lastPage = (e.count % this.model.pageSettings.pageSize == 0) ? (e.count / this.model.pageSettings.pageSize) : (parseInt(e.count / this.model.pageSettings.pageSize, 10) + 1);
                if (this._currentPage() > lastPage)
                    this._currentPage(lastPage);
                this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this.localizedLabels.EmptyDataSource);
                this._alertDialog.ejDialog("open");
                this.element.ejWaitingPopup("hide");
                return;
            }
            if (!ej.isNullOrUndefined(e.aggregates))
                this._remoteSummaryData = e.aggregates;
            if (!this.model.scrollSettings.enableVirtualization)
                this.model.currentViewData = e.result;
            if (this._$fkColumn && this.model.filterSettings.filteredColumns.length > 0 && this.model.filterSettings.filterType == "excel")
                this._fkParentTblData = e.result;
            if (!this.model.enablePersistence && this.model.pageSettings.totalRecordsCount != null && this.model.filterSettings.filteredColumns.length == 0)
                this._gridRecordsCount = this.model.pageSettings.totalRecordsCount;
            else if (e.count == 0 && e.result.length)
                this._gridRecordsCount = e.result.length;
            else
                this._gridRecordsCount = e.count;
            if (this.model.filterSettings.filteredColumns.length > 0)
                this._filteredRecordsCount = e.count;
            if (this.getPager() != null)
                this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;
            if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                this._refreshVirtualViewDetails();
                if (this._isInitNextPage || this._remoteRefresh) {
                    this._setInitialCurrentIndexRecords(e.result, this._currentPage());
                    this._isInitNextPage = this._remoteRefresh = false;
                }
                else
                    this._setVirtualLoadedRecords(e.result, this._currentPage());
                if (this._isThumbScroll && !this._checkCurrentVirtualView(this._virtualLoadedRecords, this._currentVirtualIndex))
                    this._checkPrevNextViews(this._currentPage());
                if (this.initialRender) {
                    this.model.currentViewData = [];
                    for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                        var currentView = this._currentLoadedIndexes[i];
                        $.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView] || []);
                    }
                }
                else
                    this.model.currentViewData = e.result;
            }
            this._setForeignKeyData(args);
            this._relationalColumns.length == 0 && this._initGridRender();
        },
        _initialRenderings: function () {
            if (this.model.groupSettings.groupedColumns.length) {
                var sortedColumns = new Array();
                for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                    if (ej.isNullOrUndefined(this.model.sortSettings.sortedColumns[i].direction))
                        this.model.sortSettings.sortedColumns[i].direction = ej.sortOrder.Ascending;
                    sortedColumns.push(this.model.sortSettings.sortedColumns[i].field);
                }
                if(this.model.allowGrouping){
					for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
						if ($.inArray(this.model.groupSettings.groupedColumns[i], sortedColumns) == -1)
							this.model.sortSettings.sortedColumns.push({ field: this.model.groupSettings.groupedColumns[i], direction: ej.sortOrder.Ascending });
					}
                }
            }
        },
        _getExpands: function (field, arr) {
            var splits = field.split('.'), tmp = "";
            splits.splice(splits.length - 1, 1);
            for (var i = 0; i < splits.length; i++, tmp = "") {
                for (var j = 0; j < i; j++)
                    tmp += splits[j] + "/";
                tmp = tmp + splits[i];
                if (arr.indexOf(tmp) === -1)
                    arr.push(tmp);
            }
        },
        _renderAfterColumnInitialize: function () {
            this.element.append(this._renderGridHeader());
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") {
                this._renderFiltering();
                this._renderFilterBarTemplate();
            }
			if(this.model.gridLines != "both")
				this._showHeaderGridLines();
            if (this.model.allowPaging)
                this.element.append(this.element.find(".e-pager").first());
        },
        _ensureDataSource: function (args) {
            if (this._dataSource() == null && !(this._dataSource() instanceof ej.DataManager)) {
                if (!ej.isNullOrUndefined(args) && args.requestType == "add")
                    this.dataSource([]);
                else
                    return;
            }
            this.model.query.requiresCount();
            var queryManagar = this.model.query;
            var cloneQuery = queryManagar.clone();
            if (!(this._dataSource() instanceof ej.DataManager))
                this.model.currentViewData = this._dataSource();
            if (this._isLocalData && (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) && (!ej.isNullOrUndefined(this._cModifiedData) || !ej.isNullOrUndefined(this._cAddedRecord))) {
                if (ej.isNullOrUndefined(this._cAddedRecord)) {
                    for (var index = 0; index < this._primaryKeys.length; index++)
                        queryManagar = queryManagar.where(this._primaryKeys[index], ej.FilterOperators.equal, this._primaryKeyValues[index]);
                    var currentData = this._dataManager.executeLocal(queryManagar);
                    if (!(this._dataSource() instanceof ej.DataManager))
                        ej.copyObject(this._dataSource()[$.inArray(currentData.result[0], this._dataSource())], this._cModifiedData);
                    else
                        ej.copyObject(this._dataSource().dataSource.json[$.inArray(currentData.result[0], this._dataSource().dataSource.json)], this._cModifiedData);
                    this._cModifiedData = null;
                } else {
                    var tmpRcrd = this._cAddedRecord;
                    this._cAddedRecord = null;
                    (this._dataSource() instanceof ej.DataManager) ? this._dataSource().dataSource.json.unshift(tmpRcrd) : this._dataSource(undefined, true).splice(0, 0, tmpRcrd);
                }
                queryManagar.queries = cloneQuery.queries;
                if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal"))
                    this.model.isEdit = false;
            }
            if (args && this.model.editSettings.allowDeleting && args.requestType == "delete" && (this._excludeDetailRows().length == 1 || (this.multiDeleteMode == "multiple" && this.selectedRowsIndexes.length == this._excludeDetailRows().length)) && this.model.pageSettings.currentPage != 1)
                this._currentPage(this.model.pageSettings.totalPages - 1)
            if (args && this.model.editSettings.allowDeleting && args.requestType == "delete" && !ej.isNullOrUndefined(this._cDeleteData) && this._isLocalData) {
                if (!(this._dataSource() instanceof ej.DataManager)) {
                    var index = $.inArray(this._cDeleteData[0], this._dataSource());
                    this._dataSource(undefined, true).splice(index, 1);
                }
                else {
                    var index = $.inArray(this._cDeleteData[0], this._dataSource().dataSource.json);
                    this._dataSource().dataSource.json.splice(index, 1);
                }
            }
            if (this.model.scrollSettings.allowVirtualScrolling && args && (args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete")) {
                this._virtualDataRefresh = true;
                this._refreshVirtualViewData();
            }
            if (this.model.sortSettings.sortedColumns.length) {
                 var sortedGrp = [], sortedColumns = this.model.sortSettings.sortedColumns;
                for (var i = sortedColumns.length - 1; i >= 0; i--){
                    if(this.model.groupSettings.groupedColumns.indexOf(sortedColumns[i].field) == -1){
                        queryManagar.sortBy(sortedColumns[i].field, sortedColumns[i].direction);
						if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization && $.inArray(sortedColumns[i], this._prevVirtualSort) == -1){
							for(var j = 0; j < this._prevVirtualSort.length; j++){
								if(sortedColumns[i].field == this._prevVirtualSort[j].field)
									this._prevVirtualSort.splice(j, 1);
							}
							this._needVPaging = this._currentVirtualIndex * this._virtualRowCount % this.model.pageSettings.pageSize <= this._virtualRowCount;
							this._prevVirtualSort.push(sortedColumns[i]);	
							this._virtualDataRefresh = true;
							this._refreshVirtualViewData();							
						}
					}
                    else
                        sortedGrp.push({field: sortedColumns[i].field, direction: sortedColumns[i].direction })
				}
                for (var j = 0; j < sortedGrp.length ; j++){
                    queryManagar.sortBy(sortedGrp[j].field, sortedGrp[j].direction);
                }
            }

            if (this.model.allowSearching && this.model.searchSettings.key.length) {
                var searchDetails = this.model.searchSettings;
                searchDetails.fields = searchDetails.fields.length != 0 ? searchDetails.fields : this.getColumnFieldNames();
                queryManagar.search(searchDetails.key, searchDetails.fields, searchDetails.operator || "contains", searchDetails.ignoreCase);
                if (!this.initialRender && args.requestType == "searching")
                    this._currentPage(1);
            }
            if (this._isLocalData && this.model.allowSearching)
                this._filteredRecords = this.model.searchSettings.key.length != 0 ? this._dataManager.executeLocal(queryManagar).result : [];
            if (this.model.allowFiltering && this.model.filterSettings.filteredColumns.length) {
                var predicate, firstFilterCondition = this.model.filterSettings.filteredColumns[0];
                var filteredColumns = this.model.filterSettings.filteredColumns;
                for (var i = 0; i < filteredColumns.length; i++) {
                    var index = $.inArray(this.getColumnByField(filteredColumns[i].field), this.filterColumnCollection);
                    if (filteredColumns[i].field !== "" && index == -1)
                        this.filterColumnCollection.push(this.getColumnByField(filteredColumns[i].field));
                }
				if ((this._isExcelFilter || this._excelFilterRendered) && !(firstFilterCondition instanceof ej.Predicate)) {
                    this._excelFilter.getPredicate(filteredColumns, null, true);
                    var predicates = this._excelFilter._predicates[0];
                    for (var prop in predicates) {
                        var obj = predicates[prop], isTake = obj["from"] != undefined;
                        if (isTake)
                            queryManagar.skip(obj["from"] == "top" ? 0 : this._gridRecordsCount - obj["take"]).take(obj["take"]);
                        else
                            predicate = predicate != undefined ? predicate["and"](obj) : obj;
                    }
                }
                else {
                    if (!(firstFilterCondition instanceof ej.Predicate))
                        predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, !firstFilterCondition.matchcase);
                    else {
                        predicate = firstFilterCondition;
                        if (this._excelFilterRendered) {
                            var dis = ej.distinct(filteredColumns, "field", false);
                            this._excelFilter._predicates[0] = this._excelFilter._predicates[0] || {};
                            this._excelFilter._predicates[0][dis[0]] = predicate;
                        }
                    }
                    for (var i = 1; i < filteredColumns.length; i++) {
                        if (!(filteredColumns[i] instanceof ej.Predicate)) {
                            if (!this._isLocalData && filteredColumns.length > 2 && i > 1 && filteredColumns[i].predicate == "or")
                                predicate.predicates.push(ej.Predicate(filteredColumns[i].field, filteredColumns[i].operator, filteredColumns[i].value, filteredColumns[i].ignoreCase || !filteredColumns[i].matchcase));
                            else
                                predicate = predicate[filteredColumns[i].predicate || "and"](filteredColumns[i].field, filteredColumns[i].operator, filteredColumns[i].value, !filteredColumns[i].matchcase);
                        }
                        else
                            predicate = predicate[filteredColumns[i].predicate || "and"](filteredColumns[i]);
                    }
                }
                predicate && queryManagar.where(predicate);
                if (this._isLocalData) {
                    var fresults = this._dataManager.executeLocal(queryManagar);
                    this._filteredRecordsCount = isTake ? fresults.result.length : fresults.count;
                    var lastPage = (this._filteredRecordsCount % this.model.pageSettings.pageSize == 0) ? (this._filteredRecordsCount / this.model.pageSettings.pageSize) : (parseInt(this._filteredRecordsCount / this.model.pageSettings.pageSize, 10) + 1);
                    if (this._currentPage() > lastPage)
                        this._currentPage(lastPage);
                    this._filteredRecords = this._dataManager.executeLocal(queryManagar).result;
                    if (this._$fkColumn && this.model.filterSettings.filteredColumns.length > 0 && this.model.filterSettings.filterType == "excel")
                        this._fkParentTblData  = this._filteredRecords;
                } else if (!ej.isNullOrUndefined(args) && args.requestType == ej.Grid.Actions.Filtering)
                    this._currentPage(1);
				if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
					for(var i = 0; i < filteredColumns.length; i++){
						for(var j = 0; j < this._prevVirtualFilter.length; j++){
							if(filteredColumns[i] == this._prevVirtualFilter[j] && args.requestType == ej.Grid.Actions.Filtering)
								this._prevVirtualFilter.splice(j, 1);
						}
						if($.inArray(filteredColumns[i], this._prevVirtualFilter) == -1){
							this._prevVirtualFilter.push(filteredColumns[i]);	
							this._gridRecordsCount = this._filteredRecordsCount;
							this._refreshViewPageDetails();							
							this._refreshVirtualViewData();
							this._refreshVirtualViewDetails();							 
						}
					}
				}
            }
			if (this._isLocalData && this.model.allowFiltering && this.model.filterSettings.filteredColumns.length==0){
				if(!ej.isNullOrUndefined(this._filteredRecordsCount) || this._filteredRecordsCount > 0){
					if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
						this._refreshViewPageDetails();
						this._refreshVirtualViewDetails(true);						
					}
					this._filteredRecordsCount = null;
					this._filteredRecords = [];
				}
			}

            if (this.model.summaryRows.length) {
                this._setSummaryAggregate(queryManagar);
            }

            if (this.model.allowPaging || (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling && !this.model.scrollSettings.enableVirtualization)) {
                if (this._isLocalData) {
                    var fresults = this._dataManager.executeLocal(queryManagar);
                    this._recordsCount = fresults.count;
                    var lastPage = (this._recordsCount % this.model.pageSettings.pageSize == 0) ? (this._recordsCount / this.model.pageSettings.pageSize) : (parseInt(this._recordsCount / this.model.pageSettings.pageSize, 10) + 1);
                    if (this._currentPage() > lastPage)
                        this._currentPage(lastPage);
                }
                if (this._currentPage() == 0) {
                    if (this._prevPageNo == 0 || this._prevPageNo == null)
                        this._currentPage(1);
                    else
                        this._currentPage(this._prevPageNo);
                }
                if (!this._isLocalData && !this.initialRender && !ej.isNullOrUndefined(args) && args.requestType == "refresh") {
                    if (cloneQuery.queries.length) {
                        for (i = 0; i < cloneQuery.queries.length; i++) {
                            if (cloneQuery.queries[i].fn == "onWhere")
                                this._currentPage(1);
                        }
                    }
                }
                queryManagar.page(this._currentPage(), this.model.pageSettings.pageSize);
            }
			
			 if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {                              
                this._needPaging = true; 				
                if (this.initialRender && this.model.currentIndex > 1 && (this.model.currentIndex <= this._getVirtualTotalRecord() || !this._isLocalData)) { 					
					if(this.model.scrollSettings.virtualScrollMode == "continuous")
						this.model.currentIndex = 1;
                    this._currentVirtualIndex = Math.ceil(this.model.currentIndex / this._virtualRowCount);
                    this._isThumbScroll = true;
                    this._currentPage(Math.ceil(this.model.currentIndex / this.model.pageSettings.pageSize));
					this._virtualLoadedPages.push(this._currentPage());
                }
				if(this._virtualDataRefresh){					
                    this._isThumbScroll = true;
					this._refreshVirtualViewData(true);
					this._gridRecordsCount = this._dataSource() !== null ? (this.model.pageSettings.totalRecordsCount == null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount) : 0;
                    this._currentPage(Math.ceil(this._currentVirtualIndex * this._virtualRowCount / this.model.pageSettings.pageSize));
					this._virtualLoadedPages.push(this._currentPage());					
				}
                if(this.model.virtualLoading != null)
                    this._gridRecordsCount = this.model.pageSettings.totalRecordsCount;
				if(this.model.filterSettings.filteredColumns == 0 && this._prevVirtualFilter.length){
					this._refreshVirtualViewData();
					this._prevVirtualFilter = [];
				}									
				if(this._isLocalData && this.initialRender)
				    this._refreshVirtualViewDetails();
				this._getVirtualLoadedRecords(queryManagar);
            }	

            if (this.model.allowGrouping) {
                var cloned = queryManagar.clone();
                if (this.model.allowPaging && this.model.groupSettings.groupedColumns.length) {
                    cloned.queries = cloned.queries.slice(0, cloned.queries.length - 1);
                }
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                    var colName = this.model.groupSettings.groupedColumns[i], col = this.getColumnByField(colName);
                    if (!ej.isNullOrUndefined(col) && !ej.isNullOrUndefined(col.enableGroupByFormat) && col.enableGroupByFormat) {
                        queryManagar.group(colName, ej.proxy(this._formatGroupColumn, this));
                        cloned.group(colName, ej.proxy(this._formatGroupColumn, this));
                    }
                    else {
                        queryManagar.group(colName);
                        cloned.group(colName);
                    }
                }
                if (this.model.groupSettings.groupedColumns.length)
                    this._setAggreatedCollection(cloned);
            }
            if (args != undefined && args.requestType == "add" && this._isLocalData && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0)
                !(this._dataSource() instanceof ej.DataManager) ? this._dataSource().unshift(args.data) : this._dataSource().dataSource.json.unshift(args.data);
            if ((!ej.isNullOrUndefined(args) && args.action == "add") && !ej.isNullOrUndefined(this.model.parentDetails)) {
                var column = this.getColumnByField(this.model.parentDetails.parentKeyField);
                var ix = $.inArray(column, this.model.columns)
                if (ix == -1) {
                    var newdata = {};
                    newdata[this.model.parentDetails.parentKeyField] = this.model.parentDetails.parentKeyFieldValue;
                    $.extend(true, this.model.currentViewData[0], newdata);
                }
            }
            this._cloneQuery = queryManagar.clone();
                if (this._isLocalData && (!this.model.scrollSettings.enableVirtualization || this._virtualDataRefresh)) {
                var dataMgrJson = this._dataManager.dataSource.json;
                var dataSource = this._dataSource().dataSource;
                if (!ej.isNullOrUndefined(dataSource) && this._dataSource() instanceof ej.DataManager)
                    this._dataManager.dataSource.json = dataMgrJson != dataSource.json ? dataSource.json : dataMgrJson;
                var result = this._dataManager.executeLocal(queryManagar);
                if (!(!ej.isNullOrUndefined(args) && args.requestType == "beginedit")) {
                    if (this.model.scrollSettings.allowVirtualScrolling && this.model.pageSettings.currentPage == this.model.pageSettings.totalPages - 1)
                        this._prevPageRendered = true;
                    if (this.model.scrollSettings.allowVirtualScrolling && !this._prevPageRendered && result.result.length != this.model.pageSettings.pageSize && this.model.pageSettings.totalPages == this.model.pageSettings.currentPage) {
                        var pageQuery = ej.pvt.filterQueries(queryManagar.queries, "onPage");
                        queryManagar.queries.splice($.inArray(pageQuery[0], queryManagar.queries), 1);
                        queryManagar.page(this._currentPage() - 1, this.model.pageSettings.pageSize);
                        var lastPageResult = this._dataManager.executeLocal(queryManagar);
                        lastPageResult.result.splice(0, result.result.length);
                        this._previousPageRecords = $.extend(true, [], lastPageResult.result);
                        this._previousPageLength = result.result.length;
                        this._currentPageData = result.result;
                        ej.merge(lastPageResult.result, result.result);
                        this.model.currentViewData = this._lastVirtualPage = lastPageResult.result;
                        this._lastPageRendered = true;
                    }
                    else if (this._lastPageRendered && this.model.pageSettings.currentPage == this.model.pageSettings.totalPages - 1 && !this.model.scrollSettings.enableVirtualization) {
                        var count = this.model.pageSettings.pageSize - this._previousPageLength;
                        for (var dupRow = 0; dupRow < count; dupRow++) {
                            var removeEle = this.getRows()[this.getRows().length - (this.model.pageSettings.pageSize - dupRow)];
                            removeEle.remove();
                        }
                        this._tempPageRendered = true;
                        this.model.currentViewData = result.result;
                    }
                    else
                        this.model.currentViewData = result.result;
                }
                else
                    this.model.currentViewData = result.result;
                this._gridRecordsCount = result.count;
                this._remoteSummaryData = result.aggregates;
                this._searchCount = this._searchString.length ? result.count : null;
                this.model.groupSettings.groupedColumns.length && this._setAggregates();
            }
        },
        _formatGroupColumn: function (value,field) {
            var col = this.getColumnByField(field), format;
            format = col.format;
            var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
            format = toformat.exec(format)[2];
            return ej.format(value, format, this.model.locale);
        },
		_refreshViewPageDetails: function(){
			this._currentPage(1);
			this.model.currentIndex = 0;
			this._currentVirtualIndex = 1;
			this.getContent().ejScroller("model.scrollTop", 0);
		},
		_refreshVirtualViewDetails: function (dataRefreshed) {
		    var dataSrc = this._dataSource();
			if(dataRefreshed)
			    this._gridRecordsCount = dataSrc !== null ? dataSrc instanceof ej.DataManager ? dataSrc.dataSource.json.length : dataSrc.length : this.model.pageSettings.totalRecordsCount;
			this._totalVirtualViews = Math.ceil(this._getVirtualTotalRecord() / this._virtualRowCount);
			this._maxViews = Math.ceil(this.model.pageSettings.pageSize / this._virtualRowCount);			
			this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
			this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;			
			this._lastViewData = this._virtualRowCount - ((this._totalVirtualViews * this._virtualRowCount) - this._getVirtualTotalRecord());		
		},
		_getVirtualLoadedRecords: function (queryManagar) {                                        
            var currentPage = this._currentPage(), needTwoPage;
			if (this._needPaging){
				this._isLastVirtualpage = needTwoPage = this._isThumbScroll && currentPage == this.model.pageSettings.totalPages && !this._virtualPageRecords[currentPage];				
				if(this.initialRender || this._virtualDataRefresh) needTwoPage = true;
				if (this.model.virtualLoading && this._isLocalData && (this.model.currentIndex != 0 || currentPage != 1) && this.model.currentIndex < this.model.pageSettings.totalRecordsCount)
					this._getVirtualOnLoadingData(currentPage, !needTwoPage);
				else
					this._setVirtualPaging(queryManagar, currentPage, !needTwoPage);
				if(!this.initialRender && this._isThumbScroll && this._virtualPageRecords[currentPage] && !this._virtualDataRefresh)
					this._checkPrevNextViews(currentPage, queryManagar);
			}		                            
			this._needPaging = false;			
            this._setVirtualLoadedIndexes(this._currentVirtualIndex);
            if(this.initialRender && this._isLocalData){
                this.model.currentViewData = [];
                for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                    var currentView = this._currentLoadedIndexes[i];
					if(this._virtualLoadedRecords[currentView])
						$.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView]);
                }
            }
        },
        _setVirtualPaging: function(queryManagar, currentPage, isCurrentIndex){     
            var pageQuery = ej.pvt.filterQueries(queryManagar.queries, "onPage");
			if(pageQuery.length)
				queryManagar.queries.splice($.inArray(pageQuery[0], queryManagar.queries), 1);
			if((!isCurrentIndex || this._needVPaging) && this.model.currentIndex > this._virtualRowCount)
				this._initCurrentIndex(queryManagar, currentPage);	
			else
				queryManagar.page(currentPage, this.model.pageSettings.pageSize);
            this._needVPaging = false;
            if(this._isLocalData && !this._virtualPageRecords[currentPage]) {								 
				var result = this._dataManager.executeLocal(queryManagar);   
				if(!this.initialRender) this.model.currentViewData = result.result;
				if(result.result.length){
					this._setVirtualLoadedRecords(result.result, currentPage);					
					if($.inArray(currentPage, this._virtualLoadedPages) == -1)
						this._virtualLoadedPages.push(currentPage);
				}
				else if (!this.initialRender)
					this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();					
			}                   						
        },
		_checkPrevNextViews: function(currentPage){
			var currentVirtualIndex = this._currentVirtualIndex;
			var prevView = this._virtualLoadedRecords[currentVirtualIndex - 1], nextView = this._virtualLoadedRecords[currentVirtualIndex + 1];			
				var adjust = this._maxViews == 3 ? 1 : 2, sTop;																	
				if(currentVirtualIndex != 1 && currentVirtualIndex != this._totalVirtualViews){				
					if(!prevView || prevView.length != this._virtualRowCount){
						var currentIndex = currentVirtualIndex + adjust;
						this._currentVirtualIndex = this._virtualLoadedRecords[currentVirtualIndex] ? currentIndex : currentIndex + 1;
						sTop = this._scrollValue + (adjust * this._virtualRowCount * this._vRowHeight);
					}
					else if((!nextView || nextView.length != this._virtualRowCount) && this._totalVirtualViews != currentVirtualIndex - 1){
						var currentIndex = currentVirtualIndex - adjust;
						this._currentVirtualIndex = this._virtualLoadedRecords[currentVirtualIndex] ? currentIndex : currentIndex - 1;
						sTop = this._scrollValue - (adjust * this._virtualRowCount * this._vRowHeight);
					}			
					if(sTop){					
						this._scrollValue = sTop;
						this._setVirtualLoadedIndexes(this._currentVirtualIndex);
						this.model.currentIndex = sTop == 0 ? sTop : Math.floor(sTop / this._vRowHeight);
					}
				}			
		},
		_initCurrentIndex: function(queryManagar, currentPage){			
			var pageResultCount = currentPage * this.model.pageSettings.pageSize;
			var nextDataCount = (this._currentVirtualIndex * this._virtualRowCount) + this._virtualRowCount;
			var prevDataCount = (this._currentVirtualIndex *  this._virtualRowCount) - (this._virtualRowCount * 2);	
			var needTwoPage = nextDataCount > pageResultCount || prevDataCount < pageResultCount - this.model.pageSettings.pageSize;
			if(needTwoPage || this._isLastVirtualpage){
				if(nextDataCount > pageResultCount){
					var skipValue = (currentPage - 1) * this.model.pageSettings.pageSize, takeValue = this.model.pageSettings.pageSize * 2;	
					this._isInitNextPage = true;					
				}
				else if(prevDataCount < pageResultCount - this.model.pageSettings.pageSize  || this._isLastVirtualpage){
					var skipValue = (currentPage - 2) * this.model.pageSettings.pageSize, takeValue = this.model.pageSettings.pageSize * 2;
					this._isInitNextPage = false; this._remoteRefresh = true;					
				}
				if(this.model.virtualLoading && this._isLocalData){
					var args = {};					
					args.endIndex = skipValue + takeValue;
					args.endIndex = args.endIndex > this._getVirtualTotalRecord() ? this._getVirtualTotalRecord() : args.endIndex;
					args.startIndex = skipValue;	
					args.currentPage = this._currentPage();
					args.result = null;
					this._trigger("virtualLoading", args);
					var currentData = args.result;
					this._setInitialCurrentIndexRecords(currentData, currentPage);
				}
				else {
				    var skipQuery = ej.pvt.filterQueries(queryManagar.queries, "onSkip");
				    if (skipQuery.length)
				        queryManagar.queries.splice($.inArray(skipQuery[0], queryManagar.queries), 1);
					queryManagar.skip(skipValue).take(takeValue);					
					if(this._isLocalData){
						var result = this._dataManager.executeLocal(queryManagar);                                    
						var currentData = this.model.currentViewData = result.result;
						this._isLastVirtualpage = false;
						this._setInitialCurrentIndexRecords(currentData, currentPage);						
					}
				}
			}			
			else{
				this._needVPaging = false;
				if(this.model.virtualLoading && this._isLocalData && (this.model.currentIndex != 0 || currentPage != 1))
					this._getVirtualOnLoadingData(currentPage, true);
				else
					this._setVirtualPaging(queryManagar, currentPage, true);						
			}
		},
		_setInitialCurrentIndexRecords: function(currentData, currentPage){
			for(i = 0; i < 2; i++){
				var start = i * this.model.pageSettings.pageSize, end = start + this.model.pageSettings.pageSize;
				var data = currentData.slice(start, end), page;
				if (this._isInitNextPage || (currentPage == 1 && this.model.pageSettings.totalPages == 1))
					page = i == 0 ? currentPage : currentPage + 1;
				else
					page = i == 0 ? currentPage - 1 : currentPage;
				this._setVirtualLoadedRecords(data, page);
			}
		},
        _getVirtualOnLoadingData: function(currentPage, isCurrentIndex){
            if(currentPage > 0){
				if(this.model.currentIndex > this._virtualRowCount && (!isCurrentIndex || this._needVPaging) && this.model.currentIndex < this.model.pageSettings.totalRecordsCount)
					this._initCurrentIndex(undefined, currentPage);
				else{
					var args = {};
					args.endIndex = (currentPage * this.model.pageSettings.pageSize) > this._gridRecordsCount ? this._gridRecordsCount : currentPage * this.model.pageSettings.pageSize;
					args.startIndex = (currentPage * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
					args.currentPage = this._currentPage();	args.result = null;			
					this._trigger("virtualLoading", args);
					var currentData = args.result;
					this._setVirtualLoadedRecords(currentData, currentPage);
				}
            }
        },
        _setVirtualLoadedRecords: function(currentData, currentPage){
            var virtualRowCount = this._virtualRowCount, pageSize = this.model.pageSettings.pageSize; 
            var pageIndex = pageSize / virtualRowCount, prevIndex;  
			var maxIndex = Math.ceil(currentPage * pageSize / virtualRowCount);
			var lastPage = currentPage == this.model.pageSettings.totalPages;
			if(!this._virtualPageRecords[currentPage])
				this._virtualPageRecords[currentPage] = currentData;
			if(lastPage){									
			    var lastPageData = this._getVirtualTotalRecord() % pageSize;
				if((!this._virtualLoadedRecords[this._totalVirtualViews] || this._virtualLoadedRecords[this._totalVirtualViews].length != this._lastViewData) && lastPageData < this._lastViewData && lastPageData != 0)
					maxIndex = this._totalVirtualViews + 1;
				else
					maxIndex = this._totalVirtualViews;	
				if(this._getVirtualTotalRecord() < virtualRowCount)
					this._singleView = true;
			}						
            for (var i = 0; i < pageIndex; i++) {
                var startIndex, endIndex;                                                      
                var viewIndex = Math.ceil((currentPage - 1) * pageIndex + (i + 1));				
                if((viewIndex <= this._totalVirtualViews || lastPage) && viewIndex <= maxIndex){					
                    if(this._virtualLoadedRecords[viewIndex - 1] && this._virtualLoadedRecords[viewIndex - 1].length != virtualRowCount) {
                        var start = this._virtualLoadedRecords[viewIndex - 1].length + (i * virtualRowCount);
                        startIndex = virtualRowCount - start + (i * virtualRowCount);
                        $.merge(this._virtualLoadedRecords[viewIndex - 1], currentData.slice(0, startIndex));
                        prevIndex = endIndex = startIndex + virtualRowCount;
						if(viewIndex <= this._totalVirtualViews)
							this._virtualLoadedRecords[viewIndex] = currentData.slice(startIndex, prevIndex);						
                    }									
                    else {
                        if (viewIndex != 1 && !this._virtualLoadedRecords[viewIndex - 1]) {                                        
                            var prevEnd = endIndex = (viewIndex - 1) * virtualRowCount % pageSize;
                            if(prevEnd != 0)
                                this._virtualLoadedRecords[viewIndex - 1] = currentData.slice(0, prevEnd);
                            startIndex = prevEnd, endIndex = prevIndex = prevEnd + virtualRowCount;
                        }
                        else {
                            startIndex = prevIndex ? prevIndex : i * virtualRowCount % pageSize;       
                            prevIndex = endIndex = startIndex + virtualRowCount;
                        }                                   
                    }                    
					if(!this._singleView && this._virtualLoadedRecords[viewIndex] && this._virtualLoadedRecords[viewIndex].length != virtualRowCount){
						var	data = currentData.slice(startIndex, endIndex);						
						if(data.length + this._virtualLoadedRecords[viewIndex].length <= virtualRowCount){
							var viewData = $.merge(data, this._virtualLoadedRecords[viewIndex]); 
							this._virtualLoadedRecords[viewIndex] = viewData;
						}
					}
					else if(!this._virtualLoadedRecords[viewIndex] && viewIndex <= this._totalVirtualViews)
						this._virtualLoadedRecords[viewIndex] = currentData.slice(startIndex, endIndex);					
                }
            }
			if($.inArray(currentPage, this._virtualLoadedPages) == -1)
				this._virtualLoadedPages.push(currentPage);
        },
        _setVirtualLoadedIndexes: function (currentIndex) {
            this._prevLoadedIndexes = this._currentLoadedIndexes;
			this._currentLoadedIndexes = [];            
            var virtualCount = currentIndex == this._totalVirtualViews ? currentIndex : currentIndex + 1;			
            if(currentIndex != 1)                               
                currentIndex = currentIndex - 1;            
            for (var i = currentIndex; i <= virtualCount; i++) {
                this._currentLoadedIndexes.push(i);                    
            }  
        },
        _getVirtualTotalRecord: function(){
            var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;    
            return recordCount;
        },
        _initGridRender: function () {
            this.addInitTemplate();
            if (this.model.scrollSettings.frozenColumns > 0)
                this.addFrozenTemplate();
            this.model.allowGrouping && this.addGroupingTemplate();
            this.model.showSummary && this.addSummaryTemplate();
            if (this.model.allowResizing || this.model.allowResizeToFit)
                this._resizer = new ej.gridFeatures.gridResize(this);
            if (this.model.keySettings)
                $.extend(this.model.keyConfigs, this.model.keySettings);
            
            this._initHeight = this.model.scrollSettings.height;
            if (this.model.scrollSettings.height == "100%")
                this._isHeightResponsive = true;
            this.render();
            this._setTextWrap();
            if (this.model.columnLayout == "fixed") {
                var headerTableWidth = this.model.scrollSettings.frozenColumns > 0 ? this.getHeaderTable().eq(0).width() + this.getHeaderTable().eq(1).width() : this.getHeaderTable().width();
                var operation = this.getHeaderContent().width() > headerTableWidth ? 'addClass' : 'removeClass';
                var headerTable = this.getHeaderTable();
                var contentTable = this.getContentTable();
                if (this.model.scrollSettings.frozenColumns > 0) {
                    headerTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getHeaderTable().eq(1) : this.getHeaderTable().eq(0);
                    contentTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getContentTable().eq(1) : this.getContentTable().eq(0);
                }
                headerTable[operation]('e-tableLastCell');
                contentTable[operation]('e-tableLastCell');
            }
            if (this.model.allowGrouping && ej.gridFeatures.dragAndDrop)
                this._headerCellgDragDrop();
            if (this.model.allowReordering && ej.gridFeatures.dragAndDrop) {
                this._headerCellreorderDragDrop();
                this._initIndicators();
            }
            this._wireEvents();
            if (this.model.allowGrouping && !ej.isNullOrUndefined(this.model.serverProperties)) {
                this.model._groupingCollapsed = this.model.serverProperties._groupingCollapsed;
                for (var i = 0; i < this.model._groupingCollapsed.length; i++) {
                    var content = this.getContent().find(".e-recordplusexpand");
                    var tr = content.filter("td[ej-mappingname='" + this.model._groupingCollapsed[i].key + "'    ][ej-mappingvalue='" + this.model._groupingCollapsed[i].value + "']");
                    if (tr.length > 1 && !ej.isNullOrUndefined(this.model._groupingCollapsed[i].parent)) {
                        var parent = this.model._groupingCollapsed[i].parent;
                        tr = tr.filter(function (e) { return $(this).parents(".e-tabletd").parent("tr").prev("tr").find(".e-recordplusexpand[ej-mappingvalue=" + parent + "]").length })
                    }

                    this.expandCollapse(tr);
                }
            }
            this.initialRender = false;
            if (this.model.width && !this.model.allowScrolling)
                this.element.width(this.model.width);
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding)
                this._processEditing();
            if (this.model.mergeHeaderCellInfo != null) {               
                var args = { columnHeaders: this.getHeaderContent().find(".e-columnheader"), model: this.model }, proxy = this;
                this._headerCellMerge(args);
                this._trigger("mergeHeaderCellInfo", args);
            }
            this._trigger("dataBound", {});
			this._trigger("refresh");
            if (this.model.parentDetails) {  //refreshes parent scroller on child expand
                var id = this.model.parentDetails.parentID, parentObj = $("#" + id).data("ejGrid");
                parentObj.model.allowScrolling && parentObj._refreshScroller({ requestType: "refresh" });
            }
            if (this.element.closest('tr').hasClass('e-detailrow') && !this.model.parentDetails) {
                var parentObj = this.element.closest('tr.e-detailrow').closest('.e-grid').data("ejGrid");
                parentObj.model.allowScrolling && parentObj.getScrollObject().refresh();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "menu") {
                this._renderFilterDialogs();
            }
            if (this.model.enableResponsiveRow && (this.model.allowSorting || this.model.allowFiltering)) {
                this._renderResponsiveFilter();
            }
            if (this.model.allowGrouping && this.model.showSummary) {
                this._refreshGroupSummary();
                if (!ej.isNullOrUndefined(this.model.currentViewData) && this.model.currentViewData.length)
                    this._refreshGridFooterColGroup();
            }   
            if (this._isMapSelection)
                this._mappingSelection();
			if (this.model.showColumnChooser)
			    this._renderColumnChooser();
			if (this._enableCheckSelect) {
			    			    if (this.model.currentViewData != null && this.model.currentViewData.length == 0)
                			        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").hide();
			    			    else
                			        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").show();
			    			}
        },
        _setTextWrap: function () {
            if (this.model.allowTextWrap == true) {
                switch (this.model.textWrapSettings.wrapMode) {
                    case "content":
                        this.element.find(".e-columnheader").removeClass("e-wrap");
                        this.element.removeClass("e-wrap");
                        this.getContent().addClass("e-wrap");
                        break;
                    case "header":
                        this.element.removeClass("e-wrap");
                        this.getContent().removeClass("e-wrap");
                        this.element.find(".e-columnheader").addClass("e-wrap");
                        break;
                    default:
                        this.getContent().removeClass("e-wrap");
                        this.element.find(".e-columnheader").removeClass("e-wrap");
                        this.element.addClass("e-wrap");
                        break;
                }
                if(this.model.scrollSettings.frozenColumns > 0 && this.model.textWrapSettings.wrapMode != "content"){
                    var $frozenTh = this.getHeaderContent().find(".e-frozenheaderdiv").find(".e-columnheader").last().find("th"), $movableTh = this.getHeaderContent().find(".e-movableheader").find(".e-columnheader").last().find("th");
                    $frozenTh.height()> $movableTh.height() ? $movableTh.height($frozenTh.height()) : $frozenTh.height($movableTh.height());
                }
            }
            else {
                this.getContent().removeClass("e-wrap").find(".e-rowcell").removeClass("e-nwrap");
                this.element.find(".e-columnheader").removeClass("e-wrap").find(".e-headercelldiv").removeClass("e-nwrap");
                this.element.removeClass("e-wrap");
            }
        },
        _getMetaColGroup: function () {
            var $colgroup = ej.buildTag("colgroup");
            for (var i = 0; i < this.model.columns.length; i++) {
                var $col = $(document.createElement("col"));
                this.model.columns[i]["visible"] === false && $col.css("display", "none");
				if(this.model.rowTemplate!=null && !ej.isNullOrUndefined(this.model.columns[i]["cssClass"]))
					$col.addClass(this.model.columns[i]["cssClass"]);
                if ( this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && $.inArray(this.model.columns[i]["field"], this.model.groupSettings.groupedColumns) != -1)
                    $col.css("display", "none");
                $colgroup.append($col);
            }
            return $colgroup;
        },
        _alternateRow: function () {
            return this.getIndex() % 2 == 0 ? "e-row" : "e-alt_row";
        },
        addInitTemplate: function () {
            var headerCellDiv = this.element.find(".e-headercelldiv:not(.e-emptyCell)"), templates = {}, firstVisible = true;
            var tbody = document.createElement('tbody'), $tbody = $(tbody),divElement;
            if (this.model.rowTemplate == null) {
                var tr = document.createElement('tr'),
                    $tr = $(tr),
                    columns = this.model.columns,
                    i;
                if (this._gridRecordsCount && !this._virtualDataRefresh) {
                    var currentData = this.model.editSettings.showAddNewRow && !this.initialRender ? this.model.currentViewData[1] : this.model.currentViewData[0];
                    if (!ej.isNullOrUndefined(currentData))
                        this._initColumns(currentData);
                }
                else if (this._isLocalData && (this._dataSource() != null && this._dataSource().length || (this._dataManager && this._dataManager.dataSource.json.length)))
                    this._initColumns(this._dataSource()[0] != undefined ? this._dataSource()[0] : this._dataManager.dataSource.json[0]);
                var helpers = { _gridFormatting: this.formatting, getComplexData: ej.getObject };
                $.views.helpers(helpers);

                var viewHelper = {};
                viewHelper["_foreignKey"] = this._foreignKeyBinding; 
                $.views.helpers(viewHelper);

                if (this.model.childGrid || this.model.detailsTemplate ) {
                    var $tdDetailCell = ej.buildTag("td.e-detailrowcollapse", "<div class='e-icon e-gnextforward'></div>");
                    $tr.append($tdDetailCell);
                }
                for (var i = 0; i < this.model.columns.length; i++) {
                    var $tdCell = ej.buildTag("td.e-rowcell");
                    if (!ej.isNullOrUndefined(columns[i]["tooltip"]) || columns[i]["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip)
                        $tdCell.addClass("e-gridtooltip")
                    if (columns[i]["clipMode"] == ej.Grid.ClipMode.Ellipsis || columns[i]["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip)
                        $tdCell.addClass("e-gridellipsis");
                    if (this.model.isResponsive)
                        $tdCell.attr("data-cell", this._decode(this.model.columns[i]["headerText"]));
                    if (columns[i]["visible"] == false)
                        $tdCell.addClass("e-hide");
                    else {
                        if (firstVisible && (this.model.detailsTemplate != null || this.model.childGrid != null))
                            $tdCell.addClass('e-detailrowvisible');
                        firstVisible = false;
                    }
                    !this.model.groupSettings.showGroupedColumn && $tdCell.addClass("{{for ~groupedColumns}}" +
                        " {{if #data == '" + this.model.columns[i]["field"] + "'}}e-hide{{/if}}" +
                        "{{/for}}");
                    if (!ej.isNullOrUndefined(columns[i]["templateID"] || columns[i]["template"])) {
                        var viewHelper = {}, index, htxt = columns[i].headerText;
                        viewHelper["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this, index);
                        $.views.helpers(viewHelper);
                        if(!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                            htxt = htxt.replace(/[^0-9\s\w]/g,"_");
                        $("#" + this._id + htxt + i + "_Template").remove();
                        var scriptElement = this._createTemplateElement(columns[i]);
                        if ((columns[i].field == "") || ej.isNullOrUndefined(columns[i].field))
                            this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                        if (columns[i]["template"] != false)
                            $tdCell.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "','" + i + "')}}");
                    } else {
                        var splits = (columns[i].field || "").split("."), sLen = splits.length - 1, braces = "";
                        while (sLen) {
                            braces += "(";
                            sLen--;
                        }
                        var columnType = columns[i].type || columns[i].editType
                        switch (columnType) {
                            case "boolean":
                            case "booleanedit":
                                if (ej.isNullOrUndefined(columns[i].displayAsCheckbox)) columns[i].displayAsCheckbox = true;
                                if (!columns[i]["displayAsCheckbox"])
                                    $tdCell.html("{{if ~getComplexData('"+this.model.columns[i].field+"', #data)}}" + this.localizedLabels.True + '{{else}}' + this.localizedLabels.False + '{{/if}}');
                                else {
                                    var disabled = "";
                                    this.model.editSettings.editMode == "batch" && (ej.isNullOrUndefined(columns[i].allowEditing) || columns[i].allowEditing) ? disabled = disabled : disabled = "disabled='disabled'";
                                    var str = "{{if ~getComplexData('" + this.model.columns[i].field + "', #data)}} <input type ='checkbox' " + disabled + " checked='checked'></input>{{else}} <input type ='checkbox' " + disabled + "></input> {{/if}}";
                                    $tdCell.addClass("e-boolrowcell").html(str);
                                }
                                break;
                            case "checkbox":
                                this._enableCheckSelect = true;
                                this.model.selectionType = "multiple";
                                if(this.model.editSettings.allowDeleting) this.multiDeleteMode = true;
                                this.model.selectionSettings.enableToggle = true;
                                this._isMapSelection = (!ej.isNullOrUndefined(columns[i].field) && (columns[i].field != ""));
                                this._selectionMapColumn = columns[i].field;
                                columns[i]["textAlign"] = "center";
                                if (!this._isMapSelection)
                                    this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                                $tdCell.addClass("e-checkcell").html("<div class = 'e-checkcelldiv'>{{if #data['" + splits.join("']['") + "']}} <input type ='checkbox' checked='checked'></input>{{else}} <input type ='checkbox'></input> {{/if}}</div>");
                                this.model.columns[i].editType = ej.Grid.EditingType.Boolean;
                                this.model.scrollSettings.frozenColumns > 0 && $tdCell.addClass("e-frozenunbound");
                                this.model.enableAutoSaveOnSelectionChange = false;
                                break;
                            default:
                                if (columns[i].disableHtmlEncode)
                                    $tdCell.html("{{html:" + braces + "#data['" + splits.join("'] || {})['") + "']}}");
                                else
                                    $tdCell.html("{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}");
                        }
                        if (columns[i]["format"] != undefined && (!columns[i]["foreignKeyValue"]))
                            $tdCell.html("{{:~_gridFormatting('" + columns[i]["format"] + "'," + braces + "#data['" + splits.join("'] || {})['") + "'],'" + this.model.locale + "')}}");
                        if (columns[i]["foreignKeyValue"] && columns[i]["dataSource"]) {
                            $tdCell.html("{{:~_foreignKey(" + i + "," + braces + "#data['" + splits.join("'] || {})['") + "'],'" + this._id + "')}}");
                        }
                        if (columns[i]["commands"]) {
                            var viewHelper = {};
                            viewHelper["_" + this._id + "UnboundTemplate"] = this._unboundTemplateRendering;
                            $.views.helpers(viewHelper);
                            if ((ej.isNullOrUndefined(columns[i]["field"])) || (columns[i].field == ""))
                                this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                            if (!ej.isNullOrUndefined(columns[i].headerText))
                            $("#" + this._id + columns[i].headerText.replace(/[^a-z0-9|s_]/gi, '')+ i + "_UnboundTemplate").remove();
                            divElement = this._createUnboundElement(columns[i],i);
                            if (!ej.isNullOrUndefined(columns[i].headerText))
                            $tdCell.addClass("e-unboundcell").addClass("e-" + columns[i]["headerText"].replace(/[^a-z0-9|s_]/gi, '')+i).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                            this.model.scrollSettings.frozenColumns > 0 && $tdCell.addClass("e-frozenunbound");
                            this._isUnboundColumn = true;
                        }

                    }
                    if (columns[i]["textAlign"] == undefined)
                        columns[i]["textAlign"] = "left";
                    if (columns[i]["isPrimaryKey"] === true) {
                        this._primaryKeys.push($.trim(columns[i].field));
                        this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                    }
                    if (!(this.phoneMode && this.model.enableResponsiveRow) && columns[i]["textAlign"] != undefined) {
                        $tdCell.css("text-align", columns[i]["textAlign"]);
                        $(headerCellDiv[i]).css("text-align", columns[i]["textAlign"]);
                    }
                    if (!this.phoneMode && !ej.isNullOrUndefined(columns[i]["headerTextAlign"])) {
                        $(headerCellDiv[i]).css("text-align", columns[i]["headerTextAlign"]);
                    }
                    if (!ej.isNullOrUndefined(columns[i]["cssClass"])) {
                        $tdCell.addClass(columns[i]["cssClass"]);
                    }
                    if (this.model.allowTextWrap && this.model.textWrapSettings.wrapMode != "header") {
                         if (columns[i]["allowTextWrap"] == false)
                            $tdCell.addClass("e-nwrap");
                    }
                    if (!ej.isNullOrUndefined(columns[i]["priority"]))
                        $tdCell.addClass("e-table-priority-" + columns[i]["priority"]);
                    if (!ej.isNullOrUndefined(columns[i]["customAttributes"]))
                        $tdCell.attr(columns[i]["customAttributes"]);
                    $tdCell.attr("role", "gridcell");
                    $tr.append($tdCell);
                    if (this.model.enableAltRow) {
                        helpers["_" + this._id + "AlternateRow"] = this._alternateRow;
                        $.views.helpers(helpers);
                        $tr.addClass("{{:~_" + this._id + "AlternateRow()}}");
                    }
                    else
                        $tr.addClass("e-row");
                    $tr.attr("role", "row");
                    if (this.model.scrollSettings.frozenColumns > 0 && this.model.scrollSettings.frozenColumns == i + 1) {
                        tbody.appendChild(tr);
                        templates[this._id + "_JSONFrozenTemplate"] = $tbody.html();
                        $tr.empty();
                        $tbody.empty();
                    }
                }
                tbody.appendChild(tr);
            }
            templates[this._id + "_JSONTemplate"] = this.model.rowTemplate != null ? $(this.model.rowTemplate).html() : $tbody.html();
            $.templates(templates);
        },
        
        
        render: function () {
            this.model.showSummary = this.model.summaryRows.length > 0 || this.model.showSummary;
            this._renderGridContent().insertAfter(this.element.children(".e-gridheader"));
            this.model.allowResizeToFit && this.setWidthToColumns();
            if (this.model.allowGrouping && ej.gridFeatures.dragAndDrop)
                this._groupHeaderCelldrag();
            if (this.model.showSummary && this._currentJsonData.length) {
                this._renderGridFooter().insertAfter(this.getContent());
                this._hideCaptionSummaryColumn();
            }
            this._initialEndRendering();

        },
        _createStackedRow: function (stackedHeaderRow, frozenHeader) {
            var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow');
            var sHeader = [], sCss = [], tAl = [], tp = [];
            for (var c = 0; c < this.model.columns.length; c++) {
                var column = this.model.columns[c];
                if (column.visible != false) {
                    if (this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && this.model.groupSettings.groupedColumns.length > 0) {
                        if ($.inArray(column.field, this.model.groupSettings.groupedColumns) != -1)
                            continue;
                    }
                    var headerText = '', cssClass = '', txtAlign = '', ttp = "";
                    var sColumn = stackedHeaderRow.stackedHeaderColumns;
                    for (var col = 0; col < sColumn.length; col++) {
                        var _column = $.isArray(sColumn[col].column) ? sColumn[col].column : $.map(sColumn[col].column.split(","), $.trim),
                            className = "e-row" + $.inArray(stackedHeaderRow, this.model.stackedHeaderRows) + "-column" + col;
                        if ($.inArray(column.field, _column) != -1)
                        {
                            headerText = sColumn[col].headerText;
                            cssClass = sColumn[col]["cssClass"];
                            txtAlign = sColumn[col].textAlign;
                            ttp = sColumn[col]["tooltip"] ? " e-gridtooltip " + className : '';
                        }                        
                    }
                    sHeader.push(headerText);
                    sCss.push(cssClass);
                    tAl.push(txtAlign);
                    tp.push(ttp);
                }
            }
            var colsPanList = []
            for (var i = 0; i < sHeader.length; i++) {
                var colSpan = 1;
                for (var j = i + 1; j < sHeader.length; j++) {
                    if (sHeader[i] == sHeader[j]) {
                        colSpan++;
                    }
                    else
                        break;
                }
                colsPanList.push({ sapnCount: colSpan, headerText: sHeader[i], cssClass: sCss[i], txtAlign: tAl[i], tooltip: tp[i] });
                i += colSpan - 1;
            }
            var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow');
            var frzCol = this.model.scrollSettings.frozenColumns;
            if (this.model.allowScrolling && frzCol > 0) {
                var frozenColspanList = [];
                var forzenColumn = 0, index = 0, frzHideCol = 0;
                for (var i = 0; i < this.model.columns.length; i++) {
                    var col = this.model.columns[i];
                    if (i < frzCol && col.visible == false)
                        frzHideCol++;
                }
                forzenColumn = frzCol - frzHideCol;
                while (forzenColumn > 0) {
                    var spanC = colsPanList[index].sapnCount;
                    if (colsPanList[index].sapnCount < forzenColumn) {
                        frozenColspanList.push(colsPanList[index])
                        if (!frozenHeader)
                            colsPanList.splice(index, 1);
                        else
                            index++;
                    }
                    else if (colsPanList[index].sapnCount > forzenColumn) {
                        colsPanList[index].sapnCount = colsPanList[index].sapnCount - forzenColumn
                        if (frozenHeader)
                            frozenColspanList.push({ sapnCount: forzenColumn, headerText: colsPanList[index].headerText });
                    }
                    else {
                        frozenColspanList.push(colsPanList[index])
                        if (!frozenHeader)
                            colsPanList.splice(index, 1);
                    }
                    forzenColumn -= spanC;
                }
                if (frozenHeader)
                    colsPanList = frozenColspanList
            }
            if (this.model.detailsTemplate || this.model.childGrid)
                $tr.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div></div>'));
            for (var c = 0; c < colsPanList.length; c++) {
                var $th = ej.buildTag('th.e-headercell e-stackedHeaderCell e-default' + colsPanList[c].tooltip, colsPanList[c].headerText, {}, { 'colspan': colsPanList[c].sapnCount });
                $th.css("textAlign", colsPanList[c].txtAlign);
                $tr.append($th);
                if (colsPanList[c]["cssClass"] != undefined)
                    $th.addClass(colsPanList[c]["cssClass"]);
				if(this.model.allowResizing || this.model.allowReordering || this.model.allowResizeToFit)
                    $th.addClass("e-resizer");
            }
            return $tr;
        },
        _renderGridHeaderInternalDesign: function (columns, frozenHeader) {
            var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: "0.25px", role: "grid" });
            var $thead = ej.buildTag('thead');
            var $tbody = ej.buildTag('tbody.e-hide');
            var $columnHeader = ej.buildTag('tr.e-columnheader');
            var $colGroup = $(document.createElement('colgroup'));
            var $rowBody = $(document.createElement('tr'));
            if (this.model.childGrid || this.model.detailsTemplate ) {
                $columnHeader.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div></div>'));
                $colGroup.append(this._getIndentCol());
            }
            if (this.model.showStackedHeader) {
                for (var index = 0; index < this.model.stackedHeaderRows.length; index++) {
                    var $tr = this._createStackedRow(this.model.stackedHeaderRows[index], frozenHeader);
                    $thead.append($tr);
                }
            }
            for (var columnCount = 0; columnCount < columns.length; columnCount++) {
                var $headerCell = ej.buildTag('th.e-headercell e-default', "", {}, { role: "columnheader" });
                var bodyCell = document.createElement('td');
                var $headerCellDiv = ej.buildTag('div.e-headercelldiv', (columns[columnCount]["headerText"] === undefined && columns[columnCount]["type"] != "checkbox") ? columns[columnCount]["headerText"] = columns[columnCount]["field"] : columns[columnCount]["headerText"], {}, { "ej-mappingname": columns[columnCount]["field"] });
                if (columns[columnCount].disableHtmlEncode)
                    $headerCellDiv.text(columns[columnCount]["headerText"]);
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTooltip"]))
                    $headerCellDiv.addClass("e-gridheadertooltip");
                if (!ej.isNullOrUndefined(columns[columnCount]["tooltip"]))
                    $headerCellDiv.addClass("e-gridtooltip");
                if (columns[columnCount]["clipMode"] == ej.Grid.ClipMode.Ellipsis || columns[columnCount]["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip)
                    $headerCellDiv.addClass("e-gridellipsis");
                if(this.model.allowResizing || this.model.allowReordering || this.model.allowResizeToFit)
                        $headerCell.addClass("e-resizer");               
			   $headerCell.append($headerCellDiv);
                if (this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel") &&
                                (columns[columnCount]["allowFiltering"] == undefined || columns[columnCount]["allowFiltering"] === true) && (!ej.isNullOrUndefined(columns[columnCount].field) || columns[columnCount].field == "") && (columns[columnCount]["type"] != "checkbox")) {
                        var filtericon = 'e-filterset';
                    if (!this.initialRender && this.model.filterSettings.filteredColumns) {
                        for (var i = 0; i < this.model.filterSettings.filteredColumns.length; i++) {
                            if (this.model.filterSettings.filteredColumns[i].field == columns[columnCount].field) {
                                filtericon = 'e-filterset e-filteredicon e-filternone';
                            }
                        }
                    }
                    $headerCell.append(ej.buildTag('div.e-filtericon e-icon ' + filtericon));
                    $headerCell.addClass("e-headercellfilter");
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0" && this.model.enableRTL)
                        $($headerCellDiv).css("padding", "0 0 0 2em");
                }
                var col = document.createElement('col');
                if (columns[columnCount]["priority"])
                    $(bodyCell).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                $rowBody.append(bodyCell);
                $columnHeader.append($headerCell);
                $colGroup.append(col);
                if (columns[columnCount]["visible"] === false) {
                    $headerCell.addClass("e-hide") && $(col).css("display", "none")
                    if ($.inArray(columns[columnCount].headerText, this._hiddenColumns) == -1 && $.inArray(columns[columnCount].field, this._hiddenColumnsField) == -1)
                        this._hiddenColumns.push(columns[columnCount].headerText) && columns[columnCount].field != ("" || undefined) ? this._hiddenColumnsField.push(columns[columnCount].field) : this._hiddenColumnsField.push(columns[columnCount].headerText);
                    if ($.inArray(columns[columnCount].field, this._visibleColumnsField) != -1)
                        this._visibleColumnsField.splice($.inArray(columns[columnCount].field, this._visibleColumnsField), 1) && this._visibleColumns.splice($.inArray(columns[columnCount].headerText, this._visibleColumns), 1)
                }
                else {
                    this._visibleColumns.push(columns[columnCount].headerText) && columns[columnCount].field != ("" || undefined) ? this._visibleColumnsField.push(columns[columnCount].field) : this._visibleColumnsField.push(columns[columnCount].headerText);
                    columns[columnCount]["visible"] = true;
                    if ($.inArray(columns[columnCount].field == "" ? columns[columnCount].headerText : columns[columnCount].field, this._hiddenColumnsField) != -1)
                        this._hiddenColumnsField.splice($.inArray(columns[columnCount].field == "" ? columns[columnCount].headerText : columns[columnCount].field, this._hiddenColumnsField), 1) && this._hiddenColumns.splice($.inArray(columns[columnCount].headerText, this._hiddenColumns), 1)
                }
                if (this.model.showColumnChooser && columns[columnCount]["showInColumnChooser"] !== false)
                    columns[columnCount]["showInColumnChooser"] = true;
                if (this.model.allowResizing && columns[columnCount]["allowResizing"] !== false)
                    columns[columnCount]["allowResizing"] = true;
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTextAlign"]))
                    $headerCellDiv.css("text-align", columns[columnCount]["headerTextAlign"]);
                else if (columns[columnCount]["textAlign"] != undefined)
                    $headerCellDiv.css("text-align", columns[columnCount]["textAlign"]);
				else if (this.model.enableRTL)
					$headerCellDiv.css("text-align",columns[columnCount]["textAlign"] = "right");
                columns[columnCount]["allowResizing"] === false && this._disabledResizingColumns.push(columns[columnCount].field);
                columns[columnCount]["allowSorting"] === false && this._disabledSortableColumns.push(columns[columnCount].field);
                columns[columnCount]["allowGrouping"] === false && this._disabledGroupableColumns.push(columns[columnCount].field);
                columns[columnCount]["allowEditing"] === false && this._disabledEditableColumns.push(columns[columnCount].field);
                if (!ej.isNullOrUndefined(columns[columnCount]["cssClass"])) {
                    $headerCell.addClass(columns[columnCount]["cssClass"]);
                    $(col).addClass(columns[columnCount]["cssClass"]);
                }
                if ( this.model.allowTextWrap && this.model.textWrapSettings.wrapMode != "content") {
                     if (columns[columnCount]["allowTextWrap"] == false)
                        $headerCellDiv.addClass("e-nwrap");
                }
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTemplateID"])) {
                    $headerCellDiv.html($(columns[columnCount]["headerTemplateID"]).hide().html()).parent().addClass("e-headertemplate");
                    var index = $.inArray(columns[columnCount].field, this._disabledGroupableColumns);
                    index == -1 && ej.isNullOrUndefined(columns[columnCount].field) && this._disabledGroupableColumns.push(columns[columnCount].field);
                }
                if (ej.getObject("type", columns[columnCount]) == "checkbox" && ej.isNullOrUndefined(columns[columnCount]["headerText"])) {
                    $headerCellDiv.addClass("e-headercheckcelldiv");
                    $headerCellDiv.html("<input type = 'checkbox' class = 'e-checkselectall'></input>");
                    if (!ej.isNullOrUndefined(columns[columnCount].field))
                        $headerCellDiv.attr("ej-mappingname", columns[columnCount].field);
                }
                if (this.model.allowGrouping && this.model.groupSettings.showToggleButton && $.inArray(columns[columnCount].field, this._disabledGroupableColumns) == -1 && !ej.isNullOrUndefined(columns[columnCount].field) && columns[columnCount].field != "") {
                    if ($.inArray(columns[columnCount].field, this.model.groupSettings.groupedColumns) != -1)
                        $headerCellDiv.append(this._getToggleButton().addClass("e-toggleungroup"));
                    else
                        $headerCellDiv.append(this._getToggleButton().addClass("e-togglegroup"));
                }
                if (this.model.isResponsive)
                    $headerCell.attr("title", this._decode(columns[columnCount].headerText));
                if (columns[columnCount]["priority"]) {
                    $headerCell.attr("data-priority", columns[columnCount]["priority"]).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                    $(col).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                }
                if (this.initialRender) {
                    var cCount = columnCount, frozenCols = this.model.scrollSettings.frozenColumns;
                    cCount = !frozenHeader ? frozenCols > 0 ? cCount + frozenCols : cCount : cCount;
                    this._columnsPixelConvert(columns[columnCount], cCount);
                }
                if (columns[columnCount]["width"] == undefined && this.model.commonWidth !== undefined)
                    this.columnsWidthCollection[columnCount] = this.model.commonWidth;
                this._fieldColumnNames[columns[columnCount].headerText] = columns[columnCount].field;
                this._headerColumnNames[columns[columnCount].field] = columns[columnCount].headerText;                
            }
            $thead.append($columnHeader);
            $tbody.append($rowBody);
            $table.append($colGroup).append($thead).append($tbody);
            return $table;
        },
        _columnsPixelConvert: function (column, columnIndex) {
            var colIndex;
            var elementWidth = this.model.scrollSettings.width > 0 ? this.model.scrollSettings.width : this.element.width();
            var cols = ej.isNullOrUndefined(column) ? this.model.columns : $.makeArray(column);
            for (var columnCount = 0; columnCount < cols.length; columnCount++) {
                colIndex = columnIndex || columnCount;
                if (typeof (cols[columnCount].width) == "string" && cols[columnCount].width.indexOf("%") != -1 && (this.model.allowScrolling || (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length)))
                    this.columnsWidthCollection[colIndex] = (parseInt(cols[columnCount]["width"]) / 100 * elementWidth);
                else
                    this.columnsWidthCollection[colIndex] = (cols[columnCount]["width"]);
            }
        },
        _renderGridHeader: function () {
            var $div = ej.buildTag('div.e-gridheader'), temp, $frozenDiv, $movableDiv;
            var $innerDiv = ej.buildTag('div');
            if (this.model.allowScrolling)
                $innerDiv.addClass("e-headercontent");
            this.setGridHeaderContent($div);
            if (this.initialRender) {
                this.columnsWidthCollection = [];
                this._hiddenColumns = [];
                this._hiddenColumnsField = [];
            }
            this._visibleColumns = [];
            this._visibleColumnsField = [];
            this._disabledGroupableColumns = [];
            this._fieldColumnNames = {};
            this._headerColumnNames = {};
            if (this.model.scrollSettings.frozenColumns > 0) {
                $frozenDiv = ej.buildTag("div.e-frozenheaderdiv", this._renderGridHeaderInternalDesign(this.model.columns.slice(0, this.model.scrollSettings.frozenColumns), true));
                $movableDiv = ej.buildTag("div.e-movableheader", ej.buildTag("div.e-movableheaderdiv", this._renderGridHeaderInternalDesign(this.model.columns.slice(this.model.scrollSettings.frozenColumns), false)));
                $innerDiv.append($frozenDiv).append($movableDiv);
            } else
                $innerDiv.append(this._renderGridHeaderInternalDesign(this.model.columns));
            $div.html($innerDiv);
            if (this.model.isResponsive)
                $div.addClass("e-textover");
            this.setGridHeaderTable(this.getHeaderContent().find(".e-table"));
            return $div;
        },
        _renderGridContent: function () {
            var $div = ej.buildTag('div.e-gridcontent');
            var $innderDiv = ej.buildTag('div');
            var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: "0.25px" });
            var $tbody = $(document.createElement('tbody'));
            $table.append(this.getHeaderTable().find('colgroup').clone()).append($tbody);
            $innderDiv.html($table);
            $div.html($innderDiv);
            this.setGridContentTable($table);
            this.setGridContent($div);
            $table.attr("role", "grid");
            var args = {};
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length) {
                if (this.initialRender) {
                    args.columnName = this.model.groupSettings.groupedColumns[this.model.groupSettings.groupedColumns.length - 1];
                    if (!this.model.groupSettings.showGroupedColumn) {
                        for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                            var col = this.model.groupSettings.groupedColumns[i];
                            if ($.inArray(col, this._hiddenColumnsField) == -1) {//updated for
                                this._hiddenColumnsField.push(col);//updated for
                                this._hiddenColumns.push(this.getColumnByField(col).headerText);
                                this.getColumnByField(col).visible = false;
                            }
                        }
                    }
                }
                args.requestType = ej.Grid.Actions.Grouping;
            } else
                args.requestType = ej.Grid.Actions.Refresh;
            if (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0) {
                var $emptyTd = ej.buildTag('td.emptyrecord', this.localizedLabels.EmptyRecord, {}, { colSpan: (this.model.columns.length - this._hiddenColumns.length)});
                $tbody.append($(document.createElement("tr")).append($emptyTd));
                this.setWidthToColumns();
                if (this.initialRender || this.model.groupSettings.groupedColumns.length)
                    this.sendDataRenderingRequest(args)
            } else
                this.sendDataRenderingRequest(args);
            if (this._isCaptionSummary && args.requestType == "grouping" && this.model.groupSettings.groupedColumns.length > 1) {
                var colgroup = this.getContentTable().find(".e-table").not(".e-recordtable").children("colgroup");
                var $cols1 = $(this.getContentTable().find(".e-recordtable")[0]).children("colgroup").find("col");
                for (var i = 0; i < colgroup.length; i++) {
                    var colCount = $(colgroup[i]).find("col").length;
                    $(colgroup[i]).find("col:gt(" + (colCount - $cols1.length - 1) + ")").remove();
                    $(colgroup[i]).append($cols1.clone());
                }
            }
            return $div;
        },
        
        print: function () {
            var args = {}; args.requestType = "print";
            this._printselectrows = this.getContentTable().find('tr[aria-selected="true"]');            
            this._trigger("actionBegin", args);

            var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no"), $printDiv = ej.buildTag("div#" + this._id), cloneGridModel = $.extend({}, this.model);            
            cloneGridModel.toolbarSettings.showToolbar = cloneGridModel.allowPaging = cloneGridModel.allowScrolling = cloneGridModel.showColumnChooser = false;
            cloneGridModel.editSettings = {};
            cloneGridModel.query.queries = [];
            if (this.model.allowPaging && this.model.pageSettings.printMode == "currentpage") {
                cloneGridModel.query.queries = [{ fn: "onPage", e:{ pageIndex: this._currentPage(), pageSize: this.model.pageSettings.pageSize }}];
                cloneGridModel.dataBound = function () {
                    this._printProcess(printWin);
                }
            }
            else {                
                cloneGridModel.dataBound = function () {
                    this._printProcess(printWin);
                }
            }
            $printDiv.ejGrid(cloneGridModel);

        },
        _printProcess: function (printWin) {
            var elementClone = this.element,  args = { requestType: "print", element: elementClone, selectedRows: this._printselectrows };
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                elementClone.find(".e-filterbar").remove();
            elementClone.show();           
            this._trigger("beforePrint", args);
            ej.print(elementClone, printWin);           
            this._trigger("actionComplete", args);
        },
        
         "export": function (action, serverEvent, multipleExport,gridIds) {
           var modelClone = $.extend(true, {}, this.model);
            var proxy = this;
            var attr = { action: action, method: 'post', "data-ajax": "false" };
            var form = ej.buildTag('form', "", null, attr);
            var locale = [];
            if (multipleExport && !ej.isOnWebForms) {
                var gridCol=$('div.e-grid');
                if (gridIds && gridIds.length > 0) {
                    gridCol = $.map(gridIds, function (i) { return document.getElementById(i) })
                }
                $.each(gridCol,function (index, object) {
                        var gridobjectArray = {};
                        var gridObject = $(object).data('ejGrid');
                        locale.push({ id: gridObject._id, locale: gridObject.model.locale });
                        if (!ej.isNullOrUndefined(gridObject)) {
                            var modelClone = $.extend(true, {}, gridObject.model);
                            modelClone = proxy._getModifyExportModel(modelClone);
                            if (gridObject.ignoreOnExport) {
                                for (var i = 0; i < gridObject.ignoreOnExport.length; i++) {
                                    delete modelClone[gridObject.ignoreOnExport[i]];
                                }
                                var inputAttr = { name: 'GridModel', type: 'hidden', value: gridObject.stringify(modelClone) }
                                var input = ej.buildTag('input', "", null, inputAttr);
                                form.append(input);
                            }
                        }
                    });
                    $('body').append(form);
                    form.submit();
            }
            else {
                this._locale = this.model.locale;
                modelClone = this._getModifyExportModel(modelClone);
                var gridob = this;
                if (this.ignoreOnExport) {
                    for (var i = 0; i < this.ignoreOnExport.length; i++) {
                        delete modelClone[this.ignoreOnExport[i]];
                    }
                }
                if (ej.raiseWebFormsServerEvents) {
                    var args = { model: modelClone, originalEventType: serverEvent };
                    var clientArgs = { model: this.stringify(modelClone) };
                    ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
                    setTimeout(function () {
                        ej.isOnWebForms = true;
                    }, 1000);
                }
                else {
                        var inputAttr = { name: 'GridModel', type: 'hidden', value: this.stringify(modelClone) }
                        var input = ej.buildTag('input', "", null, inputAttr);
                        form.append(input);
                        form.append(this);
                        $('body').append(form);
                        form.submit();
                }
            }
            setTimeout(function () {
                if (locale.length) {
                    for (var i = 0; i < locale.length; i++) {
                        var gridObject = $("#" + locale[i].id).data('ejGrid');
                        gridObject.model.locale = locale[i].locale;
                    }
                }
                if (!ej.isNullOrUndefined(proxy._locale))
                    proxy.model.locale = proxy._locale;
            }, 0);
            form.remove();
            return true;
        },
        _getModifyExportModel:function(modelClone){
            var tempObj = {}
            $.extend(tempObj, ej.Grid.Locale["en-US"], ej.Grid.Locale[modelClone.locale]);
            var temp = tempObj.GroupCaptionFormat;
            var split1 = temp.indexOf("{{if");
            var split2 = temp.indexOf(" {{else}}");
            var grpText = temp.slice(split1, split2).replace("{{if count == 1 }}", "");
            var localeProp = { EmptyRecord: tempObj.EmptyRecord, GroupCaptionFormat: temp.slice(0, split1), GroupText: grpText,True:tempObj.True,False:tempObj.False };
            if (!ej.isNullOrUndefined(this.model))
                this.model.locale = modelClone.locale.concat(JSON.stringify(localeProp));
            modelClone.locale = modelClone.locale.concat(JSON.stringify(localeProp));
            for (var i = 0; i < modelClone.columns.length; i++) {
                if (modelClone.columns[i].editType != undefined) {
                    switch (modelClone.columns[i].editType) {
                        case "stringedit":
                        case "edittemplate":
                            modelClone.columns[i].editType = "string";
                            break;
                        case "numericedit":
                            modelClone.columns[i].editType = "numeric";
                            break;
                        case "dropdownedit":
                            modelClone.columns[i].editType = "dropdown";
                            break;
                        case "booleanedit":
                            modelClone.columns[i].editType = "boolean";
                            break;
                        default:
                            break;
                    }
                }
            }
            for (var i = 0; i < modelClone.filterSettings.filteredColumns.length; i++) {
                if (modelClone.filterSettings.filteredColumns[i].operator == "equal")
                    modelClone.filterSettings.filteredColumns[i].operator = "equals";
                else if (modelClone.filterSettings.filteredColumns[i].operator == "notequal")
                    modelClone.filterSettings.filteredColumns[i].operator = "notequals";
            }
            if (modelClone.showStackedHeader) {
                modelClone.stackedHeaderRow = modelClone.stackedHeaderRows;
                for (var i = 0; i < modelClone.stackedHeaderRow.length; i++) {
                    modelClone.stackedHeaderRow[i].stackedHeaderColumn = modelClone.stackedHeaderRow[i].stackedHeaderColumns;
                    var a = modelClone.stackedHeaderRow[i].stackedHeaderColumn;
                    for (var j = 0; j < a.length; j++) {
                        modelClone.stackedHeaderRow[i].stackedHeaderColumn[j].column = $.isArray(a[j].column) ? a[j].column : a[j].column.split(',');
                    }
                }
            }
            return modelClone
        },
        sendDataRenderingRequest: function (args) {
            if (this._templateRefresh) {
                this.refreshTemplate();
                this._templateRefresh = false;
            }
            this.setFormat();
            if(!this.model.scrollSettings.enableVirtualization){
				this._previousColumnIndex = null;
				this._previousRowCellIndex = null;
				this._previousIndex = null;
			}
            if (args.requestType == "add" || args.requestType == "grouping" || (this.model.currentViewData != null && this.model.currentViewData.length)) {
                switch (args.requestType) {
                    case ej.Grid.Actions.Refresh:
                    case ej.Grid.Actions.Paging:
                    case ej.Grid.Actions.Sorting:
                    case ej.Grid.Actions.Filtering:
                    case ej.Grid.Actions.Save:
                    case ej.Grid.Actions.Cancel:
                    case ej.Grid.Actions.Delete:
                    case ej.Grid.Actions.Search:
                    case ej.Grid.Actions.Reorder:
                    case ej.Grid.Actions.BatchSave:
                        var cloneGroupedColumns = this.model.groupSettings.groupedColumns
                        if(this.model.allowGrouping && args.requestType == ej.Grid.Actions.Refresh && cloneGroupedColumns.length == 0 && this.element.find(".e-grouptopleftcell").length > 0) {
                            var $header = this.element.children(".e-gridheader");
                            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
                        }
						if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                            $("#" + this._id + "_externalEdit").css("display", "none");
                        if(!this.model.allowGrouping)
                            cloneGroupedColumns = [];
                        if (cloneGroupedColumns.length == 0) {
                            var temp = document.createElement('div'), temp1, insertIndex = -1, isRemoteAdaptor = false;
                            if (!this.phoneMode)
                                this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                            (this.model.childGrid != null || this.model.detailsTemplate != null) && this.getContentTable().find("colgroup").first().prepend(this._getIndentCol());
                            var currentPage = this._currentPage();
                            if ((this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate" || this.model.editSettings.editMode == "normal") && (args.requestType == "cancel" || args.requestType == "save"))
                                this._editFormHeight = this.element.find(".gridform").closest("tr").height();
     
                            if (this.model.scrollSettings.frozenColumns > 0)
                                temp.innerHTML = this._renderByFrozenDesign();
                            else {                                
                                if (args.data) {
                                    temp1 = document.createElement('div');
                                    temp1.innerHTML = ['<table><tbody>', $.render[this._id + "_JSONTemplate"](args.data), '</tbody></table>'].join("");
                                    if (this._dataSource() instanceof ej.DataManager && args.requestType == ej.Grid.Actions.Save) {
                                        insertIndex = this._getDataIndex(this.model.currentViewData, args.data);
                                        isRemoteAdaptor = this._dataSource().adaptor instanceof ej.remoteSaveAdaptor;
                                    }
                                }
                                var currentData = null;
                                if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && !ej.isNullOrUndefined(this._currentVIndex) && (args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete"))
                                    currentData = ej.isNullOrUndefined(this._lastVirtualPage) ? this._virtualLoadedRecords[this._currentVIndex] : this._lastVirtualPage;
                                else
                                    currentData = this.model.currentViewData
                                if (this.model.rowTemplate != null)
                                    temp.innerHTML = ['<table><tbody>', this._renderEjTemplate(this.model.rowTemplate, currentData), '</tbody></table>'].join("");
                                else
                                temp.innerHTML = ['<table><tbody>', $.render[this._id + "_JSONTemplate"](currentData), '</tbody></table>'].join("");
                                var tableEle = this.getContentTable().get(0);
                                var tbodyEle = tableEle.lastChild;
                                var rindex = this.getContentTable().first().find('tbody').first(), rowIndex;
                                if ((args.requestType == "save" || args.requestType == "cancel") && this.model.editSettings.editMode != "batch" && !this.model.scrollSettings.allowVirtualScrolling) {
                                    if (this.model.editSettings.editMode.indexOf("inlineform") != -1)
                                        rowIndex = !ej.isNullOrUndefined(args.selectedRow) ? args.selectedRow : this._selectedRow();
                                    else
                                        rowIndex = this.getContentTable().find('.e-' + args.action + 'edrow').index();
                                    var a = this._currentTrIndex;
                                    if (rowIndex == -1)
                                        rowIndex = a;
                                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                                        if (this.model.editSettings.editMode == "inlineform")
                                            var rowTr = $($(tbodyEle.childNodes).not('.e-detailrow')[rowIndex]);
                                        else
                                            var rowTr = $(tbodyEle.childNodes[rowIndex]);
                                        var rowEle = $(tbodyEle.childNodes).not('.e-detailrow');
                                        for (var i = 0; i < rowEle.length; i++) {
                                            if (rowTr.is(rowEle[i]))
                                                rowIndex = i;
                                        }
                                    }
                                    var $oldChild, $editedTr, $newChild;
                                    if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                        if (args.action == "add" && !this.getContentTable().find(".e-addedrow").length) break;
                                        $oldChild = this.getContentTable().find('.e-addedrow').get(0);
                                        $editedTr = this.getContentTable().find('.e-editedrow');
                                        $newChild = ($editedTr.length || args.requestType == "cancel") ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;                       
                                        if ($editedTr.length) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                                $oldChild = $editedTr.prev('tr').get(0);
                                                $editedTr.remove();
                                            } else
                                                $oldChild = $editedTr.get(0);
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('tr.e-detailrow:visible').length) {
                                                var $target = $newChildObj.find('.e-detailrowcollapse');
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            if (args.requestType == "cancel") {
                                                if (this.model.editSettings.showAddNewRow)
                                                    this.getContentTable().find('.e-addedrow').addClass("e-showaddrow");
                                                $oldChildObj.replaceWith($newChildObj);
                                            } else if (!ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount < this._previousFilterCount) {
                                                if (this.model.detailsTemplate != null && $oldChildObj.next('tr.e-detailrow').length)
                                                    tbodyEle.removeChild($oldChildObj.next('tr.e-detailrow').get(0));
                                                $oldChildObj.remove();
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && cloneGroupedColumns.length == 0)
                                                    tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            else {
                                                if (ej.isNullOrUndefined(this.model.currentViewData[rowIndex]) || (this._primaryKeys.length && ej.getObject(this._primaryKeys[0], this.model.currentViewData[rowIndex]) != ej.getObject(this._primaryKeys[0], args.data)))
                                                    $(tbodyEle).replaceWith($(temp).find('tbody'))
                                                else
                                                    tbodyEle.replaceChild($newChild, $oldChild);
                                            }
											if (this.model.editSettings.showAddNewRow)
												this.model.editSettings.rowPosition == "top" ? tbodyEle.firstChild.remove(): tbodyEle.lastChild.remove();
                                        } else {
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if (args.action == "add" && args.requestType == "save" && this.model.editSettings.showAddNewRow && this.model.allowPaging && this.model.pageSettings.pageSize <= this._currentJsonData.length)
                                                this.model.editSettings.rowPosition == "bottom" ? tbodyEle.lastChild.previousSibling.remove() : tbodyEle.lastChild.remove();
                                            if (args.requestType == "cancel" || this._dataSource() instanceof ej.DataManager || this._currentPage() != 1 || (args.requestType == "save" && !ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount == this._previousFilterCount)) {
                                                if (!ej.isNullOrUndefined($oldChild)) {
                                                    $oldChildObj.remove();
                                                    if (this._dataSource() instanceof ej.DataManager && insertIndex != -1) {
                                                        if (insertIndex == 0)
                                                            tbodyEle.insertBefore($newChild, tbodyEle.children[insertIndex]);
                                                        else
                                                            $newChildObj.insertAfter(tbodyEle.children[insertIndex - 1]);
                                                    }
                                                    else if ((!(this._dataSource() instanceof ej.DataManager) || isRemoteAdaptor) && this._currentPage() != 1 && args.requestType == "save")
                                                        $(tbodyEle).prepend($(temp.firstChild.firstChild.firstChild));
                                                    if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && cloneGroupedColumns.length == 0 &&
                                                        ((this._dataSource() instanceof ej.DataManager && insertIndex == -1 && (!isRemoteAdaptor && args.requestType != "save")) ||
                                                        (args.requestType != "save" && !(this._dataSource() instanceof ej.DataManager))) && (args.requestType == "cancel" && !this.model.editSettings.showAddNewRow))
                                                        tableEle.lastChild.appendChild(temp.firstChild.firstChild.lastChild);
                                                }
                                                if (args.requestType == "cancel" && this._selectedRow() != -1 && !this._enableCheckSelect)
                                                    this.clearSelection();

                                            } else if (this.model.currentViewData.length == 1) {
                                                $(tbodyEle).empty();
                                                tbodyEle.appendChild($newChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount) && this.element.find('.gridform').length > 0) {
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            } else if (this.model.editSettings.rowPosition == "bottom" && this.element.find('.gridform').length > 0) {
                                                rindex.prepend($oldChild);
                                                tbodyEle.replaceChild($newChild, $oldChild);
                                            } else
                                                if (this.element.find('.gridform').length > 0)
                                                    tbodyEle.replaceChild($newChild, $oldChild);
                                        }
                                    } else if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                                        $editedTr = this.element.find('.e-editedrow');
                                        if (args.requestType == "cancel" || (!$editedTr.length && !ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount == this._previousFilterCount)) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            $oldChild = tbodyEle.childNodes[rowIndex];
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('.e-detailrow:visible').length) {
                                                var $target = $newChildObj.find('.e-detailrowcollapse');
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            $oldChildObj.replaceWith($newChildObj);
                                            !this._enableCheckSelect && this.clearSelection();
                                            this.model.allowPaging && this._refreshGridPager();

                                        } else if ($editedTr.length) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            $oldChild = this._excludeDetailRows(tbodyEle.childNodes)[rowIndex];
                                            if (this.model.allowCellMerging != null) {
                                                var $oldChildObj = $($oldChild);
                                                if ($($oldChild.childNodes).hasClass("e-merged")) {
                                                    var index = $oldChildObj.children('.e-merged').index();
                                                    var count = $oldChild.children[index].colSpan;
                                                    for (var i = 0 ; i < count; i++) {
                                                        $newChild.childNodes[index + i].className += " e-merged e-hide";
                                                        $newChild.childNodes[index].colSpan = i + 1;
                                                    }
                                                }
                                            }
                                            if (this.model.detailsTemplate != null)
                                                $oldChild = $(tbodyEle.childNodes).not('.e-detailrow').eq(rowIndex).get(0);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('tr.e-detailrow:visible').length) {
                                                var $target = $($newChild).find(".e-detailrowcollapse");
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            if (!ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount < this._previousFilterCount) {
                                                var $oldChildObj = $($oldChild);
                                                if (this.model.detailsTemplate != null && $oldChildObj.next('tr.e-detailrow').length)
                                                    tbodyEle.removeChild($oldChildObj.next('tr.e-detailrow').get(0));
                                                $oldChildObj.remove();
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length)
                                                    tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            else {
                                                if (ej.isNullOrUndefined(this.model.currentViewData[rowIndex]) || (this._primaryKeys.length && ej.getObject(this._primaryKeys[0], this.model.currentViewData[rowIndex]) != ej.getObject(this._primaryKeys[0], args.data)))
                                                    $(tbodyEle).replaceWith($(temp).find('tbody'))
                                                else
                                                    tbodyEle.replaceChild($newChild, $oldChild);
                                            }
                                        } else if (this.model.currentViewData.length == 1 && this.getContentTable().find('td.e-rowcell').length == 0) {
                                            $newChild = temp.firstChild.firstChild.firstChild;
                                            $(tbodyEle).empty();
                                            tbodyEle.appendChild($newChild);
                                        } else {
                                            var newChild = ($editedTr.length || args.requestType == "cancel") ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;
                                            if (!(this._dataSource() instanceof ej.DataManager)) {
                                                if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                    this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                                else if (this._currentPage() == 1)
                                                    this.getContentTable().find('tbody').first().prepend($(newChild));
                                                else
                                                    this.getContentTable().find('tbody').first().prepend($(temp.firstChild.firstChild.firstChild));
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length)
                                                    tbodyEle.removeChild(tbodyEle.lastChild);
                                            }
                                            else if (insertIndex != -1) {
                                                if (insertIndex == 0)
                                                    tbodyEle.insertBefore(newChild, tbodyEle.children[insertIndex]);
                                                else
                                                    $(newChild).insertAfter(tbodyEle.children[insertIndex - 1]);
                                                var currentDataLength = this._isAddNew && insertIndex ? this.model.currentViewData.length - 1 : this.model.currentViewData.length + 1;
                                                if (this.model.allowPaging && (this.model.pageSettings.pageSize < currentDataLength || insertIndex == this.model.pageSettings.pageSize))
                                                    tbodyEle.removeChild(tbodyEle.lastChild);
                                            }
                                            if (this.model.detailsTemplate != null && $(tableEle.lastChild.lastChild).children('.e-detailrowexpand').length)
                                                tbodyEle.removeChild(tbodyEle.lastChild);
                                        }
                                    }
                                    if (this.model.editSettings.showAddNewRow)
                                        this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                                    else
                                        this._gridRows = tableEle.rows;
                                    if (this.model.enableAltRow)
                                        this._refreshAltRow();
                                } else if (args.requestType == "delete" && !this.model.scrollSettings.allowVirtualScrolling) {
                                    if (this._isUnboundColumn) {
                                        var $editedrow = this.element.find('.e-editedrow');
                                        $oldChild = this.getContentTable().find('.e-editedrow').get(0);
                                        $newChild = ($editedrow.length) ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;

                                        if ($editedrow.length != 0 && (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")) {
                                            $($oldChild).replaceWith($($newChild));
                                        }
                                        else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                            $oldChild = $editedrow.prev('tr').get(0);
                                            $editedrow.remove();
                                        }
                                        else
                                            $oldChild = $editedrow.get(0);
                                    }
                                    if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && this.getContentTable()[0].rows.length != this.model.currentViewData.length) {
                                        if (this.getContentTable().find("tr").length && this._excludeDetailRows().length) {
                                            if (this.multiDeleteMode) {
                                                var rowLength = temp.firstChild.firstChild.rows.length;
                                                var rows = $(temp.firstChild.firstChild.rows).slice(rowLength - this.selectedRowsIndexes.length, rowLength);
                                                $(tbodyEle).append(rows);
                                            }
                                            else
                                                tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);

                                        }
                                        else
                                            $(tbodyEle).prepend(temp.firstChild.firstChild.rows);
                                    }
                                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                                        var visibleRow = this.getContentTable().find('.e-detailrow:visible');
                                        $.each(visibleRow, function (indx, item) {
                                            if (visibleRow.eq(indx).closest('tr').prev().children('.e-detailrowexpand').length == 0)
                                                visibleRow.eq(indx).remove();
                                        });
                                    }
                                    this._gridRows = tableEle.rows;
                                    if (this.model.enableAltRow)
                                        this._refreshAltRow();
                                } else
                                    this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);

                            }
                            this._currentJsonData = this.model.currentViewData;
                            if (this.model.editSettings.showAddNewRow)
                                this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                            else
                                this._gridRows = this.getContentTable().get(0).rows;
                            if (this.model.scrollSettings.frozenColumns > 0)
                                this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

                            var model = {};
                            if ((args.requestType == "sorting" || args.requestType == "filtering" || args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete") && this.model.scrollSettings.allowVirtualScrolling) {
                                if (args.requestType == "filtering") {
                                    this.getContent().first().ejScroller("refresh").ejScroller("isVScroll") ? this.element.find(".gridheader").addClass("e-scrollcss") : this.element.find(".gridheader").removeClass("e-scrollcss");
                                    var model = this._refreshVirtualPagerInfo();
                                }
                                if(this.model.scrollSettings.enableVirtualization)
									this._refreshVirtualView(this._currentVirtualIndex);
								else
									this._refreshVirtualContent(currentPage);
                                args.requestType == "filtering" && this.getContent().first().ejScroller("refresh");
                            }
                            if (args.requestType == "refresh" && (this._singleView || this._getVirtualTotalRecord() < this._virtualRowCount))
                                this._addLastRow();
                            if (this.model.allowPaging) {
                                if (this.model.filterSettings.filteredColumns.length)
                                    this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._filteredRecordsCount : this._searchCount, currentPage: this._currentPage() });
                                else
                                    this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._gridRecordsCount : this._searchCount, currentPage: this._currentPage() });
                                this._refreshGridPager();
                            }
							if(!this.model.scrollSettings.enableVirtualization)
								this._eventBindings();
                            break;
                        }
                    case ej.Grid.Actions.Grouping:
                        this._group(args);
                        this._refreshStackedHeader();
                        break;
                    case ej.Grid.Actions.BeginEdit:
                        this._edit(args);
                        break;
                    case ej.Grid.Actions.Add:
                        this._add(args);
                        break;
                    case ej.Grid.Actions.Ungrouping:
                        this._ungroup(args);
                        break;
                    case ej.Grid.Actions.VirtualScroll:
						if(!this._isVirtualRecordsLoaded){
							if(!this.model.scrollSettings.enableVirtualization)
								this._replacingContent();
							else
								this._replacingVirtualContent();
						}                        
                        break;
                }
            }
            else if (args.requestType == "reorder" && this.model.groupSettings.groupedColumns.length > 0)
                    this._group(args);
            else {
                if ((ej.isNullOrUndefined(this.model.currentViewData) || this.model.currentViewData.length == 0) && !this.phoneMode) {
                    if (args.requestType == "refresh" && this.model.scrollSettings.frozenColumns == 0)
                        this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                    if((args.requestType == "filtering" ||args.requestType == "cancel" || args.requestType == "refresh") && this.model.scrollSettings.frozenColumns > 0)
                        this._removeFrozenTemplate();
                }
				this._newungroup(args);  
            }
            if (ej.isNullOrUndefined(this.model.currentViewData) || this.model.currentViewData.length == 0)
                this._currentJsonData = [];
            this._showGridLines();
            this._completeAction(args);
        },
        _removeFrozenTemplate: function(){
            this.getContent().find('div').eq(0).empty();
            var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: "0.25px" });
            var $tbody = $(document.createElement('tbody'));
            $table.append(this.getHeaderTable().find('colgroup').clone()).append($tbody);
            this.getContent().find('div').eq(0).html($table);
            this.setGridContentTable($table);
        },
        _showGridLines: function () {
            var $lines = this.model.gridLines;
            if ($lines != "both") {
				this.getContent().addClass($lines != "none" ? "e-" + $lines + "lines" : "e-hidelines");
            }
        },
		_showHeaderGridLines: function(){
			var $lines = this.model.gridLines;
			if ($lines != "both") 
				this.getHeaderContent().addClass($lines != "none" ? "e-"+$lines+"lines" : "e-hidelines");
		},
        _newungroup: function (args) {
            if (args.requestType == "ungrouping")
                this._ungroup(args);
            else
                this.getContentTable().find('tbody').empty().first().append(this._getEmptyTbody());
        },
        setFormat: function () {
            var column = [];
            for (var i = 0 ; i < this.model.columns.length ; i++) {
                if (this.model.columns[i].type == "date") {
                    column.push(this.model.columns[i]);
                }
            }
            if (column.length > 0 && !ej.isNullOrUndefined(this.model.currentViewData)) {
                for (var i = 0, len = this.model.currentViewData.length; i < len ; i++) {
                    for (var j = 0 ; j < column.length ; j++) {
                        var data = ej.getObject(column[j].field, this.model.currentViewData[i]);
                        if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*)?)([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(data))
                            ej.createObject(column[j].field, new Date(data), this.model.currentViewData[i]);
                    }
                }
            }
        },
        _completeAction: function (args) {
            if (this.model.editSettings.editMode.indexOf("dialog") != -1 && (args.requestType == "save" || args.requestType == "cancel") && $("#" + this._id + "_dialogEdit").data("ejDialog"))
                $("#" + this._id + "_dialogEdit").ejDialog("close");
            if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal"))
                this.model.isEdit = false;
            this._confirmedValue = false;
            if (ej.Grid.Actions.Grouping == args.requestType && ej.isNullOrUndefined(args.columnName) || args.requestType == "refresh" && this._LastColumnUnGroup) {
                this._LastColumnUnGroup = false;
                return;
            }
            if ((args.columnSortDirection == "ascending" || args.columnSortDirection == "descending") && !ej.isNullOrUndefined(args.columnName)) {
                var scolumn = this.getColumnByField(args.columnName);
                if (this.model.allowSorting && this.model.allowMultiSorting)
                    this._scolumns.push(scolumn.field);
                else
                    this._gridSort = scolumn.field;
            }
            if (args.requestType != 'beginedit' && args.requestType != 'add' && (!this.model.allowScrolling || !this.initialRender || this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
                this.setWidthToColumns();
            if (args.requestType == "save" || args.requestType == "cancel" ||  args.requestType == "delete") {
                this._isAddNew = false;
                if (this.model.isResponsive && this.model.minWidth)
                {
                    this._refreshScroller(args);
                    this.windowonresize();
                }
            }
            if (!this.initialRender && (ej.Grid.Actions.UnGrouping == args.requestType || this.model.groupSettings.groupedColumns.length > 0) && !$("#" + this._id + "EditForm").length)
                this._recalculateIndentWidth();
            if (ej.Grid.Actions.Paging == args.requestType || ej.Grid.Actions.BatchSave == args.requestType)
                this._refreshGridPager();
            else if ((ej.Grid.Actions.Sorting == args.requestType && this.model.allowSorting) || ej.Grid.Actions.Refresh == args.requestType  || ej.Grid.Actions.Cancel == args.requestType) {
                if (ej.gridFeatures.sort && this.getHeaderTable() !== null)
                    this._sortCompleteAction(args);
                if (this.model.allowPaging) {
                    var pageModel = this.getPager().ejPager("option");
                    this._currentPage(pageModel.currentPage);
                    delete pageModel.currentPage;
                    $.extend(this.model.pageSettings, pageModel);
                    delete this.model.pageSettings.masterObject;
                    this._refreshGridPager();
                }
				if (!this.initialRender && (this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
                    this._refreshScroller(args);
                
            } else if (ej.Grid.Actions.Delete == args.requestType || ej.Grid.Actions.Save == args.requestType || ej.Grid.Actions.Search == args.requestType) {
                this._editEventTrigger(args);
				if (!this.initialRender && (this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
					this._refreshScroller(args);
                if (this.model.allowPaging)
                    this._refreshPagerTotalRecordsCount();
            } else if (ej.Grid.Actions.Filtering == args.requestType)
                this._filterCompleteAction();
            else if (ej.Grid.Actions.BeginEdit == args.requestType || ej.Grid.Actions.Add == args.requestType)
                this._editCompleteAction(args);
            else if (ej.Grid.Actions.Grouping == args.requestType || ej.Grid.Actions.Ungrouping == args.requestType)
                this["_" + args.requestType + "CompleteAction"](args);
            if (this.model.toolbarSettings.showToolbar || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow))
                this.refreshToolbar();
            if (!this.initialRender && this.model.showSummary && this.model.summaryRows.length > 0) {
                if (this.model.currentViewData.length) {
                    if (!this.element.children(".e-gridfooter").length)
                        this._renderGridFooter().insertAfter(this.getContent());
                    if (!(args.requestType == "beginedit" || args.requestType == "add")) {
                        this._refreshGridFooterColGroup();
                        this._createSummaryRows(this.getFooterTable());
                    }
                }
                else
                    this.element.children(".e-gridfooter").remove();
            }
            if (!this.initialRender && ej.gridFeatures.selection) {
                if (!this.getContent().find("td.e-selectionbackground").length)
                    this._setCurrentRow(args.requestType);
                if (args.requestType == "cancel" && this.model.selectedRowIndex != -1)
                     $(this.getRowByIndex(this.model.selectedRowIndex)).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                if (args.requestType != "virtualscroll" && this.clearColumnSelection())
                    $(this.getHeaderTable().find("th.e-headercell")).removeClass("e-columnselection");
            }
            this.model.editSettings.editMode == "batch" && this.refreshBatchEditMode();
            if (!this.initialRender && (this.model.allowScrolling || this.model.isResponsive) && (this._checkScrollActions(args.requestType) || (this.model.editSettings.editMode.indexOf("inline") != -1 && args.requestType == "beginedit")) ||
                (this.model.scrollSettings.virtualScrollMode == "continuous" && args.requestType == "virtualscroll")){
                if(this.model.isResponsive && this.model.minWidth)
                {
                    this._refreshScroller(args);
                    this.windowonresize()
                }
                else
                    this._refreshScroller(args);
             }    
            if (this.model.scrollSettings.virtualScrollMode == "normal" && args.requestType == "virtualscroll")
                this.getContent().find("div:first").scrollLeft(this.getScrollObject().scrollLeft());
            if (this._customPop != null && args.requestType != "sorting") {
                this._customPop.hide();
            }
            if (this.model.allowScrolling && !this.initialRender && !this.model.scrollSettings.enableVirtualization && !(this.model.isResponsive && this._isHeightResponsive))
                this.getContentTable().find("tr:last").find("td").addClass("e-lastrowcell");

            if (this.model.allowGrouping && this.model.showSummary)
                this._refreshGroupSummary();
            if (ej.Grid.Actions.Refresh == args.requestType && !this.initialRender && this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0)
                this._groupingCompleteAction(args);
            if (ej.Grid.Actions.Refresh == args.requestType && !this.initialRender && this.model.allowGrouping && this.model.groupSettings.groupedColumns.length < 1)
                this._ungroupingCompleteAction(args);
			 if(this.model.allowGrouping){
                var $groupDrop = this.element.children(".e-groupdroparea");
                $groupDrop.length > 0 && $groupDrop.removeClass("e-default").removeClass("e-active");
                if(this.model.groupSettings.groupedColumns.length > 0)
                    $groupDrop.addClass("e-active");
                else
                    $groupDrop.addClass("e-default");
            }
            if (this.model.textWrapSettings)
                this._setTextWrap();
            if (args.requestType == ej.Grid.Actions.Reorder && this.model.showColumnChooser) {
                var dlgObj = $("#" + this._id + "ccDiv").data("ejDialog");
                if (dlgObj.isOpened())
                    $("#" + this._id + "_ccTail").first().remove();
                var ccBtnHeight = 0;
                if (!ej.isNullOrUndefined(this.element.find(".e-ccButton").outerHeight()))
                    ccBtnHeight += this.element.find(".e-ccButton").outerHeight();
                this.element.find(".e-ccButton").first().remove();
                $("#" + this._id + 'ccDiv_wrapper').remove();
                this.element.css('margin-top', (parseInt(this.element.css('margin-top'), 10) - ccBtnHeight));
                this._renderColumnChooser();
            }
            if (this.initialRender && args.requestType == "grouping")
                args = { requestType: "refresh" };
            if(!((this._isUngrouping || this._columnChooser  ) && ( args.requestType == "refresh") ) ){
				this._trigger("actionComplete", args);
				this._isUngrouping = false;
				this._columnChooser = false;
			}
            if ((!this._isUngrouping && !this.initialRender) || this._showHideColumns || this._columntemplaterefresh)
            this._trigger("refresh");
            if ((this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")) {
                
                if (!this.initialRender && this.getContentTable().find("tr.e-addedrow").length == 0 && this.element.find(".e-gridcontent").find("tr").length != 0)
                    this._startAdd();
                 if (args.requestType == "searching")
                    this.element.find(".e-gridtoolbar").find("li#" + this._id + "_search input").focus();
            }
            
            if ((ej.Grid.Actions.BeginEdit == args.requestType || ej.Grid.Actions.Add == args.requestType) && $.isFunction($.validator))
                this.setValidation();
            if (!this.initialRender)
                this.model._groupingCollapsed = [];
            if (this._updateDataSource && this._gridRecordsCount) {
                var currentData = this.model.editSettings.showAddNewRow ? this.model.currentViewData[1] : this.model.currentViewData[0];
                if (!ej.isNullOrUndefined(currentData)) {
                    this._initColumns(currentData);
                    this.model.allowFiltering && this._renderFilterDialogs();
                    this._updateDataSource = false;
                }
            }
		    if (this.model.columnLayout == "fixed" && !this.model.isEdit)
		        this.setWidthToColumns();
		    if (this.model.allowRowDragAndDrop)
		        this._rowsDragAndDrop();
            if (this.model.allowScrolling && this.element.width() != 0) 
                 this.refreshScrollerEvent();
		    if (!this.initialRender && this._enableCheckSelect) {
		        var indexes = this.checkSelectedRowsIndexes[this._currentPage() - 1];
		        var headerCheckCell = this.getHeaderTable().find(".e-headercheckcelldiv .e-checkselectall");
				if (!this._selectAllCheck && !(this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.selectedRowsIndexes.length == this._gridRecordsCount))
					headerCheckCell.prop("checked", false);
		        if (!this._isMapSelection && indexes && indexes.length > this._gridRows.length)
		            indexes.splice(this._gridRows.length, indexes.length - this._gridRows.length);
		        if (this._isMapSelection)
		            this._mappingSelection();
		        else if (args.requestType != "paging" && args.requestType != "save" && args.requestType != "beginedit" && args.requestType != "cancel")
		            this.checkSelectedRowsIndexes = [];
		        else if (indexes && indexes.length)
		            this.selectRows(indexes);
		        if (this.model.currentViewData != null && this.model.currentViewData.length == 0)
		            this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").hide();
		        else
                    this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").show();
		        if (this._selectAllCheck) { // For Selection using header after filtering
		            var selectAll = headerCheckCell.prop("checked") ^ this.selectedRowsIndexes.length == this.model.currentViewData.length;
		            if (this.model.groupSettings.groupedColumns.length)
		                selectAll = !selectAll;
		            headerCheckCell[0].checked = !selectAll ? !headerCheckCell[0].checked : headerCheckCell[0].checked;
		        }
		    }
        },        
        _getDataIndex: function (data, item) {
            var flag = 0, _plen;
            for (var d = 0, len = data.length; d < len; d++) {
                for (var key = 0, _plen = this._primaryKeys.length; key < _plen; key++) {
                    if (!this._checkPrimaryValue(data[d][this._primaryKeys[key]], item[this._primaryKeys[key]], this._primaryKeys[key])) {
                        if (key == _plen - 1)
                            flag = 1;
                        continue;
                    }
                    else
                        break;
                }
                if (flag) return d;
            }
            return -1;
        },
        _checkPrimaryValue: function (keyData, keyItem, field) {
            var col = this.getColumnByField(field),
            type = ej.isNullOrUndefined(col.foreignKeyField) ? col.type : col.originalType;
            if (type == "string")
                keyData = keyData.trim();
            if (keyData != keyItem)
                return true;
            else
                return false;
        },
        _eventBindings: function () {
            var rowLength = this.model.scrollSettings.frozenColumns > 0 ? this._gridRows[0].length : this._gridRows.length;
            var trIndex = 0;
            var prev;
            var pageSize = this.model.pageSettings.pageSize;
            if (ej.gridFeatures.common)
                this._refreshUnboundTemplate(this.getContentTable());
            if (this._gridRecordsCount != 0) {
                if (this.model.queryCellInfo != null || this.model.rowDataBound != null || this.model.mergeCellInfo != null || this.model.templateRefresh != null) {
                    for (var row = 0; row < rowLength; row++) {
                        var rowIndex = null, trIndex = row, viewIndex, viewData;
                        if (this.model.scrollSettings.allowVirtualScrolling && row < pageSize) {
							if(!this.model.scrollSettings.enableVirtualization){
								for (var i = 0; i < this._cloneQuery.queries.length; i++)
									prev = this._cloneQuery.queries[i].fn == "onPage" &&  this._cloneQuery.queries[i].e.pageIndex - 1;
								var value = pageSize * prev; 
								if (value != 0) {
									rowIndex = this.getContentTable().find("tr[name=" + value + "]").eq(row);
									trIndex = rowIndex.index();
								}
							}
							else{
								rowIndex = $(this._gridRows).eq(row);
								viewIndex = parseInt($(rowIndex).attr("name"), 32);	
								if($.inArray(viewIndex, this._queryCellView) != -1)		
									continue;
								if(this._virtualLoadedRecords[viewIndex])
									viewData = this._virtualLoadedRecords[viewIndex][row % this._virtualRowCount];
								trIndex = viewIndex * this._virtualRowCount + (row % this._virtualRowCount);								
							}
                        }
						else if(this.model.scrollSettings.enableVirtualization)
							rowIndex = $(this._gridRows).eq(row);
                        rowIndex = rowIndex || this.getRowByIndex(trIndex);
                        if (rowIndex.hasClass("e-virtualrow") || ej.isNullOrUndefined(this._currentJsonData[row] || viewData))
                            break;
						var rowData = this.model.scrollSettings.enableVirtualization ? viewData : this._currentJsonData[row];
                        this._rowEventTrigger(rowIndex, rowData);                       
                    }
                }
            }
        },
        _rowEventTrigger: function (row, data) {
            var args = { row: row, data: data, rowData: data };
            this._trigger("rowDataBound", args);
            var tdCells = row.cells;
            var $tdRowcells = $(row).find(".e-rowcell");
            if (this.model.queryCellInfo != null || this.model.mergeCellInfo != null || this.model.templateRefresh != null) {
                for (var cellIndex = 0; cellIndex < $tdRowcells.length; cellIndex++) {
                    var args = { cell: $tdRowcells[cellIndex], data: data, rowData: data, text: $tdRowcells[cellIndex].innerHTML };
                    var foreignKeyData = this._getForeignKeyData(args.data);
                    if ($($tdRowcells[cellIndex]).hasClass("e-rowcell"))
                        args.column = this.model.columns[cellIndex];
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    if (this.model.allowCellMerging == true) {
                        this._cellMerging(args);
                        this._trigger("mergeCellInfo", args);
                    }
                    this._trigger("queryCellInfo", args);
                    if ($($tdRowcells[cellIndex]).hasClass("e-templatecell")) {
                        var args = { cell: $tdRowcells[cellIndex], column: this.model.columns[cellIndex], data: data, rowData: data, rowIndex: $(row).index() };
                        this._trigger("templateRefresh", args);
                    }
                }
            }

        },

        setWidthToColumns: function () {
            var $cols1 = this.getContentTable().children("colgroup").find("col");
            var $cols2 = this.getHeaderTable().children("colgroup").find("col");
            var undefinedColsCollection = [], hCellIndex;
            var width = this.element.width(), frozenWidth = 0, columnsTotalWidth = 0, finalWidth = 0, browserDetails = !ej.isIOSWebView() && this.getBrowserDetails();
            if (this.model.groupSettings.groupedColumns.length && !this.model.allowScrolling && this.model.groupSettings.showGroupedColumn) {
                if (browserDetails && browserDetails.browser == "msie" && parseInt(browserDetails.version, 10) > 8)
                    $cols1.first().css("width", ((30 / width) * 100) + "%");
            }
            if (!ej.isNullOrUndefined(this.model.detailsTemplate)) {
                var headerIndx = this.model.groupSettings.groupedColumns.length;
                var contentIndx = this.model.groupSettings.groupedColumns.length != 0 ? 1 : 0;
                $cols1.eq(contentIndx).css("width", this._detailsOuterWidth);
                $cols2.eq(headerIndx).css("width", this._detailsOuterWidth);
            }
            this._detailColsRefresh();
            $cols1 = this._$headerCols;
            $cols2 = this._$contentCols;
            if (this.model.allowResizeToFit) {
                var visibleColumnsWidth = 0; var undefinedWidthColumnsCount = 0;
                for (j = 0; j < this.model.columns.length; j++) {
                    if (this.model.columns[j].visible) {
                        if (this.model.columns[j]["width"] != undefined)
                            visibleColumnsWidth = visibleColumnsWidth + this.model.columns[j]["width"];
                        else
                            undefinedWidthColumnsCount = undefinedWidthColumnsCount + 1;
                    }
                }
            }
            for (var i = 0; i < $cols2.length; i++) {
                if (this.model.allowResizeToFit && this.model.columns[i]["width"] === undefined) {
                    hCellIndex = this.model.groupSettings.groupedColumns.length ? (i + this.model.groupSettings.groupedColumns.length) : i;
                    var contentWidth = this._resizer._getContentWidth(i);
                    var cellDiv = this.getHeaderTable().find('.e-headercelldiv').eq(hCellIndex);
                    var headerWidth = this._resizer._getHeaderContentWidth(cellDiv);
                    if (this.model.editSettings.editMode == "normal" && (this.model.isEdit || this._isAddNew))
                        finalWidth = browserDetails.browser == "firefox" ? parseInt($cols1[i].style.width, 10) : $cols1.eq(i).width();
                    else if (undefinedWidthColumnsCount > 0) {
                        finalWidth = this.model.columns[i].visible ? parseInt(this.element.width() - visibleColumnsWidth) / undefinedWidthColumnsCount : 0;
                    }
                    if ((finalWidth < contentWidth && finalWidth < headerWidth) && undefinedWidthColumnsCount > 0) {
                        finalWidth = contentWidth > headerWidth ? contentWidth : headerWidth;
                        finalWidth += parseInt(cellDiv.css("padding-left"), 10) + parseInt(cellDiv.css("padding-right"), 10);
                        visibleColumnsWidth += finalWidth;                       
                        undefinedWidthColumnsCount -= 1;
                        this.columnsWidthCollection[i] = finalWidth;
                        columnsTotalWidth += this.model.columns[i].visible ? finalWidth : 0;
                    }
                    else if (undefinedWidthColumnsCount > 0 && (contentWidth > 0 || (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0))) {
                        var cWidth = contentWidth > headerWidth ? contentWidth : headerWidth;
                        if (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0) {
                            if (cWidth > finalWidth) {
                                finalWidth = cWidth;
                                finalWidth += parseInt(cellDiv.css("padding-left"), 10) + parseInt(cellDiv.css("padding-right"), 10);
                            }
                        }
                        else {
                            if (cWidth > finalWidth || (this.element.width() / undefinedWidthColumnsCount < visibleColumnsWidth - finalWidth && !this.model.allowTextWrap)) {
                                finalWidth = cWidth;
                                finalWidth += parseInt(cellDiv.css("padding-left"), 10) + parseInt(cellDiv.css("padding-right"), 10);
                            }
                        }
                        if (this.model.columns[i].visible) {
                            visibleColumnsWidth += finalWidth;
                            undefinedWidthColumnsCount -= 1;
                        }
                        this.columnsWidthCollection[i] = finalWidth;
                        columnsTotalWidth += this.model.columns[i].visible ? finalWidth : 0;
                    }
                } else {
                    if (typeof (this.model.columns[i].width) == "string" && this.model.columns[i].width.indexOf("%") != -1)
                        var columnWidth = (parseInt(this.model.columns[i]["width"]) / 100 * this.element.width());
                    else
                        var columnWidth = parseInt(this.model.columns[i]["width"], 10);
                    columnsTotalWidth += this.model.columns[i].visible ? columnWidth : 0;
                }
                if (this.model.columns[i]["priority"])
                    $cols2.eq(i).addClass("e-table-priority-" + this.model.columns[i]["priority"]);
                if (!ej.isNullOrUndefined(this.columnsWidthCollection[i])) {
                    $cols1.eq(i).width(this.columnsWidthCollection[i]);
                    $cols2.eq(i).width(this.columnsWidthCollection[i]);
                } else if (this.model.allowScrolling) {
                    undefinedColsCollection.push(this.model.columns[i]);
                }
            }
            var hiddenColLength = undefinedColsCollection.filter(function (e) { return !e.visible }).length;
            var headercell = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell");
            for (var i = 0; i < undefinedColsCollection.length; i++) {
                if (!undefinedColsCollection[i].visible)
                    continue;
                var colIndex = ej.isNullOrUndefined(undefinedColsCollection[i].field) ? this.getColumnIndexByField(undefinedColsCollection[i].field) : this.getColumnIndexByHeaderText(undefinedColsCollection[i].headerText);
                var cell = headercell.eq(colIndex)[0];
                var colWidth = cell.getBoundingClientRect().width;
                if (ej.isNullOrUndefined(colWidth))
                    colWidth = cell.offsetWidth;
                if (parseInt(colWidth) < 15) {
                    colWidth = (width / this.model.columns.length).toFixed(2);
                    var bSize = (width / (this.model.scrollSettings.buttonSize || 18) / 100).toFixed(2);
                    colWidth = colWidth - bSize;
                }
                $cols1.eq(colIndex).css("width", colWidth + "px");
                $cols2.eq(colIndex).css("width", colWidth + "px");
                this.model.columns[colIndex].width = colWidth;
                this.columnsWidthCollection[colIndex] = parseFloat(colWidth);
            }
            if (!hiddenColLength)
                this._undefinedColsCollection = null;
            if (this.model.columnLayout == "fixed") {
                if (this.model.scrollSettings && this.model.scrollSettings.frozenColumns == 0) {
                    this.getHeaderTable().width(columnsTotalWidth);
                    this.getContentTable().width(columnsTotalWidth);
                }
                var headerTableWidth = this.model.scrollSettings.frozenColumns > 0 ? this.getHeaderTable().eq(0).width() + this.getHeaderTable().eq(1).width() : this.getHeaderTable().width();
                var operation = this.getHeaderContent().width() > headerTableWidth ? 'addClass' : 'removeClass';
                var headerTable = this.getHeaderTable();
                var contentTable = this.getContentTable();
                if (this.model.scrollSettings.frozenColumns > 0) {
                    headerTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getHeaderTable().eq(1) : this.getHeaderTable().eq(0);
                    contentTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getContentTable().eq(1) : this.getContentTable().eq(0);
                }
                headerTable[operation]('e-tableLastCell');
                contentTable[operation]('e-tableLastCell');
            }
            if (!this.model.allowScrolling && this.model.allowResizeToFit && !this.model.isResponsive && columnsTotalWidth > width) {
                this.model.allowScrolling = true;
                this.model.scrollSettings.width = width;
                this.getHeaderTable().parent().addClass("e-headercontent");
                this._renderScroller();
                if (!this.model.scrollSettings.frozenColumns > 0)
                    this.getHeaderTable().width(width);
            }
            if (this.model.isEdit) {
                var clonedCol = $cols1.clone();
                var editedTr;
                if (this.model.editSettings.showAddNewRow)
                    editedTr = this.getContentTable().find(".e-editedrow");
                var $colGroup = this.model.scrollSettings.frozenColumns > 0 ? this.getContent().find(".gridform").find("colgroup") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr.find("colgroup") : $("#" + this._id + "EditForm").find("colgroup");
                this.model.scrollSettings.frozenColumns > 0 && $colGroup.first().empty().append(clonedCol.splice(0, this.model.scrollSettings.frozenColumns));
                $colGroup.last().empty().append(clonedCol);
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $colGroup.prepend(this._getIndentCol());
            }
            if (this.model.groupSettings.groupedColumns.length) {
                var $grouedColGroup = this.getContentTable().find(".e-recordtable").children("colgroup");
                for (var i = 0; i < $grouedColGroup.length; i++) {
                    var clonedCol = $cols1.clone();
                    var detailsWidth = this._detailsOuterWidth != null ? this._detailsOuterWidth : "30px";
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) clonedCol.splice(0, 0, $(this._getIndentCol()).width(detailsWidth)[0]);
                    $grouedColGroup.eq(i).empty().append(clonedCol);
                }
            }
            if (this.model.scrollSettings.frozenColumns > 0) {
                var totalWidth = 0, frozenWidth;
                for (var i = 0; i < this.model.columns.length; i++) {
                    totalWidth += this.model.columns[i].visible ? parseInt(this.columnsWidthCollection[i], 10) : 0;
                    if (this.model.scrollSettings.frozenColumns - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                }
                this.element.width(this.model.scrollSettings.width || this.model.width);
                var gridContentWidth = this.element.find(".e-gridcontent").children().first().width();
                if (gridContentWidth > totalWidth)
                    totalWidth = gridContentWidth + ((this.getContentTable().height() < this.model.scrollSettings.height && this.getScrollObject()._vScroll) ? this.model.scrollSettings.buttonSize : 0);
                else
                    totalWidth += ((this.getContentTable().height() > this.model.scrollSettings.height) ? this.model.scrollSettings.buttonSize : 0);
                this.getContent().find(".e-frozencontentdiv").outerWidth(frozenWidth)
                    .end().find(".e-movablecontentdiv").outerWidth(totalWidth - frozenWidth);
                this.getHeaderContent().find(".e-frozenheaderdiv").outerWidth(frozenWidth)
                    .end().find(".e-movableheaderdiv").outerWidth(totalWidth - frozenWidth);
            }
           if(!this.initialRender && this.model.allowResizeToFit && this.model.allowScrolling && this.model.scrollSettings.enableVirtualization ){			
				var width = this.getHeaderTable().width() >this.getContentTable().width()?this.getHeaderTable().width() : this.getContentTable().width();
				this.getContentTable().width(width);
				this.getHeaderTable().width(width);
			}
        },
        _initialEndRendering: function () {
            // use this method to add behaviour after grid render.
            if (this.model.allowRowDragAndDrop)
                this._rowsDragAndDrop();
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate")
                    this.element.append(this._renderDialog());
                else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                    this.element.append(this._renderExternalForm());
            }
            
            (this.model.editSettings.editMode == "batch" || this.model.editSettings.showDeleteConfirmDialog) && this._renderConfirmDialog();
            (this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) && $("#" + this._id + 'AlertDialog').length == 0 && this._renderAlertDialog();
            if (this.model.allowMultiSorting || this.model.selectionType == "multiple")
                this._renderMultiTouchDialog();
            if (this.model.scrollSettings.frozenColumns > 0 && !this.model.allowScrolling) {
                this.getContent().remove();
                this.getHeaderTable().eq(1).remove();
                this._alertDialog.find(".e-content").text(this.localizedLabels.FrozenColumnsScrollAlert);
                this._alertDialog.ejDialog("open");
                return;
            }
            this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && this._createPagerStatusBar();
            this._getRowHeights();
            if (this.element.width() != 0 && this.model.allowScrolling) {
                this._renderScroller();
                if (!(this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0)) {
                    this.setWidthToColumns();
                    var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null;
                    scrollObj != null && scrollObj.refresh();
                    this.refreshScrollerEvent();
                }
            }
            else if ((this.model.allowScrolling || (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length)) && this.element.width() <= 0) {
                var proxy = this, myVar = setInterval(function () {
                    if (!ej.isNullOrUndefined(proxy.element) && proxy.element.width() > 0 && !ej.isNullOrUndefined(proxy.element.width())) {
                        if (proxy.model.allowScrolling) {
                            proxy._renderScroller();
                            if (!(proxy.model.scrollSettings.frozenRows > 0 || proxy.model.scrollSettings.frozenColumns > 0)) {
                                proxy.setWidthToColumns();
                                var scrollObj = !ej.isNullOrUndefined(proxy.getContent().data("ejScroller")) ? proxy.getScrollObject() : null;
                                scrollObj != null && scrollObj.refresh();
                                proxy.refreshScrollerEvent();
                            }
                        }
                        if (proxy.model.allowGrouping && proxy.model.groupSettings.groupedColumns.length && proxy.getHeaderTable().find(".e-grouptopleftcell").width() <= 0)
                            proxy.getHeaderTable().find(".e-grouptopleftcell").css('width', proxy.getHeaderTable().find('colgroup col').eq(0).width());
                        proxy._endRendering();
                        clearInterval(myVar);
                    }
                }, 100);
                return;
            }
           this._endRendering();
        },

        _endRendering: function () {
            if (!ej.isNullOrUndefined(this.model.serverProperties)) {
                var chkIndexes = this.model.serverProperties._checkSelectedRowsIndexes;
                this.checkSelectedRowsIndexes = chkIndexes && chkIndexes.length ? chkIndexes : this.checkSelectedRowsIndexes;
            }
            if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && this.model.allowScrolling)
                var scroller = this.getScrollObject();
            var css = this.model.enableRTL ? "e-summaryscroll e-rtl" : "e-summaryscroll";
            if (this.model.allowScrolling && this.model.showSummary) {
                if(scroller._vScroll)
                    this.element.find(".e-summaryrow.e-scroller").addClass(css);
                this.getFooterTable() && this.getFooterTable().find("colgroup").first().replaceWith(this.getHeaderTable().find("colgroup").clone());
            }
            this._addMedia();
            if(this.model.allowScrolling && this.model.allowTextWrap && !this.model.scrollSettings.allowVirtualScrolling) this.getContent().first().ejScroller("refresh");
            if (this.model.scrollSettings.allowVirtualScrolling) {
                this._currentPage(1);
                if (this._currentPage() == 1 && !this.model.scrollSettings.enableVirtualization)
                    this._virtualLoadedRecords[this._currentPage()] = this._currentJsonData;
                if(this.model.scrollSettings.enableVirtualization)
                    this._refreshVirtualView();				
                else
                    this._refreshVirtualContent(this._currentPage());
                this.getContent().first().ejScroller("refresh");
                if (this.getContent().ejScroller("isVScroll")) {
                    this.element.find(".e-gridheader").addClass("e-scrollcss");
                    this.getHeaderTable().first().width(this.getContentTable().width());
                }
                else
                    this.element.find(".e-gridheader").removeClass("e-scrollcss");
            }
            if (this.model.allowSelection == true && this.model.selectionType == "multiple" && this._selectedMultipleRows().length > 0)
                this._selectingMultipleRows(this._selectedMultipleRows());
            if (this._selectedRow() != -1 || this._selectedMultipleRows().length == 1) {
                var row = this._selectedMultipleRows();
                var indexes = row.length ? row : this._selectedRow();
                this.selectRows(indexes);
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar" && !this.model.allowPaging && !this.model.scrollSettings.allowVirtualScrolling)
                this._createPagerStatusBar();
            if (ej.gridFeatures.common)
                this.rowHeightRefresh()
            if (ej.gridFeatures.filter && ["menu", "excel"].indexOf(this.model.filterSettings.filterType) != -1)
                this._refreshFilterIcon();
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this._recalculateIndentWidth();
            if (this.initialRender && (!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount))
                this._addLastRow();
        },

        _addLastRow: function () {
            var lastRowtd = this.getContentTable().find("tr:last").find("td"), rowHeight = 0;

            if (this.model.allowScrolling && !this.model.scrollSettings.allowVirtualScrolling && !ej.isNullOrUndefined(this.model.dataSource) && !ej.isNullOrUndefined(this.getRows())) {
                for (var i = 0; i < this.getRows().length; i++)
                    rowHeight += $(this.getRows()[i]).height();

                if (rowHeight < this.getContent().height() - 1)
                    lastRowtd.addClass("e-lastrowcell");
            }
            if(this.model.scrollSettings.allowVirtualScrolling && this.getContentTable().height() < this.getContent().height())
                lastRowtd.addClass("e-lastrowcell");
        },
        _addMedia: function () {
            if (!this.model.enablePersistence && typeof (this.model.scrollSettings.width) != "string" && this.model.scrollSettings.width > 0) {
                this._responsiveScrollWidth = this._originalScrollWidth = this.model.scrollSettings.width;
            }
            else
                this._originalScrollWidth = this.element.width();
            if (typeof (this.model.scrollSettings.height) != "string" && this.model.scrollSettings.height > 0)
                this._responsiveScrollHiehgt = this.model.scrollSettings.height;
            if (this.model.minWidth && this.model.isResponsive) {
                this._$onresize = $.proxy(this.windowonresize, this);
                $(window).on("resize", this._$onresize);
                if ($.isFunction(window.matchMedia)) {
                    var mediaFilterObj = window.matchMedia("(max-width: 768px)");
                    this._mediaStatus = mediaFilterObj.matches;
                }
                this.windowonresize();
            }
        },
        _getNoncontentHeight: function () {   
            var height = 0;
            if (!ej.isNullOrUndefined(this.getHeaderContent().outerHeight()))
                height += this.getHeaderContent().outerHeight();
            if (this.model.toolbarSettings.showToolbar && !ej.isNullOrUndefined(this.element.find('.e-gridtoolbar').outerHeight()))
                height += this.element.find('.e-gridtoolbar').outerHeight();
            if (this.model.allowPaging && !ej.isNullOrUndefined(this.element.find('.e-pager').outerHeight()))
                height += this.element.find('.e-pager').outerHeight();
            if (this.model.showColumnChooser && !ej.isNullOrUndefined(this.element.find(".e-ccButton").outerHeight()))
                height += this.element.find(".e-ccButton").outerHeight();
            if (this.model.allowGrouping && this.model.groupSettings.showDropArea && !ej.isNullOrUndefined(this.element.find('.e-groupdroparea').outerHeight()))
                height += this.element.find('.e-groupdroparea').outerHeight();
            if (this.model.showSummary && !ej.isNullOrUndefined(this.element.find('.e-gridsummary').outerHeight()))
                height += this.element.find('.e-gridsummary').outerHeight();
            return height;
        },
        
        setDimension: function (height, width) {
            var originalHeight = height - this._getNoncontentHeight();
            this.model.scrollSettings.height = originalHeight;
            this.model.scrollSettings.width = width;
            this._renderScroller();
        },
		_getVisibleColumnsWidth: function(){
			var i,gridColsWidth=0;
			for(i=0; i<this.columnsWidthCollection.length; i++){
				if(this.model.columns[i].visible)
					gridColsWidth += this.columnsWidthCollection[i];
			}
			return gridColsWidth;
		},
		setPhoneModeMaxWidth: function (value) {
		    this._gridPhoneMode = value;
		},
        _mediaQueryUpdate: function (isScroller, elemHeight, width, winHeight) {
            if (window.innerWidth <= this._gridPhoneMode && this.model.enableResponsiveRow) {
                var contentStyle=this.getContentTable()[0].style;
               if(contentStyle.removeAttribute)
                   contentStyle.removeAttribute('min-width');
               else        
                   contentStyle.removeProperty('min-width');
                var scrollObj = this.getContent().data('ejScroller');
                if (scrollObj)
                    this.getContent().ejScroller('destroy');
                return;
            }
            if (isScroller) {
                this.model.scrollSettings.width = ej.isNullOrUndefined(this._responsiveScrollWidth) ? width : Math.min(this._responsiveScrollWidth, width);
                var height = Math.min(winHeight, elemHeight) - this._getNoncontentHeight();
                height = ej.isNullOrUndefined(this._responsiveScrollHiehgt) ? height : Math.min(this._responsiveScrollHiehgt, height);
                if(((this.element.parent().is("body") && $(document).height() > height) ||(height > this.element.parent().height())) && this.model.scrollSettings.height != "auto")
					height -= parseInt(this.element.parent().css('margin-bottom')+1);
				height = this.model.scrollSettings.height != "auto" ? height : this.model.scrollSettings.height;
				if ((this.model.minWidth > width || this.getContentTable().width() > width) && elemHeight > winHeight)
                    height = height != "auto" ? height + this.model.scrollSettings.buttonSize : height ;
                if (ej.isNullOrUndefined(this.getRows()))
                    height = '100%';
                this.model.scrollSettings.height = this._isHeightResponsive ? height : this._initHeight ? this._initHeight : this.getContentTable()[0].scrollHeight;
                this.element.find(".e-gridheader").first().find("div").first().addClass("e-headercontent");
                this._renderScroller();
            }
            else {
                this.model.scrollSettings.width = '100%';
                if (!ej.isNullOrUndefined(this._responsiveScrollWidth))
                    this.model.scrollSettings.width = Math.min(this._responsiveScrollWidth, width);
                var modifyHeight = Math.min(winHeight, elemHeight);
                var height = modifyHeight - this._getNoncontentHeight();
                if (!ej.isNullOrUndefined(this._responsiveScrollHiehgt))
                    height = Math.min(this._responsiveScrollHiehgt, height);
                if(((this.element.parent().is("body") && $(document).height() > height) ||(height > this.element.parent().height())) && this.model.scrollSettings.height != "auto")
					height -= parseInt(this.element.parent().css('margin-bottom'));
				height = this.model.scrollSettings.height != "auto" ? height : this.model.scrollSettings.height;
				if (!ej.isNullOrUndefined(this._responsiveScrollWidth) && this.model.scrollSettings.width == this._responsiveScrollWidth && (this.model.minWidth > this._responsiveScrollWidth || this._getVisibleColumnsWidth() > this._responsiveScrollWidth) || (ej.isNullOrUndefined(this._responsiveScrollWidth) && (this.getRowHeight() == height || this._isHeightResponsive) && this.getContentTable().width() > width))
                   height = height != "auto" ? height + this.model.scrollSettings.buttonSize : height;
                if (ej.isNullOrUndefined(this.getRows()))
                    height = '100%';
                if (this.getContent().height() >= height && !this._resize && !this.initialRender && typeof(this.model.scrollSettings.width) == "string")
                    this.model.scrollSettings.width = width;
                this.model.scrollSettings.height = this._isHeightResponsive ? height : this._initHeight ? this._initHeight : this.getContentTable()[0].scrollHeight;
                this.element.find(".e-gridheader").first().find("div").first().addClass("e-headercontent");
				this._renderScroller();
            }
            this._resize = false;
        },
        windowonresize: function (e) {
            if (!this.element.is(":visible")) {
                var proxy = this;
                proxy._isVisible = true;
                var testVar = setInterval(function () {
                    if (proxy.element.is(":visible") && proxy._isVisible) {
                        proxy.windowonresize();
                        proxy._isVisible = false;
                        clearInterval(testVar);
                    }
                }, 100);
                return;
            }
            if (e && e.type == "resize")
                this._resize = true;
            this.model.scrollSettings.width = this._responsiveScrollWidth;
            var width, height;
            this.element.css("width", '100%');
            this.getContentTable().width('100%');
            this.getHeaderTable().width('100%');
            this.getContentTable().css('minWidth', this.model.minWidth);
            if (this._isHeightResponsive) {
                this.getContent().height("100%");
                this.getContent().find(".e-content").height('100%');
            }
            if (this.getBrowserDetails().browser == "msie")
                this.getHeaderTable().css("min-width", this.model.minWidth);
            width = this.element.width();
            var winHeight = $(window).height() - this.element.offset()['top'];
            var rowCount = !ej.isNullOrUndefined(this.getRows()) ? this.getRows().length : 1;
            var isBody = this.element.parent().is($('body')) || this.element.parent().height() == $('body').height() || (["", "auto"].indexOf(this.element.parent()[0].style.height) != -1);
            var originalElemHeight=this.getContentTable()[0].scrollHeight + this._getNoncontentHeight();
            var elemHeight = isBody ? winHeight : this.element.parent().height();
            originalElemHeight += parseInt(this.element.parent().css('margin-top'));
            var isScroller = this.model.minWidth > width || elemHeight <= originalElemHeight;
            this._mediaQueryUpdate(isScroller, elemHeight, width, originalElemHeight)
        },
        _removeMedia: function () {
            $(window).off("resize", this._$onresize);
            this.getContentTable().css("min-width", "");
            this.getHeaderTable().css("min-width", "");
            this.getContentTable().css("width", "");
            this.model.scrollSettings.width = "auto";
            if (this.getContent().data("ejScroller"))
                this.getContent().ejScroller("destroy");
        },
        _getRowHeights: function () {
            var trs = this.getRows(), frotrs = [], movtrs = [];
            if (trs !== null) {
                this._rowHeightCollection = [];
                if (trs[1] !== undefined && trs[1].length && ((this.model.scrollSettings.frozenColumns > 0 && trs[0] !== undefined) || (trs[0] !== undefined && typeof trs[0].item !== "undefined" && typeof trs[0].length == "number" && typeof trs[1].item !== "undefined" && typeof trs[1].length == "number"))) {
                    frotrs = trs[0];
                    movtrs = trs[1];
                    for (var i = 0 ; i < frotrs.length ; i++) {
                        this._rowHeightCollection[i] = frotrs[i].offsetTop >= movtrs[i].offsetTop ? frotrs[i].offsetTop : movtrs[i].offsetTop;
                    }
                }
                else {
                    for (var i = 0 ; i < trs.length ; i++) {
                        this._rowHeightCollection[i] = trs[i].offsetTop;
                    }
                }
            }
            return this._rowHeightCollection;
        },
        _getEmptyTbody: function () {
            var $emptyTd = ej.buildTag('td.emptyrecord', this.localizedLabels.EmptyRecord, {}, { colSpan: (this.model.columns.length- this._hiddenColumns.length)});
            return $(document.createElement("tr")).append($emptyTd);
        },
        _getIndentCol: function () {
            return ej.buildTag("col", "", { width: "30px" });
        },
        _createSortElement: function () {
            return ej.buildTag('span.e-icon', "&nbsp;");
        },
        _createSortNumber: function (number, header) {
            if (header.css("text-align") == "right")
            return ej.buildTag('span.e-number', number, { "color": "white", "font-size": "9px", "text-align": "center", "float": "left" });
            else
            return ej.buildTag('span.e-number', number, { "color": "white", "font-size": "9px", "text-align": "center", "float": "right" });
        },
        _onFocusIn: function (e) {
           var proxy=this;
		   setTimeout(function(){proxy.element.removeClass('e-activefocusout')},0);
        },
        _onFocusOut: function (e) {
            var proxy=this;
            setTimeout(function(){
				proxy.element.addClass('e-activefocusout');
            },0)
        },
        _wireEvents: function () {
            this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", this._clickHandler);
            this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", ".e-gridheader", this._mouseClickHandler);
            if (this.model.enableFocusout) {
                this._on(this.element, "focusout", this._onFocusOut);
                this._on(this.element, "focusin", this._onFocusIn);
            }
            if (ej.gridFeatures.common) {
				this._on(this.element, ($.isFunction($.fn.doubletap) && this.model.enableTouch) ? "doubletap" : "dblclick", ".e-gridcontent > div:first", this._recorddblClickHandler);
                if (this.model.rightClick)
                    this._on(this.element, "contextmenu", this._rightClickHandler);
                this._on(this.element, "click", ".e-gridcontent", this._recordClick);
                this._enableRowHover();
                if (this.model.enableTouch)
                    this._on(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._touchGrid, this));
                else
                    this.element.addClass("e-touch");
                this._on(this.element, "mousedown", ".e-gridheader", this._headerMouseDown);
                if (this.model.allowRowDragAndDrop && this.model.selectionType == "multiple")
                    this._on(this.element, "touchstart mousedown", ".e-gridcontent", this._contentMouseDown);
                this._on(this.element, "mouseover mouseleave", ".e-gridheader:first", this._headerHover);
                this._on(this.element, ej.eventType.mouseMove, ".e-gridheader:first", this._headerHover);
                this.model.allowResizeToFit && this._on(this.element, "dblclick", ".e-gridheader", this._headerdblClickHandler);
                if (this.model.allowResizing) {
                    this._on(this.element, ej.eventType.mouseMove,".e-gridheader:first", this._mouseMove);
                    this._on(this.element, "mouseup", this._mouseUp);
                }
                if (this.model.allowKeyboardNavigation) {
                    this.element[0].tabIndex = this.element[0].tabIndex == -1 ? 0 : this.element[0].tabIndex;
                    this.element[0].accessKey = (!ej.isNullOrUndefined(this.element[0].accessKey) && this.element[0].accessKey != "") ? this.element[0].accessKey : "e";
                    this._on(this.element, "keyup", this._keyDownHandler);
                }
            }
            if (ej.gridFeatures.edit) {
                this._enableEditingEvents();
                this._on(this.element, "click", ".e-gridcontent .e-unboundcelldiv", this._unboundClickHandler);
            }
            if (this.model.allowGrouping) {
                this._enableGroupingEvents();
                this._on(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", this._dropAreaHover);

            }
            this._enableFilterEvents();
        },
        _enableFilterEvents: function () {
            if (this.model.allowMultiSorting || this.model.selectionType == "multiple" || this.model.allowFiltering)
                this._on($(document), "mousedown", this._docClickHandler);
            if (this.model.allowFiltering) {
                var proxy = this, $target;
                this._off(this.element, "keyup", ".e-filterbar input")._on(this.element, "keyup", ".e-filterbar input", this._filterBarHandler);
                this._on(this.element, "focus click", ".e-filterbar", this._filterBarClose);
            }
        },
        _docClickHandler: function (e) {
            var details = !ej.isIOSWebView() && this.getBrowserDetails(), $target = $(e.target);
            if (this._customPop != null && this.element.find(e.target).length == 0)
                this._customPop.hide();
            if (this.model.allowFiltering) {
                if (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel") {
                    if (this._$colType && ($(e.target).find(".e-grid.e-dlgcontainer").length > 1 || $(e.target).find(".e-excelfilter").length > 1))
                        if (details && details.browser == "msie")
                            e.target.tagName != "BODY" && (!this.isExcelFilter ? this._closeFilterDlg() : this._excelFilter.closeXFDialog(e));
                        else
                            !this._isExcelFilter ? this._closeFilterDlg() : this._excelFilter.closeXFDialog(e);
                } else if (!$target.hasClass("e-filtertext") && !$target.hasClass("e-cancel"))
                    this.getFilterBar().find(".e-cancel").addClass("e-hide");
            }

        },
        _mouseClickHandler: function (e) {
            var $temp = $(e.target), $target, $cloneCommonQuery = this.commonQuery.clone(), currentColumn;
            if ($temp.closest(".e-grid").length != 0 && $temp.closest(".e-grid").attr("id") !== this._id) return;
            if (this.getHeaderTable().find('.e-columnheader').not('.e-stackedHeaderRow').css('cursor') == "col-resize")
                return;
            if ($(e.target).is(".e-ascending, .e-descending"))
                $target = $(e.target.parentNode);
            else if ($temp.hasClass('e-groupheadercell'))
                $target = $temp.children("div");
            else
                $target = $(e.target);
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this._isExcelFilter)) {
                $.fx.off = true;
                this._closeFDialog();
                $.fx.off = false;
            }
            this.getHeaderTable().find(".e-columnheader").find(".e-headercellactive").removeClass("e-headercellactive").removeClass("e-active");
            if ($target.hasClass("e-headercelldiv") || $target.hasClass("e-headercell") && $.inArray('column', this.model.selectionSettings.selectionMode) == -1 || (!$target.hasClass("e-togglegroupbutton") && $target.closest(".e-headercelldiv").length && $.inArray($target[0].tagName, ["SELECT", "INPUT", "TEXTAREA"]) == -1)
                || ($target.closest(".e-groupheadercell").length && $(e.target).is(".e-ascending, .e-descending"))) {
                if (!this.model.allowSorting || ej.gridFeatures.sort === undefined)
                    return;
                $target = ($target.hasClass("e-headercelldiv") || $target.closest(".e-groupheadercell").length) ? $target : $target.hasClass("e-headercell") ? $target.find(".e-headercelldiv") : $target.closest(".e-headercelldiv");
                var columnName = $target.attr("ej-mappingname");
                var columnSortDirection = ej.sortOrder.Ascending;
                this._$prevSElementTarget = this._$curSElementTarget;
                this._$curSElementTarget = $target;
                if ($target.find('span').hasClass("e-ascending"))
                    var columnSortDirection = ej.sortOrder.Descending;
                else
                    var columnSortDirection = ej.sortOrder.Ascending;
                if (e["pointerType"] == "touch" && this._customPop != null && !this._customPop.is(":visible") && this._customPop.find(".e-sortdirect").hasClass("e-spanclicked"))
                    this._customPop.show();
                if (e["pointerType"] == "touch" && this._customPop != null && (this._customPop.find(".e-rowselect").is(":visible") || !this._customPop.find(".e-sortdirect").hasClass("e-spanclicked")) && this.model.allowMultiSorting) {
                    var $offset = $target.offset();
                    this._customPop.removeAttr("style");
                    this._customPop.offset({ left: $offset.left, top: $offset.top - this.getHeaderTable().find(".e-columnheader").height() - $target.height() }).find(".e-sortdirect").show().end()
                        .find(".e-rowselect").hide().end().show();
                }
                if (this.model.allowMultiSorting && (e.ctrlKey || this._enableSortMultiTouch))
                    this.multiSortRequest = true;
                if (e.shiftKey && $.inArray(columnName, this.model.groupSettings.groupedColumns) == -1) {
                    this._removeSortedColumnFromCollection(columnName);
                    this.multiSortRequest = true;
                    columnName = null;
                    this.sortColumn(columnName, columnSortDirection);
                }
                if (!ej.isNullOrUndefined(columnName))
                    this.sortColumn(columnName, columnSortDirection);
            } else if ($target.hasClass("e-togglegroupbutton") && this.model.allowGrouping) {
                var field = $target.parent().attr("ej-mappingname");
                $target.hasClass("e-togglegroup") && this.groupColumn(field);
                $target.hasClass("e-toggleungroup") && this.ungroupColumn(field);
            } else if ($target.hasClass("e-filtericon") || $target.hasClass("e-filteredicon") || $target.hasClass('e-responsivefilterColDiv') || $target.parent().hasClass('e-responsivefilterColDiv')) {
                var columnName = $target.parent().find(".e-headercelldiv").attr("ej-mappingname") || $target.attr("ej-mappingname") || $($target.parent()).attr("ej-mappingname");
                this._$prevFieldName = this._$curFieldName, currentColumn = this.getColumnByField(columnName);
                var localXFLabel = { True: this.localizedLabels.True, False: this.localizedLabels.False };
                if (this.model.allowFiltering) {
                    var proxy = this;
                    if (this.model.filterSettings.filterType == "excel" && currentColumn.filterType == "menu" && $.inArray(currentColumn.type, this._menuColTypes) == -1) {
                        this._renderFilters(currentColumn);
                        this._menuColTypes.push(currentColumn.type);
                    }
                    else if (((this.model.filterSettings.filterType == "menu" && currentColumn.filterType == "excel") || (this.model.filterSettings.filterType == "excel" && currentColumn.filterType != "menu")) && $.inArray(currentColumn.type, this._excelColTypes) == -1) {
                        this._renderFilters(currentColumn);
                        this._excelColTypes.push(currentColumn.type);
                    }
                    $.each(this.model.columns, function (indx, col) {
                        if (col.field == columnName) {
                            proxy._$colType = col.type;
                            proxy._$curFieldName = col.field;
                            proxy._$colFormat = col.format;
                            proxy._$filterType = col.filterType;
                            proxy._$colForeignKeyField = col.foreignKeyField ? col.foreignKeyField : col.field;
                            proxy._$colForeignKeyValue = col.foreignKeyValue;
                            proxy._$colDropdownData = col.dataSource;
                        }
                    });
                    if ((this.model.filterSettings.filterType == "menu" && this._$filterType != "excel") || (this.model.filterSettings.filterType == "excel" && this._$filterType == "menu")) {
                        var $id = "#" + this._id + "_" + this._$colType + "Dlg";
                        this._$menuDlgIsOpen = true;
                        if (this._$colType == "string") {
                            if (this._$colForeignKeyValue && this._$colDropdownData)
                                $("#" + this._id + "_acString").ejAutocomplete({ fields: { text: proxy._$colForeignKeyValue, key: proxy._$colForeignKeyField }, dataSource: proxy._$colDropdownData });
                            else
                                $("#" + this._id + "_acString").ejAutocomplete({ fields: { text: proxy._$curFieldName, key: this._getIdField() }, dataSource: this._dataSource() });
                        } else if (this._$colType == "date") {
                            if (this._$colFormat != undefined) {
                                this._$colFormat = this._$colFormat.replace("{0:", "").replace("}", "");
                                $($id).find(".e-datewidget .e-datepicker").ejDatePicker({ dateFormat: this._$colFormat.replace("{0:", "").replace("}", "") });
                            }
                            else
                                $($id).find(".e-datewidget .e-datepicker").ejDatePicker({ dateFormat: ej.preferredCulture(this.model.locale).calendars.standard.patterns.d });
                        }
                        else if (this._$colType == "datetime") {
                            if (this._$colFormat != undefined) {
                                this._$colFormat = this._$colFormat.replace("{0:", "").replace("}", "");
                                $($id).find(".e-datetimewidget input").ejDateTimePicker({ dateFormat: this._$colFormat.replace("{0:", "").replace("}", "") });
                            }
                            this._setFilterFieldValues($id);
                        }
                    }
                    this._mediaStatus = document.documentElement.clientWidth < 768;
                    if (this.model.isResponsive && this._mediaStatus) {
                        var gridObj = this;
                        var $headerDiv = ej.buildTag('div.e-resFilterDialogHeaderDiv');
                        var $titleSapn = ej.buildTag('div.labelRes', '<span>Filter</span>');
                        if ($(".e-filterMenuBtn").length > 0)
                            $(".e-filterMenuBtn").remove();
                        var $dlgBtn = ej.buildTag('div.e-filterMenuBtn');
                        var $inputOk = ej.buildTag('input.e-resposnsiveFilterBtnLeft e-flat e-btnsub');
                        var $inputCancel = ej.buildTag('input.e-resposnsiveFilterBtnRight e-flat e-btncan');

                        $headerDiv.append($titleSapn);
                        $headerDiv.css('width', '100%');
                        var $dlgClone = $($id).css('padding-left', '0px');
                        if ($target.parent().hasClass('e-responsivefilterColDiv') && $target.hasClass('e-filternone')) {
                            proxy._fltrClrHandler();
                            $target.remove();
                            $("#responsiveFilter").css('display', 'block');
                            // this.element.css('display', 'block');
                        }
                        else {
                            this.element.css('display', 'none');
                            setTimeout(function () { $("#responsiveFilter").css('display', 'none'), 0 });
                            if (!this._isExcelFilter && this._$filterType != "excel") {
                                var btnText = this.model.enableResponsiveRow ? 'OK' : 'Filter', clearText = this.model.enableResponsiveRow ? 'Cancel' : 'Clear';
                                $inputOk.ejButton({ text: btnText, type: 'button', click: $.proxy(this._fltrBtnHandler, this) });
                                $inputCancel.ejButton({
                                    text: clearText, type: 'button', click: function () {
                                        if (clearText == 'Clear') {
                                            proxy.element.css('display', 'block');
                                            proxy._fltrClrHandler();
                                        }
                                        $($id).css('display', 'none');
                                        if ($inputCancel.hasClass("e-resposnsiveFilterBtnRight"))
                                            proxy.element.css('display', 'block');
                                    }
                                });
                                if ($target.parent().hasClass('e-responsivefilterColDiv') && $target.hasClass('e-filternone')) {
                                    proxy._fltrClrHandler();
                                    $target.remove();
                                }
                                else {
                                    $dlgClone.addClass('e-resMenuFltr');
                                    $dlgClone.css('height', $(window).height() - 1).css('width', $(window).width() - 2);
                                    $dlgClone.find('.e-operator').addClass('e-resFilterOperator');
                                    $dlgClone.find('.e-value').addClass('e-resFilterOperator');
                                    var $btnContainer = $dlgClone.find('.e-dlgBtns').remove().addClass('e-filterMenuBtn');
                                    $dlgClone.append($dlgBtn.append($inputOk).append($inputCancel));
                                    if (ej.isNullOrUndefined($dlgClone.find('.e-resFilterDialogHeaderDiv')[0])) {
                                        $dlgClone.insertAfter(this.element);
                                        var $backIcon = ej.buildTag('div.e-resFilterleftIcon', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' });
                                        var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responisveBack', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' })
                                        $backIcon.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            if (gridObj.model.enableResponsiveRow)
                                                $("#responsiveFilter").css('display', 'block');
                                            else
                                                gridObj.element.css('display', 'block');
                                        })
                                        $headerDiv.append($backIcon.append($spanIcon));
                                        var $closeIcon = ej.buildTag('div.e-resFIlterRigthIcon', '', {}, { closeDialogue: $id.slice(1), gridEle: true });
                                        var $closeSpan = ej.buildTag('span.e-icon e-resIcon e-responisveClose', '', {}, { closeDialogue: $id.slice(1), gridEle: true })
                                        $closeIcon.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            gridObj.element.css('display', 'block');
                                        });
                                        var $ejWid = $($dlgClone.find('.e-value').find('input:last'));
                                        if (proxy._$colType == 'string') {
                                            var model = $($dlgClone.find('.e-value').find('input:last')).ejAutocomplete('model');
                                            $ejWid.ejAutocomplete('destroy').ejAutocomplete({
                                                enableDistinct: true, dataSource: model.dataSource, fields: model.fields, width: model.width, focusIn: function (args) {
                                                    var $dropdown = this.element.closest(".e-filterDialog").find(".e-dropdownlist");
                                                    this.model.filterType = $dropdown.val();
                                                }
                                            });
                                        }
                                        $headerDiv.append($closeIcon.append($closeSpan));
                                        $dlgClone.prepend($headerDiv);
                                    }
                                    $dlgClone.find('.e-responsiveLabelDiv').remove();
                                    var $label = ej.buildTag('div.e-responsiveLabelDiv', '', { 'margin-left': '5%', 'font-size': '17px', 'margin-top': '5%' }).append(ej.buildTag('span', this.getHeaderTextByFieldName(columnName), { 'font-weight': 'bold' }));
                                    $label.insertAfter($dlgClone.find('.e-resFilterDialogHeaderDiv'));
                                    $dlgClone.fadeIn(100, function () {
                                    });
                                }
                            }
                            else {
                                this._excelDlg = $id = "#" + this._id + this._$colType + "_excelDlg";
                                if (ej.isNullOrUndefined($dlgClone.find('.e-resFilterDialogHeaderDiv')[0])) {
                                    $inputOk.ejButton({
                                        text: 'OK', type: 'button', click: function (sender) {
                                            gridObj._responsiveFilterClose();
                                            gridObj._excelFilter._openedFltr = $(gridObj._excelDlg);
                                            gridObj._excelFilter._fltrBtnHandler();
                                            gridObj._setResponsiveFilterIcon();
                                        }
                                    });
                                    $inputCancel.ejButton({ text: 'Cancel', type: 'button', click: function () { $($id).css('display', 'none'); proxy.element.css('display', 'block') } });
                                    $($id).children().not('.e-searchcontainer').remove();
                                    var excelObj = this._excelFilter;
                                    var $backIcon = ej.buildTag('div.e-resFilterleftIcon', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' });
                                    var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responisveBack', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' })
                                    $backIcon.click(function (e) {
                                        $.proxy(gridObj._closeDivIcon(e), this);
                                    })
                                    $headerDiv.append($backIcon.append($spanIcon));
                                    var $closeIcon = ej.buildTag('div.e-resFIlterRigthIcon', '', {}, { closeDialogue: $id.slice(1), gridEle: true });
                                    var $closeSpan = ej.buildTag('span.e-icon e-resIcon e-responisveCustomFilter', '', {}, { closeDialogue: $id.slice(1), gridEle: true })
                                    $closeIcon.click(function (e) {
                                        $.proxy(gridObj._closeDivIcon(e), this);
                                    })
                                    if (proxy._$colType != 'boolean')
                                        $headerDiv.append($closeIcon.append($closeSpan));
                                    $($id).css('padding', '0px');
                                    var $searchContainer = $($id).css('height', $(window).height() - 2);
                                    $searchContainer.css('width', $(window).width() - 2);
                                    var $searchBox = $searchContainer.find('.e-searchcontainer .e-searchbox').css('margin-top', '10px');
                                    $searchBox.children().css('margin-top', '10px');
                                    var $checkBoxDiv = $searchContainer.find('.e-checkboxlist');
                                    var scrolWidth = $(window).width() * (97 / 100), scrollHeight = $(window).height() * (65 / 100);
                                    $($searchContainer.find('.e-searchcontainer')).addClass('e-resSearch');
                                    var $btn = $searchContainer.find('.e-resSearch .e-btncontainer').remove();
                                    $btn.find('input:first').css('width', '45.6%');
                                    $btn.find('input:first').addClass('e-resposnsiveFilterBtnLeft');
                                    $btn.find('input:last').addClass('e-resposnsiveFilterBtnRight');
                                    $searchContainer.find('.e-excelLabel').remove();
                                    var $labelDiv = ej.buildTag('div.e-excelLabel', 'Order Id', { 'font-weight': 'bold', 'margin-top': '10px' });
                                    var $searchBox = $searchContainer.find('.e-searchcontainer');
                                    $labelDiv.insertAfter($searchContainer.find('.e-searchcontainer .e-searchbox'));
                                    $searchContainer.prepend($headerDiv);
                                    $($id).append($dlgBtn.append($inputOk).append($inputCancel))
                                    $checkBoxDiv.ejScroller({ height: scrollHeight, width: scrolWidth }).ejScroller('refresh');
                                }
                                this._excelFilter.openXFDialog({ field: columnName, enableResponsiveRow: true, displayName: currentColumn.headerText, dataSource: this._dataSource(), query: $cloneCommonQuery, position: { X: xPos, Y: yPos }, dimension: { height: $(window).height(), width: $(window).width() }, cssClass: "resFilter", type: this._$colType, format: this._$colFormat, localizedStrings: localXFLabel });
                                $($id).insertAfter(this.element);
                                !ej.isNullOrUndefined($($id).parents('.e-grid')[0]) && $($id).remove();
                                $closeIcon.click(function (e) {
                                    $(gridObj._excelDlg).css('display', 'none');
                                    var height = $(window).height() - 5, width = $(window).width();
                                    excelObj._openCustomFilter('equal');
                                    var $dlgClone = $id = $("#" + gridObj._id + gridObj._$colType + "_CustomFDlg").addClass('e-responsviesExcelFilter');
                                    if (ej.isNullOrUndefined($dlgClone.find('.e-resFilterDialogHeaderDiv')[0])) {
                                        var $headerDivCustom = ej.buildTag('div.e-resFilterDialogHeaderDiv');
                                        var $titleSapn = ej.buildTag('div.labelRes', '<span>Custom Filter</span>');
                                        $headerDivCustom.append($titleSapn);
                                        var $backIcon = ej.buildTag('div.e-resFilterleftIcon', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", openDialogue: gridObj._excelDlg.slice(1) });
                                        var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responisveBack', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", openDialogue: gridObj._excelDlg.slice(1) })
                                        $backIcon.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            if (gridObj.model.enableResponsiveRow)
                                                $("#responsiveFilter").css('display', 'block');
                                            else
                                                gridObj.element.css('display', 'block');
                                        });
                                        $headerDivCustom.append($backIcon.append($spanIcon));
                                        var $closeIconCust = ej.buildTag('div.e-resFIlterRigthIcon', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", gridEle: true });
                                        var $closeSpan = ej.buildTag('span.e-icon e-resIcon e-responisveClose', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", gridEle: true })
                                        $headerDivCustom.append($closeIconCust.append($closeSpan));
                                        $closeIconCust.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            gridObj.element.css('display', 'block');
                                        })
                                        $dlgClone.prepend($headerDivCustom);
                                        $dlgClone.insertAfter(gridObj.element);
                                        $dlgClone.find('.e-dlgfields').css('width', '100%');
                                        var $firstDiv = $dlgClone.find('.e-dlgfields:first').css('width', '92%').css('margin-left', '6%');
                                        $firstDiv.css('margin-top', '4%');
                                        var colName = $dlgClone.find('.e-dlgfields').find('.e-fieldset legend').text();
                                        var $labelDiv = ej.buildTag('div.e-responsiveLabelDiv', colName, { 'margin-left': '6%' });
                                        $labelDiv.insertAfter($firstDiv);
                                        var $fieldSet = $dlgClone.find('.e-dlgfields').find('.e-fieldset').find('table').css('width', '61%');
                                        $dlgClone.find('.e-dlgfields').find('.e-fieldset').replaceWith($fieldSet);
                                        var $fieldDiv = $fieldSet.parent('div').addClass('e-responsiveExcelFilterFieldDiv');
                                        var $ddl = $fieldSet.find('.e-dropdownlist')
                                        $fieldSet.find('.e-dropdownlist').each(function (index, object) {
                                            var ds = $(object).ejDropDownList('model.dataSource');
                                            var wid = $(window).width() * (40 / 100);
                                            $(object).ejDropDownList('destroy').ejDropDownList({ width: wid, popupWidth: wid + "px", dataSource: ds });
                                        });
                                        $fieldSet.find('.e-autocomplete').each(function (index, object) {
                                            var model = $(object).ejAutocomplete('model.dataSource');
                                            var wid = $(window).width() * (40 / 100);
                                            $(object).ejAutocomplete('destroy').ejAutocomplete({ width: wid, dataSource: model.dataSource, fields: model.fields });
                                        });
                                        $fieldSet.find('.e-datepicker').each(function (index, object) {
                                            var ds = $(object).ejDatePicker('model.dataSource');
                                            var wid = $(window).width() * (40 / 100);
                                            $(object).ejDatePicker('destroy').ejDatePicker({ width: wid });
                                        });
                                        var $okClone = $inputOk.clone(), $cancelClone = $inputCancel.clone();
                                        $okClone.ejButton({
                                            text: 'OK', type: 'button', click: function (sender) {
                                                gridObj._excelFilter._openedFltr = $dlgClone;
                                                gridObj._excelFilter._fltrBtnHandler();
                                                if ($dlgClone.hasClass('e-dlgcustom'))
                                                    $dlgClone.ejDialog('close');
                                                gridObj._setResponsiveFilterIcon();
                                                gridObj.element.css('display', 'block');
                                            }
                                        });
                                        $cancelClone.ejButton({ text: 'Cancel', type: 'button', click: function () { $dlgClone.ejDialog('close'); proxy.element.css('display', 'block') } });
                                        $dlgClone.append($dlgBtn.clone().append($okClone).append($cancelClone))
                                        var $btnContainer = $dlgClone.find('.e-dlgfields .e-btncontainer').remove();
                                        $btnContainer.find('input:first').addClass('e-resposnsiveFilterBtnLeft');
                                        $btnContainer.find('input:first').css('width', '45.6%')
                                        $btnContainer.find('input:last').addClass('e-resposnsiveFilterBtnRight');
                                    }
                                    gridObj.element.css('display', 'none');
                                    $dlgClone.ejDialog({ enableModal: false, height: height, width: width, position: { X: 0, Y: 0 }, enableResize: false, showHeader: false }).ejDialog('open');
                                })
                                var $searchdiv = ej.buildTag('div');
                            }
                        }
                    }
                    else {
                        if ($($id).hasClass("e-resMenuFltr")) {
                            $($id).remove();
                            this._renderFilterDialogs();
                            $id = "#" + this._id + "_" + this._$colType + "Dlg";
                        }
                        $($id).ejDialog({ position: { X: "", Y: "" } });
                        var docWidth = $(document).width(), dlgWidth = document.documentElement.clientWidth < 800 ? 200 : 250, xPos = $target.position().left + 18 , yPos = $target.position().top + 2, gridwidth = $("#" + this._id).width();
                        if ($target.closest(".e-headercell").css("position") == "relative")
                            xPos = $target.offset().left + 15, yPos = $target.offset().top + 20;
                        var filterDlgLargeCss = "e-filterdialoglarge";
                        dlgWidth = this._isExcelFilter && currentColumn.filterType != "menu" && !ej.isNullOrUndefined(this._excelFilter._dialogContainer) ? this._excelFilter._dialogContainer.width() : dlgWidth;
                        var rightPosWidth = (this.element.offset().left + this.element.width()) - $target.offset().left, rightWidth = dlgWidth - rightPosWidth;
                        var leftPosWidth = $target.offset().left - this.element.offset().left, leftWidth = dlgWidth - leftPosWidth;
                        if ($target.offset().left + 18 + dlgWidth > gridwidth && rightWidth > leftWidth)
                            xPos = xPos - dlgWidth;
                        if (dlgWidth == 200)
                            filterDlgLargeCss = "";
                        if (!ej.isNullOrUndefined(this._$colType)) {
                            if ((this.model.filterSettings.filterType == "menu" && this._$filterType != "excel") || (this.model.filterSettings.filterType == "excel" && this._$filterType == "menu")) {
                                xPos = xPos - $("#" + this._id).offset().left, yPos = yPos - $("#" + this._id).offset().top;
                                $($id).ejDialog({ position: { X: xPos, Y: yPos }, width: dlgWidth, cssClass: filterDlgLargeCss })
                                .ejDialog("open");
                            }
                            else
                                this._excelFilter.openXFDialog({ field: columnName, displayName: currentColumn.headerText, dataSource: this._dataSource(), query: $cloneCommonQuery, position: { X: xPos, Y: yPos }, type: this._$colType, format: currentColumn.format, foreignKey: currentColumn.foreignKeyField, foreignKeyType: currentColumn.originalType, foreignKeyValue: currentColumn.foreignKeyValue, foreignDataSource: currentColumn.dataSource, localizedStrings: localXFLabel });
                        }
                    }
                    this._setFilterFieldValues($id);
                    if (this._$colType == "number" && currentColumn["serverType"] != undefined)
                        $($id).find(".e-numerictextbox").ejNumericTextbox({ width: "100%",decimalPlaces: 0 });
                    else if(this._$colType == "number")
                        $($id).find(".e-numerictextbox").ejNumericTextbox({ width: "100%",decimalPlaces: 2 });
                    this._$prevColType = this._$colType;
                    this._$fDlgIsOpen = true;
                }
            }
        },
        _responsiveFilterClose: function () {
            this.element.css('display', 'block');
        },
        _clickHandler: function (e) {
            var $target = $(e.target),tempChooser = $("[id$='ccDiv'].e-grid.e-columnChooser"),fieldName, $form = $("#" + this._id + "EditForm"), index, columnIndex, rowIndex;
			if(tempChooser.length) {
                var  flag = true;
                for(var i = 0; i < tempChooser.length; i++){
                    if($target.parents(".e-ccButton").length|| $target.hasClass('e-ccButton')) flag = $(e.target).closest(".e-grid").attr("id")+"ccDiv" != tempChooser[i].id;
                    var obj = $("#"+tempChooser[i].id).ejDialog("instance");
                    if(obj.isOpened() && flag) {
                        obj.close();
                        $(".e-columnChoosertail").remove();
                        $(".e-columnChoosertailAlt").remove();
                    }
                }
            }
            if ($target.hasClass("e-button") && ($target.hasClass("e-disable") || $target.prop("disabled"))) return;
            if ($target.closest(".e-grid").attr("id") !== this._id) return;
            if ($target.closest("#" + this._id + "EditForm").length)
                return;
            if ($target.hasClass("e-rowcell") || $target.closest("td").is(".e-rowcell") || ($target.hasClass("e-headercell") && ((e.clientY - $target.offset().top) < ($target.height() / 4))) || $target.parents(".e-headercheckcelldiv").length) {
                if (this._bulkEditCellDetails.cancelSave) {
                    this._bulkEditCellDetails.cancelSave = false;
                    return;
                }
                if (this.model.editSettings.editMode == "batch" && ($.isFunction($.validator) && $form.length && $form.validate().errorList.length > 0))
                    return;
                index = $target.closest("tr").hasClass("e-insertedrow") ? this.model.groupSettings.groupedColumns.length : 0;
                var tempIndex = $target.closest(".e-rowcell").index() != -1 ? $target.closest(".e-rowcell").index() : $target.closest(".e-headercell").index() - this.model.groupSettings.groupedColumns.length;
                columnIndex = $target.hasClass("e-rowcell") ? $target.index() - index : tempIndex - index;
                columnIndex = (this.model.detailsTemplate != null || this.model.childGrid != null) ? columnIndex - 1 : columnIndex;
                if (this.model.scrollSettings.frozenColumns && ($target.closest(".e-movableheaderdiv").length || $target.closest(".e-movablecontentdiv").length))
                    columnIndex = columnIndex + this.model.scrollSettings.frozenColumns;
                rowIndex = this.getIndexByRow($target.closest("tr"));
                this._bulkEditCellDetails.columnIndex = columnIndex;
                this._bulkEditCellDetails.rowIndex = rowIndex;
                if (this.model.allowSelection && ej.gridFeatures.selection) {
                    var checkBoxSelection = this._enableCheckSelect && $target.parent(".e-checkcelldiv").length ? true : false;
                    if ($target.hasClass("e-checkselectall")) {
                        this._selectAllCheck = true;
                        var toCheckIndex =this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling ? this._gridRecordsCount:this.model.allowPaging ? this.model.currentViewData.length : this._gridRows.length;
                        this.selectRows(0, toCheckIndex - 1, $target);
                    }
                    if (this.model.selectionType == "multiple") {
                        if (e.ctrlKey || this._enableSelectMultiTouch) {
                            this.multiSelectCtrlRequest = true;
                        }
                        if (e.shiftKey) {
                            this.multiSelectShiftRequest = true;
                            if (this._allowcellSelection && rowIndex > -1)
                                this.selectCells([[rowIndex, [columnIndex]]]);
                            if (this._allowrowSelection && rowIndex > -1 && (!this._enableCheckSelect || checkBoxSelection))
                                this.selectRows(this._previousIndex, this.getIndexByRow($target.closest('tr')), $target);
                                this._selectedRow(this.getIndexByRow($target.closest('tr')));
                            if (this._allowcolumnSelection && $target.hasClass("e-headercell") && !$target.hasClass("e-stackedHeaderCell") && ((e.clientY - $target.offset().top) < ($target.height() / 4)))
                                this.selectColumns(this._previousColumnIndex, columnIndex);
                        }
                        if (e["pointerType"] == "touch" && this._customPop != null && !this._customPop.is(":visible") && this._customPop.find(".e-rowselect").hasClass("e-spanclicked") && this.model.selectionSettings.selectionMode == "row")
                            this._customPop.show();
                        if (e["pointerType"] == "touch" && this._customPop != null && (this._customPop.find(".e-sortdirect").is(":visible") || !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) && this.model.selectionType == "multiple") {
                            this._customPop.removeAttr("style");
                            var offset = $target.offset();
                            this._customPop.offset({ top: 0, left: 0 }).offset({ left: offset.left, top: offset.top - this.getRowHeight() - $target.height() }).find(".e-sortdirect").hide().end()
                                .find(".e-rowselect").show().end().show();
                        }
                    }
                    if (!this.multiSelectShiftRequest) {
                        if (this._allowcellSelection && rowIndex > -1) {
                            var cellProto = this._checkCellSelectionByRow(rowIndex, columnIndex);
                            if ((this.model.selectionSettings.enableToggle && this.selectedRowCellIndexes.length == 1 && this.selectedRowCellIndexes[0].cellIndex.length==1 || (e.ctrlKey && this.model.selectionType == 'multiple')) && (cellProto != -1 && this.selectedRowCellIndexes.length > 0 && this.selectedRowCellIndexes[0].cellIndex.length > 0))
                                this.clearCellSelection(cellProto.rowIndex, columnIndex);
                            else
                                this.selectCells([[rowIndex, [columnIndex]]]);
                        }
                        if (this._allowrowSelection && rowIndex > -1) {
                            var selectedIndex = this.getIndexByRow($target.closest('tr'));
                            if (this._enableCheckSelect)
                                this.multiSelectCtrlRequest = true;
							if(this.model.scrollSettings.enableVirtualization){
								var remain = rowIndex % this._virtualRowCount, viewIndex;							
								viewIndex = parseInt($($target).closest("tr").attr("name"), 32);																												
								selectedIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);	
							}
                            if (!this._enableCheckSelect || checkBoxSelection) {
							    if (this.model.selectionSettings.enableToggle && !this._enableCheckSelect && this.getSelectedRecords().length == 1 && $.inArray(this.getIndexByRow($target.closest('tr')), this.selectedRowsIndexes) != -1)
							        this.clearSelection(selectedIndex);
							    else
							        this.selectRows(this.getIndexByRow($target.closest('tr')), null, $target);
							}
                            if(this._enableCheckSelect && !(e.ctrlKey || this._enableSelectMultiTouch))
                                this.multiSelectCtrlRequest = false;
                        }
                        if (this._allowcolumnSelection && $target.hasClass("e-headercell") && !$target.hasClass("e-stackedHeaderCell") && ((e.clientY - $target.offset().top) < ($target.height() / 4))) {
                            if (this.model.selectionSettings.enableToggle && this.selectedColumnIndexes.length == 1 && $.inArray(columnIndex, this.selectedColumnIndexes) != -1)
                                this.clearColumnSelection(columnIndex);
                            else
                                this.selectColumns(columnIndex);
                        }
                        this.multiSelectCtrlRequest = false;
                    }
                    this.multiSelectShiftRequest = false;
                }

                fieldName = this._bulkEditCellDetails.columnIndex >= 0 ? this.model.columns[this._bulkEditCellDetails.columnIndex]["field"] : null;
                if ($target.closest(".e-rowcell").length && !ej.isNullOrUndefined(fieldName)) {
                    this._tabKey = false;
                    this.model.editSettings.allowEditing && this.model.editSettings.editMode == ej.Grid.EditMode.Batch && this.editCell($.inArray($target.closest("tr").get(0), this._excludeDetailRows()), fieldName);
                }
            }
            if ($target.hasClass("e-rowselect") || $target.hasClass("e-sortdirect")) {
                if (!$target.hasClass("e-spanclicked")) {
                    $target.addClass("e-spanclicked");
                    if ($target.hasClass("e-rowselect"))
                        this._enableSelectMultiTouch = true;
                    if ($target.hasClass("e-sortdirect"))
                        this._enableSortMultiTouch = true;
                } else {
                    $target.removeClass("e-spanclicked");
                    if ($target.hasClass("e-rowselect"))
                        this._enableSelectMultiTouch = false;
                    if ($target.hasClass("e-sortdirect"))
                        this._enableSortMultiTouch = false;
                    this._customPop.hide();
                }
            }
            this._selectAllCheck = false;
            if (ej.gridFeatures.common) {
                this.expandCollapse($target);
            }
            if ($target.is(".e-filtericon") && $target.closest(".e-detailrow").length != 0)
                e.preventDefault();
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this._isExcelFilter) && !$target.is(".e-filtericon") && $target.closest(".e-dlgcontainer").length != 1)
                this._closeFDialog();
            if (this.model.allowSearching && this._searchBar != null) {
                if ($target.is(this._searchBar.find(".e-cancel")))
                    this._searchBar.find("input").val("");
                else {
                    if (e.target.id == this._id + "_searchbar")
                        this._searchBar.find(".e-cancel").removeClass("e-hide");
                    else if (!this._searchBar.find(".e-cancel").hasClass("e-hide"))
                        this._searchBar.find(".e-cancel").addClass("e-hide");
                }
            }
        },
        _checkCellSelectionByRow: function (rowIndex, columnIndex) {
            for (var i = 0; i < this.selectedRowCellIndexes.length; i++) {
                if (this.selectedRowCellIndexes[i].rowIndex == rowIndex)
                    break;
            }
            if (i != this.selectedRowCellIndexes.length && $.inArray(columnIndex, this.selectedRowCellIndexes[i].cellIndex) != -1)
                return this.selectedRowCellIndexes[i];
            return -1;
        },
        _persistState: function (customModel) {
           if (this.model.enablePersistence && this._isHeightResponsive)
                customModel._isHeightResponsive = this._isHeightResponsive;
         },
        _restoreState: function (customModel) {
           if (this.model.enablePersistence && customModel._isHeightResponsive)
                this._isHeightResponsive = customModel._isHeightResponsive;
         },  
        _destroy: function () {
            /// <summary>This function is  used to destroy the Grid Object</summary>
            this.element.off();
            this.element.find(".e-gridheader").find(".e-headercontent,.e-movableheader")
                .add(this.element.find(".e-gridcontent").find(".e-content,.e-movablecontent")).off('scroll');
            var editForm = $("#" + this._id + "EditForm");
            if (editForm.length) {
                var $formEle = editForm.find('.e-field'), $element;
                for (var i = 0; i < $formEle.length; i++) {
                    $element = $($formEle[i]);
                    if ($element.hasClass('e-datetimepicker'))
                        $element.ejDateTimePicker("destroy");
                    else if ($element.hasClass('e-datepicker'))
                        $element.ejDatePicker("destroy");
                    else if ($element.hasClass('e-dropdownlist'))
                        $element.ejDropDownList("destroy");
                }
                editForm.remove();
            }
            if (this._confirmDialog)
                this._confirmDialog.ejDialog("destroy");
            this.element.find('.e-dropdownlist').ejDropDownList('model.dataSource', []);
            if (this.model.showColumnChooser) {
                $("#" + this._id + "ccDiv").ejDialog("destroy");
                $("#" + this._id + "ccDiv").remove();
                $("#" + this._id + "_ccTail").remove();
                $("#" + this._id + "_ccTailAlt").remove();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "excel")
                this._excelFilter.resetExcelFilter()
            if (this.model.allowReordering)
                $(".e-columndropindicator").remove();
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "menu") {
                var proxy = this, $colType;
                $.each(this.model.columns, function (indx, col) {
                    $colType = col.type;
                    $("#" + proxy._id + $colType + "_ddinput_popup_wrapper").remove();
                    if ($colType == "string")
                        $("#" + proxy._id + "_stringDlg").find('.e-autocomplete').ejAutocomplete("destroy");
                    else if ($colType == "date")
                        $("#" + proxy._id + "_dateDlg").find('.e-datepicker').ejDatePicker("destroy");
                    else if ($colType == "datetime")
                        $("#" + proxy._id + "_datetimeDlg").find('.e-datetimepicker').ejDateTimePicker("destroy");
                    else if ($colType == "number")
                        $("#" + proxy._id + "_numberDlg").find('.e-numerictextbox').ejNumericTextbox("destroy");
                });
            }
            if (this._$onresize)
                $(window).off("resize", this._$onresize);
            this.element.empty().removeClass("e-grid " + this.model.cssClass);
            this.element.ejWaitingPopup("destroy");
            if (this.model.contextMenuSettings.enableContextMenu) {
                $("#" + this._id + "_Context").ejMenu('destroy');
                $("#" + this._id + "_Context").remove();
            }
        },
        _getDeprecatedLocalizedLabel: function (key) {
            if (["OkButton", "OKButton"].indexOf(key) != -1)
                return this.localizedLabels.OkButton || this.localizedLabels.OKButton;
        },
        _getLocalizedLabels: function (property) {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
    });
    if (ej.gridFeatures.common)
        $.extend(ej.Grid.prototype, ej.gridFeatures.common);
    if (ej.gridFeatures.edit)
        $.extend(ej.Grid.prototype, ej.gridFeatures.edit);
    if (ej.gridFeatures.filter)
        $.extend(ej.Grid.prototype, ej.gridFeatures.filter);
    if (ej.gridFeatures.group)
        $.extend(ej.Grid.prototype, ej.gridFeatures.group);
    if (ej.gridFeatures.selection)
        $.extend(ej.Grid.prototype, ej.gridFeatures.selection);
    if (ej.gridFeatures.sort)
        $.extend(ej.Grid.prototype, ej.gridFeatures.sort);
    if (ej.gridFeatures.dragAndDrop)
        $.extend(ej.Grid.prototype, ej.gridFeatures.dragAndDrop);

    ej.Grid.Locale = ej.Grid.Locale || {};

    ej.Grid.Locale["default"] = ej.Grid.Locale["en-US"] = {
        EmptyRecord: "No records to display",
        GroupDropArea: "Drag a column header here to group its column",
        DeleteOperationAlert: "No records selected for delete operation",
        EditOperationAlert: "No records selected for edit operation",
        SaveButton: "Save",
        OKButton: "OK",
        CancelButton: "Cancel",
        EditFormTitle: "Details of ",
        AddFormTitle: "Add New Record",
        GroupCaptionFormat: "{{:headerText}}: {{:key}} - {{:count}} {{if count == 1 }} item {{else}} items {{/if}} ",
        BatchSaveConfirm: "Are you sure you want to save changes?",
        BatchSaveLostChanges: "Unsaved changes will be lost. Are you sure you want to continue?",
        ConfirmDelete: "Are you sure you want to Delete Record?",
        CancelEdit: "Are you sure you want to Cancel the changes?",
        PagerInfo: "{0} of {1} pages ({2} items)",
        FrozenColumnsViewAlert: "Frozen columns should be in grid view area",
        FrozenColumnsScrollAlert: "Enable allowScrolling while using frozen Columns",
        FrozenNotSupportedException: "Frozen Columns and Rows are not supported for Grouping, Row Template, Detail Template, Hierarchy Grid and Batch Editing",
        Add: "Add",
        Edit: "Edit",
        Delete: "Delete",
        Update: "Update",
        Cancel: "Cancel",
        Done: "Done",
        Columns: "Columns",
        SelectAll: "(Select All)",
        PrintGrid: "Print",
        ExcelExport: "Excel Export",
        WordExport: "Word Export",
        PdfExport: "PDF Export",
        StringMenuOptions: [{ text: "StartsWith", value: "StartsWith" }, { text: "EndsWith", value: "EndsWith" }, { text: "Contains", value: "Contains" }, { text: "Equal", value: "Equal" }, { text: "NotEqual", value: "NotEqual" }],
        NumberMenuOptions: [{ text: "LessThan", value: "LessThan" }, { text: "GreaterThan", value: "GreaterThan" }, { text: "LessThanOrEqual", value: "LessThanOrEqual" }, { text: "GreaterThanOrEqual", value: "GreaterThanOrEqual" }, { text: "Equal", value: "Equal" }, { text: "NotEqual", value: "NotEqual" }],
        PredicateAnd: "AND",
        PredicateOr: "OR",
        Filter: "Filter",
        FilterMenuCaption: "Filter Value",
        FilterbarTitle: "'s filter bar cell",
        MatchCase: "Match Case",
        Clear: "Clear",
        ResponsiveFilter: "Filter",
        ResponsiveSorting: "Sort",
        Search: "Search",
        DatePickerWaterMark: "Select date",
        NumericTextBoxWaterMark: "Enter value",
        EmptyDataSource: "DataSource must not be empty at initial load since columns are generated from dataSource in AutoGenerate Column Grid",
        ForeignKeyAlert: "The updated value should be a valid foreign key value",
        True: "true",
        False: "false",
        UnGroup: "Click here to ungroup",
        AddRecord: "Add Record",
        EditRecord: "Edit Record",
        DeleteRecord: "Delete Record",
        Save: "Save",
        Grouping: "Group",
        Ungrouping: "Ungroup",
        SortInAscendingOrder: "Sort In Ascending Order",
        SortInDescendingOrder: "Sort In Descending Order",
        NextPage: "Next Page",
        PreviousPage: "Previous Page",
        FirstPage: "First Page",
        LastPage: "Last Page",
        EmptyRowValidationMessage:"Atleast one field must be updated",
		NoResult: "No Matches Found"
    };
    ej.Grid.Actions = {
        /** Used to specify paging action in grid   */
        Paging: "paging",
        /** Used to specify sorting action in grid   */
        Sorting: "sorting",
        /** Used to specify filtering action in grid   */
        Filtering: "filtering",
        /** Used to specify begin edit action in grid   */
        BeginEdit: "beginedit",
        /** Used to specify saving action in grid   */
        Save: "save",
        /** Used to specify adding action in grid   */
        Add: "add",
        /** Used to specify deleting action in grid   */
        Delete: "delete",
        /** Used to specify cancelling action in grid   */
        Cancel: "cancel",
        /** Used to specify grouping action in grid   */
        Grouping: "grouping",
        /** Used to specify un-grouping action in grid   */
        Ungrouping: "ungrouping",
        /** Used to specify refresh action in grid   */
        Refresh: "refresh",
        /** Used to specify reordering action in grid   */
        Reorder: "reorder",
        /** Used to specify searching action in grid   */
        Search: "searching",
        /** Used to specify batch save action in grid   */
        BatchSave: "batchsave",
        /** Used to specify virtual scroll action in grid   */
        VirtualScroll: "virtualscroll"
    };

    ej.Grid.SummaryType = {
        /**  Creates grid with summary type as Average */
        Average: "average",
        /**  Creates grid with summary type as Minimum */
        Minimum: "minimum",
        /**  Creates grid with summary type as Maximum */
        Maximum: "maximum",
        /**  Creates grid with summary type as Count */
        Count: "count",
        /**  Creates grid with summary type as Sum */
        Sum: "sum",
        /**  Creates grid with summary type as TrueCount */
        TrueCount: "truecount",
        /**  Creates grid with summary type as FalseCount */
        FalseCount: "falsecount",
        /**  Creates grid with summary type as Custom */
        Custom: "custom"
    };

    ej.Grid.EditMode = {
        /**  Creates grid with editMode as Normal */
        Normal: "normal",
        /**  Creates grid with editMode as Dialog */
        Dialog: "dialog",
        /**  Creates grid with editMode as DialogTemplate */
        DialogTemplate: "dialogtemplate",
        /**  Creates grid with editMode as Batch */
        Batch: "batch",
        /**  Creates grid with editMode as ExternalForm */
        ExternalForm: "externalform",
        /**  Creates grid with editMode as ExternalFormTemplate */
        ExternalFormTemplate: "externalformtemplate",
        /**  Creates grid with editMode as InlineForm */
        InlineForm: "inlineform",
        /**  Creates grid with editMode as InlineTemplateForm */
        InlineTemplateForm: "inlineformtemplate"
    };

    ej.Grid.PrintMode = {
        /**  print all pages in grid */
        AllPages: "allpages",
        /**   print current pages in grid */
        CurrentPage: "currentpage",
    };
    ej.Grid.ResizeMode = {
        NextColumn: 'nextcolumn',
        Control: 'control',
        Normal: 'normal'
    };
    ej.Grid.Rowposition = {
        /** Add new row in the top of the grid */
        Top: "top",
        /** Add new row in the bottom of the grid */
        Bottom: "bottom",
    };

    ej.Grid.FormPosition = {
        /**  Creates grid with formPosition as BottomLeft */
        BottomLeft: "bottomleft",
        /**  Creates grid with formPosition as TopRight */
        TopRight: "topright"
    };

    ej.Grid.ClipMode = {
        /** Render an ellipsis ("...") to represent clipped text **/
        Ellipsis: "ellipsis",
        /** Clips the text **/
        Clip: "clip",
        /** Render an ellipsis ("...") to represent clipped text and tooltip would be shown **/
        EllipsisWithTooltip: "ellipsiswithtooltip"
    };

    ej.Grid.EditingType = {
        /**  Allows to set edit type as string edit type */
        String: "stringedit",
        /**  Allows to set edit type as boolean edit type */
        Boolean: "booleanedit",
        /**  Allows to set edit type as numeric edit type */
        Numeric: "numericedit",
        /**  Allows to set edit type as drop down edit type */
        Dropdown: "dropdownedit",
        /**  Allows to set edit type as date picker edit type */
        DatePicker: "datepicker",
        /**  Allows to set edit type as date time picker edit type */
        DateTimePicker: "datetimepicker",
    };

    ej.Grid.UnboundType = {
        /** Used to specify unbound type as Edit   */
        Edit: "edit",
        /** Used to specify unbound type as Save   */
        Save: "save",
        /** Used to specify unbound type as Delete   */
        Delete: "delete",
        /** Used to specify unbound type as Cancel   */
        Cancel: "cancel"
    };

    ej.Grid.ToolBarItems = {
        /** Used to add toolbar item for adding records    */
        Add: "add",
        /** Used to add toolbar item for editing records    */
        Edit: "edit",
        /** Used to add toolbar item for deleting records    */
        Delete: "delete",
        /** Used to add toolbar item for updating records    */
        Update: "update",
        /** Used to add toolbar item for cancelling records    */
        Cancel: "cancel",
        /** Used to add toolbar item for searching records    */
        Search: "search",
        /** Used to add toolbar item for printing grid    */
        PrintGrid: "printGrid",
        /** Used to add toolbar item for exproting grid to excel    */
        ExcelExport: "excelExport",
        /** Used to add toolbar item for exporting grid to word    */
        WordExport: "wordExport",
        /** Used to add toolbar item for exporting grid to pdf    */
        PdfExport: "pdfExport"
    };

    ej.Grid.FilterType = {
        /**  Creates grid with filtering type as Menu */
        Menu: "menu",
        /**  Creates grid with filtering type as FilterBar */
        FilterBar: "filterbar",
        /** Creates grid with filtering type as Excel */
        Excel: "excel"
    };

    ej.Grid.FilterBarMode = {
        /** Used to set filter bar mode as Immediate mode */
        Immediate: "immediate",
        /** Used to set filter bar mode as OnEnter mode */
        OnEnter: "onenter"
    };

    ej.Grid.SelectionType = {
        /**  Support for Single selection only in grid */
        Single: "single",
        /**  Support for multiple selections in grid */
        Multiple: "multiple"
    };
    ej.Grid.ColumnLayout = {
         /**  Support for auto width in grid */
        Auto: "auto",
        /**  Support for fixed column width in grid */
        Fixed: "fixed"
    };
    ej.Grid.GridLines = {
        /**  Support for Show both the vertical and horizontal line in grid  */
        Both: "both",
        /**  Support for Hide both the vertical and horizontal line in grid  */
        None: "none",
        /**  Support for Shows the horizontal line only in grid */
        Horizontal: "horizontal",
        /**  Support for Shows the vertical line only in grid  */
        Vertical: "vertical",
    };

    ej.Grid.VirtualScrollMode = {
        /** Used to set the Normal mode virtual paging*/
        Normal: "normal",
        /** Used to set the Continuous mode virtual paging*/
        Continuous: "continuous"
    };

    ej.Grid.SelectionMode = {
        /**  Support for Row selection in grid */
        Row: "row",
        /**  Support for Cell selection in grid */
        Cell: "cell",
        /**  Support for Column selection in grid */
        Column: "column"
    };

    ej.Grid.WrapMode = {
        /**  Support for text wrap with both header and content in grid */
        Both: "both",
        /**  Support for text wrap with content alone in grid */
        Content: "content",
        /**  Support for text wrap with header alone in grid */
        Header: "header"
    };

    ej.Grid.exportAll = function (exportAction, gridIds) {
        ej.Grid.prototype["export"](exportAction, null, true, gridIds);
    };

    ej.SqlDataSourceAdaptor = new ej.UrlAdaptor().extend({
        init: function (id) {
            this.initialRender = true;
        },
        processQuery: function (dm, query, hierarchyFilters) {
            var obj = ej.UrlAdaptor.prototype.processQuery(dm, query, hierarchyFilters);
            var data = ej.parseJSON(obj.data), result = {};
            // Param
            if (data.param) {
                for (var i = 0; i < data.param.length; i++) {
                    var param = data.param[i], key = Object.keys(param)[0];
                    result[key] = param[key];
                }
            }
            result["value"] = data;
            var modelStr = JSON.stringify({ type: "SqlData", args: data });
            if (this.initialRender == false) {
                __doPostBack("", modelStr);
            }
            this.initialRender = false;
            return {
                data: JSON.stringify(result),
                result: dm.dataSource.json,
                ejPvtData: obj.ejPvtData,
                count: dm.dataSource.json.length,
            }
        },
        processResponse: function (data, ds, query, xhr, changes) {
            var pvt = data.ejPvtData || {};
            var groupDs = data.groupDs;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            var d = JSON.parse(data.data);
            if (d && d.action === "batch" && data.added) {
                changes.added = data.added;
                return changes;
            }
            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                if ('count' in data) args.count = data.count;
                if (data["result"]) args.result = data.result;
                if (data["aggregate"]) data = data.aggregate;
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                args["aggregates"] = res;
                data = args;
            }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups, args = {};
                if ('count' in data) args.count = data.count;
                if (data["aggregates"]) args.aggregates = data.aggregates;
                if (data["result"]) data = data.result;
                for (var i = 0; i < groups.length; i++) {
                    var level = null;
                    if (!ej.isNullOrUndefined(groupDs))
                        groupDs = ej.group(groupDs, groups[i]);
                    data = ej.group(data, groups[i], pvt.aggregates, level, groupDs);
                }
                if (args.count != undefined)
                    args.result = data;
                else
                    args = data;
                return args;
            }
            return data;
        },
    });
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    "use strict"
    ej.gridFeatures.gridResize = function (instance) {
        this.$headerTable = instance.getHeaderTable();
        this.gridInstance = instance;
        this._colMinWidth = 15;
        this._$visualElement = $();
        this._currentCell = -1;
        this._allowStart = false;
        this._oldWidth = null;
        this._orgX = null;
        this._orgY = null;
        this._extra = null;
        this._expand = false;
        this._target = null;
        this._cellIndex = -1;
    }

    ej.gridFeatures.gridResize.prototype = {
        _mouseHover: function (e) {
            if (this._$visualElement.is(":visible"))
                return;
            this._allowStart = false;
            if ($(e.target).is(".e-headercelldiv"))
                e.target = e.target.parentNode;
            var $target = $(e.target);
			if ($(e.target).hasClass("e-filtericon") && ($(e.target).css("cursor") == "col-resize" || $(e.target).closest("tr").css("cursor") == "col-resize")) {
                $(e.target).css("cursor", "pointer");
                $(e.target).closest("tr").css("cursor", "pointer");
            }
            if ($target.hasClass("e-headercell")) {
                var _resizableCell = e.target;
                var location = _resizableCell.getBoundingClientRect(), _x = 0, _y = 0;
                if (e.type = "mousemove") {
                    _x = e.clientX;
                    _y = e.clientY;
                }
                else if (e.type = "touchmove") {
                    _x = evt.originalEvent.changedTouches[0].clientX;
                    _y = evt.originalEvent.changedTouches[0].clientY;
                }
                else if (e.type = "MSPointerMove") {
                    _x = e.originalEvent.clientX;
                    _y = e.originalEvent.clientY;
                }
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                    var _nlx = this.gridInstance.getHeaderContent().width() + this.gridInstance.element.children(".e-gridheader").find(".e-columnheader").offset().left;
                else
                    var _nlx = this.gridInstance.getHeaderTable().width() + this.gridInstance.element.children(".e-gridheader").find(".e-columnheader").offset().left;
                if (((_x >= (location.left + document.documentElement.scrollLeft + _resizableCell.offsetWidth - 5)) || ((_x <= (location.left + 3)))) && (_x < _nlx) && (_x >= location.left) && (_y <= location.top + document.documentElement.scrollTop + e.target.offsetHeight)) {
                    if (_x > location.left + 3)
                        var tempTarget = $(e.target).find(".e-headercelldiv");
                    else
                        var tempTarget = $(e.target).prevAll("th:visible:first").find(".e-headercelldiv");
                    var windowScrollX = window.pageXOffset || document.documentElement.scrollTop || document.body.scrollTop;
                    var _lx = (this.gridInstance.element.find(".e-headercell").not('.e-detailheadercell').offset().left + 10) - windowScrollX;
                    if ((this.gridInstance.model.enableRTL && (_x <= _lx)) || (!this.gridInstance.model.enableRTL && (_x >= _lx))) {
                        if ((this.gridInstance.model.showStackedHeader || tempTarget.length) && $.inArray($(tempTarget).attr("ej-mappingname"), this.gridInstance._disabledResizingColumns) == -1) {
                            this.gridInstance.model.showStackedHeader && $($target.parents('thead')).find('tr').css("cursor", "col-resize");
                            !this.gridInstance.model.showStackedHeader && $target.parent().css("cursor", "col-resize");
                            if ($(e.target).hasClass('e-stackedHeaderCell'))
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").index(_resizableCell);
                            else
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").not(".e-stackedHeaderCell,.e-detailheadercell").index(_resizableCell);
                            if (this.gridInstance.model.enableRTL)
                                this._currentCell = this._currentCell - 1;
                            this._allowStart = true;
                        }
                        else {
                            $target.parent().css("cursor", "pointer");
                            this._currentCell = -1;
                        }
                    }
                }
                else {
                    this.gridInstance.element.find(".e-columnheader").css("cursor", "pointer");
                    this._currentCell = -1;
                }
            }
        },
        _start: function (_x, _y) {
            var _myrow = this.gridInstance.getHeaderTable().find(".e-columnheader"), _top;
            var _cells, _mycel;
            if ($(this._target).hasClass('e-stackedHeaderCell'))
                _cells = _myrow.find(".e-headercell").not(".e-hide");
            else
                _cells = _myrow.find(".e-headercell").not(".e-stackedHeaderCell,.e-hide");
            if (this._currentCell != -1 && this._currentCell < _cells.length)
                _mycel = _cells[this._currentCell];
            if (typeof (_mycel) == 'undefined')
                return;
            var _j = _mycel.getBoundingClientRect();
            _top = this._tableY = _j.top + parseInt(navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollTop : document.documentElement.scrollTop);
            if (this._allowStart) {
                var vElement = this._$visualElement = $(document.createElement('div')),
                _height = this.gridInstance.element.find(".e-gridcontent").first().height() + this.gridInstance.element.find(".e-gridheader").height();
                if (this.gridInstance.model.showStackedHeader && this.gridInstance.model.stackedHeaderRows.length > 0) {
                    var headerRow = this.gridInstance.getHeaderTable().find('tr.e-columnheader')
                    var lenght = headerRow.length;
                    var currentIndex = $(this._target).parent('tr')[0].rowIndex;
                    for (var i = 0; i < currentIndex; i++) {
                        _height = _height - $(headerRow[i]).height();
                    }
                    // _height = _height - $(".e-stackedHeaderRow").height();
                }
                vElement.addClass("e-reSizeColbg").appendTo(this.gridInstance.element).attr("unselectable", "on").css("visibility", "hidden");
                this.gridInstance._resizeTimeOut = setTimeout(function() {
                    vElement.css({ visibility: "visible", height: _height + 'px', cursor: 'col-resize', left: _x, top: _top, position: 'fixed' });
                }, 100);
                this._oldWidth = _mycel.offsetWidth;
                this._orgX = _x;
                this._orgY = _y;
                this._extra = _x - this._orgX;
                this._expand = true;
            }
            else {
                this._currentCell = -1;
            }
        },
        _mouseMove: function (e) {
            if (this._expand) {
                var _x = 0, _y = 0;
                if (e.type = "mousemove") {
                    _x = e.clientX;
                    _y = e.clientY;
                }
                else if (e.type = "touchmove") {
                    _x = evt.originalEvent.changedTouches[0].clientX;
                    _y = evt.originalEvent.changedTouches[0].clientY;
                }
                else if (e.type = "MSPointerMove") {
                    _x = e.originalEvent.clientX;
                    _y = e.originalEvent.clientY;
                }
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY;
                }
                _x += document.documentElement.scrollLeft;
                e.preventDefault();
                this._moveVisual(_x);
            }
            else
                this._mouseHover(e);
        },
        _getCellIndex: function (e) {
            var $target = $(e._target);
            var targetCell = e._target;
            var location = targetCell.getBoundingClientRect();
            var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            if (this._orgX < location.left + 5 + scrollLeft)
                targetCell = $(targetCell).prevAll(":visible:first")[0];
            var hCellIndex = targetCell.cellIndex;
            var cellIndex = hCellIndex;
            if (e.gridInstance.model.groupSettings.groupedColumns.length) {
                cellIndex = hCellIndex - e.gridInstance.model.groupSettings.groupedColumns.length;
            }
            return cellIndex;
        },
        _reSize: function (_x, _y) {
            // Function used for Resizing the column
            var proxy = this;
            var resized = false, $content;
            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                this._initialTableWidth = this.gridInstance.getHeaderTable().first().parent().width() + this.gridInstance.getHeaderTable().last().parent().width();
            else
                this._initialTableWidth = this.gridInstance.getHeaderTable().parent().width();
            if (this.gridInstance.model.enableRTL && (this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid))
                this._currentCell = this._currentCell - 1;
            else
                !this.gridInstance.model.enableRTL && this._getResizableCell();
            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns > 0)
                var _rowobj = this.gridInstance.getHeaderTable().find('thead');
            else
                var _rowobj = $(this._target).parents('thead');
            if (this._currentCell != -1 && this._expand) {
                this._expand = false;
                var _childTH = $(this._target).hasClass('e-stackedHeaderCell') ? _rowobj.find(".e-headercell:not(.e-detailheadercell)").filter(":visible") : _rowobj.find(".e-headercell:not(.e-detailheadercell,.e-stackedHeaderCell)").filter(":visible");
                var _outerCell = _childTH[this._currentCell];
                var _oldWidth = _outerCell.offsetWidth;
                var _extra = _x - this._orgX;
                if (this.gridInstance.model.enableRTL)
                    _extra = -_extra;
                //Check whether the column minimum width reached
                if (parseInt(_extra) + parseInt(_oldWidth) > this._colMinWidth) {
                    if (_extra != 0)
                        _rowobj.css("cursor", 'default');
                     var $prevheaderCol, oldColWidth;
                    if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                     var $prevheaderCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
                     if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                     this.gridInstance._detailColsRefresh();
                    $prevheaderCols = this.gridInstance._$headerCols;
                   }
                    var $prevheaderCol = $prevheaderCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                    var oldColWidth = $prevheaderCol.width();
                   }
                    this._resizeColumnUsingDiff(_oldWidth, _extra);
                    $content = this.gridInstance.element.find(".e-gridcontent").first();
                    var scrollContent = $content.find("div").hasClass("e-content");                    
                    var browser = !ej.isIOSWebView() && this.gridInstance.getBrowserDetails();
                    if (browser && browser.browser == "msie" && this.gridInstance.model.allowScrolling) {
                        var oldWidth = this.gridInstance.getContentTable().width(), newwidth = this.gridInstance._calculateWidth();
                        if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns > 0) {
                            this.gridInstance.getHeaderTable().last().width(newwidth - this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width());
                            this.gridInstance.getContentTable().last().width(newwidth - this.gridInstance.getContent().find(".e-frozencontentdiv").width());
                            this.gridInstance.model.showSummary && this.gridInstance.getFooterTable().last().width(newwidth - this.gridInstance.getFooterContent().find(".e-frozenfootertdiv").width());
                        }
                        else {
                            if (newwidth > oldWidth) {
                                this.gridInstance.getHeaderTable().width(newwidth);
                                this.gridInstance.getContentTable().width(newwidth);
                                this.gridInstance.model.showSummary && this.gridInstance.getFooterTable().width(newwidth);
                            }
                        }
                        if (parseInt(browser.version, 10) > 8 && this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                            if (newwidth > oldWidth) {
                                this.gridInstance.getContentTable().width(newwidth);
                                this.gridInstance.getContentTable().children("colgroup").find("col").first().css("width", (20 / $content.find("table").first().width()) * 100 + "%");
                            }
                            else {
                                this.gridInstance.getContentTable().css("width", "100%");
                                this.gridInstance._groupingAction(true);
                                this.gridInstance.getContentTable().children("colgroup").find("col").first().css("width", ((this.gridInstance.getHeaderTable().find("colgroup").find("col").first().width() / $content.find("table").first().width()) * 100).toFixed(2) + "%");
                            }
                        }
                        this.gridInstance.getHeaderTable().parent().scrollLeft($content.find(".e-content").scrollLeft() - 1);
                    }
                    this.gridInstance._colgroupRefresh();
                    if (this.gridInstance.model.allowTextWrap)
                        this.gridInstance.rowHeightRefresh();
                    if (this.gridInstance.model.groupSettings.groupedColumns.length && !this.gridInstance.model.isEdit)
                        this.gridInstance._recalculateIndentWidth();
                    if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'normal') {
                        if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                            var $headerCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
                            var $ContentCols = this.gridInstance.getContentTable().find('colgroup').find("col");
                            if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                                this.gridInstance._detailColsRefresh();
                                $headerCols = this.gridInstance._$headerCols;
                                $ContentCols = this.gridInstance._$contentCols;
                            }
                            var nextCell = this._currentCell + 1;
                            var $headerCol = $headerCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) ? nextCell : nextCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                            var newWidth = $headerCol.width() + (oldColWidth - $prevheaderCol.width()), $ContentCol;
                            if (newWidth < this._colMinWidth)
                                newWidth = this._colMinWidth;
                            $headerCol.width(newWidth);
                            if (this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                                var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                                var $colGroup = $tables.find("colgroup");
                                var colCount = this.gridInstance.getVisibleColumnNames().length;
                                if (this.gridInstance.getContentTable().find('.e-detailrow').length)
                                    $colGroup = $colGroup.not($tables.find(".e-detailrow").find("colgroup")).get();
                                for (var i = 0 ; i < $colGroup.length; i++) {
                                    var cols = $($colGroup[i]).find("col").filter(this._diaplayFinder);
                                    if (cols.length > colCount) cols.splice(0, (cols.length - colCount));
                                    $(cols[nextCell]).width(newWidth);
                                }
                            }
                            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns) {
                                if (nextCell >= 0 && nextCell < this.gridInstance.model.scrollSettings.frozenColumns && this._getFrozenResizeWidth() + _extra > this.gridInstance.element.find(".e-headercontent").first().width())
                                    return;
                                $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(nextCell);
                            }
                            else
                                $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) ? nextCell : nextCell + this.gridInstance.model.groupSettings.groupedColumns.length);
                            $ContentCol.width(newWidth);
                            this.gridInstance._findColumnsWidth();
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(_outerCell).is(":last-child") && this.gridInstance.pluginName == "ejGrid") {
                                var val = $prevheaderCol.width() - oldColWidth;
                                var frozenWidth = this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width() + val;
                                var movableWidth = this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width() - val;
                                var marginLeft = parseInt(this.gridInstance.getHeaderContent().find('.e-movableheader')[0].style["margin-left"]) + val;
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(frozenWidth);
                                this.gridInstance.getContent().find('.e-frozencontentdiv').width(frozenWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width(movableWidth);
                                this.gridInstance.getContent().find('.e-movablecontentdiv').width(movableWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheader').css("margin-left", marginLeft);
                                this.gridInstance.getContent().find('.e-movablecontent').css("margin-left", marginLeft);
                            }

                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(this._target).parent('tr').parents('div:first').hasClass('e-frozenheaderdiv')) {
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(this._newWidth);
                                this.gridInstance.getContent().find('.e-frozencontentdiv').width(this._newWidth);
                            }
                        }
                        else if (!this.gridInstance.model.scrollSettings.frozenColumns) {
                            var oldTableWidth = this.gridInstance.getHeaderTable().width();
                            this.gridInstance.getHeaderTable().css("width", oldTableWidth + parseInt(_extra));
                            this.gridInstance.getContentTable().css("width", oldTableWidth + parseInt(_extra));
                            this.gridInstance.model.scrollSettings.width += parseInt(_extra);
                            if (this.gridInstance.getContent().width() > this.gridInstance.getContentTable().width()) {
                                this.gridInstance.getContentTable().addClass('e-tableLastCell');
                                this.gridInstance.getHeaderTable().addClass('e-tableLastCell');
                            }
                            else {
                                this.gridInstance.getContentTable().removeClass('e-tableLastCell');
                                this.gridInstance.getHeaderTable().removeClass('e-tableLastCell');
                            }
                        }
                    }
                    if (!(browser.browser == "msie") && browser && this.gridInstance.model.allowScrolling && this.gridInstance.model.scrollSettings.frozenColumns == 0) {
                        this.gridInstance.getHeaderTable().width("100%");
                        this.gridInstance.getContentTable().width("100%");
                        var tableWidth = this.gridInstance._calculateWidth();
                        if (tableWidth <= this.gridInstance.getContentTable().width() || this.gridInstance.getHeaderTable().width() > this.gridInstance.getContentTable().width()) {
                            this.gridInstance.getHeaderTable().width(tableWidth);
                            this.gridInstance.getContentTable().width(tableWidth);
                        }
                    }
                    if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'default') {
                        var cellIndex = this._currentCell;
                        var target = $(this._target), columnIndex = [], col = [];
                        var newWidth = _oldWidth + _extra;
                        var args = {};
                        if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                            var rowindex = target.parent(".e-stackedHeaderRow").index(),
                            stackedHeaderText = target.text(),
                            stackedHeaderCol = this.gridInstance.model.stackedHeaderRows[rowindex].stackedHeaderColumns,stackedHeaderColumns;
                            for(i=0;i<stackedHeaderCol.length;i++){
                                if(stackedHeaderCol[i].headerText == stackedHeaderText)
                                    stackedHeaderColumns = stackedHeaderCol[i].column;
                            }
                            var columns = stackedHeaderColumns;
                            if (!(stackedHeaderColumns instanceof Array))
                                columns = stackedHeaderColumns.split(",");
                            for (var i = 0 ; i < columns.length; i++) {
                                var index = this.gridInstance.getColumnIndexByField(columns[i]);
                                columnIndex.push(index)
                                col.push(this.gridInstance.model.columns[index]);
                            }
                            args = { columnIndex: columnIndex, column: col, oldWidth: _oldWidth, newWidth: newWidth };
                        }
                        else
                        args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], oldWidth: _oldWidth, newWidth: newWidth };
                        this.gridInstance._trigger("resized", args);
                    }
                    if (this.gridInstance.model.allowScrolling) {
                        this.gridInstance.getScrollObject().refresh(this.gridInstance.model.scrollSettings.frozenColumns > 0);
                        if (this.gridInstance.model.isResponsive && this.gridInstance.model.minWidth)
                            this.gridInstance.windowonresize();
                        if (!scrollContent && $content.find("div").hasClass("e-content"))
                            this.gridInstance.refreshScrollerEvent();
                        this.gridInstance._isHscrollcss();
                    }
                }

            }

            this._target = null;
            this._$visualElement.remove();
            this._expand = false;
            this._currentCell = -1;
            this._allowStart = false;

        },
        _getFrozenResizeWidth: function () {
            var $frozenColumnsCol = this.gridInstance.getHeaderTable().find('colgroup').find("col").slice(0, this.gridInstance.model.scrollSettings ? this.gridInstance.model.scrollSettings.frozenColumns : 0), width = 0;
            for (var i = 0; i < $frozenColumnsCol.length; i++) {
                if ($frozenColumnsCol.eq(i).css("display") != "none")
                    width += parseInt($frozenColumnsCol[i].style.width.replace("px", ""));
            }
            return width;
        },
        _diaplayFinder: function () {
            return $(this).css('display') != 'none';
        },
        _resizeColumnUsingDiff: function (_oldWidth, _extra) {
            var proxy = this, _extraVal;			
            this._currntCe = this._currentCell;
            var $headerCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
            var $ContentCols = this.gridInstance.getContentTable().find('colgroup').find("col");
            if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                this.gridInstance._detailColsRefresh();
                $headerCols = this.gridInstance._$headerCols;
                $ContentCols = this.gridInstance._$contentCols;
            }
            var $headerCol = $headerCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                    , $ContentCol, $footerCol, $frozenCols = $headerCols.slice(0, this.gridInstance.model.scrollSettings ? this.gridInstance.model.scrollSettings.frozenColumns : 0);
            var colWidth = $headerCol[0].style.width, isPercent = colWidth.indexOf("%") != -1;
            var _inlineWidth = (!colWidth || isPercent)? $(this._target).outerWidth() : colWidth;
            var indent = !isPercent ? _oldWidth / parseInt(_inlineWidth) : 1;
            _extraVal = _extra = _extra / indent
            var _newWidth = this._newWidth = parseInt(_extra) + parseInt(_inlineWidth);
            if (_newWidth > 0 && _extra != 0) {
                if (_newWidth < this._colMinWidth)
                    _newWidth = this._colMinWidth;
                if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                    var nextCol = $headerCol.next();
                    var isFrozenLastCell = this.gridInstance.model.scrollSettings.frozenColumns && this._currentCell == this.gridInstance.model.scrollSettings.frozenColumns - 1 ? true : false;
                    if (isFrozenLastCell)
                        nextCol = $headerCols.eq(this.gridInstance.model.scrollSettings.frozenColumns);
                    if ((isFrozenLastCell || !$headerCol.is(":last-child")) && (nextCol.width() + ($headerCol.width() - _newWidth) <= this._colMinWidth))
                        _newWidth = $headerCol.width() + (nextCol.width() - this._colMinWidth);
                }
                var _extra = _newWidth - _oldWidth;
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns) {
                    if (this._currentCell >= 0 && this._currentCell < this.gridInstance.model.scrollSettings.frozenColumns && this._getFrozenResizeWidth() + _extra > this.gridInstance.element.find(".e-headercontent").first().width())
                        return;
                    $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(this._currentCell);
                }
                else
                    $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length);
                if (this.gridInstance.model.showSummary) {
                    this._$footerCols = this.gridInstance.getFooterTable().find('colgroup').find("col");
                    var colCount = this.gridInstance.model.columns.length;
                    if (this._$footerCols.length > colCount) this._$footerCols.splice(0, (this._$footerCols.length - colCount));
                    var $footerCols = this._$footerCols,
                    $footerCol = $footerCols.filter(this._diaplayFinder).eq(this._currentCell);
                    $footerCol.outerWidth(_newWidth);
                }
                if ($(this._target).parent('tr').hasClass('e-stackedHeaderRow')) {
                    this._resizeStackedHeaderColumn($(this._target).parent('tr'), _extraVal, this._currntCe);
                }
                else
                    $headerCol.outerWidth(_newWidth);
                if ($(this._target).parent('tr').hasClass('e-stackedHeaderRow')) {
                    if (this.gridInstance.model.groupSettings.groupedColumns.length) {
                        var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                        var $colGroup = $tables.find("colgroup");
                        for (var i = 0; i < this._changedcell.length; i++) {
                            var cellIndex = this._changedcell[i];
                            for (var j = 0 ; j < $colGroup.length; j++) {
                                var visibleCols = $($colGroup[j]).children().filter(this._diaplayFinder);
                                var width = parseInt((_extraVal)) + parseInt(visibleCols[cellIndex].style.width);
                                if (width < this._colMinWidth)
                                    width = this._colMinWidth
                                $(visibleCols[cellIndex]).width(width);
                            }
                        }
                    }
                    var length = this.gridInstance.getContentTable().find('colgroup').find("col").filter(this._diaplayFinder).length;
                    for (var i = 0; i < this._changedcell.length; i++) {
                        var $conCol = this.gridInstance.getContentTable().find('colgroup').find("col").filter(this._diaplayFinder)[this._changedcell[i]]
                        var width = parseInt((_extraVal)) + parseInt($conCol.style.width);
                        if (width < this._colMinWidth)
                            width = this._colMinWidth
                        $($conCol).outerWidth(width);
                        if (this.gridInstance.model.isEdit && (this.gridInstance.model.allowGrouping && this.gridInstance.model.groupSettings.groupedColumns.length == 0)) {
                            var $sEditCol = this.gridInstance.getContentTable().find(".gridform").find("colgroup col").filter(this._diaplayFinder)[this._changedcell[i]];
                            $($sEditCol).outerWidth(width);
                        }
                    }
                }
                else {
                    if (this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                        var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                        var $colGroup = $tables.find("colgroup");
                        var cellIndex = this._currentCell;
                        var colCount = this.gridInstance.getVisibleColumnNames().length;
                        if (this.gridInstance.getContentTable().find('.e-detailrow').length)
                            $colGroup = $colGroup.not($tables.find(".e-detailrow").find("colgroup")).get();
                        for (var i = 0 ; i < $colGroup.length; i++) {
                            var cols = $($colGroup[i]).find("col").filter(this._diaplayFinder);
                            if (cols.length > colCount) cols.splice(0, (cols.length - colCount));
                            $(cols[cellIndex]).width(_newWidth);
                        }
                    }
                    $ContentCol.outerWidth(_newWidth);
                    if (this.gridInstance.model.isEdit) {
                        var $editableRow = this.gridInstance.getContentTable().find(".e-editedrow,.e-addedrow");
                        var $editCols = $editableRow.find("table").find("colgroup col");
                        var addCol;
                        if ($editableRow.hasClass("e-addedrow") && this.gridInstance.model.groupSettings.groupedColumns.length)
                            addCol = this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length - 1;
                        else
                            addCol = this._currentCell;
                        var $editCol = $editCols.filter(this._diaplayFinder).eq(addCol);
                        $editCol.outerWidth(_newWidth);
                    }
                }
                this.gridInstance._findColumnsWidth();
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns && ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'nextcolumn' && this.gridInstance.pluginName == "ejGrid") {
                    var frozenColumns = this.gridInstance.getContentTable().find('colgroup').find("col").slice(0, this.gridInstance.model.scrollSettings.frozenColumns)
                        , width = 0, direction;
                    for (i = 0; i < frozenColumns.length; i++)
                        width += frozenColumns[i].style.display == 'none' ? 0 : parseInt(frozenColumns[i].style.width.replace("px", ""));
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width);
                    direction = this.gridInstance.model.enableRTL ? "margin-right" : "margin-left";
                    this.gridInstance.getContent().find(".e-frozencontentdiv").width(width).next().css(direction, width + "px");
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width).next().css(direction, width + "px");
                    this.gridInstance.model.showSummary && this.gridInstance.getFooterContent().find(".e-frozenfooterdiv").width(width);
                }
                this.gridInstance.getHeaderTable().find(".e-columnheader").css("cursor", "default");
            }
        },
        _resizeStackedHeaderColumn: function (currentTr, extra, currentCell) {
            // var currentIndex = this._currntCe;
            this._changedcell = [];
            var headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-detailheadercell");
            var preCol = 0, limit = 0, currentTh = headerCells[currentCell], currentSpan = $(currentTh).attr('colspan'), commonExtra = extra / currentSpan, tr = $(currentTh).parent('tr');
            var nextTr = tr.next();
            var currentIndex = currentTh.cellIndex;
            if (this.gridInstance.model.groupSettings.showGroupedColumn) {
                limit = this.gridInstance.model.groupSettings.groupedColumns.length;
                preCol += limit
            }
            while (currentIndex > limit) {
                currentIndex--;
                var th = $(tr).children('th').not(".e-detailheadercell")[currentIndex];
                preCol += parseInt($(th).attr('colspan'));
            }
            this._currentCell = preCol;
            var length = preCol + parseInt(currentSpan);
            for (var i = preCol; i < length; i++) {
                var $colG = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder)[i];
                this._changedcell.push(i - limit)
                var width = parseInt(extra) + parseInt($colG.style.width);
                if (width < this._colMinWidth)
                    width = this._colMinWidth;
                $($colG).outerWidth(width);
             }
        },
        _triggerResizeEvents: function (event, _x) {
            var _rowobj = this.gridInstance.getHeaderTable().find(".e-columnheader");
            var _childTH = _rowobj.find(".e-headercell").filter(":visible");
            var cellIndex = this._cellIndex;
            var target = $(this._target), columnIndex = [], col = [];
            if (event == "resizeStart") {
                this._orgX = _x;
                cellIndex = this._cellIndex = this._getCellIndex(this, _x);
            }
            var _outerCell = _childTH[this._currentCell];
            var _oldWidth = _outerCell.offsetWidth;
            if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                var rowindex = target.parent(".e-stackedHeaderRow").index(),
                stackedHeaderText = target.text(),
                stackedHeaderCol = this.gridInstance.model.stackedHeaderRows[rowindex].stackedHeaderColumns,stackedHeaderColumns;
                for(i=0;i<stackedHeaderCol.length;i++){
                    if(stackedHeaderCol[i].headerText == stackedHeaderText)
                        stackedHeaderColumns = stackedHeaderCol[i].column;
                }
                var columns = stackedHeaderColumns;
                if (!(stackedHeaderColumns instanceof Array))
                    columns = stackedHeaderColumns.split(",");
                for (var i = 0 ; i < columns.length; i++) {
                    var index = this.gridInstance.getColumnIndexByField(columns[i]);
                    columnIndex.push(index)
                    col.push(this.gridInstance.model.columns[index]);
                }
            }
            if (event == "resizeStart") {
                var args = {};
                if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                    args = { columnIndex: columnIndex, column: col, target: target, oldWidth: _oldWidth };
                }
                else
                    args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth };
                return this.gridInstance._trigger("resizeStart", args);
            }
            else {
                var _childth = _rowobj.find(".e-headercell").not(".e-detailheadercell").filter(":visible");
                var _extra = _x - this._orgX;
                var newWidth = _oldWidth + _extra;
                this.gridInstance._colgroupRefresh();
                var args = {};
                if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                    args = { columnIndex: columnIndex, column: col, target: $(_outerCell), oldWidth: _oldWidth, newWidth: newWidth, extra: _extra };
                }
                else
                    args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth, newWidth: newWidth, extra: _extra };
                return this.gridInstance._trigger("resizeEnd", args);
            }
        },
        _mouseUp: function (e) {
            if (this.gridInstance._resizeTimeOut){
                clearTimeout(this.gridInstance._resizeTimeOut);
                this.gridInstance._resizeTimeOut = 0;
            }
            if (this._expand) {
                var _x = e.clientX, _y = e.clientY;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY;
                }
                if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'col-resize') {
                    if (this._triggerResizeEvents("resizeEnd", _x)) {
                        this.gridInstance.element.find(".e-reSizeColbg").remove();
                        return;
                    }
                }
                _x += document.documentElement.scrollLeft;
                this._reSize(_x, _y);
                if (!ej.isNullOrUndefined(this._currntCe) && this._currntCe >= 0)
                    this.gridInstance.model.columns[this._currntCe].width = this.gridInstance.columnsWidthCollection[this._currntCe];
            }
        },
        _getResizableCell: function () {
            var row;
            if ($(this._target).hasClass('e-stackedHeaderCell'))
                row = this.gridInstance.getHeaderTable().find(".e-columnheader");
            else
                row = this.gridInstance.getHeaderTable().find(".e-columnheader").not('.e-stackedHeaderRow');
            var cell = row.find(".e-headercell").not(".e-hide,.e-detailheadercell");
            var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            if (!this.gridInstance.model.scrollSettings.frozenColumns || this._currentCell != this.gridInstance.model.scrollSettings.frozenColumns - 1)
                for (var i = 0; i < cell.length; i++) {
                    var point = cell[i].getBoundingClientRect();
                    var xlimit = point.left + scrollLeft + 5;
                    if (xlimit > this._orgX && $(cell[i]).height() + point.top >= this._orgY) {
                        this._currentCell = i - 1;
                        return;
                    }
                    if (i == cell.length - 1 || (this.gridInstance.model.showStackedHeader && $(this._target).get(0) === cell[i])) {
                        this._currentCell = i;
                        return;
                    }
                }
        },
        _moveVisual: function (_x) {
            /// Used to move the visual element in mouse move
            var _bounds = this.gridInstance.getHeaderContent().find("div").first()[0].getBoundingClientRect();
            if ((_bounds.left + document.documentElement.scrollLeft + _bounds.width < _x) || (_x < _bounds.left + document.documentElement.scrollLeft))
                this._$visualElement.remove();
            else if (this._currentCell != -1)
                this._$visualElement.css({ left: _x, top: this._tableY });
        },
        _mouseDown: function (e) {
            if (this._allowStart && ($(e.target).closest("tr").css("cursor") == 'col-resize')) {
                this._target = e.target;
                var _x = e.clientX, _y = e.clientY;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY - document.body.scrollTop;
                }
                if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'col-resize') {
                    if ($(e.target).is(".e-headercelldiv"))
                        e.target = e.target.parentNode;
                    this._target = e.target;
                    if (this._triggerResizeEvents("resizeStart", _x))
                        return;
                }
                var gridobj = this;
                _x += document.documentElement.scrollLeft;
                if (e.button != 2)
                    this._start(_x, _y);
                return false;
            }
            return true;
        },
        _columnResizeToFit: function (e) {
            var resize = this.gridInstance.getHeaderTable().find(".e-columnheader").filter(function (e) {
                return $(this).css("cursor") == "col-resize";
            });
            if (this.gridInstance.model.allowResizeToFit && resize.length) {
                if ($(e.target).is(".e-headercelldiv"))
                    e.target = e.target.parentNode;
                var $target = $(e.target);
                var headerCells, preCol = 0, indent = 0;
                if ($target.hasClass('e-stackedHeaderCell'))
                    headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-detailheadercell");
                else
                    headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-stackedHeaderCell,.e-detailheadercell");
                this._target = $target;
                if ($target.hasClass("e-headercell")) {
                    var targetCell = e.target;
                    var hCellIndex = $.inArray(targetCell, headerCells);
                    var cellIndex = hCellIndex;
                    this._orgX = e.pageX;
                    if(!this.gridInstance.model.enableRTL) 
						this._getResizableCell();
					else
						this._currentCell = hCellIndex;
                    if (hCellIndex != this._currentCell) {
                        hCellIndex = cellIndex = this._currentCell;
                        targetCell = e.target.previousSibling;
                    }
                    var currentTh = headerCells.filter(":visible")[cellIndex], changesCellIndex = [], changesFinalWdith = [], changesOldWidth = [];
                    indent = this.gridInstance.model.groupSettings.groupedColumns.length;
                    if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) || !ej.isNullOrUndefined(this.gridInstance.model.childGrid))
                        indent += 1;
                    if ($(targetCell).parent("tr").hasClass('e-stackedHeaderRow')) {
                        var currentSpan = $(currentTh).attr('colspan'), tr = $(currentTh).parent('tr'), tHeadIndex = currentTh.cellIndex;
                        var nextTr = tr.next();
                        while (tHeadIndex > indent) {
                            tHeadIndex--
                            var th = $(tr).children('th')[tHeadIndex];
                            preCol += parseInt($(th).attr('colspan'))
                        };
                        var length = preCol + parseInt(currentSpan);
                    }
                    else {

                        preCol = cellIndex; length = cellIndex + 1;
                    }
                    var finalWidth = 0, headerWidth = 0, contentWidth = 0, argCols = [], argExtra = [];
                    if (preCol != -1) {
                        var hiddenLen = headerCells.slice(0, preCol + 1).filter(".e-hide").length;
                        var args = { columnIndex: preCol + hiddenLen, column: this.gridInstance.model.columns[preCol + hiddenLen], target: $target, oldWidth: oldWidth };
                        this.gridInstance._trigger("resizeStart", args);
                        for (var i = preCol; i < length; i++) {
                            hiddenLen = headerCells.slice(0, i + 1).filter(".e-hide").length;
                            contentWidth = this._getContentWidth(i + hiddenLen);
                            var $cellDiv = this.gridInstance.getHeaderTable().find('.e-headercell:not(.e-hide, .e-stackedHeaderCell)').children(".e-headercelldiv").eq(i);
                            headerWidth = this._getHeaderContentWidth($cellDiv);
                            finalWidth = headerWidth > contentWidth ? headerWidth : contentWidth;
                            finalWidth += parseInt(($cellDiv.css("padding-left"), 10) + ($cellDiv.css("padding-right"), 10));
                            var oldWidth = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder).eq(i + indent).width();
                            finalWidth = oldWidth > finalWidth ? finalWidth : (this._colMinWidth < finalWidth ? finalWidth : this._colMinWidth);

                            var headerCols = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder);
                            if(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)
                                headerCols.splice(0, 1);
                            headerCols.eq(i + indent).width(finalWidth);
                            if (this.gridInstance.model.groupSettings.groupedColumns.length) {
                                var $colGroups = this.gridInstance.getContentTable().find('.e-recordtable').find('colgroup');
                                var proxy = this;
                                $.each($colGroups, function (indx, colgroup) {
                                    $(colgroup).find('col').filter(proxy._diaplayFinder).eq(i).width(finalWidth);
                                });
                            }
                            var contentCols = this.gridInstance.getContentTable().find('col').filter(this._diaplayFinder);
                            if(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)
                                contentCols.splice(0, 1);
                            contentCols.eq(i + indent).width(finalWidth);
                            if (this.gridInstance.model.isEdit) {
                                var $editableCol = this.gridInstance.getContentTable().find(".e-editedrow").find("col");
                                var $form = this.gridInstance.element.find(".gridform");
                                for (var j = 0; j < $form.length; j++) {
                                   var $editableCol = $($form[j]).find("col")
                                   $editableCol.eq(i + indent).width(finalWidth);
                               }
                            }
                            argCols.push(this.gridInstance.model.columns[i + hiddenLen]);
                            argExtra.push(Math.abs(finalWidth - oldWidth))
                            changesCellIndex.push(i + hiddenLen); changesFinalWdith.push(finalWidth); changesOldWidth.push(oldWidth);
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 || (this.gridInstance.model.groupSettings.groupedColumns.length && this.gridInstance.model.isEdit)) {
                                var colIndex = i + hiddenLen;
                                this.gridInstance.columnsWidthCollection[colIndex] = finalWidth;
                                this.gridInstance.setWidthToColumns();
                                if (this.gridInstance.model.scrollSettings.frozenColumns <= colIndex + 1) {
                                    this.gridInstance.getHeaderContent().find(".e-movableheader").css("margin-left", finalWidth);
                                    this.gridInstance.getContent().find(".e-movablecontent").css("margin-left", finalWidth);
                                }
                            }
                        }

                    }
                    this.gridInstance._colgroupRefresh();
                    this.gridInstance._recalculateIndentWidth();
                    args = { columnIndex: changesCellIndex, column: argCols, target: currentTh, oldWidth: changesOldWidth, newWidth: changesFinalWdith, extra: argExtra };
                    this.gridInstance._trigger("resizeEnd", args);
                    for (var i = 0; i < changesCellIndex.length; i++) {
                        this.gridInstance.columnsWidthCollection[changesCellIndex[i]] = changesFinalWdith[i];
                        this.gridInstance.model.columns[changesCellIndex[i]]["width"] = changesFinalWdith[i];
                    }
                    args = { columnIndex: changesCellIndex, column: argCols, target: currentTh, oldWidth: changesOldWidth, newWidth: changesFinalWdith, extra: argExtra };
                    this.gridInstance._trigger("resized", args);
                    if (this.gridInstance.model.summaryRows.length > 0)
                        this.gridInstance._summaryColRrefresh();
					this.gridInstance._findColumnsWidth();
                }				
            }
        },
        _getContentWidth: function (cellindx) {
            var contentWidth = 0;
            var $span = ej.buildTag('span', {}, {}), proxy = this.gridInstance, tdWidth;
            if (!ej.isNullOrUndefined(proxy._gridRows)) {
                var rows = proxy._gridRows;
                if (this.gridInstance.model.scrollSettings.frozenColumns && cellindx >= this.gridInstance.model.scrollSettings.frozenColumns) {
                    rows = rows[1];
                    cellindx = cellindx - this.gridInstance.model.scrollSettings.frozenColumns;
                }
                $.each(rows, function (indx, row) {
                    if ($(row).is('.e-row,.e-alt_row') && !$(row).is('.e-editedrow')) {
					    var td = $(row).find('td.e-rowcell').eq(cellindx);
					    var content = $(td).html();
					    if (proxy.model.columns[cellindx]["commands"])
					        $span.html($(content).children());
					    else if (td.hasClass("e-validError"))
					        $span.html($(content).attr("value"));
					    else
						    $span.html(content);
					    $(td).html($span);
					    tdWidth = td.find('span:first').width();
					    if (tdWidth > contentWidth)
						    contentWidth = tdWidth;
					    $(td).html(content);
                    }
				});
			}
            proxy._refreshUnboundTemplate(this.gridInstance.getContentTable());
            return contentWidth;
        },
        _getHeaderContentWidth: function ($cellDiv) {
            var headerWidth = 0, $span = ej.buildTag('span', {}, {});
            var content = $cellDiv.html();
            $span.html(content);
            $cellDiv.html($span);
            headerWidth = $cellDiv.find('span:first').width();
            if (this.gridInstance.model.allowFiltering && this.gridInstance.model.filterSettings.filterType == "menu" || this.gridInstance.model.filterSettings.filterType == "excel")
                headerWidth = headerWidth + $cellDiv.parent().find(".e-filtericon").width() + 10;
            $cellDiv.html(content);
            return headerWidth;
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var horizontalHeaderTemplate = function () {
        return ("{{if multiRes == true}}<td class = 'e-horizontalheader'><div class='e-horizontalresheader'>{{:label}}</div></td>{{else}}{{/if}}" +
                "<td class='e-horizontaldaterender'><div class='e-horizontaltimecells {{:heightclass}}'>" +
                "<div class='e-headerdays' style='position:absolute;'>" +
                "<table class ='e-table {{:tablelayout}}' cellpadding='0px' cellspacing='0px' style='width:100%;border-collapse:separate;table-layout:fixed;'><tbody>{{if view !== 'month'}}" +
                "<tr style='width:100%;'> <td>{{if view === 'day'}}<table cellspacing='0px' style='width:100%;'>{{else}}<table class='e-table' cellspacing='0px'>{{/if}}<tbody><tr> {{for cols ~headercellWidth = headercellWidth}}<td class='e-headercells {{:cellToday}} e-horizontalheadertddate'><div class='{{:currentDateClass}} e-horizontalheaderdiv'>{{:currentDay}}</div></td>{{/for}} </tr></tbody></table></td> </tr>" +
                "<tr style='width:100%;position:absolute;'> <td><table class =' e-table e-horizontaltabletimecell' cellspacing='0px' style='border-collapse:collapse;'><tbody><tr> {{for timeTdCount  ~columnvalue =column  }}{{for ~name=time ~dayend=timecellclass ~index=#getIndex() }}<td class='e-horizontaltimetd {{:~dayend}}'><div style='width:{{:timeCellWidth}}'><span class ='e-horizontaltimespan'>{{:~name.slice(0,2)}}</span><div class ='e-horizontaltimespandiv'>{{:~name.slice(3,5)}}</div></div></td>{{for ~columnvalue[~index] ~width = timeCellWidth}}<td class='e-horizontalalternatetd'><div style='width:{{:~width}}'></div></td>{{/for}}{{/for}}{{/for}}  </tr></tbody></table></td> </tr>{{/if}}" +
                "{{if view == 'month'}}<tr>{{for cols}}<td class='e-headercells e-horizontmonthheaderdatetd {{:cellToday}}'><div title='{{:title}}' class='e-dateheadercell e-horizontmonthdatealign'>{{:currentDate}}</div></td>{{/for}}</tr>" +
                "<tr>{{for cols}}<td class ='e-horizontmonthheaderdaytd' style='width:{{:cellWidth}}'><div class='e-dateheadercell e-horizontmonthdatealign' title='{{:daynameTitle}}'>{{:currentDay}}</div></td>{{/for}}</tr>" +
                "{{/if}}</tbody></table></div></div></td>");
    };
    var userTimeCellsHoriTemplate = function () {
        return ("{{if multiRes == true}}<td class = 'e-horizontalheader'><div class='e-horizontalresheader'>{{:label}}</div></td>{{else}}{{/if}}" +
                "<td class='e-horizontaldaterender'><div class='e-horizontaltimecells {{:heightclass}}'>" +
                "<div class='e-headerdays' style='position:absolute;'>" +
                "<table class ='e-table' cellpadding='0px' cellspacing='0px' style='width:100%;border-collapse:separate;table-layout:fixed;'><tbody>{{if view !== 'month'}}" +
                "<tr style='width:100%;'> <td>{{if view === 'day'}}<table cellspacing='0px' style='width:100%;'>{{else}}<table class='e-table' cellspacing='0px'>{{/if}}<tbody><tr> {{for cols ~headercellWidth = headercellWidth}}<td class='e-headercells {{:cellToday}} e-horizontalheadertddate'><div class='{{:currentDateClass}} e-horizontalheaderdiv'>{{:currentDay}}</div></td>{{/for}} </tr></tbody></table></td> </tr>" +
                "<tr style='width:100%;position:absolute;'> <td><table class='e-table e-horizontaltabletimecell' cellspacing='0px' style='border-collapse:collapse;'><tbody><tr> {{for timeTdCount  ~userTemplateId = userTemplateId  ~template=template  ~columnvalue =column}}{{for ~name=time ~names=times ~dayend=timecellclass }}<td class='e-horizontaltimetd {{:~dayend}}'><div style='width:{{:timeCellWidth}}'><span class ='e-horizontaltimespan'>{{:~name}}</span><div class ='e-horizontaltimespandiv'></div></div></td>{{for ~columnvalue ~width = timeCellWidth ~names=~names}}<td class='e-horizontalalternatetd' style='vertical-align:middle !important;'><div style='width:{{:~width}};' > {{if ~template ==true || ~userTemplateId==true }}{{:~names[#getIndex()]}}{{else}}</div>{{/if}}</td>{{/for}}{{/for}}{{/for}}  </tr></tbody></table></td> </tr>{{/if}}" +
                "{{if view == 'month'}}<tr>{{for cols}}<td class='e-headercells e-horizontmonthheaderdatetd {{:cellToday}}'><div class='e-dateheadercell e-horizontmonthdatealign'>{{:currentDate}}</div></td>{{/for}}</tr>" +
                "<tr>{{for cols}}<td class ='e-horizontmonthheaderdaytd'><div class='e-dateheadercell e-horizontmonthdatealign' style='width:{{:cellWidth}}'>{{:currentDay}}</div></td>{{/for}}</tr>" +
                "{{/if}}</tbody></table></div></div></td>");
    };

    var horizontalResourceHeaderTemplate = function () {
        return ("<div class ='e-horizontresdiv'><div class='e-horires' style='height:100%'><table class='e-table e-resourceheadertable' width='100%' cellpadding='0px' cellspacing='0px' style='table-layout:fixed'>" +
                "<tbody>{{for trs}}<tr class='e-horizontresheaderdiv'>{{for ~resname=name ~marginleft=marginleft }}{{if classname == 'e-parentnode'}}<td class='{{:classname}} resemptytd' style='width:25px;height:{{:cellHeight}}'></td>{{else}}<td class='resemptytd' style='width:25px;height:{{:cellHeight}}'></td>{{/if}}<td class='{{:classname}}' style='vertical-align:middle;height:{{:cellHeight}};'>" +
                "{{if classname == 'e-parentnode'}}<div id={{:idnum}} class='{{:classname}}category e-resourceicon e-resourcecollapse' style='width:20px;vertical-align:middle;float:left;margin-left:{{:~marginleft}};margin-top:2px;'></div>{{/if}}" +
                "<div class='e-resourceheadertext' style='text-align:left;margin-left:{{:~marginleft}};' title='{{if userResTemplId == true}}{{:name}}{{else}}{{:~resname}}{{/if}}'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resname}}{{/if}}</div>" +
                "</td>{{/for}}</tr>{{/for}}</tbody></table></div></div>");
    };

    var horizontalCellsTemplate = function () {
        return ("<table class='e-table e-workcellstab'cellpadding='0px' cellspacing='0px'>" +
                "<tbody>{{for cellrows ~cols=cols ~hourdiff=hourdiff ~view=view ~classname=classname ~columnvalue=column ~userTemp=userTemplate ~userHtml=userHtml}}" +
                "{{if classname == 'e-parentnode'}} <tr class='e-resourceheadertr' style='width:100%'>{{for ~cols ~value=#getIndex()}}{{if #index % ~hourdiff == 0 && #index != 0 && ~view !== 'month' }}<td class='e-resourceheadercells e-workcells e-parentworkcell e-dayend' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{else}}<td class='e-resourceheadercells e-workcells e-parentworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{/if}}{{if ~userTemp == true}}{{if ~view !== 'month'}}{{:~userHtml[~value][0][#getIndex()]}}{{else}}{{:~userHtml[~value][#getIndex()]}}{{/if}}{{/if}}</td>{{if ~view !== 'month' ~val=#index}}{{for ~columnvalue[#getIndex()] ~width = cellWidth}}<td class='e-resourceheadercells e-workcells e-parentworkcell e-alternateworkcell' style='width:{{:~width}};height:{{:cellHeight}}'>{{if ~userTemp == true}}{{:~userHtml[~value][1][~val][#getIndex()]}}{{/if}}</td>{{/for}}{{/if}}{{/for}}</tr>" +
                "{{else}}<tr style='width:100%'>{{for ~cols ~value=#getIndex()}}{{if #index % ~hourdiff == 0 && #index != 0 && ~view !== 'month'  }}<td class='e-workcells e-childworkcell e-dayend' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{else}}<td class='e-workcells e-childworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{/if}}{{if ~userTemp == true}}{{if ~view !== 'month'}}{{:~userHtml[~value][0][#getIndex()]}}{{else}}{{:~userHtml[~value][#getIndex()]}}{{/if}}{{/if}}</td>{{if ~view !== 'month' ~val=#index}}{{for ~columnvalue[#getIndex()] ~width = cellWidth}}<td class='e-workcells e-childworkcell e-alternateworkcell' style='width:{{:~width}};height:{{:cellHeight}}'>{{if ~userTemp == true}}{{:~userHtml[~value][1][~val][#getIndex()]}}{{/if}}</td>{{/for}}{{/if}}{{/for}}" +
                "</tr>{{/if}}{{/for}}</tbody></table>");
    };

    ej.scheduleFeatures.horizontal = {

        _renderHorizontalTemplates: function () {
            this.horizontalHeader = $.templates(horizontalHeaderTemplate());
            this.cellTemplate = $.templates(horizontalCellsTemplate());
            this.horizontalResHeader = $.templates(horizontalResourceHeaderTemplate());
            this.userTimeCellHoriTemplate = $.templates(userTimeCellsHoriTemplate());
        },

        _horizontalViewNavigation: function (e) {
            var currentDateIndex, navidate;
            if (e.type == "click") {
                if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                    this.element.find(".e-headercells").children().removeClass("e-activeview");
                    currentDateIndex = e.currentTarget.cellIndex;
                    navidate = new Date(this._dateRender[currentDateIndex]);
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate) {
                        (this.model.timeScale.enable) && $(e.currentTarget).children().addClass("e-activeview");
                        this.currentDate(navidate);
                    }
                    else { return false; }
                    this._businessHourScroller();
                }
                else if (this.currentView() == "month" || (this._isCustomMonthView())) {
                    currentDateIndex = e.currentTarget.cellIndex;
                    if (this.model.views.indexOf("day") == -1) return false;
                    navidate = new Date(this.monthDays[currentDateIndex]);
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                        this.currentDate(navidate);
                    else { return false; }
                    this._navView = true;
                    this._viewChange(e, this.currentView(), "day");
                }
            }
            else if (e.type == "dblclick") {
                if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                    var target = $(e.target);
                    var dayTarget = target.hasClass("e-headercells") ? target : target.parent().hasClass("e-headercells") ? target.parent() : target.parent().parent();
                    if (this.model.views.indexOf("day") == -1 || !dayTarget.hasClass("e-headercells")) return false;
                    navidate = new Date(this._dateRender[dayTarget.index()]);
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                        this.currentDate(navidate);
                    else { return false; }
                    this._navView = true;
                    this._viewChange(e, this.currentView(), "day");
                }
            }
        },

        _renderHorizontalHeaderDays: function (localizeDays) {
            this.element.find(".e-headercells").addClass("e-dateheaderselect");
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                this.element.find(".e-currentdayhighlight").removeClass("e-currentdayhighlight");
                var curday, temp;
                if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId)) {
                    var columns = this._getUserDateheaderTemplate();
                    for (i = 0; i < this._dateRender.length; i++) {
                        $(this.element.find(".e-headercells")[i]).find("div")[0].innerHTML = columns[i].currentDay;
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                            $(this.element.find("td.e-headercells")[i]).addClass("e-currentdayhighlight");
                    }
                }
                else {
                    this.element.find(".e-headercells").children().removeClass("e-activeview");
                    for (var i = 0; i < this._dateRender.length; i++) {
                        curday = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? this._dayNames[new Date(this._dateRender[i]).getDay()].split("")[0] : (this.currentView() === "day") ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? localizeDays.calendar.days.names[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                        if (this.model.timeScale.enable)
                            temp = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? curday + parseInt(ej.format(new Date(this._dateRender[i]), "dd", this.model.locale)) : this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? curday + " " + ej.format(new Date(this._dateRender[i]), "dd MMMM yyyy", this.model.locale) : curday + " " + ej.format(new Date(this._dateRender[i]), "dd MMM yy", this.model.locale) : curday + " " + new Date(this._dateRender[i]).getDate();
                        else
                            temp = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? curday + parseInt(ej.format(new Date(this._dateRender[i]), "dd", this.model.locale)) : this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? ej.format(new Date(this._dateRender[i]), "dd MMMM yyyy", this.model.locale) : ej.format(new Date(this._dateRender[i]), "dd MMM yy", this.model.locale) : ("0" + new Date(this._dateRender[i]).getDate()).slice(-2);
                        $(this.element.find(".e-headercells")[i]).find("div")[0].innerHTML = temp;
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                            $(this.element.find("td.e-headercells")[i]).addClass("e-currentdayhighlight");
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(this.currentDate().setHours(0, 0, 0, 0)).getTime())
                            $(this.element.find(".e-headercells")[i]).children().addClass("e-activeview");
                    }
                }
                var currentDate = new Date(this.currentDate());
                if (this.model.orientation == "horizontal" && this.currentView() != "month" && this.model.timeScale.enable) {
                    if (new Date(this.currentDate()).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime()) {
                        this.element.find(".e-headercells").children().removeClass("e-activeview");
                        this.element.find(".e-currentdayhighlight").children().addClass("e-activeview");
                    }
                    var active = this.element.find(".e-headercells").children(".e-activeview").parent().index();
                    this.element.find(".e-headercells").children().removeClass("e-activeview");
                    var index = this.currentView() === "day" ? 0 : this.currentView() === "workweek" ? currentDate.getDay() - 1 : this.currentView() === "week" ? currentDate.getDay() : active;
                    this.currentView() != "day" && $(this.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                    new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime() ? $(this.element.find("td.e-horizontalheadertddate")[index]).addClass("e-headerToday") : "";
                }
            }
            else {
                var monthDays = this.monthDays;
                for (var i = 0; i < monthDays.length; i++) {
                    if (new Date(new Date(monthDays[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                        $(this.element.find("td.e-headercells")[i]).addClass("e-currentdayhighlight");
                }
            }
        },

        _horizontalScroll: function (e, proxy) {
            if (ej.isNullOrUndefined(e.scrollLeft)) return;
            if (proxy.currentView() == "day" || proxy.currentView() == "week" || proxy.currentView() == "workweek" || (proxy.currentView() === "customview" && proxy._renderDays <= 7)) {
                var currentDateIndex = $(proxy.element.find(".e-headercells").find(".e-activeview").parent()).index();
                var index = 0;
                if (proxy.model.enableRTL) {
                    var leftValue = (ej.browserInfo().name == "mozilla") ? Math.abs(e.scrollLeft) : e.scrollData.scrollable - e.scrollLeft;
                    proxy.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left", leftValue - 1 + "px");
                    var index = Math.floor((Math.abs(leftValue) / (proxy.element.find(".e-workcells").width() + 1)) / ((proxy.model.endHour - proxy.model.startHour) * proxy.model.timeScale.minorSlotCount));
                }
                else {
                    proxy.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left", (-e.scrollLeft) + "px");
                    var index = Math.floor((Math.abs(e.scrollLeft) / (proxy.element.find(".e-workcells").width())) / ((proxy.model.endHour - proxy.model.startHour) * proxy.model.timeScale.minorSlotCount * (60 / proxy.model.timeScale.majorSlot)));
                }
                if (e.scrollData.scrollable - e.scrollLeft == 0) return;
                if (proxy.currentView() != "day" && currentDateIndex !== index)
                    proxy.element.find(".e-headercells").children().removeClass("e-activeview");
                (proxy.currentView() != "day") && $(proxy.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                (!proxy.model.timeScale.enable) && proxy.element.find(".e-headercells").children().removeClass("e-activeview");
            }
        },

        _getHorizontalheaderCellCount: function (weekcols) {
            var cols = [];
            this._isCustomMonthView();
            if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && (this.currentView() == "day" || this.currentView() == "week" || this.currentView() == "workweek" || (this.currentView() == "customview" && this._oneWeek))) {
                cols = this._getUserDateheaderTemplate();
            }
            else {
                var curday, headerCellClass, temp;
                for (i = 0; i < this._dateRender.length; i++) {
                    curday = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? this._dayNames[new Date(this._dateRender[i]).getDay()].split("")[0] : (this.currentView() === "month" || this.currentView() === "day" || (this._isCustomMonthView())) ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? weekcols.calendar.days.names[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                    headerCellClass = (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-headerToday e-currentdayhighlight" : "";
                    temp = (this.currentView() === "month" || this._isCustomMonthView()) ? { currentDay: curday, currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : (this.currentView() === "day") ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? { currentDay: ej.format(new Date(this._dateRender[i]), this._pattern.D, this.model.locale), currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : { currentDay: curday + " " + ej.format(new Date(this._dateRender[i]), "dd MMM yy", this.model.locale), currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : { currentDay: (this._mediaQuery) ? curday + parseInt(ej.format(new Date(this._dateRender[i]), "dd", this.model.locale)) : curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass, cellWidth: this.model.cellWidth };
                    cols.push(temp);
                }
            }
            return cols;
        },

        _getHoriStartEndTime: function (localizeAmPm) {
            var templateValue = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)
            if (templateValue) {
                var userTemp = $.templates($(this.model.timeScale.majorSlotTemplateId).html());
                var userTemp1 = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
            }
            var startendTimes = [];
            var headercellWidth = (!this.model.cellWidth) ? this._safariBrowser ? "29px" : "30px" : this._safariBrowser ? (parseInt(this.model.cellWidth) - 1 + "px") : this.model.cellWidth;
            var daysCount = this.currentView() == "week" ? 7 : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : this.model.workWeek.length;
            for (var day = 0; day < daysCount; day++) {
                if (templateValue) {
                    var dateValue = new Date(new Date().setHours(0, 0, 0, 0));
                    var j = 0, timelist1 = [];
                    for (var i = this.model.startHour; i < this.model.endHour;) {
                        var value = this.model.timeScale.majorSlot + j;
                        var jvalue = j;
                        while (j < value) {
                            var jval = j;
                            j = j * 60 * 1000;
                            if (templateValue) {
                                if (jval == jvalue)
                                    var timelist = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) ? userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }) : userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) });
                                else if (!ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId))
                                    timelist1.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());

                            }
                            else {
                                if (this._timeMode == "12") {
                                    var timelist = ((i === this.model.startHour || i === 12) && (localizeAmPm.AM && localizeAmPm.PM) && j == 0) ? ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh tt", this.model.locale) : ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh:mm tt", this.model.locale);
                                    startendTimes.push({ time: timelist, id: i + "_" + j, timecellclass: ((i == this.model.startHour && day != 0 && j == 0)) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                                }
                                else
                                    startendTimes.push({ time: (i <= 9 ? "0" + i : i) + " 00", timecellclass: ((i % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount)) == this.model.startHour && day != 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                            }
                            j = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId) ? (j / (60 * 1000)) + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) : (j / (60 * 1000)) + this.model.timeScale.majorSlot;
                        }
                        i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : j >= 60 ? i + 1 : i;
                        j = (j >= 60) ? 0 : j;
                        if (templateValue) {
                            if (j == this.model.timeScale.majorSlot || j == 0) {
                                startendTimes.push({ time: timelist.trim(), times: timelist1, id: i + "_" + j, timecellclass: (((i - 1) == this.model.startHour) && day != 0 && j == 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                                timelist1 = [];
                            }
                        }
                    }
                }
                else {
                    var dateValue = new Date(new Date().setHours(0, 0, 0, 0));
                    for (var i = this.model.startHour; i < this.model.endHour;) {
                        var j = 0;
                        while (j < 60) {
                            j = j * 60 * 1000;
                            if (this._timeMode == "12") {
                                var timelist = ((i === this.model.startHour || i === 12) && (localizeAmPm.AM && localizeAmPm.PM) && j == 0) ? ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh tt", this.model.locale) : ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh:mm tt", this.model.locale);
                                startendTimes.push({ time: timelist, id: i + "_" + j, timecellclass: ((i == this.model.startHour && day != 0 && j == 0)) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                            }
                            else
                                startendTimes.push({ time: (i <= 9 ? "0" + i : i) + " 00", timecellclass: ((i % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount)) == this.model.startHour && day != 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                            j = (j / (60 * 1000)) + this.model.timeScale.majorSlot;
                        }
                        i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : i + 1;
                    }
                }
            }
            return startendTimes;
        },

        _getHorizontalDayAppointments: function (appointmentsList, dateCount, day, res) {
            var resAvail = [];
            for (var app = 0; app < appointmentsList.length; app++) {
                if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                    resAvail = new ej.DataManager(this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, ej.FilterOperators.equal, appointmentsList[app][this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 2]]));
                else resAvail = this.res1;
                if (resAvail.length != 0) {
                    if (new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() &&
                          new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources) ? appointmentsList[app][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()] == this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]] : true &&
                               new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) {
                        this._renderApp(appointmentsList[app], day, res);
                    }
                }
            }
        },

        _horiGroupCollection: function () {
            if ((this._tempResource.length != 0)) {
                var rIndex, temp = this._resourceSort(), temp1 = this.res1;
                var temp2 = temp.filter(function (a) { return temp1.indexOf(a) === -1; });
                if (ej.isNullOrUndefined(this.model.group)) this.res1 = ["0"];
                return temp2;
            }
        },

        _renderHorizontalApp: function (rStartTime, rEndTime, record, day, cellHeight, timeScaleRowCount, startHour, endHour) {
            var headerCell = this.element.find(".e-workcellstab tr"), appHeight, appWidth, topPosition = 0, leftPosition;
            if (rStartTime <= rEndTime) {
                var startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
                var endTime = ((new Date(rEndTime).getHours()) > endHour) ? (new Date(rEndTime).getHours() + (-new Date(rEndTime).getHours() + (endHour - startHour)) + (-new Date(rEndTime).getMinutes())) : (new Date(rEndTime).getHours() + (-startHour));
                endTime = (new Date(rEndTime).getHours() == endHour) ? (new Date(endTime).getMinutes() + (-new Date(rEndTime).getMinutes())) : endTime;
                appHeight = (this.element.find(".e-appointment").length > 0 ? this.element.find(".e-appointment").outerHeight(true) : this._getElementHeight("e-appointment"));
                var level = 0;
                if (this.model.startHour <= new Date(rStartTime).getHours() && this.model.endHour >= new Date(rStartTime).getHours()) {
                    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && this._grouping.length > 1) ? this._findResourceIndex(this._horiHeaderCollection, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()]) + 1 : 0;
                    var resValue = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) + 1 : 1;
                    var userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
                    var userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "";
                    appHeight = (!this.model.appointmentTemplateId) ? appHeight : ($(userTempHtml).css('height') == "100%" ? (!this.model.showOverflowButton ? this.initialCellHeight : (cellHeight - 15)) : $(userTempHtml).css('height') == "0px" ? appHeight : $(userTempHtml).height());
                    level = (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && !ej.isNullOrUndefined(this.model.group)) ? this._getOverlapCount(record, day, this._dateRender, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : this._getOverlapCount(record, day, this._dateRender, null);
                    this._renderedAllDay.push($.extend(true, {}, record));
                    topPosition = (level * appHeight) + topPosition;
                    var diffTime, diffDays, diffMinutes, cellIndex;
                    if (record[this._appointmentSettings["allDay"]]) {
                        diffTime = new Date(new Date(new Date(rEndTime).setHours(0, 0, 0, 0)).getTime()) - new Date(new Date(new Date(rStartTime).setHours(0, 0, 0, 0)).getTime());
                        diffDays = Math.round(diffTime / 86400000) + 1;
                        if (diffDays > this._dateRender.length)
                            diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
                        diffMinutes = (diffDays * (endHour - startHour) * 60);
                        cellIndex = ((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day;
                        appWidth = ((this.cellwidth / 30) * diffMinutes) + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 1);
                        leftPosition = "0";
                    }
                    else if (new Date(new Date(new Date(record[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) < new Date(new Date(new Date(record[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                        var endDiffer = (new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.endHour, 0, 0)) && new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0))) ? (((this.model.endHour) / 2) * 60) : ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
                        var startDiffer = new Date(rStartTime) > new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0)) ? (this.model.startHour * 60) : ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                        var i = 1, rEnd, rStart, end, start, diffTime;
                        rEnd = this._dateRender.indexOf(new Date(rEndTime).setHours(0, 0, 0, 0));
                        rStart = this._dateRender.indexOf(new Date(rStartTime).setHours(0, 0, 0, 0));
                        if (rEnd == -1) {
                            while (i < 7) {
                                if (new Date(this._dateRender[this._dateRender.length - i]).getTime() < new Date(rEndTime).setHours(0, 0, 0, 0)) {
                                    end = this._dateRender.length - i;
                                    endDiffer = this.model.endHour * 60;
                                    break;
                                }
                                else i++;
                            }
                        }
                        else
                            end = rEnd;
                        if (rStart == -1) {
                            start = day;
                            startDiffer = this.model.startHour * 60;
                        }
                        else
                            start = rStart;
                        diffTime = end - start;
                        diffMinutes = ((((diffTime) * ((endHour - startHour)) * 60) - startDiffer) + endDiffer);
                        cellIndex = Math.floor((((this.model.endHour - this.model.startHour) * timeScaleRowCount) * (60 / this.model.timeScale.majorSlot) * day) + ((rStart == -1) ? 0 : startTime * timeScaleRowCount) * (60 / this.model.timeScale.majorSlot));
                        appWidth = ((this.cellwidth / 30) * diffMinutes) + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 2);
                        if (diffDays > this._dateRender.length) {
                            diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
                            diffMinutes = ((diffDays) * (endHour - startHour) * 60);
                            appWidth = diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.cellwidth + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 3);
                        }
                        leftPosition = (rStart == -1 ? 0 : parseFloat((new Date(rStartTime).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * timeScaleRowCount / this.model.timeScale.majorSlot);
                    }
                    else {
                        leftPosition = (parseFloat((new Date(rStartTime).getMinutes() + (new Date(rStartTime).getMilliseconds() / 60))) * (this.cellwidth * this.model.timeScale.minorSlotCount) / this.model.timeScale.majorSlot) - 1;
                        if ((this.model.endHour - this.model.startHour) == 24)
                            var diffInMinutes = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) - ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                        else {
                            var endDiffer = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) > (this.model.endHour * 60) ? (this.model.endHour * 60) : ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
                            var startDiffer = ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes()) < (this.model.startHour * 60) ? (this.model.startHour * 60) : ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                            var diffInMinutes = endDiffer - startDiffer;
                        }
                        diffInMinutes += 1;
                        appWidth = diffInMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.cellwidth + ((diffInMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 2) + 1;
                        cellIndex = Math.floor((((this.model.endHour - this.model.startHour) * timeScaleRowCount) * (60 / this.model.timeScale.majorSlot) * day) + (startTime * timeScaleRowCount * (60 / this.model.timeScale.majorSlot)));
                    }
                    var colorAppointment = this._appointmentColor(record);
                    if ((!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0))
                        cellHeight = headerCell.eq((resValue + groupIndex) - 1).children().eq(cellIndex).height() + 1;
                    else cellHeight = cellHeight;
                    var indicationIcon = this._indicationApp(record);
                    if (topPosition + appHeight + 7 < cellHeight) {
                        var startTimeDisp = this._timeMode == "12" ? ej.format(new Date(record[this._appointmentSettings["startTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["startTime"]]), "HH:mm", this.model.locale),
                            endTimeDisp = this._timeMode == "12" ? ej.format(new Date(record[this._appointmentSettings["endTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["endTime"]]), "HH:mm", this.model.locale),
                            recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                            timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" })),
                            celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex);
                        (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                        celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                    }
                    else {
                        if (this.model.showOverflowButton) {
                            var overflowIconIndex = cellIndex + Math.round(new Date(rStartTime).getMinutes() / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount));
                            if ($("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex).length == 0) {
                                var celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(overflowIconIndex);
                                var overflowhtml = '<div id="' + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex + '" class="e-icon e-arrowhead-down e-appsoverflow" cellinfo="' + this._dateRender[day] + '"></div>';
                                celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(overflowhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(overflowhtml));
                                topPosition = cellHeight - this.element.find('.e-appsoverflow').height();
                                this.element.find("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex).css(this.model.enableRTL ? "right" : "left", (this.cellwidth - 25) + "px").css("top", topPosition + "px");
                            }
                            $("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex).attr("appcount", level + 1);
                        }
                        else {
                            this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).children().css('height', cellHeight + appHeight - 1 + "px");
                            this.element.find(".e-resourceheadertable tr").eq(resValue + groupIndex - 1).find(".e-childnode").css('height', cellHeight + appHeight - 1 + "px");
                            var startTimeDisp = (this._timeMode == "12") ? ej.format(new Date(record[this._appointmentSettings["startTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["startTime"]]), "HH:mm", this.model.locale),
                                endTimeDisp = (this._timeMode == "12") ? ej.format(new Date(record[this._appointmentSettings["endTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["endTime"]]), "HH:mm", this.model.locale),
                                recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" })),
                                celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex);
                            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                            this._overflowFlag = true;
                        }
                    }
                    if (!ej.isNullOrUndefined(indicationIcon)) {
                        if (indicationIcon.leftIndication)
                            this.model.enableRTL ? this.element.find(".e-appointment").filter('div[guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-left", "11px") : this.element.find(".e-appointment").filter('div[guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-left", "13px");
                        if (indicationIcon.rightIndication)
                            this.model.enableRTL ? this.element.find(".e-appointment").filter('div[guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-right", "13px") : this.element.find(".e-appointment").filter('div[guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-right", "11px");
                    }
                    if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                        this._renderAppointmentCategory(this._horiHeaderCollection, groupIndex, cellIndex, record, appWidth, leftPosition);
                }
            }
        },

        _renderAppointmentCategory: function (resCollection, groupIndex, cellIndex, record, appWidth, leftPosition) {
            var appointColor, categoryClass, index = 0, rGroupId, resIndex, rObject = [], rIndex;
            var resHeaderHeight = this.element.find(".e-resourceheadercells").height();
            if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 0) {
                appointColor = this._getResourceColor(record);
                categoryClass = (appointColor.appointData == "") ? "e-categorycolor" : "";
                groupIndex -= 1;
                appWidth = (this.currentView() == "month" || this._isCustomMonthView()) ? appWidth : appWidth + 2;
                do {
                    var celltd = this.element.find(".e-resourceheadertr").eq(groupIndex).find("td.e-workcells").eq(cellIndex);
                    var categorybarhtml = this.model.enableRTL ? ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (resHeaderHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;right:" + leftPosition + "px;'></div>") : ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (resHeaderHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;left:" + leftPosition + "px;'></div>");
                    celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(categorybarhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(categorybarhtml));
                    if (this._tempResource.length > 2) {
                        for (var a = this._tempResource.length - 2; a >= 0; a--) {
                            index = this._tempResource[a].resourceSettings.dataSource.indexOf(resCollection[groupIndex]);
                            if (index != -1) {
                                index = a;
                                rGroupId = this._tempResource[a].resourceSettings.groupId;
                                if (ej.isNullOrUndefined(rGroupId))
                                    return;
                                break;
                            }
                        }
                        resIndex = (index == 0) ? index : index - 1;
                        rObject = new ej.DataManager(resCollection).executeLocal(new ej.Query().where(this._tempResource[resIndex].resourceSettings.id, ej.FilterOperators.equal, resCollection[groupIndex][rGroupId]));
                        rIndex = this._tempResource[0].resourceSettings.dataSource.indexOf(rObject[0]);
                        if (rIndex == 0) {
                            rObject = [];
                            if (this._tempResource.length > 2) {
                                var celltd = this.element.find(".e-resourceheadertr").eq(rIndex).find("td.e-workcells").eq(cellIndex);
                                var categorybarhtml = this.model.enableRTL ? ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (resHeaderHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;right:" + leftPosition + "px;'></div>") : ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (this.element.find(".e-resourceheadercells").height()) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;left:" + leftPosition + "px;'></div>");
                                celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(categorybarhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(categorybarhtml));
                            }
                        }
                        else (rObject.length != 0) ? groupIndex = resCollection.indexOf(rObject[0]) : "";
                    }
                } while (rObject.length != 0)
            }
        },

        _getHorizontalOverlapCount: function (appointments, dateRender, day, record, resValue) {
            var filterData = [];
            for (var i = 0, len = appointments.length; i < len; i++) {
                if (ej.scheduleFeatures.resources && (this._tempResource.length > 0) && this._grouping.length > 0) {
                    if ((new Date(new Date(appointments[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (new Date(new Date(appointments[i][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (((new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]])))
                        && ((resValue != null) ? (resValue == appointments[i][this._tempResource[this._tempResource.length - 1]["field"]]) : resValue == null))) {
                        filterData.push(appointments[i]);
                    }
                }
                else {
                    if ((new Date(new Date(appointments[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (new Date(new Date(appointments[i][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (((new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]]))))) {
                        filterData.push(appointments[i]);
                    }
                }
            }
            return filterData;
        },

        _renderHorizontalHeaderBar: function () {
            var customview = this._isCustomMonthView(), view = this.model.timeScale.enable ? (this._isCustomMonthView()) ? "month" : this.currentView() : "month";
            var viewColCount = view == "day" ? 1 : view == "week" ? 7 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : this.model.workWeek.length;
            this._strTime = this._getStartEndTime();
            var colValue = this._columnTimeScale(this._strTime);
            this.datesColumn = this._getHeaderAllDayCellsCount();
            if (view === 'month' || (this._isCustomMonthView())) {
                this.datesColumn = [], this.monthDays = [], this.totdays = [];
                for (var i = 0; i < this._dateRender.length; i++) {
                    if (this.currentView() === "month" || (this._isCustomMonthView() && this._oneWeek)) {
                        if (new Date(this.currentDate()).getMonth() === new Date(this._dateRender[i]).getMonth())
                            this.totdays.push(this._dateRender[i]);
                    }
                    else
                        this.totdays.push(new Date(this._dateRender[i]));
                }
                var date = this.totdays.length;
                if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && (this.currentView() == "day" || this.currentView() == "week" || this.currentView() == "workweek" || (this.currentView() == "customview" && this._oneWeek))) {
                    var temp, columns = this._getUserDateheaderTemplate();
                    for (i = 0; i < date; i++) {
                        temp = { currentDate: columns[i].currentDay, currentDateClass: "", currentDay: this.currentView() == "day" ? this._dayFullNames[new Date(this.totdays[i]).getDay()] : this._dayShortNames[new Date(this.totdays[i]).getDay()].toString(), cellWidth: !this.model.cellWidth ? "100%" : this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: (new Date(this.totdays[i]).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime() ? "e-currentdayhighlight" : "") };
                        this.datesColumn.push(temp);
                        this.monthDays.push(this.totdays[i]);
                    }
                }
                else {
                    var temp, curdate, headerCellClass;
                    for (var i = 0; i < date; i++) {
                        headerCellClass = (new Date(this.totdays[i]).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-currentdayhighlight" : "";
                        curdate = customview && new Date(this.totdays[i]).getDate() == 1 ? (ej.format(new Date(this.totdays[i]), "MMM", this.model.locale) + " " + new Date(this.totdays[i]).getDate()) : ej.format(new Date(this.totdays[i]), "dd", this.model.locale);
                        if (this.model.timeScale.enable)
                            temp = { daynameTitle: ej.format(new Date(this.totdays[i]), "dddd", this.model.locale), title: new Date(this.totdays[i]).toDateString(), currentDate: curdate, currentDateClass: "", currentDay: this._dayFullNames[new Date(this.totdays[i]).getDay()].toString().slice(0, 1), cellWidth: (!this.model.cellWidth && this.currentView() != "month" && !(this._isCustomMonthView())) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: headerCellClass };
                        else {
                            if (this.currentView() == "day" || this.currentView() == "week" || this.currentView() == "workweek")
                                temp = { daynameTitle: ej.format(new Date(this.totdays[i]), "dddd", this.model.locale), title: new Date(this.totdays[i]).toDateString(), currentDate: curdate, currentDateClass: "", currentDay: this.currentView() == "day" ? this._dayFullNames[new Date(this.totdays[i]).getDay()] : this._dayShortNames[new Date(this.totdays[i]).getDay()].toString(), cellWidth: !this.model.cellWidth ? "100%" : this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: headerCellClass };
                            else
                                temp = { daynameTitle: ej.format(new Date(this.totdays[i]), "dddd", this.model.locale), title: new Date(this.totdays[i]).toDateString(), currentDate: curdate, currentDateClass: "", currentDay: this._dayFullNames[new Date(this.totdays[i]).getDay()].toString().slice(0, 1), cellWidth: this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: headerCellClass };
                        }
                        this.datesColumn.push(temp);
                        this.monthDays.push(this.totdays[i]);
                    }
                }
            }
            var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) ? true : false;
            var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) ? true : false;
            if (userTemplateId || template) {
                var userTemp = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
                var userTemp1 = $.templates($(this.model.timeScale.majorSlotTemplateId).html());
                var timeValue1 = [], j = 0;
                for (var i = this.model.startHour; i < this.model.endHour;) {
                    var timeValue = [];
                    var value = this.model.timeScale.majorSlot + j;
                    var jvalue = j;
                    while (j < value) {
                        var jval = j;
                        j = j * 60 * 1000;
                        if (this._timeMode == "12") {
                            if (jval == jvalue && !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId))
                                timeValue.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                            else
                                timeValue.push(userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                        }
                        j = (j / 60000) + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    }
                    i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : j >= 60 ? i + 1 : i;
                    j = (j >= 60) ? 0 : j;
                    timeValue1.push(timeValue);
                }
                template = true;
            }
            var multiResources = ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? true : false;
            if (userTemplateId || template)
                var html = this.userTimeCellHoriTemplate.render({ cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), multiRes: multiResources, view: view, timeTdCount: this._strTime, colspan: view == "month" ? 1 : (this._strTime.length / viewColCount) * 2, heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: colValue, userTemplateId: userTemplateId, template: template });
            else
                var html = this.horizontalHeader.render({ tablelayout: customview ? "e-fixedlayout" : '', cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), multiRes: multiResources, view: view, timeTdCount: this._strTime, colspan: view == "month" ? 1 : (this._strTime.length / viewColCount) * 2, heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: colValue });
            this.aTR.append(html);
        },

        _renderHorizontalContent: function ($contentAreaDiv, $contentTable, $contentBody, $contentTR, $WorkCellTD, $scrollerbarDiv) {
            var templateValue = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId);
            var trCount, resHtml, columnValue = [], value = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            var strTime = this._strTime;
            columnValue = this._columnValue;
            if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                resHtml = this._renderHorizontalResources();
                trCount = this._horiResources;
            }
            else {
                resHtml = "";
                trCount = [{ classname: "e-childnode" }];
            }
            var userTemplate = (!ej.isNullOrUndefined(this.model.workCellsTemplateId)) ? true : false;
            if (userTemplate) { var workHtml = this._getUserWorkCellsTemplate(); }
            var workCellhtml = this.cellTemplate.render({ cellrows: trCount, hourdiff: Math.ceil(((this.model.endHour - this.model.startHour)) * (60 / this.model.timeScale.majorSlot)), view: this.model.timeScale.enable ? (this._isCustomMonthView()) ? "month" : this.currentView() : "month", cols: (this.model.timeScale.enable ? this.currentView() == 'month' || (this._isCustomMonthView()) ? this.datesColumn : strTime : this.datesColumn), column: columnValue, userTemplate: userTemplate, userHtml: workHtml });
            if (resHtml == "")
                this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
            else
                this.wTR.append(ej.buildTag('td.e-horizontalrestd', {}, {}, { width: "15%", height: "100%" }).append(resHtml)).append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
        },
        _columnTimeScale: function (strTime) {
            this._columnValue = [], _cols2 = [];
            var value = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            var templateValue = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplate) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplate);
            var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplate) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplate)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplate)) ? true : false;
            var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplate)) ? true : false;
            if (!templateValue) {
                for (var j = 0; j < strTime.length; j++) {
                    for (var i = 0; i < this.model.timeScale.minorSlotCount - 1; i++) {
                        value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                        if (value > (this.model.endHour - this.model.startHour) * 60) {
                            _cols2.push(i);
                            if (i == (this.model.timeScale.minorSlotCount - 2)) {
                                value = 0;
                                break;
                            }
                        }
                        else
                            _cols2.push(i);
                    }
                    this._columnValue.push(_cols2);
                    value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    _cols2 = [];
                }
            }
            else {
                for (var j = 0; j < strTime.length; j++) {
                    this._columnValue.push(j);
                }
            }
            return this._columnValue;
        },

        _getResourceHeadTemplate: function (record) {
            var userTemp = $.templates($(this.model.resourceHeaderTemplateId).html());
            var userTempHtml = userTemp.render(record);
            return userTempHtml;
        },

        _renderHorizontalResources: function () {
            this._resCollect = []; this._horizontalResRender = []; this._horiResources = [];
            var view = this.currentView();
            var viewColCount = view == "day" ? 1 : view == "week" || view == "month" || (this._isCustomMonthView()) ? 7 : this.model.workWeek.length;
            var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
            if (!ej.isNullOrUndefined(this.model.group)) {
                if (this._grouping.length === 1) {
                    var index;
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i]);
                    }
                    for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
                        this._horiResources.push({ cellHeight: this.model.cellHeight, name: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], idnum: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].id], classname: "e-childnode", marginleft: "10px", width: "10px", backgroundcolor: "", border: "1px solid #bbbcbb", bordertop: "", userResHeader: this._getResourceHeadTemplate($.extend(this._resourceInfo[index].dataSource[i], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                        this._resCollect.push(this._resourceInfo[index].dataSource[i]);
                    }
                    this._horizontalResRender.push(this._resCollect);
                }
                else {
                    var tempResource1 = this._resourceSort();
                    for (var a = 0; a < tempResource1.length; a++) {
                        for (var b = 0; b < this.render_Resources.length; b++) {
                            var rIndex = this.render_Resources[b].indexOf(tempResource1[a]);
                            if (rIndex != -1) {
                                index = b;
                                break;
                            }
                        }
                        if (index == this.render_Resources.length - 1) {
                            this._horiResources.push({ cellHeight: this.model.cellHeight, name: tempResource1[a][this._tempResource[index].resourceSettings.text], classname: "e-childnode", marginleft: ((this._mediaQuery) ? (index * 11) : (index * 21)) + "px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "", userResHeader: this._getResourceHeadTemplate($.extend(tempResource1[a], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                            this._resCollect.push(tempResource1[a]);
                        }
                        else {
                            this._horiResources.push({ cellHeight: this.model.cellHeight, name: tempResource1[a][this._tempResource[index].resourceSettings.text], idnum: tempResource1[a][this._tempResource[index].resourceSettings.id] + "_" + tempResource1[a][this._tempResource[index].resourceSettings.groupId], classname: "e-parentnode", marginleft: (index * 10) + "px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "", userResHeader: this._getResourceHeadTemplate($.extend(tempResource1[a], { classname: "e-parentnode" })), userResTemplId: userResTemplId });
                            this._resCollect.push(tempResource1[a]);
                        }
                    }
                    this._horizontalResRender.push(this._resCollect);
                }
            }
            else {
                for (var k = 0; k < this._tempResource.length; k++) {
                    this._horizontalResRender.push(this._tempResource[k].resourceSettings.dataSource);
                    this._resCollect.push(this._tempResource[k].resourceSettings.dataSource);
                }
            }
            var html = this.horizontalResHeader.render({ trs: this._horiResources });
            return html;
        },

        _horizontalResIcon: function () {
            var resCat = this.element.find(".e-parentnodecategory"), resId, cIndex, resAvail, count;
            for (var a = 0; a < resCat.length; a++) {
                resId = resCat[a].id.split("_")[0];
                for (var b = 0; b < this._tempResource.length; b++) {
                    cIndex = new ej.DataManager(this._tempResource[b].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[b].resourceSettings.id, ej.FilterOperators.equal, resId));
                    if (cIndex.length != 0) { cIndex = b; break; }
                }
                count = cIndex + 1;
                count = (count == this._tempResource.length) ? count - 1 : count;
                for (var c = 0; c < this._tempResource.length; c++) {
                    resAvail = new ej.DataManager(this._resourceSort()).executeLocal(new ej.Query().where(this._tempResource[count].resourceSettings.groupId, ej.FilterOperators.equal, resId));
                    if (resAvail.length == 0) { $(resCat[a]).removeClass("e-resourceicon e-resourcecollapse"); }
                    break;
                }
            }
        },

        _renderHorizontalCurrentTime: function () {
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                if (this.element.find("td.e-headerToday").length > 0) {
                    this.element.find('.e-horizontaltabletimecell').parent().append('<div id="' + this._id + '_HighlightCurrentTimeline" class="e-highlightcurrenttimeline" style="height: 92%; width: 2px; position: absolute; background-color: red; "></div>');
                    $('#' + this._id + '_HighlightCurrentTimeline').css("top", this.element.find('.e-headerdays tr')[1].offsetTop);
                }
            }
            else {
                var monthDays = this.monthDays;
                var target = this.element.find(".e-headerdays").find("table").find("td");
                for (var i = 0; i < monthDays.length; i++) {
                    if (new Date(new Date(monthDays[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                        $(target[i]).addClass("e-monthcurrenttime");
                }
            }
        },

        _horizontalTimePosition: function (temp, now) {
            if (temp.element.find("td.e-headerToday").length > 0) {
                var headertodaypos = temp.element.find("td.e-headerToday")[0].cellIndex;
                var cellIndex = (((temp.model.endHour - temp.model.startHour) * ((60 / temp.model.timeScale.majorSlot) * temp.model.timeScale.minorSlotCount)) * headertodaypos) + ((now.getHours() - temp.model.startHour) * ((60 / temp.model.timeScale.majorSlot) * temp.model.timeScale.minorSlotCount));
                var leftPosition = (parseFloat((now.getMinutes())) * (temp.element.find(".e-workcells")[1].offsetWidth) * temp.model.timeScale.minorSlotCount / temp.model.timeScale.majorSlot);
                $('#' + temp._id + '_HighlightCurrentTimeline').css("left", (cellIndex * temp.element.find(".e-workcells")[1].offsetWidth) + leftPosition);
            }
        },

        _horizontalBusinessHighlight: function (renderDates, bStartHour, bEndHour, timeRowsCount, target) {
            var tdLength = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? this._horiResources.length : 1;
            if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                for (var res = 0; res < tdLength; res++) {
                    for (var k = 0; k < renderDates.length; k++) {
                        for (var j = 0; j < this.model.workWeek.length; j++) {
                            if (this._dayNamesArray.indexOf(this.model.workWeek[j]) == new Date(renderDates[k]).getDay()) {
                                $($(this.element.find(".e-workcellstab tr")[res]).find(".e-workcells")[((bStartHour * timeRowsCount) + ((this.model.endHour - this.model.startHour) * timeRowsCount * k)) - 1]).nextAll(".e-workcells").slice(0, ((bEndHour * timeRowsCount) - (bStartHour * timeRowsCount))).addClass("e-businesshighlightworkcells");
                            }
                        }
                    }
                }
            }
            else {
                var monthDays = this.monthDays;
                target = this.element.find(".e-workcells"); target.removeClass("e-monthcellhighlight");
                for (var res = 0; res < tdLength; res++) {
                    for (var i = 0; i < monthDays.length; i++) {
                        for (var j = 0; j < this.model.workWeek.length; j++) {
                            if (this._dayNamesArray.indexOf(this.model.workWeek[j]) == new Date(monthDays[i]).getDay())
                                $($(this.element.find(".e-workcellstab tr")[res]).find(".e-workcells")[i]).addClass("e-monthcellhighlight");
                        }
                    }
                }
            }
        },

        _onResourceClick: function (e) {
            var index, target, hide, show, tempRes, resCount, pNode, newResCollection, resHeadTable = [], resWorkTable = [];;
            target = $(e.currentTarget);
            if (target.hasClass("e-resourceicon e-resourcecollapse")) {
                target.removeClass("e-resourceicon e-resourcecollapse").addClass("e-resourceicon e-resourceexpand");
                hide = true;
            }
            else {
                target.removeClass("e-resourceicon e-resourceexpand").addClass("e-resourceicon e-resourcecollapse");
                show = true;
            }
            if (!this.model.cellHeight) {
                this.element.find(".e-workcellstab").css('height', '100%');
                this.element.find(".e-resourceheadertable").css('height', '100%');
            }
            index = $(e.currentTarget).closest("td.e-parentnode").parent().index();
            newResCollection = this._getResourceCollection();
            for (i = 0; i < newResCollection.length; i++) {
                tempRes = new ej.DataManager(this._tempResource[i].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[i].resourceSettings.id, ej.FilterOperators.equal, e.currentTarget.id.split("_")[0]));
                if (tempRes.length != 0) {
                    resCount = tempRes[0].count;
                    break;
                }
            }
            for (var a = 0; a < resCount; a++) {
                resHeadTable.push(this.element.find(".e-resourceheadertable tr")[index + a + 1]);
                resWorkTable.push(this.element.find(".e-workcellstab tr")[index + a + 1]);
            }
            for (var i = 0; i < resHeadTable.length ; i++) {
                if (hide) {
                    pNode = $(resHeadTable[i]).children().hasClass("e-parentnode");
                    if (pNode) $(resHeadTable[i]).find(".e-parentnodecategory").removeClass("e-resourceicon e-resourcecollapse").addClass("e-resourceicon e-resourceexpand");
                    if ($(resHeadTable[i]).is(":visible")) {
                        $(resHeadTable[i]).toggle();
                        $(resWorkTable[i]).toggle();
                    }
                }
                else {
                    pNode = $(resHeadTable[i]).children().hasClass("e-parentnode");
                    if (pNode) $(resHeadTable[i]).find(".e-parentnodecategory").removeClass("e-resourceicon e-resourceexpand").addClass("e-resourceicon e-resourcecollapse");
                    if ($(resHeadTable[i]).is(":hidden")) {
                        $(resHeadTable[i]).toggle();
                        $(resWorkTable[i]).toggle();
                    }
                }
            }
            this.element.find(".e-horires").height(this.element.find(".e-draggableworkarea").height());
            this._horizontalRender();
            if (this.model.cellHeight) this._reRenderScroller();
            if (this._mediaQuery) this.refreshScroller();
            this._horizontalResIcon();
            this.element.find("div.e-prevapp,div.e-nextapp").remove();
            this.element.find(".e-categorybar").height(this.element.find(".e-parentworkcell").height() - 3);
            this._businessHourScroller();
            this._renderAppointmentAll();
        },

    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {

    ej.ExcelFilter = ej.ExcelFilter || {};
    "use strict"
    ej.excelFilter = function (options) {
        this._ctrlInstance = options["instance"];
        this.id = this._ctrlInstance._id;
        this._dialogContainer = null;
        this._showSort = options["showSortOptions"] || false;
        this._interDeterminateState = options["interDeterminateState"] || false;
        this._maxCount = ej.isNullOrUndefined(options["maxFilterLimit"]) ? 1000 : options["maxFilterLimit"];
        this._formatFiltering = true;
        this._locale = this._ctrlInstance.model.locale || "en-US";
        this.localizedLabels = this._getLocalizedLabel();
        this._filterHandler = options["filterHandler"] || null;
        this._searchHandler = this._ctrlInstance.model.searchSettings || null
		this._cancelHandler = options["cancelHandler"] || null;
		this._customFilterHandler = options["customFilterHandler"] || null;
        this._cssClass = options["cssClass"] || null;
        this._matchCase = options["allowCaseSensitive"] || false;
        this._title = options["title"] || this.localizedLabels.title;
        this._complexBlankCriteria = options["enableComplexBlankFilter"];
        this._blankValue = options["blankValue"];
        this.fName = options["initFilterCol"] || null;
        this._spliter = options["valueDelimiter"] || ej.ExcelFilter.valueDelimiter;
        this._initialFName = this.fName;
        this._displayName = null;
        this._dataSource = null;
        this._isUrlAdaptor = false;
		this._$tableID = null;
        this._$blankVal = null;
        this._$selectedColors = [];
        this._$enableColor = false;
        this._$filteredByColor = "";
        this._$colType = null;
        this._$key = 0;
        this.filteredColumn = null;
        this.sortedColumns = null;        
        this._chkList = null;
        this._listsWrap = null;
        this._menuWrap = null;
        this._localJSON = null;
        this._actualCount = 0;
        this._totalRcrd = 0;
        this._enableResponsiveRow=false;
        this._searchCount = 0;
        this._currentData = null;
        this._openedFltr = null;
        this._predicates = [];
        this.cFilteredCols = this.fName!=null ? [this.fName] : [];
        this._columnsFiltered = [];
        this.guid = ej.getGuid("excelfilter");
        this._noDlg = [];
        this._sepAftr = ["sortDesc","notequal", "between", "top10","endswith","contains"];
        this._posType = ["number", "date", "datetime", "string", "boolean","guid"];
        this._empties = !this._complexBlankCriteria ? [this.guid] : ["null", "undefined", ""];
        this._reqInProgess = false;
        this._isFiltered = false;
        this._onActionBegin = options["actionBegin"] || null;
        this._onActionComplete = options["actionComplete"] || null;
        this.maxItemOnQuery = 0; /*To prevent OData URI queryString length*/
        this.enableNormalize = true; /*To clean up redundant values after formatting */
        this.enableSelect = false;
        this._onDemandSearch = false;
        this._maxFilterCount = false;
        this._clearSearchValue = false;
        this._islargeData = false;
        this._checkedValue = [];
        this._searchRequest = false;
        this._isIndeterminate = false;
        this._selectAll = "<div class='e-ftrchk'><input type='checkbox' class='e-selectall' value='selectall' class='e-ftrchk' /><label class='e-ftrchk'>(" + this.localizedLabels.SelectAll + ")</label></div>";
        this._blanks = "<div class='e-ftrchk'><input type='checkbox' id='blanks' class='e-ftrchk' value='" + this._empties.join(this._spliter) + "' @@/><label class='e-ftrchk' for='blanks' value=''>(" + this.localizedLabels.Blanks + ")</label></div>";
        this._blank = undefined;
        this._addAtLast = false;
		this.guidMenuOpt = [
              { id: 1, text: this.localizedLabels.SortNoSmaller, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortNoLarger, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.GuidFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.GuidMenuOptions }];
        this.numberMenuOpt = this.booleanMenuOpt = [
              { id: 1, text: this.localizedLabels.SortNoSmaller, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortNoLarger, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.NumberFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.NumberMenuOptions }];
        this.stringMenuOpt = [
              { id: 1, text: this.localizedLabels.SortTextAscending, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortTextDescending, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.TextFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.StringMenuOptions }];
        this.dateMenuOpt = [
              { id: 1, text: this.localizedLabels.SortDateOldest, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortDateNewest, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.DateFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.DateMenuOptions }];
        this.datetimeMenuOpt = [
              { id: 1, text: this.localizedLabels.SortDateOldest, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortDateNewest, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.DateTimeFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.DatetimeMenuOptions }];
        return this;
    };
    ej.excelFilter.prototype = {
        //Helpers to handle (Blanks) value.
        isNotBlank: function (key, global) {
            var e = ej.isNullOrUndefined(key) || (key === ""||key===null);

            if (!global && (key === ""||key===null))/* Handle special case - since "" string sorted before all */
                this._addAtLast = true;

            return !e;
        },   
        _checkBlank: function (key) {         

            if (this.isNotBlank(key))
                return true;
            /*Ensure Blank value added only once */
            var ret = this._blank == undefined && !this._addAtLast;

            if (ret) this._blank = true;            

            return ret;
        },
        _getValueData: function (key, data) {
            var arr = this._empties;

            if (this.isNotBlank(key, true))
                arr = ej.distinct(data, this._$foreignKey || this.fName, false);

            return arr.join(this._spliter); /*Return value will be set to input element value attr*/
        },
        //Collection to predicate processing
        getPredicate: function (cols, field, updateModel) {
            this._isUrlAdaptor = this._ctrlInstance._dataSource() instanceof ej.DataManager && (this._ctrlInstance._dataSource().adaptor instanceof ej.UrlAdaptor || this._ctrlInstance._dataSource().adaptor instanceof ej.WebMethodAdaptor);
            var c, dis = field != undefined ? [field] : ej.distinct(cols, "field", false), collection, pred = {};
            for (var f = 0, flen = dis.length; f < flen; f++) {
                collection = new ej.DataManager(cols).executeLocal(new ej.Query().where("field", "equal", dis[f]));
                pred[dis[f]] = this.generatePredicate(collection);
                if (updateModel) {
                    this._predicates[this._$key] = this._predicates[this._$key] || {};
                    this._predicates[this._$key][dis[f]] = pred[dis[f]];
                }

            }
            return pred;
        },

        generatePredicate: function (cols) {
            var len = cols ? cols.length : 0, predicate, first;
            if (!len) return;
            first = this._updateDateFilter(cols[0]);
            if(this._isUrlAdaptor && (first.type == "date" || first.type == "datetime"))
                predicate = this._getDatePredicate(first);
            else
                predicate = first.ejpredicate ? first.ejpredicate : ej.Predicate(first.field, first.operator, first.value, first.ignoreCase || !first.matchcase);
            for (var p = 1; p < len; p++) {
                cols[p] = this._updateDateFilter(cols[p]);
                if (this._isUrlAdaptor && len > 2 && p > 1 && cols[p].predicate == "or"){
                    if (cols[p].type == "date" || cols[p].type == "datetime")                        
                        predicate.predicates.push(this._getDatePredicate(cols[p]));             
                    else
                        predicate.predicates.push(ej.Predicate(cols[p].field, cols[p].operator, cols[p].value, cols[p].ignoreCase || !cols[p].matchcase));
                }
                else{
                    if (this._isUrlAdaptor && (cols[p].type == "date" || cols[p].type == "datetime"))
                        predicate = predicate[cols[p].predicate](this._getDatePredicate(cols[p]));
                    else
                        predicate = cols[p].ejpredicate ? predicate[cols[p].predicate](cols[p].ejpredicate) : predicate[cols[p].predicate](cols[p].field, cols[p].operator, cols[p].value, cols[p].ignoreCase || !cols[p].matchcase);
                }
            }
            return predicate || null;
        },
        _getDatePredicate: function(predicate){
            return ej.Predicate(predicate.field, predicate.operator, predicate.value, predicate.ignoreCase || !predicate.matchcase);           
        },
        getFilterFrom: function (dm, data) {
            var data = ej.distinct(data, this.fName, false);
                        
            if (this.maxItemOnQuery > 0) data = data.slice(0, this.maxItemOnQuery);
                        
            return ej.UrlAdaptor.prototype.getFiltersFrom(data, new ej.Query().foreignKey(this._$foreignKey)); /*get [or] conditioned ejPredicate*/
        },
        /*Main Dialog*/
        renderDialog: function (type) {
            this._$colType = type;
            var dlgId = this.id + type + "_excelDlg";           
            //if ($("#" + dlgId).length != 0)
            //    return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-excelfilter e-dlgcontainer e-shadow");
            var $ul = ej.buildTag("ul#" + this.id + type + "_MenuItem");
            var menuData = this._getMenuData(type);
            $ul = this._createLiTag($ul, menuData, false);
            var $searchBox = ej.buildTag("span.e-searchbox e-fields").append(ej.buildTag("input#" + this.id + "_SearchBox.e-ejinputtext e-searchinput", {}, {}, { "type": "text", "placeholder": this.localizedLabels.Search })).append(ej.buildTag("span.e-search e-icon"))
            var $lbox = ej.buildTag("div#" + this.id + type + "_CheckBoxList.e-checkboxlist e-fields").append(ej.buildTag("div"));
            var $btns = this._createBtn();
            var $sBox = ej.buildTag("div.e-searchcontainer");            
            var $status = ej.buildTag("div.e-status e-fields e-hide", this.localizedLabels.CheckBoxStatusMsg);
            $dlg.append($ul);            
            $sBox.append($searchBox);
            $sBox.append($status);
            $sBox.append($lbox);
            $sBox.append($btns);
            $dlg.append($sBox);
            $dlg.appendTo(this._ctrlInstance.element);
            $dlg.css("display", "none");
            this._renderCustomFDlg(type);
            this._dialogContainer = $dlg;
            if(this._cssClass!=null)
                $dlg.addClass(this._cssClass);
            if (!this._showSort) {
                $ul.find(".e-fnsort").closest("li").css("display", "none");
                $ul.find("li.e-separator:first").css("display", "none");
            }
            this._lsitBoxTemplate();
            this._renderSubCtrls(type);
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                ej.ieClearRemover($searchBox.find("input")[0]);
            this._wireEvents();
        },
        _getDeprecatedLocalizedLabel: function (key) {
            if (["Ok", "OK"].indexOf(key) != -1)
                return this.localizedLabels.Ok || this.localizedLabels.OK;
        },
        _renderSubCtrls: function (type) {
            $("#" + this.id + type + "_MenuItem").ejMenu({ orientation: "vertical", width: 266, container: "#" + this.id, click: ej.proxy(this._menuHandler, this), enableRTL: this._ctrlInstance.model.enableRTL, enableSeparator: false });
            $("#" + this.id + type + "_OkBtn").ejButton({ text: this._getDeprecatedLocalizedLabel("OK"), showRoundedCorner: true, width: 60, click: ej.proxy(this._fltrBtnHandler, this), enabled: true });
            $("#" + this.id + type + "_CancelBtn").ejButton({ text: this.localizedLabels.Cancel, showRoundedCorner: true, width: 60, click: ej.proxy(this.closeXFDialog, this) });
            $("#" + this.id + type + "_CheckBoxList").ejScroller({ height: 130, width: 234, scroll: ej.proxy(this._virtualize,this) });
            $("#" + this.id + type + "_CheckBoxList").ejWaitingPopup({ showOnInit: false });
        },
        openXFDialog: function (options) {
			var obj;
            this.fName = options["field"];
            this._dataSource = options["dataSource"];
            this._$colType = options["type"] || "string";
            this._$format = options["format"] || "";
            this._enableResponsiveRow=options["enableResponsiveRow"];
            this.filteredColumn = options["filteredColumns"] || this._ctrlInstance.model.filterSettings.filteredColumns;
            this.sortedColumns = options["sortedColumns"] || this._ctrlInstance.model.sortSettings.sortedColumns;
            this._displayName = options["displayName"];
            this.query = options["query"] || new ej.Query();
            this._$key = options["key"] || 0;
			this._$tableID = options["tableID"];
			this._$blankVal = ej.isNullOrUndefined(this._$tableID) ? this._$blankVal : options["blank"];
            this._$selectedColors = options["selectedColors"] || [];
            this._$enableColor = options["enableColor"] || false;
            this._$filteredByColor = options["filteredByColor"] || this._$filteredByColor;
			this._$foreignField = options["foreignKeyValue"];
			this._$foreignData = options["foreignDataSource"];
			this._$foreignKey = options["foreignKey"];
			this._$foreignKeyType = options["foreignKeyType"];
			if (this._$foreignData instanceof ej.DataManager && (this._$foreignData.adaptor instanceof ej.ODataAdaptor || this._$foreignData.adaptor instanceof ej.ODataV4Adaptor || this._$foreignData.adaptor instanceof ej.WebApiAdaptor))
			    this.maxItemOnQuery = 50;
			$.extend(this.localizedLabels, options["localizedStrings"] || {});
            var args = { requestType : "filterbeforeopen", filterModel : this, columnName:this.fName, columnType: this._$colType };
            if (this._ctrlInstance._trigger(this._onActionBegin, args))
                return;
            if (this._openedFltr == null || !this._openedFltr.is($("#" + this.id + this._$colType + "_excelDlg"))) {
                this.closeXFDialog();
                this._openedFltr = $("#" + this.id + this._$colType + "_excelDlg");
            }
            this._listsWrap = $("#" + this.id + this._$colType + "_CheckBoxList");
            this._menuWrap = $("#" + this.id + this._$colType + "_MenuItem");
            this._searchBox = this._openedFltr.find(".e-searchbox input");
            this._setPosition(this._openedFltr, options["position"]);
            this._openedFltr.addClass(options["cssClass"]);
            this._openedFltr.fadeIn(300, function () {
            });
			var $popups = $("#" + this.id + this._$colType + "_MenuItem").find("li[ejfnrole='popup']");
            if (this._$enableColor) {
                this._createDivTag($popups.eq(0).find(".e-shadow"), this._$selectedColors, false, "sort");
                (this._$filteredByColor == -1 || (this._$filteredByColor.length < 1 || this._$filteredByColor === this.fName)) ? this._createDivTag($popups.eq(1).find(".e-shadow"),this._$selectedColors, false, "filter") : $popups.eq(1).addClass("e-disable-item");
            }    
            else 
                $popups.hide();
            this._isFiltered = this._predicates[this._$key] != undefined && this._predicates[this._$key][this.fName] != undefined;
            this._isFiltered = options["isFiltered"] || this._isFiltered;
            if ((this._$colType == "date" || this._$colType == "datetime") && this._$format == "")
                this._$format = this._$colType == "date" ? "{0:MM/dd/yyyy}" : "{0:MM/dd/yyyy hh:mm:ss}";
            this._processListData();
			obj = this._listsWrap.data("ejScroller");
            if(this._ctrlInstance.model.enableRTL && obj.isHScroll()){
				obj.scrollLeft(obj.content()[0].scrollWidth - obj.content()[0].clientWidth);
				obj.refresh();
			}
                        
            this._setDisable();
            var args = { requestType: "filterafteropen", filterModel: this, columnName: this.fName, columnType: this._$colType };
            if (this._ctrlInstance._trigger(this._onActionComplete, args))
                return;
        },
        closeXFDialog: function (e) {
            if (e != null) {
                var $target = $(e.target);
                if (!($target.closest("#" + this.id + this._$colType + "_CustomFDlg").length > 0 || $target.closest("#" + this.id + this._$colType + "_excelDlg").length > 0))
                    return;
            }            
            if (this._openedFltr) {
                if (!this._openedFltr.hasClass("e-dlgcustom")) {
                    this._openedFltr.fadeOut(300, function () {
                    });
                    this._listsWrap.ejWaitingPopup("hide");
                }
                else {
                    this._openedFltr.ejDialog("close");
                }
                !ej.isNullOrUndefined(this._cancelHandler) && this._cancelHandler();
                this.resetFilterModel();/*Reset private properties after filter closed*/
                this._ctrlInstance._$fDlgIsOpen = false;
            }
        },
        _setPosition: function (ele, pos) {
            ele.css("position", "absolute");
            ele.css("left", pos["X"]).css("top", pos["Y"]);                      
        },
        _setDisable: function () {
            var $clr = this._menuWrap.find("li[ejfnrole='clearfilter']"), $fltr = this._menuWrap.find("li[ejfnrole='filterpopup']");
            var $sort = this._menuWrap.find("li[ejfnrole *= 'sort']"), $checked = this._listsWrap.find("input").filter(":checked:not(.e-selectall)").length;
            !this._isFiltered ? $clr.addClass("e-disable-item") : $clr.removeClass("e-disable-item");
            if (this._showSort) {
                var sQM = ej.DataManager(this.sortedColumns).executeLocal(new ej.Query().where("field", "equal", this.fName));
                ( sQM.length && sQM[0]["direction"] == "ascending") ? $sort.filter("[ejfnrole='sortAsc']").addClass("e-disable-item") : $sort.filter("[ejfnrole='sortAsc']").removeClass("e-disable-item");
                (sQM.length && sQM[0]["direction"] == "descending") ? $sort.filter("[ejfnrole='sortDesc']").addClass("e-disable-item") : $sort.filter("[ejfnrole ='sortDesc']").removeClass("e-disable-item");
            }
            var $flteredList = $fltr.find(".aschild");
            if (this.cFilteredCols.length != 0 && $.inArray(this.fName,this.cFilteredCols) != -1) {
                for (var f = 0; f < this.filteredColumn.length; f++) {
                    if (this.filteredColumn[f].field == this.fName) {
                        if ($flteredList.find("#ejFiltercheck").length == 0) {
                            $flteredList.append("<input type='checkbox' id='ejFiltercheck' />");
                            $flteredList.find("#ejFiltercheck").ejCheckBox({ checked: true });
                            $flteredList.find("#ejFiltercheck").ejCheckBox("disable");
                        }
                        if ($fltr.find(".e-shadow .e-exceltick").length > 0)
                            $fltr.find(".e-shadow .e-exceltick").remove();
                        if (this.filteredColumn[f].field == this.fName && !ej.isNullOrUndefined(this.filteredColumn[f + 1]) && this.filteredColumn[f + 1].field == this.fName && (this._$foreignField && this.filteredColumn[f + 1].customFilter || !this._$foreignField)) {
                            if (this.filteredColumn[f].operator == "greaterthanorequal" && this.filteredColumn[f + 1].operator == "lessthanorequal")
                                $fltr.find(".e-shadow .e-list[ejvalue=between]").find("a").append("<span class='e-exceltick e-icon' />");
                            else
                                $fltr.find(".e-shadow .e-list[ejvalue=customfilter]").find("a").append("<span class='e-exceltick e-icon' />");
                        }
                        else if (this._$foreignField)
                            $fltr.find(".e-shadow .e-list[ejvalue=" + this.filteredColumn[f].actualFilterOperator + "]").find("a").append("<span class='e-exceltick e-icon' />");
                        else
                            $fltr.find(".e-shadow .e-list[ejvalue=" + this.filteredColumn[f].operator + "]").find("a").append("<span class='e-exceltick e-icon' />");
                        break;
                    }
                }
            }
            else {
                for (var f = 0; f < this.filteredColumn.length; f++) {
                    if (this.filteredColumn[f].field == this.fName) {
                        this._removeTick($fltr,$flteredList);
                        break;
                    }
                }
            }
            if (!this._isFiltered && $flteredList.find("#ejFiltercheck").length != 0) {
                 this._removeTick($fltr,$flteredList);
            }
            if (this._$colType == "boolean")
                this._menuWrap.find("li[aria-haspopup=true]").addClass("e-hide");            
            this._searchBox.val(""); this._searchBox.siblings().addClass("e-search").removeClass("e-cancel");
        },
        _removeTick: function($fltr,$flteredList){
            $flteredList.find("#ejFiltercheck").ejCheckBox("destroy");
            $fltr.find(".aschild #ejFiltercheck").remove();
            $fltr.find(".e-shadow .e-exceltick.e-icon").remove();
        },
        _createBtn: function (isCDlg) {
            var id = isCDlg ? this.id + this._$colType + "Custom" : this.id + this._$colType;
            var $divCon = ej.buildTag("div.e-btncontainer e-fields");
            var $div = ej.buildTag("div");
            $div.append(ej.buildTag("input#" + id + "_OkBtn.e-fltrbtn e-btnsub e-flat", {}, {}, { type: "button" })).append(ej.buildTag("input#" + id + "_CancelBtn.e-fltrbtn e-btncan e-flat", {}, {}, { type: "button" }));
            return $divCon.append($div);
        },
        _menuHandler: function (args) {
            var $ele = $(args.element);
            var role = $ele.attr("ejfnrole");
            var arg = {};
            if (role === "filterbgcolor" || role === "filterfgcolor") {
                var fDetails = { field: this.fName, operation: role, color: $(args.element).css('background-color')};
			    arg = { originalEvent: args.event, action: "filterbycolor", filterDetails: fDetails, tableID: this._$tableID }; 
                this._isFiltered = false;
            }
            else if (role == "clearfilter") {
                var ftrDetails = { field: this.fName, operator: "", value: "", predicate: "or" };
                arg = { originalEvent: args.event, fieldName: this.fName, action: "clearfiltering", filterDetails: ftrDetails, tableID: this._$tableID };
                var indx = $.inArray(this.fName, this.cFilteredCols);
                indx!=-1 && this.cFilteredCols.splice(indx, 1);
				var $cIndx = $.inArray(this.fName, this._columnsFiltered);
                $cIndx!=-1 && this._columnsFiltered.splice($cIndx, 1);
                if (this._initialFName == this.fName)
                    this._initialFName = null;
            }
            else if(role == "popup" || role == "filterpopup") {
                return;
            }
            else if (role == "operator") {
                this._openCustomFilter($ele.attr("ejvalue"));
            }
			else{
                var sOrder, sDetails;
				if(role == "sortAsc" || role == "sortDesc"){
					sOrder = role == "sortAsc" ? "ascending" : "descending";
					sDetails = { field: this.fName, direction: sOrder };
					arg = { originalEvent: args.event, action: "sorting", sortDetails: sDetails, tableID: this._$tableID };
				}
				else{
					sDetails = { field: this.fName, direction: sOrder, operation: role, color: $(args.element).css('background-color')};
					arg = { originalEvent: args.event, action: "sortbycolor", sortDetails: sDetails, tableID: this._$tableID }; 
				}
            }
            if (role != "operator") {
                this._filterHandler(arg);
                this.closeXFDialog();
            }
        },
        _searchBoxFocus: function (e) {
            var $target = $(e.target);
            if ($target.hasClass("e-cancel")) {
                $target.prev().val("");
                $target.next().addClass("e-cancel")
                $target.addClass("e-search");
                $target.prev().trigger("keyup");
            }
            if (e.type == "focusin") {
                $target.next().addClass("e-cancel");
                $target.next().removeClass("e-search");
            }
        },
        _search: function (e) {
            var enterText = e.target.value, args = {}, parsed, operator, $target = $(e.target);
            parsed = (this.getType() != "string" && parseFloat(enterText)) ? parseFloat(enterText) : enterText;
            operator ="contains" ;
            parsed = (parsed == "" || parsed == undefined) ? undefined : parsed;
            if (this._$colType == "boolean") {
                if (parsed != undefined && this.localizedLabels.True.toLocaleLowerCase().indexOf(parsed.toLowerCase()) != -1)
                    parsed = "true";
                else if (parsed != undefined && this.localizedLabels.False.toLocaleLowerCase().indexOf(parsed.toLowerCase()) != -1)
                    parsed = "false";
            }
            if (this._$colType == "date" || this._$colType == "datetime") {
                parsed = ej.parseDate(enterText, this.replacer(this._$format, /{0:|}/g, ""));
                operator = "equal";
                if (this._previousValue == null && parsed == null)
                    return;
            }
            this._previousValue = parsed;
            delay = this._dataSource instanceof ej.DataManager && (this._ctrlInstance._gridRecordsCount > this._ctrlInstance.model.filterSettings.maxFilterChoices) ? 1500 : 0;
            sender = { type: "filterchoicesearch", value: parsed, operator: operator, matchcase: ["date", "datetime"].indexOf(this._$colType) != -1 ? false : this._matchCase }
            this._processSearch(sender, delay);
            if ($target.val() == "") {
                $target.next().addClass("e-search");
                $target.next().removeClass("e-cancel");
            } else {
                $target.next().addClass("e-cancel");
                $target.next().removeClass("e-search");
            }
        },
        _processSearch: function (sender, delay) {
            if (!this._alreadySearchProcessed) {
                this._alreadySearchProcessed = true;
                this._startTimer(sender, delay);
            } else {
                this._stopTimer();
                this._startTimer(sender, delay);
            }
        },
        _startTimer: function (sender, delay) {
            this._timer = window.setTimeout(
                function () {
                    proxy._processListData(sender);
                }, delay)
        },
        _stopTimer: function () {
            if (this._timer != null)
                window.clearTimeout(this._timer);
        },
        _getLocalizedLabel: function (property) {
            return ej.getLocalizedConstants("ej.ExcelFilter", this._locale);
        },
        _getMenuData: function (type) {
            return type != undefined ? this[type + "MenuOpt"] : [];
        },
        /*CheckBox list*/
        _lsitBoxTemplate: function () {
            var helper = {}, temp = {};            
            helper[this.id + "isNotBlank"] = ej.proxy(this.isNotBlank, this);
            helper[this.id + "checkBlank"] = ej.proxy(this._checkBlank, this);
            helper[this.id + "_getValueData"] = ej.proxy(this._getValueData, this);            
            helper[this.id + "_checkBoxState"] = ej.proxy(this._setCheckState, this);     
            helper[this.id + "_genId"] = this._genCheckID;
            $.views.helpers(helper); 			
            var genID = this.id + this._$colType + "{{:~" + this.id + "_genId()}}";
            temp[this.id + this._$colType + "_listBox_Template"] = "{{if ~" + this.id + "checkBlank(key)}}<div class='e-ftrchk'><input type='checkbox' id='" + genID + "' value='{{html:~" + this.id + "_getValueData(key, items)}}' class='e-ftrchk' {{:~" + this.id + "_checkBoxState(~" + this.id + "_getValueData(key, items))}}/><label class='e-ftrchk' for='" + genID + "'>{{if ~" + this.id + "isNotBlank(key,'true')}} {{>key}} {{else}} (Blanks) {{/if}}</label></div>{{/if}}";
            $.templates(temp);
        },
      
        _processListData: function (params) {
            var result, promise, args = {}, query = new ej.Query(), searchQuery = new ej.Query().requiresCount(), evtArgs = {}; this._searchCount = 0;
            var predicates = this._predicates[this._$key], pred;
			var data = null, columnName = null, localJSON = null, result = null;
			if(ej.isNullOrUndefined(this._$foreignField && this._$foreignData)){
				data = this._dataSource; 
				columnName =  this.fName;
				localJSON = this._localJSON;
			}
			else{
				data = localJSON = this._$foreignData; 
				if(this._dataSource instanceof ej.DataManager && !(data instanceof ej.DataManager))
                    data = ej.DataManager(data);
				columnName = this._$foreignField;
			}
            for (var prop in predicates) {
                if (prop == this.fName)
                    continue;
                var obj = predicates[prop], from = obj["from"];
                if (from)
                    query.skip(from == "top" ? 0 : data.length - (data.length - obj["take"])).take(obj["take"]);
                else
                    pred = pred != undefined ? pred["and"](obj) : obj;
            }
            args.columnName = columnName;           
            query.requiresCount();
            if (this._dataSource instanceof ej.DataManager && !this._dataSource.dataSource.offline && this._ctrlInstance._gridRecordsCount > this._ctrlInstance.model.filterSettings.maxFilterChoices) {
                query.take(this.maxFilterChoices);
                this._onDemandSearch = true;
            }
		    pred && query.where(pred);
            ej.merge(query.queries, this.query.queries) || ej.merge(query._params, this.query._params)
            evtArgs.requestType = params ? params.type : "filterchoicerequest",evtArgs.filterModel = this, evtArgs.query = query, evtArgs.dataSource = data;
            if (this._ctrlInstance._trigger(this._onActionBegin, evtArgs))
                return;
            if (!ej.isNullOrUndefined(this._searchHandler) && this._searchHandler.key.length) {
                var searchDetails = this._searchHandler;
                query.search(searchDetails.key, searchDetails.fields, searchDetails.operator || "contains", searchDetails.ignoreCase || true);
            }
            if (this.enableSelect)
                query.select(this.fName);
            if (params && params.type == "filterchoicesearch") {
                this._clearSearchValue = ej.isNullOrUndefined(params.value) ? true : false;
                args.type = params.type;
                if (this._$foreignField) query = searchQuery;
                params.value && query.where(columnName, params.operator, params.value, !params.matchcase);
                if (this._dataSource instanceof ej.DataManager && this._ctrlInstance._gridRecordsCount > this._ctrlInstance.model.filterSettings.maxFilterChoices) {
                    this._searchRequest = true;
                    this._listsWrap.ejWaitingPopup("show");
                    if (this._$foreignField) {
                        var frKeyData = this._$foreignData instanceof ej.DataManager ? this._$foreignData : ej.DataManager(this._$foreignData);
                        this._dataProcessing(frKeyData, query, args);
                    }
                    else
                        this._dataProcessing(this._dataSource, query, args);
                }
                else
                    this._dataProcessing(ej.DataManager(this._localJSON), query, args);
            }
            else if (!(this._dataSource instanceof ej.DataManager)) {
				var result = [];
                promise = ej.DataManager(this._dataSource).executeLocal(query);
                args.type = "filterchoicerequest";
                if (this._$foreignField)
                    this._filterForeignData(promise, args);
                else {
                    result = promise.result;
                    args.data = this._localJSON = this._currentData = result;
                    this._totalRcrd = promise.count;
                    this._setCheckBoxList(args);
                }
            }
            else {
                proxy = this; args.type = "filterchoicerequest";
                this._listsWrap.ejWaitingPopup("show");
                if (!this._reqInProgess) {
                    this._reqInProgess = true;
					if(this._$foreignField)
                        data = this._dataSource;
                    promise = data.executeQuery(query);
                    promise.done(function (e) {
                        if (proxy._$foreignField)
                            proxy._filterForeignData(e, args);
                        else {
                            result = e.result;
                            args.data = proxy._localJSON = proxy._currentData = result;
                            proxy._totalRcrd = e.count;
                            proxy._listsWrap.ejWaitingPopup("hide");
                            proxy._setCheckBoxList(args);;
                            proxy._reqInProgess = false;
                        }
                    });
                }
            }           
        },
        _dataProcessing: function (dataSource, query, args) {
            var result, promise;
            promise = dataSource.executeQuery(query);
            promise.done(function (e) {
                args.data = proxy._currentData = e.result;
                proxy._totalRcrd = proxy._searchCount = e.result.length;
                proxy._setCheckBoxList(args);
            });
        },
        _filterForeignData: function (fromPromise, args) {
            var custom = typeof args === "boolean", key = this._$foreignKey,
               field = this._$foreignField, type = this._$foreignKeyType,
                result, count, proxy = this, defaults = {}, pred, tmp, actuals, query = new ej.Query(),
                dm = this._$foreignData instanceof ej.DataManager ? this._$foreignData : ej.DataManager(this._$foreignData);
            if (!custom) {
                result = fromPromise.result, count = fromPromise.count;
                if (!!count)
                    query.where(this.getFilterFrom(this._$foreignData, result));
                if (!this._listsWrap.ejWaitingPopup("model.showOnInit"))
                    this._listsWrap.ejWaitingPopup("show");
            }
            else {
                tmp = fromPromise[0], defaults = fromPromise[0], actuals = fromPromise.slice();
                if (!!tmp)
                    this.closeXFDialog();
                pred = new ej.Predicate(field, tmp.operator, tmp.value, !tmp.matchcase);
                for (var i = 1, tmp, len = fromPromise.length; i < len; i++) {
                    tmp = fromPromise[i], pred = pred[tmp.predicate](field, tmp.operator, tmp.value, !tmp.matchcase);
                }
                query.where(pred);
            }
            query.select([key, field]);
            dm.executeQuery(query).done(function (e) {
                if (!custom) {
                    args.data = proxy._localJSON = proxy._currentData = e.result;
                    proxy._totalRcrd = count;
                    proxy._listsWrap.ejWaitingPopup("hide");
                    proxy._setCheckBoxList(args);
                    proxy._reqInProgess = false;
                } else {
                    var dst = ej.distinct(e.result, key, true), dst = 0 in dst ? dst : [{}];
                    var coll = dst.map(function (val, ind) {
                        return $.extend({}, defaults, { value: val[key], operator: "equal", actuals: actuals, type: type });
                    });
                    proxy.initiateFilter(coll);
                }
            });
        },
        _setCheckBoxList: function (args) {
            var evtArgs = {}, _blank ="", sortedData, flag, blank = this._blanks, $checked;
            evtArgs.requestType = args.type, evtArgs.dataSource = this._dataSource, evtArgs.filterModel = this;
            if (this._currentData.length != 0) {                
                sortedData = this.getDistinct(args.data, args.columnName, true, !!this._$foreignKey);
                flag = this._isFiltered;                
                this._actualCount = sortedData.length; sortedData.length = this._maxCount > this._actualCount ? this._actualCount : this._maxCount;               
                (this._onDemandSearch && this._actualCount == 1000) || this._actualCount >= this._maxCount ? this._openedFltr.find("div.e-status").removeClass("e-hide") : this._openedFltr.find("div.e-status").addClass("e-hide");
                this._islargeData = this._maxCount < this._actualCount ? true : false;
                this._filterdCol = ej.DataManager(this.filteredColumn).executeLocal(ej.Query().where("field", "equal", this.fName));
                this._listsWrap.find("div:first").html([this._selectAll, $.render[this.id + this._$colType + "_listBox_Template"](sortedData), this._addAtLast ? this.replacer(blank, /@@/g, this._setCheckState, this._empties.join(this._spliter)) : ""].join(""));
                this._chkList = this._listsWrap.find("input:checkbox").not(".e-selectall"), $inView = this._chkList.slice(0, 20);
                $inView.ejCheckBox({ change: ej.proxy(this._checkHandler, this) });
                $inView.siblings().height(14).width(14);
                this._listsWrap.find(".e-selectall").ejCheckBox({ change: ej.proxy(this._selectAllHandler, this), enableTriState: this._interDeterminateState });
				this._listsWrap.find(".e-selectall").attr("id",this.id + this._$colType + "SelectAll");
                this._listsWrap.find(".e-selectall").siblings().height(14).width(14);
				this._listsWrap.find(".e-selectall").closest("span").siblings("label").attr("for", this.id + this._$colType + "SelectAll");
            }
            else
            {
                this._listsWrap.find("div").first().html(ej.buildTag("div.e-ftrchk", this.localizedLabels.NoResult, {}, {}));
                this._chkList = this._listsWrap.find("input:checkbox").not(".e-selectall");
            }
            if (!ej.isNullOrUndefined(this._chkList))
                $checked = this._chkList.filter(":checked").length;
            if (this._isFiltered && this._searchRequest && $checked == 0)
                this._checkIsIndeterminate(args.columnName, this.filteredColumn);
            if (!this._isFiltered || this._actualCount == $checked)
                this._listsWrap.find(".e-selectall").ejCheckBox({ checked: true });
            else if ($checked > 0 || this._isIndeterminate && this._interDeterminateState)
                this._listsWrap.find(".e-selectall").ejCheckBox('model.checkState', 'indeterminate');
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: $checked != 0 });
            this._listsWrap.ejScroller({ scrollTop: 0 }).ejScroller("refresh");
             if(this._listsWrap.hasClass('e-waitingpopup'))
                this._listsWrap.ejWaitingPopup("hide");
            if (this._ctrlInstance._trigger(this._onActionComplete, evtArgs))
                return;
            this._isIndeterminate = false;
            this._checkedValue = [];
        },
        _checkIsIndeterminate: function (colName, filteredCol) {
            for (var i = 0 ; i < filteredCol.length; i++) {
                if (colName == filteredCol[i].field)
                    this._isIndeterminate = true;
            }
        },
        _createLiTag: function ($ul, menuData, isChild) {
            proxy = this;
            $.each(menuData, function (index, obj) {
                var $li = ej.buildTag("li", {}, {}, obj["htmlAttribute"] || (isChild && { "ejfnrole": "operator", "ejvalue": obj.value }) || {}), $child;
                var apd = (isChild && $.inArray(obj.value,proxy._noDlg)==-1) ? "..." : "";
                var $a = ej.buildTag("a", obj.text + apd, {}, {});
                obj["sprite"] != undefined && $a.append(ej.buildTag("span", {}, {}, { "class": obj["sprite"] }))
                if (obj["child"] != undefined){
                    if(obj.id != 3 && obj.id != 5)
                        $child = proxy._createLiTag(ej.buildTag("ul.e-shadow"), obj["child"], true);
                    else if(obj.id === 3 )
                        $child = proxy._createDivTag(ej.buildTag("ul.e-shadow"), obj["child"], true, "sort");
                    else
                        $child = proxy._createDivTag(ej.buildTag("ul.e-shadow"), obj["child"], true, "filter");
				}
                obj["child"] == undefined ? $ul.append($li.append($a)) : $ul.append($li.append($a).append($child))
                if ($.inArray(obj.value || (obj.htmlAttribute && obj.htmlAttribute.ejfnrole), proxy._sepAftr) != -1)
                    $ul.append(ej.buildTag("li.e-separator"));
            });
            return $ul;
        },
		
		_createDivTag: function ($ul, menuData, isChild, reqType) {
            var $li, $a, $div, bgColor = [], fgColor = [], avble = false, cellcolor = "", fontcolor = "", selCellHdr = "", selCellClr = "", selFontHdr = "", selFontClr = "";
            if (reqType == "sort") {
                cellcolor = this.localizedLabels.SortByCellColor;
                fontcolor = this.localizedLabels.SortByFontColor;
            }
            else{
                cellcolor = this.localizedLabels.FilterByCellColor;
                fontcolor = this.localizedLabels.FilterByFontColor;
            }
			selCellHdr = reqType + "colorhdr";
            selFontHdr = reqType + "fonthdr";
            selCellClr = reqType + "bgcolor";
            selFontClr = reqType + "fgcolor";
            ($ul.length > 0) && $ul.children().remove();
            if(menuData.length > 0){
			    for(var i = 0; i < menuData.length; i++){
				    for(var j = 0; j < bgColor.length; j++){
					    if(bgColor[j] == menuData[i].background){
						    avble = true;
						    break;
					    }
				    }
				    if(!avble && (!ej.isNullOrUndefined(menuData[i].background) && !menuData[i].background.startsWith('#6n'))) 
                        bgColor.push(menuData[i].background);
				    avble = false;
				    for(var j = 0; j < fgColor.length; j++){
					    if(fgColor[j] == menuData[i].foreground){
						    avble = true;
						    break;
					    }
				    }
				    if(!avble && (!ej.isNullOrUndefined(menuData[i].foreground) && !menuData[i].foreground.startsWith('#6n'))) 
                        fgColor.push(menuData[i].foreground);
				    avble = false;
			    }
                if(bgColor.length > 0){
                    $li = ej.buildTag("li.e-list e-bghdrcolor", "", "" , {"ejfnrole": selCellHdr });
                    $a = ej.buildTag("a.e-menulink", cellcolor, {});
                    $li.append($a);
                    $ul.append($li);
			        for(var i = 0; i < bgColor.length; i++){
                        $li = ej.buildTag("li.e-list e-valcolor", {}, {'background-color': bgColor[i]}, {"ejfnrole": selCellClr });
                        $ul.append($li);
			        }
                }
                if(fgColor.length > 0){
			        $li = ej.buildTag("li.e-list e-fghdrcolor", "", "" , {"ejfnrole": selFontHdr });
                    $a = ej.buildTag("a.e-menulink", fontcolor, {});
                    $li.append($a);
                    $ul.append($li);
                    for(var i = 0; i < fgColor.length; i++) {
                        $li = ej.buildTag("li.e-list e-valcolor", {}, {'background-color': fgColor[i]}, {"ejfnrole": selFontClr });
                        $ul.append($li);
                    }
                }
                (bgColor.length < 1 && fgColor.length < 1) ? $ul.parent().addClass("e-disable-item"): $ul.parent().removeClass("e-disable-item");
            }
            else {
                $ul.parent().addClass("e-disable-item");
            }
            return $ul;
        },
		
        _setCheckState: function (value) {           
            var val = value, fobj, splts = value.split(this._spliter), splen = splts.length, flag = false;           
            if (!this._isFiltered || this._searchCount)
                return "checked";
            else {
               
                while (splen--) { /*looped for split values*/
                    val = this.processValue(splts[splen]);

                    //Date and boolean will be checked as iteration due to 
                    if (this._$colType == "date" || this._$colType == "datetime" || this._$colType == "boolean") {
                        for (var i = 0, len = this._filterdCol.length; i < len; i++) {
                            if (this._$colType == "boolean" && val !== this._filterdCol[i].value)
                                continue;
                            if (this._$colType == "date" || this._$colType == "datetime") {
                                var firstVal = this._$colType == "date" && val instanceof Date ? this._formatting(this._$format, new Date(val.getFullYear(), val.getMonth(), val.getDate()), this._locale) : this._formatting(this._$format, val, this._locale);
                                var secondVal = this._formatting(this._$format, this._filterdCol[i].value, this._locale);
                                if (firstVal !== secondVal && !this._maxFilterCount)
                                    continue;
                                else {
                                    if (this._maxFilterCount && (this._onDemandSearch || this._islargeData)) {
                                        if (firstVal == secondVal) {
                                            this._checkedValue.push(firstVal);
                                            return ""
                                        }
                                        else if (this._checkedValue.indexOf(secondVal) == -1 || this._checkedValue.length == this._filterdCol.length)
                                            return "checked";
                                        else
                                            continue;
                                    }
                                }
                            }
                            return "checked";
                        }
                    }
                    else {
                        var fQ = ej.DataManager(this._filterdCol).executeLocal(ej.Query().where("value", "equal", val).where("operator", "equal", "equal"));
                        if (fQ.length != 0) {
                            if (fQ[0].operator == "equal" && fQ[0].isCustom == true && this._ctrlInstance.model.currentViewData.length > 0)
                                return "checked";
                            else
                                return fQ[0]["isCustom"] === true ? "" : "checked";
                        }
                        else {
                            if ((this._onDemandSearch || this._islargeData) && this._maxFilterCount) {
                                var fltrQury = ej.DataManager(this._filterdCol).executeLocal(ej.Query().where("value", "equal", val).where("operator", "notequal", "equal"));
                                if (fltrQury.length == 0)
                                    return "checked";
                            }
                        }
                    }
                }
            }
        },
        _genCheckID: function () {
            return "CheckBox" + this.getIndex();
        },
        _formatting: function (format, value, locale) {

            if (this._$colType == "date" && format == "")
                format = "{0:MM/dd/yyyy hh:mm:ss}";

            if (this._$colType == "boolean")                 
                return value === "" ? "" : this.localizedLabels[value == true ? "True" : value == false ? "False" : ""];
           
            if (this._formatFiltering || this._$colType == "date") {
                var formatter = this._ctrlInstance.formatting;                
                return format != "" ? formatter(format, value, locale) : value;
            } 
        },
        _updateDateFilter: function (filter) {
            if (filter.type != "date" && !(filter.value instanceof Date))
                return filter;            
            filter.value = filter.value instanceof Date ? filter.value : ej.parseJSON({ val: filter.value }).val;
            return ["equal", "notequal"].indexOf(filter.operator) == -1 ? filter : this._setDateObject(filter);
        },        
        _checkHandler: function (args) {
            $("#" + args.model.id).prop("checked", args.isChecked);
            var $checkedlist = this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall)"), clen = $checkedlist.length;
            var $selectall = this._listsWrap.find(".e-selectall"), canCheck;
            if (clen == this._chkList.length) {
                $selectall.prop("checked", true);
                canCheck = true;
            }
            else if (clen == 0 || !this._interDeterminateState) {
                $selectall.prop("checked", false);
                canCheck = false;
            }
            else if (args.isInteraction)
                $selectall.ejCheckBox('model.checkState', 'indeterminate')
            $selectall.ejCheckBox({ checked: canCheck });
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: clen != 0 });
        },
        _selectAllHandler: function (args) {
            
            if (args.checkState=="check"){
                this._chkList.filter(":not(:checked)").ejCheckBox({ checked: args.isChecked });
                this._chkList.prop("checked", true);
            }
            else if (args.checkState == "uncheck") {
                this._chkList.filter(function () { if ($(this).hasClass("e-checkbox") && $(this).prop("checked")) return this; }).ejCheckBox({ checked: args.isChecked });
                this._chkList.prop("checked", false); this._chkList.removeAttr("checked");
            }
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: args.isChecked });
        },
        /*Custom Dialog*/
        _renderCustomFDlg: function (type) {
            var dlgId = this.id + type + "_CustomFDlg";
            if ($("#" + dlgId).length)
                return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-excelfilter e-dlgcustom");
            $dlg.addClass(this._cssClass);
            this._renderCDlgContent($dlg, type);
            $dlg.ejDialog({ showOnInit: false, enableResize: false, enableModal: true, allowKeyboardNavigation: false, title: this._title, width: 370, content: "#" + this.id, enableRTL: this._ctrlInstance.model.enableRTL, closeIconTooltip: "Close", cssClass: "e-excelfilter e-customDlg" });
			$dlg.ejDialog("refresh");
        },

        _renderCDlgContent: function (content, type) {
            var $div1 = ej.buildTag("div.e-dlgfields",this.localizedLabels.Showrowswhere, {}, {});
            var $id = this.id + this._$colType;
            var $fset = ej.buildTag("fieldset.e-fieldset");
            var $op1 = ej.buildTag("tr.e-fields"), $op2 = ej.buildTag("tr.e-fields"), $op3 = ej.buildTag("tr.e-fields e-top");
            var $dp1 = ej.buildTag("input#" + $id + "_CustomDrop1"), $dp2 = ej.buildTag("input#" + $id + "_CustomDrop2"), $dp3 = ej.buildTag("input#" + $id + "_CustomDrop3");
            var $in1 = ej.buildTag("input#" + $id + "_CustomValue1.e-ejinputtext e-excustmfltr", {}, {}, { "type": "text" }), $in2 = ej.buildTag("input#" + $id + "_CustomValue2.e-ejinputtext e-excustmfltr", {}, {}, { "type": "text" }), $in3 = ej.buildTag("input#" + $id + "_CustomValue3.e-ejinputtext e-excustmfltr", {}, {}, { "type": "text" });
            var $pred = ej.buildTag("tr.e-predicate");
            var radioAnd = ej.buildTag("input#" + $id + "_CustomAndPredicate", {}, {}, { "type": "radio", "name": "predicate" , "value":"and" }), radioOr = ej.buildTag("input#" + $id + "_CustomOrPredicate", {}, {}, { "type": "radio", "name": "predicate", "value":"or" });
            var matchCase = ej.buildTag("input#" + $id + "_CustomMatchPredicate", {}, {}, { "type": "checkbox" });
            content.append($div1);
            var table = ej.buildTag("table.e-optable");

            $op1.append(ej.buildTag("td.e-operator").append($dp1))
                .append(ej.buildTag("td.e-value").append($in1));
            $pred.append(ej.buildTag("td", {}, {}, {}).append(radioAnd).append(ej.buildTag("label.e-caption", this.localizedLabels.PredicateAnd, {}, { "for": $id + "_CustomAndPredicate" }))
                .append(radioOr).append(ej.buildTag("label.e-caption", this.localizedLabels.PredicateOr, {}, { "for": $id + "_CustomOrPredicate" })));
            $op2.append(ej.buildTag("td.e-operator").append($dp2))
                .append(ej.buildTag("td.e-value").append($in2));
            table.append($op1)
            .append($pred)
            .append($op2);
			if(type == "string")
			    $pred.append(ej.buildTag("td", {}, {}, {}).append(matchCase).append(ej.buildTag("label.e-caption", this.localizedLabels.MatchCase, {}, { "for": $id + "_CustomMatchPredicate" })));
            if (type == "number" || type == "guid") {
                $op3.append(ej.buildTag("td.e-operator").append($dp3))
                .append(ej.buildTag("td.e-value").append($in3));
                table.append($op3)
            }
            $fset.append(ej.buildTag("legend"))
                .append(table)
            content.append(ej.buildTag("div.e-dlgfields").append($fset));
            content.append(ej.buildTag("div.e-dlgfields").append(this._createBtn(true)));
            content.appendTo("body");
            var uppertype = type.replace(type.charAt(0), type.charAt(0).toUpperCase());
            $([$dp1, $dp2]).ejDropDownList({ fields: { text: "text", value: "value" }, height: 27, width: 120, enableRTL: this._ctrlInstance.model.enableRTL });
            if (type == "number") {
				$([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
                $([$in1, $in2]).ejNumericTextbox({ showSpinButton: false, height: "27px", width: "177px", enableRTL: this._ctrlInstance.model.enableRTL,watermarkText: this.localizedLabels.NumericTextboxWaterMark, focusOut: function(args){ if(this.model.decimalPlaces == 0) this.element.prev(".e-input").val(this.model.value); } });
            }
			else if (type == "guid") {
                $([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
                $($in1).css({"height":"22px","width":"175px" });
                $($in2).css({"height":"22px","width":"177px" });
            }
            else if (type == "date") {
				$([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
				$([$in1, $in2]).ejDatePicker({ "cssClass": this._ctrlInstance.model.cssClass, height: "27px", width: "177px", "enableRTL": this._ctrlInstance.model.enableRTL, watermarkText: this.localizedLabels.DatePickerWaterMark, locale: this._locale });
            }
            else if (type == "datetime") {
                $([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
                $([$in1, $in2]).ejDateTimePicker({ "cssClass": this._ctrlInstance.model.cssClass, height: "27px", width: "177px", "enableRTL": this._ctrlInstance.model.enableRTL, watermarkText: this.localizedLabels.DateTimePickerWaterMark, locale: this._locale });
            }
            else if (type == "string") {
                $([$in1, $in2]).ejAutocomplete({ "cssClass": this._ctrlInstance.model.cssClass, "enableRTL": this._ctrlInstance.model.enableRTL, enableDistinct: true, width: "177px", height: "27px", locale: this._locale });
            }
            $([radioAnd, radioOr]).ejRadioButton({ "cssClass": this._ctrlInstance.model.cssClass, "enableRTL": this._ctrlInstance.model.enableRTL });
            matchCase.ejCheckBox({ });
            $("#" + $id + "Custom_OkBtn").ejButton({ text: this._getDeprecatedLocalizedLabel("OK"), showRoundedCorner: true, width: "23.6%", click: ej.proxy(this._fltrBtnHandler, this), enabled: true });
            $("#" + $id + "Custom_CancelBtn").ejButton({ text: this.localizedLabels.Cancel, showRoundedCorner: true, width: "23.6%", click: ej.proxy(this.closeXFDialog, this) })
        },
                     
        _openCustomFilter: function (operator) {
            var oper = operator != "top10" ? this._$colType : operator, emptyOp = { text: "", value: "" }, query = this.query;
            var type = oper.replace(oper.charAt(0), oper.charAt(0).toUpperCase());
            var id = this.id + this._$colType;
            this.closeXFDialog();
            this._openedFltr = $("#" + id + "_CustomFDlg");
            var args = { requestType: "filterbeforeopen", filterModel: this, columnName: this.fName, columnType: this._$colType, isCustomFilter: true };
            if (this._ctrlInstance._trigger(this._onActionBegin, args))
                return;
            this._openedFltr.ejDialog("open");
            this._openedFltr.ejDialog({open: function(args){
				$("#" + id + "_CustomValue1").hasClass("e-autocomplete") ? $("#" + id + "_CustomValue1").focus() : $("#" + id + "_CustomValue1").prev().focus();
			}});
            this._openedFltr.find("legend").html(this._displayName);            
            var sl = (["Number","Date"].indexOf(type) != -1) ? 6 : 5;
            var sliced = this.localizedLabels[type + "MenuOptions"].slice(0,sl); sliced.unshift(emptyOp);
            $("#" + id + "_CustomDrop1").ejDropDownList({ dataSource: sliced });
            $("#" + id + "_CustomDrop2").ejDropDownList({ dataSource: sliced });
			if (this._$colType == "number") {
                var decimalPlace = 0;
                if(operator == "top10"){
                    this._openedFltr.find(".e-optable tr").not(".e-top").addClass("e-hide");   
                    this._openedFltr.find(".e-optable tr.e-top").removeClass("e-hide");
                    $("#" + id + "_CustomDrop3").ejDropDownList({ dataSource: this.localizedLabels[type + "MenuOptions"] });
                }
                else{                   
                    decimalPlace = this._$format.length != 0 ? parseInt(this._$format.replace(/\D/g,'')) : 0;                    
                    this._openedFltr.find(".e-optable tr.e-top").addClass("e-hide");
                    this._openedFltr.find(".e-optable tr").not(".e-top").removeClass("e-hide"); 
                    $("#" + id + "_CustomValue1").ejNumericTextbox("model.decimalPlaces", decimalPlace);
                    $("#" + id + "_CustomValue2").ejNumericTextbox("model.decimalPlaces", decimalPlace);
                }
            }
            else {
                this._openedFltr.find(".e-optable tr.e-top").addClass("e-hide");
                this._openedFltr.find(".e-optable tr").not(".e-top").removeClass("e-hide");
            }
            if(this._$colType == "string"){
				var fName = this._$foreignField ? this._$foreignField : this.fName;
				var data = this._$foreignData && this._$foreignField ? this._$foreignData : this._dataSource;
                this._openedFltr.find(".e-autocomplete").ejAutocomplete({
                    fields: { text: fName }, dataSource: data,query:query, focusIn: function (args) {
                        var type = this.element.closest("td").siblings().find(".e-dropdownlist").ejDropDownList("getSelectedValue");
                        var $matchCase = this.element.closest(".e-dialog-scroller").find(".e-checkbox").prop("checked");
						 this.model.caseSensitiveSearch = $matchCase;
						 this.model.filterType = type == "" ? this.model.filterType : type;
                    }
                });
            }
            if (this._$colType == "date" && this._$format != "")
                this._openedFltr.find(".e-datepicker").ejDatePicker({ dateFormat: this._$format.replace(/{0:|}/g, function () { return "" }), enableStrictMode: true });
            else if (this._$colType == "datetime" && this._$format != "")
                this._openedFltr.find(".e-datetimepicker").ejDateTimePicker({ dateTimeFormat: this._$format.replace(/{0:|}/g, function () { return "" }), enableStrictMode: true });
            this._setFilteredData(id, operator);
			if(!ej.isNullOrUndefined(this._customFilterHandler)) 
				this._customFilterHandler();
            var args = { requestType: "filterafteropen", filterModel: this, columnName: this.fName, columnType: this._$colType, isCustomFilter: true };
            
			if (this._ctrlInstance._trigger(this._onActionComplete, args))
                return;
        },
        
        _setFilteredData: function ($id, op) {
            var indx = $.inArray(this.fName, this.cFilteredCols);
            var fQM = [], optrs = [], fLen;
            var between = ["greaterthanorequal", "lessthanorequal"];
            if (op == "top10")
                return;
            if (indx != -1)
                fQM = ej.DataManager(this.filteredColumn).executeLocal(ej.Query().where("field", "equal", this.fName));
            if (indx != -1 && this._$foreignField)
                fQM = fQM[0]["actuals"];
            if (this._initialFName != null && this._initialFName == this.fName)
                fQM[0]["isCustom"] = true;
            fLen = fQM.length;
            var drops = this._openedFltr.find(".e-dropdownlist"), inputs = this._openedFltr.find(".e-value input.e-ejinputtext.e-input"), $pred = this._openedFltr.find(".e-predicate");            
            if (indx != -1 && fLen && fQM[0]["from"]!=undefined)
                optrs = [op, ""];
			else if(op == "between" && indx != -1 && fLen )
				optrs = [fQM[0]["operator"], !ej.isNullOrUndefined(fQM[1]) ? fQM[1]["operator"] : ""];
            else if (indx != -1 && fLen && fQM[0]["isCustom"])
                optrs = [(op != "customfilter" && indx != -1) ? op : fQM[0]["operator"], op == "customfilter" && fQM[1] ? fQM[1]["operator"] : ""];
			else if(indx == -1 && op == "customfilter") 
                optrs = ["equal", ""];
            else if (op == "between" || op == "customfilter")
                optrs = op != "customfilter" ? between : ["", ""];           
            else
                optrs = [op, ""];
           
            for (var i = 0; i < (indx != -1 ? fLen : 2) ; i++) {
                var opt = /\D*/.exec(optrs[i])[0];
                $(drops[i]).prop("value", opt);
                $(drops[i]).ejDropDownList("setSelectedValue", opt);
				 $(drops[i]).ejDropDownList({ change: function(arg){ 
					this.element.closest(".e-fields").find(".e-autocomplete").val("");
				 }});
				var value = (indx != -1 && fLen && fQM[i]["isCustom"] && (opt == (this._$foreignField ? fQM[i]["actualFilterOperator"] : fQM[i]["operator"]) || opt == "customfilter" || opt == "between")) ? this._$foreignField ? opt != "" ? fQM[i]["actualFilterValue"] : "" : fQM[i]["value"] : "";
                if ($(inputs[i]).hasClass("e-datepicker"))
                    $("#" + inputs[i].id).ejDatePicker("model.value", (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["value"] : null);
                else if ($(inputs[i]).hasClass("e-numerictextbox"))
                    $("#" + inputs[i].id).ejNumericTextbox("model.value", value);
                else if ($(inputs[i]).hasClass("e-datetimepicker"))
                    $(inputs[i]).ejDateTimePicker("model.value", value);
                else
                    $(inputs[i]).val(value);
                var $pre = (indx != -1 && fLen && fQM[i]["isCustom"] && fQM[i]["predicate"] != undefined) ? this._$foreignField ? fQM[i]["actualPredicate"] : fQM[i]["predicate"] : "and";
				$pred.find("input[value=" + $pre + "]").ejRadioButton({checked:  true});
				if(this._$colType == "string"){
				    var $match = (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["matchcase"] : this._matchCase;
					$pred.find("input.e-js[type='checkbox']").ejCheckBox({checked: $match});
				}
				this._openedFltr.find(".e-value input:visible:eq(0)").select();
            }            
        },
        _setDateObject: function (filterObject) {
            if (filterObject.value != null) {
                var $fltrVal = filterObject.value;
                var $prevObj = $.extend(true, {}, filterObject);
                var $nextObj = $.extend(true, {}, filterObject);                
                var $prevDate = new Date($prevObj.value.setSeconds($prevObj.value.getSeconds() - 1));
                var $nextDate = new Date($nextObj.value.setSeconds($nextObj.value.getSeconds() + 2));
                filterObject.value = new Date(filterObject.value.setSeconds($nextObj.value.getSeconds() - 1));                
                $prevObj.value = $prevDate;
                $nextObj.value = $nextDate;
                if (filterObject.operator == "equal") {
                    $prevObj.operator = "greaterthan";
                    $prevObj.predicate = "and";
                    $nextObj.operator = "lessthan";
                    $nextObj.predicate = "and";
                } else if (filterObject.operator == "notequal") {
                    $prevObj.operator = "lessthanorequal";
                    $prevObj.predicate = "or";
                    $nextObj.operator = "greaterthanorequal";
                    $nextObj.predicate = "or";
                }
                var predicate = ej.Predicate($prevObj.field, $prevObj.operator, $prevObj.value, false);
                predicate = predicate[$nextObj.predicate]($nextObj.field, $nextObj.operator, $nextObj.value, false);
                filterObject.ejpredicate = predicate; filterObject.type = "date";
                return filterObject;
            }
            else
                return filterObject;
        },
        _getCDlgFields: function () {
            var dropDowns = this._openedFltr.find(".e-dropdownlist"), defaults;
            var $match = this._openedFltr.find(".e-checkbox"), matchcase = true,valueColl = [];
            var $inputs = this._openedFltr.find(".e-value input.e-ejinputtext.e-input");
            var $ginputs = this._openedFltr.find(".e-value input"),
                $pred = this._openedFltr.find(".e-predicate input[type='radio']:checked").val();
            $.inArray(this.fName, this.cFilteredCols) == -1 && this.cFilteredCols.push(this.fName);

            for (var i = 0,len = dropDowns.length; i < len; i++) {
                var dvalue = $(dropDowns[i]).ejDropDownList("getSelectedValue"), value;
                if (this._$colType == "number")
                    value = parseFloat($inputs.eq(i).ejNumericTextbox("model.value"));
				if(this._$colType == "guid")
                    value = $ginputs.eq(i).val();
                if (this._$colType == "string") {
                    value = $inputs.eq(i).val();
                    matchcase = $match.is(":checked");
                }
                if (this._$colType == "date") 
                    value = $inputs.eq(i).ejDatePicker("model.value");
                if (this._$colType == "datetime")
                    value = $inputs.eq(i).ejDateTimePicker("model.value");

                defaults = { field: this.fName, predicate: i == 1 ? $pred : "or", matchcase: matchcase, isCustom: true };
                if (dvalue == "top" || dvalue == "bottom") {
                    valueColl.push($.extend(true, { value: "", operator: "notequal", take: value, from: dvalue }, defaults));
                }
                else if (dvalue != "") {
                    if (this._empties.indexOf(value + "") > -1 || (this._$colType == "number" && isNaN(value))) {
                        var cols = this.iterateAndGetCollection(this._empties.join(this._spliter), $.extend({}, defaults, { predicate: dvalue.toLowerCase() === "notequal" ? "and" : "or", operator: dvalue.toLowerCase() }));
                        var pred = this.generatePredicate(cols);
                        valueColl.push($.extend({}, defaults, { ejpredicate: pred, operator: dvalue.toLowerCase() }));
                    }
                    else {
                        var filterObj = {}; $.extend(true, filterObj, { value: value, operator: dvalue.toLowerCase(), isCustom: true, actualFilterOperator: dvalue.toLowerCase(), actualFilterValue: value, actualPredicate: defaults.predicate }, defaults);
                        if (this._$colType == "date")
                            filterObj.type = "date";
                        valueColl.push((this._$colType == "date" && ["equal", "notequal"].indexOf(dvalue.toLowerCase()) != -1) ? this._setDateObject(filterObj) : filterObj);
                    }
                }
                else
                    break;
            }
            if (this._$foreignField == undefined)
                this.initiateFilter(valueColl);
            else 
                this._filterForeignData(valueColl, true);            
        },
      
        _fltrBtnHandler: function (args) {
            var matchcase, valColl = [], arg = {}, predicate, fObj = {}, optr = "", checked = [];
            this._maxFilterCount = false;
            if (this._clearSearchValue)
                this._searchCount = 0;
            if (!this._openedFltr.hasClass("e-dlgcustom")) {
                if (!this._isFiltered && this._listsWrap.find(".e-selectall").ejCheckBox("model.checked") && this._searchCount == 0) 
                    return this.closeXFDialog();                                  
                if (this._onDemandSearch || this._islargeData) {
                    if (this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall)").length < this._listsWrap.find("input.e-ftrchk").filter(":not(:checked):not(.e-selectall)").length || this._listsWrap.find(".e-selectall").ejCheckBox("model.checked")) {
                        checked = this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall)");
                        optr = "equal";
                    }
                    else {
                        checked = this._listsWrap.find("input.e-ftrchk").filter(":not(:checked):not(.e-selectall)");
                        optr = "notequal";
                        this._maxFilterCount = true;
                    }
                }
                else {
                    checked = this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall)");
                    optr = this._colType == "string" ? "startswith" : "equal";
                }
                var len = checked.length, cVal, type = this.getType();
                var _isCase = this._colType == "string" ? this._matchCase : true;
                var defaults = this._maxFilterCount ? { field: this.fName, predicate: "and", operator: optr, matchcase: _isCase } : { field: this.fName, predicate: "or", operator: optr, matchcase: _isCase };
                for (var i = 0; i < len; i++) {
                    cVal = checked[i].value;
                    if (this.enableNormalize && cVal.indexOf(this._spliter) != -1) {
                        ej.merge(valColl, this.iterateAndGetCollection(cVal, defaults));
                        continue;
                    }
                    cVal = this.processValue(cVal, type);                    
                                        
                    $.extend(true, fObj, { value: cVal }, defaults);
                                                            
                    valColl.push(type == "date" ? this._setDateObject(fObj) : fObj);
                                                             
                    fObj = {};
                }
                var cIndex = $.inArray(this.fName, this.cFilteredCols);
                if(cIndex != -1)
                    this.cFilteredCols.splice(cIndex, 1);
                if (this._isFiltered && this._searchRequest) {
                    this._checkIsIndeterminate(this.fName, this.filteredColumn);
                    if (this._isIndeterminate) {
                        ej.merge(valColl, this.filteredColumn);
                        valColl = ej.distinct(valColl, "value", true);
                        this._searchRequest = false;
                    }          
                }
                this.initiateFilter(valColl);
            }
            else {
                valColl = this._getCDlgFields();
                $.inArray(this.fName, this.cFilteredCols) == -1 && valColl[0] && this.cFilteredCols.push(this.fName);
            }
        },
        initiateFilter: function (valColl) {
            var firstVal = valColl[0], predicate;
            if (!ej.isNullOrUndefined(firstVal)) {
                isTake = firstVal["from"];
                predicate = firstVal["ejpredicate"] ? firstVal["ejpredicate"] : ej.Predicate(firstVal.field, firstVal.operator, firstVal.value, !firstVal.matchcase);
                for (var j = 1, jlen = valColl.length; j < jlen; j++) {
                    predicate = valColl[j].ejpredicate != undefined ? predicate[valColl[j].predicate](valColl[j].ejpredicate) : predicate[valColl[j].predicate](valColl[j].field, valColl[j].operator, valColl[j].value, !valColl[j].matchcase);
                }
                arg = { action: "filtering", filterCollection: valColl, fieldName: this.fName, ejpredicate: predicate, tableID: this._$tableID};
                if (this._predicates[this._$key] == undefined)
                    this._predicates[this._$key] = {};
                this._predicates[this._$key][this.fName] = !isTake ? predicate : { from: firstVal["from"], take: firstVal["take"] };
                if (!this._openedFltr.hasClass("e-dlgcustom") && this._listsWrap.find(".e-selectall").ejCheckBox("model.checked") && !this._searchCount && $.inArray(this.fName, this._columnsFiltered) != -1)
                    arg = { action: "clearfiltering", filterDetails: { field: this.fName, operator: "", predicate: "or", value: "" }, fieldName: this.fName, tableID: this._$tableID }
                if ($.inArray(this.fName, this._columnsFiltered) == -1)
                    this._columnsFiltered.push(this.fName);                
                this._filterHandler(arg);
            }
            this.closeXFDialog();
        },        
		/*Util method to perform formatted group on the inputted json*/
        getDistinct: function (json, field, fullRecord, redundancy) {
		    var lookup = {}, len = json.length, result = [], current, value, fd;

		    while (len--) {
		        current = json[len], value = ej.getObject(field, current), fd = value;
            if (!ej.isNullOrUndefined(current)) {
		        if (this.enableNormalize)
		            fd = this._formatting(this._$format, value, this._locale);

		        current["ejvalue"] = fd;

		        if (redundancy || !(value in lookup))
		            result.push(fullRecord ? current : value);

		        lookup[value] = true;
		    }
         }

		    result = ej.group(ej.mergeSort(result, field), "ejvalue"); /* sort with field and group with ejvalue */

		    return result;
		},
        /*Util method to split string and build filterobject collection */
		iterateAndGetCollection: function (valuestring, defaults) {
		    var splts = valuestring.split(this._spliter), len = splts.length, result = [], value;

		    while (len--) {
		        value = this.processValue(splts[len]);		       

		        result.push($.extend(true, { value: value }, defaults));
		    }

		    return result;
		},
        /*Util method to perform type conversion*/
		processValue: function (val, type/* optional */) {		    
		     type = type || this.getType(); type = this._empties.indexOf(val) != -1 ? "empty" : type; val = val === this.guid ? this._blankValue + "" : val;
		    switch (type) {
		        case "empty":/*Handle blanks*/
		            val = val == "null" ? null : val == "undefined" ? undefined : "";
		            break;
		        case "date":
		        case "datetime":
		            val = new Date(val);
		            break;
		        case "number":
		            val = +val;
		            break;
		        case "boolean":		           
		            val = (!isNaN(val) && typeof (val) == "string") ? ej.parseInt(val) != 0 : val === "true" ? true : false;
		            break;
		    }		    		      
		    return val;
		},
		getType: function () {
		    return !ej.isNullOrUndefined(this._$foreignField) ? this._$foreignKeyType : this._$colType;
		},
		replacer: function (input, pattern, processor, params) {
		    if (typeof processor == "function")
		        processor = processor.call(this, params)
		   return input.replace(pattern, processor);
		},
        _virtualize: function (e) {
            var height = $("#" + this.id + this._$colType + "_CheckBoxList").height();
            var chks = this._chkList.not(".e-checkbox").filter(function () { if (this.offsetTop > e.scrollTop - this.offsetHeight && e.scrollTop + height+70 > this.offsetTop + this.offsetHeight) return this; });
            if (chks.length == 0) return;
            chks.filter(":checked").ejCheckBox({ checked: true }); chks.filter(":not(:checked)").ejCheckBox({ checked: false });
            chks.ejCheckBox({ change: ej.proxy(this._checkHandler, this) });
            var scrollObj = this._listsWrap.ejScroller('instance');            
            scrollObj.refresh();
        },
        /*Method to reset private properties*/
        resetFilterModel: function (destroy) {
            this._blank = undefined;
            this._addAtLast = false;
            this._isFiltered = false;
            this._searchCount = 0;
        },
        resetExcelFilter: function (template) {
            var _i, _type, _id = this.id,_len, _$id;
            this._predicates = [];          
            this.cFilteredCols = [];
            this.resetFilterModel();
            for (_i = 0, _len = this._posType.length; _i < _len; _i++) {
                _type = this._posType[_i], _$id = _id + _type;
                var cDlg = $("#" + _$id + "_CustomFDlg");               
                $("#" + _$id + "_CheckBoxList").ejWaitingPopup("destroy"); $("#" + _$id + "_excelDlg").remove();
                cDlg.find(".e-dropdownlist").ejDropDownList("destroy");
                cDlg.find(".e-button").ejButton("destroy");
                if (_type == "string" || _type == "boolean") cDlg.find(".e-autocomplete").ejAutocomplete("destroy");
                if (_type == "number") cDlg.find(".e-numerictextbox").ejNumericTextbox("destroy");
                if (_type == "date") cDlg.find(".e-datepicker").ejDatePicker("destroy");
                cDlg.ejDialog("destroy");
                $("#" + _$id + "_CustomFDlg").remove();
            }
        },
        _wireEvents: function () {
            this._ctrlInstance._on(this._dialogContainer, "focus click", ".e-searchbox", ej.proxy(this._searchBoxFocus, this));
            this._ctrlInstance._on(this._dialogContainer, "keyup", ".e-searchbox input", ej.proxy(this._search, this));
        }
    };

    ej.ExcelFilter.valueDelimiter = "@|@";
    ej.ExcelFilter.Locale = ej.ExcelFilter.Locale || {};

    ej.ExcelFilter.Locale["default"] = ej.ExcelFilter.Locale["en-US"] = {
        SortNoSmaller: "Sort Smallest to Largest",
        SortNoLarger: "Sort Largest to Smallest",
        SortTextAscending: "Sort A to Z",
        SortTextDescending: "Sort Z to A",
        SortDateOldest: "Sort by Oldest",
        SortDateNewest:"Sort by Newest",
		SortByColor: "Sort By Color",
        SortByCellColor: "Sort by Cell Color",
        SortByFontColor: "Sort by Font Color",
        FilterByColor: "Filter By Color",
		CustomSort: "Custom Sort",
        FilterByCellColor: "Filter by Cell Color",
        FilterByFontColor: "Filter by Font Color",
        ClearFilter: "Clear Filter",
        NumberFilter: "Number Filters",
		GuidFilter: "Guid Filters",
        TextFilter: "Text Filters",
        DateFilter: "Date Filters",
        DateTimeFilter: "Date Time Filters",
        SelectAll: "Select All",
        Blanks: "Blanks",
		Search:"Search",
        Showrowswhere:"Show rows where",
		NumericTextboxWaterMark:"Enter value",
        StringMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Starts With", value: "startswith" }, { text: "Ends With", value: "endswith" }, { text: "Contains", value: "contains" }, { text: "Custom Filter", value: "customfilter" }],
        NumberMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
        GuidMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Custom Filter", value: "customfilter" }],
		DateMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
		DatetimeMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
		Top10MenuOptions: [{ text: "Top", value: "top" }, { text: "Bottom", value: "bottom" }],
        title:"Custom Filter",
        PredicateAnd: "AND",
        PredicateOr: "OR",
        OK: "OK",
        MatchCase: "Match Case",
        Cancel: "Cancel",
        NoResult: "No Matches Found",
        CheckBoxStatusMsg: "Not all items showing",
        DatePickerWaterMark: "Select date",
        DateTimePickerWaterMark: "Select date time",
		True: "true",
        False: "false"
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var resourceHeadTemplate = function () {
        return ("{{for resourceName}}{{for ~cols=colspan}}<td class='e-resourcecells' colspan='{{:~cols}}'> {{for ~resource=resourceNam}}<div class='e-resourceheadertext' align='center' title='{{if userResTemplId == true}}{{:resourceNam}}{{else}}{{:~resource}}{{/if}}'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resource}}{{/if}}</div>{{/for}}  </td>{{/for}}{{/for}}");
    };

    ej.scheduleFeatures.resources = {
        _getMultipleResourceCellsCount: function (count) {
            if (this._grouping.length === 1) {
                var index = this._findResourceIndex(this._tempResource, "name", this._grouping[0]);
                var resCount = this._resourceInfo[index].dataSource.length;
                if (this._resWorkWeek) {
                    var count = 0; var res = this._resourceInfo[index].dataSource;
                    for (var a = 0; a < res.length; a++) {
                        if (!ej.isNullOrUndefined(res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count = count + res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count = count + this.model.workWeek.length;
                        }
                    }
                }
            }
            else {
                var newResCollection = this._getResourceCollection(), resources = [];
                var groupData, prevGroupDataId, query, resApp;
                for (var j = 0; j < newResCollection.length; j++) {
                    resources = [];
                    if (j == 0) {
                        for (var i = 0; i < newResCollection[j].dataSource.length; i++) {
                            resources.push({ resourceNam: newResCollection[j].dataSource[i][newResCollection[j].text] });
                        }
                    }
                    else {
                        if (j > 1) {
                            newResCollection[j - 1].dataSource = [];
                            newResCollection[j - 1].dataSource = this.res;
                        }
                        this.res = [];
                        groupData = ej.group(newResCollection[j].dataSource, newResCollection[j].groupId);
                        prevGroupDataId = ej.group(newResCollection[j - 1].dataSource, newResCollection[j - 1].id);
                        this._resourceManager1 = groupData instanceof ej.DataManager ? groupData : ej.DataManager(groupData);
                        for (var l = 0; l < prevGroupDataId.length; l++) {
                            for (var k = 0; k < prevGroupDataId[l].items.length; k++) {
                                query = new ej.Query().where("key", ej.FilterOperators.equal, prevGroupDataId[l].items[k][newResCollection[j - 1].id]);
                                resApp = this._resourceManager1.executeLocal(query);
                                if (resApp.length > 0) {
                                    for (var a = 0; a < resApp[0].items.length; a++) {
                                        resources.push({ resourceNam: resApp[0].items[a][newResCollection[j].text] });
                                        this.res.push(resApp[0].items[a]);
                                    }
                                }
                            }
                        }
                    }
                }
                resCount = resources.length;
                this.res1 = resources.length;
            }
            count = (this._resWorkWeek) ? count : count * resCount;
            return { resCount: resCount, count: count };
        },

        _initResourceData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this;
            var queryPromise = fields.dataSource.executeQuery(query);
            queryPromise.done(function (e) {
                fields.dataSource = e.result;
                proxy._resourceInfo.push(fields);
                if (i == proxy.model.resources.length - 1) {
                    proxy._renderInitSchedule();
                    proxy._bindAppointmentsData("Load");
                }
            });
        },

        _showMultipleResourceDetails: function (temp) {
            var prevdata, query, resApp1;
            if (this._tempResource.length > 0) {
                var newResCollection = this._resCollection;
                for (var i = 0; i < newResCollection.length; i++) {
                    this._appointmentAddWindow.find('.owner_' + i).ejAutocomplete("clearText");
                }
                for (var j = 0; j < this.render_Resources.length - 1; j++) {
                    prevdata = this.render_Resources[j + 1] instanceof ej.DataManager ? this.render_Resources[j + 1] : ej.DataManager(this.render_Resources[j + 1]);
                    query = new ej.Query().where(newResCollection[j + 1].groupId, ej.FilterOperators.equal, temp[this._appointmentSettings.resourceFields.toString().split(',')[j].trim()]);
                    resApp1 = prevdata.executeLocal(query);
                    this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("clearText");
                    this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("option", "dataSource", resApp1);
                }
                for (var i = 0; i < newResCollection.length; i++) {
                    this._appointmentAddWindow.find('.owner_' + i).data("ejAutocomplete").selectValueByKey(temp[this._appointmentSettings.resourceFields.toString().split(',')[i].trim()]);
                }
            }
        },

        _renderAppWindowResources: function (control) {
            var newResCollection = this.render_Resources;
            var Text = (this.model.enableRTL) ? 'margin-right:30px;margin-top:-18px' : '';
            var Color = (this.model.enableRTL) ? 'float:none' : 'float:left';
            for (var i = 0; i < newResCollection.length; i++) {
                control.find('.owner_' + i).ejAutocomplete({
                    enableRTL: this.model.enableRTL,
                    showPopupButton: true,
                    width: "100%",
                    cssClass: this.model.cssClass,
                    multiSelectMode: (!this._tempResource[i].allowMultiple) ? "none" : "visualmode",
                    emptyResultText: this._getLocalizedLabels("EmptyResultText"),
                    dataSource: newResCollection[i],
                    fields: {
                        text: this._resCollection[i]["text"],
                        key: this._resCollection[i]["id"]
                    },
                    change: this._onResourceChange,
                    template: "<div class='e-resourcediv' style='height:15px; margin-right:5px; margin-top:3px; float:left;width:15px;" + Color + "; background-color: ${" + this._resCollection[i].color + "}'></div><div style= " + Text + ">${" + this._resCollection[i]["text"] + "}</div>"
                });
            }
        },

        _onResourceChange: function (e) {
            if (!ej.isNullOrUndefined(e.value) && e.value != "") {
                var scheduleDiv = $("#" + this._id.toString().split("_")[0]), proxy = scheduleDiv.ejSchedule("instance");
                var controlId = parseInt(this._id.toString().split("_")[2]);
                var controlMode = proxy._appointmentAddWindow.find('.owner_' + controlId).ejAutocomplete("option", "multiSelectMode");
                var selectedItems = this.getSelectedItems();
                var resourceCollection = proxy._resCollection;
                if (controlId < proxy.render_Resources.length - 1 && selectedItems.length > 0) {
                    var j = controlId + 1;
                    var data = proxy.render_Resources[j - 1] instanceof ej.DataManager ? proxy.render_Resources[j - 1] : ej.DataManager(proxy.render_Resources[j - 1]);
                    var prevdata = proxy.render_Resources[j] instanceof ej.DataManager ? proxy.render_Resources[j] : ej.DataManager(proxy.render_Resources[j]);
                    var query, resApp1, fieldCollection = [];
                    if (controlMode == "none") {
                        if (!ej.isNullOrUndefined(e.value)) {
                            var textCheck = new ej.Query().where(resourceCollection[j - 1].text, ej.FilterOperators.equal, e.value);
                            var result = data.executeLocal(textCheck);
                        }
                        var currentVal = ((!e.value) || ej.isNullOrUndefined(e.value) || result.length <= 0) ? selectedItems[0][resourceCollection[j - 1].id] : result[0][resourceCollection[j - 1].id];
                        if (!ej.isNullOrUndefined(currentVal)) {
                            for (a = j; a < resourceCollection.length; a++) {
                                resApp1 = new ej.DataManager(resourceCollection[j].dataSource).executeLocal(new ej.Query().where(resourceCollection[j].groupId, ej.FilterOperators.equal, currentVal));
                                if (resApp1.length != 0)
                                    currentVal = resApp1[0][resourceCollection[j - 1].id];
                                fieldCollection = [];
                                for (var k = 0; k < resApp1.length; k++) {
                                    fieldCollection.push(resApp1[k]);
                                }
                                if (resApp1.length != 0) {
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                                    proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
                                    selectedItems = resApp1[0][resourceCollection[j].id];
                                }
                                else {
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                                }
                                j++;
                            }
                        }
                    }
                    else {
                        var predicate;
                        predicate = ej.Predicate(resourceCollection[j - 1].id, ej.FilterOperators.equal, selectedItems[0][resourceCollection[j - 1].id]);
                        selectedItems = e.value.split(",");
                        for (var i = 1; i < selectedItems.length; i++) {
                            predicate = predicate["or"](resourceCollection[j - 1].text, ej.FilterOperators.equal, selectedItems[i]);
                        }
                        query = new ej.Query().where(predicate);
                        resApp = data.executeLocal(query);
                        if (resApp.length > 0) {
                            var prevPredicate;
                            prevPredicate = ej.Predicate(resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[0][resourceCollection[j - 1].id]);
                            for (var i = 1; i < resApp.length; i++) {
                                prevPredicate = prevPredicate["or"](resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[i][resourceCollection[j - 1].id]);
                            }
                            query = new ej.Query().where(prevPredicate);
                            resApp1 = prevdata.executeLocal(query);
                            fieldCollection = [];
                            for (var k = 0; k < resApp1.length; k++) {
                                fieldCollection.push(resApp1[k]);
                            }
                            proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                            proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                            proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
                            selectedItems.push(resApp1[0][resourceCollection[j].id]);
                        }
                    }
                }
            }
        },

        _getResourceCollection: function () {
            var resIndexCollection = [], index;
            if ((this._tempResource.length != 0)) {
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i]);
                        resIndexCollection.push({ index: index, name: this._tempResource[i].name });
                    }
                    resIndexCollection = resIndexCollection.sort(function (a, b) {
                        var x = a.index; var y = b.index;
                        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
                    });
                }
                else {
                    for (var i = 0; i < this._tempResource.length; i++) {
                        resIndexCollection.push({ index: i });
                    }
                }
                var newResCollection = [];
                for (var k = 0; k < resIndexCollection.length; k++) {
                    newResCollection.push(this._resourceInfo[resIndexCollection[k].index]);
                }
                this._resCollection = newResCollection;
                return newResCollection;
            }
        },

        _resourceSort: function () {
            var nextRes, count, resAvail, index, rIndex, cRes, tempResource = [], rCollection = [], tempRes1 = [];
            if (this._tempResource.length > 1) {
                for (i = 0; i < this._tempResource.length; i++) {
                    for (j = 0; j < this._tempResource[i].resourceSettings.dataSource.length; j++) {
                        tempResource.push(this._tempResource[i].resourceSettings.dataSource[j]);
                    }
                }
                count = 1;
                for (a = 0; a < this._tempResource.length; a++) {
                    for (b = 0, cRes = this._tempResource[a].resourceSettings.dataSource; b < cRes.length; b++) {
                        resAvail = rCollection.indexOf(cRes[b]);
                        (resAvail == -1) ? rCollection.push(cRes[b]) : "";
                        nextRes = new ej.DataManager(tempResource).executeLocal(new ej.Query().where(this._tempResource[count].resourceSettings.groupId, ej.FilterOperators.equal, cRes[b][this._tempResource[a].resourceSettings.id]));
                        nextRes = nextRes.filter(function (a) { return cRes.indexOf(a) === -1; });
                        index = rCollection.indexOf(cRes[b]);
                        if (nextRes.length != 0) {
                            for (c = 0; c < nextRes.length; c++) {
                                rIndex = index + c + 1;
                                resAvail = rCollection.indexOf(nextRes[c]);
                                (resAvail == -1) ? rCollection.splice(rIndex, 0, nextRes[c]) : "";
                            }
                        }
                    }
                    count++;
                    count = (count == this._tempResource.length) ? count - 1 : count;
                }
                for (x = 0; x < rCollection.length; x++) {
                    index = this.res1.indexOf(rCollection[x]);
                    if (index != -1) tempRes1.push(rCollection[x]);
                }
                this.res1 = tempRes1;
            }
            else
                rCollection = this.res1;
            return rCollection;
        },

        _renderMultipleResourceHeaderTemplate: function (tbody, cols) {
            this.res1 = []; this.render_Resources = []; this.level_Resources = [];
            var view = this.currentView(), newResCollection = this._getResourceCollection(), noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
            var viewColCount = view == "day" ? 1 : (view == "week" || view == "month") ? noOfDays : this.model.workWeek.length;
            viewColCount = (view == "customview" && this._dateRender.length >= 7) ? noOfDays : (view == "customview" && this._dateRender.length < 7) ? this._dateRender.length : viewColCount;
            if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
                var resources = [];
                if (this._grouping.length === 1) {
                    var index;
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i]);
                    }
                    for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
                        if (this._resWorkWeek)
                            var colCount = !ej.isNullOrUndefined(this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : viewColCount;
                        (this.currentView() != "agenda") && resources.push({ resourceNam: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], colspan: (this._resWorkWeek) ? colCount : viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(this._resourceInfo[index].dataSource[i], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                        this.res1.push(this._resourceInfo[index].dataSource[i]);
                        this.level_Resources.push(this.res1[i]);
                    }
                    this._valueCollection = this.res1;
                    this.render_Resources.push(this.res1);
                    if (this.model.orientation == "vertical" && this.currentView() != "agenda" && tbody !== null && cols != null) {
                        var leftCellwidth = view == "month" ? 50 : 56;
                        var resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
                        tbody.append(ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml));
                    }
                }
                else {
                    var groupDatasource = [], firstValue = [], collection = [], resAppValueCount = 0, valueCount = [];
                    var res = []; var level = []; var variable = []; this.resourceValue = 0; var resourceLength = 0;
                    groupDatasource = $.merge(groupDatasource, newResCollection);
                    if (this._tempResource.length) {
                        var k = 0;
                        for (j = 0; j < newResCollection[newResCollection.length - 2].dataSource.length; j++) {
                            var query = new ej.Query().where(newResCollection[newResCollection.length - 1].groupId, ej.FilterOperators.equal, newResCollection[newResCollection.length - 2].dataSource[j][newResCollection[newResCollection.length - 2].id]);
                            var resApp = new ej.DataManager(newResCollection[newResCollection.length - 1].dataSource).executeLocal(query);
                            var m = 0;
                            while (m < resApp.length) {
                                firstValue.push({ resourceNam: resApp[m][newResCollection[newResCollection.length - 1].text], colspan: 1 * viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(resApp[m], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                                collection[k] = resApp[m];
                                this.res1.push(resApp[m]);
                                k++;
                                m++;
                            }
                        }
                        this._valueCollection = collection;
                        newResCollection[newResCollection.length - 1].dataSource = collection;
                        var resClone = $.extend(true, [], newResCollection);
                    }
                    for (var i = this._tempResource.length - 1; i >= 0 ; i--) {
                        level.push(i);
                        for (var j = 0; j < newResCollection[i].dataSource.length; j++) {
                            var valuefirst = i != 0 ? this._findResourceIndex(newResCollection[i - 1].dataSource, newResCollection[i - 1].id, newResCollection[i].dataSource[j][newResCollection[i].groupId]) : 0;
                            var valuelast = i != this._tempResource.length - 1 ? this._findResourceIndex(newResCollection[i + 1].dataSource, newResCollection[i + 1].groupId, newResCollection[i].dataSource[j][newResCollection[i].id]) : this._tempResource.length - 1;
                            (ej.isNullOrUndefined(valuefirst) && ej.isNullOrUndefined(valuelast)) ? newResCollection[i].dataSource[j] = 0 : "";
                            if (!ej.isNullOrUndefined(valuefirst) && !ej.isNullOrUndefined(valuelast) && newResCollection[i].dataSource[j] !== 0) {
                                res.push(newResCollection[i].dataSource[j]);
                                this.resourceValue = res.length;
                                if (i <= this._tempResource.length - 2) {
                                    query = new ej.Query().where(newResCollection[i + 1].groupId, ej.FilterOperators.equal, newResCollection[i].dataSource[j][newResCollection[i].id]);
                                    var resApp = new ej.DataManager(newResCollection[i + 1].dataSource).executeLocal(query);
                                    if (i <= this._tempResource.length - 3) {
                                        for (k = 0; k < resApp.length; k++)
                                            resAppValueCount = resAppValueCount + (!ej.isNullOrUndefined(resApp[k].count) ? resApp[k].count : 0);

                                        resourceLength = this.model.orientation == "vertical" ? resAppValueCount : resAppValueCount + resApp.length;
                                        newResCollection[i].dataSource[j].count = resourceLength;
                                        resAppValueCount = 0;
                                    }
                                    if (i == this._tempResource.length - 2) {
                                        newResCollection[i].dataSource[j].count = resApp.length;
                                        resourceLength = resApp.length;
                                    }
                                    this.resourceValue = resourceLength;
                                    resApp.length = 0;
                                }
                                if (this._resWorkWeek) {
                                    var weekCount = 0;
                                    if (i != this._tempResource.length - 1) {
                                        var query = new ej.Query().where(resClone[i + 1].groupId, ej.FilterOperators.equal, resClone[i].dataSource[j][resClone[i].id]);
                                        var colCount = new ej.DataManager(resClone[i + 1].dataSource).executeLocal(query);
                                        for (var a = 0; a < colCount.length; a++) {
                                            weekCount += !ej.isNullOrUndefined(colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : !ej.isNullOrUndefined(colCount[a].colspan) ? colCount[a].colspan : viewColCount;
                                        }
                                    }
                                    else {
                                        weekCount += !ej.isNullOrUndefined(resClone[i].dataSource[j][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? resClone[i].dataSource[j][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : viewColCount;
                                    }
                                    resClone[i].dataSource[j]["colspan"] = weekCount;
                                    this.resourceValue = weekCount;
                                }
                                (this.currentView() != "agenda") && resources.push({ resourceNam: newResCollection[i].dataSource[j][newResCollection[i].text], colspan: (this._resWorkWeek) ? this.resourceValue : this.resourceValue * viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(newResCollection[i].dataSource[j], { classname: (this._tempResource.length - 1 == i) ? "e-childnode" : "e-parentnode" })), userResTemplId: userResTemplId });
                                this.level_Resources.push(newResCollection[i].dataSource[j]);
                                res.length = 0;

                            }
                            if (this.model.orientation == "vertical" && this.currentView() != "agenda" && tbody !== null && cols != null) {
                                leftCellwidth = view == "month" ? 50 : 56;
                                resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
                                variable[i] = ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml)[0];
                            }
                        }
                        valueCount[i] = newResCollection[i].dataSource;
                        resources.length = 0;
                    }
                    this.render_Resources = valueCount;
                    this.model.orientation == "vertical" && this.currentView() != "agenda" ? tbody.append(variable) : "";
                }
            }
            else {
                for (var k = 0; k < this._tempResource.length; k++) {
                    this.render_Resources.push(this._tempResource[k].resourceSettings.dataSource);
                }
                this.res1 = [0];
            }
            return tbody;
        },

        _getMultipleResourceAlldayApp: function (renderDate, day, res, i) {
            this.allDayCount = [];
            if ((new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(this._processed[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (this._processed[i][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()] == this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings.id]) &&
                (this._processed[i][this._appointmentSettings["allDay"]] === true || (((new Date(this._processed[i][this._appointmentSettings["endTime"]]) - new Date(this._processed[i][this._appointmentSettings["startTime"]])) / 3600000) >= 24))) {
                this._setAllDayPos(this._processed[i], day, res);
                this.allDayCount.push(i);
            }
        },

        _getResourceColor: function (record) {
            var newResCollection = this._resCollection;
            var resourceDataIndex, appointData = "", appointCustomcss = "", applyFilter = false;
            if (!ej.isNullOrUndefined(this.model.group)) {
                for (var a = 0; a < this.render_Resources.length; a++) {
                    resourceDataIndex = this._findResourceIndex(this.render_Resources[a], newResCollection[a].id, record[this._appointmentSettings.resourceFields.split(',')[a].trim()]);
                    if (!ej.isNullOrUndefined(resourceDataIndex)) {
                        appointData = (appointData == "" || ej.isNullOrUndefined(appointData)) ? this.render_Resources[a][resourceDataIndex][newResCollection[a].color] : appointData;
                        appointCustomcss = (appointCustomcss == "" || ej.isNullOrUndefined(appointCustomcss)) ? this.render_Resources[a][resourceDataIndex][newResCollection[a].appointmentClass] : appointCustomcss;
                        if (!ej.isNullOrUndefined(appointData) && !ej.isNullOrUndefined(appointCustomcss)) break;
                    }
                }
                appointData = !ej.isNullOrUndefined(appointData) && appointData != "" ? appointData : "";
                appointCustomcss = !ej.isNullOrUndefined(appointCustomcss) && appointCustomcss != "" ? appointCustomcss : "";
            }
            else {
                resourceDataIndex = this._findResourceIndex(this.render_Resources[this.render_Resources.length - 1], newResCollection[newResCollection.length - 1].id, record[this._appointmentSettings.resourceFields.split(',')[this._appointmentSettings.resourceFields.split(',').length - 1].trim()]);
                if (!ej.isNullOrUndefined(resourceDataIndex)) {
                    appointData = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color] : appointData;
                    appointCustomcss = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass] : appointCustomcss;
                }
            }
            return { appointData: appointData, appointCustomcss: appointCustomcss, applyFilter: applyFilter };
        },

        _getResourceValue: function (target, index) {
            var resDetails;
            if (ej.scheduleFeatures.resources && (this._tempResource.length != 0)) {
                var resource = this._getResourceDetails(target);
                resDetails = ej.DataManager(this._resCollection[resource.length - 1].dataSource).executeLocal(new ej.Query().where(this._tempResource[resource.length - 1].resourceSettings["id"], "equal", resource[0].id))[0];
            }
            return resDetails;
        },

        _getResourceDetails: function (target, index) {
            if ((this._tempResource.length != 0)) {
                if (this._tempResource.length > 0) {
                    var noOfDays = this.currentView() == "day" ? 1 : (this.model.showWeekend && (this.currentView() == "week" || this.currentView() == "month")) ? 7 : this.model.workWeek.length;
                    noOfDays = (this.model.showWeekend && this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 : (this.currentView() == "customview" && this._dateRender.length < 7) ? this._dateRender.length : noOfDays;
                    index = this.currentView() === "month" || this.currentView() == "customview" ? target.index() : (!ej.isNullOrUndefined(this._cellIndex) && ej.isNullOrUndefined(this._multiple)) ? this._cellIndex : target.index();
                    !target.hasClass("e-detailedapp") ? this.index = index : "";
                    index = target.hasClass("e-detailedapp") ? this.index : index;
                    if (this._resWorkWeek) {
                        var resIndex = 0;
                        for (var a = 0; a < this._valueCollection.length; a++) {
                            if (!ej.isNullOrUndefined(this._valueCollection[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                                resIndex += this._valueCollection[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            else
                                resIndex += this.model.workWeek.length;

                            if (resIndex > target.index()) {
                                index = a;
                                break;
                            }
                        }
                    }
                    else
                        index = this.model.orientation == "vertical" ? parseInt(index / noOfDays) : !ej.isNullOrUndefined(this._workCellIndex) ? this._workCellIndex : target.parent().index();
                    var res1 = this.model.orientation == "vertical" ? this._valueCollection : this._resCollect;
                    var group, resourceData, query, result; this._resourceCollection = [];
                    var newResCollection = this._resCollection;
                    for (var i = newResCollection.length - 1; i >= 0; i--) {
                        if (i == newResCollection.length - 1) {
                            if (!ej.isNullOrUndefined(this.model.group)) {
                                this._resourceCollection.push({ id: res1[index][newResCollection[i].id] });
                                group = res1[index][newResCollection[i].groupId];
                            }
                            else {
                                this._resourceCollection.push({ id: newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].id] });
                                group = newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].groupId];
                            }
                        }
                        else {
                            resourceData = newResCollection[i].dataSource instanceof ej.DataManager ? newResCollection[i].dataSource : ej.DataManager(newResCollection[i].dataSource);
                            query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, group);
                            result = resourceData.executeLocal(query);
                            this._resourceCollection.push({ id: result[0][newResCollection[i].id] });
                            group = result[0][newResCollection[i].groupId];
                        }
                    }
                    return this._resourceCollection;
                }
            }
        },

        _getResourceFields: function (obj) {
            if (!ej.isNullOrUndefined(this.model.group) || this._tempResource.length > 1) {
                for (var j = 0, i = this._resourceCollection.length - 1; j < this._resourceCollection.length; j++, i--)
                    obj[this._appointmentSettings.resourceFields.split(',')[j].trim()] = this._resourceCollection[i].id;
            }
            else
                obj[this._appointmentSettings.resourceFields.split(',')[0].trim()] = this._resourceCollection[0].id;
            return obj;
        },
        _getDragDropResourceData: function (proxy, cellIndex, newAddList) {
            if (!ej.isNullOrUndefined(cellIndex)) {
                var noOfCols = proxy.currentView() == "day" ? 1 : (proxy.model.showWeekend && (proxy.currentView() == "week" || proxy.currentView() == "month")) ? 7 : proxy.model.workWeek.length;
                noOfCols = (proxy.model.showWeekend && proxy.currentView() == "customview" && proxy._dateRender.length >= 7) ? 7 : (proxy.currentView() == "customview" && proxy._dateRender.length < 7) ? proxy._dateRender.length : noOfCols;
                var index = proxy.model.enableRTL ? proxy.res1.length - Math.floor(cellIndex / noOfCols) - 1 : Math.floor(cellIndex / noOfCols);
                if (proxy._resWorkWeek) {
                    var resIndex = 0;
                    for (var a = 0; a < proxy.res1.length; a++) {
                        if (!ej.isNullOrUndefined(proxy.res1[a][proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["workWeek"]]))
                            resIndex += proxy.res1[a][proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["workWeek"]].length;
                        else
                            resIndex += proxy.model.workWeek.length;

                        if (resIndex > cellIndex) {
                            index = a;
                            break;
                        }
                    }
                }
                var newRes = proxy.model.orientation == "vertical" ? proxy.res1[index] : proxy._resCollect[cellIndex];
                newAddList[proxy._appointmentSettings.resourceFields.split(',')[proxy._appointmentSettings.resourceFields.split(',').length - 1].trim()] = newRes[proxy.model.resources[proxy.model.resources.length - 1].resourceSettings.id];
                if (proxy._appointmentSettings.resourceFields.split(',').length > 1)
                    newAddList[proxy._appointmentSettings.resourceFields.split(',')[proxy._appointmentSettings.resourceFields.split(',').length - 2].trim()] = newRes[proxy.model.resources[proxy.model.resources.length - 1].resourceSettings.groupId];
            }
            return newAddList;
        },

        _renderResourceData: function (targetElement, index) {
            if ((targetElement.hasClass("e-workcells") || targetElement.hasClass("e-alldaycells") || targetElement.hasClass("e-monthcells")) && !targetElement.hasClass("e-resourceheadercells")) this._getResourceDetails(targetElement)
            var fieldCollection = [], collection = [];
            if (this._tempResource.length) {
                for (var k = this._resourceCollection.length - 1; k >= 0; k--) {
                    var resourceDataIndex = this._findResourceIndex(this._resCollection[k].dataSource, this._resCollection[k].id, this._resourceCollection[(this._resourceCollection.length - 1) - k].id);
                    fieldCollection.push(this._resCollection[k].dataSource[resourceDataIndex]);
                    if (k != 0) {
                        var query = new ej.Query().where(ej.Predicate(this._resCollection[k].groupId, ej.FilterOperators.equal, this._resCollection[k].dataSource[resourceDataIndex][this._resCollection[k].groupId]));
                        var resApp = new ej.DataManager(this._resCollection[k].dataSource).executeLocal(query);
                        index = this._findResourceIndex(resApp, this._resCollection[k].id, this._resourceCollection[(this._resourceCollection.length - 1) - k].id);
                        collection = resApp;
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("clearText");
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("option", "dataSource", collection);
                        this._appointmentAddWindow.find('.owner_' + (k)).data("ejAutocomplete").selectValueByKey(collection[index][this._resCollection[k].id]);
                    }
                    else {
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("clearText");
                        this._appointmentAddWindow.find('.owner_' + (k)).data("ejAutocomplete").selectValueByKey(fieldCollection[(this._resourceCollection.length - 1) - k][this._resCollection[k].id]);
                    }
                }
            }
        },

        _bindResourcesData: function () {
            if ((this._tempResource.length != 0)) {
                this._resourceInfo = []; var resFlag = false;
                for (var i = 0; i < this._tempResource.length; i++) {
                    if (!ej.isNullOrUndefined(this._tempResource[i].resourceSettings)) {
                        if (ej.isNullOrUndefined(this._tempResource[i].resourceSettings.query) || !(this._tempResource[i].resourceSettings.query instanceof ej.Query))
                            this._tempResource[i].resourceSettings.query = ej.Query();
                        if (this._tempResource[i].resourceSettings.dataSource instanceof ej.DataManager)
                            this._initResourceData(this._tempResource[i].resourceSettings, i);
                        else {
                            this._resourceInfo.push(this._tempResource[i].resourceSettings);
                            resFlag = true;
                        }
                    }
                }
                if (resFlag)
                    this._renderInitSchedule();
            }
        },

        _renderResourceElements: function ($appWindow) {
            for (var i = 0; i < this._tempResource.length; i++) {
                $appWindow += "<tr><td class='e-leftfields e-textlabel'>" + this._tempResource[i].title + ":</td><td colspan='3' class='e-rightfields'><input id='" + this._id + "_ownerfield_" + i + "'  class='owner_" + i + "' type='text' value=''/><div id='ownerlist'></div></td></tr>";
            }
            return $appWindow;
        },

        _renderResourcesTemplate: function () {
            if (this.model.orientation == "vertical")
                this.resourceHeadTemplate = $.templates(resourceHeadTemplate());
        }
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Schedule elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.2
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var monthCellsTemplate = function () {
        return ("<table class='e-table e-workcellstab'  height='100%'width='100%' cellpadding='0px' cellspacing='0px'>" +
                "<tbody>{{for cellrows ~cols1=cols1 ~userTemp=userTemplate ~userHtml=userHtml}}" +
                "<tr>{{for ~cwidth=cwidth ~cheight=cheight ~cols1 ~value=#getIndex()}}" +
                "<td class='e-monthcells' width='{{:~cwidth}}' height='{{:~cheight}}'>" +
                "<div class='e-monthheader'></div>{{if ~userTemp == true}}{{:~userHtml[~value][#getIndex()]}}{{/if}}</td>{{/for}}" +
                "</tr>{{/for}}</tbody></table>");
    };

    var appointmentTemplate = function () {
        return ("<div class='{{:appClass}} {{:appointCustomcss}}' id='Appointment_{{:id}}' guid= '{{:uid}}' resource='{{:resId}}' role='presentation' style='{{if rtl == true}}right{{else}}left{{/if}}: {{:left}}; {{if ignoreColorFilter == true}}filter:none;{{/if}} width: {{:appWidth}}; background: {{:appointData}};  color:{{:appointtextcolor}}; {{if appHeight}}height:{{:appHeight}}px;{{/if}} top: {{:top}}px;' >" +
                "{{if appResize == true}}{{if appClass == 'e-appointment'}}" +
                "{{if orientation == 'vertical'}}<div class='e-tophandle'></div><div class='e-bottomhandle'></div>{{else}}<div class='e-lefthandle'></div><div class='e-righthandle'></div>{{/if}}" +
                "{{else}}{{if currentview != 'day'}}<div class='e-lefthandle'></div><div class='e-righthandle'></div>{{/if}}{{/if}}{{/if}}" +
                "<span class='e-icon e-schedulemouseclose'/></span>" +
                "{{if (priority!=undefined && priority!='') && ((priorityTemplate!=undefined && priorityTemplate!=''))}}{{if enablePriority==null}}<div class='e-priority e-{{:priorityTemplate}}'></div>{{else}}<div class='e-priority'>{{:priorityTemplate}}</div>{{/if}}{{/if}}" +
                "{{if userAppTemplId == false}}" +
                "{{if leftInd ==true}}<span class='e-icon e-arrow-sans-left e-leftind'></span>{{/if}}{{if rightInd ==true}}<span class='e-icon e-arrow-sans-right e-rightind'></span>{{/if}}" +
                "{{if bottomInd ==true}}<span class='e-icon e-arrow-sans-down e-bottomind'></span>{{/if}}{{if topInd ==true}}<span class='e-icon e-arrow-sans-up e-topind'></span>{{/if}}" +
                "<div class='e-appointinnertext'><div class='e-apptext {{if (priority!=undefined && priority!='')}}e-priorwidth{{/if}}'>{{if recurrence == true}}{{if recurrenceEdit == true}}<span class='e-icon e-recureditapp'></span>{{else}}<span class='e-icon e-recurapp'></span>{{/if}}{{/if}}{{:subject}} </div><div class='e-apptime {{if (priority!=undefined && priority!='')}}e-priorwidth{{/if}}'> {{:startTime}} - {{:endTime}}</div>{{if value == true}}<div class='e-multipleCategory'>{{:multiDiv}}</div>{{/if}}</div>" +
                "{{else}}{{if recurrence == true}}{{if recurrenceEdit == true}}<span class='e-icon e-recureditapp'></span>{{else}}<span class='e-icon e-recurapp'></span>{{/if}}{{/if}}{{:userTemplate}}{{/if}}</div>");
    };

    var blockTimeTemplate = function () {
        return ("<div class='e-blocktimewrapper'><div class='e-blocktimeappointment {{:blockClass}} {{:customStyle}}' id='BlockTime_{{:id}}' role='presentation' style='width: {{:appWidth}}; height: {{:appHeight}}px; left: {{:left}}px; top: {{:top}}px;'>" +
                "{{if userTempId == false}}{{:subject}}{{else}}{{:userTemplate}}{{/if}}</div></div>");

    };

    var categorizeMultipleTemplate = function () {
        return ("{{for renderData }}<div style='background:{{:value}};height:11px;width:6px;float:left'></div>{{/for}}");
    };

    var headerTemplate = function () {
        return ("{{for cols ~view=view ~colspan=colspan}}{{if cellToday == 'e-headerToday'}}<td class='e-headercells e-currentdayhighlight' colspan='{{:~colspan}}'>{{else}}<td class='e-headercells' colspan='{{:~colspan}}'>{{/if}}" +
                "<div class='e-dateheadercell'> <span class='e-headerdaydisplay'>{{:currentDay}}</span></div></td>{{/for}}");
    };
    var leftHeaderTemplate = function () {
        return ("<table class='e-table e-leftindenttable' height='100%' cellpadding='0px' cellspacing='0px'>" +
                "<tbody> {{for trs ~tdClass=tdClass ~divClass=divClass}} <tr>{{for ~tdClass=tdClass ~divClass=divClass}} <td class='{{:~tdClass}} {{if ~tdClass == 'e-leftindent' }}e-alldaycellsheight{{else}}e-headercellsheight{{/if}}'> <div class='{{:~divClass}}'></div></td>{{/for}}</tr>" +
                "{{/for}}</tbody></table>");
    };
    var alldayTemplate = function () {
        return ("{{for cols ~colspan=colspan ~userTemp=userTemp ~allDayHtml=userHtml}}<td class='e-alldaycells e-alldaycellsheight' colspan='{{:~colspan}}'>{{if ~userTemp==true}}{{:~allDayHtml[#getIndex()]}}{{/if}}</td>{{/for}}");
    };

    var workCellsTemplate = function () {
        return ("<table class='e-table e-workcellstab' width='100%' height='100%' cellpadding='0px' cellspacing='0px'>" +
                "<tbody >{{for cellrows  ~timesc=timeScale ~cols1=cols1 ~userTemp=userTemplate ~userHtml=userHtml}}" +
                "<tr>{{for ~index=#index ~cwidth=cwidth ~cheight=cheight ~cols1 ~value=#getIndex()}}" +
                "{{if ((~index+1) % ~timesc) == 0 }}<td class='e-workcells' width='{{:~cwidth}}' height='{{:~cheight}}'>{{else}}<td class='e-workcells e-alternatecells'width='{{:~cwidth}}' height='{{:~cheight}}'>{{/if}}{{if ~userTemp == true}}{{:~userHtml[~value][#getIndex()]}}{{/if}}</td>" +
                "{{/for}}</tr>{{/for}}</tbody></table>");
    };

    var timeCellsTemplate = function () {
        return ("<div class='e-scrolltimecells' style='width:auto;height:100%;'><table class='e-table e-timecelltable' width='100%' height='100%' cellpadding='0px' cellspacing='0px'>" +
                "<tbody>{{for timerows ~timesc=timeScale ~cols1=cols1 ~view1=viewclass ~userTemplateId = userTemplateId ~timeValue1=timeValue1 ~template=template}}" +
                "<tr>{{for ~name=time ~id=id ~view=~view1 ~index=#index }}" +
                "{{if ~view == 0}}{{if ~userTemplateId==true}}<td class='e-timecells'>{{for ~cols1[~index] }}{{if (#index+1)% ~timesc ==0}}<div class='e-timecelldivs' style='height: 20px'>{{:~timeValue1[~index][#getIndex()]}}</div>{{else}}<div class='e-timecelldivs' style='height: 21px'>{{:~timeValue1[~index][#getIndex()]}}</div>{{/if}}{{/for}}</td>" +
                "{{else}}<td class='e-timecells'><div class='e-timecelldivs'>{{if ~template==true}}{{:~name}}{{else}}{{:~name.slice(0,2)}}{{/if}}</div></td>{{/if}}" +
                "<td class='e-timecells' rowspan='1'>{{for ~cols1[~index] }}{{if (#index+1)% ~timesc ==0}}<div class='e-ampmdisplay'></div>  {{else}} {{if (#getIndex())== 0}}<div id='{{:~id}}' class='e-ampmdisplay e-ampmstyle e-idAmpmstyle'> {{if ~template ==true || ~userTemplateId==true }}{{else}}{{:~name.slice(3,6)}}{{/if}}</div>{{else}}<div class='e-ampmdisplay e-ampmstyle'></div>{{/if}} {{/if}}{{/for}}</td>{{else}}<td class='e-timecells'><div class='e-timecelldivs'></div></td>{{/if}}{{/for}}</tr>{{/for}}</tbody></table></div>");
    };

    var userTimeCellsTemplate = function () {
        return ("<div class='e-scrolltimecells'><table class='e-table' cellpadding='0px' cellspacing='0px' width='70px'>" +
                "<tbody>{{for timerows ~timesc=timeScale ~cols1=cols1 ~view1=viewclass  ~userTemplateId = userTemplateId ~timeValue1=timeValue1 ~template=template ~cheight = cheight}}" +
                "<tr height='21px'>{{if ~timesc == 1}}<th class='e-timecells' rowspan='1'>{{else}}<th class='' rowspan='1'>{{/if}}{{:~timeValue1[#getIndex()][0]}}</th></tr>" +
                "{{for ~cols1 ~name=time ~id=id ~view=~view1 ~index=#index ~timeSc=~timesc}}" +
                "{{if  (#getIndex()+2)% ~timeSc ==0}}<tr height='21px'><th class='e-timecells' style='text-align:left' rowspan='1'>{{:~timeValue1[~index][#getIndex()+1]}}</th></tr> " +
                "{{else}}<tr height='21px'>{{if ~timesc == 1}}<th class='e-timecells' rowspan='1'>{{else}}<th class='' rowspan='1'>{{/if}}{{:~timeValue1[~index][#getIndex()+1]}}</th></tr>{{/if}}{{/for}}{{/for}}</tbody></table></div>");
    };
    var agendaHeaderTemplate = function () {
        return ("<tr>{{for cols}}<td class='e-headercells {{:className}} {{if (#index==0)}}e-firstcolumn{{/if}}'><div class='e-textwrapper'><b>{{:headertext}}</b></div></td>{{/for}}</tr>");
    };

    var agendaCellsTemplate = function () {
        return ("<table class='e-table e-agendacellstab' width='100%' cellpadding='0px' cellspacing='0px'>" +
                "<tbody >{{for cols}}<tr>" +
                "{{if resGroup}}{{for resGroup}}<td class='e-agendacells {{:resId}} e-resourcecolumn {{if (#index==0)}}e-firstcolumn{{/if}}'><div class='e-textwrapper'>{{:text}}</div></td>{{/for}}{{/if}}" +
                "{{if resChild}}<td rowspan={{:resRowSpan}} class='e-agendacells e-resourcecolumn {{if (resGroup.length==0)}}e-firstcolumn{{/if}}'><div class='e-textwrapper'>{{if userResourceId == false}}{{:resName}}{{else}}{{:userResourceHtml}}{{/if}}</div></td>{{/if}}" +
                "{{if dayChild}}<td rowspan={{:dayRowSpan}} class='e-agendacells e-datecolumn {{if (resGroup.length != 0) }}{{else (resName =='')}}e-firstcolumn{{/if}}'><div class='e-textwrapper'>{{if userDateId == false}}{{:date}}{{else}}{{:userDateHtml}}{{/if}}</div></td>{{/if}}" +
                "<td class='e-agendacells e-timecolumn {{if dayBorderBottom==false}}e-alternatecells{{/if}}'><div class='e-textwrapper'>{{if userTimeId == false}}{{:time}}{{else}}{{:userTimeHtml}}{{/if}}</div></td>" +
                "<td class='e-agendacells e-eventcolumn {{if dayBorderBottom==false}}e-alternatecells{{/if}}'><div class='e-textwrapper'><div id='Appointment_{{:id}}'  guid= '{{:uid}}' class='e-agendaappointment'>{{if userAppTemplId == false}}<span class='e-agendacolordiv' style='background:{{:background}}; {{if ignoreColorFilter == true}}filter:none;{{/if}}'/>{{:event}}{{else}}{{:userTemplate}}{{/if}}{{if readOnly == false}}<div class='e-agendahover'><span class='e-icon e-edit_05 e-editapp' title={{:edittext}}/><span class='e-icon e-close e-deleteapp' title={{:deletetext}}/></div>{{/if}}</div></div></td>" +
                "</tr>{{/for}}</tbody></table>");
    };

    ej.widget("ejSchedule", "ej.Schedule", {
        _rootCSS: "e-schedule",
        element: null,
        validTags: ["div"],
        model: null,
        _requiresID: true,
        defaults: {
            timeZoneCollection: {
                dataSource: [
                { text: "UTC -12:00", id: "1", value: "UTC -12:00" },
                { text: "UTC -11:00", id: "2", value: "UTC -11:00" },
                { text: "UTC -10:00", id: "3", value: "UTC -10:00" },
                { text: "UTC -09:00", id: "4", value: "UTC -09:00" },
                { text: "UTC -08:00", id: "5", value: "UTC -08:00" },
                { text: "UTC -07:00", id: "6", value: "UTC -07:00" },
                { text: "UTC -06:00", id: "7", value: "UTC -06:00" },
                { text: "UTC -05:00", id: "8", value: "UTC -05:00" },
                { text: "UTC -04:30", id: "9", value: "UTC -04:30" },
                { text: "UTC -04:00", id: "10", value: "UTC -04:00" },
                { text: "UTC -03:30", id: "11", value: "UTC -03:30" },
                { text: "UTC -03:00", id: "12", value: "UTC -03:00" },
                { text: "UTC -02:00", id: "13", value: "UTC -02:00" },
                { text: "UTC -01:00", id: "14", value: "UTC -01:00" },
                { text: "UTC +00:00", id: "15", value: "UTC +00:00" },
                { text: "UTC +01:00", id: "16", value: "UTC +01:00" },
                { text: "UTC +02:00", id: "17", value: "UTC +02:00" },
                { text: "UTC +03:00", id: "18", value: "UTC +03:00" },
                { text: "UTC +03:30", id: "19", value: "UTC +03:30" },
                { text: "UTC +04:00", id: "20", value: "UTC +04:00" },
                { text: "UTC +04:30", id: "21", value: "UTC +04:30" },
                { text: "UTC +05:00", id: "22", value: "UTC +05:00" },
                { text: "UTC +05:30", id: "23", value: "UTC +05:30" },
                { text: "UTC +05:45", id: "24", value: "UTC +05:45" },
                { text: "UTC +06:00", id: "25", value: "UTC +06:00" },
                { text: "UTC +06:30", id: "26", value: "UTC +06:30" },
                { text: "UTC +07:00", id: "27", value: "UTC +07:00" },
                { text: "UTC +08:00", id: "28", value: "UTC +08:00" },
                { text: "UTC +09:00", id: "29", value: "UTC +09:00" },
                { text: "UTC +09:30", id: "30", value: "UTC +09:30" },
                { text: "UTC +10:00", id: "31", value: "UTC +10:00" },
                { text: "UTC +11:00", id: "32", value: "UTC +11:00" },
                { text: "UTC +12:00", id: "33", value: "UTC +12:00" },
                { text: "UTC +13:00", id: "34", value: "UTC +13:00" }
                ],
                text: "text",
                id: "id",
                value: "value"
            },
            views: ["Day", "Week", "WorkWeek", "Month", "Agenda"],
            agendaViewSettings: {
                daysInAgenda: 7,
                dateColumnTemplateId: null,
                timeColumnTemplateId: null
            },
            currentView: "week",
            timeMode: null,
            firstDayOfWeek: null,
            workWeek: ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"],
            dateFormat: "",
            isDST: false,
            timeZone: null,
            timeScale: {
                enable: true,
                minorSlotCount: 2,
                majorSlot: 60,
                minorSlotTemplateId: null,
                majorSlotTemplateId: null
            },
            startHour: 0,
            endHour: 24,
            highlightBusinessHours: true,
            enableLoadOnDemand: false,
            enablePersistence: false,
            showQuickWindow: true,
            showLocationField: false,
            showTimeZoneFields: true,
            businessStartHour: 9,
            businessEndHour: 18,
            workHours: {
                highlight: true,
                start: 9,
                end: 18
            },
            width: "100%",
            height: "1120px",
            cellHeight: "",
            cellWidth: "",
            currentDate: new Date(),
            minDate: new Date(1900, 01, 01),
            maxDate: new Date(2099, 12, 31),
            cssClass: "",
            locale: "en-US",
            enableResize: false,
            readOnly: false,
            enableRTL: false,
            enableAppointmentNavigation: null,
            showAppointmentNavigator: true,
            appointmentTemplateId: null,
            allDayCellsTemplateId: null,
            dateHeaderTemplateId: null,
            workCellsTemplateId: null,
            resourceHeaderTemplateId: null,
            allowDragDrop: null,
            allowDragAndDrop: true,
            enableAppointmentResize: true,
            showCurrentTimeIndicator: true,
            showAllDayRow: true,
            showHeaderBar: true,
            isResponsive: true,
            showWeekend: true,
            enableRecurrenceValidation: true,
            appointmentDragArea: "",
            showOverflowButton: true,
            reminderSettings: {
                enable: false,
                alertBefore: 5
            },
            contextMenuSettings: {
                enable: false,
                menuItems: {
                    appointment: [
                        { id: "open", text: "Open Appointment" },
                        { id: "delete", text: "Delete Appointment" }
                    ],
                    cells: [
                        { id: "new", text: "New Appointment" },
                        { id: "recurrence", text: "New Recurring Appointment" },
                        { id: "today", text: "Today" },
                        { id: "gotodate", text: "Go to date" },
                        { id: "settings", text: "Settings" },
                        { id: "view", text: "View", parentId: "settings" },
                        { id: "timemode", text: "TimeMode", parentId: "settings" },
                        { id: "view_Day", text: "Day", parentId: "view" },
                        { id: "view_Week", text: "Week", parentId: "view" },
                        { id: "view_Workweek", text: "Workweek", parentId: "view" },
                        { id: "view_Month", text: "Month", parentId: "view" },
                        { id: "view_Agenda", text: "Agenda", parentId: "view" },
                        { id: "timemode_Hour12", text: "12 Hours", parentId: "timemode" },
                        { id: "timemode_Hour24", text: "24 Hours", parentId: "timemode" },
                        { id: "workhours", text: "Work Hours", parentId: "settings" }
                    ]
                }
            },
            group: null,
            resources: null,
            allowKeyboardNavigation: true,
            blockoutSettings: {
                enable: false,
                templateId: null,
                dataSource: [],
                query: null,
                tableName: null,
                id: "Id",
                subject: "Subject",
                startTime: "StartTime",
                endTime: "EndTime",
                isBlockAppointment: "IsBlockAppointment",
                isAllDay: null,
                customStyle: null,
                resourceId: null
            },
            appointmentSettings: {
                applyTimeOffset: true,
                dataSource: [],
                query: null,
                tableName: null,
                id: null,
                subject: null,
                description: null,
                startTime: null,
                endTime: null,
                recurrence: null,
                recurrenceRule: null,
                allDay: null,
                resourceFields: null,
                categorize: null,
                recurrenceId: null,
                recurrenceExDate: null,
                location: null,
                priority: null,
                startTimeZone: null,
                endTimeZone: null
            },
            renderDates: null,
            orientation: "vertical",
            categorizeSettings: {
                title: null,
                enable: false,
                allowMultiple: false,
                dataSource:
                   [
                   { text: "Blue Category", id: 1, color: "#43b496", fontColor: "#ffffff" },
                   { text: "Green Category", id: 2, color: "#7f993e", fontColor: "#ffffff" },
                   { text: "Orange Category", id: 3, color: "#cc8638", fontColor: "#ffffff" },
                   { text: "Purple Category", id: 4, color: "#ab54a0", fontColor: "#ffffff" },
                   { text: "Red Category", id: 5, color: "#dd654e", fontColor: "#ffffff" },
                   { text: "Yellow Category", id: 6, color: "#d0af2b", fontColor: "#ffffff" }
                   ],
                text: "text",
                id: "id",
                color: "color",
                fontColor: "fontColor"
            },
            prioritySettings: {
                title: null,
                enable: false,
                template: null,
                dataSource:
                [
                { text: "None", value: "none" },
                { text: "High", value: "high" },
                { text: "Medium", value: "medium" },
                { text: "Low", value: "low" }
                ],
                text: "text",
                value: "value"
            },
            showTimeScale: true,
            tooltipSettings: {
                enable: false,
                templateId: null
            },
            showDeleteConfirmationDialog: true,
            showNextPrevMonth: true,
            cellClick: null,
            cellHover: null,
            appointmentClick: null,
            appointmentHover: null,
            cellDoubleClick: null,
            appointmentWindowOpen: null,
            appointmentSaved: null,
            appointmentEdited: null,
            appointmentDeleted: null,
            beforeAppointmentCreate: null,
            beforeAppointmentChange: null,
            beforeAppointmentRemove: null,
            appointmentCreated: null,
            appointmentChanged: null,
            appointmentRemoved: null,
            keyDown: null,
            navigation: null,
            dragStart: null,
            drag: null,
            dragStop: null,
            resizeStart: null,
            resize: null,
            resizeStop: null,
            menuItemClick: null,
            beforeContextMenuOpen: null,
            reminder: null,
            actionBegin: null,
            actionComplete: null,
            overflowButtonClick: null,
            overflowButtonHover: null,
            create: null,
            load: null,
            destroy: null,
            queryCellInfo: null
        },
        dataTypes: {
            views: "array",
            workWeek: "array",
            timeZoneCollection: {
                dataSource: "data",
                query: "data"
            },
            renderDates: "data",
            enablePersistence: "boolean",
            showTimeScale: "boolean",
            resources: "array",
            group: {
                resources: "array"
            },
            appointmentSettings: {
                dataSource: "data",
                query: "data",
                subject: "parent",
                description: "parent",
                startTime: "parent",
                endTime: "parent",
                recurrence: "parent",
                recurrenceRule: "parent",
                allDay: "parent",
                resourceFields: "parent",
                categorize: "parent",
                location: "parent",
                priority: "parent",
                startTimeZone: "parent",
                endTimeZone: "parent"
            },
            categorizeSettings: {
                dataSource: "data",
                query: "data"
            },
            prioritySettings: {
                dataSource: "data",
                query: "data"
            },
            contextMenuSettings: {
                menuItems: {
                    appointment: "array",
                    cells: "array",
                }
            },
            blockoutSettings: {
                dataSource: "data",
                query: "data"
            }
        },
        _ignoreOnPersist: [
            "appointmentSettings.query", "appointmentSettings.dataSource", "timeZoneCollection.dataSource",
            "allowKeyboardNavigation", "showQuickWindow", "cssClass", "locale", "enableResize", "showHeaderBar",
            "readOnly", "enableRTL", "enableAppointmentNavigation", "showAppointmentNavigator", "appointmentTemplateId", "resourceHeaderTemplateId", "allowDragDrop", "allowDragAndDrop", "enableAppointmentResize",
            "showCurrentTimeIndicator", "reminderSettings.enable", "contextMenuSettings.enable", "group", "categorizeSettings.enable", "categorizeSettings.dataSource",
            "cellClick", "overflowButtonClick ", "overflowButtonHover", "keyDown", "appointmentClick", "cellDoubleClick", "appointmentWindowOpen", "appointmentSaved", "appointmentEdited", "appointmentDeleted", "beforeAppointmentCreate", "beforeAppointmentChange", "beforeAppointmentRemove", "appointmentCreated", "appiontmentChanged", "appointmentRemoved", "navigation", "dragStart", "dragStop",
            "resizeStart", "resize", "resizeStop", "menuItemClick", "beforeContextMenuOpen", "reminder", "prioritySettings.dataSource", "prioritySettings.enable", "agendaViewSettings.daysInAgenda", "agendaViewSettings.dateColumnTemplateId", "agendaViewSettings.timeColumnTemplateId", "blockoutSettings.dataSource"
        ],
        _ignoreFromAppointmentOnExport: ["dataSource", "query", "tableName", "resourceFields"],
        _ignoreFromModelOnExport: ["timezoneCollection", "timeZoneCollection", "contextMenuSettings", "prioritySettings"],
        _resources: function (index, property, value, old) {
            this.element.empty();
            this._bindResourcesData();
            if (!ej.isNullOrUndefined(this.dataSource()))
                this._renderAppointmentAll();
        },
        observables: ["appointmentSettings.dataSource", "currentView", "currentDate"],
        _tags: [
            { tag: "timeZoneCollection", attr: [], "singular": "timeZoneCollection" },
            { tag: "appointmentSettings.dataSource", attr: [], "singular": "dataSource" },
            { tag: "resources", attr: ["allowMultiple", "field", "title", "name", "resourceSettings"] },
            { tag: "contextMenuSettings.menuItems.appointment", attr: ["id", "text", "parentId"] },
            { tag: "contextMenuSettings.menuItems.cells", attr: ["id", "text", "parentId"] },
            { tag: "categorizeSettings.dataSource", attr: ["text", "id", "color", "fontColor"] },
            { tag: "timeZoneCollection.dataSource", attr: ["text", "id", "value"] },
            { tag: "prioritySettings.dataSource", attr: ["text", "value"] }
        ],
        currentView: ej.util.valueFunction("currentView"),
        currentDate: ej.util.valueFunction("currentDate"),
        dataSource: ej.util.valueFunction("appointmentSettings.dataSource"),

        _init: function () {
            if ($.isEmptyObject(this.model.group)) this.model.group = null;
            this._localizedLabels = ej.getLocalizedConstants("ej.Schedule", this.model.locale);
            if (this.model.locale != "en-US") this._recurrenceLocal();
            if (ej.isNullOrUndefined(this.model.workHours.start)) this.model.workHours.start = this.model.businessStartHour;
            if (ej.isNullOrUndefined(this.model.workHours.end)) this.model.workHours.end = this.model.businessEndHour;
            if (ej.isNullOrUndefined(this.model.workHours.highlight)) this.model.workHours.highlight = this.model.highlightBusinessHours;
            if (ej.isNullOrUndefined(this.model.timeZoneCollection)) this.model.timeZoneCollection = this.model.timezoneCollection;
            if (ej.isNullOrUndefined(this.model.timeScale.enable)) this.model.timeScale.enable = this.model.showTimeScale;
            //Added the deprecating the enableAppointmentNavigation API
            this.model.showAppointmentNavigator = ej.isNullOrUndefined(this.model.enableAppointmentNavigation) ? this.model.showAppointmentNavigator : this.model.enableAppointmentNavigation;
            this.model.allowDragAndDrop = ej.isNullOrUndefined(this.model.allowDragDrop) ? this.model.allowDragAndDrop : this.model.allowDragDrop;
            //Added the deprecating the appointmentEvents API
            if (ej.isNullOrUndefined(this.model.beforeAppointmentCreate)) this.model.beforeAppointmentCreate = this.model.appointmentSaved;
            if (ej.isNullOrUndefined(this.model.beforeAppointmentChange)) this.model.beforeAppointmentChange = this.model.appointmentEdited;
            if (ej.isNullOrUndefined(this.model.beforeAppointmentRemove)) this.model.beforeAppointmentRemove = this.model.appointmentDeleted;
            this._processAppointmentSettings();
            this._currentDateFormat(this.model.dateFormat);
            this._trigger("load");
            this.element.addClass("e-schedule");
            (this.model.cssClass != null) && this.element.addClass(this.model.cssClass);
            this._initPrivateProperties();
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) this._resourceSegregate();
            if (this.model.categorizeSettings.enable && this.model.categorizeSettings.dataSource instanceof ej.DataManager) this._bindCategorizeData();
            if (this.model.prioritySettings.enable && this.model.prioritySettings.dataSource instanceof ej.DataManager) this._bindPriorityData();
            (ej.scheduleFeatures.resources && this._tempResource.length != 0) ? this._bindResourcesData() : this._renderInitSchedule();
            this._wireEvents();
            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
            this._bindAppointmentsData("Load");
            if (this.model.blockoutSettings.enable) {
                (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
            }
            if (this.model.reminderSettings.enable) {
                this._checkReminders();
                this._reminderInterval = window.setInterval($.proxy(this._checkReminders, this), 60000);
            }
        },
        _processAppointmentSettings: function () {
            if (ej.isNullOrUndefined(this.model.appointmentSettings.query) || !(this.model.appointmentSettings.query instanceof ej.Query)) this.model.appointmentSettings.query = ej.Query();
            this._appointmentSettings = {}, resource = "";
            this._applyTimeOffset = this.model.appointmentSettings.applyTimeOffset;
            for (var col in this.model.appointmentSettings) {
                if (col != "applyTimeOffset") {
                    if (col !== "tableName" && col !== "query" && col !== "dataSource") {
                        this._appointmentSettings[col] = ($.type(this.model.appointmentSettings[col]) == "string" || ej.isNullOrUndefined(this.model.appointmentSettings[col])) ? this.model.appointmentSettings[col] : this.model.appointmentSettings[col].field;
                        if (col !== "resourceFields" && col !== "categorize" && col !== "priority")
                            (ej.isNullOrUndefined(this._appointmentSettings[col])) && (this._appointmentSettings[col] = col.charAt(0).toUpperCase() + col.slice(1));
                        if (col == "resourceFields" && ej.isNullOrUndefined(this._appointmentSettings.resourceFields) && !ej.isNullOrUndefined(this.model.resources)) {
                            for (var i = 0, len = this.model.resources.length; i < len; i++) {
                                resource = this.model.resources[i].field.charAt(0).toUpperCase() + this.model.resources[i].field.slice(1);
                                this._appointmentSettings[col] += ((i !== 0) ? "," : "") + resource;
                            }
                        }
                    }
                }
            }
        },
        _setModel: function (options) {
            var flag = false;
            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow)) this._quickAppDetailsWindow.ejDialog("close");
            for (var prop in options) {
                switch (prop) {
                    case "views":
                        this.model.views = options[prop];
                        this.model.views = (this.model.views.length == 0) ? this.currentView().toString().toLowerCase().split(",") : this.model.views.toString().toLowerCase().split(",");
                        this.hTR.find("table.e-viewstable").remove();
                        this.hTR.find("div.e-viewsdiv").append(this._renderViewNavigation(options[prop].toString().toLowerCase().split(",")));
                        this.element.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview").attr("tabIndex", 0).focus();
                        if (!ej.isNullOrUndefined(this._scheduleDrawer)) {
                            this._scheduleDrawer.ejNavigationDrawer('destroy');
                            $(this._scheduleDrawer).remove(); this._scheduleDrawer = null;
                            ((this._mediaQuery || this.element.width() < 600) && !$("#" + this._id + "navDrawer").hasClass("e-scheduledrawer")) && this._renderNavigationDrawer();
                        }
                        if (this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) == -1) {
                            this._navView = true;
                            if (this.model.views.length == 0) {
                                this.model.views = this.currentView().toString().toLowerCase().split(",");
                                flag = true;
                            }
                            else
                                this._viewChange(null, null, this.model.views[0].toLowerCase());
                        }
                        break;
                    case "currentView":
                        if (this.model.views.toString().toLowerCase().split(',').indexOf(ej.util.getVal(options[prop]).toLowerCase()) != -1) {
                            this._navView = true;
                            this._viewChange(null, null, ej.util.getVal(options[prop]).toLowerCase())
                        }
                        else {
                            this._navView = false;
                            this.currentView((this.element.find(".e-activeview")[0].className.split("e-")[2]).split(" ")[0]);
                        }
                        break;
                    case "currentDate":
                        if ($.type(options[prop]) == "string")
                            this._currentDateFormat(this.model.dateFormat);
                        else if ($.type(options[prop]) == "function" && $.type(ej.util.getVal(options[prop])) == "string")
                            this.currentDate(ej.parseDate(this.currentDate(), this._datepattern()));
                        if (this._keyPressed) {
                            this._keyPressed = false;
                            return false;
                        }
                        this._setCurrentDate = true;
                        ((this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate));
                        ((this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate));
                        this._navigateClick(null, "DateNavigation");
                        break;
                    case "minDate":
                    case "maxDate":
                        this._currentDateFormat(this.model.dateFormat);
                        flag = true;
                        break;
                    case "timeMode":
                        this.model.timeMode = this._timeMode = (options[prop] == "Hour12") ? "12" : (options[prop] == "Hour24") ? "24" : options[prop];
                        this._updateTimeMode();
                        break;
                    case "timeZone":
                        this._setmodelvalue = true;
                        this.model.timeZone = options[prop];
                        this.element.find("div.e-categorybar").remove();
                        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,.e-appsoverflow").remove();
                        this._bindAppointmentsData("Load");
                        if (this.model.blockoutSettings.enable) {
                            (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
                        }
                        break;
                    case "showTimeScale":
                    case "timeScale":
                        if (prop == "showTimeScale") this.model.timeScale.enable = options[prop];
                        if (prop == "timeScale") $.extend(this.model.timeScale, options[prop]);
                        (this.currentView() !== "agenda") && (flag = true);
                        break;
                    case "timezoneCollection":
                    case "timeZoneCollection":
                        $.extend(this.model.timeZoneCollection, options[prop]);
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        this._appointmentAddWindow.find('.startutc').ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                        this._appointmentAddWindow.find('.endutc').ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                        break;
                    case "showTimeZoneFields":
                        this.model.showTimeZoneFields = options[prop];
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (this.model.showTimeZoneFields) {
                            if (this._appointmentAddWindow.find("#" + this._id + "_appStartTime").children().length < 4) {
                                if (this._mediaQuery) {
                                    var $startTimeZone = "<td width='31%'><input id='" + this._id + "startTimeZone' class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                                    var $endTimeZone = "<td><input  id='" + this._id + "endTimeZone' class='endutc' name='" + this._appointmentSettings["endTimeZone"] + "' type='text' value=''/><div id='Timezonelistend'></div></td>";
                                }
                                else {
                                    var $startTimeZone = "<td width='28%'><input  id='" + this._id + "startTimeZone'  class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                                    var $endTimeZone = "<td><input id='" + this._id + "endTimeZone'  class='endutc'  name='" + this._appointmentSettings["endTimeZone"] + "'  type='text' value=''/><div id='Timezonelistend'></div></td>";
                                }
                                this._appointmentAddWindow.find("#" + this._id + "_appStartTime").append($startTimeZone);
                                this._appointmentAddWindow.find("#" + this._id + "_appEndTime").append($endTimeZone);
                                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._startUtc, this), cssClass: this.model.cssClass });
                                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._endUtc, this), cssClass: this.model.cssClass });
                            }
                            this._timeZoneCollection(null);
                        }
                        else {
                            this._appointmentAddWindow.find("#" + this._id + "_appStartTime").children().last().remove();
                            this._appointmentAddWindow.find("#" + this._id + "_appEndTime").children().last().remove();
                        }
                        break;
                    case "startHour":
                        this.model.startHour = options[prop];
                        if (this.model.startHour < 0) this.model.startHour = 0;
                        (this.currentView() !== "agenda") && this._setNewStartEndHours();
                        break;
                    case "endHour":
                        this.model.endHour = options[prop];
                        if (this.model.endHour > 24) this.model.endHour = 24;
                        (this.currentView() !== "agenda") && this._setNewStartEndHours();
                        break;
                    case "highlightBusinessHours":
                    case "businessStartHour":
                    case "businessEndHour":
                    case "workHours":
                        if (prop == "highlightBusinessHours") this.model.workHours.highlight = options[prop];
                        if (prop == "businessStartHour") this.model.workHours.start = options[prop];
                        if (prop == "businessEndHour") this.model.workHours.end = options[prop];
                        if (prop == "workHours") $.extend(this.model.workHours, options[prop]);
                        if (this.currentView() !== "agenda") {
                            (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells,.e-monthcells").removeClass("e-businesshighlightworkcells").removeClass("e-monthcellhighlight");
                            this._businessHourScroller();
                            this._renderUpDownIconPosition();
                        }
                        break;
                    case "showAllDayRow":
                        this.model.showAllDayRow = options[prop];
                        (!this.model.timeScale.enable) && (this.model.showAllDayRow = false);
                        if (this.model.orientation == "vertical" && this.model.timeScale.enable && this.currentView() != "agenda" && this.currentView() != "month" && !(this._isCustomMonthView())) {
                            this.aTR.empty();
                            this._renderHeaderAllDayTemplate();
                            this._borderAddRemove();
                            this._headerbarWidth();
                            this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                            (this.model.showAllDayRow) && this._reRenderAllDayAppointments();
                            if (this.model.orientation == "vertical" && this.model.cellWidth) {
                                this.element.find(".e-workcellstab tr td:first-child").width(this.element.find(".e-headercells").width());
                            }
                            this._reRenderScroller();
                        }
                        break;
                    case "isResponsive":
                        this.model.isResponsive = options[prop];
                        this._onScheduleResize();
                        break;
                    case "isDST":
                        this.model.isDST = options[prop];
                        if (ej.isNullOrUndefined(this.model.timeZone)) {
                            var today = new Date();
                            this._timeValue = this._true == false ? -(today.getTimezoneOffset() - this._stdTimezoneOffset()) : today.getTimezoneOffset() - this._stdTimezoneOffset();
                            this._true = (this.model.isDST == true) ? false : true;
                            this._dayLight = true;
                            this.element.find("div.e-categorybar").remove();
                            this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-appsoverflow").remove();
                            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
                            this._bindAppointmentsData("Load");
                        }
                        break;
                    case "enableRecurrenceValidation":
                        this.model.enableRecurrenceValidation = options[prop];
                        (this.model.enableRecurrenceValidation && ej.isNullOrUndefined(this._alertWindow)) && this._renderAlertWindow();
                        this._dataProcessing(this._currentAppointmentData);
                        this._renderAppointmentAll();
                        break;
                    case "height":
                        this.model.height = options[prop];
                        if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                        flag = true;
                        break;
                    case "width":
                        this.model.width = options[prop];
                        this._clientWidth = this.model.width;
                        if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                        flag = true;
                        break;
                    case "cssClass":
                        this.element.removeClass(this.model.cssClass).addClass(options[prop]);
                        break;
                    case "locale":
                        this.model.locale = options[prop];
                        this._localizedLabels = ej.getLocalizedConstants("ej.Schedule", this.model.locale);
                        if (this.model.locale != "en-US") this._recurrenceLocal();
                        this._culture = ej.preferredCulture(this.model.locale);
                        this._dayShortNames = this._culture.calendar.days.namesAbbr;
                        this._dayFullNames = this._culture.calendar.days.names;
                        this._monthNames = this._culture.calendar.months.names;
                        this._pattern = this._culture.calendar.patterns;
                        if (this.model.contextMenuSettings.enable) {
                            $("#" + this._id + "gotoWindow_wrapper").remove();
                            this._gotoDate = true;
                        }
                        flag = true;
                        break;
                    case "dateFormat":
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        this._appointmentAddWindow.find('.startenddate').ejDatePicker({ dateFormat: options[prop] });
                        this._appointmentAddWindow.find('.recurstartdate').ejDatePicker({ dateFormat: options[prop] });
                        this._appointmentAddWindow.find('.e-until').ejDatePicker({ dateFormat: options[prop] });
                        this._currentDateFormat(options[prop]);
                        break;
                    case "enableResize":
                        this.model.enableResize = options[prop];
                        if (this.model.enableResize) {
                            !ej.isTouchDevice() ? this._on($(window), "resize", $.proxy(this._onScheduleResize, this)) : this._on($(window), "orientationchange", $.proxy(this._onScheduleResize, this));
                        }
                        break;
                    case "readOnly":
                        this.model.readOnly = options[prop];
                        this._renderAppointmentAll();
                        break;
                    case "showCurrentTimeIndicator":
                        this.model.showCurrentTimeIndicator = options[prop];
                        if (this.currentView() !== "agenda") {
                            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                            if (!this.model.showCurrentTimeIndicator) this.currentView() !== "month" && !(this._isCustomMonthView()) ? this.element.find(".e-highlightcurrenttimeline").remove() : $(this.element.find(".e-monthcells")).removeClass("e-monthcurrenttime");
                        }
                        break;
                    case "enableRTL":
                        options[prop] ? this.element.addClass("e-rtl") : this.element.removeClass("e-rtl");
                        this.model.enableRTL = options[prop];
                        flag = true;
                        if (this.model.contextMenuSettings.enable) {
                            $("#" + this._id + "gotoWindow_wrapper").remove();
                            this._gotoDate = true;
                        }
                        this._quickAppointWindow = null;
                        break;
                    case "appointmentTemplateId":
                        this.model.appointmentTemplateId = options[prop];
                        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,.e-appsoverflow").remove();
                        this.element.find("div.e-categorybar").remove();
                        if (!ej.isNullOrUndefined(this.dataSource()))
                            this._renderAppointmentAll();
                        break;
                    case "allDayCellsTemplateId":
                        this.model.allDayCellsTemplateId = options[prop];
                        flag = true;
                        break;
                    case "dateHeaderTemplateId":
                        this.model.dateHeaderTemplateId = options[prop];
                        flag = true;
                        break;
                    case "workCellsTemplateId":
                        this.model.workCellsTemplateId = options[prop];
                        flag = true;
                        break;
                    case "showWeekend":
                        this.model.showWeekend = options[prop];
                        flag = true;
                        break;
                    case "allowKeyboardNavigation":
                        this.model.allowKeyboardNavigation = options[prop];
                        if (this.model.allowKeyboardNavigation) {
                            this._on(this.element, "keydown", $.proxy(this._onKeyDown, this));
                            this._on($(document), "keydown", $.proxy(this._documentOnKeyDown, this));
                        }
                        else {
                            this._off(this.element, "keydown");
                            this._off($(document), "keydown");
                        }
                        break;
                    case "renderDates":
                        $.extend(this.model.renderDates, options[prop]);
                        this._navView = true;
                        this._viewChange(null, null, "customview");
                        break;
                    case "appointmentSettings":
                        if (!$.isEmptyObject(options[prop])) {
                            $.extend(this.model.appointmentSettings, options[prop]);
                            this._processAppointmentSettings();
                            this.element.find("div.e-categorybar").remove();
                            this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-appsoverflow").remove();
                            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
                            this._setmodelvalue = true;
                            this._bindAppointmentsData("Load");
                        }
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model.contextMenuSettings, options[prop]);
                        if (this.model.contextMenuSettings.enable && (ej.isNullOrUndefined(this._contextMenu) || this.model.categorizeSettings.enable))
                            this._showContextMenu(this.model.contextMenuSettings.enable);
                        break;
                    case "reminderSettings":
                        if (options[prop].enable)
                            this._checkReminders() && (this._reminderInterval = window.setInterval($.proxy(this._checkReminders, this), 60000));
                        else
                            window.clearInterval(this._reminderInterval);
                        break;
                    case "showAppointmentNavigator":
                    case "enableAppointmentNavigation":
                        this.model.showAppointmentNavigator = this.model.enableAppointmentNavigation = options[prop];
                        if (!this.model.showAppointmentNavigator) {
                            this.element.find(".e-prevapp,.e-nextapp").remove();
                            this.element.find(".e-upicon,.e-downicon").remove();
                        }
                        else {
                            this._nextPrevAppointment(this.model.showAppointmentNavigator);
                            if (this.model.orientation == "vertical" && this.element.find(".e-vscroll").length > 0 && this.currentView() != "month" && (!this._isCustomMonthView()) && (!this._mediaQuery))
                                this._renderUpDownIcon();
                            if (!ej.isNullOrUndefined(this.dataSource()))
                                this._renderAppointmentAll();
                        }
                        break;
                    case "enableLoadOnDemand":
                        this.model.enableLoadOnDemand = options[prop];
                        this.element.find("div.e-categorybar").remove();
                        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,.e-appsoverflow").remove();
                        this._bindAppointmentsData("Load");
                        break;
                    case "resources":
                        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                            ej.copyObject(this.model.resources, options[prop]);
                            this.model.resources = options[prop];
                            if (this.model.resources.length == 0) {
                                this.model.resources = null;
                                this.model.group = null;
                                flag = true;
                            }
                            else
                                flag = true;
                        }
                        break;
                    case "categorizeSettings":
                        $.extend(this.model.categorizeSettings, options[prop]);
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) {
                            this._renderTemplates();
                            this._renderAppointmentWindow();
                        }
                        else if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {
                            if (this.model.categorizeSettings.enable) {
                                if (this._appointmentAddWindow.find('.e-categorizevalue').length == 1)
                                    this._appointmentAddWindow.find('#' + this._id + "categorizetr").remove();
                                var $appWindow = "<tr id='" + this._id + "categorizetr'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Categorize") + ":</td><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "categorize' class='e-categorizevalue' type='text' name='" + this._appointmentSettings["categorize"] + "' value=''/></td></tr>";
                                this._appointmentAddWindow.find('.' + this._id + "summary").after($appWindow);
                                this._renderTemplates();
                                this._renderCategoryItems(this._appointmentAddWindow);
                            }
                            else
                                this._appointmentAddWindow.find('#' + this._id + "categorizetr").remove();
                        }
                        this._showContextMenu(this.model.contextMenuSettings.enable);
                        if (!ej.isNullOrUndefined(this.dataSource()))
                            this._renderAppointmentAll();
                        break;
                    case "group":
                        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                            $.extend(this.model.group, options[prop]);
                            if ($.isEmptyObject(this.model.group)) this.model.group = null;
                            flag = true;
                        }
                        break;
                    case "cellWidth":
                        this.model.cellWidth = options[prop];
                        (this.currentView() !== "agenda") && (flag = true);
                        break;
                    case "cellHeight":
                        this.model.cellHeight = options[prop];
                        (this.currentView() !== "agenda") && (flag = true);
                        break;
                    case "orientation":
                        this.model.orientation = options[prop];
                        if (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && this.model.orientation == "horizontal")
                            this._on(this.element, "click", ".e-parentnodecategory", $.proxy(this._onResourceClick, this));
                        flag = true;
                        break;
                    case "resourceHeaderTemplateId":
                        this.model.resourceHeaderTemplateId = options[prop];
                        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) {
                            if (this.currentView() != "agenda") {
                                if (this.model.orientation == "horizontal") {
                                    var resDiv = $(this.wTR.find("td")[0]);
                                    resDiv.find("div.e-horizontresdiv").remove();
                                    var resHtml = this._renderHorizontalResources();
                                    resDiv.html(resHtml);
                                }
                                else {
                                    this.aTR.empty();
                                    this._renderHeaderAllDayTemplate();
                                    this._borderAddRemove();
                                    this._headerbarWidth();
                                    this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                                    (this.model.showAllDayRow) && this._reRenderAllDayAppointments();
                                }
                            }
                            else
                                this._renderAgendaContent();
                        }
                        break;
                    case "showLocationField":
                        this.model.showLocationField = options[prop];
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (this.model.showLocationField) {
                            $appWindow = "<tr id='" + this._id + "showLocation' class='" + this._id + "showLocation'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Location") + ":</td><td colspan='3' class='e-rightfields'>" +
                                 "<input id='" + this._id + "location' tabIndex='0' class='location e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["location"] + "' type='text' /><span class='e-ripple-bar'></td></tr>";
                            this._appointmentAddWindow.find("." + this._id + "subjecttr").after($appWindow);
                        }
                        else {
                            this._appointmentAddWindow.find("." + this._id + "showLocation").remove();
                        }
                        break;
                    case "prioritySettings":
                        $.extend(this.model.prioritySettings, options[prop]);
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (this.model.prioritySettings.enable) {
                            if (this._appointmentAddWindow.find("." + this._id + "priorityshow").length == 1) {
                                this._appointmentAddWindow.find("." + this._id + "priorityshow").remove();
                                this._appointmentAddWindow.find("." + this._id + "prioritylistshow").remove();
                            }
                            $appWindow = "<td colspan='1' class='e-textlabel " + this._id + "priorityshow'>" + this._getLocalizedLabels("Priority") + ":</td><td colspan='1' class='" + this._id + "prioritylistshow'><input id='" + this._id + "priority' class='priority' type='text' name='" + this._appointmentSettings["priority"] + "' value='' /><div id='prioritylist'></div></td>";
                            this._appointmentAddWindow.find("." + this._id + "parrow").prepend($appWindow);
                            this._renderPriorityItems(this._appointmentAddWindow);
                            this._renderTemplates();
                        }
                        else {
                            this._appointmentAddWindow.find("." + this._id + "priorityshow").remove();
                            this._appointmentAddWindow.find("." + this._id + "prioritylistshow").remove();
                        }
                        if (!ej.isNullOrUndefined(this.dataSource())) {
                            this._renderAppointmentAll();
                        }
                        break;
                    case "showQuickWindow":
                        this.model.showQuickWindow = options[prop];
                        if (ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._renderQuickWindow();
                        if (!ej.isNullOrUndefined(this._quickAppointWindow)) {
                            this._quickAppointWindow.ejDialog("close");
                            this._quickAppDetailsWindow.ejDialog("close");
                        }
                        this._quickWindow = this.model.showQuickWindow;
                        break;
                    case "allowDragAndDrop":
                    case "allowDragDrop":
                        this.model.allowDragAndDrop = this.model.allowDragDrop = options[prop];
                        if (this.currentView() == "agenda") return false;
                        this.model.allowDragAndDrop ? this._dragdropAppointments() : this._unWireDragDrop();
                        break;
                    case "enableAppointmentResize":
                        this.model.enableAppointmentResize = options[prop];
                        if (this.currentView() == "agenda") return false;
                        this._renderAppointmentAll();
                        break;
                    case "showHeaderBar":
                        this.model.showHeaderBar = options[prop];
                        if (this.model.showHeaderBar) {
                            this.element.find(".e-scheduleheader").show();
                            this._reRenderHeaderBar();
                        }
                        else {
                            this.element.find(".e-scheduleheader").empty();
                            this.element.find(".e-scheduleheader").hide();
                        }
                        this.refreshScroller();
                        break;
                    case "tooltipSettings":
                        $.extend(this.model.tooltipSettings, options[prop]);
                        var target = this.model.tooltipSettings.enable ? ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendacells.e-eventcolumn,.e-appup,.e-appdown,.e-appsoverflow" : ".e-appup,.e-appdown,.e-appsoverflow";
                        var toolTipObj = this.element.data("ejTooltip");
                        toolTipObj.setModel({ target: target });
                        break;
                    case "showOverflowButton":
                        this.model.showOverflowButton = options[prop];
                        flag = true;
                        break;
                    case "appointmentDragArea":
                        this.model.appointmentDragArea = options[prop];
                        flag = true;
                        break;
                    case "firstDayOfWeek":
                        this.model.firstDayOfWeek = this._firstdayofweek = options[prop];
                        if (this._firstdayofweek)
                            flag = true;
                        break;
                    case "workWeek":
                        this.model.workWeek = options[prop];
                        if (this.model.workWeek == null || this.model.workWeek.length >= 0)
                            flag = true;
                        break;
                    case "agendaViewSettings":
                        $.extend(this.model.agendaViewSettings, options[prop]);
                        if (this.currentView() == "agenda") {
                            (this.model.showHeaderBar) && this.element.find("div.e-datedisplay").html(this._getCurrentDateHeaderValue());
                            this._renderAgendaContent();
                        }
                        break;
                    case "showNextPrevMonth":
                        this.model.showNextPrevMonth = options[prop];
                        if (this.model.orientation == "vertical" && this.currentView() == "month") {
                            this._renderMonthTimeCells();
                            this._highlightBusinessHours();
                            this._dataProcessing(this._currentAppointmentData);
                            this._renderAppointmentAll();
                        }
                        break;
                    case "blockoutSettings":
                        if (!$.isEmptyObject(options[prop])) {
                            $.extend(this.model.blockoutSettings, options[prop]);
                            if (this.model.blockoutSettings.enable) {
                                (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
                            }
                        }
                        break;
                }
            }
            if (flag) {
                this.element.empty();
                !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('destroy');
                this._scheduleDrawer = null; this._quickAppointWindow = null; this._quickAppDetailsWindow = null; this._alertWindow = null; this._appointmentAddWindow = null;
                $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper").remove();
                if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) this._resourceSegregate();
                this._setmodelvalue = true;
                (this._tempResource.length == 0 && this._grouping.length == 0) ? this._renderInitSchedule() : this._bindResourcesData();
                this._businessHourScroller();
                if (!ej.isNullOrUndefined(this.dataSource())) this._dataProcessing(this._currentAppointmentData);
                this._renderAppointmentAll();
                if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            }
        },

        _touchSchedule: function (e) {
            if ($(e.target).is(".e-appointment,.e-alldayappointment,.e-monthappointment") || $(e.target).parents().is(".e-appointment,.e-alldayappointment,.e-monthappointment"))
                return false;
            if (this.model.orientation == "horizontal") return false;
            var eventType = this.model.enableRTL ? (e.type == "swipeleft" ? "swiperight" : "swipeleft") : e.type;
            var marginType = this.model.enableRTL ? "margin-right" : "margin-left";
            var event, value = parseInt(this.element.find(".e-draggableworkarea").css(marginType));
            var resWidth = Math.round(this.element.find(".e-draggableworkarea").width() / this.res1.length);
            var workIndent = (this.element.find(".e-workleftindent").length > 0) ? this.element.find(".e-workleftindent").outerWidth() : 0;
            var resPos = Math.round(Math.abs((this.element.find(".e-draggableworkarea").offset().left - workIndent - 1) / resWidth));
            if (this.currentView() == "month" || this._isCustomMonthView()) {
                var width = 0, num = eventType == "swipeleft" ? (resPos + 1) * 7 : (resPos - 1) * 7;
                for (var a = 0; a < num; a++) {
                    width += this.element.find(".e-draggableworkarea tr").eq(0).children().eq(a).outerWidth();
                }
                width += 3;
            }
            switch (eventType) {
                case "swipeleft":
                    if (this._mediaQuery && this.currentView() != "agenda" && this.model.orientation == "vertical") {
                        if (resPos + 1 != this.res1.length) {
                            var marginValue = (this.currentView() == "month" || this._isCustomMonthView()) ? -width : -((resPos + 1) * resWidth);
                            this.element.find(".e-headrealldaytable").css("left", "0px");
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").animate((this.model.enableRTL ? { "margin-right": marginValue } : { "margin-left": marginValue }), 500);
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").css(this.model.enableRTL ? { "margin-left": 0 } : { "margin-right": 0 });
                            if (resPos + 1 == this.res1.length - 1) this._showScrollTd();
                            return false;
                        }
                        this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-emptyscrolltd").css({ marginLeft: "0px", marginRight: "0px" });
                    }
                    event = { currentTarget: this.element.find('.e-navigatenext') };
                    this._navigateClick(event, "Next");
                    break;
                case "swiperight":
                    if (this._mediaQuery && this.currentView() != "agenda" && this.model.orientation == "vertical") {
                        if (resPos != 0) {
                            var marginValue = (this.currentView() == "month" || this._isCustomMonthView()) ? -width : -((resPos - 1) * resWidth);
                            this.element.find(".e-headrealldaytable").css("left", "0px");
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").animate((this.model.enableRTL ? { "margin-right": marginValue } : { "margin-left": marginValue }), 500);
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").css(this.model.enableRTL ? { "margin-left": 0 } : { "margin-right": 0 });
                            if (resPos + 1 == this.res1.length - 1) this._showScrollTd();
                            return false;
                        }
                        this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-emptyscrolltd").css({ marginLeft: "0px", marginRight: "0px" });
                    }
                    event = { currentTarget: this.element.find('.e-navigateprevious') };
                    this._navigateClick(event, "Previous");
                    break;
            }
        },

        _initPrivateProperties: function () {
            this._navSelected = this._navDrawer = this._alldayLevel = this._reminderClose = this._navView = this._editKey = this._cellClick = this._recurChecked = this._setCurrentDate = this._leftResizing = this._rightResizing = this._topResizing = this._bottomResizing = this._allDayDrag = this._dateNavigation = this._isQuickDialogOpened = false;
            this._gotoDate = this._bindapp = this._showBlockAlert = this._seriesAlert = this._isCustomAlert = true;
            this._tempStart = this._tempEnd = this._currentAction = "";
            this._currentRowIndex = this._currentColIndex = 0;
            this._appId = this._parentId = 1;
            this._currentAppointmentData = [], this._currentViewAppointments = [], this._processed = [], this._renderedApp = [], this._renderedAllDay = [], this._dateRender = [], this._grouping = [], this._tempResource = [];
            this.res1 = [0];
            this._appMainId = null, this._scheduleDrawer = null, this._quickAppointWindow = null, this._quickAppDetailsWindow = null, this._alertWindow = null, this._appointmentAddWindow = null;
            this._dayNamesArray = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
            this._dayNames = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"];
            this._culture = ej.preferredCulture(this.model.locale);
            this._dayShortNames = this._culture.calendar.days.namesAbbr;
            this._dayFullNames = this._culture.calendar.days.names;
            this._monthNames = this._culture.calendar.months.names;
            this._pattern = this._culture.calendar.patterns;
            this._browserInfo = ej.browserInfo();
            this._safariBrowser = this._browserInfo.name == "webkit" && !ej.isTouchDevice();
            this._focused = null;
            this._expandCollapseState = [];
            Array.prototype.map = Array.prototype.map || function (callback, thisArg) {
                var T, A, k;
                if (this == null) { throw new TypeError('this is null or not defined'); }
                var O = Object(this);
                var len = O.length >>> 0;
                if (typeof callback !== 'function') { throw new TypeError(callback + ' is not a function'); }
                if (arguments.length > 1) { T = thisArg; }
                A = new Array(len);
                k = 0;
                while (k < len) {
                    var kValue, mappedValue;
                    if (k in O) {
                        kValue = O[k];
                        mappedValue = callback.call(T, kValue, k, O);
                        A[k] = mappedValue;
                    }
                    k++;
                }
                return A;
            };
            String.prototype.trim = String.prototype.trim || function () { return this.replace(/^\s+|\s+$/g, ''); };
            String.prototype.capitalizeFirstString = String.prototype.capitalizeFirstString || function () { return this.charAt(0).toUpperCase() + this.slice(1); };
            Date.prototype.parseISO8601 = function (date) { return (typeof (date) === 'string') ? date.indexOf("Date") != -1 ? new Date(parseInt(date.match(/\d+/).toString())) : date.indexOf("T") != -1 ? new Date(date) : new Date(date.replace(/-/g, "/")) : new Date(date); };
            Date.prototype._currentMonthDates = function () { return { start: new Date(this.getFullYear(), this.getMonth(), 1), end: new Date(this.getFullYear(), this.getMonth() + 1, 0) }; };
            Date.prototype._currentWeekDates = function (firstdayofweek) {
                var dayDiffer = this.getDay() - firstdayofweek,
                    start = new Date(this.getFullYear(), this.getMonth(), this.getDate() + (((dayDiffer < 0) ? dayDiffer + 7 : dayDiffer) * -1)),
                    end = new Date(start.getFullYear(), start.getMonth(), start.getDate() + 6);
                return { start: new Date(start), end: new Date(end) };
            };
        },

        _destroy: function () {
            this.element.off();
            this._destorySubControls($("#" + this._id + "_AddEditForm"));
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find("#" + this._id + "recurrenceEditor").ejRecurrenceEditor("destroy");
            this.element.find("#" + this._id + "_navigator").ejDatePicker("destroy");
            window.clearInterval(this._intervalID);
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip("destroy");
            $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper,#" + this._id + "gotoWindow_wrapper").remove();
            this.element.empty().removeClass("e-schedule");
        },

        _destorySubControls: function (formelement) {
            var $formEle = formelement.find('.e-timepicker,.e-datepicker,.e-dropdownlist,.e-autocomplete');
            for (var index = 0; index < $formEle.length; index++) {
                var $element = $($formEle[index]);
                if ($element.hasClass('e-timepicker'))
                    $element.ejTimePicker("destroy");
                else if ($element.hasClass('e-datepicker'))
                    $element.ejDatePicker("destroy");
                else if ($element.hasClass('e-dropdownlist'))
                    $element.ejDropDownList("destroy");
                else if ($element.hasClass('e-autocomplete'))
                    $element.ejAutocomplete("destroy");
            }
        },
        _closeRecurence: function (args) {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            if (this._appointmentAddWindow.find('.e-recuruntil').ejRadioButton("option", "checked") && args.model.text != this._getLocalizedLabels("Cancel") && this._appointmentAddWindow.find('.recurstartdate').ejDatePicker("option", "value") > this._appointmentAddWindow.find(".e-until").ejDatePicker("option", "value")) {
                this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("WrongPattern"));
                this._alertWindow.ejDialog("open");
                return false;
            }
            var toggleWindow = true;
            if (args.model.text == this._getLocalizedLabels("Cancel")) {
                this._appointmentAddWindow.find(".e-recurFinalRule").html() == "" && this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox({ checked: false });
            }
            else {
                var obj = this._appointmentAddWindow.find(".e-recurEditor").data("ejRecurrenceEditor");
                this._rRuleStr = obj.closeRecurPublic();
                var dateChange = obj.element.find(".recurstartdate").ejDatePicker("option", "value");
                var collection = obj.recurrenceDateGenerator(obj._recRule, dateChange);
                if (obj._rRule.freq == "MONTHLY" && !ej.isNullOrUndefined(obj._rRule.monthDay)) {
                    var date = collection.filter(function (time) { return new Date(time).getDate() == obj._rRule.monthDay; });
                    if ((!ej.isNullOrUndefined(obj._rRule.count) && date.length != collection.length) || (ej.isNullOrUndefined(obj._rRule.count) && [29, 30, 31].indexOf(obj._rRule.monthDay) != -1)) {
                        toggleWindow = false;
                        if (this._alertWindow.find(".e-alertbtn").find(".e-alertCancel").length == 0) {
                            this._alertWindow.find(".e-alertbtn").append("<button id='" + this._id + "alertcancel' class='e-alertbutton e-alertCancel'></button>");
                            this._alertWindow.find(".e-alertCancel").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
                            if (this._mediaQuery) this._alertWindow.find(".e-alertCancel").css({ 'margin': '0px 20px 15px 10px' });
                        }
                        this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
                        this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("RecurrenceDateValidation"));
                        this._alertWindow.find(".e-alertCancel").html(this._getLocalizedLabels("Cancel"));
                        this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
                        this._alertWindow.addClass("e-recurAlert");
                        this._alertWindow.ejDialog("open");
                    }
                }
                if (new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value")).setHours(0, 0, 0, 0) != new Date(dateChange).getTime())
                    this._recurDateChange(dateChange);
                if (toggleWindow) {
                    this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                    this._appointmentAddWindow.find(".e-recurFinalRule").html(this._rRuleStr);
                    this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                }
            }
            if (toggleWindow) {
                this._appointmentAddWindow.find(".e-recurEditor").toggle();
                this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
                (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "block");
                this._appointmentAddWindow.find('.done').focus();
            }
        },
        _wireEvents: function () {
            this._on((this.element, $(window)), "mousedown", $.proxy(this._onScheduleMouseDown, this));
            this._on(this.element, "click", "div.e-navigateprevious,div.e-navigatenext", $.proxy(this._navigateClick, this));
            this._on($(window), "resize", $.proxy(this._onScheduleResize, this));
            this._on(this.element, "click", ".e-commonviewbutton", $.proxy(this._viewChange, this));
            this._on(this.element, "click", ".e-datedisplay", $.proxy(this._viewCalendar, this));
            this._on(this.element, "click", "div.e-appsoverflow", $.proxy(this._appOverflowClick, this));
            this._on(this.element, "click", ".e-prevapp.enable,.e-nextapp.enable", $.proxy(this._nextPrev, this));
            this._on(this.element, "dblclick", ".e-headercells", $.proxy(this._navigateView, this));
            this._on(this.element, "click", ".e-headercells,.e-timecells,td.e-monthcells div.e-monthheader", $.proxy(this._navigateView, this));
            this._on(this.element, "mouseover", "td.e-alldaycells,td.e-workcells:not('.e-resourceheadercells'),td.e-monthcells:not('.e-othermonths'),td.e-agendacells", $.proxy(this._onCellMouseOver, this));
            this._on(this.element, "mouseout", "td.e-alldaycells,td.e-workcells:not('.e-resourceheadercells'),td.e-monthcells:not('.e-othermonths'),td.e-agendacells", $.proxy(this._onCellMouseOver, this));
            this._on(this.element, "click", ".e-workcells,.e-alldaycells,.e-alldayappointment,.e-monthcells:not('.e-othermonths'),.e-agendacells", $.proxy(this._cellSelection, this));
            if (!this._mediaQuery && !ej.isTouchDevice()) {
                this._on(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells:not('.e-othermonths'),td.e-alldaycells", $.proxy(this._mouseButtonClick, this));
                this._on(this.element, "keydown click", "td.e-workcells,td.e-monthcells:not('.e-othermonths'),td.e-alldaycells", $.proxy(this._shiftSelection, this));
            }
            this._on(this.element, (ej.isMobile()) ? "click" : (ej.isTouchDevice() && ($.isFunction($.fn.tap) || $.isFunction($.fn.doubletap))) ? "doubletap" : "dblclick", ".e-workcells:not('.e-resourceheadercells'),.e-alldaycells,.e-alldayappointment,.e-monthcells:not('.e-othermonths'),.e-agendacells.e-eventcolumn,.e-agendacells.e-timecolumn", $.proxy(this._appointmentWindow, this));
            (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
            (ej.isTouchDevice()) && this._on(this.element, ($.isFunction($.fn.tap)) ? "tap" : "doubletap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
            this._on(this.element, "mouseover", ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment", $.proxy(this._onAppointMouseOver, this));
            this._on(this.element, "mouseout", ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment", $.proxy(this._onAppointMouseOver, this));
            this._on(this.element, "click", ".e-appup,.e-appdown", $.proxy(this._renderAppPosition, this));
            (this._mediaQuery || this.element.width() < 600) && this._on(this.element, "click", "#" + this._id + "navDrawerIcon", $.proxy(this._drawerOpen, this));
            if (this.model.allowKeyboardNavigation) {
                this._on(this.element, "keydown", $.proxy(this._onKeyDown, this));
                this._on($(this.element), "keydown", $.proxy(this._documentOnKeyDown, this));
            }
            if (this.model.orientation == "horizontal")
                this._on(this.element, "click", ".e-parentnodecategory", $.proxy(this._onResourceClick, this));
            if (this._mediaQuery || ej.isTouchDevice())
                this._on(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab,.e-agendacellstab", $.proxy(this._touchSchedule, this));
            if (this.model.enableResize)
                !ej.isTouchDevice() ? this._on($(window), "resize", $.proxy(this._onScheduleResize, this)) : this._on($(window), "orientationchange", $.proxy(this._onScheduleResize, this));
            this._on(this.element, "click", ".e-schedulemouseclose,.e-deleteapp", $.proxy(this._deleteAppoint, this));
            this._on(this.element, "click", ".e-editapp", $.proxy(this._appointmentWindow, this));
        },

        _drawerOpen: function () {
            this._scheduleDrawer.ejNavigationDrawer("open");
        },

        _mouseButtonClick: function (e) {
            if (!(e.altKey) && !(e.shiftKey) && !(e.ctrlKey) && (e.which != 3)) {
                if ((e.which == 1 || e.type == "touchstart") && !$(e.target).hasClass("e-resourceheadercells") && !$(e.target).hasClass("e-othermonths")) {
                    var oEl = e.target || document.activeElement || e.srcElement;
                    var oRowCell = this.element.find('div.e-draggableworkarea tr'), proxy = this;
                    ($(oEl).hasClass("e-alldaycells")) && (oRowCell = this.element.find(".e-alldaycells").parent());
                    if ($(oEl).hasClass("e-selectedAppointment")) {
                        this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                        $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    this._currentRowIndex = $(oEl).parent()[0].rowIndex;
                    this._currentColIndex = $(oEl)[0].cellIndex;
                    var renderDate = (proxy.model.orientation == "horizontal" && proxy.currentView() == "month") ? proxy.monthDays : proxy.model.orientation == "vertical" ? proxy.dateRender : proxy._dateRender;
                    var cellindexs = $(e.target).hasClass("e-workcells") || $(e.target).hasClass("e-alldaycells") ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
                    ((this.model.orientation == "horizontal") && (cellindexs = proxy.currentView() !== "month" ? Math.floor(cellindexs / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : cellindexs));
                    var curDates = new Date(renderDate[cellindexs]);
                    if ((curDates >= this.model.minDate) && (curDates <= this.model.maxDate)) {
                        if ($(oEl).hasClass('e-workcells') || $(oEl).hasClass('e-monthcells') || $(oEl).hasClass('e-alldaycells')) {
                            oRowCell.on(ej.eventType.mouseMove, function (e) {
                                if (!ej.isNullOrUndefined(proxy._quickAppointWindow) && proxy.model.showQuickWindow) {
                                    proxy._quickAppointWindow.ejDialog("close");
                                    proxy._quickAppDetailsWindow.ejDialog("close");
                                }
                                e.preventDefault();
                                var currTarget = e.target;
                                if (e.type == 'touchmove') {
                                    var coor = e.originalEvent.changedTouches[0];
                                    currTarget = document.elementFromPoint(coor.pageX, coor.pageY);
                                }
                                $(currTarget).hasClass('e-selectedCell') && proxy.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                                proxy._mouseSelection(e, proxy, oEl, currTarget);
                                proxy._moveScrollContent(oEl, proxy);
                            });
                            oRowCell.on(ej.eventType.mouseUp, function (e) {
                                oRowCell.off(ej.eventType.mouseMove);
                            });
                            this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
                            this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                        }
                    }
                }
            }
        },
        _mouseSelection: function (e, proxy, oE1, currTarget) {
            var oRowCell = proxy.element.find('div.e-draggableworkarea tr');
            var sourceRowIndex = $(oE1).parent().index();
            var sourceColumnIndex = $(oE1).index();
            var rowcount = oRowCell.length - 1;
            var i, j, k;
            var currentRowIndex = $(currTarget).parent().index();
            var currentColumnIndex = $(currTarget).index();
            var ad = proxy.element.find(".e-alldaycells").parent();
            var alldaytr = proxy.model.showAllDayRow;
            if (this._resWorkWeek) {
                var resmincolindex = 0;
                for (var z = 0; z < this.res1.length; z++) {
                    var resCusDays = !ej.isNullOrUndefined(this.res1[z][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? this.res1[z][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : this.model.workWeek.length;
                    if (currentColumnIndex <= (resmincolindex + (resCusDays - 1))) {
                        var resmaxcolindex = resmincolindex + resCusDays;
                        break;
                    }
                    else
                        resmincolindex += this.res1[z][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                }
            }
            else {
                var viewCount = proxy.model.orientation == "horizontal" ? oRowCell[0].cells.length : ((proxy.currentView() == "month" || proxy._isCustomMonthView()) ? (oRowCell[0].cells.length / proxy.res1.length) : proxy._dateRender.length);
                var resIndex = Math.floor($(currTarget).index() / viewCount);
                var resmaxcolindex = (viewCount * (resIndex + 1));
                var resmincolindex = (viewCount * resIndex);
            }
            if ($(currTarget).hasClass('e-workcells')) {
                if (proxy.model.orientation == "vertical") {
                    if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                        if (sourceColumnIndex == currentColumnIndex) {
                            if (currentRowIndex > sourceRowIndex) {
                                for (k = parseInt(sourceRowIndex) ; k <= currentRowIndex; k++)
                                    $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            }
                            else if (currentRowIndex < sourceRowIndex) {
                                for (k = parseInt(sourceRowIndex) ; k >= currentRowIndex; k--)
                                    $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            }
                            else
                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex > sourceColumnIndex) {
                            var difference = currentColumnIndex - sourceColumnIndex;
                            for (i = parseInt(sourceRowIndex) ; i <= rowcount; i++)
                                $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[sourceColumnIndex]]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[currentColumnIndex]]).addClass("e-selectedCell");
                            if (difference > 1) {
                                for (k = 1; k <= difference - 1; k++) {
                                    for (var m = 0; m <= rowcount; m++)
                                        $(oRowCell[m].cells[currentColumnIndex - k]).addClass("e-selectedCell");
                                    alldaytr && $(ad[0].cells[[currentColumnIndex - k]]).addClass("e-selectedCell");
                                }
                            }
                            for (j = 0; j <= currentRowIndex; j++)
                                $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex < sourceColumnIndex) {
                            var difference = sourceColumnIndex - currentColumnIndex;
                            for (i = parseInt(sourceRowIndex) ; i >= 0 ; i--)
                                $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[sourceColumnIndex]]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[currentColumnIndex]]).addClass("e-selectedCell");
                            if (difference > 1) {
                                for (k = 1; k <= difference - 1; k++) {
                                    for (var m = 0; m <= rowcount; m++)
                                        $(oRowCell[m].cells[[currentColumnIndex + k]]).addClass("e-selectedCell");
                                    alldaytr && $(ad[0].cells[[currentColumnIndex + k]]).addClass("e-selectedCell");
                                }
                            }
                            for (j = parseInt(currentRowIndex) ; j <= rowcount; j++)
                                $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                        }
                        proxy._currentRowIndex = currentRowIndex;
                        proxy._currentColIndex = currentColumnIndex;
                        $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else { return false; }
                }
                else {
                    if (sourceRowIndex == currentRowIndex && sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                        if (currentColumnIndex > sourceColumnIndex) {
                            for (j = sourceColumnIndex ; j <= currentColumnIndex; j++)
                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        else if (currentColumnIndex <= sourceColumnIndex) {
                            for (j = sourceColumnIndex ; j >= currentColumnIndex; j--)
                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                    else { return false; }
                }
            }
            else if ($(currTarget).hasClass('e-alldaycells')) {
                if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                    if (currentColumnIndex < sourceColumnIndex) {
                        for (k = sourceColumnIndex; k >= currentColumnIndex; k--)
                            $(ad[0].cells[k]).addClass("e-selectedCell");
                    }
                    else if (currentColumnIndex > sourceColumnIndex) {
                        for (k = sourceColumnIndex; k <= currentColumnIndex; k++)
                            $(ad[0].cells[k]).addClass("e-selectedCell");
                    }
                    proxy._currentRowIndex = 0;
                    proxy._currentColIndex = currentColumnIndex;
                    $(ad[0].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else { return false; }
            }
            else if ($(currTarget).hasClass('e-monthcells')) {
                if ($(currTarget).hasClass('e-othermonths')) return false;
                if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                    if (currentRowIndex == sourceRowIndex) {
                        if (currentColumnIndex < sourceColumnIndex) {
                            for (k = sourceColumnIndex; k >= currentColumnIndex; k--)
                                $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex > sourceColumnIndex) {
                            for (k = sourceColumnIndex; k <= currentColumnIndex; k++)
                                $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex == sourceColumnIndex)
                            $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                    }
                    else if (currentRowIndex > sourceRowIndex) {
                        var difference = (currentRowIndex - sourceRowIndex);
                        for (i = sourceColumnIndex; i < resmaxcolindex; i++)
                            $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                        if (difference > 1) {
                            for (k = 1; k <= difference - 1; k++) {
                                for (i = resmincolindex ; i < resmaxcolindex; i++)
                                    $(oRowCell[sourceRowIndex + k].cells[i]).addClass("e-selectedCell");
                            }
                        }
                        for (j = resmincolindex; j <= currentColumnIndex; j++)
                            $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                    }
                    else if (currentRowIndex < sourceRowIndex) {
                        var difference = (sourceRowIndex - currentRowIndex);
                        for (i = sourceColumnIndex; i >= resmincolindex; i--)
                            $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                        if (difference > 1) {
                            for (k = 1; k <= difference - 1; k++) {
                                for (i = resmincolindex; i < resmaxcolindex; i++)
                                    $(oRowCell[sourceRowIndex - k].cells[i]).addClass("e-selectedCell");
                            }
                        }
                        for (j = resmaxcolindex - 1; j >= currentColumnIndex; j--)
                            $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                    }
                    proxy._currentRowIndex = currentRowIndex;
                    proxy._currentColIndex = currentColumnIndex;
                    $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else { return false; }
            }
        },
        _shiftSelection: function (e) {
            if (e.shiftKey == true && e.which == 1 && !$(e.target).hasClass("e-resourceheadercells")) {
                var oE1 = this._focused, proxy = this, currTarget = e.target;
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
                this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                var renderDate = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
                var cellindex = ($(e.target).hasClass("e-workcells") || $(e.target).hasClass("e-alldaycells")) ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
                ((this.model.orientation == "horizontal") && (cellindex = this.currentView() !== "month" ? Math.floor(cellindex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : cellindex));
                var curDate = new Date(renderDate[cellindex]);
                if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate))
                    this._mouseSelection(e, proxy, oE1, currTarget);
            }
        },
        _moveScrollContent: function (oEl, proxy) {
            if (proxy.model.orientation === "horizontal") {
                var leftValue = proxy.element.find(".e-draggableworkarea").scrollLeft();
                if (proxy.model.enableRTL) {
                    if (proxy._browserInfo.name == "mozilla")
                        leftValue = leftValue > 0 ? leftValue : (leftValue * -1);
                    else if (proxy._browserInfo.name == "chrome" || proxy._browserInfo.name == "webkit")
                        leftValue = proxy.element.find(".e-workcells")[0].offsetLeft + proxy.element.find(".e-workcells").width() - proxy.element.find(".e-draggableworkarea").scrollLeft() - proxy.element.find(".e-draggableworkarea").width();
                    else
                        leftValue = Math.abs(leftValue);
                }
                else
                    leftValue = (-leftValue);
                proxy.currentView() != "month" ? $(proxy.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", leftValue + "px") : proxy.element.find(".e-headerdays").css("left", leftValue + "px");
                if (proxy.currentView() !== "day" && proxy.currentView() !== "month" && !(proxy.currentView() == "customview" && proxy._dateRender.length > 7) && proxy.model.timeScale.enable) {
                    var currentDateIndex = $(proxy.element.find(".e-headercells").find(".e-activeview").parent()).index();
                    var index = Math.floor((Math.abs(leftValue) / (proxy.element.find(".e-workcells").outerWidth())) / ((proxy.model.endHour - proxy.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    if (currentDateIndex !== index)
                        proxy.element.find(".e-headercells").children().removeClass("e-activeview");
                    $(proxy.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                }
            }
            else
                if (!$(oEl).hasClass("e-monthcells"))
                    proxy.element.find(".e-scrolltimecells").css("top", (-proxy.element.find('.e-draggableworkarea').scrollTop()) + "px");
        },

        _onScheduleMouseDown: function (e) {
            var _targ = $(e.target);
            var appointdiv = _targ.hasClass("e-appointment,e-alldayappointment,e-monthappointment") ? _targ : _targ.parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            if (!_targ.hasClass("e-workcells") && !_targ.hasClass("e-commonviewbutton") && !appointdiv.hasClass("e-appointment") && !appointdiv.hasClass("e-alldayappointment") && !appointdiv.hasClass("e-monthappointment") && !_targ.hasClass("e-alldaycells") && !_targ.hasClass("e-monthcells") && !(_targ).parents(".e-scheduledialog").hasClass("e-scheduledialog")) {
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                this.element.find(".e-workcells").removeClass("e-mousehover");
                (_targ.closest("#" + this._id).length > 0) && this._scrollerPosition();
            }
        },

        _onCellMouseOver: function (e) {
            if ($(e.target).closest(".e-appointment,.e-blocktimeappointment,.e-alldayappointment,.e-monthappointment").length > 0) return false;
            if (this.currentView() == "agenda") {
                if (this._mediaQuery == true) return false;
                var element = $(e.currentTarget);
                if (e.type === "mouseover") {
                    this.element.find(".e-mousehover").removeClass("e-mousehover");
                    if (element.hasClass("e-agendacells")) {
                        element.parent().find(".e-timecolumn,.e-eventcolumn").addClass("e-mousehover");
                        element.parent().find(".e-editapp").parent().show();
                    }
                }
                else if (e.type === "mouseout") {
                    if (element.hasClass("e-agendacells")) {
                        element.parent().find(".e-timecolumn,.e-eventcolumn").removeClass("e-mousehover");
                        element.parent().find(".e-editapp").parent().hide();
                    }
                }
            }
            else {
                var element = $(e.currentTarget);
                var index = $(e.target).hasClass("e-workcells") ? $(e.target).index() : $(e.target).hasClass("e-alldaycells") ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
                if (this.model.orientation == "horizontal") {
                    index = this.currentView() !== "month" ? Math.floor(index / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : index;
                }
                var renderDate = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
                var curDate = new Date(renderDate[index]);
                this._slotByElement($(e.target), "cellHover");
                var event = { cellIndex: index, startTime: new Date(this.cellHoverStartTime), endTime: new Date(this.cellHoverEndTime), target: e, resources: (!ej.isNullOrUndefined(this.model.cellHover) && (this._tempResource.length != 0)) ? this._getResourceValue(element, index) : null };
                if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
                    if (e.type === "mouseover") {
                        if (this._trigger("cellHover", event)) return false;
                        this.element.find(".e-mousehover").removeClass("e-mousehover");
                        if ((element.hasClass("e-workcells") || element.hasClass("e-monthcells")) && !element.hasClass("e-resourceheadercells"))
                            element.addClass("e-mousehover");
                    }
                    else if (e.type === "mouseout") {
                        if (element.hasClass("e-workcells") || element.hasClass("e-monthcells"))
                            element.removeClass("e-mousehover");
                    }
                } else
                    return false;
            }
        },

        _getAppDetails: function (e) {
            var _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") || _target.hasClass("e-agendaappointment") ? _target : _target.parents(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment");
            if (this.currentView() == "agenda" && _target.hasClass("e-eventcolumn"))
                appoint = _target.find(".e-agendaappointment");
            appId = appoint.attr('guid');
            if (ej.isNullOrUndefined(appId)) return false;
            var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appId));
            if (!tempApp[0][this._appointmentSettings["recurrence"]]) {
                var applist = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appId))[0];
            }
            else {
                var templist = $.extend(true, [], tempApp);
                templist[0][this._appointmentSettings["endTime"]] = templist[templist.length - 1][this._appointmentSettings["endTime"]];
                var applist = (tempApp[0][this._appointmentSettings["recurrence"]] && (tempApp[0][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") == 1)) ? this._getAppointmentByParentId(appId) : templist[0];
            }
            return applist;
        },

        _onAppointMouseOver: function (e) {
            if (!this.model.readOnly) {
                if (!ej.isNullOrUndefined(this.model.appointmentHover)) {
                    if (e.type != "mouseover") return false;
                    var data = { appointment: this._getAppDetails(e) };
                    if (this._trigger("appointmentHover", data))
                        return false;
                }
                if (this.currentView() == "agenda") {
                    if (this._mediaQuery == true) return false;
                    var element = $(e.currentTarget);
                    if (e.type === "mouseover") {
                        this.element.find(".e-mousehover").removeClass("e-mousehover");
                        if (element.hasClass("e-agendaappointment")) {
                            element.addClass("e-mousehover");
                            element.find(".e-editapp").parent().show();
                        }
                    }
                    else if (e.type === "mouseout") {
                        if (element.hasClass("e-agendaappointment")) {
                            element.removeClass("e-mousehover");
                            element.find(".e-editapp").parent().hide();
                        }
                    }
                }
                else {
                    var appointdiv = $(e.target).hasClass("e-appointment,e-alldayappointment,e-monthappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
                    if (appointdiv.hasClass("e-appointment") && this.model.orientation == "vertical") {
                        if (e.type === "mouseover") {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-bottomhandle,.e-tophandle").addClass("e-icon e-nsexpand");
                                appointdiv.find(".e-bottomhandle").addClass("e-appointresizer-bottom");
                                appointdiv.find(".e-tophandle").addClass("e-appointresizer-top");
                            }
                            appointdiv.find(".e-schedulemouseclose").css("display", "block");
                        }
                        else if (e.type === "mouseout") {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-bottomhandle,.e-tophandle").removeClass("e-icon e-nsexpand");
                            }
                            appointdiv.find(".e-schedulemouseclose").css("display", "none");
                        }

                    }
                    else if (((appointdiv.hasClass("e-alldayappointment") || appointdiv.hasClass("e-monthappointment")) && this.model.orientation == "vertical") || (this.model.orientation == "horizontal")) {
                        if (e.type === "mouseover") {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-lefthandle,.e-righthandle").addClass("e-icon e-ewexpand");
                                appointdiv.find(".e-lefthandle").addClass("e-appointresizer-left");
                                appointdiv.find(".e-righthandle").addClass("e-appointresizer-right");
                            }
                            appointdiv.find(".e-schedulemouseclose").css("display", "block");
                        }
                        else if (e.type === "mouseout") {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-lefthandle,.e-righthandle").removeClass("e-icon e-ewexpand");
                            }
                            appointdiv.find(".e-schedulemouseclose").css("display", "none");
                        }
                    }
                }
            }
        },

        _quickWindowPosition: function (x, y, targetEle, quickWindow) {
            var quickWindowTable = quickWindow.find(".e-tableAppoint");
            var wrapperWidth = $("#" + quickWindow.prop("id") + "_wrapper").width();
            var left = this.element.offset().left, right = this.element.offset().left + this.element.width(), top = this.element.offset().top, bottom = this.element.offset().top + this.element.height();
            var widthDiff = targetEle.width() / 2;
            var transform = "rotate(0deg)", topposflag = true, leftpos = "40%";
            if (x > left && x + wrapperWidth > right && y > top) {
                x = right - wrapperWidth - 5;
                leftpos = targetEle.offset().left - x + widthDiff;
            }
            else if (x < left && x + wrapperWidth < right && y > top) {
                x = left + 5;
                leftpos = targetEle.offset().left - x + widthDiff;
            }
            else if (y < top) {
                topposflag = false, transform = "rotate(180deg)";
                if (x < left) {
                    x = left + 5;
                    leftpos = targetEle.offset().left - x + widthDiff;
                }
                else if ((x + wrapperWidth) > right) {
                    x = right - wrapperWidth - 5;
                    leftpos = targetEle.offset().left - x + widthDiff;
                }
                var heightDiff = (quickWindow.prop("id") == this._id + "AppDetailsWindow") ? targetEle.height() : (this.model.orientation == "horizontal" ? targetEle.height() / 2 : targetEle.height() - 4);
                y = targetEle.offset().top + 10 + heightDiff;
                if (y < top || y > bottom - $("#" + quickWindow.prop("id") + "_wrapper").height()) {
                    y = top + 4; topposflag = true, transform = "rotate(0deg)";
                }
            }
            topposflag ? quickWindowTable.removeClass("e-tablePosition") : quickWindowTable.addClass("e-tablePosition");
            quickWindow.find(".e-quickarrow").css("transform", transform).css("top", topposflag ? quickWindowTable.outerHeight() + 1 : 0).css("left", leftpos);
            topposflag ? quickWindow.addClass("e-quickwinarrowbottom").removeClass("e-quickwinarrowtop") : quickWindow.addClass("e-quickwinarrowtop").removeClass("e-quickwinarrowbottom");
            return { X: x, Y: y };
        },

        _scrollerPosition: function () {
            if (this.currentView() != "agenda" && this.model.timeScale.enable && (this.element.find(".e-vscroll").length > 0 || this.element.find(".e-hscroll").length > 0)) {
                var scrolObj = this.element.find("#" + this._id + "_scroller").ejScroller("instance");
                if (this.model.orientation == "vertical") {
                    if (scrolObj.isVScroll()) {
                        var scrollValue = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                        this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: scrollValue });
                    }
                    if (scrolObj.isHScroll()) {
                        var scrollValue = this.element.find(".e-draggableworkarea").offset().left - this.element.find(".e-workcellstab").offset().left;
                        this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: Math.abs(scrollValue) });
                    }
                }
                else {
                    if (this._grouping.length > 0) {
                        if (scrolObj.isVScroll()) {
                            if (this.element.find(".e-resourceheadertable").offset().top != this.element.find(".e-workcellstab").offset().top) {
                                var scrollValue = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                                this._isQuickDialogOpened = true;
                                this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: scrollValue });
                            }
                        }
                        if (scrolObj.isHScroll()) {
                            var leftValue = (this.currentView() == "month" || this._isCustomMonthView()) ? this.element.find(".e-headerdays").offset().left : this.element.find(".e-horizontaltabletimecell").closest("tr").offset().left;
                            if (this.element.find(".e-workcellstab").offset().left != leftValue) {
                                var scrollValue = this.element.find(".e-draggableworkarea").offset().left - this.element.find(".e-workcellstab").offset().left;
                                this._isQuickDialogOpened = true;
                                this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: Math.abs(scrollValue) });
                            }
                        }
                    }
                }
            }
        },

        _cellSelection: function (e) {
            if (e.shiftKey) return false;
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            this.element.find("e.workcells,e.alldaycells,.e-monthcells,.e-agendacells").removeClass("e-mousehover");
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            var _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            if (_target.hasClass("e-blocktimeappointment") || _target.closest(".e-blocktimeappointment").length > 0) return false;
            if (this.currentView() != "agenda" && !_target.hasClass("e-schedulemouseclose") && (!ej.isNullOrUndefined(this.model.workCellsTemplateId) || !ej.isNullOrUndefined(this.model.allDayCellsTemplateId))) {
                _target = (_target.closest(".e-appointment,.e-monthappointment").length > 0) ? _target.closest(".e-appointment,.e-monthappointment") : (_target.hasClass("e-apptime") || _target.hasClass("e-apptext") || _target.hasClass("e-appointinnertext") || _target.hasClass("e-schedulemouseclose") || _target.hasClass("e-monthheader")) ? $(e.target) : _target.closest(".e-workcells, .e-alldaycells, .e-monthcells");
            }
            _target.hasClass("e-appointwrapper") || _target.hasClass("e-textwrapper") && (_target = $(_target).parent());
            if (!ej.isNullOrUndefined(e.type) && e.type == "beforeOpen") {
                var selectedCells = this.element.find("td.e-selectedCell");
                if ((selectedCells.length > 0) && !(_target.hasClass("e-selectedCell")))
                    this.element.find(".e-workcells,.e-alldaycells,.e-monthcells,.e-agendacells").removeClass("e-selectedCell");
            }
            else
                this.element.find(".e-workcells,.e-alldaycells,.e-monthcells,.e-agendacells").removeClass("e-selectedCell");
            if (this.model.showQuickWindow && ej.isNullOrUndefined(this._quickAppointWindow)) this._renderQuickWindow();
            if (this.currentView() != "agenda") {
                if ((_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells")) && !_target.hasClass("e-resourceheadercells")) {
                    this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
                    this._slotByElement(_target, "cellClick");
                    if ((this.model.minDate > this.curDate || this.model.maxDate < this.curDate)) { return false; }
                    var _quickString = this._dayFullNames[new Date(this.curDate).getDay()] + ", " + ej.format(new Date(this.curDate), "MMMM", this.model.locale) + " " + new Date(this.curDate).getDate() + ", " + ej.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale) + " - " + ej.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale);
                    var event = { cellIndex: this._cellIndex, startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, target: e, resources: ((this.model.cellClick != null || !ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("cellClick") != -1)) && (this._tempResource.length != 0)) ? this._getResourceValue(_target) : null, quickString: _quickString };
                    if (this._trigger("cellClick", event)) return false;
                    _target.addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._scrollerPosition();
                    if (this.model.showQuickWindow) {
                        this._quickAppointWindow.find("#" + this._id + "_quickAppwindow").css("display", "block");
                        this._quickAppointWindow.find('.e-quickstartend').html(event.quickString);
                        var topElmt = $(e).hasClass("e-workcells") || $(e).hasClass("e-alldaycells") || $(e).hasClass("e-monthcells") ? $(e) : $(e.target);
                        (e.type != "beforeOpen" && !this.model.readOnly) ? this._quickAppointWindow.ejDialog("open") : "";
                        this._quickAppointWindow.find('.subject').val("");
                        var x = topElmt.offset().left - ((this._quickAppointWindow.width() - topElmt.width()) / 2) + 10;
                        var y = topElmt.offset().top - this._quickAppointWindow.outerHeight() + 4;
                        var xy = this._quickWindowPosition(x, y, topElmt, this._quickAppointWindow);
                        this._quickAppointWindow.ejDialog({ position: { X: xy["X"], Y: xy["Y"] } });
                        if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                            this._getResourceDetails(_target, this._cellIndex);
                    }
                    this._focused = $(":focus");
                    this.model.showQuickWindow && this._quickAppointWindow.find('.subject').focus();
                    this._cellClick = true;
                    if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog({ title: this._getLocalizedLabels("CreateAppointmentTitle") });
                }
                else {
                    if (!_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-appsoverflow") && !_target.hasClass("e-monthheader") && !_target.hasClass("e-categorybar")) {
                        this._cellClick = false;
                        if (!ej.isNullOrUndefined(this._quickAppDetailsWindow)) this._quickAppDetailsWindow.find("" + "#" + this._id + "_quickAppDetailswindow").css("display", "block");
                        if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._quickAppointWindow.ejDialog("close");
                        var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") ? _target : _target.closest(".e-appointment,.e-alldayappointment,.e-monthappointment");
                        this._appUid = appoint.attr('guid');
                        if (_target.hasClass("e-schedulemouseclose")) return false;
                        this._processed = this._sortAppById(this._processed);
                        var splitObj = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        for (i = 0; i < splitObj.length; i++) {
                            var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, splitObj[i]["Guid"]));
                            break;
                        }
                        for (i = 0; i < templist.length; i++) {
                            var eleFind = this.element.find('[guid=' + templist[i]["Guid"] + ']');
                            eleFind.addClass("e-selectedAppointment");
                        }
                        if (this._mediaQuery)
                            this._mAppId = this._appUid;
                        var templist1 = this._sortAppById(templist);
                        var temp = templist1[0][this._appointmentSettings["recurrence"]] ? templist1[0] : this._getAppointmentByParentId(this._appUid);
                        var diffTime = new Date().getTime() - (temp[this._appointmentSettings["startTime"]].getTime());
                        var diffMinute = 60 * 1000;
                        var diffHour = 60 * diffMinute;
                        var diffDays = 24 * diffHour;
                        var result = Math.abs(new Date() - temp[this._appointmentSettings["startTime"]]);
                        var h = Math.floor(result / 1000 / 60 / 60); h = (h <= 9 ? '0' + h : h);
                        var m = new Date(result).getUTCMinutes(); m = (m <= 9 ? '0' + m : m);
                        var dueIn = Math.ceil(diffTime / diffMinute - 1) < 0 && h < 24 ? this._getLocalizedLabels("EventBeginsin") + " " + h + " " + this._getLocalizedLabels("Hours") + " " + m + " " + this._getLocalizedLabels("Minutes") : Math.ceil(diffTime / diffMinute - 1) < 0 && h >= 24 ? this._getLocalizedLabels("EventBeginsin") + " " + Math.abs(Math.ceil(diffTime / diffDays)) + " " + this._getLocalizedLabels("Days") : this._getLocalizedLabels("Overdue");
                        var data = { appointment: templist[0] };
                        if (this._trigger("appointmentClick", data)) {
                            $(".e-selectedAppointment").css({ 'border': "none" });
                            return false;
                        }
                        if (this.model.showQuickWindow) {
                            this._quickAppDetailsWindow && this._quickAppDetailsWindow.find('.e-quicksubject').html(temp[this._appointmentSettings["subject"]]).attr("title", temp[this._appointmentSettings["subject"]]);
                            var startTimeDisp = this._timeMode == "12" ? ej.format(templist[0][this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(templist[0][this._appointmentSettings["startTime"]], "HH:mm", this.model.locale);
                            var endTimeDisp = this._timeMode == "12" ? ej.format(templist[templist.length - 1][this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(templist[templist.length - 1][this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                            this._quickAppDetailsWindow.find('.e-rightfields').html(dueIn);
                            var days = Math.ceil((templist[0][this._appointmentSettings["endTime"]] - templist[0][this._appointmentSettings["startTime"]]) / 3600000) / 24;
                            if ((templist.length > 1) || (this.model.orientation == "horizontal" && this.currentView() == "month" && days > 1) || (templist[0][this._appointmentSettings["startTime"]].getDay() != templist[templist.length - 1][this._appointmentSettings["endTime"]].getDay()))
                                var dateShow = this._dayFullNames[templist[0][this._appointmentSettings["startTime"]].getDay()] + ", " + ej.format(templist[0][this._appointmentSettings["startTime"]], "MMMM", this.model.locale) + " " + templist[0][this._appointmentSettings["startTime"]].getDate() + " - " + startTimeDisp + " " + "to" + " " + this._dayFullNames[templist[templist.length - 1][this._appointmentSettings["endTime"]].getDay()] + ", " + ej.format(templist[templist.length - 1][this._appointmentSettings["endTime"]], "MMMM", this.model.locale) + " " + templist[templist.length - 1][this._appointmentSettings["endTime"]].getDate() + " - " + endTimeDisp;
                            else
                                var dateShow = this._dayFullNames[templist[0][this._appointmentSettings["startTime"]].getDay()] + ", " + ej.format(templist[0][this._appointmentSettings["startTime"]], "MMMM", this.model.locale) + " " + templist[0][this._appointmentSettings["startTime"]].getDate() + ", " + startTimeDisp + " " + "-" + " " + endTimeDisp;
                            this._quickAppDetailsWindow.find('.e-quickstartendtime').html(dateShow);
                            if (temp[this._appointmentSettings["recurrence"]] == 1)
                                this._quickAppDetailsWindow.find('.e-editseries').removeClass("e-disable");
                            else
                                this._quickAppDetailsWindow.find('.e-editseries').addClass("e-disable");
                            (e.type != "beforeOpen") ? this._quickAppDetailsWindow.ejDialog("open") : "";
                            (this.model.readOnly) ? this._quickAppDetailsWindow.find(".e-scheduledelete").addClass("e-disable") : this._quickAppDetailsWindow.find(".e-scheduledelete").removeClass("e-disable");
                            if ($(appoint).width() > this.element.width())
                                var left = ($(appoint).offset().left > this.element.offset().left) ? $(appoint).offset().left : (this.element.find('.e-draggableworkarea').scrollLeft() > $(appoint).width()) ? this.element.offset().left : this.element.width() / 2 - 4;
                            else
                                var left = $(appoint).offset().left - ((this._quickAppDetailsWindow.width() - $(appoint).width()) / 2 - 4);
                            var top = $(appoint).offset().top - this._quickAppDetailsWindow.outerHeight() + 4;
                            var xy = this._quickWindowPosition(left, top, appoint, this._quickAppDetailsWindow);
                            this._quickAppDetailsWindow.ejDialog({ position: { X: xy["X"], Y: xy["Y"] } });
                            this._quickAppDetailsWindow.focus();
                        }
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog({ title: this._getLocalizedLabels("Editevent") });
                    }
                }
                if (!$(_target).hasClass("e-monthcells"))
                    this.element.find(".e-scrolltimecells").css("top", (-this.element.find('.e-draggableworkarea').scrollTop()) + "px");
            } else {
                this._cellIndex = 0;
                this.cur_StartTime = new Date(new Date(this.currentDate()).setHours(0, 0, 0));
                this.cur_EndTime = new Date(new Date(this.currentDate()).setHours(23, 59, 59));
                $(_target).parentsUntil('.e-agendacellstab tbody').find(".e-eventcolumn,.e-timecolumn").addClass("e-selectedCell").attr("tabIndex", 0).focus();
                var appoint = _target.hasClass("e-agendaappointment") ? _target : this.element.find(".e-selectedCell").parent().find(".e-agendaappointment");
                this._appUid = appoint.attr('guid');
                if (this._mediaQuery)
                    this._mAppId = this._appUid;
                if (_target.hasClass("e-editapp") || _target.hasClass("e-deleteapp")) return false;
                var appoint = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                if (this._trigger("appointmentClick", { appointment: appoint[0] })) {
                    return false;
                }
                this._cellClick = false;
            }
        },

        _getDateByElement: function (_target) {
            var tagIndex = this.model.showWeekend ? 7 : this.model.workWeek.length;
            if (this.model.timeScale.enable)
                this._cellIndex = _target.hasClass("e-workcells") ? _target.index() : _target.hasClass("e-alldaycells") ? _target.index() : this._isCustomMonthView() && this._oneWeek ? _target.index() : tagIndex - ((parseInt(_target.index() / tagIndex) + 1) * tagIndex - _target.index()) + (_target.parent().index() * tagIndex);
            else
                this._cellIndex = this.model.orientation == "vertical" && this.currentView() == "month" || (this.currentView() == "customview" && this._dateRender.length >= 7) ? tagIndex - ((parseInt(_target.index() / tagIndex) + 1) * tagIndex - _target.index()) + (_target.parent().index() * tagIndex) : _target.index();
            if (this.model.orientation == "horizontal") {
                this._cellIndex = this.model.timeScale.enable ? this.currentView() !== "month" && !(this._isCustomMonthView()) ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : this._cellIndex : _target.index();
                this._workCellIndex = _target.parent().index();
            }
            var renderDate = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" || this.currentView() == "customview" && this._dateRender.length <= 7) ? (this._resWorkWeek) ? this._dateRender : this.dateRender : this._dateRender;
            renderDate = this.model.orientation == "horizontal" && this.currentView() == "customview" && this._dateRender.length <= 7 ? this._dateRender : renderDate;
            this.curDate = new Date(renderDate[this._cellIndex]);
        },

        _slotByElement: function (_target, type) {
            this._getDateByElement(_target);
            var curDate = this.curDate;
            if (_target.hasClass("e-workcells") && (this.model.timeScale.enable) && this.currentView() !== "month" && !(this._isCustomMonthView())) {
                this._calcCurrentTime(curDate, _target, type);
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
            }
            else {
                if (type == "cellHover") {
                    this.cellHoverStartTime = new Date(new Date(curDate).setHours(0, 0, 0));
                    this.cellHoverEndTime = new Date(new Date(curDate).setHours(23, 59, 59));
                }
                else {
                    this.cur_StartTime = new Date(new Date(curDate).setHours(0, 0, 0));
                    this.cur_EndTime = new Date(new Date(curDate).setHours(23, 59, 59));
                    if (_target.hasClass("e-alldaycells")) {
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                    }
                }
            }
        },
        _calcCurrentTime: function (curDate, _target, type) {
            var time = this.model.orientation == "vertical" ? (this.model.startHour * 60) + _target.parent().index() * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) : ((this.model.startHour * 60) + _target.index() * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - (((this.model.endHour - this.model.startHour) * (this.model.timeScale.minorSlotCount)) * this._cellIndex) * (60 / this.model.timeScale.majorSlot) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            time = time * 60 * 1000;
            this._timeScaleMin = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            this._timeScaleMin = this._timeScaleMin * 60 * 1000;
            if (type == "cellHover") {
                this.cellHoverStartTime = new Date(curDate).setMilliseconds(time);
                var min = (parseInt(new Date(this.cellHoverStartTime).getHours()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getHours() && parseInt(new Date(this.cellHoverStartTime).getMinutes()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getMinutes()) ? time + (this._timeScaleMin - 1) : new Date(this.cellHoverStartTime).getMilliseconds() + this._timeScaleMin;
                this.cellHoverEndTime = new Date(new Date(this.cellHoverStartTime).setMilliseconds(min));
                this.cellHoverEndTime = (new Date(this.cellHoverStartTime).setHours(0, 0, 0, 0) < new Date(this.cellHoverEndTime).setHours(0, 0, 0, 0)) ? new Date(new Date(this.cellHoverStartTime).setHours(23, 59, 59)) : this.cellHoverEndTime;
            }
            else {
                this.cur_StartTime = new Date(curDate).setMilliseconds(time);
                var min = (parseInt(new Date(this.cur_StartTime).getHours()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getHours() && parseInt(new Date(this.cur_StartTime).getMinutes()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getMinutes()) ? time + (this._timeScaleMin - 1) : new Date(this.cur_StartTime).getMilliseconds() + this._timeScaleMin;
                this.cur_EndTime = new Date(new Date(this.cur_StartTime).setMilliseconds(min));
                this.cur_EndTime = (new Date(this.cur_StartTime).setHours(0, 0, 0, 0) < new Date(this.cur_EndTime).setHours(0, 0, 0, 0)) ? new Date(new Date(this.cur_StartTime).setHours(23, 59, 59)) : this.cur_EndTime;
            }
        },
        _checkReminders: function (args) {
            this._todayAppointments = [];
            for (var i = 0; i < this._processed.length; i++) {
                if ((new Date(new Date(this._processed[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date().setHours(0, 0, 0, 0)).getTime())) {
                    this._todayAppointments.push(this._processed[i]);
                }
            }
            var proxy = this;
            jQuery.each(this._todayAppointments, function (val, i) {
                if (!ej.isNullOrUndefined(proxy.model.reminderSettings)) {
                    var reminderValue = proxy.model.reminderSettings.alertBefore;
                    var startTime = i[proxy._appointmentSettings["startTime"]];
                    if (reminderValue != -1 && reminderValue != null) {
                        var currTime = new Date().getTime();
                        var difference = (currTime - new Date(startTime).getTime()) / (1000 * 60);
                        if (Math.round(difference) == (reminderValue * -1))
                            proxy._trigger("reminder", { reminderAppointment: i });
                    }
                }
            });
        },

        _showContextMenu: function (flag) {
            var gotoFlag = false, categorizeFlag = false, cellCollection = this.model.contextMenuSettings.menuItems.cells;
            if (flag) {
                this._contextMenu = ej.buildTag("ul#" + this._id + "contextMenu");
                this.element.append(this._contextMenu);
                this._contextMenu.ejMenu({
                    fields: { id: "id", text: "text", parentId: "parentId" },
                    menuType: ej.MenuType.ContextMenu,
                    openOnClick: false,
                    contextMenuTarget: "#" + this._id,
                    width: "auto",
                    click: $.proxy(this._onMenuSelect, this),
                    beforeOpen: $.proxy(this._beforeopen, this)
                });
                if (this.model.categorizeSettings.enable && this.model.contextMenuSettings.menuItems.appointment) {
                    var menuItems = this.model.contextMenuSettings.menuItems.appointment;
                    var dataLength = this.model.categorizeSettings.dataSource.length;
                    for (var i = 0; i < menuItems.length; i++) {
                        if (menuItems[i].id == 'categorize') {
                            var menuId = i;
                            categorizeFlag = true;
                            break;
                        }
                    }
                    if (categorizeFlag) {
                        var deletedItems = new ej.DataManager(this.model.contextMenuSettings.menuItems.appointment).executeLocal(new ej.Query().where("parentId", ej.FilterOperators.equal, "categorize"));
                        new ej.DataManager(this.model.contextMenuSettings.menuItems.appointment).saveChanges({ added: [], changed: [], deleted: deletedItems }, "parentId");
                        for (var i = 0; i < dataLength; i++) {
                            var dataSet = this.model.categorizeSettings;
                            this.model.contextMenuSettings.menuItems.appointment.push({ text: dataSet.dataSource[i][dataSet.text], id: "categorize_" + dataSet.dataSource[i][dataSet.id], fontColor: dataSet.dataSource[i][dataSet.fontColor], color: dataSet.dataSource[i][dataSet.color], parentId: this.model.contextMenuSettings.menuItems.appointment[menuId].id.toString() });
                        }
                    }
                }
                if (this._gotoDate) {
                    if (this.model.contextMenuSettings.enable) {
                        for (var id in cellCollection) {
                            if (cellCollection[id].id == "gotodate") {
                                gotoFlag = true;
                                break;
                            }
                        }
                        if (gotoFlag) {
                            this._renderGotoWindow();
                            this._gotoDate = false;
                        }
                    }
                }
            }
        },

        _beforeopen: function (args) {
            if (this.model.contextMenuSettings.enable) {
                $(document).off(ej.eventType.mouseMove);
                var targetClass = $(args.target).closest(".e-alldayappointment,.e-appointment,.e-monthappointment,.e-workcells,.e-monthcells,.e-alldaycells"), appFlag, appointment = null, event;
                var tempargs = ($(targetClass).parents(".e-draggableworkarea tr").length > 0 && $(targetClass).parentsUntil(".e-draggableworkarea tr").is(".e-agendaappointment,.e-eventcolumn,.e-timecolumn")) || $(targetClass).is(".e-agendaappointment,.e-eventcolumn,.e-timecolumn");
                if (!targetClass.hasClass("e-appointment") && !targetClass.hasClass("e-workcells") && !targetClass.hasClass("e-alldaycells") && !targetClass.hasClass("e-monthcells") && !ej.isNullOrUndefined(this.model.appointmentTemplateId)) {
                    targetClass = $(args.target).offsetParent();
                }
                args.cancel = (targetClass.hasClass("e-alldayappointment") || targetClass.hasClass("e-monthappointment") || targetClass.hasClass("e-appointment") || targetClass.hasClass("e-workcells") || targetClass.hasClass("e-alldaycells") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-monthcells") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext") || tempargs) ? false : true;
                if (args.cancel == true) {
                    var obj = this._contextMenu.data("ejMenu");
                    obj.hide();
                    return false;
                }
                if (this.currentView() == "agenda" && tempargs) {
                    args = $(targetClass).hasClass("e-agendaappointment") ? args : $(targetClass).parents(".e-draggableworkarea tr").find(".e-agendaappointment");
                }
                this._cellSelection(args);
                if (targetClass.hasClass("e-workcells") || targetClass.hasClass("e-alldaycells") || targetClass.hasClass("e-monthcells")) {
                    event = { currentDate: this.curDate, cellIndex: this._cellIndex, events: args, resources: (!ej.isNullOrUndefined(this.model.beforeContextMenuOpen) && (this._tempResource.length != 0)) ? this._getResourceValue(targetClass, this._cellIndex) : null };
                }
                if (targetClass.hasClass("e-alldayappointment") || targetClass.hasClass("e-monthappointment") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext") || targetClass.hasClass("e-appointment")) {
                    appointment = this._getAppDetails(args);
                    event = { appointment: appointment, events: args };
                }
                if (this.currentView() == "agenda") {
                    appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                    event = { appointment: appointment, events: args };
                }
                this._baseTarget = targetClass;
                if (this._trigger("beforeContextMenuOpen", event)) return false;
                var menuObj = this._contextMenu.data("ejMenu");
                appFlag = (targetClass.hasClass("e-alldayappointment") || targetClass.hasClass("e-monthappointment") || targetClass.hasClass("e-appointment") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext") || tempargs) ? false : true;
                (appFlag) ? menuObj.option("fields.dataSource", this.model.contextMenuSettings.menuItems.cells) : menuObj.option("fields.dataSource", this.model.contextMenuSettings.menuItems.appointment);
                if (this.model.readOnly) {
                    menuObj.disableItemByID("new");
                    menuObj.disableItemByID("recurrence");
                    menuObj.disableItemByID("delete");
                    menuObj.disableItemByID("categorize");
                }
                else {
                    menuObj.enableItemByID("new");
                    menuObj.enableItemByID("recurrence");
                    menuObj.enableItemByID("delete");
                    menuObj.enableItemByID("categorize");
                }
                var tds = this.element.find('td.e-selectedCell');
                if (tds.length > 1 && this.currentView() != "agenda")
                    this._multipleCellAppointCreation(args);
                this._target = args;
                if (this.model.showQuickWindow && !ej.isNullOrUndefined(this._quickAppointWindow)) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                if (this.model.categorizeSettings.enable && appFlag == false) {
                    var findDiv = this._contextMenu.find('li#categorize').find('li').children();
                    if (findDiv.find('div').length == 0) {
                        for (var i = 0; i < this.model.categorizeSettings.dataSource.length; i++) {
                            this._contextMenu.find('li#categorize').find('li#categorize_' + this.model.categorizeSettings.dataSource[i][this.model.categorizeSettings["id"]]).children().append('<div><div style="border: 1px solid black;height: 12px;margin-left: 2px;margin-top: 2px;width: 12px;background-color:' + this.model.categorizeSettings.dataSource[i][this.model.categorizeSettings["color"]] + '"></div></div>');
                        }
                    }
                    for (var i = 1; i <= this.model.categorizeSettings.dataSource.length; i++) {
                        if (this._contextMenu.find('li#categorize').find('li#categorize_' + i).children().find('div:first-child.e-categorizeMenuSelected'))
                            this._contextMenu.find('li#categorize').find('li#categorize_' + i).children().find('div:first-child').removeClass('e-categorizeMenuSelected');
                    }
                    var query = new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid);
                    var addItem = ej.DataManager(this._processed).executeLocal(query);
                    if (addItem[0][this._appointmentSettings["categorize"]]) {
                        var categorizeItems = addItem[0][this._appointmentSettings["categorize"]].split(',');
                        if (this.model.categorizeSettings.allowMultiple) {
                            if (categorizeItems[0].length > 0) {
                                for (var i = 0; i < categorizeItems.length; i++) {
                                    this._contextMenu.find('li#categorize').find('li#categorize_' + categorizeItems[i]).children().find('div:first-child').addClass('e-categorizeMenuSelected');
                                }
                            }
                        }
                        else {
                            if (categorizeItems[0].length > 0) {
                                var lastValue = categorizeItems.length - 1;
                                this._contextMenu.find('li#categorize').find('li#categorize_' + categorizeItems[lastValue]).children().find('div:first-child').addClass('e-categorizeMenuSelected');
                            }
                        }
                    }
                }
                else {
                    if (this._contextMenu.find('li#categorize'))
                        this._contextMenu.find('li#categorize').css("display", "none");
                }

            }
            else {
                var obj = this._contextMenu.data("ejMenu");
                obj.hide();
                return false;
            }
        },

        _onMenuSelect: function (args) {
            var id = args.events.ID.split("_"), parentData = "";
            var target = this._baseTarget;
            if ($(target).is(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment") || target.parents(".e-appointment").hasClass("e-appointment") || target.parents(".e-monthappointment").hasClass("e-monthappointment") || target.parents(".e-alldayappointment").hasClass("e-alldayappointment") || this.currentView() == "agenda" && this.element.find(".e-selectedCell").parent().find(".e-agendaappointment")) {
                var appointDetails = ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                parentData = (appointDetails[0][this._appointmentSettings["recurrence"]] == 1 && appointDetails[0][this._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1) ? appointDetails[0] : this._getAppointmentByParentId(this._appUid);
            }
            else {
                parentData = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, resourceInfo: this._getResourceDetails(target) };
            }
            if (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("menuItemClick") != -1))
                args = { ID: args.ID, type: args.type, text: args.text, parentId: args.parentId, parentText: args.parentText };
            if (this._trigger("menuItemClick", { events: args, targetInfo: parentData })) return false;
            var oldIdValue = parentData[this._appointmentSettings["categorize"]];
            switch (id[0]) {
                case "new":
                    this._appointmentWindow(this._target);
                    break;
                case "recurrence":
                    this._appointmentWindow(this._target);
                    this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                    this._repeat(args = { isChecked: true, isInteraction: true });
                    break;
                case "open":
                    this._appointmentWindow(this._target);
                    break;
                case "today":
                    this._navigateClick(this.currentDate(new Date()), "DateNavigation");
                    break;
                case "view":
                    if (!ej.isNullOrUndefined(id[1])) {
                        var newView = id[1].toLowerCase();
                        this._navView = true;
                        (this.currentView() != newView) && this._viewChange(null, this.currentView(), newView);
                    }
                    break;
                case "timemode":
                    if (!ej.isNullOrUndefined(id[1])) {
                        this.model.timeMode = this._timeMode = (id[1] == "Hour12") ? "12" : "24";
                        this._updateTimeMode();
                    }
                    break;
                case "businesshours":
                case "workhours":
                    this.model.workHours.highlight = (this.model.workHours.highlight) ? false : true;
                    (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells") && this.element.find(".e-monthcells").removeClass("e-monthcellhighlight");
                    break;
                case "gotodate":
                    this._gotoWindow.ejDialog("open");
                    break;
                case "delete":
                    this._deleteAppoint();
                    break;
                case "print":
                    this._printAppointment(this._appUid);
                    break;
                case "categorize":
                    if (ej.isNullOrUndefined(id[1]))
                        this.element.find(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment").removeClass("e-selectedAppointment");
                    else {
                        if (this.model.categorizeSettings.enable) {
                            var getId = id[1]; var idValue = "";
                            if (parentData[this._appointmentSettings["categorize"]]) {
                                var categorizeItems = parentData[this._appointmentSettings["categorize"]].split(',');
                                if (!this.model.categorizeSettings.allowMultiple) {
                                    idValue = (categorizeItems[categorizeItems.length - 1] == getId) ? "" : getId.toString();
                                }
                                else {
                                    if (categorizeItems[0].length > 0) {
                                        for (var i = 0; i < categorizeItems.length; i++) {
                                            if (categorizeItems[i] == getId) {
                                                var findId = true;
                                                break;
                                            }
                                        }
                                        if (findId == true) {
                                            for (var i = 0; i < categorizeItems.length; i++) {
                                                if (categorizeItems[categorizeItems.length - 1] != getId) {
                                                    if (categorizeItems[i] != getId) idValue += (categorizeItems.length - 1 != i) ? categorizeItems[i] + "," : categorizeItems[i];
                                                }
                                                else {
                                                    if (categorizeItems[i] != getId) idValue += (categorizeItems.length - 2 != i) ? categorizeItems[i] + "," : categorizeItems[i];
                                                }
                                            }
                                        }
                                        else
                                            idValue = parentData[this._appointmentSettings["categorize"]] + "," + getId;
                                    }
                                }
                            }
                            else {
                                idValue = getId.toString();
                            }
                            parentData[this._appointmentSettings["categorize"]] = idValue;
                            if (!ej.isNullOrUndefined(id[1])) {
                                if (this._trigger("beforeAppointmentChange", { appointment: parentData })) {
                                    parentData[this._appointmentSettings["categorize"]] = oldIdValue;
                                    return false;
                                }
                            }
                            var proxy = this;
                            var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                            var promise = this._dataManager.update(queryId, parentData, this.model.appointmentSettings.query._fromTable);
                            new ej.DataManager(this._currentAppointmentData).update("AppTaskId", parentData);
                            var isObjAvail = this._processed.filter(function (obj) { return obj[proxy._appointmentSettings["id"]] == parentData[proxy._appointmentSettings["id"]]; });
                            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                            new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                            for (var ii = 0, len = isObjAvail.length; ii < len; ii++) {
                                this._appointmentRemove(isObjAvail[ii]);
                            }
                            this._appointmentProcessing(parentData);
                            this._currentViewAppointments = this._appointmentCount();
                            var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == parentData.ParentId; });
                            for (var e = 0, len = collection.length; e < len; e++) {
                                this._refreshDayAppointments(collection[e]);
                            }
                            this._trigger("appointmentChanged", { appointment: parentData });
                            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                                promise.done(function (e) {
                                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                    if ($.isArray(value)) {
                                        proxy._processUrlBinding(e);
                                    }
                                });
                            }
                            break;
                        }
                    }
            }
        },

        _updateTimeMode: function () {
            var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) ? true : false;
            var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) ? true : false;
            var columnValueCount = this._timeSlotCount(userTemplateId, template);
            if (!ej.isNullOrUndefined(this._appointmentAddWindow))
                this._appointmentAddWindow.find('.startendtime').ejTimePicker({ timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
            if (this.model.orientation == "horizontal" && this.currentView() !== "month" && !(this._isCustomMonthView()) && this.currentView() !== "agenda") {
                var view = this.model.timeScale.enable ? (this._isCustomMonthView()) ? "month" : this.currentView() : "month";
                var viewColCount = view == "day" ? 1 : view == "week" ? 7 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 5;
                this.datesColumn = this._getHeaderAllDayCellsCount();
                var multiResources = ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group)) ? true : false;
                if (userTemplateId || template)
                    var html = this.userTimeCellHoriTemplate.render({ cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", multiRes: multiResources, view: view, timeTdCount: columnValueCount.strTime, colspan: view == "month" ? 1 : (columnValueCount.strTime.length / viewColCount) * 2, height: view == 'month' ? 62 : 59, width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: columnValueCount.columnCount, userTemplateId: userTemplateId, template: template });
                else
                    var html = this.horizontalHeader.render({ cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", multiRes: multiResources, view: view, timeTdCount: columnValueCount.strTime, colspan: view == "month" ? 1 : (columnValueCount.strTime.length / viewColCount) * 2, height: view == 'month' ? 62 : 59, width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: columnValueCount.columnCount });
                this.aTR.children().remove();
                this.aTR.append(html);
                this._borderAddRemove();
                (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                this.element.find(".e-headercells").addClass("e-dateheaderselect");
                this._businessHourScroller();
            }
            else {
                if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.currentView() !== "agenda") {
                    var viewclass = this.currentView() == "month" ? 1 : 0;
                    if ((userTemplateId || template) && (this.currentView() !== "month" && !(this._isCustomMonthView()))) {
                        columnValueCount.columnCount.pop();
                        timeCellhtml = this.userTimeCellTemplate.render({ timerows: columnValueCount.strTime, cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, cheight: this.model.cellHeight, userTemplateId: userTemplateId, timeValue1: columnValueCount.timeValue1, template: template });
                    }
                    else
                        var timeCellhtml = this.timeCellTemplate.render({ timerows: columnValueCount.strTime, cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, userTemplateId: userTemplateId, template: template });
                    this.$TimeCellTD.children().remove();
                    this.$TimeCellTD.append(timeCellhtml); if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                    this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
                    this.element.find(".e-headercells").addClass("e-dateheaderselect");
                    this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                }
            }
            if (!ej.isNullOrUndefined(this.dataSource()))
                this._renderAppointmentAll();
        },

        _gotoOk: function (args) {
            if ($(args.currentTarget).hasClass("e-gotoOk")) {
                var date = this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker("option", "value");
                var view = this._gotoWindow.find("#" + this._id + "show").ejDropDownList("option", "itemValue");
                data = { currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: args };
                if (this._trigger("actionBegin", { data: data, requestType: "dateNavigate" }))
                    return false;
                var oldDate = this.currentDate();
                var oldview = this.currentView();
                this.currentDate(new Date(date));
                this.currentView(view.toLowerCase());
                data = { previousDate: oldDate, currentDate: this.currentDate(), previousView: oldview, currentView: this.currentView(), target: args, requestType: "dateNavigate" };
                if (this._trigger("navigation", data)) {
                    this.currentDate(new Date(oldDate));
                    this.currentView(oldview);
                    this._navView = false;
                    return false;
                }
                this._renderCurrentView("ViewChange");
                this._trigger("actionComplete", { data: data, requestType: "dateNavigate" });
            }
            this._gotoCancel();
        },

        _gotoCancel: function () {
            this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker({ value: this.currentDate() });
            this._gotoWindow.find("#" + this._id + "show").ejDropDownList({ value: this.currentView() });
            this._gotoWindow.ejDialog("close");
        },

        _renderGoto: function () {
            this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker({ buttonText: this._getLocalizedLabels("Today"), enableRTL: this.model.enableRTL, width: '100%', value: this.currentDate(), locale: this.model.locale, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
            var views = []
            for (var i = 0; i < this.model.views.length; i++) {
                switch (this.model.views[i]) {
                    case "day": views.push({ text: this._getLocalizedLabels("Day"), value: "day" });
                        break;
                    case "week": views.push({ text: this._getLocalizedLabels("Week"), value: "week" });
                        break;
                    case "workweek": views.push({ text: this._getLocalizedLabels("WorkWeek"), value: "workweek" });
                        break;
                    case "month": views.push({ text: this._getLocalizedLabels("Month"), value: "month" });
                        break;
                    case "customview": views.push({ text: this._getLocalizedLabels("CustomView"), value: "customview" });
                        break;
                    case "agenda": views.push({ text: this._getLocalizedLabels("Agenda"), value: "agenda" });
                        break;
                }
            }
            this._gotoWindow.find("#" + this._id + "show").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: views, width: "100%", selectedItemIndex: 0, cssClass: this.model.cssClass });
            this._gotoWindow.find(".e-gotobutton").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "60px", cssClass: "e-flat" + this.model.cssClass });
        },

        _renderGotoWindow: function () {
            if ($("#" + this._id + "gotoWindow_wrapper")) $("#" + this._id + "gotoWindow_wrapper").remove();
            this._gotoWindow = ej.buildTag('div.e-gotodialog#' + this._id + "gotoWindow");
            var $goWindow = "<div><table width='100%' cellpadding='5'><tbody><tr><td>" + this._getLocalizedLabels("Date") + ":</td><td><input id='" + this._id + "gotodate' type='text' value='' /></td></tr>" +
                    "<tr><td>" + this._getLocalizedLabels("Showin") + ":</td><td><input type='text' id='" + this._id + "show' /></td></tr></tbody></table>";
            $goWindow += "<div class='e-floatright'><table><tr><td><div><button id='" + this._id + "gotook' type='button' class='e-gotobutton e-gotoOk'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                                  "<td><div><button id='" + this._id + "gotocancel' type='button' class='e-gotobutton e-gotoCancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            this._on(this._gotoWindow, "click", ".e-gotobutton", $.proxy(this._gotoOk, this));
            this._gotoWindow.append($goWindow);
            this.element.append(this._gotoWindow);
            this._renderGoto();
            this._gotoWindow.ejDialog({
                width: 300,
                cssClass: this.model.cssClass,
                showOnInit: false,
                enableRTL: this.model.enableRTL, enableModal: true,
                title: this._getLocalizedLabels("Gotodate"),
                target: "#" + this._id,
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._gotoCancel, this)
            });
            $("#" + this._id + "gotoWindow_wrapper").appendTo("body").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
        },


        _highlightCurrentTime: function (showIndicator) {
            ej.preferredCulture(this.model.locale);
            if (showIndicator && this.model.timeScale.enable) {
                var flag = false, index = 0;
                for (var i = 0; i < this._dateRender.length; i++) {
                    if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) {
                        flag = true;
                        index = i;
                        break;
                    }
                }
                var tdelement = this.element.find(".e-workcellstab tr").first().find("td");
                if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                    if (flag) {
                        var temp = this;
                        var view = this.currentView() === "week" ? (this.model.showWeekend) ? 7 : this.model.workWeek.length : this.currentView() === "workweek" ? this.model.workWeek.length : this.currentView() == "customview" ? this._dateRender.length : 1;
                        var timeWidth = (this.model.cellWidth) ? parseInt(this.model.cellWidth) : this.element.find('.e-draggableworkarea')[0].offsetWidth / (view * this.res1.length);
                        if (new Date().getHours() >= temp.model.startHour && new Date().getHours() <= temp.model.endHour) {
                            if (temp.model.orientation == "vertical") {
                                for (var i = 0; i < this.res1.length; i++) {
                                    this.element.find('.e-draggableworkarea').append('<div id="' + this._id + i + '_HighlightCurrentTimeline" class="e-highlightcurrenttimeline"></div>');
                                    $('#' + this._id + i + '_HighlightCurrentTimeline').append('<div class="e-currenttime"></div>').append(ej.buildTag("div.e-icon e-circle_01 e-timeidicatorcircle e-lefttimeindicator")).append(ej.buildTag("div.e-icon e-circle_01 e-timeidicatorcircle e-righttimeindicator")).css("width", timeWidth + "px").css("left", tdelement[index + (view * i)].offsetLeft + "px").find('.e-righttimeindicator').css("margin-left", (timeWidth - 3) + "px");
                                }
                            }
                            else {
                                this._renderHorizontalCurrentTime();
                            }
                        }
                        function ChangeCurrentTimePosition() {
                            if (temp.currentView() != "month" && !temp._isCustomMonthView()) {
                                var tdelement = temp.element.find(".e-workcellstab tr").first().find("td");
                                var view = temp.currentView() === "week" ? (temp.model.showWeekend) ? 7 : temp.model.workWeek.length : temp.currentView() === "workweek" ? temp.model.workWeek.length : temp.currentView() == "customview" ? temp._dateRender.length : 1;
                                var now = new Date();
                                now.setMinutes(now.getMinutes());
                                var index = temp._dateRender.indexOf(new Date(now).setHours(0, 0, 0, 0));
                                if (now.getHours() >= temp.model.startHour && now.getHours() <= temp.model.endHour) {
                                    if (temp.model.orientation == "vertical") {
                                        temp.element.find(".e-currentdayhighlight").removeClass("e-currentdayhighlight");
                                        var topVal = ((((now.getHours() - temp.model.startHour) * 60) + now.getMinutes()) * (temp.element.find(".e-workcells").height() + 1) * temp.model.timeScale.minorSlotCount) / temp.model.timeScale.majorSlot;
                                        for (var i = 0; i < temp.res1.length; i++) {
                                            temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').css("top", topVal - 1);
                                            temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').css("left", tdelement[index + (view * i)].offsetLeft);
                                            $(temp.element.find(".e-dateheader").children()[index + (view * i)]).addClass("e-currentdayhighlight");
                                        }
                                        var currentTime = temp._timeMode == "12" ? ej.format(new Date(), "hh:mm tt", temp.model.locale) : ej.format(new Date(), "HH:mm", temp.model.locale);
                                        for (var i = 0; i < temp.res1.length; i++) {
                                            temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').find(".e-currenttime").html(currentTime);
                                            if (temp._timeMode == "12") temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').find(".e-currenttime").addClass("e-timewidth");
                                        }
                                    }
                                    else {
                                        temp._horizontalTimePosition(temp, now);
                                    }
                                }
                            }
                        }
                        ChangeCurrentTimePosition();
                        if (ej.isNullOrUndefined(this._intervalID))
                            this._intervalID = window.setInterval(ChangeCurrentTimePosition, 60000);
                    }
                    else {
                        window.clearInterval(this._intervalID);
                        this._intervalID = null;
                        this.element.find(".e-highlightcurrenttimeline").remove();
                    }
                }
                else {
                    if (flag) {
                        if (this.model.orientation == "vertical") {
                            var rowIndex = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                            var rowPosition = Math.floor(index / rowIndex);
                            var cellId = Math.abs(index - (rowPosition * rowIndex));
                            if (!this.model.group) this.res1 = ["0"];
                            for (var i = 0; i < this.res1.length; i++) {
                                !$($(this.element.find(".e-workcellstab tr")[rowPosition]).children()[Math.floor(cellId)]).hasClass("e-othermonths") && $($(this.element.find(".e-workcellstab tr")[rowPosition]).children()[Math.floor(cellId)]).addClass("e-currentdayhighlight");
                                cellId += rowIndex;
                            }
                        }
                        else
                            this._renderHorizontalCurrentTime();
                    }
                    else
                        this.model.orientation == "vertical" ? this.element.find(".e-monthcells").removeClass("e-currentdayhighlight") : this.element.find(".e-workcells").removeClass("e-currentdayhighlight");
                }
            }
        },
        _filter: function () {
            var filter = [], filtAppoint = $.extend(true, [], this._processed);
            for (var a = 0; a < filtAppoint.length; a++) {
                if ((new Date(filtAppoint[a][this._appointmentSettings["endTime"]]) >= this.model.minDate) && (new Date(filtAppoint[a][this._appointmentSettings["endTime"]]) <= this.model.maxDate))
                    filter.push(filtAppoint[a]);
            }
            return filter;
        },
        _getPreviousNextAppointment: function () {
            var dateCount = ((this.model.orientation == "horizontal" || !this.model.showNextPrevMonth) && this.currentView() == "month") ? this.monthDays : this._dateRender;
            var previousList = [], nextList = [], appointmentsList = this._filter();
            if (this.currentView() != "workweek") {
                for (var app = 0; app < appointmentsList.length; app++) {
                    if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) < new Date(dateCount[0]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) < new Date(dateCount[0]))
                        previousList.push(appointmentsList[app]);
                    else if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) > new Date(dateCount[(dateCount.length - 1)]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) > new Date(dateCount[(dateCount.length - 1)]))
                        nextList.push(appointmentsList[app]);
                }
            }
            else {
                for (var app = 0; app < appointmentsList.length; app++) {
                    for (var i = 0; i < dateCount.length; i++) {
                        if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).getDay() == new Date(dateCount[i]).getDay()) {
                            if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) < new Date(dateCount[0]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) < new Date(dateCount[0]))
                                previousList.push(appointmentsList[app]);
                            else if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) > new Date(dateCount[(dateCount.length - 1)]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) > new Date(dateCount[(dateCount.length - 1)]))
                                nextList.push(appointmentsList[app]);
                        }
                    }
                }
            }
            return { previous: previousList, next: nextList };
        },

        _nextPrevAppointment: function (flag) {
            if (flag && !(this._browserInfo.name === "msie" && this._browserInfo.version < 9)) {
                var base = this.element.find("#" + this._id + "_scroller");
                var scroll = (base.ejScroller('instance').isVScroll()) ? this.element.find("#" + this._id + "_scroller").find(".e-vscroll").outerWidth() : 0;
                var prev = ej.buildTag("div.e-prevapp enable", this._getLocalizedLabels("PreviousAppointment"), {}, {});
                var next = ej.buildTag("div.e-nextapp enable", this._getLocalizedLabels("NextAppointment"), {}, {});
                base.append(prev).append(next);
                var top = (base.height() / 2) - (150 / 2);
                var timecell = this.element.find(".e-scrolltimecells").parent().outerWidth();
                timecell = ej.isNullOrUndefined(timecell) ? 0 : timecell;
                if (!this.model.enableRTL) {
                    prev.css({ top: (top + 40) + "px", transform: "rotate(90deg)", left: (timecell - 61) + "px" });
                    next.css({ top: (top + 40) + "px", transform: "rotate(-90deg)", left: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
                }
                else {
                    prev.css({ top: (top + 40) + "px", transform: "rotate(-90deg)", right: (timecell - 61) + "px" });
                    next.css({ top: (top + 40) + "px", transform: "rotate(90deg)", right: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
                }
            }
        },

        _nextPrev: function (e) {
            var proxy = this, appointmentList = this._getPreviousNextAppointment();
            if ($(e.currentTarget).hasClass("e-prevapp")) {
                if (!ej.isNullOrUndefined(appointmentList)) {
                    appointmentList.previous.sort(function (a, b) { return new Date(b[proxy._appointmentSettings["startTime"]]) - new Date(a[proxy._appointmentSettings["startTime"]]); });
                    if (this.currentView() == "customview") this._daterend = appointmentList.previous[0][this._appointmentSettings["startTime"]];
                    this._navigateClick(this.currentDate(new Date(new Date(appointmentList.previous[0][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0))), "Previous");
                }
            }
            else if ($(e.currentTarget).hasClass("e-nextapp")) {
                if (!ej.isNullOrUndefined(appointmentList)) {
                    appointmentList.next.sort(function (a, b) { return new Date(a[proxy._appointmentSettings["startTime"]]) - new Date(b[proxy._appointmentSettings["startTime"]]); });
                    if (this.currentView() == "customview") this._daterend = appointmentList.next[0][this._appointmentSettings["startTime"]];
                    this._navigateClick(this.currentDate(new Date(new Date(appointmentList.next[0][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0))), "Next");
                }
            }
        },

        _nextPrevButton: function () {
            if (this._appointmentCount().length != 0)
                this.element.find(".e-prevapp,.e-nextapp").css("display", "none");
            else {
                this.currentView() == "agenda" && this._refreshAppNavigation();
                var appointmentList = this._getPreviousNextAppointment();
                this.element.find(".e-prevapp,.e-nextapp").css("display", "block");
                if (appointmentList.previous.length == 0)
                    this.element.find(".e-prevapp").removeClass("enable").addClass("e-nextprevappdisable");
                else
                    this.element.find(".e-prevapp").addClass("enable").removeClass("e-nextprevappdisable");
                if (appointmentList.next.length == 0)
                    this.element.find(".e-nextapp").removeClass("enable").addClass("e-nextprevappdisable");
                else
                    this.element.find(".e-nextapp").addClass("enable").removeClass("e-nextprevappdisable");
            }
        },

        _navigateView: function (e) {
            var newView, navidate, index, cellIndex, oldview = this.currentView();
            var target = $(e.target);
            if (this.currentView() == "agenda") {
                return false;
            }
            else {
                if (this.model.orientation == "vertical") {
                    var noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    if (this.currentView() === "month" || (this._isCustomMonthView())) {
                        if (target.hasClass("e-monthheader")) {
                            if (this.model.views.toString().toLowerCase().split(",").indexOf("day") == -1) return false;
                            cellIndex = target.parent().index();
                            index = (cellIndex > (noOfDays - 1)) ? (cellIndex % noOfDays) : cellIndex;
                            navidate = new Date(this._dateRender[((target.parent().parent().index() * noOfDays) + index)]);
                            if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                                this.currentDate(navidate);
                            else return false;
                            newView = "day";
                        }
                        else if (target.hasClass("e-timecells") || target.hasClass("e-timecelldivs")) {
                            target = target.hasClass("e-timecells") ? target : target.parent();
                            if (this.model.views.toString().toLowerCase().split(",").indexOf("week") == -1) return false;
                            navidate = new Date(this._dateRender[(target.parent().index() * noOfDays)]);
                            if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                                this.currentDate(navidate);
                            else return false;
                            newView = "week";
                        }
                    }
                    else if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                        var dayTarget = target.hasClass("e-headercells") ? target : target.parent().hasClass("e-headercells") ? target.parent() : target.closest(".e-headercells");
                        if (this.model.views.toString().toLowerCase().split(",").indexOf("day") == -1 || !dayTarget.hasClass("e-headercells")) return false;
                        cellIndex = dayTarget.index();
                        var cols = (this.currentView() === "workweek") ? this.model.workWeek.length : (this.currentView() === "customview") ? this._dateRender.length : noOfDays;
                        index = (cellIndex > (cols - 1)) ? (cellIndex % cols) : cellIndex;
                        navidate = new Date(this._dateRender[index]);
                        if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                            this.currentDate(new Date(navidate));
                        else return false;
                        newView = "day";
                    }
                    this._navView = true;
                    if (oldview != "day" && !ej.isNullOrUndefined(newView)) {
                        this._viewChange(e, oldview, newView);
                        this._businessHourScroller();
                    }
                }
                else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                    this._horizontalViewNavigation(e);
            }
        },

        _appOverflowClick: function (e) {
            if (this.model.views.toString().toLowerCase().split(",").indexOf("day") !== -1) {
                if (this._trigger("overflowButtonClick", { event: e, Datas: this._overflowApp })) return false;
                !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
                if (this.model.orientation == "vertical") {
                    var noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    var index = ($(e.target).closest(".e-monthcells,.e-workcells").parent().index() * noOfDays) + ($(e.target).closest(".e-monthcells,.e-workcells").index() % noOfDays);
                    this.currentDate(new Date(this._dateRender[index]));
                }
                else {
                    var index = parseInt($(e.target).attr("id").split("_")[$(e.target).attr("id").split("_").length - 1]);
                    this.currentDate((this.currentView() == "month" || this._isCustomMonthView()) ? new Date(this.monthDays[index]) : new Date(parseInt($(e.target).attr("cellinfo"))));
                }
                this._navView = true;
                this._viewChange(e, this.currentView(), "day");
            }
            else return false;
        },

        _viewCalendar: function (e) {
            var obj = this.element.find("#" + this._id + "_navigator").data("ejDatePicker");
            if (obj) {
                obj.show();
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                var controlmargin = this.element.offset();
                if (this.model.enableRTL) {
                    var leftvalue = controlmargin.left + this.element.width() - 280;
                    if (leftvalue < 0) leftvalue = 0;
                }
                else {
                    var leftvalue = controlmargin.left + 55, winWidth = $(document).scrollLeft() + $(window).width();
                    if ((winWidth - leftvalue) < $("#e-" + this._id + "_navigator").width())
                        leftvalue = winWidth - $("#e-" + this._id + "_navigator").width();
                }
                $("#e-" + this._id + "_navigator").css({ top: (controlmargin.top + 47) + "px", left: leftvalue + "px" });
            }
            this.element.find(".e-workcells").removeClass("e-selectedCell").removeClass("e-mousehover");
            this.element.find(".e-appointment,.e-alldayappointment,.e-monthappointment").removeClass("e-selectedAppointment");
        },

        _viewChange: function (e, oldview, newView) {
            this._viewchange = true; this._renderedApp = [];
            newView = ej.isNullOrUndefined(newView) ? (e.currentTarget.className.split("e-")[2]).split(" ")[0] : newView;
            var flag = true, data;
            data = { currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e };
            if (this._trigger("actionBegin", { data: data, requestType: "viewNavigate" })) return false;
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
            if (this.model.orientation == ej.Schedule.Orientation.Horizontal && this._grouping.length > 1) {
                var expandCollapseNode = this.element.find(".e-parentnodecategory"), proxy = this;
                expandCollapseNode.each(function (index) {
                    if ($(this).hasClass("e-resourceexpand")) proxy._expandCollapseState.push(index);
                });
            }
            if (oldview !== newView || (!oldview && !newView)) {
                oldview = this.currentView();
                if (!this._navView) {
                    flag = (this.currentView() == (e.currentTarget.className.split("e-")[2]).split(" ")[0]) ? false : true;
                    this.currentView($(e.currentTarget).hasClass("e-activeview") ? this.currentView() : (e.currentTarget.className.split("e-")[2]).split(" ")[0]);
                }
                else
                    this.currentView(newView);
                data = { previousView: oldview, currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e, requestType: "viewNavigate" };
                if (this._trigger("navigation", data)) {
                    this.currentView(oldview);
                    this._navView = false;
                    return false;
                }
                if (flag) this._renderCurrentView("ViewChange");
            }
            data = { previousView: oldview, currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e, requestType: "viewNavigate" };
            (this._mediaQuery && (oldview != this.currentView())) && this.element.find(".e-workareadiv,.e-navigate").addClass("navigate");
            this._trigger("actionComplete", { data: data, requestType: "viewNavigate" });
        },

        _renderCurrentView: function (currentAction) {
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            this._resWorkWeek = (this.model.orientation == "vertical" && this.model.showWeekend && this.currentView() == "workweek" && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]));
            this.element.find(".e-commonviewbutton").blur().removeClass("e-activeview");
            if (this.model.orientation == "vertical") this.element.find(".e-headerdaydisplay,.e-datedisplay,.e-headrealldaytable").children().remove();
            this._getRenderDates();
            this.wTR.children().remove();
            this.aTR.children().remove();
            this.element.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview").attr("tabIndex", 0).focus();
            if ((!ej.isNullOrUndefined(this._scheduleDrawer)) && (!this._navSelected))
                this._scheduleDrawer.ejNavigationDrawer({ listViewSettings: { selectedItemIndex: this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) + 1 } });
            this._renderHeaderAllDayTemplate();
            this._renderContentAreaTemplate();
            if (this.model.showHeaderBar) this.element.find("div.e-datedisplay").html(this._getCurrentDateHeaderValue());
            this._renderCommon();
            if (!ej.isNullOrUndefined(this.dataSource())) {
                if (currentAction != "ScheduleResize") {
                    if (this.model.enableLoadOnDemand)
                        this._bindAppointmentsData(currentAction);
                    else {
                        this._dataProcessing(this._currentAppointmentData);
                        this._renderAppointmentAll();
                    }
                }
                else
                    this._renderAppointmentAll();
            }
            if (this.model.orientation == ej.Schedule.Orientation.Horizontal && this._grouping.length > 1) {
                var expandCollapseNode = this.element.find(".e-parentnodecategory");
                for (var ec = 0; ec < this._expandCollapseState.length; ec++) {
                    expandCollapseNode.eq(this._expandCollapseState[ec]).click();
                }
                this._expandCollapseState = [];
            }
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            this._navView = false;
        },

        _renderHeaderDays: function () {
            this.dateRender = [];
            var dateList = this._getRenderDates();
            this.res1 = (!ej.isNullOrUndefined(this.model.group)) ? this.res1 : [0];
            if (!this._resWorkWeek) {
                for (var i = 0; i < this.res1.length; i++) {
                    for (var j = 0; j < dateList.length; j++) {
                        this.dateRender.push(new Date(dateList[j]));
                    }
                }
            }
            if (this.model.showHeaderBar) this.element.find("div.e-datedisplay").html(this._getCurrentDateHeaderValue());
            (this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate);
            (this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate);
            if (this.model.orientation == "vertical") {
                this.element.find(".e-currentdayhighlight").removeClass("e-currentdayhighlight");
                if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                    var curday, temp;
                    if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId)) {
                        var cols = [], columns = this._getUserDateheaderTemplate();
                        if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                            for (i = 0; i < this.res1.length; i++) { cols = $.merge(cols, columns); }
                        }
                        else cols = $.merge(cols, columns);
                        for (i = 0; i < this.dateRender.length; i++) {
                            this.element.find(".e-headerdaydisplay").eq(i).html(cols[i].currentDay);
                            if (new Date(new Date(this.dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                                this.element.find("td.e-headercells").eq(i).addClass("e-currentdayhighlight");
                        }
                    }
                    else {
                        for (var i = 0; i < this.dateRender.length; i++) {
                            curday = (this.currentView() === "day") ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(this.dateRender[i]).getDay()] : this._dayShortNames[new Date(this.dateRender[i]).getDay()] : this._dayShortNames[new Date(this.dateRender[i]).getDay()];
                            temp = this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? ej.format(new Date(this.dateRender[i]), this._pattern.D, this.model.locale) : curday + " " + new Date(this.dateRender[i]).getDate() : curday + " " + new Date(this.dateRender[i]).getDate();
                            this.element.find(".e-headerdaydisplay").eq(i).html(temp);
                            if (new Date(new Date(this.dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                                this.element.find("td.e-headercells").eq(i).addClass("e-currentdayhighlight");
                        }
                    }
                    this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                    this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
                    if (!ej.isNullOrUndefined(this.model.allDayCellsTemplateId) && this.model.timeScale.enable) {
                        var allDayHtml = this._getUserAllDayCellsTemplate();
                        for (a = 0; a < allDayHtml.length; a++) { this.element.find(".e-alldaycells").eq(a).html(allDayHtml[a]); }
                        this.element.find(".e-leftindent").height(this.element.find(".e-alldaycells").height());
                    }
                    this.element.find(".e-headercells").addClass("e-dateheaderselect");
                }
                else
                    this._renderMonthTimeCells();
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                this._renderHorizontalHeaderDays(this._culture);
        },

        _renderMonthTimeCells: function () {
            var timeCellIndex = 0, dateRender = this._dateRender, k = 0, rowIndex = (this.model.showWeekend) ? 7 : this.model.workWeek.length, resCount = !ej.isNullOrUndefined(this.model.group) ? this.res1.length * rowIndex : rowIndex;
            var findResource = ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) ? true : false;
            if (findResource)
                resCount = this._isCustomMonthView() && this._oneWeek ? this.res1.length * this._dateRender.length : this.res1.length * rowIndex;
            else
                resCount = !ej.isNullOrUndefined(this.model.group) ? this._isCustomMonthView() && this._oneWeek ? this.res1.length * this._dateRender.length : this.res1.length * 7 : rowIndex;
            var res = findResource && this._isCustomMonthView() && this._oneWeek ? true : false;
            var monthHeader = this.element.find("div.e-monthheader");
            for (var i = 0; i < dateRender.length; i++) {
                for (var j = k; j < resCount; j = res ? j + this._dateRender.length : j + rowIndex) {
                    var curDate = (new Date(this._dateRender[i]).getDate() == 1) ? (ej.format(new Date(this._dateRender[i]), "MMM", this.model.locale) + " " + new Date(this._dateRender[i]).getDate()) : ej.format(new Date(this._dateRender[i]), "dd", this.model.locale);
                    monthHeader.eq(j).html(curDate);
                    if (this.currentView() !== "customview") {
                        if (new Date(dateRender[i]).getMonth() !== new Date(this.currentDate()).getMonth()) {
                            if (!this.model.showNextPrevMonth)
                                monthHeader.eq(j).addClass("e-monthdateshighlight").closest(".e-monthcells").addClass("e-othermonths").children().hide();
                            else
                                monthHeader.eq(j).addClass("e-monthdateshighlight").closest(".e-monthcells").removeClass("e-othermonths").children().show();
                        }
                        else
                            monthHeader.eq(j).removeClass("e-monthdateshighlight").closest(".e-monthcells").removeClass("e-othermonths").children().show();
                    }
                    if (new Date(dateRender[i]).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                        !this.element.find("td.e-monthcells").eq(j).hasClass("e-othermonths") && this.element.find("td.e-monthcells").eq(j).addClass("e-currentdayhighlight");
                }
                k++;
                if ((i + 1) % rowIndex == 0) {
                    k = resCount;
                    resCount = resCount + ((!ej.isNullOrUndefined(this.model.group) ? this.res1.length : 1) * rowIndex);
                    if (this.model.showNextPrevMonth || this.currentView() == "customview") {
                        start = ej.format(new Date(dateRender[i - (rowIndex - 1)]), "MMM dd", this.model.locale);
                        end = ej.format(new Date(dateRender[i]), "MMM dd", this.model.locale);
                    }
                    else {
                        tempDate = new Date(this.currentDate());
                        start = (i == rowIndex - 1) ? ej.format(new Date(tempDate.getFullYear(), tempDate.getMonth(), 1), "MMM dd", this.model.locale) : ej.format(new Date(dateRender[i - (rowIndex - 1)]), "MMM dd", this.model.locale);
                        end = (i == dateRender.length - 1) ? ej.format(new Date(tempDate.getFullYear(), tempDate.getMonth() + 1, 0), "MMM dd", this.model.locale) : ej.format(new Date(dateRender[i]), "MMM dd", this.model.locale);
                    }
                    if (this.model.timeScale.enable) this.element.find(".e-timecelldivs").eq(timeCellIndex).html(start + " - " + end);
                    timeCellIndex++;
                }
            }
            if (!this.model.showNextPrevMonth && this.currentView() == "month") {
                this._refreshOtherMonthsBorder();
            }
            this.element.find(".e-timecells").addClass("e-dateheaderselect");
            this.element.find(".e-monthcells, .e-timecells").outerHeight(this.model.cellHeight ? parseInt(this.model.cellHeight) + 1 : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
        },

        _refreshOtherMonthsBorder: function () {
            var border = this.model.enableRTL ? "e-borderright" : "e-borderleft";
            var prevMonthlen = this.element.find(".e-workcellstab tr").first().find(".e-othermonths").length;
            var prevRes = prevMonthlen / this.res1.length;
            for (var a = prevRes; a < prevMonthlen; a = a + prevRes) {
                this.element.find(".e-workcellstab tr").first().find(".e-othermonths").eq(a).addClass(border);
            }
            var nextMonthlen = this.element.find(".e-workcellstab tr").last().find(".e-othermonths").length;
            var nextRes = nextMonthlen / this.res1.length;
            for (var b = 0; b < nextMonthlen; b = b + nextRes) {
                this.element.find(".e-workcellstab tr").last().find(".e-othermonths").eq(b).addClass(border);
            }
        },

        _nextPrevDate: function (args) {
            var findDate, weekDate = new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0));
            var noOfDays = (this.currentView() === "day" || this.currentView() === "agenda") ? 1 : this.currentView() === "customview" ? this._dateRender.length : 7;
            if (this.currentView() === "month") {
                var navigateMonth = (args == "navigateprevious") ? new Date(weekDate.getFullYear(), weekDate.getMonth() - 1, weekDate.getDate()) : new Date(weekDate.getFullYear(), weekDate.getMonth() + 1, weekDate.getDate());
                var targetMonth = (args == "navigateprevious") ? new Date(weekDate.getFullYear(), weekDate.getMonth() - 1, 1) : new Date(weekDate.getFullYear(), weekDate.getMonth() + 1, 1);
                findDate = (navigateMonth.getMonth() == targetMonth.getMonth()) ? new Date(navigateMonth) : new Date(targetMonth._currentMonthDates().end);
            }
            else if (this.currentView() === "customview") {
                this._daterend = this._dateRender; this._dateNavigation = true;
                weekDate = (this.model.showWeekend) ? new Date(this._dateRender[0]) : new Date(this._renderStart);
                noOfDays = (this.model.showWeekend) ? noOfDays : this._isCustomMonthView() ? this._numDays : this._renderDays;
                findDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24 * noOfDays)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24 * noOfDays));
            }
            else if (this.currentView() == "day" && !this.model.showWeekend) {
                var currentDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24));
                noOfDays = this._getPrevNextDateCount(currentDate, (args == "navigateprevious") ? "previous" : "next") + 1;
                weekDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24 * noOfDays)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24 * noOfDays));
                findDate = new Date(weekDate);
            }
            else {
                findDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24 * noOfDays)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24 * noOfDays));
            }
            return new Date(findDate.getFullYear(), findDate.getMonth(), findDate.getDate());
        },

        _navigateClick: function (e, dateNavigate) {
            this._viewchange = true;
            var data, currentAction = dateNavigate;
            var oldDate = new Date(this.currentDate());
            data = { currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e };
            if (this._trigger("actionBegin", { data: data, requestType: "dateNavigate" }))
                return false;
            if (!ej.isNullOrUndefined(e) && !ej.isNullOrUndefined(e.value)) {
                this.currentDate(ej.parseDate(e.value, this._pattern.d));
            }
            if (e != null && !this._setCurrentDate) {
                if ($(e.currentTarget).hasClass("e-disable")) return false;
                if ($(e.currentTarget).hasClass("e-navigateprevious")) {
                    this.currentDate(this._nextPrevDate("navigateprevious"));
                    this.element.find(".e-navigateprevious").attr("tabIndex", 0).focus();
                    currentAction = "Previous";
                }
                else if ($(e.currentTarget).hasClass("e-navigatenext")) {
                    this.currentDate(this._nextPrevDate("navigatenext"));
                    this.element.find(".e-navigatenext").attr("tabIndex", 0).focus();
                    currentAction = "Next";
                }
            }
            if (e != null)
                if ($(e.currentTarget).hasClass("e-navigateprevious") || $(e.currentTarget).hasClass("e-navigatenext") || (e.type == "select"))
                    data = { previousDate: oldDate, currentDate: new Date(this.currentDate()), currentView: this.currentView(), target: e, requestType: "dateNavigate" };
            if (this._trigger("navigation", data)) {
                this.currentDate(new Date(oldDate));
                return false;
            }
            this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            this.element.find(".e-appsoverflow").remove();
            this.element.find(".e-monthcells").removeClass("e-monthcurrenttime");
            if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
            !ej.isNullOrUndefined(this._scheduleDrawer) && this._scheduleDrawer.ejNavigationDrawer("close");
            if (this.currentView() === "month" || this.currentView() === "agenda" || this._isCustomMonthView() || (this.currentView() === "customview" && !this.model.showWeekend) || !this.model.timeScale.enable || !ej.isNullOrUndefined(this.model.workCellsTemplateId)) {
                this._renderCurrentView(currentAction);
            }
            else {
                this._renderHeaderDays();
                if (!ej.isNullOrUndefined(this.model.queryCellInfo)) {
                    this._renderQueryCellInfo("renderHeaderAllDayTemplate");
                    this._renderQueryCellInfo("renderContentAreaTemplate");
                    this._renderQueryCellInfo("emptycell");
                }
                if (!this.model.showOverflowButton && this.model.orientation == "horizontal") {
                    this._horizontalRender();
                    this._reRenderScroller();
                }
                if (!ej.isNullOrUndefined(this.dataSource())) {
                    if (this.model.enableLoadOnDemand)
                        this._bindAppointmentsData(currentAction);
                    else {
                        this._dataProcessing(this._currentAppointmentData);
                        this._renderAppointmentAll();
                    }
                }
                (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                this._businessHourScroller();
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            }
            this._validateMinMaxDate();
            if (!ej.isNullOrUndefined(this.oldDate) && this.oldDate != "" && this._setCurrentDate) {
                this.currentDate(new Date(this.oldDate));
                this.oldDate = "";
            }
            this._setCurrentDate = false;
            if (this._mediaQuery && !ej.isNullOrUndefined(e)) {
                var value = ($(e.currentTarget).hasClass("e-navigateprevious")) ? this.element.width() : ($(e.currentTarget).hasClass("e-navigatenext") || (e.type == "select")) ? -this.element.width() : 0;
                this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll,.e-emptyscrolltd").toggle();
                if (!this.model.enableRTL)
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css({ marginLeft: -value, marginRight: value }).toggle().animate({ marginLeft: 0, marginRight: 0 }, 500, (this.model.orientation == "vertical" && this.element.find(".e-vscroll").length == 1) ? $.proxy(this._animateScroll, this) : "");
                else
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css({ marginRight: -value, marginLeft: value }).toggle().animate({ marginLeft: 0, marginRight: 0 }, 500, (this.model.orientation == "vertical" && this.element.find(".e-vscroll").length == 1) ? $.proxy(this._animateScroll, this) : "");
            }
            this._trigger("actionComplete", { data: data, requestType: "dateNavigate" });
        },
        _animateScroll: function () {
            this.element.find(".e-emptyscrolltd").toggle();
            this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css({ marginRight: 0, marginLeft: 0 });
            if (this._browserInfo.name == "webkit" || this._browserInfo.name == "msie") {
                highScrol = this.element.find('.e-businesshighlightworkcells').length != 0 ? this.element.find('.e-businesshighlightworkcells').first().parent()[0].rowIndex * $('.e-workcells').height() : 0;
                $("#" + this._id + "_scroller").ejScroller({ scrollTop: highScrol + 1 });
                this.element.find('.e-scrolltimecells').css('top', -(highScrol + 1) + 'px');
            }
        },
        _validateMinMaxDate: function () {
            this.element.find(".e-navigateprevious,.e-navigatenext").removeClass("e-disable");
            var renderDate = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : this._dateRender;
            var firstWeekDate = new Date(renderDate[0]);
            var lastWeekDate = new Date(renderDate[renderDate.length - 1]);
            if (this.currentView() == "workweek") {
                firstWeekDate = new Date(firstWeekDate.setDate(firstWeekDate.getDate() - 1));
                lastWeekDate = new Date(lastWeekDate.setDate(lastWeekDate.getDate() + 1));
            }
            if (firstWeekDate <= this.model.minDate)
                this.element.find(".e-navigateprevious").addClass("e-disable");
            else
                this.element.find(".e-navigateprevious").removeClass("e-disable");
            if (lastWeekDate >= this.model.maxDate)
                this.element.find(".e-navigatenext").addClass("e-disable");
            else
                this.element.find(".e-navigatenext").removeClass("e-disable");
        },

        _onScheduleResize: function () {
            if (!ej.isNullOrUndefined(this._scheduleDrawer)) {
                if (ej.isNullOrUndefined(this._scheduleDrawer.data("ejNavigationDrawer"))) {
                    $(this._scheduleDrawer).remove(); this._scheduleDrawer = null;
                }
                else this._scheduleDrawer.ejNavigationDrawer("close");
            }
            if (this._mediaQuery && ej.isMobile()) {
                if (!ej.isNullOrUndefined(this._recurEditWindow)) this._recurEditWindow.ejDialog("refresh");
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog("refresh");
                if (window.orientation == this._screenOrientation) return false;
                this._screenOrientation = window.orientation;
            }
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
            var temp = this._mediaQuery;
            var hasScrollbar = (typeof window.innerWidth === 'number') && window.innerWidth > document.documentElement.clientWidth;
            this._mediaQuery = (this._browserInfo.name == "msie" && parseInt(this._browserInfo.version, 10) <= 8) ? false : ((document.documentElement.clientWidth + (hasScrollbar ? 17 : 0) < 361 || ej.isMobile()) && this.model.isResponsive);
            (this._mediaQuery) ? this.element.addClass("e-scheduleresponsive") : this.element.removeClass("e-scheduleresponsive");
            var scrollerObj = this.element.find('div#' + this._id + '_scroller').data("ejScroller");
            if (this.currentView() != "agenda") {
                var scroll = (scrollerObj.isVScroll()) ? this.element.find('div#' + this._id + '_scroller').find(".e-vscroll").width() : 0;
                this.element.find(".e-nextapp").css("left", (this.element.width() - scroll - 90) + "px");
                this.model.enableRTL && this.element.find(".e-nextapp").css("left", -45 + "px");
                this.model.enableRTL && this.element.find(".e-prevapp").css("left", (this.element.width() - this.element.find(".e-scrolltimecells").width() - 89) + "px");
                if (this.model.orientation == "horizontal" && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) {
                    this.element.find(".resemptytd").width((this.element.find(".e-horizontalrestd").width() < 100) ? 5 : (this.element.find(".e-horizontalrestd").width() >= 100 && this.element.find(".e-horizontalrestd").width() <= 150) ? 10 : 25);
                    this.element.find(".e-horizontalresheader").width((this._mediaQuery) ? "50px" : "100%");
                    this.element.find(".e-parentnodecategory").width((this._mediaQuery) ? "12px" : "20px");
                }
                var scrollWidth = (this.model.orientation === "vertical") ? ((hasScrollbar && this._mediaQuery) ? this.element.outerWidth() + 17 : this.element.outerWidth()) - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : this.element.width();
                scrollerObj.model.width = parseInt(scrollWidth) - 2;
                scrollerObj.model.height = this.scHeight - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
                scrollerObj.refresh();
                if (this.model.orientation == "vertical") {
                    this._renderHoriVerticalScroll();
                    this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                    this.element.find(".e-headrealldaytable").css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
                    this.element.find(".e-upicon, .e-downicon").children().width(this.element.find(".e-workcells").width());
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-emptyscrolltd").css("margin-left", "0px");
                    this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
                }
                else {
                    if (!this._isCustomMonthView() || this.currentView() != "month" || this.currentView() != "day" || !this.model.enableRTL || this.model.timeScale.enable) {
                        this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
                        $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
                        this._horizontalRender();
                        if (!this.model.showOverflowButton) this._renderAppointmentAll();
                    }
                }
                if (this.currentView() != "month" && !(this._isCustomMonthView()) && this.model.orientation == "vertical") {
                    if (this.model.enableRTL && (this.model.cellWidth || this.model.cellHeight))
                        this._renderCurrentView("ScheduleResize");
                    else {
                        (this.model.showAllDayRow && this.model.timeScale.enable) && this.element.find("div.e-alldayappointment").remove() && this._renderAllDayAppointments();
                        if (!this.model.timeScale.enable) {
                            this.element.find("div.e-monthappointment").remove();
                            this._currentViewAppointments = this._appointmentCount();
                            this._renderMonthAppointment();
                        }
                        this._bindAppointmentAction();
                    }
                }
                else {
                    if (this._isCustomMonthView() || this.currentView() == "month" || this.currentView() == "day" || this.model.enableRTL || !this.model.timeScale.enable)
                        this._renderCurrentView("ScheduleResize");
                }
                if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            } else {
                scrollerObj.model.width = parseInt(this.element.width()) - 2;
                scrollerObj.model.height = this.scHeight - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
                scrollerObj.refresh();
                var _scrollDiv = $('div#' + this._id + "_scroller");
                this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
                this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                _scrollDiv.ejScroller("isVScroll") ? (this.element.find(".e-emptyscrolltd").show() && this.element.find('.e-draggableworkarea').height(this.element.find('.e-draggableworkarea').height() + 1)) : this.element.find(".e-emptyscrolltd").hide();
            }
            ((this._mediaQuery || this.element.width() < 600) && !$("#" + this._id + "navDrawer").hasClass("e-scheduledrawer")) && this._renderNavigationDrawer();
            var flag = (this._mediaQuery == temp) ? false : true;
            if (!flag && (this.element.width() < 600 && this.hTR.find(".e-mobileNavigation").length < 1 || this.element.width() > 600 && this.hTR.find("table.e-viewstable").length < 1)) {
                this._reRenderHeaderBar();
                this._on(this.element, "click", "#" + this._id + "navDrawerIcon", $.proxy(this._drawerOpen, this));
            }
            if (flag) {
                if (this.model.orientation == "horizontal") {
                    var renderDate = this._dateRender;
                    for (var i = 0; i < renderDate.length; i++) {
                        var curday = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? this._dayNames[new Date(renderDate[i]).getDay()].split("")[0] : (this.currentView() === "day") ? (ej.isNullOrUndefined(this._tempResource) && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(renderDate[i]).getDay()] : this._dayShortNames[new Date(renderDate[i]).getDay()] : this._dayShortNames[new Date(renderDate[i]).getDay()];
                        var temp = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? curday + parseInt(ej.format(new Date(renderDate[i]), "dd", this.model.locale)) : (this.currentView() === "day") ? (ej.isNullOrUndefined(this._tempResource) && ej.isNullOrUndefined(this.model.group)) ? curday + " " + ej.format(new Date(renderDate[i]), "dd MMMM yyyy", this.model.locale) : curday + " " + ej.format(new Date(renderDate[i]), "dd MMM yy", this.model.locale) : curday + " " + new Date(renderDate[i]).getDate();
                        if (this.element.find(".e-headerdaydisplay,.e-horizontalheaderdiv").length != 0) this.element.find(".e-headerdaydisplay,.e-horizontalheaderdiv")[i].innerHTML = temp;
                    }
                }
                this.model.showAppointmentNavigator = flag && !this._mediaQuery;
                if (!this.model.showAppointmentNavigator)
                    this.element.find(".e-prevapp,.e-nextapp").remove();
                else {
                    this._nextPrevAppointment(this.model.showAppointmentNavigator);
                }
                this.model.showHeaderBar && this._reRenderHeaderBar();
                this.element.find(".e-leftindenttable").width(this.element.find(".e-workleftindent").width());
                this.element.find(".e-ampmdisplay").height(this.element.find(".e-workcells").height());
                this._businessHourScroller();
                this.model.showQuickWindow = this._mediaQuery ? false : this._quickWindow;
                if (ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._renderQuickWindow();
                this._refreshAppointmentWindow();
                (!ej.isNullOrUndefined(this._alertWindow)) && this._alertWindow.ejDialog("close");
                if (!ej.isNullOrUndefined(this._recurEditWindow)) {
                    this._recurEditWindow.ejDialog("close");
                    this._recurEditWindow.ejDialog({ width: (this._mediaQuery) ? "90%" : 360 });
                }
                if (this._mediaQuery) this._phoneChanges();
                this._renderAppointmentAll();
                if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
                if (this._mediaQuery) {
                    this._off(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells,td.e-alldaycells");
                    this._off(this.element, "keydown click", "td.e-workcells,td.e-monthcells,td.e-alldaycells");
                    this._on(this.element, "click", "#" + this._id + "navDrawerIcon", $.proxy(this._drawerOpen, this));
                }
                else {
                    this._on(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells,td.e-alldaycells", $.proxy(this._mouseButtonClick, this));
                    this._on(this.element, "keydown click", "td.e-workcells,td.e-monthcells,td.e-alldaycells", $.proxy(this._shiftSelection, this));
                    (this.element.width() > 600) && this._off(this.element, "click", "#" + this._id + "navDrawerIcon");
                }
                (this._mediaQuery || ej.isTouchDevice()) ? this._on(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab,.e-agendacellstab", $.proxy(this._touchSchedule, this)) : this._off(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab,.e-agendacellstab");
                this._on(this.element, (ej.isMobile()) ? "click" : "dblclick", ".e-workcells,.e-alldaycells,.e-alldayappointment,.e-monthcells", $.proxy(this._appointmentWindow, this));
                if (this._mediaQuery || ej.isMobile())
                    this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
                else
                    this._off(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment");
                var scheduleResponsive = $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper,#" + this._id + "navDrawer,#" + this._id + "alertWindow_wrapper");
                (this._mediaQuery) ? scheduleResponsive.addClass("e-scheduleresponsive") : scheduleResponsive.removeClass("e-scheduleresponsive");
                (this._mediaQuery && this.res1.length > 1) && this.element.addClass("e-resources");
            }
            (this._mediaQuery || this.element.width() < 600) && this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
        },

        _reRenderHeaderBar: function () {
            var header = this.element.find(".e-scheduleheader");
            header.empty();
            this._renderHeaderBar(header);
            this.element.find("#" + this._id + "_navigator").ejDatePicker({ enableRTL: this.model.enableRTL, buttonText: this._getLocalizedLabels("Today"), select: $.proxy(this._onselect, this), locale: this.model.locale, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
            this.element.find(".e-datecommondiv").find(".e-datewidget").css("display", "none");
            this.element.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview");
        },

        _renderTemplates: function () {
            if (this.model.orientation == "vertical") {
                this.workcellTemp = $.templates(workCellsTemplate());
                this.monthcellTemp = $.templates(monthCellsTemplate());
                this.timeCellTemplate = $.templates(timeCellsTemplate());
                this.userTimeCellTemplate = $.templates(userTimeCellsTemplate());
                this.headTemplate = $.templates(headerTemplate());
                this.alldayTemp = $.templates(alldayTemplate());
                this.leftIndent = $.templates(leftHeaderTemplate());
            }
            if (ej.scheduleFeatures.resources && (this._tempResource.length != 0)) this._renderResourcesTemplate();
            this.agendaheadTemplate = $.templates(agendaHeaderTemplate());
            this.agendacellTemp = $.templates(agendaCellsTemplate());
            this.appTemplate = $.templates(appointmentTemplate());
            this.blockTimeTemplate = $.templates(blockTimeTemplate());
            if (ej.scheduleFeatures.horizontal && this.model.orientation === "horizontal") this._renderHorizontalTemplates();
            if (!ej.isNullOrUndefined(this.model.categorizeSettings) && this.model.categorizeSettings.enable) {
                this._renderCategorizeTemplate();
                this._categorizeMultipleTemplate = $.templates(categorizeMultipleTemplate());
            }
        },

        _setNewStartEndHours: function () {
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                if (this.model.orientation == "horizontal") {
                    this.aTR.children().remove();
                    this._renderHeaderAllDayTemplate();
                }
                this.wTR.children().remove();
                this._renderContentAreaTemplate();
                this._borderAddRemove();
                if (this.model.orientation == "horizontal") this._horizontalRender();
                this._renderScroller();
                this.element.find(".e-ampmdisplay").height(this.element.find(".e-workcells").height());
                (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").addClass("e-businesshighlightworkcells");
                this._businessHourScroller();
                if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                this._renderAppointmentAll();
                if (this.model.blockoutSettings.enable) {
                    (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
                }
            }
        },

        _renderInitSchedule: function () {
            this.element.addClass("e-scheduleouter");
            this._screenOrientation = window.orientation;
            this._quickWindow = this.model.showQuickWindow;
            var hasScrollbar = (typeof window.innerWidth === 'number') && window.innerWidth > document.documentElement.clientWidth;
            this._mediaQuery = (this._browserInfo.name == "msie" && parseInt(this._browserInfo.version, 10) <= 8) ? false : ((document.documentElement.clientWidth + (hasScrollbar ? 17 : 0) < 361 || ej.isMobile()) && this.model.isResponsive);
            (this._mediaQuery) ? this.element.addClass("e-scheduleresponsive") : this.element.removeClass("e-scheduleresponsive");
            (this._mediaQuery) && (this.model.showQuickWindow = false);
            (ej.isNullOrUndefined(this._clientWidth)) && (this._clientWidth = this.model.width);
            this.currentView(this.currentView().toLowerCase());
            this.model.views = (this.model.views.length == 0) ? this.currentView().toString().toLowerCase().split(",") : this.model.views.toString().toLowerCase().split(",");
            this.model.workWeek = (this.model.workWeek == "" || this.model.workWeek == null) ? this._dayNamesArray : this.model.workWeek;
            this._resWorkWeek = (this.model.orientation == "vertical" && this.model.showWeekend && this.currentView() == "workweek" && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]));
            if (this.model.endHour > 24) this.model.endHour = 24;
            if (this.model.startHour < 0) this.model.startHour = 0;
            var culture = ej.preferredCulture(this.model.locale);
            this._timeMode = (this.model.timeMode == null) ? (culture.calendar.AM == null && culture.calendar.PM == null) ? "24" : "12" : this.model.timeMode == "Hour12" ? "12" : this.model.timeMode == "Hour24" ? "24" : this.model.timeMode;
            if (this.model.timeMode == null) { this._pattern = culture.calendar.patterns; }
            else this._pattern.t = (this._timeMode == "12") ? "h:mm tt" : "HH:mm";
            this._firstdayofweek = (this.model.firstDayOfWeek != null) ? (typeof this.model.firstDayOfWeek == "string") ? this._dayNamesArray.indexOf(this.model.firstDayOfWeek.toString().toLowerCase()) : this.model.firstDayOfWeek : culture.calendar.firstDay;
            this.model.workWeek = this.model.workWeek.toString().toLowerCase().split(",");
            this.model.width = this.model.width ? this.element.width(this._clientWidth).width() : this.element.width();
            this.model.height = this.model.height ? this.element.height(this.model.height).height() : this.element.height();
            this.scWidth = this._scWidth ? parseInt(this._scWidth) : parseInt(this.model.width);
            this.scHeight = this._scHeight ? parseInt(this._scHeight) : parseInt(this.model.height);
            (this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate);
            (this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate);
            this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) == -1 && this.currentView(this.model.views[0].toLowerCase());
            this._getRenderDates();
            this.element.css({ width: this._clientWidth, height: this.model.height }).attr({ role: "presentation", tabIndex: 1 });
            var orientationClass = (this.model.orientation == "vertical") ? "e-vertical" : "e-horizontal";
            var $scheduleDiv = ej.buildTag('div.e-scheduleinner ' + orientationClass, "", {}, { height: this.scHeight, width: this.scWidth }).css({ height: this.scHeight - 2 + "px", position: "relative" });
            var $scheduleTable = ej.buildTag('table.e-table', "", {}, { cellpadding: "0px", cellspacing: "0px" }).addClass("e-scheduleoutertable");
            var $tBody = ej.buildTag('tbody');
            this.hTR = ej.buildTag("tr.e-scheduleheader");
            this.aTR = ej.buildTag("tr.e-headerarearow");
            this.wTR = ej.buildTag("tr.e-contentarearow");
            (!this.model.cellHeight) ? this.wTR.addClass("e-celldefaultheight") : this.wTR.removeClass("e-celldefaultheight");
            this._renderTemplates();
            this.model.showHeaderBar && this._renderHeaderBar(this.hTR);
            this._renderHeaderAllDayTemplate();
            this._renderContentAreaTemplate();
            $scheduleDiv.append($scheduleTable.append($tBody.append(this.hTR).append(this.aTR).append(this.wTR)));
            (this._mediaQuery && this.res1.length > 1) && this.element.addClass("e-resources");
            this._renderToolTip();
            this.element.append($scheduleDiv);
            !this.model.showHeaderBar && this.element.find(".e-scheduleheader").hide();
            if (this.model.showHeaderBar) {
                this.hTR.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview");
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ startDay: this._firstdayofweek, enableRTL: this.model.enableRTL, buttonText: this._getLocalizedLabels("Today"), select: $.proxy(this._onselect, this), locale: this.model.locale, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
                this.element.find("span.e-datewidget").css("display", "none");
            }
            (this._mediaQuery || this.element.width() < 600) && this._renderNavigationDrawer();
            this._showContextMenu(this.model.contextMenuSettings.enable);
            var scheduleResponsive = $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper,#" + this._id + "navDrawer,#" + this._id + "alertWindow_wrapper");
            (this._mediaQuery) ? scheduleResponsive.addClass("e-scheduleresponsive") : scheduleResponsive.removeClass("e-scheduleresponsive");
            if (this._mediaQuery) this._phoneChanges();
            if (this.model.enableRTL && this._browserInfo.name == "webkit" && !ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".e-chk-image").css("margin-right", "-13px");
            this._renderCommon();
        },

        _renderToolTip: function () {
            var proxy = this;
            if (ej.isNullOrUndefined(this.element.data("ejTooltip"))) {
                var target = this.model.tooltipSettings.enable ? ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendacells.e-eventcolumn,.e-appup,.e-appdown,.e-appsoverflow" : ".e-appup,.e-appdown,.e-appsoverflow";
                this.element.ejTooltip({
                    target: target,
                    associate: "mousefollow",
                    isBalloon: false,
                    beforeOpen: function (args) {
                        if (!proxy._showToolTip(args)) {
                            args.cancel = true;
                            proxy._openTooltip = false;
                        } else
                            proxy._openTooltip = true;
                    },
                    containment: "#" + this._id,
                    tip: {
                        adjust: {
                            xValue: 20,
                            yValue: 20
                        }
                    },
                    position: {
                        target: { horizontal: "center", vertical: "bottom" },
                        stem: { horizontal: "left", vertical: "top" }
                    },
                    tracking: function (args) {
                        if (!proxy._openTooltip || $(args.event.target).is(".e-tophandle,.e-bottomhandle,.e-schedulemouseclose,.e-righthandle,.e-lefthandle,.e-schedulerepeat,.e-editapp,.e-deleteapp")) {
                            args.cancel = true;
                            this.hide();
                        }
                    }
                });
            }
        },

        _renderQuickWindow: function () {
            if (this.model.showQuickWindow) {
                this._renderQuickAppWindow();
                this._renderQuickAppDetailsView();
            }
        },

        _renderDialogs: function () {
            this._renderQuickWindow();
            this._renderAppointmentWindow();
            this._renderRecurrenceEditor();
            this._renderRecurEditWindow();
            this._renderAlertWindow();
        },

        _renderCommon: function () {
            if (this.currentView() != "agenda") {
                if (this.model.orientation == "vertical") {
                    this._headerbarWidth();
                    (this.currentView() === "month" || (this._isCustomMonthView())) && this._renderMonthTimeCells();
                    if (!this.model.timeScale.enable) {
                        this.element.find(".e-headercells").first("td").css("border-left", "none");
                        this.element.find(".e-workcellstab tr td:first-child").css("border-left", "none");
                    }
                    if (!this.model.showAllDayRow && this.model.cellWidth) {
                        this.element.find(".e-workcellstab tr td:first-child").css({ width: this.element.find(".e-headercells").width() });
                    }
                    this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                    this.element.find(".e-ampmdisplay").css({ height: this.element.find(".e-workcells").height() });
                }
                if (this.currentView() != "agenda" && this.model.orientation == "horizontal" && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0))) {
                    var border = this.model.enableRTL ? 'border-right' : 'border-left';
                    this.element.find(".e-horizontaldaterender").css(border, '0px');
                    this.wTR.find(".e-workareadiv").parent().css(border, '0px');
                    if (!this.model.timeScale.enable && this.currentView() !== "month" && !this._isCustomMonthView()) this.element.find(".e-workcellstab tr td:nth-child(1)").css(border, '0px');
                }
                this.model.enableRTL && this.element.addClass("e-rtl");
                (this.model.timeScale.enable) && this._borderAddRemove();
                this.model.orientation == "vertical" ? (this.currentView() !== "month" && !(this._isCustomMonthView())) ? this.element.find(".e-headercells").addClass("e-dateheaderselect") : "" : this.element.find(".e-headercells").addClass("e-dateheaderselect");
                if (this.model.orientation == "horizontal" && (this.currentView() == "month" || this._isCustomMonthView()) && this.element.find('.e-workcells').width() < this.element.find('.e-dateheadercell').width() && this.model.cellWidth == "")
                    this.model.timeScale.enable ? this.element.find('.e-workcells').css({ width: this.element.find('.e-horizontmonthheaderdaytd').width() }) : this.element.find(".e-headerdays table tr td:nth-child(1)").css({ width: this.element.find('.e-horizontmonthheaderdaytd').width() + 1 });
                if (this.model.orientation == "horizontal" && !this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView() && this.model.cellWidth == "") {
                    this.element.find(".e-horizontmonthheaderdatetd,.e-horizontmonthheaderdaytd").width(this.element.find(".e-workcells").width());
                }
                this.element.find(".e-horizontalresheader").css({ width: (this._mediaQuery) ? "50px" : "100%" });
                this._renderScroller();
                if (this.model.showAppointmentNavigator && this.model.orientation == "vertical" && this.element.find(".e-vscroll").length > 0 && this.currentView() != "month" && (!this._isCustomMonthView()) && (!this._mediaQuery)) this._renderUpDownIcon();
                if (this.model.orientation == "horizontal")
                    this._horizontalRender();
                else {
                    if (!this.model.showOverflowButton && this.currentView() == "month")
                        this._monthCellsRender();
                    else
                        this.currentView() == "month" || (this._isCustomMonthView()) ? this.element.find(".e-monthcells, .e-timecells").outerHeight(this.model.cellHeight ? parseInt(this.model.cellHeight) + 1 : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length)) : this.element.find(".e-ampmdisplay").height((this.model.timeScale.minorSlotCount == 1) ? this.element.find(".e-timecelldivs").height() : this.element.find(".e-workcells").height());
                }
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
                    if (!this.model.timeScale.enable)
                        this.element.find(".e-headercells").removeClass("e-dateheaderselect");
                    if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0)
                        this._horizontalResIcon();
                    if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && this.currentView() != "month" && !this._isCustomMonthView())
                        this.element.find(".e-headercells").parent().parent().parent().css("width", ((this.element.width() * 10) / 100) * this._dateRender.length + "px");
                    this.element.find(".e-parentnodecategory").css({ width: (this._mediaQuery) ? "12px" : "20px" });
                }
                else {
                    if (!ej.isNullOrUndefined(this.model.allDayCellsTemplateId))
                        this.element.find(".e-leftindent").css({ height: this.element.find(".e-alldaycells").height() });
                }
                (this.model.workHours.highlight && this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                if ((!this._resWorkWeek && this._dateRender.length > 60) || ($.isNumeric(this.element.find(".e-monthcells").height()) && (this.element.find(".e-monthcells").height() != this.element.find(".e-timecells").eq(3).height()) && this.model.orientation == "vertical" && this.model.showOverflowButton)) this.element.find('td.e-timecells .e-timecelldivs').addClass('e-timedivcells');
                (this.model.orientation == "horizontal" && this._safariBrowser) && this.element.find(".e-workcells.e-dayend").width(this.element.find(".e-workcells.e-dayend").outerWidth() + 1);
                if (this._browserInfo.name == "msie" && this._browserInfo.version < 9 && this.model.orientation == "vertical") {
                    this.element.find(".e-workleftindent").find("tr").last().find("td").addClass("e-lastcell");
                    this.element.find(".e-workcellstab").find("tr").last().find("td").addClass("e-lastcell");
                }
            }
            this._validateMinMaxDate();
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("emptycell");
            this._businessHourScroller();
        },

        _resourceSegregate: function () {
            var resourceFields = ""; this._tempResource = []; this._grouping = [];
            if (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) {
                for (var i = 0; i < this.model.group.resources.length; i++) {
                    index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i]);
                    if (!ej.isNullOrUndefined(index)) {
                        if (this.model.resources.length != 0 && this.model.resources[index].resourceSettings.dataSource.length != 0) {
                            this._tempResource.push(this.model.resources[index]);
                            this._grouping.push(this.model.group.resources[i]);
                            if (i == this.model.group.resources.length - 1)
                                resourceFields = resourceFields + this.model.resources[index].field;
                            else
                                resourceFields = resourceFields + this.model.resources[index].field + ",";
                        }
                        else
                            return false;
                    }
                }
                this._appointmentSettings.resourceFields = resourceFields;
            }
            else if (ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) {
                $.merge(this._tempResource, this.model.resources);
            }
        },
        _borderAddRemove: function () {
            if (!this.model.enableRTL) {
                this.element.find(".e-headrealldaytable tr td:first-child,.e-workcellstab tr td:first-child,.e-headerdays table tr td:first-child").css("border-left", "none");
                this.element.find(".e-horizontalheader,.e-horizontalrestd,.e-monthleftindent,.e-workleftindent,.e-empty").addClass("e-borderright");
            }
            else {
                this.element.find(".e-headrealldaytable tr td:first-child,.e-workcellstab tr td:first-child,.e-headerdays table tr td:first-child").css("border-right", "none");
                this.element.find(".e-horizontalheader,.e-horizontalrestd,.e-monthleftindent,.e-workleftindent,.e-empty").addClass("e-borderleft");
            }
            if (this.model.orientation == "horizontal") {
                if (this.currentView() == "month")
                    this.element.find(".e-headerdays table tr td:first-child").width(this.element.find(".e-workcellstab tr td:first-child").width());
                else if (this._browserInfo.name == "webkit")
                    this.element.find(".e-workcellstab tr td:first-child").width(this.element.find(".e-horizontaltimetd").first().width());
            }
            else {
                if (this.model.cellWidth != "")
                    this.element.find(".e-workcellstab tr td:first-child").width(this.element.find(".e-headercells").first().width());
                this._safariBrowser && (this.currentView() == "month" ? this.element.find(".e-monthleftindent").width(this.element.find(".e-monthempty").width() + 1) : this.element.find(".e-workleftindent").attr('style', "width:" + (this.element.find(".e-empty").width() + 1) + "px !important"));
            }
            if (!ej.isNullOrUndefined(this.oldDate) && this.oldDate != "") {
                this.currentDate(new Date(this.oldDate));
                this.oldDate = "";
            }
        },
        _phoneChanges: function () {
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                this._appointmentAddWindow.ejDialog({
                    allowDraggable: false,
                    position: { X: "0", Y: "0" }
                });
            }
        },
        _dateConvert: function (dtstr) {
            if (!ej.isNullOrUndefined(dtstr)) {
                var convdt = new Date(parseInt(dtstr.match(/\d+/).toString()));
                convdt = $.type(convdt) == "date" ? convdt : new Date();
            }
            else
                convdt = null;
            return convdt;
        },
        _calculateCustomDays: function () {
            var startdate = $.type(this.model.renderDates.start) != "date" ? ej.parseDate(this.model.renderDates.start, this._datepattern()) : new Date(this.model.renderDates.start);
            startdate = (!ej.isNullOrUndefined(startdate)) ? startdate : ((new Date(this.model.renderDates.start).toString() == "Invalid Date" || new Date(this.model.renderDates.start).toString() == "NaN") ? this._dateConvert(this.model.renderDates.start) : new Date(this.model.renderDates.start));
            var enddate = $.type(this.model.renderDates.end) != "date" ? ej.parseDate(this.model.renderDates.end, this._datepattern()) : new Date(this.model.renderDates.end);
            enddate = (!ej.isNullOrUndefined(enddate)) ? enddate : ((new Date(this.model.renderDates.end).toString() == "Invalid Date" || new Date(this.model.renderDates.end).toString() == "NaN") ? this._dateConvert(this.model.renderDates.end) : new Date(this.model.renderDates.end));;
            if (!ej.isNullOrUndefined(this.model.minDate) && !ej.isNullOrUndefined(this.model.maxDate)) {
                startdate = (this.model.minDate >= startdate && this.model.maxDate <= startdate) ? startdate : (this.model.minDate >= startdate && this.model.maxDate >= startdate) ? this.model.minDate : (this.model.maxDate <= startdate) ? this.model.minDate : startdate;
                enddate = (this.model.minDate >= enddate && this.model.maxDate <= enddate) ? enddate : (this.model.minDate <= enddate && this.model.maxDate <= enddate) ? this.model.maxDate : (this.model.minDate >= enddate) ? this.model.maxDate : enddate;
            }
            this._renderStart = !ej.isNullOrUndefined(startdate) ? new Date(startdate.getFullYear(), startdate.getMonth(), startdate.getDate()) : enddate;
            this._renderEnd = !ej.isNullOrUndefined(enddate) ? new Date(enddate.getFullYear(), enddate.getMonth(), enddate.getDate()) : startdate;
            this._renderDays = Math.round((this._renderEnd - this._renderStart) / (1000 * 60 * 60 * 24)) + 1;
            this.oldDate = this.currentDate();
            if (this._dateNavigation || (this._renderStart.getTime() > this.currentDate().getTime()) || (this._renderEnd.getTime() < this.currentDate().getTime())) {
                this._renderStart = new Date(this.currentDate());
                this._renderEnd = new Date(this._renderStart.getTime() + (1000 * 60 * 60 * 24 * (this._renderDays - 1)));
                this._dateNavigation = false;
            }
            else
                this.currentDate(new Date(this._renderStart));
            if (this._renderDays > 7) {
                var firstDay = this.model.orientation == "vertical" ? new Date(this._firstweekdate(this._renderStart)) : new Date(this._renderStart);
                var endDay = new Date(this._renderEnd); var day = endDay.getDay();
                (this._firstdayofweek == 0 && day != 6) ? endDay.setDate(new Date(this._renderEnd).getDate() + (6 - day)) : endDay.setDate(new Date(this._renderEnd).getDate() + (6 - day) + this._firstdayofweek);
                endDay = this.model.orientation == "vertical" ? endDay : new Date(this._renderEnd);
                this._numDays = Math.round((endDay - firstDay) / (1000 * 60 * 60 * 24)) + 1;
            }
            return this;
        },

        _isCustomMonthView: function () {
            if (this.currentView() == "customview") {
                this._oneWeek = (this._dateRender.length > 7) ? false : true;
                return !this._oneWeek;
            }
            return false;
        },

        _headerbarWidth: function () {
            if (this.element.children().length == 0) return false;
            var cols = this.currentView() == "workweek" ? this.model.workWeek.length : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 7;
            var col = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? (this.res1.length * cols) : cols;
            var border = this.element.outerWidth() - (this.element.find('.e-draggableworkarea').offset().left - this.element.offset().left) < parseInt(this.model.cellWidth) * col ? 1 : 0;
            if (this._browserInfo.name == "webkit")
                this.aTR.find(".e-headrealldaytable").width(this.model.cellWidth ? (parseInt(this.model.cellWidth) * col + (border ? 0 : col)) : "100%");
            else
                this.aTR.find(".e-headrealldaytable").width(this.model.cellWidth ? (parseInt(this.model.cellWidth) * col) + col : "100%");
        },

        _renderScroller: function () {
            if (this.element.children().length == 0) return false;
            var _scrollDiv = this.element.find("div#" + this._id + "_scroller");
            var hghtdiff = this.scHeight - (this.element.find(".e-draggableworkarea").offset().top - this.element.offset().top);
            var proxy = this;
            var scrollWidth = (this.model.orientation === "vertical") ? this.element.width() - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() - 1 : this.element.width();
            _scrollDiv.ejScroller({
                enableRTL: this.model.enableRTL, height: (hghtdiff - 1), width: parseInt(scrollWidth) - 2, cssClass: this.model.cssClass,
                thumbStart: function (e) {
                    var target = $(e.originalEvent.target);
                    if ((!proxy._mediaQuery) && target.closest(".e-workcells").hasClass("e-workcells") || target.closest(".e-appointment").hasClass("e-appointment") || target.closest(".e-monthappointment").hasClass("e-monthappointment") || target.closest(".e-categorybar").hasClass("e-categorybar")) return false;
                },
                scroll: function (e) {
                    !ej.isNullOrUndefined(e.scrollTop) && (e.scrollTop = parseInt(e.scrollTop));
                    var scrollerObj = proxy.element.find('div#' + proxy._id + "_scroller").data("ejScroller");
                    if ((scrollerObj.isVScroll()) || (scrollerObj.isHScroll())) {
                        (proxy.model.orientation === "vertical") ? proxy.element.find(".e-scrolltimecells").css("top", (-e.scrollTop) + "px") : (proxy.model.timeScale.enable && proxy.currentView() !== "month" && !(proxy._isCustomMonthView())) ? $(proxy.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-e.scrollLeft) + "px") : proxy.element.find(".e-headerdays").css("left", (-e.scrollLeft) + "px");
                        if (proxy.element.find('.e-vhandle').length == 1)
                            proxy.element.find(".e-horires").css("top", (-e.scrollTop) + "px");
                        if (proxy.model.orientation == "vertical") {
                            proxy.element.find(".e-headrealldaytable").css("left", (proxy.model.enableRTL) ? (e.scrollData.scrollable - e.scrollLeft) : (-e.scrollLeft) + "px");
                            var timeWidth = proxy.element.find(".e-scrolltimecells").width() - 3;
                            proxy.element.find(".e-upicon, .e-downicon").css("left", -(e.scrollLeft - timeWidth) + "px");
                            if (proxy._timeMode == "12" && (proxy.currentView() !== "month" && !(proxy._isCustomMonthView()))) {
                                var top = (e.scrollTop / (proxy.element.find(".e-workcells").height() * proxy.model.timeScale.minorSlotCount));
                                top = (Math.round(top) < top) ? Math.round(top) + 1 : Math.round(top);
                                var localizeAmPm = ej.preferredCulture(proxy.model.locale).calendar;
                                if (localizeAmPm.AM && localizeAmPm.PM) {
                                    proxy.element.find('.e-idAmpmstyle').each(function (i, val) {
                                        if (i == (top) && $(val).text().trim() == "00")
                                            (parseInt($(val)[0].id) < 12) ? $(val).text(localizeAmPm.AM[0]) : $(val).text(localizeAmPm.PM[0]);
                                        else if (($(val).text() == localizeAmPm.AM[0] && i > 0) || ($(val).text() == localizeAmPm.PM[0] && parseInt($(val)[0].id) > 12))
                                            $(val).text("00");
                                    });
                                }
                            }
                            if (proxy._mediaQuery) {
                                proxy.element.find(".e-headrealldaytable").css("left", "0px");
                            }
                            if (proxy.model.showAppointmentNavigator && proxy.model.orientation == "vertical" && scrollerObj.isVScroll() && proxy.currentView() != "month" && (!proxy._isCustomMonthView()) && (!proxy._mediaQuery)) {
                                proxy._renderUpDownIcon();
                                proxy._renderUpDownIconPosition();
                            }
                        }
                        else if (ej.scheduleFeatures.horizontal && proxy.model.orientation == "horizontal")
                            proxy._horizontalScroll(e, proxy);
                    }
                    if (!(ej.isNullOrUndefined(proxy._quickAppointWindow)) && proxy.model.showQuickWindow && !proxy._isQuickDialogOpened) {
                        proxy._isQuickDialogOpened = false;
                        proxy._quickAppointWindow.ejDialog("close");
                        proxy._quickAppDetailsWindow.ejDialog("close");
                    }
                }
            });
            (!this._mediaQuery) && this._nextPrevAppointment(this.model.showAppointmentNavigator);
            this._renderHoriVerticalScroll();
            this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
            this._showScrollTd();
        },

        _showScrollTd: function () {
            var border = this.model.enableRTL ? "e-borderright" : "e-borderleft";
            var tdwidth = this.model.orientation == "horizontal" ? "16px" : "17px";
            if (this.model.orientation == "horizontal") {
                if (this.element.find(".e-vscroll").length > 0) {
                    this.element.find(".e-scheduleheader td").first().attr("colspan", "3");
                    this.element.find(".e-workareadiv").parent().attr("colspan", "2");
                    if (this.element.find(".e-emptyscrolltd").length == 0)
                        this.aTR.append(ej.buildTag("td.e-emptyscrolltd", "", {}, { width: this._mediaQuery ? "0px" : "16px" }));
                    this.element.find(".e-emptyscrolltd").addClass("e-horizontalemptytd");
                }
                else {
                    this.element.find(".e-scheduleheader td").first().attr("colspan", "2");
                    this.element.find(".e-workareadiv").parent().attr("colspan", "2");
                }
            }
            this.element.find(".e-vscroll").length > 0 ? this.element.find(".e-emptyscrolltd").addClass(border).attr("width", tdwidth).show() : this.element.find(".e-emptyscrolltd").removeClass(border).attr("width", "0px").hide();
        },
        _renderHoriVerticalScroll: function () {
            var _scrollDiv = this.element.find("div#" + this._id + "_scroller");
            var scrollWidth = (this.model.orientation === "vertical") ? this.element.width() - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find(".e-scrolltimecells").length > 0 ? this.element.find(".e-scrolltimecells").parent().outerWidth() : 0)) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : this.element.width();
            scrollWidth = parseInt(scrollWidth) - 1;
            var hghtdiff = parseInt(this.scHeight) - (this.element.find(".e-draggableworkarea").offset().top - this.element.offset().top);
            var vScrollBarWidth = _scrollDiv.ejScroller("isVScroll") ? 18 : 0, hScrollBarWidth = _scrollDiv.ejScroller("isHScroll") ? 18 : 0;
            if (this.model.orientation == "vertical") {
                if (this.model.cellWidth || this.model.cellHeight) {
                    (this.currentView() == "day") && this.element.find(".e-headerdaydisplay").css("width", this.model.cellWidth);
                    var overallWidth = (parseInt(this.model.cellWidth) + 1) * (this.element.find("div.e-draggableworkarea tr:first td").length);
                    var overallHeight = parseInt(this.model.cellHeight) * (this.element.find("div.e-draggableworkarea tr").length);
                    var timeScaleWidth = this.element.find(".e-scrolltimecells").length > 0 ? this.element.find(".e-scrolltimecells").width() : 0;
                    this.element.find(".e-draggableworkarea").width((this.element.width() > overallWidth + timeScaleWidth + vScrollBarWidth) ? overallWidth - 1 : scrollWidth - 1 - vScrollBarWidth);
                    (!this.model.cellHeight) ? this.element.find(".e-draggableworkarea").height(hghtdiff - 1 - hScrollBarWidth) : this.element.find(".e-draggableworkarea").height(hghtdiff > overallHeight ? overallHeight : hghtdiff - 1 - hScrollBarWidth);
                    (this.model.cellWidth) && this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
					if (this.currentView() != "month" && !this._isCustomMonthView()) {
						this.element.find(".e-workcells,.e-headercells").css("width", this.model.cellWidth);
						this.element.find(".e-headrealldaytable").css("width", overallWidth - 1);
					}
                }
                else {
                    this.element.find(".e-draggableworkarea").height(hghtdiff - 1);
                    if (!this.model.showOverflowButton && (this.currentView() == "month" || this._isCustomMonthView())) this._monthCellsRender();
                    this.element.find(".e-draggableworkarea").width(scrollWidth - 1 - vScrollBarWidth);
                }
                if (this._mediaQuery && this.res1.length > 1) {
                    this.element.find(".e-draggableworkarea").width(this.element.find(".e-draggableworkarea").width() * this.res1.length);
                    this.element.find(".e-headrealldaytable").width(this.element.find(".e-draggableworkarea").width());
                }
                this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
                this.element.find(".e-scrolltimecells").height(this.element.find('.e-workcellstab').height());
                if (this.model.timeScale.enable && (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId))) {
                    this.element.find(".e-scrolltimecells tr").height(this.element.find(".e-workcells,.e-monthcells").outerHeight());
                }
                if (this.model.timeScale.enable && this._mediaQuery && this.currentView() != "month") {
                    this.element.find(".e-ampmstyle").css({ minHeight: this.element.find(".e-workcells").height() + "px" });
                }
            }
            else {
                !(_scrollDiv.ejScroller("isHScroll")) ? this.element.find(".e-draggableworkarea").css("height", "100%") && this.element.find(".e-resfootertr").css("height", "0px") : "";
                !(_scrollDiv.ejScroller("isVScroll")) ? this.element.find(".e-draggableworkarea").css("height", hghtdiff - 19) : "";
                if (this._mediaQuery) {
                    this.element.find(".e-horizontresdiv").height(_scrollDiv.height());
                    this.element.find(".e-draggableworkarea").children().height("100%");
                    this.element.find(".e-horires").height(this.element.find(".e-draggableworkarea").height());
                    this.element.find(".e-horires").children().height("100%");
                }
                if (this.model.cellWidth || this.model.cellHeight) {
                    var count = $(this.element.find(".e-workcells")[0]).parent().find("td").length;
                    !(_scrollDiv.ejScroller("isHScroll")) ? this.element.find(".e-draggableworkarea").width((parseInt(this.model.cellWidth) * count) + count) : "";
                    (this.currentView() == "month" || (this._isCustomMonthView()) || !this.model.timeScale.enable) && this.element.find(".e-headerdays").children().css("width", (this.element.find(".e-draggableworkarea").children().width() + "px")).css("table-layout", "auto");
                    (this.model.cellHeight && !this._tempResource) && this.element.find('.e-draggableworkarea').height(parseInt(this.model.cellHeight) - 1);
                }
                if (this.currentView() == "month" || this._isCustomMonthView()) {
                    var eWidth = this.element.find(".e-workcellstab tr td:first-child").width();
                    this.element.find(".e-headerdays table tr td:first-child").width(this.model.timeScale.enable ? eWidth : eWidth + 1);
                }
                //Temp if scroll left issue fixed need to remove
                this.currentView() == "day" && this.model.timeScale.enable && $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
                this.element.find('.e-horizontaltabletimecell').width(this.element.find('.e-workcellstab').width());
                if (this.model.timeScale.enable && !_scrollDiv.ejScroller("isHScroll") && this.currentView() != "month" && !this._isCustomMonthView()) {
                    var width = Math.floor(this.element.find(".e-draggableworkarea").width() / $(this.element.find(".e-workcells")[0]).parent().find("td").length);
                    this.element.find(".e-workcells").width(width);
                    this.element.find(".e-horizontaltabletimecell").find("tr td").width(width);
                    this.element.find(".e-horizontaltabletimecell").css("table-layout", "fixed").width(this.element.find('.e-draggableworkarea').width());
                    _scrollDiv.ejScroller("refresh");
                }
                if (!this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView()) {
                    if (!this.model.cellWidth && this._browserInfo.name != "webkit") {
                        this.element.find(".e-dateheadercell").width(this.element.find(".e-workcells").width());
                        this.element.find(".e-workcells").width(this.element.find(".e-horizontmonthheaderdaytd").width());
                    }
                    else if (this._browserInfo.name == "webkit" && this.currentView() != "month") {
                        (this.model.cellWidth) && this.element.find(".e-headerdays").width(this.model.cellWidth);
                        this.element.find(".e-workcells").width(this.element.find(".e-draggableworkarea").width / this._dateRender.length);
                        this.element.find(".e-dateheadercell").width(this.element.find(".e-workcells").width());
                        this.element.find(".e-headerdays table tr td:not(:first-child)").find(".e-dateheadercell").width(this.element.find(".e-workcells").width() - 1);
                        this.element.find(".e-workcells").width(this.element.find(".e-workcells").width());
                    }
                }
            }
            //if (this.model.timeScale.enable && this._isCustomMonthView()) this.element.find(".e-timecells").children().height(this.element.find(".e-workcells,.e-monthcells").height());
        },

        _getDayNameIndex: function (day) {
            var dayNames = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
            var cultureNames = [], index = this._firstdayofweek;
            do {
                if (index > 6) index = 0;
                cultureNames.push(dayNames[index]);
                index++;
            } while (cultureNames.length < 7)
            return cultureNames.indexOf(day.capitalizeFirstString());
        },

        _highlightBusinessHours: function () {
            if (this.currentView() == "agenda") return false;
            var resource = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? ((!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"])) || (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["start"]) || !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["end"]))) : false;
            if (resource) {
                this.element.find(".e-workcells, .e-monthcells").removeClass("e-businesshighlightworkcells e-monthcellhighlight");
                var renderDates, startHour, endHour, resStartHour, resEndHour, noOfHours, startIndex, endIndex, tdLength, colCount, customDays, dayIndex, index, rowFirst, rowLast, dayCount = 0, dateCount = [];;
                var target = this.element.find(".e-workcellstab tr");
                var resources = (this.model.orientation == "horizontal" && this._grouping.length > 1) ? this._resourceSort() : this.res1;
                if (this.model.orientation == "vertical") {
                    for (var i = 0; i < resources.length; i++) {
                        if (!ej.isNullOrUndefined(resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                            customDays = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                        else
                            customDays = this.model.workWeek;
                        if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                            renderDates = this.dateRender;
                            if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["start"]) || !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["end"])) {
                                resStartHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["start"]];
                                resEndHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["end"]];
                                startHour = !ej.isNullOrUndefined(resStartHour) ? (resStartHour >= this.model.startHour) ? resStartHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour;
                                endHour = !ej.isNullOrUndefined(resEndHour) ? (resEndHour <= this.model.endHour) ? resEndHour : (this.model.workHours.end <= this.model.endHour) ? this.model.endHour : this.model.workHours.end : (this.model.workHours.end <= this.model.endHour) ? this.model.workHours.end : this.model.endHour;
                            }
                            else {
                                startHour = this.model.workHours.start >= this.model.startHour ? this.model.workHours.start - this.model.startHour : 0;
                                endHour = this.model.workHours.end <= this.model.endHour ? this.model.workHours.end - this.model.startHour : this.model.endHour - this.model.startHour;
                            }
                            noOfHours = this.model.endHour - this.model.startHour;
                            startIndex = Math.floor((target.length / noOfHours) * startHour) - (this.model.startHour * this.model.timeScale.minorSlotCount);
                            endIndex = Math.floor((target.length / noOfHours) * endHour) - (this.model.startHour * this.model.timeScale.minorSlotCount);
                            colCount = this.currentView() === "week" ? (this.model.showWeekend) ? 7 : customDays.length : this.currentView() === "workweek" ? customDays.length : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 1;
                            for (var a = startIndex; a < endIndex; a++) {
                                for (var b = dayCount; b < (dayCount + colCount) ; b++) {
                                    for (var c = 0; c < customDays.length; c++) {
                                        dayIndex = this._dayNamesArray.indexOf(customDays[c]);
                                        if (dayIndex == -1) {
                                            dayIndex = this._getDayNameIndex(customDays[c]);
                                        }
                                        if (dayIndex == new Date(renderDates[b]).getDay()) {
                                            $($(target[a]).children()[b]).addClass("e-businesshighlightworkcells");
                                        }
                                    }
                                }
                            }
                            dayCount += colCount;
                        }
                        else {
                            if (this._resWorkWeek) {
                                for (var a = 0; a < customDays.length; a++) {
                                    index = this._dayFullNames.indexOf(customDays[a].capitalizeFirstString());
                                    if (index == -1) {
                                        index = this._getDayNameIndex(customDays[a]);
                                    }
                                    dateCount.push(this._renderDates[index]);
                                }
                                renderDates = dateCount;
                            }
                            else renderDates = (this.currentView() != "month" && !this._isCustomMonthView()) ? this.dateRender : this._dateRender;
                            colCount = (this._resWorkWeek) ? customDays.length : (this.currentView() == "day") ? 1 : 7;
                            rowFirst = (this.currentView() != "month" && !this._isCustomMonthView()) ? dayCount : (i * 7);
                            rowLast = (this.currentView() != "month" && !this._isCustomMonthView()) ? (dayCount + colCount) : ((i + 1) * 7);
                            for (var a = 0; a < target.length; a++) {
                                for (var b = rowFirst; b < rowLast; b++) {
                                    for (var c = 0; c < customDays.length; c++) {
                                        dayIndex = this._dayNamesArray.indexOf(customDays[c]);
                                        if (dayIndex == -1) {
                                            dayIndex = this._getDayNameIndex(customDays[c]);
                                        }
                                        if (dayIndex == new Date(renderDates[b]).getDay()) {
                                            !$($(target[a]).children()[b]).hasClass("e-othermonths") ? $($(target[a]).children()[b]).addClass("e-monthcellhighlight") : $($(target[a]).children()[b]).removeClass("e-monthcellhighlight");
                                        }
                                    }
                                }
                            }
                            dayCount += colCount;
                        }
                    }
                }
                else {
                    if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                        renderDates = this._dateRender;
                        for (var i = 0; i < resources.length; i++) {
                            if (resources[i].classname != "e-parentnode") {
                                resStartHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["start"]];
                                resEndHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["end"]];
                                startHour = !ej.isNullOrUndefined(resStartHour) ? (resStartHour >= this.model.startHour) ? resStartHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour;
                                endHour = !ej.isNullOrUndefined(resEndHour) ? (resEndHour <= this.model.endHour) ? resEndHour : (this.model.workHours.end <= this.model.endHour) ? this.model.endHour : this.model.workHours.end : (this.model.workHours.end <= this.model.endHour) ? this.model.workHours.end : this.model.endHour;
                                noOfHours = this.model.endHour - this.model.startHour;
                                tdLength = $(target[i]).children().length / renderDates.length;
                                startIndex = Math.floor((tdLength / noOfHours) * startHour);
                                endIndex = Math.floor((tdLength / noOfHours) * endHour);
                                for (var a = 0; a < renderDates.length; a++) {
                                    for (var b = 0; b < this.model.workWeek.length; b++) {
                                        dayIndex = this._dayNamesArray.indexOf(this.model.workWeek[b]);
                                        if (dayIndex == -1) {
                                            dayIndex = this._getDayNameIndex(this.model.workWeek[b]);
                                        }
                                        if (dayIndex == new Date(renderDates[a]).getDay()) {
                                            for (var c = ((tdLength * a) + startIndex) ; c < ((tdLength * a) + endIndex) ; c++) {
                                                $($(target[i]).children()[c]).addClass("e-businesshighlightworkcells");
                                                if (this._grouping.length > 1) {
                                                    var resIndex = i;
                                                    var index = this._tempResource.length - 1;
                                                    do {
                                                        var resParent = new ej.DataManager(this._tempResource[index - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[index - 1].resourceSettings["id"], ej.FilterOperators.equal, resources[resIndex][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]));
                                                        if (!ej.isNullOrUndefined(resParent)) {
                                                            resIndex = resources.indexOf(resParent[0]);
                                                            $($(target[resIndex]).children()[c]).addClass("e-businesshighlightworkcells");
                                                        }
                                                        index -= 1;
                                                    } while (index > 0)
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                        this._horizontalBusinessHighlight(null, null, null, null, null);
                }
            }
            else if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                var renderDates = this.dateRender;
                var target = this.element.find(".e-workcells");
                var b_startHour = this.model.workHours.start >= this.model.startHour ? this.model.workHours.start - this.model.startHour : 0;
                var b_endHour = this.model.workHours.end <= this.model.endHour ? this.model.workHours.end - this.model.startHour : this.model.endHour - this.model.startHour;
                var timeRowsCount = (60 / this.model.timeScale.majorSlot) * (this.model.timeScale.minorSlotCount);
                this.res1 = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.res1 : [0];
                var colCount = this.currentView() === "week" ? (this.model.showWeekend) ? 7 * this.res1.length : this.model.workWeek.length * this.res1.length : this.currentView() === "workweek" ? this.model.workWeek.length * this.res1.length : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length * this.res1.length : 1 * this.res1.length;
                if (this.model.orientation == "vertical") {
                    for (var i = (b_startHour * timeRowsCount) ; i < (b_endHour * timeRowsCount) ; i++) {
                        for (var j = 0; j < colCount; j++) {
                            for (var k = 0; k < this.model.workWeek.length; k++) {
                                if (this._dayNamesArray.indexOf(this.model.workWeek[k]) == new Date(renderDates[j]).getDay())
                                    $(target[(i * colCount) + j]).addClass("e-businesshighlightworkcells");
                            }
                        }
                    }
                }
                else
                    this._horizontalBusinessHighlight(this._dateRender, b_startHour, b_endHour, timeRowsCount, target);
            }
            else {
                var target, monthDays;
                if (this.model.orientation == "vertical") {
                    monthDays = this.dateRender;
                    target = this.element.find(".e-monthcells");
                    target.removeClass("e-monthcellhighlight");
                    for (var i = 0; i < monthDays.length; i++) {
                        for (var j = 0; j < this.model.workWeek.length; j++) {
                            if (this._dayNamesArray.indexOf(this.model.workWeek[j]) == new Date(monthDays[i]).getDay())
                                !$(target[i]).hasClass("e-othermonths") ? $(target[i]).addClass("e-monthcellhighlight") : $(target[i]).removeClass("e-monthcellhighlight");
                        }
                    }
                }
                else
                    this._horizontalBusinessHighlight(null, null, null, null, null);
            }
        },

        _onselect: function (e) {
            this._navigateClick(e, "DateNavigation");
        },

        _renderHeaderBar: function (hTR) {
            var colsVal = this.model.orientation == "vertical" ? 1 : 3;
            var hTD = ej.buildTag('td', "", {}, { colspan: colsVal });
            var commonDiv = ej.buildTag('div.e-datecommondiv').append(ej.buildTag('div.e-icon e-navigateprevious', "", {}, { title: this._getLocalizedLabels("Previous") })).append(ej.buildTag('div', "", {}, { "aria-live": "assertive", tabindex: 0 }).html(this._getCurrentDateHeaderValue()).addClass("e-datedisplay")).append(ej.buildTag("input#" + this._id + "_navigator").css("display", "none").addClass("dateCalendar")).append(ej.buildTag('div.e-icon e-navigatenext', "", {}, { title: this._getLocalizedLabels("Next") }));
            if (this._mediaQuery || this.element.width() < 600) {
                this._mediaQuery && (commonDiv = ej.buildTag('div.e-datecommondiv').append(ej.buildTag('div.e-icon e-navigateprevious', "", {}, { title: this._getLocalizedLabels("Previous") })).append(ej.buildTag('div.e-icon e-navigatenext', "", {}, { title: this._getLocalizedLabels("Next") })).append(ej.buildTag('div', "", {}, { "aria-live": "assertive", tabindex: 0 }).html(this._getCurrentDateHeaderValue()).addClass("e-datedisplay")).append(ej.buildTag("input#" + this._id + "_navigator").css("display", "none").addClass("dateCalendar")));
                var menuIcon = ej.buildTag('div#' + this._id + 'navDrawerIcon.e-mobileNavigation e-icon');
                hTR.append(hTD.append(ej.buildTag("div").css("width", "100%").append(commonDiv).append(menuIcon)));
            }
            else {
                var buttonsDiv = ej.buildTag('div.e-viewsdiv');
                hTR.append(hTD.append(ej.buildTag("div").css("width", "100%").append(commonDiv).append(buttonsDiv.append(this._renderViewNavigation(this.model.views)))));
            }
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderHeaderBar", "", hTR);
        },

        _renderViewNavigation: function (views) {
            var $viewTable = ej.buildTag('table.e-table e-viewstable', "", {}, { cellspacing: '0px', cellpadding: '0px' });
            var $viewBody = ej.buildTag('tbody');
            var $viewTR = ej.buildTag('tr');
            var _viewCollection = views, viewClassname;
            for (var i = 0; i < _viewCollection.length; i++) {
                viewClassname = (_viewCollection.length == 1) ? "e-" + _viewCollection[i].toLowerCase() + " e-singleview" : (i == 0) ? "e-" + _viewCollection[i].toLowerCase() + " e-firstview" : i == (_viewCollection.length - 1) ? "e-" + _viewCollection[i].toLowerCase() + " e-lastview" : "e-" + _viewCollection[i].toLowerCase();
                switch (_viewCollection[i]) {
                    case "day": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Day"), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "week": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Week"), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "workweek": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("WorkWeek"), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "month": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Month"), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "customview": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("CustomView"), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "agenda": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Agenda"), {}, {}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                }
            }
            $viewTable.append($viewBody.append($viewTR))
            return $viewTable;
        },
        _renderNavigationDrawer: function () {
            if (ej.isNullOrUndefined(this._scheduleDrawer)) {
                this._scheduleDrawer = ej.buildTag('div#' + this._id + 'navDrawer.navDrawerMenu e-scheduledrawer');
                var $scheduleDrawer = "<ul><li data-ej-imageClass='e-icon e-mAddEvent' data-ej-text='" + this._getLocalizedLabels("AddEvent") + "' id='addEvent'></li>";
                for (var i = 0; i < this.model.views.length; i++) {
                    switch (this.model.views[i]) {
                        case "day": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Day") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "week": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Week") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "workweek": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("WorkWeek") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "month": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Month") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "customview": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("CustomView") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "agenda": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Agenda") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                    }
                }
                $scheduleDrawer += "</ul>";
                this._scheduleDrawer.append($scheduleDrawer);
                this.element.find(".e-scheduleinner").append(this._scheduleDrawer);
                this._navDrawer = true;
                this._scheduleDrawer.ejNavigationDrawer({ type: "overlay", targetId: this._id + "navDrawerIcon", direction: (this.model.enableRTL) ? "left" : "right", enableListView: true, listViewSettings: { persistSelection: true, selectedItemIndex: this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) + 1, width: 100, height: "auto", mouseUp: $.proxy(this._slideMenuClick, this) }, position: "normal" });
                this.model.enableRTL && this._scheduleDrawer.parent().css("left", "0px");
                this._navDrawer = false;
            }
        },

        _slideMenuClick: function (e) {
            if (this._navDrawer) return false;
            this._scheduleDrawer.ejNavigationDrawer("close");
            var menu = (e.item.find("div").hasClass("e-day")) ? "day" : (e.item.find("div").hasClass("e-week")) ? "week" : (e.item.find("div").hasClass("e-workweek")) ? "workweek" : (e.item.find("div").hasClass("e-month")) ? "month" : (e.item.find("div").hasClass("e-customview")) ? "customview" : (e.item.find("div").hasClass("e-agenda")) ? "agenda" : "open";
            if (menu != "open") {
                this._navView = this._navSelected = true;
                (this.currentView() != menu) && this._viewChange(null, this.currentView(), menu);
                this._navSelected = false;
            }
            else {
                if (this.currentView() != "agenda") {
                    var date = new Date(this.currentDate()), targetElement;
                    var column = 0;
                    date = new Date(date.setHours(0, 0, 0, 0));
                    for (var i = 0; i < this.dateRender.length; i++) {
                        if (new Date(this.dateRender[i]).getTime() == date.getTime()) {
                            column = i;
                            break;
                        }
                    }
                    if (this.model.orientation == "vertical")
                        var row = this.model.startHour + ((new Date().getHours()) * (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    else
                        var row = this.res1.length - 1;
                    targetElement = (this.currentView() != "month" && this.currentView() != "customview") && this.model.timeScale.enable ? this.element.find(".e-draggableworkarea tr")[row].cells[column] : this.element.find(".e-monthcells")[column];
                    $(targetElement).addClass(".e-selectedCell").trigger($.Event('click'));
                    this._appointmentWindow({ target: targetElement });
                }
            }
        },

        _renderAlertWindow: function () {
            this._alertWindow = ej.buildTag('div.e-alertdialog#' + this._id + "alertWindow");
            var $alertWindow = "<div><div class='e-alerttext'></div><div class='e-alertbtn'><button id='" + this._id + "alertok' type='button' class='e-alertbutton e-alertOk e-buttonactive'>" + this._getLocalizedLabels("Ok") + "</button></div></div>";
            this._alertWindow.append($alertWindow);
            this.element.append(this._alertWindow);
            this._alertWindow.find(".e-alertbutton").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
            this._alertWindow.ejDialog({
                width: (this._mediaQuery) ? "75%" : 450,
                cssClass: this.model.cssClass,
                showOnInit: false,
                enableRTL: this.model.enableRTL, enableModal: true,
                title: this._getLocalizedLabels("RecurrenceAlert"),
                target: "#" + this._id,
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._alertClose, this)
            });
            $("#" + this._id + "alertWindow_wrapper").appendTo("body").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
        },

        _alertClose: function (args) {
            this._alertWindow.ejDialog("close");
            if (this._alertWindow.hasClass("e-recurAlert")) {
                this._alertWindow.removeClass("e-recurAlert");
                if ($(args.target).hasClass("e-alertOk")) {
                    this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                    this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                    this._appointmentAddWindow.find(".e-recurFinalRule").html(this._rRuleStr);
                    this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                    this._appointmentAddWindow.find(".e-recurEditor").toggle();
                    this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
                    (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "block");
                    this._appointmentAddWindow.find('.done').focus();
                }
                else {
                    this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: false });
                }
            }
            else if (this._alertWindow.hasClass("e-seriesAlert")) {
                this._alertWindow.removeClass("e-seriesAlert");
                if ($(args.target).hasClass("e-alertOk")) {
                    //$("#" + this._id + "AppointmentAddEditWindow").find("#done").click();
                    this._appointmentAddWindow.find("#done").click();
                }
                else {
                    this._seriesAlert = true;
                    //var recurEdit = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
                    //recurEdit.recurrenceRuleSplit(this._rule);
                    //this._appointmentAddWindow.find(".e-recurFinalRule").html(recurEdit.showRecurrenceSummary());
                }
            }
            else if (this._alertWindow.hasClass("e-deleteAlert")) {
                this._alertWindow.removeClass("e-deleteAlert");
                if ($(args.target).hasClass("e-alertOk")) this._deletingAppointment();
            }
            if (this._alertWindow.find("#" + this._id + "alertcancel").length != 0) this._alertWindow.find("#" + this._id + "alertcancel").remove();
        },

        _renderAppointmentWindow: function () {
            if ($("#" + this._id + "AppointmentAddEditWindow_wrapper")) $("#" + this._id + "AppointmentAddEditWindow_wrapper").remove();
            this._appointmentAddWindow = ej.buildTag('div.e-scheduledialog e-appointmentaddwindow#' + this._id + "AppointmentAddEditWindow");
            var $appWindow = "<div class='e-appwindow e-windowmargin'><form id='" + this._id + "_AddEditForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            if (this._mediaQuery) {
                $appWindow += "<tr id='" + this._id + "subjectlabeltr'><td colspan='3' class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td></tr><tr id='" + this._id + "subjecttr' class='" + this._id + "subjecttr'><td colspan='3' class='e-rightfields'>" +
                              "<input id='" + this._id + "subject' tabIndex='0' class='subject e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["subject"] + "' type='text' /><span class='e-ripple-bar'><input id='id' class='id' type='text' name='" + this._appointmentSettings["id"] + "' value='' style='display: none'/></td></tr>";
                if (this.model.showLocationField) {
                    $appWindow += "<tr><td colspan='3' class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Location") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" +
                                      "<input id='" + this._id + "location' tabIndex='0' class='location e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["location"] + "' type='text' /><span class='e-ripple-bar'></td></tr>";
                }
                $appWindow += "<tr id='" + this._id + "_appStartTime'><td class='e-textlabel' colspan='3'>" + this._getLocalizedLabels("StartTime") + ":</td></tr><tr><td width='37%'><input id='" + this._id + "startdate' class='startenddate' type='text' name='StartDate' value='' /></td><td width=31%'><input type='text' id='" + this._id + "starttime' class='startendtime' name='StartTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td width='31%'><input id='" + this._id + "startTimeZone' class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                }
                $appWindow += "</tr>";
                $appWindow += "<tr id='" + this._id + "_appEndTime'><td class='e-textlabel' colspan='3'>" + this._getLocalizedLabels("EndTime") + ":</td></tr><tr><td><input id='" + this._id + "enddate' class='startenddate' type='text' name='EndDate' value='' /></td><td><input type=''text' id='" + this._id + "endtime' class='startendtime' name='EndTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td><input  id='" + this._id + "endTimeZone' class='endutc' name='" + this._appointmentSettings["endTimeZone"] + "' type='text' value=''/><div id='Timezonelistend'></div></td>";
                }
                $appWindow += "</tr>";
                if (this.model.prioritySettings.enable) {
                    $appWindow += "<tr><td class='e-leftfields e-textlabel' colspan='3'>" + this._getLocalizedLabels("Priority") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "priority' class='priority' type='text' name='" + this._appointmentSettings["priority"] + "' value=''/><div id='prioritylist'></div></td></tr>";
                }
                $appWindow += "<tr class='" + this._id + "parrow'><td class='" + this._id + "allDay' colspan='3'><table class='e-table e-appchecktable' cellpadding='3'><tr><td><div class='e-allday e-checkboxmargin'><input id='" + this._id + "allday' tabIndex='0' class='allday' type='checkbox' name='" + this._appointmentSettings["allDay"] + "'/></div></td><td><div class='e-alldaytext'>" +
                                  "<label for='" + this._id + "allday'>" + this._getLocalizedLabels("AllDay") + "</label></div></td><td><div class='e-checkboxmargin e-recurrence'>" +
                                  "<input id='" + this._id + "recurrence' tabIndex='0' class='recurrence' type='checkbox' name='" + this._appointmentSettings["recurrence"] + "' value='recurrence'/></div></td><td><label class='e-repeatlbl' for='" + this._id + "recurrence'>" +
                                      this._getLocalizedLabels("Recurrence") + "</label></td></tr></table></td></tr>";
                $appWindow += "<tr id='" + this._id + "summary' class='" + this._id + "summary' style='display:none'><td class='e-textlabel'><label>" + this._getLocalizedLabels("Summary") + ":</label></td></tr><tr class='" + this._id + "summary' style='display:none'><td colspan='4'><table><tr><td><label class='e-recurFinalRule'></label></td><td><div class='e-recuredit'><a class='e-recuredit' href='#' onclick='return false;'>" + this._getLocalizedLabels("Edit") + "</a><span class='e-icon e-edit_01 e-scheduleedit'></span></div></td></tr></table></td></tr>";
                if (this.model.categorizeSettings.enable)
                    $appWindow += "<tr id='" + this._id + "categorizetr'><td class='e-leftfields e-textlabel' colspan='3'>" + this._getLocalizedLabels("Categorize") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "categorize' name='" + this._appointmentSettings["categorize"] + "' class='e-categorizevalue' type='text' value=''/></td></tr>";
                if (this._tempResource.length > 0 && ej.scheduleFeatures.resources) $appWindow = this._renderResourceElements($appWindow);
                $appWindow += "<tr><td colspan='3'><textarea class='e-description e-textarea e-animation e-inputtext' id='" + this._id + "description' name='" + this._appointmentSettings["description"] + "'></textarea><span class='e-ripple-bar'></td></tr>";
                $appWindow += "</tbody></table></form>";
                $appWindow += "<div class='e-floatright' style='width:100%'><table width='100%' class='e-table' cellpadding='5'><tr><td width='30%'><div class='e-btnmargin e-floatleft'><button id='mDelete' class='e-btndelete e-appdelete'>" + this._getLocalizedLabels("Delete") + "</button></div></td><td width='30%'><div class='e-btnmargin e-floatleft'><button id='done' class='e-btndone e-appsave e-buttonactive'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                              "<td width='30%'><div class='e-btnmargin e-floatleft'><button id='cancel' class='e-appointcancel cancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            }
            else {
                $appWindow += "<tr  id='" + this._id + "subjecttr' class='" + this._id + "subjecttr'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td><td colspan='3' class='e-rightfields'>" +
                                 "<input id='" + this._id + "subject' tabIndex='0' class='subject e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["subject"] + "' type='text' /><span class='e-ripple-bar'><input id='id' class='id' type='text' name='" + this._appointmentSettings["id"] + "' value='' style='display: none'/></td></tr>";
                if (this.model.showLocationField) {
                    $appWindow += "<tr id='" + this._id + "showLocation' class='" + this._id + "showLocation'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Location") + ":</td><td colspan='3' class='e-rightfields'>" +
                                     "<input id='" + this._id + "location' tabIndex='0' class='location e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["location"] + "' type='text' /><span class='e-ripple-bar'></td></tr>";
                }
                $appWindow += "<tr id='" + this._id + "_appStartTime'><td class='e-textlabel'>" + this._getLocalizedLabels("StartTime") + ":</td><td width='25%'><input id='" + this._id + "startdate' class='startenddate' type='text' name='StartDate' value='' /></td><td width=22%'><input type='text' id='" + this._id + "starttime' class='startendtime' name='StartTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td width='28%'><input  id='" + this._id + "startTimeZone'  class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                }
                $appWindow += "</tr>";
                $appWindow += "<tr id='" + this._id + "_appEndTime'><td class='e-textlabel'>" + this._getLocalizedLabels("EndTime") + ":</td><td><input id='" + this._id + "enddate' class='startenddate' type='text' name='EndDate' value='' /></td><td><input type=''text' id='" + this._id + "endtime' class='startendtime' name='EndTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td><input id='" + this._id + "endTimeZone'  class='endutc'  name='" + this._appointmentSettings["endTimeZone"] + "'  type='text' value=''/><div id='Timezonelistend'></div></td>";
                }
                $appWindow += "</tr>";
                var win = this.model.prioritySettings.enable ? "<td colspan='1' class='e-textlabel " + this._id + "priorityshow'>" + this._getLocalizedLabels("Priority") + ":</td><td colspan='1' class='" + this._id + "prioritylistshow'><input id='" + this._id + "priority' class='priority' type='text' name='" + this._appointmentSettings["priority"] + "' value='' /><div id='prioritylist'></div></td>" : '';
                $appWindow += "<tr class='" + this._id + "parrow'>" + win + "<td class='" + this._id + "allDay' colspan='4'><table class='e-table e-appchecktable' cellpadding='3'><tr><td><div class='e-allday e-checkboxmargin'><input id='" + this._id + "allday' tabIndex='0' class='allday' type='checkbox' name='" + this._appointmentSettings["allDay"] + "'/></div></td><td><div class='e-alldaytext'>" +
                                 "<label for='" + this._id + "allday'>" + this._getLocalizedLabels("AllDay") + "</label></div></td><td><div class='e-checkboxmargin e-recurrence'>" +
                                  "<input id='" + this._id + "recurrence' tabIndex='0' class='recurrence' type='checkbox' name='" + this._appointmentSettings["recurrence"] + "' value='recurrence'/></div></td><td><label class='e-repeatlbl' for='" + this._id + "recurrence'>" +
                                  this._getLocalizedLabels("Recurrence") + "</label></td></tr></table></td></tr>";
                $appWindow += "<tr id='" + this._id + "summary' class='" + this._id + "summary' style='display:none'><td class='e-textlabel'><label>" + this._getLocalizedLabels("Summary") + ":</label></td><td colspan='3'><table><tr><td><label class='e-recurFinalRule'></label></td><td><div class='e-recuredit'><a class='e-recuredit' href='#' onclick='return false;'>" + this._getLocalizedLabels("Edit") + "</a><span class='e-icon e-edit_01 e-scheduleedit'></span></div></td></tr></table></td></tr>";
                if (this.model.categorizeSettings.enable)
                    $appWindow += "<tr id='" + this._id + "categorizetr'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Categorize") + ":</td><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "categorize' name='" + this._appointmentSettings["categorize"] + "' class='e-categorizevalue' type='text' value=''/></td></tr>";
                if (this._tempResource.length > 0 && ej.scheduleFeatures.resources) $appWindow = this._renderResourceElements($appWindow);
                $appWindow += "<tr><td colspan='4'><textarea class='e-description e-textarea e-animation e-inputtext' id='" + this._id + "description' name='" + this._appointmentSettings["description"] + "'></textarea><span class='e-ripple-bar'></td></tr>";
                $appWindow += "</tbody></table></form>";
                $appWindow += "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='done' class='e-btndone e-appsave e-buttonactive'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                              "<td><div class='e-btnmargin e-floatleft'><button id='cancel' class='e-appointcancel cancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            }
            this._appointmentAddWindow.append($appWindow);
            this.element.append(this._appointmentAddWindow);
            this._renderControls();
            this._appointmentAddWindow.ejDialog({
                width: (this._mediaQuery) ? "100%" : 600,
                cssClass: this.model.cssClass,
                showOnInit: false,
                enableRTL: this.model.enableRTL, enableModal: true,
                title: this._getLocalizedLabels("CreateAppointmentTitle"),
                target: "#" + this._id,
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._onclose, this)
            });
            if (this._mediaQuery)
                $("#" + this._id + "AppointmentAddEditWindow_wrapper").appendTo("body").addClass("e-scheduledialog e-scheduleresponsive").find(".e-titlebar").addClass("e-dialogheader");
            else
                $("#" + this._id + "AppointmentAddEditWindow_wrapper").appendTo("body").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
            $("#" + this._id + "priority_popup_wrapper").addClass("e-schedulepriority");
            this._on(this._appointmentAddWindow, "click", "a.e-recuredit", $.proxy(this._editRecurrence, this));
            if (this._mediaQuery) this._appointmentAddWindow.ejDialog("refresh");
            $.isFunction($.validator) && this._setValidation();
            if (this._mediaQuery) this._phoneChanges();
        },

        _renderRecurrenceEditor: function () {
            var recurrenceEditor = ej.buildTag('div.e-recurEditor#' + this._id + 'recurrenceEditor').ejRecurrenceEditor({ selectedRecurrenceType: 1, frequencies: ["daily", "weekly", "monthly", "yearly", "everyweekday"], startDate: this.currentDate(), minDate: this.model.minDate, maxDate: this.model.maxDate, firstDayOfWeek: this.model.firstDayOfWeek, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, locale: this.model.locale });
            var recurWin = "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='" + this._id + "donerecur'  class='recurbutton e-buttonactive'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                            "<td><div class='e-btnmargin e-floatleft'><button id='" + this._id + "cancelrecur' class='e-cancelrecur recurbutton'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div>";
            $(recurrenceEditor).insertAfter(this._appointmentAddWindow.find(".e-appwindow"));
            this._appointmentAddWindow.find(".e-recurEditor").append(recurWin);
            this._appointmentAddWindow.find('#' + this._id + 'donerecur').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._closeRecurence, this), cssClass: "e-flat" + this.model.cssClass });
            this._appointmentAddWindow.find('#' + this._id + 'cancelrecur').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._closeRecurence, this), cssClass: "e-flat" + this.model.cssClass });
            this._appointmentAddWindow.find('.e-recurEditor').css("display", "none");
            if (this._mediaQuery) this._phoneChanges();
        },

        _refreshAppointmentWindow: function () {
            this._destorySubControls($("#" + this._id + "_AddEditForm"));
            this._destorySubControls($("#" + this._id + "_RecurForm"));
            $("#" + this._id + "AppointmentAddEditWindow_wrapper").remove();
            this._renderAppointmentWindow();
            $.isFunction($.validator) && this._setValidation();
        },

        _renderQuickAppWindow: function () {
            this._quickAppointWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppointmentQuickWindow");
            var $quickWin = "<div id='" + this._id + "_quickAppwindow' class='e-tableAppoint'><table cellpadding='7' class='e-qappwindow'><tbody>";
            $quickWin += "<tr><td colspan='2'><div class='e-quickstartend'></div> <div title='" + this._getLocalizedLabels("Close") + "'class='e-icon e-scheduleclose e-schedclosemargin e-pointercursor'></div></td></tr><tr><td class='e-subjectlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td><td colspan='2' class='e-rightfields'>" +
                              "<form id='" + this._id + "_AddForm' onsubmit='return false;'><input id='" + this._id + "subject' class='subject e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["subject"] + "'  type='text' /><span class='e-ripple-bar'></span></form></td></tr></tbody></table>";
            $quickWin += "<div class='e-quickcreatebottomcontainer'><div tabIndex='0' class='e-detailedapp e-detailedwindow'> " + this._getLocalizedLabels("Detailed") + " >></div><div style='margin-right:-3px;' class='e-floatright'><div class='e-quickAppDone'><button id='done' class='e-btndone e-qAppDone e-buttonactive' style='font-size:12px !important;'>" + this._getLocalizedLabels("CreateAppointmentTitle") + "</button></div></div></div></div>";
            this._quickAppointWindow.append($quickWin);
            this.element.append(this._quickAppointWindow);
            this._quickAppointWindow.append(ej.buildTag("div.e-quickarrow").append("<div class='e-outerarrowline'></div>").append("<div class='e-innerarrow'></div>"));
            var control = this._quickAppointWindow;
            control.find('.e-btndone').ejButton({ showRoundedCorner: true, click: $.proxy(this._saveAppointment, this), cssClass: "e-flat" + this.model.cssClass, enableRTL: this.model.enableRTL });
            this._on(control.find('.e-scheduleclose'), "click", $.proxy(this._quickWindowClose, this));
            this._on(control.find('.e-detailedapp'), "click", $.proxy(this._appointmentWindow, this));
            this._quickAppointWindow.ejDialog({
                width: 330, minHeight: 0,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                enableAnimation: false,
                showOnInit: false,
                enableResize: false,
                allowDraggable: false, showHeader: false,
                allowKeyboardNavigation: false,
                close: $.proxy(function () { this._processFocus(); }, this)
            });
            $.isFunction($.validator) && this._setQuickValidation();
            $("#" + this._id + "AppointmentQuickWindow_wrapper").addClass("e-scheduledialog e-schedulequickdialog").css("overflow", "visible").find("#" + this._id + "AppointmentQuickWindow").addClass("e-dialogouter");
        },

        _renderQuickAppDetailsView: function () {
            this._quickAppDetailsWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppDetailsWindow");
            var $quickAppWin = "<div id='" + this._id + "_quickAppDetailswindow' class='e-tableAppoint e-appdetails'>" +
                              "<table cellpadding='1' class='e-qappwindow'><tbody>";
            $quickAppWin += "<tr><td colspan='2'><div class='e-quicksubject e-textellipsis'></div> <div title='" + this._getLocalizedLabels("Close") + "' class='e-icon e-scheduleclose e-schedclosemargin e-pointercursor'></div></td></tr><tr><td colspan='2' class='e-quickduein e-rightfields'>" +
                              "</td></tr><tr><td colspan='2'><div class='e-quickstartendtime'></div></td></tr></tbody></table>";
            $quickAppWin += "<div class='e-quickbottomcontainer'><div title='" + this._getLocalizedLabels("Delete") + "' class='e-icon e-delete e-scheduledelete e-pointercursor' tabIndex='0'></div><div class='e-floatright'><div class='e-editevents'><div class='e-editevent e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editevent") + " | " + "</div><div class='e-editseries e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editseries") + " >></div> </div>" +
                              "</div></div></div>";
            this._quickAppDetailsWindow.append($quickAppWin);
            this.element.append(this._quickAppDetailsWindow);
            this._quickAppDetailsWindow.append(ej.buildTag("div.e-quickarrow").append("<div class='e-outerarrowline'></div>").append("<div class='e-innerarrow'></div>"));
            this._on(this._quickAppDetailsWindow.find('.e-scheduleclose'), "click", $.proxy(this._quickAppDetailWindowClose, this));
            this._on(this._quickAppDetailsWindow.find('.e-scheduledelete'), "click", $.proxy(this._deleteAppoint, this));
            this._on(this._quickAppDetailsWindow.find('.e-editevent,.e-editseries'), "click", $.proxy(this._editClick, this));
            this._quickAppDetailsWindow.ejDialog({
                width: 270, minHeight: 0,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                enableAnimation: false,
                showOnInit: false,
                enableResize: false,
                allowDraggable: false, showHeader: false,
                allowKeyboardNavigation: false,
                close: $.proxy(function () { this._processFocus(); }, this)
            });
            $("#" + this._id + "AppDetailsWindow_wrapper").addClass("e-scheduledialog e-schedulequickdialog").css("overflow", "visible").find("#" + this._id + "AppDetailsWindow").addClass("e-dialogouter");
        },

        _editClick: function (e) {
            if ($(e.target).hasClass("e-editseries") && (this._quickAppDetailsWindow.find('.e-editseries').hasClass("e-disable"))) return false;
            var query = new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid);
            var templist = new ej.DataManager(this._processed).executeLocal(query);
            if ($(e.target).hasClass("e-editevent")) {
                if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                    this._parentId = templist[0]["ParentId"];
                    this._currentAction = ej.Schedule.Actions.EditOccurrence;
                    this._showAppointmentDetails(this._appUid, true);
                }
                else if (ej.isNullOrUndefined(templist[0][this._appointmentSettings["recurrence"]])) {
                    this._currentAction = ej.Schedule.Actions.Save;
                    this._showAppointmentDetails(this._appUid, true);
                }
                else {
                    this._currentAction = ej.Schedule.Actions.Save;
                    this._showAppointmentDetails(templist[0]["Guid"], true);
                }
            }
            else if ($(e.target).hasClass("e-editseries")) {
                if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                    this._parentId = (templist[0][this._appointmentSettings["recurrenceId"]] == null) ? templist[0]["ParentId"] : templist[0][this._appointmentSettings["recurrenceId"]];
                    this._currentAction = ej.Schedule.Actions.EditSeries;
                    this._showAppointmentDetails(this._parentId, false);
                }
            }
            this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
        },

        _deleteAppoint: function (e) {
            if (!this.model.readOnly) {
                if (!ej.isNullOrUndefined(e) && (ej.isNullOrUndefined(this._quickAppDetailsWindow) || !this._quickAppDetailsWindow.ejDialog("isOpen"))) {
                    var _target = $(e.target).parent();
                    var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") || _target.hasClass("e-agendaappointment") ? _target : _target.parents(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment");
                    this._appUid = appoint.attr("guid");
                    if (this._mediaQuery) this._mAppId = this._appUid;
                    var _editApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    if (_editApp[0][this._appointmentSettings["recurrence"]] || !this.model.showDeleteConfirmationDialog)
                        this._deletingAppointment();
                    else
                        this._deleteConfirmation();
                }
                else {
                    var _editApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    if (_editApp[0][this._appointmentSettings["recurrence"]] || !this.model.showDeleteConfirmationDialog) {
                        this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("isOpen") && this._quickAppDetailsWindow.ejDialog("close");
                        this._deletingAppointment();
                    }
                    else
                        this._deleteConfirmation();
                }
            }
        },

        _deletingAppointment: function () {
            this._appUid = ej.isNullOrUndefined(this._appUid) ? this._deleteUid : this._appUid;
            if (this._appUid) {
                this._currentAction = ej.Schedule.Actions.Delete;
                var parentData = this._getAppointmentByParentId((this._mediaQuery) ? ej.isNullOrUndefined(this._mAppId) ? this._appUid : this._mAppId : this._appUid);
                if (!parentData[this._appointmentSettings["recurrence"]])
                    this._deleteApp((this._mediaQuery) ? ej.isNullOrUndefined(this._mAppId) ? this._appUid : this._mAppId : this._appUid);
                else {
                    if (ej.isNullOrUndefined(this._recurEditWindow)) this._renderRecurEditWindow();
                    this._parentId = parentData["ParentId"];
                    this._recurEditWindow.ejDialog("open");
                    this._recurEditWindow.focus();
                    this._deleteBeforeOpen();
                }
            }
            (!ej.isNullOrUndefined(this._alertWindow)) && this._alertWindow.ejDialog("close");
        },

        _deleteConfirmation: function () {
            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow) && this.model.showQuickWindow) this._quickAppDetailsWindow.ejDialog("close");
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            if (this._alertWindow.find(".e-alertCancel").length == 0) {
                this._alertWindow.find(".e-alertbtn").append("<button id='" + this._id + "alertcancel' class='e-alertbutton e-alertCancel'></button>");
                this._alertWindow.find(".e-alertCancel").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
                if (this._mediaQuery) this._alertWindow.find(".e-alertCancel").css({ 'margin': '0px 20px 15px 10px' });
                $("#" + this._id + "alertWindow").ejDialog({
                    width: (this._mediaQuery) ? "90%" : 450,
                    title: this._getLocalizedLabels("MouseOverDeleteTitle")
                });
                this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("DeleteConfirmation"));
                this._alertWindow.find(".e-alertCancel").html(this._getLocalizedLabels("Cancel"));
                this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Delete"));
            }
            if (!this._alertWindow.ejDialog("isOpen")) {
                this._alertWindow.addClass("e-deleteAlert");
                this._alertWindow.ejDialog("open");
                this._alertWindow.find(".e-alertOk").attr("tabIndex", 0).focus();
            }
        },

        _quickAppDetailWindowClose: function () {
            this._quickAppDetailsWindow.ejDialog("close");
            this._processFocus();
        },

        _alldayCheck: function () {
            if (this._appointmentAddWindow.find(".allday").ejCheckBox("option", "checked")) {
                this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({ value: (this._timeMode == "12") ? "12:00 AM" : "00:00", enabled: false });
                this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({ value: (this._timeMode == "12") ? "11:59 PM" : "23:59", enabled: false });
                this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList({ enabled: false });
            }
            else {
                if (this._tempStart != "" || this._tempEnd != "") {
                    var dayStTime = ej.format(new Date(new Date().setHours(0, 0, 0)), this._pattern.t, this.model.locale);
                    var dayEndTime = ej.format(new Date(new Date().setHours(23, 59, 59)), this._pattern.t, this.model.locale);
                    this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({ value: this._tempStart });
                    this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({ value: this._tempEnd });
                    if (((this._timeMode == "12") ? (this._tempStart == dayStTime && this._tempEnd == dayEndTime) : (this._tempStart == "00:00" && this._tempEnd == "23:59"))) {
                        this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({ value: ej.format(new Date("1/1/2000 " + this.model.workHours.start + ":00:00"), this._pattern.t, this.model.locale) });
                        this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({ value: ej.format(new Date("1/1/2000 " + this.model.workHours.start + ":30:00"), this._pattern.t, this.model.locale) });
                    }
                }
                this._appointmentAddWindow.find(".startendtime").ejTimePicker({ enabled: true });
                this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList({ enabled: true });
                this._endSlotChange = true;
                this._startSlotChange = true;
            }
        },

        _renderRecurEditWindow: function () {
            if ($("#" + this._id + "RecurrenceEdit_wrapper")) $("#" + this._id + "RecurrenceEdit_wrapper").remove();
            this._recurEditWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "RecurrenceEdit");
            var msgDiv = ej.buildTag('div.e-recureditmsg', this._getLocalizedLabels("RecurrenceEditMessage"));
            var editOnly = this._getLocalizedLabels("RecurrenceEditOnly");
            var editSeries = this._getLocalizedLabels("RecurrenceEditSeries");
            var btns = ej.buildTag('div.e-recureditbtns').append(ej.buildTag('button.e-editonly#' + this._id + "Editonly", editOnly, {}, { name: "recurrenceeditonly", value: editOnly })).append(ej.buildTag('button.e-editseries#' + this._id + "EditSeries", editSeries, {}, { name: "recurrenceeditseries", value: editSeries }));
            this._recurEditWindow.append(msgDiv).append(btns);
            btns.find('.e-editonly,.e-editseries').ejButton({ cssClass: "e-flat" + this.model.cssClass, enableRTL: this.model.enableRTL, showRoundedCorner: true });
            this._on(this._recurEditWindow, "click", ".e-editonly,.e-editseries", $.proxy(this._recurBtnClick, this));
            this._on(this._recurEditWindow, "click", "div.e-scheduleclose", $.proxy(this._recrConformClose, this));
            this._recurEditWindow.appendTo(this.element);
            if (this._mediaQuery) {
                this._recurEditWindow.find('.e-editonly,.e-editseries').css({ 'margin-top': '10px' });
            }
            this._recurEditWindow.ejDialog({
                width: (this._mediaQuery) ? "90%" : 360,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                title: this._getLocalizedLabels("RecurrenceEditTitle"),
                showOnInit: false,
                enableModal: true,
                enableResize: false,
                target: "#" + this._id,
                allowKeyboardNavigation: false,
                close: $.proxy(this._processFocus, this),
                beforeOpen: $.proxy(this._deleteBeforeOpen, this)
            });
            $("#" + this._id + "RecurrenceEdit_wrapper").appendTo("body").addClass("e-scheduledialog");
        },

        _recrConformClose: function () {
            if (!ej.isNullOrUndefined(this._recurEditWindow))
                this._recurEditWindow.ejDialog("close");
            this._processFocus();
        },
        _deleteBeforeOpen: function () {
            $('#' + this._id + 'RecurrenceEdit_title').addClass('e-dialogheader');
            $('#' + this._id + 'RecurrenceEdit_title').find('.e-title').html(this._currentAction == ej.Schedule.Actions.Delete ? this._getLocalizedLabels("RecurrenceDeleteTitle") : this._getLocalizedLabels("RecurrenceEditTitle"));
        },

        _recurBtnClick: function (args) {
            if ($(args.target).hasClass("e-editonly")) {
                this._editOnlyClicked = true;
                if (this._currentAction == ej.Schedule.Actions.Delete) {
                    var _newAddList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                    if (_newAddList[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) {
                        if (this._trigger("actionBegin", { id: this._appUid, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence }))
                            return false;
                        var Parid = _newAddList[this._appointmentSettings["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[this._appointmentSettings["recurrenceId"]]
                        var deleted = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                        if (this._trigger("beforeAppointmentRemove ", { appointment: deleted, currentAction: ej.Schedule.Actions.DeleteOccurrence }))
                            return false;
                        var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "Guid";
                        var promise = this._dataManager.remove(queryId, _newAddList[queryId], this.model.appointmentSettings.query._fromTable);
                        if (this.dataSource() instanceof ej.DataManager) new ej.DataManager(this._currentAppointmentData).remove("Guid", _newAddList);
                        var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        this._appointmentRemove(deleteApp[0]);
                        this._refreshDayAppointments(deleteApp[0]);
                        this._trigger("appointmentRemoved", { appointment: deleted, requestType: "appointmentDeleted", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        this._trigger("actionComplete", { appointment: deleted, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value)) {
                                    proxy._processUrlBinding(e);
                                }
                            });
                        }
                    }
                    else {
                        if (this._trigger("actionBegin", { id: this._appId, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence }))
                            return false;
                        var Parid = _newAddList[this._appointmentSettings["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[this._appointmentSettings["recurrenceId"]]
                        var deleApp = this._deleteOcurrence(Parid, _newAddList[this._appointmentSettings["startTime"]]);
                        var temp = this._timeZoneAppointments(deleApp[0], "");
                        if (this._trigger("beforeAppointmentRemove", { appointment: _newAddList, currentAction: ej.Schedule.Actions.DeleteOccurrence })) {
                            this._recurEditWindow.ejDialog("close");
                            return false;
                        }
                        var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                        var promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable);
                        var updateTemp = (this._timeZoneAppointments(temp, "reverse"));
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                        this._refreshCellsHeight();
                        if ((new Date(new Date(updateTemp[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(updateTemp[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((updateTemp[this._appointmentSettings["endTime"]] - updateTemp[this._appointmentSettings["startTime"]]) / 3600000) < 24) && (updateTemp[this._appointmentSettings["allDay"]] !== true)) {
                            var splitApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                            var delApp = [];
                            for (i = 0; i < splitApp.length; i++) {
                                var tmpApp = this._processed.filter(function (obj) { return obj.Guid == splitApp[i]["Guid"]; });
                                if (tmpApp.length > 0) delApp.push(tmpApp[0]);
                                new ej.DataManager(this._processed).remove("Guid", splitApp[i]["Guid"]);
                                new ej.DataManager(this._renderedApp).remove("Guid", splitApp[i]["Guid"]);
                                new ej.DataManager(this._renderedAllDay).remove("Guid", splitApp[i]["Guid"]);
                            }
                        }
                        else {
                            var delApp = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                            new ej.DataManager(this._processed).remove("Guid", this._appUid);
                            new ej.DataManager(this._renderedApp).remove("Guid", this._appUid);
                            new ej.DataManager(this._renderedAllDay).remove("Guid", this._appUid);
                            this._appUid = null;
                        }
                        for (var ix = 0, len = delApp.length; ix < len; ix++) {
                            this._appointmentRemove(delApp[ix]);
                            this._refreshDayAppointments(delApp[ix]);
                        }
                        this._trigger("appointmentRemoved", { appointment: _newAddList, requestType: "appointmentDeleted", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        this._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value)) {
                                    proxy._processUrlBinding(e);
                                }
                            });
                        }
                    }
                    this._currentViewAppointments = this._appointmentCount();
                    if (this.model.showAppointmentNavigator) this._nextPrevButton();
                }
                else {
                    this._currentAction = ej.Schedule.Actions.EditOccurrence;
                    this._showAppointmentDetails(this._appUid, true);
                }
            }
            else {
                this._editOnlyClicked = false;
                if (this._currentAction == ej.Schedule.Actions.Delete) {
                    this._actionType = ej.Schedule.Actions.DeleteSeries;
                    this._deleteApp(this._appUid);
                }
                else {
                    this._currentAction = ej.Schedule.Actions.EditSeries;
                    this._showAppointmentDetails(this._parentId, false);
                }
            }
            if (!ej.isNullOrUndefined(this._recurEditWindow)) this._recurEditWindow.ejDialog("close");
        },

        _repeat: function (e) {
            if (e.isInteraction) {
                if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                this._appointmentAddWindow.find(".e-recurEditor").length == 0 && this._renderRecurrenceEditor();
                if (e.isChecked || this._recurChecked) {
                    if (this._currentAction == ej.Schedule.Actions.EditSeries || this._appointmentAddWindow.find(".e-recurFinalRule").html() != "") {
                        this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                    }
                    else {
                        (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "none");
                        this._appointmentAddWindow.find(".e-appwindow").toggle();
                        this._appointmentAddWindow.find(".e-recurEditor").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 400);
                        var recurEdit = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
                        recurEdit.clearRecurrenceFields();
                        this._appointmentAddWindow.find('.e-recurEditor').css("display", "block");
                        var strDate = new Date(this._appointmentAddWindow.find('.startenddate').ejDatePicker("option", "value"));
                        recurEdit.model.startDate = strDate;;
                        recurEdit.setDefaultValues();
                    }
                }
                else {
                    (this._currentAction == ej.Schedule.Actions.EditSeries || this._appointmentAddWindow.find(".e-recurFinalRule").html() != "") && this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
                }
                this._recurChecked = false;
            }
        },

        _resourceDaysReorder: function (days) {
            var dayNames = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
            var cultureNames = [], resDays = [], oldOrder = [], newOrder = [], index = this._firstdayofweek;
            do {
                if (index > 6) index = 0;
                cultureNames.push(dayNames[index]);
                index++;
            } while (cultureNames.length < 7)
            for (var a = 0; a < days.length; a++) { resDays.push(days[a].toLowerCase()); }
            for (var b = 0; b < resDays.length; b++) { if (cultureNames.indexOf(resDays[b]) != -1) oldOrder[cultureNames.indexOf(resDays[b])] = resDays[b]; }
            for (var c = 0; c < oldOrder.length; c++) { if (!ej.isNullOrUndefined(oldOrder[c])) newOrder.push(oldOrder[c]); }
            return newOrder;
        },

        _daysReorder: function (firstdayofweek) {
            var dayNames = [], index = firstdayofweek, names = [0, 1, 2, 3, 4, 5, 6];
            do {
                if (index > 6) index = 0;
                dayNames.push(names[index]);
                index++;
            } while (dayNames.length < 7)
            return dayNames;
        },

        _getWeekDays: function () {
            var weekDays = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], showWeekDays = [];
            for (var days = 0; days < this.model.workWeek.length; days++) {
                var dayIndex = weekDays.indexOf(this.model.workWeek[days]);
                if (dayIndex != -1) showWeekDays.push(dayIndex);
            }
            return showWeekDays;
        },

        _resourceRenderDates: function () {
            if (this._tempResource.length > 1) {
                var resCollection = this._resourceSort();
                var resource = [];
                for (x = 0; x < resCollection.length; x++) {
                    var index = this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource.indexOf(resCollection[x]);
                    if (index != -1) resource.push(resCollection[x]);
                }
                this.res1 = resource;
            }
            else
                var resource = this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource;
            var resDateRender = [], temp = [], proxy = this;
            this._resDateRen = {};
            for (var a = 0; a < resource.length; a++) {
                var resColl = resource[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                if (!ej.isNullOrUndefined(resColl)) {
                    resColl = this._resourceDaysReorder(resColl);
                    for (var b = 0; b < resColl.length; b++) {
                        var index = this._dayFullNames.indexOf(resColl[b].capitalizeFirstString());
                        if (index == -1) {
                            index = this._getDayNameIndex(resColl[b]);
                        }
                        resDateRender.push(this._renderDates[index]);
                        temp.push(this._renderDates[index]);
                    }
                    this._resDateRen[a] = temp;
                    temp = [];
                }
                else {
                    var resCustomDates = $.extend(true, [], this._dateRender), weekDays = this._getWeekDays();
                    resCustomDates = resCustomDates.filter(function (date) { return weekDays.indexOf(new Date(date).getDay()) != -1; });
                    $.merge(resDateRender, resCustomDates);
                    this._resDateRen[a] = resCustomDates;
                }
            }
            return resDateRender;
        },

        _customviewRenderDates: function () {
            if (!ej.isNullOrUndefined(this.model.renderDates)) {
                this._calculateCustomDays();
                var customRenderDates = [], showWeekDays = this._getWeekDays();
                if (this._setCurrentDate && this.model.orientation != "horizontal") {
                    this.oldDate = this.currentDate();
                    if ((this._renderStart.getTime() < this.currentDate().getTime()) && (this._renderEnd.getTime() > this.currentDate().getTime()))
                        this.currentDate(new Date(this._renderStart));
                    else {
                        this._renderStart = new Date(this.currentDate());
                        this._renderEnd = new Date(this._renderStart.getTime() + ((this._renderDays - 1) * 86400000));
                    }
                }
                var newDate, firstDay = this._renderDays <= 7 ? new Date(this.currentDate()) : this.model.orientation == "vertical" ? this._firstweekdate(this.currentDate()) : new Date(this.currentDate());
                var noOfDays = (this._renderDays <= 7) ? this._renderDays : this._numDays;
                for (var ia = 0; ia < noOfDays; ia++) {
                    var newDate = new Date(new Date(firstDay).getTime() + (1000 * 60 * 60 * 24 * ia));
                    if (this.model.showWeekend) {
                        customRenderDates.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                    }
                    else {
                        var dayIndex = showWeekDays.indexOf(newDate.getDay());
                        if (dayIndex != -1) customRenderDates.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                    }
                }
            }
            else {
                var customRenderDates = this._monthdates();
            }
            return customRenderDates;
        },

        _getRenderDates: function () {
            this.currentDate(new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0)));
            this._dateRender = [];
            if (this.currentView() === "week" || this.currentView() === "workweek") {
                if (this.model.showWeekend) {
                    var firstDay = this._firstweekdate(this.currentDate());
                    do {
                        this._dateRender.push(new Date(firstDay.getFullYear(), firstDay.getMonth(), firstDay.getDate()).getTime());
                        firstDay.setDate(firstDay.getDate() + 1);
                    } while (this._dateRender.length < 7)
                    this._renderDates = $.extend(true, [], this._dateRender);
                }
                else {
                    var showWeekDays = this._getWeekDays();
                    var weekFirst = this._firstweekdate(this.currentDate());
                    do {
                        var dayIndex = showWeekDays.indexOf(weekFirst.getDay());
                        if (dayIndex != -1) this._dateRender.push(new Date(weekFirst.getFullYear(), weekFirst.getMonth(), weekFirst.getDate()).getTime());
                        weekFirst = new Date(new Date(weekFirst).getTime() + (1000 * 60 * 60 * 24));
                    } while (this._dateRender.length != this.model.workWeek.length)
                    this._renderDates = $.extend(true, [], this._dateRender);
                }
                if (this._resWorkWeek) {
                    this.dateRender = this._dateRender = this._resourceRenderDates();
                }
                else if (this.currentView() == "workweek" && this.model.showWeekend) {
                    var proxy = this;
                    var reorderDays = this._daysReorder(this._firstdayofweek);
                    var weekDays = this.model.workWeek.map(function (day) { return proxy._dayNamesArray.indexOf(day) });
                    var workweek = reorderDays.filter(function (a) { return weekDays.indexOf(a) !== -1; });
                    var filterDate = this._dateRender.map(function (date) { if (workweek.indexOf(new Date(date).getDay()) != -1) return date; });
                    this._dateRender = filterDate.filter(function (date) { return date != undefined });
                }
            }
            else if (this.currentView() === "month") {
                this._dateRender = this._monthdates();
            }
            else if (this.currentView() === "customview") {
                this._dateRender = this._customviewRenderDates();
            }
            else {
                if (!this.model.showWeekend) {
                    var showWeekDays = this._getWeekDays();
                    if (showWeekDays.indexOf(this.currentDate().getDay()) == -1) {
                        var noOfDays = this._getPrevNextDateCount(this.currentDate(), "next");
                        this.currentDate(new Date(this.currentDate().getTime() + (1000 * 60 * 60 * 24 * noOfDays)));
                    }
                }
                this._dateRender.push(new Date(this.currentDate().getFullYear(), this.currentDate().getMonth(), this.currentDate().getDate()).getTime());
            }
            return this._dateRender;
        },

        _getAgendaDateCount: function () {
            var count = (this.model.agendaViewSettings.daysInAgenda > 0) ? this.model.agendaViewSettings.daysInAgenda - 1 : 0;
            if (!this.model.showWeekend) {
                var showWeekDays = this._getWeekDays(), daysCount = 0;
                var weekFirst = agendaDate = new Date(this.currentDate());
                do {
                    var dayIndex = showWeekDays.indexOf(weekFirst.getDay());
                    if (dayIndex != -1) daysCount++;
                    weekFirst = new Date(new Date(weekFirst).getTime() + (1000 * 60 * 60 * 24));
                } while (this.model.agendaViewSettings.daysInAgenda != daysCount)
                count = (weekFirst.getTime() - agendaDate.getTime()) / (1000 * 60 * 60 * 24) - 1;
            }
            return count;
        },

        _getCurrentDateHeaderValue: function () {
            var dateValue, value = (this._resWorkWeek) ? this._renderDates : this._dateRender;
            if (this.currentView() === "day") {
                if (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat))
                    dateValue = ej.format(new Date(value[0]), this.model.dateFormat, this.model.locale);
                else {
                    var ddt = this._pattern.D.toString().replace(/\s*dddd,?/, "").trim();
                    if (ddt.toLowerCase().startsWith("d"))
                        dateValue = ej.format(new Date(value[0]), "dd MMM yyyy", this.model.locale);
                    else if (ddt.toLowerCase().startsWith("m"))
                        dateValue = ej.format(new Date(value[0]), "MMM dd, yyyy", this.model.locale);
                    else
                        dateValue = ej.format(new Date(value[0]), ddt, this.model.locale);
                }
            }
            else if (this.currentView() === "week" || this.currentView() === "workweek" || this.currentView() == "agenda") {
                var startDate = this.currentView() == "agenda" ? new Date(this.currentDate()) : new Date(value[0]),
                endDate = this.currentView() == "agenda" ? new Date(new Date(this.currentDate()).setDate(startDate.getDate() + this._getAgendaDateCount())) : new Date(value[value.length - 1]);
                dateValue = this._formatDateHeaderValue(startDate, endDate);
            }
            else if (this.currentView() === "customview") {
                if (value.length == 1) {
                    if (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat))
                        dateValue = ej.format(new Date(value[0]), this.model.dateFormat, this.model.locale);
                    else {
                        var ddt = this._pattern.D.toString().replace(/\s*dddd,?/, "").trim();
                        if (ddt.toLowerCase().startsWith("d"))
                            dateValue = ej.format(new Date(value[0]), "dd MMM yyyy", this.model.locale);
                        else if (ddt.toLowerCase().startsWith("m"))
                            dateValue = ej.format(new Date(value[0]), "MMM dd, yyyy", this.model.locale);
                        else
                            dateValue = ej.format(new Date(value[0]), ddt, this.model.locale);
                    }
                }
                else if (value.length > 1 && value.length <= 7)
                    dateValue = this._formatDateHeaderValue(new Date(value[0]), new Date(value[value.length - 1]));
                else {
                    if (new Date(value[0]).getFullYear() == new Date(value[value.length - 1]).getFullYear()) {
                        if (new Date(value[0]).getMonth() == new Date(value[value.length - 1]).getMonth())
                            dateValue = ej.format(new Date(this.currentDate()), "MMM yyyy", this.model.locale);
                        else
                            dateValue = ej.format(new Date(value[0]), "MMM", this.model.locale) + " - " + ej.format(new Date(value[value.length - 1]), "MMM yyyy", this.model.locale);
                    }
                    else
                        dateValue = ej.format(new Date(value[0]), "MMM yyyy", this.model.locale) + " - " + ej.format(new Date(value[value.length - 1]), "MMM yyyy", this.model.locale);
                }
            }
            else
                dateValue = ej.format(new Date(this.currentDate()), "MMM yyyy", this.model.locale);
            return dateValue;
        },

        _firstweekdate: function (currentDate) {
            var firstdayofweek = new Date(currentDate);
            var day = firstdayofweek.getDay();
            if (this._firstdayofweek == 0) {
                if (day != 0) {
                    firstdayofweek.setDate(firstdayofweek.getDate() - day);
                    if (!this.model.timeScale.enable && (this.currentView() == "workweek" || this._oneWeek) && this._resize)
                        firstdayofweek = new Date(this._dateRender[0]);
                }
            }
            else if (this._firstdayofweek != 0) {
                var diff = ((firstdayofweek.getDay() - this._firstdayofweek) < 0) ? (7 + firstdayofweek.getDay() - this._firstdayofweek) : (firstdayofweek.getDay() - this._firstdayofweek);
                firstdayofweek = new Date(firstdayofweek.setDate(firstdayofweek.getDate() - diff));
            }
            return firstdayofweek;
        },

        _formatDateHeaderValue: function (startDate, endDate) {
            if (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) {
                var dateValue = ej.format(startDate, this.model.dateFormat, this.model.locale) + " - " + ej.format(endDate, this.model.dateFormat, this.model.locale);
                return dateValue;
            }
            var ddt = this._pattern.D.toString().replace(/\s*dddd,?/, "").trim(), dateValue;
            if (ddt.toLowerCase().startsWith("d")) {
                if (new Date(startDate).getYear() === new Date(endDate).getYear()) {
                    if (new Date(startDate).getMonth() === new Date(endDate).getMonth())
                        dateValue = ej.format(new Date(startDate), "dd", this.model.locale) + " - " + ej.format(new Date(endDate), "dd MMM yyyy", this.model.locale);
                    else
                        dateValue = ej.format(new Date(startDate), "dd MMM", this.model.locale) + " - " + ej.format(new Date(endDate), "dd MMM yyyy", this.model.locale);
                } else
                    dateValue = ej.format(new Date(startDate), "dd MMM yyyy", this.model.locale) + " - " + ej.format(new Date(endDate), "dd MMM yyyy", this.model.locale);
            }
            else if (ddt.toLowerCase().startsWith("m")) {
                if (new Date(startDate).getYear() === new Date(endDate).getYear()) {
                    if (new Date(startDate).getMonth() === new Date(endDate).getMonth())
                        dateValue = ej.format(new Date(startDate), "MMM dd", this.model.locale) + " - " + ej.format(new Date(endDate), "dd, yyyy", this.model.locale);
                    else
                        dateValue = ej.format(new Date(startDate), "MMM dd", this.model.locale) + " - " + ej.format(new Date(endDate), "MMM dd, yyyy", this.model.locale);
                } else
                    dateValue = ej.format(new Date(startDate), "MMM dd, yyyy", this.model.locale) + " - " + ej.format(new Date(endDate), "MMM dd, yyyy", this.model.locale);
            } else
                dateValue = ej.format(new Date(startDate), ddt, this.model.locale) + " - " + ej.format(new Date(endDate), ddt, this.model.locale);
            return dateValue
        },

        _getHeaderAllDayCellsCount: function () {
            var temp, headerCellClass, count, columns = [], cols = [], curday, resCount = 1; this.dateRender = []; this._value = []; this.value = [];
            if (this.model.orientation == "vertical") {
                if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && (this.currentView() != "month" && !this._isCustomMonthView())) {
                    columns = this._getUserDateheaderTemplate();
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                        var getCount = this._getMultipleResourceCellsCount(count);
                        resCount = getCount.resCount;
                        if ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length == 0)
                            resCount = 1;
                    }
                }
                else {
                    count = this._getColumnCount().length;
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                        var getCount = this._getMultipleResourceCellsCount(count);
                        resCount = getCount.resCount;
                        if ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length == 0)
                            resCount = 1;
                    }
                    for (i = 0; i < count; i++) {
                        curday = (this.currentView() === "month" || (this._isCustomMonthView())) ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                        headerCellClass = (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-headerToday" : "";
                        temp = (this.currentView() === "month" || (this._isCustomMonthView())) ? { currentDay: curday, currentDateClass: "", cellToday: "" } : this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? { currentDay: ej.format(new Date(this._dateRender[i]), this._pattern.D, this.model.locale), currentDateClass: "", cellToday: headerCellClass } : { currentDay: curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: "", cellToday: headerCellClass } : { currentDay: curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass };
                        columns.push(temp);
                        this._value.push(i);
                    }
                }
                if (this._resWorkWeek) {
                    cols = $.merge(cols, columns);
                    this.dateRender = $.merge(this.dateRender, this._dateRender);
                    this.value = $.merge(this.value, this._value);
                }
                else {
                    for (var i = 0; i < resCount; i++) {
                        this.dateRender = $.merge(this.dateRender, this._dateRender);
                        cols = $.merge(cols, columns);
                        this.value = $.merge(this.value, this._value);
                    }
                }
            }
            else
                cols = this._getHorizontalheaderCellCount(this._culture);
            return cols;
        },

        _findResourceIndex: function (data, attr, value) {
            for (var i = 0; i < data.length; i++) {
                if (data[i][attr] === value) {
                    return i;
                }
            }
        },

        _renderHeaderAllDayTemplate: function () {
            if (this.currentView() != "agenda") {
                if (ej.scheduleFeatures.horizontal && this.model.orientation == "horizontal") {
                    if ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) this._renderMultipleResourceHeaderTemplate(null, null);
                    this._renderHorizontalHeaderBar();
                }
                else {
                    var headerScrollDiv = ej.buildTag("div.e-headerscrolldiv");
                    var headerDiv = ej.buildTag('div.e-headeralldaydiv', "", {}, { height: "100%" }).css({ position: "relative", overflow: "hidden" });
                    var resCount = 0;
                    var table = ej.buildTag('table.e-table e-headrealldaytable', "", {}, { cellspacing: "0px", cellpadding: "0px", width: "100%" });
                    var tbody = ej.buildTag('tbody');
                    var headTR = ej.buildTag('tr.e-dateheader');
                    var cols = this._getHeaderAllDayCellsCount();
                    var html = this.headTemplate.render({ cols: cols, view: this.currentView(), colspan: 1 });
                    if ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) {
                        tbody = this._renderMultipleResourceHeaderTemplate(tbody, cols);
                        resCount = !ej.isNullOrUndefined(this.model.group) ? this._grouping.length : 0;
                        if (this._tempResource.length != 0 && this._tempResource[0].resourceSettings.dataSource.length == 0) resCount = 0;
                    }
                    var tempNavigate = ej.buildTag('div.e-navigate', "", {}, {});
                    var inner_table = ej.buildTag('table.e-table e-headertable', "", {}, { cellspacing: "0px", cellpadding: "0px" });
                    var tb = ej.buildTag('tbody');
                    var headT = ej.buildTag('tr.e-headertr');
                    headTrCount = (this.currentView() == "month") || (this._isCustomMonthView()) ? 1 : 2;
                    var rowCount = resCount + headTrCount; var rows = [];
                    for (var i = 0; i < rowCount; i++) {
                        if (this.currentView() == "month" || (this._isCustomMonthView()))
                            rows.push({ tdClass: (i == rowCount - 1) ? "e-monthleftcells" : "e-resourceleftindentcells", divClass: (i == rowCount - 1) ? "e-dateheadercell" : "" });
                        else
                            rows.push({ tdClass: (i == rowCount - 1) ? "e-leftindent" : (i == rowCount - 2) ? "e-settingsindent" : "e-resourceleftindentcells", divClass: (i == rowCount - 1) ? "e-schedulesettings e-textellipsis" : (i == rowCount - 2) ? "e-dateheadercell" : "" });
                    }
                    if (!this.model.showAllDayRow)
                        new ej.DataManager(rows).remove("tdClass", "e-leftindent");
                    var leftIndentHtml = this.leftIndent.render({ trs: rows });
                    if (this.model.timeScale.enable)
                        this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td.e-empty').addClass((this.currentView() == "month" || this._isCustomMonthView()) ? "e-monthempty" : "").append(leftIndentHtml)).append(ej.buildTag('td').append(headerScrollDiv.append(headerDiv.append(table.append(tbody.append(headTR.append(html))))))).append(ej.buildTag('td.e-emptyscrolltd', "", {}, { width: (this.currentView() == "month" || this._isCustomMonthView()) ? "0px" : (this._mediaQuery) ? "0px" : "18px" })))))));
                    else
                        this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td').append(headerScrollDiv.append(headerDiv.append(table.append(tbody.append(headTR.append(html))))))).append(ej.buildTag('td.e-emptyscrolltd', "", {}, { width: (this.currentView() == "month" || this._isCustomMonthView()) ? "0px" : (this._mediaQuery) ? "0px" : "18px" })))))));
                    if (this.currentView() !== "month" && !this._isCustomMonthView() && this.model.timeScale.enable && this.model.showAllDayRow) {
                        var userTemplate = (!ej.isNullOrUndefined(this.model.allDayCellsTemplateId)) ? true : false;
                        if (userTemplate) { var allDayHtml = this._getUserAllDayCellsTemplate(); }
                        var allHtml = this.alldayTemp.render({ cols: cols, colspan: 1, userTemp: userTemplate, userHtml: allDayHtml });
                        tbody.append(ej.buildTag('tr').append(allHtml));
                    }
                }
            }
            else {
                var tempNavigate = ej.buildTag('div.e-navigate', "", {}, {});
                var inner_table = ej.buildTag('table.e-table e-headertable', "", {}, { cellspacing: "0px", cellpadding: "0px" });
                var tb = ej.buildTag('tbody');
                var headT = ej.buildTag('tr.e-headertr');
                var headerScrollDiv = ej.buildTag("div.e-headerscrolldiv");
                var headerDiv = ej.buildTag('div.e-headeralldaydiv', "", {}, { height: "100%" }).css({ position: "relative", overflow: "hidden" });
                var table = ej.buildTag('table.e-table e-headrealldaytable', "", {}, { cellspacing: "0px", cellpadding: "0px", width: "100%" });
                var tbody = ej.buildTag('tbody tr');
                var colspan = 1;
                var cols = [{ headertext: this._getLocalizedLabels("Date"), className: "e-datecolumn" }, { headertext: this._getLocalizedLabels("Time"), className: "e-timecolumn" }, { headertext: this._getLocalizedLabels("Event"), className: "e-eventcolumn" }];
                if (this._tempResource.length != 0 && ej.scheduleFeatures.resources) {
                    this._renderMultipleResourceHeaderTemplate(null, null);
                    var res = [];
                    for (var resLevel = 0; resLevel < this.render_Resources.length; resLevel++)
                        res.push({ headertext: "", className: "e-resourcecolumn" });
                    (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) && (cols = $.merge(res, cols));
                }
                var html = this.agendaheadTemplate.render({ cols: cols });
                this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td').append(headerScrollDiv.append(headerDiv.append(table.append(tbody.append(html)))))).append(ej.buildTag('td.e-emptyscrolltd', "", {}, { width: "18px" })))))));
            }
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderHeaderAllDayTemplate");
        },
        _getDateTime: function (args) {
            var _target = args;
            if (this.model.timeScale.enable)
                this._cellIndex = (_target.is('.e-workcells, .e-alldaycells') || this._isCustomMonthView() && this._oneWeek) ? _target.index() : 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7);
            else
                this._cellIndex = (this.model.orientation == "vertical" && this.currentView() == "month") || (this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7) : _target.index();
            if (this.model.orientation == "horizontal") {
                this._cellIndex = this.model.timeScale.enable ? this.currentView() !== "month" && !(this._isCustomMonthView()) ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : this._cellIndex : _target.index();
                this._workCellIndex = _target.parent().index();
            }
            var renderDate = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" || this.currentView() == "customview" && this._dateRender.length <= 7) ? (this._resWorkWeek) ? this._dateRender : this.dateRender : this._dateRender;
            renderDate = this.model.orientation == "horizontal" && this.currentView() == "customview" && this._dateRender.length <= 7 ? this._dateRender : renderDate;
            var curDate = new Date(renderDate[this._cellIndex]);
            if ((this.model.minDate > curDate || this.model.maxDate < curDate)) { return false; }
            if (_target.hasClass("e-workcells") && (this.model.showTimeScale) && this.currentView() !== "month" && !(this._isCustomMonthView())) {
                this._calcCurrentTime(curDate, _target, "");
            }
            else {
                this.cur_StartTime = new Date(new Date(curDate).setHours(0, 0, 0));
                this.cur_EndTime = new Date(new Date(curDate).setHours(23, 59, 59));
            }
            var result;
            if (_target.hasClass("e-horizontmonthheaderdaytd")) {
                result = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, currentDate: curDate, cellIndex: this._cellIndex, currentDate: curDate };
            }
            else {
                result = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, currentDate: curDate, cellIndex: this._cellIndex, currentDate: curDate, resources: (this._tempResource.length != 0) ? this._getResourceValue(_target, this._cellIndex) : null };
            }
            return result;
        },

        _getAgendaAppointment: function (_target) {
            var appoint = [];
            if (_target.hasClass("e-datecolumn")) {
                var rowspan = $(_target).attr('rowspan');
                var appEvents = $(_target).parent().nextAll("tr").andSelf().slice(0, parseInt(rowspan));
                if (appEvents.length > 0) {
                    for (var m = 0; m < appEvents.length; m++) {
                        var tempGUID = $(appEvents[m]).find(".e-eventcolumn .e-agendaappointment").attr('guid');
                        appoint.push(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, tempGUID))[0]);
                    }
                }
            } else {
                var appoint = _target.hasClass("e-agendaappointment") ? _target : _target.parent().find(".e-agendaappointment");
                var _appUid = appoint.attr('guid');
                if (this._mediaQuery)
                    this._mAppId = _appUid;
                appoint = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, _appUid));
            }
            return appoint;
        },

        _monthdates: function () {
            var currentDate = new Date(this.currentDate());
            var currentMonth = currentDate._currentMonthDates();
            var monthStart = currentMonth.start._currentWeekDates(this._firstdayofweek).start;
            var monthEnd = currentMonth.end._currentWeekDates(this._firstdayofweek).end;
            var dates = []; this.monthDays = [];
            var showWeekDays = this._getWeekDays();
            var monthDate = new Date(monthStart.getFullYear(), monthStart.getMonth(), monthStart.getDate());
            do {
                if (this.model.showWeekend) {
                    dates.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                    if (new Date(currentDate).getMonth() === new Date(monthDate).getMonth())
                        this.monthDays.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                }
                else {
                    var dayIndex = showWeekDays.indexOf(new Date(monthDate).getDay());
                    if (dayIndex != -1) {
                        dates.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                        if (new Date(currentDate).getMonth() === new Date(monthDate).getMonth())
                            this.monthDays.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                    }
                }
                monthDate.setDate(monthDate.getDate() + 1);
            } while (monthDate.getTime() <= monthEnd.getTime())
            return (this.model.orientation == "vertical") ? dates : this.monthDays;
        },

        _getStartEndTime: function () {
            var timerows, startendTimes = [], timelist;
            this._timeInitial = 0;
            var localizeAmPm = this._culture.calendar;
            if (this.model.orientation === "vertical") {
                if (this.currentView() == "month" || this._isCustomMonthView()) {
                    var row = this._dateRender.length, count = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    for (var i = 0; i < (row / count) ; i++) {
                        startendTimes.push(i);
                    }
                }
                else {
                    if (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) {
                        startendTimes = this._getUserTimeCellsTemplate();
                    }
                    else {
                        var dateValue = new Date(new Date().setHours(0, 0, 0, 0));

                        for (var i = this.model.startHour * 60; i < this.model.endHour * 60;) {
                            if (this._timeMode == "12") {
                                if (new Date(new Date(dateValue).setHours(this.model.endHour, 0, 0, 0)).getTime() > new Date(new Date(dateValue).setHours(0, i, 0, 0)).getTime()) {
                                    timelist = (((i / 60) === this.model.startHour || (i / 60) === 12) && (localizeAmPm.AM && localizeAmPm.PM)) ? ej.format(new Date(new Date(dateValue).setHours(0, i, 0, 0)), "hh tt", this.model.locale) : ej.format(new Date(new Date(dateValue).setHours(0, i, 0, 0)), "hh mm", this.model.locale);
                                    startendTimes.push({ time: timelist, id: (i / 60) });
                                }
                            }
                            else
                                startendTimes.push({ time: new Date(new Date(dateValue).setHours(0, i, 0, 0)).toTimeString().slice(0, 5) + " 00" });
                            i = i + this.model.timeScale.majorSlot;
                        }
                    }
                }
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                startendTimes = this._getHoriStartEndTime(localizeAmPm);
            return startendTimes;
        },

        _getWorkCellsCount: function () {
            var workcells = [], count = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
            if (this.model.timeScale.enable) {
                if (this.currentView() == "month" || (this._isCustomMonthView())) {
                    var row = this._dateRender.length;
                    for (var i = 0; i < (row / count) ; i++) {
                        workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                    }
                }
                else {
                    var strEndTime = this._getStartEndTime();
                    var value = 0;
                    for (var i = 0; i < (this.model.timeScale.minorSlotCount * strEndTime.length) ; i++) {
                        value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                        if (value > (this.model.endHour - this.model.startHour) * 60) {
                            workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                            break;
                        }
                        else
                            workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                    }
                }
            }
            else {
                var row = (this._resWorkWeek) ? 1 : this._dateRender.length;
                for (var i = 0; i < (row / count) ; i++) {
                    workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                }
            }
            return workcells;
        },

        _renderContentAreaTemplate: function () {
            var $contentAreaDiv = ej.buildTag('div.e-workareadiv');
            var $contentTable = ej.buildTag('table.e-table e-worktable', "", {}, { height: "100%", cellpadding: "0px", cellspacing: "0px", width: "100%" });
            var $contentBody = ej.buildTag('tbody');
            var $contentTR = ej.buildTag('tr');
            var $WorkCellTD = ej.buildTag('td');
            var $scrollerbarDiv = ej.buildTag('div#' + this._id + "_scroller");
            this.$WorkCellDiv = ej.buildTag('div.e-draggableworkarea').attr({ width: "100%", height: "100%" });
            if (this.currentView() != "agenda") {
                if (ej.scheduleFeatures.horizontal && this.model.orientation == "horizontal")
                    this._renderHorizontalContent($contentAreaDiv, $contentTable, $contentBody, $contentTR, $WorkCellTD, $scrollerbarDiv);
                else {
                    this.$TimeCellTD = ej.buildTag('td', "", {}, {}).addClass((this.currentView() == "month" || this._isCustomMonthView()) ? "e-monthleftindent" : "e-workleftindent");
                    var timeCellhtml, workCellhtml;
                    var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) ? true : false;
                    var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) ? true : false;
                    var viewclass = this.currentView() == "month" || (this._isCustomMonthView()) ? 1 : 0;
                    var columnValueCount = this._timeSlotCount(userTemplateId, template);
                    if ((userTemplateId || template) && (this.currentView() != "month" && !(this._isCustomMonthView()))) {
                        columnValueCount.columnCount.pop();
                        timeCellhtml = this.userTimeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, cheight: this.model.cellHeight, userTemplateId: userTemplateId, timeValue1: columnValueCount.timeValue1, template: template });
                    }
                    else
                        timeCellhtml = this.timeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, userTemplateId: userTemplateId, template: template });
                    var userTemplate = (!ej.isNullOrUndefined(this.model.workCellsTemplateId)) ? true : false;
                    if (userTemplate) { var workHtml = this._getUserWorkCellsTemplate(); }
                    if (this.currentView() != "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable)
                        workCellhtml = this.workcellTemp.render({ cellrows: this._getWorkCellsCount(), cols1: this.value, orientation: this.model.orientation, timeScale: this.model.timeScale.minorSlotCount, userTemplate: userTemplate, userHtml: workHtml });
                    else
                        workCellhtml = this.monthcellTemp.render({ cellrows: this._getWorkCellsCount(), cols1: this.value, orientation: this.model.orientation, timeScale: this.model.timeScale.minorSlotCount, userTemplate: userTemplate, userHtml: workHtml });
                    if (this.model.timeScale.enable)
                        this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append(this.$TimeCellTD.append(timeCellhtml)).append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
                    else
                        this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
                }
            }
            else
                this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv))))))));
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderContentAreaTemplate");
        },

        _renderQueryCellInfo: function (method, record, temp) {
            if (method == "renderHeaderBar") {
                this._trigger("queryCellInfo", { element: temp, requestType: "headerBar" });
            }
            if (method == "appointment") {
                this._trigger("queryCellInfo", { appointment: record, element: temp, requestType: "appointment" });
            }
            if (method == "blockAppointment") {
                this._trigger("queryCellInfo", { appointment: record, element: temp, requestType: "blockoutCells" });
            }
            if (method == "emptycell") {
                var emptytd = this.aTR.find(".e-emptyscrolltd");
                this._trigger("queryCellInfo", { element: $(emptytd[0]), requestType: "emptytd" });
            }
            if (method == "renderAgendaContent") {
                var headerCells = this.aTR.find(".e-headercells");
                for (var i = 0; i < headerCells.length; i++) {
                    this._trigger("queryCellInfo", { element: $(headerCells[i]), cellType: "agendaheadercells", requestType: "agendacells" });
                }
                var dateColumn = this.element.find(".e-draggableworkarea").find(".e-datecolumn");
                var timeColumn = this.element.find(".e-draggableworkarea").find(".e-timecolumn");
                var eventColumn = this.element.find(".e-draggableworkarea").find(".e-eventcolumn");
                if (this._tempResource.length != 0) {
                    var resourceColumn = this.element.find(".e-draggableworkarea").find(".e-resourcecolumn");
                    for (var i = 0; i < resourceColumn.length; i++) {
                        var result = this._getAgendaAppointment($(resourceColumn[i]));
                        this._trigger("queryCellInfo", { appointment: result[0], element: $(resourceColumn[i]), cellType: "agendaresourcecell", requestType: "agendacells" });
                    }
                }
                for (var i = 0; i < dateColumn.length; i++) {
                    var result = this._getAgendaAppointment($(dateColumn[i]));
                    this._trigger("queryCellInfo", { currentAppointmentDate: new Date(new Date(result[0][this._appointmentSettings['startTime']]).setHours(0, 0, 0)), appointments: result, element: $(dateColumn[i]), cellType: "agendadatecell", requestType: "agendacells" });
                }
                for (var i = 0; i < timeColumn.length; i++) {
                    var result = this._getAgendaAppointment($(timeColumn[i]));
                    this._trigger("queryCellInfo", { appointment: result[0], element: $(timeColumn[i]), cellType: "agendatimecell", requestType: "agendacells" });
                }
                for (var i = 0; i < eventColumn.length; i++) {
                    var result = this._getAgendaAppointment($(eventColumn[i]));
                    this._trigger("queryCellInfo", { appointment: result[0], element: $(eventColumn[i]), cellType: "agendaeventcell", requestType: "agendacells" });
                }
            }
            else if (method == "renderHeaderAllDayTemplate") {
                if (this.model.orientation == "vertical") {
                    var headerCells = this.aTR.find(".e-headercells");
                    var resInfo = this.res1;
                    var headerDates = this._getHeaderAllDayCellsCount();
                    this.res1 = resInfo;
                    if (this.model.showAllDayRow) {
                        var alldayElements = this.aTR.find(".e-alldaycells");
                        for (var i = 0; i < alldayElements.length; i++) {
                            var result = this._getDateTime($(alldayElements[i]));
                            var event = {
                                cellIndex: result.cellIndex,
                                currentDate: result.currentDate,
                                resources: result.resources
                            };
                            this._trigger("queryCellInfo", { cell: event, element: $(alldayElements[i]), requestType: "alldaycells" });
                        }
                    }
                    if (this.currentView() != "agenda") {
                        var numberOfDates = headerCells.length / this.res1.length;
                        for (var i = 0; i < headerCells.length; i++) {
                            var k = Math.floor(i / numberOfDates);
                            this._trigger("queryCellInfo", { resource: this.res1[k], currentDay: headerDates[i].currentDay, element: $(headerCells[i]), requestType: "headercells" });
                        }
                    }
                    if ((this._tempResource.length != 0)) {
                        var resource = [];
                        var resourceHeaderCells = this.aTR.find(".e-resourcecells");
                        var resourceHeaderDivCells = this.aTR.find(".e-resourceleftindentcells");
                        for (var j = 0; j < this._tempResource.length; j++) {
                            $.merge(resource, this._tempResource[j].resourceSettings.dataSource);
                        }
                        for (var i = 0; i < resourceHeaderCells.length; i++) {
                            this._trigger("queryCellInfo", { resource: resource[i], element: $(resourceHeaderCells[i]), cellType: "headercells", requestType: "resourceheadercells" });
                        }
                        for (var i = 0; i < resourceHeaderDivCells.length; i++) {
                            this._trigger("queryCellInfo", { element: $(resourceHeaderDivCells[i]), cellType: "headerdivcells", requestType: "resourceheadercells" });
                        }
                    }
                    if (this.currentView() != "month" || !this._isCustomMonthView()) {
                        var indent = this.aTR.find(".e-leftindent");
                        this._trigger("queryCellInfo", { element: indent, requestType: "leftindentcells" });
                    }
                    var leftHeaderCells = (this.currentView() == "month" || this._isCustomMonthView()) ? this.aTR.find(".e-monthleftcells") : this.aTR.find(".e-settingsindent");
                    this._trigger("queryCellInfo", { element: leftHeaderCells, requestType: "leftheadercells" });
                }
                else {
                    var headercells = this.aTR.find(".e-headercells");
                    var resInfo = this.res1;
                    var headerDates = this._getHeaderAllDayCellsCount();
                    this.res1 = resInfo;
                    var timeCells = this.aTR.find(".e-horizontaltimetd ");
                    var timeCellsDiv = this.aTR.find(".e-horizontalalternatetd");
                    var timeCellsStartTime = this._getStartEndTime();
                    for (var i = 0; i < timeCells.length; i++) {
                        this._trigger("queryCellInfo", { cell: timeCellsStartTime[i], element: $(timeCells[i]), cellType: "timecell", requestType: "timecells" });
                    }
                    for (var i = 0; i < timeCellsDiv.length; i++) {
                        this._trigger("queryCellInfo", { element: $(timeCellsDiv[i]), cellType: "timeampmcell", requestType: "timecells" });
                    }

                    if (this.currentView() != "agenda") {
                        for (var i = 0; i < headercells.length; i++) {
                            this._trigger("queryCellInfo", { currentDay: headerDates[i].currentDay, element: $(headercells[i]), requestType: "headercells" });
                        }
                    }
                    var dateHeader = this.aTR.find(".e-horizontmonthheaderdaytd");
                    for (var i = 0; i < dateHeader.length; i++) {
                        var result = this._getDateTime($(dateHeader[i]));
                        var event = {
                            cellIndex: result.cellIndex,
                            currentDate: result.currentDate
                        };
                        this._trigger("queryCellInfo", { cell: event, element: $(dateHeader[i]), requestType: "headerdate" });
                    }
                    if ((this._tempResource.length != 0)) {
                        var resourceGroupHeader = this.aTR.find(".e-horizontalheader");
                        for (var i = 0; i < resourceGroupHeader.length; i++) {
                            this._trigger("queryCellInfo", { element: $(resourceGroupHeader[i]), requestType: "resourcegroupheader" });
                        }
                    }
                }
            }
            else if (method == "renderContentAreaTemplate") {
                if (this.model.orientation == "vertical") {
                    var tdElements, reqType;
                    timeCellsDiv = this.wTR.find(".e-timecelldivs");
                    timeCellAMPM = this.wTR.find(".e-ampmdisplay");
                    timeCellsStartTime = this._getStartEndTime();
                    if (this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable) {
                        tdElements = this.wTR.find(".e-workcells");
                        reqType = "workcells";
                    }
                    else {
                        tdElements = this.wTR.find(".e-monthcells");
                        reqType = "monthcells";
                    }
                    for (var i = 0; i < timeCellsDiv.length; i++) {
                        this._trigger("queryCellInfo", { cell: timeCellsStartTime[i], element: $(timeCellsDiv[i]).parent(), cellType: "timecell", requestType: "timecells" });
                    }
                    for (var i = 0; i < timeCellAMPM.length; i++) {
                        this._trigger("queryCellInfo", { element: $(timeCellAMPM[i]), cellType: "timeampmcell", requestType: "timecells" });
                    }
                    for (var i = 0; i < tdElements.length; i++) {
                        var result = this._getDateTime($(tdElements[i])), event;
                        if (this.currentView() != "month" && this.currentView() != "customview" && this.model.timeScale.enable) {
                            event = {
                                cellIndex: result.cellIndex,
                                startTime: result.startTime,
                                endTime: result.endTime,
                                resources: result.resources
                            };
                        }
                        else {
                            event = {
                                cellIndex: result.cellIndex,
                                currentDate: result.currentDate,
                                resources: result.resources
                            };
                        }
                        this._trigger("queryCellInfo", { cell: event, element: $(tdElements[i]), requestType: reqType });
                    }
                }
                else {
                    var tdElements;
                    tdElements = !ej.isNullOrUndefined(this.$WorkCellDiv) ? this.$WorkCellDiv.find(".e-workcells") : null;
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.$WorkCellDiv)) {
                        var resourceHeaderCells = this.$WorkCellDiv.find(".e-resourceheadercells");
                        var resource = this._resourceSort();
                        var resourceHeader = this.wTR.find('.e-horizontresheaderdiv');
                        for (var i = 0; i < resourceHeader.length; i++) {
                            this._trigger("queryCellInfo", { resource: resource[$(resourceHeaderCells[i]).index()], element: $(resourceHeader[i]), cellType: "headerdivcells", requestType: "resourceheadercells" });
                        }
                        for (var i = 0; i < resourceHeaderCells.length; i++) {
                            this._trigger("queryCellInfo", { resource: resource[$($(resourceHeaderCells[i]).parent()).index()], element: $(resourceHeaderCells[i]), cellType: "headercells", requestType: "resourceheadercells" });
                        }
                    }
                    if (!ej.isNullOrUndefined(tdElements)) {
                        for (var i = 0; i < tdElements.length; i++) {
                            if ($(tdElements[i]).hasClass("e-childworkcell") && $(tdElements[i]).hasClass("e-workcells")) {
                                var result = this._getDateTime($(tdElements[i]));
                                var event = {
                                    cellIndex: result.cellIndex,
                                    startTime: result.startTime,
                                    endTime: result.endTime,
                                    resources: result.resources
                                };
                                this._trigger("queryCellInfo", { cell: event, element: $(tdElements[i]), requestType: "workcells" });
                            }
                        }
                    }
                }
            }
        },

        _timeSlotCount: function (userTemplateId, template) {
            var value = 0, columnValue = [], cols2 = [];
            if ((!userTemplateId && !template) || (this.currentView() === "month" || (this._isCustomMonthView()))) {
                var strTime = this._getStartEndTime();
                var lenMinorSlot = this.model.orientation == "vertical" ? this.model.timeScale.minorSlotCount : this.model.timeScale.minorSlotCount - 1;
                for (var j = 0; j < strTime.length; j++) {
                    for (var i = 0; i < lenMinorSlot; i++) {
                        var value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                        if (value > (this.model.endHour - this.model.startHour) * 60) {
                            columnValue.push(i);
                            if (i == (this.model.timeScale.minorslotcount - 2)) {
                                value = 0; break;
                            }
                        }
                        else
                            columnValue.push(i);
                    }
                    cols2.push(columnValue);
                    value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    columnValue = [];
                }
                var columnCount = cols2;
            }
            else {
                for (var i = 0; i < this.model.timeScale.minorSlotCount; i++) {
                    columnValue.push(i);
                }
                var columnCount = columnValue;
            }

            if ((userTemplateId || template) && (this.currentView() !== "month" && !(this._isCustomMonthView()))) {
                var userTemp = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
                var userTemp1 = $.templates($(this.model.timeScale.majorSlotTemplateId).html());
                var timeValue1 = [], j = 0;
                for (var i = this.model.startHour; i < this.model.endHour;) {
                    var timeValue = [];
                    var value = this.model.timeScale.majorSlot + j;
                    var jvalue = j;
                    while (j < value) {
                        var jval = j;
                        j = j * 60 * 1000;
                        if (this._timeMode == "12") {
                            if (jval == jvalue && !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId))
                                timeValue.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                            else
                                timeValue.push(userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                        }
                        else {
                            if (jval == jvalue && !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId))
                                timeValue.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                            else
                                timeValue.push(userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                        }
                        j = (j / 60000) + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    }
                    i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : j >= 60 ? i + 1 : i;
                    j = (j >= 60) ? 0 : j;

                    timeValue1.push(timeValue);
                }
                template = true;
            }
            return { columnCount: columnCount, timeValue1: timeValue1, strTime: strTime };
        },
        _renderAgendaContent: function () {
            this.element.find(".e-agendacellstab").remove();
            var dateStart = new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0));
            var row = []; var col = [];
            var startTimeDisp, endTimeDisp, date, time, subject, colorDiv, resName, userAppTemplId, userTempHtml, userDateId, userDateHtml, userTimeId, userTimeHtml, userResourceId, userResourceHtml;
            if (!this.model.group) this.res1 = ["0"];
            var repeatText = this._getLocalizedLabels("Recurrence");
            var count = this._getAgendaDateCount();
            for (var res = 0; res < this.res1.length; res++) {
                var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateStart)).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(new Date(dateStart).setDate(dateStart.getDate() + count)).setHours(23, 59, 59)));
                predicate = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                var appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(predicate));
                appList = this._appointmentSort(appList);
                if (appList.length > 0) {
                    var resGroup = [];
                    if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources) {
                        var resgroupid = this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]];
                        var resLevels = this._resCollection;
                        for (var i = resLevels.length - 1; i > 0; i--) {
                            var resApp = new ej.DataManager(resLevels[i - 1].dataSource).executeLocal(new ej.Query().where(resLevels[i - 1].id, ej.FilterOperators.equal, resgroupid));
                            resGroup.push({ resId: "resLevel_" + i + "_" + resApp[0][resLevels[i - 1].id], text: resApp[0][resLevels[i - 1].text] });
                            resgroupid = resApp[0][resLevels[i - 1].groupId];
                        }
                        resGroup.reverse();
                    }
                    var resChild = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? true : false;
                    var resRowSpan = appList.length;
                    userResourceId = (this.model.resourceHeaderTemplateId) ? true : false;
                    userResourceHtml = userResourceId ? this._getResourceHeadTemplate(this.res1[res]) : "";
                    var day = 0;
                    if (new Date(dateStart) < this.model.minDate)
                        day = Math.floor((new Date(this.model.minDate) - new Date(dateStart)) / (1000 * 60 * 60 * 24));
                    if (new Date(new Date(dateStart).setDate(dateStart.getDate() + count)) > this.model.maxDate)
                        count = count - Math.floor((new Date(new Date(dateStart).setDate(dateStart.getDate() + count)) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    for (var day; day <= count; day++) {
                        if (!this.model.showWeekend) {
                            var showWeekDays = this._getWeekDays();
                            var agendaDate = new Date(new Date(dateStart).setDate(dateStart.getDate() + day));
                            if (showWeekDays.indexOf(agendaDate.getDay()) == -1) continue;
                        }
                        var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(new Date(dateStart).setDate(dateStart.getDate() + day))).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(new Date(dateStart).setDate(dateStart.getDate() + day)).setHours(23, 59, 59)));
                        predicate = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                        var dailyapplist = new ej.DataManager(appList).executeLocal(new ej.Query().where(predicate));
                        dailyapplist = this._resourceOrderSort(dailyapplist);
                        if (dailyapplist.length > 0) {
                            row.push(row.length + 1);
                            var dayRowSpan = dailyapplist.length; var dayChild = true; var dayBorderBottom = false;
                            for (var i = 0; i < dailyapplist.length; i++) {
                                if (i == dailyapplist.length - 1) dayBorderBottom = true;
                                startTimeDisp = this._timeMode == "12" ? ej.format(dailyapplist[i][this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(dailyapplist[i][this._appointmentSettings["startTime"]], "HH:mm", this.model.locale);
                                endTimeDisp = this._timeMode == "12" ? ej.format(dailyapplist[i][this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(dailyapplist[i][this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                                date = "<strong class='e-agendaday'>" + ej.format(new Date(dailyapplist[i][this._appointmentSettings['startTime']]), 'dd', this.model.locale) + "</strong><span class='e-agendaweek'>" + ej.format(new Date(dailyapplist[i][this._appointmentSettings['startTime']]), 'dddd', this.model.locale) + "</span><span class='e-agendamonth'>" + ej.format(new Date(dailyapplist[i][this._appointmentSettings['startTime']]), 'MMM, yyyy', this.model.locale) + "</span>";
                                time = (!ej.isNullOrUndefined(dailyapplist[i][this._appointmentSettings["allDay"]]) && JSON.parse(dailyapplist[i][this._appointmentSettings["allDay"]])) ? "<div class='e-icon e-circle e-scheduleallday'></div>" + this._getLocalizedLabels("AllDay") : startTimeDisp + " - " + endTimeDisp;
                                subject = (!ej.isNullOrUndefined(dailyapplist[i][this._appointmentSettings["recurrence"]]) && JSON.parse(dailyapplist[i][this._appointmentSettings["recurrence"]])) ? dailyapplist[i][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 ? "<span class='e-icon e-schedulerepeatedit' title='" + repeatText + "'/>" + dailyapplist[i][this._appointmentSettings["subject"]] : "<span class='e-icon e-schedulerepeat' title='" + repeatText + "'/>" + dailyapplist[i][this._appointmentSettings["subject"]] : dailyapplist[i][this._appointmentSettings["subject"]];
                                colorDiv = (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(dailyapplist[i][this._appointmentSettings["categorize"]]) && dailyapplist[i][this._appointmentSettings["categorize"]] != "") ? this._getCategorizeColor(dailyapplist[i]) : ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) ? this._getResourceColor(dailyapplist[i]) : { appointData: "", appointCustomcss: "", appointtextcolor: "" };
                                resName = (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources && (this._tempResource.length != 0)) ? this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["text"]] : "";
                                userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
                                userTempHtml = userAppTemplId ? dailyapplist[i][this._appointmentSettings["recurrence"]] ? dailyapplist[i][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 ? "<span class='e-icon e-schedulerepeatedit' title='" + repeatText + "'/>" + this._getUserAppointmentTemplate(dailyapplist[i]) : "<span class='e-icon e-schedulerepeat' title='" + repeatText + "'/>" + this._getUserAppointmentTemplate(dailyapplist[i]) : this._getUserAppointmentTemplate(dailyapplist[i]) : "";
                                userDateId = (this.model.agendaViewSettings.dateColumnTemplateId) ? true : false;
                                userDateHtml = userDateId ? this._getUserTemplate(this.model.agendaViewSettings.dateColumnTemplateId, dailyapplist[i]) : "";
                                userTimeId = (this.model.agendaViewSettings.timeColumnTemplateId) ? true : false;
                                userTimeHtml = userTimeId ? this._getUserTemplate(this.model.agendaViewSettings.timeColumnTemplateId, dailyapplist[i]) : "";
                                col.push({ readOnly: this.model.readOnly, edittext: this._getLocalizedLabels("Edit"), deletetext: this._getLocalizedLabels("Delete"), userResourceId: userResourceId, userResourceHtml: userResourceHtml, userDateId: userDateId, userDateHtml: userDateHtml, userTimeId: userTimeId, userTimeHtml: userTimeHtml, userAppTemplId: userAppTemplId, userTemplate: userTempHtml, resGroup: resGroup, resName: resName, resChild: resChild, resRowSpan: resRowSpan, id: dailyapplist[i]["AppTaskId"], uid: dailyapplist[i].Guid, dayRowSpan: dailyapplist.length, dayChild: dayChild, dayBorderBottom: dayBorderBottom, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorDiv.applyFilter) ? true : false, background: colorDiv.appointData, date: date, time: time, event: subject });
                                dayChild = false; resChild = false;
                            }
                        }
                    }
                }
            }
            var workCellhtml = this.agendacellTemp.render({ rows: row, cols: col });
            this.element.find(".e-draggableworkarea").append(workCellhtml);
            if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                var resLevels = this.render_Resources;
                for (var i = 0; i < resLevels.length - 1; i++) {
                    for (var j = 0; j < resLevels[i].length; j++) {
                        var cname = "resLevel_" + (i + 1) + "_" + resLevels[i][j][this._resCollection[i].id];
                        this.element.find("." + cname).first().attr('rowspan', this.element.find("." + cname).length);
                        this.element.find("." + cname).slice(1).addClass("e-hide");
                        this.element.find(".e-hide").remove();
                        (this.model.resourceHeaderTemplateId) && (this.element.find("." + cname).children().empty().append(this._getResourceHeadTemplate(resLevels[i][j])));
                    }
                }
            }
            var _scrollDiv = this.element.find('div#' + this._id + "_scroller");
            if (ej.isNullOrUndefined(_scrollDiv.data("ejScroller"))) {
                _scrollDiv.ejScroller({
                    enableRTL: this.model.enableRTL, height: this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top) - 1, width: parseInt(this.element.width()) - 2, cssClass: this.model.cssClass
                });
                (!this._mediaQuery) && this._nextPrevAppointment(this.model.showAppointmentNavigator);
            }
            _scrollDiv.ejScroller('refresh');
            var border = this.model.enableRTL ? "e-borderright" : "e-borderleft";
            _scrollDiv.ejScroller("isVScroll") ? (this.element.find(".e-emptyscrolltd").addClass(border).show() && this.element.find('.e-draggableworkarea').height(this.element.find('.e-draggableworkarea').height() + 1)) : this.element.find(".e-emptyscrolltd").removeClass(border).hide();
            this.element.find(".e-vscroll").css("left", (this.model.enableRTL) ? 0 : this.element.outerWidth() - (_scrollDiv.ejScroller("isVScroll") ? 19 : 0));
            this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
            this.element.find(".e-headrealldaytable").parent().width(this.element.find(".e-draggableworkarea").width());
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderAgendaContent");
        },

        _getUserTemplate: function (id, record) {
            var cloneObj = $.extend(cloneObj, record);
            cloneObj.View = this.currentView();
            return $.templates($(id).html()).render(cloneObj);
        },

        _getColumnCount: function () {
            var weekcells = [];
            var daysCount = (this.currentView() === "month" || this._isCustomMonthView()) ? this._isCustomMonthView() ? this._renderDays <= 7 ? this._renderDays : (this.model.showWeekend) ? 7 : this.model.workWeek.length : (this.model.showWeekend) ? 7 : this.model.workWeek.length : this._dateRender.length;
            for (var i = 0; i < daysCount; i++) weekcells.push(i);
            return weekcells;
        },

        _bindAppointmentsData: function (currentAction) {
            if (!ej.isNullOrUndefined(this.model.appointmentSettings) && this.dataSource() != null) {
                if (this.model.enablePersistence) {
                    this.model.appointmentSettings.query = new ej.Query();
                    this._enablePersist = true;
                }
                if (!this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.offline)
                    this._dateFormat(this.dataSource());
                if (this.dataSource() instanceof ej.DataManager && !this.dataSource().dataSource.offline) {
                    this._initDataSource(currentAction);
                }
                else {
                    this._bindAppointments = (this.dataSource().length > 0) ? true : false;
                    var viewchange = (currentAction == "Refresh") ? false : this._viewchange;
                    this._angular = this._bindAppointments && (!this._bindapp && !this._setmodelvalue && viewchange == true && this._obj.length > 0 && this.dataSource()[0][this._appointmentSettings["id"]] == this._obj[0][this._appointmentSettings["id"]]);
                    this._true = this.model.isDST == true ? true : false;
                    if (ej.isNullOrUndefined(this.model.timeZone) && this.model.isDST == false)
                        this._timeZoneOffset = new Date().getTimezoneOffset() - this._stdTimezoneOffset();
                    else
                        this._timeZoneOffset = 0;
                    this._currentAppointmentData = this.dataSource();
                    $.extend(true, this._obj = [], this.dataSource());
                    !ej.isNullOrUndefined(this.dataSource().dataSource) && this.dataSource().dataSource.json && (this._currentAppointmentData = this.dataSource().dataSource.json);
                    this._dataCount = this._currentAppointmentData.length;
                    if (this._dataCount > 0) {
                        this._dataProcessing(this._currentAppointmentData);
                        (this.element.children().length > 0) && this._renderAppointmentAll();
                    }
                    if (this.model.showAppointmentNavigator) this._nextPrevButton();
                    this.tzone = this.model.timeZone;
                    this._bindapp = false;
                    this._setmodelvalue = false;
                    this._viewchange = false;
                }
            }
            else
                if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _initDataSource: function (currentAction) {
            this._trigger("actionBegin", { currentAction: currentAction, requestType: "dataBinding" });
            var query = this._columnToSelect(this.model.appointmentSettings, currentAction);
            var tempQuery = $.extend(true, [], query._params);
            this._true = this.model.isDST == true ? true : false;
            this._timeZoneOffset = (ej.isNullOrUndefined(this.model.timeZone) && this.model.isDST == false) ? new Date().getTimezoneOffset() - this._stdTimezoneOffset() : 0;
            query._params = [];
            var value = new Date(new Date(this.currentDate()).setHours(0, 0, 0));
            var temp = new Date(value.getTime() + (-(this._timeZoneCalculate()) * 60000));
            query.addParams("CurrentDate", temp).addParams("CurrentView", this.currentView()).addParams("CurrentAction", currentAction);
            for (var i = 0; i < tempQuery.length; i++) {
                if (tempQuery[i].key != "CurrentDate" && tempQuery[i].key != "CurrentView" && tempQuery[i].key != "CurrentAction") {
                    query.addParams(tempQuery[i].key, tempQuery[i].value);
                }
            }
            var proxy = this, queryPromise = this.dataSource().executeQuery(query);
            queryPromise.done(function (e) {
                proxy._dataCount = e.result.length;
                if (!ej.isNullOrUndefined(e.result.result)) {
                    proxy._dataCount = e.result.count + 1;
                    e.result = e.result.result;
                }
                proxy._bindAppointments = (e.result.length > 0) ? true : false;
                proxy._currentAppointmentData = e.result;
                proxy._dataProcessing(e.result);
                proxy._renderAppointmentAll();
                if (proxy.model.showAppointmentNavigator) proxy._nextPrevButton();
                proxy._trigger("actionComplete", { requestType: "dataBound" });
            });
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _bindCategorizeData: function () {
            if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {
                this._categoryInfo = [];
                if (ej.isNullOrUndefined(this.model.categorizeSettings.query) || !(this.model.categorizeSettings.query instanceof ej.Query))
                    this.model.categorizeSettings.query = ej.Query();
                if (this.model.categorizeSettings.dataSource instanceof ej.DataManager)
                    this._initCategorizeData(this.model.categorizeSettings);
                else {
                    this._categoryInfo.push(this.model.categorizeSettings);
                }
            }
        },

        _initCategorizeData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this, queryCategoryPromise = fields.dataSource.executeQuery(query);
            queryCategoryPromise.done(function (e) {
                if (ej.isNullOrUndefined(proxy._appointmentAddWindow)) proxy._renderAppointmentWindow();
                fields.dataSource = e.result;
                proxy._categoryInfo.push(fields);
                proxy._renderCategoryItems(proxy._appointmentAddWindow);
            });
        },

        _bindPriorityData: function () {
            if (!ej.isNullOrUndefined(this.model.prioritySettings)) {
                this._priorityInfo = [];
                if (ej.isNullOrUndefined(this.model.prioritySettings.query) || !(this.model.prioritySettings.query instanceof ej.Query))
                    this.model.prioritySettings.query = ej.Query();
                if (this.model.prioritySettings.dataSource instanceof ej.DataManager)
                    this._initPriorityData(this.model.prioritySettings);
                else {
                    this._priorityInfo.push(this.model.prioritySettings);
                }
            }
        },

        _initPriorityData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this, queryPriorityPromise = fields.dataSource.executeQuery(query);
            queryPriorityPromise.done(function (e) {
                if (ej.isNullOrUndefined(proxy._appointmentAddWindow)) proxy._renderAppointmentWindow();
                fields.dataSource = e.result;
                proxy._priorityInfo.push(fields);
                proxy._renderPriorityItems(proxy._appointmentAddWindow);
            });
        },

        _bindBlockData: function () {
            if (!ej.isNullOrUndefined(this.model.blockoutSettings)) {
                if (ej.isNullOrUndefined(this.model.blockoutSettings.query) || !(this.model.blockoutSettings.query instanceof ej.Query))
                    this.model.blockoutSettings.query = ej.Query();
                if (this.model.blockoutSettings.dataSource instanceof ej.DataManager) {
                    var query = this._columnToSelect(this.model.blockoutSettings);
                    var proxy = this, queryPromise = this.model.blockoutSettings.dataSource.executeQuery(query);
                    queryPromise.done(function (e) {
                        proxy.model.blockoutSettings.dataSource = e.result;
                        proxy._renderBlockAppointments();
                    });
                }
            }
        },

        _dateFormat: function (appointments) {
            if (appointments.length > 0) {
                if (new Date(appointments[0][this._appointmentSettings["startTime"]]).toString() == "Invalid Date") {
                    for (var i = 0, len = appointments.length; i < len; i++) {
                        appointments[i][this._appointmentSettings["startTime"]] = (new Date()).parseISO8601(appointments[i][this._appointmentSettings["startTime"]]);
                        appointments[i][this._appointmentSettings["endTime"]] = (new Date()).parseISO8601(appointments[i][this._appointmentSettings["endTime"]]);
                    }
                }
            }
        },

        _columnToSelect: function (mapper, currentAction) {
            var column = [], queryManager = ej.Query();
            if (!ej.isNullOrUndefined(mapper.tableName) && !this.dataSource().dataSource.url.match(mapper.tableName + "$")) {
                queryManager = mapper.query;
                queryManager.from(mapper.tableName);
            }
            else
                queryManager = mapper.query;
            return queryManager;
        },

        _getColumns: function (mapper) {
            var column = [];
            for (var col in mapper) {
                if (col !== "tableName" && col !== "query" && col !== "dataSource")
                    !ej.isNullOrUndefined(mapper[col]) && column.push(mapper[col]);
            }
            return column;
        },

        _sortAppById: function (appointments) {
            appointments.sort(function (a, b) {
                var x = a["AppTaskId"]; var y = b["AppTaskId"];
                return ((x < y) ? -1 : ((x > y) ? 1 : 0));
            });
            return appointments;
        },
        _stdTimezoneOffset: function () {
            return Math.max(new Date(new Date().getFullYear(), 0, 1).getTimezoneOffset(), new Date(new Date().getFullYear(), 6, 1).getTimezoneOffset());
        },
        _timeZoneCalculate: function (appointment) {
            var utc, timezone, oldtimezone, hour, mins, modelutc, oldhour, oldmins, oldmodelutc, localutc = (new Date().toString().indexOf("Daylight Time") != -1 && this.model.isDST == false) ? -(new Date().getTimezoneOffset()) - this._timeZoneOffset : -(new Date().getTimezoneOffset());
            utc = localutc;
            if (!ej.isNullOrUndefined(this.model.timeZone)) {
                if (this.model.timeZone.indexOf(':') !== -1) {
                    if (ej.isNullOrUndefined(this.tzone)) this.tzone = this.model.timeZone;
                    timezone = this.model.timeZone.split(" ")[this.model.timeZone.split(" ").length - 1].split(":");
                    oldtimezone = this.tzone.split(" ")[this.tzone.split(" ").length - 1].split(":");
                    if (($.isNumeric(parseInt(timezone[0])) && (parseInt(timezone[0])).toString.length <= 2) || timezone[0].indexOf("UTC") !== -1) {
                        hour = this.model.timeZone.indexOf("-") !== -1 ? -parseInt(timezone[0].replace(/\D/g, '')) : parseInt(timezone[0].replace(/\D/g, ''));
                        mins = parseInt(timezone[1]);
                        modelutc = -((hour * 60) + mins);
                        if (this._setmodelvalue == true) {
                            if (this.tzone == this.model.timeZone) utc = -(-localutc + modelutc);
                            else {
                                oldhour = this.tzone.indexOf("-") !== -1 ? -parseInt(oldtimezone[0].replace(/\D/g, '')) : parseInt(oldtimezone[0].replace(/\D/g, ''));
                                oldmins = parseInt(oldtimezone[1]);
                                oldmodelutc = -((oldhour * 60) + oldmins);
                                utc = -(-oldmodelutc + modelutc);
                            }
                        }
                        else utc = -modelutc;
                    }
                    else utc = -localutc;
                }
                else utc = -localutc;
            }
            return utc;
        },
        _timeZoneAppointments: function (appoint, app) {
            if (this.model.appointmentSettings.applyTimeOffset) {
                var tempStartTime, tempEndTime, startUtc, endUtc, difference, startTime, endTime;
                if (!appoint[this._appointmentSettings["allDay"]]) {
                    if (ej.isNullOrUndefined(this._dayLight)) {
                        startUtc = appoint[this._appointmentSettings["startTimeZone"]];
                        endUtc = appoint[this._appointmentSettings["endTimeZone"]];
                        if (ej.isNullOrUndefined(endUtc) && !ej.isNullOrUndefined(startUtc)) appoint[this._appointmentSettings["endTimeZone"]] = endUtc = startUtc;
                        if (!ej.isNullOrUndefined(endUtc) && ej.isNullOrUndefined(startUtc)) appoint[this._appointmentSettings["startTimeZone"]] = startUtc = endUtc;
                        if (!ej.isNullOrUndefined(startUtc) && !ej.isNullOrUndefined(endUtc)) {
                            startUtc = startUtc.indexOf("UTC") != -1 ? parseInt(startUtc.split(" ")[1].split(":")[0]) * 60 + parseInt(startUtc.split(" ")[1].split(":")[1]) : parseInt(startUtc.split(":")[0]) * 60 + parseInt(startUtc.split(":")[1]);
                            endUtc = endUtc.indexOf("UTC") != -1 ? parseInt(endUtc.split(" ")[1].split(":")[0]) * 60 + parseInt(endUtc.split(" ")[1].split(":")[1]) : parseInt(endUtc.split(":")[0]) * 60 + parseInt(endUtc.split(':')[1]);
                        }
                        difference = (ej.isNullOrUndefined(startUtc) && !$.isNumeric(startUtc)) ? this._timeZoneCalculate(appoint) : startUtc - this._timeZoneCalculate(appoint);
                    }
                    else difference = this._timeValue;
                    difference = (app == "") ? -difference : difference;
                    tempStartTime = new Date(appoint[this._appointmentSettings["startTime"]]);
                    tempEndTime = new Date(appoint[this._appointmentSettings["endTime"]]);
                    if (appoint[this._appointmentSettings["allDay"]] && (Math.round((new Date(appoint[this._appointmentSettings["endTime"]]) - new Date(appoint[this._appointmentSettings["startTime"]])) / 3600000) < 24))
                        return appoint;
                    else {
                        appoint[this._appointmentSettings["startTime"]] = new Date(tempStartTime.setMinutes(tempStartTime.getMinutes() + difference));
                        appoint[this._appointmentSettings["endTime"]] = new Date(tempEndTime.setMinutes(tempEndTime.getMinutes() + difference));
                        return appoint;
                    }
                }
                else {
                    appoint[this._appointmentSettings["startTime"]] = new Date(appoint[this._appointmentSettings["startTime"]]);
                    appoint[this._appointmentSettings["endTime"]] = new Date(appoint[this._appointmentSettings["endTime"]]);
                }
                return appoint;
            }
            return appoint;
        },
        _processtimeZone: function (record, app) {
            var tempstarttime = new Date(record[this.model.blockoutSettings["startTime"]]), tempendtime = new Date(record[this.model.blockoutSettings["endTime"]]);
            if (!record[this.model.blockoutSettings["isAllDay"]]) {
                var difference = this._timeZoneCalculate(record);
                record[this.model.blockoutSettings["startTime"]] = new Date(tempstarttime.setMinutes(tempstarttime.getMinutes() + difference));
                record[this.model.blockoutSettings["endTime"]] = new Date(tempendtime.setMinutes(tempendtime.getMinutes() + difference));
            }
            else {
                record[this.model.blockoutSettings["startTime"]] = new Date(tempstarttime.getFullYear(), tempstarttime.getMonth(), tempstarttime.getDate());
                record[this.model.blockoutSettings["endTime"]] = new Date(tempendtime.getFullYear(), tempendtime.getMonth(), tempendtime.getDate(), 23, 59, 59);
            }
            return record;
        },

        _dataProcessing: function (appointments) {
            this._processed = [];
            this._appMainId = null;
            if (appointments.length > 0) {
                var appId = this._sortAppById(appointments);
                this._maxId = (ej.isNullOrUndefined(appointments[0]) || ej.isNullOrUndefined(appointments[0].AppTaskId)) ? 1 : appointments[0].AppTaskId;
                for (var app = 0; app < appointments.length; app++) {
                    appointments[app][this._appointmentSettings["startTime"]] = (new Date()).parseISO8601(appointments[app][this._appointmentSettings["startTime"]]);
                    appointments[app][this._appointmentSettings["endTime"]] = (new Date()).parseISO8601(appointments[app][this._appointmentSettings["endTime"]]);
                    if (this._bindAppointments == true && !this._angular && !this._setmodelvalue && this._applyTimeOffset && ej.isNullOrUndefined(this._enablePersist)) {
                        var appoint = this._timeZoneAppointments(appointments[app], "reverse");
                        this._appointmentProcessing(appoint);
                    }
                    else
                        this._appointmentProcessing(appointments[app]);
                }
                this._bindAppointments = false;
                this._setmodelvalue = false;
                this._processed = this._sortAppById(this._processed);
                return this._processed;
            }
        },
        _guidFormatGenerate: function () {
            function guid() {
                return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
            }
            return guid() + guid() + '-' + guid() + '-' + guid() + '-' + guid() + '-' + guid() + guid() + guid();
        },
        _RecurrenceAppointment: function (appointment) {
            ej.RecurrenceEditor.prototype._initializePrivateProperties();
            var recurEdit = ej.RecurrenceEditor.prototype;
            recurEdit._rRule = {};
            appointment.AppTaskId = ej.isNullOrUndefined(appointment.AppTaskId) ? this._maxId : appointment.AppTaskId;
            ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
            recurEdit.model.startDate = new Date(this.currentDate());
            var collection = recurEdit.recurrenceDateGenerator(appointment[this._appointmentSettings["recurrenceRule"]], appointment[this._appointmentSettings["startTime"]], appointment[this._appointmentSettings["recurrenceExDate"]]);
            var i = 0;
            var newArray = collection;
            while (i < newArray.length) {
                var newAppointment = {}, orgStrTime = new Date(newArray[i]), orgEndTime = appointment[this._appointmentSettings["endTime"]];
                ((recurEdit._rRule.freq == "MONTHLY" || recurEdit._rRule.freq == "YEARLY") && !ej.isNullOrUndefined(recurEdit._rRule.setPositions)) && (orgStrTime = recurEdit._dayOfWeekInMonth(orgStrTime, recurEdit._rRule.weekDays, recurEdit._rRule.setPositions));
                var strTime = new Date(orgStrTime.getFullYear(), orgStrTime.getMonth(), orgStrTime.getDate(), new Date(appointment[this._appointmentSettings["startTime"]]).getHours(), new Date(appointment[this._appointmentSettings["startTime"]]).getMinutes(), new Date(appointment[this._appointmentSettings["startTime"]]).getSeconds());
                var endTime = new Date(new Date(strTime).setMilliseconds(appointment[this._appointmentSettings["endTime"]].getTime() - appointment[this._appointmentSettings["startTime"]].getTime()));
                this._idChecking();
                appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] || appointment[this._appointmentSettings["id"]] || appointment.AppTaskId);
                appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]];
                if (!ej.isNullOrUndefined(recurEdit._rRule.exDate)) {
                    if (recurEdit._rRule.exDate.indexOf(ej.format(new Date(orgStrTime), this._pattern.d, this.model.locale)) == -1) {
                        newAppointment = this._addAppData(appointment, this._maxId, strTime, endTime, appointment.ParentId);
                    }
                }
                else
                    newAppointment = this._addAppData(appointment, this._maxId, strTime, endTime, appointment.ParentId);

                if ((new Date(new Date(appointment[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(appointment[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((appointment[this._appointmentSettings["endTime"]] - appointment[this._appointmentSettings["startTime"]]) / 3600000) < 24) && (appointment[this._appointmentSettings["allDay"]] !== true)) {
                    newAppointment.Guid = this._guidFormatGenerate();
                    this._multipleDayApp(newAppointment, this._maxId, newAppointment[this._appointmentSettings["startTime"]], endTime);
                }
                else if (Math.round((newAppointment[this._appointmentSettings["endTime"]] - newAppointment[this._appointmentSettings["startTime"]]) / 3600000) > 24) {
                    newAppointment.Guid = this._guidFormatGenerate();
                    this._multipleSplit(newAppointment, this._maxId, newAppointment[this._appointmentSettings["startTime"]], newAppointment[this._appointmentSettings["endTime"]]);
                }
                else {
                    if (!$.isEmptyObject(newAppointment)) {
                        newAppointment.Guid = this._guidFormatGenerate();
                        this._processed.push(newAppointment);
                    }
                }
                i++;
                this._maxId++;
            }
        },

        _recurrenceAppSort: function (apps) {
            var splitProcessed = [];
            for (var a = 0; a < apps.length; a++) {
                var obj = new ej.DataManager(apps).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, apps[a]["Guid"]));
                if (obj.length > 1) {
                    var tempObj = $.extend(true, [], obj);
                    tempObj[0][this._appointmentSettings["endTime"]] = tempObj[tempObj.length - 1][this._appointmentSettings["endTime"]];
                    splitProcessed.push(tempObj[0]);
                    a++;
                }
                else
                    splitProcessed.push(apps[a]);
            }
            return splitProcessed;
        },
        _appointmentProcessing: function (appointment) {
            this._maxId = !ej.isNullOrUndefined(this._appMainId) ? parseInt(this._appMainId) + 1 : parseInt(this._maxId);
            var recurEdit = ej.RecurrenceEditor.prototype;
            recurEdit._rRule = {};
            if (!ej.isNullOrUndefined(appointment[this._appointmentSettings["recurrence"]]) && !ej.isNullOrUndefined(appointment[this._appointmentSettings["recurrenceRule"]]))
                recurEdit.recurrenceRuleSplit(appointment[this._appointmentSettings["recurrenceRule"]], appointment[this._appointmentSettings["recurrenceExDate"]]);
            if (appointment[this._appointmentSettings["recurrence"]] == 1 && ej.isNullOrUndefined(recurEdit._rRule.recurEditId)) {
                this._RecurrenceAppointment(appointment);
            }
            else if ((new Date(new Date(appointment[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(appointment[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((appointment[this._appointmentSettings["endTime"]] - appointment[this._appointmentSettings["startTime"]]) / 3600000) < 24) && (appointment[this._appointmentSettings["allDay"]] !== true) && ((appointment[this._appointmentSettings["recurrence"]] && !ej.isNullOrUndefined(recurEdit._rRule.recurEditId)) || !appointment[this._appointmentSettings["recurrence"]])) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (!ej.isNullOrUndefined(recurEdit._rRule.recurEditId) ? recurEdit._rRule.recurEditId : appointment[this._appointmentSettings["id"]]);
                if (appointment[this._appointmentSettings["recurrence"]]) {
                    appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] == null ? appointment["ParentId"] : appointment[this._appointmentSettings["recurrenceId"]]);
                }
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                this._maxId = appointment.AppTaskId;
                this._multipleDayApp(appointment, this._maxId, appointment[this._appointmentSettings["startTime"]], appointment[this._appointmentSettings["endTime"]]);
            }
            else if ((((appointment[this._appointmentSettings["endTime"]] - appointment[this._appointmentSettings["startTime"]]) / 3600000) >= 24)) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (!ej.isNullOrUndefined(recurEdit._rRule.recurEditId) ? recurEdit._rRule.recurEditId : appointment[this._appointmentSettings["id"]]);
                if (appointment[this._appointmentSettings["recurrence"]]) {
                    appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] == null ? appointment["ParentId"] : appointment[this._appointmentSettings["recurrenceId"]]);
                }
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                this._maxId = appointment.AppTaskId;
                this._multipleSplit(appointment, this._maxId, appointment[this._appointmentSettings["startTime"]], appointment[this._appointmentSettings["endTime"]]);
            }
            else if ((appointment[this._appointmentSettings["recurrence"]] == 0 || !ej.isNullOrUndefined(recurEdit._rRule.recurEditId))) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (!ej.isNullOrUndefined(recurEdit._rRule.recurEditId) ? recurEdit._rRule.recurEditId : appointment[this._appointmentSettings["id"]]);
                if (appointment[this._appointmentSettings["recurrence"]]) {
                    appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] == null ? appointment["ParentId"] : appointment[this._appointmentSettings["recurrenceId"]]);
                }
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                this._processed.push(appointment);
            }
            else if (((appointment[this._appointmentSettings["recurrence"]] == undefined) || (appointment[this._appointmentSettings["allDay"]] == undefined)) && !appointment[this._appointmentSettings["recurrence"]]) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (appointment[this._appointmentSettings["id"]]);
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                appointment.RecurrenceId = appointment.recurrenceExDate = null;
                this._processed.push(appointment);
            }
            this._appMainId = (ej.isNullOrUndefined(this._appMainId) || this._appMainId < this._maxId) ? this._maxId : this._appMainId;
        },
        _idChecking: function () {
            for (var i = 0; i < this._currentAppointmentData.length ; i++) {
                var query = new ej.Query().where("AppTaskId", ej.FilterOperators.equal, this._maxId);
                var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                if (_editApp.length == 0) { this._maxId; break; }
                else
                    this._maxId++;
            }
            for (; ;) {
                var query = new ej.Query().where("AppTaskId", ej.FilterOperators.equal, this._maxId);
                var _editApp = new ej.DataManager(this._processed).executeLocal(query);
                if (_editApp.length == 0) { this._maxId; break; }
                else
                    this._maxId++;
            }
            return this._maxId
        },

        _getTotalDays: function (strDate, endDate) {
            var showWeekDays = this._getWeekDays();
            var firstDate = new Date(strDate), count = 0;
            do {
                count = showWeekDays.indexOf(firstDate.getDay()) != -1 ? count + 1 : count;
                firstDate = new Date(new Date(firstDate).getTime() + (1000 * 60 * 60 * 24));
            } while (new Date(firstDate.getFullYear(), firstDate.getMonth(), firstDate.getDate()).getTime() <= new Date(endDate).getTime())
            return count;
        },

        _getPrevNextDateCount: function (date, type) {
            var showWeekDays = this._getWeekDays();
            var currentDate = new Date(date), count = 0;
            while (showWeekDays.indexOf(currentDate.getDay()) < 0) {
                currentDate = (type == "next") ? new Date(new Date(currentDate).getTime() + (1000 * 60 * 60 * 24)) : new Date(new Date(currentDate).getTime() - (1000 * 60 * 60 * 24));
                count++;
            }
            return count;
        },

        _multipleDayApp: function (app, maxId, startTime, endTime) {
            if (endTime.getHours() == 0 && endTime.getMinutes() == 0) endTime = new Date(endTime.getTime() - 1000);
            var dayStart = new Date(startTime), dayEnd = new Date(endTime);
            if ((this.model.orientation == "vertical") || ((this.model.orientation == "horizontal") && (startTime < new Date(this._dateRender[0]) || endTime > new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)))))
                dayEnd = new Date(new Date(startTime).setHours(23, 59, 59));
            while (dayStart >= new Date(startTime) && dayStart <= dayEnd && dayEnd <= new Date(endTime)) {
                this._processed.push(this._addAppData(app, maxId, dayStart, dayEnd, app.ParentId));
                dayStart = new Date(new Date(dayEnd).setHours(24, 0, 0));
                dayEnd = app[this._appointmentSettings["endTime"]];
                this._maxId = maxId = this._idChecking();
            }
        },

        _multipleSplit: function (app, maxId, startTime, endTime) {
            startTime = new Date(startTime);
            if (this.currentView() == "workweek" && !this._resWorkWeek && $.inArray(new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate()).getTime(), this._dateRender) == -1) {
                for (var i = 1; i < this._dateRender.length; i++) {
                    if ($.inArray(new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate() + i).getTime(), this._dateRender) >= 0) {
                        var index = $.inArray(new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate() + i).getTime(), this._dateRender);
                        startTime = new Date(this._dateRender[index]);
                        break;
                    }
                }
                if (this.currentView() == "workweek" && !this._resWorkWeek && this.model.orientation == "horizontal" && $.inArray(new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate()).getTime(), this._dateRender) == -1) {
                    startTime = new Date(new Date(startTime).getFullYear(), new Date(startTime).getMonth(), new Date(startTime).getDate() + (7 - this._dateRender.length));
                }
            }
            var appstarttime = new Date(new Date(startTime).getFullYear(), new Date(startTime).getMonth(), new Date(startTime).getDate(), new Date(startTime).getHours(), new Date(startTime).getMinutes(), new Date(startTime).getSeconds());
            var end = new Date(new Date(endTime).getFullYear(), new Date(endTime).getMonth(), new Date(endTime).getDate(), 23, 59, 59);
            while (appstarttime <= end) {
                var differDate = 0, day_start = new Date(appstarttime);
                if (this.currentView() !== "day" && this.currentView() != "agenda") {
                    var weekDate = (day_start)._currentWeekDates(this._firstdayofweek);
                    if (!this._isCustomMonthView() && this._oneWeek) {
                        appstarttime = (new Date(new Date(day_start).getFullYear(), new Date(day_start).getMonth(), new Date(day_start).getDate()));
                        differDate = (this._dateRender.indexOf(appstarttime.getTime()) != -1) ? (this._dateRender.length - 1) - this._dateRender.indexOf(appstarttime.getTime()) : (appstarttime.getTime() < new Date(this._dateRender[0]).getTime()) ? ((new Date(new Date(this._dateRender[0]).setDate(new Date(this._dateRender[0]).getDate() - 1)).getTime() - new Date(appstarttime).setHours(0, 0, 0, 0)) / 3600000) / 24 : (appstarttime.getTime() > new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)) ? this._dateRender.length - 1 : 0;
                    }
                    else if (this.currentView() == "month" && (this.model.orientation == "horizontal" || !this.model.showNextPrevMonth && new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1).getTime() != new Date(appstarttime.getFullYear(), appstarttime.getMonth(), 1).getTime())) {
                        differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
                    }
                    else {
                        var index = (this.currentView() == "workweek" && !this._resWorkWeek && this._firstdayofweek == 0) ? (weekDate.end.getDay() - new Date(this._dateRender[this._dateRender.length - 1]).getDay()) : 0;
                        differDate = ((weekDate.end.getTime() - new Date(day_start).setHours(0, 0, 0)) / (1000 * 60 * 60 * 24)) - index;
                    }
                }
                var nextDay = new Date(appstarttime.getFullYear(), appstarttime.getMonth(), appstarttime.getDate() + differDate);
                var day_end = (new Date(nextDay).getDate() == new Date(end).getDate() && this.currentView() !== "month") ? new Date(new Date(nextDay).setHours(endTime.getHours(), endTime.getMinutes(), endTime.getSeconds())) : new Date(new Date(nextDay).setHours(23, 59, 59));
                if ((day_end >= new Date(endTime)) && this.currentView !== "day")
                    day_end = app[this._appointmentSettings["endTime"]];
                if (!this.model.showNextPrevMonth && this.currentView() == "month" && new Date(appstarttime.getFullYear(), appstarttime.getMonth(), 1).getTime() != new Date(day_end.getFullYear(), day_end.getMonth(), 1).getTime())
                    day_end = new Date(appstarttime.getFullYear(), appstarttime.getMonth() + 1, 0, day_end.getHours(), day_end.getMinutes(), day_end.getSeconds());
                appointment = this._addAppData(app, maxId, day_start, day_end, app["ParentId"]);
                this._processed.push(appointment);
                this._maxId = maxId = this._idChecking();
                var noOfDays = (this.model.showWeekend) ? (this.currentView() == "workweek" && this._firstdayofweek == 0) ? (7 - this.model.workWeek.length) + 1 : 1 : this._getPrevNextDateCount(new Date(new Date(day_end).setHours(0, 0, 0, 0) + (1000 * 60 * 60 * 24)), "next") + 1;
                appstarttime = new Date(new Date(day_end).getFullYear(), new Date(day_end).getMonth(), new Date(day_end).getDate() + noOfDays);
            }
        },

        _deleteOcurrence: function (appId, date) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            (ej.isNullOrUndefined(this._appointmentAddWindow)) && ej.RecurrenceEditor.prototype._initializePrivateProperties();
            var recurEdit = (!ej.isNullOrUndefined(this._appointmentAddWindow)) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
            var query = new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, appId);
            var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
            if ((this._currentAction == "delete" || this._currentAction == "editOccurrence") && _editApp[0][this._appointmentSettings["endTime"]].getDay() > _editApp[0][this._appointmentSettings["startTime"]].getDay()) {
                var objDate = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this._appointmentSettings["startTime"], ej.FilterOperators.equal, date));
                objDate = objDate.length == 0 ? this._objDate : objDate;
                objDate = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, objDate[0]["AppTaskId"]));
            }
            if (!ej.isNullOrUndefined(_editApp) && !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceRule"]])) {
                var _rRule = _editApp[0][this._appointmentSettings["recurrenceRule"]];
                recurEdit.recurrenceRuleSplit(_rRule, _editApp[0][this._appointmentSettings["recurrenceExDate"]]);
                if (ej.isNullOrUndefined(recurEdit._rRule.exDate)) {
                    if ((this._currentAction == "delete" || this._currentAction == "editOccurrence") && _editApp[0][this._appointmentSettings["endTime"]].getDay() > _editApp[0][this._appointmentSettings["startTime"]].getDay()) {
                        if (objDate[0][this._appointmentSettings["startTime"]].getDay() == objDate[0][this._appointmentSettings["endTime"]].getDay()) {
                            date = objDate[0][this._appointmentSettings["startTime"]];
                            _editApp[0][this._appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + ej.format(date, this._pattern.d, this.model.locale);
                            _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                        }
                        else {
                            _editApp[0][this._appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + ej.format(date, this._pattern.d, this.model.locale);
                            _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                        }
                    }
                    else {
                        _editApp[0][this._appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + ej.format(date, this._pattern.d, this.model.locale);
                        _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                    }
                }
                else {
                    var _rules = _rRule.split(';');
                    recurRule = "";
                    for (var i = 0; i < _rules.length; i++) {
                        if (recurRule != "")
                            recurRule += ";";
                        var keyValuePair = _rules[i].replace(/ /g, '').split('=');
                        if (keyValuePair[0] == "EXDATE") {
                            if ((this._currentAction == "delete" || this._currentAction == "editOccurrence") && _editApp[0][this._appointmentSettings["endTime"]].getDay() > _editApp[0][this._appointmentSettings["startTime"]].getDay()) {
                                if (objDate[0][this._appointmentSettings["startTime"]].getDay() == objDate[0][this._appointmentSettings["endTime"]].getDay()) {
                                    date = objDate[0][this._appointmentSettings["startTime"]];
                                    _rules[i] = _rules[i] + "," + ej.format(date, this._pattern.d, this.model.locale);
                                }
                                else
                                    _rules[i] = _rules[i] + "," + ej.format(date, this._pattern.d, this.model.locale);
                            }
                            else
                                _rules[i] = _rules[i] + "," + ej.format(date, this._pattern.d, this.model.locale);
                        }
                        recurRule += _rules[i];
                    }
                    _editApp[0][this._appointmentSettings["recurrenceRule"]] = recurRule;
                    _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                }
                return _editApp;
            }
        },

        _getWeekIndex: function (curDate) {
            var index = 0;
            var firstDate = new Date(curDate.getFullYear(), curDate.getMonth(), 1);
            var dayIndex = curDate.getDay();
            if (dayIndex != firstDate.getDay())
                do {
                    firstDate = new Date(firstDate.setDate(firstDate.getDate() + 1));
                } while (dayIndex != firstDate.getDay())
            while (firstDate.getDate() != curDate.getDate()) {
                firstDate = new Date(firstDate.setDate(firstDate.getDate() + 7));
                index++;
            }
            return index;
        },

        _addAppData: function (app, id, startTime, endTime, parentId) {
            var data = {};
            for (var item in this._appointmentSettings) {
                if (item != "dataSource" && item != "query" && item != "tableName" && item != "resourceFields")
                    data[this._appointmentSettings[item]] = app[this._appointmentSettings[item]];
                if (item == "resourceFields" && !ej.isNullOrUndefined(this._appointmentSettings.resourceFields)) {
                    var level = this._appointmentSettings.resourceFields.split(',');
                    for (var val = 0, len = level.length; val < len; val++)
                        data[level[val]] = app[level[val]];
                }
            }
            (!ej.isNullOrUndefined(id)) && (data.AppTaskId = id);
            (!ej.isNullOrUndefined(startTime)) && (data[this._appointmentSettings["startTime"]] = startTime);
            (!ej.isNullOrUndefined(endTime)) && (data[this._appointmentSettings["endTime"]] = endTime);
            (!ej.isNullOrUndefined(parentId)) && (data["ParentId"] = parentId);
            var appdata = $.extend({}, app, data);
            return appdata;
        },
        _renderAppointments: function () {
            var dateCount = $.extend(true, [], this._dateRender);
            this._overflowFlag = false;
            this._renderedApp = [], this._renderedAllDay = [];
            var level = 1; this.level = 0;
            !this.model.showOverflowButton && (this.initialCellHeight = this.model.cellHeight ? parseInt(this.model.cellHeight) : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
            this.cellwidth = this.element.find(".e-workcells").width();
            this.cellheight = this.element.find(".e-workcells").outerHeight();
            if (this.model.orientation == "vertical" && this.model.showAllDayRow) {
                this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
            }
            this.alldaycellsheight = this.element.find(".e-alldaycells").height();
            this._horiHeaderCollection = this._horiGroupCollection();
            this.leftPosition = 0;
            this._variable = [];
            if (!this.model.group || (this._tempResource.length != 0 && this._tempResource[0].resourceSettings.dataSource.length == 0)) this.res1 = ["0"];
            this.resIndex = 0;
            this._processed = this._appointmentSort(this._processed);
            for (var res = 0; res < this.res1.length; res++) {
                var day = 0, diff, count = dateCount.length;
                if (new Date(dateCount[0]) < this.model.minDate)
                    day = Math.floor((new Date(this.model.minDate) - new Date(dateCount[0])) / (1000 * 60 * 60 * 24));
                if (new Date(dateCount[dateCount.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(dateCount[dateCount.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = dateCount.length - diff;
                }
                if (this._resWorkWeek) {
                    count = 0; day = 0; var temp = 0;
                    for (var a = 0; a < res + 1; a++) {
                        if (!ej.isNullOrUndefined(this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            if (a == res) temp += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count += this.model.workWeek.length;
                            if (a == res) temp += this.model.workWeek.length;
                        }

                        if (a == res) {
                            day = count - temp;
                            break;
                        }
                    }
                }
                for (day; day < count; day++) {
                    this._getDayAppointments(day, res);
                }
            }
            (this._overflowFlag || this._allDayDrag) && this._reRenderScroller();
            this._overflowFlag = this._allDayDrag = false;
        },

        _appointmentRemove: function (app) {
            this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").filter("div[guid=" + app.Guid + "]").remove();
            this.element.find(".e-categorybar").filter("div[id=categorybar_" + app.Guid + "]").remove();
        },

        _refreshDayAppointments: function (app) {
            if (this.model.timeScale.enable && this.currentView() != "agenda" && this.currentView() != "month" && !this._isCustomMonthView()) {
                this._overflowFlag = false;
                var date = new Date(app[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0);
                var resIndex = (this._tempResource.length > 0 && this._grouping.length > 0 && ej.scheduleFeatures.resources) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], app[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]]) : 0;
                var day = this._dateRender.indexOf(date), resDay = 0;
                if (this.model.orientation == "vertical" && this._grouping.length > 0) {
                    if (this._resWorkWeek) {
                        var count = 0, day = 0, temp = 0, curday = 0;
                        for (var a = 0; a < resIndex + 1; a++) {
                            if (!ej.isNullOrUndefined(this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                                count += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                                if (a == resIndex) {
                                    temp += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                                    curday = this._resDateRen[resIndex].indexOf(date);
                                }
                            }
                            else {
                                count += this.model.workWeek.length;
                                if (a == resIndex) {
                                    temp += this.model.workWeek.length;
                                    curday = this._resDateRen[resIndex].indexOf(date);
                                }
                            }

                            if (a == resIndex) {
                                day = count - temp;
                                break;
                            }
                        }
                        day = day + curday;
                    }
                    else {
                        resDay += resIndex * (this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : (this.currentView() == "week" || this.currentView() == "week" || this._isCustomMonthView()) ? this.model.showWeekend ? 7 : this.model.workWeek.length : this._dateRender.length);
                    }
                }
                if (this.model.orientation == "horizontal") {
                    var horiIndex = (this._grouping.length > 1) ? this._resCollect.indexOf(this.res1[resIndex]) : resIndex;
                }
                (this.model.orientation == "vertical") ? this.element.find(".e-workcellstab tr td:nth-child(" + (day + resDay + 1) + ")").find(".e-appointwrapper").remove() : this.element.find(".e-workcellstab tr:nth(" + horiIndex + ")").find(".e-appointwrapper").remove();
                if (this.model.orientation == "vertical") {
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(date)).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(date).setHours(23, 59, 59)));
                    predicate = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources) ? predicate.and(this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[resIndex][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                    var dayApps = new ej.DataManager(this._renderedApp).executeLocal(new ej.Query().where(predicate));
                }
                else {
                    var tempApps = this._appointmentCount();
                    if (this._grouping.length > 0) {
                        var proxy = this;
                        var resApps = tempApps.filter(function (obj) { return obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == app[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()]; });
                    }
                    var dayApps = (this._grouping.length > 0) ? resApps : tempApps;
                }
                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: dayApps }, "AppTaskId");
                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: dayApps }, "AppTaskId");
                var count = (this.model.orientation == "vertical") ? 1 : this._dateRender.length;
                var dayNo = (this.model.orientation == "vertical") ? day : 0;
                var index = 0, dayNo = (this.model.orientation == "vertical") ? day : 0;
                !this.model.showOverflowButton && (this.initialCellHeight = this.model.cellHeight ? parseInt(this.model.cellHeight) : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
                this.cellwidth = this.element.find(".e-workcells").width();
                this.cellheight = this.element.find(".e-workcells").outerHeight();
                this.alldaycellsheight = ej.isNullOrUndefined(this.alldaycellsheight) ? this.element.find(".e-alldaycells").height() : this.alldaycellsheight;
                this._horiHeaderCollection = this._horiGroupCollection();
                do {
                    this._getDayAppointments(dayNo, resIndex);
                    index++;
                    dayNo++;
                } while (index < count)

                if (this.model.orientation == "vertical" && this.model.showAllDayRow) this._renderAllDayAppointments();
                if (this._overflowFlag) {
                    this._reRenderScroller();
                    this._overflowFlag = false;
                }
                if (this.model.showAppointmentNavigator && this.model.orientation == "vertical" && this.element.find(".e-vscroll").length > 0 && this.currentView() != "month" && (!this._isCustomMonthView()) && (!this._mediaQuery)) this._renderUpDownIconPosition();
            }
            else (this.currentView() == "agenda") ? this._renderAgendaContent() : this._renderMonthAppointment();
            this._bindAppointmentAction();
        },

        _renderUpDownIcon: function () {
            if (this.element.find(".e-upicon, .e-downicon").length == 0) {
                var upIcon = downIcon = upIconHtml = downIconHtml = "";
                var bottomVal = (this.element.find(".e-hscroll").length == 0) ? "0px" : this.element.find(".e-hscroll").outerHeight() + "px";
                for (a = 0; a < this.dateRender.length; a++) {
                    upIcon = upIcon + "<td class='upicon_" + a + "' style='width:100%;height:100%;'><span class='e-icon e-arrow-sans-up e-appup'></span></td>";
                    downIcon = downIcon + "<td class='downicon_" + a + "' style='width:100%;height:100%;'><span class='e-icon e-arrow-sans-down e-appdown'></span></td>";
                }
                upIconHtml = "<tr class='e-upicon' style='pointer-events:none;top:0px;'>" + upIcon + "</tr>";
                downIconHtml = "<tr class='e-downicon' style='pointer-events:none;bottom:" + bottomVal + ";'>" + downIcon + "</tr>";
                $(upIconHtml).insertBefore(this.element.find(".e-draggableworkarea").parent());
                $(downIconHtml).insertAfter(this.element.find(".e-draggableworkarea").parent());
                if (this.model.enableRTL) this.element.find(".e-appup, .e-appdown").addClass("e-rtl");
                this.element.find(".e-upicon, .e-downicon").css({ width: this.element.find(".e-workcellstab").width() });
                this.element.find(".e-appup, .e-appdown").css({ pointerEvents: "visible" });
                this.element.find(".e-upicon, .e-downicon").children().css({ float: (this.model.enableRTL) ? "right" : "left", visibility: "hidden", width: Math.floor(this.element.find(".e-workcellstab").width() / this.element.find(".e-upicon").children().length) });
            }
        },

        _renderUpDownIconPosition: function () {
            this.element.find(".e-upicon, .e-downicon").children().css({ visibility: "hidden" });
            if (this.element.find(".e-vscroll").length > 0) {
                var scrollObject = this.element.find("div#" + this._id + "_scroller").data("ejScroller");
                var scrollMax = !ej.isNullOrUndefined(scrollObject._scrollYdata) ? scrollObject._scrollYdata.scrollable : this.element.height();
                var curValue = scrollObject.scrollTop();
                var upValue = (curValue > scrollMax) ? scrollMax : curValue;
                var downValue = upValue + this.element.find(".e-draggableworkarea").height();
                var upIndex = parseInt(upValue / this.element.find(".e-workcells").outerHeight()) + 1;
                var downIndex = parseInt(downValue / this.element.find(".e-workcells").outerHeight());
                var upTrgt = this.element.find(".e-upicon");
                var downTrgt = this.element.find(".e-downicon");
                var upTime = ((this.model.startHour * 60) + upIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000);
                var time = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * 60 * 1000;
                var downTime = (((this.model.startHour * 60) + downIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000)) + time;
                this._currentViewAppointments = this._appointmentCount();
                var proxy = this;
                appointments = this._currentViewAppointments.filter(function (app) { return ((app[proxy._appointmentSettings["endTime"]] - app[proxy._appointmentSettings["startTime"]]) / (1000 * 3600)) < 24; });
                for (a = 0; a < this._dateRender.length; a++) {
                    var endDateTime = (this.model.endHour < 24) ? new Date(new Date(this._dateRender[a]).setHours(this.model.endHour, 0, 0)) : new Date(new Date(this._dateRender[a]).setHours(23, 59, 59));
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(new Date(this._dateRender[a]).setHours(this.model.startHour, 0, 0)))["and"](this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(endDateTime));
                    var dayApps = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
                    if (dayApps.length != 0) {
                        var upDate = new Date(new Date(this._dateRender[a]).setMilliseconds(upTime));
                        var upApps = new ej.DataManager(dayApps).executeLocal(new ej.Query().where(this._appointmentSettings["endTime"], ej.FilterOperators.lessThan, new Date(upDate)));
                        upApps = this._appointmentSort(upApps).reverse();
                        if (!ej.isNullOrUndefined(upTrgt) && upApps.length != 0) {
                            if (this._grouping.length == 0) { upTrgt.children().eq(a).css({ visibility: "visible" }); }
                            else {
                                for (b = 0; b < this.res1.length; b++) {
                                    var tempRes = new ej.DataManager(upApps).executeLocal(new ej.Query().where(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1], ej.FilterOperators.equal, this.res1[b].id));
                                    if (tempRes.length != 0) { upTrgt.children().eq(a + b * this._dateRender.length).css({ visibility: "visible" }); }
                                }
                            }
                        }
                        var downApps = new ej.DataManager(dayApps).executeLocal(new ej.Query().where(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThan, new Date(new Date(this._dateRender[a]).setMilliseconds(downTime))));
                        downApps = this._appointmentSort(downApps);
                        if (!ej.isNullOrUndefined(downTrgt) && downApps.length != 0) {
                            if (this._grouping.length == 0) { downTrgt.children().eq(a).css({ visibility: "visible" }); }
                            else {
                                for (c = 0; c < this.res1.length; c++) {
                                    var tempRes1 = new ej.DataManager(downApps).executeLocal(new ej.Query().where(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1], ej.FilterOperators.equal, this.res1[c].id));
                                    if (tempRes1.length != 0) { downTrgt.children().eq(a + c * this._dateRender.length).css({ visibility: "visible" }); }
                                }
                            }
                        }
                    }
                }
            }
        },

        _renderAppPosition: function (e) {
            var choice = $(e.target).hasClass("e-appup") ? "e-appup" : "e-appdown";
            var index = $(e.target).parent().index();
            var appointments = this._appointmentCount();
            var scrollerObject = this.element.find("div#" + this._id + "_scroller").data("ejScroller");
            switch (choice) {
                case "e-appup":
                    var upValue = scrollerObject.scrollTop();
                    var upIndex = parseInt(upValue / this.element.find(".e-workcells").outerHeight()) + 1;
                    var upTrgt = this.element.find(".e-draggableworkarea").find("tr").eq(upIndex);
                    var time = ((this.model.startHour * 60) + upIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000);
                    var trgtDate = new Date(new Date(this.dateRender[index]).setMilliseconds(time));
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(this.dateRender[index]))["and"](this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(trgtDate));
                    var upApps = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
                    if (upApps.length != 0) {
                        var upTime = Math.abs(upApps[0][this._appointmentSettings["startTime"]] - trgtDate);
                        var appRowIndex = parseInt((time - upTime) / ((this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * (60 * 1000)));
                        var scrollTo = upValue - ((upIndex - appRowIndex) * this.element.find(".e-workcells").height());
                        this.element.find('div#' + this._id + "_scroller").ejScroller({ scrollTop: scrollTo });
                        this.element.find('.e-scrolltimecells').css({ top: -(this.element.find('.e-draggableworkarea').scrollTop()) + 'px' });
                    }
                    break;
                case "e-appdown":
                    var downValue = scrollerObject.scrollTop() + $(this.element.find(".e-vscroll")[0]).height();
                    var downIndex = parseInt(downValue / this.element.find(".e-workcells").height());
                    var downTrgt = this.element.find(".e-draggableworkarea").find("tr").eq(downIndex);
                    var time = ((this.model.startHour * 60) + downIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000);
                    var trgtDate = new Date(new Date(this.dateRender[index]).setMilliseconds(time));
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(trgtDate))["and"](this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(this.dateRender[index]).setHours(23, 59, 59)));
                    var downApps = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
                    if (downApps.length != 0) {
                        var downTime = trgtDate.getTime() - downApps[0][this._appointmentSettings["endTime"]].getTime();
                        var appRowIndex = parseInt((time - downTime) / ((this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * (60 * 1000)));
                        var scrollTo = scrollerObject.scrollTop() + ((appRowIndex - downIndex) * this.element.find(".e-workcells").height()) + this.element.find("div#Appointment_" + downApps[0]["AppTaskId"]).height();
                        this.element.find('div#' + this._id + "_scroller").ejScroller({ scrollTop: scrollTo });
                        this.element.find('.e-scrolltimecells').css({ top: -(this.element.find('.e-draggableworkarea').scrollTop()) + 'px' });
                    }
                    break;
            }
            this._renderUpDownIconPosition();
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
        },

        _findAllDayApp: function (apps) {
            if (!apps[this._appointmentSettings["allDay"]]) {
                if (!apps[this._appointmentSettings["recurrence"]])
                    var tempCurrent = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, apps.ParentId));
                else
                    var tempCurrent = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, apps[this._appointmentSettings["id"]]));
                var Value = (!ej.isNullOrUndefined(tempCurrent[0])) ? (((tempCurrent[0][this._appointmentSettings["endTime"]] - tempCurrent[0][this._appointmentSettings["startTime"]]) / 3600000) >= 24) ? true : false : false;
                return Value;
            }
        },

        _resourceOrderSort: function (appointmentsList) {
            if (appointmentsList.length > 0 && this._grouping.length == 0 && this._tempResource.length > 0) {
                var proxy = this, filterCollection = [];
                var resMapping = this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim();
                var resSettings = this._tempResource[this._tempResource.length - 1].resourceSettings;
                appointmentsList.forEach(function (obj) {
                    var appList = appointmentsList.filter(function (list) { return new Date(list[proxy._appointmentSettings["startTime"]]).getTime() == new Date(obj[proxy._appointmentSettings["startTime"]]).getTime() && new Date(list[proxy._appointmentSettings["endTime"]]).getTime() == new Date(obj[proxy._appointmentSettings["endTime"]]).getTime(); });
                    var collection = $(appList).not(filterCollection);
                    if (collection.length != 0) {
                        var resField = $.unique(collection.map(function (index, list) { return list[proxy._id + "_ownerfield_" + (proxy._tempResource.length - 1)]; }));
                        var resOrder = resSettings.dataSource.map(function (a) { return a[resSettings.id]; }).toString();
                        var resId = (resField.length > 0) ? resField[0].split(",") : resOrder.split(",");
                        for (var r = 0, len = resId.length; r < len; r++) {
                            var filterList = collection.filter(function (index, list) { return list[resMapping] == (resId[r] || parseInt(resId[r])); });
                            for (var res = 0; res < filterList.length; res++) {
                                filterCollection.push(filterList[res]);
                            }
                        }
                    }
                });
                new ej.DataManager(appointmentsList).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                $.merge(appointmentsList, filterCollection);
            }
            return appointmentsList;
        },

        _getDayAppointments: function (day, res) {
            var dateCount = this._dateRender, appointmentsList = this._currentViewAppointments = this._appointmentCount();
            var endDateTime = (this.model.endHour < 24) ? new Date(new Date(dateCount[day]).setHours(this.model.endHour, 0, 0)) : new Date(new Date(dateCount[day]).setHours(23, 59, 59));
            var predicate2 = ej.Predicate(this._appointmentSettings["endTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day])).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(endDateTime));
            var predicate1 = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day])).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(endDateTime));
            var predicate = predicate2["or"](predicate1);
            predicate = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
            appointmentsList = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(predicate));
            var renderedAlready = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(new Date(dateCount[day - 1]).setHours(24, 0, 0))).or(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day]));
            appointmentsList = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(renderedAlready));
            appointmentsList = this._resourceOrderSort(appointmentsList);
            if (this.model.orientation == "vertical") {
                for (var app = 0; app < appointmentsList.length; app++) {
                    var isBigApp = (((appointmentsList[app][this._appointmentSettings["endTime"]] - appointmentsList[app][this._appointmentSettings["startTime"]]) / 3600000) >= 24);
                    var allDayCheck = appointmentsList[app][this._appointmentSettings["allDay"]];
                    allDayCheck = (ej.isNullOrUndefined(allDayCheck) || allDayCheck == "") ? false : allDayCheck;
                    if (((new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() == (new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime())) && allDayCheck) || isBigApp) {
                        this._setAllDayPos(appointmentsList[app], day, res);
                    }
                    else if ((new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (!allDayCheck)) {
                        if (this._findAllDayApp(appointmentsList[app]))
                            this._setAllDayPos(appointmentsList[app], day, res);
                        else {
                            var isAvail = this._renderedApp.filter(function (obj) { return obj.Guid == appointmentsList[app]; });
                            if (isAvail.length == 0) this._renderApp(appointmentsList[app], day, res);
                        }
                    }
                }
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                this._getHorizontalDayAppointments(appointmentsList, dateCount, day, res);
        },

        _startUtc: function (e) {
            (!ej.isNullOrUndefined(this.startutcValue) && ej.isNullOrUndefined(this.tempValue)) ? this._utcValue(e, "startUtc") : e.model.value == "" ? "" : ((e.model.value == this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList('model.value') && this._appointmentAddWindow.find("#" + this._id + "startTimeZone").attr('aria-expanded') == "true")) ? this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("option", { text: e.text, value: e.value }) : "";
        },
        _endUtc: function (e) {
            (this._appointmentAddWindow.find("#" + this._id + "endTimeZone").attr('aria-expanded') == "true") ? this._utcValue(e, "endUtc") : this.startutcValue = this.tempValue = null;
        },
        _utcValue: function (temp, getValue) {
            ej.preferredCulture(this.model.locale);
            getValue == "endUtc" ? this._appointmentAddWindow.find('.endutc').val(temp.text) : "";
            var localeDate = { StartDate: this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("model.value"), EndDate: this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("model.value") };
            var localeTime = { StartTime: this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("model.value"), EndTime: this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("model.value") };
            var strTime = this._timeFormat(localeTime.StartTime).split(":"), endTime = this._timeFormat(localeTime.EndTime).split(":");
            var utcValue = new Date(localeDate.StartDate.setHours(parseInt(strTime[0], 10), parseInt(strTime[1], 10)));
            var utcendValue = new Date(localeDate.EndDate.setHours(parseInt(endTime[0], 10), parseInt(endTime[1], 10)));
            var startDateutc = new Date(utcValue);
            var EndDateutc = new Date(utcendValue);
            var utcEnd = getValue == "Appoint" ? this.endTimeAppoint : getValue == "endUtc" ? temp.value : this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("model.value");
            var utcStart = getValue == "Appoint" ? this.startTimeAppoint : getValue == "startUtc" ? temp.value : this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList("model.value");
            utcStart = (utcStart == "") ? this._timezoneStringValue() : utcStart;
            utcEnd = (utcEnd == "") ? this._timezoneStringValue() : utcEnd;
            utcEnd = utcEnd.indexOf("UTC") != -1 ? parseInt(utcEnd.split(" ")[1].split(":")[0]) * 60 + parseInt(utcEnd.split(" ")[1].split(":")[1]) : parseInt(utcEnd.split(":")[0]) * 60 + parseInt(utcEnd.split(":")[1]);
            utcStart = utcStart.indexOf("UTC") != -1 ? parseInt(utcStart.split(" ")[1].split(":")[0]) * 60 + parseInt(utcStart.split(" ")[1].split(":")[1]) : parseInt(utcStart.split(":")[0]) * 60 + parseInt(utcStart.split(':')[1]);
            var startendUtc = utcEnd - utcStart;
            utcValue = new Date(utcValue.setMinutes(utcValue.getMinutes() + startendUtc));
            if (getValue == "Appoint") {
                var dateNew = new Date(temp[this._appointmentSettings["startTime"]]);
                var endNew = new Date(temp[this._appointmentSettings["endTime"]]);
                var timeZoneValue = ej.isNullOrUndefined(this.model.timeZone) ? -new Date().getTimezoneOffset() + this._timeZoneOffset : this.model.timeZone.indexOf('UTC') != -1 ? ((parseInt(this.model.timeZone.split(" ")[1].split(":")[0]) * 60) + (parseInt(this.model.timeZone.split(" ")[1].split(":")[1]))) : ((parseInt(this.model.timeZone.split(":")[0]) * 60) + (parseInt(this.model.timeZone.split(":")[1])));
                var timeZoneStart = (utcStart == timeZoneValue) ? 0 : timeZoneValue - utcStart;
                timeZoneStart = new Date(dateNew.setMinutes(dateNew.getMinutes() - timeZoneStart));
                var value2 = this._timeMode == "12" ? ej.format(new Date(timeZoneStart), this._pattern.t, this.model.locale) : ej.format(new Date(timeZoneStart), "HH:mm", this.model.locale);
                this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker({ value: ej.format(new Date(timeZoneStart), this._datepattern(), this.model.locale) });
                var timeZoneEnd = utcEnd - timeZoneValue;
                this._appointmentAddWindow.find('#' + this._id + "starttime").ejTimePicker({ value: value2 });
            }
            utcendValue = (getValue == "endUtc" || getValue == "Appoint") ? new Date(startDateutc.setMinutes(startDateutc.getMinutes() + startendUtc)) : utcValue;
            utcendValue = getValue == "Appoint" ? new Date(endNew.setMinutes(endNew.getMinutes() + timeZoneEnd)) : utcendValue;
            var different = this._timeMode == "12" ? ej.format(new Date(utcValue), this._pattern.t, this.model.locale) : ej.format(new Date(utcValue), "HH:mm", this.model.locale);
            if (getValue == "Appoint") {
                value = this._timeMode == "12" ? ej.format(new Date(endNew), this._pattern.t, this.model.locale) : ej.format(new Date(endNew), "HH:mm", this.model.locale);
            }
            else {
                var endTimeValue = new Date(utcendValue.setMinutes(utcendValue.getMinutes() + 30));
                var value = this._timeMode == "12" ? ej.format(new Date(endTimeValue), this._pattern.t, this.model.locale) : ej.format(new Date(endTimeValue), "HH:mm", this.model.locale);
            }
            this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker({ value: ej.format(new Date(utcendValue), this._datepattern(), this.model.locale) });
            this._appointmentAddWindow.find('#' + this._id + "endtime").ejTimePicker({ value: value });
            this.startutcValue = 1;
        },

        _rowHandlesOver: function (e) {
            this.model.enableAppointmentResize && $(e.target).addClass("e-rowcursor");
        },

        _colHandlesOver: function (e) {
            this.model.enableAppointmentResize && $(e.target).addClass("e-columncursor");
        },

        _getDateCount: function (res) {
            if (this._resWorkWeek) {
                var index, resDates, dateCount = [];
                if (!ej.isNullOrUndefined(this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                    resDates = this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                else resDates = this.model.workWeek;
                resDates = this._resourceDaysReorder(resDates);
                for (var a = 0; a < resDates.length; a++) {
                    index = this._dayFullNames.indexOf(resDates[a].capitalizeFirstString());
                    if (index == -1) {
                        index = this._getDayNameIndex(resDates[a]);
                    }
                    dateCount.push(this._renderDates[index]);
                }
            }
            else
                var dateCount = this._dateRender;
            return dateCount;
        },

        _renderApp: function (record, day, res) {
            var cellHeight = this.cellheight,
                startHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.startHour) : 0,
                endHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.endHour) : 24,
                dateCount = this._getDateCount(res),
                rStartTime = new Date(record[this._appointmentSettings["startTime"]]),
                rEndTime = new Date(record[this._appointmentSettings["endTime"]]);

            rStartTime = ((new Date(rStartTime).getHours()) < startHour) ? new Date(new Date(rStartTime).setHours(startHour, rStartTime.getMinutes(), rStartTime.getSeconds())) : rStartTime;
            if (this.model.orientation == "vertical") {
                var appWidth, appHeight, startTime, endTime, endDate, topPosition, resValue, overlapList, predicate, appointmentsList, appLevelsInDay, index = -1;
                if (rStartTime <= rEndTime && (new Date(dateCount[0]).getTime() <= rStartTime.getTime() && new Date(new Date(dateCount[dateCount.length - 1]).setHours(23, 59, 59)) >= rStartTime.getTime())) {
                    startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
                    endTime = ((new Date(rEndTime).getHours()) > endHour) ? (new Date(rEndTime).getHours() + (-new Date(rEndTime).getHours() + (endHour - startHour)) + (-new Date(rEndTime).getMinutes())) : (new Date(rEndTime).getHours() + (-startHour));
                    endTime = (new Date(rEndTime).getHours() == endHour) ? (new Date(endTime).getMinutes() + (-new Date(rEndTime).getMinutes())) : endTime;
                    if (endHour <= rEndTime.getHours()) {
                        endDate = new Date(rEndTime.setHours(endHour, 00, 00));
                        appHeight = (parseFloat(((new Date(endDate).getHours() * 60) + (new Date(endDate).getMinutes())) - ((new Date(rStartTime).getHours() * 60) + (new Date(rStartTime).getMinutes()))) * ((cellHeight) * this.model.timeScale.minorSlotCount) / this.model.timeScale.majorSlot) - 2;
                    }
                    else {
                        appHeight = ((parseFloat(new Date(new Date(rEndTime).getTime()) - new Date(new Date(rStartTime).getTime()))) / (60 * 1000) * (cellHeight * this.model.timeScale.minorSlotCount) / (this.model.timeScale.majorSlot)) - 2;
                        appHeight = (record[this._appointmentSettings["endTime"]].getTimezoneOffset() - record[this._appointmentSettings["startTime"]].getTimezoneOffset() != 0) ? (appHeight - (cellHeight * this.model.timeScale.minorSlotCount)) : appHeight;
                    }
                    topPosition = ((parseFloat((((new Date(rStartTime).getHours() * 60)) + new Date(rStartTime).getMinutes() + (new Date(rStartTime).getSeconds() / 60))) - parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - (this.model.startHour * 60)) * cellHeight * (this.model.timeScale.minorSlotCount / this.model.timeScale.majorSlot);
                    if (this.model.startHour <= new Date(rStartTime).getHours()) {
                        resValue = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]] : null;
                        overlapList = this._overlapApp(record["AppTaskId"], record[this._appointmentSettings["startTime"]], record[this._appointmentSettings["endTime"]], resValue);
                        var proxy = this;
                        if (this._grouping.length > 0 && this._tempResource.length > 0 && this._tempResource[0].resourceSettings.dataSource.length > 0 && ej.scheduleFeatures.resources)
                            appointmentsList = overlapList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > record[proxy._appointmentSettings["startTime"]] && obj[proxy._appointmentSettings["startTime"]] < record[proxy._appointmentSettings["endTime"]] && obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == proxy.res1[res][proxy._tempResource[proxy._tempResource.length - 1].resourceSettings["id"]]; });
                        else
                            appointmentsList = overlapList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > record[proxy._appointmentSettings["startTime"]] && obj[proxy._appointmentSettings["startTime"]] < record[proxy._appointmentSettings["endTime"]]; });

                        if (appointmentsList.length > 0) {
                            this._variable = [];
                            for (var list = 0, len = appointmentsList.length; list < len; list++) {
                                ej.isNullOrUndefined(this._variable[appointmentsList[list]["Index"]]) ? this._variable[appointmentsList[list]["Index"]] = [appointmentsList[list]] : this._variable[appointmentsList[list]["Index"]].push(appointmentsList[list]);
                            }
                            appLevelsInDay = $.map(appointmentsList, function (value, Index) { return [value.Index]; });
                            index = this._smallestMissingNumber(appLevelsInDay);
                        }
                        index = (index == -1) ? 0 : index;
                        record.Index = index;
                        overlapList.push(record);
                        if (overlapList.length != 1)
                            ej.isNullOrUndefined(this._variable[index]) ? this._variable[index] = [record] : this._variable[index].push(record);
                        else {
                            this._variable = [];
                            this._variable.push([record]);
                        }
                        appWidth = ((((90 - (this._variable.length)) / (this._variable.length)))) + "%";
                        this.leftPosition = '0%';
                        var resDay = (this._resWorkWeek) ? 0 : this._dateRender.length * res;
                        for (var i = 0, len1 = this._variable.length; i < len1; i++) {
                            if (!ej.isNullOrUndefined(this._variable[i])) {
                                for (var j = 0, len2 = this._variable[i].length; j < len2; j++) {
                                    var element = this.element.find(".e-workcellstab tr td:nth-child(" + (resDay + day + 1) + ")").find(".e-appointwrapper").find(".e-appointment");
                                    var eleGuid = this._variable[i][j]["Guid"];
                                    var apps = element.filter('div[guid=' + eleGuid + ']');
                                    if (!ej.isNullOrUndefined(apps[0]) && eleGuid != record["Guid"]) {
                                        if (parseFloat(appWidth) <= parseFloat(apps[0].style.width)) {
                                            this.model.enableRTL ? apps[0].style.right = ((parseFloat(appWidth) + 1) * i) + '%' : apps[0].style.left = ((parseFloat(appWidth) + 1) * i) + '%';
                                            apps[0].style.width = ((parseFloat(appWidth))) + '%';
                                        }
                                        else {
                                            var eleGuid = this._variable[ej.isNullOrUndefined(this._variable[i - 1]) ? i : i - 1][0]["Guid"];
                                            var apps1 = element.filter('div[guid=' + eleGuid + ']');
                                            apps[0].style.width = apps1[0].style.width;
                                            this.model.enableRTL ? apps[0].style.right = ((parseFloat(apps[0].style.width) + 1) * i) + '%' : apps[0].style.left = ((parseFloat(apps[0].style.width) + 1) * i) + '%';
                                        }
                                    }
                                    else {
                                        appWidth = ej.isNullOrUndefined(this._variable[i - 1]) ? ((((90 - (this._variable.length)) / (this._variable.length)))) : !ej.isNullOrUndefined(this.element.find('[guid=' + this._variable[i - 1][0]["Guid"] + ']')[0]) && parseFloat(element.filter('div[guid=' + this._variable[i - 1][0]["Guid"] + ']')[0].style.width);
                                        this.leftPosition = ((appWidth + 1) * index) + '%';
                                    }
                                }
                            }
                        }
                        appWidth = parseFloat(appWidth) + "%";
                        this._renderedApp.push($.extend(true, {}, record));
                        var colorAppointment = this._appointmentColor(record),
                            userAppTemplId = (this.model.appointmentTemplateId) ? true : false,
                            userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "",
                            startTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale),
                            endTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale),
                            recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                            indicationIcon = this._indicationApp(record),
                            timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), appHeight: appHeight, rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition, top: topPosition, appWidth: appWidth, userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, topInd: indicationIcon.leftIndication, bottomInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" })),
                            index = (this._resWorkWeek) ? ((startTime * this.model.timeScale.minorSlotCount) * this.element.find(".e-headercells").length) + day : parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * dateCount.length * this.res1.length + day + (dateCount.length * res),
                            celltd = this.element.find("td.e-workcells").eq(index);
                        (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                        celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                    }
                }
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                this._renderHorizontalApp(rStartTime, rEndTime, record, day, cellHeight, this.model.timeScale.minorSlotCount, startHour, endHour);
            delete record["Index"];
        },

        _priorityTemplate: function (record) {
            return this.model.prioritySettings.template.replace("{", "").replace("$", "").replace("}", "").replace(this.model.prioritySettings.template.indexOf("value") != -1 ? this.model.prioritySettings.value : this.model.prioritySettings.text, record[this._appointmentSettings["priority"]]);
        },

        _getUserAppointmentTemplate: function (record) {
            var userTemp = $.templates($(this.model.appointmentTemplateId).html());
            var cloneObj = $.extend(cloneObj, record);
            cloneObj.View = this.currentView();
            var userTempHtml = userTemp.render(cloneObj);
            return userTempHtml;
        },

        _getUserTimeCellsTemplate: function () {
            var userTemp = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
            var timelist, startendTimes = [];
            for (var i = this.model.startHour; i < this.model.endHour;) {
                var j = 0;
                while (j < 60) {
                    j = j * 60 * 1000;
                    timelist = userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) });
                    startendTimes.push({ time: timelist.trim(), id: i + "_" + j });
                    j = (j / (60 * 1000)) + this.model.timeScale.majorSlot;
                }
                i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : i + 1;
            }
            return startendTimes;
        },

        _getUserAllDayCellsTemplate: function () {
            var dateRender = [], minutes = 0, date, userTemp, userHtml;
            userTemp = $.templates($(this.model.allDayCellsTemplateId).html());
            for (a = 0; a < this.res1.length; a++) {
                for (b = 0; b < this._dateRender.length; b++) {
                    date = new Date(new Date(this._dateRender[b]).setHours(this.model.startHour, minutes, 0));
                    userHtml = userTemp.render(object = { date: date, view: this.currentView(), resource: this.res1[a], timescale: this.model.timeScale.enable });
                    dateRender.push(userHtml.trim());
                }
            }
            return dateRender;
        },

        _getUserDateheaderTemplate: function () {
            var colCount = [], userTemp, userDate, curday, headerCellClass, temp;
            userTemp = $.templates($(this.model.dateHeaderTemplateId).html());
            for (i = 0; i < this._dateRender.length; i++) {
                userDate = userTemp.render(object = { date: new Date(this._dateRender[i]) });
                curday = (this.currentView() === "month" || this.currentView() === "day" || (this._isCustomMonthView())) ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                headerCellClass = (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-headerToday" : "";
                temp = (this.currentView() === "month" || (this._isCustomMonthView())) ? { currentDay: curday, currentDateClass: "", cellToday: "" } : { currentDay: userDate, currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass };
                colCount.push(temp);
                this._value.push(i);
            }
            return colCount;
        },

        _getUserWorkCellsTemplate: function () {
            var date, dateRender = [], dateRender1 = [], userTemp, userHtml, minutes = 0, tdCount = this.model.timeScale.minorSlotCount;
            userTemp = $.templates($(this.model.workCellsTemplateId).html());
            this._isCustomMonthView();
            if (this.model.orientation == "vertical") {
                if (this.currentView() != "month" && !this._isCustomMonthView()) {
                    for (a = 0; a < ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)) ; a++) {
                        dateRender = [];
                        for (b = 0; b < this.res1.length; b++) {
                            for (c = 0; c < this._dateRender.length; c++) {
                                date = new Date(new Date(this._dateRender[c]).setHours(this.model.startHour, minutes, 0));
                                userHtml = userTemp.render(object = { date: date, view: this.currentView(), resource: this.res1[b], timescale: this.model.timeScale.enable });
                                dateRender.push(userHtml.trim());
                            }
                        }
                        minutes = minutes + (this.model.timeScale.majorSlot / tdCount);
                        dateRender1.push(dateRender);
                    }
                }
                else {
                    var i = 0;
                    for (a = 0; a < this._dateRender.length / 7; a++) {
                        dateRender = [];
                        for (b = 0; b < this.res1.length; b++) {
                            i = a * 7;
                            for (c = 0; c < 7; c++) {
                                date = new Date(new Date(this._dateRender[i]).setHours(this.model.startHour, minutes, 0));
                                userHtml = userTemp.render(object = { date: date, view: this.currentView(), resource: this.res1[b], timescale: this.model.timeScale.enable });
                                dateRender.push(userHtml.trim());
                                i++;
                            }
                        }
                        dateRender1.push(dateRender);
                    }
                }
            }
            else {
                var userHtml1, timeRender = [], tempRender = [], time = [], rCollection = this._tempResource.length == 0 ? this.res1 : this._resourceSort();
                if (this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView()) {
                    for (a = 0; a < rCollection.length; a++) {
                        dateRender = []; tempRender = []; time = [];
                        for (b = 0; b < this._dateRender.length; b++) {
                            minutes = 0;
                            for (c = 0; c < ((this.model.endHour - this.model.startHour) * (60 / this.model.timeScale.majorSlot)) ; c++) {
                                for (d = 0; d < tdCount; d++) {
                                    date = new Date(new Date(this._dateRender[b]).setHours(this.model.startHour, minutes, 0));
                                    if (d == 0) {
                                        userHtml = userTemp.render(object = { date: date, view: this.currentView(), resource: rCollection[a], timescale: this.model.timeScale.enable });
                                        dateRender.push(userHtml.trim());
                                    }
                                    else {
                                        userHtml1 = userTemp.render(object = { date: date, view: this.currentView(), resource: rCollection[a], timescale: this.model.timeScale.enable });
                                        timeRender.push(userHtml1.trim());
                                        if (timeRender.length == tdCount - 1) {
                                            time.push(timeRender);
                                            timeRender = [];
                                        }
                                    }
                                    minutes = minutes + (this.model.timeScale.majorSlot / tdCount);
                                }
                            }
                        }
                        var temp = $.extend(true, [], dateRender);
                        var temp1 = $.extend(true, [], time);
                        tempRender.push(temp, temp1);
                        dateRender1.push(tempRender);
                    }
                }
                else {
                    var monthDates = (!this.model.timeScale.enable && this.currentView() != "month" || (this.currentView() == "customview" && this._oneWeek)) ? this._dateRender : this.monthDays;
                    for (a = 0; a < rCollection.length; a++) {
                        dateRender = [];
                        for (b = 0; b < monthDates.length; b++) {
                            date = new Date(new Date(monthDates[b]).setHours(this.model.startHour, minutes, 0));
                            userHtml = userTemp.render(object = { date: date, view: this.currentView(), resource: rCollection[a], timescale: this.model.timeScale.enable });
                            dateRender.push(userHtml.trim());
                        }
                        dateRender1.push(dateRender);
                    }
                }
            }
            return dateRender1;
        },

        _overlapApp: function (id, appStartTime, appEndTime, resValue) {
            var _appList = this._renderedApp, appointmentsList = [], app = [], appList = [], overlapList = [];
            if (this.model.orientation == "vertical") {
                var proxy = this;
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                    appointmentsList = _appList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > appStartTime && obj[proxy._appointmentSettings["startTime"]] < appEndTime && obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == resValue; });
                else
                    appointmentsList = _appList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > appStartTime && obj[proxy._appointmentSettings["startTime"]] < appEndTime; });

                appointmentsList.forEach(function (obj) {
                    if (!ej.isNullOrUndefined(proxy.model.group) && (proxy._tempResource.length != 0) && proxy._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                        appList = _appList.filter(function (list) { return list[proxy._appointmentSettings["endTime"]] >= new Date(obj[proxy._appointmentSettings["startTime"]]) && list[proxy._appointmentSettings["startTime"]] <= new Date(obj[proxy._appointmentSettings["endTime"]]) && list[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == resValue; });
                    else
                        appList = _appList.filter(function (list) { return list[proxy._appointmentSettings["endTime"]] >= new Date(obj[proxy._appointmentSettings["startTime"]]) && list[proxy._appointmentSettings["startTime"]] <= new Date(obj[proxy._appointmentSettings["endTime"]]); });
                    var collection = $(appList).not(appointmentsList);
                    if (collection.length != 0) app = $.merge(app, collection);
                    return app;
                });
                overlapList = $.merge(appointmentsList, app);
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
                for (var i = 0; i < _appList.length; i++) {
                    if (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group)) {
                        if ((new Date(_appList[i][this._appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(_appList[i][this._appointmentSettings["startTime"]]) <= new Date(appEndTime))
                            && (_appList[i][this._tempResource[this._tempResource.length - 1]["field"]] == resValue)
                            && (new Date(new Date(_appList[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date(appStartTime).setHours(0, 0, 0, 0)).getTime())) {
                            overlapList.push(_appList[i]);
                        }
                    }
                    else {
                        if ((new Date(_appList[i][this._appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(_appList[i][this._appointmentSettings["startTime"]]) <= new Date(appEndTime))
                            && (new Date(new Date(_appList[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date(appStartTime).setHours(0, 0, 0, 0)).getTime())) {
                            overlapList.push(_appList[i]);
                        }
                    }
                }
            }
            return overlapList;
        },

        _getOverlapCount: function (record, day, dateRender, resValue) {
            if (this._renderedAllDay.length == 0) {
                record.Index = 0;
                var index = 0;
            }
            else {
                var appLevelsInDay = [], proxy = this;
                if (this.model.orientation == "horizontal" && ej.scheduleFeatures.resources && (this._tempResource.length > 0) && this._grouping.length > 0) {
                    var appointments = this._renderedAllDay.filter(function (obj) {
                        return ((obj[proxy._appointmentSettings["endTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59))) ||
                               (obj[proxy._appointmentSettings["startTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59)))) &&
                               (obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == record[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()]);
                    });
                }
                else {
                    var appointments = this._renderedAllDay.filter(function (obj) {
                        return ((obj[proxy._appointmentSettings["endTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59))) ||
                               (obj[proxy._appointmentSettings["startTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59))));
                    });
                }
                var filterData = [];
                if (this.model.orientation == "vertical") {
                    for (var i = 0, len = appointments.length; i < len; i++) {
                        var isBigApp = (((appointments[i][this._appointmentSettings["endTime"]] - appointments[i][this._appointmentSettings["startTime"]]) / 3600000) >= 24);
                        var allDayCheck = appointments[i][this._appointmentSettings["allDay"]];
                        if (((((new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime() == (new Date(new Date(appointments[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime())) &&
                                  allDayCheck) || isBigApp) && (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) ? (appointments[i][this._tempResource[this._tempResource.length - 1]["field"]] == resValue) : true))) {
                            filterData.push(appointments[i]);
                        }
                    }
                }
                else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                    filterData = this._getHorizontalOverlapCount(appointments, dateRender, day, record, resValue);
                var index = -1;
                index = this._findResourceIndex(filterData, "AppTaskId", record["AppTaskId"]);
                var appLevelsInDay = $.map(filterData, function (value, Index) { return [value.Index]; });
                index = this._smallestMissingNumber(appLevelsInDay);
                record.Index = index;
                index = index == -1 ? 0 : index;
            }
            return index;
        },
        _smallestMissingNumber: function (array) {
            if (array.length == 0) return 0;
            var large = Math.max.apply(Math, array);
            for (var i = 0; i < large; i++) {
                if (array.indexOf(i) == -1) {
                    return i;
                }
            }
            return large + 1;
        },
        _setAllDayPos: function (record, day, res) {
            var level = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this._getOverlapCount(record, day, this._dateRender, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : this._getOverlapCount(record, day, this._dateRender, null);
            var start = new Date(record[this._appointmentSettings["startTime"]]),
                end = new Date(record[this._appointmentSettings["endTime"]]);
            if (new Date(start) <= new Date(end)) {
                var dateRender = this._dateRender, appWidth, left = 0, top = appHeight = (this.element.find(".e-alldayappointment").length > 0 ? this.element.find(".e-alldayappointment").outerHeight(true) : this._getElementHeight("e-alldayappointment"));
                if (this.level <= level) {
                    var cellHeight = (level + 1) * (appHeight) + this.alldaycellsheight;
                    this.element.find(".e-alldaycells,.e-leftindent").removeClass("e-alldaycellsheight").css('height', cellHeight + "px");
                    this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
                    if (this.element.find(".e-vscroll").length == 0 && this.level == 0) this._reRenderScroller();
                }
                this._overflowFlag = true;
                if (this._resWorkWeek) {
                    var index, resDates, dateCount = [];
                    if (!ej.isNullOrUndefined(this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                        resDates = this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                    else
                        resDates = this.model.workWeek;
                    for (var a = 0; a < resDates.length; a++) {
                        index = this._dayFullNames.indexOf(resDates[a].capitalizeFirstString());
                        if (index == -1) {
                            index = this._getDayNameIndex(resDates[a]);
                        }
                        dateCount.push(this._renderDates[index]);
                    }
                    dateRender = dateCount;
                }
                var r_start = new Date(dateRender[0]),
                    r_end = new Date(new Date(dateRender[dateRender.length - 1]).setHours(23, 59, 59));
                end = new Date(end) > new Date(r_end) ? r_end : end;
                if ((this.currentView() == "workweek" || this.currentView() == "week" && !this.model.showWeekend) && $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), this._dateRender) == -1) {
                    for (var i = 1; i < this._dateRender.length; i++) {
                        if ($.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate() - i).getTime(), this._dateRender) > 0) {
                            var index = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate() - i).getTime(), this._dateRender);
                            end = new Date(new Date(this._dateRender[index]).setHours(record[this._appointmentSettings["endTime"]].getHours(), record[this._appointmentSettings["endTime"]].getMinutes(), record[this._appointmentSettings["endTime"]].getSeconds()));
                            break;
                        }
                    }
                }
                this._renderedAllDay.push($.extend(true, {}, record));
                var diffInDays;
                if (this._resWorkWeek || this.currentView() == "workweek" || (this.currentView() == "week" && !this.model.showWeekend))
                    diffInDays = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), dateRender) - ($.inArray(new Date(start.getFullYear(), start.getMonth(), start.getDate()).getTime(), dateRender)) + 1;
                else if (this.currentView() == "week" || this.currentView() == "day" || (this.currentView() == "customview" && parseFloat((end - start) / 3600000) <= 24))
                    diffInDays = (end.getHours() == 0 && end.getMinutes() == 0) ? Math.ceil(((new Date(end) - new Date(start)) / (1000 * 3600)) / 24) : Math.ceil(((new Date(end).setHours(23, 59, 59) - new Date(start).setHours(0, 0, 0)) / (1000 * 3600)) / 24);
                else
                    diffInDays = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), this._dateRender) - ($.inArray(new Date(start.getFullYear(), start.getMonth(), start.getDate()).getTime(), this._dateRender)) + 1;

                if (diffInDays <= 0) diffInDays = 1;
                var cellWidth = this.element.find(".e-alldaycells").width(),
                    daysCount = this._dateRender.length,
                    alldayTr = (!ej.isNullOrUndefined(this.model.group) && this._tempResource.length != 0) ? this._grouping.length : 0,
                    tdIndex = this.currentView() === "day" ? 0 : this._dateRender.indexOf(new Date(start).setHours(0, 0, 0));
                if (this._resWorkWeek)
                    left = (this.model.enableRTL) ? this.element.find(".e-headrealldaytable").width() - this.element.find(".e-alldaycells")[day].offsetLeft - this.element.find(".e-alldaycells").width() : this.element.find(".e-alldaycells")[day].offsetLeft;
                else if (!ej.isNullOrUndefined(this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)]))
                    left = (this.model.enableRTL) ? this.element.find(".e-headrealldaytable").width() - this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)].offsetLeft - this.element.find(".e-alldaycells").width() : this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)].offsetLeft;
                appWidth = ((diffInDays * cellWidth) + diffInDays) - 2;
                top = (level * top) + (level + 1) + this.element.find(".e-headercells").outerHeight() + ((alldayTr != 0) ? (alldayTr * this.element.find(".e-headerbar").first().height()) : alldayTr);

                var colorAppointment = this._appointmentColor(record),
                    userAppTemplId = (this.model.appointmentTemplateId) ? true : false,
                    userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "",
                    startTimeDisp = this._timeMode == "12" ? ej.format(record[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale),
                    endTimeDisp = this._timeMode == "12" ? ej.format(record[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale),
                    recEditIcon = (record[this._appointmentSettings["recurrence"]]) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                    indicationIcon = this._indicationApp(record),
                    alldayCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), top: top, rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", allday: true, left: left + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-alldayappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }));
                (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, alldayCellhtml);
                this.element.find(".e-headrealldaytable").append(alldayCellhtml);
            }
            this._alldayLevel = false;
            this.level = this.level < level ? level : this.level;
            if (record[this._appointmentSettings["recurrence"]] != 1) {
                var templist = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, record.ParentId));
                if ((new Date(record[this._appointmentSettings["endTime"]])) < (templist[0][this._appointmentSettings["endTime"]]))
                    (this.model.enableRTL) ? this.element.find('[guid=' + record["Guid"] + ']').children('.e-lefthandle').remove() : this.element.find('[guid=' + record["Guid"] + ']').children(".e-righthandle").remove();
                if ((new Date(record[this._appointmentSettings["startTime"]])) > (templist[0][this._appointmentSettings["startTime"]]))
                    (this.model.enableRTL) ? this.element.find('[guid=' + record["Guid"] + ']').children(".e-righthandle").remove() : this.element.find('[guid=' + record["Guid"] + ']').children('.e-lefthandle').remove();
            }
            if (!ej.isNullOrUndefined(indicationIcon)) {
                if (indicationIcon.leftIndication)
                    this.model.enableRTL ? this.element.find('[guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-left", "11px") : this.element.find('[guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-left", "13px");
                if (indicationIcon.rightIndication)
                    this.model.enableRTL ? this.element.find('[guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-right", "13px") : this.element.find('[guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-right", "11px");
            }
            delete record["Index"];
        },
        _indicationApp: function (record) {
            var leftIndication = false, rightIndication = false;
            var indication = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, record["ParentId"]))[0];
            if (!ej.isNullOrUndefined(indication)) {
                if (indication[this._appointmentSettings["endTime"]].getHours() == 0 && indication[this._appointmentSettings["endTime"]].getMinutes() == 0) {
                    indication = $.extend(true, [], indication);
                    indication[this._appointmentSettings["endTime"]] = new Date(indication[this._appointmentSettings["endTime"]].getTime() - 1000);
                }
                var rightIndication, leftIndication, startCheck, endCheck, dateRender, splitapp;
                dateRender = this.currentView() == "day" ? [new Date(this._dateRender[0]).getTime()] : this._dateRender;
                startCheck = $.inArray(new Date(new Date(record[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime(), dateRender);
                endCheck = $.inArray(new Date(new Date(record[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime(), dateRender);
                splitapp = ((startCheck != endCheck) && (new Date(new Date(indication[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(indication[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((indication[this._appointmentSettings["endTime"]] - indication[this._appointmentSettings["startTime"]]) / 3600000) < 24));
                if (!record[this._appointmentSettings["recurrence"]]) {
                    if (((new Date(indication[this._appointmentSettings["startTime"]]) < record[this._appointmentSettings["startTime"]]) || startCheck == -1) && !splitapp)
                        this.model.enableRTL ? rightIndication = true : leftIndication = true;
                    if (((new Date(indication[this._appointmentSettings["endTime"]]) > record[this._appointmentSettings["endTime"]]) || endCheck == -1) && !splitapp)
                        this.model.enableRTL ? leftIndication = true : rightIndication = true;
                }
                else {
                    var recurIndication = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, record["Guid"]));
                    if (recurIndication.length > 1) {
                        var recur = this._sortAppById(recurIndication);
                        if (((recur[0][this._appointmentSettings["startTime"]] < record[this._appointmentSettings["startTime"]]) || startCheck == -1) && !splitapp)
                            this.model.enableRTL ? rightIndication = true : leftIndication = true;
                        if (((recur[recur.length - 1][this._appointmentSettings["endTime"]] > record[this._appointmentSettings["endTime"]]) || endCheck == -1) && !splitapp)
                            this.model.enableRTL ? leftIndication = true : rightIndication = true;
                    }
                }
                return { leftIndication: (ej.isNullOrUndefined(leftIndication)) ? false : leftIndication, rightIndication: (ej.isNullOrUndefined(rightIndication)) ? false : rightIndication };
            }
            else {
                return { leftIndication: false, rightIndication: false };
            }
        },
        _reRenderScroller: function () {
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                var dialogObj = this._appointmentAddWindow.data("ejDialog");
                dialogObj.option("enableAnimation", false);
                dialogObj.close();
            }
            var _scrollDiv = this.element.find('div#' + this._id + '_scroller');
            var scrollerObj = _scrollDiv.data("ejScroller");
            var scrollWidth = (this.model.orientation === "vertical") ? parseInt(this.element.width()) - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? parseInt(this.element.width()) - parseInt(this.element.find(".e-resourceheadertable").width()) : parseInt(this.element.width());
            scrollerObj.model.width = parseInt(scrollWidth) - 2;
            scrollerObj.model.height = this.scHeight - 1 - (this.wTR.find('.e-draggableworkarea').offset().top - this.element.offset().top);
            scrollerObj.refresh();
            if (this.model.cellWidth != "") {
                var overallWidth = (parseInt(this.model.cellWidth) + 1) * (this.element.find('div.e-draggableworkarea tr:first td').length);
                var timeScaleWidth = this.wTR.find(".e-scrolltimecells").length > 0 ? this.wTR.find(".e-scrolltimecells").width() : 0;
                this.wTR.find(".e-draggableworkarea").width((this.element.width() > (overallWidth) + timeScaleWidth + (_scrollDiv.ejScroller("isVScroll") ? 18 : 0)) ? (overallWidth) - 1 : scrollWidth - 2 - (_scrollDiv.ejScroller("isVScroll") ? 18 : 0));
                this.aTR.find(".e-headeralldaydiv").width(this.wTR.find(".e-draggableworkarea").width());
            }
            if (this.model.orientation == "vertical" && (!this.model.cellHeight) && this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable)
                this.element.find(".e-draggableworkarea").height(scrollerObj.model.height - (_scrollDiv.ejScroller("isHScroll") ? 18 : 0));
            if (this.model.orientation == "vertical" && this._mediaQuery && this.res1.length > 1)
                this.element.find(".e-draggableworkarea").width(this.element.find(".e-draggableworkarea").width() * this.res1.length);
            this.aTR.find(".e-headeralldaydiv").width(this.wTR.find(".e-draggableworkarea").width());
            this.wTR.find(".e-scrolltimecells").css("top", -(this.wTR.find(".e-draggableworkarea").scrollTop()) + "px");
            (this._mediaQuery && !ej.isNullOrUndefined(this._appointmentAddWindow)) && this._appointmentAddWindow.ejDialog("close");
            !ej.isNullOrUndefined(this._appointmentAddWindow) && dialogObj.option("enableAnimation", true);
            if ((this.model.orientation == "horizontal" && _scrollDiv.ejScroller("isVScroll")) || this._mediaQuery) this._renderHoriVerticalScroll();
            this._showScrollTd();
        },
        _appointmentSort: function (appointments) {
            var proxy = this;
            if (this.currentView() == "agenda") {
                appointments.sort(function (a, b) {
                    var d1 = a[proxy._appointmentSettings["startTime"]];
                    var d2 = b[proxy._appointmentSettings["startTime"]];
                    var d3 = a[proxy._appointmentSettings["endTime"]];
                    var d4 = b[proxy._appointmentSettings["endTime"]];
                    return d1.getTime() - d2.getTime() || d3.getTime() - d4.getTime();
                });
            }
            else if (this.currentView() != "day") {
                appointments.sort(function (a, b) {
                    var d1 = a[proxy._appointmentSettings["endTime"]] - a[proxy._appointmentSettings["startTime"]];
                    var d2 = b[proxy._appointmentSettings["endTime"]] - b[proxy._appointmentSettings["startTime"]];
                    var date1 = new Date(a[proxy._appointmentSettings["startTime"]]);
                    var date2 = new Date(b[proxy._appointmentSettings["startTime"]]);
                    var date3 = new Date(a[proxy._appointmentSettings["endTime"]]);
                    var date4 = new Date(b[proxy._appointmentSettings["endTime"]]);
                    var d3 = a[proxy._appointmentSettings["startTime"]];
                    var d4 = b[proxy._appointmentSettings["startTime"]];
                    if (date1 == date2 && date3 == date4)
                        return d3 - d4 || a.Guid.localeCompare(b.Guid);
                    else if (date1 - date2 == 0)
                        return d2 - d1 || d3 - d4 || a.Guid.localeCompare(b.Guid);
                    else
                        return d3 - d4 || a.Guid.localeCompare(b.Guid);
                });
            }
            else {
                appointments.sort(function (a, b) {
                    var d3 = a[proxy._appointmentSettings["startTime"]];
                    var d4 = b[proxy._appointmentSettings["startTime"]];
                    var d1 = a[proxy._appointmentSettings["endTime"]] - a[proxy._appointmentSettings["startTime"]];
                    var d2 = b[proxy._appointmentSettings["endTime"]] - b[proxy._appointmentSettings["startTime"]];
                    return d3 - d4 || d2 - d1 || a.Guid.localeCompare(b.Guid);
                });
            }
            return appointments;
        },
        _alldaySort: function (appointments) {
            var value = [];
            for (var i = 0; i < appointments.length; i++) {
                if (((new Date(appointments[i][this._appointmentSettings["endTime"]]) - new Date(appointments[i][this._appointmentSettings["startTime"]])) / 3600000) < 24 && !appointments[i][this._appointmentSettings["allDay"]])
                    value.push(appointments[i]);
            }
            return value;
        },
        _appointmentRecurrenceSort: function (appointments) {
            var proxy = this;
            appointments.sort(function (a, b) {
                var d1 = a[proxy._appointmentSettings["startTime"]];
                var d2 = b[proxy._appointmentSettings["startTime"]];
                return d1 - d2;
            });
            return appointments;
        },

        _renderMonthAppointment: function () {
            this._overflowFlag = false;
            this.filterData = []; this._renderedApp = [];
            this.element.find(".e-appointwrapper").remove();
            !this.model.showOverflowButton && (this.initialCellHeight = this.model.cellHeight ? parseInt(this.model.cellHeight) : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
            var renderDate = (this.model.orientation == "vertical") ? (this.currentView() == "month" && !this.model.showNextPrevMonth ? this.monthDays : this._dateRender) : this.monthDays;
            var appointments = this._currentViewAppointments = this._appointmentCount();
            var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(renderDate[0])).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59)));
            var appointmentsList = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
            appointments = appointmentsList;
            renderDate = (this.model.orientation == "vertical") ? this._dateRender : this.monthDays;
            if (!this.model.group || (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length == 0) this.res1 = ["0"];
            for (var res = 0; res < this.res1.length; res++) {
                var day = 0, count = renderDate.length;
                if (new Date(renderDate[0]) < this.model.minDate) {
                    day = Math.floor((new Date(this.model.minDate) - new Date(renderDate[0])) / (1000 * 60 * 60 * 24));
                }
                if (new Date(renderDate[renderDate.length - 1]) > this.model.maxDate) {
                    count = renderDate.length - Math.floor((new Date(renderDate[renderDate.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                }
                for (day; day < count; day++) {
                    var predicate12 = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(renderDate[day])).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(renderDate[day]).setHours(23, 59, 59)));
                    predicate12 = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate.and(this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                    appointments = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(predicate12));
                    var renderedAlready = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(renderDate[day]));
                    appointments = new ej.DataManager(appointments).executeLocal(new ej.Query().where(renderedAlready));
                    appointments = this._resourceOrderSort(appointments);
                    for (var app = 0; app < appointments.length; app++) {
                        if (this.model.orientation == "horizontal" && !ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                            var resAvail = new ej.DataManager(this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, ej.FilterOperators.equal, appointments[app][this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 2]]));
                        else var resAvail = this.res1;
                        if (resAvail.length != 0) {
                            if ((new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
                                (new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
                                (new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                                this._renderAppointmentMonth(appointments[app], day, res);
                            }
                        }
                    }
                }
            }
            if (this._overflowFlag) {
                this._reRenderScroller();
                this._overflowFlag = false;
            }
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _wireResizeEvents: function () {
            if (this.model.enableAppointmentResize && !this.model.readOnly) {
                this.element.find("div.e-lefthandle,div.e-righthandle,div.e-tophandle,div.e-bottomhandle").on("mousedown", $.proxy(this._appointmentResizeStart, this));
                this._on(this.element.find("div.e-lefthandle,div.e-righthandle"), "mouseover", $.proxy(this._colHandlesOver, this));
                this._on(this.element.find("div.e-tophandle,div.e-bottomhandle"), "mouseover", $.proxy(this._rowHandlesOver, this));
            }
        },

        _unWireResizeEvents: function () {
            if (this.model.enableAppointmentResize) {
                this.element.find("div.e-lefthandle,div.e-righthandle,div.e-tophandle,div.e-bottomhandle").off("mousedown", $.proxy(this._appointmentResizeStart, this));
                this._off(this.element.find("div.e-lefthandle,div.e-righthandle"), "mouseover", $.proxy(this._colHandlesOver, this));
                this._off(this.element.find("div.e-tophandle,div.e-bottomhandle"), "mouseover", $.proxy(this._rowHandlesOver, this));
            }
        },

        _recuCollectionIndex: function (recurColl, _appList) {
            var index, model = this._appointmentSettings;
            for (var i = 0; i < recurColl.length; i++) {
                if (recurColl[i]["Guid"] == _appList["Guid"]) {
                    if (recurColl[i]["AppTaskId"] == _appList["AppTaskId"]) {
                        index = i;
                        break;
                    }
                }
            }
            return index;
        },

        _getIndex: function (day, record, dateRender, renderedApp, resValue) {
            if (this._renderedApp.length == 0) {
                record.Index = 0;
                var index = 0;
            }
            else {
                var appLevelsInDay = [];
                var proxy = this;
                var len = dateRender.length;
                var data = [];
                if (this.model.orientation == "horizontal" && ej.scheduleFeatures.resources && (this._tempResource.length > 0) && this._grouping.length > 0) {
                    var appointments = renderedApp.filter(function (obj) { return (obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == record[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()]); });
                }
                else
                    var appointments = renderedApp;
                for (var app = 0, alen = appointments.length; app < alen; app++) {
                    if (((ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? (appointments[app][this._tempResource[this._tempResource.length - 1]["field"]] == resValue) : true) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                        data.push(appointments[app]);
                    }
                }
                var index = -1;
                if (data.length > 0) {
                    var appLevelsInDay = $.map(data, function (value, Index) { return [value.Index]; });
                    index = this._smallestMissingNumber(appLevelsInDay);
                }
                index = index == -1 ? 0 : index;
                record.Index = index;
            }
            return index;
        },
        _recurrenceLocal: function () {
            var recurLocale = ej.RecurrenceEditor.Locale[this.model.locale] = $.extend(true, {}, ej.RecurrenceEditor.Locale["en-US"]);
            var proxy = this;
            $.each(recurLocale, function (key, value) { ej.RecurrenceEditor.Locale[proxy.model.locale][key] = proxy._getLocalizedLabels(key); });
        },
        _minMaxIndex: function () {
            var dayIndex = $.unique(this._dateRender.map(function (time) { return new Date(time).getDay(); }));
            var minValue = Math.min.apply(Math, dayIndex);
            var maxValue = Math.max.apply(Math, dayIndex);
            return { minIndex: minValue, maxIndex: maxValue };
        },
        _renderAppointmentMonth: function (record, day, res) {
            var renderDate = (this.model.orientation == "vertical") ? this._dateRender : this.monthDays,
                renderCells = (this.model.orientation == "vertical") ? "td.e-monthcells" : "td.e-workcells",
                appointments = this._renderedApp,
                overlapCount = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? this._getIndex(day, record, renderDate, appointments, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : this._getIndex(day, record, renderDate, appointments, null),
                startTime = new Date(record[this._appointmentSettings["startTime"]]),
                endTime = new Date(record[this._appointmentSettings["endTime"]]),
                appWidth, topPosition = 0,
                start = new Date(startTime),
                end = new Date(endTime),
                r_end = new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59));
            end = end > r_end ? r_end : end;

            this.leftPosition = 0;
            this.CellWidth = this.model.orientation == "vertical" ? this.element.find(".e-monthcells").width() : this.element.find(".e-workcells").width();
            this.CellHeight = this.model.orientation == "vertical" ? this.element.find(".e-monthcells").height() : this.element.find(".e-workcells").height();
            this._renderedApp.push($.extend(true, {}, record));

            var diffInDays = (this.model.showWeekend) ? (start.getHours() == 0 && end.getHours() == 0) ? Math.ceil(((new Date(end) - new Date(start)) / (1000 * 3600)) / 24) : Math.ceil(((new Date(end).setHours(23, 59, 59) - new Date(start).setHours(0, 0, 0)) / (1000 * 3600)) / 24) : this._getTotalDays(start, end),
                noOfDays = (this.model.showWeekend) ? 7 : this._minMaxIndex().maxIndex + 1,
                maxDays = (!this.model.timeScale.enable && this._oneWeek) ? (noOfDays - renderDate.indexOf(start.getTime())) : (noOfDays - new Date(start).getDay()) + this._firstdayofweek;

            if (startTime.getTime() <= endTime.getTime()) {
                if (this.model.orientation == "vertical") {
                    diffInDays = diffInDays >= maxDays ? maxDays : diffInDays;
                    var rowPosition = Math.ceil((day + 1) / ((this.model.showWeekend) ? noOfDays : this.model.workWeek.length));
                    appWidth = (diffInDays * this.CellWidth) - ((this.CellWidth * 5) / 100);
                }
                else {
                    appWidth = (!this.model.timeScale.enable || this.currentView() == "month" || this._isCustomMonthView()) ? (this.model.cellWidth != "") ? ((diffInDays * this.CellWidth) + diffInDays) : (diffInDays * this.CellWidth) : (this.CellWidth * diffInDays) - parseInt((this.CellWidth * 10) / 100);
                }
                var resIndex = ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : 0;
                if (this.model.showWeekend) {
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                        var cellId = this.model.orientation == "vertical" ? this.currentView() == "day" ? resIndex + 1 : this.currentView() == "workweek" || this._isCustomMonthView() && this._oneWeek ? (resIndex * (this._dateRender.length)) + (day + 1) : this.currentView() == "workweek" ? (resIndex * (this._dateRender.length) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * this._dateRender.length)) : this._firstdayofweek == 0 ? (resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) : (this.model.orientation == "vertical" && this._firstdayofweek != 0) ? ((resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) - this._firstdayofweek) : day + 1 : day + 1;
                    else
                        var cellId = (this.model.orientation == "vertical" && this._isCustomMonthView() && !this._oneWeek) ? (resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) : day + 1;
                }
                else {
                    var cellId = this.model.orientation == "vertical" ? ((rowPosition - 1) * (this.res1.length * this.model.workWeek.length)) + (res * this.model.workWeek.length) + (day % this.model.workWeek.length) + 1 : day + 1;
                }
                if (this.model.orientation == "vertical" && this._firstdayofweek != 0 && new Date(startTime).getDay() < this._firstdayofweek)
                    var cellId = (resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) - this._firstdayofweek + noOfDays;
                if (this.model.orientation == "horizontal" && this.model.cellWidth == "" && diffInDays > 1 && !this.model.enableRTL) {
                    var startLeft = this.element.find(".e-workcellstab tr:first").children().eq(cellId - 1).offset().left,
                        endElement = this.element.find(".e-workcellstab tr:first").children().eq(cellId - 2 + diffInDays),
                        endLeft = endElement.offset().left + endElement.width();
                    appWidth = endLeft - startLeft;
                }
                var tempAppWidth = appWidth - 1,
                    userAppTemplId = (this.model.appointmentTemplateId) ? true : false,
                    userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "",
                    monthHeader = (this.element.find('.e-monthheader').length != 0) ? this.element.find('.e-monthheader').height() : 0,
                    appHeight = (!this.model.appointmentTemplateId) ? (this.element.find(".e-monthappointment").length > 0 ? this.element.find(".e-monthappointment").outerHeight(true) : this._getElementHeight("e-monthappointment")) : ($(userTempHtml).css('height') == "100%" ? (!this.model.showOverflowButton ? this.initialCellHeight : (this.CellHeight - monthHeader - 15)) : $(userTempHtml).css('height') == "0px" ? this.element.find(".e-monthappointment").height() : $(userTempHtml).height());
                appWidth = (!this.model.appointmentTemplateId) ? appWidth : ($(userTempHtml).css('width') == "100%" || $(userTempHtml).css('width') == "0px" ? appWidth : $(userTempHtml).width());
                topPosition = (overlapCount * appHeight);
                this.leftPosition = 0;
                if (this._tempResource.length != 0) {
                    var newResCollection = this._resCollection;
                    var newResCollection1 = this._horiGroupCollection();
                }
                if (this.model.orientation == "vertical")
                    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? this._findResourceIndex(newResCollection[0].dataSource, newResCollection[0].id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()]) + 1 : 0;
                else
                    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? this._findResourceIndex(newResCollection1, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()]) + 1 : 0;
                var resValue = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) + 1 : 1,
                    colorAppointment = this._appointmentColor(record),
                    monthCal = this.element.find(".e-monthappointment").length != 0 ? this.element.find(".e-monthappointment").outerWidth(true) - this.element.find(".e-monthappointment").width() : 0,
                    colCount = parseInt(this.CellWidth / (this.CellWidth <= appWidth ? this.CellWidth : (appWidth + monthCal))),
                    rowCount = parseInt((this.CellHeight - monthHeader - 10) / (this.element.find(".e-monthappointment").length > 0 ? this.element.find(".e-monthappointment").outerHeight(true) : appHeight));
                this.CellHeight = (this.model.orientation == "horizontal") ? this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find(".e-workcells").height() : this.element.find("td.e-monthcells").eq(cellId - 1).parent().children().outerHeight();
                var indicationIcon = this._indicationApp(record),
                    startTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale),
                    endTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                if (this.model.showOverflowButton && userAppTemplId && $(userTempHtml).css('height') != "0px" && this.model.orientation != "horizontal" ? ((overlapCount + 1) <= (colCount * rowCount)) : (this.CellHeight > monthHeader + ((overlapCount + 1) * appHeight) + 10)) {
                    if (userAppTemplId && (appWidth < tempAppWidth))
                        this.element.find(".e-appointwrapper").eq(cellId - 1).attr('style', "height:" + (parseInt(overlapCount / colCount) + 1) * appHeight + "px !important;width:" + this.CellWidth + "px !important;position:absolute !important;");
                    if (topPosition > 1) topPosition = (overlapCount * appHeight);
                    this.leftPosition = (this.leftPosition > 1) ? this.leftPosition - 1 : this.leftPosition;
                    var recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false;
                    var timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }));
                    var celltd = (this.model.orientation == "vertical") ? this.element.find("td.e-monthcells").eq(cellId - 1) : this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(cellId - 1);
                    (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                    if (this.model.orientation == "vertical") {
                        celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.find(".e-monthheader").after($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                    }
                    else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
                        celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                        if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                            this._renderAppointmentCategory(newResCollection1, groupIndex, cellId - 1, record, appWidth, this.leftPosition);
                    }
                    timeCellhtml = "";
                }
                else {
                    if ($("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1)).length != 0) {
                        $("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1)).remove();
                    }
                    if (this.model.showOverflowButton) {
                        var count = cellId - 1,
                            DateString = new Date(record[this._appointmentSettings["startTime"]]).getTime(),
                            endDay = Math.round(((record[this._appointmentSettings["endTime"]] - record[this._appointmentSettings["startTime"]]) / 3600000) / 24),
                            i = count,
                            appCount = overlapCount + 1;
                        do {
                            var celltd = this.model.orientation == "vertical" ? this.element.find("td.e-monthcells").eq(i) : this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(i);
                            var overflowhtml = '<div id="' + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + (i) + '" class="e-icon e-arrowhead-down e-appsoverflow" cellinfo="' + renderDate[day] + '" appcount="' + appCount + '"></div>';
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(overflowhtml) : (this.model.orientation == "vertical") ? celltd.find(".e-monthheader").after($("<div class='e-appointwrapper'></div>").append(timeCellhtml)) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                            DateString = DateString + (60 * 60 * 24 * 1000);
                            i++;
                        }
                        while (i < endDay + count);
                        if (this.model.orientation == "horizontal" && !ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                            this._renderAppointmentCategory(newResCollection1, groupIndex, cellId - 1, record, appWidth, this.leftPosition);
                    }
                    else {
                        if (this.model.orientation == "vertical") {
                            topPosition = (overlapCount * appHeight);
                            var recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                timecellindex = this.element.find("td.e-monthcells").eq(cellId - 1).parent().index(),
                                timeCellhtml = this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }),
                                celltd = this.element.find("td.e-monthcells").eq(cellId - 1),
                                cellHeight = this.element.find("td.e-monthcells").eq(cellId - 1).parent().children().outerHeight();
                            this.CellHeight = (cellHeight > ((appHeight * (overlapCount + 1)) + monthHeader)) ? cellHeight : (cellHeight + (appHeight - 1));
                            this.element.find("td.e-monthcells").eq(cellId - 1).parent().children().css('height', this.CellHeight + "px");
                            this.element.find(".e-timecells").eq(timecellindex).css('height', this.CellHeight + "px");
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.find(".e-monthheader").after($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                        }
                        else {
                            topPosition = (overlapCount * appHeight);
                            if ((this.CellHeight - 10) < (appHeight * (overlapCount + 1))) {
                                this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find(".e-workcells").css('height', this.CellHeight + appHeight + "px");
                                this.element.find(".e-resourceheadertable tr").eq(resValue + groupIndex - 1).find(".e-childnode").css('height', this.CellHeight + appHeight + "px");
                            }
                            var recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                timeCellhtml = this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }),
                                celltd = this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(cellId - 1);
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                            if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                                this._renderAppointmentCategory(newResCollection1, groupIndex, cellId - 1, record, appWidth, this.leftPosition);
                        }
                        this._overflowFlag = true;
                    }
                    var appsoverflow = (this.element.find('.e-appsoverflow').length > 0) ? this.element.find('.e-appsoverflow').height() : 0;
                    topPosition = this.CellHeight - ((monthHeader + appsoverflow) - 2);
                    (this.model.enableRTL) ? this.element.find(".e-icon.e-appsoverflow").css({ right: (this.CellWidth + this.leftPosition - 25) + "px", top: topPosition + "px" }) : this.element.find(".e-icon.e-appsoverflow").css({ left: (this.CellWidth + this.leftPosition - 25) + "px", top: topPosition + "px" });
                }
                delete record["Index"];
            }
            if (!record[this._appointmentSettings["recurrence"]]) {
                var templist = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, record.ParentId));
                var tempMultiApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, record.Guid));
                if ((new Date(record[this._appointmentSettings["endTime"]])) < (templist[0][this._appointmentSettings["endTime"]])) {
                    (this.model.enableRTL) ? this.element.find(renderCells).eq(cellId - 1).find('[guid=' + templist[0]["Guid"] + ']').children(".e-lefthandle").remove() : this.element.find(renderCells).eq(cellId - 1).find('[guid=' + templist[0]["Guid"] + ']').children(".e-righthandle").remove();
                }
                if ((new Date(record[this._appointmentSettings["startTime"]])) > (templist[0][this._appointmentSettings["startTime"]])) {
                    (this.model.enableRTL) ? this.element.find(renderCells).eq(cellId - 1).find('[guid=' + record["Guid"] + ']').children(".e-righthandle").remove() : this.element.find(renderCells).eq(cellId - 1).find('[guid=' + record["Guid"] + ']').children(".e-lefthandle").remove();
                }
            }
            if (!ej.isNullOrUndefined(tempMultiApp) && tempMultiApp > 1) {
                this.element.find(renderCells).eq(cellId - 1).find('[guid=' + record["Guid"] + ']').children(".e-lefthandle").remove();
                this.element.find(renderCells).eq(cellId - 1).find('[guid=' + record["Guid"] + ']').children(".e-righthandle").remove();
            }
            if (!ej.isNullOrUndefined(indicationIcon)) {
                if (indicationIcon.leftIndication)
                    this.model.enableRTL ? this.element.find('[guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-left", "11px") : this.element.find('[guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-left", "13px");
                if (indicationIcon.rightIndication)
                    this.model.enableRTL ? this.element.find('[guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-right", "13px") : this.element.find('[guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-right", "11px");
            }
        },

        _getElementHeight: function (elementClass) {
            var el = $(document.createElement('div')).addClass(elementClass).clone(false), height;
            el.css({ visibility: 'hidden', position: 'absolute' });
            el.appendTo(this.element.find(".e-scheduleinner"));
            height = el.outerHeight(true);
            el.remove()
            return height;
        },

        _quickWindowClose: function () {
            this._quickAppointWindow.find(".e-error").remove();
            this._quickAppointWindow.ejDialog("close");
            this._scrollerPosition();
            this._processFocus();
        },

        _appointmentWindow: function (e) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._quickAppointWindow.ejDialog("close");
            var startTime, endTime, _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            if (this.currentView() != "agenda" && !_target.hasClass("e-detailedapp") && (!ej.isNullOrUndefined(this.model.workCellsTemplateId) || !ej.isNullOrUndefined(this.model.allDayCellsTemplateId)))
                _target = !ej.isNullOrUndefined($(e.target).closest(".e-appointment,.e-monthappointment")) ? $(e.target).closest(".e-appointment,.e-monthappointment") : _target.closest(".e-workcells, .e-alldaycells, .e-monthcells");
            if (_target.hasClass("e-appup") || _target.hasClass("e-appdown") || _target.closest(".e-blocktimeappointment").hasClass("e-blocktimeappointment") || _target.closest(".e-categorybar").hasClass("e-categorybar")) return false;
            var customFlag = (_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells") || this._cellClick || _target.hasClass("e-detailedapp")) && !_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-schedulemouseclose") && !_target.hasClass("e-appointinnertext") && !_target.hasClass("e-apptext") && !_target.hasClass("e-apptime");
            var eventFlag = (this.model.appointmentWindowOpen != null || this.model.cellDoubleClick != null) || (!ej.isNullOrUndefined(this.model.serverEvents) && ((this.model.serverEvents.indexOf("appointmentWindowOpen") != -1) || (this.model.serverEvents.indexOf("cellDoubleClick") != -1)));
            var event = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, target: e, resources: (eventFlag && customFlag && (this._tempResource.length != 0)) ? this._getResourceValue(_target) : null };
            if ((_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells") || this._cellClick || _target.hasClass("e-detailedapp")) && !_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-schedulemouseclose") && !_target.hasClass("e-appointinnertext") && !_target.hasClass("e-apptext") && !_target.hasClass("e-apptime")) {
                if (!ej.isNullOrUndefined(this.model.cellDoubleClick) && this._trigger("cellDoubleClick", event)) return false;
                this._currentAction = ej.Schedule.Actions.Add;
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                    this._appointmentAddWindow.find(".e-recurEditor").css("display", "none");
                    this._appointmentAddWindow.find(".e-appwindow").css("display", "block");
                }
                var index = this._cellIndex;
                var renderDate = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
                var curDate = new Date(renderDate[index]);
                if (this.model.minDate > curDate || this.model.maxDate < curDate) return false;
                startTime = new Date(this.cur_StartTime);
                endTime = new Date(this.cur_EndTime);
                if (!ej.isNullOrUndefined(this.model.appointmentWindowOpen) || (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("appointmentWindowOpen") != -1))) {
                    if (this._trigger("appointmentWindowOpen", event)) return false;
                }
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                    this._appointmentAddWindow.find("#" + this._id + "subject").val(this.model.showQuickWindow ? this._quickAppointWindow.find(".subject").val() : "");
                    this._appointmentAddWindow.find("#" + this._id + "location").val(this.model.showQuickWindow ? this._quickAppointWindow.find(".location").val() : "");
                    this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", { value: ej.format(new Date(startTime), this._datepattern(), this.model.locale) });
                    this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", { value: ej.format(new Date(endTime), this._datepattern(), this.model.locale) });
                    this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(new Date(startTime), this._pattern.t, this.model.locale));
                    this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(new Date(endTime), this._pattern.t, this.model.locale));
                    this._appointmentAddWindow.find("#" + this._id + "priority").ejDropDownList("option", "value", this.model.prioritySettings.dataSource[0][this.model.prioritySettings["value"]]);
                    ($(e.currentTarget).hasClass("e-alldaycells") || this.currentView() == "month" || (this._isCustomMonthView())) && this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                    this._timeZoneCollection(null);
                    this._tempStart = this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value");
                    this._tempEnd = this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value");
                    this._alldayCheck();
                    if (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0)
                        this._renderResourceData(_target, this._cellIndex);
                    if (!this.model.readOnly) {
                        this._appointmentAddWindow.find(".e-appsave ,#" + this._id + "donerecur").ejButton("enable", true);
                        (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "none");
                        this._appointmentAddWindow.ejDialog("open");
                    }
                    (!this._mediaQuery) && this._appointmentAddWindow.find(".subject").focus();
                    this._cellClick = false;
                }
            }
            else {
                if (!_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-schedulemouseclose")) {
                    if (_target.hasClass("e-monthheader") || _target.hasClass("e-appsoverflow")) return false;
                    var target = (this._editKey) ? $(e) : _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") || _target.hasClass("e-agendaappointment") ? _target : _target.parents('.e-monthappointment,.e-appointment,.e-alldayappointment,.e-agendaappointment');
                    this.currentView() == "agenda" && (target = target.hasClass("e-agendaappointment") ? target : this.element.find(".e-selectedCell").parent().find(".e-agendaappointment"));
                    if (target.length > 0 && !ej.isNullOrUndefined(target[0].id)) {
                        this._currentAction = ej.Schedule.Actions.Save;
                        this._appUid = target.attr('guid');
                        var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                            if (ej.isNullOrUndefined(this._recurEditWindow)) this._renderRecurEditWindow();
                            this._parentId = templist[0]["ParentId"];
                            this._recurEditWindow.ejDialog("open");
                            this._recurEditWindow.focus();
                            this._deleteBeforeOpen();
                        }
                        else
                            this._showAppointmentDetails(this._appUid, true);
                        if (!ej.isNullOrUndefined(this._quickAppDetailsWindow) && this.model.showQuickWindow) this._quickAppDetailsWindow.ejDialog("close");
                    }
                    this._editKey = false;
                }
            }
        },

        _editRecurrence: function (args) {
            this._appointmentAddWindow.find(".e-appwindow").toggle();
            (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "none");
            this._appointmentAddWindow.find(".e-recurEditor").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
        },

        _showAppointmentDetails: function (appId, editOcurrence) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            (ej.isNullOrUndefined(this._appointmentAddWindow)) && ej.RecurrenceEditor.prototype._initializePrivateProperties();
            var recurEdit = !ej.isNullOrUndefined(this._appointmentAddWindow) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
            this._appUid = ej.isNullOrUndefined(this._appUid) ? appId : this._appUid;
            this._currentAction = (ej.isNullOrUndefined(this._currentAction) || this._currentAction == "") ? ej.Schedule.Actions.Save : this._currentAction;
            var query = editOcurrence == true ? new ej.Query().where("Guid", ej.FilterOperators.equal, appId) : new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, appId);
            var list = editOcurrence == true ? this._processed : this._currentAppointmentData;
            var templist = this._sortAppById(new ej.DataManager(list).executeLocal(query));
            var data = { appointment: templist[0], edit: editOcurrence };
            if (this._trigger("appointmentWindowOpen", data)) return false;
            templist[0][this._appointmentSettings["endTime"]] = templist[templist.length - 1][this._appointmentSettings["endTime"]];
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                this._appointmentAddWindow.find('.subject').val(templist[0][this._appointmentSettings["subject"]]);
                this._appointmentAddWindow.find('.location').val(templist[0][this._appointmentSettings["location"]]);
                this._appointmentAddWindow.find('.id').val(templist[0]["AppTaskId"]);
                this._appointmentAddWindow.find('.e-description').val(templist[0][this._appointmentSettings["description"]] ? templist[0][this._appointmentSettings["description"]] : "");
                var temp = templist[0];
                this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", ej.format(temp[this._appointmentSettings["startTime"]], this._datepattern(), this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", ej.format(temp[this._appointmentSettings["endTime"]], this._datepattern(), this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(temp[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(temp[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale));
                if (this.model.prioritySettings.enable) {
                    if (!ej.isNullOrUndefined(temp[this._appointmentSettings["priority"]])) {
                        this._appointmentAddWindow.find("#" + this._id + "priority").ejDropDownList("option", { value: templist[0][this._appointmentSettings["priority"]] });
                    }
                    else {
                        this._appointmentAddWindow.find("#" + this._id + "priority").ejDropDownList("option", { value: this.model.prioritySettings.dataSource[0][this.model.prioritySettings.value] });
                    }
                }
                this._timeZoneCollection(temp);
                this._tempStart = this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value");
                this._tempEnd = this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value");

                templist[0][this._appointmentSettings["allDay"]] == 1 && (this._appointmentAddWindow.find(".allday ").ejCheckBox({ checked: true }));
                if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                    recurEdit._recRule = templist[0][this._appointmentSettings["recurrenceRule"]];
                    if (editOcurrence == true) {
                        (!ej.isNullOrUndefined(templist[0][this._appointmentSettings["recurrenceRule"]]) && templist[0][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) && (this._currentAction = ej.Schedule.Actions.Save);
                        this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true, enabled: false });
                        this._appointmentAddWindow.find(".e-repeatlbl").addClass('e-disable');
                        this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
                        this._appointmentAddWindow.find(".e-recurFinalRule").html("");
                    }
                    else {
                        recurEdit.recurrenceRuleSplit(templist[0][this._appointmentSettings["recurrenceRule"]], temp[this._appointmentSettings["recurrenceExDate"]]);
                        this._appointmentAddWindow.find(".recurstartdate").ejDatePicker({ value: ej.format(temp[this._appointmentSettings["startTime"]], this._datepattern(), this.model.locale) });
                        this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                        this._appointmentAddWindow.find(".e-recurFinalRule").html(recurEdit.showRecurrenceSummary(appId));
                        this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                        this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                    }
                }
                if (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(temp[this._appointmentSettings["categorize"]])) {
                    this._showCategorizeDetails(temp);
                }
                if (this._tempResource.length != 0 && ej.scheduleFeatures.resources)
                    this._showMultipleResourceDetails(temp);
                if (temp[this._appointmentSettings["allDay"]] || this.currentView() == "agenda") this._alldayCheck();
                var enableDisable = (this.model.readOnly) ? "disable" : "enable";
                this._appointmentAddWindow.find(".e-appsave,#" + this._id + "donerecur").ejButton(enableDisable, true);
                (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "block");
                this._appointmentAddWindow.ejDialog("open");
                (!this._mediaQuery) && this._appointmentAddWindow.find(".subject").focus();
            }
        },

        _recurDateChange: function (args) {
            this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", args);
            if (this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value") < this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value"))
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", args);
            else if (args != this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value"))
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", args);
        },

        _cancel: function () {
            this._appointmentAddWindow.ejDialog("close");
        },

        _timeChange: function (e) {
            var obj = this._appointmentAddWindow.find("#" + this._id + "starttime").data("ejTimePicker");
            if (ej.isNullOrUndefined(e.value)) {
                obj.option("value", new Date(this.cur_StartTime));
                return;
            }
            if (obj.showDropdown && obj._id == this._id + "starttime") {
                if (this._appointmentAddWindow.find('.startutc').val() != this._appointmentAddWindow.find('.endutc').val()) {
                    this._utcValue("", "starttime");
                }
                else {
                    var end = this._timeFormat(this._appointmentAddWindow.find('#' + this._id + 'endtime').ejTimePicker("option", "value")).split(":");
                    var endTime = new Date(new Date("1/1/2000").setHours(parseInt(end[0], 10), parseInt(end[1], 10)));
                    var start = this._timeFormat(this._appointmentAddWindow.find('#' + this._id + 'starttime').ejTimePicker("option", "value")).split(":");
                    var startTime = new Date(new Date("1/1/2000").setHours(parseInt(start[0], 10), parseInt(start[1], 10)));
                    var prev = this._timeFormat(e.prevTime).split(":");
                    var prevtime = new Date(new Date("1/1/2000").setHours(parseInt(prev[0], 10), parseInt(prev[1], 10)));
                    var updatetime = new Date(new Date(startTime).setHours(startTime.getHours() + endTime.getHours() - prevtime.getHours(), startTime.getMinutes() + endTime.getMinutes() - prevtime.getMinutes()));
                    this._appointmentAddWindow.find('#' + this._id + 'endtime').ejTimePicker("option", "value", updatetime);
                }
                this._startSlotChange = true;
            }
        },
        _setQuickValidation: function () {
            if (ej.isNullOrUndefined(this._quickAppointWindow)) return false;
            var form = this._id + "_AddForm";
            this._initValidator(form);
            if (!ej.isNullOrUndefined(this.model.appointmentSettings["subject"]) && !ej.isNullOrUndefined(this.model.appointmentSettings["subject"]["validationRules"])) {
                var name = this.model.appointmentSettings["subject"].field, rules = this.model.appointmentSettings["subject"]["validationRules"];
                ele = this._quickAppointWindow.find('.subject');
                !ele.attr("name") && ele.attr("name", name);
                ele.rules("add", rules);
                var validator = $("#" + this._id + "_AddForm").validate();
                if (!ej.isNullOrUndefined(rules["required"])) {
                    ej.isNullOrUndefined(validator.settings.messages[name]) ? (validator.settings.messages[name] = {}) : "";
                    validator.settings.messages[name]["required"] = (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"])) ? rules["messages"]["required"] : name + " is required.";
                }
            }
        },
        _setValidation: function () {
            var form = this._id + "_AddEditForm";
            this._initValidator(form);
            var proxy = this;
            $.each(this.model.appointmentSettings, function (key, value) {
                if (!ej.isNullOrUndefined(proxy.model.appointmentSettings[key]) && !ej.isNullOrUndefined(proxy.model.appointmentSettings[key]["validationRules"])) {
                    proxy._setValidationToField(key, proxy.model.appointmentSettings[key].field, proxy.model.appointmentSettings[key].validationRules);
                }
            });
        },
        _initValidator: function (form) {
            $("#" + form).validate({
                onfocusout: false,
                ignore: ".e-hide",
                errorClass: 'e-field-validation-error',
                errorElement: 'div',
                wrapper: "div",
                errorPlacement: function (error, element) {
                    var $td = element.closest("td"), $container = $(error).addClass("e-error"), $tail = ej.buildTag("div.e-errortail e-toparrow"), $container;
                    $td.find(".e-error").remove();
                    (element.parent().hasClass("e-in-wrap")) ? $container.insertAfter(element.closest(".e-widget")) : $container.insertAfter(element);
                    $container.prepend($tail)
                    var offsettop = (element[0]['type'] == 'checkbox' || element[0]['type'] == 'hidden') ? element.parent().offset().top + element.parent().height() : element.offset().top + element.height();
                    $container.offset({ top: offsettop });
                    $container.fadeIn("slow");
                }
            });
        },
        _setValidationToField: function (field, name, rules) {
            if (field == "startTime")
                ele = this._appointmentAddWindow.find("#" + this._id + "startdate,#" + this._id + "starttime");
            else if (field == "endTime")
                ele = this._appointmentAddWindow.find("#" + this._id + "enddate,#" + this._id + "endtime");
            else if (field == "resourceFields")
                ele = $("#" + this._id + "AppointmentAddEditWindow").find("[id^=" + this._id + "_ownerfield_" + "][type!=hidden]").find(".e-autocomplete");
            else
                ele = $("#" + this._id + "AppointmentAddEditWindow").find("[name=" + name + "][type!=hidden]");
            if (ele.length < 1) ele = $("#" + this._id + field);
            for (var i = 0; i < ele.length; i++) {
                if ($(ele[i]).hasClass("e-autocomplete")) {
                    var obj = $(ele[i]).data("ejAutocomplete");
                    ele[i] = obj.model.multiSelectMode == "visualmode" ? obj._hiddenInput : obj.element;
                }
                $(ele[i]).rules("add", rules);
                var validator = $("#" + this._id + "_AddEditForm").validate();
                if (!ej.isNullOrUndefined(rules["required"])) {
                    ej.isNullOrUndefined(validator.settings.messages[name]) ? (validator.settings.messages[name] = {}) : "";
                    validator.settings.messages[name]["required"] = (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"])) ? rules["messages"]["required"] : name + " is required.";
                }
            }
        },
        _endTimeChange: function (e) {
            var obj = this._appointmentAddWindow.find("#" + this._id + "endtime").data("ejTimePicker");
            if (ej.isNullOrUndefined(e.value)) {
                obj.option("value", new Date(this.cur_EndTime));
                return;
            }
            if (obj.showDropdown && obj._id == this._id + "endtime") {
                this._endSlotChange = true;
            }
        },

        _renderControls: function (e) {
            var control = this._appointmentAddWindow;
            control.find('.allday').ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._alldayCheck, this) });
            control.find('.startenddate').ejDatePicker({ buttonText: this._getLocalizedLabels("Today"), startDay: this._firstdayofweek, enableRTL: this.model.enableRTL, width: '100%', value: this.currentDate(), locale: this.model.locale, dateFormat: this.model.dateFormat, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
            control.find("#" + this._id + "starttime").ejTimePicker({ enableRTL: this.model.enableRTL, width: "100%", value: this.currentDate(), locale: this.model.locale, change: $.proxy(this._timeChange, this), cssClass: this.model.cssClass, interval: 30, timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
            control.find("#" + this._id + "endtime").ejTimePicker({ enableRTL: this.model.enableRTL, width: "100%", value: this.currentDate(), locale: this.model.locale, change: $.proxy(this._endTimeChange, this), cssClass: this.model.cssClass, interval: 30, timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
            control.find("#" + this._id + "startTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._startUtc, this), cssClass: this.model.cssClass });
            control.find("#" + this._id + "endTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._endUtc, this), cssClass: this.model.cssClass });
            if (this.model.prioritySettings.enable && !(this.model.prioritySettings.dataSource instanceof ej.DataManager)) this._renderPriorityItems(control);
            if (this._tempResource.length != 0 && ej.scheduleFeatures.resources) this._renderAppWindowResources(control);
            if (this.model.categorizeSettings.enable && !(this.model.categorizeSettings.dataSource instanceof ej.DataManager)) this._renderCategoryItems(control);
            control.find('.recurrence').ejCheckBox({ enableRTL: this.model.enableRTL, change: $.proxy(this._repeat, this), cssClass: this.model.cssClass });
            control.find('.e-btndone').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: (this._mediaQuery) ? "100%" : "100px", click: $.proxy(this._saveAppointment, this), cssClass: "e-flat" + this.model.cssClass });
            control.find('.cancel').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: (this._mediaQuery) ? "100%" : "100px", click: $.proxy(this._cancel, this), cssClass: "e-flat" + this.model.cssClass });
            (this._mediaQuery) && control.find('.e-btndelete').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100%", click: $.proxy(this._mobileAppDelete, this), cssClass: "e-flat" + this.model.cssClass });
        },

        _mobileAppDelete: function () {
            if ((this._mediaQuery) && !(ej.isNullOrUndefined(this._editOnlyClicked)) && !(this._editOnlyClicked) && this._appointmentAddWindow.find(".recurrence").ejCheckBox("option", "checked")) {
                this._deleteApp(this._appUid);
            }
            else
                this._deleteAppoint();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog("close");
        },

        _renderPriorityItems: function (control) {
            if (!ej.isNullOrUndefined(control)) {
                control.find('.priority').ejDropDownList({
                    enableRTL: this.model.enableRTL,
                    template: ej.isNullOrUndefined(this.model.prioritySettings["template"]) ? "<div class='e-" + "${" + this.model.prioritySettings["value"] + "}'></div><div>${" + this.model.prioritySettings["text"] + "}</div>" : this.model.prioritySettings["template"] + "${" + this.model.prioritySettings["text"] + "}",
                    dataSource: this.model.prioritySettings.dataSource, fields: { text: this.model.prioritySettings["text"], value: this.model.prioritySettings["value"] },
                    width: "100%",
                    cssClass: this.model.cssClass
                });
            }
        },

        _renderCategoryItems: function (control) {
            if (!ej.isNullOrUndefined(control)) {
                control.find('.e-categorizevalue').ejAutocomplete({
                    enableRTL: this.model.enableRTL,
                    showPopupButton: true,
                    width: "100%", cssClass: this.model.cssClass,
                    multiSelectMode: this.model.categorizeSettings.allowMultiple ? "visualmode" : "none",
                    focusOut: $.proxy(this._categorizeValidate, this),
                    dataSource: this.model.categorizeSettings.dataSource, fields: { text: this.model.categorizeSettings["text"], value: this.model.categorizeSettings["color"], key: this.model.categorizeSettings["id"], fontColor: this.model.categorizeSettings["fontColor"] },
                    template: this._categorizeTemplate,
                    emptyResultText: this._getLocalizedLabels("EmptyResultText")
                });
            }
        },
        _categorizeValidate: function (args) {
            if ($.isFunction($.validator) && !$("#" + this._id + "_AddEditForm").validate().form())
                return false;
        },
        _appointmentColor: function (record) {
            var appointColor = (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(record[this._appointmentSettings["categorize"]]) && record[this._appointmentSettings["categorize"]] != "") ? this._getCategorizeColor(record) : ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) ? this._getResourceColor(record) : { appointData: "", appointCustomcss: "", appointtextcolor: "", applyFilter: true };

            if (this.model.categorizeSettings.enable && this.model.categorizeSettings.allowMultiple && !ej.isNullOrUndefined(record[this._appointmentSettings["categorize"]])) {
                var categorizeItems = record[this._appointmentSettings["categorize"]].split(",");
                var categorizeItemsLength = categorizeItems.length;
                var value = (categorizeItemsLength > 1) ? true : false;
                var multiDiv = this._categorizeMultipleDiv(record, categorizeItems, categorizeItemsLength);
            }
            if (!ej.isNullOrUndefined(multiDiv) && appointColor.appointData.length > 0 && this.model.categorizeSettings.allowMultiple)
                return { appointColor: appointColor, value: value, multiDiv: multiDiv, applyFilter: false };
            else if (appointColor.appointData.length > 0 && !this.model.categorizeSettings.allowMultiple || (this._tempResource.length != 0) && ej.scheduleFeatures.resources)
                return { appointColor: appointColor, applyFilter: false };
            else {
                appointData = "", appointCustomcss = "", appointtextcolor = "", value = "";
                return { appointColor: appointColor, value: value, multiDiv: multiDiv, applyFilter: true };
            }
        },

        _categorizeMultipleDiv: function (record, categorizeItems, categorizeItemsLength) {
            var renderData = [];
            for (i = 0; i <= categorizeItemsLength - 1; i++) {
                if (i != categorizeItemsLength - 1) {
                    var dataSet = this.model.categorizeSettings;
                    var categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], categorizeItems[i]);
                    (ej.isNullOrUndefined(categorizeDataIndex)) && (categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], parseInt(categorizeItems[i])));
                    if (ej.isNullOrUndefined(categorizeDataIndex)) {
                        record[this._appointmentSettings["categorize"]] = "";
                        return null;
                    }
                    else
                        renderData.push({ text: dataSet.dataSource[categorizeDataIndex][dataSet.text], value: dataSet.dataSource[categorizeDataIndex][dataSet.color], key: dataSet.dataSource[categorizeDataIndex][dataSet.id], fontColor: dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] })
                }
            }
            var template = this._categorizeMultipleTemplate.render({ renderData: renderData });
            return template;
        },

        _getResCategorySaveData: function (categorizeVal, autoVal, obj, maxId, parId, starttime, endtime) {
            var args = [], newAppointment, data, prevdata, tempSource = [];
            newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
            if (categorizeVal.length > 0 && !ej.isNullOrUndefined(categorizeVal[0][0])) {
                var categorizeItemsLength = categorizeVal[categorizeVal.length - 1].length - 1; var idValue = "";
                for (var i = 0; i <= categorizeItemsLength; i++) {
                    var getId = categorizeVal[categorizeVal.length - 1][i][this.model.categorizeSettings["id"]];
                    idValue = (i != categorizeItemsLength) ? idValue + getId.toString() + "," : idValue + getId.toString();
                }
                newAppointment[this._appointmentSettings["categorize"]] = idValue;
            }
            if (autoVal.length > 0) {
                var categorizeVar = newAppointment[this._appointmentSettings["categorize"]];
                var resources = this._appointmentSettings.resourceFields.toString().split(',');
                if (this._grouping.length != 0) {
                    if (resources.length != this._grouping.length) {
                        for (var i = 0; i < this._grouping.length; i++) {
                            tempSource.push(resources[i]);
                        }
                        resources = tempSource;
                    }
                }
                var newResCollection = this._getResourceCollection();
                if (autoVal[autoVal.length - 1].length > 0) {
                    for (var j = 0; j < autoVal[autoVal.length - 1].length; j++) {
                        newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                        if (categorizeVal.length > 0)
                            newAppointment[this._appointmentSettings["categorize"]] = categorizeVar;

                        if (autoVal[autoVal.length - 1].length > 1) {
                            obj.Guid = this._guidFormatGenerate();
                            maxId++;
                            var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, maxId));
                            maxId = (templist.length == 0) ? maxId : this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"] + 1;
                            obj[this._appointmentSettings["id"]] = parId = maxId;
                            if (this._currentAction == ej.Schedule.Actions.EditSeries) obj[this._appointmentSettings["recurrenceId"]] = maxId;
                        }
                        newAppointment[resources[resources.length - 1].trim()] = autoVal[resources.length - 1][j][newResCollection[newResCollection.length - 1]["id"]];

                        var id = autoVal[resources.length - 1][j][newResCollection[newResCollection.length - 1]["id"]];
                        for (var i = resources.length - 1; i > 0; i--) {
                            data = this.render_Resources[i] instanceof ej.DataManager ? this.render_Resources[i] : ej.DataManager(this.render_Resources[i]);
                            query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, id);
                            appointId = data.executeLocal(query);
                            prevdata = this.render_Resources[i - 1] instanceof ej.DataManager ? this.render_Resources[i - 1] : ej.DataManager(this.render_Resources[i - 1]);
                            query1 = new ej.Query().where(newResCollection[i - 1].id, ej.FilterOperators.equal, appointId[0][newResCollection[i].groupId]);
                            appointGroupId = prevdata.executeLocal(query1);
                            id = appointGroupId[0][newResCollection[i - 1].id];
                            newAppointment[resources[i - 1]] = id;
                        }
                        if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                        args.push(newAppointment);
                    }
                }
                else {
                    var resources = this._appointmentSettings.resourceFields.toString().split(',');
                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                    if (categorizeVal.length > 0)
                        newAppointment[this._appointmentSettings["categorize"]] = categorizeVar;
                    if (resources.length > 1) {
                        for (i = 0; i < resources.length; i++) {
                            newAppointment[resources[i].trim()] = this._tempResource[i].resourceSettings.dataSource[0].id
                        }
                    }
                    else
                        newAppointment[resources[resources.length - 1].trim()] = this._tempResource[0].resourceSettings.dataSource[0].id;
                    if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                    args.push(newAppointment);
                }
            }

            if (autoVal.length == 0 && categorizeVal.length > 0) {
                if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                args.push(newAppointment);
            }
            return args;
        },

        _timeZoneCollection: function (temp) {
            if (!ej.isNullOrUndefined(temp)) {
                this.startTimeAppoint = temp[this._appointmentSettings["startTimeZone"]];
                this.endTimeAppoint = temp[this._appointmentSettings["endTimeZone"]];
            }
            this.startutcValue = this.tempValue = null;
            if (!ej.isNullOrUndefined(temp) && this.endTimeAppoint) {
                this._utcValue(temp, "Appoint");
                this.tempValue = 1;
            }
            var rawTimezone = (this.model.timeZone == null) ? this._timezoneStringValue() : this.model.timeZone;
            var value1 = !ej.isNullOrUndefined(temp) ? ej.isNullOrUndefined(this.startTimeAppoint) ? rawTimezone : this.startTimeAppoint : rawTimezone;
            var addUTC = (value1.indexOf("UTC") != 0) ? "UTC " + value1 : value1;
            var zeroValue = (addUTC.split(" ")[1].split(":")[0].length != 3) ? ((addUTC.split(" ")[1].split(":")[0][0] == "+") ? "+0" + addUTC.split(" ")[1].split(":")[0].split("+")[1] + ":" + addUTC.split(" ")[1].split(":")[1] : "-0" + addUTC.split(" ")[1].split(":")[0].split("-")[1] + ":" + addUTC.split(" ")[1].split(":")[1]) : addUTC;
            var timeZoneValue = (zeroValue.indexOf("UTC") != 0) ? "UTC " + zeroValue : zeroValue;
            var value = !ej.isNullOrUndefined(this._findResourceIndex(this.model.timeZoneCollection.dataSource, this.model.timeZoneCollection["value"], timeZoneValue)) ? this._findResourceIndex(this.model.timeZoneCollection.dataSource, this.model.timeZoneCollection["value"], timeZoneValue) : "add";
            if (!ej.isNullOrUndefined(temp) && value !== "add") {
                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList("option", { value: (!ej.isNullOrUndefined(temp) && !ej.isNullOrUndefined(this.startTimeAppoint)) ? this.startTimeAppoint : this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("option", { value: (!ej.isNullOrUndefined(temp) && !ej.isNullOrUndefined(this.endTimeAppoint)) ? this.endTimeAppoint : this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
            }
            else if (value !== "add") {
                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList("option", { text: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["text"]], value: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("option", { text: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["text"]], value: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
            }
            if (value == "add") {
                var addDataSoure = {};
                addDataSoure[this.model.timeZoneCollection["text"]] = timeZoneValue;
                addDataSoure[this.model.timeZoneCollection["id"]] = (this.model.timeZoneCollection.dataSource.length + 1).toString();
                addDataSoure[this.model.timeZoneCollection["value"]] = timeZoneValue;
                this.model.timeZoneCollection.dataSource.push(addDataSoure);
                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                temp != null ? this._timeZoneCollection(temp) : this._timeZoneCollection(null);
            }
            this.tempValue = null;
        },

        _timezoneStringValue: function () {
            var sign = (-new Date().getTimezoneOffset()) + (this._timeZoneOffset);
            var value = sign < 0 ? "-" : "+";
            var offset = Math.abs(sign);
            var hours = ((Math.floor(offset / 60)) < 10) ? '0' + (Math.floor(offset / 60)) : (Math.floor(offset / 60));
            var minutes = ((offset % 60) < 10) ? '0' + (offset % 60) : (offset % 60);
            return value + hours + ":" + minutes;
        },

        _showCategorizeDetails: function (temp) {
            var categorizeItems = temp[this._appointmentSettings["categorize"]].split(",");
            var key;
            for (i = 0; i < categorizeItems.length; i++) {
                key = $.type(categorizeItems[i]) == 'string' ? categorizeItems[i] : parseInt(categorizeItems[i]);
                this._appointmentAddWindow.find('.e-categorizevalue').data("ejAutocomplete").selectValueByKey(key);
            }
        },

        _renderCategorizeTemplate: function () {
            var Text = this.model.enableRTL ? 'margin-right:30px;margin-top:-18px' : '';
            var Color = this.model.enableRTL ? 'float:none' : 'float:left';
            if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {
                this._categorizeTemplate = "<div class='e-categorizeTemplate' style='height:15px;margin-right:5px;margin-top:3px;" + Color + ";width:15px;background-color: ${" + this.model.categorizeSettings["color"] + "}'></div><div style= " + Text + ">${" + this.model.categorizeSettings["text"] + "}</div>";
            }
        },

        _getCategorizeColor: function (record) {
            var categorizeDataIndex = null, appointData = "", appointCustomcss = "", appointtextcolor = "", applyFilter = false;
            var categorizeItems = record[this._appointmentSettings["categorize"]].split(",");
            var categorizeItemsLength = categorizeItems.length - 1;
            var dataSet = this.model.categorizeSettings;
            categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], categorizeItems[categorizeItemsLength]);
            (ej.isNullOrUndefined(categorizeDataIndex)) && (categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], parseInt(categorizeItems[categorizeItemsLength])));
            if (ej.isNullOrUndefined(categorizeDataIndex)) {
                record[this._appointmentSettings["categorize"]] = "";
                return { appointData: appointData, appointCustomcss: appointCustomcss, appointtextcolor: appointtextcolor };
            }
            else {
                appointData = !ej.isNullOrUndefined(dataSet.dataSource[categorizeDataIndex][dataSet.color]) ? dataSet.dataSource[categorizeDataIndex][dataSet.color] : appointData;
                appointtextcolor = !ej.isNullOrUndefined(dataSet.dataSource[categorizeDataIndex][dataSet.fontColor]) ? dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] : appointtextcolor;
            }
            return { appointData: appointData, appointCustomcss: appointCustomcss, appointtextcolor: appointtextcolor, applyFilter: applyFilter }
        },

        _currentDateFormat: function (option) {
            var minDate, maxDate;
            if (!ej.isNullOrUndefined(option) && ($.type(this.currentDate()) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
                var date = ej.parseDate(this.currentDate(), this.model.dateFormat);
                minDate = ej.parseDate(this.model.minDate, this.model.dateFormat);
                maxDate = ej.parseDate(this.model.maxDate, this.model.dateFormat);
                this.currentDate((!ej.isNullOrUndefined(date)) ? date : ((new Date(this.currentDate()).toString() == "Invalid Date" || new Date(this.currentDate()).toString() == "NaN") ? this._dateConvert(this.currentDate()) : new Date(this.currentDate())));
                this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : ((new Date(this.model.minDate).toString() == "Invalid Date" || new Date(this.model.minDate).toString() == "NaN") ? this._dateConvert(this.model.minDate) : new Date(this.model.minDate));
                this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : ((new Date(this.model.maxDate).toString() == "Invalid Date" || new Date(this.model.maxDate).toString() == "NaN") ? this._dateConvert(this.model.maxDate) : new Date(this.model.maxDate));
            }
            else if (option == "MM/dd/yyyy" && ($.type(this.currentDate()) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
                var curntDate = ej.parseDate(this.currentDate());
                minDate = ej.parseDate(this.model.minDate);
                maxDate = ej.parseDate(this.model.maxDate);
                (!ej.isNullOrUndefined(curntDate)) ? this.currentDate(curntDate) : this.currentDate(new Date());
                this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : this.model.minDate;
                this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : this.model.maxDate;
            }
        },

        _datepattern: function () {
            return (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) ? this.model.dateFormat : this._pattern.d;
        },

        _businessHourScroller: function () {
            if (this.currentView() == "agenda") return false;
            var highScrol = 0;
            if (this.model.orientation == "vertical" && this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView()) {
                highScrol = (this.element.find(".e-businesshighlightworkcells").length != 0 && this.model.workHours.highlight) ? this.element.find(".e-businesshighlightworkcells").first().parent().index() * this.element.find(".e-workcells").height() : 0;
                this.element.find("div#" + this._id + "_scroller").ejScroller({ scrollTop: highScrol });
                this.element.find(".e-scrolltimecells").css({ top: -(this.element.find(".e-draggableworkarea").scrollTop()) + "px" });
            }
            else if (this.model.orientation == "horizontal" && this.model.timeScale.enable) {
                if (this.element.find(".e-businesshighlightworkcells").length != 0 && this.model.workHours.highlight && this.currentView() != "month") {
                    highScrol = this.element.find(".e-businesshighlightworkcells")[0].offsetLeft;
                    if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                        var currentDateIndex = this.element.find(".e-activeview.e-horizontalheaderdiv").parent().index();
                        if (!ej.isNullOrUndefined(currentDateIndex) && currentDateIndex >= 0) {
                            this.currentView() == "customview" ? this.currentDate(new Date(this._dateRender[0])) : this.currentDate(new Date(this._dateRender[currentDateIndex]));
                            highScrol = this.element.find(".e-workcells")[currentDateIndex * ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))].offsetLeft;
                            var hourDiff = (this.model.workHours.start - this.model.startHour) <= 0 ? 1 : this.model.workHours.start - this.model.startHour;
                            if ([0, 6].indexOf(new Date(this._dateRender[currentDateIndex]).getDay()) == -1 && this.currentView() != "customview") {
                                if (this.model.enableRTL)
                                    highScrol -= (hourDiff * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot) * this.element.find(".e-workcells").width());
                                else
                                    highScrol += (hourDiff * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot) * this.element.find(".e-workcells").width()) - this.element.find(".e-workcells").width();
                            }
                        }
                    }
                }
                else
                    highScrol = (this.element.find(".e-activeview.e-horizontalheaderdiv").parent().index() != -1) ? this.element.find(".e-workcells")[(this.element.find(".e-activeview.e-horizontalheaderdiv").parent().index()) * ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))].offsetLeft : 0;
                var leftValue = (this.model.enableRTL) ? this.element.find(".e-workcells")[0].offsetLeft - highScrol : highScrol;
                this.element.find("div#" + this._id + "_scroller").ejScroller({ scrollLeft: leftValue });
            }
        },

        _minToHour: function (mins) {
            return { "h": parseInt(mins / 60), "m": mins % 60 };
        },

        _onclose: function (args) {
            this._appointmentAddWindow.find(".e-error").remove();
            this._appointmentAddWindow.find(".e-recurEditor").hide();
            this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).show().animate({ "margin-left": 10 }, 300);
            this._clearFields();
            this._processFocus();
        },

        _printAppointment: function (appointment) {
            var $element = ej.buildTag("div"), templist;
            if (typeof appointment === 'object')
                templist = appointment;
            else {
                var query = new ej.Query().where("Guid", ej.FilterOperators.equal, appointment);
                list = new ej.DataManager(this._processed).executeLocal(query);
                if (list.length > 1) {
                    var applist = $.extend(true, [], list);
                    applist[0][this._appointmentSettings["endTime"]] = applist[applist.length - 1][this._appointmentSettings["endTime"]];
                    templist = applist[0];
                } else templist = list[0];
            }
            var appointmentTable = "<table align='center' style='margin-top:50px;margin-left:50;'>";
            var proxy = this;
            var exclude = ["Guid", "ParentId", "RecurrenceId", "RecurrenceExDate", "AppTaskId"];
            $.each(templist, function (i, val) {
                if ((exclude.indexOf(i) == -1) && !ej.isNullOrUndefined(val) && !ej.isNullOrUndefined(i) && i != "null") {
                    if (i == proxy._appointmentSettings.startTime || i == proxy._appointmentSettings.endTime)
                        val = val;
                    appointmentTable += "<tr style='height:30px'><td style='width:300px'><b>" + i + ":</b></td><td  style='width:600px'>" + val + "</td></tr>";
                }
            });
            appointmentTable += "</table>";
            var ownerTextName = "";
            if ((this._tempResource.length != 0)) {
                if (!ej.isNullOrUndefined(templist[this._tempResource[this._tempResource.length - 1].field])) {
                    var s = proxy._appointmentSettings.resourceFields.split(',');
                    $.each(this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource, function (i, val) {
                        if (val.id == templist[s[s.length - 1].trim()])
                            ownerTextName = val.text;
                    });
                }
            }
            ownerTextName = (ownerTextName == "") ? "Unknown" : ownerTextName;
            var appointmentWindowData = "<font size='20' style='margin-top:50px;margin-left:50;font-family:Times New Roman'><b>" + ownerTextName + "</b></font></br><hr style='margin-left:50' size='10'>"
            var printElement = appointmentWindowData + appointmentTable;
            $element.append(printElement);
            ej.print($element);
            return false;
        },

        _recurrenceValidate: function (rule, recurId, sTime, eTime) {
            var recurEdit = (!ej.isNullOrUndefined(this._appointmentAddWindow)) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
            (!ej.isNullOrUndefined(rule)) && recurEdit.recurrenceRuleSplit(rule, recurId);
            var appEnd, appStart;
            if (!ej.isNullOrUndefined(eTime))
                appEnd = eTime;
            else {
                var end = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value")).split(':');
                appEnd = new Date(this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value").setHours(parseInt(end[0], 10), parseInt(end[1], 10)));
            }
            if (!ej.isNullOrUndefined(sTime))
                appStart = sTime;
            else {
                var start = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value")).split(':');
                appStart = new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value").setHours(parseInt(start[0], 10), parseInt(start[1], 10)));
            }
            var day_start = !ej.isNullOrUndefined(sTime) ? sTime : this._appointmentAddWindow.find(".recurstartdate").ejDatePicker("option", "value");
            var _interval = recurEdit._rRule.interval;
            if (!ej.isNullOrUndefined(recurEdit._rRule.until)) {
                recurEndDate = new Date(recurEdit._rRule.until);
                recurEndDate.setDate(recurEndDate.getDate() + 1);
            } else if (!ej.isNullOrUndefined(recurEdit._rRule.count))
                switch (recurEdit._rRule.freq) {
                    case "DAILY":
                        recurEndDate = new Date(new Date(day_start).setDate(day_start.getDate() + recurEdit._rRule.count * (_interval)));
                        break;
                    case "WEEKLY":
                        var byDay = recurEdit._rRule.weekDays.split(",");
                        var dayCount = day_start.getDate() + (((recurEdit._rRule.count / byDay.length) * 7)) * (_interval);
                        recurEndDate = new Date(new Date(day_start).setDate(Math.round(dayCount) < dayCount ? dayCount + 1 : dayCount));
                        break;
                    case "MONTHLY":
                        recurEndDate = new Date(new Date(day_start).setMonth(day_start.getMonth() + recurEdit._rRule.count * (_interval)));
                        break;
                    case "YEARLY":
                        recurEndDate = new Date(new Date(day_start).setFullYear(day_start.getFullYear() + recurEdit._rRule.count * (_interval)));
                        break;
                }
            else {
                recurEndDate = new Date(new Date(this.currentDate()).setDate(day_start.getDate() + 42 * (_interval)));
            }
            if (((recurEndDate - day_start) / (1000 * 3600) / 24) < ((recurEdit._rRule.freq == "DAILY") ? 2 : (recurEdit._rRule.freq == "WEEKLY") ? 7 : 1)) {
                return true;
            } else {
                switch (recurEdit._rRule.freq) {
                    case "DAILY":
                        var count = recurEdit._rRule.interval;
                        return ((appEnd - appStart) / (1000 * 3600) > parseInt(count) * 24) ? false : true;
                        break;
                    case "WEEKLY":
                        if (rule.split(";")[1].split("=")[0] == "INTERVAL") {
                            var types = recurEdit._rRule.weekDays.split(",");
                            var obj = { "SU": 0, "MO": 1, "TU": 2, "WE": 3, "TH": 4, "FR": 5, "SA": 6 };
                            var temp = [], tempDiff = [];
                            for (var i = 0; i < types.length * (parseInt(recurEdit._rRule.interval) + 1) ; i++) {
                                temp[i] = (types.length > i) ? obj[types[i]] : temp[i - types.length] + (7 * parseInt(recurEdit._rRule.interval));
                            }
                            var tempvalue = temp.sort(function (a, b) { return a - b });
                            for (var i = 1; i < tempvalue.length; i++) {
                                tempDiff.push(tempvalue[i] - tempvalue[i - 1]);
                            }
                            return ((appEnd - appStart) / (1000 * 3600) > Math.min.apply(Math, tempDiff) * 24) ? false : true;
                        } else {
                            return ((appEnd - appStart) / (1000 * 3600) > 24) ? false : true;
                        }
                        break;
                    case "MONTHLY":
                        if (appEnd.getTime() > new Date(appStart).setMonth(appStart.getMonth() + parseInt(recurEdit._rRule.interval)))
                            return false;
                        else
                            return true;
                        break;
                    case "YEARLY":
                        if (appEnd.getTime() > new Date(appStart).setFullYear(appStart.getFullYear() + parseInt(recurEdit._rRule.interval)))
                            return false;
                        else
                            return true;
                        break;
                }
            }
            return true;
        },

        _saveAppointment: function () {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            var recurEdit = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
            if (this._currentAction != "") {
                if (ej.isNullOrUndefined(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value")) || ej.isNullOrUndefined(this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value")))
                    return false;
                start = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value")).split(":");
                end = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value")).split(":");
                startTime = new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value").setHours(parseInt(start[0], 10), parseInt(start[1], 10)));
                endTime = new Date(this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value").setHours(parseInt(end[0], 10), parseInt(end[1], 10)));
                if (startTime > endTime) {
                    ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
                    this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
                    this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("StartEndError"));
                    this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
                    this._alertWindow.ejDialog("open");
                    return false;
                }
            }
            if (this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox("option", "checked") && recurEdit._recRule != "" && !ej.isNullOrUndefined(recurEdit._recRule) && this.model.enableRecurrenceValidation && this._currentAction == "add") {
                if (!this._recurrenceValidate(recurEdit._recRule)) {
                    this._alertCreateError();
                    return false;
                }
            }
            var appointments = this._sortAppById(this._processed), maxId, query, query1, appointId, appointGroupId, _editApp;
            if (this._cellClick && this.model.showQuickWindow) {
                if ($.isFunction($.validator) && !$("#" + this._id + "_AddForm").validate().form()) return false;
                var argsValue, obj = {};
                maxId = !ej.isNullOrUndefined(this._appMainId) ? this._appMainId + 1 : 1;
                if (this.model.enableLoadOnDemand) maxId = this._dataCount;
                obj[this._appointmentSettings["id"]] = obj["AppTaskId"] = obj["ParentId"] = maxId;
                obj[this._appointmentSettings["subject"]] = this._quickAppointWindow.find('.subject').val();
                obj[this._appointmentSettings["startTime"]] = new Date(this.cur_StartTime);
                obj[this._appointmentSettings["endTime"]] = new Date(this.cur_EndTime);
                if (this.currentView() === "month" || (new Date(this.cur_StartTime).getHours() == 0 && new Date(this.cur_EndTime).getHours() == 23 && new Date(this.cur_EndTime).getMinutes() == 59) || (this._isCustomMonthView()))
                    obj[this._appointmentSettings["allDay"]] = true;
                else
                    obj[this._appointmentSettings["allDay"]] = false;
                if (this.model.appointmentSettings.applyTimeOffset && !obj[this._appointmentSettings["allDay"]]) {
                    obj[this._appointmentSettings["startTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                    obj[this._appointmentSettings["endTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                }
                obj[this._appointmentSettings["recurrence"]] = false;
                if ((!ej.isNullOrUndefined(this.model.group) || (this._tempResource.length != 0) && ej.scheduleFeatures.resources) && ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0))
                    obj = this._getResourceFields(obj);
                ("null" in obj) && delete obj[null];
                var avail = this._checkAvailability(obj);
                var args = { appointment: obj };
                if (this._trigger("actionBegin", { data: args.appointment, requestType: "appointmentSave" }) || avail.length > 0) {
                    this._showBlockAlert && avail.length > 0 && this._alertBlockError();
                    if (!ej.isNullOrUndefined(this._quickAppointWindow)) this._quickAppointWindow.ejDialog("close");
                    return false;
                }
                if (this._trigger("beforeAppointmentCreate", args)) {
                    if (!ej.isNullOrUndefined(this._quickAppointWindow)) this._quickAppointWindow.ejDialog("close");
                    return false;
                }
                this._currentAction == ej.Schedule.Actions.Add;
                args.appointment.Guid = this._guidFormatGenerate();
                $.extend(true, argsValue = {}, args.appointment);
                var temp = this._timeZoneAppointments(argsValue, "");
                var promise = this._dataManager.insert(temp, this.model.appointmentSettings.query._fromTable);
                if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(args.appointment);
                new ej.DataManager(this._currentAppointmentData).update("AppTaskId", args.appointment);
                this._appointmentProcessing(args.appointment);
                this._currentViewAppointments = this._appointmentCount();
                var renderCollection = this._currentViewAppointments.filter(function (obj) { return obj.Guid == args.appointment.Guid; });
                for (var rx = 0; rx < renderCollection.length; rx++) {
                    this._refreshDayAppointments(renderCollection[rx]);
                }
                this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                this._trigger("appointmentCreated", { appointment: args.appointment, requestType: "appointmentSaved" });
                this._trigger("actionComplete", { data: args.appointment, requestType: "appointmentSave" });
                this._cellClick = false;
                if (!ej.isNullOrUndefined(this._quickAppointWindow)) this._quickAppointWindow.ejDialog("close");
                this._scrollerPosition();
                if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                    var proxy = this;
                    promise.done(function (e) {
                        var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                        if ($.isArray(value)) {
                            proxy._processUrlBinding(e);
                        }
                        else if ($.isPlainObject(value)) {
                            if (value.added.length > 0) {
                                proxy._dateFormat(value.added);
                                for (var a = 0, len = value.added.length; a < len; a++) {
                                    args.appointment[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                    if (!args.appointment[proxy._appointmentSettings["recurrence"]]) args.appointment.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                    new ej.DataManager(proxy._processed).update("Guid", args.appointment);
                                }
                            }
                        }
                    });
                }
            }
            else {
                if ($.isFunction($.validator) && !$("#" + this._id + "_AddEditForm").validate().form()) return false;
                var formelement, obj = {}, temp = {};
                var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                maxId = (this._currentAction == ej.Schedule.Actions.Add || this._currentAction == ej.Schedule.Actions.EditOccurrence) ? (this.model.enableLoadOnDemand ? this._dataCount + 1 : (!ej.isNullOrUndefined(this._appMainId) ? this._appMainId + 1 : parseInt(this._appId))) : tempApp[0]["AppTaskId"];
                formelement = $("#" + this._id + "AppointmentAddEditWindow").find("#" + this._id + "_AddEditForm").get(0); var autoVal = []; var categorizeVal = [];
                for (var index = 0; index < formelement.length; index++) {
                    var columnName = formelement[index].name, $element = $(formelement[index]);
                    if (columnName != undefined) {
                        var value = formelement[index].value;
                        if ((columnName != "" && obj[columnName] == null)) {
                            if (columnName == this._appointmentSettings["id"])
                                value = (value == "") ? parseInt(maxId) : parseInt(value);
                            if ($(formelement[index]).hasClass("e-datepicker"))
                                value = $element.ejDatePicker("option", "value");
                            else if ($(formelement[index]).hasClass("e-timepicker"))
                                value = $element.ejTimePicker("option", "value");
                            else if ($element.data("ejDropDownList"))
                                value = $element.ejDropDownList("model.value");
                            else if ($element.data("ejAutocomplete")) {
                                if ($(formelement[index])[0].id == this._id + "categorize")
                                    categorizeVal.push($element.data("ejAutocomplete").getSelectedItems());
                                else if ($(formelement[index])[0].id.indexOf(this._id + "_ownerfield_") == 0)
                                    autoVal.push($element.data("ejAutocomplete").getSelectedItems());
                            }
                            if (columnName != "StartDate" && columnName != "EndDate" && columnName != "StartTime" && columnName != "EndTime") {
                                if (formelement[index].type != "checkbox")
                                    obj[columnName] = value;
                                else
                                    obj[columnName] = $(formelement[index]).is(':checked');
                            }
                            else {
                                temp[columnName] = columnName == "StartDate" || columnName == "EndDate" ? new Date(value) : value;
                            }
                        }
                        else {
                            if ($element.data("ejAutocomplete")) {
                                if ($(formelement[index])[0].id == this._id + "categorize")
                                    categorizeVal.push($element.data("ejAutocomplete").getSelectedItems());
                                else if ($(formelement[index])[0].id.indexOf(this._id + "_ownerfield_") == 0)
                                    autoVal.push($element.data("ejAutocomplete").getSelectedItems());
                            }
                        }
                    }
                }
                this.startutcValue = this.tempValue = null;
                if (!this.model.showTimeZoneFields) {
                    obj[this._appointmentSettings["startTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                    obj[this._appointmentSettings["endTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                }
                if (this.model.categorizeSettings.enable == true && this.model.categorizeSettings.allowMultiple != true) {
                    var dataSet = this.model.categorizeSettings;
                    categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["text"], obj[this._appointmentSettings["categorize"]]);
                    categorizeVal[0].push(this.model.categorizeSettings.dataSource[categorizeDataIndex]);
                    categorizeVal[0].shift();
                }
                ("null" in obj) && delete obj[null];
                var starttime = this._timeFormat(temp.StartTime).split(":");
                var endtime = this._timeFormat(temp.EndTime).split(":");
                obj[this._appointmentSettings["startTime"]] = new Date(temp.StartDate.setHours(parseInt(starttime[0], 10), parseInt(starttime[1], 10)));
                obj[this._appointmentSettings["endTime"]] = new Date(temp.EndDate.setHours(parseInt(endtime[0], 10), parseInt(endtime[1], 10)));
                (obj[this._appointmentSettings["recurrence"]]) && (obj[this._appointmentSettings["recurrenceRule"]] = recurEdit._recRule);
                this._publicMethodSave = true;
                var value = this._timeZoneSavingAppoint(obj, temp);
                obj = value.obj;
                var currentAction = this._currentAction == "save" ? "edit" : this._currentAction;
                var _editApps = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                if (obj[this._appointmentSettings["recurrenceRule"]] != "" && !ej.isNullOrUndefined(obj[this._appointmentSettings["recurrenceRule"]]) && this.model.enableRecurrenceValidation && (this._currentAction == "editSeries" || this._currentAction == "editOccurrence" || this._currentAction == "save")) {
                    if (this._currentAction == "editOccurrence") {
                        var _appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                        var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                        var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                        var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                        var twoDayApps = (((obj[this._appointmentSettings["endTime"]] - obj[this._appointmentSettings["startTime"]]) / 3600000) < 24 && obj[this._appointmentSettings["endTime"]].getDate() != obj[this._appointmentSettings["startTime"]].getDate());
                        if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                        var recurColl = this._appointmentRecurrenceSort(recurColl);
                        var index = this._recuCollectionIndex(recurColl, _appList);
                        var model = this._appointmentSettings;
                        if (((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime())))) {
                            this._alertCreateError();
                            return false;
                        }
                    }
                    else {
                        if (!this._recurrenceValidate(obj[this._appointmentSettings["recurrenceRule"]], _editApps[0][this._appointmentSettings["recurrenceExDate"]])) {
                            this._alertCreateError();
                            return false;
                        }
                    }
                }
                if (this._currentAction == ej.Schedule.Actions.EditOccurrence) {
                    this._objDate = _editApps;
                    var MapValue = this._objDate[0][this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                    var _editApp = this._deleteOcurrence(this._objDate[0][MapValue], new Date(_editApps[0][this._appointmentSettings["startTime"]]));
                    obj[this._appointmentSettings["recurrence"]] = 1;
                    obj[this._appointmentSettings["recurrenceRule"]] = _editApp[0][this._appointmentSettings["recurrenceRule"]] + ";RECUREDITID=" + _editApp[0]["ParentId"];
                    obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                    obj["Guid"] = this._appUid;
                    obj[this._appointmentSettings["recurrenceExDate"]] = _editApp[0][this._appointmentSettings["recurrenceExDate"]];
                }
                else if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                    var Parid = _editApps[0][this._appointmentSettings["recurrenceId"]] == null ? _editApps[0]["ParentId"] : _editApps[0][this._appointmentSettings["recurrenceId"]];
                    var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                    if (!ej.isNullOrUndefined(_editApp[0].RecurrenceExDate) && this._seriesAlert) {
                        this._seriesAlert = false;
                        //this._rule=_editApp[0].RecurrenceRule.slice(0,_editApp[0].RecurrenceRule.indexOf('EXDATE'));
                        ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
                        if (this._alertWindow.find(".e-alertbtn").find(".e-alertCancel").length == 0) {
                            this._alertWindow.find(".e-alertbtn").append("<button id='" + this._id + "alertcancel' class='e-alertbutton e-alertCancel'></button>");
                            this._alertWindow.find(".e-alertCancel").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
                            if (this._mediaQuery) this._alertWindow.find(".e-alertCancel").css({ 'margin': '0px 20px 15px 10px' });
                        }
                        this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
                        this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("SeriesChangeAlert"));
                        this._alertWindow.find(".e-alertCancel").html(this._getLocalizedLabels("Cancel"));
                        this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
                        this._alertWindow.addClass("e-seriesAlert");
                        this._alertWindow.ejDialog("open");
                        return false;
                    }
                    if (!ej.isNullOrUndefined(_editApp[0].RecurrenceExDate)) this._seriesAlert = true;
                    obj["AppTaskId"] = _editApp[0]["AppTaskId"];
                    obj[this._appointmentSettings["id"]] = _editApp[0][this._appointmentSettings["id"]];
                    obj["Guid"] = this._appUid;
                    maxId = _editApp[0]["AppTaskId"];
                    obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                    obj[this._appointmentSettings["recurrenceExDate"]] = null;
                    obj[this._appointmentSettings["recurrenceRule"]] = (ej.isNullOrUndefined(recurEdit._recRule) || recurEdit._recRule == "") ? _editApp[0][this._appointmentSettings["recurrenceRule"]] : recurEdit._recRule;
                }
                if (this._currentAction != ej.Schedule.Actions.Add) {
                    obj["Guid"] = _editApps[0]["Guid"];
                    obj["AppTaskId"] = _editApps[0]["AppTaskId"];
                    obj[this._appointmentSettings["id"]] = (this._currentAction != ej.Schedule.Actions.EditSeries) ? _editApps[0][this._appointmentSettings["id"]] : obj[this._appointmentSettings["id"]];
                    var editedApp = $.extend(editedApp, obj);
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                else {
                    obj.Guid = ej.isNullOrUndefined(obj.Guid) ? this._guidFormatGenerate() : obj.Guid;
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentSave" })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                var args = [], newAppointment;
                (this._startTimezone != this._endTimezone) ? obj[this._appointmentSettings["endTime"]] = value.cloneEnddiffer : "";
                parId = this._currentAction == ej.Schedule.Actions.Add ? maxId : _editApps[0]["ParentId"];
                if (!ej.isNullOrUndefined(this.model.categorizeSettings) && categorizeVal.length > 0 && !ej.isNullOrUndefined(categorizeVal[0][0]) || (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                    args = this._getResCategorySaveData(categorizeVal, autoVal, obj, maxId, parId, starttime, endtime);
                else {
                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                    if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                    args.push(newAppointment);
                }
                if (this._currentAction == ej.Schedule.Actions.Add) {
                    if (this._trigger("beforeAppointmentCreate", { appointment: args, currentAction: currentAction })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                if (this._currentAction != ej.Schedule.Actions.Add) {
                    if (this._currentAction != ej.Schedule.Actions.EditOccurrence) {
                        var _newApp = new ej.DataManager(args).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.notEqual, editedApp[this._appointmentSettings["id"]]));
                        var _editedApp = new ej.DataManager(args).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, editedApp[this._appointmentSettings["id"]]));
                    }
                    else {
                        for (var i = 0; i < args.length; i++) {
                            var _editedApp = new ej.DataManager(args).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, editedApp[this._appointmentSettings["id"]]));
                            var _newApp = new ej.DataManager(args).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.notEqual, editedApp[this._appointmentSettings["id"]]));
                        }
                    }
                    _batch = ({ added: _newApp, changed: _editedApp });
                    if (this._trigger("beforeAppointmentChange", { appointment: _batch, currentAction: currentAction })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                var avail = this._checkAvailability(args[0]);
                if (args[this._appointmentSettings["startTime"]] > args[this._appointmentSettings["endTime"]] || avail.length > 0) {
                    this._showBlockAlert && this._alertBlockError();
                    return false;
                }
                if (this._currentAction == ej.Schedule.Actions.Add || this._currentAction == ej.Schedule.Actions.EditOccurrence) {
                    var temp = [];
                    for (var a = 0; a < args.length; a++) {
                        var startTimezone1 = args[a][this._appointmentSettings["startTimeZone"]];
                        (startTimezone1 != this.model.timeZone) ? temp.push(this._timeZoneAppointments(args[a], "")) : temp.push(args[a]);
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", args[a]);
                    }
                    var _editApp = [];
                    if (this._currentAction == ej.Schedule.Actions.EditOccurrence) {
                        var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, this._parentId));
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", _App[0]);
                        _editApp.push(this._timeZoneAppointments(_App[0], ""));
                    }
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable);
                    var updateTempNew = [];
                    for (var c = 0; c < temp.length; c++) {
                        updateTempNew = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(temp[c], "reverse") : temp[c];
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew);
                    }
                    var updateTempNew2 = [];
                    for (var c = 0; c < _editApp.length; c++) {
                        updateTempNew2 = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(_editApp[c], "reverse") : _editApp[c];
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew2);
                    }
                    for (var d = 0, count = args.length; d < count; d++) {
                        if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(args[d]);
                        var isObjAvail = this._processed.filter(function (obj) { return obj.Guid == args[d].Guid; });
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                        this._maxId = ej.isNullOrUndefined(this._maxId) ? args[d].AppTaskId : this._maxId;
                        this._appointmentProcessing(args[d]);
                        this._currentViewAppointments = this._appointmentCount();
                        var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == args[d].ParentId; });
                        for (var e = 0, len = collection.length; e < len; e++) {
                            this._refreshDayAppointments(collection[e]);
                        }
                    }
                    this._trigger("appointmentCreated", { appointment: args[0], requestType: "appointmentSaved" });
                    this._trigger("actionComplete", { data: args, requestType: "appointmentSave" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        var proxy = this;
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        args[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!args[0][proxy._appointmentSettings["recurrence"]]) args[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", args[0]);
                                    }
                                }
                            }
                        });
                    }
                }
                else if (this._currentAction == ej.Schedule.Actions.Save || this._currentAction == ej.Schedule.Actions.EditSeries) {
                    var newApp = [], editedApp = [], deleted = [];
                    for (var i = 0; i < args.length; i++) {
                        var GId = this._currentAction == ej.Schedule.Actions.Save ? args[i]["Guid"] : args[i][this._appointmentSettings["recurrenceId"]];
                        var idName = this._currentAction == ej.Schedule.Actions.Save ? "Guid" : this._appointmentSettings["recurrenceId"];
                        _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(idName, ej.FilterOperators.equal, GId));
                        (!ej.isNullOrUndefined(_editApp) && _editApp.length > 0) ? editedApp.push(args[i]) : newApp.push(args[i]);
                    }
                    if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                        for (var i = 0; i < editedApp.length; i++) {
                            var dele = new ej.DataManager(this._currentAppointmentData).executeLocal(ej.Query().where(ej.Predicate(this._appointmentSettings["recurrenceRule"], ej.FilterOperators.contains, "RECUREDITID=" + args[i][this._appointmentSettings["recurrenceId"]], true)));
                            deleted = deleted.concat(dele);
                            this._appointmentAddWindow.find('.recurbutton').click();
                            editedApp[i][this._appointmentSettings["recurrenceRule"]] = recurEdit._recRule;
                            editedApp[i][this._appointmentSettings["recurrenceExDate"]] = null;
                            new ej.DataManager(this._currentAppointmentData).remove("ParentId", editedApp[i].ParentId);
                            var removeCollection = this._processed.filter(function (obj) { return obj.ParentId == editedApp[i].ParentId; });
                            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                            new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                            var objCol = this._appointmentCount(removeCollection);
                            for (var j = 0, len = objCol.length; j < len; j++) {
                                this._appointmentRemove(objCol[j]);
                                this._refreshDayAppointments(objCol[j]);
                            }
                        }
                    }
                    var newTemp = [], editTemp = [];
                    for (var a = 0; a < newApp.length; a++)
                        newTemp.push(this._timeZoneAppointments(newApp[a], ""));
                    for (var b = 0; b < editedApp.length; b++)
                        editTemp.push(this._timeZoneAppointments(editedApp[b], ""));
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newTemp, changed: editTemp, deleted: deleted }, queryId, this.model.appointmentSettings.query._fromTable);
                    for (var c = 0; c < newTemp.length; c++)
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(newTemp[c], "reverse"));
                    for (var d = 0; d < editTemp.length; d++)
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(editTemp[d], "reverse"));
                    if (editedApp.length > 0) {
                        for (var iy = 0; iy < args.length; iy++) {
                            new ej.DataManager(this._currentAppointmentData).remove("Guid", args[iy]);
                            var tempApps = this._processed.filter(function (obj) { return obj.Guid == args[iy].Guid; });
                            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                            new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                            this._currentAppointmentData.push(args[iy]);
                            this._appointmentProcessing(args[iy]);
                            this._appointmentRemove(args[iy]);
                            this._currentViewAppointments = this._appointmentCount();
                            var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == args[iy].ParentId; });
                            for (var e = 0, len = collection.length; e < len; e++) {
                                this._refreshDayAppointments(collection[e]);
                            }
                        }
                        this._trigger("appointmentChanged", { appointment: editedApp[0], requestType: "appointmentChanged", currentAction: currentAction });
                        this._trigger("actionComplete", { data: editedApp, requestType: "appointmentEdit", currentAction: currentAction });
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value)) {
                                    proxy._processUrlBinding(e);
                                }
                                else if ($.isPlainObject(value)) {
                                    if (value.added.length > 0) {
                                        proxy._dateFormat(value.added);
                                        for (var a = 0, len = value.added.length; a < len; a++) {
                                            args[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                            if (!args[0][proxy._appointmentSettings["recurrence"]]) args[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        }
                                    }
                                }
                            });
                        }
                    }
                }
                this._clearFields();
                this._appointmentAddWindow.ejDialog("close");
            }
            if (this.element.find('div.e-draggableworkarea tr').find('td').hasClass("e-selectedCell"))
                this._processFocus();
            if (this.model.orientation == "horizontal" && this.currentView() != "agenda" && (this.element.find(".e-draggableworkarea").offset().top > this.element.find(".e-workcellstab").offset().top)) {
                var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                this.element.find(".e-horires").css("top", -restop + "px");
            }
            this._recRule = "";
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _alertCreateError: function () {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
            this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("CreateError"));
            this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
            this._alertWindow.ejDialog("open");
        },

        _timeZoneSavingAppoint: function (obj, temp) {
            if (this.model.appointmentSettings.applyTimeOffset) {
                this._startTimezone = obj[this._appointmentSettings["startTimeZone"]];
                this._endTimezone = obj[this._appointmentSettings["endTimeZone"]];
                if (!ej.isNullOrUndefined(this._startTimezone) && this._startTimezone != "") {
                    var utc = this._startTimezone.indexOf("UTC") != -1 ? this._startTimezone.split(" ")[1].split(":") : this._startTimezone.split(":");
                    var hour = parseInt(utc[0]);
                    var minutes = parseInt(utc[1]);
                    var calcualtevalue = (hour * 60) + minutes;
                    if (this.model.timeZone == null) {
                        var localtime = new Date().getTimezoneOffset() - this._timeZoneOffset;
                        var local = this._minToHour(localtime + calcualtevalue);
                    }
                    else {
                        var timezone = this.model.timeZone.indexOf("UTC") != -1 ? this.model.timeZone.split(" ")[1].split(":") : this.model.timeZone.split(":");
                        var local = this._minToHour(calcualtevalue);
                        local.h = local.h - (parseInt(timezone[0]));
                        local.m = local.m - (parseInt(timezone[1]));
                    }
                    new Date(obj[this._appointmentSettings["startTime"]].setHours(obj[this._appointmentSettings["startTime"]].getHours() - local.h, obj[this._appointmentSettings["startTime"]].getMinutes() - local.m));
                    if (this._startTimezone != this._endTimezone && this._publicMethodSave) {
                        this.startutcValue = null;
                        this.tempValue = null;
                        var utc1 = this._endTimezone.indexOf("UTC") != -1 ? this._endTimezone.split(" ")[1].split(":") : this._endTimezone.split(":");
                        var hour1 = parseInt(utc1[0]);
                        var minutes1 = parseInt(utc1[1]);
                        var calculateend = (hour1 * 60) + minutes1;
                        var newcalcualtevalue = calcualtevalue - calculateend;
                        var tempStart = new Date(temp.StartDate);
                        var CloneStart = new Date(obj[this._appointmentSettings["startTime"]]);
                        var cloneEnd = new Date(temp.EndDate);
                        duration = new Date(cloneEnd.setMinutes(cloneEnd.getMinutes() + newcalcualtevalue));
                        duration = new Date(duration.setMinutes(duration.getMinutes() - ((local.h * 60) + local.m)));
                        var cloneEnddiffer = duration;
                    }
                    else
                        new Date(obj[this._appointmentSettings["endTime"]].setHours(obj[this._appointmentSettings["endTime"]].getHours() - (local.h), obj[this._appointmentSettings["endTime"]].getMinutes() - local.m));
                }
                return { obj: obj, cloneEnddiffer: cloneEnddiffer };
            }
            return { obj: obj, cloneEnddiffer: cloneEnddiffer };
        },

        _renderAllDayAppointments: function () {
            var appHeight = 16;
            var appWidth = this.element.find(".e-workcells").width() - 20;
            var level = 1; this.level = 0;
            var renderDate = this._dateRender; this._renderedAllDay = [];
            allDayCount = [];
            this.element.find(".e-alldayappointment").remove();
            var appoints = this._appointmentSort(this._processed);
            if (!this.model.group) this.res1 = ["0"];
            if (this._resWorkWeek) {
                var count = 0, resDay = 0;
                for (var res = 0; res < this.res1.length; res++) {
                    if (!ej.isNullOrUndefined(this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                        count += this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                    else
                        count += this.model.workWeek.length;
                    for (resDay; resDay < count; resDay++) {
                        for (var i = 0; i < appoints.length; i++) {
                            this._getMultipleResourceAlldayApp(renderDate, resDay, res, appoints[i]);
                            if (!ej.isNullOrUndefined(this.allDayCount[0])) allDayCount.push(this.allDayCount[0]);
                        }
                    }
                }
            }
            else {
                for (var res = 0; res < this.res1.length; res++) {
                    for (var day = 0; day < renderDate.length; day++) {
                        for (var i = 0; i < appoints.length; i++) {
                            if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                                this._getMultipleResourceAlldayApp(renderDate, day, res, i);
                                !ej.isNullOrUndefined(this.allDayCount[0]) ? allDayCount.push(this.allDayCount[0]) : "";
                            }
                            else {
                                if ((ej.format(new Date(renderDate[day]), this._pattern.d, this.model.locale) == ej.format(new Date(appoints[i][this._appointmentSettings["startTime"]]), this._pattern.d, this.model.locale)) && (appoints[i][this._appointmentSettings["allDay"]] === true || this._findAllDayApp(appoints[i]))) {
                                    this._setAllDayPos(appoints[i], day, res);
                                    allDayCount.push(i);
                                }
                            }
                        }
                    }
                }
            }
            this.allDayLevel = allDayCount.length;
            if (allDayCount.length == 0 && this.level == 0) {
                this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
            }
            this._reRenderScroller();
        },

        _renderSingleApp: function () {
            this.element.find(".e-prevapp,.e-nextapp").css("display", "none");
            this._dataProcessing(this._currentAppointmentData);
            this._renderAppointmentAll();
        },

        _timeFormat: function (time) {
            var dateObj = ej.parseDate(time, (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale);
            if (dateObj) {
                var hours = dateObj.getHours();
                var minutes = dateObj.getMinutes();
            } else {
                var hours = Number(time.match(/^(\d+)/)[1]);
                var minutes = Number(time.match(/:(\d+)/)[1]);
                if (!ej.isNullOrUndefined(time.split(" ")[1])) {
                    var AMPM = time.match(/\s(.*)$/)[1];
                    if (!ej.isNullOrUndefined(this._culture.calendar.AM) && !ej.isNullOrUndefined(this._culture.calendar.PM)) {
                        if (AMPM == this._culture.calendar.PM[0] && hours < 12) hours = hours + 12;
                        if (AMPM == this._culture.calendar.AM[0] && hours == 12) hours = hours - 12;
                    }
                }
            }
            var sHours = hours.toString();
            var sMinutes = minutes.toString();
            if (hours < 10) sHours = "0" + sHours;
            if (minutes < 10) sMinutes = "0" + sMinutes;
            return sHours + ":" + sMinutes;
        },

        _processEscapeKey: function () {
            (!ej.isNullOrUndefined(this._quickAppointWindow)) && this._quickAppointWindow.find(".e-error").remove();
            this._processFocus();
            this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
        },

        _processFocus: function () {
            var selectApp = this.element.find("div.e-selectedAppointment");
            if (selectApp.length != 0)
                selectApp.focus();
            if (this.element.find("td.e-selectedCell").hasClass("e-workcells")) {
                var oRowCell = this.element.find('div.e-draggableworkarea tr');
                var rowcount = oRowCell.length - 1;
                var omincolIndex, omaxcolIndex, rowInx, maxrowInx, checkcolindex;
                var curr_View = this.currentView();
                var proxy = this;
                this.element.find('td.e-selectedCell').each(function (index, tdItem) {
                    var targetId = $(tdItem).index();
                    if (targetId != null && !isNaN(targetId)) {
                        if (omincolIndex == null) {
                            omincolIndex = targetId;
                            rowInx = $(tdItem).parent()[0].rowIndex;
                        }
                        else if (omincolIndex < targetId) {
                            omincolIndex = omincolIndex;
                        }
                        else {
                            if (omincolIndex != targetId) {
                                omincolIndex = targetId;
                                rowInx = $(tdItem).parent()[0].rowIndex;
                            }
                        }
                        if (omaxcolIndex == null) {
                            omaxcolIndex = targetId;
                            if (curr_View != "month") {
                                checkcolindex = parseInt(omaxcolIndex);
                                for (var i = 0; i <= rowcount; i++) {
                                    if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                        maxrowInx = i;

                                    }
                                }
                            }
                        }
                        else if (omaxcolIndex > targetId) {
                            omaxcolIndex = omaxcolIndex;
                        }
                        else {
                            if (omaxcolIndex != targetId) {
                                omaxcolIndex = targetId;
                                if (curr_View != "month") {
                                    checkcolindex = parseInt(omaxcolIndex);
                                    for (var i = 0; i <= rowcount; i++) {
                                        if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                            maxrowInx = i;

                                        }
                                    }
                                }
                            }
                        }
                    }
                });
                if (curr_View != "month") {
                    $(oRowCell[maxrowInx].cells[omaxcolIndex]).attr("tabIndex", 0).focus();
                }
                else {
                    var tdsel = oRowCell.find('td.e-selectedCell');
                    var tdlen = parseInt(tdsel.length) - 1;
                    $(tdsel[tdlen]).attr("tabIndex", 0).focus();
                }
            }
            else {
                this.element.focus();
                this.element.find("td.e-selectedCell").attr("tabIndex", 0).focus();
                if (!ej.isNullOrUndefined(this._appointmentAddWindow))
                    this._appointmentAddWindow.ejDialog("isOpened") && this._appointmentAddWindow.find(".subject").focus();
            }
        },

        _clearFields: function () {
            this._appointmentAddWindow.find('.subject').val("");
            this._appointmentAddWindow.find('.id').val("");
            this._appointmentAddWindow.find('.e-description').val("").css("height", "");
            this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", new Date());
            this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", new Date());
            this._appointmentAddWindow.find('.startendtime').ejTimePicker({ enabled: true });
            this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(new Date(), this._pattern.t, this.model.locale));
            this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(new Date(), this._pattern.t, this.model.locale));
            this._appointmentAddWindow.find(".recurrence,.weekdays").ejCheckBox({ checked: false, enabled: true });
            this._appointmentAddWindow.find(".e-repeatlbl").removeClass('e-disable');
            this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
            this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList("clearText");
            this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
            this._appointmentAddWindow.find(".e-recurFinalRule").html("");
            this._appointmentAddWindow.find(".e-recuredit").hide();
            this._appointmentAddWindow.find(".e-categorizevalue").ejAutocomplete("clearText");
        },

        _getNumericModel: function () {
            return numericModel = {
                width: "100px",
                minValue: 1,
                value: 1,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                localize: this.model.locale
            };
        },

        _deleteApp: function (id) {
            var currentAction = this._actionType == ej.Schedule.Actions.DeleteSeries ? ej.Schedule.Actions.DeleteSeries : ej.Schedule.Actions.Delete;
            if (this._trigger("actionBegin", { id: id, requestType: "appointmentDelete", currentAction: currentAction }))
                return false;
            var removeItem = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, id));
            if (removeItem.length == 0) return false;
            if (this._trigger("beforeAppointmentRemove", { appointment: removeItem[0], currentAction: currentAction }))
                return false;
            var parentObj = this._getAppointmentByParentId(id);
            if (parentObj[this._appointmentSettings["recurrence"]]) {
                var Parid = removeItem[0][this._appointmentSettings["recurrenceId"]] == null ? removeItem[0]["ParentId"] : removeItem[0][this._appointmentSettings["recurrenceId"]];
                var MapValue = removeItem[0][this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                var deleted = ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                var promise = this._dataManager.saveChanges({ added: [], changed: [], deleted: deleted }, queryId, this.model.appointmentSettings.query._fromTable);
            }
            else {
                var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                var promise = this._dataManager.remove(queryId, parentObj[queryId], this.model.appointmentSettings.query._fromTable);
                if (this.dataSource() instanceof ej.DataManager) new ej.DataManager(this._currentAppointmentData).remove(queryId, parentObj[queryId]);
            }
            this._refreshCellsHeight();
            if (this.currentView() != "agenda") {
                if (this._currentAppointmentData.length > 0) {
                    if (removeItem[0][this._appointmentSettings["recurrence"]])
                        var deleteApp = this._processed.filter(function (obj) { return obj[MapValue] == Parid; });
                    else
                        var deleteApp = this._processed.filter(function (obj) { return obj.Guid == id; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                    var removeCollection = this._appointmentCount(deleteApp);
                    for (var del = 0, len = removeCollection.length; del < len; del++) {
                        this._appointmentRemove(removeCollection[del]);
                        this._refreshDayAppointments(removeCollection[del]);
                    }
                }
                else {
                    this._processed = []; this._renderedApp = []; this._renderedAllDay = [];
                    this.element.find("div.e-appointwrapper").remove();
                    this._appointmentRemove(removeItem[0]);
                    this._refreshDayAppointments(removeItem[0]);
                }
            }
            else {
                new ej.DataManager(this._processed).remove("Guid", id);
                var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(ej.Predicate("ParentId", ej.FilterOperators.equal, removeItem[0].ParentId)));
                new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                this._renderAgendaContent();
            }
            this._trigger("appointmentRemoved", { appointment: parentObj, requestType: "appointmentDeleted", currentAction: currentAction });
            this._trigger("actionComplete", { data: parentObj, requestType: "appointmentDelete", currentAction: currentAction });
            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                var proxy = this;
                promise.done(function (e) {
                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                    if ($.isArray(value)) {
                        proxy._processUrlBinding(e);
                    }
                });
            }
            if (this.model.timeScale.enable && ((((removeItem[0][this._appointmentSettings["endTime"]] - removeItem[0][this._appointmentSettings["startTime"]]) / 3600000) > 24) || removeItem[0][this._appointmentSettings["allDay"]]) && this.currentView() != "month" && !(this._isCustomMonthView()) && this.currentView() != "agenda" && (this.allDayLevel == 0)) {
                this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
                this._reRenderScroller();
            }
            this._currentViewAppointments = this._appointmentCount();
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            if (!this.model.showOverflowButton && this.model.orientation == "horizontal" && this.currentView() != "agenda") {
                var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                this.element.find(".e-horires").css("top", -restop + "px");
            }
            this._appUid = null;
            this._actionType = "";
        },

        _appointmentCount: function (apps) {
            var renderDate = (this.model.orientation == "horizontal" && (this.currentView() == "month" || this._isCustomMonthView())) ? this.monthDays : (this._resWorkWeek) ? this._renderDates : this._dateRender,
                appointments = ej.isNullOrUndefined(apps) ? this._appointmentSort(this._processed) : apps,
                startDate = this.currentView() == "agenda" ? new Date(new Date(this.currentDate()).setHours(0, 0, 0)) : new Date(renderDate[0]),
                endDate = this.currentView() == "agenda" ? new Date(new Date(new Date(this.currentDate()).setDate(startDate.getDate() + (this.model.agendaViewSettings.daysInAgenda > 0 ? this.model.agendaViewSettings.daysInAgenda - 1 : 0))).setHours(23, 59, 59)) : new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59)),
                predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, startDate).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, endDate),
                newAppList = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
            return newAppList;
        },

        _reRenderAllDayAppointments: function () {
            this._alldayLevel = (this.level == 1) ? true : false;
            (this.model.showAllDayRow) && this.element.find("div.e-alldayappointment").remove() && this._renderAllDayAppointments();
            this._bindAppointmentAction();
        },

        _appointmentResizeStart: function (e) {
            if (this.model.enableAppointmentResize) {
                this._tooltipEvents("disable");
                this._appointdata = $(e.target).parent();
                var appUid = $(e.target).parent().attr("guid");
                var app = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appUid)));
                var data = { element: $(e.target).parent(), appointment: app[0] };
                if (this._trigger("actionBegin", { data: data, requestType: "appointmentResize" })) {
                    this._tooltipEvents("enable");
                    return false;
                }
                if (this._trigger("resizeStart", data)) {
                    this._tooltipEvents("enable");
                    return false;
                }
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                this.resizeStart = true;
                if ($(e.target).hasClass("e-lefthandle") || $(e.target).hasClass("e-righthandle")) {
                    this.resize = e.pageX;
                    this.appoint_width = $(e.target).parent().width();
                    this.appoint_left = parseInt($(e.target).parent()[0].style.left);
                    this._appointleft = parseInt($($(e.target).parent()[0]).offset().left);
                    this._appointright = parseInt($($(e.target).parent()[0]).css('right'));
                    if (this.model.orientation == "horizontal" && this.model.enableRTL)
                        $(e.target).hasClass("e-lefthandle") ? this._rightResizing = true : this._leftResizing = true;
                    else $(e.target).hasClass("e-lefthandle") ? this._leftResizing = true : this._rightResizing = true;
                }
                else if ($(e.target).hasClass("e-tophandle") || $(e.target).hasClass("e-bottomhandle")) {
                    this.resize = e.pageY;
                    this.appoint_height = $(e.target).parent().height();
                    this.appoint_top = parseInt($(e.target).parent()[0].style.top);
                    $(e.target).hasClass("e-tophandle") ? this._topResizing = true : this._bottomResizing = true;
                }
                this._curElmt = $(e.target).parent();
                this.element.find(".e-workcells").removeClass("e-selectedCell,e-mousehover");
                $(document).on(ej.eventType.mouseMove, $.proxy(this._appointmentResizing, this));
                $(document).on(ej.eventType.mouseUp, $.proxy(this._appointmentResizeStop, this));
                if ($(e.target).hasClass("e-rowcursor") || $(e.target).hasClass("e-columncursor"))
                    return false;
            }
        },

        _appointmentResizing: function (e) {
            var target = $(e.target);
            var data = { element: target.parent(), interval: 10 };
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            var appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-alldayappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            if ($(".e-scheduleAppGlassy").length == 0) {
                appointDiv.find('.e-schedulemouseclose').addClass('e-schedulemouseclosetemp').removeClass('e-schedulemouseclose e-icon');
                appointDiv.clone().prop('id', 'cloneElement').appendTo(appointDiv.parent());
                appointDiv.addClass("e-draggableAppointment e-scheduleAppGlassy").removeClass("e-schedulemouseclose").appendTo(appointDiv.parent());
                if (this._topResizing || this._bottomResizing) {
                    (!this.model.enableRTL) ? appointDiv.css("left", "0") : appointDiv.css("right", "0");
                    appointDiv.css("width", "98%");
                }
                else if (this._rightResizing || this._leftResizing) {
                    if (this.model.orientation != "horizontal") {
                        if (this.currentView() === "month" || this._isCustomMonthView()) {
                            this._appointmentResizeHeight(appointDiv, -(this.element.find(".e-monthheader").height()), "e-monthcells");
                        }
                        else {
                            if (!this.model.timeScale.enable) {
                                appointDiv.css("height", this.element.find(".e-monthcells").height() - 2);
                            }
                            else {
                                appointDiv.css("top", (this.element.find(".e-headerarearow").height() - this.element.find(".e-alldaycells").height() - 2));
                                appointDiv.css("height", this.element.find(".e-alldaycells").height() - 2);
                            }
                        }
                    }
                    else {
                        this._appointmentResizeHeight(appointDiv, 0, "e-workcells");
                    }
                }
            }
            appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-workcells") || $(e.target).hasClass("e-monthcells") || $(e.target).hasClass("e-alldayappointment") || $(e.target).hasClass("e-alldaycells") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            var cellHeight = this.element.find(".e-workcells").height();
            var appointcellCount = ($(appointDiv[0]).height() / cellHeight);
            if (this._topResizing) {
                if (appointcellCount > 0 && !$(e.target).hasClass("e-alldaycells") && !$(e.target).hasClass("e-apptext")) {
                    this._curElmt.height(this.appoint_height + this.resize - e.pageY + 3);
                    this._curElmt.css("top", this.appoint_top - (this.resize - e.pageY) - 3);
                }
            }
            else if (this._bottomResizing) {
                this._curElmt.height(this.appoint_height + (e.pageY - this.resize) + 2);
            }
            else if (this._rightResizing) {
                if (this.model.orientation == "horizontal" && this.model.enableRTL) {
                    this._curElmt.width(this.appoint_width + this.resize - e.pageX + 3);
                    this._curElmt.css("left", this.appoint_left - (this.resize - e.pageX) - 3);
                }
                else {
                    this._curElmt.width(this.appoint_width + (e.pageX - this.resize) + 2);
                    this._curElmt.css("right", this._appointright - (e.pageX - this.resize) - 2);
                }
            }
            else if (this._leftResizing) {
                if (this.model.orientation == "horizontal" && this.model.enableRTL) {
                    this._curElmt.width(this.appoint_width + (e.pageX - this.resize) + 2);
                    this._curElmt.css("right", this._appointright - (e.pageX - this.resize) - 2);
                }
                else {
                    this._curElmt.width(this.appoint_width + this.resize - e.pageX + 3);
                    this._curElmt.css("left", this.appoint_left - (this.resize - e.pageX) - 3);
                }
            }
            this._trigger("resize", data);
            this._resizeInterval = data.interval;
            (this._curElmt.hasClass("e-appointment")) && this._appointmentCurrentTimeUpdate();
        },

        _appointmentResizeHeight: function (appointDiv, topHeight, classname) {
            if (appointDiv.length > 0) {
                var target = (this.model.showOverflowButton) ? this.element.find("." + classname) : appointDiv.closest("td");
                appointDiv.css("top", topHeight).css("height", $(target).height() - 2);
            }
        },
        _appointmentCurrentTimeUpdate: function () {
            var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, parseInt(this._curElmt.attr("id").split("_")[1])))[0];
            var newStartTime = new Date(appointment[this._appointmentSettings["startTime"]]), newEndTime = new Date(appointment[this._appointmentSettings["endTime"]]);
            var cellHeight = this.element.find(".e-workcells").outerHeight();
            var timesoltduration = parseInt(this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                var dragArea = this.element.find(".e-draggableworkarea");
                var appTop = $(this._curElmt[0]).offset().top;
                var resizeMax = dragArea.height() + dragArea.scrollTop();
                var resizeElmntHeight = $(this._curElmt[0]).outerHeight();
                var topPos = appTop - dragArea.offset().top + dragArea.scrollTop();
                var resizeMaxTop = (topPos - (cellHeight / this.model.timeScale.minorSlotCount)) < resizeMax ? topPos : resizeMax - resizeElmntHeight;
            }
            if (this._topResizing) {
                var newTopTime = resizeMaxTop * this.model.timeScale.majorSlot / ((this.model.timeScale.minorSlotCount) * (cellHeight));
                newStartTime.setHours(parseInt(this.model.startHour) + parseInt(newTopTime / 60));
                newStartTime.setMinutes(parseInt(newTopTime % 60));
                (timesoltduration >= this._resizeInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval);
            }
            else if (this._bottomResizing) {
                var newcellCount = ($(this._curElmt[0]).outerHeight() / cellHeight);
                var newTopTime = (resizeMaxTop + (newcellCount * cellHeight)) * this.model.timeScale.majorSlot / ((this.model.timeScale.minorSlotCount) * (cellHeight));
                newEndTime.setHours(parseInt(this.model.startHour) + parseInt(newTopTime / 60));
                newEndTime.setMinutes(newTopTime % 60);
                (timesoltduration >= this._resizeInterval) ? newEndTime.setMinutes((Math.round(newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval)) : newEndTime.setMinutes(((newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval));
            }
            else if (this._rightResizing) {
                var diffWidth = (this.model.endHour - this.model.startHour === 24) ? this._curElmt.width() - this.appoint_width : this._curElmt.width();
                var diffMinutes = (diffWidth * 60) / ((this.element.find(".e-workcells").width() * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)) + 1);

                if (this.model.endHour - this.model.startHour === 24) {
                    newEndTime.setHours(new Date(newEndTime).getHours() + parseInt(diffMinutes / 60));
                    newEndTime.setMinutes(new Date(newEndTime).getMinutes() + parseInt(diffMinutes % 60));
                }
                else {
                    newEndTime.setHours(new Date(newStartTime).getHours() + (parseInt(this._curElmt.width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    newEndTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                }
                (timesoltduration >= this._resizeInterval) ? newEndTime.setMinutes(Math.round(newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval) : newEndTime.setMinutes((newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval);
                if (newEndTime > new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)))
                    newEndTime = new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59));
                if (this.model.endHour - this.model.startHour != 24) {
                    var indexCell = parseInt((this._curElmt.offset().left + (dragArea.scrollLeft() - dragArea.offset().left) + this._curElmt.width()) / this.element.find(".e-workcells").width()) - 1;
                    var hourValue = parseInt(indexCell / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    var newStart = new Date(newStartTime);
                    var variable = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? (this._dateRender[hourValue] - new Date(new Date(new Date(newStartTime).setHours(0, 0, 0, 0))).getTime()) / (24 * 1000 * 60 * 60) : 0;
                    var missDate = this.currentView() == "workweek" ? ((variable - 1) * (this.model.endHour - this.model.startHour)) : 0;
                    var minStartTime = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? new Date(new Date(newStart).setHours(new Date(newStartTime).getHours() + missDate + (parseInt($(this._curElmt).width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) + (variable * ((24 - this.model.endHour) + this.model.startHour)))) : newEndTime;
                    if (new Date(newEndTime).getHours() >= (this.model.endHour)) minStartTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                    if (new Date(new Date(minStartTime).setHours(0, 0, 0, 0)).getTime() != new Date(this._dateRender[hourValue]).getTime())
                        minStartTime = new Date(this._dateRender[hourValue]).setHours(new Date(minStartTime).getHours(), new Date(minStartTime).getMinutes(), new Date(minStartTime).getSeconds(), new Date(minStartTime).getMilliseconds());
                    newEndTime = new Date(minStartTime);
                }
            }
            else if (this._leftResizing) {
                if ($(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left < $(this._curElmt).offset().left)
                    var diffLeft = this._curElmt.offset().left - this._appointleft;
                else
                    var diffLeft = $(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left - this._appointleft;
                if (this.model.enableRTL) {
                    var diff = this._curElmt.width() - this.appoint_width;
                    diffLeft = -diff;
                }
                var diffMinutes = (diffLeft * 60) / ((this.element.find(".e-workcells").width() * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)) + 1);
                newStartTime.setHours(parseInt(new Date(newStartTime).getHours()) + parseInt(diffMinutes / 60));
                newStartTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                (timesoltduration >= this._resizeInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval);
                if (newStartTime < new Date(this._dateRender[0]))
                    newStartTime = new Date(this._dateRender[0]);
                //if (this.model.endHour - this.model.startHour !== 24) {
                //    var drag = (dragArea.scrollLeft() == 0) ? dragArea.offset().left : dragArea.scrollLeft() - dragArea.offset().left;
                //    var offsetLeft = (((this._curElmt.offset().left + drag)) / this.element.find(".e-workcells").width()) - 1;
                //    var cellIndex = parseInt(parseInt(offsetLeft) / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                //    var maxNewStartTime = new Date(this._dateRender[cellIndex]);
                //    var indTime = (offsetLeft % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                //    var hrsTime = ((this.model.startHour) + (indTime / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))) - 0.2;
                //    maxNewStartTime.setHours(hrsTime);
                //    maxNewStartTime.setMinutes((hrsTime * 60) % 60);
                //    newStartTime = new Date(maxNewStartTime);
                //}
            }
            if (this.model.enableRTL) {
                this._curElmt.find(".e-apptext").html(ej.format(new Date(newStartTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal");
                this._curElmt.find(".e-apptime").html(ej.format(new Date(newEndTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal").css("float", "left").css("margin-top", (this._curElmt.height() - (this._curElmt.find(".e-apptime").outerHeight() + this._curElmt.find(".e-apptext").outerHeight())) + "px");
            }
            else {
                this._curElmt.find(".e-apptext").html(ej.format(new Date(newStartTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal");
                this._curElmt.find(".e-apptime").html(ej.format(new Date(newEndTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal").css("float", "right").css("margin-top", (this._curElmt.height() - (this._curElmt.find(".e-apptime").outerHeight() + this._curElmt.find(".e-apptext").outerHeight())) + "px");
            }
            this._resizeNewStartTime = newStartTime;
            this._resizeNewEndTime = newEndTime;
        },

        _leftRightResize: function (document, appointDiv, index, noOfDays, Start, End) {
            var StartTime = this._leftResizing ? Start : End;
            var EndTime = this._leftResizing ? End : Start;

            if (this._resWorkWeek) {
                var eleOffset = appointDiv.offset();
                this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "none");
                var element = this._leftResizing ? document.elementFromPoint((eleOffset.left - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop())) : document.elementFromPoint((eleOffset.left + appointDiv.width() - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop()));
                if (this._leftResizing)
                    var trgtIndex = Math.floor(appointDiv.offset().left / this.element.find(".e-alldaycells").width()) - Math.floor(appointDiv.width() / this.element.find(".e-alldaycells").width());
                else
                    var trgtIndex = Math.floor(appointDiv.offset().left / this.element.find(".e-alldaycells").width()) + Math.floor(appointDiv.width() / this.element.find(".e-alldaycells").width());
                this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "visible");
            }
            else var trgtIndex = this._leftResizing ? index * noOfDays : (index == this.res1.length - 1) ? ((index + 1) * noOfDays - 1) : (index + 1) * noOfDays;

            if (!this.model.enableRTL) {
                if (this._rightResizing) {
                    var diffLeft = appointDiv[0].offsetLeft + $(appointDiv[0]).width();
                    if (!this._resWorkWeek) var diffDays = Math.floor(diffLeft / (this.element.find(".e-alldaycells").width())) - (index * noOfDays);
                    var cellsLeft = (index == this.res1.length - 1) ? $(this.element.find(".e-alldaycells")[trgtIndex]).offset().left + this.element.find(".e-alldaycells").width() : $(this.element.find(".e-alldaycells")[trgtIndex]).offset().left;
                }
                else {
                    var diffLeft = $(this.element.find(".e-alldaycells")[trgtIndex]).offset().left;
                    var cellsLeft = $(appointDiv[0]).offset().left;
                }
                if (cellsLeft >= diffLeft) {
                    newStartTime = new Date(this._dateRender[0]);
                    if (!this._resWorkWeek && this._leftResizing) {
                        var diffLeft = $(appointDiv[0]).offset().left - $(this.element.find(".e-alldaycells")[index * noOfDays]).offset().left;
                        var diffDays = Math.round(diffLeft / (this.element.find(".e-alldaycells").width() + 1));
                    }
                    if (this.model.workWeek.length > 0) {
                        if (this._resWorkWeek) {
                            newStartTime = new Date(this._dateRender[trgtIndex]);
                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                        }
                        else {
                            newStartTime = new Date(this._dateRender[0]);
                            newStartTime.setDate(new Date(this._dateRender[diffDays]).getDate());
                            newStartTime.setMonth(new Date(this._dateRender[diffDays]).getMonth());
                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                        }
                    }
                    else {
                        newStartTime = new Date(this._dateRender[0]);
                        newStartTime.setDate(new Date(newStartTime).getDate() + ((diffDays >= noOfDays) ? diffDays - 1 : diffDays));
                        newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                    }
                }
                else {
                    (this._rightResizing) ? this._rightResizing = false : this._leftResizing = false;
                    (!this.model.enableRTL) ? newStartTime = Start : newEndTime = End;
                }
            }
            else {
                if (this._resWorkWeek) {
                    var resDates = $.extend(true, [], this._dateRender);
                    resDates.reverse();
                    var eleOffset = appointDiv.offset();
                    this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "none");
                    var element = this._rightResizing ? document.elementFromPoint((eleOffset.left - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop())) : document.elementFromPoint((eleOffset.left + appointDiv.width() - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop()));
                    var target = $.grep(element, function (value) { if ($(value).closest("td").hasClass("e-alldaycells")) { return value; } });
                    var trgtIndex = (this.element.find(".e-alldaycells").length - 1) - $(target[0]).index();
                    this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "visible");
                    newEndTime = new Date(resDates[trgtIndex]);
                    newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                }
                else {
                    var diffWidth = $(appointDiv[0]).width() - this.appoint_width;
                    var diffDays = Math.round($(appointDiv[0]).width() / this.element.find(".e-alldaycells").width()) - 1;
                    newEndTime = this._rightResizing ? new Date(End) : new Date(StartTime);
                    this._rightResizing ? newEndTime.setDate(new Date(newEndTime).getDate() - diffDays) : newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                    newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                    if (newEndTime > new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()))) {
                        newEndTime = new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()));
                    }
                    else if (newEndTime < new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()))) {
                        newEndTime = new Date(new Date(this._dateRender[0]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()));
                    }
                }
            }
            return (!this.model.enableRTL) ? newStartTime : newEndTime;
        },
        _appointmentResizeStop: function (e) {
            this._tooltipEvents("enable");
            try {
                var dragArea = this.element.find(".e-draggableworkarea");
                this.resizeStart = false;
                $(document).off(ej.eventType.mouseMove, $.proxy(this._appointmentResizing, this));
                $(document).off(ej.eventType.mouseUp, $.proxy(this._appointmentResizeStop, this));
                var model = this._appointmentSettings;
                var workcell = this.element.find(".e-workcellstab");
                var scheduleHeight = workcell.find("tr").length * this.element.find(".e-workcells").height();
                var appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-alldayappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
                (appointDiv.length == 0) && (appointDiv = this._appointdata);
                if (appointDiv.attr("guid") != this._appointdata.attr('guid')) { appointDiv = this._appointdata; }
                this._appUid = appointDiv.attr('guid');
                var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                var twoDayApps = tempApp.length > 1 ? true : false;
                var appoint = ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) ? this._getAppointmentByParentId(this._appUid) : (tempApp[0][model["recurrence"]] ? tempApp[0] : this._getAppointmentByParentId(this._appUid));
                var noOfDays = (this.currentView() === "week" || this.currentView() === "month" || this._isCustomMonthView()) ? this.model.showWeekend ? 7 : this.model.workWeek.length : this.currentView() === "workweek" && this.model.workWeek.length > 0 ? this.model.workWeek.length : 1;
                noOfDays = (this.currentView() == "customview" && this._renderDays <= 7) ? this._renderDays : noOfDays;
                if (this._resWorkWeek) {
                    var resDates;
                    var resObj = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, tempApp[0][this._appointmentSettings.resourceFields.split(",")[this._appointmentSettings.resourceFields.split(",").length - 1]]));
                    if (!ej.isNullOrUndefined(resObj[0][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                        resDates = resObj[0][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                    else
                        resDates = this.model.workWeek;
                    noOfDays = resDates.length;
                }
                if (appoint != null || appoint !== undefined) {
                    var bigApps = appoint[this._appointmentSettings["startTime"]].getDate() < new Date(appoint[this._appointmentSettings["endTime"]]).getDate() ? true : false;
                    var newStartTime = new Date(appoint[this._appointmentSettings["startTime"]]);
                    var newEndTime = new Date(appoint[this._appointmentSettings["endTime"]]);
                    if (twoDayApps && tempApp[0][model["recurrence"]]) {
                        var splitObj = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, tempApp[0].Guid)));
                        newStartTime = new Date(splitObj[0][this._appointmentSettings["startTime"]]);
                        newEndTime = new Date(splitObj[1][this._appointmentSettings["endTime"]]);
                    }
                    else if (tempApp[0][model["recurrence"]]) {
                        newStartTime = new Date(tempApp[0][this._appointmentSettings["startTime"]]);
                        newEndTime = new Date(tempApp[0][this._appointmentSettings["endTime"]]);
                    }
                    this.element.find('[guid=' + tempApp[0]["Guid"] + ']').removeClass("e-selectedAppointment");
                    var StartTime = appoint[this._appointmentSettings["startTime"]];
                    var EndTime = appoint[this._appointmentSettings["endTime"]];
                    var resizeElmntHeight = $(appointDiv[0]).outerHeight();

                    var cellHeight = this.element.find(".e-workcells").outerHeight();
                    if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                        var appTop = $(appointDiv[0]).offset().top;
                        var resizeMax = dragArea.height() + dragArea.scrollTop();
                        var topPos = appTop - dragArea.offset().top + dragArea.scrollTop();
                        var resizeMaxTop = (topPos - (cellHeight / this.model.timeScale.minorSlotCount)) < resizeMax ? topPos : resizeMax - resizeElmntHeight;
                    }
                    resizeMaxTop = ej.isNullOrUndefined(resizeMaxTop) ? 0 : resizeMaxTop;
                    var cellCount = ($(appointDiv[0]).outerHeight() / cellHeight);
                    var cellDiff = (resizeMaxTop + (cellCount * cellHeight)) * this.model.timeScale.majorSlot / ((this.model.timeScale.minorSlotCount) * (cellHeight)) / 30;
                    var difHeight = resizeElmntHeight - parseInt(cellDiff);
                    var apptotheight = resizeMaxTop + difHeight;
                    if (this._topResizing) {
                        var splitTopResize = this._topResizing;
                        if (resizeMaxTop > 0) {
                            newStartTime = this._resizeNewStartTime;
                        }
                        else {
                            newStartTime.setHours(0, 0, 0);
                        }
                        this._topResizing = false;
                    }
                    else if (this._bottomResizing) {
                        var splitBottomResize = this._bottomResizing;
                        if (resizeMaxTop >= 0 && apptotheight < scheduleHeight) {
                            newEndTime = this._resizeNewEndTime;
                        }
                        else {
                            newEndTime.setHours(23, 59, 59);
                        }
                        this._bottomResizing = false;
                    }
                    else if (this._leftResizing) {
                        if (this.model.orientation == "vertical") {
                            var index = (!this.model.group) ? 0 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appoint[this._appointmentSettings.resourceFields.split(',')[this._tempResource.length - 1].trim()]);
                            if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                                !this.model.enableRTL ? newStartTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime) : newEndTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime);
                            }
                            else {
                                var cellsLeft = !this.model.enableRTL ? ($(this.element.find(".e-monthcells")[index * noOfDays]).offset().left) : $(this.element.find(".e-monthcells")[(index + 1) * noOfDays - 1]).offset().left;
                                if ($(appointDiv[0]).offset().left > cellsLeft) {
                                    if (!this.model.enableRTL) {
                                        this._resize = true;
                                        newStartTime = new Date(this._firstweekdate(new Date(tempApp[0][model["startTime"]])));
                                        this._resize = false;
                                        var diffDays = Math.round(($(appointDiv[0]).offset().left - $(this.element.find(".e-monthcells")[index * noOfDays]).offset().left) / this.element.find(".e-monthcells").width());
                                        if (this.model.showWeekend) {
                                            newStartTime.setDate(newStartTime.getDate() + diffDays);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                        else {
                                            var showWeekDays = this._getWeekDays();
                                            while (showWeekDays.indexOf(newStartTime.getDay()) < 0) {
                                                newStartTime = new Date(new Date(newStartTime).getTime() + (1000 * 60 * 60 * 24));
                                            }
                                            var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) + diffDays;
                                            newStartTime = new Date(this._dateRender[dateIndex]);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                    }
                                    else {
                                        if (this.model.showWeekend) {
                                            var diffDays = Math.round(($(appointDiv[0]).width() - this.appoint_width) / (this.element.find(".e-monthcells").width()));
                                            newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                        else {
                                            var showWeekDays = this._getWeekDays();
                                            while (showWeekDays.indexOf(newEndTime.getDay()) < 0) {
                                                newEndTime = new Date(new Date(newEndTime).getTime() + (1000 * 60 * 60 * 24));
                                            }
                                            var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                            newEndTime = new Date(this._dateRender[dateIndex]);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                    }
                                }
                            }
                        }
                        else {
                            if ($(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left < $(appointDiv[0]).offset().left)
                                var diffLeft = $(appointDiv[0]).offset().left - this._appointleft;
                            else
                                var diffLeft = $(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left - this._appointleft;
                            if (this.model.enableRTL) {
                                var diff = $(appointDiv[0]).width() - this.appoint_width;
                                diffLeft = -diff;
                            }
                            if (this.currentView() == "month" || (this._isCustomMonthView()) || !this.model.timeScale.enable) {
                                var diffDays = Math.round(diffLeft / (this.element.find(".e-workcells").width() + 1));
                                if (this.model.showWeekend) {
                                    newStartTime.setDate(new Date(newStartTime).getDate() + diffDays);
                                }
                                else {
                                    var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) + diffDays;
                                    var findDate = new Date(new Date(this._dateRender[dateIndex]).setHours(new Date(newStartTime).getHours(), new Date(newStartTime).getMinutes(), new Date(newStartTime).getSeconds()));
                                    newStartTime = new Date(findDate);
                                }
                            }
                            else {
                                newStartTime = this._resizeNewStartTime;
                            }
                        }
                        this._leftResizing = false;
                    }
                    else if (this._rightResizing) {
                        if (this.model.orientation == "vertical") {
                            var index = (!this.model.group) ? 0 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appoint[this._appointmentSettings.resourceFields.split(',')[this._tempResource.length - 1].trim()]);
                            if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                                (!this.model.enableRTL) ? newEndTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime) : newStartTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime);
                            }
                            else {
                                var cellwidth = this.element.find(".e-monthcells").width();
                                var cellsLeft = this.model.enableRTL ? ($(this.element.find(".e-monthcells")[(index) * noOfDays]).offset().left + cellwidth) : (index == this.res1.length - 1) ? $(this.element.find(".e-monthcells")[(index + 1) * noOfDays - 1]).offset().left + cellwidth : $(this.element.find(".e-monthcells")[(index + 1) * noOfDays]).offset().left;
                                if (cellsLeft >= ($(appointDiv[0]).offset().left + $(appointDiv[0]).width())) {
                                    var diffDays = Math.round(($(appointDiv[0]).width() - this.appoint_width) / cellwidth);
                                    if (!this.model.enableRTL) {
                                        if (this.model.showWeekend) {
                                            newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                        else {
                                            var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                            newEndTime = new Date(this._dateRender[dateIndex]);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                    }
                                    else {
                                        if (this.model.showWeekend) {
                                            newStartTime.setDate(new Date(newStartTime).getDate() - diffDays);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                        else {
                                            var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) - diffDays;
                                            newStartTime = new Date(this._dateRender[dateIndex]);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                    }
                                }
                            }
                        }
                        else {
                            var diffWidth = (this.model.endHour - this.model.startHour === 24) ? $(appointDiv[0]).width() - this.appoint_width : $(appointDiv[0]).width();
                            if (this.currentView() == "month" || (this._isCustomMonthView()) || !this.model.timeScale.enable) {
                                var diffWidth = $(appointDiv[0]).width() - this.appoint_width;
                                var diffDays = Math.round(diffWidth / (this.element.find(".e-workcells").width() + 1));
                                if (this.model.showWeekend) {
                                    newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                }
                                else {
                                    var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                    var findDate = new Date(new Date(this._dateRender[dateIndex]).setHours(new Date(newEndTime).getHours(), new Date(newEndTime).getMinutes(), new Date(newEndTime).getSeconds()));
                                    newEndTime = new Date(findDate);
                                }
                            }
                            else {
                                newEndTime = this._resizeNewEndTime;
                            }
                        }
                        this._rightResizing = false;
                    }
                    if ((newStartTime >= newEndTime) || $(appointDiv[0]).width() == 0) {
                        newStartTime = tempApp[0][model["startTime"]];
                        newEndTime = tempApp[0][model["endTime"]];
                    }
                    if (newStartTime.getTime() == tempApp[0][model["startTime"]].getTime() && newEndTime.getTime() == tempApp[0][model["endTime"]].getTime()) {
                        if (this.element.find("#cloneElement").length > 0) {
                            var height = (this.element.find(".e-monthappointment").length > 1) ? this.element.find("#cloneElement").outerHeight() : this.element.find("#cloneElement").height();
                            if (this.model.enableRTL)
                                this._curElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({ 'width': this.element.find("#cloneElement").width(), 'height': height, 'top': this.element.find("#cloneElement").css('top'), 'right': this.element.find("#cloneElement").css('right') });
                            else
                                this._curElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({ 'width': this.element.find("#cloneElement").width(), 'height': height, 'top': this.element.find("#cloneElement").css('top'), 'left': this.element.find("#cloneElement").css('left') });
                            this._curElmt.find(".e-apptext").replaceWith(this.element.find("#cloneElement").find(".e-apptext")).prop("style", false);
                            this._curElmt.find(".e-apptime").html(this.element.find("#cloneElement").find(".e-apptime").text()).prop("style", false);
                            this._curElmt.css("width", this.element.find("#cloneElement")[0].style.width);
                            if (this._curElmt.hasClass("e-alldayappointment")) this._curElmt.height(19);
                            this.element.find("#cloneElement").remove();
                            $(appointDiv[0]).find('.e-schedulemouseclosetemp').addClass('e-schedulemouseclose e-icon').removeClass('e-schedulemouseclosetemp');
                        }
                        return false;
                    }
                    (this.element.find("#cloneElement").length > 0) && this.element.find('#cloneElement').remove();
                    this._refreshCellsHeight();
                    var currentMonth = new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1);
                    var maxdate = new Date(new Date(this.model.maxDate).getTime()).setHours(23, 59, 59);
                    var otherMonth = (!this.model.showNextPrevMonth && this.model.orientation == "vertical" && this.currentView() == "month") ? currentMonth.getTime() != new Date(newStartTime.getFullYear(), newStartTime.getMonth(), 1).getTime() || currentMonth.getTime() != new Date(newEndTime.getFullYear(), newEndTime.getMonth(), 1).getTime() : false;
                    if (!otherMonth && (newEndTime >= new Date(this.model.minDate)) && (newEndTime <= maxdate)) {
                        if (appoint[model["recurrence"]] == 1 && appoint[model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1) {
                            var index, reverse = false;
                            var recList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                            var _appList = $.extend(true, {}, recList[0]);
                            _appList[this._appointmentSettings["endTime"]] = recList[recList.length - 1][this._appointmentSettings["endTime"]];
                            var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                            var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                            var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                            if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                            var recurColl = this._appointmentRecurrenceSort(recurColl);
                            var _newAddList = $.extend({}, tempApp[0]);
                            if (twoDayApps) _newAddList = $.extend({}, recurColl.filter(function (a) { return a.Guid == tempApp[0].Guid; })[0]);
                            (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]]) && (index = this._recuCollectionIndex(recurColl, _appList));
                            if (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                                _newAddList[model["startTime"]] = _appList[model["startTime"]];
                                _newAddList[model["endTime"]] = _appList[model["endTime"]];
                                this._alertDragResizeError();
                                reverse = true;
                            }
                            else {
                                prvStartTime = _newAddList[model["startTime"]];
                                prvEndTime = _newAddList[model["endTime"]];
                                _newAddList[model["startTime"]] = new Date(newStartTime);
                                _newAddList[model["endTime"]] = new Date(newEndTime);
                                var avail = this._checkAvailability(_newAddList);
                                var eventTarget = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("resizeStop") != -1)) ? { type: e.type } : e;
                                if (this._trigger("resizeStop", { appointment: _newAddList, target: eventTarget }) || avail.length > 0) {
                                    this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                                    _newAddList[model["startTime"]] = new Date(prvStartTime);
                                    _newAddList[model["endTime"]] = new Date(prvEndTime);
                                    reverse = true;
                                }
                                else {
                                    var maxId = this.model.enableLoadOnDemand ? this._dataCount : this._appMainId + 1;
                                    var Parid = _newAddList[model["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[model["recurrenceId"]];
                                    this._deleteOcurrence(Parid, new Date(_appList[model["startTime"]]));
                                    _newAddList[model["recurrenceRule"]] = tempApp[0][model["recurrenceRule"]] + ";RECUREDITID=" + _newAddList["ParentId"];
                                    _newAddList[model["id"]] = _newAddList["AppTaskId"] = maxId;
                                }
                            }
                            var temp = [], _editApp = [];
                            temp.push(this._timeZoneAppointments(_newAddList, ""));
                            var parid = _newAddList[this._appointmentSettings["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[this._appointmentSettings["recurrenceId"]];
                            var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, parid));
                            _editApp.push(this._timeZoneAppointments(_App[0], ""));
                            var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                            (!reverse) && (promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable));
                            var updateTempNew = [];
                            for (var c = 0; c < temp.length; c++) {
                                updateTempNew = this._timeZoneAppointments(temp[c], "reverse");
                                new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew);
                            }
                            var updateTempNew1 = [];
                            for (var c = 0; c < _editApp.length; c++) {
                                updateTempNew1 = this._timeZoneAppointments(_editApp[c], "reverse");
                                new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew1);
                            }
                            if (!reverse) {
                                if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(_newAddList);
                                var filterCollection = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                                new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                this._appointmentProcessing(_newAddList);
                                this._appointmentRemove(_newAddList);
                                this._currentViewAppointments = this._appointmentCount();
                                var collection = this._currentViewAppointments.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                                for (var e = 0, len = collection.length; e < len; e++) {
                                    this._refreshDayAppointments(collection[e]);
                                }
                            }
                            else {
                                this._appointmentRemove(_newAddList);
                                var filterCollection = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                for (var e = 0, len = filterCollection.length; e < len; e++) {
                                    this._refreshDayAppointments(filterCollection[e]);
                                }
                            }
                            this._trigger("actionComplete", { data: _newAddList, requestType: "appointmentResize" });
                            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                                var proxy = this;
                                promise.done(function (e) {
                                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                    if ($.isArray(value)) {
                                        proxy._processUrlBinding(e);
                                    }
                                    else if ($.isPlainObject(value)) {
                                        if (value.added.length > 0) {
                                            proxy._dateFormat(value.added);
                                            for (var a = 0, len = value.added.length; a < len; a++) {
                                                _newAddList[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                                new ej.DataManager(proxy._processed).update("Guid", _newAddList);
                                            }
                                        }
                                    }
                                });
                                promise.fail(function (e) {
                                    proxy._renderAppointmentAll();
                                });
                            }
                        }
                        else {
                            var index, reverse = false, appointSource = (twoDayApps) ? this._currentAppointmentData : this._processed;
                            var object = new ej.DataManager(appointSource).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appoint.Guid));
                            var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, object[0].ParentId));
                            if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                            var recurColl = this._appointmentRecurrenceSort(recurColl);
                            var _updateList = $.extend({}, object[0]);
                            (this.model.enableRecurrenceValidation && _updateList[model["recurrence"]]) && (index = this._recuCollectionIndex(recurColl, object[0]));
                            if (this.model.enableRecurrenceValidation && _updateList[model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                                _updateList[model["startTime"]] = object[0][model["startTime"]];
                                _updateList[model["endTime"]] = object[0][model["endTime"]];
                                this._alertDragResizeError();
                                reverse = true;
                            }
                            else {
                                prevStartTime = _updateList[model["startTime"]];
                                prevEndTime = _updateList[model["endTime"]];
                                _updateList[model["startTime"]] = newStartTime;
                                _updateList[model["endTime"]] = newEndTime;
                                var avail = this._checkAvailability(_updateList);
                                var eventTarget = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("resizeStop") != -1)) ? { type: e.type } : e;
                                if (this._trigger("resizeStop", { appointment: _updateList, target: eventTarget }) || avail.length > 0) {
                                    this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                                    _updateList[model["startTime"]] = prevStartTime;
                                    _updateList[model["endTime"]] = prevEndTime;
                                    reverse = true;
                                }
                            }
                            var temp = this._timeZoneAppointments(_updateList, "");
                            var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                            (!reverse) && (promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable));
                            var updateTemp = this._timeZoneAppointments(temp, "reverse");
                            new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                            if (twoDayApps) {
                                var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, _updateList["Guid"]));
                                new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                                this._appointmentProcessing(_updateList);
                            }
                            else {
                                new ej.DataManager(this._processed).update("Guid", _updateList);
                                new ej.DataManager(this._renderedApp).remove("Guid", _updateList);
                                new ej.DataManager(this._renderedAllDay).remove("Guid", _updateList);
                            }
                            this._appointmentRemove(_updateList);
                            this._currentViewAppointments = this._appointmentCount();
                            var collection = this._currentViewAppointments.filter(function (obj) { return obj.Guid == _updateList.Guid; });
                            for (var e = 0, len = collection.length; e < len; e++) {
                                this._refreshDayAppointments(collection[e]);
                            }
                            this._trigger("actionComplete", { data: _updateList, requestType: "appointmentResize" });
                            this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                                var proxy = this;
                                promise.done(function (e) {
                                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                    if ($.isArray(value)) {
                                        proxy._processUrlBinding(e);
                                    }
                                });
                                promise.fail(function (e) {
                                    proxy._renderAppointmentAll();
                                });
                            }
                        }
                    }
                    else
                        this._renderAppointmentAll();
                }
                this.element.find("div.e-tophandle,div.e-bottomhandle").removeClass("e-rowcursor");
                this.element.find("div.e-lefthandle,div.e-righthandle").removeClass("e-columncursor");
            } catch (e) {

            }
        },
        _dragdropAppointments: function () {
            if (this.model.readOnly)
                return false;
            this._topResizing = false;
            this._bottomResizing = false;
            this._leftResizing = false;
            this._rightResizing = false;
            var appointdiv;
            if (this.model.allowDragAndDrop) {
                var proxy = this;
                var $dragableElements = this.element.find(".e-appointment");
                $dragableElements.ejDraggable({
                    handle: ".e-appointment",
                    dragArea: (proxy.model.appointmentDragArea == "") ? proxy.element.find("div.e-draggableworkarea", (".e-headrealldaytable tr")[(!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this._grouping.length + 1 : 1]) : $(proxy.model.appointmentDragArea),
                    cursorAt: (proxy.model.appointmentDragArea == "") ? { top: 0, left: 0 } : { top: -40, left: -40 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                    },
                    drag: function (args) {
                        proxy._dragOver(args);
                    },
                    dragStop: function (args) {
                        proxy._dragStop(args);
                    },
                    helper: function (event, ui) {
                        appointdiv = $(event.sender.target).hasClass("e-appointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-appointment");
                        return proxy._appointElement(appointdiv, proxy);
                    }

                });
                var $dragableElements = this.element.find(".e-alldayappointment");
                $dragableElements.ejDraggable({
                    handle: ".e-alldayappointment",
                    dragArea: (proxy.model.appointmentDragArea == "") ? proxy.element : $(proxy.model.appointmentDragArea),// proxy.element.find((".e-headrealldaytable tr")[(!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length!=0)) ? this._grouping.length + 1 : 1],"div.e-draggableworkarea"),
                    cursorAt: { top: 17, left: 0 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                    },
                    drag: function (args) {
                        proxy._dragOver(args);
                    },
                    dragStop: function (args) {
                        proxy._dragStop(args);
                    },
                    helper: function (event, ui) {
                        appointdiv = $(event.sender.target).hasClass("e-alldayappointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-alldayappointment");
                        return proxy._appointElement(appointdiv, proxy);
                    }

                });
                var $dragableElements = this.element.find(".e-monthappointment");
                $dragableElements.ejDraggable({
                    handle: ".e-monthappointment",
                    dragArea: (proxy.model.appointmentDragArea == "") ? proxy.element.find("div.e-draggableworkarea") : $(proxy.model.appointmentDragArea),
                    cursorAt: (proxy.model.appointmentDragArea == "") ? { top: 0, left: 0 } : { top: -20, left: 10 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                    },
                    drag: function (args) {
                        proxy._dragOver(args);
                    },
                    dragStop: function (args) {
                        proxy._dragStop(args);
                    },
                    helper: function (event, ui) {
                        appointdiv = $(event.sender.target).hasClass("e-monthappointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-monthappointment");
                        return proxy._appointElement(appointdiv, proxy);
                    }

                });
            }
        },
        _appointElement: function (appointdiv, proxy) {
            var _cloneWidth = (proxy.model.orientation == "vertical" && appointdiv.hasClass("e-appointment")) ? appointdiv.closest('td').width() * 0.85 : appointdiv.width();
            appointdiv.find('.e-schedulemouseclose').removeClass('e-schedulemouseclose e-icon');
            appointdiv.find('.e-tophandle').removeClass('e-tophandle e-appointresizer-top e-icon e-nsexpand');
            appointdiv.find('.e-bottomhandle').removeClass('e-bottomhandle e-appointresizer-bottom e-icon e-nsexpand');
            appointdiv.find('.e-lefthandle').removeClass('e-lefthandle e-appointresizer-left e-icon e-ewexpand');
            appointdiv.find('.e-righthandle').removeClass('e-righthandle e-appointresizer-right e-icon e-ewexpand');
            appointdiv.clone().prop('id', 'cloneElement').appendTo(appointdiv.parent());
            appointdiv.css('cursor', 'move');
            return (proxy.model.appointmentDragArea == "") ? appointdiv.addClass("e-draggableAppointment e-scheduleAppGlassy").removeClass("e-schedulemouseclose e-tophandle e-bottomhandle").css("width", _cloneWidth + "px").appendTo(proxy.element) : appointdiv.addClass("e-draggableAppointment e-scheduleAppGlassy").removeClass("e-schedulemouseclose e-tophandle e-bottomhandle").css("width", _cloneWidth + "px").appendTo($(document.body));
        },
        _dragStart: function (args) {
            if ($(args.element[0]).hasClass("e-appointment") || $(args.element[0]).hasClass("e-monthappointment") || $(args.element[0]).hasClass("e-alldayappointment")) {
                this._tooltipEvents("disable");
                (this._mediaQuery || ej.isMobile()) && this._off(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment");
                var target = this._curDragElmt = args.element;
                var model = this._appointmentSettings, appoint;
                this._appUid = $(args.element[0]).attr("guid");
                var tempApp = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
                if (tempApp.length > 1) {
                    var templist = $.extend(true, [], tempApp);
                    templist[0][model["endTime"]] = templist[templist.length - 1][model["endTime"]];
                    appoint = templist[0];
                } else appoint = tempApp[0];
                var data = { target: target, appointment: appoint };
                if (this._trigger("actionBegin", { data: data, requestType: "appointmentDrag" })) {
                    args.cancel = true;
                    ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
                    this._renderAppointmentAll();
                    this._tooltipEvents("enable");
                    (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
                    return false;
                }
                if (this._trigger("dragStart", data)) {
                    args.cancel = true;
                    ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
                    this._renderAppointmentAll();
                    this._tooltipEvents("enable");
                    (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
                    return false;
                }
            }
            else
                args.cancel = true;
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
        },

        _dragOver: function (args) {
            var $target = $(args.element);
            var data = { target: $target, interval: 10 };
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            this.element.find(".e-workcells").removeClass("e-selectedCell").removeClass("e-mousehover");
            this._trigger("drag", data);
            this._dragInterval = data.interval;
            ((this.currentView() != "month" && !this._isCustomMonthView()) && ($(args.element[0]).hasClass("e-appointment") || args.target.className.indexOf('e-workcells') > -1)) && this._dragAppointmentCurrentTime(args);
            if (this.model.orientation == "horizontal" && this._tempResource.length != 0 && this._grouping.length != 0) {
                args.element.css("pointer-events", "none");
                if (this.model.group.resources.length > 1) {
                    var tempTrgt = document.elementFromPoint(args.element.offset().left, args.element.offset().top);
                    var trgtIndex = $(tempTrgt).closest(".e-workcells").parent().index();
                    var trgtElement = $(this.element.find(".e-resourceheadertable tr")[trgtIndex]).children();
                    if (trgtElement.hasClass("e-parentnode")) {
                        if ($(trgtElement.children()[0]).hasClass("e-resourceexpand")) {
                            $(trgtElement.children()[0]).removeClass("e-resourceexpand").addClass("e-resourcecollapse");
                            var grpIndex = $(trgtElement.children()[0]).attr("id").split("_")[0];
                            var resColl = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, grpIndex));
                            for (var a = 0; a < resColl.length; a++) {
                                var newIndex = trgtIndex + a + 1;
                                if ($(this.element.find(".e-resourceheadertable tr")[newIndex]).is(":hidden")) {
                                    $(this.element.find(".e-resourceheadertable tr")[newIndex]).toggle();
                                    $(this.element.find(".e-workcellstab tr")[newIndex]).toggle();
                                }
                            }
                            this.element.find(".e-horires").height(this.element.find(".e-draggableworkarea").height());
                            this._horizontalRender();
                            if (this.model.cellHeight) this._reRenderScroller();
                            this._horizontalResIcon();
                        }
                    }
                }
                args.element.css("pointer-events", "");
            }
        },

        _dragStop: function (args) {
            (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
            this._tooltipEvents("enable");
            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow) && this.model.showQuickWindow) this._quickAppDetailsWindow.ejDialog("close");
            var proxy = this, model = this._appointmentSettings, dragArea = this.element.find(".e-draggableworkarea");
            this._appUid = args.element.attr("guid");
            var tempApp = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
            if (tempApp.length > 1 && !tempApp[0][model["recurrence"]]) {
                var twoDayApps = true;
                var appoint = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
            }
            else {
                var twoDayApps = (tempApp.length > 1) ? true : false;
                var templist = $.extend(true, [], tempApp);
                templist[0][model["endTime"]] = templist[templist.length - 1][model["endTime"]];
                var appoint = (tempApp[0][model["recurrence"]] && (tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) ? this._getAppointmentByParentId(this._appUid) : (tempApp[0][model["recurrence"]] ? (tempApp.length > 1) ? templist[0] : tempApp[0] : this._getAppointmentByParentId(this._appUid));
            }
            if ((ej.isNullOrUndefined(this._dragNewStartTime) || ej.isNullOrUndefined(this._dragNewEndTime)) || (this.model.orientation == "horizontal" && (this.currentView() == "month" || this._isCustomMonthView())) && tempApp.length != 0) {
                this._dragNewStartTime = new Date(tempApp[0][this._appointmentSettings["startTime"]]);
                this._dragNewEndTime = new Date(tempApp[tempApp.length - 1][this._appointmentSettings["endTime"]]);
            }
            var apps = $.extend(true, {}, appoint);
            var splitDrag = ((Math.ceil((apps[model["endTime"]] - apps[model["startTime"]]) / 3600000) < 24) && (apps[model["endTime"]].getDay() != apps[model["startTime"]].getDay())) ? true : false;
            if (this.model.orientation == "vertical") {
                if ($(args.element[0]).hasClass("e-appointment")) {
                    var newStartTime, newEndTime, cellstrtime, cellendtime;
                    newStartTime = cellstrtime = this._dragNewStartTime;
                    newEndTime = cellendtime = this._dragNewEndTime;
                    if (args.target.className.indexOf('e-alldaycells') > -1 || Math.ceil((this._dragNewEndTime.getTime() - this._dragNewStartTime.getTime()) / (60 * 60 * 1000)) >= 24) {
                        var allday = true;
                        cellstrtime = new Date(cellstrtime.setHours(0, 0, 0, 0));
                        cellendtime = new Date(cellendtime.setHours(23, 59, 59, 59));
                    }
                    var cellIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                }
                else if ($(args.element[0]).hasClass("e-alldayappointment")) {
                    if (args.target.className.indexOf('e-workcells') > -1) {
                        var cellIndex = args.target.cellIndex;
                        cellstrtime = this._dragNewStartTime;
                        cellendtime = this._dragNewEndTime;
                        var allday = false;
                        this._allDayDrag = true;
                    }
                    else {
                        newStartTime = appoint[model["startTime"]];
                        newEndTime = appoint[model["endTime"]];
                        if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                            newStartTime = tempApp[0][model["startTime"]];
                            newEndTime = tempApp[0][model["endTime"]];
                        }
                        var diffLeft = $(args.element[0]).offset().left + dragArea.scrollLeft() - this.element.find(".e-alldaycells").offset().left - 1;
                        diffLeft = (this.model.enableRTL) ? Math.abs(diffLeft) : diffLeft;
                        var cellIndex = Math.round(diffLeft / (this.element.find(".e-alldaycells").width() + 1));
                        var count = Math.round($(args.element[0]).width() / (this.element.find(".e-alldaycells").width() + 1));
                        var overall = Math.ceil((newEndTime - newStartTime) / (1000 * 60 * 60 * 24));
                        var endInd = Math.round($(args.element[0]).width() / (this.element.find(".e-alldaycells").width() + 1));
                        var cols = this.currentView() === "week" ? 7 : this.currentView() === "workweek" ? this.model.workWeek.length : this.currentView() == "customview" ? this._renderDays : 1;
                        newStartTime = new Date(this._dateRender[cellIndex]);
                        newEndTime = new Date(this._dateRender[cellIndex]);
                        newEndTime.setHours(appoint[model["endTime"]].getHours(), appoint[model["endTime"]].getMinutes(), appoint[model["endTime"]].getSeconds());
                        if (cellIndex < 0) {
                            if (newStartTime <= new Date(this._dateRender[0])) {
                                cellstrtime = new Date(newStartTime);
                                cellstrtime.setDate(cellstrtime.getDate() + cellIndex);
                                cellstrtime.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                                cellstrtime = new Date(cellstrtime);
                            }
                            else {
                                var startdate = new Date(this._dateRender[0]);
                                startdate.setDate(startdate.getDate() + cellIndex);
                                startdate.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                                cellstrtime = new Date(startdate);
                            }
                        }
                        else {
                            if (newStartTime < new Date(this._dateRender[0])) {
                                var Index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                                (this._resWorkWeek) ? newStartTime = new Date(new Date(this._dateRender[cellIndex])) : newStartTime.setDate(new Date(appoint[proxy._appointmentSettings["startTime"]]).getDate() + Index);
                                newStartTime.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                                cellstrtime = new Date(newStartTime);
                            }
                            else {
                                var Index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                                cellstrtime = new Date(new Date(this._dateRender[Index]));
                                cellstrtime.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                            }
                        }
                        var starttime = new Date(cellstrtime);
                        var diff = new Date(appoint[model["endTime"]]).getTime() - new Date(appoint[model["startTime"]]).getTime();
                        cellendtime = new Date(new Date(starttime).setMilliseconds(diff));
                    }
                }
                else if ($(args.element[0]).hasClass("e-monthappointment")) {
                    var oldStartTime = appoint[model["startTime"]];
                    var oldEndTime = appoint[model["endTime"]];
                    if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                        oldStartTime = tempApp[0][model["startTime"]];
                        oldEndTime = tempApp[tempApp.length - 1][model["endTime"]];
                    }
                    newStartTime = new Date(new Date(this.model.currentDate).getFullYear(), new Date(this.model.currentDate).getMonth(), 1);
                    var daysInPrevMonth = newStartTime.getDay();
                    newStartTime.setDate(newStartTime.getDate() - daysInPrevMonth);
                    if (this.currentView() == "month" || (this.currentView() == "customview" && !this._oneWeek)) {
                        var cellIndex = parseInt(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-monthcells").width());
                        cellIndex = (this.model.enableRTL) ? 7 - cellIndex - 1 : cellIndex;
                    }
                    else {
                        var noOfCols = !ej.isNullOrUndefined(this.model.group) ? this._dateRender.length * this.res1.length : this._dateRender.length;
                        var cellIndex = parseInt(($(args.element[0]).offset().left - dragArea.offset().left) / (Math.round(dragArea.width() / noOfCols)));
                    }
                    if (splitDrag && (parseInt(args.element.attr("id").split("_")[1]) == tempApp[tempApp.length - 1]["AppTaskId"])) cellIndex -= 1;
                    var newTopDate = parseInt(($(args.element[0]).offset().top + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-monthcells").outerHeight()));
                    if (!this.model.showOverflowButton) newTopDate = this._findRowIndex(args);
                    var dateCount = this.currentView() == "month" || this._isCustomMonthView() && !this._oneWeek ? (this.model.showWeekend) ? 7 : this.model.workWeek.length : this._dateRender.length;
                    var index = (this.model.enableRTL) ? (newTopDate * dateCount) + (cellIndex - (Math.floor(cellIndex / dateCount) * dateCount)) - (oldEndTime.getDay() - oldStartTime.getDay()) : (newTopDate * dateCount) + (cellIndex - (Math.floor(cellIndex / dateCount) * dateCount));
                    newStartTime = new Date(new Date(this._dateRender[index]).setHours(oldStartTime.getHours(), oldStartTime.getMinutes(), oldStartTime.getSeconds()));
                    if (Math.ceil((appoint[model["endTime"]] - appoint[model["startTime"]]) / 3600000) > 24) {
                        var trgtApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, parseInt(args.element.attr('id').split("_")[1])));
                        var multiDif = new Date(trgtApp[0][model["startTime"]]) - new Date(tempApp[0][model["startTime"]]);
                        cellstrtime = new Date(newStartTime - multiDif);
                        var diffTime = (newStartTime.getTime() - new Date(oldStartTime).getTime()) - new Date(multiDif).getTime();
                    }
                    else {
                        cellstrtime = new Date(newStartTime);
                        var diffTime = newStartTime.getTime() - new Date(oldStartTime).getTime();
                    }
                    newEndTime = new Date(new Date(oldEndTime).getTime() + diffTime);
                    cellendtime = new Date(newEndTime);
                }
            }
            else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal) {
                var newStartTime = cellstrtime = this._dragNewStartTime;
                var newEndTime = cellendtime = this._dragNewEndTime;
                if (this.model.enableRTL) {
                    var colIndex = (document.elementFromPoint($(args.element[0]).offset().left, $(args.element[0]).offset().top - 1)).cellIndex;
                    colIndex -= Math.round(($(args.element[0]).width() / 30) - 1);
                }
                else
                    var colIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                var rowIndex = parseInt(($(args.element[0]).offset().top + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-workcells").outerHeight()));
                if (!this.model.showOverflowButton) rowIndex = this._findRowIndex(args);
                if (this.element.find('.e-resourceheadertable .e-resourceexpand').length > 0)
                    rowIndex += $(this.element.find('.e-resourceheadertable').find('tr').filter(function () { return $(this).css('display') !== 'none'; })[rowIndex]).prevUntil("table.e-resourceheadertable").filter(function () { return $(this).css('display') == 'none'; }).length;
                var target = $(this.element.find(".e-workcellstab tr")[rowIndex]).find("td")[colIndex];
                if (!$(target).hasClass("e-resourceheadercells") && !ej.isNullOrUndefined(target)) {
                    this._cellIndex = (this.model.enableRTL) ? this.element.find(".e-workcells").length - (Math.round($(args.element[0]).offset().left / this.element.find(".e-workcells").width())) : Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                    var cellIndex = rowIndex;
                    if ($(args.element[0]).hasClass("e-monthappointment")) {
                        var oldStartTime = new Date(appoint[model["startTime"]]);
                        var oldEndTime = new Date(appoint[model["endTime"]]);
                        if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                            oldStartTime = tempApp[0][model["startTime"]];
                            oldEndTime = tempApp[0][model["endTime"]];
                        }
                        else if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") > 0)) {
                            appoint = tempApp[0];
                            oldStartTime = tempApp[0][model["startTime"]];
                            oldEndTime = tempApp[0][model["endTime"]];
                        }
                        newStartTime = new Date(this.monthDays[this._cellIndex]);
                        newStartTime.setHours(oldStartTime.getHours(), oldStartTime.getMinutes(), oldStartTime.getSeconds());
                        cellstrtime = new Date(newStartTime);
                        var diffTime = newStartTime.getTime() - new Date(oldStartTime).getTime();
                        newEndTime = new Date(new Date(oldEndTime).getTime() + diffTime);
                        cellendtime = new Date(newEndTime);
                    }
                }
            }
            var currentView = (this.currentView() == ej.Schedule.CurrentView.Month && (this.model.orientation == "horizontal") || this._isCustomMonthView());
            if (this.model.orientation == ej.Schedule.Orientation.Horizontal && tempApp[0][model["allDay"]] && this.res1.length > 1 && !(this.currentView() == ej.Schedule.CurrentView.Month || this._isCustomMonthView())) {
                cellstrtime = new Date(tempApp[0][model["startTime"]]);
                cellendtime = new Date(tempApp[0][model["endTime"]]);
            }
            var curLevel = true;
            if (this._grouping.length > 0) {
                var tempList = $.extend(true, {}, tempApp[0]);
                tempList = this._getDragDropResourceData(this, cellIndex, tempList);
                var resLevel = this._appointmentSettings.resourceFields.split(",");
                var curLevel = tempList[this._appointmentSettings.resourceFields.split(",")[resLevel.length - 1]] == tempApp[0][this._appointmentSettings.resourceFields.split(",")[resLevel.length - 1]];
            }
            if (curLevel && !ej.isNullOrUndefined(newStartTime) && new Date(newStartTime).getTime() == new Date(tempApp[0][model["startTime"]]).getTime() && new Date(newEndTime).getTime() == new Date(tempApp[0][model["endTime"]]).getTime() && !currentView) {
                if (this.element.find("#cloneElement").length > 0) {
                    var originElmt = this._curDragElmt.clone();
                    var startTimeDisp = this._timeMode == "12" ? ej.format(tempApp[0][model["startTime"]], this._pattern.t, this.model.locale) : ej.format(tempApp[0][model["startTime"]], "HH:mm", this.model.locale);
                    var endTimeDisp = this._timeMode == "12" ? ej.format(tempApp[0][model["endTime"]], this._pattern.t, this.model.locale) : ej.format(tempApp[0][model["endTime"]], "HH:mm", this.model.locale);
                    originElmt.find(".e-apptime").remove();
                    originElmt.find(".e-appointinnertext").append($("<div class='e-apptime'>" + startTimeDisp + " - " + endTimeDisp + "</div>"));
                    if (this.model.enableRTL)
                        originElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({
                            'width': (this.model.orientation == "vertical") ? this.element.find("#cloneElement").outerWidth() : this.element.find("#cloneElement").width(),
                            'height': (this.model.orientation == "vertical") ? this.element.find("#cloneElement").outerHeight() : this.element.find("#cloneElement").height(),
                            'top': this.element.find("#cloneElement").css('top'),
                            'right': this.element.find("#cloneElement").css('right'),
                            'cursor': ''
                        });
                    else
                        originElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({
                            'width': (this.model.orientation == "vertical") ? this.element.find("#cloneElement").outerWidth() : this.element.find("#cloneElement").width(),
                            'height': (this.model.orientation == "vertical") ? this.element.find("#cloneElement").outerHeight() : this.element.find("#cloneElement").height(),
                            'top': this.element.find("#cloneElement").css('top'),
                            'left': this.element.find("#cloneElement").css('left'),
                            'cursor': ''
                        });
                    if (this.model.timeScale.enable && this.model.orientation == "vertical" && this.currentView() != "month" && !this._isCustomMonthView() && !originElmt.hasClass("e-alldayappointment")) {
                        originElmt.children().eq(0).addClass('e-tophandle e-appointresizer-top e-icon');
                        originElmt.children().eq(1).addClass('e-bottomhandle e-appointresizer-bottom e-icon');
                    }
                    else {
                        originElmt.children().eq(0).addClass('e-lefthandle e-appointresizer-left e-icon');
                        originElmt.children().eq(1).addClass('e-righthandle e-appointresizer-right e-icon');
                    }
                    originElmt.children().eq(2).addClass('e-schedulemouseclose e-icon').removeAttr("style");
                    this._bindAppointmentAction();
                    ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
                }
                return false;
            }
            var maxdate = new Date(new Date(this.model.maxDate).getTime()).setHours(23, 59, 59);
            var otherMonth = (!this.model.showNextPrevMonth && this.model.orientation == "vertical" && this.currentView() == "month") ? new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1).getTime() != new Date(cellstrtime.getFullYear(), cellstrtime.getMonth(), 1).getTime() : false;
            if (!otherMonth && (cellendtime >= new Date(this.model.minDate)) && (cellendtime <= maxdate)) {
                this._refreshCellsHeight();
                if (appoint[model["recurrence"]] == 1 && appoint[model["recurrenceRule"]].indexOf("RECUREDITID") == -1) {
                    var _appList = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
                    if (_appList.length > 1) {
                        var tempList = $.extend(true, [], _appList);
                        tempList[0][model["endTime"]] = tempList[tempList.length - 1][model["endTime"]];
                    }
                    _appList = (_appList.length > 1) ? tempList[0] : _appList[0];
                    var Parid = _appList[model["recurrenceId"]] == null ? _appList["ParentId"] : _appList[model["recurrenceId"]];
                    var MapValue = _appList[model["recurrenceId"]] == null ? "ParentId" : model["recurrenceId"];
                    var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                    if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                    var recurColl = this._appointmentRecurrenceSort(recurColl);
                    var _newAddList = $.extend({}, _appList), index, reverse = false;
                    (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]]) && (index = this._recuCollectionIndex(recurColl, _appList));
                    if (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                        _newAddList[model["startTime"]] = _appList[model["startTime"]];
                        _newAddList[model["endTime"]] = _appList[model["endTime"]];
                        this._alertDragResizeError();
                        reverse = true;
                    }
                    else {
                        var _prevObj = $.extend(true, [], _appList);
                        _newAddList[model["startTime"]] = cellstrtime;
                        _newAddList[model["endTime"]] = cellendtime;
                        if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                            _newAddList = this._getDragDropResourceData(this, cellIndex, _newAddList);
                        if (!ej.isNullOrUndefined(allday)) _newAddList[model["allDay"]] = allday;
                        var avail = this._checkAvailability(_newAddList);
                        var eventArgs = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("dragStop") != -1)) ? { type: args.type } : args;
                        if (this._trigger("dragStop", { appointment: _newAddList, event: eventArgs }) || avail.length > 0) {
                            this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                            _newAddList = $.extend(true, [], _prevObj);
                            reverse = true;
                        }
                        else {
                            this._processed = this._sortAppById(this._processed);
                            var maxId = this.model.enableLoadOnDemand ? this._dataCount : this._appMainId + 1;
                            this._appMainId = maxId;
                            var Parid = appoint[model["recurrenceId"]] == null ? appoint["ParentId"] : appoint[model["recurrenceId"]];
                            this._deleteOcurrence(Parid, _appList[model["startTime"]]);
                            _newAddList[model["recurrenceRule"]] = appoint[model["recurrenceRule"]] + ";RECUREDITID=" + _newAddList["ParentId"];
                            _newAddList[model["recurrenceExDate"]] = appoint[model["recurrenceExDate"]];
                            _newAddList[model["id"]] = _newAddList["AppTaskId"] = maxId;
                        }
                    }
                    var temp = [], _editApp = [];
                    temp.push(this._timeZoneAppointments(_newAddList, ""));
                    var Parid = _newAddList[model["recurrenceId"]] == null ? appoint["ParentId"] : _newAddList[model["recurrenceId"]];
                    var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                    _editApp.push(this._timeZoneAppointments(_App[0], ""));
                    var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? model["id"] : "AppTaskId";
                    (!reverse) && (promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable));
                    for (var c = 0; c < temp.length; c++) {
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(temp[c], "reverse"));
                    }
                    for (var c = 0; c < _editApp.length; c++) {
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(_editApp[c], "reverse"));
                    }
                    if (!reverse) {
                        if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(_newAddList);
                        var removeCol = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        this._appointmentProcessing(_newAddList);
                        this._appointmentRemove(_newAddList);
                        var currentDrag = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        for (var cd = 0; cd < currentDrag.length; cd++) { this._refreshDayAppointments(currentDrag[cd]); }
                        this._refreshDayAppointments(_prevObj);
                    }
                    else {
                        this._appointmentRemove(_newAddList);
                        var removeCol = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        var dragCol = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        for (var d = 0; d < dragCol.length; d++) { this._refreshDayAppointments(dragCol[d]); }
                    }
                    this._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDrag" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        _newAddList[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", _newAddList);
                                    }
                                }
                            }
                        });
                        promise.fail(function (e) {
                            proxy._renderAppointmentAll();
                        });
                    }
                }
                else {
                    var index, reverse = false, appointSource = (twoDayApps) ? this._currentAppointmentData : this._processed;
                    var object = new ej.DataManager(appointSource).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, tempApp[0]["Guid"]));
                    var _prevObj = $.extend(true, {}, object[0]);
                    var prvcellstrtime = object[0][model["startTime"]];
                    var prvcellendtime = object[0][model["endTime"]];
                    var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, object[0].ParentId));
                    if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                    var recurColl = this._appointmentRecurrenceSort(recurColl);
                    object[0][model["startTime"]] = cellstrtime;
                    object[0][model["endTime"]] = cellendtime;
                    (this.model.enableRecurrenceValidation) && (index = this._recuCollectionIndex(recurColl, object[0]));
                    if (this.model.enableRecurrenceValidation && object[0][model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                        object[0][model["startTime"]] = prvcellstrtime;
                        object[0][model["endTime"]] = prvcellendtime;
                        this._alertDragResizeError();
                        reverse = true;
                    }
                    else {
                        if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                            object[0] = this._getDragDropResourceData(this, cellIndex, object[0]);
                        if (!ej.isNullOrUndefined(allday)) object[0][model["allDay"]] = allday;
                        var avail = this._checkAvailability(object[0]);
                        var eventArgs = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("dragStop") != -1)) ? { type: args.type } : args;
                        if (this._trigger("dragStop", { appointment: object[0], event: eventArgs }) || avail.length > 0) {
                            this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                            object[0] = $.extend(true, {}, _prevObj);
                            reverse = true;
                        }
                    }
                    if (this.model.appointmentDragArea != "") {
                        var appoint = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        if (appoint.length == 0) return false;
                    }
                    var temp = this._timeZoneAppointments(object[0], "");
                    var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? model["id"] : "AppTaskId";
                    (!reverse) && (promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable));
                    var updateTemp = this._timeZoneAppointments(temp, "reverse");
                    var objId = (twoDayApps) ? "Guid" : "AppTaskId";
                    new ej.DataManager(this._currentAppointmentData).update(objId, updateTemp);
                    var isBigApp = (new Date(new Date(object[0][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(object[0][model["endTime"]]).setHours(0, 0, 0, 0)).getTime());
                    if (isBigApp || twoDayApps) {
                        var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, object[0]["Guid"]));
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        this._appointmentProcessing(object[0]);
                    }
                    else {
                        new ej.DataManager(this._processed).update("AppTaskId", object[0]);
                        new ej.DataManager(this._renderedApp).remove("AppTaskId", object[0]);
                        new ej.DataManager(this._renderedAllDay).remove("AppTaskId", object[0]);
                    }
                    this._appointmentRemove(object[0]);
                    var currentFilter = this._processed.filter(function (obj) { return obj.Guid == object[0].Guid; });
                    for (var f = 0; f < currentFilter.length; f++) { this._refreshDayAppointments(currentFilter[f]); }
                    this._refreshDayAppointments(_prevObj);
                    this._trigger("actionComplete", { appointment: object[0], requestType: "appointmentDrag" });
                    this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                    if (!ej.isNullOrUndefined(promise) && promise && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                        });
                        promise.fail(function (e) {
                            proxy._renderAppointmentAll();
                        });
                    }
                }
            }
            else {
                this._renderAppointmentAll();
                var eventArgs = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("dragStop") != -1)) ? { type: args.type } : args;
                this._trigger("dragStop", { appointment: tempApp[0], event: eventArgs });
            }
            ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
            (this.element.find('#cloneElement').length > 0) && this.element.find('#cloneElement').remove();
        },

        _findRowIndex: function (args) {
            var eleOffset = $(args.element[0]).offset();
            this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "none");
            var element = $(document.elementFromPoint((eleOffset.left - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop() - 1)));
            var rowIndex = $(element).closest("td").parent().index();
            this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "visible");
            return rowIndex;
        },

        _alertDragResizeError: function () {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
            this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("DragResizeError"));
            this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
            this._alertWindow.ejDialog("open");
        },

        _processUrlBinding: function (e) {
            if (this.model.enableLoadOnDemand || (this.dataSource() instanceof ej.DataManager && this.dataSource().adaptor instanceof ej.ODataAdaptor))
                this._initDataSource("refresh");
            else {
                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                this._currentAppointmentData.length = 0;
                this._dateFormat(value);
                this._bindAppointments = true;
                this._currentAppointmentData = $.merge(this._currentAppointmentData, value);
                this._dataProcessing(value);
                this._renderAppointmentAll();
            }
        },

        _refreshCellsHeight: function () {
            if (this.currentView() == "agenda") return false;
            if (this.model.orientation == "horizontal" && !this.model.showOverflowButton) {
                this._horizontalRender();
                this._reRenderScroller();
            }
            if (this.model.orientation == "vertical" && !this.model.showOverflowButton && this.currentView() == "month") {
                this._monthCellsRender();
                this._reRenderScroller();
            }
        },

        _dragAppointmentCurrentTime: function (args) {
            var tempApp = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, args.element.attr("guid"))));
            var dragArea = this.element.find(".e-draggableworkarea");
            var timesoltduration = parseInt(this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            var proxy = this;
            var model = proxy._appointmentSettings;
            if (!tempApp[0][model["recurrence"]]) {
                var appoint = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
            }
            else {
                var templist = $.extend(true, [], tempApp);
                templist[0][model["endTime"]] = templist[templist.length - 1][model["endTime"]];
                var appoint = (tempApp[0][model["recurrence"]] && (tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == 1)) ? this._getAppointmentByParentId(this._appUid) : (tempApp[0][model["recurrence"]] ? templist[0] : this._getAppointmentByParentId(this._appUid));
            }
            if (this.model.orientation == "vertical" && ($(args.element[0]).hasClass("e-appointment") || args.target.className.indexOf('e-workcells') > -1)) {
                var dragMax = dragArea.height() + dragArea.scrollTop();
                var dragElmntHeight = args.element[0].offsetHeight;
                var cellHeight = this.element.find(".e-workcells").outerHeight();
                var topPos = $(args.element[0]).offset().top - dragArea.offset().top + dragArea.scrollTop();
                var dragMaxTop = (topPos - (cellHeight / (60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)))) < dragMax ? topPos : dragMax - dragElmntHeight;
                var newStartTime, newEndTime, cellstrtime, cellendtime;
                if ($(args.element[0]).hasClass("e-alldayappointment")) {
                    var cellIndex = args.target.cellIndex;
                    newStartTime = new Date(this.dateRender[cellIndex]);
                    var newTopTime = (dragMaxTop > 0) ? dragMaxTop * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight) : 1 * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight);
                    newStartTime.setHours(parseInt(this.model.startHour) + Math.round(newTopTime / 60));
                    newStartTime.setMinutes(parseInt(newTopTime % 60));
                    newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                    newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._dragInterval) * this._dragInterval);
                    cellstrtime = new Date(newStartTime);
                    newEndTime = new Date(newStartTime).setMinutes(newStartTime.getMinutes() + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount));
                    cellendtime = new Date(newEndTime);
                }
                else {
                    if ((dragMaxTop > 0 || !this.model.showAllDayRow) && (args.target.className.indexOf('e-alldaycells') != 1)) {
                        var newTopTime = Math.round((dragMaxTop > 0) ? dragMaxTop * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight) : 1 * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight));
                        var twoDayApps = (new Date(new Date(appoint[proxy._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(appoint[proxy._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) ? true : false;
                        if (proxy.currentView() !== "month" && !(proxy._isCustomMonthView())) {
                            var firstDayOfWeek = new Date(proxy._firstweekdate(proxy.currentDate()));
                            if (proxy.currentView() === "workweek" || (proxy.currentView() == "customview" && proxy._renderDays == 5)) {
                                var _day = new Date(firstDayOfWeek).getDay();
                                var _dayAdd = _day == 0 ? 1 : 0;
                                firstDayOfWeek.setDate(firstDayOfWeek.getDate() + _dayAdd);
                            }
                            newStartTime = firstDayOfWeek;
                            var noOfCols = proxy.currentView() === "week" ? 7 : proxy.currentView() === "workweek" ? this.model.workWeek.length : proxy.currentView() == "customview" ? proxy._renderDays : 1;
                            noOfCols = !ej.isNullOrUndefined(proxy.model.group) ? noOfCols * proxy.res1.length : noOfCols;
                            var cellIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                            newStartTime = (this.model.enableRTL) ? new Date(this.dateRender[noOfCols - cellIndex - 1]) : new Date(this.dateRender[cellIndex]);
                            newEndTime = newStartTime;
                        }
                        else {
                            newStartTime = appoint[model["startTime"]];
                            newEndTime = new Date(newStartTime);
                        }
                        if (twoDayApps) {
                            newStartTime = this._getNewStartTime(newTopTime, newStartTime);
                            cellstrtime = new Date(newStartTime);
                        }
                        else {
                            var min = (newTopTime % 60).toFixed(1);
                            var sec = min.toString().split(".");
                            var milliSec = !ej.isNullOrUndefined(sec[1]) ? ((sec[1] * 60) / 60) : 0;
                            newStartTime.setHours(parseInt(this.model.startHour) + Math.round(newTopTime / 60), parseInt(min.toString().split('.')[0]), milliSec, 0);
                            newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                            (timesoltduration >= this._dragInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._dragInterval) * this._dragInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._dragInterval) * this._dragInterval);
                            cellstrtime = new Date(newStartTime);
                        }
                        var diff = new Date(appoint[model["endTime"]]).getTime() - new Date(appoint[model["startTime"]]).getTime();
                        cellendtime = new Date(new Date(newStartTime).setMilliseconds(diff));
                    }
                    else {
                        var noOfCols = this.currentView() === "week" ? 7 : this.currentView() === "workweek" ? this.model.workWeek.length : this.currentView() == "customview" ? this._renderDays : 1;
                        noOfCols = !ej.isNullOrUndefined(this.model.group) ? noOfCols * this.res1.length : noOfCols;
                        var cellIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                        newStartTime = (this.model.enableRTL) ? new Date(this.dateRender[noOfCols - cellIndex - 1]) : new Date(this.dateRender[cellIndex]);
                        cellstrtime = new Date(newStartTime.setHours(0, 0, 0));
                        cellendtime = new Date(newStartTime.setHours(23, 59, 59));
                    }
                }
            }
            else if ((this.model.orientation == "horizontal" && $(args.element[0]).hasClass("e-appointment"))) {
                var diffTimeLeft;
                var cellstrtime = new Date(appoint[proxy._appointmentSettings["startTime"]]);
                var cellendtime = new Date(appoint[proxy._appointmentSettings["endTime"]]);
                if (this.model.enableRTL) {
                    var colIndex = (document.elementFromPoint($(args.element[0]).offset().left, $(args.element[0]).offset().top - 1)).cellIndex;
                    colIndex -= Math.round(($(args.element[0]).width() / 30) - 1);
                }
                else
                    var colIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                var rowIndex = parseInt(($(args.element[0]).offset().top + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-workcells").outerHeight()));
                if (!this.model.showOverflowButton) rowIndex = this._findRowIndex(args);
                if (this.element.find('.e-resourceheadertable .e-resourceexpand').length > 0)
                    rowIndex += $(this.element.find('.e-resourceheadertable').find('tr').filter(function () { return $(this).css('display') !== 'none'; })[rowIndex]).prevUntil("table.e-resourceheadertable").filter(function () { return $(this).css('display') == 'none'; }).length;
                var target = $(this.element.find(".e-workcellstab tr")[rowIndex]).find("td")[colIndex];
                if (!$(target).hasClass("e-resourceheadercells") && !ej.isNullOrUndefined(target)) {
                    var newStartTime = new Date(this._dateRender[0]);
                    diffTimeLeft = this.model.enableRTL ? (colIndex * 30) : (($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) / $(this.element.find(".e-workcells")[1]).outerWidth();
                    var minStartTime = ((this.model.startHour) + ((colIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) / 60));
                    var minVal = parseInt(((colIndex) / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    minStartTime = (minStartTime >= (this.model.endHour)) ? (Math.round(diffTimeLeft / 60) + (minVal * ((24 - this.model.endHour) + this.model.startHour))) : Math.round(diffTimeLeft / 60);
                    newStartTime.setHours(parseInt(proxy.model.startHour) + minStartTime);
                    newStartTime.setMinutes(parseInt(diffTimeLeft % 60));
                    newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                    (timesoltduration >= this._dragInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._dragInterval) * this._dragInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._dragInterval) * this._dragInterval);
                    cellstrtime = new Date(newStartTime);
                    var startTime = appoint[proxy._appointmentSettings["startTime"]];
                    var endTime = appoint[proxy._appointmentSettings["endTime"]];
                    var duration = (endTime - startTime) / 1000;
                    var hours = Math.floor(duration / 3600);
                    var hourValue = parseInt(args.element.width() / this.element.find(".e-workcells").width()) / this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot);
                    if (this.currentView() == "workweek" && this.model.workWeek != 5)
                        if (new Date(appoint["StartTime"]).getDay() != new Date(appoint["EndTime"]).getDay()) {
                            var differ = new Date(appoint["EndTime"]).getDay() - new Date(appoint["StartTime"]).getDay();
                            var hours = hours - ((differ - 1) * (this.model.endHour - this.model.startHour));
                        }
                    var minutes = Math.round(Math.floor((duration % 3600) / 60) / this._dragInterval) * this._dragInterval;
                    newEndTime = proxy._getNewEndTime(newStartTime, hourValue, minutes);
                    if (new Date(appoint["StartTime"]).getDay() == new Date(appoint["EndTime"]).getDay() && this.currentView() == "workweek" && this.model.workWeek.length != 5) {
                        totalhrs = newStartTime.getHours() + hours;
                        if (totalhrs > 24) {
                            var index = $.inArray(new Date(newStartTime.getFullYear(), newStartTime.getMonth(), newStartTime.getDate()).getTime(), this._dateRender) + 1;
                            newEndTime.setDate(new Date(this._dateRender[index]).getDate());
                        }
                    }
                    var some = parseInt(colIndex) + (parseInt($(args.element[0]).width() / this.element.find(".e-workcells").width())) - 1;
                    some = parseInt(some / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    var variable = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? parseInt(parseInt((new Date(newEndTime) - new Date(new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).setHours(this.model.endHour))) / (1000 * 60 * 60)) / (this.model.endHour - this.model.startHour)) : 0;
                    var newStart = new Date(newStartTime);
                    var missDate = this.currentView() == "workweek" ? ((variable - 1) * (this.model.endHour - this.model.startHour)) : 0;
                    minStartTime = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? new Date(new Date(newStart).setHours(new Date(newStartTime).getHours() + missDate + (parseInt($(args.element[0]).width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) + (variable * ((24 - this.model.endHour) + this.model.startHour)))) : newEndTime;
                    if (new Date(newEndTime).getHours() >= (this.model.endHour)) minStartTime.setMinutes(new Date(newStartTime).getMinutes() + Math.round(parseInt(diffTimeLeft % 60) / this._dragInterval) * this._dragInterval);
                    if (this.model.endHour - this.model.startHour !== 24) {
                        if (new Date(new Date(minStartTime).setHours(0, 0, 0, 0)).getTime() != new Date(this._dateRender[some]).getTime())
                            minStartTime = new Date(this._dateRender[some]).setHours(new Date(minStartTime).getHours(), new Date(minStartTime).getMinutes(), new Date(minStartTime).getSeconds(), new Date(minStartTime).getMilliseconds());
                    }
                    cellendtime = new Date(minStartTime);
                    this._cellIndex = (this.model.enableRTL) ? this.element.find(".e-workcells").length - (Math.round($(args.element[0]).offset().left / this.element.find(".e-workcells").width())) : Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                }
            }
            args.element.find(".e-apptime").html(ej.format(cellstrtime, (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale) + " - " + ej.format(cellendtime, (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).insertBefore(args.element.find(".e-apptext")).css("font-size", "12px").css("white-space", "normal");
            this._dragNewStartTime = cellstrtime;
            this._dragNewEndTime = cellendtime;
        },
        _unWireDragDrop: function () {
            var dragableElements = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment");
            dragableElements.ejDraggable("destroy");
        },

        _getAppointmentByParentId: function (appId) {
            var tempApp, appoint, appList = this._currentAppointmentData;
            var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appId));
            var appoint = new ej.DataManager(appList).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, tempApp[0]["ParentId"]));
            return !$.isEmptyObject(appoint) ? appoint[0] : appoint;
        },

        _renderAppointmentAll: function () {
            if (this.element.children().length == 0) return false;
            if (this.currentView() == "agenda")
                this._renderAgendaContent();
            else {
                ej.preferredCulture(this.model.locale);
                this.element.find("div.e-appointwrapper,.e-alldayappointment,.e-scheduleAppGlassy").remove();
                this._currentViewAppointments = this._appointmentCount();
                if (this.currentView() != "month" && (!this._isCustomMonthView()) && this.model.timeScale.enable) {
                    if (this.model.orientation == "vertical") this._reRenderScroller();
                    this._renderAppointments();
                    if (this.model.showAppointmentNavigator) {
                        if (this.model.orientation == "vertical" && this.element.find(".e-vscroll").length > 0 && (!this._mediaQuery)) this._renderUpDownIconPosition();
                        this._nextPrevButton();
                    }
                }
                else
                    this._renderMonthAppointment();
                this._bindAppointmentAction();
                if (!this.model.showOverflowButton && this.model.orientation == "horizontal") {
                    var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                    this.element.find(".e-horires").css({ top: -restop + "px" });
                }
            }
        },

        _bindAppointmentAction: function () {
            this._unWireResizeEvents();
            this._wireResizeEvents();
            this._dragdropAppointments();
        },

        _renderBlockAppointments: function () {
            this.element.find(".e-blocktimewrapper").remove();
            if (!this.model.blockoutSettings.enable || this.model.blockoutSettings.dataSource instanceof ej.DataManager || this.currentView() == "agenda") return;
            this._processBlockApps();
            var dateCount = this.model.orientation == "horizontal" && this.currentView() == "month" ? $.extend(true, [], this.monthDays) : $.extend(true, [], this._dateRender);
            if (!this.model.group) this.res1 = ["0"];
            for (var res = 0; res < this.res1.length; res++) {
                var day = 0, diff, count = dateCount.length;
                if (new Date(dateCount[0]) < this.model.minDate)
                    day = Math.floor((new Date(this.model.minDate) - new Date(dateCount[0])) / (1000 * 60 * 60 * 24));
                if (new Date(dateCount[dateCount.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(dateCount[dateCount.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = dateCount.length - diff;
                }
                if (this._resWorkWeek) {
                    count = 0; day = 0; var temp = 0;
                    for (var a = 0; a < res + 1; a++) {
                        if (!ej.isNullOrUndefined(this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            if (a == res) temp += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count += this.model.workWeek.length;
                            if (a == res) temp += this.model.workWeek.length;
                        }
                        if (a == res) {
                            day = count - temp;
                            break;
                        }
                    }
                }
                for (day; day < count; day++) {
                    this._getBlockIntervals(day, res, dateCount);
                }
            }
        },

        _processBlockApps: function () {
            this._processedIntervals = [];
            var data = $.extend(true, [], this.model.blockoutSettings.dataSource);
            for (var app = 0; app < data.length; app++) {
                data[app] = this._processtimeZone(data[app]);
                if (new Date(new Date(data[app][this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(data[app][this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())
                    this._blockTimeSplit(data[app], new Date(data[app][this.model.blockoutSettings["startTime"]]), new Date(data[app][this.model.blockoutSettings["endTime"]]));
                else
                    this._processedIntervals.push(data[app]);
            }
        },

        _blockTimeSplit: function (app, startTime, endTime) {
            var start = (new Date(this._dateRender[0]) <= startTime) ? startTime : new Date(this._dateRender[0]);
            var end = new Date(new Date(endTime).getFullYear(), new Date(endTime).getMonth(), new Date(endTime).getDate(), 23, 59, 59);
            var next = 0, differDate, nextDay, day_start, day_end;
            while (start <= end) {
                differDate = 0; day_start = start;
                if (this.currentView() == "month" || this._isCustomMonthView() || (this.currentView() != "agenda" && this.currentView() != "day" && this.model.orientation == "horizontal")) {
                    if ((this.model.orientation == "horizontal" && this.currentView() == "month"))
                        differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
                    else if (this.currentView() == "customview" && (this._renderDays <= 7 || this.model.orientation == "horizontal")) {
                        start = (new Date(new Date(day_start).getFullYear(), new Date(day_start).getMonth(), new Date(day_start).getDate()));
                        if (this._dateRender.indexOf(start.getTime()) != -1)
                            differDate = (this._dateRender.length - 1) - this._dateRender.indexOf(start.getTime());
                        else
                            differDate = (start.getTime() < new Date(this._dateRender[0]).getTime()) ? ((new Date(new Date(this._dateRender[0]).setDate(new Date(this._dateRender[0]).getDate() - 1)).getTime() - new Date(start).setHours(0, 0, 0, 0)) / 3600000) / 24 : (start.getTime() > new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)) ? this._dateRender.length - 1 : 0;
                    }
                    else {
                        if (!this.model.showNextPrevMonth && this.currentView() == "month" && new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1).getTime() != new Date(start.getFullYear(), start.getMonth(), 1).getTime())
                            differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
                        else
                            differDate = 6 - day_start.getDay() + this._firstdayofweek;
                        if (this._firstdayofweek > day_start.getDay())
                            differDate = (6 - day_start.getDay()) - (7 - this._firstdayofweek);
                    }
                }
                nextDay = new Date(new Date(start).getFullYear(), new Date(start).getMonth(), new Date(start).getDate() + differDate);
                day_end = (new Date(nextDay).getDate() == new Date(endTime).getDate()) ? new Date(new Date(nextDay).setHours(endTime.getHours(), endTime.getMinutes(), endTime.getSeconds())) : new Date(new Date(nextDay).setHours(23, 59, 59));
                if (day_end >= new Date(endTime))
                    day_end = app[this.model.blockoutSettings["endTime"]];
                if (!this.model.showNextPrevMonth && this.currentView() == "month" && new Date(start.getFullYear(), start.getMonth(), 1).getTime() != new Date(day_end.getFullYear(), day_end.getMonth(), 1).getTime())
                    day_end = new Date(start.getFullYear(), start.getMonth() + 1, 0, day_end.getHours(), day_end.getMinutes(), day_end.getSeconds());
                var data = {};
                data[this.model.blockoutSettings["startTime"]] = day_start;
                data[this.model.blockoutSettings["endTime"]] = day_end;
                this._processedIntervals.push($.extend({}, app, data));
                next = (this.model.orientation == "horizontal" && this.currentView() == "workweek" && new Date(this._dateRender[0]).getDay() == 1 && new Date(this._dateRender[this._dateRender.length - 1]).getDay() == 5) ? 3 : 1;
                start = new Date(new Date(day_end).getFullYear(), new Date(day_end).getMonth(), new Date(day_end).getDate() + next);
                if (new Date(this._dateRender[this._dateRender.length - 1]) < start) {
                    break;
                }
            }
        },

        _getBlockIntervals: function (day, res, dateCount) {
            var appointmentsList = this._processedIntervals;
            var predicate2 = ej.Predicate(this.model.blockoutSettings["endTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day])).and(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(dateCount[day]).setHours(23, 59, 59)));
            var predicate1 = ej.Predicate(this.model.blockoutSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day])).and(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(dateCount[day]).setHours(23, 59, 59)));
            var predicate = predicate2["or"](predicate1);
            predicate = !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources ? predicate["and"](this.model.blockoutSettings.resourceId, ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
            appointmentsList = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(predicate));
            for (var app = 0; app < appointmentsList.length; app++) {
                if ((new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointmentsList[app][this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
            (new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
            (new Date(new Date(appointmentsList[app][this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                    if (this.currentView() == "month" || this._isCustomMonthView() || !this.model.timeScale.enable)
                        (appointmentsList[app][this.model.blockoutSettings["isAllDay"]]) && this._renderMonthBlockTime(appointmentsList[app], day, res);
                    else
                        this._renderBlockTime(appointmentsList[app], day, res);
                }
            }
        },

        _renderBlockTime: function (record, day, res) {
            var cellHeight = this.element.find(".e-workcells").outerHeight();
            var startHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.startHour) : 0;
            var endHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.endHour) : 24;
            var dateCount = this._getDateCount(res);
            var rStartTime = record[this.model.blockoutSettings["startTime"]];
            var rEndTime = record[this.model.blockoutSettings["endTime"]];
            rStartTime = new Date(rStartTime).getHours() < startHour ? new Date(new Date(rStartTime).setHours(startHour, rStartTime.getMinutes(), rStartTime.getSeconds())) : rStartTime;
            rEndTime = endHour <= rEndTime.getHours() ? new Date(new Date(rEndTime).setHours(endHour, 00, 00)) : rEndTime;
            var startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
            if (rStartTime <= rEndTime && (new Date(dateCount[0]).getTime() <= rStartTime.getTime() && new Date(new Date(dateCount[dateCount.length - 1]).setHours(23, 59, 59)) >= rStartTime.getTime())) {
                if (this.model.orientation == "vertical") {
                    var appWidth = "100%", appHeight, topPosition, leftPosition = 0;
                    appHeight = ((parseFloat(new Date(new Date(rEndTime).getTime()) - new Date(new Date(rStartTime).getTime()))) / (60 * 1000) * (cellHeight * this.model.timeScale.minorSlotCount) / (this.model.timeScale.majorSlot)) - 1;
                    topPosition = ((parseFloat((((new Date(rStartTime).getHours() * 60)) + new Date(rStartTime).getMinutes() + (new Date(rStartTime).getSeconds() / 60))) - parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - (this.model.startHour * 60)) * cellHeight * (this.model.timeScale.minorSlotCount / this.model.timeScale.majorSlot);
                    var timeCellhtml = this._generateBlockElement(record, appWidth, appHeight, topPosition, leftPosition);
                    if (this._resWorkWeek)
                        $(this.element.find("td.e-workcells")[((startTime * this.model.timeScale.minorSlotCount) * this.element.find(".e-headercells").length) + day]).append(timeCellhtml);
                    else
                        $(this.element.find("td.e-workcells")[parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * dateCount.length * this.res1.length + day + (dateCount.length * res)]).append(timeCellhtml);
                }
                else {
                    var newResCollection = this._horiGroupCollection(), appHeight = cellHeight, appWidth, topPosition = 0, leftPosition, groupIndex = 0;
                    if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) {
                        var templist = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, record[this.model.blockoutSettings.resourceId]));
                        groupIndex = this._findResourceIndex(newResCollection, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], templist[0][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]) + 1;
                    }
                    var resValue = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this._tempResource)) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId]) + 1 : 1;
                    var diffTime, diffDays, diffMinutes, cellIndex;
                    if (new Date(new Date(new Date(record[this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) < new Date(new Date(new Date(record[this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                        var endDiffer = (new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.endHour, 0, 0)) && new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0))) ? (((this.model.endHour) / 2) * 60) : ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
                        var startDiffer = new Date(rStartTime) > new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0)) ? (this.model.startHour * 60) : ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                        var i = 1, rEnd, rStart, end, start, diffTime;
                        rEnd = this._dateRender.indexOf(new Date(rEndTime).setHours(0, 0, 0, 0));
                        rStart = this._dateRender.indexOf(new Date(rStartTime).setHours(0, 0, 0, 0));
                        if (rEnd == -1) {
                            while (i < 7) {
                                if (new Date(this._dateRender[this._dateRender.length - i]).getTime() < new Date(rEndTime).setHours(0, 0, 0, 0)) {
                                    end = this._dateRender.length - i;
                                    endDiffer = this.model.endHour * 60;
                                    break;
                                }
                                else i++;
                            }
                        }
                        else
                            end = rEnd;
                        if (rStart == -1) {
                            start = day;
                            startDiffer = this.model.startHour * 60;
                        }
                        else
                            start = rStart;
                        diffTime = end - start;
                        diffMinutes = ((((diffTime) * ((endHour - startHour)) * 60) - startDiffer) + endDiffer);
                        cellIndex = (((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount) * (60 / this.model.timeScale.majorSlot) * day) + ((rStart == -1) ? 0 : startTime * this.model.timeScale.minorSlotCount) * (60 / this.model.timeScale.majorSlot);
                        appWidth = ((this.element.find(".e-workcells").outerWidth() / (30)) * diffMinutes) + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 2);
                        if (diffDays > this._dateRender.length) {
                            diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
                            diffMinutes = ((diffDays) * (endHour - startHour) * 60);
                            appWidth = diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.element.find(".e-workcells").width() + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 3);
                        }
                        leftPosition = (rStart == -1 ? 0 : parseFloat((new Date(rStartTime).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * this.model.timeScale.minorSlotCount / this.model.timeScale.majorSlot);
                    }
                    else {
                        leftPosition = (parseFloat((new Date(rStartTime).getMinutes() + (new Date(rStartTime).getMilliseconds() / 60))) * ($(this.element.find(".e-workcells")[1]).width() * this.model.timeScale.minorSlotCount) / this.model.timeScale.majorSlot) - 1;
                        diffMinutes = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) - ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes()) + 1;
                        appWidth = diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.element.find(".e-workcells").width() + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 2) + 1;
                        cellIndex = (((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount) * (60 / this.model.timeScale.majorSlot) * day) + (startTime * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot));
                    }
                    appWidth = appWidth + "px";
                    var timeCellhtml = this._generateBlockElement(record, appWidth, appHeight, topPosition, leftPosition);
                    $($(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find("td.e-workcells")[cellIndex]).append(timeCellhtml);
                }
            }
        },
        _generateBlockElement: function (record, appWidth, appHeight, topPosition, leftPosition) {
            var userTempId = (this.model.blockoutSettings.templateId) ? true : false;
            var userTempHtml = userTempId ? this._getUserTemplate(this.model.blockoutSettings.templateId, record) : "";
            var blockClass = record[this.model.blockoutSettings["isBlockAppointment"]] ? "e-blockenable" : '';
            var timeCellhtml = $(this.blockTimeTemplate.render({ id: record[this.model.blockoutSettings["id"]], subject: record[this.model.blockoutSettings["subject"]], appWidth: appWidth, appHeight: appHeight, left: leftPosition, top: topPosition, blockClass: blockClass, customStyle: record[this.model.blockoutSettings["customStyle"]], userTempId: userTempId, userTemplate: userTempHtml }));
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("blockAppointment", record, timeCellhtml);
            return timeCellhtml;
        },
        _renderMonthBlockTime: function (record, day, res) {
            var renderDate = (this.model.orientation == "vertical") ? this._dateRender : this.monthDays;
            var startTime = new Date(record[this.model.blockoutSettings["startTime"]]);
            var endTime = new Date(record[this.model.blockoutSettings["endTime"]]);
            var appWidth, appHeight, topPosition = 0, leftPosition = 0, userTempId, userTempHtml, blockClass, timeCellhtml, cellHeight;
            var cellWidth = this.model.orientation == "vertical" ? this.element.find(".e-monthcells").width() : this.element.find(".e-workcells").width();
            var start = new Date(startTime);
            var r_end = new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59));
            var end = new Date(endTime) > r_end ? r_end : new Date(endTime);
            var diffInDays = (start.getHours() == 0 && end.getHours() == 0) ? Math.ceil(((new Date(end) - new Date(start)) / (1000 * 3600)) / 24) : Math.ceil(((new Date(end).setHours(23, 59, 59) - new Date(start).setHours(0, 0, 0)) / (1000 * 3600)) / 24);
            if (startTime <= endTime) {
                if (this.model.orientation == "vertical") {
                    var maxDays = this._firstdayofweek == 0 ? 7 - (new Date(start).getDay()) : 7 - (new Date(start).getDay()) + this._firstdayofweek;
                    diffInDays = diffInDays >= maxDays ? maxDays : diffInDays;
                    var rowPosition = Math.ceil((day + 1) / 7);
                }
                appWidth = (diffInDays * cellWidth) + "px";
                var resIndex = (this._tempResource.length != 0 && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId]) : 0;
                var cellId = this.model.orientation == "vertical" ? ((resIndex * (7) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * 7)) - this._firstdayofweek) : day + 1;
                if (this.model.orientation == "vertical" && this._firstdayofweek != 0 && new Date(startTime).getDay() < this._firstdayofweek)
                    cellId = (resIndex * (7) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * 7)) - this._firstdayofweek + 7;
                if (this.model.orientation == "vertical")
                    cellHeight = $(this.element.find("td.e-monthcells")[cellId - 1]).closest("tr").find(".e-monthcells").outerHeight();
                else {
                    var newResCollection = this._horiGroupCollection(), groupIndex = 0;
                    if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) {
                        var templist = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, record[this.model.blockoutSettings.resourceId]));
                        groupIndex = this._findResourceIndex(newResCollection, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], templist[0][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]) + 1;
                    }
                    var resValue = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this._tempResource)) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId]) + 1 : 1;
                    cellHeight = $(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find(".e-workcells").height();
                }
                appHeight = cellHeight - this.element.find('.e-monthheader').height();
                var timeCellhtml = this._generateBlockElement(record, appWidth, appHeight, topPosition, leftPosition);
                if (this.model.orientation == "vertical")
                    $(this.element.find("td.e-monthcells")[cellId - 1]).append(timeCellhtml);
                else if (this.model.orientation == "horizontal" && ej.scheduleFeatures.horizontal)
                    $($(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find("td.e-workcells")[cellId - 1]).append(timeCellhtml);
            }
        },
        _checkAvailability: function (record) {
            if (this.model.blockoutSettings.enable) {
                var start = new Date(record[this._appointmentSettings["startTime"]]), end = new Date(record[this._appointmentSettings["endTime"]]), resId, available = [];
                if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                    resId = record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()];
                var predicate2 = ej.Predicate(this.model.blockoutSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, start).and(this.model.blockoutSettings["endTime"], ej.FilterOperators.greaterThanOrEqual, start).and(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThan, end);
                var predicate1 = ej.Predicate(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThanOrEqual, start).and(this.model.blockoutSettings["endTime"], ej.FilterOperators.greaterThan, start);
                var predicate = predicate2["or"](predicate1);
                predicate = !ej.isNullOrUndefined(resId) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources ? predicate["and"](this.model.blockoutSettings.resourceId, ej.FilterOperators.equal, resId) : predicate;
                predicate = predicate["and"](this.model.blockoutSettings["isBlockAppointment"], ej.FilterOperators.equal, true);
                available = new ej.DataManager(this._processedIntervals).executeLocal(new ej.Query().where(predicate));
                return available;
            }
            return [];
        },
        _alertBlockError: function () {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("BlockIntervalAlertTitle"));
            this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("BlockIntervalError"));
            this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
            this._alertWindow.ejDialog("open");
        },
        _getNewEndTime: function (newStartTime, hours, minutes) {
            var newEndTime = new Date(newStartTime);
            newEndTime.setMilliseconds(1000 * 60 * 60 * hours);
            return newEndTime;
        },

        _getNewStartTime: function (newTopTime, newStartTime) {
            newStartTime.setHours((newStartTime.getHours()) + parseInt(this.model.startHour) + parseInt(newTopTime / 60));
            newStartTime.setMinutes((newStartTime.getMinutes()) + parseInt(newTopTime % 60));
            newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / 10.0) * 10);
            return newStartTime;
        },

        _documentOnKeyDown: function (event) {
            if (this.model.allowKeyboardNavigation) {
                var oEl = event.target || document.activeElement || event.srcElement;
                if (event.which == 27) {
                    this._processEscapeKey();
                }
                else if (event.which == 13) {
                    this._processEnterKey(oEl);
                }
                else if (event.shiftKey == false && event.which == 9) {
                    this._processWindowTab(oEl);
                }
            }
        },

        _processWindowTab: function (oEl) {
            if ($(oEl).hasClass("e-qAppDone") && !ej.isNullOrUndefined(this._quickAppointWindow))
                this._quickAppointWindow.find(".subject").focus();
            else if (!ej.isNullOrUndefined(this._appointmentAddWindow) && ($(oEl).hasClass("e-appointcancel") || $(oEl).hasClass("e-cancelrecur")))
                this._appointmentAddWindow.find(".subject").focus();
            else if ($(oEl).hasClass("e-editseries") && !ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow)
                this._quickAppDetailsWindow.focus();
        },

        _onKeyDown: function (event) {
            if (this.model.allowKeyboardNavigation) {
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                var oRowCell = this.element.find('div.e-draggableworkarea tr');
                var oEl = event.target || document.activeElement || event.srcElement;
                $(oEl).hasClass("e-alldaycells") && (oRowCell = this.element.find(".e-alldaycells").parent());
                if (this._trigger("keyDown", { event: event })) return false;
                if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-alldaycells") || $(oEl).hasClass("e-monthcells")) {
                    this._getDateByElement($(oEl));
                    var curDate = this.curDate;
                    (event.which == 39) && curDate.setDate(curDate.getDate() + 1);
                    (event.which == 37) && curDate.setDate(curDate.getDate() - 1);
                    if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
                        this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                        if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-alldaycells") || $(oEl).hasClass("e-monthcells"))
                            $(oEl).addClass("e-selectedCell");
                        if (event.shiftKey == false && event.which == 38) { //up arrow navigation
                            this._stopDefaultAction(event);
                            this._processUpArrow(oEl, oRowCell);
                        }
                        else if (event.shiftKey == false && event.which == 40) { //down arrow for cell navigation
                            this._stopDefaultAction(event);
                            this._processDown(oEl, oRowCell);
                        }
                        else if (event.ctrlKey == false && event.shiftKey == false && event.which == 39) { //right arrow cell navigation
                            this._stopDefaultAction(event);
                            this._processRight(oEl, oRowCell);
                        }
                        else if (event.ctrlKey == false && event.shiftKey == false && event.which == 37) { //left arrow cell navigation
                            this._stopDefaultAction(event);
                            this._processLeft(oEl, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 38) { //shift + up arrow
                            this._stopDefaultAction(event);
                            this._processShiftUp(oEl, event, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 40) { //shift + down arrow
                            this._stopDefaultAction(event);
                            this._processShiftDown(oEl, event, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 37) { //shift+left
                            this._stopDefaultAction(event);
                            this._processShiftLeft(oEl, event, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 39) { //shift+right
                            this._stopDefaultAction(event);
                            this._processShiftRight(oEl, event, oRowCell);
                        }
                    }
                }
                else if (this.currentView() == "agenda" && $(oEl).hasClass("e-agendacells")) {
                    this._stopDefaultAction(event);
                    if (event.which == 38 || event.which == 40) {
                        this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                        var rowcount = oRowCell.length - 1;
                        var currrowindex = this.element.find(".e-selectedCell").parent().index();
                        var newcur = (event.which == 38) ? parseInt(currrowindex) - 1 : parseInt(currrowindex) + 1;
                        if (newcur >= 0 && newcur <= rowcount && currrowindex != "undefined") {
                            $(oRowCell).find(".e-eventcolumn,.e-timecolumn").removeClass("e-selectedCell");
                            $(oRowCell[newcur]).find(".e-eventcolumn,.e-timecolumn").addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                }
                if (event.altKey == true && event.which == 67) { //Alt+C To show/hide the calendar pane
                    this._stopDefaultAction(event);
                    this.element.find(".e-datedisplay").click();
                }
                else if (event.ctrlKey == true && event.which == 37) { //Previous button
                    this._stopDefaultAction(event);
                    this.element.find("div.e-navigateprevious").click();
                    this.element.find('div.e-navigateprevious').attr("tabIndex", 0).focus();
                    this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                }
                else if (event.ctrlKey == true && event.which == 39) { //Next button
                    this._stopDefaultAction(event);
                    this.element.find("div.e-navigatenext").click();
                    this.element.find('div.e-navigatenext').attr("tabIndex", 0).focus();
                    this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                }
                else if ((event.altKey == true && event.which == 107) || (event.altKey == true && event.which == 187) || (event.altKey == true && event.which == 61)) { //Alt + "+" to navigate through the toolbar items
                    this._stopDefaultAction(event);
                    this._navigateToolbarRight(event);
                }
                else if ((event.altKey == true && event.which == 189) || (event.altKey == true && event.which == 109) || (event.altKey == true && event.which == 45) || (event.altKey == true && event.which == 173)) { // Alt + "-" to navigate back through the toolbar items
                    this._stopDefaultAction(event);
                    this._navigateToolbarLeft(event);
                }
                else if (event.ctrlKey == true && event.which == 67) { //Cancel Ctrl+C
                    this._stopDefaultAction(event);
                    this._cancel();
                }
                else if (event.which == 32) { //spacebar
                    if ($(document.activeElement)[0] === this.element.find("div.e-navigateprevious")[0]) {
                        this._stopDefaultAction(event);
                        this.element.find("div.e-navigateprevious").click();
                        this.element.find('div.e-navigateprevious').attr("tabIndex", 0).focus();
                        this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                    }
                    else if ($(document.activeElement)[0] === this.element.find("div.e-navigatenext")[0]) {
                        this._stopDefaultAction(event);
                        this.element.find("div.e-navigatenext").click();
                        this.element.find('div.e-navigatenext').attr("tabIndex", 0).focus();
                        this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                    }
                }
                else if (event.altKey == true && event.which == 78) { //New appointment window
                    this._stopDefaultAction(event);
                    this.currentView() != "agenda" && this._newAppWindow(oEl, oRowCell);
                    this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                }
                else if (event.ctrlKey == true && event.which == 69) { //(E)Edit appointment window
                    this._stopDefaultAction(event);
                    var elmt = this.element.find(".e-selectedAppointment");
                    if (this.currentView() == "agenda" && this.element.find('.e-selectedCell').length > 0) {
                        selCell = this.element.find(".e-selectedCell").parent().find(".e-agendaappointment");
                        selCell.hasClass("e-agendaappointment") && (elmt = selCell);
                    }
                    if (elmt.length > 0) {
                        this._editKey = true;
                        this._cellClick = false;
                        this._appointmentWindow(elmt);
                        this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                    }
                }
                else if (event.which == 46) { //Delete
                    this._stopDefaultAction(event);
                    var delap = this.element.find('.e-selectedAppointment');
                    if (this.currentView() == "agenda" && this.element.find('.e-selectedCell').length > 0) {
                        var selCell = this.element.find(".e-selectedCell").parent().find(".e-agendaappointment");
                        selCell.hasClass("e-agendaappointment") && (delap = selCell);
                    }
                    if (delap.length > 0) {
                        this._appUid = delap.attr('guid');
                        this._deleteAppoint();
                    }
                }
                else if (event.shiftKey == true && event.which == 9) { //Shift + tab for reverse navigation of appointments
                    this._stopDefaultAction(event);
                    this._reverseTab(oEl, event, oRowCell);
                    this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                }
                else if (event.shiftKey == false && event.which == 9) { // For tab navigation of appointments
                    this._stopDefaultAction(event);
                    this._processTab(oEl, event, oRowCell);
                    this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                }
                var proxy = this;
                this.currentView() != "agenda" && this._moveScrollContent(oEl, proxy);
            }
        },

        _processShiftUp: function (oEl, event, oRowCell) {
            if (this.model.orientation == "horizontal") return false;
            if ($(oEl).hasClass('e-workcells')) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    var newcur = parseInt(currrowindex) - 1;
                    if (newcur >= 0) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            $(oRowCell[newcur].cells[currcolindex]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                        else {
                            $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell");
                            $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                    this._currentRowIndex = newcur;
                    this._currentColIndex = currcolindex;
                }
                else {
                    $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = currrowindex;
                    this._currentColIndex = currcolindex;
                }

            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resourceIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, resmaxcolindex = 7 * (resourceIndex + 1), mincolindex = 7 * (parseInt(resourceIndex));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    var newcur = parseInt(currrowindex) - 1;
                    if (newcur >= 0) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            for (var i = currcolindex; i >= mincolindex; i--) {
                                $(oRowCell[currrowindex].cells[i]).attr("tabIndex", 0).focus();
                                $(oRowCell[currrowindex].cells[i]).removeClass("e-selectedCell");
                            }
                            for (var j = resmaxcolindex - 1; j >= currcolindex; j--) {
                                if (newcur >= 0) {
                                    $(oRowCell[newcur].cells[j]).attr("tabIndex", 0).focus();
                                    $(oRowCell[newcur].cells[j]).removeClass("e-selectedCell");
                                }
                            }
                            !$(oRowCell[newcur].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        else {
                            for (var i = currcolindex; i >= mincolindex; i--)
                                $(oRowCell[currrowindex].cells[i]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            for (var j = resmaxcolindex - 1; j >= currcolindex; j--) {
                                if (newcur >= 0)
                                    !$(oRowCell[newcur].cells[j]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            }
                        }
                    }
                    else
                        $(oRowCell[newcur + 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            else
                return false;

        },

        _processShiftDown: function (oEl, event, oRowCell) {
            if (this.model.orientation == "horizontal") return false;
            if ($(oEl).hasClass('e-workcells')) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    var newcur = parseInt(currrowindex) + 1;
                    if (newcur <= rowcount) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            $(oRowCell[newcur].cells[currcolindex]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                        else {
                            $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell");
                            $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        this._currentRowIndex = newcur;
                        this._currentColIndex = currcolindex;
                    }
                    else {
                        $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                        this._currentRowIndex = currrowindex;
                        this._currentColIndex = currcolindex;
                    }

                }
            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resourceIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, resmaxcolindex = 7 * (resourceIndex + 1), mincolindex = 7 * (parseInt(resourceIndex));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    var newcur = parseInt(currrowindex) + 1;
                    if (newcur < (this._dateRender.length) / 7) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            for (var i = currcolindex; i <= resmaxcolindex - 1; i++) {
                                $(oRowCell[currrowindex].cells[i]).attr("tabIndex", 0).focus();
                                $(oRowCell[currrowindex].cells[i]).removeClass("e-selectedCell");
                            }
                            for (var j = mincolindex; j <= currcolindex; j++) {
                                if (newcur < (this._dateRender.length) / 7) {
                                    $(oRowCell[newcur].cells[j]).attr("tabIndex", 0).focus();
                                    $(oRowCell[newcur].cells[j]).removeClass("e-selectedCell");
                                }
                            }
                            !$(oRowCell[newcur].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell");
                        }
                        else {
                            for (var i = currcolindex; i <= resmaxcolindex - 1; i++)
                                !$(oRowCell[currrowindex].cells[i]).hasClass("e-othermonths") && $(oRowCell[currrowindex].cells[i]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            for (var j = mincolindex; j <= currcolindex; j++) {
                                if (newcur < (this._dateRender.length) / 7)
                                    !$(oRowCell[newcur].cells[j]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            }
                        }
                    }
                    else
                        $(oRowCell[newcur - 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            else
                return false;
        },

        _processShiftLeft: function (oEl, event, oRowCell) {
            var rowcount = oRowCell.length - 1;
            if ($(oEl).hasClass('e-workcells')) {
                var targetElement = oEl;
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var viewCount = this.model.orientation == "vertical" ? count : this.currentView() == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot);
                var resIndex = Math.floor($(targetElement).index() / viewCount);
                var resmaxcolindex = (viewCount * resIndex);
                var currColInx = $(targetElement)[0].cellIndex;
                var currRowInx = $(targetElement).parent()[0].rowIndex;
                var leftColInx = currColInx - 1;
                var irowcount = this.model.orientation == "vertical" ? 0 : currRowInx;
                var Hrowcount = this.model.orientation == "vertical" ? rowcount : currRowInx;
                var flag = this.model.orientation == "vertical" && this.model.showAllDayRow ? true : false;
                var ad = this.element.find(".e-alldaycells").parent();
                if (currColInx > 0 && leftColInx > parseInt(resmaxcolindex) - 1 && currColInx != "undefined") {
                    if ($(oRowCell[currRowInx].cells[leftColInx]).hasClass("e-selectedCell")) {
                        for (var i = irowcount; i <= parseInt(currRowInx) ; i++)
                            $(oRowCell[i].cells[currColInx]).removeClass("e-selectedCell");
                        for (var j = Hrowcount; j >= parseInt(currRowInx) ; j--)
                            $(oRowCell[j].cells[leftColInx]).removeClass("e-selectedCell");
                        flag && $(ad[0].cells[currColInx]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                        $(oRowCell[currRowInx].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else {
                        for (var i = irowcount; i <= parseInt(currRowInx) ; i++)
                            $(oRowCell[i].cells[currColInx]).addClass("e-selectedCell");
                        for (var j = Hrowcount; j >= parseInt(currRowInx) ; j--)
                            $(oRowCell[j].cells[leftColInx]).addClass("e-selectedCell");
                        if (flag) {
                            $(ad[0].cells[currColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            $(ad[0].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        $(oRowCell[currRowInx].cells[leftColInx]).attr("tabIndex", 0).focus();
                    }
                    this._currentRowIndex = currRowInx;
                    this._currentColIndex = leftColInx;
                }
                else {
                    $(oRowCell[currRowInx].cells[leftColInx + 1]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = currRowInx;
                    this._currentColIndex = leftColInx + 1;
                }
            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = 7 * (parseInt(resIndex) + 1);
                var mincolindex = 7 * (parseInt(resIndex));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currcolindex >= mincolindex && currcolindex <= mcolind && currcolindex != "undefined") {
                    newcur = parseInt(currcolindex) - 1;
                    if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                        if (currcolindex == mincolindex && currrowindex >= 1) {
                            var newrow = parseInt(currrowindex) - 1;
                            var newcol = parseInt(mcolind) - 1;
                            if (newrow >= 0) {
                                $(oRowCell[newrow].cells[newcol]).attr("tabIndex", 0).focus();
                                $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell");
                                $(oRowCell[currrowindex].cells[mincolindex]).removeClass("e-selectedClass");
                            }
                        }
                        else if (currcolindex < mcolind) {
                            newcur = parseInt(currcolindex) - 1;
                            $(oRowCell[currrowindex].cells[newcur]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                    }
                    else {
                        if (currcolindex == mincolindex && currrowindex >= 0) {
                            var newrow = parseInt(currrowindex) - 1;
                            var newcol = parseInt(mcolind) - 1;
                            if (newrow >= 0)
                                !$(oRowCell[newrow].cells[newcol]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[newcol]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            else
                                $(oRowCell[newrow + 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                        }
                        else if (currcolindex < mcolind) {
                            newcur = parseInt(currcolindex) - 1;
                            !$(oRowCell[currrowindex].cells[newcur]).hasClass("e-othermonths") && $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass('e-alldaycells')) {
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var resIndex = Math.floor($(oEl).index() / count);
                var resmaxcolindex = (count * resIndex);
                var currColInx = $(oEl)[0].cellIndex;
                var leftColInx = currColInx - 1;
                if (currColInx > 0 && leftColInx > parseInt(resmaxcolindex) - 1 && currColInx != "undefined") {
                    if ($(oRowCell[0].cells[leftColInx]).hasClass("e-selectedCell")) {
                        $(oRowCell[0].cells[currColInx]).removeClass("e-selectedCell");
                        $(oRowCell[0].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._currentRowIndex = 0;
                    this._currentColIndex = leftColInx;
                }
                else {
                    $(oRowCell[0].cells[leftColInx + 1]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = 0;
                    this._currentColIndex = leftColInx + 1;
                }
            }
            else
                return false;
        },

        _processShiftRight: function (oEl, event, oRowCell) {
            if ($(oEl).hasClass('e-workcells')) {
                var rowcount = oRowCell.length - 1;
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var viewCount = this.model.orientation == "vertical" ? count : this.currentView() == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot);
                var resIndex = Math.floor($(oEl).index() / viewCount);
                var resmaxcolindex = (viewCount * (resIndex + 1));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                var irowcount = this.model.orientation == "vertical" ? 0 : currrowindex;
                var Hrowcount = this.model.orientation == "vertical" ? rowcount : currrowindex;
                var ad = this.element.find(".e-alldaycells").parent();
                var flag = this.model.orientation == "vertical" && this.model.showAllDayRow ? true : false;
                if (currcolindex >= 0 && currcolindex < parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                    if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                        for (var i = parseInt(currrowindex) ; i <= Hrowcount; i++)
                            $(oRowCell[i].cells[currcolindex]).removeClass("e-selectedCell");
                        for (var j = irowcount; j <= currrowindex; j++)
                            $(oRowCell[j].cells[newcur]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                        flag && $(ad[0].cells[currcolindex]).removeClass("e-selectedCell");
                        $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell");
                    }
                    else {
                        for (var i = parseInt(currrowindex) ; i <= Hrowcount; i++)
                            $(oRowCell[i].cells[currcolindex]).addClass("e-selectedCell");
                        for (var j = irowcount; j <= currrowindex; j++)
                            $(oRowCell[j].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        if (flag) {
                            $(ad[0].cells[newcur]).addClass("e-selectedCell");
                            $(ad[0].cells[currcolindex]).addClass("e-selectedCell");
                        }
                    }
                    this._currentRowIndex = currrowindex;
                    this._currentColIndex = newcur;
                }
                else
                    $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = resmaxcolindex = 7 * (parseInt(resIndex) + 1), mincolindex = 7 * (parseInt(resIndex));;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (currcolindex >= 0 && currcolindex <= parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                    if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                        if (newcur < mcolind) {
                            $(oRowCell[currrowindex].cells[newcur]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                        if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                            var newrow = parseInt(currrowindex) + 1;
                            currcolindex = mincolindex;
                            if (newrow < (this._dateRender.length) / 7) {
                                !$(oRowCell[newrow].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                                if (newcur < mcolind) {
                                    $(oRowCell[newrow].cells[newcur]).attr("tabIndex", 0).focus();
                                    $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell");
                                }
                            }
                        }
                    }
                    else {
                        if (newcur < mcolind)
                            !$(oRowCell[currrowindex].cells[newcur]).hasClass("e-othermonths") && $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                            var newrow = parseInt(currrowindex) + 1;
                            currcolindex = mincolindex;
                            if (newrow < (this._dateRender.length) / 7) {
                                $(oRowCell[newrow].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                if (newcur < mcolind)
                                    $(oRowCell[newrow].cells[newcur]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            }
                            else
                                $(oRowCell[newrow - 1].cells[newcur - 1]).attr("tabIndex", 0).focus();
                        }
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass('e-alldaycells')) {
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var resIndex = Math.floor($(oEl).index() / count);
                var resmaxcolindex = (count * (resIndex + 1));
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (currcolindex >= 0 && currcolindex < parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                    if ($(oRowCell[0].cells[newcur]).hasClass("e-selectedCell")) {
                        $(oRowCell[0].cells[currcolindex]).removeClass("e-selectedCell");
                        $(oRowCell[0].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._currentRowIndex = 0;
                    this._currentColIndex = newcur;
                }
                else
                    $(oRowCell[0].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
            else
                return false;
        },

        _processEnterKey: function (oEl) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-monthcells") || $(oEl).hasClass("e-alldaycells")) {
                var tds = this.element.find('td.e-selectedCell');
                var nt = tds.length - 1;
                if (nt == 0) {
                    this._cellSelection(oEl);
                }
                else {
                    this._multipleCellAppointCreation(oEl);
                }
            }
            else if ($(oEl).hasClass("e-detailedapp e-detailedwindow")) {
                this._appointmentWindow(oEl);
            }
            else if ($(oEl).parent().hasClass("e-allday")) {
                var e = this._appointmentAddWindow.find("#" + this._id + "allday").ejCheckBox("option", "checked");
                var checkedVal = e ? false : true;
                this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: checkedVal });
            }
            else if ($(oEl).parent().hasClass("e-recurrence")) {
                var e = this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox("option", "checked");
                var checkedVal = e ? false : true;
                this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: checkedVal });
                this._recurChecked = checkedVal ? true : false;
                this._repeat(oEl);
            }
            else if ($(oEl).hasClass("e-scheduledelete")) {
                this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-scheduledelete').click();
            }
            else if ($(oEl).hasClass("e-editevent"))
                this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-editevent').click();
            else if ($(oEl).hasClass(".e-editseries"))
                this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-editseries').click();
            else if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment"))
                this._cellSelection(oEl);
            else if ($(oEl).parent().hasClass("e-weekday")) {
                var e = this._appointmentAddWindow.find("#" + $(oEl).children()[0].id).ejCheckBox("option", "checked");
                var checkedVal = e ? false : true;
                this._appointmentAddWindow.find("#" + $(oEl).children()[0].id).ejCheckBox({ checked: checkedVal });
            }
        },

        _findMinMaxCellIndex: function () {
            var oRowCell = this.element.find('div.e-draggableworkarea tr');
            var rowcount = oRowCell.length - 1;
            var omincolIndex, omaxcolIndex, rowInx, maxrowInx, checkcolindex;
            var curr_View = this.currentView();
            var viewCount = curr_View == "day" ? 1 : curr_View == "workweek" ? this.model.workWeek.length : 7;
            var proxy = this;
            this.element.find('td.e-selectedCell').each(function (index, tdItem) {
                var targetId = $(tdItem).index();
                if (targetId != null && !isNaN(targetId)) {
                    if (omincolIndex == null) {
                        omincolIndex = targetId;
                        rowInx = $(tdItem).parent()[0].rowIndex;
                    }
                    else if (omincolIndex < targetId) {
                        omincolIndex = omincolIndex;
                    }
                    else {
                        if (omincolIndex != targetId) {
                            omincolIndex = targetId;
                            rowInx = $(tdItem).parent()[0].rowIndex;
                        }
                    }
                    if (curr_View != "month") {
                        for (var i = 0; i <= rowcount; i++) {
                            if ($(oRowCell[i].cells[omincolIndex]).hasClass("e-selectedCell")) {
                                rowInx = i;
                                break;
                            }
                        }
                    }
                    if (omaxcolIndex == null) {
                        omaxcolIndex = targetId;
                        if (curr_View != "month") {
                            checkcolindex = parseInt(omaxcolIndex);
                            for (var i = 0; i <= rowcount; i++) {
                                if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                    maxrowInx = i;

                                }
                            }
                        }
                    }
                    else if (omaxcolIndex > targetId) {
                        omaxcolIndex = omaxcolIndex;
                    }
                    else {
                        if (omaxcolIndex != targetId) {
                            omaxcolIndex = targetId;
                            if (curr_View != "month") {
                                checkcolindex = parseInt(omaxcolIndex);
                                for (var i = 0; i <= rowcount; i++) {
                                    if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                        maxrowInx = i;
                                    }
                                }
                            }
                        }
                    }
                }
            });
            var _minMaxIndexes = { rowInx: rowInx, maxrowInx: maxrowInx, omincolIndex: omincolIndex, omaxcolIndex: omaxcolIndex };
            return _minMaxIndexes;
        },

        _multipleCellAppointCreation: function (e) {
            if (ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._renderQuickWindow();
            var target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e); this._multiple = true;
            this._slotByCellSelect(target);
            if (this.model.showQuickWindow && e.type !== "beforeOpen") {
                this._quickAppointWindow.find("#" + this._id + "_quickAppwindow").css("display", "block");
                if (new Date(new Date(this.cur_StartTime).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(this.cur_EndTime).setHours(0, 0, 0, 0)).getTime())
                    this._quickAppointWindow.find('.e-quickstartend').html(this._dayFullNames[new Date(this.cur_StartTime).getDay()] + ", " + ej.format(new Date(this.cur_StartTime), "MMMM", this.model.locale) + " " + new Date(this.cur_StartTime).getDate() + ", " + ej.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale) + " - " + ej.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale));
                else
                    this._quickAppointWindow.find('.e-quickstartend').html(this._dayFullNames[new Date(this.cur_StartTime).getDay()] + ", " + ej.format(new Date(this.cur_StartTime), "MMMM", this.model.locale) + " " + new Date(this.cur_StartTime).getDate() + ", " + ej.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale) + " - " + this._dayFullNames[new Date(this.cur_EndTime).getDay()] + ", " + ej.format(new Date(this.cur_EndTime), "MMMM", this.model.locale) + " " + new Date(this.cur_EndTime).getDate() + ", " + ej.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale));
                this._quickAppointWindow.find('.subject').val("");
                if (!this.model.readOnly)
                    this._quickAppointWindow.ejDialog("open");
                var x = $(target).offset().left - ((this._quickAppointWindow.width() - $(target).width()) / 2) + 10;
                var y = $(target).offset().top - this._quickAppointWindow.height() - 10;
                var xy = this._quickWindowPosition(x, y, $(target), this._quickAppointWindow);
                this._quickAppointWindow.ejDialog({ position: { X: xy["X"], Y: xy["Y"] } });
                this._quickAppointWindow.find(".subject").focus();
                if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                    this._getResourceDetails($(target));
            }
            this._cellClick = true;

        },
        _slotByCellSelect: function (target) {
            var noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
            this._cellIndex = $(target).hasClass("e-workcells") ? $(target).index() : $(target).hasClass("e-alldaycells") ? $(target).index() : noOfDays - ((parseInt($(target).index() / noOfDays) + 1) * noOfDays - $(target).index()) + ($(target).parent().index() * noOfDays);
            if (this.model.orientation == "horizontal") {
                this._cellIndex = this.currentView() !== "month" ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount)) : this._cellIndex;
                this._workCellIndex = $(target).parent().index();
            }
            var indexes = this._findMinMaxCellIndex();
            var renderDates = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : this.model.orientation == "vertical" ? this.dateRender : this._dateRender;
            var omincolIndex = indexes.omincolIndex, omaxcolIndex = indexes.omaxcolIndex, rowInx = indexes.rowInx, maxrowInx = indexes.maxrowInx;
            var minStartDate = renderDates[omincolIndex]; var maxEndDate = renderDates[omaxcolIndex];
            if (this.model.orientation == "vertical") {
                if ($(target).hasClass("e-workcells")) {
                    var cellmins = this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount;
                    var minStartTime = (this.model.startHour * 3600000) + (rowInx * cellmins * 60 * 1000);
                    var maxEndTime = ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot) - 1) == maxrowInx ? (this.model.startHour * 3600000) + ((maxrowInx + 1) * cellmins * 60 * 1000) - 1 : (this.model.startHour * 3600000) + ((maxrowInx + 1) * cellmins * 60 * 1000);
                    this.cur_StartTime = new Date(new Date(minStartDate).setMilliseconds(minStartTime));
                    this.cur_EndTime = new Date(new Date(maxEndDate).setMilliseconds(maxEndTime));
                }
                else if ($(target).hasClass("e-monthcells")) {
                    var selCell = this.element.find('td.e-selectedCell');
                    var nsc = selCell.length - 1;
                    var startIndex = ($(selCell[0]).parent().index() * noOfDays) + ($(selCell[0]).index() - (Math.floor($(selCell[0]).index() / noOfDays) * noOfDays));
                    var endIndex = ($(selCell[nsc]).parent().index() * noOfDays) + ($(selCell[nsc]).index() - (Math.floor($(selCell[nsc]).index() / noOfDays) * noOfDays));
                    var startDate = new Date(this._dateRender[startIndex]);
                    var endDate = new Date(this._dateRender[endIndex]);
                    this.cur_StartTime = new Date(startDate.setHours(0, 0, 0));
                    this.cur_EndTime = new Date(endDate.setHours(23, 59, 59));
                }
                else if ($(target).hasClass("e-alldaycells")) {
                    this.cur_StartTime = new Date(minStartDate);
                    this.cur_EndTime = new Date(new Date(maxEndDate).setHours(23, 59, 59));
                }
            }
            else {
                if (this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable) {
                    var minStartDate = renderDates[parseInt(omincolIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))];
                    var maxEndDate = renderDates[parseInt(omaxcolIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))];
                    var minVal = (omincolIndex % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    var minStartTime = ((this.model.startHour) + (minVal / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    var maxVal = (omaxcolIndex % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    var maxEndTime = ((this.model.startHour) + (maxVal / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    this.cur_StartTime = new Date(minStartDate).setMinutes(minStartTime * 60);
                    this.cur_EndTime = new Date(maxEndDate).setMinutes(maxEndTime * 60);
                    this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(new Date(this.cur_EndTime).getMinutes() + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)));
                }
                else {
                    var minStartDate = this.totdays[omincolIndex]; var maxEndDate = this.totdays[omaxcolIndex];
                    this.cur_StartTime = new Date(minStartDate);
                    this.cur_EndTime = new Date(new Date(maxEndDate).setHours(23, 59, 59));
                }
            }
        },

        _addCellSelection: function (oRowCell) {
            var tds = this.element.find('td.e-selectedCell');
            var nt = tds.length - 1;
            if (nt > 0) {
                this.element.find('td.e-selectedCell').removeClass("e-selectedCell");
                $(oRowCell[this._currentRowIndex].cells[this._currentColIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        },

        _processUpArrow: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            var allda = this.element.find(".e-alldaycells");
            if ($(oEl).hasClass("e-workcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) - 1;
                if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    if ($(oRowCell[currrowindex - 1].cells[currcolindex]).hasClass("e-resourceheadercells")) return false;
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (currrowindex == 0) {
                    if (this.model.orientation == "vertical") {
                        var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                        var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(this.element).attr("tabIndex", 0).focus();
                        $(allda[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                return false;
            }

            else if ($(oEl).hasClass("e-monthcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) - 1;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    if (newcur >= 0) {
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
                }
                else
                    return false;
            }
            else
                return false;

        },

        _processDown: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            if ($(oEl).hasClass("e-workcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) + 1;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    if (newcur <= rowcount) {
                        if ($(oRowCell[currrowindex + 1].cells[currcolindex]).hasClass("e-resourceheadercells")) return false;
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                }
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
                var allda = this.element.find(".e-alldaycells");
                $(allda[allDayInx]).removeClass("e-selectedCell").blur();
                $(this.element.find(".e-workcells")[allDayInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }

            else if ($(oEl).hasClass("e-monthcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) + 1;
                if (currrowindex >= 0 && currrowindex < rowcount && currrowindex != "undefined") {
                    if (newcur <= 7) {
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[newcur - 1].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
            }
            else
                return false;
        },

        _processRight: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            if ($(oEl).hasClass("e-workcells")) {
                var maxcolindex = oRowCell[0].cells.length;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (currcolindex >= 0 && currcolindex < parseInt(maxcolindex) - 1 && currcolindex != "undefined") {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (currcolindex == parseInt(maxcolindex) - 1) {
                    if (this.currentView() != "month") {
                        var maxrowInx1 = $(oEl).parent()[0].rowIndex;
                        this.element.find("div.e-navigatenext").click();
                        $(oRowCell[maxrowInx1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    } else {
                        this.element.find("div.e-navigatenext").click();
                        $(this.element.find('div.e-draggableworkarea tr')[currrowindex].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass("e-monthcells")) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = resmaxcolindex = 7 * (parseInt(resIndex) + 1), mincolindex = 7 * (parseInt(resIndex));;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (newcur < mcolind) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    var newrow = parseInt(currrowindex) + 1;
                    currcolindex = mincolindex;
                    if (newrow < (this._dateRender.length) / 7) {
                        $(oRowCell[newrow].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        if (newcur < mcolind) {
                            $(oRowCell[newrow].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                    else {
                        var previndex = currcolindex / 7;
                        this.element.find("div.e-navigatenext").click();
                        var index = (!ej.isNullOrUndefined(this.model.group) ? previndex * 7 : 0);
                        $(this.element.find(".e-monthcells")[index]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
                var nall = parseInt(this.element.find(".e-alldaycells").length) - 1;
                if (allDayInx >= 0 && allDayInx < nall) {
                    $(this.element.find(".e-alldaycells")[allDayInx]).removeClass("e-selectedCell").blur();
                    $(this.element.find(".e-alldaycells")[parseInt(allDayInx) + 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (allDayInx == nall) {
                    this.element.find("div.e-navigatenext").click();
                    $(this.element.find(".e-alldaycells")[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            this._keyPressed = true;
        },

        _processLeft: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            if ($(oEl).hasClass("e-workcells")) {
                var maxcolindex = oRowCell[0].cells.length;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currcolindex) - 1;
                if (currcolindex > 0 && currcolindex <= parseInt(maxcolindex) - 1 && currcolindex != "undefined") {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (currcolindex == 0) {
                    if (this.currentView() != "month") {
                        var maxrowInx1 = $(oEl).parent()[0].rowIndex;
                        this.element.find("div.e-navigateprevious").click();
                        $(oRowCell[maxrowInx1].cells[maxcolindex - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else {
                        this.element.find("div.e-navigateprevious").click();
                        $(this.element.find('div.e-draggableworkarea tr')[currrowindex].cells[this.totdays.length - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass("e-monthcells")) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = 7 * (parseInt(resIndex) + 1);
                var mincolindex = 7 * (parseInt(resIndex));
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var colIndex = this.model.orientation == "vertical" ? count : this.currentView() == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
                maxcolindex = ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) && this.model.orientation == "vertical" ? this.render_Resources[this.render_Resources.length - 1].length * colIndex : colIndex;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;

                if (currcolindex == mincolindex && currrowindex >= 0) {
                    var newrow = parseInt(currrowindex) - 1;
                    var newcol = parseInt(mcolind) - 1;
                    if (newrow >= 0) {
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newrow].cells[newcol]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else {
                        var previndex = currcolindex / 7;
                        this.element.find("div.e-navigateprevious").click();
                        var rowmax = this._dateRender.length / 7;
                        var index = (!ej.isNullOrUndefined(this.model.group) ? previndex * 7 : 0);
                        $(this.element.find('div.e-draggableworkarea tr')[rowmax - 1].cells[index + 6]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else if (currcolindex < mcolind) {
                    newcur = parseInt(currcolindex) - 1;
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
                var nall = parseInt(this.element.find(".e-alldaycells").length) - 1;
                if (allDayInx > 0 && allDayInx <= nall) {
                    $(this.element.find(".e-alldaycells")[allDayInx]).removeClass("e-selectedCell").blur();
                    $(this.element.find(".e-alldaycells")[parseInt(allDayInx) - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (allDayInx == 0) {
                    this.element.find("div.e-navigateprevious").click();
                    $(this.element.find(".e-alldaycells")[nall]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            this._keyPressed = true;
        },

        _selectCurrentMonth: function (oRowCell, currrowindex, currcolindex) {
            if (oRowCell.find(".e-selectedCell").hasClass("e-othermonths")) {
                oRowCell.find(".e-selectedCell").removeClass("e-selectedCell").blur();
                $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        },

        _navigateToolbarRight: function (event) {
            var views = this.model.views;
            var curViewIndex = this.element.find(".e-commonviewbutton.e-" + this.currentView()).parent().index();
            if (curViewIndex < views.length - 1) {
                var newView = views[curViewIndex + 1].toLowerCase(); this._navView = true;
                this._viewChange(event, this.currentView(), newView);
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
        },

        _navigateToolbarLeft: function (event) {
            var curViewIndex = this.element.find(".e-commonviewbutton.e-" + this.currentView()).parent().index();
            if (curViewIndex > 0) {
                var newView = this.model.views[curViewIndex - 1].toLowerCase(); this._navView = true;
                this._viewChange(event, this.currentView(), newView);
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
        },

        _newAppWindow: function (contextElement, oRowCell) {
            if ($(contextElement).hasClass("e-selectedCell")) {
                if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                this._currentAction = ej.Schedule.Actions.Add;
                var targetElement = contextElement == null ? event : contextElement;
                var rowIndex = $(targetElement).parent().index();
                var columnIndex = $(targetElement).index();
                var resourceIndex = 0;
                var renderDates = (this.model.orientation == "horizontal" && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" || this.currentView() == "customview" && this._dateRender.length <= 7) ? this.dateRender : this._dateRender;
                renderDates = this.model.orientation == "horizontal" && this.currentView() == "customview" && this._dateRender.length <= 7 ? this._dateRender : renderDates;
                var ns = parseInt(this.element.find('td.e-selectedCell').length) - 1;
                _target = $(targetElement);
                if (this.model.timeScale.enable)
                    this._cellIndex = _target.hasClass("e-workcells") ? _target.index() : _target.hasClass("e-alldaycells") ? _target.index() : this._isCustomMonthView() && this._oneWeek ? _target.index() : 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7);
                else
                    this._cellIndex = this.model.orientation == "vertical" && this.currentView() == "month" || (this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7) : _target.index();
                if (this.model.orientation == "horizontal") {
                    this._cellIndex = this.model.timeScale.enable ? this.currentView() !== "month" && !(this._isCustomMonthView()) ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * 2)) : this._cellIndex : _target.index();
                    this._workCellIndex = _target.parent().index();
                }
                if (ns == 0) {
                    var curDate = new Date(renderDates[this._cellIndex]);
                    if ((this.model.minDate > curDate || this.model.maxDate < curDate)) { return false; }
                    if (_target.hasClass("e-workcells") && (this.model.timeScale.enable) && this.currentView() !== "month" && !(this._isCustomMonthView())) {
                        var time = this.model.orientation == "vertical" ? this.model.startHour + (_target.parent().index() / 2) : this.model.startHour + ((_target.index() - (((this.model.endHour - this.model.startHour) * 2) * this._cellIndex)) / 2);
                        var timemin = time.toString().split(".");
                        startTime = new Date(curDate).setHours(parseInt(timemin[0]), parseInt(timemin[1]) == 5 ? 30 : 00);
                        var min = (parseInt(new Date(startTime).getHours()) == 23 && parseInt(new Date(startTime).getMinutes()) == 30) ? new Date(startTime).getMinutes() + 29 : new Date(startTime).getMinutes() + 30;
                        endTime = new Date(new Date(startTime).setMinutes(min));
                        if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
                    }
                    else {
                        startTime = new Date(new Date(curDate).setHours(0, 0, 0));
                        endTime = new Date(new Date(curDate).setHours(23, 59, 59));
                        if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                    }
                }
                else if (ns > 0) {
                    var indexes = this._findMinMaxCellIndex();
                    var omincolIndex = indexes.omincolIndex, omaxcolIndex = indexes.omaxcolIndex, rowInx = indexes.rowInx, maxrowInx = indexes.maxrowInx;
                    if (this.model.orientation == "vertical") {
                        if ($(contextElement).hasClass('e-workcells')) {
                            var minStartDate = renderDates[omincolIndex]; var maxEndDate = renderDates[omaxcolIndex];
                            var minStartTime = (this.model.startHour + (rowInx / 2)).toString().split(".");
                            var maxEndTime = (this.model.startHour + (maxrowInx / 2)).toString().split(".");
                            startTime = new Date(new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00));
                            endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                            endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                        }
                        else if ($(contextElement).hasClass('e-monthcells')) {
                            var selCell = this.element.find('td.e-selectedCell');
                            var startIndex = ($(selCell[0]).parent().index() * 7) + ($(selCell[0]).index() - (Math.floor($(selCell[0]).index() / 7) * 7));
                            var endIndex = ($(selCell[ns]).parent().index() * 7) + ($(selCell[ns]).index() - (Math.floor($(selCell[ns]).index() / 7) * 7));
                            var startDate = new Date(this._dateRender[startIndex]);
                            var endDate = new Date(this._dateRender[endIndex]);
                            startTime = new Date(new Date(startDate).setHours(0, 0, 0));
                            endTime = new Date(new Date(endDate).setHours(23, 59, 59));
                        }
                        else if ($(contextElement).hasClass('e-alldaycells')) {
                            startTime = new Date(new Date(renderDates[omincolIndex]).setHours(0, 0, 0));
                            endTime = new Date(new Date(renderDates[omaxcolIndex]).setHours(23, 59, 59));
                        }
                    }
                    else {
                        if (this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable) {
                            var minStartDate = renderDates[0]; var maxEndDate = renderDates[0];
                            var minStartTime = (this.model.startHour + (omincolIndex / 2)).toString().split(".");
                            var maxEndTime = (this.model.startHour + (omaxcolIndex / 2)).toString().split(".");
                            startTime = new Date(new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00));
                            endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                            endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                        }
                        else {
                            var minStartDate = this.totdays[omincolIndex]; var maxEndDate = this.totdays[omaxcolIndex];
                            var minStartTime = (this.model.startHour).toString().split(".");
                            var maxEndTime = (this.model.startHour).toString().split(".");
                            startTime = new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 00);
                            endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 00);
                            endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                            endTime = new Date(new Date(endTime).setHours(23, 59, 59));
                        }
                    }
                }
                var event = { startTime: new Date(startTime), endTime: new Date(endTime), target: _target, resources: ((this.model.appointmentWindowOpen != null || this.model.cellDoubleClick != null) && (this._tempResource.length != 0)) ? this._getResourceValue(_target) : null };
                if (this._trigger("appointmentWindowOpen", event))
                    return false;
                if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                    this._renderResourceData($(targetElement), this._cellIndex);
                this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", new Date(startTime));
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", new Date(endTime));
                this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(new Date(startTime), this._pattern.t, this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(new Date(endTime), this._pattern.t, this.model.locale));
                ($(contextElement).hasClass("e-alldaycells") || this.currentView() == "month" || (this._isCustomMonthView())) && this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                this._timeZoneCollection(null);
                this._tempStart = this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value");
                this._tempEnd = this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value");
                this._alldayCheck();
                if (!this.model.readOnly) {
                    this._appointmentAddWindow.find(".e-appsave,#" + this._id + "donerecur").ejButton("enable", true);
                    (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "none");
                    this._appointmentAddWindow.ejDialog("open");
                }
                this._appointmentAddWindow.find('.subject').focus();
                this._cellClick = false;
            }

        },

        _tooltipEvents: function (args) {
            if (args == "disable") {
                if (!ej.isNullOrUndefined(this.element.data("ejTooltip"))) {
                    var tipObj = this.element.ejTooltip('instance');
                    tipObj._wireEvents(false);
                }
            }
            else {
                if (!ej.isNullOrUndefined(this.element.data("ejTooltip"))) {
                    var tipObj = this.element.ejTooltip('instance');
                    tipObj._wireEvents(true);
                }
            }
        },
        _showToolTip: function (event) {
            var event = event.event;
            if (ej.isNullOrUndefined(event.target)) return false;
            var toolTipObj = this.element.data("ejTooltip");
            if ($(event.target).hasClass("e-appup") || $(event.target).hasClass("e-appdown")) {
                toolTipObj.setModel({ content: this._getLocalizedLabels("AppointmentIndicator") });
                return true;
            } else if ($(event.target).hasClass("e-appsoverflow")) {
                return this._showAppCount(event);
            }
            else if (this.model.tooltipSettings.enable && !ej.isTouchDevice()) {
                var appData = this._getAppDetails(event.currentTarget);
                if (appData == false) return false;
                if (ej.isNullOrUndefined(this.model.tooltipSettings.templateId)) {
                    var startTime = this._timeMode == "12" ? ej.format(appData[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(appData[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale);
                    var endTime = this._timeMode == "12" ? ej.format(appData[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(appData[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                    var subject = (appData[this._appointmentSettings["subject"]] == "" || ej.isNullOrUndefined(appData[this._appointmentSettings["subject"]])) ? this._getLocalizedLabels("NoTitle") : appData[this._appointmentSettings["subject"]];
                    var appDetails = subject + ":&nbsp;(" + startTime + "-" + endTime + ")";
                } else {
                    var appDetails = $(this.model.tooltipSettings.templateId).render(appData).trim();
                }
                toolTipObj.setModel({ content: appDetails });
                return true;
            }
            return false;
        },
        _showAppCount: function (e) {
            var id = e.target.id.split("_");
            var date = (this.currentView() != "day") ? new Date(parseInt($(e.currentTarget).attr("cellinfo"))) : new Date($(e.currentTarget).attr("cellinfo"));
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group)) var resValue = this._resourceSort()[parseInt(id[id.length - 2])].id;
            if (this.model.orientation == "horizontal" && this.currentView() != "month") {
                var cellIndex = parseInt(id[id.length - 1]);
                var starttime = new Date(date.setMilliseconds(((this.model.startHour * 60) + cellIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000)));
                var endtime = new Date(starttime.setMilliseconds((this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * 60 * 1000));
            }
            var userTempHtml = $.templates($(this.model.appointmentTemplateId).html());
            var appoverflowheight = this.element.find(".e-appsoverflow").height();
            if (this.model.orientation == "vertical") {
                var monthcellheight = this.element.find(".e-monthcells").outerHeight();
                var monthappheight = this.element.find(".e-monthappointment").outerHeight();
                var monthheaderheight = this.element.find(".e-monthheader").height();
                if (ej.isNullOrUndefined(monthappheight)) monthappheight = (!this.model.appointmentTemplateId) ? 19 : ($(userTempHtml.markup).css('height') == "100%" ? (monthcellheight - this.element.find('.e-monthheader').height() - 15) : $(userTempHtml.markup).css('height') == "0px" ? 20 : $(userTempHtml.markup).height());
                var appCount = parseInt($(e.currentTarget).attr("appcount"));
                var total = (appCount * monthappheight) + monthheaderheight + appoverflowheight;
                var overflowapps = Math.round((total - monthcellheight) / monthappheight);
                overflowapps = (overflowapps == 0) ? 1 : overflowapps;
            }
            else {
                var cellheight = this.element.find(".e-workcells").outerHeight();
                var appheight = (this.currentView() == "month") ? appheight = this.element.find(".e-monthappointment").outerHeight() : this.element.find(".e-appointment").height();
                if (ej.isNullOrUndefined(appheight)) appheight = (!this.model.appointmentTemplateId) ? 20 : ($(userTempHtml.markup).css('height') == "100%" ? (cellheight - 15) : $(userTempHtml.markup).css('height') == "0px" ? 20 : $(userTempHtml.markup).height());
                var appoverflowheight = this.element.find(".e-appsoverflow").height();
                var appCount = parseInt($(e.currentTarget).attr("appcount"));
                var total = (appCount * appheight) + appoverflowheight;
                var overflowapps = Math.ceil((total - cellheight) / appheight);
            }
            var data = { Date: date, ResourceValue: resValue, StartTime: starttime, EndTime: endtime };
            this._overflowApp = data;
            var toolTipObj = this.element.data("ejTooltip");
            if (this._trigger("overflowButtonHover", { event: e, datas: data })) {
                return false;
            }
            toolTipObj.setModel({ content: overflowapps + "&nbsp;" + this._getLocalizedLabels("OverFlowAppCount") });
            return true;
        },

        _horizontalRender: function () {
            (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) && this.element.find(".resemptytd").width((this.element.find(".e-horizontalrestd").width() < 100) ? 5 : (this.element.find(".e-horizontalrestd").width() >= 100 && this.element.find(".e-horizontalrestd").width() <= 150) ? 10 : 25);
            if (this._mediaQuery) {
                this.element.find(".e-parentnode,.e-childnode").css({ height: this.element.find(".e-workcells").height() });
            }
            else {
                var resLength = (this._tempResource.length == 0) ? this.res1.length : this._resourceSort().length;
                var scrollHeight = (this.element.find("div#" + this._id + "_scroller").ejScroller("isHScroll")) ? this.element.find("div#" + this._id + "_scroller").find(".e-hscroll").outerHeight() : 0;
                scrollHeight = ej.isNullOrUndefined(scrollHeight) ? 0 : scrollHeight;
                var workareaheight = this.scHeight - 1 - ((this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top) + scrollHeight);
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) {
                    var workcellheight = Math.round(workareaheight / resLength) - 1;
                    workcellheight = workcellheight < 20 ? 20 : workcellheight;
                    this.element.find(".e-workcells").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : workcellheight + "px" });
                    this.element.find(".e-childnode").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : workcellheight + "px" });
                    this.element.find(".e-parentnode").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : workcellheight + "px" });
                    if (this.currentView() != "agenda") {
                        var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;//this.element.find(".e-draggableworkarea")[0].scrollTop;
                        this.element.find(".e-horires").css({ top: -restop + "px" });
                    }
                }
                else {
                    this.element.find(".e-workcells").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : Math.round(workareaheight - 1) + "px" });
                }
            }
            if (this.element.find(".e-workcells").height() > workareaheight) this.element.find("div#" + this._id + "_scroller").ejScroller("refresh");
            this.element.find("div#" + this._id + "_scroller").ejScroller("isVScroll") && this._showScrollTd();
        },
        _monthCellsRender: function () {
            var len = this.element.find(".e-workcellstab tr").length;
            var workareaheight = parseInt(this.scHeight) - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
            this.element.find(".e-monthcells, .e-timecells").outerHeight((this.model.cellHeight) ? parseInt(this.model.cellHeight) + 1 : Math.round(workareaheight / len));
        },

        _processTab: function (oEl, event, oRowCell) {
            var appo = this.element.find('div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment');
            if (oEl.id == this._id || $(oEl).hasClass("e-datedisplay")) {
                if (appo.length != 0)
                    $(appo[0]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                else
                    $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if ($(oEl).hasClass("e-selectedCell")) {
                if (appo.length != 0) {
                    var selcel = this.element.find('td.e-selectedCell');
                    var n = parseInt(selcel.length) - 1;
                    if (n > 0) {
                        for (var i = 0; i <= n; i++) {
                            selcel.eq(i).removeClass("e-selectedCell").blur();
                        }
                    }
                    else
                        $(oEl).removeClass("e-selectedCell").blur();
                    $(appo[0]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                }
            }
            if ($(oEl).hasClass("e-navigateprevious")) {
                this.element.find('.e-navigatenext').attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-navigatenext")) {
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                if ($(oRowCell[0].cells[0]).hasClass("e-resourceheadercells"))
                    $(oRowCell[1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment") || $(oEl).hasClass("e-agendaappointment")) {
                var appcount = appo.length;
                var appindex = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment").index(this.element.find(".e-selectedAppointment"));
                if (appindex < appcount && appindex >= 0) {
                    $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                    var newappindex = parseInt(appindex) + 1;
                    if (newappindex < appcount)
                        $(appo[newappindex]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                    else if (newappindex == appcount)
                        this.element.find('.e-navigateprevious').attr("tabIndex", 0).focus();
                }
                else if (appindex == appcount)
                    this.element.find('.e-navigateprevious').attr("tabIndex", 0).focus();
            }
        },

        _reverseTab: function (oEl, event, oRowCell) {
            var appo = this.element.find('div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment');
            if (oEl.id == this._id || $(oEl).hasClass("e-datedisplay")) {
                var len = parseInt(appo.length) - 1;
                if (appo.length != 0)
                    $(appo[len]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
            }
            var appcount = appo.length;
            if ($(oEl).hasClass("e-selectedCell")) {
                var len = appo.length - 1;
                if (appo.length != 0) {
                    var selcel = this.element.find('td.e-selectedCell');
                    var n = parseInt(selcel.length) - 1;
                    if (n > 0) {
                        for (var i = 0; i <= n; i++)
                            selcel.eq(i).removeClass("e-selectedCell").blur();
                    }
                    else
                        $(oEl).removeClass("e-selectedCell").blur();
                    $(appo[len]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                }
            }
            if ($(oEl).hasClass("e-navigatenext"))
                $(this.element).find('.e-navigateprevious').attr("tabIndex", 0).focus();
            else if ($(oEl).hasClass("e-navigateprevious")) {
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                if ($(oRowCell[0].cells[0]).hasClass("e-resourceheadercells"))
                    $(oRowCell[1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment") || $(oEl).hasClass("e-agendaappointment")) {
                var appindex = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment").index(this.element.find(".e-selectedAppointment"));
                if (appindex < appcount && appindex > 0) {
                    $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                    var newappindex = parseInt(appindex) - 1;
                    if (newappindex < appcount && appindex >= 0)
                        $(appo[newappindex]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                    else if (newappindex == 0)
                        $(this.element).find('.e-navigatenext').attr("tabIndex", 0).focus();
                }
                else if (appindex == 0) {
                    $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                    $(this.element).find('.e-navigatenext').attr("tabIndex", 0).focus();
                }
            }
        },

        _stopDefaultAction: function (e) {
            e.cancelBubble = true; e.returnValue = false; e.stopPropagation(); e.preventDefault();
        },

        _getLocalizedLabels: function (property) {
            var _localizedText;
            if (property == "Categorize")
                _localizedText = !ej.isNullOrUndefined(this.model.categorizeSettings.title) ? this.model.categorizeSettings.title : this._localizedLabels[property] === undefined ? ej.Schedule.Locale["en-US"][property] : this._localizedLabels[property];
            else if (property == "Priority")
                _localizedText = !ej.isNullOrUndefined(this.model.prioritySettings.title) ? this.model.prioritySettings.title : this._localizedLabels[property] === undefined ? ej.Schedule.Locale["en-US"][property] : this._localizedLabels[property];
            else
                _localizedText = this._localizedLabels[property] === undefined ? ej.Schedule.Locale["en-US"][property] : this._localizedLabels[property];;
            return _localizedText;
        },

        _refreshDatasource: function () {
            if (!ej.isNullOrUndefined(this.dataSource()) && this.dataSource().length > 0) {
                var appointments = this.dataSource();
                for (var a = 0, len = appointments.length; a < len; a++) {
                    this._timeZoneAppointments(appointments[a], "");
                }
            }
        },

        refreshAppointments: function () {
            !ej.isNullOrUndefined(this._appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
            this._refreshDatasource();
            this._bindAppointmentsData("Refresh");
        },

        refresh: function () {
            this._refreshDatasource();
            this._destroy();
            this._init();
        },

        getSlotByElement: function (args) {
            var target = !ej.isNullOrUndefined(args) ? $(args) : $(this.element.find("td.e-selectedCell"));
            if (ej.isNullOrUndefined(target) || target.length == 0 || this.currentView() == "agenda") return false;
            if (target.hasClass("e-workcells") || target.hasClass("e-monthcells") || target.hasClass("e-alldaycells")) {
                if (target.length == 1)
                    this._slotByElement(target, "");
                else
                    this._slotByCellSelect(target);
            }
            return { startTime: new Date(this.cur_StartTime), endTime: new Date(this.cur_EndTime), resources: (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this._getResourceValue(target) : null };
        },

        saveAppointment: function (obj) {
            if (!this.model.readOnly) {
                if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
                (ej.isNullOrUndefined(this._appointmentAddWindow)) && ej.RecurrenceEditor.prototype._initializePrivateProperties();
                var recurEdit = (!ej.isNullOrUndefined(this._appointmentAddWindow)) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
                var appointments = this._sortAppById(this._processed), maxId;
                this._publicMethodSave = false;
                if (this.model.appointmentSettings.applyTimeOffset) {
                    ej.isNullOrUndefined(obj[this._appointmentSettings["startTimeZone"]]) && (obj[this._appointmentSettings["startTimeZone"]] = (this.model.timeZone == null) ? "UTC " + this._timezoneStringValue() : this.model.timeZone);
                    ej.isNullOrUndefined(obj[this._appointmentSettings["endTimeZone"]]) && (obj[this._appointmentSettings["endTimeZone"]] = (this.model.timeZone == null) ? "UTC " + this._timezoneStringValue() : this.model.timeZone);
                }
                var savingTimeZone = this._timeZoneSavingAppoint(obj, "");
                obj = savingTimeZone.obj;
                if (!ej.isNullOrUndefined(obj[this._appointmentSettings["id"]]) || !obj[this._appointmentSettings["id"]] == "") {
                    var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, obj[this._appointmentSettings["id"]]));
                    if (!ej.isNullOrUndefined(tempApp[0])) {
                        obj["Guid"] = tempApp[0]["Guid"];
                        obj["AppTaskId"] = tempApp[0]["AppTaskId"];
                        obj[this._appointmentSettings["recurrenceId"]] = tempApp[0][this._appointmentSettings["recurrenceId"]];
                        obj[this._appointmentSettings["recurrenceExDate"]] = tempApp[0][this._appointmentSettings["recurrenceExDate"]];
                        obj["ParentId"] = tempApp[0]["ParentId"];
                    }
                }
                var proxy = this;
                this._maxId = maxId = !ej.isNullOrUndefined(this._appMainId) ? this._appMainId + 1 : 1;
                var currentAction = this._currentAction == "save" ? "edit" : this._currentAction;
                if (ej.isNullOrUndefined(obj["AppTaskId"]) || obj["AppTaskId"] == "") {
                    obj[this._appointmentSettings["id"]] = (ej.isNullOrUndefined(obj[this._appointmentSettings["id"]]) || obj[this._appointmentSettings["id"]] == "") ? maxId : obj[this._appointmentSettings["id"]];
                    obj["AppTaskId"] = obj["ParentId"] = maxId;
                    obj.Guid = this._guidFormatGenerate();
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentSave", methodType: "public" }))
                        return false;
                    if (this._trigger("beforeAppointmentCreate", { appointment: obj, methodType: "public" }))
                        return false;
                    var temp = this._timeZoneAppointments(obj, "");
                    var promise = this._dataManager.insert(temp, this.model.appointmentSettings.query._fromTable);
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(temp, "reverse"));
                    if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(temp);
                    this._appointmentProcessing(obj);
                    this._currentViewAppointments = this._appointmentCount();
                    var renderApps = this._currentViewAppointments.filter(function (list) { return obj.ParentId == list.ParentId });
                    for (var ix = 0, len = renderApps.length; ix < len; ix++) {
                        this._refreshDayAppointments(renderApps[ix]);
                    }
                    this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                    this._trigger("appointmentCreated", { appointment: temp, requestType: "appointmentSaved", methodType: "public" });
                    this._trigger("actionComplete", { data: temp, requestType: "appointmentSave", methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        temp[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!temp[proxy._appointmentSettings["recurrence"]]) temp.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", temp);
                                    }
                                }
                            }
                        });
                    }
                }
                else if (this._currentAction == "editOccurrence") {
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction }))
                        return false;
                    if (this._trigger("beforeAppointmentChange", { appointment: obj, currentAction: currentAction }))
                        return false;
                    var _appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                    var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                    var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                    var recurColl = this._appointmentRecurrenceSort(new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid)));
                    var index = this._recuCollectionIndex(recurColl, _appList);
                    var model = this._appointmentSettings;
                    if (((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime())))) {
                        this._alertCreateError();
                        return false;
                    }
                    var _editApps = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    this._objDate = _editApps;
                    var MapValue = this._objDate[0][this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                    var _editApp = this._deleteOcurrence(this._objDate[0][MapValue], new Date(_editApps[0][this._appointmentSettings["startTime"]]));
                    obj[this._appointmentSettings["recurrence"]] = 1;
                    obj[this._appointmentSettings["recurrenceRule"]] = _editApp[0][this._appointmentSettings["recurrenceRule"]] + ";RECUREDITID=" + _editApp[0]["ParentId"];
                    obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                    obj[this._appointmentSettings["recurrenceExDate"]] = _editApp[0][this._appointmentSettings["recurrenceExdate"]];
                    obj["Guid"] = _editApps[0]["Guid"];
                    obj[this._appointmentSettings["id"]] = _editApps[0][this._appointmentSettings["id"]];
                    var args = [], newAppointment;
                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), obj[this._appointmentSettings["recurrenceId"]]);
                    newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                    args.push(newAppointment);
                    var newApp = [], _editApp = [];
                    var startTimezone1 = args[0][this._appointmentSettings["startTimeZone"]];
                    (startTimezone1 != this.model.timeZone) ? newApp.push(this._timeZoneAppointments(args[0], "")) : newApp.push(args[0]);
                    var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, this._parentId));
                    (startTimezone1 != this.model.timeZone) ? _editApp.push(this._timeZoneAppointments(_App[0], "")) : _editApp.push(_App[0]);
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newApp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable);
                    var updateTempNew = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(newApp[0], "reverse") : newApp[0];
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew);
                    var updateTempNew2 = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(_editApp[0], "reverse") : _editApp[0];
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew2);
                    if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(args[0]);
                    var isObjAvail = this._processed.filter(function (obj) { return obj.Guid == args[0].Guid; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    this._appointmentProcessing(args[0]);
                    this._currentViewAppointments = this._appointmentCount();
                    var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == args[0].ParentId; });
                    for (var e = 0, len = collection.length; e < len; e++) {
                        this._refreshDayAppointments(collection[e]);
                    }
                    this._trigger("appointmentChanged", { appointment: args[0], requestType: "appointmentChanged", currentAction: currentAction, methodType: "public" });
                    this._trigger("actionComplete", { data: args, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        args[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!args[0][proxy._appointmentSettings["recurrence"]]) args[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", args[0]);
                                    }
                                }
                            }
                        });
                    }
                }
                else if ((this._currentAction == "save" && obj[this._appointmentSettings["recurrence"]]) || (this._currentAction == ej.Schedule.Actions.EditSeries)) {
                    var _editApps = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    if (this._currentAction != ej.Schedule.Actions.EditSeries) {
                        if (!ej.isNullOrUndefined(_editApps[0][this._appointmentSettings["recurrenceRule"]]))
                            obj[this._appointmentSettings["recurrenceRule"]] = _editApps[0][this._appointmentSettings["recurrenceRule"]];
                        var _appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                        var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                        var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                        var recurColl = this._appointmentRecurrenceSort(new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid)));
                        var index = this._recuCollectionIndex(recurColl, _appList);
                        var model = this._appointmentSettings;
                        if (((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime())))) {
                            this._alertCreateError();
                            return false;
                        }
                    }
                    else {
                        var Parid = _editApps[0][this._appointmentSettings["recurrenceId"]] == null ? _editApps[0]["ParentId"] : _editApps[0][this._appointmentSettings["recurrenceId"]];
                        var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                        maxId = obj["AppTaskId"] = _editApp[0]["AppTaskId"];
                        obj[this._appointmentSettings["id"]] = _editApp[0][this._appointmentSettings["id"]];
                        obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                        obj[this._appointmentSettings["recurrenceExDate"]] = _editApp[0][this._appointmentSettings["recurrenceExDate"]];
                        obj[this._appointmentSettings["recurrenceRule"]] = (ej.isNullOrUndefined(recurEdit._recRule) || recurEdit._recRule == "") ? _editApp[0][this._appointmentSettings["recurrenceRule"]] : recurEdit._recRule;
                    }
                    obj["Guid"] = _editApps[0]["Guid"];
                    obj[this._appointmentSettings["id"]] = (this._currentAction != ej.Schedule.Actions.EditSeries) ? _editApps[0][this._appointmentSettings["id"]] : obj[this._appointmentSettings["id"]];
                    var args = [], newAppointment;
                    var parId = this._currentAction == ej.Schedule.Actions.EditOccurrence || (!ej.isNullOrUndefined(obj[this._appointmentSettings["recurrenceRule"]]) && obj[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) ? this._parentId : this._currentAction == (ej.Schedule.Actions.Save) ? _editApps[0].AppTaskId : maxId;
                    var taskId = ((((new Date(obj[this._appointmentSettings["endTime"]]) - new Date(obj[this._appointmentSettings["startTime"]])) / 3600000) > 24) && this._currentAction != ej.Schedule.Actions.EditOccurrence && (obj[this._appointmentSettings["allDay"]] == true)) ? parId : this._currentAction == (ej.Schedule.Actions.Save) ? _editApps[0].AppTaskId : this._appMainId + 1;
                    taskId = (this._currentAction == ej.Schedule.Actions.EditSeries) ? parId : taskId;
                    newAppointment = this._addAppData(obj, taskId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                    args.push(newAppointment);
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction }))
                        return false;
                    if (this._trigger("beforeAppointmentChange", { appointment: obj, currentAction: currentAction }))
                        return false;
                    if (this._currentAction == ej.Schedule.Actions.EditSeries && !ej.isNullOrUndefined(obj["RecurrenceExDate"]))
                        this._isCustomAlert = true;
                    var newApp = [], editedApp = [], deleted = [];
                    var GId = this._currentAction == ej.Schedule.Actions.Save ? args[0]["Guid"] : args[0][this._appointmentSettings["recurrenceId"]];
                    var idName = this._currentAction == ej.Schedule.Actions.Save ? "Guid" : this._appointmentSettings["recurrenceId"];
                    var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(idName, ej.FilterOperators.equal, GId));
                    (!ej.isNullOrUndefined(_editApp) && _editApp.length > 0) ? editedApp.push(args[0]) : newApp.push(args[0]);
                    if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                        var query = ej.Query().where(ej.Predicate(this._appointmentSettings["recurrenceRule"], ej.FilterOperators.contains, "RECUREDITID=" + args[0].ParentId, true));
                        var dele = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                        deleted = deleted.concat(dele);
                        //this._appointmentAddWindow.find('.recurbutton').click();
                        editedApp[0][this._appointmentSettings["recurrenceRule"]] = recurEdit._recRule;
                        editedApp[0][this._appointmentSettings["recurrenceExDate"]] = null;
                        var removeCollection = this._processed.filter(function (obj) { return obj.ParentId == editedApp[0].ParentId; });
                        new ej.DataManager(this._currentAppointmentData).remove("ParentId", editedApp[0].ParentId);
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCollection }, "ParentId");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCollection }, "ParentId");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCollection }, "ParentId");
                        for (var j = 0, len = removeCollection.length; j < len; j++) {
                            this._appointmentRemove(removeCollection[j]);
                            this._refreshDayAppointments(removeCollection[j]);
                        }
                    }
                    else if (editedApp.length > 0) {
                        for (var k = 0; k < editedApp.length; k++) {
                            new ej.DataManager(this._processed).remove("Guid", editedApp[k].Guid);
                            new ej.DataManager(this._renderedApp).remove("Guid", editedApp[k].Guid);
                            new ej.DataManager(this._renderedAllDay).remove("Guid", editedApp[k].Guid);
                            this._appointmentRemove(editedApp[k]);
                            this._refreshDayAppointments(editedApp[k]);
                        }
                    }
                    var proxy = this, newTemp = [], editTemp = [];
                    if (newApp.length > 0)
                        newTemp.push(this._timeZoneAppointments(newApp[0], ""));
                    if (editedApp.length > 0)
                        editTemp.push(this._timeZoneAppointments(editedApp[0], ""));
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newTemp, changed: editTemp, deleted: deleted }, queryId, this.model.appointmentSettings.query._fromTable);
                    if (editedApp.length > 0)
                        var updateTemp = this._timeZoneAppointments(editTemp[0], "reverse");
                    if (newApp.length > 0)
                        var updateTemp = this._timeZoneAppointments(newTemp[0], "reverse");
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                    new ej.DataManager(this._currentAppointmentData).remove("Guid", editedApp[0]);
                    var tempApps = this._processed.filter(function (obj) { return obj.Guid == editedApp[0].Guid; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                    this._currentAppointmentData.push(editedApp[0]);
                    this._appointmentProcessing(editedApp[0]);
                    this._currentViewAppointments = this._appointmentCount();
                    var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == editedApp[0].ParentId; });
                    for (var e = 0, len = collection.length; e < len; e++) {
                        this._refreshDayAppointments(collection[e]);
                    }
                    for (var f = 0, len = deleted.length; f < len; f++) {
                        this._refreshDayAppointments(deleted[f]);
                    }
                    this._trigger("appointmentChanged", { appointment: editedApp[0], requestType: "appointmentChanged", currentAction: currentAction, methodType: "public" });
                    this._trigger("actionComplete", { data: editedApp, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        editedApp[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!editedApp[0][proxy._appointmentSettings["recurrence"]]) editedApp[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                    }
                                }
                            }
                        });
                    }
                }
                else {
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" }))
                        return false;
                    if (this._trigger("beforeAppointmentChange", { appointment: obj, currentAction: currentAction, methodType: "public" }))
                        return false;
                    var temp = this._timeZoneAppointments(obj, "");
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable);
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(temp, "reverse"));
                    this._renderSingleApp();
                    this._trigger("appointmentChanged", { appointment: obj, requestType: "appointmentChanged", currentAction: currentAction, methodType: "public" });
                    this._trigger("actionComplete", { data: obj, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value)) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        obj[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!obj[proxy._appointmentSettings["recurrence"]]) obj.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                    }
                                }
                            }
                        });
                    }
                }
                this._currentViewAppointments = this._appointmentCount();
                if (this.model.showAppointmentNavigator) this._nextPrevButton();
            }
        },

        print: function (appointment) {
            if (!ej.isNullOrUndefined(appointment))
                this._printAppointment(appointment);
            else {
                var cloneElement = this.element.clone();
                if (this.currentView() == "agenda") {
                    cloneElement.width(this.element.find('.e-agendacellstab').width() + 2);
                    cloneElement.height($("#" + this._id + " .e-headertr").height() + this.element.find('.e-agendacellstab').height() + $("#" + this._id + " .e-scheduleheader").height() + 2);
                    cloneElement.find("div#" + this._id + "_scroller").ejScroller({ width: this.element.find('.e-agendacellstab').width(), height: this.element.find('.e-agendacellstab').height() + 2 });
                    cloneElement.find('.e-commonviewbutton').css({ 'margin-top': '0px' });
                    cloneElement.find('.e-viewstable').css({ 'padding-top': '15px' });
                }
                else {
                    cloneElement.find(".e-upicon,.e-downicon").remove();
                    if (this.model.orientation == "vertical") {
                        if (this.model.timeScale.enable) {
                            if (this.currentView() == "month" || (this._isCustomMonthView() && this._renderDays > 7))
                                cloneElement.width(this.element.find('.e-workcellstab').width() + $('.e-monthleftindent').width());
                            else
                                cloneElement.width(this.element.find('.e-workcellstab').width() + $('.e-workleftindent').width());
                            cloneElement.height($("#" + this._id + " .e-headertr").height() + $("#" + this._id + " .e-workcellstab").height() + $("#" + this._id + " .e-scheduleheader").height() + 2);
                            cloneElement.find('.e-scroller').ejScroller({ width: $('.e-dateheader').width(), height: $("#" + this._id + " .e-workcellstab").height() + 2 });
                            cloneElement.find('.e-scrolltimecells').css({ top: 0 });
                            cloneElement.find('.e-commonviewbutton').css({ 'margin-top': '0px' });
                            cloneElement.find('.e-viewstable').css({ 'padding-top': '15px' });
                            cloneElement.children().first().css({ border: "0px solid #bbbcbb" });
                            cloneElement.css({ border: "1px solid #bbbcbb" });
                            if (this.currentView() == "month")
                                cloneElement.find('.e-draggableworkarea').css({ 'height': this.element.find('.e-timecells').height() * this.element.find('.e-timecells').length + 2 });
                        }
                        else {
                            cloneElement.width(this.element.find('.e-workcellstab').width() + $('.e-workleftindent').width());
                            cloneElement.find(".e-workcellstab").css({ left: -($("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()), position: 'absolute' });
                        }
                    }
                    else {
                        if (this.currentView() == "month" || (this._isCustomMonthView() && this._renderDays > 7)) {
                            cloneElement.width(this.element.find('.e-workcellstab').width());
                        }
                        else {
                            cloneElement.find(".e-workcellstab").css({ left: -($("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()), position: 'absolute' });
                            cloneElement.find(".e-horizontaltimecells tr:nth-child(2)").css("left", -($("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()) + "px");
                        }
                    }
                }
                //ej.print(cloneElement);
                this._schedulePrint(cloneElement);
            }
        },

        _schedulePrint: function (element, printWin) {
            var $div = ej.buildTag('div');
            var elementClone = element.clone();
            var elementWidth = Math.round((elementClone.width()) / 100) * 100;
            $div.append(elementClone);
            if (!printWin)
                var printWin = window.open('', 'print', "height=452,width=" + elementWidth + ",tabbar=no");
            printWin.document.write('<!DOCTYPE html>');
            var links = $('head').find('link').add("style");
            if (ej.browserInfo().name === "msie") {
                var a = ""
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.write('<html><head></head><body>' + a + $div[0].innerHTML + '</body></html>');
            }
            else {
                var a = ""
                printWin.document.write('<html><head>')
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.writeln(a + '</head><body>')
                printWin.document.writeln($div[0].innerHTML + '</body></html>')
            }
            printWin.document.close();
            printWin.focus();
            setTimeout(function () {
                if (!ej.isNullOrUndefined(printWin.window)) {
                    printWin.print();
                    setTimeout(function () { printWin.close() }, 1000);
                }
            }, 1000);
        },

        notifyChanges: function (action, data) {
            if (!ej.isNullOrUndefined(data) || data.length != 0) {
                var app = (!ej.isNullOrUndefined(data)) ? data : data[0];
                var object = $.extend(true, {}, app);
                object[this._appointmentSettings["startTime"]] = new Date(object[this._appointmentSettings["startTime"]]);
                object[this._appointmentSettings["endTime"]] = new Date(object[this._appointmentSettings["endTime"]]);

                if (action == "beforeAppointmentCreate") {
                    new ej.DataManager(this._currentAppointmentData).insert(object);
                    this._appointmentProcessing(object);
                    this._renderAppointmentAll();
                }
                else if (action == "beforeAppointmentChange") {
                    new ej.DataManager(this._currentAppointmentData).update(this._appointmentSettings["id"], object);
                    new ej.DataManager(this._processed).remove(this._appointmentSettings["id"], object[this._appointmentSettings["id"]]);
                    this._dataProcessing(this._currentAppointmentData);
                    this._renderAppointmentAll();
                }
                else if (action == "beforeAppointmentRemove") {
                    var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, object[this._appointmentSettings["id"]]));
                    new ej.DataManager(this._currentAppointmentData).remove(this._appointmentSettings["id"], appointment[0][this._appointmentSettings["id"]]);
                    new ej.DataManager(this._processed).remove(this._appointmentSettings["id"], appointment[0][this._appointmentSettings["id"]]);
                    this._renderAppointmentAll();
                }
            }
        },

        deleteAppointment: function (id) {
            if (!this.model.readOnly) {
                if (typeof id == "string") {
                    var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, id));
                    if (appointment[0][this._appointmentSettings["recurrence"]]) {
                        this._deleteUid = id;
                        this._deletingAppointment();
                    }
                    else this._deleteApp(id);
                }
                else if (typeof id == "object") {
                    this._deleteUid = id.Guid;
                    if (ej.isNullOrUndefined(this._deleteUid)) {
                        var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, id.ParentId));
                        this._deleteUid = appointment[0].Guid;
                    }
                    if (id[this._appointmentSettings["recurrence"]])
                        this._deletingAppointment();
                    else this._deleteApp(this._deleteUid);
                }
            }
        },

        getAppointments: function () {
            var appList = this.dataSource();
            return appList;
        },

        searchAppointments: function (searchString, fields, filterOperator, ignoreCase) {
            var _fields = ej.isNullOrUndefined(fields) ? this._getColumns(this._appointmentSettings) : fields;
            var _filterOperator = ej.isNullOrUndefined(filterOperator) ? "contains" : filterOperator;
            var _ignoreCase = ej.isNullOrUndefined(ignoreCase) ? true : ignoreCase;
            var result;
            if (typeof searchString == "string") {
                result = (searchString == "") ? [] : new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().search(searchString, _fields, _filterOperator, _ignoreCase));
            }
            else if (typeof searchString == "object") {
                result = this.filterAppointments(searchString);
            }
            return result;
        },

        filterAppointments: function (filterConditions) {
            var result, queryManagar = ej.Query(), matchcaseVal;
            if (!ej.isNullOrUndefined(filterConditions)) {
                var firstFilterCondition = filterConditions[0];
                matchcaseVal = ej.isNullOrUndefined(firstFilterCondition.matchcase) ? true : firstFilterCondition.matchcase;
                var predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, matchcaseVal);
                for (var i = 1; i < filterConditions.length; i++) {
                    matchcaseVal = ej.isNullOrUndefined(filterConditions[i].matchcase) ? true : filterConditions[i].matchcase;
                    predicate = predicate[filterConditions[i].predicate](filterConditions[i].field, filterConditions[i].operator, filterConditions[i].value, matchcaseVal);
                }
                queryManagar.where(predicate);
                result = new ej.DataManager(this._currentAppointmentData).executeLocal(queryManagar);
            }
            return result;
        },

        refreshScroller: function () {
            var scrollerObj = this.element.find('div#' + this._id + '_scroller').data("ejScroller");
            var scrollWidth = (this.model.orientation === "vertical") ? this.element.width() - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : this.element.width();
            scrollerObj.model.width = parseInt(scrollWidth) - 2;
            scrollerObj.model.height = this.scHeight - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
            scrollerObj.refresh();
            if (this.model.orientation == "vertical") {
                this._renderHoriVerticalScroll();
                this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                this.element.find(".e-headrealldaytable").css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
            }
            else {
                $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(this.element.find('.e-draggableworkarea').scrollLeft()) + "px");
                this.element.find(".e-horizontresdiv").height(this.element.find('.e-draggableworkarea').height());
            }
            this._reRenderHeaderBar();
            this.model.showAppointmentNavigator && this._refreshAppNavigation();
            if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            if ((this.currentView() == "month" || this._isCustomMonthView()) && this.model.orientation == "vertical")
                this._renderCurrentView("ScheduleResize");
            this._showScrollTd();
            this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
        },
        _refreshAppNavigation: function () {
            var base = this.element.find("#" + this._id + "_scroller");
            if ((this._browserInfo.name === "msie" && this._browserInfo.version < 9) || ej.isNullOrUndefined(base.data("ejScroller")))
                return;
            var scroll = (base.ejScroller('instance').isVScroll()) ? base.find(".e-vscroll").outerWidth() : 0;
            var top = (base.height() / 2) - (150 / 2);
            var timecell = this.element.find(".e-scrolltimecells").parent().outerWidth();
            timecell = ej.isNullOrUndefined(timecell) ? 0 : timecell;
            if (!this.model.enableRTL) {
                this.element.find(".e-prevapp").css({ top: (top + 40) + "px", transform: "rotate(90deg)", left: (timecell - 61) + "px" });
                this.element.find(".e-nextapp").css({ top: (top + 40) + "px", transform: "rotate(-90deg)", left: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
            }
            else {
                this.element.find(".e-prevapp").css({ top: (top + 40) + "px", transform: "rotate(-90deg)", right: (timecell - 61) + "px" });
                this.element.find(".e-nextapp").css({ top: (top + 40) + "px", transform: "rotate(90deg)", right: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
            }
        },
        getDifference: function (value) {
            var time = "";
            if (value.toString().indexOf("-") != -1) {
                time = value.toString().substring(value.toString().indexOf("-") + 1, value.toString().indexOf("-") + 5);
                return -(parseInt(time.substring(0, 2)) * 60) + parseInt(time.substring(2, 4));
            }
            else {
                time = value.toString().substring(value.toString().indexOf("+") + 1, value.toString().indexOf("+") + 5);
                return (parseInt(time.substring(0, 2)) * 60) + parseInt(time.substring(2, 4));
            }
        },
        exportSchedule: function (action, serverEvent, id) {
            var sampleModel = {}, processedApp = [], blockedApp = [];
            this._currentViewAppointments = this._appointmentCount();
            $.extend(true, sampleModel, this.model);
            $.extend(true, processedApp, this._currentViewAppointments);
            $.extend(true, blockedApp, this._processedIntervals);
            for (var i = 0; i < processedApp.length; i++) {
                processedApp[i][this._appointmentSettings["startTime"]] = new Date(processedApp[i][this._appointmentSettings["startTime"]].getTime() + (this.getDifference(processedApp[i][this._appointmentSettings["startTime"]]) * 60000));
                processedApp[i][this._appointmentSettings["endTime"]] = new Date(processedApp[i][this._appointmentSettings["endTime"]].getTime() + (this.getDifference(processedApp[i][this._appointmentSettings["endTime"]]) * 60000));
            }
            for (var a = 0; a < blockedApp.length; a++) {
                blockedApp[a][this.model.blockoutSettings["startTime"]] = new Date(blockedApp[a][this.model.blockoutSettings["startTime"]].getTime() + (this.getDifference(blockedApp[a][this.model.blockoutSettings["startTime"]]) * 60000));
                blockedApp[a][this.model.blockoutSettings["endTime"]] = new Date(blockedApp[a][this.model.blockoutSettings["endTime"]].getTime() + (this.getDifference(blockedApp[a][this.model.blockoutSettings["endTime"]]) * 60000));
            }
            var value = new Date(new Date(this.currentDate()).setHours(0, 0, 0));
            sampleModel.currentDate = new Date(value.getTime() + (this.getDifference(value) * 60000));
            var appointmentClone = JSON.parse(JSON.stringify(this._appointmentSettings));
            $.extend(true, sampleModel.appointmentSettings, appointmentClone);
            var blockAppsClone = JSON.parse(JSON.stringify(this.model.blockoutSettings));
            $.extend(true, sampleModel.blockoutSettings, blockAppsClone);
            var modelClone = JSON.parse(JSON.stringify(sampleModel));
            var attr = { action: action, method: 'post' };
            var form = ej.buildTag('form', "", null, attr);
            var view = this.currentView() == "day" ? "Day" : this.currentView() == "month" ? "Month" : this.currentView() == "week" ? "Week" : this.currentView() == "agenda" ? "Agenda" : this.currentView() == "workweek" ? "WorkWeek" : "CustomView";
            if (this._ignoreFromAppointmentOnExport) {
                for (var i = 0; i < this._ignoreFromAppointmentOnExport.length; i++) {
                    delete appointmentClone[this._ignoreFromAppointmentOnExport[i]];
                    delete blockAppsClone[this._ignoreFromAppointmentOnExport[i]];
                }
            }
            if (this._ignoreFromModelOnExport) {
                for (var i = 0; i < this._ignoreFromModelOnExport.length; i++) {
                    delete modelClone[this._ignoreFromModelOnExport[i]];
                }
            }
            delete modelClone.appointmentSettings.dataSource;
            delete modelClone.blockoutSettings.dataSource;
            if (ej.raiseWebFormsServerEvents) {
                var args = { model: modelClone, originalEventType: serverEvent };
                var clientArgs = { appSetting: JSON.stringify(appointmentClone), appId: id, processedApp: JSON.stringify(processedApp), blockedApp: JSON.stringify(blockedApp), model: JSON.stringify(modelClone), locale: this._getLocalizedLabels(view) + ',' + this._getLocalizedLabels("AllDay") + ',' + this._getLocalizedLabels("Date") + ',' + this._getLocalizedLabels("Time") + ',' + this._getLocalizedLabels("Event") };
                ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
            } else {
                var inputAttr = { name: 'ScheduleApps', type: 'hidden', value: JSON.stringify(appointmentClone) }
                var input = ej.buildTag('input', "", null, inputAttr);
                var blockInputAttr = { name: 'ScheduleBlockedApps', type: 'hidden', value: JSON.stringify(blockAppsClone) }
                var blockInput = ej.buildTag('input', "", null, blockInputAttr);
                var inputAttrModel = { name: 'ScheduleModel', type: 'hidden', value: JSON.stringify(modelClone) }
                var inputModel = ej.buildTag('input', "", null, inputAttrModel);
                var processedApp = { name: 'ScheduleProcesedApps', type: 'hidden', value: JSON.stringify(processedApp) }
                var inputApp = ej.buildTag('input', "", null, processedApp);
                var blockedApp = { name: 'ScheduleProcesedIntervalsApps', type: 'hidden', value: JSON.stringify(blockedApp) }
                var blockInputApp = ej.buildTag('input', "", null, blockedApp);
                var localeText = { name: 'Locale', type: 'hidden', value: this._getLocalizedLabels(view) + ',' + this._getLocalizedLabels("AllDay") + ',' + this._getLocalizedLabels("Date") + ',' + this._getLocalizedLabels("Time") + ',' + this._getLocalizedLabels("Event") }
                var inputLocale = ej.buildTag('input', "", null, localeText);
                form.append(inputModel);
                form.append(inputApp);
                form.append(blockInputApp);
                form.append(inputLocale);
                if (!ej.isNullOrUndefined(id)) {
                    var idAttr = { name: 'AppointmentId', type: 'hidden', value: id }
                    var inputId = ej.buildTag('input', "", null, idAttr);
                    form.append(inputId);
                }
                form.append(input);
                form.append(blockInput);
                form.append(this);
                $('body').append(form);
                form.submit();
            }
            return true;
        }
    });

    if (ej.scheduleFeatures.resources)
        $.extend(ej.Schedule.prototype, ej.scheduleFeatures.resources);
    if (ej.scheduleFeatures.horizontal)
        $.extend(ej.Schedule.prototype, ej.scheduleFeatures.horizontal);

    ej.Schedule.Locale = ej.Schedule.Locale || {};
    ej.Schedule.Locale['default'] = ej.Schedule.Locale["en-US"] = {
        ReminderWindowTitle: "Reminder window",
        CreateAppointmentTitle: "Create Appointment",
        RecurrenceEditTitle: "Edit Repeat Appointment",
        RecurrenceEditMessage: "How would you like to change the appointment in the series?",
        RecurrenceEditOnly: "Only this appointment",
        RecurrenceEditSeries: "Entire series",
        PreviousAppointment: "Previous Appointment",
        NextAppointment: "Next Appointment",
        AppointmentSubject: "Subject",
        StartTime: "Start Time",
        EndTime: "End Time",
        AllDay: "All day",
        StartTimeZone: "Start TimeZone",
        EndTimeZone: "End TimeZone",
        Today: "Today",
        Recurrence: "Repeat",
        Done: "Done",
        Cancel: "Cancel",
        Ok: "OK",
        Repeat: "Repeat",
        RepeatBy: "Repeat by",
        RepeatEvery: "Repeat every",
        RepeatOn: "Repeat on",
        StartsOn: "Starts on",
        Ends: "Ends",
        Summary: "Summary",
        Daily: "Daily",
        Weekly: "Weekly",
        Monthly: "Monthly",
        Yearly: "Yearly",
        Every: "Every",
        EveryWeekDay: "Every weekday",
        Never: "Never",
        After: "After",
        Occurrence: "Occurrence(s)",
        On: "On",
        Edit: "Edit",
        RecurrenceDay: "Day(s)",
        RecurrenceWeek: "Week(s)",
        RecurrenceMonth: "Month(s)",
        RecurrenceYear: "Year(s)",
        The: "The",
        OfEvery: "of every",
        First: "First",
        Second: "Second",
        Third: "Third",
        Fourth: "Fourth",
        Last: "Last",
        WeekDay: "Weekday",
        WeekEndDay: "Weekendday",
        Subject: "Subject",
        Categorize: "Categories",
        DueIn: "Due In",
        DismissAll: "Dismiss All",
        Dismiss: "Dismiss",
        OpenItem: "Open Item",
        Snooze: "Snooze",
        Day: "Day",
        Week: "Week",
        WorkWeek: "Work Week",
        Month: "Month",
        AddEvent: "Add Event",
        CustomView: "Custom View",
        Agenda: "Agenda",
        Detailed: "Edit Appointment",
        EventBeginsin: "Appointment Begins in",
        Editevent: "Edit Appointment",
        Editseries: "Edit Series",
        Times: "times",
        Until: "until",
        Eventwas: "Appointment was",
        Hours: "hrs",
        Minutes: "mins",
        Overdue: "Overdue Appointment",
        Days: "day(s)",
        Event: "Event",
        Select: "select",
        Previous: "Previous",
        Next: "Next",
        Close: "Close",
        Delete: "Delete",
        Date: "Date",
        Showin: "Show in",
        Gotodate: "Go To Date",
        Resources: "RESOURCES",
        RecurrenceDeleteTitle: "Delete Repeat Appointment",
        Location: "Location",
        Priority: "Priority",
        RecurrenceAlert: "Alert",
        RecurrenceDateValidation: "Some months have fewer than selected dates. For these months, the occurrence will fall on the last date of the month.",
        NoTitle: "No Title",
        OverFlowAppCount: "more appointment(s)",
        AppointmentIndicator: "Click for more appointments",
        WrongPattern: "The recurrence pattern is not valid",
        CreateError: "The duration of the appointment must be shorter than how frequently it occurs. Shorten the duration, or change the recurrence pattern in the Appointment Recurrence dialog box.",
        DragResizeError: "Cannot reschedule an occurrence of the recurring appointment if it skips over a later occurrence of the same appointment.",
        StartEndError: "End time should be greater than start time",
        SeriesChangeAlert: "The changes made to specific instances of this series will be cancelled and those appointments will match the series again.",
        MouseOverDeleteTitle: "Delete Appointment",
        DeleteConfirmation: "Are you sure you want to delete this appointment?",
        Time: "Time",
        EmptyResultText: "No suggestions",
        BlockIntervalAlertTitle: "Alert",
        BlockIntervalError: "The selected time interval has been blocked and is unavailable for selection."
    };

    ej.Schedule.Actions = {
        Add: "add",
        Save: "save",
        Delete: "delete",
        DeleteOccurrence: "deleteOccurrence",
        DeleteSeries: "deleteSeries",
        EditOccurrence: "editOccurrence",
        EditSeries: "editSeries"
    };

    ej.Schedule.CurrentView = {
        Day: "day",
        Week: "week",
        Workweek: "workweek",
        Month: "month",
        CustomView: "customview",
        Agenda: "agenda"
    };

    ej.Schedule.TimeMode = {
        Hour12: "12",
        Hour24: "24"
    };

    ej.Schedule.Orientation = {
        Vertical: "vertical",
        Horizontal: "horizontal"
    };
    ej.Schedule.DayOfWeek = {
        Sunday: "Sunday",
        Monday: "Monday",
        Tuesday: "Tuesday",
        Wednesday: "Wednesday",
        Thursday: "Thursday",
        Friday: "Friday",
        Saturday: "Saturday"
    };
})(jQuery, Syncfusion);;
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var RecurrenceEditor = (function (_super) {
    __extends(RecurrenceEditor, _super);
    function RecurrenceEditor(element, options) {
        _super.call(this);
        this.defaults = {
            frequencies: ["never", "daily", "weekly", "monthly", "yearly", "everyweekday"],
            firstDayOfWeek: null,
            enableSpinners: true,
            startDate: new Date(),
            locale: "en-US",
            enableRTL: false,
            value: "",
            dateFormat: "",
            selectedRecurrenceType: 0,
            minDate: new Date(1900, 1, 1),
            maxDate: new Date(2099, 12, 31),
            cssClass: "",
            change: null,
            create: null
        };
        this.dataTypes = {
            frequencies: "array",
            enableSpinners: "boolean",
            enableRTL: "boolean",
        };
        this.rootCSS = "e-recurrenceeditor";
        this.PluginName = "ejRecurrenceEditor";
        this._id = "null";
        this.validTags = ["div"];
        this.model = this.defaults;
        if (element) {
            this._id = element[0].id;
            if (!element["jquery"])
                element = $('#' + element);
            if (element.length) {
                return $(element).ejRecurrenceEditor(options).data(this.PluginName);
            }
        }
    }
    RecurrenceEditor.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    RecurrenceEditor.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };
    RecurrenceEditor.prototype._setModel = function (options) {
        var flag = false;
        for (var key in options) {
            switch (key) {
                case "frequencies":
                    this.model.frequencies = options[key];
                    flag = true;
                    break;
                case "firstDayOfWeek":
                    this.model.firstDayOfWeek = this._firstDayOfWeek = options[key];
                    flag = true;
                    break;
                case "enableSpinners":
                    this.model.enableSpinners = options[key];
                    flag = true;
                    break;
                case "startDate":
                    if ($.type(options[key]) == "string")
                        this._currentDateFormat(this.model.dateFormat);
                    else if ($.type(options[key]) == "function" && $.type(ej.util.getVal(options[key])) == "string")
                        this.model.startDate = ej.parseDate(this.model.startDate.toString(), this._datepattern());
                    ((this.model.startDate < this.model.minDate) ? this.model.startDate = this.model.minDate : "");
                    ((this.model.startDate > this.model.maxDate) ? this.model.startDate = this.model.maxDate : "");
                    this._recurrenceContent.find('.recurstartdate').ejDatePicker("option", "value", this.model.startDate);
                    break;
                case "locale":
                    this.model.locale = options[key];
                    flag = true;
                    break;
                case "enableRTL":
                    this.model.enableRTL = options[key];
                    this._recurrenceLayout.addClass('e-rtl');
                    break;
                case "value":
                    this.model.value = options[key];
                    break;
                case "dateFormat":
                    this.model.dateFormat = options[key];
                    this._recurrenceContent.find('.recurstartdate').ejDatePicker("option", "dateFormat", this.model.dateFormat);
                    this._recurrenceContent.find('.until').ejDatePicker("option", "dateFormat", this.model.dateFormat);
                    break;
                case "selectedRecurrenceType":
                    this.model.selectedRecurrenceType = options[key];
                    this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: this.model.selectedRecurrenceType });
                    break;
                case "minDate":
                case "maxDate":
                    this._currentDateFormat(this.model.dateFormat);
                    this._recurrenceContent.find('.recurstartdate').ejDatePicker({ minDate: this.model.minDate, maxDate: this.model.maxDate });
                    break;
                case "cssClass":
                    this.model.cssClass = options[key];
                    this.element.removeClass(this.model.cssClass).addClass(options[key]);
                    break;
            }
            if (flag == true)
                this._render();
        }
    };
    RecurrenceEditor.prototype._init = function () {
        if (!ej.isNullOrUndefined(this.element))
            this._render();
    };
    RecurrenceEditor.prototype._destroy = function () {
        this.element.off();
        var $formElements = this.element.find('.e-datepicker,.e-dropdownlist');
        for (var index = 0; index < $formElements.length; index++) {
            var $element = $($formElements[index]);
            if ($element.hasClass('e-datepicker'))
                $element.ejDatePicker("destroy");
            else if ($element.hasClass('e-dropdownlist'))
                $element.ejDropDownList("destroy");
        }
        this.element.empty().removeClass("e-recurrenceeditor");
    };
    RecurrenceEditor.prototype._render = function () {
        $("#" + this._id + "recurrenceeditor").remove();
        this._currentDateFormat(this.model.dateFormat);
        this._initializePrivateProperties();
        var hasScrollbar = (typeof window.innerWidth === 'number') && window.innerWidth > document.documentElement.clientWidth;
        this._mediaQuery = (this._browserInfo.name == "msie" && parseInt(this._browserInfo.version, 10) <= 8) ? false : (document.documentElement.clientWidth + (hasScrollbar ? 17 : 0) < 361 || ej.isMobile());
        this.model.frequencies = this.model.frequencies.toString().toLowerCase().split(",");
        for (var i = 0; i < this.model.frequencies.length; i++) {
            if (this.model.frequencies[i] == "everyweekday")
                this.model.frequencies[i] = "EveryWeekDay";
            else
                this.model.frequencies[i] = this.model.frequencies[i].replace(/^./, function (str) { return str.toUpperCase(); });
        }
        this._renderRecurrenceEditor();
    };
    RecurrenceEditor.prototype._initializePrivateProperties = function () {
        this._rRule = {};
        this.flag = true;
        this._subControlChange = false;
        this._culture = ej.preferredCulture(this.model.locale);
        this._dayNamesArray = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
        this._firstDayOfWeek = (this.model.firstDayOfWeek != null) ? (typeof this.model.firstDayOfWeek == "string") ? this._dayNamesArray.indexOf(this.model.firstDayOfWeek.toString().toLowerCase()) : this.model.firstDayOfWeek : this._culture.calendar.firstDay;
        this._monthNames = this._culture.calendar.months.names;
        this._pattern = this._culture.calendar.patterns;
        this._browserInfo = ej.browserInfo();
        this._dayNamesValue = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"];
        this._dayNames = [];
        this._dayShortNames = [];
        this._dayFullNames = [];
        var index = this._firstDayOfWeek;
        do {
            if (index > 6)
                index = 0;
            this._dayFullNames.push(this._culture.calendar.days.names[index]);
            this._dayShortNames.push(this._culture.calendar.days.namesAbbr[index]);
            this._dayNames.push(this._dayNamesValue[index]);
            index++;
        } while (this._dayNames.length < 7);
        this._mediaQuery = false;
    };
    RecurrenceEditor.prototype._currentDateFormat = function (option) {
        var minDate, maxDate;
        if (!ej.isNullOrUndefined(option) && ($.type(this.model.startDate) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
            var date = ej.parseDate(this.model.startDate.toString(), this.model.dateFormat);
            minDate = ej.parseDate(this.model.minDate.toString(), this.model.dateFormat);
            maxDate = ej.parseDate(this.model.maxDate.toString(), this.model.dateFormat);
            this.model.startDate = ((!ej.isNullOrUndefined(date)) ? date : ((new Date(this.model.startDate.toString()).toString() == "Invalid Date" || new Date(this.model.startDate.toString()).toString() == "NaN") ? this._dateConvert(this.model.startDate) : new Date(this.model.startDate.toString())));
            this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : ((new Date(this.model.minDate.toString()).toString() == "Invalid Date" || new Date(this.model.minDate.toString()).toString() == "NaN") ? this._dateConvert(this.model.minDate) : new Date(this.model.minDate.toString()));
            this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : ((new Date(this.model.maxDate.toString()).toString() == "Invalid Date" || new Date(this.model.maxDate.toString()).toString() == "NaN") ? this._dateConvert(this.model.maxDate) : new Date(this.model.maxDate.toString()));
        }
        else if (option == "MM/dd/yyyy" && ($.type(this.model.startDate) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
            var currentDate = ej.parseDate(this.model.startDate.toString(), option);
            minDate = ej.parseDate(this.model.minDate.toString(), option);
            maxDate = ej.parseDate(this.model.maxDate.toString(), option);
            this.model.startDate = (!ej.isNullOrUndefined(currentDate)) ? currentDate : this.model.startDate;
            this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : this.model.minDate;
            this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : this.model.maxDate;
        }
    };
    RecurrenceEditor.prototype._renderRecurrenceEditor = function () {
        this._recurrenceLayout = ej.buildTag('div#' + this._id + 'recurrenceeditor', "", {}, {});
        if (this.model.enableRTL)
            this._recurrenceLayout.addClass('e-rtl');
        var $recurWind = "<table style='width:100%'><tr><td style='width:20%'><div class='e-textlabel'>" + this._getLocalizedLabels("Repeat") + ":</div></td><td><input class='e-recurrencetype' id='" + this._id + "_recurrenceType' type='text' name='RecurrenceType' value='' /></td></tr></table><div id='" + this._id + "_recurtypelist'><ul>";
        for (var type = 0; type < this.model.frequencies.length; type++) {
            $recurWind += "<li>" + this._getLocalizedLabels(this.model.frequencies[type]) + "</li>";
        }
        $recurWind += "</ul></div>";
        this.element.append(this._recurrenceLayout.append($recurWind));
        this._renderRecurrenceContent();
        this._initialSubControlRender = true;
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_recurtypelist", width: (this._mediaQuery ? "140px" : "33%"), change: $.proxy(this._recurrenceTypeChange, this), cssClass: this.model.cssClass });
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: this.model.selectedRecurrenceType });
    };
    RecurrenceEditor.prototype._renderRecurrenceContent = function () {
        for (var i = 0; i < this._dayNames.length; i++)
            this._dayNames[i] = this._dayNames[i].toUpperCase();
        var startday = [this._getLocalizedLabels("First"), this._getLocalizedLabels("Second"), this._getLocalizedLabels("Third"), this._getLocalizedLabels("Fourth"), this._getLocalizedLabels("Last")];
        var margin = this.model.enableRTL ? "margin-right" : "margin-left";
        this._recurrenceContent = ej.buildTag('div.e-recurrencecontent#' + this._id + 'recurrencecontent', "", {}, {});
        if (this._mediaQuery) {
            var $recurCont = "<form id='" + this._id + "_recurrenceForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $recurCont += "<tr id='" + this._id + "_every' style='display:none'><td width='16%' id='everylabel' class='e-textlabel'>" + this._getLocalizedLabels("Every") + ":</td><td id='everycount' class='e-tdpadding'><table><tr><td><div class='e-floatleft'><input id='" + this._id + "_recurevery' class='recurevery' type='text' /></div></td>" +
                "<td><div id='" + this._id + "_recurtypes' class='e-appcheckbox e-labelcursor'>" + this._getLocalizedLabels("RecurrenceDay") + "</div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_weekly' class='" + this._id + "_weekly' style='display:none'><td colspan='2' id='weeklabel' class='e-textlabel'><div>" + this._getLocalizedLabels("RepeatOn") + ":</div></td></tr><tr class='" + this._id + "_weekly' style='display:none'>" +
                "<td colspan='2' id='weekcount'><table class='e-table' cellpadding='3'><tr>";
            for (var weekcount = 0; weekcount < this._dayShortNames.length; weekcount++) {
                $recurCont += "<td><div class='e-weekday " + this._dayShortNames[weekcount] + "'><input id='" + this._id + "_" + this._dayNames[weekcount] + "' class='weekdays e-weekly" + this._dayNames[weekcount] + "'name='weekdays' type='checkbox'/><label class='e-textmargin' for='" + this._id + "_" + this._dayNames[weekcount] + "'>" + this._dayShortNames[weekcount] + "</label></div></td>";
            }
            $recurCont += "</tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_monthly' class='" + this._id + "_monthly' style='display:none'><td colspan='2' id='monthlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td></tr><tr class='" + this._id + "_monthly' style='display:none'>" +
                "<td colspan='2' id='monthcount'><table class='e-table' cellpadding='3'><tr id='monthdaytr'><td><div><input id='" + this._id + "_monthday' class='monthdaytype' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthday'>" + this._getLocalizedLabels("Day") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthdate' class='monthdate' type='text'/></div></td></tr>" +
                "<tr id='monthweekdaytr'><td><div><input id='" + this._id + "_monthon' class='monthposition' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthon'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthsrt' class='monthsrt' type='text' name='monthsrt' value=''/><div id='" + this._id + "_monthsrtlist'><ul>";
            for (var day = 0; day < startday.length; day++) {
                $recurCont += "<li>" + startday[day] + "</li>";
            }
            $recurCont += "</div></div></td>";
            $recurCont += "<td><div class='e-appcheckbox e-labelcursor'><input id='" + this._id + "_monthsrtday' class='e-monthsrtday monthsrtday' type='text' name='monthsrtday' value=''/>" +
                "<div id='" + this._id + "_monthsrtdaylist'><ul>";
            for (var monthday = 0; monthday < this._dayFullNames.length; monthday++) {
                $recurCont += "<li>" + this._dayFullNames[monthday] + "</li>";
            }
            $recurCont += "</div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_yearly' class='" + this._id + "_yearly' style='display:none'><td colspan='2' id='yearlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td></tr><tr class='" + this._id + "_yearly' style='display:none'>" +
                "<td colspan='2' id='yearcount' ><table class='e-table' cellpadding='3'><tr id='yeardaytr'>" +
                "<td><div><input id='" + this._id + "_yearday' class='yearrecurday' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearday'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div class='e-controlalign'><input id='" + this._id + "_yearmonth' class='yearmonth' type='text' name='yearmonth' value=''/></div></td>" +
                "<div id='" + this._id + "_yearmonthlist'><ul>";
            for (var monthcount = 0; monthcount < (this._monthNames.length - 1); monthcount++) {
                $recurCont += "<li>" + this._monthNames[monthcount] + "</li>";
            }
            $recurCont += "</ul></div><td><input id='" + this._id + "_yeardate' class='yeardate' text='text'/></td></tr>" +
                "<tr id='yearweekdaytr'><td><div><input id='" + this._id + "_yearother' class='yearrecurposi' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearother'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_yearsrt' class='yearsrt' type='text' name='yearsrt' value=''/><div id='" + this._id + "_yearsrtlist'><ul>";
            for (var yearstartday = 0; yearstartday < startday.length; yearstartday++) {
                $recurCont += "<li>" + startday[yearstartday] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div class='e-controlalign'><input id='" + this._id + "_yearsrtday' class='yearsrtday' type='text' name='yearsrtday' value=''/>" +
                "<div id='" + this._id + "_yearsrtdaylist'><ul>";
            for (var yearweek = 0; yearweek < this._dayFullNames.length; yearweek++) {
                $recurCont += "<li>" + this._dayFullNames[yearweek] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div><span>" + this._getLocalizedLabels("OfEvery") + "</span></div></td></tr><tr><td></td><td><div><input id='" + this._id + "_yearsrtmonth' class='yearsrtmonth' type='text' name='yearsrtmonth' value=''/>" +
                "<div id='" + this._id + "_yearsrtmonthlist'><ul>";
            for (var yearmonth = 0; yearmonth < (this._monthNames.length - 1); yearmonth++) {
                $recurCont += "<li>" + this._monthNames[yearmonth] + "</li>";
            }
            $recurCont += "</ul></div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_startson' ><td colspan='2' id='startsonlabel' class='e-textlabel'>" + this._getLocalizedLabels("StartsOn") + ":</td></tr><tr>" +
                "<td colspan='2' id='startsoncount'><input id='" + this._id + "_recurstartdate' class='recurstartdate' type='text' name='RecurStartDate' value=''/></td></tr>";
            $recurCont += "<tr id='" + this._id + "_endson' ><td colspan='2' id='endsonlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("Ends") + ":</div></td></tr><tr>" +
                "<td colspan='2' id='endsoncount'><table class='e-table' cellpadding='3'><tr id='endsonnever'><td><div><input id='" + this._id + "_repeatendnever' class='recurends e-recurnoend' type='radio' name='" + this._id + "_repeatend' value='Never'/><label class='e-textmargin' for='" + this._id + "_repeatendnever'>" + this._getLocalizedLabels("Never") + "</label></div></td></tr>" +
                "<tr id='endsonafter'><td><div><input id='" + this._id + "_repeatendafter' class='recurends e-recurafter' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendafter'>" + this._getLocalizedLabels("After") + "</label>" +
                "</div></td><td><div><input id='" + this._id + "_recurcount' class='recurcount' type='text'/></div></td>" +
                "<td><span class='e-labelcursor' style='" + margin + ": -80px;'>" + this._getLocalizedLabels("Occurrence") + "</span></td></tr>" +
                "<tr id='endsonuntil'><td><div><input id='" + this._id + "_repeatendon' class='recurends e-recuruntil' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendon'>" + this._getLocalizedLabels("On") + "</label></div></td>" +
                "<td><input id='" + this._id + "_daily' class='e-until until' type='text' name='daily' value=''/></td></tr>  </table></td></tr>";
            $recurCont += "<tr style='display:none'><td><span class='e-textlabel'>Summary:</span></td><td><span class=e-recurRule></span></td></tr></tbody></table></form>";
        }
        else {
            var $recurCont = "<form id='" + this._id + "_recurrenceForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $recurCont += "<tr id='" + this._id + "_every' style='display:none'><td width='20%' id='everylabel' class='e-textlabel'>" + this._getLocalizedLabels("Every") + ":</td><td id='everycount' class='e-tdpadding'><table><tr><td><div class='e-floatleft'><input id='" + this._id + "_recurevery' class='recurevery' type='text' /></div></td>" +
                "<td><div id='" + this._id + "_recurtypes' class='e-appcheckbox e-labelcursor'>" + this._getLocalizedLabels("RecurrenceDay") + "</div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_weekly' class='" + this._id + "_weekly' style='display:none'><td id='weeklabel' class='e-textlabel'><div>" + this._getLocalizedLabels("RepeatOn") + ":</div></td>" +
                "<td id='weekcount'><table class='e-table' cellpadding='3'><tr>";
            for (var weekcount = 0; weekcount < this._dayShortNames.length; weekcount++) {
                $recurCont += "<td><div class='e-weekday " + this._dayShortNames[weekcount] + "'><input id='" + this._id + "_" + this._dayNames[weekcount] + "' class='weekdays e-weekly" + this._dayNames[weekcount] + "'name='weekdays' type='checkbox'/><label class='e-textmargin' for='" + this._id + "_" + this._dayNames[weekcount] + "'>" + this._dayShortNames[weekcount] + "</label></div></td>";
            }
            $recurCont += "</tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_monthly' class='" + this._id + "_monthly' style='display:none'><td id='monthlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td>" +
                "<td id='monthcount'><table class='e-table' cellpadding='3'><tr id='monthdaytr'><td><div><input id='" + this._id + "_monthday' class='monthdaytype' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthday'>" + this._getLocalizedLabels("Day") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthdate' class='monthdate' type='text'/></div></td></tr>" +
                "<tr id='monthweekdaytr'><td><div><input id='" + this._id + "_monthon' class='monthposition' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthon'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthsrt' class='monthsrt' type='text' name='monthsrt' value=''/><div id='" + this._id + "_monthsrtlist'><ul>";
            for (var day = 0; day < startday.length; day++) {
                $recurCont += "<li>" + startday[day] + "</li>";
            }
            $recurCont += "</div></div></td>";
            $recurCont += "<td><div class='e-appcheckbox e-labelcursor'><input id='" + this._id + "_monthsrtday' class='e-monthsrtday monthsrtday' type='text' name='monthsrtday' value=''/>" +
                "<div id='" + this._id + "_monthsrtdaylist'><ul>";
            for (var monthday = 0; monthday < this._dayFullNames.length; monthday++) {
                $recurCont += "<li>" + this._dayFullNames[monthday] + "</li>";
            }
            $recurCont += "</div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_yearly' class='" + this._id + "_yearly' style='display:none'><td id='yearlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td>" +
                "<td id='yearcount' ><table class='e-table' cellpadding='3'><tr id='yeardaytr'>" +
                "<td><div><input id='" + this._id + "_yearday' class='yearrecurday' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearday'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div class='e-controlalign'><input id='" + this._id + "_yearmonth' class='yearmonth' type='text' name='yearmonth' value=''/></div></td>" +
                "<div id='" + this._id + "_yearmonthlist'><ul>";
            for (var monthcount = 0; monthcount < (this._monthNames.length - 1); monthcount++) {
                $recurCont += "<li>" + this._monthNames[monthcount] + "</li>";
            }
            $recurCont += "</ul></div><td><input id='" + this._id + "_yeardate' class='yeardate' text='text'/></td></tr>" +
                "<tr id='yearweekdaytr'><td><div><input id='" + this._id + "_yearother' class='yearrecurposi' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearother'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_yearsrt' class='yearsrt' type='text' name='yearsrt' value=''/><div id='" + this._id + "_yearsrtlist'><ul>";
            for (var yearstartday = 0; yearstartday < startday.length; yearstartday++) {
                $recurCont += "<li>" + startday[yearstartday] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div class='e-controlalign'><input id='" + this._id + "_yearsrtday' class='yearsrtday' type='text' name='yearsrtday' value=''/>" +
                "<div id='" + this._id + "_yearsrtdaylist'><ul>";
            for (var yearweek = 0; yearweek < this._dayFullNames.length; yearweek++) {
                $recurCont += "<li>" + this._dayFullNames[yearweek] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div><span>" + this._getLocalizedLabels("OfEvery") + "</span></div></td><td><div><input id='" + this._id + "_yearsrtmonth' class='yearsrtmonth' type='text' name='yearsrtmonth' value=''/>" +
                "<div id='" + this._id + "_yearsrtmonthlist'><ul>";
            for (var yearmonth = 0; yearmonth < (this._monthNames.length - 1); yearmonth++) {
                $recurCont += "<li>" + this._monthNames[yearmonth] + "</li>";
            }
            $recurCont += "</ul></div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_startson' style='display:none'><td width='20%' id='startsonlabel' class='e-textlabel'>" + this._getLocalizedLabels("StartsOn") + ":</td>" +
                "<td id='startsoncount'><input id='" + this._id + "_recurstartdate' class='recurstartdate' type='text' name='RecurStartDate' value=''/></td></tr>";
            $recurCont += "<tr id='" + this._id + "_endson' style='display:none'><td id='endsonlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("Ends") + ":</div></td>" +
                "<td id='endsoncount'><table class='e-table' cellpadding='3'><tr id='endsonnever'><td><div><input id='" + this._id + "_repeatendnever' class='recurends e-recurnoend' type='radio' name='" + this._id + "_repeatend' value='Never'/><label class='e-textmargin' for='" + this._id + "_repeatendnever'>" + this._getLocalizedLabels("Never") + "</label></div></td></tr>" +
                "<tr id='endsonafter'><td><div><input id='" + this._id + "_repeatendafter' class='recurends e-recurafter' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendafter'>" + this._getLocalizedLabels("After") + "</label>" +
                "</div></td><td><div><input id='" + this._id + "_recurcount' class='recurcount' type='text'/></div></td>" +
                "<td><span class='e-labelcursor' style='" + margin + ": -80px;'>" + this._getLocalizedLabels("Occurrence") + "</span></td></tr>" +
                "<tr id='endsonuntil'><td><div><input id='" + this._id + "_repeatendon' class='recurends e-recuruntil' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendon'>" + this._getLocalizedLabels("On") + "</label></div></td>" +
                "<td><input id='" + this._id + "_daily' class='e-until until' type='text' name='daily' value=''/></td></tr>  </table></td></tr>";
            $recurCont += "<tr style='display:none'><td><span class='e-textlabel'>Summary:</span></td><td><span class=e-recurRule></span></td></tr></tbody></table></form>";
        }
        this._recurrenceLayout.append(this._recurrenceContent.append($recurCont));
        this._renderControls();
    };
    RecurrenceEditor.prototype._renderControls = function () {
        var control = this._recurrenceContent;
        control.find('.weekdays').ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._weeklyClick, this) });
        control.find('.monthsrt').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_monthsrtlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._monthSrt, this) });
        control.find('.monthsrtday').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_monthsrtdaylist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._monthSrt, this) });
        control.find('.yearsrt').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearsrtlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearsrt, this) });
        control.find('.yearmonth').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearmonthlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearmonth, this) });
        control.find('.yearsrtday').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearsrtdaylist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearsrt, this) });
        control.find('.yearsrtmonth').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearsrtmonthlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearsrt, this) });
        control.find('.recurstartdate').ejDatePicker({ buttonText: "Today", startDay: this._firstDayOfWeek, enableRTL: this.model.enableRTL, locale: this.model.locale, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, value: this.model.startDate, minDate: this.model.minDate, maxDate: this.model.maxDate, change: $.proxy(this._startDateChange, this) });
        control.find('.until').ejDatePicker({ buttonText: "Today", startDay: this._firstDayOfWeek, enableRTL: this.model.enableRTL, locale: this.model.locale, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, change: $.proxy(this._recurUntil, this) });
        control.find('.recurcount').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "recurcount", minValue: 1, value: 10, width: "65px", decimalPlaces: 0, cssClass: this.model.cssClass, change: $.proxy(this._recurCount, this) });
        control.find('.recurevery').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "recurevery", minValue: 1, value: 1, decimalPlaces: 0, width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._everyCount, this) });
        control.find('.monthdate').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "monthdate", minValue: 1, decimalPlaces: 0, maxValue: 31, value: 1, width: "70px", cssClass: this.model.cssClass, change: $.proxy(this._monthDate, this) });
        control.find('.yeardate').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "yeardate", minValue: 1, decimalPlaces: 0, maxValue: 31, value: 1, width: "70px", cssClass: this.model.cssClass, change: $.proxy(this._yearmonth, this) });
        control.find('.recurends').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._recurEndChange, this) });
        control.find('.monthposition,.monthdaytype').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._recurEndChange, this) });
        control.find('.yearrecurposi,.yearrecurday').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._recurEndChange, this) });
    };
    RecurrenceEditor.prototype._recurrenceTypeChange = function (args) {
        this._recurrenceType(args);
        if (this._rRuleFreq != "")
            this.closeRecurPublic();
        if (this._rRuleFreq == "") {
            this._recRule = undefined;
        }
        this._trigger("change", { recurrenceRule: this._recRule });
    };
    RecurrenceEditor.prototype._recurrenceType = function (args) {
        this._rRuleFreq = "";
        var _rule = "";
        var strDate = ($.type(this.model.startDate) == "string") ? this._dateConvert(this.model.startDate) : this.model.startDate;
        if (this.flag) {
            this._subControlChange = true;
            this._recurrenceContent.find('.until').ejDatePicker({ value: new Date(new Date(strDate.toDateString()).setDate(new Date(strDate.toDateString()).getDate() + 7 * 10)) });
            this._subControlChange = false;
            this._recurrenceContent.find(".e-recurnoend").ejRadioButton({ checked: true });
            this.flag = false;
        }
        !this._mediaQuery && this._recurrenceContent.find("#" + this._id + "_startson,#" + this._id + "_endson").css("display", "table-row");
        if (args.itemId != null) {
            this._recurrenceContent.find("#" + this._id + "_every").css("display", "table-row");
            var selectedType = this._getLocalizedLabels(this.model.frequencies[args.itemId]);
            switch (selectedType) {
                case this._getLocalizedLabels("Never"):
                    this._recurrenceContent.css("display", "none");
                    break;
                case this._getLocalizedLabels("Daily"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceDay");
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_monthly,." + this._id + "_yearly").css("display", "none");
                    this._rRuleFreq = "DAILY";
                    _rule = this._getLocalizedLabels("RecurrenceDay").toLowerCase();
                    break;
                case this._getLocalizedLabels("Weekly"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceWeek");
                    var curDay = this._dayShortNames.indexOf(ej.format(strDate, "ddd", this.model.locale));
                    this._initialSubControlRender = true;
                    this._recurrenceContent.find(".e-weekly" + this._dayNames[curDay]).ejCheckBox({ checked: true });
                    _rule = this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._dayFullNames[strDate.getDay()];
                    this._rRuleFreq = "WEEKLY";
                    this._recurrenceContent.find("." + this._id + "_monthly,." + this._id + "_yearly").css("display", "none");
                    this._recurrenceContent.find("." + this._id + "_weekly").css("display", "table-row");
                    break;
                case this._getLocalizedLabels("Monthly"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceMonth");
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_yearly").css("display", "none");
                    this._recurrenceContent.find("." + this._id + "_monthly").css("display", "table-row");
                    this._initialSubControlRender = true;
                    this._recurrenceContent.find('.monthdate').ejNumericTextbox({ value: strDate.getDate() });
                    this._recurrenceContent.find('.monthsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf((ej.format(strDate, "ddd", "en-US").substr(0, 2)).toUpperCase()) });
                    this._recurrenceContent.find('.monthsrt').ejDropDownList({ selectedItemIndex: this._getWeekIndex(strDate) });
                    this._recurrenceContent.find('.monthdaytype').ejRadioButton({ checked: true });
                    this._rRuleFreq = "MONTHLY";
                    _rule = this._getLocalizedLabels("RecurrenceMonth").toLowerCase();
                    break;
                case this._getLocalizedLabels("Yearly"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceYear");
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_monthly").css("display", "none");
                    this._recurrenceContent.find("." + this._id + "_yearly").css("display", "table-row");
                    this._initialSubControlRender = true;
                    this._recurrenceContent.find('.yearmonth').ejDropDownList({ selectedItemIndex: strDate.getMonth() });
                    this._recurrenceContent.find('.yeardate').ejNumericTextbox({ value: strDate.getDate() });
                    this._recurrenceContent.find('.yearsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf((ej.format(strDate, "ddd", "en-US").substr(0, 2)).toUpperCase()) });
                    this._recurrenceContent.find('.yearsrtmonth').ejDropDownList({ selectedItemIndex: strDate.getMonth() });
                    this._recurrenceContent.find('.yearsrt').ejDropDownList({ selectedItemIndex: this._getWeekIndex(strDate) });
                    this._recurrenceContent.find('.yearrecurday').ejRadioButton({ checked: true });
                    this._rRuleFreq = "YEARLY";
                    _rule = this._getLocalizedLabels("RecurrenceYear").toLowerCase();
                    break;
                case this._getLocalizedLabels("EveryWeekDay"):
                    this._recurrenceContent.css("display", "block");
                    this._rRuleFreq = "WEEKDAYS";
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_yearly,#" + this._id + "_every,." + this._id + "_monthly").css("display", "none");
                    _rule = args.text;
                    break;
            }
            this._initialSubControlRender = false;
        }
        this._recurrenceContent.find(".e-recurRule").html(_rule);
    };
    RecurrenceEditor.prototype._getWeekIndex = function (curDate) {
        var index = 0;
        var firstDate = new Date(curDate.getFullYear(), curDate.getMonth(), 1);
        var dayIndex = curDate.getDay();
        if (dayIndex != firstDate.getDay())
            do {
                firstDate = new Date(firstDate.setDate(firstDate.getDate() + 1));
            } while (dayIndex != firstDate.getDay());
        while (firstDate.getDate() != curDate.getDate()) {
            firstDate = new Date(firstDate.setDate(firstDate.getDate() + 7));
            index++;
        }
        return index;
    };
    RecurrenceEditor.prototype._weeklyClick = function () {
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._monthSrt = function () {
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_monthon").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._yearsrt = function () {
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_yearother").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._yearmonth = function () {
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_yearday").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._startDateChange = function (args) {
        this.model.startDate = new Date(args.model.value);
        if (!this._recurrenceContent.find("#" + this._id + "_repeatendon").ejRadioButton("model.checked") || (this.model.startDate > this._recurrenceContent.find(".until").ejDatePicker("option", "value"))) {
            this._subControlChange = true;
            this._recurrenceContent.find(".until").ejDatePicker("option", "value", new Date(new Date(args.model.value).setDate(args.model.value.getDate() + 7 * 10)));
        }
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._recurUntil = function (args) {
        if (this._subControlChange)
            return;
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_repeatendon").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._recurCount = function (args) {
        this._recurrenceContent.find("#" + this._id + "_repeatendafter").ejRadioButton("option", "checked", true);
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._everyCount = function () {
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._monthDate = function () {
        this._recurrenceContent.find("#" + this._id + "_monthday").ejRadioButton("option", "checked", true);
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._recurEndChange = function () {
        if (this._subControlChange)
            return;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._stringGenerate = function () {
        this.closeRecurPublic();
        this._trigger("change", { recurrenceRule: this._recRule });
    };
    RecurrenceEditor.prototype._findInterval = function (numericElement) {
        var interval;
        interval = numericElement.ejNumericTextbox("model.value");
        return interval = ej.isNullOrUndefined(interval) ? 0 : interval;
    };
    RecurrenceEditor.prototype._weeklyDayFind = function (strDate, days) {
        var newdayStr = strDate;
        do {
            newdayStr = new Date(newdayStr.setDate(newdayStr.getDate() + 1));
            var curDay = this._dayNamesValue[new Date(newdayStr).getDay()].toUpperCase();
        } while (days.indexOf(curDay) == -1);
        return newdayStr;
    };
    RecurrenceEditor.prototype._dayOfWeekInMonth = function (strDate, dayName, weekIndex) {
        var dayIndex = this._dayNamesValue.indexOf(dayName);
        var curDate = weekIndex == -1 ? new Date(strDate.getFullYear(), strDate.getMonth() + 1, 0) : new Date(strDate.getFullYear(), strDate.getMonth(), 1);
        while (curDate.getDay() != dayIndex) {
            curDate = new Date(weekIndex == -1 ? curDate.setDate(curDate.getDate() - 1) : curDate.setDate(curDate.getDate() + 1));
        }
        var curIndex = Math.abs(Math.ceil((curDate.getDate() - 1 - curDate.getDay()) / 7));
        return new Date(weekIndex == 1 || weekIndex == -1 ? curDate.toString() : new Date(curDate.setDate(curDate.getDate() + ((weekIndex - curIndex - 1) * 7))).toString());
    };
    RecurrenceEditor.prototype._findRecurCount = function (_interval, byDay, objValue) {
        var _count = 0, _interval, byDay, wTrue = false, ractualDate, rincrDate, interCount = this._interval;
        var day_start = new Date(this._recurrenceContent.find('.recurstartdate').ejDatePicker("model.value"));
        if (!ej.isNullOrUndefined(this._actualDate) && this._actualDate != 0) {
            var lastdate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0);
            day_start = lastdate.getDate() < this._actualDate ? lastdate : new Date(day_start.getFullYear(), day_start.getMonth(), this._actualDate);
        }
        rincrDate = ractualDate = new Date(day_start.toString());
        var recurEndDate = new Date(this.element.find('.e-until').ejDatePicker("model.value"));
        while (day_start <= recurEndDate) {
            switch (this._rRuleFreq) {
                case "DAILY":
                    day_start = new Date(day_start.setDate(day_start.getDate() + _interval));
                    wTrue = true;
                    break;
                case "WEEKLY":
                case "WEEKDAYS":
                    var wDays = byDay.split(",");
                    var curDay = objValue._dayNames[new Date(day_start.toString()).getDay()];
                    for (var b = 0; b < wDays.length; b++) {
                        if (wDays[b] == curDay) {
                            if (interCount == this._interval) {
                                wTrue = true;
                                interCount = 1;
                                break;
                            }
                            interCount++;
                        }
                    }
                    break;
                case "MONTHLY":
                    day_start = new Date(day_start.setMonth(day_start.getMonth() + _interval));
                    if (!ej.isNullOrUndefined(this._month) && this._month && ractualDate.getMonth() > day_start.getMonth())
                        day_start = new Date(day_start.setDate(ractualDate.getDate()));
                    if (day_start.getDate() != rincrDate.getDate() && (ej.isNullOrUndefined(this._month) || !this._month)) {
                        this._month = true;
                        day_start = new Date(day_start.setDate(day_start.getDate() - day_start.getDate()));
                    }
                    wTrue = true;
                    break;
                case "YEARLY":
                    day_start = new Date(day_start.setFullYear(day_start.getFullYear() + _interval));
                    wTrue = true;
                    break;
            }
            (wTrue) && _count++;
            wTrue = false;
            if (this._rRuleFreq == "WEEKLY" || this._rRuleFreq == "WEEKDAYS") {
                day_start = new Date(day_start.setDate(day_start.getDate() + 1));
            }
            rincrDate = new Date(day_start.toString());
        }
        this._month = false;
        this._actualDate = 0;
        return _count;
    };
    RecurrenceEditor.prototype._getLocalizedLabels = function (prop) {
        return ej.isNullOrUndefined(ej.RecurrenceEditor.Locale[this.model.locale]) ? ej.RecurrenceEditor.Locale["en-US"][prop] : ej.RecurrenceEditor.Locale[this.model.locale][prop];
    };
    RecurrenceEditor.prototype._datepattern = function () {
        return (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) ? this.model.dateFormat : this._pattern.d;
    };
    RecurrenceEditor.prototype._dateConvert = function (dateString) {
        if (!ej.isNullOrUndefined(dateString)) {
            var convertedDate = new Date(parseInt(dateString.match(/\d+/).toString()));
            convertedDate = $.type(convertedDate) == "date" ? convertedDate : new Date();
        }
        else
            convertedDate = null;
        return convertedDate;
    };
    RecurrenceEditor.prototype.recurrenceDateGenerator = function (recurrenceString, strDate, recurExDate) {
        var RecDateCollection = [], weeklyRule = recurrenceString.split(';');
        this._recurDates = {};
        var day_start = new Date(strDate), _count = 0;
        var rincrDate, ractualDate, rcurrentDate, recurEndDate;
        rcurrentDate = new Date(day_start);
        if (ej.isNullOrUndefined(recurExDate))
            recurExDate = null;
        this.recurrenceRuleSplit(recurrenceString, recurExDate);
        if (ej.isNullOrUndefined(this._rRule.recurEditId)) {
            var byDay = "", _interval = ej.isNullOrUndefined(this._rRule.interval) ? 1 : this._rRule.interval;
            !ej.isNullOrUndefined(this._rRule.weekDays) && (byDay = this._rRule.weekDays.split(','));
            if (!ej.isNullOrUndefined(this._rRule.until)) {
                recurEndDate = new Date(this._rRule.until);
                recurEndDate.setDate(recurEndDate.getDate() + 1);
            }
            else if (!ej.isNullOrUndefined(this._rRule.count))
                switch (this._rRule.freq) {
                    case "DAILY":
                        recurEndDate = new Date(new Date(day_start).setDate(day_start.getDate() + this._rRule.count * (_interval)));
                        break;
                    case "WEEKLY":
                        var dayCount = day_start.getDate() + (((this._rRule.count / byDay.length) * 7)) * (_interval);
                        recurEndDate = new Date(new Date(day_start).setDate(Math.round(dayCount) < dayCount ? dayCount + 1 : dayCount));
                        break;
                    case "MONTHLY":
                        recurEndDate = new Date(new Date(day_start).setMonth(day_start.getMonth() + this._rRule.count * (_interval)));
                        break;
                    case "YEARLY":
                        recurEndDate = new Date(new Date(day_start).setFullYear(day_start.getFullYear() + this._rRule.count * (_interval)));
                        break;
                }
            else
                recurEndDate = new Date(new Date(this.model.startDate.toString()).setDate(day_start.getDate() + 42 * (_interval)));
            switch (this._rRule.freq) {
                case "WEEKLY":
                    byDay = this._rRule.weekDays.split(',');
                    if (byDay.indexOf(this._dayNamesValue[new Date(day_start).getDay()].toUpperCase()) == -1)
                        day_start = this._weeklyDayFind(day_start, byDay);
                    break;
                case "MONTHLY":
                    if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                        var _lastDay = new Date(day_start).getDate() == new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() ? true : false;
                        while (new Date(day_start).getDate() != this._rRule.monthDay) {
                            day_start = new Date(day_start.setDate(day_start.getDate() + 1));
                        }
                    }
                    else
                        day_start = new Date((this._getWeekIndex(day_start) + 1) > this._rRule.setPositions && this._rRule.setPositions != -1 ? new Date(day_start.getFullYear(), day_start.getMonth(), 1) : day_start);
                    rincrDate = ractualDate = new Date(day_start);
                    break;
                case "YEARLY":
                    if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                        var appMonth = new Date(rcurrentDate.setMonth(this._rRule.month - 1));
                        var lastDate = new Date(appMonth.getFullYear(), appMonth.getMonth() + 1, 0).getDate();
                        if (this._rRule.monthDay > lastDate)
                            this._rRule.monthDay = lastDate;
                        day_start = (day_start.getMonth() + 1 >= this._rRule.month) && day_start.getDate() > this._rRule.monthDay ? new Date(day_start.getFullYear() + 1, this._rRule.month - 1, this._rRule.monthDay) : new Date(day_start.getFullYear(), this._rRule.month - 1, this._rRule.monthDay);
                    }
                    else if (!ej.isNullOrUndefined(this._rRule.setPositions)) {
                        day_start = new Date(day_start.getFullYear(), this._rRule.month - 1, day_start.getDate());
                        day_start = new Date((this._getWeekIndex(day_start) + 1) > this._rRule.setPositions && this._rRule.setPositions != -1 ? new Date(day_start.getFullYear(), day_start.getMonth(), 1) : day_start);
                    }
                    break;
            }
            while (day_start <= recurEndDate) {
                ((this._rRule.freq == "MONTHLY" || this._rRule.freq == "YEARLY") && !ej.isNullOrUndefined(this._rRule.setPositions)) && (day_start = this._dayOfWeekInMonth(day_start, this._rRule.weekDays, this._rRule.setPositions));
                if (!ej.isNullOrUndefined(this._rRule.exDate)) {
                    if (this._rRule.exDate.indexOf(ej.format(new Date(day_start), this._pattern.d, this.model.locale)) == -1) {
                        var i = 2;
                    }
                }
                else
                    var i = 0;
                var value = new Date(day_start);
                switch (this._rRule.freq) {
                    case "DAILY":
                        RecDateCollection.push(new Date(value.toString()).getTime());
                        day_start = new Date(day_start.setDate(day_start.getDate() + _interval));
                        break;
                    case "WEEKLY":
                        var curDay = this._dayNamesValue[new Date(day_start).getDay()].toUpperCase();
                        if (byDay.length - 1 != byDay.indexOf(curDay)) {
                            RecDateCollection.push(new Date(value.toString()).getTime());
                            day_start = this._weeklyDayFind(day_start, byDay);
                        }
                        else {
                            RecDateCollection.push(new Date(value.toString()).getTime());
                            day_start = new Date(day_start.setDate(day_start.getDate() + (day_start.getDay() * -1)));
                            day_start = new Date(day_start.setDate(day_start.getDate() + (_interval * 7) - 1));
                            day_start = this._weeklyDayFind(day_start, byDay);
                        }
                        break;
                    case "MONTHLY":
                        RecDateCollection.push(new Date(value.toString()).getTime());
                        if (_lastDay)
                            day_start = new Date(day_start.getFullYear(), (day_start.getMonth() + _interval) + 1, 0);
                        else if (ej.isNullOrUndefined(this._rRule.setPositions)) {
                            var cloneDate = new Date(day_start);
                            var nextMonth = new Date(cloneDate.setMonth(cloneDate.getMonth() + _interval));
                            var lastDayOfMonth = new Date(nextMonth.getFullYear(), nextMonth.getMonth() + 1, 0);
                            var nextInterval = (day_start.getFullYear() == nextMonth.getFullYear()) ? day_start.getMonth() + _interval : nextMonth.getMonth();
                            if (nextInterval == nextMonth.getMonth())
                                day_start = (nextMonth > lastDayOfMonth) ? new Date(lastDayOfMonth.toString()) : new Date(nextMonth.setDate(this._rRule.monthDay));
                            else {
                                var prevMonth = new Date(nextMonth.setMonth(nextMonth.getMonth() - 1));
                                day_start = new Date(prevMonth.getFullYear(), prevMonth.getMonth() + 1, 0);
                            }
                        }
                        else
                            day_start = new Date(day_start.getFullYear(), day_start.getMonth() + _interval, 1);
                        break;
                    case "YEARLY":
                        RecDateCollection.push(new Date(value.toString()).getTime());
                        day_start = new Date(day_start.setFullYear(day_start.getFullYear() + _interval));
                        break;
                }
                _count++;
                if (!ej.isNullOrUndefined(this._rRule.count) && _count == this._rRule.count)
                    break;
            }
        }
        return RecDateCollection;
    };
    RecurrenceEditor.prototype.recurrenceRuleSplit = function (rRule, exDate) {
        this._rRule = {};
        _ruleExdate = exDate;
        var _rule, _ruleExdate, _rRuleSplit = rRule.split(";");
        if (!ej.isNullOrUndefined(exDate) && !ej.isNullOrUndefined(_ruleExdate.split(","))) {
            var _exDates = _ruleExdate.split(",");
            this._rRule.exDate = [];
            for (var i = 0; i < _exDates.length; i++) {
                this._rRule.exDate[i] = _exDates[i];
            }
        }
        for (var r = 0; r < _rRuleSplit.length; r++) {
            _rule = _rRuleSplit[r].split("=");
            switch ($.trim(_rule[0]).toUpperCase()) {
                case "FREQ":
                    this._rRule.freq = $.trim(_rule[1]).toUpperCase();
                    break;
                case "INTERVAL":
                    this._rRule.interval = parseInt(_rule[1], 10);
                    break;
                case "COUNT":
                    this._rRule.count = parseInt(_rule[1], 10);
                    break;
                case "UNTIL":
                    this._rRule.until = new Date(_rule[1]);
                    break;
                case "BYDAY":
                    this._rRule.weekDays = _rule[1];
                    break;
                case "BYMONTHDAY":
                    this._rRule.monthDay = parseInt(_rule[1], 10);
                    break;
                case "BYMONTH":
                    this._rRule.month = parseInt(_rule[1], 10);
                    break;
                case "BYSETPOS":
                    this._rRule.setPositions = parseInt(_rule[1], 10);
                    break;
                case "WKST":
                    this._rRule.weekStart = _rule[1];
                    break;
                case "EXDATE":
                    if (!ej.isNullOrUndefined(exDate) && !ej.isNullOrUndefined(_ruleExdate.split(","))) {
                        var _exDates = _ruleExdate.split(",");
                        this._rRule.exDate = [];
                        for (var i = 0; i < _exDates.length; i++) {
                            this._rRule.exDate[i] = _exDates[i];
                        }
                    }
                    else {
                        var _exDates = _rule[1].split(",");
                        this._rRule.exDate = [];
                        for (var i = 0; i < _exDates.length; i++) {
                            this._rRule.exDate[i] = _exDates[i];
                        }
                    }
                    break;
                case "RECUREDITID":
                    this._rRule.recurEditId = parseInt(_rule[1]);
                    break;
            }
        }
        return this._rRule;
    };
    RecurrenceEditor.prototype.clearRecurrenceFields = function () {
        var list = this.element.find("input.weekdays");
        for (var i = 0; i < list.length; i++) {
            $(list[i]).ejCheckBox({ checked: false });
        }
        this.element.find('.recurevery').ejNumericTextbox({ value: 1 });
        this.element.find('.recurcount').ejNumericTextbox({ value: 10 });
        this.element.find(".e-recurRule").html("");
    };
    RecurrenceEditor.prototype.setDefaultValues = function () {
        var strDate = this.model.startDate.toString();
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: 0 });
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: 1 });
        this.element.find(".recurstartdate").ejDatePicker({ value: new Date(strDate) });
        this.element.find('.e-until').ejDatePicker({ value: new Date(new Date(strDate).setDate(new Date(strDate).getDate() + 7 * 10)) });
        this.element.find(".e-recurnoend").ejRadioButton({ checked: true });
    };
    RecurrenceEditor.prototype.showRecurrenceSummary = function (appId) {
        for (var i = 0; i < this._dayNames.length; i++)
            this._dayNames[i] = this._dayNames[i].toUpperCase();
        var _recurRule = "", _recurOpt = "", _recurType = this.element.find('#' + this._id + '_recurrenceType');
        _recurRule = ej.isNullOrUndefined(this._rRule.interval) ? this._getLocalizedLabels("Every") + " " : this._getLocalizedLabels("Every") + " " + this._rRule.interval + " ";
        _recurType.ejDropDownList({ selectedItemIndex: this.model.frequencies.indexOf(this._rRule.freq.toLowerCase().replace(/^./, function (str) { return str.toUpperCase(); })) });
        switch (this._rRule.freq) {
            case "DAILY":
                _recurRule += this._getLocalizedLabels("RecurrenceDay").toLowerCase();
                this._rRuleFreq = "DAILY";
                break;
            case "WEEKLY":
                this._rRuleFreq = "WEEKLY";
                this.element.find('.weekdays').ejCheckBox({ checked: false });
                var _days = this._rRule.weekDays.split(',');
                for (var i = 0; i < _days.length; i++) {
                    this.element.find('.e-weekly' + _days[i]).ejCheckBox({ checked: true });
                    _recurOpt += this._dayShortNames[this._dayNames.indexOf(_days[i])] + (i == _days.length - 1 ? "" : ", ");
                }
                _recurRule += this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
            case "MONTHLY":
                this._rRuleFreq = "MONTHLY";
                if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                    this.element.find('.e-monthdaytype').ejRadioButton({ checked: true });
                    this.element.find('.e-monthdate').ejNumericTextbox({ value: parseInt(this._rRule.monthDay) });
                    _recurOpt = parseInt(this._rRule.monthDay).toString();
                }
                else {
                    this.element.find('.e-monthposition').ejRadioButton({ checked: true });
                    this.element.find('.e-monthsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf(this._rRule.weekDays) });
                    this.element.find('.monthsrt').ejDropDownList({ selectedItemIndex: this._rRule.setPositions - 1 });
                    _recurOpt = this.element.find('.monthsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[this._dayNames.indexOf(this._rRule.weekDays)];
                }
                _recurRule += this._getLocalizedLabels("RecurrenceMonth").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
            case "YEARLY":
                this._rRuleFreq = "YEARLY";
                if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                    this.element.find('.e-yearrecurday').ejRadioButton({ checked: true });
                    this.element.find('.yearmonth').ejDropDownList({ selectedItemIndex: this._rRule.month - 1 });
                    this.element.find('.yeardate').ejNumericTextbox({ value: parseInt(this._rRule.monthDay) });
                    _recurOpt = this._monthNames[this._rRule.month - 1] + " " + parseInt(this._rRule.monthDay);
                }
                else {
                    this.element.find('.e-yearrecurposi').ejRadioButton({ checked: true });
                    this.element.find('.yearsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf(this._rRule.weekDays) });
                    this.element.find('.yearsrtmonth').ejDropDownList({ selectedItemIndex: this._rRule.month - 1 });
                    this.element.find('.yearsrt').ejDropDownList({ selectedItemIndex: this._rRule.setPositions - 1 });
                    _recurOpt = this.element.find('.yearsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[this._dayNames.indexOf(this._rRule.weekDays)] + " " + this._monthNames[this._rRule.month - 1];
                }
                _recurRule += this._getLocalizedLabels("RecurrenceYear").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
        }
        this.element.find('.recurevery').ejNumericTextbox({ value: ej.isNullOrUndefined(this._rRule.interval) ? 1 : this._rRule.interval });
        if (!ej.isNullOrUndefined(this._rRule.count)) {
            this.element.find(".e-recurafter").ejRadioButton({ checked: true });
            this.element.find('.recurcount').ejNumericTextbox({ value: this._rRule.count });
            _recurRule += ", " + this._rRule.count + this._getLocalizedLabels("Times").toLowerCase();
        }
        else if (!ej.isNullOrUndefined(this._rRule.until)) {
            this.element.find(".e-recuruntil").ejRadioButton({ checked: true });
            this.element.find('.e-until').ejDatePicker({ value: new Date(this._rRule.until) });
            _recurRule += " " + this._getLocalizedLabels("Until").toLowerCase() + " " + ej.format(new Date(this._rRule.until), this._datepattern(), this.model.locale);
        }
        else
            this.element.find(".e-recurnoend").ejRadioButton({ checked: true });
        return _recurRule;
    };
    RecurrenceEditor.prototype.getRecurrenceRule = function () {
        this.closeRecurPublic();
        return this._recRule;
    };
    RecurrenceEditor.prototype.closeRecurPublic = function () {
        var recurEditValue = this._rRuleFreq;
        var interval, monthDate, endRecur = "", recurOption = "", _weekRule = "", recurRules = "";
        interval = this._interval = this._findInterval(this.element.find('.recurevery'));
        switch (recurEditValue) {
            case "DAILY":
                recurRules = "FREQ=" + recurEditValue + ";INTERVAL=" + interval;
                break;
            case "WEEKDAYS":
                recurRules = "FREQ=WEEKLY;BYDAY=MO,TU,WE,TH,FR";
                _weekRule = "MO,TU,WE,TH,FR";
                break;
            case "WEEKLY":
                var _weekChkList = this.element.find("input.weekdays");
                var _dayName = "", _byDay = "", checked = "", checkedNames = "";
                for (var i = 0; i < _weekChkList.length; i++) {
                    $(_weekChkList[i]).ejCheckBox("model.checked") == true ? _weekRule += (_weekRule != "" ? "," : "") + this._dayNames[i].toUpperCase() : "";
                    $(_weekChkList[i]).ejCheckBox("model.checked") == true ? _dayName += (_dayName != "" ? ", " : "") + this._dayShortNames[i] : "";
                }
                for (var c = 0; c < this._dayNamesValue.length; c++) {
                    if (checked.indexOf(this._dayNamesValue[c]) != -1) {
                        _weekRule += (_weekRule != "" ? "," : "") + this._dayNamesValue[c];
                    }
                    if (checkedNames.indexOf(this._culture.calendar.days.namesAbbr[c]) != -1) {
                        _dayName += (_dayName != "" ? "," : "") + this._culture.calendar.days.namesAbbr[c];
                    }
                }
                if (_weekRule == "") {
                    var date = this.element.find('.recurstartdate').ejDatePicker("model.value");
                    _weekRule = this._dayNames[date.getDay()].toUpperCase();
                }
                var _rule = this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " on " + _dayName;
                this.element.find(".e-recurRule").html(_rule);
                recurRules = "FREQ=" + recurEditValue + ";INTERVAL=" + interval + ";" + "BYDAY=" + _weekRule;
                break;
            case "MONTHLY":
                if (this.element.find('.monthdaytype').ejRadioButton("model.checked")) {
                    monthDate = this.element.find('.monthdate').ejNumericTextbox("model.value");
                    recurRules = "FREQ=" + recurEditValue + ";BYMONTHDAY=" + monthDate + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + monthDate;
                }
                else {
                    var _setPos = this.element.find('.monthsrt').ejDropDownList("selectedItemIndex");
                    var dayName = this.element.find('.e-monthsrtday').ejDropDownList("selectedItemIndex");
                    _setPos = _setPos < 5 ? (_setPos + 1) : -1;
                    recurRules = "FREQ=" + recurEditValue + ";BYDAY=" + this._dayNames[dayName] + ";BYSETPOS=" + _setPos + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this.element.find('.monthsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[dayName];
                }
                break;
            case "YEARLY":
                if (this.element.find("#" + this._id + "_yearday").ejRadioButton("model.checked")) {
                    var _monthIndex = this.element.find('.yearmonth').ejDropDownList("selectedItemIndex");
                    var _monthDate = this._findInterval(this.element.find('.yeardate'));
                    recurRules = "FREQ=" + recurEditValue + ";BYMONTHDAY=" + _monthDate + ";BYMONTH=" + (_monthIndex + 1) + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._monthNames[_monthIndex] + " " + _monthDate;
                }
                else {
                    var _setPos = this.element.find('.yearsrt').ejDropDownList("selectedItemIndex");
                    var _monthIndex = this.element.find('.yearsrtmonth').ejDropDownList("selectedItemIndex");
                    var dayName = this.element.find('.yearsrtday').ejDropDownList("selectedItemIndex");
                    _setPos = _setPos < 5 ? (_setPos + 1) : -1;
                    recurRules = "FREQ=" + recurEditValue + ";BYDAY=" + this._dayNames[dayName] + ";BYMONTH=" + (_monthIndex + 1) + ";BYSETPOS=" + _setPos + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this.element.find('.yearsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[dayName] + " " + this._monthNames[_monthIndex];
                }
                break;
            case "NEVER":
                this._recRule = undefined;
                break;
        }
        if (this.element.find('.e-recurafter').ejRadioButton("model.checked")) {
            var _count = this._findInterval(this.element.find('.recurcount'));
            recurRules += ";COUNT=" + _count;
            endRecur = _count ? ", " + _count + " " + this._getLocalizedLabels("Times") : ", ";
        }
        else if (this.element.find('.e-recuruntil').ejRadioButton("model.checked")) {
            var _count1 = this._findRecurCount(interval, _weekRule, this);
            recurRules += ";COUNT=" + _count1;
            endRecur = _count1 ? ", " + _count1 + " " + this._getLocalizedLabels("Times") : ", ";
        }
        var _every = (this._rRuleFreq != "WEEKDAYS" ? this._getLocalizedLabels("Every") : "") + " " + (interval > 1 ? interval + " " : "");
        var _rRuleStr = _every + this.element.find(".e-recurRule").html() + recurOption + endRecur;
        this._recRule = recurRules;
        return _rRuleStr;
    };
    return RecurrenceEditor;
}(ej.WidgetBase));
ej.widget("ejRecurrenceEditor", "ej.RecurrenceEditor", new RecurrenceEditor());
ej.RecurrenceEditor.Locale = {};
ej.RecurrenceEditor.Locale["en-US"] = {
    Repeat: "Repeat",
    Never: "Never",
    Daily: "Daily",
    Weekly: "Weekly",
    Monthly: "Monthly",
    Yearly: "Yearly",
    First: "First",
    Second: "Second",
    Third: "Third",
    Fourth: "Fourth",
    Last: "Last",
    EveryWeekDay: "Every weekday",
    Every: "Every",
    RecurrenceDay: "Day(s)",
    RecurrenceWeek: "Week(s)",
    RecurrenceMonth: "Month(s)",
    RecurrenceYear: "Year(s)",
    RepeatOn: "Repeat on",
    RepeatBy: "Repeat by",
    StartsOn: "Starts on",
    Times: "times",
    Ends: "Ends",
    Day: "Day",
    The: "The",
    OfEvery: "Of",
    After: "After",
    On: "On",
    Occurrence: "Occurrence(s)",
    Until: "Until"
};
;
/**
* @fileOverview Plugin to create the Gantt
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    'use strict';
    ej.widget("ejGantt", "ej.Gantt", {

        // widget element will be automatically set in this
        _rootCSS: "e-gantt",

        element: null,

        validTags: ["div"],
        // user defined model will be automatically set in this
        model: null,
        _tags: [{
            tag: "holidays",
            attr: ["day", "background", "label"],
            content: "template"
        },
        {
            tag: "stripLines",
            attr: ["day", "label", "lineStyle", "lineColor", "lineWidth"],
            content: "template"
        },
         {
             tag: "editDialogFields",
             attr: ["field", "editType"],
             content: "template"
         },
         {
             tag: "addDialogFields",
             attr: ["field", "editType"],
             content: "template"
         },
         {
             tag: "sortSettings.sortedColumns",
             attr: ["field","direction"]
         },
         {
             tag: "dayWorkingTime",
             attr: ["from", "to"],
             singular: "dayWorkingTime"
         }
        ],
        _holidays: function (index, property, value, old) {
            this._$ganttchartHelper.ejGanttChart("refreshHolidays");
            this._trigger("refresh");
        },
        _stripLines: function (index, property, value, old) {
            this._$ganttchartHelper.ejGanttChart("refreshStripLines");
            this._trigger("refresh");
        },
        _editDialogFields: function (index, property, value, old) {
            this._trigger("refresh");
        },
        _addDialogFields: function (index, property, value, old) {
            this._trigger("refresh");
        },
        defaults: {
            expandStateMapping:"",
            allowSorting: false,
            allowColumnResize: false,
            allowSelection: true,
            allowMultipleExporting: false,
            allowDragAndDrop: false,
            dragTooltip: {
                showTooltip: false,
                tooltipItems: [],
                tooltipTemplate: "",
            },
            dataSource: null,
            showColumnChooser: false,
            showColumnOptions: false,
            query: null,
            splitterSettings: {
                position: "",
                index: -1
            },
            splitterPosition: "",
            taskIdMapping: "",
            parentTaskIdMapping: "",
            taskNameMapping: "",
            startDateMapping: "",
            endDateMapping: "",
            baselineStartDateMapping: "",
            baselineEndDateMapping: "",
            childMapping: "",
            durationMapping: "",
            milestoneMapping: "",
            progressMapping: "",
            predecessorMapping: "",
            resourceInfoMapping: "",
            taskSchedulingModeMapping: "",
            workMapping: "",
            notesMapping:"",
            resources: [],
            holidays: [],
            searchSettings: {
                fields: [],
                key: "",
                operator: "contains",
                ignoreCase: true
            },
            highlightWeekends: true,
            scheduleStartDate: null,
            scheduleEndDate: null,
            enableProgressBarResizing: true,
            rowHeight: 30,
            includeWeekend: true,
            taskSchedulingMode: "auto",
            validateManualTasksOnLinking: false,
            toolbarSettings: {
                showToolbar: false,
                toolbarItems: [],
                customToolbarItems: []
            },
            stripLines: [],
            workingTimeScale: 'TimeScale8Hours',
            roundOffDayworkingTime: true,
            durationUnit: 'day',
            workUnit: 'hour',
            taskType: "fixedUnit",
            perMinuteWidth: null,
            perHourWidth: null,
            perDayWidth: null,
            perWeekWidth: null,
            perMonthWidth: null,
            minuteInterval: null,
            scheduleHeaderSettings:
            {
                weekHeaderFormat: "MMM dd , yyyy",
                dayHeaderFormat: "",
                yearHeaderFormat: "yyyy",
                monthHeaderFormat: "MMM",
                hourHeaderFormat: 'HH',
                scheduleHeaderType: 'week',
                minutesPerInterval: "auto",
                weekendBackground: '',
                timescaleStartDateMode: "auto",
                timescaleUnitSize:"100%",
                weekStartDay: 0
            },
            taskbarBackground: "",
            progressbarBackground: "",
            connectorLineBackground: "",
            parentTaskbarBackground: "",
            parentProgressbarBackground: "",
            connectorlineWidth: 1,
            readOnly:false,
            showTaskNames: true,
            leftTaskLabelMapping: "",
            rightTaskLabelMapping: "",
            leftTaskLabelTemplate: "",
            rightTaskLabelTemplate: "",
            showGridCellTooltip: false,
            cellTooltipTemplate:null,
            showGridExpandCellTooltip: false,
            showProgressStatus: true,
            showResourceNames: true,
            enableTaskbarDragTooltip: true,
            enableTaskbarTooltip: true,
            enableWBS:false,
            enableWBSPredecessor:false,
            editSettings: {
                allowEditing: false,
                allowAdding: false,
                allowDeleting: false,
                allowIndent: false,               
                editMode: "normal",
                beginEditAction: "dblclick",
                rowPosition: "belowselectedrow"
            },
            flatRecords: [],
            parentRecords: [],
            currentViewData: [],
            updatedRecords: [],
            ids: [],
            allowKeyboardNavigation: true,
            cssClass: "",
            locale: "en-US",
            allowMultiSorting: false,
            sortSettings: {
                sortedColumns: []
            },
            enableAltRow: true,
            enableVirtualization: false,
            progressbarHeight: 100,
            taskbarTooltipTemplate: "",
            progressbarTooltipTemplate: "",
            taskbarTooltipTemplateId: "",
            dateFormat: "",
            resourceIdMapping: "",
            resourceNameMapping: "",
            resourceUnitMapping: "",
            progressbarTooltipTemplateId: "",
            taskbarEditingTooltipTemplateId: "",
            taskbarEditingTooltipTemplate: "",
            selectedRowIndex: -1,
            allowGanttChartEditing: true,
            sizeSettings: {
                height: "",
                width: "",
            },
            selectedItem: null,
            selectionType: "single",
            selectionMode: "row",
            selectedCellIndexes: [],
            weekendBackground: "",
            baselineColor: '#fba41c',
            treeColumnIndex: 0,
            editDialogFields: [],
            addDialogFields: [],
            columnDialogFields: [],
            renderBaseline: false,
            enableContextMenu: false,
            enableResize: true,
            isResponsive: true,
            enableCollapseAll: false,
            enablePredecessorValidation: true,
            taskbarTemplate: "",
            parentTaskbarTemplate: "",
            milestoneTemplate: "",
            durationUnitMapping: "",
            dayWorkingTime: [{ "from": "08:00 AM", "to": "12:00 PM" }, { "from": "01:00 PM", "to": "05:00 PM" }],//, { from: "4:00 PM", to: "5:00 PM" }
            exportToExcelAction: "",
            exportToPdfAction: "",
            /*Events*/
            rowSelecting: null,
            rowSelected: null,
            rowDragStart: null,
            rowDrag: null,
            rowDragStop: null,
            cellSelecting: null,
            cellSelected: null,
            queryCellInfo: null,
            queryTaskbarInfo: null,            
            beginEdit: null,
            endEdit: null,
            rowDataBound: null,
            expanding: null,
            expanded: null,
            collapsing: null,
            collapsed: null,
            actionBegin: null,
            actionComplete: null,
            taskbarEditing: null,
            taskbarEdited: null,
            load: null,
            create:null,
            contextMenuOpen: null,
            taskbarClick: null,
            taskbarHeight: 20,
            criticalTask: "",
            toolbarClick: null,
        },

        dataTypes: {
            allowSorting: "boolean",
            allowColumnResize: "boolean",
            allowSelection: "boolean",
            dataSource: "data", //inline or remote data
            query: "data",
            taskIdMapping: "string",
            parentTaskIdMapping: "string",
            taskNameMapping: "string",
            startDateMapping: "string",
            endDateMapping: "string",
            baselineStartDateMapping: "string",
            baselineEndDateMapping: "string",
            childMapping: "string",
            durationMapping: "string",
            milestoneMapping: "string",
            progressMapping: "string",
            predecessorMapping: "string",
            resourceInfoMapping: "string",
            taskSchedulingModeMapping: "string",
            notesMapping: "string",
            workMapping: "string",
            resources: "array",
            holidays: "array",
            dayWorkingTime: "array",
            highlightWeekends: "boolean",
            scheduleStartDate: "data",
            scheduleEndDate: "data",
            enableProgressBarResizing: "boolean",
            rowHeight: "number",
            includeWeekend: "boolean",
            taskSchedulingMode: "string",
            validateManualTasksOnLinking: "boolean",
            toolbarSettings: {
                showToolbar: "boolean",
                toolbarItems: "array",
                customToolbarItems: "array"
            },
            stripLines: "array",
            scheduleHeaderSettings: "data",
            roundOffDayworkingTime: "boolean",
            taskbarBackground: "string",
            progressbarBackground: "string",
            connectorLineBackground: "string",
            parentTaskbarBackground: "string",
            parentProgressbarBackground: "string",
            connectorlineWidth: "number",
            readOnly:"boolean",
            showTaskNames: "boolean",
            leftTaskLabelMapping: "string",
            rightTaskLabelMapping: "string",
            leftTaskLabelTemplate: "string",
            rightTaskLabelTemplate: "string",
            showProgressStatus: "boolean",
            showResourceNames: "boolean",
            enableTaskbarDragTooltip: "boolean",
            enableTaskbarTooltip: "boolean",
            editSettings: "data",
            flatRecords: "array",
            parentRecords: "array",
            currentViewData: "array",
            ids: "array",
            updatedRecords: "array",
            allowKeyboardNavigation: "boolean",
            cssClass: "string",
            locale: "string",
            allowMultiSorting: "boolean",
            showGridExpandCellTooltip: "boolean",
            sortSettings: {
                sortedColumns: "array"
            },
            enableAltRow: "boolean",
            enableVirtualization: "boolean",
            progressbarHeight: "number",
            taskbarTooltipTemplate: "string",
            progressbarTooltipTemplate: "string",
            taskbarTooltipTemplateId: "string",
            dateFormat: "string",
            resourceIdMapping: "string",
            resourceNameMapping: "string",
            resourceUnitMapping: "string",
            progressbarTooltipTemplateId: "string",
            taskbarEditingTooltipTemplateId: "string",
            taskbarEditingTooltipTemplate: "string",
            allowGanttChartEditing: "boolean",
            size: {
                height: "string",
                width: "string"
            },            
            weekendBackground: "string",
            baselineColor: "string",
            renderBaseline: "boolean",
            enableContextMenu: "boolean",
            showGridCellTooltip: "boolean",
            treeColumnIndex: "number",
            editDialogFields: "array",
            addDialogFields: "array",
            showColumnChooser: "boolean",
            enableResize: "boolean",
            isResponsive: "boolean",
            enableCollapseAll: "boolean",
            enablePredecessorValidation: "boolean",
            durationUnitMapping: "string",
            taskbarTemplate: "string",
            parentTaskbarTemplate: "string",
            milestoneTemplate: "string",
            taskbarHeight: "number",
            criticalTask: "string"
        },
        ignoreOnExport: [
            "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "enableRTL", "rowDataBound",
              "editSettings", "localization", "cssClass", "dataSource", "allowKeyboardNavigation"
        ],
        observables: ["selectedItem", "selectedRowIndex", "selectedCellIndexes", "splitterPosition", "dataSource","splitterSettings.position"],
        selectedItem: ej.util.valueFunction("selectedItem"),
        selectedRowIndex: ej.util.valueFunction("selectedRowIndex"),
        selectedCellIndexes: ej.util.valueFunction("selectedCellIndexes"),
        splitterPosition: ej.util.valueFunction("splitterSettings.position"),
        dataSource: ej.util.valueFunction("dataSource"),
        _splitterPosition: ej.util.valueFunction("splitterPosition"),

        //Retruns column value
        getColumns: function () {
            return this._columns;
        },
        //set column value
        setColumns: function(value) {
            this._columns = value;
        },

        // Initialize values to header Text and Gantt records for custom columns alone
        customColumnFields: function () {
            var proxy = this,
                totalColumns = proxy._columns, totalColumnsLength = totalColumns.length;

            for (var i = 0; i < totalColumnsLength; i++)
            {
                if (!proxy._columnHeaderTexts[totalColumns[i].field]) {
                    proxy._columnHeaderTexts[totalColumns[i].field] = totalColumns[i].headerText;
                }
            }           
        },

        //Control Rendering is initiated
        _init: function () {
            var proxy = this,
                model = proxy.model, startDate, endDate,interval = model.scheduleHeaderSettings.minutesPerInterval,
                durationUnit = model.durationUnit;

            //Default data source for ASP designer
            if (model.isdesignMode) {
                model.taskIdMapping = "Id";
                model.taskNameMapping = "Name";
                model.startDateMapping = "StartDate";
                model.durationMapping = "Duration";
                model.progressMapping = "Progress";
                model.scheduleStartDate = "02/23/2014";
                model.scheduleEndDate = "03/10/2014";
                this.dataSource([{ Id: 1, Name: "Task 1", StartDate: "02/23/2014", Duration: 5, Progress: 40 },
                { Id: 2, Name: "Task 2", StartDate: "02/24/2014", Duration: 5, Progress: 40 },
                { Id: 3, Name: "Task 3", StartDate: "02/25/2014", Duration: 5, Progress: 40 }]);
                model.sizeSettings.height = "300px";
                model.sizeSettings.width = "800px";
            }

            if (!(model.scheduleStartDate || model.scheduleEndDate) && interval == "auto")
                model.scheduleHeaderSettings.minutesPerInterval = ej.Gantt.minutesPerInterval.FiveMinutes;
            if (model.workMapping != "")
                model.taskType = ej.Gantt.TaskType.FixedWork;
            proxy._initPrivateProperties();
            //Load event triggered
            proxy._trigger("load");
            proxy.element.addClass("e-gantt-core");
            if (this.dataSource() !== null) {
                this._checkDataBinding();
            }
            else {
                proxy._initialize();
            }
        },
        /*set taskbar height at load time*/
        _setTaskbarHeight: function (height) {

            if (height < this.model.rowHeight)
                this.taskbarHeight = height;
            else
                this.taskbarHeight = this.model.rowHeight;
            /*MilesStone width as by rowHeight*/
            this._milesStoneWidth = (Math.floor(this.taskbarHeight / 2) * 2);
        },
        //clear selected item
        _deSelectRowItem: function () {
            var proxy = this, model = proxy.model;
            proxy._$ganttchartHelper.ejGanttChart("selectRows", -1);
            proxy._$treegridHelper.ejTreeGrid("selectRows", -1);
            this.selectedRowIndex(-1);
            model.selectedItem = null;
        },
        
        //populate gantt records from data source
        _checkDataBinding: function () {
            var proxy = this, model = proxy.model;
           
            if (this.dataSource() == null) {
                this.dataSource([]);
            }
            if (this.dataSource() instanceof ej.DataManager) {
                this._initDataSource();
            }
            else if (this.dataSource().length > 0) {
                if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                    var dataArray = proxy._retrivedData = proxy.dataSource(), data = [];
                    proxy._taskIds = [];
                    for (var i = 0; i < dataArray.length; i++) {
                        var tempData = dataArray[i];
                        data.push($.extend(true, {}, tempData));
                        if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                    }
                  
                    if (!model.childMapping) model.childMapping = "Children";                                        
                    proxy._reconstructDatasource(data);
                    proxy._createGanttRecords(proxy.secondaryDatasource);
                }
                else {
                    proxy._createGanttRecords(this.dataSource());
                }
                proxy._initialize();
            }
            else {
                proxy._initialize();
            }
        },

        //Create gantt records and render gantt if data source is remote data
        _initDataSource: function () {
            var proxy = this, model = proxy.model;     
            var query = this._columnToSelect();
            var queryPromise = this.dataSource().executeQuery(query);
            queryPromise.done(ej.proxy(function (e) {
                if (proxy.dataSource().dataSource.offline) {
                    proxy._retrivedData = proxy.dataSource().dataSource.json;
                } else {
                    proxy._retrivedData = e.result;
                }
               
                if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                    //cloning the datasource
                    var dataArray = e.result, data = [];
                    proxy._taskIds = [];
                    for (var i = 0; i < dataArray.length; i++) {
                        var tempData = dataArray[i];
                        data.push($.extend(true, {}, tempData));
                        if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                    }
                    if (!model.childMapping) {
                        model.childMapping = "Children";
                    }
                    proxy._reconstructDatasource(data);
                }
                else {
                    proxy.secondaryDatasource = proxy._retrivedData;
                }
                proxy._createGanttRecords(proxy.secondaryDatasource);
                proxy._initialize();
            }));
        },

        //create ejQuery when remote data is initiated
        _columnToSelect: function () {
            var proxy = this,
                model = proxy.model,
                column = [], queryManager = ej.Query();

            queryManager = model.query ? model.query : queryManager;
            return queryManager;
        },

        _intersectionObjects: function (flatCollection, rootCollection) {
            var result = [];
            while (flatCollection.length > 0 && rootCollection.length > 0) {
                var index = rootCollection.indexOf(flatCollection[0]);
                if (index == -1) {
                    flatCollection.shift();
                }
                else {
                    result.push(flatCollection.shift());
                    rootCollection.splice(index, 1);
                }
            }

            return result;
        },

        //If parentIdMapping is given data source is changed in hierarchical order
        _reconstructDatasource: function (datasource) {
            var proxy = this, model = proxy.model,
                data, filter;

            filter = ej.Predicate(model.parentTaskIdMapping, ej.FilterOperators.notEqual, "null");
            data = ej.DataManager(datasource).executeLocal(ej.Query().where(filter).group(model.parentTaskIdMapping));
            var tempParent = [];
            for (var i = 0; i < data.length; i++) {
                if (!ej.isNullOrUndefined(data[i].key)) {

                    var index = proxy._taskIds.indexOf(data[i].key);
                    if (index > -1) {
                        datasource[index][model.childMapping] = data[i].items;
                        continue;
                    }
                }
                var items = data[i].items;
                for (var item in data[i].items)
                    tempParent.push(items[item]);
            }
            proxy.secondaryDatasource = proxy._intersectionObjects(datasource, tempParent);
        },       

        //refresh the chart with updated schedule dates
        updateScheduleDates: function (startDate, endDate) {
            
            var proxy = this, model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType;
            model.scheduleStartDate = startDate;
            model.scheduleEndDate = endDate;
            proxy._scheduleDays = [];
            proxy._scheduleMonths = [];
            proxy._scheduleWeeks = [];
            proxy._scheduleYears = [];
            proxy._scheduleHours = [];
            proxy._scheduleMinutes = [];
            proxy._calculateHeaderDates();
            var chartObject = $("#ejGanttChart" + proxy._id).ejGanttChart("instance");
            var chartModel = chartObject.model;
            /* No need to re render parent item , because all the records are rerendered*/
            proxy._isTreeGridRendered = false;
            proxy._isGanttChartRendered = false;
            proxy._isChartRendering = true;
            proxy._updateGanttRecords();
            chartModel.projectStartDate = proxy._getDateFromFormat(proxy._projectStartDate);
            chartModel.projectEndDate = proxy._getDateFromFormat(proxy._projectEndDate);
            chartModel.scheduleDays = proxy._scheduleDays;
            chartModel.scheduleMonths = proxy._scheduleMonths;
            chartModel.scheduleWeeks = proxy._scheduleWeeks;
            chartModel.scheduleYears = proxy._scheduleYears;
            chartModel.scheduleHours = proxy._scheduleHours;
            chartModel.scheduleMinutes = proxy._scheduleMinutes;
            chartModel.renderBaseline = model.renderBaseline;
            chartModel.scheduleHeaderSettings.scheduleHeaderType = scheduleHeaderType;
            if (scheduleHeaderType == "week") {
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.weekHeaderFormat = model.scheduleHeaderSettings.weekHeaderFormat;
                chartModel.scheduleHeaderSettings.dayHeaderFormat = model.scheduleHeaderSettings.dayHeaderFormat;
                chartModel.durationUnit = model.durationUnit;
                chartModel.perDayWidth = proxy._perDayWidth;
            }
            else if (scheduleHeaderType == "day") {
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.dayHeaderFormat = model.scheduleHeaderSettings.dayHeaderFormat;
                chartModel.scheduleHeaderSettings.hourHeaderFormat = model.scheduleHeaderSettings.hourHeaderFormat;
                chartModel.durationUnit = model.durationUnit;
                chartModel.perHourWidth = proxy._perHourWidth;
                chartModel.perDayWidth = proxy._perDayWidth;
            }
            else if (scheduleHeaderType == "hour") {
                chartModel.dateFormat = model.dateFormat;
                chartModel.durationUnit = ej.Gantt.DurationUnit.Minute;
                chartModel.scheduleHeaderSettings.minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval;
                chartModel.workingTimeScale = model.workingTimeScale;
                chartModel.minuteInterval = proxy._minuteInterval;
                chartModel.perMinuteWidth = proxy._perMinuteWidth;
                chartModel.perDayWidth = proxy._perDayWidth;
            }
            else if (scheduleHeaderType == "month") {
                chartModel.durationUnit = model.durationUnit;
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.monthHeaderFormat = model.scheduleHeaderSettings.monthHeaderFormat;
                chartModel.scheduleHeaderSettings.weekHeaderFormat = model.scheduleHeaderSettings.weekHeaderFormat;
                chartModel.perDayWidth = proxy._perDayWidth;
                chartModel.perWeekWidth = proxy._perWeekWidth;
            }
            else if (scheduleHeaderType == "year") {
                chartModel.durationUnit = model.durationUnit;
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.yearHeaderFormat = model.scheduleHeaderSettings.yearHeaderFormat;
                chartModel.perDayWidth = proxy._perDayWidth;
                chartModel._perMonthWidth = proxy._perMonthWidth;
            }
            $("#ejGanttChart" + proxy._id).ejGanttChart("refreshChartHeader", proxy._getDateFromFormat(startDate), proxy._getDateFromFormat(endDate));
            $("#ejGanttChart" + proxy._id).ejGanttChart("refreshContainersWidth");
            proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords, proxy._totalCollapseRecordCount);
            if (model.predecessorMapping) {
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._connectorlineIds = [];
                proxy._connectorLinesCollection = [];
                proxy._isValidationEnabled = false;
                proxy._createConnectorLinesCollection();
                proxy._isValidationEnabled = true;
            }
            chartObject._$bodyContainer.ejScroller("refresh");

            proxy._isTreeGridRendered = true;
            proxy._isGanttChartRendered = true;
            proxy._isChartRendering = false;
        },
        //used to change the schedule mode dynamically
        
        reRenderChart: function (scheduleMode) {
            var proxy = this, model = proxy.model,
                startDate = proxy._getDateFromFormat(model.scheduleStartDate),
                endDate = proxy._getDateFromFormat(model.scheduleEndDate);
            model.flatRecords = [];
            model.parentRecords = [];
            $("#ejGanttChart" + proxy._id).empty();

            switch (scheduleMode) {
                case ej.Gantt.ScheduleHeaderType.Week:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Week;
                    proxy._perDayWidth = model.perDayWidth;
                    proxy._calculateWeekSplit(startDate, endDate);
                    break;

                case ej.Gantt.ScheduleHeaderType.Day:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Day;
                    proxy._perHourWidth = model.perHourWidth;
                    proxy._perDayWidth = (proxy._perHourWidth * 24);//24 hours
                    proxy._calculateDaySplit(startDate, endDate);
                    break;

                case ej.Gantt.ScheduleHeaderType.Month:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Month;
                    proxy._perDayWidth = model.perDayWidth;
                    proxy._perWeekWidth = model.perWeekWidth;
                    proxy._calculateMonthSplit(startDate, endDate);
                    break;

                case ej.Gantt.ScheduleHeaderType.Year:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Year;
                    proxy._perDayWidth = model.perDayWidth;
                    proxy._perMonthWidth = model.perMonthWidth;
                    proxy._calculateYearSplit(startDate, endDate);
                    break;
                case ej.Gantt.ScheduleHeaderType.Hour:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Hour;
                    var minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval,
                        intervalValue = ej.Gantt.minutesPerInterval;
                    proxy._perMinuteWidth = model.perMinuteWidth;
                    if (minutesPerInterval) {
                        if (minutesPerInterval == intervalValue.Auto) {
                            var twoDaysTimeSpan = 2 * 86400000,// Time in milliseconds
                                sevenDaysTimeSpan = 7 * 86400000,//Time in milliseconds
                                tenDaysTimeSpan = 10 * 86400000,
                                diff = endDate - startDate;

                            if (diff > tenDaysTimeSpan) {
                                proxy._minuteInterval = 30;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                            }
                            else if (diff > sevenDaysTimeSpan) {
                                proxy._minuteInterval = 15;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                            }
                            else if (diff > twoDaysTimeSpan) {
                                proxy._minuteInterval = 5;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                            }
                            else {
                                proxy._minuteInterval = 1;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);//24 hours
                            }
                        }
                        else if (minutesPerInterval == intervalValue.OneMinute) {
                            proxy._minuteInterval = 1;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);
                        }
                        else if (minutesPerInterval == intervalValue.FiveMinutes) {
                            proxy._minuteInterval = 5;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.FifteenMinutes) {
                            proxy._minuteInterval = 15;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.ThirtyMinutes) {
                            proxy._minuteInterval = 30;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                        }
                    }
                    proxy._calculateHourSplit(startDate, endDate);
                    break;
            }
            proxy.element.ejGantt("destroy").ejGantt(model);
            proxy._isTreeGridRendered = false;
            proxy._isGanttChartRendered = false;

        },

        changeTaskMode:function(record, taskMode){
            var proxy = this, model = proxy.model, args = {};
            args.data = record;

            proxy._isValidationEnabled = true;
            if (taskMode == ej.Gantt.TaskSchedulingMode.Manual) {
                record.isAutoSchedule = false;
                record.item[model.taskSchedulingModeMapping] = true;                
            }
            else if (taskMode == ej.Gantt.TaskSchedulingMode.Auto) {
                record.isAutoSchedule = true;
                record.item[model.taskSchedulingModeMapping] = false;                
            }
            args.columnName = "taskMode";
            proxy._updateEditedGanttRecords(args);
            proxy._isValidationEnabled = false;
        },
        autoSchedule: function (taskId) {
            var proxy = this, model = proxy.model, targetRecord,
                updatedRecords = model.updatedRecords;
            targetRecord = updatedRecords.filter(function (record) {
                return record.taskId === taskId;
            });
            proxy.changeTaskMode(targetRecord[0], ej.Gantt.TaskSchedulingMode.Auto);
        },
        manualSchedule: function (taskId) {
            var proxy = this, model = proxy.model, targetRecord,
                updatedRecords = model.updatedRecords;
            targetRecord = updatedRecords.filter(function (record) {
                return record.taskId === taskId;
            });
            proxy.changeTaskMode(targetRecord[0], ej.Gantt.TaskSchedulingMode.Manual);
        },
        //update the all gantt records width,progresswidth and left value
        _updateGanttRecords: function () {

            var proxy = this, model = proxy.model,
                flatRecords = model.flatRecords,
                length = flatRecords.length,
                currentRecord, parentItem, childRecords;
          
            for (var i = 0; i < length; i++) {
                currentRecord = flatRecords[i];
                if (currentRecord.hasChildRecords === false) {
                    currentRecord.left = currentRecord._calculateLeft(this);
                    currentRecord.width = currentRecord._calculateWidth(this);
                    currentRecord.width = currentRecord.isMilestone == true ? proxy._milesStoneWidth : model.flatRecords[i].width;
                    currentRecord.progressWidth = currentRecord._calculateProgressWidth(currentRecord.width, currentRecord.status);
                }
                if (currentRecord.baselineStartDate && currentRecord.baselineEndDate) {
                    currentRecord.baselineLeft = currentRecord._calculateBaselineLeft(this);
                    currentRecord.baselineRight = currentRecord._calculateBaselineRight(this);
                    currentRecord.baselineWidth = currentRecord._calculateBaseLineWidth(this);
                } else {
                    currentRecord.baselineLeft = 0;
                    currentRecord.baselineRight = 0;
                    currentRecord.baselineWidth = 0;
                }

                parentItem = currentRecord.parentItem;
                childRecords = parentItem && parentItem.childRecords;

                if (parentItem && childRecords.indexOf(currentRecord) == childRecords.length - 1 && currentRecord.hasChildRecords === false) {
                    if (parentItem.isAutoSchedule)
                        proxy._updateParentItem(currentRecord);
                    else
                        proxy._updateManualParentItem(currentRecord);
                }                
            }

        },
        
        //Method for initialize private peoperties
        _initPrivateProperties: function () {

            var proxy = this,
                model = proxy.model,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;
            proxy._isFromGantt = true;
            proxy._disabledToolItems = [],
            proxy._id = proxy.element.attr('id'),
            proxy._scheduleWeeks = [],
            proxy._taskIds = [],
            proxy._duplicate = false,          
            proxy._wrongenddate=false,
            proxy._addPosition = null,
            proxy._scheduleYears = [],//new property for year schedule modes

            proxy._scheduleMonths = [], //new property for month

            proxy._scheduleYears = [],//property for schedule years
            proxy._scheduleDays = [],//property for schedule days
            proxy._scheduleHours=[],
            proxy._projectStartDate, //property instead of scheduleWeeks[0] and scheduleYears[0]
            proxy._projectEndDate,

            proxy._columns = [],
            proxy._storedIndex = -1,
            proxy._perDayWidth,
            proxy._prevDayWidth = 0,
            proxy._rowIndexOfLastSelectedCell = -1,
            proxy._perMonthWidth,//new property for month
            proxy._perWeekWidth,//new property for month-week schedule

            proxy._$treegridPane = null,
            proxy._$ganttchartPane = null,
            proxy._$treegrid = null,
            proxy._$ganttchart = null,
            proxy._$ejGantt = null,
            proxy._$treegridHelper = null,
            proxy._$ganttchartHelper = null;
            proxy._tdsOffsetWidth = [];
            proxy._subPosx = [];
            proxy._predecessorsCollection = [];
            proxy._connectorLinesCollection = [];            
            proxy._updatedConnectorLineCollection = [];
            proxy._connectorlineIds = [];
            proxy._gridRows = null;

            //variables used for ExpandCollapse action in non Virtualization 
            proxy._collapsedRecordCount = 0;
            proxy._expandedRecordsCount = 0;
            proxy._totalCollapseRecordCount = 0;
            proxy._isInExpandCollapse = false;

            proxy._hiddenRecordCount = 0;
            
            proxy.prevPredecessorTO = null;
            proxy.prevPredecessorFrom = null;
            proxy.prevPredecessorcount = 0;
            proxy._isValidationEnabled = true;
            proxy._isTreeGridRendered = false;//indicate treegrid part is rendered or not for refresh row
            proxy._isGanttChartRendered = false;//indicate gantChart part is rendered or not
            proxy._isChartRendering = false;//To check chart is re-rendering for timescale unit size
            proxy._holidaysList = proxy._getHoliday();
            proxy._stringHolidays = proxy._getStringHolidays();
            proxy._isinBeginEdit = false;
            proxy._isMileStoneEdited = false;
            proxy._cellEditColumn = null;
            proxy._isinAddnewRecord = false;
           
            //variables for context menu items
            proxy._contextMenuItems = null; //proxy._getContextMenuItems();
            proxy._totalBorderWidth = 2;//Left and Right border width

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 3 : 2;//top,bottom,toolbar div
            } else {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 1 : 0;//top box-sizing:border-box includes it's border
            }
            //private variable decalartion for localization
            proxy._columnHeaderTexts = null;
            proxy._predecessorEditingTexts = null;
            proxy._editDialogTexts = null;
            proxy._toolboxTooltipTexts = null;
            proxy._durationUnitTexts = null;
            proxy._durationUnitEditText = null;
            proxy._workUnitTexts = null;
            proxy._taskTypeTexts = null;
            proxy._effortDrivenTexts = null;
            proxy._contextMenuTexts = null;
            proxy._columnMenuTexts = null;
            proxy._editTypeText = null;
            proxy._clipModeText = null;
            proxy._textAlignTypeText = null;
            proxy._columnDialogTitle = null;
            proxy._deleteColumnText = null;
            proxy._okButtonText = null;
            proxy._cancelButtonText = null;
            proxy._confirmDeleteText = null;
            proxy._columnDialogTexts = null;
            proxy._newTaskTexts = null;
            proxy._months = null;  
            proxy._days = null;
            proxy._dialogTabTitleTexts = null;
            proxy._isLoad = true;
            proxy._updatedColumn = "";
            proxy._isExistingUnitIsUpdated = false;
            proxy._isDurationUpdated = false;
            proxy._isResourceAddedOrRemoved = false;
            proxy._newRecordResourceCollection = [];//maintan newly added row resources and its units.

            /*alert text localization*/
            proxy._alertTexts = null;

            proxy._commonColumnWidth = 150;
            proxy._searchString = "",
            proxy._emptyDataColumns = [],
            proxy.secondaryDatasource = [];
            proxy._datasourceChildItems = [];
            proxy._$predecessorTable = null;
            proxy._mappingItems = [];
            proxy._editedDialogRecord = null;
            proxy._calculateDimensions();
            proxy._retrivedData = this.dataSource();
            proxy._isInExpandCollapseAll = false;
            proxy._preTableCollection = [];
            proxy._defaultStartTime = null;
            proxy._defaultEndTime = null;
            proxy._workingTimeRanges = [];
            proxy._nonWorkingHours = [];
            this._validateTimeRange();
            //deprecate working timescaale API with dayWorkingTime API
            if (JSON.stringify(model.dayWorkingTime) == '[{\"from\":\"08:00 AM\",\"to\":\"12:00 PM\"},{\"from\":\"01:00 PM\",\"to\":\"05:00 PM\"}]') {
                if (model.workingTimeScale != ej.Gantt.workingTimeScale.TimeScale8Hours)
                    model.dayWorkingTime = [{ from: "12:00 AM", to: "12:00 AM" }];
                else
                    model.dayWorkingTime = [{ from: "08:00 AM", to: "12:00 PM" }, { from: "01:00 PM", to: "05:00 PM" }];
            }
            proxy._secondsPerDay = proxy._getSecondsPerDay();
            proxy._timelineWidthCalculation();
            proxy._localizedLabels = proxy._getLocalizedLabels();
            //culture info assigned for private variables
            proxy._setCultureInfo();
            //Column collection populated
            proxy.setColumns(model.columns && model.columns.length ? model.columns : proxy.createTreeGridColumns());

            //update columns dropdown data while changing localization dynamically.
            if (model.isRerender)
                proxy._updateColumnDropDownData();

            proxy._updateColumnLocaleText();
            /* flag for refreshing newly added record */
            proxy._isRefreshAddedRecord = false;
            /* Used as flag for refresh chart and grid rows on adding when parent item is in collpased state*/
            proxy._isInAdd = false;
            //context menu sctive item's ID
            proxy._activeMenuItemId = null;
            proxy._isAddEditDialogSave = false;
            proxy._setTaskbarHeight(model.taskbarHeight);            
            proxy.isCriticalPathEnable = false;
            proxy.criticalPathCollection = [];
            proxy.detailPredecessorCollection = [];
            proxy.collectionTaskId = [];
            proxy._enableDisableCriticalIcon = false;
            proxy._generalTabColumnFields = [];
            proxy._addDialogGeneralColumns = [];
            proxy._addDialogcustomColumns = [];
            proxy._editDialogGeneralColumns = [];
            proxy._editDialogCustomColumns = [];
            //update resource unit mapping value
            if (model.resourceUnitMapping == "")
                model.resourceUnitMapping = "unit";
            proxy._dialogTab = ["General", "Predecessors", "Resources", "Custom Fields", "Notes"];
            proxy._cssClass = model.cssClass;
        },
        //Update all the private variables widths to model
        _updateModelsWidth: function () {
            var proxy = this, model = proxy.model;
            model.perDayWidth = proxy._perDayWidth ? proxy._perDayWidth : null;
            model.perMonthWidth = proxy._perMonthWidth ? proxy._perMonthWidth : null;
            model.perWeekWidth = proxy._perWeekWidth ? proxy._perWeekWidth : null;
            model.perHourWidth = proxy._perHourWidth ? proxy._perHourWidth : null;
            model.perMinuteWidth = proxy._perMinuteWidth ? proxy._perMinuteWidth : null;
            model.minuteInterval = proxy._minuteInterval ? proxy._minuteInterval : null;
        },
        //Gantt chart timeline width calculation
        _timelineWidthCalculation: function (scaleSize) {
            var proxy = this, model = proxy.model,
                fitTimescaleSize = true,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                timescaleUnitSize = model.scheduleHeaderSettings.timescaleUnitSize,
                timescaleUnitSizeStr = timescaleUnitSize.toString(),
                timescaleSizeValue;
            //On Initial loading - timescaleSizeValue
            if (scaleSize == undefined && timescaleUnitSize != "100%") {
                fitTimescaleSize = false;
                var negativeVal = timescaleUnitSizeStr.indexOf("-");
                if (negativeVal != -1)
                    timescaleSizeValue = 100;//default value
                else
                    timescaleSizeValue = +(timescaleUnitSizeStr.match(/\d+/)[0]);
                if (timescaleSizeValue < 50)
                    timescaleSizeValue = 50;
                else if (timescaleSizeValue > 500)
                    timescaleSizeValue = 500;
                model.scheduleHeaderSettings.timescaleUnitSize = timescaleSizeValue + "%";//To receive updated value
            }
            //Dynamic update - timescaleSizeValue
            if (scaleSize != undefined) {
                fitTimescaleSize = false;
                var negativeVal = timescaleUnitSizeStr.indexOf("-");
                if (negativeVal != -1)
                    timescaleSizeValue = timescaleUnitSize;//Existing scale value
                else
                    timescaleSizeValue = +(timescaleUnitSizeStr.match(/\d+/)[0]);
                if (timescaleSizeValue < 50)
                    timescaleSizeValue = 50;
                else if (timescaleSizeValue > 500)
                    timescaleSizeValue = 500;
                model.scheduleHeaderSettings.timescaleUnitSize = timescaleSizeValue + "%";//To receive updated value
            }
            if (scheduleMode == "week") {
                proxy._perDayWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.3) : 30;
                proxy._perMinuteWidth = proxy._perDayWidth / (24 * 60);
            }
            else if (scheduleMode == "year") {
                proxy._perDayWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.03) : 3;
                proxy._perMonthWidth = proxy._perDayWidth * 30;
                proxy._perMinuteWidth = proxy._perDayWidth / (24 * 60);
            }
            else if (scheduleMode == "month") {
                proxy._perDayWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.1) : 10;
                proxy._perWeekWidth = proxy._perDayWidth * 7;
                proxy._perHourWidth = proxy._perDayWidth / 24;
                proxy._perMinuteWidth = proxy._perDayWidth / (24 * 60);
            }
            else if (scheduleMode == "day") {
                proxy._perHourWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.2) : 20;
                proxy._perMinuteWidth = proxy._perHourWidth / 60;
                proxy._perDayWidth = (proxy._perHourWidth * 24);//24 hours
            }
            else if (scheduleMode == "hour") {
                var minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval,
                    intervalValue = ej.Gantt.minutesPerInterval;
                proxy._perMinuteWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.2) : 20;
                if (minutesPerInterval) {
                    if (minutesPerInterval == intervalValue.Auto) {
                        var scheduleStartDate = proxy._getDateFromFormat(model.scheduleStartDate),
                            scheduleEndDate = proxy._getDateFromFormat(model.scheduleEndDate),
                            twoDaysTimeSpan = 2 * 86400000,// Time in milliseconds
                            sevenDaysTimeSpan = 7 * 86400000,//Time in milliseconds
                            tenDaysTimeSpan = 10 * 86400000,
                            diff = scheduleEndDate - scheduleStartDate;

                        if (diff > tenDaysTimeSpan) {
                            proxy._minuteInterval = 30;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                        }
                        else if (diff > sevenDaysTimeSpan) {
                            proxy._minuteInterval = 15;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                        }
                        else if (diff > twoDaysTimeSpan) {
                            proxy._minuteInterval = 5;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                        }
                        else {
                            proxy._minuteInterval = 1;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);//24 hours
                        }
                    }
                    else if (minutesPerInterval == intervalValue.OneMinute) {
                        proxy._minuteInterval = 1;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);
                    }
                    else if (minutesPerInterval == intervalValue.FiveMinutes) {
                        proxy._minuteInterval = 5;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                    }
                    else if (minutesPerInterval == intervalValue.FifteenMinutes) {
                        proxy._minuteInterval = 15;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                    }
                    else if (minutesPerInterval == intervalValue.ThirtyMinutes) {
                        proxy._minuteInterval = 30;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                    }
                }                
            }
            proxy._updateModelsWidth();
        },
        //Private method for changing timescaleSize
        _updateTimescaleUnitSize: function (sizeValue) {
            var proxy = this, model = proxy.model,
                scheduleHeaderSettings = model.scheduleHeaderSettings,
                previousTimescaleUnitSize = scheduleHeaderSettings.timescaleUnitSize;
            scheduleHeaderSettings.timescaleUnitSize = sizeValue;
            //Calculate timeline width for timescaleUnitSize value
            proxy._timelineWidthCalculation(sizeValue);
            //Re render the gantt chart side alone
            proxy.updateScheduleDates(model.scheduleStartDate, model.scheduleEndDate);
            // Update the scrollbar to focus the selected taskbar while zooming
            var selectedItemIndex = proxy.selectedRowIndex();
            if (selectedItemIndex >= 0) {
                proxy.focusOnTask(selectedItemIndex);
            }
        },

        /*validate dayWorkingTime API if it is not valid assign default value to this API*/
        _validateTimeRange: function () {
            var tempDay = "01/01/2016", tempEndDay = "01/02/2016", proxy = this, model = this.model,
               length = model.dayWorkingTime.length, isValid = true, prevTimeline = null;//MM/dd/yyyy
            for (var count = 0; count < length; count++) {
                var currentRange = model.dayWorkingTime[count];
                if (currentRange.from && currentRange.to) {
                    var startHour = ej.parseDate(tempDay + " " + currentRange.from, "MM/dd/yyyy h:mm tt", "en-US"),
                        endHour = currentRange.to != "12:00 AM" ? ej.parseDate(tempDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US") : ej.parseDate(tempEndDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US"),
                        timeDiff = endHour.getTime() - startHour.getTime(),
                        sdHour = this._getSecondsInDecimal(startHour),
                        edHour = this._getSecondsInDecimal(endHour);
                    if (edHour == 0)
                        edHour = 86400; // second in a day
                    if (sdHour >= edHour) {
                        isValid = false;
                    }
                    else {
                        if (prevTimeline == null)
                            prevTimeline = edHour;
                        else if (prevTimeline >= sdHour || prevTimeline >= edHour)
                            isValid = false;
                    }
                }
                else {
                    isValid = false;
                }
            }
            if (!isValid) {
                model.dayWorkingTime = [{ from: "08:00 AM", to: "12:00 PM" }, { from: "01:00 PM", to: "05:00 PM" }];
            }
        },
        /*Get date from string*/
        _getParsedDate: function (value, format, locale) {
            return ej.parseDate(value, format, locale);
        },
        _setTime: function (seconds, date) {
            var hour = parseInt(seconds / (3600)),
                min = parseInt((seconds - (hour * 3600)) / 60),
                sec = seconds - (hour * 3600) - (min * 60);
            date.setHours(hour, min, sec, 0);
        },
        // Update date next recent working hours
        _checkStartDate: function (date, record, validateAsMilestone) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), startRangeIndex = -1,
                isMilestone = ej.isNullOrUndefined(validateAsMilestone) ? !ej.isNullOrUndefined(record) ? record.isMilestone : false : validateAsMilestone;
            if (hour < this._defaultStartTime) {
                this._setTime(this._defaultStartTime, cloneDate);
            } else if (hour == this._defaultEndTime && (!record || !isMilestone)) {//milestone can fall at end of the day
                cloneDate.setDate(cloneDate.getDate() + 1);
                this._setTime(this._defaultStartTime, cloneDate);
            }
            else if (hour > this._defaultEndTime) {
                cloneDate.setDate(cloneDate.getDate() + 1);
                this._setTime(this._defaultStartTime, cloneDate);
            } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (hour >= val.to && (this._workingTimeRanges[i + 1] && hour < this._workingTimeRanges[i + 1].from)) {
                        //milestone can fall at end of any interval time
                        if (hour == val.to && (!record || !isMilestone))
                            this._setTime(this._workingTimeRanges[i + 1].from, cloneDate);
                        else if (hour != val.to)
                            this._setTime(this._workingTimeRanges[i + 1].from, cloneDate);
                        break;
                    }
                }
            }
            var tempStartDate;
            do{
                tempStartDate = new Date(cloneDate);
                //check holidays and weekends
                if ((!ej.isNullOrUndefined(record) && record.isAutoSchedule && (!model.includeWeekend || model.holidays.length > 0)) || (ej.isNullOrUndefined(record) && (!model.includeWeekend || model.holidays.length > 0))) {
                    if (!model.includeWeekend) {
                        if (cloneDate.getDay() == 0) {
                            cloneDate.setDate(cloneDate.getDate() + 1);
                            this._setTime(this._defaultStartTime, cloneDate);
                            //cloneDate.setHours(this._defaultStartTime, 0, 0, 0);
                        }
                        else if (cloneDate.getDay() == 6) {
                            cloneDate.setDate(cloneDate.getDate() + 2);
                            this._setTime(this._defaultStartTime, cloneDate);
                           // cloneDate.setHours(this._defaultStartTime, 0, 0, 0);
                        }
                    }
                    for (var count = 0; count < model.holidays.length; count++) {
                        var holidayFrom = this._getDateFromFormat(model.holidays[count].day),
                            holidayTo = new Date(holidayFrom);
                        holidayFrom.setHours(0, 0, 0, 0);
                        holidayTo.setHours(23, 59, 59, 59);
                        if (cloneDate.getTime() >= holidayFrom.getTime() && cloneDate.getTime() < holidayTo.getTime()) {
                            cloneDate.setDate(cloneDate.getDate() + 1);
                            this._setTime(this._defaultStartTime, cloneDate);
                            //cloneDate.setHours(this._defaultStartTime, 0, 0, 0);
                        }
                    }
                }
            } while (tempStartDate.getTime() != cloneDate.getTime());
            return new Date(cloneDate);
            //Holiday Update
        },
        //Update the date to previous working time
        _checkEndDate: function (date, record) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), endRangeIndex = -1;
            if (hour > this._defaultEndTime) {
                this._setTime(this._defaultEndTime, cloneDate);
            //    cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
            } else if (hour <= this._defaultStartTime) {
                cloneDate.setDate(cloneDate.getDate() - 1);
                this._setTime(this._defaultEndTime, cloneDate);
              //  cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
            } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (hour > val.to && (this._workingTimeRanges[i + 1] && hour <= this._workingTimeRanges[i + 1].from)) {
                        this._setTime(this._workingTimeRanges[i].to, cloneDate);
                        //cloneDate.setHours(this._workingTimeRanges[i].to, 0, 0, 0);
                        break;
                    }
                }
            }
            var tempCheckDate;
            do {
                tempCheckDate = new Date(cloneDate);
                if ((!ej.isNullOrUndefined(record) && record.isAutoSchedule && (!model.includeWeekend || model.holidays.length > 0)) || (ej.isNullOrUndefined(record) && (!model.includeWeekend || model.holidays.length > 0))) {

                    //Update Weekend and holidays
                    if (!model.includeWeekend) {
                        if (cloneDate.getDay() == 0) {
                            cloneDate.setDate(cloneDate.getDate() - 2);
                            this._setTime(this._defaultEndTime, cloneDate);
                            //cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                        }
                        else if (cloneDate.getDay() == 6) {
                            cloneDate.setDate(cloneDate.getDate() - 1);
                            this._setTime(this._defaultEndTime, cloneDate);
                            //cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                        }
                        else if (cloneDate.getDay() == 1 && this._defaultEndTime == 86400 && this._getSecondsInDecimal(cloneDate) == 0) {
                            cloneDate.setDate(cloneDate.getDate() - 2);
                        }
                    }
                    for (var count = 0; count < model.holidays.length; count++) {
                        var holidayFrom = this._getDateFromFormat(model.holidays[count].day),
                            holidayTo = new Date(holidayFrom),
                            tempHoliDay = new Date(cloneDate);
                        tempHoliDay.setMinutes(cloneDate.getMinutes() - 2);
                        holidayFrom.setHours(0, 0, 0, 0);
                        holidayTo.setHours(23, 59, 59, 59);
                        if (cloneDate.getTime() >= holidayFrom.getTime() && cloneDate.getTime() < holidayTo.getTime() || (tempHoliDay.getTime() >= holidayFrom.getTime() && tempHoliDay.getTime() < holidayTo.getTime())) {
                            cloneDate.setDate(cloneDate.getDate() - 1);
                            if (!(cloneDate.getTime() == holidayFrom.getTime() && this._defaultEndTime == 86400 && this._getSecondsInDecimal(cloneDate) == 0))
                                this._setTime(this._defaultEndTime, cloneDate);
                                //cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                        }
                    }
                }
            } while (tempCheckDate.getTime() != cloneDate.getTime());
            return new Date(cloneDate);
        },

        _checkBaseLineStartDate: function (date) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), startRangeIndex = -1;
            if (ej.isNullOrUndefined(date)) {
                return "";
            }
            else {
                if (hour < this._defaultStartTime) {
                    this._setTime(this._defaultStartTime, cloneDate);
                } else if (hour >= this._defaultEndTime) {
                    cloneDate.setDate(cloneDate.getDate() + 1);
                    this._setTime(this._defaultStartTime, cloneDate);
                } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                    for (var i = 0; i < this._workingTimeRanges.length; i++) {
                        var val = this._workingTimeRanges[i];
                        if (hour >= val.to && (this._workingTimeRanges[i + 1] && hour < this._workingTimeRanges[i + 1].from)) {
                            this._setTime(this._workingTimeRanges[i + 1].from, cloneDate);
                            break;
                        }
                    }
                }
                return cloneDate;
            }
        },

        _checkBaseLineEndDate: function (date) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), endRangeIndex = -1;
            if (ej.isNullOrUndefined(date)) {
                return "";
            }
            else {
                if (hour > this._defaultEndTime) {
                    this._setTime(this._defaultEndTime, cloneDate);
                    //    cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                } else if (hour <= this._defaultStartTime) {
                    cloneDate.setDate(cloneDate.getDate() - 1);
                    this._setTime(this._defaultEndTime, cloneDate);
                    //  cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                    for (var i = 0; i < this._workingTimeRanges.length; i++) {
                        var val = this._workingTimeRanges[i];
                        if (hour > val.to && (this._workingTimeRanges[i + 1] && hour <= this._workingTimeRanges[i + 1].from)) {
                            this._setTime(this._workingTimeRanges[i].to, cloneDate);
                            //cloneDate.setHours(this._workingTimeRanges[i].to, 0, 0, 0);
                            break;
                        }
                    }
                }
                return cloneDate;
            }
        },
        /*get left value of task with schedule start*/
        _getTaskLeft: function (currentDate) {
            var date = new Date(currentDate), model = this.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType;
            if (headerType == ej.Gantt.ScheduleHeaderType.Week || headerType == ej.Gantt.ScheduleHeaderType.Month
                || headerType == ej.Gantt.ScheduleHeaderType.Year) {
                if (this._getSecondsInDecimal(date) == this._defaultStartTime) {
                    date.setHours(0, 0, 0, 0);
                }
            }
            if (this._projectStartDate)
                return (((date.getTime() - this._projectStartDate.getTime()) / (1000 * 60 * 60 * 24)) * this._perDayWidth);//this._perMinuteWidth
            else
                return 0;
        },
        /*get width value of task*/
        _getTaskWidth: function (startDate, endDate) {
            var sDate = new Date(startDate), eDate = new Date(endDate), model = this.model,
               headerType = model.scheduleHeaderSettings.scheduleHeaderType;

            if (headerType == ej.Gantt.ScheduleHeaderType.Week || headerType == ej.Gantt.ScheduleHeaderType.Month
                || headerType == ej.Gantt.ScheduleHeaderType.Year) {
                if (this._getSecondsInDecimal(sDate) == this._defaultStartTime) {
                    sDate.setHours(0, 0, 0, 0);
                }
                if (this._getSecondsInDecimal(eDate) == this._defaultEndTime) {
                    eDate.setHours(24);
                }
            }
            var timeDiff = eDate.getTime() - sDate.getTime();

            return ((timeDiff / (1000 * 60 * 60 * 24)) * this._perDayWidth);//per day width
        },
        /*Get holidays betwwen two dates range*/
        _getHolidaysCount: function (startDate, endDate) {
            var model = this.model,
                holidays = this.model.holidays,
                holidaysCount = 0;
            for (var i = 0; i < holidays.length; i++) {
                var currentHoliday = this._getDateFromFormat(holidays[i].day);
                if (startDate.getTime() < currentHoliday.getTime() && endDate.getTime() >= currentHoliday.getTime())
                    if (!model.includeWeekend && currentHoliday.getDay() != 0 && currentHoliday.getDay() != 6)
                        holidaysCount += 1;
                    else if (model.includeWeekend) {
                        holidaysCount += 1;
                    }
            }
            return holidaysCount;
        },

        //get weekend days between two dates without including args dates
        _getWeekendCount: function (startDate, endDate) {
            var sDay = new Date(startDate), eDay = new Date(endDate), weekEndCount = 0;
            sDay.setHours(0, 0, 0, 0);
            sDay.setDate(sDay.getDate() + 1);
            eDay.setHours(0, 0, 0, 0);
            while (sDay.getTime() < eDay.getTime()) {
                if (sDay.getDay() == 0) {
                    weekEndCount += 1;
                    sDay.setDate(sDay.getDate() + 5);
                }
                if (sDay.getTime() < endDate.getTime() && sDay.getDay() == 6) {
                    weekEndCount += 1;
                }
                sDay.setDate(sDay.getDate() + 1);
            }
            return weekEndCount;
        },
        /*get days between two dates*/
        _getDayDiff: function (startDate, endDate) {
            return (endDate.getTime() - startDate.getTime()) / (1000 * 60 * 60 * 24);
        },
        //Get seconds between two Dates
        _getNumberOfSeconds: function (startDate, endDate) {
            var sDay = new Date(startDate), eDay = new Date(endDate), weekEndCount = 0, timeDiff = 0;
            sDay.setHours(0, 0, 0, 0);
            sDay.setDate(sDay.getDate() + 1);
            eDay.setHours(0, 0, 0, 0);
            if (sDay.getTime() < eDay.getTime())
                timeDiff = (eDay.getTime() - sDay.getTime()) / 1000;
            return timeDiff;
        },
        //Calculate end date with startDate,duration ,duration Unit
        _getEndDate: function (startDate, duration, durationUnit, record, validateAsMilestone) {
            var secondDuration = 0, sHour = -1, nextAvailDuration = 0, endDate = new Date(startDate), startRangeIndex = -1;
            if (!durationUnit || durationUnit == ej.Gantt.DurationUnit.Day)
                secondDuration = this._secondsPerDay * duration;
            else if (durationUnit == ej.Gantt.DurationUnit.Hour)
                secondDuration = duration * 3600;
            else
                secondDuration = duration * 60;

            while (secondDuration > 0) {
                sHour = this._getSecondsInDecimal(endDate);
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (sHour >= val.from && sHour <= val.to) {
                        startRangeIndex = i;
                        break;
                    }
                }
                nextAvailDuration = Math.round(this._workingTimeRanges[startRangeIndex].to - sHour);
                if (nextAvailDuration <= secondDuration) {
                    endDate.setSeconds(endDate.getSeconds() + nextAvailDuration);
                    secondDuration -= nextAvailDuration;
                } else {
                    endDate.setSeconds(endDate.getSeconds() + secondDuration);
                    break;
                }
                if (secondDuration > 0)
                    endDate = this._checkStartDate(endDate, record, validateAsMilestone);
            }
            return endDate;
        },
        //Calculate start date with endDate,duration ,duration Unit
        _getStartDate: function (endDate, duration, durationUnit, record) {
            var minuteDuraion = 0, sHour = -1, nextAvailDuration = 0, startDate = new Date(endDate), startRangeIndex = -1;
            if (!durationUnit || durationUnit == ej.Gantt.DurationUnit.Day)
                minuteDuraion = this._secondsPerDay * duration;
            else if (durationUnit == ej.Gantt.DurationUnit.Hour)
                minuteDuraion = duration * 3600;
            else
                minuteDuraion = duration * 60;

            while (minuteDuraion > 0) {
                sHour = this._getSecondsInDecimal(startDate);
                if (this._workingTimeRanges.length > 0 && this._workingTimeRanges[this._workingTimeRanges.length - 1].to == 86400 && sHour == 0) {
                    sHour = 86400;
                }
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (sHour >= val.from && sHour <= val.to) {
                        startRangeIndex = i;
                        break;
                    }
                }
                nextAvailDuration = Math.round(sHour - this._workingTimeRanges[startRangeIndex].from);//In Minutes
                if (nextAvailDuration <= minuteDuraion) {
                    startDate.setSeconds(startDate.getSeconds() - nextAvailDuration);
                    minuteDuraion -= nextAvailDuration;
                } else {
                    startDate.setSeconds(startDate.getSeconds() - minuteDuraion);
                    break;
                }
                if (minuteDuraion > 0)
                    startDate = this._checkEndDate(startDate, record);
            }
            return startDate;
        },
        /*get duration betwwen two dates according to duration unit value*/
        _getDuration: function (sDate, eDate, durationUnit, isAutoSchedule) {
            var timeDiff = eDate.getTime() - sDate.getTime(), durationValue,
               weekendCount = !this.model.includeWeekend && isAutoSchedule ? this._getWeekendCount(sDate, eDate) : 0,
               nonWrkHours = 0, durationHrs = 0, totalHours = this._getNumberOfSeconds(sDate, eDate),
               holidaysCount = isAutoSchedule ? this._getHolidaysCount(sDate, eDate) : 0;
            timeDiff = timeDiff / 1000;
            totalHours = (totalHours - (weekendCount * 86400) - (holidaysCount * 86400)) / 86400; // days between two dates
            nonWrkHours = this._getNonWorkingSecondsOnDate(sDate, eDate);
            durationHrs = timeDiff - (totalHours * (86400 - this._secondsPerDay)) - (weekendCount * 86400) - (holidaysCount * 86400) - nonWrkHours;
            if (!durationUnit || durationUnit == ej.Gantt.DurationUnit.Day) {
                durationValue = durationHrs / this._secondsPerDay;
            } else if (durationUnit == ej.Gantt.DurationUnit.Minute) {
                durationValue = durationHrs / 60;
            } else {
                durationValue = durationHrs / 3600;
            }
            return parseFloat(durationValue.toFixed(2));
        },
        /*Get four infomration in date*/
        _getSecondsInDecimal: function (date) {
            return (date.getHours() * 60 * 60) + (date.getMinutes() * 60) + date.getSeconds() + (date.getMilliseconds() / 1000);
        },
        /*get non working hours betwwen two dates*/
        _getNonWorkingSecondsOnDate: function (startDate, endDate) {

            var proxy = this, sHour = this._getSecondsInDecimal(startDate), eHour = this._getSecondsInDecimal(endDate), startRangeIndex = -1, endRangeIndex = -1, totNonWrkSecs = 0;
            for (var i = 0; i < this._workingTimeRanges.length; i++) {
                var val = this._workingTimeRanges[i];
                if (sHour >= val.from && sHour <= val.to)
                    startRangeIndex = i;
                if (eHour >= val.from && eHour <= val.to)
                    endRangeIndex = i;
            }
            if (startDate.getDate() != endDate.getDate() || startDate.getMonth() != endDate.getMonth() || startDate.getFullYear() != endDate.getFullYear()) {
                totNonWrkSecs = proxy._nonWorkingHours[proxy._nonWorkingHours.length - 1 - startRangeIndex] + 86400 - proxy._defaultEndTime;
                totNonWrkSecs += proxy._nonWorkingHours[endRangeIndex] + proxy._defaultStartTime;
            }
            else {
                if (startRangeIndex != endRangeIndex) {
                    totNonWrkSecs = proxy._nonWorkingHours[endRangeIndex] - proxy._nonWorkingHours[startRangeIndex];
                }
            }
            return totNonWrkSecs;
        },
        /*Get working hours between work time range value*/
        _getSecondsPerDay: function () {
            var tempDay = "01/01/2016", tempEndDay = "01/02/2016", proxy = this, model = this.model,
                length = model.dayWorkingTime.length, totalSeconds = 0;//MM/dd/yyyy
            for (var count = 0; count < length; count++) {
                var currentRange = model.dayWorkingTime[count];
                if (currentRange.from && currentRange.to) {

                    var startHour = ej.parseDate(tempDay + " " + currentRange.from, "MM/dd/yyyy h:mm tt", "en-US"),
                        endHour = currentRange.to != "12:00 AM" ? ej.parseDate(tempDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US") : ej.parseDate(tempEndDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US"),
                        timeDiff = endHour.getTime() - startHour.getTime(),
                        sdHour = this._getSecondsInDecimal(startHour),
                        edHour = this._getSecondsInDecimal(endHour);
                    if (edHour == 0)
                        edHour = 86400; // second in a day
                    totalSeconds += timeDiff / 1000;
                    if (count == 0)
                        proxy._defaultStartTime = sdHour;
                    if (count == length - 1)
                        proxy._defaultEndTime = edHour;
                    if (count > 0)
                        proxy._nonWorkingHours.push(proxy._nonWorkingHours[proxy._nonWorkingHours.length - 1] + sdHour - proxy._workingTimeRanges[count - 1].to);
                    else
                        proxy._nonWorkingHours.push(0);
                    proxy._workingTimeRanges.push({ from: sdHour, to: edHour });
                }
            }
            return totalSeconds;
        },

        _updateColumnLocaleText: function () {
            var model = this.model,
                columns = model.columns;
            if (columns && columns.length > 0) {
                for (var count = 0; count < columns.length; count++) {
                    if (columns[count].field && this._columnHeaderTexts[columns[count].field]) {
                        columns[count].headerText = this._columnHeaderTexts[columns[count].field];
                    }
                }
            }
        },
        //calculate height and width for gantt at load time
        _calculateDimensions: function ()
        {
            var proxy = this,
                sizeSettings = this.model.sizeSettings,
                sizeSettingHeight = sizeSettings.height,
                sizeSettingsWidth = sizeSettings.width,
                element = proxy.element,
                elementStyleHeight = element[0].style.height,
                elementStyleWidth = element[0].style.width,
                parentHeight = element.parent().height(),
                parentWidth = element.parent().width();

            if (sizeSettingsWidth)
                element.css("width", sizeSettingsWidth);

            if (sizeSettingHeight)
                element.css("height", sizeSettingHeight);

            /* check given value and assign default value for width and height */
            if (!sizeSettingHeight && !elementStyleHeight) {
                elementStyleHeight = "450px";
                element.css("height", "450px");
            }

            if (!sizeSettingsWidth && !elementStyleWidth) {
                elementStyleWidth = "100%";
                proxy.element.css("width", "100%");
            }
            proxy._ganttHeight = element.height();
            proxy._ganttWidth = element.width();

            if (proxy._ganttHeight === 0) {
                proxy._ganttHeight = 450;
                element.css("450px");
            }
        },
        _setCultureInfo:function() {
            var proxy = this,
               model = proxy.model,
               culture = model.locale,
               localization = $.extend({}, proxy._localizedLabels, 
                ej.isNullOrUndefined(ej.cultures[culture]) ? ej.cultures["default"] : ej.cultures[culture]),
               defaultLocalization = $.extend({}, ej.cultures["default"], ej.Gantt.Locale["default"]);
            model.dateFormat = !model.dateFormat ? ((localization && localization["calendars"] &&
                    localization["calendars"]["standard"]["patterns"]) ?
                (localization["calendars"]["standard"]["patterns"]["d"]) :
                ej.preferredCulture(culture) ? ej.preferredCulture(culture)["calendars"]["standard"]["patterns"]["d"] :
                    defaultLocalization["calendars"]["standard"]["patterns"]["d"]) : model.dateFormat;

            
            //EmptyRecord text to be displayed with dataSource is null
            proxy._emptyRecordText = (localization && localization["emptyRecord"]) ?
                localization["emptyRecord"] : defaultLocalization["emptyRecord"];
            
            //ColumnHeaderText to be displayed in treegrid
            proxy._columnHeaderTexts = ( localization && localization["columnHeaderTexts"] ) ?
                localization["columnHeaderTexts"] : defaultLocalization["columnHeaderTexts"];
            
            proxy._columnHeaderTexts = $.extend({}, defaultLocalization["columnHeaderTexts"], proxy._columnHeaderTexts);

            //taskModeDropDownValue to be displayed in treegrid
            proxy._taskModeTexts = (localization && localization["taskModeTexts"]) ?
                localization["taskModeTexts"] : defaultLocalization["taskModeTexts"];

            proxy._taskModeTexts = $.extend({}, defaultLocalization["taskModeTexts"], proxy._taskModeTexts);

            //EditDialog Text to be displayed in popup window
            proxy._editDialogTexts = (localization && localization["editDialogTexts"]) ?
                localization["editDialogTexts"] : defaultLocalization["editDialogTexts"];

            proxy._editDialogTexts = $.extend({}, defaultLocalization["editDialogTexts"], proxy._editDialogTexts);

            //Add Column Dialog Text to be displayed in popup window
            proxy._columnDialogTexts = (localization && localization["columnDialogTexts"]) ?
                localization["columnDialogTexts"] : defaultLocalization["columnDialogTexts"];

            //Tooltip Text to be displayed in the Toolbar
            proxy._toolboxTooltipTexts = (localization && localization["toolboxTooltipTexts"]) ?
                localization["toolboxTooltipTexts"] :
                defaultLocalization["toolboxTooltipTexts"];

            proxy._toolboxTooltipTexts = $.extend({}, defaultLocalization["toolboxTooltipTexts"], proxy._toolboxTooltipTexts);
            //Tooltip Text to be displayed on the Taskbar for duration units
            proxy._durationUnitTexts = (localization && localization["durationUnitTexts"]) ?
                localization["durationUnitTexts"] : defaultLocalization["durationUnitTexts"];

            proxy._durationUnitTexts = $.extend({}, defaultLocalization["durationUnitTexts"], proxy._durationUnitTexts);

            //Tooltip Text to be displayed on the Taskbar for duration units
            proxy._durationUnitEditText = (localization && localization["durationUnitEditText"]) ?
                localization["durationUnitEditText"] : defaultLocalization["durationUnitEditText"];

            proxy._durationUnitEditText = $.extend({}, defaultLocalization["durationUnitEditText"], proxy._durationUnitEditText);


            //Unit text to display in Work field.
            proxy._workUnitTexts = (localization && localization["workUnitTexts"]) ?
                localization["workUnitTexts"] : defaultLocalization["workUnitTexts"];
            
            proxy._workUnitTexts = $.extend({}, defaultLocalization["workUnitTexts"], proxy._workUnitTexts);
            
            //Text to be displayed in type drop down.
            proxy._taskTypeTexts = (localization && localization["taskTypeTexts"]) ?
                localization["taskTypeTexts"] : defaultLocalization["taskTypeTexts"];
            
            proxy._taskTypeTexts = $.extend({}, defaultLocalization["taskTypeTexts"], proxy._taskTypeTexts);
            
            //Text to be displayed in default type drop down.
            proxy._effortDrivenTexts = (localization && localization["effortDrivenTexts"]) ?
                localization["effortDrivenTexts"] : defaultLocalization["effortDrivenTexts"];
            
            proxy._effortDrivenTexts = $.extend({}, defaultLocalization["effortDrivenTexts"], proxy._effortDrivenTexts);

            //Context Menu Text
            proxy._contextMenuTexts = (localization && localization["contextMenuTexts"]) ?
                localization["contextMenuTexts"] : defaultLocalization["contextMenuTexts"];

            proxy._contextMenuTexts = $.extend({}, defaultLocalization["contextMenuTexts"], proxy._contextMenuTexts);
            //Name for New Task while adding
            proxy._newTaskTexts = (localization && localization["newTaskTexts"]) ?
                localization["newTaskTexts"] : defaultLocalization["newTaskTexts"];
            
            //Month names to be displayed in schedule
            proxy._months = (localization && localization["calendars"]) ?
                localization["calendars"]["standard"]["months"]["namesAbbr"] :
                ej.preferredCulture(culture) ? ej.preferredCulture(culture)["calendars"]["standard"]["months"]["namesAbbr"] :
                defaultLocalization["calendars"]["standard"]["months"]["namesAbbr"];
            
            //Day names to displayed in schedule
            proxy._days = (localization && localization["calendars"]) ?
                localization["calendars"]["standard"]["months"]["namesAbbr"] :
                ej.preferredCulture(culture) ? ej.preferredCulture(culture)["calendars"]["standard"]["days"]["namesAbbr"] :
                defaultLocalization["calendars"]["standard"]["days"]["namesAbbr"];

            //Column Menu Text
            proxy._columnMenuTexts = (localization && localization["columnMenuTexts"]) ?
                localization["columnMenuTexts"] : defaultLocalization["columnMenuTexts"];

            proxy._columnMenuTexts = $.extend({}, defaultLocalization["contextMenuTexts"], proxy._columnMenuTexts);

            //Column dialog title Text 
            proxy._columnDialogTitle = (localization && localization["columnDialogTitle"]) ?
                localization["columnDialogTitle"] : defaultLocalization["columnDialogTitle"];


            //Deleting the column texts 
            proxy._deleteColumnText = (localization && localization["deleteColumnText"]) ?
                localization["deleteColumnText"] : defaultLocalization["deleteColumnText"];

            proxy._okButtonText = (localization && localization["okButtonText"]) ?
                localization["okButtonText"] : defaultLocalization["okButtonText"];

            proxy._cancelButtonText = (localization && localization["cancelButtonText"]) ?
                localization["cancelButtonText"] : defaultLocalization["cancelButtonText"];

            proxy._confirmDeleteText = (localization && localization["confirmDeleteText"]) ?
                    localization["confirmDeleteText"] : defaultLocalization["confirmDeleteText"];

            //Predecssor Editing Text
            proxy._predecessorEditingTexts = localization && localization["predecessorEditingTexts"] ?
                localization["predecessorEditingTexts"] : defaultLocalization["predecessorEditingTexts"];

            proxy._predecessorEditingTexts = $.extend({}, defaultLocalization["contextMenuTexts"], proxy._predecessorEditingTexts);


            proxy._alertTexts = localization && localization["alertTexts"] ?
                localization["alertTexts"] : defaultLocalization["alertTexts"];

            proxy._alertTexts = $.extend({}, defaultLocalization["alertTexts"], proxy._alertTexts);
            
            //TabDialogText to be displayed in Gantt add and edit dialog
            proxy._dialogTabTitleTexts = (localization && localization["dialogTabTitleTexts"]) ?
                localization["dialogTabTitleTexts"] : defaultLocalization["dialogTabTitleTexts"];

            proxy._dialogTabTitleTexts = $.extend({}, defaultLocalization["dialogTabTitleTexts"], proxy._dialogTabTitleTexts);

            proxy._predecessorCollectionText = localization && localization["predecessorCollectionText"] ?
                localization["predecessorCollectionText"] : defaultLocalization["predecessorCollectionText"];

            //Edit type text
            proxy._editTypeText = (localization && localization["editTypeTexts"]) ?
                localization["editTypeTexts"] : defaultLocalization["editTypeTexts"];

            //Edit types text
            proxy._textAlignTypeText = (localization && localization["textAlignTypes"]) ?
                localization["textAlignTypes"] : defaultLocalization["textAlignTypes"];

            //Clip mode types text
            proxy._clipModeText = (localization && localization["clipModeTexts"]) ?
                localization["clipModeTexts"] : defaultLocalization["clipModeTexts"];
        },

        //Populate available fields
        _getMappingItems: function () {
            var proxy = this,
                model = proxy.model,
                mappingItems = [],
                length = proxy._columns.length;

            for (var i = 0; i < length; i++) {
                mappingItems.push(proxy._columns[i].mappingName);
            }
            return mappingItems;
        },

        //populate the context menu with items
        _getContextMenuItems: function () {
            var contextMenuItems = [],
                proxy = this,
                contextMenuLabel = this._contextMenuTexts;

            contextMenuItems = [{
                headerText: contextMenuLabel["taskDetailsText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Task",

            }, {
                headerText: contextMenuLabel["addNewTaskText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Add"
            },
             {
                headerText: contextMenuLabel["indentText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Indent"
            }, {
                headerText: contextMenuLabel["outdentText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Outdent"
            }, {
                headerText: contextMenuLabel["deleteText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Delete"
            },
            {
                iconPath: null,
                headerText: contextMenuLabel["aboveText"],
                eventHandler: null,
                menuId: "Above",
                parentMenuId: "Add"
            }, {
                iconPath: null,
                headerText: contextMenuLabel["belowText"],
                eventHandler: null,
                menuId: "Below",
                parentMenuId: "Add"
            }
           ];
            return contextMenuItems;
        },

        //rendering is initiated here
        _initialize: function () {

            if (this._isFromSetModel)
                return;
            else {
                var proxy = this, model = proxy.model;
                model.cssClass && (proxy.element.addClass(model.cssClass));
                proxy._$treegridPane = ej.buildTag('div.e-treegridPane');
                proxy._$ganttchartPane = ej.buildTag('div.e-ganttchartPane');
                proxy._$ejGantt = ej.buildTag('div.e-gantt-Spliter#e-ejSpliter' + proxy._id, "", {}, { 'unselectable': "on" });
                model.predecessorMapping && proxy._updatePredecessors();
                proxy._render();
                model.updatedRecords = model.flatRecords.slice();
                model.currentViewData = model.flatRecords.slice();
                model.predecessorMapping && model.enablePredecessorValidation && proxy._updatedRecordsDateByPredecessor();
                proxy._calculateScheduleDates();
                proxy._calculateHeaderDates();
                proxy._updateGanttRecords();
                proxy._checkDataManagerUpdate();
                proxy._renderTreeGrid();
                model.updatedRecords = proxy.getUpdatedRecords();
                model.currentViewData = proxy.getCurrentViewData();
                proxy._renderGanttChart();
                proxy._enableCreateCollection = true;
                proxy._isValidationEnabled = false;          //no validation require here
                proxy._isLoad = false,
                model.predecessorMapping && proxy._createConnectorLinesCollection();//connectorline oboject creates here
                proxy._isValidationEnabled = true;//reassign this value
                proxy._$treegridPane.css({ 'overflow': 'hidden' });
                //Dialog templates Rendering initiated
                proxy._initiateDialogTemplates();
                proxy._isTreeGridRendered = true;
                proxy._isGanttChartRendered = true;
                proxy._gridRows = proxy.getRows();
                proxy._ganttChartRows = proxy.getGanttChartRows();
                proxy._createContextMenuTemplate();
                proxy._wireEvents();
                proxy._initialEndRendering();
                proxy._getLocalizedLabels();
            }
        },

        _getLocalizedLabels:function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },

        //apply row Selection and enable collapse all while loading
        _initialEndRendering:function()
        {
            var proxy = this,
                model = this.model;

            //Call collapse All
            if (model.enableCollapseAll) {
                if (this.selectedRowIndex() != -1) {
                    proxy._deSelectRowItem();
                }
                proxy._collapseAll();
            }           
            else if (model.expandStateMapping) {
                proxy._collapseRecordOnLoad();
            }

            //Select item by selected row index
            if (proxy.selectedRowIndex() >= 0 && proxy.selectedRowIndex() < proxy.model.updatedRecords.length && model.selectionMode == "row") {
                var rowSelectingArgs = {};
                rowSelectingArgs.recordIndex = proxy.selectedRowIndex();
                rowSelectingArgs.previousIndex = model.selectedItem ? model.updatedRecords.indexOf(model.selectedItem) : -1;
                if (proxy.rowSelecting(rowSelectingArgs)) {
                    proxy.selectRows(proxy.selectedRowIndex());
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                }
            }  
        },

        //Check if data manager is updatable
        _checkDataManagerUpdate: function ()
        {
            var proxy = this,
                dataSource =this.dataSource();
            proxy._isDataManagerUpdate = false;
            proxy._jsonData = null;

            if (dataSource instanceof ej.DataManager) {
                if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = dataSource.dataSource.json;
                }
                else if (!dataSource.dataSource.offline) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = proxy._retrivedData;
                }
            }
        },
        //Render add,edit dialog templates
        _initiateDialogTemplates:function()
        {
            var proxy = this, model = this.model;

            proxy.customColumnFields();
            if (model.editSettings.allowEditing || model.editSettings.editMode == "normal" || model.editSettings.editMode == "dialogTemplate") {
                proxy.editDialogTemplate();
                if ($("#" + this._id + "_dialogEdit").length === 0)
                    proxy.element.append(proxy._renderDialog());
            }
            if (model.editSettings.allowAdding) {
                proxy.addDialogTemplate();
                if ($("#" + this._id + "_dialogAdd").length === 0) {
                    var $dialog = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none", "overflow-x": "hidden" }, { id: this._id + "_dialogAdd" });
                    proxy.element.append($dialog);
                }
            }
        },

        //Toolbar,Gantt and treegrid parts are rendered and templates for add and edit dialog are created
        _render: function () {
            var proxy = this, element = proxy.element, model = proxy.model;
            if (proxy.model.toolbarSettings.showToolbar) {
                element.append(proxy._renderToolBar());
            }
            proxy._ganttHeight = parseInt(proxy._ganttHeight) - proxy._getToolBarHeight() - proxy._totalBorderHeight;
            proxy._$treegrid = ej.buildTag("div.ejTreeGrid#ejTreeGrid" + proxy._id, "", { "height": proxy._ganttHeight }, {});
            proxy._$ganttchart = ej.buildTag("div.ejGanttChart#ejGanttChart" + proxy._id, "", { "height": proxy._ganttHeight }, {});
            proxy._$ganttchartPane.append(proxy._$ganttchart);
            proxy._$treegridPane.append(proxy._$treegrid);
            proxy._$ejGantt.append(proxy._$treegridPane);
            proxy._$ejGantt.append(proxy._$ganttchartPane);    
            
            element.append(proxy._$ejGantt);
            proxy._renderGantt();
        },

        //Return dialog tag
        _renderDialog: function () {
            var $dialog = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none", "overflow-x":"hidden" }, { id: this._id + "_dialogEdit" });
            return $dialog;
        },
        //Create Template for edit dialog
        editDialogTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = $.extend([], proxy._columns),
                length = columns.length,
                emptyDataColumns = [], column, predecessorColoumnIndex = -1, resourceColumnIndex = -1,
                treeGridObj = proxy._$treegridHelper.data("ejTreeGrid"),
                columnIndex,
                dialogTab = proxy._dialogTab,
                tabLength = dialogTab.length;
            proxy._editDialogGeneralColumns = [];
            proxy._editDialogCustomColumns = [];            
            proxy._generalTabColumnFields = ["taskId", "taskMode", "taskName", "startDate", "endDate", "duration", "resourceInfo", "status", "work", "taskType", "effortDriven", "baselineStartDate", "baselineEndDate", "predecessor", "WBS", "notesText"];
            proxy._mappingItems = proxy._getMappingItems();

            if (length == 0)
                return;

            if (model.editDialogFields.length > 0) {
                var filteredColumns = [];
                var count = 0, resultColumn;
                for (; count < model.editDialogFields.length; count++) {
                    resultColumn = $.grep(proxy._columns, function (val) {
                        return val.mappingName === model.editDialogFields[count].field;
                    });
                    resultColumn.length && filteredColumns.push(resultColumn[0]);
                }
                columns = filteredColumns;                
            }
            else {
                //To hide the WBS predecessor field
                if (model.enableWBS) {
                    var finalColumns;
                    if (model.enableWBSPredecessor) {
                        finalColumns = columns.filter(function (col) {
                            return col.mappingName != "WBSPredecessor";
                        });
                    }
                    if (finalColumns && finalColumns.length)
                        columns = finalColumns;
                }
            }
            var index = $.map(columns, function (column, index) {
                if (column.mappingName == model.taskNameMapping) {
                    return index;
                }
            });
            if ((index[0] + 1) % 3 == 0) {
                columns.splice(index[0] - 1, 0, columns.splice(index[0], 1)[0]);
            }
            length = columns.length;
            for (var i = 0; i < length; i++) {
                if ($.inArray(columns[i].mappingName, proxy._mappingItems) != -1) {
                    if (!model.resourceInfoMapping && (columns[i].field == "work" || columns[i].field == "taskType" || columns[i].field == "effortDriven"))
                        continue;
                    if (columns[i].mappingName !== model.predecessorMapping && columns[i].mappingName != model.resourceInfoMapping && columns[i].mappingName != model.notesMapping) {
                        var index = $.map(proxy._generalTabColumnFields, function (field, index) {
                            if (field == columns[i].field) {
                                return index;
                            }
                        });
                        if (index.length > 0) {
                            proxy._editDialogGeneralColumns.push(columns[i]);
                        }
                        else {
                            proxy._editDialogCustomColumns.push(columns[i]);
                        }
                    }
                    else {
                        if (columns[i].mappingName !== model.baselineStartDateMapping && columns[i].mappingName !== model.baselineEndDateMapping) {
                            if (columns[i].mappingName !== model.predecessorMapping)
                                resourceColumnIndex = i;
                            else
                                predecessorColoumnIndex = i;
                        }
                    }
                }
            }
            var $tbody = ej.buildTag('div', "", {}, {}),
                $tab = ej.buildTag('div', "", {}, { id: proxy._id + "EditTab" }),
                $ul = ej.buildTag('ul', "", {}, {}),
                $inTr, $inTd, $inTr2, $inTd2, $preDiv;
            $tab.append($ul);
            $tbody.append($tab);
            for (var tabIndex = 0; tabIndex < tabLength; tabIndex++) {
                switch (dialogTab[tabIndex]) {
                    //General Tab
                    case "General":
                        $ul.append("<li><a href='#" + proxy._id + "EditGeneral'>" + proxy._dialogTabTitleTexts["generalTabText"] + "</a></li>");
                        var $general = ej.buildTag('div.e-gantt-editor-container', "", {}, { id: proxy._id + "EditGeneral" }),
                            $genearlForm = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "GeneralEditForm" });
                        $general.append($genearlForm);
                        $tab.append($general);
                       // var $form = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "EditForm" });
                        var $genearlTable = ej.buildTag('table.e-general-edit-div', "", { "border-spacing": "2px", "border-collapse": "separate" }, {}),
                        $tr = ej.buildTag('tr'), $td;
                        var columnCount = 0,
                            generalColumns = proxy._editDialogGeneralColumns,
                            length = generalColumns.length;
                        for (var i = 0; i < length; i++) {
                            if (columnCount < 3) {
                                if (generalColumns[i].mappingName !== model.taskNameMapping) {
                                    columnCount++;
                                    $td = ej.buildTag('td.e-property-container', "", {}, {});
                                }
                                else {
                                    columnCount += 2;
                                    $td = ej.buildTag('td.e-property-container', "", {}, { "colspan": "2" });
                                }
                                var $innerTable = ej.buildTag('table', "", { "outline": "none", "border-spacing": "2px", "border-collapse": "separate" }, {});
                                $inTr = ej.buildTag('tr', "", { "line-height": "1.4" }, {});
                                $inTd = ej.buildTag('td.editLabel', "", {}, {});
                                $inTd.append("<label for='" + generalColumns[i].field + "'>" + proxy._columnHeaderTexts[generalColumns[i].field] + "</label>");
                                $inTr.append($inTd);
                                $innerTable.append($inTr);
                                $inTr2 = ej.buildTag('tr');
                                $inTd2 = ej.buildTag('td.e-editValue', "", {}, {});
                                columnIndex = proxy._columns.indexOf(generalColumns[i]);
                                ej.TreeGrid._initCellEditType(treeGridObj, $inTd2, proxy._id, columnIndex, "Edit");
                                $inTr2.append($inTd2);
                                $innerTable.append($inTr2);
                                $td.append($innerTable);
                                $tr.append($td);
                            }
                            else {
                                $genearlTable.append($tr);
                                $tr = ej.buildTag('tr');
                                i--;
                                columnCount = 0;
                            }
                        }
                        $genearlTable.append($tr);
                        $genearlForm.append($genearlTable);
                        break;
                    case "Predecessors":
                        //Predecessor Tab
                        if (model.predecessorMapping && predecessorColoumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "EditPredecessors'>" + proxy._dialogTabTitleTexts["predecessorsTabText"] + "</a></li>");
                            var $predecessor = ej.buildTag('div.e-gantt-predecessor-container', "", {}, { id: proxy._id + "EditPredecessors" }),
                                $predecessorForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "PredecessorEditForm" });
                            $predecessor.append($predecessorForm);
                            $tab.append($predecessor);
                            var $predecessorTable = ej.buildTag('table#' + proxy._id + 'predecessoreditTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px" , "top":"2px"}, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, "");
                            $inTd = ej.buildTag('td.editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "EditDialog_PredecesorAdd' class='e-addpre e-icon e-enable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "EditDialog_PredecesorDelete' class='e-deletepre e-icon e-disable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $predecessorTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "predecessorEdit", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $predecessorTable.append($inTr2);
                            $predecessorForm.append($predecessorTable);
                        }
                        break;
                    case "Resources":
                        // Resource tab
                        if (model.resourceInfoMapping && resourceColumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "EditResources'>" + proxy._dialogTabTitleTexts["resourcesTabText"] + "</a></li>");
                            var $resource = ej.buildTag('div.e-gantt-resource-container', "", {}, { id: proxy._id + "EditResources" }),
                                $resourceForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "ResourceEditForm" });
                            $resource.append($resourceForm);
                            $tab.append($resource);
                            var $resourceTable = ej.buildTag('table#' + proxy._id + 'resourceeditTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "2px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, {});
                            $inTd = ej.buildTag('td.editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "EditDialog_ResourceAdd' class='e-addpre e-icon e-enable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "EditDialog_ResourceDelete' class='e-deletepre e-icon e-disable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $resourceTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "resourceEdit", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $resourceTable.append($inTr2);
                            $resourceForm.append($resourceTable);
                        }
                        break;
                    case "Custom Fields":
                        // Custom Field Tab
                        if (proxy._editDialogCustomColumns.length > 0) {
                            $ul.append("<li><a href='#" + proxy._id + "EditCustomFields'>" + proxy._dialogTabTitleTexts["customFieldsTabText"] + "</a></li>");
                            var $customField = ej.buildTag('div.e-gantt-csfield-container', "", {}, { id: proxy._id + "EditCustomFields" }),
                                $customFieldForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "CustomFieldsEditForm" });
                            $customField.append($customFieldForm);
                            $tab.append($customField);
                            var $customFieldTable = ej.buildTag('table#' + proxy._id + 'customFieldeditTable', "", { "width": "100%", "outline": "none", "position": "relative", "left": "-2px", "top": "4px", "border-collapse": "collapse" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse" }, "");
                            $inTd = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "customFieldEdit", "", {}, {});
                            $inTd.append($preDiv);
                            $inTr.append($inTd);
                            $customFieldTable.append($inTr);
                            $customFieldForm.append($customFieldTable);
                        }
                        break;
                    case "Notes":
                        //Notes Tab
                        var editDialogFields = model.editDialogFields,
                            length = editDialogFields.length,
                            index = $.map(editDialogFields, function (dialogField, index) {
                                if (dialogField.field == model.notesMapping) {
                                    return index;
                                }
                            });
                        if ((model.notesMapping && length == 0) || (length > 0 && index.length > 0)) {
                            $ul.append("<li><a href='#" + proxy._id + "EditNotes'>" + proxy._dialogTabTitleTexts["notesTabText"] + "</a></li>");
                            var $notes = ej.buildTag('div.e-gantt-notes-container', "", {}, { id: proxy._id + "EditNotes" }),
                                $notesDiv = ej.buildTag('div', "", { "padding": "0px", "position": "relative", "top": "5px", "left": "-1px" }, {}),
                                $noteTextArea = ej.buildTag('textarea', "", {}, { id: proxy._id + "EditAreaNotes" });
                            $notesDiv.append($noteTextArea);
                            $notes.append($notesDiv);
                            $tab.append($notes);
                        }
                        break;
                }
            }
            $tbody = proxy.renderDiaglogButton("edit", $tbody);
            $.templates(proxy._id + "_JSONDialogEditingTemplate", $tbody.html());
        },
        //create template for add dialog
        addDialogTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = $.extend([], proxy._columns),
                length = columns.length,
                emptyDataColumns = [], column, predecessorColoumnIndex = -1, resourceColumnIndex = -1,
                treeGridObj = proxy._$treegridHelper.data("ejTreeGrid"),
                columnIndex,
                dialogTab = proxy._dialogTab,
                tabLength = dialogTab.length;
            proxy._addDialogGeneralColumns = [];
            proxy._addDialogCustomColumns = [];            
            proxy._generalTabColumnFields = ["taskId", "taskMode", "taskName", "startDate", "endDate", "duration", "resourceInfo", "status", "work", "taskType", "effortDriven", "baselineStartDate", "baselineEndDate", "predecessor", "WBS", "notesText"];
            proxy._mappingItems = proxy._getMappingItems();

            if (length == 0)
                return;

            if (model.addDialogFields.length > 0) {
                var filteredColumns = [];
                var count = 0, resultColumn;
                for (; count < model.addDialogFields.length; count++) {
                    resultColumn = $.grep(proxy._columns, function (val) {
                        return val.mappingName === model.addDialogFields[count].field;
                    });
                    resultColumn.length && filteredColumns.push(resultColumn[0]);
                }
                columns = filteredColumns;
            }
            else {
                //To hide the WBS predecessor field
                if (model.enableWBS) {
                    var finalColumns;
                    if (model.enableWBSPredecessor) {
                        finalColumns = columns.filter(function (col) {
                            return col.mappingName != "WBSPredecessor";
                        });
                    }
                    if (finalColumns && finalColumns.length)
                        columns = finalColumns;
                }
            }
            var index = $.map(columns, function (column, index) {
                if (column.mappingName == model.taskNameMapping) {
                    return index;
                }
            });
            if ((index[0] + 1) % 3 == 0) {
                columns.splice(index[0] - 1, 0, columns.splice(index[0], 1)[0]);
            }
            var $tbody = ej.buildTag('div', "", {}, {}),
                $tab = ej.buildTag('div', "", {}, { id: proxy._id + "AddTab" }),
                $ul = ej.buildTag('ul', "", {}, {}),
                $inTr, $inTd, $inTr2, $inTd2, $preDiv;
            $tab.append($ul);
            $tbody.append($tab);
            length = columns.length;
            for (var i = 0; i < length; i++) {
                if ($.inArray(columns[i].mappingName, proxy._mappingItems) != -1) {
                    if ((!columns[i].mappingName && columns[i].field == "work") || columns[i].field == "taskType" || columns[i].field == "effortDriven")
                        continue;
                    if (columns[i].mappingName !== model.predecessorMapping && columns[i].mappingName != model.resourceInfoMapping && columns[i].mappingName != model.notesMapping) {
                        var index = $.map(proxy._generalTabColumnFields, function (field, index) {
                            if (field == columns[i].field) {
                                return index;
                            }
                        });
                        if (index.length > 0) {
                            proxy._addDialogGeneralColumns.push(columns[i]);
                        }
                        else {
                            proxy._addDialogCustomColumns.push(columns[i]);
                        }
                    }
                    else {
                        if (columns[i].mappingName === model.predecessorMapping)
                            predecessorColoumnIndex = i;
                        else if (columns[i].mappingName === model.resourceInfoMapping)
                            resourceColumnIndex = i;
                    }
                }
            }
            for (var tabIndex = 0; tabIndex < tabLength; tabIndex++) {
                switch (dialogTab[tabIndex]) {
                    // General Tab
                    case "General":
                        $ul.append("<li><a href='#" + proxy._id + "AddGeneral'>" + proxy._dialogTabTitleTexts["generalTabText"] + "</a></li>");
                        var $general = ej.buildTag('div.e-gantt-editor-container', "", {}, { id: proxy._id + "AddGeneral" }),
                            $genearlForm = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "GeneralAddForm" });
                        $general.append($genearlForm);
                        $tab.append($general);
                        //$form = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "AddForm" });
                        var $genearlTable = ej.buildTag('table.e-general-edit-div', "", { "border-spacing": "2px", "border-collapse": "separate" }, {}),
                        $tr = ej.buildTag('tr'), $td;
                        var columnCount = 0,
                            generalColumns = proxy._addDialogGeneralColumns,
                            length = generalColumns.length;
                        for (var i = 0; i < length; i++) {
                            if (columnCount < 3) {
                                if (generalColumns[i].mappingName !== model.taskNameMapping) {
                                    columnCount++;
                                    $td = ej.buildTag('td.e-property-container', "", {}, {});
                                }
                                else {
                                    columnCount += 2;
                                    $td = ej.buildTag('td.e-property-container', "", {}, { "colspan": "2" });
                                }
                                var $innerTable = ej.buildTag('table', "", { "outline": "none", "border-spacing": "2px", "border-collapse": "separate" }, {});
                                $inTr = ej.buildTag('tr', "", { "line-height": "1.4" }, {});
                                $inTd = ej.buildTag('td.editLabel', "", {}, {});
                                $inTd.append("<label for='" + generalColumns[i].field + "'>" + proxy._columnHeaderTexts[generalColumns[i].field] + "</label>");
                                $inTr.append($inTd);
                                $innerTable.append($inTr);
                                $inTr2 = ej.buildTag('tr');
                                $inTd2 = ej.buildTag('td.e-editValue', "", {}, {});
                                columnIndex = proxy._columns.indexOf(generalColumns[i]);
                                ej.TreeGrid._initCellEditType(treeGridObj, $inTd2, proxy._id, columnIndex, "Add");
                                $inTr2.append($inTd2);
                                $innerTable.append($inTr2);
                                $td.append($innerTable);
                                $tr.append($td);
                            }
                            else {
                                $genearlTable.append($tr);
                                $tr = ej.buildTag('tr');
                                i--;
                                columnCount = 0;
                            }
                        }
                        $genearlTable.append($tr);
                        $genearlForm.append($genearlTable);
                        break;
                    case "Predecessors":
                        //Predecessor Tab
                        if (model.predecessorMapping && predecessorColoumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "AddPredecessors'>" + proxy._dialogTabTitleTexts["predecessorsTabText"] + "</a></li>");
                            var $predecessor = ej.buildTag('div.e-gantt-predecessor-container', "", {}, { id: proxy._id + "AddPredecessors" }),
                                $predecessorForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "PredecessorAddForm" });
                            $predecessor.append($predecessorForm);
                            $tab.append($predecessor);
                            var $predecessorTable = ej.buildTag('table#' + proxy._id + 'predecessoraddTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "2px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, {});
                            $inTd = ej.buildTag('td.editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "AddDialog_PredecesorAdd' class='e-addpre e-icon e-enable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "AddDialog_PredecesorDelete' class='e-deletepre e-icon e-disable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $predecessorTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "predecessorAdd", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $predecessorTable.append($inTr2);
                            $predecessorForm.append($predecessorTable);
                        }
                        break;
                    case "Resources":
                        // Resource tab
                        if (model.resourceInfoMapping && resourceColumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "AddResources'>" + proxy._dialogTabTitleTexts["resourcesTabText"] + "</a></li>");
                            var $resource = ej.buildTag('div.e-gantt-resource-container', "", {}, { id: proxy._id + "AddResources" }),
                                $resourceForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "ResourceAddForm" });
                            $resource.append($resourceForm);
                            $tab.append($resource);
                            var $resourceTable = ej.buildTag('table#' + proxy._id + 'resourceaddTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "2px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, {});
                            $inTd = ej.buildTag('td.editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "AddDialog_ResourceAdd' class='e-addpre e-icon e-enable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "AddDialog_ResourceDelete' class='e-deletepre e-icon e-disable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $resourceTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "resourceAdd", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $resourceTable.append($inTr2);
                            $resourceForm.append($resourceTable);
                        }
                        break;
                    case "Custom Fields":
                        // Custom Field Tab
                        if (proxy._addDialogCustomColumns.length > 0) {
                            $ul.append("<li><a href='#" + proxy._id + "AddCustomFields'>" + proxy._dialogTabTitleTexts["customFieldsTabText"] + "</a></li>");
                            var $customField = ej.buildTag('div.e-gantt-csfield-container', "", {}, { id: proxy._id + "AddCustomFields" }),
                                $customFieldForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "CustomfFieldsAddForm" });
                            $customField.append($customFieldForm);
                            $tab.append($customField);
                            var $customFieldTable = ej.buildTag('table#' + proxy._id + 'customfieldaddTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "4px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "customFieldAdd", "", {}, {});
                            $inTd.append($preDiv);
                            $inTr.append($inTd);
                            $customFieldTable.append($inTr);
                            $customFieldForm.append($customFieldTable);
                        }
                        break;
                    case "Notes":
                        //Notes Tab
                        var addDialogFields = model.addDialogFields,
                            length = addDialogFields.length,
                            index = $.map(addDialogFields, function (dialogField, index) {
                                if (dialogField.field == model.notesMapping) {
                                    return index;
                                }
                            });
                        if (model.notesMapping && (length == 0) || (length > 0 && index.length > 0)) {
                            $ul.append("<li><a href='#" + proxy._id + "AddNotes'>" + proxy._dialogTabTitleTexts["notesTabText"] + "</a></li>");
                            var $notes = ej.buildTag('div.e-gantt-notes-container', "", {}, { id: proxy._id + "AddNotes" }),
                                $notesDiv = ej.buildTag('div', "", { "padding": "0px", "position": "relative", "top": "5px", "left": "-1px" }, {}),
                                $noteTextArea = ej.buildTag('textarea', "", {}, { id: proxy._id + "AddAreaNotes" });
                            $notesDiv.append($noteTextArea);
                            $notes.append($notesDiv);
                            $tab.append($notes);
                        }
                        break;
                }
            }

            $tbody = proxy.renderDiaglogButton("add", $tbody);
            $.templates(proxy._id + "_JSONDialogAddingTemplate", $tbody.html());
        },
        //remove contextmenu from DOM
        _clearContextMenu: function () {
            //variables for context menu items
         
            $('.e-contextmenu').remove();
            $('.e-innerContextmenu').remove();
        },

        //JSRender Template for ContextMenu
        _createContextMenuTemplate: function () {
            var proxy = this;
            var helpers = {};
            helpers["_" + proxy._id + "getHeaderName"] = $.proxy(proxy._getHeaderName, proxy);

            $.views.helpers(helpers);
            var menuItemList = "<li style='list-style-type:none;margin:0px;'>";
            var listChild = "<div class='e-menuitem{{if disable}} e-disable{{/if}}{{if ~_" + proxy._id + "getHeaderName(#data)}} e-parent-menuitem{{/if}}' id={{:menuId}}  style='display:table;cursor:pointer;min-width:100px;'>" +
                            "{{if iconPath}}" +
                            "<div class='e-icon e-contextmenu-image'" +
                            " style='background-image:{{:iconPath}};background-repeat:no-repeat;'/>" +
                             "{{else}}" +
                            "<div class='e-icon {{:iconClass}} e-contextmenu-icon'/>" +
                            "{{/if}}" +
                            "<div class='e-contextmenu-label'>" +
                            "<span>{{:headerText}}</span></div>" +
                            "{{if ~_" + proxy._id + "getHeaderName(#data)}}<div class='e-icon e-expander e-contextmenu-icon'/> {{/if}}";

            menuItemList += listChild;
            menuItemList += "</div></li>";
            var templates = {};
            templates[proxy._id + "contextMenuTemplate"] = menuItemList;
            $.templates(templates);
        },

        //helper methods for context menu template
        _getHeaderName: function (data) {
            var childMenuItems = this._contextMenuItems.filter(function (value) {
                if (data.menuId != null && data.menuId == value.parentMenuId)
                    return true;
            });
            if (childMenuItems.length > 0) {
                return true;
            }
            return false;
        },

        //create templates for all columns edit types
        initCellEditType: function (column, element,editTarget) {

            var proxy = this,
                model = proxy.model,
                id,    
                helpers = {};
            id = editTarget ? editTarget : "";
            if (ej.isNullOrUndefined(column["editType"]))
                column["editType"] = "stringedit";

            switch (column["editType"]) {
                case "stringedit":
                    if (column.mappingName === model.predecessorMapping) {
                        helpers["_" + proxy._id + "predecessor"] = proxy._getPredecessorsValue;
                        $.views.helpers(helpers);
                        element.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{:~_" + proxy._id + "predecessor('" + proxy._id + "Object','" + model.predecessorMapping + "','" + column.field + "')}}", id: proxy._id + column.field, name: column.field }));
                    } else {
                        element.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, dialog: editTarget }));
                    }
                    break;
                case "booleanedit":
                    element.html('{{if ' + column.field + '}} <input class="e-field e-checkbox" type ="checkbox" id=' + proxy._id + column.field + ' name=' + column.field + ' checked="checked"></input>{{else}} <input class="e-field e-checkbox" type ="checkbox" id=' + proxy._id + column.field + ' name=' + column.field + ' > {{/if}}');
                    break;
                case "numericedit":
                    var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", {}, { type: "text", value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, dialog: editTarget });
                    element.append($numericText);
                    break;
                case "datepicker":
                case "datetimepicker":
                    var $datePicker = ej.buildTag('input.e-' + column["editType"] + ' e-field', "", {}, { type: "text", value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, dialog: editTarget });
                    element.append($datePicker);
                    break;
                case "dropdownedit":
                    var $dropDownList = ej.buildTag('input.e-field e-dropdownlist' + ' e-field', "", {}, { type: "text", value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, dialog: editTarget });
                    element.append($dropDownList);                    
                    break;
                case "maskedit":
                    var $maskEdit = ej.buildTag('input .e-field e-maskedit', "", {},
                                        {
                                            value: "{{:#data['" + column.field + "']}}",
                                            id: proxy._id + column.field + id,
                                            name: column.field,
                                            dialog: editTarget
                                        });
                    element.append($maskEdit);
                    break;
            }
        },

        //returns predecessor value
        _getPredecessorsValue: function (gridObject, mappingName) {
            return this.data.item ? this.data.item[mappingName] : "";
        },

        //reduce the date when date is fall on holidays
        _onHoliDayCheckBefore: function (startDate) {
            var proxy = this,
                holidays = proxy.model.holidays,
                includeWeekend = proxy.model.includeWeekend;


            if (isAutoSchedule && holidays && holidays.length) {
                var holidayIndex = 0,
                    holidayslength = holidays.length,
                    holiday, flag;
                    for (holidayIndex = 0; holidayIndex < holidayslength; holidayIndex++) {
                        holiday = proxy._getDateFromFormat(holidays[holidayIndex].day);
                        if (holiday.getTime() == startDate.getTime()) {
                            startDate.setDate(startDate.getDate() - 1);
                            if (this.model.includeWeekend === false) {
                                proxy._setBeforeWeekend(startDate);
                            }
                        }
                        else {
                            return startDate;
                        }
                    }
                    return startDate;
            }
            else {
                return startDate;
            }
        },
        //check date is on holidays
        _onHoliDayCheck: function (startDate)
        {
            var proxy = this,
                holidays = proxy.model.holidays,
                includeWeekend = proxy.model.includeWeekend;
                

            if (isAutoSchedule && holidays && holidays.length && !proxy.hasChildRecords) {
                var holidayIndex = 0,
                    holidayslength = holidays.length,
                    holiday, flag;

                    for (holidayIndex = 0; holidayIndex < holidayslength; holidayIndex++) {
                        holiday = proxy._getDateFromFormat(holidays[holidayIndex].day);
                        if (holiday.getTime()==startDate.getTime()) {
                            startDate.setDate(startDate.getDate() + 1);
                            if (this.model.includeWeekend === false) {
                                if (startDate.getDay() == 0) {
                                    startDate.setDate(startDate.getDate() + 1);
                                } else if (startDate.getDay() == 6) {
                                    startDate.setDate(startDate.getDate() + 2);
                                }
                            }
                        }
                        else
                        {
                            return startDate;
                        }
                    }
                    return startDate;
            }
            else
            {
                return startDate;
            }
        },
        /*get duration and duration unit value from given string*/
        _getDurationValues: function (val, isFromDialog) {
            var duration = 0,
                model = this.model,
                durationUnit = model.durationUnit, unitIndex;

            if (typeof val == "string") {
                var values = val.match(/(\d*\.*\d+|[A-z]+)/g);
                if (values && values.length <= 2) {
                    duration = parseFloat(values[0]);
                    durationUnit = values[1] ? values[1].toLowerCase() : "";
                    if (this._durationUnitEditText.minute.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Minute;
                    else if (this._durationUnitEditText.hour.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Hour;
                    else if (this._durationUnitEditText.day.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Day;
                    else
                        durationUnit = model.durationUnit;
                } 
            } else {
                duration = val;
                durationUnit = model.durationUnit;
            }

            if (isNaN(duration)) {
                duration = isFromDialog ? this._editedDialogRecord.duration : 0;
                durationUnit = isFromDialog ? this._editedDialogRecord.durationUnit : model.durationUnit;
            }
            var output = {};
            output.duration = duration;
            output.durationUnit = durationUnit;
            return output;
        },

        //calculate end date and duration on date change in edit dialog
        _editStartDateChange: function (element, args)
        {
            var proxy = this,
                id = proxy._id,
                model = proxy.model,
                targetId = element.attr("id"),
                holidays = this.model.holidays,
                dialog = element.attr("dialog"),
                selectedItem = model.selectionMode == "row" ? this.selectedItem() : model.updatedRecords[proxy._rowIndexOfLastSelectedCell],
                editedObj = this._editedDialogRecord,
                effortDriven = editedObj.effortDriven == "true" ? true : false,
                effortDrivenId, typeId, workId,
                startDateId, endDateId, durationId, baselineStartDateId, baselineEndDateId, durationVal, durationUnit;

            if (this._editedDialogRecord.isUpdatedFromDialog)
                return;
            this._editedDialogRecord.isUpdatedFromDialog = true;

            if (dialog === "Add") {
                startDateId = "#" + id + "startDateAdd";
                endDateId = "#" + id + "endDateAdd";
                durationId = "#" + id + "durationAdd";
                effortDrivenId = "#" + id + "effortDrivenAdd";
                typeId = "#" + id + "taskTypeAdd";
                workId = "#" + id + "workAdd";
                baselineStartDateId = "#" + id + "baselineStartDateAdd";
                baselineEndDateId = "#" + id + "baselineEndDateAdd";
            }
            else {
                startDateId = "#" + id + "startDateEdit";
                endDateId = "#" + id + "endDateEdit";
                durationId = "#" + id + "durationEdit";
                effortDrivenId = "#" + id + "effortDrivenEdit";
                typeId = "#" + id + "taskTypeEdit";
                workId = "#" + id + "workEdit";
            }
            var startDate = $(startDateId).val(),
                endDate = $(endDateId).val(),
                duration = $(durationId).val(),
                work = $(workId).val();
            if ((targetId === id + "startDateEdit") || (targetId === id + "startDateAdd"))
            if (!startDate) {
                startDate = editedObj ? editedObj.startDate : undefined;
            }
            if (!duration) {
                duration = editedObj ? editedObj.duration : undefined;
            }
            if (!endDate) {
                endDate = editedObj ? editedObj.endDate : undefined;
            }
            if ((targetId === id + "startDateEdit") || (targetId === id + "startDateAdd")){
                startDate = args.value ? proxy._getDateFromFormat(args.value) : startDate;
                startDate = proxy._checkStartDate(startDate, editedObj);
                if (proxy.getFormatedDate(startDate) != args.value) {


                    if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                        $(startDateId).ejDateTimePicker("option", "value", startDate);
                    else
                        $(startDateId).ejDatePicker("option", "value", startDate);
                }
                var tempEndDate = proxy._getEndDate(startDate, editedObj.duration, editedObj.durationUnit, editedObj);
                editedObj.startDate = startDate;
                editedObj.endDate = tempEndDate;
                if (model.dateFormat.indexOf("hh") != -1)
                    $(endDateId).ejDateTimePicker("option", "value", tempEndDate);
                else
                    $(endDateId).ejDatePicker("option", "value", tempEndDate);
            }

            else if((targetId=== id + "endDateEdit") ||(targetId===id + "endDateAdd")){
                endDate = args.value ? proxy._getDateFromFormat(args.value) : endDate;
                if (endDate.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, endDate);
                endDate = this._checkEndDate(endDate, editedObj);
                if (proxy.getFormatedDate(endDate) != args.value) {
                    if (model.dateFormat.indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", endDate);
                }

                if (editedObj.isMilestone) {
                    editedObj.startDate = this._checkStartDate(editedObj.startDate, editedObj);

                    if (proxy.getFormatedDate(editedObj.startDate) != startDate) {
                        if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                            $(startDateId).ejDateTimePicker("option", "value", editedObj.startDate);
                        else
                            $(startDateId).ejDatePicker("option", "value", editedObj.startDate);
                    }
                proxy._updateResourceRelatedFields(editedObj);
                $(workId).ejNumericTextbox("option", "value", editedObj.work);
                $(durationId).val(proxy._getDurationStringValue(editedObj));
                }
                if (editedObj.startDate.getTime() <= endDate.getTime()) {
                    editedObj.endDate = endDate;
                    editedObj.duration = this._getDuration(editedObj.startDate, endDate, editedObj.durationUnit, editedObj.isAutoSchedule);
                    duration = proxy._getDurationStringValue(editedObj);
                    $(durationId).val(duration);
                } else {

                    if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", editedObj.endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", editedObj.endDate);

                }
            }
              
            else if ((targetId === id + "durationEdit") || (targetId === id + "durationAdd")) {
                var values = proxy._getDurationValues(duration, true);
                durationVal = values.duration;
                durationUnit = values.durationUnit;
                if (editedObj.duration != durationVal || editedObj.durationUnit != durationUnit) {
                    //calculate end date and update it
                    editedObj.duration = durationVal;
                    editedObj.durationUnit = durationUnit;
                    if (editedObj.isMilestone) {
                        if (editedObj.duration > 0)
                            editedObj.isMilestone = false;
                        else
                            editedObj.isMilestone = true;
                        editedObj.startDate = this._checkStartDate(editedObj.startDate, editedObj);
                        if (proxy.getFormatedDate(editedObj.startDate) != startDate) {
                            if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                                $(startDateId).ejDateTimePicker("option", "value", editedObj.startDate);
                            else
                                $(startDateId).ejDatePicker("option", "value", editedObj.startDate);
                        }
                    }
                    endDate = this._getEndDate(editedObj.startDate, durationVal, durationUnit, editedObj);
                    editedObj.endDate = endDate;
                    if (model.dateFormat.indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", endDate);
                }
                proxy._updateResourceRelatedFields(editedObj);
                if (!effortDriven)
                    $(workId).ejNumericTextbox("option", "value", editedObj.work);
                $(durationId).val(proxy._getDurationStringValue(editedObj));
                if (editedObj.taskType == "fixedWork")
                    proxy._updateResourceDataSource(editedObj);                                   
            }
            else if ((targetId === id + "workEdit") || (targetId === id + "workAdd")) {
                editedObj.work = parseInt(work);
                proxy._updateResourceRelatedFields(editedObj);
                if (editedObj.taskType != "fixedDuration" && editedObj.isAutoSchedule) {                    
                    $(durationId).val(proxy._getDurationStringValue(editedObj));
                    endDate = this._getEndDate(editedObj.startDate, editedObj.duration, editedObj.durationUnit, editedObj);
                    editedObj.endDate = endDate;
                    if (model.dateFormat.indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", endDate);
                }
                else
                    proxy._updateResourceDataSource(editedObj);
            }
            else if (targetId === id + "baselineStartDateAdd") {
                if ($(baselineEndDateId).length > 0) {
                    var baselineStartDate = proxy._getDateFromFormat($(baselineStartDateId).val());
                    var baselineEndDate = proxy._getDateFromFormat($(baselineEndDateId).val());
                    if (baselineStartDate && baselineEndDate && baselineStartDate.getTime() > baselineEndDate.getTime()) {
                        if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                            $(baselineStartDateId).ejDateTimePicker("option", "value", args.prevDate);
                        else
                            $(baselineStartDateId).ejDatePicker("option", "value", args.prevDate);
                    }
                }

            } else if (targetId === id + "baselineEndDateAdd") {
                if ($(baselineStartDateId).length > 0) {
                    var baselineStartDate = proxy._getDateFromFormat($(baselineStartDateId).val());
                    var baselineEndDate = proxy._getDateFromFormat($(baselineEndDateId).val());
                    if (baselineStartDate && baselineEndDate && baselineStartDate.getTime() > baselineEndDate.getTime()) {
                        if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                            $(baselineEndDateId).ejDateTimePicker("option", "value", args.prevDate);
                        else
                            $(baselineEndDateId).ejDatePicker("option", "value", args.prevDate);
                    }
                }
            }
            this._editedDialogRecord.isUpdatedFromDialog = false;
        },

        //Create task name collection from records for edit dialog
        _taskNameCollection:function()
        {
            var proxy = this,
            records = proxy.model.flatRecords,
            names = [],
            idsCollection = [];
            proxy._preTableCollection = [];
            for(var i=0;i<records.length;i++)
            {
                var temp = { id: records[i].taskId.toString(), text: (records[i].taskId.toString() + "-" + records[i].taskName), value: (records[i].taskId.toString() + "-" + records[i].taskName)};
                var ids = { id: (records[i].taskId.toString() + "-" + records[i].taskName), text: records[i].taskId.toString(), value: records[i].taskId.toString() };
                names.push(temp);
                idsCollection.push(ids);
            }            
            proxy._preTableCollection.push(idsCollection);
            proxy._preTableCollection.push(names);
        },

        //get ID array from predecessor string
        _idFromPredecessor:function(pre)
        {
            var str = "123FS+2";
            var preArray = pre.split(',');
            var preIdArray = [];
           

            for (var j = 0; j < preArray.length; j++)
            {
                var strArray = [];
                for (var i = 0; i < preArray[j].length; i++) {
                    if (!isNaN(preArray[j].charAt(i))) {
                        strArray.push(preArray[j].charAt(i));
                    }
                    else {
                        break;
                    }
                }
                preIdArray.push((strArray.join('')));
            }
            return preIdArray;
        },

        //Change the id name while task name is selected in dialog
        _preIdChangByName:function()
        {
            var proxy = this,
                $form = $("#" + proxy._id + "PreEditForm"),
                $targetTr = $form.closest("tr"),
                $val = $form.find(".onEdit"),
                names = proxy._taskNameCollection();

            var id = $.map(names, function (obj, index) {
                if (obj.text === $val.val()) {
                    return obj.id;
                }
            });
            id = id[0];
            $targetTr.find(".id").html(id);
        },

        //handle end edit event in dialog box predecessor editing
        _preEndEdit:function(editDialogId,dialogType,args)
        {
            var proxy = this,
                dataSource = args.model.dataSource,
                selectedItem = args.model.selectedItem,
                tempId, id, curent;
            proxy._taskNameCollection();
            if (args.value !== null && (args.columnName === "name" || args.columnName === "id")) {
                if (args.columnName === "name" && args.value.length > 0) {
                    tempId = args.value.split('-');
                    id = $.map(proxy._preTableCollection[1], function (obj, index) {
                        if (obj.id === tempId[0]) {
                            return obj.id;
                        }
                    });
                    id = id[0];
                    selectedItem.id = id;
                    selectedItem.name = args.value;
                    curent = dataSource.indexOf(selectedItem.item);
                    if (curent === -1) {
                        dataSource.push(selectedItem.item);
                        curent = dataSource.indexOf(selectedItem.item);
                    }
                    dataSource[curent].id = id;
                    dataSource[curent].name = args.value;
                }
                if (args.columnName === "id" && args.value.length > 0) {

                    var name = $.map(proxy._preTableCollection[0], function (obj, index) {
                        if (obj.value === args.value) {
                            return obj.id;
                        }
                    });
                    name = name[0];
                    selectedItem.name = name;
                    selectedItem.id = id;
                    curent = dataSource.indexOf(selectedItem.item);
                    if (curent === -1) {
                        dataSource.push(selectedItem.item);
                        curent = dataSource.indexOf(selectedItem.item);
                    }
                    dataSource[curent].name = name;
                }

                if (!selectedItem.type && !ej.isNullOrUndefined(curent)) {
                    selectedItem.type = "Finish-Start";
                    dataSource[curent].type = "Finish-Start";
                }
                $(editDialogId).ejTreeGrid("refreshRow", args.model.selectedRowIndex);
                $(editDialogId).ejTreeGrid("selectRows", args.model.selectedRowIndex);
                proxy._enbleDisablePredecessorAddButton('enable', dialogType);
            }
        },
        //udapte the status of predecessor delete button in dialog
        _enableDisablePredecessorDelete: function (dialogType, args)
        {
            var proxy = this,
                predecessorDelete;
            if (dialogType == "add")
                predecessorDelete = $("#" + proxy._id + "AddDialog_PredecesorDelete");
            else
                predecessorDelete = $("#" + proxy._id + "EditDialog_PredecesorDelete");
            $(predecessorDelete).unbind("click", $.proxy(proxy._deletepredecessor, proxy)).bind("click", $.proxy(proxy._deletepredecessor, proxy));
            $(predecessorDelete).removeClass("e-disable").addClass("e-enable");
        },

        //udapte the status of resource delete button in dialog
        _enableDisableResouceDelete: function (dialogType,args) {
            var proxy = this, resourceDelete;
            if (dialogType == "add")
                resourceDelete = $("#" + proxy._id + "AddDialog_ResourceDelete");
            else
                resourceDelete = $("#" + proxy._id + "EditDialog_ResourceDelete");
            $(resourceDelete).unbind("click", $.proxy(proxy._deleteResource, proxy)).bind("click", $.proxy(proxy._deleteResource, proxy));
            $(resourceDelete).removeClass("e-disable").addClass("e-enable");
        },

        //prepare data source for dropdown in predecessor edit in dialog box
        _predecessorEditCollection:function(){
        
            var proxy = this,
               model = proxy.model,
               collection,
               gridId,
               types,
               data = [],
               selectedItem;
            gridId = "#" + proxy._id + "predecessor";            
            types = proxy._predecessorCollectionText;
            data = [];
            selectedItem = model.selectedItem;
            proxy._taskNameCollection();
            collection = proxy._preTableCollection[1];
            if (!ej.isNullOrUndefined(selectedItem) && !ej.isNullOrUndefined(selectedItem.predecessor) && !ej.isNullOrUndefined(selectedItem.item[model.predecessorMapping]))
            {
                var predecessor = selectedItem.predecessor,
                    predecessorLength = predecessor.length,
                    typeLength = types.length,
                    collectionLength = collection.length;
                for (var i = 0; i < predecessorLength; i++) {
                    var id = predecessor[i].from;
                    if (selectedItem.taskId.toString()!==id.toString())
                    {
                        var taskName, type, lags = 0;
                        for (var j = 0; j < collectionLength; j++) {
                            if (collection[j].id === id) {
                                taskName = collection[j].value;
                                break;
                            }
                        }
                        for (var k = 0; k < typeLength; k++) {
                            if (types[k].id == predecessor[i].predecessorsType) {
                                type = types[k].text;
                            }
                        }

                        var multiple = predecessor[i].offset != 1, val = "";
                        if (predecessor[i].offsetDurationUnit == "day")
                            val += multiple ? this._durationUnitTexts.days : this._durationUnitTexts.day;
                        else if (predecessor[i].offsetDurationUnit == "hour")
                            val += multiple ? this._durationUnitTexts.hours : this._durationUnitTexts.hour;
                        else
                            val += multiple ? this._durationUnitTexts.minutes : this._durationUnitTexts.minute;

                        lags = (predecessor[i].offset + " " + val);
                        var obj = { id: id, name: taskName, type: type, offset: lags };
                        data.push(obj);
                    }
                }
            }
            return data;
        },
        _getResourceInfoIndex: function (resourceIdcollection, resourcecollection) {

            var count = 0,
            resources = [];
            if (resourceIdcollection && resourcecollection) {
                for (count; count < resourceIdcollection.length; count++) {
                    if (resourcecollection[resourceIdcollection[count]])
                        resources.push(resourceIdcollection[count]);
                }
            }
            return resources;
        },
        //render control in diaog box as per template created
        _refreshEditForm: function (args) {
            var proxy = this,
                elementFocused = false,
                $formElement,
                percent = 86,
                i = 0, form, length,
                $element,
                inputWidth = "165px",
                model = proxy.model,
                width,
                params = {},
                value,
                column,
                customParams,
                toformat, newIdInstant,
                formatVal, editTreeGridId,
                selectedItem = model.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];

            if (args.requestType == "add") {
                var tab = document.getElementById(proxy._id + "AddTab"),
                    dialog = $("#" + proxy._id + "_dialogAdd_wrapper"),
                form = document.getElementById(proxy._id + "GeneralAddForm"),
                editTreeGridId = "#treegrid" + proxy._id + "predecessorAdd",
                noteRteId = "#" + proxy._id + "AddAreaNotes",
                resourceTreeGridId = "#treegrid" + proxy._id + "resourceAdd",
                customFieldTreeGridId = "#treegrid" + proxy._id + "customFieldAdd";
                if (!ej.isNullOrUndefined(model.dataSource) && model.dataSource.length == 0 && model.predecessorMapping && $(editTreeGridId).length > 0) {
                    var index = [];
                    index[0] = proxy._dialogTab.indexOf("Predecessors");
                    $("#" + proxy._id + "AddTab").ejTab("option", "disabledItemIndex", index);
                }
                else {
                    var index = [];
                    index[0] = proxy._dialogTab.indexOf("Predecessors");
                    $("#" + proxy._id + "AddTab").ejTab("option", "enabledItemIndex", index);
                    $("#" + proxy._id + "AddTab").find("div.e-content").css("overflow", "visible");
                }
                newIdInstant = proxy.model.flatRecords.length;
                newIdInstant = proxy._getNewTaskId(newIdInstant);
                if (proxy.model.enableWBS) {
                    var rowPos = model.editSettings.rowPosition.toLowerCase(),
                        newWBSval = proxy._getNewWBSid(rowPos);
                }
            }
            else {
                var tab = document.getElementById(proxy._id + "EditTab"),
                    dialog = $("#" + proxy._id + "_dialogEdit_wrapper"),
                    form = document.getElementById(proxy._id + "GeneralEditForm"),
                    editTreeGridId = "#treegrid" + proxy._id + "predecessorEdit",
                    noteRteId = "#" + proxy._id + "EditAreaNotes",
                    resourceTreeGridId = "#treegrid" + proxy._id + "resourceEdit",
                    customFieldTreeGridId = "#treegrid" + proxy._id + "customFieldEdit";
                if (model.flatRecords.length <= 2 && model.parentRecords.length == 1
                    && model.predecessorMapping && $(editTreeGridId).length > 0)
                    $("#" + proxy._id + "EditTab").ejTab("removeItem", 1);

            }
            $formElement = $(form).find("input,select");
            length = $formElement.length;
            for (i; i < length; i++) {
                $element = $formElement.eq(i);
                params = {};
                inputWidth = 180;
                column = ej.TreeGrid.getColumnByField(proxy._columns, $element.prop("name"));

                if (column)
                    value = args.data[column.field];
                else
                    continue;

                if ($element.hasClass("e-numerictextbox")) {

                    width = inputWidth;
                    params.width = width;
                    params.showSpinButton = true;
                    params.cssClass = model.cssClass;
                    //for parent editing 
                    var tempId = $element[0].id;
                    tempId = tempId.replace(proxy._id, '');
                    if (!ej.isNullOrUndefined(selectedItem) && selectedItem.hasChildRecords && (tempId == "statusEdit" ||tempId == "workEdit")) {
                        params.readOnly = true;
                        $element.closest("td").css("opacity", 0.5);
                    }
                    if (tempId == "statusEdit" || tempId == "statusAdd") {
                            params.maxValue = 100;
                            params.minValue = 0;
                        }
                        if (tempId == "workEdit") {
                            params.change = function (args) {
                                proxy._updatedColumn = "work";
                                proxy._editStartDateChange($(this.element[0]));
                            }
                        }
                    if (value && value.toString().length)
                            params.value = parseFloat(value);
                        else
                        params.value = 0;

                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);
                    $element.ejNumericTextbox(params);
                    $element.prop("name", $element.prop("name").replace(proxy._id, ""));
                }
                else if ($element.hasClass("e-datepicker")) {

                    params.width = inputWidth;
                    params.cssClass = model.cssClass;
                    params.dateFormat = model.dateFormat;
                    params.locale = model.locale;
                    params.startDay = model.scheduleHeaderSettings.weekStartDay;
                    params.change = function (args) {
                        this.option("value", args.value);
                        proxy._updatedColumn = this.element[0].name;
                        proxy._editStartDateChange(this.element, args);
                    };
                    var tempId = $element[0].id;
                    tempId = tempId.replace(proxy._id, '');
                    if (!ej.isNullOrUndefined(selectedItem) && selectedItem.hasChildRecords && selectedItem.isAutoSchedule && (tempId == "startDateEdit" || tempId == "endDateEdit") && args.requestType !== "add") {
                        params.readOnly = true;
                        $element.closest("td").css("opacity", 0.5);
                    }
                    if (value && value.toString().length)
                        params.value = proxy._getDateFromFormat(value.toString());
                    else
                        params.value = proxy._getDateFromFormat(model.scheduleStartDate);


                    if (column["format"] !== undefined && column.format.length > 0) {
                        toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                        formatVal = toformat.exec(column.format);
                        params.dateFormat = formatVal[2];
                        params.value = ej.format(new Date(params.value), params.dateFormat, params.locale);
                        $element.val(params.value);
                    }
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);

                    $element.ejDatePicker(params);
                }
                else if ($element.hasClass("e-datetimepicker")) {

                    params = {
                        width: inputWidth,
                        rtl: model.rtl,
                        locale: model.locale,
                            cssClass: model.css,
                            dateTimeFormat: model.dateFormat,
                            startDay : model.scheduleHeaderSettings.weekStartDay
                        };
                        params.change = function (args) {
                            proxy._updatedColumn = this.element[0].name;
                            this.option("value", args.value);
                            if (this._prevDateTimeVal)
                                proxy._editStartDateChange(this.element, args);
                        };
                        var tempId = $element[0].id;
                        tempId = tempId.replace(proxy._id, '');
                        if (!ej.isNullOrUndefined(selectedItem) && selectedItem.hasChildRecords && selectedItem.isAutoSchedule && selectedItem.isAutoSchedule && (tempId == "startDate" || tempId == "endDate") && args.requestType !== "add" ) {
                            params.readOnly = true;
                            $element.closest("td").css("opacity", 0.5);
                        }
                    if (value && value.toString().length)
                        params.value = proxy._getDateFromFormat(value.toString());
                        else
                        params.value = proxy._getDateFromFormat(model.scheduleStartDate);

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);
                        
                    $element.ejDateTimePicker(params);
                }
                else if ($element.hasClass("e-dropdownlist")) {

                    var dataSource = column.dropdownData;
                    if (column.field === "resourceInfo") {
                        $element.ejDropDownList({
                            cssClass: model.cssClass,
                            width: inputWidth,
                            showCheckbox: true,
                            dataSource: dataSource,
                            fields: { id: model.resourceIdMapping, text: model.resourceNameMapping, value: model.resourceNameMapping },
                                selectedItems: args.requestType == "add" ? proxy._getResourceInfoIndex(args.data.resourceInfo, model.resources) : proxy.getIndexofresourceInfo(dataSource, args.data)
                            });
                        }                       
                        else {
                            var controlArgs = {};
                            controlArgs.cssClass = model.cssClass;
                            controlArgs.width = inputWidth;
                            controlArgs.dataSource = dataSource;
                            controlArgs.value = value;
                            controlArgs.change = function (args) {
                                proxy._updateEditDialogFields(this);
                            };
                            if (!ej.isNullOrUndefined(column["editParams"]))
                                $.extend(controlArgs, column["editParams"]);
                            if ($element.val.length) {
                                if (column.field == "taskMode") {                                   
                                    var value = args.requestType == "beginedit" ? !args.data.isAutoSchedule : model.taskSchedulingMode == "manual" ? true : false;
                                    controlArgs.value = value.toString();
                                }
                                else if (column.field == "taskType") {
                                    controlArgs.value = args.requestType == "beginedit" ? args.data.taskType : proxy.model.taskType;                                    
                                }
                                else if (column.field == "effortDriven") {
                                    controlArgs.value = args.requestType == "beginedit" ? args.data.effortDriven : model.taskType == "fixedWork" ? true : false;                                   
                                }
                            }
                            if (args.requestType == "beginedit" && !args.data.isAutoSchedule && (column.field == "taskType" || column.field == "effortDriven"))
                                controlArgs.enabled = false;
                            if (args.data.taskType == "fixedWork" && column.field == "effortDriven")
                                controlArgs.enabled = false;
                            if (args.requestType == "add" && column.field == "effortDriven" && model.taskType == "fixedWork")
                                controlArgs.enabled = false;
                            if ((column.field == "taskType" || column.field == "effortDriven") && args.data.hasChildRecords)
                                controlArgs.enabled = false;
                            if (column.field == "taskMode" && model.taskSchedulingMode != ej.Gantt.TaskSchedulingMode.Custom)
                                controlArgs.enabled = false;
                            $element.val(controlArgs.value);
                            $element.ejDropDownList(controlArgs);

                            var obj = $element.ejDropDownList("instance");
                            obj._setValue($element.val());

                        }
                    }
                else if ($element.hasClass("e-maskedit")) {
                    var controlArgs = {};
                    controlArgs.locale = model.locale;
                    controlArgs.cssClass = model.cssClass;
                    controlArgs.width = inputWidth;
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(controlArgs, column["editParams"]);

                    $element.ejMaskEdit(controlArgs);
                }
                else {
                    switch ($element.prop('tagName')) {
                        case "INPUT":

                            if ($element.attr("type") != "checkbox") {
                                //For ID field id is read only

                                if ($element.attr("name") === "taskId") {
                                    if (args.requestType !== "add") {
                                        $element.attr("readonly", "readonly");
                                        $element.css("opacity", 0.5);
                                        $element.val(args.data.taskId);
                                    }
                                    else if (args.requestType === "add") {
                                        if (args.data.taskId == "" || ej.isNullOrUndefined(args.data.taskId))
                                            $element.val(newIdInstant);
                                        else
                                            $element.val(args.data.taskId);
                                    }
                                }
                                else if ($element.attr("name") === "taskName") {
                                    if (args.requestType === "add") {
                                        if (args.data.taskName == "" || ej.isNullOrUndefined(args.data.taskName))
                                            $element.val(proxy._newTaskTexts["newTaskName"] + " " + newIdInstant);
                                        else
                                            $element.val(args.data.taskName);
                                    }
                                    else
                                        $element.val(args.data.taskName);
                                }
                                else if ($element.attr("name") === "duration") {
                                    args.data && $element.val(proxy._getDurationStringValue(args.data));
                                    var durationValues = proxy._getDurationValues(args.data);
                                    if (args.requestType !== "add" && args.data.hasChildRecords && args.data.isAutoSchedule) {
                                        $element.attr("readonly", "readonly");
                                        $element.css("opacity", 0.5);
                                    } else if ((args.requestType == "add") && args.data.duration == "") {
                                        $element.val("0 " + proxy._durationUnitTexts[durationValues.durationUnit]);
                                    }
                                    else 
                                        $element.val(args.data.duration + " " + proxy._durationUnitTexts[durationValues.durationUnit]); 

                                        $element.change(function () {
                                            proxy._updatedColumn = "duration";
                                            proxy._editStartDateChange($(this));                                            
                                        });
                                        $element.keyup(function (e) {
                                            if (e.keyCode == 13)
                                            proxy._editStartDateChange($(this));
                                    });
                                }
                                else if ($element.attr("name") === "WBS") {
                                    if (args.requestType !== "add") {
                                        $element.attr("readonly", "readonly").css("opacity", 0.5);
                                        $element.val(args.data.WBS);
                                    }
                                    else if (args.requestType === "add") {
                                        $element.val(newWBSval);
                                        $element.attr("readonly", "readonly").css("opacity", 0.5);
                                    }
                                }
                                else if ($element.attr("name") === "WBSPredecessor")
                                    $element.attr("readonly", "readonly").css("opacity", 0.5);
                                if ($element.attr("name") === "taskName")
                                    inputWidth = 380;
                                var tempId = $element[0].id;
                                tempId = tempId.replace(proxy._id, '');

                                $element.css("text-align", $element.attr("name") != null && ej.TreeGrid.getColumnByField(proxy._columns, $element.prop("name")) != null ?
                                    ej.TreeGrid.getColumnByField(proxy._columns, $element.attr("name")).textAlign : "center");
                                $element.outerWidth(inputWidth);
                            } else {
                                var controlArgs = {};
                                controlArgs.cssClass = model.cssClass;
                                controlArgs.size = "medium";
                                if (!ej.isNullOrUndefined(column["editParams"]))
                                    $.extend(params, column["editParams"]);
                                $element.ejCheckBox(controlArgs);
                            }
                            break;

                        case "SELECT":
                            $element.width(inputWidth).height(23);
                            break;
                    }
                }
                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof $element.data("ejDropDownList") == "object")) {
                    if (!proxy._isEnterKeyPressed) {
                        proxy._focusElements($element.closest('td'));
                        elementFocused = true;
                    }
                }
            }
            //render prdecessor table in edit dialog
            if (model.predecessorMapping && $(editTreeGridId).length) {
                var ds = [];
                if (args.requestType !== "add") {
                    ds = proxy._predecessorEditCollection();
                }
                proxy._taskNameCollection();                
                var types = proxy._predecessorCollectionText;
                $(editTreeGridId).ejTreeGrid({
                    dataSource: ds,
                    allowSorting: false,
                    columns: [{ headerText: proxy._columnHeaderTexts["taskId"], field: "id", editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: proxy._preTableCollection[0], width: "89px" },
                              { headerText: proxy._columnHeaderTexts["taskName"], field: "name", editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: proxy._preTableCollection[1], width: "300px" },
                              { headerText: proxy._columnHeaderTexts["type"], field: "type", editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: types, width: "141px" },
                              { headerText: proxy._columnHeaderTexts["offset"], field: "offset", editType: ej.TreeGrid.EditingType.String, width: "88px" }],
                    enableAltRow: false,
                    allowColumnResize: true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                        rowPosition: "bottom",
                        beginEditAction: ej.TreeGrid.BeginEditAction.Click
                    },
                    locale: model.locale,
                    endEdit: $.proxy(proxy._preEndEdit, proxy, editTreeGridId, args.requestType),
                    beginEdit: $.proxy(proxy._preBeginEdit, proxy),
                    rowSelected: $.proxy(proxy._enableDisablePredecessorDelete, proxy, args.requestType),
                    actionComplete: function (eventArgs) {
                        if (eventArgs.requestType == "delete") {
                            proxy._enbleDisablePredecessorDeleteButton('disable', args.requestType);
                            proxy._disablePredecessorAddButton(editTreeGridId, args.requestType);
                        }
                    },
                    treeColumnIndex: 5,
                    predecessorTable: proxy._isFromGantt,
                    sizeSettings: { width: "620px", height: "198px" },
                    isResponsive: false,
                    cssClass: model.cssClass
                });

                if (model.selectedItem && model.selectedItem.hasChildRecords && args.requestType !== "add") {
                    proxy._enbleDisablePredecessorDeleteButton('disable', args.requestType);
                    proxy._enbleDisablePredecessorAddButton('disable', args.requestType);
                }
                else {
                    proxy._enbleDisablePredecessorDeleteButton('disable', args.requestType);
                    proxy._enbleDisablePredecessorAddButton('enable', args.requestType);
                }
            }

            //Render resource table in add and edit dialog
            if (model.resourceInfoMapping && $(resourceTreeGridId).length) {
                var resourceData = [],
                    resoruce = $.extend(true, [], model.resources);
                if (args.requestType != "add") {
                    var resource = args.data.resourceInfo,
                        length = resource ? resource.length : 0;
                    for (var i = 0; i < length; i++) {
                        resourceData.push({ "name": resource[i][model.resourceIdMapping], "unit": resource[i][model.resourceUnitMapping] });
                    }
                }
                else if (args.data.resourceInfo.length != 0) {
                    ganttRecord = new ej.Gantt.GanttRecord();
                    ganttRecord.item = args.data;
                    var resourceCollection = model.resources, resourceInfo = args.data.resourceInfo;
                    ganttRecord.resourceInfo = resourceInfo && ganttRecord._setResourceInfo(resourceInfo, model.resourceIdMapping, model.resourceNameMapping, model.resourceUnitMapping, resourceCollection);
                    var resource = ganttRecord.resourceInfo,
                        length = resource ? resource.length : 0;
                    for (var i = 0; i < length; i++) {
                        resourceData.push({ "name": resource[i][model.resourceIdMapping], "unit": resource[i][model.resourceUnitMapping] });
                    }
                }
                var resoruce = $.extend(true, [], model.resources);
                $(resourceTreeGridId).ejTreeGrid({
                    dataSource: resourceData,                    
                    columns: [{
                        headerText: proxy._columnHeaderTexts["resourceInfo"], field: "name", width: "309px",
                        editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: resoruce, editParams: { fields: { text: model.resourceNameMapping, value: model.resourceIdMapping } }
                    },
                              {
                                  headerText: proxy._columnHeaderTexts["unit"], field: "unit", width: "309px",
                                  editType: ej.TreeGrid.EditingType.Numeric, visible: true, headerTextAlign: "center"
                              }
                    ],
                    enableAltRow: false,
                    allowColumnResize: true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                        beginEditAction: ej.TreeGrid.BeginEditAction.Click
                    },
                    locale: model.locale,
                    endEdit: $.proxy(proxy._resourceEndEdit, proxy, resourceTreeGridId, args.requestType),
                    beginEdit: $.proxy(proxy._resourceBeginEdit, proxy, resourceTreeGridId),
                    rowSelected: $.proxy(proxy._enableDisableResouceDelete, proxy, args.requestType),
                    actionBegin: function (args) {
                        if (args.requestType == "delete" || args.requestType == "sorting")
                            this.model.columns[0].dropdownData = $.extend(true, [], proxy.model.resources);
                    },
                    actionComplete: function (eventArgs) {
                        if (eventArgs.requestType == "delete") {
                            proxy._enableDisableResourceAddButton(eventArgs, true, args.requestType);
                            proxy.enbleDisableDeleteResourceButton('disable', args.requestType);
                        }
                    },
                    treeColumnIndex: 3,
                    resourceTable: proxy._isFromGantt,
                    sizeSettings: { width: "620px", height: "198px" },
                    isResponsive: false,
                    cssClass: model.cssClass
                });
                if (args.requestType !== "add" && resourceData.length == model.resources.length) {
                    proxy.enbleDisableDeleteResourceButton('enable', args.requestType);
                    proxy.enbleDisableAddResourceButton('disable', args.requestType);
                }
                else {
                    proxy.enbleDisableDeleteResourceButton('disable', args.requestType);
                    proxy.enbleDisableAddResourceButton('enable', args.requestType);
                }
            }
            //Render custom field tab in add and edit dialog
            if ($(customFieldTreeGridId).length) {
                if (args.requestType == "add") {
                    var customColumns = proxy._addDialogCustomColumns,
                        gridData = [],
                        id = 0,
                        length = customColumns.length;
                    for (var i = 0; i < length; i++) {
                        id++;
                        var data = {};
                        data.id = id;
                        data.field = customColumns[i].field;
                        data.headerText = customColumns[i].headerText;
                        data.value = args.data[customColumns[i].field];
                        data.text = args.data[customColumns[i].field];
                        data.editType = customColumns[i].editType ? customColumns[i].editType.toLowerCase() : "stringedit";
                        gridData.push(data);
                    }
                }
                else {
                    var customColumns = proxy._editDialogCustomColumns,
                        gridData = [],
                        id = 0,
                        length = customColumns.length;
                    for (var i = 0; i < length; i++) {
                        id++;
                        var data = {};
                        data.id = id;
                        data.field = customColumns[i].field;
                        data.headerText = customColumns[i].headerText;
                        data.value = args.data[customColumns[i].field];

                        data.editType = customColumns[i].editType ? customColumns[i].editType.toLowerCase() : "stringedit";
                        if (customColumns[i].editType.toLowerCase() == "dropdownedit") {
                            data.text = ej.isNullOrUndefined(args.data[customColumns[i].field]) ? "" : proxy._getDropDownText(customColumns[i], args.data[customColumns[i].field]);
                        }
                        else
                            data.text = args.data[customColumns[i].field];
                        gridData.push(data);
                    }
                }
                $(customFieldTreeGridId).ejTreeGrid({
                    dataSource: gridData,
                    allowSorting: false,
                    locale: model.locale,
                    enableAltRow: false,
                    rowHeight:30,
                    columns: [{ headerText: proxy._columnHeaderTexts["dialogCustomFieldName"], field: "headerText", allowEditing: false },
                              { headerText: "Original Value", field: "value", visible: false },
                              { headerText: "Field", field: "field", visible: false },
                              {
                                  headerText: proxy._columnHeaderTexts["dialogCustomFieldValue"], field: "text",
                                  editTemplate: {
                                      create: function () {
                                          return "<input style='width:100%;'>";
                                      },
                                      read: $.proxy(proxy._customColumnRead, proxy, customFieldTreeGridId),
                                      write: $.proxy(proxy._customColumnWrite, proxy, customColumns, customFieldTreeGridId),
                                  }
                              }
                    ],
                    allowColumnResize: true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                        beginEditAction: ej.TreeGrid.BeginEditAction.Click
                    },
                    sizeSettings: { width: "620px", height: "234px" },
                    isResponsive: false,
                    cssClass: model.cssClass
                });
            }
            //Render the RTE control for notes tab.
            if (model.notesMapping && $(noteRteId).length) {
                var value;
                if (args.requestType == "add")
                    value = args.data.notes;
                else {
                    var htmlText = args.data.item[model.notesMapping];
                    value = htmlText;
                }
                $(noteRteId).ejRTE({
                    width: "620px", isResponsive: false, height: "281px", value: value,
                    locale: model.locale,
                    cssClass: model.cssClass,
                    tools: {
                        font: ["fontName", "fontSize", "fontColor", "backgroundColor"],
                        style: ["bold", "italic", "underline", "strikethrough"],
                        alignment: ["justifyLeft", "justifyCenter", "justifyRight", "justifyFull"],
                        doAction: ["undo", "redo"],
                        indenting: [],
                        clear: [],
                        links: ["createLink", "removeLink"],
                        images: [],
                        media: [],
                        tables: [],
                        lists: ["unorderedList"],
                        clipboard: [],
                        edit: [],
                        formatStyle: [],
                        view: []
                    }
                });
                $(noteRteId + "_wrapper").find(".e-toolbar.e-toolbarspan").css("border-bottom", "none"); // Remove the border bottom of rich text editor toolbar.
                $(noteRteId + "_editor").height("208");
                $(noteRteId + "_Iframe")[0].style.height = "203px";
                $(dialog).removeClass("e-rte");
            }
        },
        //updated the status of predecessor delelte button in dialog box
        _enbleDisablePredecessorDeleteButton: function (args, dialogType) {
            var proxy = this,
                 predecessorDelete;
            if (dialogType == "add")
                predecessorDelete = $("#" + proxy._id + "AddDialog_PredecesorDelete");
            else
                predecessorDelete = $("#" + proxy._id + "EditDialog_PredecesorDelete");
            if (args === "enable") {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deletepredecessor, proxy)).bind("click", $.proxy(proxy._deletepredecessor, proxy));
                $(predecessorDelete).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deletepredecessor, proxy));
                $(predecessorDelete).addClass('e-disable').removeClass('e-enable');
            }
        },

        //updated the status of predecessor button in dialog box
        _enbleDisablePredecessorAddButton: function (args, dialogType) {
            var proxy = this,
                predecessorAdd = "";
            if (dialogType == "add")
                predecessorAdd = $("#" + proxy._id + "AddDialog_PredecesorAdd");
            else
                predecessorAdd = $("#" + proxy._id + "EditDialog_PredecesorAdd");

            if (args === "enable") {
                $(predecessorAdd).unbind("click", $.proxy(proxy._addpredecessor, proxy)).bind("click", $.proxy(proxy._addpredecessor, proxy));
                $(predecessorAdd).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(predecessorAdd).unbind("click", $.proxy(proxy._addpredecessor, proxy));
                $(predecessorAdd).addClass('e-disable').removeClass('e-enable');
            }
        },

        //updated the status of predecessor button in dialog box
        _disablePredecessorAddButton: function (treeGridId, dialogType) {
            var proxy = this;
            var table = $(treeGridId + "e-table");
            var flag = false;
            var len = table[0].rows.length;
            proxy._enbleDisablePredecessorAddButton('disable', dialogType);
            for (var j = 0; j < len; j++) {
                var currentRow = table[0].rows[j];
                if (currentRow.cells.length === 4)
                    if (currentRow.cells[1].innerText === "") {
                        flag = true;
                    }
            }
            if (!flag) {
                proxy._enbleDisablePredecessorAddButton('enable', dialogType);
            }
        },

        //Dynamically update input elements fields in add/edit dialog box according with another fields change.
        _updateEditDialogFields: function (editObj) {
            var proxy = this,
                typeObj, effortDrivenObj,
                reuestType = $(editObj.element).attr("dialog");
            if (reuestType == "Add") {
                effortDrivenObj = $("#" + proxy._id + "effortDrivenAdd").data("ejDropDownList");
                typeObj = $("#" + proxy._id + "taskTypeAdd").data("ejDropDownList");
            }
            else {
                effortDrivenObj = $("#" + proxy._id + "effortDrivenEdit").data("ejDropDownList");
                typeObj = $("#" + proxy._id + "taskTypeEdit").data("ejDropDownList");
            }
            if (!ej.isNullOrUndefined(effortDrivenObj) && editObj._name == "taskType") {
                if (editObj.model.value == "fixedWork") {
                    effortDrivenObj.selectItemByValue("true");
                    effortDrivenObj.disable();
                }
                else
                    effortDrivenObj.enable();

                proxy._editedDialogRecord[editObj._name] = editObj.model.value;
            }
            if (editObj._name == "taskMode") {
                if (editObj.model.text == "Auto") {
                    if (!ej.isNullOrUndefined(effortDrivenObj) && !ej.isNullOrUndefined(typeObj) && typeObj.model.value != "fixedWork")
                        effortDrivenObj.enable();
                    if (!ej.isNullOrUndefined(typeObj))
                        typeObj.enable();
                    proxy._editedDialogRecord["isAutoSchedule"] = true;
                }
                if (editObj.model.text == "Manual") {
                    if (!ej.isNullOrUndefined(effortDrivenObj))
                        effortDrivenObj.disable();
                    if (!ej.isNullOrUndefined(typeObj))
                        typeObj.disable();
                    proxy._editedDialogRecord["isAutoSchedule"] = false;
                }
            }

        },

        _customColumnWrite: function (customColumns, gridId, args) {
            var proxy = this,
                value = args.rowdata !== undefined ? args.rowdata["text"] : "",
                gridModel = $(gridId).ejTreeGrid("instance").model,
                column = customColumns[gridModel.selectedRowIndex],
                editParams = {};
            if (column.editParams)
                editParams = $.extend(true, {}, column.editParams);
            editParams.value = value;
            editParams.locale = proxy.model.locale;
            switch (args.rowdata.editType.toLowerCase()) {

                case "numericedit":
                    editParams.height = "25px";
                    args.element.ejNumericTextbox(editParams);
                    break;
                case "stringedit":
                    $(args.element).val(value).css({ "padding": "0px", "border": "0px", "height": "25px" }).addClass("e-ejinputtext");
                    break;
                case "datepicker":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    editParams.startDay = proxy.model.scheduleHeaderSettings.weekStartDay;
                    args.element.ejDatePicker(editParams);
                    break;
                case "datetimepicker":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    editParams.startDay = proxy.model.scheduleHeaderSettings.weekStartDay;
                    args.element.ejDateTimePicker(editParams);
                    break;
                case "maskedit":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    args.element.ejMaskEdit(editParams);
                    break;
                case "dropdownedit":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    editParams.dataSource = column.dropdownData;
                    editParams.value = gridModel.currentViewData[gridModel.selectedRowIndex].value;
                    args.element.ejDropDownList(editParams);
                    break;
                case "booleanedit":
                    editParams.cssClass = proxy.model.cssClass;
                    editParams.size = "small";
                    editParams.checked = value;
                    args.element.ejCheckBox(editParams);
                    var parentElement = args.element.parent(".e-chkbox-wrap"),
                                formElement = parentElement.parent("form");

                    if (formElement.length > 0)
                        formElement.css("margin-left", "45%");
                    else
                        parentElement.css("margin-left", "45%");
                    break;
            }
        },

        _customColumnRead: function (gridId, args) {
            var value, text,
                treeGrid = $(gridId).ejTreeGrid("instance"),
                selectedRowIndex = treeGrid.model.selectedRowIndex,
                updatedRecords = treeGrid.model.updatedRecords;
            $(args).blur();
            $(args).focusout();
            if ($(args[0]).hasClass("e-numerictextbox"))
                value = text = $(args).ejNumericTextbox("getValue");
            else if ($(args[0]).hasClass("e-datepicker"))
                value = text = $(args).ejDatePicker("getValue");
            else if ($(args[0]).hasClass("e-datepicker"))
                value = text = $(args).ejDatePicker("getValue");
            else if ($(args[0]).hasClass("e-dattimeepicker"))
                value = text = $(args).ejDateTimePicker("getValue");
            else if ($(args[0]).hasClass("e-maskedit"))
                value = text = $(args[0]).ejMaskEdit("model.value");
            else if ($(args[0]).hasClass("e-dropdownlist")) {
                text = $(args[0]).ejDropDownList("model.text");
                value = $(args[0]).ejDropDownList("getSelectedValue");
            }
            else if ($(args[0]).hasClass("e-checkbox")) {
                value = text = $(args[0]).ejCheckBox('isChecked');
            }
            else
                value = text = $(args).val();
            updatedRecords[selectedRowIndex].value = value;
            updatedRecords[selectedRowIndex].text = text;
            treeGrid.refreshRow(selectedRowIndex);
            return text;
        },

        //updated the status of predecessor button in dialog box
        _enableDisableResourceAddButton: function (args,enableResourceAdd,dialogType) {
            var proxy = this,
                dataSource = args.model.dataSource,
                flag = false;
            proxy.enbleDisableAddResourceButton('disable', dialogType);
            if (enableResourceAdd) {
                var index = $.map(dataSource, function (data, index) {
                    if (data.name == "" || data.name == null) {
                        return index;
                    }
                });
                if (index.length > 0 && dataSource.length > 0)
                    flag = true;
                if (!flag) {
                    proxy.enbleDisableAddResourceButton('enable', dialogType);
                }
            }
        },
        //add empty row in predecessor grid in dialog box
        _addpredecessor: function (e) {
            var proxy = this,
                args = {}, treeGridId, grid,
                item = { id: "", name: "", type: "Finish-Start", offset: "0" }, dialogType;
            
            if ($(e.target).hasClass("e-edit-dialog")) {
                treeGridId = "#treegrid" + proxy._id + "predecessorEdit";
                dialogType = "edit";
            }
            else {
                treeGridId = "#treegrid" + proxy._id + "predecessorAdd";
                dialogType = "add";
            }
            proxy._enbleDisablePredecessorAddButton('disable', dialogType);
            grid = $(treeGridId).ejTreeGrid("instance");
            grid.addRow(item);
            grid.clearSelection(grid.model.selectedRowIndex);
            proxy._enbleDisablePredecessorDeleteButton('disable', dialogType);
        },
        //delete predecessor in dialog box 
        _deletepredecessor:function(e)
        {
            var proxy = this, treeGridId, dialogType;

            if ($(e.target).hasClass("e-edit-dialog")) {
                treeGridId = "#treegrid" + proxy._id + "predecessorEdit";
                dialogType = "edit";
            }
            else {
                treeGridId = "#treegrid" + proxy._id + "predecessorAdd";
                dialogType = "add";
            }

            var selectedItem = $(treeGridId).ejTreeGrid("option", "selectedRowIndex");
            var args = {};
            args["requestType"] = ej.TreeGrid.Actions.Delete;
            if (selectedItem !== -1) {
                $(treeGridId).ejTreeGrid("deleteRow");
                proxy._enbleDisablePredecessorDeleteButton('disable',dialogType);
            }
            proxy._disablePredecessorAddButton(treeGridId, dialogType);
        },

         //updated the status of Resource button in dialog box
        enbleDisableDeleteResourceButton:function(args,dialogType)
        {
            var proxy = this, predecessorDelete;
            if (dialogType == "add")
                predecessorDelete = $("#" + proxy._id + "AddDialog_ResourceDelete");
            else
                predecessorDelete = $("#" + proxy._id + "EditDialog_ResourceDelete");
            if(args==="enable")
            {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deleteResource, proxy)).bind("click", $.proxy(proxy._deleteResource, proxy));
                $(predecessorDelete).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deleteResource, proxy));
                $(predecessorDelete).addClass('e-disable').removeClass('e-enable');
            }
        },
        //updated the status of Resource button in dialog box
        enbleDisableAddResourceButton: function (args,dialogType)
        {
            var proxy = this, resourceAdd;
            if (dialogType == "add")
                resourceAdd = $("#" + proxy._id + "AddDialog_ResourceAdd");
            else
                resourceAdd = $("#" + proxy._id + "EditDialog_ResourceAdd");
            if (args === "enable") {
                $(resourceAdd).unbind("click", $.proxy(proxy._addResource, proxy)).bind("click", $.proxy(proxy._addResource, proxy));
                $(resourceAdd).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(resourceAdd).unbind("click", $.proxy(proxy._addResource, proxy));
                $(resourceAdd).addClass('e-disable').removeClass('e-enable');
            }
        },

        //add empty row in predecessor grid in dialog box
        _addResource: function (e) {
            var proxy = this,
                args = {}, treeGridId, grid,
                item = { name: "", unit: "100" }, dialogType;
            if ($(e.target).hasClass("e-edit-dialog")) {
                dialogType = "edit";
                treeGridId = "#treegrid" + proxy._id + "resourceEdit";
            }
            else {
                dialogType = "add";
                treeGridId = "#treegrid" + proxy._id + "resourceAdd";
            }
            proxy.enbleDisableAddResourceButton('disable', dialogType);
            grid = $(treeGridId).ejTreeGrid("instance");
            grid.clearSelection(grid.model.selectedRowIndex);
            grid.addRow(item, "bottom");                       
            proxy.enbleDisableDeleteResourceButton('disable', dialogType);
        },
        //delete predecessor in dialog box 
        _deleteResource: function (e) {
            var proxy = this, treeGridId;

            if ($(e.target).hasClass("e-edit-dialog"))
                treeGridId = "#treegrid" + proxy._id + "resourceEdit";
            else
                treeGridId = "#treegrid" + proxy._id + "resourceAdd";

            var selectedItem = $(treeGridId).ejTreeGrid("option", "selectedRowIndex");
            var args = {};
            args["requestType"] = ej.TreeGrid.Actions.Delete;
            if (selectedItem !== -1) {
                $(treeGridId).ejTreeGrid("deleteRow");
            }
        },
            
        _resourceEndEdit:function(gridId,dialogType, args)
        {
            var proxy = this,
                columns = args.model.columns,
                enableResourceAdd;
            columns[0].dropdownData = $.extend(true, [], proxy.model.resources),
            enableResourceAdd = args.model.dataSource.length < proxy.model.resources.length;
            proxy._enableDisableResourceAddButton(args, enableResourceAdd, dialogType);
        },
        _resourceBeginEdit: function (gridId, args) {
            var proxy = this,
                idMapping = proxy.model.resourceIdMapping,
                gridModel = args.model,
                 columns = gridModel.columns,
                 dropDownData = columns[0].dropdownData,
                 dataSource = gridModel.dataSource,
                 length = dataSource.length,
                 value = args.data.item.name;
            for (var i = 0; i < length; i++) {
                if (dataSource[i].name != "" && dataSource[i].name != null && value != dataSource[i].name) {
                    var index = $.map(dropDownData, function (data, index) {
                        if (data[idMapping].toString() == dataSource[i].name) {
                            return index;
                        }
                    });
                    dropDownData.splice(index[0], 1);
                }
            }
        },
        //returns column value by field name
        getColumnIndexByField: function (field) {

            var proxy = this,
                columns = proxy.model.columns,
                length = columns.length,
                column = 0;

            for (column; column < length; column++) {

                if (columns[column]["field"] == field) break;

            }

            return column;
        },

        //returns selected resource index from rource value
        getIndexofresourceInfo: function (dataSource,data) {
            var resourceInfo = data.resourceInfo,
                count = 0, length = resourceInfo ? resourceInfo.length : 0, resourceIndex = [];
            
            for (count; count < length; count++) {
                if (dataSource.indexOf(resourceInfo[count]) != -1)
                    resourceIndex.push(dataSource.indexOf(resourceInfo[count]));
            }

            return resourceIndex;

        },
        //focus elements on editing
        _focusElements: function ($currentCell) {
            if ($currentCell.length) {
                $currentCell.focus();
                var $childElem = $currentCell.children();
                if ($childElem[0].tagName.toLowerCase() == "select" || $childElem[0].tagName.toLowerCase() == "input") {
                    $childElem.focus().select();
                    $childElem[0].focus();
                }
                else if ($childElem.find(".e-field.e-dropdownlist").length)
                    $childElem.find(".e-ddl").focus();
                else
                    $childElem.find('input,select').select().focus();
            }
        },
        //add button templates for add and edit dialog
        renderDiaglogButton: function (type, tbody) {

            var btnId,
                proxy = this,
                model = proxy.model;
            if (type == "edit")
                btnId = "EditDialog_";
            else
                btnId = "AddDialog_";

            var savebtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px',
                     "min-width": "70px"
                 },
                 { type: "button", id: btnId + proxy._id + "_Save" }),
             saveText = type == "edit" ? proxy._editDialogTexts["saveButton"] : proxy._editDialogTexts["addButton"];
            
            savebtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: saveText,
                    width: "auto"
                });

            var cancelText = proxy._editDialogTexts["cancelButton"],
             cancelbtn = ej.buildTag('input', "",
                 {
                     'margin-left': '18px',
                     'border-radius': '3px',
                     "min-width": "70px"
                 },
                 {
                     type: "button",
                     id: btnId + proxy._id + "_Cancel"
                 });
            
            cancelbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: cancelText,
                    width: "auto"
                });

            //Sample delete button
            var deleteText = proxy._editDialogTexts["deleteButton"],
                delbtn = ej.buildTag('input', "",
                {
                    'border-radius': '3px',
                    "min-width": "90px"
                },
                {
                    type: "button",
                    id: "EditDialog_" + proxy._id + "_Delete"
                });

            delbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: deleteText,
                    width: "auto"
                });



            var btnDiv = ej.buildTag('div', "", { 'float': 'right',"z-index":"10" }, { 'class': "e-editform-btn e-editfrom-btn-right" });
            var deleteBtnDiv = ej.buildTag('div', "", { 'float': 'left', "z-index": "10" }, { 'class': "e-editform-btn e-editfrom-btn-left" });

            btnDiv.append(savebtn);
            if (type == "edit" && model.editSettings.allowDeleting)
                deleteBtnDiv.append(delbtn);
            btnDiv.append(cancelbtn);
            btnDiv.appendTo(tbody);
            deleteBtnDiv.appendTo(tbody);
            return tbody;
        },
        //Tool bar rendering initiated
        _renderToolBar: function() {
            var proxy = this,
                model = proxy.model,
                $div = ej.buildTag("div.e-gantttoolbar#e-gantttoolbar" + proxy._id, "", { 'height': '50px' }, { id: proxy._id + "_toolbarItems" });                
            if (!ej.isNullOrUndefined(model.toolbarSettings.toolbarItems) && model.toolbarSettings.toolbarItems.length) {
                var $ul = ej.buildTag("ul", "", {}, {});
                proxy._renderLi($ul);
                $div.append($ul);
            }
            if (!ej.isNullOrUndefined(model.toolbarSettings.customToolbarItems) && model.toolbarSettings.customToolbarItems.length) {
                var $customUl = ej.buildTag("ul", "", {}, {});
                proxy._renderCustomLi($customUl);
                $div.append($customUl);
            }
            if (model.toolbarSettings.toolbarItems.indexOf(ej.Gantt.ToolbarItems.Search) != -1) {
                    var $searchUl = ej.buildTag("ul.e-gantt-search-container", "", {'float':'right'}, {}),
                    $li = ej.buildTag("li", "", {}, {
                        id: proxy._id + "_" + ej.Gantt.ToolbarItems.Search,
                        "tabindex": "0"
                    });
                    proxy._renderLiContent($li, ej.Gantt.ToolbarItems.Search);
                    $searchUl.append($li);
                    $div.append($searchUl);
                }            
            var helper = {};
            helper.click = proxy._toolBarClick;
            helper.cssClass = model.cssClass;
            helper.rtl = false;
            helper.itemSeparator = false;
            helper.width = proxy._ganttWidth;
            helper.fields = {
                id: "",
                tooltipText: "",
                imageUrl: "",
                text: "",
                imageAttributes: "",
                spriteCSS: "",
                htmlAttributes: "",
            };
            $div.ejToolbar(helper);
            $div.ejToolbar("disableItem", proxy._disabledToolItems);
            proxy._disabledToolItems = $();
            return $div;
        },
        //to renderCustom Li
        _renderCustomLi: function ($ul) {
            var proxy = this,
            model = proxy.model,
            $li, $item,
            customToolbarItems = model.toolbarSettings.customToolbarItems;
            for (var i = 0; i < customToolbarItems.length; i++) {
                if (customToolbarItems[i]["text"] || customToolbarItems[i]["templateID"]) {
                    if (customToolbarItems[i]["text"])
                    {
                       var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["text"];
                       $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["text"], title: customToolbar });
                       $item = ej.buildTag("a.e-toolbaricons e-icon e-ganttcustomtoolbaritem", "", {}).addClass(customToolbarItems[i]["text"]);
                       $li.addClass("e-gantttoolbaritem");
                    }
                    else {
                        var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["templateID"].replace("#", "");
                        $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["templateID"].replace("#", ""), title: customToolbar });
                        $item = $(customToolbarItems[i]["templateID"]).hide().html();
                    }                    
                    $li.html($item);
                    $ul.append($li);
                }              
            }
        },
        //craete LI elements for tool bar
        _renderLi: function ($ul) {
            var proxy = this,
                toolBarItems = proxy.model.toolbarSettings.toolbarItems,
                length = toolBarItems.length,
                i = 0,
                $li;
            for (i; i < length; i++) {

                $li = ej.buildTag("li", "", {}, {
                    id: proxy._id + "_" + toolBarItems[i],                    
                    "tabindex": "0"
                });

                if (toolBarItems[i] !== "search") {
                    $li.addClass("e-gantttoolbaritem");                   
                    proxy._renderLiContent($li, toolBarItems[i]);
                    $ul.append($li);
                }
            }
        },

        //add attributes for tool bar li elements
        _renderLiContent: function ($li, item) {
            var $a, $input;
            var selectedRowIndex = this.selectedRowIndex();
            var editSetting = this.model.editSettings;
            switch (item) {

                case "add":
                    $a = ej.buildTag("a.e-addnewitem e-toolbaricons e-icon e-gantt-add", "", {});
                    //title: toolBarItems[i],
                    var addTitle = this._toolboxTooltipTexts["addTool"];
                    $li.attr("title", addTitle);
                        if (this.model.readOnly==true||!this.model.editSettings.allowAdding)
                        this._disabledToolItems.push($li.get(0));
                    break;

                case "edit":
                    $a = ej.buildTag("a.e-edititem e-toolbaricons e-icon e-gantt-edit", "", {});
                    var editTitle = this._toolboxTooltipTexts["editTool"];
                    $li.attr("title", editTitle);
                        if (this.model.readOnly == true || (!this.model.editSettings.allowEditing || selectedRowIndex == -1 || this.model.editSettings.beginEditAction == "click")) {
                        this._disabledToolItems.push($li.get(0));
                    }
                    
                    break;

                case "delete":
                    var deleteTitle = this._toolboxTooltipTexts["deleteTool"];
                    $li.attr("title", deleteTitle);
                    $a = ej.buildTag("a.e-deleteitem e-toolbaricons e-icon e-gantt-delete", "", {});
                    
                    if (this.model.readOnly==true||(!this.model.editSettings.allowDeleting || selectedRowIndex == -1)) {
                        this._disabledToolItems.push($li.get(0));
                    }
                    
                    break;

                case "update":
                    var saveTitle = this._toolboxTooltipTexts["saveTool"];
                    $li.attr("title", saveTitle);
                    $a = ej.buildTag("a.e-saveitem e-toolbaricons e-icon e-gantt-save e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "cancel":
                    var cancelTitle = this._toolboxTooltipTexts["cancelTool"];
                    $li.attr("title", cancelTitle);
                    $a = ej.buildTag("a.e-cancel e-toolbaricons e-icon e-gantt-cancel e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "indent":
                    var indentTitle = this._toolboxTooltipTexts["indentTool"];
                    $li.attr("title", indentTitle);
                    $input = ej.buildTag("a.e-indent e-toolbaricons e-icon e-disabletool e-gantt-indent", "", {}, {});
                    $li.append($input);
                    if (this.model.readOnly==true ||(!this.model.editSettings.allowIndent || selectedRowIndex == -1)) {
                        this._disabledToolItems.push($li.get(0));
                    }

                    break;

                case "outdent":
                    var outdentTitle = this._toolboxTooltipTexts["outdentTool"];
                    $li.attr("title", outdentTitle);
                    $input = ej.buildTag("a.e-outdent e-toolbaricons e-icon e-disabletool e-gantt-outdent", "", {}, {});
                    $li.append($input);
                    if (this.model.readOnly==true ||(!this.model.editSettings.allowIndent || selectedRowIndex == -1)) {
                        this._disabledToolItems.push($li.get(0));
                    }
                    break;

                case "expandAll":
                    var expandTitle = this._toolboxTooltipTexts["expandAllTool"];
                    $li.attr("title", expandTitle);
                    $input = ej.buildTag("a.e-expandall e-toolbaricons e-icon e-gantt-expandall", "", {}, {});
                    $li.append($input);
                    break;

                case "collapseAll":
                    var collapseTitle = this._toolboxTooltipTexts["collapseAllTool"];
                    $li.attr("title", collapseTitle);
                    $input = ej.buildTag("a.e-collapseall e-toolbaricons e-icon e-gantt-collapseall", "", {}, {});
                    $li.append($input); 
                    break;
                case "prevTimeSpan":
                    var prevTitle = this._toolboxTooltipTexts["prevTimeSpanTool"];
                    $li.attr("title", prevTitle);
                    $input = ej.buildTag("a.e-prevtimespan e-toolbaricons e-icon e-gantt-prevtimespan", "", {}, {});
                    $li.append($input);
                    break;
                case "nextTimeSpan":
                    var nextTitle = this._toolboxTooltipTexts["nextTimeSpanTool"];
                    $li.attr("title", nextTitle);
                    $input = ej.buildTag("a.e-nexttimespan e-toolbaricons e-icon e-gantt-nexttimespan", "", {}, {});
                    $li.append($input);
                    break;
                case "criticalPath":
                    var criticalTitle = this._toolboxTooltipTexts["criticalPathTool"];
                    $li.attr("title", criticalTitle);
                    $input = ej.buildTag("a.e-criticaltask e-toolbaricons e-icon e-gantt-criticaltask", "", {}, {});
                    $li.append($input);
                    break;
                case "search":
                    var searchTitle = this._toolboxTooltipTexts["searchTool"];
                    $input = ej.buildTag("input.e-ejinputtext", "", { 'margin': '4px', 'text-indent': '4px' }, { type: "text", placeholder: searchTitle }, { 'color': "#E8E9E9" });
                    $li.css({ 'float': 'right', 'padding': '2px' });
                    $li.attr("title", searchTitle);
                    $li.addClass('e-search');
                    $li.append($input);
                    this.model.allowSearching = true;

                    $input.keydown($.proxy(this._keyDown, this));

                    break;
                case "excelExport":
                    var excelExportTitle = this._toolboxTooltipTexts["excelExportTool"];
                    $li.attr("title", excelExportTitle);
                    $input = ej.buildTag("a.e-excelIcon e-toolbaricons e-icon e-gantt-excelexport", "", {}, {});
                    $li.append($input);
                    break;
                case "pdfExport":
                    var pdfExportTitle = this._toolboxTooltipTexts["pdfExportTool"];
                    $li.attr("title", pdfExportTitle);
                    $input = ej.buildTag("a.e-pdfIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
            }
            $li.append($a);
        },

        //handle key down for searching in gantt
        _keyDown: function (e) {

            if (e.which ===13) { //13 is key code for Enter Key 
                this._toolbarOperation(this._id + "_search", e.currentTarget.value);
				e.preventDefault();
				return false;//prevent post back
            }          
        },

        //update the status of tool bar elements 
        _updateToolbarOptions:function(){

            var proxy = this,
                model = proxy.model,
                editSettings = model.editSettings,
                toolbar = $("#" + proxy._id + "_toolbarItems"),
                $addElement = $(toolbar).find(".e-addnewitem").parent()[0],
                $editElement = $(toolbar).find(".e-edititem").parent()[0],
                $deleteElement = $(toolbar).find(".e-deleteitem").parent()[0],
                $indentElement = $(toolbar).find(".e-indent").parent()[0],
                $outdentElement = $(toolbar).find(".e-outdent").parent()[0],                
                $updateElement = $(toolbar).find(".e-saveitem").parent()[0],
                $cancelElement = $(toolbar).find(".e-cancel").parent()[0],
                disabledItems = [], enabledItems = [];
            if (model.readOnly == true) {
                $addElement && disabledItems.push($($addElement));
                $editElement && disabledItems.push($($editElement));
                $deleteElement && disabledItems.push($($deleteElement));
                $indentElement && disabledItems.push($($indentElement));
                $outdentElement && disabledItems.push($($outdentElement));
                $updateElement && disabledItems.push($($updateElement));
                $cancelElement && disabledItems.push($($cancelElement));
                $(toolbar).ejToolbar('disableItem', disabledItems);
            }
            else {
                if (editSettings.allowAdding)
                    $addElement && enabledItems.push($addElement);
                else
                    $addElement && disabledItems.push($($addElement));

            if (!model.selectedItem) {

                if (editSettings.allowEditing) {
                    $editElement && disabledItems.push($($editElement));
                }

                if (editSettings.allowDeleting) {
                    $deleteElement && disabledItems.push($($deleteElement));
                    }

                if ($updateElement)
                    $updateElement && disabledItems.push($($updateElement));

                if ($cancelElement)
                    $cancelElement && disabledItems.push($($cancelElement));

                    if ($indentElement)
                        $indentElement && disabledItems.push($($indentElement));

                    if ($outdentElement)
                        $outdentElement && disabledItems.push($($outdentElement));
                }
                else {

                if (editSettings.allowEditing && model.editSettings.beginEditAction != "click")
                        $editElement && enabledItems.push($editElement);
                    else
                        $editElement && disabledItems.push($($editElement));

                    if (editSettings.allowDeleting)
                        $deleteElement && enabledItems.push($deleteElement);
                    else
                        $deleteElement && disabledItems.push($($deleteElement));

                    proxy.updateIndentOutdentOption(model.selectedItem);
                }

                $(toolbar).ejToolbar('disableItem', disabledItems);
                $(toolbar).ejToolbar('enableItem', enabledItems);
            }
        },

        //Splitter control is initiated
        _renderGantt: function () {

            var proxy = this,
                model = proxy.model,
                leftPaneSize,
                rightPaneSize,
                ganttWidth = parseInt(proxy._ganttWidth),
                splitterPosition = proxy.splitterPosition(),
                isPercentage = false, columnWidth,
                splitterColumnIndex = model.splitterSettings.index;
            if (!splitterPosition)
            {
                splitterPosition = proxy._splitterPosition();
                proxy.splitterPosition(splitterPosition);
            }
            //calculate treegrid pane size
            if (splitterPosition || splitterColumnIndex > -1) {
                if (splitterPosition) {
                    if (typeof splitterPosition == "string" && splitterPosition.indexOf("%") != -1) {
                        leftPaneSize = parseInt(splitterPosition);
                        isPercentage = true;
                    }
                    else {
                        leftPaneSize = parseInt(splitterPosition) / ganttWidth * 100;
                        isPercentage = false;
                    }
                }
                else {
                    var columns = proxy.getColumns(),
                        columnWidth = 0,
                    columnIndex = splitterColumnIndex;
                    if (columnIndex >= columns.length)
                        columnIndex = columns.length - 1;
                    for (var index = 0; index <= columnIndex; index++)
                        columnWidth += columns[index].width;
                    if (columnWidth <= ganttWidth) {
                        leftPaneSize = parseInt(columnWidth) / ganttWidth * 100;
                        splitterColumnIndex = index - 1;
                    }
                    else {
                        columnWidth = 0;
                        for (var index = 0; index <= columnIndex; index++) {
                            if ((columnWidth + columns[index].width) <= ganttWidth) {
                                columnWidth += columns[index].width;
                                splitterColumnIndex = index;
                            }
                            else {
                                leftPaneSize = parseInt(columnWidth) / ganttWidth * 100;
                                break;
                            }
                        }
                    }
                    model.splitterSettings.index = splitterColumnIndex;
                }
                // set grid width value is zero when grid width is less than zero or NAN.
                if (isNaN(leftPaneSize) || leftPaneSize < 0)
                    leftPaneSize = 0;
                // check the left pane size is greather than 100% of gantt width
                if (leftPaneSize > 100) {
                    leftPaneSize = (2 * proxy._commonColumnWidth + 3) / ganttWidth * 100;
                    leftPaneSize = leftPaneSize < 30 ? leftPaneSize : 30;
                    isPercentage = true;
                }
            }
            else {
                leftPaneSize = (2 * proxy._commonColumnWidth + 3) / ganttWidth * 100;
                leftPaneSize = leftPaneSize < 30 ? leftPaneSize : 30;
                isPercentage = true;
            }
            //Here 9 is the splitter span width
            rightPaneSize = 100 - leftPaneSize - (9 / ganttWidth * 100);
            // Check the right pane size is less than or euqal to 0.
            if (rightPaneSize <= 0) {
                if (isPercentage)
                    proxy.splitterPosition("100%");
                else
                    proxy.splitterPosition(ganttWidth.toString());
                leftPaneSize = 100 - (9 / ganttWidth * 100);
                rightPaneSize = 0;
            }
            else if (rightPaneSize > 0) {
                if (isPercentage)
                    proxy.splitterPosition(Math.round(leftPaneSize) + "%");
                else
                    proxy.splitterPosition(Math.round((leftPaneSize * ganttWidth / 100)).toString());
            }
            // assign the splitter position value to deprecated splitterPosition property
            proxy._splitterPosition(proxy.splitterPosition());
            $("#e-ejSpliter" + proxy._id).ejSplitter({
                //border width and height excluded
                height: proxy._ganttHeight,
                width: ganttWidth,
                orientation: ej.Orientation.Horizontal,
                properties: [{ paneSize: leftPaneSize + "%", collapsible: false }, { paneSize: rightPaneSize + "%", collapsible: false }],
                enableAutoResize: false,
                resize: $.proxy(proxy._onResize, proxy),
                cssClass: model.cssClass
            });
        },

        //Tree Grid part is initiated
        _renderTreeGrid: function() {
            var proxy = this, model = proxy.model;
            proxy._$treegridHelper = $("#ejTreeGrid" + proxy._id).ejTreeGrid({
                enableAltRow: model.enableAltRow,
                allowColumnResize: model.allowColumnResize,
                enableVirtualization: model.enableVirtualization,
                allowSorting: model.allowSorting,
                showColumnChooser: model.showColumnChooser,
                showColumnOptions: model.showColumnOptions,
                allowMultiSorting: model.allowMultiSorting,
                sortSettings: model.sortSettings,
                allowSelection: model.allowSelection,
                selectionType: model.selectionMode == "cell" ? model.selectionType : "single",
                selectionMode: model.selectionMode,
                selectedRowIndex: this.selectedRowIndex(),
                allowDragAndDrop: model.allowDragAndDrop,
                dragTooltip: model.dragTooltip,
                allowSearching: model.allowSearching,
                parentIdMapping: model.parentTaskIdMapping,
                baselineStartDateMapping: model.baselineStartDateMapping,
                baselineEndDateMapping: model.baselineEndDateMapping,
                allowKeyboardNavigation: model.allowKeyboardNavigation,
                cssClass: model.cssClass,
                locale: model.locale,
                columns: proxy.getColumns(),
                editSettings: model.editSettings,
                toolbarSettings:model.toolbarSettings,
                rowTemplate: model.rowTemplate,
                rowDataBound: model.rowDataBound,
                queryCellInfo: model.queryCellInfo,
                cellSelecting: model.cellSelecting,
                cellSelected: model.cellSelected,
                selectedCellIndexes: this.selectedCellIndexes(),
                dataSource:this.dataSource(),
                flatRecords: model.flatRecords,
                parentRecords: model.parentRecords,
                ids: proxy.model.ids,                
                dateFormat: model.dateFormat,
                resourceInfoMapping: model.resourceInfoMapping,
                resourceNameMapping: model.resourceNameMapping,
                resourceIdMapping:model.resourceIdMapping,
                resourceUnitMapping: model.resourceUnitMapping,
                idMapping: model.taskIdMapping,
                readOnly:model.readOnly,
                notesMapping: model.notesMapping,
                showGridCellTooltip: model.showGridCellTooltip,
                cellTooltipTemplate:model.cellTooltipTemplate,
                showGridExpandCellTooltip: model.showGridExpandCellTooltip,
                taskNameMapping: model.taskNameMapping,
                taskSchedulingModeMapping: model.taskSchedulingModeMapping,
                startDateMapping: model.startDateMapping,
                endDateMapping: model.endDateMapping,
                childMapping: model.childMapping,
                durationMapping: model.durationMapping,
                durationUnitMapping: model.durationUnitMapping,
                durationUnit: model.durationUnit,
                progressMapping: model.progressMapping,
                predecessorMapping: model.predecessorMapping,
                rowHeight: model.rowHeight,
                emptyRecordText: proxy._emptyRecordText,
                isFromGantt: proxy._isFromGantt,
                treeColumnIndex: model.treeColumnIndex,
                workingTimeScale:model.workingTimeScale,
                enableWBS: model.enableWBS,
                enableWBSPredecessor: model.enableWBSPredecessor,
                columnMenuTexts: proxy._columnMenuTexts,
                editTypeText: proxy._editTypeText,
                clipModeText: proxy._clipModeText,
                textAlignTypeText: proxy._textAlignTypeText,
                columnDialogTitle: proxy._columnDialogTitle,
                deleteColumnText: proxy._deleteColumnText,
                okButtonText: proxy._okButtonText,
                cancelButtonText: proxy._cancelButtonText,
                confirmDeleteText: proxy._confirmDeleteText,
                columnDialogFields: model.columnDialogFields,
                columnDialogTexts: proxy._columnDialogTexts,
                workMapping: model.workMapping,
                workUnit: proxy._workUnitTexts[model.workUnit],
                taskTypeTexts: proxy._taskTypeTexts,
                effortDrivenTexts: proxy._effortDrivenTexts,
                dataManagerUpdate: { isDataManagerUpdate: proxy._isDataManagerUpdate, jsonData: proxy._jsonData },
                durationUnitEditText: this._durationUnitEditText,
                durationUnitTexts: proxy._durationUnitTexts,
                enableCollapseAll: model.enableCollapseAll,
                weekStartDay: model.scheduleHeaderSettings.weekStartDay,
                indentLevelWidth: this.indentLevelWidth
            });
        },
        //Chart part is initiated
        _renderGanttChart: function() {
            var proxy = this,
                model = this.model;
            proxy._$ganttchartHelper = $("#ejGanttChart" + proxy._id).ejGanttChart(
                {
                    dataSource: this.dataSource(),
                    scheduleStartDate: model.scheduleStartDate,
                    scheduleEndDate: model.scheduleEndDate,
                    startDateMapping: model.startDateMapping,
                    endDateMapping: model.endDateMapping,
                    taskNameMapping: model.taskNameMapping,
                    taskIdMapping: model.taskIdMapping,
                    progressMapping: model.progressMapping,
                    durationMapping: model.durationMapping,
                    childPropertyName: model.childMapping,
                    predecessorMapping: model.predecessorMapping,
                    enableVirtualization: model.enableVirtualization,
                    highlightWeekends: model.highlightWeekends,
                    milestoneMapping: model.milestoneMapping,
                    enableRowHover: model.enableRowHover,
                    perDayWidth: proxy._perDayWidth,
                    workingTimeScale: model.workingTimeScale,
                    roundOffDayworkingTime: model.roundOffDayworkingTime,
                    durationUnit: model.durationUnit,
                    isCriticalPathEnable: this.isCriticalPathEnable,
                    criticalPathCollection: this.criticalPathCollection,
                    perMonthWidth: proxy._perMonthWidth,//new property for year - month schedule
                    perWeekWidth: proxy._perWeekWidth,//new property for week - month schedule
                    perHourWidth: proxy._perHourWidth,
                    perMinuteWidth: proxy._perMinuteWidth,
                    perTopHourWidth: proxy._perTopHourWidth,
                    minuteInterval:proxy._minuteInterval,
                    includeWeekend: model.includeWeekend,
                    connectorlineWidth: model.connectorlineWidth,
                    workingTimeRanges: proxy._workingTimeRanges,
                    secondsPerDay: proxy._secondsPerDay,
                    scheduleHeaderSettings: model.scheduleHeaderSettings,
                    taskbarBackground: model.taskbarBackground,
                    progressbarBackground: model.progressbarBackground,
                    connectorLineBackground: model.connectorLineBackground,
                    parentTaskbarBackground: model.parentTaskbarBackground,
                    parentProgressbarBackground: model.parentProgressbarBackground,
                    holidays: model.holidays,
                    dateFormat: model.dateFormat,
                    locale: model.locale,
                    enableTaskbarTooltip: model.enableTaskbarTooltip,
                    enableTaskbarDragTooltip:model.enableTaskbarDragTooltip,
                    flatRecords: model.flatRecords,
                    parentRecords: model.parentRecords,
                    scheduleWeeks: proxy._scheduleWeeks,

                    projectStartDate: proxy._projectStartDate, //new property instead of scheduleWeeks[0] and scheduleYears[0]
                    projectEndDate: proxy._projectEndDate,

                    scheduleYears: proxy._scheduleYears, //new property for year
                    scheduleMonths: proxy._scheduleMonths, //new property for month
                    scheduleDays:proxy._scheduleDays,
                    scheduleHours:proxy._scheduleHours,
                    progressbarHeight: model.progressbarHeight,
                    tooltipTemplate: model.taskbarTooltipTemplate,
                    tooltipTemplateId: model.taskbarTooltipTemplateId,
                    progressbarTooltipTemplate: model.progressbarTooltipTemplate,
                    progressbarTooltipTemplateId: model.progressbarTooltipTemplateId,
                    queryTaskbarInfo: model.queryTaskbarInfo,
                    readOnly:model.readOnly,
                    showTaskNames: model.showTaskNames,
                    leftTaskLabelMapping: model.leftTaskLabelMapping,
                    rightTaskLabelMapping: model.rightTaskLabelMapping,
                    leftTaskLabelTemplate: model.leftTaskLabelTemplate,
                    rightTaskLabelTemplate: model.rightTaskLabelTemplate,
                    showProgressStatus: model.showProgressStatus,
                    showResourceNames: model.showResourceNames,
                    resourceInfoMapping: model.resourceInfoMapping,
                    resourceNameMapping: model.resourceNameMapping,
                    resourceUnitMapping: model.resourceUnitMapping,
                    enableProgressBarResizing: model.enableProgressBarResizing,
                    allowGanttChartEditing: model.allowGanttChartEditing,
                    taskbarEditingTooltipTemplateId: model.taskbarEditingTooltipTemplateId,
                    taskbarEditingTooltipTemplate:model.taskbarEditingTooltipTemplate,
                    ids: proxy.model.ids,
                    stripLines: model.stripLines,
                    _predecessorCollection: proxy._predecessorsCollection,
                    _columns:proxy._columns,
                    weekendBackground: model.weekendBackground,
                    allowKeyboardNavigation: model.allowKeyboardNavigation,
                    updatedRecords: proxy.model.updatedRecords,
                    renderBaseline: model.renderBaseline,
                    baselineColor:model.baselineColor,
                    editSettings: model.editSettings,
                    columnHeaderTexts: proxy._columnHeaderTexts,
                    durationUnitTexts:proxy._durationUnitTexts,
                    predecessorEditingTexts: proxy._predecessorEditingTexts,
                    localizedDays: proxy._days,
                    localizedMonths:proxy._months,
                    rowHeight: model.rowHeight,
                    allowSelection: model.allowSelection,
                    selectionMode: model.selectionMode,
                    taskbarTemplate: model.taskbarTemplate,
                    parentTaskbarTemplate: model.parentTaskbarTemplate,
                    milestoneTemplate: model.milestoneTemplate,
                    durationUnitEditText: this._durationUnitEditText,
                    taskbarClick: model.taskbarClick,
                    predecessorText: proxy._getPredecessorText(),
                    taskbarHeight: proxy.taskbarHeight,
                    cssClass: model.cssClass
                });
        },

        _getPredecessorText: function(){
            var temp = this._predecessorCollectionText[1], predecessorText = {};
            temp = temp.value.split("-");
            predecessorText["Start"] = temp[0],
            predecessorText["Finish"] = temp[1];
            return predecessorText;
        },

        //Dynamically update dropDown datasources while changing localization of a project.
        _updateColumnDropDownData:function(){
            var proxy = this, model = proxy.model, columns = model.columns,
                length = columns.length;
            for (var i = 0; i < length; i++) {
                if (columns[i].field == "taskMode") {
                    columns[i].dropdownData = [{ id: 1, "text": proxy._taskModeTexts["manual"], "value": "true" },
                                   { id: 2, "text": proxy._taskModeTexts["auto"], "value": "false" }];
                }
                if (columns[i].field == "taskType") {
                    columns[i].dropdownData = [{ id: 1, "text": proxy._taskTypeTexts["fixedWork"], "value": "fixedWork" },
                              { id: 2, "text": proxy._taskTypeTexts["fixedUnit"], "value": "fixedUnit" },
                              { id: 3, "text": proxy._taskTypeTexts["fixedDuration"], "value": "fixedDuration" }];
                }
                if (columns[i].field == "effortDriven") {
                    columns[i].dropdownData = [{ id: 1, "text": proxy._effortDrivenTexts["yes"], "value": "true" },
                              { id: 2, "text": proxy._effortDrivenTexts["no"], "value": "false" }];
                }
            }
        },

        //Populate columns for treegrid from mapping names
        createTreeGridColumns: function () {

            var proxy = this, model = proxy.model, column, columns = [];

            var mapping = (model.taskIdMapping);//?model.taskIdMapping:"Task Id";

            if (mapping.length) {
                if(model.showColumnChooser){
                    column = {
                        field: "taskId",
                        headerText: proxy._columnHeaderTexts["taskId"],
                        width: 40,
                        editType: ej.Gantt.EditingType.String,
                        mappingName: mapping,
                        allowEditing: false,
                        allowCellSelection: true 
                    };
                }
                else
                {
                    column = {
                        field: "taskId",
                        headerText: proxy._columnHeaderTexts["taskId"],
                        width: 30,
                        editType: ej.Gantt.EditingType.String,
                        mappingName: mapping,
                        allowEditing: false,
                        allowCellSelection: true
                    };
                }

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.taskNameMapping;// "Task Name";

            if (mapping.length) {
                column = {
                    field: "taskName",
                    headerText: proxy._columnHeaderTexts["taskName"],
                    width: 150,
                    editType: ej.Gantt.EditingType.String,
                    mappingName: mapping,
                    allowCellSelection: true
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.startDateMapping;// "Start Date";

            if (mapping.length) {
                column = {
                    field: "startDate",
                    headerText:proxy._columnHeaderTexts["startDate"],
                    width: 150,
                    editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                              ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                    mappingName: mapping,
                    allowCellSelection: true,
                    format: "{0:" + model.dateFormat + "}"
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }


            mapping = model.endDateMapping;// "End Date";

            if (mapping.length) {
                column = {
                    field: "endDate",
                    headerText: proxy._columnHeaderTexts["endDate"],
                    width: 150,
                    editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                    mappingName: mapping,
                    allowCellSelection: true ,
                    format: "{0:" + model.dateFormat + "}"
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.resourceInfoMapping;//"Resources";

            if (mapping.length) {
                column = {
                    field: "resourceInfo",
                    headerText:proxy._columnHeaderTexts["resourceInfo"],
                    width: 150,
                    editType: ej.Gantt.EditingType.Dropdown,
                    mappingName: mapping,
                    allowCellSelection: true ,
                    dropdownData: model.resources //model.resources is null
                };
                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.durationMapping;// "Duration";

            if (mapping.length) {
                column = {
                    field: "duration",
                    headerText: proxy._columnHeaderTexts["duration"],
                    width: 150,
                    editType: ej.Gantt.EditingType.String,
                    allowCellSelection: true ,
                    mappingName:mapping
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }           

            mapping = model.progressMapping;// "Progress";

            if (mapping.length) {
                column = {
                    field: "status",
                    headerText: proxy._columnHeaderTexts["status"],
                    width: 150,
                    editType: ej.Gantt.EditingType.Numeric,
                    mappingName: mapping,
                    allowCellSelection: true
                };
                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }
            mapping = model.predecessorMapping;//)?model.predecessorMapping: "Predecessor";

            if (mapping.length) {
                column = {
                    field: "predecessor",
                    headerText:proxy._columnHeaderTexts["predecessor"],
                    width: 150,
                    editType: ej.Gantt.EditingType.String,
                    mappingName: mapping,
                    allowCellSelection: true
                };
                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }
            /*If renderBaseline enabled baseline columns  are added*/
            if (model.renderBaseline && model.baselineStartDateMapping && model.baselineEndDateMapping) {

                mapping = model.baselineStartDateMapping;
                if (mapping.length) {
                    column = {
                        field: "baselineStartDate",
                        headerText: proxy._columnHeaderTexts["baselineStartDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    columns.push(column);
                }
                mapping = model.baselineEndDateMapping;

                if (mapping.length) {
                    column = {
                        field: "baselineEndDate",
                        headerText: proxy._columnHeaderTexts["baselineEndDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    columns.push(column);
                }
            }
            /*To insert WBS column*/
            if (model.enableWBS) {
                mapping = "WBS";

                if (mapping.length) {
                    column = {
                        field: "WBS",
                        headerText: proxy._columnHeaderTexts["WBS"],
                        width: 150,
                        editType: ej.Gantt.EditingType.String,
                        allowEditing: false,
                        mappingName: mapping
                    };
                    columns.push(column);
                }
            }
            /*To insert WBS Predecessor column*/
            if (model.enableWBS && model.enableWBSPredecessor) {
                mapping = "WBSPredecessor";

                if (mapping.length) {
                    column = {
                        field: "WBSPredecessor",
                        headerText: proxy._columnHeaderTexts["WBSPredecessor"],
                        width: 150,
                        editType: ej.Gantt.EditingType.String,
                        allowEditing: false,
                        mappingName: mapping
                    };
                    columns.push(column);
                }
            }
            mapping = model.notesMapping;

            if (mapping.length) {
                column = {
                    field: "notesText",
                    headerText: proxy._columnHeaderTexts["notes"],
                    width: 150,
                    editType: "stringedit",
                    mappingName: mapping,
                    allowEditing: true,
                    allowCellSelection: true
                };
                columns.push(column);
            }
            mapping = model.taskSchedulingModeMapping;// "Task Mode";
            if (mapping.length) {
                var enableColumn = false;
                if (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Custom)
                    enableColumn = true;
                column = {
                    field: "taskMode",
                    headerText: proxy._columnHeaderTexts["taskMode"],
                    width: 100,
                    editType: ej.Gantt.EditingType.Dropdown,
                    allowCellSelection: enableColumn,
                    allowEditing: enableColumn,
                    mappingName: mapping,
                    dropdownData: [{ id: 1, "text": proxy._taskModeTexts["manual"], "value": "true" },
                                   { id: 2, "text": proxy._taskModeTexts["auto"], "value": "false" }],
                    editParams: { field: { text: "text", value: "value" } }
                };
                columns.push(column);
            }
            mapping = model.workMapping;// work ;
            column = {
                field: "work",
                headerText: proxy._columnHeaderTexts["work"],
                width: 150,
                editType: ej.Gantt.EditingType.Numeric,
                allowEditing: true,
                allowCellSelection: true,
                visible: mapping ? true : false
            };
            if (mapping.length)
                column.mappingName = mapping;
            columns.push(column);
            column = {
                field: "taskType",
                headerText: proxy._columnHeaderTexts["taskType"],
                width: 150,
                editType: ej.Gantt.EditingType.Dropdown,
                dropdownData: [{ id: 1, "text": proxy._taskTypeTexts["fixedWork"], "value": "fixedWork" },
                               { id: 2, "text": proxy._taskTypeTexts["fixedUnit"], "value": "fixedUnit" },
                               { id: 3, "text": proxy._taskTypeTexts["fixedDuration"], "value": "fixedDuration" }],
                editParams: { field: { text: "text", value: "value" } },
                allowEditing: true,
                allowCellSelection: true,
                visible: false
            };
            columns.push(column);

            column = {
                field: "effortDriven",
                headerText: proxy._columnHeaderTexts["effortDriven"],
                width: 150,
                editType: ej.Gantt.EditingType.Dropdown,
                dropdownData: [{ id: 1, "text": proxy._effortDrivenTexts["yes"], "value": "true" },
                               { id: 2, "text": proxy._effortDrivenTexts["no"], "value": "false" }],
                editParams: { field: { text: "text", value: "value" } },
                allowEditing: true,
                allowCellSelection: true,
                visible: false
            };
            columns.push(column);

            return columns;
        },
        
        //Create gannt record from given data source
        _createGanttRecords: function(data) {
            var proxy = this,
                model = proxy.model,
                ganttRecords = model.flatRecords,
                length = data.length,
                count = 0,
                parentGanttRecord,
                parentRecords = model.parentRecords,
                enableSorting = model.allowSorting,
                enableAltRow = model.enableAltRow,
                ids = proxy.model.ids;


            for (count; count < length; count++) {
                if (model.enableWBS) {
                    data[count]["WBS"] = (count + 1).toString();
                }
                parentGanttRecord = proxy._createGanttRecord(data[count], 0, null,undefined,"Load");
                proxy._storedIndex++;
                //if (enableAltRow)
                parentGanttRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                parentGanttRecord.index = proxy._storedIndex;
                
                ids[proxy._storedIndex] = parentGanttRecord["taskId"].toString();
                ganttRecords.push(parentGanttRecord);
                //if (enableSorting)
                parentRecords.push(parentGanttRecord);
                parentGanttRecord.childRecords && proxy._addNestedGanttRecords(parentGanttRecord.childRecords);
            }
            if (model.enableWBS && model.enableWBSPredecessor)
                proxy.createWBSPredecessor();
        },
        
        /*Create WBS predecessors value*/
        createWBSPredecessor: function () {
            var proxy = this,
                model = proxy.model;
            if (model.enableWBS && model.enableWBSPredecessor && model.predecessorMapping) {
                var linkedRecords = model.flatRecords.filter(function (record) {
                    return record && record["predecessor"];
                });
                for (var r = 0; r < linkedRecords.length; r++) {
                    var linkRecord = linkedRecords[r],
                        prdc = linkRecord["predecessor"],
                        wbspred = null;
                    for (var p = 0; p < prdc.length; p++) {
                        var refId = +prdc[p].from, refRecord;
                        refRecord = model.flatRecords.filter(function (record) {
                            return record && record.taskId == refId;
                        });
                        var newOne = refRecord[0]["WBS"] + prdc[p].predecessorsType;
                        wbspred = wbspred ? (wbspred + "," + newOne) : newOne;
                    }
                    linkRecord["WBSPredecessor"] = wbspred;
                    linkRecord["item"]["WBSPredecessor"] = wbspred;
                }
            }
        },
        //Calculate schedule dates from GanttRecord Collections
        _calculateScheduleDates:function(editArgs)
        {
            var proxy = this,
                minStartDate,
                maxEndDate,
                tempStartDate,
                tempEndDate,
                baseLineStartDate,
                baseLineEndDate,
                model = this.model,
                records = model.flatRecords,
                updatedDates;
            if (((!model.scheduleEndDate || !model.scheduleStartDate) && records.length > 0)  || editArgs) {

                $.each(records, function (index, value) {
                        tempStartDate = new Date(value.startDate);
                        tempEndDate = new Date(value.endDate);
                        baseLineStartDate = value.baselineStartDate ? new Date(value.baselineStartDate) : null;
                        baseLineEndDate = value.baselineEndDate ? new Date(value.baselineEndDate) : null;
                        //minimum startDate
                        if (minStartDate) {
                            if (minStartDate.getTime() >= tempStartDate.getTime()) {
                                minStartDate = tempStartDate;
                            }
                            if (baseLineStartDate && model.renderBaseline && (minStartDate.getTime() >= baseLineStartDate.getTime())) {
                                minStartDate = baseLineStartDate;
                            }
                            else if (baseLineEndDate && model.renderBaseline && (minStartDate.getTime() >= baseLineEndDate.getTime())) {
                                minStartDate = baseLineEndDate;
                            }
                        } else {
                            if (baseLineStartDate && model.renderBaseline && tempStartDate.getTime() >= baseLineStartDate.getTime())
                                minStartDate = baseLineStartDate;
                            else if (baseLineEndDate && model.renderBaseline && tempStartDate.getTime() >= baseLineEndDate.getTime())
                                minStartDate = baseLineEndDate;
                            else
                                minStartDate = tempStartDate;
                        }
                        //Maximum endDate
                        if (maxEndDate) {
                            if (maxEndDate.getTime() <= tempEndDate.getTime()) {
                                maxEndDate = tempEndDate;
                            }
                            if (baseLineEndDate && model.renderBaseline && (maxEndDate.getTime() <= baseLineEndDate.getTime())) {
                                maxEndDate = baseLineEndDate;
                            }
                            else if (baseLineStartDate && model.renderBaseline && (maxEndDate.getTime() <= baseLineStartDate.getTime())) {
                                maxEndDate = baseLineStartDate;
                            }
                        } else {
                            if (baseLineEndDate && model.renderBaseline && tempEndDate.getTime() <= baseLineEndDate.getTime())
                                maxEndDate = baseLineEndDate;
                            if (baseLineStartDate && model.renderBaseline && tempEndDate.getTime() <= baseLineStartDate.getTime())
                                maxEndDate = baseLineStartDate;
                            else
                                maxEndDate = tempEndDate;
                        }
                });
                updatedDates = proxy._updateScheduleDatesByTaskLables(minStartDate, maxEndDate);
                minStartDate = updatedDates.minStartDate;
                maxEndDate = updatedDates.maxEndDate;
            }
            else if ((!model.scheduleEndDate || !model.scheduleStartDate) && records.length === 0) {
                minStartDate = proxy._getDateFromFormat(new Date());
                maxEndDate = proxy._getDateFromFormat(new Date(minStartDate));
                maxEndDate.setDate(maxEndDate.getDate() + 20);
            }
            if (!editArgs) {
                model.scheduleStartDate = minStartDate ? proxy.getFormatedDate(minStartDate) : model.scheduleStartDate;
                model.scheduleEndDate = maxEndDate ? proxy.getFormatedDate(maxEndDate) : model.scheduleEndDate;
            }
            else {
                editArgs.minStartDate = minStartDate;
                editArgs.maxEndDate = maxEndDate;
            }

        },

        //update schedule dates as per showTaskName and showResourceName values  and 
        //holidays collection and strip line collections at loadtime and edit time
        _updateScheduleDatesByTaskLables: function (startDate, endDate)
        {
            var proxy = this,
                model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType,
                resourceStringWidth = proxy._getResourceStringWidth(),
                numOfDays, returnValues = {},
                scheduleEndDate = model.scheduleEndDate && this._getDateFromFormat(model.scheduleEndDate);
              
            if (scheduleHeaderType == scheduleHeaderValue.Week) {
                //if (model.showTaskNames) {
                //    startDate.setDate(startDate.getDate() - 7);//one week before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime()))
                {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perDayWidth)+7 : 7;//one week after
                    endDate.setDate(endDate.getDate() + numOfDays);
                }
            }
            if (scheduleHeaderType == scheduleHeaderValue.Year) {
                //if (model.showTaskNames) {
                //    startDate.setMonth(startDate.getMonth() - 2);//2 month before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perMonthWidth) + 1 : 1;//1 month after
                    endDate.setMonth(endDate.getMonth() + numOfDays);
                }
            }
             

            if (scheduleHeaderType == scheduleHeaderValue.Month) {
                //if (model.showTaskNames) {
                //    startDate.setDate(startDate.getDate() - 14);//two week before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perDayWidth) + 7 : 7;//one week after
                    endDate.setDate(endDate.getDate() + numOfDays);
                }
            }


            if (scheduleHeaderType == scheduleHeaderValue.Day) {
                //if (model.showTaskNames) {
                //    startDate.setHours(startDate.getHours() - 8);//8hrs before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perHourWidth) + 7 : 7;//7hrs after
                    endDate.setHours(endDate.getHours() + numOfDays);
                }
            }
            if (scheduleHeaderType == scheduleHeaderValue.Hour) {
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    var numOfHours = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perMinuteWidth) + 5 : 5;//5hrs after
                    endDate.setHours(endDate.getHours() + numOfHours);
                    startDate.setHours(startDate.getHours() - 1);//Add 1 hour before.
                }
            }

            /* Update schedule dates as per holiday and strip line collection */
            returnValues = proxy._updateScheduleDatesByStripLines(startDate, endDate);

            startDate = returnValues.startDate;
            endDate = returnValues.endDate;


            returnValues = proxy._updateScheduleDatesByHolidays(startDate, endDate);

            startDate = returnValues.startDate;
            endDate = returnValues.endDate;

            returnValues.minStartDate = startDate;
            returnValues.maxEndDate = endDate;
           
            return returnValues;

        },

         //update Schedule dates by holidays collection */
        _updateScheduleDatesByHolidays: function (startDate, endDate)
        {
            var proxy = this, model = this.model, returnValues = {};

            //Check holidays are in range of schedule dates
            if (proxy._holidaysList.length > 0) {
                $.each(proxy._holidaysList, function (idx, value) {
                    if (!(value.getTime() > startDate.getTime()) || !(value.getTime() < endDate.getTime())) {
                        if (value.getTime() < startDate.getTime())
                            startDate = new Date(value);
                        else
                            endDate = new Date(value);
                    }
                });
            }

            returnValues.startDate = startDate;
            returnValues.endDate = endDate;

            return returnValues;


        },

        //update Schedule dates by stripLines collection */
        _updateScheduleDatesByStripLines: function (startDate, endDate) {
            var proxy = this, model = this.model, returnValues = {};

            //Check striplines are in range of schedule dates
            if (model.stripLines.length > 0) {
                $.each(model.stripLines, function (idx, value) {
                    var currentValue = proxy._getDateFromFormat(value.day)
                    if (!(currentValue.getTime() > startDate.getTime()) || !(currentValue.getTime() < endDate.getTime())) {
                        if (currentValue.getTime() < startDate.getTime())
                            startDate = new Date(currentValue);
                        else
                            endDate = new Date(currentValue);
                    }
                });
            }
            returnValues.startDate = startDate;
            returnValues.endDate = endDate;

            return returnValues;
        },

        //Get reosurce collections width
        _getResourceStringWidth:function(){
            var proxy = this,
                model = this.model,
                resource = model.resources,
                totalString = "",width;
            if (resource.length > 0 && model.showResourceNames) {
                for (var count = 0; count < resource.length; count++) {
                    totalString += resource[count][model.resourceNameMapping] + " ,";
                }
                var $span = ej.buildTag("span", "", { "font-family": "Segoe UI", "font-size": "12px" }, {});
                $span.text(totalString);
                $(document.body).append($span);
                width = $span.width();
                $span.remove();
                return width;
            } else {
                return 0;
            }
        },

        //calculate project dates by schedule mode types
        _calculateHeaderDates: function () {

            var proxy = this,
                model=this.model,
                startDate = proxy._getDateFromFormat(model.scheduleStartDate),
                endDate = proxy._getDateFromFormat(model.scheduleEndDate),
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType;

            if (headerType == headerValue.Week)
                proxy._calculateWeekSplit(startDate, endDate);

            if (headerType == headerValue.Year) {
                proxy._calculateYearSplit(startDate, endDate);//method for year split
            }

            if (headerType == headerValue.Month)
                proxy._calculateMonthSplit(startDate, endDate);//method for Month split

            if (headerType == headerValue.Day)
                proxy._calculateDaySplit(startDate, endDate);

            if (headerType == headerValue.Hour)
                proxy._calculateHourSplit(startDate, endDate);
        },
        //AddNested Gantt Records
        _addNestedGanttRecords: function (data) {
            var proxy = this,
               
                ids = proxy.model.ids,
                model = proxy.model,
                ganttRecords = model.flatRecords,
                count = 0,
                length = data.length,
                records = [],
                record,
                enableAltRow = model.enableAltRow;
            
            for (count; count < length; count++) {
                record = data[count];
                proxy._storedIndex++;
                //if (enableAltRow)
                record.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                record.index = proxy._storedIndex;
              
                ids[proxy._storedIndex] = record["taskId"].toString();
                ganttRecords.push(record);
                records = record.childRecords;
                if (records) {
                    var j = 0, recordlength = records.length, childGanttRecord = null;
                    for (j; j < recordlength; j++) {
                        childGanttRecord = records[j];
                        proxy._storedIndex++;
                        //if (enableAltRow)
                        childGanttRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                        childGanttRecord.index = proxy._storedIndex;
                     
                        ids[proxy._storedIndex] = childGanttRecord["taskId"].toString();
                        ganttRecords.push(childGanttRecord);
                        childGanttRecord.childRecords && proxy._addNestedGanttRecords(childGanttRecord.childRecords);
                    }
                }

            }
            
        },
        //returns gantt record from data
        _createGanttRecord: function (data, level, parentItem, expanded, creatAt) {
            var proxy = this, ganttRecord, model = proxy.model,
                columnRecords = proxy._columns, columnRecordsLength = columnRecords.length,
                child = data[model.childMapping],
                duration = !ej.isNullOrUndefined(data[model.durationMapping]) ? data[model.durationMapping] : null,
                status = data[model.progressMapping] ? (!isNaN(parseFloat(data[model.progressMapping])) ? parseFloat(data[model.progressMapping]) : 0) : 0,
                startDateType = proxy._getDateFromFormat(data[model.startDateMapping]),
                endDateType = proxy._getDateFromFormat(data[model.endDateMapping]),
                work = !ej.isNullOrUndefined(data[model.workMapping]) ? data[model.workMapping] : null,
                resourceInfo = data[model.resourceInfoMapping],
                predecessors = data[model.predecessorMapping],
                notes = data[model.notesMapping],
                baselineStartDateType = proxy._getDateFromFormat(data[model.baselineStartDateMapping]),
                baselineEndDateType = proxy._getDateFromFormat(data[model.baselineEndDateMapping]),
                WBS_Val = data["WBS"] ? data["WBS"] : null,
                autoSchedule_val = (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Auto) ? true :
                                    (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Manual) ? false :
                                    (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Custom) ? data[model.taskSchedulingModeMapping] == true ? false : true :
                                    model.taskSchedulingMode,
                resourceName = [],
                predecessorscol = [],
                durationUnit = (model.durationUnitMapping && data[model.durationUnitMapping]) ? proxy._validateDurationUnitMapping(data[model.durationUnitMapping]) : null,
                isMilesStone = model.milestoneMapping && data[model.milestoneMapping];

            var sTime = startDateType ? new Date(startDateType.getFullYear(), startDateType.getMonth(),
                startDateType.getDate(), startDateType.getHours(), startDateType.getMinutes()).getTime() : null,
                eTime = endDateType ? new Date(endDateType.getFullYear(), endDateType.getMonth(),
                endDateType.getDate(), endDateType.getHours(), endDateType.getMinutes()).getTime() : null;

            ganttRecord = new ej.Gantt.GanttRecord();
            ganttRecord.taskId = data[model.taskIdMapping];
            ganttRecord.taskName = data[model.taskNameMapping];
            proxy._addItemValue(ganttRecord, data, creatAt);
            ganttRecord.isAutoSchedule = autoSchedule_val;            
            ganttRecord.startDate = this._checkStartDate(startDateType, ganttRecord);
            var resourceCollection = proxy._isinAddnewRecord ? proxy._newRecordResourceCollection : model.resources;
            ganttRecord.resourceInfo = resourceInfo && ganttRecord._setResourceInfo(data[(model.resourceInfoMapping)], model.resourceIdMapping, model.resourceNameMapping, model.resourceUnitMapping, resourceCollection);
            proxy._updateResourceName(ganttRecord);
            //Update duration and endDate by miles stone mapping
            if (!ej.isNullOrUndefined(isMilesStone) && isMilesStone) {
                ganttRecord.duration = 0;
                ganttRecord.durationUnit = durationUnit;
                ganttRecord.isMilestone = true;
                ganttRecord.endDate = new Date(ganttRecord.startDate);
            }
            else if (model.workMapping) {
                ganttRecord.durationUnit = model.durationUnit;
                if (isNaN(work) || ej.isNullOrUndefined(work)) {
                    ganttRecord.work = 0;
                    ganttRecord.duration = 0;
                    ganttRecord.isMilestone = true;
                    ganttRecord.endDate = new Date(ganttRecord.startDate);
                }
                else {
                    ganttRecord.work = work;
                    ganttRecord._updateDurationWithWork(proxy);
                    if (ganttRecord.duration == 0) {
                        ganttRecord.isMilestone = true;
                        ganttRecord.endDate = new Date(ganttRecord.startDate);
                    } else
                        ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                }
                if (!ej.isNullOrUndefined(data[model.durationMapping]))
                    data[model.durationMapping] = ganttRecord.duration;
                if (!ej.isNullOrUndefined(data[model.durationMapping]))
                    data[model.endDateMapping] = ganttRecord.endDate;
            }
                //validate duration value
            else if (!ej.isNullOrUndefined(duration)) {
                var retrunVal = this._getDurationValues(duration);
                ganttRecord.duration = retrunVal.duration;
                ganttRecord.durationUnit = durationUnit ? durationUnit : retrunVal.durationUnit;
                if (ganttRecord.duration == 0) {
                    ganttRecord.isMilestone = true;
                    ganttRecord.endDate = new Date(ganttRecord.startDate);
                } else
                    ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
            } else if (endDateType) {
                //If No hour information on endate default end time is set
                if (endDateType.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, endDateType);
                ganttRecord.endDate = this._checkEndDate(endDateType, ganttRecord);
                if (ganttRecord.startDate.getTime() >= ganttRecord.endDate.getTime()) {
                    ganttRecord.endDate = new Date(ganttRecord.startDate);
                    ganttRecord.isMilestone = true;
                    ganttRecord.duration = 0;
                } else
                    ganttRecord.duration = this._getDuration(ganttRecord.startDate, ganttRecord.endDate, model.durationUnit, ganttRecord.isAutoSchedule);
                ganttRecord.durationUnit = model.durationUnit;
            } else if (!endDateType && ej.isNullOrUndefined(duration)) {
                ganttRecord.isMilestone = true;
                ganttRecord.duration = 0;
                ganttRecord.endDate = new Date(ganttRecord.startDate);
            }
            ganttRecord.baselineStartDate = this._checkBaseLineStartDate(baselineStartDateType);
            //If No hour information on endate default end time is set
            if (baselineEndDateType && baselineEndDateType.getHours() == 0 && this._defaultEndTime != 86400)
                this._setTime(this._defaultEndTime, baselineEndDateType);
            ganttRecord.baselineEndDate = this._checkBaseLineEndDate(baselineEndDateType);
            ganttRecord.WBS = WBS_Val;
            ganttRecord.notes = notes;
            ganttRecord["notesText"] = notes ? proxy._getPlainText(notes) : "";

            // updating Gantt record for custom columns while adding new row
            if (columnRecordsLength) {
                for (var i = 0; i < columnRecordsLength; i++) {
                    if (ganttRecord[columnRecords[i].field] == undefined)
                        ganttRecord[columnRecords[i].field] = data[columnRecords[i].mappingName];
                }
            }

            ganttRecord.status = status,
            ganttRecord.predecessor = predecessors && ganttRecord._calculatePredecessor(predecessors, this._durationUnitEditText, model.durationUnit);
            ganttRecord.predecessorsName = predecessors;
            ganttRecord.parentItem = parentItem;
            ganttRecord.level = level;

            if (!creatAt) {
                ganttRecord.width = ganttRecord._calculateWidth(this);
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, status);

                if (ganttRecord.baselineStartDate && ganttRecord.baselineEndDate) {
                    ganttRecord.baselineLeft = ganttRecord._calculateBaselineLeft(this);
                    ganttRecord.baselineRight = ganttRecord._calculateBaselineRight(this);
                    ganttRecord.baselineWidth = ganttRecord._calculateBaseLineWidth(this);
                }
            }
            proxy._updateItemValueInRecord(ganttRecord);
            ganttRecord.childRecords = (child && child.length > 0) && proxy._createChildRecords(child, level + 1, ganttRecord),
            ganttRecord.hasChildRecords = (child && child.length > 0) ? true : false,
            ganttRecord.isMilestone = ganttRecord.hasChildRecords ? false : ganttRecord.isMilestone;
            if (model.expandStateMapping && ganttRecord.hasChildRecords) {
                if (!ej.isNullOrUndefined(data[model.expandStateMapping])) {
                    ganttRecord[model.expandStateMapping] = ganttRecord.item[model.expandStateMapping] = data[model.expandStateMapping];
                } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && !model.enableCollapseAll) {
                    ganttRecord[model.expandStateMapping] = ganttRecord.item[model.expandStateMapping] = data[model.expandStateMapping] = true;
                } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && model.enableCollapseAll) {
                    ganttRecord[model.expandStateMapping] = ganttRecord.item[model.expandStateMapping] = data[model.expandStateMapping] = false;
                }
            }
            ganttRecord.expanded = expanded !== undefined ? expanded : child ? child.length > 0 : false;
            if (model.enableVirtualization === false) {
                ganttRecord.isExpanded = true;
            }
            if (ganttRecord.hasChildRecords) {                               
                ganttRecord.manualStartDate = ganttRecord.startDate;
                ganttRecord.manualEndDate = ganttRecord.endDate;                
                ganttRecord.manualDuration = ganttRecord.duration;                
            }            
            ganttRecord.taskType = data.taskType ? data.taskType : model.taskType;
            ganttRecord.effortDriven = data.effortDriven ? data.effortDriven : ganttRecord.taskType != "fixedWork" ? "false" : "true";           
            //Calculate total works for this record.
            if (!model.workMapping)
                ganttRecord._updateWorkWithDuration(proxy);
            if (predecessors)
                proxy._predecessorsCollection.push(ganttRecord);
            return ganttRecord;
        },
        /*Validate duration unit value from data source*/
        _validateDurationUnitMapping: function (value) {
            var durationUnit = value;
            if (this._durationUnitEditText.minute.indexOf(durationUnit) != -1)
                durationUnit = ej.Gantt.DurationUnit.Minute;
            else if (this._durationUnitEditText.hour.indexOf(durationUnit) != -1)
                durationUnit = ej.Gantt.DurationUnit.Hour;
            else if (this._durationUnitEditText.day.indexOf(durationUnit) != -1)
                durationUnit = ej.Gantt.DurationUnit.Day;
          
            if (durationUnit == ej.Gantt.DurationUnit.Day || durationUnit == ej.Gantt.DurationUnit.Hour || durationUnit == ej.Gantt.DurationUnit.Minute)
                return durationUnit;
            else
                return this.model.durationUnit;
        },
        //Start date,end date and duration are validated update this value in data source
        _updateItemValueInRecord: function (ganttRecord) {
            var model = this.model;
            if (ganttRecord.item) {
                var data = ganttRecord.item;
                if (model.startDateMapping)
                    data[model.startDateMapping] = ganttRecord.startDate;
                if (model.endDateMapping)
                    data[model.endDateMapping] = ganttRecord.endDate;
                if (model.durationMapping)
                    data[model.durationMapping] = ganttRecord.duration;
                if (model.durationUnitMapping)
                    data[model.durationUnitMapping] = ganttRecord.durationUnit;
                if (model.workMapping)
                    data[model.workMapping] = ganttRecord.work;
                if (model.taskSchedulingModeMapping)
                    data[model.taskSchedulingModeMapping] = !ganttRecord.isAutoSchedule;
            }
        },
        _addItemValue: function (ganttRecord, data, creatAt) {
            var proxy = this, model = this.model;
            //add item value in Gantt record

            if (model.parentTaskIdMapping && creatAt) {
                var id = data[model.taskIdMapping],
                   index = proxy._taskIds.indexOf(id);
                ganttRecord.item = (index > -1) ? proxy._retrivedData[index] : [];
            }
            else {
                if (this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.json && this.dataSource().dataSource.offline && creatAt) {

                    if (model.parentTaskIdMapping) {
                        var id = data[model.taskIdMapping],
                            index = proxy._taskIds.indexOf(id);
                        ganttRecord.item = (index > -1) ? proxy._retrivedData[index] : [];
                    } else {
                        ganttRecord.item = data;
                    }
                }
                else {
                    ganttRecord.item = data;
                }
            }
        },

        //Get the plain text from html string
        _getPlainText: function (htmlString) {
            var div = document.createElement("DIV");
            div.innerHTML = htmlString;
            return div.textContent || div.innerText || "";
        },

        /* udpate resourceNames attribute of record*/
        _updateResourceName: function (ganttRecord) {
            var proxy = this, resourceInfo = ganttRecord.resourceInfo,
                resourceName = [], length;

            if (resourceInfo) {
                length = resourceInfo.length;
                ganttRecord.item ? ganttRecord.item[this.model.resourceInfoMapping] = [] : null;
                 for (var i = 0; i < length; i++){
                     resourceName.push(resourceInfo[i][this.model.resourceNameMapping]);
                     if (ganttRecord.item)
                         ganttRecord.item[this.model.resourceInfoMapping].push(resourceInfo[i][this.model.resourceIdMapping]);
                 }
                 ganttRecord.resourceNames = resourceName.join(',');
             }
        },
        //Update duration, work or unit of a resource according with the changes.
        _updateResourceRelatedFields: function (ganttRecord) {
            var proxy = this, model = proxy.model, updatedWorks,
                calculationType = ganttRecord.taskType,
                isAutoSchedule = ganttRecord.isAutoSchedule,
                isEffortDriven = (ganttRecord.effortDriven === "true"); //Convert String true/false to boolean.

            if (!ej.isNullOrUndefined(ganttRecord.resourceInfo)) {
                if (ganttRecord.work > 0 || proxy._updatedColumn == "work") {
                    switch (calculationType) {
                        case "fixedUnit":
                            if (isAutoSchedule && ganttRecord.resourceInfo.length &&
                                (proxy._updatedColumn == "work" ||
                                (isEffortDriven && proxy._updatedColumn == "resourceInfo")))
                                ganttRecord._updateDurationWithWork(proxy);

                            else if (!isAutoSchedule && proxy._updatedColumn == "work")
                                ganttRecord._updateUnitWithWork(proxy);

                            else
                                ganttRecord._updateWorkWithDuration(proxy);
                            break;
                        case "fixedWork":
                            if (ganttRecord.resourceInfo.length == 0)
                                return;
                            else if (isAutoSchedule) {
                                if (proxy._updatedColumn == "duration" || proxy._updatedColumn == "endDate") {
                                    ganttRecord._updateUnitWithWork(proxy);
                                    if (ganttRecord.duration == 0) {
                                        ganttRecord.work = 0;
                                        if (model.workMapping)
                                            ganttRecord.item[model.workMapping] = 0;
                                    }
                                }
                                else
                                    ganttRecord._updateDurationWithWork(proxy);
                            }
                            else {
                                if (proxy._updatedColumn == "work")
                                    ganttRecord._updateUnitWithWork(proxy);
                                else
                                    ganttRecord._updateWorkWithDuration(proxy);
                            }
                            break;
                        case "fixedDuration":                                                       
                            if (ganttRecord.resourceInfo.length && (proxy._updatedColumn == "work" ||
                                (isAutoSchedule && isEffortDriven && proxy._updatedColumn == "resourceInfo")))
                                ganttRecord._updateUnitWithWork(proxy);
                            else
                                ganttRecord._updateWorkWithDuration(proxy);
                            break;
                    }
                }
                else 
                    ganttRecord._updateWorkWithDuration(proxy);
            }
        },

        //Dynamically update resource treegrid datasource in resource tab of edit dialog box, according with changes in other resource related fields.
        _updateResourceDataSource: function (editedObj) {
            var proxy = this, resourceData = [],
                length = editedObj.resourceInfo ? editedObj.resourceInfo.length : 0;
            for (var i = 0; i < length; i++) {
                resourceData.push({ "name": editedObj.resourceInfo[i][proxy.model.resourceIdMapping], "unit": editedObj.resourceInfo[i][proxy.model.resourceUnitMapping] });
            }
            var resourceTreeGridId = "#treegrid" + proxy._id + "resourceEdit",
                resourceTreeGridDataSource = $(resourceTreeGridId).data("ejTreeGrid").model.dataSource;

            for (var index = 0; index < resourceTreeGridDataSource.length; index++) {
                var resource = resourceData.filter(function (data) { return data.name === parseInt(resourceTreeGridDataSource[index].name); });
                if (resource && resource.length == 0)
                    resourceData.push(resourceTreeGridDataSource[index]);
            }

            $(resourceTreeGridId).ejTreeGrid("option", "dataSource", resourceData);
        },
        _getHoliday: function () {
            if (this.model.holidays != null) {
                var holidayList = this.model.holidays,
                    holidays = [],
                    holidayLength = holidayList.length;
                if (holidayLength > 0) {
                    for (var i = 0; i < holidayLength; i++) {
                        holidays[i] = this._getDateFromFormat(holidayList[i].day);
                    }
                    return holidays;
                }
            }
            return false;
        },

        _getStringHolidays: function() {
            if (this._holidaysList != null && this._holidaysList.length > 0) {
                var holidayList = this._holidaysList,
                    holidays = [],
                    holidayLength = holidayList.length;
                if (holidayLength > 0) {
                    for (var i = 0; i < holidayLength; i++) {
                        holidays[i] = ej.format(holidayList[i], this.model.dateFormat, this.model.locale);
                    }
                    return holidays;
                }
            }
            return [];
        },
        
        //create childRecords for particular GanttRecord
        _createChildRecords: function (data, level, parentItem) {
            var ganttRecords = [],
                proxy = this, model = proxy.model,
                i = 0,
                length = data.length;

            for (i = 0; i < length; i++) {
                if (model.enableWBS) {
                    var parentWBS = parentItem.WBS;
                    data[i]["WBS"] = parentWBS + "." + (i + 1);
                }
                if (data[i]) {
                    var parentRecord = proxy._createGanttRecord(data[i], level, parentItem,undefined,"Load");
                    ganttRecords.push(parentRecord);
                }
            }
            return ganttRecords;
        },

        _createResourceInfoCollection: function (data) {
            var proxy = this,
                count = 0,
                length = data.length;
            for (count; count < length; count++) {
                proxy._resourceInfoCollection.push(proxy._createResourceInfo(data[count]));
            }
        },

        _createResourceInfo: function (data) {
            var model = this.model, resourceInfo = {};
            resourceInfo.resourceId = data[model.resourceIdMapping];
            resourceInfo.resourceName = data[model.resourceNameMapping];
            return resourceInfo;
        },

        _calculateWeekSplit: function (startdate, enddate) {
            var proxy = this,model=proxy.model,
                weekStartDay = model.scheduleHeaderSettings.weekStartDay;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") 
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") 
                var dt = new Date(startdate.getFullYear(), 0, 1);
            else
                var dt = startdate;
            startdate = dt;
            var dayIndex = (weekStartDay >= 0 && weekStartDay < 7) ? weekStartDay : 0,
                roundOffStartDate = startdate.getDay() <= dayIndex ? (startdate.getDate()) - (7 - dayIndex + startdate.getDay()) :
              (startdate.getDate()) - startdate.getDay() + dayIndex;
            startdate.setDate(roundOffStartDate);
            startdate.setHours(0, 0, 0, 0);
            do {
                proxy._scheduleWeeks.push(new Date(startdate));
                startdate.setDate(startdate.getDate() + 7);
            } while (!(startdate > enddate));

            proxy._projectStartDate= new Date(proxy._scheduleWeeks[0]);
            proxy._projectEndDate = new Date(proxy._scheduleWeeks[proxy._scheduleWeeks.length - 1]);
        },

        //method for calculatting years (year-month schedule mode)
        _calculateYearSplit: function (startdate, enddate) {
            var proxy = this, model=proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;
                do {
                    proxy._scheduleYears.push(new Date(startdate));
                    startdate = new Date(startdate.getFullYear() + 1, 0, 1);
                } while (!(startdate >= enddate));
                var projectStartDate, projectEndDate;
                proxy._projectStartDate = new Date(proxy._scheduleYears[0].getFullYear(), proxy._scheduleYears[0].getMonth(), 1);
                proxy._projectEndDate = new Date(proxy._scheduleYears[proxy._scheduleYears.length - 1].getFullYear(), 11, 31);
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                  (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
                do {
                    proxy._scheduleYears.push(new Date(startdate));
                    if (startdate.getDate() == 29 && startdate.getMonth() == 0 && startdate.getFullYear() % 4 != 0)
                        startdate = new Date(startdate.getFullYear()+1, startdate.getMonth(), startdate.getDate() - 1);
                    else
                        startdate = new Date(startdate.getFullYear()+1, startdate.getMonth(), startdate.getDate());
                } while (!(startdate >= enddate));
                var projectStartDate, projectEndDate;
                proxy._projectStartDate = new Date(proxy._scheduleYears[0]);
                proxy._projectEndDate = new Date(proxy._scheduleYears[proxy._scheduleYears.length - 1].getFullYear(), 11, 31);
            }
            else {
                startdate.setMonth(0);
                startdate.setDate(1);
                startdate.setHours(0, 0, 0, 0);
                do {
                    proxy._scheduleYears.push(new Date(startdate));
                    startdate.setMonth(startdate.getMonth() + 12);
                } while (!(startdate >= enddate));
                var projectStartDate, projectEndDate;
                proxy._projectStartDate = new Date(proxy._scheduleYears[0].getFullYear(), proxy._scheduleYears[0].getMonth(), 1);
                proxy._projectEndDate = new Date(proxy._scheduleYears[proxy._scheduleYears.length - 1].getFullYear(), 11, 31);
            }        

           
        },

        //Method for calculating days (day-hour schedule mode)
        _calculateDaySplit: function (startdate, enddate) {
            var proxy = this, model=proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                    (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") {
                var dt = new Date(startdate.getFullYear(), 0, 1);
                startdate = dt;
            }
            else {
                startdate.setHours(0, 0, 0, 0);
            }
            do {
                proxy._scheduleDays.push(new Date(startdate));
                startdate.setDate(startdate.getDate() + 1);
            } while ((startdate <= enddate));
            proxy._projectStartDate = new Date(proxy._scheduleDays[0]);
            proxy._projectEndDate = new Date(proxy._scheduleDays[proxy._scheduleDays.length - 1]);
        },

        //Method for calculating hours (Hour-Minute schedule mode)
        _calculateHourSplit: function (startdate, enddate) {
            var proxy = this, model=proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                    (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;               
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") {
                var dt = new Date(startdate.getFullYear(), 0, 1);
                startdate = dt;
            }
            else {
                startdate.setMinutes(0);              
            }
            do {
                proxy._scheduleHours.push(new Date(startdate));
                startdate.setHours(startdate.getHours() + 1);
            } while (startdate <= enddate);
            proxy._projectStartDate = new Date(proxy._scheduleHours[0]);          
            proxy._projectEndDate = new Date(proxy._scheduleHours[proxy._scheduleHours.length - 1]);
        },
        //new method for calculatting months
        _calculateMonthSplit: function (startdate, enddate) {
            var proxy = this, model = proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                   (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
                do {
                    proxy._scheduleMonths.push(new Date(startdate));
                    if (startdate.getDate() == 29 && startdate.getMonth() == 0 && startdate.getFullYear() % 4 != 0)
                        startdate = new Date(startdate.getFullYear(), startdate.getMonth() + 1, startdate.getDate() - 1);
                    else
                        startdate = new Date(startdate.getFullYear(), startdate.getMonth() + 1, startdate.getDate());
                } while (!(startdate >= enddate));
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") {
                var dt = new Date(startdate.getFullYear(), 0, 1);
                startdate = dt;
                do {
                    proxy._scheduleMonths.push(new Date(startdate));
                    if (startdate.getMonth() == 0 || startdate.getMonth() == 2 || startdate.getMonth() == 4 || startdate.getMonth() == 6 || startdate.getMonth() == 7 || startdate.getMonth() == 9 || startdate.getMonth() == 11)
                        startdate.setDate(startdate.getDate() + 31);
                    else if (startdate.getMonth() == 3 || startdate.getMonth() == 5 || startdate.getMonth() == 8 || startdate.getMonth() == 10)
                        startdate.setDate(startdate.getDate() + 30);
                    else if (startdate.getMonth() == 1) {
                        if (startdate.getFullYear() % 4 == 0)
                            startdate.setDate(startdate.getDate() + 29);
                        else
                            startdate.setDate(startdate.getDate() + 28);
                    }
                } while (!(startdate >= enddate));
            }
            else {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;
                do {
                    proxy._scheduleMonths.push(new Date(startdate));
                    if (startdate.getMonth() == 0 || startdate.getMonth() == 2 || startdate.getMonth() == 4 || startdate.getMonth() == 6 || startdate.getMonth() == 7 || startdate.getMonth() == 9 || startdate.getMonth() == 11)
                        startdate.setDate(startdate.getDate() + 31);
                    else if (startdate.getMonth() == 3 || startdate.getMonth() == 5 || startdate.getMonth() == 8 || startdate.getMonth() == 10)
                        startdate.setDate(startdate.getDate() + 30);
                    else if (startdate.getMonth() == 1) {
                        if (startdate.getFullYear() % 4 == 0)
                            startdate.setDate(startdate.getDate() + 29);
                        else
                            startdate.setDate(startdate.getDate() + 28);
                    }
                } while (!(startdate >= enddate));
            }

            var projectStartDate, projectEndDate;
            projectStartDate = new Date(proxy._scheduleMonths[0]);
            projectEndDate = new Date(proxy._scheduleMonths[proxy._scheduleMonths.length - 1]);
            projectEndDate = new Date(projectEndDate.getFullYear(), projectEndDate.getMonth() + 1, 0);
            proxy._projectStartDate = projectStartDate;
            proxy._projectEndDate = projectEndDate;
        },



        _updatePredecessors: function () {
            var proxy = this,
                count = 0,
                predecessorsCollection = proxy._predecessorsCollection,
                length = predecessorsCollection.length,
                ganttRecord,
                connectorsCollection,
            i = 0,
            successorGanttRecord,
            connectorCount;
            for (count; count < length; count++) {
                ganttRecord = predecessorsCollection[count];
                connectorsCollection = ganttRecord["predecessor"];
                connectorCount = connectorsCollection.length;
                for (i=0; i < connectorCount; i++) {
                    var connector = connectorsCollection[i];
                    successorGanttRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(connector.from)];
                    if (connector.from !== ganttRecord.taskId.toString()) {
                        if (successorGanttRecord) {
                            if (successorGanttRecord.predecessor) {
                                successorGanttRecord.predecessor.push(connector);
                            } else {
                                successorGanttRecord.predecessor = [];
                                successorGanttRecord.predecessor.push(connector);
                                predecessorsCollection.push(successorGanttRecord);
                            }
                        }
                    }

                }                
            }
        },
        
        getDateType: function (date) {
            if (date != null) {
                if (typeof (date) == "object") {
                    return date;
                }
                else {
                    var hyphenRegex = new RegExp("\\-", "g"),
                    dotRegex = new RegExp("\\.", "g");
                    date = date.replace(hyphenRegex, "/");
                    date = date.replace(dotRegex, "/");
                    return new Date(date);
                }
            }
            return null;
        },

        getFormatedDate: function(date) {
            return ej.format(date, this.model.dateFormat, this.model.locale);
        },

        _getProgressWidth: function (parentwidth, percent) {
            return (parentwidth * percent) / 100;
        },

        
        _wireEvents: function () {
            var proxy = this,
                model=proxy.model,
                treeGrid = $("#ejTreeGrid" + proxy._id),
                ganttChart = $("#ejGanttChart" + proxy._id),
                gantt = proxy._$ejGantt;

            proxy._on(proxy.element, "click", proxy.clickHandler);
            proxy._on(proxy.element, "click", ".e-ejinputtext", proxy._searchTextFocusIn);
            proxy._on(proxy.element, "focusout", ".e-ejinputtext", proxy._searchTextFocusOut);
            if (model.enableContextMenu) {
                proxy._on(proxy.element, "contextmenu", proxy._rightClick);
                proxy._on(proxy.element, "keyup", this._preventContextMenu);
            }

            if (model.enableResize && model.isResponsive) {
                proxy._on($(window), "resize", proxy.windowResize);
            }

            treeGrid.ejTreeGrid({ rowSelecting: $.proxy(proxy.rowSelecting, proxy) });
            treeGrid.ejTreeGrid({ rowSelected: $.proxy(proxy.rowSelected, proxy) });
            treeGrid.ejTreeGrid({ cellSelecting: $.proxy(proxy.cellSelecting, proxy) });
            treeGrid.ejTreeGrid({ cellSelected: $.proxy(proxy.cellSelected, proxy) });
            //treeGrid.ejTreeGrid({ rowHover: $.proxy(proxy._treeGridRowHover, proxy) });
            treeGrid.ejTreeGrid({ rowDrag: $.proxy(proxy.rowDrag, proxy) });
            treeGrid.ejTreeGrid({ rowDragStart: $.proxy(proxy.rowDragStart, proxy) });
            treeGrid.ejTreeGrid({ rowDragStop: $.proxy(proxy.rowDragStop, proxy) });
            treeGrid.ejTreeGrid({ actionBegin: $.proxy(proxy.actionBegin, proxy) });
            treeGrid.ejTreeGrid({ actionComplete: $.proxy(proxy.actionComplete, proxy) });
            treeGrid.ejTreeGrid({ expandAllCollapseAllRequest: $.proxy(proxy.expandAllCollapseAllRequest, proxy) });
            treeGrid.ejTreeGrid({ contextMenuAction: $.proxy(proxy.contextMenuAction, proxy) });
            treeGrid.ejTreeGrid({ subContextMenuAction: $.proxy(proxy.subContextMenuAction, proxy) });
            treeGrid.ejTreeGrid({ setInitialData: $.proxy(proxy.setInitialData, proxy) });
            

            if (model.queryCellInfo) {
                treeGrid.ejTreeGrid({ queryCellInfo: $.proxy(proxy._queryCellInfo, proxy) });
            }
            
            if (model.rowDataBound) {
                treeGrid.ejTreeGrid({ rowDataBound: $.proxy(proxy._rowDataBound, proxy) });
            }
            
            treeGrid.ejTreeGrid({ beginEdit: $.proxy(proxy._beginEdit, proxy) });
            treeGrid.ejTreeGrid({ endEdit: $.proxy(proxy._endEdit, proxy) });            
            
            treeGrid.ejTreeGrid({ expanding: $.proxy(proxy.expanding, proxy) });
            treeGrid.ejTreeGrid({ collapsing: $.proxy(proxy.collapsing, proxy) });
            treeGrid.ejTreeGrid({ expanded: $.proxy(proxy.expanded, proxy) });
            treeGrid.ejTreeGrid({ collapsed: $.proxy(proxy.collapsed, proxy) });
            treeGrid.ejTreeGrid({ refreshRow: $.proxy(proxy.refreshRow, proxy) });
            treeGrid.ejTreeGrid({ cancelEditCell: $.proxy(proxy.cancelEditCell, proxy) });
            
            
            ganttChart.ejGanttChart({ rowSelecting: $.proxy(proxy.rowSelecting, proxy) });
            ganttChart.ejGanttChart({ rowSelected: $.proxy(proxy.rowSelected, proxy) });
            ganttChart.ejGanttChart({ rowHover: $.proxy(proxy._ganttChartRowHover, proxy) });
            ganttChart.ejGanttChart({ actionBegin: $.proxy(proxy.actionBegin, proxy) });
            ganttChart.ejGanttChart({ actionComplete: $.proxy(proxy.chartactionComplete, proxy) });
            ganttChart.ejGanttChart({ refreshRow: $.proxy(proxy.refreshRowData, proxy) }); 
            ganttChart.ejGanttChart({ zooming: $.proxy(proxy.zoomingChart, proxy) });
            ganttChart.ejGanttChart({ queryTaskbarInfo: $.proxy(proxy.queryTaskbarInfo, proxy) });
            ganttChart.ejGanttChart({ expanding: $.proxy(proxy.expanding, proxy) });
            ganttChart.ejGanttChart({ collapsing: $.proxy(proxy.collapsing, proxy) });
            ganttChart.ejGanttChart({ expanded: $.proxy(proxy.expanded, proxy) });
            ganttChart.ejGanttChart({ collapsed: $.proxy(proxy.collapsed, proxy) });
            ganttChart.ejGanttChart({ expandAllCollapseAllRequest: $.proxy(proxy.expandAllCollapseAllRequest, proxy) });
            ganttChart.ejGanttChart({ taskbarEditing: $.proxy(proxy.taskbarEditing, proxy) });
            ganttChart.ejGanttChart({ taskbarEdited: $.proxy(proxy.taskbarEdited, proxy) });
            ganttChart.ejGanttChart({ calculateEndDate: $.proxy(proxy.calculateEndDate, proxy) });
            ganttChart.ejGanttChart({ calculateDuration: $.proxy(proxy.calculateDuration, proxy) });
            ganttChart.ejGanttChart({ clearColumnMenu: $.proxy(proxy.clearColumnMenu, proxy) });
            ganttChart.ejGanttChart({ deleteRow: $.proxy(proxy.deleteRow, proxy) });
            ganttChart.ejGanttChart({ cancelEditCell: $.proxy(proxy.cancelEditCell, proxy) });
            gantt.ejSplitter({ allowResizing: $.proxy(proxy._onResize, proxy) });
            proxy._on(proxy.element, "mousedown", proxy._mousedownhandler);
            proxy._enableEditingEvents();
        },
 
        /* prevent context menu action by menu option key*/
        _preventContextMenu: function (e) {
            if (e.keyCode == 93) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }
        },
        _onResize: function (args) {
            var proxy = this,
                isPercentage = false,
                splitterPosition = proxy.splitterPosition();
            /* cancel edited cell in treegrid while resize the splitter*/
            if (proxy._isinBeginEdit) {
                if ($("#ejTreeGrid" + proxy._id + "EditForm").length > 0) {
                    proxy._$treegridHelper.ejTreeGrid("cancelEditCell");
                    proxy._isinBeginEdit = false;
                }
            }
            if (splitterPosition.indexOf("%") != -1) 
                isPercentage = true;
            else 
                isPercentage = false;
            if (isPercentage)
                proxy.splitterPosition(Math.round(args.prevPane.size / proxy._ganttWidth * 100)+ "%");
            else
                proxy.splitterPosition(Math.round(args.prevPane.size).toString());
            proxy._splitterPosition(proxy.splitterPosition());
            proxy._$treegridHelper.ejTreeGrid("refreshScroller", args.prevPane.size);
            proxy._$ganttchartHelper.ejGanttChart("refreshScroller", args.nextPane.size - 1);// chart content parent div added with 1px right border

        },
        _searchTextFocusOut: function (e) {
            var focus = 0;
            var proxy = this,searchTitle = this._toolboxTooltipTexts["searchTool"];
            var $target = $(e.target);
            if ($($target).closest('li') && $($target).closest('li').attr('id') == proxy._id + "_search") {
                $($target).attr("placeholder", searchTitle);
            }
        },
        _searchTextFocusIn: function (e) {
            var proxy = this;
            var $target = $(e.target);
            var attr = $($target).attr('placeholder');
            if ($target.hasClass("e-ejinputtext") && attr)
                $target.removeAttr('placeholder');
        },
        clickHandler: function (e) {
            var proxy = this;
            var $target = $(e.target);

            //if ($target.closest(".e-popup").length == 0 &&
            //  $target.closest(".e-rowcell").find("#" + proxy._id + "EditForm").length == 0) {
                
            //}


            proxy._clearContextMenu();

            //Skip the scroll bar click in Gantt.
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vhandlespace") || $target.hasClass("e-vdown"))
                return;
            if ($target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hup") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace"))
                return;            
            if (proxy._isinBeginEdit && document.getElementById(proxy._id).contains($target[0])) {

                if (!$target.closest('td').hasClass("e-editedcell") && !$target.hasClass('e-date') && !$target.hasClass('e-arrow') && !$target.hasClass('e-down-arrow') && $target.closest("form#ejTreeGrid" + proxy._id + "EditForm").length == 0
                    && $("#ejTreeGrid" + proxy._id + "EditForm").length > 0) {
                    proxy._$treegridHelper.ejTreeGrid("saveCell");
                    proxy._isinBeginEdit = false;
                }
            }
            proxy.clearColumnMenu();
        },

        windowResize: function (e) {

            if (!this.element.is(":visible")) {
                return;
            }

            var proxy = this,
                ejGanttSplit = ("#e-ejSpliter" + this._id),
                toolbar = ("#" + this._id + "_toolbarItems"),
                ganttchart = ("#ejGanttChart" + this._id),
                treegrid = ("#ejTreeGrid" + this._id),
                ganttbody = (".e-ganttviewerbodyContianer"),
                gantthead = (".e-ganttviewerheaderContainer"),
                treegridhelp = ("#ejTreeGrid" + this._id),
                treegridcontent = ("#ejTreeGrid" + this._id + "e-gridcontent"),
                sizeSettingsWidth = proxy.model.sizeSettings.width,
                sizeSettingsHeight = proxy.model.sizeSettings.height,
                elementStyleHeight = proxy.element[0].style.height,
                elementStyleWidth = proxy.element[0].style.width,
                width, height, maxScrollWidth;
            //Width calculation
            if ((sizeSettingsWidth && (typeof(sizeSettingsWidth) != "number" && sizeSettingsWidth.indexOf("%") != -1)) || elementStyleWidth.indexOf("%") != -1) {

                var ganttWidth = sizeSettingsWidth ? sizeSettingsWidth : elementStyleWidth;
                var containerWidth = $(proxy.element).parent().width() ? $(proxy.element).parent().width() : $(proxy.element).width();
                width = (containerWidth / 100) * parseInt(ganttWidth);
                
            }
            else
                width = $(proxy.element).width();
            if (proxy.splitterPosition().indexOf("%") == -1){
                var splitterPosition = parseInt(proxy.splitterPosition()) + 7 + 2; // here 7 is splitter width, 2 is border width
                proxy._ganttWidth = width = Math.max(width, splitterPosition);
            }
            else
                proxy._ganttWidth = width;
            //height calculation
            if ((sizeSettingsHeight && (typeof(sizeSettingsWidth) != "number" && sizeSettingsHeight.indexOf("%") != -1 )) || elementStyleHeight.indexOf("%") != -1) {
                var ganttHeight = sizeSettingsHeight ? sizeSettingsHeight : elementStyleHeight;
                var containerHeight = $(proxy.element).parent().height() ? $(proxy.element).parent().height() : $(proxy.element).height();
                var tempHeight;
                if ($(proxy.element).parent().height())
                    tempHeight = (containerHeight / 100) * parseInt(ganttHeight);
                else
                    tempHeight = $(proxy.element).height();
                height = tempHeight;
            }
            else
                height = $(proxy.element).height();

            //Exclude bordor from width and height
            height = height - proxy._totalBorderHeight;
            width = Math.round(width);

            var ganttWidth, treeGridWidth, top,left,
                toolbarHeight = $(toolbar).length ? $(toolbar).height() : 0;
            $(ejGanttSplit).css("width", width);
            $(ejGanttSplit).css("height", (height - toolbarHeight));
            $(ejGanttSplit).ejSplitter("refresh");
            if ($(toolbar).length) {
                $(toolbar).css("width", width);              
            }

            ganttWidth = $(ganttchart).width();
            treeGridWidth = $(treegrid).width();
            $(ganttchart).height(height - toolbarHeight);

            top = $(ganttbody).ejScroller("option", "scrollTop");
            left = $(ganttbody).ejScroller("option", "scrollLeft");
            //set height for scroller div
            $(ganttbody).ejScroller({
                width: ganttWidth,
                height: (height - toolbarHeight - $(gantthead).height() - parseInt($(gantthead).css("border-bottom-width"))),
            });
            $(ganttbody).ejScroller("refresh");
            maxScrollWidth = proxy._$ganttchartHelper.ejGanttChart("getMaxScrollWidth");
            if (left > maxScrollWidth)
                left = maxScrollWidth > 0 ? maxScrollWidth : 0;

            $(ganttbody).ejScroller("option", "scrollTop", top);
            $(ganttbody).ejScroller("option", "scrollLeft", left);

            $(treegridhelp).height(height - toolbarHeight);
            $(treegridcontent).height((height - toolbarHeight - $(gantthead).height() - proxy._totalBorderHeight));
            left = $(treegridcontent).ejScroller("option", "scrollLeft");
            //$(treegridcontent).ejScroller("destroy";
            $(treegridcontent).width(treeGridWidth);
            //$(treegridcontent).ejScroller({
            //    width: treeGridWidth,
            //    scrollTop: top,
            //    height: 0
            //});
            $(treegridcontent).ejScroller("refresh");
            maxScrollWidth = proxy._$treegridHelper.ejTreeGrid("getMaxScrollWidth");
            if (left > maxScrollWidth)
                left = maxScrollWidth > 0 ? maxScrollWidth : 0;

            $(treegridcontent).ejScroller("option", "scrollLeft", left);

            proxy._$treegridHelper.ejTreeGrid("updateViewPortHeight");
            proxy._$ganttchartHelper.ejGanttChart("updateViewPortHeight");
            if(proxy.model.enableVirtualization)
            {
                proxy._$treegridHelper.ejTreeGrid("cancelRowEditCell");                
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy._$treegridHelper.ejTreeGrid("processBindings", tempArgs);
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords);
                proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", top);
            }
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._updateRowHeightInConnectorLine(proxy._connectorLinesCollection);
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines", proxy._connectorLinesCollection);
            proxy.setSplitterPosition(proxy.splitterPosition());
        },
        _updateRowHeightInConnectorLine: function (collection) {
            if (collection && collection.length) {
                var chartObject = $("#ejGanttChart" + this._id).ejGanttChart("instance");
                var rowHeight1 = $("#" + chartObject._$ganttViewTablebody[0].id).find("tr:first")[0].getBoundingClientRect().height;
                if (rowHeight1 && !isNaN(rowHeight1)) {
                    for (var count = 0; count < collection.length; count++) {
                        collection[count].RowHeight = rowHeight1;
                    }
                }
            }
        },
        /* Public method for scroll to the corresponding offset value */
        setScrollTop: function (top) {
            var proxy = this,
                max = proxy._$treegridHelper.ejTreeGrid("getMaxScrollHeight");
            if (proxy._isinBeginEdit)
                proxy._$treegridHelper.ejTreeGrid("saveCell");

            if ((typeof top == "number" || typeof parseInt(top) == "number")) {
                top = parseInt(top);
                if (top >= 0) {
                    if (max >= top)
                        proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", top);
                    else
                        proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", max);
                }
            }
        },
        
        // handler for mouse right click
        _rightClick: function (e) {
            e.preventDefault();
            var proxy = this,
                model = proxy.model,
                $target = $(e.target),
                div = $target.closest('tr'),
                $ganttGridRows,
                row,
                recordIndexr,
                item,selectIndex, selectCellIndex,
                args = {};
            proxy._$treegridHelper.ejTreeGrid("disableTooltip");
            proxy.clearColumnMenu();
            if ($(div).hasClass("e-chartcell") || $(div).hasClass("e-ganttrowcell")) {
                $ganttGridRows = proxy._$ganttchartHelper.ejGanttChart("getGanttChartRows");
                args.target = "ejTreeGrid";
            } else {
                $ganttGridRows = $(proxy._$treegridHelper.ejTreeGrid("getRows"));
                args.target = "ejGanttChart";
            }
            row = $target.closest('tr');
            recordIndexr = $ganttGridRows.index(row);
            proxy.model.currentViewData = proxy.getCurrentViewData();
            item = proxy.model.currentViewData[recordIndexr];
            recordIndexr = proxy.model.updatedRecords.indexOf(item);
            args.data = item;
            args.recordIndex = recordIndexr;

            if (item && proxy.model.enableContextMenu) {
                proxy._contextMenuItems = [];
                proxy._contextMenuItems = proxy._getContextMenuItems();
                proxy._updateIndentOutdentContextmenuOption(item);
                proxy._clearContextMenu();
                if (proxy._contextMenuItems.length > 0) {
                    if (proxy.model.readOnly == true || !proxy.model.editSettings.allowAdding) {
                          proxy._removeContextMenuItem("Below");
                          proxy._removeContextMenuItem("Above");
                    }
                    proxy._renderContextMenu(e, recordIndexr, item);
                }
                if (model.selectionMode == "row") {
                if (recordIndexr != proxy.model.selectedRowIndex)
                    proxy.rowSelected(args);
                proxy._$treegridHelper.ejTreeGrid("selectRows", recordIndexr);
                proxy._$ganttchartHelper.ejGanttChart("selectRows", recordIndexr);
                proxy.updateIndentOutdentOption(args.data);
            }
                if (model.selectionMode == "cell")  {
                    proxy._rowIndexOfLastSelectedCell = recordIndexr;
                    selectCellIndex = proxy._$treegridHelper.ejTreeGrid("getCellIndex", e);
                    if (!$($target.closest('td')).hasClass("e-chartcell"))
                        proxy.selectCells([{ rowIndex: recordIndexr, cellIndex: selectCellIndex }]);
                }
                //To save edited data when beginEditAction as "click"
                if (model.editSettings.beginEditAction == "click" && $("#ejTreeGrid" + proxy._id + "EditForm").length > 0) {
                    proxy._$treegridHelper.ejTreeGrid("saveCell");
                    proxy._isinBeginEdit = false;
                }
            }
            else if (proxy.model.flatRecords.length === 0 && proxy.model.enableContextMenu) {
                proxy._contextMenuItems = [];
                proxy._contextMenuItems = proxy._getContextMenuItems();
                //remove subContextMenu Items
                proxy._contextMenuItems.splice(5, 2);
                proxy._updateIndentOutdentContextmenuOption(item);
                proxy._clearContextMenu();
                if (proxy._contextMenuItems.length > 0)
                    proxy._renderContextMenu(e, recordIndexr, item);
            }
        },
		 // Mouse down handler for gantt
        _mousedownhandler:function(e)
        {
            var $target = $(e.target),
            proxy = this;
            proxy._clearContextMenu();
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown") || $target.hasClass("e-vhandlespace") || $target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace") || $target.hasClass("e-splitbar")) {
                
                proxy.clearColumnMenu();
            }
        },
        
        //remove corresponding menu item in contextmenu collection by it menuId
        _removeContextMenuItem: function (id) {
            var proxy = this,
                index, contextMenuItems = proxy._contextMenuItems,
                filteredMenuItem;

            filteredMenuItem = contextMenuItems.filter(function (value) {
                if (value.menuId === id)
                    return true;
            });

            if (filteredMenuItem.length > 0) {
                index = contextMenuItems.indexOf(filteredMenuItem[0]);
                contextMenuItems.splice(index, 1);
            }
        },

        //Update contextmenu item according to selected item and editSettings API values
        _updateIndentOutdentContextmenuOption: function (ganttRecord) {
            var proxy = this,
                model = proxy.model,
                flatRecords = this.model.flatRecords,
                recordIndex = flatRecords.indexOf(ganttRecord);
            if (proxy.model.readOnly == true) {
                proxy._removeContextMenuItem("Add");              
                proxy._removeContextMenuItem("Task");
                proxy._removeContextMenuItem("Delete");
                proxy._removeContextMenuItem("Indent");
                proxy._removeContextMenuItem("Outdent");
            }
            else {
                if (recordIndex === 0) {
                    proxy._removeContextMenuItem("Indent");
                    proxy._removeContextMenuItem("Outdent");
                }
                else if (recordIndex > 0) {
                    if (ganttRecord.level === 0) {
                        proxy._removeContextMenuItem("Outdent");
                    }
                    else {
                        var previousGanttRecord = flatRecords[recordIndex - 1];
                        if (ganttRecord.level - previousGanttRecord.level === 1) {
                            proxy._removeContextMenuItem("Indent");
                        }
                    }
                }
                else if (recordIndex < 0) {
                    proxy._removeContextMenuItem("Task");
                    proxy._removeContextMenuItem("Delete");
                    proxy._removeContextMenuItem("Indent");
                    proxy._removeContextMenuItem("Outdent");
                }

                if (!model.editSettings.allowAdding) {
                    proxy._removeContextMenuItem("Add");
                }

                if (!model.editSettings.allowDeleting) {
                    proxy._removeContextMenuItem("Delete");
                }

                if (!model.editSettings.allowEditing) {
                    proxy._removeContextMenuItem("Task");
                }
                if (!model.editSettings.allowIndent) {
                    proxy._removeContextMenuItem("Indent");
                    proxy._removeContextMenuItem("Outdent");
                }                
            }
        },
      
        queryTaskbarInfo: function (args) {        
            this._trigger("queryTaskbarInfo", args);
        },
        

        zoomingChart: function (args) {
            var proxy = this;
            proxy.reRenderChart(args.delta);
        },

        refreshRowData: function (args) {
            var proxy = this,
                treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            ej.TreeGrid.refreshRow(treegridObject, args.index);
        },

        expanding: function (args) {
            var proxy = this;           
            if (!proxy._trigger("expanding", args)) {
                if (proxy.model.enableVirtualization) {                    
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                } else {
                    proxy._isInExpandCollapse = true;
                    //If need refresh chart if record is added after searching or sorting
                    if (proxy._isRefreshAddedRecord) {
                        args.data.expanded = true;
                        proxy._$treegridHelper.ejTreeGrid("updateExpandStatus", args.data, true);
                        proxy._refreshChartAndGridRows();
                        proxy._isRefreshAddedRecord = false;
                        return;
                    }
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    proxy._isInExpandCollapse = false;

                }
                proxy.updateSelectedItemIndex();
            }
        },

        collapsing: function (args) {
            var proxy = this, model= this.model,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            if (!proxy._trigger("collapsing", args)) {
                if (proxy.model.enableVirtualization) {                    
                    ej.TreeGrid.sendExpandCollapseRequest(proxy,args);
                } else {
                    proxy._isInExpandCollapse = true;
                    //If need refresh chart if record is added after searching or sorting
                    if (proxy._isRefreshAddedRecord) {
                        args.data.expanded = false;
                        proxy._$treegridHelper.ejTreeGrid("updateExpandStatus", args.data, false);
                        proxy._refreshChartAndGridRows();
                        proxy._isRefreshAddedRecord = false;
                        return;
                    }
                    proxy._gridRows = proxy.getRows();
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    proxy._isInExpandCollapse = false;
                }
                var selectItem = proxy.selectedItem(), index;
                if (selectItem) {
                    var expanded = proxy.getExpandStatus(selectItem);
                    if (!expanded && !args.expanded) {
                        proxy._deSelectRowItem();
                        if (model.toolbarSettings.showToolbar) {
                            if (proxy.model.toolbarSettings.toolbarItems.indexOf("delete") !== -1) {
                                $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-deleteitem").parent()[0]);
                                if (proxy.model.toolbarSettings.toolbarItems.indexOf("indent") !== -1)
                                    $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-indent").parent()[0]);
                                if (proxy.model.toolbarSettings.toolbarItems.indexOf("outdent") !== -1)
                                    $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-outdent").parent()[0]);
                                if (proxy.model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)
                                    $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-edititem").parent()[0]);
                            }
                        }
                    }
                    else {
                        proxy.updateSelectedItemIndex();
                    }
                }
            }
        },

        refreshRow: function (args) {
            var proxy = this;
            proxy._$ganttchartHelper.ejGanttChart("refreshRow", args.recordIndex);
        },

        _enableEditingEvents: function () {
            var proxy = this,
                model = proxy.model;
            //To off the  event while changing the editSettings dynamically in setModel
            proxy._off($("#" + proxy._id + "_dialogEdit"),
                    "click keypress", "#EditDialog_" + proxy._id + "_Save ,#EditDialog_" + proxy._id + "_Cancel,#EditDialog_" + proxy._id + "_Delete", proxy._buttonClick);

            proxy._off($("#" + proxy._id + "_dialogAdd"),
               "click keypress", "#AddDialog_" + proxy._id + "_Save ,#AddDialog_" + proxy._id + "_Cancel", proxy._buttonClick);

            if (model.editSettings.allowEditing|| model.editSettings.editMode == "dialogTemplate" ||
                (model.toolbarSettings.showToolbar && ((model.editSettings.allowAdding && model.toolbarSettings.toolbarItems.indexOf("add") !== -1) ||
                    (model.editSettings.allowEditing && model.toolbarSettings.toolbarItems.indexOf("index") !== -1)))) {
                
                proxy._on($("#" + proxy._id + "_dialogEdit"),
                    "click keypress", "#EditDialog_" + proxy._id + "_Save ,#EditDialog_" + proxy._id + "_Cancel,#EditDialog_" + proxy._id + "_Delete", proxy._buttonClick);

                proxy._on($("#" + proxy._id + "_dialogAdd"),
                   "click keypress", "#AddDialog_" + proxy._id + "_Save ,#AddDialog_" + proxy._id + "_Cancel", proxy._buttonClick);
                // $(proxy.element).on("click", ".e-icon", $.proxy(proxy._buttonClick, proxy));
            }
        },
        
        cancelEditCell: function () {

            var proxy = this;
            if ($("#ejTreeGrid" + proxy._id + "EditForm").length > 0)
                proxy._$treegridHelper.ejTreeGrid("cancelEditCell");
        },

        _keyPressed: function (action, target, e) {
        },

        _buttonClick: function (e) {

            if (e.type !="click" && e.keyCode !== undefined && e.keyCode != 13)
                return true;
            
            var proxy = this,   
                model = proxy.model,
                args = {};
            
            if (model.editSettings.allowEditing || model.editSettings.editMode == "dialogTemplate" ||
                (model.toolbarSettings.showToolbar && ((model.editSettings.allowAdding && model.toolbarSettings.toolbarItems.indexOf("add") !== -1) ||
                    (model.editSettings.allowEditing && model.toolbarSettings.toolbarItems.indexOf("index") !== -1)))) {

                if (e.target.id == "EditDialog_" + proxy._id + "_Save") {
                    if (!proxy._sendSaveRequest("Edit")) {
                        proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                        $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                    }
                } else if (e.target.id == "EditDialog_" + proxy._id + "_Cancel") {
                    //To revert back automatically updated resource unit while cancel the edit field changes.
                    if (model.selectedItem.resourceInfo)
                        model.selectedItem._updateUnitWithWork(proxy);
                    $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                }
                    //For delete option in editing dialog window
                else if (e.target.id == "EditDialog_" + proxy._id + "_Delete") {
                    var result;
                    if (model.allowSelection == false && !ej.isNullOrUndefined(proxy._contextMenuSelectedIndex)) {
                        result = proxy._$treegridHelper.ejTreeGrid("deleteRow", null, true, proxy._contextMenuSelectedIndex);
                    }else{
                        result = proxy._$treegridHelper.ejTreeGrid("deleteRow");
                    }

                    if (!(result == true)) {
                        proxy._isAddEditDialogSave = true;
                        $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                    }
                }
                else if (e.target.id == "AddDialog_" + proxy._id + "_Save") {
                    if (!proxy._sendSaveRequest("Add"))
                        if (!this._duplicate && !this._wrongenddate) {
                            proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                            $("#" + proxy._id + "_dialogAdd").ejDialog("close");                            
                        }
                }
                else if (e.target.id == "AddDialog_" + proxy._id + "_Cancel") {
                  //  proxy._ids.splice(proxy._ids.length - 1, 1);
                    $("#" + proxy._id + "_dialogAdd").ejDialog("close");
                }
            }
            else {
                proxy._sendCancelRequest();
            }

            return false;
        },
        rowDrag: function (args) {
            var proxy = this;
            proxy.model.selectedCellIndexes = [];
            proxy._trigger("rowDrag", args);
        },
        rowDragStart: function (args) {
            var proxy = this;
            proxy._trigger("rowDragStart", args);
        },
        rowDragStop: function (args) {
            var proxy = this;
            proxy._trigger("rowDragStop", args);
        },
        cellSelecting: function (args) {
            var proxy = this, model = proxy.model;
            proxy._trigger("cellSelecting", args);           
        },
        cellSelected: function (args) {
            var proxy = this, model = proxy.model;
            proxy._trigger("cellSelected", args);
            model.selectedCellIndexes = proxy._$treegridHelper.ejTreeGrid("instance").model.selectedCellIndexes;
            proxy._rowIndexOfLastSelectedCell = model.selectedCellIndexes[0].rowIndex;
        },
        //trigger row selecting client side event
        rowSelecting: function (args) {
            var proxy = this, eventArgs = {}, model = this.model;
            if (proxy.model.rowSelecting && model.selectionMode == "row") {
                eventArgs.recordIndex = args.recordIndex;
                eventArgs.previousIndex = args.previousIndex;
                eventArgs.previousData = model.updatedRecords[args.previousIndex];
                eventArgs.data = model.updatedRecords[args.recordIndex];
                eventArgs.previousChartRow = proxy._$ganttchartHelper.ejGanttChart("getRowByIndex", args.previousIndex);
                eventArgs.previousGridRow = ej.TreeGrid.getRowByIndex(this, args.previousIndex);
                eventArgs.targetChartRow = proxy._$ganttchartHelper.ejGanttChart("getRowByIndex", args.recordIndex);
                eventArgs.targetGridRow = ej.TreeGrid.getRowByIndex(this, args.recordIndex);
                if (proxy._trigger("rowSelecting", eventArgs))
                    return false;
            }
            return true;
        },

        rowSelected: function (args) {
            var proxy = this, model = this.model,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            if (model.allowSelection) {
                if (args.target == "ejTreeGrid")
                    proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                if (args.target == "ejGanttChart")
                    proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
            }
            var idx = args.recordIndex;
            this.selectedItem(args.data);
            this.selectedRowIndex(idx);
            if (proxy.model.toolbarSettings.showToolbar && args.requestType!="rowDragAndDrop") {
                if (proxy.model.readOnly == true) {
                    var disableItems = [];
                    disableItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    disableItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    disableItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    $(toolbar).ejToolbar('disableItem', disableItems);

                }

                else {

                    if ((proxy.model.toolbarSettings.toolbarItems.indexOf("indent") !== -1 || proxy.model.toolbarSettings.toolbarItems.indexOf("outdent") !== -1) && proxy.model.allowSelection) {

                        proxy.updateIndentOutdentOption(args.data);
                    }

                    var enableItems = [];

                    if (proxy.model.editSettings.allowDeleting && proxy.model.allowSelection) {
                        if (proxy.model.toolbarSettings.toolbarItems.indexOf("delete") !== -1)
                            enableItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    }
                    if (proxy.model.editSettings.allowAdding) {
                        if (proxy.model.toolbarSettings.toolbarItems.indexOf("add") !== -1)
                            enableItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    }
                    if (proxy.model.editSettings.allowEditing && proxy.model.allowSelection && model.editSettings.beginEditAction != "click") {
                        if (proxy.model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)
                            enableItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    }

                    $(toolbar).ejToolbar('enableItem', enableItems);
                }
            }

            var eventArgs = {};
            eventArgs.recordIndex = args.recordIndex;
            var data = $.extend({}, model.updatedRecords[args.recordIndex]);
            /* Delete the childRecords and parentItem from data because of avoid circular reference
               while performing postback in ASP.NET */
            delete data.childRecords; 
            delete data.parentItem;
            eventArgs.data = data;
            eventArgs.targetChartRow = proxy._$ganttchartHelper.ejGanttChart("getRowByIndex", args.recordIndex);
            eventArgs.targetGridRow = ej.TreeGrid.getRowByIndex(this, args.recordIndex);
            if (model.allowSelection && model.selectionMode == "row")
                proxy._trigger("rowSelected", eventArgs);
        },

        _treeGridRowHover: function (args) {
            var proxy = this;
            if (args.reason == "mouseenter")
                proxy._$ganttchartHelper.ejGanttChart("addRowHover", args.index);
            else if (args.reason == "mouseleave")
                proxy._$ganttchartHelper.ejGanttChart("removeRowHover");
        },

        updateIndentOutdentOption: function (ganttRecord) {
            var proxy = this,
                flatRecords = proxy.model.flatRecords;

            var recordIndex = flatRecords.indexOf(ganttRecord),
                previousGanttRecord;

            var toolbar = $("#" + proxy._id + "_toolbarItems"),
                indentIconElement = $(toolbar).find(".e-indent").parent()[0],
                outentIconElement = $(toolbar).find(".e-outdent").parent()[0];
            if (recordIndex === 0 || proxy.model.editSettings.allowIndent == false || proxy.model.readOnly == true) {
                if (indentIconElement)
                    $(toolbar).ejToolbar('disableItem', indentIconElement);

                if (outentIconElement)
                    $(toolbar).ejToolbar('disableItem', outentIconElement);
            }
            else {
                if (ganttRecord.level === 0 && proxy.model.editSettings.allowIndent == true) {
                    if (indentIconElement)
                        $(toolbar).ejToolbar('enableItem', indentIconElement);
                    if (outentIconElement)
                        $(toolbar).ejToolbar('disableItem', outentIconElement);
                }
                else {
                    previousGanttRecord = flatRecords[recordIndex - 1];
                    if ((ganttRecord.level - previousGanttRecord.level === 1) && proxy.model.editSettings.allowIndent == true && proxy.selectedRowIndex() !=-1) {
                        if (outentIconElement)
                            $(toolbar).ejToolbar('enableItem', outentIconElement);
                        if (indentIconElement)
                            $(toolbar).ejToolbar('disableItem', indentIconElement);
                    }

                    else if (proxy.model.editSettings.allowIndent == true && proxy.selectedRowIndex() != -1) {
                        if (indentIconElement)
                            $(toolbar).ejToolbar('enableItem', indentIconElement);
                        if (outentIconElement)
                            $(toolbar).ejToolbar('enableItem', outentIconElement);
                    }
                }
            }
        },

        _ganttChartRowHover: function (args) {
            var proxy = this;
            if (args.reason == "mouseenter")
                proxy._$treegridHelper.ejTreeGrid("addRowHover", args.index);
            else if (args.reason == "mouseleave")
                proxy._$treegridHelper.ejTreeGrid("removeRowHover");
        },
        _removeChildRecordsPredecessor:function(record)
        {
            var proxy = this;
            if (record.hasChildRecords) {
                var length = record.childRecords.length, index = 0;
                for (index; index < length; index++) {
                    record.childRecords[index].predecessor && proxy._removePredecessor(record.childRecords[index].predecessor, record.childRecords[index]);
                    if(record.childRecords[index].hasChildRecords)
                    {
                        proxy._removeChildRecordsPredecessor(record.childRecords[index]);
                    }
                }
            }
        },
        getExpandedRecordCount: function (record, count)
        {
            var currentRecord, proxy = this;
            if (!record.hasChildRecords)
                return 0;
            for (var i = 0; i < record.childRecords.length; i++) {
                currentRecord = record.childRecords[i];
                if (proxy.getExpandStatus(currentRecord))
                    count++;
                
                if (currentRecord.hasChildRecords) {
                    count = proxy.getExpandedRecordCount(currentRecord, count);
                }
            }
            return count;
        },

        _updateExpandStatus:function()
        {
            var proxy = this,
                records = this.model.flatRecords,
            length = records.length, oldValue;
            for (var i = 0; i < length; i++) {
                oldValue = records[i].isExpanded;
                if (proxy.getExpandStatus(records[i]) !== records[i].isExpanded) {
                    records[i].isExpanded = proxy.getExpandStatus(records[i]);
                    if (records[i].isExpanded) {
                        proxy._totalCollapseRecordCount--;
                    }
                    else {
                        proxy._totalCollapseRecordCount++;
                    }
                }
            }
        },
        actionComplete: function (args) {
            var proxy = this,model = proxy.model,
                addedIndex = -1;
            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();
            proxy._gridRows = proxy.getRows();
            proxy._ganttChartRows = proxy.getGanttChartRows();
            proxy._totalCollapseRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");

            if (args.requestType === "searching" || args.requestType === "sorting") {
                proxy._isRefreshAddedRecord = false;
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords, proxy._totalCollapseRecordCount);
                proxy._isValidationEnabled = false;
                proxy._connectorlineIds = [];
                proxy._connectorLinesCollection = [];
                proxy._createConnectorLinesCollection();
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                }
            }
            if (args.requestType == "sorting") {
                proxy._deSelectRowItem();
            }

            if (args.requestType === "delete") {
                proxy._isRefreshAddedRecord = false;
                this.dataSource(proxy._$treegridHelper.ejTreeGrid("getDataSource"));
                if (proxy._isDataManagerUpdate)
                    this._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDataManagerData");
                proxy.model.flatRecords = proxy._$treegridHelper.ejTreeGrid("getFlatRecords");
                proxy.model.ids = proxy._$treegridHelper.ejTreeGrid("getUpdatedIds");
                proxy.model.updatedRecords = proxy.getUpdatedRecords();
                model.selectedItem = null;
                this.selectedRowIndex(-1);
                var childCount = 0,
                    expandedRecordCount=0;
                //Delete from parent collection if item is in parentsCollection
                if (model.parentRecords.indexOf(args.data) !== -1) {
                    model.parentRecords.splice(model.parentRecords.indexOf(args.data), 1);
                }
                //Delete predecessor from child records
                if (args.data.hasChildRecords) {
                    proxy._removeChildRecordsPredecessor(args.data)
                }
                //Delete Predecessor from record
                if (!args.isDragAndDropDelete)
                args.data.predecessor && proxy._removePredecessor(args.data.predecessor, args.data);
                //Update parent item if item has parent
                if (args.data.parentItem)
                {
                    var parentRecord=args.data.parentItem;
                    if(args.data.parentItem.childRecords.length>0)
                    {
                        if (args.data.parentItem.isAutoSchedule)
                        proxy._updateParentItem(args.data);
                        else if(!args.data.parentItem.isAutoSchedule)
                            proxy._updateManualParentItem(args.data);
                    }else
                    {
                        parentRecord.expanded=false;
                        parentRecord.hasChildRecords = false;
                        proxy.refreshGanttRecord(parentRecord);
                    }
                }
                // To avoid refresh of gantt chart twice.
                if (args.isDragAndDropDelete)
                    return;
                proxy._isValidationEnabled = false;
                if (proxy.model.predecessorMapping) {
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._predecessorsCollection = [];
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._createConnectorLinesCollection();
                }
                if (this.isCriticalPathEnable == true) {
                    this.showCriticalPath(true, true);
                }
                //Scroller is not correctly updated before connector line cleared.
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.getCurrentViewData(), proxy.getUpdatedRecords(), proxy._totalCollapseRecordCount);

                proxy._updateToolbarOptions(); // for uypdating toolbar items after delete operation
                proxy.updateAltRow(proxy.getUpdatedRecords(), 0, 1);//for set e-alt-row style after deletion of element  
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                }
            }

            if (args.requestType === "selection") {
                proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
            }

            if (args.requestType === "rowHover") {
                proxy._$ganttchartHelper.ejGanttChart("addRowHover", args.index);
            }
            
            if (args.requestType === "scroll") {
                
                proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", args.delta);
            }
            if (args.requestType == "dragAndDrop") {
                proxy._isRefreshAddedRecord = false;
                this.dataSource(proxy._$treegridHelper.ejTreeGrid("getDataSource"));
                if (proxy._isDataManagerUpdate)
                    this._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDataManagerData");
                model.flatRecords = proxy._$treegridHelper.ejTreeGrid("getFlatRecords");
                model.ids = proxy._$treegridHelper.ejTreeGrid("getUpdatedIds");
                model.updatedRecords = proxy.getUpdatedRecords();               
                var parentData = args.draggedRow.parentItem;
                if (args.droppedPosition == "insertAsChild" && parentData) {
                    parentData.taskType = ej.Gantt.TaskType.FixedDuration;
                    parentData.effortDriven = "false";
                }
                if (model.predecessorMapping) {
                    //Remove predecessor information from parent of dropped record.
                    if (args.droppedPosition == "insertAsChild") {                       
                        parentData.predecessor && proxy._removePredecessor(parentData.predecessor, parentData);
                        parentData.item[model.predecessorMapping] = undefined;
                        parentData.predecessorsName = undefined;
                        parentData.predecessor = undefined;                        
                    }                    
                    proxy._isValidationEnabled = false;
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._createConnectorLinesCollection();
                    proxy._isValidationEnabled = true;
                }
                if (args.draggedRow.parentItem && args.draggedRow.parentItem.isAutoSchedule)
                    proxy._updateParentItem(args.draggedRow);
                else if (args.draggedRow.parentItem && !args.draggedRow.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(args.draggedRow);
                if (this.isCriticalPathEnable == true) {
                    this.showCriticalPath(true, true);
                }
                if (args.draggedRow)
                    proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.getCurrentViewData(), proxy.getUpdatedRecords(), proxy._totalCollapseRecordCount);
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                }
            }
            if (args.requestType === "save") {
                if (args._cAddedRecord) {
                    //Update WBS value while adding through ADD DIALOG
                    if (model.enableWBS && model.enableWBSPredecessor && model.predecessorMapping) {
                        proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", args._cAddedRecord);
                    }
                    proxy._renderAddedRow(args.index, args._cAddedRecord);
                   

                    if (args._cAddedRecord.parentItem && args._cAddedRecord.parentItem.isAutoSchedule)
                        proxy._updateParentItem(args._cAddedRecord);
                    else if (args._cAddedRecord.parentItem && !args._cAddedRecord.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(args._cAddedRecord);

                    ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);

                    //proxy.updateAltRow(model.updatedRecords[0], 0, 0);

                    /* select newly added item */
                    proxy.selectRows(model.updatedRecords.indexOf(args._cAddedRecord));
                    addedIndex = proxy.selectedRowIndex();

                    /*trigger row events and taskbar event for new record*/
                    if (!model.enableVirtualization) {
                        var refreshArgs = {};
                        refreshArgs.index = refreshArgs.recordIndex = model.currentViewData.indexOf(args._cAddedRecord);
                        proxy.refreshRowData(refreshArgs);
                        proxy.refreshRow(refreshArgs);
                    }
                } else if (args._cModifiedData) {                    

                    if (args._cModifiedData.hasChildRecords && args._cModifiedData.isAutoSchedule) {
                        
                        args._cModifiedData.startDate = proxy._checkStartDate(args._cModifiedData.manualStartDate, args._cModifiedData);                        
                        args._cModifiedData.left = args._cModifiedData._calculateManualLeft(this);
                        args._cModifiedData.width = args._cModifiedData._calculateManualWidth(this);
                        args._cModifiedData.progressWidth = args._cModifiedData._getProgressWidth(args._cModifiedData.width, args._cModifiedData.status);
                        args._cModifiedData.endDate = args._cModifiedData.manualEndDate;
                        args._cModifiedData._calculateDuration(this);                                                
                    }
                    else if (args._cModifiedData.hasChildRecords && !args._cModifiedData.isAutoSchedule) {
                        args._cModifiedData.left = args._cModifiedData._calculateLeft(this);
                        args._cModifiedData.width = args._cModifiedData._calculateWidth(this);
                        args._cModifiedData._calculateDuration(this);
                        args._cModifiedData.manualStartDate = args._cModifiedData.startDate;
                        args._cModifiedData.manualEndDate = args._cModifiedData.endDate;
                        proxy._updateManualParentItem(args._cModifiedData, null, true);
                    }
                    else {
                        args._cModifiedData.startDate = proxy._checkStartDate(args._cModifiedData.startDate, args._cModifiedData);
                        args._cModifiedData.endDate = proxy._getEndDate(args._cModifiedData.startDate, args._cModifiedData.duration,args._cModifiedData.durationUnit, args._cModifiedData);
                        args._cModifiedData.left = args._cModifiedData._calculateLeft(this);
                        args._cModifiedData.width = args._cModifiedData._calculateWidth(this);
                        args._cModifiedData.progressWidth = args._cModifiedData._getProgressWidth(args._cModifiedData.width, args._cModifiedData.status);
                    }
                    //Update WBS value while editing through EDIT DIALOG
                    if (model.enableWBS && model.enableWBSPredecessor && model.predecessorMapping) {
                        proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", args._cModifiedData);
                    }

                    proxy.refreshGanttRecord(args._cModifiedData);

                    if (args._cModifiedData.parentItem && args._cModifiedData.parentItem.isAutoSchedule)
                        proxy._updateParentItem(args._cModifiedData);
                    else if (args._cModifiedData.parentItem && !args._cModifiedData.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(args._cModifiedData);

                    if (args._cModifiedData.predecessor) {
                        if (args.previousValue) {
                            proxy._removeConnectorLine(args.previousValue, args._cModifiedData);
                        }
                    }
                }
                
                if (proxy.model.predecessorMapping) {

                    if ((args._cModifiedData && args._cModifiedData.predecessor)) {
                        proxy._isValidationEnabled = true;
                    }
                    else
                        proxy._isValidationEnabled = false;
                    if (args._cAddedRecord) {
                        if (args._cAddedRecord.predecessor) {
                            proxy._validatePredecessorDates(args._cAddedRecord);
                            proxy._addConnectorLine(args._cAddedRecord);
                        }
                        proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                        proxy._connectorlineIds = [];
                        proxy._connectorLinesCollection = [];
                        proxy._createConnectorLinesCollection();
                    } else {
                        if (args._cModifiedData) {
                            if (args.previousValue) {
                                proxy._removeConnectorLine(args.previousValue, args._cModifiedData);
                            }
                            proxy._addConnectorLine(args._cModifiedData);
                            if (args._cModifiedData.predecessor) {
                                if(proxy._isUpdateOffset)
                                    proxy._editedTaskBarItem = args._cModifiedData;
                                proxy._isMileStoneEdited = args._cModifiedData.isMilestone;
                                proxy._updatedConnectorLineCollection = [];
                                proxy._connectorlineIds = [];
                                proxy._validatePredecessor(args._cModifiedData,args.previousValue);
                                if (proxy._isUpdateOffset)
                                   proxy._editedTaskBarItem = null;
                                if (proxy._updatedConnectorLineCollection.length > 0) {
                                    proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                                    this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                                }
                            }
                            if (args._cModifiedData.parentItem && args._cModifiedData.parentItem.isAutoSchedule)
                                proxy._updateParentItem(args._cModifiedData);
                            else if(args._cModifiedData.parentItem && !args._cModifiedData.parentItem.isAutoSchedule)
                                proxy._updateManualParentItem(args._cModifiedData);
                        }
                    }
                }
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                    this.showCriticalPath(true);
                }
            }

            if (args.requestType === "validatePredecessor") {
                var result = proxy._editedPredecessorValidation(args);
                args.result = result;
                return;
            }
            proxy._ganttActionCompleteTrigger(args);
            // Update the scrollbar for focus the newly added record
            if (addedIndex >= 0) {
                proxy.focusOnTask(addedIndex);
            }
        },

        /*Update the scrollbar to focus the selected task item by it's index*/
        focusOnTask: function (index) {
            var proxy = this, model = proxy.model,
                ganttbody = proxy.element.find(".e-ganttviewerbodyContianer"),
                scroller = ganttbody.ejScroller("instance"),
                taskbarLeft = model.updatedRecords[index].left,
                width = scroller.model.width,
                scrollLeft = scroller.model.scrollLeft,
                hScrollbar = scroller._hScrollbar;
            if (hScrollbar) {
                if (hScrollbar.model.maximum < scrollLeft)
                    scrollLeft = hScrollbar.model.maximum;
                if (scrollLeft > taskbarLeft || (scrollLeft + width) < taskbarLeft) {
                    var left = taskbarLeft - (width / 2);
                    left = left < 0 ? 0 : left;
                    ganttbody.ejScroller("scrollX", left, true);
                }
            }
            proxy._$ganttchartHelper.ejGanttChart("updateScrollBar");
        },
        calculateEndDate: function (args) {
            var proxy = this;
            var endDate = this._getEndDate(proxy._checkStartDate(args.startDate, args.record),
                args.duration, args.durationUnit, args.record);
            proxy._$ganttchartHelper.ejGanttChart("updateEditedRecordEndDate", proxy._checkEndDate(endDate, args.record));
        },

        calculateDuration: function (args) {
            var proxy = this;
            var duration = this._getDuration(proxy._checkStartDate(args.startDate, args.record),
                           proxy._checkEndDate(args.endDate, args.record), args.durationUnit, args.isAutoSchedule);
            proxy._$ganttchartHelper.ejGanttChart("updateEditedRecordDuration", duration);
        },
        expandAllCollapseAllRequest:function(args)
        {
            var proxy = this,
                $gridEle = $(proxy.element),//.closest(".e-gantt"),
                gridInstance = $gridEle.ejGantt("instance"),
                gridId = $gridEle.attr('id');
                gridInstance._toolbarOperation(gridId + "_" + args.requestType);
        },

        chartactionComplete: function (args) {
            var proxy = this, model = this.model;

            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();

            if (args.requestType === "updateConnectors") {
                if (proxy.model.predecessorMapping) {
                    var ganttRecord = args.ganttRecord;
                    proxy._isMileStoneEdited = ganttRecord.isMilestone;
                    proxy._updatedConnectorLineCollection = [];
                    proxy._connectorlineIds = [];
                    proxy._editedTaskBarItem = ganttRecord;
                    proxy._validatePredecessor(ganttRecord);
                    if (proxy._updatedConnectorLineCollection.length > 0) {
                        proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                        this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                    }
                    proxy._editedTaskBarItem = null;
                }
            }

            if (args.requestType === "rowHover") {
                proxy._$treegridHelper.ejTreeGrid('addRowHover', args.index);
            }
            
            if (args.requestType === "scroll") {

                proxy._isTreeGridRendered = false;
                proxy._isGanttChartRendered = false;
                if (args.vscrollExsist && args.delta !== undefined)
                    proxy._$treegridHelper.ejTreeGrid('onScrollHelper', args.delta);

                proxy.model.updatedRecords = proxy.getUpdatedRecords();
                proxy.model.currentViewData = proxy.getCurrentViewData();

                if (proxy.model.enableVirtualization) {

                    if (proxy.model.predecessorMapping) {

                        if (proxy._connectorLinesCollection.length > 0) {
                            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                        }
                        proxy._isValidationEnabled = false;
                        proxy._connectorlineIds = [];
                        proxy._connectorLinesCollection = [];
                        proxy._createConnectorLinesCollection();
                    }
                }
                proxy._isTreeGridRendered = true;
                proxy._isGanttChartRendered = true;
            }
            
            if (args.requestType === "selection") {
                proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
            }
            //for validate the predecessor on mouse hover and mouse up of second drag point
            if (args.requestType === "validatePredecessor") {
                var flag= proxy._editedPredecessorValidation(args);
                args.predecessorValidation = flag;
            }

            //on mouse up if validation is true then draw connector line
            if (args.requestType === "drawConnectorLine") {

                var currentPredecessor = args.toItem._calculatePredecessor(args.predecessor, this._durationUnitEditText, this.model.durationUnit);
                args.toItem.item[proxy.model.predecessorMapping] = args.predecessorString[0];
                args.toItem.predecessorsName = args.toItem.item[proxy.model.predecessorMapping];
                //Update WBS value while drawing the predecessor links
                if (model.enableWBS && model.enableWBSPredecessor) {
                    proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", args.toItem);
                }
                if (!args.fromItem.predecessor) {// for parent item
                    args.fromItem['predecessor'] = currentPredecessor;
                }
                else {
                    args.fromItem.predecessor.push(currentPredecessor[0]);
                }
                if (args.toItem.predecessor)
                {
                    args.toItem.predecessor.push(currentPredecessor[0]);
                }
                else
                {
                    args.toItem.predecessor=[];
                    args.toItem.predecessor.push(currentPredecessor[0]);
                }

                proxy._isMileStoneEdited = args.toItem.isMilestone;
                proxy._updatedConnectorLineCollection = [];
                proxy._connectorlineIds = [];
                if (proxy.model.enablePredecessorValidation && (args.toItem.isAutoSchedule || proxy.model.validateManualTasksOnLinking))
                    proxy._isValidationEnabled = true;
                else
                    proxy._isValidationEnabled = false;
                proxy._validatePredecessor(args.toItem);
                if (proxy._updatedConnectorLineCollection.length > 0) {
                    proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                    this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                }
                //Update predecessor cell value in treegrid while drawing a new connector line to/from manual task.
                if (!args.toItem.isAutoSchedule && !proxy.model.validateManualTasksOnLinking) {
                    var treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
                    ej.TreeGrid.refreshRow(treegridObject, proxy.model.currentViewData.indexOf(args.toItem));
                }
                /*update schedule dates on predecessor editing */
                var checkArgs = {};
                checkArgs.data = args.toItem;
                proxy._updateScheduleDatesOnEditing(checkArgs);
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                    this.showCriticalPath(true);
                }
        }
            proxy._ganttActionCompleteTrigger(args);
        },

        //Public method for hidding column using header text
        // argument headerText is header text of the column

        
        hideColumn:function(headerText)
        {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("hideColumn",headerText);
        },

		//Public method for showing column using header text
        // argument headerText is header text of the column

        
        showColumn: function (headerText) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("showColumn", headerText);
        },
		 // public method for accessing tree grid clearColumnMenu method
        clearColumnMenu:function()
        {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("clearColumnMenu");
        },
        // public method for deleting row
        deleteRow: function () {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("deleteRow");
        },
        taskbarEditing: function (args) {
            
            this._trigger("taskbarEditing", args);
        },
        // public method for accessing _setInitialData Private method.
        setInitialData: function () {
            this._setInitialData();
        },

        sortColumn: function (columnName, columnSortDirection) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("sortColumn", columnName, columnSortDirection);
        },

        clearSorting: function()
        {
            var proxy = this,
                model = proxy.model;
            proxy._$treegridHelper.ejTreeGrid("clearSorting");
        },

        "export": function (action, serverEvent, multipleExport) {
            var proxy = this, model=proxy.model;
            //proxy.model.isFromGantt = proxy._isFromGantt;
            //proxy._$treegridHelper.ejTreeGrid("export", action, serverEvent, multipleExport, proxy);
            var attr = { action: action, method: 'post', "data-ajax": "false" };
            $('form#' + proxy._id + 'export').remove();
            var form = ej.buildTag('form#' + proxy._id + 'export', "", null, attr);
            var ignoreOnExport = proxy.ignoreOnExport,
                igonreLength = ignoreOnExport.length,
                modelClone;
            model.criticalTask = this.criticalPathCollection.join();
            if (!multipleExport) {
                var updatedRecords = model.updatedRecords,
                       currentViewData = model.currentViewData,
                       flatRecords = model.flatRecords,
                       parentRecords = model.parentRecords,
                       selectedItem = model.selectedItem,
                       selectedItems = model.selectedItems,
                       workUnit = model.workUnit;
                proxy._$treegridHelper.ejTreeGrid("contextMenuOperations", "Cancel");
                //proxy._contextMenuOperations("Cancel"); // Cancel the edit row or empty newly added row.
                // Delete the below internal items in model for avoid the circular reference while extend the model
                delete model.updatedRecords;
                delete model.currentViewData;
                delete model.flatRecords;
                delete model.parentRecords;
                delete model.selectedItem;
                delete model.selectedItems;
                delete model.workUnit;
                modelClone = $.extend(true, {}, model);
                model.updatedRecords = updatedRecords;
                model.currentViewData = currentViewData;
                model.flatRecords = flatRecords;
                model.parentRecords = parentRecords;
                model.selectedItem = selectedItem;
                model.selectedItems = selectedItems;
                model.workUnit = workUnit;
                var columns = modelClone.columns,
                    columnLength = columns.length;
                for (var i = 0; i < columnLength; i++) {
                    if (modelClone.columns[i].editType != undefined) {
                        switch (columns[i].editType) {
                            case "stringedit":
                                columns[i].editType = "string";
                                break;
                            case "numericedit":
                                columns[i].editType = "numeric";
                                break;
                            case "dropdownedit":
                                columns[i].editType = "dropdown";
                                break;
                            case "booleanedit":
                                columns[i].editType = "boolean";
                                break;
                            default:
                                break;
                        }
                    }
                }              
               
                if (this.ignoreOnExport) {
                    for (var i = 0; i < igonreLength; i++) {
                        delete modelClone[ignoreOnExport[i]];
                    }
                }
            }
            if (ej.raiseWebFormsServerEvents) {
               
                var locale = { "durationText": proxy._durationUnitTexts, "durationEditText": proxy._durationUnitEditText, "taskTypeTexts": proxy._taskTypeTexts, "effortDrivenTexts": proxy._effortDrivenTexts, "taskModeTexts": proxy._taskModeTexts };
                var args = { model: modelClone, originalEventType: serverEvent };
                var clientArgs = { model: JSON.stringify(modelClone), locale: JSON.stringify(locale) };
                ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
            }
            else {
                var ganttObjectArray = {};
                if (multipleExport) {
                    $('body').find('.e-gantt').each(function (index, object) {
                        var ganttObject = $(object).data('ejGantt');
                        if (!ej.isNullOrUndefined(ganttObject)) {
                            var gridmodel = ganttObject.model;
                            updatedRecords = gridmodel.updatedRecords;
                            flatRecords = gridmodel.flatRecords;
                            currentViewData = gridmodel.currentViewData;
                            parentRecords = gridmodel.parentRecords;
                            selectedItem = gridmodel.selectedItem;
                            selectedItems = gridmodel.selectedItems;
                            workUnit = model.workUnit;
                            // Delete the below internal items in model for avoid the circular reference while extend the model
                            delete gridmodel.updatedRecords;
                            delete gridmodel.flatRecords;
                            delete gridmodel.currentViewData;
                            delete gridmodel.parentRecords;
                            delete gridmodel.selectedItem;
                            delete gridmodel.selectedItems;
                            delete gridmodel.workUnit;
                            var modelClone = JSON.parse(JSON.stringify(gridmodel));
                            gridmodel.updatedRecords = updatedRecords;
                            gridmodel.flatRecords = flatRecords;
                            gridmodel.currentViewData = currentViewData;
                            gridmodel.parentRecords = parentRecords;
                            gridmodel.selectedItem = selectedItem;
                            gridmodel.selectedItems = selectedItems;
                            gridmodel.workUnit = workUnit;
                            columns = modelClone.columns;
                            columnLength = columns.length;
                            for (var i = 0; i < columnLength; i++) {
                                if (columns[i].editType != undefined) {
                                    switch (columns[i].editType) {
                                        case "stringedit":
                                            columns[i].editType = "string";
                                            break;
                                        case "numericedit":
                                            columns[i].editType = "numeric";
                                            break;
                                        case "dropdownedit":
                                            columns[i].editType = "dropdown";
                                            break;
                                        case "booleanedit":
                                            columns[i].editType = "boolean";
                                            break;
                                        default:
                                            break;
                                    }
                                }
                            }
                            if (ignoreOnExport) {
                                for (var i = 0; i < igonreLength; i++) {
                                    delete modelClone[ignoreOnExport[i]];
                                }
                                ganttObjectArray[index] = JSON.stringify(modelClone);
                                var inputAttr = { name: 'GanttModel', type: 'hidden', value: JSON.stringify(modelClone) };
                                var input = ej.buildTag('input', "", null, inputAttr);
                                form.append(input);
                            }
                        }
                    });
                }
                else {
                    var inputAttr = { name: 'GanttModel', type: 'hidden', value: JSON.stringify(modelClone) };
                    var input = ej.buildTag('input', "", null, inputAttr);
                    form.append(input);
                    form.append(this);
                }
                var locale = { "durationText": proxy._durationUnitTexts, "durationEditText": proxy._durationUnitEditText, "taskTypeTexts": proxy._taskTypeTexts, "effortDrivenTexts": proxy._effortDrivenTexts, "taskModeTexts": proxy._taskModeTexts };
                var localeAttr = { name: 'locale', type: 'hidden', value: JSON.stringify(locale) };
                var localeInput = ej.buildTag('input', "", null, localeAttr);
                form.append(localeInput);
                $('body').append(form);
                form.submit();
            }
            return true;
        },


        _refreshParent: function (item) {
            this.refreshGanttRecord(item);
            if (item.parentItem) {
                this._refreshParent(item.parentItem);
            }
        },

        taskbarEdited: function (args) {
            var proxy = this,
                ganttRecord = args.data, model = proxy.model,
                projectStartDate = new Date(proxy._projectStartDate),
                remainDays, remainDaysInDecimal, 
                day, perDayHourUnit,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                durationUnitValue = ej.Gantt.DurationUnit,
                offset = 0;
            
            proxy._isValidationEnabled = false;
            
            if (args.dragging) {
                var editMode = "dragging";
                if (args.previousData.left !== ganttRecord.left) {
                    remainDays = ganttRecord.left % proxy._perDayWidth;
                    day = (ganttRecord.left - remainDays) / proxy._perDayWidth;
                    remainDaysInDecimal = remainDays / proxy._perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (headerType == headerValue.Week || headerType == headerValue.Month || headerType == headerValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                            var newRemainDays = remainDaysInDecimal * proxy._perDayWidth;
                            ganttRecord.left = ganttRecord.left - remainDays + newRemainDays;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays + proxy._perDayWidth;
                        }
                    }
                    if (headerType == headerValue.Day || headerType == headerValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = proxy._secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, proxy._workingTimeRanges, headerType);
                    ganttRecord.startDate = proxy._checkStartDate(projectStartDate, ganttRecord);
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    ganttRecord._calculateEndDate(this);
                    ganttRecord.left = ganttRecord._calculateLeft(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);
                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
                    proxy._isValidationEnabled = true;
                }

            } else if (args.rightResizing) {
                var editMode = "Resizing";
                if (args.previousData.width !== ganttRecord.width) {

                    if (headerType == headerValue.Day || headerType == headerValue.Hour) {
                        var tempStartDate = new Date(ganttRecord.startDate),
                                                         tempNewStartDate = new Date(ganttRecord.startDate), timeDiff, taskTempWidth;
                        tempNewStartDate.setHours(0, 0, 0, 0);
                        timeDiff = tempStartDate.getTime() - tempNewStartDate.getTime();
                        if (timeDiff > 0)
                            taskTempWidth = ganttRecord.width + ((timeDiff / (1000 * 60 * 60 * 24)) * proxy._perDayWidth);
                        else
                            taskTempWidth = ganttRecord.width;
                        remainDays = taskTempWidth % proxy._perDayWidth;
                        day = (taskTempWidth - remainDays) / proxy._perDayWidth;
                        perDayHourUnit = 24;
                    }
                    else {
                        remainDays = ganttRecord.width % proxy._perDayWidth,
                        day = (ganttRecord.width - remainDays) / proxy._perDayWidth;
                        perDayHourUnit = proxy._secondsPerDay / 3600;
                    }
                    remainDaysInDecimal = remainDays / proxy._perDayWidth;
                    var startDate = proxy._getDateFromFormat(ganttRecord.startDate);
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (headerType == headerValue.Week || headerType == headerValue.Month || headerType == headerValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                            ganttRecord.width = ganttRecord.width - remainDays;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                            var newRemainDays = remainDaysInDecimal * proxy._perDayWidth;
                            ganttRecord.width = ganttRecord.width - remainDays + newRemainDays;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                            ganttRecord.width = ganttRecord.width - remainDays + proxy._perDayWidth;
                        }
                    }
                    /*Calculating the remaining day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    var endDate = ganttRecord._endDateUpdate(startDate, day - 1, inMinutes, proxy._workingTimeRanges, headerType);
                    ganttRecord.endDate = proxy._checkEndDate(endDate, ganttRecord);
                    
                    if (model.endDateMapping)
                        ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;
                    ganttRecord._calculateDuration(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);

                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
                    proxy._updatedColumn = "duration";
                    proxy._updateResourceRelatedFields(ganttRecord);                    
                }

            } else if (args.leftResizing) {
                var editMode = "Resizing";
                if (args.previousData.left !== ganttRecord.left) {                    
                    remainDays = ganttRecord.left % proxy._perDayWidth;
                    day = (ganttRecord.left - remainDays) / proxy._perDayWidth;
                    remainDaysInDecimal = remainDays / proxy._perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (headerType == headerValue.Week || headerType == headerValue.Month || headerType == headerValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays;
                        }

                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                            var newRemainDays = remainDaysInDecimal * proxy._perDayWidth;
                            ganttRecord.left = ganttRecord.left - remainDays + newRemainDays;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays + proxy._perDayWidth;
                        }
                    }
                    if (headerType == headerValue.Day || headerType == headerValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = proxy._secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, proxy._workingTimeRanges, headerType);
                    ganttRecord.startDate = proxy._checkStartDate(projectStartDate, ganttRecord);
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    ganttRecord.endDate = proxy._checkEndDate(ganttRecord.endDate, ganttRecord);
                    if (ganttRecord.isAutoSchedule && model.includeWeekend == false && (headerType == headerValue.Hour || headerType == headerValue.Day))
                        ganttRecord._calculateEndDate(this);
                    ganttRecord._calculateDuration(this);
                    ganttRecord.left = ganttRecord._calculateLeft(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);
                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);                    
                    proxy._updatedColumn = "duration";
                    proxy._updateResourceRelatedFields(ganttRecord);
                }
            } 
            if (args.progressResizing) {
                if (args.previousData.status != args.data.status) {
                    ganttRecord.status = ganttRecord._getProgressPercent(ganttRecord.width, ganttRecord.progressWidth);
                    if (ganttRecord.parentItem) {
                        ganttRecord._updateParentProgress(ganttRecord.parentItem, model.progressMapping);
                    }
                    proxy._refreshParent(ganttRecord);
                }                
            }
            else {
                proxy._isValidationEnabled = true;
                proxy._updateEditedGanttRecord(ganttRecord);
                if (ganttRecord.predecessor) {
                    proxy._isMileStoneEdited = ganttRecord.isMilestone;
                    proxy._updatedConnectorLineCollection = [];
                    proxy._connectorlineIds = [];
                    proxy._editedTaskBarItem = ganttRecord;
                    if (model.enablePredecessorValidation)
                        proxy._validatePredecessor(ganttRecord);
                    else
                        proxy._validatePredecessorOnEditing(ganttRecord);

                    if (proxy._updatedConnectorLineCollection.length > 0) {
                        proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                        this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                    }
                }
                proxy._editedTaskBarItem = null;

                if (!ganttRecord.isAutoSchedule) {
                    if (ganttRecord.hasChildRecords && !args.isChildren && !args.rightResizing) {
                        proxy._validateAutoChildRecords(args);
                    }
                }
                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateParentItem(ganttRecord, editMode);
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(ganttRecord, editMode);                
            }
            proxy.refreshGanttRecord(ganttRecord);
            proxy._trigger("taskbarEdited", args);
            if (!args.cancel && (args.leftResizing || args.rightResizing || args.dragging) && proxy._isValidationEnabled) {
                proxy._updateScheduleDatesOnEditing(args);
            }
            if (this.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                this.showCriticalPath(true);
            }
        },

        _validatePredecessorOnEditing: function (ganttRecord, manualOffsetEditing) {
            var proxy = this,
                model = proxy.model,
                currentTaskId = ganttRecord['taskId'].toString(),
                model = this.model,
                predecessorsCollection = ganttRecord['predecessor'],
                flatRecords = model.flatRecords,
                ids = model.ids,
                predecessor, isOffsetChanged, parentGanttRecord, record, connectorLineObject, connectorLineId,
                previousValue = null,
                predecessors = predecessorsCollection.filter(function (data) { return data.to === currentTaskId; }),
                successors = predecessorsCollection.filter(function (data) { return data.from === currentTaskId; }),
                predecessorLength = predecessors.length;

            for (var count = 0; count < predecessorLength; count++) {
                predecessor = predecessors[count];
                isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                record = flatRecords[ids.indexOf(predecessor.to)];
                if (manualOffsetEditing) {
                    proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                    manualOffsetEditing = false;
                }
                connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                if (proxy._$ganttchartHelper) {
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                    this._updateConnectorLineCollection(connectorLineId);
                }
            }
            for (var count = 0; count < predecessorLength; count++) {
                predecessor = predecessors[count];
                parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                record = flatRecords[ids.indexOf(predecessor.to)];

                if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))//(model.enableVirtualization === false && !parentGanttRecord.isExpanded && record.isExpanded === false)
                    continue;
                connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                if (connectorLineObject) {
                    if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.length == 0) {
                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                        var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                        proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                    }
                }

            }

            var length = successors.length;

            for (count = 0; count < length; count++) {

                predecessor = successors[count];
                parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                record = flatRecords[ids.indexOf(predecessor.to)];
                connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                if (proxy._$ganttchartHelper) {
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                    this._updateConnectorLineCollection(connectorLineId);
                }
                if (manualOffsetEditing) {
                    proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                    manualOffsetEditing = false;
                }
                if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))
                    continue;
                connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                if (connectorLineObject) {
                    if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.length == 0) {
                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                        var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                        proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                    }
                }

            }
        },

        _validateAutoChildRecords: function (args) {
            var proxy = this,
                item = args.data,
                prevItem = args.previousData,
                childItem = item.childRecords,
                arg = {},
                diffLeft = item.left - prevItem.left;
            for (var i = 0; i < childItem.length; i++) {

                if (childItem[i].isAutoSchedule && !childItem[i].hasChildRecords) {
                    arg.previousData = $.extend({}, childItem[i]);
                    childItem[i].left += diffLeft;
                    arg.data = childItem[i];
                    arg.dragging = true;
                    args.isChildren = true;
                    proxy.taskbarEdited(arg);
                }
            }
        },

        actionBegin: function (args) {

            var proxy = this;

            if (!proxy._trigger("actionBegin", args)) {

                if (args.requestType === "beginedit") {
                    proxy._sendEditRequest();
                }   
                
            }

        },

        _ganttActionCompleteTrigger: function (args) {
            this._trigger("actionComplete", args);
            if (!args.cancel && args.requestType === 'save') {
                if (args._cModifiedData) {
                    args.data = args._cModifiedData;
                }
                if (args._cAddedRecord) {
                    args.data = args._cAddedRecord;
                }
                this._updateScheduleDatesOnEditing(args);
            }
        },

        _queryCellInfo: function (args) {
            this._trigger("queryCellInfo", args);
        },

        _beginEdit: function (args) {
            var proxy = this,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            if (!proxy._trigger("beginEdit", args)) {
                proxy._isinBeginEdit = true;
                if (proxy.model.toolbarSettings.showToolbar) {

                    var toolBarEnabledItems = [];

                    var cancelElement = $(toolbar).find(".e-cancel").parent()[0];
                    var saeveElement = $(toolbar).find(".e-saveitem").parent()[0];

                    if (cancelElement) {
                        toolBarEnabledItems.push(cancelElement);
                    }

                    if (saeveElement) {
                        toolBarEnabledItems.push(saeveElement);
                    }

                    $(toolbar).ejToolbar('enableItem', toolBarEnabledItems);
                    var disableToolItems = [];
                    if (proxy.model.editSettings.allowAdding && proxy.model.toolbarSettings.toolbarItems.indexOf("add") !== -1)
                        disableToolItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    if (proxy.model.editSettings.allowEditing && proxy.model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)
                        disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    if (proxy.model.editSettings.allowDeleting && proxy.model.toolbarSettings.toolbarItems.indexOf("delete") !== -1)
                        disableToolItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    $(toolbar).ejToolbar('disableItem', disableToolItems);
                }
            }
        },

        _endEdit: function (args) {
            var proxy = this,model=this.model;
            var toolbar = $("#" + proxy._id + "_toolbarItems");

            if (proxy._trigger("endEdit", args)) {
                var predecessorString = "";
                args.data[args.columnName] = args.previousValue;
                if (args.columnName === "predecessor") {
                    predecessorString = proxy._predecessorToString(args.data.predecessor, args.data);
                    args.data.item[args.columnObject.mappingName] = predecessorString;
                    args.data.predecessorsName = predecessorString;
                } else {
                    args.data.item[args.columnObject.mappingName] = args.previousValue;
                    if (args.columnName === "resourceInfo") {
                        proxy._updateResourceName(args.data);
                        proxy._updateResourceRelatedFields(args.data);
                    }
                }
            }
            else {
                proxy._updatedColumn = args.columnName;
                //Effort driven is always true for fixedWork type of calculation.
                if (args.columnName == "taskType" && args.value == "fixedWork")
                    args.data.effortDriven = "true";
                if (args.columnName === "duration" || args.columnName == "work")
                    proxy._updateResourceRelatedFields(args.data);

                if (args.columnName === "resourceInfo") {
                    proxy._updateResourceName(args.data);
                    proxy._updateResourceRelatedFields(args.data);
                    //update parent item while child works got updated, if duration is updated the
                    //corresponding parent will update automatically.
                    if (proxy._isDurationUpdated == false) {
                        var data = args.data,
                            isParent = args.data.hasChildRecords ? true : false;
                        if (isParent && data.isAutoSchedule)
                            proxy._updateParentItem(data, null, true);
                        else if (isParent && !data.isAutoSchedule)
                            proxy._updateManualParentItem(data, null, true);

                        if (data.parentItem && data.parentItem.isAutoSchedule)
                            proxy._updateParentItem(data, null, false);
                        else if(data.parentItem && !data.parentItem.isAutoSchedule)
                            proxy._updateManualParentItem(data, null, false);
                    }
                }

                if (args.isModified || proxy._isDurationUpdated) {
                    proxy.model.currentViewData = proxy._$treegridHelper.ejTreeGrid("getCurrentViewData");
                    if (args.data.isAutoSchedule || model.validateManualTasksOnLinking)
                        proxy._isValidationEnabled = true;
                    else
                        proxy._isValidationEnabled = false;
                    proxy._updateEditedGanttRecords(args);
                }
            }

            proxy._isDurationUpdated = false;
            proxy._isinBeginEdit = false;
            proxy.refreshGanttRecord(args.data);
            
            delete args.isModified;
            if (proxy.model.toolbarSettings.showToolbar) {
                var toolBarDisableItems = [];

                if (proxy.model.toolbarSettings.toolbarItems.indexOf("cancel") !== -1) {
                    toolBarDisableItems.push($(toolbar).find(".e-cancel").parent()[0]);
                }

                if (proxy.model.toolbarSettings.toolbarItems.indexOf("update") !== -1) {
                    toolBarDisableItems.push($(toolbar).find(".e-saveitem").parent()[0]);
                }
                
                $(toolbar).ejToolbar('disableItem', toolBarDisableItems);
            }

            if (!args.cancel && (args.columnName === "startDate" || args.columnName === "endDate" || args.columnName === "duration" || args.columnName === "baselineStartDate" || args.columnName === "baselineEndDate")) {
                proxy._updateScheduleDatesOnEditing(args);
            }
            if (!args.cancel && (args.columnName === "taskMode" || args.columnName === "startDate" || args.columnName === "endDate" || args.columnName === "duration" || args.columnName === "status" || args.columnName === "predecessor")) {
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                    this.showCriticalPath(true);
                }
            }
            // proxy._trigger("endEdit", args);
        },

        //updated the schedule dates while cellediting ,taskBarediting and dialogEditing and dialogAdding
        _updateScheduleDatesOnEditing:function(args)
        {
            var proxy = this,
                model = this.model,
                startDate = proxy._getDateFromFormat(args.data.startDate),
                endDate = proxy._getDateFromFormat(args.data.endDate),
                scheduleStartDate = proxy._projectStartDate,    //_getDateFromFormat(model.scheduleStartDate),
                scheduleEndDate = proxy._getDateFromFormat(model.scheduleEndDate),
                minStartDate, maxEndDate, minBaselineStartDate, maxBaseLineEndDate,
                isDateChanged = false,
                tempStartDate = model.scheduleStartDate,
                updatedDates,
                tempEndDate = model.scheduleEndDate;
            if(args.data.hasChildRecords && !args.data.isAutoSchedule){
                startDate = proxy._getDateFromFormat(args.data.manualStartDate),
                endDate = proxy._getDateFromFormat(args.data.manualEndDate)
            }            
                proxy._calculateDatesForScheduleCheck(startDate);
            if (!model.predecessorMapping) {
                if (!(startDate.getTime() >= scheduleStartDate.getTime()) || !(startDate.getTime() <= scheduleEndDate.getTime())) {
                    if (startDate.getTime() < scheduleStartDate.getTime()) {
                        minStartDate = startDate;
                        scheduleStartDate = startDate;
                    }
                    else {
                        maxEndDate = proxy._getDateFromFormat(args.data.startDate);
                        scheduleEndDate = proxy._getDateFromFormat(args.data.startDate);
                    }
                }
                if (!(endDate.getTime() >= scheduleStartDate.getTime()) || !(endDate.getTime() <= scheduleEndDate.getTime())) {
                    if (endDate.getTime() < scheduleStartDate.getTime())
                        minStartDate = endDate;
                    else
                        maxEndDate = endDate;
                }
                if (maxEndDate) {
                    isDateChanged = true;
                    tempEndDate = args.data._getFormatedDate(maxEndDate, model.dateFormat, model.locale);
                }
                if (minStartDate) {
                    isDateChanged = true;
                    tempStartDate = args.data._getFormatedDate(minStartDate, model.dateFormat, model.locale);
                }
                if (model.renderBaseline && args.data["baselineStartDate"] && args.data["baselineEndDate"])
                {
                    var baselineStartDate = proxy._getDateFromFormat(args.data["baselineStartDate"]),
                        baselineEndDate = proxy._getDateFromFormat(args.data["baselineEndDate"]),
                        tempStartDate = proxy._getDateFromFormat(tempStartDate),
                        tempEndDate = proxy._getDateFromFormat(tempEndDate);
                    if (!(baselineStartDate.getTime() >= tempStartDate.getTime()) || !(baselineStartDate.getTime() <= tempEndDate.getTime())) {
                        if (baselineStartDate.getTime() < tempStartDate.getTime()) {
                            minBaselineStartDate = baselineStartDate;
                            scheduleStartDate = baselineStartDate;
                        }
                        else {
                            maxBaseLineEndDate = baselineStartDate;
                            scheduleEndDate = baselineStartDate;
                        }
                    }

                    if (!(baselineEndDate.getTime() >= tempStartDate.getTime()) || !(baselineEndDate.getTime() <= tempEndDate.getTime())) {
                        if (baselineEndDate.getTime() < tempStartDate.getTime())
                            minBaselineStartDate = baselineEndDate;
                        else
                            maxBaseLineEndDate = baselineEndDate;
                    }
                }
                if (maxBaseLineEndDate) {
                    isDateChanged = true;
                    tempEndDate = args.data._getFormatedDate(maxBaseLineEndDate, model.dateFormat, model.locale);
                }
                if (minBaselineStartDate) {
                    isDateChanged = true;
                    tempStartDate = args.data._getFormatedDate(minBaselineStartDate, model.dateFormat, model.locale);
                }
                if (isDateChanged) {
                    updatedDates = proxy._updateScheduleDatesByTaskLables(proxy._getDateFromFormat(tempStartDate), proxy._getDateFromFormat(tempEndDate));
                    proxy.updateScheduleDates(args.data._getFormatedDate(updatedDates.minStartDate, model.dateFormat, model.locale), args.data._getFormatedDate(updatedDates.maxEndDate, model.dateFormat, model.locale));
                }
            }
            else {
                var editArgs = {};
                editArgs.onEditing = true;
                proxy._calculateScheduleDates(editArgs);
                proxy._calculateDatesForScheduleCheck(editArgs.minStartDate);
                if (editArgs.minStartDate.getTime() < scheduleStartDate) {
                    tempStartDate = args.data._getFormatedDate(editArgs.minStartDate, model.dateFormat, model.locale);
                    isDateChanged = true;
                }
                if(editArgs.maxEndDate.getTime() > scheduleEndDate)
                {
                    tempEndDate = args.data._getFormatedDate(editArgs.maxEndDate, model.dateFormat, model.locale);
                    isDateChanged = true;
                }
                if (isDateChanged)
                {
                    proxy.updateScheduleDates(tempStartDate, tempEndDate);
                }
            }
        },
        //add dates before edited dates for scheduleupdate 
        _calculateDatesForScheduleCheck:function(startdate)
        {
            var proxy = this, model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType;
               
            if (scheduleHeaderType == scheduleHeaderValue.Week) {

                startdate.setDate(startdate.getDate() - 3);
            }

            if (scheduleHeaderType == scheduleHeaderValue.Year) {
                startdate.setDate(startdate.getDate() - 5);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Month) {
                startdate.setDate(startdate.getDate() - 3);
            }

            if (scheduleHeaderType == scheduleHeaderValue.Day) {
                startdate.setHours(startdate.getHours() - 2);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Hour) {
                startdate.setMinutes(startdate.getMinutes() - 5);
            }
        },
        //update schedule dates by tool bar operation
        _updateScheduleDatesByToolBar:function(args)
        {
            var proxy = this, model = this.model,
                 startDate = args === "prevTimeSpan" ? proxy._projectStartDate : proxy._getDateFromFormat(proxy.model.scheduleStartDate),
                 endDate = proxy._getDateFromFormat(proxy.model.scheduleEndDate),
                 chartObject = $("#ejGanttChart" + proxy._id).ejGanttChart("instance"),
                 scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                 scheduleHeaderValue = ej.Gantt.ScheduleHeaderType,
                 maxScrollWidth = 0;

            if (scheduleHeaderType == scheduleHeaderValue.Week) {
                if (args === "prevTimeSpan") {
                    startDate.setDate(startDate.getDate() - 6);
                }
                else {
                    endDate.setDate(endDate.getDate() + 7);
                }
            }

            if (scheduleHeaderType == scheduleHeaderValue.Year) {
                if (args === "prevTimeSpan")
                    startDate.setDate(startDate.getDate() - 360);
                else
                    endDate.setDate(endDate.getDate() + 365);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Month) {
                if (args === "prevTimeSpan")
                    startDate.setMonth(startDate.getMonth() - 1);
                else
                    endDate.setDate(endDate.getDate() + 30);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Day) {
                if (args === "prevTimeSpan")
                    startDate.setDate(startDate.getDate() - 1);
                else
                    endDate.setDate(endDate.getDate() + 1);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Hour) {
                if (args === "prevTimeSpan")
                    startDate.setHours(startDate.getHours() - 1);
                else
                    endDate.setHours(endDate.getHours() + 1);
            }                                    
            if (args === "prevTimeSpan") {
                proxy.updateScheduleDates(proxy._getFormatedDate(startDate, model.dateFormat, model.locale), proxy._getFormatedDate(endDate, model.dateFormat, model.locale));
                chartObject._$bodyContainer.ejScroller("scrollX", 0, true);
                if (proxy.isCriticalPathEnable == true && model.predecessorMapping) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
                }
            }
            else if (args === "nextTimeSpan") {
                proxy.updateScheduleDates(proxy._getFormatedDate(startDate, model.dateFormat, model.locale), proxy._getFormatedDate(endDate, model.dateFormat, model.locale));
                maxScrollWidth = chartObject.getMaxScrollWidth();
                chartObject._$bodyContainer.ejScroller("scrollX", maxScrollWidth, true);
                if (proxy.isCriticalPathEnable == true && model.predecessorMapping) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
                }
            }
        },
        _rowDataBound: function (args) {
            this._trigger("rowDataBound", args);
        },
        _refreshToolBar: function () {
            var $toolbar = $("#" + this._id + "_toolbarItems");
            $toolbar.find("li").removeClass("e-hover");
        },

        _toolBarClick: function (sender) {
            var proxy = this,
                model=proxy.model,
                $ganttEle = $(this.itemsContainer).closest(".e-gantt"),
                ganttInstance = $ganttEle.ejGantt("instance"),
               ganttId = $ganttEle.attr('id'),
                toolbarObj = $("#" + ganttInstance._id + "_toolbarItems");

            ganttInstance._clearContextMenu();
            if (sender.event == undefined && sender.target.tagName == "INPUT" && sender.currentTarget.id == ganttId + "_search")
                return false;

            if (ganttInstance.model.dateFormat.toLowerCase().indexOf("hh") != -1)
                $.isFunction($.fn.ejDateTimePicker) && $("#" + ganttId + "EditForm").find(".e-datetimepicker").ejDateTimePicker("hide");
            else
                $.isFunction($.fn.ejDatePicker) && $("#" + ganttId + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            var currentTarget = sender.currentTarget; var target = sender.target;
            var args = {
                itemName: sender.text,
                currentTarget: currentTarget,
                model: ganttInstance.model,
            };

            if ($ganttEle.ejGantt("instance")._trigger("toolbarClick", args))
                return false;
            $(toolbarObj).ejToolbar('deselectItem', sender.currentTarget);
            switch (sender.currentTarget.id) {
                case ganttId + "_excelExport":
                    ganttInstance._toolbarOperation(ganttId + "_excelExport");
                    break;
                case ganttId + "_pdfExport":
                    ganttInstance._toolbarOperation(ganttId + "_pdfExport");
                    break;
                case ganttId + "_add":
                    ganttInstance._toolbarOperation(ganttId + "_add");
                    break;

                case ganttId + "_edit":
                    ganttInstance._toolbarOperation(ganttId + "_edit");
                    break;

                case ganttId + "_delete":
                    ganttInstance._toolbarOperation(ganttId + "_delete");
                    break;

                case ganttId + "_update":
                    ganttInstance._toolbarOperation(ganttId + "_update");
                    break;

                case ganttId + "_cancel":
                    ganttInstance._toolbarOperation(ganttId + "_cancel");
                    break;

                case ganttId + "_search":
                    ganttInstance._toolbarOperation(ganttId + "_search", $(sender.currentTarget).find("input").val());
                    break;

                case ganttId + "_indent":
                    ganttInstance._toolbarOperation(ganttId + "_indent");
                    break;

                case ganttId + "_outdent":
                    ganttInstance._toolbarOperation(ganttId + "_outdent");
                    break;
                    
                case ganttId + "_expandAll":
                    ganttInstance._toolbarOperation(ganttId + "_expandAll");
                    break;

                case ganttId + "_criticalPath":
                    if (!ganttInstance._enableDisableCriticalIcon) {
                        ganttInstance._toolbarOperation(ganttId + "_criticalEnable");
                    }
                    else if (ganttInstance._enableDisableCriticalIcon) {
                        ganttInstance._toolbarOperation(ganttId + "_criticalDisable");
                    }
                    break;

                case ganttId + "_collapseAll":
                    ganttInstance._toolbarOperation(ganttId + "_collapseAll");
                    break;
                case ganttId + "_prevTimeSpan":
                    ganttInstance._toolbarOperation(ganttId + "_prevTimeSpan");
                    break;
                case ganttId + "_nextTimeSpan":
                    ganttInstance._toolbarOperation(ganttId + "_nextTimeSpan");
                    break;
                }
            return false;
        },

        _toolbarOperation: function (operation, searchEle) {
            var $ganttEle = this.element,
                ganttObject = $ganttEle.ejGantt("instance"),
                //gridObject = $gridEle.ejTreeGrid("instance"),
                ganttId = $ganttEle.attr('id'),
                proxy = this,
                rowindex = proxy.selectedRowIndex();
            ganttObject._exportTo = ganttObject["export"];
            var toolbar = $("#" + proxy._id + "_toolbarItems");
            switch (operation) {

                case ganttId + "_add":
                    proxy._sendAddRequest();
                    break;

                case ganttId + "_edit":
                    proxy._sendEditRequest();
                    break;

                case ganttId + "_delete":
                    proxy._$treegridHelper.ejTreeGrid("deleteRow");
                    proxy._isRefreshAddedRecord = false;

                    break;

                case ganttId + "_update":
                    proxy._$treegridHelper.ejTreeGrid("endEdit");
                    //gridObject.sendSaveRequest();

                    if (proxy.model.toolbarSettings.toolbarItems.indexOf("cancel") !== -1) {
                        proxy._disabledToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
                    }

                    if (proxy.model.toolbarSettings.toolbarItems.indexOf("update") !== -1) {
                        proxy._disabledToolItems.push($(toolbar).find(".e-saveitem").parent()[0]);
                    }
                    $(toolbar).ejToolbar('disableItem', proxy._disabledToolItems);
                    
                    proxy._disabledToolItems = [];
                    
                    break;

                case ganttId + "_cancel":
                    proxy._$treegridHelper.ejTreeGrid("cancelEditCell");                                                            
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_criticalEnable":
                    proxy.showCriticalPath(true);
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_criticalDisable":
                    proxy.showCriticalPath(false);
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_search":
                    proxy.cancelEditCell();
                    if (proxy._searchString != searchEle) {
                        proxy._$treegridHelper.ejTreeGrid("search", searchEle);
                        proxy._searchString = searchEle;
                        proxy.updateSelectedItemIndex();
                        proxy._updateToolbarOptions();
                        proxy._isRefreshAddedRecord = false;
                    }
                    break;

                case ganttId + "_indent":
                    proxy._sendIndentRequest();
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    proxy._isRefreshAddedRecord = false;
                    break;

                case ganttId + "_outdent":
                    proxy._sendOutdentRequest();
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    proxy._isRefreshAddedRecord = false;
                    break;

                case ganttId + "_expandAll":
                    proxy._expandAll();
                    proxy.updateSelectedItemIndex();
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_collapseAll":
                    proxy._collapseAll();
                    proxy.updateSelectedItemIndex();
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;
                case ganttId + "_prevTimeSpan":
                    proxy._updateScheduleDatesByToolBar("prevTimeSpan");
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;
                case ganttId + "_nextTimeSpan":
                    proxy._updateScheduleDatesByToolBar("nextTimeSpan");
                    proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_excelExport":
                    proxy._exportTo(ganttObject.model.exportToExcelAction, 'excelExporting', ganttObject.model.allowMultipleExporting);
                    break;
                case ganttId + "_pdfExport":
                    proxy._exportTo(ganttObject.model.exportToPdfAction, 'pdfExporting', ganttObject.model.allowMultipleExporting);
                    break;
            }
            proxy._refreshToolBar();
            return false;
        },

        /* update selected ietm index when selected item row position changed */
        updateSelectedItemIndex: function () {
            var proxy = this, model = this.model, updatedRecords = model.updatedRecords,
                index;
            if(model.allowSelection && !ej.isNullOrUndefined(this.selectedItem()))
            {
                if (proxy.getExpandStatus(this.selectedItem())) {
                    index = updatedRecords.indexOf(this.selectedItem());
                    proxy.selectRows(index);
                }
                else
                {
                    proxy.selectRows(-1);
                }
            } else if (!model.allowSelection && !ej.isNullOrUndefined(this.selectedItem())) {
                proxy.selectRows(-1);
            }
        },

        clearSelection:function(){
            var proxy = this;
            proxy.model.selectedCellIndexes = [];
            proxy._$treegridHelper.ejTreeGrid("clearSelection");
            proxy._$ganttchartHelper.ejGanttChart("clearSelection");
        },

        selectCells: function (indexes, preservePreviousSelectedCells) {
            var proxy = this,
                model = proxy.model;
            if (model.selectionMode == "cell" && model.allowSelection) {
                proxy._$treegridHelper.ejTreeGrid("selectCells", indexes, preservePreviousSelectedCells);
            }
        },

        //select rows index of this item
        selectRows: function (index)
        {
            var proxy = this, model = this.model;

            if (model.selectionMode == "cell")
                return;

            if (index !== -1 && !ej.isNullOrUndefined(index) && index < model.updatedRecords.length) {
                var args = {};
                args.recordIndex = index;
                args.data = model.updatedRecords[args.recordIndex];
                args.target = "ejTreeGrid";
                if (proxy.rowSelecting(args)) {
                    proxy.rowSelected(args);
                    proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                    proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                }
                proxy.updateIndentOutdentOption(args.data);
            }
            else if (index === -1) {
                proxy._deSelectRowItem();
                proxy._updateToolbarOptions();
            }
        },

        _setModel: function (options) {
            
            var proxy = this, option,
                model = proxy.model;
            
            for (option in options) {
                switch (option) {
                    case "sortSettings":
                        proxy._sendSortingRequest(options[option]);
                        break;
                    case "allowSorting":
                        proxy._sortingRequest(options[option]);
                        if (model.showColumnChooser && model.showColumnOptions)
                            proxy._$treegridHelper.ejTreeGrid("columnAddDialogTemplate");
                        break;
                    case "allowMultiSorting":
                        model.allowMultiSorting = options[option];
                        proxy._$treegridHelper.ejTreeGrid("model.allowMultiSorting", model.allowMultiSorting);
                        break;
                    case "destroy":
                        proxy.destroy();
                        break;
                    case "treeColumnIndex":
                        proxy._columnIndex(options[option]);
                        break;
                    case "allowGanttChartEditing":
                        proxy._ganttChartEditing(options[option]);
                        break;
                    case "enableProgressBarResizing":
                        proxy._resizeProgressbar(options[option]);
                        break;
                    case "enableTaskbarTooltip":
                        proxy._showTooltip(options[option]);
                        break;
                    case "enableTaskbarDragTooltip":
                        proxy._showEditingTooltip(options[option]);
                        break;                  
                    case "validateManualTasksOnLinking":
                        model.validateManualTasksOnLinking = options[option];
                        break;
                    case "enableAltRow":
                        proxy._updateAltRow(options[option]);
                        break;
                    case "locale":
                        model.flatRecords = [];
                        model.parentRecords = [];
                        proxy._clearContextMenu();
                        model.locale = options[option];
                        model.isRerender = true;
                        proxy.element.ejGantt("destroy").ejGantt(model);                        
                        break;
                    case "allowSelection":
                        model.allowSelection = options[option];
                        if (model.allowSelection) {
                            proxy._$treegridHelper.ejTreeGrid("instance").model.allowSelection = true;
                            proxy._$ganttchartHelper.ejGanttChart("instance").model.allowSelection = true;
                        }
                        else {
                            proxy._deSelectRowItem();
                            proxy._$treegridHelper.ejTreeGrid("instance").model.allowSelection = false;
                            proxy._$ganttchartHelper.ejGanttChart("instance").model.allowSelection = false;
                        }
                        proxy._updateToolbarOptions();
                        break;
                    case "editSettings":
                        $.extend(model.editSettings, options[option]);
                        proxy._updateEditSettings(options[option]);
                        proxy._initiateDialogTemplates();
                        proxy._enableEditingEvents();
                        this.cancelEditCell();
                        break;
                    case "taskbarBackground":
                        proxy._updateTaskbarBackground(options[option]);
                        break;
                    case "progressbarBackground":
                        proxy._updateProgressbarBackground(options[option]);
                        break;
                    case "parentTaskbarBackground":
                        proxy._updateParentTaskbarBackground(options[option]);
                        break;
                    case "parentProgressbarBackground":
                        proxy._updateParentProgressbarBackground(options[option]);
                        break;
                    case "showTaskNames":
                        proxy._updateRenderTaskNames(options[option]);
                        break;
                    case "leftTaskLabelMapping":
                        proxy._refreshLeftTaskLabelMapping(options[option]);
                        break;

                    case "rightTaskLabelMapping":
                        proxy._refreshRightTaskLabelMapping(options[option]);
                        break;

                    case "leftTaskLabelTemplate":
                        proxy._refreshLeftTaskLabelTemplate(options[option]);
                        break;

                    case "rightTaskLabelTemplate":
                        proxy._refreshRightTaskLabelTemplate(options[option]);
                        break;
                    case "showProgressStatus":
                        proxy._updateRendeProgressStatus(options[option]);
                        break;
                    case "showResourceNames":
                        proxy._updateRenderResourceNames(options[option]);
                        break;
                    case "progressbarHeight":
                        proxy._updateProgressbarHeight(options[option]);
                        break;
                    case "baselineColor":
                        proxy._updateBaselineColor(options[option]);
                        break;
                    case "renderBaseline":
                        proxy._updateRenderBaseline(options[option]);
                        break;
                    case "allowColumnResize":
                        proxy._updateAllowColumnResize(options[option]);
                        break;
                    case "allowKeyboardNavigation":
                        proxy._updateAllowKeyboardNavigation(options[option]);
                        break;
                    case "selectedItem":
                        proxy._updateSelectedItem(options[option]);
                        break;
                    case "dataSource":
                        proxy._deSelectRowItem();
                        proxy._updateToolbarOptions();
                        this._refreshDataSource(options[option]);
                        if (proxy._enableDisableCriticalIcon) {
                            proxy.showCriticalPath(true);
                        }
                        break;
                    case "readOnly":
                        proxy._updateReadOnly(options[option]);
                        break;
                    case "showGridCellTooltip":
                        proxy._updateShowGridCellTooltip(options[option]);
                        break;
                    case "showGridExpandCellTooltip":
                        proxy._updateShowGridExpandCellTooltip(options[option]);
                        break;
                    case "highlightWeekends":
                        proxy._updateHighlightWeekends(options[option]);
                        break;
                    case "connectorLineBackground":
                        proxy._updateConnectorLineBackground(options[option]);
                        if (proxy._enableDisableCriticalIcon) {
                            proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                        }
                        break;
                    case "connectorlineWidth":
                        proxy._updateConnectorlineWidth(options[option]);
                        if (proxy._enableDisableCriticalIcon) {
                            proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                        }
                        break;
                    case "weekendBackground":
                        proxy._updateWeekendBackground(options[option]);
                        break;
                    case "scheduleHeaderSettings":
                        var settings = options[option];
                        for (var setting in settings) {
                            switch (setting) {
                                case "timescaleUnitSize":
                                    proxy._updateTimescaleUnitSize(settings[setting]);
                                    break;
                                case "scheduleHeaderType":
                                    proxy._changeChartSchedule(settings[setting]);
                                    break;
                            }
                        }
                        break;
                    case "enableContextMenu":
                        model.enableContextMenu = options[option];
                        proxy._clearContextMenu();
                        proxy._off(proxy.element, "contextmenu", proxy._rightClick);
                        if (model.enableContextMenu) {
                            proxy._on(proxy.element, "contextmenu", proxy._rightClick);
                        }
                        break;
                    case "enableResize":
                        if (model.enableResize) {
                            proxy.model.enableResize = options[option];
                            proxy._on($(window), "resize", proxy.windowResize);
                        }
                        else {
                            proxy._off($(window), "resize", proxy.windowResize);
                        }
                        break;
                    case "isResponsive":
                        if (model.isResponsive) {
                            proxy.model.isResponsive = options[option];
                            proxy._on($(window), "resize", proxy.windowResize);
                        }
                        else {
                            proxy._off($(window), "resize", proxy.windowResize);
                        }
                        break;
                    case "selectedRowIndex":
                        if (this.selectedRowIndex() === -1 || this.selectedRowIndex() === "") {
                            proxy._deSelectRowItem();
                            proxy._updateToolbarOptions();
                        }
                        else if (this.selectedRowIndex() !== -1 && !ej.isNullOrUndefined(this.selectedRowIndex()) && this.selectedRowIndex() < proxy.model.updatedRecords.length) {
                            var rowSelectingArgs = {};
                            rowSelectingArgs.recordIndex = proxy.selectedRowIndex();
                            rowSelectingArgs.previousIndex = model.selectedItem ? model.updatedRecords.indexOf(model.selectedItem) : -1;
                            if (proxy.rowSelecting(rowSelectingArgs)) {
                                var args = {};
                                args.recordIndex = this.selectedRowIndex();
                                args.data = proxy.model.updatedRecords[args.recordIndex];
                                args.target = "ejTreeGrid";
                                proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                                proxy.rowSelected(args);
                            }
                        }
                        break;
                    case "selectedCellIndexes":
                        if (model.allowSelection && model.selectionMode == "cell") {
                            proxy.selectCells(options[option]);
                        }
                        break;
                    case "selectionMode":
                        if (model.allowSelection) {
                            proxy.clearSelection();
                            proxy._$treegridHelper.ejTreeGrid("selectRows", -1);
                            proxy._$ganttchartHelper.ejGanttChart("selectRows", -1);
                            model.selectedItem = null;
                            model.selectionMode = options[option];
                            proxy._$treegridHelper.ejTreeGrid("option", "selectionMode", options[option]);
                            proxy._$ganttchartHelper.ejGanttChart("option", "selectionMode", options[option]);
                            if (options[option] == "row")
                                proxy._$treegridHelper.ejTreeGrid("instance").model.selectionSettings.selectionType = "single";
                            proxy._updateToolbarOptions();
                        }
                        break;
                    case "selectionType":
                        if (model.allowSelection) {
                            proxy.clearSelection();
                            if (model.selectionMode == "cell") {
                                model.selectionType = options[option];
                                proxy._$treegridHelper.ejTreeGrid("instance").model.selectionSettings.selectionType = options[option];
                            }
                            else {
                                model.selectionType = "single";
                                proxy._$treegridHelper.ejTreeGrid("instance").model.selectionSettings.selectionType = "single";
                            }
                        }
                        break;
                    case "showColumnChooser":
                        model.showColumnChooser = options[option];
                        proxy._$treegridHelper.ejTreeGrid("setModel", {"showColumnChooser":model.showColumnChooser});
                        break;
                    case "showColumnOptions":
                        model.showColumnOptions = options[option];
                        proxy._$treegridHelper.ejTreeGrid("setModel", { "showColumnOptions": model.showColumnOptions });
                        break;
                    case "splitterPosition":
                        proxy.setSplitterPosition(proxy._splitterPosition());
                        break;
                    case "addDialogFields":
                        if (model.editSettings.allowAdding) {
                            model.addDialogFields = options[option];
                            proxy.addDialogTemplate();
                        }
                        break;
                    case "dragTooltip":
                        proxy._$treegridHelper.ejTreeGrid("setModel", { "dragTooltip": options[option] });
                        break;

                    case "allowDragAndDrop":
                        model.allowDragAndDrop = options[option];
                        proxy._$treegridHelper.ejTreeGrid("setModel", { "allowDragAndDrop": model.allowDragAndDrop });
                        break;
                    case "editDialogFields":
                        if (model.editSettings.allowEditing) {
                            model.editDialogFields = options[option];
                            proxy.editDialogTemplate();
                        }
                        break;
                    case "toolbarSettings":
                        $.extend(proxy.model.toolbarSettings, options[option]);
                        proxy._updateToolbar();
                        break;
                    case "holidays":
                        model.holidays = options[option];
                        proxy._refreshHolidays();
                        break;
                    case "stripLines":
                        model.stripLines = options[option];
                        proxy._updateStripLines();
                        break;
                    case "splitterSettings":
                        $.extend(model.splitterSettings, options[option]);
                         if (!ej.isNullOrUndefined(options[option].index) && ej.isNullOrUndefined(options[option].position))
                            proxy.setSplitterIndex(model.splitterSettings.index);
                        else
                            proxy.setSplitterPosition(proxy.splitterPosition());
                        break;
                    case "enablePredecessorValidation":
                        model.enablePredecessorValidation = options[option];
                        break;
                    case "sizeSettings":
                        this._calculateDimensions();
                        this.windowResize();
                        break;
                    case "milestoneTemplate":
                        proxy._milestoneTemplate(options[option]);
                        break;
                    case "taskbarTemplate":
                        proxy._taskbarTemplate(options[option]);
                        break;
                    case "parentTaskbarTemplate":
                        proxy._parentTaskbarTemplate(options[option]);
                        break;
                    case "dayWorkingTime":
                        model.dayWorkingTime = options[option].slice();
                        model.flatRecords = [];
                        model.parentRecords = [];
                        model.updatedRecords = [];
                        model.ids = [];
                        model.scheduleStartDate = model.scheduleStartDate;
                        model.scheduleEndDate = model.scheduleEndDate;
                        proxy._storedIndex = -1;
                        proxy.selectedRowIndex(-1);
                        proxy._predecessorsCollection = [];
                        proxy.element.ejGantt("destroy").ejGantt(model);
                        break;
                    case "workUnit":
                        model.workUnit = options[option];
                        this._updateWorkUnit();
                        break;
                    case "resources":                        
                        proxy._updateResourcesData(options[option]);
                        break;
                    case "cssClass":
                        this.element.removeClass(proxy._cssClass).addClass(options[option]);
                        model.toolbarSettings.showToolbar && $("#" + proxy._id + "_toolbarItems").ejToolbar("model.cssClass", options[option]);
                        $("#e-ejSpliter" + proxy._id).data("ejSplitter") && $("#e-ejSpliter" + proxy._id).ejSplitter("model.cssClass", options[option]);
                        proxy._$treegridHelper.ejTreeGrid("model.cssClass", options[option]);
                        proxy._$ganttchartHelper.removeClass(proxy._cssClass).addClass(options[option]);
                        proxy._$ganttchartHelper.ejGanttChart("model.cssClass", options[option]);
                        proxy.addDialogTemplate();
                        proxy.editDialogTemplate();
                        this._cssClass = options[option];
                }
            }
        },

        _updateResourcesData: function (updatedResources) {
            var proxy = this, model = proxy.model, ganttObj, columnIndex = -1,
                columns = proxy.getColumns(),
                flatRecords;
            model.resources = $.extend(true, [], updatedResources);

            $.each(columns, function (index, column) {
                if (column.mappingName == model.resourceInfoMapping) {
                    columnIndex = index;
                    return;
                }
            });
            if (columnIndex > -1) columns[columnIndex]["dropdownData"] = model.resources;
            flatRecords = model.flatRecords.slice();
            flatRecords.reverse();
            ganttObj = ej.Gantt.GanttRecord.prototype;
            $.each(flatRecords, function (index, record) {
                if (record.resourceInfo && record.resourceInfo.length > 0) {                    
                    record.resourceInfo = ganttObj._setResourceInfo(record.item[model.resourceInfoMapping], model.resourceIdMapping, model.resourceNameMapping, model.resourceUnitMapping, model.resources);
                    proxy._updateResourceName(record);
                    proxy._updateResourceRelatedFields(record);
                    if (record.hasChildRecords) {
                        if (record.isAutoSchedule)
                            proxy._updateParentItem(record, null, true);
                        else if (!record.isAutoSchedule)
                            proxy._updateManualParentItem(record, null, true);
                    }
                    else
                        proxy.refreshGanttRecord(record);                   
                }                
            });            
        },
        //To change schedule mode of gantt on chart side
        _changeChartSchedule: function (headerType) {
            var proxy = this, model = proxy.model,
                startDate = proxy._getDateFromFormat(model.scheduleStartDate),
                endDate = proxy._getDateFromFormat(model.scheduleEndDate);
            switch (headerType) {
                case ej.Gantt.ScheduleHeaderType.Week:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Week;
                    proxy._perDayWidth = 30;
                    break;
                case ej.Gantt.ScheduleHeaderType.Day:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Day;
                    proxy._perHourWidth = 20;
                    if (model.workingTimeScale == ej.Gantt.workingTimeScale.TimeScale24Hours)
                        proxy._perDayWidth = (proxy._perHourWidth * 24);//24 hours
                    else if (model.workingTimeScale == ej.Gantt.workingTimeScale.TimeScale8Hours)
                        proxy._perDayWidth = (proxy._perHourWidth * 24);//9 hours
                    break;
                case ej.Gantt.ScheduleHeaderType.Month:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Month;
                    proxy._perDayWidth = 10;
                    proxy._perWeekWidth = 70;
                    break;
                case ej.Gantt.ScheduleHeaderType.Year:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Year;
                    proxy._perDayWidth = 3;
                    proxy._perMonthWidth = 90;
                    break;
                case ej.Gantt.ScheduleHeaderType.Hour:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Hour;
                    var minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval,
                        intervalValue = ej.Gantt.minutesPerInterval;
                    proxy._perMinuteWidth = 20;
                    if (minutesPerInterval) {
                        if (minutesPerInterval == intervalValue.Auto) {
                            var twoDaysTimeSpan = 2 * 86400000,// Time in milliseconds
                                sevenDaysTimeSpan = 7 * 86400000,//Time in milliseconds
                                tenDaysTimeSpan = 10 * 86400000,
                                diff = endDate - startDate;
                            if (diff > tenDaysTimeSpan) {
                                proxy._minuteInterval = 30;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                            }
                            else if (diff > sevenDaysTimeSpan) {
                                proxy._minuteInterval = 15;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                            }
                            else if (diff > twoDaysTimeSpan) {
                                proxy._minuteInterval = 5;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                            }
                            else {
                                proxy._minuteInterval = 1;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);//24 hours
                            }
                        }
                        else if (minutesPerInterval == intervalValue.OneMinute) {
                            proxy._minuteInterval = 1;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);
                        }
                        else if (minutesPerInterval == intervalValue.FiveMinutes) {
                            proxy._minuteInterval = 5;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.FifteenMinutes) {
                            proxy._minuteInterval = 15;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.ThirtyMinutes) {
                            proxy._minuteInterval = 30;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                        }
                    }
                    break;
            }                        
            proxy._updateModelsWidth();
            //Re render the gantt chart side alone
            proxy.updateScheduleDates(model.scheduleStartDate, model.scheduleEndDate);
        },        
        //Change work unit for whole project using set model.
        _updateWorkUnit: function () {
            var proxy = this, model = proxy.model,
                flatRecords = model.flatRecords,              
                currentViewData = proxy.getCurrentViewData(),
                treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            treegridObject.model.workUnit = proxy._workUnitTexts[model.workUnit];
            for (var index = 0; index < flatRecords.length; index++) {
                var record = flatRecords[index],
                    currentRecordIndex = currentViewData.indexOf(record);
                record._updateWorkWithDuration(proxy);
                if (record.parentItem)
                    proxy._updateParentItem(record);
                if (currentRecordIndex != -1)
                    ej.TreeGrid.refreshRow(treegridObject, currentRecordIndex);
            }
        },
        /*Data binding method for dynamic update of dataSource*/
        _dataBindingForSetModel: function () {
            var proxy = this, model = proxy.model;
            if (this.dataSource() == null) {
                this.dataSource([]);
            }
            if (this.dataSource() instanceof ej.DataManager) {
                var query = this._columnToSelect();
                var queryPromise = this.dataSource().executeQuery(query);
                queryPromise.done(ej.proxy(function (e) {
                    if (proxy.dataSource().dataSource.offline) {
                        proxy._retrivedData = proxy.dataSource().dataSource.json;
                    } else {
                        proxy._retrivedData = e.result;
                    }
                    
                    if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                        var dataArray = proxy.dataSource(), data = [];
                        proxy._taskIds = [];
                        for (var i = 0; i < dataArray.length; i++) {
                            var tempData = dataArray[i];
                            data.push($.extend(true, {}, tempData));
                            if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                        }

                        if (!model.childMapping) model.childMapping = "Children";
                        proxy._reconstructDatasource(data);                     
                    }
                    else {
                        proxy.secondaryDatasource = proxy._retrivedData;
                    }
                    proxy._createGanttRecords(proxy.secondaryDatasource);
                    proxy._refreshGanttWithNewRecords();
                }));
            }
            else if (this.dataSource().length > 0) {
                if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                    var dataArray = proxy.dataSource(), data = [];
                    proxy._taskIds = [];
                    for (var i = 0; i < dataArray.length; i++) {
                        var tempData = dataArray[i];
                        data.push($.extend(true, {}, tempData));
                        if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                    }

                    if (!model.childMapping) model.childMapping = "Children";
                    proxy._reconstructDatasource(data);
                    proxy._createGanttRecords(proxy.secondaryDatasource);
                }
                else {
                    proxy._createGanttRecords(this.dataSource());
                }
                this._refreshGanttWithNewRecords();
            } else {
                this._refreshGanttWithNewRecords();
            }
            if (model.expandStateMapping)
                proxy._collapseRecordOnLoad();
        },
        /*Refresh all Gantt rows on new data source update*/
        _refreshGanttWithNewRecords: function () {
            var proxy = this,
                model = this.model,
                args = {};
            this._updatePredecessors();
            this._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());
            this._$treegridHelper.ejTreeGrid("processBindings");
            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();
            proxy._gridRows = proxy.getRows();
            proxy._totalCollapseRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
            this._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
            this._calculateScheduleDates();
            this.updateScheduleDates(model.scheduleStartDate, this.model.scheduleEndDate);
            args.requestType = ej.TreeGrid.Actions.Refresh;
            proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args);
            this._isFromSetModel = false;
        },
        /*Method to update the data source dynamically*/
        _refreshDataSource: function (dataSource) {
            var proxy = this;
            this.resetModelCollections();
            this.dataSource(dataSource);
            this._isFromSetModel = true;
            proxy.secondaryDatasource = [];
            proxy._retrivedData = this.dataSource();
            this._dataBindingForSetModel();
        },

        resetModelCollections: function () {
            var proxy = this,
                model = proxy.model;
            model.dataSource = [];
            model.flatRecords = [];
            model.parentRecords = [];
            model.updatedRecords = [];
            model.ids = [];
            model.scheduleStartDate = model.scheduleStartDate;
            model.scheduleEndDate = model.scheduleEndDate;
            proxy._storedIndex = -1;
            proxy.selectedRowIndex(-1);
            proxy._predecessorsCollection = [];
        },
        /* refresh holidays collections */
        _refreshHolidays: function () {
            var proxy = this,
                model = this.model, updatedDates;
            proxy._holidaysList = proxy._getHoliday();
            proxy._stringHolidays = proxy._getStringHolidays();

            updatedDates = proxy._updateScheduleDatesByHolidays(new Date(proxy._projectStartDate), new Date(proxy._projectEndDate));
            if (updatedDates.startDate.getTime() !== proxy._projectStartDate.getTime() || updatedDates.endDate.getTime() !== proxy._projectEndDate.getTime()) {
                var ganttObject = proxy._$ganttchartHelper.data("ejGanttChart");
                ganttObject.model.holidays = model.holidays;
                proxy.updateScheduleDates(updatedDates.startDate, updatedDates.endDate);
            }
            else {
                /* prevent refresh parent Item on update the child records */
                proxy._isTreeGridRendered = false;
                proxy._isGanttChartRendered = false;

                /* Update Left and Width Value of all records with new holidays*/
                proxy._updateGanttRecords();

                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords, proxy._totalCollapseRecordCount);
                /* refresh the connector line collection */
                if (model.predecessorMapping) {
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._isValidationEnabled = false;
                    proxy._createConnectorLinesCollection();
                    proxy._isValidationEnabled = true;
                }
                /*refresh the holiday container */
                this._$ganttchartHelper.ejGanttChart("refreshHolidays", model.holidays);
                proxy._isTreeGridRendered = true;
                proxy._isGanttChartRendered = true;
            }

            /* refresh chart and Treegrid part */
            proxy._$treegridHelper.ejTreeGrid("renderRecords");
        },

        /* refreh the strip lines collection */
        _updateStripLines : function()
        {
            var proxy = this, model = this.model, updatedDates;

            updatedDates = proxy._updateScheduleDatesByStripLines(new Date(proxy._projectStartDate), new Date(proxy._projectEndDate));

            if (updatedDates.startDate.getTime() !== proxy._projectStartDate.getTime() || updatedDates.endDate.getTime() !== proxy._projectEndDate.getTime()) {
                var ganttObject = proxy._$ganttchartHelper.data("ejGanttChart");
                ganttObject.model.stripLines = model.stripLines;
                proxy.updateScheduleDates(updatedDates.startDate, updatedDates.endDate);
            }
            else {
                this._$ganttchartHelper.ejGanttChart("refreshStripLines", this.model.stripLines);
            }
        },
        _updateWeekendBackground: function (bgcolor) {
            var proxy = this;
            this.model.weekendBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateWeekendBackground", bgcolor);

        },

        _updateConnectorlineWidth: function (lineWidth) {
            var proxy = this;
            this.model.connectorlineWidth = lineWidth;
            proxy._$ganttchartHelper.ejGanttChart("updateConnectorlineWidth", lineWidth);
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines",
                proxy._connectorLinesCollection);

        },

        _updateConnectorLineBackground: function (bgcolor) {
            var proxy = this;
            this.model.connectorLineBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateConnectorLineBackground", bgcolor);
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines",
                proxy._connectorLinesCollection);

        },

        _updateHighlightWeekends: function (bool) {
            var proxy = this;
            this.model.highlightWeekends = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateHighlightWeekends", bool);
        },

        _updateReadOnly:function(bool){
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateReadOnly", bool);
            proxy._$ganttchartHelper.ejGanttChart("updateReadOnly", bool);
            proxy._updateToolbarOptions();
        },
        _updateShowGridCellTooltip: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateShowGridCellTooltip", bool);
        },

        _updateShowGridExpandCellTooltip: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateShowGridExpandCellTooltip", bool);
        },

        _updateSelectedItem: function (item) {
            var proxy = this,
                args = {};
            if (item[proxy.model.taskIdMapping] != null) {


                args.recordIndex =proxy.model.ids.indexOf((item[proxy.model.taskIdMapping]).toString());
                args.item = proxy.model.flatRecords[args.recordIndex];
                args.target = "ejTreeGrid";
                proxy.rowSelected(args);
                proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                proxy._$ganttchartHelper.ejGanttChart("updateSelectedItem", args.recordIndex);
            }
        },

        /* udpate allowKeyboardNavigation API value in treegrid and chart side */
        _updateAllowKeyboardNavigation: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateAllowKeyboardNavigation", bool);
            proxy._$ganttchartHelper.ejGanttChart("updateAllowKeyboardNavigation", bool);
        },
        
        _updateAllowColumnResize: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateAllowColumnResize", bool);
        },
        
        _updateProgressbarHeight: function (height) {
            var proxy = this;
            this.model.progressbarHeight = height;
            proxy._$ganttchartHelper.ejGanttChart("updateProgressbarHeight", height);
        },
        
        _updateBaselineColor: function (color) {
            var proxy = this;
            this.model.baselineColor = color;
            proxy._$ganttchartHelper.ejGanttChart("updateBaselineColor", color);
        },
        
        _showBaselineColumns: function () {
            var proxy = this, model = proxy.model, column, mapping;
            /*If renderBaseline enabled baseline columns  are added*/
            if (model.renderBaseline && model.baselineStartDateMapping && model.baselineEndDateMapping) {

                mapping = model.baselineStartDateMapping;
                if (mapping.length) {
                    column = {
                        field: "baselineStartDate",
                        headerText: proxy._columnHeaderTexts["baselineStartDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    proxy._columns.push(column);
                }
                mapping = model.baselineEndDateMapping;

                if (mapping.length) {
                    column = {
                        field: "baselineEndDate",
                        headerText: proxy._columnHeaderTexts["baselineEndDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    proxy._columns.push(column);
                }
            }
        },
        _updateRenderBaseline: function (bool) {
            var proxy = this, model=proxy.model;
            this.model.renderBaseline = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRenderBaseline", bool);
            //Show Baseline columns in TreeGrid Side.
            if (model.renderBaseline) {
                proxy._showBaselineColumns();
                proxy._trigger("load");
            }
            //Delete Baseline Columns From TreeGrid.
            if (!model.renderBaseline) {
                var baselineStartDateColumIndex = proxy._getbaselineColumnIndex(proxy._columns).indexOf("baselineStartDate");
                proxy._columns.splice(baselineStartDateColumIndex, 1);
                var baselineEndDateColumIndex = proxy._getbaselineColumnIndex(proxy._columns).indexOf("baselineEndDate");
                proxy._columns.splice(baselineEndDateColumIndex, 1);
            }
            //Update Column Collection of Gantt in TreeGrid side.
            proxy._$treegridHelper.ejTreeGrid("updateColumns", proxy._columns);
            proxy.addDialogTemplate();
            proxy.editDialogTemplate();
        },
        // to get the column fields as an array collection to find particular column index
        _getbaselineColumnIndex: function (columns) {
            var proxy = this, columnIndexArray = [];
            for (var i = 0; i < columns.length; i++) {
                columnIndexArray[i] = columns[i].field;
            }
            return columnIndexArray;
        },
        _updateRenderTaskNames: function (bool) {
            var proxy = this;
            this.model.showTaskNames = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRenderTaskNames", bool);
        },
        _refreshLeftTaskLabelMapping: function (leftLabel) {
            var proxy = this;
            this.model.leftTaskLabelMapping = leftLabel;
            proxy._$ganttchartHelper.ejGanttChart("refreshLeftTaskLabelMapping", leftLabel);
        },
        _refreshRightTaskLabelMapping: function (rightLabel) {
            var proxy = this;
            this.model.rightTaskLabelMapping = rightLabel;
            proxy._$ganttchartHelper.ejGanttChart("refreshRightTaskLabelMapping", rightLabel);
        },
        _refreshLeftTaskLabelTemplate: function (leftLabelTemplate) {
            var proxy = this;
            this.model.leftTaskLabelTemplate = leftLabelTemplate;
            proxy._$ganttchartHelper.ejGanttChart("refreshLeftTaskLabelTemplate", leftLabelTemplate);
        },
        _refreshRightTaskLabelTemplate: function (rightLabelTemplate) {
            var proxy = this;
            this.model.rightTaskLabelTemplate = rightLabelTemplate;
            proxy._$ganttchartHelper.ejGanttChart("refreshRightTaskLabelTemplate", rightLabelTemplate);
        },
        
        _updateRendeProgressStatus: function (bool) {
            var proxy = this;
            this.model.showProgressStatus = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRendeProgressStatus", bool);
        },
        
        _updateRenderResourceNames: function (bool) {
            var proxy = this;
            this.model.showResourceNames = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRenderResourceNames", bool);
        },
        
        _updateTaskbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.taskbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateTaskbarBackground", bgcolor);
        },

        _updateProgressbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.progressbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateProgressbarBackground", bgcolor);
        },

        _updateParentTaskbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.parentTaskbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateParentTaskbarBackground", bgcolor);
        },

        _updateParentProgressbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.parentProgressbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateParentProgressbarBackground", bgcolor);
        },
        
        _updateEditSettings: function (edit) {
            var proxy = this;
            proxy._$ganttchartHelper.ejGanttChart("updateEditSettings", edit);
            proxy._$treegridHelper.ejTreeGrid("updateEditSettings", edit);
            proxy._updateToolbarOptions();
            
        },
        
        _updateRowSelection: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateRowSelection", bool);
        },

        _updateAltRow: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("option", "enableAltRow", bool);
        },

        //Insert templated row in DOM for newly added record
        _renderAddedRow: function (index, data)
        {
            var proxy = this, model = this.model;
            model.currentViewData = proxy._$treegridHelper.ejTreeGrid("getUpdatedCurrentViewData");
            proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
            if (model.enableVirtualization) {
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
            }
            else {
                proxy._$treegridHelper.ejTreeGrid("renderNewAddedRow", index, data);
                proxy._$ganttchartHelper.ejGanttChart("renderNewAddedRow", index, data);
            }
            proxy._$treegridHelper.ejTreeGrid("updateHeight");
            proxy._gridRows = proxy.getRows();
            proxy._ganttChartRows = proxy.getGanttChartRows();
        },
        
        /* get visible child record count in udpated records */
        _getVisibleChildRecordCount:function(data,count,collection)
        {
            var proxy = this, model = this.model, childRecords, length;

            if (data.hasChildRecords) {
                childRecords = data.childRecords;
                length = childRecords.length;
                for (var i = 0; i < length; i++) {
                    if (collection.indexOf(childRecords[i]) !== -1)
                        count++;
                    if (childRecords[i].hasChildRecords) {
                        count = proxy._getVisibleChildRecordCount(childRecords[i], count, collection);
                    }
                }
            }
            else {
                if (collection.indexOf(data) !== -1) {
                    count++;
                }
            }
            return count;
        },

        /* validate predecessor value of adding record*/
        _validateAddRecordPrecessorValue :function(args){
            var proxy = this, data = args.data, model = this.model;
            /* Validate the predecessor value*/
            if (model.predecessorMapping && data[model.predecessorMapping] && data[model.predecessorMapping].length > 0) {
                var validateArgs = {};
                validateArgs.currentRecord = args.currentRecord;
                validateArgs.predecessorString = data[model.predecessorMapping].split(",");
                if (!proxy._editedPredecessorValidation(validateArgs)) {
                    data[model.predecessorMapping] = "";
                    args.currentRecord.predecessor = null;
                    args.currentRecord.predecessorsName = "";
                    return false;
                }
                else {
                    return true;
                }
            } else {
                return true;
            }
        },
        
        openAddDialog: function () {
            this.cancelEditCell();
            this._sendAddRequest();
        },

        
        openEditDialog: function () {
            this.cancelEditCell();
            this._sendEditRequest();
        },
        
        
        searchItem: function (searchString) {
            var proxy = this;
            proxy.cancelEditCell();
            if (proxy._searchString != searchString) {
                proxy._$treegridHelper.ejTreeGrid("search", searchString);
                proxy._searchString = searchString;
                $("#gantt_search input").val(searchString);
            }
        },
        
        
        addRecord: function (data, rowPosition) {
            var proxy = this, model = this.model,
                selectedRowIndex = model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell,
                selectedItem = model.updatedRecords[selectedRowIndex], _cAddedRecord,
                taskIdMapping = model.taskIdMapping,
                updatedRecords = model.updatedRecords,
                flatRecords = model.flatRecords,
                parentRecords = model.parentRecords,
                ids = model.ids,
                dataSource = this.dataSource(), dataChildCount,
                level = 0, insertIndex, validateArgs = {},
                parentItem, nextBelowItemInflatRecords, nextBelowItemInUpdatedRecords;
            proxy.clearSelection();
            /* clear if treegrid is in edit state*/
            proxy.cancelEditCell();
            if ($.type(dataSource) !== "array" && !(dataSource instanceof ej.DataManager))
            {
                this.dataSource([]);
                dataSource = this.dataSource();
            }
            if (Object.prototype.toString.call(data) !== "[object Object]") {
                data = {};
            }

            if (selectedRowIndex === -1 && (rowPosition === ej.Gantt.RowPosition.AboveSelectedRow
                 || rowPosition === ej.Gantt.RowPosition.BelowSelectedRow
                 || rowPosition === ej.Gantt.RowPosition.Child) || !rowPosition) {
                rowPosition = ej.Gantt.RowPosition.Top;
            }

            /*Validate Task Id of data*/
            if (data[taskIdMapping]) {
                if(model.ids.indexOf(data[taskIdMapping].toString()) != -1) {
                    data[taskIdMapping] = null;
                } else {
                    data[taskIdMapping] = isNaN(parseInt(data[taskIdMapping])) ? null : parseInt(data[taskIdMapping]);
                }
            }

            //Add default value for missing fields
            proxy._updateAddData(data, rowPosition);
            //get updated json data of data manager from TreeGrid 
            if (proxy._isDataManagerUpdate)
                proxy._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDataManagerData");

            switch (rowPosition) {
                case ej.Gantt.RowPosition.Top:
                    level = 0;
                    parentItem = null;
                    _cAddedRecord = proxy._createGanttRecord(data, level);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    /*record update*/
                    flatRecords.splice(0, 0, _cAddedRecord);
                    updatedRecords.splice(0, 0, _cAddedRecord);
                    ids.splice(0, 0, _cAddedRecord.taskId.toString());
                    parentRecords.splice(0, 0, _cAddedRecord);
                    /*data source update*/
                    if (proxy._isDataManagerUpdate) {
                        proxy._jsonData.splice(0, 0, _cAddedRecord.item);
                    } else {
                        dataSource.splice(0, 0, _cAddedRecord.item);
                    }
                    insertIndex = 0;
                    break;

                case ej.Gantt.RowPosition.Bottom:
                    level = 0;
                    parentItem = null;
                    _cAddedRecord = proxy._createGanttRecord(data, level);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    /*record update*/
                    flatRecords.push(_cAddedRecord);
                    updatedRecords.push(_cAddedRecord);
                    ids.push(_cAddedRecord.taskId.toString());
                    parentRecords.push(_cAddedRecord);
                    /*data source update*/
                    if (proxy._isDataManagerUpdate) {
                        proxy._jsonData.push(_cAddedRecord.item);
                    } else {
                        dataSource.push(_cAddedRecord.item);
                    }
                    insertIndex = updatedRecords.indexOf(_cAddedRecord);
                    break;

                case ej.Gantt.RowPosition.AboveSelectedRow:
                    level = selectedItem.level;
                    parentItem = selectedItem.parentItem;
                    _cAddedRecord = proxy._createGanttRecord(data, level, parentItem);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }
                    var childIndex, recordIndex, updatedCollectionIndex;
                    /*Record Updates*/
                    recordIndex = flatRecords.indexOf(selectedItem);
                    updatedCollectionIndex = updatedRecords.indexOf(selectedItem);
                    flatRecords.splice(recordIndex, 0, _cAddedRecord);
                    updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                    ids.splice(recordIndex, 0, _cAddedRecord.taskId.toString());

                    if (!ej.isNullOrUndefined(parentItem)) {
                        childIndex = parentItem.childRecords.indexOf(selectedItem);
                        /*Child collection update*/
                        parentItem.childRecords.splice(childIndex, 0, _cAddedRecord);
                        if (!model.parentTaskIdMapping) {
                            parentItem.item[model.childMapping].splice(childIndex, 0, _cAddedRecord.item);
                        }
                        else {
                            _cAddedRecord.item[model.parentTaskIdMapping] = _cAddedRecord.parentItem.taskId;
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.push(_cAddedRecord.item);

                            } else {
                                dataSource.push(_cAddedRecord.item);
                            }
                        }
                    } else {
                        /* Parent records collection and data source update*/
                        parentRecords.splice(parentRecords.indexOf(selectedItem), 0, _cAddedRecord);
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                        }
                        else {
                            dataSource.splice(dataSource.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                        }
                    }
                    insertIndex = updatedCollectionIndex;
                    break;
                case ej.Gantt.RowPosition.BelowSelectedRow:
                    level = selectedItem.level;
                    parentItem = selectedItem.parentItem;
                    _cAddedRecord = proxy._createGanttRecord(data, level, parentItem);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    //find next item position
                    var currentItemIndex = flatRecords.indexOf(selectedItem)

                    if (selectedItem.hasChildRecords) {
                        dataChildCount = proxy._$treegridHelper.ejTreeGrid("getChildCount", selectedItem, 0);
                        recordIndex = currentItemIndex + dataChildCount + 1;
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1;

                    } else {
                        recordIndex = currentItemIndex + 1;
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                    }

                    /* Record collection update */
                    flatRecords.splice(recordIndex, 0, _cAddedRecord);
                    updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                    ids.splice(recordIndex, 0, _cAddedRecord.taskId.toString());

                    /* data Source update */
                    if (!ej.isNullOrUndefined(parentItem)) {
                        childIndex = parentItem.childRecords.indexOf(selectedItem);
                        /*Child collection update*/
                        parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                        if (!model.parentTaskIdMapping) {
                            parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                        }
                        else {
                            _cAddedRecord.item[model.parentTaskIdMapping] = _cAddedRecord.parentItem.taskId;
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.push(_cAddedRecord.item);

                            } else {
                                dataSource.push(_cAddedRecord.item);
                            }
                        }
                    } else {
                        /* Parent records collection and data source update*/
                        parentRecords.splice(parentRecords.indexOf(selectedItem) + 1, 0, _cAddedRecord);
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                        }
                        else {
                            dataSource.splice(dataSource.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                        }
                    }
                    insertIndex = updatedCollectionIndex;
                    break;
                case ej.Gantt.RowPosition.Child:
                    level = selectedItem.level + 1;
                    parentItem = selectedItem;
                    _cAddedRecord = proxy._createGanttRecord(data, level, parentItem);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    //find next item position
                    var currentItemIndex = flatRecords.indexOf(selectedItem)

                    if (selectedItem.hasChildRecords) {
                        dataChildCount = proxy._$treegridHelper.ejTreeGrid("getChildCount", selectedItem, 0);
                        recordIndex = currentItemIndex + dataChildCount + 1;
                        //Expand Add record's parent item 
                        if (!selectedItem.expanded) {
                            var expanargs = {};
                            expanargs.expanded = true;
                            expanargs.data = selectedItem;
                            proxy._isInAdd = true;
                            proxy.expanding(expanargs);
                            proxy._isInAdd = false;
                            updatedRecords = proxy.getUpdatedRecords();
                        }
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1;

                    } else {
                        selectedItem.hasChildRecords = true;
                        selectedItem.childRecords = [];
                        selectedItem.expanded = true;
                        if (!model.parentTaskIdMapping) {
                            selectedItem.item[model.childMapping] = [];
                        }
                        selectedItem.isMilestone = false;
                        recordIndex = currentItemIndex + 1;
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                        selectedItem.predecessor && proxy._updatePredecessorOnIndentOutdent(selectedItem);
                    }
                  
                    /* Record collection update */
                    flatRecords.splice(recordIndex, 0, _cAddedRecord);
                    updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                    ids.splice(recordIndex, 0, _cAddedRecord.taskId.toString());

                    /* data Source update */
                    if (!ej.isNullOrUndefined(parentItem)) {
                        childIndex = parentItem.childRecords.indexOf(selectedItem);
                        /*Child collection update*/
                        parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                        if (!model.parentTaskIdMapping) {
                            parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                        }
                        else {
                            _cAddedRecord.item[model.parentTaskIdMapping] = _cAddedRecord.parentItem.taskId;
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.push(_cAddedRecord.item);

                            } else {
                                dataSource.push(_cAddedRecord.item);
                            }
                        }
                    }
                    insertIndex = updatedCollectionIndex;
                    break;
            }

            //Clear previously selected Item
            proxy._deSelectRowItem()

            /*Updated record collections in treegrid side*/
            proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());

            /* Trigger action complete event for further updated*/
            var eventArgs = {};
            eventArgs.requestType = "save";
            eventArgs._cAddedRecord = eventArgs.addedRecord = _cAddedRecord;
            eventArgs.index = insertIndex;
            proxy.actionComplete(eventArgs);

            if (model.enableWBS) {
                proxy.updateWBSdetails();
            }
            /*Set flag for refresh newly added record in non virtalization mode*/
            var treeGridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            if (model.enableVirtualization === false &&
                (treeGridObject.model.sortSettings.sortedColumns.length > 0 || treeGridObject._searchString.length > 0)) {
                proxy._isRefreshAddedRecord = true;
            }
            //Maintain index of newly added row to update scrollbar while selection mode is cell.
            if (model.selectionMode == "cell") {
                var selectedRowIndex = model.updatedRecords.indexOf(_cAddedRecord);
                proxy._$treegridHelper.ejTreeGrid("updateScrollBar", selectedRowIndex);
            }
            else
                /* scroll to new added record */
                proxy._$treegridHelper.ejTreeGrid("updateScrollBar");
            //For dialog add reference
            return true;
        },
        
        /*Update the WBS value of all the records that are below the newly added row*/
        updateWBSdetails: function (targetedRow, isOutdentMinus, isReRenderWBSPred) {
            var proxy = this,
                model = proxy.model,
                dataW = targetedRow ? targetedRow : model.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell],
                      //^^ during indent-outdent    ^^ Newly added row
                newWBS = dataW["WBS"];
           
            //Updating the WBS value of other records that are below the newly added row
            var childItems, markedIndex, markedRecords, dataS, dataLength;
            if (dataW.parentItem) {
                childItems = dataW.parentItem.childRecords;
                markedIndex = childItems.indexOf(dataW);
                dataS = childItems;
                dataLength = dataS.length;
            } else if (model.flatRecords.length) {
                var flatData = model.flatRecords,
                    Level0 = flatData.filter(function (item) {
                        return item && item.level == 0;
                    });
                dataS = Level0;
                markedIndex = dataS.indexOf(dataW);
                dataLength = dataS.length;
            }
            if (isOutdentMinus)
                markedRecords = dataS.slice(markedIndex, dataLength);
            else
                markedRecords = dataS.slice(markedIndex + 1, dataLength);
            if (markedRecords.length) {
                var lastVal = newWBS.lastIndexOf('.') != -1 ? parseInt(newWBS.substr(newWBS.lastIndexOf('.') + 1)) : parseInt(newWBS),
                    parentVal = dataW.parentItem ? dataW.parentItem.WBS : null;
                if (isOutdentMinus && !isReRenderWBSPred)
                    lastVal--;
                else if (isOutdentMinus && isReRenderWBSPred)
                    lastVal = lastVal; // Here we no need to change the last digit of WBS value to update WBS, because it is in updated state
                else
                    lastVal++;
                proxy.reCalculateWBS(markedRecords, lastVal, parentVal);
            }
        },
        
        deleteItem: function () {
            var proxy = this;
            proxy.cancelEditCell();
            proxy._$treegridHelper.ejTreeGrid("deleteRow");
        },

        expandAllItems: function () {
            this.cancelEditCell();
            this._expandAll();
            this.updateSelectedItemIndex();
            this._$treegrid.focus();
        },

        collapseAllItems:function() {
            this._collapseAll();
            this.updateSelectedItemIndex();
            this._$treegrid.focus();
        },
        
          
        indentItem: function () {
            var proxy = this, model = this.model,
                flatRecords = proxy.model.flatRecords,
                ganttRecord = model.selectedItem, indentFlag = true;
            if (model.editSettings.allowIndent == false) {
                return true;
            }

            if (ganttRecord) {
                var recordIndex = flatRecords.indexOf(ganttRecord),
                previousGanttRecord;
                if (recordIndex === 0) {
                    indentFlag = false;
                }
                else {
                    if (ganttRecord.level === 0) {
                        indentFlag = true;
                    }
                    else {
                        previousGanttRecord = flatRecords[recordIndex - 1];
                        if (ganttRecord.level - previousGanttRecord.level === 1) {
                            indentFlag = false;
                        }
                        else {
                            indentFlag = true;
                        }
                    }
                }
            }
            if (indentFlag) {
                this._sendIndentRequest();
            } else {
                return false;
            }
        },

        
        outdentItem:function() {
            this._sendOutdentRequest();
        },
        
        //Updating the Gantt Columns from TreeGrid Columns.
        updateGanttColumns: function (tColumns) {
            var proxy = this,
                model = proxy.model;                
            model.columns = tColumns;
            proxy._columns = tColumns;
        },
        
        cancelEdit:function() {
            this.sendCancelRequest();
        },
        

        
        expandCollapseRecord: function (taskId) {
            var proxy = this, args = {},
                record, model = this.model, expandStatus,
                currentViewIndex, $gridRow, $chartRow;

            record = model.flatRecords[model.ids.indexOf(taskId.toString())];

            if (!ej.isNullOrUndefined(record) && record.hasChildRecords) {
                var args = {};
                args.expanded = record.expanded == true ? false : true;
                expandStatus = proxy.getExpandStatus(record);

                /*If the record is within expanded parent item*/
                if (expandStatus) {
                    args.data = record;
                    if (args.expanded) {
                        proxy.expanding(args);
                    } else {
                        proxy.collapsing(args);
                    }
                }
                /*If the record is within collapsed parent item*/
                else {
                    record.expanded = args.expanded;
                    currentViewIndex = model.currentViewData.indexOf(record);
                    if (currentViewIndex != -1 && !model.enableVirtualization) {
                        $gridRow = $(proxy.getRows()[currentViewIndex]);
                        if (record.expanded) {
                            $gridRow.find(".e-treegridcollapse").removeClass('e-treegridcollapse').addClass('e-treegridexpand');
                            $gridRow.removeClass('e-treegridrowcollapse').addClass('e-treegridrowexpand');
                        } else {
                            $gridRow.find(".e-treegridexpand").removeClass('e-treegridexpand').addClass('e-treegridcollapse');
                            $gridRow.removeClass('e-treegridrowexpand').addClass('e-treegridrowcollapse');
                        }
                    }
                }
            }
        },

        
        saveEdit: function () {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("endEdit");
        },

       // Set the splitter position based on column index.
        setSplitterIndex: function(index)
        {
            var proxy = this,
                model = proxy.model,
                columns = proxy.getColumns(),
                columnWidth = 0,
                treegridContent = $("#ejTreeGrid" + proxy._id + "e-gridcontent"),
                columnIndex = parseInt(index);
            if (columnIndex > -1 && columnIndex < columns.length)
            {
                for (var i = 0; i <= columnIndex; i++)
                    columnWidth += columns[i].width;
                if (columnWidth > proxy._ganttWidth) {
                    columnWidth = 0;
                    for (var i = 0; i <= columnIndex; i++) {
                        if ((columnWidth + columns[i].width) <= proxy._ganttWidth) {
                            columnWidth += columns[i].width;
                            index = i;
                        }
                        else {
                            model.splitterSettings.index = index;
                            break;
                        }
                    }
                }
                else
                    model.splitterSettings.index = columnIndex;
                //Check tree grid side have horizontal scrollbar or not.
                if (treegridContent.ejScroller("isHScroll"))
                    treegridContent.ejScroller("scrollLeft", 0);
                proxy.setSplitterPosition(columnWidth.toString());
            }
        },

        // calculation to find critical path.

        showCriticalPath: function (isShown, isRefreshed) {

            var proxy = this, modelRecordIds = this.model.ids, flatRecords = this.model.flatRecords;

            // execute if we enable critical path.
            if (isShown == true) {
                this.isCriticalPathEnable = true;

                // execute if the flat records contains task.
                if (flatRecords.length != 0) {

                    var totalPredecessorsCollection = [], individualPredecessorLength, taskid, todate, fromdateID, collection = [], collectionTaskId = [], criticalPathIds = [],
                        checkBeyondEnddate = [], totalPredecessorsCollectionId = [], taskBeyondEnddate = [], updatedRecords = this.model.flatRecords,
                        parentRecords = this.model.parentRecords, predecessorTaskBeyondEnddate = [], just1 = 0, dateDifference = 0,
                         mediater2 = 0, fromDataObject = [], checkEndDate, checkEndDateTaskid;


                    checkEndDate = this.model.parentRecords[0].endDate;

                    if (this.model.parentRecords[0].manualEndDate > this.model.parentRecords[0].endDate && !this.model.parentRecords[0].isAutoSchedule)
                        checkEndDate = this.model.parentRecords[0].manualEndDate;

                    checkEndDateTaskid = this.model.parentRecords[0].taskId;

                    // Find the total project endDate
                    for (var js = 1; js < parentRecords.length; js++) {
                        if (parentRecords[js].endDate >= checkEndDate) {
                            checkEndDate = parentRecords[js].endDate;
                            checkEndDateTaskid = parentRecords[js].taskId;
                        }
                        if (!parentRecords[js].isAutoSchedule) {
                            if (parentRecords[js].manualEndDate >= checkEndDate) {
                                checkEndDate = parentRecords[js].manualEndDate;
                                checkEndDateTaskid = parentRecords[js].taskId;
                            }
                        }
                    }

                    // find the taskes that ends on total project end date that stored in checkBeyondEnddate
                    // find the taskes with predecessor that stored in totalPredecessorsCollectionId.
                    for (var kk = 0; kk < updatedRecords.length; kk++) {
                        updatedRecords[kk].isCritical = false;
                        dateDifference = proxy._getDuration(updatedRecords[kk].endDate, checkEndDate, updatedRecords[kk].durationUnit, updatedRecords[kk].isAutoSchedule);
                        updatedRecords[kk].slack = dateDifference + " " + updatedRecords[kk].durationUnit;
                        if (updatedRecords[kk].endDate >= checkEndDate) {
                            checkBeyondEnddate.push(updatedRecords[kk].taskId);
                        }
                        if (updatedRecords[kk].predecessor) {
                            if (updatedRecords[kk].predecessor.length != 0) {
                                totalPredecessorsCollection.push(updatedRecords[kk]);
                                totalPredecessorsCollectionId.push(updatedRecords[kk].taskId);
                            }
                        }
                    }

                    // seperate the predecessor connected taskes from the individual taskes that ends on total project end date 
                    for (var ss = 0; ss < checkBeyondEnddate.length; ss++) {
                        if (totalPredecessorsCollectionId.indexOf(checkBeyondEnddate[ss]) == -1) {
                            mediater2 = modelRecordIds.indexOf(checkBeyondEnddate[ss].toString());
                            if (flatRecords[mediater2].status < 100)
                                flatRecords[mediater2].isCritical = true;
                            flatRecords[mediater2].slack = 0 + flatRecords[mediater2].durationUnit;
                            taskBeyondEnddate.push(checkBeyondEnddate[ss]);
                        }
                        else
                            predecessorTaskBeyondEnddate.push(checkBeyondEnddate[ss]);
                    }
                    var predecessorLength = totalPredecessorsCollection.length, endTask = [];

                    // find the detail collection of predecessor for each taskes that stored in collection.
                    for (var x = 0; x < predecessorLength; x++) {
                        var to = -1, from = -1, toPredecessor = -1, fromPredecessor = -1, currentIndex = x;
                        individualPredecessorLength = totalPredecessorsCollection[x].predecessor.length,
                         taskid = parseInt(totalPredecessorsCollection[x].taskId);

                        for (var y = 0; y < individualPredecessorLength; y++) {
                            if (totalPredecessorsCollection[x].predecessor[y].from == taskid) {
                                if (to == -1) {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {
                                        to = totalPredecessorsCollection[x].predecessor[y].to;
                                        toPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {
                                        to = totalPredecessorsCollection[x].predecessor[y].to + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        toPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                } else {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {

                                        to = to + "," + totalPredecessorsCollection[x].predecessor[y].to;
                                        toPredecessor = toPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {
                                        to = to + "," + totalPredecessorsCollection[x].predecessor[y].to + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        toPredecessor = toPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                }
                            }
                            if (totalPredecessorsCollection[x].predecessor[y].to == taskid) {
                                if (from == -1) {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {

                                        from = totalPredecessorsCollection[x].predecessor[y].from;
                                        fromPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {
                                        from = totalPredecessorsCollection[x].predecessor[y].from + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        fromPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                } else {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {
                                        from = from + "," + totalPredecessorsCollection[x].predecessor[y].from;
                                        fromPredecessor = fromPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {

                                        from = from + "," + totalPredecessorsCollection[x].predecessor[y].from + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        fromPredecessor = fromPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                }
                            }
                        }
                        if (from == -1) {
                            from = null;
                            fromPredecessor = null;
                        }
                        if (to == -1) {
                            to = null;
                            toPredecessor = null;
                        }
                        collection.push({ from: from, fromPredecessor: fromPredecessor, taskid: taskid, to: to, toPredecessor: toPredecessor, currentIndex: currentIndex, slack: null, ff: 0, fs: 0, enddate: null, fsslack: 0 });
                        collectionTaskId.push(parseInt(taskid));
                    }
                    var collectionLength = collection.length, indexenddate = 0, num;

                    // find the predecessors connected taskes that does not contains any successor.
                    for (var z = 0; z < collectionLength; z++) {
                        if (!collection[z].to) {
                            num = collection[z].taskid;
                            indexenddate = modelRecordIds.indexOf(num.toString());
                            dateDifference = proxy._getDuration(flatRecords[indexenddate].endDate, checkEndDate, "minute",flatRecords[indexenddate].isAutoSchedule);
                            collection[z].slack = dateDifference;
                            collection[z].fs = -1;
                            collection[z].enddate = flatRecords[indexenddate].endDate;
                            endTask.push({ fromdata: collection[z].from, todateID: collection[z].taskid, fromDataPredecessor: collection[z].fromPredecessor });

                        }
                    }
                    for (var k = 0; k < endTask.length; k++) {
                        fromDataObject.push(endTask[k]);
                        proxy._slackCalculation(fromDataObject, collection, collectionTaskId, checkEndDate, flatRecords, modelRecordIds);
                    }
                    criticalPathIds = proxy._finalCriticalPath(collection, taskBeyondEnddate, flatRecords, modelRecordIds);
                    this.criticalPathCollection = criticalPathIds;
                    this.detailPredecessorCollection = collection;
                    this.collectionTaskId = collectionTaskId;
                    if (!isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                        this._$ganttchartHelper.ejGanttChart("criticalPathColor", criticalPathIds, isShown, collection, collectionTaskId);
                        proxy._$treegridHelper.ejTreeGrid("refresh");
                    } else if (isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                      //proxy._$treegridHelper.ejTreeGrid("refresh");
                    }
                    proxy._enableDisableCriticalIcon = true;
                }
                else {
                    var criticalPathIds = [], collection = [], collectionTaskId = [];
                    if (!isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                        this._$ganttchartHelper.ejGanttChart("criticalPathColor", criticalPathIds, isShown, collection, collectionTaskId);
                        this._$treegridHelper.ejTreeGrid("refresh");
                    } else if (isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                      //proxy._$treegridHelper.ejTreeGrid("refresh");
                    }
                    proxy._enableDisableCriticalIcon = true;
                }
            }

            // execute if we disable critical path
            if (isShown == false) {
                var criticalPathIds = [], collection = [], collectionTaskId = [], distructIndex = 0;
                this.isCriticalPathEnable = false;
                for (var zs = 0; zs < proxy.criticalPathCollection.length ; zs++) {
                    distructIndex = modelRecordIds.indexOf(proxy.criticalPathCollection[zs].toString());
                    flatRecords[distructIndex].isCritical = false;
                }
                if (!isRefreshed) {
                    this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                    this._$ganttchartHelper.ejGanttChart("criticalPathColor", criticalPathIds, isShown, collection, collectionTaskId);
                    this._$treegridHelper.ejTreeGrid("refresh");
                } else if (isRefreshed) {
                    this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                  //proxy._$treegridHelper.ejTreeGrid("refresh");
                }
                proxy._enableDisableCriticalIcon = false;
            }
        },

        // calculation to find critical task ids with the help of slack values.
        _finalCriticalPath: function (collection, taskBeyondEnddate, flatRecords, modelRecordIds) {
            var proxy = this;
            var criticalPathIds = [], index;
            for (var x = 0; x < collection.length; x++) {
                index = modelRecordIds.indexOf(collection[x].taskid.toString());
                if (flatRecords[index].durationUnit == "day") {
                    flatRecords[index].slack = collection[x].slack / 60 / (proxy._secondsPerDay / 3600);
                    if (flatRecords[index].slack % 1 != 0)
                        flatRecords[index].slack = flatRecords[index].slack.toFixed(2) + " day";
                    else
                        flatRecords[index].slack = flatRecords[index].slack + " day";
                }
                else if (flatRecords[index].durationUnit == "hour") {
                    flatRecords[index].slack = collection[x].slack / 60;
                    if (flatRecords[index].slack % 1 != 0)
                        flatRecords[index].slack = flatRecords[index].slack.toFixed(2) + " hour";
                    else
                        flatRecords[index].slack = flatRecords[index].slack + " hour";
                }
                else {
                    flatRecords[index].slack = collection[x].slack + " minutes";
                }
                if ((collection[x].slack <= 0)) {

                    if (flatRecords[index].status < 100) {
                        flatRecords[index].isCritical = true;
                        criticalPathIds.push(collection[x].taskid);
                    }
                }
            }
            criticalPathIds = criticalPathIds.concat(taskBeyondEnddate);
            return criticalPathIds;
        },

        // calculation to find slack values.
        _slackCalculation: function (fromDataObject, collection, collectionTaskId, checkEndDate, flatRecords, modelRecordIds) {
            var proxy = this, fromDateArray = fromDataObject[0].fromdata.split(","), fromDataPredecessor = fromDataObject[0].fromDataPredecessor.split(","),
                fromDateArray1 = [], fromTaskIdIndex, indexfromtaskid, indexenddate, totaskId, arraylength = fromDateArray.length, prevTaskEnddate, ffslack, mediater, holidayCount, diffInMilliSec, dateDifference, offsetInMillSec;
            for (var xx = 0; xx < arraylength; xx++) {
                fromDateArray1 = fromDateArray[xx].split(":");
                fromTaskIdIndex = collectionTaskId.indexOf(parseInt(fromDateArray1[0]));
                totaskId = collectionTaskId.indexOf(parseInt(fromDataObject[0].todateID));

                // calculate slack value for the task contains predecessor connection in "finish to start".
                if (fromDataPredecessor[xx] == "FS") {
                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                    indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                    if (flatRecords[indexfromtaskid].endDate > flatRecords[indexenddate].startDate)
                        dateDifference = -(proxy._getDuration(flatRecords[indexenddate].startDate, flatRecords[indexfromtaskid].endDate, "minute",flatRecords[indexfromtaskid].isAutoSchedule));
                    else
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, flatRecords[indexenddate].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                    // execute if the slack value is not set initially.
                    if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {

                        // execute if the offset value is not given.
                        if (fromDateArray1.length <= 1) {
                            if (collection[totaskId].slack + dateDifference < 0) {
                                collection[fromTaskIdIndex].slack = 0;
                            }
                            else {
                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            }
                        }
                            // execute if the offset value is given.
                        else if (fromDateArray1.length > 1) {
                            if (fromDateArray1[1].indexOf("hour") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                            else if (fromDateArray1[1].indexOf("day") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                            else
                                offsetInMillSec = parseInt(fromDateArray1[1]);

                            collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                            if (collection[fromTaskIdIndex].slack < 0)
                                collection[fromTaskIdIndex].slack = 0;
                        }
                        collection[fromTaskIdIndex].fs = 1;
                        collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                        collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                    }

                        // execute if the current calculated slack value is less than the previous slack value.
                    else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {

                        // execute if the offset value is not given.
                        if (fromDateArray1.length <= 1) {
                            if (collection[totaskId].slack + dateDifference < 0) {
                                collection[fromTaskIdIndex].slack = 0;
                            }
                            else {
                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            }
                        }

                            // execute if the offset value is given.
                        else if (fromDateArray1.length > 1) {

                            if (fromDateArray1[1].indexOf("hour") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                            else if (fromDateArray1[1].indexOf("day") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                            else
                                offsetInMillSec = parseInt(fromDateArray1[1]);

                            collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                            if (collection[fromTaskIdIndex].slack < 0)
                                collection[fromTaskIdIndex].slack = 0;
                        }
                        collection[fromTaskIdIndex].fs = 1;
                        collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                        collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }

                //  calculate slack value for the task contains predecessor connection in "start to start".
                if (fromDataPredecessor[xx] == "SS") {
                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());

                    // It execute if the task is in auto mode.
                    if (flatRecords[indexfromtaskid].isAutoSchedule) {
                        indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                        if (flatRecords[indexfromtaskid].startDate > flatRecords[indexenddate].startDate)
                            dateDifference = -(proxy._getDuration(flatRecords[indexenddate].startDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                        else
                            dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                        // It execute while the slack value is not set to the corresponding task. 
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            if (fromDateArray1.length <= 1) {
                                if (collection[totaskId].slack + dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                }
                            } else if (fromDateArray1.length > 1) {
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                            //It execute while already the slack value is set and it is higher than the datedifference. 
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            if (fromDateArray1.length <= 1) {
                                if (collection[totaskId].slack + dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                }
                            } else if (fromDateArray1.length > 1) {

                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                    }
                        // It execute if the task is in not an auto mode task.
                    else if (!flatRecords[indexfromtaskid].isAutoSchedule) {
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }

                //  calculate slack value for the task contains predecessor connection in "finish to finish".
                if (fromDataPredecessor[xx] == "FF") {

                    // execute if the previous task is from finish to start or finish to finish state.
                    if (collection[totaskId].fs == 1 || collection[totaskId].ff == 1 || collection[totaskId].fs == -1) {
                        indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                        indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());

                        if (collection[totaskId].fs == 1) {
                            prevTaskEnddate = flatRecords[indexenddate].endDate;
                            ffslack = collection[totaskId].slack;
                        }
                        else if (collection[totaskId].ff == 1) {
                            prevTaskEnddate = flatRecords[indexenddate].endDate;
                            ffslack = collection[totaskId].slack;
                        }
                        if (collection[totaskId].fs == -1) {
                            prevTaskEnddate = collection[totaskId].enddate;
                            ffslack = collection[totaskId].slack;
                        }
                        if (prevTaskEnddate > flatRecords[indexfromtaskid].endDate)
                            dateDifference = -(proxy._getDuration(flatRecords[indexfromtaskid].endDate, prevTaskEnddate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                        else
                            dateDifference = proxy._getDuration(prevTaskEnddate, flatRecords[indexfromtaskid].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                        // set the slack value if the slack value is not set initially.
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {

                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ffslack - dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = ffslack - dateDifference;
                                }
                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {

                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack - dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].ff = 1;
                            collection[fromTaskIdIndex].enddate = prevTaskEnddate;
                            collection[fromTaskIdIndex].fsslack = ffslack;
                        }
                            // overright the slack value if the current calculated slack value is less than the previous slack value.
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {

                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ffslack - dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = ffslack - dateDifference;
                                }
                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {

                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack - dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].ff = 1;
                            collection[fromTaskIdIndex].enddate = prevTaskEnddate;
                            collection[fromTaskIdIndex].fsslack = ffslack;
                        }
                    }
                        // execute if the previous task is from start to start or start to finish state.
                    else {
                        indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                        // execute if the slack value is not set initially.
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack))
                                    collection[fromTaskIdIndex].slack = dateDifference;
                                else if (collection[fromTaskIdIndex].slack > dateDifference)
                                    collection[fromTaskIdIndex].slack = dateDifference;

                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                        }
                            // execute if the current calculated slack value is less than the previous slack value.
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack))
                                    collection[fromTaskIdIndex].slack = dateDifference;
                                else if (collection[fromTaskIdIndex].slack > dateDifference)
                                    collection[fromTaskIdIndex].slack = dateDifference;
                            }
                                // execute if the offset value is not given.
                            else if (fromDateArray1.length > 1) {
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                        }
                        collection[fromTaskIdIndex].ff = 1;
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }

                //  calculate slack value for the task contains predecessor connection in "start to finish".
                if (fromDataPredecessor[xx] == "SF") {
                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());

                    //It execute if the task is an auto mode task.
                    if (flatRecords[indexfromtaskid].isAutoSchedule) {
                        //execute if the slack value is not set initially.
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                // execute if the previous task does no has sucessor. 
                                if (ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                    collection[fromTaskIdIndex].slack = dateDifference;
                                }
                                    // execute if the previous task has sucessor.
                                else if (!ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                                    if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].startDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                    if (collection[totaskId].slack + dateDifference < 0) {
                                        collection[fromTaskIdIndex].slack = 0;
                                    }
                                    else {
                                        collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                    }
                                }
                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {
                                indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                                if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].endDate) {
                                    if (flatRecords[indexfromtaskid].startDate > flatRecords[indexenddate].endDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                } else {
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                }
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                        else {

                            if (fromDateArray1.length <= 1) {
                                if (ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                } else if (!ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                                    if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].startDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                                }
                                // execute if the current calculated slack value is less than the previous slack value.
                                if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                                    if (ej.isNullOrUndefined(collection[totaskId].to)) {
                                        collection[fromTaskIdIndex].slack = dateDifference;
                                    } else if (!ej.isNullOrUndefined(collection[totaskId].to)) {
                                        if (collection[totaskId].slack + dateDifference < 0) {
                                            collection[fromTaskIdIndex].slack = 0;
                                        }
                                        else {
                                            collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                        }
                                    }
                                }
                            } else if (fromDateArray1.length > 1) {
                                indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());

                                if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].endDate) {
                                    if (flatRecords[indexfromtaskid].startDate > flatRecords[indexenddate].endDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                } else {
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                }
                                // execute if the current calculated slack value is less than the previous slack value.
                                if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                                    if (fromDateArray1[1].indexOf("hour") != -1)
                                        offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                    else if (fromDateArray1[1].indexOf("day") != -1)
                                        offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                    else
                                        offsetInMillSec = parseInt(fromDateArray1[1]);

                                    collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                    collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                    if (collection[fromTaskIdIndex].slack < 0)
                                        collection[fromTaskIdIndex].slack = 0;
                                }
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                    }
                        //It execute if the task is an auto mode task.
                    else if (!flatRecords[indexfromtaskid].isAutoSchedule) {
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }
                if (collection[fromTaskIdIndex].from)
                    fromDataObject.push({ fromdata: collection[fromTaskIdIndex].from, todateID: collection[fromTaskIdIndex].taskid, fromDataPredecessor: collection[fromTaskIdIndex].fromPredecessor });
            }
            if (fromDataObject) {
                fromDataObject.splice(0, 1);
                if (fromDataObject.length > 0)
                    proxy._slackCalculation(fromDataObject, collection, collectionTaskId, checkEndDate, flatRecords, modelRecordIds);
            }
        },

        setSplitterPosition: function(width)
        {
            var proxy = this,
                model = proxy.model,
                leftPaneSize = 0,
                rightPaneSize = 0,
                splitter,
                ganttWidth = parseInt(proxy._ganttWidth) - proxy._totalBorderWidth,
                isPercentage = false;
            if (!ej.isNullOrUndefined(width)) {
                if (width.indexOf("%") != -1){
                    leftPaneSize = parseInt(width);
                    isPercentage = true;
                }
                else
                {
                    leftPaneSize = parseInt(width) / proxy._ganttWidth * 100;
                    isPercentage = false;
                }
                leftPaneSize = isNaN(leftPaneSize) ? 0 : leftPaneSize;
                
                //Check the grid width is less than or equal to 100% of gantt width.
                if (leftPaneSize <= 100)
                {
                    leftPaneSize = leftPaneSize < 0 ? 0 : leftPaneSize;
                    //Here 9 is the splitter span width
                    rightPaneSize = 100 - leftPaneSize - (9 / ganttWidth * 100);
                    // Check the right pane size is less than or equal to 0.
                    // if it is less than 0 mean adjust rightpane size is 0 and left pane size is 100
                    if (rightPaneSize <= 0)
                    {
                        if (isPercentage)
                            proxy.splitterPosition("100%");
                        else
                            proxy.splitterPosition(ganttWidth.toString());
                        leftPaneSize = 100 - (9 / ganttWidth * 100);
                        rightPaneSize = 0;
                    }
                    else if (rightPaneSize > 0) {
                        if (isPercentage)
                            proxy.splitterPosition(Math.round(leftPaneSize) + "%");
                        else
                            proxy.splitterPosition(Math.round((leftPaneSize * proxy._ganttWidth / 100)).toString());
                    }
                    splitter = $("#e-ejSpliter" + proxy._id).ejSplitter("instance");
                    // Set left and right pane size to ejSplitter
                    splitter.model.properties[0].paneSize = leftPaneSize+"%";
                    splitter.model.properties[1].paneSize = rightPaneSize + "%";
                    splitter.refresh();
                    proxy._$treegridHelper.ejTreeGrid("refreshScroller", Math.round((leftPaneSize * ganttWidth) / 100));
                    proxy._$ganttchartHelper.ejGanttChart("refreshScroller", splitter.model.properties[1].paneSize - 1);
                    proxy._clearContextMenu();
                }
                else
                {
                    splitter = $("#e-ejSpliter" + proxy._id).ejSplitter("instance");
                    leftPaneSize = splitter.model.properties[0].paneSize;
                    rightPaneSize = splitter.model.properties[1].paneSize;
                    if (parseInt(rightPaneSize) == 0)
                    {
                        if (isPercentage)
                            proxy.splitterPosition("100%");
                        else
                            proxy.splitterPosition(ganttWidth.toString());
                    }
                    else
                    {
                        if (isPercentage)
                            proxy.splitterPosition(Math.round((parseInt(leftPaneSize) / ganttWidth * 100)) + "%");
                        else
                            proxy.splitterPosition((leftPaneSize).toString());
                    }

                }
                proxy._splitterPosition(proxy.splitterPosition());
            }
        },

        _showTooltip: function (boolValue) {
            var proxy = this;
            this.model.enableTaskbarTooltip = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("showTooltip", boolValue);
        },

        _showEditingTooltip: function (boolValue) {
            var proxy = this;
            this.model.enableTaskbarDragTooltip = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("showEditingTooltip", boolValue);
        },
        
        _ganttChartEditing:function(boolValue) {
            var proxy = this;
            proxy.model.allowGanttChartEditing = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("ganttChartEditing", boolValue);
            //Dynamically updated the cursor styles.
            if (!boolValue) {                
                $(".e-gantt-childtaskbar, .e-tasklabel, .progressbar, .taskbarresizer-right, .taskbarresizer-left").css({ cursor: "auto" });
            }
            else {
                $(".e-gantt-childtaskbar, .e-tasklabel, .progressbar").css({ cursor: "move" });
                $(".taskbarresizer-right").css({ cursor: "w-resize" });
                $(".taskbarresizer-left").css({ cursor: "e-resize" });
            }
        },
        
        _resizeProgressbar: function (boolValue) {
            var proxy = this;
            proxy.model.enableProgressBarResizing = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("resizeProgressbar", boolValue);

        },

        _milestoneTemplate: function (value) {
            var proxy = this;
            proxy.model.milestoneTemplate = value;
            proxy._$ganttchartHelper.ejGanttChart("changeMilestoneTemplate", proxy.model.milestoneTemplate);
        },

        _taskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.taskbarTemplate = value;
            proxy._$ganttchartHelper.ejGanttChart("changeTaskbarTemplate", proxy.model.taskbarTemplate);
        },

        _parentTaskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.parentTaskbarTemplate = value;
            proxy._$ganttchartHelper.ejGanttChart("changeParentTaskbarTemplate", proxy.model.parentTaskbarTemplate);
        },
        _sendSortingRequest: function(sortSettings) {
            var proxy = this;
            proxy.model.sortSettings = sortSettings;
            proxy._$treegridHelper.ejTreeGrid("option", "sortSettings", sortSettings);
        },
        
        _sortingRequest: function (boolValue) {
            var proxy = this, model = proxy.model, sorting;
            proxy.model.allowSorting = boolValue;           
            proxy._$treegridHelper.ejTreeGrid("sortSetting", boolValue);
        },
        _columnIndex: function (value) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("columnIndex", value);
        },
        sendCancelRequest: function () {
            var proxy = this,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            proxy._$treegridHelper.ejTreeGrid("cancelEditCell");

            if (proxy.model.toolbarSettings.toolbarItems.indexOf("cancel") !== -1) {
                proxy._disabledToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
            }

            if (proxy.model.toolbarSettings.toolbarItems.indexOf("save") !== -1) {
                proxy._disabledToolItems.push($(toolbar).find(".e-saveitem").parent()[0]);
            }

            $(toolbar).ejToolbar('disableItem', proxy._disabledToolItems);
            proxy._disabledToolItems = [];
        },
        
        _sendAddRequest: function () {
            
            var proxy = this,                
                columns = proxy._columns,
                length = columns.length,
                columnCount = 0,
                cloneData = {},
                fieldData = {},
                args = {};
            proxy._isinAddnewRecord = true;
            
            for (columnCount; columnCount < length; columnCount++)
                columns[columnCount].mappingName && (cloneData[columns[columnCount].mappingName] = "");

            args.data = cloneData;
            args.requestType = "add";
            proxy.renderedEditDialog(args);
        },

        _sendEditRequest: function ($tr) {
            var proxy = this,
                model = proxy.model,
                args={},
                data;
            
            if (ej.isNullOrUndefined($tr)) {
                proxy._currentTrIndex = model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell;
                proxy._$currentTr = $(proxy._$treegridHelper.ejTreeGrid("getRows")).eq(this.selectedRowIndex());
            } else {
                proxy._currentTrIndex = $tr.index();
                proxy._$currentTr = $tr;
            }
            data = proxy.getUpdatedRecords()[proxy._currentTrIndex];

            args.data = data;
            args.requestType = "beginedit";
            if (args.data)
                proxy.renderedEditDialog(args);
        },
        _updateAddData: function (obj, rowPosition)
        {
            var proxy = this, model = this.model, id, startDate;
           
            if (!obj[model.taskIdMapping])
            {
                id= model.flatRecords.length;
                id = proxy._getNewTaskId(id);
                obj[model.taskIdMapping] = id;
            }

            if (model.taskNameMapping && !obj[model.taskNameMapping]) {
                obj[model.taskNameMapping] = proxy._newTaskTexts["newTaskName"] + " " + obj[model.taskIdMapping];
            }

            if (!obj[model.startDateMapping]) {
                obj[model.startDateMapping] = model.scheduleStartDate;
            }

            if (model.durationMapping && ej.isNullOrUndefined(obj[model.durationMapping])) {
                if (!obj[model.endDateMapping])
                    obj[model.durationMapping] = "5";
            }
            if (model.progressMapping) {
                obj[model.progressMapping] = obj[model.progressMapping] ? (obj[model.progressMapping] > 100 ? 100 : obj[model.progressMapping]) : 0;
            }

            if (!obj[model.endDateMapping] && model.endDateMapping) {

                if (!obj[model.durationMapping]) {
                    var startDate = proxy._getDateFromFormat(model.scheduleStartDate);
                    startDate.setDate(startDate.getDate() + 4);
                    obj[model.endDateMapping] = ej.format(startDate, this.model.dateFormat, this.model.locale);
                }
            }
            if (model.enableWBS && !obj["WBS"]) {
                obj["WBS"] = proxy._getNewWBSid(rowPosition);
            }
             if(model.enableWBS && !obj["WBS"])
            {
                obj["WBS"] = proxy._getNewWBSid(rowPosition);
             }
             if (!ej.isNullOrUndefined(model.selectedItem)) {
                 obj["taskType"] = model.workMapping ? ej.Gantt.TaskType.FixedWork : model.selectedItem.taskType;
                 obj["effortDriven"] = model.workMapping ? "true" : model.selectedItem.effortDriven;
             }
        },
        _sendSaveRequest: function (saveType) {
            var obj = {},
                doc = document,
                proxy = this,
                model = proxy.model,
                index = 0,
                formelement,
                length,
                editedRowWrap,
                columnName,
                $element,
                startdate,
                enddate,
                column,
                value, dialogId, treeGridId, resourceGridId, customGridId, noteRteId,
                args = {},
                generalColumns, generalColumnsLength, customColumns, customColumnsLength;
            this._duplicate = false;
            this._wrongenddate = false;
            if (saveType === "Add")
            {
                formelement = doc.querySelectorAll("#" + proxy._id + "GeneralAddForm", "#" + proxy._id + "PredecessorAddForm", "#" + proxy._id + "ReosurceAddForm", "#" + proxy._id + "CustomFieldsAddForm");
                length = formelement && formelement.length;
                dialogId = "Add";
                treeGridId = "#treegrid" + proxy._id + "predecessorAdd";
                resourceGridId = "#treegrid" + proxy._id + "resourceAdd";
                customGridId = "#treegrid" + proxy._id + "customFieldAdd";
                noteRteId = "#" + proxy._id + "AddAreaNotes";
                $element = $("#" + proxy._id + "taskId" + dialogId);             
                column = ej.TreeGrid.getColumnByField(proxy._columns, "taskId");
                proxy._cellEditColumn = column;
                generalColumns = proxy._addDialogGeneralColumns;
                generalColumnsLength = generalColumns.length;
                customColumns = proxy._addDialogCustomColumns;
                customColumnsLength = customColumns.length;
                if (column && $element.length>0)
                    value = proxy.getCurrentEditCellData($element, column.dropdownData);

                if (proxy.model.ids.indexOf(value) != -1 && value)
                    this._duplicate = true;
                else if (value) {
                    this._duplicate = false;
                }

                if (!this.addFormValidate())
                    return true;
            }
            else
            {
                formelement = doc.getElementById(proxy._id + "GeneralEditForm");
                length = formelement && formelement.length;
                treeGridId = "#treegrid" + proxy._id + "predecessorEdit";
                resourceGridId = "#treegrid" + proxy._id + "resourceEdit";
                customGridId = "#treegrid" + proxy._id + "customFieldEdit";
                noteRteId = "#" + proxy._id + "EditAreaNotes";
                dialogId = "Edit";
                generalColumns = proxy._editDialogGeneralColumns;
                generalColumnsLength = generalColumns.length;
                customColumns = proxy._editDialogCustomColumns;
                customColumnsLength = customColumns.length;

                if (!this.editFormValidate())
                    return true;
            }
            editedRowWrap = $(formelement).closest('div');                    
                      
            if (!this._duplicate) {


                for (var count = 0; count < generalColumnsLength; count++) {
                    $element = $(formelement).find("#" + proxy._id + generalColumns[count].field + dialogId);
                    if ($element.length > 0) {
                        proxy._cellEditColumn = generalColumns[count];
                        if (proxy._cellEditColumn.field == "duration" || proxy._cellEditColumn.field == "startDate" || proxy._cellEditColumn.field == "endDate") {
                            obj[generalColumns[count].mappingName] = this._editedDialogRecord[proxy._cellEditColumn.field];
                            if (proxy._cellEditColumn.field == "duration" && model.durationUnitMapping) {
                                obj[model.durationUnitMapping] = this._editedDialogRecord.durationUnit;
                            }
                            continue;
                        }
                        value = proxy.getCurrentEditCellData($element, generalColumns[count].dropdownData); // formelement[index].value;
                        if (proxy._isinAddnewRecord === false && generalColumns[count].mappingName === proxy.model.predecessorMapping) {
                            args.previousValue = proxy._updatePredecessorValue(null, value);
                        }
                        /*Validate progress value is null or undefined*/
                        if (generalColumns[count].mappingName === proxy.model.progressMapping && ej.isNullOrUndefined(value))
                            value = 0;
                        if ((!model.workMapping && proxy._cellEditColumn.field == "work") || proxy._cellEditColumn.field == "taskType" || proxy._cellEditColumn.field == "effortDriven")
                            obj[generalColumns[count].field] = value;
                        else
                            obj[generalColumns[count].mappingName] = value;
                    }
                }

                // Get the custom column values from custom column table.
                if ($(customGridId).length) {
                    /* save tree grid if it is in edit mode */
                    if ($(customGridId).ejTreeGrid("model.isEdit")) {
                        $(customGridId).ejTreeGrid("saveCell");
                    }
                    var data = $(customGridId).ejTreeGrid("model.updatedRecords");
                    for (var count = 0; count < customColumnsLength; count++) {
                        if (customColumns[count].editType == "dropdownedit")
                            obj[customColumns[count].mappingName] = data[count].value;
                        else
                            obj[customColumns[count].mappingName] = data[count].text;
                    }
                }
                // Adding notes value to newly added task.
                var noteRte = $(noteRteId);
                if (noteRte.length) {
                    obj[model.notesMapping] = noteRte.ejRTE("getHtml");
                }

                var date1 = proxy._getDateFromFormat(obj[model.startDateMapping]),
                date2 = proxy._getDateFromFormat(obj[model.endDateMapping]);
                var diffdays=0;
                if (date1 && date2)
                    diffdays = date2.getTime() - date1.getTime();
                if (diffdays < 0)
                    this._wrongenddate = true;
                else
                    this._wrongenddate = false;
                if (!this._wrongenddate) {
                    // when adding new task resource value changes.
                    var resourceGrid = $(resourceGridId), resourceFlag = true;
                    if (resourceGrid.length > 0) {
                        /* save tree grid if it is in edit mode */
                        if ($(resourceGrid).ejTreeGrid("model.isEdit")) {
                            $(resourceGrid).ejTreeGrid("saveCell");
                        }
                        var resource = [];
                        var data = $(resourceGridId).ejTreeGrid("option", "dataSource"),
                            selectedRowIndex = $(resourceGridId).ejTreeGrid("option", "selectedRowIndex");
                        $.each(data, function (indx, value) {
                            if (value.name != null && value.name != "") {
                                var index = $.map(model.resources, function (resource, index) {
                                    if (resource[model.resourceIdMapping].toString() == value.name) {
                                        return index;
                                    }
                                });
                                
                                var newResource = model.resources[index[0]];
                                if (saveType === "Add") {
                                    resource.push(newResource[model.resourceIdMapping]);
                                    newResource[model.resourceUnitMapping] = value.unit;
                                    proxy._newRecordResourceCollection.push(newResource);
                                }
                                    //update duration, work, resource units of a task, while add/remove/changes in existing resource unit.
                                else {

                                    if (ej.isNullOrUndefined(model.selectedItem.resourceInfo))
                                        model.selectedItem.resourceInfo = [];

                                    var ganttModel = proxy.model,
                                        ganttRecord = ganttModel.selectedItem,
                                        resourceInfo = ganttRecord.resourceInfo,
                                        resourceIdMapping = ganttModel.resourceIdMapping;

                                    if (ej.isNullOrUndefined(resourceInfo) || resourceInfo.length != data.length)
                                        proxy._isResourceAddedOrRemoved = true;

                                    if (resourceInfo) {
                                        for (var index = 0; index < resourceInfo.length; index++) {
                                            if (resourceInfo[index][resourceIdMapping] === newResource[resourceIdMapping]) {
                                                var resourceIndex = index;
                                                break;
                                            }
                                            else
                                                var resourceIndex = -1;
                                        }
                                    } else {
                                        resourceInfo = [];
                                    }
                                    if ((ej.isNullOrUndefined(resourceIndex) || resourceIndex == -1) &&  resourceInfo.length != data.length) {
                                        var ganttRecordResource = $.extend({}, newResource);
                                        ganttModel.selectedItem._updateResourceUnit(newResource, ganttRecordResource, model.resourceUnitMapping);
                                        //Unit for newly selected resource should be 100, even there is a defined unit for the selected resource.
                                        ganttRecordResource[model.resourceUnitMapping] = 100;
                                        resourceInfo.push(ganttRecordResource);                                        
                                    }
                                    if (resourceInfo[indx][model.resourceUnitMapping] != data[indx].unit)
                                        proxy._isExistingUnitIsUpdated = true;

                                    resourceInfo[indx][model.resourceIdMapping] = parseInt(data[indx].name);
                                    resourceInfo[indx][model.resourceNameMapping] = model.resources[parseInt(data[indx].name)-1][model.resourceNameMapping];
                                    resourceInfo[indx][model.resourceUnitMapping] = data[indx].unit;
                                    resource.push(resourceInfo[indx]);

                                    //update duration as per changes in existing resources unit before adding new resources.
                                    if (proxy._isExistingUnitIsUpdated) {
                                        if (!ganttRecord.isAutoSchedule || ganttRecord.taskType == "fixedDuration")
                                            ganttRecord._updateWorkWithDuration(proxy);
                                        else
                                            ganttRecord._updateDurationWithWork(proxy);
                                        obj.Duration = ganttRecord.duration;
                                        if (model.workMapping)
                                            obj[model.workMapping] = ganttRecord.work;
                                        else
                                            obj.work = ganttRecord.work;
                                        proxy._editedDialogRecord.duration = ganttRecord.duration;
                                        proxy._editedDialogRecord.work = ganttRecord.work;
                                        proxy._isExistingUnitIsUpdated = false;
                                    }
                                }
                            }
                            else {
                                resourceFlag = false;
                                return false;
                            }
                        });
                        if (resourceFlag)
                            obj[model.resourceInfoMapping] = resource;
                        else {
                            alert(proxy._alertTexts["dialogResourceAlert"]);
                            return true;
                        }
                }

                if (!obj[model.taskIdMapping] && saveType === "Edit")
                    obj[model.taskIdMapping] = proxy._editedDialogRecord.taskId;

                args.data = obj;

                //getting predecessor from edit dialog table    
                var prdecessor_validation_flag = false;
                var results = [], resultFlag = false;
                if (model.predecessorMapping)
                {
                    if (saveType === "Edit") {
                        resultFlag = model.editDialogFields.length === 0 ? true : false;
                        results = $.grep(model.editDialogFields, function (val, idx) {
                            return (val.field === model.predecessorMapping);
                        });
                    } else if (saveType === "Add")
                    {
                        resultFlag = model.addDialogFields.length === 0 ? true : false;
                        results = $.grep(model.addDialogFields, function (val, idx) {
                            return (val.field === model.predecessorMapping);
                        });
                    }
                }
                if (results.length > 0 || resultFlag)
                {
                    var pre = [];
                    var taskNameFlag = true;

                    /* save tree grid if it is in edit mode */
                    if ($(treeGridId).ejTreeGrid("model.isEdit")) {
                        $(treeGridId).ejTreeGrid("saveCell");
                    }

                    pre = $(treeGridId).ejTreeGrid("option", "dataSource");
                    $.each(pre, function (idx, value) {
                        if (ej.isNullOrUndefined(value.id) || ej.isNullOrUndefined(value.name) || ej.isNullOrUndefined(value.type) || !(value.id.length > 0 && value.name.length && value.type.length))
                        {
                            taskNameFlag = false;
                        }
                    });
                    if (taskNameFlag) {
                        var predecessorColl = [], predecessorString = [],//from,to,offset,predecessorType,isdrawn                        
                        types = proxy._predecessorCollectionText;
                        var tempType;
                        for (var i = 0; i < pre.length; i++) {
                            var predecessor = {};
                            predecessor["from"] = obj.taskID;
                            predecessor["to"] = pre[i].id;
                            predecessor["isdrawn"] = false;
                            predecessor["offset"] = pre[i].offset;
                            for (var j = 0; j < types.length; j++) {
                                if (pre[i].type == types[j].text) {
                                    predecessor["predecessorType"] = types[j].id;
                                    tempType = types[j].id;
                                    break;
                                }
                            }
                            var tem = pre[i].id + tempType//+data[i].lags.toString();
                            pre[i].offset = parseFloat(pre[i].offset);
                            if (pre[i].offset !== 0) {
                                if (pre[i].offset < 0)
                                    tem += pre[i].offset.toString();
                                else
                                    tem += "+" + pre[i].offset.toString();
                            }
                            predecessorString.push(tem);
                            predecessorColl.push(predecessor);
                        }
                        args.predecessorString = predecessorString;
                    } else {
                        //Break here and give notification to users
                        alert(proxy._alertTexts["predecessorAddingValidationAlert"]);
                        return true;
                    }
                    //Validate predecessoe for editing
                    if (proxy._isinAddnewRecord === false) {
                        args.currentRecord = model.selectionMode == "row" ? this.selectedItem() : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        if(proxy._editedPredecessorValidation(args))
                        {
                            args.previousValue = proxy._updatePredecessorValue(null, predecessorString.join(','));
                        }
                        else {
                            alert(proxy._alertTexts["predecessorEditingValidationAlert"]);
                            return true;
                        }
                    }
                    obj[model.predecessorMapping] = predecessorString.join(',');
                }

                args.requestType = ej.TreeGrid.Actions.Save;
                args.recordIndex = (this.selectedRowIndex() !== -1) ? this.selectedRowIndex() : -1;
                if (proxy._trigger("actionBegin", args))
                    return true;
                if (saveType === "Edit") {
                    args._cModifiedData = proxy._updateRecord(obj);
                    if (proxy._editedDialogRecord) {
                        args._cModifiedData.startDate = new Date(proxy._editedDialogRecord.startDate);
                        args._cModifiedData.endDate = new Date(proxy._editedDialogRecord.endDate);
                        args._cModifiedData.duration = proxy._editedDialogRecord.duration;                        
                        args._cModifiedData.durationUnit = proxy._editedDialogRecord.durationUnit;
                        if (proxy._isResourceAddedOrRemoved)
                            proxy._updateResourceRelatedFields(args._cModifiedData);
                        model.durationUnitMapping && (args._cModifiedData.item[model.durationUnitMapping] = proxy._editedDialogRecord.durationUnit);
                        proxy._editedDialogRecord = null;
                    }
                    if (args.data[model.endDateMapping] && (ej.isNullOrUndefined(args.data[model.durationMapping]) || args.data[model.durationMapping] === "") && proxy._isDurationUpdated == false) {
                        args._cModifiedData.startDate = proxy._checkStartDate(args._cModifiedData.startDate, args._cModifiedData);
                        args._cModifiedData.endDate = proxy._checkEndDate(args._cModifiedData.endDate, args._cModifiedData);
                        args._cModifiedData._calculateDuration(this);
                    }
                    /*Milestone status update if start date,end date , duration fields not given in edit dialog fields*/
                    if (args._cModifiedData.duration == 0 && args._cModifiedData.startDate.getTime() == args._cModifiedData.endDate.getTime())
                        args._cModifiedData.isMilestone = true;
                    else
                        args._cModifiedData.isMilestone = false;
                    if (args.data[model.baselineStartDateMapping] && args.data[model.baselineEndDateMapping])
                    {
                        var baseLineStartDate = proxy._getDateFromFormat(args.data[model.baselineStartDateMapping]),
                            baseLineEndDate = proxy._getDateFromFormat(args.data[model.baselineEndDateMapping]);
                        if (baseLineEndDate && baseLineEndDate.getHours() == 0 && this._defaultEndTime != 86400)
                            this._setTime(this._defaultEndTime, baseLineEndDate);
                        args._cModifiedData.baselineStartDate = this._checkBaseLineStartDate(baseLineStartDate);
                        args._cModifiedData.baselineEndDate = this._checkBaseLineEndDate(baseLineEndDate);
                        args._cModifiedData.baselineLeft = args._cModifiedData._calculateBaselineLeft(this);
                        args._cModifiedData.baselineRight = args._cModifiedData._calculateBaselineRight(this);
                        args._cModifiedData.baselineWidth = args._cModifiedData._calculateBaseLineWidth(this);
                    }
                    args.modifiedRecord = args._cModifiedData;                    
                    proxy.actionComplete(args);
                }
                else if (saveType === "Add") {
                    var rowPosition = proxy._addPosition != null ? proxy._addPosition : model.editSettings.rowPosition;
                    if (!proxy.addRecord(obj, rowPosition)) {
                        alert(proxy._alertTexts["predecessorEditingValidationAlert"]);
                        return true;
                    }                 
                }  
                proxy._cModifiedData = null;
                proxy._cAddedRecord = null;
                proxy._primaryKeyValues = [];
                proxy._isinAddnewRecord = false;
                proxy._isResourceAddedOrRemoved = false;
                return false;
                }
                else {
                    alert(proxy._alertTexts["dateValidationAlert"]);
                    return true;
                }
            }
            else {
                alert(proxy._alertTexts["idValidationAlert"]);
                return true;
            }   
        },

        _recordReturnerByID:function(id)
        {
            var proxy = this,
                records = proxy.model.flatRecords;
            for (var i = 0; i < records.length; i++) {
                if (records[i].taskId.toString() === id.toString()) {
                    return records[i]
                }
            }
            return null;

        },
        _editedPredecessorValidation: function (args) {

            var proxy = this,
                flag = true,
                recordId = args.currentRecord.taskId, currentId,
                predecessor = args.predecessorString.join(','), predecessorIdArray;
            if (predecessor.length > 0) {
                predecessorIdArray = proxy._idFromPredecessor(predecessor);
                for (var count = 0; count < predecessorIdArray.length; count++) {
                    //Check edited item has parent item in predecessor collection
                    var editingData = args.currentRecord;
                    if (editingData && editingData.parentItem) {
                        if (predecessorIdArray.indexOf(editingData.parentItem.taskId.toString()) !== -1) {
                            return false;
                        }
                    }
                    // Check if predecessor exist more then one 
                    var tempIdArray = predecessorIdArray.slice(0),checkArray=[],countFlag=true;
                    $.each(tempIdArray, function (index, value) { 
                        if(checkArray.indexOf(value)===-1)
                            checkArray.push(value);
                        else
                            countFlag = false;
                    });
                    if (countFlag === false) {
                        return false;

                    }
                    //Cyclick check  
                    currentId = predecessorIdArray[count];
                    var visitedIdArray = [];
                    var predecessorCollection = predecessorIdArray.slice(0);
                    predecessorCollection.splice(count, 1);


                    while (currentId !== null) {
                        var currentIdArray = [], currentIdIndex,
                            currentRecord;
                        if (visitedIdArray.indexOf(currentId) === -1)
                        {
                            currentRecord = proxy._recordReturnerByID(currentId);
                            //Predecessor id not in records collection
                            if (ej.isNullOrUndefined(currentRecord))
                                return false;
                          //  var currentPredecessor="";
                            if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length>0)
                            {
                                $.each(currentRecord.predecessor, function (index, value) {
                                    if (currentRecord.taskId.toString() !== value.from) {
                                        currentIdArray.push(value.from.toString());
                                        currentIdIndex = index;
                                    }
                                });
                            //    currentPredecessor=currentRecord.predecessor[0].from
                            }
                            if (recordId.toString() === currentRecord.taskId.toString() || currentIdArray.indexOf(recordId.toString()) !== -1) { // || predecessorCollection.indexOf(currentPredecessor) !== -1
                                //cycylic occurs//break;
                                return false;
                            }
                            visitedIdArray.push(currentId);
                            if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length > 0) {
                                var result;
                                if (currentIdArray.length > 1) {
                                    result=this._predecessorValidation(currentIdArray, args);
                                }
                                else if (currentIdArray.length == 1)
                                    currentId = currentRecord.predecessor[currentIdIndex].from;

                                if (result === false) {
                                    return false;
                                }
                            }
                            else
                                break;
                        }
                        else
                        {
                            break;
                        }
                    }
                }
            }
            return flag;
        },

        _predecessorValidation: function (predecessor,args) {
            var proxy = this;
            var recordId = args.currentRecord.taskId, currentId, currentRecord;
            for (var count = 0; count < predecessor.length; count++) {
                currentId = predecessor[count];
                var visitedIdArray = [];
                var predecessorCollection = predecessor.slice(0);
                predecessorCollection.splice(count, 1);

                while (currentId !== null) {
                    var currentIdArray = [];
                    if (visitedIdArray.indexOf(currentId) === -1) {
                        currentRecord = proxy._recordReturnerByID(currentId);
                        //Predecessor id not in records collection
                        if (ej.isNullOrUndefined(currentRecord))
                            return false;

                        if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length > 0) {
                            $.each(currentRecord.predecessor, function (index, value) {
                                if (currentRecord.taskId.toString() !== value.from)
                                    currentIdArray.push(value.from.toString());
                            });
                        }
                        if (recordId.toString() === currentRecord.taskId.toString() || currentIdArray.indexOf(recordId.toString()) !== -1) { // || predecessorCollection.indexOf(currentPredecessor) !== -1
                            //cycylic occurs//break;
                            return false;
                        }
                        visitedIdArray.push(currentId);
                        if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length > 0) {
                            currentId = currentRecord.predecessor[0].from;
                        }
                        else
                            break;
                    }
                    else {
                        break;
                    }
                }
            }
            return true;
            
        },
        _sendCancelRequest: function () {
            var proxy = this,
                model=proxy.model,
                args = {};

            if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                $("#" + proxy._id + "EditForm").find(".e-datepicker").ejDateTimePicker("destroy");
            else
                $("#" + proxy._id + "EditForm").find(".e-datepicker").ejDatePicker("destroy");

            args.requestType = ej.TreeGrid.Actions.Cancel;
            proxy._$treegridHelper.ejTreeGrid("processBindings", args);
            proxy._primaryKeyValues = [];
            proxy.model.currentData = null;
        },
        //obj contains gantt record
        _updatePredecessorValue: function (obj, value) {
            var proxy = this,
                prevPredecessors,
                model = this.model,
                modifiedPredecessors,
                length=0,
                predecessor,
                ganttPredecessor = [],
                count = 0,
                selectedItem = !ej.isNullOrUndefined(obj) ? obj : model.selectionMode == "row" ? proxy.selectedItem() : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
            prevPredecessors = selectedItem["predecessor"];

            if (value.length > 0) {
                modifiedPredecessors = selectedItem._calculatePredecessor(value, this._durationUnitEditText, this.model.durationUnit);
            }
            if (modifiedPredecessors)
                length = modifiedPredecessors.length;

            var index = 0, prevPrdecessorlength=0;
            if(prevPredecessors)
                prevPrdecessorlength = prevPredecessors.length;


            for (index = 0; index < prevPrdecessorlength; index++) {
                predecessor = prevPredecessors[index];
                if (predecessor.from === selectedItem.taskId.toString()) {
                    ganttPredecessor.push(predecessor);
                }
            }
            for (count = 0; count < length; count++) {
                ganttPredecessor.push(modifiedPredecessors[count]);
            }
            selectedItem.predecessor = ganttPredecessor;
            if (proxy.model.predecessorMapping) {
                selectedItem.item[proxy.model.predecessorMapping] = value;
                selectedItem.predecessorsName = value;
            }

            return prevPredecessors;          //
        },


        getCurrentEditCellData: function ($element, dropdownData) {
            var proxy = this, model = proxy.model, date;
            if ($("#" + proxy._id + "EditForm").length || $("#" + proxy._id + "GeneralAddForm").length || $("#" + proxy._id + "GeneralEditForm").length) {
                var cellValue="";// $element = $("#" + proxy._id + proxy._columnFieldName), 
                switch (proxy._cellEditColumn.editType) {
                    case ej.TreeGrid.EditingType.String:
                        cellValue = $element.val();
                        break;
                    case ej.TreeGrid.EditingType.Numeric:
                        cellValue = $element.ejNumericTextbox("getValue");
                        break;
                    case ej.TreeGrid.EditingType.Dropdown:
                        if ($element.attr("id").indexOf("resourceInfo") > 0) {
                            cellValue = proxy._getSelectedItem($element.ejDropDownList("model.selectedItems"), dropdownData);
                        }
                        else if ($element.attr("id").indexOf("taskMode") > 0) {
                            cellValue = $element.ejDropDownList("model.value") == "true" ? true : false;
                        }
                        else
                            cellValue = $element.ejDropDownList("model.value");
                        break;
                    case ej.TreeGrid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:
                        date = $element.ejDatePicker("model.value");

                        if (proxy._cellEditColumn && !proxy._cellEditColumn.format) {
                            cellValue = proxy.getFormatedDate(date);
                        } else {
                            cellValue = date;
                        }
                        break;
                    case ej.TreeGrid.EditingType.DateTimePicker:
                        date = $element.ejDateTimePicker("model.value");
                        if (proxy._cellEditColumn && !proxy._cellEditColumn.format) {
                            cellValue = cellValue = proxy.getFormatedDate(date);
                        } else {
                            cellValue = date;
                        }
                        break;
                    case ej.TreeGrid.EditingType.Maskedit:
                        cellValue = $element.ejMaskEdit("model.value");
                        break;
                }
                return cellValue;
            }
            return null;
        },


        _getSelectedItem: function (indexArray, dropDownData) {
            var count = 0,
                length = indexArray.length,
                    selectedItems = [];
            if (dropDownData) {
                for (count = 0; count < length; count++) {
                    $.each(dropDownData, function (index, resourceInfo) {
                        if (indexArray[count] === index) {
                            selectedItems.push(resourceInfo);
                        }
                    });
                }
            }

            return selectedItems;
        },

        _getDropDownText: function (column,indexArray) {
            var count = 0,
                length, editParams, value, text,
                dropDownData = column.dropdownData,
                selectedDropDownText = [];
            indexArray = indexArray.split(",");
            length = indexArray.length;
            editParams = column.editParams;
            if (editParams && editParams.fields) {
                text = editParams.fields.text ? editParams.fields.text : "text";
                value = editParams.fields.value ? editParams.fields.value : "value";
            }
            else {
                value = "value";
                text = "text";
            }
            for (var i = 0; i < length; i++) {
                $.each(dropDownData, function (index, data) {
                    if (!ej.isNullOrUndefined(data[value])) {
                        if (indexArray[i] === data[value].toString()) {
                            selectedDropDownText.push(data[text]);
                            return false;
                        }
                    }
                    else
                    {
                        if (indexArray[i] === data[text].toString()) {
                            selectedDropDownText.push(data[text].toString());
                            return false;
                        }
                    }
                });
            }
            return selectedDropDownText.join(",");
        },
        _updateRecord: function (data) {
            var proxy = this, model = this.model,
                columns=proxy._columns,
               length,
                index = 0,
                targetIndex = model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell,
                ganttRecord = proxy.getUpdatedRecords()[targetIndex];
            proxy._isUpdateOffset = false;

            if (model.editDialogFields.length > 0) {
                var filteredColumns = [];
                var count = 0, resultColumn;
                for (; count < model.editDialogFields.length; count++) {
                    resultColumn = $.grep(proxy._columns, function (val) {
                        return val.mappingName === model.editDialogFields[count].field;
                    });
                    resultColumn.length && filteredColumns.push(resultColumn[0]);
                }
                columns = filteredColumns;
            }
            length = columns.length;

            for (index = 0; index < length; index++) {

                if (columns[index].field.toString() === "predecessor")
                    continue;
                //for predecessor from edit dialog window 
                if ((columns[index].field == "startDate")) {
                    if(ganttRecord[columns[index].field].getTime() != data[columns[index].mappingName].getTime())
                        proxy._isUpdateOffset = true;
                }
                if (columns[index].field == "endDate"){
                    if (ganttRecord[columns[index].field].getTime() != data[columns[index].mappingName].getTime())
                        proxy._isUpdateOffset = true;
                }
                if (columns[index].field == "duration") {
                    if (ganttRecord[columns[index].field] != data[columns[index].mappingName])
                        proxy._isUpdateOffset = true;
                }
                if (columns[index].field == "taskMode") {
                    ganttRecord["isAutoSchedule"] = !data[model.taskSchedulingModeMapping];                    
                }
                if (columns[index].field != "work" && columns[index].field != "taskType") {
                    ganttRecord[columns[index].field] = data[columns[index].mappingName];
                    ganttRecord.item[columns[index].mappingName] = data[columns[index].mappingName];//field
                }
                if (columns[index].field == "work") {                    
                    if (model.workMapping) {
                        ganttRecord[columns[index].field] = data[columns[index].mappingName];
                        ganttRecord.item[columns[index].mappingName] = data[columns[index].mappingName];
                    }
                    else
                        ganttRecord[columns[index].field] = data[columns[index].field];
                }
                if (columns[index].field == "taskType" || columns[index].field == "effortDriven")
                    ganttRecord[columns[index].field] = data[columns[index].field];
                if (columns[index].field.toString() === "resourceInfo")
                    proxy._updateResourceName(ganttRecord);
                if (columns[index].field.toString() === "notesText") {
                    ganttRecord["notes"] = data[model.notesMapping];
                    ganttRecord["notesText"] = proxy._getPlainText(data[model.notesMapping]);
                    ganttRecord.item[model.notesMapping] = data[model.notesMapping];
                }
            }
            return ganttRecord;
            
        },
        updateRecordByTaskId: function(data){
            var proxy = this, model = proxy.model,
                flatIndex,updatedIndex, taskId = data[model.taskIdMapping],
                id = typeof (taskId) == 'number' ? taskId.toString() : typeof (taskId) == 'string' ? taskId : null;
            if (!ej.isNullOrUndefined(id)) {
                flatIndex = model.ids.indexOf(id);
                if (flatIndex > -1) {
                    var flatRecord = model.flatRecords[flatIndex],
                        updatedIndex = model.updatedRecords.indexOf(flatRecord);                    
                        proxy.updateRecordByIndex(updatedIndex, data);
                }
            }
        },

        updateRecordByIndex: function (index, data) {
            var proxy = this,
                model = proxy.model,
                updatedRecords = model.updatedRecords, args = {},
                recordIndex = index, ganttRecord,
                record = recordIndex > -1 ? updatedRecords.length > 0 ? updatedRecords[recordIndex] : null : null;
            proxy.cancelEditCell();
            if (!ej.isNullOrUndefined(record)) {
                var ganttRecord, columns = proxy.getColumns();
                data[model.taskIdMapping] = record.item[model.taskIdMapping];
                ganttRecord = proxy._createGanttRecord(data, record.level, record.parentItem, undefined);
                record.isAutoSchedule = ganttRecord.isAutoSchedule;
                record.isMilestone = ganttRecord.isMilestone;

                for (var colIndex = 0; colIndex < columns.length; colIndex++) {
                    var column = columns[colIndex], fieldName = column.field;
                    if (!ej.isNullOrUndefined(column.mappingName)) {

                        if(fieldName == "taskId")
                            continue;
                        else if (record.hasChildRecords && record.isAutoSchedule && (fieldName == "startDate" || 
                            fieldName == "endDate" || fieldName == "duration" || fieldName == "status" || fieldName == "predecessor"
                            || fieldName == "WBSPredecessor" ))
                            continue;
                        if (fieldName == "predecessor") {
                            var predecessorName = ej.isNullOrUndefined(ganttRecord.item[model.predecessorMapping]) ? "" :
                                                    ganttRecord.item[model.predecessorMapping];
                            args.previousValue = proxy._updatePredecessorValue(record, predecessorName);
                        }
                        else if (fieldName == "duration" && !ej.isNullOrUndefined(ganttRecord.item[model.durationUnitMapping])) {
                            record.item[model.durationUnitMapping] = ganttRecord.item[model.durationUnitMapping];
                            record.durationUnit = ganttRecord.durationUnit;
                            record[fieldName] = ganttRecord[fieldName];
                            record.item[column.mappingName] = ganttRecord.item[column.mappingName];
                        }
                        else if (fieldName == "notesText") {
                            record.notes = ganttRecord.notes;
                            record.notesText = ganttRecord.notesText;
                            record.item[model.notesMapping] = ganttRecord.item[model.notesMapping];
                        }
                        else {
                            record[fieldName] = ganttRecord[fieldName];
                            record.item[column.mappingName] = ganttRecord.item[column.mappingName];
                        }
                    }
                }                
                args.requestType = ej.TreeGrid.Actions.Save;
                args.recordIndex = recordIndex;
                args._cModifiedData = record;
                proxy.actionComplete(args);
            }
        },

        _sendIndentRequest: function () {

            var proxy = this,
                model = proxy.model,
                data = proxy.getCurrentData(),
                args = {},
                eveargs = {},
                previousGanttRecord,
                isRefresh = false,
                treeGridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            proxy.cancelEditCell();
            if (ej.isNullOrUndefined(data)) {
                alert(proxy._alertTexts["indentAlert"]);
            }
            else {
                previousGanttRecord = model.flatRecords[model.flatRecords.indexOf(data) - 1];
                args.data = data;
                args.requestType = "indent";
                if (!proxy._trigger("actionBegin", args)) {

                    if (data.parentItem) {
                        var childIndex = data.parentItem.childRecords.indexOf(data);
                        data.parentItem.childRecords.splice(childIndex, 1);
                        if (!model.parentTaskIdMapping)
                            data.parentItem.item[model.childMapping].splice(childIndex, 1);
                    } else {
                        if (this.dataSource() instanceof ej.DataManager) {
                            if (this.dataSource().dataSource.offline && this.dataSource().dataSource.json) {
                                var dataSourceIndex = this.dataSource().dataSource.json.indexOf(data.item);
                                if (!model.parentTaskIdMapping)
                                    this.dataSource().dataSource.json.splice(dataSourceIndex, 1);
                            }
                            else if (proxy._isDataManagerUpdate) {
                                var dataSourceIndex = proxy._jsonData.indexOf(data.item);
                                if (!model.parentTaskIdMapping) {
                                    proxy._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDatamanagerData");
                                    proxy._jsonData.splice(dataSourceIndex, 1);
                                }
                            }
                        }
                        else {
                            var dataSourceIndex = this.dataSource().indexOf(data.item);
                            if (!model.parentTaskIdMapping)
                                this.dataSource().splice(dataSourceIndex, 1);
                        }
                    }
                    if (data.level === previousGanttRecord.level) {
                        if (previousGanttRecord.childRecords) {
                            if (!previousGanttRecord.expanded) {
                                previousGanttRecord.childRecords.splice(previousGanttRecord.childRecords.length, 0, data);
                                data.parentItem = previousGanttRecord;
                                if (!model.parentTaskIdMapping)
                                    previousGanttRecord.item[model.childMapping].splice(previousGanttRecord.childRecords.length, 0, data.item);
                                else
                                    data.item[model.parentTaskIdMapping] = previousGanttRecord.taskId;
                            }
                        } else {
                            previousGanttRecord.childRecords = [];
                            previousGanttRecord.childRecords.push(data);
                            previousGanttRecord.expanded = true;
                            previousGanttRecord.taskType = ej.Gantt.TaskType.FixedDuration;
                            previousGanttRecord.effortDriven = "false";                            
                            data.parentItem = previousGanttRecord;
                            previousGanttRecord.item[model.childMapping] = [];
                            if (!model.parentTaskIdMapping)
                                previousGanttRecord.item[model.childMapping].push(data.item);
                            else
                                data.item[model.parentTaskIdMapping] = previousGanttRecord.taskId;
                        }
                    } else if (previousGanttRecord.level - data.level === 1) {
                        previousGanttRecord.parentItem.childRecords.splice(previousGanttRecord.parentItem.childRecords.length, 0, data);
                        if (!model.parentTaskIdMapping)
                            previousGanttRecord.parentItem.item[model.childMapping].splice(previousGanttRecord.parentItem.childRecords.length, 0, data.item);
                        else
                            data.item[model.parentTaskIdMapping] = previousGanttRecord.parentItem.taskId;
                        data.parentItem = previousGanttRecord.parentItem;
                    } else if (previousGanttRecord.level - data.level > 1) {

                        var parentItem = proxy.getParentItem(previousGanttRecord, data.level);
                        parentItem.childRecords.splice(parentItem.childRecords.length, 0, data);
                        if (!model.parentTaskIdMapping)
                            parentItem.item[model.childMapping].splice(parentItem.childRecords.length, 0, data.item);
                        else
                            data.item[model.parentTaskIdMapping] = parentItem.taskId;
                        data.parentItem = parentItem;

                    }

                    if (data.parentItem.isMilestone) {
                        data.parentItem.isMilestone = false;
                    }
                    previousGanttRecord.hasChildRecords = previousGanttRecord.childRecords ? previousGanttRecord.childRecords.length > 0 : false;
                    data.level += 1;

                    if (treeGridObject._searchString.length > 0 || treeGridObject.model.sortSettings.sortedColumns.length > 0) {
                        isRefresh = true;
                    }
                    proxy.updateLevel(data, +1, isRefresh);

                    if (!isRefresh)
                        proxy.refreshGanttRecord(data);

                    //update parent recordsCollections
                    if (previousGanttRecord.level === 0) {
                        if (model.parentRecords.indexOf(previousGanttRecord) === -1) {
                            model.parentRecords.push(previousGanttRecord);
                        }
                    }
                    if (data.level > 0) {
                        if (model.parentRecords.indexOf(data) !== -1) {
                            var idx = model.parentRecords.indexOf(data);
                            model.parentRecords.splice(idx, 1);
                        }
                    }
                    //Update parentitem
                    if (data.parentItem && data.parentItem.isAutoSchedule) {
                        proxy._updateParentItem(data);
                    }
                    else if (data.parentItem && !data.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(data);
                    //Remove child predecessor from Parent item
                    if (data.parentItem && data.parentItem.predecessor && model.predecessorMapping) {
                        proxy._updatePredecessorOnIndentOutdent(data.parentItem);
                    }
                    if (!isRefresh)
                        proxy.refreshGanttRecord(previousGanttRecord);



                    if (!proxy.getExpandStatus(data)) {
                        var expanargs = {};
                        expanargs.expanded = true;
                        expanargs.data = data.parentItem;
                        proxy.expanding(expanargs);
                    }
                    proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());
                    if (isRefresh) {
                        

                        args.requestType = "indent";
                        //update oudented reocords as per searching and sorting
                        proxy._$treegridHelper.ejTreeGrid("processBindings", args);
                        var tempArgs = {};
                        tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                        proxy.model.updatedRecords = proxy.getUpdatedRecords();
                        proxy.model.currentViewData = proxy.getCurrentViewData();
                        proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
                        proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
                        proxy.updateAltRow(model.updatedRecords, 0, 1);
                    }

                    if (model.predecessorMapping) {
                        proxy._isValidationEnabled = false;
                        proxy._connectorlineIds = [];
                        proxy._connectorLinesCollection = [];
                        proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                        proxy._createConnectorLinesCollection();
                    }

                    //row selection
                    var rowToindex = model.updatedRecords.indexOf(data);
                    var $ganttChartRows = proxy.getGanttChartRows();
                    args = {
                        rowElement: $ganttChartRows.eq(rowToindex),
                        data: proxy.model.selectedItem,
                        recordIndex: rowToindex
                    };

                    proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                    proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                    this.selectedItem(args.data);
                    this.selectedRowIndex(args.recordIndex);
                    if (model.allowSelection && model.selectionMode != "cell")
                        proxy.updateIndentOutdentOption(data);
                    if (model.enableWBS) {
                        var parentVal = data.parentItem.WBS,
                            inRowIndex = data.parentItem.childRecords.length,
                            target = [data];
                        //Updating WBS for the indent record
                        proxy.reCalculateWBS(target, inRowIndex, parentVal);
                        //Updating WBS for corresponding below records
                        proxy.updateWBSdetails(data.parentItem);
                    }
                    eveargs.data = data;
                    eveargs.requestType = "indent";
                    this._trigger("actionComplete", eveargs);
                }
            }
            if (this.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                this.showCriticalPath(true);
            }
        },
        
        _updatePredecessorOnIndentOutdent:function(parentRecord)
        {

            var proxy = this, len = parentRecord.predecessor.length,
                predecessorCollection = parentRecord.predecessor,
                predecessorIndex,
                childRecord,
                id,
                updatedPredecessor = [],
                model = proxy.model;
            for (var count = 0; count < len; count++) {
                //remove predecessor connect with parent item
                if (predecessorCollection[count].to === parentRecord.taskId.toString()) {
                    childRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessorCollection[count].from)];
                    predecessorIndex = childRecord.predecessor.indexOf(predecessorCollection[count]);
                    childRecord.predecessor.splice(predecessorIndex, 1);
                    id = "parent" + childRecord['taskId'] + "child" + parentRecord['taskId'];
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", id);
                    this._updateConnectorLineCollection(id);
                }
                    //remove predecessor if parent record as predecessor of it's child record
                else if (predecessorCollection[count].from === parentRecord.taskId.toString()) {
                    childRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessorCollection[count].to)];
                    if (parentRecord.childRecords.indexOf(childRecord) !== -1) {
                        predecessorIndex = childRecord.predecessor.indexOf(predecessorCollection[count]);
                        childRecord.predecessor.splice(predecessorIndex, 1);
                        var stringPredecessor = proxy._predecessorToString(childRecord.predecessor, childRecord);
                        childRecord.item[model.predecessorMapping] = stringPredecessor;
                        childRecord.predecessorsName = stringPredecessor;
                        if (model.enableWBS && model.enableWBSPredecessor) {
                            proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", childRecord);
                        }
                        id = "parent" + parentRecord['taskId'] + "child" + childRecord['taskId'];
                        proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", id);
                        this._updateConnectorLineCollection(id);
                        proxy.refreshGanttRecord(childRecord);
                    }
                    else
                    {
                        updatedPredecessor.push(predecessorCollection[count]);
                    }
                }
            }
            parentRecord.predecessor = updatedPredecessor;
            parentRecord.item[model.predecessorMapping] = "";
            parentRecord.predecessorsName = "";
            if (model.enableWBS && model.enableWBSPredecessor) {
                parentRecord["WBSPredecessor"] = "";
                parentRecord["item"]["WBSPredecessor"] = "";
            }

            //if (updatedPredecessor.length > 0) {
            //    proxy._updatedConnectorLineCollection = [];
            //    proxy._connectorlineIds = [];
            //    proxy._validatePredecessor(parentRecord);
            //    if (proxy._updatedConnectorLineCollection.length > 0) {
            //        proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
            //    }
            //}
        },
        
        _removePredecessor:function(predecessor,record)
        {
            var proxy = this, length = predecessor.length, count = 0, model = proxy.model, parentGanttRecord, childGanttRecord;
            for (count; count < length; count++)
            {
                if (predecessor[count].from !== record.taskId.toString())
                {
                    childGanttRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessor[count].from)];  //index st
                }
                else if (predecessor[count].to !== record.taskId.toString())
                {
                    childGanttRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessor[count].to)];
                }

                if (childGanttRecord) {
                    var cIndex = childGanttRecord.predecessor.indexOf(predecessor[count]);
                    if (cIndex !== -1)
                        childGanttRecord.predecessor.splice(cIndex, 1);

                    if (childGanttRecord.item[model.predecessorMapping]) {
                        childGanttRecord.item[model.predecessorMapping] = proxy._predecessorToString(childGanttRecord.predecessor, childGanttRecord);
                        childGanttRecord.predecessorsName = childGanttRecord.item[model.predecessorMapping];
                        if (model.enableWBS && model.enableWBSPredecessor)
                            proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", childGanttRecord);
                        proxy.refreshGanttRecord(childGanttRecord);
                    }
                }
            }

        },

        _predecessorToString:function(predecessorCollection,record)
        {
            var proxy = this, predecessorString=[],count=0,length=predecessorCollection.length;
            
            for (count; count < length;count++)
            {
                if(record.taskId.toString()!==predecessorCollection[count].from)
                    {
                        var tem = predecessorCollection[count].from + predecessorCollection[count].predecessorsType;
                        predecessorCollection[count].offset = isNaN(predecessorCollection[count].offset) ? 0 : predecessorCollection[count].offset;

                        if (predecessorCollection[count].offset !== 0) {
                            if (predecessorCollection[count].offset < 0)
                                tem += predecessorCollection[count].offset.toString()+"d";
                            else if (predecessorCollection[count].offset > 0)
                                tem += "+" + predecessorCollection[count].offset.toString()+"d";
                        }
                        predecessorString.push(tem);
                }
            }
           
            return predecessorString.join(',');
        },
        //get the parentItem of selected ganttRecord to perform the indent operation
        
        getParentItem:function(ganttRecord,level) {

            var proxy = this;

            if (ganttRecord.parentItem.level === level)
                return ganttRecord.parentItem;

            return proxy.getParentItem(ganttRecord.parentItem, level);
        },

        //Change the position or index for the outdent element 
        getSubChangeIndex: function (itemLevel, itemIndex, item) {
            var proxy = this, changetoIndex;
            for (var items = 0; items < proxy.model.updatedRecords.length; items++) {
                if (proxy.model.updatedRecords[items].level == itemLevel && proxy.model.updatedRecords[items].index > itemIndex) {
                    if (item.parentItem && proxy.model.updatedRecords[items].parentItem.taskId == item.parentItem.taskId)
                        changetoIndex = proxy.model.updatedRecords[items].index;
                    break;
                }
            }
            return changetoIndex;
        },

        //get the next sample level item from 
        _nextSameLevelItem:function(data,totRecords)
        {
            var proxy = this,
                level = data.parentItem.level, dataIndex = totRecords.indexOf(data), nextItem;
            for (var i = dataIndex; i < totRecords.length; i++)
            {
                if (level === totRecords[i].level || level > totRecords[i].level) {
                    nextItem = totRecords[i];
                    break;
                }
            }
            return nextItem;
        },

        //Indent operation for gantt records
        _sendOutdentRequest: function () {
            var proxy = this,
                model = proxy.model,
                data = proxy.getCurrentData(),
                args = {},
                eveargs = {},
                updateNextItem,
                rowNextItem,
                updateInsertIndex,
                rowInsertIndex,
                dataUpdatedRecordIndex,
                dataRowIndex,
                outParent,
                childDataIndex,
                insertParentItem,
                rowNextItemChildIndex,
                dataChildCount, splicedRows, splicedIds;
            proxy.cancelEditCell();
            if (ej.isNullOrUndefined(data)) {
                alert(proxy._alertTexts["outdentAlert"]);
            } else {
                args.data = data;
                args.requestType = "outdent";
                if (!proxy._trigger("actionBegin", args)) {
                    if (data.level === 0 || model.editSettings.allowIndent == false)
                        return;
                    else {
                        //find where to insert data
                        rowNextItem = proxy._nextSameLevelItem(data, model.flatRecords);
                        dataRowIndex = model.flatRecords.indexOf(data);

                        outParent = data.parentItem;
                        childDataIndex = data.parentItem.childRecords.indexOf(data);
                        insertParentItem = data.parentItem.parentItem;
                        rowNextItemChildIndex = insertParentItem && data.parentItem.parentItem.childRecords.indexOf(rowNextItem);

                        //remove data from current parent item
                        data.parentItem.childRecords.splice(childDataIndex, 1);

                        if(!model.parentTaskIdMapping)
                            data.parentItem.item[model.childMapping].splice(childDataIndex, 1);

                        if (data.parentItem.childRecords.length == 0) {

                            data.parentItem.childRecords = null;
                            data.parentItem.expanded = false;
                            data.parentItem.hasChildRecords = false;
                        }
                        else
                        {
                            if (data.parentItem && data.parentItem.isAutoSchedule)
                                proxy._updateParentItem(data.parentItem.childRecords[0]);
                            else if (data.parentItem && !data.parentItem.isAutoSchedule)
                                proxy._updateManualParentItem(data.parentItem.childRecords[0]);
                        }

                        //add to next parent item
                        if (insertParentItem) {
                            if (rowNextItemChildIndex != -1)
                            insertParentItem.childRecords.splice(rowNextItemChildIndex, 0, data);
                            else
                                insertParentItem.childRecords.push(data);
                            if (!model.parentTaskIdMapping) {
                                if (rowNextItemChildIndex != -1)
                                insertParentItem.item[model.childMapping].splice(rowNextItemChildIndex, 0, data.item);
                            else
                                    insertParentItem.item[model.childMapping].push(data.item);
                            }
                            else
                                data.item[model.parentTaskIdMapping] = insertParentItem.taskId;

                            data.parentItem = insertParentItem;
                        } else {

                            if (this.dataSource() instanceof ej.DataManager) {
                                if (this.dataSource().dataSource.offline && this.dataSource().dataSource.json) {
                                    if (!model.parentTaskIdMapping)
                                        this.dataSource().dataSource.json.push(data.item);
                                }
                                else if (proxy._isDataManagerUpdate) {
                                    if (!model.parentTaskIdMapping) {
                                        proxy._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDatamanagerData");
                                        proxy._jsonData.push(data.item);
                                    }
                                }
                            } else {
                                if (!model.parentTaskIdMapping)
                                    if (rowNextItem) {
                                        var index = this.dataSource().indexOf(rowNextItem.item);
                                        this.dataSource().splice(index, 0, data.item);
                                    }
                                    else
                                        this.dataSource().push(data.item);
                            }
                            data.parentItem = null;
                            if (model.parentTaskIdMapping)
                                data.item[model.parentTaskIdMapping] = null;

                        }

                        //Records updates _rows collections
                        dataChildCount = proxy._$treegridHelper.ejTreeGrid("getChildCount", data, 0);
                        splicedRows = model.flatRecords.splice(dataRowIndex, dataChildCount + 1);
                        splicedIds = model.ids.splice(dataRowIndex, dataChildCount + 1);

                        if (rowNextItem) {
                            rowInsertIndex = model.flatRecords.indexOf(rowNextItem);
                        }
                        else {
                            rowInsertIndex = model.flatRecords.length;
                        }

                        if (data.hasChildRecords && data.childRecords.length > 0) {

                            for (var i = 0; i < splicedRows.length; i++) {
                                model.flatRecords.splice(rowInsertIndex, 0, splicedRows[i]);
                                model.ids.splice(rowInsertIndex, 0, splicedIds[i]);
                                splicedRows[i].level -= 1;
                                rowInsertIndex++;
                            }
                        }
                        else {
                            model.flatRecords.splice(rowInsertIndex, 0, splicedRows[0]);
                            model.ids.splice(rowInsertIndex, 0, splicedIds[0]);
                            splicedRows[0].level -= 1;
                        }
                        //update parentitem of selected item after changing of its child 
                        if (data.parentItem) {
                            //change the structure of milestone after outdent
                            if (data.parentItem.isMilestone) {
                                data.parentItem.isMilestone = false;
                            }
                            if (data.parentItem && data.parentItem.isAutoSchedule)
                                proxy._updateParentItem(data);
                            else if (data.parentItem && !data.parentItem.isAutoSchedule)
                                proxy._updateManualParentItem(data);
                        }

                        if (data.hasChildRecords) {
                            if (data.isAutoSchedule)
                                proxy._updateParentItem(data, null, true);
                            else
                                proxy._updateManualParentItem(data, null, true);
                        }

                        //update parent recordsCollections
                        if (data.level === 0) {
                            if (model.parentRecords.indexOf(data) === -1) {
                                model.parentRecords.push(data);
                            }
                        }

                        //update predecessor
                        if (data.predecessor && data.predecessor.length > 0 && model.predecessorMapping && data.hasChildRecords) {
                            proxy._updatePredecessorOnIndentOutdent(data);
                        }

                        if (model.enableVirtualization) {
                            model.updatedRecords = proxy._$treegridHelper.ejTreeGrid("getExpandedRecords", model.flatRecords);
                        }
                        else {
                            model.updatedRecords = model.flatRecords.slice();
                        }

                        //Refreshing the Gantt and TreeGrid data
                        proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords,this.dataSource());
                        args.requestType = "outdent";
                        //update oudented reocords as per searching and sorting
                        proxy._$treegridHelper.ejTreeGrid("processBindings", args);
                        var tempArgs = {};
                        tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);

                        proxy.model.updatedRecords = proxy.getUpdatedRecords();
                        proxy.model.currentViewData = proxy.getCurrentViewData();
                        proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
                        if (proxy.model.predecessorMapping) {
                            proxy._isValidationEnabled = false;
                            proxy._connectorlineIds = [];
                            proxy._connectorLinesCollection = [];
                            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                            proxy._createConnectorLinesCollection();
                        }

                        proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
                        proxy.updateAltRow(model.updatedRecords, 0, 1);

                        //   Making the outdented row as selected row 
                        var rowToindex = model.updatedRecords.indexOf(data);
                        var $ganttChartRows = proxy.getGanttChartRows();
                        args = {
                            data: proxy.model.selectedItem,
                            recordIndex: rowToindex
                        };

                        proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                        proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                        this.selectedItem(args.data);
                        this.selectedRowIndex(args.recordIndex);
                        if (model.allowSelection && model.selectionMode != "cell")
                            proxy.updateIndentOutdentOption(data);
                        if (model.enableWBS) {                           
                            //Updating WBS for the old siblings
                            var oldNxtSibling = outParent.childRecords && outParent.childRecords[childDataIndex];
                            if (oldNxtSibling)
                                proxy.updateWBSdetails(oldNxtSibling, true);
                            //Updating WBS for other records that are below the outdented item
                            proxy.updateWBSdetails(outParent);
                            //Again update the WBS for the updated WBSPredecessor value
                            if (oldNxtSibling)
                                proxy.updateWBSdetails(oldNxtSibling, true, true);
                        }
                        eveargs.data = data;
                        eveargs.requestType = "outdent";
                        this._trigger("actionComplete", eveargs);
                    }
                }
            }
            if (this.isCriticalPathEnable == true) {
                this.showCriticalPath(true, true);
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
            }
        },
        
        _refreshChildLevel: function (ganttRecord) {

            var proxy = this,
                count = 0,
                childRecords = ganttRecord.childRecords,
                length = childRecords.length,
                record;

            for (count = 0; count < length; count++) {
                record = childRecords[count];                
                proxy.refreshGanttRecord(record);
                if (record.hasChildRecords) {
                    proxy._refreshChildLevel(record);
                }
            }
        },

        _updateChildLevel:function(ganttRecord) {

            var proxy = this,
                count = 0,
                childRecords = ganttRecord.childRecords,
                length = childRecords.length,
                record;
            
            for (count = 0; count < length; count++) {
                record = childRecords[count];                
                record.level = record.level - 1;
                // proxy.refreshGanttRecord(record);
                if (record.hasChildRecords) {
                    proxy._updateChildLevel(record);
                }
            }
        },

        _removeChildRecords:function(ganttRecord,index){

            if (ganttRecord.parentItem) {
                var proxy = this,
                    model = proxy.model,
                    childIndex = 0,
                    record,
                    addedChildGanttRecordCount = 0,
                    length = 0,
                    parentChildRecords = ganttRecord.parentItem.childRecords,
                    parentChildRecordsLength = parentChildRecords && parentChildRecords.length;

                for (childIndex = index; childIndex < parentChildRecordsLength; childIndex++) {

                    record = parentChildRecords[childIndex];


                    if (record) {

                        if (ganttRecord.childRecords) {

                            length = ganttRecord.childRecords.length;
                            ganttRecord.childRecords.splice(length, 0, record);
                            if (!model.parentTaskIdMapping)
                                ganttRecord.item[model.childMapping].splice(length, 0, record.item);
                            else
                                record.item[model.parentTaskIdMapping] = ganttRecord.taskId;
                        } else {
                            ganttRecord.childRecords = [];
                            ganttRecord.item[model.childMapping] = [];
                            ganttRecord.childRecords.push(record);
                            if (!model.parentTaskIdMapping)
                                ganttRecord.item[model.childMapping].push(record.item);
                            else
                                record.item[model.parentTaskIdMapping] = ganttRecord.taskId;
                        }
                        record.parentItem = ganttRecord;                                             
                        addedChildGanttRecordCount++;
                    }
                }

                if (ganttRecord.parentItem.childRecords) {

                    ganttRecord.parentItem.childRecords.splice(index, addedChildGanttRecordCount);
                    if(!model.parentTaskIdMapping)
                        ganttRecord.parentItem.item[model.childMapping].splice(index, addedChildGanttRecordCount);
                    if (ganttRecord.parentItem.childRecords.length == 0) {
                        ganttRecord.parentItem.childRecords = null;
                        ganttRecord.parentItem.expanded = false;
                        ganttRecord.parentItem.hasChildRecords = false;
                        proxy.refreshGanttRecord(ganttRecord.parentItem);
                    }
                }
            }
        },

        updateChildGanttRecordLevel: function (data,index) {
            var childIndex = 0, proxy = this, model = proxy.model,
                parentChildRecords = data.parentItem&& data.parentItem.parentItem&& data.parentItem.parentItem.childRecords,
                parentChildRecordsLength =parentChildRecords&&parentChildRecords.length,
                addedChildGanttRecordCount = 0;
            for (childIndex = index; childIndex < parentChildRecordsLength; childIndex++) {
                var childGanttRecord = parentChildRecords[childIndex];
                if (childGanttRecord.childRecords) {
                    childGanttRecord.childRecords.splice(childGanttRecord.childRecords.length, 0, childGanttRecord);
                    childGanttRecord.item[model.childMapping].splice(childGanttRecord.childRecords.length, 0, childGanttRecord.item);
                }
                else {
                    childGanttRecord.childRecords = [];
                    childGanttRecord.item[model.childMapping] = [];
                    if (childGanttRecord) {
                        childGanttRecord.childRecords.push(childGanttRecord);
                        childGanttRecord.item[model.childMapping].push(childGanttRecord.item);
                    }
                }
                proxy.refreshGanttRecord(data.parentItem);
                data.parentItem = childGanttRecord;
                ++addedChildGanttRecordCount;
            }
            data.parentItem.childRecords.splice(index, addedChildGanttRecordCount);
            if (data.parentItem.childRecords.length == 0) {
                data.parentItem.childRecords = null;
                data.parentItem.expanded = false;
                data.parentItem.hasChildRecords = false;
            }

            proxy.refreshGanttRecord(data.parentItem);

        },

        updateLevel: function (childGanttRecord, offset, isRefresh) {
            var proxy = this,
                count = 0,
                childRecords = childGanttRecord.childRecords,
                length =childRecords&& childRecords.length,
                ganttRecord;
            for (count; count < length; count++) {
                ganttRecord = childRecords[count];
                ganttRecord.level += offset;
                if (!isRefresh)
                    proxy.refreshGanttRecord(ganttRecord);
                if (ganttRecord.childRecords) 
                    proxy.updateLevel(ganttRecord, offset, isRefresh);
            }
        },

        addNewGanttRecord: function () {
            var proxy = this, eventArgs = {},newRecord;
            newRecord = this.model.flatRecords[this.model.flatRecords.length].item;
            eventArgs.requestType = "save";
            eventArgs._cAddedRecord = eventArgs.addedRecord = jQuery.extend(true, {}, newRecord);
            eventArgs.recordIndex = newRecord ? (newRecord.recordIndex + 1) : 0;
            proxy.subContextMenuAction(eventArgs);
            proxy._clearContextMenu();
        },
        getExpandStatus: function (record) {

            var parentRecord = record.parentItem;

            if (parentRecord != null) {

                if (parentRecord.expanded === false) {
                    return false;
                } else if (parentRecord.parentItem) {

                    if (parentRecord.parentItem.expanded === false) {
                        return false;
                    } else {
                        return this.getExpandStatus(parentRecord.parentItem);
                    }

                } else return true;
            } else return true;
        },
        subContextMenuAction: function (args) {
            var proxy = this,
                model = proxy.model,
            data = $.extend(true, {}, proxy._contextMenuSelectedItem.item), rowPosition;
            if (!model.durationUnitMapping)
                data.duration = this._getDurationStringValue(proxy._contextMenuSelectedItem);
            delete data[model.childMapping];
            delete data[model.predecessorMapping];
            delete data["WBSPredecessor"];
            delete data[model.taskNameMapping];
            
            if (args.position === "Below") {
                rowPosition = ej.Gantt.RowPosition.BelowSelectedRow;
            } else {
                rowPosition = ej.Gantt.RowPosition.AboveSelectedRow;
            }
            /*Assign or update WBS value*/
            if (model.enableWBS)
                data["WBS"] = proxy._getNewWBSid(rowPosition);
            proxy.addRecord(data, rowPosition);
        },

        /* To recalculate the WBS value */
        reCalculateWBS: function (selectedRecords, lastDigit, parentWBS) {
            var proxy = this, model = proxy.model, final;

            if (parentWBS) {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = lastDigit + i;
                    selectedRecords[i]["WBS"] = parentWBS + "." + final;
                    selectedRecords[i]["item"]["WBS"] = parentWBS + "." + final;
                    if (model.enableWBSPredecessor && model.predecessorMapping)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    proxy.refreshGanttRecord(selectedRecords[i]);
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i]);
                }
            }
            else {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = (lastDigit + i).toString();
                    selectedRecords[i]["WBS"] = final;
                    selectedRecords[i]["item"]["WBS"] = final;
                    if (model.enableWBSPredecessor && model.predecessorMapping)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    proxy.refreshGanttRecord(selectedRecords[i]);
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i]);
                }
            }
        },

        _updateChildWBS: function (parentRecord) {
            var proxy = this, model = proxy.model,
                childRecs = parentRecord.childRecords,
                pWBS = parentRecord["WBS"];
            for (var c = 0; c < childRecs.length; c++) {
                childRecs[c]["WBS"] = pWBS + "." + (c + 1);
                childRecs[c]["item"]["WBS"] = pWBS + "." + (c + 1);
                if (model.enableWBSPredecessor && model.predecessorMapping)
                    proxy._getPredecessorIds(childRecs[c]);
                proxy.refreshGanttRecord(childRecs[c]);
                if (childRecs[c].hasChildRecords) {
                    proxy._updateChildWBS(childRecs[c]);
                }
            }
        },

        /*Get all the predecessor rows that are matching the taskId*/
        _getPredecessorIds: function (pData) {
            var proxy = this,
                model = proxy.model,
                dataTID = pData.taskId,
                flatDatas = model.flatRecords,
                targetRecords = flatDatas.filter(function (item) {
                    if (item["predecessorsName"]) {
                        var prdcList = item["predecessorsName"].split(',');
                        for (var p = 0; p < prdcList.length; p++) {
                            var ref = prdcList[p].match(/(\d+|[A-z]+)/g),
                                refId = +ref[0];
                            if (refId == dataTID)
                                return item;
                        }
                    }
                });
            if (targetRecords.length) {
                for (var t = 0; t < targetRecords.length; t++) {
                    proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", targetRecords[t]);
                    proxy.refreshGanttRecord(targetRecords[t]);
                }
            }
        },

        /*Get new WBS id for newly adding row*/
        _getNewWBSid: function (rowPosition) {
            var proxy = this,
                model = proxy.model,
                data = model.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell], //selected row item before adding the new row
                newWBS;
            if (data)
                newWBS = data["WBS"];//Same WBS value to new row if it is AboveSelectedRow
            else
                newWBS = 1;// While adding new row without selecting the row (i.e. Adding to the TOP)

            //Creating new WBS value to new row if the RowPosition is BelowSelectedRow
            if (data && rowPosition == ej.Gantt.RowPosition.BelowSelectedRow) {
                var lastVal = newWBS.lastIndexOf('.') != -1 ? parseInt(newWBS.substr(newWBS.lastIndexOf('.') + 1)) : parseInt(newWBS),
                    newLastVal = lastVal + 1;                
                if (data.parentItem) {
                    var parentVal = data.parentItem ? data.parentItem.WBS : null;
                    newWBS = parentVal + '.' + newLastVal;
                }
                else {
                    newWBS = newLastVal;
                }               
            }
            return newWBS.toString();
        },

        _getNewTaskId: function (taskId) {
            var proxy = this, tempTaskId;
            if (proxy.model.ids.indexOf(taskId.toString()) == -1) {              
                return taskId == 0 ? 1 : taskId;
            } else {
                taskId++;
                tempTaskId = proxy._getNewTaskId(taskId);
                return tempTaskId;
            }
        },

        contextMenuAction: function (args) {
            var proxy = this;
            if (args.requestType == "contextMenuAdd")
                proxy._sendAddRequest();
            if (args.requestType == "contextMenuIndent")
                proxy._sendIndentRequest();
            if (args.requestType == "contextMenuOutdent")
                proxy._sendOutdentRequest();
            if (args.requestType == "contextMenuDelete")
                proxy._$treegridHelper.ejTreeGrid("deleteRow", null, true, proxy._contextMenuSelectedIndex);
            if (args.requestType == "contextMenuTaskDetails")
                proxy._sendEditRequest();
        },

        _renderContextMenu: function (e, index, item) {

            var proxy = this,
                eventArgs = {},
                args = {},
                posx,
				subposx,
                posy, addItemPositionY,addItemIndex,
                contextMenu,
                contextMenuUList,
                length, columnIndex;
            proxy._contextMenuSelectedIndex = index;
            proxy._contextMenuSelectedItem = item;
            proxy._contextMenuEvent = e;
            columnIndex = proxy._$treegridHelper.ejTreeGrid("getCellIndex", e);
            if (!e) e = window.event;
            if (e.pageX || e.pageY) {
                subposx = posx = e.pageX;
                posy = e.pageY;
            } else if (e.clientX || e.clientY) {
                subposx = posx = e.clientX + document.body.scrollLeft
                    + document.documentElement.scrollLeft;
                posy = e.clientY + document.body.scrollTop
                    + document.documentElement.scrollTop;
            }

            var ganttOffset = this._$treegridHelper.ejTreeGrid("getOffsetRect", proxy.element[0]);
            ganttOffset.bottom = ganttOffset.top + this.element[0].offsetHeight;
            ganttOffset.right = ganttOffset.left + $(this.element).width();            
            args.requestType = "ContextMenuOpen";
            args.contextMenuItems = proxy._contextMenuItems;
            args.columnIndex = columnIndex;
            args.item = proxy._contextMenuSelectedItem;
            args.targetElement = e;
            args.index = index;
            if (proxy._trigger("contextMenuOpen", args))
                return;

            proxy._activeMenuItemId = null;
            proxy._contextMenuItems = args.contextMenuItems;
            if (proxy._contextMenuItems.length == 0)
                return;
            contextMenu = ej.buildTag("div.e-contextmenu", "", {
                'position': 'absolute',
                'z-index': proxy._$treegridHelper.ejTreeGrid("getMaxZIndex") + 1,
            }, { "id": proxy._id + "_ContextMenu" });
            proxy.model.cssClass && (contextMenu.addClass(proxy.model.cssClass));
            //Get zero th level menu items
            var parentMenuItems = args.contextMenuItems.filter(function (value) {
                if (value.parentMenuId == null || value.parentMenuId == undefined)
                    return true;
            });

            contextMenuUList = ej.buildTag("ul.e-gantt-contextmenu", $.render[proxy._id + "contextMenuTemplate"](parentMenuItems), {
                'margin': '0px',
                'padding-left': '0px'
            }, {
                'data-icon': false,
                'type': 'none',
                'data-role': 'list-divider'
            });
            contextMenu.append(contextMenuUList);
            $(document.body).append(contextMenu);

            var contextMenuHeight = $(contextMenu).outerHeight(),
                contextMenuWidth = $(contextMenu).outerWidth(),
                contextMenuItems = contextMenu.find(".e-menuitem");
            contextMenuItems.width(contextMenuWidth + 2);
            contextMenuWidth = $(contextMenu).outerWidth();
            if (ganttOffset.left > posx || (ganttOffset.right < (posx + contextMenuWidth))) {

                if (ganttOffset.right < (posx + contextMenuWidth)) {
                    posx = posx - contextMenuWidth;
                }
                if (posx < 0) {
                    posx = ganttOffset.left + 10;
                }
            }

            if (ganttOffset.bottom < posy + ($(contextMenuUList).outerHeight())) {
                var tempPosY = posy - ($(contextMenuUList).outerHeight());
                if (tempPosY > 0) {
                    posy = tempPosY;
                }
            }

            else if (($(window).height() + $(window).scrollTop()) < posy + contextMenuHeight)
                posy = posy - contextMenuHeight;

            contextMenu.css({ 'left': posx + 'px', 'top': posy + 'px', });
            proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
            $(contextMenu).css({ 'height': 'auto' });
            proxy._on(contextMenu, "contextmenu", function (argsE) {
                argsE.preventDefault();
            });

            //click event handlers for contextmenu items and subcontextmenu items
            $(contextMenuItems).click(function () {
                proxy._contextMenuClickHandler(this);
            });

            //Mouseenter and mouse leave handler for contextmenu items and Subcontextmenuitems
            $(contextMenuItems).mouseenter(function () {
                if (!$(this).hasClass("e-disable")) {
                    contextMenu.find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                    $(this).addClass("e-contextmenu-mouseover");
                    proxy._activeMenuItemId = $(this).attr("id");
                    proxy._showSubContextMenu(this, args.contextMenuItems);
                }
            });

            e.preventDefault();
        },
        //Show SubContext menu for selected Menu items
        _showSubContextMenu: function (element, menuItems) {
            var model = this.model,
                proxy = this,
                currentMenuItem = [],
                menuId = $(element).attr("id"),
                subContextMenu, subContextMenuUList, subMenuItems = [], subContextMenuItems;

            subMenuItems = menuItems.filter(function (value) {
                if (value.menuId == menuId)
                    currentMenuItem = value;
                if (value.parentMenuId == menuId)
                    return true;
            });

            if (!currentMenuItem.parentMenuId)
                $(".e-innerContextmenu").remove();

            if (currentMenuItem.parentMenuId) {
                this._removeContextMenu(currentMenuItem, menuItems);
            }

            if (subMenuItems.length > 0) {
                subContextMenu = ej.buildTag("div.e-innerContextmenu", "", {
                    'position': 'absolute',
                    'z-index': proxy._$treegridHelper.ejTreeGrid("getMaxZIndex") + 1,
                }, { "id": this._id + "_SubContextMenu" + menuId });
                model.cssClass && (subContextMenu.addClass(model.cssClass));
                subContextMenuUList = ej.buildTag("ul.e-gantt-innercontextmenu", $.render[proxy._id + "contextMenuTemplate"](subMenuItems), {
                    'margin': '0px',
                    'padding-left': '0px'
                }, {
                    'data-icon': false,
                    'type': 'none',
                    'data-role': 'list-divider'
                });
                subContextMenu.append(subContextMenuUList);
                $(document.body).append(subContextMenu);
                subContextMenuItems = subContextMenu.find(".e-menuitem");
                var menuWidth = $(subContextMenu).outerWidth();
                subContextMenuItems.width(menuWidth > 100 ? menuWidth : 100);
                var subMenuOffset = proxy._getSubContextMenuPosition(element, subContextMenu);
                $(subContextMenu).css({ "top": subMenuOffset.top, "left": subMenuOffset.left });
                $(subContextMenuItems).mouseenter(function () {
                    if (!$(this).hasClass("e-disable")) {
                        proxy._showSubContextMenu(this, menuItems);
                        $(this).closest(".e-innerContextmenu").find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                        $(this).addClass("e-contextmenu-mouseover");
                        proxy._activeMenuItemId = $(this).attr("id");
                    }
                });
                proxy._on(subContextMenu, "contextmenu", function (argsE) {
                    argsE.preventDefault();
                });
                $(subContextMenuItems).click(function () {
                    proxy._contextMenuClickHandler(this);
                });
            }
        },
        _removeContextMenu: function (menuItem, menuItems) {

            var currentMeuItemContainer = $("#" + this._id + "_SubContextMenu" + menuItem.parentMenuId),
                expandedMenu = $(currentMeuItemContainer).find(".e-contextmenu-mouseover");
            if ($(expandedMenu).length > 0) {
                var innerMenu = menuItems.filter(function (value) {
                    if (value.menuId == $(expandedMenu).attr("id"))
                        return true;
                });
                if (innerMenu.length > 0) {
                    var nextLevelItem = menuItems.filter(function (value) {
                        if (value.parentMenuId == innerMenu[0].menuId)
                            return true;
                    });
                    if (nextLevelItem.length > 0)
                        this._removeContextMenu(nextLevelItem[0], menuItems);
                }
                $("#" + this._id + "_SubContextMenu" + $(expandedMenu).attr("id")).remove();
            }
        },
        _getSubContextMenuPosition: function (element, subMenu) {
            var model = this.model,
                subContextMenuWidth = $(subMenu).outerWidth(),
                 subContextMenuHeight = $(subMenu).outerHeight(),
                elementOffset = this._$treegridHelper.ejTreeGrid("getOffsetRect", element), subMenuOffset = { top: "", left: "" },
                parentElement = $(element).closest(".e-contextmenu"),
                posx, posy,
                contextMenuWidth;
            if (parentElement.length == 0)
                parentElement = $(element).closest(".e-innerContextmenu");
            contextMenuWidth = $(parentElement).outerWidth();
            subMenuOffset.top = elementOffset.top - 1;
            subMenuOffset.left = elementOffset.left + $(parentElement).width() + 1;
            posx = subMenuOffset.left;

            //Edge detection for context menu
            var treeGridOffset = this._$treegridHelper.ejTreeGrid("getOffsetRect", this.element[0]);
            treeGridOffset.bottom = treeGridOffset.top + this.element[0].offsetHeight;
            treeGridOffset.right = treeGridOffset.left + $(this.element).width();
            if (treeGridOffset.left > posx || (treeGridOffset.right < (posx + subContextMenuWidth))) {
                if (treeGridOffset.right < (posx + subContextMenuWidth)) {
                    posx = posx - contextMenuWidth - subContextMenuWidth;
                }
                if (posx > 0) {
                    subMenuOffset.left = posx;
                }
            }
            if (treeGridOffset.bottom < subMenuOffset.top + subContextMenuHeight) {
                var tempPosY = (subMenuOffset.top + subContextMenuHeight) - treeGridOffset.bottom;
                tempPosY = subMenuOffset.top - tempPosY - 2;
                if (tempPosY > 0) {
                    subMenuOffset.top = tempPosY;
                }
            }

            return subMenuOffset;
        },
        //Click event handler for context menu items
        _contextMenuClickHandler: function (target) {
            var choice = $(target).attr('id'),
                proxy = this,
                eventArgs = {};
            if (!$(target).hasClass("e-disable") && $(target).find(".e-expander").length == 0) {
                switch (choice) {
                    case "Task":
                        eventArgs.requestType = "contextMenuTaskDetails";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        break;
                    case "Indent": eventArgs.requestType = "contextMenuIndent";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Outdent": eventArgs.requestType = "contextMenuOutdent";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Delete": eventArgs.requestType = "contextMenuDelete";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Above": eventArgs.requestType = "save";
                        eventArgs.position = "Above";
                        proxy.subContextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Below": eventArgs.requestType = "save";
                        eventArgs.position = "Below";
                        proxy.subContextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Open":
                        eventArgs.requestType = "contextMenuAdd";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Add":
                        proxy._setInitialData();
                        break;
                    default:
                        eventArgs.data = proxy._contextMenuSelectedItem;
                        proxy._triggerMenuEventHandler(choice, eventArgs);
                        proxy._clearContextMenu();
                        break;
                }
            }
        },
        //Call custom context menu event handlers
        _triggerMenuEventHandler:function(menuId,eventArgs){
            var proxy = this,
                contextMenuItems = proxy._contextMenuItems,
                currentMenuItemCollection, menuItem;

            if (!ej.isNullOrUndefined(contextMenuItems)) {
                currentMenuItemCollection = contextMenuItems.filter(function (value) {
                    //convert menu id to string since id accepts only string values
                    if (value.menuId.toString() === menuId)
                        return true;
                });

                if (currentMenuItemCollection.length > 0) {
                    menuItem = currentMenuItemCollection[0];
                    eventArgs.menuId = menuId;
                    var fn = menuItem.eventHandler;
                    if (fn) {
                        if (typeof fn === "string") {
                            fn = ej.util.getObject(fn, window);
                        }
                        if ($.isFunction(fn)) {
                            var args = ej.event("customContextMenuHandler", this.model, eventArgs);
                            fn.call(this, args);
                        }
                    }

                }
            }
        },
        _setInitialData: function () {
            var eventArgs = {}, proxy = this,
                model = proxy.model;
            if (model.flatRecords.length == 0) {
                proxy.addRecord();
                proxy._clearContextMenu();
            }
        },

        //Updated the all child records expandstatus on expandCollapse
        updateConnectorLines: function ($gridRows, expanded) {
            var proxy = this,
                length = $gridRows.length / 2,
                count = 0,
                row,
                index,
                record;
            
            for (count = 0; count < length; count++) {
                row = $gridRows[count];
                index = $(proxy._gridRows).index(row);
                if (index !== -1) {
                    record = proxy.model.currentViewData[index];
                    record.isExpanded = expanded;                  
                }
            }
                   
        },

        updateAltRow: function (ganttRecord, recordIndex, offset) {
            var proxy = this;
            if (proxy.model.enableAltRow) {
                var count = 0,
                currentViewData = proxy.model.currentViewData,
                length = currentViewData.length,
                isAltRow = ganttRecord.isAltRow,
                record,
                $gridRows = $(proxy._gridRows);
            for (count = recordIndex + offset; count < length; count++) {
                if ($($gridRows[count]).css('display') === "none")
                    continue;
                record = currentViewData[count];
                record.isAltRow = !isAltRow;
                isAltRow = record.isAltRow;
                if (isAltRow)
                    $($gridRows[count]).addClass('e-alt-row');
                else
                    $($gridRows[count]).removeClass('e-alt-row');
            }
        }
        },
        renderedEditDialog: function (args) {
            var proxy = this,
                model = this.model,
                columns = model.columns,
                length = columns.length,
                fieldData = {};
            switch (args.requestType) {
                case ej.TreeGrid.Actions.Add:
                    var temp = document.createElement('div'),
                        dialog = $("#" + proxy._id + "_dialogAdd");
                    $(temp).addClass("e-addedrow");
                    temp.innerHTML = $.render[proxy._id + "_JSONDialogAddingTemplate"](args.data);
                    $(dialog).html($(temp));
                    var evntArgs = {};
                    evntArgs.cssClass = model.cssClass;
                    evntArgs.enableModal = true;
                    evntArgs.width = "650px";
                    evntArgs.height = "auto";
                    evntArgs.enableResize = false;
                    evntArgs.contentSelector = "#" + proxy._id;
                    evntArgs.rtl = model.rtl;
                    evntArgs.showOnInit = false;
                    evntArgs.allowKeyboardNavigation = false;
                    evntArgs.close = function () {
                        $("#" + proxy._id + "AddAreaNotes").data("ejRTE") && $("#" + proxy._id + "AddAreaNotes").ejRTE("destroy");
                    };
                    evntArgs.beforeClose = function (args) {
                        if (proxy._closeAddEditDialog(args, "Add"))
                            args.cancel = true; // Cancel the add dialog box close.
                        else
                            proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    },
                    title = proxy._editDialogTexts["addFormTitle"];
                    evntArgs.title = title;
                    proxy._editedDialogRecord = {};
                    var tab = $("#" + proxy._id + "AddTab");
                    $(tab).ejTab({
                        headerSize: "25px",
                        height: "auto",
                        locale: model.locale,
                        cssClass: model.cssClass,
                        itemActive: function (args) {
                            var activeHeader = $(args.activeHeader).find("a").attr("href");
                            if (activeHeader == "#" + proxy._id + "AddNotes") {
                                $("#" + proxy._id + "AddAreaNotes_Iframe").height("202");
                            }
                            else if (activeHeader == "#" + proxy._id + "AddCustomFields") {
                                var treeGrid = $("#treegrid" + proxy._id + "customFieldAdd").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "280px" } });
                            } else if (activeHeader == "#" + proxy._id + "AddPredecessors") {
                                var treeGrid = $("#treegrid" + proxy._id + "predecessorAdd").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            } else if (activeHeader == "#" + proxy._id + "AddResources") {
                                var treeGrid = $("#treegrid" + proxy._id + "resourceAdd").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            }
                        }
                    });
                    $(tab).find("div.e-content").css("overflow", "visible");
                    $(tab).find("div.e-hidebottom.e-addborderbottom.e-content").css("min-height", "283px");
                    $(dialog).ejDialog(evntArgs);
                    var dialogArgs = {};
                    dialogArgs.data = args.data;
                    dialogArgs.rowPosition = model.editSettings.rowPosition;
                    dialogArgs.requestType = "beforeOpenAddDialog";
                    dialogArgs.element = $("#" + proxy._id + "_dialogAdd");
                    if (!proxy._trigger("actionBegin", dialogArgs)) {
                        for (var columnCount = 0; columnCount < length; columnCount++)
                            fieldData[columns[columnCount].field] = dialogArgs.data[columns[columnCount].mappingName];
                        args.data = fieldData;
                        proxy._refreshEditForm(args);
                        dialogArgs.data = args.data;
                        dialogArgs.requestType = "OpenAddDialog";
                        dialogArgs.element = $("#" + proxy._id + "_dialogAdd");
                        if (!proxy._trigger("actionBegin", dialogArgs)) {
                            var dialogWrapper = $("#" + proxy._id + "_dialogAdd_wrapper");
                            $(dialog).find(".e-addedrow").css("overflow", "visible");
                            dialogWrapper.addClass("e-ganttdialog");
                            $(dialog).ejDialog("refresh");
                            $(dialog).ejDialog("open");
                        }
                    }
                    proxy._addPosition = dialogArgs.rowPosition;
                    var tempDate = this._getDateFromFormat(model.scheduleStartDate);
                    if (this._getSecondsInDecimal(tempDate) != this._defaultStartTime) {
                        this._setTime(this._defaultStartTime, tempDate);
                    }
                    this._editedDialogRecord.isUpdatedFromDialog = false;
                    var autoSchedule_val = (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Auto) ? true :
                                   (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Manual) ? false :
                                   (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Custom) ? args.data.taskMode == true ? false : true :
                                   model.taskSchedulingMode;
                    proxy._editedDialogRecord.isAutoSchedule = autoSchedule_val;
                    proxy._editedDialogRecord.startDate = args.data.startDate ? this._checkStartDate(new Date(args.data.startDate)) : this._checkStartDate(new Date(tempDate));
                    proxy._editedDialogRecord.endDate = args.data.endDate ? proxy._editedDialogRecord.startDate.getTime() > new Date(args.data.endDate).getTime() ? new Date(proxy._editedDialogRecord.startDate) : new Date(args.data.endDate) : new Date(proxy._editedDialogRecord.startDate);
                    proxy._editedDialogRecord.duration = args.data.duration != "" ? args.data.duration : 0;
                    proxy._editedDialogRecord.durationUnit = model.durationUnit;

                    break;
                case ej.TreeGrid.Actions.BeginEdit:
                    var temp = document.createElement('div'),
                        dialog = $("#" + proxy._id + "_dialogEdit");
                    $(temp).addClass("e-editedrow");
                    temp.innerHTML = $.render[proxy._id + "_JSONDialogEditingTemplate"](args.data);
                    $(dialog).html($(temp));
                    var evntArgs = {};
                    evntArgs.cssClass = proxy.model.cssClass;
                    evntArgs.rtl = model.rtl;
                    evntArgs.width = "650px";
                    evntArgs.height = "auto";
                    evntArgs.enableResize = false;
                    evntArgs.contentSelector = "#" + proxy._id;
                    evntArgs.enableModal = true;
                    evntArgs.showOnInit = false;
                    evntArgs.allowKeyboardNavigation = false;
                    evntArgs.close = function () {
                        $("#" + proxy._id + "EditAreaNotes").data("ejRTE") && $("#" + proxy._id + "EditAreaNotes").ejRTE("destroy");
                    };
                    evntArgs.beforeClose = function (args) {
                        if (proxy._closeAddEditDialog(args, "Edit"))
                            args.cancel = true; // Cancel the add dialog box close.
                        else
                            proxy._$treegrid.ejTreeGrid('setFocusOnTreeGridElement');
                    };
                    if (model.selectionMode == "row")
                        var selectedItem = proxy.selectedItem()
                    else
                        var selectedItem = proxy.model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
                    var title = proxy._editDialogTexts["editFormTitle"];
                    evntArgs.open = function () {
                        var dialog = this, id = this._id;
                        var titleElement = $("#" + id + "_title").children(".e-title");
                        titleElement.width("450px");
                        titleElement.css({ "word-wrap": "normal", "text-overflow": "ellipsis", "white-space": "nowrap", "display": "inline-block", "overflow-x": "hidden", "float": "left" });
                        titleElement.attr("title", title);
                    };
                    evntArgs.title = title;
                    var tab = $("#" + proxy._id + "EditTab");
                    $(tab).ejTab({
                        headerSize: "25px",
                        height: "auto",
                        locale: model.locale,
                        cssClass: model.cssClass,
                        itemActive: function (args) {
                            var activeHeader = $(args.activeHeader).find("a").attr("href");
                            if (activeHeader == "#" + proxy._id + "EditNotes") {
                                $("#" + proxy._id + "EditAreaNotes_Iframe").height("202");
                            }
                            else if (activeHeader == "#" + proxy._id + "EditCustomFields") {
                                var treeGrid = $("#treegrid" + proxy._id + "customFieldEdit").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "279px" } });
                            } else if (activeHeader == "#" + proxy._id + "EditPredecessors") {
                                var treeGrid = $("#treegrid" + proxy._id + "predecessorEdit").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            } else if (activeHeader == "#" + proxy._id + "EditResources") {
                                var treeGrid = $("#treegrid" + proxy._id + "resourceEdit").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            } 
                        }
                    });
                    $(tab).find("div.e-content").css("overflow", "visible");
                    $(tab).find("div.e-hidebottom.e-addborderbottom.e-content").css("min-height", "283px");
                    $(dialog).ejDialog(evntArgs);
                    var dialogArgs = {};
                    dialogArgs.data = args.data;
                    dialogArgs.requestType = "beforeOpenEditDialog";
                    dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                    if (!proxy._trigger("actionBegin", dialogArgs)) {
                        proxy._editedDialogRecord = jQuery.extend({}, selectedItem);
                        this._editedDialogRecord.isUpdatedFromDialog = false;
                        proxy._refreshEditForm(args);
                        dialogArgs.data = args.data;
                        dialogArgs.requestType = "openEditDialog";
                        dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                        if (!proxy._trigger("actionBegin", dialogArgs)) {
                            var dialogWrapper = $("#" + proxy._id + "_dialogEdit_wrapper");
                            $(dialog).find(".e-editedrow").css("overflow", "visible");
                            dialogWrapper.addClass("e-ganttdialog");
                            $(dialog).ejDialog("refresh");
                            $(dialog).ejDialog("open");
                        }
                    }
                    this._editedDialogRecord && (this._editedDialogRecord.isUpdatedFromDialog = false);
                    break;                    
            }
        },

        _closeAddEditDialog: function (args, type) {
            var proxy = this;
            if (proxy._isAddEditDialogSave)
                proxy._isAddEditDialogSave = false;
            else {
                var eventArgs = {};
                if (type === "Add")
                    eventArgs.requestType = "closeAddDialog";
                else
                    eventArgs.requestType = "closeEditDialog";
                return proxy._trigger("actionBegin", eventArgs);
            }
        },
        editFormValidate: function () {
            if ($.isFunction($.validator))
                return $("#" + this._id + "GeneralEditForm").validate().form();
            return true;
        },

        addFormValidate: function () {
            if ($.isFunction($.validator))
                return $("#" + this._id + "GeneralAddForm").validate().form();
            return true;
        },
        getCurrentData: function () {
            var proxy = this,
                updatedRecords = proxy.getUpdatedRecords(),
                currentRowIndex = proxy.model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell;
            return updatedRecords && updatedRecords[currentRowIndex];
        },

        getCurrentViewData: function () {
            return this._$treegridHelper.ejTreeGrid("getCurrentViewData");
        },

        getUpdatedCurrentViewData: function () {
            return this._$treegridHelper.ejTreeGrid("getUpdatedCurrentViewData");
        },

        getRows: function () {
            return this._$treegridHelper.ejTreeGrid("getRows");
        },
        
        getSelectedCells: function () {
            return this._$treegridHelper.ejTreeGrid("getSelectedCells");
        },

        getGanttChartRows: function() {
            return this._$ganttchartHelper.ejGanttChart("getGanttChartRows");
        },

        getUpdatedRecords: function () {
            return this._$treegridHelper.ejTreeGrid("getUpdatedRecords");
        },

        _getToolBarHeight: function () {
            var toolbarH = 0;
            if (this.model.toolbarSettings.showToolbar) {
                toolbarH = this.element.find(".e-gantttoolbar").height();
            }
            return toolbarH;
        },

        _initValidator: function () {
            var gridObject = this;
            $("#" + this._id + "EditForm").validate({
                errorClass: 'e-field-validation-error',
                errorElement: 'div',
                wrapper: "div",
                errorPlacement: function (error, element) {
                    var $td = element.closest("td"), $container = $(error).addClass("e-error")
                    , $tail = ej.buildTag("div.e-errortail e-toparrow");
                    $td.find(".e-error").remove();
                    element.hasClass("e-numerictextbox") ? $container.insertAfter(element.closest(".e-numeric")) : $container.insertAfter(element);
                    $container.prepend($tail);
                    gridObject.model.editSettings.editMode != "normal" && $container.offset({ left: element.offset().left });
                    $container.fadeIn("slow");
                },

            });
        },

        setValidation: function () {
            this._initValidator();
            for (var i = 0; i < this._columns.length; i++) {
                if (!ej.isNullOrUndefined(this._columns[i]["validationRules"])) {
                    this.setValidationToField(this._columns[i].field, this._columns[i].validationRules);
                }
            }
        },

        setValidationToField: function (name, rules) {
            var ele = $("#" + this._id + name).length > 0 ? $("#" + this._id + name) : $("#" + name);
            ele.rules("add", rules);
            var validator = $("#" + this._id + "EditForm").validate();
            if (!ej.isNullOrUndefined(rules["required"])) {
                validator.settings.messages["Name"] = {};
                validator.settings.messages["Name"]["required"] = ej.TreeGrid.getColumnByField(this._columns, name).headerText + " is required";
            }
        },

        _createConnectorLinesCollection: function (args) {

            var proxy = this,
                model = this.model,
                recordLength = model.currentViewData.length,
                count,
                prdecessorIndex = -1,
                predecessorsCollection,
                ganttRecord,
                connectorLinesCollection = proxy._predecessorsCollection,
                connectorLinesLength = connectorLinesCollection.length,
                x = connectorLinesLength / 2,
                connectorLinesCount,
                enableVirtualization = model.enableVirtualization,
                record;


            if (model.enableVirtualization && args === "Load") {
                //THis is done for validate all the record during load time
                recordLength = model.updatedRecords.length;
                for (count = 0; count < recordLength; count++) {
                    ganttRecord = model.updatedRecords[count];
                    predecessorsCollection = ganttRecord["predecessor"];
                    if (predecessorsCollection) {
                        record = ganttRecord;
                        proxy._addPredecessorsCollection(ganttRecord, predecessorsCollection);
                    }
                }
            }
            else {

                for (count = 0; count < recordLength; count++) {
                    ganttRecord = model.currentViewData[count];
                    if (enableVirtualization === false && ganttRecord.isExpanded === false)
                        continue;
                    if (model.currentViewData.indexOf(ganttRecord) !== -1) {
                        predecessorsCollection = ganttRecord["predecessor"];
                        if (predecessorsCollection) {
                            record = ganttRecord;
                            proxy._addPredecessorsCollection(ganttRecord, predecessorsCollection);
                        }
                    }
                }

            }
            proxy._$ganttchartHelper && proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines", proxy._connectorLinesCollection);
        },

        _addPredecessorsCollection: function (ganttRecord, predecessorsCollection) {
            var proxy = this,
                predecessorsLength,
                predecessorCount,
                predecessor,
                parentGanttRecord,
                childGanttRecord,
                model = proxy.model,
                connectorObj = {},
                predecessorValue = [],
                flatRecords = model.flatRecords,
                updatedRecords = model.updatedRecords,
                ids = model.ids;

            if (predecessorsCollection) {

                predecessorsLength = predecessorsCollection.length;

                for (predecessorCount = 0; predecessorCount < predecessorsLength; predecessorCount++) {

                    predecessor = predecessorsCollection[predecessorCount];


                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];

                        if (!model.enableVirtualization) {
                            if ((parentGanttRecord && parentGanttRecord.isExpanded === false) || 
                                (childGanttRecord && childGanttRecord.isExpanded === false))
                                continue;
                        }

                        if (proxy._isValidationEnabled && !proxy._isInExpandCollapse && childGanttRecord)
                           proxy._validatePredecessorDates(childGanttRecord);
                }

                //for calculate auto schedule only validation is enough  
                if (!proxy._enableCreateCollection)
                    return;

				// for correct re draw the alreadey created line in multiple predecessor for same task
                var count = 0;
                 $.each(predecessorsCollection, function (inx, value) {

                    if (value.to === ganttRecord.taskId.toString()) {
                        count++;
                    }
                    return count;
                });
				
				
				
                    for (predecessorCount = 0; predecessorCount < predecessorsLength; predecessorCount++) {

                        predecessor = predecessorsCollection[predecessorCount];
						if (count > 1)
                        {
                            predecessor.isdrawn = false;
                        }
						
						parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
						childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];

                    if (updatedRecords.indexOf(parentGanttRecord) === -1 || updatedRecords.indexOf(childGanttRecord) == -1)
                                continue;

                            if (!model.enableVirtualization) {
                                if (parentGanttRecord.isExpanded === false || childGanttRecord.isExpanded === false)
                                    continue;
                            }

                            //if (proxy._isValidationEnabled && !proxy._isInExpandCollapse)
                            //    proxy._validateChildGanttRecord(parentGanttRecord, childGanttRecord, predecessor);

                        if (parentGanttRecord && childGanttRecord) {

                            connectorObj = proxy._createConnectorLineObject(parentGanttRecord, childGanttRecord, predecessor);
                          
                            if (connectorObj) {

                                if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorObj.ConnectorLineId) == -1) {

                                    proxy._connectorLinesCollection.push(connectorObj);
                                    proxy._connectorlineIds.push(connectorObj.ConnectorLineId);
                                }
                                else if (proxy._connectorlineIds.length == 0) {
                                    proxy._connectorLinesCollection.push(connectorObj);
                                    proxy._connectorlineIds.push(connectorObj.ConnectorLineId);
                                }
                                else if (proxy._connectorlineIds.indexOf(connectorObj.ConnectorLineId) != -1) {
                                    var index = proxy._connectorlineIds.indexOf(connectorObj.ConnectorLineId);
                                    proxy._connectorLinesCollection[index] = connectorObj;
                                }
                                predecessor.isdrawn = true;
                            }
                        }
                   // }
                }

            }
          
        },
        //create connector line object collection for rendering
        _createConnectorLineObject: function (parentGanttRecord, childGanttRecord, predecessor) {
            var connectorObj = {},
                proxy = this,
                model = proxy.model,
                parentTop,
                childTop,
                updatedRecords = model.updatedRecords,
                parentIndex = updatedRecords.indexOf(parentGanttRecord),
                childIndex = updatedRecords.indexOf(childGanttRecord),
                count = 0,
                index = 0;
            
            if (parentIndex === -1 || childIndex === -1){
                return;
            }
            if (!model.enableVirtualization) {
                var collapsedCount = 0;
                if (childIndex > parentIndex) {
                    
                    for (count = 0; count < parentIndex; count++) {
                        if (updatedRecords[count].isExpanded===false)
                            ++collapsedCount;
                    }
                    index = parentIndex;
                    parentIndex -= collapsedCount;
                    
                    for (index; index < childIndex; index++) {
                        if (updatedRecords[index].isExpanded === false)
                            ++collapsedCount;
                    }
                    childIndex -= collapsedCount;
                }
                else if (parentIndex > childIndex) {
                    for (count = 0; count < childIndex; count++) {
                        if (updatedRecords[count].isExpanded === false)
                            ++collapsedCount;
                    }
                    index = childIndex;
                    childIndex -= collapsedCount;
                    
                    for (index ; index < parentIndex; index++) {
                        if (updatedRecords[index].isExpanded === false)
                            ++collapsedCount;
                    }
                    parentIndex -= collapsedCount;
                }
            }

            var chartObject = $("#ejGanttChart" + proxy._id).ejGanttChart("instance");
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                var rowHeight = model.rowHeight;
            } else {
                var rowHeight = $("#" + chartObject._$ganttViewTablebody[0].id).find("tr:first")[0].getBoundingClientRect().height;
            }
            if (parentIndex != -1 && childIndex != -1) {
                connectorObj["ParentLeft"] = parentGanttRecord['left'];
                connectorObj["ChildLeft"] = childGanttRecord['left'];
                connectorObj["ParentWidth"] = parentGanttRecord['width'] == 0 || parentGanttRecord['isMilestone'] ? proxy._milesStoneWidth : parentGanttRecord['width'];
                connectorObj["ChildWidth"] = childGanttRecord['width'] == 0 || childGanttRecord['isMilestone'] ? proxy._milesStoneWidth : childGanttRecord['width'];
                connectorObj["ParentIndex"] = parentIndex;
                connectorObj["ChildIndex"] = childIndex;
                connectorObj["RowHeight"] = rowHeight;
                connectorObj["Type"] = predecessor.predecessorsType;
                connectorObj["ConnectorLineId"] = "parent"+ parentGanttRecord['taskId'] + "child" + childGanttRecord['taskId'];                
                connectorObj["milestoneParent"] = parentGanttRecord.isMilestone ? true : false;
                connectorObj["milestoneChild"] = childGanttRecord.isMilestone ? true : false;
                
                return connectorObj;
            }
        },

        /* get date after weekend and holidays */
        _getDateAfterWeekendHolidays: function (date, isAutoSchedule)
        {
            var proxy = this, model = this.model,
                holidays = this._getStringHolidays(),
                tempDate = new Date(date),
                isDateUpdated = false,
                formatedDate;
            tempDate.setHours(0,0,0,0);
            formatedDate = this._getFormatedDate(tempDate, model.dateFormat, model.locale);
            
            /* Holiday checking */
            if (isAutoSchedule && holidays.indexOf(formatedDate) != -1) {
                date.setDate(date.getDate() + 1);
                isDateUpdated = true;
            }

            /* Weekend updates */
            if (isAutoSchedule && model.includeWeekend === false) {
                if (date.getDay() == 0) {
                    date.setDate(date.getDate() + 1);
                    isDateUpdated = true;
                }
                else if (date.getDay() == 6) {
                    date.setDate(date.getDate() + 2);
                    isDateUpdated = true;
                }
            }

            /* if Date modified check for another turn */
            if (isDateUpdated)
                return this._getDateAfterWeekendHolidays(date, isAutoSchedule);
            else
                return date;
        },

        /*get date before holidays and weekends */
        _getDateBeforeWeekendHolidays: function (date, isAutoSchedule) {
            var proxy = this, model = this.model,
                holidays = this._getStringHolidays(),
                tempDate = new Date(date),
                isDateUpdated = false,
                formatedDate;
            tempDate.setHours(0, 0, 0, 0);
            formatedDate = this._getFormatedDate(tempDate, model.dateFormat, model.locale);

            /* Holiday checking */
            if (isAutoSchedule && holidays.indexOf(formatedDate) != -1) {
                date.setDate(date.getDate() - 1);
                isDateUpdated = true;
            }

            /* Weekend updates */
            if (isAutoSchedule && model.includeWeekend === false) {
                if (date.getDay() == 0) {
                    date.setDate(date.getDate() - 2);
                    isDateUpdated = true;
                }
                else if (date.getDay() == 6) {
                    date.setDate(date.getDate() - 1);
                    isDateUpdated = true;
                }
            }

            /* if Date modified check for another turn */
            if (isDateUpdated)
                return this._getDateBeforeWeekendHolidays(date, isAutoSchedule);
            else
                return date;
        },
        /* update date as per offset value */
        _updateDateByOffset: function (date, predecessor, isMilestone, record)
        {
            var resultDate,
                offsetValue = predecessor.offset,
                durationUnit = predecessor.offsetDurationUnit;
            if (offsetValue < 0) {
                resultDate = this._getStartDate(this._checkEndDate(date, record), (offsetValue * -1), durationUnit, record);
            } else {
                resultDate = this._getEndDate(date, offsetValue, durationUnit, record, false);
                if (!isMilestone)
                    resultDate = this._checkStartDate(resultDate, record);
            }
            return resultDate;
        },

        /* update StartDate by using duration and enddate with weekends and holidays*/
        _setStartDateByDurationEndDate:function(ganttRecord)
        {
            var proxy = this,
                model = this.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                duartionUnit = model.durationUnit,
                isAutoSchedule = ganttRecord.isAutoSchedule,
                duration = duartionUnit == ej.Gantt.DurationUnit.Day ? ganttRecord.duration - 1 : ganttRecord.duration;

            if (ganttRecord.isMilestone)
                ganttRecord.startDate = ganttRecord.endDate;
            else {
                var tempEndDate = new Date(ganttRecord.endDate);
                //To calculate the Child Gantt record start date from its end date.
                for (var i = 0; i < duration; i++) {
                    if (duartionUnit == ej.Gantt.DurationUnit.Hour)
                        tempEndDate.setHours(tempEndDate.getHours() - 1);
                    else if (duartionUnit == ej.Gantt.DurationUnit.Day)
                        tempEndDate.setDate(tempEndDate.getDate() - 1);
                    else if (duartionUnit == ej.Gantt.DurationUnit.Minute)
                        tempEndDate.setMinutes(tempEndDate.getMinutes() - 1);
                    tempEndDate = this._getDateBeforeWeekendHolidays(tempEndDate, isAutoSchedule);
                }
                ganttRecord.startDate = new Date(tempEndDate);
            }
        },
        //Validate the child Gantt Record
        _validateChildGanttRecord: function (parentGanttRecord, childGanttRecord, predecessor, predecessorValidation,offsetChanged) {
            var proxy = this,
            model = proxy.model,
            predecessorType;

            if (proxy._editedTaskBarItem === childGanttRecord) {
                return;
            }
            switch (predecessor.predecessorsType) {

                case 'SS':
                    var currentTaskId = childGanttRecord['taskId'].toString(),
                        predecessorsCollection = childGanttRecord['predecessor'],
                        childPredecessor = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                        minStartDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);

                    childGanttRecord.startDate = new Date(minStartDate);
                    childGanttRecord._calculateEndDate(this);
                    childGanttRecord.left = childGanttRecord._calculateLeft(this);
                    childGanttRecord.width = childGanttRecord._calculateWidth(this);
                    childGanttRecord.progressWidth = childGanttRecord._calculateProgressWidth(childGanttRecord.width, childGanttRecord.status);
                    break;

                case 'SF':
                    var currentTaskId = childGanttRecord['taskId'].toString(),
                        predecessorsCollection = childGanttRecord['predecessor'],
                        childPredecessor = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                        minStartDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);

                    childGanttRecord.startDate = new Date(minStartDate);
                    childGanttRecord._calculateEndDate(this);
                    childGanttRecord.left = childGanttRecord._calculateLeft(this);
                    childGanttRecord.width = childGanttRecord._calculateWidth(this);
                    childGanttRecord.progressWidth = childGanttRecord._calculateProgressWidth(childGanttRecord.width, childGanttRecord.status);
                    break;

                case 'FS':

                    var predecessorsCollection = childGanttRecord['predecessor'],
                        currentTaskId = childGanttRecord['taskId'].toString(),
                        childPredecessor = predecessorsCollection && predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                        maxStartDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);

                    childGanttRecord.startDate = new Date(maxStartDate);
                    childGanttRecord._calculateEndDate(this);
                    childGanttRecord.left = childGanttRecord._calculateLeft(this);
                    childGanttRecord.width = childGanttRecord._calculateWidth(this);
                    childGanttRecord.progressWidth = childGanttRecord._calculateProgressWidth(childGanttRecord.width, childGanttRecord.status);

                    break;

                case 'FF':
                    var currentTaskId = childGanttRecord['taskId'].toString(),
                        predecessorsCollection = childGanttRecord['predecessor'],
                        childPredecessor = predecessorsCollection && predecessorsCollection.filter(function (data) { return data.to === currentTaskId });
                    childGanttRecord.startDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);
                    childGanttRecord._calculateEndDate(this);
                    childGanttRecord.left = childGanttRecord._calculateLeft(this);
                    childGanttRecord.width = childGanttRecord._calculateWidth(this);
                    childGanttRecord.progressWidth = childGanttRecord._calculateProgressWidth(childGanttRecord.width, childGanttRecord.status);
                    break;
            }
            this._updateItemValueInRecord(childGanttRecord);            

            if (childGanttRecord.parentItem && childGanttRecord.parentItem.isAutoSchedule)
                proxy._updateParentItem(childGanttRecord);
            else if (childGanttRecord.parentItem && !childGanttRecord.parentItem.isAutoSchedule)
                proxy._updateManualParentItem(childGanttRecord);
            if (proxy._isTreeGridRendered || proxy._isGanttChartRendered) {
                proxy.refreshGanttRecord(childGanttRecord);
            }
        },

        //calulate the offset based on parent task and child task date
        _calculateOffset:function(parentDate,childDate)
        {
            var proxy = this,
                model = proxy.model,
                dayDifference = proxy._daydiff(parentDate, childDate);
            if (!model.includeWeekend){
                var weekEndCount = proxy._calculateWeekendCount(parentDate, dayDifference);
                dayDifference = (dayDifference > 0) ? (dayDifference - weekEndCount) : (dayDifference + weekEndCount);
            }
            if (model.holidays.length) {
                var holidayCount = proxy._calculateHolidayCount(parentDate, childDate);
                dayDifference = (dayDifference > 0) ? (dayDifference - holidayCount) : (dayDifference + holidayCount);
            }
            return dayDifference;
        },

        /*Get validated start of task on all predecessor type*/
        _getValidatedStartDate: function (ganttRecord, parentGanttRecord, predecessor) {
            var type = predecessor.predecessorsType,
                offset = predecessor.offset,
                tempDate, returnStartDate;
            switch (type) {
                case "FS":
                    tempDate = new Date(parentGanttRecord.endDate);
                    if (!ganttRecord.isMilestone || offset != 0)
                        tempDate = this._checkStartDate(tempDate, ganttRecord);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        returnStartDate = this._checkStartDate(tempDate, ganttRecord);
                    else
                        returnStartDate = new Date(tempDate);
                    break;
                case "FF":
                    tempDate = new Date(parentGanttRecord.endDate);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        tempDate = this._checkEndDate(tempDate, ganttRecord);
                    returnStartDate = this._getStartDate(tempDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                    break;
                case "SF":
                    tempDate = new Date(parentGanttRecord.startDate);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        tempDate = this._checkEndDate(tempDate, ganttRecord);
                    returnStartDate = this._getStartDate(tempDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                    break;
                case "SS":
                    tempDate = new Date(parentGanttRecord.startDate);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        returnStartDate = this._checkStartDate(tempDate, ganttRecord);
                    else
                        returnStartDate = tempDate;
                    break;
            }
            return returnStartDate;
        },
        //Get maximum or minimum date as per predecessor type
        _getPredecessorDate: function (ganttRecord, predecessorsCollection) {
            var minStartDate = null, model = this.model,
                maxStartDate = null,
                length, i,
                flatRecords = model.flatRecords,
                ids = model.ids,
                tempStartDate,
                parentGanttRecord,
                childGanttRecord,
                validatedpredecessor = predecessorsCollection.filter(function (data) {
                    if (data.to === ganttRecord.taskId.toString())
                        return true;
                });

            if (validatedpredecessor) {
                length = validatedpredecessor.length;
                for (i = 0; i < length; i++) {
                    var predecessor = validatedpredecessor[i];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];
                    tempStartDate = this._getValidatedStartDate(childGanttRecord, parentGanttRecord, predecessor);
                    if (maxStartDate == null)
                        maxStartDate = new Date(tempStartDate);
                    else if (tempStartDate.getTime() > maxStartDate.getTime())
                        maxStartDate = new Date(tempStartDate);
                }
            }
            return maxStartDate;
        },

        _setBeforeWeekend: function(date) {
            if (date.getDay() == 0)
                date.setDate(date.getDate() - 2);
            else if (date.getDay() == 6)
                date.setDate(date.getDate() - 1);
        },
        
        _setAfterWeekend: function(date) {
            if (date.getDay() == 0)
                date.setDate(date.getDate() + 1);
            else if (date.getDay() == 6)
                date.setDate(date.getDate() + 2);
        },
        
        _updateEditedGanttRecords: function (args) {
            var proxy = this, model = proxy.model,
                ganttRecord = args.data,
                startDate = new Date(ganttRecord.startDate),
                isAutoSchedule = ganttRecord.isAutoSchedule,
                isPredecessorsModified = false;

            if (args.columnName === "startDate") {
                var previousData = $.extend({}, args.data);
                startDate = proxy._checkStartDate(startDate, ganttRecord);
                ganttRecord.startDate = new Date(startDate);
                if (model.startDateMapping)
                    ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                ganttRecord._calculateEndDate(this);
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);// model.holidays
                if (!ganttRecord.hasChildRecords)
                    ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, ganttRecord.status);
                else {
                    var arg = {};
                    arg.previousData = previousData;
                    arg.data = ganttRecord;
                    proxy._validateAutoChildRecords(arg);
                }
                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateParentItem(ganttRecord);
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(ganttRecord);
            }

            else if (args.columnName === "endDate") {
                //validate start date
                var endDate = new Date(ganttRecord.endDate);
                if (endDate.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, endDate);
                endDate = this._checkEndDate(endDate, ganttRecord);
                ganttRecord.endDate = new Date(endDate);
                if (model.endDateMapping)
                    ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;
                if (ganttRecord.isMilestone) {
                    ganttRecord.startDate = this._checkStartDate(ganttRecord.startDate, ganttRecord);
                    model.startDateMapping && (ganttRecord.item[model.startDateMapping] = ganttRecord.startDate);
                }

                if (startDate.getTime() <= endDate.getTime()) {
                    ganttRecord._calculateDuration(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);                    
                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, ganttRecord.status);

                    if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                        proxy._updateParentItem(ganttRecord);
                    else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(ganttRecord);
                }
                else
                {
                    ganttRecord.endDate = args.previousValue;
                    ganttRecord.item[model.endDateMapping] = args.previousValue;
                }
                if (ganttRecord.duration === 0)
                    ganttRecord.isMilestone = true;
                else
                    ganttRecord.isMilestone = false;
                
                proxy._updateResourceRelatedFields(ganttRecord);
            }
            
            else if (args.columnName == "duration" || proxy._isDurationUpdated) {
                var currentDuration = ganttRecord.duration;
                if (currentDuration != 0 && ganttRecord.isMilestone) {
                    ganttRecord.isMilestone = false;
                    ganttRecord.startDate = this._checkStartDate(ganttRecord.startDate, ganttRecord);
                    model.startDateMapping && (ganttRecord.item[model.startDateMapping] = ganttRecord.startDate);
                    ganttRecord.left = ganttRecord._calculateLeft(this);
                }
                if (currentDuration === 0) {
                    ganttRecord.isMilestone = true;
                } else {
                    ganttRecord.isMilestone = false;
                }
                ganttRecord._calculateEndDate(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);
                if (!ganttRecord.hasChildRecords)
                    ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, ganttRecord.status);

                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateParentItem(ganttRecord);
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(ganttRecord);
            }

            else if (args.columnName == "predecessor") {
                isPredecessorsModified = true;
                if (args.previousValue) {
                    proxy._removeConnectorLine(args.previousValue, ganttRecord);
                }
                proxy._addConnectorLine(ganttRecord);
            }

            else if (args.columnName == "status") {
                ganttRecord.status = ganttRecord.status > 100 ? 100 : ganttRecord.status;
                if (!ganttRecord.hasChildRecords)
                    ganttRecord.progressWidth = proxy._getProgressWidth(ganttRecord.width, ganttRecord.status);
                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule) {                    
                    proxy._updateParentItem(ganttRecord);
                }
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule) {                    
                    proxy._updateManualParentItem(ganttRecord);
                }
            }
            else if (args.columnName == "taskMode") {
                proxy._updateGanttRecord(ganttRecord);
            }
            else if (args.columnName == "baselineStartDate" || args.columnName == "baselineEndDate")
            {
                var baseLineStartDate = proxy._getDateFromFormat(ganttRecord.baselineStartDate),
                    baseLineEndDate = proxy._getDateFromFormat(ganttRecord.baselineEndDate);
                if (baseLineEndDate && baseLineEndDate.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, baseLineEndDate);
                ganttRecord.baselineStartDate = this._checkBaseLineStartDate(baseLineStartDate);
                ganttRecord.baselineEndDate = this._checkBaseLineEndDate(baseLineEndDate);
                if (ganttRecord.baselineStartDate && ganttRecord.baselineEndDate) {
                    ganttRecord.baselineLeft = ganttRecord._calculateBaselineLeft(this);
                    ganttRecord.baselineRight = ganttRecord._calculateBaselineRight(this);
                    ganttRecord.baselineWidth = ganttRecord._calculateBaseLineWidth(this);
                }
            }
            //proxy._updateEditedGanttRecord(ganttRecord);
            if (ganttRecord.predecessor) {
                
                proxy._isMileStoneEdited = ganttRecord.isMilestone;
                proxy._updatedConnectorLineCollection = [];
                proxy._connectorlineIds = [];
                if (args.columnName === "predecessor") {
                    if (model.enablePredecessorValidation)
                        proxy._validatePredecessor(ganttRecord, args.previousValue);
                    else{
                        var manualOffsetEditing=true;
                        proxy._validatePredecessorOnEditing(ganttRecord, manualOffsetEditing);
                    }
                }
                else
                    proxy._validatePredecessor(ganttRecord, undefined, "successor");
                if (proxy._updatedConnectorLineCollection.length > 0) {
                    proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                    this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                }
            }
            proxy._isValidationEnabled = false;
            
            proxy.refreshGanttRecord(ganttRecord);
        },

        _removeConnectorLine: function (predecessor,ganttRecord) {
            var proxy = this,
                model = this.model,
                connectorLineId,
                parentGanttRecord,
                record,
                i = 0,
                length = predecessor && predecessor.length,
                index = -1,
                flatRecords = model.flatRecords,
                ids = model.ids;
                
            for (i = 0; i < length; i++) {
                parentGanttRecord = flatRecords[ids.indexOf(predecessor[i].from)];
                record = flatRecords[ids.indexOf(predecessor[i].to)];
                
                if (ganttRecord.taskId.toString() === predecessor[i].to.toString()) {
                    
                    index = parentGanttRecord.predecessor.indexOf(predecessor[i]);
                    index >= 0 && parentGanttRecord.predecessor.splice(index, 1);
                }

                if (parentGanttRecord && record) {
                    connectorLineId = "parent"+parentGanttRecord['taskId'] + "child" + record['taskId'];
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                    this._updateConnectorLineCollection(connectorLineId);
                }
            }
        },

        _addConnectorLine:function(ganttRecord) {
            var proxy = this,
                count = 0,
                model = proxy.model,
                predecessors = ganttRecord.predecessor,
                length,
                predecessor,
                flatRecords = model.flatRecords,
                ids = model.ids,
                successorGanttRecord;

            if (predecessors) {

                length = predecessors.length;

                for (count = 0; count < length; count++) {

                    predecessor = predecessors[count];
                    
                    if (predecessor.to === ganttRecord.taskId.toString()) {
                        successorGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    }

                    if (successorGanttRecord) {
                        if (successorGanttRecord.predecessor) {
                            successorGanttRecord.predecessor.push(predecessor);
                        } else {
                            successorGanttRecord.predecessor = [];
                            successorGanttRecord.predecessor.push(predecessor);
                            proxy._predecessorsCollection.push(successorGanttRecord);
                        }
                    }
                }
            }
        },

        _calculateUpdatedDate: function (modifiedDate, offset) {
            var proxy = this, model = proxy.model,
                durationUnitValue = ej.Gantt.DurationUnit,
                i = 0;
            if (offset > 0) {
                for (i; i < offset; i++) {
                    if (model.durationUnit == durationUnitValue.Day) {
                        modifiedDate = proxy.dateUpdate(modifiedDate, 1, 0);
                    }
                    else if (model.durationUnit == durationUnitValue.Hour) {
                        modifiedDate = proxy.dateUpdate(modifiedDate, 0, 1);
                    }
                    else if (model.durationUnit == durationUnitValue.Minute) {
                        modifiedDate = proxy.dateUpdate(modifiedDate, 0, 0, 1);
                    }
                    if (modifiedDate.getDay() == 0)
                        modifiedDate.setDate(modifiedDate.getDate() + 1);
                    else if (modifiedDate.getDay() == 6)
                        modifiedDate.setDate(modifiedDate.getDate() + 2);
                }
            } else {
                var dateOffset = (-1) * offset;
                for (i = 0; i < dateOffset; i++) {
                    if (model.durationUnit == durationUnitValue.Day) {
                        modifiedDate = proxy.dateUpdate(modifiedDate, -1, 0);
                    }
                    else if (model.durationUnit == durationUnitValue.Hour) {
                        modifiedDate = proxy.dateUpdate(modifiedDate, 0, -1);
                    }

                    if (modifiedDate.getDay() == 0)
                        modifiedDate.setDate(modifiedDate.getDate() - 2);
                    else if (modifiedDate.getDay() == 6)
                        modifiedDate.setDate(modifiedDate.getDate() - 1);
                }
            }
            modifiedDate = new Date(modifiedDate);
            return modifiedDate;
        },

        _updateEditedGanttRecord: function (ganttRecord) {
            var proxy = this;
            if (ganttRecord.predecessor) {
                var predecessorsCollection = ganttRecord.predecessor,
                    count = 0,
                    length = predecessorsCollection.length,
                    predecessor,
                    parentGanttRecord,
                    record,
                    connectorLineId,
                    connectorLineObject,
                    model = proxy.model,
                    flatRecords = model.flatRecords,
                    ids = model.ids;

                for (count = 0; count < length; count++) {
                    proxy._updatedConnectorLineCollection = [];
                    proxy._connectorlineIds = [];
                    predecessor = predecessorsCollection[count];
                    if (predecessor.to === ganttRecord['taskId'].toString()) {

                        parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                        record = flatRecords[ids.indexOf(predecessor.to)];
                        
                        if (parentGanttRecord && record) {
                            connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                            proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                            this._updateConnectorLineCollection(connectorLineId);
                            connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                            if (connectorLineObject) {
                                if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                                    proxy._updatedConnectorLineCollection.push(connectorLineObject);
                                    proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                                }
                                else if (proxy._connectorlineIds.length == 0) {
                                    proxy._updatedConnectorLineCollection.push(connectorLineObject);
                                    proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                                }
                                proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                                this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                            }
                        }
                        
                    }
                }
            }
        },
        

        _updateTargetGanttRecord: function (ganttRecord) {
            var proxy = this,
                model = proxy.model;
            ganttRecord.startDate = proxy._checkStartDate(ganttRecord.startDate, ganttRecord);
            ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
            ganttRecord.left = ganttRecord._calculateLeft(this);
            ganttRecord.width = ganttRecord._calculateWidth(this);
            ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, ganttRecord.status);
            if (ganttRecord.parentItem) {
                if (ganttRecord.parentItem.isAutoSchedule == true) {
                    proxy._updateParentItem(ganttRecord);
                }
                else {
                    proxy._updateManualParentItem(ganttRecord);
                }
            }
            proxy.refreshGanttRecord(ganttRecord);
        },

        _updateGanttRecord: function (ganttRecord) {
            var proxy = this,
                model = proxy.model;

            if (ganttRecord.hasChildRecords && ganttRecord.isAutoSchedule) {
                ganttRecord.startDate = proxy._checkStartDate(ganttRecord.manualStartDate, ganttRecord);                
                ganttRecord.left = ganttRecord._calculateManualLeft(this);
                ganttRecord.width = ganttRecord._calculateManualWidth(this);
                ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, ganttRecord.status);                
                ganttRecord.endDate = ganttRecord.manualEndDate;
                ganttRecord._calculateDuration(this);
            }
            else if (ganttRecord.hasChildRecords && !ganttRecord.isAutoSchedule) {                
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);
                ganttRecord._calculateDuration(this);
                ganttRecord.manualStartDate = ganttRecord.startDate;
                ganttRecord.manualEndDate = ganttRecord.endDate;                
                proxy._updateManualParentItem(ganttRecord, null, true);
            }
            else {
                ganttRecord.startDate = proxy._checkStartDate(ganttRecord.startDate, ganttRecord);
                ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);
                ganttRecord.progressWidth = ganttRecord._calculateProgressWidth(ganttRecord.width, ganttRecord.status);
            }
            if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                proxy._updateParentItem(ganttRecord);
            if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                proxy._updateManualParentItem(ganttRecord);

            proxy.refreshGanttRecord(ganttRecord);
        },

        refreshGanttRecord: function (ganttRecord) {
            var proxy = this;
            if (proxy._isTreeGridRendered) {
                proxy.model.currentViewData = proxy.getCurrentViewData();
                var index = proxy.model.currentViewData.indexOf(ganttRecord);
                var treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
                treegridObject.model.allowSelection = proxy.model.allowSelection;
                ej.TreeGrid.refreshRow(treegridObject, index);
                if (proxy._isGanttChartRendered) {
                    proxy._$ganttchartHelper.ejGanttChart("refreshRow", index);
                }
                //Client side event is triggerd for upadte the server side database
                var eventArgs = {};
                eventArgs.data = ganttRecord;
                eventArgs.item = ganttRecord.item;
                eventArgs.requestType = "recordUpdate";
                proxy._trigger("actionComplete",eventArgs);
            }
        },

        _updateManualParentItem: function (ganttRecord, editmode, isParent) {

            var proxy = this,
                parentGanttRecord = isParent ? ganttRecord : ganttRecord.parentItem,
                model = proxy.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                prevStartDate = new Date(parentGanttRecord.startDate),
                prevManualStartDate = new Date(parentGanttRecord.manualStartDate),
                currentStartDate = new Date(ganttRecord.startDate),
                prevEndDate = new Date(parentGanttRecord.endDate),
                prevManualEndDate = new Date(parentGanttRecord.manualEndDate),
                currentEndDate = new Date(ganttRecord.endDate);                    
           
            if (currentStartDate.getTime() < prevManualStartDate.getTime()) {
                parentGanttRecord.manualStartDate = ganttRecord.startDate;                
            }

            if (currentEndDate.getTime() > prevEndDate.getTime() && proxy._isLoad) {
                //dateDiff = proxy._daydiff(prevEndDate, currentEndDate);                                
            }

            if (currentEndDate.getTime() > prevManualEndDate.getTime()) {
                parentGanttRecord.manualEndDate = ganttRecord.endDate;
                //dateManualDiff = proxy._daydiff(prevManualEndDate, currentEndDate);                
            }

            var count = 0,
                childRecords = parentGanttRecord.childRecords,
                length = childRecords && childRecords.length,
                childGanttRecord,
                index = null,
                minStartDate = null,
                maxEndDate = null,
                parentProgress = 0,
                milestoneCount = 0,
                totalProgress = 0,               
                childCompletedWorks = 0;

            for (count = 0; count < length; count++) {

                childGanttRecord = childRecords[count];

                if (!childGanttRecord.isAutoSchedule && childGanttRecord.hasChildRecords) {

                    var childManualStartDate = new Date(childGanttRecord.manualStartDate),
                        childManualEndDate = new Date(childGanttRecord.manualEndDate),
                        childNormalStartDate = new Date(childGanttRecord.startDate),
                        childNormalEndDate = new Date(childGanttRecord.endDate),

                        childStartDate = childManualStartDate.getTime() < childNormalStartDate.getTime() ? childGanttRecord.manualStartDate : childGanttRecord.startDate,
                        childEndDate = childManualEndDate.getTime() > childNormalEndDate.getTime() ? childGanttRecord.manualEndDate : childGanttRecord.endDate;
                }
                else {
                    var childStartDate = childGanttRecord.startDate,
                        childEndDate = childGanttRecord.endDate;
                }

                if (minStartDate === null) {
                    minStartDate = new Date(childStartDate);
                }
                if (maxEndDate === null) {
                    maxEndDate = new Date(childEndDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (childEndDate.getTime() > maxEndDate.getTime()) {
                    maxEndDate = new Date(childEndDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (childStartDate.getTime() < minStartDate.getTime()) {
                    minStartDate = new Date(childStartDate);
                }

                childCompletedWorks += parseInt(childGanttRecord.work);

                if (!childGanttRecord.isMilestone)
                    totalProgress += parseInt(childGanttRecord.status);
                else
                    milestoneCount++;
            }

            if (prevManualStartDate.getTime() !== minStartDate.getTime()) {
                parentGanttRecord.manualStartDate = new Date(minStartDate);                
            }

            if (prevManualEndDate.getTime() != maxEndDate.getTime()) {
                parentGanttRecord.manualEndDate = new Date(maxEndDate);                
            }
           
            if (proxy._isLoad || proxy._isChartRendering) {
                parentGanttRecord._calculateDuration(this);
                parentGanttRecord.width = parentGanttRecord._calculateWidth(this);
            }
                
            parentGanttRecord.left = parentGanttRecord._calculateLeft(this);
            parentGanttRecord.manualLeft = parentGanttRecord._calculateManualLeft(this);
            parentGanttRecord._calculateManualDuration(this);
            parentGanttRecord.manualWidth = parentGanttRecord._calculateManualWidth(this);            

            //update parent works 
            parentGanttRecord._updateWorkWithDuration(proxy);
            //Add child works to parent
            parentGanttRecord.work += childCompletedWorks;

            if (model.workMapping)
                parentGanttRecord.item[model.workMapping] = parentGanttRecord.work;

            //Calculate progressWidth after left and width calulation            
            var taskCount = length - milestoneCount;
            parentProgress = taskCount > 0 ? (totalProgress / taskCount) : 0;
            parentGanttRecord.progressWidth = proxy._getProgressWidth(parentGanttRecord.manualWidth, parentProgress);
            parentGanttRecord.status = Math.floor(parentProgress);

            if (model.progressMapping)
                parentGanttRecord.item[model.progressMapping] = parentGanttRecord.status;

            if (proxy._isTreeGridRendered || proxy._isGanttChartRendered)
                proxy.refreshGanttRecord(parentGanttRecord);

            if (parentGanttRecord.parentItem && parentGanttRecord.parentItem.isAutoSchedule && !isParent) {
                proxy._updateParentItem(parentGanttRecord);
            }
            else if (parentGanttRecord.parentItem && !parentGanttRecord.parentItem.isAutoSchedule && !isParent)
                proxy._updateManualParentItem(parentGanttRecord,editmode);
        },

        _updateParentItem: function (ganttRecord, editmode, isParent) {

            var proxy = this,
                parentGanttRecord = isParent ? ganttRecord : ganttRecord.parentItem,                               
                model = proxy.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                prevStartDate = new Date(parentGanttRecord.startDate),
                currentStartDate = new Date(ganttRecord.startDate),
                prevEndDate = new Date(parentGanttRecord.endDate),
                currentEndDate = new Date(ganttRecord.endDate);
                            
            
            if (currentStartDate.getTime() < prevStartDate.getTime()) {
                parentGanttRecord.startDate = ganttRecord.startDate;
                if (model.startDateMapping)
                    parentGanttRecord.item[model.startDateMapping] = parentGanttRecord.startDate;                
            }

            if (currentEndDate.getTime() > prevEndDate.getTime()) {                
                //dateDiff = proxy._daydiff(prevEndDate, currentEndDate);
                parentGanttRecord.endDate = ganttRecord.endDate;
                if(model.endDateMapping)
                    parentGanttRecord.item[model.endDateMapping] = parentGanttRecord.endDate;

            }

            var count = 0,
                childRecords = parentGanttRecord.childRecords,
                length = childRecords && childRecords.length,
                childGanttRecord,
                index = null,
                minStartDate = null,
                maxEndDate = null,
                parentProgress = 0,
                milestoneCount = 0,
                totalProgress = 0,               
                childCompletedWorks = 0;

            for (count = 0; count < length; count++) {

                childGanttRecord = childRecords[count];
                var startDate = childGanttRecord.startDate,
                                    endDate = childGanttRecord.endDate;

                if (childGanttRecord.hasChildRecords && !childGanttRecord.isAutoSchedule) {
                    startDate = childGanttRecord.startDate.getTime() > childGanttRecord.manualStartDate.getTime() ?
                                    childGanttRecord.manualStartDate : childGanttRecord.startDate;
                }

                if (childGanttRecord.hasChildRecords && !childGanttRecord.isAutoSchedule) {
                    endDate = childGanttRecord.endDate.getTime() < childGanttRecord.manualEndDate.getTime() ?
                                    childGanttRecord.manualEndDate : childGanttRecord.endDate;
                }

                if (minStartDate === null) {
                    minStartDate = new Date(startDate);
                }
                if (maxEndDate === null) {
                    maxEndDate = new Date(endDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (endDate.getTime() > maxEndDate.getTime()) {
                    maxEndDate = new Date(endDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (startDate.getTime() < minStartDate.getTime()) {
                    minStartDate = new Date(startDate);
                }

                childCompletedWorks += parseInt(childGanttRecord.work);

                if (!childGanttRecord.isMilestone) {
                    totalProgress += parseInt(childGanttRecord.status);
                }
                else
                    milestoneCount++;
            }

            if (prevStartDate.getTime() !== minStartDate.getTime()) {
                parentGanttRecord.startDate = new Date(minStartDate);
                if (model.startDateMapping)
                    parentGanttRecord.item[model.startDateMapping] = parentGanttRecord.startDate;
            }
            
            if (prevEndDate.getTime() != maxEndDate.getTime()) {                                                       
                parentGanttRecord.endDate = new Date(maxEndDate);
                if(model.endDateMapping)
                    parentGanttRecord.item[model.endDateMapping] = parentGanttRecord.endDate;

            }

            parentGanttRecord._calculateDuration(this);
            parentGanttRecord.left = parentGanttRecord._calculateLeft(this);
            parentGanttRecord.width = parentGanttRecord._calculateWidth(this);
            if (milestoneCount == parentGanttRecord.childRecords.length) {
                if (parentGanttRecord.startDate.getTime() == parentGanttRecord.endDate.getTime())
                    parentGanttRecord.width = Math.floor((model.rowHeight - 6) / 2) * 2; //milestone width
                else
                    parentGanttRecord.width += Math.floor((model.rowHeight - 6) / 2) * 2;
            }

            //Calculate progressWidth after Left and width calculation
            var taskCount = length - milestoneCount;
            parentProgress = taskCount > 0 ? (totalProgress / taskCount) : 0;            
            parentGanttRecord.progressWidth = proxy._getProgressWidth(parentGanttRecord.width, parentProgress);
            parentGanttRecord.status = Math.floor(parentProgress);

            //update parent works 
            parentGanttRecord._updateWorkWithDuration(proxy);
            //Add child works to parent
            parentGanttRecord.work += childCompletedWorks;

            if (model.workMapping)
                parentGanttRecord.item[model.workMapping] = parentGanttRecord.work;

            //Default Values of Parent tasks.
            parentGanttRecord.taskType = ej.Gantt.TaskType.FixedDuration;
            parentGanttRecord.effortDriven = "false";

            if (model.progressMapping)
                parentGanttRecord.item[model.progressMapping] = parentGanttRecord.status;

            if (proxy._isTreeGridRendered || proxy._isGanttChartRendered)
                proxy.refreshGanttRecord(parentGanttRecord);

            if (parentGanttRecord.parentItem && parentGanttRecord.parentItem.isAutoSchedule && !isParent) {
                proxy._updateParentItem(parentGanttRecord);
            }
            else if (parentGanttRecord.parentItem && !parentGanttRecord.parentItem.isAutoSchedule && !isParent)
                proxy._updateManualParentItem(parentGanttRecord);
        },
        UpdatePredecessor: function () {
            var proxy = this;
            proxy._updatedRecordsDateByPredecessor();
            
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._connectorLinesCollection = [];
            proxy._createConnectorLinesCollection();
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines",
                proxy._connectorLinesCollection);
        },

        /* updated all records dates as per predecessor and successor collections */
        _updatedRecordsDateByPredecessor:function()
        {
            var proxy = this, model = this.model,
                flatRecords = model.flatRecords, length = flatRecords.length;
            for (var count = 0; count < length ; count++) {
                (flatRecords[count].predecessor && flatRecords[count].item[model.predecessorMapping]) && proxy._validatePredecessorDates(flatRecords[count]);
            }
        },

        /* updated the record dates as per predecessor and successor collections */
        _validatePredecessorDates: function (childGanttRecord) {

            var proxy = this, model = proxy.model;

            if (childGanttRecord.predecessor) {

                var predecessorsCollection = childGanttRecord['predecessor'],
                    count,
                    parentGanttRecord,
                    record = null,
                    isValidated = false,
                    predecessor,
                    lowestOffset,
                    flatRecords = model.flatRecords,
                    ids = model.ids;

                var currentTaskId = childGanttRecord['taskId'].toString(),
                    predecessors = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                    successors = predecessorsCollection.filter(function (data) { return data.from === currentTaskId });
                var predecessorLength = predecessors.length;

                for (count = 0; count < predecessorLength; count++) {
                    predecessor = predecessors[count];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    record = flatRecords[ids.indexOf(predecessor.to)];
                    if (record.isAutoSchedule || model.validateManualTasksOnLinking)
                        proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor);
                }

                var length = successors.length;

            }
        },


        _validatePredecessor: function (childGanttRecord, previousValue, validationOn) {

            var proxy = this, model = proxy.model;

            if (childGanttRecord.predecessor) {

                var predecessorsCollection = childGanttRecord['predecessor'],
                    count,                    
                    parentGanttRecord,
                    record=null,
                    connectorLineId,
                    isValidated = false,
                    predecessor,
                    connectorLineObject,
                    lowestOffset,
                    flatRecords = model.flatRecords,
                    ids = model.ids,
                     isOffsetChanged = false;

                var currentTaskId = childGanttRecord['taskId'].toString(),

                    predecessors = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                    successors = predecessorsCollection.filter(function (data) { return data.from === currentTaskId });
               var predecessorLength = predecessors.length;

                for (count = 0; count < predecessorLength; count++) {
                    predecessor = predecessors[count];
                    isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                    record = flatRecords[ids.indexOf(predecessor.to)];
                    connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                    if (proxy._$ganttchartHelper) {
                        proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                        this._updateConnectorLineCollection(connectorLineId);
                    }

                    if (model.enablePredecessorValidation && (record.isAutoSchedule || model.validateManualTasksOnLinking))
                       proxy._isValidationEnabled = true;
                   else
                       proxy._isValidationEnabled = false;
                   if ((childGanttRecord.taskId.toString() === predecessor.to || childGanttRecord.taskId.toString() === predecessor.from) &&
                       (!validationOn || validationOn == "predecessor") && proxy._isValidationEnabled)
                       proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                }
                for (count = 0; count < predecessorLength; count++) {
                    predecessor = predecessors[count];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                    record = flatRecords[ids.indexOf(predecessor.to)];
             
                    if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))//(model.enableVirtualization === false && !parentGanttRecord.isExpanded && record.isExpanded === false)
                        continue;
                    connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                    if (connectorLineObject) {
                        if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.length == 0) {
                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                            var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                            proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                        }
                    }                   

                }

                var length = successors.length;

                for (count = 0; count < length; count++) {

                    predecessor = successors[count];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    record = flatRecords[ids.indexOf(predecessor.to)];
                    connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                    isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                    if (model.enablePredecessorValidation && (record.isAutoSchedule || model.validateManualTasksOnLinking))
                        proxy._isValidationEnabled = true;
                    else
                        proxy._isValidationEnabled = false;
                    if (proxy._$ganttchartHelper) {
                        proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                        this._updateConnectorLineCollection(connectorLineId);
                    }
                    if (validationOn != "predecessor" && proxy._isValidationEnabled)
                        proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                    if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))
                        continue;
                    connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                    if (connectorLineObject) {
                        if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.length == 0) {
                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                            var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                            proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                        }
                    }

                    record && proxy._validatePredecessor(record, undefined, "successor");

                }                
            }
        },

        /*While zooming the browser we have re-rendered the connector lines collection
        for this we need keep the connectot lines collection updated*/
        _updateConnectorLineCollection: function (connectorLines) {
            if (typeof connectorLines == "string") {
                for (var count = 0; count < this._connectorLinesCollection.length; count++) {
                    if (this._connectorLinesCollection[count].ConnectorLineId == connectorLines) {
                        this._connectorLinesCollection.splice(count, 1);
                        break;
                    }
                }
            } else {
                for (var count = 0; count < connectorLines.length; count++) {
                    var currentObj, index = 0;
                    for (var inCount = 0; inCount < this._connectorLinesCollection.length; inCount++) {
                        if (this._connectorLinesCollection[inCount].ConnectorLineId == connectorLines[count].ConnectorLineId) {
                            currentObj = connectorLines[count];
                            index = count;
                            break;
                        }
                    }
                    if (currentObj)
                        this._connectorLinesCollection[index] = currentObj;
                    else
                        this._connectorLinesCollection.push(connectorLines[count]);
                }
            }
        },
        // Check whether the predecessor offset is changed or not.
        _isOffsetChange: function (predecessor, previousValue, count)
        {
            var proxy = this,
                model = proxy.model,
                isOffsetChanged = false;
            if (!model.enablePredecessorValidation) {
                if (previousValue && previousValue.length) {
                    var predecessorOffset = predecessor.offset ? parseInt(predecessor.offset) : 0,
                        previousPredecessor = previousValue[count],
                        previousPredecessorOffset = previousPredecessor.offset ? parseInt(previousPredecessor.offset) : 0;
                    isOffsetChanged = predecessorOffset != previousPredecessorOffset ? true : false;

                }
                else if (ej.isNullOrUndefined(previousValue)) {
                    isOffsetChanged = false;
                }
                else
                    isOffsetChanged = true;
            }
            return isOffsetChanged;
        },
        _calculateDateDifference: function (emptyDate, dateDiff) {
            var differenceCount = dateDiff >= 0 ? dateDiff : (-1 * dateDiff),
                offset = 0;
            
            if (dateDiff > 0)
                offset = differenceCount - this._calculateWeekendCount(emptyDate, dateDiff);
            else
                offset = dateDiff + this._calculateWeekendCount(emptyDate, dateDiff);
            return offset;
        },

        _calculateWeekendCount: function (emptyDate, dateDiff) {
            var differenceCount = dateDiff >= 0 ? dateDiff : (-1 * dateDiff),
                weekendCount = 0,
                i = 0;
            
            if (dateDiff > 0) {
                for (i = 0; i < dateDiff; i++) {
                    if (emptyDate.getDay() == 0) {
                        weekendCount++;
                        emptyDate.setDate(emptyDate.getDate() + 1);
                    }
                    else if (emptyDate.getDay() == 6) {
                        weekendCount += 2;
                        ++i;
                        emptyDate.setDate(emptyDate.getDate() + 2);
                    } else
                        emptyDate.setDate(emptyDate.getDate() + 1);
                }
            }
            else {
                for (i = 0; i < differenceCount; i++) {
                    emptyDate.setDate(emptyDate.getDate() - 1);
                    if (emptyDate.getDay() == 0 || emptyDate.getDay() == 6) {
                        weekendCount += 1;
                    }
                }
            }
            return weekendCount;
        },

        _daydiff: function (first, second) {
            return ((new Date(second) - new Date(first)) / (1000 * 60 * 60 * 24));
        },

        //Calcualte the number of holidays between two dates
        _calculateHolidayCount: function (first, second) {
            var proxy = this,
                model = proxy.model,
                holidays = model.holidays,
                length = holidays.length,
                startDate = (first < second) ? first : second,
                endDate = (first > second) ? first : second,
                holidayCount = 0;
            for (var count = 0; count < length; count++) {
                if (proxy._getDateFromFormat(holidays[count].day) >= startDate && proxy._getDateFromFormat(holidays[count].day) <= endDate) {
                    holidayCount++;
                }
            }
            return holidayCount;
        },


        dateUpdate: function (date, days, hours, minutes) {
            if (!minutes)
                minutes = 0;
            return new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours() + hours,
                date.getMinutes() + minutes,
                date.getSeconds(),
                date.getMilliseconds()
            );
        },
        
        //refresh treegrid and gantt rows
        _refreshChartAndGridRows: function ()
        {
            var proxy = this, model = this.model, collapsedRecordCount, height;
            proxy._$treegridHelper.ejTreeGrid("processBindings");
            var tempArgs = {};
            tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
            proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();
            collapsedRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
            proxy._totalCollapseRecordCount = collapsedRecordCount;
            height = (proxy.model.updatedRecords.length - collapsedRecordCount) * model.rowHeight;
            proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
            proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
            if (!proxy._isInAdd) {
                proxy._$treegridHelper.ejTreeGrid("updateHeight");
                proxy._$ganttchart.ejGanttChart("updateHeight", height);
                proxy._$ganttchartHelper.ejGanttChart("setCollapsedRecordCount", collapsedRecordCount);
                proxy._$ganttchartHelper.ejGanttChart("refreshGridLinesTable", proxy.model.updatedRecords.length - collapsedRecordCount);
                if (model.enableAltRow && model.currentViewData.length > 0)
                    ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);

                if (model.predecessorMapping) {
                    proxy._isValidationEnabled = false;
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._createConnectorLinesCollection();
                }
            }
        },
        //Refresh gantt after expnadAll or collapseAll operation
        _refreshGanttOnExpandCollapseAll:function()
        {
            var proxy = this,
                args = {},
                model = this.model,
                collapsedRecordCount = 0,
                height = 0;

            if (model.enableVirtualization) {
                args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
                proxy._$treegridHelper.ejTreeGrid("updateAltRowOnCollapseAll");
                proxy._$treegridHelper.ejTreeGrid("updateAltRowOnRendering");
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args);
                model.updatedRecords = proxy.getUpdatedRecords();
                model.currentViewData = proxy.getCurrentViewData();
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords);
                proxy._$treegridHelper.ejTreeGrid("updateHeight");
            } else {
                //If need refresh chart if record is added after searching or sorting
                if (proxy._isRefreshAddedRecord) {
                    proxy._refreshChartAndGridRows();
                    proxy._isRefreshAddedRecord = false;
                    return;
                }
                collapsedRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
                proxy._totalCollapseRecordCount = collapsedRecordCount;
                height = (proxy.model.updatedRecords.length - collapsedRecordCount) * model.rowHeight;
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._$treegridHelper.ejTreeGrid("updateHeight");
                proxy._$ganttchart.ejGanttChart("updateHeight", height);
                proxy._$ganttchartHelper.ejGanttChart("setCollapsedRecordCount", collapsedRecordCount);
                proxy._$ganttchartHelper.ejGanttChart("refreshGridLinesTable", proxy.model.updatedRecords.length - collapsedRecordCount);
                if (model.enableAltRow && model.currentViewData.length > 0)
                    ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);
            }
            if (model.predecessorMapping) {
                proxy._isValidationEnabled = false;
                proxy._connectorlineIds = [];
                proxy._connectorLinesCollection = [];
                proxy._createConnectorLinesCollection();
            }
            if (proxy.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
            }
        },
        //get all the visible records in Gantt
        _collapsedRecords: function () {
            var proxy = this,
                model = proxy.model;
            var records = model.updatedRecords.filter(function (record) {
                if (record.parentItem == null)
                    return record;
                else if (record.parentItem[model.expandStateMapping] || ej.isNullOrUndefined(record.parentItem[model.expandStateMapping]))
                    return record;
            });
            return records;            
        },
        //collapse the defined records from data source on load time.
        _collapseRecordOnLoad: function () {
            var proxy = this,
               model = proxy.model,
               count = 0,
               ganttRecord,
               args = {},
               records,
               enableVirtualization = model.enableVirtualization,
               $gridRows = proxy.getRows(),
               $rowElement = null;

            proxy._gridRows = $gridRows;
            proxy._isInExpandCollapseAll = true;
            records = proxy._collapsedRecords();
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control            
            for (count = 0; count < records.length; count++) {
                ganttRecord = records[count];
                if (!ganttRecord[model.expandStateMapping]) {
                    if (ganttRecord[model.expandStateMapping] || ej.isNullOrUndefined(ganttRecord[model.expandStateMapping])) continue;
                    args.data = ganttRecord;
                    args.recordIndex = count;                    
                    args.expanded = false;
                    if (ganttRecord.hasChildRecords) {
                        !ganttRecord[model.expandStateMapping] && ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshGanttOnExpandCollapseAll();
            proxy._isInExpandCollapseAll = false;
        },
        //Collapse all parent and inner level parent records
        _collapseAll: function () {
            var proxy = this,
                model = proxy.model,
                count = 0,
                ganttRecord,
                args = {},
                enableVirtualization = model.enableVirtualization,
                $gridRows = proxy.getRows(),
                $rowElement = null;

            proxy._$treegridHelper.ejTreeGrid("cancelEditCell"); // Cancel the edit cell, if it is in edit mode.
            proxy._gridRows = $gridRows;
            proxy._isInExpandCollapse = true;
            proxy._isInExpandCollapseAll = true;
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control            
            for (count = 0; count < proxy.model.parentRecords.length; count++) {
                    ganttRecord = proxy.model.parentRecords[count];
                    args.data = ganttRecord;
                    args.recordIndex = count;
                    args.expanded = false;
                    if (ganttRecord.hasChildRecords) {
                        proxy._expandCollapseInnerLevelRecord(ganttRecord, args.expanded);
                        ganttRecord.expanded && ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshGanttOnExpandCollapseAll();

            proxy._isInExpandCollapse = false;
            proxy._isInExpandCollapseAll = false;
        },
        //expand or collapse all inner level parent records
        _expandCollapseInnerLevelRecord:function(record,expanded)
        {
            var proxy = this,
                length = record.childRecords.length,
                tempArgs = {};

            for (var count = 0; count < length; count++) {
                if (record.childRecords[count].hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(record.childRecords[count], expanded);
                    tempArgs.data = record.childRecords[count];
                    tempArgs.expanded = expanded;
                    if(record.childRecords[count].expanded !== expanded)
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, tempArgs);

                }
            }
        },


        //Method for expand all the GanttRecords
        
        _expandAll: function () {
            
            var proxy = this,
                model = proxy.model,
                count = 0,
                ganttRecord,
                args = {},
                enableVirtualization = model.enableVirtualization,
                parentRecords = model.parentRecords,
                length = parentRecords.length;

            proxy._isInExpandCollapse = true;
            proxy._isInExpandCollapseAll = true;
            //loop excecute for iterate the GanttRecords present in the Gantt Control

            for (count = 0; count < length; count++) {
                ganttRecord = parentRecords[count];
                args.data = ganttRecord;
                args.recordIndex = count;
                args.expanded = true;
                if (ganttRecord.hasChildRecords ) {
                    proxy._expandCollapseInnerLevelRecord(ganttRecord, args.expanded);
                    if(!ganttRecord.expanded)
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshGanttOnExpandCollapseAll();

            proxy._isInExpandCollapse = false;
            proxy._isInExpandCollapseAll = false;
        },
        _getDateFromFormat: function (date) {
            
            if (date == null)
                return;

            if (typeof date === "object") {
                return new Date(date);
            }
            if (date) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale) == null ?
                    new Date(date) : ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
        },
        _getFormatedDate: function (dateObject, dateformat, locale) {
            return ej.format(dateObject, dateformat, locale);
        },

        
        _destroy: function () {
            var proxy = this;
            //Unbind all events binded to Document and window and chart side and TreeGrid side
            this.element.off();
            proxy._off($(window), "resize", proxy.windowResize);
            $("#" + proxy._id + "_dialogEdit").data("ejDialog") && $("#" + proxy._id + "_dialogEdit").data("ejDialog").destroy();
            $("#" + proxy._id + "_dialogAdd").data("ejDialog") && $("#" + proxy._id + "_dialogAdd").data("ejDialog").destroy();
            $("#" + proxy._id + "_dialogAdd").remove();
            $("#" + proxy._id + "_dialogEdit").remove();
            $("#" + this._id + "_toolbarItems_Main").remove();
            $("#" + this._id + "_dialogEdit_wrapper").remove();
            $("#" + this._id + "startDateEdit_popup").remove();
            $("#" + this._id + "endDateEdit_popup").remove();
            $("#" + this._id + "startDateAdd_popup").remove();
            $("#" + this._id + "endDateAdd_popup").remove();
            $("#" + this._id + "taskTypeEdit_popup_wrapper").remove();
            $("#" + this._id + "_dialogAdd_wrapper").remove();
            $("#" + this._id + "effortDrivenEdit_popup_wrapper").remove();
            //Chart side
            var ganttChartObj = proxy._$ganttchartHelper.ejGanttChart("instance");
            ganttChartObj.destroy();
            //TreeGrid side
            var treeGridObj = proxy._$treegridHelper.ejTreeGrid("instance");
            treeGridObj.destroy();
            proxy.element.empty().removeClass("e-gantt-core e-gantt " + proxy.model.cssClass);
        },
        _updateToolbar: function () {
            var proxy = this,
                model = proxy.model,
                ganttHeight;
            $("#" + proxy._id + "_toolbarItems").remove();
            $("#" + proxy._id + "_toolbarItems_Main").remove();
            if (model.toolbarSettings.showToolbar) {
                proxy._renderToolBar().insertBefore($("#e-ejSpliter" + proxy._id));
                proxy._updateToolbarOptions("");
            }
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 3 : 2;//top,bottom,toolbar div
            } else {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 1 : 0;//top box-sizing:border-box includes it's border
            }
            proxy._$treegridHelper.ejTreeGrid("cancelEditCell");
            //Calculate the viewport height based on toolbar height
            //Change the tree grid and gantt chart container height based on view port height
            var toolbar = $("#" + proxy._id + "_toolbarItems"),
                ganttbody = proxy.element.find(".e-ganttviewerbodyContianer"),
                gantthead = proxy.element.find(".e-ganttviewerheaderContainer"),
                treegridcontent = ("#ejTreeGrid" + proxy._id + "e-gridcontent"),
                splitter = $("#e-ejSpliter" + proxy._id),
                height = $(proxy.element).height() - proxy._totalBorderHeight,
                viewPortHeight = height - gantthead.height() - 2 - toolbar.height(), // 2 is border width
                top = ganttbody.ejScroller("option", "scrollTop"),
                left = ganttbody.ejScroller("option", "scrollLeft");
            ganttbody.ejScroller({
                height: viewPortHeight
            });
            ganttHeight = height - toolbar.height();
            splitter.height(ganttHeight);
            $("#ejTreeGrid" + proxy._id).height(ganttHeight);
            $("#ejGanttChart" + proxy._id).height(ganttHeight);
            $(treegridcontent).height(viewPortHeight);
            ganttbody.height(viewPortHeight);
            $(treegridcontent).ejScroller("refresh");
            ganttbody.ejScroller("option", "scrollTop", top);
            ganttbody.ejScroller("option", "scrollLeft", left);
            proxy._$treegridHelper.ejTreeGrid("updateViewPortHeight");
            proxy._$ganttchartHelper.ejGanttChart("updateViewPortHeight");
            if (proxy.model.enableVirtualization) {
                proxy._$treegridHelper.ejTreeGrid("processBindings");
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords);
                proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", top);
            }
            proxy._clearContextMenu();
        },
        /*Get string value from record*/
        _getDurationStringValue: function (data) {
            var val = "";
            if (data.duration != null && data.duration != undefined)
                val += data.duration + " ";
            if (data.durationUnit != null && data.durationUnit != undefined) {
                var multiple = data.duration != 1;
                if (data.durationUnit == "day")
                    val += multiple ? this._durationUnitTexts.days : this._durationUnitTexts.day;
                else if (data.durationUnit == "hour")
                    val += multiple ? this._durationUnitTexts.hours : this._durationUnitTexts.hour;
                else
                    val += multiple ? this._durationUnitTexts.minutes : this._durationUnitTexts.minute;
            }
            return val;
        }
        


    });
    
    ej.Gantt.EditingType = {
        String: "stringedit",
        Boolean: "booleanedit",
        Numeric: "numericedit",
        Dropdown: "dropdownedit",
        DatePicker: "datepicker",
        DateTimePicker: "datetimepicker",
        Maskedit: "maskedEdit"
    };

    ej.Gantt.ToolbarItems = {
        Add: "add",
        Edit: "edit",
        Delete: "delete",
        Update: "update",
        Cancel: "cancel",
        Search: "search",
        Indent: "indent",
        Outdent: "outdent",
        ExpandAll: "expandAll",
        CollapseAll: "collapseAll",
        PrevTimeSpan: "prevTimeSpan",
        NextTimeSpan: "nextTimeSpan",        
        CriticalPath: "criticalPath",
        ExcelExport: "excelExport",
        PdfExport: "pdfExport"
    };

    ej.Gantt.ScheduleHeaderType = {
        Year: "year",
        Month: "month",
        Week: "week",
        Day: "day",
        Hour:"hour"
    };

    ej.Gantt.minutesPerInterval = {
        Auto:"auto",
        OneMinute: "oneMinute",
        FiveMinutes: "fiveMinutes",
        FifteenMinutes: "fifteenMinutes",
        ThirtyMinutes:"thirtyMinutes"
    };

    ej.Gantt.DurationUnit = {
        Day: "day",
        Hour: "hour",
        Minute:"minute"
    };
    ej.Gantt.WorkUnit = {
        Day: "day",
        Hour: "hour",
        Minute: "minute"
    };
    ej.Gantt.TaskType = {
        FixedUnit: "fixedUnit",
        FixedWork: "fixedWork",
        FixedDuration: "fixedDuration"
    }
    ej.Gantt.workingTimeScale = {
        TimeScale8Hours: "TimeScale8Hours",
        TimeScale24Hours: "TimeScale24Hours",
    };

    ej.Gantt.RowPosition = {
        Top: "top",
        Bottom: "bottom",
        AboveSelectedRow: "aboveselectedrow",
        BelowSelectedRow: "belowselectedrow",
        Child:"child"
    };

    //Enum for Edit Action of TreeGrid.
    ej.Gantt.BeginEditAction = {
        DblClick: "dblClick",
        Click: "click"
    };

    //Enum Value of selectionType.
    ej.Gantt.SelectionType = {
        Single: "single",
        Multiple:"multiple"
    };

    //Enum Value of selectionType.
    ej.Gantt.TimescaleRoundMode = {
        Auto:"auto",
        Year: "year",
        Month: "month",
        Week:"week"
    };


    //Enum Value of selectionMode.
    ej.Gantt.SelectionMode = {
        Row: "row",
        Cell: "cell"
    };

    ej.Gantt.TaskSchedulingMode = {
        Auto: "auto",
        Manual: "manual",
        Custom: "custom"
    };

    ej.Gantt.Locale = ej.Gantt.Locale || {};

    ej.Gantt.Locale["default"] = ej.Gantt.Locale["en-US"] = {

        //string to display with dataSource contains 0 objects
        emptyRecord: "No records to display",

        alertTexts: {
            indentAlert: "There is no gantt record is selected to perform the Indent",
            outdentAlert: "There is no gantt record is selected to perform the Outdent",
            predecessorEditingValidationAlert: "Cyclic Dependency Occured, Please Check The Predecessor",
            predecessorAddingValidationAlert: "Fill all the columns in predecessor table",
            idValidationAlert: "Duplicate ID",
            dateValidationAlert: "Invalid End date",
            dialogResourceAlert: "Fill All the columns in resource table"
        },

        //headerText to be displayed in treegrid
        columnHeaderTexts: {
            taskId: "ID",
            taskName: "Task Name",
            startDate: "Start Date",
            endDate: "End Date",
            resourceInfo: "Resources",
            duration: "Duration",
            status: "Progress",
            taskMode: "Task Mode",
            subTasksStartDate: "SubTasks Start Date",
            subTasksEndDate: "SubTasks End Date",
            scheduleStartDate: "Schedule Start Date",
            scheduleEndDate: "Schedule End Date",
            predecessor: "Predecessors",
            type: "Type",
            offset: "Offset",
            baselineStartDate: "Baseline Start Date",
            baselineEndDate: "Baseline End Date",
            WBS: "WBS",
            WBSPredecessor: "WBS Predecessor",
            dialogCustomFieldName: "Column Name",
            dialogCustomFieldValue: "Value",
            notes: "Notes",
            taskType: "Task Type",
            work: "Work",
            unit:"Unit",
            effortDriven: "Effort Driven"
        },

        //string to display in dialog 
        editDialogTexts: {
            addFormTitle: "New Task",
            editFormTitle: "Task Information",
            saveButton: "Save",
            deleteButton: "Delete Task",
            cancelButton: "Cancel",
            addPredecessor: "Add New",
            removePredecessor: "Remove",
            addButton: "Add"
        },

        //string to display in column add dialog 
        columnDialogTexts: {
            field: "Field",
            headerText: "Header Text",
            editType: "Edit Type",
            filterEditType: "Filter Edit Type",
            allowFiltering: "Allow Filtering",
            allowFilteringBlankContent: "Allow Filtering Blank Content",
            allowSorting: "Allow Sorting",
            visible: "Visible",
            width: "Width",
            textAlign: "Text Alignment",
            headerTextAlign: "Header Text Alignment",
            columnsDropdownData: "Column Dropdown Data",
            dropdownTableText: "Text",
            dropdownTableValue: "Value",
            addData: "Add",
            deleteData: "Remove",
            allowCellSelection: "Allow Cell Selection",
            displayAsCheckbox: "Display As Checkbox",
            clipMode: "Clip Mode",
            tooltip: "Tooltip",
            headerTooltip: "Header Tooltip"
        },

        //string to be displayed in Toolbox's tooltip 
        toolboxTooltipTexts: {
            addTool: "Add",
            editTool: "Edit",
            saveTool: "Update",
            deleteTool: "Delete",
            cancelTool: "Cancel",
            searchTool: "Search",
            indentTool: "Indent",
            outdentTool: "Outdent",
            expandAllTool: "Expand All",
            collapseAllTool: "Collapse All",
            nextTimeSpanTool: "Next Timespan",
            prevTimeSpanTool: "Previous Timespan",            
            criticalPathTool: "Critical Path",
            excelExportTool: "Excel Export",
            pdfExportTool:"PDF Export"
        },

        //string to be displayed in taskbar tooltip for duration unit 
        durationUnitTexts: {           
            days: "days",
            hours: "hours",
            minutes: "minutes",
            day: "day",
            hour: "hour",
            minute: "minute",
        },
        durationUnitEditText: { minute: ["m", "min", "minute", "minutes"], hour: ["h", "hr", "hour", "hours"], day: ["d", "dy", "day", "days"] },

        //string to be displayed in taskbar tooltip for duration unit 
        workUnitTexts: {
            day: "days",
            hour: "hours",
            minute: "minutes"           
        },

        //String to be displayed in default type drop down.
        taskTypeTexts: {
            fixedWork: "Fixed Work",
            fixedUnit: "Fixed Units",
            fixedDuration: "Fixed Duration"
        },

        //String to be displayed in effort drven drop down box.
        effortDrivenTexts: {
            yes: "Yes",
            no: "No"
        },

        //string to be displayed in context menu 
        contextMenuTexts: {
            taskDetailsText: "Task Details...",
            addNewTaskText: "Add New Task",
            indentText: "Indent",
            outdentText: "Outdent",
            deleteText: "Delete",
            aboveText: "Above",
            belowText: "Below"
        },

        //Name to be displayed for New Task while adding  
        newTaskTexts: {           
            newTaskName: "New Task"
        },

        //string to be displayed in column menu 
        columnMenuTexts: {
            sortAscendingText: "Sort Ascending",
            sortDescendingText: "Sort Descending",
            columnsText: "Columns",
            insertColumnLeft: "Insert Column Left",
            insertColumnRight: "Insert Column Right",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column"
        },

        taskModeTexts: {
            manual: "Manual",
            auto: "Auto"
        },

        //String to be display for edittype and filter edit type.
        editTypeTexts: {
            string: "String",
            numeric: "Numeric",
            datePicker: "Date Picker",
            dateTimePicker: "Date Time Picker",
            dropdown: "Dropdown",
            boolean: "Boolean"

        },

        // String to be display for text align type.
        textAlignTypes: {
            right: "Right",
            left: "Left",
            center: "Center"
        },

        // String to be display for clip mode type.
        clipModeTexts: {
            clip: "Clip",
            ellipsis: "Ellipsis"
        },

        //string to be displayed in column add dialog title 
        columnDialogTitle: {
            insertColumn: "Insert Column",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column"
        },

        //Locale Text for delete confirm dialog
        deleteColumnText: "Are you sure you want to delete this column?",
        okButtonText: "OK",
        cancelButtonText: "Cancel",
        confirmDeleteText: "Confirm Delete",

        predecessorEditingTexts: {
            fromText: "From",
            toText : "To"
        },

        dialogTabTitleTexts: {
            generalTabText: "General",
            predecessorsTabText: "Predecessors",
            resourcesTabText: "Resources",
            customFieldsTabText: "Custom Fields",
            notesTabText:"Notes"
        },
        predecessorCollectionText: [
                { id: "SS", text: "Start-Start", value: "Start-Start" },
                { id: "SF", text: "Start-Finish", value: "Start-Finish" },
                { id: "FS", text: "Finish-Start", value: "Finish-Start" },
                { id: "FF", text: "Finish-Finish", value: "Finish-Finish" }
            ],        
    };

    /*-----Initialize the GanttRecord object--------------*/

    ej.Gantt.GanttRecord = function () {
        var proxy = this;
        proxy.taskId = null;
        proxy.taskName = null;
        proxy.startDate = null;
        proxy.endDate = null;
        proxy.duration = null;
        proxy.isMilestone = false;
        proxy.status = null;
        proxy.predecessor = null;
        proxy.resourceInfo = null;
        proxy.parentItem = null;
        proxy.isSelected = false;
        proxy.childRecords = null;
        proxy.hasChildRecords = false;
        proxy.expanded = false;
        proxy.level = 0;
        proxy.left = 0;
        proxy.width = 0;
        proxy.progressWidth = 0;
        proxy.item = null;
        proxy.baselineLeft = 0;
        proxy.baselineWidth = 0;
        proxy.baselineStartDate = null;
        proxy.baselineEndDate = null;
        proxy.isCritical = false,
        proxy.slack = null,
        proxy.isReadOnly = false;
        proxy.hasFilteredChildRecords = true;
        proxy.taskbarBackground = null;
        proxy.progressbarBackground = null;
        proxy.parentProgressbarBackground = null;
        proxy.cellBackgroundColor = null;
        proxy.rowBackgroundColor = null;
        proxy.treeMappingName = [];
        proxy.dragState = true;
        proxy.isSelected = false;
        proxy.durationUnit = "";
        proxy.isAutoSchedule = true;
        proxy.manualStartDate = null;
        proxy.manualEndDate = null;
        proxy.manualLeft = 0;
        proxy.manualDuration = 0;
        proxy.manualWidth = 0;
    }

    ej.Gantt.GanttRecord.prototype = {

        //calculate the left position of the taskbar
        _calculateLeft: function (ganttObj) {
            return ganttObj._getTaskLeft(this.startDate);
        },

        _calculateManualLeft: function (ganttObj) {
            return ganttObj._getTaskLeft(this.manualStartDate);
        },

        //calculate the left margin of the baseLine element.
        _calculateBaselineLeft: function (ganttObj) {
            var beginDate = new Date(this.baselineStartDate),
                endDate = new Date(this.baselineEndDate);
            if (beginDate && endDate) {
                return ganttObj._getTaskLeft(beginDate);
            } else {
                return 0;
            }
        },

        //calculate the right margin of the baseLine element.
        _calculateBaselineRight: function (ganttObj) {
            var beginDate = new Date(this.baselineStartDate),
                endDate = new Date(this.baselineEndDate);
            if (beginDate && endDate) {
                return ganttObj._getTaskLeft(endDate);
            } else {
                return 0;
            }
        },

        _updateHoliday: function (date, holidays, model) {
            var j = 0,
                length = holidays && holidays.length;

            if (length > 0) {

                for (j = 0; j < length; j++) {
                    var tempDate = new Date(date);

                    tempDate.setHours(0, 0, 0, 0);

                    if (this._getFormatedDate(holidays[j], model.dateFormat, model.locale) == this._getFormatedDate(date, model.dateFormat, model.locale)) {
                        date.setDate(date.getDate() + 1);
                    }
                }
                if ((model.includeWeekend == false) && (date.getDay() == 6)) {
                    date.setDate(date.getDate() + 2);
                }
            }
        },

        _calculateGanttRecordLeft: function (startDate, projectStartDate, dayWidth) {
            var proxy = this,
                diffDate = proxy._daydiff(projectStartDate, startDate);
            return (diffDate * dayWidth);
        },

        _calculateReverseLeft: function (projectStartDate, dayWidth, includeWeekend, dateformat) {
            var diffDate,
                proxy = this,
                enddatecount = 0,
                startdate = proxy.startDate,
                duration = proxy.duration && parseInt(proxy.duration);

            if (startdate == null) {

                startdate = new Date(proxy.endDate);
                startdate.setDate(startdate.getDate() - duration);
            }
            if (includeWeekend == false) {

                var emptyDate = new Date(proxy.endDate);

                for (var i = 0; i < duration; i++) {

                    if (emptyDate.getDay() == 0) {
                        enddatecount += 2;
                        emptyDate.setDate(emptyDate.getDate() - 2);
                    }
                    else if (emptyDate.getDay() == 6) {
                        enddatecount++;
                    }
                    emptyDate.setDate(emptyDate.getDate() - 1);
                }
                startdate = new Date(proxy.endDate);
                enddatecount = duration === 0 ? 1 : enddatecount;
                startdate.setDate(startdate.getDate() - (duration + enddatecount - 1));
            }
            proxy.startDate = new Date(startdate);
            diffDate = Math.ceil((startdate - projectStartDate) / 86400000);
            return (diffDate * dayWidth);
        },

        _calculateReverseWidth: function (dayWidth, dateFormat, includeWeekend, holidays) {

            var proxy = this,
                enddatecount = 0,
                diffDate,
                emptyDate,
                i = 0,
                startdate = proxy.startDate,
                duration = proxy.duration && parseInt(proxy.duration),
                enddate = proxy.endDate;

            if (startdate == null) {
                startdate = new Date(enddate);
                startdate.setDate(startdate.getDate() - duration + 1);

            }

            if (includeWeekend == false) {

                emptyDate = new Date(enddate);

                for (i = 0; i < duration; i++) {

                    if (emptyDate.getDay() == 0) {

                        enddatecount += 2;
                        emptyDate.setDate(emptyDate.getDate() - 2);

                    } else if (emptyDate.getDay() == 6) {
                        enddatecount++;
                    }

                    emptyDate.setDate(emptyDate.getDate() - 1);

                }

                startdate = new Date(enddate);
                startdate.setDate(startdate.getDate() - (duration + enddatecount - 1));
            }

            if (holidays != null && holidays.length > 0) {

                emptyDate = new Date(startdate);

                for (i = 0; i < duration; i++) {

                    emptyDate.setDate(emptyDate.getDate() + 1);

                    for (var j = 0; j < holidays.length; j++) {

                        if (proxy._getDateFromFormat(holidays[j].day).getDate() == emptyDate.getDate()) {
                            enddatecount++;
                        }

                    }

                    if ((includeWeekend == false) && (emptyDate.getDay() == 0 || emptyDate.getDay() == 6)) {
                        enddatecount++;
                    }

                }

                enddate = new Date(proxy.startDate);
                enddate.setDate(enddate.getDate() + (duration + enddatecount - 1));
            }

            diffDate = Math.ceil((new Date(enddate) - (proxy.startDate)) / 86400000) + 1;

            return (diffDate) * dayWidth;
        },

        _calculateWidth: function (ganttObj) {
            var proxy = this,
                startdate = new Date(proxy.startDate),
                enddate = new Date(proxy.endDate);
            return ganttObj._getTaskWidth(startdate, enddate);
        },

        _calculateManualWidth: function (ganttObj) {
            var proxy = this,
                manualStartDate = new Date(proxy.manualStartDate),
                manualEndDate = new Date(proxy.manualEndDate);
            return ganttObj._getTaskWidth(manualStartDate, manualEndDate);
        },

        _calculateBaseLineWidth: function (ganttObj) {
            var proxy = this,
               startdate = new Date(this.baselineStartDate),
                   enddate = new Date(this.baselineEndDate);
            return ganttObj._getTaskWidth(startdate, enddate);
        },
        _getFormatedDate: function (dateObject, dateformat, locale) {
            return ej.format(dateObject, dateformat, locale);
        },

        _getDateFromFormat: function (dateString, dateformat, locale) {
            if (dateString) {
                return ej.parseDate(dateString, dateformat, locale) == null ?
                    new Date(dateString) : ej.parseDate(dateString, dateformat, locale);
            }
        },

        _calculateProgressWidth: function (parentWidth, percent) {
            return (parentWidth * percent) / 100;
        },

        _setResourceInfo: function (resourceIdcollection, resourceIdMapping, resourceNameMapping, resourceUnitMapping, resourcecollection) {

            var proxy=this, count = 0,
            resources = [];

            for (count; count < resourceIdcollection.length; count++) {

                var resource = resourcecollection.filter(function (resourceInfo) {
                    return resourceIdcollection[count] === resourceInfo[resourceIdMapping];
                });

                var ganttRecordResource = $.extend({}, resource[0]);
                if (resource.length) {
                    resources.push(ganttRecordResource);
                    proxy._updateResourceUnit(resource[0], ganttRecordResource, resourceUnitMapping);
                }
                else {
                    resourceIdcollection.splice(count, 1);
                    count--;
                }
            }
            return resources;
        },
        _updateResourceUnit: function (resource, ganttRecordResource, resourceUnitMapping) {          
            if (resourceUnitMapping != "") {
                if (ej.isNullOrUndefined(resource[resourceUnitMapping]))
                    ganttRecordResource[resourceUnitMapping] = 100;
            }
            else                
                ganttRecordResource.unit = 100;            
        },
        _updateEndDate: function (prevStartDate, includeWeekend, dateFormat) {
            var proxy = this,
                formatedPrevStartDate = new Date(prevStartDate),
                formatedStartDate = new Date(proxy.startDate),
                diff = proxy._daydiff(formatedPrevStartDate, formatedStartDate),
            endDate = new Date(proxy.endDate),
            weekendCount = 0;

            if (includeWeekend == false) {
                var count = 0;
                for (count; count <= diff; count++) {
                    endDate.setDate(endDate.getDate() + 1);
                    if (endDate.getDay() == 0 || endDate.getDay() == 6)
                        weekendCount += 1;
                }
            }

            var modifiedEndDate = proxy.endDate;
            modifiedEndDate.setDate(modifiedEndDate.getDate() + diff + weekendCount);
            proxy.endDate = new Date(modifiedEndDate);
        },

        _calculateFormatedDate: function (date, format, locale) {
            return ej.format(date, format, locale);
        },

        _updateParentProgress: function (parent, progressMapping) {
            var parentProgress = 0,
                childRecords = parent.childRecords,
                childCount = childRecords ? childRecords.length : 0,
                totalProgress = 0,
                milesStoneCount = 0,
                taskCount = 0;

            if (childRecords) {
                for (var i = 0; i < childCount; i++) {
                    if (!childRecords[i].isMilestone)
                        totalProgress += parseInt(childRecords[i].status);
                    else
                        milesStoneCount += 1;
                }
                taskCount = childCount - milesStoneCount;
                parentProgress = taskCount > 0 ? (totalProgress / taskCount) : 0;
                if (isNaN(parentProgress))
                    parentProgress = 0;
                var width = parent.isAutoSchedule ? parent.width : parent.manualWidth;
                parent.progressWidth = this._getProgressWidth(width, parentProgress);
                parent.status = Math.floor(parentProgress);
                if (progressMapping)
                    parent.item[progressMapping] = parent.status;
            }
            if (parent.parentItem) {
                this._updateParentProgress(parent.parentItem, progressMapping);
            }
        },


        _getProgressWidth: function (parentwidth, percent) {
            return (parentwidth * percent) / 100;
        },

        _calculatePredecessor: function (string, durationUnitLabels, defaultDurationUnit) {
            var collection = [],
                match,
                obj = {},
                values,
                to = this.taskId.toString(),
                offsetvalue,
                ganttRecord = this;
            if (typeof string === 'string')
            {
                string.split(',').forEach(function (el) {
                    values = el.split('+');
                    offsetvalue = '+';
                    if (el.indexOf('-') >= 0) {
                        values = el.split('-');
                        offsetvalue = '-';
                    }
                    match = values[0].match(/(\d+|[A-z]+)/g);
                    obj = {
                        from: match[0],
                        predecessorsType: match.length > 1 ? match[1].toUpperCase() : "FS",
                        offset: values.length > 1 ? offsetvalue + "" + values[1] : "0",
                        isdrawn: false,
                        to: to
                    };
                    var offsetUnits = ganttRecord._getOffsetDurationUnit(obj.offset, durationUnitLabels, defaultDurationUnit);
                    obj.offset = offsetUnits.duration;
                    obj.offsetDurationUnit = offsetUnits.durationUnit;
                    collection.push(obj);
                });
           }
            return collection;
        },
        /*Get duration and duration unit value from tasks*/
        _getOffsetDurationUnit: function (val, durationUnitLabels, defaultDurationUnit) {
            var duration = 0,
                  durationUnit = defaultDurationUnit;

            if (typeof val == "string") {
                var values = val.match(/(-?\d*\.*\d+|[A-z]+)/g);
                if (values && values.length <= 2) {
                    duration = parseFloat(values[0]);
                    durationUnit = values[1] ? values[1].toLowerCase() : "";
                    if (durationUnitLabels.minute.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Minute;
                    else if (durationUnitLabels.hour.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Hour;
                    else if (durationUnitLabels.day.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Day;
                    else
                        durationUnit = defaultDurationUnit;
                }
            } else {
                duration = val;
                durationUnit = defaultDurationUnit;
            }
            if (isNaN(duration)) {
                duration = 0;
                durationUnit = ej.Gantt.DurationUnit.Day;
            }
            var output = {};
            output.duration = duration;
            output.durationUnit = durationUnit;
            return output;
        },

        _updateGanttRecord: function (startDateMappingName, endDateMappingName, durationMappingName, includeWeekend, scheduleStartDay, perDayWidth, dateFormat, holidays) {
            var proxy = this,
                remainDays = proxy.left % perDayWidth,
                day = (proxy.left - remainDays) / perDayWidth, holiday,
                startDate = new Date(scheduleStartDay);

            startDate.setDate(scheduleStartDay.getDate() + day);

            if (startDate.getDay() == 0)
                startDate.setDate(startDate.getDate() + 1);
            else if (startDate.getDay() == 6)
                startDate.setDate(startDate.getDate() + 2);

            proxy.startDate = new Date(startDate);
            proxy.left = proxy._calculateLeft(this);
            proxy.width = proxy._calculateWidth(this);
            if (proxy.parentItem)
                proxy._updateParentItem(proxy, startDateMappingName, endDateMappingName, durationMappingName, includeWeekend, scheduleStartDay, perDayWidth, dateFormat, holidays);
        },

        _calculateUpdatedDate: function (modifiedDate, offset) {
            var proxy = this,
                i = 0;
            if (offset > 0) {
                for (i; i < offset; i++) {
                    modifiedDate = proxy._dataSubtract(modifiedDate, 1);
                    if (modifiedDate.getDay() == 0)
                        modifiedDate.setDate(modifiedDate.getDate() + 1);
                    else if (modifiedDate.getDay() == 6)
                        modifiedDate.setDate(modifiedDate.getDate() + 2);
                }
            } else {
                var dateOffset = (-1) * offset;
                for (i = 0; i < dateOffset; i++) {
                    modifiedDate = proxy._dataSubtract(modifiedDate, -1);
                    if (modifiedDate.getDay() == 0)
                        modifiedDate.setDate(modifiedDate.getDate() - 2);
                    else if (modifiedDate.getDay() == 6)
                        modifiedDate.setDate(modifiedDate.getDate() - 1);
                }
            }
            modifiedDate = new Date(modifiedDate);
            return modifiedDate;
        },

        _dataSubtract: function (date, days) {
            return new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours(),
                date.getMinutes(),
                date.getSeconds(),
                date.getMilliseconds()
            );
        },

        _calculateEndDate: function (ganttObj) {
            var model = ganttObj.model,
                tempEndDate = ganttObj._getEndDate(this.startDate, this.duration, this.durationUnit, this);
            this.endDate = new Date(tempEndDate);
            if (model.endDateMapping)
                this.item[model.endDateMapping] = this.endDate;
        },

        _calculateTimeScale8Hour: function (startHour, duration) {
              if ((24 - startHour) > 8) {           
                    if (this.duration < 8)
                        duration = this.duration;
                    else
                        duration = this.duration % 8;             
            }
            if ((24 - startHour) < 8 || this.duration > 8)
                startHour = 8;
            if (duration == 0)
                duration = 8;
            var endHour = startHour;

            do {
                if ((startHour >= 8 && startHour < 13) || (startHour > 13 && startHour <= 17)) {
                    endHour++;
                    duration--;
                    startHour = startHour == 24 ? 0 : startHour + 1;
                }
                else {
                    startHour = startHour == 24 ? 0 : startHour + 1;
                    
                    endHour++;
                    duration--;
                }
            } while (duration > 0);

            return endHour;
        },

        _dateUpdate: function (date, days, hours, minutes) {
            if (!minutes)
                minutes = 0;           
            return new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours() + hours,
                date.getMinutes() + minutes,
                date.getSeconds(),
                date.getMilliseconds()
            );
        },

        _calculateDuration: function (ganttObj) {
            var model = ganttObj.model, tempDuration = ganttObj._getDuration(this.startDate, this.endDate, this.durationUnit, this.isAutoSchedule);
            this.duration = tempDuration;
            if (model.durationMapping && this.item) {
                this.item[model.durationMapping] = tempDuration;
                model.durationUnitMapping && (this.item[model.durationUnitMapping] = this.durationUnit);
            }
        },

        _calculateManualDuration: function (ganttObj) {
            var tempDuration = ganttObj._getDuration(this.manualStartDate, this.manualEndDate, this.durationUnit, this.isAutoSchedule);
            this.manualDuration = tempDuration;
        },

        _calculateDateDifference: function (emptyDate, dateDiff) {
            var differenceCount = dateDiff >= 0 ? dateDiff : (-1 * dateDiff),
                offset = 0;

            if (dateDiff > 0)
                offset = differenceCount - this._calculateWeekendCount(emptyDate, dateDiff) + 1;
            else
                offset = dateDiff + this._calculateWeekendCount(emptyDate, dateDiff);
            return offset;
        },

        _calculateWeekendCount: function (emptyDate, dateDiff) {
            var differenceCount = dateDiff >= 0 ? dateDiff : (-1 * dateDiff),
                weekendCount = 0,
                i = 0;

            if (dateDiff > 0) {
                for (i = 0; i < dateDiff; i++) {
                    if (emptyDate.getDay() == 0) {
                        weekendCount++;
                        emptyDate.setDate(emptyDate.getDate() + 1);
                    }
                    else if (emptyDate.getDay() == 6) {
                        weekendCount += 2;
                        ++i;
                        emptyDate.setDate(emptyDate.getDate() + 2);
                    } else
                        emptyDate.setDate(emptyDate.getDate() + 1);
                }
            }
            else {
                for (i = 0; i < differenceCount; i++) {
                    emptyDate.setDate(emptyDate.getDate() - 1);
                    if (emptyDate.getDay() == 0 || emptyDate.getDay() == 6) {
                        weekendCount += 1;
                    }
                }
            }
            return weekendCount;
        },
        //Update duration with respect to work and units of resources of a task.
        _updateDurationWithWork: function (proxy) {
            var model = proxy.model, totalHours,
                resourceInfo = this.resourceInfo,
                resourceLength = resourceInfo ? resourceInfo.length : 0,
                totalResourceOneDayWork = 0,
                updatedDuration = 0,
                ActualOneDayWork = proxy._secondsPerDay / (60 * 60); //in hours

            for (var length = 0; length < resourceLength; length++) {
                var resourceUnit = resourceInfo[length][model.resourceUnitMapping], //in percentage 
                    resourceOneDayWork = resourceUnit > 0 ? (ActualOneDayWork * resourceUnit) / 100 : ActualOneDayWork;//in hours

                totalResourceOneDayWork += resourceOneDayWork;
            }

            totalHours = this._getTotalWorksInHours(model,ActualOneDayWork);

            if (resourceLength != 0)
                updatedDuration += (totalHours / totalResourceOneDayWork);

            //Update work as per defined unit.
            if (this.durationUnit == "minute")
                updatedDuration = updatedDuration * ActualOneDayWork * 60;
            if (this.durationUnit == "hour")
                updatedDuration = updatedDuration * ActualOneDayWork;

            //To check the decimal places.
            if (updatedDuration % 1 != 0)
                updatedDuration = updatedDuration.toFixed(2);

            proxy._isDurationUpdated = true;

            this.duration = updatedDuration;

            if (model.durationMapping)
                this.item[model.durationMapping] = this.duration;
        },
        //Update work with respect to duration and units of resources of a task.
        _updateWorkWithDuration: function (proxy) {
            var model = proxy.model,
                resourceInfo = this.resourceInfo,
                resourceLength = resourceInfo ? resourceInfo.length : 0,
                updatedWorks = 0,
                ActualOneDayWork = proxy._secondsPerDay / (60 * 60), //in hours
                durationInDay = this._getDurationInDays(ActualOneDayWork);

            for (var length = 0; length < resourceLength; length++) {
                var resourceUnit = resourceInfo[length][model.resourceUnitMapping], //in percentage 
                    resourceOneDayWork = resourceUnit > 0 ? (ActualOneDayWork * resourceUnit) / 100 : ActualOneDayWork;//in hours
                updatedWorks += (resourceOneDayWork * durationInDay);
            }

            //Update work as per defined unit.
            if (model.workUnit == "minute")
                updatedWorks = updatedWorks * 60;
            if (model.workUnit == "day")
                updatedWorks = updatedWorks / ActualOneDayWork;

            //To check the decimal places.
            if (updatedWorks % 1 != 0)
                updatedWorks = updatedWorks.toFixed(2);

            this.work = parseFloat(updatedWorks);
            if (model.workMapping)
                this.item[model.workMapping] = this.work;
        },
        //Update units of resources with respect to duration and work of a task.
        _updateUnitWithWork: function (proxy) {
            var model = proxy.model,
                resourceInfo = this.resourceInfo,
                resourceLength = resourceInfo ? resourceInfo.length : 0,
                ActualOneDayWork = proxy._secondsPerDay / (60 * 60); //in hours
            if (resourceLength == 0)
                return;
            var durationInDay = this._getDurationInDays(ActualOneDayWork),
                totalWorksInHour = this._getTotalWorksInHours(model, ActualOneDayWork),
                totalUnitInPercentage = durationInDay > 0 ? (totalWorksInHour / (durationInDay * ActualOneDayWork)) * 100 : 0,
                individualUnit = totalUnitInPercentage > 0 ? totalUnitInPercentage / resourceLength : 100;

            //To check the decimal places.
            if (individualUnit % 1 != 0)
                individualUnit = individualUnit.toFixed(2);           

            for (var length = 0; length < resourceLength; length++) {
                resourceInfo[length][model.resourceUnitMapping] = individualUnit;
            }
        },
        _getTotalWorksInHours:function(model, oneDayWork){
            var proxy = this, worksInHour;
            if (model.workUnit == "day")
                worksInHour = proxy.work * oneDayWork;
            else if (model.workUnit == "minute")
                worksInHour = proxy.work / 60;
            else
                worksInHour = proxy.work;

            return worksInHour;
        },
        _getDurationInDays:function(oneDayWork){
            var proxy = this, durationInDay;
            if (this.durationUnit == "hour")
                durationInDay = proxy.duration / oneDayWork;
            else if (this.durationUnit == "minute")
                durationInDay = proxy.duration / (oneDayWork * 60);
            else
                durationInDay = proxy.duration;

            return durationInDay;
        },       

        //Get day difference from two dates time
        _daydiff: function (first, second) {
            return ((second - first) / (1000 * 60 * 60 * 24));
        },
         //Get hour difference from two dates time      
        _hourdiff: function (first, second) {
            //if(first.getTime()>second.getTime())
            //    return ((first - second) / (1000 * 60 * 60));
            //else
                return ((second - first) / (1000 * 60 * 60));
        },
        //Get progress value from taskbar width and progrssbar width
        _getProgressPercent: function (parentwidth, progresswidth) {
            return Math.ceil(((progresswidth / parentwidth) * 100).toFixed(2));
        },
        //Get minute difference from two dates time 
        _minutediff: function (first, second) {
            return ((second - first) / (1000 * 60));
        },
        _setTime: function (seconds, date) {
            var hour = parseInt(seconds / (3600)),
               min = parseInt((seconds - (hour * 3600)) / 60),
               sec = seconds - (hour * 3600) - (min * 60);
            date.setHours(hour, min, sec, 0);
        },
        _endDateUpdate: function (date, days, minutes, workingTimeRanges, headerType) {
            if (!minutes)
                minutes = 0;
            var newDate = new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours(),
                date.getMinutes(),
                date.getSeconds(),
                date.getMilliseconds()
            );
            if (headerType == "day" || headerType == "hour") {
                //Rounding off to next day
                newDate.setHours(24);
                //Then assigning the dayDecimal duration values in Minutes for exact time
                newDate.setMinutes(minutes);
            }
            else {
                if (workingTimeRanges.length) {
                    if (minutes > 0) {
                        //Rounding off to next day
                        newDate.setHours(24);
                        //Updating to start time of the next day
                        this._setTime(workingTimeRanges[0].from, newDate);
                        //Then assigning the dayDecimal duration values in Minutes for exact time
                        newDate.setMinutes(minutes);
                    }
                    else
                        this._setTime(workingTimeRanges[workingTimeRanges.length - 1].to, newDate);
                }
            }
            return newDate;
        },
        _startDateUpdate: function (date, days, minutes, workingTimeRanges, headerType) {
            if (!minutes)
                minutes = 0;
            var newDate = new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours(),
                date.getMinutes(),
                date.getSeconds(),
                date.getMilliseconds()
            );
            if (headerType == "day" || headerType == "hour") {
                newDate.setMinutes(minutes);
            }
            else {
                if (workingTimeRanges.length) {
                    if (minutes > 0) {
                        //Updating to start time of the day
                        this._setTime(workingTimeRanges[0].from, newDate);
                        //Then add the balance dayDecimal duration values in Minutes for exact time
                        newDate.setMinutes(minutes);
                    }
                    else
                        this._setTime(workingTimeRanges[0].from, newDate);
                }
            }
            return newDate;
        }
    };
    //Get predecessor value
    ej.Gantt._getPredecessorsValue = function (data) {
        var predecessors = data.predecessor,
                returnVal = "";
        if (predecessors) {
            var length = predecessors.length,
                resultString = "";
            for (var i = 0; i < length; i++) {
                var cPredecessor = predecessors[i],
                    temp = "";
                if (cPredecessor.from != data.taskId) {
                    temp = cPredecessor.from + cPredecessor.predecessorsType;
                    if (cPredecessor.offset != 0) {
                        temp += cPredecessor.offset > 0 ? ("+" + cPredecessor.offset + " ") : (cPredecessor.offset + " ");
                        var multiple = cPredecessor.offset != 1;
                        if (cPredecessor.offsetDurationUnit == "day")
                            temp += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                        else if (cPredecessor.offsetDurationUnit == "hour")
                            temp += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                        else
                            temp += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
                    }
                    if (resultString.length > 0)
                        resultString = resultString + "," + temp;
                    else
                        resultString = temp;
                }
            }
        }
        return resultString;
    };
    ej.Gantt._getDurationStringValue = function (data) {
        var val = "";
        if (data.duration != null && data.duration != undefined)
            val += data.duration + " ";
        if (data.durationUnit != null && data.durationUnit != undefined) {
            var multiple = data.duration != 1;
            if (data.durationUnit == "day")
                val += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
            else if (data.durationUnit == "hour")
                val += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
            else
                val += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
        }
        return val;
    };
    //Returns cell value
    ej.Gantt._getCellValue = function (columnName) {

        var cellValue = this.data[columnName];

        if (cellValue) {
            return cellValue;
        } else {
            return this.data.item && this.data.item[columnName];
        }


    };

})(jQuery, Syncfusion);;
/**
 * @fileOverview Plugin to style the Html TreeGrid elements
 * @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
 *  Use of this code is subject to the terms of our license.
 *  A copy of the current license can be obtained at any time by e-mailing
 *  licensing@syncfusion.com. Any infringement will be prosecuted under
 *  applicable laws. 
 * @version 12.1 
 * @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
 */

(function ($, ej, undefined) {
    'use strict';
    ej.widget("ejTreeGrid", "ej.TreeGrid", {
        // widget element will be automatically set in this
        _rootCSS: "e-treegrid",

        // widget element will be automatically set in this
        element: null,

        validTags: ["div"],

        // user defined model will be automatically set in this
        model: null,

        _requiresID: true,
        _tags: [
        {
            tag: "columns",
            attr: ["field", "headerText", "allowSorting", "editType", "allowFiltering", "filterEditType", "width", "visible", "editParams", 
			"format", "isFrozen", "allowFreezing", "headerTemplateID", "allowCellSelection", "showCheckbox","showInColumnChooser", "validationRules.minlength", 
			"validationRules.maxlength", "validationRules.range", "validationRules.number", "validationRules.required","displayAsCheckbox"],
            content: "template"
        },
        {
            tag: "summaryRows",
            attr: ["title", "summaryColumns"],
            content: "template"
        },
         {
             tag: "summaryRows.summaryColumns",
             attr: ["summaryType", "dataMember", "displayColumn", "prefix", "suffix", "format"],
             content: "template"
         },
        {
            tag: "sortSettings.sortedColumns",
            attr: ["field", "direction"]
        },
        {
            tag: "sizeSettings",
            attr:["height","width"]
        },
        {
            tag:"columnResizeSettings",
            attr: ["columnResizeMode"]
        }
        ],
        _columns: function (index, property, value, old){
            var $header = this.element.find(".e-headercelldiv");
            $header[index.columns].innerHTML=value;
            this._trigger("refresh");
        },
        keyConfigs: {
            focus: "e",
            editRecord: "113", //F2
            saveRequest: "13", // enter
            cancelRequest: "27", //Esc         
            firstRowSelection: "36", //"Home",
            lastRowSelection: "35", //"End",
            leftArrow:"37",//Left arrow
            upArrow: "38", //Up arrow
            rightArrow:"39",//Right arrow
            downArrow: "40", //Down arrow
            moveCellRight: "9", //tab
            moveCellLeft: "shift+9", //shifttab
            shiftDownArrow: "shift+40", //shift + DownArrow
            shiftUpArrow: "shift+38", //shift + UpArrow
            shiftRightArrow: "shift+39", //shift + RightArrow
            shiftLeftArrow: "shift+37", //shift + LeftArrow
            shiftHomeButton: "shift+36",//shift + HomeButton
            shiftEndButton: "shift+35",//shift + EndButton
            selectedRowExpand: "alt+40", //"AltPlusDownArrow",
            totalRowExpand: "ctrl+40", //"CtrlPlusDownArrow",
            selectedRowCollapse: "alt+38", //"AltPlusUpArrow",
            totalRowCollapse: "ctrl+38", //"CtrlPlusUpArrow"
            deleteRecord: "46", // delete
            spaceBar: "32", // spacebar
            topRowSelection: "ctrl+36", //CtrlPlusHome
            bottomRowSelection: "ctrl+35",//CtrlPlusEnd
            nextPage: "33", //PageUp
            prevPage:"34", //PageDown            
        },
      
        defaults: {
            expandStateMapping:"",
            allowFiltering: false,            
            allowDragAndDrop: false,            
            dragTooltip: {                
                showTooltip: false,                
                tooltipItems:[],                
                tooltipTemplate: "",
            },  
            allowSorting: false,            
            allowColumnResize: false, 
            allowSelection: true,   
            allowPaging: false,
            dataSource: null,
            query: ej.Query(),            
            idMapping: "",            
            parentIdMapping: "",  
            readOnly: false,
            showGridCellTooltip: false,
            cellTooltipTemplate:null,
            showGridExpandCellTooltip: false,
            showColumnChooser: false,
            showColumnOptions: false,
            enableAltRow: true,			
            selectedItem: null,            
            toolbarSettings: {                
                showToolbar: false,                
                toolbarItems: [],
                customToolbarItems:[]
            },         
            editSettings: {       
                allowEditing: false,  
                allowAdding: true,
                allowDeleting: true,                
                editMode: "cellEditing",                
                rowPosition: "top",
                beginEditAction: "dblclick",
                dialogEditorTemplateID: ""
            },                   
            enableVirtualization: false,   
            allowMultiSorting: false,
            sortSettings: {                
                sortedColumns: []
            },
            filterSettings: {
                filterBarMode: "immediate",
                filteredColumns: [],
                filterType: "filterbar",
            },
            selectionType: "single",    
            selectionMode: "row",
            selectionSettings: {
                selectionType: "single",
                selectionMode: "row",
                enableHierarchySelection: true,
                enableSelectAll: true,
            },
            selectedCellIndexes: [],
            selectedRowIndex: -1,
            showSummaryRow: false,
            summaryRows: [],            
            showTotalSummary: false,    
            allowKeyboardNavigation: true,
            cssClass: "",           
            locale: "en-US",
            isEdit: false,
            allowScrolling: false,
            scrollSettings: {
                frozenColumns: 0
            },
            groupSettings: {
                groupedColumns:[]
            },            
            sizeSettings: {                
                height: "",                
                width: "",
            },            
            enableResize: true,            
            isResponsive: true,
            showDetailsRow: false,            
            showDetailsRowInfoColumn: false,            
            detailsTemplate: "",            
            detailsRowHeight: 100,    
            rowDataBound: null,                        
            load: null,
            create:null,
            queryCellInfo: null,            
            rowSelecting: null,           
            rowSelected: null,           
            cellSelecting: null,
            cellSelected: null,
            beginEdit: null,            
            endEdit: null,            
            expanding: null,            
            expanded: null,            
            collapsing: null,            
            collapsed: null,            
            actionComplete: null,            
            actionBegin: null,
            currentViewData: [],
            flatRecords: [],
            parentRecords: [],
            updatedRecords:[],
            summaryRowRecords: [],
            selectedItems: [],
            ids: [],      
            columns: [
            {
                field: "",
                headerText: "",
                editType: "",
                filterEditType: "",
                allowFiltering: false,
                allowFilteringBlankContent: true,
                allowSorting: false,
                visible: "",
                textAlign: ej.TextAlign.Left,
                headerTextAlign: ej.TextAlign.Left,
                allowCellSelection: true,
                clipMode: "",
                headerTooltip: "",
                tooltip:"",
                showInColumnChooser:true,
                //isFrozen: false,
                //allowFreezing: false
                //displayAsCheckbox
            },
            ],
            columnDialogFields: [],
            commonWidth: 150,
            dateFormat: "MM/dd/yyyy",   
            rowHeight: 30,
            emptyRecordText: "No Records To Display",            
            treeColumnIndex: 0,
            //API for toggle between datepicker and datetimepicker
            workingTimeScale: 'TimeScale8Hours',            
            childMapping: "",             
            enableCollapseAll:false,
            rowTemplateID: "",
            altRowTemplateID: "",
            parseRowTemplate: true,
            contextMenuSettings: {                
                showContextMenu: false,                
                contextMenuItems: []
            },            
            contextMenuOpen: null,            
            rowDragStart: null,            
            rowDrag: null,            
            rowDragStop: null,       
            detailsDataBound: null,            
            detailsShown: null,            
            detailsHidden: null,
            toolbarClick: null,
            columnResizeStart: null,
            columnResizeEnd: null,
            columnResized:null,
            recordClick:null,
            exportToPdfAction: "",
            exportToExcelAction: "",
            allowMultipleExporting: false,
            headerTextOverflow: "none",
            pageSettings: {
                pageSize: 12,
                pageCount: 8,
                currentPage: 1,
                totalPages: 0,
                totalRecordsCount: null,
                pageSizeMode: "all",
                template: null,                
            },
            allowColumnReordering: false,
            columnResizeSettings: {
                columnResizeMode: "normal"
            }
        },

        dataTypes: {
            columns: "array",            
            summaryRows: "array",
            sortSettings: {
                sortedColumns: "array"
            },
            filterSettings: {
                filteredColumns: "array",
                filterType: "string",
            },
            dataSource: "data",
            query: "data",
            currentViewData: "array",
            flatRecords: "array",
            parentRecords: "array",
            updatedRecords:"array",
            summaryRowRecords: "array",
            ids: "array",
            contextMenuSettings: {
                contextMenuItems: "array"
            },
            toolbarSettings: {
                toolbarItems: "array",
                customToolbarItems: "array"
            },
            selectedItem: "data",            
        },
        ignoreOnExport: [
            "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "enableRTL", "rowDataBound", "rowTemplate","parseRowTemplate",
             "detailsTemplate", "editSettings", "localization", "cssClass", "dataSource", "allowKeyboardNavigation","pageSettings","columnResizeSettings"
        ],
        observables: ["selectedRowIndex", "dataSource", "selectedCellIndexes","pageSettings.currentPage"],
        selectedItem: ej.util.valueFunction("selectedItem"),
        selectedRowIndex: ej.util.valueFunction("selectedRowIndex"),
        selectedCellIndexes: ej.util.valueFunction("selectedCellIndexes"),
        dataSource: ej.util.valueFunction("dataSource"),
        _currentPage: ej.util.valueFunction("pageSettings.currentPage"),

        //GET THE LOCALIZATION OBJECT
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },

        //GET THE GRID HEADER TABLE FOR COLUMNRESIZE
        getHeaderTable: function () {
            return this._$gridHeaderTable;
        },

        //SET THE GRID HEADER TABLE
        setGridHeaderTable: function (value) {
            this._$gridHeaderTable = value;
        },

        //GET THE GRIDHEADERCONTENT
        getHeaderContent: function () {
            return this._$gridHeaderContent;
        },

        //SET THE GRIDHEADERCONTENT
        setGridHeaderContent: function (value) {
            this._$gridHeaderContent = value;
        },

        //GET THE GRID CONTENT TABLE
        getContentTable: function () {
            return this._$gridContentTable;
        },

        getContent: function () {
            return this._$gridContent;
        },
        
        //SET THE GRID CONTENT TABLE
        setGridContentTable: function (value) {
            this._$gridContentTable = value;
        },

        //GET TREEGRID ROWS
        getRows: function () {
            var $gridRows = this._excludeDetailRows();
            return $gridRows;
        },

        //GET SELECTED CELLS
        getSelectedCells: function () {
            var proxy = this, model = proxy.model;
            var selectedCellElement = [];
            this._selectedCellDetails.forEach(function (item) {
                //Replace the current view cell Element after scrolling.
                var record = item.data,
                    currentRowIndex = model.currentViewData.indexOf(record);
                if (currentRowIndex != -1) {
                    item.cellElement = proxy.getRows()[currentRowIndex].childNodes[item.cellIndex];
                }
                selectedCellElement.push(item.cellElement);
            });
            return selectedCellElement;
        },

        //SET TREEGRID ROWS
        setGridRows: function (value) {
            this._$gridRows = value;
        },

        //GET CURRENTVIEWPORT DATA
        getCurrentViewData: function () {
            return this.model.currentViewData;
        },

        //GET UPDATED CURRENT VIEW DATA
        getUpdatedCurrentViewData: function () {
            this._updateCurrentViewData();
            return this.model.currentViewData;
        },

        //GET FLAT RECORDS
        getFlatRecords: function () {
            return this.model.flatRecords;
        },

        //SET THE HEIGHT BASED ON THE RECORD COUNT
        setHeight: function (value) {
            this._totalHeight = value;
        },

        //GET THE UPDATEDRECORDS[SORTED,FILTERED,EXPANDCOLLAPSED]
        getUpdatedRecords: function () {
            var model = this.model,updatedRecords = [];
            if (!this._isFromGantt && model.allowPaging)
                updatedRecords = this._updatedPageData;
            else
                updatedRecords = model.updatedRecords;           
            return updatedRecords;
        },

        //GET THE SUMMARY ROW RECORDS
        getsummaryRowRecords: function () {
            return this.model.summaryRowRecords;
        },
        //GET THE UPDATED DATASOURCE
        getDataSource: function () {
            return this.dataSource();
        },

        //get the ids collection after perform the addition/delete operation
        //GET THE IDS COLLECTION AFTER PERFORM THE ADDITION/DELETE OPERATION
        getUpdatedIds: function () {
            return this.model.ids;
        },

        //GET THE RECORDS COUNT
        getRecordsCount: function () {
            return this._recordsCount;
        },

        //SET THE RECORDS COUNT
        setRecordsCount: function (value) {
            this._recordsCount = value;
        },
        // SET FOCUS ON ELEMENT
        setFocusOnTreeGridElement: function(){
            this._focusTreeGridElement();
        },

        //update the collapseRecount by updatedRecord collection
        updateCollapsedRecordCount:function()
        {
            var proxy = this,
                model = this.model,
                resultRecord = [];
            resultRecord = model.updatedRecords.filter(function (record) {
                return proxy.getExpandStatus(record) == false;
            });
            proxy._totalCollapsedRecordCount = resultRecord.length;
        },

        //In virtualization get expaned records from total record collection only
        _getDetailsExpandedRecords: function (records) {            
            var resultRecord = records.filter(function (record) {
                return record.isDetailsExpanded == true;
            });
            return resultRecord;
        },

        /* Get expanded details row height */
        _getExpandedDetailsRowHeight:function()
        {
            var proxy = this,                
                expandedRecords, 
                detailExpandedRecords,
                updatedRecords = proxy.getUpdatedRecords();

            expandedRecords = this.getExpandedRecords(updatedRecords);
            detailExpandedRecords = this._getDetailsExpandedRecords(expandedRecords);
            detailExpandedRecords = proxy._spliceSummaryRows(detailExpandedRecords);
            return (proxy._detailsRowHeight * detailExpandedRecords.length);
        },
        //return collapsed recount length in updatedRecord collectio
        getCollapsedRecordCount: function (records) {
            return this._totalCollapsedRecordCount;
        },
        
        _colgroupRefresh: function () {
            var gridheaderCol, gridcontentCol;
            
            if (this._frozenColumnsLength > 0) {
                gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                gridcontentCol = $(this.getContentTable()).find('colgroup');
            }
            else {
                gridheaderCol = $(this.getHeaderTable()).find('colgroup')[0];
                gridcontentCol = $(this.getContentTable()).find('colgroup')[0];
            }
            var headerColClone = $(gridheaderCol).clone();
            var contentColClone = $(gridcontentCol).clone();
            var footerColClone = $(gridcontentCol).clone();
            $(gridcontentCol).remove();
            $(gridheaderCol).remove();
            if (this._frozenColumnsLength > 0) {
                $(headerColClone[0]).prependTo(this.getHeaderTable()[0]);
                $(headerColClone[1]).prependTo(this.getHeaderTable()[1]);
                $(contentColClone[0]).prependTo(this.getContentTable()[0]);
                $(contentColClone[1]).prependTo(this.getContentTable()[1]);
                if (this._$footertableContent) {
                    $(this._$footertableContent).find('colgroup').remove();
                    $(footerColClone[0]).prependTo(this._$footertableContent[0]);
                    $(footerColClone[1]).prependTo(this._$footertableContent[1]);
                }
                if (this._$totalSummaryRowContainer) {
                    if (this.getBrowserDetails().browser == "safari")
                        this._$totalSummaryRowContainer.find("#e-movablefooter" + this._id).css("margin-left", "auto");
                }
                if (this.getBrowserDetails().browser == "safari")
                    this.getHeaderContent().find("#e-movableheader" + this._id).add(this.getContent().find("#e-movablecontainer" + this._id)).css("margin-left", "auto");
                $("#e-frozencontentdiv" + this._id).length && $("#e-frozencontentdiv" + this._id).css("width", "100%");
            }
            else {
                $(headerColClone).prependTo(this.getHeaderTable());
                $(contentColClone).prependTo(this.getContentTable());
                if (this._$footertableContent) {
                    $(this._$footertableContent).find('colgroup').remove();
                    $(footerColClone).prependTo(this._$footertableContent);
                }
            }
        },
        _detailColsRefresh: function () {
            this._$headerCols = this.getHeaderTable().children("colgroup").find("col");
            this._$contentCols = this.getContentTable().children("colgroup").find("col");
            if (this.model.detailsTemplate && this.model.showDetailsRow && this.model.showDetailsRowInfoColumn || this.model.isFromGantt) {
                var colCount = this.model.columns.length;
                if (this._$headerCols.length > colCount) this._$headerCols.splice(colCount, 1);
                if (this._$contentCols.length > colCount) this._$contentCols.splice(colCount, 1);
            }
        },

        _swipeAction: function (e) {
            var proxy = this,curPage = this._currentPage(), doPage = true;
            var hScroll = (this.getScrollObject() || {})._scrollXdata;
            if (hScroll)
                doPage = e.type == "swipeleft" ? hScroll.scrollable - hScroll.sTop == 0 : hScroll.sTop == 0;

            switch (e.type) {
                case "swipeleft":
                    if (this.model.allowPaging && curPage != this.model.pageSettings.totalPages && !this.model.isEdit) {
                        if (doPage || !proxy.getScrollElement().ejScroller("isHScroll")) {
                            this.element.ejTreeGrid("gotoPage", curPage + 1);
                        }
                    }
                    break;
                case "swiperight":
                    if (this.model.allowPaging && curPage > 1 && !this.model.isEdit) {
                        if (doPage || !proxy.getScrollElement().ejScroller("isHScroll")) {
                            this.element.ejTreeGrid("gotoPage", curPage - 1);
                        }
                    }
                    break;
            }
        },

        // Move to the given page number
        gotoPage: function (pageIndex) {
            if (!this.model.allowPaging)
                return;
            var proxy = this, model = proxy.model,
                args = {}, returnValue;
            if (ej.isNullOrUndefined(pageIndex))
                pageIndex = proxy._currentPage();
            else {
                if (pageIndex <= 0)
                    pageIndex = 1;
                else if (pageIndex > model.pageSettings.totalPages)
                    pageIndex = model.pageSettings.totalPages;
            }
            pageIndex = ej.isNullOrUndefined(pageIndex) ? proxy._currentPage() : pageIndex;
            args.previousPage = this._prevPageNo;
            this._currentPage(pageIndex);           
            args.currentPage = pageIndex;
            if (model.allowPaging) {                
                args.requestType = ej.TreeGrid.Actions.Paging;
            }
            proxy._setScrollTop();
            proxy._updateCurrentViewData();            
            proxy.renderRecords(args);
            proxy.updateHeight();            
            proxy.getScrollElement().ejScroller("refresh");
            proxy._updateScrollCss();
            if (returnValue)
                this._currentPage(args.previousPage);
            if (args.previousPage != args.currentPage) {                
                proxy.clearSelection(-1);
                proxy.selectedRowIndex(-1);
                proxy.model.selectedItem = null;
                proxy._cancelSaveTools();
                proxy._clearContextMenu();
                if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                    proxy._clearMultiSelectPopup();
                }
                this._prevPageNo = args.currentPage;
            }
        },
        _pagerClickHandler: function (sender) {
            var proxy = this;
            if (this._prevPageNo == sender.currentPage)
                return;
            proxy._isNextPage = true;
            if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            else if (proxy.model.isEdit)
                proxy.cancelEditCell();
            this.gotoPage(sender.currentPage);
            return false;
        },
        /*CONSTRUCTOR FUNCTION*/
        _init: function () {

            var proxy = this;

            /* default value for asp designer */
            if (proxy.model.isdesignMode) {
                proxy.model.columns = [
                    { "field": "Column1", "HeaderText": "Column1" },
                    { "field": "Column2", "HeaderText": "Column2" },
                    { "field": "Column3", "HeaderText": "Column3" },
                    { "field": "Column4", "HeaderText": "Column4" }];
                proxy.model.childMapping = "Children";
                var tempDataSource = [{ Column1: "Value 1", Column2: "Value 2", Column3: "Value 3", Column4: "Value 4", Children: [] }];

                for (var count = 1; count < 4; count++) {
                    var data = { Column1: "Value 1", Column2: "Value 2", Column3: "Value 3", Column4: "Value 4" };
                    tempDataSource[0].Children.push(data);
                }
                this.dataSource(tempDataSource);
                this.model.sizeSettings.height = "250px";
                this.model.sizeSettings.width = "600px";
            }
            proxy._trigger("load");
            proxy._validateColumnFields();
            proxy._initPrivateProperties();
            proxy._setCultureInfo();
            proxy._initDatasource();
            proxy._processEditing();
            if (proxy.model.showColumnChooser && proxy.model.showColumnOptions) {
                proxy.columnAddDialogTemplate();
                proxy._renderUpdateConfirmDialog();
            }
            proxy._createDragTooltipTemplate();
            proxy._createTooltipTemplate();
        },

        // Method to render the outer div element for Add/edit dialog into the DOM
        _renderEditDialog: function () {
            var $dialog = ej.buildTag("div.e-editdialog-padding", "", { display: "none" }, { id: this._id + "_dialogEdit" });
            return $dialog;
        },

        // Method to validate the column fields
        _validateColumnFields: function ()
        {
            var proxy = this, column = proxy.model.columns;
            if (!ej.isNullOrUndefined(column)) {
                for (var index = 0; index < column.length; index++) {
                    if (ej.isNullOrUndefined(column[index].field)) {
                        column[index].field = "";
                        column[index].allowEditing = false;
                        column[index].allowSorting = false;
                        column[index].allowFiltering = false;
                    }
                    if (ej.isNullOrUndefined(column[index].editType)) {
                        column[index].editType = "stringedit";
                    }
                }
            }

        },

        // Method to create a template for add/edit dialog.
        _treeGridAddEditDialog: function () {
            if (this.model.columns.length == 0)
                return;
            var $formbody = ej.buildTag('div');
            var $form = ej.buildTag('form.treegridform', "", {}, { id: this._id + "EditFormDialog" });
            var $table = ej.buildTag('table', "", { "margin": "0 auto" }, {});
            var $innerTr, $labelTd, $valueTd, trElement, tdElement;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if ((this.model.columns[columnCount].visible || ej.isNullOrUndefined(this.model.columns[columnCount].visible)) && this.model.columns[columnCount].field != "checkboxState") {
                    trElement = 'tr';
                    tdElement = 'td';
                    $innerTr = ej.buildTag(trElement);
                    $labelTd = ej.buildTag(tdElement + ".e-editdialoglabel", "", { "text-align": "right" });
                    $valueTd = ej.buildTag(tdElement + ".e-editdialogrowcell", "", { "text-align": "left" });
                    $innerTr.append($labelTd.get(0)).append($valueTd.get(0));
                    if (this.model.columns[columnCount].headerText == undefined)
                        this.model.columns[columnCount].headerText = this.model.columns[columnCount].field;
                    $labelTd.append("<label for='" + this.model.columns[columnCount].field + "'>" + this.model.columns[columnCount].headerText + "</label>");
                    if (this.model.columns[columnCount]["allowEditing"] != false && this.model.columns[columnCount]["field"])
                        ej.TreeGrid._initCellEditType(this, $valueTd, this._id, columnCount);
                    this.model.columns[columnCount]["allowEditing"] == false && $valueTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                    if (this.model.columns[columnCount]["visible"] === false)
                        $innerTr.addClass("e-hide");
                    $table.append($innerTr);
                }
            }
            $form.append($table);
            $form.appendTo($formbody);
            $formbody = this._renderDiaglogButton($form, $formbody, $table);
            $.templates(this._id + "_JSONDialogEditingTemplate", $formbody.html());
        },

        //  Method to create a template for add/edit template dialog.
        _treeGridAddEditDialogTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $tbody = ej.buildTag('div', "", { 'display': 'none' });
            var $form = ej.buildTag('form.treegridform', "", {}, { id: this._id + "EditFormDialog" });
            var cloneElement = this.model.editSettings.dialogEditorTemplateID;
            $form.html($(cloneElement).html());
            $tbody = this._renderDiaglogButton($form, $tbody);
            $.templates(this._id + "_JSONdialogTemplateMode", $tbody.html());
        },

        // To render the save/cancel buttons for treegrid add/edit dialog and add/edit template dialog
        _renderDiaglogButton: function (form, $formbody, $table) {
            var btnId, contextMenuLabel = this._contextMenuTexts, savebtn, cancelbtn;
            btnId = "EditFormDialog_";
            if (ej.isNullOrUndefined($table)) {
                savebtn = ej.buildTag('input.e-save e-button e-btnsub e-flat', "", { 'margin-left': '33%' }, { type: "button", id: btnId + this._id + "_Save" });
                savebtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["saveText"], width: "30%" });
                cancelbtn = ej.buildTag('input.e-cancel e-button e-btncan e-flat', "", { 'margin-left': '7%' }, { type: "button", id: btnId + this._id + "_Cancel" });
                cancelbtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["cancelText"], width: "30%" });
            } else {
                savebtn = ej.buildTag('input.e-save e-button e-btnsub e-flat', "", { 'margin-left': '0px' }, { type: "button", id: btnId + this._id + "_Save" });
                savebtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["saveText"], width: "45%" });
                cancelbtn = ej.buildTag('input.e-cancel e-button e-btncan e-flat', "", { 'margin-left': '10%' }, { type: "button", id: btnId + this._id + "_Cancel" });
                cancelbtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["cancelText"], width: "45%" });
            }
            var btnDiv = ej.buildTag('div', "", {}, { 'class': "e-editform-btn e-editdialogbutton" }),
                $innerTr, $innerTd1, $innerTd2;
            if (!ej.isNullOrUndefined($table)) {
                $innerTr = ej.buildTag('tr');
                $innerTd1 = ej.buildTag('td.e-editdialoglabel');
                $innerTd2 = ej.buildTag('td.e-editdialogrowcell');
            }
            btnDiv.append(savebtn);
            btnDiv.append(cancelbtn);
            if (!ej.isNullOrUndefined($table)) {
                $innerTd2.append(btnDiv);
                $innerTr.append($innerTd1);
                $innerTr.append($innerTd2);
                $table.append($innerTr);
            }
            form.appendTo($formbody);
            if (!ej.isNullOrUndefined($table))
                form.append($table);
            else
                form.append(btnDiv);
            return $formbody;
        },

        /* update allow keyboard navigation value*/
        updateAllowKeyboardNavigation: function (bool)
        {
            this.model.allowKeyboardNavigation = bool;
        },
        /* Refresh footer summary records if total summary exist */
        _refreshFooterSummaryRecords: function () {
            var proxy = this,
                model = this.model;
            if (model.showTotalSummary && proxy._$footerContainer.length > 0) {
                if (this._frozenColumnsLength > 0) {
                    proxy._$footerContainer.html(this._renderSummaryByFrozenDesign());
                    this._renderFrozenSummary();
                } else {
                    var $table = ej.buildTag('table.e-table#' + proxy._id + "summarye-table", "",
                    { top: "0px" }, { 'cellspacing': '0px' }),
                      $tbody = ej.buildTag('tbody');
                    $table.append(proxy.getContentTable().find('colgroup').clone()).append($tbody);
                    $tbody.html($.render[this._id + "_Template"](proxy._footerSummaryRecord));
                    proxy._$footerContainer.empty().append($table);
                }
                proxy._$footertableContent = proxy._$footerContainer.find(".e-table");
            }
        },
        /* update scrollLeft of header container with content scrollLeft*/
        _updateHeaderScrollLeft: function (scrollLeft) {
            var proxy = this;
            if (ej.isNullOrUndefined(scrollLeft))
                scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft");
            if (this._frozenColumnsLength > 0) {
                proxy._$gridHeaderContainer.find("#e-movableheader" + this._id).scrollLeft(scrollLeft);
                if (proxy.model.showTotalSummary && proxy._$footerContainer)
                    proxy._$footerContainer.find("#e-movablefooter" + this._id).scrollLeft(scrollLeft);
            } else {
                proxy._$gridHeaderContainer.scrollLeft(scrollLeft);
                if (proxy.model.showTotalSummary && proxy._$footerContainer)
                    proxy._$footerContainer.scrollLeft(scrollLeft);
            }
        },
        //Update Columns Dynamically.
        updateColumns: function (columns) {
            var proxy = this,
               model = this.model;
            model.columns = columns;
            proxy._refreshFrozenColumns();
        },
        //Update the Gantt Columns from TreeGrid Columns.
        updateToGanttColumns: function () {
            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            ganttObject.updateGanttColumns(columns);            
        },

        //Update the add and edit dialog template.
        _updateAddEditDialogTemplate: function () {
            var proxy = this, ganttObject;
            ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            ganttObject.addDialogTemplate();
            ganttObject.editDialogTemplate();
        },
        /* Refresh columns collection with freeze and unfreeze*/
        _refreshFrozenColumns: function () {
            var proxy = this,
               model = this.model,
               layoutUpdated = false;
            proxy._initFrozenColumns();
            proxy._processEditing();
            //Rerendering the column header with new columns.;
            proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
            proxy._addInitTemplate();
            if (model.isFromGantt)
                proxy._$gridContent.removeClass("e-borderbox");
            /* Render frozen and movable table if any column is frozen*/
            if (this._frozenColumnsLength > 0 && proxy._$frozenTableContent.length == 0) {
                layoutUpdated = true;
                var contentWidth = proxy._$gridContent.css("width"),
                    contentHeight = proxy._$gridContent.css("height");
                proxy._$gridContent.ejScroller("destroy");
                proxy._$gridContent.css("width", contentWidth);
                proxy._$gridContent.css("height", contentHeight);
                proxy._$gridContainer.html(proxy._renderByFrozenDesign());
                proxy.setGridContentTable(proxy._$gridContainer.find(".e-table"));
                proxy._$gridContainer.find("#e-movablecontent" + proxy._id + ",#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", proxy._$gridContainer.css("height"));
                proxy._renderScroller(true);
            } else if (proxy._$frozenTableContent.length > 0 && this._frozenColumnsLength == 0) {
                layoutUpdated = true;
                proxy._$gridContent.find("#e-movablecontainer" + proxy._id).ejScroller("destroy");
                var $table = ej.buildTag('table.e-table#' + proxy._id + "e-table", "",
                     { top: "0px", "position": "relative" }, { 'cellspacing': '0px' }),
                     $tbody = ej.buildTag('tbody');
                $table.append(proxy.getHeaderTable().find('colgroup').clone()).append($tbody);
                proxy._$gridContainer.html($table);
                proxy.setGridContentTable($table);
                proxy._renderScroller(true);
            }
            /* Update table private  properties*/
            proxy._$frozenTableContent = $("#" + proxy._id + "frozene-table");
            proxy._$movableTableContent = $("#" + proxy._id + "movablee-table");
            proxy._$tableContent = $("#" + proxy._id + "e-table");

            if (model.showTotalSummary && proxy._$footerContainer.length > 0) {
                proxy._refreshFooterSummaryRecords();
            }

            if (layoutUpdated) {
                proxy.onScrollHelper(0);
            }
            var args = {};
            args.requestType = ej.TreeGrid.Actions.Refresh;
            /* for details rows detailsDataBound event can be called after the width update of column */
            proxy._isRendered = false;
            //Rerendering the content of the tree grid
            proxy.sendDataRenderingRequest(args);
            proxy.setWidthToColumns();
            proxy._isRendered = true;
            /* trigger queryCellInfo ,detailsDataBoundEvent after update the width of the columns */
            proxy._trigger("refresh");
            this._eventBindings();
            this._hideCollapsedDetailsRows();
            /* Update the scrollbar*/           
            proxy.getScrollElement().ejScroller("refresh");
            proxy._updateScrollCss();                
            if (model.isFromGantt) {
                var gridContent = proxy.getScrollElement(),
                    isHorizontalScroll = gridContent.ejScroller("isHScroll");
                if (!isHorizontalScroll) {
                    proxy._$gridContent.addClass("e-borderbox");
                }
                else {
                    proxy._$gridContent.removeClass("e-borderbox");
                }
            }
            if (model.showColumnChooser)
                proxy._renderColumnChooserList(true);
            /* update header and footer scrollLeft value*/
            proxy._updateHeaderScrollLeft();            
            
            if (model.isFromGantt) {
                /*Add additional td on column header to maintain column width*/
                proxy._addEmptyColumntoGrid();
                /*Updating the column properties to Gantt's model.columns*/
                proxy.updateToGanttColumns();
            }           
        },
        /* Freeze all Columns before argumented column*/
        freezePrecedingColumns: function (field) {
            var proxy = this, model = this.model,
                columns = model.columns,
                currentColumn = this.getColumnByField(field),
                columnIndex = columns.indexOf(currentColumn);
            /* Clear edit state , context menu and details template*/
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
                      
            this._clearContextMenu();
            this._removeDetailsRow();
            this._clearColumnMenu();

            /* Check column is available or not*/
            if (ej.isNullOrUndefined(currentColumn) || columnIndex == -1)
                return false;
            /*Check all previous columns are in frozen*/
            if (columnIndex == 0 && columnIndex <= this._frozenColumnsLength)
                return false;
            /*Check frozen column width and container width */
            var frozenWidth = this._getFrozenColumnWidth(columnIndex);
            frozenWidth = frozenWidth + 18;
            if (frozenWidth > this._gridWidth)
                return false;
            /* update isFrozen API of columns and refresh the columns*/
            for (var count = 0; count < columnIndex; count++) {
                columns[count].isFrozen = true;
            }
            proxy._refreshFrozenColumns();
        },
        /* Public method for freeze or unfreeze the columns */
        freezeColumn: function (field, isFrozen) {
            var proxy = this, model = this.model,
                columns = model.columns,                
                currentColumn = this.getColumnByField(field);

            /* Clear edit state , context menu and details template*/
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }

            this._clearContextMenu();
            this._removeDetailsRow();
            this._clearColumnMenu();

            if (model.selectionSettings.selectionMode == "cell")
                proxy.clearSelection();

            /* Check column is available or not*/
            if (ej.isNullOrUndefined(currentColumn))
                return false;
            /*Check all other columns are in frozen*/
            if (proxy._frozenColumnsLength == model.columns.length - 1 && isFrozen)
                return false;
            /* Check column is in same state*/
            if (currentColumn.isFrozen == isFrozen)
                return false;
            /*Check frozen column width and container width */
            var frozenWidth = this._getFrozenColumnWidth(),
                columnIndex = columns.indexOf(currentColumn);
            frozenWidth = frozenWidth + (isFrozen ? (this.columnsWidthCollection[columnIndex] + 18) : (-this.columnsWidthCollection[columnIndex]));
            if (frozenWidth > this._gridWidth)
                return false;

            currentColumn.isFrozen = isFrozen;
            /* refresh columns collection in UI*/
            proxy._refreshFrozenColumns();
			proxy._off(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            if (this._frozenColumnsLength)
                proxy._on(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
        },

        //Public method use to change checkbox Column
        updateCheckboxColumn: function(fieldName){
            var proxy = this, model = proxy.model,
                columns = model.columns,
                column = proxy.getColumnByField(fieldName);
            if (!proxy._checkboxSelection)
                return;
            $.each (columns, function (index, value) {
                value["showCheckbox"] = false;
            });
            if (!ej.isNullOrUndefined(column)) {                
                var index = columns.indexOf(column);
                if(index > -1)
                    columns[index]["showCheckbox"] = true;
            }            
            var selectionSettings = {}, args = {};
            selectionSettings.selectionType = ej.TreeGrid.SelectionType.Checkbox;
            args.selectionSettings = selectionSettings;
            proxy._refreshSelectionSettings(args, "selectionSettings");
        },

        //Refresh selectionSettings when update by setModel
        _refreshSelectionSettings: function (options, prop) {
            var proxy = this,
                model = proxy.model,
                isSelectionChanged = false;

            isSelectionChanged = !ej.isNullOrUndefined(options[prop].selectionType) || !ej.isNullOrUndefined(options[prop].selectionMode);

            if (prop == "selectionType") {
                model.selectionSettings.selectionType = options[prop];
                isSelectionChanged = true;
            }
            else if (prop == "selectionMode") {
                model.selectionSettings.selectionMode = options[prop];
                isSelectionChanged = true;
                if (model.showColumnChooser && model.showColumnOptions)
                    proxy.columnAddDialogTemplate();
            }
            else
                $.extend(model.selectionSettings, options[prop]);
                    

            var isCheckboxType = (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox &&
              model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row);

            // Unchecked all checked records
            if ((!ej.isNullOrUndefined(options[prop].enableHierarchySelection) && model.selectedItems.length > 0) ||
                    (!isCheckboxType && proxy._checkboxSelection)) {
                proxy._isFromSetmodel = true;
                proxy.selectAllRows(false);
                proxy._isFromSetmodel = false;
            }

            if (proxy._checkboxSelection || isCheckboxType) {
                proxy._checkboxSelection = isCheckboxType;

                proxy._processEditing();

                if ((!isCheckboxType && proxy._checkboxColumnName == "checkboxState") || 
                        (model.columns[0].nonColumn && proxy._checkboxColumnName != "checkboxState")) {
                    var treeGridIndexColumn = model.columns[model.treeColumnIndex];
                    if (model.columns[0]['isFrozen']) {
                        model.columns[0]['isFrozen'] = false;
                        proxy._frozenColumnsLength -= 1;
                        var index = proxy._frozenColumns.indexOf(model.columns[0]);
                        proxy._frozenColumns.splice(index, 1);
                        model.scrollSettings.frozenColumns = this._frozenColumnsLength;
                    }
                    model.columns.splice(0, 1);
                    if (treeGridIndexColumn)
                        model.treeColumnIndex = model.columns.indexOf(treeGridIndexColumn);
                }
                if (!proxy._checkboxSelection) proxy._checkboxColumnName = null;

                proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                proxy._setWidthToHeaders();
                if (model.allowFiltering)
                    proxy._resizeFilteringElements();
                if (isSelectionChanged) {
                    proxy._addInitTemplate();
                    this.renderRecords();
                }
                proxy.setWidthToColumns();
                proxy._updateScrollCss();
                proxy._updateHeaderScrollLeft();
                //Updating header checkbox state while render dynamically            
                if (model.selectedItems.length > 0)
                    proxy.selectAllRows();
            }
        },

        //#region RUNTIME UPDATE METHOD FOR TREEGRID
        //METHOD FOR UPDATE THE TREEGRID IN RUN TIME
        _setModel: function (options) {

            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords();

            for (var prop in options) {

                switch (prop) {

                    case "enableAltRow":
                        model.enableAltRow = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        break;
                    case "allowFiltering":
                        if (!model.allowFiltering && proxy._filteredColumnValueID.length > 0) {
                            proxy._clearAllFilter(proxy._filteredColumnValue);
                        }
                        model.allowFiltering = options[prop];
                        proxy._initiateSetModel();
                        model.allowFiltering = options[prop];
                        var scroller = proxy.getScrollElement().ejScroller("instance"),
                          left = scroller.scrollLeft(), totalSummaryHeight = 0,
                          top = scroller.scrollTop();
                        //Re render the grid header
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy._setWidthToHeaders();
                        if (model.showTotalSummary)
                            totalSummaryHeight = proxy.element.find('.e-footersummaryrowdiv').outerHeight();
                        $("#" + proxy._id).addClass('e-treegrid-overflow');
                        proxy._viewPortHeight = proxy.element.height() - (proxy._getNonContentHeight() + totalSummaryHeight);
                        $("#" + proxy._id).removeClass('e-treegrid-overflow');
                        if (proxy._frozenColumnsLength > 0) {
                            proxy._$gridContent.css("height", proxy._viewPortHeight);
                        }
                        scroller.option("height", proxy._viewPortHeight);
                        if (model.enableVirtualization) {
                            var length = model.currentViewData.length,
                                rowHeight = model.rowHeight, isTopChanged;
                            rowHeight += (model.showDetailsRow && !model.showDetailsRowInfoColumn) ? model.detailsRowHeight : 0;
                            if ((length * rowHeight) < proxy._viewPortHeight) {
                                if (length > 0) {
                                    top = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                                    if (top < 0)
                                        top = 0;
                                } else {
                                    proxy.processBindings();
                                    proxy.renderRecords();
                                }
                            }
                        }
                        //Update columnOptions fields
                        if (model.showColumnChooser && model.showColumnOptions)
                            proxy.columnAddDialogTemplate();
                        if (model.allowFiltering && model.filterSettings.filterType == "menu" && proxy._renderedFilterMenuDialog.length == 0)
                            proxy._renderFilterMenu();
                        //update the column width
                        this.setWidthToColumns();
                        scroller.scrollY(top, true);
                        scroller.scrollX(left, true);
                        proxy._updateHeaderScrollLeft(left);
                        proxy._updateScrollCss();
                        break;
                    case "enableResize":
                        proxy.model.enableResize = options[prop];
                        if (model.enableResize) {
                            proxy._on($(window), "resize", proxy._windowResize);
                        }
                        else {
                            proxy._off($(window), "resize", proxy._windowResize);
                        }
                        break;

                    case "isResponsive":
                        proxy.model.isResponsive = options[prop];
                        if (model.isResponsive) {
                            proxy._on($(window), "resize", proxy._windowResize);
                            $("#" + proxy._id + "_toolbarItems").addClass("e-treegridadaptivetoolbar");
                            proxy._mediaQueryUpdate();
                            proxy._off(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));
                            proxy._on(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));
                        }
                        else {
                            proxy._off($(window), "resize", proxy._windowResize);
                            proxy._off(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));
                            $("#" + proxy._id + "_toolbarItems").removeClass("e-treegridadaptivetoolbar");
                            proxy._mediaQueryUpdate();
                        }
                        break;

                    case "headerTextOverflow":
                        model.headerTextOverflow = options[prop];
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());                        
                        proxy.updateViewPortHeight();

                        if (model.enableVirtualization) {
                            proxy.cancelRowEditCell(); // To hide or destroy popup menu
                            proxy.processBindings();
                            var tempArgs = {},
                                rowHeight = model.rowHeight;
                            tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                            proxy.sendDataRenderingRequest(tempArgs);
                            /* check detail template and its row height */
                            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                                rowHeight += model.detailsRowHeight;
                            }

                            if ((model.currentViewData.length * rowHeight) < proxy._viewPortHeight) {

                                var currentPosition = top - (proxy._viewPortHeight - model.currentViewData.length * rowHeight);
                                if (currentPosition < 0)
                                    currentPosition = 0;
                                proxy._$gridContent.ejScroller("scrollY", currentPosition, true);
                            }
                        }
                        
                        proxy._$gridContent.ejScroller({ height: proxy._viewPortHeight });
                        proxy._updateScrollCss();
                        proxy.setWidthToColumns();
                                           
                        break;

                    case "enableVirtualization":
                        model.enableVirtualization = options[prop];
                        var previousRecord = proxy._prevSelectedItem,
                            selectedRecord = proxy.selectedRowIndex() && updatedRecords[proxy.selectedRowIndex()];
                        proxy.processBindings();
                        // change the table top position is 0 and change the update records for non-virtulization mode.
                        if (!model.enableVirtualization) {
                            if (this._frozenColumnsLength > 0) {
                                proxy._$frozenTableContent.css({
                                    "top": 0
                                });
                                proxy._$movableTableContent.css({
                                    "top": 0
                                });
                            } else {
                                proxy._$tableContent.css({
                                    "top": 0
                                });
                            }
                        }
                        selectedRecord && proxy.selectedRowIndex(updatedRecords.indexOf(selectedRecord));
                        var args = {};
                        args.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy.sendDataRenderingRequest(args);
                        proxy._isRowEdit = model.isEdit = false;
                        proxy._cancelSaveTools();
                        proxy._clearColumnMenu();
                        proxy._clearContextMenu();
                        this._removeDetailsRow();
                        break;

                    case "allowColumnResize":
                        model.allowColumnResize = options[prop];
                        if (model.allowColumnResize)
                            proxy._resizer = new ej.gridFeatures.gridResize(proxy);
                        proxy._enableColumnResizeEvents();
                        break;

                    case "allowSorting":
                        model.allowSorting = options[prop];
                        proxy.sortSetting(options[prop]);
                        if (model.showColumnChooser && model.showColumnOptions)
                            proxy.columnAddDialogTemplate();
                        break;
                    case "allowPaging":
                        if (model.allowPaging) {                            
                            proxy.element.append(proxy._renderGridPager());
                            proxy.element.append(proxy.element.find(".e-pager").first());
                            proxy.element.find(".e-pager").css({ "width": proxy._gridWidth - 2 });
                            var scroller = proxy.getScrollElement().ejScroller("instance"),
                                left = scroller.scrollLeft(),
                                top = scroller.scrollTop();                            
                            proxy._viewPortHeight = proxy._getViewPortHeight();                            
                            if (model.showTotalSummary)
                                proxy._viewPortHeight -= proxy._$totalSummaryRowContainer.outerHeight();
                            scroller.option("height", proxy._viewPortHeight);                            
                            scroller.scrollY(top, true);
                            scroller.scrollX(left, true);
                            proxy._pagerHeight = proxy.element.find(".e-pager").outerHeight();
                            proxy.gotoPage();                            
                        }
                        else {
                            var height = proxy.element.find(".e-pager").first().outerHeight();
                        proxy.element.find(".e-pager").first().remove();
                        proxy._viewPortHeight = proxy._viewPortHeight + height;
                        if (this._frozenColumnsLength > 0) {
                            proxy._$gridContent.css("height", proxy._viewPortHeight);
                        }

                        proxy.getScrollElement().ejScroller({
                            height: proxy._viewPortHeight,//for border-width of gridcontent
                        });                            
                        if(model.pageSettings.totalRecordsCount > 0)
                            proxy._refreshDataSource();
                        else
                            proxy.refreshContent();
                        proxy.renderRecords();
                        proxy._isRefreshAddedRecord = false;
                }                
                        break;
                   
                    case "dragTooltip":
                        var tooltipValue = options[prop].tooltipItems;
                        if (tooltipValue && !$.isArray(tooltipValue)) {
                            tooltipValue = tooltipValue.length > 0 ? tooltipValue.split(",") : [];
                            options[prop].tooltipItems = tooltipValue;
                        }
                        $.extend(model.dragTooltip, options[prop]);
                        proxy._createDragTooltipTemplate();
                        proxy.refreshContent();
                        break;

                    case "allowDragAndDrop":
                        model.allowDragAndDrop = options[prop];
                        var matched = jQuery.uaMatch(navigator.userAgent);                                                
                        proxy.refreshContent();
                        break;

                    case "sortSettings":
                        $.extend(model.sortSettings, options[prop]);
                        proxy.refreshContent();
                        var refreshArgs = {};
                        refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy.sendDataRenderingRequest(refreshArgs);                       
                        break;

                    case "allowSelection":                      
                        model.allowSelection = options[prop];
                        if (!model.allowSelection) {
                            if (proxy._checkboxSelection && model.selectedItems.length > 0) {
                                proxy._isFromSetmodel = true;
                                proxy.selectAllRows(false);
                                proxy._isFromSetmodel = false;
                            }
                            proxy.clearSelection(-1);
                            proxy.selectedRowIndex(-1);
                            proxy.model.selectedItem = null;
                            proxy._cancelSaveTools();
                        }
                        break;

                    case "selectionType":
                    case "selectionMode":
                    case "selectionSettings":
                        this._initiateSetModel();
                        proxy.clearAllSelection();
                        proxy._refreshSelectionSettings(options, prop);
                        if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && $("#" + proxy._id + "_selectionpopup").length == 0 && !proxy.model.isFromGantt) {
                            proxy._renderMultiSelectionIndicator();
                        }
                        break;
                    case "showSummaryRow":
                        model.showSummaryRow = options[prop];
                        if (model.showSummaryRow) {
                            proxy._createSummaryRow();
                            var refreshArgs = {};
                            refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                            proxy.sendDataRenderingRequest(refreshArgs);
                        }
                        else {
                            $(proxy.element).find(".e-summaryrow").hide();
                            model.updatedRecords = proxy._spliceSummaryRows(model.updatedRecords);
                            if (model.allowPaging) { 
                                proxy._updateCurrentViewData();
                                var refreshArgs = {};
                                refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                                proxy.sendDataRenderingRequest(refreshArgs);
                            }
                        }                       
                        proxy.updateCollapsedRecordCount();
                        proxy.updateHeight();
                        break;
                    case "showTotalSummary":
                        model.showTotalSummary = options[prop];
                        if (model.showTotalSummary) {
                            proxy._createTotalSummaryRow();
                            proxy._setWidthToFooters();
                            proxy._viewPortHeight = proxy._getViewPortHeight();
                            proxy._viewPortHeight -= $(proxy._$totalSummaryRowContainer).height();
                        }
                        else {
                            $(proxy.element).find(".e-footersummaryrowdiv").remove();
                            proxy._viewPortHeight = proxy._getViewPortHeight();
                        }

                        var scroller = proxy.getScrollElement().ejScroller("instance"),
                            left = scroller.scrollLeft(),
                            top = scroller.scrollTop();
                        if (proxy._frozenColumnsLength > 0) {
                            proxy._$gridContent.css("height", proxy._viewPortHeight);
                        }
                        scroller.option("height", proxy._viewPortHeight);
                        if (model.enableVirtualization) {
                            var length = model.currentViewData.length,
                                rowHeight = model.rowHeight;
                            rowHeight += (model.showDetailsRow && !model.showDetailsRowInfoColumn) ? model.detailsRowHeight : 0;
                            if ((length * rowHeight) < proxy._viewPortHeight) {
                                if (length > 0) {
                                    top = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                                    if (top < 0)
                                        top = 0;
                                } else {
                                    proxy.processBindings();
                                    proxy.renderRecords();
                                }
                            }
                        }
                        scroller.scrollY(top, true);
                        scroller.scrollX(left, true);
                        proxy._updateHeaderScrollLeft(left);
                        proxy._updateScrollCss();
                        break;
                    case "selectedRowIndex":
                        if (!this.isEdit && !this._isRowEdit) {
                            if (this.selectedRowIndex() >= 0
                                && !ej.isNullOrUndefined(this.selectedRowIndex()) && model.allowSelection && updatedRecords.length > this.selectedRowIndex()
                                && this.getExpandStatus(updatedRecords[this.selectedRowIndex()])) {
                                var index = this.selectedRowIndex();
                                if (!proxy._rowSelectingEventTrigger(this._previousIndex, index)) {
                                    if (model.showSummaryRow) {
                                        var recordsWithOutSummary = proxy._spliceSummaryRows(model.updatedRecords),
                                            currentSelectedRecord = recordsWithOutSummary[index];
                                        index = updatedRecords.indexOf(currentSelectedRecord);
                                    }
                                    proxy.selectRows(index);
                                    proxy._rowSelectedEventTrigger(index);
                                }
                            } else {
                                proxy.clearSelection(-1);
                                proxy.selectedRowIndex(-1);
                                proxy.model.selectedItem = null;
                                proxy._previousIndex = -1;
                            }
                            proxy._cancelSaveTools();
                        } else {
                            this.selectedRowIndex(updatedRecords.indexOf(proxy._prevSelectedItem));
                        }
                        break;
                    case "selectedCellIndexes":
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell") {                            
                            proxy.selectCells(options[prop]);                            
                        }
                        break;
                    case "editSettings":
                        $.extend(model.editSettings, options[prop]);
                        proxy._processEditing();
                        proxy._enableEditingEvents();
                        proxy._updateToolbarItems();
                        break;

                    case "allowKeyboardNavigation":
                        model.allowKeyboardNavigation = options[prop];
                        break;

                    case "dataSource":
                        if (!proxy._isRowEdit && !proxy.model.isEdit) {
                            proxy._refreshDataSource();
                        }
                        break;

                    case "columns":
                        model.columns = options[prop].slice(0);
                        proxy._validateColumnFields();
                        proxy._refreshFrozenColumns();
                        break;
                    
                    case "rowHeight":
                        model.rowHeight = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        proxy.updateHeight();
                        break;

                    case "treeColumnIndex":
                        proxy.columnIndex(options[prop]);
                        break;

                    case "showColumnChooser":
                        model.showColumnChooser = options[prop];
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy.setWidthToColumns();
                        proxy.getScrollElement().ejScroller("refresh");
                        proxy._updateScrollCss();
                        if (!model.showColumnChooser){
                            proxy._clearColumnMenu();
                            $("#" + proxy._id + "ccDiv_wrapper").remove();
                            $("#" + proxy._id + "filterMenu_wrapper").remove();
                        }
                        else {
                            proxy._renderColumnChooser();
                            if(model.allowFiltering && model.filterSettings.filterType == "menu" && proxy._renderedFilterMenuDialog.length == 0)
                            proxy._renderFilterMenu();
                        }
                        /*Add empty column in gantt*/
                        if (model.isFromGantt) {
                            proxy._addEmptyColumntoGrid();
                            this._updateHeaderScrollLeft(this.getScrollElement().ejScroller("model.scrollLeft"));
                        }
                        break;
                    case "showColumnOptions":
                        model.showColumnOptions = options[prop];
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy.setWidthToColumns();
                        proxy.getScrollElement().ejScroller("refresh");
                        proxy._updateScrollCss();
                        if (model.showColumnChooser && model.showColumnOptions) {
                            proxy.columnAddDialogTemplate();
                            proxy._renderUpdateConfirmDialog();
                        }
                        else {
                            proxy._clearColumnMenu();
                            $("#" + proxy._id + "ccDiv_wrapper").remove();
                            $("#" + proxy._id + "filterMenu_wrapper").remove();
                        }
                        /*Add empty column in gantt*/
                        if (model.isFromGantt) {
                            proxy._addEmptyColumntoGrid();
                        }
                        break;
                    case "locale":
                        proxy._clearContextMenu();
                        proxy._clearColumnMenu();
                        proxy._removeDetailsRow();
                        model.locale = options[prop];
                        proxy._setCultureInfo();
                        proxy._processEditing();
                        proxy._addInitTemplate();
                        proxy.refreshContent();
                        //Re render the grid header(for updating filtering elements also) and content
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy.renderRecords(args);
                        proxy.setWidthToColumns();
                        // Update the scrollbar
                        proxy.getScrollElement().ejScroller("refresh");
                        proxy._updateScrollCss();
                        // Update the column chooser
                        if (model.showColumnChooser)
                            proxy._renderColumnChooserList(true);
                        // Update the toolbar
                        if (model.toolbarSettings.showToolbar)
                            proxy._updateToolbar();
                        if (model.allowPaging)
                            proxy.getPager().ejPager("option", options[prop]).ejPager("refreshPager");
                        if (proxy.model.showColumnChooser && proxy.model.showColumnOptions) {
                            proxy.columnAddDialogTemplate();
                            proxy._renderUpdateConfirmDialog();
                        }
                        if (model.allowFiltering && model.filterSettings.filterType == "menu")
                            proxy._renderFilterMenu();
                        break;
                    case "toolbarSettings": 
                        $.extend(proxy.model.toolbarSettings, options[prop]);
                        proxy._updateToolbar();
                        break;
                    case "contextMenuSettings":
                        $.extend(proxy.model.contextMenuSettings, options[prop]);
                        if (!model.contextMenuSettings.showContextMenu)
                            proxy._clearContextMenu();
                        this._removeDetailsRow();
                        break;
                    case "enableCollapseAll":
                        model.enableCollapseAll = options[prop];
                        if (model.enableCollapseAll)
                            proxy.collapseAll();
                        else
                            proxy.expandAll();
                        break;
                    case "showDetailsRow":
                        model.showDetailsRow = options[prop];
                        this._updateDetailsRowProperties("showDetailsRow");
                        break;
                    case "detailsRowHeight":
                        model.detailsRowHeight = options[prop];
                        this._updateDetailsRowProperties("detailsRowHeight");
                        break;
                    case "detailsTemplate":
                        model.detailsTemplate = options[prop];
                        this._updateDetailsRowProperties("detailsTemplate");
                        break;
                    case "showDetailsRowInfoColumn":
                        model.showDetailsRowInfoColumn = options[prop];
                        this._updateDetailsRowProperties("showDetailsRowInfoColumn");
                        break;
                    case "altRowTemplateID":
                        this._initiateSetModel();
                        model.altRowTemplateID = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        this.updateHeight();
                        break;
                    case "rowTemplateID":
                        this._initiateSetModel();
                        model.rowTemplateID = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        this.updateHeight();
                        break;
                    case "pageSettings":
                        this._initiateSetModel();
                        if (model.allowPaging) {
                            $.extend(model.pageSettings, options[prop]);
                            this.getPager().ejPager("option", model.pageSettings).ejPager("refreshPager");
                            if (options[prop].totalRecordsCount > 0) {
                                proxy._refreshDataSource();
                            }
                            else
                                proxy.gotoPage();
                        }
                        break;
                    case "sizeSettings":
                        this._initiateSetModel();
                        $.extend(model.sizeSettings, options[prop]);

                        this._calculateDimensions();
                        if (this._getViewPortHeight() <= 0) {
                            model.sizeSettings.height = "450px";
                            this._updateElementHeight();
                        }
                        this._windowResize();
                        break;
                    case "readOnly":
                        model.readOnly = options[prop];
                        break;
                    case "showGridCellTooltip":
                        model.showGridCellTooltip = options[prop];
                        break;

                    case "showGridExpandCellTooltip":
                        model.showGridExpandCellTooltip = options[prop];
                        break;

                    case "allowMultiSorting":
                        model.allowMultiSorting = options[prop];
                        break;

                    case "query":
                        if (!ej.isNullOrUndefined(options[prop]))
                            model.query = options[prop];
                        else
                            model.query = ej.Query();
                        proxy._refreshDataSource();
                        break;
                    case "filterSettings":
                        if (model.allowFiltering) {
                            if (!options.filterSettings.filterType && model.filterSettings.filterType == "filterbar") {
                            var filterSettings,
                                filterBarMode, args = {};
                            $.extend(proxy.model.filterSettings, options[prop]);
                            filterSettings = proxy.model.filterSettings;
                            filterBarMode = ej.isNullOrUndefined(filterSettings.filterBarMode) ? "immediate" : filterSettings.filterBarMode;
                            // Get the filteredColumn value before going to clear the filter columns
                            var newFilterColumn = $.extend([], filterSettings.filteredColumns);

                            for (var column = 0; column < model.columns.length; column++) {
                                if (model.columns[column].allowFiltering)
                                proxy._clearFilterElementValue(model.columns[column]);
                            }

                            filterSettings.filteredColumns = newFilterColumn;
                            filterSettings.filterBarMode = filterBarMode;
                            args.requestType = "filtering";

                            for (var i = 0; i < newFilterColumn.length; i++)
                                $("#" + proxy._id + "_" + newFilterColumn[i].field.split('.').join("") + "_filterbarcell").val(newFilterColumn[i].value);
                            //Render the record with sorting and filtering
                            proxy._ensureDataSource(args);
                            proxy._off(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                            proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
                            //Method binding for filtering data.
                            if (filterBarMode == "immediate") {
                                proxy._on(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._on(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
                            }
                            } else if (options.filterSettings.filterType) {
                            model.allowFiltering = true;
                            $.extend(proxy.model.filterSettings, options[prop]);
                            proxy._initiateSetModel();
                            var scroller = proxy.getScrollElement().ejScroller("instance"),
                              left = scroller.scrollLeft(),
                              top = scroller.scrollTop();
                            //Re render the grid header
                            proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                            proxy._setWidthToHeaders();
                            $("#" + proxy._id).addClass('e-treegrid-overflow');
                            proxy._viewPortHeight = proxy._getViewPortHeight();
                            $("#" + proxy._id).removeClass('e-treegrid-overflow');
                            if (model.filterSettings.filterType == "menu" && proxy._renderedFilterMenuDialog.length == 0)
                            proxy._renderFilterMenu();
                            if (proxy._frozenColumnsLength > 0) {
                                proxy._$gridContent.css("height", proxy._viewPortHeight);
                            }
                            scroller.option("height", proxy._viewPortHeight);
                            if (model.enableVirtualization) {
                                var length = model.currentViewData.length,
                                    rowHeight = model.rowHeight, isTopChanged;
                                rowHeight += (model.showDetailsRow && !model.showDetailsRowInfoColumn) ? model.detailsRowHeight : 0;
                                if ((length * rowHeight) < proxy._viewPortHeight) {
                                    if (length > 0) {
                                        top = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                                        if (top < 0)
                                            top = 0;
                                    } else {
                                        proxy.processBindings();
                                        proxy.renderRecords();
                                    }
                                }
                            }
                            //Update columnOptions fields
                            if (model.showColumnChooser && model.showColumnOptions)
                                proxy.columnAddDialogTemplate();
                            //update the column width
                            this.setWidthToColumns();
                            scroller.scrollY(top, true);
                            scroller.scrollX(left, true);
                            proxy._updateHeaderScrollLeft(left);
                            proxy._updateScrollCss();

                            }                            
                        }
                        break;
                    case "columnResizeSettings":
                        var $headerTable, $contentTable, $totalSummaryTable;
                        this._initiateSetModel();
                        $.extend(model.columnResizeSettings, options[prop]);
                        this._updateGridResizeSettings();
                        var columnResizeMode = model.columnResizeSettings.columnResizeMode;
                        if (columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns) {
                            this._updateTableWidth();
                        } else {
                            if (this._frozenColumnsLength > 0) {
                                $headerTable = $(this.getHeaderTable()[1]);
                                $contentTable = $(this.getContentTable()[1]);
                                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[1]) : null;
                            } else {
                                $headerTable = this.getHeaderTable();
                                $contentTable = this.getContentTable();
                                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[0]) : null;
                            }
                            //set width to 100% for all tables in treegrid in normal resize mode
                            $headerTable.css("width", "").removeClass("e-tableLastCell");
                            $contentTable.css("width", "").removeClass("e-tableLastCell");
                            $totalSummaryTable && $totalSummaryTable.css("width", "").removeClass("e-tableLastCell");
                        }
                        this._updateScrollCss();
                        break;
                    case "cssClass":
                        this.element.removeClass(proxy._cssClass).addClass(options[prop]);
                        this.model.allowPaging && ($("#" + this._id + "Pager").ejPager("model.cssClass", options[prop]));
                        model.toolbarSettings.showToolbar && ($("#" + proxy._id + "_toolbarItems").ejToolbar("model.cssClass", options[prop]));
                        if (proxy._updateConfirmDialog) {
                            proxy._updateConfirmDialog.data("ejDialog") && proxy._updateConfirmDialog.ejDialog("model.cssClass", options[prop]);
                        }
                        for (var count = 0; count < proxy._renderedFilterMenuDialog.length; count++) {
                            if (proxy._renderedFilterMenuDialog[count] == "stringedit") {
                                $("#" + this._id + "filterStringMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterStringMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterStringMenuDiv_wrapper").find(".e-autocomplete").ejAutocomplete("model.cssClass", options[prop]);
                            }
                            else if (proxy._renderedFilterMenuDialog[count] == "numericedit") {
                                $("#" + this._id + "filterNumericMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterNumericMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterNumericMenuDiv_wrapper").find(".e-numerictextbox").ejNumericTextbox("model.cssClass", options[prop]);
                            }
                            else if (proxy._renderedFilterMenuDialog[count] == "datepicker") {
                                $("#" + this._id + "filterDatepickerMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatepickerMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatepickerMenuDiv_wrapper").find(".e-datepicker").ejDatePicker("model.cssClass", options[prop]);
                            }
                            else if (proxy._renderedFilterMenuDialog[count] == "datetimepicker") {
                                $("#" + this._id + "filterDatetimePickerMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatetimePickerMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatetimePickerMenuDiv_wrapper").find(".e-datetimepicker").ejDateTimePicker("model.cssClass", options[prop]);
                            }
                            else if ("#" + proxy._renderedFilterMenuDialog[count] == "dropdownedit") {
                                $("#" + this._id + "filterDropdownMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDropdownMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                            }
                            else if ("#" + proxy._renderedFilterMenuDialog[count] == "booleanedit") {
                                $("#" + this._id + "filterBooleanMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterBooleanMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                            }
                        }
                        this.columnAddDialogTemplate();
                        $("#" + proxy._id + 'ConfirmDialog_wrapper').find(".e-button").ejButton("model.cssClass", options[prop]);
                        if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) || proxy.model.editSettings.dialogEditorTemplateID == "")) {
                            proxy._treeGridAddEditDialog();
                        } else if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) && proxy.model.editSettings.dialogEditorTemplateID != "")) {
                            proxy._treeGridAddEditDialogTemplate();
                        }
                        if (model.showColumnChooser)
                            this._renderColumnChooserList(true);
                        proxy._cssClass = options[prop];
                        break;
                }
            }
        },
        /* clear contextMenu, columnChooser, detailsTemplate and save edited item before change
        property by setModel*/
        _initiateSetModel: function ()
        {
            var model = this.model;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }

            this._clearContextMenu();
            this._clearColumnMenu();
            this._removeDetailsRow();
        },
        /* update the tree grid control as per new detailsRow fetaures API values by setModel */
        _updateDetailsRowProperties: function (property) {

            var proxy = this,
                model = this.model;

            /* cance edited cell or row */
            if(model.isEdit || this._isRowEdit){
                this.cancelRowEditCell();
                this._cancelSaveTools();
            }
            /* clear columnchooser menu and contextmenu and detail wrapper */
            this.clearColumnMenu();
            this._clearContextMenu();
            this._removeDetailsRow();
             
            /* update the detailsRowHeight private property */
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                proxy._detailsRowHeight = model.detailsRowHeight;
            } else {
                proxy._detailsRowHeight = 0;
            }

            /* update the details expand status as per details feture API values */
            model.flatRecords.forEach(function (record) {
                if (model.showDetailsRow && model.detailsTemplate) {
                    record.isDetailsExpanded = model.showDetailsRowInfoColumn ? false : true;
                } else {
                    record.isDetailsExpanded = false;
                }
            });
            
            /* update the tree grid control as per new detailsRow API's */
            if ((property == "detailsTemplate" || property == "detailsRowHeight") && model.showDetailsRowInfoColumn) {
                proxy._addInitTemplate();
            } else {
                proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                proxy._addInitTemplate();
                /* while changing details row features API scroll top is assigned to beacause of rowHeight changes*/
                this.onScrollHelper(0);
                proxy.refreshContent();

                /* for details rows detailsDataBound event can be called after the width update of column */
                proxy._isRendered = false;
                //Rerendering the content of the tree grid
                var refreshArgs = {};
                refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy.sendDataRenderingRequest(refreshArgs);
                proxy.setWidthToColumns();
                proxy._isRendered = true;
                proxy._trigger("refresh");
                /* trigger queryCellInfo ,detailsDataBoundEvent after update the width of the columns */
                this._eventBindings();
                this._hideCollapsedDetailsRows();

                proxy.getScrollElement().ejScroller("refresh");
                proxy._updateScrollCss();
            }
        },
        /* hide the collapsed state detail rows for prevent alignement issue for rendering sf control in  display none state*/
        _hideCollapsedDetailsRows:function()
        {
            var proxy = this, model = this.model;
            /* Collapse hidden expanded details rows */
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                if (this._frozenColumnsLength > 0)
                    $(proxy.getTreeGridRows()[0]).add(proxy.getTreeGridRows()[1]).filter("tr.collapsedrowexpandeddetailsrow").css("display", "none");
                else
                    $(proxy.getTreeGridRows()).filter("tr.collapsedrowexpandeddetailsrow").css("display", "none");
            }
        },
        _updateToolbar: function () {
            var proxy = this,
                model = proxy.model,
                scroller = proxy.getScrollElement().ejScroller("instance"),
                           left = scroller.scrollLeft(),
                           top = scroller.scrollTop();
            //$.extend(proxy.model.toolbarSettings, options[prop]);
            $("#" + proxy._id + "_toolbarItems").remove();
            $("#" + proxy._id + "_toolbarItems_Main").remove();
            if (model.toolbarSettings.showToolbar)
                proxy._renderToolbarTemplate().insertBefore($("#" + proxy._id + "e-gridheader"));
            if (model.isEdit)
                proxy.cancelEditCell();
            if (proxy._isRowEdit) {
                proxy.cancelRowEditCell();
                proxy._cancelSaveTools();
            }
            proxy._viewPortHeight = proxy._getViewPortHeight();
            if (proxy._frozenColumnsLength > 0) {
                proxy._$gridContent.css("height", proxy._viewPortHeight);
            }
            scroller.option("height", proxy._viewPortHeight);
            if (model.enableVirtualization) {
                proxy.processBindings();
                proxy.renderRecords();
            }
            scroller.option("scrollTop", top);
            scroller.option("scrollLeft", left);
            proxy._clearContextMenu();
            this._removeDetailsRow();

        },
        //refresh data source on set model     
        _refreshDataSource: function ()
        {
            var proxy = this, model = this.model, args;
            //Cancelling the editable state of the row
            if (proxy._isRowEdit || proxy.model.isEdit) {
                proxy.cancelRowEditCell();
            }
            proxy.resetModelCollections();
            proxy._createdAt = "load";
            if (this.dataSource() instanceof ej.DataManager) {
                var queryPromise = this.dataSource().executeQuery(model.query);
                queryPromise.done(ej.proxy(function (e) {
                    if (proxy.dataSource().dataSource.offline) {
                        proxy._retrivedData = proxy.dataSource().dataSource.json;
                    } else {
                        proxy._retrivedData = e.result;
                    }
                    if (model.idMapping && model.parentIdMapping && proxy._retrivedData.length > 0) {
                        //cloning the datasource                    
                        var data = []; proxy._taskIds = [];
                        for (var i = 0; i < proxy._retrivedData.length; i++) {
                            var tempData = proxy._retrivedData[i];
                            data.push($.extend(true, {}, tempData));
                            if (tempData[model.idMapping]) proxy._taskIds.push(tempData[model.idMapping]);
                        }
                        proxy._reconstructDatasource(data);                       

                    } else
                        proxy.secondaryDatasource = proxy._retrivedData;

                    proxy._createRecords(proxy.secondaryDatasource);

                    args = {};
                    args["requestType"] = ej.TreeGrid.Actions.RefreshDataSource;
                    proxy._ensureDataSource(args);
                    if (proxy.selectedRowIndex() !== -1 && proxy.selectedRowIndex() < proxy.model.currentViewData.length) {
                        proxy.selectRows(proxy.selectedRowIndex());
                    }
                    if (proxy.getScrollElement().hasClass("e-scroller"))
                        proxy.getScrollElement().ejScroller("refresh");
                    proxy._createdAt = null;
                }));
            }
            else if (this.dataSource()) {
                proxy._retrivedData = proxy.dataSource();
                if (model.idMapping && model.parentIdMapping && proxy._retrivedData.length > 0) {
                    //cloning the datasource                    
                    var data = []; proxy._taskIds = [];
                    for (var i = 0; i < proxy._retrivedData.length; i++) {
                        var tempData = proxy._retrivedData[i];
                        data.push($.extend(true, {}, tempData));
                        if (tempData[model.idMapping]) proxy._taskIds.push(tempData[model.idMapping]);
                    }
                    proxy._reconstructDatasource(data);
                    proxy._createRecords(proxy.secondaryDatasource);
                }
                else if (model.flatRecords.length === 0 && this.dataSource() !== null) {
                    proxy._createRecords(this.dataSource());
                }
                args = {};
                args["requestType"] = ej.TreeGrid.Actions.RefreshDataSource;
                proxy._ensureDataSource(args);
                if (this.selectedRowIndex() !== -1 && this.selectedRowIndex() < proxy.model.currentViewData.length) {
                    proxy.selectRows(this.selectedRowIndex());
                }
                if (proxy.getScrollElement().hasClass("e-scroller"))
                    proxy.getScrollElement().ejScroller("refresh");
                proxy._createdAt = null;
            }
            else if (this.dataSource() == null) {
                args = {};
                args["requestType"] = ej.TreeGrid.Actions.RefreshDataSource;
                proxy._ensureDataSource(args);
                proxy._createdAt = null;
            }
            $(".e-tooltiptable").remove();
            if(model.showSummaryRow || model.showTotalSummary)
                proxy._summaryRow();
        },
        //REFRESH THE TREEGRIDCONTENT
        refreshContent: function () {

            var proxy = this,
                args = {};     
            args.requestType = ej.TreeGrid.Actions.Refresh;
            proxy.processBindings(args);
        },


        //RESET THE COLLECTIONS WHILE CHANGING THE DATASOURCE
       
        resetModelCollections: function () {

            var proxy = this,
            model = proxy.model;

            // model.sortSettings.sortedColumns = [];
            model.currentViewData = [];
            model.flatRecords = [];
            model.parentRecords = [];
            model.updatedRecords = [];
            model.summaryRowRecords = [];
            model.ids = [];
            proxy.secondaryDatasource = [];
            proxy._parentRecords = [];
            proxy._storedIndex = -1;
            proxy._idGenerator = -1; //unique id only use for treegrid
            proxy._taskIds = [];
        },        

        //#endregion

        //DECLARE THE PRIVATE VARIABLES
        _initPrivateProperties: function () {

            var proxy = this,
                model = this.model;

            proxy._id = proxy.element.attr("id"),
            proxy.columnsWidthCollection = [],
            proxy._cSortedColumn = null,
            proxy._taskIds=[],
            proxy._cSortedDirection = null,
            proxy._dataManager = null,
            proxy._disabledSortableColumns = [],
            proxy._filteredRecords = [],
            proxy._disabledToolItems = [],
            proxy._currentFilterColumn = [],
            proxy._fieldColumnNames = [],
            proxy._multiSortRequest = null,
            proxy._$gridContainer = null,
            proxy._$gridContent = null,
            proxy._$gridContentTable = null,
            proxy._$gridHeaderTable = null,
            proxy._$gridHeaderContainer = null,
            proxy._$totalSummaryRowContainer = null,
            proxy._recordsCount = null,
            proxy._$gridRows = null,
            proxy._gridRows = null,
            this._frozenColumnsLength = 0,
            proxy._initFrozenColumns(),
            proxy._allowFreezingDefault = this._frozenColumnsLength > 0 ? true : false;
            proxy._calculateDimensions(),
            proxy._headerColumnNames = [],
            proxy._hiddenColumns = [],
            proxy._multiSelectCtrlRequest = false,
            proxy._multiSelectShiftRequest = false,
            proxy._offset = 0,
            proxy._previousIndex = -1,
            proxy._prevRBottom = 0,
            proxy._prevRTop = 0,
            proxy._prevScrollTop = 0,
            proxy._prevScrollLeft = 0,
            proxy._prevVBottom = 0,
            proxy._resizer = null,
            proxy._scrollTop = 0,
            proxy._scrollLeft = 0,
            proxy._searchString = "",
            proxy._fieldName = "",
            proxy._selectedCellsinARow = [],
            proxy._currentRecordIndex = -1,
            proxy._sortedRecords = [],
            proxy._storedIndex = -1,
            proxy._rowIndex = -1,
            proxy._$tableContent = null,
            proxy._$footertableContent = null,
             proxy._$footerContainer = null,
            proxy._tempsortedrecords = [],
            proxy._totalHeight = 0,
            proxy._viewPortHeight = 0,
            proxy._recordIndexCount = 0,
            proxy._totalCollapsedRecordCount = 0,
            proxy._visibleColumns = [],
            proxy._visibleRange = null,
            proxy._vScrollDir = 1,
            proxy._vScrollDist = 0,
            proxy._cellEditTemplate = $(),
            proxy._tooltipTimer,
            proxy._totalBorderWidth = 2;//left and right border width
            proxy._totalBorderHeight = 1;
            proxy._toolboxTooltipTexts = null;
            proxy._contextMenuTexts = null;
            proxy._columnMenuTexts = null;
            proxy._deleteColumnText = null;
            proxy._okButtonText = null;
            proxy._cancelButtonText = null;
            proxy._confirmDeleteText = null;
            proxy._dropDownListBlanksText = null;
            proxy._editTypeText = null;
            proxy._textAlignType = null;
            proxy._clipMode = null;
            proxy._dropDownListClearText = null;
            proxy._trueText = null;
            proxy._falseText = null;
            proxy._rowDragIndexes = [];
            proxy._dropCancel = false;
            proxy._cellEditingDetails = {
                cellValue: null,
                rowIndex: -1,
                columnIndex: -1,
                fieldName: null,
                _data: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                data: null
            },
           proxy._previousSelectedCellDetails = {
               rowElement: null,
               cellElement: null,
               cellIndex: -1,
               rowIndex: -1,
           },
           proxy._shiftKeyFirstElementDetails = {
               firstElementRowIndex: -1,
               firstElementCellIndex: -1
           },
            proxy._selectedCellDetails = [];
            proxy._focusingRowIndex = -1,
            proxy._rowIndexOfLastSelectedCell = -1,
            proxy._lastSelectedCellIndex = -1,
            proxy._tdsOffsetWidth = [],
            proxy._isEnterKeyPressed = false,
            proxy._isShiftKeyNavigation = false;
            proxy._scrollBarHeight = 18,
            proxy._removedCount = 0,
            proxy._$gridHeaderContent = null,
            proxy.secondaryDatasource = [],
            //variables for context menu items
            proxy._contextMenuItems = null;
            proxy._subContextMenuItems = null;
           
            proxy._createContextMenuTemplate();
            proxy._createColumnMenuTemplate();
            proxy._retrivedData = this.dataSource();
            proxy._createdAt = "load";
            proxy._isInExpandCollapseAll = false;
            proxy._dataManager = proxy.dataSource() instanceof ej.DataManager ? proxy.dataSource() :
                proxy.dataSource() != null ? ej.DataManager(proxy.dataSource()) : null;
            proxy._dragMouseDown = false;
            proxy._dragTooltip = false;
            proxy._dragMouseLeave = false;
            proxy._timerDragDown = null;
            proxy._timerDragUp = null;
            /* Check data manger is updatable */ 
            proxy._isDataManagerUpdate = false;
            proxy._jsonData = null;

            /* flag for refreshing newly added record */
            proxy._isRefreshAddedRecord = false;
            /* Used as flag for refresh chart and grid rows on adding when parent item is in collpased state*/
            proxy._isInAdd = false;         
            /* get unique index for tree grid add whil add */
            proxy._maxRowIndex = 0;
           /* used to check treegrid rendering is completed on load time*/
            proxy._isRendered = false;
            this._updateGridResizeSettings();
            proxy._isSummaryRow = false;
            proxy._flatChildRecords = [];
            proxy._footerSummaryRecord = [];
            proxy._filteredChildRecords = [];
            proxy._parentRecords = [];
            proxy._zerothLevelParentRecords = [];
            proxy._detailsRowHeight = 0;
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn)
            {
                proxy._detailsRowHeight = model.detailsRowHeight;
            }
            proxy._isEmptyRow = false;
            proxy._isPublicAdd = false;
            proxy._prevSelectedItem = null;
            proxy._dataSourcefields = [];
            proxy._columnDialogTexts = null;
            proxy._columnDialogTitle = null;
            proxy._addColumnFields = [];
            proxy._addColumnFieldsTxt = [];
            proxy._targetColumnIndex = 0;
            proxy._insertPosition = null;
            proxy._updateconfirmDialog = null;
            proxy._columnRenameDialog = null;
            proxy._renderedSubMenuType = null;
            proxy.localizedLabels = proxy._getLocalizedLabels();
            proxy._gridRecordsCount = model.pageSettings.totalRecordsCount;                            
            proxy._gridPager = null;
            proxy._summaryRowsCount = 0;                                 
            proxy._updatedPageData = [];
            proxy._isNextPage = false;
            model.selectionSettings.selectionType = model.selectionSettings.selectionType != "single" ? model.selectionSettings.selectionType :
                    model.selectionType != "single" ? model.selectionType : model.selectionSettings.selectionType;
            model.selectionSettings.selectionMode = model.selectionSettings.selectionMode != "row" ? model.selectionSettings.selectionMode :
                    model.selectionMode != "row" ? model.selectionMode : model.selectionSettings.selectionMode;
            proxy._idGenerator = -1;
            proxy._checkboxColumnName = null;
            proxy._isFromSetmodel = false;
            proxy._flatFilteredRecords = [];
            proxy._checkboxSelection = (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox && 
                model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row),            
            proxy._addCheckboxColumn = this._getDefaultCheckboxColumn(),
            proxy._filteredColumnValue = [];
            proxy._filteredColumnValueID = [];
            proxy._filterIconTarget = null;
            proxy._renderedFilterMenuDialog = [];
            proxy._filtermenutext = null;
            proxy._headerDragStatus = "";
            proxy._draggedColumn = null;
            proxy._mouseDragged = false;
            if (!ej.isNullOrUndefined(model.indentLevelWidth) && model.isFromGantt)
                proxy.treeIndentLevelWidth = model.indentLevelWidth;
            else
                proxy.treeIndentLevelWidth =  proxy.treeIndentLevelWidth ? proxy.treeIndentLevelWidth : 10;
            proxy._draggedColumnTemplate = null;
            proxy._viewPortWidth = proxy._gridLeft = 0;            
            proxy._responsiveMinWidth = 768;
            proxy._dy = proxy._dx = 0;
            proxy._isTouchEvent = false;
            proxy._isTouchTrigger = false;
            proxy._currentEditRecordDialogIndex = -1;
            proxy._isTreeAddEditDialogSave = false;
            proxy._displayContextMenu = model.contextMenuSettings.showContextMenu ? true : false;
            proxy._isEmptyRowDeleted = false;
            proxy._cssClass = this.model.cssClass;
        },
        //Return default check box selection column obect
        _getDefaultCheckboxColumn: function () {
            return {
                field: "checkboxState",
                headerText: "",
                allowEditing: false,
                allowDelete: false,
                allowSorting: false,
                allowFiltering: false,
                allowCellSelection: false,
                isFrozen: false,
                nonColumn:true,
                editType: "booleanedit",
                width: 50,
                textAlign:"center"
            };
        },
        //update columnResizeSettings API to grid resizeSettings API
        _updateGridResizeSettings: function () {
            var resizeSettings = {
                resizeMode: (this.model.columnResizeSettings.columnResizeMode == "fixedcolumns" ? "control" : this.model.columnResizeSettings.columnResizeMode)
            };
            this.model.resizeSettings = resizeSettings;
        },
        //set size to treegrid core by user values
        _calculateDimensions: function ()
        {
            var proxy = this, model = this.model;

            if (!model.isFromGantt) {
                if (model.sizeSettings.width)
                    proxy.element.css("width", model.sizeSettings.width);

                if (model.sizeSettings.height)
                    proxy.element.css("height", model.sizeSettings.height);
                else
                {
                    if (!proxy.element[0].style.height) {
                        proxy.element.height(450);
                    }
                    else
                        model.sizeSettings.height = proxy.element[0].style.height;
                }
            }
            proxy._gridHeight = Math.round(proxy.element.height());
            proxy._gridWidth = Math.round(proxy.element.width());

            if (this._frozenColumnsLength > 0) {
                var frozenWidth = 0;
                for (var count = 0; count <= this._frozenColumnsLength; count++) {
                    if (model.columns[count])
                        frozenWidth += ej.isNullOrUndefined(model.columns[count].width) ? 150 : parseInt(model.columns[count].width);
                }
                if (proxy._gridWidth < frozenWidth) {
                    proxy.element.css("width", frozenWidth);
                    model.sizeSettings.width = proxy._gridWidth = frozenWidth;
                }
            }
        },

        /* Reordering and initialize frozen and unfrozen columns*/
        _initFrozenColumns: function ()
        {
            var frozen = [], unfrozen = [], visibleFrozenColumns = 0, visibleUnfrozenColumns = 0,
                model = this.model, columns = model.columns, treeColumn;
            treeColumn = columns[model.treeColumnIndex];
            for (var columnCount = 0; columnCount < columns.length; columnCount++) {
                if (columns[columnCount]["isFrozen"] === true) {
                    frozen.push(columns[columnCount]);
                    if (ej.isNullOrUndefined(columns[columnCount].visible) || columns[columnCount].visible)
                        visibleFrozenColumns += 1;
                }
                else {
                    unfrozen.push(columns[columnCount]);
                    if (ej.isNullOrUndefined(columns[columnCount].visible) || columns[columnCount].visible)
                        visibleUnfrozenColumns += 1;
                }
            }
            if (frozen.length > 0) {
                /*one column must be in un frozen state*/
                if (model.columns.length && model.columns.length == frozen.length) {
                    unfrozen = frozen.splice(frozen.length - 1, 1);
                    unfrozen[0].isFrozen = false;
                }
                model.columns = $.merge($.merge([], frozen), unfrozen);
            }
            this._frozenColumns = frozen;
            this._unFrozenColumns = unfrozen;
            /*Update minimum number of column to visible*/
            if (visibleFrozenColumns == 0 && this._frozenColumns[0])
                this._frozenColumns[0].visible = true;
            if (visibleUnfrozenColumns == 0 && this._unFrozenColumns[0])
                this._unFrozenColumns[0].visible = true;
            if (treeColumn)
                model.treeColumnIndex = model.columns.indexOf(treeColumn);

            this._frozenColumnsLength = frozen.length;
            model.scrollSettings.frozenColumns = this._frozenColumnsLength;
        },
        //update altrow when enableCollapseAll enabled.
        updateAltRowOnCollapseAll: function () {
            var proxy=this, model=proxy.model;
            if (model.enableAltRow && model.enableCollapseAll) {
                var records = model.parentRecords,
                    record;
                for (var count = 0; count < records.length; count++) {
                    record = records[count];
                    if (record.isSummaryRow)
                        continue;
                    record.isAltRow = count % 2 == 0 ? false : true;
                }
            }
        },
        //update altrow when expandStateMapping is defined.
        updateAltRowOnRendering: function () {
            var proxy = this, model = proxy.model;           
            var records = model.updatedRecords.filter(function (record) {
                if (record.parentItem == null)
                    return record;
                else if (record.parentItem.expanded)
                    return record;
            });
            for (var count = 0; count < records.length; count++) {
                var record = records[count];
                if (record.isSummaryRow)
                    continue;
                record.isAltRow = count % 2 == 0 ? false : true;
            }            
        },
        //DATASOURCE CHECKING
        _checkDataBinding: function () {

            var proxy = this,
                model = proxy.model;
            $("#" + proxy._id).addClass('e-treegrid-overflow');
            proxy._createdAt = null;
            proxy.element.addClass('e-treegrid-core');
            proxy.element.attr("tabindex", "0");
            model.cssClass && this.element.addClass(model.cssClass);
            proxy._renderToolbar();
            if (proxy._checkboxSelection)
                proxy._updateCheckboxColumnName();
            proxy._renderAfterColumnInitialize();
            if (proxy.model.showColumnChooser) {
                proxy._renderColumnChooser();
                if(proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu")
                proxy._renderFilterMenu();
            } else if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                proxy._renderFilterMenu();
            }
            proxy._setWidthToHeaders();
            if (proxy.model.allowPaging) {
                proxy.element.append(proxy._renderGridPager());
                proxy.element.append(proxy.element.find(".e-pager").attr({ "id": this._id + "Pager" }));
            }
            proxy._viewPortHeight = proxy._getViewPortHeight();

            /* check if viewport heigth value*/
            if (!model.isFromGantt && proxy._viewPortHeight < 0) {
                proxy._updateElementHeight();
            }
            proxy._ensureDataSource();
            if (model.showSummaryRow)
                proxy._createSummaryRow();
            if (!model.isFromGantt)
                proxy.updateAltRowOnCollapseAll();
            if (model.expandStateMapping && model.enableAltRow)
                proxy.updateAltRowOnRendering();
            proxy._initGridRender();          
            proxy._$gridContent = $("#" + proxy._id + "e-gridcontent");
            proxy._$gridContainer = $("#" + proxy._id + "e-gridcontainer");
            proxy._$tableContent = $("#" + proxy._id + "e-table");
            proxy._$frozenTableContent = $("#" + proxy._id + "frozene-table");
            proxy._$movableTableContent = $("#" + proxy._id + "movablee-table");
            proxy._viewPortHeight = proxy._getViewPortHeight();
            proxy._$gridContent.css({ "height": proxy._viewPortHeight + "px" });
            proxy.element.find(".e-pager").css({ "width": proxy._gridWidth - 2 });
            proxy._pagerHeight = proxy.element.find(".e-pager").outerHeight();
            if (model.showTotalSummary) {
                proxy._createTotalSummaryRow();
                proxy._viewPortHeight = proxy._getViewPortHeight();
                if (!model.allowPaging || model.sizeSettings.height)
                    proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
            proxy._updatePagerTextAlignment();
            proxy.updateHeight();
            proxy._wireEvents();
            
            proxy.setWidthToColumns();
            
            proxy._renderScroller();
            proxy._updateScrollCss();
            proxy._resizeFilteringElements();
            proxy._initialEndRendering();
            if (model.isFromGantt) {
                proxy._addEmptyColumntoGrid();
            }
            if (!model.isFromGantt) {
                proxy._checkDataManagerUpdate();
            } else {
                proxy._isDataManagerUpdate = model.dataManagerUpdate.isDataManagerUpdate;
                proxy._jsonData = model.dataManagerUpdate.jsonData;
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && !proxy.model.isFromGantt) {
                proxy._renderMultiSelectionIndicator();
            }
            $("#" + proxy._id).removeClass('e-treegrid-overflow');
        },

        //Render Multi selection indicator
        _renderMultiSelectionIndicator: function () {
            this._multiSelectPopup = ej.buildTag("div.e-treegridpopup#" + this._id + "_selectionpopup", "", { display: "none" });
            var $content = ej.buildTag("div.e-popupcontent"), $downTail = ej.buildTag("div.e-downtail e-tail");
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            this._multiSelectPopup.append($content);
            this._multiSelectPopup.append($downTail);
            this.element.append(this._multiSelectPopup);
        },

        //Updated records of online data manager 
        getUpdatedDataManagerData: function () {
            var proxy = this, data;
            data = proxy._jsonData;
            return data;
        },

        //Check if data manager is updatable
        _checkDataManagerUpdate: function () {
            var proxy = this,
                dataSource = this.dataSource();
            proxy._isDataManagerUpdate = false;
            proxy._jsonData = null;

            if (dataSource instanceof ej.DataManager) {
                if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = dataSource.dataSource.json;
                }
                else if (!dataSource.dataSource.offline) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = proxy._retrivedData;
                }
            }
        },

        _initDatasource: function () {
            var proxy = this,
                model = proxy.model, retriveData;
            if (!model.isFromGantt) {
                if (this.dataSource() instanceof ej.DataManager) {

                    var queryPromise = this.dataSource().executeQuery(model.query);
                    queryPromise.done(ej.proxy(function (e) {
                        if (proxy.dataSource().dataSource.offline) {
                            proxy._retrivedData = proxy.dataSource().dataSource.json;
                        } else {
                            proxy._retrivedData = e.result;
                        }
                        if (model.idMapping && model.parentIdMapping && proxy._retrivedData.length > 0) {
                            //cloning the datasource                    
                            var data = []; proxy._taskIds = [];
                            for (var i = 0; i < proxy._retrivedData.length; i++) {
                                var tempData = proxy._retrivedData[i];
                                data.push($.extend(true, {}, tempData));
                                if (tempData[model.idMapping]) proxy._taskIds.push(tempData[model.idMapping]);
                            }
                            proxy._reconstructDatasource(data);
                            proxy._createRecords(proxy.secondaryDatasource);
                        }
                        else
                            proxy._retrivedData && proxy._createRecords(proxy._retrivedData);
                        proxy._checkDataBinding();
                    }));
                }

                else if (this.dataSource()) {
                    proxy._retrivedData = proxy.dataSource();
                    if (model.idMapping && model.parentIdMapping && proxy._retrivedData.length > 0) {
                        //cloning the datasource                    
                        var data = []; proxy._taskIds = [];
                        for (var i = 0; i < proxy._retrivedData.length; i++) {
                            var tempData = proxy._retrivedData[i];
                            data.push($.extend(true, {}, tempData));
                            if (tempData[model.idMapping]) proxy._taskIds.push(tempData[model.idMapping]);
                        }                        
                        proxy._reconstructDatasource(data);
                        proxy._createRecords(proxy.secondaryDatasource);

                    }
                    else if (model.flatRecords.length === 0 && this.dataSource() !== null) {
                        proxy._createRecords(this.dataSource());
                    }
                    proxy._checkDataBinding();
                }
                else {
                    proxy._checkDataBinding();
                }
            } else {
                proxy._checkDataBinding();
            }            
        },
        _intersectionObjects: function (flatCollection, rootCollection) {
            var result = [];
            while (flatCollection.length > 0 && rootCollection.length > 0) {
                var index = rootCollection.indexOf(flatCollection[0]);
                if ( index == -1) {
                    flatCollection.shift();
                }
                else {
                    result.push(flatCollection.shift());
                    rootCollection.splice(index, 1);
                }
            }

            return result;
        },

        _reconstructDatasource: function (datasource) {
            var proxy = this, model = proxy.model, data, filter;                      

            filter = ej.Predicate(model.parentIdMapping, ej.FilterOperators.notEqual, "null");
            data = ej.DataManager(datasource).executeLocal(ej.Query().where(filter).group(model.parentIdMapping));            
            var tempParent = [];

            if (!model.chidMapping) model.childMapping = "Children";

            for (var i = 0; i < data.length; i++) {
                if (!ej.isNullOrUndefined(data[i].key)) {

                    var index = proxy._taskIds.indexOf(data[i].key);
                    if (index > -1) {
                        datasource[index][model.childMapping] = data[i].items;
                        continue;
                    }
                }
                var items = data[i].items;
                for (var item in data[i].items)
                    tempParent.push(items[item]);
            }
            proxy.secondaryDatasource = proxy._intersectionObjects(datasource, tempParent);           
        },        
               
        //Window resize event
        _windowResize: function (e)
        {
            if (!this.element.is(":visible")) {
                return;
            }
            var proxy = this,
               model = this.model;
            $("#" + proxy._id).addClass('e-treegrid-overflow');

            var treeGridHeader = proxy._$gridHeaderContent,
               totalSummaryRowContent = proxy._$totalSummaryRowContainer,
               treeGridContent,
               treegridToolbar = $("#" + proxy._id + "_toolbarItems"),
               sizeSettingsHeight = model.sizeSettings.height,
               sizeSettingsWidth = model.sizeSettings.width,
               elementStyleWidth = proxy.element[0].style.width,
               elementStyleHeight = proxy.element[0].style.height,
               width, height;

            proxy._clearContextMenu();
            if (!proxy.model.isResponsive && !ej.isTouchDevice()) {
                    proxy._clearColumnMenu();
                    proxy._clearFilterMenu();
            }
            else {
                if (!ej.isTouchDevice()) {
                    proxy._clearColumnMenu('resize');
                }
            }

            if (this._frozenColumnsLength > 0)
                treeGridContent = this.element.find("#e-movablecontainer" + this._id);
            else
                treeGridContent = $("#" + proxy._id + "e-gridcontent");


            $("#" + this._id + "detailscellwrapper").length > 0 && this._removeDetailsRow();

            //Width calculation
            if ((sizeSettingsWidth && (typeof(sizeSettingsWidth) != "number" && sizeSettingsWidth.indexOf("%") != -1)) || elementStyleWidth.indexOf("%") != -1) {
                var ganttWidth = sizeSettingsWidth ? sizeSettingsWidth : elementStyleWidth;
                var containerWidth = $(proxy.element).parent().width() ? $(proxy.element).parent().width() : $(proxy.element).width();
                var tempWidth = (containerWidth / 100) * parseInt(ganttWidth);
                width = tempWidth;
            }
            else
                width = $(proxy.element).width();
            proxy._gridWidth = width;
            if (proxy._frozenColumnsLength > 0) {
                var totalWidth = 0;
                for (var i = 0; i <= proxy._frozenColumnsLength; i++)
                    totalWidth += proxy.columnsWidthCollection[i];
                if (width < totalWidth)
                    proxy._gridWidth = width = totalWidth;
            }
            //height calculation
            if ((sizeSettingsHeight && (typeof (sizeSettingsHeight) != "number" && sizeSettingsHeight.indexOf("%") != -1)) || elementStyleHeight.indexOf("%") != -1) {
                var ganttHeight = sizeSettingsHeight ? sizeSettingsHeight : elementStyleHeight;
                var containerHeight = $(proxy.element).parent().height() ? $(proxy.element).parent().height() : $(proxy.element).height();
                var tempHeight;
                if ($(proxy.element).parent().height())
                    tempHeight = (containerHeight / 100) * parseInt(ganttHeight);
                else
                    tempHeight = $(proxy.element).height();
                height = tempHeight;
            }
            else
                height = $(proxy.element).height();

            //excludes border 
            height = height - proxy._totalBorderHeight;
            
            if (proxy._$totalSummaryRowContainer)
                height -= proxy._$totalSummaryRowContainer.outerHeight();
            width = Math.round(width - proxy._totalBorderWidth);
            var treeGridWidth, headerHeight, headerWidth, top, left,
                toolbarHeight = treegridToolbar.length > 0 ? treegridToolbar.outerHeight() : 0;
            top = treeGridContent.ejScroller("option", "scrollTop");
            left = treeGridContent.ejScroller("option", "scrollLeft");
            var scrollerWidth = width,
                PagerHgDiff = 0;
            if (model.allowPaging) {
                var pagerHeight = proxy.element.find('.e-pager').outerHeight(),
                    isPagerTemplate = ej.isNullOrUndefined(model.pageSettings.template)? false : true;
                height -= pagerHeight;               
                if (!model.sizeSettings.height) {
                    var totalWidth = 0;
                    if (pagerHeight > proxy._pagerHeight && !isPagerTemplate)
                        PagerHgDiff = pagerHeight - proxy._pagerHeight;
                    for (var i = 0; i < proxy.columnsWidthCollection.length; i++)
                        totalWidth += proxy.columnsWidthCollection[i];
                    if (totalWidth > proxy._gridWidth) {
                        height = height + proxy._scrollBarHeight;
                    }                   
                }
            }
            if (this._frozenColumnsLength > 0) {
                proxy._$gridContent.css("width", width);
                proxy._$gridContent.css("height", height - $(treeGridHeader).outerHeight() - toolbarHeight);
                scrollerWidth = width - this._getFrozenColumnWidth() - 1;//frozen div border width
            }
            proxy.getScrollElement().ejScroller({
                width: scrollerWidth,
                height: height - $(treeGridHeader).outerHeight() - toolbarHeight + PagerHgDiff//for border-width of gridcontent
            });
            proxy._updateScrollCss();
            if ($(treeGridHeader).hasClass("e-scrollcss") && proxy.getScrollElement().children(".e-vscrollbar").length > 0) {
                $(treeGridHeader).width(width - 17);
            }
            else {
                $(treeGridHeader).width(width);
            }

            if (proxy._$totalSummaryRowContainer) {
                if (proxy._$totalSummaryRowContainer.outerHeight() >= 90 && proxy._$totalSummaryRowContainer.hasClass("e-scroller"))
                    proxy._$totalSummaryRowContainer.ejScroller("refresh");
                else if ($(totalSummaryRowContent).hasClass("e-scrollcss") && proxy.getScrollElement().children(".e-vscrollbar").length > 0 )
                    $(totalSummaryRowContent).width(width - 17);
                else 
                    $(totalSummaryRowContent).width(width);
            }
            if (model.toolbarSettings.showToolbar && treegridToolbar.length > 0) {
                treegridToolbar.width(width);
            }

            proxy.getScrollElement().ejScroller("refresh");
            proxy.updateViewPortHeight();

            if(model.showTotalSummary)
                proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            proxy.getScrollElement().ejScroller("option", "scrollTop",top);
            proxy.getScrollElement().ejScroller("option", "scrollLeft", left);
            proxy._updateHeaderScrollLeft();
            if (model.enableVirtualization) {
                proxy.cancelRowEditCell(); // To hide or destroy popup menu
                var tempArgs = {},
                    rowHeight = model.rowHeight;
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy.processBindings(tempArgs);                
                proxy.sendDataRenderingRequest(tempArgs);
                /* check detail template and its row height */
                if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn)
                {
                    rowHeight += model.detailsRowHeight;
                }
                
                if ((model.currentViewData.length * rowHeight) < proxy._viewPortHeight) {

                    var currentPosition = top - (proxy._viewPortHeight - model.currentViewData.length * rowHeight);
                    if (currentPosition < 0)
                        currentPosition = 0;
                    proxy.getScrollElement().ejScroller("scrollY",currentPosition, true);
                }
            }
            if (model.allowPaging)
                proxy.element.find(".e-pager").css({ "width": proxy._gridWidth - 2 });
            proxy._resizeFilteringElements();
            if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt) {
                this._updateTableWidth(true);
            }
            if (proxy.model.isResponsive && !proxy.model.isFromGantt) {
                proxy._mediaQueryUpdate();
            }
            proxy._updatePagerTextAlignment();
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._alignMultiSelectPopup();
            }
            $("#" + proxy._id).removeClass('e-treegrid-overflow');
        },
		
        _updatePagerTextAlignment: function () {
            var proxy = this;
            if (proxy.model.allowPaging) {
                if (($('#' + proxy._id + 'Pager').find('.e-pagercontainer').outerWidth() + $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').outerWidth() + 10) > $('#' + proxy._id).width()) {
                    var pagecontainer = ($('#' + proxy._id).width() - $('#' + proxy._id + 'Pager').find('.e-pagercontainer').outerWidth()) / 2;
                    var parentmsgbar = ($('#' + proxy._id).width() - $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').width()) / 2;
                    if (pagecontainer > 0) {
                        $('#' + proxy._id + 'Pager').find('.e-pagercontainer').css("margin-left", pagecontainer + 'px');
                    }
                    if (parentmsgbar > 0) {
                        $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').css("margin-right", (parentmsgbar - 6) + 'px');
                    }
                } else {
                    $('#' + proxy._id + 'Pager').find('.e-pagercontainer').css("margin-left", "");
                    $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').css("margin-right", "");
                }
            }
        },

        _alignMultiSelectPopup: function() {
            var proxy = this,
                contentHeightLimit = proxy._$gridContent.offset().top + proxy._$gridContent.outerHeight(),
                contentWidthLimit = proxy._$gridContent.offset().left + proxy._$gridContent.outerWidth();
            if ((proxy._multiSelectPopup.offset().top + proxy._multiSelectPopup.outerHeight() + 10) > contentHeightLimit || proxy._multiSelectPopup.offset().top < proxy._$gridContent.offset().top || (proxy._multiSelectPopup.offset().left + proxy._multiSelectPopup.outerWidth()) > contentWidthLimit || proxy._multiSelectPopup.offset().left < proxy._$gridContent.offset().left) {
                var top = proxy._$gridContent.offset().top + (proxy._$gridContent.outerHeight() / 2),
               left = proxy._$gridContent.offset().left + (proxy._$gridContent.outerWidth() / 2);
                if (proxy._$gridContent.find(".e-hscrollbar").length > 0)
                    top = top - proxy._$gridContent.find(".e-hscrollbar").outerHeight();
                if (proxy._$gridContent.find(".e-vscrollbar").length > 0)
                    left = left - proxy._$gridContent.find(".e-vscrollbar").outerWidth();
            proxy._multiSelectPopup.offset({ top: (top - (this._multiSelectPopup.height() / 2) - 5), left: (left - (this._multiSelectPopup.width() / 2)) });
        }
        },

        _mediaQueryUpdate: function () {
            var proxy = this, length, sliceFilterMenuDivID, filterMenuDivID,
                temp = "",
                controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]);

            // Insert dialog-box changes with respect to window resize.

            if ($("#" + proxy._id + "_dialogColumnAdd_wrapper").length > 0 && $("#" + proxy._id + "_dialogColumnAdd_wrapper").css('display') != 'none') {
                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {

                        $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "_dialogColumnAdd").find(".dropdowntreegrid").css('width', ($("#" + proxy._id).width() - 80) + 'px');  // 80px ((28px of $("#" + proxy._id + "_dialogColumnAdd"))+(18px of Hscrollbar)+(30px of $("#" + proxy._id + "ColumnAddForm div"))) get minused in width to place the dropdown dialog treegrid div in absolute position.
                        $("#" + proxy._id + "_dialogColumnAdd").ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, allowDraggable: false, enableModal: false, isResponsive: false });

                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-shadow");
                        $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-shadow");

                } else {
                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog({ width: "auto", height: "auto", minHeight: 0, minWidth: 0, showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true });
                    $("#" + proxy._id + "_dialogColumnAdd").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").addClass("e-treegridadaptivedialog e-treegrid-dialog");
                    $("#" + proxy._id + "_dialogColumnAdd").find(".dropdowntreegrid").css('width', '438px');  // fixed width of dialog dropdown treegrid div.
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").addClass("e-shadow");
                }
            }

            // Column rename dialog-box changes with respect to window resize.

            if ($("#" + proxy._id + "ColumnRenameDialog_wrapper").length > 0 && $("#" + proxy._id + "ColumnRenameDialog_wrapper").css('display') != 'none') {

                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {

                        $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-treegridadaptivedialog");
                        proxy._columnRenameDialog.ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", position: { X: controlPosition.left, Y: controlPosition.top }, minHeight: "50px", minWidth: "50px", showOnInit: false, allowDraggable: false, enableResize: false, enableModal: false, isResponsive: false });
                        $("#" + proxy._id + "ColumnRenameDialog_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                        $("#" + proxy._id + "ColumnRenameDialog_wrapper").removeClass("e-shadow");
                        $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-shadow");
                        $("#" + proxy._id + "ColumnRenameDialog_wrapper").removeClass("e-treegridadaptivedialog");

                } else {
                    proxy._columnRenameDialog.ejDialog({ width: "auto", height: "auto", minHeight: 0, minWidth: 0, showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true });
                    $("#" + proxy._id + "ColumnRenameDialog").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "ColumnRenameDialog_wrapper").addClass("e-treegridadaptivedialog e-treegrid-dialog");
                }
            }

            // Filter menu dialog-box changes with respect to window resize.

            if (proxy._renderedSubMenuType) { // proxy._renderedSubMenuType shows the rendered type of sub menu (filter menu / column chooser) dialog of column menu.
                temp = "";
                if (proxy._renderedSubMenuType.indexOf("Desktop") == -1) {
                    temp = proxy._renderedSubMenuType;
                } else {
                    var index = proxy._renderedSubMenuType.indexOf("Desktop");
                    temp = proxy._renderedSubMenuType.slice(0, index);
                }
                if ($(temp + "_wrapper").length > 0 && $(temp + "_wrapper").css('display') != 'none') {
                    if ($(window).width() <= proxy._responsiveMinWidth && proxy._renderedSubMenuType.indexOf("Desktop") == -1 && proxy.model.isResponsive) {

                        var dialogInnerDivHeight = ($("#" + proxy._id).height() - 50) + "px"; // (48px - Dialog box header height) + (2px - excess border of parent div).
                            $(proxy._renderedSubMenuType + "_wrapper").find("div.e-dialog-scroller").addClass("e-treegridadaptivewidth");
                            $(proxy._renderedSubMenuType).ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", position: { X: controlPosition.left + "px", Y: controlPosition.top + "px" }, minHeight: "50px", minWidth: "50px", showOnInit: false, enableResize: false, enableModal: false, isResponsive: false });
                            if ($(proxy._renderedSubMenuType).height() > $(proxy._renderedSubMenuType + "_wrapper").height() - 48) { // 48px - Dialog box header height
                                $(proxy._renderedSubMenuType + "_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 48) + "px", 'width': 'auto', 'padding': '0px' }); // 48px - Dialog box header height
                                $(proxy._renderedSubMenuType).ejDialog("refresh"); // 'refresh' event get called inorder to update dialog scroll bar
                            } else {
                                $(proxy._renderedSubMenuType+"_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight, 'width': 'auto' });
                              //$(proxy._renderedSubMenuType).ejDialog("refresh"); // 'refresh' event get called inorder to update dialog scroll bar
                            }

                    } else {
                        if (ej.isTouchDevice()) {
                            if (((proxy._renderedSubMenuType.indexOf("Desktop") == -1) && ($(window).width() > proxy._responsiveMinWidth)) || ((proxy._renderedSubMenuType.indexOf("Desktop") != -1) && ($(window).width() <= proxy._responsiveMinWidth))) {
                                proxy._clearColumnMenu();
                                proxy._clearFilterMenu();
                            }
                        } else {
                            proxy._clearFilterMenu();
                        }
                    }
                } else if ((ej.isTouchDevice() && !proxy._renderedSubMenuType) || (ej.isTouchDevice() && $(temp + "_wrapper").length > 0 && $(temp + "_wrapper").css('display') == 'none')) {
                    proxy._clearColumnMenu();
                }
            } else if ((ej.isTouchDevice() && !proxy._renderedSubMenuType) || (ej.isTouchDevice() && $(temp + "_wrapper").length > 0 && $(temp + "_wrapper").css('display') == 'none')) {
                proxy._clearColumnMenu();
            }

            // Column chooser dialog-box changes with respect to window resize.

            if ($("#" + proxy._id + "ccDiv_wrapper").length > 0 && $("#" + proxy._id + "ccDiv_wrapper").css('display') != 'none') {
                if ($(window).width() < proxy._responsiveMinWidth && proxy._renderedSubMenuType.indexOf("AdaptiveColChooser") == 0 && proxy.model.isResponsive) {

                    var dialogInnerDivHeight = ($("#" + proxy._id).height() - 66) + "px"; //(48px - Dialog box header height) + (16px - $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller") of padding) + (2px - excess border of parent div) 
                        $("#" + proxy._id + "ccDiv").ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, enableModal: false, isResponsive: false });
                        $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "ccDiv").css({ 'width': '100%', 'height': 'auto' });
                        if ($("#" + proxy._id + "ccDiv").height() > $("#" + proxy._id + "ccDiv_wrapper").height() - 48) { //(48px - Dialog box header height)
                            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 48) + "px", 'width': 'auto', 'padding': '0px' }); //(48px - Dialog box header height)
                            $("#" + proxy._id + "ccDiv").removeClass("e-columnSelector");
                            $("#" + proxy._id + "ccDiv").ejDialog("refresh");
                        } else {
                            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight, 'width': 'auto', 'padding': '8px 16px' });
                            $("#" + proxy._id + "ccDiv").css({ 'padding': '0px' });
                        }
                        $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-shadow");
                        $("#" + proxy._id + "ccDiv").removeClass("e-shadow");

                } else {
                    proxy._clearColumnMenu();
                }
            }

            if ($("#" + proxy._id + "_dialogEdit").length > 0 && $("#" + proxy._id + "_dialogEdit").css('display') != 'none') {
                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {
                    $("#" + proxy._id + "_dialogEdit").ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, allowDraggable: false, enableModal: false, isResponsive: false });
                    $("#" + proxy._id + "_dialogEdit_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                    $("#" + proxy._id + "_dialogEdit_wrapper").removeClass("e-shadow").removeClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogEdit").removeClass("e-shadow");
                } else {
                    $("#" + proxy._id + "_dialogEdit").ejDialog({ width: "auto", height: "auto", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true });
                    $("#" + proxy._id + "_dialogEdit_wrapper").addClass("e-shadow").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogEdit").addClass("e-shadow");
                }
            }

            if (proxy._renderedSubMenuType && (proxy._renderedSubMenuType.indexOf("AdaptiveColChooser") == 0 || proxy._renderedSubMenuType.indexOf("ColumnDesktop") == 0)) {
                proxy._clearColumnMenu();
            }
        },

        updateResponsiveMinWidth: function (width) {
            var proxy = this;
            if (parseInt(width) < 150)
                width = 150;

            proxy._responsiveMinWidth = parseInt(width);

            proxy._mediaQueryUpdate();

        },

        //PROCESSBINDING
        processBindings: function (args) {

            var proxy = this,
                model = proxy.model;

            model.query = new ej.Query();

            if (!proxy._isEmptyRow && proxy._trigger("actionBegin", args)) {
                if (args.requestType == "filtering") 
                    $("#" + proxy._id + "_" + args.currentFilteringColumn + "_filterbarcell").val("");               
                return true;
            }

            proxy._ensureDataSource(args);

        },
        //updated the treegrid record collection after record update in Gantt
        setUpdatedRecords: function (flatRecords, updatedRecords, ids, parentRecords, dataSource) {
            var model = this.model;
            model.flatRecords = flatRecords;
            model.updatedRecords = updatedRecords;
            model.ids = ids;
            model.parentRecords = parentRecords;
            this.dataSource(dataSource);
        },
        //In virtualization get expaned records from total record collection only
        getExpandedRecords: function (records) {
            var proxy = this;
            var resultRecord = records.filter(function (record) {
                return proxy.getExpandStatus(record) == true;
            });
            return resultRecord;
        },

        //update the expandStatus of all child records in non-virtualization mode
        updateExpandStatus:function(record , expanded)
        {
            var proxy = this,
                childRecords = record.childRecords;
                for (var count = 0; count < childRecords.length; count++) {
                    childRecords[count].isExpanded = expanded;
                    if (childRecords[count].hasChildRecords && childRecords[count].expanded) {
                        proxy.updateExpandStatus(childRecords[count], expanded);
                    }
                }
        },
        //Expand collapse, sort, delete, filter search the record collections
        _ensureDataSource: function (args) {

            var proxy = this,
                model = proxy.model,
                sortcolumns = model.sortSettings.sortedColumns,
                filteredColumns = model.filterSettings.filteredColumns,
                isupdatedHeight = false,
                index,
                dataSource = this.dataSource(),
                childIndex, ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            proxy._filteredRecords = [];
            proxy._flatFilteredRecords = [];

            model.query.requiresCount();
            proxy._queryManagar = ej.Query();
            proxy._queryManagar.requiresCount();

            if ($.type(dataSource) !== "array" && !(dataSource instanceof ej.DataManager)) {
                this.dataSource([]);
                dataSource = this.dataSource();
            }

            //Expand Collapse Opearation
            if (args && args.requestType === ej.TreeGrid.Actions.ExpandCollapse) {

                isupdatedHeight = true;
                proxy._filteredRecords = [];
                args.data.expanded = args.expanded;               
                if (!ej.isNullOrUndefined(args.data.item[model.expandStateMapping])) {
                    args.data[model.expandStateMapping] = args.expanded;
                    args.data.item[model.expandStateMapping] = args.expanded;
                }
                model.updatedRecords = [];
                proxy._flatFilteredRecords = model.flatRecords;
                proxy._filteredRecords = proxy._flatFilteredRecords.filter(function (record) {
                    return proxy.getExpandStatus(record) == true;
                });
                model.updatedRecords = proxy._filteredRecords;
            }

            // Condition for filtering columns.
            if ((args && args.requestType == "filtering") || (model.allowFiltering && !model.isFromGantt && filteredColumns.length)) {
                //Removed the summary rows before filtering the datasource.
                if (model.showSummaryRow) {
                    model.updatedRecords = proxy._spliceSummaryRows(model.updatedRecords);
                    model.flatRecords = proxy._spliceSummaryRows(model.flatRecords);
                }
                if ((model.allowFiltering && !model.isFromGantt &&filteredColumns.length)) {
                    var predicate, firstFilterCondition =filteredColumns[0];
                    // Condition to collect the details of filtering column.
                    if (firstFilterCondition.value == proxy._dropDownListBlanksText) {
                        predicate = ej.Predicate(firstFilterCondition.field, "equal", null);
                        predicate = predicate["or"](firstFilterCondition.field, "equal", "");
                    }
                    else if (!firstFilterCondition.isComplex)
                        predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, !firstFilterCondition.matchcase);
                    else
                        predicate = firstFilterCondition;
                    if (ej.isNullOrUndefined(args))
                      proxy._storePreviousFilteredValue(firstFilterCondition.field, firstFilterCondition.value, firstFilterCondition.operator);
                    for (var i = 1; i < filteredColumns.length; i++) {
                        //Loop to gather all the column condition as array.
                        if (!filteredColumns[i].isComplex)
                            predicate = predicate[filteredColumns[i].predicate](filteredColumns[i].field,filteredColumns[i].operator,filteredColumns[i].value, !filteredColumns[i].matchcase);
                        else
                            predicate = predicate["and"](filteredColumns[i]);
                        if (ej.isNullOrUndefined(args))
                          proxy._storePreviousFilteredValue(filteredColumns[i].field, filteredColumns[i].value, filteredColumns[i].operator);
                    }
                    proxy._queryManagar.where(predicate);
                    proxy._filteredRecords = model.flatRecords.slice();
                    var dataManager = new ej.DataManager(proxy._filteredRecords);
                    proxy._tempfilteredrecords = dataManager.executeLocal(proxy._queryManagar).result;
                    proxy._updateFilteredRecords(proxy._tempfilteredrecords);
                    model.updatedRecords = proxy._filteredRecords;
                    if (model.allowPaging && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                        model.parentRecords = proxy._getParentRecords(model.updatedRecords, proxy, true);
                    if (model.allowSorting && model.sortSettings.sortedColumns.length > 0) {
                        proxy._sortingRecords();
                    }
                } else {
                    model.updatedRecords = model.enableVirtualization ? proxy.getExpandedRecords(model.flatRecords) : model.flatRecords.slice();
                    proxy._updateHasFilteredChildRecordsStatus(model.updatedRecords);
                    if (model.allowPaging && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                        model.parentRecords = proxy._getParentRecords(model.updatedRecords, proxy, true);
                }
                //// Updating checkbox state of parent records when enableHierarchySelection is true
                if (args && !model.isFromGantt && args.requestType == "filtering" && proxy._checkboxSelection &&
						 model.selectionSettings.enableHierarchySelection) {
                    if (args.requestType == "filtering") {
                        $.each(model.updatedRecords, function (index, record) {
                            if (record.hasChildRecords)
                                proxy._updateParentSelection(record);

                        });
                        proxy.selectAllRows();
                    }
                }

                if (model.showSummaryRow)
                    proxy._createSummaryRow(args);
                if (args) {
                    if (model.showTotalSummary)
                        proxy._updateTotalSummaryRow(args);
                }
                proxy.updateCollapsedRecordCount();
                proxy.updateHeight();
                isupdatedHeight = true;
                if (model.enableAltRow) {
                    proxy.updateAltRow();
                }
            }

            if ((model.allowSearching && proxy._searchString.length) || (args && args.requestType==="searching")) {

                proxy._queryManagar.search(proxy._searchString, proxy.getColumnFieldNames(),
                    ej.FilterOperators.contains, true);

                proxy._filteredRecords = model.flatRecords.filter(function (record) {
                    return record.hasChildRecords === false;
                });
                if (model.isFromGantt) {
                    ganttObject.model.searchSettings = {
                        fields: proxy._getColumnMappingNames(),
                        key: proxy._queryManagar.queries[0].e.searchKey,
                        operator: "contains",
                        ignoreCase: true
                    };  
                }
                var dataManager = new ej.DataManager(proxy._filteredRecords);
                proxy._tempfilteredrecords = dataManager.executeLocal(proxy._queryManagar).result;
                proxy._updateFilteredRecords(proxy._tempfilteredrecords);
                model.updatedRecords = proxy._filteredRecords;

                if (model.allowSorting && model.sortSettings.sortedColumns.length > 0) {
                    proxy._sortingRecords();
                }
                proxy.updateCollapsedRecordCount();
                proxy.updateHeight();
                isupdatedHeight = true;

                if (model.enableAltRow) {

                    proxy.updateAltRow();
                }

                proxy.clearSelection();

            }
            else if (model.allowSorting && sortcolumns.length > 0 || (args && args.requestType == "sorting")) {
                
                proxy._sortingRecords();
                if (model.showSummaryRow)
                    proxy._createSummaryRow(args);
                if (!isupdatedHeight)
                {
                    proxy.updateCollapsedRecordCount();
                    proxy.updateHeight();
                    isupdatedHeight = true;
                }
            }

            if (args && (args.requestType === "outdent" || args.requestType === "indent")) {
                args = {};
                args.requestType = ej.TreeGrid.Actions.Refresh;
                isupdatedHeight = true;
            }
            if (args && model.allowPaging && args.requestType == "delete") {
                var arg = {};
                arg.totalRecordsCount = proxy.getExpandedRecords(model.flatRecords).length;
                //proxy.getPager().ejPager("option", arg).ejPager("refreshPager");
                proxy.getPager().ejPager("option", arg).ejPager("refreshPager");
                var pagerModel = this.getPager().ejPager("model");
                if (proxy._currentPage() > pagerModel.totalPages)
                    proxy._currentPage(pagerModel.totalPages);
                isupdatedHeight = true;                
            }

            if (!isupdatedHeight) {
                proxy._zerothLevelParentRecords = model.parentRecords.slice();
                model.updatedRecords = model.enableVirtualization ? ((model.enableCollapseAll && !args) ? proxy._zerothLevelParentRecords : proxy.getExpandedRecords(model.flatRecords)) : model.flatRecords.slice();
                proxy.updateCollapsedRecordCount();
                proxy.updateHeight();
            }

            if (!args) {
                args = {};
                if (model.allowPaging)
                    args.requestType = ej.TreeGrid.Actions.Paging;
                else
                    args.requestType = ej.TreeGrid.Actions.Refresh;
                args.inital = true;
            }
            

            proxy._updateCurrentViewData();

            if ((!model.isFromGantt && args.requestType === "save") || args.requestType === "sorting" || args.requestType === "searching"
                || args.requestType === "delete" || args.requestType === "refreshDataSource" || args.requestType === "filtering"
                || args.requestType === "dragAndDrop" || ( !args.inital && args.requestType === "paging")) {
				    proxy._isRefreshAddedRecord = false; /* flag new added record is sorted or filtered in treegrid */
                proxy.renderRecords(args);
                proxy._setScrollTop();
                proxy.getScrollElement().ejScroller("refresh");
                proxy._updateScrollCss();
            }
        },
         //Remove parent & children records which available in the data collection 
        _removeChildRecords: function(data, record){
            var proxy = this, model = proxy.model,
                childRecords = ej.isNullOrUndefined(record.childRecords) ? [] : record.childRecords;
            var recordIndex = data.indexOf(record);
            if(recordIndex > -1){
                record.checkboxState = "unchecked";
                data.splice(recordIndex, 1);
            }
            for(var i = 0; i < childRecords.length; i++){                
                if(childRecords[i].hasChildRecords)
                    proxy._removeChildRecords(data, childRecords[i]);
                else{
                    recordIndex = data.indexOf(childRecords[i]);
                    if(recordIndex > -1){
                        childRecords[i].checkboxState = "unchecked";
                        data.splice(recordIndex, 1);
                    }
                }
            }
            if(record.parentItem && model.selectionSettings.enableHierarchySelection){                
                proxy._updateParentSelection(record.parentItem);
            }
        },
        //remove child record in data source on self reference
        _removeChildItem: function (record) {
            var currentRecord, proxy = this, idx;
            for (var i = 0; i < record.childRecords.length; i++) {
                currentRecord = record.childRecords[i];
                if (this.dataSource() instanceof ej.DataManager) {
                    if (this.dataSource().dataSource.offline && this.dataSource().dataSource.json) {
                        idx = this.dataSource().dataSource.json.indexOf(currentRecord.item);
                        if(idx!==-1)
                            this.dataSource().dataSource.json.splice(idx, 1);

                        if (currentRecord.hasChildRecords) {
                            proxy._removeChildItem(currentRecord);
                        }
                    }
                    else if (proxy._isDataManagerUpdate) {
                        idx = proxy._jsonData.indexOf(currentRecord.item);
                        if (idx !== -1)
                            proxy._jsonData.splice(idx, 1);
                        if (currentRecord.hasChildRecords) {
                            proxy._removeChildItem(currentRecord);
                        }
                    }
                } else {
                    idx = this.dataSource().indexOf(currentRecord.item);
                    if (idx !== -1)
                        this.dataSource().splice(idx, 1);

                    if (currentRecord.hasChildRecords) {
                        proxy._removeChildItem(currentRecord);
                    }
                }
            }
        },

        //Update checkbox columnName to change dynamically 
        _updateCheckboxColumnName: function(){
            var proxy = this,
                model = proxy.model;

            // Checkbox column is decide by showCheckbox API or default 
            if (proxy._checkboxSelection) {
                var column = model.columns.filter(function (column) {
                    return column['showCheckbox'] == true;
                });
                proxy._addCheckboxColumn = this._getDefaultCheckboxColumn();
                proxy._checkboxColumnName = column.length > 0 ? column[0].isTemplateColumn ? null : column[0].field : null;
                if (ej.isNullOrUndefined(proxy._checkboxColumnName)) {
                    var treeGridIndexColumn = model.columns[model.treeColumnIndex];
                    if (!model.columns[0].nonColumn) {
                        model.columns.splice(0, 0, proxy._addCheckboxColumn);
                        proxy._checkboxColumnName = proxy._addCheckboxColumn.field;
                    }
                    else
                        proxy._checkboxColumnName = model.columns[0].field;
                    if (treeGridIndexColumn)
                        model.treeColumnIndex = model.columns.indexOf(treeGridIndexColumn);
                }
                if (proxy._frozenColumnsLength > 0 && !model.columns[0]['isFrozen'] &&
                        proxy._checkboxColumnName == proxy._addCheckboxColumn.field) {
                    model.columns[0]['isFrozen'] = true;
                    proxy._frozenColumnsLength += 1;
                    proxy._frozenColumns.splice(0, 0, model.columns[0]);
                    model.scrollSettings.frozenColumns = this._frozenColumnsLength;
                }

            }
        },

        //CHECK EDITING OPTIONS 
        _processEditing:function(){

            var proxy = this,
                model = proxy.model;

            if (proxy._checkboxSelection)
                proxy._updateCheckboxColumnName();

            if (model.editSettings.allowEditing || model.editSettings.allowAdding) {
                if (model.editSettings.editMode.toLowerCase() === "cellediting" || model.editSettings.editMode.toLowerCase() === "rowediting" || (model.editSettings.editMode.toLowerCase() === "normal" && model.selectionSettings.selectionMode.toLowerCase() === "cell")) {
                    proxy._addCellEditTemplate();
                } else if (model.editSettings.editMode.toLowerCase() === "dialogediting" && (ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) || model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                    if ($("#" + this._id + "_dialogEdit").length == 0)
                        this.element.append(this._renderEditDialog());
                } else if (model.editSettings.editMode.toLowerCase() === "dialogediting" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                    if ($("#" + this._id + "_dialogEdit").length == 0)
                        this.element.append(this._renderEditDialog());
                }
            }

        },

        _toolBarClick: function (sender) {

            //Skip the mouse right click and mouse wheel
            if ((sender.event.which && (sender.event.which == 3 || sender.event.which == 2)) ||
                     (sender.event.button && sender.event.button == 2))
                return false;

            var proxy = this,
               model = proxy.model,
               $gridEle = $(this.itemsContainer).closest(".e-treegrid"),
               gridInstance = $gridEle.ejTreeGrid("instance"),
               gridId = $gridEle.attr('id'),
                toolbarObj = $("#" + gridInstance._id + "_toolbarItems");
            
            if (sender.event == undefined && sender.target.tagName == "INPUT" && sender.currentTarget.id == gridId + "_search")
                return false;

            if (gridInstance.model.dateFormat.toLowerCase().indexOf("hh") != -1)
                $.isFunction($.fn.ejDateTimePicker) && $("#" + gridId + "EditForm").find(".e-datepicker").ejDateTimePicker("hide");
            else
                $.isFunction($.fn.ejDatePicker) && $("#" + gridId + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            var currentTarget = sender.currentTarget; var target = sender.target;
            var args = {
                itemName: sender.text,
                currentTarget: currentTarget,
                model: gridInstance.model,
                sender: sender
            };
            if ($gridEle.ejTreeGrid("instance")._trigger("toolbarClick", args))
                return false;
            $(toolbarObj).ejToolbar('deselectItem', sender.currentTarget);
            switch (sender.currentTarget.id) {

                case gridId + "_add":
                    gridInstance._toolbarOperation(gridId + "_add", sender);
                    break;

                case gridId + "_edit":
                    gridInstance._toolbarOperation(gridId + "_edit", sender);
                    break;

                case gridId + "_delete":
                    gridInstance._toolbarOperation(gridId + "_delete", sender);
                    break;

                case gridId + "_update":
                    gridInstance._toolbarOperation(gridId + "_update", sender);
                    break;

                case gridId + "_cancel":
                    gridInstance._toolbarOperation(gridId + "_cancel", sender);
                    break;

                case gridId + "_expandAll":
                    gridInstance._toolbarOperation(gridId + "_expandAll", sender);
                    break;

                case gridId + "_collapseAll":
                    gridInstance._toolbarOperation(gridId + "_collapseAll", sender);
                    break;
                case gridId + "_pdfExport":
                    gridInstance._toolbarOperation(gridId + "_pdfExport",sender);
                    break;
                case gridId + "_excelExport":
                    gridInstance._toolbarOperation(gridId + "_excelExport", sender);
                    break;
            }
            return false;
        },
        _toolbarOperation: function (operation, searchEle) {
            var $gridEle = this.element, gridObject = $gridEle.ejTreeGrid("instance"), gridId = $gridEle.attr('id'), proxy = this;
            var selectedrow = this.selectedItem();
            var parentEle = searchEle.target;
            var index = proxy.model.allowPaging ? this._updatedPageData.indexOf(selectedrow) : this.selectedRowIndex();
            gridObject._exportTo = gridObject["export"];
            switch (operation) {

                case gridId + "_add":
                    if (proxy.model.selectionSettings.selectionMode == "cell") {
                        proxy.model.editSettings.rowPosition = "top";
                    }
                    if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                        proxy._showTreeGridAddEditDialog(-1, "add");
                    } else {
                        proxy._startAdd(parentEle, null);
                    }
                    break;
                    
                case gridId + "_edit":
                    proxy.updateScrollBar();
                    if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                        proxy._showTreeGridAddEditDialog(index);
                    } else {
                        proxy._editRow(index);
                    }
                    break;

                case gridId + "_delete":
                    proxy.deleteRow();
                    proxy._cancelSaveTools();
                    proxy._isRefreshAddedRecord = false;/* flag new added record is sorted or filtered in treegrid */
                    break;

                case gridId + "_update":
                    editMode = proxy.model.editSettings.editMode;
                    if (editMode.toLowerCase() == "cellediting") {                      
                        if (this.editFormValidate()) {
                            if (proxy.model.isEdit)
                                this.saveCell();
                            else if (this._isRowEdit)
                                this.saveRow();
                        }
                    }
                    else if (editMode.toLowerCase() == "rowediting" && this.editFormValidate())
                        proxy.saveRow();
                    proxy._clearContextMenu();
                    this._removeDetailsRow();
                    proxy._focusTreeGridElement();

                    break;

                case gridId + "_cancel":
                    var editMode = proxy.model.editSettings.editMode;
                    if (editMode.toLowerCase() == "cellediting") {
                        if (proxy._isRowEdit)
                            proxy.cancelRowEditCell();
                        else proxy.cancelEditCell();
                    }
                    else if (editMode.toLowerCase() == "rowediting")
                        proxy.cancelRowEditCell();
                    proxy._cancelSaveTools();
                    proxy._clearContextMenu();
                    this._removeDetailsRow();
                    break;

                case gridId + "_expandAll":
                    proxy.expandAll();
                    break;

                case gridId + "_collapseAll":
                    proxy.collapseAll();
                    break;
                case gridId + "_pdfExport":
                    gridObject._exportTo(gridObject.model.exportToPdfAction, 'pdfExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_excelExport":
                    gridObject._exportTo(gridObject.model.exportToExcelAction, 'excelExporting', gridObject.model.allowMultipleExporting);
                    break;
            }
            proxy._refreshToolBar();
            return false;
        },
		 // Perform Tree grid context menu operations.
        contextMenuOperations:function(option){
            var proxy = this,
                model = proxy.model,
                index = proxy._contextMenuSelectedIndex,
                e = proxy._contextMenuEvent,
                fieldName,
                item = proxy._contextMenuSelectedItem;
            switch (option)
            {
                case "Delete":
                    proxy.deleteRow(null,true);
                    proxy._cancelSaveTools();
                    proxy._clearContextMenu();
                    break;
                case "Above":
                    proxy._subContextMenuAction(item, index, "Above");
                    proxy._focusTreeGridElement();
                    break;
                case "Below":
                    proxy._subContextMenuAction(item, index, "Below");
                    proxy._focusTreeGridElement();
                    break;
                case "Add":
                    proxy._setInitialData();
                    proxy._clearContextMenu();
                    break;
                case "Edit":
                    if (model.editSettings.editMode.toLowerCase() == "cellediting") {
                        var column = model.columns[proxy.getCellIndex(e)];
                        if (!ej.isNullOrUndefined(column) && column.allowEditing != false) {
                            proxy._focusTreeGridElement();
                            proxy._cellEditingDetails.columnIndex = proxy.getCellIndex(e);
                            proxy._editedRowIndex = proxy._cellEditingDetails.rowIndex = proxy.getRowIndex(e);
                            fieldName = proxy._cellEditingDetails.columnIndex >= 0 && column.field;
                            if (fieldName) {
                                proxy.updateScrollBar();
                                model.editSettings.allowEditing &&
                                    model.editSettings.editMode == ej.TreeGrid.EditMode.CellEditing &&
                                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, fieldName) && proxy._editAddTools();
                            }
                        }
                    }
                    else if (model.editSettings.editMode.toLowerCase() == "rowediting") {
                        proxy.updateScrollBar();
                        proxy._editRow(index);
                    } else if (proxy.model.editSettings.editMode.toLowerCase() == "dialogediting") {
                        proxy._showTreeGridAddEditDialog(index);
                    }
                    proxy._clearContextMenu();
                    break;
                case "Save":
                    if (model.editSettings.editMode.toLowerCase() == "cellediting") {
                        if (this.editFormValidate()) {
                            if (proxy._isRowEdit)
                                proxy._endEdit();
                            else proxy.saveCell();
                        }
                        else
                            return true;
                    }
                    else if (model.editSettings.editMode.toLowerCase() == "rowediting" && this.editFormValidate())
                        proxy.saveRow();
                    proxy._clearContextMenu();
                    proxy._focusTreeGridElement();
                    break;
                case "Cancel":
                    var editMode = proxy.model.editSettings.editMode;
                    if (editMode.toLowerCase() == "cellediting") {
                        if (proxy._isRowEdit)
                            proxy.cancelRowEditCell();
                        else if (model.isEdit) proxy.cancelEditCell();
                    }
                    else if (editMode.toLowerCase() == "rowediting")
                        proxy.cancelRowEditCell();
                    proxy._clearContextMenu();
                    proxy._focusTreeGridElement();
                    break;
                default:
                    var eventArgs = {};
                    eventArgs.data = item;
                    eventArgs.menuId = option;
                    proxy._triggerMenuEventHandler(option, eventArgs);
                    proxy._clearContextMenu();
                    break;
            }
            if (model.enableAltRow && model.currentViewData[0])
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);            
        },
        //Change the text based on culture information.
        _setCultureInfo: function () {
            var proxy = this,
              model = proxy.model,
              culture = model.locale,
              localization = proxy.localizedLabel, 
              defaultLocalization = ej.TreeGrid.Locale["default"];
            if (!(model.predecessorTable || model.resourceTable))
                localization = ej.TreeGrid.Locale[culture];
            else
                localization = ej.Gantt.Locale[culture];
            //Tooltip Text to be displayed in the Toolbar
            proxy._toolboxTooltipTexts = (localization && localization["toolboxTooltipTexts"])?
                localization["toolboxTooltipTexts"] : defaultLocalization["toolboxTooltipTexts"];

            //Context Menu Text
            proxy._contextMenuTexts = (localization && localization["contextMenuTexts"]) ?
                localization["contextMenuTexts"] : defaultLocalization["contextMenuTexts"];

            if (proxy.model.isFromGantt) {
                proxy._columnMenuTexts = proxy.model.columnMenuTexts;
                proxy._deleteColumnText = proxy.model.deleteColumnText;
                proxy._okButtonText = proxy.model.okButtonText;
                proxy._cancelButtonText = proxy.model.cancelButtonText;
                proxy._columnDialogTexts = proxy.model.columnDialogTexts;
                proxy._columnDialogTitle = proxy.model.columnDialogTitle;
                proxy._confirmDeleteText = proxy.model.confirmDeleteText;
                proxy._editTypeText = proxy.model.editTypeText;
                proxy._textAlignTypeText = proxy.model.textAlignTypeText;
                proxy._clipModeText = proxy.model.clipModeText;
            }
            else {
                //Column Menu Text
                proxy._columnMenuTexts = (localization && localization["columnMenuTexts"]) ?
                    localization["columnMenuTexts"] : defaultLocalization["columnMenuTexts"];
                
                //Add Column Dialog Text to be displayed in popup window
                proxy._columnDialogTexts = (localization && localization["columnDialogTexts"]) ?
                    localization["columnDialogTexts"] : defaultLocalization["columnDialogTexts"];

                //Add Column Dialog Titles
                proxy._columnDialogTitle = (localization && localization["columnDialogTitle"]) ?
                    localization["columnDialogTitle"] : defaultLocalization["columnDialogTitle"];

                //Deleting the column texts 
                proxy._deleteColumnText = (localization && localization["deleteColumnText"]) ?
                    localization["deleteColumnText"] : defaultLocalization["deleteColumnText"];
                proxy._okButtonText = (localization && localization["okButtonText"]) ?
                    localization["okButtonText"] : defaultLocalization["okButtonText"];
                proxy._cancelButtonText = (localization && localization["cancelButtonText"]) ?
                    localization["cancelButtonText"] : defaultLocalization["cancelButtonText"];
                proxy._confirmDeleteText = (localization && localization["confirmDeleteText"]) ?
                    localization["confirmDeleteText"] : defaultLocalization["confirmDeleteText"];

                //edit Types text
                proxy._editTypeText = (localization && localization["editTypeTexts"]) ?
                    localization["editTypeTexts"] : defaultLocalization["editTypeTexts"];

                //Edit types text
                proxy._textAlignTypeText = (localization && localization["textAlignTypes"]) ?
                    localization["textAlignTypes"] : defaultLocalization["textAlignTypes"];

                //Clip mode types text
                proxy._clipModeText = (localization && localization["clipModeTexts"]) ?
                    localization["clipModeTexts"] : defaultLocalization["clipModeTexts"];

                //String to be displayed in drop down list for filtering blank items
                proxy._dropDownListBlanksText = (localization && localization["dropDownListBlanksText"]) ?
                    localization["dropDownListBlanksText"] : defaultLocalization["dropDownListBlanksText"];

                //String to be displayed in drop down list to clear filtered items
                proxy._dropDownListClearText = (localization && localization["dropDownListClearText"]) ?
                    localization["dropDownListClearText"] : defaultLocalization["dropDownListClearText"];

                //Text to be displayed in drop down list for TRUE value in boolean edit type column
                proxy._trueText = (localization && localization["trueText"]) ?
                    localization["trueText"] : defaultLocalization["trueText"];

                //Text to be displayed in drop down list for FALSE value in boolean edit type column
                proxy._falseText = (localization && localization["falseText"]) ?
                    localization["falseText"] : defaultLocalization["falseText"];

                //EmptyRecord text to be displayed with dataSource is null
                proxy.model.emptyRecordText = (localization && localization["emptyRecord"]) ?
                    localization["emptyRecord"] : defaultLocalization["emptyRecord"];

                //Text to be displayed in filter menu
                proxy._filterMenuTexts = (localization && localization["filterMenuTexts"]) ?
                    localization["filterMenuTexts"] : defaultLocalization["filterMenuTexts"];
            }
        },

        //Create the instances for newly added row.
        _createNewRowInstance: function (obj) {
            var keys = [];
            for (var key in obj) {
                keys.push(key);
            }
            return keys;
        },
		
        //Public method to pass a datasource from customer side.

        //REFRESH THE TREEGRIDCONTENT
        

        refresh:function(datasource, query){
            var proxy = this, model = proxy.model;
            if (!ej.isNullOrUndefined(datasource)) {
                proxy.resetModelCollections();
                model.dataSource = datasource;
                model.query = query;
                proxy.element.ejTreeGrid("destroy").ejTreeGrid(model);
            }
            else {
                var args = {};
                args.requestType = ej.TreeGrid.Actions.Refresh;
                this.sendDataRenderingRequest(args);
            }
        },		
        /* get index for new record */
        _getNewIndex: function () {
            var proxy = this;
            proxy._maxRowIndex += 1;
            return (proxy._maxRowIndex);            
        },
        //Add new record in treeGrid control
        _addRecord: function (data, rowPosition, isEdit, isFrom) {
            var proxy = this;

            /*Cancel if treegrid is in edit*/
            if (proxy.model.isEdit || proxy._isRowEdit) {
                proxy.cancelRowEditCell();
            }

            var model = this.model,
                selectedRowIndex = this.selectedRowIndex(),
                //selectedCellIndexes = this.selectedCellIndexes(),
                _cAddedRecord,
                updatedRecords = model.updatedRecords,
                flatRecords = model.flatRecords,
                parentRecords = model.parentRecords,
                selectedItem = model.selectionSettings.selectionMode == "row" ? this.selectedItem() : updatedRecords[proxy._rowIndexOfLastSelectedCell],
                columns = model.columns,
                dataSource = this.dataSource(),
                level = 0, insertIndex, validateArgs = {}, currentPageRowIndex = -1,
                isRecordAdded = false,
                isToolbarAdd = false,
                newIndex = this._getNewIndex(),
                dataChildCount,
                parentItem, nextBelowItemInflatRecords, nextBelowItemInUpdatedRecords,
                isParentItemAdd = false, args = {}, argsLevel, argsParentItem;

            if ($.type(dataSource) !== "array" && !(dataSource instanceof ej.DataManager)) {
                this.dataSource([]);
                dataSource = this.dataSource();
            }
            if (ej.isNullOrUndefined(data)) {
                data = null;
                for (var count = 0; count < columns.length; count++) {
                    data = proxy._restoreCustomData(data, "", columns[count].field);
                }
                isToolbarAdd = true;
            }
            if (model.idMapping && model.parentIdMapping && !ej.isNullOrUndefined(data[proxy.model.parentIdMapping])) {
                var parentRec  = model.flatRecords.filter(function (item) {
                    return item[model.idMapping] == data[model.parentIdMapping];
                });
                if (parentRec.length > 0) {
                    selectedItem = parentRec[0];
                    rowPosition = ej.TreeGrid.RowPosition.Child;
                    isParentItemAdd = true;
                }
            }

            if ((selectedRowIndex === -1 && proxy._rowIndexOfLastSelectedCell == -1) && (rowPosition === ej.TreeGrid.RowPosition.Above
                 || rowPosition === ej.TreeGrid.RowPosition.Below
                 || rowPosition === ej.TreeGrid.RowPosition.Child) || !rowPosition || (model.selectedItems.length > 1 && !proxy._checkboxSelection)) {
                if (!isParentItemAdd)
                    rowPosition = ej.TreeGrid.RowPosition.Top;
            }
            if (rowPosition == ej.TreeGrid.RowPosition.Top || rowPosition == ej.TreeGrid.RowPosition.Bottom)
            {
                argsLevel = 0;
                argsParentItem = null;
            }
            else if (rowPosition == ej.TreeGrid.RowPosition.Above || rowPosition == ej.TreeGrid.RowPosition.Below) {
                argsLevel = selectedItem.level;
                argsParentItem = selectedItem.parentItem;
            }
            else if (rowPosition == ej.TreeGrid.RowPosition.Child) {
                argsLevel = selectedItem.level + 1;
                argsParentItem = selectedItem;
            }
            args.requestType = "add";
            args.data = data;
            args.level = argsLevel;
            args.rowPosition = rowPosition;
            args.parentItem = argsParentItem;
            if (!proxy._trigger("actionBegin", args)) {
                data = args.data;

                if (rowPosition != args.rowPosition)
                    rowPosition = args.rowPosition;

                if (data[model.childMapping] && data[model.childMapping].length)
                    delete data[model.childMapping]; // Remove the child items for externally adding row

                //Clear previously selected Item
                //proxy.clearSelection()
                proxy.selectRows(-1);

                switch (rowPosition) {
                    case ej.TreeGrid.RowPosition.Top:
                        level = 0;
                        parentItem = null;
                        _cAddedRecord = proxy._createRecord(data, level);
                        _cAddedRecord.index = newIndex;

                        if (model.idMapping && model.parentIdMapping && !proxy._isPublicAdd) {
                            _cAddedRecord[model.idMapping] = newIndex;
                            _cAddedRecord.item[model.idMapping] = newIndex;
                        }
                        /*record update*/
                        flatRecords.splice(0, 0, _cAddedRecord);
                        updatedRecords.splice(0, 0, _cAddedRecord);
                        parentRecords.splice(0, 0, _cAddedRecord);

                        /*data source update*/
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.splice(0, 0, _cAddedRecord.item);
                        } else {
                            dataSource.splice(0, 0, _cAddedRecord.item);
                        }
                        insertIndex = 0;
                        break;

                    case ej.TreeGrid.RowPosition.Bottom:
                        level = 0;
                        parentItem = null;
                        _cAddedRecord = proxy._createRecord(data, level);
                        _cAddedRecord.index = newIndex;
                        if (model.idMapping && model.parentIdMapping && !proxy._isPublicAdd) {
                            _cAddedRecord[model.idMapping] = newIndex;
                            _cAddedRecord.item[model.idMapping] = newIndex;
                        }
                        /*record update*/
                        flatRecords.push(_cAddedRecord);
                        updatedRecords.push(_cAddedRecord);
                        //ids.push(newIndex);
                        parentRecords.push(_cAddedRecord);
                        /*data source update*/
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.push(_cAddedRecord.item);
                        } else {
                            dataSource.push(_cAddedRecord.item);
                        }
                        insertIndex = updatedRecords.indexOf(_cAddedRecord);
                        break;

                    case ej.TreeGrid.RowPosition.Above:
                        level = selectedItem.level;
                        parentItem = selectedItem.parentItem;
                        _cAddedRecord = proxy._createRecord(data, level, parentItem);
                        _cAddedRecord.index = newIndex;
                        if (model.idMapping && model.parentIdMapping && !proxy._isPublicAdd) {
                            _cAddedRecord[model.idMapping] = newIndex;
                            _cAddedRecord.item[model.idMapping] = newIndex;
                        }

                        var childIndex, recordIndex, updatedCollectionIndex;
                        /*Record Updates*/
                        recordIndex = flatRecords.indexOf(selectedItem);
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem);
                        flatRecords.splice(recordIndex, 0, _cAddedRecord);
                        updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        //ids.splice(recordIndex, 0, newIndex);

                        if (!ej.isNullOrUndefined(parentItem)) {
                            childIndex = parentItem.childRecords.indexOf(selectedItem);
                            /*Child collection update*/
                            parentItem.childRecords.splice(childIndex, 0, _cAddedRecord);
                            if (!model.parentIdMapping) {
                                parentItem.item[model.childMapping].splice(childIndex, 0, _cAddedRecord.item);
                            }
                            else {
                                _cAddedRecord.item[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                _cAddedRecord[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                if (proxy._isDataManagerUpdate) {
                                    proxy._jsonData.push(_cAddedRecord.item);

                                } else {
                                    dataSource.push(_cAddedRecord.item);
                                }
                            }
                        } else {
                            /* Parent records collection and data source update*/
                            parentRecords.splice(parentRecords.indexOf(selectedItem), 0, _cAddedRecord);
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                            }
                            else {
                                dataSource.splice(dataSource.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                            }
                        }
                        insertIndex = updatedCollectionIndex;
                        break;
                    case ej.TreeGrid.RowPosition.Below:
                        level = selectedItem.level;
                        parentItem = selectedItem.parentItem;
                        _cAddedRecord = proxy._createRecord(data, level, parentItem);
                        _cAddedRecord.index = newIndex;
                        if (model.idMapping && model.parentIdMapping && !proxy._isPublicAdd) {
                            _cAddedRecord[model.idMapping] = newIndex;
                            _cAddedRecord.item[model.idMapping] = newIndex;
                        }
                        //find next item position
                        var currentItemIndex = flatRecords.indexOf(selectedItem);

                        if (selectedItem.hasChildRecords) {
                            dataChildCount = proxy.getChildCount(selectedItem, 0);
                            recordIndex = currentItemIndex + dataChildCount + 1;
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1;

                        } else {
                            recordIndex = currentItemIndex + 1;
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                        }

                        /* Record collection update */
                        flatRecords.splice(recordIndex, 0, _cAddedRecord);
                        updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        //ids.splice(recordIndex, 0, newIndex);

                        /* data Source update */
                        if (!ej.isNullOrUndefined(parentItem)) {
                            childIndex = parentItem.childRecords.indexOf(selectedItem);
                            /*Child collection update*/
                            parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                            if (!model.parentIdMapping) {
                                parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                            }
                            else {
                                _cAddedRecord.item[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                _cAddedRecord[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                if (proxy._isDataManagerUpdate) {
                                    proxy._jsonData.push(_cAddedRecord.item);

                                } else {
                                    dataSource.push(_cAddedRecord.item);
                                }
                            }
                        } else {
                            /* Parent records collection and data source update*/
                            parentRecords.splice(parentRecords.indexOf(selectedItem) + 1, 0, _cAddedRecord);
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                            }
                            else {
                                dataSource.splice(dataSource.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                            }
                        }
                        insertIndex = updatedCollectionIndex;
                        break;
                    case ej.TreeGrid.RowPosition.Child:
                        level = selectedItem.level + 1;
                        parentItem = selectedItem;
                        _cAddedRecord = proxy._createRecord(data, level, parentItem);
                        _cAddedRecord.index = newIndex;
                        if (model.idMapping && model.parentIdMapping && !proxy._isPublicAdd) {
                            _cAddedRecord[model.idMapping] = newIndex;
                            _cAddedRecord.item[model.idMapping] = newIndex;
                        }
                        //find next item position
                        var currentItemIndex = flatRecords.indexOf(selectedItem);

                        if (selectedItem.hasChildRecords) {
                            dataChildCount = proxy.getChildCount(selectedItem, 0);
                            recordIndex = currentItemIndex + dataChildCount + 1;
                            //Expand Add record's parent item 
                            if (!selectedItem.expanded || !proxy.getExpandStatus(selectedItem)) {
                                var expanargs = {};
                                expanargs.expanded = true;
                                expanargs.data = selectedItem;
                                proxy._isInAdd = true;
                                /* refresh Added row on expand collapse */
                                if (proxy._isRefreshAddedRecord) {
                                    expanargs.data.expanded = true;
                                    proxy.updateExpandStatus(args.data, args.expanded);
                                    proxy.refreshContent();
                                    proxy._isRefreshAddedRecord = false;
                                } else {
                                    proxy._expandRecord(selectedItem);
                                }
                                proxy._isInAdd = false;
                                updatedRecords = proxy.getUpdatedRecords();
                            }
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1 - model.summaryRows.length;

                        } else {
                            if (!proxy.getExpandStatus(selectedItem))
                                proxy._expandRecord(selectedItem.parentItem);
                            updatedRecords = proxy.getUpdatedRecords();
                            selectedItem.hasChildRecords = true;
                            selectedItem.childRecords = [];
                            selectedItem.expanded = true;
                            if (!model.parentIdMapping) {
                                selectedItem.item[model.childMapping] = [];
                            }
                            selectedItem.isMilestone = false;
                            recordIndex = currentItemIndex + 1;
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                        }

                        /* Record collection update */
                        flatRecords.splice(recordIndex, 0, _cAddedRecord);
                        updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        //ids.splice(recordIndex, 0, newIndex);

                        /* data Source update */
                        if (!ej.isNullOrUndefined(parentItem)) {
                            childIndex = parentItem.childRecords.indexOf(selectedItem);
                            /*Child collection update*/
                            parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                            if (!model.parentIdMapping) {
                                parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                            }
                            else {
                                _cAddedRecord.item[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                _cAddedRecord[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                if (proxy._isDataManagerUpdate) {
                                    proxy._jsonData.push(_cAddedRecord.item);
                                } else {
                                    dataSource.push(_cAddedRecord.item);
                                }
                            }
                        }
                        insertIndex = updatedCollectionIndex;
                        break;
                }
                if (model.allowPaging) {
                    //Goto next page if New record insertIndex exit than pagesize
                    if (rowPosition == ej.TreeGrid.RowPosition.Below || rowPosition == ej.TreeGrid.RowPosition.Child) {
                        if ((model.pageSettings.pageSizeMode !== "root" || ej.isNullOrUndefined(selectedItem.parentItem))) {
                            var targetData = proxy._updatedPageData[proxy._updatedPageData.length - 1],
                                currentIndex = proxy._updatedPageData.length == model.pageSettings.pageSize ?
                                model.updatedRecords.indexOf(targetData) : insertIndex;
                            if (insertIndex > currentIndex) {
                                proxy._currentPage(this._currentPage() + 1);
                                currentPageRowIndex = 0;
                            }
                        }
                    }
                        //Goto first page
                    else if (rowPosition == ej.TreeGrid.RowPosition.Top && (proxy._currentPage() > 1 || proxy._currentPage() < 1)) {
                        proxy._currentPage(1);
                        currentPageRowIndex = 0;
                    }
                        //Goto last page
                    else if (rowPosition == ej.TreeGrid.RowPosition.Bottom && proxy._currentPage() < model.pageSettings.totalPages) {
                        proxy._currentPage(model.pageSettings.totalPages);
                        currentPageRowIndex = insertIndex;
                    }

                }
                if (!isToolbarAdd && (ej.TreeGrid.RowPosition.Above || ej.TreeGrid.RowPosition.Below)) {
                    var args = {},
                        currentValue = {},
                        columns = model.columns,
                        length = columns.length;
                    if (!model.allowPaging)
                        currentPageRowIndex = insertIndex;
                    args.rowIndex = insertIndex;
                    args.requestType = "addNewRow";
                    args.addedRow = data;

                    if (!proxy._trigger("actionComplete", args)) {
                        proxy._renderAddedRow(insertIndex, _cAddedRecord);
                        if (model.showSummaryRow) {
                            if (args.requestType == "addNewRow" && rowPosition == "child") {
                                proxy._createAndRenderSummaryRecords(args);
                            }
                            proxy._updateSummaryRow(args);
                        }
                        if (model.showTotalSummary)
                            proxy._updateTotalSummaryRow(args);
                        isRecordAdded = true;
                    }
                    else {
                        updatedRecords.splice(insertIndex, 1);
                    }
                }
                else {
                    proxy._renderAddedRow(insertIndex, _cAddedRecord);
                    isRecordAdded = true;
                }

                /*Set flag for refresh newly added record in non virtalization mode*/
                if (model.enableVirtualization === false &&
                    (model.sortSettings.sortedColumns.length > 0 || model.filterSettings.filteredColumns.length > 0)) {
                    proxy._isRefreshAddedRecord = true;
                }
                if (model.allowPaging)
                    updatedRecords = proxy._updatedPageData;
                /* select add row */
                var currentRowIndex = isRecordAdded ? updatedRecords.indexOf(_cAddedRecord) : selectedRowIndex;
                
                if (model.allowSelection && model.selectionSettings.selectionMode == "row") {
                    
                    if (!proxy._rowSelectingEventTrigger(this._previousIndex, currentRowIndex)) {  
						proxy.selectRows(currentRowIndex);					
                        if (model.selectionSettings.enableSelectAll)
                            proxy.selectAllRows();
                        if (proxy._checkboxSelection && model.selectionSettings.enableHierarchySelection && _cAddedRecord.parentItem)
                            proxy._updateParentSelection(_cAddedRecord.parentItem);
                        proxy._rowSelectedEventTrigger(currentRowIndex);
                    }
                }
                if (model.selectionSettings.selectionMode == "cell")
                    proxy._rowIndexOfLastSelectedCell = updatedRecords.indexOf(_cAddedRecord);
                /* scroll to new added record */
                proxy.updateScrollBar();

                if (isEdit == "isEditRow") {
                    proxy._editRow(updatedRecords.indexOf(_cAddedRecord), _cAddedRecord);
                }
                else {
                    ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(_cAddedRecord));
                    proxy._cancelSaveTools();
                    if (model.enableAltRow)
                        ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);
                }
                //refresh parent item for expand collapse icons
                if (_cAddedRecord.parentItem && rowPosition == ej.TreeGrid.RowPosition.Child && (_cAddedRecord.parentItem.childRecords.length == 1 || !_cAddedRecord.parentItem.hasFilteredChildRecords)) {
                    _cAddedRecord.parentItem.hasFilteredChildRecords = true;
                    ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(_cAddedRecord.parentItem));
                }
            } else {
                if (isFrom == "dialog")
                    return true;
            }
        },

        //validate the taskId to avoid duplicate value
        _validateIdValue: function (dataID) {
            var proxy = this, model = proxy.model,
                matchedItem = [],
                fRecords = model.flatRecords;
            matchedItem = $.map(fRecords, function (record) {
                if (record[model.idMapping] == dataID)
                    return record;
            });
            if (matchedItem.length)
                return true;
            else return false;
        },         
         
        // Method to trigger the actionbegin event while close the Add/Edit dialog
        _closeTreegridAddEditDialog: function (args, type) {
            var proxy = this;
            var eventArgs = {};
            if (proxy._isTreeAddEditDialogSave)
                proxy._isTreeAddEditDialogSave = false;
            else {
                if (type === "Add")
                    eventArgs.requestType = "closeAddDialog";
                else
                    eventArgs.requestType = "closeEditDialog";
                return proxy._trigger("actionBegin", eventArgs);
            }
        },

        // Public method to show the Add dialog/Add template dialog
        showAddDialog: function () {
            var proxy = this;
            if (proxy.model.editSettings.allowAdding && proxy.model.editSettings.editMode == "dialogEditing")
                proxy._showTreeGridAddEditDialog(null, "add");
        },

        // Public method to show the Edit dialog/Edit template dialog
        showEditDialog: function (index) {
            var proxy = this;
            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing")
                proxy._showTreeGridAddEditDialog(index);
        },

        // Method to open/show the ADD/EDIT dialog from all possible ways (double/single click edit, toolbar click, public method, context menu)
        _showTreeGridAddEditDialog: function (index, addrow) {
            var temp = document.createElement('div'), proxy = this,
            $temp = $(temp), controlPosition = proxy.getOffsetRect($("#" + proxy._id)[0]),
            currentData = [], columns = proxy.model.columns, contextMenuLabel = proxy._contextMenuTexts;
            if ((ej.isNullOrUndefined(index) || index == -1) && !addrow) {
                if (proxy.model.selectionSettings.selectionMode == "cell")
                    index = proxy.selectedCellIndexes()[0].rowIndex;
                else
                    index = proxy.selectedRowIndex();
            }
            currentData[0] = proxy.model.allowPaging ? this._updatedPageData[index] : proxy.model.updatedRecords[index];
            if (addrow && addrow.toLowerCase() === "add") {
                if (ej.isNullOrUndefined(currentData[0])) {
                    currentData[0] = null;
                    for (var count = 0; count < columns.length; count++) {
                        currentData[0] = proxy._restoreCustomData(currentData[0], "", columns[count].field);
                    }
                }
                $temp.addClass("e-dialogaddrow");
            } else {
                $temp.addClass("e-dialogeditedrow");
            }
            if (ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) || proxy.model.editSettings.dialogEditorTemplateID == "")
                temp.innerHTML = $.render[this._id + "_JSONDialogEditingTemplate"](currentData);
            else if (!ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) && proxy.model.editSettings.dialogEditorTemplateID != "")
                temp.innerHTML = $.render[this._id + "_JSONdialogTemplateMode"](currentData);

            if (this.model.editSettings.editMode == "dialogEditing") {
                $("#" + this._id + "_dialogEdit").html($(temp));
                var model = {};
                model.cssClass = this.model.cssClass;
                model.enableRTL = false;
                model.enableResize = false;
                model.showOnInit = false;
                model.content = "#" + this._id;
                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {
                    model.width = $("#" + proxy._id).width() + "px";
                    model.height = $("#" + proxy._id).height() + "px";
                    model.enableModal = false;
                    model.isResponsive = false;
                    model.allowDraggable = false;
                } else {
                    model.width = "auto";
                    model.height = "auto";
                    model.enableModal = true;
                    model.isResponsive = false;
                    model.allowDraggable = true;
                }
                model.allowKeyboardNavigation = false;
                if (addrow && addrow.toLowerCase() === "add") {
                    model.title = contextMenuLabel["addRowText"];
                    model.beforeClose = function (args) {
                        if (proxy._closeTreegridAddEditDialog(args, "Add"))
                            args.cancel = true; // Cancel the add dialog box close.
                    };
                }
                else {
                    model.title = contextMenuLabel["editText"];
                    model.beforeClose = function (args) {
                        if (proxy._closeTreegridAddEditDialog(args, "Edit"))
                            args.cancel = true; // Cancel the add dialog box close.
                    };
                }
                $("#" + this._id + "_dialogEdit").ejDialog(model);
                var dialogArgs = {};
                dialogArgs.data = currentData[0];
                if (addrow && addrow.toLowerCase() === "add") {
                    dialogArgs.requestType = "beforeOpenAddDialog";
                    dialogArgs.rowPosition = proxy.model.editSettings.rowPosition;
                }
                else
                    dialogArgs.requestType = "beforeOpenEditDialog";
                dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                if (!proxy._trigger("actionBegin", dialogArgs)) {
                    var args = {};
                    args.columnIndex = index;
                    args.data = dialogArgs.data;
                    args.requestType = "beginEdit";
                    proxy._refreshEditForm(args);
                    dialogArgs.data = args.data;
                    if (addrow && addrow.toLowerCase() === "add")
                        dialogArgs.requestType = "openAddDialog";
                    else
                        dialogArgs.requestType = "openEditDialog";
                    dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                    if (!proxy._trigger("actionBegin", dialogArgs)) {
                        $("#" + this._id + "_dialogEdit").ejDialog("open");
                        proxy._currentEditRecordDialogIndex = index;
                        if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {
                            $("#" + proxy._id + "_dialogEdit_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                            $("#" + proxy._id + "_dialogEdit_wrapper").removeClass("e-shadow").removeClass("e-treegridadaptivedialog");
                            $("#" + proxy._id + "_dialogEdit").removeClass("e-shadow");
                        } else {
                            $("#" + proxy._id + "_dialogEdit_wrapper").addClass("e-shadow").addClass("e-treegridadaptivedialog");
                            $("#" + proxy._id + "_dialogEdit").addClass("e-shadow");
                        }
                        this._on($("#" + this._id + "_dialogEdit"),
                       "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                        $("#" + proxy._id + "_dialogEdit").ejDialog("refresh");
                    }
                }
            }
            if ($.isFunction($.validator)) {
                proxy._initValidator();
                proxy.setValidation();
            }
        },

        //Public method for adding new record
        addRow: function (data, rowPosition) {
            var proxy = this, model = proxy.model;
            /* Cancel edited cell before sort the column*/
            proxy._cancelEditState();

            if (!data) {
                proxy._addRecord(null, rowPosition, "isEditRow");
            } else {
                if (model.idMapping && model.parentIdMapping) {
                    if (data[model.idMapping] && !proxy._validateIdValue(data[model.idMapping])) {
                        proxy._isPublicAdd = true;
                        proxy._addRecord(data, rowPosition);
                        proxy._isPublicAdd = false;
                    }
                    else return false;
                }
                else proxy._addRecord(data, rowPosition);
            } 
        },

        _startAdd: function (parentEle, rowPos) {
            var proxy = this, model = this.model, rowPosition;
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }
            proxy._addRecord(null, model.editSettings.rowPosition, "isEditRow");
        },
        _getRecordIndexByItem: function (item, collection) {
            var record = ej.DataManager(collection).executeLocal(ej.Query().where("item", ej.FilterOperators.equal, item));
            if (record.length > 0)
                return collection.indexOf(record[0]);
            else
                return -1;
        },
        /* update the reord's expand status in expanded state*/
        _expandRecord: function (record)
        {
            var parentItem = record, args = {};
            while (parentItem != null) {
                if (parentItem.expanded == false) {
                    args.expanded = true;
                    args.data = parentItem;
                    if (!parentItem.parentItem)
                        this._isInExpandCollapseAll = false;
                    else
                        this._isInExpandCollapseAll = true;
                    ej.TreeGrid.sendExpandCollapseRequest(this, args);
                }
                parentItem = parentItem.parentItem;
            }
        },

        /* Public method for scroll to the corresponding offset value */
        scrollOffset: function (left, top) {
            var scrollerObj = this._$gridContent.data("ejScroller"),
                model = this.model;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            if ((typeof top == "number" || typeof parseInt(top) == "number")) {
                top = parseInt(top);
                if(top >= 0 && this.getMaxScrollHeight() > top)
                    scrollerObj.scrollY(top, true);
            }
            if (typeof left == "number" || typeof parseInt(left) == "number") {
                left = parseInt(left);
                if (left >= 0 && this.getMaxScrollWidth() > left)
                    scrollerObj.scrollX(left, true);
            } 
        },
        /* Public method for get scrollTop value*/
        getScrollTopOffset: function () {
            return this.getScrollElement().ejScroller("model.scrollTop");
        },
        /* Public method for get scrollLeft value*/
        getScrollLeftOffset: function () {
            return this.getScrollElement().ejScroller("model.scrollLeft");
        },
        /* Public method for scroll to first row of treegrid*/
        scrollToTop:function()
        {
            var model = this.model,
                updatedRecords = this.getUpdatedRecords(), record, rowIndex = -1;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            updatedRecords = model.allowPaging ? updatedRecords : this.getExpandedRecords(model.updatedRecords);
            if (updatedRecords.length > 0) {
                rowIndex = 0;
                record = updatedRecords[0];
                rowIndex = updatedRecords.indexOf(record);
                if (model.allowSelection && !this._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex)) {
                    this.selectRows(rowIndex);
                    this._rowSelectedEventTrigger(rowIndex);
                }
                this.updateScrollBar(rowIndex);
            }
        },
        /* Public method for scroll to last row of treegrid*/
        scrollToBottom: function ()
        {
            var model = this.model,
                updatedRecords, record, rowIndex = -1;

            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            updatedRecords = this.getExpandedRecords(model.updatedRecords);

            if (updatedRecords.length > 0) {
                rowIndex = updatedRecords.length - 1;
                record = updatedRecords[rowIndex];
                rowIndex = model.updatedRecords.indexOf(record);
                if (model.allowSelection && !this._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex)) {
                    this.selectRows(rowIndex);
                    this._rowSelectedEventTrigger(rowIndex);
                }
                this.updateScrollBar(rowIndex);
            }
        },

        //ENABLE AND DISABLE THE CORRESPONDING TOOLS WHILE ADDING AND EDITING THE ROW RECORD.
        _editAddTools: function () {
            var proxy = this, model = proxy.model;
            var toolbar = $("#" + proxy._id + "_toolbarItems");
            var editSettings = proxy.model.editSettings,
            toolbarItems = model.toolbarSettings.toolbarItems;
            var disableToolItems = [];
            if (editSettings.allowAdding && toolbarItems.indexOf("add") !== -1 && !$(toolbar).find(".e-addnew").parent("li").hasClass("e-disable"))
                disableToolItems.push($(toolbar).find(".e-addnew").parent()[0]);
            if (editSettings.allowEditing && toolbarItems.indexOf("edit") !== -1 && !$(toolbar).find(".e-edit").parent("li").hasClass("e-disable"))
                disableToolItems.push($(toolbar).find(".e-edit").parent()[0]);
            if (editSettings.allowDeleting && toolbarItems.indexOf("delete") !== -1 && !$(toolbar).find(".e-delete").parent("li").hasClass("e-disable") && model.editSettings.beginEditAction != "click")
                disableToolItems.push($(toolbar).find(".e-delete").parent()[0]);
            disableToolItems.forEach(function (element) {
                $(toolbar).ejToolbar('disableItem', element);
            });

            var enabledToolItems = [];
            if (toolbarItems.indexOf("cancel") !== -1)
                enabledToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
            if (toolbarItems.indexOf("update") !== -1)
                enabledToolItems.push($(toolbar).find(".e-save").parent()[0]);
            enabledToolItems.forEach(function (element) {
                $(toolbar).ejToolbar('enableItem', element);
            });

        },
        //ENABLE AND DISABLE THE CORRESPONDING TOOLS WHILE CANCEL AND SAVING THE ROW RECORD.
        _cancelSaveTools: function () {
            var proxy = this,
                model = proxy.model,
                editSettings = proxy.model.editSettings,
                toolbar = $("#" + proxy._id + "_toolbarItems"),
                parentRecords = [],
                enabledToolItems,
                disableToolItems,
                toolbarItems = model.toolbarSettings.toolbarItems;
            if (!model.isFromGantt) {
                enabledToolItems = [];
                disableToolItems = [];
                if (editSettings.allowAdding) {
                    if (toolbarItems.indexOf("add") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-addnew").parent()[0]);
                } else {
                    disableToolItems.push($(toolbar).find(".e-addnew").parent()[0]);
                }

                if (editSettings.allowEditing && toolbarItems.indexOf("edit") !== -1) {
                    if (proxy.selectedRowIndex() != -1 && model.allowSelection && (model.selectedItems.length == 1 || proxy._checkboxSelection)  && editSettings.beginEditAction != "click")
                        enabledToolItems.push($(toolbar).find(".e-edit").parent()[0]);
                    else if (!$(toolbar).find(".e-edit").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-edit").parent()[0]);
                } else {
                    disableToolItems.push($(toolbar).find(".e-edit").parent()[0]);
                }
                if (editSettings.allowDeleting && toolbarItems.indexOf("delete") !== -1) {
                    if (proxy.selectedRowIndex() != -1 && model.allowSelection && model.selectedItems.length > 0)
                        enabledToolItems.push($(toolbar).find(".e-delete").parent()[0]);
                    else if (!$(toolbar).find(".e-delete").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-delete").parent()[0]);
                } else {
                    disableToolItems.push($(toolbar).find(".e-delete").parent()[0]);
                }

                parentRecords = proxy._getParentRecords(model.updatedRecords, proxy);

                if (parentRecords.length <= 0) {
                    if (toolbarItems.indexOf("expandAll") !== -1 && !$(toolbar).find(".e-expandall").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-expandall").parent()[0]);
                    if (toolbarItems.indexOf("collapseAll") !== -1 && !$(toolbar).find(".e-collapseall").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-collapseall").parent()[0]);
                }
                else {
                    if (toolbarItems.indexOf("expandAll") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-expandall").parent()[0]);
                    if (toolbarItems.indexOf("collapseAll") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-collapseall").parent()[0]);
                }
                if (editSettings.beginEditAction != "click" || (editSettings.beginEditAction == "click" && !model.isEdit)) {
                    if (toolbarItems.indexOf("cancel") !== -1 && !$(toolbar).find(".e-cancel").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
                    if (toolbarItems.indexOf("update") !== -1 && !$(toolbar).find(".e-save").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-save").parent()[0]);
                }

                disableToolItems.forEach(function (element) {
                    $(toolbar).ejToolbar('disableItem', element);
                });
                enabledToolItems.forEach(function (element) {
                    $(toolbar).ejToolbar('enableItem', element);
                });
            }
            else {
                var toolbar = $("#" + proxy._id.replace("ejTreeGrid", "") + "_toolbarItems");
                var enabledToolItems = [],disableToolItems = [];
                if (model.readOnly == true) {
                    disableToolItems = [];
                    disableToolItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                }
                else {
                    if (editSettings.allowAdding && toolbarItems.indexOf("add") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-addnewitem").parent()[0]);

                    if (editSettings.allowEditing && toolbarItems.indexOf("edit") !== -1 && model.allowSelection && editSettings.beginEditAction != "click") {
                        if (proxy.selectedRowIndex() != -1)
                            enabledToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                        else
                            disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    }
                    if (editSettings.allowDeleting && toolbarItems.indexOf("delete") !== -1 && model.allowSelection) {
                        if (proxy.selectedRowIndex() != -1)
                            enabledToolItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                        else
                            disableToolItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    }
                    if (editSettings.allowIndent && (toolbarItems.indexOf("indent") !== -1 || toolbarItems.indexOf("outdent") !== -1) && model.allowSelection) {
                        if (proxy.selectedRowIndex() == -1) {
                            disableToolItems.push($(toolbar).find(".e-indent").parent()[0]);
                            disableToolItems.push($(toolbar).find(".e-outdent").parent()[0]);
                        }
                    }
                    $(toolbar).ejToolbar('enableItem', enabledToolItems);

                  
                    if (toolbarItems.indexOf("cancel") !== -1)
                        disableToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
                    if (toolbarItems.indexOf("update") !== -1)
                        disableToolItems.push($(toolbar).find(".e-saveitem").parent()[0]);
                }
                disableToolItems.forEach(function (element) {
                    $(toolbar).ejToolbar('disableItem', element);

                });
            }
        },

        
        _checkIsEmptyRow: function (item) {
            var column = this.model.columns,
                itemIndex;
                    for (itemIndex = 0; itemIndex < column.length ; itemIndex++) {
                        var value = this._getCustomCellValue(item, column[itemIndex].field);
                        if (value === " " || value === null || value === "" || value === false)
                            continue;
                        return false;
                    }
            return true;
        },
              
        _beginEdit: function () {
            var proxy = this, args = {};
            proxy._trigger("beginEdit", args);
            proxy._isinBeginEdit = true;           
        },

        _endEdit: function () {
            var proxy = this;

            proxy._isinBeginEdit = false;
            var index = this.selectedRowIndex();
            var tr = ej.TreeGrid.getRowByIndex(proxy, index);
            if (this.editFormValidate()) {
                if ($('tr').hasClass("e-addedrow") || $('tr').hasClass("e-rowedit"))
                    proxy.saveRow();
                else
                    proxy.saveCell();
            }
            else
                return true;

        },
        //Refresh the treegrid content after expandAll or collapseAll
        _refreshTreeGridOnExpandCollapseAll:function(args)
        {
            var proxy = this,
                model = this.model;
            if (model.enableVirtualization) {
                if (model.enableAltRow)
                    proxy.updateAltRow();
                proxy.sendDataRenderingRequest(args);
                proxy._setScrollTop();
                proxy.updateHeight();
            }             
            else {
                if (model.allowPaging) {
                    var arg = {},
                        pagerModel;
                    arg.totalRecordsCount = this.getExpandedRecords(model.updatedRecords).length;
                    proxy.getPager().ejPager("option", arg).ejPager("refreshPager");
                    pagerModel = this.getPager().ejPager("model");
                    proxy._currentPage(pagerModel.currentPage);
                    arg.requestType = "paging";
                    proxy.processBindings(arg);
                }
                //If need refresh chart if record is added after searching or sorting
                if (proxy._isRefreshAddedRecord) {
                    proxy.processBindings();
                    this.renderRecords();
                    proxy._isRefreshAddedRecord = false;
                    return;
                }
                proxy.updateHeight();
                if (model.enableAltRow && model.currentViewData.length > 0)
                    ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);
            }
        },
        //expand or collapse all inner level child records on expandAll or collapseAll
        _expandCollapseInnerLevelRecord: function (record, expanded) {
            var proxy = this,
                length = record.childRecords.length,
                tempArgs = {};

            for (var count = 0; count < length; count++) {
                if (record.childRecords[count].hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(record.childRecords[count], expanded);
                    tempArgs.data = record.childRecords[count];
                    tempArgs.expanded = expanded;
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, tempArgs);
                }
            }
        },
        _expandParentLevelRecord: function (record, expanded) {
            var proxy = this,               
                tempArgs = {};
            var parentExpandState = proxy.getExpandStatus(record);
            if (!record.expanded || !parentExpandState) {
                tempArgs.data = record;
                tempArgs.expanded = expanded;
                ej.TreeGrid.sendExpandCollapseRequest(proxy, tempArgs);
                if (tempArgs.data.parentItem) {
                    proxy._expandParentLevelRecord(tempArgs.data.parentItem, expanded);
                }
            }
        },
        // expand the specified level record
        expandAtLevel: function (index) {
            var proxy = this, args = {}, treegridRecord,
                parentRecords = proxy._getParentRecords(proxy.model.updatedRecords, proxy);
            for (var count = 0; count < parentRecords.length; count++) {
                treegridRecord = parentRecords[count];
                if (treegridRecord.level == index) {
                    args.data = treegridRecord;
                    args.expanded = true;
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    // expand its parent if it is collapsed.
                    if (treegridRecord.parentItem) {
                        proxy._expandParentLevelRecord(treegridRecord.parentItem, args.expanded);
                    }
                    
                }
            }
        },
        // collapse the specified level record
        collapseAtLevel: function (index) {
            var proxy = this, args = {},
                model = proxy.model,
                treegridRecord,
                parentRecords = proxy._getParentRecords(model.updatedRecords, proxy);
            for (var count = 0; count < parentRecords.length; count++) {
                treegridRecord = parentRecords[count];                
                if (treegridRecord.level == index && treegridRecord.expanded) {
                    var parentExpandState = proxy.getExpandStatus(treegridRecord);
                    if (parentExpandState) {
                        args.data = treegridRecord;
                        args.expanded = false;
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }
            }
        },

        // expand/collapse the specified record using its index
        expandCollapseRow: function (index) {
            var proxy = this, args = {}, treegridRecord;
            index = parseInt(index);
            if (proxy.model.updatedRecords.length > index && index >= 0) {
                treegridRecord = proxy.model.updatedRecords[index];
                if (treegridRecord.hasChildRecords) {
                    args.data = treegridRecord;
                    if (treegridRecord.expanded)
                        args.expanded = false;
                    else
                        args.expanded = true;
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
        },

        //Expand the child records from parent.
        expandAll: function () {

            var proxy = this,
                model = proxy.model,
                count = 0,
                treegridRecord,
                args = {};

            if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            else if(proxy.model.isEdit)
                proxy.cancelEditCell();

            args.requestType = ej.TreeGrid.Actions.ExpandCollapse;

            proxy._isInExpandCollapseAll = true;
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control

            for (count = 0; count < proxy.model.parentRecords.length; count++) {
                treegridRecord = proxy.model.parentRecords[count];
                args.data = treegridRecord;
                args.recordIndex = count;
                args.expanded = true;
                if (treegridRecord.hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(treegridRecord, args.expanded);
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshTreeGridOnExpandCollapseAll(args);

            proxy._isInExpandCollapseAll = false;
        },

           

        _refreshToolBar: function () {
            var $toolbar = $("#" + this._id + "_toolbarItems");
            $toolbar.find("li").removeClass("e-hover");
        },

        //RENDER TOOL BAR
        _renderToolbar: function () {
            var proxy = this,
                model = proxy.model,
                element = proxy.element;
            if (!model.isFromGantt) {
                if (proxy.model.toolbarSettings.showToolbar) {
                    element.append(proxy._renderToolbarTemplate());
                }
                if (proxy.model.isResponsive) {
                    $("#" + proxy._id + "_toolbarItems").addClass("e-treegridadaptivetoolbar");
                }
            }
        },

        //RENDER TOOLBAR TEMPLATE
        _renderToolbarTemplate: function () {
            var proxy = this,
                model = proxy.model,
                $div = ej.buildTag("div.e-treegridtoolbar#" + proxy._id + "_toolbarItems", "", { 'height': '36px', 'border': '1px solid' }, { "unselectable": "on" });
            if(!ej.isNullOrUndefined(model.toolbarSettings.toolbarItems) && model.toolbarSettings.toolbarItems.length){
                var $ul = ej.buildTag("ul", "", {},{});
                proxy._renderLi($ul);
                $div.append($ul);
            }
            if (!ej.isNullOrUndefined(model.toolbarSettings.customToolbarItems) && model.toolbarSettings.customToolbarItems.length) {
                var $customUl = ej.buildTag("ul", "", {}, {});
                proxy._renderCustomLi($customUl);
                $div.append($customUl);
            }
            var helper = {};
            helper.click = proxy._toolBarClick;
            helper.cssClass = proxy.model.cssClass;
            helper.rtl = false;
            helper.itemSeparator = false;
            helper.itemLeave = proxy._toolbarItemLeave;
            helper.width = proxy._gridWidth;
            helper.fields = {
                id: "",
                tooltipText: "",
                imageUrl: "",
                text: "",
                imageAttributes: "",
                spriteCSS: "",
                htmlAttributes: "",
            };
            $div.ejToolbar(helper);
            $div.ejToolbar("disableItem", proxy._disabledToolItems);
            proxy._disabledToolItems = $();
            return $div;
        },        
        //to renderCustom Li
        _renderCustomLi: function ($ul) {
            var proxy = this,
            model = proxy.model,
            $li,$item,
            customToolbarItems = model.toolbarSettings.customToolbarItems;
            for (var i = 0; i < customToolbarItems.length; i++) {
                if (customToolbarItems[i]["text"] || customToolbarItems[i]["templateID"]) {                   
                        if (customToolbarItems[i]["text"]) {
                            var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["text"];
                            $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["text"], title: customToolbar });
                            $item = ej.buildTag("a.e-toolbaricons e-icon e-treegridcustomtoolbaritem", "", {}).addClass(customToolbarItems[i]["text"]);
                            $li.addClass("e-treegridtoolbaritem");
                        }
                        else {                          
                            var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["templateID"].replace("#", "");
                            $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["templateID"].replace("#", ""), title: customToolbar });
                            $item = $(customToolbarItems[i]["templateID"]).hide().html();
                }                
                $li.html($item);              
                $ul.append($li);
                }
            }
        },
        //Render list to display the tools in toolbar.
        _renderLi: function ($ul) {
            var proxy = this,
                toolBarItems = proxy.model.toolbarSettings.toolbarItems,
                length = toolBarItems.length,
                i = 0,
                $li;
            for (i; i < length; i++) {

                $li = ej.buildTag("li.e-treegridtoolbaritem", "", {}, {
                    id: proxy._id + "_" + toolBarItems[i]
                });             
                proxy._renderLiContent($li, toolBarItems[i]);
                $ul.append($li);
            }
        },

        //RENDER TOOLBAR ICONS
        _renderLiContent: function ($li, item) {
            var $a, $input;
            var selectedRowIndex = this.selectedRowIndex();
            var editSetting = this.model.editSettings;
            switch (item) {

                case "add":
                    $a = ej.buildTag("a.e-addnew e-toolbaricons e-icon e-treegrid-add", "", {});
                    var addTitle = this._toolboxTooltipTexts["addTool"];
                    $li.attr("title", addTitle);
                    if (!this.model.editSettings.allowAdding)
                        this._disabledToolItems.push($li.get(0));
                    break;

                case "edit":
                    $a = ej.buildTag("a.e-edit e-toolbaricons e-icon e-treegrid-edit", "", {});
                    var editTitle = this._toolboxTooltipTexts["editTool"];
                    $li.attr("title", editTitle);
                    if (!this.model.editSettings.allowEditing || selectedRowIndex == -1 || !this.model.allowSelection || this.model.editSettings.beginEditAction == "click") {
                        this._disabledToolItems.push($li.get(0));
                    }

                    break;

                case "delete":
                    var deleteTitle = this._toolboxTooltipTexts["deleteTool"];
                    $li.attr("title", deleteTitle);
                    $a = ej.buildTag("a.e-delete e-toolbaricons e-icon e-treegrid-delete", "", {});

                    if (!this.model.editSettings.allowDeleting || selectedRowIndex == -1 || !this.model.allowSelection) {
                        this._disabledToolItems.push($li.get(0));
                    }

                    break;

                case "update":
                    var updateTitle = this._toolboxTooltipTexts["updateTool"];
                    $li.attr("title", updateTitle);
                    $a = ej.buildTag("a.e-save e-toolbaricons e-icon e-treegrid-save e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "cancel":
                    var cancelTitle = this._toolboxTooltipTexts["cancelTool"];
                    $li.attr("title", cancelTitle);
                    $a = ej.buildTag("a.e-cancel e-toolbaricons e-icon e-treegrid-cancel e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "expandAll":
                    var expandAllTitle = this._toolboxTooltipTexts["expandAllTool"];
                    $li.attr("title", expandAllTitle);
                    $input = ej.buildTag("a.e-expandall e-toolbaricons e-icon e-treegrid-expandall", "", {}, {});
                    $li.append($input);
                    break;

                case "collapseAll":
                    var collapseAllTitle = this._toolboxTooltipTexts["collapseAllTool"];
                    $li.attr("title", collapseAllTitle);
                    $input = ej.buildTag("a.e-collapseall e-toolbaricons e-icon e-treegrid-collapseall", "", {}, {});
                    $li.append($input);
                    break;

                case "pdfExport":
                    var pdfExportTitle = this._toolboxTooltipTexts["pdfExportTool"];
                    $li.attr("title", pdfExportTitle);
                    $input = ej.buildTag("a.e-pdfIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
                case "excelExport":
                    var excelExportTitle = this._toolboxTooltipTexts["excelExportTool"];
                    $li.attr("title", excelExportTitle);
                    $input = ej.buildTag("a.e-excelIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
            }

            $li.append($a);
        },

        //update the toolbar items when dynamically update the editSettings property
        _updateToolbarItems: function () {
            var proxy = this,
                model = proxy.model,
                toolbarItems = model.toolbarSettings.toolbarItems,
                editSettings = model.editSettings,
                toolbar = $("#" + proxy._id + "_toolbarItems"),
                selectedRowIndex = proxy.selectedRowIndex(),
                editMode = editSettings.editMode,
                disableToolItems = [],
                enableToolItems = [];
                if (editMode.toLowerCase() == "cellediting" || editMode.toLowerCase() == "dialogediting") {
                    /* We can able perform rowEditing using toolbar, whether the editMode also in cellEditing.
                       So cancel the editing based on edit type.*/
                    if (proxy._isRowEdit)
                        proxy.cancelRowEditCell();
                    else if (model.isEdit)
                        proxy.cancelEditCell();
                }
                else if (editMode.toLowerCase() == "rowediting")
                    proxy.cancelRowEditCell();
                proxy._cancelSaveTools();
        },


        //#region TREEGRIDHEADER RENDERIGN

        //TREEGRID HEADER RENDER INITIALIZATION
        _renderAfterColumnInitialize:function(){
            var proxy = this;
            proxy.element.append(proxy._renderGridHeader());
        },

        //TO CHECK FILTER FORM ELEMENTS EDIT TYPE
        filterEditType: function (column, element, filterValue) {

            var proxy = this,
                model = proxy.model,
                columnField = column.field.split('.').join("");
               
            if (ej.isNullOrUndefined(column["filterEditType"]))
                column["filterEditType"] = column["editType"];

            switch (column["filterEditType"]) {
                case "stringedit":
                    element.html(ej.buildTag('input.e-ejinputtext e-filtertext e-field e-filterwidth', "", {}, { id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue }));
                    break;
                case "numericedit":
                    var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", { "width": column.width - 15 }, { type: "text", id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue });
                    element.append($numericText);
                    break;
                case "datepicker":
                case "datetimepicker":
                    var $datePicker = ej.buildTag('input.e-' + column["filterEditType"] + ' e-field', "", {}, { type: "text", id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue });
                    element.append($datePicker);
                    break;
                case "booleanedit":
                case "dropdownedit":
                    var $dropDownList = ej.buildTag('input.e-field e-dropdownlist e-field', "", {}, { type: "text", id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue });
                    element.append($dropDownList);
                    break;
            }
        },


        //RENDER FILTER BAR ELEMENTS ACCORDING TO ITS TYPE
        _filteringElements: function (args) {
            var proxy = this,
                model=proxy.model,
                elementFocused = false,
                $formElement,
                form, length,
                $element,
                width,
                params = {},
                value,
                column,
                customParams,
                toformat,
                formatVal,
            selectedItem = model.selectedItem;

            if (args.requestType == "filtering") {
                form = document.getElementById(proxy._id + "_filterBar" + args.fieldname.split('.').join(""));
            }
            
            column = customParams = ej.TreeGrid.getColumnByField(model.columns, args.fieldname);
            $formElement = $(form).find("input,select");
            length = $formElement.length;
            for (var i=0; i < length; i++) {
                $element = $formElement.eq(i);
                params = {};
                //inputWidth = column.width ? column.width - 2 : proxy.model.commonWidth - 2;
                var inputWidth = $element.closest("div").width()-2;
                if ($element.hasClass("e-numerictextbox")) {
                    width = inputWidth;
                    value = $element.val();
                    params.width = width;                    
                    params.showSpinButton = true;
                    params.cssClass = model.cssClass;
                    params.locale = model.locale;
                    params.height = 28;
                    params.focusIn = $.proxy(proxy._cancelEditState, proxy, $element);
                    //for parent editing 
                    var tempId = $element[0].id;
                    tempId=tempId.replace(proxy._id, '');
                    if (model.filterSettings.filterBarMode == "immediate")
                        params.change = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        params.change = null;
                    if (value.length)
                        params.value = parseFloat(value);
                    else
                        params.value = null;
                    customParams = ej.TreeGrid.getColumnByField(proxy.model.columns, $element.prop("name"));
                    if (!ej.isNullOrUndefined(customParams) && !ej.isNullOrUndefined(customParams["editParams"]))
                        $.extend(params, customParams["editParams"]);
                    $element.ejNumericTextbox(params);
                    $element.prop("name", $element.prop("name").replace(proxy._id, ""));
                }
                else if ($element.hasClass("e-datepicker")) {
                    width = inputWidth;
                    params.width = width;                    
                    params.cssClass = model.cssClass;
                    params.dateFormat = model.dateFormat;
                    params.locale = model.locale;
                    params.height = 28;
                    params.focusIn = $.proxy(proxy._cancelEditState, proxy, $element);
                    var tempId = $element[0].id;
                    tempId = tempId.replace(proxy._id, '');
                    //To filter the records once the date seleted.
                    if (model.filterSettings.filterBarMode == "immediate")
                        params.select = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        params.select = null;
                    column = ej.TreeGrid.getColumnByField(proxy.model.columns, $element.prop("name"));
                    if (column["format"] !== undefined && column.format.length > 0) {
                        toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                        formatVal = toformat.exec(column.format);
                        params.dateFormat = formatVal[2];
                    }
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);

                    if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                        $element.ejDateTimePicker(params);
                    else
                        $element.ejDatePicker(params);
                    proxy._preventDoubleClick(column); //To prevent double click event
                }
                else if ($element.hasClass("e-datetimepicker")) {
                    width = inputWidth;
                    params = {
                        width: width,
                        rtl: model.rtl,
                        locale: model.locale,
                        cssClass: model.cssClass,
                        showButton: false,
                        focusIn : $.proxy(proxy._cancelEditState, proxy, $element),
                    };
                    params.height = 28;
                    if (model.filterSettings.filterBarMode == "immediate")
                        params.close = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        params.close = null;
                    column = ej.TreeGrid.getColumnByField(proxy.model.columns, $element.prop("name"));
                    if (column["format"] !== undefined && column.format.length > 0) {
                        toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                        formatVal = toformat.exec(column.format);
                        params.dateTimeFormat = formatVal[2];
                    }
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);

                    $element.ejDateTimePicker(params);
                    proxy._preventDoubleClick(column); //To prevent double click event

                }
                else if ($element.hasClass("e-dropdownlist")) {
                    column = ej.TreeGrid.getColumnByField(model.columns, args.fieldname);
                    var text = (column.editParams && column.editParams.fields && column.editParams.fields.text) ? column.editParams.fields.text : "text";
                    var value = (column.editParams && column.editParams.fields && column.editParams.fields.value) ? column.editParams.fields.value : "value";
                    var clear, emptyString, dropData = [], blank, selectAll, dropDatatrue, dropDatafalse;
                    //Collecting the drop down data for drop down filter bar
                    if (column.dropdownData && column.dropdownData.length > 0)
                        dropData = $.extend(true, [], column.dropdownData);
                    else {
                        //Default drop down data for boolean editType columns
                        if (column.editType == "booleanedit") {
                            dropData = [];
                            dropDatatrue = {};
                            dropDatatrue[text] = proxy._trueText;
                            dropDatatrue[value] = "true";
                            dropData.push(dropDatatrue);
                            dropDatafalse = {};
                            dropDatafalse[text] = proxy._falseText;
                            dropDatafalse[value] = "false";
                            dropData.push(dropDatafalse);
                        }
                        else
                            dropData = proxy._dropDownArrayCollection(column, args.fieldname);  //Gathering dropdown data from datasource                       
                    }
                    //To append selectAll(clear) label in the drop down list                   
                    //clear = { text: proxy._dropDownListClearText, value: "" };
                    clear = {};
                    clear[text] = proxy._dropDownListClearText;
                    clear[value] = "";
                    dropData.splice(0, 0, clear);
                    //To append (Blanks) label in the drop down list
                        blank = column.allowFilteringBlankContent == undefined ? true : column.allowFilteringBlankContent;
                    if (blank) {
                        //emptyString = { text: proxy._dropDownListBlanksText, value: proxy._dropDownListBlanksText };
                        emptyString = {};
                        emptyString[text] = proxy._dropDownListBlanksText;
                        emptyString[value] = proxy._dropDownListBlanksText;
                        dropData.push(emptyString);
                    }
                    var param = {}, inputValue = $element.val(), $dropDownObj, dropObject = $("#" + $element[0].id).data("ejDropDownList");
                    if (dropObject) {
                        $dropDownObj = $(dropObject.popupList);
                    }
                    
                    param.width = inputWidth;
                    param.showCheckbox = false;
                    param.dataSource = dropData;
                    param.height = 28;
                    param.popupShown = $.proxy(proxy._cancelEditState, proxy, $element);
                    param.fields = { text: text, value: value };
                    //To filter the records once the item has been selected.
                    if (model.filterSettings.filterBarMode == "immediate")
                        param.popupHide = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        param.popupHide = null;
                    $element.ejDropDownList(param);
                    //Apply italic font style for "(Clear Filter)" and "(Blanks)" label
                    if ($dropDownObj) {
                        $dropDownObj.find(".e-ul :first-child").find(".e-ddltxt").css("font-style", "italic");
                        if(blank)
                            $dropDownObj.find(".e-ul :last-child").find(".e-ddltxt").css("font-style", "italic");
                    }
                    if (inputValue == proxy._dropDownListClearText)
                        inputValue = "";
                    $element.ejDropDownList("selectItemByValue", inputValue);//To retain the selected value in dropdown    
                    proxy._preventDoubleClick(column); //To prevent double click event                 
                } else {
                    switch ($element.prop('tagName')) {
                        case "INPUT":
                            $element.width(inputWidth - 4);
                            if (column.filterEditType == "stringedit")
                                proxy._on($("#" + proxy._id + "_" + column.field.split('.').join("") + "_filterbarcell"), "focus", proxy._cancelEditState);
                            break;

                        case "SELECT":
                            $element.width(inputWidth).height(15);
                            break;
                    }
                }
                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof $element.data("ejDropDownList") == "object")) {
                    if (!proxy._isEnterKeyPressed) {
                        elementFocused = true;
                    }
                }
            }
        },

        // Method for retriving drop down data to filterbar from data source
        _dropDownArrayCollection: function (column, fieldItems) {
            var proxy = this,
                model = proxy.model,
                fieldName = fieldItems,
                dropDownRecords = [],
                uniqueDropDownRecords = [],
                dropdownData = [],
                columnEditType = column.editType;

            dropDownRecords = $.map(model.flatRecords, function (record) {
                if (record.item[fieldName])
                    return record.item[fieldName];
            });
            $.each(dropDownRecords, function (i, el) {
                el=$.trim(el); 
                if ($.inArray(el, uniqueDropDownRecords) === -1) uniqueDropDownRecords.push(el);
            });
            if (columnEditType != "numericedit")
                uniqueDropDownRecords.sort(proxy.stringCompare);
            else {
                uniqueDropDownRecords = uniqueDropDownRecords.sort(function (a, b) {
                    return a - b;
                });
            }
            $.each(uniqueDropDownRecords, function (i, val) {
                dropdownData.push({ text: val, value: val });
            });
            return dropdownData;
        },

        stringCompare: function (s1, s2) {
            var str1 = [], str2 = [];

            s1.replace(/(\d+)|(\D+)/g, function (_, $1, $2) { str1.push([$1 || Infinity, $2 || ""]) });
            s2.replace(/(\d+)|(\D+)/g, function (_, $1, $2) { str2.push([$1 || Infinity, $2 || ""]) });
    
            while (str1.length && str2.length) {
                var st1 = str1.shift();
                var st2 = str2.shift();
                var val = (st1[0] - st2[0]) || st1[1].localeCompare(st2[1]);
                if(val) return val;
            }

            return str1.length - str2.length;
        },
        // Method to prevent double click event during dropDown list and date picker filtering
        _preventDoubleClick: function (col) {
            var proxy = this,
                filterBoxTool = $("#" + proxy._id + "_" + col.field.split('.').join("") + "_filterbarcell_popup");
            if (filterBoxTool.length != 0) {
                $(filterBoxTool).on('click', function (e) {
                    if (ej.isTouchDevice())
                        proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                    else
                        proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                    setTimeout(function () {
                        if (ej.isTouchDevice())
                            proxy._on(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                        else
                            proxy._on(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                    }, 300);
                });
            }
        },
        // METHOD TO RENDER FILDERING ELEMENTS
        _renderFiltering: function (columns, showDetailColumn) {
            var proxy = this, model = this.model,
            totColumns = model.columns,
            filteredColumns = model.filterSettings.filteredColumns;
            var $tr = ej.buildTag('tr.e-filterbar', "", {}, {});
            if (proxy.model.allowFiltering) {
                $.each(totColumns, function (i, column) {
                    if (ej.isNullOrUndefined(column["allowFiltering"]))
                        column["allowFiltering"] = true;
                });
                var filterEnabled = false;
                //To check whether atleast any one of the column's allowFiltering has been enabled
                $.each(totColumns, function (i, column) {
                    if (column.allowFiltering == true) {
                        filterEnabled = true;
                        return false;
                    }
                });
                if (filterEnabled) {
                    for (var column = 0; column < columns.length; column++) {

                    var $th = ej.buildTag('th.e-filterbarcell .e-editValue', "", {}, {});
                    columns[column]["visible"] === false && $th.addClass("e-hide");
                    var $div = ej.buildTag('div.e-filterdiv', "", {}, { id: proxy._id + "_filterBar" + columns[column].field.split('.').join("") });
                        $tr.append($th.append($div));
                        //Condition to check whether allow filtering enabled for the individual column before rendering filtering elements
                        if (columns[column].allowFiltering == false)
                            continue;
                        else {
                            var filterValue = "";
                            if (filteredColumns.length > 0) {
                                for (var fcolumn = 0; fcolumn < filteredColumns.length; fcolumn++) {
                                    if (columns[column].field == filteredColumns[fcolumn].field) {
                                        filterValue = filteredColumns[fcolumn].value;
                                    }
                                }
                            }
                       
                            this.filterEditType(columns[column], $div, filterValue);
                        var $span = ej.buildTag('span.e-cancel e-icon e-hide e-spanstyle');
                        $div.append($span);
                    }                   
                }          
                }
            }
            /* add details column to last in column header */
            if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn && showDetailColumn) {
                $tr.append(ej.buildTag('th.e-filterbarcell e-detailheadercell', '<div style="width:35px;"></div>'));
            }
            return $tr;
        },


        _getIndentCol: function () {
            return ej.buildTag("col", "", { width: "35px" });
        },

        //METHOD FOR RENDERING TREEGRID HEADER
        _renderGridHeader: function () {

            var proxy = this,
                model = proxy.model,
                doc = document, temp, $frozenDiv, $movableDiv,
                $innerDiv = ej.buildTag('div.e-gridheadercontainer', "", { "overflow": "hidden" }, { "unselectable": "on" }),
                $div = model.isFromGantt ? ej.buildTag('div.e-gridheader#' + proxy._id + "e-gridheader", "", {
                    "border-left-style": "solid",
                    "border-left-width": "1px"
                }, "") :
                    ej.buildTag('div.e-gridheader#' + proxy._id + "e-gridheader", "",
                {
                    "border-top-style": "solid",
                    "border-left-style": "solid",
                    "border-right-style": "solid",
                    "border-top-width": "1px",
                    "border-left-width": "1px",
                    "border-right-width": "1px",
                    "width": proxy._gridWidth,
                }, "");
            if (model.allowFiltering == true && model.filterSettings.filterType == ej.TreeGrid.FilterType.FilterBar)
                $innerDiv.addClass("e-headercontent-material-filterbar");
            $innerDiv.addClass("e-headercontent");
            proxy.setGridHeaderContent($div);
            proxy._$gridHeaderContainer = $innerDiv;
            proxy._hiddenColumns = [];
            proxy._visibleColumns = [];
            proxy.columnsWidthCollection = [];

            if (this._frozenColumnsLength > 0) {
                $innerDiv.addClass("e-frozen-header-container");
                $frozenDiv = ej.buildTag("div.e-frozenheaderdiv#e-frozenheaderdiv" + proxy._id, this._renderGridHeaderInternalDesign(model.columns.slice(0, this._frozenColumnsLength), false));
                if (model.allowFiltering == true && model.filterSettings.filterType == ej.TreeGrid.FilterType.FilterBar)
                    $frozenDiv.addClass("e-filterbar-header-material");
                $movableDiv = ej.buildTag("div.e-movableheader#e-movableheader" + proxy._id, ej.buildTag("div.e-movableheaderdiv#e-movableheaderdiv" + proxy._id, this._renderGridHeaderInternalDesign(this.model.columns.slice(this._frozenColumnsLength), true)));
                $innerDiv.append($frozenDiv).append($movableDiv);
            } else {
                $innerDiv.append(this._renderGridHeaderInternalDesign(this.model.columns, true));
                $innerDiv.removeClass("e-frozen-header-container");
            }
            $div.html($innerDiv);
            this.setGridHeaderTable(this.getHeaderContent().find(".e-table"));
            return $div;
        },

        getPager: function () {
            return this._gridPager;
        },

        setTreeGridPager: function (value) {
            this._gridPager = value;
        },

        _renderGridPager: function () {
            var proxy = this,
                $div = $(document.createElement('div')),
                pagerModel = {}, pageSettings = proxy.model.pageSettings;

            pageSettings.click = $.proxy(proxy._pagerClickHandler, proxy);
            pageSettings.totalRecordsCount = proxy._gridRecordsCount;                        
            $.extend(pagerModel, pageSettings);
            pagerModel.locale = proxy.model.locale;
            if (proxy._currentPage() < 0)
                proxy._currentPage(1);
            pagerModel.currentPage = this._prevPageNo = proxy._currentPage();
            pagerModel.masterObject = proxy;
            pagerModel.cssClass = proxy.model.cssClass;
            proxy.setTreeGridPager($div);
            $div.ejPager(pagerModel);
            $div.ejPager("refreshPager");
            pagerModel = $div.ejPager("model");
            pageSettings.totalPages = pagerModel.totalPages;
            if (proxy._currentPage() !== pagerModel.currentPage)
                proxy._currentPage(pagerModel.currentPage);
            //Create custom Paging Template
            if (!ej.isNullOrUndefined(pageSettings.template) && pageSettings.template.length > 0) {
                $div.children().remove();                
                var $customDiv = ej.buildTag('div.e-pagercontainer'),
                $template = this._createTemplateElement(pageSettings, true);
                $customDiv.append($template.innerHTML);
                $div.append($customDiv);
            }
            return $div;
        },
		// Tempalte to render header checkbox selection
        _addHeaderCheckboxTemplate: function () {
            var model = this.model, template;

            if (model.flatRecords.length == model.selectedItems.length) {
                template = '<div><span class="e-chkbox-wrap e-widget" style="margin-left:5px;padding-right:10px;color:#c8c8c8;">' +
                        '<div class="e-chkbox-small"><span class="e-chk-act">' +
                        '<span class="e-checkbox e-checkmark e-chk-image e-icon e-headerCheckbox"' +
                'id =' + this._id + '_headerCheckbox></span></span></div></span></div>';
            }
            else if (model.flatRecords.length > model.selectedItems.length && model.selectedItems.length > 0) {
                template = '<div><span class="e-chkbox-wrap e-widget" style="margin-left:5px;padding-right:10px;color:#c8c8c8;">' +
                        '<div class="e-chkbox-small"><span class="e-chk-indeter">' +
                        '<span class="e-checkbox e-stop e-chk-image e-icon e-headerCheckbox"' +
                'id =' + this._id + '_headerCheckbox></span></span></div></span></div>';
            }
            else {
                template = '<div><span class="e-chkbox-wrap e-widget" style="margin-left:5px;padding-right:10px;color:#c8c8c8;">' +
                        '<div class="e-chkbox-small"><span class="e-chk-inact">' +
                        '<span class="e-checkbox e-chk-image e-icon e-headerCheckbox"' +
                'id =' + this._id + '_headerCheckbox></span></span></div></span></div>';
            }
            return template;
        },
        _renderGridHeaderInternalDesign: function (columns, showDetailColumn)
        {
            var proxy = this,
             model = proxy.model,
             doc = document,
             $table = ej.buildTag('table.e-table', "", {}, { "cellspacing": "0px", "border-spacing": "0px" }),
             $thead = ej.buildTag('thead'),
             $tbody = ej.buildTag('tbody.e-hide'),
             $columnHeader = ej.buildTag('tr.e-columnheader'),
             $colGroup = $(doc.createElement('colgroup')),
             $rowBody = $(doc.createElement('tr')),
             columnCount = 0,
             length = columns.length,
             $headerCell,
             bodyCell,
             $headerCellDiv, 
             col, $filterHeader,
             $columnFilter;

            //CHECK SORTING ENABLED OR NOT
            if (model.allowSorting || model.showColumnChooser || model.allowColumnReordering) {
                $columnHeader.css({ 'cursor': 'pointer' });
            }

            if (model.headerTextOverflow === "wrap")
                proxy.element.addClass("e-wrap");
            else
                proxy.element.removeClass("e-wrap");

            for (columnCount; columnCount < length; columnCount++) {
                if (columns[columnCount]) {
                    var headerTextAlign = columns[columnCount].headerTextAlign ? columns[columnCount].headerTextAlign
                                                           : (columns[columnCount].textAlign ? columns[columnCount].textAlign : ej.TextAlign.Left);
                    // set padding right 35px for displaying column menu icon
                    if ((proxy.model.showColumnChooser || (!proxy.model.showColumnChooser && proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu")) && columns[columnCount].field != "checkboxState") {
                        if (!ej.isNullOrUndefined(columns[columnCount].allowFiltering) && !columns[columnCount].allowFiltering && !proxy.model.showColumnChooser) {
                            $headerCell = ej.buildTag('th.e-headercell', "", {}, {});
                        } else {
                            $headerCell = ej.buildTag('th.e-headercell', "", {}, {});
                            $headerCell.addClass("e-column-menu-padding");
                        }
                    }
                    else {
                        $headerCell = ej.buildTag('th.e-headercell', "", {}, {});
                    }
                    if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == ej.TreeGrid.FilterType.FilterBar) {
                        $headerCell.addClass("e-filterbar-material");
                    }
                    bodyCell = doc.createElement('td');

                    $headerCellDiv = ej.buildTag(
                        'div.e-headercelldiv', "",
                        { "text-align": headerTextAlign },
                        { 'ej-mappingname': columns[columnCount]["field"], 'unselectable': "on" }
                    );
                    if (columns[columnCount]["clipMode"] && columns[columnCount]["clipMode"] == ej.TreeGrid.ClipMode.Ellipsis) {
                        $headerCellDiv.addClass("e-treegridtrimcell");
                    }
                    // add checkbox that name of column have in proxy._checkboxColumnName
                    if (proxy._checkboxSelection && model.selectionSettings.enableSelectAll) {
                        if (proxy._checkboxColumnName == columns[columnCount]["field"])
                            $headerCellDiv.append(proxy._addHeaderCheckboxTemplate());                        
                    }
                    if (columns[columnCount]["field"] == "checkboxState")
                        $headerCell.css({ cursor: "default" });

                    var headerText = ej.buildTag('span',columns[columnCount]["headerText"] == undefined ?
                        columns[columnCount]["headerText"] = columns[columnCount]["field"] :
                        columns[columnCount]["headerText"]);

                    $headerCellDiv.append(headerText);                    
                    $headerCell.append($headerCellDiv);
                    // Add column menu icon in header columns
                    if (proxy.model.showColumnChooser && !columns[columnCount].nonColumn) {
                        var $columnChooser = ej.buildTag('div.e-columnmenu-icon e-icon e-columnicon', "", { "cursor": "pointer" });
                        $columnChooser.data("isClicked", false);
                        $headerCell.append($columnChooser);
                    } else if ((!proxy.model.showColumnChooser && proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu" && (ej.isNullOrUndefined(columns[columnCount].allowFiltering) || columns[columnCount].allowFiltering)) && columns[columnCount].field != "checkboxState") {
                        if (proxy._filteredColumnValueID.indexOf(columns[columnCount].field) != -1)
                            $columnFilter = ej.buildTag('div.e-column-filtered-icon e-icon e-filtericon', "", { "cursor": "pointer" });
                        else
                            $columnFilter = ej.buildTag('div.e-column-filter-icon e-icon e-filtericon', "", { "cursor": "pointer" });
                        if (proxy.model.filterSettings.filteredColumns) {
                            for (var x = 0; x < proxy.model.filterSettings.filteredColumns.length; x++) {
                                if (proxy.model.filterSettings.filteredColumns[x].field == columns[columnCount].field && proxy.model.filterSettings.filteredColumns[x].value.toString() != "")
                                    $columnFilter = ej.buildTag('div.e-column-filtered-icon e-icon e-filtericon', "", { "cursor": "pointer" });
                            }
                        }
                        $columnFilter.data("isClicked", false);
                        $headerCell.append($columnFilter);
                    }
                    
                    col = doc.createElement('col');

                    $rowBody.append(bodyCell);
                    $columnHeader.append($headerCell);
                    $colGroup.append(col);


                    //CHECK VISIBLE PROPERTY OF THE COLUMN
                    if (columns[columnCount]["visible"] === false && columns[columnCount] != model.columns[model.treeColumnIndex]) {
                        $headerCell.addClass("e-hide") && $(col).css("display", "none") &&
                        proxy._hiddenColumns.push(columns[columnCount].headerText);

                    } else {
                        proxy._visibleColumns.push(columns[columnCount].headerText);
                        columns[columnCount]["visible"] = true;
                    }

                    if (columns[columnCount]["allowSorting"] === false) {
                        proxy._disabledSortableColumns.push(columns[columnCount].headerText);
                        $headerCell.css({ 'cursor': 'normal' });
                    }

                    if (!ej.isNullOrUndefined(columns[columnCount]["headerTemplateID"])) {
                        $headerCellDiv.html($(columns[columnCount]["headerTemplateID"]).hide().html()).parent().addClass("e-headertemplate");
                    }
                    if (columns[columnCount]["allowCellSelection"] == undefined) {
                        columns[columnCount]["allowCellSelection"] = true;
                    }
                    if (columns[columnCount]["showInColumnChooser"] == undefined) {
                        columns[columnCount]["showInColumnChooser"] = true;
                    }
                    if (columns[columnCount]["width"] == undefined && model.commonWidth !== undefined) {
                        proxy.columnsWidthCollection.push(model.commonWidth);
                        columns[columnCount]["width"] = model.commonWidth;
                    } else {
                        proxy.columnsWidthCollection.push(parseFloat(columns[columnCount]["width"]));
                        columns[columnCount]["width"] = parseFloat(columns[columnCount]["width"]);
                    }

                    proxy._fieldColumnNames[columns[columnCount].headerText] = columns[columnCount].field;
                    proxy._headerColumnNames[columns[columnCount].field] = columns[columnCount].headerText;
                }
            }
            //Updating the column properties to Gantt's model.columns also
            if (model.isFromGantt)
                proxy.updateToGanttColumns();

            /* add detail column to last*/
            if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn && showDetailColumn) {
                $columnHeader.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div style="width:35px;"></div>', {}, {}));
                $colGroup.append(this._getIndentCol());
            }

            // Condition to check whether filtering enabled to render filter elements.
            if (model.allowFiltering && !model.isFromGantt && model.filterSettings.filterType == "filterbar") {
                $filterHeader = this._renderFiltering(columns, showDetailColumn);
            }            
            $thead.append($columnHeader);
            if ($filterHeader)
                $thead.append($filterHeader);
            $table.append($colGroup).append($thead);
            return $table;
        },

        //#endregion

        //#region TREEGRIDCONTENT RENDERING
        //TREEGRID CONTENT RENDER INITIALIZATION
        _initGridRender: function () {

            var proxy = this;
            proxy._addInitTemplate();
            proxy._renderGrid();

            //CHECK COLUMN RESIZE IS ENABLED OR NOT AND INITIALIZE THE RESIZER
            if (proxy.model.allowColumnResize) {
                proxy._resizer = new ej.gridFeatures.gridResize(proxy);
            }

        },
        //Create a summary row.
        _summaryRow: function () {
            var proxy = this, model = proxy.model;
            if (model.showSummaryRow)
                proxy._createSummaryRow();
            if (model.showTotalSummary) {
                proxy._createTotalSummaryRow();
                proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
        },


        //ADD GRIDCONTENT TO THE TREEGRID
        _renderGrid: function () {
            
            var proxy = this;
            proxy._renderGridContent().insertAfter(proxy.element.children(".e-gridheader"));
            

        },
        _renderFrozenSummary: function ()
        {
            this._$footerContainer.find("#e-frozenfooterdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[0]);
            this._$footerContainer.find("#e-movablefooterdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[1]);
            this._$footerContainer.find("#e-frozenfooterdiv" + this._id + " .e-table tbody").html($.render[this._id + "_JSONFrozenTemplate"](this._footerSummaryRecord));
            this._$footerContainer.find("#e-movablefooterdiv" + this._id + " .e-table tbody").html($.render[this._id + "_Template"](this._footerSummaryRecord));
        },

        _renderSummaryByFrozenDesign: function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this._frozenColumnsLength))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            if (!$.templates[this._id + "_FrozenSummaryTemplate"])
                this.addFrozenSummaryTemplate();
            return $.render[this._id + "_FrozenSummaryTemplate"](colgroups);
           
        },
        _spliceSummaryRows: function (updatedRecords) {
            var proxy = this,
                model = proxy.model, records=[];
            var nonSummaryRowChildRecords = updatedRecords.filter(function (data) {
                if (!data.isSummaryRow)
                    records.push(data);
            });
            return records;
        },
        addFrozenSummaryTemplate: function () {
            var template = "<div class='e-frozenfooterdiv' id='e-frozenfooterdiv" + this._id +"'>"
            + "<table class='e-table' style='width:100%' cellspacing='0' id='" + this._id + "frozensummarye-table'>{{:colgroup1}}<tbody>"
            + "</tbody></table></div>"
            + "<div class='e-movablefooter' id='e-movablefooter" + this._id + "'><div class='e-movablefooterdiv' id='e-movablefooterdiv" + this._id + "'><table class='e-table' id='" + this._id + "movablesummarye-table' cellspacing='0'>{{:colgroup2}}<tbody>"
            + "</tbody></table></div></div>", templates = {};
            templates[this._id + "_FrozenSummaryTemplate"] = template;
            $.templates(templates);
        },

        //Add a total summary row after treegrid content.
        _createTotalSummaryRow: function () {
            var proxy = this, $summaryDiv, $table, model = proxy.model, flatRecords = model.flatRecords,
                summaryRows = model.summaryRows, summaryRowLength = summaryRows.length,
                updatedRecords = model.updatedRecords, parentRecords = model.parentRecords,
                columns = model.columns, $tbody = ej.buildTag('tbody');

            proxy._footerSummaryRecord = [];
            proxy._footerSummaryRows = [];
            $("#" + proxy._id + "-footersummaryrow").remove();
            $summaryDiv = ej.buildTag('div.e-footersummaryrowdiv#' + proxy._id + '-footersummaryrow', '',
                {
                    "overflow": "hidden",
                    "cursor": "default"
                });
            var $footerContainer = ej.buildTag('div.e-footercontainer#e-footercontainer' + proxy._id, '',
               {                                  
                   "overflow": "hidden"
               });
            proxy._flatChildRecords = proxy._spliceSummaryRows(model.updatedRecords);

            for (var summaryRowIndex = 1; summaryRowIndex <= summaryRowLength; summaryRowIndex++) {
                var item = {};
                for (var columnLength = 0; columnLength < columns.length; columnLength++) {
                    item[columns[columnLength].field] = "";
                }
                item = proxy._createSummaryItem(item, summaryRows[summaryRowIndex - 1]);
                var record = proxy._createRecord(item, 0);
                record.footerSummaryRowRecord = true;
                record.index = summaryRowIndex;
                proxy._footerSummaryRecord.push(record);
                //GridRow = $.render[this._id + "_Template"](record);
                //proxy._footerSummaryRows.push(GridRow);
                //$tbody.append(GridRow);
            }
            proxy._$footerContainer = $footerContainer;
            if (this._frozenColumnsLength > 0) {
                $footerContainer.html(this._renderSummaryByFrozenDesign());
                this._renderFrozenSummary();
            } else {
                var $table = ej.buildTag('table.e-table#' + proxy._id + "summarye-table", "",
                { top: "0px" }, { 'cellspacing': '0px' });
                $table.append(proxy.getContentTable().find('colgroup').clone()).append($tbody);
                $tbody.html($.render[this._id + "_Template"](proxy._footerSummaryRecord));
                $footerContainer.append($table);
            }
            proxy._$totalSummaryRowContainer = $summaryDiv;
            proxy._$footertableContent = $footerContainer.find(".e-table");
            $summaryDiv.append($footerContainer);
            //Always display after TotalSummaryRow
            if (model.allowPaging) {
                proxy.element.append($("#" + this._id + "Pager").before($summaryDiv));
            }
            else
                proxy.element.append($summaryDiv);

            proxy._flatChildRecords = [];
            this._setWidthToFooters();
            if (this._$totalSummaryRowContainer.outerHeight() < 90) {
                if (proxy.isVScroll())
                    proxy._$totalSummaryRowContainer.addClass("e-scrollcss");
            }
            else {
                proxy._$totalSummaryRowContainer.ejScroller({ height: 90 });
            }
        },
        _getFooterRows: function ()
        {
            var gridFooterRows = $();
            if (this.model.showTotalSummary && this._$footertableContent) {
                gridFooterRows = this._$footertableContent.get(0).rows;
                if (this._frozenColumnsLength > 0)
                    gridFooterRows = [gridFooterRows, this._$footertableContent.get(1).rows];
            }
            return $(gridFooterRows);
        },
        //update footer container width for frozen columns
        _setWidthToFooters: function () {
            var width = this._gridWidth;
            if (this._frozenColumnsLength > 0) {
                var totalWidth = 0, frozenWidth;
                for (var i = 0; i < this.columnsWidthCollection.length; i++) {
                    totalWidth += this.columnsWidthCollection[i];
                    if (this._frozenColumnsLength - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                }
                this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).width(width).next().css("margin-left", frozenWidth + "px");
                this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).outerWidth(frozenWidth)
                    .end().find("#e-movablefooterdiv" + this._id).css("width", "100%");
            }
        },
        _excludeSummaryRows: function () {

            var $gridRows = $(), model = this.model;
            if (this.getTreeGridRows() && this.getTreeGridRows().length > 0) {
                    if (this._frozenColumnsLength > 0)
                        $gridRows = [$(this.getTreeGridRows()[0]).not(".e-summaryrow"), $(this.getTreeGridRows()[1]).not(".e-summaryrow")];
                    else
                        $gridRows = $(this.getTreeGridRows()).not(".e-summaryrow");
            }
            return $gridRows;
        },

        //Add a summary row for every parent item in Tree grid.
        _createSummaryRow: function (args) {
            var proxy = this, model = proxy.model, parentRecords,
                recordIndex,
                item = {},
                docsummaryRow,
                totalChildRecordsLength,
                summaryRows = model.summaryRows,
                summaryRowLength = summaryRows.length,
                columns = model.columns;
            if (args && (args.requestType == "dragAndDrop" || args.requestType == "addNewRow" ||
                 args.requestType == "sorting")) {
                parentRecords = proxy._getParentRecords(model.updatedRecords, proxy);
                //Remove the summaryRow records from the childRecords collection of parentRecords
                if (args.requestType == "dragAndDrop") {
                    for (var i = 0; i < parentRecords.length; i++) {
                        var nonSummaryRowChildRecords = [];
                        nonSummaryRowChildRecords = parentRecords[i].childRecords.filter(function (data) {
                            if (!data.isSummaryRow)
                                return true;

                        });
                        parentRecords[i].childRecords = nonSummaryRowChildRecords.slice();
                    }
                }
            }
            else
                parentRecords = proxy._parentRecords;
            var length = parentRecords.length;
            if (args && ej.isNullOrUndefined(args.filterCollection))
                args.filterCollection = [];
            if (model.enableCollapseAll && model.enableVirtualization && !args)
                model.updatedRecords = model.flatRecords.slice();
            model.updatedRecords = proxy._spliceSummaryRows(model.updatedRecords); 
            model.flatRecords = proxy._spliceSummaryRows(model.flatRecords);
            model.summaryRowRecords = [];
            //$(proxy.element).find(".e-summaryrow").remove();                       
            //this._$gridRows = proxy._excludeSummaryRows();
            proxy._flatChildRecords = [];
            for (var parentIndex = 0; parentIndex < length; parentIndex++) {
                var parentRecord = parentRecords[parentIndex];
                totalChildRecordsLength = proxy._getChildRecordsLength(parentRecord, model.updatedRecords);              
                if (totalChildRecordsLength == 0)
                    continue;
                for (var summaryRowIndex = 1; summaryRowIndex <= summaryRowLength; summaryRowIndex++) {
                    for (var columnLength = 0; columnLength < columns.length; columnLength++) {
                        item[columns[columnLength].field] = "";
                    }
                    item = proxy._createSummaryItem(item, summaryRows[summaryRowIndex - 1], parentRecord);
                    var currentIndex = model.updatedRecords.indexOf(parentRecord) + totalChildRecordsLength + summaryRowIndex,
                        summaryRecord = proxy._createRecord(item, currentIndex);
                    proxy._isSummaryRow = true;
                    summaryRecord.level = parentRecord.level + 1;
                    summaryRecord.parentItem = parentRecord;
                    summaryRecord.isSummaryRow = true;
                    summaryRecord.index = model.flatRecords.length + 1;
                    if (model.enableVirtualization) {                        
                            model.updatedRecords.splice(currentIndex, 0, summaryRecord);
                            if (!args || (args && args.filterCollection))
                                model.summaryRowRecords.push(model.updatedRecords[currentIndex]);
                    }
                    else {
                        model.updatedRecords.splice(currentIndex, 0, summaryRecord);
                        model.summaryRowRecords.push(model.updatedRecords[currentIndex]);
                    }
                    currentIndex = model.flatRecords.indexOf(parentRecord) + totalChildRecordsLength + summaryRowIndex;
                    model.flatRecords.splice(currentIndex, 0, summaryRecord);
                    var getExistingSummaryChild = parentRecord.childRecords.filter(function (data) {
                        if (data.isSummaryRow && summaryRecord.summaryColumn.summaryType == data.summaryColumn.summaryType) {
                            return true;
                        }
                    });

                    if (getExistingSummaryChild.length > 0) {
                        var index = parentRecord.childRecords.indexOf(getExistingSummaryChild[0]);
                        parentRecord.childRecords.splice(index, 1);
                        parentRecord.childRecords.push(summaryRecord);
                    }
                    else
                        parentRecord.childRecords.push(summaryRecord);
                    item = {};
                    if (summaryRowIndex == summaryRowLength) {
                        summaryRecord.isLastSummary = true;
                    }
                }
                proxy._flatChildRecords = [];
            }
            proxy._isSummaryRow = false;
            proxy._summaryRowsCount = parentRecords.length;
            if (model.enableVirtualization) {
                model.updatedRecords = proxy.getExpandedRecords(model.updatedRecords);
                if (model.enableAltRow)
                    proxy.updateAltRow();
            }
            this._updateCurrentViewData();
        },
        //Get all inner parent records for Virtualization is true
        _getInnerParentRecords: function (records, proxy, parentRecords) {
            var recordLength = records.childRecords.length;

            for (var count = 0; count < records.childRecords.length; count++) {
                
                if (records.childRecords[count].hasChildRecords) {
                    if (parentRecords.indexOf(records.childRecords[count]) == -1)
                        parentRecords.push(records.childRecords[count]);
                    proxy._getInnerParentRecords(records.childRecords[count], proxy, parentRecords);
                }
            }           
        },

        //Get all parent records from updated records.
        _getParentRecords: function (updatedRecords, proxy, rootParent) {
            var recordLength = updatedRecords.length, record, parentRecords = [];
            for (var length = 0; length < recordLength; length++) {
                record = updatedRecords[length];
                if (rootParent) {
                    if (ej.isNullOrUndefined(record.parentItem))
                        parentRecords.push(record);
                }
                else if (record.childRecords && record.childRecords.length > 0) {
                    if ((proxy.model.enableVirtualization) || (proxy.model.allowPaging && proxy.model.showSummaryRow)) {
                        if (parentRecords.indexOf(record) == -1)
                            parentRecords.push(record);
                        proxy._getInnerParentRecords(record, proxy, parentRecords);
                    }
                    else
                        parentRecords.push(record);
                }
            }
            return parentRecords;
        },
        //To get all child and grand child of one parent record when the datasource is in hierarchy form.
        _getChildRecordsLength: function (parentRecord, updatedRecords) {
            var proxy = this,
                recordLength = updatedRecords.length, record;
            for (var length = 0; length < recordLength; length++) {
                record = updatedRecords[length];
                if (record.summaryRow)
                    continue;
                if (parentRecord == record.parentItem) {
                    proxy._flatChildRecords.push(record);
                    if (record.hasChildRecords)
                        proxy._getChildRecordsLength(record, updatedRecords);
                }
            }
            return proxy._flatChildRecords.length;
        },

        //Assign the values for item properties to create a summary record.
        _createSummaryItem: function (item, targetSummaryRow, parentRecord) {
            var proxy = this,
                summaryColumns = targetSummaryRow.summaryColumns,
                summaryColumnsLength = summaryColumns.length;
            for (var columnLength = 0; columnLength < summaryColumnsLength; columnLength++) {
                var targetSummaryColumn = summaryColumns[columnLength],
                    prefix = targetSummaryColumn.prefix,
                    suffix = targetSummaryColumn.suffix,
                    displayColumn = targetSummaryColumn.displayColumn;

                if (ej.isNullOrUndefined(displayColumn))
                    displayColumn = targetSummaryColumn.dataMember;
                if (ej.isNullOrUndefined(prefix))
                    prefix = "";
                if (ej.isNullOrUndefined(suffix))
                    suffix = "";
                item.summaryColumn = targetSummaryColumn;
                item.summaryRow = targetSummaryRow;

                for (var key in item) {
                    if (key == displayColumn) {
                        if (item[key])
                            item[key] = item[key] + " " + prefix + proxy._getSummaryValues(targetSummaryColumn, proxy._flatChildRecords) + suffix;
                        else
                            item[key] = prefix + proxy._getSummaryValues(targetSummaryColumn, proxy._flatChildRecords) + suffix;
                    }
                }
            }
            return item;
        },

        //Calculate the summary values.
        _getSummaryValues: function (summaryColumn, summaryData) {
            var dataMember = summaryColumn.dataMember, format = summaryColumn.format,
                jsonData = summaryData;
            var dbMgr, $value;
            if (jsonData instanceof ej.DataManager) {
                dbMgr = jsonData;
                jsonData = jsonData.dataSource.json;
            } else
                dbMgr = ej.DataManager(jsonData);
            switch (summaryColumn.summaryType) {
                case ej.TreeGrid.SummaryType.Sum:
                    $value = ej.sum(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.Average:
                    $value = ej.avg(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.Maximum:
                    var obj = ej.max(jsonData, dataMember);
                    $value = parseInt(this._getCustomCellValue(obj, summaryColumn.dataMember));
                    break;
                case ej.TreeGrid.SummaryType.Minimum:
					var filteringData = jsonData.filter(function (data) {
                        if (data[dataMember] !== "")
                            return true;
                    });
                    var obj = ej.min(filteringData, dataMember);
                    $value = parseInt(this._getCustomCellValue(obj, summaryColumn.dataMember));
                    break;
                case ej.TreeGrid.SummaryType.MaximumDate:
                    $value = this._getMaxDate(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.MinimumDate:
                    $value = this._getMinDate(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.Count:
                    $value = jsonData.length;
                    break;
                case ej.TreeGrid.SummaryType.TrueCount:
                    var predicate = ej.Predicate(summaryColumn.dataMember, "equal", true);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
                case ej.TreeGrid.SummaryType.FalseCount:
                    var predicate = ej.Predicate(summaryColumn.dataMember, "equal", false);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
            }
            if (!ej.isNullOrUndefined(format))
                $value = this.formatting(format, $value, this.model.locale);
            return $value;
        },
        // To Get Maximum Date of Particular Datamember in JSON data.
        _getMaxDate: function (jsonData, dataMember) {
            var max = 0;
            var maxDate = null;
            for (var i = 0; i < jsonData.length; i++) {
                var item = jsonData[i],
                    date = new Date(item[dataMember]),
                    time = date.getTime();
                if (time > max) {
                    max = time;
                    maxDate = item[dataMember];
                }
            }

            return maxDate;
        },
        // To Get Minimum Date of Particular Datamember in JSON data.
        _getMinDate: function (jsonData, dataMember) {
            var firstMinDate = new Date(jsonData[0][dataMember]),
                min = firstMinDate.getTime();
            var minDate = jsonData[0][dataMember];
            for (var i = 0; i < jsonData.length; i++) {
                var item = jsonData[i],
                    date = new Date(item[dataMember]),
                    time = date.getTime();
                if (time < min) {
                    min = time;
                    minDate = item[dataMember];
                }
            }

            return minDate;
        },
        /*Create new summary records and re render all records*/
        _createAndRenderSummaryRecords: function (args)
        {
            var proxy = this;
            proxy._createSummaryRow(args);
            var refreshArgs = {};
            refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
            proxy.sendDataRenderingRequest(refreshArgs);
            proxy.updateCollapsedRecordCount();
            proxy.updateHeight();
        },
        //Update the summary after add, edit or delete the record.
        _updateSummaryRow: function (args) {
            var proxy = this, model = proxy.model, summaryRow,
                editedRecord, editedRecordIndex, updatedSummaryRecords = [],
                _pRecords = [], cellvalue,
            updatedRecords = proxy.getUpdatedRecords();

            if (args && args.requestType == "dragAndDrop") {
                args.rowIndex = updatedRecords.indexOf(proxy._droppedRecord);
            }
            if (args && args.requestType == "delete") {
                proxy._updateAfterDeleteRecord(args);
                return;
            }

            if (args && args.editType == "celledit") {
                if (args.columnObject.editType == "numericedit") {
                    cellvalue = parseInt(args.value);
					args.value = isNaN(cellvalue) ? "" : cellvalue;
                    args.data[args.columnName] = args.value;
                }
                args.currentValue = args.value;
                var rowIndex = proxy.getIndexByRow(args.rowElement);
                var data = model.enableVirtualization ? model.currentViewData[rowIndex] : updatedRecords[rowIndex];
                args.rowIndex = updatedRecords.indexOf(data);
            }
            if ((args.currentValue != args.previousValue) || args.requestType == "dragAndDrop"
                || args.requestType == "addNewRow") {
                editedRecord = args.requestType == "addNewRow" ? model.updatedRecords[args.rowIndex] : updatedRecords[args.rowIndex];
                if (editedRecord.parentItem)
                    _pRecords = proxy._getpRecords(editedRecord, proxy);
                if (ej.isNullOrUndefined(_pRecords))
                    return;
                for (var parentLength = 0; parentLength < _pRecords.length; parentLength++) {
                    var summaryRowRecords = model.summaryRowRecords, recordindex, columnIndex;
                    proxy._getChildRecordsLength(_pRecords[parentLength], updatedRecords);
                    $.each(summaryRowRecords, function (index, record) {
                        summaryRow = record.summaryRow;
                        if (record.parentItem === _pRecords[parentLength]) {
                            var summaryColumnLength = summaryRow.summaryColumns.length;
                            for (var length = 0; length < summaryColumnLength; length++) {
                                var summaryColumn = summaryRow.summaryColumns[length],
                                    prefix = summaryColumn.prefix,
                                    suffix = summaryColumn.suffix;
                                if (ej.isNullOrUndefined(prefix))
                                    prefix = "";
                                if (ej.isNullOrUndefined(suffix))
                                    suffix = "";
                                if (args.editType == "rowedit") {
                                    args.columnName = summaryColumn.dataMember;
                                    var columnList = model.columns,
                                        dataMemberColumnIndex = proxy.getColumnIndexByField(args.columnName);
                                    //To convert empty string to integer while adding the new row.    
                                    if (model.columns[dataMemberColumnIndex].editType == "numericedit")
                                        editedRecord[args.columnName] = parseInt(editedRecord[args.columnName]);
                                }
                                var displayColumn = summaryColumn.displayColumn;
                                if (!displayColumn)
                                    displayColumn = summaryColumn.dataMember;
                                if (model.enableVirtualization)
                                    recordindex = model.currentViewData.indexOf(record);
                                else
                                    recordindex = updatedRecords.indexOf(record);
                                columnIndex = proxy.getColumnIndexByField(displayColumn);
                                args.data = record;

                                if (proxy._frozenColumnsLength > 0) {
                                    if (proxy._frozenColumnsLength > columnIndex)
                                        args.rowElement = $(proxy.getRows()[0][recordindex]);
                                    else {
                                        args.rowElement = $(proxy.getRows()[1][recordindex]);
                                        columnIndex -= proxy._frozenColumnsLength;
                                    }
                                } else {
                                    args.rowElement = $(proxy.getRows()[recordindex]);
                                }
                                args.cellElement = args.rowElement.find(".e-rowcell").eq(columnIndex);

                                var value = proxy._getSummaryValues(summaryColumn, proxy._flatChildRecords);
                                record[displayColumn] = prefix + value + suffix;
                                args.cellElement.empty().html(prefix + value + suffix);
                                updatedSummaryRecords.push(record);
                            }
                        }
                    });
                    proxy._flatChildRecords = [];
                    proxy._summaryRowCount = _pRecords.length;
                }
            }
        },
        //Update the Total summary after add, edit or delete the record.
        _updateTotalSummaryRow: function (args) {
            if (args.requestType == "dragAndDrop" || args.isDragAndDropDelete)
                return;
            var proxy = this, model = proxy.model, summaryRows = model.summaryRows, summaryColumns, summaryRow,
                summaryColumnsLength, record, summaryRowLength = summaryRows.length, displayColumn, recordindex, columnIndex;
            if (model.updatedRecords.length == 0) {
                $("#" + proxy._id + "-footersummaryrow").hide();
                return;
            }
            else
                $("#" + proxy._id + "-footersummaryrow").show();
            for (var length = 0; length < summaryRowLength; length++) {
                summaryRow = summaryRows[length];
                summaryColumns = summaryRow.summaryColumns;
                summaryColumnsLength = summaryColumns.length;
                record = proxy._footerSummaryRecord[length];
                for (var columnLength = 0; columnLength < summaryColumnsLength; columnLength++) {
                    var summaryColumn = summaryColumns[columnLength],
                        prefix = summaryColumn.prefix,
                        suffix = summaryColumn.suffix;
                    if (ej.isNullOrUndefined(prefix))
                        prefix = "";
                    if (ej.isNullOrUndefined(suffix))
                        suffix = "";
                    if (args.editType == "rowedit")
                        args.columnName = summaryColumn.dataMember;
                    if (!displayColumn)
                        displayColumn = summaryColumn.dataMember;
                    if (summaryColumn.dataMember == args.columnName || args.requestType == "delete"
                        || args.requestType == "filtering" || args.requestType == "addNewRow") {
                        displayColumn = summaryColumn.displayColumn;
                        recordindex = proxy._footerSummaryRecord.indexOf(record);
                        columnIndex = proxy.getColumnIndexByField(displayColumn);
                        args.data = record;
                        if (this._frozenColumnsLength > 0) {
                            if (this._frozenColumnsLength > columnIndex)
                                args.rowElement = this._getFooterRows()[0][recordindex];
                            else {
                                args.rowElement = this._getFooterRows()[1][recordindex];
                                columnIndex -= this._frozenColumnsLength;
                            }
                        } else {
                            args.rowElement = this._getFooterRows()[recordindex];
                        }
                        args.cellElement = args.rowElement.childNodes[columnIndex];
                        var footerUpdatedRecords = proxy._spliceSummaryRows(model.updatedRecords),
                        value = proxy._getSummaryValues(summaryColumn, footerUpdatedRecords);
                        record[displayColumn] = prefix + value + suffix;
                        args.cellElement.innerHTML = prefix + value + suffix;
                    }
                }
            }
        },
        //Update summary row after deleted the record.
        _updateAfterDeleteRecord: function (args) {
            var proxy = this, model = proxy.model, summaryRow,
                editedRecord, editedRecordIndex, updatedSummaryRecords = [],
                _pRecords,
                deletedRecord = args.data;
            if (deletedRecord.parentItem)
                _pRecords = proxy._getpRecords(deletedRecord, proxy);
            if (ej.isNullOrUndefined(_pRecords))
                return;
            for (var parentLength = 0; parentLength < _pRecords.length; parentLength++) {
                var summaryRowRecords = model.summaryRowRecords,
                    childRecords = _pRecords[parentLength].childRecords;
                if (childRecords.length == 0)
                    continue;
                proxy._getChildRecordsLength(_pRecords[parentLength], model.updatedRecords);
                $.each(summaryRowRecords, function (index, record) {
                    summaryRow = record.summaryRow;
                    if (record.parentItem === _pRecords[parentLength]) {
                        var summaryColumnLength = summaryRow.summaryColumns.length;
                        for (var length = 0; length < summaryColumnLength; length++) {
                            var summaryColumn = summaryRow.summaryColumns[length],
                                displayColumn = summaryColumn.displayColumn,
                                recordindex = model.updatedRecords.indexOf(record),
                                columnIndex = proxy.getColumnIndexByField(displayColumn),
                                 prefix = summaryColumn.prefix,
                                 suffix = summaryColumn.suffix;
                            if (ej.isNullOrUndefined(prefix))
                                prefix = "";
                            if (ej.isNullOrUndefined(suffix))
                                suffix = "";
                            args.data = record;
                            if (proxy._frozenColumnsLength > 0) {
                                if (proxy._frozenColumnsLength > columnIndex)
                                    args.tr = $(proxy.getRows()[0][recordindex]);
                                else {
                                    args.tr = $(proxy.getRows()[1][recordindex]);
                                    columnIndex -= proxy._frozenColumnsLength;
                                }
                            } else {
                                args.tr = $(proxy.getRows()[recordindex]);
                            }
                            args.tr = $(proxy.getRows()[recordindex]);
                            args.cellElement = args.tr.find(".e-rowcell").eq(columnIndex);
                            var value = proxy._getSummaryValues(summaryColumn, proxy._flatChildRecords);
                            record[displayColumn] = prefix + value + suffix;
                            args.cellElement.empty().html(prefix + value + suffix);
                        }
                        updatedSummaryRecords.push(record);
                    }

                })
                proxy._flatChildRecords = [];
            }
        },
        //To get parent and grand Parent of one Child record.
        _getpRecords: function (record, proxy) {
            var recordParents = [];
            do {
                record = record.parentItem;
                recordParents.push(record);
            } while (record.parentItem);
            return recordParents;
        },

        //RENDER THE GRIDCONTENT
        _renderGridContent:function(){
            
            var proxy = this,
                doc = document,
                model = proxy.model,
                $tbody = $(doc.createElement('tbody')),
                $div = ej.buildTag("div.e-gridcontent#" + proxy._id + "e-gridcontent", "",
                {                    
                    "height": proxy._viewPortHeight
                }),
                $innderDiv = ej.buildTag('div.e-gridcontainer#' + proxy._id + "e-gridcontainer", "", {}, {}),
                //Insert e-contet div for ejScroller
                $scrolllerContentDiv = ej.buildTag('div', {}, { "width": "auto", "height": "auto" });
                $scrolllerContentDiv.append($innderDiv);
            //CHECK VIRTUALIZATION ENABLED OR NOT
            if (model.enableVirtualization || model.allowPaging) {
                $innderDiv.css({ 'height': proxy._totalHeight });
            }

            if (this._frozenColumnsLength > 0) {
                $innderDiv.html(proxy._renderByFrozenDesign());
                proxy.setGridContentTable($innderDiv.find(".e-table"));

            }
            else {
                var $table = ej.buildTag('table.e-table#' + proxy._id + "e-table", "",
                    { top: "0px", "position": "relative" }, { 'cellspacing': '0px', "border-spacing": "0px" });
                $table.append(proxy.getHeaderTable().find('colgroup').clone()).append($tbody);
                $innderDiv.html($table);
                proxy.setGridContentTable($table);
            }
            $div.html($scrolllerContentDiv);
            proxy._$gridContent = $div;
            //CHECK DATASOURCE IS DEFINED OR NOT
            if (this.dataSource() === null || this.model.currentViewData.length == 0) {
                if (this._frozenColumnsLength > 0) {
                    var $emptyTd = ej.buildTag('td', model.emptyRecordText, {}, { colSpan: this._frozenColumns.length });
                    $innderDiv.find("#e-frozencontentdiv" + proxy._id + " .e-table tbody").append($(doc.createElement("tr")).append($emptyTd));
                    $emptyTd = ej.buildTag('td', model.emptyRecordText, { visibility: "hidden" }, { colSpan: this._unFrozenColumns.length });
                    $innderDiv.find("#e-movablecontentdiv" + proxy._id + " .e-table tbody").append($(doc.createElement("tr")).append($emptyTd));
                } else {
                    var $emptyTd = ej.buildTag('td', model.emptyRecordText, {}, { colSpan: model.columns.length });
                    $tbody.append($(doc.createElement("tr")).append($emptyTd));
                    $innderDiv.css('height', model.rowHeight);
                }
            } else
            {
                proxy.renderRecords();
            }

            if (!model.isFromGantt) {
                $div.css({
                    "border-bottom-style": "solid",
                    "border-bottom-width": "1px",
                    "border-left-style": "solid",
                    "border-left-width": "1px",
                    "border-right-style": "solid",
                    "border-right-width": "1px",
                    "width": "auto",
                    "height": "auto",
                    "cursor": "default"
                });
            } else {
                $div.css({
                    "border-left-style": "solid",
                    "border-left-width": "1px"
                });
            }
            return $div;

        },


        //AFTER INITIALIZATION END RENDERING
        _initialEndRendering: function () {

            var proxy = this, model = proxy.model, currentSelectingRecord,
                expandedRecords = proxy.getExpandedRecords(model.updatedRecords),
                index = proxy.selectedRowIndex(), cellIndexes = proxy.selectedCellIndexes();

            if (model.allowSelection) {
                if (model.selectionSettings.selectionMode == "row" && index != -1 && !model.isFromGantt) {
                if (model.showSummaryRow) {
                    var recordsWithOutSummary = proxy._spliceSummaryRows(model.updatedRecords),
                        currentSelectedRecord = recordsWithOutSummary[index];
                    index = model.updatedRecords.indexOf(currentSelectedRecord);                    
                }
                if (!proxy._rowSelectingEventTrigger(this._previousIndex, index)) {
                    proxy.selectRows(index);
                    proxy._cancelSaveTools();
                    proxy._rowSelectedEventTrigger(index);

                }
            }
                if (model.selectionSettings.selectionMode == "cell" && cellIndexes.length > 0) {
                    proxy.selectedRowIndex(-1);
                    proxy.selectCells(cellIndexes);
                    proxy._cancelSaveTools();
                }
                }

            /* treegrid rendering completed here at load time*/
            proxy._isRendered = true;

            proxy._trigger("refresh");
            proxy._eventBindings();
            proxy._hideCollapsedDetailsRows();
        },

        //#endregion
        
        //#region TEMPLATE

        //ADD CELLEDITING TEMPLATE
        _addCellEditTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                columnCount = 0,
                $outerDiv = ej.buildTag('div', "", { display: 'none' }, { id: proxy._id + "_CellEditTemplate" }),
                $innerDiv, columnField;

            for (columnCount = 0; columnCount < columns.length; columnCount++) {
                if (columns[columnCount]) {
                    columnField = proxy._getFieldValue(columns[columnCount].field, columnCount);
                    $innerDiv = ej.buildTag('div', "", {}, { id: columnField + "_CellEdit" });
                    ej.TreeGrid._initCellEditType(proxy, $innerDiv, proxy._id, columnCount);
                    $outerDiv.append($innerDiv);
                }
            }

            if ($outerDiv.children().length) {
                proxy._cellEditTemplate = $outerDiv;
            }

        },

        _getState: function () {
            if (this.data.parentItem)
                return false;
            else
                return true;
        },

        _getCellIndex: function (array, findItem) {
            var proxy = this, cellIndexArray = [];
            for (var i = 0; i < array.length; i++) {
                cellIndexArray[i] = array[i][findItem];
            }
            return cellIndexArray;
        },
        _getSelectedCellClass: function (data, columnCount) {
            var proxy = this, model = proxy.model,
                columnIndex = parseInt(columnCount),
                selectedCellDetails = proxy._selectedCellDetails;
            if (model.selectionSettings.selectionMode == "cell" && selectedCellDetails.length > 0) {
                    proxy._getSelectedCellsinARow(data.index, selectedCellDetails);
                if (proxy._selectedCellsinARow.length > 0) {
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                        var currentSelectingCellIndex = proxy._getCellIndex(proxy._selectedCellsinARow,"cellIndex").indexOf(columnIndex);
                    else
                        var currentSelectingCellIndex = proxy._selectedCellsinARow.map(function (e) { return e.cellIndex }).indexOf(columnIndex);                    
                    if (currentSelectingCellIndex != -1) {
                        if (proxy._selectedCellsinARow[currentSelectingCellIndex].cellIndex == columnIndex)
                            return "selectingcell";
                    }
                }
            }
            return "";
        },

        _getSelectedCellsinARow: function (recordIndex, selectedCellDetails) {
            var proxy = this;
            proxy._selectedCellsinARow = [];
            selectedCellDetails.forEach(function (selectedcell) {
                if (selectedcell.data.index == recordIndex)
                    proxy._selectedCellsinARow.push(selectedcell);
            });
            proxy._currentRecordIndex = recordIndex;
        },
        _getrowName: function () {
            var rowClass = "gridrowIndex",
                proxy = this;
            rowClass += proxy.data.index.toString() + "level" + proxy.data.level.toString();
            return rowClass;
        },
        /* get details row col span with showDetailROwInfoColumn API value */
        _getDetailsColSpan:function(isFrozenTable)
        {
            var model = this.model, visibleColumns = [];
            if (this._frozenColumnsLength > 0) {
                if (!isFrozenTable) {
                    visibleColumns = this._unFrozenColumns.filter(function (value) {
                        return value.visible !== false;
                    });
                    return visibleColumns.length;
                } else {
                    visibleColumns = this._frozenColumns.filter(function (value) {
                        return value.visible !== false;
                    });
                    return visibleColumns.length;
                }
            }
            return model.showDetailsRowInfoColumn ? this._visibleColumns.length + 1 : this._visibleColumns.length;
        },
        /* expand status for details rows */
        _getDetailsExpandStatus: function (data) {
            var proxy = this;
            if (proxy.getExpandStatus(data) && data.isDetailsExpanded) {
                return true;
            } else
            {
                return false;
            }
        },
        _createDetailsRowTemplate: function (isFrozenTable) {
            var proxy = this,
                model = this.model,
                helpers = {};

            helpers["_" + proxy._id + "getDetailsColSpan"] = $.proxy(proxy._getDetailsColSpan, proxy);
            helpers["_" + proxy._id + "getDetailsExpandStatus"] = $.proxy(proxy._getDetailsExpandStatus, proxy);
            helpers["_" + proxy._id + "getExpandStatus"] = $.proxy(proxy.getExpandStatus, proxy);
            
            $.views.helpers(helpers);

            var tr = '{{if !isSummaryRow && !footerSummaryRowRecord}}' + "<tr class='e-detailsrow e-treegridrows detailsrow{{:~_" + proxy._id + "rowClassName()}} {{if isDetailsExpanded}}" +
                      "e-detailsrowexpanded{{else}}e-detailsrowcollapsed{{/if}}{{if !~_" + proxy._id + "getExpandStatus(#data) && isDetailsExpanded}} collapsedrowexpandeddetailsrow{{/if}}' " +
                      "style='{{if ~_" + proxy._id + "getDetailsExpandStatus(#data)}}display:table-row;{{else}}visibility:none;{{/if}}height:" + model.detailsRowHeight + "px;'>" +
                      "<td class='e-detailsrowcell' colspan='{{:~_" + proxy._id + "getDetailsColSpan(" + isFrozenTable + ")}}'>" +
                      "<div class='e-detailscellwrapper' style='height:" + (model.detailsRowHeight - 1) + "px;'>";

            var templateString = "";
            if (model.detailsTemplate && model.detailsTemplate.length > 0) {

                if (document.getElementById(model.detailsTemplate))
                {
                    templateString = "#" + model.detailsTemplate;
                } else
                {
                    templateString = model.detailsTemplate;
                }
            }
            if (!isFrozenTable) {
                $("#treeGridDetailsRowTemplateElement" + proxy._id).remove();
                var scriptElement = this._createDetailRowTemplateElement(templateString);
                tr += "{{:~_treeGridTemplating('" + scriptElement.id + "')}}";
            }
            tr += "</div></td></tr>";
            tr += "{{/if}}";
            if (!isFrozenTable) {
                var templates = {};
                templates[proxy._id + "_detailRowTemplate"] = tr;
                $.templates(templates);
            }
            return tr;

        },

        _SelectState:function(args){
            var proxy = this,
                model = this.model;
            if (model.allowSelection)
                return true;
            else
                return false;
        },
        //ADD TEMPLATE FOR RENDERING GRIDCONTENT
        _addInitTemplate:function(){

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                columnCount = 0,
                length = columns.length,
                columnName,
                column,
                tdCell,
                summaryTitle,
                helpers = {};

            //CHECK THE COLUMNS ARRAY CONTAIN THE COLUMN OBJECT
            if (columns.length === 0) {
                return false;
            }
            if (this._frozenColumnsLength > 0) {
                this.addFrozenTemplate();
                if (model.showTotalSummary)
                    this.addFrozenSummaryTemplate();
            }
            helpers["_" + proxy._id + "rowClassName"] = ej.TreeGrid._getrowClassName;
            helpers["_" + proxy._id + "SummaryRowtdClassName"] = ej.TreeGrid._getSummaryRowtdClassName;
            helpers["_" + proxy._id + "isSelectedCell"] = $.proxy(proxy._getSelectedCellClass, proxy);
            helpers["_" + proxy._id + "summaryTitle"] = proxy._getSummaryTitle;
            // helpers for drag row indicator icon class
            helpers["_" + proxy._id + "rowName"] = proxy._getrowName;
            helpers["getState"] = proxy._getState;
            helpers["SelectState"] = $.proxy(proxy._SelectState, proxy);
            helpers["_" + proxy._id + "expandStatus"] = $.proxy(proxy._getExpandStatusRecord, proxy);         
            helpers["_" + proxy._id + "cellValue"] = $.proxy(proxy._getCellValue, proxy);
            helpers["_" + proxy._id + "TemplateCellValue"] = $.proxy(proxy._getTemplateCellValue, proxy);
            helpers["_" + proxy._id + "isTreeColumnIndex"] = $.proxy(proxy._isTreeColumnIndex, proxy);
            helpers["_" + proxy._id + "getIndentWidth"] = $.proxy(proxy._getIndentWidth, proxy);
            helpers["_" + proxy._id + "checkColumn"] = $.proxy(proxy._getCellColumn, proxy);
            helpers["_" + proxy._id + "formatting"] = $.proxy(proxy.formatting, proxy);
            helpers["_treeGridTemplating"] = ej.proxy(proxy._gridTemplate, null, proxy);
            helpers["_" + proxy._id + "getCheckboxState"] = $.proxy(proxy._getCheckboxState, proxy);
            helpers["isTrimCell"] = $.proxy(proxy._checkIsTrimCell, proxy);

            $.views.helpers(helpers);

            
            if (model.parseRowTemplate && (model.rowTemplateID.length > 0 || model.altRowTemplateID.length > 0)) {
                
                var altRowTemplateElement = ej.buildTag("tbody", "", {}, {});
                var rowTemplateElement = ej.buildTag("tbody", "", {}, {});
                var rowTemplateHTML = "";
                var altRowTemplateHTML = "";

                var altRowTemplateScript = model.altRowTemplateID.length > 0 ? $("#" + model.altRowTemplateID): $("#" + model.rowTemplateID);
                var rowTemplateScript = model.rowTemplateID.length > 0 ? $("#" + model.rowTemplateID): $("#" + model.altRowTemplateID);
                var altRowTemplate = altRowTemplateScript[0].innerHTML;
                var rowTemplate = rowTemplateScript[0].innerHTML;

                $(altRowTemplateElement[0]).html(altRowTemplate);
                $(rowTemplateElement[0]).html(rowTemplate);

                if (rowTemplateElement[0].childNodes.length > 0) {
                    for (var i = 0; i < rowTemplateElement[0].childNodes.length; i++) {
                        if (rowTemplateElement[0].childNodes[i].nodeName == 'TR') {

                            rowTemplateElement[0].className = rowTemplateElement[0].childNodes[i].className;
                            rowTemplateElement[0].style.cssText = rowTemplateElement[0].childNodes[i].style.cssText;

                            if (rowTemplateElement[0].childNodes[i].childNodes.length > 0) {
                                var tdCount = 0;
                                for (var j = 0; j < rowTemplateElement[0].childNodes[i].childNodes.length; j++) {

                                    var childNode = rowTemplateElement[0].childNodes[i].childNodes[j];

                                    if (childNode.nodeName == 'TD') {
                                        var innerHtml = childNode.innerHTML,
                                            templateId = proxy._id + "RowTemplateElement" + tdCount;

                                        $("#" + templateId).remove();
                                        var scriptElement = this._createRowTemplateElement(innerHtml, templateId, rowTemplateScript[0].type);
                                        childNode.innerHTML = "{{:~_treeGridTemplating('" + scriptElement.id + "')}}";
                                        childNode.className += " e-rowcell e-templatecell";


                                        if (columns[tdCount]) {
                                            column = columns[tdCount];
                                            columnName = column.field;
                                            var visible = column.visible == undefined ? true : column.visible;
                                            //To create a seperate div in summary cell to display a summary title.
                                            var summaryTitlediv = "";
                                            if (column.headerText == proxy._visibleColumns[0]) {
                                                summaryTitlediv = '{{if isSummaryRow || footerSummaryRowRecord}}' + "<div " +
                                                    "class='e-summarytitle{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" + "style='float:left;display:block;'>" + "{{:~_" + proxy._id + "summaryTitle()}}"
                                                     + "</div>" + '{{/if}}';
                                            }

                                            if (tdCount == model.treeColumnIndex) {
                                                var indentDiv = "<div class='e-inner-treecolumn-container' style='height:20px;' unselectable='on'>" +
                                                "{{if hasChildRecords && hasFilteredChildRecords}}" +
                                                "<div class='intend' style='height:1px; float:left;width:{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px; display:inline-block;'>" +
                                                //indicator icons included for drag and drop
                                                "{{if !~getState() || !hasChildRecords }}" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='aboveIcon e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='belowIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='childIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='cancelIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "</div>" +
                                                "{{else !hasChildRecords || (!hasFilteredChildRecords && hasChildRecords)}}" +
                                                "<div " +
                                                "class='intend'" +
                                                "style='height:1px; float:left; width:{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px; display:inline-block;'>" +
                                                //indicator icons included for drag and drop
                                                "{{if !~getState() || !hasChildRecords}}" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='aboveIcon iconMargin e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='belowIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "<span class='childIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "<span class='cancelIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "{{if ~getState() && hasChildRecords}}" +
                                                "<div class='intendparent'>" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='aboveIcon e-icon'  style='position:relative;float:left;display:none;'></span>" +
                                                "<span class='belowIcon e-icon' style='float:left;display:none;'></span>" +
                                                "<span class='childIcon e-icon' style='float:left;display:none;'></span>" +
                                                "<span class='cancelIcon e-icon' style='float:left;display:none;'></span>" +
                                                "</div>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "<div class='{{if expanded && hasFilteredChildRecords}}e-treegridexpand e-icon{{else hasChildRecords && hasFilteredChildRecords}}e-treegridcollapse e-icon{{/if}}' " +
                                                "style='float:left;display:inline-block;font-size:10px;'>" +
                                                "</div>" +
                                                "<div class='e-cell{{if " + (column.showCheckbox && (this.model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox)) + "}} e-treecheckboxcolumn{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}' style='overflow: hidden;'>";

                                                childNode.style.cssText = "padding-left:0px;";

                                                rowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                    + childNode.style.cssText + "'>" + indentDiv + "{{else}}'>{{/if}}" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                                     if (!ej.isNullOrUndefined(column["format"]))
                                                         rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                                     else
                                                         rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                                     rowTemplateHTML += "</div></div></td>";
                                            }
                                            else {
                                                rowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                    + childNode.style.cssText + "{{/if}}'>" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                                if (!ej.isNullOrUndefined(column["format"]))
                                                    rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                                else
                                                    rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                                rowTemplateHTML += "</td>";
                                            }
                                            if (this._frozenColumnsLength > 0 && this._frozenColumnsLength == tdCount + 1) {
                                                var frozenRowTemplate = "";
                                                frozenRowTemplate += rowTemplateHTML;
                                                frozenRowTemplate += "</tr>";
                                                rowTemplateHTML = "";
                                            }
                                            tdCount++;

                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                if (altRowTemplateElement[0].childNodes.length > 0) {
                    for (var i = 0; i < altRowTemplateElement[0].childNodes.length; i++) {
                        if (altRowTemplateElement[0].childNodes[i].nodeName == 'TR') {
                            altRowTemplateElement[0].className = altRowTemplateElement[0].childNodes[i].className;
                            altRowTemplateElement[0].style.cssText = altRowTemplateElement[0].childNodes[i].style.cssText;
                            var tdCount = 0;

                            for (var j = 0; j < altRowTemplateElement[0].childNodes[i].childNodes.length; j++) {

                                var childNode = altRowTemplateElement[0].childNodes[i].childNodes[j];

                                if (childNode.nodeName == 'TD') {

                                    var innerHtml = childNode.innerHTML,
                                        templateId = proxy._id + "AltRowTemplateElement" + tdCount;
                                    $("#" + templateId).remove();
                                    var scriptElement = this._createRowTemplateElement(innerHtml, templateId, altRowTemplateScript[0].type);
                                    childNode.innerHTML = "{{:~_treeGridTemplating('" + scriptElement.id + "')}}";

                                    childNode.className += " e-rowcell e-templatecell";
                                    if (columns[tdCount]) {
                                        column = columns[tdCount];
                                        columnName = column.field;
                                        var visible = column.visible == undefined ? true : column.visible;
                                        //To create a seperate div in summary cell to display a summary title.
                                        var summaryTitlediv = "";
                                        if (column.headerText == proxy._visibleColumns[0]) {
                                            summaryTitlediv = '{{if isSummaryRow || footerSummaryRowRecord}}' + "<div " +
                                                "class='e-summarytitle{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" + "style='float:left;display:block;'>" + "{{:~_" + proxy._id + "summaryTitle()}}"
                                                 + "</div>" + '{{/if}}';
                                        }
                                        if (tdCount == model.treeColumnIndex) {
                                            var indentDiv = "<div class='e-inner-treecolumn-container' style='height:20px;'>" +
                                            "{{if hasChildRecords && hasFilteredChildRecords}}" +
                                            "<div class='intend' style='height:1px; float:left;width:{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px; display:inline-block;'>" +
                                             //indicator icons included for drag and drop
                                            "{{if !~getState() || !hasChildRecords }}" +
                                            "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                            "<span class='aboveIcon e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='belowIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='childIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='cancelIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                            "</div>" +
                                            "{{/if}}" +
                                            "</div>" +
                                            "{{else !hasChildRecords || (!hasFilteredChildRecords && hasChildRecords)}}" +
                                            "<div " +
                                            "class='intend'" +
                                            "style='height:1px; float:left; width:{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px; display:inline-block;'>" +
                                            //indicator icons included for drag and drop
                                            "{{if !~getState() || !hasChildRecords}}" +
                                            "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                            "<span class='aboveIcon iconMargin e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='belowIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                            "<span class='childIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                            "<span class='cancelIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                            "</div>" +
                                            "{{/if}}" +
                                            "</div>" +
                                            "{{/if}}" +
                                            "{{if ~getState() && hasChildRecords}}" +
                                            "<div class='intendparent'>" +
                                            "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                            "<span class='aboveIcon e-icon'  style='position:relative;float:left;display:none;'></span>" +
                                            "<span class='belowIcon e-icon' style='float:left;display:none;'></span>" +
                                            "<span class='childIcon e-icon' style='float:left;display:none;'></span>" +
                                            "<span class='cancelIcon e-icon' style='float:left;display:none;'></span>" +
                                            "</div>" +
                                            "</div>" +
                                            "{{/if}}" +
                                            "<div class='{{if expanded&& hasFilteredChildRecords}}e-treegridexpand e-icon{{else hasChildRecords && hasFilteredChildRecords}}e-treegridcollapse e-icon{{/if}}' " +
                                            "style='float:left;display:inline-block;font-size:10px;'></div>" +
                                            "<div class='e-cell{{if " + column.showCheckbox + "}} e-treecheckboxcolumn{{/if}}{{if  ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}' style='overflow:hidden'>";

                                            childNode.style.cssText = "padding-left:0px;";

                                            altRowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                 + childNode.style.cssText + "'>" + indentDiv + "{{else}}'>{{/if}}" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                            if (!ej.isNullOrUndefined(column["format"]))
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                            else
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                            altRowTemplateHTML += "</div></div></td>";

                                        }
                                        else {
                                            altRowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                    + childNode.style.cssText + "{{/if}}'>" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                            if (!ej.isNullOrUndefined(column["format"]))
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                            else
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                            altRowTemplateHTML += "</td>";
                                        }
                                        if (this._frozenColumnsLength > 0 && this._frozenColumnsLength == tdCount + 1) {
                                            var frozenAltRowTemplate = "";
                                            frozenAltRowTemplate += altRowTemplateHTML;
                                            frozenAltRowTemplate += "</tr>";
                                            altRowTemplateHTML = "";
                                        }
                                        tdCount++;
                                    }
                                }
                            }
                        }
                    }
                }
               
                /* add details column to end of headers */
                if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn) {
                    altRowTemplateHTML += "<td class='{{if isSelected && ~SelectState()}}e-selectionbackground{{/if}} {{if isDetailsExpanded}}e-detailsrowexpand{{else}}e-detailsrowcollapse{{/if}}  " +
                                          "e-detailsrowcell{{if isLastSummary}} e-lastsummaryrow{{/if}}'>{{if !isSummaryRow && !footerSummaryRowRecord}}<div class='e-detailsiconcell e-icon {{if isDetailsExpanded}}e-detailsinfoiconhide{{else}}e-detailsinfoiconshow{{/if}}'></div>{{/if}}";
                    rowTemplateHTML += "<td class='{{if isSelected && ~SelectState()}}e-selectionbackground{{/if}} {{if isDetailsExpanded}}e-detailsrowexpand{{else}}e-detailsrowcollapse{{/if}}  " +
                                        "e-detailsrowcell{{if isLastSummary}} e-lastsummaryrow{{/if}}'>{{if !isSummaryRow && !footerSummaryRowRecord}}<div class='e-detailsiconcell e-icon {{if isDetailsExpanded}}e-detailsinfoiconhide{{else}}e-detailsinfoiconshow{{/if}}'></div>{{/if}}";
                }

                var trRow = "{{if isAltRow}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + altRowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + altRowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + altRowTemplateHTML + "</tr>"

                    + "{{else}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + rowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + rowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + rowTemplateHTML + "</tr>" +
                    "{{/if}}";


                var frozenTrRow = "{{if isAltRow}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + altRowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + altRowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + frozenRowTemplate + "</tr>"

                    + "{{else}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + rowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + rowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + frozenAltRowTemplate + "</tr>" +
                    "{{/if}}";
            } else if (!model.parseRowTemplate && (model.rowTemplateID.length > 0 || model.altRowTemplateID.length > 0)) {
                /*Render rowTemplates without parsing*/
                if (model.rowTemplateID && model.altRowTemplateID) {
                    trRow = "{{if isAltRow}}" + $("#" + model.rowTemplateID).html().trim() + "{{else}}" + $("#" + model.altRowTemplateID).html().trim() + "{{/if}}";
                }
                else if (model.rowTemplateID.length > 0) {
                    trRow = $("#" + model.rowTemplateID).html().trim();
                } else if (model.altRowTemplateID.length > 0) {
                    trRow = $("#" + model.altRowTemplateID).html().trim();
                }   
            }

            else {

                var trRow = "<tr class='e-treegridrows {{:~_" + proxy._id + "rowClassName()}} ";

                if (model.enableAltRow) {
                    trRow += "{{if isAltRow}}e-alt-row{{/if}} ";
                }

              
                var tdCellCollections = "";
                for (columnCount = 0; columnCount < length; columnCount++) {
                    if (columns[columnCount]) {
                        columnName = columns[columnCount].field;
                        column = columns[columnCount];
                        var visible = columns[columnCount].visible == undefined ? true : columns[columnCount].visible;
                        var textAlign = columns[columnCount].textAlign;
                        //To create a seperate div in summary cell to display a summary title.
                        summaryTitlediv = "";
                        if (column.headerText == proxy._visibleColumns[0]) {
                            summaryTitlediv = '{{if isSummaryRow || footerSummaryRowRecord}}' + "<div " +
                                "class='e-summarytitle{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" + "style='float:left;display:block;'>" + "{{:~_" + proxy._id + "summaryTitle()}}"
                                 + "</div>" + '{{/if}}';
                        }

                        //CHECK THE template COLUMN OR NOT
                        if (column["isTemplateColumn"]) {

                            trRow += "e-templaterow "

                            var templateId = column["templateID"],
                                template = column["template"],
                                angularTemplate = column["angularTemplate"];

                            if (angularTemplate) {
                                $("#" + proxy._id + column.headerText + columnCount + "_Template").remove();
                                var scriptElement = this._createTemplateElement(column);

                                tdCell = "<td " +
                                     "class='{{if !isSummaryRow && !footerSummaryRowRecord}} e-intend{{/if}} e-rowcell e-templatecell{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" +
                                     "style='text-Align:" + textAlign + "'" +
                                     "role='gridcell'>" +
                                     '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                     "{{:~_treeGridTemplating('" + scriptElement.id + "')}}" +
                                     '{{else}}' + summaryTitlediv + '{{/if}}';

                                     if (!ej.isNullOrUndefined(column["format"]))
                                         tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                     else
                                         tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                     tdCell += "</td>";
                            }
                            else if (templateId) {
                                
                                tdCell = "<td "+
                                     "class='{{if !isSummaryRow && !footerSummaryRowRecord}} e-intend{{/if}} e-rowcell e-templatecell{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" +
                                     " style='text-Align:" + textAlign + ";padding-left:10px;'" +
                                     " role='gridcell'>" +
                                     '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                      $("#" + templateId)[0].innerHTML +
                                      '{{else}}' + summaryTitlediv + '{{/if}}';

                                if (!ej.isNullOrUndefined(column["format"]))
                                    tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                else
                                    tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';

                                tdCell += "</td>";

                            }
                            else if (template) {

                                tdCell = "<td " +
                                     "class='{{if !isSummaryRow && !footerSummaryRowRecord}} e-intend{{/if}} e-rowcell e-templatecell{{if isSelected && ~SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" +
                                     " style='text-Align:" + textAlign + "';padding-left:10px;" +
                                     " role='gridcell'>" +
                                     '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                     template +
                                       '{{else}}' + summaryTitlediv + '{{/if}}';

                                if (!ej.isNullOrUndefined(column["format"]))
                                    tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                else
                                    tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';

                                tdCell += "</td>";
                            }

                            //EXPAND COLLAPSE COLUMN BASED ON THE TREECOLUMNINDEX
                        } else if (columnCount === model.treeColumnIndex) {

                            tdCell = "<td " +
                                 "class='{{if isSelected && ~SelectState()}}e-rowcell e-selectionbackground e-intend {{else}}e-rowcell {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if !isSummaryRow && !footerSummaryRowRecord}} e-intend{{/if}} {{/if}} {{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('"+column['clipMode']+"')}} e-treegridtrimcell{{/if}}'" +
                                 "style='padding-left:{{if ~_" + proxy._id + "isTreeColumnIndex('" + columnName + "') && isSummaryRow }}{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px{{/if}};background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                 "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                 "role='gridcell'>" +
                                 '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                 "<div class='e-inner-treecolumn-container' style='height:20px;'>" +
                                 "{{if hasChildRecords && hasFilteredChildRecords}}" +
                                 "<div " +
                                 "class='intend'" +
                                 "style='height:1px; float:left; width:{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px; display:inline-block;'>" +
                                 //indicators include for drag and drop
                                 "{{if !~getState() || !hasChildRecords}}" +
                                  "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                 "<span class='aboveIcon {{if level == 1 && hasChildRecords}} firstLevIconMargin {{/if}}  e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='belowIcon {{if level == 1 && hasChildRecords}} firstLevIconMargin {{/if}}  e-icon' style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='childIcon {{if level == 1 && hasChildRecords}} firstLevIconMargin {{/if}}  e-icon' style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='cancelIcon {{if level == 1 && hasChildRecords}} firstLevIconMargin {{/if}} e-icon' style='position:relative;float:right;display:none;'></span>" +
                                 "</div>" +
                                 "{{/if}}"+
                                 "</div>" +
                                 "{{else !hasChildRecords || (!hasFilteredChildRecords && hasChildRecords)}}" +
                                 "<div " +
                                 "class='intend'" +
                                 "style='height:1px; float:left; width:{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px; display:inline-block;'>" +
                                   //indicator icons included for drag and drop
                                 "{{if !~getState() || !hasChildRecords}}" +
                                 "<div class={{:~_" + proxy._id + "rowName()}} >"+
                                 "<span class='aboveIcon iconMargin e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='belowIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                 "<span class='childIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                 "<span class='cancelIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                 "</div>" +
                                  "{{/if}}" +
                                 "</div>" +
                                 "{{/if}}" +
                                 //indicator icons included for drag and drop
                                 "{{if ~getState() && hasChildRecords}}" +
                                 "<div " +
                                 "class='intendparent'>" +
                                 "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                 "<span class='aboveIcon e-icon'  style='position:relative;float:left;display:none;'></span>" +
                                 "<span class='belowIcon e-icon' style='float:left;display:none;'></span>" +
                                 "<span class='childIcon e-icon' style='float:left;display:none;'></span>" +
                                 "<span class='cancelIcon e-icon' style='float:left;display:none;'></span>" +
                                 "</div>" +
                                 "</div>" +
                                 "{{/if}}" +
                                 "<div " +
                                 "class='{{if expanded && hasFilteredChildRecords}}e-treegridexpand e-icon{{else hasChildRecords && hasFilteredChildRecords}}" +
                                 "e-treegridcollapse e-icon{{/if}}'" +
                                 "style='float:left;display:inline-block; font-size:10px;'>" +
                                 "</div>" +
                                 "<div class='e-cell{{if " + (column.showCheckbox && (this.model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox)) + "}} e-treecheckboxcolumn{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" +
                                 "style='overflow: hidden;padding-left:{{if ~_" + proxy._id + "isTreeColumnIndex('" + columnName + "') && isSummaryRow}}{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px{{/if}};'>" +
                                '{{/if}}' +
                                "{{:~_" + proxy._id + "getCheckboxState(#data, '" + columnName + "', '" + proxy._checkboxColumnName + "')}}";
                                
                            if (!ej.isNullOrUndefined(column["format"]))
                                tdCell += "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}";
                            else if (model.isFromGantt && column.mappingName === model.resourceInfoMapping) {
                                helpers = {};
                                helpers["_" + proxy._id + "resourceName"] = proxy._getResourceName;
                                $.views.helpers(helpers);
                                tdCell += "{{:~_" + proxy._id + "resourceName('" + proxy._id + "Object','"
                                 + model.resourceNameMapping + "','"
                                 + model.resourceUnitMapping + "','" + columnName + "')}}" +
                                "</div>" +
                                "</div>" +
                                "</td>";
                            } else if (model.isFromGantt && column.mappingName === model.predecessorMapping) {

                                helpers = {};
                                helpers["_" + proxy._id + "predecessor"] = $.proxy(proxy._getPredecessorsValue, proxy);
                                $.views.helpers(helpers);

                                tdCell += "{{:~_" + proxy._id + "predecessor(#data)}}" +
                                "</div>" +
                                "</div>" +
                                "</td>";
                            }
                            else {                               
                                tdCell += "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + summaryTitlediv +
                                '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                "</div>" +
                                "</div>" +
                                "</td>" +
                                '{{/if}}';
                                summaryTitlediv = "";
                            }
                            //CHECK RESOURCE COLUMN FROM GANTT OR NOT
                        } else if (model.isFromGantt && column.mappingName === model.resourceInfoMapping) {
                            helpers = {};
                            helpers["_" + proxy._id + "resourceName"] = proxy._getResourceName;
                            $.views.helpers(helpers);

                            tdCell = "<td  " +
                                 "class='{{if isSelected && ~SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}'" +
                                 "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                 "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                 "role='gridcell'>" +
                                 "{{:~_" + proxy._id + "resourceName('" + proxy._id + "Object','"
                                 + model.resourceNameMapping + "','"
                                 + model.resourceUnitMapping + "','" + columnName + "')}}" +
                                 "</td>";
                            //CHECK PREDECESSOR COLUMN FROM GANTT OR NOT
                        } else if (model.isFromGantt && column.mappingName === model.predecessorMapping) {

                            helpers = {};
                            helpers["_" + proxy._id + "predecessor"] = $.proxy(proxy._getPredecessorsValue, proxy);
                            $.views.helpers(helpers);

                            tdCell = "<td " +
                                "class='{{if isSelected && ~SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}' " +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                "role='gridcell'>" +
                                "{{:~_" + proxy._id + "predecessor(#data)}}" +
                                "</td>";

                        } else if (model.isFromGantt && column.mappingName === model.durationMapping) {

                            helpers = {};
                            helpers["_" + proxy._id + "getDurationString"] = $.proxy(proxy._getDurationString, proxy);
                            $.views.helpers(helpers);

                            tdCell = "<td " +
                                "class='{{if isSelected && ~SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}' " +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                "role='gridcell'>" +
                                "{{:~_" + proxy._id + "getDurationString(#data)}}" +
                                "</td>";

                        }
                        else if (column["editType"] == "booleanedit" && proxy._checkboxSelection && columnName == "checkboxState") {
                            tdCell = "<td " +
                                "class='{{if isSelected && ~SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}} {{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};text-Align: center;" +
                                "role='gridcell'" +
                                ">" + summaryTitlediv + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "', '" + proxy._checkboxColumnName + "')}}";
                        }
                        else {
                            tdCell = "<td " +
                                "class='{{if isSelected && ~SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}} {{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}'" +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};text-Align:" + textAlign + "'" +
                                "role='gridcell'" +
                                ">" +
                                "{{:~_" + proxy._id + "getCheckboxState(#data, '" + columnName + "', '" + proxy._checkboxColumnName + "')}}" + summaryTitlediv;

                            if (!ej.isNullOrUndefined(column["format"]))
                                tdCell += "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}";
                            else {
                                tdCell += "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}";

                            }    
                            tdCell+= "</td>";
                            summaryTitlediv = "";
                        }

                        tdCellCollections += tdCell;
                    }
                    if (this._frozenColumnsLength > 0 && this._frozenColumnsLength == columnCount + 1) {
                        var frozenTrRow = "";
                        frozenTrRow += tdCellCollections;
                        frozenTrRow += "</tr>";
                        tdCellCollections = "";
                    }
                }

                /* add details column to end of header cell*/
                if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn) {
                    tdCellCollections += "<td class='{{if isSelected && ~SelectState()}}e-selectionbackground{{/if}} {{if isDetailsExpanded}}e-detailsrowexpand{{else}}e-detailsrowcollapse{{/if}}  " +
                                         "e-detailsrowcell{{if isLastSummary}} e-lastsummaryrow{{/if}}'>{{if !isSummaryRow && !footerSummaryRowRecord}}<div class='e-detailsiconcell e-icon {{if isDetailsExpanded}}e-detailsinfoiconhide{{else}}e-detailsinfoiconshow{{/if}}'></div>{{/if}}";
                }

                trRow += "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} " +
                      "e-treegridrowcollapse {{/if}} '" +
                      "style='background-color:{{if rowBackgroundColor }}{{:rowBackgroundColor}}{{else}}none{{/if}}; height:" + model.rowHeight + "px;" +
                      "display:{{:~_" + proxy._id + "expandStatus(#data)}}'" +
                      "role='row'>";
                frozenTrRow = trRow + frozenTrRow;
                trRow += tdCellCollections;

                if (model.isFromGantt) {
                    trRow += "<td class='e-extendcolumn'></td></tr>";
                } else {
                    trRow += "</tr>";
                }
            }

            if (model.showDetailsRow && model.detailsTemplate)
            {
                trRow += "{{if isDetailsExpanded}}" + proxy._createDetailsRowTemplate() + "{{/if}}";
                frozenTrRow += "{{if isDetailsExpanded}}" + proxy._createDetailsRowTemplate(true) + "{{/if}}";
            }

            var templates = {};
            templates[proxy._id + "_Template"] = trRow;
            templates[proxy._id + "_JSONFrozenTemplate"] = frozenTrRow;

            $.templates(templates);

            

        },
        
        //#endregion template

        //#region template METHODS

        _gridTemplate: function (self, templateId) {
            return self._renderEjTemplate("#" + templateId, this.data, this.data.index);
        },

        //method for calculating the indent width for expander column
        _getIndentWidth:function(data){
            var level = data.level;
            return (level * this.treeIndentLevelWidth) + "px";
		},


        //creating template element for angulartemplate in details row template
        _createDetailRowTemplateElement: function (detailTemplate) {
            var quickReg = /^#([\w-]*)/,
                scripEle,
                match = quickReg.exec(detailTemplate), scriptReg = /^<script/i;

            var options = {
                name: "SCRIPT",
                type: "text/x-template",
                text: detailTemplate,
                id: "treeGridDetailsRowTemplateElement" + this._id
            };

            if (match && match[1])
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(detailTemplate))
                    scripEle = $(detailTemplate).get(0);
                else
                    scripEle = ej.buildTag(options.name, options.text).get(0);
            }

            scripEle.id = scripEle.id || options.id;
            scripEle.type = scripEle.type || options.type;
            $("body").append(scripEle);
            return scripEle;
        },


        //creating template element for angulartemplate in row template
        _createRowTemplateElement: function (innerHtml, id, type) {
            var scriptElement = document.createElement("script");
            scriptElement.id = id;
            scriptElement.type = type || "text/x-template";
            scriptElement.text = innerHtml;

            $("body").append(scriptElement);
            return scriptElement;
        },

        //creating a template element for angularjs template
        _createTemplateElement: function (column, text) {
            var idText = text ? "Pager" : column.headerText + $.inArray(column, this.model.columns) + "_Template";
            var scriptElement = document.createElement("script");
            scriptElement.id = ("treeGrid" + idText).split(" ").join("");
            scriptElement.type = "text/x-template";
            scriptElement.text = $(column["angularTemplate"] ? column["angularTemplate"] : column["template"]).html();



            $("body").append(scriptElement);
            return scriptElement;
        },

        //Get checkbox state while rendering the treegrid
        _getCheckboxState: function (data, columnName, checkboxColumnName) {
            if (columnName != checkboxColumnName)
                return;
            if (data['isSummaryRow'] == true || data.summaryColumn || data.summaryRow)
                return;
            var checkboxState;
            if (data.checkboxState == "indeterminate") {
                checkboxState = '<span class="e-chkbox-wrap e-widget" style="padding-right:10px;color:#c8c8c8;">' +
                '<div class="e-chkbox-small">' +
                '<span class="e-chk-indeter"><span class="e-checkbox e-chk-image e-icon e-stop" id =' + this._id + '_checkbox' + data.ejRowId + '></span></span></div></span>';
            }
            else if (data.checkboxState == "unchecked") {
                checkboxState = '<span class="e-chkbox-wrap e-widget" style="padding-right:10px;color:#c8c8c8;">' +
                    '<div class="e-chkbox-small">' +
                    '<span class="e-chk-inact"><span class="e-checkbox e-chk-image e-icon" id =' + this._id + '_checkbox' + data.ejRowId + '></span></span></div></span>';
            }
            else {
                checkboxState = '<span class="e-chkbox-wrap e-widget" style="padding-right:10px;color:#c8c8c8;">' +
                    '<div class="e-chkbox-small">' +
                    '<span class="e-chk-act"><span class=" e-checkbox e-chk-image e-icon e-checkmark" id =' + this._id + '_checkbox' + data.ejRowId + '></span></span></div></span>';
            }
            return checkboxState;
        },

        // Healper method to check the clip mode of the cell is in 'ellipsis'.
        _checkIsTrimCell: function (clipMode) {
            var proxy = this;
            if (clipMode && clipMode == "ellipsis")
                return true;
            else
                return false;
        },

        _getCustomCellValue: function (data, columnName) {
            if (!ej.isNullOrUndefined(data)) {
                var splits = (columnName || "").split("."), cellValue;
                if (splits.length <= 1)
                    cellValue = data[columnName];
                else {
                    cellValue = data[splits[0]];
                    if (ej.isNullOrUndefined(cellValue)) {
                        //if (typeof cellValue === "undefined")
                        //    this._restoreCustomData(data, "", columnName);
                        return null;
                    }
                    for (var splitKeyIndex = 1; splitKeyIndex < splits.length; splitKeyIndex++) {
                        cellValue = cellValue[splits[splitKeyIndex]];
                        if (ej.isNullOrUndefined(cellValue)) {
                            //if (typeof cellValue === "undefined")
                            //    this._restoreCustomData(data, "", columnName);
                            return null;
                        }
                    }
                }
                return cellValue;
            }
        },

        _restoreCustomData: function (data, value, fieldName) {
            var proxy = this, splitIndex = 0,dataIndex = 0;
            if (ej.isNullOrUndefined(fieldName)) {
                var fieldName = proxy._cellEditingDetails.fieldName;
            }
            var splits = (fieldName || "").split("."), cellValue = {};
            if (splits.length <= 1) {
                if (!ej.isNullOrUndefined(data)) {
                    data[fieldName] = value;
                } else {
                    data = {};
                    data[fieldName] = value;
                }
            }
            else {
                if (!ej.isNullOrUndefined(data)) {
                    cellValue = data[splits[0]];
                    if (ej.isNullOrUndefined(cellValue)) {
                        cellValue = {};
                        data[splits[0]] = cellValue;
                    }
                    dataIndex = 1;
                } else {
                    data = {};
                    cellValue = data;
                    dataIndex = 0;
                }
                for (splitIndex = dataIndex; splitIndex < (splits.length - 1) ; splitIndex++) {
                    if (ej.isNullOrUndefined(cellValue[splits[splitIndex]])) {
                        cellValue[splits[splitIndex]] = {};
                    }
                    cellValue = cellValue[splits[splitIndex]];
                }
                cellValue[splits[splitIndex]] = value;
            }
                return data;
        },

        //Get the cell value while rendering the tree grid.
        _getTemplateCellValue:function(data,columnName, checkboxColumn)
        {
            var proxy = this,
                column = proxy.getColumnByField(columnName),
                editType = column.editType, i, dropdownValue,
                cellValue = proxy._getCustomCellValue(data, columnName);
               var value, text;
            if (!ej.isNullOrUndefined(cellValue)) {
                cellValue = cellValue;
            } else {
                cellValue = data.item && data.item[columnName];
            }
            if (editType == ej.TreeGrid.EditingType.Boolean && columnName == checkboxColumn) {
                cellValue = proxy._getCheckboxState(data, columnName, checkboxColumn);
            } else if (!data['isSummaryRow'] && !data["footerSummaryRowRecord"] && editType == ej.TreeGrid.EditingType.Boolean && columnName != checkboxColumn && (ej.isNullOrUndefined(column.displayAsCheckbox) || column.displayAsCheckbox)) {
                if (cellValue == "true" || cellValue == true)
                    cellValue = "<input class='e-treegrid-chekboxcell' type='checkbox' disabled='disabled' checked/>";
                else
                    cellValue = "<input class='e-treegrid-chekboxcell' type='checkbox' disabled='disabled'/>";
            }

            if (columnName == "work")
                cellValue += " " + proxy.model.workUnit;
            if (columnName == "taskMode")
                cellValue = !data.isAutoSchedule;
            if (columnName == "unit")
                cellValue += "" + "%";
            if (columnName == "duration")
                cellValue = proxy._getDurationString(data);

            if (editType == ej.TreeGrid.EditingType.Dropdown)
            {
                var editParams = column.editParams;
                cellValue = (cellValue != null || cellValue != undefined) ? cellValue : "";
                if(editParams && editParams.fields)
                {
                    text = editParams.fields.text ? editParams.fields.text : "text";
                    value = editParams.fields.value ? editParams.fields.value : "value";
                }
                else
                {
                    value = "value";
                    text = "text";
                }
                if (editParams && editParams.showCheckbox) {
                    var cellValueCollection = cellValue.split(",");
                    var length = cellValueCollection.length;
                    cellValue = "";
                    if (column.dropdownData) {
                        for (var i = 0; i < length; i++) {
                            var dropdownDataCollection = column.dropdownData;
                            dropdownValue = $.map(dropdownDataCollection, function (dropdownData) {
                                if (!ej.isNullOrUndefined(dropdownData[value])) {
                                    if (dropdownData[value].toString() == cellValueCollection[i].toString())
                                        return dropdownData[text];
                                }
                                else {
                                    if (dropdownData[text] == cellValueCollection[i])
                                        return dropdownData[text];
                                }
                            });
                            dropdownValue[0] = dropdownValue[0] ? dropdownValue[0] : "";
                            cellValue += i == 0 ? dropdownValue[0] : ","+dropdownValue[0];
                        }
                    }
                }
                else {
                    if (column.dropdownData) {
                        var dropdownDataCollection = column.dropdownData;
                        dropdownValue = $.map(dropdownDataCollection, function (dropdownData) {
                            if (!ej.isNullOrUndefined(dropdownData[value])) {
                                if (dropdownData[value].toString() == cellValue.toString())
                                    return dropdownData[text];
                            }
                            else {
                                if (dropdownData[text].toString() == cellValue)
                                    return dropdownData[text];
                            }
                        });
                        dropdownValue[0] = ej.isNullOrUndefined(dropdownValue[0]) ? "" : dropdownValue[0];
                        cellValue = dropdownValue[0];
                    }
                }
            }           
            return cellValue;
        },

        _getCellValue: function (data, columnName) {

            var cellValue = this._getCustomCellValue(data, columnName);

            if (cellValue || cellValue===0) {
                return cellValue;
            } else {
                return data.item && data.item[columnName];
            }


        },
        _isTreeColumnIndex: function (columnName) {
            var proxy = this, model = proxy.model,
            currentColumn = model.columns[model.treeColumnIndex];
            if (currentColumn && currentColumn.field == columnName)
                return true;
            else
                return false;
        },
        _getSummaryTitle: function () {
            var proxy = this;
            var summaryTitleValue = proxy.data.summaryRow.title;
            if (summaryTitleValue)
                return summaryTitleValue;
            else
                return proxy.data.item && proxy.data.item.summaryRow.title;
        },

        _getCellColumn: function (columnName,data) {
            var proxy = this;

            if (data.treeMappingName.indexOf(columnName) !== -1) {
                return columnName;
            }
            else {
                return "none";
            }


        },

        //GET RESOURCE NAME FOR RESOURCE COLUMN IN THE GANTT CONTROL
        _getResourceName: function (gridObject, mappingName, unitMappingName, columnName) {

            var proxy = this,
                data = proxy.data[columnName],
                count = 0,
                resourceString, resourceUnit,
                length = data && data.length,
                resourceName = [];

            if (data && data.length > 0) {
                for (count; count < length; count++) {
                    resourceString = data[count][mappingName];
                    resourceUnit = data[count][unitMappingName];
                    if (resourceUnit != 100)
                        resourceString += "[" + resourceUnit + "%]";                    
                    resourceName.push(resourceString);
                }
            }
            return resourceName;
        },

        _getDurationString: function (data) {
            var val = "";
            if (data.duration != null)
                val += data.duration + " ";
            if (data.durationUnit != null) {
                var multiple = data.duration != 1;
                if (data.durationUnit == "day")
                    val += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                else if (data.durationUnit == "hour")
                    val += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                else
                    val += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
            }
            return val;
        },
        //GET PREDECESSOR VALUE FOR PREDECESSOR COLUMN IN THE GANTT CONTROL
        _getPredecessorsValue: function (data) {
            var predecessors = data.predecessor,
                returnVal = "",
                resultString = "";
            if (predecessors) {
                var length = predecessors.length;
                for (var i = 0; i < length; i++) {
                    var cPredecessor = predecessors[i],
                        temp = "";
                    if (cPredecessor.from != data.taskId) {
                        temp = cPredecessor.from + cPredecessor.predecessorsType;
                        if (cPredecessor.offset != 0) {
                            temp += cPredecessor.offset > 0 ? ("+" + cPredecessor.offset + " ") : (cPredecessor.offset + " ");
                            var multiple = cPredecessor.offset != 1;
                            if (cPredecessor.offsetDurationUnit == "day")
                                temp += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                            else if (cPredecessor.offsetDurationUnit == "hour")
                                temp += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                            else
                                temp += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
                        }
                        if (resultString.length > 0)
                            resultString = resultString + "," + temp;
                        else
                            resultString = temp;
                    }
                }
            }
            return resultString;
        },

        //GET THE EXPAND COLLAPSE STATUS OF TABLE ROW
        _getExpandStatusRecord: function (data) {

            var proxy = this;

            if (proxy.getExpandStatus(data)) {

                return 'table-row';

            }

            return 'none';
        },

        //#endregion TEMPLATE METHODS

        //#region CONVERT HIERARCHICAL RECORDS TO FLAT RECORDS
        //CREATE FLATRECORDS FROM HIERARCHICAL DATASOURCE
        _createRecords: function (dataSource) {

            var proxy = this,
                model = proxy.model,
                ids=proxy.model.ids,
                flatRecords = model.flatRecords,
                length = dataSource.length,
                count = 0,
                expanded = true,
                parentRecord,
                parentRecords = model.parentRecords;

            if (!model.isFromGantt && model.enableCollapseAll) 
                expanded = false;
            if (model.allowPaging && model.pageSettings.totalRecordsCount > 0 && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                length = model.pageSettings.totalRecordsCount < length ? model.pageSettings.totalRecordsCount : length;

            for (count; count < length; count++) {

                parentRecord = proxy._createRecord(dataSource[count], 0, null, expanded);
                proxy._storedIndex++;

                //CHECK ALTROW ENABLED OR NOT
                
                parentRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                

                //CHECK SORTING ENABLED OR NOT
                
                parentRecords.push(parentRecord);
                

                parentRecord.index = proxy._storedIndex;
                ids[proxy._storedIndex] = parentRecord.index;
                flatRecords.push(parentRecord);
                if (parentRecord.hasChildRecords)
                    proxy._parentRecords.push(parentRecord);
                parentRecord.childRecords && proxy._addNestedRecords(parentRecord.childRecords);

            }
            if (model.allowPaging && model.pageSettings.totalRecordsCount > 0 && model.pageSettings.pageSizeMode !== ej.TreeGrid.PageSizeMode.Root) {
                if (model.pageSettings.totalRecordsCount <= flatRecords.length) {
                    var totalRecordsCount = model.pageSettings.totalRecordsCount;
                    model.flatRecords = flatRecords.slice(0, totalRecordsCount);
                    if (model.flatRecords[totalRecordsCount - 1].hasChildRecords) {
                        model.flatRecords[totalRecordsCount - 1].hasChildRecords = false;
                        model.flatRecords[totalRecordsCount - 1].expanded = false;
                        model.flatRecords[totalRecordsCount - 1].childRecords = null;
                        model.flatRecords[totalRecordsCount - 1].hasFilteredChildRecords = false;
                    }
                }
            }
            /* assign records length as max index */
            proxy._maxRowIndex = this.model.flatRecords.length;
        },


        //CREATE RECORD OBJECT
        _createRecord: function (data, level, parentItem, expanded) {

            var proxy = this,
                record,
                childDataSource = data[proxy.model.childMapping], model = this.model;

            //To create and maintain record collections for multi select dropdownedit of columns
            record = $.extend({}, data);
            var tempData;
            if (model.parentIdMapping && proxy._createdAt === "load") {
                var id = data[model.idMapping],
                   index = proxy._taskIds.indexOf(id);
                record.item = (index > -1) ? proxy._retrivedData[index] : [];              
            }
            else {

                if (this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.json && this.dataSource().dataSource.offline && proxy._createdAt === "load") {

                    if (model.parentIdMapping) {
                        var id = data[model.idMapping],
                           index = proxy._taskIds.indexOf(id);
                        record.item = (index > -1) ? proxy._retrivedData[index] : [];
                    }
                    else {
                        record.item = data;
                    }
                }
                else {
                    record.item = data;
                }
            }
            record.parentItem = parentItem;
			record.childRecords = (childDataSource && childDataSource.length > 0) && proxy._createChildRecords(childDataSource, level + 1, record);
			record.hasChildRecords = (childDataSource && childDataSource.length > 0) ? true : false;
			if (model.expandStateMapping && record.hasChildRecords) {
			    if (!ej.isNullOrUndefined(data[model.expandStateMapping])) {
			        record[model.expandStateMapping] = record.item[model.expandStateMapping] = data[model.expandStateMapping];
			    } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && !model.enableCollapseAll) {
			        record[model.expandStateMapping] = record.item[model.expandStateMapping] = data[model.expandStateMapping] = true;
			    } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && model.enableCollapseAll) {
			        record[model.expandStateMapping] = record.item[model.expandStateMapping] = data[model.expandStateMapping] = false;
			    }
			    var expandStateMapping = data[model.expandStateMapping];
			}
			else
			    var expandStateMapping = true;
			record.expanded = (expanded !== undefined && childDataSource !== undefined && record.hasChildRecords == true
                && expandStateMapping) ? expanded : expandStateMapping && childDataSource ? childDataSource.length > 0 : false;
            record.dragState = true;
            record.isSelected = false;
            record.hasFilteredChildRecords = true;//Used to Indicates Parent records can expandable or not on Filtering operation
            record.level = level;
            record.cellBackgroundColor = null;
            record.rowBackgroundColor = null;
            record.treeMappingName = [];
            if (model.showDetailsRow && model.detailsTemplate) {
                record.isDetailsExpanded = model.showDetailsRowInfoColumn ? false : true;
            } else {
                record.isDetailsExpanded = false;
            }
            if (!model.isFromGantt)
                record.ejRowId = ++proxy._idGenerator;
            record.checkboxState = "unchecked";
            delete record[model.childMapping];
            return record;
        },


        //CREATE CHILD GANTT RECORDS
        _createChildRecords: function (childDataSource, level, parentItem) {

            var proxy = this,
                model=proxy.model,
                records = [],
                count = 0,
                length = childDataSource.length,
                record = null,
                expanded,
                childRecord;

            if (!model.isFromGantt && model.enableCollapseAll)
                expanded = false;

            for (count = 0; count < length; count++) {

                record = childDataSource[count];

                if (record) {
                    childRecord = proxy._createRecord(record, level, parentItem, expanded);
                    records.push(childRecord);
                }
            }

            return records;

        },


        //ADD NESTED RECORDS TO FLATRECORDS
        _addNestedRecords: function (childDataSource) {

            var proxy = this,
                model = proxy.model,
                ids=proxy.model.ids,
                flatRecords = model.flatRecords,
                updatedRecords = model.updatedRecords,
                count = 0,
                length = childDataSource.length,
                records = [],
                record;
                

            for (count = 0; count < length; count++) {

                record = childDataSource[count];
                proxy._storedIndex++;

                //CHECK ALTROW ENABLED OR NOT
                
                record.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                

                record.index = proxy._storedIndex;
                ids[proxy._storedIndex] = record.index;
                flatRecords.push(record);
                updatedRecords.push(record);
                if (record.hasChildRecords)
                    proxy._parentRecords.push(record);
                records = record.childRecords;

                if (records) {

                    var j = 0,
                        recordlength = records.length,
                        childRecord = null;

                    for (j = 0; j < recordlength; j++) {

                        childRecord = records[j];
                        proxy._storedIndex++;     
                        childRecord.index = proxy._storedIndex;
                        ids[proxy._storedIndex] = childRecord.index;
                        //CHECK ALTROW ENABLED OR NOT
                        
                        childRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                        
                        flatRecords.push(childRecord);
                        updatedRecords.push(record);
                        if (childRecord.hasChildRecords)
                            proxy._parentRecords.push(childRecord);
                        childRecord.childRecords && proxy._addNestedRecords(childRecord.childRecords);
                    }
                }
            }
        },

        //EVENT FOR COLUMN RESIZE
        _enableColumnResizeEvents: function () {

            var proxy = this;

            if (proxy.model.allowColumnResize) {
                proxy._on(proxy.element, "mousemove", proxy._mouseMove);
            } else {
                proxy._off(proxy.element, "mousemove", proxy._mouseMove);
            }
        },

        //#endregion CONVERT HIERARCHICAL RECORDS TO FLAT RECORDS

        //#region METHOD FOR EVENTS

        //INITIALIZE THE EVENTS
        _wireEvents: function () {

            var proxy = this,
                model = proxy.model,
                matched = jQuery.uaMatch(navigator.userAgent);

            //proxy._$gridContent.bind("scroll", $.proxy(proxy._onScroll, proxy));
            if (ej.isTouchDevice()) {
                proxy._on(proxy.element, "tap", proxy._onRecordClick);// ".e-gridcontent",
                proxy._on(proxy.element, "tap", proxy._onClick);
            }
            else {
                proxy._on(proxy.element, "click", proxy._onRecordClick);// ".e-gridcontent",
                proxy._on(proxy.element, "click", proxy._onClick);
            }            
            proxy._on(proxy.element, "keydown", proxy._keyDown);
            proxy._on(proxy.element, "click", "#" + proxy._id + "e-gridheader", proxy._onHeaderClick);
            proxy._on(proxy.element, "mousedown touchstart", "#" + proxy._id + "e-gridheader", proxy._headerMouseDown);
            proxy._on($(document), "mousedown touchstart", proxy._mouseDownHandler);
            proxy._on(proxy.element, "mousedown touchstart", ".e-gridcontent", proxy._contentMouseDown);            
            
            if (this.model.isResponsive)
                this._on(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));

            if (proxy.model.allowColumnResize)
                proxy._on(proxy.element, "mousemove", proxy._mouseMove);
            //Method binding for filtering data.
            if (model.filterSettings.filterBarMode == "immediate") {
                proxy._on(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._on(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
            }
            proxy._on(proxy.element, "focus click", ".e-filterbarcell input", proxy._filterBarClose);
            proxy._on(proxy.element, "click", ".e-filterbarcell .e-cancel", proxy._filterBarClose);
            if (proxy.model.showGridCellTooltip && !proxy.model.showGridExpandCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._on(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
                }
                else {
                    proxy._on(proxy.element, "mousemove", ".e-rowcell", proxy._mouseHover);
                }
            }
            else {
                proxy._on(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
            }
            if (proxy.model.showGridCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._on(proxy.element, "mouseenter", ".e-headercelldiv", proxy._headermouseHover);
                }
                else {
                    proxy._on(proxy.element, "mousemove", ".e-headercelldiv", proxy._headermouseHover);
                }
            }
            proxy._on(proxy.element, "mouseleave", ".e-rowcell", proxy._cellMouseLeave);
            proxy._on(proxy.element, "mouseleave", proxy._cellMouseLeave);            
            proxy._on(proxy.element, "mouseleave", ".e-headercelldiv", proxy._headerMouseLeave);
            proxy._on(proxy.element, "mouseleave", proxy._headerMouseLeave);
            

            //MOUSE WHEEL EVENT FOR GANTT CONTROL
            if (model.isFromGantt || this._frozenColumnsLength) {
                proxy._on(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            }

            if (model.enableResize && model.isResponsive && !model.isFromGantt) {
                proxy._on($(window), "resize", proxy._windowResize);
            }
            proxy._enableEditingEvents();
            //Mouse right click event for tree grid


            if (model.contextMenuSettings.showContextMenu) {
                proxy._on(proxy.element, "keyup", this._preventContextMenu);
            }
        },
        /* prevent context menu action by menu option key*/
        _preventContextMenu: function (e) {
            this._off(this.element, "contextmenu", this._preventContextMenu);
            if (e.keyCode == 93 || e.type == "contextmenu" || e.type == "taphold") {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }
        },
        _mouseDownHandler:function(e)
        {
            var proxy = this,
                target = $(e.target);
            //Check the whether the mouse down on column menu and column menu items
            if (target.closest("div.e-columnmenuitem").length == 0 && target.closest("div.e-columnMenuListDiv").length == 0 && ((!target.hasClass("e-columnmenu-icon") && !target.hasClass("e-column-filter-icon") && !target.hasClass("e-column-filtered-icon")) || $(e.target).closest("#" + proxy._id).length == 0) && target.closest("div.e-" + proxy._id + "filterStringSelector").length == 0 && target.closest("div#" + proxy._id + "filterStringDropDown_popup_list_wrapper").length == 0
                && target.closest("div#" + proxy._id + "filterStringInputBox_suggestion").length == 0 && target.closest("div.e-" + proxy._id + "filterNumericSelector").length == 0 && target.closest("div#" + proxy._id + "filterNumericDropDown_popup_list_wrapper").length == 0 &&
                target.closest("div.e-" + proxy._id + "filterDatepickerSelector").length == 0 && target.closest("div#" + proxy._id + "filterDatepickerDropDown_popup_list_wrapper").length == 0 &&
                target.closest("div#e-" + proxy._id + "filterDatepickerInputBox").length == 0 && target.closest("div.e-" + proxy._id + "filterDatetimepickerSelector").length == 0 && target.closest("div#" + proxy._id + "filterDatetimepickerDropDown_popup_list_wrapper").length == 0 &&
                target.closest("div#" + proxy._id + "filterDatetimepickerInputBox_popup").length == 0 && target.closest("div.e-" + proxy._id + "filterDropdownSelector").length == 0 && target.closest("div#" + proxy._id + "filterDropdownDropDown_popup_list_wrapper").length == 0 && target.closest("div.e-" + proxy._id + "filterBooleanSelector").length == 0)
                proxy._clearColumnMenu();
            //Check the whether the mouse down on context menu items
            if (target.closest("div.e-menuitem").length == 0)
                proxy._clearContextMenu();
            //Check the detail template items on mouse down event
            if (target.closest("div.e-detailscellwrapperfly").length == 0)
                proxy._removeDetailsRow(e);            
        },
        // Auto scroll the content if mouse move out of grid area while dragging a row.
        _mouseout: function (e) {
            var proxy = this,
                model = proxy.model,
                topvalue, bottomScrollPos, topScrollPos,
                position = proxy._gridPosition,
                top = position.top, contentHeight = proxy._gridHeight,
                height = proxy._$gridHeaderContainer.height() + top;

            if (model.toolbarSettings.showToolbar) {
                var id = model.isFromGantt ? proxy._id.replace("ejTreeGrid", "") : proxy._id;
                height += $("#" + id + "_toolbarItems").length > 0 ? $("#" + id + "_toolbarItems").outerHeight() : 0;
            }            
            if (model.allowPaging) {
                contentHeight = contentHeight - proxy.element.find(".e-pager").first().outerHeight();
            }
            if (model.showTotalSummary) {
                contentHeight = contentHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
            if (proxy._dragMouseDown) {
                var posx = position.left, posy = e.pageY;

                if (proxy.model.isFromGantt) {
                    var id = proxy._id.replace("ejTreeGrid", "");
                    var ganttbody = $("#"+id).find(".e-ganttviewerbodyContianer"),
                        isVscroll = ganttbody.ejScroller("isVScroll"),
                        max = isVscroll ? ganttbody.find(".e-content").get(0).scrollHeight - 1 : 0;
                    bottomScrollPos = ganttbody.ejScroller("isHScroll") ? (contentHeight + top - (model.rowHeight / 2) - 18) :
                                        (contentHeight + top - (model.rowHeight / 2));
                    }
                else{
                    var max = proxy.isVScroll() ? proxy.getMaxScrollHeight() - 1 : 0;
                    bottomScrollPos = proxy.getScrollElement().ejScroller("isHScroll") ? (contentHeight + top - (model.rowHeight / 2) - 18) :
                                           (contentHeight + top - (model.rowHeight / 2));
                }
                    topScrollPos = height + (model.rowHeight/2);
                   
                    //condition to whether the mouse pointer below the content.
                if (posy > bottomScrollPos) {
                        //Condition to check whether the scroller reaches the end.

                        if (max > (proxy._scrollTop)) {
                            if (!proxy._timerDragDown) {

                                //Timer started for scrolling the content till the end.
                                proxy._timerDragDown = window.setInterval(function () {
                                    if (max > proxy._scrollTop) {
                                        topvalue = max > (proxy._scrollTop) ?(proxy._scrollTop + 20) : max;                                        
                                        if (proxy.model.isFromGantt)
                                            ganttbody.ejScroller("scrollY", topvalue, true);
                                        else
                                            proxy.getScrollElement().ejScroller("scrollY", topvalue, true);                       
                                    }                                    
                                }, 100);
                            }
                        }
                        else {
                            proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
                        }
                    }
                    else {
                    proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
                    }
                    //condition to check if the mouse points above to content area.
                if (posy < topScrollPos && proxy._scrollTop != 0) {
                        if (proxy._scrollTop > 0) {
                            if (!proxy._timerDragUp) {
                                proxy._timerDragUp = window.setInterval(function () {
                                    if (proxy._scrollTop > 0) {
                                        topvalue = proxy._scrollTop - 20;                                        
                                        if (topvalue < 0)
                                            topvalue = 0;
                                        if (proxy.model.isFromGantt)
                                            ganttbody.ejScroller("scrollY", topvalue, true);
                                        else
                                            proxy.getScrollElement().ejScroller("scrollY", topvalue, true);
                                    }
                                }, 100);
                            }
                        }
                        else {
                            proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
                        }
                    }
                    else {
                    proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
                    }                
            }
        },       
        // This method is to get the row range to enable the drag row indicators consequently.
        getRange: function (record, index,$tr) {
            
            var proxy = this,
                model = proxy.model,
                roundOff = 0,
                rowHeight = $tr[0].offsetHeight,
                position = proxy.getOffsetRect($("#" + proxy._id)[0]),
                height = proxy._$gridHeaderContainer.height() + position.top;
                rowHeight += proxy._detailsRowHeight;

            if (model.toolbarSettings.showToolbar)
                height += !ej.isNullOrUndefined($("#" + proxy._id + "_toolbarItems").height()) ? $("#" + proxy._id + "_toolbarItems").height() : 0;
            if(proxy._scrollTop!=0)
                roundOff = rowHeight - proxy._scrollTop % rowHeight;
            // 7 is to equalize the height.
            var rowTop = (index * rowHeight) + height + roundOff + 7,
                rowBottom = rowTop + $tr[0].offsetHeight,
                difference = rowBottom - rowTop,
                divide = difference / 3,
                topRowSegment = rowTop + divide,
                middleRowSegment = topRowSegment + divide,
                bottomRowSegment = middleRowSegment + divide,
                position = {
                    topRowSegment: topRowSegment,
                    middleRowSegment: middleRowSegment,
                    bottomRowSegment: bottomRowSegment
                };
            return position;
        },
        //Child validation to display the child indicator.
        _childValidation: function (record) {            
            var childIndex,
                proxy = this,
                draggedRecord = proxy._draggedRecord,
                parentItem = draggedRecord.parentItem,
                childRecords;
            if (parentItem) {
                childRecords = parentItem.childRecords;
                childIndex = childRecords.indexOf(this._draggedRecord);
                if (record == parentItem && childIndex != -1)
                    this._childItem = true;
            }
        },
        _isColumnHidable: function (column) {
            var model = this.model, visibleFrozenColumn = [], visibleUnfrozenColumn = [], returnValue = true;

            visibleFrozenColumn = this._frozenColumns.filter(function (value) {
                return value.visible == true;
            });
            visibleUnfrozenColumn = this._unFrozenColumns.filter(function (value) {
                return value.visible == true;
            });
            if (visibleFrozenColumn.length == 1 && visibleFrozenColumn[0].field == column.field) {
                returnValue = false;
            }
            if (visibleUnfrozenColumn.length == 1 && visibleUnfrozenColumn[0].field == column.field) {
                returnValue = false;
            }
            return returnValue;
        },
        _updateColumnMenuVisibility: function () {
            var model = this.model, visibleFrozenColumn = [], visibleUnfrozenColumn = [];
            if (model.showColumnChooser) {
                visibleFrozenColumn = this._frozenColumns.filter(function (value) {
                    return value.visible == true;
                });
                visibleUnfrozenColumn = this._unFrozenColumns.filter(function (value) {
                    return value.visible == true;
                });
                if (visibleFrozenColumn.length == 1) {
                    var checkBoxData = $("#" + this._id + "_columnMenu_" + visibleFrozenColumn[0].field.split('.').join("")).data("ejCheckBox");
                    if (checkBoxData)
                        checkBoxData.option("enabled", false);
                }
                if (visibleUnfrozenColumn.length == 1) {
                    var checkBoxData = $("#" + this._id + "_columnMenu_" + visibleUnfrozenColumn[0].field.split('.').join("")).data("ejCheckBox");
                    if (checkBoxData)
                        checkBoxData.option("enabled", false);
                }
            }
        },
        //This method is to render the tooltip while dragging.
        _renderToolTip: function (e, element, args, $target) {
            var proxy = this,                
                model = this.model,
                positions = [],
                doc = document,
                item,
                columns = proxy.model.columns,
                tooltipItemLength = model.dragTooltip.tooltipItems.length,
                columnTooltipValue,
                $tr = $target.closest('tr'),
                $td,
                recordIndex = proxy.getIndexByRow($tr),
                positions = {}, records, dragRecIndex, index,
            updatedRecords = proxy.getUpdatedRecords();
            proxy._insertAbove = false;
            proxy._insertAsChild = false;
            proxy._insertBelow = false;
            proxy._childItem = false;            
            proxy._currentRecord = model.currentViewData[recordIndex];
            item = proxy._draggedRecord;

            if (recordIndex != proxy._draggedIndex)
                proxy._displayContextMenu = false;
                        
            // disable all the icons initially.
            $(".intend").find(".e-icon").css({ "display": "none" });
            $(".intendparent").find(".e-icon").css({ "display": "none" });
            $(".e-error").css({ "display": "none" });
            $(".e-treegridexpand").css({ "display": "inline-block" });
            $(".e-treegridcollapse").css({ "display": "inline-block" });           
               
            // to get the record index to find its mouse position.            
            var records;
            if (!model.rowTemplateID) {
                records = proxy.getExpandedRecords(updatedRecords);
                proxy.getVisibleRange();
                var currentViewData = records.slice(proxy._visibleRange.top, proxy._visibleRange.bottom);
                if (proxy._scrollTop != 0) {
                    dragRecIndex = updatedRecords.indexOf(proxy._draggedRecord) - 1;
                    index = currentViewData.indexOf(proxy._currentRecord) - 1;
                }
                else {
                    dragRecIndex = updatedRecords.indexOf(proxy._draggedRecord);
                    var index = currentViewData.indexOf(proxy._currentRecord);
                }
            }
            else {
                records = updatedRecords;
                index = updatedRecords.indexOf(proxy._currentRecord);
            }
            var currentIndex = updatedRecords.indexOf(proxy._currentRecord),
            isNextRecord = proxy._currentRecord && proxy._checkPrevNextRecord(proxy._draggedRecord, currentIndex, proxy._currentRecord.level, "next"),
            isPrevRecord = proxy._currentRecord && proxy._checkPrevNextRecord(proxy._draggedRecord, currentIndex, proxy._currentRecord.level, "prev"),
            posx = proxy._gridPosition.left, posy = e.pageY;

            if (proxy._currentRecord)
                positions = proxy.getRange(proxy._currentRecord, index, $tr);
                                           
            var isTopRowSegment = posy <= positions.topRowSegment,
                isMiddleRowSegment = (posy > positions.topRowSegment && posy <= positions.middleRowSegment),
                isBottomRowSegment = (posy > positions.middleRowSegment && posy <= positions.bottomRowSegment);
            /* check current record or else render previous records tootip*/
            if (proxy._currentRecord) {
                proxy.data = proxy._currentRecord;
                var classname = this._getrowName();
                proxy._childValidation(proxy._currentRecord);
                // This condition is to disapper the expand collapse icon if it is top most level.
                if (!proxy._currentRecord.parentItem) {
                    if (proxy._currentRecord.hasChildRecords)
                        if (proxy._currentRecord.expanded)
                            $tr.find(".e-treegridexpand").css({ "display": "none" });
                        else
                            $tr.find(".e-treegridcollapse").css({ "display": "none" });
                }
                else {
                    if (proxy._currentRecord.hasChildRecords)
                        if (proxy._currentRecord.expanded)
                            $tr.find(".e-treegridexpand").css({ "display": "inline-block" });
                        else
                            $tr.find(".e-treegridcollapse").css({ "display": "inline-block" });
                }

                //To render the indicators according to its position.
                if (proxy._currentRecord.dragState == true && args.canDrop != false) {
                    if (isTopRowSegment && !isPrevRecord) {
                        $(proxy.element).find("." + classname).find(".aboveIcon").css({ "display": "block" });
                        proxy._insertAbove = true;
                    }
                    else if (isMiddleRowSegment && proxy._childItem == false) {
                        $(proxy.element).find("." + classname).find(".childIcon").css({ "display": "block" });
                        proxy._insertAsChild = true;
                    }
                    else if (isBottomRowSegment && !isNextRecord) {
                        $(proxy.element).find("." + classname).find(".belowIcon").css({ "display": "block" });
                        proxy._insertBelow = true;
                    }
                }
                else {
                    $(proxy.element).find("." + classname).find(".cancelIcon").css({ "display": "block" });
                    proxy.cancelDrop = true;
                }
            }

            $(proxy._dragmouseOverTooltip).css({
                "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                'position': 'absolute',
                'z-index': '5',
                'padding': '0',
                'border-right': '0',
                'border-bottom': '0',
                'border-radius': '3px',
                'height': "auto",
            });                            
        },

        //Used for check whether the dragged record is previous or next to current record based on position argument
        //If it is previous or next to current record, this method return true otherwise return false.
        _checkPrevNextRecord:function(record,index,level, position)
        {
            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                currentIndex = index;
            position == "next" ? index++ : index--;
            while(updatedRecords[index])
            {
                if (updatedRecords[index].level == level)
                {
                    if (updatedRecords[index] == record && record.parentItem == updatedRecords[currentIndex].parentItem)
                        return true;
                    return false;
                }
                position == "next" ? index++ : index--;
            }
            return false;
        },
        //Tooltip template for row drag and drop
        _createDragTooltipTemplate: function () {
            var proxy = this,
                td,               
                template = proxy.model.dragTooltip.tooltipTemplate,
                parentTr;
            if (template) {
                var templateString = template.charAt(0);
             
                if (templateString == "#")
                     parentTr = $(proxy.model.dragTooltip.tooltipTemplate)[0].innerHTML;
                else
                     parentTr = proxy.model.dragTooltip.tooltipTemplate;
            }            
            var templates = {};
            templates[proxy._id + "dragtooltipTemplate"] = parentTr;
            $.templates(templates);
        },       

        //render the cancel icon if drag over its child.
		_updateDragStateFalse: function (record, count) {
		    var currentRecord, proxy = this, length;
		    record.dragState = false;		   
		    if (record.hasChildRecords) {
		        length = record.childRecords.length;
		        for (var i = 0; i < length; i++) {
		            currentRecord = record.childRecords[i];
		            currentRecord.dragState = false;
		            if (currentRecord.hasChildRecords) {
		                count = proxy._updateDragStateFalse(currentRecord, count);
		            }
		        }
		    }
		    return;
		},

        //Turn all the records dragState to true once dragging finished.
		_updateDragStateTrue: function (record, count) {
		    var currentRecord, proxy = this, length;
		    if (!ej.isNullOrUndefined(record)) {
		        record.dragState = true;
		        if (record.hasChildRecords) {
		            length = record.childRecords.length;
		            for (var i = 0; i < length; i++) {
		                currentRecord = record.childRecords[i];
		                currentRecord.dragState = true;
		                if (currentRecord.hasChildRecords) {
		                    count = proxy._updateDragStateTrue(currentRecord, count);
		                }
		            }
		        }
		    }
		    return;
		},

		// Get XY coordinates for touch and non-touch device
		_getCoordinate: function (evt) {
		    var coor = evt;
		    if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend" || evt.type== "taphold" || evt.type == "tap")
		        coor = evt.originalEvent.changedTouches[0];
		    return coor;
		},

        // Get current target element by mouse position
        // window.pageXOffset && window.pageYOffset is used to find the accurate element position in IPad/IPhone
		_getElementByPosition: function (x, y) {
		    return $(document.elementFromPoint((x - window.pageXOffset), (y - window.pageYOffset)));
		},      

        //Mouse down action for to display a Drag tooltip   
		dragRecord: function (e) {
            /*verify ctlkey and shift key and mouse button*/
		    if (e.ctrlKey || e.shiftKey || e.which == 2 || e.which == 3)
		        return true;
		    
		    var proxy = this,
               model=proxy.model,
               recordIndex,
               args = {},               
               coord = proxy._getCoordinate(e),
               $target = $(e.target),
               $tr = $target.closest('tr'),
               record,
               tooltipbody,
		       updatedRecords = proxy.getUpdatedRecords();

		    window.clearTimeout(this._dragTooltipTimer);
		    this._dragTooltipTimer = null;

		    if (!proxy._mouseDown) {		       
		        return true;
		    }
                        
		    if (!$tr.hasClass("e-editedrow") && proxy.editFormValidate()) {
                if (model.selectionSettings.selectionMode == "cell")
                    proxy.clearSelection();
		       
		        proxy._clearColumnMenu();		        
		        proxy._removeDetailsRow();
		        proxy._saveCellHandler(e);
		        

		        proxy._posx = coord.pageX;
		        proxy._posy = coord.pageY;

		        if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-footersummaryrowcell")
                || $target.hasClass("e-summarytitle"))
		            return;
		        if (!model.enableVirtualization)
		            proxy._currentIndex = proxy.getIndexByRow($tr);
		        else {
		            proxy._currentIndex = proxy.getIndexByRow($tr);
		            record = model.currentViewData[proxy._currentIndex];
		            proxy._currentIndex = updatedRecords.indexOf(record);
		        }
		        proxy._draggedIndex = recordIndex = proxy.getIndexByRow($tr);
		        proxy._draggedRecord = proxy.model.currentViewData[recordIndex];
		        args.draggedRowIndex = recordIndex;
		        args.draggedRow = proxy._draggedRecord;
		        proxy._trigger("rowDragStart", args);
		        if (args.draggedRow && args.draggedRow.isSummaryRow)
		            args.cancel = true;

		        proxy._gridPosition = proxy.getOffsetRect($("#" + proxy._id)[0]);

		        if (proxy._frozenColumnsLength > 0 && recordIndex != -1) {
		            var tempTr, index = $tr.index();
		            if ($tr.closest(".e-movablecontentdiv").length > 0)
		                tempTr = $(proxy._gridRows[0])[recordIndex];
		            else
		                tempTr = $(proxy._gridRows[1])[recordIndex];
		            $tr = $tr.add(tempTr);
		        }

		        var posx = proxy._gridPosition.left, posy = coord.pageY,
		         width = proxy._$gridContainer[0].scrollWidth,
		         element = $tr.clone();
		        //Remove the hided columns.
		        element.find(".e-hide").remove();
                var tooltipItemLength = model.dragTooltip.tooltipItems.length,
		        tooltiptable = ej.buildTag("table", "", { 'padding': '1', "width": "100%","border-collapse":"collapse" }, { 'cellspacing': '1' });
		        //to render the tooltip according the option given in the model.
		        if (proxy.model.dragTooltip.showTooltip) {
		            if (proxy._dragTooltip == false) {
		                if (!proxy.model.dragTooltip.tooltipTemplate && proxy.model.dragTooltip.tooltipItems.length == 0) {

		                    tooltipbody = ej.buildTag("tbody", "", {}, {});
		                    element.find(".e-treegridexpand").css({ "display": "none" });
		                    element.find("td.e-detailsrowcell").css({ "display": "none" });
		                    element.find(".e-treegridcollapse").css({ "display": "none" });
		                    $(element.find(".intend")).css({ "width": 0 });
		                    element.find(".e-intend").removeClass("e-intend");
		                    element.find(".e-rowcell ").removeClass("e-rowcell ").addClass("e-dragrowcell");
		                    element.addClass("e-dragtooltipbackground");
		                    if (model.isFromGantt)
		                        element.find("td:last").remove();
		                    if (element.length == 2 && this._frozenColumnsLength > 0) {
		                        $(element[0]).append($(element[1].childNodes));
		                        element.splice(1, 1);
		                    }
		                    tooltipbody.append(element);
		                    tooltiptable.append(tooltipbody);
		                    proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltiptreegrid" + proxy._id + "", tooltiptable,
                                {
                                    "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': '5',
                                    'padding': '0',
                                    'border-radius': '3px',
                                    'border-right': '0',
                                    'border-bottom': '0',
                                    'width': width,
                                }, {});
		                    model.cssClass && $(proxy._dragmouseOverTooltip).addClass(model.cssClass);
		                    $(proxy._dragmouseOverTooltip).addClass("e-dragtooltipbackground").addClass("e-dragrowcell");		                    
		                    proxy._dragTooltip = true;
		                }
		                else if (tooltipItemLength != 0) {
		                    var columns = model.columns;
		                    tooltipbody = ej.buildTag("tbody", "", {}, {});
		                    var tooltiptr = ej.buildTag("tr.e-dragtooltipbackground", "", {}, {}),
		                        columnTooltipValue;
		                    for (var j = 0; j < tooltipItemLength; j++) {
		                        for (var i = 0; i < columns.length; i++) {
		                            //Skip the columns which is not visible in TreeGrid.
		                            if (columns[i].visible == false)
		                                continue;
		                            if (model.isFromGantt)
		                                columnTooltipValue = columns[i].mappingName
		                            else
		                                columnTooltipValue = columns[i].field;
		                            if (model.dragTooltip.tooltipItems[j] == columnTooltipValue) {
		                                var innerChildCollection=columnTooltipValue.split("."),
		                                    innerChildLength = innerChildCollection.length,
		                                    value, $td;
		                                if (innerChildLength == 1)
		                                    value = !ej.isNullOrUndefined(proxy._draggedRecord.item[columns[i].field]) ? proxy._draggedRecord.item[columns[i].field].toString() : false;
		                                else
		                                    value = proxy._getCustomCellValue(proxy._draggedRecord, columns[i].field);
		                                if (value) {
		                                    $td = ej.buildTag("td.e-dragrowcell", value.toString(), { "padding": "5px", "width": proxy.columnsWidthCollection[i], "height": model.rowHeight }, {});
		                                    tooltiptr.append($td);
		                                }
		                                tooltiptr.append($td);
		                                break;
		                            }
		                        }
		                    }
		                    tooltipbody.append(tooltiptr);
		                    tooltiptable.append(tooltipbody);
		                    proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltiptreegrid" + proxy._id + "", tooltiptable,
                                {
                                    "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': '5',
                                    'padding': '0',
                                    'border-right': '0',
                                    'border-bottom': '0',
                                    'border-radius': '3px',
                                    'height': "auto",
                                }, {});
		                    model.cssClass && $(proxy._dragmouseOverTooltip).addClass(model.cssClass);
		                    $(proxy._dragmouseOverTooltip).addClass("e-dragtooltipbackground").addClass("e-dragrowcell");		                    
		                    proxy._dragTooltip = true;
		                }
		                else if (proxy.model.dragTooltip.tooltipTemplate) {
		                    proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltiptreegrid" + proxy._id + "", "",
                                {
                                    "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': '5',
                                    'padding': '0',
                                    'border-right': '0',
                                    'border-bottom': '0',
                                    'border-radius': '3px',
                                    'height': "auto"
                                }, {});
		                    model.cssClass && $(proxy._dragmouseOverTooltip).addClass(model.cssClass);
		                    proxy.tooltipState = "TemplateID";
		                    tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "dragtooltipTemplate"](proxy._draggedRecord), {}, {});
		                    proxy._dragmouseOverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
		                    proxy._dragTooltip = true;
		                }                                       
		            }
		        }
		        
		        if (proxy._draggedRecord) {		            
		            proxy._draggedElement = $tr;
		            proxy._updateDragStateFalse(proxy._draggedRecord);		                                
		            proxy._dragMouseDown = true;		            
                        //if(ej.isTouchDevice() || (ej.browserInfo().name == "chrome" && e.type == "touchstart"))
                        //    $(document.body).bind("touchmove", $.proxy(proxy.dragToolTip, proxy));
		            //else
		            if (e.type == "touchstart"){
		                $(document.body).append(proxy._dragmouseOverTooltip);
		                proxy._off(proxy.element, "touchmove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);
		                proxy._on(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		            }		                
		            else{
		                proxy._off(proxy.element, "mousemove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);
		                proxy._on(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		            }		            
		        }

		        if (args.cancel) {
		            proxy._dragMouseDown = false;
		            proxy._updateDragStateTrue(proxy._draggedRecord);
		            proxy._dragTooltip = false;
		            proxy._dragmouseOverTooltip && proxy._dragmouseOverTooltip.remove();
		            proxy._dragmouseOverTooltip = null;
		            if (e.type == "touchstart")
		                proxy._off(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		            else
		                proxy._off(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		        }
		    }
		},

        //Mouse move action for to move the drag tooltip
        dragToolTip: function (e) {
            var proxy = this,
                model = proxy.model,
                args = {},
                draggedrows = [],
                length,
                recordIndex, item,
                $trClone, $target, $tr,
                $tr_summary,
                coord = proxy._getCoordinate(e);
            e.preventDefault();
            
            var diffX = Math.abs(coord.pageX - proxy._posx),
                diffY = Math.abs(coord.pageY - proxy._posy);

            if (ej.isNullOrUndefined(proxy._posx) || ej.isNullOrUndefined(proxy._posy) || (diffX < 10 && diffY < 10))
                return;                        
            
            if (proxy._dragMouseDown == true && proxy.model.allowDragAndDrop == true) {

                if (e.type == "touchmove")
                    $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                else {
                    $target = $(e.target);
                    $(document.body).append(proxy._dragmouseOverTooltip);
                }

                $tr = $target.closest('tr');
                recordIndex = proxy.getIndexByRow($tr);
                
                var updatedRecords = proxy.getUpdatedRecords();

                if (recordIndex != -1) {
                    item = proxy.model.currentViewData[recordIndex];
                    $tr = ej.TreeGrid.getRowByIndex(proxy, proxy._currentIndex);
                    $trClone = $tr.clone();
                    //Remove the hided columns.
                    $trClone.find(".e-hide").remove();
                    proxy._dragTargetItem = item;
                    args.targetRowIndex = recordIndex;
                    args.targetRow = item;
                    args.canDrop = true;
                    args.draggedRow = proxy._draggedRecord;
                    args.draggedRowIndex = updatedRecords.indexOf(proxy._draggedRecord);
                    proxy._trigger("rowDrag", args);
                    proxy._renderToolTip(coord, $trClone, args, $target);
                    if (args.targetRow && args.targetRow.isSummaryRow) {
                        proxy._draggedRecord.canDrop = false;
                        $(".intend").find(".e-icon").css({ "display": "none" });
                        $(".intendparent").find(".e-icon").css({ "display": "none" });
                    }
                    else if (args.canDrop == false) {
                        proxy._draggedRecord.canDrop = false;
                    }
                    else {
                        proxy._draggedRecord.canDrop = true;
                    }
                } else if (proxy._draggedRecord && proxy._dragMouseDown) {
                    item = null;
                    $tr = ej.TreeGrid.getRowByIndex(proxy, proxy._currentIndex);
                    $trClone = $tr.clone();
                    $tr_summary = $target.closest('tr'),
                    args.targetRowIndex = null;
                    args.targetRow = null;
                    proxy._dragTargetItem = null;
                    args.canDrop = true;
                    args.draggedRow = proxy._draggedRecord;
                    args.draggedRowIndex = proxy._draggedRecord.index;
                    proxy._trigger("rowDrag", args);
                    if (!$tr_summary.hasClass("e-footersummaryrow"))
                        proxy._renderToolTip(coord, $trClone, args, $target);
                }
                proxy._mouseout(coord);
            }
        },

        _mouseupHandler: function(e){
            var proxy = this,
                model = proxy.model;
            
            if (e.type == "touchstart")
                proxy._off(proxy.element, "touchmove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);
            else
                proxy._off(proxy.element, "mousemove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);

            proxy._off($(document), "mouseup touchend", proxy._mouseupHandler);
            proxy._mouseDown = false;
            proxy._isTouchEvent = false;
            window.clearTimeout(proxy._dragTooltipTimer);
            if (model.allowDragAndDrop && proxy._dragMouseDown)
                proxy.dragMouseUp(e);

            if (model.contextMenuSettings.showContextMenu && proxy._contextMenuHandler && proxy._displayContextMenu) {
                proxy._rightClick(e);
            }
            else
                proxy._contextMenuHandler = false;
            proxy._displayContextMenu = true;
            proxy._dy = proxy._dx = 0;
        },
         
        //Mouse up event for drag and drop
        dragMouseUp: function (e) {
            var count = 0,
                args = {},
                arg = {},
                proxy = this,
                model = proxy.model, $target, $tr,
                draggedRecord = proxy._draggedRecord,
                currentRecord = proxy._currentRecord, droppedRecord,
                canDrop, length = model.selectedItems.length,
                dropPosition, coord = proxy._getCoordinate(e);

            proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
            proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
            
            // unbind the drag events once row dropped
            if (model.allowDragAndDrop) {
                if (e.type == "touchstart")
                    proxy._off(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
                else
                    proxy._off(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);

                if (ej.isNullOrUndefined(draggedRecord))
                    canDrop = true;
                else
                    canDrop = draggedRecord.canDrop;
            }

            window.clearTimeout(proxy._dragTooltipTimer);
            proxy._dragMouseDown = false;
            $(proxy._dragmouseOverTooltip).remove();
            proxy._dragTooltip = false;

            if (e.type == "touchend")
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
            else
                $target = $(e.target);

            $tr = $target.closest('tr');

            $(".intend").find(".e-icon").css({ "display": "none" });
            $(".intendparent").find(".e-icon").css({ "display": "none" });
            var targetItem = model.currentViewData[proxy.getIndexByRow($tr)];
            if (this.cancelDrop == true && !ej.isNullOrUndefined(targetItem) && targetItem.parentItem == null) {
                var targetTr = ej.TreeGrid.getRowByIndex(this, model.updatedRecords.indexOf(targetItem));
                if (targetItem.expanded)
                    targetTr.find(".e-treegridexpand").css({ "display": "inline-block" });
                else
                    targetTr.find(".e-treegridcollapse").css({ "display": "inline-block" });
            }
            proxy._dragMouseLeave = true;
            if ($target.closest("div#" + proxy._id).length == 1 && !ej.isNullOrUndefined(draggedRecord) && proxy._dropCancel == false) {
                
                if (model.allowDragAndDrop && canDrop) {
                    proxy._dragMouseLeave = false;                    
                    var recordIndex = proxy.getIndexByRow($tr);
                    if (recordIndex != proxy._currentIndex && recordIndex != -1) {
                        proxy._droppedRecord = model.currentViewData[recordIndex];
                        droppedRecord = proxy._droppedRecord;
                        var flatRecords = model.flatRecords;
                        args.previousParentItem = draggedRecord.parentItem;
                        if (!ej.isNullOrUndefined(draggedRecord.parentItem)) {
                            args.parentChildState = draggedRecord.parentItem.hasChildRecords;
                            args.parentExpandedState = draggedRecord.parentItem.expanded;
                        }
                        arg.targetRow = $.extend({}, proxy._droppedRecord);
                        arg.targetRow.item = $.extend({}, proxy._droppedRecord.item);
                        arg.targetRowIndex = model.updatedRecords.indexOf(droppedRecord);
                        arg.draggedRow = $.extend({}, proxy._draggedRecord);
                        arg.draggedRow.item = $.extend({}, proxy._draggedRecord.item);
                        arg.draggedRowIndex = model.updatedRecords.indexOf(draggedRecord);

                        args.previousItem = arg.draggedRow;
                        args.previousItemIndex = flatRecords.indexOf(proxy._draggedRecord);
                        args.previousTarget = proxy._droppedRecord;
                        args.previousTargetItemIndex = flatRecords.indexOf(proxy._droppedRecord);
                        args.clonedTarget = $.extend({}, proxy._droppedRecord);
                        args.hasChildRecords = droppedRecord.hasChildRecords;
                        args.expanded = droppedRecord.expanded;
                        args.childIndex = args.previousParentItem ? args.previousParentItem.childRecords.indexOf(draggedRecord) : 0;
                        args.previousLevel = draggedRecord.level;
                        var draggedrows = [];

                        if (droppedRecord.dragState == true) {
                            proxy._updateDragStateTrue(draggedRecord);

                            if (proxy._insertAbove == true || proxy._insertBelow == true || proxy._insertAsChild == true) {
                                if (!proxy.model.isEdit && !proxy._isRowEdit)
                                    proxy._cancelSaveTools();
                                for (var i = 0; i < length; i++)
                                    proxy.clearSelection(model.selectedItems[i]);

                                proxy._deleteDragRow();
                                var recordIndex1 = flatRecords.indexOf(droppedRecord);
                                // Update checkbox state of parent record of dragged record
                                if (proxy._checkboxSelection && model.selectionSettings.enableHierarchySelection) {
                                    draggedRecord.parentItem && proxy._updateParentSelection(draggedRecord.parentItem);
                                }

                                //Condition to splice above to the dropped record.
                                if (proxy._insertAbove == true) {
                                    dropPosition = "insertAbove";
                                    args.index = recordIndex1;
                                    draggedRecord.parentItem = flatRecords[recordIndex1].parentItem;
                                    draggedRecord.level = flatRecords[recordIndex1].level;
                                    flatRecords.splice(recordIndex1, 0, draggedRecord);
                                    model.updatedRecords.splice(recordIndex1, 0, draggedRecord);
                                    if (model.isFromGantt)
                                        model.ids.splice(recordIndex1, 0, (draggedRecord.taskId).toString());
                                    if (draggedRecord.hasChildRecords) {
                                        var level = 1;
                                        proxy._updateChildRecord(draggedRecord, recordIndex1);
                                        proxy._updateChildRecordLevel(draggedRecord, level);
                                    }
                                    if (droppedRecord.parentItem)
                                        droppedRecord.parentItem.childRecords.splice(droppedRecord.parentItem.childRecords.indexOf(droppedRecord), 0, draggedRecord);
                                }

                                    //condition to splice below to the dropped record.
                                else if (proxy._insertBelow == true) {
                                    dropPosition = "insertBelow";
                                    args.index = recordIndex1 + 1;
                                    if (!droppedRecord.hasChildRecords) {
                                        flatRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + 1, 0, (draggedRecord.taskId).toString());
                                    }
                                    else {
                                        count = proxy.getChildCount(droppedRecord, 0);
                                        flatRecords.splice(recordIndex1 + count + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + count + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + count + 1, 0, (draggedRecord.taskId).toString());
                                    }
                                    draggedRecord.parentItem = flatRecords[recordIndex1].parentItem;
                                    draggedRecord.level = flatRecords[recordIndex1].level;
                                    if (draggedRecord.hasChildRecords) {
                                        var level = 1;
                                        proxy._updateChildRecordLevel(draggedRecord, level);
                                        proxy._updateChildRecord(draggedRecord, recordIndex1 + count + 1);
                                    }
                                    if (droppedRecord.parentItem)
                                        droppedRecord.parentItem.childRecords.splice(droppedRecord.parentItem.childRecords.indexOf(droppedRecord) + 1, 0, draggedRecord);
                                }

                                    // Condition to insert as child to the dropped Record.
                                else if (proxy._insertAsChild == true) {
                                    dropPosition = "insertAsChild";
                                    args.index = recordIndex1 + 1;
                                    if (!draggedRecord.hasChildRecords) {
                                        flatRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + 1, 0, (draggedRecord.taskId).toString());
                                        proxy._recordLevel(recordIndex);
                                    }
                                    else {
                                        flatRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + 1, 0, (draggedRecord.taskId).toString());
                                        proxy._recordLevel(recordIndex);
                                        proxy._updateChildRecord(draggedRecord, recordIndex1 + 1, droppedRecord.expanded);
                                    }
                                }
                            }
                            //update checkbox state of parent record and header of dropped record
                            if (proxy._checkboxSelection && model.selectionSettings.enableHierarchySelection) {
                                draggedRecord.parentItem && proxy._updateParentSelection(draggedRecord.parentItem);
                                proxy.selectAllRows();
                            }
                            if (draggedRecord.parentItem == null) {
                                var newPIndex = model.parentRecords.indexOf(proxy._droppedRecord);
                                if (proxy._insertBelow == true)
                                    model.parentRecords.splice(newPIndex + 1, 0, draggedRecord);
                                else if (proxy._insertAbove == true)
                                    model.parentRecords.splice(newPIndex, 0, draggedRecord);
                            }
                            args.requestType = "dragAndDrop";
                            args.draggedRow = draggedRecord;
                            args.targetRow = droppedRecord;
                            args.droppedPosition = dropPosition;
                            proxy._updateDataSource();
                            /*update summary rows collection*/
                            if (model.showSummaryRow && proxy._insertAsChild == true)
                                proxy._createSummaryRow(args);
                            proxy.processBindings(args);
                            arg.draggedRow = args.draggedRow;                                                            
                            arg.draggedRow.item = args.draggedRow.item;
                            arg.draggedRowIndex = model.updatedRecords.indexOf(draggedRecord);
                            arg.requestType = dropPosition;
                            proxy._trigger("rowDragStop", arg);
                            if (model.enableAltRow && model.currentViewData.length > 0)
                                ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);
                            if (arg.cancel)
                                proxy._revertDragging(args);
                            if (model.enableWBS && !arg.cancel) {
                                var ddSiblings;
                                if (draggedRecord.parentItem)
                                    ddSiblings = draggedRecord.parentItem.childRecords;
                                else {
                                    var flatData = model.flatRecords,
                                        Level0 = flatData.filter(function (item) {
                                            return item && item.level == 0;
                                        });
                                    ddSiblings = Level0;
                                }
                                var ddIndex = ddSiblings.indexOf(draggedRecord),
                                    selectedRecords = ddSiblings.slice(ddIndex, ddSiblings.length),
                                    parentVal = draggedRecord.parentItem ? draggedRecord.parentItem.WBS : null,
                                    lastVal = ddIndex + 1;
                                proxy.reCalculateWBS(selectedRecords, lastVal, parentVal);
                            }
                            if (model.allowSelection) {
                                if (model.selectionSettings.selectionMode == "row")
                                    proxy._selectDraggedRow($tr);
                                if (model.selectionSettings.selectionMode == "cell")
                                    proxy.updateScrollBar(model.updatedRecords.indexOf(proxy._draggedRecord));
                            }
                        }
                        else
                            //If drag state false then drop will cancel so have change the drag state.
                            proxy._updateDragStateTrue(draggedRecord);
                    }
                    else {
                        // If drop record not found means condition failed and drag state should change
                        proxy._updateDragStateTrue(draggedRecord);
                        if (!proxy.model.isEdit && !proxy._isRowEdit)
                            proxy._cancelSaveTools();
                    }
                }
                else {
                    // if canDrop true then drop will cancelled and state should change
                    proxy._updateDragStateTrue(draggedRecord);
                    proxy._resetPrivateProperties();
                    return 0;
                }
            }
            else
                // if esc key pressed or user drops a record other the tree grid content then 
                //drop cancelled and have to change the drag state.
                proxy._updateDragStateTrue(draggedRecord);
            // to enable expand and collapse icon of top most record if user mouse up outside of the grid area. 
            if (!ej.isNullOrUndefined(proxy._currentRecord)) {
                if (proxy._currentRecord.parentItem == null) {
                    $tr = ej.TreeGrid.getRowByIndex(proxy, model.updatedRecords.indexOf(proxy._currentRecord));
                    if (proxy._currentRecord.expanded)
                        $tr.find(".e-treegridexpand").css({ "display": "inline-block" });
                    else
                        $tr.find(".e-treegridcollapse").css({ "display": "inline-block" });
                }
            }
            //Update the summary row after perform the drag and drop action.
            if (model.showSummaryRow && args.requestType == "dragAndDrop" && proxy._insertAsChild != true)
                proxy._updateSummaryRow(args);

            proxy._dropCancel = false;
            proxy._resetPrivateProperties();
            if (!ej.isNullOrUndefined(draggedRecord) && !proxy.model.isEdit && !proxy._isRowEdit)
                proxy._cancelSaveTools();                        
        },

        // Mouse down action to start a Drag Column
        dragColumn: function (e) {
            
            var $target = $(e.target),
               proxy = this,
            coord = proxy._getCoordinate(e);

            proxy._posx = coord.pageX
            proxy._posy = coord.pageY;

            /*verify ctlkey and shift key and mouse button*/
            if (e.ctrlKey || e.shiftKey || e.which == 2 || e.which == 3)
                return true;

            var model = proxy.model,
               columns = model.columns,
               columnIndex,
               args = {};

            if ($target.css("cursor") == "col-resize") return; // Return if mousedown action on column resizer

            if ($target.closest(".e-headercelldiv") && !$target.hasClass("e-columnmenu-icon")) {
                var columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("ej-mappingname");
                if (ej.isNullOrUndefined(columnFieldName) && ej.isNullOrUndefined(this.getColumnByField(columnFieldName))) return;

                if (this.editFormValidate()) {
                    if (model.isEdit)
                        this.saveCell();
                    else if (this._isRowEdit)
                        this.saveRow();
                }
                if ($target.hasClass("e-checkbox"))
                    return false;

                proxy._draggedColumn = this.getColumnByField(columnFieldName);
                columnIndex = columns.indexOf(proxy._draggedColumn);
                args.draggedColumnIndex = columnIndex;
                args.draggedColumn = proxy._draggedColumn;
                args.requestType = "columnDragStart";
                if (!ej.isNullOrUndefined(proxy._draggedColumn.headerTemplateID)) {
                    proxy._draggedColumnTemplate = $target.closest(".e-headertemplate");
                }
                else {
                    proxy._draggedColumnTemplate = null;
                }
                if (!ej.isNullOrUndefined(proxy._draggedColumn.nonColumn)) return;
                proxy._trigger("columnDragStart", args);
                if (args.cancel) return;
                if (model.selectionSettings.selectionMode == "cell")
                    proxy.clearSelection();
                proxy._headerDragStatus = "mousedown";                
                proxy._dragMouseDown = true;
                proxy._mouseDragged = false;
                var gridPos = proxy.getOffsetRect(proxy.element[0]);
                proxy._gridLeft = gridPos.left;
                proxy._touchstart = true;
                // Mousemove event bind for Drag a column                
                if (e.type != "touchstart") {
                    proxy._on(proxy.element, "mousemove touchmove", proxy.dragColumnToolTip);
                }
            }
        },

        //Mousemove action to dragging tooltip
        dragColumnToolTip: function (e) {
            var proxy = this,
                model = proxy.model,
                args = {},
                $target,
                columns = model.columns,
                columnIndex, item, column = {},
                coord = proxy._getCoordinate(e),
                posx = coord.pageX, posy = coord.pageY;
                        
            if (proxy._touchstart) {
                proxy._touchstart = false;
                return;
            }
            if (e.type == "touchmove") {
                e.preventDefault();
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
            }
            else
                $target = $(e.target);

            if (proxy._headerDragStatus.length > 0 && model.allowColumnReordering == true) {

                if (model.selectionSettings.selectionMode == "cell" && proxy._headerDragStatus != "mousemove")
                    proxy.clearSelection();
                var $hcell = $target.closest(".e-headercell");
                var columnFieldName = $hcell.find(".e-headercelldiv").attr("ej-mappingname");

                if (!ej.isNullOrUndefined(columnFieldName) && !ej.isNullOrUndefined(this.getColumnByField(columnFieldName))) {

                    var targetColumn = this.getColumnByField(columnFieldName);
                    proxy._currentIndex = columns.indexOf(targetColumn);
                    args.targetColumnIndex = proxy._currentIndex;
                    args.draggedColumnIndex = columns.indexOf(proxy._draggedColumn);
                    args.draggedColumn = proxy._draggedColumn;
                    args.targetColumn = targetColumn;
                    args.requestType = "columnDrag";
                    args.canDrop = true;

                    proxy._trigger("columnDrag", args);
                    if (args.cancel) return;

                    column.pos = proxy.getOffsetRect($hcell[0]);
                    column.height = $($hcell).height();
                    column.width = $($hcell).outerWidth();
                    column.pos.top = proxy.getOffsetRect($hcell.closest(".e-gridheader")[0]).top;
                    column.pos.left = ((args.draggedColumnIndex > args.targetColumnIndex)) ? (column.pos.left - 2) : (column.pos.left + column.width - 2);
                    column.display = "block";
                    args.column = column;
                    args.direction = (args.draggedColumnIndex > args.targetColumnIndex) ? "left" : "right";
                    proxy._autoHscroll(posx, posy, args);

                    if ((args.draggedColumnIndex == args.targetColumnIndex) || !ej.isNullOrUndefined(args.targetColumn.nonColumn) ||
                        ((column.pos.left - 8) > (proxy._gridWidth + proxy._gridLeft))) {
                        column.display = "none";
                    }
                    if (proxy._headerDragStatus != "mousemove" && !proxy._dragTooltip) {

                        var height = proxy._gridHeight - 1;
                        if (proxy.model.toolbarSettings.showToolbar) {
                            height -= !ej.isNullOrUndefined($("#" + proxy._id + "_toolbarItems").outerHeight()) ? $("#" + proxy._id + "_toolbarItems").outerHeight() : 0;
                        }
                        height -= proxy.getScrollElement().ejScroller("isHScroll") ? 18 : 0;

                        var tooltipcolumn = ej.buildTag('div', proxy._draggedColumn.headerText, { "margin-top": "5px" });
                        if (!ej.isNullOrUndefined(proxy._draggedColumnTemplate) && !ej.isNullOrUndefined(proxy._draggedColumn) && !ej.isNullOrUndefined(proxy._draggedColumn.headerTemplateID))
                            tooltipcolumn[0].innerHTML = proxy._draggedColumnTemplate[0].innerHTML;
                        proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#columnreordertooltip" + proxy._id + "", tooltipcolumn,
                            {
                                "top": posy + "px", "left": (posx - 57) + "px",
                                'position':'absolute',
                                'z-index': proxy.getMaxZIndex() + 1
                            }, {});
                        model.cssClass && proxy._dragmouseOverTooltip.addClass(model.cssClass);
                        proxy._reordervline = ej.buildTag("div.e-vline#reorderline" + proxy._id + "", {
                            "height": height,
                            "width": 0,
                            "border-width": 0,
                            "position": "absolute",
                            "top": column.pos.top + "px",
                            "left": column.pos.left + "px",
                            "border-left-width": "3px",
                            "border-style": "solid",
                            "display": column.display,
                        });
                        model.cssClass && proxy._reordervline.addClass(model.cssClass);
                        $(document.body).append(proxy._dragmouseOverTooltip);
                        $(document.body).append(proxy._reordervline);
                        $(proxy._dragmouseOverTooltip).addClass("e-headertooltip");
                        $(proxy._reordervline).addClass("e-headervline");
                        proxy._dragmouseOverTooltip["width"] = $(proxy._dragmouseOverTooltip).outerWidth();
                        proxy._reordervline["height"] = height;
                        proxy._dragTooltip = true;
                    }
                    else {
                        $(proxy._reordervline).css({
                            "height": proxy._reordervline["height"],
                            "width": 0,
                            "border-width": 0,
                            "position": "absolute",
                            "top": column.pos.top + "px",
                            "left": column.pos.left + "px",
                            "border-left-width": "3px",
                            "border-style": "solid",
                            "display": column.display,
                        });

                        $(proxy._dragmouseOverTooltip).css({
                            'top': posy + "px",
                            'left': posx - (proxy._dragmouseOverTooltip["width"] / 2) + "px",
                        });
                    }
                    proxy._headerDragStatus = "mousemove";                    
                }
                else {
                    if (!ej.isNullOrUndefined(proxy._dragmouseOverTooltip)) {
                        $(proxy._dragmouseOverTooltip).css({
                            'top': posy + "px",
                            'left': posx - (proxy._dragmouseOverTooltip["width"] / 2) + "px",
                        });
                    }
                }
            }
        },      

        //Public method to reorder the Column position.
        reorderColumn: function (fieldName, targetColumnIndex) {
            var proxy = this, model = proxy.model,
                columns = model.columns, draggedColumn, 
                draggedColumnIndex, targetColumn, width, treeColumn,
                frozenWidth;

            treeColumn = columns[model.treeColumnIndex];
            draggedColumn = proxy.getColumnByField(fieldName);
            draggedColumnIndex = columns.indexOf(draggedColumn);
            width = proxy.columnsWidthCollection[draggedColumnIndex];
            
            targetColumn = columns[targetColumnIndex];
            if (targetColumn && targetColumn.nonColumn) return;
           
            if (proxy._frozenColumnsLength > 0) {

                frozenWidth = this._getFrozenColumnWidth();
                // Drag from non-freeze column and drop on frozen column
                if (proxy._frozenColumnsLength <= draggedColumnIndex && proxy._frozenColumnsLength > targetColumnIndex && proxy._frozenColumns.indexOf(draggedColumn) == -1) {                    
                    frozenWidth = frozenWidth + (this.columnsWidthCollection[draggedColumnIndex] + 18);
                    if (frozenWidth > this._gridWidth)
                        return false;
                    draggedColumn['isFrozen'] = true;
                    proxy._frozenColumns.splice(targetColumnIndex, 0, draggedColumn);
                }
                    // Drag from frozen column and drop on non-freeze column
                else if (proxy._frozenColumnsLength > draggedColumnIndex && proxy._frozenColumnsLength <= targetColumnIndex && proxy._frozenColumns.indexOf(draggedColumn) != -1) {                   
                    draggedColumn['isFrozen'] = false;
                    proxy._frozenColumns.splice(draggedColumnIndex, 1);
                    if (proxy._checkboxSelection && proxy._frozenColumns.length == 1 && proxy._frozenColumns[0]['nonColumn']) {
                        proxy._frozenColumns[0]['isFrozen'] = false;
                        proxy._frozenColumns.splice(0, 1);
                    }

                }
            }

            columns.splice(draggedColumnIndex, 1);
            proxy.columnsWidthCollection.splice(draggedColumnIndex, 1);
            columns.splice(targetColumnIndex, 0, draggedColumn);
            proxy.columnsWidthCollection.splice(targetColumnIndex, 0, width);
            
            model.treeColumnIndex = columns.indexOf(treeColumn);
            proxy._refreshFrozenColumns();
        },

        //Horizontal auto scroll while drag towards the end
        _autoHscroll: function (posx, posy, args) {
            var proxy = this,
                model = proxy.model,
                maxWidth,
                isHscroll,
                columns = model.columns,
                frozenWidth = 0,
                columnsWidth = proxy.columnsWidthCollection,
            gridContent = proxy.getScrollElement();

            isHscroll = gridContent.ejScroller("isHScroll");

            maxWidth = isHscroll ? gridContent.find(".e-content").get(0).scrollWidth : 0;
            proxy._viewPortWidth = gridContent.find(".e-content").width();

            if (proxy._frozenColumnsLength > 0) {
                frozenWidth = this._getFrozenColumnWidth();
            }
            var rightScrollPos = Math.round(((proxy._gridLeft + proxy._gridWidth) * 10)/ 100) + 18,
                leftScrollPos = Math.round((proxy._gridLeft * 10) / 100) + 18,
                topvalue = 0;

            if (((proxy._gridLeft + proxy._gridWidth) - rightScrollPos) < posx) {
                if (!proxy._timerDragDown) {

                    //Timer started for scrolling the content till the end.
                    proxy._timerDragDown = window.setInterval(function () {
                        if (maxWidth > (proxy._scrollLeft + proxy._viewPortWidth)) {
                            topvalue = proxy._scrollLeft;
                            topvalue = topvalue + 50;
                            proxy.getScrollElement().ejScroller("scrollX", topvalue, true);
                        }
                    }, 300);
                }
            }
            else {
                proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
            }            

            if ((posx < (proxy._gridLeft + frozenWidth + leftScrollPos)) && ( posx > (proxy._gridLeft + frozenWidth)) && proxy._scrollLeft != 0) {
                if (proxy._scrollLeft > 0) {
                    if (!proxy._timerDragUp) {
                        proxy._timerDragUp = window.setInterval(function () {
                            if (proxy._scrollLeft > 0) {
                                topvalue = proxy._scrollLeft;
                                topvalue = topvalue - 50;
                                if (topvalue < 0)
                                    topvalue = 0;
                                proxy.getScrollElement().ejScroller("scrollX", topvalue, true);
                            }
                        }, 300);
                    }
                }
                else {
                    proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
                }
            }
            else {
                proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
            }
        },

        _resetPrivateProperties: function () {
            this._timerDragDown && (this._timerDragDown = window.clearInterval(this._timerDragDown));
            this._timerDragUp && (this._timerDragUp = window.clearInterval(this._timerDragUp));
            var proxy = this, model = proxy.model;
            proxy.cancelDrop = false;
            proxy._draggedRecord = null;            
            proxy._dragMouseDown = false;
            proxy._timerDragDown = null;
            proxy._timerDragUp = null;
            proxy._childItem = false;
            proxy._dragMouseLeave = false;
            proxy._currentRecord = null;
            proxy._currentIndex = null;
            proxy._droppedRecord = null;
            proxy._insertAsChild = false;
            proxy._insertAbove = false;
            proxy._insertBelow = false;
            if (model.allowDragAndDrop && model.enableVirtualization && (ej.browserInfo().name == "chrome" || ej.isTouchDevice())) {
                proxy._dummyElement && $(proxy._draggedElement).remove();
                proxy._dummyElement = false;
                proxy._draggedElement = null;
            }          
            proxy._dragTooltipTimer = null;
            proxy._dragColumnTooltipTimer = null;
            proxy._dragmouseOverTooltip = null;
        },
        // To select the dragged Record after drag stopped.
        _selectDraggedRow: function ($tr) {
            var proxy = this, model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                rowIndex = updatedRecords.indexOf(proxy._draggedRecord);            
			proxy._focusTreeGridElement();
            if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex))) {                
                proxy.selectRows(rowIndex);
                proxy._rowSelectedEventTrigger(rowIndex);
            }
        },
        //Add child records to the data source
        _addChildItem: function (record) {
            var currentRecord, proxy = this, length=0;
            length = record.childRecords.length;
            for (var i = 0; i < length; i++) {
                currentRecord = record.childRecords[i];
                if (proxy.dataSource() instanceof ej.DataManager) {
                    if (proxy.dataSource().dataSource.offline && proxy.dataSource().dataSource.json) {
                        proxy.dataSource().dataSource.json.push(currentRecord.item);
                        if (currentRecord.hasChildRecords) {
                            proxy._addChildItem(currentRecord);
                        }
                    }
                } else {
                    proxy.dataSource().push(currentRecord.item);                     
                    if (currentRecord.hasChildRecords) {
                        proxy._addChildItem(currentRecord);
                    }
                }
            }
        },
        //Update the changes in DataSource.
        _updateDataSource: function () {
            var proxy = this,
                model = proxy.model,
                draggedRecord = proxy._draggedRecord,
                droppedRecord = proxy._droppedRecord,
                tempDataSource, idx, childIndex;
            if (proxy.dataSource() instanceof ej.DataManager) {
                if (proxy.dataSource().dataSource.offline && proxy.dataSource().dataSource.json) {
                    tempDataSource = proxy.dataSource().dataSource.json;
                }
            }
            else 
                tempDataSource = proxy.dataSource();
            
            if (tempDataSource && !droppedRecord.parentItem) {
                idx = tempDataSource.indexOf(droppedRecord.item);
                if (proxy._insertAbove) {
                    if (!model.parentIdMapping)
                        tempDataSource.splice(idx, 0, draggedRecord.item);
                }
                else if (proxy._insertBelow) {
                    if (!model.parentIdMapping)
                        tempDataSource.splice(idx + 1, 0, draggedRecord.item);
                }
            }
            else if (!model.parentIdMapping && droppedRecord.parentItem) {
                childIndex = droppedRecord.parentItem.childRecords.indexOf(draggedRecord);
                if (proxy._insertAbove) 
                    droppedRecord.parentItem.item[proxy.model.childMapping].splice(childIndex, 0, draggedRecord.item);
                else if (proxy._insertBelow)
                    droppedRecord.parentItem.item[proxy.model.childMapping].splice(childIndex, 0, draggedRecord.item);
            }

            if (model.parentIdMapping) {
                if (draggedRecord.parentItem) {
                    if (proxy._insertAbove || proxy._insertBelow) {
                        if (model.isFromGantt == true) {
                            draggedRecord.item[model.parentIdMapping] = droppedRecord.item[proxy.model.parentIdMapping];
                        }
                        else {
                            draggedRecord[model.parentIdMapping] = droppedRecord[proxy.model.parentIdMapping];
                            draggedRecord.item[model.parentIdMapping] = droppedRecord[proxy.model.parentIdMapping];
                        }
                    }
                    else {
                        if (model.isFromGantt == true) {
                            draggedRecord.item[model.parentIdMapping] = droppedRecord.item[proxy.model.idMapping];
                        }
                        else {
                            draggedRecord[model.parentIdMapping] = droppedRecord[proxy.model.idMapping];
                            draggedRecord.item[model.parentIdMapping] = droppedRecord[proxy.model.idMapping];
                        }
                    }
                }
                else {
                    draggedRecord.item[model.parentIdMapping] = null;
                    draggedRecord[model.parentIdMapping] = null;
                }

                if (proxy.dataSource() instanceof ej.DataManager) {
                    if (proxy.dataSource().dataSource.offline && proxy.dataSource().dataSource.json) {
                        proxy.dataSource().dataSource.json.push(draggedRecord.item);
                    }
                } else {

                    if (proxy._insertAbove || proxy._insertBelow || proxy._insertAsChild)
                        proxy.dataSource().push(draggedRecord.item);
                    if (draggedRecord.hasChildRecords) {
                        proxy._addChildItem(draggedRecord);
                    }
                }

            }
        },

        //This method is to delete the dragged record 
        _deleteDragRow: function ($tr) {
            var proxy = this,
                model = proxy.model,
                 deletedRowIndex,
                 deletedRow,
                 dataRows,
                 isUpdateWBS,
                 targetRowIndex,
                 args = {},
                 updatedRecords = proxy.getUpdatedRecords();
            deletedRowIndex = updatedRecords.indexOf(proxy._draggedRecord);
            deletedRow = updatedRecords[deletedRowIndex];
            args.tr = $tr;
            args.data = deletedRow;
            args.requestType = ej.TreeGrid.Actions.Delete;
            args.isDragAndDropDelete = true;
            if (proxy._trigger("actionBegin", args)) {
                return true;
            }
            if (proxy.model.enableWBS) {
                dataRows, targetRowIndex, isUpdateWBS = false;
                if (deletedRow && deletedRow.parentItem) {
                    dataRows = deletedRow.parentItem.childRecords;
                    targetRowIndex = dataRows.indexOf(deletedRow);
                } else if (model.flatRecords.length) {
                    var flatData = model.flatRecords,
                    Level0 = flatData.filter(function (item) {
                        return item && item.level == 0;
                    });
                    dataRows = Level0;
                    targetRowIndex = dataRows.indexOf(deletedRow);
                }
                if (targetRowIndex != dataRows.length - 1)
                    isUpdateWBS = true;
            }
            proxy._removeRecords(args);           
            if (isUpdateWBS) {
                var targetRow;
                if (deletedRow.parentItem)
                    targetRow = dataRows[targetRowIndex];//Here we are having the updated 'dataRows'
                else {
                    //for level 0 records
                    dataRows.splice(targetRowIndex, 1);
                    targetRow = dataRows[targetRowIndex];
                }
                proxy.updateWBSdetails(targetRow);
            }
            if (!proxy._checkboxSelection)
                model.selectedItems = [];
            proxy._previousIndex = -1;
        },
        // To revert the changes if drop get cancelled.
        _revertDragging: function (args) {
            var proxy = this,
                model=proxy.model,
                flatRecords = model.flatRecords;
            proxy._draggedRecord = args.draggedRow;
            proxy._deleteDragRow();
            if (!proxy._draggedRecord.hasChildRecords) {
                flatRecords.splice(args.previousItemIndex, 0, proxy._draggedRecord);
                flatRecords[args.previousItemIndex].parentItem = args.previousItem.parentItem;
                if (!ej.isNullOrUndefined(args.previousParentItem)) {
                    flatRecords[args.previousItemIndex].parentItem.childRecords.splice(args.childIndex, 0, proxy._draggedRecord);
                    flatRecords[args.previousItemIndex].parentItem.hasChildRecords = true;
                    flatRecords[args.previousItemIndex].parentItem.hasFilteredChildRecords = true;
                    flatRecords[args.previousItemIndex].parentItem.expanded = true;
                }
                flatRecords[args.previousItemIndex].level = args.previousLevel;
            }
            else {
                flatRecords.splice(args.previousItemIndex, 0, proxy._draggedRecord);
                if (!ej.isNullOrUndefined(flatRecords[args.previousItemIndex].parentItem)) {
                    flatRecords[args.previousItemIndex].parentItem = args.previousParentItem;
                    if (!ej.isNullOrUndefined(args.previousParentItem))
                        flatRecords[args.previousItemIndex].parentItem.childRecords.splice(args.childIndex, 0, proxy._draggedRecord);
                }
                var recordIndex = model.flatRecords.indexOf(proxy._draggedRecord);
                proxy._updateChildRecord(proxy._draggedRecord,recordIndex, args.previousItem.index);
                proxy._draggedRecord.level = args.previousLevel;
                proxy._updateChildRecordLevel(proxy._draggedRecord, args.previousLevel);
            }
            if (model.parentIdMapping) {
                flatRecords[args.previousItemIndex][model.parentIdMapping] = args.previousItem[model.parentIdMapping];
                flatRecords[args.previousItemIndex].item[model.parentIdMapping] = args.previousItem[model.parentIdMapping];
            }
            if (!ej.isNullOrUndefined(args.previousItem.parentItem)) {
                args.previousItem.parentItem.hasChildRecords = args.parentChildState;
                args.previousItem.parentItem.expanded = args.parentExpandedState;
                if (model.childMapping && args.previousItem.parentItem.item[proxy.model.childMapping])
                    args.previousItem.parentItem.item[proxy.model.childMapping].splice(args.childIndex, 0, args.previousItem.item);
            }
            if (model.isFromGantt) {
                flatRecords[args.previousTargetItemIndex] = args.previousTarget;
                if (args.previousTarget.isAutoSchedule == true) {
                    args.previousTarget.startDate = args.previousTarget.item[args.model.startDateMapping] = new Date(args.clonedTarget.startDate);
                    args.previousTarget.endDate = new Date(args.clonedTarget.endDate);
                    args.previousTarget.duration = args.clonedTarget.duration;
                    args.previousTarget.status = args.clonedTarget.status;
                    if (args.model.endDateMapping) {
                        args.previousTarget.item[args.model.endDateMapping] = new Date(args.clonedTarget.endDate);
                    }
                    if (args.model.progressMapping) {
                        args.previousTarget.item[args.model.progressMapping] = args.clonedTarget.status;
                    }
                    if (args.model.durationMapping) {
                        args.previousTarget.item[args.model.durationMapping] = args.clonedTarget.duration;
                    }
                    args.previousTarget.expanded = args.clonedTarget.expanded;
                    var ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
                    ganttObject._updateTargetGanttRecord(args.previousTarget);
                }
                else {
                    args.previousTarget.manualStartDate = new Date(args.clonedTarget.manualStartDate);
                    args.previousTarget.manualEndDate = new Date(args.clonedTarget.manualEndDate);
                    args.previousTarget.manualDuration = args.clonedTarget.manualDuration;
                    args.previousTarget.status = args.clonedTarget.status;
                    if (args.model.progressMapping) {
                        args.previousTarget.item[args.model.progressMapping] = args.clonedTarget.status;
                    }
                    args.previousTarget.expanded = args.clonedTarget.expanded;
                    var ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
                    ganttObject._updateGanttRecord(args.previousTarget);
                }
            }
            proxy.processBindings(args);
            if (model.currentViewData.length > 0)
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);
        },

        //To splice the child records if user drag and dropped the parent item.
        _updateChildRecord: function (record, count,expandState){
            var currentRecord,
                proxy = this,
                model = proxy.model,
                length;
            if (!record.hasChildRecords)
                return 0;
            length = record.childRecords.length;
            for (var i = 0; i < length; i++) {
                currentRecord = record.childRecords[i];
                count++;
                model.flatRecords.splice(count, 0, currentRecord);
                model.updatedRecords.splice(count, 0, currentRecord);
                if (model.isFromGantt)
                    model.ids.splice(count, 0, (currentRecord.taskId).toString());
                if (currentRecord.hasChildRecords) {
                    count = proxy._updateChildRecord(currentRecord, count);
                }
            }
            return count;
        },
        //This method is to leveling the records when it is inserted as child.
        _recordLevel: function (recordIndex) {
            var j = 0, proxy = this,
                model = proxy.model,
                draggedRecord=proxy._draggedRecord,
                droppedRecord = proxy._droppedRecord,
                childItem = proxy.model.childMapping;
            if (!droppedRecord.hasChildRecords) {
                droppedRecord.hasChildRecords = true;
                droppedRecord.hasFilteredChildRecords = true;
                if (ej.util.isNullOrUndefined(droppedRecord.childRecords) || $.isEmptyObject(droppedRecord.childRecords)) {
                    droppedRecord.childRecords = [];
                    if (!model.parentIdMapping)
                        droppedRecord.item[childItem] = [];
                }
            }
            if (proxy._insertAsChild) {
                draggedRecord.parentItem = droppedRecord;
                droppedRecord.childRecords.splice(0, 0, draggedRecord);
                if (!ej.isNullOrUndefined(draggedRecord) && !ej.isNullOrUndefined(droppedRecord.item[childItem]) && !model.parentIdMapping) {
                    droppedRecord.item[childItem].splice(0, 0, draggedRecord.item);
                }
                if (!draggedRecord.hasChildRecords)
                    draggedRecord.level = droppedRecord.level + 1;
                else {
                    var level = 1;
                    draggedRecord.level = droppedRecord.level + 1;
                    proxy._updateChildRecordLevel(draggedRecord, level);
                }
                droppedRecord.expanded = true;
                proxy._parentRecords.push(droppedRecord);
            }
        },
        // This method is to level the parent record at the end of it hierarchy.
        _updateChildRecordLevel: function (record,level) {
            var proxy = this,
                length=0,
                currentRecord;
            level++;
            if (!record.hasChildRecords)
                return 0;
            length = record.childRecords.length;
            for (var i = 0; i < length ; i++) {
                currentRecord = record.childRecords[i];
                currentRecord.level = record.parentItem ? record.parentItem.level + level : record.level + 1;
                if (currentRecord.hasChildRecords) {
                    level--;
                    level = proxy._updateChildRecordLevel(currentRecord, level);
                }
            }
            return level;
        },
                   
        //To renter cancel icon in filtering elements.
        _filterBarClose: function (e) {
            var $target = $(e.target);
            if (e.type == "click" && $target.hasClass("e-cancel")) {
                var $targetText = $target.prev();
                    $targetText.focus().val("");
                $targetText.prop('checked', false);
                $targetText.trigger("keyup");
                e.stopPropagation();
            }
            if (e.type == "focusin") { 
                $target = $(e.target).next();
                this.getHeaderTable().find(".e-cancel").addClass("e-hide");
                $target.removeClass("e-hide");
            }
        },

        _checkIdenticalValue: function (val, currentFilterColumn) {
            var proxy = this,
                model = proxy.model,
                flag,
                filteredColumns = model.filterSettings.filteredColumns,
                columnLength = filteredColumns.length;
            for (var col = 0; col < columnLength; col++) {
                if (filteredColumns[col].value === val && filteredColumns[col].field == currentFilterColumn.field) {
                    flag = true;
                    break;
                }               
            }
            return flag;            
        },
        //To wireup method while user enter text to the filter textbox.
        _filterBarHandler: function (e) {
            var proxy = this,
                $target,
                model = proxy.model,filteringColumn;
            //cancel the edited cell and row
            if (proxy.model.isEdit)
                proxy.cancelEditCell();
            else if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            /* flag new added record is sorted or filttered in treegrid */
            proxy._isRefreshAddedRecord = false;

            /* clear selction*/
            proxy.clearAllSelection();

            if (e.target == undefined)
                $target =$(e);
            else
                $target = $(e.target);
            
            if (this.model.allowFiltering ) {
                var cols=proxy.model.columns;
                var matchcase;
                matchcase = proxy._cellEditingDetails;
                var key = proxy._queryManagar.queries[0], $element;
                //Get input element onEnter event
                if ($target.hasClass("e-ddl"))
                    $element = $target.find("input.e-field");
                else
                    $element = $target;
                proxy._fieldName = $element[0].id.replace(proxy._id + "_", "").replace("_filterbarcell", "");
                this._currentFilterColumn = ej.TreeGrid.getColumnByField(model.columns, proxy._fieldName);
                proxy._fieldName = this._currentFilterColumn.field;
                var currentFilterCol = this._currentFilterColumn, currentDateformat;
                if ($target.hasClass("e-checkbox"))
                    proxy._searchString = $target[0].checked;
                else if ($target.hasClass("e-ddl")) {
                    // To get the value from dropdown filter (onEnter) mode
                    $target = $target.find("input.e-dropdownlist");
                    var dropDownElement = $("#" + $target[0].id).data("ejDropDownList");
                    if (dropDownElement.selectedIndexValue == -1 || (proxy._checkIdenticalValue(dropDownElement._selectedValue, this._currentFilterColumn)))
                        return true;
                    proxy._searchString = dropDownElement._selectedValue;
                }
                else if ($target.hasClass("e-dropdownlist")) {
                    // To get the value from dropdown filter (immediate) mode
                    var dropdownobject = $("#" + $target[0].id).data("ejDropDownList");
                    if (dropdownobject.selectedIndexValue == -1 || (proxy._checkIdenticalValue(dropdownobject._selectedValue, this._currentFilterColumn)))
                        return true;
                    if (dropdownobject._selectedValue==proxy._dropDownListClearText)
                        proxy._searchString = "";
                    else
                        proxy._searchString = dropdownobject._selectedValue;
                }
                else
                    proxy._searchString = $target.closest("input").val();
                if ((this._currentFilterColumn.filterEditType == "datepicker" || this._currentFilterColumn.filterEditType == "datetimepicker") && proxy._searchString != "") {
                    if (proxy._searchString) {
                        if (currentFilterCol.format)
                            currentDateformat = proxy._getDateFormat(this._currentFilterColumn.format);
                        else
                            currentDateformat = proxy.model.dateFormat;
                        if (ej.isNullOrUndefined(ej.parseDate(proxy._searchString, currentDateformat, model.locale)))
                            proxy._searchString = "";
                        else
                            proxy._searchString = ej.parseDate(proxy._searchString, currentDateformat, model.locale);
                    }
                }
                if (proxy._searchString == "") {
                    filteringColumn = model.filterSettings.filteredColumns.filter(function (column) {
                        if (column.field === proxy._fieldName)
                            return true;
                    });
                    if (!filteringColumn.length) {
                        proxy._resizeFilteringElements();
                        return true;
                    }
                }
               
                proxy._validateFilterValue(proxy._searchString);
                proxy.filterColumn(proxy._fieldName, this._operator, proxy._searchString, this._predicate);                
                proxy._storePreviousFilteredValue(proxy._fieldName, proxy._searchString, this._operator);
                if (proxy.model.currentViewData.length > 0 && proxy.model.enableAltRow)
                    ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);                
            }
        },
        //Method to validate search string type and assign operators accordingly.
        _validateFilterValue: function (_value) {
            var proxy = this;
            this._predicate = "and";
            switch (this._currentFilterColumn.filterEditType) {
                case "numericedit":
                    this._operator = ej.FilterOperators.equal;
                    break;
                case "datepicker":
                    this._operator = ej.FilterOperators.equal;
                    
                    var _format;
                    if (this._currentFilterColumn.format == "" || this._currentFilterColumn.format == undefined)
                        _format = ej.preferredCulture().calendar.patterns.d; //System Date format
                    else
                        _format = this._currentFilterColumn.format.split(':')[1].replace('}', "");
                    if (this._currentFilterbarValue != "")
                        this._currentFilterbarValue = ej.format(_value, _format, this.model.locale);
                    break;
                case "datetimepicker":
                    this._operator = ej.FilterOperators.equal;
                  
                    var _format;
                    if (this._currentFilterColumn.format == "" || this._currentFilterColumn.format == undefined)
                        _format = ej.preferredCulture().calendar.patterns.f; //System DateTime format
                    else
                        _format = this._currentFilterColumn.format.split(':')[1].replace('}', "");
                    if (this._currentFilterbarValue != "")
                        this._currentFilterbarValue = ej.format(_value, _format, this.model.locale);
                    break;
                case "stringedit":
                    this._operator = ej.FilterOperators.startsWith;
                    break;
                case "dropdownedit":
                    var filterColumn = this._currentFilterColumn;
                    if (filterColumn.editType == "dropdownedit" && filterColumn.editParams && filterColumn.editParams.showCheckbox)
                        this._operator = ej.FilterOperators.contains;
                    else
                        this._operator = ej.FilterOperators.equal;
                    break;
                case "booleanedit":
                    if (proxy._searchString == true || proxy._searchString == "1")
                        proxy._searchString = true;
                    else if (proxy._searchString == "false" || proxy._searchString == "0")
                        proxy._searchString = false;
                    this._operator = ej.FilterOperators.equal;
                    break;
                default:
                    this._operator = ej.FilterOperators.equal;
            }
        },

        // Method to render header tooltip and header template tooltip.
        _headermouseHover: function (e) {
            e.preventDefault();
            var proxy = this,
                model = proxy.model;
            if (model.showGridCellTooltip) {
                if (!proxy._dragTooltip) {
                    var $target = $(e.target),
                        posx = 0,
                        posy = 0,
                        column = $target.closest('div.e-headercelldiv'),
                        tooltiptable, tooltipbody, textContent, tooltipWidth,
                        tooltipHeight, containerWidth, containerHeight,
                        currentColumn, columnFieldName;
                    proxy._headerMouseLeave();
                    if (!e) e = window.event;
                    if (e.originalEvent.pageX || e.originalEvent.pageY) {
                        posx = e.originalEvent.pageX;
                        posy = e.originalEvent.pageY;
                    }
                    else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                        posx = e.originalEvent.clientX + document.body.scrollLeft
                            + document.documentElement.scrollLeft;
                        posy = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;
                    }
                    textContent = column.clone();
                    if (textContent.find(".e-ascending").length > 0) {
                        textContent.find(".e-ascending").remove();
                    } else if (textContent.find(".e-descending").length > 0) {
                        textContent.find(".e-descending").remove();
                    }
                    if ($target.closest(".e-headercell").hasClass("e-headertemplate")) {
                        textContent = textContent.clone();
                    } else {
                        textContent = textContent.find("span").clone();
                    }
                    tooltiptable = ej.buildTag("table.e-tooltiptable", "", { 'padding': '0' }, { 'cellspacing': '1' });
                    tooltipbody = ej.buildTag("tbody", textContent, {}, {});
                    tooltiptable.append(tooltipbody);
                    var isNonEmptyText = $(textContent).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;
                    if (tooltipbody) {
                        columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("ej-mappingname");
                        currentColumn = this.getColumnByField(columnFieldName);
                        if (currentColumn && (ej.isNullOrUndefined(currentColumn['headerTooltip']) || currentColumn['headerTooltip'] == "")) {
                            if (model.showGridCellTooltip && isNonEmptyText) {
                                var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5;
                                proxy._headerMouseOverTooltip = ej.buildTag("div.e-tooltipgantt#headertooltip" + proxy._id + "", tooltiptable,
                                    {
                                        "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                        'position': 'absolute',
                                        'z-index': proxy.getMaxZIndex() + 1,
                                        'padding': '0',
                                        'border-radius': '3px'
                                    }, {});
                                model.cssClass && (proxy._headerMouseOverTooltip.addClass(model.cssClass));
                                //Providing a time delay to render the tooltip to improve UI
                                proxy._headerTooltipTimer = setTimeout(function () {
                                    $(document.body).append(proxy._headerMouseOverTooltip);
                                    var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                        position = proxy.getOffsetRect(element[0]);
                                    containerWidth = $(element).width() + position.left;
                                    containerHeight = $(element).height() + position.top;
                                    tooltipWidth = $(proxy._headerMouseOverTooltip).width();
                                    tooltipHeight = $(proxy._headerMouseOverTooltip).height();
                                    // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                    if ((posx + tooltipWidth + 15) >= containerWidth) {
                                        posx = posx - tooltipWidth - 15;
                                    }
                                    if ((posy + tooltipHeight + 10) >= containerHeight) {
                                        posy = posy - tooltipHeight - 10;
                                    }
                                    $(proxy._headerMouseOverTooltip).css({ "top": posy, "left": posx });
                                }, 700);
                            }
                        } else if (currentColumn && !ej.isNullOrUndefined(currentColumn['headerTooltip']) && currentColumn['headerTooltip'] != "") {
                            var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5,
                                dataObj = {};
                            dataObj["column"] = currentColumn;
                            proxy._createColumnTooltipTemplate(currentColumn['headerTooltip']);
                            proxy._headerMouseOverTooltip = ej.buildTag("div.e-tooltipgantt#headertooltip" + proxy._id + "", "",
                                {
                                    "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': proxy.getMaxZIndex() + 1,
                                    'padding': '0',
                                    'border-radius': '3px'
                                }, {});
                            model.cssClass && (proxy._headerMouseOverTooltip.addClass(model.cssClass));
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "columnTooltipTemplate"](dataObj), {}, {});
                            proxy._headerMouseOverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                            var isNonEmptyText = $(tooltipbody).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;
                            if (isNonEmptyText){
                            proxy._headerTooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._headerMouseOverTooltip);
                                if (!model.isFromGantt) {
                                    var position = proxy.getOffsetRect(proxy.element[0]);
                                    containerWidth = $(proxy.element).width() + position.left;
                                    containerHeight = $(proxy.element).height() + position.top;
                                }
                                else {
                                    var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                        position = proxy.getOffsetRect(element[0]);
                                    containerWidth = $(element).width() + position.left;
                                    containerHeight = $(element).height() + position.top;
                                }
                                tooltipWidth = $(proxy._headerMouseOverTooltip).width();
                                tooltipHeight = $(proxy._headerMouseOverTooltip).height();
                                // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                if ((posx + tooltipWidth + 15) >= containerWidth) {
                                    posx = posx - tooltipWidth - 15;
                                }
                                if ((posy + tooltipHeight + 10) >= containerHeight) {
                                    posy = posy - tooltipHeight - 10;
                                }
                                $(proxy._headerMouseOverTooltip).css({ "top": posy, "left": posx });
                            }, 700);
                            }
                        }
                    }
                }
            }
        },
        
        _mouseHover: function (e) {            
            var proxy = this,
                model = proxy.model;
            if (model.showGridCellTooltip) {
                if (this._dragMouseDown != true) {
                    var $target = $(e.target),
                        posx = 0,
                        posy = 0,
                        $ganttGridRows = proxy.getRows(),
                        row = $target.closest('tr'),
                        column = $target.closest('td.e-rowcell'),
                        recordIndex = this.getIndexByRow(row),
                        item = model.currentViewData[recordIndex],
                        tooltiptable, tooltipbody, textContent, tooltipWidth,
                        tooltipHeight, containerWidth, containerHeight,
                        columns = model.columns,
                        currentColumn;

                    if (row.hasClass("e-footersummaryrow")) {
                        recordIndex = proxy._getFooterRows().index(row);
                        item = proxy._footerSummaryRecord[recordIndex];
                    }
                    
                    if (recordIndex >= 0 || row.hasClass("e-footersummaryrow")) {
                        var columnIndex = proxy.getCellIndex(e);
                        proxy._cellMouseLeave();

                        currentColumn = columns[columnIndex];
                        if (!e) e = window.event;
                        if (e.originalEvent.pageX || e.originalEvent.pageY) {
                            posx = e.originalEvent.pageX;
                            posy = e.originalEvent.pageY;
                        }
                        else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                            posx = e.originalEvent.clientX + document.body.scrollLeft
                                + document.documentElement.scrollLeft;
                            posy = e.originalEvent.clientY + document.body.scrollTop
                                + document.documentElement.scrollTop;
                        }

                        if (item || row.hasClass("e-footersummaryrow")) {
                            if (columnIndex != model.treeColumnIndex) {
                                var clonedCellElement = column.clone();
                                clonedCellElement.find(".e-chkbox-wrap").remove();
                                textContent = clonedCellElement.children().length ? clonedCellElement.children().clone() : clonedCellElement.clone(); // Copying the DOM element of particular cell.
                            }
                            else {
                                if (column.find(".e-cell").length > 0) {
                                    textContent = column.find(".e-cell").clone();
                                    textContent.find(".e-chkbox-wrap").remove();
                                }
                                else if (column.hasClass("e-summaryrowcell")) {
                                    if (column.find(".e-summarytitle").length > 0) {
                                        textContent = column.find(".e-summarytitle").clone();
                                    } else {
                                        textContent = column.clone();
                                        $(textContent).css({ "cssText": "padding-left: 0px;" });
                                    }
                                }
                            }
                            tooltiptable = ej.buildTag("table.e-tooltiptable", "", { 'padding': '0' }, { 'cellspacing': '1' });

                            if (!model.showGridExpandCellTooltip || (model.showGridExpandCellTooltip && columnIndex == proxy.model.treeColumnIndex)) {
                                tooltipbody = ej.buildTag("tbody", textContent, {}, {});
                            }
                            tooltiptable.append(tooltipbody);

                            var isNonEmptyText = $(textContent).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;

                            if (tooltipbody && $(column).find("#" + proxy._id + "EditForm").length == 0) {
                                if ((!model.cellTooltipTemplate && (ej.isNullOrUndefined(currentColumn['tooltip']) || currentColumn['tooltip'] == "")) || (model.cellTooltipTemplate && !ej.isNullOrUndefined(currentColumn['tooltip']) && currentColumn['tooltip'] == "")) {
                                    if (!(model.showGridExpandCellTooltip) && isNonEmptyText
                                        || (model.showGridExpandCellTooltip && isNonEmptyText)) {
                                        var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5;
                                        proxy._mouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                                            {
                                                "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                                'position': 'absolute',
                                                'z-index': proxy.getMaxZIndex() + 1,
                                                'padding': '0',
                                                'border-radius': '3px'
                                            }, {});
                                        model.cssClass && (proxy._mouseOverTooltip.addClass(model.cssClass));
                                        //Providing a time delay to render the tooltip to improve UI
                                        proxy._tooltipTimer = setTimeout(function () {
                                            $(document.body).append(proxy._mouseOverTooltip);
                                            if (!model.isFromGantt) {
                                                var position = proxy.getOffsetRect(proxy.element[0]);
                                                containerWidth = $(proxy.element).width() + position.left;
                                                containerHeight = $(proxy.element).height() + position.top;
                                            }
                                            else {
                                                var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                                    position = proxy.getOffsetRect(element[0]);
                                                containerWidth = $(element).width() + position.left;
                                                containerHeight = $(element).height() + position.top;
                                            }
                                            tooltipWidth = $(proxy._mouseOverTooltip).width();
                                            tooltipHeight = $(proxy._mouseOverTooltip).height();
                                            // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                            if ((posx + tooltipWidth + 15) >= containerWidth) {
                                                posx = posx - tooltipWidth - 15;
                                            }

                                            if ((posy + tooltipHeight + 10) >= containerHeight) {
                                                posy = posy - tooltipHeight - 10;
                                            }
                                            $(proxy._mouseOverTooltip).css({ "top": posy, "left": posx });
                                        }, 700);
                                    }
                                }
                                else if (model.cellTooltipTemplate || (!ej.isNullOrUndefined(currentColumn['tooltip']) && currentColumn['tooltip'] != "")) {
                            var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5,
                                dataObj = {};
                            dataObj["record"] = item;
                            dataObj["column"] = columns[columnIndex];
                            if (!ej.isNullOrUndefined(currentColumn['tooltip']))
                                proxy._createColumnTooltipTemplate(currentColumn['tooltip']);
                                proxy._mouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                                    {
                                        "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                        'position': 'absolute',
                                        'z-index': proxy.getMaxZIndex() + 1,
                                        'padding': '0',
                                        'border-radius': '3px'
                                    }, {});
                                model.cssClass && (proxy._mouseOverTooltip.addClass(model.cssClass));
                                proxy.tooltipState = "Template";
                                var tooltipbody;
                                if (!ej.isNullOrUndefined(currentColumn['tooltip']))
                                    tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "columnTooltipTemplate"](dataObj), {}, {});
                                    else
                                    tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](dataObj), {}, {});
                                proxy._mouseOverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                                var isNonEmptyText = $(tooltipbody).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;
                                if (isNonEmptyText){
                                proxy._tooltipTimer = setTimeout(function () {
                                    $(document.body).append(proxy._mouseOverTooltip);
                                    if (!model.isFromGantt) {
                                        var position = proxy.getOffsetRect(proxy.element[0]);
                                        containerWidth = $(proxy.element).width() + position.left;
                                        containerHeight = $(proxy.element).height() + position.top;
                                    }
                                    else {
                                        var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                            position = proxy.getOffsetRect(element[0]);
                                        containerWidth = $(element).width() + position.left;
                                        containerHeight = $(element).height() + position.top;
                                    }
                                    tooltipWidth = $(proxy._mouseOverTooltip).width();
                                    tooltipHeight = $(proxy._mouseOverTooltip).height();
                                    // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                    if ((posx + tooltipWidth + 15) >= containerWidth) {
                                        posx = posx - tooltipWidth - 15;
                                    }

                                    if ((posy + tooltipHeight + 10) >= containerHeight) {
                                        posy = posy - tooltipHeight - 10;
                                    }
                                    $(proxy._mouseOverTooltip).css({ "top": posy, "left": posx });
                                }, 700);
                                    }
                            }

                    }
                }
            }
        }

     }
 },
        _cellMouseLeave: function () {

            var proxy = this;
            if (proxy._mouseOverTooltip != null) {
                $("#tooltipgantt").remove();
                window.clearTimeout(proxy._tooltipTimer);
                $(proxy._mouseOverTooltip).remove();
            }
        },

        // Method to clear the header tooltip.
        _headerMouseLeave: function () {
            var proxy = this;
            if (proxy._headerMouseOverTooltip != null) {
                $("#headertooltip").remove();
                window.clearTimeout(proxy._headerTooltipTimer);
                $(proxy._headerMouseOverTooltip).remove();
            }
        },

        disableTooltip: function () {
            this._cellMouseLeave();
        },
       
        _createTooltipTemplate: function () {

            var proxy = this,
                td,
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                template = proxy.model.cellTooltipTemplate,
                parentTr = null,
                helpers = {
                    _getTaskName: proxy._tooltipTaskName
                };               
            $.views.helpers(helpers);
            var templateString = "";
            if (template) {

                if (document.getElementById(template)) {
                    templateString = $("#" + template)[0].innerHTML;
                } else {
                    templateString = template;
                }
                 parentTr = templateString;
                
            }
            else {
                var parentTr = "<tr class='e-tooltip_rowcell'>";

                td = "{{if ~_getTaskName()}}" +
                    "<td class='e-tooltiptaskname' style='height:auto;width:auto;font-weight:normal;'>{{:ttiptaskname}}</td>{{/if}}";

                parentTr += td;
                parentTr += "</tr>";
            }
            var templates = {};
            templates[proxy._id + "tooltipTemplate"] = parentTr;
            $.templates(templates);
        },

        _tooltipTaskName: function () {
            return this.data.ttiptaskname;
        },

        // Method to create cell tooltip template.
        _createColumnTooltipTemplate: function (columnTemplate) {
            var proxy = this, parentTr = null, templateString = "";
            if (columnTemplate) {
                if (document.getElementById(columnTemplate)) {
                    templateString = $("#" + columnTemplate)[0].innerHTML;
                } else if (columnTemplate.slice(0, 1) === "#" && document.getElementById(columnTemplate.slice(1, columnTemplate.length))) {
                    templateString = $(columnTemplate)[0].innerHTML;
                } else {
                    templateString = columnTemplate;
                }
                parentTr = templateString;
            }
            var templates = {};
            templates[proxy._id + "columnTooltipTemplate"] = parentTr;
            $.templates(templates);
        },

        getMaxZIndex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute')
                    return parseInt($(e).css('z-index')) || 1;
            }));
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },

        //SCROLL EVENT FOR VIRTUALIZATION
        _onScroll: function (args) {

            var proxy = this,
                model = this.model,
                hScrollDist, vScrollDist;
            proxy._popupHide();
            proxy._clearContextMenu();                       
            
            $("#" + this._id + "detailscellwrapper").length > 0 && this._removeDetailsRow();

            if (proxy.model.showGridCellTooltip) {
                proxy._cellMouseLeave();
                proxy._headerMouseLeave();
            }

            if (!model.isFromGantt && proxy._dragTooltip && (!proxy._timerDragDown && !proxy._timerDragUp)) {
                args.cancel = true;
                return;
            }

            if (!proxy.isVScroll() && !proxy.model.isFromGantt && args.source === "wheel") {
                args.cancel = true;
                return;
            }                        

            if (args.scrollLeft != undefined) {
                proxy._scrollLeft = args.scrollLeft;
                hScrollDist = Math.abs(proxy._scrollLeft - proxy._prevScrollLeft);
            }

            if (args.scrollTop != undefined) {
                proxy._scrollTop = args.scrollTop; //Maintain the scroll top for dynamic update of virtualization and non-virtualization mode.
                vScrollDist = Math.abs(proxy._scrollTop - proxy._preVScrollTop);
            }            

            if (hScrollDist) {
                proxy._updateHeaderScrollLeft(proxy._scrollLeft);
                proxy._prevScrollLeft = proxy._scrollLeft;
            }
            
            if (args.scrollTop != undefined) {

                /*Cancel if treegrid is in edit*/
                if (proxy.model.isEdit) {
                    proxy.cancelEditCell();
                    proxy._focusTreeGridElement();
                }
                else if (proxy._isRowEdit) {
                    proxy.cancelRowEditCell();
                    proxy._focusTreeGridElement();
                }

                proxy._vScrollDist = Math.abs(proxy._scrollTop - proxy._prevScrollTop);
                proxy._preVScrollTop = proxy._scrollTop;
                //CHECK VIRTUALIZATION IS ENABLED OR NOT
                if (proxy.model.enableVirtualization) {

                    proxy._vScrollDir = proxy._prevScrollTop <= proxy._scrollTop ? 1 : -1;
                    //console.log("VScrollDist:" + proxy._vScrollDist);
               
                    if (proxy._vScrollDist && (proxy._scrollTop != proxy._prevScrollTop)) {
                        proxy._updateCurrentViewData(ej.TreeGrid.Actions.Scroll);
                        proxy._prevScrollTop = proxy._scrollTop;
                    }
                }
                proxy._scrollTop = args.scrollTop;
                if(this._frozenColumnsLength)
                    proxy.getContent().find("#e-frozencontainer" + proxy._id).scrollTop(proxy._scrollTop);
            }
        },

        editFormValidate: function () {
            if ($.isFunction($.validator)) {
                if ($("#" + this._id + "EditForm").length > 0)
                    return $("#" + this._id + "EditForm").validate().form();
                else if($("#" + this._id + "EditFormDialog").length>0)
                    return $("#" + this._id + "EditFormDialog").validate().form();
            }
            return true;
        },
        
        //Save the edited row

        saveRow:function()
        {
            var proxy = this,
           model = proxy.model, form, index, isDialogEdit,editType;

            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                form = $("#" + proxy._id + "EditFormDialog");
                index = proxy._currentEditRecordDialogIndex;
                isDialogEdit = true;
            } else {
                form = $("#" + proxy._id + "EditForm");
                index = this.getIndexByRow(form.closest("tr"));
            }

            var frozenForm = $("#" + proxy._id + "EditFrozenForm"),
                formElement = frozenForm.add(form).find("td"),
                isAddRow = form.closest("tr").hasClass("e-addedrow"),
                columns = model.columns,
                columnLength = columns.length,
                currentItem =model.currentViewData[index],
                currentValue = {},
                previousValue = {},
                column,
                value,
                args = {};

           proxy._focusTreeGridElement();

            if (form.length <= 0 && index == -1)
                return;

            for (var i = 0; i < columnLength; i++) {
                column = columns[i];
                if (!ej.isNullOrUndefined(column) && column["field"] != "") {
                    if (column.visible) {
                        if (ej.isNullOrUndefined(column["editType"])) {
                            editType = "stringedit";
                        } else {
                            editType = column["editType"];
                        }
                        value = proxy.getCurrentEditCellDataForRowEdit(column["field"], editType, i);
                        if (proxy._checkboxSelection && column["field"] == "checkboxState") {                            
                            continue;
                        }
                        //To avoid duplicate ID for TreeGrid on self reference while row editing
                        if (model.idMapping && model.parentIdMapping && column["field"] == model.idMapping) {
                            if (proxy._validateIdValue(value))
                                value = currentItem[column["field"]]; //Replacing the old value
                        }
                        var splits = (column["field"] || "").split(".");
                        if (splits.length <= 1) {                            
                            previousValue[column["field"]] = currentItem.item[column["field"]];
                            currentValue[column["field"]] = currentItem[column["field"]] = currentItem.item[column["field"]] = value;
                        } else {

                        var prevalue = proxy._getCustomCellValue(currentItem.item, column["field"]);
                            previousValue = proxy._restoreCustomData(previousValue, prevalue, column["field"]);
                            currentValue = proxy._restoreCustomData(currentValue, value, column["field"]);
                            currentItem = proxy._restoreCustomData(currentItem, value, column["field"]);
                            currentItem.item = proxy._restoreCustomData(currentItem.item, value, column["field"]);
                        }
                    }
                    else {
                        var prevalue = proxy._getCustomCellValue(currentItem, column["field"]);
                        previousValue = proxy._restoreCustomData(previousValue, prevalue, column["field"]);
                        currentValue = proxy._restoreCustomData(currentValue, prevalue, column["field"]);
                    }
                }
            }

            if (!isAddRow) {
                args.previousValue = previousValue;
                args.requestType = "update";
                if (isDialogEdit) {
                    args.rowIndex = proxy._currentEditRecordDialogIndex;
                    args.element = $("#" + proxy._id + "_dialogEdit");
                }
                else {
                    args.rowIndex = proxy.selectedRowIndex();
                    args.rowElement = form.add(frozenForm).closest("tr");
                }
                args.currentValue = currentItem.item;
                if (isDialogEdit) {
                    if (proxy._trigger("actionBegin", args)) {
                        for (i = 0; i < columnLength; i++) {
                            column = columns[i];
                            if (!ej.isNullOrUndefined(column))
                                if (column.visible) {
                                    var prevalue = proxy._getCustomCellValue(previousValue, column["field"]);
                                    currentItem = proxy._restoreCustomData(currentItem, prevalue, column["field"]);
                                    currentItem.item = proxy._restoreCustomData(currentItem.item, prevalue, column["field"]);
                                }
                        }
                        return true;
                    } else {
                        for (var colIndex = 0 ; colIndex < columns.length ; colIndex++) {
                            if (columns[colIndex]["editType"] == ej.TreeGrid.EditingType.Dropdown || columns[colIndex]["editType"] == ej.TreeGrid.EditingType.DatePicker || columns[colIndex]["editType"] == ej.TreeGrid.EditingType.DateTimePicker) {
                                var $element = $("#" + proxy._id + proxy._getFieldValue(columns[colIndex]["field"]));
                                $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                            }
                        }
                    }
                } else {
                    if (proxy._trigger("endEdit", args)) {
                        for (i = 0; i < columnLength; i++) {
                            column = columns[i];
                            if (!ej.isNullOrUndefined(column))
                                if (column.visible) {
                                    var prevalue = proxy._getCustomCellValue(previousValue, column["field"]);
                                    currentItem = proxy._restoreCustomData(currentItem, prevalue, column["field"]);
                                    currentItem.item = proxy._restoreCustomData(currentItem.item, prevalue, column["field"]);
                                }
                        }
                    }
                }
            }
            else {
                args.rowIndex = proxy.selectedRowIndex();
                args.previousValue = previousValue;
                args.requestType = "addNewRow";
                args.addedRow = proxy._checkIsEmptyRow(currentItem.item) ? null : currentItem.item;
                args.rowElement = form.closest("tr");
                if (proxy._trigger("actionComplete", args)) {
                    for (i = 0; i < columnLength; i++) {
                        column = columns[i];
                        if (!ej.isNullOrUndefined(column))
                            if (column.visible) {
                                var prevalue = proxy._getCustomCellValue(previousValue, column["field"]);
                                currentItem = proxy._restoreCustomData(currentItem, prevalue, column["field"]);
                                currentItem.item = proxy._restoreCustomData(currentItem.item, prevalue, column["field"]);
                            }
                    }
                }
            }

            /* delete the row if new added row is not have any values */
            if (proxy._checkIsEmptyRow(currentItem.item) && isAddRow) {
                var deleteValueUpdated = false;
                proxy._isEmptyRow = true;
                if (!model.editSettings.allowDeleting) {
                    deleteValueUpdated = true;
                    model.editSettings.allowDeleting = true;
                }
				// Only checked records delete by toolbar action, hence passing it as contextMenu deletion
                if (proxy._checkboxSelection)
                    proxy.deleteRow(null, true, null);
                else
                    proxy.deleteRow();
                proxy._isEmptyRow = false;
                proxy._isEmptyRowDeleted = true;
                if (deleteValueUpdated) {
                    model.editSettings.allowDeleting = false;
                }
            } else {
                // Save the edited row           
                ej.TreeGrid.refreshRow(proxy, index);
                if (isAddRow && currentItem.parentItem && currentItem.parentItem.childRecords.length == 1) {
                    ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(currentItem.parentItem));
                }
                if (model.showSummaryRow) {
                    args.editType = "rowedit";
                    if (args.requestType == "addNewRow" && model.editSettings.rowPosition == "child") {
                        proxy._createAndRenderSummaryRecords(args);
                    }
                    proxy._updateSummaryRow(args);
                }
                if (model.showTotalSummary) {
                    args.editType = "rowedit";
                    proxy._updateTotalSummaryRow(args);
                }
                if (isDialogEdit) {
                    //Client side event is triggerd for upadte the server side database
                    var eventArgs = {};
                    eventArgs.data = model.currentViewData[index];
                    eventArgs.item = model.currentViewData[index].item;
                    eventArgs.requestType = "recordUpdate";
                    proxy._trigger("actionComplete", eventArgs);
                }

            }
            proxy._isRowEdit = false;
            if (model.currentViewData.length > 0 && model.enableAltRow && !model.enableVirtualization)
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);
            proxy._cancelSaveTools();
            var colObject = columns.filter(function (column) {
                if (column.filterEditType == "dropdownedit" && column.editType != "dropdownedit")
                    return true;
            });
            if (model.allowFiltering && colObject.length)
                proxy._resizeFilteringElements();

        },
        _excludeDetailRows : function()
        {
            var $gridRows = $(), model = this.model;
            if (this.getTreeGridRows() && this.getTreeGridRows().length > 0) {
                if (model.showDetailsRow && model.detailsTemplate) {
                    if (this._frozenColumnsLength > 0)
                        $gridRows = [$(this.getTreeGridRows()[0]).not(".e-detailsrow"), $(this.getTreeGridRows()[1]).not(".e-detailsrow")];
                    else
                        $gridRows = $(this.getTreeGridRows()).not(".e-detailsrow");
                }
                else {
                    if (this._frozenColumnsLength > 0)
                        $gridRows = [$(this.getTreeGridRows()[0]), $(this.getTreeGridRows()[1])];
                    else
                        $gridRows = $(this.getTreeGridRows());
                }
            }
            return $gridRows;
        },

        getIndexByRow: function ($tr) {
            var $gridRows = this._excludeDetailRows(), rowIndex = -1;
            if (this._frozenColumnsLength > 0) {
                rowIndex = $($gridRows[0]).index($tr);
                if (rowIndex == -1)
                    rowIndex = $($gridRows[1]).index($tr);
                return rowIndex;
            }
            return $gridRows.index($tr);
        },
        /*get all treegrid rows with details rows*/
        getTreeGridRows: function () {
            return this._gridRows;
        },

        _keyDown: function (e) {
            var proxy = this;
            if (e.shiftKey && proxy._shiftKeyFirstElementDetails.firstElementRowIndex == -1) {
                proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
                proxy._shiftKeyFirstElementDetails.firstElementCellIndex = proxy._cellIndex;
            }
        },

        /*focus treegrid element*/
        _focusTreeGridElement: function () {
            if (ej.browserInfo().name == "msie") {
                try { this.element[0].setActive(); } catch (e) { }
            }
            else
                this.element[0].focus();
        },

        _onRecordClick: function (e) {
            var proxy = this,$target = $(e.target), model= proxy.model, column,
            $td = $target.closest("td"), args = {},$tr=$target.closest("tr");
            if (($target.hasClass("e-rowcell") || $target.parent().hasClass("e-rowcell") || ($target.closest("td").hasClass("e-rowcell"))
                || ($target.closest("td").hasClass("e-rowcell")) && $target.hasClass("e-cell")) && $tr.find(".e-editedcell").length == 0 && !$tr.hasClass("e-summaryrow")) {
                args.cell = $td;
                args.cellIndex = proxy.getCellIndex(e);
                args.row = $tr;
                args.rowIndex = proxy.getIndexByRow(args.row);
                args.data = proxy.model.currentViewData[args.rowIndex];
                column = model.columns[args.cellIndex];
                args.columnName = column.headerText;
                args.cellValue = !ej.isNullOrUndefined(args.data) ? args.data[column.field] : "";
                proxy._trigger("recordClick", args);
            }
        },
        //add remove animation class for expand/collpase and header icons
        _addRemoveAnimateClass:function(element)
        {
            var proxy = this;
           this._$gridContentTable && this._$gridContentTable.find(".e-treegrid-animate").removeClass("e-treegrid-animate");
            proxy._$gridHeaderContainer && proxy._$gridHeaderContainer.find(".e-treegrid-animate").removeClass("e-treegrid-animate");
            $(element).addClass("e-treegrid-animate");
        },
        //CLICK HANDLER FOR PERFORM ROWSELECTION AND EXPANDCOLLAPSE THE RECORD
        _onClick: function (e) {

            var proxy = this,
                model = proxy.model,
                $target = $(e.target), currentRowIndex, args = {}, rowIndex = -1, expandRecord, id = $target.closest(".e-treegrid").attr("id"),
                updatedRecords = proxy.getUpdatedRecords();
            /* check inner treegrid click events and  */
            if ($target.closest(".e-treegrid").attr("id") !== this._id) return false;
            proxy._clearContextMenu();
            this._removeDetailsRow(e);            
            if (model.allowDragAndDrop)
                window.clearTimeout(proxy._dragTooltipTimer);
            if (model.allowColumnReordering) {
                window.clearTimeout(this._dragColumnTooltipTimer);
                this._dragColumnTooltipTimer = null;
            }
            proxy._cellIndex = proxy.getCellIndex(e);
            this.getHeaderTable().find(".e-cancel").addClass("e-hide");
            if (model.selectionSettings.selectionMode == "cell" && model.editSettings.editMode != "dialogEditing") {
                model.editSettings.editMode = "cellEditing";
            }
            rowIndex = proxy.getRowIndex(e);
            if ((model.editSettings.beginEditAction == "click" || $target.hasClass('e-treegridexpand')
                || $target.hasClass("e-treegridcollapse")) && $target.closest('.e-scrollbar').length==0 && this.editFormValidate()) {  //                                
                                if(model.editSettings.editMode.toLowerCase() == "cellediting")
                                    proxy._cellEditingDetails.rowIndex = rowIndex;
                                expandRecord = model.currentViewData && model.currentViewData[rowIndex];
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && !proxy.model.isFromGantt && !($target.hasClass("e-downtail"))) {
                if ($target.hasClass("e-rowselect")) {
                    if (!$target.hasClass("e-spanclicked")) {
                        $target.addClass("e-spanclicked");
                    } else {
                        proxy._clearMultiSelectPopup();
                    }
                } else {
                    if (!$("#" + id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                        this._multiSelectPopup.hide();
                    }
                }
            }
            proxy._saveCellHandler(e);
            if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-footersummaryrowcell")
                || $target.hasClass("e-summarytitle"))
                return;
            if (($target.hasClass('e-treegridexpand') || $target.hasClass("e-treegridcollapse")) && rowIndex != -1) {
                var $tr = $target.closest('tr'),
                    recordIndex = updatedRecords.indexOf(expandRecord),
                    args = {},
                    isExpandCollapseEnabeled;
                $target.removeClass("e-treegrid-animate");
                args.data = record;
                args.data = expandRecord;
                args.recordIndex = recordIndex;
                args.expanded = $tr.hasClass("e-treegridrowexpand") ? false : true;
                //Set the focus to the element when row or column not in edit mode.
                if ($("#" + proxy._id + "EditForm").length == 0 && ($target.hasClass("e-rowcell") ||  !$target.closest(".e-rowcell").hasClass("e-templatecell"))) {
                   proxy._focusTreeGridElement();
                } else {
                    proxy._cancelEditState();
                }
                if (args.expanded) {

                    isExpandCollapseEnabeled = proxy._trigger("expanding", args);

                } else {

                    isExpandCollapseEnabeled = proxy._trigger("collapsing", args);
                    
                }

                if (!isExpandCollapseEnabeled&&!model.isFromGantt) {

                    /* refresh Added row on expand collapse */
                    if (proxy._isRefreshAddedRecord) {
                        args.data.expanded = args.expanded;
                        proxy.updateExpandStatus(args.data, args.expanded);
                        proxy.refreshContent();
                        proxy.renderRecords();
                        proxy._isRefreshAddedRecord = false;
                    } else {
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }
                //To set animate class for clicked item
                if (model.allowPaging || model.enableVirtualization) {
                    var newUpdatedRecords = proxy.getUpdatedRecords(),
                        currentRowElement = ej.TreeGrid.getRowByIndex(this,newUpdatedRecords.indexOf(expandRecord));
                    currentRowElement && proxy._addRemoveAnimateClass($(currentRowElement).find(".e-treegridcollapse,.e-treegridexpand"));
                }else
                {
                    proxy._addRemoveAnimateClass($target);
                }
                
            } else if ($target.hasClass("e-rowcell") || $target.parent().hasClass("e-rowcell") || ($target.closest("td").hasClass("e-rowcell")) || $target.parent().hasClass("e-detailsrowcell") || $target.hasClass("e-detailsrowcell")
                || ($target.closest("td").hasClass("e-rowcell")) && $target.hasClass("e-cell")) {

                if ($("#" + id + "_selectionpopup").is(":visible")) {
                    if ($("#" + id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                        e.ctrlKey = true;
                        if (model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row)
                        proxy._multiSelectCtrlRequest = true;
                    }
                    else {
                        e.ctrlKey = false; proxy._multiSelectCtrlRequest = false;
                    }
                }
                //Set the focus to the element when row or column not in edit mode.
                if ($("#" + proxy._id + "EditForm").length == 0 && ($target.hasClass("e-rowcell") || !$target.closest(".e-rowcell").hasClass("e-templatecell"))) {
                    proxy._focusTreeGridElement();
                }
                //Check selction is enabled or not
                
                    currentRowIndex = proxy.getIndexByRow($target.closest('tr'));
                    if (model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row) {

                        if (proxy._checkboxSelection && ($("#" + proxy._id + "EditForm").length == 0 || model.editSettings.beginEditAction == "click") && proxy.editFormValidate()) {
                            var record = proxy.model.currentViewData[currentRowIndex],
                        recordIndex = updatedRecords.indexOf(record), isCheckbox = false;
                            if (currentRowIndex != -1 && !proxy._rowSelectingEventTrigger(this.selectedRowIndex(), currentRowIndex)) {
                                if ($target.hasClass("e-checkbox"))
                                    isCheckbox = true;
                                proxy.selectRows(recordIndex, null, isCheckbox);
                                proxy._cancelSaveTools();
                                proxy._rowSelectedEventTrigger(recordIndex);
                            }
                        }
                if (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Multiple) {

                    if (e.ctrlKey) proxy._multiSelectCtrlRequest = true;

                    if (e.shiftKey) {
                        currentRowIndex = proxy.getIndexByRow($target.closest('tr'));
                                record = model.currentViewData[currentRowIndex];
                                currentRowIndex = updatedRecords.indexOf(record);
                        proxy._multiSelectShiftRequest = true;
                        if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), currentRowIndex)) {
                                    if (proxy.getRows() && proxy._prevSelectedItem != null) {
                                        if (proxy.getExpandStatus(proxy._prevSelectedItem))
                                            proxy.selectRows(updatedRecords.indexOf(proxy._prevSelectedItem), currentRowIndex);
                                        else
                                            proxy.selectRows(currentRowIndex);
                            }
                                    else if (proxy.getRows() && proxy._prevSelectedItem == null) {
                                        proxy.selectRows(0, currentRowIndex);
                            }
                            proxy._cancelSaveTools();
                            proxy._rowSelectedEventTrigger(currentRowIndex);
                        }
                    }
                }
                if (!proxy._checkboxSelection &&!proxy._multiSelectShiftRequest && $("#" + proxy._id + "EditForm").length == 0 ) {

                    //recordIndex = proxy.getIndexByRow($target.closest('tr'));

                    if (rowIndex != -1) {

                        record = model.currentViewData[rowIndex];
                        currentRowIndex = updatedRecords.indexOf(record);
                       
                        if (model.allowSelection &&!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), currentRowIndex)){
                            proxy.selectRows(currentRowIndex);                        
                            proxy._cancelSaveTools();
                            proxy._rowSelectedEventTrigger(currentRowIndex);  
                        }                      
                    }
                }
                proxy._multiSelectShiftRequest = false;
                    }
                    if (model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Cell && $("#" + proxy._id + "EditForm").length == 0 && proxy._cellIndex != -1 &&
                        currentRowIndex != -1 && model.allowSelection) {
                        var frozenColumnRowIndex = proxy._cellIndex >= proxy._frozenColumnsLength ? 1 : 0,
                            targetRow;
                        if (proxy._frozenColumnsLength > 0) {
                            targetRow = proxy.getRows()[frozenColumnRowIndex][currentRowIndex];
                        }
                        else
                            targetRow = proxy.getRows()[currentRowIndex];
                        var columns = model.columns,
                            record = model.currentViewData && model.currentViewData[currentRowIndex],
                            targetIndex = updatedRecords.indexOf(record),
                            targetCellIndex = proxy._cellIndex >= proxy._frozenColumnsLength ? proxy._cellIndex - proxy._frozenColumnsLength : proxy._cellIndex,
                            target = targetRow.childNodes[targetCellIndex],
                            previousRowIndex = proxy._previousSelectedCellDetails.rowIndex,
                            previousCellIndex = proxy._previousSelectedCellDetails.cellIndex,
                            targetCell = $(target).closest("td"),
                            currentCellIndex;
                        proxy._focusingRowIndex = targetIndex;

                        if (currentRowIndex != -1) {

                            if (record.isSummaryRow)
                                return;
                            var args = {
                                rowIndex: targetIndex,
                                cellIndex: proxy._cellIndex,
                                rowElement: targetRow,
                                cellElement: targetCell[0]
                            };
                            
                            var selectedCellInfo = {
                                rowIndex: targetIndex,
                                cellIndex: proxy._cellIndex,
                                cellElement: targetCell[0],                                
                                data: record
                            };

                            if (!proxy._cellSelectingEventTrigger(args) && columns[targetCellIndex].allowCellSelection) {
                                if (model.selectionSettings.selectionType == "multiple" && (e.ctrlKey || e.shiftKey)) {
                                    //Select Multiple cells dynamically using Ctrl Key + mouse click.
                                    if (e.ctrlKey) {
                                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                                            currentCellIndex = proxy._getCellIndex(proxy._selectedCellDetails, "cellElement").indexOf(targetCell[0]);
                                        else
                                            currentCellIndex = proxy._selectedCellDetails.map(function (e) { return e.cellElement; }).indexOf(targetCell[0]);


                                        if (currentCellIndex == -1) {
                                            $(targetCell[0]).addClass("selectingcell");
                                                proxy._selectedCellDetails.push(selectedCellInfo);                                            
                                            model.selectedCellIndexes.push({ rowIndex: selectedCellInfo.rowIndex, cellIndex: selectedCellInfo.cellIndex });
                                                proxy._cellSelectedEventTrigger(args, proxy._previousSelectedCellDetails);
                                        }
                                        else {
                                            $(targetCell[0]).removeClass("selectingcell");
                                            proxy._selectedCellDetails.splice(currentCellIndex, 1);
                                            model.selectedCellIndexes.splice(currentCellIndex, 1);
                                        }                                       
                                    }
                                        //Select multiple cells using Shift Key + mouse Click.
                                    else if (e.shiftKey) {
                                        var args = {
                                            rowIndex: targetIndex,
                                            cellIndex: proxy._cellIndex,
                                        };
                                        proxy._shiftKeySelectCells(args);
                                        proxy._rowIndexOfLastSelectedCell = targetIndex;
                                        proxy._focusingRowIndex = proxy._shiftKeyFirstElementDetails.firstElementRowIndex;                                     
                                    }
                                }
                                    //Select single cell using mouse click.
                                else  {
                                    proxy._selectedCellDetails = [];
                                    model.selectedCellIndexes = [];
                                    $("#" + proxy._id).find(".selectingcell").removeClass("selectingcell");
                                    $(targetCell[0]).addClass("selectingcell");
                                    proxy._selectedCellDetails.push(selectedCellInfo);
                                    model.selectedCellIndexes.push({ rowIndex: selectedCellInfo.rowIndex, cellIndex: selectedCellInfo.cellIndex });                                   
                                    proxy._cellSelectedEventTrigger(args, proxy._previousSelectedCellDetails);
                                    //Clear the Details of shiftKeyFirstElement.
                                    proxy._shiftKeyFirstElementDetails = {
                                        firstElementRowIndex: -1,
                                        firstElementCellIndex: -1
                                    }
                                    proxy._updateSecondRowIndexBy = 1;
                                }
                                if (!e.shiftKey) {
                                    proxy._previousSelectedCellDetails = {
                                        rowElement: targetRow,
                                        cellElement: targetCell[0],
                                        cellIndex: args.cellIndex,
                                        rowIndex: targetIndex,
                                    };
                                    proxy._rowIndexOfLastSelectedCell = proxy._focusingRowIndex;
                                    proxy._isShiftKeyNavigation = false;
                                }
                            }
                            proxy._cancelSaveTools();
                            //Get back default values to perform keypressed event.                            
                            proxy._lastSelectedCellIndex = proxy._cellIndex;
                        }
                    }
                
                    if (proxy._isTouchTrigger && proxy.model.allowSelection && this.model.selectionSettings.selectionType == "multiple" && !proxy.model.isFromGantt) {
                        if (proxy._isTouchTrigger && this._multiSelectPopup != null && !this._multiSelectPopup.is(":visible") && this._multiSelectPopup.find(".e-rowselect").hasClass("e-spanclicked"))
                            this._multiSelectPopup.show();
                        if (proxy._isTouchTrigger && this._multiSelectPopup != null && !this._multiSelectPopup.find(".e-rowselect").hasClass("e-spanclicked")) {
                            if (!$target.hasClass("e-detailsrowcell") && !$target.parent("td").hasClass("e-detailsrowcell") && !$target.closest("tr").hasClass('e-detailsrow')) {
                                this._multiSelectPopup.removeAttr("style");
                                var offset = $target.closest(".e-rowcell").offset();
                                this._multiSelectPopup.offset({ top: 0, left: 0 }).offset({ left: (offset.left + (($target.closest(".e-rowcell").outerWidth() / 2) - (this._multiSelectPopup.width() / 2))), top: (offset.top - this._multiSelectPopup.outerHeight() - 10) }).show();
                            }
                        }
                        proxy._isTouchTrigger = false;
                    }
            }

            /* detail row show and hide */
            if (($target.hasClass("e-detailsrowcell") || $target.parent("td").hasClass("e-detailsrowcell")) && !$target.closest("tr").hasClass('e-detailsrow')) {
                if (!e.ctrlKey && !e.shiftKey) {
                    var editState=$("#" + this._id + "EditForm").length>0 ? this.editFormValidate()?true:false:true;                  
                    if (proxy._isRowEdit) {
                        this.saveRow();
                    } else if (editState)
                    {
                        proxy._detailsExpandCollapse($target);
                    }
                }
            }

            if (proxy._isRowEdit)
                $target.focus();
            if (!$target.closest("#" + proxy._id + "_ColumnMenu").hasClass("e-columnmenu"))
            {
                proxy._clearColumnMenu();
            }
            if (model.editSettings.beginEditAction == "click" && $target.closest("#" + proxy._id + "EditForm").length == 0 &&
                !proxy._isShiftKeyNavigation && !proxy._isEmptyRowDeleted)
                proxy._editdblClickHandler(e);
            proxy._isEmptyRowDeleted = false;
        },
		// Method to check/uncheck all the records
        selectAllRows: function (checkAll) {
            var proxy = this, model = proxy.model, index = -1,
                data = (proxy._flatFilteredRecords.length > 0) ? proxy._flatFilteredRecords : model.flatRecords,
                updatedRecords = proxy.getUpdatedRecords(),
                length = 0;
            if (!model.selectionSettings.enableSelectAll && !proxy._isFromSetmodel)
                return;

            if (model.showSummaryRow)
                data = proxy._spliceSummaryRows(data);
            if (!ej.isNullOrUndefined(checkAll)) {                
                if (!checkAll)
                    data = proxy._flatFilteredRecords.length > 0 ? proxy._flatFilteredRecords : $.extend([], model.selectedItems);

                for (var i = 0; i < data.length; i++) {
                    if (checkAll) {
                        if (data[i].checkboxState == "checked") continue;
                        data[i].checkboxState = "checked";
                        model.selectedItems.push(data[i]);
                        $('#' + this._id + "_checkbox" + data[i].ejRowId).removeClass("e-stop").addClass("e-checkmark");
                        $('#' + this._id + "_checkbox" + data[i].ejRowId).parent("span").removeAttr("class").addClass("e-chk-act");
                    }
                    else {                                             
                        index = model.selectedItems.indexOf(data[i]);
                        if (index > -1) {
                            data[i].checkboxState = "unchecked";
                            model.selectedItems.splice(index, 1);
                            $('#' + this._id + "_checkbox" + data[i].ejRowId).removeClass("e-checkmark");
                            $('#' + this._id + "_checkbox" + data[i].ejRowId).parent("span").removeAttr("class").addClass("e-chk-inact");
                            if (model.selectionSettings.enableHierarchySelection || proxy._isFromSetmodel)
                                proxy._updateParentSelection(data[i]);
                        }
                    }
                }                
                proxy._cancelSaveTools();
            }
            if (proxy._flatFilteredRecords.length > 0 && model.selectedItems.length > 0) {
                var selectedFilteredRecords = proxy._flatFilteredRecords.filter(function (data) {
                    return data.checkboxState == "checked";
                });
                length = selectedFilteredRecords.length;
            }
            else
                length = model.selectedItems.length;
            if (length > 0) {
                if (length != data.length) {
                    $('#' + this._id + "_headerCheckbox").removeClass("e-checkmark").addClass("e-stop");
                    $('#' + this._id + "_headerCheckbox").parent("span").removeAttr("class").addClass("e-chk-indeter");
                }
                else {
                    $('#' + this._id + "_headerCheckbox").removeClass("e-stop").addClass("e-checkmark");
                    $('#' + this._id + "_headerCheckbox").parent("span").removeAttr("class").addClass("e-chk-act");
                }
            }
            else {
                $('#' + this._id + "_headerCheckbox").removeClass("e-stop e-checkmark");
                $('#' + this._id + "_headerCheckbox").parent("span").removeAttr("class").addClass("e-chk-inact");
            }
        },

        //Add/Remove records in selectedItems collection
        _updateSelectedItems: function (currentRecord, checkboxState) {
            var proxy = this, model = proxy.model, length = 0,
                selectedRowIndex = -1, recordIndex = -1,
                updatedRecords = proxy.getUpdatedRecords();
            recordIndex = updatedRecords.indexOf(currentRecord);
            currentRecord.checkboxState = checkboxState;
            selectedRowIndex = $.inArray(currentRecord, model.selectedItems);
            if (currentRecord.checkboxState == "unchecked") {
                selectedRowIndex != -1 && model.selectedItems.splice(selectedRowIndex, 1);
                if (recordIndex > -1) {
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).removeClass("e-checkmark e-stop");
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).parent("span").removeAttr("class").addClass("e-chk-inact");
                }
            }
            else if (currentRecord.checkboxState == "checked") {
                selectedRowIndex == -1 && model.selectedItems.push(currentRecord);
                if (recordIndex > -1) {
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).removeClass("e-stop").addClass("e-checkmark");
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).parent("span").removeAttr("class").addClass("e-chk-act");
                }
            }            
        },
        // Check/Uncheck parents & Children records Hierarchy selection
        _traverseSelection: function (record, checkboxState, ischildItem) {
            var proxy = this, length = 0, childRecords, updateParent = false, model = this.model;

                proxy._updateSelectedItems(record, checkboxState);                            

            if (!ischildItem && record.parentItem && model.selectionSettings.enableHierarchySelection) 
                proxy._updateParentSelection(record.parentItem);

            if (record.hasChildRecords && model.selectionSettings.enableHierarchySelection) {
                childRecords = record.childRecords;
                if (proxy._flatFilteredRecords.length > 0) {
                    var filteredChildRecords = childRecords.filter(function (record) {
                        return proxy._flatFilteredRecords.indexOf(record) > -1;
                    });
                    childRecords = filteredChildRecords;
                }
                length = childRecords.length;
                for (var count = 0; count < length; count++) {
                    if (childRecords[count].hasChildRecords)
                        proxy._traverseSelection(childRecords[count], checkboxState, true);
                    else if (!childRecords[count]['isSummaryRow']) {                        
                        proxy._updateSelectedItems(childRecords[count], checkboxState);
                    }
                }
            }
        },

        // Update parent checkbox state by its children checkbox state
        _updateParentSelection: function (parentRecord) {

            var proxy = this, model = proxy.model, length = 0, isChanged = false,
            childRecords = [];
            if (parentRecord && parentRecord.childRecords)
                childRecords = proxy._spliceSummaryRows(parentRecord.childRecords);
            if (proxy._flatFilteredRecords.length > 0 && model.selectionSettings.enableHierarchySelection) {
                var filteredChildRecords = childRecords.filter(function (record) {
                    return proxy._flatFilteredRecords.indexOf(record) > -1;
                });
                childRecords = filteredChildRecords;
            }
            length = childRecords && childRecords.length;
            var callMe = false;

            var indeter = childRecords.filter(function (record) {
                return record.checkboxState == "indeterminate";
            });
            var checkChildRecords = childRecords.filter(function (record) {
                return record.checkboxState == "checked";
            });

            if (indeter.length > 0 || (checkChildRecords.length > 0 && checkChildRecords.length != length)) {
                if (parentRecord.checkboxState == "checked") {
                    this._updateSelectedItems(parentRecord, "unchecked");
                    callMe = true;
                }
                else if (parentRecord.checkboxState == "unchecked") callMe = true;

                if (callMe) {
                    $('#' + this._id + "_checkbox" + parentRecord.ejRowId).addClass("e-stop");
                    $('#' + this._id + "_checkbox" + parentRecord.ejRowId).parent("span").removeAttr("class").addClass("e-chk-indeter");
                    parentRecord.checkboxState = "indeterminate";
                    if (parentRecord.parentItem) this._updateParentSelection(parentRecord.parentItem);
                }
            }
            else if (checkChildRecords.length == 0 && indeter.length == 0) {

                $('#' + this._id + "_checkbox" + parentRecord.ejRowId).removeClass("e-stop e-checkmark").parent("span").removeClass("e-chk-indeter");
                if (parentRecord.checkboxState == "checked")
                    this._updateSelectedItems(parentRecord, "unchecked");                
                else
                    parentRecord.checkboxState = "unchecked";
                parentRecord.parentItem && this._updateParentSelection(parentRecord.parentItem);
            }
            else {
                parentRecord.checkboxState = "checked";
                this._updateSelectedItems(parentRecord, "checked");
                if (parentRecord.parentItem) this._updateParentSelection(parentRecord.parentItem);
            }
        },

         /* remove child detail row wraper when detail row contains another treegrid*/
        _removeInnerDetailRows: function ($target, eventCheck)
        {
            /* check if target is in any of detail rows */
            var detailRows = $(".e-detailscellwrapperfly"),
                detailRowsLength = detailRows.length, count = 0, containsFlag = false;

            for (count; count < detailRowsLength; count++) {
                if ($.contains(detailRows[count], $target[0]) || $target == detailRows[count]) {
                    containsFlag = true;
                    break;
                }
            }

            var countFlag = false;
            if (ej.isNullOrUndefined(detailRows[count])) {
                count = detailRows.index($("#" + this._id + "detailscellwrapper"));
                countFlag = true;
            }
            var countFlagString = countFlag ? "" : ",";
            var parentTreeGridId = $(detailRows[count]).attr("parentTreeGridIds");
            var parentDetailWrapperElement = $("[parentTreeGridIds$='" + countFlagString + parentTreeGridId + "']"),
                length = parentDetailWrapperElement.length, i = 0;
            this._triggerDetailRowHideEvent(parentDetailWrapperElement, eventCheck);
        },

        /* trigger detail row collaspse event */
        _triggerDetailRowHideEvent: function (elements, eventCheck)
        {
            var proxy = this,
                model = this.model;
            var length = elements.length, i = 0;

            if (length > 0 && $("#" + this._id + "detailscellwrapper").length > 0)
            {
                var detailElement = $("#" + this._id + "detailscellwrapper"),
                    selectedItem = model.selectedItem;
                var detailsCollapseEventArgs = {};
                detailsCollapseEventArgs.rowData = selectedItem;

                if (!this._trigger("detailsHidden", detailsCollapseEventArgs) || eventCheck) {
                    for (i; i < length; i++) {
                        var treeGridContainerId = $(elements[i]).attr('id').replace("detailscellwrapper", "");
                       
                            $("#" + treeGridContainerId).find(".e-detailsrowexpand").removeClass("e-detailsrowexpand").addClass("e-detailsrowcollapse");
                            $("#" + treeGridContainerId).find(".e-detailsinfoiconhide").removeClass("e-detailsinfoiconhide").addClass("e-detailsinfoiconshow");
                        
                            $(elements[i]).remove();
                    }
                }
            }
        },
        /* remove all child detail row */
        _removeDetailsRow: function (e, eventCheck)
        {
            var model= this.model;
            
                if (e) {
                    var target = $(e.target);
                    var detailCellElement = target;
                    if (target.parent("td").hasClass("e-detailsrowcell"))
                        detailCellElement = target.parent("td");

                    if (target.closest(".e-popup").length == 0 && target[0] != $('html').get(0)) {

                        /* check if target is in any of detail rows */
                        var detailRows = $(".e-detailscellwrapperfly"),
                            detailRowsLength = detailRows.length, count = 0, containsFlag = false;

                        for (count; count < detailRowsLength; count++) {
                            if ($.contains(detailRows[count], target[0]) || target[0] == detailRows[count]) {
                                containsFlag = true;
                                break;
                            }
                        }

                        if (!target.hasClass("e-detailscellwrapperfly") && !detailCellElement.hasClass("e-detailsrowexpand") && !detailCellElement.hasClass("e-detailsrowcollapse")
                            && !containsFlag) {
                            this._removeInnerDetailRows($("#" + this._id + "detailscellwrapper"), eventCheck);
                        }

                        if (target.hasClass("e-detailscellwrapperfly") || detailCellElement.hasClass("e-detailsrowcollapse") || (!detailCellElement.hasClass("e-detailsrowexpand") && containsFlag)) {
                            var countFlag = false;
                            if (ej.isNullOrUndefined(detailRows[count])) {
                                count = detailRows.index($("#" + this._id + "detailscellwrapper"));
                                countFlag = true;
                            }
                            var countFlagString = countFlag ? "" : ",";
                            var parentTreeGridId = $(detailRows[count]).attr("parentTreeGridIds");
                            var parentDetailWrapperElement = $("[parentTreeGridIds$='" + countFlagString + parentTreeGridId + "']");
                            this._triggerDetailRowHideEvent(parentDetailWrapperElement, eventCheck);
                        }
                    }
                } else {
                    $("#" + this._id + "detailscellwrapper").length > 0 && this._removeInnerDetailRows($("#" + this._id + "detailscellwrapper")[0], eventCheck);
                    this._triggerDetailRowHideEvent($("#" + this._id + "detailscellwrapper"), eventCheck);
                }
            
        },

        /* show hide detail rows public method*/
        
        showHideDetailsRow:function(rowIndex)
        {
            var proxy = this, model = this.model;
            /* save if tree grid is in edit state */
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn && !ej.isNullOrUndefined(rowIndex)
                 && rowIndex <= model.updatedRecords.length && proxy.getExpandStatus(model.updatedRecords[rowIndex])) {
                if (rowIndex != this.selectedRowIndex()) {
                    if (rowIndex != -1 && $.inArray(rowIndex, proxy._selectedRowsIndexes == -1) && model.allowSelection && model.updatedRecords.length > rowIndex) {
                        if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex)) {
                            proxy.selectRows(rowIndex);
                            proxy._rowSelectedEventTrigger(rowIndex);
                        }
                    }
                }

                this.updateScrollBar(rowIndex);
                var targetRowElement = $(ej.TreeGrid.getRowByIndex(proxy, rowIndex)), targetCellElement;
                if (targetRowElement.length > 0 && model.updatedRecords[rowIndex] && proxy.getExpandStatus(model.updatedRecords[rowIndex]))
                {
                    targetCellElement = $(targetRowElement).find(".e-detailsrowcell");
                    if ($(targetCellElement).length > 0 && $(targetCellElement).hasClass("e-detailsrowcell"))
                    {
                        if (this.element.find(".e-detailsrowexpand")[0] != targetCellElement[0])
                            this._removeDetailsRow();

                        this._detailsExpandCollapse($(targetCellElement));
                    }
                }
            }
        },
        /* expand collapse the detail row */
        _detailsExpandCollapse:function($target)
        {
            var proxy = this,
                model = this.model;
            
            if ($target.parent("td").hasClass("e-detailsrowcell"))
                $target = $target.parent("td");
            var rowElement = $target.closest('tr'),
                detailsIconElement = rowElement.find(".e-detailsrowcell");

            if (detailsIconElement.hasClass("e-detailsrowcollapse")) {

                var rowIndexValue = this.getIndexByRow(rowElement),
                   rowData = this.model.currentViewData[rowIndexValue];
                if (ej.isNullOrUndefined(rowData) || rowData.isSummaryRow)
                    return;
                var rowBottom = this.getOffsetRect(rowElement[0]),
                   detailtr = $($.render[proxy._id + "_detailRowTemplate"](rowData)),
                   detailsCellElement = $(detailtr).find(".e-detailscellwrapper").attr({ "id": this._id + "detailscellwrapper" }),
                   width = proxy._gridWidth - (proxy.element.find(".e-scrollcss").length > 0 ? 18 : 0) - 2;//2 - treegrid border

                /* add treegrid attribute for detail row wraaper element */
                var rowWrapperElement = this.element.parents().filter(".e-detailscellwrapperfly"),
                    wrapperElementID = this._id, tempTreeGridId = "";
                while (rowWrapperElement.length > 0) {
                    tempTreeGridId = rowWrapperElement.attr("id").replace("detailscellwrapper", "");
                    wrapperElementID += "," + tempTreeGridId;
                    rowWrapperElement = $("#" + tempTreeGridId).parents().filter(".e-detailscellwrapperfly");
                }

                detailsCellElement.attr("parentTreeGridIds", wrapperElementID);
                
                //Edge detection for detail rows
                var treeGridContentOffset = this.getOffsetRect(proxy._$gridContent[0]), topPosition, bottomPosition;
                treeGridContentOffset.bottom = treeGridContentOffset.top + proxy._$gridContent[0].offsetHeight;
                topPosition = rowBottom.top + rowElement[0].offsetHeight;
                bottomPosition = topPosition + model.detailsRowHeight;
                if (topPosition > treeGridContentOffset.bottom || bottomPosition > treeGridContentOffset.bottom)
                {
                    var tempTopPosition = rowBottom.top - model.detailsRowHeight;
                    if (tempTopPosition > treeGridContentOffset.top)
                        topPosition = tempTopPosition;
                }

                detailsCellElement.removeClass("e-detailscellwrapper").addClass("e-detailscellwrapperfly");
                model.cssClass && detailsCellElement.addClass(model.cssClass);
                var scrollerLeft = proxy.getScrollElement().ejScroller("isHScroll") ? proxy.getScrollElement().ejScroller("option", "scrollLeft") : 0;
                var frozenTableWidth = 0;
                if (this._frozenColumnsLength > 0) {
                    frozenTableWidth = $(this.element).find("#e-frozencontentdiv" + this._id).width();
                }
                detailsCellElement.css({
                    "top": topPosition, "left": rowBottom.left + scrollerLeft - frozenTableWidth,
                    "z-index": proxy.getMaxZIndex() + 1, position: "absolute", width: width
                }).appendTo(this.element);
                this._trigger("refresh");
                var eventArgs = {};
                eventArgs.detailsElement = detailsCellElement;
                eventArgs.data = rowData;
                eventArgs.rowIndex = this.selectedRowIndex();
                this._trigger("detailsDataBound", eventArgs);

                /* details show/expand event trigger*/
                var expandEventArgs = {};
                expandEventArgs.detailsElement = detailsCellElement;
                expandEventArgs.data = rowData;
                expandEventArgs.rowIndex = this.selectedRowIndex();
                expandEventArgs.appendTarget = null;
                if (this._trigger("detailsShown", expandEventArgs)) {
                    this._removeInnerDetailRows($target);
                }else
                {
                    detailsIconElement.find(".e-detailsinfoiconshow").removeClass("e-detailsinfoiconshow").addClass("e-detailsinfoiconhide");
                    detailsIconElement.removeClass("e-detailsrowcollapse").addClass("e-detailsrowexpand");
                    if (expandEventArgs.appendTarget)
                    {
                        $(detailsCellElement).css({ "top": "auto", left: "auto", position: "auto" });
                        $(detailsCellElement).detach().appendTo($("#" + expandEventArgs.appendTarget));
                    }

                }
            }else
            {
                this._removeInnerDetailRows($target);
            }
        },

        //CLICK HANDLER FOR PERFORM THE SORTING ACTION
        _onHeaderClick: function (e) {

            var proxy = this,
                model = proxy.model;
            proxy._cellMouseLeave();
            proxy._headerMouseLeave();
            proxy._clearContextMenu();
            this._removeDetailsRow();
            if ($(e.target).is(".e-ascending, .e-descending")) e.target = e.target.parentNode;

            var $target = $(e.target),
                columnFieldName,
                columnSortDirection,
                column, canSort = true;

            proxy.getHeaderTable().find(".e-columnheader").find(".e-headercellactive").removeClass("e-headercellactive");

            if (proxy._mouseDragged && model.allowColumnReordering) canSort = false;

            if (proxy._checkboxSelection && model.allowSelection && model.selectionSettings.enableSelectAll && $target.hasClass("e-headerCheckbox")) {
                proxy.selectAllRows(!$target.hasClass("e-checkmark") && !$target.hasClass("e-stop"));
                canSort = false;
            }

            if ($target.closest(".e-headercelldiv") && !$target.hasClass("e-columnmenu-icon") && !$target.hasClass("e-column-filter-icon") && !$target.hasClass("e-column-filtered-icon")) {
                columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("ej-mappingname");
                if (!canSort || (ej.isNullOrUndefined(columnFieldName) && ej.isNullOrUndefined(this.getColumnByField(columnFieldName)) || this.getColumnByField(columnFieldName).allowSorting == false)) {
                    if ((model.isEdit || this._isRowEdit) && this.editFormValidate()) {
                        if (model.isEdit)
                            this.saveCell();
                        else if (this._isRowEdit)
                            this.saveRow();
                    }
                    if (!$target.hasClass("e-checkbox"))
                    return false;
                }                                    
                else if (canSort && model.allowSorting) {
                    column = this.getColumnByField(columnFieldName);
                    if ($target.closest(".e-headercell").find('span').hasClass("e-ascending")) {
                        columnSortDirection = ej.sortOrder.Descending;
                    } else {
                        columnSortDirection = ej.sortOrder.Ascending;
                    }

                    if (model.allowMultiSorting && e.ctrlKey) {
                        proxy._multiSortRequest = true;
                    }
                    proxy._isRefreshAddedRecord = false;
                    if(model.isFromGantt)
                        proxy.sortColumn(column.mappingName, columnSortDirection);
                    else
                        proxy.sortColumn(column.field, columnSortDirection);
                    if (proxy.model.isFromGantt && this.selectedRowIndex() >= 0) {
                        var args = {};
                        args.data = proxy.model.selectedItem;
                        args.target = "ejTreeGrid";
                        args.recordIndex = this.selectedRowIndex();
                        proxy._trigger("rowSelected", args);
                    }
                }
            }            
                                            

            // Show the column menu / filter menu while clicking the column menu icon / filter menu icon

            if ($target.hasClass("e-column-filter-icon") || $target.hasClass("e-column-filtered-icon"))
            {
                
                if (!$target.data("isClicked")) {
                    proxy._updateFilterMenuList(e);
                    $(".e-filtericon").data("isClicked", false);
                    $target.data("isClicked", true);
                }
                else {
                    proxy._clearColumnMenu();
                    $target.data("isClicked", false);
                }
                this._addRemoveAnimateClass($target);
            }
            else if ($target.hasClass("e-columnmenu-icon")) {
                if (!$target.data("isClicked")) {
                    proxy._renderColumnMenu(e);
                    $(".e-columnicon").data("isClicked", false);
                    $target.data("isClicked", true);
                }
                else{
                    proxy._clearColumnMenu();
                    $target.data("isClicked", false);
                }
                this._addRemoveAnimateClass($target);
            }
            else
                proxy._clearColumnMenu();
            if ($target.hasClass("e-checkbox"))
                return true;
            else
                return false;
        },

        // Method to trigger the column resizing events.
        _triggerColumnResize: function (event, _x, e) {
            var proxy = this, model=proxy.model;
            var _rowobj = proxy.getHeaderTable().find(".e-columnheader");
            var _childTH = _rowobj.find(".e-headercell");
            var cellIndex = proxy._cellIndex, newWidth;
            var target = $(proxy._target), columnIndex = [], col = [];
            if (event == "columnResizeStart") {
                proxy._orgX = _x;
                cellIndex = proxy._currentCell = proxy._cellIndex= proxy.getCellIndex(e);
            }
            if (proxy._currentCell !=-1) {
                var _outerCell = _childTH[proxy._currentCell];
                var _oldWidth = _outerCell.offsetWidth;
                // condition for column resize start event
                if (event == "columnResizeStart") {
                    var args = {};
                    args = { columnIndex: cellIndex, column: proxy.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth };
                    return proxy._trigger("columnResizeStart", args);
                }
                    //condition for column resize end event
                else if (event == "columnResizeEnd") {
                    var _childth = _rowobj.find(".e-headercell").not(".e-detailheadercell").filter(":visible");
                    //to calculate old, new and extra width values for event argument
                    var _extra = _x - proxy._orgX;
                    proxy._newWidth = _oldWidth + _extra;
                    proxy.__oldWidth = _oldWidth;
                    var args = {};
                    args = { columnIndex: cellIndex, column: model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth, newWidth: proxy._newWidth, extra: _extra };
                    return proxy._trigger("columnResizeEnd", args);
                }
                    //condition for column resized event
                else {
                    if (this.model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !this.model.isFromGantt) {
                        this._updateTableWidth();
                    } else if (!this.model.isFromGantt && this.model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.NextColumn && this.model.showTotalSummary) {
                        this._colgroupRefresh();
                    }
                    var args = {};
                    //to calculate old, new and extra width values for event argument
                    var _extra = _x - proxy._orgX;
                    newWidth = _oldWidth + _extra;
                    args = { columnIndex: cellIndex, column: model.columns[cellIndex], oldWidth: proxy.__oldWidth, newWidth: proxy._newWidth };
                    return proxy._trigger("columnResized", args);
                }
            }
        },

        //HEADER MOUSE DOWN EVENT FOR COLUMN RESIZING
        _headerMouseDown: function (e) {

            var proxy = this,
                coord = proxy._getCoordinate(e),                
            $target, $div, model = proxy.model;            
            proxy._cellMouseLeave();            
            proxy._headerMouseLeave();
            if (e.type == "touchstart") {
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                proxy._on(proxy.element, "touchmove", proxy._mouseMove);
            } else
                $target = $(e.target);

            proxy._on($(document), "mouseup touchend", proxy._headerMouseUp);
            proxy._on(proxy.element, "contextmenu", this._preventContextMenu);

            if (model.allowColumnReordering) {
                if ($target.closest(".e-columnheader").length > 0)
                    proxy.dragColumn(e);
                if (e.type == "touchstart") {
                    proxy._dragColumnTooltipTimer = window.setTimeout(function () {
                        proxy._touchstart = false;
                        if (!proxy._dragTooltip && e.type == "touchstart") {
                            proxy.dragColumnToolTip(e);
                            if (proxy._dragTooltip) {
                                proxy._on(proxy.element, "touchmove", proxy.dragColumnToolTip);
                            }
                        }
                    }, 550);
                }
            }
            if (proxy.model.allowColumnResize) {
                if(model.isFromGantt)
                    proxy._on(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);                
                else
                    proxy._on(proxy.element, "mouseup touchend", proxy._mouseUp);

                $div = $target.closest('tr');
            
                this._target = $target;
                var _x = coord.pageX, _y = coord.pageY,
                    isFrozenColumn;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = coord.pageX;
                    _y = coord.pageY - document.body.scrollTop;
                }
                if ($div.length > 0 && $div[0].style.cursor == "col-resize" && !$target.hasClass("e-columnicon")) {
                    if ($target.is(".e-headercelldiv"))
                        $target = $($target[0].parentNode);
                    this._target = $target;

                    if (proxy._frozenColumnsLength > 0) {
                        var columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("ej-mappingname"),
                         column = proxy.getColumnByField(columnFieldName);
                        isFrozenColumn = proxy._frozenColumns.indexOf(column) > -1 ? true : false;
                    }
                    // Event triggered when we start to resize the column
                    if (isFrozenColumn || this._triggerColumnResize("columnResizeStart", _x, e))
                        return;
                }
                proxy._resizer._mouseDown(e);
            }

            if (($(e.target).hasClass("headercelldiv") && $(e.target).hasClass("headercell"))) {

                var $headercell = $(e.target).hasClass("headercelldiv") ? $(e.target).parent() : $(e.target);
                model.headerEffects && $headercell.addClass("headercellactive");

            }
        },

        _headerMouseUp: function(e){
            var proxy = this, model = proxy.model,
                args = {}, coord = proxy._getCoordinate(e),
                $target;

            if (e.type == "touchend") {
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                proxy._off(proxy.element, "touchmove", proxy._mouseMove);
            }
            else
                $target = $(e.target);            
            proxy._off($(document), "mouseup touchend", proxy._headerMouseUp);

            if (proxy.model.allowColumnResize) {
                if (model.isFromGantt)
                    proxy._off(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);
                else
                    proxy._off(proxy.element, "mouseup touchend", proxy._mouseUp);
                this.element.find(".e-reSizeColbg").remove();
                proxy._resizer._expand = false;
            }

            if (model.allowColumnReordering) {
                window.clearTimeout(this._dragColumnTooltipTimer);
                this._dragColumnTooltipTimer = null;
                proxy._off(proxy.element, "mousemove touchmove", proxy.dragColumnToolTip);
                $(proxy._reordervline).remove();
                $(proxy._dragmouseOverTooltip).remove();
                if (proxy._posx != coord.pageX || proxy._posy != coord.pageY) proxy._mouseDragged = true;
                if (model.allowColumnReordering && $target.closest('.e-headercell').length > 0 && proxy._headerDragStatus == "mousemove") {
                    var columns = model.columns;
                    args.targetColumn = columns[proxy._currentIndex];
                    args.targetColumnIndex = proxy._currentIndex;
                    args.draggedColumn = proxy._draggedColumn;
                    args.draggedColumnIndex = columns.indexOf(proxy._draggedColumn);

                    if (ej.isNullOrUndefined(args.targetColumn.nonColumn) && !ej.isNullOrUndefined(args.targetColumnIndex) && args.targetColumnIndex != args.draggedColumnIndex) {
                        proxy._trigger("columnDrop", args);
                        if (!args.cancel) {
                            proxy.reorderColumn(args.draggedColumn.field, args.targetColumnIndex);
                        }
                    }
                }
            }
            proxy._resetHeaderPrivateProperties();
        },

        _resetHeaderPrivateProperties: function () {
            this._timerDragDown && (this._timerDragDown = window.clearInterval(this._timerDragDown));
            this._timerDragUp && (this._timerDragUp = window.clearInterval(this._timerDragUp));
            var proxy = this, model = proxy.model;                      
            proxy._draggedColumn = null;
            proxy._dragMouseDown = false;
            proxy._dragTooltip = false;
            proxy._headerDragStatus = "";
            proxy._timerDragDown = null;
            proxy._timerDragUp = null;
            proxy._currentIndex = null;                        
            proxy._dragmouseOverTooltip = null;
        },

        //TREE GRID CONTENT MOUSE DOWN EVENT

        _contentMouseDown: function (e) {
            var $target = $(e.target), 
                proxy = this, model = proxy.model, coord = proxy._getCoordinate(e), id = $target.closest(".e-treegrid").attr("id");
            proxy._contentPageY = coord.pageY, proxy._contentPageX = coord.pageX;
            
            proxy._on($(document), "mouseup touchend", proxy._mouseupHandler);

            if (e.type == "touchstart") {
                proxy._isTouchEvent = true;            
                proxy._isTouchTrigger = true;
            }

            if ($("#" + id + "_selectionpopup").is(":visible")) {
                if ($("#" + id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                    e.ctrlKey = true;
                    if (proxy.model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row)
                    proxy._multiSelectCtrlRequest = true;
                }
                else {
                    e.ctrlKey = false; proxy._multiSelectCtrlRequest = false;
                }
            }
            if (!proxy.model.isFromGantt && model.contextMenuSettings.showContextMenu) {
                if (ej.isTouchDevice()) {                    
                    proxy._on(proxy.element, "taphold", proxy._contextMenuAction);
                }
                else
                    proxy._on(proxy.element, "contextmenu", proxy._contextMenuAction);
            }
            
            if (!($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown")
                  || $target.hasClass("e-vhandlespace") || $target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hdown")
                  || $target.hasClass("e-hhandlespace") || $target.closest(".e-editedcell").length > 0))
            {                
                proxy._mouseDown = true;
                if (ej.isTouchDevice())
                    e.preventDefault();
                if (model.allowDragAndDrop) {
                    //Events binded for Row drag and drop
                    if ($target.closest(".e-treegridrows").length > 0 || $target.closest(".e-templatecell").length > 0) {
                        if (e.type == "touchstart") {
                            proxy._dragTooltipTimer = window.setTimeout(function () {
                                proxy.dragRecord(e);
                                if (proxy._multiSelectPopup && proxy._multiSelectPopup.is(":visible") && proxy._dragTooltip)
                                    proxy._clearMultiSelectPopup();

                            }, 550);
                        }
                        else
                            proxy.dragRecord(e);
                    }
                }
                if (e.ctrlKey || e.shiftKey || e.which == 2 || e.which == 3)
                    return true;

                if (!model.isFromGantt) {
                    if (e.type == "touchstart")
                        proxy._on(proxy.element, "touchmove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);                   
                }
            }
        },

        _touchScroll: function (e) {
            var proxy = this, model = proxy.model, args = {},
                coord = proxy._getCoordinate(e), $target, pixelX,pixelY,               
                prevX = proxy._contentPageX, prevY = proxy._contentPageY,
                posX = coord.pageX, posY = coord.pageY,
                dx, dy;
            proxy._isTouchTrigger = false;
            
            dx = posX - prevX;
            dy = posY - prevY;                        
            if (e.type == "touchmove") {                
                e.preventDefault();                
            }
            if ((proxy._mouseDown &&  !proxy._dragMouseDown)) {

                window.clearTimeout(this._dragTooltipTimer);
                this._dragTooltipTimer = null;
                window.clearTimeout(this._dragColumnTooltipTimer);
                this._dragColumnTooltipTimer = null;

                if (e.type == "touchmove")
                    $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                else
                    $target = $(e.target);

                if (!model.isFromGantt && $target.closest('div').find('.e-content')) {

                    if (prevY < posY)
                        pixelY = -Math.abs(dy);
                    else
                        pixelY = Math.abs(dy);

                    if (prevX < posX)
                        pixelX = -Math.abs(dx);
                    else
                        pixelX = Math.abs(dx);

                    proxy._contentPageX = posX;
                    proxy._contentPageY = posY;

                    proxy._updateScrollPosition($target, pixelX, pixelY);
                }
            }
        },

        _updateScrollPosition: function (target, px, py) {

            var proxy = this,
                scrollTop = proxy.getScrollElement().ejScroller("option", "scrollTop"),
                scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft"),
                deltaX = scrollLeft + px, deltaY = scrollTop + py,
                sHeight = proxy.isVScroll() ? proxy.getMaxScrollHeight() : null,
                sWidth = proxy.getScrollElement().ejScroller("isHScroll") ? proxy.getScrollElement().find(".e-content").get(0).scrollWidth : null;
            
            if (sHeight) {
                deltaY = sHeight < deltaY ? sHeight : deltaY < 0 ? 0 : deltaY;
                if ((deltaY > 0 && scrollTop > 0) || (deltaY < sHeight && scrollTop < sHeight)) {
                    proxy._$gridContent.scrollTop(0);
                    proxy.getScrollElement().ejScroller("scrollY", deltaY, true);
                }
            }

            if (sWidth) {
                deltaX = sWidth < deltaX ? sWidth : deltaX < 0 ? 0 : deltaX;
                if ((deltaX > 0 && scrollLeft > 0) || (deltaX < sWidth && scrollLeft < sWidth)) {
                    proxy._$gridContent.scrollLeft(0);
                    proxy.getScrollElement().ejScroller("scrollX", deltaX, true);
                }
            }                        
        },

        _mouseMove: function (e) {

            var proxy = this, model = this.model;
            window.clearTimeout(this._dragColumnTooltipTimer);
            this._dragColumnTooltipTimer = null;

            if (proxy.model.allowColumnResize && proxy._headerDragStatus.length == 0) {
                proxy._resizer._mouseMove(e);
                if (proxy._resizer._expand)
                    proxy._cancelEditState();
                if ($(e.target).parent().css("cursor") !== "col-resize") {
                    if ((model.allowSorting || model.showColumnChooser || (!model.showColumnChooser && model.allowFiltering && model.filterSettings.filterType == "menu")) && !$(e.target).closest("th").hasClass("e-detailheadercell")) {
                        proxy.getHeaderTable().find(".e-columnheader").css({ 'cursor': 'pointer' });
                    } else {
                        proxy.getHeaderTable().find(".e-columnheader").css({ 'cursor': 'default' });
                    }
                }
            }
        },


        _mouseUp: function (e) {

            var proxy = this,
                model = proxy.model;

            if (proxy._headerDragStatus == "mousemove") return;

            if (model.allowColumnResize) {
                
                if ($(e.target).hasClass('e-headercelldiv') || $(e.target).hasClass('e-reSizeColbg')) {
                    proxy._focusTreeGridElement();
                    proxy._clearColumnMenu();
                }
                if ($(e.target).hasClass("e-reSizeColbg") || $(e.target).closest(".e-gridheader").length > 0) {
                // if treegrid column resizer initiated
                if (proxy._resizer._expand) {
                    var _x = e.clientX, _y = e.clientY;
                    if (navigator.userAgent.indexOf("WebKit") != -1) {
                        _x = e.pageX;
                        _y = e.pageY;
                    }
                    // Event triggered when we mouse the column resize
                    if (!ej.isNullOrUndefined(proxy._currentCell) && this._triggerColumnResize("columnResizeEnd", _x, e))
                    {
                        this.element.find(".e-reSizeColbg").remove();
                        proxy._resizer._expand = false;
                        if (model.isFromGantt)
                            proxy._off(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);
                        else
                            proxy._off(proxy.element, "mouseup touchend", proxy._mouseUp);
                        return;
                    }
                    proxy._resizer._mouseUp(e);
                    //update columnWidthCollection after column resize
                    if (!ej.isNullOrUndefined(proxy._currentCell) && proxy._currentCell >= 0 && proxy._currentCell < model.columns.length) {
                        model.columns[proxy._currentCell] && (model.columns[proxy._currentCell].width = proxy._resizer._newWidth);
                    }
                    // Event triggered after column resized
                    if (!ej.isNullOrUndefined(proxy._currentCell) && this._triggerColumnResize("columnResized", _x, e))
                        return;
                    proxy.getScrollElement().ejScroller("refresh");
                    proxy._updateHeaderScrollLeft();
                    proxy._updateScrollCss();
                    }
                }else
                {
                    this.element.find(".e-reSizeColbg").remove();
                    proxy._resizer._expand = false;
                    if (model.isFromGantt)
                        proxy._off(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);
                    else
                        proxy._off(proxy.element, "mouseup touchend", proxy._mouseUp);
                }
            }
        },

        // resize the filtering elements after column resized.

        _resizeFilteringElements:function()
        {
            var proxy = this;
            if (proxy.model.allowFiltering) {
                var args = {}, colLength = proxy.model.columns.length;
                ej.TreeGrid.Actions.Filter = "filtering";
                args.requestType = ej.TreeGrid.Actions.Filter;
                for (var item = 0; item < colLength ; item++) {
                    proxy.model.columns[item].width = proxy.columnsWidthCollection[item];
                    args.fieldname = proxy.model.columns[item].field;
                    this._filteringElements(args);
                }
            }
        },

        //ENABLE THE EDITING EVENTS
        _enableEditingEvents: function () {

            var proxy = this,
                model = proxy.model;

            if (model.editSettings.allowEditing) {
                if (ej.isTouchDevice()) {
                    proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                    proxy._on(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                }
                else {
                    proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                    proxy._on(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                }
            }
            else {
                if (ej.isTouchDevice())
                    proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                else
                    proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
            }

        },


        //ENABLE THE MOUSEDOWNEVENT HANDLER FOR SAVE CELL
        _saveCellHandler: function (e) {

            var $target = $(e.target),
                proxy = this, model = proxy.model, targetIndex;
            if (model.isFromGantt && $target.closest("tr").length) {
                var $targetElement = $target.closest("tr"),
                    $gridRows = proxy.getRows(),
                    rowIndex = this.getIndexByRow($targetElement),
                    record = model.currentViewData && model.currentViewData[rowIndex];
                targetIndex = model.updatedRecords.indexOf(record);             
            }
            //SKIP THE SCROLL BAR CLICK IN TREE GRID.
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown") || $target.hasClass("e-vhandlespace") || $target.hasClass("e-vscroll"))
                return;
            if ($target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hup") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace") || $target.hasClass("e-hscroll"))
                return;
          //  e.stopPropagation();
            if ($target.closest(".e-gridcontent").length > 0 || $target.hasClass(".e-gridcontent")) {
                if (proxy._isRowEdit && this.editFormValidate()) {
                    if ($target.closest("form#" + proxy._id + "EditForm").length == 0 && $target.closest("form#" + proxy._id + "EditFrozenForm").length == 0 &&  $("#" + proxy._id + "EditForm").length > 0)
                        proxy.saveRow();
                 } else if ($target.closest(".e-popup").length == 0 && $target.closest(".e-rowcell").find("#" + proxy._id + "EditForm").length == 0
                     && $target.closest("form#" + proxy._id + "EditFrozenForm").length == 0 && $("#" + proxy._id + "EditForm").length > 0 && this.editFormValidate()) {
                    proxy.saveCell();
                }
            }

            //Row selection for Gantt alone here
            //Why because, To select the clicked row after saving the edited cell (Due to predecessor and Row refresh)
            if (model.selectedMode == "row" && model.isFromGantt && model.updatedRecords.length && !ej.isNullOrUndefined(targetIndex) && !$target.hasClass('e-treegridexpand') && !$target.hasClass("e-treegridcollapse")) {
               if (this.selectedRowIndex() != targetIndex && !proxy._rowSelectingEventTrigger(this.selectedRowIndex(), targetIndex)) {
                    if (model.allowSelection)
                   proxy.selectRows(targetIndex);
                   proxy._rowSelectedEventTrigger(targetIndex);
               }
           }
        },

        //Mouse right click (Context Menu) handler
        _contextMenuAction: function(e){
            var proxy = this,
                $target, model = proxy.model,
                coord = proxy._getCoordinate(e);

            if(e.type == "taphold")
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
            else
                $target = $(e.target);
            if (model.contextMenuSettings.showContextMenu && $target.closest(".e-gridcontent").length > 0) {
                e.preventDefault();
                if (e.which == 3 && !proxy._isTouchEvent)
                    proxy._rightClick(e);
                else {
                    proxy._contextMenuHandler = true;
                    return true;
                }
            }
            else{
                e.stopPropagation();
            }            
        },

        _rightClick: function (e) {
            
            var proxy = this,
                model = proxy.model,
               $target = $(e.target),
               div = $target[0].parentNode,
               $ganttGridRows,
               row,
               recordIndexr,
               item, selectIndex,
               args = {},
               checkEditMenu = false,
               updatedRecords = proxy.getUpdatedRecords();
            /* check inner treegrid click events and  */
            if ($target.closest(".e-treegrid").attr("id") !== this._id) return false;

            if (model.selectionSettings.selectionMode == "cell" && model.editSettings.editMode != "dialogEditing") {
                model.editSettings.editMode = "cellEditing";
            }

            if (proxy.model.contextMenuSettings.showContextMenu) {
                proxy._clearContextMenu();
                this._removeDetailsRow();
                proxy.disableTooltip();
                if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-summarytitle"))
                    return;
                if ($target.hasClass("e-cell") || $target.hasClass("e-treegridexpand"))
                    div = $target.closest('tr');
                row = $target.closest('tr');
                recordIndexr = proxy.getIndexByRow(row);
                proxy.model.currentViewData = proxy.getCurrentViewData();
                item = proxy.model.currentViewData[recordIndexr];
                recordIndexr = updatedRecords.indexOf(item);
                args.data = item;
                args.recordIndex = recordIndexr;
                if (model.isEdit)
                    checkEditMenu = ($target.closest(".e-rowcell").find("form#" + proxy._id + "EditForm").length > 0) || ($target.closest(".e-rowcell").find("form#" + proxy._id + "EditFrozenForm").length > 0);
                else if (this._isRowEdit) {
                    checkEditMenu = ($target.closest(".e-rowedit").find("form#" + proxy._id + "EditForm").length > 0) || ($target.closest(".e-rowedit").find("form#" + proxy._id + "EditFrozenForm").length > 0) ||
                                    ($target.closest(".e-addedrow").find("form#" + proxy._id + "EditForm").length > 0) || ($target.closest(".e-addedrow").find("form#" + proxy._id + "EditFrozenForm").length > 0);
                }
                /* save edited value before rendering contextmenu on non edited cell*/
                if (!checkEditMenu && proxy.editFormValidate()) {
                    if (model.isEdit)
                        this.saveCell();
                    else if (this._isRowEdit)
                        this.saveRow();
                }
                //Context menu for edited row or empty records
                if ((proxy.dataSource() == null || proxy.dataSource().length == 0 || checkEditMenu || model.flatRecords.length == 0)) {
                    proxy._contextMenuItems = [];
                    proxy._contextMenuItems = proxy._getContextMenuItems();
                    proxy._subContextMenuItems = [];
                    proxy._updateContextmenuOption(recordIndexr, item);
                    proxy._clearContextMenu();
                    if (proxy._contextMenuItems.length > 0)
                        proxy._renderContextMenu(e, recordIndexr, item, checkEditMenu);

                } else if (item) {
                    e.preventDefault();
                    proxy._contextMenuItems = [];
                    proxy._contextMenuItems = proxy._getContextMenuItems();
                    proxy._subContextMenuItems = [];
                    proxy._subContextMenuItems = proxy._getsubContextMenuItems();
                    proxy._updateContextmenuOption(recordIndexr, item);
                    proxy._clearContextMenu();

                   
                    if (model.selectionSettings.selectionMode == "row") {
                        if (model.allowSelection &&!(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), recordIndexr))){
                            proxy.selectRows(recordIndexr);
                            proxy._rowSelectedEventTrigger(recordIndexr);}
                    }
                    if (model.selectionSettings.selectionMode == "cell") {
                        var selectCellIndex = proxy.getCellIndex(e);
                        proxy.selectCells([{ rowIndex: recordIndexr, cellIndex: selectCellIndex }]);
                        proxy._rowIndexOfLastSelectedCell = recordIndexr;
                    }

                    if (proxy._contextMenuItems.length > 0)
                        proxy._renderContextMenu(e, recordIndexr, item, checkEditMenu);
                    if (proxy.editFormValidate()) proxy._cancelSaveTools();
                }
            }
            proxy._clearColumnMenu();
            proxy._contextMenuHandler = false;
            if (!proxy.model.isFromGantt && model.contextMenuSettings.showContextMenu) {
                if (ej.isTouchDevice())
                    proxy._off(proxy.element, "taphold", proxy._contextMenuAction);
                else
                    proxy._off(proxy.element, "contextmenu", proxy._contextMenuAction);
                
            }
            return;
        },

        //DOUBLE CLICK EVENT HANDLER FOR DIALOG EDITING

        _editdblClickHandler: function (e) {

            var proxy = this,
                model = proxy.model,
                $form = $("#" + proxy._id + "EditForm"),
                args = {},
                $target = $(e.target),
                row = $target.closest('tr'),
                record,
                cellEditingDetails = proxy._cellEditingDetails;
            if (model.readOnly == true)
            {
                return true;
            }
            
            var updatedRecords = proxy.getUpdatedRecords();
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown") || $target.hasClass("e-vhandlespace") ||
                $target.hasClass("e-treegridexpand") || $target.hasClass("e-treegridcollapse"))
                return;
            if ($target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hup") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace"))
                return;
            if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-footersummaryrowcell")
                || $target.hasClass("e-summarytitle") || $target.hasClass("e-lastsummaryrow"))
                return;
            /* check inner treegrid click events and  */
            if ($target.closest(".e-treegrid").length && $target.closest(".e-treegrid").attr("id") !== this._id) return false;            

            if ($target.hasClass("e-rowcell") || $target.parent().hasClass("e-rowcell") || ($target.closest("td").hasClass("e-rowcell"))
                || ($target.closest("td").hasClass("e-rowcell")) && $target.hasClass("e-cell")) {

                if (model.editSettings.editMode === "normal" && model.editSettings.allowEditing) {
                    args.requestType = ej.TreeGrid.Actions.BeginEdit;
                    proxy._trigger("actionBegin", args);
                }

                if (proxy._cellEditingDetails.cancelSave) {

                    proxy._cellEditingDetails.cancelSave = false;
                    return;

                }

                if ($form.length === 0 && proxy.getRows() !== null) {

                    if (model.editSettings.editMode.toLowerCase() == "cellediting") {
                        proxy._focusTreeGridElement();
                        proxy._cellEditingDetails.columnIndex = proxy.getCellIndex(e);
                        if (model.editSettings.beginEditAction != "click")
                        proxy._cellEditingDetails.rowIndex = proxy.getRowIndex(e);
                        record = model.currentViewData[proxy._cellEditingDetails.rowIndex];
                        if (record.summaryRow)
                            return;
                        model.selectedItem = record;                        
                        if (model.columns[cellEditingDetails.columnIndex].allowEditing == false)
                            return;
                        var fieldName = proxy._cellEditingDetails.columnIndex >= 0 && model.columns[proxy._cellEditingDetails.columnIndex].field;
                        if (fieldName) {
                            proxy.updateScrollBar();
                            model.editSettings.allowEditing &&
                                model.editSettings.editMode.toLowerCase() == ej.TreeGrid.EditMode.CellEditing.toLowerCase() &&
                                proxy.cellEdit(proxy._cellEditingDetails.rowIndex, fieldName);
                        }
                    }
                    else if (model.editSettings.editMode.toLowerCase() == "rowediting" || model.editSettings.editMode.toLowerCase() == "dialogediting") {
                        model.currentViewData = proxy.getCurrentViewData();
                        if (proxy.getCellIndex(e) != -1 && proxy.getRowIndex(e) != -1) {
                            proxy._cellEditingDetails.columnIndex = proxy.getCellIndex(e);
                            var rowIndex = proxy.getRowIndex(e);
                            if (model.enableVirtualization) {
                                var selectedItem = model.selectionSettings.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
                                rowIndex = updatedRecords.indexOf(selectedItem);
                            }
                            if ((proxy.model.editSettings.editMode.toLowerCase() == "dialogediting")) {
                                proxy._showTreeGridAddEditDialog(rowIndex);
                            } else {
                                proxy.updateScrollBar();
                                proxy._editRow(rowIndex, undefined, proxy._cellEditingDetails.columnIndex);
                            }
                        }
                    }
                    $form = $("#" + proxy._id + "EditForm");
                    if ($form.length > 0)
                        proxy._editAddTools();

                    if ($.isFunction($.validator)) {
                        proxy._initValidator();
                        proxy.setValidation();
                    }
                }

                if (!proxy.model.allowSelection)
                    row.find(".e-active").removeClass("e-active").removeClass("e-selectionbackground");
                proxy._clearContextMenu();
                this._removeDetailsRow();
            }            
        },

        //To hide the datepicker and dropdown list.
        _popupHide: function (element) {
            var proxy = this,
             column = proxy.model.columns,
             object = null,
             dateobj = null,
             columnField = null,
             tdElement = element && $(element).closest("td");
            if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "filterbar") {
                tdElement = element && $(element).closest("td, th");
            }
            var columnChooser = $("#" + proxy._id + "_ColumnMenu").length;
            if (columnChooser > 0) {
                if (!ej.isTouchDevice())
                proxy._clearColumnMenu();
            }
            for (var i = 0; i < column.length; i++) {
                object = null;

                if (column[i]) {
                    columnField = column[i].field.split('.').join("");
                    if (column[i].editType == "datepicker" || column[i].editType == "datetimepicker")
                        object = $("#" + proxy._id + columnField).data("ejDatePicker");
                    else if (column[i].editType == "dropdownedit") {
                        var dropdownobject = $("#" + proxy._id + columnField).data("ejDropDownList");
                        if (dropdownobject && $(tdElement).find("#" + dropdownobject._id).length == 0)
                            dropdownobject.hidePopup();
                    }                    
                    if (object && $(tdElement).find("#" + object._id).length == 0)
                        object.hide();

                    if (column[i].filterEditType == "datepicker" || column[i].filterEditType == "datetimepicker") {
                        dateobj = $("#" + proxy._id + "_" + columnField + "_filterbarcell").data("ejDatePicker");
                        if (dateobj && $(tdElement).find("#" + dateobj._id).length == 0)
                            dateobj.hide();
                    }
                    if (column[i].filterEditType == "dropdownedit") {
                        var dropdownobject = $("#" + proxy._id + "_" + columnField + "_filterbarcell").data("ejDropDownList");
                        if (dropdownobject && $(tdElement).find("#" + dropdownobject._id).length == 0)
                            dropdownobject.hidePopup();
                    }
                }
            }
        },
        //PERFORM SCROLLING IN TREEGRID
        _mouseWheel: function (e) {

            var proxy = this,
                delta = null,
                ori = e;            
            proxy._popupHide();
            
            e = e.originalEvent;

            if (proxy.getScrollElement().height() > proxy._$gridContainer.height()) {
                proxy.getScrollElement().ejScroller("scrollY", 0, true);
                return;
            }

            if (e.wheelDelta) {
                delta = -e.wheelDelta / 120;
                if (window.opera) {
                    if (parseFloat(window.opera.version, 10) < 10)
                        delta = -delta;
                }
            } else if (e.detail) {
                delta = e.detail / 3;
            }
	
            if (!delta) return false;

            var scrollTop = proxy.getScrollElement().ejScroller("option", "scrollTop"),

                change = scrollTop + (delta * 57);  

            var h = this.model.isFromGantt ? parseInt(proxy.model.updatedRecords.length * proxy.model.rowHeight) - (proxy._viewPortHeight - 18) : this.getMaxScrollHeight();
            if (change > h) {
                change = h;
            }
            if (change < 0) {
                change = 0;
            }
            if (scrollTop != change) {
                try {
                    e.preventDefault ? e.preventDefault() : ori.preventDefault();
                }
                catch (err) {
                }
            }
            proxy.updateScrollTop(change);
            return true;

        },
        _getCollapsedParentItem:function(record)
        {
            var parentRecord = record.parentItem;
            if (parentRecord) {
                if (this.getExpandStatus(parentRecord) === true) {
                    return parentRecord;
                } else {
                    return this._getCollapsedParentItem(parentRecord)
                }
            }
            else {
                return null;
            }
        },


        // Update the scroll bar while edit, expand and collapse the record for focusing the row.
        updateScrollBar: function (rowIndex) {
            var proxy = this,
                model = proxy.model, horizontalScrollBarHeight = 0,
                currentUpdatedRecords, recordIndex,
                rowHeight = model.rowHeight + proxy._detailsRowHeight,
                isInViewPortAbove, isInViewPortBelow,
                updatedRecords = proxy.getUpdatedRecords(), selectedItem;
            if (model.allowSelection) {
                selectedItem = model.selectionSettings.selectionMode == "row" ? this.selectedItem() : updatedRecords[proxy._rowIndexOfLastSelectedCell];
            }
            else {
                selectedItem = this.selectedItem();
            }
            currentUpdatedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(updatedRecords);
            if (rowIndex || rowIndex == 0) {
                    recordIndex = currentUpdatedRecords.indexOf(updatedRecords[rowIndex]);
                } else {
                    recordIndex = currentUpdatedRecords.indexOf(selectedItem);
                }            

            var rowTop = recordIndex * rowHeight,
                rowBottom = rowTop + model.rowHeight,
                scrollTop,
                containerWidth,
                scrollerExist = proxy.getScrollElement().children(".e-content").length;
   
            if (scrollerExist)
                scrollTop = proxy.getScrollElement().children(".e-content").scrollTop();
            else
                scrollTop = proxy.getScrollElement().scrollTop();
    
            if(proxy.getScrollElement().ejScroller("isHScroll")  || proxy.element.find(".e-borderbox").length > 0)
            {
                horizontalScrollBarHeight = 18; /* default horizontal scrollbar height*/
            }

            isInViewPortAbove = (rowTop < scrollTop);
            isInViewPortBelow = (scrollTop + proxy._viewPortHeight - horizontalScrollBarHeight) <= rowBottom;


            if (isInViewPortAbove || isInViewPortBelow) {
    
                if ((rowTop + proxy._viewPortHeight) > currentUpdatedRecords.length * rowHeight) {
                    rowTop = currentUpdatedRecords.length * rowHeight - proxy._viewPortHeight;

                    if (isInViewPortBelow)
                        rowTop += horizontalScrollBarHeight;
                }

                    var args = {
                        requestType: ej.TreeGrid.Actions.Scroll,
                         delta: rowTop
                    };
                    if (scrollerExist)
                        proxy.updateScrollTop(rowTop);
                    else {
                        proxy.getScrollElement().scrollTop(args.delta);
                        proxy._completeAction(args);
                    }
                    if (model.enableVirtualization) {
                       proxy._focusTreeGridElement();
                    }
            }
        },

        //KEY PRESSED EVENT FOR KEY BOARD INTERACTION IN TREEGRID CONTROL

        _keyPressed: function (action, target, e) {

            var proxy = this,
            model = this.model,
            lastRowIndex,
            selectingRowIndex,
            updatedRecords = proxy.getUpdatedRecords(), index, editType, str,
            expandedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(model.updatedRecords), filterMenuDiv,
            currentSelectingRecord;
            this._removeDetailsRow();
            //CHECK THE ALLOWKEYBOARDNAVIGATION
            if (!model.allowKeyboardNavigation){
                return false;
            }

            if (this.model.editSettings.editMode == "dialogEditing" && $(target).closest("#" + this._id + "_dialogEdit").length)
                return true;
            var returnValue = false,
                $target = $(target),
            $form = $("#" + proxy._id + "EditForm");
            if (action !="downArrow" && action != "upArrow" && action != "saveRequest" && action != "moveCellLeft" && action != "moveCellRight"
                   && action != "cancelRequest" && $target.prop("tagName") == "INPUT") // Skip the keypress event for filter bar input box except enter
                return true;
            var contextMenu, subContextMenu, columnMenu, columnChooserMenu, isVisible, isVisibleColumnChooserMenu, isVisibleFilterMenu;
            if (model.isFromGantt) {
                contextMenu = $("#" + proxy._id.replace("ejTreeGrid", "") + "_ContextMenu");
                subContextMenu = $("#" + proxy._id.replace("ejTreeGrid", "") + "_SubContextMenu");
            }
            else {
                contextMenu = $("#" + proxy._id + "_ContextMenu");
                subContextMenu = $("#" + proxy._id + "_SubContextMenu");
            }
            columnMenu = $("#" + proxy._id + "_ColumnMenu");
            columnChooserMenu = $("#" + proxy._id + "ccDiv_wrapper");
            if (proxy._columnMenuTarget) {
                var columnFieldName = $.trim(proxy._columnMenuTarget.prev("div.e-headercelldiv").attr("ej-mappingname")),
                column = proxy.getColumnByField(columnFieldName), filtertype;
                if (column) {
                    if (column.filterEditType) {
                        index = column.filterEditType.indexOf("edit");
                        filtertype = column.filterEditType;
                    }
                    else {
                        index = column.editType.indexOf("edit");
                        filtertype = column.editType;
                    }
                    if (index != -1) {
                        editType = filtertype.slice(0, index);
                        str = editType.charAt(0).toUpperCase() + editType.slice(1);
                        filterMenuDiv = $("#" + proxy._id + "filter" + str + "MenuDiv_wrapper");
                    } else {
                        str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                        filterMenuDiv = $("#" + proxy._id + "filter" + str + "MenuDiv_wrapper");
                    }
                }
                isVisibleFilterMenu = !ej.isNullOrUndefined(filterMenuDiv) && filterMenuDiv.is(":visible");
            }
            isVisible = subContextMenu.css("visibility") == "visible" ? true : false;
            isVisibleColumnChooserMenu = columnChooserMenu.is(":visible");
            switch (action) {

                //save the current edited cellValue on Enter key press
                case "saveRequest":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) {
                            $target.blur();
                            proxy._endEdit();
                           proxy._focusTreeGridElement();
                        }
                        if (model.filterSettings.filterBarMode == "onEnter" && model.filterSettings.filterType == "filterbar" && model.allowFiltering && $target.closest("th").hasClass("e-filterbarcell"))
                            proxy._filterBarHandler(target);
                    }
                    else
                    {
                        if (contextMenu.length)
                        {
                            proxy._moveToNextMenuItem("save");
                        }
                        else if (columnMenu.length)
                        {
                            var option = null,
                                columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection");                            
                            if (isVisibleColumnChooserMenu) {                                
                                option = columnChooserMenuItem.data("column");
                            }
                            else
                            {
                                var columnMenuItem = columnMenu.find("div.e-columnmenuselection");
                                if (columnMenuItem.length > 0) {
                                    option = columnMenuItem[0].id;
                                }
                            }
                            if (!ej.isNullOrUndefined(option))
                            {
                                $target = proxy._columnMenuTarget;
                                var columnFieldName = $.trim($target.prev("div.e-headercelldiv").attr("ej-mappingname")),
                                column = proxy.getColumnByField(columnFieldName);
                                switch(option)
                                {
                                    case proxy._id + "_SortAscendingChooser":
                                        
                                        if (proxy.model.allowMultiSorting) proxy._multiSortRequest = true;
                                        if (model.isFromGantt)
                                            proxy.sortColumn(column.mappingName, ej.sortOrder.Ascending);
                                        else
                                            proxy.sortColumn(column.field, ej.sortOrder.Ascending);
                                        proxy._multiSortRequest = false;
                                        break;
                                    case proxy._id + "_SortDescendingChooser":
                                       
                                        if (proxy.model.allowMultiSorting) proxy._multiSortRequest = true;
                                        if (model.isFromGantt)
                                            proxy.sortColumn(column.mappingName, ej.sortOrder.Descending);
                                        else
                                            proxy.sortColumn(column.field, ej.sortOrder.Descending);
                                        proxy._multiSortRequest = false;
                                        break;
                                    case proxy._id + "_FreezeColumnsChooser":
                                        if (column && !$(proxy._id + "_FreezeColumnChooser").hasClass("e-disable")) {
                                            if (proxy._checkboxSelection) {
                                                if (model.columns[0].nonColumn && !model.columns[0].isFrozen)
                                                    model.columns[0]['isFrozen'] = true;
                                            }
                                            proxy.freezeColumn(column.field, true);
                                        }
                                        break;
                                    case proxy._id + "_UnfreezeColumnsChooser":
                                        if (column && !$(proxy._id + "_UnfreezeColumnChooser").hasClass("e-disable")) {                                           
                                            if (proxy._checkboxSelection && proxy._frozenColumnsLength == 2) {
                                                if (model.columns[0].nonColumn && model.columns[0].isFrozen)
                                                    model.columns[0]['isFrozen'] = false;
                                            }
                                            proxy.freezeColumn(column.field, false);
                                        }
                                        break;
                                    case proxy._id + "_FreezePrecedingColumnsChooser":
                                        if (column && !$(proxy._id + "_FreezePrecedingColumnsChooser").hasClass("e-disable"))
                                            proxy.freezePrecedingColumns(column.field);
                                        break;
                                    case proxy._id + "_ColumnLeftChooser":
                                        if (column && !$(proxy._id + "_ColumnLeftChooser").hasClass("e-disable"))
                                            proxy.insertColumnChooser(column, "left");
                                        break;
                                    case proxy._id + "_ColumnRightChooser":
                                        if (column && !$(proxy._id + "_ColumnRightChooser").hasClass("e-disable"))
                                            proxy.insertColumnChooser(column, "right");
                                        break;
                                    case proxy._id + "_DeleteColumnChooser":
                                        if (column && !$(proxy._id + "_DeleteColumnChooser").hasClass("e-disable")) {
                                            proxy._targetColumnIndex = model.columns.indexOf(column);
                                            proxy._updateConfirmDialog.ejDialog("open");
                                            proxy._clearColumnMenu();
                                        }
                                        break;
                                    case proxy._id + "_RenameColumnChooser":
                                        if (column && !$(proxy._id + "_RenameColumnChooser").hasClass("e-disable")) {
                                            proxy._targetColumnIndex = model.columns.indexOf(column);
                                            proxy._renderColumnRenameDialog(column);
                                            proxy._columnRenameDialog.ejDialog("open");
                                            proxy._clearColumnMenu();
                                        }
                                        break;
                                    case proxy._id + "_FilterChooser":
                                        if (column && $("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) {
                                            var idValue = filterMenuDiv[0].id.substring(proxy._id.length, filterMenuDiv[0].id.indexOf("MenuDiv"));
                                            proxy._showFilterMenu(null, idValue, null, null, null, null, null, null, column, null);
                                        }
                                        break;
                                    case proxy._id + "_ColumnsChooser":
                                        if ((column && $("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) && !proxy.model.isFromGantt) {
                                            proxy._adaptiveColumnChooser();
                                        }
                                        break;
                                    default:
                                        if (!columnChooserMenuItem.find("span").hasClass("e-disable")) {
                                            var isColumnVisible = columnChooserMenuItem.find("span").attr("aria-checked");
                                            isColumnVisible == "true" ? proxy.hideColumn(option) : proxy.showColumn(option);
                                        }
                                        break;
                                }
                            }
                        }

                    }
                    break;

                    //cancel the cell editing in the current cell Esc key press
                case "cancelRequest":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if ($form.length > 0) {
                            var editMode = model.editSettings.editMode;
                            if (editMode.toLowerCase() == "cellediting") {
                                if (proxy._isRowEdit)
                                    proxy.cancelRowEditCell();
                                else
                                    proxy.cancelEditCell();
                            }
                            else if (editMode.toLowerCase() == "rowediting") {
                                proxy.cancelRowEditCell();
                            }
                            proxy._cancelSaveTools();
                        }
                       proxy._focusTreeGridElement();
                        if (proxy._dragMouseDown == true) {
                            $(proxy._dragmouseOverTooltip).remove();
                            $(".intend").find(".e-icon").css({ "display": "none" });
                            $(".intendparent").find(".e-icon").css({ "display": "none" });
                            proxy._dropCancel = true;
                            proxy._dragMouseDown = false;
                            proxy._dragTooltip = false;
                            proxy._headerDragStatus = "";
                            /*hide drag icons for target row element*/
                            if (proxy._dragTargetItem && proxy._dragTargetItem.hasChildRecords && proxy._dragTargetItem.level ==0) {
                                var targetTr = ej.TreeGrid.getRowByIndex(this, updatedRecords.indexOf(proxy._dragTargetItem));
                                if (proxy._dragTargetItem)
                                    targetTr.find(".e-treegridexpand").css({ "display": "inline-block" });
                                else
                                    targetTr.find(".e-treegridcollapse").css({ "display": "inline-block" });
                            }
                            /*unbind mouse move event of row drag*/
                            proxy._off(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
                            proxy._off(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
                        }
                    }
                    else {
                        proxy._clearContextMenu();
                        proxy._clearColumnMenu();
                    }
                    break;
                case "editRecord":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (model.selectionSettings.selectionMode == "cell" && model.editSettings.editMode != "dialogEditing") {
                            model.editSettings.editMode = "cellEditing";
                        }
                        var editSettings = model.editSettings,
                            editMode = editSettings.editMode;
                        if (model.readOnly == false && ((editSettings.allowEditing && model.selectedItems.length == 1) || (editSettings.allowEditing && model.selectionSettings.selectionMode == "cell") ||
                            (editSettings.allowEditing && model.selectedItem && proxy._checkboxSelection))) {
                            if (editMode.toLowerCase() == "cellediting" || model.selectionSettings.selectionMode == "cell") {
                                var column = proxy.model.columns[proxy._cellIndex];
                                if (ej.isNullOrUndefined(column) || !column.visible || column.allowEditing == false)
                                    return;
                                if (model.selectionSettings.selectionMode === "cell")
                                    proxy._cellEditingDetails.rowIndex = this._rowIndexOfLastSelectedCell;
                                else
                                    proxy._cellEditingDetails.rowIndex = this.selectedRowIndex();
                                proxy._cellEditingDetails.columnIndex = proxy._cellIndex;//proxy.getCellIndex(e, target);
                                model.selectedItem = updatedRecords[this.selectedRowIndex()];
                                if (proxy._cellEditingDetails.columnIndex > -1) {
                                    proxy.updateScrollBar();
                                    var fieldName = column.field;
                                    fieldName && proxy.cellEdit(proxy._cellEditingDetails.rowIndex, fieldName);
                                    proxy._editAddTools();
                                }
                            }
                            else if (editMode.toLowerCase() == "rowediting" && !proxy._isRowEdit && model.selectionSettings.selectionMode != "cell") {
                                var index = proxy.selectedRowIndex();
                                if (index >= 0) {                                   
                                    proxy.updateScrollBar();
                                    proxy._editRow(index);
                                }
                            } else if (editMode.toLowerCase() == "dialogediting" && model.selectionSettings.selectionMode != "cell") {
                                var index = proxy.selectedRowIndex();
                                if (index >= 0) {
                                    proxy._showTreeGridAddEditDialog(index);
                                }
                            }
                        }
                    }
                    break;
                    //Select first row of current Page if Paging is enabled
                case "topRowSelection":
                    if (model.allowPaging && contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;
                        if (updatedRecords.length > 0) {
                            var topRowIndex = 0;
                            if (updatedRecords[0].isSummaryRow) {
                                var record = proxy._getNextRecord(topRowIndex +1, updatedRecords, action);
                                topRowIndex = updatedRecords.indexOf(record);
                            }
                            if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), topRowIndex)) {
                                proxy.selectRows(topRowIndex);
                               proxy._focusTreeGridElement();
                                proxy.updateScrollBar();
                                proxy._rowSelectedEventTrigger(topRowIndex);
                            }
                        }
                    }
                    break;
                    //Move to next page
                case "nextPage":
                    if (model.allowPaging) {
                        var currentPage = proxy._currentPage();
                       proxy._focusTreeGridElement();
                        if (currentPage < model.pageSettings.totalPages)
                            proxy.gotoPage(currentPage + 1);
                    }
                    break;
                    //Move to previous page
                case "prevPage":
                    if (model.allowPaging) {
                        var currentPage = proxy._currentPage();
                       proxy._focusTreeGridElement();
                        if (currentPage != 1)
                            proxy.gotoPage(currentPage - 1);
                    }
                    break;
                    //Select last row of current Page if Paging is enabled
                case "bottomRowSelection":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;
                        if (updatedRecords.length > 0) {

                            var bottomRowIndex = updatedRecords.length - 1;
                            if (updatedRecords[bottomRowIndex].isSummaryRow) {
                                var record = proxy._getNextRecord(bottomRowIndex - 1, updatedRecords, action);
                                bottomRowIndex = updatedRecords.indexOf(record);
                            }
                            if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), bottomRowIndex)) {
                                proxy.selectRows(bottomRowIndex);
                               proxy._focusTreeGridElement();
                                proxy.updateScrollBar();
                                proxy._rowSelectedEventTrigger(bottomRowIndex);
                            }
                        }

                    }
                    break;

                    //select the first row while press the Home key 
                case "firstRowSelection":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;

                        if (updatedRecords.length > 0) {
                            if (model.selectionSettings.selectionMode == "row") {
                                if (model.allowPaging)
                                    proxy.gotoPage(1);
                                if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), 0))){
                                    proxy.selectRows(0);
                                    proxy.updateScrollBar();
                                    proxy._focusTreeGridElement();

                                    proxy._rowSelectedEventTrigger(0);}
                            }
                                //Select first cell of a row.
                            else if (model.selectionSettings.selectionMode == "cell") {
                                var rowIndex = proxy._focusingRowIndex,
                                    cellInfo = {
                                        rowIndex: rowIndex,
                                        cellIndex: 0
                                    };
                                proxy._isShiftKeyNavigation = false;
                                proxy._cellIndex = 0;
                                proxy.selectCells([cellInfo]);

                            }
                            proxy._cancelSaveTools();
                        }  
                    }
                    break;

                case "lastRowSelection":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;
                        if (updatedRecords.length > 0) {
                            lastRowIndex = expandedRecords.length - 1;
                            currentSelectingRecord = expandedRecords[lastRowIndex];                            
                            if (currentSelectingRecord.isSummaryRow)
                                currentSelectingRecord = proxy._getNextRecord(lastRowIndex - 1, expandedRecords, action);
                            if (model.allowPaging && currentSelectingRecord) {
                                proxy.gotoPage(model.pageSettings.totalPages);
                                updatedRecords = proxy._updatedPageData;
                            }
                            selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                            if (model.selectionSettings.selectionMode == "row") {
                                if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), selectingRowIndex))){
                                    proxy.selectRows(selectingRowIndex);
                                    proxy._focusTreeGridElement();
                                    proxy.updateScrollBar();
                                    proxy._rowSelectedEventTrigger(selectingRowIndex);}
                            }
                                //Select last cell of a row.
                            else if (model.selectionSettings.selectionMode == "cell") {
                                var rowIndex = proxy._focusingRowIndex, columns = model.columns;
                                proxy._isShiftKeyNavigation = false;
                                proxy._cellIndex = columns.length - 1;

                                var cellInfo = {
                                    rowIndex: rowIndex,
                                    cellIndex: proxy._cellIndex
                                };

                                proxy.selectCells([cellInfo]);
                            }
                            proxy._cancelSaveTools();
                        }
                    }
                    break;
                    //set the edit mode to previous cell by press shift +tab key
                case "moveCellLeft":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        //Row edit Element focusing for Shift + tab key press
                        if (proxy._isRowEdit) {
                            var previousElement = $target.closest("td").prev("td");
                            if (this._frozenColumnsLength > 0 && previousElement.length == 0 && $target.closest("#" + proxy._id + "EditForm").length > 0)
                                previousElement = $("#" + proxy._id + "EditFrozenForm").find('td').last();
                            if (previousElement.length)
                                proxy._focusElementsForRowEdit(previousElement);
                        } else if (model.editSettings.allowEditing && model.editSettings.editMode.toLowerCase() == "cellediting" && $form.length > 0 && proxy.editFormValidate()) {
                            $target.blur();
                            returnValue = proxy._moveCurrentCell("left");
                        }
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && !proxy._isRowEdit && (proxy._focusingRowIndex != 0 || proxy._cellIndex != 0)) {
                            if (proxy.model.isEdit) {
                                proxy._focusingRowIndex = proxy._cellEditingDetails.rowIndex;
                                proxy._cellIndex = proxy._cellEditingDetails.columnIndex;
                                var cellInfo = {
                                    rowIndex: proxy._focusingRowIndex,
                                    cellIndex: proxy._cellIndex
                                };
                                proxy.selectCells([cellInfo]);
                            }
                            else proxy._selectNextCell("left", action);
                    }
                    }
                    break;

                    //set the edit mode to next cell by tab key
                case "moveCellRight":
                        if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit) {
                            var nextElement = $target.closest("td").next("td");
                            if (this._frozenColumnsLength > 0 && nextElement.length == 0 && $target.closest("#" + proxy._id + "EditFrozenForm").length > 0)
                                nextElement = $($form).find('td').eq(0);
                            if (nextElement.length)
                                proxy._focusElementsForRowEdit(nextElement);
                        } else if (model.editSettings.allowEditing && (model.editSettings.editMode == "cellEditing" || model.selectionSettings.selectionMode == "cell")
                            && $target && $form.length > 0 && this.editFormValidate()) {
                            $target.blur();
                            returnValue = proxy._moveCurrentCell("right");
                        }
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && !proxy._isRowEdit && (proxy._focusingRowIndex != proxy.getRows().length - 1 || proxy._cellIndex != columnLength - 1)) {
                            if (proxy.model.isEdit) {
                                proxy._focusingRowIndex = proxy._cellEditingDetails.rowIndex;
                                proxy._cellIndex = proxy._cellEditingDetails.columnIndex;
                                var cellInfo = {
                                    rowIndex: proxy._focusingRowIndex,
                                    cellIndex: proxy._cellIndex
                                };
                                proxy.selectCells([cellInfo]);
                            }
                            else proxy._selectNextCell("right", action);
                    }
                    }
                    break;

                    //select the next row by press down arrow key
                case "downArrow":
                    if (model.allowSelection) {
                        if (contextMenu.length == 0 && columnMenu.length == 0) {
                            if (proxy._isRowEdit || proxy.model.isEdit)
                                return true;

                            if (updatedRecords.length > 0 && model.selectedItem && proxy.selectedRowIndex() > -1 && model.selectionSettings.selectionMode == "row") {
                                //get the last row index of the ganttchart control
                                lastRowIndex = updatedRecords.length - 1;
                                if (proxy.selectedRowIndex() != lastRowIndex) {
                                    var selectedItem = updatedRecords[proxy.selectedRowIndex()];
                                    selectingRowIndex = expandedRecords.indexOf(selectedItem);
                                    currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                                        //To skip the key Navigation from summary row.
                                    if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                                        currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);
                                                                  
                                        selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                                        if (currentSelectingRecord && selectingRowIndex <= lastRowIndex) {
                                            if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), selectingRowIndex))){
                                                proxy.selectRows(selectingRowIndex);
                                                proxy.updateScrollBar();
                                                proxy._focusTreeGridElement();
                                                proxy._rowSelectedEventTrigger(proxy.selectedRowIndex());}
                                        }
                                }
                            proxy._cancelSaveTools();
                        }
                            else if (model.selectionSettings.selectionMode == "cell" && proxy.selectedCellIndexes().length > 0) {
                                var rowIndex = proxy._focusingRowIndex + 1, cellIndex = proxy._cellIndex,
                                    recordLength = updatedRecords.length;
                                proxy._isShiftKeyNavigation = false;
                                if (rowIndex < recordLength) {
                                    var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                                    selectingRowIndex = expandedRecords.indexOf(selectedItem);
                                    currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                                    //To skip the key Navigation from summary row.
                                    if (currentSelectingRecord && currentSelectingRecord.isSummaryRow) {
                                        currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);
                                        rowIndex = updatedRecords.indexOf(currentSelectingRecord);
                                    }
                                    if (currentSelectingRecord) {
                                    cellInfo = {
                                        rowIndex: rowIndex,
                                        cellIndex: cellIndex
                                    };
                                        proxy._focusingRowIndex = rowIndex;
                                        proxy.selectCells([cellInfo]);
                                        proxy.updateScrollBar();
                                }
                            }
                        }
                        }
                        else {
                            if (contextMenu.length) {
                                proxy._moveToNextMenuItem("next");
                            }
                            else if (columnMenu.length) {
                                if (isVisibleColumnChooserMenu) {
                                    var columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection"),
                                       nextItem = columnChooserMenuItem.next("div.e-columnMenuListDiv");
                                    if (nextItem.length > 0) {
                                        columnChooserMenuItem.removeClass("e-columnmenuselection");
                                        nextItem.addClass("e-columnmenuselection");
                                    }
                                }
                                else {
                                    var columnMenuItem = columnMenu.find("div.e-columnmenuselection"),
                                        nextItem = proxy._findNextColumnMenuItem(columnMenuItem, "next");
                                    if (nextItem.length > 0) {
                                        columnMenuItem.removeClass("e-columnmenuselection");
                                        nextItem.addClass("e-columnmenuselection");
                                        proxy._focusTreeGridElement();
                                        proxy._clearFilterMenu();
                                    }
                                }
                            }
                        }
					}
                    break;
                // expand the child task by press right arrow
                case "rightArrow":
					if (model.allowSelection) {
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) return true;
                        var rowIndex = proxy.selectedRowIndex(),
                        record = updatedRecords[rowIndex],
                        args = {},
                        isExpandCollapseEnabeled;
                        args.data = record;
                        args.recordIndex = rowIndex;
                        args.expanded = true;
                        if (record) {
                            if (record.hasChildRecords && !record.expanded) {
                                if (proxy.selectedRowIndex() >= 0) {
                                    isExpandCollapseEnabeled = proxy._trigger("expanding", args);
                                    if (!isExpandCollapseEnabeled && !model.isFromGantt) {
                                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                                    }
                                    if (model.enableVirtualization)
                                       proxy._focusTreeGridElement();
                                    proxy.updateScrollBar();
                                }
                            }
                        }
                        proxy._cancelSaveTools();
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && (proxy._focusingRowIndex != proxy.getRows().length -1 || proxy._cellIndex != columnLength - 1)) {
                            proxy._selectNextCell("right", action);
                    }
                    }
                    else
                    {
                        if (contextMenu.length && !isVisible) {
                            proxy._moveToNextMenuItem("expand");
                        }
                        else if (columnMenu.length && !isVisibleColumnChooserMenu) {

                            var evntArgs = {};
                            evntArgs.width = "auto";
                            evntArgs.height = "auto";
                            evntArgs.minWidth = "0px";
                            evntArgs.minHeight = "0px";
                            evntArgs.showHeader = false;
                            evntArgs.position = { X: 1, Y: 1 };
                            evntArgs.enableModal = false;
                            evntArgs.isResponsive = false;
                            evntArgs.enableResize = false;
                            evntArgs.cssClass = model.cssClass;
                            $("#" + proxy._id + "ccDiv_wrapper").addClass("e-treegridadaptivedialog");
                            $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                            $("#" + proxy._id + "ccDiv").ejDialog(evntArgs);
                            $("#" + proxy._id + "ccDiv").css({ 'height': 'auto' });

                            var columnMenuItem = columnMenu.find("div.e-columnmenuselection"),
                                columnChooserMenuList = columnChooserMenu.find("div.e-columnMenuListDiv"),
                                columnListPosX = proxy._columnListPosX,
                                columnFilterPosX = proxy._columnFilterPosX,
                                columnChooserListIndex = proxy._columnChooserListIndex,
                                windowWidth = $(document).width();
                            if (columnMenuItem.length > 0 && columnMenuItem[0].id == proxy._id + "_ColumnsChooser" && !$("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) {
                                var columnchooser = $("#" + proxy._id + "ccDiv").ejDialog("instance"),
                                    columnListWidth = $("#" + proxy._id + "ccDiv_wrapper").width();
                                columnchooser.open();
                                if (windowWidth < columnListPosX + columnMenu.width()) {
                                    columnListPosX = columnListPosX - columnMenu.width() - columnListWidth;
                                }
                                var position = {
                                    X: columnListPosX,
                                    Y: proxy._columnMenuPopupY + $("#" + proxy._id + "_ColumnsChooser").position().top
                                };
                                columnchooser.option({ "position": position });
                                columnChooserMenu.css("z-index", proxy.getMaxZIndex() + 1);
                                columnChooserMenuList.removeClass("e-columnmenuselection");
                                columnChooserMenuList.eq(0).addClass("e-columnmenuselection");
                                proxy._focusTreeGridElement();
                                proxy._renderedSubMenuType = "ColumnDesktop";
                            } else if (columnMenuItem.length > 0 && columnMenuItem[0].id == proxy._id + "_FilterChooser" && !$("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) {
                                var sliceFilterMenuDivID = filterMenuDiv[0].id.indexOf("_"),
                                    filterMenuDivID = "#"+ filterMenuDiv[0].id.slice(0, sliceFilterMenuDivID),
                                    filterMenuInstance = $(filterMenuDivID).ejDialog("instance"), filterMenuPosition, filterMenuIndex;

                                var proxy = this;
                                var evntArgs = {};
                                evntArgs.width = "auto",
                                evntArgs.height = "auto",
                                evntArgs.minWidth = "0px",
                                evntArgs.minHeight = "0px",
                                evntArgs.showHeader = false,
                                evntArgs.position = { X: 1, Y: 1 },
                                evntArgs.enableModal = false,
                                evntArgs.isResponsive = false,
                                evntArgs.enableResize = false,
                                $(filterMenuDivID + "_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                                $(filterMenuDivID).ejDialog(evntArgs);

                                    if (windowWidth < columnFilterPosX + $("#" + filterMenuDiv[0].id).width()) {
                                        columnFilterPosX = columnFilterPosX - columnMenu.width() - $("#" + FilterMenuDiv[0].id).width();
                                    }
                                    filterMenuIndex = columnMenu.find("div.e-columnmenuselection").closest("li").index();
                                    filterMenuPosition = {
                                        X: columnFilterPosX,
                                        Y: proxy._columnMenuPopupY + $("#" + proxy._id + "_FilterChooser").position().top
                                    };
                                    filterMenuInstance.option({ "position": filterMenuPosition });
                                    filterMenuInstance.open();
                                    proxy._updatePreviousFilteredValue(column);
                                    filterMenuDiv.css("z-index", proxy.getMaxZIndex() + 1);
                                    proxy._focusTreeGridElement();
                                    proxy._renderedSubMenuType = filterMenuDivID + "Desktop";
                                }
                        }
                    }
					}
                    break;
				
                //collapse the child task by press left arrow 
                case "leftArrow":
					if (model.allowSelection) {
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) return true;
                        var rowIndex = proxy.selectedRowIndex(),
                        record = updatedRecords[rowIndex],
                        args = {},
                        isExpandCollapseEnabeled;
                        args.data = record;
                        args.recordIndex = rowIndex;
                        args.expanded = false;
                        if (record) {
                            if (record.hasChildRecords && record.expanded) {
                                if (proxy.selectedRowIndex() >= 0) {
                                    isExpandCollapseEnabeled = proxy._trigger("collapsing", args);
                                    if (!isExpandCollapseEnabeled && !model.isFromGantt) {
                                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                                    }
                                    if (model.enableVirtualization)
                                       proxy._focusTreeGridElement();
                                    proxy.updateScrollBar();
                                }
                            }
                        }
                        proxy._cancelSaveTools();
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && (proxy._focusingRowIndex != 0 || proxy._cellIndex != 0)) {
                            proxy._selectNextCell("left", action);
                    }
                    }
                    else if (contextMenu.length)
                        proxy._moveToNextMenuItem("collapse");
                    else if (columnMenu.length && (isVisibleColumnChooserMenu || isVisibleFilterMenu)) {
                        $("#" + proxy._id + "ccDiv").ejDialog("close");
                        proxy._clearFilterMenu();
                    }
					}
                    break;
				
                    //select the previous row by press down arrow key
                case "upArrow":
					if (model.allowSelection) {
					    if (contextMenu.length == 0 && columnMenu.length == 0) {
					       if (proxy._isRowEdit || proxy.model.isEdit)
                                return true;

                            if (model.selectionSettings.selectionMode == "row" && this.selectedRowIndex() > 0 && updatedRecords.length > 0 && model.selectedItem) {
                            var selectedItem = updatedRecords[proxy.selectedRowIndex()];
                            selectingRowIndex = expandedRecords.indexOf(selectedItem);
                            currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                                if (currentSelectingRecord.isSummaryRow)
                                    currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, action);
                                selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                                if (selectingRowIndex !=-1  && !proxy._rowSelectingEventTrigger(this.selectedRowIndex(), selectingRowIndex)) {
                                    proxy.selectRows(selectingRowIndex);
                                    proxy.updateScrollBar();
                                    proxy._focusTreeGridElement();
                                    proxy._rowSelectedEventTrigger(proxy.selectedRowIndex());
                                }
                            proxy._cancelSaveTools();
                        }
                            else if (model.selectionSettings.selectionMode == "cell") {
                                var rowIndex = proxy._focusingRowIndex - 1, cellIndex = proxy._cellIndex,
                                   recordLength = model.flatRecords.length;
                                proxy._isShiftKeyNavigation = false;
                                if (rowIndex != -1) {
                                    var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                                    selectingRowIndex = expandedRecords.indexOf(selectedItem);
                                    currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                                    //To skip the key Navigation from summary row.
                                    if (currentSelectingRecord && currentSelectingRecord.isSummaryRow) {
                                        currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, action);
                                        rowIndex = updatedRecords.indexOf(currentSelectingRecord);
                    }
                                    if (currentSelectingRecord) {
                                   cellInfo = {
                                       rowIndex: rowIndex,
                                       cellIndex: cellIndex
                                   };
                                        proxy._focusingRowIndex = rowIndex;
                                    proxy.selectCells([cellInfo]);
                                        proxy.updateScrollBar();
                                    }

                    }
                            }
                        }
                        else {
                        if (contextMenu.length) {
                            proxy._moveToNextMenuItem("prev");
                        }
                        else if (columnMenu.length) {
                            if (isVisibleColumnChooserMenu) {
                                var columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection"),
                                  prevItem = columnChooserMenuItem.prev("div.e-columnMenuListDiv");
                                if (prevItem.length > 0) {
                                    columnChooserMenuItem.removeClass("e-columnmenuselection");
                                    prevItem.addClass("e-columnmenuselection");
                                }
                            }
                            else {
                                var columnMenuItem = columnMenu.find("div.e-columnmenuselection"),
                                    prevItem = proxy._findNextColumnMenuItem(columnMenuItem, "prev");
                                if (prevItem.length > 0) {
                                    columnMenuItem.removeClass("e-columnmenuselection");
                                    prevItem.addClass("e-columnmenuselection");
                                    proxy._clearFilterMenu();
                                }
                            }
                        }
                    }
					}
                    break;
                case "deleteRecord":
                    if (model.readOnly == false && model.editSettings.allowDeleting && contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) return true;
                        if (proxy.selectedRowIndex() >= 0) {
                            proxy.deleteRow();
                            proxy._cancelSaveTools();
                           proxy._focusTreeGridElement();
                        }
                    }
                    break;
                case "totalRowCollapse":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy.model.isFromGantt) {
                            args = {};
                            args.requestType = "collapseAll";
                            proxy._trigger("expandAllCollapseAllRequest", args);
                        }
                        else
                            proxy.collapseAll();
                        break;
                    }
                case "totalRowExpand":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy.model.isFromGantt) {
                            args = {};
                            args.requestType = "expandAll";
                            proxy._trigger("expandAllCollapseAllRequest", args);
                        }
                        else
                            proxy.expandAll();
                    }
                    break;
                case "spaceBar":
                var option = null;
                if (columnMenu.length && isVisibleColumnChooserMenu) {
                    var columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection");
                    option = columnChooserMenuItem.data("column");
                    if (!ej.isNullOrUndefined(option) && !columnChooserMenuItem.find("span").hasClass("e-disable")) {
                        var isColumnVisible = columnChooserMenuItem.find("span").attr("aria-checked");
                        isColumnVisible == "true" ? proxy.hideColumn(option) : proxy.showColumn(option);
                    }
                }
                if (proxy._checkboxSelection && $target.hasClass('e-treegrid') && $("#" + proxy._id + "EditForm").length == 0) {
                    proxy.selectRows(this.selectedRowIndex(), null, true);
                    proxy._cancelSaveTools();
                }
                break;
                case "shiftDownArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var recordLength = updatedRecords.length,                            
                            selectedCellElementLength = proxy._selectedCellDetails.length,
                            nextRowIndex;

                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);
                        if (!currentSelectingRecord)
                            return;
                        nextRowIndex = updatedRecords.indexOf(currentSelectingRecord);                        
                        if (proxy._focusingRowIndex > proxy._rowIndexOfLastSelectedCell) {
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                            proxy._selectedCellDetails.sort(function (a, b) {
                                return parseFloat(a.rowIndex) - parseFloat(b.rowIndex);
                            });
                            proxy._getSelectedCellsinARow(proxy._selectedCellDetails[0].data.index, proxy._selectedCellDetails);
                            for (var i = 0; i < proxy._selectedCellsinARow.length; i++) {
                                var selectedCellIndex = proxy._selectedCellDetails.indexOf(proxy._selectedCellsinARow[i]);
                                $(proxy._selectedCellsinARow[i].cellElement).removeClass("selectingcell");
                                proxy._selectedCellDetails.splice(selectedCellIndex, 1);
                            }
                            proxy.updateScrollBar();
                        }
                        else if (nextRowIndex < recordLength) {
                            var args = {
                                rowIndex: nextRowIndex,
                                cellIndex: proxy._lastSelectedCellIndex,
                            }
                            proxy.updateScrollBar();
                            proxy._shiftKeySelectCells(args);
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                        }

                    }
                    break;
                case "shiftUpArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var selectedCellElementLength = proxy._selectedCellDetails.length;
                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, "upArrow");
                        if (!currentSelectingRecord)
                            return;
                        nextRowIndex = updatedRecords.indexOf(currentSelectingRecord);                        
                        if (selectedCellElementLength > 0 && proxy._focusingRowIndex < proxy._rowIndexOfLastSelectedCell) {
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                            proxy._getSelectedCellsinARow(proxy._selectedCellDetails[selectedCellElementLength - 1].data.index, proxy._selectedCellDetails);
                            for (var i = 0; i < proxy._selectedCellsinARow.length; i++) {
                                var selectedCellIndex = proxy._selectedCellDetails.indexOf(proxy._selectedCellsinARow[i]);
                                $(proxy._selectedCellsinARow[i].cellElement).removeClass("selectingcell");
                                proxy._selectedCellDetails.splice(selectedCellIndex, 1);
                            }
                            proxy.updateScrollBar();
                        }
                        else if (nextRowIndex >= 0) {
                            var args = {
                                rowIndex: nextRowIndex,
                                cellIndex: proxy._lastSelectedCellIndex,
                            }
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                            proxy.updateScrollBar();
                            proxy._shiftKeySelectCells(args);
                        }

                    }
                    break;

                case "shiftRightArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var columnLength = model.columns.length, cellIndex = proxy._lastSelectedCellIndex + 1;
                        if (cellIndex < columnLength - 1 && (!model.columns[cellIndex].visible || !model.columns[cellIndex].allowCellSelection))
                            cellIndex = proxy.getUpNextVisibleColumnIndex(cellIndex);
                        if (cellIndex < columnLength) {

                            var args = {
                                rowIndex: proxy._rowIndexOfLastSelectedCell,
                                cellIndex: cellIndex,
                            }
                            proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
                            proxy._shiftKeySelectCells(args);
                            proxy._lastSelectedCellIndex = cellIndex;                            
                        }
                    }
                    //proxy.updateScrollBar(proxy._rowIndexOfLastSelectedCell);                    
                    break;
                case "shiftLeftArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var cellIndex = proxy._lastSelectedCellIndex - 1;
                        if (cellIndex != -1 && (!model.columns[cellIndex].visible || !model.columns[cellIndex].allowCellSelection))
                            cellIndex = proxy.getPreviousVisibleColumnIndex(cellIndex);
                        var args = {
                            rowIndex: proxy._rowIndexOfLastSelectedCell,
                            cellIndex: cellIndex,
                        }
                        if (cellIndex != -1) {
                            proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
                            proxy._shiftKeySelectCells(args);
                            proxy._lastSelectedCellIndex = cellIndex;
                        }
                    }
                    //proxy.updateScrollBar(targetIndex);                    
                    break;

                case "shiftHomeButton":
                    if (model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var rowIndex = proxy._rowIndexOfLastSelectedCell,
                           args = {
                               rowIndex: rowIndex,
                               cellIndex: 0
                           };
                        proxy._cellIndex = 0;
                        proxy._lastSelectedCellIndex = 0;
                        proxy._shiftKeySelectCells(args);

                    }
                    break;
                case "shiftEndButton":
                    if (model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var rowIndex = proxy._rowIndexOfLastSelectedCell, columns = model.columns;
                        proxy._cellIndex = columns.length - 1;
                        args = {
                            rowIndex: rowIndex,
                            cellIndex: proxy._cellIndex
                        };
                        proxy._lastSelectedCellIndex = proxy._cellIndex;
                        proxy._shiftKeySelectCells(args);

                    }
                    break;
                default:
                    returnValue = true;
            }

            return returnValue;
        },

        _clearAllFilter: function (fieldName) {
            var proxy = this, column = proxy.model.filterSettings.filteredColumns[0];
            proxy.model.allowFiltering = true;
            proxy.model.filterSettings.filteredColumns = [];
            proxy.filterColumn(column.field, column.operator, "", "and");
            proxy._filteredColumnValue = [];
            proxy._filteredColumnValueID = [];
        },

        //Method to bind all the filter condition and splice the over writed condition.
        filterColumn: function (fieldName, filterOperator, filterValue, predicate, matchcase, actualFilterValue) {
           
            var proxy = this,
                model = proxy.model,
                filteredColumns = model.filterSettings.filteredColumns;
            if (!this.model.allowFiltering)
                return;
            var args = {};
            ej.TreeGrid.Actions.Filter = "filtering";
            args.requestType = ej.TreeGrid.Actions.Filter;
            args.currentFilterObject = [];           
            if (!$.isArray(filterOperator))
                filterOperator = $.makeArray(filterOperator);
            if (!$.isArray(filterValue))
                filterValue = $.makeArray(filterValue);
            var firstLoop = false;
            var filterCol = this._filterCollection;
            if (ej.util.isNullOrUndefined(this._currentFilterColumn))
                this._currentFilterColumn = this.getColumnByField(fieldName);
            for (var index = 0; index < filterOperator.length; index++) {
                    var filterObject = {
                        field: fieldName,
                        operator: filterOperator[index],
                        value: filterValue[index],
                        matchcase: matchcase,
                        predicate: predicate,
                        actualFilterValue: actualFilterValue
                    };
                this._$colType = "string";
                if (filteredColumns.length == 0 && filterObject.value !== "") {
                    if (this._$colType == "date" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                        this._setDateFilters(filterObject);
                    else
                        filteredColumns.push(filterObject);
                } else {
                    var proxy = this;
                    if (!firstLoop) {
                        var dataManger = ej.DataManager(filteredColumns);
                        var query = new ej.Query().where("field", ej.FilterOperators.equal, filterObject.field);
                        var object = dataManger.executeLocal(query);
                        for (var i = 0; i < object.length; i++) {
                            var objectIndex = $.inArray(object[i], filteredColumns)
                            if (objectIndex != -1)
                                filteredColumns.splice(objectIndex, 1);
                        }
                    }
                    if (filterObject.value !== "") {
                        if (this._$colType == "date" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                            this._setDateFilters(filterObject);
                        else
                            filteredColumns.push(filterObject);
                    }
                }
                firstLoop = true;
                args.currentFilterObject.push(filterObject);
            }
            args.filterCollection = filteredColumns;
            args.currentFilteringColumn = fieldName;
            args.fieldName = fieldName;
            var returnValue = this.processBindings(args);
            if (returnValue) {
                filteredColumns.reverse().splice(0, filterOperator.length);
                filteredColumns.reverse();
            }
        },

        _cellSelectingEventTrigger: function (selectedCellInfo) {
            var proxy = this,
               model = proxy.model,
               args = {}, targetIndex = selectedCellInfo.rowIndex,
               currentCellIndex = selectedCellInfo.cellIndex,
               updatedRecords = proxy.getUpdatedRecords();
            args.data = updatedRecords[targetIndex];
            args.targetRow = selectedCellInfo.rowElement;
            args.targetCell = selectedCellInfo.cellElement;
            args.rowIndex = targetIndex;
            args.cellIndex = currentCellIndex;
            return proxy._trigger('cellSelecting', args);
        },
        _cellSelectedEventTrigger: function (selectedCellInfo, previousSelectedCellDetails) {
            var proxy = this,
                model = proxy.model,
                args = {}, targetIndex = selectedCellInfo.rowIndex,
                currentCellIndex = selectedCellInfo.cellIndex,
                previousRowIndex = previousSelectedCellDetails.rowIndex,
                previousCellIndex = previousSelectedCellDetails.cellIndex,
                updatedRecords = proxy.getUpdatedRecords();

            //previousSelectedCellDetails
            args.PreviousTargetRow = previousSelectedCellDetails.rowElement;
            args.previousTargetCell = previousSelectedCellDetails.cellElement;
            args.previousData = updatedRecords[previousRowIndex];
            args.previousRowIndex = previousRowIndex;
            args.previousCellIndex = previousCellIndex;
            //currentSelectedCellDetails
            args.data = updatedRecords[targetIndex];           
            args.targetRow = selectedCellInfo.rowElement;
            args.targetCell = selectedCellInfo.cellElement;
            args.rowIndex = targetIndex;
            args.cellIndex = currentCellIndex;
            return proxy._trigger('cellSelected', args);
        },

        //ROWSELECTING EVENT METHOD
        _rowSelectingEventTrigger: function (previousIndex, currentIndex) {

            var proxy = this,
                model = proxy.model,
                args = {},
                selectedItem,
                $gridRows,
                updatedRecords = proxy.getUpdatedRecords();
                args.targetRow = ej.TreeGrid.getRowByIndex(proxy, currentIndex);
                args.previousTreeGridRow = ej.TreeGrid.getRowByIndex(proxy, previousIndex);
                args.data = updatedRecords[currentIndex];
                args.previousData = updatedRecords[previousIndex];
                args.recordIndex = currentIndex;
                args.previousIndex = previousIndex;
                if (proxy.model.isFromGantt) {
                    args.target = "ejTreeGrid";
                }
                var isCancel = proxy._trigger('rowSelecting', args);
				if (isCancel)
                    model.selectedItem = args.data;
                return isCancel;
        },


        //ROWSELECTED EVENT METHOD
        _rowSelectedEventTrigger: function (index) {

            var proxy = this, model = proxy.model,
                args = {}, updatedRecords = proxy.getUpdatedRecords();
            var record = $.extend({}, updatedRecords[index]);
            /*Remove childRecords and parentItem from record object, 
              To avoid the cyclic dependency when performing postback action in ASP.NET */
            delete record.childRecords;
            delete record.parentItem;

            args = {
                targetRow: ej.TreeGrid.getRowByIndex(proxy, index),
                recordIndex: index
            };
            if (proxy.model.isFromGantt) {
                args.target = "ejTreeGrid";
                args.data = model.updatedRecords[index];
            }
            else
                args.data = record;

                proxy._trigger("rowSelected", args);
        },


        //QUERYCELLINFO,ROWDATABOUND EVENT BINDING FOR TREEGRID
        _eventBindings: function (data) {

            var proxy = this,
                model = proxy.model,
                count = 0,
                row, updatedRecords = proxy.getUpdatedRecords(),
                gridRows = proxy.getRows(),
                length;
            
            if (ej.isNullOrUndefined(data)) {
                length = this._frozenColumnsLength > 0 ? $(gridRows[0]).length : $(gridRows).length;
                data = model.currentViewData;
            }
            else
                length = data.length;
            

            if (model.queryCellInfo != null || model.rowDataBound != null || model.detailsDataBound) {

                for (count; count < length; count++) {
                    var rowIndex = updatedRecords.indexOf(data[count]);
                    row = ej.TreeGrid.getRowByIndex(this, rowIndex);
                    proxy._rowEventTrigger(row,data[count]);
                }
            }
        },

        //ROWDATABOUND EVENT TRIGGER
        _rowEventTrigger: function (row, data) {

            var proxy = this,
                model = this.model;

            if (model.rowDataBound) {
                proxy._trigger("rowDataBound", {
                    rowElement: row,
                    data: data
                });
            }
           
            var tdCells = row.cells,
                $tdRowcells = $(row).find(".e-rowcell"),
                cellIndex = 0,
                length = $tdRowcells.length,
                column=null,
                columns = proxy.model.columns;
            if (model.queryCellInfo) {
                for (cellIndex; cellIndex < length; cellIndex++) {

                    if ($($tdRowcells[cellIndex]).hasClass("e-rowcell")) {
                        column = columns[cellIndex];
                    }

                    if (column) {
                        proxy._cellEventTrigger($tdRowcells[cellIndex], data, column);
                    }
                }
            }

            if (model.detailsDataBound && $(row).next("tr").hasClass("e-detailsrow")) {
                var detailsRowElement = $(row).next("tr");
                if (this._frozenColumnsLength > 0)
                    detailsRowElement = $(detailsRowElement[1]);
                this._trigger("detailsDataBound", { detailsElement: detailsRowElement, data: data });
            }
        },


        //QUERYCELLINFO EVENT TRIGGER
        _cellEventTrigger: function (cell, data, column) {

            var args = {
                cellElement: cell,
                data: data,
                column: column,

            };
            args.cellValue = args.column && this._getCustomCellValue(data, args.column.field);
            this._trigger("queryCellInfo", args);
        },


        //ACTION COMPLETE EVENT TRIGGER
        _completeAction: function (args) {

            var proxy = this,
                model = proxy.model,
                sortcolumns = model.sortSettings.sortedColumns,
                ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");

            model.isEdit = false;

            if (model.allowPaging && args.requestType != ej.TreeGrid.Actions.Scroll)
                this._refreshGridPager();
            if ((ej.TreeGrid.Actions.Sorting == args.requestType && model.allowSorting)
                || (ej.TreeGrid.Actions.Refresh == args.requestType)) {

                if (model.allowSorting) {

                    if (!proxy._multiSortRequest) {
                        proxy.getHeaderTable().find(".e-columnheader").
                            find(".e-headercelldiv").find(".e-ascending,.e-descending").remove();

                        proxy.getHeaderTable().find("[aria-sort]").removeAttr("aria-sort");
                    }

                    for (var i = 0; i < sortcolumns.length; i++) {
                        proxy._addSortElementToColumn(sortcolumns[i].field, sortcolumns[i].direction);
                    }

                }

                proxy._multiSortRequest = false;
            } else if (ej.TreeGrid.Actions.BeginEdit == args.requestType || ej.TreeGrid.Actions.Add == args.requestType) {

                var $form = $("#" + proxy._id + "EditForm");

                proxy.model.isEdit = true;
                proxy.setWidthToColumns();

                if (ej.TreeGrid.Actions.Add == args.requestType) {

                    $form.find(".e-field:disabled").not(".e-identity").removeAttr("disabled").removeClass("e-disable");

                }

                if ($.isFunction($.validator))
                    this._initValidator();
            }
            else if (model.isFromGantt && args.requestType === ej.TreeGrid.Actions.Scroll)
            {
                proxy._updateCurrentViewData();
            }
            if (model.isFromGantt)
                ganttObject.model.sortSettings = model.sortSettings;
            proxy._trigger("actionComplete", args);
        },


        //#endregion

        //#region METHOD FOR DATA PROCESSING

        //RENDERING THE DATA
        sendDataRenderingRequest: function (args) {

            var proxy = this, model = this.model,
                temp, data;
            if (proxy.model.currentViewData.length) {

                switch (args.requestType) {

                    case ej.TreeGrid.Actions.Delete:
                    case ej.TreeGrid.Actions.Refresh:
                    case ej.TreeGrid.Actions.Save:
                    case ej.TreeGrid.Actions.Filter:
                    case ej.TreeGrid.Actions.Sorting:
                    case ej.TreeGrid.Actions.Searching:
                    case ej.TreeGrid.Actions.ExpandCollapse:
                    case ej.TreeGrid.Actions.RefreshDataSource:
                    case ej.TreeGrid.Actions.DragAndDrop:
                    case ej.TreeGrid.Actions.Paging:
                    case ej.TreeGrid.Actions.Scroll:

                        temp = document.createElement('div');
                       

                        if (args.requestType != ej.TreeGrid.Actions.Scroll) {
                            if (this._frozenColumnsLength > 0) {
                                proxy._renderFrozenRecords();

                            }
                            else {
                                proxy.getContentTable().find("colgroup").first().replaceWith(proxy._getMetaColGroup());
                                var $tbody = proxy.getContentTable().children('tbody');
                                $tbody.empty();

                                temp.innerHTML = ['<table>', $.render[proxy._id + "_Template"](proxy.model.currentViewData), '</table>'].join("");

                                proxy.getContentTable().get(0).replaceChild(temp.firstChild.firstChild,
                                    proxy.getContentTable().get(0).lastChild);
                                proxy.setGridRows($(proxy.getContentTable().get(0).rows));
                            }
                        }
                        else {
                            var $tbody = proxy.getContentTable().children('tbody'),
                                                           currentViewData = proxy.model.currentViewData,
                                                           visibleRange = proxy._visibleRange,
                                                           length = this._frozenColumnsLength > 0 ? $($tbody[0]).children("tr").length : $tbody.children("tr").length, isTopToBottom = false;
                            if (proxy._scrollTop > proxy._prevScrollTop) {
                                var removeLength = visibleRange.top - proxy._prevRTop,
                                     addLength = visibleRange.bottom - proxy._prevRBottom,
                                     data = addLength ? currentViewData.slice(-addLength) : [];
                                
                                    isTopToBottom = true;
                            }
                            else {
                                var removeLength = length - (proxy._prevRBottom - visibleRange.bottom + 1),
                                      addLength = proxy._prevRTop - visibleRange.top,
                                       data = currentViewData.slice(0, addLength);
                                removeLength = removeLength >= 0 ? removeLength : (-length - 1);
                                
                                isTopToBottom = false;
                            }                            
                            if (this._frozenColumnsLength > 0) {
                                proxy._renderFrozenRecords(data, addLength, removeLength, isTopToBottom);
                            }
                            else {
                                proxy.getContentTable().find("colgroup").first().replaceWith(proxy._getMetaColGroup());
                                if (isTopToBottom) {
                                    $tbody.children(":visible:lt(" + removeLength + ")").remove();
                                    var dataHtml = $.render[proxy._id + "_Template"](data);
                                    $tbody.append(dataHtml);
                                }
                                else {
                                    $tbody.children(":visible:gt(" + removeLength + ")").remove();
                                    var dataHtml = $.render[proxy._id + "_Template"](data);
                                    $tbody.prepend(dataHtml);
                                }
                                proxy._gridRows = proxy.getContentTable().find("tr");
                                proxy.setGridRows(proxy._gridRows);
                            }
                        }
                        this._gridRows = this.getContentTable().get(0).rows;
                        if (this._frozenColumnsLength > 0)
                            this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

                        /* check treee grid rows are append in DOM and Trigger refresh and querycellInfo events */
                        if (proxy._$gridContent && proxy._isRendered){
                            proxy._trigger("refresh");
                            proxy._eventBindings(data);
                            this._hideCollapsedDetailsRows();
                        }
                        break;
                }

            } else {
                if (proxy._frozenColumnsLength > 0) {
                    var $emptyTd = ej.buildTag('td', model.emptyRecordText, {}, { colSpan: this._frozenColumns.length }), doc = document;
                    proxy.getContent().find("#e-frozencontentdiv" + proxy._id + " .e-table tbody").empty().append($(doc.createElement("tr")).append($emptyTd));
                    $emptyTd = ej.buildTag('td', model.emptyRecordText, { visibility: "hidden" }, { colSpan: this._unFrozenColumns.length });
                    proxy.getContent().find("#e-movablecontentdiv" + proxy._id + " .e-table tbody").empty().append($(doc.createElement("tr")).append($emptyTd));
                    proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", "30px");
                } else {
                    proxy.getContentTable().find('tbody').empty().append(proxy._getEmptyTbody());
                    proxy._$gridContainer && proxy._$gridContainer.css({ height: "30px" }); // for render no record text
                }
                proxy._gridRows = null;
                proxy.setGridRows(null);

            }

            if (proxy.model.showGridCellTooltip || proxy.model.showGridExpandCellTooltip) {
                proxy._cellMouseLeave();
                proxy._headerMouseLeave();
            }

            if (args.requestType == ej.TreeGrid.Actions.Scroll)
                args.requestType == ej.TreeGrid.Actions.Refresh;

            proxy._completeAction(args);

        },
        _renderFrozenRecords: function (data, addLength, removeLength, isTopToBottom)
        {
            /* Update colgroup of frozen and movable tables while rendering records*/
            this.getContent().find("#e-frozencontentdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[0]);
            this.getContent().find("#e-movablecontentdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[1]);
            var $tbody = this.getContentTable().children('tbody'), temp;
            

            if (ej.isNullOrUndefined(data)) {
                                $tbody.empty();
                                /*Render frozen Table*/
                                temp = document.createElement('div');
                                temp.innerHTML = ['<table>', $.render[this._id + "_JSONFrozenTemplate"](this.model.currentViewData),
                                    '</table>'].join("");
                                this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild,
                                    this.getContentTable().get(0).lastChild);
                                /*Render movable Table*/
                                temp = document.createElement('div');
                                temp.innerHTML = ['<table>', $.render[this._id + "_Template"](this.model.currentViewData),
                                    '</table>'].join("");
                                this.getContentTable().get(1).replaceChild(temp.firstChild.firstChild,
                                    this.getContentTable().get(1).lastChild);
                            }
                       else {
                           if (isTopToBottom) {
                                    $($tbody.get(0)).children(":visible:lt(" + removeLength + ")").remove();
                                    $($tbody.get(1)).children(":visible:lt(" + removeLength + ")").remove();
                                    var frozenHtml = $.render[this._id + "_JSONFrozenTemplate"](data);
                                    var moveHtml = $.render[this._id + "_Template"](data);
                                    $($tbody.get(0)).append(frozenHtml);
                                    $($tbody.get(1)).append(moveHtml);
                                }
                            else {
                                $($tbody.get(0)).children(":visible:gt(" + removeLength + ")").remove();
                                $($tbody.get(1)).children(":visible:gt(" + removeLength + ")").remove();
                                var frozenHtml = $.render[this._id + "_JSONFrozenTemplate"](data);
                                var moveHtml = $.render[this._id + "_Template"](data);
                               $($tbody.get(0)).prepend(frozenHtml);
                                $($tbody.get(1)).prepend(moveHtml);
                            }
            }

            this.setGridContentTable(this.getContent().find(".e-table"));
        },

        _renderByFrozenDesign: function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this._frozenColumnsLength))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            return $.render[this._id + "_FrozenTemplate"](colgroups);
           
        },
        addFrozenTemplate: function () {
            var template = "<div class='e-frozencontainer' id='e-frozencontainer" + this._id + "' style='overflow:hidden;float:left;'><div class='e-frozencontentdiv' id='e-frozencontentdiv" + this._id + "' style='width:100%;'>"
            + "<table class='e-table' style='width:100%' cellspacing='0' id='" + this._id + "frozene-table'>{{:colgroup1}}<tbody>"
            + "</tbody></table></div></div>"
            + "<div class='e-movablecontainer' id='e-movablecontainer" + this._id + "'><div class='e-movablecontent' id='e-movablecontent" + this._id + "'><div class='e-movablecontentdiv' id='e-movablecontentdiv" + this._id + "'><table class='e-table' id='" + this._id + "movablee-table' cellspacing='0'>{{:colgroup2}}<tbody>"
            + "</tbody></table></div></div></div>", templates = {};
            templates[this._id + "_FrozenTemplate"] = template;
            $.templates(templates);
        },
       

        //Public method to change the allowSorting value dynamically.
        sortSetting: function (value) {
            var proxy = this,
                ascendingIcon = $("#" + proxy._id).find(".e-ascending.e-icon"),
                descendingIcon = $("#" + proxy._id).find(".e-descending.e-icon");
                proxy.model.allowSorting = value;               
                if (ascendingIcon.length > 0) {
                    for (var length = 0 ; length < ascendingIcon.length; length++) {
                        $(ascendingIcon[length]).css("visibility", "hidden");
                    }
                }                                      
            if (descendingIcon.length > 0)
                for (var length = 0 ; length < descendingIcon.length; length++) {
                    $(descendingIcon[length]).css("visibility", "hidden");
                }
        },
        //Public method to change the treeColumnIndex value dynamically.
        columnIndex:function(value){
            var proxy = this, model = proxy.model;
            if (!isNaN(parseInt(value)) && parseInt(value) >= 0 && parseInt(value) < model.columns.length) {
                model.treeColumnIndex = parseInt(value);
                proxy._addInitTemplate();
                this.renderRecords();
                if (model.showColumnChooser)
                    proxy._renderColumnChooserList(true);
            }
        },


        //SORTING THE DATA BASED ON THE PARTICULAR FIELDS
        
        sortColumn: function (columnName, columnSortDirection) {

            var proxy = this,
                model = proxy.model,
                sortColumns = model.sortSettings.sortedColumns,
                args = {},
                count = 0,
                length = sortColumns.length;
            /* Cancel edited cell before sort the column*/
            proxy._cancelEditState();
            proxy.clearSelection();
            if (!model.allowSorting || $.inArray(columnName, proxy._disabledSortableColumns) != -1
                || columnName.length == 0) {
                return;
            }

            if (!proxy._multiSortRequest) {
                model.sortSettings.sortedColumns = [];
            }

            args.requestType = ej.TreeGrid.Actions.Sorting;
            args.columnName = columnName;

            // proxy._cSortedColumn = proxy.getFieldNameByHeaderText(columnName);

            proxy._cSortedColumn = columnName;

            proxy._cSortedDirection = args.columnSortDirection = columnSortDirection === undefined ?
                ej.sortOrder.Ascending : columnSortDirection;

            for (count; count < length; count++) {
                
                if (sortColumns[count].field == proxy._cSortedColumn) {
                    sortColumns.splice(count, 1);
                    break;
                }

            }

            model.sortSettings.sortedColumns.push({
                field: proxy._cSortedColumn,
                direction: proxy._cSortedDirection
            });

            var returnValue = proxy.processBindings(args);

            if (returnValue) {

                proxy._cSortedDirection = proxy._cSortedColumn = null;

            }
            if (proxy.selectedRowIndex() >= 0 && proxy._isRendered) {
                proxy.selectedRowIndex(proxy._sortedRecords.indexOf(this.selectedItem()));
            }
            proxy._clearColumnMenu();
        },


        //Clear the sorting
        clearSorting: function()
        {
            var proxy = this,
                model = proxy.model;
            model.sortSettings.sortedColumns = [];
            var args = {};
            args.requestType = ej.TreeGrid.Actions.Sorting;
            proxy.processBindings(args);
        },


        //DELETE THE PARTICULAR RECORD AND MULTIPLE RECORD
        deleteRow: function ($tr, isFromContextmenu, index) {

            var proxy = this,
                deletedRowIndex,
                deletedRow,
                args = {},
                eveArgs = {},
                model = proxy.model,
                selectedItems = $.extend([],model.selectedItems),
                length = isFromContextmenu ? 1 : selectedItems.length,
                updatedRecords = proxy.getUpdatedRecords();
            
            if (proxy._isEmptyRow && model.selectionSettings.selectionMode == "cell")
                length = 1;
            if (!model.editSettings.allowDeleting || length == 0)
                return false;

            for (var del = 0; del < length; del++) {
                if (model.isFromGantt && isFromContextmenu)
                    args.data = updatedRecords[index];
                else if (proxy._checkboxSelection && isFromContextmenu) {
                    args.data = model.selectionSettings.selectionMode == "row" ? model.selectedItem : updatedRecords[proxy._rowIndexOfLastSelectedCell];
                }
                else
                args.data = model.selectionSettings.selectionMode == "row" ? selectedItems[del] : updatedRecords[proxy._rowIndexOfLastSelectedCell];
                deletedRow = args.data;
                if (proxy.model.enableWBS) {
                    var dataRows, targetRowIndex, isUpdateWBS = false;
                    if (deletedRow && deletedRow.parentItem) {
                        dataRows = deletedRow.parentItem.childRecords,
                        targetRowIndex = dataRows.indexOf(deletedRow);
                    } else if (model.flatRecords.length) {
                        var flatData = model.flatRecords,
                            Level0 = flatData.filter(function (item) {
                                return item && item.level == 0;
                            });
                        dataRows = Level0;
                        targetRowIndex = dataRows.indexOf(deletedRow);
                    }
                    if (targetRowIndex != dataRows.length - 1)
                        isUpdateWBS = true;
                }
                if (model.flatRecords.indexOf(args.data) != -1) {
                    args.requestType = ej.TreeGrid.Actions.Delete;
                    args.isFromContextmenu = isFromContextmenu;
                    proxy._selectedCellDetails = [];
                    if (proxy._removeRecords(args))
                        return true;            
            }
                if (isUpdateWBS) {
                    var targetRow;
                    if (deletedRow.parentItem)
                        targetRow = dataRows[targetRowIndex];//Here we are having the updated 'dataRows'
                    else {
                        //for level 0 records
                        dataRows.splice(targetRowIndex, 1);
                        targetRow = dataRows[targetRowIndex];
            }
                    proxy.updateWBSdetails(targetRow);
                }
            }

            proxy._ensureDataSource(args);
            proxy.updateHeight();
            if (model.currentViewData.length > 0 && model.enableAltRow)
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);

            if (proxy._checkboxSelection) {                
                model.selectedCellIndexes = [];
                proxy._prevSelectedItems = null;
                if (!isFromContextmenu)
                    model.selectedItems = [];
                model.selectedItem = null;
                proxy.selectedRowIndex(-1);
                proxy.selectAllRows();
            }
            else {
                model.selectedItems = [];
                model.selectedCellIndexes = [];
                model.selectedItem = null;
				proxy.selectedRowIndex(-1);
                proxy._prevSelectedItems = null;
				if (this._multiSelectPopup && this._multiSelectPopup.is(":visible") && !proxy.model.isFromGantt)
				proxy._clearMultiSelectPopup();
            }
        },
		//Delete selected records
        _removeRecords: function(args){
            var proxy = this,
                model = proxy.model,
                dataSource =this.dataSource();
            if (args && (model.editSettings.allowDeleting || args.isDragAndDropDelete) && args.requestType === ej.TreeGrid.Actions.Delete) {
                var deletedRow = args.data,
                    recordIndex, rowindex;

                if (proxy._trigger("actionBegin", args)) {
                    return true;
                }

                recordIndex = model.flatRecords.indexOf(deletedRow);                

                if (deletedRow.parentItem) {

                    var childRecords = deletedRow.parentItem.childRecords,
                    childIndex = childRecords.indexOf(deletedRow);

                    deletedRow.parentItem.childRecords.splice(childIndex, 1);
                    //Delete the summary row of one parent after deleted the all child records of the parent
                    if (model.showSummaryRow) {
                        var summaryRowLength = model.summaryRows.length;
                        if (summaryRowLength == childRecords.length) {
                            deletedRow.parentItem.childRecords.splice(0, summaryRowLength);
                            model.flatRecords.splice(recordIndex, summaryRowLength);
                        }
                    }
                    if (!model.parentIdMapping)
                        deletedRow.parentItem.item[model.childMapping].splice(childIndex, 1);
                }

                if (proxy._checkboxSelection && !args.isDragAndDropDelete) {
                    if (args.isFromContextmenu)
                        proxy._removeChildRecords(model.selectedItems, args.data);
                    else {
                        while (model.selectedItems.length > 0) {
                            proxy._removeChildRecords(model.selectedItems, model.selectedItems[0]);
                        }
                    }
                }

                //Delete from parent collection if item is parent
                var parentIndex=model.parentRecords.indexOf(deletedRow);
                if (parentIndex!== -1)
                {
                    model.parentRecords.splice(parentIndex, 1);
                }
                
                if (recordIndex !== -1) {
                    var deletedRecordCount = proxy.getChildCount(deletedRow, 0);
                    model.flatRecords.splice(recordIndex, deletedRecordCount + 1);
                    model.ids && model.ids.splice(recordIndex, deletedRecordCount + 1);                    
                }

                model.updatedRecords = model.enableVirtualization ? proxy.getExpandedRecords(model.flatRecords) : model.flatRecords.slice();
                proxy.updateCollapsedRecordCount();                                
                
                if(!model.parentIdMapping)
                {
                    if (dataSource instanceof ej.DataManager) {
                        if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                            rowindex = dataSource.dataSource.json.indexOf(deletedRow.item);
                            if (rowindex !== -1)
                                dataSource.dataSource.json.splice(rowindex, 1);
                        }
                        else if (proxy._isDataManagerUpdate) {
                            rowindex = proxy._jsonData.indexOf(deletedRow.item);
                            proxy._jsonData.splice(rowindex, 1);
                        }
                    } else {
                        rowindex = dataSource.indexOf(deletedRow.item);
                        if (rowindex !== -1)
                            dataSource.splice(rowindex, 1);
                    }
                }
                else
                {
                    //remove child item
                    if (deletedRow.hasChildRecords && deletedRow.childRecords.length > 0)
                    {
                        proxy._removeChildItem(deletedRow);
                    }
                    //remove deleting item

                    if (dataSource instanceof ej.DataManager) {
                        if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                            var idx = dataSource.dataSource.json.indexOf(deletedRow.item);
                            if (idx !== -1)
                                dataSource.dataSource.json.splice(idx, 1);
                        }
                        else if (proxy._isDataManagerUpdate) {
                            var idx = proxy._jsonData.indexOf(deletedRow.item);
                            if (idx !== -1)
                                proxy._jsonData.splice(idx, 1);
                        }
                    }
                    else
                    {
                        var idx = dataSource.indexOf(deletedRow.item);
                        if (idx !== -1)
                            dataSource.splice(idx, 1);
                    }
                }
                
                if (deletedRow.parentItem)
                    if (deletedRow.parentItem.childRecords.length == 0) {
                        deletedRow.parentItem.expanded = false;
                        deletedRow.parentItem.hasChildRecords = false;
                        deletedRow.parentItem.hasFilteredChildRecords = false;
                    }
                //Update the summary and total summary row after deleted a record.
                if (model.showSummaryRow)
                    proxy._updateSummaryRow(args);
                if (model.showTotalSummary)
                    proxy._updateTotalSummaryRow(args);
            }
        },

        /*Update the WBS value of all the records that are below the newly added row*/
        updateWBSdetails: function (delTargetRow) {
            var proxy = this,
                model = proxy.model,
                dataW = delTargetRow,
                newWBS = dataW["WBS"];

            //Updating the WBS value of other records that are below the newly added row
            var childItems, markedIndex, markedRecords, dataS, dataLength;
            if (dataW.parentItem) {
                childItems = dataW.parentItem.childRecords;
                markedIndex = childItems.indexOf(dataW);
                dataS = childItems;
                dataLength = dataS.length;
            } else if (model.flatRecords.length) {
                var flatData = model.flatRecords,
                    Level0 = flatData.filter(function (item) {
                        return item && item.level == 0;
                    });
                dataS = Level0;
                markedIndex = dataS.indexOf(dataW);
                dataLength = dataS.length;
            }
            markedRecords = dataS.slice(markedIndex, dataLength);
            if (markedRecords.length) {
                var lastVal = newWBS.lastIndexOf('.') != -1 ? parseInt(newWBS.substr(newWBS.lastIndexOf('.') + 1)) : parseInt(newWBS),
                    parentVal = dataW.parentItem ? dataW.parentItem.WBS : null;
                lastVal--;
                proxy.reCalculateWBS(markedRecords, lastVal, parentVal);
            }
        },

        /* To recalculate the WBS value */
        reCalculateWBS: function (selectedRecords, lastDigit, parentWBS) {
            var proxy = this, model = proxy.model,
                cViewData = model.currentViewData, final;

            if (parentWBS) {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = lastDigit + i;
                    selectedRecords[i]["WBS"] = parentWBS + "." + final;
                    selectedRecords[i]["item"]["WBS"] = parentWBS + "." + final;
                    if (model.enableWBSPredecessor)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    proxy.refreshRow(cViewData.indexOf(selectedRecords[i]));
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i])
                }
            }
            else {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = (lastDigit + i).toString();
                    selectedRecords[i]["WBS"] = final;
                    selectedRecords[i]["item"]["WBS"] = final;
                    if (model.enableWBSPredecessor)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    proxy.refreshRow(cViewData.indexOf(selectedRecords[i]));
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i])
                }
            }
        },

        _updateChildWBS: function (parentRecord) {
            var proxy = this, model = proxy.model,
                cViewData = model.currentViewData,
                childRecs = parentRecord.childRecords,
                pWBS = parentRecord["WBS"];
            for (var c = 0; c < childRecs.length; c++) {
                childRecs[c]["WBS"] = pWBS + "." + (c + 1);
                childRecs[c]["item"]["WBS"] = pWBS + "." + (c + 1);
                if (model.enableWBSPredecessor)
                    proxy._getPredecessorIds(childRecs[c]);
                proxy.refreshRow(cViewData.indexOf(childRecs[c]));
                if (childRecs[c].hasChildRecords) {
                    proxy._updateChildWBS(childRecs[c])
                }
            }
        },

        /*Get all the predecessor rows that are matching the taskId*/
        _getPredecessorIds: function (pData) {
            var proxy = this,
                model = proxy.model,
                dataTID = pData.taskId,
                flatDatas = model.flatRecords,
                updatedRecs = model.updatedRecords,
                targetRecords = flatDatas.filter(function (item) {
                    if (item["predecessorsName"]) {
                        var prdcList = item["predecessorsName"].split(',');
                        for (var p = 0; p < prdcList.length; p++) {
                            var ref = prdcList[p].match(/(\d+|[A-z]+)/g),
                                refId = +ref[0];
                            if (refId == dataTID)
                                return item;
                        }
                    }
                });
            for (var t = 0; t < targetRecords.length; t++) {
                proxy.updateWBSPredecessor(targetRecords[t]);
                proxy.refreshRow(updatedRecs.indexOf(targetRecords[t]));
            }
        },

        //SEARCH THE TASK FROM TREE GRID CONTROL

        

        search: function (searchString) {

            var proxy = this,
                args = {};

            args.requestType = ej.TreeGrid.Actions.Searching;
            args.keyValue = searchString;

            proxy._searchString = searchString;

            proxy.processBindings(args);
        },

        //SEND SAVE REQUEST
        endEdit: function () {

            var proxy = this;

            if (proxy.model.editSettings.editMode.toLowerCase() == "cellediting" && !proxy._isRowEdit) {
                if (!this.editFormValidate())
                    return true;
                return proxy.saveCell();
            } else if (proxy.model.editSettings.editMode.toLowerCase() == "dialogediting") {
                return proxy.saveRow();
            }

            return true;

        },
        updateReadOnly:function(bool){
            var proxy=this;
            proxy.model.readOnly = bool;           
           
        },
        updateShowGridExpandCellTooltip: function (bool) {
            var proxy = this;
            proxy.model.showGridExpandCellTooltip = bool;
            proxy.refreshContent();
        },
        updateShowGridCellTooltip: function (bool) {
            var proxy = this;
            proxy.model.showGridCellTooltip = bool;
            proxy.refreshContent();
        },

        //#endregion

        //#region PUBLIC METHODS

        //CALCULATE THE VISIBLE RANGE OF RECORDS TO DISPLAYED IN CURRENT VIEWPORT
        getVisibleRange: function () {

            var proxy = this,
                model = proxy.model,
                calcHeight = (proxy.model.rowHeight + proxy._detailsRowHeight),
                top = proxy._scrollTop / calcHeight,
                coeff = top - Math.floor(top),
                topIndex, bottomIndex,
                updatedRecords = proxy.getUpdatedRecords();

                proxy._offset = coeff * calcHeight;
                var topIndex = Math.floor(top),
                bottomIndex = proxy._getRowPosition(proxy._scrollTop + proxy._viewPortHeight);
                topIndex = Math.max(0, topIndex);
                bottomIndex = Math.min(updatedRecords.length, bottomIndex);

                proxy._visibleRange = {
                    top: topIndex,
                    bottom: bottomIndex
                };

            return proxy._visibleRange;

        },
        /* set width to frozen and movable header columns to prevent
        improper view port height calculation while load time*/
        _setWidthToHeaders: function ()
        {
            var width = this._gridWidth;
            if (this._frozenColumnsLength > 0) {
                var totalWidth = 0, frozenWidth;
                for (var i = 0; i < this.columnsWidthCollection.length; i++) {
                    totalWidth += this.columnsWidthCollection[i];
                    if (this._frozenColumnsLength - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                }
                this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).width(width).next().css("margin-left", frozenWidth + "px");
                this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).outerWidth(frozenWidth)
                    .end().find("#e-movableheaderdiv" + this._id).css("width", "100%");
            }
        },
        //SET THE COLUMNWIDTH TO EACH COLUMN IN TREEGRID
        setWidthToColumns: function () {

            var proxy = this,
                model = proxy.model,
                $cols1 = proxy.getContentTable().children("colgroup").find("col"),
                $cols2 = proxy.getHeaderTable().children("colgroup").find("col"),
                width = proxy._gridWidth,
                colCount = model.columns.length;

            for (var i = 0; i < $cols2.length; i++) {

                if (!ej.isNullOrUndefined(proxy.columnsWidthCollection[i])) {

                    $cols1.eq(i).width(proxy.columnsWidthCollection[i]);
                    $cols2.eq(i).width(proxy.columnsWidthCollection[i]);
                    }
            }
            /* width fro details col group cell */
            if (!model.isFromGantt) {
                if ($cols1.length > colCount) {
                    $cols1.eq(colCount).width(35);
                }

                if ($cols2.length > colCount) {
                    $cols2.eq(colCount).width(35);
                }
            }

            /* Update column width in total summary table*/
            if (model.showTotalSummary && this._$totalSummaryRowContainer) {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                var footerColClone = $(gridheaderCol).clone();
                if (this._frozenColumnsLength > 0) {
                    if (this._$footertableContent) {
                        $(this._$footertableContent).find('colgroup').remove();
                        $(footerColClone[0]).prependTo(this._$footertableContent[0]);
                        $(footerColClone[1]).prependTo(this._$footertableContent[1]);
                    }
                }
                else {
                    if (this._$footertableContent) {
                        $(this._$footertableContent).find('colgroup').remove();
                        $(footerColClone).prependTo(this._$footertableContent);
                    }
                }
            }

            if (this._frozenColumnsLength > 0) {
                var frozenWidth = this._getFrozenColumnWidth();
                this.getContent().find("#e-movablecontainer" + this._id).css("margin-left", frozenWidth + "px");
                this.getContent().find("#e-frozencontainer" + this._id).outerWidth(frozenWidth);
                if (this.getScrollElement().data("ejScroller")) {
                    this.getScrollElement().ejScroller("option", "width", this._gridWidth - frozenWidth - this._totalBorderWidth - 1);
                    this.getScrollElement().ejScroller("option", "scrollTop", proxy._scrollTop);
                    this.getScrollElement().ejScroller("option", "scrollLeft", proxy._scrollLeft);
                }
                this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).next().css("margin-left", frozenWidth + "px");
                this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).outerWidth(frozenWidth)
                    .end().find("#e-movableheaderdiv" + this._id).css("width", "100%");
                if (this._$totalSummaryRowContainer) {
                    this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).width(width).next().css("margin-left", frozenWidth + "px");
                    this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).outerWidth(frozenWidth)
                        .end().find("#e-movablefooterdiv" + this._id).css("width", "100%");
                    if (this.getBrowserDetails().browser == "safari")
                        this._$totalSummaryRowContainer.find("#e-movablefooter" + this._id).css("margin-left", "auto");
                }
                if (this.getBrowserDetails().browser == "safari")
                    this.getHeaderContent().find("#e-movableheader" + this._id).add(this.getContent().find("#e-movablecontainer" + this._id)).css("margin-left", "auto");
            }
            if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                this._updateTableWidth();
        },
        //Set width for table according to column resize mode
        _updateTableWidth: function (isUpdateCssOnly) {
            var totWidth = 0, $headerTable, $contentTable, $totalSummaryTable,
                model = this.model, frozenColumnWidth = this._getFrozenColumnWidth(),
                columnLength = model.columns.length;
            for (var i = 0; i < columnLength; i++) {
                if (model.columns[i].isFrozen || model.columns[i].visible != false)
                    totWidth += model.columns[i].width;
            }
            if (this._frozenColumnsLength > 0) {
                totWidth -= frozenColumnWidth;
                $headerTable = $(this.getHeaderTable()[1]);
                $contentTable = $(this.getContentTable()[1]);
                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[1]) : null;
            } else {
                $headerTable = this.getHeaderTable();
                $contentTable = this.getContentTable();
                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[0]) : null;
            }
            if (model.showDetailsRow && model.showDetailsRowInfoColumn && model.detailsTemplate)
                totWidth += 35; // 35 denoted detail row icon column
            //when window resize no need to update the table width values
            if (!isUpdateCssOnly) {
                $headerTable.width(totWidth);
                $contentTable.width(totWidth);
                $totalSummaryTable && $totalSummaryTable.width(totWidth);
            }
            if (totWidth < (this._gridWidth - frozenColumnWidth) && model.columns[columnLength - 1].visible) {
                $headerTable.addClass('e-tableLastCell');
                $contentTable.addClass('e-tableLastCell');
             //   $totalSummaryTable && $totalSummaryTable.addClass('e-tableLastCell');
            } else {
                $headerTable.removeClass('e-tableLastCell');
                $contentTable.removeClass('e-tableLastCell');
              //  $totalSummaryTable && $totalSummaryTable.removeClass('e-tableLastCell');
            }
        },
        _convertHtml: function (text) {
            return text
                .replace(/&/g, "&amp;")
                .replace(/</g, "&lt;")
                .replace(/>/g, "&gt;")
                .replace(/"/g, "&quot;")
                .replace(/'/g, "&#039;");
        },

        //ENTER EDIT MODE INTO THE TREEGRID CELL
        cellEdit: function (index, fieldName) {

            var proxy = this,
                $form,
                model = proxy.model,
                row, rowIndex = index,
                updatedRecords = proxy.getUpdatedRecords(), selectedItem;
            if (model.allowSelection == true) {
                selectedItem = model.selectionSettings.selectionMode == "row" ? this.selectedItem() : updatedRecords[proxy._rowIndexOfLastSelectedCell];
            }
            else {
                selectedItem = this.selectedItem();
            }
            if (proxy.model.showGridCellTooltip) {
                proxy._cellMouseLeave();
            }

            proxy.model.isEdit && proxy.saveCell();

            $form = $("#" + proxy._id + "EditForm");

            if ($form.length > 0) return true;

            if (!selectedItem) return false;

            if (model.isFromGantt && selectedItem.hasChildRecords) {
                if (fieldName === "status" ||
                (fieldName === "startDate" && selectedItem.isAutoSchedule) ||
                (fieldName === "endDate" && selectedItem.isAutoSchedule) ||
                (fieldName === "duration" && selectedItem.isAutoSchedule) ||
                 fieldName === "work" || fieldName === "effortDriven" || fieldName === "taskType" ||
                 fieldName === "predecessor" ||
                 fieldName === "taskId")
                    return false;
            }
            if (model.isFromGantt) {
                if (selectedItem.isAutoSchedule && selectedItem.taskType == "fixedWork" && fieldName == "effortDriven")
                    return false;
                if (!selectedItem.isAutoSchedule && (fieldName == "taskType" || fieldName == "effortDriven"))
                    return false;
            }
            if (model.enableVirtualization || model.selectionSettings.selectionMode === "cell" ) {
                rowIndex = updatedRecords.indexOf(selectedItem);
                index = model.currentViewData.indexOf(selectedItem);
            }

            row = ej.TreeGrid.getRowByIndex(this, rowIndex);
            if (row && $(row).find(".e-rowcell").length > 0) {
                var $targetTr = $(row),
                columnIndex = proxy.getColumnIndexByField(fieldName),
                $targetTd = $targetTr.find(".e-rowcell").eq(columnIndex),
                column = proxy.model.columns[columnIndex],
                data = selectedItem,
                cellValue = proxy._getCustomCellValue(data, column.field),
                beginEditArgs = {},
                args = {
                    validationRules: ej.isNullOrUndefined(column.validationRules) ? {} : $.extend(true, {},
                        column.validationRules),
                    columnName: column.field,
                    value: !ej.isNullOrUndefined(cellValue) ? cellValue : data.item && data.item[fieldName],
                    data: data,
                    columnObject: column,
                    cell: $targetTd
                },
                isEditable = true;
                if (column.field == "notesText") {
                    args.value = !ej.isNullOrUndefined(data[fieldName]) ? data[fieldName] : data.item && data.item[fieldName];
                    args.value = args.value ? proxy._convertHtml(args.value) : args.value;
                }
                else {
                    args.value = !ej.isNullOrUndefined(cellValue) ? cellValue : data.item && data.item[fieldName];
                }
            if (model.isFromGantt && args.columnName === "predecessor") {

                var predecessor = args.data.item[proxy.model.predecessorMapping];
                args.value = predecessor ? predecessor : "";

            }
            if (model.isFromGantt && args.columnName === "taskMode") {
                var taskModeValue = !args.data.isAutoSchedule;
                args.value = taskModeValue;
            }

            beginEditArgs.data = data;
            beginEditArgs.columnIndex = columnIndex;
            beginEditArgs.rowElement = $targetTr;
            beginEditArgs.cellElement = $targetTd;

          

            proxy._cellEventTrigger($targetTd, data, args.columnObject);

                if (proxy._trigger("beginEdit", beginEditArgs)) return false;               

                if ($targetTr.hasClass("e-insertedrow") && (!args.columnObject.isTemplateColumn)) isEditable = true;

                if (isEditable) {

                    $.extend(proxy._cellEditingDetails, {
                        rowIndex: index,
                        cellValue: args.value,
                        columnIndex: columnIndex,
                        fieldName: fieldName,
                        cellEditType: args.columnObject.editType,
                        data: data
                    });
                }
                args.columnIndex = columnIndex;
                proxy._renderCellEditObject(args, $targetTd);
                if (!$targetTr.hasClass("e-templaterow")) {
                    $targetTr.addClass("e-editedrow");
                }

                args.cell && args.cell.addClass("e-editedcell");
                proxy._updateHorizontalScrollBar(fieldName);
                return true;
            }
        },

        _updateHorizontalScrollBar: function (fieldName)
        {
            var proxy = this,
                gridContent = proxy.getScrollElement(),
                isHorizontalScroll = gridContent.ejScroller("isHScroll");
            //Check if the horizontal scrollbar is exists or not
            if (isHorizontalScroll) {
                var model = proxy.model,
                columns = model.columns,
                columnLength = columns.length,
                columnIndex = proxy.getColumnIndexByField(fieldName),                
                width = 0, startWidth = 0,
                endWidth = 0, left = 0,
                viewPortWidth = gridContent.find(".e-content").width(),
                scrollLeft = gridContent.ejScroller("option", "scrollLeft"),
                form = $("#" + proxy._id + "EditForm"), row,
                cells=[];                
                if (model.selectionSettings.selectionMode == "cell" && form.length == 0)
                    cells = $("#" + proxy._id).find(".selectingcell");//$(proxy._selectedCellDetails[proxy._selectedCellDetails.length - 1].cellElement).clone();
                else {
                    row = $(form).closest("tr.e-treegridrows");
                    cells = $(row).find("td.e-rowcell");
                }
                if (proxy._frozenColumnsLength > 0 && columnIndex < proxy._frozenColumnsLength)
                    return false;

                //Calculate the start and end width for edited cell
                for (var index = proxy._frozenColumnsLength; index <= columnIndex; index++) {
                    if (model.selectionSettings.selectionMode == "cell" && form.length == 0)
                        var cell = cells[cells.length - 1];
                    else
                        var cell = $(cells[index - proxy._frozenColumnsLength]);
                    if (index == columnIndex) {
                        startWidth = width;
                        endWidth = width + $(cell).width() + parseFloat($(cell).css("padding-left")) + parseFloat($(cell).css("padding-right")) + 1; // 1 for border
                    }
                    if (columns[index].visible) {
                        width = width + $(cell).width() + parseFloat($(cell).css("padding-left")) + parseFloat($(cell).css("padding-right")) + 1; // 1 for border
                    }
                }
                // Check if the edited cell in viewport.
                if (startWidth < scrollLeft || endWidth > scrollLeft + viewPortWidth) {
                    if (startWidth < scrollLeft) {
                        left = scrollLeft - (scrollLeft - startWidth) - 3;
                    } else {
                        left = scrollLeft + (endWidth - (scrollLeft + viewPortWidth) + 3);// 3 for slightly adjust the left scrollbar
                    }
                    gridContent.ejScroller("option", { "scrollLeft": left });
                    proxy._updateHeaderScrollLeft(left);
                }
            }
        },
        updateAllowColumnResize: function (bool) {
            var proxy = this,
                model = proxy.model;
            model.allowColumnResize = bool;
            if (model.allowColumnResize)
                proxy._resizer = new ej.gridFeatures.gridResize(proxy);
            proxy._enableColumnResizeEvents();
        },

        //validate predecessor string

        _validatePredecessorString: function (string) {
            var proxy = this, result, values, offsetvalue, match;
            if (string.length > 0) {
                string.split(',').forEach(function (el) {
                    values = el.split('+');
                    offsetvalue = '+';
                    if (el.indexOf('-') >= 0) {
                        values = el.split('-');
                        offsetvalue = '-';
                    }
                    match = values[0].match(/(\d+|[A-z]+)/g);
                    if (match && proxy.model.ids.indexOf(match[0]) != -1) {
                        if (match[1]) {
                            if (match[1].toUpperCase() == 'FS' || match[1].toUpperCase() == 'FF' || match[1].toUpperCase() == 'SF' || match[1].toUpperCase() == 'SS') {
                            }
                            else {
                                result = false;
                            }
                        }
                    } else {
                        result = false;
                    }
                });
            } else {
                return true;
            }
            if (result === undefined || result)
                return true;
            else
                return false;
        },

        //SAVE THE EDITED CELL
        
        saveCell: function () {

            var proxy = this,
                model = proxy.model;

            if ($("#" + proxy._id + "EditForm").length > 0) {

                if (!proxy.editFormValidate()) return true;

                if (proxy._cellEditingDetails.columnIndex >= 0) {
                    proxy._focusTreeGridElement();

                    var $form = $("#" + proxy._id + "EditForm"),
                        recordIndex = model.allowPaging ? proxy._updatedPageData.indexOf(proxy._cellEditingDetails.data) : model.updatedRecords.indexOf(proxy._cellEditingDetails.data),
                        $targetTr = ej.TreeGrid.getRowByIndex(this, recordIndex),
                        $targetTd = $form.closest("td"),
                        formattedValue, args = {},
                        column = model.columns[proxy._cellEditingDetails.columnIndex],
                        $element = $("#" + proxy._id + proxy._cellEditingDetails.fieldName.split('.').join("")),
                        cellElement;

                    args = {
                        columnName: column.field,
                        value: proxy.getCurrentEditCellData(),
                        data: proxy._cellEditingDetails.data,
                        previousValue: proxy._cellEditingDetails.cellValue,
                        columnObject: column,
                        cellElement: $targetTd,
                        rowElement: $targetTr,
                    };

                    if (proxy._cellEditingDetails.cellEditType == "datetimepicker" ||
                        proxy._cellEditingDetails.cellEditType == "dropdownedit" ||
                        proxy._cellEditingDetails.cellEditType == "datepicker") {

                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");

                    }

                    if (!ej.isNullOrUndefined(column.format)) {

                        formattedValue = proxy.formatting(column.format, args.value, model.locale);
                        args.cellElement.empty().html(formattedValue);

                    } else {

                        if (args.columnObject.type == "boolean") {

                            var cellData = {};
                            cellData[args.columnObject.field] = args.value;
                            args.cellElement.empty().html(
                                $($.templates.Grid_JSONTemplate.render(cellData))[0].cells[proxy._cellEditingDetails.columnIndex].innerHTML
                            );

                        } else if (args.columnObject.field == "notesText") {
                            args.cellElement.empty().html(proxy._convertHtml(args.value));
                        }
                        else args.cellElement.empty().html(args.value);
                    }

                    var isValueModified = ((proxy._cellEditingDetails.cellEditType == "datepicker" ||
                            proxy._cellEditingDetails.cellEditType == "datetimepicker") &&
                        args.value instanceof Date && args.previousValue instanceof Date) ?
                        (args.value.getTime() !== args.previousValue.getTime()) :
                        (args.value !== args.previousValue);

                    model.isEdit = false;

                    var fieldName = proxy._cellEditingDetails["fieldName"];

                    //To avoid duplicate ID for TreeGrid on self reference while editing ID value
                    if (!model.isFromGantt && model.idMapping && model.parentIdMapping && fieldName == model.idMapping) {
                        if (proxy._validateIdValue(args.value)) {
                            args.value = args.previousValue
                            isValueModified = false;
                        }
                    }

                    if (model.isFromGantt && fieldName === "taskMode") {
                        isValueModified = (args.value !== args.previousValue) ? true : false;
                    }
                    //check start or end date value is changed on cell edit in Gantt
                    if (model.isFromGantt && args.value && (fieldName === "startDate" || fieldName === "endDate")) {
                        if (this.getFormatedDate(args.value) == this.getFormatedDate(args.data[fieldName])) {
                            isValueModified = false;
                        }
                    }

                    if (model.isFromGantt && fieldName === "predecessor") {

                        var eventArg = {}, stringResult, logicResult;
                        args.value = args.value.trim();
                        stringResult = proxy._validatePredecessorString(args.value);
                        if (stringResult) {
                            eventArg.predecessorString = args.value.split(',');
                            eventArg.currentRecord = args.data;
                            eventArg.requestType = "validatePredecessor";
                            proxy._trigger("actionComplete", eventArg);
                            logicResult = eventArg.result;
                            if (!logicResult) {
                                args.value = args.previousValue;
                            }
                        }
                        else {
                            args.value = args.previousValue;
                        }
                        var ganttPredecessor = [],
                        prevPredecessors = [],
                        modifiedPredecessors = [],
                        count = 0,
                        length, predecessor;
                        args.previousValue = args.data.predecessor;
                        prevPredecessors = args.previousValue;
                        if (args.value.length > 0) {
                            modifiedPredecessors = args.data._calculatePredecessor(args.value, model.durationUnitEditText, model.durationUnit);
                        }
                        length = modifiedPredecessors.length;
                        var index = 0,
                            prevPrdecessorlength = args.previousValue && args.previousValue.length;
                        for (index = 0; index < prevPrdecessorlength; index++) {
                            predecessor = prevPredecessors[index];
                            if (predecessor.from === args.data.taskId.toString()) {
                                ganttPredecessor.push(predecessor);
                            }
                        }
                        for (count = 0; count < length; count++) {
                            ganttPredecessor.push(modifiedPredecessors[count]);
                        }
                        args.data[proxy._cellEditingDetails["fieldName"]] = ganttPredecessor;
                        args.data.item[model.predecessorMapping] = args.value;
                        args.data.predecessorsName = args.value;
                        if (model.enableWBS && model.enableWBSPredecessor)
                            proxy.updateWBSPredecessor(args.data);

                    } else if (model.isFromGantt && fieldName === "duration") {
                        //validate text from duration field
                        var val = args.value,
                        duration = args.data.duration,
                        durationUnit = args.data.durationUnit;

                        var values = val.match(/(\d*\.*\d+|[A-z]+)/g);
                        if (values && values.length <= 2) {
                            duration = parseFloat(values[0]);
                            durationUnit = values[1] ? values[1].toLowerCase() : "";
                            if (model.durationUnitEditText.minute.indexOf(durationUnit) != -1)
                                durationUnit = ej.Gantt.DurationUnit.Minute;
                            else if (model.durationUnitEditText.hour.indexOf(durationUnit) != -1)
                                durationUnit = ej.Gantt.DurationUnit.Hour;
                            else if (model.durationUnitEditText.day.indexOf(durationUnit) != -1)
                                durationUnit = ej.Gantt.DurationUnit.Day;
                            else
                                durationUnit = model.durationUnit;
                        }
                        if (!isNaN(duration)) {
                            args.data.item[model.durationMapping] = args.data.duration = duration;
                            args.data.durationUnit = durationUnit;
                        } else {
                            args.data.item[model.durationMapping] = args.previousValue;
                        }

                    } else if (isValueModified) {
                        if (model.isFromGantt) {

                            switch (fieldName) {

                                case "taskId":
                                    args.data.item[model.idMapping] = args.value;
                                    break;
                                case "taskName":
                                    args.data.item[model.taskNameMapping] = args.value;
                                    break;
                                case "startDate":
                                    if (!args.value)
                                        args.value = args.previousValue;
                                    args.data.item[model.startDateMapping] = args.value;
                                    break;
                                case "endDate":
                                    if (!args.value)
                                        args.value = args.previousValue;
                                    args.data.item[model.endDateMapping] = args.value;
                                    break;
                                case "resourceInfo":
                                    args.data.item[model.resourceInfoMapping] = proxy._getResourceId(args.value);
                                    break;
                                    //case "duration":
                                    //    args.data.item[model.durationMapping] = args.value;
                                    //    break;
                                case "status":
                                    args.data.item[model.progressMapping] = args.value;
                                    break;
                                case "notesText":
                                    args.data.item[model.notesMapping] = args.value;
                                    args.data["notes"] = args.value;
                                    args.data["notesText"] = args.value;
                                    break;
                                case "taskMode":
                                    args.data.item[model.taskSchedulingModeMapping] = args.value;
                                    args.data["isAutoSchedule"] = args.value == true ? false : true;
                                    break;
                                case "work":
                                    if (model.workMapping)
                                        args.data.item[model.workMapping] = args.value;
                                    else
                                        args.data.item[proxy._cellEditingDetails.fieldName] = args.value;
                                    break;
                                case "baselineStartDate":
                                    args.data.item[model.baselineStartDateMapping] = args.value;
                                    break;
                                case "baselineEndDate":
                                    args.data.item[model.baselineEndDateMapping] = args.value;
                                    break;
                                default:
                                    args.data.item[proxy._cellEditingDetails.fieldName] = args.value;
                                    break;
                            }

                        } else {
                            var splits = (proxy._cellEditingDetails.fieldName || "").split(".")
                            if (splits <= 1)
                                args.data.item[proxy._cellEditingDetails.fieldName] = args.value;
                            else
                                args.data.item = proxy._restoreCustomData(args.data.item, args.value);
                        }
                        var splits = (proxy._cellEditingDetails.fieldName || "").split(".")
                        if (splits <= 1)
                            args.data[proxy._cellEditingDetails.fieldName] = args.value;
                        else
                            args.data = proxy._restoreCustomData(args.data, args.value);
                        
                    }

                    if (model.isFromGantt && (args.columnName === "startDate" ||
                        args.columnName === "endDate" ||
                        args.columnName === "duration" ||
                        (args.columnName === "taskMode" && isValueModified) ||
                        args.columnName === "predecessor" ||
                        args.columnName == "status") ||
                        args.columnName == "baselineStartDate" ||
                        args.columnName == "baselineEndDate") {

                        args.isModified = true;

                    }
                    if (this._frozenColumnsLength > 0) {
                        if (!model.allowSelection)
                            args.data.isSelected = false;
                        if (proxy._cellEditingDetails.columnIndex < this._frozenColumnsLength)
                            cellElement = $($.render[proxy._id + "_JSONFrozenTemplate"](args.data))[0].cells[proxy._cellEditingDetails.columnIndex];
                        else
                            cellElement = $($.render[proxy._id + "_Template"](args.data))[0].cells[(proxy._cellEditingDetails.columnIndex - this._frozenColumnsLength)];
                    } else {
                        if (!model.allowSelection)
                            args.data.isSelected = false;
                        cellElement = $($.render[proxy._id + "_Template"](args.data))[0].cells[proxy._cellEditingDetails.columnIndex];
                    }
                    args.cellElement.removeClass("e-editedcell").replaceWith(cellElement);
                    args.cellElement = $(cellElement);
                    /* refresh details Row */
                    if (model.showDetailsRow && !model.showDetailsRowInfoColumn && model.detailsTemplate) {
                        this._refreshDetailsRow(model.currentViewData.indexOf(args.data));
                    }

                    proxy._trigger("refresh");
                    if (!args.data.treeMappingName)
                        args.data.treeMappingName = [];
                    args.data.treeMappingName.push(args.columnName);
                    if (proxy._trigger("endEdit", args)) {
                        args.data[args.columnName] = args.previousValue;
                        args.data.item[args.columnObject.field] = args.previousValue;
                        proxy.selectRows(this.selectedRowIndex());
                        ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(args.data));
                    }
                   
                    proxy._cellEventTrigger(args.cellElement[0], args.data, args.columnObject);
                    $targetTr.removeClass("e-editedrow");

                    if (model.showSummaryRow) {
                        args.editType = "celledit";
                        proxy._updateSummaryRow(args);
                    }
                    if (model.showTotalSummary) {
                        args.editType = "celledit";
                        proxy._updateTotalSummaryRow(args);
                    }
                    proxy._cancelSaveTools();
                    var colObject = args.columnObject;
                    if (model.allowFiltering && colObject && model.filterSettings.filterType == "filterbar" && colObject.filterEditType == "dropdownedit" && colObject.editType != "dropdownedit")
                        proxy._resizeFilteringElements();
                }
            }
            return false;
        },

        
        /*Update WBS predecessors value*/
        updateWBSPredecessor: function (preData) {
            var proxy = this,
                model = proxy.model,
                prdc = preData["predecessorsName"],
                wbspred = null;
            if (prdc && prdc.length > 0) {
                var prdcList = prdc.split(',');
                for (var p = 0; p < prdcList.length; p++) {
                    var ref = prdcList[p].match(/(\d+|[A-z]+)/g),
                        refId = +ref[0],
                        refType = ref[1],
                        refRecord;
                    refRecord = model.flatRecords.filter(function (record) {
                        return record && record.taskId == refId;
                    });
                    var newOne;
                    if (refType)
                        newOne = refRecord[0] && refRecord[0]["WBS"] + refType;
                    else
                        newOne = refRecord[0] && refRecord[0]["WBS"];
                    wbspred = wbspred ? (wbspred + "," + newOne) : newOne;
                }
                preData["WBSPredecessor"] = wbspred;
                preData["item"]["WBSPredecessor"] = wbspred;
            }
            else {
                preData["WBSPredecessor"] = "";
                preData["item"]["WBSPredecessor"] = "";
            }
        },

        //GET THE CURRENT CELL DATA
        getCurrentEditCellData: function () {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                column, cellDate;

            if ($("#" + proxy._id + "EditForm").length) {

                var $element = $("#" + proxy._id + proxy._cellEditingDetails.fieldName.split('.').join("")),
                    cellValue;
                column = columns[proxy._cellEditingDetails.columnIndex];
                switch (proxy._cellEditingDetails.cellEditType) {

                    case ej.TreeGrid.EditingType.String:
                        cellValue = $element.val();
                        break;

                    case ej.TreeGrid.EditingType.Numeric:
                        cellValue = parseFloat($element.val());
                        if ((model.isFromGantt && (column.field == "work" || column.field == "status" || column.field == "duration") || column.field == "unit")) {
                            cellValue = isNaN(cellValue) ? proxy._cellEditingDetails.cellValue : cellValue;
                        } else {
                            cellValue = $element.ejNumericTextbox("model.value");
                        }
                        break;

                    case ej.TreeGrid.EditingType.Maskedit:
                        cellValue = $element.ejMaskEdit("model.value");
                        break;
                    case ej.TreeGrid.EditingType.Dropdown:
                        if (model.isFromGantt && proxy._cellEditingDetails.fieldName === "resourceInfo") {
                            cellValue = proxy._getSelectedItem($element.ejDropDownList("model.selectedItems"));
                        }
                        else if (model.isFromGantt && proxy._cellEditingDetails.fieldName === "taskMode") {
                            cellValue = $element.ejDropDownList("model.value") == "true" ? true : false;
                        }
                        else
                            cellValue = $element.ejDropDownList("model.value");
                        break;

                    case ej.TreeGrid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:
                        if (column && !column.format) {
                            cellValue = ej.format($element.ejDatePicker("model.value"), this.model.dateFormat, this.model.locale)
                        }
                        else {
                            cellValue = $element.ejDatePicker("model.value");
                        }
                        if (cellValue == "" && model.isFromGantt)
                            cellValue = proxy._cellEditingDetails.cellValue;
                        break;

                    case ej.TreeGrid.EditingType.DateTimePicker:

                        var dateTimePickerValue = $element.ejDateTimePicker("model.value"),
                            dateTimePickerFormat = $element.ejDateTimePicker("model.dateTimeFormat"),
                            dateTimePickerLocale = $element.ejDateTimePicker("model.locale"),
                            tempValue;

                        if (column && !column.format) {
                            cellValue = ej.format($element.ejDateTimePicker("model.value"), this.model.dateFormat, this.model.locale)
                        }
                        else {
                            cellValue = $element.ejDateTimePicker("model.value");
                        }
                        cellDate = ej.format($element.val(), dateTimePickerFormat, dateTimePickerLocale);
                        tempValue = ej.format(dateTimePickerValue, dateTimePickerFormat, dateTimePickerLocale);
                        if (cellDate !== tempValue && model.isFromGantt)
                            cellValue = proxy._cellEditingDetails.cellValue;
                        break;
                    case "edittemplate":
                        var temp1 = column.editTemplate.read;
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        cellValue = temp1($element);
                        break;

                }
                if (typeof cellValue == "string" && cellValue.length &&
                    model.columns[proxy._cellEditingDetails.columnIndex].type == "number") {

                    cellValue = parseFloat(cellValue);

                }

                return cellValue;
            }

            return null;
        },
        //Get the value from edited row

        getCurrentEditCellDataForRowEdit: function (field,type,cellIndex) {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                column, field = field.split('.').join(""), length, $element, isDialogEdit;
            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                length = $("#" + proxy._id + "EditFormDialog").length;
                $element = $("#" + proxy._id + field);
                isDialogEdit = true;
            } else {
                length = $("#" + proxy._id + "EditForm").length;
                $element = $("#" + proxy._id + field);
            }

            if (length) {

                var cellValue, dateValue;
                column = columns[cellIndex];

                switch (type) {

                    case ej.TreeGrid.EditingType.String:
                        cellValue = $element.val();
                        break;

                    case ej.TreeGrid.EditingType.Numeric:
                        cellValue = parseFloat($element.val());
                        if ($element.data("ejNumericTextbox"))
                            cellValue = $element.ejNumericTextbox("model.value");
                        else
                            cellValue = cellValue;
                        break;

                    case ej.TreeGrid.EditingType.Dropdown:
                        if ($element.data("ejDropDownList"))
                            cellValue = $element.ejDropDownList("model.value");
                        else
                            cellValue = $element.val();
                        if (!isDialogEdit)
                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                        break;

                    case ej.TreeGrid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:

                        if ($element.hasClass("e-datepicker")) {
                            if (model.dateFormat.toLowerCase().indexOf("hh") == -1)
                                dateValue = $element.ejDatePicker("model.value");
                            else {
                                dateValue = $element.ejDateTimePicker("model.value");
                            }
                        } else {
                           dateValue = $element.val();
                        }

                        if (column && !column.format) {
                            cellValue = proxy.getFormatedDate(dateValue);
                        }
                        else {
                            cellValue = dateValue;
                        }
                       
                        if (!isDialogEdit)
                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                        break;

                    case ej.TreeGrid.EditingType.DateTimePicker:

                        if ($element.hasClass("e-datetimepicker")) {
                            if (column && !column.format) {
                                cellValue = ej.format($element.ejDateTimePicker("model.value"), this.model.dateFormat, this.model.locale)
                            }
                            else {
                                cellValue = $element.ejDateTimePicker("model.value");
                            }
                        } else {
                            cellValue = $element.val();
                        }
                        if (!isDialogEdit)
                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                        break;

                    case ej.TreeGrid.EditingType.Maskedit:
                        cellValue = $element.ejMaskEdit("model.value");
                        break;
                    case "edittemplate":
                        var temp1 = column.editTemplate.read;
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        cellValue = temp1($element);
                        break;

                }
                if (typeof cellValue == "string" && cellValue.length &&
                    model.columns[cellIndex].type == "number") {
                    cellValue = parseFloat(cellValue);
                }

                return cellValue;
            }

            return null;
        },

        _getResourceId:function(dataSource){

            var resourceIds = [],
                count = 0, length = dataSource.length;

            for (count = 0; count < length; count++) {
                resourceIds.push(dataSource[count][this.model.resourceIdMapping]);
            }
            return resourceIds;
        },

        _getSelectedItem: function (indexArray) {

            var proxy = this, model = proxy.model,
                count = 0, index, 
                length = indexArray.length,
                resourceUnitMapping = model.resourceUnitMapping,
                resourceIdMapping = model.resourceIdMapping,
                dropDownData = model.columns[proxy._cellEditingDetails.columnIndex].dropdownData,
                selectedItemResourceInfo = model.selectedItem.resourceInfo,
                selectedItems = [];

            if (dropDownData) {

                for (count = 0; count < length; count++) {                    
                    if (selectedItemResourceInfo) {
                        for (var newIndex = 0; newIndex < selectedItemResourceInfo.length; newIndex++) {
                            if (selectedItemResourceInfo[newIndex][resourceIdMapping] === indexArray[count] + 1) {
                                index = newIndex;
                                break;
                            }
                            else
                                index = -1;
                        }
                    }
                    if (!ej.isNullOrUndefined(index) && index != -1)
                        selectedItems.push(selectedItemResourceInfo[index]);
                    else {
                        $.each(dropDownData, function (index, resourceInfo) {
                            if (indexArray[count] === index) {
                                var ganttRecordResource = $.extend({}, resourceInfo);
                                ganttRecordResource[resourceUnitMapping] = 100;
                                selectedItems.push(ganttRecordResource);
                            }
                        });
                    }
                }
            }

            return selectedItems;
        },       
        //GET THE FORMATED DATE 
        getFormatedDate: function (date) {
            return ej.format(date, this.model.dateFormat, this.model.locale);
        },
        //Get formated string from date object
        getDateFromFormat: function (date) {

            if (typeof date === "object") {
                return new Date(date);
            }
            if (date) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale) == null ?
                    new Date(date) : ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
        },

        //GET THE FORMATTED TEXT
        formatting: function (formatstring, str, locale) {
            formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
            locale = ej.preferredCulture[locale] ? locale : "en-US";
            var s = formatstring;
            var frontHtmlidx, FrontHtml, RearHtml, lastidxval;
            frontHtmlidx = formatstring.split("{0:");
            lastidxval = formatstring.split("}");
            FrontHtml = frontHtmlidx[0];
            RearHtml = lastidxval[1];
            if (typeof (str) == "string" && $.isNumeric(str))
                str = Number(str);
            if (formatstring.indexOf("{0:") != -1) {
                var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                var formatVal = toformat.exec(formatstring);
                if (formatVal != null && str != null) {
                    if (FrontHtml != null && RearHtml != null)
                        str = FrontHtml + ej.format(str, formatVal[2], locale) + RearHtml;
                    else
                        str = ej.format(str, formatVal[2], locale);
                } else if (str != null)
                    str = str;
                else
                    str = "";
                return str;
            } else if (this.data != null && this.data.Value == null) {
                $.each(this.data, function (dataIndex, dataValue) {
                    s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
                });
                return s;
            } else {
                return this.data.Value;
            }
        },


        //GET THE COLUMNINDEX BY USIGN THE FIELD NAME
        getColumnIndexByField: function (fieldName) {

            var proxy = this,
                columns = proxy.model.columns,
                length = columns.length,
                column = 0;

            for (column; column < length; column++) {
                if (columns[column]["field"] == fieldName)
                    break;
            }

            return column == columns.length ? -1 : column; // if field name not available in columns collection, it return -1 value.
        },

        getUpNextVisibleColumnIndex: function (index, action) {
            var proxy = this, columns = proxy.model.columns;
            if (!index)
                index = 0;
            for (index; index <= columns.length; index++) {
                if (index == columns.length && (action == "rightArrow" || action == "moveCellRight")) {
                    index = 0;
                    proxy._focusingRowIndex += 1;
                }
                if (columns[index].visible && columns[index].allowCellSelection)
                    return columns.indexOf(columns[index]);
            }
        },
        getPreviousVisibleColumnIndex: function (index, action) {
            var proxy = this, columns = proxy.model.columns;
            if (!index)
                index = columns.length - 1;
            for (index; index < columns.length; index--) {
                if (index < 0 && (action == "leftArrow" || action == "moveCellLeft")) {
                    index = columns.length - 1;
                    proxy._focusingRowIndex -= 1;
                }
                if (columns[index].visible && columns[index].allowCellSelection)
                    return columns.indexOf(columns[index]);
            }
        },
        //GET THE BROWSER DETAILS
        getBrowserDetails: function () {
            var b = navigator.userAgent.match(/(firefox|chrome|opera|msie|safari)\s?\/?(\d+(.\d+)*)/i);
            if (!!navigator.userAgent.match(/Trident\/7\./))
                return { browser: "msie", version: jQuery.uaMatch(navigator.userAgent).version };
            return { browser: b[1].toLowerCase(), version: b[2] };
        },

        //Check whether the Browser is Mobile Device's or not.
        mobileDevice: function () {
            if (navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/webOS/i)
                || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i)
                || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/BlackBerry/i)
                || navigator.userAgent.match(/Windows Phone/i)) {
                return true;
            }
            else {
                return false;
            }
        },


        //GET THE FIELDNAME OF COLUMN BY USING THE HEADERTEXT
        getFieldNameByHeaderText: function (headerText) {

            var proxy = this;

            if (ej.isNullOrUndefined(proxy._fieldColumnNames[headerText])) return null;

            return proxy._fieldColumnNames[headerText];
        },


        //CLEAR THE SELECTION

        

        clearSelection: function (index) {

            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords();

            if (this.selectedRowIndex() != -1 || (this.selectedRowIndex() == -1 && proxy._previousIndex != -1) || index == -1) {
                                                 //To clear the row selection of previously selected row via set model (selectedRowIndex)
                var $gridRows,
                    index;
                if (this._frozenColumnsLength) {
                    $gridRows = $(proxy.getRows()[0]).add(proxy.getRows()[1]);
                } else {
                    $gridRows = proxy.getRows();
                }     
                if (!ej.isNullOrUndefined(index) && index != -1) {
                    ej.TreeGrid.getRowByIndex(proxy, index).find(".e-selectionbackground").removeClass("e-selectionbackground").removeClass("e-active");
                    var record = updatedRecords[index];
                    record && (record.isSelected = false);
                    }
                else {

                    if ($gridRows) {
                        $gridRows.find(".e-rowcell,.e-detailsrowcell").removeClass("e-selectionbackground").removeClass("e-active");
                    }
                    var dataManager = new ej.DataManager(model.flatRecords);

                    var query = new ej.Query();
                    query.search(true, ['isSelected'], ej.FilterOperators.Equals, true);

                    var records = dataManager.executeLocal(query);
                    var length = records && records.length;

                    if (length > 0) {

                        var count = 0;

                        for (count = 0; count < length; count++) {
                            records[count].isSelected = false;                            
                        }

                    }
                }

                if (proxy._checkboxSelection) {
                    proxy.selectedRowIndex(-1);
                    model.selectedItem = null;              
                    proxy._cancelSaveTools();
                }
                //Clearing the selected item and index while clearing the row selection itself
                else if (!model.selectedItems.length || (model.selectedItems.length && !proxy._multiSelectCtrlRequest) || index == -1) {
                    proxy.selectedRowIndex(-1);
                    model.selectedItem = null;//For single selection only
                    model.selectedItems = [];
                    proxy._cancelSaveTools();
                }               

                if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible") && !$gridRows.find(".e-rowcell,.e-detailsrowcell").hasClass("e-selectionbackground") && !$("#" + proxy._id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                    proxy._clearMultiSelectPopup();
                }
            }
            if (model.selectionSettings.selectionMode == "cell") {
                proxy._selectedCellDetails = [];
                model.selectedCellIndexes = [];
                $("#" + proxy._id).find(".selectingcell").removeClass("selectingcell");

                proxy._rowIndexOfLastSelectedCell = -1;
                proxy._lastSelectedCellIndex = -1;
                proxy._focusingRowIndex = -1;
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && ej.isNullOrUndefined(index) && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }
        },

        //To hide the selection popup
        _clearMultiSelectPopup: function () {
            var proxy = this;
            $("#" + proxy._id + "_selectionpopup").find(".e-rowselect").removeClass("e-spanclicked");
            proxy._multiSelectPopup.hide();
            proxy._multiSelectCtrlRequest = false;
            proxy._isTouchTrigger = false;
        },

        //COUNT THE CHILDRECORDS COUNT
        getChildRecordsCount: function (record) {

            var proxy = this,
                childRecords = record.childRecords,
                count = 0,
                length = childRecords ? childRecords.length : 0;

            for (count; count < length; count++) {

                if (proxy._filteredRecords.length > 0) {

                    var recordIndex = proxy._filteredRecords.indexOf(childRecords[count]);

                    if (recordIndex != -1) {

                        ++proxy._removedCount;

                        if (childRecords[count].hasChildRecords && childRecords[count].expanded) {
                            proxy.getChildRecordsCount(childRecords[count]);
                        }

                    }
                } else {

                    ++proxy._removedCount;

                    if (childRecords[count].hasChildRecords && childRecords[count].expanded) {
                        proxy.getChildRecordsCount(childRecords[count]);
                    }

                }
            }

            return proxy._removedCount;
        },


        //GET THE EXPAND STATUS OF RECORD
        getExpandStatus: function (record) {

            var parentRecord = record.parentItem;

            if (parentRecord != null) {

                if (parentRecord.expanded === false) {
                    return false;
                } else if (parentRecord.parentItem) {

                    if (parentRecord.parentItem.expanded === false) {
                        return false;
                    } else {
                        return this.getExpandStatus(parentRecord.parentItem);
                    }

                } else return true;
            } else return true;
        },


        //RETURN THE COLUMN FIELD NAMES
        getColumnFieldNames: function () {

            var columnNames = [],
                columns = this.model.columns,
                count = 0,
                length = columns.length;

            for (count; count < length; count++) {

                if (columns[count]["field"] && (columns[count]["field"] != "resourceInfo") && (columns[count]["field"] != "predecessor")) { 
                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "resourceInfo") {
                    
                    columnNames.push("resourceNames");
                }
                else if (columns[count]["field"] == "predecessor")
                {
                    
                    columnNames.push("predecessorsName");
                }

            }

            return columnNames;
        },

        _getColumnMappingNames: function () {

            var columnNames = [],
                columns = this.model.columns,
                count = 0,
                length = columns.length;

            for (count; count < length; count++) {

                if (columns[count]["field"] && (columns[count]["field"] != "resourceInfo") && (columns[count]["field"] != "predecessor")

                    && (columns[count]["field"] != "work") && (columns[count]["field"] != "taskType") && (columns[count]["field"] != "effortDriven")) {
                    columnNames.push(columns[count]["mappingName"]);
                }
                else if (columns[count]["field"] == "resourceInfo") {

                    columnNames.push("resourceNames");
                }
                else if (columns[count]["field"] == "work") {

                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "taskType") {

                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "effortDriven") {

                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "predecessor") {

                    columnNames.push("predecessorsName");
                }

            }

            return columnNames;
        },

        //RENDERED  RECORDS
        renderRecords: function (args) {

            var proxy = this,
                model = proxy.model;

            if (!args) {

                args = {};
                if (!model.isFromGantt && model.enableCollapseAll) {
                    args.requestType = ej.TreeGrid.Actions.ExpandCollapse;                   
                    proxy._isInExpandCollapseAll = true;                                    
                }
                else
                    args.requestType = ej.TreeGrid.Actions.Refresh;

            }

            this.sendDataRenderingRequest(args);
            proxy._isInExpandCollapseAll = false;
        },       

        _shiftKeySelectCells: function (args, targetIndex) {
            var proxy = this, model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                //Get First Row Details for shift key functions.
                firstRowElementIndex = proxy._shiftKeyFirstElementDetails.firstElementRowIndex,
                firstRowCellIndex = ej.isNullOrUndefined(proxy._shiftKeyFirstElementDetails.firstElementCellIndex) ? -1 : 
                                    proxy._shiftKeyFirstElementDetails.firstElementCellIndex,
                secondRowElementIndex = args.rowIndex,
                secondRowCellIndex = args.cellIndex,
                shiftKeyRowIndexes = [firstRowElementIndex, secondRowElementIndex],
                shiftKeyCellIndexes = [firstRowCellIndex, secondRowCellIndex];

            //Sort the two Selected row and cell Indexes.
            shiftKeyRowIndexes.sort(function (a, b) {
                return (a - b);
            });
            shiftKeyCellIndexes.sort(function (a, b) {
                return (a - b);
            });
            proxy._isShiftKeyNavigation = true;
            proxy._selectedCellDetails = [];
            model.selectedCellIndexes = [];
            $("#" + proxy._id).find(".selectingcell").removeClass("selectingcell");

            for (var rowIndex = shiftKeyRowIndexes[0]; rowIndex <= shiftKeyRowIndexes[1]; rowIndex++) {
                var record = updatedRecords && updatedRecords[rowIndex],
                    currentRowIndex = model.currentViewData.indexOf(record);
                if (ej.isNullOrUndefined(record) || record.isSummaryRow)
                    continue;
                for (var cellIndex = shiftKeyCellIndexes[0]; cellIndex <= shiftKeyCellIndexes[1]; cellIndex++) {
                    proxy.selectCells([{ rowIndex: rowIndex, cellIndex: cellIndex }]);
                }
            }
        },

        selectCells: function (indexes, preservePreviousSelectedCells) {
            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                $gridRows = proxy.getRows(), $targetRow, targetCell, record, length = indexes.length, columns=model.columns;

            if (model.selectionSettings.selectionType == "single")
                length = 1;
            if ((!preservePreviousSelectedCells || ej.isNullOrUndefined(preservePreviousSelectedCells)) &&
                proxy._isShiftKeyNavigation == false) {
            proxy._selectedCellDetails = [];
                model.selectedCellIndexes = [];
            $("#" + proxy._id).find(".selectingcell").removeClass("selectingcell");
            }
            if (model.selectionSettings.selectionMode == "cell" && model.allowSelection && $gridRows.length > 0) {
                for (var index = 0; index < length; index++) {
                    if (indexes[index].rowIndex == -1)
                        continue;
                    var record = updatedRecords && updatedRecords[indexes[index].rowIndex],
                        currentRowIndex = model.currentViewData.indexOf(record);
                    if (record.isSummaryRow)
                        continue;
                    var frozenColumnRowIndex = indexes[index].cellIndex >= proxy._frozenColumnsLength ? 1 : 0,
                       targetCellIndex = indexes[index].cellIndex >= proxy._frozenColumnsLength ? indexes[index].cellIndex - proxy._frozenColumnsLength : indexes[index].cellIndex;
                    if (proxy._frozenColumnsLength > 0) {
                        $targetRow = $gridRows[frozenColumnRowIndex][currentRowIndex];
                    }
                    else
                        $targetRow = $gridRows[currentRowIndex];

                    if (!ej.isNullOrUndefined(record) && ej.isNullOrUndefined($targetRow))
                        $targetRow = $($.render[proxy._id + "_Template"](record))[0];

                    targetCell = $targetRow.childNodes[targetCellIndex];
                    if (indexes[index].cellIndex != -1 && columns[indexes[index].cellIndex].allowCellSelection && columns[indexes[index].cellIndex].visible &&
                           !proxy._cellSelectingEventTrigger({ rowIndex: indexes[index].rowIndex, cellIndex: indexes[index].cellIndex, rowElement: $targetRow, cellElement: targetCell })) {
                        $(targetCell).addClass("selectingcell");

                        var selectedCellInfo = {
                            rowIndex: indexes[index].rowIndex,
                            cellIndex: indexes[index].cellIndex,
                            cellElement: targetCell,
                            data: record
                        };
                        var currentCellIndex;
                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                            currentCellIndex = proxy._getCellIndex(proxy._selectedCellDetails, "cellElement").indexOf(targetCell);
                        else
                            currentCellIndex = proxy._selectedCellDetails.map(function (e) { return e.cellElement; }).indexOf(targetCell);

                        
                        if (currentCellIndex == -1) {
                            proxy._selectedCellDetails.push(selectedCellInfo);
                            model.selectedCellIndexes.push({ rowIndex: selectedCellInfo.rowIndex, cellIndex: selectedCellInfo.cellIndex });
                        }
                        proxy._cellSelectedEventTrigger({ rowIndex: indexes[index].rowIndex, cellIndex: indexes[index].cellIndex, rowElement: $targetRow, cellElement: targetCell }, proxy._previousSelectedCellDetails);
                        proxy._previousSelectedCellDetails = {
                            rowElement: $targetRow,
                            cellElement: targetCell,
                            cellIndex: indexes[index].cellIndex,
                            rowIndex: indexes[index].rowIndex,
                        }
                        proxy._updateHorizontalScrollBar(columns[indexes[index].cellIndex].field);
                    }
                }
            }
            if (proxy._isShiftKeyNavigation == false) {
            //For selecting multiple cells with Shift key.
            proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
            proxy._shiftKeyFirstElementDetails.firstElementCellIndex = proxy._cellIndex;
            //Get back Default values for key board navigation.           
            proxy._rowIndexOfLastSelectedCell = selectedCellInfo ? selectedCellInfo.rowIndex : proxy._rowIndexOfLastSelectedCell;
            proxy._lastSelectedCellIndex = proxy._cellIndex;
            }
        },

        //SELECT THE ROW IN TREEGRID
        selectRows: function (rowIndex, toIndex, isCheckbox) {

            var proxy = this,
                model = proxy.model;

            var $gridRows = proxy.getRows(),
            selectedItem;
            if (model.selectionSettings.selectionMode == "cell" && rowIndex != -1)
                return;
            if (ej.TreeGrid.getRowByIndex(proxy, rowIndex).hasClass("e-summaryrow"))
                return;
            if ((model.editSettings.allowEditing || model.editSettings.allowAdding) && !proxy._isRowEdit && model.editSettings.beginEditAction != "click") {
                if ($("#" + proxy._id + "EditForm").length > 0 && proxy.endEdit()) {
                    $gridRows = proxy.getRows();
                    return;
                }
            }
            if (this._frozenColumnsLength > 0)
                $gridRows = $(proxy.getRows()[0]);

             var updatedRecords = proxy.getUpdatedRecords();

            if (ej.isNullOrUndefined(toIndex) || ej.isNullOrUndefined(rowIndex)) {

                rowIndex = ej.isNullOrUndefined(rowIndex) ? toIndex : rowIndex;        

                switch (model.selectionSettings.selectionType) {

                    case ej.TreeGrid.SelectionType.Checkbox:
                        var currentRecord = updatedRecords[rowIndex];

                        proxy.clearSelection(-1)
                        if (isCheckbox) {
                            var checkboxState = (currentRecord.checkboxState == "unchecked") ? "checked" : "unchecked";
                            proxy._traverseSelection(currentRecord, checkboxState, false);
                            proxy.selectAllRows();
                        }

                        if (updatedRecords[rowIndex] && !updatedRecords[rowIndex].isSelected) {
                            if (model.allowSelection)
                                ej.TreeGrid.getRowByIndex(proxy, rowIndex).find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active");
                            updatedRecords[rowIndex].isSelected = true;
                            model.selectedItem = updatedRecords[rowIndex];
                        }
                        if (proxy._prevSelectedItem && proxy._prevSelectedItem != model.selectedItem) {
                            proxy._prevSelectedItem.isSelected = false;
                        }



                        proxy._prevSelectedItem = updatedRecords[rowIndex];
                        this.selectedRowIndex(rowIndex);
                        return false;                                                    
                        case ej.TreeGrid.SelectionType.Multiple:                        

                            if (proxy._multiSelectCtrlRequest) {
                            var currentRecord = updatedRecords[rowIndex],
                            selectedRowIndex = $.inArray(currentRecord, model.selectedItems);
                            proxy._prevSelectedItem = updatedRecords[rowIndex];
                                if (selectedRowIndex != -1) {
                                    proxy.clearSelection(rowIndex);
                                model.selectedItems.splice(selectedRowIndex, 1);
                                currentRecord.isSelected = false;
                                model.selectedItem = model.selectedItems.length > 0 ? model.selectedItems[model.selectedItems.length - 1] : null;
                                }

                                if (selectedRowIndex == -1) {
                                model.selectedItems.push(currentRecord);
                                    if (model.allowSelection)
                                        ej.TreeGrid.getRowByIndex(proxy, rowIndex).attr("aria-selected", "true").find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active").attr("tabindex", "0");
                                currentRecord.isSelected = true;
                                model.selectedItem = updatedRecords[rowIndex];
                                }
                                break;
                            }
                            

                        case ej.TreeGrid.SelectionType.Single:
                            proxy.clearSelection(-1);
                            model.selectedItem = null;
                            if (rowIndex <= updatedRecords.length - 1) {
                            (rowIndex != -1) && model.selectedItems.push(updatedRecords[rowIndex]);
                            proxy._prevSelectedItem = updatedRecords[rowIndex];
                                if (model.allowSelection)
                                    ej.TreeGrid.getRowByIndex(proxy, rowIndex).find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active");
                                if (updatedRecords[rowIndex]) {
                                    updatedRecords[rowIndex].isSelected = true;  //Selection issue Changes
                                    model.selectedItem = updatedRecords[rowIndex];
                                }
                                
                            if (proxy._prevSelectedItem && proxy._prevSelectedItem != model.selectedItem) {
                                proxy._prevSelectedItem.isSelected = false;
                                }

                            }
                            break;
                    }
                if (model.selectedItems.length && model.selectedItems.indexOf(updatedRecords[rowIndex]) != -1) {
                    proxy._prevSelectedItem = updatedRecords[rowIndex];
                    if (this.selectedRowIndex() != rowIndex) {
                        this.selectedRowIndex(rowIndex);
                    }
              
                }
                else if (model.selectedItems.length == 0 && this.selectedRowIndex() != -1) {
                    this.selectedRowIndex(-1);
            } else {
                    this.selectedRowIndex(model.updatedRecords.indexOf(model.selectedItems[model.selectedItems.length - 1]));
                }

            } else {

                if (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Multiple) {
                proxy.clearSelection(-1);
                    proxy.selectedRowIndex(rowIndex);
                    model.selectedItem = model.updatedRecords[rowIndex];
                    var count = 0,
                    records = rowIndex - toIndex < 0 ? updatedRecords.slice(rowIndex, toIndex + 1) : updatedRecords.slice(toIndex, rowIndex + 1),
                    row, updatedRowIndex, tempRows;
                    for (count; count < records.length; count++) {
                        if (proxy.getExpandStatus(records[count])) {
                            records[count].isSelected = true;
                            updatedRowIndex = updatedRecords.indexOf(records[count]);
                            row = ej.TreeGrid.getRowByIndex(proxy, updatedRowIndex);
                    if (this._frozenColumnsLength) {
                                tempRows = $(row[0]).add(row[1]);
                                row = row[0];
                    } else {
                                tempRows = row;
                    }
                            tempRows && $(tempRows).find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active");
                    }
                }

                }
            }

            model.selectedItems = proxy.getSelectedRecords();
            proxy._multiSelectCtrlRequest = false;
            if(model.isFromGantt)
               proxy._cancelSaveTools();
            return false;
        },

        /* Get all selected records from treegrid*/
        getSelectedRecords: function () {
            var proxy = this,
                model = this.model,
                selectedRecords = [];
            selectedRecords = model.updatedRecords.filter(function (record) {
                return record.isSelected;
            });
            return selectedRecords.slice();
        },
        /* Clear all selected rows and cells*/
        clearAllSelection: function () {
            var proxy = this,
                model = this.model;
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }
            proxy.selectRows(-1);
            model.selectedItem = null;

            //To clear cell Selections
            proxy._selectedCellDetails = [];
            model.selectedCellIndexes = [];            
            proxy._rowIndexOfLastSelectedCell = -1;
            proxy._lastSelectedCellIndex = -1;
            proxy._focusingRowIndex = -1;
            $("#" + proxy._id).find(".selectingcell").removeClass("selectingcell");

            proxy._cancelSaveTools();
        },
        //GET THE CURRENTCELLINDEX
        getCellIndex: function (e, target) {

            var $target = $(e.target),
                cellIndex = -1,
                model =this.model;

            if (target) $target = $(target);
            if ($target.hasClass("e-detailsrowcell") || $target.closest("td").hasClass("e-detailsrowcell"))
                return -1;
            if ($target.prop("tagName") == "TD") {
                cellIndex =  $target.index();
            } else if ($target.prop('tagName') == "DIV" && $target.hasClass('e-cell')) {

                var $td = $target.closest('td');
                cellIndex = $td.index();

            } else if ($target.prop('tagName') == "DIV" && $($target.closest('td')[0]).hasClass("e-templatecell")) {

                var $td = $target.closest('td');
                cellIndex = $td.index();
            }
            else if ($($target.closest('td')[0]).hasClass("e-templatecell") && $($target.closest("tr")[0]).hasClass("e-templaterow")) {

                var $td = $target.closest('td');
                cellIndex = $td.index();
            }
            else if ($target.parent().prop("tagName") == "TD") {
                var $td = $target.closest('td');
                cellIndex = $target.parent().index();
            }
            else if ($target.prop("tagName") == "TH" || ($target.prop("tagName") == "DIV" && $($target.closest("th")[0]).css("cursor") == "col-resize")) {
                var $th,
                    $targetElement = $target.prop("tagName") == "TH" ? $($target) : $target.closest("th");
                var location = $target[0].getBoundingClientRect();
                var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
                if (this._orgX < location.left + 5 + scrollLeft)
                    cellIndex = $targetElement.prevAll(":visible:first")[0].cellIndex;
                else
                    cellIndex = $targetElement.index();
            }
            else if ($target.closest("td.e-rowcell").length > 0) {
                var $td = $target.closest('td.e-rowcell');
                cellIndex = $td.index();
            }

            /*get cellIndex with frozen columns*/
            if (cellIndex != -1 && this._frozenColumnsLength > 0 && ($target.closest(".e-movablecontentdiv").length > 0 || $target.closest(".e-movableheaderdiv").length > 0 || $target.closest(".e-movablefooterdiv").length > 0))
                cellIndex += this._frozenColumnsLength;
            return cellIndex;
        },


        //GET THE CURRENT ROW INDEX
        getRowIndex: function (e) {

            var proxy = this,
                $target = $(e.target),
                $gridRows = proxy.getRows(),
                index = -1,
                model = this.model;

            if ($target.closest('.e-gridcontainer').length > 0) {
                if (this._frozenColumnsLength > 0) {
                    if ($target.closest(".e-frozencontentdiv").length > 0 || $target.closest(".e-frozencontainer").length > 0)
                        $gridRows = $($gridRows[0]);
                    else if ($target.closest(".e-movablecontentdiv").length > 0 || $target.closest(".e-movablecontainer").length > 0)
                        $gridRows = $($gridRows[1]);
                }
                index = $gridRows.index($target);
                if (index == -1) {

                    var row = $target.closest('tr');
                    index = $gridRows.index(row);

                }
            }

            return index;
        },

        //Cancel the edited cell and row
        _cancelEditState: function (e) {
            var proxy = this;
            if (!ej.isNullOrUndefined(e)) {
                if (!ej.isNullOrUndefined(e.target))
                    e.stopImmediatePropagation();
                /*Change scrollLeft of content while header is auto scrolled on filtering element focus*/
                var scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft"),
                    headerScrollLeft = 0;
                if (this._frozenColumnsLength > 0)
                    headerScrollLeft = proxy._$gridHeaderContainer.find("#e-movableheader" + this._id).scrollLeft();
                else
                    headerScrollLeft = proxy._$gridHeaderContainer.scrollLeft();
                if (scrollLeft != headerScrollLeft) {
                    proxy.getScrollElement().ejScroller("option", "scrollLeft", headerScrollLeft);
                    if (proxy.model.showTotalSummary && proxy._$footerContainer) {
                        if (this._frozenColumnsLength > 0)
                            proxy._$footerContainer.find("#e-movablefooter" + this._id).scrollLeft(headerScrollLeft);
                        else
                            proxy._$footerContainer.scrollLeft(headerScrollLeft);
                    }
                }
            }
            if (proxy.model.isEdit)
                proxy.cancelEditCell();
            else if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
        },

        //cancel the editMode of the cell
        cancelEditCell: function (e) {

            var proxy = this,
                model = proxy.model,
                tr,
                data = proxy.model.selectedItem,
                cell, cellIndex = proxy._cellEditingDetails.columnIndex,
                args = {}, column = model.columns[cellIndex];
            if (model.isFromGantt && !model.isEdit)
                return true;
            args = {
                columnName: column.field,
                value: proxy.getCurrentEditCellData(),
                data: proxy._cellEditingDetails.data,
                previousValue: proxy._cellEditingDetails.cellValue,
                columnObject: column,                
            };
            if (this._frozenColumnsLength > 0) {
                if (this._frozenColumnsLength <= proxy._cellEditingDetails.columnIndex) {
                    cellIndex = proxy._cellEditingDetails.columnIndex - this._frozenColumnsLength;
                    tr = $(proxy.getRows()[1])[proxy._cellEditingDetails.rowIndex];
                    if ($(tr).hasClass("e-editedrow"))
                        $(tr).removeClass("e-editedrow");
                    cell = tr.cells[cellIndex];
                    $(cell).removeClass("e-editedcell").empty().html(
                       $($.render[proxy._id + "_Template"](args.data))[0].cells[cellIndex].innerHTML
                    );
                } else {
                    tr = $(proxy.getRows()[0])[proxy._cellEditingDetails.rowIndex];
                    if ($(tr).hasClass("e-editedrow"))
                        $(tr).removeClass("e-editedrow");
                    cell = tr.cells[cellIndex];
                    $(cell).removeClass("e-editedcell").empty().html(
                      $($.render[proxy._id + "_JSONFrozenTemplate"](args.data))[0].cells[cellIndex].innerHTML
                    );
                }
            } else {
                tr = $(proxy.getRows())[proxy._cellEditingDetails.rowIndex];
                if ($(tr).hasClass("e-editedrow"))
                    $(tr).removeClass("e-editedrow");
                cell = tr.cells[cellIndex];
                $(cell).removeClass("e-editedcell").empty().html(
                    $($.render[proxy._id + "_Template"](args.data))[0].cells[cellIndex].innerHTML
                );
            }
            proxy._cellEventTrigger($(cell)[0], args.data, args.columnObject);
            proxy.model.isEdit = false;
            proxy._cancelSaveTools();
            proxy._trigger("refresh");
        },

        // To destroy the edit forms and popup menu
        _destroyWidgetElements:function()
        {
            var proxy = this, model = this.model, column = model.columns, columnLength = column.length,
                columnField;
            for (var i = 0; i < columnLength; i++) {
                columnField = proxy._getFieldValue(column[i].field,i);
                var $element = $("#" + proxy._id + columnField);
                $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
            }
        },

        //Cancel row edit.
        cancelRowEditCell: function () {

            var proxy = this, model = this.model,
            //  To delete the empty added row when allowDeleting is false.
            temp = model.editSettings.allowDeleting,
            form = $(document.getElementById(proxy._id + "EditForm")), $tr,
            frozenForm = $("#" + proxy._id + "EditFrozenForm"), $frozenTr;
            if (form.length > 0)
                this._destroyWidgetElements();
            $tr = $(form.closest("tr"));
            $frozenTr = frozenForm.closest("tr");

            var rowIndex = proxy.getIndexByRow($tr),
            data = model.currentViewData[rowIndex];
            if (rowIndex == -1 && form.length == 0)
                return;
            
            if ($tr.hasClass('e-addedrow')) {
                if (!proxy.model.editSettings.allowDeleting)
                    proxy.model.editSettings.allowDeleting = true;
            }
            
            //Cancel the edited row.
            if ($tr.hasClass('e-editedrow')) {
                $tr.removeClass("e-editedrow").empty().html(
                    $($.render[proxy._id + "_Template"](data))[0].innerHTML);
                if ($frozenTr.length > 0) {
                    $frozenTr.removeClass("e-editedrow").empty().html(
                        $($.render[proxy._id + "_JSONFrozenTemplate"](data))[0].innerHTML);
                }
                proxy._rowEventTrigger($tr, data);
            }
            else if ($tr.hasClass('e-rowedit')) {
                $tr.removeClass("e-rowedit").empty().html(
                    $($.render[proxy._id + "_Template"](data))[0].innerHTML);
                if ($frozenTr.length > 0) {
                    $frozenTr.removeClass("e-rowedit").empty().html(
                        $($.render[proxy._id + "_JSONFrozenTemplate"](data))[0].innerHTML);
                }
                proxy._rowEventTrigger($tr, data);
            }               
            //Cancel the newly added row.
            else if ($tr.hasClass('e-addedrow')) {
                proxy._isRefreshAddedRecord = false;
                proxy._isEmptyRow = true;
			// Only checked records delete by toolbar action, hence passing it as contextMenu deletion
                if (proxy._checkboxSelection)
                    proxy.deleteRow(null, true, null);
                else
                    proxy.deleteRow();
                proxy._isEmptyRow = false;
            }           
            model.isEdit = proxy._isRowEdit = false;
            model.editSettings.allowDeleting = temp;
            proxy._cancelSaveTools();
            proxy._trigger("refresh");
        },

        //RERENDERED THE EDITED RECORD
        refreshRow: function (index) {
            var proxy = this,
                model = proxy.model,
                updatedRecords = model.allowPaging ? proxy._updatedPageData : model.updatedRecords,
                data = updatedRecords[index], eventArgs = {},
                editIndex = proxy.getIndexByRow($("#" + proxy._id + "EditForm").closest("tr"));
            if (model.enableVirtualization || model.allowPaging)
            {
                index = model.currentViewData.indexOf(data);
            }
            if (data && index > -1) {
                ej.TreeGrid.refreshRow(this, index);

                //var currentRefreshingRow = $(proxy.getRows()[index]);

                //if (model.showDetailsRow && model.detailsTemplate && data.isDetailsExpanded) {
                //    var detailsRow = currentRefreshingRow.next("tr");
                //    if (detailsRow.hasClass("e-detailsrow"))
                //        detailsRow.remove();
                //}
                //currentRefreshingRow.replaceWith($($.render[proxy._id + "_Template"](data)));
                //proxy.setGridRows($(proxy.getContentTable().get(0).rows));

                //eventArgs.rowElement = $(proxy.getRows()[index])[0];
                //eventArgs.data = data;
                //proxy._trigger("refresh");
                //proxy._refreshedCellEventTrigger(eventArgs);

                // Check whether the edited index and refreshed index are same
                // If it is same either rowEdit or cellEdit is enable in particular row.
                // So update the _isRowEdit and isEdit value is false, and also update the toolbar item.s
                if (editIndex == index) {
                    proxy._isRowEdit = proxy.model.isEdit = false;
                    proxy._cancelSaveTools();
                }
            }
        },
        /* refresh the details row while cell editing */
        _refreshDetailsRow: function (index) {
            var proxy = this,
                model = this.model,
                data = proxy.model.currentViewData[index], eventArgs = {},
                gridRows = {};

            if (data) {
                if (this._frozenColumnsLength > 0)
                    gridRows = $(proxy.getRows()[1]);
                else
                    gridRows = $(proxy.getRows());

                var currentRefreshingRow = $(gridRows[index]).next("tr");
                if (currentRefreshingRow.hasClass("e-detailsrow")) {
                    currentRefreshingRow.remove();
                    var detailsRow = $($.render[proxy._id + "_detailRowTemplate"](data));
                    $(gridRows[index]).after(detailsRow);
                    proxy.setGridRows($(proxy.getContentTable().get(0).rows));
                    this._gridRows = this.getContentTable().get(0).rows;
                    if (this._frozenColumnsLength > 0)
                        this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];
                    proxy._trigger("refresh");
                    if (model.detailsDataBound) {
                        this._trigger("detailsDataBound", { detailsElement: detailsRow, data: data });
                    }
                }
            }
        },
        //Trigger rowDataBound and queryCellInfo event when row is refreshed
        _refreshedCellEventTrigger:function(eventArgs)
        {
            var proxy = this, model = this.model;
            if (model.queryCellInfo != null || model.rowDataBound != null || model.detailsDataBound != null) {
                if (model.rowDataBound != null){
                    proxy._trigger("rowDataBound", {
                        rowElement: eventArgs.rowElement,
                        data: eventArgs.data
                    });
                }

                var tdCells = eventArgs.rowElement.cells,
                $tdRowcells = $(eventArgs.rowElement).find(".e-rowcell"),
                cellIndex = 0,
                length = tdCells.length,
                column = null,
                columns = proxy.model.columns;

                if (model.queryCellInfo != null) {

                    for (cellIndex; cellIndex < length; cellIndex++) {
                        if ($(tdCells[cellIndex]).hasClass("e-rowcell")) {
                            column = columns[$tdRowcells.index(tdCells[cellIndex])];
                        }
                        if (column) {
                            proxy._cellEventTrigger(tdCells[cellIndex], eventArgs.data, column);
                        }
                    }
                }
                if (model.detailsDataBound && $(eventArgs.rowElement).next("tr").hasClass("e-detailsrow")) {
                    var detailsRowElement = $(eventArgs.rowElement).next("tr");
                    if (this._frozenColumnsLength > 0)
                        detailsRowElement = $(detailsRowElement[1]);
                    this._trigger("detailsDataBound", { detailsElement: $(eventArgs.rowElement).next("tr"), data: eventArgs.data });
                }
            }
        },

        _refreshGridPager: function () {
            if (this.getPager() != null) {
                var proxy = this,
                    model = proxy.model,
                     pagerModel = this.getPager().ejPager("model"), args = {};
                args.currentPage = this._currentPage();
                if (model.currentViewData.length == 0 && model.updatedRecords.length > 0) {
                    if (pagerModel.totalPages != 1) {
                        proxy.gotoPage(args.currentPage - 1);
                        return;
                    }                   
                }
                args.totalRecordsCount = proxy._gridRecordsCount;          
                this.getPager().ejPager("option", args).ejPager("refreshPager");
                pagerModel = this.getPager().ejPager("model");
                model.pageSettings.totalPages = pagerModel.totalPages;
                proxy._updatePagerTextAlignment();
            }
        },
        /* get visible child record count in udpated records */
        _getVisibleChildRecordCount: function (data, count, collection) {
            var proxy = this, model = this.model, childRecords, length;

            if (data.hasChildRecords) {
                childRecords = data.childRecords;
                length = childRecords.length;
                for (var i = 0; i < length; i++) {
                    if (collection.indexOf(childRecords[i]) !== -1)
                        count++;
                    if (childRecords[i].hasChildRecords) {
                        count = proxy._getVisibleChildRecordCount(childRecords[i], count, collection);
                    }
                }
            }
            else {
                if (collection.indexOf(data) !== -1) {
                    count++;
                }
            }
            return count;
        },
        //Insert templated row in DOM for newly added record
        _renderAddedRow: function (index, data) {
            var proxy = this, model = this.model;
            proxy._updateCurrentViewData();
            if (model.enableVirtualization || model.allowPaging) {
                proxy.updateAltRow();
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy.sendDataRenderingRequest(tempArgs);
            }
            else {
                proxy.renderNewAddedRow(index, data);
            }
            proxy.updateHeight();
        },

        //insert new item in DOM 
        renderNewAddedRow:function(index, data)
        {
            var proxy = this, model = this.model, length,
                gridRows = proxy.getRows(),
                addedGridRow = $.render[this._id + "_Template"](data),
                isFrozenColumn = this._frozenColumnsLength > 0,
                addedFrozenRow,
                frozenTableRows;
            if (isFrozenColumn) {
                gridRows = $(proxy.getRows()[1]);
                frozenTableRows = $(proxy.getRows()[0]);
                addedFrozenRow = $.render[this._id + "_JSONFrozenTemplate"](data);
            }


            if (!ej.isNullOrUndefined(gridRows) && gridRows.length > 0) {
                if (gridRows.length == index) {
                    var insertPositionRow = gridRows.eq(index - 1),
                        insertPositionFrRow;
                    if (isFrozenColumn)
                        insertPositionFrRow = frozenTableRows.eq(index - 1);
                    /*check whether the next row is detail row or not */
                    if($(insertPositionRow).next("tr").hasClass("e-detailsrow"))
                    {
                        $(insertPositionRow).next("tr").after(addedGridRow);
                        isFrozenColumn && $(insertPositionFrRow).next("tr").after(addedFrozenRow);
                    }else
                    {
                        $(insertPositionRow).after(addedGridRow);
                        isFrozenColumn && $(insertPositionFrRow).after(addedFrozenRow);
                    }
                } else {
                    gridRows.eq(index).before(addedGridRow);
                    isFrozenColumn && frozenTableRows.eq(index).before(addedFrozenRow);
                }
            } else {
                if (this._frozenColumnsLength > 0)
                    proxy._renderFrozenRecords();
                else {
                    proxy.getContentTable().find('tbody').empty().append(proxy._getEmptyTbody());
                    var temp = document.createElement('div');
                    proxy.getContentTable().find("colgroup").first().replaceWith(proxy._getMetaColGroup());
                    var $tbody = proxy.getContentTable().children('tbody');
                    $tbody.empty();
                    temp.innerHTML = ['<table>', $.render[proxy._id + "_Template"](proxy.model.currentViewData),
                        '</table>'].join("");
                    proxy.getContentTable().get(0).replaceChild(temp.firstChild.firstChild,
                        proxy.getContentTable().get(0).lastChild);
                }
            }
            this._gridRows = this.getContentTable().get(0).rows;
            if (this._frozenColumnsLength > 0)
                this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

            proxy.setGridRows($(proxy.getContentTable().get(0).rows));
          
        },


        
        onScrollHelper: function (scrolltop, isFromChart) {
            var proxy = this;
            proxy._isFromChart = isFromChart;
            proxy.getScrollElement().ejScroller("scrollY", scrolltop, true);
            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");
            if (!isHorizontalScroll && this.model.isFromGantt)
                proxy.getScrollElement().scrollTop(scrolltop);
        },

        isVScroll: function () {
            if (this.getScrollElement().hasClass("e-scroller")) {
                return this.getScrollElement().ejScroller("isVScroll");
            }
            else
            {
                return false;
            }
        },

        //REFRESH THE SCROLLER FOR TREEGRIDCONTENT
        refreshScroller:function(panSize){
            
            var proxy = this;
            proxy._$gridContent.removeClass("e-borderbox");
            
            var scrollTop = proxy.getScrollElement().ejScroller("option", "scrollTop");
            var scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft");

            proxy.getScrollElement().ejScroller("option", { "persist": true });
            proxy.getScrollElement().ejScroller("option", { "width": panSize });
            
            var maxScrollWidth = proxy.getMaxScrollWidth();
            if (scrollLeft > maxScrollWidth)
                scrollLeft = maxScrollWidth > 0 ? maxScrollWidth : 0;

            proxy._$gridContent.css("height", proxy._viewPortHeight);
            proxy.getScrollElement().ejScroller("refresh");
            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");

            if (proxy.model.isFromGantt)
                if (!isHorizontalScroll) {
                    proxy._$gridContent.addClass("e-borderbox");
                }
                else {
                    proxy._$gridContent.removeClass("e-borderbox");
                }
            proxy.getScrollElement().ejScroller("option", { "scrollTop": scrollTop });
            isHorizontalScroll && proxy.getScrollElement().ejScroller("option", { "scrollLeft": scrollLeft });
            proxy._$gridHeaderContainer.scrollLeft(scrollLeft);

            if (!isHorizontalScroll)
                this.getScrollElement().scrollTop(scrollTop);
            else {
                this.getScrollElement().scrollTop(0);
            }
        },
        getMaxScrollHeight: function () {
            var proxy = this;
            return proxy.getScrollElement().children(".e-content").children().height() - this.getScrollElement().children(".e-content").height();
        },
        getMaxScrollWidth:function()
        {
            var proxy=this;
            return proxy.getScrollElement().children(".e-content").children(".e-gridcontainer").children(".e-table").width() - this.getScrollElement().children(".e-content").width();
        },
        refreshHeight:function(){

            var proxy = this;
            proxy.getScrollElement().ejScroller("refresh");            

        },

		// Get the column using header text
        // argument headerText is column header text value

        getColumnByHeaderText: function (headerText) {
            var proxy = this;
            var length = proxy.model.columns.length;
            var columns = proxy.model.columns;
            for (var column = 0; column < length; column++) {
                if (columns[column]["headerText"] == headerText)
                    break;
            }
            return column == columns.length ? null : columns[column];
        },

        //Hide the column by using header text
        //argument headerText is column header text value
        
        hideColumn: function (headerText) {
            var proxy = this,
                model = proxy.model,
                column = this.getColumnByHeaderText(headerText),
                index = $.inArray(column, model.columns),
                hiddenColumnIndex = $.inArray(headerText, proxy._hiddenColumns);

            /* check this is single column in frozen or movable column*/
            if (column && !proxy._isColumnHidable(column))
                return;
            if (index != -1 && index != model.treeColumnIndex && hiddenColumnIndex == -1) {
                /* Cancel edited cell before sort the column*/
                proxy._cancelEditState();
                proxy._hiddenColumns.push(headerText);
                proxy.model.columns[index].visible = false;
               
				//Table column width not properly set in firefox, so just remove and add the e-table class from both header and content table
                proxy.getHeaderTable().removeClass("e-table");
                proxy.getContentTable().removeClass("e-table");
                var headerColgroup = proxy.getHeaderTable().find('colgroup').find("col");
                $(headerColgroup).eq(index).hide();
                var headerRows = proxy.getHeaderTable().find('thead').find("th.e-headercell");
                $(headerRows).eq(index).addClass("e-hide");
                if (model.allowFiltering && model.filterSettings.filterType == "filterbar") {
                    var headerrows = proxy.getHeaderTable().find('thead').find("th.e-filterbarcell");
                    $(headerrows).eq(index).addClass("e-hide");
                }
                var gridrows = proxy.getContentTable().find("colgroup").find("col"),
                    isFrozenTable = true, cellIndex = index, footerRows;
                $(gridrows).eq(index).hide();
                gridrows = proxy.getRows();
                footerRows = this._getFooterRows();
                //hidding the specified column
                if (this._frozenColumnsLength > 0) {
                    if (index < this._frozenColumnsLength) {
                        gridrows = $(proxy.getRows()[0]);
                        footerRows = $(footerRows[0]);
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan - 1);
                        }
                    }
                    else {
                        gridrows = $(proxy.getRows()[1]);
                        footerRows = $(footerRows[1]);
                        isFrozenTable = false;
                        cellIndex = index - this._frozenColumnsLength;
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan - 1);
                        }
                    }
                } else {
                    if (proxy._gridRows && $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                        var tempColSpan = parseInt($(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                        $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan - 1);
                    }
                }
                
                gridrows.each(function () {
                    var td = $(this).children("td").eq(cellIndex);
                    $(td).addClass("e-hide");
                    if (model.showSummaryRow && $(td).hasClass('e-summaryrowcell') && isFrozenTable)
                        proxy._updateSummaryRowTitleCell(headerColgroup, td[0].parentElement);
                });
                //Hide the specific column from total summary row.
                if (model.showTotalSummary) {
                    var footerColGroup = proxy._$footertableContent.find("colgroup").find("col");
                    $(footerColGroup).eq(index).hide();
                    footerRows.each(function () {
                        var footerSummarytd = $(this).children("td").eq(cellIndex);
                        $(footerSummarytd).addClass("e-hide");
                        if ($(footerSummarytd).hasClass('e-footersummaryrowcell'))
                            proxy._updateSummaryRowTitleCell(footerColGroup, footerSummarytd[0].parentElement);
                    });
                }
                proxy.getHeaderTable().addClass("e-table");
                proxy.getContentTable().addClass("e-table");
                var gridContent = proxy.getScrollElement();
                if (model.isFromGantt) {
                    var isHorizontalScroll = gridContent.ejScroller("isHScroll");
                    if (!isHorizontalScroll)
                        gridContent.addClass("e-borderbox");
                    else
                        gridContent.removeClass("e-borderbox");
                }
                if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                    this._updateTableWidth();
                gridContent.ejScroller("refresh");
                proxy._updateScrollCss();                
                proxy._updateHeaderScrollLeft();
                /* update scrollTop in gantt when treegrid horizontal scroller not exist*/
                if (model.isFromGantt && !gridContent.ejScroller("isHScroll")) {
                    gridContent.scrollTop(gridContent.data("ejScroller").scrollTop());
                }
                index = $.inArray(headerText, proxy._visibleColumns);
                if (index != -1)
                    proxy._visibleColumns.splice(index, 1);
                if (model.showColumnChooser) {
                    proxy._renderColumnChooserList(true, headerText);
                    proxy._updateColumnMenuVisibility();
                }
                proxy._addInitTemplate();
            }
            //Updating the column properties to Gantt's model.columns
            if (model.isFromGantt)
                proxy.updateToGanttColumns();
        },

        //Clear the filter based on fieldName.
        //clearFilter method without argumentment means, it clear the all filter in tree grid.
        clearFilter: function (fieldName) {
            var proxy = this,
                model = proxy.model;
            if (ej.isNullOrUndefined(fieldName)) {
                var filteredColumns = model.filterSettings.filteredColumns,
                    length = filteredColumns && filteredColumns.length;
                //Loop for clearing all the filter in tree grid
                while (filteredColumns && filteredColumns.length > 0) {
                    proxy.clearFilter(filteredColumns[0].field);
                }

            } else {
                var column = proxy.getColumnByField(fieldName),
                    filteredColumn = $.grep(model.filterSettings.filteredColumns, function (filterColumn, index) {
                        return filterColumn.field === fieldName;
                    });
                if (column && filteredColumn.length > 0) {
                    /*Skip the filterColumn method for numeric textbox in immediate filterbar mode.
                      Because while set the empty value to numeric text box, it automatically triiger filterBarHanlder method*/
                    if (!(model.filterBarMode == "immediate" && column.filterEditType == "numericedit")) {
                        proxy._searchString = "";
                        proxy._fieldName = "";
                        proxy.filterColumn(fieldName, "equal", "", "and");
                        proxy._storePreviousFilteredValue(proxy._fieldName, proxy._searchString, this._operator);
                    }
                    proxy._clearFilterElementValue(column);
                }
            }
        },

        //Get the column details based on the given field in tree grid
        getColumnByField: function (fieldName) {
            var proxy = this,
              model = proxy.model,
              columns = model.columns;
            for (var index = 0; index < columns.length; index++) {
                if (columns[index]["field"] == fieldName)
                    break;
            }
            return index == columns.length ? null : columns[index]; //If field name not available in column collection, it returns null value.
        },

        //Set the empty value to filter input elements
        _clearFilterElementValue: function (column) {
            var proxy = this, columnField = column.field.split('.').join(""),
                element = $("#" + proxy._id + "_" + columnField + "_filterbarcell");
            switch (column.filterEditType) {
                case "stringedit":
                    $(element).val("");
                    break;
                case "booleanedit":
                    $(element).prop("checked", false);
                    break;
                case "numericedit":
                    $(element).ejNumericTextbox("instance").option("value", "");
                    break;
                case "dropdownedit":
                    $(element).ejDropDownList("instance").option("value", "");
                    break;
                case "datepicker":
                    $(element).ejDatePicker("instance").option("value", "");
                    break;
                case "datetimepicker":
                    $(element).ejDateTimePicker("instance").option("value", "");
                    break;
            }
        },

        //To maintain the summary row title after hide/show the column using columnChooser.
        _updateSummaryRowTitleCell: function (colgroup, summaryRow) {
            var length = colgroup.length;
            for (var cell = 0; cell < length; cell++) {
                if ($(colgroup[cell]).css('display') == 'none')
                    continue;
                var summaryTitleElement = $(summaryRow).find(".e-summarytitle")[0],
                    currentColumnSummaryTitle = $(summaryRow.childNodes[cell]).find(".e-summarytitle")[0];
                if (currentColumnSummaryTitle)
                    return;
                else
                    $(summaryRow.childNodes[cell]).append(summaryTitleElement);
                return;

            }

        },

        //Show the column by using header text
        // argument headerText is column header text value

        
        showColumn: function (headerText) {
            var proxy = this,
                model = proxy.model,
                column = this.getColumnByHeaderText(headerText),
                index = $.inArray(column, model.columns),
                visibleColumnIndex = $.inArray(headerText, proxy._visibleColumns);
            if (index != -1 && visibleColumnIndex == -1) {
                /* Cancel edited cell before sort the column*/
                proxy._cancelEditState();
                proxy._visibleColumns.push(headerText);
                proxy.model.columns[index].visible = true;
                var headerColgroup = proxy.getHeaderTable().find('colgroup').find("col");
                $(headerColgroup).eq(index).show();
                var headerRows = proxy.getHeaderTable().find('thead').find("th.e-headercell");
                $(headerRows).eq(index).removeClass("e-hide");
                if (model.allowFiltering && model.filterSettings.filterType == "filterbar") {
                    var headerrows = proxy.getHeaderTable().find('thead').find("th.e-filterbarcell");
                    $(headerrows).eq(index).removeClass("e-hide");
                }
                var gridrows = proxy.getContentTable().find("colgroup").find("col"),
                    isFrozenTable = true, cellIndex = index, footerRows;
                $(gridrows).eq(index).show();
                gridrows = proxy.getRows();
                footerRows = this._getFooterRows();

                if (this._frozenColumnsLength > 0) {
                    if (index < this._frozenColumnsLength) {
                        gridrows = $(proxy.getRows()[0]);
                        footerRows = $(footerRows[0]);
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan + 1);
                        }
                    }
                    else {
                        gridrows = $(proxy.getRows()[1]);
                        footerRows = $(footerRows[1]);
                        isFrozenTable = false;
                        cellIndex = index - this._frozenColumnsLength;
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan + 1);
                        }
                    }
                } else {
                    if (proxy._gridRows && $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                        var tempColSpan = parseInt($(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                        $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan + 1);
                    }
                }


				//Display the specified column
                gridrows.each(function () {
                    var td = $(this).children("td").eq(cellIndex);
                    $(td).removeClass("e-hide");
                    if (model.showSummaryRow && $(td).hasClass('e-summaryrowcell') && isFrozenTable)
                        proxy._updateSummaryRowTitleCell(headerColgroup, td[0].parentElement);
                });
                //Show the specific column from total summary row.
                if (model.showTotalSummary) {
                    var footerColGroup = proxy._$footertableContent.find("colgroup").find("col");
                    $(footerColGroup).eq(index).show();
                    footerRows.each(function () {
                        var footerSummarytd = $(this).children("td").eq(cellIndex);
                        $(footerSummarytd).removeClass("e-hide");
                        if ($(footerSummarytd).hasClass('e-footersummaryrowcell'))
                            proxy._updateSummaryRowTitleCell(footerColGroup, footerSummarytd[0].parentElement);
                    });
                }
                proxy._addInitTemplate();
                var gridContent = proxy.getScrollElement();
                if (model.isFromGantt) {
                    var isHorizontalScroll = gridContent.ejScroller("isHScroll");
                    if (!isHorizontalScroll) {
                        gridContent.addClass("e-borderbox");
                    }
                    else {
                        gridContent.removeClass("e-borderbox");
                    }
                }
                if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                    this._updateTableWidth();
                gridContent.ejScroller("refresh");
                proxy._updateScrollCss();
                proxy._updateHeaderScrollLeft();
                /* update scrollTop in gantt when treegrid horizontal scroller not exist*/
                if (model.isFromGantt && !gridContent.ejScroller("isHScroll")) {
                    gridContent.scrollTop(gridContent.data("ejScroller").scrollTop());
                }
                index = $.inArray(headerText, proxy._hiddenColumns);
                if (index != -1)
                    proxy._hiddenColumns.splice(index, 1);
                if (model.showColumnChooser) {
                    proxy._renderColumnChooserList(true, headerText);
                    proxy._updateColumnMenuVisibility();
                }
            }
            //Updating the column properties to Gantt's model.columns
            if (model.isFromGantt)
                proxy.updateToGanttColumns();
        },

        // Get the hidden columns detail in tree grid
        getHiddenColumns: function () {
            var proxy = this,
                model = proxy.model,
                hiddenColumn = proxy._hiddenColumns,
                length = hiddenColumn.length,
                hiddenColumns = [];
            for (var i = 0; i < length; i++)
                hiddenColumns.push(proxy.getColumnByHeaderText(hiddenColumn[i])); //Get the column by using header text
            return hiddenColumns;

        },

        // Get the column details based on the given column index in tree grid
        getColumnByIndex: function (index) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns;
            if (columns.length > index)
                return columns[index];
            return null;
        },

        // Get the visible columns detail in tree grid
        getVisibleColumns: function () {
            var proxy = this,
                model = proxy.model,
                visibleColumn = proxy._visibleColumns,
                length = visibleColumn.length,
                visibleColumns = [];
            for (var i = 0; i < length; i++)
                visibleColumns.push(proxy.getColumnByHeaderText(visibleColumn[i])); //Get the column by using header text
            return visibleColumns;

        },

        //Cancel the edit cell or row based on editing.
        cancelEdit: function () {
            if (this._isRowEdit)
                this.cancelRowEditCell();
            else if (this.model.isEdit)
                this.cancelEditCell();
        },

        //Rerender the tree grid content.
        redraw: function () {
            this.resetModelCollections();
            this._clearColumnMenu();
            this._clearContextMenu();
            this._removeDetailsRow();
            this.element.empty();
            /*Remove all events binded in treegrid*/
            this.element.off();
            var matched = jQuery.uaMatch(navigator.userAgent),
                proxy = this, model = this.model;

            proxy._off(proxy.element, "click", proxy._onClick);
            proxy._off(proxy.element, "keydown", proxy._keyDown);
            proxy._off(proxy.element, "click", "#" + proxy._id + "e-gridheader", proxy._onHeaderClick);
            proxy._off(proxy.element, "mousedown touchstart", "#" + proxy._id + "e-gridheader", proxy._headerMouseDown);
            proxy._off($(document), "mousedown touchstart", proxy._mouseDownHandler);
            proxy._off(proxy.element, "mousedown touchstart", ".e-gridcontent", proxy._contentMouseDown);
            proxy._off(proxy.element, "click", proxy._onRecordClick);// ".e-gridcontent",

            //Method binding for filtering data.
            if (model.filterSettings.filterBarMode == "immediate") {
                proxy._off(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._off(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
            }
            proxy._off(proxy.element, "focus click", ".e-filterbarcell input", proxy._filterBarClose);
            proxy._off(proxy.element, "click", ".e-filterbarcell .e-cancel", proxy._filterBarClose);
            if (proxy.model.showGridCellTooltip && !proxy.model.showGridExpandCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-rowcell", proxy._mouseHover);
                }
            }
            else {
                proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
            }
            if (proxy.model.showGridCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-headercelldiv", proxy._headermouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-headercelldiv", proxy._headermouseHover);
                }
            }
            proxy._off(proxy.element, "mouseleave", ".e-rowcell", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", ".e-headercelldiv", proxy._headerMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._headerMouseLeave);

            //MOUSE WHEEL EVENT FOR GANTT CONTROL
            if (model.isFromGantt || this._frozenColumnsLength) {
                proxy._off(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            }

            if (model.enableResize && model.isResponsive && !model.isFromGantt) {
                proxy._off($(window), "resize", proxy._windowResize);
            }
            if (ej.isTouchDevice())
                proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
            else
                proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
            //Mouse right click event for tree grid


            if (model.contextMenuSettings.showContextMenu) {
                proxy._off(proxy.element, "keyup", this._preventContextMenu);
            }                        
            
            /*Redraw all elements in treegrid toolbar, header,content and summary*/
            this._init();
        },

        // Public method for removing column menu
		clearColumnMenu:function()
        {
            var proxy=this;
            proxy._clearColumnMenu();
		},

		"export": function (action, serverEvent, multipleExport) {
		    var proxy = this,
                model = proxy.model;
		   
		    proxy.contextMenuOperations("Cancel"); // Cancel the edit row or empty newly added row.
		    var modelClone = proxy._getExportModel(model);
		    var attr = { action: action, method: 'post', "data-ajax": "false" };
		    $('form#' + proxy._id + 'export').remove();
		    var form = ej.buildTag('form#'+proxy._id+'export', "", null, attr);
		    if (ej.raiseWebFormsServerEvents) {
		        var args = { model: modelClone, originalEventType: serverEvent };
		        var clientArgs = { model: JSON.stringify(modelClone) };
		        ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
		    }
		    else {
		        var treegridObjectArray = {};
		        if (multipleExport) {
		            $('body').find('.e-treegrid').each(function (index, object) {
		                var gridObject = $(object).data('ejTreeGrid');
		                if (!ej.isNullOrUndefined(gridObject)) {
		                    var gridmodel = gridObject.model,
		                        modelClone = proxy._getExportModel(model);
		                        treegridObjectArray[index] = JSON.stringify(modelClone);
		                        var inputAttr = { name: 'TreeGridModel', type: 'hidden', value: JSON.stringify(modelClone) };
		                        var input = ej.buildTag('input', "", null, inputAttr);
		                        form.append(input);
		                }
		            });
		        }
		        else {
		            var inputAttr = { name: 'TreeGridModel', type: 'hidden', value: JSON.stringify(modelClone) };
		            var input = ej.buildTag('input', "", null, inputAttr);
		            form.append(input);
		            form.append(this);
		        }
		        $('body').append(form);
		        form.submit();
		    }
		    return true;
		},

        //#endregion

        //#region PRIVATE METHODS

		_getExportModel: function (treegridModel) {
		    var proxy = this,
		        model = treegridModel,
		        updatedRecords = model.updatedRecords,
                currentViewData = model.currentViewData,
                flatRecords = model.flatRecords,
                parentRecords = model.parentRecords,
                summaryRowRecords = model.summaryRowRecords,
                selectedItem = model.selectedItem,
                selectedItems = model.selectedItems;
		    // Delete the below internal items in model for avoid the circular reference while extend the model
		    delete model.updatedRecords;
		    delete model.currentViewData;
		    delete model.flatRecords;
		    delete model.parentRecords;
		    delete model.summaryRowRecords;
		    delete model.selectedItem;
		    delete model.selectedItems;
		    var modelClone = $.extend(true, {}, model);
		    model.updatedRecords = updatedRecords;
		    model.currentViewData = currentViewData;
		    model.flatRecords = flatRecords;
		    model.parentRecords = parentRecords;
		    model.selectedItem = selectedItem;
		    model.selectedItems = selectedItems;
		    model.summaryRowRecords = summaryRowRecords;
		    var columns = modelClone.columns,
                columnLength = columns.length,
                filteredColumns = modelClone.filterSettings.filteredColumns,
                filterColumnLength = filteredColumns.length;
		    for (var i = 0; i < columnLength; i++) {
		        if (modelClone.columns[i].editType != undefined) {
		            switch (columns[i].editType) {
		                case "stringedit":
		                case "edittemplate":
		                    columns[i].editType = "string";
		                    break;
		                case "numericedit":
		                    columns[i].editType = "numeric";
		                    break;
		                case "dropdownedit":
		                    columns[i].editType = "dropdown";
		                    break;
		                case "booleanedit":
		                    columns[i].editType = "boolean";
		                    break;
		                default:
		                    break;
		            }
		        }
		        if (columns[i].filterEditType != undefined) {
		            switch (columns[i].filterEditType) {
		                case "stringedit":
		                    columns[i].filterEditType = "string";
		                    break;
		                case "numericedit":
		                    columns[i].filterEditType = "numeric";
		                    break;
		                case "dropdownedit":
		                    columns[i].filterEditType = "dropdown";
		                    break;
		                case "booleanedit":
		                    columns[i].filterEditType = "boolean";
		                    break;
		                default:
		                    break;
		            }
		        }
		    }
		    for (var i = 0; i < filterColumnLength; i++) {
		        if (filteredColumns[i].operator == "equal")
		            filteredColumns[i].operator = "equals";
		        else if (modelClone.filterSettings.filteredColumns[i].operator == "notequal")
		            filteredColumns[i].operator = "notequals";
		    }
		    var ignoreOnExport = proxy.ignoreOnExport,
                igonreLength = ignoreOnExport.length;
		    if (proxy.ignoreOnExport) {
		        for (var i = 0; i < igonreLength; i++) {
		            delete modelClone[ignoreOnExport[i]];
		        }
		    }
		    return modelClone;
		},

		_getNonContentHeight: function(){
		    var proxy = this, model = proxy.model,
                height = 0, borderTopWidth = 0;
		    borderTopWidth = proxy.model.isFromGantt ? 0 : 1;
		    height = proxy._$gridHeaderContent.outerHeight() + parseFloat(borderTopWidth);
		    if (proxy.model.toolbarSettings.showToolbar) {
		        height += !ej.isNullOrUndefined($("#" + proxy._id + "_toolbarItems").outerHeight()) ?$("#" + proxy._id + "_toolbarItems").outerHeight():0;
		    }
		    if (model.allowPaging)
		        height += proxy.element.find('.e-pager').outerHeight();		    	    

		    return height;
                
		},
        //CALCULATE THE VIEWPORTHEIGHT
		_getViewPortHeight: function () {		    
		    return (this.element.height() - this._getNonContentHeight());
        },

        updateViewPortHeight: function () {
            var proxy = this;
            proxy._viewPortHeight = proxy._getViewPortHeight();
        },

        _updateScrollCss: function () {
            var proxy = this,
                model = proxy.model;
            if (!model.isFromGantt) {
                var isVscroll = proxy.isVScroll(),
                    isPaddingExist = proxy._$gridHeaderContent.hasClass("e-scrollcss");
                var isSafari = /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor);
                if (isSafari)
                    proxy._$gridHeaderContent.removeClass("e-gridheader");
                if (isVscroll) {
                    if (!this.mobileDevice())
                    proxy._$gridHeaderContent.addClass("e-scrollcss");
                    if (model.showTotalSummary && proxy._$totalSummaryRowContainer && proxy._$totalSummaryRowContainer.outerHeight() < 90) {
                        if (!this.mobileDevice())
                            proxy._$totalSummaryRowContainer.addClass("e-scrollcss");
                        if (!this.mobileDevice())
                            proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width() - 17);
                        else
                            proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width());
                    }
                } else {
                    proxy._$gridHeaderContent.removeClass("e-scrollcss");
                    if (model.showTotalSummary && proxy._$totalSummaryRowContainer && proxy._$totalSummaryRowContainer.outerHeight() < 90) {
                        proxy._$totalSummaryRowContainer.removeClass("e-scrollcss");
                        proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width());
                    }
                }
                this._updateHeaderScrollLeft(this.getScrollElement().ejScroller("model.scrollLeft"));
                //update frozenContainer height
                if (this._frozenColumnsLength) {
                    var movableContainerHeight = this.getContent().find("#e-movablecontent" + proxy._id).height();
                    if (movableContainerHeight != this.getContent().find("#e-frozencontainer" + proxy._id).height()) {
                        this.getContent().find("#e-frozencontainer" + proxy._id).height(movableContainerHeight);
                    }
                }
                // Tree grid header not properly aligned in safari browser.
                // Because dynamically add or remove any css class it not affected immediately in safari browser
                // So just refresh the tree grid header
                if (isSafari) {
                    proxy._$gridHeaderContent[0].style.width=proxy._gridWidth+"px";
                    proxy._$gridHeaderContent.addClass("e-gridheader");
                }
                    proxy._resizeFilteringElements();
            }
        },

        _updatePagerIndex: function(){
            var proxy = this,
                model = proxy.model,
                expandedRecords = [], endIndex = -1, startIndex = -1,
                updatedRecords = model.updatedRecords;
            if (model.allowPaging) {
                var pageSize = model.pageSettings.pageSize;

                if (model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root) {
                    var rootParentRecords = model.parentRecords.slice(),
                        index = -1, rootEndIndex = -1, rootStartIndex = -1;
                    proxy._gridRecordsCount = rootParentRecords.length;
                    var totalAvailablePages = (proxy._gridRecordsCount < 1) ? 0 : (pageSize == 0)? 0 : Math.ceil(proxy._gridRecordsCount / pageSize);
                    if (proxy._currentPage() > totalAvailablePages)
                        proxy._currentPage(totalAvailablePages);
                    rootEndIndex = ((proxy._currentPage() * pageSize) > proxy._gridRecordsCount)? (proxy._gridRecordsCount) : (proxy._currentPage() * pageSize);
                    rootStartIndex = (proxy._gridRecordsCount <= pageSize) ? 0 : ((proxy._currentPage() * pageSize) - pageSize);                                     
                    endIndex = updatedRecords.indexOf(rootParentRecords[rootEndIndex]);
                    if (rootStartIndex > rootEndIndex)
                        rootStartIndex = rootEndIndex - pageSize;
                    else if (proxy._gridRecordsCount == rootEndIndex)
                        endIndex = updatedRecords.length;
                    startIndex = updatedRecords.indexOf(rootParentRecords[rootStartIndex]);                    
                    proxy._updatedPageData = this.getExpandedRecords(updatedRecords.slice(startIndex, endIndex));
                }
                else {
                    expandedRecords = this.getExpandedRecords(updatedRecords);
                    if (model.enableVirtualization) {
                        proxy._gridRecordsCount = updatedRecords.length;                        
                    }
                    else {                        
                        proxy._gridRecordsCount = expandedRecords.length;                        
                    }
                   
                    var currentTotalPages = (proxy._gridRecordsCount < 1) ? 0 : (pageSize == 0)? 0 : Math.ceil(proxy._gridRecordsCount / pageSize) ;
                    if (proxy._currentPage() > currentTotalPages)
                        proxy._currentPage(currentTotalPages);
                    endIndex = ((proxy._currentPage() * pageSize) > proxy._gridRecordsCount) ? (proxy._gridRecordsCount) : (proxy._currentPage() * pageSize),
                    startIndex = (proxy._gridRecordsCount < pageSize) ? 0 : ((proxy._currentPage() * pageSize) - pageSize);
                    if (startIndex > endIndex)
                        startIndex = endIndex - pageSize;
                    proxy._updatedPageData = expandedRecords.slice(startIndex, endIndex);
                }               
                proxy.updateHeight();
            }
        },

        //UPDATE CURRENT VIEWPORT DATA FROM FLATRECORDS/UPDATED RECORDS
        _updateCurrentViewData: function (requestType) {

            var proxy = this,
                model = proxy.model,
                args = {},
                tMargin,
                isRangeModified = false;

            //CHECK VIRTUALIZATION IS ENABLED OR NOT 
            if (model.enableVirtualization) {

                if (model.allowPaging) {
                    if (requestType != ej.TreeGrid.Actions.Scroll)
                        proxy._updatePagerIndex();
                    proxy.getVisibleRange();
                    if (model.sizeSettings.height)
                        model.currentViewData = proxy._updatedPageData.slice(proxy._visibleRange.top,
                        proxy._visibleRange.bottom);
                    else
                        model.currentViewData = proxy._updatedPageData;
                }

                else {
                    proxy.getVisibleRange();
                    model.currentViewData = proxy.model.updatedRecords.slice(proxy._visibleRange.top,
                    proxy._visibleRange.bottom);                    
                }

                if (model.allowDragAndDrop && proxy._dragMouseDown && (ej.browserInfo().name == "chrome" || ej.isTouchDevice())) {
                    var updatedRecords = proxy.getUpdatedRecords(),
                       draggedItemIndex = updatedRecords.indexOf(proxy._draggedRecord);
                    if (proxy._visibleRange.top > draggedItemIndex || proxy._visibleRange.bottom < draggedItemIndex) {
                        if (!proxy._dummyElement) {
                            $(document.body).append(proxy._draggedElement);
                            proxy._dummyElement = true;
                            $(proxy._draggedElement).hide();
                        }
                    }
                }

                if (proxy._vScrollDist !== 0) {

                    tMargin = proxy._scrollTop - proxy._offset;
                    if (requestType && requestType == ej.TreeGrid.Actions.Scroll) args.requestType = ej.TreeGrid.Actions.Scroll;

                    else args.requestType = ej.TreeGrid.Actions.Refresh;

                    proxy.sendDataRenderingRequest(args);
                    isRangeModified = true;

                    if (this._frozenColumnsLength > 0) {
                        proxy._$frozenTableContent.css({ "top": tMargin });

                        proxy._$movableTableContent.css({ "top": tMargin });
                    } else 
                        proxy._$tableContent.css({ "top": tMargin });
                }
                proxy._prevRTop = proxy._visibleRange.top;
                proxy._prevRBottom = proxy._visibleRange.bottom;

            } else {
                if (model.allowPaging) {
                    proxy._updatePagerIndex();
                    model.currentViewData = proxy._updatedPageData;
                }
                else
                    model.currentViewData = proxy.model.updatedRecords.slice();
            }


            if (proxy._isEnterKeyPressed) {

                proxy._isEnterKeyPressed = false;
                if (model.allowSelection && model.editSettings.allowEditing) {

                    if (!isRangeModified) proxy._cellEditingDetails.rowIndex += 1;

                    if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), proxy._cellEditingDetails.rowIndex)) {

                        proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                        proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);

                    }

                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, proxy.model.columns[proxy._cellEditingDetails.columnIndex].field);

                }
            }
        },


        //GET THE TABLE ROW POSITION
        _getRowPosition: function (y) {
            return Math.ceil((y) / (this.model.rowHeight + this._detailsRowHeight));
        },


        //GET THE COLUMNGROUP FOR HEADER TABLE
        _getMetaColGroup: function () {

            var $colgroup = this.getHeaderTable().find('colgroup').clone();
            return $colgroup;

        },


        //CREATE EMPTY ROW WHILE DATASOURCE OBJECT AS NULL
        _getEmptyTbody: function () {

            var proxy = this,
                $emptyTd = ej.buildTag('td', proxy.model.emptyRecordText, {}, { colSpan: proxy.model.columns.length });
            return $(document.createElement("tr")).append($emptyTd);

        },


        //ADD SORTICON TO THE COLUMN HEADER
        _addSortElementToColumn: function (field, direction) {

            var proxy = this, model = this.model,
                column,index;
            if (model.isFromGantt)
                column = ej.TreeGrid.getColumnByMappingName(proxy.model.columns, field);
            else
                column = ej.TreeGrid.getColumnByField(proxy.model.columns, field);
            index = $.inArray(column, proxy.model.columns);
            var $headerCellDiv = proxy.getHeaderTable().find("thead").
                find(".e-headercell").eq(index).find(".e-headercelldiv");
            $headerCellDiv.find(".e-ascending,.e-descending").remove();
            $headerCellDiv.append(proxy._createSortElement().addClass("e-" + direction).addClass("e-icon"));
            $headerCellDiv.parent().attr("aria-sort", direction);
        },


        //CREATE SORT ELEMENT        
        _createSortElement: function () {
            return ej.buildTag('span', "&nbsp;");
        },


        //RENDERED EDITED CELL
        _renderCellEditObject: function (cellEditArgs, $td) {

            var proxy = this,
                $form = ej.buildTag("form.#" + proxy._id + "EditForm", "", {}, {}),
                $cellEditTemplate = proxy._cellEditTemplate,
                $element,
                htmlString,
                cellData = {},
                cellValue,
                columnObject = cellEditArgs.columnObject,
                columnField = columnObject.field.split('.').join(""),
                columnIndex = -1,
            cellValue = cellEditArgs.value;
            if (columnObject.editType == "dropdownedit" && cellValue == false)
                cellValue = cellValue.toString();
            cellData[columnField] = cellValue,
            columnIndex = proxy.getColumnIndexByField(columnObject.field);

            $td.empty();

            $td.addClass("e-validError");

            htmlString = $cellEditTemplate.find("#" + columnField + "_CellEdit").html();
            if (columnObject.field === "predecessor" || columnObject.field === "duration")
                $element = $($.templates(htmlString).render(cellEditArgs.data));
            else
                $element = $($.templates(htmlString).render(cellData));

            if ($element.get(0).tagName == "SELECT") {

                $element.val(cellData[columnField]);
                $element.val() == null && $element.val($element.find("option").first().val());

            }

            if ($element.get(0).tagName == "INPUT" && proxy.model.isFromGantt) {
                if (columnObject.field != "predecessor" && columnObject.field != "duration")
                    $element.val(cellData[columnField]);
            } else if ($element.get(0).tagName == "INPUT") {
                $element.val(cellData[columnField]);
            }

            $form.append($element);

           $td.append($form);

           proxy._setoffsetWidth();
           var args = {};
           args.columnIndex = cellEditArgs.columnIndex;
           args.data = cellEditArgs.data.item;
           args.requestType = "beginEdit";
           proxy._refreshEditForm(args);

            if ($.isFunction($.validator) && !$.isEmptyObject(cellEditArgs.validationRules)) {

                proxy._initValidator();
                proxy.setValidation();

            }
            proxy.model.isEdit = true;

        },


        //SET WIDTH FOR EDITING ELEMENTS
        _setoffsetWidth: function () {

            var proxy = this,
                model = proxy.model,
                tds, $form = $("#" + proxy._id + "EditForm"), $frozenForm = $("#" + proxy._id + "EditFrozenForm"),
                i = 0,
                rowIndex = proxy._cellEditingDetails.rowIndex,
                length, child;

            if (model.editSettings.editMode.toLowerCase() == "cellediting" && !proxy._isRowEdit) {
                tds = $form.closest("td");
            } else {
                tds = $frozenForm.add($form).find("tr").find(".e-rowcell");
            }

            length = tds.length;

            for (i; i < length; i++) {

                child = $(tds.children()[0]).children();

                if (child.length > 1) {
                    if (model.currentViewData[rowIndex].level == 0 && model.currentViewData[rowIndex].hasChildRecords)
                        proxy._tdsOffsetWidth[i] = $(tds.get(i)).width() - ($(tds.children()[0]).outerWidth() - $(tds.children()[0]).width()) - child[0].offsetWidth - child[2].offsetWidth - ($(child[3]).outerWidth() - $(child[3]).width());
                    else
                        proxy._tdsOffsetWidth[i] = $(tds.get(i)).width() - ($(tds.children()[0]).outerWidth() - $(tds.children()[0]).width()) - child[0].offsetWidth - child[1].offsetWidth - ($(child[3]).outerWidth() - $(child[3]).width());
                } else {
                    proxy._tdsOffsetWidth[i] = $(tds.get(i)).width();
                }
            }

        },


        //get Index of resourceInfo
        getIndexofresourceInfo: function (dataSource) {

            var proxy = this, model = proxy.model,
                resourceIdMapping = model.resourceIdMapping,
                data = proxy._cellEditingDetails.data,
                resourceInfo = data.resourceInfo,
                count = 0,
                length = resourceInfo && resourceInfo.length,
                resourceIndex = [];

            for (count; count < length; count++) {                
                for (var index = 0; index < dataSource.length; index++) {
                    if (dataSource[index][resourceIdMapping] == resourceInfo[count][resourceIdMapping])
                        resourceIndex.push(index)
                }
            }

            return resourceIndex;

        },

        //REFRESH THE EDITED FORM
        _refreshEditForm: function (args) {

            var proxy = this, $form, rowHeight, isDialogEdit;
            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                $form = $("#" + proxy._id + "EditFormDialog");
                rowHeight = "";
                isDialogEdit = true;
            } else {
                $form = $("#" + proxy._id + "EditForm");
                rowHeight = proxy.model.rowHeight - 5;
            }
            var $frozenForm = $("#" + proxy._id + "EditFrozenForm"),
                elementFocused = false,
                $formElement = $frozenForm.add($form).find("input,select,textarea"),
                percent = 86,
                i = 0,
                length = $formElement.length,
                $element, inputWidth,
                model = proxy.model,
                width,
                params = {},
                value,
                column,
                customParams,
                toformat,
                formatVal,
                cellEditType;

            for (i; i < length; i++) {

                $element = $formElement.eq(i);
                cellEditType = $element.attr("edittype");
                column = ej.TreeGrid.getColumnByField(model.columns, $element.prop("name"));
                if (ej.isNullOrUndefined(column) && proxy.model.editSettings.editMode == "dialogEditing") {
                    if (($element).hasClass("e-btn") || (proxy.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != ""))) {
                        return;
                    } else
                        $element.closest("tr").addClass("e-hide");
                } else {
              
                    if (proxy.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != ""))
                        cellEditType = column.editType;
              
                        inputWidth = "100%";

                    switch (cellEditType) {
              
                        case ej.TreeGrid.EditingType.Numeric:
                            params = {};
                            width = inputWidth;
                            value = $element.val();
                            params.width = width;
                            params.locale = model.locale;
                            params.height = rowHeight;
                            params.showSpinButton = true;
                            params.cssClass = model.cssClass;
                  
                        if (value.length)
                           {
                                  params.value = parseFloat(value);
                           }

                        if (model.isFromGantt && column.field === "status") {
                            params.minValue = 0;
                            params.maxValue = 100;
                            params.decimalPlaces = 0;
                        }

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);

                        $element.ejNumericTextbox(params);
                        $element.prop("name", $element.prop("name").replace(proxy._id, ""));
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:
                        params = {};
                        params.width = inputWidth;
                        params.height = rowHeight;
                        params.locale = model.locale;
                        params.cssClass = model.cssClass;
                        params.dateFormat = model.dateFormat;
                        params.enableStrictMode = true;
                        if (model.isFromGantt)
                            params.startDay = model.weekStartDay;
                        if ($element.val().length) params.value = proxy.getDateFromFormat($element.val());

                        if (column["format"] !== undefined && column.format.length > 0) {

                            toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                            formatVal = toformat.exec(column.format);
                            params.dateFormat = formatVal[2];
                            if ($element.val().length) {
                                params.value = ej.format(new Date($element.val()), params.dateFormat, params.locale);
                                $element.val(params.value);
                            }
                        }

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);

                        if (model.dateFormat.toLowerCase().indexOf("hh") == -1)
                            $element.ejDatePicker(params);
                        else {
                            $element.ejDateTimePicker(params);
                        }
                        break;
                    case ej.TreeGrid.EditingType.DateTimePicker:
                        params = {};
                        params.width = inputWidth;
                        params.height = rowHeight;
                        params.locale = model.locale;
                        params.cssClass = model.cssClass;
                        params.displayDefaultDate = true;
                        params.dateTimeFormat = model.dateFormat;
                        params.enableStrictMode = true;
                        if (model.isFromGantt)
                            params.startDay = model.weekStartDay;
                        if ($element.val().length) params.value = proxy.getDateFromFormat($element.val());

                        if (column["format"] !== undefined && column.format.length > 0) {

                            toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                            formatVal = toformat.exec(column.format);
                            params.dateTimeFormat = formatVal[2];
                            if ($element.val().length) {
                                params.value = ej.format(new Date($element.val()), params.dateTimeFormat, params.locale);
                                $element.val(params.value);
                            }
                        }

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);

                            $element.ejDateTimePicker(params);
                        break;
                    case ej.TreeGrid.EditingType.Dropdown:

                        var dataSource, fieldName;

                        if (proxy._isRowEdit)
                        {
                            dataSource = column.dropdownData;
                            fieldName = column.field;
                        }
                        else{
                            dataSource = column.dropdownData;
                            fieldName = column.field;
                        }

                        if(model.isFromGantt && fieldName === "resourceInfo"){
                            $element.ejDropDownList({
                                width: inputWidth,
                                height: rowHeight,
                                showCheckbox: true,
                                dataSource: dataSource,
                                fields: {
                                    id: model.resourceIdMapping,
                                    text: model.resourceNameMapping,
                                    value: model.resourceNameMapping
                                },
                                selectedItems: proxy.getIndexofresourceInfo(dataSource)
                            });
                        
                        } else {
                            var controlArgs = {};
                            controlArgs.cssClass = model.cssClass;
                            controlArgs.width = inputWidth;
                            controlArgs.height = rowHeight;
                            controlArgs.dataSource = dataSource;
                            if (!ej.isNullOrUndefined(column["editParams"]))
                                $.extend(controlArgs, column["editParams"]);

                            $element.ejDropDownList(controlArgs);

                            var obj = $element.ejDropDownList("instance");
                            obj._setValue($element.attr("cellValue"));
                           
                        }
                        break;

                    case ej.TreeGrid.EditingType.String:
                        if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                            $element.outerWidth("100%").height(27);
                        } else {
                            $element.outerWidth(inputWidth).height(model.rowHeight - 9);
                        }
                        break;
                    case ej.TreeGrid.EditingType.Boolean:
                        if (proxy._checkboxSelection && column["nonColumn"]) {                            
                            $element[0].style.display = "none";
                        }
                        else {
                            var controlArgs = {};
                            controlArgs.cssClass = model.cssClass;
                            controlArgs.size = "small";                            

                            if (!ej.isNullOrUndefined(column["editParams"]))
                                $.extend(controlArgs, column["editParams"]);

                            $element.ejCheckBox(controlArgs);
                            ////center align of check box control
                            var parentElement = $element.parent(".e-chkbox-wrap"),
                                formElement = parentElement.parent("form");

                            if (!isDialogEdit) {
                                if (formElement.length > 0)
                                    formElement.css("margin-left", "45%");
                                else
                                    parentElement.css("margin-left", "45%");
                            }
                        }                       
                        break;
                   
                    case ej.TreeGrid.EditingType.Maskedit:
                        var controlArgs = {};
                        controlArgs.locale = model.locale;
                        controlArgs.cssClass = model.cssClass;
                        controlArgs.width = inputWidth;
                        controlArgs.height = rowHeight;
                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(controlArgs, column["editParams"]);

                        $element.ejMaskEdit(controlArgs);
                        break;
                    case "edittemplate":
                        var temp = { rowdata: args.data, "column": column, element: $element, requestType: args.requestType};
                        var temp1 = column.editTemplate.write;
                        if (!ej.isNullOrUndefined(args) && args.requestType == "add") temp.rowdata = {};
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        temp1(temp);
                        break;
                }

                if (!$element.is(":disabled") && !elementFocused &&
                   (!$element.is(":hidden") || typeof ($element.data("ejDropDownList") || $element.data("ejNumericTextbox") ||
                   $element.data("ejDatePicker") || $element.data("ejCheckBox")) == "object")) {

                    if ((!proxy._isEnterKeyPressed && column == model.columns[args.columnIndex]) || ((!args.columnIndex || args.columnIndex == -1) && !proxy._isEnterKeyPressed)) {

                        proxy._focusElements($element.closest('td'));
                        elementFocused = true;

                    }
                }
                }
        }
            },

        _getRecordIndex: function () {
            var proxy = this,
                model = proxy.model,
                currentViewData, index,
                records = model.allowPaging ? proxy._updatedPageData : proxy.getExpandedRecords(model.updatedRecords);
            proxy.getVisibleRange();
            currentViewData =  records.slice(proxy._visibleRange.top, proxy._visibleRange.bottom); 
            index = currentViewData.indexOf(model.selectedItem);
            return index;
        },
         //INITIALIZE THE VALIDATOR
        _initValidator: function () {
            var proxy = this, elements = $("#" + this._id + "EditForm").length>0 ? $("#" + this._id + "EditForm") : $("#" + this._id + "EditFormDialog");
            for (var i = 0; i < elements.length ; i++) {
                elements.eq(i).validate({
                    ignore: ".e-hide",
                    errorClass: 'e-field-validation-error',
                    errorElement: 'div',
                    wrapper: "div",
                    errorPlacement: function (error, element) {
                        proxy._renderValidator(error, element);
                    },
                });
            }
        },

        _renderValidator: function (error, element) {
            if (element.is(":hidden"))
                element = element.siblings("input:visible");
            if (!element.length)
                return;
            var proxy=this,
                model = proxy.model,
                recordIndex,
                $td = element.closest(".e-rowcell"),
                $container = $(error).addClass("e-error"),
                $tail = ej.buildTag("div.e-errortail");
            $td = !$td.length ? $td = element.closest("td") : $td;
            $td.find(".e-error").remove();
            if (model.editSettings.editMode != "dialogEditing") {
                recordIndex = proxy._getRecordIndex();                
                var recordPosition = (recordIndex + 1) * model.rowHeight;
                if (!model.enableVirtualization) {
                    var expandRecords = proxy.getExpandedRecords(model.updatedRecords);
                    recordIndex = model.allowPaging ? proxy._updatedPageData.indexOf(model.selectedItem) : expandRecords.indexOf(model.selectedItem);
                }
                if (recordIndex == -1) {
                    if (model.editSettings.rowPosition == "bottom")
                        recordIndex = model.updatedRecords.length - 1;
                    else if (model.editSettings.rowPosition == "top")
                        recordIndex = 0;
                    recordPosition = (recordIndex + 1) * model.rowHeight;
                }
                // here 45 is the error container height
                if (proxy._viewPortHeight < recordPosition + 45) {
                    $tail.addClass("e-bottomarrow");
                    var top = recordIndex * model.rowHeight - 45;
                    var operation = "append";
                }
                else {                   
                    $tail.addClass("e-toparrow");
                    var top = (recordIndex + 1) * model.rowHeight;
                    var operation = "prepend";
                }
            }
            else {
                var top = $td.offset().top - $("#" + this._id + "EditFormDialog").offset().top + $td.parent()[0].offsetHeight;
                $tail.addClass("e-toparrow");
                var operation = "prepend";
            }
            $($container).css({ "top": top });
            if (element.parent().hasClass("e-in-wrap"))
                $container.insertAfter(element.closest(".e-widget"));
            else
                $container.insertAfter(element);
            $container[operation]($tail);            
            $container.show("slow");
        },

        setValidation: function () {
            var proxy=this,
                model=proxy.model;
            
            for (var i = 0; i < this.model.columns.length; i++) {
                if (!ej.isNullOrUndefined(model.columns[i]["validationRules"])) {
                    if (model.editSettings.editMode == ej.TreeGrid.EditMode.RowEditing
                         || model.editSettings.editMode == ej.TreeGrid.EditMode.DialogEditing || proxy.element.find(".e-rowedit").length > 0
						 || proxy.element.find(".e-addedrow").length > 0)
                        this.setValidationToField(model.columns[i].field, model.columns[i].validationRules);
                    else if (model.editSettings.editMode == ej.TreeGrid.EditMode.CellEditing && proxy._cellEditingDetails.columnIndex == i) {
                        this.setValidationToField(model.columns[i].field, model.columns[i].validationRules);
                        return;
                    }
                }                
            }
        },

        setValidationToField: function (name, rules) {
            var fName = name, ele;
            if (!ej.isNullOrUndefined(name))
            fName = fName.replace(/[^a-z0-9\s_]/gi, '');
            var form = $("#" + this._id + "EditForm").length > 0 ? $("#" + this._id + "EditForm") : $("#" + this._id + "EditFormDialog"),
            ele = form.find("#" + this._id + fName).length > 0 ? form.find("#" + this._id + fName) : form.find("#" + fName);
            if (rules["regex"]) {
                rules[name + "regex"] = rules["regex"]; delete rules["regex"];
                $.validator.addMethod(fName + "regex", function (value, element, options) {
                    var ptn = options instanceof RegExp ? options : new RegExp(options);
                    return ptn.test(value);
                }, ej.getObject("messages.regex", rules) || this.getColumnByField(name).headerText + " should match the given pattern");
            }
            !ele.attr("name") && ele.attr("name", name);
            ele.rules("add", rules);
            var validator = $("#" + this._id + "EditForm").length > 0 ? $("#" + this._id + "EditForm").validate() : $("#" + this._id + "EditFormDialog").validate();
            validator.settings.messages[name] = validator.settings.messages[name] || {};
            if (!ej.isNullOrUndefined(rules["required"])) {
                if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"]))
                    var message = rules["messages"]["required"];
                else
                    var message = $.validator.messages.required;
                if (message.indexOf("This field") == 0)
                    message = message.replace("This field", this.getColumnByField(name).headerText);
                validator.settings.messages[name]["required"] = message;
                if (ele.hasClass("e-datepicker"))
                    ele.ejDatePicker({ watermarkText: "" });
            }
        },

        //SET FOCUS TO EDITED ELEMENT
        _focusElements: function ($currentCell) {
            var proxy = this;

            if ($currentCell.length) {

                $currentCell.focus();
                var $childElem = $currentCell.children();

                if ($childElem[0]) {

                    if ($childElem[0].tagName.toLowerCase() == "select" || 
                        $childElem[0].tagName.toLowerCase() == "input") {

                        $childElem.focus().select();
                        $childElem[0].focus();

                    } else if ($childElem.find(".e-field.e-dropdownlist").length) {

                        $childElem.find(".e-ddl").focus();

                    } else if ($childElem.find(".e-chkbox-wrap.e-widget").length) {

                        $childElem.find(".e-chkbox-wrap.e-widget").focus();

                    }
                    else {
                        if ($childElem.find(".e-datepicker").length <= 0)
                            $childElem.find('input,select').select().focus();
                        else
                            $childElem.find('input,select').select();
                    }
                }
            }

            var contentScrollLeft = proxy.getScrollElement().children('.e-content').scrollLeft(),
                scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft");
            if (proxy.getScrollElement().hasClass("e-scroller") && contentScrollLeft != scrollLeft) {
                if (!ej.isNullOrUndefined(contentScrollLeft))
                proxy.getScrollElement().ejScroller("option", "scrollLeft", contentScrollLeft);
            }
            proxy._updateHeaderScrollLeft(proxy.getScrollElement().children('.e-content').scrollLeft());
        },
        //Set the focus for edit row elements
        _focusElementsForRowEdit: function ($currentCell) {
            if ($currentCell.length) {
                var $childElem = $currentCell.children();
                if ($childElem[0].tagName.toLowerCase() == "select" || $childElem[0].tagName.toLowerCase() == "input") {
                    $childElem.focus().select();
                    $childElem[0].focus();
                }
                else if ($childElem.find(".e-field.e-dropdownlist").length)
                    $childElem[0].focus();
                else if ($childElem.hasClass("e-chkbox-wrap")) {
                    $childElem[0].focus();
                } else {
                    if ($childElem.find(".e-datepicker").length <= 0)
                        $childElem.find('input:visible,select').first().select().focus();
                    else
                        $childElem.find('input,select').select();
                }
            }
        },
        //UPDATE THE GRID CONTAINER HEIGHT
        //By updatedRecords and CollapsedRecord count length
        updateHeight: function () {

            var proxy = this,
                model = this.model,
                height = 0,
                detailsRowHeight = 0;
            if (proxy._$gridContainer && proxy._$gridContent) {
                if (model.allowPaging) {                    
                    height = model.rowHeight * proxy._updatedPageData.length;
                }
                else if (model.enableVirtualization) {
                    height = model.updatedRecords.length * model.rowHeight;
                }

                else {
                    height = model.rowHeight * (model.updatedRecords.length - proxy.getCollapsedRecordCount());
                }

                if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                    detailsRowHeight = proxy._getExpandedDetailsRowHeight();
                }

                height += detailsRowHeight;

                if (height == 0 && (model.currentViewData.length == 0 || model.flatRecords.length == 0))
                    height = 30;
                //To skip Vertical scrollbar
                if (model.allowPaging && !model.sizeSettings.height) {
                    var viewPortHeight = height                    
                    if (this._frozenColumnsLength > 0) {
                        proxy._$gridContent.css("height", height);
                    }
                    else if (proxy.getScrollElement().hasClass("e-scroller")) {
                        if (proxy.getScrollElement().ejScroller("isHScroll")) {
                            viewPortHeight = height + proxy._scrollBarHeight;
                        }
                        proxy.getScrollElement().ejScroller({
                            height: viewPortHeight,//for border-width of gridcontent
                        });
                        
                    }
                    proxy._viewPortHeight = viewPortHeight;
                    proxy._gridHeight = height + proxy._getNonContentHeight();
                    if (proxy._summaryRowsCount > 0 && model.showTotalSummary)
                        proxy._gridHeight += proxy._$totalSummaryRowContainer.outerHeight();
                    proxy.element.height(proxy._gridHeight);                    
                }
                proxy._$gridContainer.css({
                    "height": height + "px",
                    "width": "auto"
                });
                if (this._frozenColumnsLength) {
                    proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", height + "px");
                }
                if (proxy.getScrollElement().hasClass("e-scroller")) {
                    proxy.getScrollElement().ejScroller("refresh");
                    proxy._updateScrollCss();
                }
            }
        },
        //check scroller position in virtualization
        _setScrollTop: function () {

            var proxy = this,
            model = this.model,
            currentPosition = 0,
            top = proxy._scrollTop,
            rowHeight = model.rowHeight,
            length = model.currentViewData.length, id = model.isFromGantt ? proxy._id.replace("ejTreeGrid", "") : proxy._id,
            ganttbody = $("#" + id).find(".e-ganttviewerbodyContianer");

            /* check detail template and its row height */
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                rowHeight += proxy._detailsRowHeight;
            }
            if (model.allowPaging && proxy._isNextPage) {
                top = 0;
                proxy._isNextPage = false;
                proxy.getScrollElement().ejScroller("scrollY", top, true);
            }
            if (top !== 0) {
                if(model.enableVirtualization){
                    if ((length * rowHeight) < proxy._viewPortHeight) {
                        if (length > 0) {
                            currentPosition = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                            if (currentPosition < 0)
                                currentPosition = 0;
                        }
                        if (model.isFromGantt)
                            ganttbody.ejScroller("scrollY", currentPosition, true);
                        else
                        proxy.getScrollElement().ejScroller("scrollY", currentPosition, true);
                    }
                }
                else {
                    if (model.isFromGantt)
                        ganttbody.ejScroller("scrollY", top, true);
                else
                    proxy.getScrollElement().ejScroller("scrollY", top, true);
            }
            }
        },

        getChildCount:function(record,count)
        {
            var currentRecord, proxy = this;
            if (!record.hasChildRecords)
                return 0;
            for (var i = 0; i < record.childRecords.length;i++)
            {
                currentRecord= record.childRecords[i];
                count++;
                if(currentRecord.hasChildRecords)
                {
                    count=proxy.getChildCount(currentRecord, count);
                }
            }
            return count;
        },
        //UPDATE THE FILTERED RECORDS FOR ADDING PARENTRECORDS
        _updateFilteredRecords: function (data) {

            var proxy = this,
                count = 0,
                length = data.length,
                record,virtualization=proxy.model.enableVirtualization;

            proxy._flatFilteredRecords = [];
            proxy._filteredRecords = [];
            proxy._filteredGanttRecords = [];

            for (count; count < length; count++) {

                record = data[count];

                proxy._addParentRecord(record);

                if (!this.model.isFromGantt) {
                    if (record.hasChildRecords && record.childRecords.length > 0) {
                        if (!this._checkChildExsist(record, data)) {
                            record.hasFilteredChildRecords = false;
                        } else {
                            record.hasFilteredChildRecords = true;
                        }
                    }
                    if (record.parentItem) {
                        record.parentItem.hasFilteredChildRecords = true;
                    }
                }
            }
            if (virtualization)
            proxy._filteredRecords = proxy.getExpandedRecords(proxy._flatFilteredRecords);
            else
                proxy._filteredRecords = proxy._flatFilteredRecords.slice();
        },
        /* Check child records of filtered parent records exists or not in updated records*/
        _checkChildExsist: function (record, collection)
        {
            var childRecords = record.childRecords,
                length = childRecords.length, isExsist = false;
            for (var count = 0; count < length; count++) {
                if ($.inArray(childRecords[count], collection) != -1) {
                    isExsist = true;
                    break;
                } else if (childRecords[count].hasChildRecords) {
                    isExsist = this._checkChildExsist(childRecords[count], collection);
                }
            }
            return isExsist;
        },
        /* While clear the filter, update hasFilteredChildRecords status of all records*/
        _updateHasFilteredChildRecordsStatus: function (collection)
        {
            var count=0,length=collection.length,currentRecord;
            for (count; count < length; count++) {
                currentRecord = collection[count];
                if (currentRecord.hasChildRecords && !currentRecord.hasFilteredChildRecords)
                    currentRecord.hasFilteredChildRecords = true;
            }
        },
        //ADD PARENTRECORD FOR FILTERED OTH LEVEL ITEMS
        _addParentRecord: function (record) {

            var proxy = this;

            if (record.parentItem)
                proxy._addParentRecord(record.parentItem);

            if ($.inArray(record, proxy._flatFilteredRecords) === -1) {
                proxy._flatFilteredRecords.push(record);
            }
        },


        //UPDATEEXPANDCOLLAPSE FOR SORTED RECORDS
        _updateExpandCollapseForSortedRecords: function (Record, expanded) {

            var proxy = this,
                count = 0,
                length = proxy._sortedRecords.length,
                record,
                index = proxy._sortedRecords.indexOf(Record);

            if (expanded) {

                proxy._addNestedSortRecords(Record, index);

            } else {

                var removedCount = 0;

                for (count = index + 1; count < length; count++) {

                    record = proxy._sortedRecords[count];

                    if (record.level === Record.level) {
                        break;
                    } else if (!proxy.getExpandStatus(record)) {
                        removedCount++;
                    }

                }

                proxy._sortedRecords.splice(index + 1, removedCount);

            }
        },


        //ADD NESTEDSORTRECORDS
        _addNestedSortRecords: function (record, index) {

            var proxy = this,
                childRecords,
                sortColumns = proxy.model.sortSettings.sortedColumns,
                length;

            if (sortColumns.length) {

                length = sortColumns.length - 1;
                proxy._queryManagar.queries = [];

                for (var i = length; i >= 0; i--) {

                    proxy._queryManagar.sortBy(sortColumns[i].field, sortColumns[i].direction);

                }

            }
            if (record.hasChildRecords) {

                var dataManager = ej.DataManager(record.childRecords),
                    count,
                    childrecord;

                childRecords = dataManager.executeLocal(proxy._queryManagar).result;
                length = childRecords.length;

                for (count = 0; count < length; count++) {

                    childrecord = childRecords[count];

                    if (proxy._filteredRecords.length) {

                        if ($.inArray(childrecord, proxy._filteredRecords) !== -1) {
                            proxy._sortedRecords.splice(++index, 0, childrecord);
                        }

                    } else {
                        proxy._sortedRecords.splice(++index, 0, childrecord);
                    }

                    if (childrecord.hasChildRecords && childrecord.expanded) {
                        proxy._addNestedSortRecords(childrecord, index);
                    }
                }
            }
        },

        //UPDATE Edit Settings
        updateEditSettings: function (edit) {

            var proxy = this;

            if (edit) {
                if (edit.editMode) {
                    if (proxy.model.editSettings.editMode === "normal" && edit.editMode === "cellEditing") {
                        proxy.model.editSettings.editMode = edit.editMode;
                        proxy._processEditing();
                    } else {
                        proxy.model.editSettings.editMode = edit.editMode;
                    }
                }
                if (!ej.isNullOrUndefined(edit.allowAdding))
                    proxy.model.editSettings.allowAdding = edit.allowAdding;
                if (!ej.isNullOrUndefined(edit.allowEditing))
                    proxy.model.editSettings.allowEditing = edit.allowEditing;
                if (!ej.isNullOrUndefined(edit.allowDeleting))
                    proxy.model.editSettings.allowDeleting = edit.allowDeleting;
                if (!ej.isNullOrUndefined(edit.beginEditAction))
                    proxy.model.editSettings.beginEditAction = edit.beginEditAction;
                proxy._enableEditingEvents();
            }
        },

        //UPDATE ALTROW
        updateAltRow: function () {

            var proxy = this,
                count = 0,
                currentViewData = proxy.model.updatedRecords,
                length = currentViewData.length,
                record, isAltRow = true;

            for (count = 0; count < length; count++) {
                record = currentViewData[count];
                if (record.isSummaryRow || !proxy.getExpandStatus(record))
                    continue;
                // record.isAltRow = count % 2 == 0 ? false : true;
                record.isAltRow = !isAltRow;
                isAltRow = record.isAltRow;
            }

        },


        
        //COUNT THE NUMBER OF CHILD RECORDS PRESENT IN THE GANTTRECORD
        _getFilteredChildRecordsCount: function (Record) {

            var proxy = this,
                model=proxy.model,
                length = Record&&Record.childRecords && Record.childRecords.length,
                i = 0,
                record;

            for (i = 0; i < length; i++) {

                record = Record.childRecords[i];
                if (model.enableVirtualization)
                {
                    if(proxy.getExpandStatus(record))
                    {
                        proxy._removedCount++;
                    }
                }
                else
                {
                    proxy._removedCount++;
                }
                   
                if (record.childRecords) {
                    proxy._getFilteredChildRecordsCount(record);
                }
            }

            return proxy._removedCount;
        },


        //SORTING THE RECORDS
        _sortingRecords: function (args) {

            var proxy = this,
                model = proxy.model,
                sortcolumns = model.sortSettings.sortedColumns;

            proxy._queryManagar.queries = [];

            if (sortcolumns.length) {

                var length = sortcolumns.length - 1;

                for (var i = length; i >= 0; i--) {
                    var fieldName;
                    if (model.isFromGantt) {
                        var currentColumn = ej.TreeGrid.getColumnByMappingName(proxy.model.columns, sortcolumns[i].field);
                        fieldName = currentColumn.field;
                    } else {
                        fieldName = sortcolumns[i].field;
                    }
                    if (model.isFromGantt) {
                            if (fieldName === "resourceInfo")
                                fieldName = "resourceNames";
                            else if (fieldName === "predecessor")
                                fieldName = "predecessorsName";
                    }

                    proxy._queryManagar.sortBy(fieldName, sortcolumns[i].direction);
                }
            }

            var dataManager = new ej.DataManager(model.parentRecords),
                records = dataManager.executeLocal(proxy._queryManagar).result;

            proxy._sortedRecords = [];
            proxy._storedIndex = -1;
            proxy._rowIndex = -1;

            proxy._createSortedRecords(records);
            proxy._tempsortedrecords = proxy._sortedRecords;
            proxy.model.updatedRecords = proxy._sortedRecords;
            //Update zeroLevelParentRecords
            if (model.allowPaging && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                model.parentRecords = proxy._getParentRecords(proxy.model.updatedRecords, proxy, true);

            return true;
        },


        /**
        * Create sorted collection argumented data
        * @param {data} collection of records to sorting
        */
        _createSortedRecords: function (data) {

            var proxy = this, model = proxy.model,
                sortedRecords = proxy._sortedRecords,
                dataManager,
                enableAltRow = proxy.model.enableAltRow,model=this.model;
            data = proxy._spliceSummaryRows(data);
            $.each(data, function (index, record) {
                //Skip the summary record from sorting.
                if (record.isSummaryRow) {
                    var recordIndex = record.parentItem.childRecords.indexOf(record);
                    record.parentItem.childRecords.splice(recordIndex, 1);
                    return;
                }
                if (proxy._searchString.length > 0 || (model.filterSettings.filteredColumns.length > 0)) {

                    if (proxy._filteredRecords.length > 0 && proxy._filteredRecords.indexOf(record) !== -1) {

                        proxy._storedIndex++;
                        proxy._rowIndex++;

                        if (enableAltRow) {

                            record.isAltRow = proxy._rowIndex % 2 == 0 ? false : true;

                        }

                        sortedRecords[proxy._storedIndex] = record;

                    }
                } else {

                    proxy._storedIndex++;
                    proxy._rowIndex++;

                    if (enableAltRow) {

                        record.isAltRow =proxy._rowIndex % 2 == 0 ? false : true;

                    }

                    sortedRecords[proxy._storedIndex] = record;

                }

                if (record.hasChildRecords && record.expanded) {
                    record.childRecords = proxy._spliceSummaryRows(record.childRecords);
                    dataManager = ej.DataManager(record.childRecords);
                    var childRecords = dataManager.executeLocal(proxy._queryManagar).result;
                    proxy._createSortedRecords(childRecords);

                }
                else if (record.hasChildRecords && !record.expanded && !model.enableVirtualization) {
                    record.childRecords = proxy._spliceSummaryRows(record.childRecords);
                    proxy._setChildRecords(record, sortedRecords);
                }
            });
        },

        _setChildRecords:function(record,sortedRecords)
        {
            var proxy = this,
                model = proxy.model,
                enableAltRow = proxy.model.enableAltRow,
                length = record.childRecords.length,
                dataManager;
            dataManager = ej.DataManager(record.childRecords);
            var childRecords = dataManager.executeLocal(proxy._queryManagar).result;
            for(var count=0;count<length;count++)
            {
                if (proxy._searchString.length > 0 || (model.filterSettings.filteredColumns.length > 0)) {

                    if (proxy._filteredRecords.length > 0 && proxy._filteredRecords.indexOf(childRecords[count]) !== -1) {
                        proxy._storedIndex++;
                        if (enableAltRow) {
                            childRecords[count].isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                        }
                        sortedRecords[proxy._storedIndex] = childRecords[count];
                        if (childRecords[count].hasChildRecords) {
                            this._setChildRecords(childRecords[count], sortedRecords);
                        }
                    }
                } else
                {
                    proxy._storedIndex++;
                    if (enableAltRow) {
                        childRecords[count].isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                    }
                    sortedRecords[proxy._storedIndex] = childRecords[count];
                    if (childRecords[count].hasChildRecords) {
                        this._setChildRecords(childRecords[count], sortedRecords);
                    }
                }
            }
        },
        //UPDAT THE SORTED RECORDS
        _updateSortedRecords: function (data) {

            var proxy = this,
                count = 0,
                length = data.length,
                record, model = this.model;

            for (count; count < length; count++) {

                record = data[count];

                if (!model.enableVirtualization) {

                    if (proxy._filteredRecords.length > 0) {

                        if ($.inArray(record, proxy._filteredRecords) !== -1 && $.inArray(record, proxy._sortedRecords) === -1) {
                            proxy._sortedRecords.push(record);
                        }

                    } else {

                        if ($.inArray(record, proxy._sortedRecords) === -1) {
                            proxy._sortedRecords.push(record);
                        }

                    }

                    if (record.hasChildRecords && record.childRecords.length > 0) {

                        var dataManager = ej.DataManager(record.childRecords),
                            sortedChildRecords = dataManager.executeLocal(proxy._queryManagar).result;
                        proxy._updateSortedRecords(sortedChildRecords);

                    }
                }
            }
        },


        //REMOVE SORT ICON FORM COLUMN HEADER
        _removeSortElementFromColumn: function (field) {

            var proxy = this,
                column = ej.TreeGrid.getColumnByField(proxy.model.columns, field),
                index = $.inArray(column, proxy.model.columns),
                $headerCellDiv = proxy.getHeaderTable().find("thead").find(".e-headercell").eq(index).find(".e-headercelldiv");

            $headerCellDiv.find(".ascending,.descending").remove();
            $headerCellDiv.parent().removeAttr("aria-sort");
        },


        //ADD EMPTYCOLUMN TO THE TREEGRID
        _addEmptyColumntoGrid: function () {

            var proxy = this;
            $(proxy.element).find('.e-gridheadercontainer table colgroup').append(ej.buildTag('col', "", {
                "width": "auto"
            },
            {}));
            proxy._$gridContainer.find('table colgroup').append(ej.buildTag('col', "", {
                "width": "auto"
            },
            {}));
            $(proxy.element).find('.e-gridheadercontainer table thead tr').append(ej.buildTag('th.e-headercell'));
        },


        //UPDATE THE SCROLLTOP OF THE GRIDCONTAINER
        updateScrollTop: function (y, isFromChart) {

            var args = {},
                proxy = this;

            args.requestType = ej.TreeGrid.Actions.Scroll;
            args.delta = y;

            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");

            if (!isHorizontalScroll && this.model.isFromGantt) {
                proxy._$gridContent.scrollTop(y);//grid container
            }
            else
            {
                proxy._$gridContent.scrollTop(0);
            }
            proxy.getScrollElement().ejScroller("scrollY", y, true);
            if (proxy.model.isFromGantt && !isFromChart) {
                proxy._completeAction(args);
               proxy._focusTreeGridElement();
            }
            else proxy._isFromChart = false;
            
        },

        _selectNextCell: function (direction, action) {
            var proxy = this, model = proxy.model,
                columns = model.columns,
                columnLength = columns.length,
                rowElement, cellElement,
                selectingRowIndex,
                currentSelectingRecord,
                $form = $("#" + proxy._id + "EditForm"),
                updatedRecords = proxy.getUpdatedRecords(),
                expandedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(model.updatedRecords);
            proxy._isShiftKeyNavigation = false;

            switch (direction) {
                case "right":                   
                    if ((proxy._focusingRowIndex >= updatedRecords.length - 1 && proxy._cellIndex >= columnLength - 1)
                        || (proxy._focusingRowIndex == -1 || proxy._cellIndex == -1)) {
                        proxy.element[0].focus();
                        return;
                    }
                    proxy._cellIndex += 1;
                    if (proxy._cellIndex == columnLength) {
                        proxy._cellIndex = 0;
                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);

                        if (!currentSelectingRecord)
                            return;
                        proxy._focusingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                    }
                    if (proxy._focusingRowIndex >= updatedRecords.length)
                        return;
                    if ((!columns[proxy._cellIndex].visible || !columns[proxy._cellIndex].allowCellSelection) && $form.length <= 0)
                        proxy._cellIndex = proxy.getUpNextVisibleColumnIndex(proxy._cellIndex, action);
                    if ($form.length > 0 && columns[proxy._cellEditingDetails.columnIndex].allowCellSelection)
                        proxy._cellIndex = proxy._cellEditingDetails.columnIndex;
                    var cellInfo = {
                        rowIndex: proxy._focusingRowIndex,
                        cellIndex: proxy._cellIndex
                    };
                    proxy.selectCells([cellInfo]);
                    proxy.updateScrollBar();
                    break;
                case "left":                    
                    proxy._cellIndex -= 1;
                    columnLength = columns.length;

                    if (proxy._cellIndex < 0) {
                        proxy._cellIndex = columnLength - 1;
                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, "upArrow");

                        if (!currentSelectingRecord)
                            return;
                        proxy._focusingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                    }
                    if (proxy._focusingRowIndex < 0)
                        return;
                    if (proxy._focusingRowIndex >= updatedRecords.length)
                        proxy._focusingRowIndex = updatedRecords.length - 1;
                    if ((!columns[proxy._cellIndex].visible || !columns[proxy._cellIndex].allowCellSelection) && $form.length <= 0)
                        proxy._cellIndex = proxy.getPreviousVisibleColumnIndex(proxy._cellIndex, action);
                    if ($form.length > 0 && columns[proxy._cellEditingDetails.columnIndex].allowCellSelection)
                        proxy._cellIndex = proxy._cellEditingDetails.columnIndex;

                    var cellInfo = {
                        rowIndex: proxy._focusingRowIndex,
                        cellIndex: proxy._cellIndex
                    };
                    proxy.selectCells([cellInfo]);
                    proxy.updateScrollBar();
                    break;
            }
        },
        //MOVE CURRENT CELL FOR KEYBOARD INTERACTION
        _moveCurrentCell: function (direction) {

            var proxy = this,
                rowIndex = proxy._cellEditingDetails.rowIndex,
                columnIndex = proxy._cellEditingDetails.columnIndex,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords();

            if (rowIndex == -1 && columnIndex == -1) return false;

            if (proxy.model.isEdit) {

                proxy.saveCell();
                proxy.model.isEdit = false;

            }
            if (model.enableVirtualization) {
                var record = model.currentViewData[rowIndex];
                proxy._cellEditingDetails.rowIndex = rowIndex = updatedRecords.indexOf(record);
            }
            switch (direction) {

                case "right":
                    var columns = model.columns,
                        columnLength = columns.length,
                        hiddenColumn = proxy.getHiddenColumns(),
                        visibleColumn = $.extend([], columns),
                        nextColumnIndex, newColumnIndex, visibleColumnLength;
                    if(hiddenColumn)
                    hiddenColumn.forEach(function (item) {
                        visibleColumn.splice(visibleColumn.indexOf(item), 1);
                    });
                    newColumnIndex = visibleColumn.indexOf(columns[columnIndex]);
                    visibleColumnLength = visibleColumn.length;
                    if (rowIndex == updatedRecords.length - 1 && newColumnIndex == visibleColumnLength - 1) {
                        return true;
                    }
                    if (newColumnIndex == visibleColumnLength - 1) {
                        nextColumnIndex = 0;
                        while (!columns[nextColumnIndex].visible) {
                            nextColumnIndex++;
                        }
                        proxy._cellEditingDetails.columnIndex = nextColumnIndex;
                        if(proxy._getNextRow(direction, rowIndex, proxy))
                            return true;
                        
                    }
                    else {
                        nextColumnIndex = columnIndex + 1;
                        while (!columns[nextColumnIndex].visible) {
                            nextColumnIndex++;
                        }
                        proxy._cellEditingDetails.columnIndex = nextColumnIndex;
                    }
                    while (model.columns[nextColumnIndex].allowEditing == false || !columns[nextColumnIndex].visible) {
                        if ((nextColumnIndex + 1) == model.columns.length) {
                            proxy._cellEditingDetails.columnIndex = nextColumnIndex = 0;
                            if (proxy._getNextRow(direction, rowIndex, proxy))
                                return true;
                            continue;
                        }
                        proxy._cellEditingDetails.columnIndex = ++nextColumnIndex;
                    }
                    proxy.updateScrollBar();
                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex,
                        model.columns[proxy._cellEditingDetails.columnIndex].field);
                    proxy._editAddTools();
                    break;

                case "left":
                    var columns = model.columns,
                       columnLength = columns.length,
                       hiddenColumn = proxy.getHiddenColumns(),
                       visibleColumn = $.extend([], columns),
                       prevColumnIndex, newColumnIndex, visibleColumnLength;
                    if (hiddenColumn)
                        hiddenColumn.forEach(function (item) {
                            visibleColumn.splice(visibleColumn.indexOf(item), 1);
                        });
                    newColumnIndex = visibleColumn.indexOf(columns[columnIndex]);
                    visibleColumnLength = visibleColumn.length;
                    if ((rowIndex == 0 && newColumnIndex == 0)) return true;
                    if (newColumnIndex == 0) {
                        prevColumnIndex = model.columns.length - 1;
                        while (!columns[prevColumnIndex].visible) {
                            prevColumnIndex--;
                        }
                        proxy._cellEditingDetails.columnIndex = prevColumnIndex;
                        if(proxy._getNextRow(direction, rowIndex, proxy))
                            return true;
                    } else {
                        prevColumnIndex = columnIndex - 1;
                        while (!columns[prevColumnIndex].visible) {
                            prevColumnIndex--;
                        }
                        proxy._cellEditingDetails.columnIndex = prevColumnIndex;
                    }

                    while (model.columns[prevColumnIndex].allowEditing == false || !columns[prevColumnIndex].visible) {

                        if ((prevColumnIndex - 1) == -1) {
                            proxy._cellEditingDetails.columnIndex = prevColumnIndex = columnLength - 1;
                            if (proxy._getNextRow(direction, rowIndex, proxy))
                                return true;
                            continue;
                        }
                        proxy._cellEditingDetails.columnIndex = --prevColumnIndex;
                    }
                    proxy.updateScrollBar();
                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, model.columns[proxy._cellEditingDetails.columnIndex].field);
                    proxy._editAddTools();
                    break;

                case "up":
                    if (rowIndex == 0) return true;
                    proxy._cellEditingDetails.rowIndex = rowIndex - 1;
                    proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                    proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);
                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, model.columns[proxy._cellEditingDetails.columnIndex].field);
                    break;

                case "down":
                    if (rowIndex + 1 == updatedRecords.length) {
                        proxy._focusTreeGridElement();
                        proxy._isEnterKeyPressed = true;
                    }
                    if (model.showSummaryRow) {
                        if (rowIndex + 1 == updatedRecords.length - model.summaryRows.length)
                            proxy._isEnterKeyPressed = true;
                    }
                    if (!proxy._isEnterKeyPressed) {
                        if (updatedRecords.length > (rowIndex + 1))
                            if (!model.enableVirtualization) {
                                var currentRecord = updatedRecords[rowIndex],
                                    expandedRecords = model.allowPaging? updatedRecords : proxy.getExpandedRecords(model.updatedRecords),
                                    nextRecord = expandedRecords[expandedRecords.indexOf(currentRecord) + 1];
                                //Skip the summary row from keyboard navigation.
                                if (nextRecord && nextRecord.isSummaryRow)
                                    nextRecord = proxy._getNextRecord(rowIndex + 1, expandedRecords);
                                var index = updatedRecords.indexOf(nextRecord);
                                if ((rowIndex == expandedRecords.length - 1 && columnIndex == model.columns.length - 1) || index == -1) {
                                    return true;
                                }
                                proxy._cellEditingDetails.rowIndex = index;
                            }
                            else {
                                var nextRecord = updatedRecords[rowIndex + 1];
                                //Skip the summary row from keyboard navigation.
                                if (nextRecord && nextRecord.isSummaryRow)
                                    nextRecord = proxy._getNextRecord(rowIndex + 1, updatedRecords);
                                index = updatedRecords.indexOf(nextRecord);
                                if (index == -1)
                                    return true;
                                proxy._cellEditingDetails.rowIndex = index;
                            }
                        if (!proxy._rowSelectingEventTrigger(proxy.selectedRowIndex(), proxy._cellEditingDetails.rowIndex)) {
                            proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                            proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);
                        }
                        proxy.updateScrollBar();
                        var args = {};
                        args.requestType = ej.TreeGrid.Actions.Scroll;
                        args.delta = proxy._$gridContent.children('.e-content').scrollTop();
                        proxy._trigger("actionComplete", args);
                        proxy.cellEdit(proxy._cellEditingDetails.rowIndex, model.columns[proxy._cellEditingDetails.columnIndex].field);
                        proxy._editAddTools();
                    }
                    else
                        proxy._isEnterKeyPressed = false;
                    break;
            }

            return false;

        },
        //To skip the summary record. 
        _getNextRecord: function (index, expandedRecords, action) {
            var nextRecord;
            do {
                nextRecord = expandedRecords[index];
                if (action == "upArrow" || action == "lastRowSelection" || action == "bottomRowSelection")
                    index--;
                else
                    index++;
            } while (nextRecord && nextRecord.isSummaryRow);
            return nextRecord;
        },

        _getNextRow: function (direction, rowIndex, proxy) {
            var cellIndex,
            model = proxy.model,
            index,
            updatedRecords = proxy.getUpdatedRecords();
            if (direction == "right")
                cellIndex = 1;
            else
                cellIndex = -1;

            if (!model.enableVirtualization) {
                var currentRecord = updatedRecords[rowIndex],
                  expandedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(model.updatedRecords),
                  nextRecord = expandedRecords[expandedRecords.indexOf(currentRecord) + cellIndex];
                //Skip the summary row from keyboard navigation.
                if (nextRecord && nextRecord.isSummaryRow) {
                    var action = cellIndex > 0 ? "" : "lastRowSelection";
                    nextRecord = proxy._getNextRecord(rowIndex + cellIndex, expandedRecords, action);
                }
                if (model.allowPaging && nextRecord) {
                    index = updatedRecords.indexOf(nextRecord);
                    if (index < 0 && cellIndex == 1)
                        proxy.gotoPage(proxy._currentPage() + 1);
                    else if (index < 0 && cellIndex == -1)
                        proxy.gotoPage(proxy._currentPage() - 1);
                }
                index = updatedRecords.indexOf(nextRecord);
                if(index == -1) {
                    return true;
                }
                proxy._cellEditingDetails.rowIndex = index;
            }
            else {
                var nextRecord = updatedRecords[rowIndex + cellIndex];
                //Skip the summary row from keyboard navigation.
                if (nextRecord && nextRecord.isSummaryRow) {
                    var action = cellIndex > 0 ? "" : "lastRowSelection";
                    nextRecord = proxy._getNextRecord(rowIndex + cellIndex, updatedRecords, action);
                }
                if (model.allowPaging && nextRecord) {
                    index = updatedRecords.indexOf(nextRecord);
                    if (index < 0 && cellIndex == 1)
                        proxy.gotoPage(proxy._currentPage() + 1);
                    else if(index < 0 && cellIndex == -1)
                        proxy.gotoPage(proxy._currentPage() - 1);
                }
                index = updatedRecords.indexOf(nextRecord);
                if (index == -1)
                    return true;
                proxy._cellEditingDetails.rowIndex = index;
            }
            if (model.allowSelection && model.selectionSettings.selectionMode == "cell") {
                model.selectedItem = updatedRecords[proxy._cellEditingDetails.rowIndex];
                proxy._rowIndexOfLastSelectedCell = proxy._cellEditingDetails.rowIndex;
            }
            else if (!proxy._rowSelectingEventTrigger(proxy.selectedRowIndex(), proxy._cellEditingDetails.rowIndex)) {
                proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);
            }

        },

        //FIND THE COLUMNWIDTH OF THE TREEGRID COLUMN
        _findColumnsWidth: function (extra) {

            var proxy = this,
                length = proxy.model.columns.length,
                j = proxy.getHeaderTable().find("colgroup").find("col");
            
            for (var i = 0; i < length; i++)
                proxy.columnsWidthCollection[i] = j.eq(i).width();

        },

        //CALCULATE THE TOTAL WIDTH OF THE COLUMNS
        _calculateWidth: function () {

            var j = this.getHeaderTable().find("colgroup").find("col"),
                width = 0;

            for (var i = 0; i < j.length; i++)
                width += j.eq(i).width();

            return width;
        },
        getScrollObject: function () {
            return this.getScrollElement().data("ejScroller");

        },
        //update element height when viewport height is <0
        _updateElementHeight:function()
        {
            var proxy = this;
            proxy._calculateDimensions();
            proxy.updateViewPortHeight();
        },
        /* Get scroller rendered div in treegrid*/
        getScrollElement: function () {
            if (this._frozenColumnsLength > 0)
                return this.element.find("#e-movablecontainer" + this._id);
            else
                return this._$gridContent;
        },
        /* Get width of all columns before the index or get frozen column width*/
        _getFrozenColumnWidth: function (index) {
            var width = 0,
                index = ej.isNullOrUndefined(index) ? this._frozenColumnsLength : index,
                columns = ej.isNullOrUndefined(index) ? this._frozenColumns : this.model.columns;
            if (index > 0)
            {
                for (var count = 0; count < index; count++) {
                    width += columns[count] ? this.columnsWidthCollection[count] : 0;
                }
            }
            return width;
        },
        _renderScroller: function (isFromFreezeColumn) {

            var proxy = this,
            model = proxy.model;
            var containerHeight = model.flatRecords.length * model.rowHeight;
            var contentHeight = proxy._viewPortHeight, autoHide = false;            
            if (!proxy._$gridContent.hasClass("e-scroller") || (model.allowPaging && !model.sizeSettings.height)) {
                var height = proxy._gridHeight ? contentHeight : "auto", enableTouchScroll = false;
                var width = this._gridWidth, targetPane = null;
                if (this._frozenColumnsLength > 0) {
                    proxy._$gridContent.css("width", width - proxy._totalBorderWidth);
                    width = width - this._getFrozenColumnWidth() - 1;//frozen div border width
                }
                if (!model.isFromGantt) enableTouchScroll = true;
                if (this.mobileDevice() && !model.isFromGantt) {
                    autoHide = true;
                    proxy._scrollBarHeight = 10;
                }

                proxy.getScrollElement().ejScroller({
                    enableTouchScroll: false,
                    autoHide: autoHide,
                    scrollerSize: proxy._scrollBarHeight,
                    height: proxy.model.isFromGantt ? 0 : height,
                    width: proxy.model.isFromGantt ? width : width - proxy._totalBorderWidth,
                    scroll: $.proxy(proxy._onScroll, proxy)
                });
            }
            else {
                proxy.getScrollElement().ejScroller("refresh");
            }
            proxy.getScrollElement().ejScroller("model.keyConfigs", { up: "", down: "", left: "", right: "" });
            if (ej.isNullOrUndefined(isFromFreezeColumn))
                proxy._updateScrollCss();
            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");
            if (model.allowPaging && !model.sizeSettings.height && isHorizontalScroll) {
                var scrollHeight = height + proxy._scrollBarHeight;
                proxy.getScrollElement().ejScroller({
                    height: scrollHeight,
                });
                proxy.getScrollElement().ejScroller("refresh");
            }
            if (proxy.model.isFromGantt) {
                if (!isHorizontalScroll) {
                    proxy._$gridContent.addClass("e-borderbox");
                }
                else {
                    proxy._$gridContent.removeClass("e-borderbox");
                }
            }
            
            if (!this.mobileDevice() && this.getBrowserDetails().browser== "safari" && this._frozenColumnsLength > 0) {
                this.getHeaderContent().find("#e-movableheader" + proxy._id).add(this.getContent().find("#e-movablecontainer" + proxy._id)).css("margin-left", "auto");
                if(this._$totalSummaryRowContainer)
                    this._$totalSummaryRowContainer.find("#e-movablefooter" + proxy._id).css("margin-left", "auto");
            }
            if (this._frozenColumnsLength > 0) {
                proxy._$gridContent.height(height);
                proxy.getContent().find("#e-frozencontainer" + proxy._id).height(proxy.getContent().find("#e-movablecontent" + proxy._id).height());
            }
        },
        

        
        //ALL EVENTS BOUND USING THIS._ON WILL BE UNBIND AUTOMATICALLY
        _destroy: function () {
            var proxy = this,
                model = this.model,
                columns = model.columns;
            proxy.element.off();
            
            proxy._off(proxy.element, "click", proxy._onClick);
            proxy._off(proxy.element, "keydown", proxy._keyDown);
            proxy._off(proxy.element, "click", "#" + proxy._id + "e-gridheader", proxy._onHeaderClick);
            proxy._off(proxy.element, "mousedown touchstart", "#" + proxy._id + "e-gridheader", proxy._headerMouseDown);
            proxy._off($(document), "mousedown touchstart", proxy._mouseDownHandler);
            proxy._off(proxy.element, "mousedown touchstart", ".e-gridcontent", proxy._contentMouseDown);
            proxy._off(proxy.element, "click", proxy._onRecordClick);// ".e-gridcontent",

            //Method binding for filtering data.
            if (model.filterSettings.filterBarMode == "immediate") {
                proxy._off(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._off(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
            }
            proxy._off(proxy.element, "focus click", ".e-filterbarcell input", proxy._filterBarClose);
            proxy._off(proxy.element, "click", ".e-filterbarcell .e-cancel", proxy._filterBarClose);
            if (proxy.model.showGridCellTooltip && !proxy.model.showGridExpandCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-rowcell", proxy._mouseHover);
                }
            }
            else {
                proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
            }
            if (proxy.model.showGridCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-headercelldiv", proxy._headermouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-headercelldiv", proxy._headermouseHover);
                }
            }
            proxy._off(proxy.element, "mouseleave", ".e-rowcell", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", ".e-headercelldiv", proxy._headerMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._headerMouseLeave);
            

            //MOUSE WHEEL EVENT FOR GANTT CONTROL
            if (model.isFromGantt || this._frozenColumnsLength) {
                proxy._off(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            }

            if (model.enableResize && model.isResponsive && !model.isFromGantt) {
                proxy._off($(window), "resize", proxy._windowResize);
            }
            if (ej.isTouchDevice())
                proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
            else
                proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
            //Mouse right click event for tree grid


            if (model.contextMenuSettings.showContextMenu) {
                proxy._off(proxy.element, "keyup", this._preventContextMenu);
            }
            
            this._clearColumnMenu();
            this._clearContextMenu();
            this._removeDetailsRow();
            if (proxy._columnRenameDialog) {
                proxy._columnRenameDialog.data("ejDialog") && proxy._columnRenameDialog.data("ejDialog").destroy();
                $("#" + proxy._columnRenameDialog.attr("id") + "_wrapper").remove();
                $("#" + proxy._id + 'ColumnRenameDialog').remove();
            }
            if (this.model.showColumnChooser) {
                $("#" + this._id + "ccDiv").data("ejDialog") && $("#" + this._id + "ccDiv").data("ejDialog").destroy();
                $("#" + proxy._id + "ccDiv_wrapper").remove();
                $("#" + this._id + "ccDiv").remove();
            }
            if (proxy._updateConfirmDialog) {
                proxy._updateConfirmDialog.data("ejDialog") && proxy._updateConfirmDialog.data("ejDialog").destroy();
                $("#" + proxy._updateConfirmDialog.attr("id") + "_wrapper").remove();
                $("#" + proxy._id + 'ConfirmDialog').remove();
            }
            if ($("#" + proxy._id + "_dialogColumnAdd_wrapper").length > 0) {
                $("#" + proxy._id + "_dialogColumnAdd").data("ejDialog") && $("#" + proxy._id + "_dialogColumnAdd").data("ejDialog").destroy();
                $("#" + proxy._id + "_dialogColumnAdd_wrapper").remove();
                $("#" + proxy._id + "_dialogColumnAdd").remove();
            }

            //destroy all widgets in filtterbar
            if (model.allowFiltering && !model.isFromGantt) {
                for (var count = 0 ; count < columns.length; count++) {
                    var currentElement = $("#" + this._id + "_" + columns[count].field.split('.').join("") + "_filterbarcell");
                    currentElement.data("ejWidgets") && $(currentElement).data($(currentElement).data("ejWidgets")[0]).destroy();
                }
            }
            proxy.element.empty().removeClass("e-treegrid-core e-treegrid " + proxy.model.cssClass);  
        },

        

        collapseAll: function () {
            var proxy = this,
                model = proxy.model,
                count = 0,
                ganttRecord,
                args = {},
                enableVirtualization = model.enableVirtualization,
                $gridRows = proxy.getRows(),
                $rowElement = null;

            
            //To cancel the cell edit or row edit mode when collapse the all record.
            if (proxy._isRowEdit || proxy.model.isEdit) {
                proxy._isRowEdit ? proxy.cancelRowEditCell() : proxy.cancelEditCell();
                proxy.selectRows(-1);                          
                proxy._cancelSaveTools();
            }
            args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control
            proxy._isInExpandCollapseAll = true;

            for (count = 0; count < proxy.model.parentRecords.length; count++) {
                var treegridRecord = proxy.model.parentRecords[count];
                args.data = treegridRecord;
                args.recordIndex = count;
                args.expanded = false;
                if (treegridRecord.hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(treegridRecord, args.expanded);
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshTreeGridOnExpandCollapseAll(args);

            proxy._isInExpandCollapseAll = false;

        },
        //populate the context menu with items
        _getContextMenuItems: function () {
            var contextMenuItems = [],
            proxy = this,
            contextMenuLabel = proxy._contextMenuTexts;
            contextMenuItems = [ {
                headerText: contextMenuLabel["addRowText"],
                eventHandler: null,
                isDefault: true,
                disable: false,
                menuId: "Add",
                parentMenuId: null
            },
             {
                 iconClass: "e-edit",
                 headerText: contextMenuLabel["editText"],
                 eventHandler: null,
                 isDefault: true,
                 disable: false,
                 menuId: "Edit",
                 parentMenuId: null
             },
            {
                headerText: contextMenuLabel["deleteText"],
                eventHandler: null,
                isDefault: true,
                disable: false,
                menuId: "Delete",
                parentMenuId: null
            },
            {
                iconClass: "e-save",
                headerText: contextMenuLabel["saveText"],
                eventHandler: null,
                isDefault: true,
                isEdit: true,
                disable: false,
                menuId: "Save",
                parentMenuId: null
            },
             {
                 iconClass: "e-cancel",
                 headerText: contextMenuLabel["cancelText"],
                 eventHandler: null,
                 isDefault: true,
                 isEdit: true,
                 disable: false,
                 menuId: "Cancel",
                 parentMenuId: null
             },
             {
                 iconPath: null,
                 headerText: contextMenuLabel["aboveText"],
                 eventHandler: null,
                 menuId: "Above",
                 parentMenuId: "Add"
             }, {
                 iconPath: null,
                 headerText: contextMenuLabel["belowText"],
                 eventHandler: null,
                 menuId: "Below",
                 parentMenuId: "Add"
             }
            ];
            return contextMenuItems;
        },

        //populate sub context menu items
        _getsubContextMenuItems: function () {
            var contextMenuItems = [],
            proxy = this,
            contextMenuLabel = proxy._contextMenuTexts;
            contextMenuItems = [{
                iconPath: null,
                headerText: contextMenuLabel["aboveText"],
                eventHandler: null,
                menuId: "Above",
                parentMenuId: "Add"
            }, {
                iconPath: null,
                headerText: contextMenuLabel["belowText"],
                eventHandler: null,
                menuId: "Below",
                parentMenuId: "Add"
            }
            ];
            return contextMenuItems;
        },
        _clearContextMenu: function () {
            //remove context menu items
            $('.e-contextmenu').remove();
            $('.e-innerContextmenu').remove();
        },
        // create and append a context menu and also bind the events for context menu option
        _renderContextMenu: function (e, index, item, checkEditMenu) {

            var proxy = this,
            model = proxy.model,
                eventArgs = {},
                args = {},
                posx,
				subposX,
                posy,
                subposY,
                contextMenu,
                contextMenuUList,
                subContextMenu,
                subContextMenuUList,
                coord = proxy._getCoordinate(e);
            proxy._contextMenuSelectedIndex = index;
            proxy._contextMenuSelectedItem = item;
            proxy._contextMenuEvent = e;


            if (!checkEditMenu && !this.editFormValidate())
                return;
            if (!e) e = window.event;
            subposX = posx = coord.pageX;
            subposY = posy = coord.pageY;
            
            //Edge detection for context menu
            var treeGridOffset = this.getOffsetRect(proxy.element[0]);
            treeGridOffset.bottom = treeGridOffset.top + this.element[0].offsetHeight;
            treeGridOffset.right = treeGridOffset.left + $(this.element).width();
           
            args.targetElement = e;
            args.item = item;
            args.index = index;
            args.columnIndex = proxy.getCellIndex(e);
            args.requestType = "ContextMenuOpen";
            args.contextMenuItems = proxy._contextMenuItems;
            if (proxy._trigger("contextMenuOpen", args)) return false;
            proxy._activeMenuItemId = null;
            proxy._contextMenuItems = args.contextMenuItems;
            contextMenu = ej.buildTag("div.e-contextmenu", "", {
                'display': 'table',
                'position': 'absolute',
                'z-index': proxy.getMaxZIndex() + 1,
            }, { "id": proxy._id + "_ContextMenu" });
            model.cssClass && (contextMenu.addClass(model.cssClass));
            //Get zero th level menu items
            var parentMenuItems = args.contextMenuItems.filter(function (value) {
                if (value.parentMenuId == null || value.parentMenuId == undefined)
                    return true;
            });
            contextMenuUList = ej.buildTag("ul.e-treegrid-contextmenu", $.render[proxy._id + "contextMenuTemplate"](parentMenuItems), {
                'margin': '0px',
                'padding-left': '0px'
            }, {
                'data-icon': false,
                'type': 'none',
                'data-role': 'list-divider'
            });
            
            
            contextMenu.append(contextMenuUList);
            $(document.body).append(contextMenu);

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive) 
                proxy._off($(window), "resize", proxy.windowResize);
            var contextMenuHeight = $(contextMenu).outerHeight(),
                contextMenuWidth = $(contextMenu).outerWidth(),
                contextMenuItems = contextMenu.find(".e-menuitem"),
                contextMenuSelectItem = contextMenuItems.eq(0);
            contextMenuItems.outerWidth(contextMenuWidth + 2);
            if (treeGridOffset.left > posx || (treeGridOffset.right < (posx + contextMenuWidth))) {
                if (treeGridOffset.right < (posx + contextMenuWidth)) {
                    posx = posx - contextMenuWidth;
                }
                if (posx < 0) {
                    posx = treeGridOffset.left + 10;
                }
            }
            if (treeGridOffset.bottom < posy + (contextMenuHeight)) {
                var tempPosY = posy - (contextMenuHeight);
                if (tempPosY > 0) {
                    posy = tempPosY;
                }
            }         
            contextMenu.css({ 'left': posx + 'px', 'top': posy + 'px', });
            proxy._focusTreeGridElement();
            $(contextMenu).css({ 'height': 'auto' });
            proxy._on(contextMenu, "contextmenu", function (argsE) {
                argsE.preventDefault();
            });
            //click event handlers for contextmenu items and subcontextmenu items
            $(contextMenuItems).click(function () {
                proxy._contextMenuClickHandler(this);
            });

            //Mouseenter and mouse leave handler for contextmenu items and Subcontextmenuitems
            $(contextMenuItems).mouseenter(function () {
                if (!$(this).hasClass("e-disable")) {
                    contextMenu.find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                    $(this).addClass("e-contextmenu-mouseover");
                    proxy._activeMenuItemId = $(this).attr("id");
                    proxy._showSubContextMenu(this, args.contextMenuItems);
                }
            });

            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive) 
                proxy._on($(window), "resize", proxy.windowResize);
            e.preventDefault();
        },

        //Show SubContext menu for selected Menu items
        _showSubContextMenu: function (element, menuItems) {
            var model = this.model,
                proxy = this,
                currentMenuItem = [],
                menuId = $(element).attr("id"),
                subContextMenu, subContextMenuUList, subMenuItems = [], subContextMenuItems;

            subMenuItems = menuItems.filter(function (value) {
                if (value.menuId == menuId)
                    currentMenuItem = value;
                if (value.parentMenuId == menuId)
                    return true;
            });

            if (!currentMenuItem.parentMenuId)
                $(".e-innerContextmenu").remove();

            if (currentMenuItem.parentMenuId) {
                this._removeContextMenu(currentMenuItem, menuItems);
            }

            if (subMenuItems.length > 0) {
                subContextMenu = ej.buildTag("div.e-innerContextmenu", "", {
                    'display': 'table',
                    'position': 'absolute',
                    'z-index': proxy.getMaxZIndex() + 1,
                }, { "id": this._id + "_SubContextMenu" + menuId });
                model.cssClass && (subContextMenu.addClass(model.cssClass));
                subContextMenuUList = ej.buildTag("ul", $.render[proxy._id + "contextMenuTemplate"](subMenuItems), {
                    'margin': '0px',
                    'padding-left': '0px'
                }, {
                    'data-icon': false,
                    'type': 'none',
                    'data-role': 'list-divider'
                });
                subContextMenu.append(subContextMenuUList);
                $(document.body).append(subContextMenu);
                subContextMenuItems = subContextMenu.find(".e-menuitem");
                var menuWidth = $(subContextMenu).outerWidth();
                subContextMenuItems.outerWidth(menuWidth > 100 ? menuWidth : 100);
                var subMenuOffset = proxy._getSubContextMenuPosition(element, subContextMenu);
                $(subContextMenu).css({ "top": subMenuOffset.top, "left": subMenuOffset.left });
                $(subContextMenuItems).mouseenter(function () {
                    if (!$(this).hasClass("e-disable")) {
                        proxy._showSubContextMenu(this, menuItems);
                        $(this).closest(".e-innerContextmenu").find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                        $(this).addClass("e-contextmenu-mouseover");
                        proxy._activeMenuItemId = $(this).attr("id");
                    }
                });
                proxy._on(subContextMenu, "contextmenu", function (argsE) {
                    argsE.preventDefault();
                });
                $(subContextMenuItems).click(function () {
                    proxy._contextMenuClickHandler(this);
                });
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive)
                    proxy._on($(window), "resize", proxy.windowResize);
                
            }
        },
        _removeContextMenu: function (menuItem, menuItems) {

            var currentMeuItemContainer = $("#" + this._id + "_SubContextMenu" + menuItem.parentMenuId),
                expandedMenu = $(currentMeuItemContainer).find(".e-contextmenu-mouseover");
            if ($(expandedMenu).length > 0 ) {
                var innerMenu = menuItems.filter(function (value) {
                    if (value.menuId == $(expandedMenu).attr("id"))
                        return true;
                });
                if (innerMenu.length > 0) {
                    var nextLevelItem = menuItems.filter(function (value) {
                        if (value.parentMenuId == innerMenu[0].menuId)
                            return true;
                    });
                    if (nextLevelItem.length > 0)
                        this._removeContextMenu(nextLevelItem[0], menuItems);
                }
                $("#" + this._id + "_SubContextMenu" + $(expandedMenu).attr("id")).remove();
            }
        },
        _getSubContextMenuPosition: function (element, subMenu) {
            var proxy = this, model = this.model,
                subContextMenuWidth,
                subContextMenuHeight,
                elementOffset, subMenuOffset = { top: "", left: "" },
                parentElement = $(element).closest(".e-contextmenu"),
                posx, posy,
                contextMenuWidth;
            if (parentElement.length == 0)
                parentElement = $(element).closest(".e-innerContextmenu");

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive)
                proxy._off($(window), "resize", proxy.windowResize);

            subContextMenuWidth = $(subMenu).outerWidth(),
            subContextMenuHeight = $(subMenu).height(),
            elementOffset = this.getOffsetRect(element),

            contextMenuWidth = $(parentElement).outerWidth();
            subMenuOffset.top = elementOffset.top - 1;
            subMenuOffset.left = elementOffset.left + $(parentElement).width() + 1;
            posx = subMenuOffset.left;

            //Edge detection for context menu
            var treeGridOffset = this.getOffsetRect(this.element[0]);
            treeGridOffset.bottom = treeGridOffset.top + this.element[0].offsetHeight;
            treeGridOffset.right = treeGridOffset.left + $(this.element).width();
            if (treeGridOffset.left > posx || (treeGridOffset.right < (posx + subContextMenuWidth))) {
                if (treeGridOffset.right < (posx + subContextMenuWidth)) {
                    posx = posx - contextMenuWidth - subContextMenuWidth;
                }
                if (posx > 0) {
                    subMenuOffset.left = posx;
                }
            }
            if (treeGridOffset.bottom < subMenuOffset.top + subContextMenuHeight) {
                var tempPosY = (subMenuOffset.top + subContextMenuHeight) - treeGridOffset.bottom;
                tempPosY = subMenuOffset.top - tempPosY - 2;
                if (tempPosY > 0) {
                    subMenuOffset.top = tempPosY;
                }
            }
            return subMenuOffset;
        },
        _contextMenuClickHandler: function (target)
        {
            var choice = $(target).attr('id'),
                proxy = this;
            if (!$(target).hasClass("e-disable") && $(target).find(".e-expander").length == 0) {
                switch (choice) {
                    case "Delete":
                        proxy.contextMenuOperations("Delete");
                        break;
                    case "Above":
                        proxy.contextMenuOperations("Above");
                        break;
                    case "Below":
                        proxy.contextMenuOperations("Below");
                        break;
                    case "Add":
                        proxy.contextMenuOperations("Add");
                        break;
                    case "Edit":
                        proxy.contextMenuOperations("Edit");
                        break;
                    case "Save":
                        proxy.contextMenuOperations("Save");
                        break;
                    case "Cancel":
                        proxy.contextMenuOperations("Cancel");
                        break;
                    default:
                        proxy.contextMenuOperations(choice);
                        break;
                }
            }
        },

        //Call custom context menu event handlers
        _triggerMenuEventHandler: function (menuId, eventArgs) {
            var proxy = this,
                contextMenuItems = proxy._contextMenuItems,
                currentMenuItemCollection, menuItem;

            if (!ej.isNullOrUndefined(contextMenuItems)) {
                currentMenuItemCollection = contextMenuItems.filter(function (value) {
                    //convert menu id to string if it is given as number
                    if (value.menuId.toString() === menuId)
                        return true;
                });

                if (currentMenuItemCollection.length > 0) {
                    menuItem = currentMenuItemCollection[0];
                    var fn = menuItem.eventHandler;
                    if (fn) {
                        if (typeof fn === "string") {
                            fn = ej.util.getObject(fn, window);
                        }
                        if ($.isFunction(fn)) {
                            var args = ej.event("customContextMenuHandler", this.model, eventArgs);
                            fn.call(this, args);
                        }
                    }

                }
            }
        },

        _createContextMenuTemplate: function () {
            var proxy = this;
            var helpers = {};
            helpers["_" + proxy._id + "getHeaderName"] = $.proxy(proxy._getHeaderName, proxy);

            $.views.helpers(helpers);

            var menuItemList = "<li style='list-style-type:none;margin:0px;'>";
            var listChild = "<div class='e-menuitem {{if disable}}e-disable{{/if}}{{if ~_" + proxy._id + "getHeaderName(#data)}} e-parent-menuitem{{/if}}' id={{:menuId}}  style='display:table;cursor:{{if disable}}default{{else}}pointer{{/if}};min-width:100px;'>" +
                            "{{if iconPath}}" +
                           "<div class='e-icon e-contextmenu-image'" +
                            " style='background-image:{{:iconPath}};background-repeat:no-repeat;'/> " + 
                            "{{else}}" +
                            "<div class='e-icon {{:iconClass}} e-contextmenu-icon'/>" +
                            "{{/if}}" +
                            "<div class='e-contextmenu-label'>" +
                            "<span>{{:headerText}}</span></div>" +
                            "{{if ~_" + proxy._id + "getHeaderName(#data)}}<div class='e-icon e-expander'/> {{/if}}";

            menuItemList += listChild;
            menuItemList += "</div></li>";
            var templates = {};
            templates[proxy._id + "contextMenuTemplate"] = menuItemList;
            $.templates(templates);
        },
        _getHeaderName: function (data) {
            var childMenuItems = this._contextMenuItems.filter(function (value) {
                if (data.menuId != null && data.menuId == value.parentMenuId)
                    return true;
            });
            if (childMenuItems.length > 0) {
                return true;
            }
            return false;
        },

        // Remove the speace from column menu name for chaning name to id.

        _getColumnId: function (data) {
            return data.name.replace(/\s/g, "");
        },

        //Change the context menu based on context menu item list.
        _updateContextmenuOption: function (recordIndex) {
            //removing empty string and undefined from contextmenu items.
            Array.prototype.clean = function (deleteValue) {
                for (var i = 0; i < this.length; i++) {
                    if (this[i] == deleteValue) {
                        this.splice(i, 1);
                        i--;
                    }
                }
                return this;
            };
            var proxy = this;
            
            if(proxy._isRowEdit || proxy.model.isEdit)
            {
                //Remove add, delete and edit context menu when row in edit mode.
                proxy._contextMenuItems.splice(0, 3);
            }
            else
            {
                proxy._contextMenuItems.splice(3, 2); //Remove save and cancel when row not in edit mode
                var editSetting = proxy.model.editSettings;
                var contextMenuItems = $.extend(true, [], proxy._contextMenuItems);
                var contextMenuList = proxy.model.contextMenuSettings.contextMenuItems.clean("").clean(undefined);
                var contextMenuItemList = [];
                //removing duplicate conetxt menu items
                $.each(contextMenuList, function (i, el) {
                    if ($.inArray(el.toLowerCase(), contextMenuItemList) === -1) contextMenuItemList.push(el.toLowerCase());
                });
                proxy._contextMenuItems = [];
                if (recordIndex == -1) {
                    if (contextMenuItemList.indexOf("add") != -1 || contextMenuItemList.length==0)
                        proxy._contextMenuItems[0] = contextMenuItems[0];
                    if (!editSetting.allowAdding)
                        proxy._contextMenuItems[0].disable = true;
                    proxy._contextAddMenuIndex = 0;
                }
                //Adding default context menu when user not specify the context menu items.
                else if (contextMenuItemList.length == 0)
                {
                    proxy._contextMenuItems[0] = contextMenuItems[0];
                    if (!editSetting.allowAdding)
                        proxy._contextMenuItems[0].disable = true;
                    proxy._contextAddMenuIndex = 0;
                    proxy._contextMenuItems[1] = contextMenuItems[2];
                    if (!editSetting.allowDeleting)
                        proxy._contextMenuItems[1].disable = true;
                    proxy._contextMenuItems.push.apply(proxy._contextMenuItems, proxy._subContextMenuItems);
                }
                //Change the context menu order based on context menu items order
                else {
                for(var i=0;i<contextMenuItemList.length;i++)
                {
                    var item=contextMenuItemList[i];
                    switch(item.toLowerCase())
                    {
                        case "add":
                            proxy._contextMenuItems[i] = contextMenuItems[0];
                            proxy._contextAddMenuIndex = i;
                            if (!editSetting.allowAdding)
                                proxy._contextMenuItems[i].disable = true;
                            break;
                        case "delete":
                            proxy._contextMenuItems[i] = contextMenuItems[2];
                            if (!editSetting.allowDeleting)
                                proxy._contextMenuItems[i].disable = true;
                            break;
                        case "edit":
                            proxy._contextMenuItems[i] = contextMenuItems[1];
                            if (!editSetting.allowEditing)
                                proxy._contextMenuItems[i].disable = true;
                            break;
                    }
                }
                proxy._contextMenuItems.push.apply(proxy._contextMenuItems, proxy._subContextMenuItems);
                }
            }
        },
        //Assign default value to columns based on column edit type
        _setInitialData:function()
        {
            var eventArgs = {}, proxy = this,
               model = proxy.model, data = [], item, initialData = {};
            for (var i = 0; i < model.columns.length; i++)
            {
                var column = model.columns[i];
                switch(column.editType)
                {
                    case "booleanedit":
                        initialData[column.field] = false;
                        break;
                    case "stringedit":
                        initialData[column.field] = null;
                        break;
                    case "datepicker":
                        initialData[column.field] = ej.format(new Date(), this.model.dateFormat, this.model.locale);
                        break;
                    case "datetimepicker":
                        initialData[column.field] = ej.format(new Date(), "MM/dd/yyyy hh:mm tt", this.model.locale);
                        break;
                    case "numericedit":
                        initialData[column.field] = 0;
                        break;
                    default:
                        initialData[column.field] = null;

            }
            }
            data.push(initialData);
            if (proxy.dataSource() == null || proxy.dataSource().length == 0 || model.flatRecords.length == 0) {
                
                item = proxy._createRecord(data[0], 0, null);
                item.index = 0;
                proxy._addRecord(item, ej.TreeGrid.RowPosition.Top);
                proxy._clearContextMenu();
                this._removeDetailsRow();
            }
        },
        
        // Perform add new row operation
           
        _subContextMenuAction: function (item, index, position, addrow)
        {
            var proxy = this, model = proxy.model,
            eventArgs = {},
            newItem, selectionIndex;

            eventArgs.requestType = "save";
            newItem = jQuery.extend(true, {}, item.item);
            newItem[proxy.model.childMapping] = null;
            if (model.idMapping && model.parentIdMapping && newItem[model.parentIdMapping])
                delete newItem[model.parentIdMapping];

            if (position == "Above") {
                proxy._addRecord(newItem, ej.TreeGrid.RowPosition.Above);
            } else if (position == "Below") {
                proxy._addRecord(newItem, ej.TreeGrid.RowPosition.Below);
            }
            proxy._clearContextMenu();
        },

        _appendEditTemplateRow: function (columns, $targetTr, index, isFrozenTr, addrow) {

            var model = this.model,
                proxy = this,
                rowHeight = proxy.model.rowHeight, $mainTd,
                $form, $frozenForm, $table, $detailCell, visibleColumns = [],
                updatedRecords = proxy.getUpdatedRecords();

            this._editedRowIndex = index;
            $table = ej.buildTag('table.e-table', "", {}, { "cellspacing": "0px", "cellpadding": "0" });
            if (this._frozenColumnsLength > 0) {
                if (isFrozenTr) {
                    $form = ej.buildTag("form.#" + proxy._id + "EditFrozenForm", "", { "margin": "-2px 0px" }, {});
                    $table.append(proxy._$gridHeaderContainer.find("#e-frozenheaderdiv" + proxy._id).find('colgroup').clone());
                } else {
                    $form = ej.buildTag("form.#" + proxy._id + "EditForm", "", { "margin": "-2px 0px" }, {});
                    $table.append(proxy._$gridHeaderContainer.find("#e-movableheaderdiv" + proxy._id).find('colgroup').clone());
                }
            } else {
                $form = ej.buildTag("form.#" + proxy._id + "EditForm", "", { "margin": "-2px 0px" }, {});
                $table.append(proxy.getHeaderTable().find('colgroup').clone());
            }


            if (!isFrozenTr && model.showDetailsRow && model.showDetailsRowInfoColumn && model.detailsTemplate) {
                $detailCell = $targetTr.find("td.e-detailsrowcell");
            }

            $targetTr.empty();
            if (addrow) {
                $targetTr.addClass('e-addedrow');
                if ($targetTr.next('tr').hasClass('e-detailsrow'))
                    $targetTr.next('tr').remove();
            }
            else
                $targetTr.addClass('e-rowedit');

            visibleColumns = columns.filter(function (value) {
                return !(value.visible === false);
            });
            $mainTd = ej.buildTag("td", "", {}, { "colspan": $detailCell ? visibleColumns.length + 1 : visibleColumns.length });
            if (model.allowSelection)
                var $tr = ej.buildTag('tr.e-treegridrows e-selectionbackground e-active', { "height": rowHeight }, {});
            else
                var $tr = ej.buildTag('tr.e-treegridrows', { "height": rowHeight }, {});
            var $tbody = ej.buildTag('tbody'),
            $cellEditTemplate = proxy._cellEditTemplate;
            var columnLength = columns.length;
            for (var column = 0; column < columnLength; column++) {
                if (!ej.isNullOrUndefined(column)) {
                    if (columns[column].visible) {
                        var data = {}, columnField = proxy._getFieldValue(columns[column].field, model.columns.indexOf(columns[column])),
                        //Create a html string for column field with specific edit type using cellEditTemplate
                        htmlString = $cellEditTemplate.find("#" + columnField + "_CellEdit").html();
                        var value = proxy._getCustomCellValue(updatedRecords[index], columns[column]["field"]);
                        data[columnField] = value;
                            if (columns[column]["editType"] == "dropdownedit" && data[columns[column]["field"]] == false)
                                data[columnField] = data[columnField].toString();
                         var $element = $($.templates(htmlString).render(data)), 
                         $td = ej.buildTag('td.e-rowcell e-editedcell', "", { "height": rowHeight, "vertical-align": "middle;", "overflow": "hidden" }, {});

                        $td.addClass('e-validError');

                        if (columns[column].allowEditing == false)
                            $element.attr('disabled', true).addClass('e-disable');

                        if ($element.get(0).tagName == "SELECT") {
                            $element.val(data[columns[column]["field"]]);
                            $element.val() == null && $element.val($element.find("option").first().val());
                        }
                        if ($element.get(0).tagName == "INPUT") {
                            $element.val(data[columnField]);
                        }
                        $tr.append($td.append($element));
                        $tbody.append($tr);
                    }
                }
            }
            if ($detailCell) {
                $tr.append($detailCell);
            }
            $table.append($tbody);
            $form.append($table);
            $mainTd.append($form);
            $targetTr.append($mainTd);

        },
        //Create editable row with specific edit type.

        _editRow: function (index, addrow, columnIndex) {
            var proxy = this,
                model = proxy.model,
            rowHeight = model.rowHeight,
            $form, $frozenForm, $table,
            updatedRecords = proxy.getUpdatedRecords(),
            isAddRow = false;

            proxy._editedRowIndex = index;

            var $targetTr = ej.TreeGrid.getRowByIndex(proxy, index);
            if ($targetTr.hasClass("e-summaryrow")) {
                proxy._editAddTools();
                return;
            }
            if (ej.isNullOrUndefined(addrow)) {
                var args = {};
                args.data = updatedRecords[index];
                args.rowElement = $targetTr;
                args.rowIndex = index;
                args.columnIndex = columnIndex;
                isAddRow = false;
                if (proxy._trigger("beginEdit", args)) return false;
            }
            else
                isAddRow = true;
            if (this._frozenColumnsLength > 0) {
                proxy._appendEditTemplateRow(proxy._frozenColumns, $($targetTr[0]), index, true, addrow);
                proxy._appendEditTemplateRow(proxy._unFrozenColumns, $($targetTr[1]), index, false, addrow);
            } else {
                proxy._appendEditTemplateRow(model.columns, $($targetTr), index, false, addrow);
            }
            proxy._isRowEdit = true;
            proxy._setoffsetWidth();
            proxy._editAddTools();
            var args = {};
            if (isAddRow)
            {
                args.data = {};
                args.requestType = "add";
            }
            else
            {
                args.columnIndex = columnIndex;
                args.data = updatedRecords[index];
                args.requestType = "beginEdit";
            }
           
           
            proxy._refreshEditForm(args);
            if ($.isFunction($.validator)) {
                proxy._initValidator();
                proxy.setValidation();
            }
            model.selectedItem = updatedRecords[index];
        },

        //Creating column chooser menu

        _renderColumnChooser: function () {
            var proxy = this,
                $outerDiv = ej.buildTag("div.e-columnSelector", '',"", { id: this._id + "ccDiv" });
            $("#" + proxy._id + "ccDiv_wrapper").remove();
            proxy._renderColumnChooserList(false);
            $outerDiv.append(proxy._columnChooserList);
            $outerDiv.insertAfter(proxy.element);
            $outerDiv.data("columnMenuDialog", "TreeGrid");
            $outerDiv.ejDialog({ showOnInit: false, allowKeyboardNavigation: false, enableResize: false, "enableRTL": false, showHeader: false, width: "auto",allowDraggable: false,
                                 position: { X: 1, Y: 1 }, enableAnimation: false, minWidth:"0px", minHeight:"0px" });
            $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content").addClass("e-treegrid-columnchooser");
        },

        //render filter menu dialog
        _renderFilterMenu: function (filterType) {
            var proxy = this, numeric = 0, srting = 0, datepicker = 0, DropDown = 0, datetimepicker = 0, boolean = 0, column = this.model.columns, dropdownValue;
            if (!filterType) {
                for (var x = 0; x < column.length; x++) {
                    if (column[x].filterEditType == "numericedit" || column[x].editType == "numericedit")
                        numeric++;
                    if (column[x].filterEditType == "stringedit" || column[x].editType == "stringedit")
                        srting++;
                    if (column[x].filterEditType == "datepicker" || column[x].editType == "datepicker")
                        datepicker++;
                    if (column[x].filterEditType == "datetimepicker" || column[x].editType == "datetimepicker")
                        datetimepicker++;
                    if (column[x].filterEditType == "booleanedit" || column[x].editType == "booleanedit")
                        boolean++;
                    if (column[x].filterEditType == "dropdownedit" || column[x].editType == "dropdownedit") {
                        DropDown++;
                        dropdownValue = column[x];
                    }
                }
            }
            if (srting > 0 || filterType == "stringedit") {
                proxy._renderEdittypeFilterMenu("String");
                proxy._renderedFilterMenuDialog.push("stringedit");
            }
            if (numeric > 0 || filterType == "numericedit") {
                proxy._renderEdittypeFilterMenu("Numeric");
                proxy._renderedFilterMenuDialog.push("numericedit");
            }
            if (datepicker > 0 || filterType == "datepicker") {
                proxy._renderEdittypeFilterMenu("Datepicker");
                proxy._renderedFilterMenuDialog.push("datepicker");
            }
            if (datetimepicker > 0 || filterType == "datetimepicker") {
                proxy._renderEdittypeFilterMenu("Datetimepicker");
                proxy._renderedFilterMenuDialog.push("datetimepicker");
            }
            if (DropDown > 0 || filterType == "dropdownedit") {
                proxy._renderEdittypeFilterMenu("Dropdown", dropdownValue);
                proxy._renderedFilterMenuDialog.push("dropdownedit");
            }
            if (boolean > 0 || filterType == "booleanedit") {
                proxy._renderEdittypeFilterMenu("Boolean");
                proxy._renderedFilterMenuDialog.push("booleanedit");
            }
        },

        //render filter menu dialog box depends on its filterEditType
        _renderEdittypeFilterMenu: function (idvalue, dropdownValue) {
            var proxy = this, filterTable,
                $outerDiv = ej.buildTag("div.e-" + proxy._id + "filter" + idvalue + "Selector e-filterMenuDiv e-treegridmenufilterwraper", "", {}, { id: this._id + "filter" + idvalue + "MenuDiv" }),
                localeFilterTexts = proxy._filterMenuTexts;
            if (idvalue == "Dropdown") {
                filterTable = "<div class='e-filter-container'><div class='e-dropdown-filter-container'><input id='" + this._id + "filter" + idvalue + "DropDown'/></div><div class='e-filter-button-container'><div class='e-filter-btn-filter'><button id='" + this._id + "filter" + idvalue + "MenuButton' class='e-filterMenuDiv'>" + localeFilterTexts.filterButton + "</button></div><div class='e-filter-btn-clear'><button id='" + this._id + "filter" + idvalue + "ClearButton' class='e-filterMenuDiv'>" + localeFilterTexts.clearButton + "</button></div></div></div>";
            } else if (idvalue == "Boolean") {
                filterTable = "<div class='e-filter-container'><div class='e-checkbox-filter-container'><span class='e-checkbox-filter-text'>" + localeFilterTexts.filterValue + "</span><div class='e-checkbox-filter-control' style='padding-bottom:14px;padding-left: 48%;'><input id='" + this._id + "filter" + idvalue + "InputBox'/></div><div class='e-filter-button-container'><div class='e-filter-btn-filter'><button id='" + this._id + "filter" + idvalue + "MenuButton' class='e-filterMenuDiv'>" + localeFilterTexts.filterButton + "</button></div><div class='e-filter-btn-clear'><button id='" + this._id + "filter" + idvalue + "ClearButton' class='e-filterMenuDiv'>" + localeFilterTexts.clearButton + "</button></div></div></div>";
            }
            else {
                filterTable = "<div class='e-filter-container'><div class='e-filter-operator'><input id='" + this._id + "filter" + idvalue + "DropDown'/></div><span class='e-filter-text'>" + localeFilterTexts.filterValue + "</span><div class='e-filter-value'><input id='" + this._id + "filter" + idvalue + "InputBox'/></div><div class='e-filter-button-container'><div class='e-filter-btn-filter'><button id='" + this._id + "filter" + idvalue + "MenuButton' class='e-filterMenuDiv'>" + localeFilterTexts.filterButton + "</button></div><div class='e-filter-btn-clear'><button id='" + this._id + "filter" + idvalue + "ClearButton' class='e-filterMenuDiv'>" + localeFilterTexts.clearButton + "</button></div></div></div>";
            }
            $outerDiv.append(filterTable);
            $outerDiv.insertAfter(proxy.element);
            proxy._renderFilterMenuDialog(idvalue + "MenuDiv", idvalue, dropdownValue, localeFilterTexts);
            $outerDiv.data("filter" + idvalue + "MenuDialog", "TreeGrid");
            $outerDiv.ejDialog({
                showOnInit: false, allowKeyboardNavigation: false, enableResize: false, "enableRTL": false, showHeader: false, width: "auto", allowDraggable : false,
                position: { X: 1, Y: 1 }, enableAnimation: false, cssClass: proxy.model.cssClass
            });
            $("#" + proxy._id + "filter" + idvalue + "MenuDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css({ 'height': 'auto','width':'auto' }).removeClass("e-widget-content");
            $("#" + proxy._id + "filter" + idvalue + "MenuDiv_wrapper").css("outline", "none").addClass("e-treegrid-columnchooser");
        },

        //render filter menu inner components for each dialog box depends on its filterEditType
        _renderFilterMenuDialog: function (idValue, inputIdValue, dropdownValue, localeFilterTexts) {

            var proxy = this, localization, groups, initialtextvalue, field1;
            if (inputIdValue == "String") {
                groups = localeFilterTexts.stringMenuOptions;
                initialtextvalue = "endswith";
                field1 = { value: "value", text: "text" };
            }
            if (inputIdValue == "Numeric" || inputIdValue == "Datepicker" || inputIdValue == "Datetimepicker") {
                groups = localeFilterTexts.numberMenuOptions;
                initialtextvalue = "GreaterThan";
                field1 = { value: "value", text: "text" };
            }
            if (inputIdValue == "Dropdown") {
                groups = dropdownValue.dropdownData;
                if (dropdownValue.editParams)
                    field1 = { value: dropdownValue.editParams.fields.value, text: dropdownValue.editParams.fields.text };
                else
                    field1 = { value: "value", text: "text" };
            }
            if (inputIdValue == "String") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejAutocomplete({
                    width: "100%",
                    watermarkText: localeFilterTexts.enterValueText,
                    filterType: initialtextvalue,
                    enableResize:false,
                    enableDistinct: true,
                    locale: proxy.model.locale,
                    cssClass: proxy.model.cssClass
                });
            }
            if (inputIdValue == "Numeric") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejNumericTextbox({
                    decimalPlaces: 2,
                    width: "100%",
                    locale: proxy.model.locale,
                });
            }
            if (inputIdValue == "Boolean") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejCheckBox({
                    size: "small"
                });
            }
            if (inputIdValue == "Datetimepicker") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejDateTimePicker({
                    width: "100%",
                    locale: proxy.model.locale,
                    cssClass: proxy.model.cssClass
                });
            }
            if (inputIdValue == "Datepicker") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejDatePicker({
                    width: "100%",
                    locale: proxy.model.locale,
                    cssClass: proxy.model.cssClass
                });
            }
            if (inputIdValue != "Boolean") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'DropDown').ejDropDownList({
                    dataSource: groups,
                    selectedIndex: 1,
                    fields: field1,
                    select: function (args) {
                        if (inputIdValue == "String") {
                            var suggesionBox = $("#" + proxy._id + "filter" + inputIdValue + "InputBox").data("ejAutocomplete");
                            suggesionBox.option("filterType", args.value);
                        }
                    },
                    cssClass: proxy.model.cssClass,
                    width: "100%"
                });
            }

            $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'MenuButton').ejButton({
                size: "normal",
                width: "100%",
                cssClass: proxy.model.cssClass,
                click: function (args) {
                    var columnFieldName = $.trim(proxy._columnMenuTarget.prev("div.e-headercelldiv").attr("ej-mappingname")),
                    column = proxy.getColumnByField(columnFieldName), suggesionBox, dropDown;
                    if (args.e.target.id == proxy._id + "filterStringMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterStringInputBox").data("ejAutocomplete");
                        dropDown = $("#" + proxy._id + "filterStringMenuDiv").find("#" + proxy._id + "filterStringDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.value(), dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterNumericMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterNumericInputBox").data("ejNumericTextbox");
                        dropDown = $("#" + proxy._id + "filterNumericMenuDiv").find("#" + proxy._id + "filterNumericDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.model.value, dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDropdownMenuButton") {
                        dropDown = $("#" + proxy._id + "filterDropdownMenuDiv").find("#" + proxy._id + "filterDropdownDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, dropDown.model.value, "equal");
                    }
                    if (args.e.target.id == proxy._id + "filterDatepickerMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterDatepickerInputBox").data("ejDatePicker");
                        dropDown = $("#" + proxy._id + "filterDatepickerMenuDiv").find("#" + proxy._id + "filterDatepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.model.value, dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDatetimepickerMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterDatetimepickerInputBox").data("ejDateTimePicker");
                        dropDown = $("#" + proxy._id + "filterDatetimepickerMenuDiv").find("#" + proxy._id + "filterDatetimepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.model.value, dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterBooleanMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterBooleanInputBox").data("ejCheckBox");
                        if (suggesionBox.model.checkState == "uncheck")
                            proxy._performMenuFilter(column, false, "equal");
                        else if (suggesionBox.model.checkState == "check")
                            proxy._performMenuFilter(column, true, "equal");
                    }
                }
            });

            $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'ClearButton').ejButton({
                size: "normal",
                width: "100%",
                cssClass: proxy.model.cssClass,
                click: function (args) {
                    var columnFieldName = $.trim(proxy._columnMenuTarget.prev("div.e-headercelldiv").attr("ej-mappingname")),
                    column = proxy.getColumnByField(columnFieldName), dropDown;
                    if (args.e.target.id == proxy._id + "filterStringClearButton") {
                        dropDown = $("#" + proxy._id + "filterStringMenuDiv").find("#" + proxy._id + "filterStringDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterNumericClearButton") {
                        dropDown = $("#" + proxy._id + "filterNumericMenuDiv").find("#" + proxy._id + "filterNumericDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDropdownClearButton") {
                        dropDown = $("#" + proxy._id + "filterDropdownMenuDiv").find("#" + proxy._id + "filterDropdownDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", "equal");
                    }
                    if (args.e.target.id == proxy._id + "filterDatepickerClearButton") {
                        dropDown = $("#" + proxy._id + "filterDatepickerMenuDiv").find("#" + proxy._id + "filterDatepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDatetimepickerClearButton") {
                        dropDown = $("#" + proxy._id + "filterDatetimepickerMenuDiv").find("#" + proxy._id + "filterDatetimepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterBooleanClearButton") {
                        proxy._performMenuFilter(column, "", "equal");
                    }
                }
            });
        },
        /*  Creating Column Chooser menu list with column header name
		    argument refresh in boolean data type
		    If it is false, rendering the column chooser list
            If is is true, rerendering the column chooser list
        */

        _renderColumnChooserList: function (refresh, headerText) {
            var proxy = this,
                length = proxy.model.columns.length,
                columns = proxy.model.columns,
                $listBox = ej.buildTag("div", '', { 'margin-left': '0px', "width": "auto" });
            for (var index = 0; index < length; index++) {
                if (proxy.model.treeColumnIndex != index && columns[index].showInColumnChooser ==true ) {
                    var column = columns[index];
                    if (column.nonColumn) continue;
                    if (!ej.isNullOrUndefined(column)) {
                        var $innerDiv = ej.buildTag('div', '',"", { 'class': 'e-columnMenuListDiv' }),
                            styleAttr = {},
                            colValue = ej.isNullOrUndefined(column.headerText) ? column.field : column.headerText,
                            $input = ej.buildTag('input', '', styleAttr, { 'id': proxy._id + "_columnMenu_" + column.field.split('.').join(""), 'value': colValue, 'type': 'checkbox' }),
                            label = ej.buildTag('label', colValue, {"width": "auto" }, { 'for': proxy._id + "_columnMenu_" + column.field.split('.').join("") });
                        $innerDiv.append($input);
                        $innerDiv.append(label);
                        $innerDiv.data("column", column.headerText);
                        $listBox.append($innerDiv);
                        if (column.headerText == headerText)
                            $innerDiv.addClass("e-columnmenuselection");
                        $input.ejCheckBox({
                            checked: !ej.isNullOrUndefined(column.visible) ? column.visible : true,
                            cssClass: proxy.model.cssClass,
                            change: function(args)
                            {
                                var columnName = "";
                                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                                    columnName = this.element.closest(".e-columnMenuListDiv").data().column;
                                } else {
                                    columnName = args.model.value;
                                }
                                if (!args.isChecked)
                                    proxy.hideColumn(columnName);
                                else
                                    proxy.showColumn(columnName);
                            }
                        });
                    }
                }
            }
            if (!refresh) 
                proxy._columnChooserList = $listBox;
            else {
                proxy._columnChooserList.empty().append($listBox.children());
                proxy._focusTreeGridElement();
            }
            var columnChooserListItem = proxy._columnChooserList.find("div.e-columnMenuListDiv");
            $(columnChooserListItem).mouseenter(function () {
                columnChooserListItem.removeClass("e-columnmenuselection");
                $(this).addClass("e-columnmenuselection");
            });
        },

        //Template for column menu

        _createColumnMenuTemplate:function()
        {
            var proxy = this;
            var columnMenuList = "<li style='list-style-type:none;'>" +
                                 "<div class='e-columnmenuitem{{if enabled==false}} e-disable{{/if}}{{if (menuId =='Columns' || menuId =='Filter')}} e-parent-menuitem{{/if}}' style='display:table;cursor:pointer'" +
                                    " id='" + proxy._id + "_{{:menuId}}Chooser'>" +
                                "<div class='e-icon {{:icon}} e-treegridicon' style='display:inline-block;'></div>" +
                                "<div class='e-menuitem-label' style='display:inline-block;width:auto'>" +
                                "<span>{{:name}}</span></div>" +
                                "{{if (menuId =='Columns' || menuId =='Filter')}}<div class='e-icon e-expander e-treegridicon' style='display:inline-block;float:right;'/> {{/if}}" +
                                "</div>" +
                                "{{if menuId == 'RenameColumn' || menuId == 'SortDescending'}}<hr class='e-menuitem-hr'>{{/if}}" +
                                "</li>";            
            var templates = {};
            templates[proxy._id + "columnMenuTemplate"] = columnMenuList;
            $.templates(templates);
        },

        //render filter menu dialog in a respective position while clicking filter menu icon
        _updateFilterMenuList: function (e) {
            var proxy = this,
               model = proxy.model,
               columnFilterPosX, posY,
               posX,
               containerOffset,
               $target = $(e.target),
               targetWidth = targetHeight = 0,
               targetWidth = $target[0].offsetWidth,
               targetHeight = $target[0].offsetHeight,
               columnFieldName = $.trim($target.prev("div.e-headercelldiv").attr("ej-mappingname")), position,
               element, editType, str, index, filtertype,
               column = proxy.getColumnByField(columnFieldName);
            posX = columnFilterPosX = posY = 0;
            proxy._clearFilterMenu();
            proxy._clearColumnMenu("columnmenu");
            proxy._columnMenuTarget = $target;
            proxy._filterIconTarget = e;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            position = proxy.getOffsetRect($target[0]);
            position.top = position.top + targetHeight;
            if (!proxy.model.isFromGantt)
                posY = position.top + targetHeight;
            else
                posY = position.top + targetHeight;
            element = !model.isFromGantt ? $(this.element) : $(this.element).closest(".e-gantt"),
            containerOffset = this.getOffsetRect(element[0]);
            containerOffset.bottom = containerOffset.top + element[0].offsetHeight;
            containerOffset.right = containerOffset.left + $(element).width();
            if (column.filterEditType) {
                index = column.filterEditType.indexOf("edit");
                filtertype = column.filterEditType;
            }
            else {
                index = column.editType.indexOf("edit");
                filtertype = column.editType;
            }
            if (index != -1) {
                editType = filtertype.slice(0, index);
                str = editType.charAt(0).toUpperCase() + editType.slice(1);
                proxy._showFilterMenu("filtermenu", "filter" + str, position, targetWidth, containerOffset.right, posX, null, null, column, posY);
            } else {
                str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                proxy._showFilterMenu("filtermenu", "filter" + str, position, targetWidth, containerOffset.right, posX, null, null, column, posY);
            }
            proxy._updatePreviousFilteredValue(column);
        },
        //Creating Column Menu

        _renderColumnMenu: function (e) {
            var proxy = this,
                model = proxy.model,
                posX, columnListPosX, columnFilterPosX, posY,
                $target = $(e.target),
                targetWidth = targetHeight = 0,
                columnMenuItems = [],
                columnChooserListIndex = 0,
                targetWidth = $target[0].offsetWidth,
                targetHeight = $target[0].offsetHeight,
                columnMenuText = proxy._columnMenuTexts,
                columnFieldName = $.trim($target.prev("div.e-headercelldiv").attr("ej-mappingname")),
                column = proxy.getColumnByField(columnFieldName),
                filtermenuindex,
                allowSorting = column.allowSorting == undefined ? true : column.allowSorting;
            posX = columnListPosX = columnFilterPosX = posY = 0;
            proxy._clearColumnMenu("columnmenu");
            proxy._columnMenuTarget = $target;
            /* save edited value before rendering contextmenu on non edited cell*/
            if ((model.isEdit || this._isRowEdit)) {
                if (this.editFormValidate()) {
                    if (model.isEdit)
                        this.saveCell();
                    else if (this._isRowEdit)
                        this.saveRow();
                }
                else
                    return true;
            }
            

            if (model.showColumnChooser && model.showColumnOptions) {
                var isInsert = proxy._enableDisableInsertLabel();
                columnMenuItems.push({ "name": columnMenuText["insertColumnLeft"], "icon": "e-column-insertleft-icon", "menuId": "ColumnLeft", enabled: isInsert });
                columnMenuItems.push({ "name": columnMenuText["insertColumnRight"], "icon": "e-column-insertright-icon", "menuId": "ColumnRight", enabled: isInsert });
                columnMenuItems.push({ "name": columnMenuText["deleteColumn"], "icon": "e-column-delete-icon", "menuId": "DeleteColumn", enabled: proxy._enableDisableDEL(column) });
                columnMenuItems.push({ "name": columnMenuText["renameColumn"], "icon": "e-column-rename-icon", "menuId": "RenameColumn" });
            }
            if (model.allowFiltering && (ej.isNullOrUndefined(column.allowFiltering) || column.allowFiltering) && model.filterSettings.filterType == "menu") {
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    columnMenuItems.push({ "name": columnMenuText["menuFilter"], "icon": "e-column-filtered-icon", "menuId": "Filter" });
                    filtermenuindex = columnMenuItems.length;
                } else {
                    columnMenuItems.push({ "name": columnMenuText["menuFilter"], "icon": "e-column-filter-icon", "menuId": "Filter" });
                    filtermenuindex = columnMenuItems.length;
                }
            }
            if (model.allowSorting && allowSorting)
            {
                columnMenuItems.push({ "name": columnMenuText["sortAscendingText"], "icon": "e-columnmenu-ascending", "menuId": "SortAscending" });
                columnMenuItems.push({ "name": columnMenuText["sortDescendingText"], "icon": "e-columnmenu-descending", "menuId": "SortDescending" });
            }
            if (model.showColumnChooser) {
                columnChooserListIndex = columnMenuItems.length;
                columnMenuItems.push({ "name": columnMenuText["columnsText"], "icon": "e-columnchooser-icon", "menuId": "Columns" });
            }

            if (!model.isFromGantt) {
                if (column.allowFreezing || (proxy._allowFreezingDefault && ej.isNullOrUndefined(column.allowFreezing))) {
                    var enableFreeze, enableFreezeBefore = false;
                    /*Check all other columns are in frozen*/
                    if (proxy._frozenColumnsLength == model.columns.length - 1 && !column.isFrozen)
                        enableFreeze = true;

                    /*Check frozen column width and container width */
                    var frozenWidth = this._getFrozenColumnWidth(),
                        columnIndex = model.columns.indexOf(column);
                    frozenWidth = frozenWidth + this.columnsWidthCollection[columnIndex] + 18;
                    if (frozenWidth > this._gridWidth)
                        enableFreeze = true;

                    columnMenuItems.push({ "name": columnMenuText["freezeText"], "icon": "e-freezecolumn-icon", "menuId": "FreezeColumns", enabled: enableFreeze ? false : !column.isFrozen });
                    columnMenuItems.push({ "name": columnMenuText["unfreezeText"], "icon": "e-unfreezecolumn-icon", "menuId": "UnfreezeColumns", enabled: (column.isFrozen == true) });
                    if (proxy._checkboxSelection) {
                        if (model.columns[0].nonColumn && model.columns.indexOf(column) != 1 && model.columns.indexOf(column) > this._frozenColumnsLength)
                            enableFreezeBefore = true;
                    }
                    else if (model.columns.indexOf(column) != 0 && model.columns.indexOf(column) > this._frozenColumnsLength)
                        enableFreezeBefore = true;

                    /*Check frozen column width and container width */
                    frozenWidth = this._getFrozenColumnWidth(columnIndex);
                    frozenWidth = frozenWidth + 18;
                    if (frozenWidth > this._gridWidth)
                        enableFreezeBefore = false;
                    columnMenuItems.push({ "name": columnMenuText["freezePrecedingColumnsText"], "icon": "e-freezecolumnbefore-icon", "menuId": "FreezePrecedingColumns", enabled: enableFreezeBefore });
                }
            }
            var position = proxy.getOffsetRect($target[0]);            
            var elementPosition = proxy.getOffsetRect(proxy.element[0]);           
            if (!proxy.model.isFromGantt)
                posY = position.top + targetHeight;
            else
                posY = position.top + targetHeight;            
            proxy._columnChooserListIndex = columnChooserListIndex;
            var $outerDiv = ej.buildTag("div.e-columnmenu", "", {
                "display": "table",
                "position": "absolute", "top": posY, "z-index": proxy.getMaxZIndex() + 1
            }, { id: proxy._id + "_ColumnMenu" }),
                $outerUl = ej.buildTag("ul.e-treegrid-columnmenu", "", {}, {}),
                $columnMenuList = $.render[proxy._id + "columnMenuTemplate"](columnMenuItems);
            model.cssClass && ($outerDiv.addClass(model.cssClass));
            $outerUl.append($columnMenuList);
            $outerDiv.append($outerUl);
            $(document.body).append($outerDiv);
            var columnMenuHeight = $outerDiv.height(),
                columnMenuWidth = ($outerDiv.outerWidth() + 1);
            posX = position.left + targetWidth - columnMenuWidth;
            if (posX <= elementPosition.left)
                posX = elementPosition.left;
            columnListPosX = posX + columnMenuWidth;
            columnFilterPosX = posX + columnMenuWidth;
            proxy._columnListPosX = columnListPosX;
            proxy._columnFilterPosX = columnFilterPosX;
            proxy._columnMenuPopupY = posY;
            $outerDiv.css({ 'left': posX });
            $outerDiv.find(".e-columnmenuitem").outerWidth(columnMenuWidth);

            //Edge detection for column menu
            var element = !model.isFromGantt ? $(this.element) : $(this.element).closest(".e-gantt"),
                containerOffset = this.getOffsetRect(element[0]);
            containerOffset.bottom = containerOffset.top + element[0].offsetHeight;
            containerOffset.right = containerOffset.left + $(element).width();
            if (!model.isFromGantt) {
                if (proxy.model.isResponsive && $(window).width() <= proxy._responsiveMinWidth)
                    $("#" + proxy._id + "_ColumnMenu").find(".e-expander").addClass("e-treegridadaptivesubicon");
                else
                    $("#" + proxy._id + "_ColumnMenu").find(".e-expander").removeClass("e-treegridadaptivesubicon");
            }

            $("#" + proxy._id + "_ColumnsChooser").on("mouseenter click", function (e) {

                if (((e.type == "mouseenter" && $(window).width() > proxy._responsiveMinWidth) || !proxy.model.isResponsive) || ((e.type == "click" && $(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive)) || model.isFromGantt) {
                    if (($(window).width() > proxy._responsiveMinWidth || !proxy.model.isResponsive) || model.isFromGantt) {
                        var evntArgs = {};
                        evntArgs.width = "auto";
                        evntArgs.height = "auto";
                        evntArgs.minWidth = "0px";
                        evntArgs.minHeight = "0px";
                        evntArgs.showHeader = false;
                        evntArgs.position = { X: 1, Y: 1 };
                        evntArgs.enableModal = false;
                        evntArgs.isResponsive = false;
                        evntArgs.enableResize = false;
                        evntArgs.cssClass = proxy.model.cssClass;
                         $("#" + proxy._id + "ccDiv_wrapper").addClass("e-treegridadaptivedialog")
                        $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                        $("#" + proxy._id + "ccDiv").ejDialog(evntArgs);
                        $("#" + proxy._id + "ccDiv").css({ 'height': 'auto' });

                        proxy._updateColumnMenuVisibility();
                        var columnchooser = $("#" + proxy._id + "ccDiv").ejDialog("instance"),
                            columnChooserList = $("#" + proxy._id + "ccDiv_wrapper"),
                            columnChooserMenuList = columnChooserList.find("div.e-columnMenuListDiv");
                        columnchooser.open();
                        if (containerOffset.right < columnListPosX + columnChooserList.width()) {
                            columnListPosX = columnListPosX - columnChooserList.width() - columnMenuWidth;
                            if (columnListPosX <= (columnMenuWidth)) {
                                columnListPosX = posX + columnMenuWidth;
                            }
                        }
                        proxy._columnListPosX = columnListPosX;
                        var position = {
                            X: columnListPosX,
                            Y: posY + $("#" + proxy._id + "_ColumnsChooser").position().top
                        };
                        columnchooser.option({ "position": position });
                        columnChooserList.css("z-index", proxy.getMaxZIndex() + 1);
                        columnChooserMenuList.removeClass("e-columnmenuselection");
                        columnChooserMenuList.eq(0).addClass("e-columnmenuselection");
                        proxy._focusTreeGridElement();
                        proxy._renderedSubMenuType = "ColumnDesktop";
                    } else {
                        proxy._adaptiveColumnChooser();

                    }
                    if (model.allowFiltering && model.filterSettings.filterType == "menu") {
                        proxy._clearFilterMenu();
                    }
                }
                });

            $("#" + proxy._id + "_FilterChooser").on("mouseenter click", function (e) {
                if (((e.type == "mouseenter" && $(window).width() > proxy._responsiveMinWidth) || !proxy.model.isResponsive) || ((e.type == "click" && $(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive))) {

                    var index, editType, str, filtertype;
                    proxy._updateColumnMenuVisibility();
                    if (column.filterEditType) {
                        index = column.filterEditType.indexOf("edit");
                        filtertype = column.filterEditType;
                    }
                    else {
                        index = column.editType.indexOf("edit");
                        filtertype = column.editType;
                    }
                    if (index != -1) {
                        editType = filtertype.slice(0, index);
                        str = editType.charAt(0).toUpperCase() + editType.slice(1);
                        proxy._showFilterMenu("columnchooser", "filter" + str, columnFilterPosX, columnMenuWidth, containerOffset.right, posX, columnChooserListIndex, filtermenuindex, column, posY);
                    } else {
                        str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                        proxy._showFilterMenu("columnchooser", "filter" + str, columnFilterPosX, columnMenuWidth, containerOffset.right, posX, columnChooserListIndex, filtermenuindex, column, posY);
                    }
                    proxy._updatePreviousFilteredValue(column);
                    $("#" + proxy._id + "ccDiv").ejDialog("close");
                }
                });
            $("#" + proxy._id + "_SortAscendingChooser," + "#" + proxy._id + "_SortDescendingChooser," +
              "#" + proxy._id + "_FreezeColumnsChooser," + "#" + proxy._id + "_UnfreezeColumnsChooser," +
              "#" + proxy._id + "_FreezePrecedingColumnsChooser," + "#" + proxy._id + "_ColumnLeftChooser," +
              "#" + proxy._id + "_ColumnRightChooser," + "#" + proxy._id + "_DeleteColumnChooser," +
              "#" + proxy._id + "_RenameColumnChooser").mouseenter(function () {
                $("#" + proxy._id + "ccDiv").ejDialog("close");
                  if (model.allowFiltering && model.filterSettings.filterType == "menu") {
                      proxy._clearFilterMenu();
                  }
              });
            $("#" + proxy._id + "_SortAscendingChooser").click(function () {
                if (model.allowMultiSorting)  proxy._multiSortRequest = true;
                if (model.isFromGantt)
                    proxy.sortColumn(column.mappingName, ej.sortOrder.Ascending);
                else
                    proxy.sortColumn(column.field, ej.sortOrder.Ascending);
                proxy._multiSortRequest = false;
            });
            $("#" + proxy._id + "_SortDescendingChooser").click(function () {
                if(model.allowMultiSorting) proxy._multiSortRequest = true;
                if (model.isFromGantt)
                    proxy.sortColumn(column.mappingName, ej.sortOrder.Descending);
                else
                    proxy.sortColumn(column.field, ej.sortOrder.Descending);
                proxy._multiSortRequest = false;
            });
            $("#" + proxy._id + "_FreezeColumnsChooser").click(function () {
                if (!$(this).hasClass("e-disable")) {
                    if (proxy._checkboxSelection) {
                        if (model.columns[0].nonColumn && !model.columns[0].isFrozen)
                            model.columns[0]['isFrozen'] = true;                        
                    }
                    proxy.freezeColumn(column.field, true);
                }
            });
            $("#" + proxy._id + "_UnfreezeColumnsChooser").click(function () {
                if (!$(this).hasClass("e-disable")) {                    
                    if (proxy._checkboxSelection && proxy._frozenColumnsLength == 2) {
                        if (model.columns[0].nonColumn && model.columns[0].isFrozen)
                            model.columns[0]['isFrozen'] = false;                            
                    }
                    proxy.freezeColumn(column.field, false);
                }
            });
            $("#" + proxy._id + "_FreezePrecedingColumnsChooser").click(function () {
                if (!$(this).hasClass("e-disable"))
                    proxy.freezePrecedingColumns(column.field);
            });

            $("#" + proxy._id + "_ColumnLeftChooser").click(function () {
                if (!$(this).hasClass("e-disable"))
                    proxy.insertColumnChooser(column, "left");
                else
                    return false;
            });
            $("#" + proxy._id + "_ColumnRightChooser").click(function () {
                if (!$(this).hasClass("e-disable"))
                    proxy.insertColumnChooser(column, "right");
                else
                    return false;
            });

            $("#" + proxy._id + "_DeleteColumnChooser").click(function () {
                if (!$(this).hasClass("e-disable")) {
                    proxy._targetColumnIndex = model.columns.indexOf(column);
                    proxy._updateConfirmDialog.ejDialog("open");
                    proxy._clearColumnMenu();
                }
                else
                    return false;
            });

            $("#" + proxy._id + "_RenameColumnChooser").click(function () {
                proxy._targetColumnIndex = model.columns.indexOf(column);
                proxy._renderColumnRenameDialog(column);
                proxy._columnRenameDialog.ejDialog("open");
                proxy._clearColumnMenu();
            });

            var columnMenu = $("#" + proxy._id + "_ColumnMenu"),
                columnMenuItem = columnMenu.find("div.e-columnmenuitem");
            columnMenuItem.eq(0).addClass("e-columnmenuselection");
            $(columnMenuItem).mouseenter(function () {
                if (!$(this).hasClass("e-disable")) {
                    columnMenuItem.removeClass("e-columnmenuselection");
                    $(this).addClass("e-columnmenuselection");
                }
            });
        },

        // Method to render adaptive column chooser

        _adaptiveColumnChooser: function () {
            var proxy = this, evntArgs = {}, controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]),columnMenuText = proxy._columnMenuTexts;
            evntArgs.cssClass = proxy.model.cssClass,
            evntArgs.enableModal = false,
            evntArgs.enableResize = false;
            evntArgs.enableResize = false,
            evntArgs.contentSelector = "#" + proxy._id,
            evntArgs.rtl = proxy.model.rtl,
            evntArgs.allowDraggable = false;
            evntArgs.showHeader = true;
            evntArgs.minHeight = "50px";
            evntArgs.minWidth = "50px";
                evntArgs.width = $("#" + proxy._id).width() + "px";
                evntArgs.height = $("#" + proxy._id).height() + "px";
                evntArgs.position = { X: controlPosition .left + "px", Y: controlPosition .top + "px" };
                evntArgs.isResponsive = false;
            evntArgs.allowKeyboardNavigation = false;
            evntArgs.title = columnMenuText["columnsText"];
            $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-treegridadaptivedialog");
            $("#" + proxy._id + "ccDiv_wrapper").addClass("e-dialog").addClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%");
            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").addClass("e-treegridadaptivedialog");
            $("#" + proxy._id + "ccDiv").ejDialog(evntArgs);
            $("#" + proxy._id + "ccDiv").ejDialog("open");

            $("#" + proxy._id + "ccDiv").css({ 'width': '100%', 'height': '100%' });
            if (proxy.model.isResponsive) {
                var dialogInnerDivHeight = ($("#" + proxy._id).height() - 50) + "px"; // (48px - Dialog box header height) + (2px - excess border of parent div).
                $("#" + proxy._id + "ccDiv_wrapper").css({ 'width': $("#" + proxy._id).width(), 'height': $("#" + proxy._id).height() });
                $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                $("#" + proxy._id + "ccDiv").css({ 'width': '100%', 'height': 'auto' });
                if ($("#" + proxy._id + "ccDiv").height() > $("#" + proxy._id + "ccDiv_wrapper").height() - 48) { // 48px - Dialog box header height
                    $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 48) + "px", 'width': 'auto', 'padding': '0px' }); // 48px - Dialog box header height
                    $("#" + proxy._id + "ccDiv").removeClass("e-columnSelector");
                    $("#" + proxy._id + "ccDiv").ejDialog("refresh");
                } else {
                    $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight, 'width': 'auto' });
                    $("#" + proxy._id + "ccDiv").css({ 'padding': '8px 16px' });
                }
                $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-shadow");
                $("#" + proxy._id + "ccDiv").removeClass("e-shadow");
            }

            proxy._renderedSubMenuType = "AdaptiveColChooser";
            $("#" + proxy._id + "_ColumnMenu").remove();

        },

        //update previous filtered value for current rendering dialog box depends on its filter edit type
        _updatePreviousFilteredValue: function (column) {
            var proxy = this, suggesionBox, dropDown, dataManager, query, result, fieldIndex, groups = [], field1, filtertype, emptydrop;
            if (column.filterEditType)
                filtertype = column.filterEditType;
            else
                filtertype = column.editType;
            if (filtertype == "stringedit") {
                suggesionBox = $("#" + proxy._id + "filterStringInputBox").data("ejAutocomplete");
                dropDown = $("#" + proxy._id + "filterStringMenuDiv").find("#" + proxy._id + "filterStringDropDown").data("ejDropDownList");
                query = ej.Query().select(column.field);
                dataManager = new ej.DataManager(proxy.model.flatRecords.slice());
                result = dataManager.executeLocal(query);
                suggesionBox.option("dataSource", result);
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "startswith");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                    $("#" + proxy._id + "filterStringInputBox").val(proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    dropDown.option("value", "startswith");
                    suggesionBox.option("value", null);
                }
            }
            if (filtertype == "numericedit") {
                suggesionBox = $("#" + proxy._id + "filterNumericInputBox").data("ejNumericTextbox");
                dropDown = $("#" + proxy._id + "filterNumericMenuDiv").find("#" + proxy._id + "filterNumericDropDown").data("ejDropDownList");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "lessthan");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                    $("#" + proxy._id + "filterNumericInputBox").val(proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("value", null);
                    dropDown.option("value", "lessthan");
                }
            }
            if (filtertype == "datepicker") {
                suggesionBox = $("#" + proxy._id + "filterDatepickerInputBox").data("ejDatePicker");
                dropDown = $("#" + proxy._id + "filterDatepickerMenuDiv").find("#" + proxy._id + "filterDatepickerDropDown").data("ejDropDownList");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "lessthan");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("value", null);
                    dropDown.option("value", "lessthan");
                }
                if (column.format) {
                    suggesionBox.option("dateFormat", proxy._getDateFormat(column.format));
                }
            }
            if (filtertype == "datetimepicker") {
                suggesionBox = $("#" + proxy._id + "filterDatetimepickerInputBox").data("ejDateTimePicker");
                dropDown = $("#" + proxy._id + "filterDatetimepickerMenuDiv").find("#" + proxy._id + "filterDatetimepickerDropDown").data("ejDropDownList");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "lessthan");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("value", null);
                    dropDown.option("value", "lessthan");
                }
                if (column.format) {
                    suggesionBox.option("dateFormat", proxy._getDateFormat(column.format));
                }
            }
            if (filtertype == "dropdownedit") {
                $.extend(groups, column.dropdownData);
                if (column.editParams) {
                    field1 = { value: column.editParams.fields.value, text: column.editParams.fields.text };
                        emptydrop = {};
                        emptydrop[column.editParams.fields.text] = proxy._dropDownListBlanksText;
                        emptydrop[column.editParams.fields.value] = "(Blanks)";
                } else {
                    field1 = { value: "value", text: "text" };
                    emptydrop = { text: proxy._dropDownListBlanksText, value: "(Blanks)" };
                }
                dropDown = $("#" + proxy._id + "filterDropdownDropDown").data("ejDropDownList");
                if (!ej.isNullOrUndefined(groups) && groups.length != 0) {

                    if (column.allowFilteringBlankContent || ej.isNullOrUndefined(column.allowFilteringBlankContent))
                        groups.unshift(emptydrop);

                    dropDown.option("dataSource", groups);
                }
                else {
                    groups = proxy._dropDownArrayCollection(column, column.field);
                    if (column.allowFilteringBlankContent || ej.isNullOrUndefined(column.allowFilteringBlankContent))
                        groups.unshift(emptydrop);
                    dropDown.option("dataSource", groups);
                }
                dropDown.option("fields", field1);

                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    dropDown.option("value", proxy._filteredColumnValue[fieldIndex].value);

                } else {
                        dropDown.option("value", null);
                }
            }
            if (filtertype == "booleanedit") {
                var suggesionBox = $("#" + proxy._id + "filterBooleanInputBox").data("ejCheckBox");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "") {
                        suggesionBox.option("checkState", "uncheck");
                    }
                    else
                        suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("selectedIndex", "");
                }
            }
        },

        //perform filter operation
        _performMenuFilter: function (column, suggesionBoxValue, dropDownValue) {
            var proxy = this, filteredColumnIdIndex, filtertype;
            proxy.clearAllSelection();
            if (column.filterEditType)
                filtertype = column.filterEditType;
            else
                filtertype = column.editType;
            if (ej.isNullOrUndefined(suggesionBoxValue)) {
                suggesionBoxValue = "";
            }
            proxy._searchString = suggesionBoxValue;
            if (proxy._filteredColumnValueID.indexOf(column.field) == -1 && suggesionBoxValue.toString() == "") {
                proxy.clearColumnMenu();
                proxy._clearFilterMenu();
            } else {
                if (filtertype == "numericedit" || filtertype == "datepicker" || filtertype == "datetimepicker") {
                    if ((filtertype == "datepicker" || filtertype == "datepicker") && (dropDownValue == "equal" || dropDownValue == "notequal"))
                        proxy.filterColumn(column.field, dropDownValue, suggesionBoxValue, "and");
                    else
                        proxy.filterColumn(column.field, dropDownValue, suggesionBoxValue, "and", true);
                }
                else {
                    proxy.filterColumn(column.field, dropDownValue, suggesionBoxValue, "and");
                }
            if (!proxy.model.showColumnChooser) {
                if (suggesionBoxValue.toString() != "" || suggesionBoxValue.toString() == "false") {
                    proxy._filterIconTarget.target.className = "e-column-filtered-icon e-icon e-filtericon";
                } else {
                    proxy._filterIconTarget.target.className = "e-column-filter-icon e-icon e-filtericon";
                }
            }
            proxy._storePreviousFilteredValue(column.field, suggesionBoxValue, dropDownValue);
            proxy._searchString = suggesionBoxValue;
            proxy.clearColumnMenu();
            proxy._clearFilterMenu();
        }

        },

        // Resore the previous filtered values.
        _storePreviousFilteredValue: function (field, suggesionBoxValue, dropDownValue) {
            var proxy = this, filteredColumnIdIndex;
            if (proxy._filteredColumnValueID.indexOf(field) == -1 && (suggesionBoxValue.toString() != "" || suggesionBoxValue.toString() == "false")) {
                proxy._filteredColumnValue.push({ column: field, value: suggesionBoxValue, dropdown: dropDownValue });
                proxy._filteredColumnValueID.push(field);
            } else {
                if (suggesionBoxValue.toString() != "" || suggesionBoxValue.toString() == "false") {
                    filteredColumnIdIndex = proxy._filteredColumnValueID.indexOf(field);
                    proxy._filteredColumnValue[filteredColumnIdIndex].value = suggesionBoxValue;
                    proxy._filteredColumnValue[filteredColumnIdIndex].dropdown = dropDownValue;
                } else {
                    if (proxy._filteredColumnValueID.indexOf(field) != -1) {
                        filteredColumnIdIndex = proxy._filteredColumnValueID.indexOf(field);
                        proxy._filteredColumnValue.splice(filteredColumnIdIndex, 1);
                        proxy._filteredColumnValueID.splice(filteredColumnIdIndex, 1);
                    }
                }
            }
        },

        //render filter menu dialog in a respective position
        _showFilterMenu: function (from, idValue, columnFilterPosX, columnMenuWidth, containerRightOffset, posX, columnChooserListIndex, filtermenuindex, column, posY) {
            if (!this.editFormValidate()) return;
            if (($(window).width() <= this._responsiveMinWidth && this.model.isResponsive) && !this.model.isFromGantt) {
                var proxy = this,
                evntArgs = {},
                controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]);
                evntArgs.cssClass = this.model.cssClass;
                evntArgs.enableModal = false;
                evntArgs.isResponsive = false;
                evntArgs.enableRTL = this.model.enableRTL;
                evntArgs.enableResize = false;
                evntArgs.allowDraggable = false;
                evntArgs.minWidth = "50px";
                evntArgs.minHeight = "50px";
                evntArgs.width = $("#" + proxy._id).width() + "px";
                evntArgs.height = $("#" + proxy._id).height() + "px";
                evntArgs.position = { X: controlPosition .left + "px", Y: controlPosition .top + "px" };
                evntArgs.contentSelector = "#" + proxy._id;
                evntArgs.rtl = proxy.model.rtl;
                evntArgs.allowKeyboardNavigation = false;
                evntArgs.showHeader = true;
                evntArgs.title = column.headerText;
                $("#" + proxy._id + idValue + "MenuDiv").removeClass("e-treegridadaptivedialog");
                $("#" + proxy._id + idValue + "MenuDiv").ejDialog(evntArgs);
                $("#" + proxy._id + idValue + "MenuDiv_wrapper").addClass("e-dialog").addClass("e-shadow").find("div.e-dialog-scroller").addClass("e-treegridadaptivewidth");
                $("#" + proxy._id + idValue + "MenuDiv").css({ 'width': '100%','height':'auto' });
                var dialogInnerDivHeight = $("#" + proxy._id).height() - 50 + "px"; // (48px - Dialog box header height) + (2px - excess border of parent div).
                $("#" + proxy._id + idValue + "MenuDiv").ejDialog('open');
                    $("#" + proxy._id + idValue + "MenuDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight });
                    $("#" + proxy._id + idValue + "MenuDiv_wrapper").removeClass("e-shadow");
                    $("#" + proxy._id + idValue + "MenuDiv").removeClass("e-shadow");

                    if ($("#" + proxy._id + idValue + "MenuDiv").height() > $("#" + proxy._id + idValue + "MenuDiv_wrapper").height() - 48) { // 48px - Dialog box header height
                        $("#" + proxy._id + idValue + "MenuDiv").ejDialog("refresh");
                    }
                proxy._renderedSubMenuType = "#" + proxy._id + idValue + "MenuDiv";
                $("#" + proxy._id + "_ColumnMenu").remove();
            } else {
                var proxy = this;
                var evntArgs = {};
                evntArgs.width = "auto",
                evntArgs.height = "auto",
                evntArgs.minWidth = "0px",
                evntArgs.minHeight = "0px",
                evntArgs.showHeader = false,
                evntArgs.position = { X: 1, Y: 1 },
                evntArgs.enableModal = false,
                evntArgs.isResponsive = false,
                evntArgs.enableResize = false,
                evntArgs.cssClass = this.model.cssClass;
                $("#" + proxy._id + idValue + "MenuDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                $("#" + proxy._id + idValue + "MenuDiv").ejDialog(evntArgs);
                var filterMenuDiv, filterMenuDivWrapper, filterMenuPosition;
                filterMenuDiv = $("#" + proxy._id + idValue + "MenuDiv").ejDialog("instance");
                filterMenuDivWrapper = $("#" + proxy._id + idValue + "MenuDiv_wrapper");
                if (from == "columnchooser") {
                    var windowWidth = $(document).width();
                    if ((containerRightOffset < columnFilterPosX + filterMenuDivWrapper.width()) || (windowWidth < columnFilterPosX + filterMenuDivWrapper.width())) {
                        if ((columnFilterPosX - columnMenuWidth - filterMenuDivWrapper.width()) > 0)
                            columnFilterPosX = columnFilterPosX - columnMenuWidth - filterMenuDivWrapper.width();
                    }
                    filterMenuPosition = {
                        X: columnFilterPosX,
                        Y: posY + $("#" + proxy._id + "_FilterChooser").position().top
                    };
                    filterMenuDiv.option({ "position": filterMenuPosition });
                    filterMenuDiv.open();
                } else if (from = "filtermenu") {
                    var position = columnFilterPosX,
                    targetWidth = columnMenuWidth;
                    posX = position.left + targetWidth - filterMenuDivWrapper.width();
                    position.left = posX + filterMenuDivWrapper.width() + 4;
                    if (containerRightOffset < position.left + filterMenuDivWrapper.width()) {
                        position.left = position.left - filterMenuDivWrapper.width() - targetWidth;
                    }
                    filterMenuPosition = {
                        X: position.left,
                        Y: position.top
                    };
                    filterMenuDiv.option({ "position": filterMenuPosition });
                    filterMenuDiv.open();
                }
                proxy._renderedSubMenuType = "#" + proxy._id + idValue + "MenuDivDesktop";
            }
        },

        _clearResponsiveColumnMenu:function(){
            var proxy = this;
            $("div[id$='ccDiv']").each(function () {
                if ($(this).data("columnMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'padding': '0px' });
            $("#" + proxy._id + "ccDiv").addClass("e-columnSelector");
            $("div[id$='filterStringMenuDiv']").each(function () {
                if ($(this).data("filterStringMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterNumericMenuDiv']").each(function () {
                if ($(this).data("filterNumericMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterBooleanMenuDiv']").each(function () {
                if ($(this).data("filterBooleanMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterDatepickerMenuDiv']").each(function () {
                if ($(this).data("filterDatepickerMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterDatetimepickerMenuDiv']").each(function () {
                if ($(this).data("filterDatetimepickerMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterDropdownMenuDiv']").each(function () {
                if ($(this).data("filterDropdownMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='ColumnRenameDialog']").each(function () {
                $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='dialogColumnAdd']").each(function () {
                $(this).data("ejDialog") && $(this).ejDialog("close");
            });

            $("#" + proxy._id).find(".e-filtericon").data("isClicked", false);
        },

        //Clear the column menu and menu list

        _clearColumnMenu:function(args)
        {
            var proxy = this;
            if (args === "columnmenu" && $(window).width() < proxy._responsiveMinWidth) {
                proxy._clearResponsiveColumnMenu();
            }
            if (proxy.model.isResponsive && $(window).width() < proxy._responsiveMinWidth) {
                $("#" + proxy._id + "_ColumnMenu").remove();
                if (proxy._renderedSubMenuType && proxy._renderedSubMenuType.indexOf("AdaptiveColChooser") == -1) {
                    $("div[id$='" + proxy._id + "ccDiv']").each(function () {
                        if ($(this).data("columnMenuDialog") == "TreeGrid")
                            $(this).data("ejDialog") && $(this).ejDialog("close");
                    });
                    $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({'padding': '0px' });
                    $("#" + proxy._id + "ccDiv").addClass("e-columnSelector");
                }
            }
        else{
            $("#" + proxy._id + "_ColumnMenu").remove();
            if (args != "resize") {
                $("div[id$='" + proxy._id + "ccDiv']").each(function () {
                    if ($(this).data("columnMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'padding': '0px' });
                $("#" + proxy._id + "ccDiv").addClass("e-columnSelector");
                if (args != "resize") {
                    if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                        proxy._clearFilterMenu();
                    }
                }
            }
    }

            $("#" + proxy._id).find(".e-columnicon").data("isClicked", false);
            $("#" + proxy._id).find(".e-filtericon").data("isClicked", false);
        },

        // clear the filter menu dialog and its inner components
        _clearFilterMenu: function () {
            var proxy = this;
            if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                $("div[id$='" + proxy._id + "filterStringMenuDiv']").each(function () {
                    if ($(this).data("filterStringMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterNumericMenuDiv']").each(function () {
                    if ($(this).data("filterNumericMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterBooleanMenuDiv']").each(function () {
                    if ($(this).data("filterBooleanMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterDatepickerMenuDiv']").each(function () {
                    if ($(this).data("filterDatepickerMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterDatetimepickerMenuDiv']").each(function () {
                    if ($(this).data("filterDatetimepickerMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterDropdownMenuDiv']").each(function () {
                    if ($(this).data("filterDropdownMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("#" + proxy._id + "filterStringDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterStringInputBox_suggestion").hide();
                $("#" + proxy._id + "filterNumericDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterNumericInputBox_suggestion").hide();
                $("#" + proxy._id + "filterDatepickerDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterDatepickerInputBox_suggestion").hide();
                $("#" + proxy._id + "filterDatetimepickerDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterDatetimepickerInputBox_suggestion").hide();
                $("#" + proxy._id + "filterDropdownDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id).find(".e-filtericon").data("isClicked", false);
                var datetimepicobj = $("#" + proxy._id + "filterDatetimepickerInputBox").data("ejDateTimePicker");
                if (datetimepicobj)
                    datetimepicobj.hide();
                var datepicobj = $("#" + proxy._id + "filterDatepickerInputBox").data("ejDatePicker");
                if (datepicobj)
                    datepicobj.hide();
            }
        },

        _getDateFormat: function (format) {
            var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm"),
                formatVal = toformat.exec(format),
                dateFormat = formatVal[2];
            return dateFormat;
        },

        //Enabling or disabling delete button of columnchooser
        _enableDisableDEL: function (colItem) {
            var proxy = this, model = proxy.model,
                fieldName = colItem.field,
                columnIndex = model.columns.indexOf(colItem);
            if (model.isFromGantt) {
                if (fieldName == "taskId" || fieldName == "taskName" || fieldName == "startDate" || fieldName == "endDate" || (fieldName == "duration" && !model.endDateMapping) || columnIndex == model.treeColumnIndex)
                    return false;
                else
                    return true;
            }
            else {
                if (columnIndex == model.treeColumnIndex)
                    return false;
                else
                    return true;
            }
        },

        //Enabling or disabling Insert column label columnchooser
        _enableDisableInsertLabel: function () {
            var proxy = this, model = proxy.model;
            //Block column add operation while frozen columns Width is near to grid width
            if (!model.isFromGantt && proxy._frozenColumnsLength > 0) {
                var frozenWidth = this._getFrozenColumnWidth();
                frozenWidth = frozenWidth + 250;
                if (frozenWidth > this._gridWidth)
                    return false;
                else
                    return true;
            }
            else
                return true;
        },

        //Insert column through column chooser
        insertColumnChooser: function (column, position) {
            var proxy = this, model = proxy.model;
            if ($("#" + proxy._id + "_dialogColumnAdd").length === 0) {
                var $dialogCol = ej.buildTag("div.e-dialog e-dialog-content e-widget-content", "", { display: "none" }, { id: proxy._id + "_dialogColumnAdd" });
                proxy.element.append($dialogCol);
                proxy._on($("#" + proxy._id + "_dialogColumnAdd"),
               "click keypress", "#ColumnAddDialog_" + proxy._id + "_Ok ,#ColumnAddDialog_" + proxy._id + "_Cancel", proxy._buttonClick);
            }
            proxy.renderColumnAddDialog();
            proxy._targetColumnIndex = model.columns.indexOf(column);
            proxy._insertPosition = position;
        },

        // To change the headerText of column
        renameColumn: function (colIndex, name) {
            var proxy = this, model = proxy.model,
                columns = model.columns, args = {};
            args.requestType = "renameColumn";
            args.columnObject = columns[colIndex];
            args.previousName = columns[colIndex].headerText;
            args.currentName = name;          
            if (!proxy._trigger("actionComplete", args)) {
                columns[colIndex].headerText = name;
                proxy._refreshFrozenColumns();
            }
        },

        //Method to render dialog box for renaming column
        _renderColumnRenameDialog: function (columnItem) {
            var proxy = this, columnMenuText = proxy._columnMenuTexts,
                $contentDiv = ej.buildTag('div.e-treegridrenamedialog', "", {}, { 'unselectable': 'on' }), controlWidth = $("#" + proxy._id).width(), controlHeight = $("#" + proxy._id).height(),
                $form = ej.buildTag('form', "", { 'height': '100%', 'width': '100%', 'font-size': '14px' }, { id: proxy._id + "ColumnRenameForm", onsubmit: "return false" }),
            $buttons = ej.buildTag('span.e-buttons', "<input class='e-treegrid-rename-dialog-btn-ok' type='button' id=" + proxy._id + 'RenameDialogOK' + " value=" + proxy._okButtonText + " /> "
            + "<input class='e-treegrid-rename-dialog-btn-cancel' type='button' id=" + proxy._id + 'RenameDialogCancel' + " value='" + proxy._cancelButtonText + "' />"),
            btnDiv = ej.buildTag('div', "", {}, { 'class': "e-treegrid-rename-dialog-btn" }),

            $innerTable = ej.buildTag('table', "", { 'outline': 'none', 'width': '100%' }, { 'unselectable': "on" }),

            $inTr1 = ej.buildTag('tr'),

            $inTd = ej.buildTag('td.editLabel', "", { "outline": "none" }, { 'unselectable': "on" });
            $inTd.append("<label style='font-weight:normal;'>" + proxy._columnDialogTitle["renameColumn"] + "</label>");

            $inTr1.append($inTd);

            $innerTable.append($inTr1);

            var $inTr2 = ej.buildTag('tr'),
            $inTd2 = ej.buildTag('td.e-editValue'),

            $input = ej.buildTag('input.e-field e-ejinputtext',
                                            "",
                                            {},
                                            {
                                                value: columnItem.headerText,
                                                id: proxy._id + "RenameHeaderText",
                                                name: columnItem.field,
                                                dialog: "RenameHeaderText"
                                            });
            $inTd2.html($input);
            $inTr2.append($inTd2);
            $innerTable.append($inTr2);
            $form.append($innerTable);
            $contentDiv.append($form);

            proxy._columnRenameDialog = ej.buildTag('div', '', '', { 'title': columnMenuText["renameColumn"], 'id': proxy._id + 'ColumnRenameDialog' });
            btnDiv.append($buttons);
            proxy._columnRenameDialog.append($contentDiv).append(btnDiv);
            proxy.element.append(proxy._columnRenameDialog);
            $buttons.find("input").ejButton({
                cssClass: proxy.model.cssClass,
                showRoundedCorner: true,
                size: "normal",
                click: $.proxy(proxy._triggerRenameColumn, proxy)
            });
            if (($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) && !proxy.model.isFromGantt) {
                if (proxy.model.isResponsive) {
                    var controlPosition = proxy.getOffsetRect($("#" + proxy._id)[0]);
                    $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-treegridadaptivedialog");
                    proxy._columnRenameDialog.ejDialog({ width: controlWidth + "px", height: controlHeight + "px", position: { X: controlPosition.left + "px", Y: controlPosition.top + "px" }, minHeight: "50px", minWidth: "50px", showOnInit: false, allowDraggable: false, enableResize: false, enableModal: false, isResponsive: false, cssClass: this.model.cssClass });
                    $("#" + proxy._id + "ColumnRenameDialog_wrapper").removeClass("e-shadow").addClass("e-treegrid-dialog");
                    $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-shadow");
                }
            } else {
                proxy._columnRenameDialog.ejDialog({ width: "auto", height: "auto", minHeight: 0, minWidth: 240, showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true, cssClass: this.model.cssClass });
                $("#" + proxy._id + "ColumnRenameDialog_wrapper").addClass("e-treegrid-dialog");
            }
            $input.focus().select();
        },

        _triggerRenameColumn: function (args) {
            var proxy = this, $elem, text;
            if (args !== undefined && args.model.text == proxy._okButtonText) {
                $elem = proxy._columnRenameDialog.find("#" + proxy._id + "RenameHeaderText");
                text = $elem.val();
                proxy.renameColumn(proxy._targetColumnIndex, text);
                if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) || proxy.model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                } else if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) && proxy.model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                }
            }
            proxy._columnRenameDialog.ejDialog("close");
        },

        //To render dialog for adding custom column
        renderColumnAddDialog: function () {

            var proxy = this, model = proxy.model, colDialogFields = model.columnDialogFields,
                args = {}, controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]);;

            args.requestType = "openColumnAddDialog";
            if (colDialogFields.length) {
                args.data = {};
                for (var i = 0; i < colDialogFields.length; i++) {
                    var val = colDialogFields[i];
                    args.data[val] = "";
                }
            }
            else args.data = { "field": "", "headerText": "", "editType": "" };

            if (!proxy._trigger("actionBegin", args)) {
                args.requestType = "columnAdd";
                var temp = document.createElement('div');
                $(temp).addClass("e-addedColumn");
                temp.innerHTML = $.render[proxy._id + "_ColumnAddTemplate"](args.data);
                $("#" + proxy._id + "_dialogColumnAdd").html($(temp));
                var evntArgs = {};
                evntArgs.cssClass = this.model.cssClass,
                evntArgs.enableResize = false,
                evntArgs.width = "auto",
                evntArgs.height = "auto",
                evntArgs.contentSelector = "#" + proxy._id,
                evntArgs.rtl = proxy.model.rtl,
                evntArgs.allowKeyboardNavigation = false;
                var title = proxy._columnDialogTitle["insertColumn"];
                evntArgs.title = title;
                if (($(window).width() > proxy._responsiveMinWidth || !proxy.model.isResponsive) || proxy.model.isFromGantt) {
                    evntArgs.enableModal = true,
                    evntArgs.allowDraggable = true,
                    evntArgs.isResponsive = true;
                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog(evntArgs);
                    $("#" + proxy._id + "_dialogColumnAdd").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").addClass("e-treegridadaptivedialog e-treegrid-dialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog("open");
                    $("#" + proxy._id + "_dialogColumnAdd").find(".dropdowntreegrid").css('width', '438px'); // fixed width of dialog dropdown treegrid div.
                }
                if (($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) && !proxy.model.isFromGantt) {

                    evntArgs.isResponsive = false;
                    evntArgs.enableResize = false;
                    evntArgs.enableModal = false,
                    evntArgs.allowDraggable = false;
                    evntArgs.width = $("#" + proxy._id).width() + "px";
                    evntArgs.height = $("#" + proxy._id).height() + "px";
                    evntArgs.minHeight= "150px";
                    evntArgs.minWidth = "150px";
                    $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd").find(".dropdowntreegrid").css({ 'width': ($("#" + proxy._id).width() - 80) + 'px', 'height': '150px' }); // 80px ((28px of $("#" + proxy._id + "_dialogColumnAdd"))+(18px of Hscrollbar)+(30px of $("#" + proxy._id + "ColumnAddForm div"))) get minused in width to place the dropdown dialog treegrid div in absolute position.
                        $("#" + proxy._id + "_dialogColumnAdd").ejDialog(evntArgs);
                        $("#" + proxy._id + "_dialogColumnAdd").ejDialog("open");
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-treegridadaptivedialog").addClass("e-treegrid-dialog");
   
                $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");

                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").css({ 'left': controlPosition .left + "px", 'top': controlPosition .top + "px" });
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-shadow");
                    $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-shadow");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 50) + "px" }); // (48px - Dialog box header height) + (1px - excess border of parent div).

            }
                proxy._clearColumnMenu();
                proxy._refreshColumnAddForm();
                $("#" + proxy._id + "_dialogColumnAdd").ejDialog("refresh");
            }
        },

        setAddColumnFields: function () {
            var proxy = this,
                model = proxy.model;
            if (model.columnDialogFields.length) {
                proxy._addColumnFields = model.columnDialogFields;
                var tempFields = ["field", "headerText", "editType"];
                //Ensure the above 3 default fields with "model.columnDialogFields"
                for (var i = 0; i < tempFields.length; i++) {
                    if ($.inArray(tempFields[i], proxy._addColumnFields) == -1) {
                        switch (tempFields[i]) {
                            case "field":
                                proxy._addColumnFields.splice(0, 0, tempFields[i]);
                                break;
                            case "headerText":
                                proxy._addColumnFields.splice(1, 0, tempFields[i]);
                                break;
                            case "editType":
                                proxy._addColumnFields.splice(2, 0, tempFields[i]);
                                break;
                        }
                    }
                }
                //Check the "model.columnDialogFields" with allowSorting, allowFiltering and selectionType APIs
                if (model.isFromGantt) {
                    if (!model.allowSorting && proxy._addColumnFields.indexOf("allowSorting") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowSorting"), 1);
                    }
                    if (model.selectionSettings.selectionMode == "row" && proxy._addColumnFields.indexOf("allowCellSelection") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowCellSelection"), 1);
                    }
                }
                else {
                    if (!model.allowSorting && proxy._addColumnFields.indexOf("allowSorting") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowSorting"), 1);
                    }
                    if (!model.allowFiltering && proxy._addColumnFields.indexOf("allowFiltering") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowFiltering"), 1);
                    }
                    if (model.selectionSettings.selectionMode == "row" && proxy._addColumnFields.indexOf("allowCellSelection") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowCellSelection"), 1);
                    }
                }
                //Move displayAsCheckbox to end o hide this field in column add dialog, if edittype choosed ad boolean then it will be shown
                if (proxy._addColumnFields.indexOf("displayAsCheckbox") != -1) {
                    proxy._addColumnFields.push(proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("displayAsCheckbox"), 1)[0]);
                }

                //Assign appropriate header text to fields
                proxy._addColumnFieldsTxt = [];
                for (var i = 0; i < proxy._addColumnFields.length; i++) {
                    switch (proxy._addColumnFields[i]) {
                        case "field":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["field"]);
                            break;
                        case "headerText":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["headerText"]);
                            break;
                        case "editType":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["editType"]);
                            break;
                        case "filterEditType":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["filterEditType"]);
                            break;
                        case "allowFiltering":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowFiltering"]);
                            break;
                        case "allowFilteringBlankContent":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowFilteringBlankContent"]);
                            break;
                        case "allowSorting":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowSorting"]);
                            break;
                        case "visible":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["visible"]);
                            break;
                        case "width":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["width"]);
                            break;
                        case "textAlign":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["textAlign"]);
                            break;
                        case "headerTextAlign":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["headerTextAlign"]);
                            break;
                        case "isFrozen":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["isFrozen"]);
                            break;
                        case "allowFreezing":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowFreezing"]);
                            break;
                        case "allowCellSelection":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowCellSelection"]);
                            break;
                        case "showInColumnChooser":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["showInColumnChooser"]);
                            break;
                        case "clipMode":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["clipMode"]);
                            break;
                        case "tooltip":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["tooltip"]);
                            break;
                        case "headerTooltip":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["headerTooltip"]);
                            break;
                        case "displayAsCheckbox":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["displayAsCheckbox"]);
                            break;
                    }                  
                }
            }
            else {
                proxy._addColumnFields = ["field", "headerText", "editType"];
                proxy._addColumnFieldsTxt = [proxy._columnDialogTexts["field"], proxy._columnDialogTexts["headerText"], proxy._columnDialogTexts["editType"]];
            }
        },

        //Method for creating cell edit type
        setColumnCelEditType: function (columnAttr) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                $input;
            if (columnAttr == "field" || columnAttr == "filterEditType" || columnAttr == "editType" || columnAttr == "textAlign" || columnAttr == "headerTextAlign" || columnAttr == "clipMode") {
                $input = ej.buildTag('input.e-field e-dropdownlist',
                                         "",
                                         {},
                                         {
                                             value: "{{:#data['" + columnAttr + "']}}",
                                             id: proxy._id + columnAttr + "ColumnAdd",
                                             name: columnAttr,
                                             dialog: "ColumnAdd"
                                         });
            }
            else if (columnAttr == "headerText" || columnAttr == "tooltip" || columnAttr == "headerTooltip") {
                $input = ej.buildTag('input.e-field e-ejinputtext',
                                         "",
                                         {},
                                         {
                                             value: "{{:#data['" + columnAttr + "']}}",
                                             id: proxy._id + columnAttr + "ColumnAdd",
                                             name: columnAttr,
                                             dialog: "ColumnAdd"
                                         });
            }
            else if (columnAttr == "allowFiltering" || columnAttr == "allowSorting" || columnAttr == "isFrozen" || columnAttr == "allowFreezing") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' dialog ="ColumnAdd"' +
                         ' name="' + columnAttr + '" edittype="booleanedit">';
            }
            else if (columnAttr == "allowFilteringBlankContent" || columnAttr == "visible") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' dialog = "ColumnAdd"' +
                         ' checked = "checked"' +
                         ' name="' + columnAttr + '" edittype="booleanedit">';
            }
            else if (columnAttr == "allowCellSelection") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' dialog = "ColumnAdd"' +
                         ' checked = "checked"' +
                         ' name="' + columnAttr + '" edittype="booleanedit">';
            }
            else if (columnAttr == "showInColumnChooser" || columnAttr == "displayAsCheckbox") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' dialog = "ColumnAdd"' +
                         ' checked = "checked"' +
                         ' name="' + columnAttr + '" edittype="booleanedit">';
            }
            else if (columnAttr == "width") {
                $input = ej.buildTag('input.e-numerictextbox e-field',
                                         "",
                                         {},
                                         {
                                             type: "text",
                                             value: "{{:#data['" + columnAttr + "']}}",
                                             id: proxy._id + columnAttr + "ColumnAdd",
                                             name: columnAttr,
                                             dialog: "ColumnAdd"
                                         });
                $input.attr("edittype", "numericedit")
            }
            return $input;
        },

        //Template for adding custom column through dialog
        columnAddDialogTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                length = columns.length,
                $inputElem;

            if (length == 0)
                return;

            proxy.setAddColumnFields();

            var $tbody = ej.buildTag('div', "", {}, { 'unselectable': 'on' }),
            $form = ej.buildTag('form', "", { 'height': '100%', 'width': '100%', 'font-size': '14px' }, { id: proxy._id + "ColumnAddForm" }),
            $table = ej.buildTag('table', "", { width: "100%" }, { 'unselectable': "on" }),
            $tr = ej.buildTag('tr', "", { width: "100%" }),
            $td, $innerTable, $inTr, $inTd, $inTr2, $inTd2;
            for (var i = 0; i < proxy._addColumnFields.length; i++) {
                if ($tr.children("td").length < 2) {
                    $td = ej.buildTag('td.e-add-property-container', "", {}, { 'unselectable': "on" });
                    $innerTable = ej.buildTag('table', "", { "width": "100%", "outline": "none" }, { 'unselectable': "on" });

                    $inTr = ej.buildTag('tr');

                    $inTd = ej.buildTag('td.editLabel', "", { "outline": "none" }, { 'unselectable': "on" });
                    $inTd.append("<label style='font-weight:normal;'>" + proxy._addColumnFieldsTxt[i] + "</label>");

                    $inTr.append($inTd);

                    $innerTable.append($inTr);

                    $inTr2 = ej.buildTag('tr');
                    $inTd2 = ej.buildTag('td.e-editValue');

                    $inputElem = proxy.setColumnCelEditType(proxy._addColumnFields[i]);


                    $inTd2.html($inputElem);

                    $inTr2.append($inTd2);
                    $innerTable.append($inTr2);
                    if (proxy._addColumnFields[i] == "displayAsCheckbox") {
                        $innerTable.addClass("e-display-checkbox-conatiner").css("display","none");
                    }
                    $td.append($innerTable);
                    $tr.append($td);

                }
                else {
                    $table.append($tr);
                    $tr = ej.buildTag('tr');
                    i--;
                }

            }
            $table.append($tr);

          //  Table of Dropdown data for drop down edit type
            var $tr2 = ej.buildTag("tr"),
                $inTr3, $inTd3;

            if (model.showColumnChooser) {

                $td = ej.buildTag('td.e-add-property-container', "", {}, { colspan: 2, 'unselectable': "on" });

                $innerTable = ej.buildTag('table#' + proxy._id + 'dropdownDataTable', "", { "width": "100%", "outline": "none" }, { 'unselectable': "on" });

                $inTr3 = ej.buildTag('tr');
                $inTd3 = ej.buildTag('td.editLabel', "", { "outline": "none" }, { 'unselectable': "on" });
                $inTd3.append("<label for='dropdownData' style='font-weight:normal;'>" + proxy._columnDialogTexts["columnsDropdownData"] + "</label>");

                $inTr3.append($inTd3);
                $innerTable.append($inTr3);

                $inTr = ej.buildTag('tr');
                $inTd = ej.buildTag('td.editLabel', "", { "outline": "none" }, { 'unselectable': "on" });

                $inTd.append("<span class='e-addpre e-icon e-enable e-add-dialog' style='cursor:pointer; width: auto;'>" + proxy._columnDialogTexts["addData"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class='e-deletepre e-icon e-disable e-add-dialog' style='cursor:pointer; width: auto;'>&nbsp;&nbsp;" + proxy._columnDialogTexts["deleteData"] + "</span>");

                $inTr.append($inTd);
                $innerTable.append($inTr);

                $inTr2 = ej.buildTag('tr');
                $inTd2 = ej.buildTag('td.e-editValue');
                if ($("#" + proxy._id).width() <= proxy._responsiveMinWidth) {
                    var dropdownTreegridWidth = ($("#" + proxy._id).width() - 80) + 'px';
                    $inTd3 = ej.buildTag('div.dropdowntreegrid', "", { 'width': dropdownTreegridWidth, 'overflow':'hidden' });
                } else {
                    $inTd3 = ej.buildTag('div.dropdowntreegrid', "", { 'width': '438px', 'overflow': 'hidden' });
                }
                var $preDiv = ej.buildTag("div#treegrid" + proxy._id + "dropdownData", "", { "width": "100%", "height": "150px" }, {});
                $inTd3.append($preDiv);
                $inTd2.append($inTd3);

                $inTr2.append($inTd2);
                $innerTable.append($inTr2);

                $td.append($innerTable);
                $tr2.append($td);
                $table.append($tr2);
            }


            $form.append($table);

            $tbody = proxy.renderColumnAddDialogButton($form, $tbody);
            $.templates(proxy._id + "_ColumnAddTemplate", $tbody.html());
        },

        //button templates for column add dialog
        renderColumnAddDialogButton: function (form, tbody) {

            var btnId = "ColumnAddDialog_",
                proxy = this,
                model = proxy.model,
                $btnokDiv = ej.buildTag("div.e-add-dialog-btn-ok", "", {}, {}),
                $innerButokDiv = ej.buildTag("div", "", {}, {});
            var okbtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px'
                 },
                 { type: "button", id: btnId + proxy._id + "_Ok" }),
             okText = proxy._okButtonText;

            okbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: okText,
                    width: "100%"
                });

            var $btncanDiv = ej.buildTag("div.e-add-dialog-btn-cancel", "", {}, {}),
            $innerButcanDiv = ej.buildTag("div", "", {}, {});
            var cancelText = proxy._cancelButtonText,
             cancelbtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px'
                 },
                 {
                     type: "button",
                     id: btnId + proxy._id + "_Cancel"
                 });

            cancelbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: cancelText,
                    width: "100%"
                });

                var btnDiv = ej.buildTag('div', "", {}, { 'class': "e-treegrid-add-btn" });

            $innerButokDiv.append(okbtn)
            $btnokDiv.append($innerButokDiv);
            btnDiv.append($btnokDiv);
            $innerButcanDiv.append(cancelbtn)
            $btncanDiv.append($innerButcanDiv);
            btnDiv.append($btncanDiv);
            form.appendTo(tbody);
            btnDiv.appendTo(tbody);

            return tbody;
        },

        //button click event column add dialog
        _buttonClick: function (e) {

            if (e.keyCode != 0 && e.keyCode !== undefined && e.keyCode != 13)
                return true;

            var proxy = this,
                model = proxy.model, treeIndex = model.treeColumnIndex, setFrozen = false,
                dialogId = "ColumnAdd", $element, columnVals = {}, colFields = proxy._addColumnFields, columns = model.columns,
                insertIndex, args = {}, isAlreadyRender,filtertype;

            if (e.target.id == "ColumnAddDialog_" + proxy._id + "_Ok") {
                var formelement = document.getElementById(proxy._id + "ColumnAddForm"), ddl;
                for (var count = 0; count < colFields.length; count++) {
                    var colField = colFields[count];
                    $element = $(formelement).find("#" + proxy._id + colField + dialogId);
                    if (colField == "editType" || colField == "filterEditType" || colField == "textAlign" || colField == "headerTextAlign" || colField == "clipMode") {
                        ddl = $element.data("ejDropDownList");
                        columnVals[colField] = ddl._selectedValue;
                        //To get column's dropdown data if edit type is dropdownedit
                        if (colField == "editType" && columnVals[colField] == "dropdownedit") {
                            var tableTreeGrid = $(formelement).find("#treegrid" + proxy._id + "dropdownData"),
                                tableTreeGridObj = tableTreeGrid.data("ejTreeGrid"),
                                treeData = tableTreeGridObj.model.dataSource;
                            if (treeData.length > 0)
                                columnVals["dropdownData"] = treeData;
                        }
                    }
                    else if (colField == "showInColumnChooser" || colField == "allowCellSelection" || colField == "allowSorting" || colField == "allowFiltering" || colField == "allowFilteringBlankContent" || colField == "visible" || colField == "isFrozen" || colField == "allowFreezing" || colField == "displayAsCheckbox") {
                        var ch = $element.data("ejCheckBox");
                        columnVals[colField] = ch._isChecked;
                    }
                    else if ($element.val() == "" && (colField == "headerText" || colField == "field")) {
                        if (colField == "field")
                            columnVals[colField] = "Column" + (model.columns.length + 1);
                        else if (colField == "headerText")
                            columnVals[colField] = "Column " + (model.columns.length + 1);
                    }
                    else
                        columnVals[colField] = $element.val();
                }
                if (proxy._insertPosition == "left")
                    insertIndex = proxy._targetColumnIndex;
                else if (proxy._insertPosition == "right")
                    insertIndex = proxy._targetColumnIndex + 1;
                //To shift and maintain treecolumn index
                if (insertIndex <= treeIndex)
                    model.treeColumnIndex = treeIndex + 1;
                //Inserting new columns between frozen columns
                if (!model.isFromGantt) {
                    if (insertIndex <= proxy._frozenColumnsLength - 1)
                        setFrozen = true;
                }
                //Inserting columns -  left or right
                var newColumnObject = {};
                if (model.isFromGantt) {
                    newColumnObject = {
                        field: columnVals.field,
                        headerText: columnVals.headerText,
                        editType: columnVals.editType,
                        allowSorting: ej.isNullOrUndefined(columnVals.allowSorting) ? null : columnVals.allowSorting,
                        visible: columnVals.visible == false ? false : true,
                        width: columnVals.width ? columnVals.width : 150,
                        textAlign: columnVals.textAlign ? columnVals.textAlign : "left",
                        headerTextAlign: columnVals.headerTextAlign ? columnVals.headerTextAlign : "left",
                        dropdownData: columnVals.dropdownData ? columnVals.dropdownData : null,
                        allowCellSelection: ej.isNullOrUndefined(columnVals.allowCellSelection) ? null : columnVals.allowCellSelection,
                        mappingName: columnVals.field,
                        displayAsCheckbox: columnVals.displayAsCheckbox == false ? false : true,
                        clipMode: columnVals.clipMode ? columnVals.clipMode : "clip",
                        tooltip: columnVals.tooltip,
                        headerTooltip: columnVals.headerTooltip
                    };
                }
                else {
                    newColumnObject = {
                        field: columnVals.field,
                        headerText: columnVals.headerText,
                        editType: columnVals.editType,
                        filterEditType: columnVals.filterEditType ? columnVals.filterEditType : "stringedit",
                        allowFiltering: ej.isNullOrUndefined(columnVals.allowFiltering) ? null : columnVals.allowFiltering,
                        allowFilteringBlankContent: ej.isNullOrUndefined(columnVals.allowFilteringBlankContent) ? null : columnVals.allowFilteringBlankContent,
                        allowSorting: ej.isNullOrUndefined(columnVals.allowSorting) ? null : columnVals.allowSorting,
                        visible: columnVals.visible == false ? false : true,
                        width: columnVals.width ? columnVals.width : 150,
                        textAlign: columnVals.textAlign ? columnVals.textAlign : "left",
                        headerTextAlign: columnVals.headerTextAlign ? columnVals.headerTextAlign : "left",
                        clipMode: columnVals.clipMode ? columnVals.clipMode : "clip",
                        tooltip: columnVals.tooltip,
                        headerTooltip: columnVals.headerTooltip,
                        isFrozen: (columnVals.isFrozen == true || setFrozen == true) ? true : false,
                        allowFreezing: ej.isNullOrUndefined(columnVals.allowFreezing) ? null : columnVals.allowFreezing,
                        dropdownData: columnVals.dropdownData ? columnVals.dropdownData : null,
                        allowCellSelection: ej.isNullOrUndefined(columnVals.allowCellSelection) ? null : columnVals.allowCellSelection,
                        showInColumnChooser: columnVals.showInColumnChooser == false ? false : true,
                        displayAsCheckbox: columnVals.displayAsCheckbox == false ? false : true
                    }
                }
                args.requestType = "insertColumn";
                args.columnObject = newColumnObject;
                args.insertIndex = insertIndex;
                if (!proxy._trigger("actionComplete", args)) {
                    columns.splice(args.insertIndex, 0, args.columnObject);
                    proxy._refreshFrozenColumns();
                    if (model.isFromGantt)
                        proxy._updateAddEditDialogTemplate();
                }
                $("#" + proxy._id + "_dialogColumnAdd").ejDialog("close");
                if (model.allowFiltering && model.filterSettings.filterType == "menu") {
                    if (args.columnObject.filterEditType)
                        filtertype = args.columnObject.filterEditType;
                    else
                        filtertype = args.columnObject.editType;
                    var isAlreadyRender = proxy._renderedFilterMenuDialog.indexOf(filtertype);
                    if (isAlreadyRender == -1) {
                        proxy._renderFilterMenu(filtertype);
                    }
                }
                if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) || model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                } else if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                }
            }
            else if (e.target.id == "ColumnAddDialog_" + proxy._id + "_Cancel") {
                $("#" + proxy._id + "_dialogColumnAdd").ejDialog("close");
            }

            if (this.model.editSettings.editMode == "dialogEditing") {
                if (e.target.id == "EditFormDialog_" + this._id + "_Save") {
                    if (!proxy.editFormValidate())
                        return true;
                    if (this.element.find(".e-dialogaddrow .treegridform").length > 0) {
                        if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                            proxy._clearMultiSelectPopup();
                        }
                        if (!proxy._treegridDialogAddRow()) {
                            proxy._isTreeAddEditDialogSave = true;
                            $("#" + this._id + "_dialogEdit").ejDialog("close");
                            this._off($("#" + this._id + "_dialogEdit"),
                            "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                        }
                    } else if (this.element.find(".e-dialogeditedrow .treegridform").length > 0) {
                        if (!proxy.endEdit()) {
                            proxy._isTreeAddEditDialogSave = true;
                            $("#" + this._id + "_dialogEdit").ejDialog("close");
                            this._off($("#" + this._id + "_dialogEdit"),
                            "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                        }
                    }
                }
                else if (e.target.id == "EditFormDialog_" + this._id + "_Cancel") {
                    $("#" + this._id + "_dialogEdit").ejDialog("close");
                    this._off($("#" + this._id + "_dialogEdit"),
                  "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                }
            }

            return false;
        },

        // Method to save the newly added record via Add dialog or Add template dialog
        _treegridDialogAddRow: function () {
            var proxy = this, columns = proxy.model.columns, newItem = {}, value, column;
            for (var i = 0; i < columns.length; i++) {
                column = columns[i];
                if (!ej.isNullOrUndefined(column) && column["field"] != "") {
                    if (column.visible) {
                        value = proxy.getCurrentEditCellDataForRowEdit(column["field"], column["editType"], i);
                        if (proxy._checkboxSelection && column["field"] == "checkboxState") {
                            continue;
                        }
                        var splits = (column["field"] || "").split(".");
                        if (splits.length <= 1) {
                            newItem[column["field"]] = value;
                        } else {
                            newItem = proxy._restoreCustomData(newItem, value, column["field"]);
                        }
                    }
                }
            }
            if (proxy._addRecord(newItem, proxy.model.editSettings.rowPosition, null, "dialog"))
                return true;
        },

        //REFRESH THE EDITED FORM
        _refreshColumnAddForm: function () {
            var proxy = this,
               $form = $("#" + proxy._id + "ColumnAddForm"),
               $formElement = $form.find("input,select"),
               i = 0,
               elementFocused = false,
               length = $formElement.length,
               $element, inputWidth,
               model = proxy.model,
               width,
               params = {},
               value,
               columnPpty,
               customParams,
               toformat,
               formatVal,
               tableTreeGridId,
               dropdownDataTable,
               allColFields = [],
               rowHeight = proxy.model.rowHeight,
               editTypeLocaleText = proxy._editTypeText,
               textAlignLocaleText = proxy._textAlignTypeText,
               clipModeLocaleText = proxy._clipModeText,
               cellEditType;


            for (i; i < length; i++) {

                $element = $formElement.eq(i);
                inputWidth = '100%';

                columnPpty = $element.prop("name");

                if ($element.hasClass("e-dropdownlist")) {
                    if (columnPpty == "field") {
                        var fieldData = [], reqFields = [];

                        if (model.columns.length) {
                            allColFields = $.map(model.columns, function (col) {
                                if (model.isFromGantt)
                                    return col.mappingName ? col.mappingName : col.field;
                                else
                                    return col.field;
                            });
                        }

                        //getting all the fields of datasource
                        if (!proxy._dataSourcefields.length) {
                            proxy._dataSourcefields = $.extend(true, [], allColFields);
                            proxy.getAllDataSourceFields();
                        }
                        //comaparing and taking the non column fields alone for add column dialog - fields
                        for (var k = 0; k < proxy._dataSourcefields.length; k++) {
                            if ($.inArray(proxy._dataSourcefields[k], allColFields) == -1 && proxy._dataSourcefields[k] != model.notesMapping)
                                reqFields.push(proxy._dataSourcefields[k]);
                        }

                        for (var fd = 0; fd < reqFields.length; fd++) {
                            fieldData.push({ "id": fd + 1, "text": reqFields[fd] });
                        }
                        $element.ejDropDownList({
                            width: inputWidth,
                            cssClass: model.cssClass,
                            dataSource: fieldData,
                            fields: {
                                id: "id",
                                text: "text",
                                value: "text"
                            },
                        });
                    }
                    else if (columnPpty == "editType" || columnPpty == "filterEditType") {
                        var fieldData = [
                            { "id": "1", "text": editTypeLocaleText['string'], "value": "stringedit" }, { "id": "2", "text": editTypeLocaleText['numeric'], "value": "numericedit" },
                            { "id": "3", "text": editTypeLocaleText['datePicker'], "value": "datepicker" }, { "id": "4", "text": editTypeLocaleText['dateTimePicker'], "value": "datetimepicker" },
                            { "id": "5", "text": editTypeLocaleText['dropdown'], "value": "dropdownedit" }, { "id": "6", "text": editTypeLocaleText['boolean'], "value": "booleanedit" }
                        ];
                        $element.ejDropDownList({
                            width: inputWidth,
                            dataSource: fieldData,
                            cssClass: model.cssClass,
                            fields: {
                                id: "id",
                                text: "text",
                                value: "value"
                            },
                            selectedIndex: 0,
                            change: function (args) {
                                var isRefreshDialog = false;
                                if (dropdownDataTable.hidden == true && args.value == "dropdownedit") {
                                    dropdownDataTable.hidden = false;
                                    isRefreshDialog = true;
                                }
                                else if (dropdownDataTable.hidden == false && args.value != "dropdownedit") {
                                    dropdownDataTable.hidden = true;
                                    isRefreshDialog = true;
                                }

                                var checkBoxContainer = $("#" + proxy._id + "_dialogColumnAdd").find(".e-display-checkbox-conatiner");
                                if (args.value == "booleanedit" && checkBoxContainer.length > 0 && checkBoxContainer.css("display") == "none") {
                                    checkBoxContainer.css("display", "block");
                                    isRefreshDialog = true;
                                } else if (args.value != "booleanedit" && checkBoxContainer.length > 0 && checkBoxContainer.css("display") == "block") {
                                    checkBoxContainer.css("display", "none");
                                    isRefreshDialog = true;
                                }
                                if (isRefreshDialog) {
                                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog("refresh");
                                }
                            }
                        });
                    }
                    else if (columnPpty == "textAlign" || columnPpty == "headerTextAlign") {
                        var fieldData1 = [
                            { "id": "1", "text": textAlignLocaleText["left"], "value": "left" }, { "id": "2", "text": textAlignLocaleText["right"], "value": "right" },
                            { "id": "3", "text": textAlignLocaleText["center"], "value": "center" }];

                        $element.ejDropDownList({
                            width: inputWidth,
                            dataSource: fieldData1,
                            cssClass: model.cssClass,
                            fields: {
                                id: "id",
                                text: "text",
                                value: "value"
                            },
                            selectedIndex: 0
                        });
                    } else if (columnPpty == "clipMode") {
                        var clipModeData = [
                                                    { "id": "1", "text": clipModeLocaleText["clip"], "value": "clip" }, { "id": "2", "text": clipModeLocaleText["ellipsis"], "value": "ellipsis" }];

                        $element.ejDropDownList({
                            width: inputWidth,
                            dataSource: clipModeData,
                            cssClass: model.cssClass,
                            fields: {
                                id: "id",
                                text: "text",
                                value: "value"
                            },
                            selectedIndex: 0
                        });
                    }
                }
                else if ($element.hasClass("e-numerictextbox") && columnPpty == "width") {

                    value = $element.val();
                    params.width = inputWidth;
                    params.showSpinButton = true;
                    params.cssClass = model.cssClass;
                    params.maxValue = 250;
                    params.minValue = 30;

                    if (value.length)
                        params.value = parseFloat(value);
                    else
                        params.value = 150;
                    
                    $element.ejNumericTextbox(params);
                }
                else if (columnPpty == "showInColumnChooser" || columnPpty == "allowCellSelection" || columnPpty == "allowFiltering" || columnPpty == "allowFilteringBlankContent" || columnPpty == "allowSorting" || columnPpty == "visible" || columnPpty == "isFrozen" || columnPpty == "allowFreezing" || columnPpty == "displayAsCheckbox") {

                    var controlArgs = {};
                    controlArgs.cssClass = model.cssClass;
                    controlArgs.size = "small";
                    $element.ejCheckBox(controlArgs);
                }               

                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof $element.data("ejDropDownList") == "object")) {
                    if (!proxy._isEnterKeyPressed) {
                        proxy._focusElements($element.closest('td'));
                        elementFocused = true;
                    }
                }
            }

            tableTreeGridId = "#treegrid" + proxy._id + "dropdownData";
            //Render dropdown data table for column add dialog 
            if ($(tableTreeGridId).length) {
                var ds = [];

                $(tableTreeGridId).ejTreeGrid({
                    dataSource: ds,
                    allowSorting: false,
                    allowAdding: true,
                    columns: [{ headerText: proxy._columnDialogTexts["dropdownTableText"], field: "text", editType: ej.TreeGrid.EditingType.String, width: "150px" },
                              { headerText: proxy._columnDialogTexts["dropdownTableValue"], field: "value", editType: ej.TreeGrid.EditingType.String, width: "150px" }],
                    enableAltRow: true,
                    allowColumnResize: true,
                    cssClass: model.cssClass,
                    enableResize:true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                    },
                    locale: model.locale,
                    treeColumnIndex: 5,
                    emptyRecordText: "Add values for dropdown",
                    rowSelected: function (args) {
                        if (args.data) {
                            $('.e-deletepre').addClass('e-enable').removeClass('e-disable');
                            $(".e-deletepre").bind("click", $.proxy(proxy._deleteDropDownRow, proxy, $(tableTreeGridId)));
                        }
                    },

                });
                //Hide the dropdown data table while initializing
                dropdownDataTable = $form.find("#" + proxy._id + "dropdownDataTable").parent()[0];
                dropdownDataTable.hidden = true;
                //Enable the click event for Add icon
                $(".e-addpre").bind("click", $.proxy(proxy._addDropDownRow, proxy, $(tableTreeGridId)));
            }

        },

        // Add new row for the drop down table
        _addDropDownRow: function (tableTreeGrid, e) {
            var proxy = this, args = {},
                treeGridObj = tableTreeGrid.data("ejTreeGrid"),
                treeData = treeGridObj.model.dataSource,
                dlength = treeData.length,
                item = { text: "Text " + (dlength + 1), value: "Value" + (dlength + 1) };
            treeGridObj.addRow(item, "bottom");
        },
        // delete row from the drop down table
        _deleteDropDownRow: function (tableTreeGrid, e) {
            var proxy = this, args = {},
                treeGridObj = tableTreeGrid.data("ejTreeGrid"),
                treeData = treeGridObj.model.updatedRecords,
                dlength = treeData.length,
                selectedItem = treeGridObj.model.selectedItem;
            if (dlength != 0 && selectedItem) {
                treeGridObj.deleteRow();
                $('.e-deletepre').addClass('e-disable').removeClass('e-enable');
                $(".e-deletepre").unbind("click", $.proxy(proxy._deleteDropDownRow, proxy, tableTreeGrid));
            }

        },

        //get all the fields of the dataSource
        getAllDataSourceFields: function () {
            var proxy = this, model = proxy.model,
                dataSourceCol = model.dataSource;
            for (var d = 0; d < dataSourceCol.length; d++) {
                var jsonData = dataSourceCol[d];
                for (var dsKey in jsonData) {
                    if (dsKey == model.childMapping) {
                        proxy.getChildKeys(jsonData[dsKey]);
                    }
                    else if ($.inArray(dsKey, proxy._dataSourcefields) == -1)
                        if (model.isFromGantt) {
                            if (dsKey != "undefined" && dsKey != model.notesMapping)
                                proxy._dataSourcefields.push(dsKey);
                        }
                        else {
                            if (typeof jsonData[dsKey] != "object")
                            proxy._dataSourcefields.push(dsKey);
                        }
                }
            }
        },

        //get keys of child from datasource.
        getChildKeys: function (childData) {
            var proxy = this, model = proxy.model;
            if (childData) {
                for (var c = 0; c < childData.length; c++) {
                    var chData = childData[c];
                    for (var childKey in chData)
                        if (childKey == model.childMapping) {
                            proxy.getChildKeys(chData[childKey]);
                        }
                        else if ($.inArray(childKey, proxy._dataSourcefields) == -1) {
                            if (typeof chData[childKey] != "object")
                            proxy._dataSourcefields.push(childKey);
                        }
                }
            }
        },

        //Method to render confirm dialog box while saving and cancelling and deleting
        _renderUpdateConfirmDialog: function () {
            var proxy = this,
                confDelTxt = proxy._confirmDeleteText,
                $contentDiv = ej.buildTag('div.e-content', proxy._deleteColumnText),
                $buttons = ej.buildTag('span.e-buttons', "<input class='e-confirm-dialog-btn-ok' type='button' id=" + proxy._id + 'ConfirmDialogOK' + " value=" + proxy._okButtonText + " /> "
                + "<input class='e-confirm-dialog-btn-cancel' type='button' id=" + proxy._id + 'ConfirmDialogCancel' + " value='" + proxy._cancelButtonText + "' />"),
                btnDiv = ej.buildTag('div', "", {}, { 'class': "e-confirm-dialog-btn" });
            btnDiv.append($buttons);
            proxy._updateConfirmDialog = ej.buildTag('div', '', '', { 'title': confDelTxt, 'id': proxy._id + 'ConfirmDialog' });
            proxy._updateConfirmDialog.append($contentDiv).append(btnDiv);
            proxy.element.append(proxy._updateConfirmDialog);
            $buttons.find("input").ejButton({
                cssClass: proxy.model.cssClass,
                showRoundedCorner: true,
                size: "normal",
                click: $.proxy(proxy._triggerUpdateConfirm, proxy)
            });
            proxy._updateConfirmDialog.ejDialog({ width: "auto", minHeight: 0, minWidth: 0, showOnInit: false, isResponsive: true, enableResize: false, enableModal: true, cssClass: proxy.model.cssClass });
            $("#" + proxy._id + "ConfirmDialog_wrapper").addClass("e-treegrid-dialog");
        },

        _triggerUpdateConfirm: function (args) {
            var proxy = this;
            if (args !== undefined && args.model.text == proxy._okButtonText) {
                if (proxy._updateConfirmDialog.find(".e-content").text() == proxy._deleteColumnText)
                    proxy.deleteColumn(proxy._targetColumnIndex);
            }
            proxy._updateConfirmDialog.ejDialog("close");
        },

        //Method to delete column
        deleteColumn: function (columnIndex) {
            var proxy = this, model = proxy.model, columns = model.columns, deletedColumn,
                sortedColumns = model.sortSettings && model.sortSettings.sortedColumns.length ? model.sortSettings.sortedColumns : null,
                column = columns[columnIndex], args = {};
            args.requestType="deleteColumn";
            args.columnObject = column;
            args.deleteIndex = columnIndex;
            if (!proxy._trigger("actionComplete", args)) {
                deletedColumn = columns.splice(columnIndex, 1);
                if (sortedColumns) {
                    var resultCol = $.grep(sortedColumns, function (sCol) { return sCol.field == deletedColumn[0].field; });
                    if (resultCol.length)
                        sortedColumns.splice(sortedColumns.indexOf(resultCol[0]), 1);
                }
                if (proxy._targetColumnIndex <= model.treeColumnIndex)
                    model.treeColumnIndex = model.treeColumnIndex - 1;
                proxy._refreshFrozenColumns();
                if (model.isFromGantt)
                    proxy._updateAddEditDialogTemplate();
            }
        },

        //Get the element Left and Top position

        getOffsetRect:function(elem) {
            var box = elem.getBoundingClientRect(),
                body = document.body,
                docElem = document.documentElement,
                scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
                scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
                clientTop = docElem.clientTop || body.clientTop || 0 ,
                clientLeft = docElem.clientLeft || body.clientLeft || 0 ,
                top  = box.top +  scrollTop - clientTop ,
                left = box.left + scrollLeft- clientLeft;
            return { top: Math.round(top), left: Math.round(left) };
        },
        _moveToNextMenuItem: function (move) {

            var proxy,
              currentMenuItem,
              contextMenu, model = this.model,
              nextMenuItem = {};
            if (model.isFromGantt) {
                proxy = $("#" + this._id.replace("ejTreeGrid", "")).data("ejGantt");
                contextMenu = $("#" + this._id.replace("ejTreeGrid", "") + "_ContextMenu");
            }
            else {
                proxy = this;
                contextMenu = $("#" + this._id + "_ContextMenu");
            }
            currentMenuItem = $("#" + proxy._activeMenuItemId);

            switch (move) {
                case "next":
                    if (currentMenuItem.length == 0) {
                        nextMenuItem = contextMenu.find("div.e-menuitem:not(.e-disable)").first();
                    } else {
                        nextMenuItem = currentMenuItem.closest("li").next("li").find("div.e-menuitem");
                        if (nextMenuItem.length > 0) {
                            if (nextMenuItem.hasClass("e-disable")) {
                                nextMenuItem = this._findContextMenuItem(nextMenuItem, "next");
                            }
                        }
                    }
                    var nextSubContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                    nextSubContextMenu.remove();
                    break;
                case "prev":
                    nextMenuItem = this._findContextMenuItem(currentMenuItem, "prev");
                    var nextSubContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                    nextSubContextMenu.remove();
                    break;
                case "expand":
                    if (currentMenuItem.length > 0) {
                        proxy._showSubContextMenu(currentMenuItem[0], proxy._contextMenuItems);
                        var subContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                        if (subContextMenu.length > 0) {
                            nextMenuItem = subContextMenu.find("div.e-menuitem:not(.e-disable)").first();
                        }
                    }
                    break;
                case "collapse":
                    var subContextMenu = $(currentMenuItem).closest(".e-innerContextmenu");
                    if (subContextMenu.length > 0) {
                        var parentMenuId = subContextMenu.attr("id").replace(proxy._id + "_SubContextMenu", "");
                        nextMenuItem = $("#" + parentMenuId);
                        var nextSubContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                        nextSubContextMenu.remove();
                        subContextMenu.remove();
                    }
                    break;
                case "save":
                    if (currentMenuItem.length > 0) {
                        if ($("#" + proxy._activeMenuItemId).find(".e-expander").length == 0) {
                            if (!model.isFromGantt)
                                proxy.contextMenuOperations(proxy._activeMenuItemId);
                            else
                                proxy._contextMenuClickHandler($("#" + proxy._activeMenuItemId));
                            proxy._clearContextMenu();
                        } else {
                            proxy._showSubContextMenu(currentMenuItem[0], proxy._contextMenuItems);
                            var subContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                            if (subContextMenu.length > 0) {
                                nextMenuItem = subContextMenu.find("div.e-menuitem:not(.e-disable)").first();
                            }
                        }
                    }
            }

            if (nextMenuItem.length > 0) {
                if((move == "next" || move == "prev"))
                    currentMenuItem.removeClass("e-contextmenu-mouseover");
                nextMenuItem.addClass("e-contextmenu-mouseover");
                proxy._activeMenuItemId = $(nextMenuItem).attr("id");
            }
        },
        /*Get Next active columnMenu item*/
        _findNextColumnMenuItem: function (item, move) {
            var proxy = this, nextItem, prevItem;
            if (move === "next") {
                nextItem = item.closest("li").next("li").find("div.e-columnmenuitem");
                if (nextItem.length > 0) {
                    if (!nextItem.hasClass("e-disable")) {
                        return nextItem;
                    }
                    else
                        return proxy._findNextColumnMenuItem(nextItem, "next");
                }
                else
                    return nextItem;
            }
            else {
                prevItem = item.closest("li").prev("li").find("div.e-columnmenuitem");
                if (prevItem.length > 0) {
                    if (!prevItem.hasClass("e-disable")) {
                        return prevItem;
                    }
                    else
                        return proxy._findNextColumnMenuItem(prevItem, "prev");
                }
                else
                    return prevItem;
            }
        },
        // get concade field value
        _getFieldValue: function (field, columnCount) {

            if (field != "") {
                return field.split('.').join("");
            } else {
                return "TGcolumn" + columnCount;
            }

        },

        // Find the next context menu item to select
        _findContextMenuItem: function (item, move) {
            var proxy = this, nextItem, prevItem;
            if (move === "next") {
                nextItem = item.closest("li").next("li").find("div.e-menuitem");
                if (nextItem.length > 0) {
                    if (!nextItem.hasClass("e-disable")) {
                        return nextItem;
                    }
                    else
                        return proxy._findContextMenuItem(nextItem, "next");
                }
                else
                    return nextItem;
            }
            else {
                prevItem = item.closest("li").prev("li").find("div.e-menuitem");
                if (prevItem.length > 0) {
                    if (!prevItem.hasClass("e-disable")) {
                        return prevItem;
                    }
                    else
                        return proxy._findContextMenuItem(prevItem, "prev");
                }
                else
                    return prevItem;
            }
        }
    });

    //ENUM FOR EACH ACTION IN TREEGRID
    ej.TreeGrid.Actions = {
        Sorting: "sorting",
        BeginEdit: "beginedit",
        Save: "save",
        Add: "add",
        Delete: "delete",
        Cancel: "cancel",
        Refresh: "refresh",
        Searching: "searching",
        ExpandCollapse: "expandcollapse",
        Selection: "selection",
        rowHover: "rowHover",
        Scroll: "scroll",
        ContextMenuAdd: "contextMenuAdd",
        RefreshDataSource: "refreshDataSource",
        DragAndDrop: "dragAndDrop",
        Paging: "paging"
    };

    //ENUM FOR SELECTION MODE IN TREEGRID
    ej.TreeGrid.SelectionType = {
        Single: "single",
        Multiple: "multiple",
        Checkbox: "checkbox"
    };

    //ENUM FOR FILTER TYPE IN TREEGRID
    ej.TreeGrid.FilterType = {
        FilterBar: "filterbar",
        Menu: "menu",
    };

    //ENUM FOR DIFFERENT EDIT MODE IN TREEGRID
    ej.TreeGrid.EditMode = {
        CellEditing: "cellEditing",
        RowEditing: "rowEditing",
        DialogEditing: "dialogEditing",
    };

    //ENUM FOR DIFFERENT WRAP MODE IN TREEGRID
    ej.TreeGrid.ClipMode = {
        Clip: "clip",
        Ellipsis: "ellipsis"
    };

    //ENUM FOR DIFFERENT PAGE MODE IN TREEGRID
    ej.TreeGrid.PageSizeMode = {
        All: "all",
        Root: "root",
    };

    //Enum for position of new added row.
    ej.TreeGrid.RowPosition = {
        Top: "top",
        Bottom: "bottom",
        Above: "aboveSelectedRow",
        Below: "belowSelectedRow",
        Child : "child"
    }

    //Enum for Edit Action of TreeGrid.
    ej.TreeGrid.BeginEditAction = {
        DblClick: "dblClick",
        Click: "click"
    };
    /* enum for six different columnEditType for treegrid */
    ej.TreeGrid.EditingType = {
        String: "stringedit",
        Boolean: "booleanedit",
        Numeric: "numericedit",
        Dropdown: "dropdownedit",
        DatePicker: "datepicker",
        DateTimePicker: "datetimepicker",
        Maskedit : "maskedit"
    };
    /* enum for different context menu in treegrid */
    ej.TreeGrid.ContextMenuItems = {
        Add: "add",
        Edit: "edit",
        Delete: "delete",
    };
    //enum for column width mode
    ej.TreeGrid.ColumnResizeMode = {
        Normal: "normal",
        FixedColumns: "fixedcolumns",
        NextColumn: "nextcolumn"
    }
    ej.TreeGrid = ej.TreeGrid || {};


    //INITIALIZE THE CELLEDIT ELEMENT FOR DIFFERENT TYPES OF EDITORS
    ej.TreeGrid._initCellEditType = function (instance, $element, id, columnCount, dialogId) {

        var proxy = instance,
            model = proxy.model,
            columns = model.columns,
            column = columns[columnCount],
            dialogId = dialogId ? dialogId : "", splits = (columns[columnCount].field || "").split("."), columnName;

        if (columns[columnCount]["editTemplate"])
            columns[columnCount]["editType"] = "edittemplate";
        else if (ej.isNullOrUndefined(columns[columnCount]["editType"])) {
            column["editType"] = "stringedit";
        }

        if (proxy.model.editSettings.editMode == "dialogEditing") {
            columnName = columns[columnCount].field;
        } else {
            columnName = proxy._getFieldValue(columns[columnCount].field, columnCount);
        }

        switch (column["editType"]) {

            case "stringedit":

                if (model.isFromGantt) {

                    var helpers = {};

                    if (column.field === "predecessor") {
                        helpers["_" + id + "predecessorCell"] = $.proxy(ej.Gantt._getPredecessorsValue, proxy);
                    }

                    $.views.helpers(helpers);


                    if (column.field === "predecessor") { //get the predecessor value from item of GanttRecord

                        var $input = ej.buildTag('input.e-field e-ejinputtext',
                                       "", {},
                                       {
                                           value: "{{:~_" + id + "predecessorCell(#data)}}",
                                           id: id + column.field + dialogId,
                                           name: column.field,
                                           dialog: dialogId
                                       });

                    } else if (column.field === "duration") { //get the predecessor value from item of GanttRecord
                        var helpers = {};
                        helpers["_" + id + "getDurationStringValue"] = $.proxy(ej.Gantt._getDurationStringValue, proxy);
                        $.views.helpers(helpers);
                        var $input = ej.buildTag('input.e-field e-ejinputtext',
                                       "", {},
                                       {
                                           value: "{{:~_" + id + "getDurationStringValue(#data)}}",
                                           id: id + column.field + dialogId,
                                           name: column.field,
                                           dialog: dialogId
                                       });

                    }
                    else { /*get the cellValue if the column does not exist in the GanttRecord object and
                           present in the item of GanttRecord*/
                        $input = ej.buildTag('input.e-field e-ejinputtext',
                                            "",
                                            {},
                                            {
                                                value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                                id: id + model.columns[columnCount].field + dialogId,
                                                name: model.columns[columnCount].field,
                                                dialog: dialogId
                                            });

                    }

                } else { /*Get the cellvalue of the normal gridcell*/
                    $input = ej.buildTag('input.e-field e-ejinputtext',
                                          "",
                                          {},
                                          {
                                              value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                              id: id + proxy._getFieldValue(column.field,columnCount) + dialogId,
                                              name: column.field,
                                              dialog: dialogId
                                          });
                }
                $input.attr("edittype", columns[columnCount].editType);
                $element.html($input);
            
                break;

            case "maskedit":
                $input = ej.buildTag('input.e-field e-maskedit', "", {},
                                         {
                                             value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                             id: id + proxy._getFieldValue(column.field,columnCount) + dialogId,
                                             name: column.field,
                                             dialog: dialogId
                                         });
                $input.attr("edittype", columns[columnCount].editType);
                $element.html($input);
                break;

            case "booleanedit":
                $element.html('{{if true===~_' + proxy._id + 'cellValue(#data,"' + columnName + '")}}' +
                         '<input type ="checkbox" ' +
                         'id="' + id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId +
                         '" dialog ="' + dialogId +
                         '" name="' + columns[columnCount].field +
                         '" checked="checked" edittype="' + columns[columnCount].editType + '"></input>' +
                         ' {{else}}' +
                         '<input' +
                         ' type ="checkbox"' +
                         ' id="' + id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId +
                         '" dialog ="' + dialogId +
                         '" name="' + columns[columnCount].field + '" edittype="' + columns[columnCount].editType + '">' +
                         '{{/if}}');

                break;

            case "numericedit":

                var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", {}, {
                    type: "text",
                    value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                    id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                    name: columns[columnCount].field,
                    dialog: dialogId
                });
                $numericText.attr("edittype", columns[columnCount].editType);
                $element.append($numericText);

                break;

            case "datepicker":

                var $datePicker = ej.buildTag('input.e-datepicker e-field', "",
                                             {},
                                             {
                                                 type: "text",
                                                 value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                                 id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                                                 name: columns[columnCount].field,
                                                 dialog: dialogId
                                             });
                $datePicker.attr("edittype", columns[columnCount].editType);
                $element.append($datePicker);

                break;
            case "datetimepicker":

                var $datePicker = ej.buildTag('input.e-datetimepicker e-field', "",
                                             {},
                                             {
                                                 type: "text",
                                                 value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                                 id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                                                 name: columns[columnCount].field,
                                                 dialog: dialogId
                                             });
                $datePicker.attr("edittype", columns[columnCount].editType);
                $element.append($datePicker);

                break;
            case "dropdownedit":

                var $dropDownList = ej.buildTag('input.e-field e-dropdownlist',
                    "",
                    {},
                    {
                        type: "text",
                        id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                        name: columns[columnCount].field,
                        dialog: dialogId
                    });
                $dropDownList.attr("edittype", columns[columnCount].editType)
                    .attr("cellValue", "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}");
                $element.append($dropDownList);

                break;
            case "edittemplate":
                var temp = columns[columnCount].editTemplate.create;
                if (typeof temp == "string") {
                    var temp1 = ej.util.getObject(temp, window);
                    if (!$.isFunction(temp1)) {
                        if ($(temp).length == 1 && $(temp).get(0).tagName == "SCRIPT")
                            var $edittemplate = $($(temp).html()).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                        else
                            var $edittemplate = $(temp).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                    }
                    else
                        var $edittemplate = $(temp1()).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                }
                else
                    var $edittemplate = $(temp()).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                $edittemplate.attr("edittype", columns[columnCount].editType);
                $element.append($edittemplate);
                break;
        }
    };
    
    //Initialize tree grid toolbar item.
    ej.TreeGrid.ToolbarItems = {
        Add: "add",
        Edit: "edit",
        Delete: "delete",
        Update: "update",
        Cancel: "cancel",
        ExpandAll: "expandAll",
        CollapseAll: "collapseAll",
        PdfExport: "pdfExport",
        ExcelExport: "excelExport"
    };

    //Enum Values of summaryType
    ej.TreeGrid.SummaryType = {
        Sum: "sum",
        Average: "average",
        Maximum: "maximum",
        Minimum: "minimum",
        Count: "count",
        MinimumDate: "minimumDate",
        MaximumDate: "maximumDate",
        TrueCount: "trueCount",
        FalseCount: "falseCount",
    };

    //Enum Value of selectionMode.
    ej.TreeGrid.SelectionMode = {
        Row: "row",
        Cell: "cell"
    };

    ej.TreeGrid.Locale = ej.TreeGrid.Locale || {};

    ej.TreeGrid.Locale["default"] = ej.TreeGrid.Locale["en-US"] = {
        //string to be displayed in Toolbox's tooltip 
        toolboxTooltipTexts: {
            addTool: "Add",
            editTool: "Edit",
            updateTool: "Update",
            deleteTool: "Delete",
            cancelTool: "Cancel",
            expandAllTool: "Expand All",
            collapseAllTool: "Collapse All",
            pdfExportTool: "PDF Export",
            excelExportTool: "Excel Export"
        },
        //string to be displayed in context menu 
        contextMenuTexts: {
            addRowText: "Add Row",
            editText: "Edit",
            deleteText: "Delete",
            saveText: "Save",
            cancelText : "Cancel",
            aboveText: "Above",
            belowText: "Below"
        },
        filterMenuTexts:{
            stringMenuOptions: [{ text: "Starts With", value: "startswith" },
                    { text: "Ends With", value: "endswith" },
                    { text: "Contains", value: "contains" },
                    { text: "Equals", value: "equal" },
                    { text: "Does Not Equal", value: "notequal" }],
            numberMenuOptions: [{ text: "Less Than", value: "lessthan" },
                        { text: "Greater Than", value: "greaterthan" },
                        { text: "Less Than Or Equal To", value: "lessthanorequal" },
                        { text: "Greater Than Or Equal To", value: "greaterthanorequal" },
                        { text: "Equals", value: "equal" },
                        { text: "Does Not Equal", value: "notequal" }],
            filterValue: "Filter Value",
            filterButton: "Filter",
            clearButton: "Clear",
            enterValueText: "enter value",
        },
        //string to be displayed in column menu 
        columnMenuTexts: {
            sortAscendingText: "Sort Ascending",
            sortDescendingText: "Sort Descending",
            columnsText: "Columns",
            freezeText: "Freeze",
            unfreezeText: "Unfreeze",
            freezePrecedingColumnsText: "Freeze Preceding Columns",
            insertColumnLeft: "Insert Column Left",
            insertColumnRight: "Insert Column Right",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column",
            menuFilter: "Filter"
        },

        //string to display in column add dialog 
        columnDialogTexts: {
            field: "Field",
            headerText: "Header Text",
            editType: "Edit Type",
            filterEditType: "Filter Edit Type",
            allowFiltering: "Allow Filtering",
            allowFilteringBlankContent: "Allow Filtering Blank Content",
            allowSorting: "Allow Sorting",
            visible: "Visible",
            width: "Width",
            textAlign: "Text Alignment",
            headerTextAlign: "Header Text Alignment",
            isFrozen: "Is Frozen",
            allowFreezing: "Allow Freezing",
            columnsDropdownData: "Column Dropdown Data",
            dropdownTableText: "Text",
            dropdownTableValue: "Value",
            addData: "Add",
            deleteData: "Remove",
            allowCellSelection: "Allow Cell Selection",
            showInColumnChooser: "Show In Column Chooser",
            clipMode: "Clip Mode",
            tooltip: "Tooltip",
            headerTooltip: "Header Tooltip",
            displayAsCheckbox: "Display As Checkbox"
        },

        //string to be displayed in column add dialog title 
        columnDialogTitle: {
            insertColumn: "Insert Column",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column"
        },

        //String to be display for edittype and filter edit type.
        editTypeTexts: {
            string: "String",
            numeric: "Numeric",
            datePicker: "Date Picker",
            dateTimePicker: "Date Time Picker",
            dropdown: "Dropdown",
            boolean: "Boolean"

        },

        // String to be display for text align type.
        textAlignTypes:{
            right: "Right",
            left: "Left",
            center: "Center"
        },

        // String to be display for clip mode type.
        clipModeTexts:{
            clip: "Clip",
            ellipsis: "Ellipsis"
        },

        //Locale Text for delete confirm dialog
        deleteColumnText: "Are you sure you want to delete this column?",
        okButtonText: "OK",
        cancelButtonText: "Cancel",
        confirmDeleteText: "Confirm Delete",

        //String to be displayed in drop down list for filtering blank items
        dropDownListBlanksText: "(Blanks)",
        //String to be displayed in drop down list to clear filtered items
        dropDownListClearText: "(Clear Filter)",
        //Text to be displayed in drop down list for FALSE value in boolean edit type column
        trueText: "True",
        //Text to be displayed in drop down list for True value in boolean edit type column
        falseText: "False",
        emptyRecord: "No records to display",
    };

    //GET ROW CLASS NAME FOR EXPAND COLLAPSE ACTION
    ej.TreeGrid._getrowClassName = function () {

        var rowClass = "gridrowIndex",
            proxy = this;

        if (proxy.data.parentItem) {

            rowClass += proxy.data.parentItem.index.toString();

        }

        rowClass += "level";
        rowClass += proxy.data.level.toString();
        if (proxy.data.isSummaryRow) {
            rowClass += " ";
            rowClass += "e-summaryrow";
        }
        if (proxy.data.footerSummaryRowRecord) {
            rowClass += " ";
            rowClass += "e-footersummaryrow";
        }

        return rowClass;
    };
    ej.TreeGrid._getSummaryRowtdClassName = function () {
        var proxy = this;
        var tdClass = "";
        if (proxy.data.isSummaryRow) {
            tdClass += " ";
            tdClass += "e-summaryrowcell";
        }
        if (proxy.data.footerSummaryRowRecord) {
            tdClass += " ";
            tdClass += "e-footersummaryrowcell";
        }
        return tdClass;
    };

    //GET COLUMN BY FIELD NAME
    ej.TreeGrid.getColumnByField = function (columns, field) {

        var column = 0;

        for (column; column < columns.length; column++) {

            if (columns[column]["field"].split('.').join("") == field.split('.').join("")) break;

        }

        return column == columns.length ? null : columns[column];
    };


    ej.TreeGrid.getColumnByMappingName = function (columns, field) {
        var column = 0;
        for (column; column < columns.length; column++) {
            if (columns[column]["mappingName"] == field) break;
        }
        return column == columns.length ? null : columns[column];
    };

    //EXPAND COLLAPSE THE PARTICULAR RECORD OBJECT
    ej.TreeGrid.sendExpandCollapseRequest = function (element, args) {

        var proxy = element,
             model = proxy.model,
             toolbarItems = model.toolbarSettings.toolbarItems,
             updatedRecords;

        args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
        //To cancel the cell edit or row edit mode when expand the all record.
        if (proxy._isRowEdit) 
            proxy.cancelRowEditCell();
        else if (proxy.model.isEdit)
            proxy.cancelEditCell();

        if (model.enableVirtualization) {

            if (proxy._isFromGantt) {
                proxy._$treegridHelper.ejTreeGrid("processBindings", args);
            } else {
                proxy.processBindings(args);
            }

            if (proxy._isFromGantt) {
                if (proxy._isInExpandCollapseAll === false) {
                    if (model.enableAltRow) {
                        proxy._$treegridHelper.ejTreeGrid("updateAltRow");
                    }
                    proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args);
                    proxy._$treegridHelper.ejTreeGrid("updateHeight");
                    proxy.model.updatedGanttRecords = proxy.getUpdatedRecords();
                    proxy.model.currentViewData = proxy.getCurrentViewData();
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedGanttRecords);
                  
                }
            }
            else {
                if (proxy._isInExpandCollapseAll === false) {
                    if (model.enableAltRow) {
                        proxy.updateAltRow();
                    }
                    proxy.sendDataRenderingRequest(args);
                    proxy._setScrollTop();
                    proxy.updateHeight();
                }
            }
            
        } else {
            var record = args.data,
                index,
                $row,
                height = 0,
                isModified = record.expanded !== args.expanded;
                index = proxy.model.currentViewData.indexOf(record);
            
                if (proxy._frozenColumnsLength && proxy.getRows()) {
                    $row = $(proxy.getRows()[0][index]).add(proxy.getRows()[1][index]);
                }
                else if (proxy.getRows()) {
                    $row = proxy.getRows() && $(proxy.getRows()[index]);
                }

                if (args.expanded) {
                    record.expanded = args.expanded;
                    $row && ej.TreeGrid.expandRecord(proxy, record, args.expanded, args);
                    if (record.hasFilteredChildRecords) {
                        $row && $row.find(".e-treegridcollapse").removeClass('e-treegridcollapse').addClass('e-treegridexpand');
                        $row && $row.removeClass('e-treegridrowcollapse').addClass('e-treegridrowexpand');
                    }
                    if (model.enableAltRow && proxy._isInExpandCollapseAll === false && !model.allowPaging) {
                        ej.TreeGrid.updateAltRow(proxy, record, index, 1);
                    }
                }
                else {
                    proxy._collapsedRecordCount = 0;//For update alt row
                    $row && ej.TreeGrid.collapseRecord(proxy, record, args.expanded);
                    record.expanded = args.expanded;
                    if (record.hasFilteredChildRecords) {
                        $row && $row.find(".e-treegridexpand").removeClass('e-treegridexpand').addClass('e-treegridcollapse');
                        $row && $row.removeClass('e-treegridrowexpand').addClass('e-treegridrowcollapse');
                    }
                    if (model.enableAltRow && proxy._isInExpandCollapseAll === false && proxy._collapsedRecordCount != 0 && !model.allowPaging)
                        ej.TreeGrid.updateAltRow(proxy, record, index, proxy._collapsedRecordCount);
                }

            var collapsedRecordCount= 0;
            if (proxy._isFromGantt) {
                proxy._$treegridHelper.ejTreeGrid("updateExpandStatus", record, args.expanded);
                proxy._$treegridHelper.ejTreeGrid("updateCollapsedRecordCount");
                collapsedRecordCount =  proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
            } else {
                proxy.updateExpandStatus(record, args.expanded);
                proxy.updateCollapsedRecordCount();
                collapsedRecordCount = proxy.getCollapsedRecordCount();
            }

            height = (proxy.model.updatedRecords.length - collapsedRecordCount) * model.rowHeight;

            if (model.allowPaging && (args.type == "ejTreeGridcollapsing" || args.type =="ejTreeGridexpanding")) {
                if (!ej.isNullOrUndefined(proxy.getPager())) {                    
                    proxy.gotoPage();
                }
                if (model.enableAltRow && proxy._isInExpandCollapseAll === false)
                    ej.TreeGrid.updateAltRow(proxy, record, index, 1);               
            }
            
            if (proxy._isFromGantt)
            {
                if (proxy._isInExpandCollapseAll === false) {
                    proxy._totalCollapseRecordCount = collapsedRecordCount;
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._$treegridHelper.ejTreeGrid("updateHeight");
                    proxy._$ganttchartHelper.ejGanttChart("updateHeight", height);
                    proxy._$ganttchartHelper.ejGanttChart("setCollapsedRecordCount", collapsedRecordCount);
                    proxy._$ganttchartHelper.ejGanttChart("refreshGridLinesTable", proxy.model.updatedRecords.length - collapsedRecordCount);
                }
                
            } else {
                if (proxy._isInExpandCollapseAll === false) {
                    proxy.updateHeight();
                }
            }
        }

        
        if (proxy._isFromGantt && proxy.model.predecessorMapping && proxy._isInExpandCollapseAll === false) {
            proxy._isValidationEnabled = false;
            proxy._connectorlineIds = [];
            proxy._connectorLinesCollection = [];
            proxy._createConnectorLinesCollection();
            if (element.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", element.criticalPathCollection, element.detailPredecessorCollection, true, element.collectionTaskId);
            }
        }

        if (proxy._isFromGantt) {
            var treeGrid = proxy._$treegridHelper.ejTreeGrid("instance");
            var chart = proxy._$ganttchart.ejGanttChart("instance");
            var top = treeGrid._$gridContent.ejScroller("option", "scrollTop");
            chart._$bodyContainer.ejScroller("option", "scrollTop", top);
        }
       
        var argstemp = {};
        argstemp.recordIndex = args.recordIndex;
        argstemp.data = args.data;
        argstemp.requestType = args.requestType;
        argstemp.expanded = args.expanded;
        if (!ej.isNullOrUndefined(argstemp.data.item[model.expandStateMapping])) {
            argstemp.data[model.expandStateMapping] = args.expanded;
            argstemp.data.item[model.expandStateMapping] = args.expanded;
        }
        if (args.expanded) {
            proxy._trigger("expanded", argstemp);
        } else {
            proxy._trigger("collapsed", argstemp);
        }

        var selectItem = proxy.selectedItem();
        if (!proxy._isFromGantt && selectItem && (model.selectedItems.length == 1 || proxy._checkboxSelection)) {
            var expanded = proxy.getExpandStatus(selectItem);
            if (!expanded && !args.expanded) {
                proxy.selectRows(-1);
                proxy.selectedRowIndex(-1);
                selectItem.isSelected = false;
                model.selectedItem = null;
                selectItem = null;
            }
            if (model.allowPaging)
                updatedRecords = proxy._updatedPageData;
            else
                updatedRecords = proxy.model.updatedRecords;
            if (model.enableVirtualization && selectItem && updatedRecords.indexOf(selectItem) !== proxy.selectedRowIndex())
                proxy.selectRows(updatedRecords.indexOf(selectItem));
            proxy._cancelSaveTools();
        }
    };

    //EXPAND THE RECORD
    ej.TreeGrid.expandRecord = function (controlObject, Record, expanded, args) {
  
        var proxy = controlObject,
            rowClassName = ".gridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            detailsRowClassName = ".detailsrowgridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            $rows = $(proxy.element).find(rowClassName),
            count = 0,
            length = $rows.length,
            row,
            index,
            record,
            model = proxy.model,
            $detailRows = $(proxy.element).find(detailsRowClassName),
            $expandedRows = $(proxy.element).find(rowClassName),
            index,
            $gridRows = proxy.getRows(),
            $row = $($gridRows[index]);

            index = model.currentViewData.indexOf(Record);

        if (Record.hasChildRecords && Record.childRecords.length > 0) {
            $row.find(".e-treegridcollapse").removeClass('e-treegridcollapse').addClass('e-treegridexpand');
            $row.removeClass('e-treegridrowcollapse').addClass('e-treegridrowexpand');
        }
        proxy._expandedRecordsCount += (proxy._isFromGantt || proxy._frozenColumnsLength > 0) ? $expandedRows.length / 2 : $expandedRows.length;
        $expandedRows.css({ 'display': 'table-row' });
        $detailRows.filter("tr.e-detailsrowexpanded").css('display', 'table-row');
        if (proxy._isFromGantt || proxy._frozenColumnsLength > 0) {
            length = length / 2;
        }

        for (count; count < length; count++) {
            row = $rows[count];
            index = -1;
            if (proxy._frozenColumnsLength > 0)
                index = $(proxy.getRows()[0]).index(row);
            else
                index = proxy.getRows().index(row);

            if (index !== -1) {
                record = proxy._isFromGantt ? proxy.model.updatedRecords[index] : proxy.model.updatedRecords[index];
                record.isExpanded = true;
                if (record.expanded)
                    ej.TreeGrid.expandRecord(proxy,record, expanded);
            }
        }
    },
    
    //COLLAPSE THE RECORD
    ej.TreeGrid.collapseRecord = function (controlObject, Record, expanded) {

        var proxy = controlObject,
            model = proxy.model,
            rowClassName = ".gridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            detailsRowClassName = ".detailsrowgridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            $rows = $(proxy.element).find(rowClassName),
            count = 0,
            length = $rows.length,
            row,
            index,
            record,
            $detailRows = $(proxy.element).find(detailsRowClassName),
            $collapsedRows = $(proxy.element).find(rowClassName),
        $gridRows = proxy.getRows();

        proxy._collapsedRecordCount += (proxy._isFromGantt || proxy._frozenColumnsLength > 0) ? $collapsedRows.length / 2 : $collapsedRows.length;
        $collapsedRows.css({ 'display': 'none' });
        $detailRows.css({ 'display': 'none' });

        if (proxy._isFromGantt || proxy._frozenColumnsLength > 0) {
            length = length / 2;
        }

        for (count; count < length; count++) {

            row = $rows[count];
            index = -1;
            if (proxy._frozenColumnsLength > 0)
                index = $(proxy.getRows()[0]).index(row);
            else
                index = proxy.getRows().index(row);


            if (index !== -1) {
                record = proxy.getUpdatedRecords()[index];

                if (record.expanded)
                    ej.TreeGrid.collapseRecord(proxy,record, expanded);
            }
        }
    },

    //UPDATE THE ALT ROW FUNCTION
    ej.TreeGrid.updateAltRow = function (controlObject, Record, recordIndex, offset) {

        var proxy = controlObject,
            count = 0,
            model = proxy.model,
            currentViewData = model.currentViewData,
            length = currentViewData.length,
            isAltRow = Record.isAltRow,
            record,
            $gridRows,
            $gridAllRows = proxy.getRows();

        if (proxy._frozenColumnsLength)
            $gridRows = proxy.getRows()[0];
        else
            $gridRows = proxy.getRows();

        /* for rowTemplate no need set alt row class*/
        if (model.rowTemplateID || model.altRowTemplateID)
            return;

        for (count = recordIndex + offset; count < length; count++) {

            if ($($gridRows[count]).hasClass("e-summaryrow"))
                continue;

            if ($($gridRows[count]).css('display') === "none")
                continue;

            record = currentViewData[count];
            if(count!=0)
            record.isAltRow = !isAltRow;
            isAltRow = record.isAltRow;
            var currentRow = {};
            if (proxy._frozenColumnsLength) {
                currentRow = $($gridAllRows[0][count]).add($gridAllRows[1][count]);
            }
            else
                currentRow = $($gridAllRows[count])
            if (isAltRow) {
                $(currentRow).addClass('e-alt-row');
            }
            else {
                $(currentRow).removeClass('e-alt-row');
            }
        }
    };

    //RERENDERED THE EDITED RECORD
    ej.TreeGrid.refreshRow = function (controlObject, index) {
        var proxy = controlObject,
            model = proxy.model,
            data = proxy.model.currentViewData[index], eventArgs = {},
            currentRefreshingRow, currentFrozenRow;
        if (data) {
            if (proxy._frozenColumnsLength > 0) {
                currentFrozenRow = $(proxy.getRows()[0][index]);
                currentRefreshingRow = $(proxy.getRows()[1][index]);
                if (model.showDetailsRow && model.detailsTemplate && data.isDetailsExpanded) {
                    var detailsRow = currentFrozenRow.next("tr");
                    if (detailsRow.hasClass("e-detailsrow")) {
                        detailsRow.remove();
                        currentRefreshingRow.next("tr").remove();
                    }
                }
                currentFrozenRow.replaceWith($($.render[proxy._id + "_JSONFrozenTemplate"](data)));
                currentRefreshingRow.replaceWith($($.render[proxy._id + "_Template"](data)));
            } else {
                currentRefreshingRow = $(proxy.getRows()[index]);
                if (model.showDetailsRow && model.detailsTemplate && data.isDetailsExpanded) {
                    var detailsRow = currentRefreshingRow.next("tr");
                    if (detailsRow.hasClass("e-detailsrow"))
                        detailsRow.remove();
            }
            if (!model.allowSelection)
                data.isSelected = false;
            currentRefreshingRow.replaceWith($($.render[proxy._id + "_Template"](data)));
            }
            proxy.setGridRows($(proxy.getContentTable().get(0).rows));

            proxy._gridRows = proxy.getContentTable().get(0).rows;
            if (proxy._frozenColumnsLength > 0)
                proxy._gridRows = [proxy._gridRows, proxy.getContentTable().get(1).rows];

            var rowElement = ej.TreeGrid.getRowByIndex(proxy, proxy.getUpdatedRecords().indexOf(model.currentViewData[index]));
            proxy._trigger("refresh");
            proxy._rowEventTrigger(rowElement, data);
        }
    };

    //Return corressponding treegrid rows jquery object
    ej.TreeGrid.getRowByIndex = function (controlObject, from, to) {

        try {
            var proxy;
            if (controlObject.pluginName == "ejTreeGrid")
                proxy = controlObject;
            else
                proxy = controlObject._$treegridHelper.data("ejTreeGrid");

            var $gridRows = proxy.getRows(),
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
               // gridRows=proxy._gridRows,
                $row = $();

            if (proxy.model.enableVirtualization) {
                var recordstart = updatedRecords[from];
                from = proxy.model.currentViewData.indexOf(recordstart);
            }

            if (ej.isNullOrUndefined(to)) {
                if (proxy._frozenColumnsLength > 0) {
                    if ($gridRows[0][from]) {
                        $row.push($gridRows[0][from]);
                        $row.push($gridRows[1][from]);
                    }
                    return $row;
                }
                return $($gridRows[from]);
            } else {
                if (proxy.model.enableVirtualization) {
                    var recordend = updatedRecords[to];
                    to = proxy.model.currentViewData.indexOf(recordend);
                }
                if (proxy._frozenColumnsLength > 0) {
                    $row.push($($gridRows[0]).slice(from, to));
                    $row.push($($gridRows[1]).slice(from, to));
                    return $row;
                }
                return $($gridRows.slice(from, to));
            }
        } catch (e) {
            return $();
        }
    }

})(jQuery, Syncfusion);;;;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    ej.widget("ejRibbon", "ej.Ribbon", {
        element: null,
        validTags: ["div"],
        model: null,
        _rootCSS: "e-ribbon",
        _requiresID: true,
        defaults: {

            width: null,

            cssClass: "",


            buttonDefaults: {

                width: null,
                height: null,

                enableRTL: false,

                showRoundedCorner: false,

                enabled: true,

                cssClass: null
            },

            expandPinSettings: {

                toolTip: null,

                customToolTip: {

                    title: null,

                    content: null,

                    prefixIcon: null

                }

            },

            collapsePinSettings: {

                toolTip: null,

                customToolTip: {

                    title: null,

                    content: null,

                    prefixIcon: null

                }

            },

            applicationTab: {

                type: "menu",

                backstageSettings: {

                    text: null,

                    height: null,

                    width: null,

                    headerWidth: null,

                    pages: [{

                        id: null,

                        text: null,

                        itemType: "tab",

                        contentID: null,

                        enableSeparator: false
                    }]

                },

                menuItemID: null,

                menuSettings: {}
            },

            tabs: [{

                id: null,

                text: null,

                groups: [{
					
					id: null,

                    text: null,

                    type: null,

                    contentID: null,

                    customContent: null,

                    alignType: "rows",

                    enableGroupExpander: false,

                    groupExpanderSettings: {

                        toolTip: null,

                        customToolTip: {

                            title: null,

                            content: null,

                            prefixIcon: null

                        }
                    },

                    content: [{

                        groups: [{

                            id: null,

                            text: null,

                            toolTip: null,

                            quickAccessMode: "none",

                            isMobileOnly:"false",

                            customToolTip: {

                                title: null,

                                content: null,

                                prefixIcon: null,
                            },

                            columns: null,

                            itemHeight: null,

                            itemWidth: null,

                            expandedColumns: null,

                            type: "button",

                            galleryItems: [{

                                text: null,

                                toolTip: null,

                                customToolTip: {},

                                buttonSettings: {}
                            }],

                            customGalleryItems: [{

                                text: null,

                                toolTip: null,

                                customToolTip: {},

                                customItemType: "button",

                                buttonSettings: {},

                                menuId: "",

                                menuSettings: {}
                            }],

                            contentID: null,

                            enableSeparator: false,

                            isBig: false,

                            cssClass: null,

                            buttonSettings: {},

                            splitButtonSettings: {},

                            toggleButtonSettings: {},

                            dropdownSettings: {},
                        }],

                        defaults: {},
                    }],
                }]
            }],

            contextualTabs: [{

                backgroundColor: null,

                borderColor: null,

                tabs: []
            }],

            tabSelect: null,

            tabClick: null,

            tabAdd: null,

            tabRemove: null,

            load:null,

            beforeTabRemove: null,

            tabCreate: null,

            create: null,

            groupClick: null,

            beforeTabClick:null,

            galleryItemClick: null,

            backstageItemClick: null,

            collapse: null,

            expand: null,

            pinState: null,

            toggleButtonClick: null,

            groupExpand: null,

            qatMenuItemClick: null,

            selectedItemIndex: 1,

            enabledItemIndex: [],

            disabledItemIndex: [0],

            // allowResizing is a deprecated API, we can achieve this requirement by isResponsive property
            allowResizing: false,

            isResponsive: false,

            showQAT: false,

            showBelowQAT: false,
			
			enableOnDemand :false,
			
			collapsible :false,

            locale: "en-US",

            enableRTL: false,

            destory: null,

            //This is only for internal purpose of spreadsheet.
           _destroyed: null,
            
        },
        dataTypes: {
            tabs: "array",
            contextualTabs: "array",
            disabledItemIndex: "data",
            enabledItemIndex: "data",
            selectedItemIndex: "number",
            applicationTab: {
                backstageSettings: {
                    pages: "array"
                }
            }
        },

        _destroy: function () {
            var galleryMenu, ddlPopup, splitPopup, appTabMenu;
            appTabMenu = this._applicationTab.find('.e-menu');
            if (appTabMenu.length > 0)
                appTabMenu.data('ejMenu').destroy();
            this.element.find(".e-rbncustomelement,.e-backstagetabarea,.e-gallerymenu").hide();
            galleryMenu = this.element.find(".e-gallerymenu");
            var gallen = galleryMenu.length;
            for (var i = 0; i < gallen; i++) {
                galleryMenu.eq(i).data('ejMenu').destroy();
                galleryMenu.eq(i).remove();
            }
            this.element.find(".e-rbncustomelement,.e-backstagetabarea,.e-gallerymenu").appendTo(this.element.parent());
            ddlPopup = $('.e-rbn-ddl.e-ddl').find('.e-dropdownlist');
            var ddlPopuplen=ddlPopup.length;
            for (var i = 0; i < ddlPopuplen; i++) {
                ddlPopup.eq(i).data('ejDropDownList').destroy();
                ddlPopup.siblings('ul').appendTo(this.element.parent());
            }
            splitPopup = $('.e-rbn-splitbtn.e-splitbutton');
            var splitPopuplen = splitPopup.length;
            for (var i = 0; i < splitPopuplen; i++) {
                splitPopup.eq(i).data('ejSplitButton').destroy();
                splitPopup.siblings('ul').appendTo(this.element.parent());
            }
            this.element.children().remove();
			if(this.element.hasClass('e-ribwithout-apptab'))
			 this.element.removeClass('e-ribwithout-apptab')
		    if(this.model.enableOnDemand)
		        this.element.ejWaitingPopup("destroy");
		    this._trigger("_destroyed");
        },
        _tags: [{
            tag: "applicationTab.backstageSettings.pages", attr: ["id", "text", "itemType", "contentID", "enableSeparator"]
        },
		{
		    tag: "tabs", attr: ["id", "text", [{
		        tag: "groups", attr: ["id", "text", "alignType", "type", "contentID", "enableGroupExpander", [{
		            tag: "content", attr: ["defaults.type", "defaults.width", "defaults.height", "defaults.isBig", [{
		                tag: "groups", attr: ["id", "columns", "itemHeight", "itemWidth", "expandedColumns", "contentID", "text", "type", "toolTip","isMobileOnly", "quickAccessMode", "width",
                        "enableSeparator",
					"buttonSettings.contentType", "buttonSettings.type", "buttonSettings.imagePosition", "buttonSettings.prefixIcon", "buttonSettings.click", "buttonSettings.width", "buttonSettings.cssClass", "buttonSettings.enabled", "buttonSettings.showRoundedCorner", "buttonSettings.enableRTL", "buttonSettings.repeatButton", "buttonSettings.size", "buttonSettings.height", "buttonSettings.text", "buttonSettings.timeInterval", "buttonSettings.create", "buttonSettings.click", "buttonSettings.destroy", "splitButtonSettings.contentType", "splitButtonSettings.prefixIcon", "splitButtonSettings.targetID",
                        "splitButtonSettings.buttonMode", "splitButtonSettings.arrowPosition", "splitButtonSettings.type", "splitButtonSettings.click",
						"splitButtonSettings.enabled", "splitButtonSettings.showRoundedCorner", "splitButtonSettings.enableRTL", "splitButtonSettings.size", "splitButtonSettings.height", "splitButtonSettings.imagePosition", "splitButtonSettings.width", "splitButtonSettings.text", "splitButtonSettings.suffixIcon", "splitButtonSettings.create", "splitButtonSettings.itemMouseOver", "splitButtonSettings.itemSelected", "splitButtonSettings.beforeOpen", "splitButtonSettings.destroy", "splitButtonSettings.cssClass",
						"dropdownSettings.dataSource", "dropdownSettings.text", "dropdownSettings.value", "dropdownSettings.select", "dropdownSettings.width", "dropdownSettings.showRoundedCorner", "dropdownSettings.showPopupOnLoad", "dropdownSettings.allowMultiSelection", "dropdownSettings.enableRTL", "dropdownSettings.enabled", "dropdownSettings.caseSensitiveSearch", "dropdownSettings.showCheckbox", "dropdownSettings.checkAll", "dropdownSettings.uncheckAll", "dropdownSettings.enablePersistence", "dropdownSettings.enableIncrementalSearch", "dropdownSettings.readOnly", "dropdownSettings.allowGrouping", "dropdownSettings.fields",
						"dropdownSettings.selectedItems", "dropdownSettings.itemsCount", "dropdownSettings.height", "dropdownSettings.cssClass", "dropdownSettings.itemValue", "dropdownSettings.popupHeight", "dropdownSettings.targetID", "dropdownSettings.waterMarkText", "dropdownSettings.template", "dropdownSettings.cascadeTo", "dropdownSettings.query", "dropdownSettings.create", "dropdownSettings.popupHide", "dropdownSettings.popupShown", "dropdownSettings.beforePopupShown", "dropdownSettings.change", "dropdownSettings.checkChange", "dropdownSettings.enableAnimation", "dropdownSettings.destroy",
						"toggleButtonSettings.contentType", "toggleButtonSettings.defaultText", "toggleButtonSettings.activeText", "toggleButtonSettings.type", "toggleButtonSettings.defaultPrefixIcon", "toggleButtonSettings.activePrefixIcon", "toggleButtonSettings.click", "toggleButtonSettings.enabled", "toggleButtonSettings.showRoundedCorner", "toggleButtonSettings.enableRTL", "toggleButtonSettings.enablePersistence", "toggleButtonSettings.toggleState",
						"toggleButtonSettings.preventToggle", "toggleButtonSettings.size", "toggleButtonSettings.imagePosition", "toggleButtonSettings.height", "toggleButtonSettings.width", "toggleButtonSettings.cssClass",
						"toggleButtonSettings.defaultText", "toggleButtonSettings.activeText", "toggleButtonSettings.defaultPrefixIcon",
						"toggleButtonSettings.defaultSuffixIcon", "toggleButtonSettings.activePrefixIcon", "toggleButtonSettings.create", "toggleButtonSettings.change", "toggleButtonSettings.destroy",
						"customToolTip.title", "customToolTip.content", "customToolTip.prefixIcon", [{
						    tag: "galleryItems", attr: ["text", "toolTip", "customToolTip.title", "customToolTip.content", "customToolTip.prefixIcon", "buttonSettings.contentType", "buttonSettings.type", "buttonSettings.imagePosition", "buttonSettings.prefixIcon", "buttonSettings.click", "buttonSettings.width", "buttonSettings.cssClass", "buttonSettings.enabled", "buttonSettings.showRoundedCorner", "buttonSettings.enableRTL", "buttonSettings.repeatButton", "buttonSettings.size", "buttonSettings.height", "buttonSettings.text", "buttonSettings.timeInterval", "buttonSettings.create", "buttonSettings.click", "buttonSettings.destroy"]
						}, {
						    tag: "customGalleryItems", attr: ["text", "toolTip", "customToolTip.title", "customToolTip.content", "customToolTip.prefixIcon", "menuId", "customItemType",
    "buttonSettings.contentType", "buttonSettings.type", "buttonSettings.imagePosition", "buttonSettings.prefixIcon", "buttonSettings.click", "buttonSettings.width", "buttonSettings.cssClass", "buttonSettings.enabled", "buttonSettings.showRoundedCorner", "buttonSettings.enableRTL", "buttonSettings.repeatButton", "buttonSettings.size", "buttonSettings.height", "buttonSettings.text", "buttonSettings.timeInterval", "buttonSettings.create", "buttonSettings.click", "buttonSettings.destroy",
                            "menuSettings.openOnClick", "menuSettings.enableCenterAlign", "menuSettings.showRooltLevelArrows", "menuSettings.showSubLevelArrows", "menuSettings.enableSeparator", "menuSettings.enabled", "menuSettings.orientation", "menuSettings.menuType", "menuSettings.animationType", "menuSettings.subMenuDirection", "menuSettings.fields", "menuSettings.cssClass", "menuSettings.contextMenuTarget", "menuSettings.excludeTarget", "menuSettings.height", "menuSettings.width", "menuSettings.titleText", "menuSettings.create", "menuSettings.beforeOpen", "menuSettings.open", "menuSettings.close", "menuSettings.mouseover", "menuSettings.mouseout", "menuSettings.keydown", "menuSettings.destroy"
						    ]
						}]]
		            }]]
		        }]]
		    }]]
		}, {
		    tag: "contextualTabs", attr: ["backgroundColor", "borderColor", [{
		        tag: "tabs", attr: ["id", "text", [{
		            tag: "groups", attr: ["id", "text", "alignType", "type", "contentID", [{
		                tag: "content", attr: ["defaults.type", "defaults.width", "defaults.height", "defaults.isBig", [{
		                    tag: "groups", attr: ["id", "columns", "itemHeight", "itemWidth", "expandedColumns", "contentID", "text", "type", "toolTip", "width",
                            "enableSeparator",
                            "buttonSettings.contentType", "buttonSettings.type", "buttonSettings.imagePosition", "buttonSettings.prefixIcon", "buttonSettings.click", "buttonSettings.width", "buttonSettings.cssClass", "buttonSettings.enabled", "buttonSettings.showRoundedCorner", "buttonSettings.enableRTL", "buttonSettings.repeatButton", "buttonSettings.size", "buttonSettings.height", "buttonSettings.text", "buttonSettings.timeInterval", "buttonSettings.create", "buttonSettings.click", "buttonSettings.destroy", "splitButtonSettings.contentType", "splitButtonSettings.prefixIcon", "splitButtonSettings.targetID",
                            "splitButtonSettings.buttonMode", "splitButtonSettings.arrowPosition", "splitButtonSettings.type", "splitButtonSettings.click",
                            "splitButtonSettings.enabled", "splitButtonSettings.showRoundedCorner", "splitButtonSettings.enableRTL", "splitButtonSettings.size", "splitButtonSettings.height", "splitButtonSettings.imagePosition", "splitButtonSettings.width", "splitButtonSettings.text", "splitButtonSettings.suffixIcon", "splitButtonSettings.create", "splitButtonSettings.itemMouseOver", "splitButtonSettings.itemSelected", "splitButtonSettings.beforeOpen", "splitButtonSettings.destroy", "splitButtonSettings.cssClass",
                            "dropdownSettings.dataSource", "dropdownSettings.text", "dropdownSettings.value", "dropdownSettings.select", "dropdownSettings.width", "dropdownSettings.showRoundedCorner", "dropdownSettings.showPopupOnLoad", "dropdownSettings.allowMultiSelection", "dropdownSettings.enableRTL", "dropdownSettings.enabled", "dropdownSettings.caseSensitiveSearch", "dropdownSettings.showCheckbox", "dropdownSettings.checkAll", "dropdownSettings.uncheckAll", "dropdownSettings.enablePersistence", "dropdownSettings.enableIncrementalSearch", "dropdownSettings.readOnly", "dropdownSettings.allowGrouping", "dropdownSettings.fields",
                            "dropdownSettings.selectedItems", "dropdownSettings.itemsCount", "dropdownSettings.height", "dropdownSettings.cssClass", "dropdownSettings.itemValue", "dropdownSettings.popupHeight", "dropdownSettings.targetID", "dropdownSettings.waterMarkText", "dropdownSettings.template", "dropdownSettings.cascadeTo", "dropdownSettings.query", "dropdownSettings.create", "dropdownSettings.popupHide", "dropdownSettings.popupShown", "dropdownSettings.beforePopupShown", "dropdownSettings.change", "dropdownSettings.checkChange", "dropdownSettings.enableAnimation", "dropdownSettings.destroy",
                            "toggleButtonSettings.contentType", "toggleButtonSettings.defaultText", "toggleButtonSettings.activeText", "toggleButtonSettings.type", "toggleButtonSettings.defaultPrefixIcon", "toggleButtonSettings.activePrefixIcon", "toggleButtonSettings.click", "toggleButtonSettings.enabled", "toggleButtonSettings.showRoundedCorner", "toggleButtonSettings.enableRTL", "toggleButtonSettings.enablePersistence", "toggleButtonSettings.toggleState",
                            "toggleButtonSettings.preventToggle", "toggleButtonSettings.size", "toggleButtonSettings.imagePosition", "toggleButtonSettings.height", "toggleButtonSettings.width", "toggleButtonSettings.cssClass",
                            "toggleButtonSettings.defaultText", "toggleButtonSettings.activeText", "toggleButtonSettings.defaultPrefixIcon",
                            "toggleButtonSettings.defaultSuffixIcon", "toggleButtonSettings.activePrefixIcon", "toggleButtonSettings.create", "toggleButtonSettings.change", "toggleButtonSettings.destroy",
                            "customToolTip.title", "customToolTip.content", "customToolTip.prefixIcon", [{
                                tag: "galleryItems", attr: ["text", "toolTip", "customToolTip.title", "customToolTip.content", "customToolTip.prefixIcon", "buttonSettings.contentType", "buttonSettings.type", "buttonSettings.imagePosition", "buttonSettings.prefixIcon", "buttonSettings.click", "buttonSettings.width", "buttonSettings.cssClass", "buttonSettings.enabled", "buttonSettings.showRoundedCorner", "buttonSettings.enableRTL", "buttonSettings.repeatButton", "buttonSettings.size", "buttonSettings.height", "buttonSettings.text", "buttonSettings.timeInterval", "buttonSettings.create", "buttonSettings.click", "buttonSettings.destroy"]
                            }, {
                                tag: "customGalleryItems", attr: ["text", "toolTip", "customToolTip.title", "customToolTip.content", "customToolTip.prefixIcon", "menuId", "customItemType",
        "buttonSettings.contentType", "buttonSettings.type", "buttonSettings.imagePosition", "buttonSettings.prefixIcon", "buttonSettings.click", "buttonSettings.width", "buttonSettings.cssClass", "buttonSettings.enabled", "buttonSettings.showRoundedCorner", "buttonSettings.enableRTL", "buttonSettings.repeatButton", "buttonSettings.size", "buttonSettings.height", "buttonSettings.text", "buttonSettings.timeInterval", "buttonSettings.create", "buttonSettings.click", "buttonSettings.destroy",
                                "menuSettings.openOnClick", "menuSettings.enableCenterAlign", "menuSettings.showRooltLevelArrows", "menuSettings.showSubLevelArrows", "menuSettings.enableSeparator", "menuSettings.enabled", "menuSettings.orientation", "menuSettings.menuType", "menuSettings.animationType", "menuSettings.subMenuDirection", "menuSettings.fields", "menuSettings.cssClass", "menuSettings.contextMenuTarget", "menuSettings.excludeTarget", "menuSettings.height", "menuSettings.width", "menuSettings.titleText", "menuSettings.create", "menuSettings.beforeOpen", "menuSettings.open", "menuSettings.close", "menuSettings.mouseover", "menuSettings.mouseout", "menuSettings.keydown", "menuSettings.destroy"
                                ]
                            }]]
		                }]]
		            }]]
		        }]]
		    }]
		    ]
		}],
        _ribbonRerender: function () {
            var model = this.model, element = this.element, i, contentDiv;
            contentDiv = this.element.find('.e-content.e-content-item');
            if (this.element.find('.e-collapse-content').length > 0) {
                var contentlen=contentDiv.length;
                for (i = 0; i < contentlen; i++) {
                    if (contentDiv.eq(i).hasClass('e-active-content') && contentDiv.eq(i).hasClass('e-collapse-content')) {
                        this._selectedItemIndex = i;
                        this._isCollapsed = true;
                        break;
                    }
                }
            }
            if (this._isCollapsed) {
                model.selectedItemIndex = this._selectedItemIndex;
                model._isCollapsed = true;
            }
            else
                model._isCollapsed = false;
            if (this.element.data("ejTab")) {
                this.element.data("ejTab")._destroy();
                this.element = element, this.model = model;
            }
            this.element.ejRibbon("destroy").ejRibbon(model);
            this.model = model;
            this.element = element;
            if (this.model._isCollapsed)
                this.collapse();
        },
        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
				    case "applicationTab":
					    if(!ej.isNullOrUndefined(options.applicationTab.backstageSettings) && !ej.isNullOrUndefined(options.applicationTab.backstageSettings.pages))
					     this.model.applicationTab.backstageSettings.pages=options.applicationTab.backstageSettings.pages;
					    this.model.enableOnDemand ? this._createAppTabOnDemand() : this._createApplicationTab();
						break;
                    case "selectedItemIndex":
                        if (this.model.selectedItemIndex > 0 && this._tabObj.model.disabledItemIndex.indexOf(this.model.selectedItemIndex) === -1 && (this._ribbonTabs.eq(this.model.selectedItemIndex).is(':visible') || (this._responsiveTabText.eq(!ej.isNullOrUndefined(ej.isNullOrUndefined(this.model.applicationTab)) ? this.model.selectedItemIndex - 1 : this.model.selectedItemIndex).is(":visible"))))
                            this._tabObj.option({ selectedItemIndex: this.model.selectedItemIndex });
                        break;
                    case "disabledItemIndex":
                        var conParent, disableLen = this.model.disabledItemIndex.length;
                        var curDisabled = this.model.disabledItemIndex, aTag = this.element.find('.e-link'), activeTab;
                        this.model.disabledItemIndex.push(0);
                        this._tabObj.option({ disabledItemIndex: this.model.disabledItemIndex });
                        for (var k = 0; k < disableLen; k++) {
                            conParent = this._ribbonTabs.eq(curDisabled[k]).parent().parent();
                            if (conParent.hasClass('e-contextli') || conParent.hasClass('e-contextliset'))
                                conParent.addClass("e-disable");
                            if (this._tabObj.model.selectedItemIndex != 0 && this._tabObj.model.selectedItemIndex === curDisabled[k]) {
                                activeTab = aTag.eq(curDisabled[k]).attr("href");
                                $(activeTab).append(this.element.find("#" + this._id + "_disabled"));
                                $(activeTab).css("position", "relative");
                                this.element.find("#" + this._id + "_disabled").show();
                            }
                        }
                        break;
                    case "enabledItemIndex":
                        var conParent, enableLen = this.model.enabledItemIndex.length, conTabs = this._tabUl.find(".e-contextualtabset");
                        this._ribbonTabs = this._ribbonTabs.not("span,.e-ribresmenu,.e-responsiveqat");
                        for (var k = 0; k < enableLen; k++) {
                            if (this.model.enabledItemIndex[k] === 0 || !(this._ribbonTabs.eq(this.model.enabledItemIndex[k]).is(':visible'))) {
                                this.model.enabledItemIndex.splice(k, 1);
                                --enableLen;
                                --k;
                            }
                        }

                        this._conTabsRemove();
                        this._tabObj.option({ enabledItemIndex: this.model.enabledItemIndex });
                        this._contextualTabs();
                        var enableItemLen = this.model.enabledItemIndex.length;
                        for (var i = 0; i < enableItemLen; i++) {
                            this._tabText.eq(this.model.enabledItemIndex[i]).parent().removeClass("e-disable");
                            this._tabText.eq(this.model.enabledItemIndex[i]).parent().css("position", "");
                            conParent = this._ribbonTabs.eq(this.model.enabledItemIndex[i]).parent().parent();
                            if (conParent.hasClass('e-contextli') || conParent.hasClass('e-contextliset'))
                                conParent.removeClass("e-disable");
                            if (this.model.enabledItemIndex[i] == this._tabObj.model.selectedItemIndex)
                                this.element.find("#" + this._id + "_disabled").hide();
                        }
                        var conTabsLen=conTabs.length;
                        for (var j = 0; j < conTabsLen; j++) {
                            if ($(conTabs[j]).hasClass('e-disable'))
                                $(conTabs[j]).parents(".e-contextliset").addClass('e-disable');
                        }
                        break;
                    case "allowResizing":
                        this._ribbonWindowResize();
                        break;
                    case "isResponsive":
                        this._ribbonWindowResize();
                        break;
                    case "width":
                        this.element.width(options[key]);
                        this._ribbonWindowResize();
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[key];
                        var model = this.model, element = this.element;
                        if (this.element.data("ejTab")) {
                            this.element.data("ejTab")._destroy();
                            this.element = element, this.model = model;
                        }
                        this.element.ejRibbon("destroy");
                        $("#" + this._id).ejRibbon(model);
                        break;
                    case "locale":
                        this.model.locale = options[key];
                        this._ribbonRerender();
                        break;
                    case "cssClass": this._changeSkin(options[key]); break;
                }
            }
        },

        _changeSkin: function (skin) {
            this._tabObj.option('cssClass', skin);
        },

        _setTabContentHeight: function () {
            this.element.find(".e-ribGroupContent").height("auto");
            var maxGrpHeight = 0, tabContent = this.element.find('.e-content.e-content-item'), ctrlSeparatorCol, ctrlSeparatorLen, ribParent;
            ribParent = $("#" + this._id).parents();
            $(tabContent).addClass('e-content-show');
            if ($("#" + this._id).is(":hidden"))
                $("#" + this._id).addClass('e-ribbon-show');
            for (var i = 0; i < ribParent.length; i++) {
                if (ribParent.eq(i).is(':hidden'))
                    ribParent.eq(i).addClass('e-ribbon-show');
            }
            ctrlSeparatorCol = this.element.find('.e-separatordivrow'), ctrlSeparatorLen = ctrlSeparatorCol.length;
            for (var i = 0; i < ctrlSeparatorLen; i++)
                $(ctrlSeparatorCol).eq(i).height($(ctrlSeparatorCol).eq(i).prev().height());
            this.element.find('.e-ribGroupContent').each(function () {
                maxGrpHeight = Math.max(maxGrpHeight, $(this).height());
            });
            this.element.find(".e-ribGroupContent").height(maxGrpHeight);
            $(tabContent).removeClass('e-content-show');
            if ($("#" + this._id).hasClass('e-ribbon-show')) {
                this._ribbonResize();
                $(".e-ribbon-show").removeClass('e-ribbon-show');
            }
        },

        _init: function () {
            if (!ej.isNullOrUndefined(this.element)) {
                this._trigger("load");
                this._render();
                this._wireEvents();
            }
        },
        _render: function () {
		    if(this.model.enableOnDemand && $.isFunction($.fn.ejWaitingPopup)){
               this.element.ejWaitingPopup({ showOnInit: false });
               $("#" + this._id + "_WaitingPopup").addClass("e-ribbonwaitingpopup");
			}
		    if (this.model.disabledItemIndex.length == 0) 
		        this.model.disabledItemIndex.push(0);
            this._renderTab();
            if (this.model.showQAT) {
                var quickAccessBar = ej.buildTag("div.e-rbnquickaccessbar").click($.proxy(this._onQatClick, this));
                if (this.model.showBelowQAT) {
                    quickAccessBar.removeClass("e-rbnabove").addClass("e-rbnbelow");
                    this.element.append(quickAccessBar).addClass('e-rbnwithqatbelow');
                }
                else {
                    quickAccessBar.removeClass("e-rbnbelow").addClass("e-rbnabove");
                    this.element.prepend(quickAccessBar).addClass('e-rbnwithqatabove');
                }
                this.element.addClass('e-rbnwithqat');
            }
            this._initPrivateProperties();
            this.model.enableOnDemand ? (!this.model.collapsible ? (this._groupContent(), this.element.find(".e-header").addClass("e-rbnondemand"), this._createQAT()) : this._createQAT()) : (this._groupingControls(), this._createQAT());
            this._initial = true;
            this._customization();
            this._initialRender = true;
            if (this.model.collapsible)
                this.collapse();
            this._ribbonResponsive();
            this._responsiveTabText = this.element.find(".e-responsivetabheader li");
            if (this._phoneMode)
                this._ribbonWindowResize();
            this._tabObj.initialRender = false;
            this.element.append(ej.buildTag("div#" + this._id + "_disabled"));
            this.element.append(ej.buildTag("div#" + this._id + "_modelDiv"));
            var content = this.element.find(".e-content");
            this.element.find("#" + this._id + "_disabled").height(this.element.find(".e-active-content").height()).width(this.model.width);
            this.element.find("#" + this._id + "_disabled").css({ top: 0, left: 0, position: "absolute" }).addClass("e-disable");
            this.element.find("#" + this._id + "_disabled").hide();
            this.element.find("#" + this._id + "_modelDiv").height($(content).height()).width(this.model.width);
            this.element.find("#" + this._id + "_modelDiv").css({ top: 0, left: 0, position: "absolute" }).addClass("e-modelDiv");
            this.element.find("#" + this._id + "_modelDiv").hide();
            var resizeDiv = ej.buildTag("div#" + this._id + "_resize").addClass("e-resizediv").hide().click($.proxy(this._onResizeDivClick, this));
            this.element.append(resizeDiv);
            var toolTipDiv = ej.buildTag("div#" + this._id + "_tooltip").addClass("e-tooltipdiv").hide();
            var title = ej.buildTag("div#" + this._id + "_toolTip_title").addClass('e-tooltiptitle');
            var description = ej.buildTag("div#" + this._id + "_toolTip_Desc").addClass('e-tooltipdesc');
            toolTipDiv.append(title);
            toolTipDiv.append(description);
            this.element.append(toolTipDiv);
             if (this._applicationTab.hasClass('e-active') && !ej.isNullOrUndefined(this.model.tabs[0].id)) {
			 this._applicationTab.removeClass("e-active");
             this.element.find('.e-content.e-content-item').remove();
                this._tabUl.find('.e-expandcollapse').remove();
           }
            var emptyTabContent = this.element.find('.e-empty-content'), firstGroupDiv = this.element.find('.e-groupdiv').eq(0);
            if ($(emptyTabContent).length > 0 && $(firstGroupDiv).length > 0)
                $(emptyTabContent).height($(firstGroupDiv).parent().height());
            this.element.find(".e-rbncustomelement,.e-backstagetabarea,.e-gallerymenu").show();
        },
        _createQuickAccessBar: function () {
            if (this.model.showQAT) {
                var qatSplitBtnDiv = ej.buildTag("div.e-splitbtnqatdiv").attr('title', this.localizedLabels.CustomizeQuickAccess), qatSplitBtn = ej.buildTag("button#" + this._id + "_" + "qatsplitbtn").addClass("e-splitbtnqat e-rbn-button"), qatPopup;
                qatSplitBtnDiv.append(qatSplitBtn.ejButton({
                    size: "normal",
                    type: "button",
                    contentType: "imageonly",
                    height: 30,
                    width: 14,
                    prefixIcon: "e-icon e-ribbon e-qatexpand",
                    click: $.proxy(this._onQatExpandBtnClick, this)
                }));
                this._qAccessBar.append(qatSplitBtnDiv);
                qatPopup = ej.buildTag("ul.e-rbnqatmenu", "<div>" + this.localizedLabels.CustomizeQuickAccess + "</div>").click($.proxy(this._onQatMenuClick, this));
                var qatColtrolLen = this._qatControlsName.length;
                for (var i = 0; i < qatColtrolLen; i++) {
                    var qatPopupEle = ej.buildTag("li#" + this._qatControlsName[i].id + "_menuli" + ".e-qatmenuli e-removemenuli", "<p>" + this._qatControlsName[i].text + "</p>").appendTo(qatPopup).attr("title", this.localizedLabels.RemoveFromQuickAccessToolbar);
                    if (this._qatControlsName[i].qAccess == "menu")
                        qatPopupEle.addClass('e-addmenuli').removeClass('e-removemenuli').attr("title", this.localizedLabels.AddToQuickAccessToolbar);
                }
                var qatLi = "";
                if (this.model.showBelowQAT)
                    qatLi = "<li class='e-rbnshowabove e-qatmenuli'>" + this.localizedLabels.ShowAboveTheRibbon + "</li>";
                else
                    qatLi = "<li class='e-rbnshowbelow e-qatmenuli'>" + this.localizedLabels.ShowBelowTheRibbon + "</li>";
                qatPopup.append("<li class='e-qatmenuli e-qatseparator'></li><li class='e-qatmorecommands e-qatmenuli' title=" + this.localizedLabels.CustomizeQuickAccess + ">" + this.localizedLabels.MoreCommands + "</li>" + qatLi);
                this._qAccessBar.append(qatPopup.hide());
            }
        },
        _tooltip: function (e) {
            var control = this.element.find('.e-controlclicked');
            if (control.length <= 0 || $(control).find('.e-ribbonbtn').length > 0) {
                if (this.element.find("#" + e.data.ribbonId + "_resize").is(':visible') || this.element.find('.e-gallexpandcontent').is(':visible')) {
                    if ($(e.target).parents(".e-resizediv").length > 0 || $(e.target).parents('.e-gallexpandcontent').length > 0)
                        this._toolTipShow(e);
                }
                else
                    this._toolTipShow(e);
            }
        },
        _toolTipShow: function (e) {
            var toolTipDiv = this.element.find("#" + e.data.ribbonId + "_tooltip"), control, controlOffset, tipTop, resizeDiv, tipDesc, tipTitle, expandContent, title, cntOverflow, ribHeight, activeContent;
            if (toolTipDiv.find('.e-tooltiptitle').length <= 0) {
                title = ej.buildTag("div#" + e.data.ribbonId + "_toolTip_title").addClass('e-tooltiptitle');
                toolTipDiv.prepend(title);
            }
            toolTipDiv.removeClass("e-tooltipdivwithimg");
            tipTitle = toolTipDiv.find('.e-tooltiptitle');
            tipTitle.children().remove();
            if ($(e.target).is("li"))
                return;
            var tipValue;
            if ($(e.target).hasClass('e-rarrowup-2x') && !ej.isNullOrUndefined(this.model.expandPinSettings.toolTip))
                $($(e.target).parent()).attr("title", this.model.expandPinSettings.toolTip);
            if ($(e.target).hasClass('e-rarrowup-2x') && (!ej.isNullOrUndefined(this.model.expandPinSettings.customToolTip.title) || !ej.isNullOrUndefined(this.model.expandPinSettings.customToolTip.content)))
                tipValue = e.data.value.expandObj;
            if ($(e.target).hasClass('e-ribbonpinicon') && !ej.isNullOrUndefined(this.model.collapsePinSettings.toolTip))
                $($(e.target).parent()).attr("title", this.model.collapsePinSettings.toolTip);
            else if ($(e.target).hasClass('e-ribbonpinicon') && (!ej.isNullOrUndefined(this.model.collapsePinSettings.customToolTip.title) || !ej.isNullOrUndefined(this.model.collapsePinSettings.customToolTip.content)))
                tipValue = e.data.value.collapseObj;
            else if (!$(e.target).hasClass('e-rarrowup-2x') && !$(e.target).hasClass('e-ribbonpinicon'))
                tipValue = e.data.value;
            if (!ej.isNullOrUndefined(tipValue) && !ej.isNullOrUndefined(tipValue.customToolTip) && !ej.isNullOrUndefined(tipValue.customToolTip.title))
                tipTitle.append(tipValue.customToolTip.title);
            else
                tipTitle.remove();

            if (!ej.isNullOrUndefined(tipValue) && !ej.isNullOrUndefined(tipValue.customToolTip) && !ej.isNullOrUndefined(tipValue.customToolTip.content)) {
                if (tipTitle.children().length <= 0)
                    tipTitle.empty().append("<b>" + tipValue.customToolTip.title + "</b>");
                tipDesc = toolTipDiv.find('.e-tooltipdesc');
                tipDesc.children().remove();
                tipDesc.append(tipValue.customToolTip.content);
                if (tipDesc.children().length <= 0)
                    tipDesc.empty().append("<h6>" + tipValue.customToolTip.content + "</h6>");
                if (!ej.isNullOrUndefined(tipValue) && !ej.isNullOrUndefined(tipValue.customToolTip.prefixIcon)) {
                    tipDesc.prepend("<span class=e-tooltipimg></span>");
                    tipDesc.find('.e-tooltipimg').addClass(tipValue.customToolTip.prefixIcon);
                    tipDesc.children().not('.' + tipValue.customToolTip.prefixIcon).addClass('e-tooltipcntwithimg');
                    toolTipDiv.addClass("e-tooltipdivwithimg");
                }
                else
                    tipDesc.children().addClass('e-tooltipcontent');
            }
            if (ej.isNullOrUndefined(tipValue))
                return;
            controlOffset = this.element.find("#" + e.delegateTarget.id).offset();
            control = this.element.find("#" + e.delegateTarget.id);
            toolTipDiv.stop(true).delay(700).show(0).addClass("e-rbntooltipshadow");
            resizeDiv = this.element.find("#" + e.data.ribbonId + "_resize");
            expandContent = $(e.target).parents('.e-gallexpandcontent');
            this.element.css({ 'position': 'relative' });
            cntOverflow = (this.element.width() + this.element.offset().left) - (controlOffset.left + parseInt($(toolTipDiv).width(), 10));
            if (cntOverflow <= 0)
                controlOffset.left = controlOffset.left + cntOverflow - this.element.offset().left;
            else
                controlOffset.left = controlOffset.left - this.element.offset().left;
            activeContent = this.element.find('.e-active-content').eq(0);
            if (activeContent.is(":visible"))
                ribHeight = this._tabUl.height() + activeContent.height();
            else
                ribHeight = this._tabUl.height();
            if (resizeDiv.is(':visible') && !expandContent.is(':visible')) {
                toolTipDiv.offset({ left: controlOffset.left });
                if (control.parents('.e-galleryrow').length > 0)
                    tipTop = ribHeight + control.position().top + control.parents('.e-galleryrow').height();
                else
                    tipTop = ribHeight + control.position().top + control.height();
                toolTipDiv.css({ 'top': tipTop });
            }
            else if (expandContent.is(':visible')) {
                var galRow;
                if (control.parents('.e-galleryrow').length > 0)
                    galRow = control.parents('.e-galleryrow');
                else if (control.parents('.e-galleryexpanderrow').length > 0)
                    galRow = control.parents('.e-galleryexpanderrow');
                else
                    galRow = control;
                if ($(expandContent).parents('.e-resizediv').length > 0)
                    tipTop = galRow.height() + ribHeight + control.position().top + 12;
                else
                    tipTop = galRow.height() + this._tabUl.height() + control.position().top + 12;
                toolTipDiv.offset({ left: controlOffset.left });
                toolTipDiv.css({ 'top': tipTop });
            }
            else {
                if ($(e.target).parents('.e-qatooldiv').length > 0 || $(e.target).hasClass('e-qatooldiv')) {
                    var qaResizeDiv = this.element.find('.e-qaresizediv'), qAccessBar = this.element.find('.e-rbnquickaccessbar');
                    if (qAccessBar.hasClass('e-rbnabove') && qaResizeDiv.length > 0) {
                        if (qaResizeDiv.is(':visible'))
                            toolTipDiv.offset({ top: qaResizeDiv.height() + qAccessBar.height() + 4, left: controlOffset.left });
                    }
                    else if (qAccessBar.hasClass('e-rbnabove'))
                        toolTipDiv.offset({ top: qAccessBar.height() + 4, left: controlOffset.left });
                    else {
                        if (qaResizeDiv.is(':visible'))
                            tipTop = qAccessBar.height() + qaResizeDiv.height() + ribHeight + 4;
                        else
                            tipTop = ribHeight + qAccessBar.height() + 4;
                        toolTipDiv.offset({ top: tipTop, left: controlOffset.left });
                    }
                }
                else {
                    tipTop = ribHeight + 3;
                    toolTipDiv.offset({ top: tipTop, left: controlOffset.left });
                }
            }
        },
        _toolTipOut: function (e) {
            var toolTipDiv = this.element.find("#" + e.data.ribbonId + "_tooltip");
            toolTipDiv.hide(0);
            toolTipDiv.css({ top: '', left: '' });
            toolTipDiv.find('.e-tooltiptitle').children().remove();
            toolTipDiv.find('.e-tooltipdesc').children().remove();
        },
        _responsiveScrollRemove: function () {
            var scroll = this.element.find(".e-active-content .e-responsiveScroll");
            var contentScroll = this.element.find(".e-rescontentScroll");
            if (contentScroll.length > 0) {
                contentScroll.data("ejScroller")._destroy();
                contentScroll.parent().append(contentScroll.find("div:first").children());
                contentScroll.remove();
            }
            if (scroll.length > 0) {
                scroll.data("ejScroller")._destroy();
                this.element.find(".e-active-content").append(scroll.find("div:first").children());
                scroll.remove();
            }
        },
        _onGroupClick: function (args) {
            this._toolTipCustomization(args);var parentElem = $(args.target).parents('.e-resizebtnselect');
            this.element.find('.e-resizebtnselect').removeClass('e-resizebtnselect e-active');
            var resizeDiv = $(args.target).parents('.e-resizediv');
            if ($(args.target).hasClass('e-resizebtnselect'))
                $(args.target).removeClass('e-resizebtnselect e-active');
            else {
                if (parentElem.length > 0)
                    parentElem.removeClass('e-resizebtnselect e-active');
                else {
                    parentElem = $(args.target).parents('.e-resizebtn');
                    if (parentElem.length > 0)
                        parentElem.addClass('e-resizebtnselect e-active');
                    else if ($(args.target).hasClass('e-resizebtn'))
                        $(args.target).addClass('e-resizebtnselect e-active');
                }
            }
            if (this.model.showQAT && !$(args.target).parents(".e-mobdiv").length > 0) {
                if ($(args.target).hasClass('e-togglebutton e-btn') || $(args.target).parents('.e-togglebutton.e-btn').length > 0) {
                    var tBtnId, target = $(args.target);
                    if ($(args.target).parents('.e-togglebutton.e-btn').length > 0)
                        target = $(args.target).parents('.e-togglebutton.e-btn');
                    if (this._QATclick)
                        tBtnId = target.parent().find("input").attr("id") + "_mobEle";
                    else
                        tBtnId = target.parent().find("input").attr("id") + "_qatEle";
                    if ($('.e-ribbon.e-rbnwithqat').find("#" + tBtnId).length > 0)
                        this._rbnToggleBtnCustomization(args, tBtnId);
                }
            }
            if (!this._phoneMode) {
                if (resizeDiv.length <= 0) {
                    if ($(args.target).hasClass('e-resizebtn'))
                        resizeDiv = $(args.target);
                    else if (!ej.isNullOrUndefined($(args.target).parents('.e-resizebtn')))
                        resizeDiv = $(args.target).parents('.e-resizebtn');
                }
                if (this.element.find('.e-resizediv').is(':visible') && this.element.find('.e-resizediv .e-gallexpandcontent').is(':visible')) {
                    if ($(args.target).hasClass('e-gallerymoveicon') || $(args.target).hasClass('e-gallerymovediv') || $(args.target).hasClass('e-expgallerydiv') || $(args.target).hasClass('e-scrollbar') || $(args.target).parents().hasClass('e-scrollbar'))
                        expClick = args.target;
                    else if ($(args.target).parents().hasClass('e-gallerymenu')) {
                        if ($(args.target).hasClass('e-haschild') || $(args.target).hasClass('aschild') || $(args.target).hasClass('e-arrows'))
                            expClick = args.target;
                    }
                    if (ej.isNullOrUndefined(expClick)) {
                        this._ribbonGalleryShow();
                        this.element.find('.e-resizediv').show().css('visibility', '');
                        this.element.find('.e-resizediv .e-gallexpandcontent').hide().css('visibility', '');
                    }
                }
                else if (resizeDiv.length <= 0) {
                    if ((!$(args.target).parents(".e-content").length > 0 && $(args.target).parents(".e-rbn-ddl").length > 0) || $(args.target).parents(".e-rbn-splitbtn").length > 0 || $(args.target).parents(".e-presetWrapper").length > 0 || $(args.target).parents(".e-ribbonpopup").length > 0 || $(args.target).parents('.e-colorpicker.e-ribbon:visible').length > 0)
                        return false;
                    else
                        this._resizeDivHide();
                }
                else {
                    if ($(resizeDiv).hasClass('e-resizebtn')) {
                        if (this.element.find('.e-resizediv').is(":visible")) {
                            if (resizeDiv.parent().siblings('.e-contentbottom').length <= 0)
                                this._resizeDivHide();
                            else {
                                this._resizeDivHide();
                                this._resizeDivShow(resizeDiv);
                            }
                        }
                        else
                            this._resizeDivShow(resizeDiv);
                    }
                }
            }
            if (this._phoneMode) {
                var activeContent = this.element.find(".e-active-content"), activeContentHeight = 0, toolbarscroll, scrollHeightCheck, activeContents;
                var target = args.target;
                if ($(target).hasClass("e-groupresponsive e-ribdownarrow")) {
                    toolbarscroll = activeContent.find(".e-resptoolbarScroll .e-scrollbar").height();
                    activeContents = activeContent.children(".e-groupdiv,.e-groupmobdiv");
                    for (var i = 0; i < activeContents.length; i++) 
                        activeContentHeight += activeContents.eq(i).outerHeight();
                    activeContentHeight += ej.isNullOrUndefined(toolbarscroll) ? 0 : toolbarscroll;
                    scrollHeightCheck = activeContent.find(".e-respmobcontent").length > 0 ? activeContentHeight - activeContent.find(".e-respmobcontent").outerHeight() > this._responsiveHeight : activeContentHeight > this._responsiveHeight;
                    activeContent.height(scrollHeightCheck ? activeContent.find(".e-respmobcontent").length > 0 ? this._responsiveHeight + activeContent.find(".e-respmobcontent").outerHeight() : this._responsiveHeight : activeContentHeight).removeClass("e-responsiveheight e-rbnmobheader e-responsiveToolbarScroll");
                    if (scrollHeightCheck) {
                        var div = ej.buildTag("div#" + this._id + "_responsiveScroller").addClass("e-responsiveScroll").append(ej.buildTag("div"));
                        if (activeContent.find(".e-respmobcontent").length > 0)
                            div.find("div").append(activeContent.children().eq(0).siblings());
                        else
                            div.find("div").append(activeContent.children());
                        activeContent.append(div);
                        activeContent.find(".e-responsiveScroll").ejScroller({ height: this._responsiveHeight, scrollerSize: 8, buttonSize: 0 });
                    }
                    $(target).removeClass("e-ribdownarrow").addClass("e-ribuparrow");
                    $(target).parents(".e-groupdiv").find(".e-ribdownarrow").removeClass("e-ribdownarrow").addClass("e-ribuparrow");
                }
                else if ($(target).hasClass("e-groupresponsive e-ribuparrow")) {
                    activeContent.addClass("e-responsiveheight e-rbnmobheader");
                    if (activeContent.find(".e-resptoolbarScroll").length > 0)
                        activeContent.addClass("e-responsiveToolbarScroll");
                    this._responsiveScrollRemove();
                    $(target).removeClass("e-ribuparrow").addClass("e-ribdownarrow");
                }
                else if (this.element.find(".e-responsivecontent").is(":hidden")) {
                    if ($(target).hasClass("e-resizebtn") || $(target).parents(".e-resizebtn").length > 0 || $(target).hasClass("e-groupresponsive e-ribrightarrow") || $(target).hasClass("e-ribrightdivarrow")){
                        if ($(target).hasClass("e-resizebtn")) {
                            this._responsiveTarget = $(target).parents(".e-groupdiv");
                            this._responsiveContent = $(target).parent().siblings();
                        }
                        else if ($(target).parents(".e-resizebtn").length > 0) {
                            this._responsiveTarget = $(target).parents(".e-resizebtn").parents(".e-groupdiv");
                            this._responsiveContent = $(target).parents(".e-resizebtn").parent().siblings();
                        }
                        else if ($(target).hasClass("e-groupresponsive e-ribrightarrow") || $(target).hasClass("e-ribrightdivarrow")) {
                            var resParent = $(target).parents(".e-resizegroupdiv").find(".e-resizebtn")
                            if (resParent.length > 0) {
                                this._responsiveTarget = resParent.parents(".e-groupdiv");
                                this._responsiveContent = resParent.parent().siblings();
                            }
                        }
                    var resizeContent = this._responsiveContent.eq(0).removeClass("e-reshide");
                    var responsivecontent = this.element.find(".e-content.e-responsivecontent");
                    responsivecontent.children().not(".e-responsiveback").remove();
                    responsivecontent.append(resizeContent);
                    this.element.find(".e-restopbackcontent").text(this._responsiveTarget.find(".e-resizebtn .e-btntxt").text());
                    var gallery = responsivecontent.find(".e-ribbongallery");
                    if (gallery.length > 0) {
                        var expcolumns = this._responsiveGallery;
                        var rowLen = Math.floor(gallery.find('.e-galleryrow').children().length / expcolumns);
                        if (gallery.find('.e-galleryrow').children().length % expcolumns > 0)
                            ++rowLen;
                        for (var m = 1; m <= rowLen; m++) {
                            var galleryExpanderRow = ej.buildTag("div#" + gallery.attr("id") + "_galleryExpanderRow_" + m).addClass('e-galleryexpanderrow').click({ model: gallery }, $.proxy(this._onGalleryItemClick, this));
                            for (var n = 0; n < expcolumns; n++)
                                gallery.find('.e-galleryrow').children().eq(0).appendTo(galleryExpanderRow);
                            galleryExpanderRow.appendTo(responsivecontent.parent().find('.e-expandercontent'));
                        }
                        gallery.hide();
                        responsivecontent.parent().find(".e-gallexpandcontent").show();
                    }
                    this._responsiveContentShow(responsivecontent);
                }
                }
            }
            var groupIndex = $(args.target).hasClass("e-groupdiv") ? $(args.target).index() : $(args.target).parents(".e-groupdiv").index();
            if (groupIndex != -1)
                args.groupItems = this._groupClickEventArgs(groupIndex, args);
            if ($(args.target).parents('.e-ribbongallerycontrol').length === 0) {
                this._trigger("groupClick", args);
                if (!args.cancel && ej.raiseWebFormsServerEvents && !ej.isNullOrUndefined(this.model.serverEvents)) {
                    if (this.model.serverEvents.indexOf("groupClick") != -1) {
                        var modelRibbon = $.extend(true, {}, this.model), controlId;
                        controlId = (args.target.id) ? args.target.id : args.target.parentNode.id;
                        var argsRibbon = { model: modelRibbon, originalEventType: "groupClick", id: controlId };
                        var clientArgs = { model: modelRibbon, id: controlId };
                        ej.raiseWebFormsServerEvents("groupClick", argsRibbon, clientArgs);
                    }
                }
            }

        },
        _groupClickEventArgs: function (groupIndex, args) {
            var activeTab = this._tabUl.find(".e-active");
            var tabIndex = activeTab.index(), currentGrp;
            if (this._phoneMode && $(args.target).parents(".e-groupdiv").siblings(".e-groupmobdiv").length > 0)
                groupIndex -= 1;
            if (!ej.isNullOrUndefined(this.model.applicationTab) && !activeTab.hasClass("e-contextualtabset"))
                tabIndex = tabIndex - 1;
            if (!(tabIndex < 0)) {
                var tab;
                if (!activeTab.hasClass("e-contextualtabset"))
                    tab = this.model.tabs[tabIndex];
                else
                    tab = this.model.contextualTabs[activeTab.parents(".e-contextual").index()].tabs[tabIndex];
                if (!ej.isNullOrUndefined(tab)) currentGrp = tab.groups[groupIndex];
                return currentGrp;
            }
        },
        goToMainContent: function () {
            var responsiveBackstage = this.element.find(".e-responsivebackstage"), respTabHeader = this.element.find(".e-responsivetabheader"), args = {};
            var content = this.element.find(".e-active-content");
            var responsebackstage = this.element.find(".e-responsivebackstage");
            var respBackStageContent = this.element.find(".e-responsivebackstagecontent");
            respTabHeader.removeClass("e-resshow");
            if (responsiveBackstage.is(":visible"))
                responsiveBackstage.removeClass("e-backstageshowanimate").addClass("e-reshide");
            if (respBackStageContent.is(":visible")) 
                respBackStageContent.hide();
            if (this.element.find(".e-responsivecontent").is(":visible"))
                this._responsiveContentBack();
            if (!content.hasClass("e-responsiveheight")) {
                content.addClass("e-responsiveheight e-rbnmobheader");
                this._responsiveScrollRemove();
                content.find(".e-groupresponsive.e-ribuparrow").removeClass("e-ribuparrow").addClass("e-ribdownarrow");
                args.type = "collapse";
                this._trigger("collapse", args);
            }
            if (respTabHeader.hasClass("e-resshow"))
                respTabHeader.removeClass("e-resshow");
        },
        _onResizeDivClick: function (args) {
            this._toolTipCustomization(args);
            if (this.model.showQAT) {
                if ($(args.target).hasClass('e-togglebutton e-btn') || $(args.target).parents('.e-togglebutton.e-btn').length > 0) {
                    var tBtnId, target = $(args.target);
                    if ($(args.target).parents('.e-togglebutton.e-btn').length > 0)
                        target = $(args.target).parents('.e-togglebutton.e-btn');
                    tBtnId = target.parent().find("input").attr('id') + "_qatEle";
                    this._rbnToggleBtnCustomization(args, tBtnId);
                }
            }
            if (this._phoneMode) {
                if ($(args.target).hasClass('e-togglebutton e-btn') || $(args.target).parents('.e-togglebutton.e-btn').length > 0) {
                    var tBtnId, target = $(args.target);
                    if ($(args.target).parents('.e-togglebutton.e-btn').length > 0)
                        target = $(args.target).parents('.e-togglebutton.e-btn');
                    tBtnId = target.parent().find("input").not(".e-active").attr("id") + "_mobEle"
                    this._rbnToggleBtnCustomization(args, tBtnId);
                }
                if ($(args.target).hasClass("e-ribleftarrow")) {
                    this._responsiveContentBack();
                }
            }
            if ($(args.currentTarget).find(".e-ribGroupContent").length > 0) {
                var resizedDiv = $(args.currentTarget).find(".e-ribGroupContent").attr("id").split("_");
                var groupIndex = this.element.find("#" + resizedDiv[0] + '_' + resizedDiv[1] + '_' + resizedDiv[2]).index();
                if (this._phoneMode && groupIndex > 0 && this.element.find("#" + resizedDiv[0] + '_' + resizedDiv[1] + '_' + resizedDiv[2]).siblings(".e-groupmobdiv").length > 0)
                    groupIndex -= 1;
                if (groupIndex != -1)
                    args.groupItems = this._groupClickEventArgs(groupIndex,args);
            }
            args.targetElement = "resizedGroup";
            this._trigger("groupClick", args);
        },
        _toolTipCustomization: function (args) {
            var control = $(args.target).parents('.e-controlpadding');
            if ($(control).find('.e-ribbongallerycontrol').length <= 0 && $(args.target).find('.e-disable').length <= 0 && (!$(args.target).hasClass('e-disable'))) {
                this.element.find(".e-tooltipdiv").hide(0);
                if ($(control).hasClass('e-controlclicked'))
                    $(control).removeClass('e-controlclicked');
                else
                    $(control).addClass('e-controlclicked');
            }
        },
        _onTabClick: function (args) {
            this._trigger("beforeTabClick", args);
            if(this.model.enableOnDemand){ 
             if ($("#" + this._id + "_WaitingPopup").is(":hidden") &&  this.element.find(".e-content.e-content-item").eq(args.activeIndex).children().length==0)
              this.element.ejWaitingPopup("show");
			 this._groupContent(args);
			}
            var expandCollapse = this.element.find('.e-rarrowup-2x'), active = this._tabUl.find('li.e-active');
            var collapse = this.element.find('.e-collapseactive'), aTag, href;
            var activeContent = this.element.find('.e-active-content').eq(0);
            if (this._phoneMode) {
                this._responsiveScrollRemove();
                this.element.find(".e-mobribgroupactive").removeClass("e-mobribgroupactive");
                var tabactiveIndex = args.activeIndex;
                var ribActiveContent = this.element.find(".e-content.e-content-item").eq(tabactiveIndex);
                var tab = this._tabUl.children(".e-tab").index(args.activeHeader);
                if (ej.isNullOrUndefined(this.model.applicationTab)) {
                    --args.activeIndex; --args.prevActiveIndex;
                }
                this.element.find(".e-content.e-content-item").eq(args.prevActiveIndex).removeClass("e-responsiveheight e-rbnmobheader");
                this.element.find(".e-content.e-content-item").eq(args.activeIndex).addClass("e-responsiveheight e-rbnmobheader");
                this.element.find(".e-responsivecontent").is(":visible") && this.element.find(".e-responsivecontent").hasClass("e-resshow") && this.element.find(".e-responsivecontent").removeClass("e-resshow");
                if (!ej.isNullOrUndefined(this._responsiveContent))
                    this._responsiveTarget.append(this._responsiveContent).css(this._responsiveContentStyle);
                if (tab != -1) {
                    if (this._mobileContents[tab].mobileContent.length > 0 && !ribActiveContent.find(".e-respmobcontent").length > 0) {
                        ribActiveContent.prepend(ej.buildTag("div#" + this._id + "_mobcontent").addClass("e-respmobcontent e-groupmobdiv").append(ej.buildTag("div#" + this._id + "_mobribgroup").addClass("e-mobribgroup e-mobribgroupactive").append(ej.buildTag("div.e-ribupdivarrow").addClass("e-toolbaralign").append(ej.buildTag("span.e-icon").addClass("e-groupresponsive e-ribdownarrow"))))).click($.proxy(this._onGroupClick, this)).click($.proxy(this._onMobContentClick, this));
                        ribActiveContent.find(".e-resgroupheader").removeClass("e-resgroupheader");
                        for (var i = 0; i < this._mobileToolbar[tab].Content.length; i++)
                            ribActiveContent.find(".e-mobribgroup").append(this._mobileToolbar[tab].Content[i]);
                        ribActiveContent.find(".e-mobribgroup").append(ribActiveContent.find(".e-mobribgroup .e-ribupdivarrow"))
                    }
                }
                if (tab != -1 && this._mobileContents[tab].mobileContent.length > 0 && !ribActiveContent.find(".e-mobribgroup").hasClass("e-mobribgroupactive"))
                    ribActiveContent.find(".e-mobribgroup").addClass("e-mobribgroupactive");
            }
            if (active.length > 0) {
                active.removeClass("e-active");
                active.children().removeClass("e-active");
                activeContent.removeClass("e-active-content").hide();
            }
            else {
                if (collapse.length > 0) {
                    if (args.activeHeader.textContent === collapse.find('.e-link').text()) {
                        collapse.addClass("e-active").removeClass("e-collapseactive");
                        activeContent.removeClass("e-collapse-content").slideDown("fast", "swing", $.proxy(this._ribExpand, this));
                    }
                    else {
                        aTag = this.element.find('.e-link');
                        collapse.removeClass("e-collapseactive");
                        this.element.find('.e-collapse-content').removeClass("e-collapse-content");
                        activeContent.removeClass("e-active-content");
                        href = aTag.eq(args.activeIndex).attr("href");
                        aTag.eq(args.activeIndex).addClass("e-active");
                        $(href).slideDown("fast", "swing", $.proxy(this._ribExpand, this));
                    }
                }
            }
            if (expandCollapse.length > 0 && this.element.find(".e-collapsed").length > 0)
                this._addRibbonPin();
            if (!this._initialRender)
                this._trigger("tabClick", args);
            this._clickValue = "click";
          
        },
        _onTabSelect: function (args) {
            if (this.model.enableOnDemand){
			 if (this._initialRender && $("#" + this._id + "_WaitingPopup").is(":hidden"))
              this.element.ejWaitingPopup("show");
             this._setTabContentHeight();
			}
            var active = this.element.find('li.e-active'), aTag, href, disable, expCollapse = this.element.find('.e-expandcollapse');
            this.model.selectedItemIndex = args.activeIndex;
            if (!active.hasClass("e-disable")) {
                aTag = this.element.find('.e-link');
                href = aTag.eq(args.activeIndex).attr("href");
                disable = $(href).find("#" + this._id + "_disabled");
                if (disable)
                    this.element.find("#" + this._id + "_disabled").hide();
            }
            if (expCollapse.length > 0)
                expCollapse.appendTo(this.element.find('.e-active-content').eq(0));
            if (!this._phoneMode)
                this._ribbonResize();
            if (!this._initialRender) {
                this._trigger("tabSelect", args);
                if ($('.e-menu-wrap').children('.e-split:visible').length > 0)
                    $($('.e-menu-wrap').children('.e-split')).css("display", "none");
                if ($('.e-rbn-ddl').parent(".e-ddl-popup:visible").length > 0)
                    $($('.e-rbn-ddl').parent(".e-ddl-popup:visible")).css("display", "none");
                if ($(".e-popupWrapper").parent(".e-colorpicker.e-ribbon:visible").length > 0)
                    $($(".e-popupWrapper").parent(".e-colorpicker.e-ribbon")).css("display", "none");
                if (ej.isOnWebForms && ej.raiseWebFormsServerEvents && !ej.isNullOrUndefined(this.model.serverEvents)) {
                    if (this.model.serverEvents.indexOf("tabSelect") != -1) {
                        var modelRibbon = $.extend(true, {}, this.model);
                        var argsRibbon = { model: modelRibbon, originalEventType: "tabSelect", activeIndex: args.activeIndex, prevActiveIndex: args.prevActiveIndex };
                        var clientArgs = { model: modelRibbon, activeIndex: args.activeIndex, prevActiveIndex: args.prevActiveIndex };
                        ej.raiseWebFormsServerEvents("tabSelect", argsRibbon, clientArgs);
                    }
                }
            }
            if (this._phoneMode && !this._initialRender)
                this._ribbonWindowResize();
            this._initialRender = false;
			var proxy=this;
			if(this.model.enableOnDemand && $("#" + this._id + "_WaitingPopup").is(":visible")){
			 setTimeout(function () {
               proxy.element.ejWaitingPopup("hide");
			 },300);
			}
        },
        _create: function (args) {
            if(this.model.enableOnDemand) this.element.find(".e-content.e-content-item").addClass("e-rbn-ondemand");
            this._trigger("tabCreate", args);
        },
        _onGalMoveUpClick: function (args) {
            var gallery = this.element.find("#" + args.data.galleryId);
            var prevElem = gallery.find(".e-gallerycontent").children(':visible').first().prev();
            if (this.element.find('.e-gallexpandcontent:visible').length > 0)
                this._ribbonGalleryShow();
            if (prevElem.length > 0) {
                gallery.find(".e-gallerycontent").children(':visible').last().hide();
                prevElem.show().width(gallery.find('.e-galleryrow').first().width());
                if ($(prevElem).hasClass('e-gryfirstrow'))
                    gallery.find(".e-moveupdiv").addClass("e-disablegrymovebtn");
                gallery.find(".e-movedowndiv").removeClass("e-disablegrymovebtn");
            }
        },
        _onGalMoveDownClick: function (args) {
            var gallery = this.element.find("#" + args.data.galleryId);
            var nextElem = gallery.find(".e-gallerycontent").children(':visible').last().next();
            if (this.element.find('.e-gallexpandcontent:visible').length > 0)
                this._ribbonGalleryShow();
            if (nextElem.length > 0) {
                gallery.find(".e-gallerycontent").children(':visible').first().hide();
                nextElem.show().width(gallery.find('.e-galleryrow').first().width());
                if ($(nextElem).hasClass('e-grylastrow'))
                    gallery.find(".e-movedowndiv").addClass("e-disablegrymovebtn");
                gallery.find(".e-moveupdiv").removeClass("e-disablegrymovebtn");
            }
        },
        _onQatMenuItemClick: function (args) {
            var argsMenu = { target: $(args.target), cancel: false, text: $(args.target).text() };
            this._trigger("qatMenuItemClick", argsMenu);
        },
        _onQatResizeBtnClick: function (args) {
            var qaResizeDiv = this.element.find('.e-qaresizediv'), qaResizeBtn = this.element.find('.e-qaresizebtn'), pLeft;
            if (qaResizeBtn.hasClass('e-active'))
                qaResizeBtn.removeClass('e-tbtn e-active');
            else
                qaResizeBtn.addClass('e-tbtn e-active');
            if (qaResizeDiv.is(':hidden')) {
                if (($(args.e.currentTarget).position().left + qaResizeDiv.width()) > this.element.width()) {
                    pLeft = ($(args.e.currentTarget).position().left + qaResizeDiv.width()) - this.element.width();
                    qaResizeDiv.show().css({ left: $(args.e.currentTarget).position().left - pLeft });
                }
                else
                    qaResizeDiv.show().css({ top: this._qAccessBar.height(), left: $(args.e.currentTarget).position().left });
                if (this._qAccessBar.hasClass('e-rbnbelow'))
                    qaResizeDiv.css({ top: this.element.height() });
                else
                    qaResizeDiv.css({ top: this._qAccessBar.height() });
            }
            else
                qaResizeDiv.hide().css({ top: '', left: '' });
        },
        _onQatExpandBtnClick: function (args) {
            var pLeft = 0, expandBtn = this.element.find('.e-splitbtnqat'), qaResizeDiv = this.element.find('.e-qaresizediv'), qaMenu = this.element.find('.e-rbnqatmenu'), target = $(args.e.currentTarget), qaWidth;
            if (expandBtn.hasClass('e-active')) {
                expandBtn.removeClass('e-tbtn e-active');
                qaMenu.hide(); return;
            }
            else
                expandBtn.addClass('e-tbtn e-active');
            if (qaResizeDiv.length > 0 && qaResizeDiv.is(':visible')) {
                qaWidth = (qaResizeDiv.position().left + target.position().left + qaMenu.width());
                if (qaWidth > this.element.width())
                    pLeft = qaWidth - this.element.width();
                qaMenu.show().css({ top: qaResizeDiv.height() - 6, left: (qaResizeDiv.position().left + target.position().left - (pLeft + 6)) });
            }
            else {
                qaWidth = (target.position().left + qaMenu.width());
                if (this.model.enableRTL)
                    qaWidth = this.element.width() - target.offset().left + qaMenu.width()
                if (qaWidth > this.element.width())
                    pLeft = qaWidth - this.element.width();
                if (this.model.enableRTL)
                    qaMenu.show().css({ right: this.element.width() - target.offset().left + this.element.offset().left - target.outerWidth() - (pLeft) });
                qaMenu.show().css({ left: target.position().left - (pLeft) });
                if (this.element.hasClass("e-grpdivhide")) {
                    this.element.removeClass("e-grpdivhide");
                    this.element.find('.e-active-content').eq(0).addClass("e-resdivshow");
                }
            }
        },
        _onQatClick: function (args) {
            if (!this._QATclick)
                this._QATclick = true;
            if (this.model.showQAT) {
                if ($(args.target).hasClass('e-togglebutton e-btn') || $(args.target).parents('.e-togglebutton.e-btn').length > 0) {
                    var tBtnId, target = $(args.target);
                    if ($(args.target).parents('.e-togglebutton.e-btn').length > 0)
                        target = $(args.target).parents('.e-togglebutton.e-btn');
                    tBtnId = target.parents('.e-qatooldiv').attr('id').slice(0, -7);
                    this._rbnToggleBtnCustomization(args, tBtnId);
                }
            }
            this._QATclick = false;
        },
        _onMobContentClick: function (args) {
            if ($(args.target).hasClass('e-togglebutton e-btn') || $(args.target).parents('.e-togglebutton.e-btn').length > 0) {
                var tBtnId, target = $(args.target);
                if ($(args.target).parents('.e-togglebutton.e-btn').length > 0)
                    target = $(args.target).parents('.e-togglebutton.e-btn');
                if (!target.parents('.e-mobdiv').length > 0)
                    return;
                tBtnId = target.parents('.e-mobdiv').attr('id').slice(0, -7);
                this._rbnToggleBtnCustomization(args, tBtnId);
            }
        },
        _rbnToggleBtnCustomization: function (args, tBtnId) {
            var tBtnInput = this.element.find("#" + tBtnId + ":input.e-togglebutton.e-chkbx-hidden"), tBtn = tBtnInput.parent().siblings('.e-togglebutton');
            if (this._rbnToggleBtnAction && tBtnInput.length > 0) {
                var tBtnClick, tBtnObj;
                this._rbnToggleBtnAction = false;
                tBtnObj = tBtnInput.data("ejToggleButton");
                tBtnClick = tBtnObj.model.click;
                tBtnObj.model.click = "";
                tBtn.click();
                tBtnObj.model.click = tBtnClick;
            }
            this._rbnToggleBtnAction = true;
        },
        _onQatMenuClick: function (args) {
            var qAccessBar = this.element.find('.e-rbnquickaccessbar'), parentEle, target = $(args.target), parentLi = target.parents('.e-qatmenuli');
            if (target.hasClass('e-qatmenuli') || parentLi.length > 0) {
                if (parentLi.length > 0)
                    target = parentLi;
                if (target.attr('id')) {
                    parentEle = this.element.find("#" + this._id + "_" + target.attr('id').slice(0, -7) + "_qatEle").parents(".e-qatooldiv");
                    if (parentEle.is(':visible')) {
                        parentEle.hide();
                        target.addClass('e-addmenuli').removeClass('e-removemenuli').attr('title', this.localizedLabels.AddToQuickAccessToolbar);
                    }
                    else {
                        parentEle.show();
                        target.removeClass('e-addmenuli').addClass('e-removemenuli').attr('title', this.localizedLabels.RemoveFromQuickAccessToolbar);
                    }
                }
                if (target.hasClass('e-rbnshowbelow')) {
                    this.element.append(qAccessBar.removeClass('e-rbnabove').addClass('e-rbnbelow')).removeClass('e-rbnwithqatabove').addClass('e-rbnwithqatbelow');
                    target.addClass('e-rbnshowabove').removeClass('e-rbnshowbelow').text(this.localizedLabels.ShowAboveTheRibbon);
                    this.model.showBelowQAT = true;
                }
                else if (target.hasClass('e-rbnshowabove')) {
                    this.element.prepend(qAccessBar.removeClass('e-rbnbelow').addClass('e-rbnabove')).removeClass('e-rbnwithqatbelow').addClass('e-rbnwithqatabove');
                    target.addClass('e-rbnshowbelow').removeClass('e-rbnshowabove').text(this.localizedLabels.ShowBelowTheRibbon);
                    this.model.showBelowQAT = false;
                }
                this.element.find('.e-rbnqatmenu').hide().css({ top: '', left: '' });
                this.element.find('.e-qaresizebtn,.e-splitbtnqat').removeClass('e-tbtn e-active');
                if (this.model.allowResizing || this.model.isResponsive) {
                    this._qatResize();
                    this._qatResizeRemove();
                }
            }
        },
        _onGalContentClick: function (args) {
            var gallery = this.element.find("#" + args.data.galleryId);
            if ($(args.target).hasClass("e-gallerybtn")) {
                gallery.find(".e-galleryselect").removeClass("e-galleryselect");
                $(args.target).addClass("e-galleryselect");
            }
            else if ($(args.target).parents(".e-gallerybtn")) {
                gallery.find(".e-galleryselect").removeClass("e-galleryselect");
                $(args.target).parents(".e-gallerybtn").addClass("e-galleryselect");
            }
        },
        _onExpandContentClick: function (args) {
            var gallery = this.element.find("#" + args.data.galleryId);
            if ($(args.target).hasClass("e-gallerybtn")) {
                gallery.parent().find(".e-galleryselect").removeClass("e-galleryselect");
                $(args.target).addClass("e-galleryselect");
            }
            else if ($(args.target).parents(".e-gallerybtn")) {
                gallery.parent().find(".e-galleryselect").removeClass("e-galleryselect");
                $(args.target).parents(".e-gallerybtn").addClass("e-galleryselect");
            }
        },
        _onExpandGalleryClick: function (args) {
            var rowLen, gallery = this.element.find("#" + args.data.galleryId), expcolumns = args.data.expandedColumns;

            if (this.element.find('.e-gallexpandcontent:visible').length > 0)
                this._ribbonGalleryShow();
            if (ej.isNullOrUndefined(args.data.expandedColumns))
                expcolumns = args.data.columns;
            rowLen = Math.floor(gallery.find('.e-galleryrow').children().length / expcolumns);
            if (gallery.find('.e-galleryrow').children().length % expcolumns > 0)
                ++rowLen;
            for (var m = 1; m <= rowLen; m++) {
                var galleryExpanderRow = ej.buildTag("div#" + gallery.attr("id") + "_galleryExpanderRow_" + m).addClass('e-galleryexpanderrow').click({ model: gallery }, $.proxy(this._onGalleryItemClick, this));
                for (var n = 0; n < expcolumns; n++)
                    gallery.find('.e-galleryrow').children().eq(0).appendTo(galleryExpanderRow);
                galleryExpanderRow.appendTo(this.element.find("#" + gallery.attr("id")).parent().find('.e-expandercontent'));
            }
            gallery.hide();
            for (var i = 0; i < args.data.columns; i++)
                gallery.find('.e-galleryrow').eq(0).append("<div></div>");
            if (this.element.find('.e-resizediv').is(":visible")) {
                this.element.find('.e-resizediv').css('visibility', 'hidden');
                this.element.find('.e-resizediv .e-gallexpandcontent').css('visibility', 'visible');
            }
            this.element.find("#" + gallery.attr("id")).parent().find(".e-gallexpandcontent").show();
            if (this.element.find("#" + gallery.attr("id")).parent().find('.e-expandercontent').height() > 160 && !this._phoneMode)
                this.element.find("#" + gallery.attr("id")).parent().find(".e-gallscrollcontent").ejScroller({ height: 160 });
        },
        _onGalleryItemClick: function (e) {
            var args, target, galleryModel, cancel;
            args = { target: e.target, galleryModel: e.data.model, cancel: false };
            if (!$(args.target).hasClass("e-galleryexpanderrow")) {
                this._trigger("galleryItemClick", args);
                e.preventDefault();
                if (ej.raiseWebFormsServerEvents && !ej.isNullOrUndefined(this.model.serverEvents)) {
                    if (this.model.serverEvents.indexOf("galleryItemClick") != -1) {
                        var modelRibbon = $.extend(true, {}, this.model), controlId;
                        controlId = (args.target.id) ? args.target.id : args.target.parentNode.id;
                        var argsRibbon = { model: modelRibbon, originalEventType: "galleryItemClick", id: controlId };
                        var clientArgs = { model: e.data.model, id: controlId };
                        ej.raiseWebFormsServerEvents("galleryItemClick", argsRibbon, clientArgs);
                    }
                }
            }
        },
        _ribbonKeyDown: function (e) {
            if (e.keyCode === 40 || e.keyCode === 39)
                if (this._tabUl.find('.e-tab:visible,.e-contextualtabset:visible').length === this._tabObj.model.selectedItemIndex)
                    e.stopImmediatePropagation();
        },
        _OnKeyDown: function (e) {
            if (e.keyCode === 27) {
                var resizeDiv = this.element.find('.e-resizediv');
                if (this.element.find('.e-ribbonbackstagepage').is(':visible'))
                    this.hideBackstage();
                else if ($('.e-menu-wrap').children('.e-split:visible').length <= 0 && resizeDiv.find('.e-ddl').parents('.e-controlclicked').length <= 0 && resizeDiv.is(':visible'))
                    this._resizeDivHide();
                else if (this.element.find('.e-gallexpandcontent').is(':visible'))
                    this._ribbonGalleryShow();
                if (resizeDiv.is(':visible'))
                    resizeDiv.find('.e-controlclicked').removeClass('e-controlclicked');
                var modelDivEle = this.element.find("#" + this._id + "_modelDiv");
                if (modelDivEle.is(":visible"))
                    modelDivEle.css("display", "none");
            }
        },
        _ribCollapse: function (args) {
            var args = { clickType: this._clickValue };
            if (this._clickValue == null)
                args = { clickType: "click" };
            this._clickValue = null;
            this._trigger("collapse", args);
        },
        _ribExpand: function (args) {
            if (this.element.find('.e-ribbonpin').length > 0)
                this._tabContents.width(this.element.width());
            var args = { clickType: this._clickValue };
            if (this._clickValue == null)
                args = { clickType: "click" };
            this._clickValue = null;
            this._trigger("expand", args);
        },
        collapse: function () {
            var activeContent = this.element.find('.e-active-content').eq(0), togglecontent = this.element.find("#" + this._id + "_togglebutton");
            if (this._initialRender && this.model.collapsible)
                activeContent.hide();
            else
                activeContent.slideUp("fast", "swing", $.proxy(this._ribCollapse, this));
            this.element.find('li.e-active').eq(0).removeClass("e-active").addClass("e-collapseactive e-select");
            activeContent.addClass("e-collapse-content");
            this._selectedItemIndex = this._tabObj.model.selectedItemIndex;
            this._tabObj.option({ selectedItemIndex: 0 });
            this._tabObj.model.selectedItemIndex = 0;
            this.model.selectedItemIndex = 0;
            togglecontent.removeClass("e-expanded").addClass("e-collapsed");
            this._isCollapsed = true;
        },

        expand: function () {
            var activeContent = this.element.find('.e-active-content').eq(0);
            if (activeContent.hasClass("e-rbn-ondemand"))
                this._groupContent({activeIndex:this.model.selectedItemIndex+1});
            var togglecontent = this.element.find("#" + this._id + "_togglebutton");
            activeContent.slideDown("fast", "swing", $.proxy(this._ribExpand, this));
            this.element.find('.e-collapseactive').addClass("e-active").removeClass("e-collapseactive");
            activeContent.removeClass("e-collapse-content");
            this._tabObj.model.selectedItemIndex = this._selectedItemIndex;
            this.model.selectedItemIndex = this._selectedItemIndex
            togglecontent.removeClass("e-collapsed").addClass("e-expanded");
            togglecontent.find("span").addClass("e-rarrowup-2x");
            if (!this._phoneMode) {
                this._ribbonResize();
                this._addRibbonPin();
            }
        },
        _addRibbonPin: function () {
            if (this.element.find('.e-ribbonpinicon').length <= 0) {
                var expandCollapse = this.element.find('.e-expandcollapse'), expandIcon = this.element.find('.e-rarrowup-2x');
                expandIcon.parent().removeClass("e-collapsed").addClass("e-expanded e-ribbonpin");
                expandIcon.removeClass("e-rarrowup-2x").addClass("e-ribbonpinicon");
                this._isCollapsed = false;
            }
            this._tabContents.css({ 'position': 'absolute' }).width(this.element.width());
            if (this.element.hasClass("e-grpdivhide"))
                this._tabContents.css({ 'position': '' }).width(this.element.width());
            if (this.element.hasClass("e-grpdivhide") && this.element.find('.e-ribbonpin').length > 0 && this.model.showQAT && this._qAccessBar.hasClass('e-rbnbelow'))
                this.element.find('.e-rbnquickaccessbar').css({ 'position': 'absolute' });
        },
        _removeRibbonPin: function () {
            var togglecontent = this.element.find("#" + this._id + "_togglebutton");
            this._tabContents.css({ 'position': '', 'width': '' });
            togglecontent.removeClass("e-ribbonpin");
            togglecontent.find("span").removeClass("e-ribbonpinicon").addClass("e-rarrowup-2x");
        },
        _onRbnPinDivClick: function (args) {
            this._removeRibbonPin();
        },
        _onGroupExpandClick: function (e) {
            this._trigger("groupExpand", e);
        },
        _onBackStageItemClick: function (args) {
            if (this._phoneMode)
                this.element.find(".e-responsivebackstagecontent .e-backstageTitle").text($(args.currentTarget).text());
            var iconHeight, backStageId, backStageText, argsBackStage, backStageHeight;
            var contentId = this.element.find(args.data.contentDivId);
            args.preventDefault();
            if ($(args.target).hasClass("e-backstagebutton")) {
                this.element.find(".e-ribbonbackstagepage").hide();
                if (this._phoneMode)
                    if (this.element.find(".e-responsivebackstage").is(":visible"))
                        this.element.find(".e-responsivebackstage").removeClass("e-backstageshowanimate");
            }
            this.element.find('.e-backstageactive-content').removeClass("e-backstageactive-content").hide();
            this.element.find(".e-backstageactive").removeClass("e-backstageactive");
            if (this.model.enableOnDemand && contentId.children().length == 0) {
                var backstageSet = this.model.applicationTab.backstageSettings;
                var backstagePageLen = backstageSet.pages.length;
                if (this.model.enableOnDemand && backstagePageLen > 0) {
                    var activeIndex = $(args.currentTarget).index() - $(args.currentTarget).prevAll(".e-backstageseparator").length;
                    contentId.append($('#' + backstageSet.pages[activeIndex].contentID).addClass('e-backstagetabarea').show());
                }
            }
            this.element.find(args.data.contentDivId).addClass("e-backstageactive-content").show();
            if ($(args.target).hasClass("e-backstageli"))
                $(args.target).addClass("e-backstageactive");
            else
                $(args.target).parents(".e-backstageli").addClass("e-backstageactive");
            iconHeight = this.element.find('.e-ribbonbackstagetop').height();
            this.element.find(".e-backstagescrollcontent").ejScroller({ height: 0 });
            backStageHeight = this.model.applicationTab.backstageSettings.height;
            if (!ej.isNullOrUndefined($(args.target).text()))
                backStageText = $(args.target).text();
            else
                backStageText = $(args.target).children('a').text();
            if (!ej.isNullOrUndefined($(args.target).attr('id')))
                backStageId = $(args.target).attr('id');
            else
                backStageId = $(args.target).parent().attr('id');
            argsBackStage = { id: backStageId, text: backStageText, target: args.target, type: "backstageItemClick", cancel: false };
            if (!this.element.find(args.data.contentDivId).children().hasClass("e-backstagetitlecontent") && this.model.enableOnDemand)
                ej.buildTag("div#" + this._id + "_BackStageTitleContent").addClass('e-backstagetitlecontent').text(backStageText).prependTo(contentId);
            else if (this.model.enableOnDemand)
                this.element.find(".e-backstagetitlecontent").text('').append(backStageText);
			this._backStageHeightCalculate(backStageHeight, iconHeight);
            if ($(args.target).parents(".e-backstageheader").length > 0 && ($(args.target).find("a").length > 0 || args.target.localName == "a") && this._phoneMode) {
                this.element.find(".e-responsivebackstagecontent").show();
                this.element.find(".e-responsivebackstage").removeClass("e-backstageshowanimate");
            }
            this._trigger("backstageItemClick", argsBackStage);
        },
        _onBackStageTopIcon: function (args) {
            this.hideBackstage();
        },
        _backStageHeightCalculate: function (backStageHeight, iconHeight) {
            var backStageWidth = this.model.applicationTab.backstageSettings.width;
            if (!ej.isNullOrUndefined(backStageHeight)) {
                if (backStageHeight.toString().endsWith('%'))
                    backStageHeight = this.element.find(".e-ribbonbackstagepage").height();
                else if (backStageHeight.toString().endsWith('px'))
                    backStageHeight = parseInt(backStageHeight, 10);
                if (this.model.applicationTab.backstageSettings.height != '100%') {
                    if (this.element.find(".e-backstageactive-content").height() > backStageHeight - iconHeight)
					{
                        this.element.find(".e-ribbonbackstagepage").height(backStageHeight).width(backStageWidth);
                        this.element.find(".e-backstagescrollcontent").ejScroller({ height: backStageHeight - iconHeight, scroll: $.proxy(this._scroll, this) });
					}
                    else {
                        if (ej.isNullOrUndefined(backStageHeight))
                            if (this.element.find(".e-backstageactive-content").height() > this.element.height() - iconHeight)
                                this.element.find(".e-backstagescrollcontent").ejScroller({ height: this.element.height() - iconHeight, scroll: $.proxy(this._scroll, this) });
                    }
                }
            }
            if (!ej.isNullOrUndefined(backStageWidth)) {
                if (backStageWidth.toString().endsWith('%'))
                    backStageWidth = this.element.find(".e-ribbonbackstagepage").width();
                else if (backStageWidth.toString().endsWith('px'))
                    backStageHeight = parseInt(backStageWidth, 10);
                if (this.model.applicationTab.backstageSettings.width != '100%') {
                    if (this.element.find(".e-backstageactive-content").width() > backStageWidth - this.element.find(".e-backstageheader").width()) {
                        this.element.find(".e-ribbonbackstagepage").height(backStageHeight).width(backStageWidth);
                        this.element.find(".e-backstagescrollcontent").ejScroller({ width: backStageWidth });
                    }
                    else {
                        if (ej.isNullOrUndefined(backStageWidth))
                            if (this.element.find(".e-backstageactive-content").width() > this.element.width())
                                this.element.find(".e-backstagescrollcontent").ejScroller({ width: this.element.width() })
                    }
                }
            }
            this._refreshBackstageScroller();
        },
        _refreshBackstageScroller: function () {
            var proxy = this;
            this.element.find(".e-backstagescrollcontent").find(".e-content").scroll(ej.proxy(function (e) {
                proxy.element.find(".e-backstagetopcontent").css({ 'position': 'relative', 'left': -$(e.currentTarget).scrollLeft() });
                proxy.element.find(".e-backstagetopicon").css({ 'left': $(e.currentTarget).scrollLeft() + 26 });
            }));
        },
        _onApplicationTabClick: function (args) {
            args.preventDefault();
            var backStageContent = this.element.find(".e-backstagecontent");
            if (this.model.enableOnDemand && backStageContent.length == 0)
                this._createApplicationTab();
            backStageContent = this.element.find(".e-backstagecontent");
               this.showBackstage();
        },

        showBackstage: function () {
            var headerWidth, argsBackStage, iconHeight, backStageHeight, backStageWidth, target, backStageText, backStageLi, bodyCon, headerCon;
            var backStageContent = this.element.find(".e-backstagecontent");
            if (this.model.enableOnDemand && backStageContent.length == 0)
                this._createApplicationTab();
            bodyCon = this.element.find(".e-ribbonbackstagebody");
            headerCon = this.element.find(".e-backstageheader");
            backStageHeight = this.model.applicationTab.backstageSettings.height;
            backStageWidth = this.model.applicationTab.backstageSettings.width;
            if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Backstage) {
                if (ej.isNullOrUndefined(backStageHeight)) {
                    this.element.find(".e-ribbonbackstagepage").height(this.element.height()).width(this.element.width());
                    bodyCon.height(this.element.height() - 92);
                    headerCon.height(this.element.height() - 92);
                }
                else {
                    bodyCon.height(backStageHeight - 92);
                    headerCon.height(backStageHeight - 92);
                }
                if (ej.isNullOrUndefined(backStageWidth)) {
                    this.element.find(".e-ribbonbackstagepage").height(this.element.height()).width(this.element.width());
                    bodyCon.width(this.element.width());
                }
                else {
                    bodyCon.width(backStageWidth);
                }
                this.element.css({ "position": "relative" });
                this.element.find(".e-ribbonbackstagepage").show();
                headerWidth = this.element.find('.e-backstageheader').width();
                this.element.find('.e-backstagetopcontent').width(headerWidth);
                this.element.find('.e-backstageheader').width(headerWidth);
                backStageLi = this.element.find(".e-backstageli");
                backStageLi.width(backStageLi.width());
                iconHeight = this.element.find('.e-ribbonbackstagetop').height();
                this.element.find(".e-backstageactive-content").removeClass("e-backstageactive-content").hide();
                this.element.find(".e-backstageactive").removeClass("e-backstageactive");
                backStageLi.first().addClass("e-backstageactive");
                this.element.find('.e-backstagecontent').first().addClass("e-backstageactive-content").show();
                this.element.find(".e-backstagescrollcontent").ejScroller({ height: 0, width: 0 });
                target = this.element.find('.e-backstageli').first();
                if (!ej.isNullOrUndefined($(target).text()))
                    backStageText = $(target).text();
                else
                    backStageText = $(target).children('a').text();
                var backstageSet = this.model.applicationTab.backstageSettings;
                var backstagePageLen = backstageSet.pages.length;
                var backStageContent = this.element.find(".e-backstagecontent");
                if (!this._phoneMode) {
                    if (this.model.enableOnDemand && backstagePageLen > 0 && !ej.isNullOrUndefined(backstageSet.pages[0].text)) {
                        var activeIndex = $(".e-backstageactive-content").index() - 1;
                        var activeContent = $(backStageContent).filter(".e-backstageactive-content");
                        if (activeIndex != -1)
                            $(activeContent).append($('#' + backstageSet.pages[activeIndex].contentID).addClass('e-backstagetabarea').show());
                        if (!$(activeContent).children().hasClass("e-backstagetitlecontent"))
                            $(activeContent).prepend(ej.buildTag("div#" + this._id + "_BackStageTitleContent").addClass('e-backstagetitlecontent'));
                    }
                }
                this._backStageHeightCalculate(backStageHeight, iconHeight);
                backStageContent = this.element.find(".e-backstagecontent");
                var responsebackstage = this.element.find(".e-responsivebackstage").removeClass("e-reshide");
                var resbackstageHeader = responsebackstage.find(".e-backstageheader");
                if (this._phoneMode) {
                    if (this.element.find(".e-responsivetabheader").is(":visible"))
                        this.element.find(".e-responsivetabheader").removeClass("e-resshow");
                    if (responsebackstage.children().length > 0) {
                        var top = parseInt(resbackstageHeader.css("top"))
                        if (this.element.parent(".e-js").length > 0 && ((document.documentElement.clientHeight - (responsebackstage.find(".e-backstageheader").offset().top)) > this.element.parent(".e-js").height()))
                            resbackstageHeader.css({ "width": this.element.find(".e-header").outerWidth() / 2, "height": this.element.parent().height() });
                        else
                            resbackstageHeader.css({ "width": this.element.find(".e-header").outerWidth() / 2, "height": document.documentElement.clientHeight - (responsebackstage.find(".e-backstageheader").offset().top) });
                        if (resbackstageHeader.offset().top != top)
                            resbackstageHeader.height(resbackstageHeader.height() - top);
                    }
                    responsebackstage.addClass("e-backstageshowanimate");
                    this.element.find(".e-backstageactive").removeClass("e-backstageactive");
                }
                argsBackStage = { id: $(target).attr('id'), text: backStageText, target: $(target).children(), type: "backstageItemClick", cancel: false };
                if (this.model.enableOnDemand)
                    this.element.find(".e-backstagetitlecontent").text('').append(backStageText);
                this._trigger("backstageItemClick", argsBackStage);
            }
        },
        hideBackstage: function () {
            this.element.find(".e-ribbonbackstagepage").hide();
            if (this._phoneMode)
                this.goToMainContent();
        },
        _initPrivateProperties: function () {
            this._initialRender = false;
            this._tabUl = this.element.find('.e-header');
            this._applicationTab = this.element.find('.e-apptab');
            this._ribbonTabs = this._tabUl.find(":not('a')");
            this._tabText = this.element.find('.e-link');
            this._id = this.element.attr("id");
            this._tabObj = this.element.data("ejTab");
            this._isCollapsed = false;
            this._contextualTabSet = "";
            this._resizeWidth = 0;
            this._selectedItemIndex = 0;
            this._clickValue = null;
            this._tabContents = this.element.children().attr('role', 'tabpanel').not('.e-header,.e-disable,.e-resizediv,.e-tooltipdiv,.e-ribbonbackstagepage');
            this._qatControlsName = [];
            this._qAccessBar = this.element.find('.e-rbnquickaccessbar');
            this._rbnToggleBtnAction = true;
            this.localizedLabels = this._getLocalizedLabels();
            this._phoneMode = (this.model.allowResizing || this.model.isResponsive) && document.documentElement.clientWidth < 420 ? true : false;
            this._responsiveTarget = null;
            this._responsiveContent = null;
            this._responsiveContentStyle = null;
            this._responsiveGallery = null;
            this._mobileToolbar = [];
            this._mobileContents = [];
            this._responsiveTabText = null;
            this._responsiveHeight = document.documentElement.clientHeight * (parseInt("40%") / 100);
            this._QATclick = false;
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _customization: function () {
            var toggleelm, model = {}, expColObj = {}, li, proxy = this;
            if (this._initial) {
                if (this.model.contextualTabs.length > 0 && this.model.contextualTabs[0].tabs.length > 0)
                  this._contextualTabs();
                toggleelm = '<div id=' + this._id + '_togglebutton class="e-expanded"><span class="e-icon e-rarrowup-2x"></span></div>';
                li = ej.buildTag("li#" + this._id + "_" + "expandCollapse.e-expandcollapse", toggleelm);
                this.element.find('.e-active-content').eq(0).append(li);
                expColObj.expandObj = this.model.expandPinSettings;
                expColObj.collapseObj = this.model.collapsePinSettings;
                li.mouseover({ value: expColObj, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
            }
            this.model.enableOnDemand ? this._createAppTabOnDemand() : this._createApplicationTab();
                      this.element.find('.e-content.e-content-item').on("webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend",
                           function (event) {
						          if(proxy.element.hasClass('e-responsive')){
                                   if (proxy.element.find(".e-ribupdivarrow .e-icon").hasClass("e-ribuparrow"))
                                       proxy._ribExpand(this);
                                    else if (proxy.element.find(".e-ribupdivarrow .e-icon").hasClass("e-ribdownarrow"))
                                       proxy._ribCollapse(this);
								  }
                               });

        },
        _createAppTabOnDemand: function () {
            var model;
            if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Menu) {
                this._applicationTab.find('.e-link').hide();
                if (this.model.applicationTab.menuSettings)
                    model = this.model.applicationTab.menuSettings;
                if (this.model.applicationTab.menuItemID) {
                    $("#" + this.model.applicationTab.menuItemID).appendTo(this._applicationTab);
                    model.enableRTL = this.model.enableRTL;
                    model.isResponsive = false;
                    $("#" + this.model.applicationTab.menuItemID).addClass("e-rbncustomelement").ejMenu(model);
                }
                $("#" + this._id + "_" + this.model.applicationTab.type.replace(/\s/g, '')).hide();
            }
            else {
                this._applicationTab.find('.e-link').text(this.model.applicationTab.backstageSettings.text);
            }
            this._applicationTab.click($.proxy(this._onApplicationTabClick, this));
            if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Backstage) 
             this._applicationTab.find('a').addClass('e-apptabanchor');
        },
		_createApplicationTab: function() {
		 var backStagePage=this.element.find(".e-ribbonbackstagepage"), backStageContent, backStageUl=this.element.find(".e-backstageheader"), backStageLi, aTag, backStageScrollContent, backStageTop, backStageBody=this.element.find(".e-ribbonbackstagebody"), backStageTopContent=this.element.find(".e-backstagetopcontent"), backStageTitleContent, backStageTopIcon, bottomSeparator,backstageSet,backstagePageLen,model;
         backstageSet = this.model.applicationTab.backstageSettings;
         backstagePageLen = backstageSet.pages.length;
		 if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Menu && !this.model.enableOnDemand) {
                this._applicationTab.find('.e-link').hide();
                if (this.model.applicationTab.menuSettings)
                    model = this.model.applicationTab.menuSettings;
                if (this.model.applicationTab.menuItemID) {
                    $("#" + this.model.applicationTab.menuItemID).appendTo(this._applicationTab);
                    model.enableRTL = this.model.enableRTL;
                    model.isResponsive = false;
                    $("#" + this.model.applicationTab.menuItemID).addClass("e-rbncustomelement").ejMenu(model);
		        }
                $("#" + this._id + "_" + this.model.applicationTab.type.replace(/\s/g, '')).hide();
		    }
            else {
                this._applicationTab.find('.e-link').text(this.model.applicationTab.backstageSettings.text);
		    }
            this._applicationTab.click($.proxy(this._onApplicationTabClick, this));
            this.element.find('.e-content.e-content-item').css("box-sizing", "content-box");
            if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Backstage) {
                var backStageHeight = this.model.applicationTab.backstageSettings.height;
                if (backStageHeight.toString().endsWith('%'))
                    backStageHeight = $(document).height() * (parseInt(backStageHeight.slice(0, -1), 10) / 100);
                else if (backStageHeight.toString().endsWith('px'))
                    backStageHeight = parseInt(backStageHeight, 10);
	            if(backStagePage.length==0){
                 backStagePage = ej.buildTag("div#" + this._id + "_BackStage").addClass('e-ribbonbackstagepage');
                 backStageBody = ej.buildTag("div#" + this._id + "_BackStageBody").addClass('e-ribbonbackstagebody');
                 backStageUl = ej.buildTag("ul#" + this._id + "_BackStageHeader").addClass('e-backstageheader');
				}
				backStagePage.height(backStageHeight).width(this.model.applicationTab.backstageSettings.width).hide();
                backStageBody.height(backStageHeight - 50);
                backStageUl.height(backStageHeight - 50);
                for (var i = 0; i < backstagePageLen; i++) {
				  var bsItem=this.element.find("#"+backstageSet.pages[i].id + "_backStageTab"),prevItem=this.element.find("#"+backstageSet.pages[i].id + "_backStageBtn");
                  if(ej.isNullOrUndefined(backstageSet.pages[i].itemType))
                     backstageSet.pages[i].itemType = ej.Ribbon.ItemType.Tab;
				  if(backstageSet.pages[i].itemType == ej.Ribbon.ItemType.Button){
				   bsItem =this.element.find("#"+backstageSet.pages[i].id + "_backStageBtn");
				   prevItem=this.element.find("#"+backstageSet.pages[i].id + "_backStageTab");
				  }
				if(this.element.find(".e-ribbonbackstagepage").length==0 || (bsItem.length==0 && prevItem.length==0)){
                    backStageLi = ej.buildTag("li").addClass('e-backstageli').attr("tabindex", 0).click({ contentDivId: "#" + this._id + "_BackStage_" + backstageSet.pages[i].id.replace(/\s/g, ''), height: backstageSet.height }, $.proxy(this._onBackStageItemClick, this));
                    if (backstageSet.pages[i].itemType == ej.Ribbon.ItemType.Tab) {
                        aTag = ej.buildTag("a", backstageSet.pages[i].text, {}, { href: "#" + this._id + "_BackStage_" + backstageSet.pages[i].id.replace(/\s/g, '') }).focus(function() {
                         $(this).parents('.e-backstageli').addClass('e-bsmaterial-focus');
                            }).focusout(function() {
                         $(this).parents('.e-backstageli').removeClass('e-bsmaterial-focus');
                         });
                        backStageLi.append(aTag).attr('id', backstageSet.pages[i].id + "_backStageTab");
						}
                    else
                        backStageLi.append(backstageSet.pages[i].text).addClass('e-backstagebutton').attr('id', backstageSet.pages[i].id + "_backStageBtn");
                    backStageUl.append(backStageLi);
                    if (backstageSet.pages[i].enableSeparator) {
                        bottomSeparator = ej.buildTag("li").addClass('e-backstageseparator');
                        backStageUl.append(bottomSeparator);
                    }
                    if (backstageSet.pages[i].itemType == ej.Ribbon.ItemType.Tab) 
                        this._addBackStageTabCont(backstageSet,backStageBody,i);
					}
					else{
					 var bItem=prevItem;
					 if(bsItem.length>0)
					  bItem=bsItem;
					 if(backstageSet.pages[i].itemType == ej.Ribbon.ItemType.Button){
					     if(bItem.find('a').length>0){
						  this._removeBackStageTabCont(this.element.find(bItem.find('a').attr('href')));
						  bItem.attr('id', backstageSet.pages[i].id + "_backStageBtn").addClass('e-backstagebutton');
						  bItem.find('a').remove();
						  }
						  bItem.text(backstageSet.pages[i].text);
					 }
					 else{
					   if(bItem.hasClass('e-backstagebutton')){
						 aTag = ej.buildTag("a", backstageSet.pages[i].text, {}, { href: "#" + this._id + "_BackStage_" + backstageSet.pages[i].id.replace(/\s/g, '') }).focus(function() {
                         $(this).parents('.e-backstageli').addClass('e-bsmaterial-focus');
                            }).focusout(function() {
                         $(this).parents('.e-backstageli').removeClass('e-bsmaterial-focus');
                         });
                         bItem.append(aTag).attr('id', backstageSet.pages[i].id + "_backStageTab").removeClass('e-backstagebutton');
                         this._addBackStageTabCont(backstageSet,backStageBody,i);
						}
						bItem.find('a').text(backstageSet.pages[i].text);
						var tabCon=this.element.find(bItem.find('a').attr('href'));
						if(backstageSet.pages[i].contentID!=tabCon.find(".e-backstagetabarea").attr('id')){
				          tabCon.find('.e-backstagetabarea').removeClass('e-backstagetabarea').appendTo('body');
                          tabCon.append($('#' + backstageSet.pages[i].contentID).addClass('e-backstagetabarea'));
						}
					 }
					if (backstageSet.pages[i].enableSeparator) {
					    if(bItem.next().length>0 && !bItem.next().hasClass('e-backstageseparator')){
                        bottomSeparator = ej.buildTag("li").addClass('e-backstageseparator');
                        bItem.after(bottomSeparator);
						}
                    }
					else{
					 if(bItem.next().length>0 && bItem.next().hasClass('e-backstageseparator'))
					  bItem.next().remove();
					}
					}
		        }
		        if (this.element.find(".e-ribbonbackstagepage").length == 0) {
		            backStageBody.prepend(backStageUl);
		            backStageTop = ej.buildTag("div#" + this._id + "_BackStageTop").addClass('e-ribbonbackstagetop').height(92);
		            backStageTopContent = ej.buildTag("div#" + this._id + "_BackStageTopContent").addClass('e-backstagetopcontent').appendTo(backStageTop);
		            backStageTopIcon = ej.buildTag("div#" + this._id + "_BackStageTopIcon", "<div class='e-ribbonbackicon'><span></span></div>").addClass('e-backstagetopicon').click($.proxy(this._onBackStageTopIcon, this)).appendTo(backStageTopContent);
		            backStagePage.append(backStageTop);
		            backStageScrollContent = ej.buildTag("div#" + this._id + "_backStageScrollContent", "<div></div>").addClass("e-backstagescrollcontent");
		            backStageScrollContent.children().append(backStageBody);
		            backStagePage.append(backStageScrollContent);
		            this._applicationTab.addClass('e-backstagetab');
		            this._applicationTab.find('a').addClass('e-apptabanchor');
		            if (this.element.find('.e-ribbonbackstagepage').length > 0)
		                this.element.find('.e-ribbonbackstagepage').remove();
		            this.element.append(backStagePage);
		            var responsiveBackStage = this.element.find(".e-responsivebackstagecontent .e-resbackstagecontent");
		            if (backStagePage.find(".e-ribbonbackstagebody .e-backstagecontent").length > 0 && this._phoneMode) {
		                responsiveBackStage.children().remove();
		                responsiveBackStage.append(backStagePage.find(".e-ribbonbackstagebody .e-backstagecontent"));
		            }
		        }
		        else {
		            var tabs = [];
		            for (var i = 0; i < this.model.applicationTab.backstageSettings.pages.length; i++)
		                tabs.push(this.model.applicationTab.backstageSettings.pages[i].id);
		            for (var i = 0; i < this.element.find('.e-backstageli').length; i++) {
		                var ele = this.element.find('.e-backstageli').eq(i), id = ele.attr('id').split('_')[0];
		                if ($.inArray(id, tabs) < 0) {
		                    if (ele.find('a').length > 0)
		                        this._removeBackStageTabCont(this.element.find(ele.find('a').attr('href')));
		                    if (ele.next().length > 0 && ele.next().hasClass('e-backstageseparator'))
		                        ele.next().remove();
		                    ele.remove();
		                    --i;
		                }
		            }
		            for (var i = 0; i < backstageSet.pages.length; i++)
		                this._checkBackstageTabOrder(backstageSet.pages[i], i);
		        }
		        if (!ej.isNullOrUndefined(backstageSet.headerWidth)) {
		            backStageTopContent.css("width", backstageSet.headerWidth);
		            backStageUl.css("width", backstageSet.headerWidth);
		        }
		    }
		    if (this.model.enableOnDemand && this._phoneMode) {
		        backstage = this.element.find(".e-responsivebackstage");
		        backstagePage = this.element.find(".e-ribbonbackstagepage");
		        if (this._tabUl.find(".e-backstagetab").length > 0 && backstage.length == 1) {
		            var backstagecontent = backstagePage.find(".e-ribbonbackstagebody .e-backstageheader");
		            backstage.append(backstagecontent).addClass("e-reshide");
		        }
		    }
		},
	    _addBackStageTabCont: function (backstageSet,backStageBody,i) {
		  var content = ej.buildTag("div#" + this._id + "_BackStage_" + backstageSet.pages[i].id.replace(/\s/g, '')).addClass('e-backstagecontent').css({ "width": "auto" });
          if (i > 0)
            content.hide();
	        if (backstageSet.pages[i].contentID && !this.model.enableOnDemand) {
	            backStageTitleContent = ej.buildTag("div#" + this._id + "_BackStageTitleContent").addClass('e-backstagetitlecontent').appendTo($(content));
	            $(backStageTitleContent).text('').append(backstageSet.pages[i].text);
	            $(content).append($('#' + backstageSet.pages[i].contentID).addClass('e-backstagetabarea').show());
	        }
	        backStageBody.append(content);
		},
		_removeBackStageTabCont: function (tab) {
		   tab.find('.e-backstagetabarea').removeClass('e-backstagetabarea').appendTo('body');
		   tab.remove();
		 },
        _conTabsRemove: function () {
            var cntxTabs = this.element.find(".e-contextli,.e-contextliset"), $cntxTab;
            var cntxTabLen = cntxTabs.length;
            for (var i = 0; i < cntxTabLen; i++) {
                $cntxTab = $(cntxTabs[i]);
                $cntxTab.is(":visible") ? $cntxTab.find("li").insertAfter($cntxTab.eq(0)) : $cntxTab.find("li").hide().insertAfter($cntxTab.eq(0));
                $cntxTab.remove();
            }
        },
        _contextualTabs: function () {
            var curcontextualTabSet, li, ul;
            if (this.model.contextualTabs) {
                var contextTabLen = this.model.contextualTabs.length;
                for (var i = 0; i < contextTabLen; i++) {
                    curcontextualTabSet = this.model.contextualTabs[i];
                    if (curcontextualTabSet.tabs.length > 0) {
                        li = ej.buildTag("li#e-contextlisetIn_" + i).addClass("e-contextliset");
                        this._contextualTabSet = this._tabUl.children('.e-contextualtabset').filter(function (index) { return $(this).text() === curcontextualTabSet.tabs[0].text; });
                        this._contextualTabSet.before(li);
                        this._tabUl.children('.e-contextualtabset').find('a').css("color", curcontextualTabSet.borderColor);
                        ul = ej.buildTag("ul.e-contextual", "", {
                            'background': curcontextualTabSet.backgroundColor,
                            'border-top-color': curcontextualTabSet.borderColor
                        });
                        var contexttualTabLen = curcontextualTabSet.tabs.length;
                        for (var j = 0; j < contexttualTabLen; j++) {
                            ul.append(this._tabUl.children('.e-contextualtabset').filter(function (index) {
                                return $(this).text() ===
                                curcontextualTabSet.tabs[j].text;
                            }));
                        }
                        ul.appendTo(li);
                    }
                }
            }
        },
        addBackStageItem: function (pageitem, index) {
            var pageIndex = this.model.applicationTab.backstageSettings.pages.length;
            if (!ej.isNullOrUndefined(index))
                pageIndex = index;
            this.model.applicationTab.backstageSettings.pages.splice(pageIndex, 0, pageitem);
            this._initial = false;
            this._customization();
            if (this._phoneMode) {
                backstagePage = this.element.find(".e-ribbonbackstagepage");
                if (backstagePage.find(".e-ribbonbackstagebody .e-backstagecontent").length > 0)
                    this.element.find(".e-responsivebackstagecontent .e-resbackstagecontent").append(backstagePage.find(".e-ribbonbackstagebody .e-backstagecontent"));
            }
        },
		_checkBackstageTabOrder: function (pageitem, index) {
		 var curTabLi=this.element.find("#"+pageitem.id+"_backStageTab");
		 if(curTabLi.length==0)
		  curTabLi=this.element.find("#"+pageitem.id+"_backStageBtn");
		 if(curTabLi.index()!=index)
		  {
			var target=this.element.find(".e-backstageli").eq(index);
			if(pageitem.enableSeparator && curTabLi.next().hasClass('e-backstageseparator'))
			  target=curTabLi.next().insertBefore(target);
			curTabLi.insertBefore(target);
		    this.element.find("#"+this._id+"_BackStage_"+pageitem.id).insertBefore(this.element.find(".e-backstagecontent").eq(index));
		  }
		},
        removeBackStageItem: function (index) {
            var id, pageId;
            id = this.model.applicationTab.backstageSettings.pages[index].id;
            pageId = "#" + this._id + "_BackStage" + "_" + id;
            this.model.applicationTab.backstageSettings.pages.splice(index, 1);
            if (this.element.find(pageId).hasClass('e-backstagecontent'))
                this.element.find(pageId).remove();
            $(this.element.find('.e-backstageli')[index]).remove();
            this.hideBackstage();
        },
        updateBackStageItem: function (index, pageitem) {
            $.extend(this.model.applicationTab.backstageSettings.pages[index], pageitem)
            this._initial = false;
            this._customization();
            if(this._phoneMode){
                backstagePage = this.element.find(".e-ribbonbackstagepage");
                if (backstagePage.find(".e-ribbonbackstagebody .e-backstagecontent").length > 0)
                    this.element.find(".e-responsivebackstagecontent .e-resbackstagecontent").append(backstagePage.find(".e-ribbonbackstagebody .e-backstagecontent"));
            }
        },
        showContextualTab: function (text) {
            this.element.find(".e-contexttitle").filter(function (index) { return $(this).text() === text; }).parent().parent().show();
        },
        hideContextualTab: function (text) {
            this.element.find(".e-contexttitle").filter(function (index) { return $(this).text() === text; }).parent().parent().hide();
            this._tabObj.option({ selectedItemIndex: this._tabObj.model.selectedItemIndex + 1 });
        },
        _createQAT: function () {
            if (this.model.showQAT && (!ej.isNullOrUndefined(this.model.qatItems) || this.element.find(".e-rbnquickaccessbar").children().length == 0)) {
                if (this.model.enableOnDemand) {
                    if (!ej.isNullOrUndefined(this.model.tabs))
                        this._createCollapseQuickaccess(this.model.tabs);
                    if (!ej.isNullOrUndefined(this.model.contextualTabs))
                        for (var i = 0; i < this.model.contextualTabs.length; i++)
                            this._createCollapseQuickaccess(this.model.contextualTabs[i].tabs);
                }
                if (this.model.showQAT && !ej.isNullOrUndefined(this.model.qatItems))
                    this._createCollapseQuickaccess();
            }
            this._createQuickAccessBar();
        },
        _createCollapseQuickaccess: function (tabs) {
            if (!ej.isNullOrUndefined(tabs) && (!ej.isNullOrUndefined(this.model.qatItems) || this.element.find(".e-rbnquickaccessbar").children().length == 0)) {
                for (var i = 0; i < tabs.length; i++) {
                    if (!ej.isNullOrUndefined(tabs[i].groups))
                        for (var j = 0; j < tabs[i].groups.length; j++) {
                            if (!ej.isNullOrUndefined(tabs[i].groups[j].content))
                                for (var k = 0; k < tabs[i].groups[j].content.length; k++) {
                                    var subGroup = tabs[i].groups[j].content[k].groups;
                                    var defaults = tabs[i].groups[j].content[k].defaults;
                                    tabs[i].groups[j].content[k].defaults;
                                    this._createqatItems(subGroup, defaults)
                                }
                        }

                }
            }
            else
                this._createqatItems(this.model.qatItems)
        },
        _createqatItems: function (subGroup, defaults) {
            if (this.model.showQAT && (!ej.isNullOrUndefined(this.model.qatItems) || this.element.find(".e-rbnquickaccessbar").children().length == 0))
                var qatOrder = ej.buildTag('div#' + this._id + "order");
            var qatControls = [];
            for (var m = 0; m < subGroup.length; m++) {
                if (!ej.isNullOrUndefined(subGroup[m])) {
                    if (!ej.isNullOrUndefined(defaults)) {
                        if (!ej.isNullOrUndefined(defaults.type))
                            subGroup[m].type = defaults.type;
                    }
                    if (ej.isNullOrUndefined(subGroup[m].type))
                        subGroup[m].type = ej.Ribbon.Type.Button;
                    if (ej.isNullOrUndefined(subGroup[m].isBig) && !ej.isNullOrUndefined(defaults))
                        subGroup[m].isBig = defaults.isBig;
                    var buttonDef = this.model.buttonDefaults;
                    if (ej.isNullOrUndefined(subGroup[m].height)) {
                        var btnHeight;
                        if (!ej.isNullOrUndefined(subGroup[m].buttonSettings) && !ej.isNullOrUndefined(subGroup[m].buttonSettings.height))
                            btnHeight = subGroup[m].buttonSettings.height;
                        else if (!ej.isNullOrUndefined(defaults) && !ej.isNullOrUndefined(defaults.height))
                            btnHeight = defaults.height;
                        else if (!ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.height))
                            btnHeight = buttonDef.height;
                        subGroup[m].height = btnHeight;
                        btnHeight = null;
                    }
                    if (ej.isNullOrUndefined(subGroup[m].width)) {
                        var btnWidth;
                        if (!ej.isNullOrUndefined(subGroup[m].buttonSettings) && !ej.isNullOrUndefined(subGroup[m].buttonSettings.width))
                            btnWidth = subGroup[m].buttonSettings.width;
                        else if (!ej.isNullOrUndefined(defaults) && !ej.isNullOrUndefined(defaults.width))
                            btnWidth = defaults.width;
                        else if (!ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.width))
                            btnWidth = buttonDef.width;
                        subGroup[m].width = btnWidth;
                        btnWidth = null;
                    }
                    if (!ej.isNullOrUndefined(subGroup[m].buttonSettings)) {
                        var buttonSet = subGroup[m].buttonSettings;
                        if (ej.isNullOrUndefined(buttonSet.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                            buttonSet.enabled = buttonDef.enabled;
                        if (ej.isNullOrUndefined(buttonSet.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                            buttonSet.enableRTL = buttonDef.enableRTL;
                        if (ej.isNullOrUndefined(buttonSet.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                            buttonSet.cssClass = buttonDef.cssClass;
                        if (ej.isNullOrUndefined(buttonSet.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                            buttonSet.showRoundedCorner = buttonDef.showRoundedCorner;
                    }
                    if (!ej.isNullOrUndefined(subGroup[m].splitButtonSettings)) {
                        var splitButtonSet = subGroup[m].splitButtonSettings;
                        if (ej.isNullOrUndefined(splitButtonSet.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                            splitButtonSet.enabled = buttonDef.enabled;
                        if (ej.isNullOrUndefined(splitButtonSet.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                            splitButtonSet.enableRTL = buttonDef.enableRTL;
                        if (ej.isNullOrUndefined(splitButtonSet.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                            splitButtonSet.cssClass = buttonDef.cssClass;
                        if (ej.isNullOrUndefined(splitButtonSet.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                            splitButtonSet.showRoundedCorner = buttonDef.showRoundedCorner;
                    }
                    if (!ej.isNullOrUndefined(subGroup[m].toggleButtonSettings)) {
                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                            subGroup[m].toggleButtonSettings.enabled = buttonDef.enabled;
                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                            subGroup[m].toggleButtonSettings.enableRTL = buttonDef.enableRTL;
                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                            subGroup[m].toggleButtonSettings.cssClass = buttonDef.cssClass;
                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                            subGroup[m].toggleButtonSettings.showRoundedCorner = buttonDef.showRoundedCorner;
                    }
                    if (ej.isNullOrUndefined(subGroup[m].quickAccessMode))
                        subGroup[m].quickAccessMode = "none";
                    switch (subGroup[m].type) {
                        case ej.Ribbon.Type.SplitButton:
                            split = subGroup[m];
                            model = {}
                            if (split.splitButtonSettings)
                                model = JSON.parse(JSON.stringify(split.splitButtonSettings));
                            model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                            model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                            if (model.cssClass)
                                model.cssClass = model.cssClass.concat(" e-rbn-splitbtn e-rbn-button");
                            else
                                model.cssClass = "e-rbn-splitbtn e-rbn-button";
                            model.enableRTL = this.model.enableRTL;
                            if (split.quickAccessMode != "none" && this.model.showQAT) {
                                this._splitButtonQAT = ej.buildTag("button#" + this._id + "_" + split.id + "_qatEle", split.text, {}, { type: "button" }).addClass(split.cssClass);
                                var qatMainDiv = ej.buildTag("div#" + this._id + "_" + split.id + "_qatDiv", this._splitButtonQAT).addClass('e-qatooldiv');
                                qatOrder.append(qatMainDiv);
                                model.height = 30;
                                model.arrowPosition = ej.ArrowPosition.Right;
                                model.contentType = ej.ContentType.ImageOnly;
                                if (!$.isEmptyObject(split.customToolTip))
                                    qatMainDiv.mouseover({ value: split, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                else if (!ej.isNullOrUndefined(split.toolTip))
                                    qatMainDiv.attr("title", split.toolTip);
                                this._splitButtonQAT.ejSplitButton(model);
                                if (split.quickAccessMode == "menu")
                                    qatMainDiv.hide();
                                var btnText;
                                if (!ej.isNullOrUndefined(split.text))
                                    btnText = split.text;
                                else if (!ej.isNullOrUndefined(split.splitButtonSettings.text))
                                    btnText = split.splitButtonSettings.text;
                                qatControls.push({ id: split.id, text: btnText, qAccess: split.quickAccessMode });
                            }
                            break;
                        case ej.Ribbon.Type.ToggleButton:
                            toggle = subGroup[m];
                            model = {}
                            if (toggle.toggleButtonSettings)
                                model = JSON.parse(JSON.stringify(toggle.toggleButtonSettings));
                            model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                            model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                            if (toggle.quickAccessMode != "none" && this.model.showQAT) {
                                this._toggleButtonQAT = ej.buildTag("input#" + this._id + "_" + toggle.id + "_qatEle", "", "", { type: "checkbox" }).addClass(toggle.cssClass);
                                var qatMainDiv = ej.buildTag("div#" + this._id + "_" + toggle.id + "_qatDiv", this._toggleButtonQAT).addClass('e-qatooldiv e-rbn-button');
                                model.height = 30;
                                model.contentType = ej.ContentType.ImageOnly;
                                if (!$.isEmptyObject(toggle.customToolTip))
                                    qatMainDiv.mouseover({ value: toggle, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                else if (!ej.isNullOrUndefined(toggle.toolTip))
                                    qatMainDiv.attr("title", toggle.toolTip);
                                this._toggleButtonQAT.ejToggleButton(model).addClass('e-ribbonbtn');
                                qatMainDiv.find('button').addClass('e-rbn-button');
                                qatOrder.append(qatMainDiv);
                                if (toggle.quickAccessMode == "menu")
                                    qatMainDiv.hide();
                                var btnText;
                                if (!ej.isNullOrUndefined(toggle.text))
                                    btnText = toggle.text;
                                else if (!ej.isNullOrUndefined(toggle.toggleButtonSettings.defaultText))
                                    btnText = toggle.toggleButtonSettings.defaultText;
                                qatControls.push({ id: toggle.id, text: btnText, qAccess: toggle.quickAccessMode });
                            }
                            break;
                        case ej.Ribbon.Type.Button:
                            button = subGroup[m];
                            model = {}
                            if (button.buttonSettings)
                                model = JSON.parse(JSON.stringify(button.buttonSettings));
                            model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                            model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                            if (button.quickAccessMode != "none" && this.model.showQAT) {
                                if (button.buttonSettings) {
                                    if (button.buttonSettings.type)
                                        this._buttonQAT = ej.buildTag("button#" + this._id + "_" + button.id + "_qatEle", button.text, {}, { type: button.buttonSettings.type }).addClass(button.cssClass);
                                    else
                                        this._buttonQAT = ej.buildTag("button#" + this._id + "_" + button.id + "_qatEle", button.text).addClass(button.cssClass);
                                }
                                else
                                    this._buttonQAT = ej.buildTag("button#" + this._id + "_" + button.id + "_qatEle", button.text).addClass(button.cssClass);
                                var qatMainDiv = ej.buildTag("div#" + this._id + "_" + button.id + "_qatDiv", this._buttonQAT).addClass('e-qatooldiv');
                                model.height = 30;
                                model.contentType = ej.ContentType.ImageOnly;
                                if (!$.isEmptyObject(button.customToolTip))
                                    qatMainDiv.mouseover({ value: button, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                else if (!ej.isNullOrUndefined(button.toolTip))
                                    qatMainDiv.attr("title", button.toolTip);
                                this._buttonQAT.ejButton(model).addClass('e-ribbonbtn e-rbn-button');
                                qatOrder.append(qatMainDiv);
                                if (button.quickAccessMode == "menu")
                                    qatMainDiv.hide();
                                var btnText;
                                if (!ej.isNullOrUndefined(button.text))
                                    btnText = button.text;
                                else if (!ej.isNullOrUndefined(button.buttonSettings.text))

                                    btnText = button.buttonSettings.text;
                                qatControls.push({ id: button.id, text: btnText, qAccess: button.quickAccessMode });
                            }
                            break;
                    }

                }

            }
            qatOrder.children().prependTo(this._qAccessBar);
            this._qatControlsName = $.merge(qatControls, this._qatControlsName)
        },
        _resizeTabName: function (text) {
            if (!ej.isNullOrUndefined(this.model.tabs)) {
                for (var i = 0; i < this.model.tabs.length; i++) {
                    if (this.model.tabs[i].text === text) {
                        var tabIndex = $(this._tabUl.find('.e-tab')[i]);
                        return tabIndex;
                    }
                }
            }
            if (!ej.isNullOrUndefined(this.model.contextualTabs)) {
                for (var i = 0; i < this.model.contextualTabs.length; i++) {
                    for (var j = 0; j < this.model.contextualTabs[i].tabs.length; j++) {
                        if (this.model.contextualTabs[i].tabs[j].text === text) {
                            var tabIndex = $(this._tabUl.find('.e-contextliset')[i]).children().find('.e-contextualtabset').eq(j);
                            return tabIndex;
                        }
                    }
                }
            }
        },
        hideTab: function (text) {
            var index = this._tabText.map(function (index) { if ($(this).text() === text) return index; })[0], updatedindex, disLen = this._tabObj.model.disabledItemIndex.length, hide = true, conTab;
            this._width = this.element.width();
            if (ej.isNullOrUndefined(index)) {
                var tabElement = this._resizeTabName(text)
                if (this._phoneMode) {
                    tabElement = this._responsiveTabText.filter(function (index) { return $(this).text() === text; });
                    this.element.find(".e-responsivetabheader").addClass("e-resshow");
                }
                if (!ej.isNullOrUndefined(tabElement))
                    tabElement.hide();
            }
            var hiddenTabId = this.element.find('.e-link').eq(index).attr('href');
            conTab = this._tabText.filter(function (index) { return $(this).text() === text; }).parents(".e-contextualtabset");
            for (var i = 0; i < disLen; i++) {
                if (this._tabObj.model.disabledItemIndex[i] === index)
                    hide = false;
            }
            if (hide) {
                if (conTab.length > 0) {
                    conTab.hide();
                    this._responsiveTabText.eq(!ej.isNullOrUndefined(this.model.applicationTab) ? index - 1 : index).hide();
                }
                else {
                    this._tabText.filter(function (index) { return $(this).text() === text; }).parent().hide();
                    this._responsiveTabText.eq(!ej.isNullOrUndefined(this.model.applicationTab) ? index - 1 : index).hide();
                }
                if ($(hiddenTabId).hasClass('e-active-content')) {
                    $(hiddenTabId).hide();
                    $(hiddenTabId).removeClass('e-active-content');
                }
            }
            if (this._tabUl.find('.e-active').is(':hidden')) {
                if (this._phoneMode) {
                    this.element.find(".e-responsivetabheader").addClass("e-resshow");
                    updatedindex = this._getVisibleItemIndex(this._responsiveTabText);
                }
                else
                    updatedindex = this._getVisibleItemIndex(this._tabText);
                if (updatedindex) {
                    var currentTab = this.element.find('.e-link').eq(updatedindex).attr('href');
                    if ($(this._tabText[updatedindex]).parent().hasClass('e-disable')) {
                        $(this._tabText[index]).parent().removeClass('e-active');
                        $(this._tabText[updatedindex]).parent().addClass('e-active')
                        $(currentTab).append(this.element.find("#" + this._id + "_disabled"));
                        $(currentTab).css("position", "relative");
                        this.element.find("#" + this._id + "_disabled").show();
                        $(currentTab).show();
                        this._tabObj.option("selectedItemIndex", updatedindex);
                    }
                    else
                        this._tabObj.option("selectedItemIndex", updatedindex);
                    this._tabObj.model.selectedItemIndex = updatedindex;
                    this.model.selectedItemIndex = updatedindex;
                }
            }
            if (this.element.hasClass("e-responsive"))
                this.element.find(".e-responsivetabheader").removeClass("e-resshow");
        },

        showTab: function (text) {
            var index = this._tabText.map(function (index) { if ($(this).text() === text) return index; })[0], conTab;
            if (ej.isNullOrUndefined(index)) {
                var tabElement = this._resizeTabName(text)
                if (this._phoneMode) {
                    tabElement = this._responsiveTabText.filter(function (index) { return $(this).text() === text; });
                    this.element.find(".e-responsivetabheader").addClass("e-resshow");
                }
                if (!ej.isNullOrUndefined(tabElement))
                    tabElement.show();
            }
            var Tab = this._tabText.filter(function (index) { return $(this).text() === text; }).parent();
            conTab = this._tabText.filter(function (index) { return $(this).text() === text; }).parents(".e-contextualtabset");
            if (conTab.length > 0) {
                conTab.show();
                this._responsiveTabText.eq(!ej.isNullOrUndefined(this.model.applicationTab) ? index - 1 : index).show();
            }
            else {
                this._tabText.filter(function (index) { return $(this).text() === text; }).parent().show();
                this._responsiveTabText.eq(!ej.isNullOrUndefined(this.model.applicationTab) ? index - 1 : index).show();
            }
			var tabContent = this.element.find(".e-content").eq(index);
            if (!Tab.hasClass('e-active'))
                Tab.addClass('e-select');
			else if(tabContent.css("display") == "none")
			    tabContent.show();
            if (this.element.hasClass("e-responsive"))
                this.element.find(".e-responsivetabheader").removeClass("e-resshow");
        },
        hideGroups: function (tabId, groupText) {
            if (typeof groupText == "string")
                $("#" + this._id + "_" + tabId + "_" + groupText).hide();
            else {
                for (var i = 0; i < groupText.length; i++) {
                    $("#" + this._id + "_" + tabId + "_" + groupText[i]).hide();
                }
            }
        },
        showGroups: function (tabId, groupText) {
            if (typeof groupText == "string")
                $("#" + this._id + "_" + tabId + "_" + groupText).show();
            else {
                for (var i = 0; i < groupText.length; i++) {
                    $("#" + this._id + "_" + tabId + "_" + groupText[i]).show();
                }
            }
        },
        hideGroupItems: function (tabId, groupText, subGroupId) {
            if (typeof subGroupId == "string")
                $("#" + this._id + "_" + tabId + "_" + groupText + "_" + subGroupId).hide();
            else {
                for (var i = 0; i < subGroupId.length; i++) {
                    $("#" + this._id + "_" + tabId + "_" + groupText + "_" + subGroupId[i]).hide();
                }
            }

        },
        showGroupItems: function (tabId, groupText, subGroupId) {
            if (typeof subGroupId == "string")
                $("#" + this._id + "_" + tabId + "_" + groupText + "_" + subGroupId).show();
            else {
                for (var i = 0; i < subGroupId.length; i++) {
                    $("#" + this._id + "_" + tabId + "_" + groupText + "_" + subGroupId[i]).show();
                }
            }
        },
        _getVisibleItemIndex: function (items) {
            var i = 1;
            while (i < items.length) {
                if ($(items[i]).is(":visible"))
                    return i;
                i++;
            }
        },
        removeApplicationTab:function(){
		 this._ribbonTabs = this._tabUl.find(".e-link").parent();
                    href = this._ribbonTabs.eq(0).children().attr("href");
                    curTab = this._ribbonTabs.eq(0);
					if(curTab.hasClass("e-apptab"))
					{
				     this._tabObj.contentPanels.splice(0,1);
				     this._tabObj.items.splice(0,1);
					 this._tabObj.selectedItemIndex(this._tabObj.model.selectedItemIndex-1);
					 curTab.remove();
					 $(href).remove();
					 $(this._tabUl.find(".e-link").parent('.e-active')).find('a').addClass("e-removeapptab");
					 var tabLi=this._tabUl.find('li').eq(0);
					 if(!tabLi.hasClass('e-disable') && !tabLi.hasClass('e-apptab'))
					  {
					   this._tabObj.option({ enabledItemIndex: [0] });
					   this.model.disabledItemIndex.splice(0);
					  }
					  this.element.addClass('e-ribwithout-apptab');
					  this._ribbonWindowResize();
					}
		},
        removeTab: function (tabIndex) {
            var curTab, href, args, expandCollapse;
            if (this._tabObj.model) {
                if (tabIndex > 0) {
                    args = { index: tabIndex };
                    this._trigger("beforeTabRemove", args);
                    this._ribbonTabs = this._tabUl.find(".e-link").parent();
                    href = this._ribbonTabs.eq(tabIndex).children().attr("href");
                    curTab = this._ribbonTabs.eq(tabIndex);
                    if (this._phoneMode) curResTab = this._responsiveTabText.eq(tabIndex - 1);
                    if (curTab.hasClass("e-contextualtab"))
                        curTab.parent().remove();
                    else if (curTab.hasClass("e-contextualtabset")) {
                        if (curTab.siblings('.e-contextualtabset').length === 0)
                            curTab.parent().remove();
                        else
                            curTab.remove();
                    }
                    else
                        curTab.remove();
                    if (this._phoneMode) curResTab.remove();
                    this._responsiveTabText = this.element.find(".e-responsivetabheader li");
                    expandCollapse = this.element.find(".e-expandcollapse");
                    $(href).remove();
                    this._ribbonTabs = this._tabUl.find(".e-link").parent();
                    if (this._tabObj.model.selectedItemIndex === tabIndex) {
                        curTab = this._ribbonTabs.eq(tabIndex);
                        if (this._phoneMode) {
                            curResTab = this._responsiveTabText.eq(tabIndex - 1);
                            curResTab.addClass("e-resactive");
                            this.element.find(".e-ribresmenu .e-reslink").text(this._responsiveTabText.filter(".e-resactive").text());
                        }
                        curTab.addClass("e-active");
                        href = curTab.children().attr("href");
                        $(href).append(expandCollapse.click($.proxy(this._tabExpandCollapse, this)));
                        $(href).addClass("e-active-content e-activetop").show();
                    }
                    if (this._isCollapsed)
                        this.element.find(this._ribbonTabs.eq(tabIndex).children().attr("href")).append(expandCollapse.click($.proxy(this._tabExpandCollapse, this)));
                    this._tabObj.contentPanels.splice(tabIndex, 1);
                    this._tabObj.items.splice(tabIndex, 1);
					this.model.tabs.splice(tabIndex-1,1);
                    if (this._phoneMode) {
                        this._mobileContents.splice(tabIndex - 1, 1);
                        this._mobileToolbar.splice(tabIndex - 1, 1);
                        this._ribbonWindowResize();
                    }
                    args = { removedIndex: tabIndex };
                    this._trigger("tabRemove", args);
                }
            }
        },
        removeTabGroup: function (tabIndex, groupText) {
            var tabGroup, curTab, curGrp, conTabIndex, conTabGrp;
            tabGroup = $($('.e-ribbon .e-content')[tabIndex]).find('.e-groupdiv');
            curTab = this._tabUl.find('.e-select,.e-active').eq(tabIndex);
            if ($(curTab).hasClass('e-tab')) {
                curGrp = this.model.tabs[tabIndex - 1].groups;
                for (i = 0; i < curGrp.length; i++) {
                    if (curGrp[i].text == groupText) {
                        curGrp.splice(i, 1);
                        $(tabGroup[i]).remove();
                    }
                    else if (ej.isNullOrUndefined(groupText))
                        $(tabGroup[i]).remove();
                }
            }
            else {
                conTabIndex = this.model.tabs.length;
                var contextTabsLen = this.model.contextualTabs.length;
                for (var i = 0; i < this.model.contextualTabs.length; i++) {
                    var contextualTabsLen = this.model.contextualTabs[i].tabs.length;
                    for (var j = 0; j < contextualTabsLen; j++) {
                        ++conTabIndex;
                        if (conTabIndex === tabIndex) {
                            conTabGrp = this.model.contextualTabs[i].tabs[j].groups;
                            var contTabGrpLen=conTabGrp.length;
                            for (var k = 0; k < contTabGrpLen; k++) {
                                if (conTabGrp[k].text == groupText) {
                                    conTabGrp.splice(k, 1);
                                    $(tabGroup[k]).remove();
                                }
                                else if (ej.isNullOrUndefined(groupText))
                                    $(tabGroup[k]).remove();
                            }
                        }
                    }
                }
            }
        },
        _addTabGrpIntoCollec: function (ribTabs,tabGroup,grpIndex) {
           var grpCheck=tabGroup.length,gIndex=grpIndex;
           if($.isPlainObject(tabGroup))
             grpCheck=1;
           for(var v=0;v<grpCheck;v++){
		     var grp=tabGroup;
             if(!$.isPlainObject(tabGroup)){
              grp= tabGroup[v];
			  if(v>0)
			   ++gIndex;
			   }
              ribTabs.groups.splice(gIndex, 0, grp);
            }
           return ribTabs;
        },
        addTabGroup: function (tabIndex, tabGroup, grpIndex) {
            var tabContent, conTabIndex = 0, grpLen = 0, tabs, curTab, tabGroupText, contDiv, groupDiv;
            curTab = this._tabUl.find('.e-select,.e-active').eq(tabIndex);
            tabContent = curTab.children('a').attr('href');
            if ($(curTab).hasClass('e-tab')) {
                var tabsLen = this.model.tabs.length;
                for (var i = 0; i < tabsLen; i++) {
                    if (i === tabIndex - 1) {
                        grpLen = this.model.tabs[i].groups.length;
                        if (ej.isNullOrUndefined(grpIndex))
                            grpIndex = grpLen;
                        tabs = this._addTabGrpIntoCollec(this.model.tabs[i],tabGroup,grpIndex);
                    }
                }
            }
            else {
                conTabIndex = this.model.tabs.length;
                var contextTabsLen = this.model.contextualTabs.length;
                for (var i = 0; i < contextTabsLen; i++) {
                    var contextualTabsLen = this.model.contextualTabs[i].tabs.length;
                    for (var j = 0; j < contextualTabsLen; j++) {
                        ++conTabIndex;
                        if (conTabIndex === tabIndex) {
                            grpLen = this.model.contextualTabs[i].tabs[j].groups.length;
                            if (ej.isNullOrUndefined(grpIndex))
                                grpIndex = grpLen;
                            tabs = this._addTabGrpIntoCollec( this.model.contextualTabs[i].tabs[j],tabGroup,grpIndex);
                        }
                    }
                }
            }
            if (!ej.isNullOrUndefined(tabs.groups[grpIndex]) && (!this.element.find(".e-content.e-content-item").eq(tabIndex).hasClass("e-rbn-ondemand"))) {
			  var grpCheck=tabGroup.length,gIndex=grpIndex;
              if($.isPlainObject(tabGroup))
               grpCheck=1;
              for(var v=0;v<grpCheck;v++){
               if(!$.isPlainObject(tabGroup) && v>0)
                ++gIndex;
               tabGroupText = ej.isNullOrUndefined(tabs.groups[gIndex].id) ? (ej.isNullOrUndefined(tabs.groups[gIndex].text) ? tabs.groups[gIndex].text : tabs.groups[gIndex].text.replace(/\s/g, '')) : tabs.groups[gIndex].id.replace(/\s/g, ''); 
               contDiv = this._createControls(gIndex, tabs, tabGroupText, tabIndex);
               groupDiv = this._addControlsToGroup(gIndex, tabs, tabGroupText, contDiv);
               if ($(tabContent).children().eq(gIndex).length > 0)
                $(tabContent).children().eq(gIndex).before(groupDiv);
               else
                $(tabContent).append(groupDiv);
              }
			  if($(tabContent).hasClass('e-empty-content'))
               $(tabContent).removeClass('e-empty-content');
             }
            if(!$(tabContent).hasClass('e-parentdiv'))
             $(tabContent).addClass('e-parentdiv');
            this._setTabContentHeight();
        },

        addTabGroupContent: function (tabIndex, grpIndex, content, contentIndex, subGrpIndex) {
            var tabContent, conTabIndex = 0, tabs, curTab, tabGroupText, contDiv, grpContent, subGroup, separator, grpContentDiv, grpHeight, alignType, isNewGroup = false, contInnerDiv;
            curTab = this._tabUl.find('.e-select,.e-active').eq(tabIndex);
            tabContent = curTab.children('a').attr('href');
            if (ej.isNullOrUndefined(contentIndex))
                contentIndex = 0;
            if (ej.isNullOrUndefined(subGrpIndex)) subGrpIndex = 0;
            if (curTab.hasClass('e-tab')) {
                var tabsLen = this.model.tabs.length;
                for (var i = 0; i < tabsLen; i++)
                    if (i === tabIndex - 1)
                        if (!ej.isNullOrUndefined(this.model.tabs[i].groups[grpIndex].content)) {
                            alignType = this.model.tabs[i].groups[grpIndex].alignType;
                            if (contentIndex == 0 || !ej.isNullOrUndefined(this.model.tabs[i].groups[grpIndex].content[contentIndex - 1])) {
                                if (ej.isNullOrUndefined(this.model.tabs[i].groups[grpIndex].content[contentIndex])) {
                                    this.model.tabs[i].groups[grpIndex].content[contentIndex] = content;
                                    isNewGroup = true;
                                }
                                else
                                    this.model.tabs[i].groups[grpIndex].content[contentIndex].groups.splice(subGrpIndex, 0, content);
                                tabs = this.model.tabs[i];
                            }
                        }
            }
            else {
                conTabIndex = this.model.tabs.length;
                var contextTabsLen = this.model.contextualTabs.length;
                for (var i = 0; i < contextTabsLen; i++) {
                    var contextualTabsLen = this.model.contextualTabs[i].tabs.length;
                    for (var j = 0; j < contextualTabsLen; j++) {
                        ++conTabIndex;
                        if (conTabIndex === tabIndex)
                            if (!ej.isNullOrUndefined(this.model.contextualTabs[i].tabs[j].groups[grpIndex].content)) {
                                alignType = this.model.contextualTabs[i].tabs[j].groups[grpIndex].alignType
                                if (ej.isNullOrUndefined(contentIndex))
                                    contentIndex = this.model.contextualTabs[i].tabs[j].groups[grpIndex].content[0].groups.length;
                                if (contentIndex == 0 || !ej.isNullOrUndefined(this.model.contextualTabs[i].tabs[j].groups[grpIndex].content[contentIndex - 1])) {
                                    if (ej.isNullOrUndefined(this.model.contextualTabs[i].tabs[j].groups[grpIndex].content[contentIndex])) {
                                        this.model.contextualTabs[i].tabs[j].groups[grpIndex].content[contentIndex] = content;
                                        isNewGroup = true;
                                    }
                                    else
                                        this.model.contextualTabs[i].tabs[j].groups[grpIndex].content[contentIndex].groups.splice(subGrpIndex, 0, content);
                                    tabs = this.model.contextualTabs[i].tabs[j];
                                }
                            }
                    }
                }
            }
            if (!ej.isNullOrUndefined(tabs) && !ej.isNullOrUndefined(tabs.groups[grpIndex]) && (!this.element.find(".e-content.e-content-item").eq(tabIndex).hasClass("e-rbn-ondemand"))) {
                tabGroupText = ej.isNullOrUndefined(tabs.groups[grpIndex].id) ?  (ej.isNullOrUndefined(tabs.groups[grpIndex].text) ? tabs.groups[grpIndex].text : tabs.groups[grpIndex].text.replace(/\s/g, '')): tabs.groups[grpIndex].id.replace(/\s/g, ''); 
                contDiv = this._createControls(grpIndex, tabs, tabGroupText, tabIndex);
                grpContentDiv = ej.buildTag("div");
                contInnerDiv = contDiv.find(".e-innerdiv,.e-innerdivrow").eq(contentIndex).find(".e-controlpadding");
                grpContent = isNewGroup ? contInnerDiv : contInnerDiv.eq(subGrpIndex);
                separator = contDiv.find("#" + grpContent.attr("id")).next();
                if (separator.hasClass("e-separatordivrow"))
                    grpContentDiv.append(separator);
                grpContentDiv.prepend(grpContent);
                subGroup = $(tabContent).children().eq(grpIndex).find(".e-innerdiv,.e-innerdivrow").eq(contentIndex);
                if (!subGroup.length > 0) {
                    var div;
                    if (alignType == ej.Ribbon.alignType.columns)
                        div = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + (contentIndex + 1)).addClass("e-innerdiv");
                    else
                        div = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + (contentIndex + 1)).addClass("e-innerdivrow");
                    $(tabContent).children().eq(grpIndex).find(".e-ribGroupContent").append(div);
                    subGroup = $(tabContent).children().eq(grpIndex).find(".e-innerdiv,.e-innerdivrow").eq(contentIndex);
                }
                grpHeight = $(subGroup).parent().height();
                if (subGroup.find(".e-controlpadding").eq(subGrpIndex).length > 0)
                    subGroup.find(".e-controlpadding").eq(subGrpIndex).before(grpContentDiv.children());
                else
                    subGroup.append(grpContentDiv.children());
                if ($(subGroup).parent().height() > grpHeight)
                    this.element.find(".e-content").height(this.element.find(".e-content").height() + ($(subGroup).parent().height() - grpHeight));
                contDiv.children().remove();
			    if($(tabContent).hasClass('e-empty-content'))
                 $(tabContent).removeClass('e-empty-content');
                this._setTabContentHeight();
            }
        },
        removeTabGroupContent: function (tabIndex, groupText, contentIndex, subGrpIndex) {
            var tabGroup, curTab, curGrp, conTabIndex, conTabGrp, conLegth, tabContent, conDiv, innerDiv;
            tabGroup = $($('.e-ribbon .e-content')[tabIndex]).find('.e-groupdiv');
            curTab = this._tabUl.find('.e-select,.e-active').eq(tabIndex);
            tabContent = curTab.children('a').attr('href');
            if ($(curTab).hasClass('e-tab')) {
                curGrp = this.model.tabs[tabIndex - 1].groups;
                var curGrpLen = curGrp.length;
                for (i = 0; i < curGrpLen; i++) {
                    if (curGrp[i].text == groupText) {
                        if (!ej.isNullOrUndefined(contentIndex)) {
                            if (!ej.isNullOrUndefined(subGrpIndex) && !ej.isNullOrUndefined(curGrp[i].content[contentIndex].groups)) {
                                conTabGrp = curGrp[i].content[contentIndex].groups;
                                innerDiv = $(tabContent).children(".e-groupdiv").eq(i).find(".e-innerdiv,.e-innerdivrow");
                                if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                    innerDiv = this.element.find(".e-responsivecontent").find(".e-innerdiv,.e-innerdivrow");
                                }
                                conDiv = innerDiv.eq(contentIndex);
                                for (j = 0; j < conDiv.children().length; j++) {
                                    conTabGrp.splice(j, 1);
                                }
                                conDiv.children().eq(subGrpIndex).remove();
                                if (innerDiv.children().length == 0) {
                                    innerDiv.remove();
                                }
                            }
                            else {
                                conTabGrp = curGrp[i].content[contentIndex];
                                innerDiv = $(tabContent).children(".e-groupdiv").eq(i).find('.e-innerdiv,.e-innerdivrow');
                                if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                    innerDiv = this.element.find(".e-responsivecontent").find(".e-innerdiv,.e-innerdivrow");
                                }
                                innerDiv.eq(contentIndex).children().remove();
                                conTabGrp.groups.splice(0, conTabGrp.groups.length);
                            }
                        }
                        else if (curGrp[i].type === ej.Ribbon.type.custom && curGrp[i].text == groupText && ej.isNullOrUndefined(curGrp[i].content)) {
                            innerDiv = $(tabContent).find(".e-groupdiv").eq(i).find(".e-ribGroupContent");
                            if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                innerDiv = this.element.find(".e-responsivecontent").find(".e-ribGroupContent");
                            }
                            innerDiv.children().remove();
                            curGrp[i].contentID = null;
                        }
                        else if (curGrp[i].text == groupText && ej.isNullOrUndefined(contentIndex)) {
                            conTabGrp = curGrp[i].content;
                            if (!ej.isNullOrUndefined(conTabGrp)) {
                                conlen = curGrp[i].content.length;
                                for (var l = 0; l < conlen; l++)
                                    conTabGrp[l].groups.splice(0, conTabGrp[l].groups.length);
                            }
                            innerDiv = $(tabContent).find(".e-groupdiv").eq(i).find(".e-ribGroupContent");
                            if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                innerDiv = this.element.find(".e-responsivecontent").find(".e-ribGroupContent");
                            }
                            innerDiv.children().remove();
                        }
                    }
                }
            }
            else {
                conTabIndex = this.model.tabs.length;
                var contextTabsLen = this.model.contextualTabs.length
                for (var i = 0; i < contextTabsLen; i++) {
                    var contextualTabsLen = this.model.contextualTabs[i].tabs.length
                    for (var j = 0; j < contextualTabsLen; j++) {
                        ++conTabIndex;
                        if (conTabIndex === tabIndex) {
                            conTabGrp = this.model.contextualTabs[i].tabs[j].groups;
                            var conTabGrpLen = conTabGrp.length;
                            for (var k = 0; k < conTabGrpLen; k++) {
                                if (conTabGrp[k].text == groupText) {
                                    if (!ej.isNullOrUndefined(contentIndex)) {
                                        if (!ej.isNullOrUndefined(subGrpIndex) && !ej.isNullOrUndefined(conTabGrp[k].content[contentIndex].groups)) {
                                            contTabGrp = conTabGrp[k].content[contentIndex].groups;
                                            innerDiv = $(tabContent).children(".e-groupdiv").eq(k).find(".e-innerdiv,.e-innerdivrow");
                                            if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                                innerDiv = this.element.find(".e-responsivecontent").find(".e-innerdiv,.e-innerdivrow");
                                            }
                                            conDiv = innerDiv.eq(contentIndex);
                                            for (m = 0; m < conDiv.children().length; m++) {
                                                contTabGrp.splice(m, 1);
                                            }
                                            conDiv.children().eq(subGrpIndex).remove();
                                            if (innerDiv.children().length == 0)
                                                innerDiv.remove();
                                        }
                                        else {
                                            contTabGrp = conTabGrp[k].content[contentIndex];
                                            innerDiv = $(tabContent).children(".e-groupdiv").eq(k).find('.e-innerdiv,.e-innerdivrow');
                                            if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                                innerDiv = this.element.find(".e-responsivecontent").find(".e-innerdiv,.e-innerdivrow");
                                            }
                                            innerDiv.eq(contentIndex).children().remove();
                                            contTabGrp.groups.splice(0, contTabGrp.groups.length);
                                        }
                                    }
                                    else if (conTabGrp[k].type === ej.Ribbon.type.custom && conTabGrp[k].text == groupText && ej.isNullOrUndefined(conTabGrp[k].content)) {
                                        innerDiv = $(tabContent).find(".e-groupdiv").eq(k).find(".e-ribGroupContent");
                                        if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                            innerDiv = this.element.find(".e-responsivecontent").find(".e-ribGroupContent");
                                        }
                                        innerDiv.children().remove();
                                        conTabGrp[k].contentID = null;
                                    }
                                    else if (ej.isNullOrUndefined(contentIndex)) {
                                        contTabGrp = conTabGrp[k].content;
                                        if (!ej.isNullOrUndefined(contTabGrp)) {
                                            conlen = conTabGrp[k].content.length;
                                            for (var l = 0; l < conlen; l++)
                                                contTabGrp[l].groups.splice(0, contTabGrp[l].groups.length);
                                        }
                                        innerDiv = $(tabContent).find(".e-groupdiv").eq(k).find(".e-ribGroupContent");
                                        if (this._phoneMode && this.element.find(".e-responsivecontent").is(":visible") && innerDiv.length == 0) {
                                            innerDiv = this.element.find(".e-responsivecontent").find(".e-ribGroupContent");
                                        }
                                        innerDiv.children().remove();
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },
        addTab: function (tabText, ribbonGroups, index) {
            var rTab = { id: tabText.replace(/\s/g, ''), text: tabText, groups: ribbonGroups }, tabLen = this.model.tabs.length, ribbonModel, newTab, tabcont, args;
            if (ej.isNullOrUndefined(index))
                index = this._tabUl.find(".e-select,.e-active").length;
            if (index > 0) {
                this._conTabsRemove();
                this._tabObj.addItem("#" + this._id + "_" + tabText.replace(/\s/g, ''), tabText, index);
                if (this._tabUl.find('.e-ribresmenu').nextAll('li.e-select').length > 0) {
                    var liTag = this._tabUl.find(".e-select,.e-active").not('.e-apptab,.e-tab');
                    liTag.insertBefore(this._tabUl.find('.e-ribresmenu'));
                }
                this._contextualTabs();
                this._tabUl.find(".e-select,.e-active").eq(index).addClass("e-tab");
                this._tabUl.find(".e-select > a,.e-active > a ").eq(index).addClass("e-link");
                if(ej.isNullOrUndefined(this.model.tabs[0].id)){
				 this.model.tabs[0]=rTab;
                 this._tabObj.showItem(1);
                }
				else
				 this.model.tabs.splice(index - 1, 0, rTab);
                for (i = 0; i < 1; i++) {
                    tabs = this.model.tabs[index - 1];
                    var tabsGrpLen = tabs.groups.length;
					if(tabsGrpLen==0)
                     this.element.find("#" + this._id + "_" + tabs.id).addClass('e-empty-content');
                    for (j = 0; j < tabsGrpLen; j++) {
                        if (!ej.isNullOrUndefined(tabs.groups[j])) {
                            var tabGroupText = ej.isNullOrUndefined(tabs.groups[j].id) ? (ej.isNullOrUndefined(tabs.groups[j].text) ? tabs.groups[j].text : tabs.groups[j].text.replace(/\s/g, '')) : tabs.groups[j].id.replace(/\s/g, ''); 
                            var contDiv = this._createControls(j, tabs, tabGroupText, index);
                            var groupDiv = this._addControlsToGroup(j, tabs, tabGroupText, contDiv);
                            tabcont = this.element.find("#" + this._id + "_" + tabs.id);
                            tabcont.append(groupDiv).addClass("e-parentdiv");
                        }
                    }
                }
                this._setTabContentHeight();
                this.element.find('.e-content.e-content-item').css("box-sizing", "content-box");
				this._ribbonTabs = this._tabUl.find(".e-link").parent();
				this._tabContents = this.element.children().attr('role', 'tabpanel').not('.e-header,.e-disable,.e-resizediv,.e-tooltipdiv,.e-ribbonbackstagepage');
                this._applicationTab.click($.proxy(this._onApplicationTabClick, this));
                newTab = this._tabUl.find(".e-select,.e-active").eq(index);
                args = { tabHeader: newTab, tabContent: tabcont };
                this._trigger("tabAdd", args);
            }
			this._tabText = this.element.find('.e-link');
            if (this._applicationTab.hasClass('e-active'))
             this._applicationTab.removeClass("e-active");
            if(!$(tabcont).hasClass('e-parentdiv'))
             $(tabcont).addClass('e-parentdiv');
        },

        addContextualTabs: function (contextualTabSet, index) {
            if (!(this._tabUl.find(".e-tab").length < index))
                return;
            var tabSetLen = this.model.contextualTabs.length, ribbonModel,contextTabSetLen;
            if (ej.isNullOrUndefined(index))
                index = this._tabUl.find(".e-select,.e-active").length;
            if (index > 0) {
                this._conTabsRemove();
                contextTabSetLen = contextualTabSet.tabs.length;
                for (var i = 0; i < contextTabSetLen; i++) {
                    if (ej.isNullOrUndefined(this._mobileContents[index - 1])) {
                        this._mobileContents[index - 1] = { "tab": contextualTabSet.tabs[i].text, "mobileContent": [] };
                        this._mobileToolbar[index - 1] = { "tab": contextualTabSet.tabs[i].text, "Content": [] };
                    }
                    else {
                        this._mobileContents.splice(index - 1, 0, { "tab": contextualTabSet.tabs[i].text, "mobileContent": [] });
                        this._mobileToolbar.splice(index - 1, 0, { "tab": contextualTabSet.tabs[i].text, "Content": [] });
                    }
                    this._tabObj.addItem("#" + this._id + "_" + contextualTabSet.tabs[i].id, contextualTabSet.tabs[i].text, index);
                    var liResTag = ej.buildTag("li", contextualTabSet.tabs[i].text).addClass("e-responsivetabli e-resContextual");
                    var check_appTab = $.isEmptyObject(this.model.applicationTab.menuSettings) && ej.isNullOrUndefined(this.model.applicationTab.menuItemID) && ej.isNullOrUndefined(this.model.applicationTab.backstageSettings.pages[0].id);
                    liResTag.insertBefore(this.element.find(".e-rescontent").children(".e-responsivetabli ").eq(index - (!check_appTab ? 1 : 0)));
                    this._responsiveTabText = this.element.find(".e-responsivetabheader li");
                    if (this._tabUl.find('.e-ribresmenu').nextAll('li.e-select').length > 0) {
                        var liTag = this._tabUl.find(".e-select,.e-active").not('.e-apptab,.e-tab');
                        liTag.insertBefore(this._tabUl.find('.e-ribresmenu'));
                    }
                    this._tabUl.find(".e-select,.e-active").eq(index).addClass("e-contextualtabset");
                    this._tabUl.find(".e-select > a ,.e-active > a ").eq(index).addClass("e-link");
                    ++index;
                }
                if (this.model.contextualTabs[0].tabs.length > 0)
                    this.model.contextualTabs.splice(index - 1, 0, contextualTabSet);
                else
                    this.model.contextualTabs[0] = contextualTabSet;
                this._contextualTabs();
                contextTabSetLen = contextualTabSet.tabs.length;
                for (i = 0; i < contextTabSetLen; i++) {
                    tabs = contextualTabSet.tabs[i];
                    var tabGrbLen = tabs.groups.length;
                    for (j = 0; j < tabGrbLen; j++) {
                        if (!ej.isNullOrUndefined(tabs.groups[j])) {
                            var tabGroupText = ej.isNullOrUndefined(tabs.groups[j].id) ? (ej.isNullOrUndefined(tabs.groups[j].text) ? tabs.groups[j].text : tabs.groups[j].text.replace(/\s/g, '')) : tabs.groups[j].id.replace(/\s/g, ''); 
                            var contDiv = this._createControls(j, tabs, tabGroupText);
                            var groupDiv = this._addControlsToGroup(j, tabs, tabGroupText, contDiv);
                            tabcont = this.element.find("#" + this._id + "_" + tabs.id);
                            tabcont.append(groupDiv).addClass("e-parentdiv");
                        }
                    }
                }
                this._setTabContentHeight();
                this.element.find('.e-content.e-content-item').css("box-sizing", "content-box");
				this._ribbonTabs = this._tabUl.find(".e-link").parent();
				this._tabContents = this.element.children().attr('role', 'tabpanel').not('.e-header,.e-disable,.e-resizediv,.e-tooltipdiv,.e-ribbonbackstagepage');
                this._applicationTab.click($.proxy(this._onApplicationTabClick, this));
            }
        },

        setTabText: function (oldText, newText) {
            this._tabText.filter(function (index) { return $(this).text() === oldText; }).text(newText);
            if (this._phoneMode) {
                this._responsiveTabText.filter(function (index) { return $(this).text() === oldText; }).text(newText);
                this.element.find(".e-ribresmenu .e-reslink").text(this._responsiveTabText.filter(".e-resactive").text());
            }
        },

        getTabText: function (index) {
            var tabText = this._tabText.eq(index).text();
            return tabText;
        },

        updateGroup: function (tabIndex, groupId, contentGroup) {
            var curTab, grp, curGroup, contDiv, tabs, tabGroupText, cntGroupId, conTabIndex,grpLen,grpConLen,conGrpLen;
            curTab = this._tabUl.find('.e-select,.e-active').eq(tabIndex);
            if ($(curTab).hasClass('e-tab')) {
                grp = this.model.tabs[tabIndex - 1].groups;
                grpLen = grp.length;
                for (var i = 0; i < grpLen; i++) {
                    if (!ej.isNullOrUndefined(grp[i].content)) {
                        grpConLen = grp[i].content.length;
                        for (var j = 0; j < grpConLen; j++) {
                            conGrpLen = grp[i].content[j].groups.length;
                            for (var k = 0; k < conGrpLen; k++) {
                                if (grp[i].content[j].groups[k].id == groupId) {
                                    var grpContent = grp[i].content[j].groups[k];
                                    if (!ej.isNullOrUndefined(contentGroup.buttonSettings)) {
                                        $.extend(grpContent.buttonSettings, contentGroup.buttonSettings);
                                        $(contentGroup).removeProp('buttonSettings');
                                    }
                                    if (!ej.isNullOrUndefined(contentGroup.dropdownSettings)) {
                                        $.extend(grpContent.dropdownSettings, contentGroup.dropdownSettings);
                                        $(contentGroup).removeProp('dropdownSettings');
                                    }
                                    if (!ej.isNullOrUndefined(contentGroup.toggleButtonSettings)) {
                                        $.extend(grpContent.toggleButtonSettings, contentGroup.toggleButtonSettings);
                                        $(contentGroup).removeProp('toggleButtonSettings');
                                    }
                                    if (!ej.isNullOrUndefined(contentGroup.splitButtonSettings)) {
                                        $.extend(grpContent.splitButtonSettings, contentGroup.splitButtonSettings);
                                        $(contentGroup).removeProp('splitButtonSettings');
                                    }
                                    if (!ej.isNullOrUndefined(contentGroup.customToolTip)) {
                                        $.extend(grpContent.customToolTip, contentGroup.customToolTip);
                                        $(contentGroup).removeProp('customToolTip');
                                    }
                                    $.extend(grpContent, contentGroup);
                                    tabGroupText = ej.isNullOrUndefined(grp[i].id) ? (ej.isNullOrUndefined(grp[i].text) ? grp[i].text : grp[i].text.replace(/\s/g, '')) : grp[i].id.replace(/\s/g, ''); 
                                    tabs = this.model.tabs[tabIndex - 1];
                                    contDiv = this._createControls(i, tabs, tabGroupText,tabIndex);
                                    cntGroupId = "#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + groupId;
                                    curGroup = this.element.find(cntGroupId);
                                    groupDiv = contDiv.find(cntGroupId);
                                    curGroup.replaceWith(groupDiv);
                                }
                            }
                        }
                    }
                }
            }
            else {
                conTabIndex = this.model.tabs.length;
                for (var m = 0; m < this.model.contextualTabs.length; m++) {
                    for (var n = 0; n < this.model.contextualTabs[m].tabs.length; n++) {
                        ++conTabIndex;
                        if (conTabIndex === tabIndex) {
                            grp = this.model.contextualTabs[m].tabs[n].groups;
                            grpLen = grp.length;
                            for (var i = 0; i < grpLen; i++) {
                                if (!ej.isNullOrUndefined(grp[i].content)) {
                                    grpConLen = grp[i].content.length;
                                    for (var j = 0; j < grpConLen; j++) {
                                        conGrpLen = grp[i].content[j].groups.length;
                                        for (var k = 0; k < conGrpLen; k++) {
                                            if (grp[i].content[j].groups[k].id == groupId) {
                                                var grpContent = grp[i].content[j].groups[k];
                                                if (!ej.isNullOrUndefined(contentGroup.buttonSettings)) {
                                                    $.extend(grpContent.buttonSettings, contentGroup.buttonSettings);
                                                    $(contentGroup).removeProp('buttonSettings');
                                                }
                                                if (!ej.isNullOrUndefined(contentGroup.dropdownSettings)) {
                                                    $.extend(grpContent.dropdownSettings, contentGroup.dropdownSettings);
                                                    $(contentGroup).removeProp('dropdownSettings');
                                                }
                                                if (!ej.isNullOrUndefined(contentGroup.toggleButtonSettings)) {
                                                    $.extend(grpContent.toggleButtonSettings, contentGroup.toggleButtonSettings);
                                                    $(contentGroup).removeProp('toggleButtonSettings');
                                                }
                                                if (!ej.isNullOrUndefined(contentGroup.splitButtonSettings)) {
                                                    $.extend(grpContent.splitButtonSettings, contentGroup.splitButtonSettings);
                                                    $(contentGroup).removeProp('splitButtonSettings');
                                                }
                                                if (!ej.isNullOrUndefined(contentGroup.customToolTip)) {
                                                    $.extend(grpContent.customToolTip, contentGroup.customToolTip);
                                                    $(contentGroup).removeProp('customToolTip');
                                                }
                                                $.extend(grpContent, contentGroup);
                                                tabGroupText = ej.isNullOrUndefined(grp[i].id) ? (ej.isNullOrUndefined(grp[i].text) ? grp[i].text : grp[i].text.replace(/\s/g, '')) : grp[i].id.replace(/\s/g, ''); 
                                                tabs = this.model.contextualTabs[0].tabs[0];
                                                contDiv = this._createControls(i, tabs, tabGroupText, tabIndex);
                                                cntGroupId = "#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + groupId;
                                                curGroup = this.element.find(cntGroupId);
                                                groupDiv = contDiv.find(cntGroupId);
                                                curGroup.replaceWith(groupDiv);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },
        isVisible: function (text) {
            var tab = this._tabText.filter(function (index) { return $(this).text() === text; }).parent();
            return (tab.is(':visible'));
        },

        isEnable: function (text) {
            var isEnable = true, tabIndex = this._tabText.filter(function (index) { return $(this).text() === text; }).parent().index();
            var disabeldItemLen = this.model.disabledItemIndex.length;
            for (var i = 0; i < disabeldItemLen; i++) {
                if (this.model.disabledItemIndex[i] == tabIndex)
                    isEnable = false;
            }
            return isEnable;
        },
        _renderTab: function () {
            var ul = ej.buildTag("ul"), li, aTag, appTab = this.model.applicationTab.type, tabs, contextualTabs, contextualTabSet, i, j, tab = this.model.tabs, tabLen = tab.length;
            if (appTab != null)
                aTag = ej.buildTag("a", "", {}, { href: "#" + this._id + "_" + appTab.replace(/\s/g, '') });
            li = ej.buildTag("li.e-apptab", aTag);
            ul.append(li);
            if (tabLen >= 1 && !ej.isNullOrUndefined(tab[0].id) && !ej.isNullOrUndefined(tab[0].text)) {
                for (i = 0; i < tabLen; i++) {
                    tabs = tab[i];
                    aTag = ej.buildTag("a", tabs.text, {}, { href: "#" + this._id + "_" + tabs.id });
                    li = ej.buildTag("li", aTag).addClass("e-tab");
                    ul.append(li);
                }
            }
            if (this.model.contextualTabs) {
                var contextTabLen = this.model.contextualTabs.length;
                for (i = 0; i < contextTabLen; i++) {
                    if (this.model.contextualTabs[i].tabs) {
                        var contextualTabLen = this.model.contextualTabs[i].tabs.length;
                        for (j = 0; j < contextualTabLen; j++) {
                            contextualTabSet = this.model.contextualTabs[i].tabs[j];
                            aTag = ej.buildTag("a", contextualTabSet.text, {}, { href: "#" + this._id + "_" + contextualTabSet.id });
                            li = ej.buildTag("li", aTag).addClass("e-contextualtabset").css('border-bottom-color',this.model.contextualTabs[i].backgroundColor);
                            ul.append(li);
                        }
                    }
                }
            }
            ul.append(ej.buildTag("li.e-ribresmenu").append(ej.buildTag("span.e-icon").addClass("e-ribdownarrow")).prepend(ej.buildTag("a#" + this._id + "_responsivelink").addClass("e-reslink")).click($.proxy(this._onResponsiveHeaderClick, this)));
            this.model.showQAT && ul.append(ej.buildTag("li#" + this._id + "_responsiveqat").addClass("e-responsiveqat").click($.proxy(this._onQatClick, this)))
            this.element.append(ul);
            this.element.ejTab({ width: this.model.width, allowKeyboardNavigation: false, disabledItemIndex: this.model.disabledItemIndex, enabledItemIndex: this.model.enabledItemIndex, enableTabScroll: false, itemActive: $.proxy(this._onTabSelect, this), beforeActive: $.proxy(this._onTabClick, this), create: $.proxy(this._create, this), selectedItemIndex: this.model.selectedItemIndex, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass });
        },
        _createControls: function (j, tabs, tabGroupText, tabIndex) {
            var innerDiv, innerDivCustom, innerDivChild, contDiv, model = {};
            var split, button, dropdown, custom, toggle, separatorDiv, tabsConLen, subGrpLen, centerAlign;
            tabGroupText = !ej.isNullOrUndefined(tabGroupText) ? tabGroupText.replace(/\&/g, '') : tabGroupText;
            contDiv = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_content").addClass('e-ribGroupContent');
            if (tabs.groups[j].type === "custom") {
                if (!tabs.groups[j].contentID)
                    innerDivCustom = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + tabs.groups[j].type, tabs.groups[j].customContent).addClass("e-innerdiv");
                else {
                    innerDivCustom = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + tabs.groups[j].type).addClass("e-innerdiv");
                    $("#" + tabs.groups[j].contentID).addClass('e-rbncustomelement').appendTo(innerDivCustom).show();
                }
                if (j === 0)
                    contDiv.append(ej.buildTag("div.e-ribupdivarrow").append(ej.buildTag("span.e-icon").addClass("e-groupresponsive e-ribdownarrow"))).addClass("e-resgroupheader");
                contDiv.append(innerDivCustom);
            }
            else {
                if (tabs.groups[j].content) {
                    if (j === 0)
                        contDiv.append(ej.buildTag("div.e-ribupdivarrow").append(ej.buildTag("span.e-icon").addClass("e-groupresponsive e-ribdownarrow"))).addClass("e-resgroupheader");
                    tabsConLen = tabs.groups[j].content.length;
                    for (var l = 0; l < tabsConLen; l++) {
                        if (tabs.groups[j].content[l] != undefined) {
                            var subGroup = tabs.groups[j].content[l].groups;
                            var defaults = tabs.groups[j].content[l].defaults;
                            if (tabs.groups[j].content.length == 1)
                                centerAlign = true;
                            if (ej.isNullOrUndefined(tabs.groups[j].alignType))
                                tabs.groups[j].alignType = ej.Ribbon.AlignType.Rows;
                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns)
                                innerDiv = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + (l + 1)).addClass("e-innerdiv");
                            else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                innerDiv = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + (l + 1)).addClass("e-innerdivrow");
                                ++m;
                            }
                            subGrpLen = subGroup.length;
                            for (var m = 0; m < subGrpLen; m++) {
                                if (!ej.isNullOrUndefined(subGroup[m])) {
                                    if (!ej.isNullOrUndefined(defaults)) {
                                        if (!ej.isNullOrUndefined(defaults.type))
                                            subGroup[m].type = defaults.type;
                                    }
                                    if (ej.isNullOrUndefined(subGroup[m].type))
                                        subGroup[m].type = ej.Ribbon.Type.Button;
                                    if (ej.isNullOrUndefined(subGroup[m].isBig) && !ej.isNullOrUndefined(defaults))
                                        subGroup[m].isBig = defaults.isBig;
                                    var buttonDef = this.model.buttonDefaults;
                                    if (ej.isNullOrUndefined(subGroup[m].height)) {
                                        var btnHeight;
                                        if (!ej.isNullOrUndefined(subGroup[m].buttonSettings) && !ej.isNullOrUndefined(subGroup[m].buttonSettings.height))
                                            btnHeight = subGroup[m].buttonSettings.height;
                                        else if (!ej.isNullOrUndefined(defaults) && !ej.isNullOrUndefined(defaults.height))
                                            btnHeight = defaults.height;
                                        else if (!ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.height))
                                            btnHeight = buttonDef.height;
                                        subGroup[m].height = btnHeight;
                                        btnHeight = null;
                                    }
                                    if (ej.isNullOrUndefined(subGroup[m].width)) {
                                        var btnWidth;
                                        if (!ej.isNullOrUndefined(subGroup[m].buttonSettings) && !ej.isNullOrUndefined(subGroup[m].buttonSettings.width))
                                            btnWidth = subGroup[m].buttonSettings.width;
                                        else if (!ej.isNullOrUndefined(defaults) && !ej.isNullOrUndefined(defaults.width))
                                            btnWidth = defaults.width;
                                        else if (!ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.width))
                                            btnWidth = buttonDef.width;
                                        subGroup[m].width = btnWidth;
                                        btnWidth = null;
                                    }
                                    if (!ej.isNullOrUndefined(subGroup[m].buttonSettings)) {
                                        var buttonSet = subGroup[m].buttonSettings;
                                        if (ej.isNullOrUndefined(buttonSet.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                                            buttonSet.enabled = buttonDef.enabled;
                                        if (ej.isNullOrUndefined(buttonSet.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                                            buttonSet.enableRTL = buttonDef.enableRTL;
                                        if (ej.isNullOrUndefined(buttonSet.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                                            buttonSet.cssClass = buttonDef.cssClass;
                                        if (ej.isNullOrUndefined(buttonSet.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                                            buttonSet.showRoundedCorner = buttonDef.showRoundedCorner;
                                    }
                                    if (!ej.isNullOrUndefined(subGroup[m].splitButtonSettings)) {
                                        var splitButtonSet = subGroup[m].splitButtonSettings;
                                        if (ej.isNullOrUndefined(splitButtonSet.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                                            splitButtonSet.enabled = buttonDef.enabled;
                                        if (ej.isNullOrUndefined(splitButtonSet.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                                            splitButtonSet.enableRTL = buttonDef.enableRTL;
                                        if (ej.isNullOrUndefined(splitButtonSet.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                                            splitButtonSet.cssClass = buttonDef.cssClass;
                                        if (ej.isNullOrUndefined(splitButtonSet.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                                            splitButtonSet.showRoundedCorner = buttonDef.showRoundedCorner;
                                    }

                                    if (!ej.isNullOrUndefined(subGroup[m].dropdownSettings)) {
                                        if (ej.isNullOrUndefined(subGroup[m].dropdownSettings.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                                            subGroup[m].dropdownSettings.enabled = buttonDef.enabled;
                                        if (ej.isNullOrUndefined(subGroup[m].dropdownSettings.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                                            subGroup[m].dropdownSettings.enableRTL = buttonDef.enableRTL;
                                        if (ej.isNullOrUndefined(subGroup[m].dropdownSettings.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                                            subGroup[m].dropdownSettings.cssClass = buttonDef.cssClass;
                                        if (ej.isNullOrUndefined(subGroup[m].dropdownSettings.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                                            subGroup[m].dropdownSettings.showRoundedCorner = buttonDef.showRoundedCorner;
                                    }

                                    if (!ej.isNullOrUndefined(subGroup[m].toggleButtonSettings)) {
                                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.enabled) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enabled))
                                            subGroup[m].toggleButtonSettings.enabled = buttonDef.enabled;
                                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.enableRTL) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.enableRTL))
                                            subGroup[m].toggleButtonSettings.enableRTL = buttonDef.enableRTL;
                                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.cssClass) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.cssClass))
                                            subGroup[m].toggleButtonSettings.cssClass = buttonDef.cssClass;
                                        if (ej.isNullOrUndefined(subGroup[m].toggleButtonSettings.showRoundedCorner) && !ej.isNullOrUndefined(buttonDef) && !ej.isNullOrUndefined(buttonDef.showRoundedCorner))
                                            subGroup[m].toggleButtonSettings.showRoundedCorner = buttonDef.showRoundedCorner;
                                    }
                                    if (ej.isNullOrUndefined(subGroup[m].quickAccessMode))
                                        subGroup[m].quickAccessMode = "none";
                                    switch (subGroup[m].type) {
                                        case ej.Ribbon.Type.Custom:
                                            custom = subGroup[m];
                                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + custom.contentID).addClass("e-controlpadding");
                                            }
                                            else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + custom.contentID).addClass("e-innerdivchild e-controlpadding");
                                            }
                                            if (!$.isEmptyObject(custom.customToolTip))
                                                innerDivChild.mouseover({ value: custom, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                            else if (!ej.isNullOrUndefined(custom.toolTip))
                                                innerDivChild.attr("title", custom.toolTip);
                                            $("#" + custom.contentID).addClass('e-rbncustomelement').appendTo(innerDivChild);
                                            if (!ej.isNullOrUndefined(subGroup[m])) {
                                                if (!ej.isNullOrUndefined(subGroup[m].height))
                                                    innerDivChild.children().height(subGroup[m].height);
                                                if (!ej.isNullOrUndefined(subGroup[m].width))
                                                    innerDivChild.children().width(subGroup[m].width);
                                            }
                                            if (!ej.isNullOrUndefined(custom.isBig)) {
                                                (custom.isBig) ? innerDivChild.children().addClass("e-big") : innerDivChild.children().addClass("e-small");
                                            }
                                            innerDiv.append(innerDivChild);
                                            if (subGroup[m].enableSeparator) {
                                                if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                    separatorDiv = ej.buildTag("div#" + this._id + "_" + "separator" + "_" + custom.toolTip).addClass("e-separatordivrow");
                                                    innerDiv.append(separatorDiv);
                                                }
                                            }
                                            break;
                                        case ej.Ribbon.Type.SplitButton:
                                            split = subGroup[m];
                                            this._splitButtonControl = ej.buildTag("button#" + this._id + "_" + split.id, split.text, {}, { type: "button" }).addClass(split.cssClass);
                                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + split.id, this._splitButtonControl).addClass("e-controlpadding");
                                            }
                                            else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + split.id, this._splitButtonControl).addClass("e-innerdivchild e-controlpadding");
                                            }
                                            if (!$.isEmptyObject(split.customToolTip))
                                                innerDivChild.mouseover({ value: split, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                            else if (!ej.isNullOrUndefined(split.toolTip))
                                                innerDivChild.attr("title", split.toolTip);
                                            model = {}
                                            if (split.splitButtonSettings)
                                                model = split.splitButtonSettings;
                                        model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                                        model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                                        if (model.cssClass)
                                            model.cssClass = model.cssClass.concat(" e-rbn-splitbtn e-rbn-button");
                                        else
                                            model.cssClass = "e-rbn-splitbtn e-rbn-button";
                                        model.enableRTL = this.model.enableRTL;
                                        this._splitButtonControl.ejSplitButton(model);
										innerDivChild.find('.e-split').addClass('e-rbn-split');
                                        if (split.isMobileOnly) {
                                            this._mobileSplitButton = ej.buildTag("button#" + this._id + "_" + split.id + "_mobEle", split.text, {}, { type: "button" }).addClass(split.cssClass);
                                            var mobileContentDiv = ej.buildTag("div#" + this._id + "_" + split.id + "_mobDiv", this._mobileSplitButton).addClass('e-mobdiv');
                                            model.height = split.splitButtonSettings.height;
                                            model.width = split.splitButtonSettings.width;
                                            model.arrowPosition = ej.ArrowPosition.Right;
                                            model.imagePosition = split.splitButtonSettings.imagePosition;
                                                model.contentType = split.splitButtonSettings.contentType
                                                this._mobileSplitButton.ejSplitButton(model);
										        mobileContentDiv.find('button').addClass('e-rbn-button');
                                                this._mobileToolbar[tabIndex].Content.push(mobileContentDiv);
                                                var btnText;
                                                if (!ej.isNullOrUndefined(split.text))
                                                    btnText = split.text;
                                                else if (!ej.isNullOrUndefined(split.splitButtonSettings.text))
                                                    btnText = split.splitButtonSettings.text;
                                                this._mobileContents[tabIndex].mobileContent.push({ id: split.id, text: btnText, isMobileOnly: split.isMobileOnly });
                                            }
                                        if (split.quickAccessMode != "none" && this.model.showQAT && (!this.model.enableOnDemand)) {
                                                this._splitButtonQAT = ej.buildTag("button#" + this._id + "_" + split.id + "_qatEle", split.text, {}, { type: "button" }).addClass(split.cssClass);
                                                var qatMainDiv = ej.buildTag("div#" + this._id + "_" + split.id + "_qatDiv", this._splitButtonQAT).addClass('e-qatooldiv');
                                                model.height = 30;
                                                model.arrowPosition = ej.ArrowPosition.Right;
                                                model.contentType = ej.ContentType.ImageOnly;
                                                if (!$.isEmptyObject(split.customToolTip))
                                                    qatMainDiv.mouseover({ value: split, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                                else if (!ej.isNullOrUndefined(split.toolTip))
                                                    qatMainDiv.attr("title", split.toolTip);
                                                this._splitButtonQAT.ejSplitButton(model);
												qatMainDiv.find('button').addClass('e-rbn-button');
                                                qatMainDiv.appendTo(this._qAccessBar);
                                                if (split.quickAccessMode == "menu")
                                                    qatMainDiv.hide();
                                            var btnText;
                                            if (!ej.isNullOrUndefined(split.text))
                                                btnText = split.text;
                                            else if (!ej.isNullOrUndefined(split.splitButtonSettings.text))
                                                btnText = split.splitButtonSettings.text;
                                            this._qatControlsName.push({ id: split.id, text: btnText, qAccess: split.quickAccessMode });
                                        }
                                        if (!ej.isNullOrUndefined(split.isBig)) {
                                            (split.isBig) ? innerDivChild.children().prop("style",false).addClass("e-big") : innerDivChild.children().prop("style",false).addClass("e-small");
                                        }
                                        innerDiv.append(innerDivChild);
                                        if (subGroup[m].enableSeparator) {
                                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                    separatorDiv = ej.buildTag("div#" + this._id + "_" + "separator" + "_" + split.id).addClass("e-separatordivrow");
                                                    innerDiv.append(separatorDiv);
                                                }
                                            }
                                            break;
                                        case ej.Ribbon.Type.ToggleButton:
                                            toggle = subGroup[m];
                                            this._toggleButtonControl = ej.buildTag("input#" + this._id + "_" + toggle.id, "", "", { type: "checkbox" }).addClass(toggle.cssClass);
                                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + toggle.id, this._toggleButtonControl).addClass("e-controlpadding");
                                            }
                                            else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + toggle.id, this._toggleButtonControl).addClass("e-innerdivchild e-controlpadding");
                                            }
                                            if (!$.isEmptyObject(toggle.customToolTip))
                                                innerDivChild.mouseover({ value: toggle, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                        else if (!ej.isNullOrUndefined(toggle.toolTip))
                                            innerDivChild.attr("title", toggle.toolTip);
                                        model = {}
                                        if (toggle.toggleButtonSettings)
                                            model = toggle.toggleButtonSettings;
                                        model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                                        model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                                        var qatToggle = $(("#" + this._toggleButtonControl.attr("id") + "_qatDiv button.e-togglebutton"));
                                        if (this.model.enableOnDemand && this.model.showQAT && qatToggle.is(":visible") && qatToggle.hasClass("e-active")) {
                                            model.toggleState = true;
                                        }
                                        this._toggleButtonControl.ejToggleButton(model).addClass('e-ribbonbtn e-rbn-button');
										innerDivChild.find('button').addClass('e-rbn-button');
                                        if (toggle.isMobileOnly) {
                                            this._mobileToggleButton = ej.buildTag("button#" + this._id + "_" + toggle.id + "_mobEle", "", "", { type: "checkbox" }).addClass(toggle.cssClass);
                                            var mobileContentDiv = ej.buildTag("div#" + this._id + "_" + toggle.id + "_mobDiv", this._mobileToggleButton).addClass('e-mobdiv');
                                            model.height = toggle.toggleButtonSettings.height;
                                            model.width = toggle.toggleButtonSettings.width;
                                            model.contentType = toggle.toggleButtonSettings.contentType;
                                            model.imagePosition = toggle.toggleButtonSettings.imagePosition;
                                            this._mobileToggleButton.ejToggleButton(model).addClass('e-ribbonbtn');
										    mobileContentDiv.find('button').addClass('e-rbn-button');
                                                this._mobileToolbar[tabIndex].Content.push(mobileContentDiv);
                                                var btnText;
                                                if (!ej.isNullOrUndefined(toggle.text))
                                                    btnText = toggle.text;
                                                else if (!ej.isNullOrUndefined(toggle.toggleButtonSettings.defaultText))
                                                    btnText = toggle.toggleButtonSettings.defaultText;
                                                this._mobileContents[tabIndex].mobileContent.push({ id: toggle.id, text: btnText, isMobileOnly: toggle.isMobileOnly });
                                            }
                                        if (toggle.quickAccessMode != "none" && this.model.showQAT && (!this.model.enableOnDemand)) {
                                                this._toggleButtonQAT = ej.buildTag("input#" + this._id + "_" + toggle.id + "_qatEle", "", "", { type: "checkbox" }).addClass(toggle.cssClass);
                                                var qatMainDiv = ej.buildTag("div#" + this._id + "_" + toggle.id + "_qatDiv", this._toggleButtonQAT).addClass('e-qatooldiv');
                                                model.height = 30;
                                                model.contentType = ej.ContentType.ImageOnly;
                                                if (!$.isEmptyObject(toggle.customToolTip))
                                                    qatMainDiv.mouseover({ value: toggle, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                                else if (!ej.isNullOrUndefined(toggle.toolTip))
                                                    qatMainDiv.attr("title", toggle.toolTip);
                                                this._toggleButtonQAT.ejToggleButton(model).addClass('e-ribbonbtn');
												qatMainDiv.find('button').addClass('e-rbn-button');
                                                qatMainDiv.appendTo(this._qAccessBar);
                                                if (toggle.quickAccessMode == "menu")
                                                    qatMainDiv.hide();
                                                var btnText;
                                                if (!ej.isNullOrUndefined(toggle.text))
                                                    btnText = toggle.text;
                                                else if (!ej.isNullOrUndefined(toggle.toggleButtonSettings.defaultText))
                                                    btnText = toggle.toggleButtonSettings.defaultText;
                                                this._qatControlsName.push({ id: toggle.id, text: btnText, qAccess: toggle.quickAccessMode });
                                            }
                                            if (!ej.isNullOrUndefined(toggle.isBig)) {
                                                (toggle.isBig) ? innerDivChild.find('.e-togglebutton.e-tbtn.e-btn').addClass("e-big") : innerDivChild.find('.e-togglebutton.e-tbtn.e-btn').addClass("e-small");
                                            }
                                            innerDiv.append(innerDivChild);
                                            if (subGroup[m].enableSeparator) {
                                                if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                    separatorDiv = ej.buildTag("div#" + this._id + "_" + "separator" + "_" + toggle.id).addClass("e-separatordivrow");
                                                    innerDiv.append(separatorDiv);
                                                }
                                            }
                                            break;
                                        case ej.Ribbon.Type.Button:
                                            button = subGroup[m];
                                            if (button.buttonSettings) {
                                                if (button.buttonSettings.type)
                                                    this._buttonControl = ej.buildTag("button#" + this._id + "_" + button.id, button.text, {}, { type: button.buttonSettings.type }).addClass(button.cssClass);
                                                else
                                                    this._buttonControl = ej.buildTag("button#" + this._id + "_" + button.id, button.text).addClass(button.cssClass);
                                            }
                                            else
                                                this._buttonControl = ej.buildTag("button#" + this._id + "_" + button.id, button.text).addClass(button.cssClass);
                                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + button.id, this._buttonControl).addClass("e-controlpadding");
                                            }
                                            else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + button.id, this._buttonControl).addClass("e-innerdivchild e-controlpadding");
                                            }
                                            if (!$.isEmptyObject(button.customToolTip))
                                                innerDivChild.mouseover({ value: button, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                            else if (!ej.isNullOrUndefined(button.toolTip))
                                            innerDivChild.attr("title", button.toolTip);
                                        model = {}
                                        if (button.buttonSettings)
                                            model = button.buttonSettings;
                                        model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                                        model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                                        this._buttonControl.ejButton(model).addClass('e-ribbonbtn  e-rbn-button');
                                        if (button.isMobileOnly) {
                                            if (button.buttonSettings) {
                                                if (button.buttonSettings.type)
                                                    this._mobileButton = ej.buildTag("button#" + this._id + "_" + button.id + "_mobEle", button.text, {}, { type: button.buttonSettings.type }).addClass(button.cssClass);
                                                else
                                                    this._mobileButton = ej.buildTag("button#" + this._id + "_" + button.id + "_mobEle", button.text).addClass(button.cssClass);
                                            }
                                                else
                                                    this._mobileButton = ej.buildTag("button#" + this._id + "_" + button.id + "_mobEle", button.text).addClass(button.cssClass);
                                                var mobileContentDiv = ej.buildTag("div#" + this._id + "_" + button.id + "_mobDiv", this._mobileButton).addClass('e-mobdiv');
                                                this._mobileButton.ejButton(model).addClass('e-ribbon-resbtn  e-rbn-button');
                                                this._mobileToolbar[tabIndex].Content.push(mobileContentDiv);
                                                var btnText;
                                                if (!ej.isNullOrUndefined(button.text))
                                                    btnText = button.text;
                                                else if (!ej.isNullOrUndefined(button.buttonSettings.text))
                                                    btnText = button.buttonSettings.text;
                                                this._mobileContents[tabIndex].mobileContent.push({ id: button.id, text: btnText, isMobileOnly: button.isMobileOnly });
                                            }
                                        if (button.quickAccessMode != "none" && this.model.showQAT && (!this.model.enableOnDemand)) {
                                                if (button.buttonSettings) {
                                                    if (button.buttonSettings.type)
                                                        this._buttonQAT = ej.buildTag("button#" + this._id + "_" + button.id + "_qatEle", button.text, {}, { type: button.buttonSettings.type }).addClass(button.cssClass);
                                                    else
                                                        this._buttonQAT = ej.buildTag("button#" + this._id + "_" + button.id + "_qatEle", button.text).addClass(button.cssClass);
                                                }
                                                else
                                                    this._buttonQAT = ej.buildTag("button#" + this._id + "_" + button.id + "_qatEle", button.text).addClass(button.cssClass);
                                                var qatMainDiv = ej.buildTag("div#" + this._id + "_" + button.id + "_qatDiv", this._buttonQAT).addClass('e-qatooldiv');
                                                model.height = 30;
                                                model.contentType = ej.ContentType.ImageOnly;
                                                if (!$.isEmptyObject(button.customToolTip))
                                                    qatMainDiv.mouseover({ value: button, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                                else if (!ej.isNullOrUndefined(button.toolTip))
                                                    qatMainDiv.attr("title", button.toolTip);
                                                this._buttonQAT.ejButton(model).addClass('e-ribbonbtn e-rbn-button');
                                                qatMainDiv.appendTo(this._qAccessBar);
                                                if (button.quickAccessMode == "menu")
                                                    qatMainDiv.hide();
                                                var btnText;
                                                if (!ej.isNullOrUndefined(button.text))
                                                    btnText = button.text;
                                                else if (!ej.isNullOrUndefined(button.buttonSettings.text))
                                                    btnText = button.buttonSettings.text;
                                                this._qatControlsName.push({ id: button.id, text: btnText, qAccess: button.quickAccessMode });
                                            }
                                            if (!ej.isNullOrUndefined(button.isBig)) {
                                                (button.isBig) ? innerDivChild.children().addClass("e-big") : innerDivChild.children().addClass("e-small");
                                            }
                                            innerDiv.append(innerDivChild);
                                            if (subGroup[m].enableSeparator) {
                                                if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                    separatorDiv = ej.buildTag("div#" + this._id + "_" + "separator" + "_" + button.id).addClass("e-separatordivrow");
                                                    innerDiv.append(separatorDiv);
                                                }
                                            }
                                            break;
                                        case ej.Ribbon.Type.DropDownList:
                                            dropdown = subGroup[m];
                                            this._dropdownControl = ej.buildTag("input#" + this._id + "_" + dropdown.id, { type: "text" }).addClass(dropdown.cssClass);
                                            if (dropdown.dropdownSettings) {
                                                if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns) {
                                                    innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + dropdown.id, this._dropdownControl).append($("#" + dropdown.dropdownSettings.targetID)).addClass("e-controlpadding");
                                                }
                                                else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                    innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + dropdown.id, this._dropdownControl).append($("#" + dropdown.dropdownSettings.targetID)).addClass("e-innerdivchild e-controlpadding");
                                                }
                                                if (!$.isEmptyObject(dropdown.customToolTip))
                                                    innerDivChild.mouseover({ value: dropdown, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                                else if (!ej.isNullOrUndefined(dropdown.toolTip))
                                                    innerDivChild.attr("title", dropdown.toolTip);
                                            }
                                            model = {};
                                            if (dropdown.dropdownSettings)
                                            model = dropdown.dropdownSettings;
                                        model.height = ej.isNullOrUndefined(model.height) ? subGroup[m].height : model.height;
                                        model.width = ej.isNullOrUndefined(model.width) ? subGroup[m].width : model.width;
                                        if (model.cssClass)
                                            model.cssClass = model.cssClass.concat(" e-rbn-ddl");
                                        else
                                            model.cssClass = "e-rbn-ddl";
                                        if (dropdown.isMobileOnly) {
                                            this._mobileDropdown = ej.buildTag("input#" + this._id + "_" + dropdown.id + "_mobEle", "", "", { type: "text" }).addClass(dropdown.cssClass);
                                            var mobileContentDiv = ej.buildTag("div#" + this._id + "_" + dropdown.id + "_mobDiv", this._mobileDropdown).addClass('e-mobdiv');
                                            this._mobileDropdown.ejDropDownList(model).addClass('e-ribbonbtn');
                                            this._mobileToolbar[tabIndex].Content.push(mobileContentDiv);
                                            var btnText;
                                            if (!ej.isNullOrUndefined(dropdown.text))
                                                btnText = dropdown.text;
                                            else if (!ej.isNullOrUndefined(dropdown.dropdownSettings.defaultText))
                                                btnText = dropdown.dropdownSettings.defaultText;
                                            this._mobileContents[tabIndex].mobileContent.push({ id: dropdown.id, text: btnText, isMobileOnly: dropdown.isMobileOnly });
                                        }
                                        model.enableRTL = this.model.enableRTL;
                                        this._dropdownControl.ejDropDownList(model);
                                        innerDiv.append(innerDivChild);
                                            if (subGroup[m].enableSeparator) {
                                                if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows) {
                                                    separatorDiv = ej.buildTag("div#" + this._id + "_" + "separator" + "_" + dropdown.id).addClass("e-separatordivrow");
                                                    innerDiv.append(separatorDiv);
                                                }
                                            }
                                            break;
                                        case ej.Ribbon.Type.Gallery:
                                            var galleryContentDiv, galleryPagesDiv, prevPage, nextPage, expandGallery, visibleRowCnt, galleryRows;
                                            gallery = subGroup[m];
                                            this._galleryControl = ej.buildTag("div#" + this._id + "_" + gallery.id + "_gallerycontrol").addClass("e-ribbongallerycontrol");
                                            this._gallery = ej.buildTag("div#" + this._id + "_" + gallery.id).addClass("e-ribbongallery");
                                            var galleryContentDiv = ej.buildTag("div#" + this._id + "_" + gallery.id + "_ContentDiv").addClass("e-gallerycontent").height(65).width(gallery.columns * gallery.itemWidth).click({ galleryId: this._gallery.attr("id") }, $.proxy(this._onGalContentClick, this));

                                            galleryRows = Math.floor(gallery.galleryItems.length / gallery.columns);

                                            if ((gallery.galleryItems.length % gallery.columns) > 0)
                                                ++galleryRows;

                                            for (var m = 1; m <= galleryRows; m++) {
                                                var galleryRow = ej.buildTag("div#" + this._id + "_" + gallery.id + "_galleryrow_" + m).addClass('e-galleryrow').click({ model: gallery }, $.proxy(this._onGalleryItemClick, this));
                                                if (m === 1)
                                                    galleryRow.addClass('e-gryfirstrow');
                                                else if (m === galleryRows)
                                                    galleryRow.addClass('e-grylastrow');

                                                for (var n = 1; n <= gallery.columns; n++) {
                                                    var contentLen = galleryContentDiv.find('.e-galleryrow').children().length + galleryRow.children().length, btnCtrl;
                                                    if (!ej.isNullOrUndefined(gallery.galleryItems[contentLen])) {
                                                        btnCtrl = ej.buildTag("button#" + gallery.id + "_galleryItem_" + (contentLen + 1), gallery.galleryItems[contentLen].text, {}, { type: "button" }).addClass('e-gallerybtn  e-rbn-button');
                                                        if (!$.isEmptyObject(gallery.galleryItems[contentLen].customToolTip))
                                                            btnCtrl.mouseover({ value: gallery.galleryItems[contentLen], ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                                        else if (!ej.isNullOrUndefined(gallery.galleryItems[contentLen].toolTip))
                                                            btnCtrl.attr("title", gallery.galleryItems[contentLen].toolTip);

                                                        model = {}
                                                        if (gallery.galleryItems[contentLen].buttonSettings)
                                                            model = gallery.galleryItems[contentLen].buttonSettings;
                                                        if (gallery.itemHeight <= 65)
                                                            model.height = gallery.itemHeight;
                                                        else
                                                            model.height = 65;
                                                        model.width = gallery.itemWidth;
                                                        btnCtrl.ejButton(model);
                                                        btnCtrl.appendTo(galleryRow);
                                                    }
                                                }
                                                if (gallery.itemHeight > 65)
                                                    visibleRowCnt = 1;
                                                else
                                                    visibleRowCnt = (galleryContentDiv.height() / gallery.itemHeight);
                                                if (m > visibleRowCnt)
                                                    galleryRow.hide();
                                                galleryRow.appendTo(galleryContentDiv);
                                            }
                                            this._gallery.append(galleryContentDiv);

                                            var galleryPagesDiv = ej.buildTag("div#" + this._id + "_" + gallery.id + "_PagesDiv").addClass("e-gallerymovediv");
                                            var prevPage = ej.buildTag("div#" + this._id + "_" + gallery.id + "_prevPage", "<span class='e-icon e-galleryup e-gallerymoveicon'></span>").click({ galleryId: this._gallery.attr("id"), rowCnt: visibleRowCnt }, $.proxy(this._onGalMoveUpClick, this)).addClass('e-moveupdiv e-disablegrymovebtn');
                                            var nextPage = ej.buildTag("div#" + this._id + "_" + gallery.id + "_nextPage", "<span class='e-icon e-gallerydown e-gallerymoveicon'></span>").click({ galleryId: this._gallery.attr("id") }, $.proxy(this._onGalMoveDownClick, this)).addClass('e-movedowndiv');
                                            var expandGallery = ej.buildTag("div#" + this._id + "_" + gallery.id + "_expandGallery", "<span class='e-icon e-galleryexpand e-gallerymoveicon'></span>").click({ galleryId: this._gallery.attr("id"), columns: gallery.columns, expandedColumns: gallery.expandedColumns, itemWidth: gallery.itemWidth }, $.proxy(this._onExpandGalleryClick, this)).addClass('e-expgallerydiv');
                                            this._responsiveGallery = gallery.expandedColumns;

                                            galleryPagesDiv.append(prevPage);
                                            galleryPagesDiv.append(nextPage);
                                            galleryPagesDiv.append(expandGallery);
                                            this._gallery.append(galleryPagesDiv);
                                            var galleryExpandContent = ej.buildTag("div#" + this._id + "_" + gallery.id + "_ExpandContent").addClass("e-gallexpandcontent").hide();
                                            var scrollContent = ej.buildTag("div#" + this._id + "_" + gallery.id + "_scrollContent", "<div></div>").addClass("e-gallscrollcontent");
                                            var expanderContent = ej.buildTag("div#" + this._id + "_" + gallery.id + "_ExpanderContent").addClass("e-expandercontent").click({ galleryId: this._gallery.attr("id") }, $.proxy(this._onExpandContentClick, this));
                                            scrollContent.children().append(expanderContent);
                                            galleryExpandContent.append(scrollContent);
                                            if (!ej.isNullOrUndefined(gallery.customGalleryItems)) {
                                                var expanderExtraContent = ej.buildTag("div#" + this._id + "_" + gallery.id + "_ExtraContent").addClass("e-extracontent").click({ model: gallery }, $.proxy(this._onGalleryItemClick, this));
                                                var customGalItemsLen = gallery.customGalleryItems.length;
                                                for (var l = 0; l < customGalItemsLen; l++) {
                                                    var btnCtrlExtra;
                                                    if (ej.isNullOrUndefined(gallery.customGalleryItems[l].customItemType))
                                                        gallery.customGalleryItems[l].customItemType = ej.Ribbon.CustomItemType.Button;
                                                    if (gallery.customGalleryItems[l].customItemType === ej.Ribbon.CustomItemType.Button) {
                                                        btnCtrlExtra = ej.buildTag("button#" + gallery.id + "_" + "_extraItem_" + l, gallery.customGalleryItems[l].text, {}, { type: "button" }).addClass('e-galleryextrabtn e-rbn-button');
                                                        if (!$.isEmptyObject(gallery.customGalleryItems[l].customToolTip))
                                                            btnCtrlExtra.mouseover({ value: gallery.customGalleryItems[l], ribbonId: this._id }, $.proxy(this._tooltip, this))
                                                            .mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                                                        else if (!ej.isNullOrUndefined(gallery.customGalleryItems[l].toolTip))
                                                            btnCtrlExtra.attr("title", gallery.customGalleryItems[l].toolTip);
                                                        model = {}
                                                        if (gallery.customGalleryItems[l]) {
                                                            if (gallery.customGalleryItems[l].buttonSettings)
                                                                model = gallery.customGalleryItems[l].buttonSettings;
                                                            btnCtrlExtra.ejButton(model);
                                                        }
                                                        btnCtrlExtra.appendTo(expanderExtraContent);
                                                    }
                                                    else {
                                                        model = {}
                                                        if (gallery.customGalleryItems[l].menuSettings)
                                                            model = gallery.customGalleryItems[l].menuSettings;
                                                        model.menuType = ej.MenuType.NormalMenu;
                                                        model.orientation = ej.Orientation.Vertical;
                                                        model.enableRTL = this.model.enableRTL;
                                                        $("#" + gallery.customGalleryItems[l].menuId).ejMenu(model).addClass('e-gallerymenu');
                                                        $("#" + gallery.customGalleryItems[l].menuId).appendTo(expanderExtraContent).css("width", "100%");
                                                    }
                                                }
                                                galleryExpandContent.append(expanderExtraContent);
                                            }
                                            this._galleryControl.append(this._gallery);
                                            this._galleryControl.append(galleryExpandContent);
                                            if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Columns)
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + gallery.id, this._galleryControl).addClass("e-controlpadding");
                                            else if (tabs.groups[j].alignType === ej.Ribbon.AlignType.Rows)
                                                innerDivChild = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText + "_" + gallery.id, this._galleryControl).addClass("e-innerdivchild e-controlpadding");
                                            innerDiv.append(innerDivChild);
                                            break;
                                    }
                                    contDiv.append(innerDiv);
                                }
                            }
                        }
                    }
                }
            }
            return contDiv;
        },

        _groupContent: function (e) {
            var tabContextualLen = 0;
            ej.isNullOrUndefined(e) ? index = this._tabUl.find(".e-active").index() - 1 : (tabContextualLen = $(e.activeHeader).parents(".e-contextliset").length > 0 ? $(e.activeHeader).parents(".e-contextliset").prevAll(".e-tab").eq(0).prevAll().not(".e-tab,.e-apptab").length : $(e.activeHeader).prevAll().not(".e-tab,.e-apptab").length, index = e.activeIndex - (tabContextualLen + 1));
            var rbnOnDemand = this.element.find(".e-content-item").eq(index + (1 + tabContextualLen));
            if (!rbnOnDemand.hasClass("e-rbn-ondemand") || index < 0)
                return;
            ribbonModel = $.extend(true, {}, this.model);
            var tabLen = this.model.tabs.length;
            !ej.isNullOrUndefined(e) ? contextIndex = $(e.activeHeader).hasClass("e-contextualtabset") ? tabLen - $(e.activeHeader).index() : -1 : contextIndex = -1;
            if (this.model.contextualTabs && contextIndex != -1) {
                var currentContext = $(e.activeHeader).parents(".e-contextliset").attr("id");
                contextIndex = parseInt(currentContext[currentContext.length - 1]);
                contextualTab = this.model.contextualTabs[contextIndex];
                if (contextualTab.tabs) {
                    var contexttualTablen = contextualTab.tabs.length;
                    for (var l = 0; l < contexttualTablen; l++) {
                        if (!ej.isNullOrUndefined(contextualTab.tabs[l].groups) && contextualTab.tabs[l].groups.length > 0) {
                            this.model.tabs[tabLen] = contextualTab.tabs[l];
                            index = tabLen;
                        }
                    }
                }
            }
            tabs = this.model.tabs[index];
            this._mobileContents[this._tabObj.model.selectedItemIndex - 1] = { "tab": tabs.text, "mobileContent": [] };
            this._mobileToolbar[this._tabObj.model.selectedItemIndex - 1] = { "tab": tabs.text, "Content": [] };
            if (!ej.isNullOrUndefined(tabs.groups)) {
                var tabsGrouplen = tabs.groups.length;
                for (j = 0; j < tabsGrouplen; j++) {
                    if (!ej.isNullOrUndefined(tabs.groups[j])) {
                        tabGroupText = ej.isNullOrUndefined(tabs.groups[j].id) ? (ej.isNullOrUndefined(tabs.groups[j].text) ? tabs.groups[j].text : tabs.groups[j].text.replace(/\s/g, '')) : tabs.groups[j].id.replace(/\s/g, ''); 
                        contDiv = this._createControls(j, tabs, tabGroupText, index);
                        groupDiv = this._addControlsToGroup(j, tabs, tabGroupText, contDiv);
                        tabcont = this.element.find("#" + this._id + "_" + tabs.id);
                        tabcont.append(groupDiv).addClass("e-parentdiv");
                    }
                }
            }
            else 
                this.element.find('.e-content.e-content-item').eq(index + 1).addClass('e-empty-content');
            rbnOnDemand.removeClass("e-rbn-ondemand");
            this.model = ribbonModel;
        },
        _groupingControls: function () {
            var tabLen = this.model.tabs.length, contextualTab, tabs, groupDiv, contDiv, tabcont;
            var i, j, tabGroupText, ribbonModel = $.extend(true, {}, this.model);
            if (this.model.contextualTabs) {
                var contextTablen = this.model.contextualTabs.length;
                for (var k = 0; k < contextTablen; k++) {
                    contextualTab = this.model.contextualTabs[k];
                    if (contextualTab.tabs) {
                        var contexttualTablen = contextualTab.tabs.length;
					    if(contexttualTablen==0)
                         this.element.find('.e-content.e-content-item').eq(i + 1).addClass('e-empty-content');
                        for (var l = 0; l < contexttualTablen; l++) {
                            if (!ej.isNullOrUndefined(contextualTab.tabs[l].groups) && contextualTab.tabs[l].groups.length > 0) {
                                this.model.tabs[tabLen] = contextualTab.tabs[l];
                                ++tabLen;
                            }
                        }
                    }
                }
            }
            for (i = 0; i < tabLen; i++) {
                tabs = this.model.tabs[i];
                this._mobileContents[i] = { "tab": tabs.text, "mobileContent": [] };
                this._mobileToolbar[i] = { "tab": tabs.text, "Content": [] };
                if (!ej.isNullOrUndefined(tabs.groups)) {
                    var tabsGrouplen = tabs.groups.length;
					if(tabsGrouplen==0)
                     this.element.find('.e-content.e-content-item').eq(i + 1).addClass('e-empty-content');
                    for (j = 0; j < tabsGrouplen; j++) {
                        if (!ej.isNullOrUndefined(tabs.groups[j])) {
                            tabGroupText = ej.isNullOrUndefined(tabs.groups[j].id) ? (ej.isNullOrUndefined(tabs.groups[j].text) ? tabs.groups[j].text : tabs.groups[j].text.replace(/\s/g, '')) : tabs.groups[j].id.replace(/\s/g, ''); 
                            contDiv = this._createControls(j, tabs, tabGroupText, i);
                            groupDiv = this._addControlsToGroup(j, tabs, tabGroupText, contDiv);
                            tabcont = this.element.find("#" + this._id + "_" + tabs.id);
                            tabcont.append(groupDiv).addClass("e-parentdiv");
                        }
                    }
                }
                else
                    this.element.find('.e-content.e-content-item').eq(i + 1).addClass('e-empty-content');
            }
            this._setTabContentHeight();
            this.model = ribbonModel;
        },
        _addControlsToGroup: function (j, tabs, tabGroupText, contDiv) {
            var contentbottom = ej.buildTag("div.e-contentbottom"), centerAlign = false, groupDiv, groupexpander;
            var captionArea = ej.buildTag("div.e-captionarea", tabs.groups[j].text);
            contentbottom.append(captionArea);
            if (tabs.groups[j].enableGroupExpander) {
                groupexpander = ej.buildTag("div#" + this._id + "_" + tabGroupText + "_e-groupexpander.e-icon e-expander e-groupexpander");
                contentbottom.append(groupexpander);
                if (!ej.isNullOrUndefined(tabs.groups[j].groupExpanderSettings)) {
                    if (!ej.isNullOrUndefined(tabs.groups[j].groupExpanderSettings.toolTip))
                        groupexpander.attr("title", tabs.groups[j].groupExpanderSettings.toolTip);
                    if (!$.isEmptyObject(tabs.groups[j].groupExpanderSettings.customToolTip))
                        groupexpander.mouseover({ value: tabs.groups[j].groupExpanderSettings, ribbonId: this._id }, $.proxy(this._tooltip, this)).mouseout({ ribbonId: this._id }, $.proxy(this._toolTipOut, this));
                }
            }
            groupDiv = ej.buildTag("div#" + this._id + "_" + tabs.id + "_" + tabGroupText).addClass("e-groupdiv").click($.proxy(this._onGroupClick, this));
            if (!ej.isNullOrUndefined(tabs.groups[j].content))
                if (tabs.groups[j].content.length == 1)
                    centerAlign = true;
            tabs.groups[j].width && groupDiv.width(tabs.groups[j].width);
            groupDiv.append(contDiv);
            if (centerAlign) {
                groupDiv.addClass("e-centeralign");
                centerAlign == false;
            }
            groupDiv.append(contentbottom);
            return groupDiv;
        },
        _tabExpandCollapse: function (e) {
            var target, args, action;
			if(e.type=="touchend")
			   e.preventDefault();
            target = e.target.tagName == "div" ? e.target : e.target.parentNode;
            action = target.className == "e-expanded" ? "collapse" : "expand";
            args = { target: $(target), type: e.type, action: action, cancel: false };
            this._trigger("toggleButtonClick", args);
            if (args.cancel)
                return;
            if (this.element.find('.e-rarrowup-2x').length > 0)
                this.collapse();
            else {
                this._removeRibbonPin();
                if (this.model.showQAT)
                    this._qAccessBar.show();
                this._trigger("pinState", { action: "pin" });
            }
            this._clickValue = "click";
        },
        _responsiveback: function () {
            this.element.find(".e-resizebtnselect").removeClass("e-active e-resizebtnselect");
            this.element.find(".e-responsivebackstagecontent").is(":visible") && this.element.find(".e-responsivebackstagecontent").hide();
            this.element.find(".e-responsivecontent").hasClass("e-resshow") && !(this.element.find(".e-responsivecontent").find(".e-split.e-active").length > 0) && this._responsiveContentBack();
            if (this.element.find(".e-respcontent").is(":visible")) {
                this.element.find(".e-active-content").addClass("e-responsiveheight e-rbnmobheader");
                this.element.find(".e-respcontent .e-groupresponsive.e-ribuparrow").removeClass("e-ribuparrow").addClass("e-ribdownarrow");
            }
            return;
        },
        _ribbonResponsive: function () {
            var ul = ej.buildTag("ul#" + this._id + "_responsivetabContent").addClass("e-rescontent");
            var count = this.model.tabs.length, tabcount = true;
            for (var i = 0; i < count ; i++)
                ul.append(ej.buildTag("li", this.model.tabs[i].text).addClass("e-responsivetabli"));
            count = this.model.contextualTabs.length;
            if (count == 1)
                tabcount = this.model.contextualTabs[0].tabs.length > 0 ? true : false;
            if (count != 0 && tabcount)
                for (var i = 0; i < count ; i++)
                    ul.append(ej.buildTag("li", this.model.contextualTabs[i].tabs[0].text).addClass("e-responsivetabli").addClass("e-resContextual"));
            var div = ej.buildTag("div#" + this._id + "_responsivetabHeader").addClass("e-responsivetabheader").click($.proxy(this._onResponsiveHeaderClick, this));
            div.append(ul);
            this.element.append(div);
            if (this._initialRender) {
                this._tabUl.find("li.e-ribresmenu a").not(".e-backstagetab").text(this._tabUl.find("li.e-active a").text());
            }
            if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Backstage) {
                this.element.prepend(ej.buildTag("div#" + this._id + "_responsivebackstage").addClass("e-responsivebackstage"));
                var resbackstage = ej.buildTag("div#" + this._id + "_resbackstagecontent").addClass("e-responsivebackstagecontent").append(ej.buildTag("div.e-resbackstagecontent"));
                resbackstage.prepend(ej.buildTag("div#" + this._id + "backstagetop").addClass("e-backstagerestop").append(ej.buildTag("div.e-backstagerestopcontent").append(ej.buildTag("span.e-icon").addClass("e-ribleftarrow")).append(ej.buildTag("div#" + this._id + "resbacstageTitle").addClass("e-backstageTitle"))));
                this.element.prepend(resbackstage.hide());
            }
        },
        _onResponsiveHeaderClick: function (args) {
            if ($(args.target).hasClass("e-responsivetabli")) {
                var index = $(args.target).parent("ul").children().index(args.target);
                this.element.find(".e-responsivetabheader").removeClass("e-resshow");
                this.element.find(".e-ribresmenu a").text(args.target.textContent);
                $(this._tabUl.find(".e-tab,.e-contextliset").find("a")[index]).trigger("click");
                $(args.target).parent("ul").children(".e-resactive").removeClass("e-resactive");
                $(args.target).addClass("e-resactive");
                return;
            }
            if ($(args.target).parent(".e-ribresmenu").length > 0) {
                this.element.find(".e-responsivetabheader").addClass("e-resshow"); return;
            }
        },
        _ribbonResGroup: function () {
            var tab = this._tabUl.find(".e-tab,.e-contextualtabset").index(this._tabUl.find("li.e-active"));
			if(tab<0)
			 tab=this._tabUl.find(".e-tab,.e-contextualtabset").index(this._tabUl.find("li.e-collapseactive"));
            if (!ej.isNullOrUndefined(this.model.applicationTab))
                tabIndex = tab + 1;
            var ribTabContents = this.element.find('.e-content.e-content-item');
            var ribActiveContent = this.element.find(".e-active-content");
            var tabContent = ribTabContents.eq(tabIndex).attr('id');
            var grpLen = ribTabContents.eq(tabIndex).children('.e-groupdiv').length;
            var resize = ribTabContents.eq(tabIndex).children('.e-groupdiv')[grpLen - 1];
            var curGroup = ribTabContents.eq(tabIndex).children('.e-groupdiv').eq(grpLen - 1).find('.e-resizebtn');
            if (tab != -1 && this.element.find(".e-content-item").eq(tabIndex).children().not(".e-expandcollapse").length > 0) {
                if (this._mobileContents[tab].mobileContent.length > 0 && !ribActiveContent.find(".e-respmobcontent").length > 0) {
                    ribActiveContent.prepend(ej.buildTag("div#" + this._id + "_mobcontent").addClass("e-respmobcontent e-groupmobdiv").append(ej.buildTag("div#" + this._id + "_mobribgroup").addClass("e-mobribgroup e-mobribgroupactive").append(ej.buildTag("div.e-ribupdivarrow").addClass("e-toolbaralign").append(ej.buildTag("span.e-icon").addClass("e-groupresponsive e-ribdownarrow"))))).click($.proxy(this._onGroupClick, this)).click($.proxy(this._onMobContentClick, this));
                    ribActiveContent.find(".e-resgroupheader").removeClass("e-resgroupheader");
                    var mobToolbarlen = this._mobileToolbar[tab].Content.length;
                    for (var i = 0; i < mobToolbarlen; i++)
                        ribActiveContent.find(".e-mobribgroup").append(this._mobileToolbar[tab].Content[i]);
                    ribActiveContent.find(".e-mobribgroup").append(ribActiveContent.find(".e-mobribgroup .e-ribupdivarrow"))
                }
            }
            for (var j = grpLen - 1; j >= 0; j--) {
                curGroup = ribTabContents.eq(tabIndex).children('.e-groupdiv').eq(j).find('.e-resizebtn');
                if ((curGroup.length == 0) && (j != 0 || this._mobileContents[tab].mobileContent.length > 0))
                    this._createResizeBtn(tabIndex, j);
                else if (j == 0 && curGroup.length > 0 && !this._mobileContents[tab].mobileContent.length > 0) {
                    var group = curGroup.parent().siblings();
                    curGroup.parent().remove();
                    group.show();
                    group.not('.e-contentbottom').css("width", "");
                }
            }

        },
        _ribbonWindowResize: function () {
            this._phoneMode = (this.model.allowResizing || this.model.isResponsive) && document.documentElement.clientWidth < 420 ? true : false;
            var tab = this._tabUl.find(".e-tab,.e-contextualtabset").index(this._tabUl.find("li.e-active"));
            var ribbonPin = this.element.find(".e-ribbonpin");
            var ribTabContents = this.element.find('.e-active-content').eq(0);
            var responsiveTab = this.element.find(".e-ribresmenu"), backstage, backstagePage, mobiletoolgroup;
            var responsiveContent = this.element.find(".e-respcontent"), tabIndex;
            if (!ej.isNullOrUndefined(this.model.applicationTab))
                tabIndex = tab + 1;
            this.element.find(".e-ribGroupContent.e-resshow").addClass("e-reshide");
            if (this._phoneMode) {
                this._responsiveScrollRemove();
                if (responsiveContent.is(":hidden") && this.element.find(".e-responsivecontent").is(":hidden"))
                    responsiveContent.removeClass("e-reshide")
                if (this._isCollapsed) {
                    if (this._tabUl.find(".e-active").length > 0)
                        responsiveTab.find("a").text(this._tabUl.find(".e-active a").text());
                    else {
                        this._responsiveTabText.eq(0).addClass("e-resactive");
                        responsiveTab.find("a").text(this._responsiveTabText.filter(".e-resactive").text());
                    }
                }
                else {
                    this._responsiveTabText.filter(".e-resactive").removeClass("e-resactive");
                    this._responsiveTabText.eq($(this._ribbonTabs.filter(".e-tab ,.e-contextualtabset")).index(this._ribbonTabs.filter(".e-active"))).addClass("e-resactive")
                    responsiveTab.find("a").text(this._responsiveTabText.filter(".e-resactive").text());
                }
                if (ribbonPin.length > 0)
                    ribbonPin.trigger("click");
                ribTabContents.addClass("e-responsiveheight e-rbnmobheader").addClass("e-tab_" + this._tabUl.find(".e-active a").text());
                if (!ribTabContents.hasClass("e-respcontent"))
                    ribTabContents.addClass("e-respcontent");
                var responsivenestedmenu = ribTabContents.find(".e-groupresponsive");
                if ($(responsivenestedmenu).eq(0).hasClass("e-ribdownarrow") || responsivenestedmenu.hasClass("e-ribuparrow"))
                    responsivenestedmenu.hasClass("e-ribuparrow") && responsivenestedmenu.eq(0).removeClass("e-ribuparrow").addClass("e-ribdownarrow");
                if (!ej.isNullOrUndefined(this.model.applicationTab))
                    this.element.find(".e-ribresmenu").css("padding-left", "12px");
                this._ribbonResGroup();
                this.element.addClass("e-responsive");
                this.element.find(".e-rbn-ddl.e-ddl").addClass("e-rbn-resize");
                backstagePage = this.element.find(".e-ribbonbackstagepage");
                backstage = this.element.find(".e-responsivebackstage");
                var headerWidth = this.element.find(".e-header").width();
                if (this.model.enableOnDemand && this.element.find(".e-backstagetab .e-resbackstage").length == 0) {
                    if (this.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Backstage)
                        this._applicationTab.addClass('e-backstagetab');
                    this.element.find(".e-backstagetab").append(ej.buildTag("span.e-icon").addClass("e-ribbon e-resbackstage").click($.proxy(this._onResponsiveHeaderClick, this)));
                    this.element.find(".e-header").addClass("e-resheader");
                }
                else if (this.model.applicationTab.type == ej.Ribbon.ApplicationTabType.Backstage && this.element.find(".e-backstagetab .e-resbackstage").length == 0) {
                    this.element.find(".e-backstagetab").append(ej.buildTag("span.e-icon").addClass("e-ribbon e-resbackstage").click($.proxy(this._onResponsiveHeaderClick, this)));
                    this.element.find(".e-header").addClass("e-resheader");
                }
                  else if (this.model.applicationTab.type == ej.Ribbon.ApplicationTabType.Menu && this.model.applicationTab.menuItemID)
                {
                    this.element.find(".e-header").addClass("e-resheader");
                    this.element.find(".e-rescontent").addClass("e-rescontent-menu");
                }
                if (this.model.showQAT) {
                    this._tabUl.find("li.e-responsiveqat").append(this.element.find(".e-rbnquickaccessbar.e-rbnabove").children());
                    var headerContent = this.element.find(".e-ribdownarrow").not(".e-groupresponsive");
                    if (this.element.find(".e-resqatScroll").length > 0) {
                        var mobQATScroll = this.element.find(".e-resqatScroll")
                        mobQATScroll.data("ejScroller")._destroy();
                        mobQATScroll.parent().append(mobQATScroll.find("div:first").children());
                        mobQATScroll.remove();
                    }
                    var qatOffset = ((headerWidth - (headerContent.offset().left + headerContent.outerWidth())) < (headerWidth - this.element.find("li.e-responsiveqat").offset().left));
                    if (qatOffset && !this.element.find(".e-resqatScroll").length > 0) {
                        var diff = (headerWidth - this.element.find("li.e-responsiveqat").offset().left) - (headerWidth - (headerContent.offset().left + headerContent.outerWidth()));
                        var div = ej.buildTag("div#" + this._id + "_responsiveqat").addClass("e-resqatScroll").append(ej.buildTag("div"));
                        div.find("div").append(this._tabUl.find("li.e-responsiveqat").children());
                        this._tabUl.find("li.e-responsiveqat").append(div);
                        var qatScroll = this.element.find(".e-resqatScroll");
                        qatScroll.ejScroller({ width: (headerWidth - this.element.find("li.e-responsiveqat").offset().left) - diff, height: "", scrollerSize: 3, buttonSize: 0 })
                    }
                }
                if (ribTabContents.find(".e-groupdiv .e-resizebtn").length > 0 && !ribTabContents.find(".e-groupdiv .e-groupresponsive").not(".e-ribdownarrow").length > 0)
                    ribTabContents.find(".e-groupdiv").find(".e-resizebtn").parent("div").prepend(ej.buildTag("div.e-ribrightdivarrow").append(ej.buildTag("span.e-icon").addClass("e-groupresponsive e-ribrightarrow")));
                if (this._tabUl.find(".e-backstagetab").length > 0 && backstage.length == 1) {
                    var backstagecontent = backstagePage.find(".e-ribbonbackstagebody .e-backstageheader");
                    backstage.append(backstagecontent).addClass("e-reshide");
                }
                if (!this.element.find(".e-responsivecontent").length > 0) {
                    var div = ej.buildTag("div#" + this._id + "_responsive").addClass("e-content e-responsivecontent").click($.proxy(this._onResizeDivClick, this));
                    div.append(ej.buildTag("div#" + this._id + "_resback").addClass("e-responsiveback").append(ej.buildTag("span").addClass("e-groupresponsive e-icon e-ribleftarrow")).append(ej.buildTag("div#" + this._id + "+rescontentback").addClass("e-restopbackcontent")));
                    this.element.append(div.hide());
                }
                if (backstagePage.find(".e-ribbonbackstagebody .e-backstagecontent").length > 0)
                    this.element.find(".e-responsivebackstagecontent .e-resbackstagecontent").append(backstagePage.find(".e-ribbonbackstagebody .e-backstagecontent"));
                var header = this.element.find(".e-header");
                var screenHeight = document.documentElement.clientHeight;
                mobiletoolgroup = this.element.find(".e-mobribgroup.e-mobribgroupactive");
                this.element.find(".e-responsivebackstagecontent .e-resbackstagecontent").css({ "height": screenHeight - this.element.find(".e-backstagerestop").outerHeight() });
                mobiletoolgroup.find(".e-ribupdivarrow").removeClass("e-toolbaralign");
                var mobToolbarScroll = mobiletoolgroup.find(".e-resptoolbarScroll");
                if (mobToolbarScroll.length > 0) {
                    mobToolbarScroll.data("ejScroller")._destroy();
                    mobToolbarScroll.parent().append(mobToolbarScroll.find("div:first").children());
                    mobToolbarScroll.parents(".e-active-content").removeClass("e-responsiveToolbarScroll");
                    mobToolbarScroll.remove();
                }
                if (this._phoneMode && mobiletoolgroup.outerWidth() > this.element.find(".e-header").outerWidth()) {
                var div = ej.buildTag("div#" + this._id + "_responsivetoolbar").addClass("e-resptoolbarScroll").append(ej.buildTag("div"));
                div.find("div").append(mobiletoolgroup.children());
                mobiletoolgroup.append(div);
                var toolbarScroll = this.element.find(".e-respmobcontent .e-resptoolbarScroll");
                toolbarScroll.find(".e-toolbaralign").removeClass("e-toolbaralign");
                toolbarScroll.ejScroller({ width: this.element.find(".e-header").width(), height: "", scrollerSize: 4, buttonSize: 0 })
                toolbarScroll.parents(".e-active-content").addClass("e-responsiveToolbarScroll");
            }
            else if (mobiletoolgroup.find(".e-resptoolbarScroll").length > 0 && !mobiletoolgroup.find("e-responsiveToolbarScroll").length > 0)
                mobiletoolgroup.parents(".e-active-content").addClass("e-responsiveToolbarScroll");
            else mobiletoolgroup.find(".e-ribupdivarrow").addClass("e-toolbaralign"); {
                this.goToMainContent();
                return;
            }
            }
            else {
                if (this.element.hasClass("e-responsive")) {
                    this.element.removeClass("e-responsive");
                    this._ribbonRerender();
                   
                }
            }

            if (this.model.allowResizing || this.model.isResponsive) {
                if (this.element.find('.e-ribbonpin').length > 0 && this.element.find('.e-active-content').eq(0).is(':visible')) {
                    this.collapse();
                }
                else
                    this._ribbonResize();
            }
            if (this.element.find('.e-ribbonpin').length > 0)
                this._tabContents.width(this.element.width());
        },
        _ribbonResize: function () {
            var tabContent, resize, tabIndex, tabLeft, tabWidth, tabHeadLen, curHead, curTextLen, grpLen, contentWidth, grpsWidth, resizeBtnLen = 0, resizeBtn, m = 0, tabArray = [], resizeHead, toolTip, tabUl, curGroup, expandDiv, resizeHeadLen;
            var ribTabContents, ribActiveCon = this.element.find('.e-active-content').eq(0), ribTabs, ribTabsVisible, ribResizeDiv, resizeTab, ribbonPin = this.element.find('.e-ribbonpin');
            ribTabsVisible = this._tabUl.find('li.e-select:visible,li.e-active:visible'), ribResizeDiv = this.element.find('.e-resizediv'), expandDiv = this.element.find('.e-expandcollapse');
            tabUl = this.element.find('.e-header');
            if (ribbonPin.length > 0) {
                this._removeRibbonPin();
                expandDiv.children().addClass('e-ribbonpin');
            }
            if (tabUl.is(":hidden") && ribActiveCon.is(":hidden")) {
                if (this._resizeWidth <= this.element.width() + this.element.offset().left) {
                    tabUl.show();
                    this._qAccessBar.show();
                    if (this.element.find('.e-expandcollapse').children().hasClass('e-expanded') || tabUl.find('.e-active').length > 0) {
                        if (ribbonPin.length <= 0) {
                            ribActiveCon.show();
                            expandDiv.children().addClass('e-expanded').removeClass('e-collapsed');
                        }
                        else if (ribbonPin.length > 0)
                            this.collapse();
                    }
                }
            }
            ribTabs = tabUl.find('li.e-select,li.e-active');
            tabHeadLen = ribTabs.length;
            if (tabUl.is(":visible")) {
                for (var t = tabHeadLen - 1; t > 0; t--) {
                    curHead = ribTabs.eq(t).children();
                    curTextLen = curHead.text().length - 1;
                    for (var s = curTextLen; s > 1; s--) {
                        if (ribTabsVisible.length > 0) {
                            tabLeft = ribTabsVisible.last().offset().left;
                            tabWidth = ribTabsVisible.last().width();
                            if (((this.element.width() + this.element.offset().left) - 30) - (tabLeft + tabWidth) <= 0 || (this.model.enableRTL && ribTabsVisible.last().offset().left < this.element.offset().left)) {
                                if (!curHead.hasClass("e-resizeHead"))
                                    curHead.text(curHead.text().slice(0, -1)).addClass("e-resizeHead");
                                else
                                    curHead.text(curHead.text().slice(0, -1));
                            }
                        }
                    }
                }
                resizeTab = tabUl.find('.e-resizeHead');
                if (tabHeadLen - 1 === resizeTab.length && resizeTab.eq(0).text().length <= 2) {
                    if (ribTabsVisible.length > 0) {
                        tabLeft = ribTabsVisible.last().offset().left;
                        tabWidth = ribTabsVisible.last().width();
                        if (((this.element.width() + this.element.offset().left) - 30) - (tabLeft + tabWidth) <= 0) {
                            this._resizeWidth = this.element.width() + this.element.offset().left;
                        }
                    }
                }
            }
            tabIndex = this._tabObj.model.selectedItemIndex;
            ribTabContents = this.element.find('.e-content.e-content-item');
            tabContent = ribTabContents.eq(tabIndex).attr('id');
            grpLen = ribTabContents.eq(tabIndex).children('.e-groupdiv').length;
            resize = ribTabContents.eq(tabIndex).children('.e-groupdiv')[grpLen - 1];
            curGroup = ribTabContents.eq(tabIndex).children().eq(grpLen - 1).find('.e-resizebtn');
            if (!ej.isNullOrUndefined(resize)) {
                for (var j = grpLen - 1; j >= 0; j--) {
                    curGroup = ribTabContents.eq(tabIndex).children().eq(j).find('.e-resizebtn');
                    if ((this.element.width() + this.element.offset().left - 25) - (resize.offsetWidth + $(resize).offset().left) <= 0 || (this.model.enableRTL && ($(window).width() - this.element.offset().left + 25) - ($(window).width() - $(resize).offset().left + resize.offsetWidth) <= 0)) {
                        if (curGroup.length === 0)
                            this._createResizeBtn(tabIndex, j);
                    }
                }
                if ((this.element.width() + this.element.offset().left - 25) - (resize.offsetWidth + $(resize).offset().left) <= 0 || (this.model.enableRTL && ($(window).width() - this.element.offset().left + 25) - ($(window).width() - $(resize).offset().left + resize.offsetWidth) <= 0)) {
                    if (grpLen === ribTabContents.eq(tabIndex).find('.e-resizebtn').length) {
                        this._resizeWidth = this.element.width() + this.element.offset().left;
                        this.element.addClass("e-grpdivhide")
                        this.element.find('.e-expandcollapse').css("display", "none");
                    }
                }
                else {
                    this.element.removeClass("e-grpdivhide");
                    this.element.find('.e-expandcollapse').css("display", "block");
                }
            }
            this._qatResize();
            if (ribResizeDiv.is(":visible")) {
                var resizeCon = ribResizeDiv.children().eq(0).attr("id");
                resizeCon = "#" + resizeCon.replace("_content", "");
                ribResizeDiv.children().hide().appendTo(resizeCon);
                ribResizeDiv.hide();
            }
            var tabLen = this.model.tabs.length
            for (var l = 0; l < tabLen; l++) {
                var tabText = this.model.tabs[l].text;
                tabArray.push(tabText);
            }

            if (this.model.contextualTabs) {
                var contextTabLen = this.model.contextualTabs.length;
                for (var i = 0; i < contextTabLen; i++) {
                    if (this.model.contextualTabs[i].tabs) {
                        var contexttualTabLen = this.model.contextualTabs[i].tabs.length;
                        for (var j = 0; j < contexttualTabLen; j++) {
                            tabText = this.model.contextualTabs[i].tabs[j].text;
                            tabArray.push(tabText);
                        }
                    }
                }
            }

            resizeHeadLen = tabUl.find(".e-resizeHead").length;
            if (tabUl.is(":visible")) {
                for (var t = 0; t < resizeHeadLen; t++) {
                    curHead = tabUl.find(".e-resizeHead").eq(0);
                    if (curHead.hasClass("e-resizeHead")) {
                        var aTagLen = ribTabs.find(".e-link").not('.e-resizeHead').length - 1;
                        var textLen = curHead.text().length;
                        var tabLength = tabArray[aTagLen].length;
                        for (var s = textLen; s <= tabLength; s++) {
                            if (ribTabsVisible.length > 0) {
                                tabLeft = ribTabsVisible.last().offset().left;
                                tabWidth = ribTabsVisible.last().width() + 15;
                                if (((this.element.width() + this.element.offset().left) - 30) >= (tabLeft + tabWidth) && !this.model.enableRTL || (this.model.enableRTL && ribTabsVisible.last().offset().left - 15 > this.element.offset().left)) {
                                    if (curHead.text().length === tabArray[aTagLen].length)
                                        curHead.removeClass("e-resizeHead");
                                    else if (this._width != this.element.width())
                                        curHead.text(tabArray[aTagLen].slice(0, curHead.text().length + 1));
                                }
                            }
                        }
                    }
                }
            }
            resizeBtnLen = ribTabContents.eq(tabIndex).find('.e-resizebtn').length;
            for (var i = 0; i < resizeBtnLen; i++) {
                resizeBtn = ribTabContents.eq(tabIndex).find('.e-resizebtn').eq(0);
                if ($(resizeBtn).is(':visible')) {
                    grpsWidth = this.element.width() + this.element.offset().left - 25;
                    contentWidth = resizeBtn.offset().left + resizeBtn.parent().siblings().not('.e-contentbottom').width();
                    if (this.model.enableRTL)
                        contentWidth = (this.element.width() + this.element.offset().left - resizeBtn.offset().left) + resizeBtn.parent().siblings().not('.e-contentbottom').width();
                    var resizeBtnLength = ribTabContents.eq(tabIndex).find('.e-resizebtn').length;
                    if (resizeBtnLength > 1) {
                        for (var k = 0; k < resizeBtnLength; k++)
                            contentWidth = contentWidth + ribTabContents.eq(tabIndex).find('.e-resizebtn').eq(k).parents('.e-groupdiv').width() + 7;
                    }
                    if (grpsWidth > contentWidth) {
                        var rez = resizeBtn.parent().siblings();
                        resizeBtn.parent().remove();
                        rez.show();
                        rez.not('.e-contentbottom').css("width", "");
                    }
                }
            }
            this._qatResizeRemove();
            toolTip = this.element.find('.e-tooltipdiv');
            toolTip.hide();
            toolTip.find('.e-tooltiptitle').children().remove();
            toolTip.find('.e-tooltipdesc').children().remove();
            if (this.element.find('.e-ribbonpin').length > 0 && this.element.find('.e-active-content').eq(0).is(':visible')) {
                this._addRibbonPin();
                this._tabContents.width(this.element.width());
            }
            this.element.find('.e-resizebtnselect').removeClass('e-resizebtnselect e-active');
            if (this.model.showQAT) {
                var qaMenu = this.element.find('.e-rbnqatmenu');
                if (qaMenu.is(':visible'))
                    qaMenu.hide().css({ top: '', left: '' });
                this.element.find('.e-qaresizebtn,.e-splitbtnqat').removeClass('e-tbtn e-active');
            }
        },
        _qatResize: function () {
            if (this.model.showQAT && this._qAccessBar.is(':visible')) {
                var qaLastEle, qaResizeDiv;
                var qatToolbarlen = this._qAccessBar.children(':visible').length;
                for (var i = 0; i < qatToolbarlen; i++) {
                    qaLastEle = this._qAccessBar.children(':visible').last();
                    if (this.element.width() - (qaLastEle.width() + $(qaLastEle).position().left + 6) <= 0) {
                        if (qaLastEle.hasClass('e-splitbtnqatdiv')) {
                            var qatResizeBtnDiv = ej.buildTag("div.e-qaresizebtndiv").attr('title', 'More Controls'), qaResizeBtn = ej.buildTag("button.e-qaresizebtn");
                            qaResizeDiv = ej.buildTag("div.e-qaresizediv").hide();
                            this.element.append(qaResizeDiv);
                            qaResizeDiv.append(qaLastEle.prev());
                            qatResizeBtnDiv.append(qaResizeBtn.ejButton({
                                size: "normal",
                                type: "button",
                                contentType: "imageonly",
                                height: 30,
                                width: 14,
                                prefixIcon: "e-icon e-ribbon e-qaresizebtnicon",
                                click: $.proxy(this._onQatResizeBtnClick, this)
                            }));
                            qaResizeDiv.append(qaLastEle);
                            qatResizeBtnDiv.insertBefore(this.element.find('.e-rbnqatmenu'));
                        }
                        else if (qaLastEle.hasClass('e-qaresizebtndiv')) {
                            qaResizeDiv = this.element.find('.e-qaresizediv');
                            qaResizeDiv.prepend(qaLastEle.prevAll(':visible').first());
                        }
                    }
                }
                qaResizeDiv = this.element.find('.e-qaresizediv');
                if (qaResizeDiv.is(':visible'))
                    qaResizeDiv.hide();
            }
        },
        _qatResizeRemove: function () {
            var qaResizeDiv = this.element.find('.e-qaresizediv'), rbnWidth = this.element.width(), qAccessBarWidth = 0, qaResizebBtnDiv;
            if (qaResizeDiv.length > 0 && this._qAccessBar.is(':visible') && this.model.showQAT) {
                qaResizeDiv.show();
                qaResizebBtnDiv = this.element.find('.e-qaresizebtndiv');
                var qatToolbarlen = this._qAccessBar.children(':visible').length;
                var qaResizelen = qaResizeDiv.children().length;
                for (var i = 0; i < qatToolbarlen; i++)
                    qAccessBarWidth = qAccessBarWidth + this._qAccessBar.children(':visible').eq(i).width() + 6;
                for (var i = 0; i <= qaResizelen; i++) {
                    if (qaResizeDiv.children().length > 2)
                        qAccessBarWidth = qAccessBarWidth + qaResizeDiv.children().eq(0).width();
                    else
                        qAccessBarWidth = qAccessBarWidth + qaResizeDiv.width();
                    if (rbnWidth > qAccessBarWidth) {
                        if (qaResizeDiv.children().length > 2)
                            qaResizeDiv.children().eq(0).insertBefore(qaResizebBtnDiv);
                        else {
                            qaResizeDiv.children().insertBefore(qaResizebBtnDiv);
                            this.element.find('.e-qaresizebtndiv').remove();
                            qaResizeDiv.remove();
                        }
                    }
                }
                qaResizeDiv.hide();
            }
        },
        _createResizeBtn: function (i, j) {
            var groupText, grpWidth, ribTabContents = this.element.find('.e-content.e-content-item'), curGroup, grpContents, grpHeight;
            curGroup = ribTabContents.eq(i).children('.e-groupdiv').eq(j);
            grpHeight = curGroup.height();
			var groupId = ej.isNullOrUndefined(this.model.tabs[i-1].groups[j].id) ? this.model.tabs[i-1].groups[j].text  : this.model.tabs[i-1].groups[j].id;
            groupText = curGroup.find('.e-contentbottom').text();
            grpContents = curGroup.children().not('.e-contentbottom');
            grpWidth = grpContents.width();
            if (ej.isNullOrUndefined(this._responsiveContentStyle))
                this._responsiveContentStyle = { "height": grpHeight };
            curGroup.children().hide();
            grpContents.css("width", grpWidth);
            var rBtnDiv = ej.buildTag("div.e-resizegroupdiv#" + this._id + "_" + "resizeDiv" + "_" + groupId);
            var rBtn = ej.buildTag("button#" + this._id + "_" + "resizebtn" + "_" + groupId, groupText, {}, { type: "button" }).addClass("e-resizebtn e-rbn-button")
            var data = { target: ribTabContents.eq(i).children('.e-groupdiv').eq(j).children() };
            rBtn.ejButton({
                click: $.proxy(this._resizeBtnClick, data),
                contentType: ej.ContentType.TextAndImage,
                imagePosition: ej.ImagePosition.ImageBottom,
                prefixIcon: "e-icon e-ribbonresize"
            });
            curGroup.height(grpHeight);
            rBtn.find('div').prepend("<span class='e-icon e-" + groupText + "'></span>").height(grpHeight - 5);
            rBtn.appendTo(rBtnDiv);
            rBtnDiv.appendTo(ribTabContents.eq(i).children('.e-groupdiv').eq(j));
        },
        _resizeBtnClick: function (args) {

        },
        _responsiveCustomize: function (responsivecontent) {
            responsivecontent.find(".e-rbn-resize").parents(".e-controlpadding").addClass("e-rbn-resize").addClass("e-rbn-dll-cus");
            responsivecontent.find(".e-rbn-resize").parents(".e-innerdivrow").addClass("e-rbn-resize").next().css("display", "inline-block");
        },
        _responsiveContentShow: function (responsivecontent) {
            var content = this.element.find(".e-active-content");
            this._responsiveCustomize(responsivecontent);
            content.addClass("e-reshide");
            responsivecontent.addClass("e-resshow");
            this.element.find(".e-responsivecontent .e-ribGroupContent").addClass("e-resshow");
            if (responsivecontent.find(".e-ribGroupContent").height() > this._responsiveHeight) {
                var div = ej.buildTag("div#" + this._id + "_responsivecontentScroll").addClass("e-rescontentScroll").append(ej.buildTag("div"));
                div.find("div").append(responsivecontent.children(".e-ribGroupContent"));
                responsivecontent.append(div);
                responsivecontent.find(".e-rescontentScroll").ejScroller({ height: this._responsiveHeight, scrollerSize: 8, buttonSize: 0 });
            }
           content.find(".e-resizebtnselect").removeClass("e-resizebtnselect");
        },
        _responsiveContentBack: function () {
            this._responsiveTarget.append(this._responsiveContent).find(".e-ribGroupContent").addClass("e-reshide").css(this._responsiveContentStyle);
            this._responsiveContent = null;
            this.element.find(".e-resizebtn.e-active").removeClass("e-active e-resizebtnselect");
            if (this.element.find(".e-galleryexpand.e-gallerymoveicon").length > 0)
                this.element.find(".e-galleryexpand.e-gallerymoveicon").trigger("click")
            this.element.find(".e-content.e-responsivecontent").children().not(".e-responsiveback").remove();
            this.element.find(".e-active-content").removeClass("e-reshide");
            this.element.find(".e-responsivecontent").removeClass("e-resshow");
        },
        _ribbonDocClick: function (e) {
            if (this.element.hasClass("e-responsive")) {
                var target = e.target, args = {}, proxy = this;
                var responsiveBackstage = this.element.find(".e-responsivebackstage"), respTabHeader = this.element.find(".e-responsivetabheader");
                var content = this.element.find(".e-active-content");
                var responsebackstage = this.element.find(".e-responsivebackstage");
                if (((!$(e.target).parents(".e-ribbon").length > 0 && !(e.target == document.documentElement) && !$(e.target).parents(".e-rbn-ddl").length > 0) && !$(e.target).parents(".e-popup").length > 0) && !this.element.find(".e-responsivecontent").is(":visible")) {
                    respTabHeader.removeClass("e-resshow");
                    if (responsiveBackstage.is(":visible"))
                        responsiveBackstage.removeClass("e-backstageshowanimate");
                    if (this.element.find(".e-responsivecontent").is(":visible"))
                        this._responsiveContentBack();
                    this.element.find(".e-responsivebackstagecontent").hide();
                    if (!content.hasClass("e-responsiveheight")) {
                        content.addClass("e-responsiveheight e-rbnmobheader");
                        this._responsiveScrollRemove();
                        content.find(".e-groupresponsive.e-ribuparrow").removeClass("e-ribuparrow").addClass("e-ribdownarrow")
                        args.isMobile = this.element.hasClass("e-responsive");
                        args.target = target;
                        args.currentTarget = e.currentTarget
                        args.eventType = e.type
                        this.element.find('.e-content.e-content-item').on("webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend",
                            function (event) {
                                    proxy._trigger("collapse", args);
                            });
                    }
                    return;
                }
                if ($(target).hasClass("e-header") || $(target).hasClass("e-ribGroupContent") || $(target).hasClass("e-groupresponsive") || $(target).hasClass("e-respmobcontent")) {
                    if (respTabHeader.hasClass("e-resshow"))
                        respTabHeader.removeClass("e-resshow");
                    if (responsiveBackstage.is(":visible"))
                        responsiveBackstage.removeClass("e-backstageshowanimate");
                }
                if ($(target).parent().hasClass("e-backstagerestopcontent") && !$(".e-ddl-popup").is(":visible")) {
                    $(target).parents(".e-responsivebackstagecontent").hide();
                    return;
                }
                else return;
            }
            var resizeDiv, resizeContent, expClick, gallery, gryColumns, contentHeight, toolTip, control, modelDivCon, activeContent, disabled;
            var popup, galExpandCont = this.element.find(".e-gallexpandcontent");
            modelDivCon = this.element.find("#" + this._id + "_modelDiv");
            activeContent = this.element.find(".e-active-content");
            if (modelDivCon.is(':visible'))
                modelDivCon.hide();
            if (galExpandCont.hasClass('e-gallerypopupshow')) {
                galExpandCont.removeClass("e-gallerypopupshow")
                modelDivCon.hide();
            }
            if ($(".e-rbn-splitbtn").parents().hasClass('e-active') || this.element.find('.e-resizebtn').hasClass('e-resizebtnselect') || $('.e-ddl-popup.e-rbn-ddl:visible').length > 0 || this.element.find('.e-colorwidget').hasClass('e-active')) {
                activeContent.append(modelDivCon.show().height("100%"));
            }
            popup = $('.e-ribbonpopup:visible');
            if (popup.length > 0 && !popup.hasClass("e-ribbonpopupshow")) {
                popup.addClass("e-ribbonpopupshow");
                activeContent.append(modelDivCon.show().height("100%"));
            }
            else if (popup.hasClass("e-ribbonpopupshow"))
                popup.removeClass("e-ribbonpopupshow");
            if ($(e.target).hasClass("e-expgallerydiv") || $(e.target).parents(".e-expgallerydiv").length > 0) {
                galExpandCont.addClass("e-gallerypopupshow");
                activeContent.append(modelDivCon.show().height("100%"));
            }
            if ($(e.target).hasClass('e-gallerymoveicon') || $(e.target).hasClass('e-gallerymovediv') || $(e.target).hasClass('e-expgallerydiv') || $(e.target).hasClass('e-scrollbar') || $(e.target).parents().hasClass('e-scrollbar'))
                expClick = e.target;
            else if ($(e.target).parents().hasClass('e-gallerymenu')) {
                if ($(e.target).hasClass('e-haschild') || $(e.target).hasClass('aschild') || $(e.target).hasClass('e-arrows'))
                    expClick = e.target;
            }
            if (ej.isNullOrUndefined(expClick))
                this._ribbonGalleryShow();
            toolTip = this.element.find('.e-tooltipdiv');
            disabled = $(e.target).find('.e-disable');
            if (toolTip.is(':visible') && $(disabled).length <= 0 && (!$(e.target).hasClass('e-disable')))
                toolTip.hide();
            if ($(e.target).hasClass('e-backstagechild') || $(e.target).parents('.e-backstagechild').length > 0 || $(e.target).hasClass('e-ribbonbackstagepage') || $(e.target).hasClass('e-apptab') || $(e.target).parents('.e-ribbonbackstagepage').length > 0 || $(e.target).parents('.e-apptab').length > 0)
                expClick = e.target;
			if(ej.isNullOrUndefined(expClick) && $(document).find($(e.target)).length==0)
			 expClick=$(e.currentTarget.activeElement);
            if (ej.isNullOrUndefined(expClick))
                this.element.find(".e-ribbonbackstagepage").hide();
            if (!$(e.target).hasClass('e-disable-item') && $(e.target).parents('.e-disable-item').length <= 0)
                this.element.find(".e-controlclicked").removeClass('e-controlclicked');
            control = $(e.target).parents('.e-controlpadding');
            if (control.length > 0 && $(disabled).length <= 0 && (!$(e.target).hasClass('e-disable')))
                if ($(control).find('.e-ribbongallerycontrol').length <= 0)
                    $(control).addClass('e-controlclicked');
            if (this.element.find('.e-ribbonpin').is(':visible') && $(e.target).parents('.e-ribbon').length <= 0 && !$(e.target).hasClass('e-scrollbar') && !$(e.target).parents().hasClass('e-scrollbar'))
                this.collapse();
            if (this.element.find('.e-resizediv').is(':hidden'))
                this.element.find('.e-resizebtnselect').removeClass('e-resizebtnselect e-active');
            this._tabUl.find('.e-link.e-active').removeClass('e-active');
            if (this.model.showQAT) {
                var qaMenu = this.element.find('.e-rbnqatmenu'), qaResizeDiv = this.element.find('.e-qaresizediv'), splitBtnQat = this.element.find('.e-splitbtnqat');
                if (!$(e.target).hasClass('e-splitbtnqatdiv') && $(e.target).parents('.e-splitbtnqatdiv').length <= 0 && $(e.target).parents('.e-rbnqatmenu').length <= 0)
                    qaMenu.hide().css({ top: '', left: '' });
                if (!$(e.target).hasClass('e-qaresizebtndiv') && qaMenu.is(':hidden') && $(e.target).parents('.e-qaresizediv').length <= 0 && $(e.target).parents('.e-qaresizebtndiv').length <= 0 && !$(e.target).hasClass('e-splitbtnqatdiv') && $(e.target).parents('.e-splitbtnqatdiv').length <= 0)
                    qaResizeDiv.hide().css({ top: '', left: '' });
                if (qaResizeDiv.is(':hidden') && this.element.find('.e-qaresizebtn').hasClass('e-active') && !$(e.target).hasClass('e-qaresizebtndiv') && $(e.target).parents('.e-qaresizebtndiv').length <= 0 && $(e.target).parents('.e-rbnqatmenu').length <= 0)
                    this.element.find('.e-qaresizebtn').removeClass('e-tbtn e-active');
                if (splitBtnQat.hasClass('e-active') && !$(e.target).hasClass('e-splitbtnqatdiv') && $(e.target).parents('.e-splitbtnqatdiv').length <= 0 && $(e.target).parents('.e-rbnqatmenu').length <= 0)
                    splitBtnQat.removeClass('e-tbtn e-active');
            }
        },
        _ribbonGalleryShow: function () {
            var startIndex = 0;
            if (this.element.find('.e-gallexpandcontent:visible').length > 0) {
                var visibleRows = 0, n = 0;
                gallery = this.element.find('.e-gallexpandcontent:visible').parent().find('.e-ribbongallery');
                var galleryRowlen = gallery.find('.e-galleryrow').length;
                for (var i = 1; i <= galleryRowlen; i++) {
                    if (gallery.find('.e-galleryrow').eq(i - 1).css('display') === "block") {
                        if (visibleRows === 0)
                            startIndex = i - 1;
                        ++visibleRows;
                    }
                }
                gallery.find('.e-galleryrow').hide();
                gallery.parent().find('.e-gallexpandcontent').hide();
                gallery.show();
                gryColumns = gallery.find('.e-galleryrow').eq(0).children().length;
                gallery.find('.e-galleryrow').eq(0).children().remove();
                var galleryRowlen = gallery.find('.e-galleryrow').length;
                for (var k = 0; k < galleryRowlen; k++) {
                    for (var l = 0; l < gryColumns; l++) {
                        var activeBtn = gallery.parent().find('.e-galleryexpanderrow').children().eq(0);
                        if ($(activeBtn).hasClass("e-galleryselect")) {
                            gallery.find('.e-galleryrow').eq(k).append(gallery.parent().find('.e-galleryexpanderrow').children().eq(0)).show();
                            --visibleRows;
                            for (var i = 1; i <= visibleRows; i++) {
                                if (gallery.find('.e-galleryrow').eq(k + i).length > 0)
                                    gallery.find('.e-galleryrow').eq(k + i).show();
                                else {
                                    ++n;
                                    gallery.find('.e-galleryrow').eq(k - n).show();
                                }
                            }
                            if (!gallery.find('.e-galleryrow').last().is(':visible'))
                                gallery.parent().find('.e-movedowndiv').removeClass('e-disablegrymovebtn');
                            else
                                gallery.parent().find('.e-movedowndiv').addClass('e-disablegrymovebtn');
                            if (gallery.find('.e-galleryrow').first().is(':visible'))
                                gallery.parent().find('.e-moveupdiv').addClass('e-disablegrymovebtn');
                            else
                                gallery.parent().find('.e-moveupdiv').removeClass('e-disablegrymovebtn');
                        }
                        else
                            gallery.find('.e-galleryrow').eq(k).append(gallery.parent().find('.e-galleryexpanderrow').children().eq(0));
                    }
                }
                if (gallery.find('.e-galleryselect').length <= 0) {
                    for (var i = 0; i < visibleRows; i++) {
                        gallery.find('.e-galleryrow').eq(startIndex).show();
                        ++startIndex;
                    }
                }
                gallery.parent().find('.e-galleryexpanderrow').remove();
            }
        },
        _resizeDivHide: function () {
            var resizeArea = this.element.find('.e-resizediv'), resizeCon;
            this._off($(document), "mousedown", this._rbndocumentClick);
            if ($(resizeArea).is(":visible")) {
                resizeCon = $(resizeArea).children().eq(0).attr("id");
                if (!ej.isNullOrUndefined(resizeCon)) {
                    resizeCon = "#" + resizeCon.slice(0, -8);
                    $(resizeArea).children().hide().appendTo(resizeCon);
                    this.element.find("#" + this._id + "_disabled").hide();
                    $(resizeArea).hide();
                }
                if (this.element.find('.e-ribbonpin').length > 0)
                    $(resizeArea).css({ 'top': '' });
            }
        },
        _resizeDivShow: function (resizeDiv) {
            var contentWidth, contentLeft, curGroup, rDivPadding, resizeArea = this.element.find('.e-resizediv');
            curGroup = this.element.find("#" + resizeDiv[0].id).parent().siblings();
            contentWidth = curGroup.not('.e-contentbottom').width() + curGroup.parent().offset().left;
            if (this.model.enableRTL)
                contentWidth = curGroup.not('.e-contentbottom').width() + (this.element.width() + this.element.offset().left - curGroup.parent().offset().left);
            this.element.css({ "position": "relative" });
            $(resizeArea).css({ 'left': '' });
            if (contentWidth > this.element.width() + this.element.offset().left) {
                contentLeft = curGroup.parent().position().left - (contentWidth - (this.element.width() + this.element.offset().left));
                if (this.model.enableRTL)
                    contentLeft = this.element.width() + (this.element.offset().left - curGroup.parent().offset().left) - (contentWidth - (this.element.width() + this.element.offset().left - curGroup.parent().width()))
                rDivPadding = parseInt($(resizeArea).css('padding-left'), 10) + parseInt($(resizeArea).css('padding-right'), 10);
                if (this.model.enableRTL)
                    $(resizeArea).css({ right: contentLeft + rDivPadding - 1 });
                else
                    $(resizeArea).offset({ left: contentLeft - rDivPadding });
            }
            else
                if (this.model.enableRTL)
                    $(resizeArea).css({ right: this.element.width() + (this.element.offset().left - curGroup.parent().offset().left) - curGroup.parent().outerWidth() });
                else
                    $(resizeArea).offset({ left: curGroup.parent().position().left });
            if (this.element.find('.e-ribbonpin').length > 0)
                $(resizeArea).offset({ top: this.element.height() + this.element.find('.e-active-content').eq(0).height() });
            $(resizeArea).width(curGroup.not('.e-contentbottom').css("width"));
            $(resizeArea).append(curGroup.show()).show();
            if (this.element.hasClass("e-grpdivhide")) {
                this.element.removeClass("e-grpdivhide");
                this.element.find('.e-active-content').eq(0).addClass("e-resdivshow");
            }
            this._on($(document), "mousedown", this._rbndocumentClick);
        },
        _rbndocumentClick: function (e) {
            if (this.element.find('.e-resizediv').is(":visible") && $(e.target).parents('.e-resizediv').length <= 0 && $(e.target).parents('.e-rbn-ddl').length <= 0 && !$(e.target).hasClass('e-rbn-splitbtn') && $(e.target).parents('.e-colorpicker.e-ribbon:visible').length <= 0 && $(e.target).parents('.e-rbn-splitbtn:visible').length <= 0)
                this._resizeDivHide();
            if (this.element.find('.e-resizediv').is(':hidden'))
                this.element.find('.e-resizebtnselect').removeClass('e-resizebtnselect e-active');
        },
        _ribbonDocRightClick: function (e) {
            var resizeDiv, toolTip;
            resizeDiv = $(e.target).parents('.e-resizediv');
            if (resizeDiv.length <= 0)
                this._resizeDivHide();
            if (this.element.find('.e-resizediv').is(':hidden'))
                this.element.find('.e-resizebtnselect').removeClass('e-resizebtnselect e-active');
            if (this.element.find(".e-gallexpandcontent").hasClass('e-gallerypopupshow'))
                this._ribbonGalleryShow();
            if ($(this.element.find(".e-ribbonbackstagepage")).is(':visible'))
                this.element.find(".e-ribbonbackstagepage").hide();
            toolTip = this.element.find('.e-tooltipdiv');
            if (toolTip.is(':visible'))
                toolTip.hide();
        },
        _onTabDblClick: function (e) {
            if (this._phoneMode)
                return;
            if (this.element.find('.e-apptab .e-menu ul').is(":visible") || this.element.find('.e-ribbonbackstagepage').is(":visible"))
                return;
            if (!$(e.target).closest(".e-tab.e-disable").length) {
                if (this.element.find('.e-collapsed .e-rarrowup-2x').length)
                    this.expand();
                if (this.element.find('.e-expanded .e-rarrowup-2x').length)
                    this.collapse();
                if (this.element.find('.e-expanded.e-ribbonpin').length)
                    this._removeRibbonPin();
            }
            this._clickValue = e.type;
        },
        _ribbonhover: function (e) {
            if (!this._phoneMode)
                return;
            if (e.type == "mouseover") {
                if ($(e.currentTarget).hasClass("e-resizegroupdiv"))
                    $(e.currentTarget).addClass("e-reshover");
            }
            else if (e.type == "mouseout") {
                if ($(e.currentTarget).hasClass("e-resizegroupdiv e-reshover"))
                    $(e.currentTarget).removeClass("e-reshover");
            }

        },

        _wireEvents: function () {
            this._on($(document), "keydown", this._OnKeyDown);
            this._on(this.element, "keydown", this._ribbonKeyDown);
            this._on(this.element, "mouseover mouseout", ".e-resizegroupdiv", this._ribbonhover);
            this._on(this.element.find("#" + this._id + "_expandCollapse"), ej.eventType.click, this._tabExpandCollapse);
            this._on(this.element.find(".e-groupexpander"), ej.eventType.click, this._onGroupExpandClick);
            this._on(this.element.find(".e-qatmenuli"), ej.eventType.click, this._onQatMenuItemClick);
            this._on($(window), 'resize', this._ribbonWindowResize);
            this._on($(document), 'click', this._ribbonDocClick);
            this._on($(document), "contextmenu", this._ribbonDocRightClick);
            this._on(this.element.find('.e-header > li'), "dblclick", this._onTabDblClick);
        }
    });
    ej.Ribbon.alignType = {
        rows: "rows",
        columns: "columns"
    };
    ej.Ribbon.AlignType = {
        Rows: "rows",
        Columns: "columns"
    };
    ej.Ribbon.applicationTabType = {
        menu: "menu",
        backstage: "backstage"
    };
    ej.Ribbon.ApplicationTabType = {
        Menu: "menu",
        Backstage: "backstage"
    };
    ej.Ribbon.quickAccessMode = {
        none: "none",
        toolBar: "toolbar",
        menu: "menu"
    };
    ej.Ribbon.QuickAccessMode = {
        None: "none",
        ToolBar: "toolbar",
        Menu: "menu"
    };
    ej.Ribbon.type = {
        button: "button",
        splitButton: "splitbutton",
        dropDownList: "dropdownlist",
        custom: "custom",
        toggleButton: "togglebutton",
        gallery: "gallery"
    };
    ej.Ribbon.Type = {
        Button: "button",
        SplitButton: "splitbutton",
        DropDownList: "dropdownlist",
        Custom: "custom",
        ToggleButton: "togglebutton",
        Gallery: "gallery"
    };
    ej.Ribbon.customItemType = {
        button: "button",
        menu: "menu"
    };
    ej.Ribbon.CustomItemType = {
        Button: "button",
        Menu: "menu"
    };
    ej.Ribbon.itemType = {
        button: "button",
        tab: "tab"
    };
    ej.Ribbon.ItemType = {
        Button: "button",
        Tab: "tab"
    };

    ej.Ribbon.Locale = ej.Ribbon.Locale || {};

    ej.Ribbon.Locale['default'] = ej.Ribbon.Locale["en-US"] = {
        CustomizeQuickAccess: "Customize Quick Access Toolbar",
        RemoveFromQuickAccessToolbar: "Remove from Quick Access Toolbar",
        AddToQuickAccessToolbar: "Add to Quick Access Toolbar",
        ShowAboveTheRibbon: "Show Above the Ribbon",
        ShowBelowTheRibbon: "Show Below the Ribbon",
        MoreCommands: "More Commands..."
    };
})(jQuery, Syncfusion);;
var InternalAdaptive = (function () {
    function InternalAdaptive(element) {
        this.kanbanObj = null;
        this.kanbanObj = element;
    }
    ;
    InternalAdaptive.prototype._kbnTimeoutSearch = function ($kanbanEle, sender) {
        var kanbanObj = $kanbanEle.data("ejKanban"), target;
        target = sender.currentTarget;
        if (kanbanObj._searchTout)
            kanbanObj._searchTout = window.clearInterval(kanbanObj._searchTout);
        kanbanObj._searchTout = window.setInterval(function () {
            $('.e-kanbanwaitingpopup').removeClass('e-kanbanwaitingpopup').addClass('e-kbnsearchwaitingpopup');
            $kanbanEle.data("ejWaitingPopup").show();
            $('.e-kbnsearchwaitingpopup').css({ 'top': '1px', 'left': '1px' });
            var timeot = setTimeout(function () {
                var val = $(target).find("input").val();
                if (ej.isNullOrUndefined(val))
                    val = $(target).val();
                var args = {
                    itemName: target.title, itemId: target.id, target: target, currentTarget: target,
                    itemIndex: $(target).index(), toolbarData: sender, itemText: val
                };
                kanbanObj._trigger("toolbarClick", args);
                kanbanObj.KanbanFilter.searchCards(val);
                kanbanObj.element.find('.e-searchbar .e-search.e-tooltxt').addClass('e-highliht-kbnsearchbar');
                $('.e-kbnsearchwaitingpopup').addClass('e-kanbanwaitingpopup').removeClass('e-kbnsearchwaitingpopup').css({ 'top': '0px', 'left': '0px' });
                if (!ej.isNullOrUndefined(kanbanObj.model.fields.swimlaneKey)) {
                    var query = new ej.Query().where(ej.Predicate["or"](kanbanObj.keyPredicates)).select(kanbanObj.model.fields.swimlaneKey);
                    kanbanObj._kbnAdaptDdlData = new ej.DataManager(kanbanObj._currentJsonData).executeLocal(query);
                    kanbanObj._kbnAdaptDdlData = ej.dataUtil.mergeSort(ej.dataUtil.distinct(kanbanObj._kbnAdaptDdlData));
                    kanbanObj.KanbanAdaptive._adaptiveSwimlaneRefresh();
                }
                $kanbanEle.data("ejWaitingPopup").hide();
                clearTimeout(timeot);
            }, 300);
            kanbanObj._searchTout = window.clearInterval(kanbanObj._searchTout);
        }, 1000);
    };
    InternalAdaptive.prototype._kbnRightSwipe = function () {
        var kObj = this.kanbanObj, eleWidth = kObj.element.width(), rowCell = kObj.element.find('.e-rowcell:visible'), eqWidth, sHeader = kObj.element.find('.e-stackedHeaderCell'), tCount = 0, prevCount, count, curEle, proxy = kObj;
        if (kObj._kbnSwipeCount > 0) {
            if (kObj._kbnSwipeCount == 1)
                kObj._kbnSwipeWidth = 0;
            else {
                curEle = rowCell.eq(kObj._kbnSwipeCount - 1);
                if (curEle.length == 0)
                    curEle = kObj.element.find(".e-headercell:visible").not(".e-stackedHeaderCell").eq(kObj._kbnSwipeCount - 1);
                kObj._kbnSwipeWidth = kObj._kbnSwipeWidth - curEle.offset().left;
                if (window.matchMedia("(max-width: 600px)").matches || window.matchMedia("(max-device-width: 800px)").matches)
                    eqWidth = (eleWidth - curEle.width()) / 2;
                else if (window.matchMedia("(max-width: 801px)").matches || window.matchMedia("(max-device-width: 1200px)").matches)
                    eqWidth = (eleWidth - curEle.width()) / 8;
                kObj._kbnSwipeWidth = kObj._kbnSwipeWidth + eqWidth;
            }
            for (var i = 0; i < sHeader.length; i++) {
                var leftVal = kObj.headerContent.find('col:eq(0)').width();
                prevCount = tCount, count = kObj._kbnSwipeCount - 1;
                tCount = tCount + (parseInt($(sHeader).eq(i).attr('colspan')));
                if (count >= prevCount && count < tCount) {
                    if (prevCount == kObj._kbnSwipeCount - 1) {
                        kObj.element.find('.e-adapt-stheader').removeClass('e-adapt-stheader');
                        $(sHeader).eq(i).find('div').css({ 'position': '', 'left': '' });
                        var prevHeader = $(sHeader).eq(i).prev('.e-stackedHeaderCell');
                        if (prevHeader.length > 0)
                            prevHeader.addClass('e-adapt-stheader');
                        break;
                    }
                    else if (prevCount < kObj._kbnSwipeCount - 1) {
                        $(sHeader).eq(i).find('div').css({ 'position': 'relative', 'left': (leftVal * ((kObj._kbnSwipeCount - 1) - prevCount)) + (8 * (count - 1)) });
                        break;
                    }
                }
            }
            kObj._kbnTransitionEnd = false;
            if (kObj._kbnSwipeCount > 1)
                kObj._kbnSwipeWidth = kObj._kbnSwipeWidth + kObj.element.offset().left;
            kObj.headerContent.find('table').css({ 'transform': 'translate3d(' + kObj._kbnSwipeWidth + 'px, 0px, 0px)', 'transition-duration': '' }).one("webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend", function (event) {
                proxy._kbnTransitionEnd = true;
            });
            kObj.kanbanContent.find('table').eq(0).css({ 'transform': 'translate3d(' + kObj._kbnSwipeWidth + 'px, 0px, 0px)', 'transition-duration': '' });
            --kObj._kbnSwipeCount;
        }
    };
    InternalAdaptive.prototype._kbnLeftSwipe = function () {
        var kObj = this.kanbanObj, eleWidth = kObj.element.width(), rowCell = kObj.element.find('.e-rowcell:visible'), eqWidth, sHeader = kObj.element.find('.e-stackedHeaderCell'), tCount = 0, prevCount, count, curEle, proxy = kObj;
        if (((window.matchMedia("(max-width: 600px)").matches || window.matchMedia("((max-device-width: 800px)").matches) && kObj._kbnSwipeCount < kObj.model.columns.length - 1) || ((window.matchMedia("(max-width: 801px)").matches || window.matchMedia("(max-device-width: 1200px)").matches) && kObj._kbnSwipeCount < kObj.model.columns.length - 2)) {
            curEle = rowCell.eq(kObj._kbnSwipeCount + 1);
            if (curEle.length == 0)
                curEle = kObj.element.find(".e-headercell:visible").not(".e-stackedHeaderCell").eq(kObj._kbnSwipeCount + 1);
            kObj._kbnSwipeWidth = kObj._kbnSwipeWidth - (curEle.offset().left);
            if (window.matchMedia("(max-width: 600px)").matches || window.matchMedia("(max-device-width: 800px)").matches) {
                if (kObj._kbnSwipeCount == kObj.model.columns.length - 2)
                    eqWidth = eleWidth - curEle.width();
                else
                    eqWidth = (eleWidth - curEle.width()) / 2;
            }
            else if (window.matchMedia("(max-width: 801px)").matches || window.matchMedia("(max-device-width: 1200px)").matches) {
                if (kObj._kbnSwipeCount == kObj.model.columns.length - 3) {
                    var columnSpace = parseInt(kObj.contentTable.css('border-spacing').split('px')[0]);
                    eqWidth = eleWidth - ((curEle.width() + columnSpace) * 2);
                }
                else
                    eqWidth = (eleWidth - curEle.width()) / 8;
            }
            kObj._kbnSwipeWidth = kObj._kbnSwipeWidth + eqWidth;
            for (var i = 0; i < sHeader.length; i++) {
                var leftVal = kObj.headerContent.find('col:eq(0)').width();
                prevCount = tCount, count = kObj._kbnSwipeCount + 1;
                tCount = tCount + (parseInt($(sHeader).eq(i).attr('colspan')));
                if (count > prevCount && count < tCount) {
                    if (i == 0) {
                        $(sHeader).eq(i).addClass('e-adapt-stheader');
                        $(sHeader).eq(i).find('div').css({ 'position': 'relative', 'left': (leftVal * count) + (8 * (count - 1)) });
                        break;
                    }
                    else if (prevCount == kObj._kbnSwipeCount + 1) {
                        kObj.element.find('.e-adapt-stheader').removeClass('e-adapt-stheader');
                        $(sHeader).eq(i - 1).find('div').css({ 'position': '', 'left': '' });
                        $(sHeader).eq(i).addClass('e-adapt-stheader');
                        break;
                    }
                    else if (prevCount < kObj._kbnSwipeCount + 1) {
                        $(sHeader).eq(i).find('div').css({ 'position': 'relative', 'left': (leftVal * ((kObj._kbnSwipeCount + 1) - prevCount)) + (8 * (count - 1)) });
                        break;
                    }
                }
            }
            kObj._kbnTransitionEnd = false;
            kObj._kbnSwipeWidth = kObj._kbnSwipeWidth + kObj.element.offset().left;
            kObj.headerContent.find('table').css({ 'transform': 'translate3d(' + kObj._kbnSwipeWidth + 'px, 0px, 0px)', 'transition-duration': '' }).one("webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend", function (event) {
                proxy._kbnTransitionEnd = true;
            });
            kObj.kanbanContent.find('table').eq(0).css({ 'transform': 'translate3d(' + kObj._kbnSwipeWidth + 'px, 0px, 0px)', 'transition-duration': '' });
            ++kObj._kbnSwipeCount;
        }
    };
    InternalAdaptive.prototype._clearAdaptSearch = function (e) {
        var kObj = this.kanbanObj, $target, $kanbanEle = kObj.element, $kanbanObj = $kanbanEle.data('ejKanban');
        if (!ej.isNullOrUndefined(e))
            $target = $(e.target);
        if (!ej.isNullOrUndefined($target))
            $target.hide();
        $kanbanEle.data("ejWaitingPopup").show();
        setTimeout(function () {
            var args, input;
            if (!ej.isNullOrUndefined($target))
                input = $target.prev('.e-input');
            if (ej.isNullOrUndefined(input) || input.length == 0) {
                if (!ej.isNullOrUndefined($target))
                    input = $target.next('.e-search').find('input');
                else
                    input = $kanbanEle.find('.e-kanbantoolbar .e-searchdiv > .e-input');
            }
            if (ej.isNullOrUndefined($target))
                args = { itemText: input.val() };
            else
                args = {
                    target: $target, currentTarget: $target,
                    itemIndex: $target.index(), toolbarData: e, itemText: input.val()
                };
            $kanbanObj._trigger("toolbarClick", args);
            kObj.KanbanFilter.searchCards("");
            kObj.element.find('.e-searchbar .e-search.e-tooltxt').removeClass('e-highliht-kbnsearchbar');
            if (!ej.isNullOrUndefined($kanbanObj.model.fields.swimlaneKey)) {
                var query = new ej.Query().where(ej.Predicate["or"]($kanbanObj.keyPredicates)).select($kanbanObj.model.fields.swimlaneKey);
                $kanbanObj._kbnAdaptDdlData = new ej.DataManager($kanbanObj._currentJsonData).executeLocal(query);
                $kanbanObj._kbnAdaptDdlData = ej.dataUtil.mergeSort(ej.dataUtil.distinct($kanbanObj._kbnAdaptDdlData));
                $kanbanObj.KanbanAdaptive._adaptiveSwimlaneRefresh();
            }
            $kanbanEle.data("ejWaitingPopup").hide();
        }, 300);
    };
    InternalAdaptive.prototype._adaptiveKbnClick = function (e) {
        var kObj = this.kanbanObj, $target = $(e.target), filterWin, filterIcon, slWindow = kObj.element.find('.e-swimlane-window');
        if (kObj.element.hasClass('e-responsive')) {
            filterWin = $('.e-kanbanfilter-window');
            filterIcon = kObj.element.find('.e-kanbanfilter-icon');
            if ($target.hasClass('e-searchitem')) {
                var searchBar = $target.parents('.e-searchbar');
                $target.prev().show();
                $target.prev().children(":first").removeAttr('style');
                searchBar.siblings().hide();
                if (searchBar.find('.e-adapt-search').length == 0) {
                    var searchDiv = ej.buildTag('div.e-icon e-adapt-search e-searchfind', "", {}), cancelDiv;
                    cancelDiv = ej.buildTag('div.e-icon e-adapt-cancel e-cancel', "", {});
                    $target.siblings('.e-searchdiv').append(cancelDiv).prepend(searchDiv);
                }
                $target.parents('.e-search').css({ 'border': '' });
                $target.parents('body').addClass('e-kbnwindow-modal');
                $target.parents('.e-kanbantoolbar').addClass('e-adaptive-search');
                searchBar.find('.e-adapt-cancel').show();
                $target.hide();
                if (e.type === 'tap')
                    e.preventDefault();
            }
            if ($target.hasClass('e-adapt-cancel')) {
                this._clearAdaptSearch(e);
                $target.parents('.e-searchbar').siblings(".e-print,.e-kanbanfilter-icon,.e-customtoolbar").show();
                var search = $target.parents(".e-search");
                search.find('.e-searchdiv').hide();
                search.find('.e-searchitem').show();
                search.css({ 'border': 'none' });
                $target.parents('body').removeClass('e-kbnwindow-modal');
                $target.parents('.e-kanbantoolbar').removeClass('e-adaptive-search');
            }
            if ($target.hasClass('e-filter-done') || $target.hasClass('e-clearfilter')) {
                var text = $target.text(), args;
                filterWin.parents('body').removeClass('e-kbnwindow-modal');
                if ($target.hasClass('e-clearfilter'))
                    text = $target.val();
                args = {
                    target: $target, currentTarget: $target,
                    itemIndex: $target.index(), toolbarData: e, itemText: text
                };
                kObj._trigger("toolbarClick", args);
                if ($target.hasClass('e-clearfilter')) {
                    kObj._kbnFilterCollection = [];
                    kObj._kbnFilterObject = [];
                    kObj._filterCollection = [];
                    kObj._kbnAdaptFilterObject = [];
                    $target.hide();
                    filterIcon.removeClass('e-kbnclearfl-icon');
                    filterWin.find('.e-kbnfilter-check').parents('[aria-checked~="true"]').click();
                }
                else {
                    if (!filterIcon.hasClass('e-kbnclearfl-icon'))
                        filterIcon.addClass('e-kbnclearfl-icon');
                    if (kObj._kbnFilterObject.length == 0 && filterIcon.hasClass('e-kbnclearfl-icon'))
                        filterIcon.removeClass('e-kbnclearfl-icon');
                }
                args = {};
                args.requestType = ej.Kanban.Actions.Filtering;
                args.currentFilterObject = [];
                args.filterCollection = kObj._kbnFilterCollection;
                args.currentFilterObject = kObj._kbnFilterObject;
                var kbnCurrentData;
                if (!(kObj._dataSource() instanceof ej.DataManager))
                    kbnCurrentData = kObj._dataSource();
                else
                    kbnCurrentData = kObj._dataSource().dataSource.json;
                if (kbnCurrentData.length == 0 && kObj._currentJsonData.length > 0)
                    kbnCurrentData = kObj._currentJsonData;
                kObj._initialData = kbnCurrentData;
                kObj.KanbanCommon._processBindings(args);
                if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                    if (kObj._currentJsonData.length == 0) {
                        kObj.element.find('.e-swimlane-ddl,.e-swimlane-window').remove();
                        kObj.kanbanContent.data('ejScroller').destroy();
                    }
                    else {
                        var query = new ej.Query().where(ej.Predicate["or"](kObj.keyPredicates)).select(kObj.model.fields.swimlaneKey);
                        kObj._kbnAdaptDdlData = new ej.DataManager(kObj._currentJsonData).executeLocal(query);
                        kObj._kbnAdaptDdlData = ej.dataUtil.mergeSort(ej.dataUtil.distinct(kObj._kbnAdaptDdlData));
                        kObj.KanbanAdaptive._adaptiveSwimlaneRefresh();
                    }
                }
                filterWin.hide();
                kObj.kanbanWindowResize();
                if (e.type === 'tap')
                    e.preventDefault();
            }
            if ($target.hasClass('e-filterback-icon')) {
                var filters = [], chk;
                for (var i = 0; i < kObj.model.filterSettings.length; i++)
                    filters.push(kObj.model.filterSettings[i].text);
                for (var i = 0; i < kObj._kbnAdaptFilterObject.length; i++) {
                    var text = kObj._kbnAdaptFilterObject[i].text, index;
                    index = $.inArray(text, filters);
                    filters.splice(index, 1);
                    chk = filterWin.find("label.e-filterlabel:contains(" + text + ")").prev();
                    if (chk.attr('aria-checked') == "false")
                        chk.click();
                }
                for (var i = 0; i < filters.length; i++) {
                    chk = filterWin.find("label.e-filterlabel:contains(" + filters[i] + ")").prev();
                    if (chk.attr('aria-checked') == "true")
                        chk.click();
                }
                filterWin.hide();
                if (e.type === 'tap')
                    e.preventDefault();
            }
            if ($target.hasClass('e-kanbanfilter-icon')) {
                var clear = filterWin.find('.e-clearfilter'), headHeight, cFilter, cFilterHght = 0, scrollContent;
                scrollContent = filterWin.find('.e-filter-scrollcontent');
                if (slWindow.is(':visible'))
                    slWindow.hide();
                filterWin.show();
                if ($target.hasClass('e-kbnclearfl-icon'))
                    clear.show();
                else
                    clear.hide();
                headHeight = filterWin.find('.e-kbnfilterwindow-head').height();
                cFilter = filterWin.find('.e-clearfilter');
                if (cFilter.is(":visible")) {
                    scrollContent.ejScroller({ height: 0, buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
                    cFilterHght = cFilter.outerHeight() + parseInt(cFilter.css('bottom'));
                }
                if ($(window).height() - cFilterHght < (filterWin.find('.e-filter-content').height() + headHeight)) {
                    scrollContent.ejScroller({ height: $(window).height() - (headHeight + cFilterHght + 10), buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
                }
                filterWin.parents('body').addClass('e-kbnwindow-modal');
                if (e.type === 'tap')
                    e.preventDefault();
            }
            if ($target.attr('id') == this._id + "_Cancel" || $target.parent().attr("id") == this._id + "_closebutton")
                kObj.KanbanEdit.cancelEdit();
            if ($target.attr('id') == kObj._id + "_Save")
                kObj.KanbanEdit.endEdit();
        }
        var slScroller = kObj.element.find('.e-slwindow-scrollcontent');
        if ($target.hasClass('e-swimlane-item') || $target.parents('.e-swimlane-item').length > 0) {
            var trgt = $target, rows, toolBar;
            if ($target.parents('.e-swimlane-item').length > 0)
                trgt = $target.parents('.e-swimlane-item');
            trgt.parents('.e-swimlane-ul').find('.e-selected-item').removeClass('e-selected-item');
            trgt.addClass('e-selected-item');
            slWindow = $('#' + kObj._id + '_slWindow');
            kObj._kbnAdaptDdlIndex = kObj._freezeSlOrder = slWindow.find('.e-swimlane-item').index(trgt);
            toolBar = $('#' + kObj._id + "_toolbarItems");
            toolBar.find('.e-kbnhide').removeClass('e-kbnhide');
            toolBar.removeClass('e-kbntoolbar-body').prependTo(kObj.element);
            slWindow.removeClass('e-kbnslwindow-body').appendTo(kObj.element).hide();
            kObj.element.find('.e-swimlane-text').text(kObj._kbnAdaptDdlData[kObj._kbnAdaptDdlIndex]);
            rows = kObj.element[0].getElementsByClassName('e-columnrow');
            kObj.kanbanWindowResize();
            var scroller = kObj.kanbanContent.data('ejScroller');
            scroller.scrollY(0, true);
            scroller.scrollY(($(rows[kObj._kbnAdaptDdlIndex]).offset().top - kObj.kanbanContent.offset().top), true);
            kObj._freezeScrollTop = scroller.scrollTop();
            if (slScroller.hasClass('e-scroller'))
                slScroller.data('ejScroller').refresh();
        }
        if ($target.hasClass('e-swimlane-ddl') || $target.parents('.e-swimlane-ddl').length > 0) {
            var top = 36, toolBar;
            if (slWindow.is(':hidden')) {
                kObj.element.parents('body').addClass('e-kbnwindow-modal');
                toolBar = kObj.element.find('.e-kanbantoolbar');
                toolBar.children().not('.e-swimlane-ddl').addClass('e-kbnhide');
                toolBar.addClass('e-kbntoolbar-body').appendTo('body');
                kObj.element.find('.e-swimlane-window').addClass('e-kbnslwindow-body').appendTo('body');
                slWindow.show();
                if ($(window).height() < top + slScroller.height())
                    slScroller.ejScroller({ height: $(window).height() - top, buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
            }
            else {
                slWindow.hide();
                toolBar = $('#' + kObj._id + "_toolbarItems");
                toolBar.find('.e-kbnhide').removeClass('e-kbnhide');
                toolBar.removeClass('e-kbntoolbar-body').prependTo(kObj.element);
                $('#' + kObj._id + '_slWindow').removeClass('e-kbnslwindow-body').appendTo(kObj.element).hide();
                kObj.element.parents('body').removeClass('e-kbnwindow-modal');
            }
        }
    };
    InternalAdaptive.prototype._kbnFilterChange = function (args) {
        var kObj = this, $kanbanEle = $(args.event.target).closest(".e-kanban"), kanbanObj = $kanbanEle.data("ejKanban");
        var filterName = $(args.event.target).parents('.e-chkbox-wrap').next().text(), kbnFilter, done, filterValue;
        if (!kObj["_kbnAutoFilterCheck"]) {
            if (filterName == "")
                filterName = $(args.event.target).next().text();
            kbnFilter = $kanbanEle.find('.e-kanbanfilter-icon');
            done = $('.e-kanbanfilter-window .e-filter-done');
            if (done.is(':hidden'))
                done.show();
            for (var count = 0; count < kObj["model"].filterSettings.length; count++) {
                if (kObj["model"].filterSettings[count]["text"] == filterName)
                    break;
            }
            filterValue = (count == kObj["model"].filterSettings.length ? null : kObj["model"].filterSettings[count]);
            if (!args.isChecked) {
                var index = $.inArray(filterValue, kObj["_kbnFilterObject"]);
                if (index >= 0) {
                    kObj["_kbnFilterObject"].splice(index, 1);
                    kObj["_kbnFilterCollection"].splice(index, 1);
                }
            }
            else {
                kObj["_kbnFilterObject"].push(filterValue);
                for (var i = 0; i < kObj["model"].filterSettings.length; i++) {
                    if (kObj["model"].filterSettings[i].text == filterValue.text) {
                        var query = kObj["model"].filterSettings[i].query["queries"][0].e;
                        kObj["_kbnFilterCollection"].push(query);
                    }
                }
            }
        }
    };
    InternalAdaptive.prototype._kbnAdaptSwimlaneData = function () {
        var kObj = this.kanbanObj, proxy = kObj;
        if (kObj.model.isResponsive && (ej.isNullOrUndefined(kObj.model.minWidth) || kObj.model.minWidth == 0) && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
            var query = new ej.Query();
            if (!ej.isNullOrUndefined(kObj.model.keyField))
                kObj._addColumnFilters();
            kObj.model.query["_fromTable"] != "" && query.from(kObj.model.query["_fromTable"]);
            if (kObj._dataSource() instanceof ej.DataManager && query["queries"].length && !kObj._dataManager.dataSource.offline) {
                var queryPromise = kObj._dataSource().executeQuery(query);
                queryPromise.done(ej.proxy(function (e) {
                    this._kbnAdaptDdlData = new ej.DataManager(e.result);
                    query = new ej.Query().where(ej.Predicate["or"](kObj.keyPredicates)).select(kObj.model.fields.swimlaneKey);
                    kObj._kbnAdaptDdlData = kObj._kbnAdaptDdlData.executeLocal(query);
                    kObj._kbnAdaptDdlData = ej.dataUtil.mergeSort(ej.dataUtil.distinct(kObj._kbnAdaptDdlData));
                }));
            }
            else {
                query = new ej.Query().where(ej.Predicate["or"](kObj.keyPredicates)).select(kObj.model.fields.swimlaneKey);
                if (kObj._dataManager.dataSource.offline && kObj._dataManager.dataSource.json.length)
                    kObj._kbnAdaptDdlData = kObj._dataManager.executeLocal(query);
                kObj._kbnAdaptDdlData = ej.dataUtil.mergeSort(ej.dataUtil.distinct(kObj._kbnAdaptDdlData));
            }
        }
    };
    InternalAdaptive.prototype._setResponsiveHeightWidth = function () {
        var kObj = this.kanbanObj;
        if (typeof (kObj.model.scrollSettings.width) == "string")
            kObj._originalScrollWidth = kObj.element.width();
        else if (kObj.model.scrollSettings.width > 0)
            kObj._originalScrollWidth = kObj.model.scrollSettings.width;
        if (typeof (kObj.model.scrollSettings.height) == "string")
            kObj._originalScrollHeight = kObj.getContent().height();
        else if (kObj.model.scrollSettings.height > 0)
            kObj._originalScrollHeight = kObj.model.scrollSettings.height;
        if (kObj.model.isResponsive) {
            $(window).on("resize", $.proxy(kObj.kanbanWindowResize, kObj));
            kObj.kanbanWindowResize();
        }
    };
    InternalAdaptive.prototype._renderResponsiveKanban = function (isScroller, elemHeight, width, winHeight, winWidth) {
        var kObj = this.kanbanObj;
        if (isScroller) {
            kObj.model.scrollSettings.width = ej.isNullOrUndefined(kObj._originalScrollWidth) ? Math.min(width, winWidth) : Math.min(kObj._originalScrollWidth, Math.min(width, winWidth));
            var height = Math.min(winHeight, elemHeight);
            height = ej.isNullOrUndefined(kObj._originalScrollHeight) ? height : Math.min(kObj._originalScrollHeight, winHeight);
            kObj.model.scrollSettings.height = height;
            if (kObj._originalScrollWidth < winWidth)
                kObj.model.scrollSettings.width = Math.min(width, winWidth);
            if (kObj.KanbanScroll)
                kObj.KanbanScroll._renderScroller();
        }
        else {
            kObj.model.scrollSettings.width = '100%';
            if (!ej.isNullOrUndefined(kObj._originalScrollWidth))
                kObj.model.scrollSettings.width = Math.min(kObj._originalScrollWidth, width);
            var height = kObj.element.outerHeight();
            if (!ej.isNullOrUndefined(kObj._originalScrollHeight))
                height = Math.min(kObj._originalScrollHeight, winHeight);
            kObj.model.scrollSettings.height = height;
            if (kObj.KanbanScroll)
                kObj.KanbanScroll._renderScroller();
        }
    };
    InternalAdaptive.prototype._columnTimeoutAdapt = function () {
        var kObj = this.kanbanObj;
        if (Math.floor(kObj.element.width()) > $(window).width()) {
            kObj.element.width(($(window).width() - kObj.element.offset().left) - 5);
            kObj.headerContent.removeClass('e-scrollcss');
            kObj.headerContent.find('.e-hscrollcss').removeClass('e-hscrollcss');
        }
        var eqwidth, hCell, rCell, sHeader, proxy = kObj, timeot, curEle;
        if (window.matchMedia("(max-width: 480px)").matches)
            eqwidth = (kObj.element.width() * (80 / 100));
        else if (window.matchMedia("(max-width: 600px)").matches || window.matchMedia("(max-device-width: 800px)").matches)
            eqwidth = (kObj.element.width() * (60 / 100));
        else if (window.matchMedia("(max-width: 801px)").matches || window.matchMedia("(max-device-width: 1200px)").matches)
            eqwidth = (kObj.element.width() * (43 / 100));
        hCell = kObj.element.find('.e-headercell');
        rCell = kObj.element.find('.e-columnrow .e-rowcell');
        kObj.kanbanContent.find('table:eq(0) > colgroup col').width(eqwidth);
        rCell.width(eqwidth);
        kObj.headerContent.find('table > colgroup col').width(eqwidth);
        hCell.not('.e-stackedHeaderCell').width(eqwidth);
        sHeader = kObj.element.find('.e-stackedHeaderCell');
        for (var i = 0; i < sHeader.length; i++)
            $(sHeader).eq(i).width(parseInt($(sHeader).eq(i).attr('colspan')) * eqwidth);
        timeot = setTimeout(function () {
            if (proxy._kbnSwipeCount > 0) {
                curEle = rCell.eq(proxy._kbnSwipeCount);
                if (curEle.length == 0)
                    curEle = hCell.not('.e-stackedHeaderCell').eq(kObj._kbnSwipeCount);
                proxy._kbnSwipeWidth = proxy._kbnSwipeWidth - curEle.offset().left;
                var eleWidth = proxy.element.width(), colWidth = curEle.width();
                if (window.matchMedia("(max-width: 600px)").matches || window.matchMedia("(max-device-width: 800px)").matches) {
                    if (proxy._kbnSwipeCount == proxy.model.columns.length - 1) {
                        if (proxy.element.hasClass('e-swimlane-responsive'))
                            eqwidth = eleWidth - (colWidth + 18);
                        else
                            eqwidth = eleWidth - colWidth;
                    }
                    else
                        eqwidth = (eleWidth - colWidth) / 2;
                }
                else if (window.matchMedia("(max-width: 801px)").matches || window.matchMedia("(max-device-width: 1200px)").matches) {
                    if (proxy._kbnSwipeCount == proxy.model.columns.length - 3) {
                        var columnSpace = parseInt(proxy.contentTable.css('border-spacing').split('px')[0]);
                        eqWidth = eleWidth - ((colWidth + columnSpace) * 2);
                    }
                    else
                        eqwidth = (eleWidth - colWidth) / 8;
                }
                proxy._kbnSwipeWidth = proxy._kbnSwipeWidth + eqwidth + kObj.element.offset().left;
                proxy.headerContent.find('table').css({ 'transform': 'translate3d(' + proxy._kbnSwipeWidth + 'px, 0px, 0px)', 'transition-duration': '0ms' });
                proxy.kanbanContent.find('table').eq(0).css({ 'transform': 'translate3d(' + proxy._kbnSwipeWidth + 'px, 0px, 0px)', 'transition-duration': '0ms' });
                clearTimeout(timeot);
            }
        }, 2500);
    };
    InternalAdaptive.prototype._addSwimlaneName = function () {
        var rows = this.kanbanObj.element.find('.e-columnrow');
        for (var i = 0; i < rows.length; i++) {
            var cells = rows.eq(i).find('.e-rowcell');
            for (var j = 0; j < cells.length; j++) {
                var $limit = cells.eq(j).find('.e-limits');
                if ($limit.length == 0)
                    $limit = ej.buildTag('div.e-limits', "", {}, {});
                if ($limit.find('.e-swimlane-name').length == 0) {
                    $limit.append(ej.buildTag('div.e-swimlane-name', this.kanbanObj._kbnAdaptDdlData[i], {}, {}));
                    cells.eq(j).prepend($limit);
                }
                else {
                    var name = $limit.find('.e-swimlane-name');
                    name.text(this.kanbanObj._kbnAdaptDdlData[i]);
                    name.show();
                    name.parents('.e-limits').show();
                }
            }
        }
    };
    InternalAdaptive.prototype._kbnAdaptSwimlaneDdl = function () {
        var kObj = this.kanbanObj, $ddl = ej.buildTag('div.e-swimlane-ddl', "", {}), curItem = kObj.model.fields.swimlaneKey, textDiv, slWindow, slItem, slScrollContent;
        var ddlItems = [], ddlTempl, $select, $option, data, uniqueData, toolbar = kObj.element.find('.e-kanbantoolbar');
        kObj.element.addClass('e-swimlane-responsive');
        ej.buildTag('div.e-swimlane-text', kObj._kbnAdaptDdlData[0]).appendTo($ddl);
        ej.buildTag('div.e-swimlane-arrow').appendTo($ddl);
        slWindow = ej.buildTag('div#' + kObj._id + '_slWindow.e-swimlane-window', "", {});
        slItem = ej.buildTag('ul.e-swimlane-ul ', "", {});
        for (var index = 0; index < kObj._kbnAdaptDdlData.length; index++)
            ej.buildTag('li.e-swimlane-item ', '<div>' + kObj._kbnAdaptDdlData[index] + '</div>', {}).appendTo(slItem);
        slItem.find('.e-swimlane-item:eq(0)').addClass('e-selected-item');
        this._addSwimlaneName();
        slScrollContent = ej.buildTag("div#" + kObj._id + "_slScrollContent", "<div></div>").addClass("e-slwindow-scrollcontent");
        slScrollContent.children().append(slItem);
        slScrollContent.appendTo(slWindow);
        slWindow.appendTo(kObj.element).hide();
        if (toolbar.length == 0) {
            kObj._renderToolBar().insertBefore(kObj.element.find(".e-kanbanheader").first());
            toolbar = kObj.element.find('.e-kanbantoolbar').css("padding", "0px").addClass('e-sladapt-bar');
        }
        toolbar.prepend($ddl);
        kObj.element.find('.e-swimlanerow').hide();
    };
    InternalAdaptive.prototype._kbnAdaptFilterWindow = function () {
        var kObj = this.kanbanObj, toolbar = kObj.element.find('.e-kanbantoolbar'), headDiv, bodyDiv, clearbtn, $div, filterIcon, $filterWin, filterScrollContent;
        toolbar.find('.e-quickfilter').parent().hide();
        $filterWin = ej.buildTag('div.e-kanbanfilter-window', "", {});
        headDiv = ej.buildTag('div.e-kbnfilterwindow-head', "", {});
        ej.buildTag('div.e-filterback-icon', "", {}).appendTo(headDiv);
        ej.buildTag('div.e-text', "FILTER", {}).appendTo(headDiv);
        ej.buildTag('div.e-text e-filter-done', "DONE", {}).appendTo(headDiv).hide();
        headDiv.appendTo($filterWin);
        $('body').append($filterWin.hide());
        bodyDiv = ej.buildTag('div.e-kbnfilterwindow-body', "", {});
        $div = ej.buildTag("div.e-filter-content");
        for (var i = 0; i < kObj.model.filterSettings.length; i++) {
            var $item = ej.buildTag("div", "", {});
            $item.append("<input type='checkbox' class='e-kbnfilter-check' id='check" + i + "' /><label for='check" + i + "' class='e-filterlabel'>" + kObj.model.filterSettings[i].text + "</label></td>");
            $div.append($item);
            $item.find('input').ejCheckBox({ change: $.proxy(this._kbnFilterChange, kObj) });
        }
        bodyDiv.append($div);
        filterScrollContent = ej.buildTag("div#" + kObj._id + "_filterScrollContent", "<div></div>").addClass("e-filter-scrollcontent");
        filterScrollContent.children().append(bodyDiv);
        filterScrollContent.appendTo($filterWin);
        clearbtn = ej.buildTag('input.e-clearfilter', "", {}, { type: "button", id: kObj._id + "_ClearFilter" });
        clearbtn.ejButton({ text: "ClearFilter" });
        $filterWin.append(clearbtn);
        clearbtn.hide();
        filterIcon = ej.buildTag('div.e-kanbanfilter-icon', "", { 'float': 'right' });
        toolbar.append(filterIcon);
    };
    InternalAdaptive.prototype._setAdaptiveSwimlaneTop = function () {
        var kObj = this.kanbanObj;
        if (kObj.element.hasClass("e-responsive") && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
            var scroller = kObj.kanbanContent.data('ejScroller'), rows, sTop;
            rows = kObj.element[0].getElementsByClassName('e-columnrow');
            sTop = kObj._freezeScrollTop;
            scroller.scrollY(sTop, true);
            kObj._freezeScrollTop = sTop;
        }
    };
    InternalAdaptive.prototype._adaptiveSwimlaneRefresh = function () {
        var kObj = this.kanbanObj, slRows;
        kObj.element.find('.e-swimlane-window .e-swimlane-ul').empty();
        for (var index = 0; index < kObj._kbnAdaptDdlData.length; index++)
            ej.buildTag('li.e-swimlane-item ', '<div>' + kObj._kbnAdaptDdlData[index] + '</div>', {}).appendTo(kObj.element.find('.e-swimlane-window .e-swimlane-ul'));
        if (kObj.KanbanAdaptive && kObj.element.hasClass('e-responsive') && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
            kObj.KanbanAdaptive._addSwimlaneName();
            slRows = kObj.kanbanContent.find('.e-columnrow');
            for (var k = 0; k < slRows.length; k++) {
                if (slRows.eq(k).offset().top >= 0) {
                    kObj.element.find('.e-swimlane-text').text(kObj._kbnAdaptDdlData[k]);
                    break;
                }
            }
            if (kObj.kanbanContent.hasClass('e-scroller'))
                kObj.kanbanContent.data('ejScroller').refresh();
        }
    };
    InternalAdaptive.prototype._removeKbnAdaptItems = function () {
        var kObj = this.kanbanObj;
        if (kObj.element.hasClass('e-responsive')) {
            var toolbar = kObj.element.find('.e-kanbantoolbar'), sHeader = kObj.element.find('.e-stackedHeaderCell'), scrollEle, swimDdl = kObj.element.find('.e-swimlane-ddl'), $filterWin = $('.e-kanbanfilter-window'), scrollCell;
            if (swimDdl.length > 0) {
                swimDdl.remove();
                kObj.element.find('.e-swimlane-window').remove();
            }
            if (toolbar.hasClass('e-sladapt-bar'))
                toolbar.remove();
            if ($filterWin.length > 0) {
                var filters = $filterWin.find('.e-filter-content').children();
                for (var i = 0; i < filters.length; i++) {
                    if (filters.eq(i).find('span.e-chkbox-wrap').attr('aria-checked') == "true") {
                        var index = filters.index(filters.eq(i));
                        kObj.element.find('.e-quickfilter').nextAll('li.e-tooltxt').eq(index).addClass('e-select');
                    }
                }
                $filterWin.remove();
            }
            if (sHeader.length > 0)
                sHeader.width('');
            kObj.element.find('.e-rowcell,.e-headercell').width('');
            kObj.kanbanContent.find('table:eq(0) > colgroup col').width('');
            kObj.headerContent.find('table > colgroup col').width('');
            if (!kObj.element.hasClass('e-swimlane-responsive')) {
                scrollEle = kObj.element.find('.e-rowcell .e-cell-scrollcontent:visible');
                for (var i = 0; i < scrollEle.length; i++) {
                    var scrollObj = $(scrollEle[i]).data('ejScroller');
                    if (!ej.isNullOrUndefined(scrollObj))
                        scrollObj.destroy();
                }
            }
            if (toolbar.length > 0 && toolbar.is(':visible')) {
                toolbar.css('display', 'block');
                var qFilter = toolbar.find('.e-quickfilter'), sBar = toolbar.find('.e-searchbar'), sDiv;
                if (toolbar.find('.e-adapt-cancel').is(':visible'))
                    sBar.find('.e-searchitem').addClass('e-cancel').removeClass('e-searchfind');
                toolbar.find('.e-adapt-cancel,.e-adapt-search').hide();
                if (qFilter.length > 0) {
                    toolbar.find('.e-kanbanfilter-icon').remove();
                    qFilter.parent('.e-ul.e-horizontal').show();
                }
                sDiv = sBar.find('.e-searchdiv');
                if (sDiv.length > 0) {
                    sDiv.show();
                    sBar.find('.e-search').css('border', '');
                    sBar.find('.e-searchitem').show();
                    toolbar.parents('body').removeClass('e-kbnwindow-modal');
                    toolbar.removeClass('e-adaptive-search');
                }
            }
            kObj.headerContent.find('table').css({ 'transform': '', 'transition-duration': '' });
            kObj.kanbanContent.find('table').eq(0).css({ 'transform': '', 'transition-duration': '' });
            scrollCell = kObj.element.find('.e-cell-scrollcontent');
            for (var i = 0; i < scrollCell.length; i++) {
                var scrollDiv = scrollCell.eq(i).children();
                scrollDiv.children().appendTo(scrollCell.eq(i).parents('.e-rowcell'));
                scrollCell.eq(i).remove();
            }
            var kbnDialog = kObj.element.find('.e-kanbandialog');
            if (kbnDialog.is(':visible')) {
                var scroller = kbnDialog.parents('.e-dialog-scroller'), wrapper = kbnDialog.parents('.e-dialog');
                wrapper.css({ 'top': '', 'left': '' }).removeClass('e-kbnadapt-editdlg');
                scroller.css('height', 'auto');
                scroller.ejScroller({ height: 0, buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
                kbnDialog.parents('body').removeClass('e-kbnwindow-modal');
                wrapper.hide();
                kObj.KanbanEdit._onKbnDialogOpen();
            }
            if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                if (kObj.kanbanContent.hasClass('e-scroller'))
                    kObj.kanbanContent.data('ejScroller').destroy();
                kObj.element.parents('body').removeClass('e-kbnwindow-modal');
                kObj.element.find('.e-swimlanerow').show();
                var rows = kObj.element.find('.e-columnrow');
                for (var i = 0; i < rows.length; i++) {
                    var cells = rows.eq(i).find('.e-rowcell');
                    for (var j = 0; j < cells.length; j++) {
                        var name = cells.eq(j).find('.e-swimlane-name');
                        if (name.length > 0) {
                            if (name.siblings().length == 0)
                                name.parents('.e-limits').hide();
                            else
                                name.hide();
                        }
                    }
                }
            }
            var stHeader = kObj.element.find('.e-adapt-stheader');
            if (stHeader.length > 0)
                stHeader.find('div').css({ 'position': '', 'left': '' });
            kObj.element.removeClass('e-responsive');
            kObj.element.removeClass('e-swimlane-responsive');
        }
    };
    InternalAdaptive.prototype._setAdaptEditWindowHeight = function () {
        var kObj = this.kanbanObj, kbnDialog, scroller, title;
        kbnDialog = $('#' + kObj._id + "_dialogEdit"), scroller = kbnDialog.parents('.e-dialog-scroller'), title;
        kbnDialog.parents('.e-dialog').css({ 'top': '0', 'left': '0' }).addClass('e-kbnadapt-editdlg');
        kbnDialog.parents('body').addClass('e-kbnwindow-modal');
        title = scroller.prev('.e-titlebar');
        scroller.ejScroller({ height: $(window).height() - title.outerHeight(), buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
        scroller.data('ejScroller').refresh();
        kbnDialog.css('height', scroller.height());
    };
    return InternalAdaptive;
}());
window.ej.createObject("ej.KanbanFeatures.Adaptive", InternalAdaptive, window);
;
var InternalScroller = (function () {
    function InternalScroller(element) {
        this.kanbanObj = null;
        this.kanbanObj = element;
    }
    ;
    InternalScroller.prototype._initScrolling = function () {
        var kObj = this.kanbanObj;
        if (kObj.model.width || kObj.model.height) {
            kObj.model.allowScrolling = true;
            if (kObj.model.width)
                kObj.model.scrollSettings.width = kObj.model.width;
            if (kObj.model.height)
                kObj.model.scrollSettings.height = kObj.model.height;
        }
        kObj._originalScrollWidth = kObj.model.scrollSettings.width;
    };
    InternalScroller.prototype._renderScroller = function () {
        var kObj = this.kanbanObj;
        if (!kObj.model.scrollSettings)
            kObj.model.scrollSettings = {};
        if (typeof (kObj._originalScrollWidth) == "string") {
            kObj.element.css("width", "auto");
            var width = kObj.element.width();
            if (kObj.model.scrollSettings.width == "auto" || kObj._originalScrollWidth == "auto")
                kObj._originalScrollWidth = "100%";
            kObj.model.scrollSettings.width = width * (parseFloat(kObj._originalScrollWidth) / 100);
        }
        if (typeof (kObj.model.scrollSettings.height) == "string") {
            var height = kObj.element.height();
            if (kObj.model.scrollSettings.height == "auto")
                kObj.model.scrollSettings.height = "100%";
            kObj.model.scrollSettings.height = height * (parseFloat(kObj.model.scrollSettings.height) / 100);
        }
        if ((kObj.model.scrollSettings.width || kObj.model.width))
            kObj.element.width(kObj.model.scrollSettings.width || kObj.model.width);
        var contentHeight = kObj.model.scrollSettings.height != 0 ? (kObj.model.scrollSettings.height - kObj.getHeaderTable().height() - (!ej.isNullOrUndefined(kObj._filterToolBar) && kObj._filterToolBar.height())) : kObj.model.scrollSettings.height;
        var $content = kObj.getContent().attr("tabindex", "0");
        kObj.element.addClass("e-kanbanscroll");
        $content.ejScroller({
            enableRTL: kObj.model.enableRTL,
            height: contentHeight,
            width: kObj.model.scrollSettings.width,
            thumbStart: $.proxy(kObj._kbnThumbStart, kObj),
            scroll: $.proxy(kObj._freezeSwimlane, kObj)
        });
        if (kObj.getContent().ejScroller("isVScroll")) {
            kObj.element.find(".e-kanbanheader").addClass("e-scrollcss");
            kObj.getHeaderContent().find("div").first().addClass("e-headercontent");
        }
        else
            kObj.element.find(".e-kanbanheader").removeClass("e-scrollcss");
        if (kObj.model.scrollSettings.width || kObj.model.width)
            kObj.element.width(kObj.model.scrollSettings.width || kObj.model.width);
        var scroller = kObj.getContent().data("ejScroller"), css = scroller && (scroller.isVScroll()) ? "addClass" : "removeClass";
        kObj.getHeaderContent().find(".e-headercontent")[css]("e-hscrollcss");
        this._refreshHeaderScroller();
    };
    InternalScroller.prototype._refreshHeaderScroller = function () {
        var proxy = this.kanbanObj;
        this.kanbanObj.getContent().find(".e-content").scroll(ej.proxy(function (e) {
            proxy.getHeaderContent().find("div").first().scrollLeft($(e.currentTarget).scrollLeft());
        }));
        this.kanbanObj.element.find(".e-kanbanheader").find(".e-headercontent").scroll(ej.proxy(function (e) {
            var $currentTarget = $(e.currentTarget);
            proxy.getContent().find(".e-content").first().scrollLeft($currentTarget.scrollLeft());
        }));
    };
    InternalScroller.prototype._refreshScroller = function (args) {
        var kObj = this.kanbanObj;
        var kanbanContent = kObj.getContent().first();
        if (ej.isNullOrUndefined(kanbanContent.data("ejScroller")))
            return;
        if (args.requestType == "beginedit")
            kObj.getScrollObject().scrollY(0, true);
        kanbanContent.ejScroller("refresh");
        kanbanContent.ejScroller({ enableRTL: kObj.model.enableRTL });
        if (kanbanContent.ejScroller("isVScroll") && !kObj.getScrollObject().model.autoHide) {
            kObj.getHeaderContent().addClass("e-scrollcss");
            !kObj.getHeaderContent().find(".e-headercontent").hasClass("e-hscrollcss") && kObj.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
        }
        else
            kObj.element.find(".e-kanbanheader").removeClass("e-scrollcss");
    };
    return InternalScroller;
}());
window.ej.createObject("ej.KanbanFeatures.Scroller", InternalScroller, window);
;
var InternalSelection = (function () {
    function InternalSelection(element) {
        this.kanbanObj = null;
        this.kanbanObj = element;
    }
    ;
    InternalSelection.prototype._cardSelection = function (rowCellIndexes, target, e) {
        var kObj = this.kanbanObj, $cell, args, previousCard = null, data = null, queryManager;
        $cell = target.parent("td.e-rowcell");
        if (kObj._currentRowCellIndex.length > 0)
            kObj._previousRowCellIndex = [[kObj._currentRowCellIndex[0][0], [kObj._currentRowCellIndex[0][1][0]], [kObj._currentRowCellIndex[0][2][0]]]];
        if (!ej.isNullOrUndefined(target.attr("id"))) {
            queryManager = new ej.DataManager(kObj._currentJsonData);
            data = queryManager.executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, target.attr('id')));
        }
        if (!ej.isNullOrUndefined(kObj._previousRowCellIndex) && kObj._previousRowCellIndex.length != 0)
            previousCard = kObj.KanbanCommon._getCardbyIndexes(kObj._previousRowCellIndex);
        args = { currentCell: $cell, target: target, cellIndex: rowCellIndexes[0][1][0], cardIndex: rowCellIndexes[0][2][0], data: data, previousRowCellIndex: kObj._previousRowCellIndex, previousCard: previousCard, selectedCardsData: kObj._selectedCardData };
        if (kObj._trigger("beforeCardSelect", args))
            return;
        if (!$(target).hasClass("e-cardselection")) {
            if (kObj.model.selectionType == "multiple" && !kObj._kTouchBar.find(".e-cardtouch").hasClass("e-spanclicked"))
                kObj._kTouchBar.hide();
            if (e["pointerType"] == "touch" && !kObj._kTouchBar.find(".e-cardtouch").hasClass("e-spanclicked") && kObj.model.selectionType == "multiple") {
                var trgtOffset = $(target).offset();
                kObj._kTouchBar.show();
                kObj._kTouchBar.offset({ top: trgtOffset.top, left: trgtOffset.left });
            }
        }
        if (e["pointerType"] == "touch" && $(target).hasClass("e-cardselection") && kObj._kTouchBar.is(':hidden')) {
            var trgtOffset = $(target).offset();
            kObj._kTouchBar.show();
            kObj._kTouchBar.offset({ top: trgtOffset.top, left: trgtOffset.left });
        }
        if (kObj.model.selectionType == "multiple" && e.shiftKey) {
            var parentRow, cards, i = 0, l = 0, endCard = target, selectedCards = [];
            if (!ej.isNullOrUndefined(previousCard)) {
                parentRow = previousCard.parents('.e-columnrow');
                parentRow.find('.e-cardselection').not(previousCard).removeClass('e-cardselection');
                cards = parentRow.find('.e-kanbancard');
                i = cards.index(previousCard);
            }
            else
                cards = target.parents('.e-columnrow').find('.e-kanbancard');
            kObj._selectedCards = [];
            kObj._selectedCardData = [];
            kObj.selectedRowCellIndexes = [];
            while (l <= 0) {
                var row, column, curRowCellIndexes = [];
                row = $(cards[i]).parents('.e-columnrow');
                column = $(cards[i]).parents('.e-rowcell');
                $(cards[i]).addClass('e-cardselection');
                selectedCards.push(cards[i]);
                kObj._selectedCardData.push(kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, cards[i].id)[0]);
                curRowCellIndexes = [[kObj.element.find('.e-columnrow').index(row), [column.index()], [column.find($(cards[i])).index()]]];
                if (cards[i].id == endCard.attr("id"))
                    l = 1;
                this._pushIntoSelectedArray(curRowCellIndexes);
                if (!ej.isNullOrUndefined(previousCard)) {
                    if (rowCellIndexes[0][1][0] < kObj._previousRowCellIndex[0][1][0])
                        --i;
                    else if (rowCellIndexes[0][1][0] == kObj._previousRowCellIndex[0][1][0]) {
                        if (rowCellIndexes[0][2][0] < kObj._previousRowCellIndex[0][2][0])
                            --i;
                        else
                            ++i;
                    }
                    else
                        ++i;
                }
                else {
                    ++i;
                }
            }
            if (ej.isNullOrUndefined(previousCard)) {
                kObj._previousRowCellIndex = kObj._currentRowCellIndex = [[0, [0], [0]]];
                previousCard = kObj.KanbanCommon._getCardbyIndexes(kObj._previousRowCellIndex);
            }
            kObj._selectedCards = [];
            kObj._selectedCards[kObj._selectedCards.length] = selectedCards;
            if (ej.isNullOrUndefined(previousCard) && (!e.ctrlKey && !e.shiftKey && !kObj._enableMultiTouch)) {
                {
                    $(target).addClass('e-cardselection');
                    kObj._selectedCards.push(target[0]);
                    kObj._selectedCardData.push(kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, target.id)[0]);
                    this._pushIntoSelectedArray(rowCellIndexes);
                }
            }
        }
        if (kObj.model.selectionType == "multiple" && (e.ctrlKey || kObj._enableMultiTouch)) {
            if ($(target).hasClass("e-cardselection")) {
                $(target).removeClass("e-cardselection");
                this._popFromSelectedArray(rowCellIndexes[0][0], rowCellIndexes[0][1], rowCellIndexes[0][2], e);
                for (var k = 0; k < kObj._selectedCardData.length; k++) {
                    if (data[0][kObj.model.fields.primaryKey] == kObj._selectedCardData[0][kObj.model.fields.primaryKey])
                        break;
                }
                kObj._selectedCardData.splice(k, 1);
                kObj._selectedCards.splice(k, 1);
                kObj._currentRowCellIndex = rowCellIndexes;
            }
            else {
                $(target).addClass("e-cardselection");
                kObj._selectedCards.push(target[0]);
                this._pushIntoSelectedArray(rowCellIndexes);
                kObj._selectedCardData.push(data[0]);
            }
        }
        else {
            if (!(kObj.model.selectionType == "multiple" && e.shiftKey)) {
                var cardIndex = rowCellIndexes[0][2];
                kObj.element.find(".e-cardselection").removeClass("e-cardselection");
                kObj._selectedCards = [];
                kObj.selectedRowCellIndexes = [];
                $(target).addClass("e-cardselection");
                kObj._selectedCardData = [];
                kObj._selectedCardData.push(data[0]);
                kObj._selectedCards.push(target[0]);
                if (kObj.model.selectionType == "multiple")
                    cardIndex = [rowCellIndexes[0][2]];
                kObj.selectedRowCellIndexes.push({ rowIndex: rowCellIndexes[0][0], cellIndex: rowCellIndexes[0][1], cardIndex: cardIndex });
            }
        }
        args = { currentCell: $cell, target: target, cellIndex: rowCellIndexes[0][1][0], cardIndex: rowCellIndexes[0][2][0], data: data, selectedRowCellIndex: kObj.selectedRowCellIndexes, previousRowCellIndex: kObj._previousRowCellIndex, previousCard: previousCard, selectedCardsData: kObj._selectedCardData };
        if (kObj.model.selectionType == "multiple" && e.shiftKey && $(target).hasClass("e-cardselection")) {
            if (kObj._previousRowCellIndex.length == 0)
                kObj._currentRowCellIndex = [[target.parents('.e-columnrow').index(), [0], [0]]];
            if (kObj._currentRowCellIndex.length == 0)
                kObj._currentRowCellIndex = rowCellIndexes;
        }
        else if ($(target).hasClass("e-cardselection"))
            kObj._currentRowCellIndex = rowCellIndexes;
        if (kObj._trigger("cardSelect", args))
            return;
        kObj.element.focus();
    };
    InternalSelection.prototype.clear = function () {
        var kObj = this.kanbanObj;
        if (kObj.model.allowSelection) {
            var $kanbanRows = $(kObj._kanbanRows).not(".e-swimlanerow");
            $($kanbanRows).find(".e-rowcell .e-kanbancard").removeClass("e-cardselection");
            kObj.selectedRowCellIndexes = [];
            kObj._selectedCardData = [];
            kObj._selectedCards = [];
            kObj._previousRowCellIndex = [];
            kObj._currentRowCellIndex = [];
        }
    };
    InternalSelection.prototype._pushIntoSelectedArray = function (rowCellIndexes) {
        var kObj = this.kanbanObj, i, l = 0, newRow = true, newCell = true;
        for (i = 0; i < kObj.selectedRowCellIndexes.length; i++) {
            var row = kObj.selectedRowCellIndexes[i];
            if (row.rowIndex == rowCellIndexes[0][0]) {
                newRow = false;
                for (l = 0; l < row.cellIndex.length; l++) {
                    var cell = row.cellIndex[l];
                    if (cell == rowCellIndexes[0][1][0]) {
                        newCell = false;
                        break;
                    }
                }
                break;
            }
        }
        if (newRow)
            kObj.selectedRowCellIndexes.push({ rowIndex: rowCellIndexes[0][0], cellIndex: rowCellIndexes[0][1], cardIndex: [rowCellIndexes[0][2]] });
        if (!newCell)
            kObj.selectedRowCellIndexes[i].cardIndex[l].push(rowCellIndexes[0][2][0]);
        else if (!newRow) {
            kObj.selectedRowCellIndexes[i].cellIndex.push(rowCellIndexes[0][1][0]);
            kObj.selectedRowCellIndexes[i].cardIndex.push([rowCellIndexes[0][2][0]]);
        }
    };
    InternalSelection.prototype._popFromSelectedArray = function (val1, val2, val3, e) {
        var kObj = this.kanbanObj;
        if (kObj.model.selectionType == "multiple" && (e.ctrlKey || e.shiftKey || kObj._enableMultiTouch)) {
            var i, l, j;
            for (i = 0; i < kObj.selectedRowCellIndexes.length; i++) {
                var row = kObj.selectedRowCellIndexes[i];
                if (row.rowIndex == val1) {
                    for (l = 0; l < row.cellIndex.length; l++) {
                        var cell = row.cellIndex[l];
                        if (cell == val2[0]) {
                            if (e.shiftKey) {
                                row.cardIndex = [];
                                break;
                            }
                            else {
                                for (j = 0; j < row.cardIndex[l].length; j++) {
                                    var card = row.cardIndex[l][j];
                                    if (card == val3[0]) {
                                        row.cardIndex[l].splice(j, 1);
                                        if (row.cardIndex[l].length == 0) {
                                            row.cardIndex.splice(l, 1);
                                            row.cellIndex.splice(l, 1);
                                        }
                                        if (row.cellIndex.length == 0)
                                            kObj.selectedRowCellIndexes.splice(i, 1);
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    InternalSelection.prototype._selectionOnRerender = function () {
        var rowIndex, row, column, cardsSelected = true, kObj = this.kanbanObj;
        if (!kObj.model.allowSelection)
            return;
        if (kObj.model.selectionType == "single") {
            if (kObj._selectedCards.length > 0) {
                var el = $(kObj._selectedCards[0]), curEl, index;
                curEl = kObj.element.find("#" + el[0].id);
                if (curEl.hasClass('e-kanbancard')) {
                    row = $(curEl).parents('.e-columnrow');
                    column = $(curEl).parents('.e-rowcell');
                    kObj._selectedCards = [];
                    kObj._selectedCards = curEl.addClass('e-cardselection');
                    kObj._currentRowCellIndex = kObj._previousRowCellIndex = [];
                    kObj._currentRowCellIndex.push([row.index(), [column.index()], [column.find('.e-kanbancard').index(column.find("#" + el[0].id))]]);
                    kObj._currentRowCellIndex = kObj._previousRowCellIndex;
                    kObj.selectedRowCellIndexes = [];
                    kObj.selectedRowCellIndexes.push({ rowIndex: kObj._currentRowCellIndex[0][0], cellIndex: kObj._currentRowCellIndex[0][1][0], cardIndex: kObj._currentRowCellIndex[0][2][0] });
                }
                else {
                    kObj._selectedCards = [];
                    kObj._selectedCardData = [];
                    kObj.selectedRowCellIndexes = [];
                    kObj._currentRowCellIndex = kObj._previousRowCellIndex = [];
                }
            }
        }
        else {
            for (var i = 0; i < kObj._selectedCards.length; i++) {
                var el, curEl;
                if ($(kObj._selectedCards[i]).length > 1) {
                    for (var l = 0; l < kObj._selectedCards[i].length; l++) {
                        var rowCellIndex;
                        el = $(kObj._selectedCards[i][l]);
                        curEl = kObj.element.find("#" + el[0].id);
                        row = $(curEl).parents('.e-columnrow');
                        column = $(curEl).parents('.e-rowcell');
                        if (curEl.hasClass('e-kanbancard')) {
                            cardsSelected = true;
                            kObj._selectedCards[i].splice(l, 0, curEl[0]);
                            curEl.addClass('e-cardselection');
                            kObj._selectedCards[i].splice(l + 1, 1);
                            if (i == 0 && l == 0) {
                                kObj._currentRowCellIndex = kObj._previousRowCellIndex = [];
                                kObj._currentRowCellIndex.push([row.index(), [column.index()], [column.find('.e-kanbancard').index(column.find("#" + el[0].id))]]);
                                kObj._currentRowCellIndex = kObj._previousRowCellIndex;
                                kObj.selectedRowCellIndexes = [];
                            }
                            rowCellIndex = [row.index(), [column.index()], [column.find('.e-kanbancard').index(column.find("#" + el[0].id))]];
                            this._pushIntoSelectedArray([rowCellIndex]);
                        }
                        else {
                            cardsSelected = false;
                            kObj._selectedCards[i].splice(l, 1);
                            var index = kObj._selectedCardData.indexOf(kObj.KanbanCommon._getKanbanCardData(kObj._selectedCardData, el[0].id)[0]);
                            kObj._selectedCardData.splice(index, 1);
                            --l;
                        }
                    }
                }
                else {
                    var rowCellIndex;
                    el = $(kObj._selectedCards[i]);
                    curEl = kObj.element.find("#" + el[0].id);
                    row = $(curEl).parents('.e-columnrow');
                    column = $(curEl).parents('.e-rowcell');
                    if (curEl.hasClass('e-kanbancard')) {
                        cardsSelected = true;
                        curEl.addClass('e-cardselection');
                        kObj._selectedCards[i] = curEl[0];
                        if (i == 0) {
                            kObj._currentRowCellIndex = kObj._previousRowCellIndex = [];
                            kObj._currentRowCellIndex.push([row.index(), [column.index()], [column.find('.e-kanbancard').index(column.find("#" + el[0].id))]]);
                            kObj._currentRowCellIndex = kObj._previousRowCellIndex;
                            kObj.selectedRowCellIndexes = [];
                        }
                        rowCellIndex = [row.index(), [column.index()], [column.find('.e-kanbancard').index(column.find("#" + el[0].id))]];
                        this._pushIntoSelectedArray([rowCellIndex]);
                    }
                    else {
                        cardsSelected = false;
                        kObj._selectedCards.splice(i, 1);
                        var index = kObj._selectedCardData.indexOf(kObj.KanbanCommon._getKanbanCardData(kObj._selectedCardData, el[0].id)[0]);
                        kObj._selectedCardData.splice(index, 1);
                        --i;
                    }
                }
            }
            if (!cardsSelected && kObj._selectedCards.length <= 0)
                kObj._currentRowCellIndex = kObj._previousRowCellIndex = kObj.selectedRowCellIndexes = [];
        }
        rowIndex = kObj.element.find('.e-columnrow').index(kObj.element.find('.e-cardselection').eq(0).parents('.e-columnrow'));
        if (rowIndex >= 0) {
            kObj.selectedRowCellIndexes[0].rowIndex = kObj._currentRowCellIndex[0][0] = rowIndex;
            if (kObj._previousRowCellIndex.length > 0)
                kObj._previousRowCellIndex[0][0] = rowIndex;
        }
    };
    InternalSelection.prototype._renderKanbanTouchBar = function () {
        var kObj = this.kanbanObj;
        kObj._kTouchBar = ej.buildTag("div.e-kanbantouchbar", "", { display: "none" }, {});
        var content = ej.buildTag("div.e-content", "", {}, {}), downTail = ej.buildTag("div.e-downtail e-tail", "", {}, {});
        var touchElement = ej.buildTag("span.e-cardtouch e-icon", "", {}, {});
        content.append(touchElement);
        kObj._kTouchBar.append(content);
        kObj._kTouchBar.append(downTail);
        kObj.element.append(kObj._kTouchBar);
    };
    InternalSelection.prototype._updateSelectedCardIndexes = function (target) {
        var targetRow, targetCellIndex, kObj = this.kanbanObj;
        if (kObj.selectedRowCellIndexes.length > 0) {
            if ($(target).hasClass('e-rowcell'))
                targetCellIndex = $(target).index();
            else {
                target = kObj.element.find("#" + $(target).attr('id'));
                targetCellIndex = $(target).parents('.e-rowcell').index();
            }
            targetRow = $(target).parents('.e-columnrow');
            if ($.inArray(targetCellIndex, kObj.selectedRowCellIndexes[0].cellIndex) == -1)
                kObj.selectedRowCellIndexes[0].cellIndex.push(targetCellIndex);
            for (var k = 0; k < kObj.selectedRowCellIndexes[0].cellIndex.length; k++) {
                var selectedCards;
                selectedCards = targetRow.find('.e-rowcell').eq(kObj.selectedRowCellIndexes[0].cellIndex[k]).find('.e-cardselection');
                if (selectedCards.length > 0) {
                    kObj.selectedRowCellIndexes[0].cardIndex.splice(k, 1);
                    kObj.element.find('.e-targetclone').remove();
                    for (var m = 0; m < selectedCards.length; m++) {
                        if (m > 0)
                            kObj.selectedRowCellIndexes[0].cardIndex[k].push($(selectedCards[m]).index());
                        else
                            kObj.selectedRowCellIndexes[0].cardIndex.splice(k, 0, [$(selectedCards[0]).index()]);
                    }
                }
                else {
                    kObj.selectedRowCellIndexes[0].cellIndex.splice(k, 1);
                    kObj.selectedRowCellIndexes[0].cardIndex.splice(k, 1);
                    --k;
                }
            }
        }
    };
    return InternalSelection;
}());
window.ej.createObject("ej.KanbanFeatures.Selection", InternalSelection, window);
;
var InternalFilter = (function () {
    function InternalFilter(element) {
        this.kanbanObj = null;
        this.kanbanObj = element;
    }
    ;
    InternalFilter.prototype._filterHandler = function (filterValue, currentTarget) {
        var kObj = this.kanbanObj, args = { requestType: "filtering", currentFilterObject: [], filterCollection: kObj._filterCollection };
        args.currentFilterObject.push(filterValue);
        if (kObj.model.isResponsive) {
            var filter = [];
            kObj._kbnFilterObject = kObj._kbnFilterObject.concat(args.currentFilterObject);
            for (var i = 0; i < kObj._kbnFilterObject.length; i++) {
                var index = $.inArray(kObj._kbnFilterObject[i], filter);
                if (index < 0)
                    filter.push(kObj._kbnFilterObject[i]);
            }
            kObj._kbnFilterObject = filter;
        }
        var kbnCurrentData;
        if (!(kObj._dataSource() instanceof ej.DataManager))
            kbnCurrentData = kObj._dataSource();
        else
            kbnCurrentData = kObj._dataSource().dataSource.json;
        if (kbnCurrentData.length == 0 && kObj._currentJsonData.length > 0)
            kbnCurrentData = kObj._currentJsonData;
        kObj._initialData = kbnCurrentData;
        for (var i = 0; i < kObj.model.filterSettings.length; i++) {
            if (kObj.model.filterSettings[i].text == args.currentFilterObject[0].text) {
                var query = kObj.model.filterSettings[i].query["queries"][0].e;
                if (ej.isNullOrUndefined(args.filterCollection[0])) {
                    args.filterCollection.push(query);
                    $(currentTarget).addClass("e-select");
                }
                else if ($(currentTarget).hasClass("e-select")) {
                    $(currentTarget).removeClass("e-select");
                    var index = $.inArray(query, args.filterCollection);
                    args.filterCollection.splice(index, 1);
                }
                else {
                    $(currentTarget).addClass("e-select");
                    args.filterCollection.push(query);
                }
                break;
            }
        }
        kObj.KanbanCommon._processBindings(args);
    };
    InternalFilter.prototype.filterCards = function (query) {
        var args = { requestType: "filtering", filterCollection: this.kanbanObj._filterCollection };
        var query = query.queries[0].e;
        args.filterCollection.push(query);
        this.kanbanObj.KanbanCommon._processBindings(args);
    };
    InternalFilter.prototype.clearFilter = function () {
        var kObj = this.kanbanObj;
        if (kObj._filterCollection.length != 0) {
            var args = { requestType: "filtering" };
            kObj._filterCollection = [];
            kObj.element.find(".e-kanbantoolbar .e-tooltxt").removeClass("e-select");
            kObj.KanbanCommon._processBindings(args);
        }
    };
    InternalFilter.prototype._filterLimitCard = function (args) {
        var kObj = this.kanbanObj, cardCount, curHeader, count;
        for (var i = 0; i < kObj.model.columns.length; i++) {
            var column = kObj.model.columns[i];
            var card = kObj.getHeaderContent().find("span.e-totalcount");
            if (kObj.model.enableTotalCount) {
                card = $(card[i]);
                var index = $(card).text().indexOf(kObj.localizedLabels.FilterOfText);
                if (!ej.isNullOrUndefined(args) && (args.requestType == "drop" || args.requestType == "beginedit" || args.requestType == "save" || args.requestType == "cancel" || args.requestType == "refresh" || args.requestType == "add" || (args.requestType == "filtering" ? (args.filterCollection.length > 0 ? true : kObj.model.searchSettings.key == "" ? false : true) : args.requestType == "search" ? (kObj.model.searchSettings.key != "" ? true : (kObj.model.filterSettings.length > 0 ? kObj.element.find(".e-kanbantoolbar .e-tooltxt").hasClass("e-select") : false)) : false))) {
                    if (index != -1 && kObj._dataManager instanceof ej.DataManager && !kObj._dataManager.dataSource.offline) {
                        count = kObj.localizedLabels.FilterOfText.length + index + 1;
                        cardCount = $(card).text().slice(count);
                        if (args.requestType == "drop" || args.requestType == "save") {
                            curHeader = kObj.headerContent.find(".e-headercell").eq(i);
                            if (curHeader.hasClass("e-card-dragged")) {
                                cardCount = --cardCount;
                                curHeader.removeClass("e-card-dragged");
                            }
                            if (curHeader.hasClass("e-card-dropped")) {
                                cardCount = ++cardCount;
                                curHeader.removeClass("e-card-dropped");
                            }
                        }
                        $(card).text(cardCount);
                    }
                    else if ((kObj._dataManager instanceof ej.DataManager && kObj._dataManager.dataSource.offline) && (index != -1 || kObj.model.filterSettings.length != 0 || kObj.model.searchSettings.key.length != 0)) {
                        cardCount = new ej.DataManager(kObj.model.dataSource).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, column.key)).length;
                        $(card).text(cardCount);
                    }
                    var columnKey = kObj.KanbanCommon._multikeySeparation(column.key);
                    $(card).text($($(kObj.element.find(".e-columnrow")).find('td[ej-mappingkey="' + columnKey + '"] > div.e-kanbancard')).length + " " + kObj.localizedLabels.FilterOfText + " " + $(card).text());
                }
                else if (!ej.isNullOrUndefined(column.constraints))
                    kObj.KanbanCommon._renderLimit();
                else
                    $(card).text($(card).text().slice(index + 3));
            }
        }
    };
    InternalFilter.prototype.searchCards = function (searchString) {
        var args, kObj = this.kanbanObj, searchBar = $("#" + kObj._id + "_toolbarItems_search");
        if (searchBar.find("input").val() != searchString)
            searchBar.find("input").val(searchString);
        if (!kObj.element.hasClass('e-responsive')) {
            searchBar.parent().addClass('e-highliht-kbnsearchbar');
            if (searchBar.find("input").val() == "")
                searchBar.parent().removeClass('e-highliht-kbnsearchbar');
        }
        args = { requestType: "search", keyValue: searchString };
        if (searchString != "" || kObj.model.searchSettings.key != "") {
            kObj.model.searchSettings.key = searchString;
            if (kObj.model.searchSettings.key.length > 0) {
                var kbnCurrentData;
                if (!(kObj._dataSource() instanceof ej.DataManager))
                    kbnCurrentData = kObj._dataSource();
                else
                    kbnCurrentData = kObj._dataSource().dataSource.json;
                if (kbnCurrentData.length == 0 && kObj._currentJsonData.length > 0)
                    kbnCurrentData = kObj._currentJsonData;
                kObj._initialData = kbnCurrentData;
            }
            kObj.KanbanCommon._processBindings(args);
        }
    };
    InternalFilter.prototype.clearSearch = function () {
        var kObj = this.kanbanObj;
        kObj.element.find(".e-kanbantoolbar #" + kObj._id + "_toolbarItems_search").val("");
        this.searchCards("");
        $.extend(kObj.model.searchSettings, kObj.defaults.searchSettings);
    };
    InternalFilter.prototype._onToolbarKeypress = function (sender) {
        var kObj = this["KanbanFilter"]["kanbanObj"];
        var $kanbanEle = kObj.element, kanbanObj = $kanbanEle.data("ejKanban");
        if (kObj.model.isResponsive && $kanbanEle.hasClass('e-responsive')) {
            $(kObj.itemsContainer).parent().children().not('.e-searchbar').hide();
            kObj.KanbanAdaptive._kbnTimeoutSearch($kanbanEle, sender);
        }
    };
    return InternalFilter;
}());
window.ej.createObject("ej.KanbanFeatures.Filter", InternalFilter, window);
;
var InternalDragAndDrop = (function () {
    function InternalDragAndDrop(element) {
        this.kanbanObj = null;
        this._dragEle = null;
        this._dropEle = null;
        this._dropTarget = null;
        this.kanbanObj = element;
    }
    ;
    InternalDragAndDrop.prototype._addDragableClass = function () {
        var kObj = this.kanbanObj;
        kObj._dropped = false;
        this._dragEle = kObj.getContent().find(".e-columnrow td.e-drag .e-kanbancard");
        this._dropEle = kObj.getContent().find(".e-columnrow .e-rowcell.e-drop");
        this._dropEle.addClass("e-droppable");
        this._dragEle.addClass("e-draggable e-droppable");
        this._enableDragDrop();
        kObj._on(kObj.element, "mouseup touchstart pointerdown MSPointerDown", "", $.proxy(kObj.element.focus(), this));
    };
    InternalDragAndDrop.prototype._enableDragDrop = function () {
        var kObj = this.kanbanObj;
        this._drag();
        $(kObj.getContent()).ejDroppable({
            accept: $(kObj.getContent()).find("div.e-kanbancard"),
            drop: function (event, ui) {
                $(ui.helper).hide();
            }
        });
    };
    InternalDragAndDrop.prototype._selectedPrevCurrentCards = function () {
        var prevCard, curCard, kObj = this.kanbanObj;
        if (kObj._previousRowCellIndex.length > 0) {
            prevCard = kObj.KanbanCommon._getCardbyIndexes(kObj._previousRowCellIndex);
            kObj._pCardId = prevCard.attr('id');
        }
        kObj._previousRowCellIndex = kObj._currentRowCellIndex;
        kObj._pCardId = kObj._cCardId;
        if (kObj._currentRowCellIndex.length > 0) {
            curCard = kObj.KanbanCommon._getCardbyIndexes(kObj._currentRowCellIndex);
            kObj._cCardId = curCard.attr('id');
        }
    };
    InternalDragAndDrop.prototype._getPriorityIndex = function (element) {
        var dropData = null, index, kObj = this.kanbanObj;
        ;
        for (var i = 0; i < kObj._priorityCollection.length; i++) {
            if (kObj._priorityCollection[i].primaryKey == element.attr('id')) {
                dropData = kObj._priorityCollection[i];
                break;
            }
        }
        if (!ej.isNullOrUndefined(dropData))
            index = parseInt(dropData["dropKey"]);
        else
            index = this._getPriorityKey(element.attr('id'));
        return index;
    };
    InternalDragAndDrop.prototype._removeFromPriorirtyCollec = function (cardId) {
        var dRemoveIndex = null, kObj = this.kanbanObj;
        for (var i = 0; i < kObj._priorityCollection.length; i++) {
            if (kObj._priorityCollection[i].primaryKey == cardId) {
                dRemoveIndex = i;
                break;
            }
        }
        if (!ej.isNullOrUndefined(dRemoveIndex))
            kObj._priorityCollection.splice(dRemoveIndex, 1);
    };
    InternalDragAndDrop.prototype._columnDataOndrop = function (target, prKey) {
        var kObj = this.kanbanObj, editingManager = new ej.DataManager(kObj._initialData), data, key, swimlane, cText, sText, queryManager = new ej.Query();
        key = kObj.model.keyField, swimlane = kObj.model.fields.swimlaneKey;
        if ($(target).hasClass('e-rowcell'))
            cText = $(target).attr('ej-mappingkey');
        else
            cText = $(target).parents('.e-rowcell').attr('ej-mappingkey');
        sText = $(target).parents('.e-columnrow').prev('.e-swimlanerow').find('.e-slkey').text();
        if (!ej.isNullOrUndefined(swimlane))
            queryManager = queryManager.where(key, ej.FilterOperators.equal, cText).where(swimlane, ej.FilterOperators.equal, sText);
        else
            queryManager = queryManager.where(key, ej.FilterOperators.equal, cText);
        data = editingManager.executeLocal(queryManager);
        data.sort(function (val1, val2) {
            return val1[prKey] - val2[prKey];
        });
        return data;
    };
    InternalDragAndDrop.prototype._dropToColumn = function (target, element) {
        var kObj = this.kanbanObj, lastDrpIndex, eleDrpIndex, trgtColData = [], pCheck = false, prKey = kObj.model.fields.priority, filter, selEle;
        var sibling = target.parent().has(element).length;
        if (!ej.isNullOrUndefined(kObj._filterToolBar))
            filter = kObj._filterToolBar.find('.e-select');
        if (target.hasClass('e-targetclone'))
            target = target.parent();
        if (target.hasClass('e-columnkey'))
            target = target.parent().parent();
        this._selectedPrevCurrentCards();
        if (prKey && ((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))) {
            trgtColData = this._columnDataOndrop(target, prKey);
            pCheck = trgtColData.length > 0;
        }
        else
            pCheck = $(target).children('.e-kanbancard').length > 1;
        selEle = this._getSelectedCards(element);
        if (kObj.model.selectionType == "multiple" && selEle.length > 0 && $(element).hasClass('e-cardselection'))
            element = selEle;
        for (var i = 0; i < element.length; i++) {
            var ele = element[i];
            for (var l = 0; l < $(ele).length; l++) {
                var card = $(ele)[l];
                if ($(card).is(':visible')) {
                    if (prKey && pCheck) {
                        if ((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))
                            lastDrpIndex = trgtColData[trgtColData.length - 1][prKey];
                        else
                            lastDrpIndex = this._getPriorityIndex(target.find('.e-kanbancard').last());
                        eleDrpIndex = this._getPriorityIndex($(card));
                        if (lastDrpIndex >= eleDrpIndex)
                            eleDrpIndex = ++lastDrpIndex;
                        this._removeFromPriorirtyCollec($(card).attr('id'));
                        kObj._priorityCollection.push({ primaryKey: $(card).attr('id'), dropKey: eleDrpIndex });
                        var data = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, $(card)[0].id)[0];
                        if (!ej.isNullOrUndefined(eleDrpIndex)) {
                            data[prKey] = eleDrpIndex;
                            trgtColData.push(data);
                        }
                    }
                    if ($(target).find(".e-customaddbutton").length > 0) {
                        $(card).insertBefore($(target).find(".e-customaddbutton"));
                    }
                    else {
                        if (kObj.element.hasClass('e-responsive')) {
                            var scroller = target.find('.e-cell-scrollcontent');
                            if (scroller.length > 0)
                                scroller.children().append(card);
                            else
                                $(target).append(card);
                        }
                        else
                            $(target).append(card);
                    }
                }
            }
        }
        this._updateDropAction(target, element);
        if (sibling == 0 && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj.model.swimlaneSettings.allowDragAndDrop)
            kObj.refresh(true);
    };
    InternalDragAndDrop.prototype._updateDropAction = function (trgt, ele) {
        var trgtTd, kObj = this.kanbanObj, rowCell;
        trgtTd = $(trgt).hasClass('e-rowcell') ? trgt : $(trgt).closest("td.e-rowcell");
        kObj._selectedCardData = [];
        for (var c = 0; c < ele.length; c++) {
            var cardId, card;
            if (ej.isNullOrUndefined(ele[c].length)) {
                if ($(ele[c]).is(':visible') || ($(trgt).hasClass("e-hide") && kObj.model.contextMenuSettings.enable)) {
                    cardId = $(ele[c]).attr('id');
                    this._updateDropData(trgt, ele[c], cardId);
                    card = kObj.element.find("#" + cardId);
                    rowCell = card.parents('.e-rowcell');
                    if (card.parents('.e-rowcell').hasClass('e-shrink'))
                        card.addClass('e-hide');
                    var count = parseInt(rowCell.find(".e-shrinkcount").html());
                    rowCell.find(".e-shrinkcount").html(++count);
                }
            }
            else {
                for (var k = 0; k < ele[c].length; k++) {
                    if ($(ele[c][k]).is(':visible') || ($(trgt).hasClass("e-hide") && kObj.model.contextMenuSettings.enable)) {
                        cardId = ele[c][k].id;
                        this._updateDropData(trgt, ele[c][k], cardId);
                        card = kObj.element.find("#" + cardId);
                        rowCell = card.parents('.e-rowcell');
                        if (card.parents('.e-rowcell').hasClass('e-shrink'))
                            card.addClass('e-hide');
                        var count = parseInt(rowCell.find(".e-shrinkcount").html());
                        rowCell.find(".e-shrinkcount").html(++count);
                    }
                }
            }
        }
        if (kObj.model.fields.priority && kObj._priorityCollection.length > 0) {
            while (kObj._priorityCollection.length > 0) {
                var key = kObj._priorityCollection[0].primaryKey, card = kObj.element.find("#" + key);
                this._updateDropData(trgt, card, key);
            }
        }
        var args, prKeyValue = kObj._bulkUpdateData[0][kObj.model.fields.primaryKey];
        if (kObj._bulkUpdateData.length > 1)
            prKeyValue = "bulk";
        args = { data: kObj._bulkUpdateData, requestType: "drop", primaryKeyValue: prKeyValue };
        kObj._saveArgs = args;
        kObj.updateCard(prKeyValue, kObj._bulkUpdateData);
        if (kObj.model.allowSelection && !ej.isNullOrUndefined(ele[0].length) && ele[0].length > 1 || ele.length > 1 || (ele.length == 1 && $(ele).hasClass('e-cardselection'))) {
            kObj._previousRowCellIndex = (!ej.isNullOrUndefined(kObj._pCardId)) ? this._updateRowCellIndexes(kObj._pCardId, kObj._previousRowCellIndex) : [];
            kObj._currentRowCellIndex = (!ej.isNullOrUndefined(kObj._cCardId)) ? this._updateRowCellIndexes(kObj._cCardId, kObj._currentRowCellIndex) : [];
            kObj.KanbanSelection._selectionOnRerender();
            if (ej.isNullOrUndefined(kObj._pCardId))
                kObj._previousRowCellIndex = kObj._currentRowCellIndex;
            if (kObj.model.selectionType == "single")
                kObj.selectedRowCellIndexes = kObj._currentRowCellIndex;
            else
                kObj.KanbanSelection._updateSelectedCardIndexes(trgt);
        }
        kObj._priorityCollection = [];
    };
    InternalDragAndDrop.prototype._getPriorityKey = function (key) {
        var kObj = this.kanbanObj;
        var kCard = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, key);
        return kCard[0][kObj.model.fields.priority];
    };
    InternalDragAndDrop.prototype._dropAsSibling = function (target, element, pre) {
        var kObj = this.kanbanObj, targetKey = 0, prevKey = 0, nextKey = 0, nextAll, prevAll, dropIndex, cards, initTarget, prevCard, nextCard, trgtColData = [], prCardId, prKey = kObj.model.fields.priority, filter, primeKey, selEle;
        var sibling = target.parent().has(element).length;
        if (!ej.isNullOrUndefined(kObj._filterToolBar))
            filter = kObj._filterToolBar.find('.e-select');
        primeKey = kObj.model.fields.primaryKey;
        this._selectedPrevCurrentCards();
        if (prKey && ((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0)))
            trgtColData = this._columnDataOndrop(target, prKey);
        if ($(target).hasClass("e-targetclone")) {
            if (target.next().length == 0)
                $(target).addClass("e-targetappend");
            prevCard = $(target).prevAll('.e-kanbancard')[0];
            nextCard = $(target).nextAll('.e-kanbancard')[0];
            if ($(target).hasClass("e-targetappend")) {
                pre = true;
                target = prevCard;
                if (ej.isNullOrUndefined(target))
                    target = nextCard;
            }
            else {
                pre = false;
                target = nextCard;
                if (ej.isNullOrUndefined(target))
                    target = prevCard;
            }
        }
        initTarget = target;
        selEle = this._getSelectedCards(element);
        if (kObj.model.selectionType == "multiple" && selEle.length > 0 && $(element).hasClass('e-cardselection'))
            element = selEle;
        for (var i = 0; i < element.length; i++) {
            var ele = element[i];
            for (var l = 0; l < $(ele).length; l++) {
                var card = $(ele)[l];
                if ($(card).is(':visible')) {
                    if (pre) {
                        if (l > 0 && element[i][l - 1] != initTarget)
                            target = element[i][l - 1];
                        else if (l == 0 && i > 0 && element[i - 1] != initTarget)
                            target = element[i - 1];
                    }
                    if (card != initTarget) {
                        pre ? $(card).insertAfter(target) : $(card).insertBefore(target);
                        if (prKey && ((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))) {
                            var data, index, curIndex, addData;
                            data = kObj.KanbanCommon._getKanbanCardData(trgtColData, $(target).attr('id'));
                            index = trgtColData.indexOf(data[0]);
                            addData = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, $(card)[0].id);
                            if (data[0][kObj.model.keyField] == addData[0][kObj.model.keyField])
                                trgtColData.splice(trgtColData.indexOf(addData[0]), 1);
                            if (pre)
                                trgtColData.splice(index + 1, 0, addData[0]);
                            else
                                trgtColData.splice(index, 0, addData[0]);
                            prCardId = $(card)[0].id;
                        }
                    }
                    if (prKey) {
                        if (((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))) {
                            var tData = kObj.KanbanCommon._getKanbanCardData(trgtColData, $(target).attr('id'));
                            targetKey = tData[0][prKey];
                            tData = kObj.KanbanCommon._getKanbanCardData(trgtColData, prCardId);
                            cards = [];
                            for (var k = trgtColData.indexOf(tData[0]); k < trgtColData.length; k++) {
                                cards.push(trgtColData[k]);
                            }
                        }
                        else {
                            targetKey = this._getPriorityIndex($(target));
                            var nextCards = $(card).nextAll('.e-kanbancard');
                            cards = ej.isNullOrUndefined(nextCards["addBack"]) ? nextCards["andSelf"]() : nextCards["addBack"]();
                        }
                        for (var k = 0; k < cards.length; k++) {
                            var thisEle = cards[k];
                            if (((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))) {
                                var tData = null, index;
                                dropIndex = thisEle[prKey];
                                if (!pre && ($(card)[0].id == thisEle[primeKey]) && targetKey < dropIndex)
                                    dropIndex = targetKey;
                                tData = kObj.KanbanCommon._getKanbanCardData(trgtColData, thisEle[primeKey]);
                                index = curIndex = trgtColData.indexOf(tData[0]);
                                if (index - 1 >= 0)
                                    prevKey = trgtColData[index - 1][prKey];
                                tData = kObj.KanbanCommon._getKanbanCardData(trgtColData, thisEle[primeKey]);
                                index = curIndex = trgtColData.indexOf(tData[0]);
                                if (index + 1 < trgtColData.length) {
                                    nextKey = trgtColData[index + 1][prKey];
                                    nextAll = trgtColData[index + 1];
                                }
                                else
                                    nextAll = [];
                            }
                            else {
                                dropIndex = this._getPriorityKey($(thisEle).attr('id'));
                                if (!pre && ($(card)[0] == thisEle) && targetKey < dropIndex)
                                    dropIndex = targetKey;
                                prevAll = $(thisEle).prevAll('.e-kanbancard');
                                if (prevAll.length > 0)
                                    prevKey = this._getPriorityIndex(prevAll.eq(0));
                                nextAll = $(thisEle).nextAll('.e-kanbancard');
                                if (nextAll.length > 0)
                                    nextKey = this._getPriorityIndex(nextAll.eq(0));
                            }
                            if (!isNaN(prevKey) && prevKey < dropIndex && (dropIndex < nextKey || nextAll.length == 0))
                                break;
                            var c_Id;
                            if (((!ej.isNullOrUndefined(kObj._filterToolBar) && filter.length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))) {
                                if (!(!pre && $(card)[0].id == thisEle[primeKey]))
                                    dropIndex = ++targetKey;
                                else if (!(!pre && $(card)[0].id == thisEle[primeKey] && targetKey < dropIndex))
                                    dropIndex = targetKey;
                                trgtColData[curIndex][prKey] = dropIndex;
                                c_Id = thisEle[primeKey];
                            }
                            else {
                                if (!(!pre && $(card)[0] == thisEle))
                                    dropIndex = ++targetKey;
                                else if (!(!pre && $(card)[0] == thisEle && targetKey < dropIndex))
                                    dropIndex = targetKey;
                                c_Id = $(thisEle).attr('id');
                            }
                            this._removeFromPriorirtyCollec(c_Id);
                            kObj._priorityCollection.push({ primaryKey: c_Id, dropKey: dropIndex });
                            targetKey = dropIndex;
                        }
                    }
                }
            }
        }
        this._updateDropAction(target, element);
        this._dropTarget = null;
        if (sibling == 0 && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj.model.swimlaneSettings.allowDragAndDrop)
            kObj.refresh(true);
    };
    InternalDragAndDrop.prototype._updateDropData = function (target, element, cardId) {
        var kObj = this.kanbanObj;
        if (!ej.isNullOrUndefined(kObj.model.fields.primaryKey)) {
            var targetTd, prKey, primeKey, tempCard = [], columnKey;
            prKey = kObj.model.fields.priority;
            primeKey = kObj.model.fields.primaryKey;
            if (ej.isNullOrUndefined(cardId))
                cardId = $(target).attr('id');
            if ($(target).hasClass('e-rowcell'))
                targetTd = $(target);
            else
                targetTd = $(target).parents(".e-rowcell");
            if (targetTd.index() < 0)
                targetTd = kObj.element.find("#" + $(target).attr('id')).parents(".e-rowcell");
            tempCard = $.extend(true, [], kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, cardId));
            var cKey = kObj.model.columns[targetTd.index()].key;
            columnKey = typeof (cKey) == "object" ? cKey : cKey.split(",");
            if (tempCard.length > 0) {
                if ($(targetTd).find(".e-targetclonemulti").length > 0)
                    tempCard[0][kObj.model.keyField] = $(targetTd).find(".e-columnkey.e-active .e-text").eq(0).text();
                else if (columnKey.length == 1)
                    tempCard[0][kObj.model.keyField] = columnKey[0];
                if (kObj.model.fields.swimlaneKey) {
                    var sKey = $(target).parents("tr.e-columnrow").prev().find("div.e-slkey").html();
                    if (!ej.isNullOrUndefined(sKey))
                        tempCard[0][kObj.model.fields.swimlaneKey] = sKey;
                    else
                        tempCard[0][kObj.model.fields.swimlaneKey] = kObj.element.find("#" + target.id).parents("tr.e-columnrow").prev().find("div.e-slkey").html();
                }
            }
            kObj._dropped = true;
            if (prKey && kObj._priorityCollection.length > 0) {
                var dropData, curData;
                for (var i = 0; i < kObj._priorityCollection.length; i++) {
                    if (kObj._priorityCollection[i].primaryKey == cardId) {
                        dropData = kObj._priorityCollection[i];
                        kObj._priorityCollection.splice(i, 1);
                        break;
                    }
                }
                if (!ej.isNullOrUndefined(dropData) && tempCard.length > 0)
                    tempCard[0][prKey] = dropData["dropKey"];
                if (!ej.isNullOrUndefined(kObj._filterToolBar) && kObj._filterToolBar.find('.e-select').length > 0 && !ej.isNullOrUndefined(dropData) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0)) {
                    for (var k = 0; k < kObj._initialData.length; k++) {
                        if (dropData["primaryKey"] == kObj._initialData[k][primeKey]) {
                            if (tempCard.length > 0)
                                kObj._initialData[k] = tempCard[0];
                            else
                                kObj._initialData[k][prKey] = dropData["dropKey"];
                            curData = kObj._initialData[k];
                            break;
                        }
                    }
                }
            }
            if (tempCard.length > 0) {
                if ($(element).hasClass('e-cardselection')) {
                    for (var k = 0; k < kObj._selectedCardData.length; k++) {
                        if (tempCard[0][primeKey] == kObj._selectedCardData[k][primeKey])
                            break;
                    }
                    kObj._selectedCardData.splice(k, 1);
                    kObj._selectedCardData.push(tempCard[0]);
                }
                kObj._bulkUpdateData.push(tempCard[0]);
            }
            else if (prKey) {
                if (kObj.KanbanCommon._getKanbanCardData(kObj._bulkUpdateData, curData[primeKey])["length"] <= 0)
                    kObj._bulkUpdateData.push(curData);
            }
        }
    };
    InternalDragAndDrop.prototype._updateRowCellIndexes = function (id, indexes) {
        var row, column, ele = [];
        if (!ej.isNullOrUndefined(id)) {
            var card = this.kanbanObj.element.find('#' + id);
            row = $(card).parents('.e-columnrow');
            column = $(card).parents('.e-rowcell');
            ele.push([row.index(), [column.index()], [column.find('.e-kanbancard').index(column.find("#" + id))]]);
        }
        else
            ele = indexes;
        return ele;
    };
    InternalDragAndDrop.prototype._dragStop = function (args, clone, pre) {
        var proxy = this, eventArgs, dragColumn, dropColumn, trgtCloneMulti, selectedCards, parentRow, columns, clonedElement, kObj = this.kanbanObj, dragParent, dragParentIndex;
        if (!args.element.dropped)
            clone && clone.remove();
        args.target = this._getCursorElement(args);
        var target = $(args.target).closest(".e-kanbancard").length > 0 ? $(args.target).closest(".e-kanbancard")[0] : args.target;
        if (kObj.element.hasClass('e-responsive') && !$(target).hasClass('e-targetclone')) {
            var parent = $(target).parents(".e-rowcell");
            if (!$(target).hasClass("e-kanbancard") && $(target).parents(".e-kanbancard").length == 0 && parent.length > 0 && ($(target).parents(".e-kanbancard").is(":visible"))) {
                args.target = target = parent[0];
            }
        }
        parentRow = $(args.element).parents('.e-columnrow');
        var cheight = parentRow.find(target).parents('.e-rowcell').height() - kObj._tdHeightDiff;
        if (kObj._dataManager instanceof ej.DataManager && !kObj._dataManager.dataSource.offline) {
            dragColumn = kObj.element.find('.e-kanban-draggedcard').parents(".e-rowcell").index();
            dropColumn = kObj.element.find('.e-targetclone').parents(".e-rowcell").index();
            header = kObj.headerContent.find(".e-headercell");
            if (kObj.model.enableTotalCount && (kObj._filterCollection.length > 0 || kObj.model.searchSettings.key.length > 0)) {
                header.eq(dragColumn).addClass("e-card-dragged");
                header.eq(dropColumn).addClass("e-card-dropped");
            }
        }
        kObj.element.find('.e-kanban-draggedcard').removeClass('e-kanban-draggedcard');
        kObj.element.find('.e-targetdragclone').remove();
        proxy._dropEle.removeClass("e-dropping e-dragged e-dragpossible");
        kObj.element.find(".e-droppableremove").removeClass("e-droppableremove e-droppable");
        kObj.element.find(".e-dragpossible").removeClass("e-dragpossible e-drop");
        eventArgs = { data: args.dragData, draggedElement: args.dragEle, dropTarget: $(target), event: args.event };
        if (kObj._trigger('cardDragStop', eventArgs))
            return false;
        parentRow = $(args.element).parents('.e-columnrow');
        selectedCards = parentRow.find('.e-cardselection');
        columns = parentRow.find('.e-rowcell');
        if ($(args.target).parents(".e-targetclonemulti").length > 0)
            clonedElement = kObj.element.find('.e-targetclonemulti');
        else
            clonedElement = kObj.element.find('.e-targetclone');
        dragParent = $(args.element).parents('.e-rowcell');
        dragParentIndex = kObj.element.find('.e-rowcell.e-drag').index(dragParent);
        var isAdd = $(target).parent().children().hasClass("e-customaddbutton"), isLimit = $(target).parent().children().hasClass("e-limits"), isToggle = $(target).parent().children().hasClass("e-shrinkheader"), child = $(target).parent().children();
        var toggle = isToggle ? (isAdd ? (isLimit ? child.length == 4 : child.length == 3) : isLimit ? child.length == 3 : child.length == 2) : isAdd ? (isLimit ? child.length == 3 : child.length == 2) : (isLimit ? child.length == 2 : child.length == 1);
        if (clonedElement.is(':visible') && document.body.style.cursor == '' && target.style.cursor == '') {
            if ($(target).parents(".e-targetclonemulti").length > 0)
                proxy._dropToColumn($(target).parents(".e-rowcell"), $(args.element));
            else if ((target.nodeName == "TD" && $(target).parent().hasClass("e-columnrow") && clonedElement.is(':visible')) || clonedElement.siblings().length <= 0 || toggle) {
                var lastEle, cEleSiblings, scroll = $(target).find('.e-cell-scrollcontent');
                if (scroll.length > 0)
                    lastEle = scroll.children().eq(0).children().last();
                else
                    lastEle = $(target).children().last();
                if (lastEle.hasClass('e-targetclone'))
                    lastEle = lastEle.prev();
                cEleSiblings = clonedElement.siblings().not('.e-shrinkheader').not('.e-customaddbutton').not('.e-limits');
                if ($(target).children().length == 0 || cEleSiblings.length <= 0 || (lastEle.hasClass('e-customaddbutton') && lastEle.prev().hasClass('e-targetclone')) || (!lastEle.hasClass('e-customaddbutton') && ($(lastEle).offset().top + $(lastEle).height() < $(clonedElement).offset().top))) {
                    if (lastEle.next().hasClass('e-targetclone') || cEleSiblings.length <= 0)
                        proxy._dropToColumn($(target), $(args.element));
                    else {
                        pre = false;
                        proxy._dropAsSibling($(clonedElement.next()), $(args.element), pre);
                    }
                }
            }
            else if (target.nodeName == "DIV" && ($(target).hasClass("e-kanbancard") || $(target).hasClass("e-targetclone"))) {
                if ($(target).hasClass("e-targetclone")) {
                    var parent = $(target).parents('.e-rowcell');
                    if ($(target).next().length == 0 && $(parent).find('.e-kanbancard').length == 0)
                        proxy._dropToColumn($(parent), $(args.element));
                    else
                        proxy._dropAsSibling($(target), $(args.element), pre);
                }
                else if (clonedElement.is(':visible') || selectedCards.length > 1)
                    proxy._dropAsSibling($(target), $(args.element), pre);
            }
            kObj._kbnBrowserContext = "contextmenu";
        }
        proxy._removeKanbanCursor();
        if (kObj.element.hasClass('e-responsive'))
            kObj.element.parents('body').removeClass('e-kbnwindow-modal');
        kObj._autoKbnSwipeLeft = false;
        kObj._autoKbnSwipeRight = false;
        kObj.element.find(".e-targetclone").remove();
        var tarketMultiClne = kObj.element.find(".e-targetclonemulti");
        if (tarketMultiClne.length > 0) {
            tarketMultiClne.parent().find(".e-kanbancard").show();
            $(args.target).parents(".e-rowcell").css("border-style", "");
            if (kObj.element.find(".e-responsive"))
                tarketMultiClne.parent().find(".e-limits").show();
            tarketMultiClne.remove();
        }
        if ($(args.element)[0] != target)
            columns.height(cheight);
        kObj._on(kObj.element, "mouseenter mouseleave", ".e-columnrow .e-kanbancard", kObj._cardHover);
        $(clone).length > 0 && $(clone).remove();
        kObj._eventBindings();
        if (kObj.model.isResponsive)
            kObj.kanbanWindowResize();
        var draggedEle = kObj.element.find("#" + args.element.attr('id'));
        if ($(draggedEle).hasClass('e-cardselection'))
            draggedEle = $(draggedEle).parents('.e-columnrow').find('.e-cardselection:visible');
        if (kObj.KanbanAdaptive && kObj.element.hasClass('e-responsive') && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
            kObj.KanbanAdaptive._addSwimlaneName();
        dragParent = kObj.element.find('.e-rowcell.e-drag').eq(dragParentIndex);
        eventArgs.draggedElement = draggedEle;
        eventArgs.draggedParent = dragParent;
        eventArgs.data = kObj._bulkUpdateData;
        if (kObj.model.allowScrolling && !kObj.element.hasClass("e-responsive"))
            kObj.kanbanContent.data('ejScroller').refresh();
        if (kObj._trigger('cardDrop', eventArgs))
            return false;
        kObj._bulkUpdateData = [];
        var cells = dragParent.parent().find('.e-rowcell'), curDragParent = draggedEle.parents('.e-rowcell');
        if (kObj.model.isResponsive && kObj.element.hasClass('e-responsive') && curDragParent[0] != dragParent[0] && cells.index(curDragParent) != kObj._kbnSwipeCount) {
            if (cells.index(curDragParent) > cells.index(dragParent))
                kObj.KanbanAdaptive._kbnLeftSwipe();
            else
                kObj.KanbanAdaptive._kbnRightSwipe();
        }
        if (kObj.KanbanEdit && kObj.element.find(".e-form-container .e-disable").attr("value") == args.dragEle[0].id && kObj.element.find(".e-form-container").css("display") == "block" && (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate"))
            kObj.KanbanEdit.startEdit(args.dragEle);
        kObj.element.find('.e-togglevisible').removeClass('e-togglevisible');
        if (kObj.element.hasClass('e-responsive') && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj._kbnAdaptDdlIndex > 0) {
            var scroller = kObj.kanbanContent.data('ejScroller'), rows, sTop = kObj._freezeScrollTop;
            rows = kObj.element[0].getElementsByClassName('e-columnrow');
            scroller.scrollY(0, true);
            kObj._freezeScrollTop = sTop;
            scroller.scrollY(kObj._freezeScrollTop, true);
        }
        return true;
    };
    InternalDragAndDrop.prototype._getCursorElement = function (e) {
        var tgtCl = $(e.target).closest(".dragClone"), evt = e.event;
        if (tgtCl.length > 0) {
            tgtCl.hide();
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend")
                e.target = document.elementFromPoint(evt.originalEvent.changedTouches[0].pageX, evt.originalEvent.changedTouches[0].pageY);
            else
                e.target = document.elementFromPoint(evt.clientX, evt.clientY);
            tgtCl.show();
        }
        return e.target;
    };
    InternalDragAndDrop.prototype._getSelectedCards = function (ele) {
        var kObj = this.kanbanObj;
        for (var i = 0; i < kObj._selectedCards.length; i++) {
            if ($(kObj._selectedCards[i]).length > 1) {
                for (var l = 0; l < kObj._selectedCards[i].length; l++) {
                    if ($(kObj._selectedCards[i][l])[0] == ele[0]) {
                        kObj._selectedCards[i].splice(l, 1);
                        kObj._selectedCards[i].splice(0, 0, ele[0]);
                        kObj._selectedCards.splice(0, 0, kObj._selectedCards[i]);
                        kObj._selectedCards.splice(i + 1, 1);
                    }
                }
            }
            else {
                if ($(kObj._selectedCards[i])[0] == ele[0]) {
                    kObj._selectedCards.splice(0, 0, kObj._selectedCards[i]);
                    kObj._selectedCards.splice(i + 1, 1);
                }
            }
        }
        ele = kObj._selectedCards;
        return ele;
    };
    InternalDragAndDrop.prototype._kanbanAutoScroll = function (args) {
        var proxy = this, trgtCloneMulti, kObj = this.kanbanObj;
        var scroller, scrollObj, _tDragLeft = null, _tDragRight = null, _tDragUp = null, _tDragDown = null, dCard = kObj.element.find('.e-draggedcard'), rowCell = kObj.element.find('.e-columnrow .e-rowcell');
        var kWidth, kLeft, kTop, cursorX, cursorY, hHandle, hDown, hUp, vHandle, vDown, vUp;
        if (!ej.isNullOrUndefined(args["event"].clientX))
            cursorX = args["event"].clientX;
        else
            cursorX = args["event"].originalEvent.changedTouches[0].clientX;
        if (!ej.isNullOrUndefined(args["event"].clientY))
            cursorY = args["event"].clientY;
        else
            cursorY = args["event"].originalEvent.changedTouches[0].clientY;
        kWidth = kObj.element.width();
        if (kObj.element.hasClass('e-responsive') && !kObj.element.hasClass('e-swimlane-responsive'))
            scroller = $(rowCell).eq(kObj._kbnSwipeCount).find('.e-cell-scrollcontent');
        else
            scroller = kObj.getContent();
        scrollObj = scroller.data("ejScroller");
        kLeft = kObj.element.offset().left, kTop = kObj.element.offset().top;
        hUp = scroller.find('.e-hup'), hDown = scroller.find('.e-hdown');
        vUp = scroller.find('.e-vup'), vDown = scroller.find('.e-vdown');
        hHandle = scroller.find('.e-hhandle.e-box'), vHandle = scroller.find('.e-vhandle.e-box');
        if (!kObj.element.hasClass('e-responsive') && kObj.model.allowScrolling) {
            if (cursorX > kLeft + kWidth - 10) {
                kObj.element.removeClass('e-view-horizontal');
                _tDragRight = window.setInterval(function () {
                    if (dCard.length <= 0 || (dCard.length > 0 && dCard.is(':hidden')))
                        _tDragRight && (_tDragRight = window.clearInterval(_tDragRight));
                    if ((hHandle.length > 0 && ((hHandle.width() + hHandle.offset().left) <= hDown.offset().left)) && !kObj.element.hasClass('e-view-horizontal'))
                        scrollObj.scrollX(scrollObj.scrollLeft() + 5, true);
                    else
                        _tDragRight && (_tDragRight = window.clearInterval(_tDragRight));
                }, 100);
            }
            else if (cursorX - 10 < kLeft) {
                kObj.element.removeClass('e-view-horizontal');
                if (scrollObj.scrollLeft() > 0) {
                    _tDragLeft = window.setInterval(function () {
                        if (dCard.length <= 0 || (dCard.length > 0 && dCard.is(':hidden')))
                            _tDragLeft && (_tDragLeft = window.clearInterval(_tDragLeft));
                        if (hHandle.offset().left >= (hUp.offset().left + hUp.width()) && !kObj.element.hasClass('e-view-horizontal')) {
                            scrollObj.scrollX(scrollObj.scrollLeft() - 5, true);
                        }
                        else
                            _tDragLeft && (_tDragLeft = window.clearInterval(_tDragLeft));
                    }, 100);
                }
            }
            else {
                kObj.element.addClass('e-view-horizontal');
                _tDragRight && (_tDragRight = window.clearInterval(_tDragRight));
                _tDragLeft && (_tDragLeft = window.clearInterval(_tDragLeft));
            }
        }
        if (!ej.isNullOrUndefined(scroller) && scroller.length > 0 && scroller.hasClass('e-scroller')) {
            if (cursorY > ((kTop + kObj.getHeaderContent().height()) + (scroller.height() - 60)) && vHandle.length > 0 && vDown.length > 0) {
                kObj.element.removeClass('e-view-vertical');
                _tDragDown = window.setInterval(function () {
                    if (dCard.length <= 0 || (dCard.length > 0 && dCard.is(':hidden')))
                        _tDragDown && (_tDragDown = window.clearInterval(_tDragDown));
                    if (vHandle.height() + vHandle.offset().top <= vDown.offset().top && !kObj.element.hasClass('e-view-vertical') && (scrollObj.scrollTop() < (kObj.kanbanContent.find('.e-table').height() - kObj.kanbanContent.height())))
                        scrollObj.scrollY(scrollObj.scrollTop() + 5, true);
                    else
                        _tDragDown && (_tDragDown = window.clearInterval(_tDragDown));
                }, 100);
            }
            else if (cursorY - 30 < kObj.element.find('.e-kanbancontent').offset().top && vHandle.length > 0 && vUp.length > 0) {
                if (scrollObj.scrollTop() > 0) {
                    kObj.element.removeClass('e-view-vertical');
                    _tDragUp = window.setInterval(function () {
                        _tDragDown && (_tDragDown = window.clearInterval(_tDragDown));
                        if (dCard.length <= 0 || (dCard.length > 0 && dCard.is(':hidden')))
                            _tDragUp && (_tDragDown = window.clearInterval(_tDragUp));
                        if (vHandle.offset().top >= vUp.offset().top + vUp.height() && !kObj.element.hasClass('e-view-vertical')) {
                            scrollObj.scrollY(scrollObj.scrollTop() - 5, true);
                        }
                        else
                            _tDragUp && (_tDragUp = window.clearInterval(_tDragUp));
                    }, 100);
                }
            }
            else {
                kObj.element.addClass('e-view-vertical');
                _tDragDown && (_tDragDown = window.clearInterval(_tDragDown));
                _tDragUp && (_tDragUp = window.clearInterval(_tDragUp));
            }
        }
    };
    InternalDragAndDrop.prototype._changeKanbanCursor = function (target, clonedElement, args) {
        var tParent = $(target).parents('.e-kanbancard'), isCard = $(target).hasClass('e-kanbancard'), clonedCard;
        if (tParent.length > 0 || isCard) {
            var trgt = isCard ? $(target) : tParent;
            trgt[0].style.cursor = 'not-allowed';
        }
        else if ($(target).hasClass('e-shrinkheader') || $(target).parents('.e-shrinkheader').length > 0 || $(target).hasClass('e-slexpandcollapse') || $(target).parents('.e-slexpandcollapse').length > 0) {
            var trgt = $(target);
            if ($(target).parents('.e-shrinkheader').length > 0)
                trgt = $(target).parents('.e-shrinkheader');
            else if ($(target).parents('.e-slexpandcollapse').length > 0)
                trgt = $(target).parents('.e-slexpandcollapse');
            trgt[0].style.cursor = 'not-allowed';
        }
        else if ($(target).hasClass('e-shrink'))
            $(target)[0].style.cursor = 'not-allowed';
        else if ($(target).parents('.e-columnrow').has(args.element).length == 0 || $(target).parents('.e-swimlanerow').length > 0 || $(target).hasClass('e-columnkey e-disable') || $(target).parents(".e-columnkey.e-disable").length > 0)
            document.body.style.cursor = 'not-allowed';
        else if ($(target).hasClass('e-rowcell'))
            $(target)[0].style.cursor = 'not-allowed';
        clonedCard = $(clonedElement).find('.e-kanbancard');
        if (clonedCard.length > 0)
            clonedCard[0].style.cursor = 'not-allowed';
    };
    InternalDragAndDrop.prototype._removeKanbanCursor = function () {
        document.body.style.cursor = '';
        this.kanbanObj.element.find('.e-kanbancard,.e-shrink,.e-shrinkheader,.e-slexpandcollapse,.e-rowcell').css('cursor', '');
    };
    InternalDragAndDrop.prototype._multicloneremove = function (dropTd) {
        if (dropTd.hasClass("e-rowcell")) {
            var kObj = this.kanbanObj;
            $(trgtCloneMulti).parents(".e-rowcell").css("border-style", "");
            $(trgtCloneMulti).siblings(".e-kanbancard").show();
            $(trgtCloneMulti).siblings(".e-targetdragclone").show();
            if (kObj.element.find(".e-responsive"))
                $(trgtCloneMulti).siblings(".e-limits").show();
            $(trgtCloneMulti).remove();
            trgtCloneMulti.children().remove();
        }
    };
    InternalDragAndDrop.prototype._multiKeyCardDrop = function (dropTd, keylength, trgtCloneMulti, targetKey, draggedEle) {
        var kObj = this.kanbanObj;
        $(trgtCloneMulti).height(dropTd.height());
        dropTd.css("border-style", "none");
        dropTd.children().hide();
        if (kObj.element.find(".e-responsive"))
            dropTd.find(".e-limits").hide();
        dropTd.append(trgtCloneMulti);
        targetKey = typeof (targetKey) == "object" ? targetKey : targetKey.split(",");
        var draggedData = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, draggedEle.attr("id"));
        for (var i = 0; i < keylength; i++) {
            var targetcolumn = dropTd.find(".e-targetclonemulti");
            targetcolumn.append(ej.buildTag("div.e-columnkey"));
            var trgetClmn = targetcolumn.find(".e-columnkey").eq(i).addClass(kObj.KanbanCommon._preventCardMove(draggedData[0][kObj.model.keyField], targetKey[i]) ? "" : "e-disable");
            trgetClmn.append(ej.buildTag("div.e-text").text(targetKey[i]));
            trgetClmn.css({ "height": (dropTd.height() / keylength) - (1 + (1 / keylength)) });
            trgetClmn.find(".e-text").css("top", trgetClmn.height() / 2 - trgetClmn.find(".e-text").height() / 2);
        }
    };
    InternalDragAndDrop.prototype._createCardClone = function (clonedElement, ele) {
        var kObj = this.kanbanObj, draggedEle;
        clonedElement = kObj.element.find('.e-draggedcard');
        if (clonedElement.length > 0)
            clonedElement.remove();
        if (!ej.isNullOrUndefined(ele) && $(ele).hasClass('e-draggable')) {
            clonedElement = ej.buildTag('div.e-draggedcard');
            clonedElement.addClass(kObj.model.cssClass);
            draggedEle = $(ele).clone().addClass("dragClone");
            $(clonedElement).css({ "width": ele.width() });
            clonedElement.append(draggedEle);
            $(clonedElement).find("div:first").removeClass("e-hover");
            clonedElement.appendTo(kObj.element);
        }
        return clonedElement;
    };
    InternalDragAndDrop.prototype._drag = function () {
        var proxy = this, trgtCloneMulti, clonedElement = null, draggedEle = null, dragContainment = null, prevTd = null, timeot = null, queryManager, pre, eventArgs, data = [], trgtClone, draggedCard, allowDrop, kObj = this.kanbanObj;
        if (kObj.element != null)
            dragContainment = kObj.getContent().find("div:first");
        $(kObj.getContent()).find(".e-rowcell.e-drag div.e-kanbancard").not(".e-js").ejDraggable({
            dragArea: dragContainment,
            clone: true,
            cursorAt: { left: -20, top: -20 },
            dragStart: function (args) {
                if (kObj.model.enableTouch && !ej.isNullOrUndefined(kObj._cardSelect) && kObj._cardSelect == 'touch')
                    return false;
                if (kObj.element.hasClass('e-responsive'))
                    kObj.element.parents('body').addClass('e-kbnwindow-modal');
                kObj._off(kObj.element, "mouseenter mouseleave", ".e-columnrow .e-kanbancard");
                draggedCard = kObj.element.find('.e-draggedcard');
                if ($(args.element).hasClass('e-cardselection'))
                    draggedEle = $(args.element).parents('.e-columnrow').find('.e-cardselection:visible');
                else
                    draggedEle = $(args.element);
                if (draggedEle.length > 1) {
                    var multiCloneDiv = ej.buildTag('div.e-dragmultiple');
                    multiCloneDiv.append(draggedEle.length + kObj.localizedLabels.Cards);
                    draggedCard.children().remove();
                    draggedCard.append(multiCloneDiv).css("width", "90px");
                }
                for (var i = 0; i < draggedEle.length; i++) {
                    var trgtDragClone = ej.buildTag('div.e-targetdragclone');
                    $(draggedEle).eq(i).after(trgtDragClone);
                    $(trgtDragClone).css({ "width": $(draggedEle).eq(i).width(), "height": $(draggedEle).eq(i).height() });
                    $(draggedEle).eq(i).addClass('e-kanban-draggedcard');
                }
                if (data.length != 0)
                    data = [];
                for (var i = 0; i < draggedEle.length; i++) {
                    if (draggedEle[i].id != "") {
                        queryManager = new ej.DataManager(kObj._currentJsonData);
                        data.push(queryManager.executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, draggedEle[i].id)));
                    }
                }
                if (proxy && !ej.isNullOrUndefined(args.target)) {
                    eventArgs = { draggedElement: draggedEle, dragTarget: args.target, data: data, event: args["event"] };
                    if (kObj._trigger("cardDragStart", eventArgs)) {
                        args.cancel = true;
                        clonedElement && clonedElement.remove();
                        return false;
                    }
                }
                else
                    return false;
                kObj._dropinside = typeof (eventArgs.allowInternalDrop) == "boolean" ? eventArgs.allowInternalDrop : false;
                return true;
            },
            drag: function (args) {
                var _tDragRight = null, _tDragLeft = null, dCard = kObj.element.find('.e-draggedcard');
                pre = false;
                kObj._cardSelect = null;
                kObj.element.find('.e-kanbantooltip').hide();
                dCard.addClass('e-left-rotatecard');
                if (!ej.isNullOrUndefined(args["event"].clientX))
                    kObj._kbnMouseX = args["event"].clientX;
                else
                    kObj._kbnMouseX = args["event"].originalEvent.changedTouches[0].clientX;
                $(".e-kanban-context").length > 0 && $(".e-kanban-context").css("visibility", "hidden");
                !ej.isNullOrUndefined(kObj._kTouchBar) && kObj._kTouchBar.hide();
                if (!kObj._autoKbnSwipeRight && kObj.element.hasClass('e-responsive')) {
                    if ((kObj.element.offset().left + kObj.element.width()) - 50 < kObj._kbnMouseX) {
                        _tDragRight = window.setInterval(function () {
                            if (dCard.is(':hidden'))
                                _tDragRight && (_tDragRight = window.clearInterval(_tDragRight));
                            else {
                                if (kObj.element.offset().left + kObj.element.width() < kObj._kbnMouseX)
                                    _tDragRight = window.clearInterval(_tDragRight);
                                else if (kObj.element.offset().left + kObj.element.width() - 50 < kObj._kbnMouseX)
                                    kObj.KanbanAdaptive._kbnLeftSwipe();
                                else
                                    _tDragRight && (_tDragRight = window.clearInterval(_tDragRight));
                            }
                        }, 1500);
                        kObj._autoKbnSwipeRight = true;
                        kObj._autoKbnSwipeLeft = false;
                    }
                }
                if (!kObj._autoKbnSwipeLeft && kObj.element.hasClass('e-responsive')) {
                    if (kObj.element.offset().left + 20 > kObj._kbnMouseX) {
                        _tDragLeft = window.setInterval(function () {
                            if (dCard.is(':hidden'))
                                _tDragLeft && (_tDragLeft = window.clearInterval(_tDragLeft));
                            else {
                                if (kObj.element.offset().left + 20 > kObj._kbnMouseX)
                                    kObj.KanbanAdaptive._kbnRightSwipe();
                                else
                                    _tDragLeft && (_tDragLeft = window.clearInterval(_tDragLeft));
                            }
                        }, 1500);
                        kObj._autoKbnSwipeLeft = true;
                        kObj._autoKbnSwipeRight = false;
                    }
                }
                if (kObj.model.allowScrolling || kObj.model.isResponsive)
                    proxy._kanbanAutoScroll(args);
                if ($(args.target).closest(".dragClone").length > 0) {
                    args.target = prevTd;
                    clearTimeout(timeot);
                    timeot = setTimeout(function () {
                        args.target = proxy._getCursorElement(args);
                    }, 10);
                }
                if (!$(args.target).hasClass("e-targetclone") && !$(args.target).hasClass("e-rowcell") && !$(args.target).hasClass("e-customaddbutton")) {
                    $(trgtClone).remove();
                }
                var target = $(args.target).closest(".e-kanbancard").length > 0 ? $(args.target).closest(".e-kanbancard")[0] : args.target, dropTd, dragTd, selectedCards;
                var isSwimDragAndDrop = !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj.model.swimlaneSettings.allowDragAndDrop;
                dragTd = $(args.element).closest("td.e-rowcell").addClass("e-dragged");
                var dragTdSiblen = dragTd.siblings().length;
                if (dragTd.parent().find(".e-dragpossible").length == 0 && dragTdSiblen > 0) {
                    var cardData = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, $(args.element).attr('id'))[0];
                    for (var i = 0; i < dragTdSiblen; i++)
                        if (kObj.KanbanCommon._preventCardMove(cardData[kObj.model.keyField], kObj.model.columns[dragTd.parent().children().index(dragTd.siblings()[i])].key)) {
                            dragTd.siblings().eq(i).addClass("e-dragpossible");
                            if (isSwimDragAndDrop) {
                                var kbnColumn = kObj.element.find(".e-columnrow");
                                for (var j = 0; j < kbnColumn.length; j++) {
                                    var kbnrowcell = kbnColumn.eq(j).find(".e-rowcell");
                                    var kbnColumncell = dragTd.parent().children();
                                    kbnrowcell.eq(kbnColumncell.index(dragTd.siblings().eq(i))).addClass("e-dragpossible");
                                    kbnrowcell.eq(kbnColumncell.index(dragTd)).addClass("e-dragpossible");
                                }
                            }
                        }
                }
                dragTd.siblings(".e-drop.e-dragpossible").addClass("e-dropping");
                if (!kObj._dropinside)
                    dragTd.addClass("e-dragpossible e-drop");
                else
                    dragTd.addClass("e-dragpossible e-drop e-droppable e-droppableremove");
                eventArgs = { draggedElement: draggedEle, data: data, dragTarget: target, event: args["event"] };
                prevTd = dropTd = $(target).closest("td.e-rowcell");
                selectedCards = dropTd.parents('.e-columnrow').find('.e-cardselection');
                if (dropTd && dropTd.hasClass("e-droppable") && (isSwimDragAndDrop ? true : $(dropTd).parent().has(args.element[0]).length > 0) && (target != args.element[0] || selectedCards.length > 1)) {
                    document.body.style.cursor = '';
                    if ($(trgtClone).parents('.e-rowcell').index() != dropTd.index())
                        $(trgtClone).remove();
                    dropTd.find(".e-kanbancard").removeClass("e-hover");
                    var lastEle, prevHgt;
                    if (kObj.element.hasClass('e-responsive')) {
                        var parent = $(target).parents(".e-rowcell");
                        if (!$(target).hasClass("e-kanbancard") && $(target).parents(".e-kanbancard").length == 0 && parent.length > 0) {
                            target = parent;
                            dropTd = $(target).find('.e-cell-scrollcontent').children().eq(0);
                        }
                    }
                    lastEle = dropTd.children().last();
                    if (lastEle.hasClass('e-shrinkheader'))
                        lastEle = lastEle.prev();
                    if ($(target).hasClass("e-columnkey") || $(target).parents(".e-columnkey").length > 0 || $(target).find(".e-columnkey").length > 0) {
                        var parentRow = $(target).hasClass("e-rowcell") ? $(target) : $(target).parents(".e-rowcell");
                        var curtrgt = args.target;
                        if (($(curtrgt).hasClass("e-columnkey") && !$(curtrgt).hasClass("e-disable")) || ($(curtrgt).parents(".e-columnkey").length > 0 && !$(curtrgt).parents(".e-disable").length > 0)) {
                            proxy._removeKanbanCursor();
                            parentRow.find(".e-columnkey.e-active").removeClass("e-active");
                            parentRow.find(".e-columnkey.e-multiclonestyle").removeClass("e-multiclonestyle");
                            $(curtrgt).closest(".e-columnkey").not(".e-disable").addClass("e-active");
                            $(dropTd).find(".e-active").prev().addClass("e-multiclonestyle");
                        }
                        else {
                            proxy._changeKanbanCursor(target, clonedElement, args);
                        }
                    }
                    if (($(target).hasClass("e-rowcell") || $(target).hasClass("e-kanbancard") || $(target).hasClass("e-targetdragclone") || ($(target).hasClass("e-swimlane-name") || ($(target).hasClass("e-limits"))) || $(target).parents(".e-rowcell").not(".e-drop").length > 0) && $(trgtCloneMulti).is(":visible") && ($(target).index() != trgtCloneMulti.parents(".e-rowcell").index())) {
                        $(trgtCloneMulti).siblings(".e-kanbancard").not(".e-kanban-draggedcard").show();
                        $(trgtCloneMulti).parents(".e-rowcell").css("border-style", "");
                        $(trgtCloneMulti).siblings(".e-targetdragclone,.e-customaddbutton,.e-limits").show();
                        $(trgtCloneMulti).remove();
                        trgtCloneMulti.children().remove();
                    }
                    else if ($(target).hasClass("e-rowcell") && (args.element[0] != lastEle[0] || selectedCards.length > 1) && !$(target).hasClass("e-shrink") && !$(lastEle[0]).hasClass("e-targetclonemulti")) {
                        var dragPossible = $(target).hasClass("e-dragpossible");
                        var targetIndex = $(target).parent().children().index(target);
                        var targetKey = kObj.model.columns[targetIndex].key;
                        var keylength = (typeof (targetKey) == "object" ? targetKey : targetKey.split(",")).length;
                        if (lastEle.length == 0 || dropTd.children().length == 0 || ((lastEle.offset().top + lastEle.height() < $(clonedElement).offset().top) || keylength > 1)) {
                            if (dragPossible && (keylength == 1 || ((targetIndex == $(dragTd).parent().children().index(dragTd) && (draggedEle.length == 1 || (draggedEle.length > 1 && kObj.selectedRowCellIndexes[0].cellIndex.length == 1))) || (draggedEle.length > 1 && (!kObj.selectedRowCellIndexes[0].cellIndex.length > 1 && ($.inArray(dropTd.index(), kObj.selectedRowCellIndexes[0].cellIndex) != -1)))))) {
                                prevHgt = $(target).height();
                                var clHght = $(args.element[0]).height(), clWidth = $(target).width();
                                var lastEle = dropTd.children().last(), appendTrgt = dropTd, scroller = dropTd.find('.e-cell-scrollcontent');
                                if (kObj.element.hasClass('e-responsive') && scroller.length > 0) {
                                    lastEle = scroller.children().last();
                                    appendTrgt = scroller.children();
                                }
                                if (lastEle.hasClass('e-customaddbutton'))
                                    lastEle.before($(trgtClone).height(clHght).width(clWidth - 28));
                                else
                                    appendTrgt.append($(trgtClone).height(clHght).width(clWidth - 28));
                                if (prevHgt < $(target).height()) {
                                    dropTd.height(dropTd.height());
                                    kObj._tdHeightDiff = $(target).height() - prevHgt;
                                }
                            }
                            else if (dragPossible && keylength > 1) {
                                if (!dropTd.find(".e-columnkey").length > 0)
                                    proxy._multicloneremove(dropTd);
                                proxy._multiKeyCardDrop(dropTd, keylength, trgtCloneMulti, targetKey, draggedEle);
                            }
                            else
                                proxy._changeKanbanCursor(target, clonedElement, args);
                        }
                    }
                    else if (($(target).hasClass("e-rowcell") && $(target).hasClass("e-shrink") && $(target).hasClass("e-dragpossible")) || (($(target).hasClass("e-shrinkheader IE") || $(target).hasClass("e-shrinkcount") || $(target).hasClass("e-shrinklabel")) && ($(target).parents('.e-rowcell').hasClass("e-dragpossible")))) {
                        var targetCol = $(target).hasClass('e-rowcell') ? $(target) : $(target).parents('.e-rowcell');
                        var column = new ej.DataManager(kObj.model.columns).executeLocal(new ej.Query().where('key', ej.FilterOperators.equal, targetCol.attr('ej-mappingkey')));
                        kObj.toggleColumn(column[0].headerText);
                        kObj.element.find('.e-draggedcard').width(kObj.element.find('.e-targetdragclone').width());
                        trgtClone.width(kObj.element.find('.e-targetdragclone').width());
                        targetCol.addClass('e-togglevisible');
                    }
                    else if ($(target).hasClass("e-shrink") && !$(target).hasClass("e-dragpossible")) {
                        proxy._changeKanbanCursor(target, clonedElement, args);
                    }
                    else if ($(target).hasClass("e-kanbancard") || $(target).hasClass("e-targetclone")) {
                        var parentTd = $(target).parents('.e-rowcell'), pageY;
                        var targetKey = kObj.model.columns[parentTd.parent().children().index(parentTd)].key;
                        var keylength = (typeof (targetKey) == "object" ? targetKey : targetKey.split(",")).length;
                        prevHgt = parentTd.height();
                        var dragPossible = $(target).parents(".e-rowcell").hasClass("e-dragpossible");
                        if (!ej.isNullOrUndefined(args["event"].pageY))
                            pageY = args["event"].pageY;
                        else
                            pageY = args["event"].originalEvent.changedTouches[0].pageY;
                        if ((($(target).offset().top + ($(target).height()) / 2) >= pageY) && dragPossible && ((draggedEle.length > 1 && (!kObj.selectedRowCellIndexes[0].cellIndex.length > 1 && ($.inArray(dropTd.index(), kObj.selectedRowCellIndexes[0].cellIndex)) != -1)) || keylength == 1 || (($(dropTd).parent().children().index(dropTd) == $(dragTd).parent().children().index(dragTd)) && dragTd.parents("tr").index() == dropTd.parents("tr").index()))) {
                            if ($(target).prev()[0] != args.element[0] || selectedCards.length > 1) {
                                if (!$(target).hasClass("e-targetclone") && ($(target).prev().length == 0 || ($(target).prev().length > 0 && !$(target).prev().hasClass("e-targetdragclone")))) {
                                    proxy._removeKanbanCursor();
                                    $(trgtClone).insertBefore($(target)).height(dCard.find('.e-kanbancard').outerHeight()).width($(target).width()).removeClass('e-targetappend');
                                }
                            }
                            else
                                proxy._changeKanbanCursor(target, clonedElement, args);
                        }
                        else {
                            if (($(target).next()[0] != args.element[0] || selectedCards.length > 1) && dragPossible && ((draggedEle.length > 1 && (!kObj.selectedRowCellIndexes[0].cellIndex.length > 1 && ($.inArray(dropTd.index(), kObj.selectedRowCellIndexes[0].cellIndex)) != -1)) || keylength == 1 || (($(dropTd).parent().children().index(dropTd) == $(dragTd).parent().children().index(dragTd)) && (dragTd.parents("tr").index() == dropTd.parents("tr").index() || isSwimDragAndDrop)))) {
                                prevHgt = $(target).parents('.e-rowcell').height();
                                if (!$(target).hasClass("e-targetclone") && ($(target).next().length == 0 || ($(target).next().length > 0 && !$(target).next().hasClass("e-targetdragclone")))) {
                                    pre = true;
                                    proxy._removeKanbanCursor();
                                    $(trgtClone).insertAfter($(target)).height(dCard.find('.e-kanbancard').outerHeight()).width($(target).width()).addClass('e-targetappend');
                                }
                            }
                            else if (dragPossible && keylength > 1 && !parentTd.find(".e-columnkey").length > 0 && !($(dropTd).parent().children().index(dropTd) == $(dragTd).parent().children().index(dragTd))) {
                                proxy._multicloneremove(dropTd);
                                proxy._multiKeyCardDrop(parentTd, keylength, trgtCloneMulti, targetKey, draggedEle);
                            }
                            else
                                proxy._changeKanbanCursor(target, clonedElement, args);
                        }
                        if (prevHgt < parentTd.height()) {
                            parentTd.height(parentTd.height());
                            kObj._tdHeightDiff = parentTd.height() - prevHgt;
                        }
                    }
                    if ($(trgtClone).parent().hasClass("e-rowcell") && dragTd.parent().has($(trgtClone).parent()).length == 0 && isSwimDragAndDrop) {
                        kObj.element.find(".e-columnrow .e-rowcell.e-drop").addClass("e-dropping");
                        dragTd.removeClass("e-dropping").addClass("e-dragged");
                    }
                    else {
                        kObj.element.find(".e-columnrow .e-rowcell").removeClass("e-dropping");
                        dragTd.addClass("e-dragged");
                        dragTd.siblings(".e-drop.e-dragpossible ").addClass("e-dropping");
                    }
                }
                else {
                    if ($(target).parents(".e-rowcell").not(".e-droppable").length > 0 || $(target).hasClass("e-swimlane-name") || $(target).hasClass("e-limits") || ($(target).hasClass("e-swimlanerow") || $(target).parents(".e-swimlanerow").length > 0)) {
                        if ($(trgtCloneMulti).is(":visible")) {
                            $(trgtCloneMulti).siblings(".e-kanbancard").not(".e-kanban-draggedcard").show();
                            $(trgtCloneMulti).parents(".e-rowcell").css("border-style", "");
                            $(trgtCloneMulti).siblings(".e-targetdragclone,.e-customaddbutton,.e-limits").show();
                            $(trgtCloneMulti).remove();
                            trgtCloneMulti.children().remove();
                        }
                    }
                    if ($(target).hasClass("e-swimlanerow") || $(target).parents(".e-swimlanerow").length > 0) {
                        if ($(trgtClone).is(':visible'))
                            $(trgtClone).remove();
                    }
                    proxy._changeKanbanCursor(target, clonedElement, args);
                }
                var tColumn = kObj.element.find('.e-togglevisible');
                if (tColumn.length > 0 && !$(target).hasClass('e-togglevisible') && $(target).parents('.e-togglevisible').length == 0) {
                    var column = new ej.DataManager(kObj.model.columns).executeLocal(new ej.Query().where('key', ej.FilterOperators.equal, tColumn.attr('ej-mappingkey')));
                    kObj.toggleColumn(column[0].headerText);
                    kObj.element.find('.e-draggedcard').width(kObj.element.find('.e-targetdragclone').width());
                    trgtClone.width(kObj.element.find('.e-targetdragclone').width());
                    tColumn.removeClass('e-togglevisible');
                }
                if (kObj._trigger("cardDrag", eventArgs))
                    return false;
                return true;
            },
            dragStop: function (args) {
                kObj._cardSelect = null;
                args["dragData"] = data, args["dragEle"] = draggedEle;
                proxy._dragStop(args, clonedElement, pre);
            },
            helper: function (event) {
                if (kObj.model.enableTouch && !ej.isNullOrUndefined(kObj._cardSelect) && kObj._cardSelect == 'touch')
                    return false;
                trgtClone = ej.buildTag('div.e-targetclone');
                trgtCloneMulti = ej.buildTag('div.e-targetclonemulti');
                $(trgtClone).css({ "width": event.element.width(), "height": event.element.height() });
                clonedElement = proxy._createCardClone(clonedElement, event.element);
                return clonedElement;
            }
        });
    };
    return InternalDragAndDrop;
}());
window.ej.createObject("ej.KanbanFeatures.DragAndDrop", InternalDragAndDrop, window);
;
var InternalEdit = (function () {
    function InternalEdit(element) {
        this.kanbanObj = null;
        this._dropDownManager = null;
        this._editForm = null;
        this._onKbnDialogBeforeClose = function () {
            var kObj = this.kanbanObj, $dialogWrapper = kObj.element.find("#" + kObj._id + "_dialogEdit_wrapper");
            $dialogWrapper.addClass('e-kbndialog-transitionclose');
        };
        this._onKbnDialogBeforeOpen = function () {
            var kObj = this.kanbanObj, $dialogWrapper = kObj.element.find("#" + kObj._id + "_dialogEdit_wrapper");
            $dialogWrapper.removeClass('e-kbndialog-transitionclose');
        };
        this.kanbanObj = element;
    }
    ;
    InternalEdit.prototype._processEditing = function () {
        var kObj = this.kanbanObj, query = this._columnToSelect(), proxy = this;
        kObj.model.query._fromTable != "" && query.from(kObj.model.query._fromTable);
        if (kObj._dataSource() instanceof ej.DataManager && query["queries"].length && !kObj._dataManager.dataSource.offline) {
            var queryPromise = kObj._dataSource().executeQuery(query);
            queryPromise.done(ej.proxy(function (e) {
                proxy._dropDownManager = new ej.DataManager(e.result);
                proxy._addDialogEditingTemplate();
            }));
        }
        else {
            proxy._addDialogEditingTemplate();
        }
    };
    InternalEdit.prototype._renderDialog = function () {
        var $dialog = ej.buildTag("div.e-dialog e-kanbandialog e-dialog-content e-shadow e-widget-content", "", { display: "none" }, { id: this.kanbanObj._id + "_dialogEdit" });
        return $dialog;
    };
    InternalEdit.prototype._columnToSelect = function () {
        var item = [], kObj = this.kanbanObj;
        for (var i = 0; i < kObj.model.editSettings.editItems.length; i++) {
            if (kObj.model.editSettings.editItems[i].editType == "dropdownedit" && ej.isNullOrUndefined(kObj.model.editSettings.editItems[i].dataSource))
                item.push(kObj.model.editSettings.editItems[i].field);
        }
        if (item.length)
            return new ej.Query().select(item);
        return new ej.Query();
    };
    InternalEdit.prototype.cancelEdit = function () {
        var kObj = this.kanbanObj;
        if (kObj.model.editSettings.allowEditing || kObj.model.editSettings.allowAdding) {
            if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate")
                $("#" + kObj._id + "_dialogEdit").ejDialog("close");
            else if (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate") {
                if (kObj.model.editSettings.formPosition == "right")
                    $(kObj.element).children().css("width", "100%");
                $("#" + kObj._id + "_externalEdit").css("display", "none");
            }
            kObj.refreshTemplate();
            var args = { requestType: "cancel" };
            kObj.KanbanCommon._processBindings(args);
        }
        kObj.element.parents('body').removeClass('e-kbnwindow-modal');
        if (kObj.element.hasClass('e-responsive'))
            kObj.kanbanWindowResize();
    };
    InternalEdit.prototype._renderExternalForm = function () {
        var kObj = this.kanbanObj;
        var $externalform = ej.buildTag("div", "", { display: "none" }, { id: kObj._id + "_externalEdit", 'class': "e-form-container" });
        var $eformHeader = ej.buildTag("div", "", "", { id: kObj._id + "_eFormHeader", 'class': "e-form-titlebar" });
        var $eformTitle = ej.buildTag("span", "", "", { 'class': "e-form-title" });
        var $eformCloseBtn = ej.buildTag("div", "", "", { id: kObj._id + "_closebutton", 'class': "e-externalform-icon" });
        var $eformCloseIcon = ej.buildTag("span", "", "", { 'class': "e-icon e-externaledit e-cancel" });
        $eformCloseBtn.append($eformCloseIcon);
        $eformHeader.append($eformTitle).append($eformCloseBtn);
        var $eformContent = ej.buildTag("div", "", "", { id: kObj._id + "_eFormContent", 'class': "e-form-content" });
        var $eform = ej.buildTag("div", "", "", { id: kObj._id + "_externalForm", 'class': "e-externalform" });
        var $contentOuterDiv = ej.buildTag("div", "", "", { 'class': "e-externalformedit" });
        $eform.append($contentOuterDiv);
        $eformContent.append($eform);
        return $externalform.append($eformHeader).append($eformContent);
        ;
    };
    InternalEdit.prototype._maxZindex = function () {
        var maxZ = 1;
        maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
            if ($(e).css('position') == 'absolute')
                return parseInt($(e).css('z-index')) || 1;
        }));
        if (maxZ == undefined || maxZ == null)
            maxZ = 1;
        return maxZ;
    };
    InternalEdit.prototype.addCard = function (primaryKey, data) {
        var kObj = this.kanbanObj;
        if (kObj._currentJsonData.length == 0) {
            var addData = [];
            addData.push(data);
            kObj.element.ejKanban({ "dataSource": addData });
            return;
        }
        if (kObj.model.editSettings.allowAdding) {
            var args, pKey = kObj.model.fields.primaryKey;
            if (primaryKey != "bulk" && $.type(kObj._currentJsonData[0][pKey]) == "number")
                primaryKey = parseInt(primaryKey);
            args = { data: data, requestType: "save", action: "add", primaryKeyValue: primaryKey };
            kObj._cAddedRecord = data;
            kObj._saveArgs = args;
            if (primaryKey && data)
                kObj.updateCard(primaryKey, data);
            else {
                var editItems = kObj.model.editSettings.editItems;
                args = { requestType: "add" }, kObj._currentData = {};
                if (kObj._isAddNewClick) {
                    if (kObj.model.fields.swimlaneKey)
                        kObj._currentData[kObj.model.fields.swimlaneKey] = $(kObj._newCard).parent().prev('.e-swimlanerow').find('.e-slkey').text();
                    if (kObj.model.keyField)
                        kObj._currentData[kObj.model.keyField] = kObj.model.columns[$(kObj._newCard).index()].key;
                }
                for (var i = 0; i < editItems.length; i++)
                    kObj._currentData[editItems[i].field] = !ej.isNullOrUndefined(editItems[i].defaultValue) ? editItems[i].defaultValue : !ej.isNullOrUndefined(kObj._currentData[editItems[i].field]) ? kObj._currentData[editItems[i].field] : "";
                kObj._currentData[pKey] = kObj._currentJsonData[kObj._currentJsonData.length - 1][pKey];
                if ($.type(kObj._currentJsonData[0][pKey]) == "string")
                    kObj._currentData[pKey] = parseInt(kObj._currentData[pKey]);
                kObj._currentData[pKey] = kObj._currentData[pKey] + 1;
                if ($.type(kObj._currentJsonData[0][pKey]) == "string")
                    kObj._currentData[pKey] = kObj._currentData[pKey].toString();
                args.data = kObj._currentData;
                kObj.element.find('.e-kanbandialog').removeAttr('data-id');
                kObj.KanbanCommon._processBindings(args);
            }
        }
    };
    InternalEdit.prototype.deleteCard = function (primaryKey) {
        var args, kObj = this.kanbanObj, cardDiv, currentData, deleteManager, query, promise, pKey = kObj.model.fields.primaryKey, kObj = this.kanbanObj;
        cardDiv = kObj.element.find("#" + primaryKey);
        deleteManager = new ej.DataManager(kObj._currentJsonData);
        query = new ej.Query();
        query = query.where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, primaryKey);
        currentData = deleteManager.executeLocal(query);
        if ($.type(kObj._currentJsonData[0][pKey]) == "number")
            primaryKey = parseInt(primaryKey);
        args = { div: cardDiv, data: currentData[0], requestType: "delete", primaryKeyValue: primaryKey };
        kObj._saveArgs = args;
        if (kObj._trigger("actionBegin", args))
            return true;
        kObj._cDeleteData = currentData;
        kObj.updateCard(primaryKey, currentData[0]);
    };
    InternalEdit.prototype.startEdit = function ($div) {
        var kObj = this.kanbanObj;
        if ($.type($div) != "object")
            $div = kObj.element.find("#" + $div);
        if (kObj.model.editSettings.allowEditing && $div.hasClass('e-kanbancard')) {
            var parentDiv, args, pKey = kObj.model.fields.primaryKey, primaryKey = $div.attr('id');
            var columnIndex = $div.hasClass("e-rowcell") ? $div.index() : $div.closest(".e-rowcell").index();
            var rowIndex = kObj.getIndexByRow($div.closest("tr")), editingManager, queryManager = new ej.Query();
            parentDiv = $div.closest('.e-kanbancard');
            if (kObj._cardEditClick == true)
                kObj._currentData.data = kObj._dblArgs.data;
            else {
                editingManager = new ej.DataManager(kObj._currentJsonData);
                queryManager = queryManager.where(pKey, ej.FilterOperators.equal, $div.attr('id'));
                kObj._currentData = editingManager.executeLocal(queryManager);
            }
            if ($.type(kObj._currentJsonData[0][pKey]) == "number")
                primaryKey = parseInt(primaryKey);
            args = { target: $div, rowIndex: rowIndex, data: kObj._currentData[0], columnIndex: columnIndex, cardIndex: parentDiv.index(), primaryKeyValue: primaryKey };
            kObj._trigger("beginEdit", args);
            args.requestType = "beginedit";
            if (args.cancel)
                return;
            kObj.KanbanCommon._processBindings(args);
        }
    };
    InternalEdit.prototype._refreshEditForm = function (args) {
        var kObj = this.kanbanObj;
        var tds, inputWidth;
        if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate") {
            var $dialogWrapper = kObj.element.find("#" + kObj._id + "_dialogEdit_wrapper"), percent = 95;
            $dialogWrapper.show();
            var dialogEditForm = $("#" + kObj._id + "_dialogEdit");
            tds = dialogEditForm.find("tr").find(".e-rowcell");
        }
        else if (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate") {
            var $external = kObj.element.find("#" + kObj._id + "_externalEdit"), percent = 133;
            $external.show();
            var dialogEditForm = $("#" + kObj._id + "_externalForm");
            tds = dialogEditForm.find("div").find(".e-rowcell");
        }
        for (var i = 0; i < tds.length; i++)
            kObj._tdsOffsetWidth[i] = tds.get(i).offsetWidth;
        if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate")
            inputWidth = ej.max(kObj._tdsOffsetWidth) * (percent / 100);
        for (var count = 0; count < kObj.model.editSettings.editItems.length; count++) {
            var curItem = kObj.model.editSettings.editItems[count], curControl = dialogEditForm.find('#' + kObj._id + "_" + curItem['field']);
            if (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate") {
                inputWidth = ej.max(kObj._tdsOffsetWidth) * (percent / 100);
                $(curControl).parent().css("width", inputWidth + "px");
            }
            var params;
            var customParams;
            if (curItem['editType'] == "stringedit")
                curControl.width(inputWidth - 4);
            var isText = (curItem['editType'] == "textarea"), isExternal = (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate");
            customParams = curItem['editParams'];
            if (!ej.isNullOrUndefined(customParams) && isText) {
                if (!ej.isNullOrUndefined(customParams.width)) {
                    curControl.width(customParams.width);
                    if (isText && isExternal)
                        curControl.parent().width(customParams.width + 8);
                }
                if (!ej.isNullOrUndefined(customParams.height)) {
                    curControl.height(customParams.height);
                    if (isText && isExternal)
                        curControl.parent().height(customParams.height + 8);
                }
            }
            else if (isText && (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate"))
                curControl.width(250).height(95);
            else if (isText && (isExternal && kObj.model.editSettings.formPosition == "bottom")) {
                curControl.height(95);
                $(curControl).css({ "width": "400px" });
                $(curControl).parent().css({ "width": "500px" });
            }
            else if (isText && (isExternal && kObj.model.editSettings.formPosition == "right")) {
                curControl.css({ "width": inputWidth - 8 });
                curControl.height(150);
                $(curControl).parent().css("width", inputWidth + 8);
            }
            if (curItem['editType'] == "rteedit") {
                params = { width: "450px", height: "260px", minHeight: "240px", locale: kObj.model.locale, enableRTL: kObj.model.enableRTL };
                customParams = curItem['editParams'];
                params.toolsList = ["style", "links"];
                params.tools = {
                    style: ["bold", "italic", "underline"],
                    casing: ["upperCase", "lowerCase"],
                    links: ["createLink"]
                };
                if (!ej.isNullOrUndefined(customParams))
                    $.extend(params, customParams);
                dialogEditForm.find('#' + kObj._id + "_" + curItem['field']).ejRTE(params);
            }
            else {
                var value;
                if (curItem['editType'] == "dropdownedit") {
                    params = { width: inputWidth, enableIncrementalSearch: true, enableRTL: kObj.model.enableRTL };
                    value = curControl.val();
                    customParams = curItem['editParams'];
                    var disable = [];
                    if (((curItem.field == kObj.model.keyField)) && args.requestType === "beginedit") {
                        for (var i = 0; i < curControl.children().length; i++) {
                            var dropdownvalue = curControl.children().eq(i).val();
                            if (!ej.isNullOrUndefined(kObj.model.workflows))
                                kObj.KanbanCommon._preventCardMove(value, curControl.children().eq(i).val()) ? true : disable.push(i);
                            if (value != dropdownvalue) {
                                if (!kObj.model.columns[kObj._getColumnKeyIndex(dropdownvalue)].allowDrop) {
                                    if ($.inArray(i, disable) === -1)
                                        disable.push(i);
                                }
                                if (!kObj.model.columns[kObj._getColumnKeyIndex(value)].allowDrag) {
                                    if ($.inArray(i, disable) === -1)
                                        disable.push(i);
                                }
                            }
                        }
                    }
                    if (disable.length > 0)
                        for (var j = disable.length - 1; j >= 0; j--)
                            $(curControl.children()).eq(disable[j]).remove();
                    if (curControl.hasClass("e-disable"))
                        params.enabled = false;
                    if (!ej.isNullOrUndefined(customParams))
                        $.extend(params, customParams);
                    kObj._kbnDdlWindowResize = true;
                    curControl.ejDropDownList(params);
                    curControl.ejDropDownList("setSelectedValue", curControl.val());
                    kObj._kbnDdlWindowResize = false;
                }
                else if (curItem['editType'] == "numericedit") {
                    params = { width: inputWidth };
                    value = curControl.val();
                    customParams = curItem['editParams'];
                    params.cssClass = kObj.model.cssClass;
                    params.showSpinButton = true;
                    params.enableRTL = kObj.model.enableRTL;
                    params.locale = kObj.model.locale;
                    if (value.length)
                        params.value = parseFloat(value);
                    if (curControl.hasClass("e-disable"))
                        params.enabled = false;
                    if (!ej.isNullOrUndefined(customParams))
                        $.extend(params, customParams);
                    curControl.ejNumericTextbox(params);
                }
                else if (curItem['editType'] == "datepicker") {
                    params = { width: inputWidth };
                    value = curControl.val();
                    customParams = curItem['editParams'];
                    params.cssClass = kObj.model.cssClass;
                    params.displayDefaultDate = true;
                    params.enableRTL = kObj.model.enableRTL;
                    params.locale = kObj.model.locale;
                    if (value.length)
                        params.value = new Date(value);
                    if (curControl.hasClass("e-disable"))
                        params.enabled = false;
                    if (!ej.isNullOrUndefined(customParams))
                        $.extend(params, customParams);
                    curControl.ejDatePicker(params);
                }
                else if (curItem['editType'] == "datetimepicker") {
                    params = { width: inputWidth, cssClass: kObj.model.cssClass, locale: kObj.model.locale, showPopupButton: false, enableRTL: kObj.model.enableRTL };
                    value = curControl.val();
                    customParams = curItem['editParams'];
                    if (value.length)
                        params.value = new Date(value);
                    if (curControl.hasClass("e-disable"))
                        params.enabled = false;
                    if (!ej.isNullOrUndefined(customParams))
                        $.extend(params, customParams);
                    curControl.ejDateTimePicker(params);
                }
            }
            if (curItem['editType'] != "textarea")
                $(curControl.outerWidth(inputWidth)).height(28);
            if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
                curControl.css("line-height", "26px");
        }
        if (isExternal)
            kObj._editForm = kObj.element.find(".e-externalform");
        if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate") {
            kObj._editForm = kObj.element.find(".kanbanform");
            $dialogWrapper.hide();
        }
        this._formFocus();
    };
    InternalEdit.prototype._setKanbanDdlValue = function ($editRow) {
        var $selectDdl = $editRow.find("select.e-field"), x, inputDdl = $editRow.find("input.e-field.e-dropdownlist");
        for (var i = 0; i < $selectDdl.length; i++) {
            var ddlTempl = {};
            ddlTempl[this.kanbanObj._id + "drpDownTempl"] = "{{:" + $selectDdl[i].name.replace(/[^a-z0-9\s]/gi, '') + "}}";
            $.templates(ddlTempl);
            x = $.render[this.kanbanObj._id + "drpDownTempl"](this.kanbanObj._currentData);
            $editRow.find("select").eq(i).val(x).attr("selected", "selected");
            $selectDdl.eq(i).val(x);
        }
        for (var j = 0; j < inputDdl.length; j++)
            inputDdl.eq(j).val(ej.getObject(inputDdl.eq(j).attr("name"), this.kanbanObj._currentData[0]));
    };
    InternalEdit.prototype._editAdd = function (args) {
        var dialogEditForm, kObj = this.kanbanObj, $dialog = kObj.element.find(".e-kanbandialog"), target = $(args.target), editingManager, queryManager = new ej.Query(), pKey = kObj.model.fields.primaryKey;
        var editRow = document.createElement('div'), $editRow = $(editRow), cardId;
        if (args.requestType == "add")
            $editRow.addClass("e-addedrow");
        else {
            kObj._currentData = {};
            if (target.hasClass('e-kanbancard'))
                cardId = target.attr('id');
            else if (target.parents('.e-kanbancard').length > 0)
                cardId = target.parents('.e-kanbancard').attr('id');
            if ($.type(kObj._currentJsonData[0][pKey]) == "number")
                cardId = parseInt(cardId);
            editingManager = new ej.DataManager(kObj._currentJsonData);
            queryManager = queryManager.where(pKey, ej.FilterOperators.equal, cardId);
            kObj._currentData = editingManager.executeLocal(queryManager);
            $editRow.addClass("e-editedrow");
        }
        editRow.innerHTML = $.render[kObj._id + "_dialogEditingTemplate"](kObj._currentData);
        this._setKanbanDdlValue($editRow);
        var titleLbl, title;
        if (args.requestType == "add") {
            if (!ej.isNullOrUndefined(kObj.model.fields.title) && !$.isEmptyObject(kObj._newData)) {
                titleLbl = kObj.model.fields.title;
                title = kObj.localizedLabels.EditFormTitle + kObj._newData[titleLbl];
            }
            else
                title = kObj.localizedLabels.AddFormTitle;
        }
        else {
            titleLbl = pKey;
            if (!ej.isNullOrUndefined(kObj.model.fields.title))
                titleLbl = kObj.model.fields.title;
            title = kObj.localizedLabels.EditFormTitle + kObj._currentData[0][titleLbl];
        }
        if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate") {
            dialogEditForm = $("#" + kObj._id + "_dialogEdit");
            dialogEditForm.html($(editRow));
            var model = { cssClass: kObj.model.cssClass, enableRTL: kObj.model.enableRTL, width: "auto", content: "#" + kObj._id, close: $.proxy(this.cancelEdit, this), beforeClose: $.proxy(this._onKbnDialogBeforeClose, this), beforeOpen: $.proxy(this._onKbnDialogBeforeOpen, this), open: $.proxy(this._onKbnDialogOpen, this), enableModal: true, enableResize: false, title: title };
            dialogEditForm.ejDialog(model);
            dialogEditForm.ejDialog("open");
            $dialog.attr('data-id', cardId);
            var $dialogWrapper = kObj.element.find("#" + kObj._id + "_dialogEdit_wrapper");
            $dialogWrapper.css("left", "0");
            var wTop;
            if (self != parent) {
                if (ej.browserInfo().name == "chrome")
                    wTop = $(window).scrollTop();
                else
                    wTop = -$(window.frameElement).offset().top;
            }
            else
                wTop = $(window).scrollTop();
            $dialogWrapper.css("top", wTop);
            $dialogWrapper.hide();
        }
        else if (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate") {
            $("#" + kObj._id + "_externalEdit").css("display", "block").css('z-index', this._maxZindex() + 1);
            $("#" + kObj._id + "_externalForm").find(".e-externalformedit").html($(editRow));
            $("#" + kObj._id + "_eFormHeader").find(".e-form-title").text(title);
            $("#" + kObj._id + "_externalForm").attr('data-id', cardId);
            this._externalFormPosition();
        }
        if ($.isFunction($["validator"])) {
            this.initValidator();
            this.setValidation();
        }
    };
    InternalEdit.prototype._onKbnDialogOpen = function () {
        var kObj = this.kanbanObj, $dialogWrapper = kObj.element.find("#" + kObj._id + "_dialogEdit_wrapper");
        $dialogWrapper.css("position", "absolute");
        var top, left;
        var element = $(kObj.element)[0], elementTop, elementLeft, elementWidth, elementHeight;
        elementTop = element.offsetTop;
        elementLeft = element.offsetLeft;
        elementWidth = $(element).find('.e-kanbancontent')[0].offsetWidth;
        elementHeight = $(element).find('.e-kanbancontent')[0].offsetHeight + $(kObj.element).find('.e-kanbanheader')[0].offsetHeight;
        if (window.pageYOffset > elementTop) {
            if ((elementTop + elementHeight) > (window.pageYOffset + window.innerHeight))
                top = Math.max(0, ((window.innerHeight - $dialogWrapper.outerHeight()) / 2));
            else
                top = Math.max(0, (((elementTop + elementHeight - window.pageYOffset) - $dialogWrapper.outerHeight()) / 2));
            top = window.pageYOffset + top;
        }
        else {
            if ((elementTop + elementHeight) > (window.pageYOffset + window.innerHeight))
                top = Math.max(0, (((window.innerHeight - (elementTop - window.pageYOffset)) - $dialogWrapper.outerHeight()) / 2));
            else
                top = Math.max(0, ((elementHeight - $dialogWrapper.outerHeight()) / 2));
            top = elementTop + top;
        }
        if (window.pageXOffset > elementLeft) {
            if ((elementLeft + elementWidth) > (window.pageXOffset + window.innerWidth))
                left = Math.max(0, ((window.innerWidth - $dialogWrapper.outerWidth()) / 2));
            else
                left = Math.max(0, ((((elementLeft + elementWidth) - window.pageXOffset) - $dialogWrapper.outerWidth()) / 2));
            left = window.pageXOffset + left;
        }
        else {
            if ((elementLeft + elementWidth) > (window.pageXOffset + window.innerWidth))
                left = Math.max(0, (((window.innerWidth - (elementLeft - window.pageXOffset)) - $dialogWrapper.outerWidth()) / 2));
            else
                left = Math.max(0, ((elementWidth - $dialogWrapper.outerWidth()) / 2));
            left = elementLeft + left;
        }
        $dialogWrapper.css("top", top + "px");
        $dialogWrapper.css("left", left + "px");
        $dialogWrapper.show();
        this._formFocus();
        if (kObj._editForm.find('.e-rte').length > 0)
            kObj.element.find("#" + kObj._id + "_dialogEdit").data("ejDialog")._resetScroller();
        if (kObj.model.isResponsive && kObj.element.hasClass('e-responsive')) {
            kObj._on($('.e-kanban-editdiv'), ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._kbnAdaptEditClickHandler);
            kObj.KanbanAdaptive._setAdaptEditWindowHeight();
            if ($dialogWrapper.parents('.e-kanban').length > 0) {
                $dialogWrapper.appendTo("body");
            }
        }
        else {
            var kbnDialog, scroller, title;
            if ($(window).scrollTop() + $(window).height() < ($dialogWrapper.height() + top)) {
                kbnDialog = $('#' + kObj._id + "_dialogEdit"), scroller = kbnDialog.parents('.e-dialog-scroller'), title;
                title = scroller.prev('.e-titlebar');
                scroller.ejScroller({ height: $(window).height() - (title.height() + kObj.element.find('.e-kanbandialog').offset().top) });
                scroller.data('ejScroller').refresh();
                kbnDialog.css('height', scroller.height());
            }
        }
    };
    InternalEdit.prototype._externalFormPosition = function () {
        var kObj = this.kanbanObj;
        var pos = $(kObj.element).offset();
        var width = $(kObj.element).width();
        var height = $(kObj.element).height();
        var DivElement = $("#" + kObj._id + "_externalEdit");
        switch (kObj.model.editSettings.formPosition) {
            case "right":
                $(DivElement).find('.e-close').removeClass('e-bottomleft').addClass('e-topright');
                $("#" + kObj._id + "_eFormContent").height('auto');
                if (!kObj.model.allowScrolling && !kObj.model.isResponsive) {
                    $(kObj.element).css({ "width": "100%" });
                    $(kObj.element).children().not(".e-form-container").css("width", "73%");
                    $(DivElement).css({ "left": (pos.left + $(kObj.element).children().width() + 2) + "px", "top": pos.top + "px", "position": "absolute", "width": "25%" });
                }
                else {
                    $(DivElement).css({ "left": (pos.left + (width) + 2) + "px", "top": pos.top + "px", "position": "absolute", "width": "25%" });
                    $(".e-externalrow").css("padding-right", "0px");
                }
                break;
            case "bottom":
                $(DivElement).find('.e-close').removeClass('e-topright').addClass('e-bottomleft');
                $(DivElement).css({ "left": (pos.left) + "px", "top": (pos.top + height + 1) + "px" });
                $("#" + kObj._id + "_eFormContent").width("100%");
                if (kObj.element.find(".e-scrollbar").hasClass("e-hscrollbar") || kObj.model.isResponsive)
                    $("#" + kObj._id + "_externalEdit").css({ "border": "none", "border-top": "1px solid" });
                break;
        }
    };
    InternalEdit.prototype._formFocus = function () {
        var formElement = $(this.kanbanObj._editForm).find("input,select,div.e-field,textarea.e-field"), elementFocused = false;
        for (var i = 0; i < formElement.length; i++) {
            var ele = formElement.eq(i);
            if (!ele.is(":disabled") && !elementFocused && (!ele.is(":hidden") || typeof (ele.data("ejDropDownList") || ele.data("ejNumericTextbox")) == "object") || ele.hasClass('e-rte')) {
                this._focusKbnDialogEle(ele);
                elementFocused = true;
            }
        }
    };
    InternalEdit.prototype._focusKbnDialogEle = function (ele) {
        if (ele.length) {
            if ((ele[0].tagName.toLowerCase() == "select" && !ele.hasClass("e-field e-dropdownlist")) || (ele[0].tagName.toLowerCase() == "input") || (ele[0].tagName.toLowerCase() == "textarea") && !ele.hasClass("e-numerictextbox")) {
                if (ele.hasClass('e-rte')) {
                    var rte = ele.data('ejRTE');
                    $(rte).focus();
                    rte.selectAll();
                }
                else {
                    ele.focus().select();
                    ele[0].focus();
                }
            }
            else if (ele.hasClass("e-field e-dropdownlist"))
                ele.closest(".e-ddl").focus();
            else if (ele.hasClass('e-numerictextbox'))
                ele.siblings('input:visible').first().select().focus();
            else
                ele.find('input:visible,select').first().select().focus();
        }
    };
    InternalEdit.prototype.endEdit = function () {
        var kObj = this.kanbanObj;
        if (kObj.model.editSettings.allowEditing || kObj.model.editSettings.allowAdding) {
            var pKey = kObj.model.fields.primaryKey;
            if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate")
                var $edit = $('#' + kObj._id + "_dialogEdit");
            else
                $edit = kObj.element.find('.e-externalform');
            var formElement, $formElement, editedRowWrap, cardId, obj = {};
            if (!this.editFormValidate())
                return true;
            formElement = document.getElementById(kObj._id + "EditForm");
            $formElement = $(formElement);
            editedRowWrap = $formElement.closest('div');
            if (!ej.isNullOrUndefined($edit.attr('data-id'))) {
                cardId = $edit.attr('data-id');
                if ($.type(kObj._currentJsonData[0][pKey]) == "number")
                    cardId = parseInt(cardId);
            }
            else {
                cardId = kObj._currentJsonData[kObj._currentJsonData.length - 1][pKey];
                if ($.type(kObj._currentJsonData[0][pKey]) == "string")
                    cardId = parseInt(cardId);
                cardId = cardId + 1;
                if ($.type(kObj._currentJsonData[0][pKey]) == "string")
                    cardId = cardId.toString();
                obj[pKey] = cardId;
            }
            for (var index = 0; index < formElement.length; index++) {
                if (editedRowWrap.hasClass("e-addedrow") && $(formElement[index]).hasClass("e-identity"))
                    continue;
                var columnName = formElement[index].name, $element = $(formElement[index]);
                if ((($element.hasClass("e-dropdownlist") || $element.hasClass("e-input")) && (ej.isNullOrUndefined($element.attr("id")) || $element.attr("id").indexOf("_input") != -1 || $element.attr("id").indexOf("_hidden") != -1))) {
                    if (!ej.isNullOrUndefined($formElement[1]) && ej.isNullOrUndefined(formElement[index + 1])) {
                        formElement = $formElement[1];
                        index = -1;
                    }
                    continue;
                }
                if (columnName != undefined) {
                    if (columnName == "") {
                        if (formElement[index].id.indexOf("Save") != -1 || formElement[index].id.indexOf("Cancel") != -1)
                            columnName = "";
                        else {
                            columnName = formElement[index].id.replace(kObj._id + "_", "");
                            columnName = columnName.replace("_hidden", "");
                        }
                    }
                    if (columnName != "" && obj[columnName] == null) {
                        var value = formElement[index].value;
                        if ($(formElement[index]).hasClass("e-datepicker")) {
                            value = $element.ejDatePicker("model.value");
                        }
                        else if ($(formElement[index]).hasClass("e-datetimepicker")) {
                            value = $element.ejDateTimePicker("model.value");
                        }
                        else if ($element.is(".e-numerictextbox")) {
                            value = $element.ejNumericTextbox("getValue");
                            if (!ej.isNullOrUndefined(value))
                                value = value.toString();
                        }
                        else if ($element.data("ejDropDownList")) {
                            value = $element.ejDropDownList("getSelectedValue");
                        }
                        var originalvalue;
                        if (formElement[index].type != "checkbox")
                            originalvalue = value;
                        else
                            originalvalue = $(formElement[index]).is(':checked');
                        obj[columnName] = originalvalue;
                    }
                    else if (columnName == pKey) {
                        obj[pKey] = formElement[index].value;
                    }
                }
            }
            kObj._editForm = $('#' + kObj._id + "EditForm");
            if (isNaN(obj[pKey]))
                obj[pKey] = cardId;
            else {
                if ($.type(kObj._currentJsonData[0][pKey]) == "number")
                    obj[pKey] = cardId = parseInt(obj[pKey]);
                else
                    obj[pKey] = cardId = obj[pKey];
            }
            var args = { data: obj, requestType: "save" };
            if (kObj._trigger("actionBegin", args))
                return true;
            if ($(kObj._editForm).hasClass('e-formdestroy'))
                kObj.refresh(true);
            else {
                if (!ej.isNullOrUndefined($edit.attr('data-id'))) {
                    args["action"] = "edit";
                    args["primaryKeyValue"] = cardId;
                    kObj._cModifiedData = obj;
                }
                else {
                    args["action"] = "add";
                    args["primaryKeyValue"] = cardId;
                    kObj._cAddedRecord = obj;
                }
            }
            args["primaryKey"] = pKey;
            kObj._saveArgs = args;
            kObj.updateCard(cardId, obj);
            if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate") {
                $edit.removeAttr('data-id');
                $("#" + kObj._id + "_dialogEdit").ejDialog("close");
            }
            else if (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate") {
                if (kObj.model.editSettings.formPosition == "right")
                    $(kObj.element).children().css("width", "100%");
                $edit.removeAttr('data-id');
                $("#" + kObj._id + "_externalEdit").css("display", "none");
            }
        }
        if (kObj.element.hasClass('e-responsive')) {
            kObj.kanbanWindowResize();
            if (kObj.element.find('.e-kbnadapt-editdlg').length == 0)
                $("#" + kObj._id + "_dialogEdit_wrapper").appendTo(kObj.element);
        }
    };
    InternalEdit.prototype.initValidator = function () {
        var kanbanObject = this.kanbanObj, elements = kanbanObject.element.find(".kanbanform");
        for (var i = 0; i < elements.length; i++) {
            elements.eq(i).validate({
                ignore: ".e-hide,:hidden",
                errorClass: 'e-field-validation-error',
                errorElement: 'div',
                wrapper: "div",
                errorPlacement: function (error, element) {
                    if (element.is(":hidden"))
                        element = element.siblings("input:visible");
                    var $td = element.closest("td"), $container = $(error).addClass("e-error"), $tail = ej.buildTag("div.e-errortail e-toparrow");
                    if (kanbanObject.model.editSettings.editMode != "dialog")
                        $td.find(".e-error").remove();
                    if (element.parent().hasClass("e-in-wrap"))
                        $container.insertAfter(element.closest(".e-widget"));
                    else
                        $container.insertAfter(element);
                    $container.prepend($tail);
                    if (kanbanObject.model.enableRTL)
                        kanbanObject.model.editSettings.editMode != "dialog" && $container.offset({ left: element.offset().left, top: element.offset().top + element.height() });
                    else
                        kanbanObject.model.editSettings.editMode != "dialog" && $container.offset({ left: element.offset().left, top: element.offset().top + element.height() });
                    $container.fadeIn("slow");
                },
            });
        }
    };
    InternalEdit.prototype.setValidation = function () {
        var kObj = this.kanbanObj;
        for (var i = 0; i < kObj.model.editSettings.editItems.length; i++) {
            if (!ej.isNullOrUndefined(kObj.model.editSettings.editItems[i].validationRules)) {
                this.setValidationToField(kObj.model.editSettings.editItems[i].field, kObj.model.editSettings.editItems[i].validationRules);
            }
        }
    };
    InternalEdit.prototype.setValidationToField = function (name, rules) {
        var fName = name, ele, message, kObj = this.kanbanObj;
        if (!ej.isNullOrUndefined(name))
            fName = fName.replace(/[^a-z0-9\s_]/gi, '');
        var form = $('#' + kObj._id + "EditForm");
        ele = form.find("#" + kObj._id + "_" + fName).length > 0 ? form.find("#" + kObj._id + "_" + fName) : form.find("#" + fName);
        !ele.attr("name") && ele.attr("name", name);
        ele.rules("add", rules);
        var validator = $('#' + kObj._id + "EditForm").validate();
        validator.settings.messages[name] = validator.settings.messages[name] || {};
        if (!ej.isNullOrUndefined(rules.required)) {
            if (!ej.isNullOrUndefined(rules.messages && rules.messages.required)) {
                message = rules.messages.required;
            }
            else {
                message = $["validator"].messages.required;
            }
            if (message.indexOf("This field") == 0)
                message = message.replace("This field", name);
            validator.settings.messages[name].required = message;
        }
    };
    InternalEdit.prototype.editFormValidate = function () {
        if ($.isFunction($["validator"])) {
            return $('#' + this.kanbanObj._id + "EditForm").validate().form();
        }
        return true;
    };
    InternalEdit.prototype._addDialogEditingTemplate = function () {
        var kObj = this.kanbanObj, $editDiv = ej.buildTag('div'), $form, $table, $tr, $labelTd, $valueTd, savebtn, cancelbtn, btnDiv, trElement, tdElement;
        if (kObj.model.columns.length == 0)
            return;
        $form = ej.buildTag('form.kanbanform', "", {}, { id: kObj._id + "EditForm" });
        $table = ej.buildTag('table', "", {}, { cellspacing: "14px" });
        if (ej.isNullOrUndefined(kObj.model.editSettings.editMode))
            kObj.model.editSettings.editMode = "dialog";
        if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "externalform") {
            for (var dataCount = 0; dataCount < kObj.model.editSettings.editItems.length; dataCount++) {
                var curItem = kObj.model.editSettings.editItems[dataCount], name = curItem.field;
                if (kObj.model.editSettings.editMode == "dialog") {
                    trElement = 'tr';
                    tdElement = 'td';
                }
                else {
                    trElement = 'div.e-externalrow';
                    tdElement = 'div';
                }
                $tr = ej.buildTag(trElement);
                $labelTd = ej.buildTag(tdElement, "", {}).addClass("e-label");
                $valueTd = ej.buildTag(tdElement, "", { "text-align": "left" }).addClass("e-rowcell");
                if (dataCount == kObj.model.editSettings.editItems.length - 1)
                    $valueTd.addClass("e-last-rowcell");
                $tr.append($labelTd.get(0)).append($valueTd.get(0));
                $labelTd.append("<label style='text-transform:capitalize' for='" + name + "'>" + name + "</label>");
                if (kObj.model.editSettings.editMode == "externalform" && kObj.model.editSettings.formPosition == "right")
                    $tr.css({ "width": "300px", "padding-right": "0px" });
                if (ej.isNullOrUndefined(curItem.editType))
                    curItem["editType"] = "stringedit";
                if (!ej.isNullOrUndefined(name))
                    name = name.replace(/[^a-z0-9\s_]/gi, '');
                switch (curItem.editType) {
                    case "stringedit":
                        if (kObj.model.fields.primaryKey == name)
                            $valueTd.html(ej.buildTag('input.e-field e-ejinputtext e-disable', "", {}, { value: "{{html:#data['" + name + "']}}", id: kObj._id + "_" + name, name: name, disabled: "disabled" }));
                        else
                            $valueTd.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{html:#data['" + name + "']}}", id: kObj._id + "_" + name, name: name }));
                        break;
                    case "numericedit":
                        $valueTd.html(ej.buildTag('input.e-numerictextbox e-field', "", {}, { type: "text", value: "{{:#data['" + name + "']}}", id: kObj._id + "_" + name, name: name }));
                        break;
                    case "dropdownedit":
                        var ddlItems = [], ddlTempl, $select, $option, data, uniqueData;
                        if (ej.isNullOrUndefined(curItem.dataSource)) {
                            var query = new ej.Query().where(ej.Predicate["or"](kObj.keyPredicates)).select(curItem.field);
                            if (ej.isNullOrUndefined(this._dropDownManager) || (!kObj._dataManager.dataSource.offline && kObj._dataManager.dataSource.json.length))
                                data = kObj._dataManager.executeLocal(query);
                            else {
                                if (kObj._dataManager.adaptor instanceof ej.JsonAdaptor && curItem.field.indexOf('.') != -1) {
                                    var field = curItem.field.replace(/\./g, ej["pvt"].consts.complexPropertyMerge);
                                    query = new ej.Query().select(field);
                                }
                                data = this._dropDownManager.executeLocal(query);
                            }
                            uniqueData = ej.dataUtil.mergeSort(ej.dataUtil.distinct(data));
                            for (var index = 0; index < uniqueData.length; index++)
                                ddlItems.push({ text: uniqueData[index], value: uniqueData[index] });
                        }
                        else
                            ddlItems = curItem.dataSource;
                        $select = ej.buildTag('select');
                        $option = ej.buildTag("option", "{{:text}}", {}, { value: "{{html:#data['value']}}" });
                        $select.append($option);
                        ddlTempl = $.templates($select.html());
                        if (!ej.isNullOrUndefined(curItem.editParams) && !ej.isNullOrUndefined(curItem.dataSource))
                            $valueTd.get(0).innerHTML = "<input>";
                        else
                            $valueTd.get(0).innerHTML = ["<select>", ddlTempl.render(ddlItems), "</select>"].join("");
                        $valueTd.find("select,input").prop({ id: kObj._id + "_" + name, name: name }).addClass("e-field e-dropdownlist");
                        break;
                    case "rteedit":
                        $valueTd.html(ej.buildTag('textarea.e-field e-rte', "{{html:#data['" + name + "']}}", {}, { id: kObj._id + "_" + name, name: name }));
                        break;
                    case "textarea":
                        $valueTd.html(ej.buildTag('textarea.e-field e-kanbantextarea e-ejinputtext', "{{html:#data['" + name + "']}}", {}, { id: kObj._id + "_" + name, name: name }));
                        break;
                    case "datepicker":
                    case "datetimepicker":
                        $valueTd.html(ej.buildTag('input.e-' + curItem.editType + ' e-field', "", {}, { type: "text", value: "{{:#data['" + name + "']}}", id: kObj._id + "_" + name, name: name }));
                        break;
                }
                if (kObj.model.editSettings.editMode == "dialog") {
                    $form.append($table);
                    $table.append($tr);
                }
                else
                    $form.append($tr);
                $form.appendTo($editDiv);
            }
        }
        else {
            var cloneElement;
            if (kObj.model.editSettings.editMode == "dialogtemplate" && kObj.model.editSettings.dialogTemplate != null)
                cloneElement = kObj.model.editSettings.dialogTemplate;
            if (kObj.model.editSettings.editMode == "externalformtemplate" && kObj.model.editSettings.externalFormTemplate != null)
                cloneElement = kObj.model.editSettings.externalFormTemplate;
            $form.html($(cloneElement).html());
            $form.appendTo($editDiv);
        }
        savebtn = ej.buildTag('input.e-save', "", {}, { type: "button", id: kObj._id + "_Save" });
        savebtn.ejButton({ text: kObj.localizedLabels.SaveButton });
        if (kObj.model.editSettings.formPosition != "right")
            cancelbtn = ej.buildTag('input.e-cancel', "", {}, { type: "button", id: kObj._id + "_Cancel" });
        else
            cancelbtn = ej.buildTag('input.e-cancel', "", {}, { type: "button", id: kObj._id + "_Cancel" });
        cancelbtn.ejButton({ text: kObj.localizedLabels.CancelButton });
        btnDiv = (kObj.model.editSettings.editMode != "dialog" && kObj.model.editSettings.editMode != "dialogtemplate") ? ej.buildTag('div', "", "", { 'class': "e-editform-btn" }) : ej.buildTag('div#' + kObj._id + "_EditBtnDiv", "", {}, { "class": "e-kanban-editdiv" });
        btnDiv.append(savebtn);
        btnDiv.append(cancelbtn);
        if (kObj.model.editSettings.editMode != "dialog" && kObj.model.editSettings.editMode != "dialogtemplate")
            btnDiv.appendTo($editDiv);
        else
            $form.append(btnDiv);
        $.templates(kObj._id + "_dialogEditingTemplate", $editDiv.html());
    };
    return InternalEdit;
}());
;
window.ej.createObject("ej.KanbanFeatures.Edit", InternalEdit, window);
;
var InternalContext = (function () {
    function InternalContext(element) {
        this.kanbanObj = null;
        this.kanbanObj = element;
    }
    ;
    InternalContext.prototype._renderContext = function () {
        var kObj = this.kanbanObj, menuitems, submenu, submenuitem, data, menuItem1, item, menu, i, j, k, l, custom, custom2, ul, disableitem, customitems, subMenuItems, subul;
        menuitems = kObj.model.contextMenuSettings.menuItems;
        ul = ej.buildTag('ul', "", {}, { id: kObj._id + '_Context' });
        disableitem = kObj.model.contextMenuSettings.disableDefaultItems;
        for (var m = 0; m < menuitems.length; m++) {
            if (menuitems[m] == "" || menuitems[m] == " ")
                menuitems.splice(m, 1);
        }
        for (i = 0; i < menuitems.length; i++) {
            item = menuitems[i];
            if ($.inArray(item, disableitem) == -1)
                menu = this._items(item, "menuItem");
            ul.append(menu);
        }
        customitems = kObj.model.contextMenuSettings.customMenuItems;
        for (j = 0; j < customitems.length; j++) {
            custom = customitems[j].text;
            custom2 = this._items(custom, "custom");
            if (customitems[j].template)
                custom2.append($(customitems[j].template));
            ul.append(custom2);
        }
        subul = ej.buildTag('ul', "", {}, { id: kObj._id + '_SubContext' });
        for (i = 0; i < kObj.model.columns.length; i++) {
            item = kObj.model.columns[i].headerText;
            submenuitem = ej.buildTag('input', "", {}, { type: "checkbox", name: item });
            menu = this._items(item, "subMenuItem");
            menu.find("span").append(submenuitem);
            menu.find("span").addClass("e-checkbox e-visiblecolumns");
            subul.append(menu);
            submenuitem.ejCheckBox({
                checked: kObj.model.columns[i].visible,
            });
        }
        $(ul).find("li.e-column.e-visiblecolumn").append(subul);
        if (kObj.model.fields.swimlaneKey) {
            subul = ej.buildTag('ul', "", {}, { id: kObj._id + '_SubContext' });
            var query = new ej.Query().select([kObj.model.fields.swimlaneKey]);
            if (kObj._dataManager.dataSource.offline)
                data = kObj._dataManager.executeLocal(query);
            else
                data = kObj._contextSwimlane.executeLocal(query);
            data = ej.dataUtil.mergeSort(ej.dataUtil.distinct(data));
            for (i = 0; i < data.length; i++) {
                item = data[i];
                menu = this._items(item, "subMenuItem");
                subul.append(menu);
            }
            $(ul).find("li.e-move.e-swimlane").append(subul);
        }
        $(ul).ejMenu({
            menuType: ej.MenuType.ContextMenu,
            openOnClick: false,
            contextMenuTarget: "#" + kObj._id,
            click: $.proxy(kObj._clickevent, kObj),
            width: "auto",
            cssClass: "e-kanban-context",
            beforeOpen: $.proxy(kObj._menu, kObj),
            open: $.proxy(this._contextopen, kObj)
        });
        kObj._conmenu = ul.data("ejMenu");
    };
    InternalContext.prototype._contextopen = function () {
        var context = this["_conmenu"].element;
        if (context.length > 0) {
            if (!context.find("li").is(":visible")) {
                context.css("visibility", "hidden");
            }
        }
    };
    InternalContext.prototype._kanbanContextClick = function (sender, kObj) {
        var args, c, card, cardlen;
        if (sender.parentText != null)
            args = sender.parentText;
        else
            args = sender.events.text;
        c = $(kObj._contexttarget);
        sender.targetelement = kObj._contexttarget;
        card = c.closest(".e-kanbancard");
        cardlen = card.length;
        if (card.length > 0) {
            sender.card = card;
            sender.index = card.parent('.e-rowcell').find('.e-kanbancard').index(card);
            sender.cellIndex = card.parent('.e-rowcell').index();
            sender.rowIndex = kObj.getIndexByRow(card.parents('.e-columnrow'));
            sender.cardData = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, card.attr('id'))[0];
        }
        if (kObj._trigger("contextClick", sender))
            return;
        switch (args) {
            case kObj.localizedLabels.AddCard:
                kObj._isAddNewClick = true;
                kObj._newCard = $(kObj._contexttarget);
                if (kObj.KanbanEdit)
                    kObj.KanbanEdit.addCard();
                break;
            case kObj.localizedLabels.EditCard:
                if (cardlen > 0 && !ej.isNullOrUndefined(kObj.model.fields.primaryKey) && kObj.KanbanEdit)
                    kObj.KanbanEdit.startEdit(card);
                break;
            case kObj.localizedLabels.HideColumn:
                if (c.closest(".e-headercell").find(".e-headercelldiv").length > 0)
                    kObj.hideColumns($.trim(c.closest(".e-headercell").find(".e-headercelldiv .e-headerdiv").text()).split("[")[0]);
                break;
            case kObj.localizedLabels.DeleteCard:
                if (!ej.isNullOrUndefined(kObj.model.fields.primaryKey) && card.length > 0 && kObj.KanbanEdit) {
                    kObj.KanbanEdit.deleteCard(card.attr("id"));
                    kObj.KanbanCommon._showhide(kObj._hiddenColumns, "hide");
                    if (kObj.model.enableTotalCount)
                        kObj.KanbanCommon._totalCount();
                }
                break;
            case kObj.localizedLabels.MoveRight:
                if (cardlen > 0 && kObj.KanbanDragAndDrop) {
                    kObj._bulkUpdateData = [];
                    kObj.KanbanDragAndDrop._dropToColumn($(kObj._contexttarget).closest("td.e-rowcell").next(), card);
                    if (kObj.model.enableTotalCount)
                        kObj.KanbanCommon._totalCount();
                }
                break;
            case kObj.localizedLabels.MoveLeft:
                if (cardlen > 0 && kObj.KanbanDragAndDrop) {
                    kObj._bulkUpdateData = [];
                    kObj.KanbanDragAndDrop._dropToColumn($(kObj._contexttarget).closest("td.e-rowcell").prev(), card);
                    if (kObj.model.enableTotalCount)
                        kObj.KanbanCommon._totalCount();
                }
                break;
            case kObj.localizedLabels.MoveUp:
                if (cardlen > 0 && kObj.KanbanDragAndDrop) {
                    kObj._bulkUpdateData = [];
                    kObj.KanbanDragAndDrop._dropAsSibling(card.prev(), card, false);
                }
                break;
            case kObj.localizedLabels.MoveDown:
                if (cardlen > 0 && kObj.KanbanDragAndDrop) {
                    kObj._bulkUpdateData = [];
                    kObj.KanbanDragAndDrop._dropAsSibling(card.next(), card, true);
                }
                break;
            case kObj.localizedLabels.TopofRow:
                if (cardlen > 0 && kObj.KanbanDragAndDrop) {
                    kObj._bulkUpdateData = [];
                    kObj.KanbanDragAndDrop._dropAsSibling(c.closest("td.e-rowcell").find(".e-kanbancard").first(), card, false);
                }
                break;
            case kObj.localizedLabels.BottomofRow:
                if (cardlen > 0 && kObj.KanbanDragAndDrop) {
                    kObj._bulkUpdateData = [];
                    kObj.KanbanDragAndDrop._dropAsSibling(c.closest("td.e-rowcell").find(".e-kanbancard").last(), card, true);
                }
                break;
            case kObj.localizedLabels.MovetoSwimlane:
                if (args != sender.text && cardlen > 0) {
                    var id = c.closest(".e-kanbancard").attr("id");
                    var data = new ej.DataManager(kObj._currentJsonData).executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, id))[0];
                    data[kObj.model.fields.swimlaneKey] = sender.text;
                    var args = { data: data, requestType: "save", primaryKeyValue: data[kObj.model.fields.primaryKey] };
                    kObj._saveArgs = args;
                    kObj.updateCard(id, data);
                    kObj.KanbanCommon._showhide(kObj._hiddenColumns, "hide");
                    if (kObj._dataManager.dataSource.offline)
                        kObj._saveArgs = null;
                }
                break;
            case kObj.localizedLabels.PrintCard:
                if (cardlen > 0)
                    kObj.print(card);
                break;
            case kObj.localizedLabels.VisibleColumns:
                if (args != sender.text) {
                    var index = $(sender.element.parentElement).find("li").index(sender.element);
                    if (kObj.model.columns[index].visible) {
                        kObj.hideColumns(sender.text);
                        $($(sender.element).find("input.e-checkbox")).ejCheckBox({ "checked": false });
                    }
                    else {
                        kObj.showColumns(sender.text);
                        $($(sender.element).find("input.e-checkbox")).ejCheckBox({ "checked": true });
                    }
                }
                break;
        }
        if (kObj.model.isResponsive)
            kObj.kanbanWindowResize();
        if (kObj.model.allowScrolling && !kObj.element.hasClass("e-responsive"))
            kObj.kanbanContent.data('ejScroller').refresh();
        if (kObj.element.hasClass('e-responsive') && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj._kbnAdaptDdlIndex > 0) {
            var scroller = kObj.kanbanContent.data('ejScroller'), rows, sTop = kObj._freezeScrollTop;
            ;
            rows = kObj.element[0].getElementsByClassName('e-columnrow');
            scroller.scrollY(0, true);
            kObj._freezeScrollTop = sTop;
            scroller.scrollY(kObj._freezeScrollTop, true);
        }
    };
    InternalContext.prototype._kanbanMenu = function (sender, kObj) {
        var context, targetelement, td, tr, rowCell, card, contextmenu, custommenuitems, customitems, i, j, count, index, menuItems;
        context = kObj._conmenu.element;
        kObj._contexttarget = sender.target;
        targetelement = $(sender.target);
        td = $(kObj._contexttarget).closest("td.e-rowcell");
        tr = $(kObj._contexttarget).closest("tr.e-columnrow");
        rowCell = targetelement.closest(".e-rowcell");
        card = $(targetelement).closest(".e-kanbancard");
        var cardData = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, card.attr('id'))[0];
        contextmenu = kObj.model.contextMenuSettings.menuItems;
        context.css("visibility", "visible");
        context.find("li").hide();
        if (targetelement.closest(".e-kanban").attr("id") !== kObj._id) {
            context.css("visibility", "hidden");
            return;
        }
        if (context.find(".e-customitem").length > 0) {
            custommenuitems = kObj.model.contextMenuSettings.customMenuItems;
            customitems = context.find(".e-customitem");
            for (j = 0; j < customitems.length; j++) {
                if (!custommenuitems[j].target)
                    custommenuitems[j].target = "all";
                if (custommenuitems[j].target && custommenuitems[j].text == context.find(".e-customitem").children("a").eq(j).text())
                    switch (custommenuitems[j].target) {
                        case "content":
                            if (kObj.getContentTable().find(targetelement).length > 0) {
                                $(customitems[j]).show();
                                if ($(customitems[j]).find("li").length > 0)
                                    $(customitems[j]).find("li").show();
                            }
                            else
                                $(customitems[j]).hide();
                            break;
                        case "header":
                            if (kObj.getHeaderContent().find(targetelement).length > 0) {
                                $(customitems[j]).show();
                                if ($(customitems[j]).find("li").length > 0)
                                    $(customitems[j]).find("li").show();
                            }
                            else
                                $(customitems[j]).hide();
                            break;
                        case "card":
                            if (kObj.element.find(".e-kanbancard").find(targetelement).length > 0) {
                                $(customitems[j]).show();
                                if ($(customitems[j]).find("li").length > 0)
                                    $(customitems[j]).find("li").show();
                            }
                            else
                                $(customitems[j]).hide();
                            break;
                        case "all":
                            $(customitems[j]).show();
                            if ($(customitems[j]).find("li").length > 0)
                                $(customitems[j]).find("li").show();
                            break;
                    }
            }
        }
        if (kObj.getContentTable().find(targetelement).length > 0) {
            if (rowCell.length == 0 || targetelement.filter(".e-targetclone,.e-targetdragclone").length > 0) {
                context.css("visibility", "hidden");
                return;
            }
            else if ($(targetelement).closest(".e-swimlanerow").length > 0) {
                context.css("visibility", "hidden");
                return;
            }
            else if (card.length > 0) {
                var closecard = $(targetelement).closest("td.e-rowcell").find(".e-kanbancard");
                index = closecard.index(card);
                count = closecard.length;
                $(context.find("li").not(".e-customitem")).hide();
                $(context.find(".e-customitem li")).show();
                if (!ej.isNullOrUndefined(kObj.model.fields.primaryKey) && kObj.model.editSettings.allowEditing)
                    context.find(".e-content.e-cardedit").show();
                if (td.hasClass("e-drag")) {
                    if (index > 1)
                        context.find(".e-move.e-up").show();
                    if (index != count - 1 && td.hasClass("e-drop"))
                        context.find(".e-row.e-bottom").show();
                    if (index != 0 && td.hasClass("e-drop"))
                        context.find(".e-row.e-top").show();
                    if (((count - 1) - index) > 1)
                        context.find(".e-move.e-down").show();
                    if (td.next().length > 0 && td.next().hasClass("e-drop") && !kObj._checkMultikey(td.next()) && kObj.KanbanCommon._preventCardMove(cardData[kObj.model.keyField], kObj.model.columns[td.next().index()]["key"]))
                        context.find(".e-move.e-right").show();
                    if (td.prev().length > 0 && td.prev().hasClass("e-drop") && !kObj._checkMultikey(td.prev()) && kObj.KanbanCommon._preventCardMove(cardData[kObj.model.keyField], kObj.model.columns[td.prev().index()]["key"]))
                        context.find(".e-move.e-left").show();
                    if (kObj.model.fields.swimlaneKey && kObj.model.fields.primaryKey && context.find(".e-move.e-swimlane").length > 0) {
                        context.find(".e-move.e-swimlane").show();
                        context.find(".e-move.e-swimlane").find("li").show();
                        context.find(".e-move.e-swimlane").find("li").eq(kObj._columnRows.index(tr)).hide();
                    }
                }
                if (!ej.isNullOrUndefined(kObj.model.fields.primaryKey))
                    context.find(".e-content.delete").show();
                if (kObj.model.allowPrinting)
                    context.find(".e-print").show();
            }
            else if (rowCell.length > 0) {
                $(context.find("li").not(".e-customitem")).hide();
                $(context.find(".e-customitem li")).show();
                if (kObj.model.editSettings.allowAdding)
                    context.find(".e-add").show();
            }
        }
        else if (kObj.getHeaderContent().find(targetelement).length > 0) {
            var concolumnmenu = context.find(".e-column");
            if ($(targetelement).closest(".e-headercell").not(".e-stackedHeaderCell").length > 0) {
                $(context.find("li").not(".e-customitem")).hide();
                $(context.find(".e-customitem li")).show();
                $(context.find("li.e-haschild").find("li")).show();
                concolumnmenu.show();
                for (i = 0; i < context.find(".e-column.e-visiblecolumn").find("li").length; i++) {
                    if (kObj.element.find(".e-headercell").not(".e-stackedHeaderCell").eq(i).hasClass("e-hide"))
                        concolumnmenu.find("li input.e-checkbox").eq(i).ejCheckBox({ checked: false });
                    else
                        concolumnmenu.find("li input.e-checkbox").eq(i).ejCheckBox({ checked: true });
                }
                concolumnmenu.find("li").show();
            }
            else {
                context.css("visibility", "hidden");
                return;
            }
        }
        else {
            context.css("visibility", "hidden");
            return;
        }
        if (kObj.model.contextOpen) {
            sender.card = card;
            sender.index = card.parent('.e-rowcell').find('.e-kanbancard').index(card);
            sender.cellIndex = card.parent('.e-rowcell').index();
            sender.rowIndex = kObj.getIndexByRow(card.parents('.e-columnrow'));
            sender.cardData = kObj.KanbanCommon._getKanbanCardData(kObj._currentJsonData, card.attr('id'))[0];
            kObj._trigger("contextOpen", sender);
        }
    };
    InternalContext.prototype._items = function (item, type) {
        if (item == "" || ej.isNullOrUndefined(item))
            return false;
        var li, localization;
        if (type == "menuItem") {
            if (item.indexOf("Card") != -1) {
                li = ej.buildTag('li', "", {}, { "class": "e-content" });
                li.css("display", "none");
                if (item.indexOf("Add") != -1) {
                    li.addClass("e-add");
                    localization = this.kanbanObj.localizedLabels.AddCard;
                }
                if (item.indexOf("Edit") != -1) {
                    li.addClass("e-cardedit");
                    localization = this.kanbanObj.localizedLabels.EditCard;
                }
                if (item.indexOf("Delete") != -1) {
                    li.addClass("delete");
                    localization = this.kanbanObj.localizedLabels.DeleteCard;
                }
                if (item.indexOf("Print") != -1) {
                    li.addClass("e-print");
                    localization = this.kanbanObj.localizedLabels.PrintCard;
                }
                li.css("display", "none");
            }
            else if (item.indexOf("Column") != -1 || item.indexOf("Columns") != -1) {
                li = ej.buildTag('li', "", {}, { "class": "e-column" });
                if (item.indexOf("Hide") != -1) {
                    li.addClass("e-hidecolumn");
                    localization = this.kanbanObj.localizedLabels.HideColumn;
                }
                if (item.indexOf("Visible") != -1) {
                    li.addClass("e-visiblecolumn");
                    localization = this.kanbanObj.localizedLabels.VisibleColumns;
                }
                li.css("display", "none");
            }
            else if (item.indexOf("Row") != -1) {
                li = ej.buildTag('li', "", {}, { "class": "e-row" });
                if (item.indexOf("Top") != -1) {
                    li.addClass("e-top");
                    localization = this.kanbanObj.localizedLabels.TopofRow;
                }
                else {
                    li.addClass("e-bottom");
                    localization = this.kanbanObj.localizedLabels.BottomofRow;
                }
                li.css("display", "none");
            }
            else if (item.indexOf("Move") != -1) {
                li = ej.buildTag('li', "", {}, { "class": "e-move" });
                if (item.indexOf("Left") != -1) {
                    li.addClass("e-left");
                    localization = this.kanbanObj.localizedLabels.MoveLeft;
                }
                else if (item.indexOf("Right") != -1) {
                    li.addClass("e-right");
                    localization = this.kanbanObj.localizedLabels.MoveRight;
                }
                else if (item.indexOf("Up") != -1) {
                    li.addClass("e-up");
                    localization = this.kanbanObj.localizedLabels.MoveUp;
                }
                else if (item.indexOf("Down") != -1) {
                    li.addClass("e-down");
                    localization = this.kanbanObj.localizedLabels.MoveDown;
                }
                else if (item.indexOf("Swimlane") != -1) {
                    li.addClass("e-swimlane");
                    localization = this.kanbanObj.localizedLabels.MovetoSwimlane;
                }
                li.css("display", "none");
            }
        }
        else if (type == "subMenuItem") {
            li = ej.buildTag('li', "", {}, {});
        }
        else if (type == "custom") {
            li = ej.buildTag('li', "", {}, { "class": "e-customitem" });
            li.css("display", "block");
        }
        var a = document.createElement("a"), classElement = "";
        if (typeof item == "string") {
            if (item.indexOf("Move to") != -1)
                classElement = item.split(" ")[2].toLowerCase();
            else if (item.indexOf("Move") != -1)
                classElement = item.split(" ")[1].toLowerCase();
            else
                classElement = item.split(" ")[0].toLowerCase();
        }
        else
            classElement = item;
        if (ej.isNullOrUndefined(localization))
            a.innerHTML = item;
        else
            a.innerHTML = localization;
        $(a).append(ej.buildTag('span', "", {}, { "class": "e-kanbancontext e-icon e-context" + classElement }));
        li.append(a);
        return li;
    };
    InternalContext.prototype._kbnBrowserContextMenu = function (e) {
        if (this["_kbnBrowserContext"] == "contextmenu" && this["model"].enableTouch)
            e.preventDefault();
        this["_kbnBrowserContext"] = "null";
    };
    return InternalContext;
}());
window.ej.createObject("ej.KanbanFeatures.Context", InternalContext, window);
;
var InternalSwimlane = (function () {
    function InternalSwimlane(element) {
        this.kanbanObj = null;
        this._removeFreezeRow = function (kObj) {
            var kObj = this.kanbanObj;
            if ((!kObj.model.scrollSettings.allowFreezeSwimlane && !$.isEmptyObject(kObj._freezeSwimlaneRow)) || (kObj.element.hasClass('e-responsive') && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj.model.scrollSettings.allowFreezeSwimlane)) {
                this._removeFreezeslRow();
            }
        };
        this._removeFreezeslRow = function (kObj) {
            var kObj = this.kanbanObj;
            kObj._freezeSwimlaneRow.remove();
            kObj.headerContent.css({ 'position': '', 'top': '' });
            kObj.kanbanContent.css({ 'position': '', 'top': '' });
            var toolbar = kObj.element.find('.e-kanbantoolbar');
            if (toolbar.length > 0)
                toolbar.css({ 'position': '', 'top': '' });
        };
        this.kanbanObj = element;
    }
    ;
    InternalSwimlane.prototype.expandAll = function () {
        var slDivs = this.kanbanObj.element.find(".e-swimlanerow .e-slcollapse");
        if (slDivs.length != 0) {
            for (var i = 0; i < slDivs.length; i++)
                this.toggle($(slDivs[i]));
        }
    };
    InternalSwimlane.prototype.collapseAll = function () {
        var slDivs = this.kanbanObj.element.find(".e-swimlanerow .e-slexpand");
        if (slDivs.length != 0) {
            for (var i = 0; i < slDivs.length; i++)
                this.toggle($(slDivs[i]));
        }
    };
    InternalSwimlane.prototype.toggle = function ($target) {
        var name, $curRow, kObj = this.kanbanObj;
        if (typeof $target == "string" || typeof $target == "number") {
            name = kObj.KanbanCommon._removeIdSymbols($target);
            $curRow = kObj.element.find('tr[id="' + name + '"]');
            this._toggleSwimlaneRow($($curRow).find(".e-rowcell .e-slexpandcollapse"));
        }
        else if (typeof $target == "object" && $target[0].nodeName != "DIV") {
            for (var i = 0; i < $target.length; i++) {
                name = kObj.KanbanCommon._removeIdSymbols($target[i]);
                $curRow = kObj.element.find('tr[id="' + name + '"]');
                this._toggleSwimlaneRow($($curRow).find(".e-rowcell .e-slexpandcollapse"));
            }
        }
        else
            this._toggleSwimlaneRow($target);
    };
    InternalSwimlane.prototype._toggleSwimlaneRow = function ($target) {
        var kObj = this.kanbanObj, args, idx = kObj._swimlaneRows.index($target.parents('.e-swimlanerow')), action;
        var curData = kObj.currentViewData[idx], id = $target.parent().next(".e-slkey").html();
        $target = $target.hasClass("e-slexpandcollapse") ? $target.find("div:first") : $target;
        if (!($target.hasClass("e-slexpand") || $target.hasClass("e-slcollapse")))
            return;
        var cRow = $target.closest('tr');
        cRow.next(".e-collapsedrow").remove();
        var $row = cRow.next();
        var swim = kObj.KanbanCommon._removeIdSymbols($target.parent().next(".e-slkey").html());
        action = $target.hasClass("e-slexpand") ? "collapse" : "expand";
        args = { target: $target, swimlaneRow: cRow, data: curData.items, cards: $row.find('.e-kanbancard'), id: id, key: curData.key, rowIndex: idx, action: action };
        kObj._trigger("swimlaneClick", args);
        if (args.cancel)
            return false;
        if ($target.hasClass("e-slexpand")) {
            $row.hide();
            var dRow = ej.buildTag('tr', "", {}, { "class": "e-collapsedrow" }), cols = kObj.model.columns, td;
            for (var i = 0; i < cols.length; i++) {
                td = ej.buildTag('td', "", {}, { "class": "e-rowcell", "role": "kanbancell" });
                if (!cols[i].visible)
                    td.addClass("e-hide");
                if (cols[i].isCollapsed)
                    td.addClass("e-shrink");
                dRow.append(td);
            }
            $row.before(dRow);
            $target.removeClass("e-slexpand").addClass("e-slcollapse");
            if ($.inArray(swim, kObj._collapsedSwimlane) == -1)
                kObj._collapsedSwimlane.push(swim);
        }
        else {
            $row.show();
            $target.removeClass("e-collapsedrow").removeClass("e-slcollapse").addClass("e-slexpand");
            var index = $.inArray(swim, kObj._collapsedSwimlane);
            if (index != -1)
                kObj._collapsedSwimlane.splice(index, 1);
        }
        if (kObj.model.allowScrolling) {
            var vScrollArea = kObj.headerContent.find('.e-hscrollcss');
            kObj.KanbanScroll._refreshScroller({ requestType: "refresh" });
            if (kObj.getContent().find('.e-vscrollbar').length > 0)
                vScrollArea.removeClass('e-vscroll-area');
            else
                vScrollArea.addClass('e-vscroll-area');
        }
    };
    InternalSwimlane.prototype._freezeRow = function (e, kObj) {
        var slKey = kObj.model.fields.swimlaneKey, toolbar = kObj.element.find('.e-kanbantoolbar');
        kObj._freezeSwimlaneRow = kObj.element.find('.e-freezeswimlanerow');
        this._removeFreezeRow();
        if (kObj.element.hasClass('e-responsive') && ej.isNullOrUndefined(slKey) || (!kObj.element.hasClass('e-responsive') && (!kObj.model.scrollSettings.allowFreezeSwimlane || ej.isNullOrUndefined(slKey) || (!ej.isNullOrUndefined(e.scrollLeft) && kObj._freezeSwimlaneRow.length == 0))))
            return;
        var top, firstSl, table, tbody, tds;
        if (kObj._freezeSwimlaneRow.length <= 0 && kObj.model.scrollSettings.allowFreezeSwimlane && !kObj.element.hasClass('e-responsive')) {
            kObj._freezeSwimlaneRow = ej.buildTag('div.e-freezeswimlanerow e-swimlanerow', "<div></div>", {}, {});
            top = (kObj.headerContent.offset().top + kObj.headerContent.height()) - (kObj.element.offset().top + 1);
            var height = kObj.element.height();
            kObj._freezeSwimlaneRow.prependTo(kObj.element).css({ 'top': top });
            top = kObj._freezeSwimlaneRow.height();
            kObj.headerContent.css({ 'position': 'relative', 'top': -top });
            kObj.kanbanContent.css({ 'position': 'relative', 'top': -top });
            if (toolbar.length > 0)
                toolbar.css({ 'position': 'relative', 'top': -top });
            kObj.element.height(height);
            firstSl = kObj._swimlaneRows.eq(0);
            kObj._freezeSwimlaneRow.children().append(firstSl.find('.e-slkey,.e-slcount').clone());
            kObj._freezeSwimlaneRow.width(kObj.headerContent.width() - 1).height(firstSl.height());
            kObj._freezeSlOrder = 0;
            table = ej.buildTag('table.e-table e-freeze-table', "", {}, { cellspacing: "0.25px" });
            table.append(kObj.getContentTable().find('colgroup').clone());
            tbody = ej.buildTag("tbody", "", {}, {});
            table.append(tbody);
            tbody.append(kObj.getContentTable().find('.e-columnrow').eq(0).clone().removeClass('e-columnrow').addClass('e-collapsedrow'));
            tds = tbody.find('td');
            tds.removeClass('e-droppable').removeAttr('ej-mappingkey').height(0);
            tds.children().remove();
            kObj._freezeSwimlaneRow.append(table);
        }
        else if (kObj._freezeSwimlaneRow.length > 0 || (!ej.isNullOrUndefined(slKey) && kObj.element.hasClass('e-responsive'))) {
            var freezeSlHeight, curHeight, nextSlHeight = 0, curSlHeight = 0, prevSlHeight = 0, rows, slText = kObj.element.find('.e-swimlane-text');
            var nextSl, curSl, prevSl, freezeSlDiv;
            if (!ej.isNullOrUndefined(slKey) && kObj.element.hasClass('e-responsive')) {
                rows = kObj.element.find('.e-columnrow');
                freezeSlHeight = kObj.getContent().offset().top;
                curSl = rows.eq(kObj._freezeSlOrder);
                nextSl = rows.eq(kObj._freezeSlOrder + 1);
                prevSl = rows.eq(kObj._freezeSlOrder - 1);
                if (nextSl.length > 0)
                    nextSlHeight = nextSl.offset().top;
                if (curSl.length > 0)
                    curSlHeight = curSl.offset().top;
                if (prevSl.length > 0)
                    prevSlHeight = prevSl.offset().top;
            }
            else if (kObj._freezeSwimlaneRow.length > 0) {
                freezeSlHeight = kObj.getContent().offset().top + kObj._freezeSwimlaneRow.height();
                curSl = kObj._swimlaneRows.eq(kObj._freezeSlOrder);
                nextSl = kObj._swimlaneRows.eq(kObj._freezeSlOrder + 1);
                prevSl = kObj._swimlaneRows.eq(kObj._freezeSlOrder - 1);
                if (nextSl.length > 0)
                    nextSlHeight = nextSl.offset().top + nextSl.height();
                curSlHeight = curSl.offset().top + curSl.height();
                prevSlHeight = prevSl.offset().top + prevSl.height();
            }
            freezeSlDiv = kObj.element.find('.e-freezeswimlanerow >div');
            if (kObj._freezeScrollTop > e.scrollTop) {
                curSlHeight = curSlHeight;
                if (freezeSlHeight >= nextSlHeight)
                    nextSlHeight = freezeSlHeight + 1;
            }
            if (kObj._freezeScrollTop < e.scrollTop)
                nextSlHeight = nextSlHeight;
            if (e.source == "wheel" || e.source == "button") {
                if (kObj._freezeScrollTop < e.scrollTop)
                    nextSlHeight = nextSlHeight - e.model.scrollOneStepBy;
                else if (kObj._freezeScrollTop > e.scrollTop)
                    freezeSlHeight = freezeSlHeight - e.model.scrollOneStepBy;
            }
            if (freezeSlHeight >= nextSlHeight && kObj._freezeSlOrder < kObj._swimlaneRows.length - 1) {
                if (freezeSlDiv.length > 0) {
                    freezeSlDiv.children().remove();
                    freezeSlDiv.append(nextSl.find('.e-slkey,.e-slcount').clone());
                }
                if (slText.length > 0) {
                    slText.text(kObj._kbnAdaptDdlData[kObj._kbnAdaptDdlIndex + 1]);
                    ++kObj._kbnAdaptDdlIndex;
                }
                ++kObj._freezeSlOrder;
            }
            else if (freezeSlHeight < curSlHeight && freezeSlHeight > prevSlHeight && kObj._freezeSlOrder > 0) {
                if (freezeSlDiv.length > 0) {
                    freezeSlDiv.children().remove();
                    freezeSlDiv.append(prevSl.find('.e-slkey,.e-slcount').clone());
                }
                if (slText.length > 0) {
                    slText.text(kObj._kbnAdaptDdlData[kObj._kbnAdaptDdlIndex - 1]);
                    --kObj._kbnAdaptDdlIndex;
                }
                --kObj._freezeSlOrder;
            }
            if (e.scrollTop == 0)
                this._removeFreezeslRow();
            if (!ej.isNullOrUndefined(e.scrollLeft)) {
                freezeSlDiv.css({ 'left': -e.scrollLeft });
                kObj._freezeSwimlaneRow.find('table').css({ 'left': -e.scrollLeft });
            }
        }
        kObj._freezeScrollTop = e.scrollTop;
    };
    InternalSwimlane.prototype._swimlaneLimit = function (args) {
        var kObj = this.kanbanObj;
        for (var i = 0; i < kObj.model.columns.length; i++) {
            var constraints = kObj.model.columns[i].constraints, key = kObj.KanbanCommon._multikeySeparation(kObj.model.columns[i].key), $min, $minLimit, $max, $maxLimit;
            if (!ej.isNullOrUndefined(constraints)) {
                var isMin = !ej.isNullOrUndefined(constraints.min), isMax = !ej.isNullOrUndefined(constraints.max), $cell = $($(kObj.getContent().find(".e-columnrow")).find('td[ej-mappingkey="' + key + '"]'));
                if (constraints.type == "swimlane" && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                    for (var j = 0; j < $cell.length; j++) {
                        if ($($cell).eq(j).find(".e-limits").length == 0) {
                            var limit = ej.buildTag("div.e-limits");
                            $($cell).eq(j).prepend(limit);
                        }
                        var $limit = $($cell).eq(j).find(".e-limits");
                        if (isMin) {
                            $min = ej.buildTag("div.e-min", kObj.localizedLabels.Min, "", {});
                            $minLimit = ej.buildTag("span.e-minlimit", " " + constraints.min.toString(), "", {});
                            $min.append($minLimit);
                            if ($limit.find(".e-min").length > 0)
                                $limit.find(".e-min").remove();
                            $limit.append($min);
                        }
                        if (isMax) {
                            $max = ej.buildTag("div.e-max", kObj.localizedLabels.Max, "", {});
                            $maxLimit = ej.buildTag("span.e-maxlimit", " " + constraints.max.toString(), "", {});
                            $max.append($maxLimit);
                            if ($limit.find(".e-max").length > 0)
                                $limit.find(".e-max").remove();
                            if (isMin)
                                $limit.append("/");
                            $limit.append($max);
                        }
                        if (kObj.getHeaderContent().find(".e-headercell").eq(i).hasClass("e-shrinkcol"))
                            $($cell).eq(j).find(".e-limits").addClass("e-hide");
                    }
                }
            }
        }
    };
    return InternalSwimlane;
}());
window.ej.createObject("ej.KanbanFeatures.Swimlane", InternalSwimlane, window);
;
var InternalCommon = (function () {
    function InternalCommon(element) {
        this.kanbanObj = null;
        this.kanbanObj = element;
    }
    ;
    InternalCommon.prototype._updateGroup = function (cardId, data) {
        var kObj = this.kanbanObj;
        if (ej.isNullOrUndefined(kObj._saveArgs))
            new ej.DataManager(kObj._currentJsonData).update(kObj.model.fields.primaryKey, data, "");
        if ($.type(data) && !data.count)
            this._renderSingleCard(cardId, data);
    };
    InternalCommon.prototype._removeIdSymbols = function (id) {
        if (typeof id == "string")
            id = id.replace(/[-\s']/g, '_');
        return id;
    };
    InternalCommon.prototype._enableKanbanRTL = function () {
        if (this.kanbanObj.model.enableRTL)
            this.kanbanObj.element.addClass("e-rtl");
        else
            this.kanbanObj.element.removeClass("e-rtl");
    };
    InternalCommon.prototype._getEmptyTbody = function () {
        var $emptyTd = ej.buildTag('td.e-emptycard', this.kanbanObj.localizedLabels.EmptyCard, {}, { colSpan: this.kanbanObj.model.columns.length });
        return $(document.createElement("tr")).append($emptyTd);
    };
    InternalCommon.prototype._renderSingleCard = function (primaryKey, card) {
        var kObj = this.kanbanObj, curEle = kObj.element.find("div[id='" + primaryKey + "']"), proxy = kObj, curTr, curTd;
        if (!kObj._dropped) {
            var swimlaneKey = proxy.model.fields.swimlaneKey;
            if (!ej.isNullOrUndefined(swimlaneKey)) {
                var unassignedGroup = kObj.model.swimlaneSettings.unassignedGroup;
                if (unassignedGroup.enable && unassignedGroup.keys.length > 0)
                    card = kObj._checkKbnUnassigned(card);
                var slKey = this._removeIdSymbols(card[swimlaneKey]);
                var slTr = kObj.element.find("tr[id='" + slKey + "']");
                if (slTr.length > 0)
                    curTr = slTr.next();
            }
            else
                curTr = kObj.element.find(".e-columnrow:first");
            curTd = $(curTr).find("td.e-rowcell").eq(kObj._getColumnKeyIndex(card[kObj.model.keyField]));
            $(curEle).remove();
            if (curTd.length > 0)
                $(curTd).children().hasClass("e-customaddbutton") ? $($.render[kObj._id + "_cardTemplate"](card)).insertBefore($(curTd).find(".e-customaddbutton")) : $(curTd).append($.render[kObj._id + "_cardTemplate"](card));
        }
        else {
            var cTemp = $.render[kObj._id + "_cardTemplate"](card);
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                $(curEle).after(cTemp);
            else {
                $(curEle).replaceWith(cTemp);
                var index = $.inArray(primaryKey, kObj._collapsedCards);
                if (index != -1)
                    kObj.toggleCard(primaryKey);
            }
        }
        if (kObj.KanbanDragAndDrop)
            kObj.KanbanDragAndDrop._addDragableClass();
        if (kObj.KanbanSelection)
            kObj.KanbanSelection._selectionOnRerender();
    };
    InternalCommon.prototype._getKanbanCardData = function (data, key) {
        return (new ej.DataManager(data).executeLocal(new ej.Query().where(this.kanbanObj.model.fields.primaryKey, ej.FilterOperators.equal, key)));
    };
    InternalCommon.prototype._kbnHeaderAndCellEvents = function ($target) {
        var kObj = this.kanbanObj, args = {}, cards = $target.find('.e-kanbancard'), hTrgt = $target, key, selCards = $target.find('.e-cardselection'), headerIndex, proxy = this, cellIndex = $target.index(), row = $target.parents('.e-columnrow'), cells;
        cells = kObj.element.find('.e-rowcell.e-droppable');
        key = $target.attr('ej-mappingkey');
        if (hTrgt.parents('.e-headercell').length > 0)
            hTrgt = $target.parents('.e-headercell');
        if (hTrgt.hasClass('e-headercell')) {
            var curCell;
            headerIndex = cellIndex = hTrgt.index();
            curCell = cells.eq(headerIndex);
            key = curCell.attr('ej-mappingkey');
            if (kObj.model.fields.swimlaneKey)
                curCell = $("td[ej-mappingkey~='" + key + "']");
            cards = curCell.find('.e-kanbancard');
            selCards = curCell.find('.e-cardselection');
            row = curCell.parents('.e-columnrow');
        }
        if ($target.hasClass('e-rowcell') || !hTrgt.hasClass('e-stackedHeaderCell')) {
            var skey = row.prev('.e-swimlanerow').find('.e-slkey').text(), selIndexes = [], predicates = [];
            if (!ej.isNullOrUndefined(key)) {
                var key = typeof (key) == "object" ? key : key.split(",");
                for (var j = 0; j < key.length; j++)
                    predicates.push(new ej.Predicate(kObj.model.keyField, ej.FilterOperators.equal, key[j], true));
            }
            else
                predicates.push(new ej.Predicate(kObj.model.keyField, ej.FilterOperators.equal, key, true));
            args["cardsInfo"] = function () {
                var cardsInfo = {}, index;
                cardsInfo["cards"] = cards;
                if (kObj.model.fields.swimlaneKey && $target.hasClass('e-rowcell'))
                    cardsInfo["cardsData"] = new ej.DataManager(kObj._currentJsonData).executeLocal(new ej.Query().where(ej.Predicate["or"](predicates)).where(kObj.model.fields.swimlaneKey, ej.FilterOperators.equal, skey));
                else
                    cardsInfo["cardsData"] = new ej.DataManager(kObj._currentJsonData).executeLocal(new ej.Query().where(ej.Predicate["or"](predicates)));
                cardsInfo["cardsCount"] = cards.length;
                if (kObj._selectedCardData.length > 0) {
                    index = $.inArray(cellIndex, kObj.selectedRowCellIndexes[0].cellIndex);
                    if (!ej.isNullOrUndefined(index) && index >= 0)
                        selIndexes.push(kObj.selectedRowCellIndexes[0].cardIndex[index]);
                }
                cardsInfo["selectedCardsIndexes"] = selIndexes;
                cardsInfo["selectedCardsData"] = new ej.DataManager(proxy._selectedCardData).executeLocal(new ej.Query().where(ej.Predicate["or"](predicates)));
                cardsInfo["selectedCards"] = selCards;
                return cardsInfo;
            };
        }
        if ($target.hasClass('e-rowcell')) {
            args["rowIndex"] = kObj.getIndexByRow(row);
            args["cellIndex"] = cellIndex;
            kObj._trigger('cellClick', args);
        }
        if (hTrgt.hasClass('e-stackedHeaderCell')) {
            args["text"] = $target.text();
            var sCards = [], selCards, colIndexes = [], selColIndexes = [], cardIndexes = [], stRows, data = [], selData = [];
            stRows = kObj.element.find('.e-stackedHeaderRow');
            args["data"] = function () {
                var columns, count = 0, index;
                var stackedColumns = kObj.model.stackedHeaderRows[stRows.index(hTrgt.parents('.e-stackedHeaderRow'))].stackedHeaderColumns;
                columns = stackedColumns[hTrgt.index()].column;
                columns = columns.split(',');
                for (var i = 0; i < columns.length; i++) {
                    var key = new ej.DataManager(kObj.model.columns).executeLocal(new ej.Query().where('headerText', ej.FilterOperators.equal, columns[i])), cell, cards, selectedCards;
                    cell = $("td[ej-mappingkey~='" + key[0].key + "']");
                    cards = cell.find('.e-kanbancard');
                    sCards.push(cards);
                    data.push(new ej.DataManager(kObj._currentJsonData).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, key[0].key)));
                    cellIndex = cells.index($("td[ej-mappingkey~='" + key[0].key + "']")[0]);
                    if (kObj._selectedCardData.length > 0) {
                        index = $.inArray(cellIndex, kObj.selectedRowCellIndexes[0].cellIndex);
                        if (!ej.isNullOrUndefined(index) && index >= 0) {
                            selectedCards = cell.find('.e-cardselection');
                            selCards.push(selectedCards);
                            selData.push(new ej.DataManager(kObj._selectedCardData).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, key[0].key)));
                            if (selectedCards.length > 0) {
                                selColIndexes.push(cellIndex);
                                cardIndexes.push(kObj.selectedRowCellIndexes[0].cardIndex[index]);
                            }
                        }
                    }
                    count = count + cards.length;
                    colIndexes.push(cellIndex);
                }
                var detials = {};
                detials["count"] = count;
                detials["cards"] = sCards;
                detials["cardsData"] = data;
                detials["cellIndexes"] = colIndexes;
                detials["selectedCellCardIndexes"] = { cellIndex: selColIndexes, cardIndex: cardIndexes };
                detials["selectedCards"] = selCards;
                detials["selectedCardsData"] = selData;
                return detials;
            };
            kObj._trigger('headerClick', args);
        }
        else if (hTrgt.hasClass('e-headercell')) {
            args["text "] = hTrgt.text();
            args["cellIndex"] = headerIndex;
            args["target"] = hTrgt;
            args["columnData"] = kObj.model.columns[headerIndex];
            kObj._trigger('headerClick', args);
            if (kObj.model.allowScrolling && kObj.model.allowToggleColumn) {
                kObj.KanbanCommon._setWidthToColumns();
                kObj.kanbanContent.data('ejScroller').destroy();
                kObj.KanbanScroll._renderScroller();
            }
        }
    };
    InternalCommon.prototype._toggleCardByTarget = function ($target) {
        var kObj = this.kanbanObj;
        $target = $target.hasClass("e-expandcollapse") ? $target.find("div:first") : $target;
        if (!($target.hasClass("e-cardexpand") || $target.hasClass("e-cardcollapse")))
            return;
        var $header = $target.closest('div.e-cardheader'), $cardContent = $header.next(), primarykey = $header.find(".e-primarykey").text(), card = $($target).closest(".e-kanbancard"), cardId = card.attr('id');
        if ($target.hasClass("e-cardexpand")) {
            $target.removeClass("e-cardexpand").addClass("e-cardcollapse");
            card.addClass("e-collapsedcard");
            $header.append($cardContent.find(".e-text").clone());
            $cardContent.hide();
            if ($.inArray(cardId, kObj._collapsedCards) == -1)
                kObj._collapsedCards.push(cardId);
            var bottomTriangle = $cardContent.find('.e-bottom-triangle').clone();
            $header.append(bottomTriangle);
        }
        else {
            $target.removeClass("e-cardcollapse").addClass("e-cardexpand");
            card.removeClass("e-collapsedcard");
            $header.find(".e-text,.e-bottom-triangle").remove();
            $cardContent.show();
            var index = $.inArray(cardId, kObj._collapsedCards);
            if (index != -1)
                kObj._collapsedCards.splice(index, 1);
        }
        if (kObj.model.allowScrolling) {
            if (kObj.getScrollObject().isVScroll() || kObj.getScrollObject().isHScroll())
                kObj.getScrollObject().refresh();
            if (!kObj.getScrollObject().isVScroll())
                kObj.element.find(".e-kanbanheader").removeClass("e-scrollcss").children().removeClass("e-hscrollcss");
            else
                kObj.element.find(".e-kanbanheader").addClass("e-scrollcss").children().addClass("e-hscrollcss");
        }
        if (kObj.element.hasClass('e-responsive')) {
            var scroller = $target.parents('.e-cell-scrollcontent');
            if (scroller.length > 0)
                scroller.data('ejScroller').refresh();
        }
    };
    InternalCommon.prototype._priorityColData = function (colData, cData) {
        var cardIndex, pKey = this.kanbanObj.model.fields.primaryKey, prkey = this.kanbanObj.model.fields.priority;
        cardIndex = $.map(colData, function (obj, index) {
            if (obj[pKey] == cData[pKey])
                return index;
        });
        if (!ej.isNullOrUndefined(cardIndex[0]))
            colData.splice(cardIndex, 1);
        var index = cData[prkey] - 1;
        if (!ej.isNullOrUndefined(colData[index - 1])) {
            if (colData[index - 1][prkey] == cData[prkey])
                --index;
        }
        colData.splice(index, 0, cData);
        colData.sort(function (val1, val2) {
            return val1[prkey] - val2[prkey];
        });
        return colData;
    };
    InternalCommon.prototype._getPriorityData = function (priorityData, data) {
        var index, pKey = this.kanbanObj.model.fields.primaryKey;
        index = $.map(priorityData, function (obj, index) {
            if (obj[pKey] == data[pKey])
                return index;
        });
        if (!ej.isNullOrUndefined(index[0]))
            priorityData[index][this.kanbanObj.model.fields.priority] = data[this.kanbanObj.model.fields.priority];
        else
            priorityData.push(data);
        return priorityData;
    };
    InternalCommon.prototype._preventCardMove = function (currentcardkey, targetcardkey) {
        var kObj = this.kanbanObj, targetkey = typeof (targetcardkey) == "object" ? targetcardkey : targetcardkey.split(",");
        for (var k = 0; k < targetkey.length; k++) {
            if (currentcardkey == targetkey[k])
                return true;
            var AllowedTransitionsdrag = true, flow = kObj.model.workflows;
            if (!ej.isNullOrUndefined(flow) && flow.length > 0) {
                for (var i = 0; i < flow.length; i++) {
                    if (flow[i].key == currentcardkey && !ej.isNullOrUndefined(flow[i].allowedTransitions)) {
                        var array = typeof (flow[i].allowedTransitions) == "object" ? flow[i].allowedTransitions : flow[i].allowedTransitions.split(",");
                        if (array.length == 1 && array[0].length == 0)
                            return true;
                        for (var j = 0; j < array.length; j++) {
                            if (targetkey[k] == array[j]) {
                                return true;
                            }
                            else {
                                AllowedTransitionsdrag = false;
                            }
                        }
                    }
                }
            }
        }
        if (AllowedTransitionsdrag)
            return true;
        else
            return false;
    };
    InternalCommon.prototype._updateKbnPriority = function (priorityData, cData) {
        var kObj = this.kanbanObj, currData = kObj._currentJsonData, colData, oldData, primary = kObj.model.fields.primaryKey, prkey = kObj.model.fields.priority, slKey = kObj.model.fields.swimlaneKey;
        if ((!ej.isNullOrUndefined(kObj._filterToolBar) && kObj._filterToolBar.find('.e-select').length > 0) || (kObj._searchBar != null && kObj._searchBar.find(".e-cancel").length > 0))
            currData = kObj._initialData;
        oldData = this._getKanbanCardData(currData, cData[primary])[0];
        cData[prkey] = parseInt(cData[prkey]);
        if (ej.isNullOrUndefined(slKey))
            colData = new ej.DataManager(currData).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, cData[kObj.model.keyField]));
        else
            colData = new ej.DataManager(currData).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, cData[kObj.model.keyField]).where(slKey, ej.FilterOperators.equal, cData[slKey]));
        colData = colData.slice();
        var proxy = kObj, pkey = cData[primary];
        colData.sort(function (val1, val2) {
            return val1[prkey] - val2[prkey];
        });
        if (kObj._bulkPriorityData.length > 0) {
            for (var i = 0; i < colData.length; i++) {
                var index = $.map(kObj._bulkPriorityData, function (obj, index) {
                    if (obj[primary] == colData[i][primary])
                        return index;
                });
                if (!ej.isNullOrUndefined(index[0]))
                    colData[i][kObj.model.fields.priority] = kObj._bulkPriorityData[index][kObj.model.fields.priority];
            }
            colData.sort(function (val1, val2) {
                return val1[prkey] - val2[prkey];
            });
        }
        if (!ej.isNullOrUndefined(slKey)) {
            colData = this._priorityColData(colData, cData);
        }
        else
            colData = this._priorityColData(colData, cData);
        var init = cData[prkey] - 1;
        if (init != $.inArray(cData, colData))
            init = $.inArray(cData, colData);
        if (cData[prkey] - 1 > colData.length)
            init = colData.length - 1;
        if (init < 0)
            init = 0;
        for (var i = init; i < colData.length; i++) {
            if (!ej.isNullOrUndefined(colData[i])) {
                if (i < colData.length - 1 && !ej.isNullOrUndefined(colData[i + 1]) && colData[i][prkey] >= colData[i + 1][prkey]) {
                    colData[i + 1][prkey] = colData[i][prkey] + 1;
                    priorityData = this._getPriorityData(priorityData, colData[i + 1]);
                }
                else if (i == colData.length - 1 && !ej.isNullOrUndefined(colData[i - 1])) {
                    if (colData[i][prkey] < colData[i - 1][prkey]) {
                        colData[i][prkey] = colData[i - 1][prkey] + 1;
                        priorityData = this._getPriorityData(priorityData, colData[i]);
                    }
                }
            }
        }
        for (var i = init; i >= 0; i--) {
            if (!ej.isNullOrUndefined(colData[i])) {
                if (!ej.isNullOrUndefined(colData[i - 1])) {
                    if (i > 0 && colData[i - 1][prkey] >= colData[i][prkey]) {
                        colData[i - 1][prkey] = colData[i][prkey] - 1;
                        priorityData = this._getPriorityData(priorityData, colData[i - 1]);
                    }
                }
                else if (i == 0 && !ej.isNullOrUndefined(colData[i + 1])) {
                    if (colData[i][prkey] > colData[i + 1][prkey]) {
                        colData[i][prkey] = colData[i + 1][prkey] - 1;
                        priorityData = this._getPriorityData(priorityData, colData[i]);
                    }
                }
            }
        }
        return priorityData;
    };
    InternalCommon.prototype._kbnBulkUpdate = function (addData, deleteData, editdata) {
        var kObj = this.kanbanObj, bulkUpdate;
        if (kObj._dataManager instanceof ej.DataManager && !kObj._dataManager.dataSource.offline || (kObj._dataSource().adaptor instanceof ej.remoteSaveAdaptor)) {
            var bulkChanges;
            bulkChanges = {
                added: addData,
                deleted: deleteData,
                changed: editdata
            };
            $("#" + kObj._id).data("ejWaitingPopup").show();
            (bulkUpdate = kObj._dataManager.saveChanges(bulkChanges, kObj.model.fields.primaryKey, kObj.model.query._fromTable));
            if ($.isFunction(bulkUpdate.promise)) {
                bulkUpdate.done(function (e) {
                    kObj.KanbanCommon._processBindings(kObj._saveArgs);
                    kObj._cModifiedData = null;
                    kObj._cAddedRecord = null;
                    kObj._isAddNewClick = false;
                    kObj._currentData = null;
                    kObj._newCard = null;
                    kObj._saveArgs = null;
                    kObj._cardEditClick = null;
                    kObj._dblArgs = null;
                    kObj._cDeleteData = null;
                    $("#" + kObj._id).data("ejWaitingPopup").hide();
                });
                bulkUpdate.fail(function (e) {
                    var argsKanban;
                    if (ej.isNullOrUndefined(kObj._saveArgs))
                        argsKanban = e;
                    else {
                        kObj._saveArgs.error = (e && e.error) ? e.error : e;
                        argsKanban = kObj._saveArgs;
                    }
                    kObj._renderAllCard();
                    kObj._enableDragandScroll();
                    kObj._cModifiedData = null;
                    kObj._cAddedRecord = null;
                    kObj._isAddNewClick = false;
                    kObj._currentData = null;
                    kObj._newCard = null;
                    kObj._saveArgs = null;
                    kObj._cardEditClick = null;
                    kObj._dblArgs = null;
                    kObj._cDeleteData = null;
                    kObj._trigger("actionFailure", argsKanban);
                    $("#" + kObj._id).data("ejWaitingPopup").hide();
                });
            }
        }
        else
            kObj.KanbanCommon._processBindings(kObj._saveArgs);
        if (bulkUpdate == undefined || !$.isFunction(bulkUpdate.promise)) {
            kObj._cModifiedData = null;
            kObj._cAddedRecord = null;
            kObj._isAddNewClick = false;
            kObj._currentData = null;
            kObj._newCard = null;
            kObj._saveArgs = null;
            kObj._cardEditClick = null;
            kObj._dblArgs = null;
            kObj._cDeleteData = null;
        }
    };
    InternalCommon.prototype._checkSkipAction = function (args) {
        switch (args.requestType) {
            case "save":
            case "delete":
                return true;
        }
        return false;
    };
    InternalCommon.prototype._processBindings = function (args) {
        var kObj = this.kanbanObj;
        args.primaryKey = kObj.model.fields.primaryKey;
        if (!this._checkSkipAction(args) && kObj._trigger("actionBegin", args))
            return true;
        kObj._ensureDataSource(args);
        kObj._editForm = kObj.element.find(".kanbanform");
        if (!(args.requestType == "beginedit") && !(args.requestType == "drop") && kObj._editForm.length != 0) {
            if (kObj._editForm.length > 1 && args.requestType == "save" && args.action == "edit")
                kObj._editForm = $(kObj._editForm[0]);
            $(kObj._editForm).find("select.e-dropdownlist").ejDropDownList("destroy");
            $(kObj._editForm).find("textarea.e-rte").ejRTE("destroy");
            $(kObj._editForm).find(".e-datepicker").ejDatePicker("destroy");
            $(kObj._editForm).find(".e-datetimepicker").ejDateTimePicker("destroy");
            $(kObj._editForm).find(".e-numerictextbox").ejNumericTextbox("destroy");
            $(kObj._editForm).addClass('e-formdestroy');
        }
        if (args && args.requestType == "delete")
            args.div.remove();
        if (args.requestType == "drop")
            kObj._templateRefresh = true;
        if (kObj._dataSource() instanceof ej.DataManager && args.requestType != "beginedit" && args.requestType != "cancel" && args.requestType != "add") {
            kObj.element.ejWaitingPopup("show");
            var queryPromise = kObj._queryPromise = kObj._dataSource().executeQuery(kObj.model.query);
            var proxy = kObj;
            if (proxy._dataSource().ready) {
                proxy._dataSource().ready.done(function () {
                    proxy.KanbanCommon._processDataRequest(proxy, args, queryPromise);
                });
            }
            else {
                proxy.KanbanCommon._processDataRequest(proxy, args, queryPromise);
            }
        }
        else
            kObj.sendDataRenderingRequest(args);
    };
    InternalCommon.prototype._processDataRequest = function (proxy, args, queryPromise) {
        queryPromise.done(ej.proxy(function (e) {
            proxy.element.ejWaitingPopup("hide");
            proxy._currentJsonData = proxy.currentViewData = e.result == null ? [] : e.result;
            proxy.KanbanCommon._processData(e, args);
        }));
        queryPromise.fail(ej.proxy(function (e) {
            proxy.element.ejWaitingPopup("hide");
            args.error = e.error;
            e = [];
            proxy.currentViewData = [];
            proxy.KanbanCommon._processData(e, args);
            proxy._trigger("actionFailure", args);
        }));
    };
    InternalCommon.prototype._processData = function (e, args) {
        var kObj = this.kanbanObj;
        if (!ej.isNullOrUndefined(kObj.model.filterSettings))
            if ((args.requestType == "filtering" || (kObj.model.filterSettings.length > 0 && args.requestType == "refresh")))
                kObj._filteredRecordsCount = e.count;
        kObj.sendDataRenderingRequest(args);
    };
    InternalCommon.prototype._moveCurrentCard = function (index, key, e) {
        var cellindex, rowCellIndex, cards, cardIndex, cellcards, tdCard, column, cellcardsCount, tdCellIncr, tdCellDecr, colCellSel, kObj = this.kanbanObj;
        rowCellIndex = kObj.selectedRowCellIndexes[0];
        var rowcardIndex = rowCellIndex.cardIndex;
        cellindex = rowCellIndex.cellIndex[rowCellIndex.cellIndex.length - 1];
        if (key == "down" || key == "up") {
            colCellSel = $(kObj._columnRows[index]).find("td.e-rowcell").eq(cellindex);
            cellcards = colCellSel.find(".e-kanbancard");
            cardIndex = $(cellcards).index(colCellSel.find(".e-cardselection"));
            cellcardsCount = cellcards.length;
            if (key == "down") {
                if (ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                    if (kObj.model.selectionType == "multiple")
                        cardIndex = rowcardIndex[rowCellIndex.cellIndex.length - 1][rowcardIndex[rowCellIndex.cellIndex.length - 1].length - 1];
                    else
                        cardIndex = rowcardIndex[rowCellIndex.cellIndex.length - 1];
                else if ((e.shiftKey || e.ctrlKey) && kObj.model.selectionType == "multiple")
                    cardIndex = rowcardIndex[rowCellIndex.cellIndex.length - 1][rowcardIndex[rowCellIndex.cellIndex.length - 1].length - 1];
                if (cardIndex == (cellcardsCount - 1) || cellcardsCount == 0)
                    if (index == kObj._columnRows.length - 1)
                        return;
                    else if ((!e.shiftKey && !e.ctrlKey) || (kObj.model.selectionType == "single"))
                        this._moveCurrentCard(index + 1, key, e);
                    else
                        return;
                else if (cellcards.eq(cardIndex + 1).hasClass("e-cardselection"))
                    kObj.KanbanSelection._cardSelection([[index, [cellindex], [cardIndex]]], $(cellcards[cardIndex]), e);
                else
                    kObj.KanbanSelection._cardSelection([[index, [cellindex], [cardIndex + 1]]], $(cellcards[cardIndex + 1]), e);
            }
            else if (key == "up") {
                if (ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                    if (kObj.model.selectionType == "multiple")
                        cardIndex = rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1][rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1].length - 1];
                    else
                        cardIndex = rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1];
                else if ((e.shiftKey || e.ctrlKey) && kObj.model.selectionType == "multiple")
                    cardIndex = rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1][rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1].length - 1];
                if (cellcardsCount == 0 || cardIndex == 0)
                    if (index == 0)
                        return;
                    else if ((!e.shiftKey && !e.ctrlKey) || (kObj.model.selectionType == "single"))
                        this._moveCurrentCard(index - 1, key, e);
                    else
                        return;
                else if (cellcards.eq(cardIndex - 1).hasClass("e-cardselection"))
                    kObj.KanbanSelection._cardSelection([[index, [cellindex], [cardIndex]]], $(cellcards[cardIndex]), e);
                else {
                    if (cardIndex != -1)
                        kObj.KanbanSelection._cardSelection([[index, [cellindex], [cardIndex - 1]]], $(cellcards[cardIndex - 1]), e);
                    else
                        kObj.KanbanSelection._cardSelection([[index, [cellindex], [cellcardsCount - 1]]], $(cellcards[cellcardsCount - 1]), e);
                }
            }
            if ((!e.shiftKey && !e.ctrlKey) || ("single"))
                if (kObj.element.find(".e-cardselection").closest("tr.e-columnrow:visible").length == 0)
                    kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slcollapse"));
        }
        else {
            var card, cardselec, switchcard;
            column = $(kObj._columnRows[rowCellIndex.rowIndex]);
            tdCard = column.find("td.e-rowcell");
            cellcards = tdCard.eq(index).find(".e-kanbancard");
            cards = tdCard.eq(index).find(".e-kanbancard");
            tdCellIncr = tdCard.eq(index + 1);
            tdCellDecr = tdCard.eq(index - 1);
            card = kObj.element.find(".e-kanbancard");
            cardselec = kObj.element.find(".e-cardselection");
            if ((!tdCellDecr.is(":visible") || !tdCellIncr.is(":visible")) && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                if (kObj.element.find(".e-cardselection").closest("tr.e-columnrow:visible").length == 0)
                    kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slcollapse"));
            if ((e.shiftKey || e.ctrlKey) && kObj.model.selectionType == "multiple")
                cardIndex = rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1][rowCellIndex.cardIndex[rowCellIndex.cellIndex.length - 1].length - 1];
            else if (kObj.model.selectionType == "single")
                cardIndex = rowCellIndex.cardIndex[0];
            else
                cardIndex = rowCellIndex.cardIndex[0][0];
            if (key == "right") {
                switchcard = card.eq(card.index(cardselec) + 1);
                if (index == tdCard.length - 1) {
                    if (switchcard.length > 0 && ((!e.shiftKey && !e.ctrlKey) || (kObj.model.selectionType == "single")) && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                        kObj.KanbanSelection._cardSelection([[kObj._columnRows.index(switchcard.closest("tr.e-columnrow")), [switchcard.closest("tr.e-columnrow").find("td.e-rowcell").index(switchcard.closest("td.e-rowcell"))], [0]]], switchcard, e);
                        if (kObj.element.find(".e-cardselection").closest("tr:visible").length == 0)
                            kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slcollapse"));
                    }
                    return;
                }
                if (tdCellIncr.find(".e-kanbancard:visible").length > 0) {
                    cards = tdCellIncr.find(".e-kanbancard");
                    if (cards.eq(cardIndex).length > 0)
                        kObj.KanbanSelection._cardSelection([[rowCellIndex.rowIndex, [index + 1], [cardIndex]]], $(cards[cardIndex]), e);
                    else
                        kObj.KanbanSelection._cardSelection([[rowCellIndex.rowIndex, [index + 1], [cards.length - 1]]], $(cards[cards.length - 1]), e);
                    if (((!e.shiftKey && !e.ctrlKey) || (kObj.model.selectionType == "single")) && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                        if (kObj.element.find(".e-cardselection").closest("tr.e-columnrow:visible").length == 0)
                            kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slcollapse"));
                }
                else
                    this._moveCurrentCard(index + 1, key, e);
            }
            else if (key == "left") {
                if (card.index(cardselec) != 0)
                    switchcard = card.eq(card.index(cardselec) - 1);
                if (index == 0) {
                    if ((!e.shiftKey && !e.ctrlKey) && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                        kObj.KanbanSwimlane.toggle($(column).prev().find(".e-slexpand"));
                        if (ej.isNullOrUndefined(switchcard))
                            return;
                        if (switchcard.length > 0 && (!e.shiftKey && !e.ctrlKey) || (kObj.model.selectionType == "single")) {
                            kObj.KanbanSelection._cardSelection([[kObj._columnRows.index(switchcard.closest("tr.e-columnrow")), [switchcard.closest("tr.e-columnrow").find("td.e-rowcell").index(switchcard.closest("td.e-rowcell"))], [0]]], switchcard, e);
                            if (kObj.element.find(".e-cardselection").closest("tr.e-columnrow:visible").length == 0)
                                kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slcollapse"));
                        }
                    }
                    return;
                }
                if (tdCellDecr.find(".e-kanbancard:visible").length > 0) {
                    cards = tdCellDecr.find(".e-kanbancard");
                    if (cards.eq(cardIndex).length > 0)
                        kObj.KanbanSelection._cardSelection([[rowCellIndex.rowIndex, [index - 1], [cardIndex]]], $(cards[cardIndex]), e);
                    else
                        kObj.KanbanSelection._cardSelection([[rowCellIndex.rowIndex, [index - 1], [cards.length - 1]]], $(cards[cards.length - 1]), e);
                    if (((!e.shiftKey && !e.ctrlKey) || (kObj.model.selectionType == "single")) && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                        if (kObj.element.find(".e-cardselection").closest("tr.e-columnrow:visible").length == 0)
                            kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slexpand"));
                }
                else
                    this._moveCurrentCard(index - 1, key, e);
            }
        }
    };
    InternalCommon.prototype._kanbanKeyPressed = function (action, target, e, event) {
        var selectedcard, kanbancard, rowCellIndex, cellIndex, $target = $(target), returnValue = true, kObj = this.kanbanObj;
        selectedcard = kObj.element.find(".e-cardselection");
        kanbancard = kObj.element.find(".e-kanbancard:visible");
        if (e.code == 13 && target.tagName == 'INPUT' && $target.closest("#" + kObj._id + "_toolbarItems_search").length)
            action = "searchRequest";
        rowCellIndex = kObj.selectedRowCellIndexes[0];
        var swimlane = !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey);
        switch (action) {
            case "editCard":
                if (selectedcard.length > 0 && kObj.model.editSettings.allowEditing) {
                    cellIndex = rowCellIndex.cellIndex;
                    selectedcard = kObj._columnRows.eq(rowCellIndex.rowIndex).find("td.e-rowcell").eq(cellIndex[cellIndex.length - 1]).find(".e-kanbancard").eq(rowCellIndex.cardIndex[cellIndex.length - 1]);
                    kObj.KanbanEdit.startEdit(selectedcard);
                }
                break;
            case "insertCard":
                if (kObj.model.editSettings.allowAdding)
                    kObj.KanbanEdit.addCard();
                break;
            case "swimlaneExpandAll":
                if (kObj.KanbanSwimlane)
                    kObj.KanbanSwimlane.expandAll();
                break;
            case "swimlaneCollapseAll":
                if (kObj.KanbanSwimlane)
                    kObj.KanbanSwimlane.collapseAll();
                break;
            case "downArrow":
                if (selectedcard.length > 0 && (document.activeElement["id"] == kObj._id))
                    this._moveCurrentCard(rowCellIndex.rowIndex, "down", e);
                break;
            case "upArrow":
                if (selectedcard.length > 0 && (document.activeElement["id"] == kObj._id)) {
                    this._moveCurrentCard(rowCellIndex.rowIndex, "up", e);
                }
                break;
            case "leftArrow":
                if (selectedcard.length > 0 && (document.activeElement["id"] == kObj._id))
                    this._moveCurrentCard(rowCellIndex.cellIndex[rowCellIndex.cellIndex.length - 1], "left", e);
                if (kObj.model.isResponsive && kObj.element.hasClass('e-responsive') && kObj._kbnTransitionEnd)
                    kObj.KanbanAdaptive._kbnRightSwipe();
                break;
            case "rightArrow":
                if (selectedcard.length > 0 && (document.activeElement["id"] == kObj._id))
                    this._moveCurrentCard(rowCellIndex.cellIndex[rowCellIndex.cellIndex.length - 1], "right", e);
                if (kObj.model.isResponsive && kObj.element.hasClass('e-responsive') && kObj._kbnTransitionEnd)
                    kObj.KanbanAdaptive._kbnLeftSwipe();
                break;
            case "multiSelectionByDownArrow":
                e.ctrlKey = true;
                if (selectedcard.length > 0)
                    this._moveCurrentCard(rowCellIndex.rowIndex, "down", e);
                break;
            case "multiSelectionByUpArrow":
                e.ctrlKey = true;
                if (selectedcard.length > 0)
                    this._moveCurrentCard(rowCellIndex.rowIndex, "up", e);
                break;
            case "multiSelectionByRightArrow":
                e.shiftKey = true;
                if (selectedcard.length > 0)
                    this._moveCurrentCard(rowCellIndex.cellIndex[rowCellIndex.cellIndex.length - 1], "right", e);
                break;
            case "multiSelectionByLeftArrow":
                e.shiftKey = true;
                if (selectedcard.length > 0)
                    this._moveCurrentCard(rowCellIndex.cellIndex[rowCellIndex.cellIndex.length - 1], "left", e);
                break;
            case "firstCardSelection":
                if (kObj.model.allowSelection && (document.activeElement["id"] == kObj._id)) {
                    kObj.KanbanSelection.clear();
                    kanbancard.eq(0).addClass("e-cardselection");
                    selectedcard = kObj.element.find(".e-cardselection");
                    var cardIndex = $(kObj._columnRows).find(".e-cardselection").index();
                    var selectionIndex = $(kObj._columnRows).find(".e-cardselection").parent().children().eq(0).hasClass("e-limits") ? cardIndex - 1 : cardIndex;
                    if (kObj.model.selectionType == "multiple")
                        kObj.selectedRowCellIndexes.push({ cardIndex: [[selectionIndex]], cellIndex: [selectedcard.parent().index()], rowIndex: $(kObj._columnRows).index(selectedcard.parents(".e-columnrow")) });
                    else
                        kObj.selectedRowCellIndexes.push({ cardIndex: [selectionIndex], cellIndex: [selectedcard.parent().index()], rowIndex: $(kObj._columnRows).index(selectedcard.parents(".e-columnrow")) });
                }
                break;
            case "lastCardSelection":
                if (kObj.model.allowSelection && (document.activeElement["id"] == kObj._id)) {
                    kObj.KanbanSelection.clear();
                    kanbancard.eq(kanbancard.length - 1).addClass("e-cardselection");
                    selectedcard = kObj.element.find(".e-cardselection");
                    selectedcard = kObj.element.find(".e-cardselection");
                    var cardIndex = $(kObj._columnRows).find(".e-cardselection").index();
                    var selectionIndex = $(kObj._columnRows).find(".e-cardselection").parent().children().eq(0).hasClass("e-limits") ? cardIndex - 1 : cardIndex;
                    if (kObj.model.selectionType == "multiple")
                        kObj.selectedRowCellIndexes.push({ cardIndex: [[selectionIndex]], cellIndex: [selectedcard.parent().index()], rowIndex: $(kObj._columnRows).index(selectedcard.parents(".e-columnrow")) });
                    else
                        kObj.selectedRowCellIndexes.push({ cardIndex: [selectionIndex], cellIndex: [selectedcard.parent().index()], rowIndex: $(kObj._columnRows).index(selectedcard.parents(".e-columnrow")) });
                }
                break;
            case "cancelRequest":
                if ($("#" + kObj._id + "_dialogEdit:visible").length > 0)
                    kObj.KanbanEdit.cancelEdit();
                else if (selectedcard.length > 0)
                    kObj.KanbanSelection.clear();
                break;
            case "searchRequest":
                kObj.KanbanFilter.searchCards($target.val());
                returnValue = false;
                break;
            case "saveRequest":
                if ($("#" + kObj._id + "_dialogEdit:visible").length > 0)
                    kObj.KanbanEdit.endEdit();
                break;
            case "deleteCard":
                if (selectedcard.length > 0 && $("#" + kObj._id + "_dialogEdit:visible").length <= 0 && !ej.isNullOrUndefined(kObj.model.fields.primaryKey))
                    kObj.KanbanEdit.deleteCard(selectedcard.attr("id"));
                break;
            case "selectedSwimlaneExpand":
                if (selectedcard.length > 0 && swimlane)
                    if (!selectedcard.is(":visible"))
                        kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().prev(".e-swimlanerow").find(".e-slexpandcollapse"));
                break;
            case "selectedSwimlaneCollapse":
                if (selectedcard.length > 0 && swimlane)
                    if (selectedcard.is(":visible"))
                        kObj.KanbanSwimlane.toggle($(kObj._columnRows[kObj.selectedRowCellIndexes[0].rowIndex]).prev().find(".e-slexpandcollapse"));
                break;
            case "selectedColumnCollapse":
                if (selectedcard.length > 0)
                    this._toggleField(kObj.model.columns[kObj.selectedRowCellIndexes[0].cellIndex[0]].headerText);
                break;
            case "selectedColumnExpand":
                if (kObj._collapsedColumns.length != 0)
                    this._toggleField(kObj._collapsedColumns[kObj._collapsedColumns.length - 1]);
                break;
            case "focus":
                kObj.element.find(".e-cardselection").focus();
                break;
            default:
                returnValue = true;
        }
        return returnValue;
    };
    InternalCommon.prototype._createStackedRow = function (stackedHeaderRow) {
        var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow', "", {}, {}), sHeader = [], kObj = this.kanbanObj;
        for (var s = 0; s < kObj.model.columns.length; s++) {
            var column = kObj.model.columns[s];
            if (column.visible != false) {
                var headerText = '';
                var sColumn = stackedHeaderRow.stackedHeaderColumns;
                for (var cl = 0; cl < sColumn.length; cl++) {
                    if (sColumn[cl].column.indexOf(column.headerText) != -1) {
                        headerText = sColumn[cl].headerText;
                    }
                }
                sHeader.push(headerText);
            }
        }
        var colsPanList = [], css = "";
        for (var h = 0; h < sHeader.length; h++) {
            var colSpan = 1;
            for (var j = h + 1; j < sHeader.length; j++) {
                if ((sHeader[h] != "") && (sHeader[j] != "") && sHeader[h] == sHeader[j]) {
                    colSpan++;
                }
                else
                    break;
            }
            colsPanList.push({
                sapnCount: colSpan,
                headerText: sHeader[h],
                css: (sHeader[h] != "") ? css : "e-sheader"
            });
            h += colSpan - 1;
            css = "";
        }
        for (var c = 0; c < colsPanList.length; c++) {
            var $div = ej.buildTag('div' + '', colsPanList[c].headerText, {}, {});
            var $th = ej.buildTag('th.e-headercell e-stackedHeaderCell ' + colsPanList[c].css + '', "", {}, { 'colspan': colsPanList[c].sapnCount }).append($div);
            $tr.append($th);
        }
        return $tr;
    };
    InternalCommon.prototype._refreshStackedHeader = function () {
        var kObj = this.kanbanObj, stackedRows = kObj.model.stackedHeaderRows, stackHeaderRow = kObj.element.find(".e-stackedHeaderRow");
        for (var i = 0; i < stackedRows.length; i++) {
            var stackedTr = this._createStackedRow(stackedRows[i]);
            if (stackHeaderRow.length > 0)
                stackHeaderRow.remove();
            $(kObj.getHeaderTable().find(".e-columnheader").before(stackedTr));
        }
        kObj.model.allowScrolling && kObj.KanbanScroll._refreshScroller({ requestType: "refresh" });
    };
    InternalCommon.prototype._stackedHeadervisible = function () {
        var stackHeadercell = this.kanbanObj.element.find(".e-columnheader .e-stackedHeaderCell ");
        for (var i = 0; i < stackHeadercell.length; i++)
            if (stackHeadercell[i].offsetWidth < stackHeadercell[i].scrollWidth)
                stackHeadercell.eq(i).find("div").addClass("e-hide");
    };
    InternalCommon.prototype._kanbanUpdateCard = function (primaryKey, data) {
        var kbnCurrentData, kObj = this.kanbanObj, args = kObj._saveArgs, header, curData, cardKey;
        var swimlaneKey = kObj.model.fields.swimlaneKey, unassignedGroup = kObj.model.swimlaneSettings.unassignedGroup;
        if (!ej.isNullOrUndefined(swimlaneKey) && unassignedGroup.enable && unassignedGroup.keys.length > 0) {
            if (ej.isNullOrUndefined(data.length))
                data = kObj._checkKbnUnassigned(data);
            else {
                for (var i = 0; i < data.length; i++)
                    data[i] = kObj._checkKbnUnassigned(data[i]);
            }
        }
        if (ej.isNullOrUndefined(data.length) && $.inArray(data[kObj.model.keyField], kObj._keyValue) == -1)
            return;
        if (ej.isNullOrUndefined(args)) {
            kObj._saveArgs = args = { data: data, requestType: "save", action: "edit", primaryKeyValue: primaryKey };
            kObj._cModifiedData = data;
        }
        if (!(kObj._dataSource() instanceof ej.DataManager))
            kbnCurrentData = kObj._dataSource();
        else
            kbnCurrentData = kObj._dataSource().dataSource.json;
        if (kbnCurrentData.length == 0 && kObj._currentJsonData.length > 0)
            kbnCurrentData = kObj._currentJsonData;
        if (kObj._dataManager instanceof ej.DataManager && !kObj._dataManager.dataSource.offline && (!ej.isNullOrUndefined(args) && args.requestType != "drop") && kObj.model.enableTotalCount && (kObj._filterCollection.length > 0 || kObj.model.searchSettings.key.length > 0)) {
            curData = new ej.DataManager(kbnCurrentData).executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, data[kObj.model.fields.primaryKey]));
            header = kObj.headerContent.find(".e-headercell");
            if (!ej.isNullOrUndefined(curData) && args.action == "edit") {
                cardKey = kObj._getColumnKeyIndex(currentData[0][kObj.model.keyField]);
                header.eq(cardKey).addClass("e-cardDraggedHeader");
            }
            if (!ej.isNullOrUndefined(data)) {
                cardKey = kObj._getColumnKeyIndex(data[kObj.model.keyField]);
                header.eq(cardKey).addClass("e-cardDroppedHeader");
            }
        }
        if (ej.isNullOrUndefined(args) || (!ej.isNullOrUndefined(args) && args.requestType != "drop")) {
            if (kObj.model.fields.priority) {
                var priorityData = [], currentData;
                if ($.isPlainObject(data)) {
                    priorityData.push(data);
                    if (ej.isNullOrUndefined(data[kObj.model.fields.priority])) {
                        currentData = new ej.DataManager(kbnCurrentData).executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, data[kObj.model.fields.primaryKey]));
                        if (currentData.length > 0)
                            data[kObj.model.fields.priority] = currentData[0][kObj.model.fields.priority];
                        else {
                            var colData = new ej.DataManager(kbnCurrentData).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, data[kObj.model.keyField]));
                            data[kObj.model.fields.priority] = colData[colData.length - 1][kObj.model.fields.priority] + 1;
                        }
                    }
                    data = kObj.KanbanCommon._updateKbnPriority(priorityData, data);
                }
                else {
                    var cData, fData, primary = kObj.model.fields.primaryKey;
                    for (var i = 0; i < data.length; i++) {
                        priorityData = $.extend(true, [], data);
                        if (ej.isNullOrUndefined(data[i][kObj.model.fields.priority])) {
                            currentData = new ej.DataManager(kbnCurrentData).executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, data[i][kObj.model.fields.primaryKey]));
                            if (currentData.length > 0)
                                data[i][kObj.model.fields.priority] = currentData[0][kObj.model.fields.priority];
                            else {
                                var colData = new ej.DataManager(kbnCurrentData).executeLocal(new ej.Query().where(kObj.model.keyField, ej.FilterOperators.equal, data[i][kObj.model.keyField]));
                                data[i][kObj.model.fields.priority] = colData[colData.length - 1][kObj.model.fields.priority] + 1;
                            }
                        }
                        cData = data[i];
                        fData = kObj.KanbanCommon._updateKbnPriority(priorityData, cData);
                        for (var j = 0; j < fData.length; j++) {
                            if (kObj._bulkPriorityData.length > 0) {
                                var cardIndex = $.map(kObj._bulkPriorityData, function (obj, index) {
                                    if (obj[primary] == fData[j][primary])
                                        return index;
                                });
                                if (!ej.isNullOrUndefined(cardIndex[0])) {
                                    kObj._bulkPriorityData.splice(cardIndex, 1);
                                    kObj._bulkPriorityData.splice(cardIndex, 0, fData[j]);
                                }
                                else
                                    kObj._bulkPriorityData.push(fData[j]);
                            }
                            else
                                kObj._bulkPriorityData.push(fData[j]);
                        }
                    }
                    data = kObj._bulkPriorityData;
                    kObj._bulkPriorityData = [];
                }
            }
        }
        var cData = [], addData = [], deleteData = [], editData = [];
        if (ej.isNullOrUndefined(data) && primaryKey)
            data = new ej.DataManager(kObj._currentJsonData).executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, primaryKey))[0];
        data = ej.isNullOrUndefined(data) ? null : data;
        if ($.isPlainObject(data))
            cData.push(data);
        else
            cData = data;
        if (kObj._isLocalData) {
            var queryManagar = kObj.model.query, cloned = queryManagar.clone();
            for (var i = 0; i < cData.length; i++) {
                var currentData, index;
                queryManagar = queryManagar.where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, cData[i][kObj.model.fields.primaryKey]);
                currentData = kObj._dataManager.executeLocal(queryManagar);
                if (!(kObj._dataSource() instanceof ej.DataManager))
                    index = $.inArray(currentData.result[0], kObj._dataSource());
                else
                    index = $.inArray(currentData.result[0], kObj._dataSource().dataSource.json);
                if (index >= 0) {
                    if (!(kObj._dataSource() instanceof ej.DataManager))
                        $.extend(kObj._dataSource()[index], cData[i]);
                    else
                        $.extend(kObj._dataSource().dataSource.json[index], cData[i]);
                }
                else {
                    var tmpRcrd = cData[i];
                    kObj._cAddedRecord = null;
                    (kObj._dataSource() instanceof ej.DataManager) ? kObj._dataSource().dataSource.json.push(tmpRcrd) : kObj._dataSource(undefined, true).splice(kObj._dataSource().length, 0, tmpRcrd);
                }
                queryManagar["queries"] = queryManagar["queries"].slice(queryManagar["queries"].length);
            }
            queryManagar["queries"] = cloned["queries"];
        }
        if (args.requestType != "drop")
            args.data = cData;
        kObj._saveArgs = args;
        if (kObj._dataManager instanceof ej.DataManager && !kObj._dataManager.dataSource.offline || (kObj._dataSource().adaptor instanceof ej.remoteSaveAdaptor)) {
            if (args.requestType == "delete")
                deleteData.push(args.data[0]);
            else {
                for (var i = 0; i < cData.length; i++) {
                    var tempCard = this._getKanbanCardData(kObj._currentJsonData, cData[i][kObj.model.fields.primaryKey]);
                    if (tempCard.length > 0)
                        editData.push(cData[i]);
                    else
                        addData.push(cData[i]);
                }
            }
            kObj.KanbanCommon._kbnBulkUpdate(addData, deleteData, editData);
        }
        else {
            kObj.KanbanCommon._processBindings(kObj._saveArgs);
            kObj._cModifiedData = null;
            kObj._cAddedRecord = null;
            kObj._isAddNewClick = false;
            kObj._currentData = null;
            kObj._newCard = null;
            kObj._saveArgs = null;
            kObj._cardEditClick = null;
            kObj._dblArgs = null;
        }
    };
    InternalCommon.prototype._getMetaColGroup = function () {
        var $colgroup = ej.buildTag("colgroup", "", {}, {}), kObj = this.kanbanObj;
        for (var i = 0; i < kObj.model.columns.length; i++) {
            var $col = $(document.createElement("col"));
            if (kObj.model.allowToggleColumn)
                kObj.model.columns[i]["isCollapsed"] === true && $col.addClass("e-shrinkcol");
            kObj.model.columns[i]["visible"] === false && $col.addClass("e-hide");
            $colgroup.append($col);
        }
        return $colgroup;
    };
    InternalCommon.prototype._kanbanToolbarClick = function (sender, kObj) {
        var $searchIcon;
        var currentTarget = sender.currentTarget;
        var target = sender.target;
        if ($(currentTarget).hasClass("e-quickfilter"))
            return false;
        if (kObj.KanbanFilter && target.tagName == 'INPUT' && $(target).parent().next().hasClass("e-cancel") && $(target).val().length == 0)
            kObj.KanbanFilter.searchCards("");
        if (kObj.model.isResponsive && kObj.element.hasClass('e-responsive')) {
            $(kObj["itemsContainer"]).parent().children().not('.e-searchbar').hide();
            if (sender.keyCode == 8) {
                kObj.KanbanAdaptive._kbnTimeoutSearch(kObj.element, sender);
            }
        }
        if (sender.event == undefined)
            return false;
        var filterName = $(currentTarget).text();
        for (var count = 0; count < kObj.model.filterSettings.length; count++) {
            if (kObj.model.filterSettings[count]["text"] == filterName)
                break;
        }
        var filterValue = (count == kObj.model.filterSettings.length ? null : kObj.model.filterSettings[count]);
        var args = { itemName: $(currentTarget).attr("data-content"), itemId: currentTarget.id, target: target, currentTarget: currentTarget, itemIndex: $(currentTarget).index(), toolbarData: sender, itemText: filterName, model: kObj.model, cancel: false, type: "toolbarClick" };
        if (kObj._trigger("toolbarClick", args))
            return false;
        if (args.itemId == kObj._id + "_toolbarItems" + "_search") {
            if (args.target.nodeName == "A") {
                if (kObj.model.allowSearching && kObj._searchBar != null && $(args.currentTarget).find("input").val().length != 0) {
                    if ($(target).is(kObj._searchBar.find(".e-searchfind"))) {
                        kObj.KanbanFilter.searchCards($(args.currentTarget).find("input").val());
                    }
                    else if ($(target).is(kObj._searchBar.find(".e-cancel"))) {
                        kObj.KanbanFilter.searchCards("");
                    }
                }
            }
            if (!kObj._isWatermark) {
                kObj._searchInput.blur(function () {
                    !kObj._searchInput.val() && kObj._hiddenSpan.css("display", "block");
                });
                kObj._hiddenSpan.css("display", "none");
            }
        }
        else if ($(args.currentTarget).hasClass("e-printlist"))
            kObj.print();
        else if (kObj.KanbanFilter && !$(currentTarget).parent().hasClass("e-customtoolbar"))
            kObj.KanbanFilter._filterHandler(filterValue, currentTarget);
        return false;
    };
    InternalCommon.prototype._kanbanSetModel = function (options, kObj) {
        for (var prop in options) {
            var $content;
            switch (prop) {
                case "columns":
                    var columns = options.columns;
                    kObj.model.columns = [];
                    kObj._keyValue = [];
                    kObj.columns(columns, "add");
                    break;
                case "cssClass":
                    kObj.element.removeClass(kObj.model.cssClass).addClass(options[prop]);
                    break;
                case "allowFiltering":
                case "filterSettings":
                    if (prop == "allowFiltering") {
                        kObj.model.allowFiltering = options[prop];
                        if (kObj.model.allowFiltering)
                            kObj.KanbanFilter = new ej.KanbanFeatures.Filter(kObj);
                        if (!kObj.model.allowSearching && kObj.model.filterSettings.length == 0 && !kObj.model.allowPrinting && kObj.model.customToolbarItems.length == 0)
                            kObj.KanbanFilter = null;
                    }
                    else {
                        if (prop == "filterSettings")
                            kObj.model.filterSettings = options[prop];
                        if (kObj.model.filterSettings.length > 0) {
                            kObj.element.find(".e-kanbantoolbar").remove();
                            kObj._filterCollection = [];
                            kObj._renderToolBar().insertBefore(kObj.element.find(".e-kanbanheader").first());
                            if (kObj.model.filterSettings.length > 0)
                                kObj.KanbanFilter = new ej.KanbanFeatures.Filter(kObj);
                        }
                        else {
                            kObj.element.find(".e-kanbantoolbar").remove();
                            kObj.model.filterSettings = [];
                            kObj._filterCollection = [];
                            kObj._renderToolBar().insertBefore(kObj.element.find(".e-kanbanheader").first());
                            if (!kObj.model.allowSearching && kObj.model.filterSettings.length == 0 && !kObj.model.allowPrinting && kObj.model.customToolbarItems.length == 0)
                                kObj.element.find(".e-kanbantoolbar").remove();
                            $(kObj.element.find(".e-kanbanheader")).replaceWith(kObj._renderHeader());
                            kObj.refresh();
                        }
                    }
                    break;
                case "allowSearching":
                    kObj.model.allowSearching = options[prop];
                    var selected = [];
                    if ((kObj.model.filterSettings.length != 0 || kObj.model.allowFiltering)) {
                        var selectedToolbar = kObj.element.find(".e-kanbantoolbar .e-tooltxt.e-select");
                        for (var i = 0; i < selectedToolbar.length; i++) {
                            selected.push(selectedToolbar.eq(i).index());
                        }
                    }
                    if (kObj.model.allowSearching) {
                        kObj.element.find(".e-kanbantoolbar").remove();
                        kObj.model.searchSettings.key = "";
                        kObj._renderToolBar().insertBefore(kObj.element.find(".e-kanbanheader").first());
                        for (var j = 0; j < selected.length; j++) {
                            kObj.element.find(".e-kanbantoolbar .e-tooltxt").eq(selected[j]).addClass("e-select");
                        }
                        if (kObj.model.allowSearching)
                            kObj.KanbanFilter = new ej.KanbanFeatures.Filter(kObj);
                    }
                    else {
                        kObj.KanbanFilter.clearSearch();
                        kObj.element.find(".e-kanbantoolbar").remove();
                        kObj._renderToolBar().insertBefore(kObj.element.find(".e-kanbanheader").first());
                        if (kObj.model.filterSettings.length == 0 && !kObj.model.allowPrinting && kObj.model.customToolbarItems.length == 0)
                            kObj.element.find(".e-kanbantoolbar").remove();
                        if ((kObj.model.filterSettings.length != 0 || kObj.model.allowFiltering)) {
                            for (var j = 0; j < selected.length; j++) {
                                kObj.element.find(".e-kanbantoolbar .e-tooltxt").eq(selected[j]).addClass("e-select");
                            }
                        }
                    }
                    kObj._on($("#" + kObj._id + "_searchbar"), "keyup", "", kObj._onToolbarClick);
                    break;
                case "enableTotalCount":
                    kObj.model.enableTotalCount = options[prop];
                    $(kObj.element.find(".e-kanbanheader")).replaceWith(kObj._renderHeader());
                    if (kObj.model.enableTotalCount)
                        this._totalCount();
                    kObj.refresh();
                    break;
                case "fields":
                    if (prop == "fields") {
                        $(kObj.element.find(".e-kanbanheader")).replaceWith(kObj._renderHeader());
                        if (kObj.model.allowSearching)
                            kObj.KanbanFilter.searchCards("");
                        if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && kObj.model.contextMenuSettings.enable)
                            kObj.KanbanContext._renderContext();
                        if (kObj.model.filterSettings.length > 0)
                            kObj.KanbanFilter.clearFilter();
                        if (kObj.model.filterSettings.length != 0)
                            $("#Kanban").find(".e-kanbantoolbar .e-tooltxt").removeClass("e-select");
                        kObj.getHeaderContent().replaceWith(kObj._renderHeader());
                        this._refreshDataSource(kObj._dataSource());
                        this._renderLimit();
                        if (kObj.model.enableTotalCount)
                            this._totalCount();
                        kObj.element.find(".e-kanbantoolbar").remove();
                        kObj._renderToolBar().insertBefore(kObj.element.find(".e-kanbanheader").first());
                        if (!kObj.model.allowSearching && kObj.model.filterSettings.length == 0 && !kObj.model.allowPrinting && kObj.model.customToolbarItems.length == 0)
                            kObj.element.find(".e-kanbantoolbar").remove();
                        if (kObj.model.fields && !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                            kObj.KanbanSwimlane = new ej.KanbanFeatures.Swimlane(kObj);
                        kObj._on($("#" + kObj._id + "_searchbar"), "keyup", "", kObj._onToolbarClick);
                    }
                    break;
                case "enableTouch":
                    kObj.model.enableTouch = options[prop];
                    if (!kObj.model.enableTouch) {
                        kObj._off(kObj.element, "doubletap", ".e-kanbancard");
                        if (kObj.model.editSettings.allowEditing)
                            kObj._on(kObj.element, ($.isFunction($.fn.doubletap) && kObj.model.enableTouch) ? "doubletap" : "dblclick", ".e-kanbancard", kObj._cardDblClickHandler);
                        if (kObj.KanbanAdaptive) {
                            kObj._off(kObj.element, "taphold", "", kObj.KanbanAdaptive._kbnHoldHandler);
                            kObj._off(kObj.element, "touchend", "", kObj.KanbanAdaptive._kbnTouchEndHandler);
                            kObj._off(kObj.element, "swipeleft swiperight", ".e-kanbancontent", $.proxy(kObj._swipeKanban, kObj));
                        }
                        kObj._on(kObj.element, ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._clickHandler);
                        kObj._on($('.e-swimlane-window,.e-kanbanfilter-window,.e-kanbantoolbar'), ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._kbnAdaptClickHandler);
                        kObj._on($('.e-kanban-editdiv'), ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._kbnAdaptEditClickHandler);
                    }
                    else {
                        kObj._off(kObj.element, "dblclick", ".e-kanbancard");
                        if (kObj.model.editSettings.allowEditing)
                            kObj._on(kObj.element, ($.isFunction($.fn.doubletap) && kObj.model.enableTouch) ? "doubletap" : "dblclick", ".e-kanbancard", kObj._cardDblClickHandler);
                        kObj._on(kObj.element, ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._clickHandler);
                        kObj._on($('.e-swimlane-window,.e-kanbanfilter-window,.e-kanbantoolbar'), ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._kbnAdaptClickHandler);
                        kObj._on($('.e-kanban-editdiv'), ($.isFunction($.fn.tap) && kObj.model.enableTouch) ? "tap" : "click", "", kObj._kbnAdaptEditClickHandler);
                        if (kObj.KanbanAdaptive) {
                            kObj._on(kObj.element, "taphold", "", kObj.KanbanAdaptive._kbnHoldHandler);
                            kObj._on(kObj.element, "touchend", "", kObj.KanbanAdaptive._kbnTouchEndHandler);
                            kObj._on(kObj.element, "swipeleft swiperight", ".e-kanbancontent", $.proxy(kObj._swipeKanban, kObj));
                        }
                    }
                    break;
                case "allowHover":
                    kObj.model.allowHover = options[prop];
                    kObj._enableCardHover();
                    break;
                case "enableRTL":
                    kObj.model.enableRTL = options[prop];
                    this._enableKanbanRTL();
                    kObj.refresh(true);
                    kObj.KanbanScroll._refreshScroller({ requestType: "refresh" });
                    this._renderLimit();
                    break;
                case "tooltipSettings":
                    $.extend(kObj.model.tooltipSettings, options[prop]);
                    if (!ej.isNullOrUndefined(kObj.model.tooltipSettings) && kObj.model.tooltipSettings.enable) {
                        kObj.element.find(".e-kanbantooltip").remove();
                        kObj.element.append($("<div class='e-kanbantooltip'></div>"));
                        kObj.element.find('.e-kanbantooltip').hide();
                        kObj._on(kObj.element, "mouseover", ".e-kanbancard", $.proxy(kObj._showToolTip, kObj));
                        kObj._on(kObj.element, "mouseout", ".e-kanbancard", $.proxy(kObj._hideToolTip, kObj));
                    }
                    else {
                        kObj._off(kObj.element, "mouseover", ".e-kanbancard");
                        kObj._off(kObj.element, "mouseout", ".e-kanbancard");
                    }
                    break;
                case "allowScrolling":
                case "scrollSettings":
                    $content = kObj.getContent();
                    kObj.model.allowScrolling = options[prop];
                    if (prop != "allowScrolling") {
                        if (!ej.isNullOrUndefined(options["scrollSettings"])) {
                            if ($.isEmptyObject(options["scrollSettings"]))
                                break;
                            $.extend(kObj.model.scrollSettings, options["scrollSettings"]);
                        }
                        if (!ej.isNullOrUndefined(options["allowScrolling"]))
                            kObj.model.allowScrolling = options["allowScrolling"];
                        !ej.isNullOrUndefined($content.data("ejScroller")) && $content.ejScroller("destroy");
                        if (kObj.model.allowScrolling) {
                            kObj.KanbanScroll = new ej.KanbanFeatures.Scroller(kObj);
                            kObj.getHeaderContent().find("div").first().addClass("e-headercontent");
                            kObj._originalScrollWidth = kObj.model.scrollSettings.width;
                            kObj.KanbanScroll._renderScroller();
                        }
                        else {
                            kObj.element.children(".e-kanbanheader").removeClass("e-scrollcss");
                            kObj.element.css("width", "auto");
                            kObj.element.removeClass("e-kanbanscroll");
                            kObj.element.find(".e-headercontent").removeClass("e-hscrollcss");
                        }
                        if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                            kObj._swimlaneRows = kObj.element.find('.e-swimlanerow');
                        if (!$.isEmptyObject(kObj._freezeSwimlaneRow) && kObj.KanbanSwimlane)
                            kObj.KanbanSwimlane._removeFreezeRow();
                    }
                    break;
                case "dataSource":
                    $content = kObj.element.find(".e-kanbancontent").first();
                    this._refreshDataSource(kObj._dataSource());
                    this._addLastRow();
                    break;
                case "swimlaneSettings":
                    if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                        $.extend(kObj.model.swimlaneSettings, options[prop]);
                        if (!ej.isNullOrUndefined(options[prop].showCount))
                            kObj.refresh(true);
                    }
                    break;
                case "editSettings":
                    $.extend(kObj.model.editSettings, options[prop]);
                    kObj.KanbanEdit._processEditing();
                    kObj._tdsOffsetWidth = [];
                    if (kObj.model.editSettings.allowEditing || kObj.model.editSettings.allowAdding) {
                        if (kObj.model.editSettings.editMode == "dialog" || kObj.model.editSettings.editMode == "dialogtemplate") {
                            $("#" + kObj._id + "_dialogEdit").data("ejDialog") && $("#" + kObj._id + "_dialogEdit").ejDialog("destroy");
                            $("#" + kObj._id + "_dialogEdit_wrapper,#" + kObj._id + "_dialogEdit").remove();
                            if (!ej.isNullOrUndefined($("#" + kObj._id + "_externalEdit")))
                                $("#" + kObj._id + "_externalEdit").remove();
                            kObj.element.append(kObj.KanbanEdit._renderDialog());
                        }
                        else if (kObj.model.editSettings.editMode == "externalform" || kObj.model.editSettings.editMode == "externalformtemplate") {
                            if (!ej.isNullOrUndefined(kObj.element.find(".e-kanbandialog")))
                                kObj.element.find(".e-kanbandialog").remove();
                            $("#" + kObj._id + "_externalEdit").remove();
                            kObj.element.append(kObj.KanbanEdit._renderExternalForm());
                        }
                        kObj._isEdit = false;
                    }
                    kObj._enableEditingEvents();
                    break;
                case "allowSelection":
                    if (options[prop]) {
                        kObj._off(kObj.element, "click");
                        kObj._on(kObj.element, "click", "", kObj._clickHandler);
                    }
                    break;
                case "query":
                    kObj.model.query = $.extend(true, {}, options[prop]);
                    break;
                case "stackedHeaderRows":
                    if (prop == "stackedHeaderRows")
                        kObj.model.stackedHeaderRows = options[prop];
                    if (kObj.model.stackedHeaderRows.length > 0) {
                        this._refreshStackedHeader();
                    }
                    else {
                        kObj.element.find(".e-stackedHeaderRow").remove();
                        kObj.model.stackedHeaderRows = [];
                    }
                    break;
                case "cardSettings":
                    if (!ej.isNullOrUndefined(options["cardSettings"])) {
                        $.extend(kObj.model.cardSettings, options["cardSettings"]);
                    }
                    kObj.element.find(".e-kanbancard").remove();
                    kObj.refreshTemplate();
                    kObj._renderAllCard();
                    kObj._enableDragandScroll();
                    break;
                case "allowToggleColumn":
                    kObj.model.allowToggleColumn = options[prop];
                    kObj.refreshTemplate();
                    kObj.getHeaderContent().replaceWith(kObj._renderHeader());
                    kObj.sendDataRenderingRequest({ requestType: "refresh" });
                    if (!kObj.model.allowToggleColumn)
                        kObj.element.find(".e-shrinkheader").not(".e-hide").addClass("e-hide");
                    if (kObj.model.enableTotalCount)
                        this._totalCount();
                    this._renderLimit();
                    break;
                case "locale":
                    kObj.model.locale = options[prop];
                    var model = kObj.model, element = kObj.element;
                    model.query["queries"] = model.query["queries"].slice(0, model.query["queries"].length - 1);
                    kObj.element.ejKanban("destroy").ejKanban(model);
                    kObj.element = element;
                    kObj.model = model;
                    if (kObj._collapsedCards.length != 0)
                        kObj.toggleCard(kObj._collapsedCards);
                    break;
            }
        }
    };
    InternalCommon.prototype._setWidthToColumns = function () {
        var kObj = this.kanbanObj, $cols1 = kObj.getContentTable().children("colgroup").find("col"), $cols2 = kObj.getHeaderTable().children("colgroup").find("col");
        var width = kObj._originalWidth - (kObj._collapsedColumns.length * 50);
        for (var i = 0; i < $cols2.length; i++) {
            if (!ej.isNullOrUndefined(kObj._columnsWidthCollection[i]) && !kObj.model.allowToggleColumn) {
                $cols1.eq(i).width(kObj._columnsWidthCollection[i]);
                $cols2.eq(i).width(kObj._columnsWidthCollection[i]);
            }
            else if (kObj.model.allowScrolling) {
                width = kObj.element.width() - (kObj._collapsedColumns.length * 50);
                if (kObj.headerTable.find('.e-shrinkcol').length == 0 && !ej.isNullOrUndefined(kObj._initialKanbanModel.columns[i].width) && ($.isNumeric(kObj._initialKanbanModel.scrollSettings.width) || $.isNumeric(kObj._initialKanbanModel.columns[i].width) || ((kObj._initialKanbanModel.scrollSettings.width.indexOf("%") > 0 || kObj._initialKanbanModel.scrollSettings.width == "auto") && kObj._initialKanbanModel.columns[i].width.indexOf("%") > 0))) {
                    $cols1.eq(i).width(kObj._initialKanbanModel.columns[i].width);
                    $cols2.eq(i).width(kObj._initialKanbanModel.columns[i].width);
                }
                else {
                    var colWidth = parseInt((width / kObj._expandedColumns.length).toFixed(2)), bSize = (parseInt(kObj.kanbanContent.find("table:first").css("border-spacing").split('px')[0]) * kObj.model.columns.length) + 18, cWidth = colWidth - bSize;
                    if (!kObj.model.columns[i].isCollapsed) {
                        $cols1.eq(i).css("width", cWidth + "px");
                        $cols2.eq(i).css("width", cWidth + "px");
                        kObj.model.columns[i].width = cWidth;
                    }
                    else
                        kObj._columnsWidthCollection[i] = parseInt((width / kObj.model.columns.length).toFixed(2)) - bSize;
                }
            }
        }
    };
    InternalCommon.prototype._getCardbyIndexes = function (indexes) {
        return $(this.kanbanObj.getRowByIndex(indexes[0][0]).find(".e-rowcell:eq(" + indexes[0][1][0] + ")").find("div.e-kanbancard:eq(" + indexes[0][2][0] + ")"));
    };
    InternalCommon.prototype._addLastRow = function () {
        var kObj = this.kanbanObj, lastRowtd = kObj.getContentTable().find("tr:last").find("td"), rowHeight = 0;
        if (kObj.model.allowScrolling && !ej.isNullOrUndefined(kObj.model.dataSource) && !ej.isNullOrUndefined(kObj._kanbanRows)) {
            for (var i = 0; i < kObj._kanbanRows.length; i++)
                rowHeight += $(kObj._kanbanRows[i]).height();
            if (rowHeight < kObj.getContent().height() - 1)
                lastRowtd.addClass("e-lastrowcell");
        }
    };
    InternalCommon.prototype._refreshDataSource = function (dataSource) {
        var kObj = this.kanbanObj;
        if (dataSource instanceof ej.DataManager)
            kObj._dataManager = dataSource;
        else
            kObj._dataManager = new ej.DataManager(dataSource);
        kObj._isLocalData = (!(kObj._dataSource() instanceof ej.DataManager) || (kObj._dataManager.dataSource.offline || kObj._isRemoteSaveAdaptor));
        kObj.refresh(true);
    };
    InternalCommon.prototype._cardClick = function (target, parentDiv) {
        var args, data = null, queryManager;
        if (!ej.isNullOrUndefined(parentDiv.attr("id"))) {
            queryManager = new ej.DataManager(this.kanbanObj._currentJsonData);
            data = queryManager.executeLocal(new ej.Query().where(this.kanbanObj.model.fields.primaryKey, ej.FilterOperators.equal, parentDiv.attr('id')));
        }
        args = { target: target, currentCard: parentDiv, data: data };
        if (this.kanbanObj._trigger("cardClick", args))
            return;
    };
    InternalCommon.prototype._validateLimit = function (curColumn, $curHeaderCell, count) {
        var kObj = this.kanbanObj, key = this._multikeySeparation(curColumn.key), $cell = $($(kObj.element.find(".e-columnrow")).find('td[ej-mappingkey="' + key + '"]')), totalcard;
        var isMin = !ej.isNullOrUndefined(curColumn.constraints.min), isMax = !ej.isNullOrUndefined(curColumn.constraints.max), isSwimlane = !ej.isNullOrUndefined(kObj.model.fields.swimlaneKey) && count == 0;
        if (curColumn.constraints.type == "column") {
            totalcard = $cell.find(".e-kanbancard").length;
        }
        else {
            totalcard = $($cell[count]).find(".e-kanbancard").length;
            $cell = $($cell[count]);
        }
        if (isMin)
            if (curColumn.constraints.min > totalcard) {
                $cell.addClass("e-deceed");
                if (isSwimlane)
                    $($curHeaderCell).addClass("e-deceed");
            }
            else {
                $cell.removeClass("e-deceed");
                if (isSwimlane)
                    $($curHeaderCell).removeClass("e-deceed");
            }
        if (isMax)
            if (curColumn.constraints.max < totalcard) {
                $cell.addClass("e-exceed");
                if (isSwimlane)
                    $($curHeaderCell).addClass("e-exceed");
            }
            else {
                $cell.removeClass("e-exceed");
                if (isSwimlane)
                    $($curHeaderCell).removeClass("e-exceed");
            }
        $cell.find(".e-limits").addClass("e-hide");
        if (!curColumn.isCollapsed)
            $($curHeaderCell).find(".e-limits").removeClass("e-hide");
    };
    InternalCommon.prototype._totalCount = function () {
        var kObj = this.kanbanObj;
        for (var i = 0; i < kObj.model.columns.length; i++) {
            var column = kObj.model.columns[i];
            if (kObj.model.enableTotalCount) {
                var total = kObj.getHeaderContent().find("span.e-totalcount")[i];
                var key = this._multikeySeparation(column.key);
                var $columnrow = $($(kObj.element.find(".e-columnrow")).find('td[ej-mappingkey="' + key + '"]'));
                var totalcard = $columnrow.find(".e-kanbancard").length;
                $(total).text(totalcard);
            }
        }
    };
    InternalCommon.prototype._multikeySeparation = function (key) {
        var columnKey = typeof (key) == "object" ? key : key.split(","), key = "", length = columnKey.length;
        if (length == 1)
            key = columnKey[0];
        else
            for (var j = 0; j < length; j++) {
                key = key + columnKey[j];
                if (j != length - 1)
                    key += ",";
            }
        return key;
    };
    InternalCommon.prototype._renderLimit = function () {
        var kObj = this.kanbanObj, $headerCell = {};
        for (var i = 0; i < kObj.model.columns.length; i++) {
            var column = kObj.model.columns[i];
            if (!ej.isNullOrUndefined(column.constraints)) {
                var isMin = !ej.isNullOrUndefined(column.constraints['min']), isMax = !ej.isNullOrUndefined(column.constraints['max']);
                if (isMin || isMax)
                    $headerCell = kObj.getHeaderContent().find(".e-columnheader").not(".e-stackedHeaderRow").find(".e-headercell")[i];
                var columnKey = typeof (column.key) == "object" ? column.key : column.key.split(","), key = kObj.KanbanCommon._multikeySeparation(columnKey);
                var $cell = $($(kObj.element.find(".e-columnrow")).find('td[ej-mappingkey="' + key + '"]')), k = 0;
                if (ej.isNullOrUndefined(column.constraints.type))
                    column.constraints.type = "column";
                switch (column.constraints.type) {
                    case "column":
                        this._validateLimit(column, $headerCell, k);
                        break;
                    case "swimlane":
                        for (k = 0; k < $cell.length; k++) {
                            this._validateLimit(column, $headerCell, k);
                            if (!kObj.getHeaderContent().find(".e-headercell").eq(i).hasClass("e-shrinkcol"))
                                $cell.eq(k).find(".e-limits").removeClass("e-hide");
                        }
                        if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey))
                            $($headerCell).find(".e-limits").addClass("e-hide");
                        break;
                }
            }
        }
    };
    InternalCommon.prototype._showhide = function (shcolumns, val) {
        var kObj = this.kanbanObj, i, count = 0, hideshowCols, columns = kObj.model.columns;
        hideshowCols = (val === "show") ? "_visibleColumns" : "_hiddenColumns";
        var $head = kObj.getHeaderTable().find("thead");
        var $headerCell = $head.find("tr").not(".e-stackedHeaderRow").find(".e-headercell");
        var $col = kObj.getHeaderTable().find("colgroup").find("col"), column;
        var $content_col = kObj.getContentTable().find("colgroup").find("col");
        var columnrow = kObj._columnRows;
        for (i = 0; i < columns.length; i++) {
            if ($.inArray(columns[i]["headerText"], kObj[hideshowCols]) != -1) {
                if (val === "show")
                    columns[i].visible = true;
                else
                    columns[i].visible = false;
                count++;
            }
            column = kObj.getColumnByHeaderText(shcolumns[i]);
            var index = $.inArray(column, kObj.model.columns);
            if (index != -1) {
                if (val == "show") {
                    $headerCell.eq(index).removeClass("e-hide");
                    $col.eq(index).css("display", "");
                }
                else {
                    $headerCell.eq(index).addClass("e-hide");
                    $col.eq(index).css("display", "none");
                }
            }
        }
        for (i = 0; i < columns.length; i++) {
            for (var j = 0; j < columnrow.length; j++) {
                if (!ej.isNullOrUndefined(kObj.model.fields.swimlaneKey)) {
                    if ($(columnrow[j]).is(":visible"))
                        columnrow.eq(j).prev().find(".e-rowcell").attr("colspan", kObj.getVisibleColumnNames().length);
                    else {
                        columnrow.eq(j).prev().prev(".e-swimlanerow").find(".e-rowcell").attr("colspan", kObj.getVisibleColumnNames().length);
                        if (!columns[i].visible)
                            columnrow.eq(j).prev(".e-collapsedrow").find("td.e-rowcell").eq(i).addClass("e-hide");
                        else
                            columnrow.eq(j).prev(".e-collapsedrow").find("td.e-rowcell").eq(i).removeClass("e-hide");
                    }
                }
                var colval = columnrow.eq(j).find("td.e-rowcell[ej-mappingkey='" + kObj.model.columns[i].key + "']");
                if (!columns[i].visible) {
                    colval.addClass("e-hide");
                    $content_col.eq(i).addClass("e-hide");
                }
                else {
                    colval.removeClass("e-hide");
                    $content_col.eq(i).removeClass("e-hide");
                }
            }
        }
        var $header = kObj.element.find(".e-kanbanheader");
        kObj._columnsWidthCollection = [];
        for (var columnCount = 0; columnCount < kObj.model.columns.length; columnCount++)
            if (!ej.isNullOrUndefined(kObj.model.columns[columnCount]["width"])) {
                kObj._columnsWidthCollection.push(kObj.model.columns[columnCount]["width"]);
            }
        kObj.element[0].replaceChild(kObj._renderHeader()[0], $header[0]);
        kObj.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
        this._setWidthToColumns();
        kObj.KanbanScroll && kObj.KanbanScroll._refreshScroller({ requestType: "refresh" });
    };
    InternalCommon.prototype._showExpandColumns = function (key, c, hidden, visible) {
        var kObj = this.kanbanObj;
        if (ej.isNullOrUndefined(key))
            return;
        if (key != null) {
            if ($.isArray(c)) {
                for (var i = 0; i < c.length; i++) {
                    var ckey = kObj.getColumnByHeaderText(c[i]);
                    c[i] = ckey != null ? ckey.headerText : c[i];
                }
            }
            else
                c = key.headerText;
        }
        if ($.isArray(c)) {
            for (i = 0; i < c.length; i++) {
                var index = $.inArray(c[i], kObj[hidden]);
                if (index != -1) {
                    kObj[hidden].splice(index, 1);
                    kObj[visible].push(c[i]);
                }
                else if (index == -1 && $.inArray(c[i], kObj[visible]) == -1 && !ej.isNullOrUndefined(kObj.getColumnByHeaderText(c[i]))) {
                    kObj[visible].push(kObj.getColumnByHeaderText(c[i]).key) && kObj[visible].push(c[i]);
                    kObj[hidden].splice($.inArray(kObj.getColumnByHeaderText(c[i]).key, kObj[hidden]), 1) && kObj[hidden].splice($.inArray(c[i], kObj[hidden]), 1);
                }
            }
        }
        else {
            index = $.inArray(c, kObj[hidden]);
            if (index != -1) {
                kObj[hidden].splice(index, 1);
                kObj[visible].push(c);
            }
            else if (index == -1 && $.inArray(c, kObj[visible]) == -1 && !ej.isNullOrUndefined(kObj.getColumnByHeaderText(c))) {
                kObj[visible].push(kObj.getColumnByHeaderText(c).key) && kObj[visible].push(c);
                kObj[hidden].splice($.inArray(kObj.getColumnByHeaderText(c).key, kObj[hidden]), 1) && kObj[hidden].splice($.inArray(c, kObj[hidden]), 1);
            }
        }
    };
    InternalCommon.prototype._expandColumns = function (c) {
        var key, hidden = "_collapsedColumns", visible = "_expandedColumns", kObj = this.kanbanObj;
        key = typeof (c) == "string" ? kObj.getColumnByHeaderText(c) : kObj.getColumnByHeaderText(c[0]);
        this._showExpandColumns(key, c, hidden, visible);
        this._expandCollapse(kObj[visible], "expand");
        if (kObj.model.allowScrolling)
            this._setWidthToColumns();
        if (kObj.model.stackedHeaderRows.length > 0) {
            this._refreshStackedHeader();
        }
    };
    InternalCommon.prototype._toggleField = function (c) {
        var index, i, kObj = this.kanbanObj;
        if (kObj.model.allowToggleColumn) {
            if ($.isArray(c)) {
                for (i = 0; i < c.length; i++) {
                    index = $.inArray(c[i], kObj._collapsedColumns);
                    if (index != -1)
                        this._expandColumns(c[i]);
                    else
                        this._collapseColumns(c[i]);
                }
            }
            else if ($.inArray(c, kObj._collapsedColumns) != -1)
                this._expandColumns(c);
            else
                this._collapseColumns(c);
            if (kObj.model.allowScrolling) {
                var $cols1 = kObj.getContentTable().children("colgroup").find("col"), $cols2 = kObj.getHeaderTable().children("colgroup").find("col");
                var width = kObj._originalWidth - (kObj._collapsedColumns.length * 50);
                for (i = 0; i < $cols2.length; i++) {
                    var colWidth = parseInt((width / kObj._expandedColumns.length).toFixed(2)), bSize = parseInt((width / (kObj.model.scrollSettings["buttonSize"] || 18) / 100).toFixed(2)), cWidth = colWidth - bSize;
                    if (!kObj.model.columns[i].isCollapsed) {
                        $cols1.eq(i).css("width", cWidth + "px");
                        $cols2.eq(i).css("width", cWidth + "px");
                        kObj.model.columns[i].width = cWidth;
                    }
                }
            }
            kObj.KanbanScroll && kObj.KanbanScroll._refreshScroller({ requestType: "refresh" });
        }
    };
    InternalCommon.prototype._hideCollapseColumns = function (key, c, hidden, visible) {
        var i, index, kObj = this.kanbanObj;
        if (ej.isNullOrUndefined(key))
            return;
        if ($.isArray(c)) {
            for (i = 0; i < c.length; i++) {
                index = $.inArray(c[i], kObj[visible]);
                if (index != -1) {
                    kObj[hidden].push(c[i]);
                    kObj[visible].splice(index, 1);
                }
                else if (index == -1 && $.inArray(c[i], kObj[hidden]) == -1 && !ej.isNullOrUndefined(kObj.getColumnByHeaderText(c[i]))) {
                    kObj[hidden].push(kObj.getColumnByHeaderText(c[i]).key) && kObj[hidden].push(kObj.getColumnByHeaderText(c[i]).key);
                    kObj[visible].splice($.inArray(kObj.getColumnByHeaderText(c[i]).key, kObj[visible]), 1) && kObj[visible].splice($.inArray(c[i], kObj[visible]), 1);
                }
            }
        }
        else {
            index = $.inArray(c, kObj[visible]);
            if (index != -1) {
                kObj[hidden].push(c);
                kObj[visible].splice(index, 1);
            }
            else if (index == -1 && visible == visible && $.inArray(c, kObj[hidden]) == -1 && !ej.isNullOrUndefined(kObj.getColumnByHeaderText(c))) {
                kObj[hidden].push(kObj.getColumnByHeaderText(c).key) && kObj[hidden].push(kObj.getColumnByHeaderText(c).key);
                kObj[visible].splice($.inArray(kObj.getColumnByHeaderText(c).key, kObj[visible]), 1) && kObj[visible].splice($.inArray(c, kObj[visible]), 1);
            }
        }
    };
    InternalCommon.prototype._expandCollapse = function (shcolumns, val) {
        var kObj = this.kanbanObj, i, count = 0, hideshowCols, columns = kObj.model.columns;
        hideshowCols = (val === "expand") ? "_expandedColumns" : "_collapsedColumns";
        var $head = kObj.getHeaderTable().find("thead");
        var $headerCell = $head.find("tr").not(".e-stackedHeaderRow").find(".e-headercell");
        var $col = kObj.getHeaderTable().find("colgroup").find("col"), column, colval;
        var $col1 = kObj.getContentTable().find("colgroup").find("col");
        for (i = 0; i < columns.length; i++) {
            if ($.inArray(columns[i]["headerText"], kObj[hideshowCols]) != -1) {
                if (val === "expand") {
                    columns[i].isCollapsed = false;
                }
                else {
                    columns[i].isCollapsed = true;
                }
                count++;
            }
            column = kObj.getColumnByHeaderText(shcolumns[i]);
            var index = $.inArray(column, kObj.model.columns);
            var isExp = val == "expand" ? true : false;
            if (index != -1) {
                if (isExp) {
                    if ($col.eq(index).hasClass("e-shrinkcol")) {
                        $headerCell.eq(index).find(".e-headercelldiv,.e-totalcard,.e-limits").removeClass("e-hide");
                        $headerCell.eq(index).removeClass("e-shrinkcol");
                        $col.eq(index).removeClass("e-shrinkcol");
                        $col1.eq(index).removeClass("e-shrinkcol");
                        $headerCell.eq(index).find(".e-clcollapse").addClass("e-clexpand").removeClass("e-clcollapse");
                    }
                }
                else {
                    if (!$col.eq(index).hasClass("e-shrinkcol")) {
                        $headerCell.eq(index).find(".e-headercelldiv,.e-totalcard,.e-limits").addClass("e-hide");
                        $headerCell.eq(index).addClass("e-shrinkcol");
                        $col.eq(index).addClass("e-shrinkcol");
                        $col1.eq(index).addClass("e-shrinkcol");
                        $headerCell.eq(index).find(".e-clexpand").addClass("e-clcollapse").removeClass("e-clexpand");
                    }
                }
            }
            var cshrink = kObj.model.columns[i].isCollapsed;
            var j;
            if (isExp) {
                if (!cshrink)
                    for (j = 0; j < kObj._columnRows.length; j++) {
                        colval = kObj._columnRows.eq(j).find("td.e-rowcell").eq(i);
                        if (colval.hasClass("e-shrink")) {
                            colval.removeClass("e-shrink").find(".e-shrinkheader").addClass("e-hide").parent().find(".e-kanbancard").removeClass("e-hide");
                            if (kObj.element.hasClass('e-responsive') && colval.find('.e-cell-scrollcontent').length > 0)
                                colval.find('.e-cell-scrollcontent').removeClass("e-hide");
                            if (kObj.model.enableRTL)
                                colval.find(".e-shrinkheader").css({ 'position': '', 'top': '' });
                            colval.find(".e-customaddbutton").removeClass("e-hide");
                            colval.find(".e-limits").removeClass("e-hide");
                            colval.find(".e-shrinkcount").text(kObj._columnCardcount(kObj.currentViewData, kObj.model.columns[i].key, kObj.model.fields.swimlaneKey ? j : null, kObj));
                        }
                        else
                            break;
                    }
            }
            else {
                if (cshrink)
                    for (j = 0; j < kObj._columnRows.length; j++) {
                        colval = kObj._columnRows.eq(j).find("td.e-rowcell").eq(i);
                        if (!colval.hasClass("e-shrink")) {
                            colval.addClass("e-shrink").find(".e-shrinkheader").removeClass("e-hide").parent().find(".e-kanbancard").addClass("e-hide");
                            if (kObj._checkMultikey(colval))
                                colval.addClass("e-shrink").find(".e-shrinkheader").show();
                            if (kObj.element.hasClass('e-responsive') && colval.find('.e-cell-scrollcontent').length > 0)
                                colval.find('.e-cell-scrollcontent').addClass("e-hide");
                            var contentTop = colval.offset().top, sCountTop = colval.find('.e-shrinkcount').offset().top;
                            if (kObj.model.enableRTL && contentTop > sCountTop) {
                                var topVal = contentTop - sCountTop, sHeader = colval.find(".e-shrinkheader");
                                topVal = (sHeader.offset().top - (contentTop + kObj.element.offset().top)) + topVal;
                                sHeader.css({ 'position': 'relative', 'top': topVal - 6 });
                            }
                            colval.find(".e-customaddbutton").addClass("e-hide");
                            colval.find(".e-limits").addClass("e-hide");
                            colval.find(".e-shrinkcount").text(kObj._columnCardcount(kObj.currentViewData, kObj.model.columns[i].key, kObj.model.fields.swimlaneKey ? j : null, kObj));
                        }
                        else
                            break;
                    }
            }
        }
    };
    InternalCommon.prototype._collapseColumns = function (c) {
        var kObj = this.kanbanObj, i, index, key, hidden = "_collapsedColumns", visible = "_expandedColumns", count = 0;
        for (i = 0; i < c.length; i++) {
            index = $.inArray(c[i], kObj._expandedColumns);
            if (index != -1)
                count++;
        }
        if (!(kObj._expandedColumns.length == count) && !(kObj.getVisibleColumnNames().length - kObj._collapsedColumns.length == 1) && !(kObj.model.columns.length - kObj._collapsedColumns.length == 1)) {
            key = typeof (c) == "string" ? kObj.getColumnByHeaderText(c) : kObj.getColumnByHeaderText(c[0]);
            this._hideCollapseColumns(key, c, hidden, visible);
            this._expandCollapse(kObj[hidden], "collapse");
            if (kObj.model.allowScrolling)
                this._setWidthToColumns();
            if (kObj.model.stackedHeaderRows.length > 0)
                this._refreshStackedHeader();
        }
        else if (kObj._collapsedColumns.length > 0) {
            this._expandColumns(kObj._collapsedColumns[0]);
            this._collapseColumns(c);
        }
    };
    return InternalCommon;
}());
window.ej.createObject("ej.KanbanFeatures.Common", InternalCommon, window);
;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Kanban = (function (_super) {
    __extends(Kanban, _super);
    function Kanban(element, options) {
        _super.call(this);
        this.element = null;
        this.PluginName = "ejKanban";
        this.id = "null";
        this.validTags = ["div"];
        this.observables = ["dataSource"];
        this._tags = [
            {
                tag: "columns",
                attr: ["headerTemplate", "headerText", "key", "isCollapsed", "showAddButton", "visible", "constraints.type", "constraints.min", "constraints.max", "allowDrag", "allowDrop", "totalCount.text"]
            },
            {
                tag: "workflows",
                attr: ["key", "allowedTransitions"]
            },
            {
                tag: "stackedHeaderRows",
                attr: [
                    [
                        {
                            tag: "stackedHeaderColumns",
                            attr: ["headerText", "column"]
                        }
                    ]
                ]
            }, {
                tag: "contextMenuSettings",
                attr: [
                    "customMenuItems", "menuItems", "disableDefaultItems"
                ]
            },
            {
                tag: "filterSettings",
                attr: ["text", "query", "description"]
            },
            { tag: "editSettings.editItems", attr: ["field", "editType", "validationRules", "editParams", "defaultValue"] }
        ];
        this.localizedLabels = null;
        this.currentViewData = null;
        this.keyConfigs = {
            focus: "e",
            insertCard: "45",
            deleteCard: "46",
            editCard: "113",
            saveRequest: "13",
            cancelRequest: "27",
            firstCardSelection: "36",
            lastCardSelection: "35",
            upArrow: "38",
            downArrow: "40",
            rightArrow: "39",
            leftArrow: "37",
            swimlaneExpandAll: "ctrl+40",
            swimlaneCollapseAll: "ctrl+38",
            selectedSwimlaneExpand: "alt+40",
            selectedSwimlaneCollapse: "alt+38",
            selectedColumnCollapse: "ctrl+37",
            selectedColumnExpand: "ctrl+39",
            multiSelectionByUpArrow: "shift+38",
            multiSelectionByDownArrow: "shift+40",
            multiSelectionByLeftArrow: "shift+37",
            multiSelectionByRightArrow: "shift+39",
        };
        this.dataTypes = {
            dataSource: "data",
            query: "data",
            columns: "array",
            stackedHeaderRows: "array",
            contextMenuSettings: {
                disableDefaultItems: "array",
                menuItems: "array",
                customMenuItems: "array"
            },
            filterSettings: "array",
            editSettings: {
                editMode: "enum",
                editItems: "array"
            },
            searchSettings: {
                fields: "array"
            }
        };
        this.defaults = {
            dataSource: null,
            keyField: null,
            keySettings: null,
            allowTitle: false,
            cssClass: "",
            allowSelection: true,
            allowSearching: false,
            allowToggleColumn: false,
            enableTotalCount: false,
            enableTouch: true,
            selectionType: "single",
            allowKeyboardNavigation: false,
            allowDragAndDrop: true,
            allowHover: true,
            allowScrolling: false,
            allowPrinting: false,
            enableRTL: false,
            stackedHeaderRows: [],
            filterSettings: [],
            scrollSettings: {
                width: "auto",
                height: 0,
                allowFreezeSwimlane: false
            },
            swimlaneSettings: {
                showCount: true,
                allowDragAndDrop: false,
                unassignedGroup: {
                    enable: true,
                    keys: ["null", "undefined", ""]
                }
            },
            fields: {
                content: null,
                tag: null,
                color: null,
                imageUrl: null,
                swimlaneKey: null,
                primaryKey: null,
                priority: null
            },
            cardSettings: {
                colorMapping: {},
                template: null
            },
            columns: [],
            contextMenuSettings: {
                enable: false,
                menuItems: [
                    "Add Card", "Edit Card", "Delete Card", "Top of Row", "Bottom of Row", "Move Up", "Move Down", "Move Left", "Move Right", "Move to Swimlane", "Hide Column", "Visible Columns", "Print Card"], customMenuItems: []
            },
            customToolbarItems: [],
            editSettings: {
                editItems: [],
                allowEditing: false,
                allowAdding: false,
                dialogTemplate: null,
                externalFormTemplate: null,
                formPosition: "bottom"
            },
            searchSettings: {
                fields: [],
                key: "",
                operator: "contains",
                ignoreCase: true
            },
            tooltipSettings: {
                enable: false,
                template: null
            },
            minWidth: 0,
            isResponsive: false,
            locale: "en-US",
            query: null,
            create: null,
            actionBegin: null,
            actionComplete: null,
            actionFailure: null,
            load: null,
            destroy: null,
            beginEdit: null,
            endEdit: null,
            endAdd: null,
            endDelete: null,
            beforeCardSelect: null,
            cardSelect: null,
            toolbarClick: null,
            cardDoubleClick: null,
            cardDragStart: null,
            cardDrag: null,
            cardDragStop: null,
            cardDrop: null,
            contextClick: null,
            contextOpen: null,
            cardClick: null,
            beforePrint: null,
            cellClick: null,
            headerClick: null,
            dataBound: null,
            queryCellInfo: null,
        };
        this._dataSource = ej.util.valueFunction("dataSource");
        this._rootCSS = "e-kanban";
        this._requiresID = true;
        this._id = null;
        this.KanbanDragAndDrop = null;
        this.KanbanEdit = null;
        this.KanbanCommon = null;
        this.KanbanAdaptive = null;
        this.KanbanScroll = null;
        this.KanbanContext = null;
        this.KanbanSwimlane = null;
        this.KanbanSelection = null;
        this.KanbanFilter = null;
        this._currentJsonData = null;
        this._kanbanRows = null;
        this._columnRows = null;
        this._swimlaneRows = null;
        this._filterToolBar = null;
        this._filteredRecordsCount = 0;
        this._filteredRecords = null;
        this._contexttarget = null;
        this._editForm = null;
        this._newData = null;
        this._isAddNew = false;
        this._isRemoteSaveAdaptor = false;
        this._queryPromise = null;
        this._kanbanWidth = null;
        this.keyPredicates = null;
        this._cloneQuery = null;
        this._isLocalData = true;
        this._previousRowCellIndex = [];
        this.selectedRowCellIndexes = [];
        this._bulkUpdateData = [];
        this._bulkPriorityData = [];
        this._kbnFilterObject = [];
        this._kbnAdaptFilterObject = [];
        this._kbnFilterCollection = [];
        this._kbnAdaptDdlData = [];
        this._kbnAdaptDdlIndex = 0;
        this._kbnSwipeWidth = 0;
        this._kbnSwipeCount = 0;
        this._searchTout = null;
        this._cardSelect = null;
        this._kbnBrowserContext = null;
        this._kbnMouseX = null;
        this._kbnAutoFilterCheck = false;
        this._autoKbnSwipeLeft = false;
        this._autoKbnSwipeRight = false;
        this._kbnTransitionEnd = true;
        this._kbnDdlWindowResize = false;
        this._conmenu = null;
        this._rowIndexesColl = [];
        this.templates = {};
        this.initialRender = false;
        this._columnsWidthCollection = [];
        this._slTemplate = "";
        this._cardTemplate = "";
        this._tdsOffsetWidth = [];
        this._scrollObject = null;
        this._templateRefresh = false;
        this._action = "";
        this._hiddenColumns = [];
        this._visibleColumns = [];
        this._filterCollection = [];
        this.collapsedColumns = null;
        this._expandedColumns = null;
        this._headerColumnNames = null;
        this._isWatermark = null;
        this._searchInput = null;
        this._hiddenSpan = null;
        this._currentRowCellIndex = [];
        this._recordsCount = 0;
        this._dropinside = false;
        this._selectedCards = [];
        this._selectedCardData = [];
        this._tableBEle = null;
        this._saveArgs = null;
        this._cModifiedData = null;
        this._dropped = null;
        this._cAddedRecord = null;
        this._cDeleteData = null;
        this._isAddNewClick = false;
        this._isEdit = false;
        this._currentData = null;
        this._newCard = null;
        this._cardEditClick = null;
        this._collapsedCards = [];
        this._collapsedSwimlane = [];
        this._keyValue = [];
        this._dblArgs = null;
        this._freezeSwimlaneRow = {};
        this._freezeScrollTop = 0;
        this._freezeSlOrder = 0;
        this._originalWidth = null;
        this._originalScrollWidth = 0;
        this._collapsedColumns = [];
        this._enableMultiTouch = false;
        this._enableSwimlaneCount = true;
        this._kTouchBar = null;
        this._contextSwimlane = null;
        this._initialData = null;
        this._searchBar = null;
        this._originalScrollHeight = null;
        this._dataManager = null;
        this._priorityCollection = [];
        this._initialKanbanModel = [];
        this._kbnAdaptEditClickHandler = function (e) {
            if (this.element.hasClass('e-responsive')) {
                var $target = $(e.target);
                if ($target.attr('id') == this._id + "_Cancel" || $target.parent().attr("id") == this._id + "_closebutton")
                    this.KanbanEdit.cancelEdit();
                if ($target.attr('id') == this._id + "_Save")
                    this.KanbanEdit.endEdit();
            }
        };
        this._keyPressed = function (action, target, e, event) {
            var value = this.KanbanCommon._kanbanKeyPressed(action, target, e, event);
            return value;
        };
        this._freezeSwimlane = function (e) {
            this.KanbanSwimlane && this.KanbanSwimlane._freezeRow(e, this);
        };
        this.getCurrentJsonData = function () {
            return this._currentJsonData;
        };
        if (element) {
            this._id = element[0].id;
            if (!element["jquery"])
                element = $('#' + element);
            if (element.length) {
                return $(element).ejKanban(options).data(this.PluginName);
            }
        }
    }
    Kanban.prototype.getHeaderTable = function () {
        return this.headerTable;
    };
    Kanban.prototype.setHeaderTable = function (value) {
        this.headerTable = value;
    };
    Kanban.prototype.getColumnByHeaderText = function (headerText) {
        if (ej.isNullOrUndefined(headerText))
            return;
        var columns = this.model.columns;
        for (var i = 0; i < columns.length; i++) {
            if (columns[i]["headerText"] == headerText)
                break;
        }
        return i == columns.length ? null : columns[i];
    };
    Kanban.prototype._getColumnKeyIndex = function (key) {
        var columns = this.model.columns, columnKey;
        for (var i = 0; i < columns.length; i++) {
            columnKey = typeof (columns[i]["key"]) == "object" ? columns[i]["key"] : columns[i]["key"].split(",");
            for (var j = 0; j < columnKey.length; j++)
                if (columnKey[j] == key)
                    return i;
        }
        return i == columns.length ? null : columns[i];
    };
    Kanban.prototype._checkMultikey = function (columnTd) {
        var index = columnTd.index(), key;
        key = this.model.columns[index]["key"];
        key = typeof (key) == "object" ? key : key.split(",");
        if (key.length > 1)
            return true;
        else
            return false;
    };
    Kanban.prototype._destroy = function () {
        this.element.off();
        this.element.find(".e-kanbanheader").find(".e-headercontent")
            .add(this.getContent().find(".e-content")).off('scroll');
        if (!ej.isNullOrUndefined(this._filterToolBar))
            this._filterToolBar.ejToolbar("destroy");
        if (!ej.isNullOrUndefined(this._editForm)) {
            var formElement = this._editForm.find('.e-field'), $editElement, rteElement;
            for (var i = 0; i < formElement.length; i++) {
                $editElement = $(formElement[i]);
                if ($editElement.hasClass('e-ejinputtext'))
                    this.element.find('.e-ejinputtext').remove();
                if ($editElement.hasClass('e-kanbantextarea'))
                    this.element.find('.e-kanbantextarea').remove();
                if ($editElement.hasClass('e-dropdownlist'))
                    $editElement.ejDropDownList("destroy");
                if ($editElement.hasClass("e-numerictextbox"))
                    $editElement.ejNumericTextbox("destroy");
                rteElement = $editElement.parent('div').find("textarea.e-rte");
                if (rteElement.length) {
                    rteElement.ejRTE("destroy");
                    $editElement.parent().find('textarea').remove();
                }
            }
            $("#" + this._id + "_dialogEdit").ejDialog("destroy");
        }
        this.element.ejWaitingPopup("destroy");
        if (this.model.contextMenuSettings.enable) {
            $("#" + this._id + "_Context").ejMenu('destroy');
            $("#" + this._id + "_Context").remove();
        }
        this.element.children().remove();
        if (this.model.isResponsive)
            $(window).off("resize", $.proxy(this.kanbanWindowResize, this));
    };
    Kanban.prototype._menu = function (sender) {
        this.KanbanContext && this.KanbanContext._kanbanMenu(sender, this);
    };
    Kanban.prototype._setModel = function (options) {
        this.KanbanCommon._kanbanSetModel(options, this);
    };
    Kanban.prototype._onToolbarClick = function (sender) {
        var $kanbanEle = $(this["itemsContainer"]).closest(".e-kanban"), kObj = sender.type == "keyup" ? this : $kanbanEle.data("ejKanban");
        kObj["KanbanCommon"]._kanbanToolbarClick(sender, kObj);
    };
    Kanban.prototype._showToolTip = function (event) {
        var kObj = this;
        if (kObj.model.tooltipSettings.enable) {
            if ($(event.target).hasClass('e-kanbantooltip'))
                return;
            var data, queryManager, kTooltip = kObj.element.find('.e-kanbantooltip'), template = ej.isNullOrUndefined(kObj.model.tooltipSettings.template);
            if (template && !($(event.target).hasClass('e-tag') || $(event.target).hasClass('e-text') || $(event.target).closest('.e-primarykey').length > 0))
                return;
            if (template)
                kTooltip.html($(event.target).text()).removeClass("e-tooltiptemplate");
            else {
                kTooltip.addClass("e-tooltiptemplate");
                queryManager = new ej.DataManager(kObj._currentJsonData);
                data = queryManager.executeLocal(new ej.Query().where(kObj.model.fields.primaryKey, ej.FilterOperators.equal, $(event.currentTarget).attr("id")));
                kTooltip.html($(kObj.model.tooltipSettings.template).render(data[0]));
            }
            var xPos = !ej.isNullOrUndefined(event.originalEvent) ? event.pageX : event.originalEvent.clientX;
            var yPos = !ej.isNullOrUndefined(event.originalEvent) ? event.pageY : event.originalEvent.clientY;
            var tooltipdivelmt = $(kObj.element).find('.e-kanbantooltip');
            xPos = ((xPos + tooltipdivelmt.width()) < $(kObj.element).width()) ? (xPos) : (xPos - tooltipdivelmt.width());
            yPos = ((yPos + tooltipdivelmt.height()) < $(kObj.element).height()) ? (yPos) : (yPos - tooltipdivelmt.height());
            tooltipdivelmt.css("left", xPos);
            tooltipdivelmt.css("top", yPos);
            if (kObj.model.enableRTL == true)
                tooltipdivelmt.addClass("e-rtl");
            $(kObj.element).find('.e-kanbantooltip').show();
        }
    };
    Kanban.prototype._hideToolTip = function () {
        if (this.model.tooltipSettings.enable)
            this.element.find('.e-kanbantooltip').hide();
    };
    Kanban.prototype.showColumns = function (c) {
        var args = {}, key, hidden = "_hiddenColumns", visible = "_visibleColumns";
        key = typeof (c) == "string" ? this.getColumnByHeaderText(c) : this.getColumnByHeaderText(c[0]);
        this.KanbanCommon._showExpandColumns(key, c, hidden, visible);
        this.KanbanCommon._showhide(this[visible], "show");
        this.KanbanCommon._renderLimit();
        this.KanbanCommon._totalCount();
        if (this.model.stackedHeaderRows.length > 0) {
            this.KanbanCommon._refreshStackedHeader();
        }
    };
    Kanban.prototype.print = function (singleCard) {
        var args = {}, elementClone;
        args["requestType"] = "print";
        this._trigger("actionBegin", args);
        if (!ej.isNullOrUndefined(this.element.find("#" + this._id + "_externalEdit")))
            this.element.find("#" + this._id + "_externalEdit").css("display", "none");
        var elementClone = this.element.clone();
        elementClone.find(".e-kanbantouchbar").remove();
        if (this.model.allowScrolling) {
            var scrollWidth = this.model.scrollSettings.width, scrollHeight = this.model.scrollSettings.height;
            if (this.getScrollObject().isVScroll() || this.getScrollObject().isHScroll()) {
                var scrollContent = this.getContent().find('.e-content')[0];
                elementClone.find('.e-kanbancontent').height(scrollContent.scrollHeight);
                elementClone.find('.e-kanbancontent').ejScroller({ width: scrollContent.scrollWidth, height: scrollContent.scrollHeight });
                elementClone.width(scrollContent.scrollWidth);
            }
        }
        if (!ej.isNullOrUndefined(this.model.filterSettings) || this.model.allowSearching || this.model.allowPrinting || !ej.isNullOrUndefined(this.model.customToolbarItems))
            elementClone.find(".e-kanbantoolbar").remove();
        elementClone.find(".e-kanbancontent div:first").nextAll().remove();
        if (singleCard) {
            var singleCard, column, card;
            if (typeof singleCard == "string" || typeof singleCard == "number")
                singleCard = this.element.find('div.e-kanbancard[id=' + singleCard + ']');
            elementClone.find(".e-kanbanheader").remove();
            column = singleCard.parent().clone(), card = singleCard.clone();
            column.children().remove();
            elementClone.find('table[role="kanban"]').remove();
            elementClone.find(".e-kanbancontent").children().append(column.append(card));
            elementClone.css("border-style", "none");
            if (this.model.allowScrolling) {
                elementClone.css({ "width": "auto", "height": "auto" });
                elementClone.find(".e-kanbancontent").css({ "width": "auto", "height": "auto" });
            }
            else
                elementClone.find(".e-kanbancard").css("width", "30%");
        }
        var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no");
        args = { requestType: "print", element: elementClone };
        this._trigger("beforePrint", args);
        if (!ej.isNullOrUndefined(args["element"]))
            elementClone = args["element"];
        ej.print(elementClone, printWin);
        this._trigger("actionComplete", args);
    };
    Kanban.prototype._kbnAdaptClickHandler = function (e) {
        if (this.KanbanAdaptive)
            this.KanbanAdaptive._adaptiveKbnClick(e);
    };
    Kanban.prototype._kbnTouchEndHandler = function (e) {
        var clone = this.element.find('.e-draggedcard');
        if (clone.length > 0)
            clone.remove();
        this._cardSelect = 'null';
    };
    ;
    Kanban.prototype._kbnTouchClick = function (e) {
        if (this.model.selectionType == "multiple") {
            if (this._kTouchBar.is(':visible') && (!$(e.target).hasClass('e-cardselection') && $(e.target).parents('.e-cardselection').length <= 0 && !$(e.target).hasClass('e-cardtouch') && $(e.target).parents('.e-cardtouch').length <= 0) && !this._kTouchBar.find(".e-cardtouch").hasClass("e-spanclicked"))
                this._kTouchBar.hide();
        }
        if (e.type == 'touchstart')
            this._cardSelect = 'touch';
        if (this.model.allowSearching && !this.element.hasClass('e-responsive')) {
            var searchBar = this.element.find('.e-searchbar.e-ul');
            if (($(e.target).hasClass('e-searchitem') && $(e.target).hasClass('e-cancel')) || ($(e.target).parents('.e-searchdiv').length > 0 && $(e.target).parents('.e-searchbar').find('.e-cancel').length > 0))
                searchBar.addClass('e-highliht-kbnsearchbar');
            else if ($(e.target).hasClass('e-searchitem') && $(e.target).hasClass('e-searchfind'))
                searchBar.removeClass('e-highliht-kbnsearchbar');
        }
    };
    Kanban.prototype._kbnHoldHandler = function (e) {
        if (this.model.enableTouch && ($(e.target).hasClass('e-kanbancard') || $(e.target).parents('.e-kanbancard').length > 0) && (e.type == "taphold" && e.pointerType == "touch")) {
            this._cardSelect = 'hold';
            var target = $(e.target), clonedElement = null;
            if ($(e.target).parents('.e-kanbancard').length > 0)
                target = $(e.target).parents('.e-kanbancard');
            if (this.KanbanDragAndDrop) {
                clonedElement = this.KanbanDragAndDrop._createCardClone(clonedElement, target);
                clonedElement.css({ 'position': 'absolute', 'top': e.originalEvent.changedTouches[0].pageY, 'left': e.originalEvent.changedTouches[0].pageX });
                clonedElement.addClass('e-left-rotatecard');
            }
        }
    };
    Kanban.prototype._swipeKanban = function (e) {
        if (this.element.hasClass('e-responsive') && this._kbnTransitionEnd && this.element.find('.e-targetclone').length == 0) {
            switch (e.type) {
                case "swipeleft":
                    this.KanbanAdaptive._kbnLeftSwipe();
                    break;
                case "swiperight":
                    this.KanbanAdaptive._kbnRightSwipe();
                    break;
            }
        }
    };
    Kanban.prototype._wireEvents = function () {
        this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", "", this._clickHandler);
        this._on($("#" + this._id + "_searchbar"), "keyup", "", this._onToolbarClick);
        this._on($(document), 'click touchstart', "", this._kbnTouchClick);
        this._on(this.element, "taphold", "", this._kbnHoldHandler);
        this._on(this.element, "touchend", "", this._kbnTouchEndHandler);
        this._on(this.element, ($.isFunction($.fn.doubletap) && this.model.enableTouch) ? "doubletap" : "dblclick", ".e-kanbancard", this._cardDblClickHandler);
        if (this.KanbanAdaptive) {
            this._on(this.element, "swipeleft swiperight", ".e-kanbancontent", $.proxy(this._swipeKanban, this));
        }
        if (this.KanbanContext)
            this._on(this.element, "contextmenu", "", this.KanbanContext._kbnBrowserContextMenu);
        if (this.KanbanFilter)
            this._on($("#" + this._id + "_searchbar"), "keypress", "", this.KanbanFilter._onToolbarKeypress);
        if (this.KanbanEdit) {
            if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
                $(window).on("resize", $.proxy(this.kanbanWindowResize, this));
            this._enableEditingEvents();
        }
        this._enableCardHover();
        if (this.model.tooltipSettings.enable) {
            this._on(this.element, "mouseover", ".e-kanbancard", this._showToolTip);
            this._on(this.element, "mouseout", ".e-kanbancard", this._hideToolTip);
        }
        if (this.model.allowKeyboardNavigation) {
            this.element[0].tabIndex = this.element[0].tabIndex == -1 ? 0 : this.element[0].tabIndex;
            this.element[0].accessKey = (!ej.isNullOrUndefined(this.element[0].accessKey) && this.element[0].accessKey != "") ? this.element[0].accessKey : "e";
            this._on(this.element, "keyup", "", undefined);
        }
    };
    Kanban.prototype._enableEditingEvents = function () {
        if (this.model.editSettings.allowAdding)
            this._on(this.element, "dblclick doubletap", ".e-kanbancontent .e-columnrow .e-rowcell", this._cellDblClickHandler);
        else
            this._off(this.element, "dblclick doubletap", ".e-kanbancontent .e-columnrow .e-rowcell");
        if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding)
            this._on($("#" + this._id + "_dialogEdit"), "click keypress", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel", this._clickHandler);
        else
            this._off($("#" + this._id + "_dialogEdit"), "click", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel");
    };
    Kanban.prototype._cardDblClickHandler = function (args) {
        this._dblArgs = args;
        var cardDiv, pKey = this.model.fields.primaryKey, primaryKey, editingManager, queryManager = new ej.Query();
        cardDiv = ($(args.target).closest('.e-kanbancard'));
        primaryKey = cardDiv.attr('id');
        editingManager = new ej.DataManager(this._currentJsonData);
        queryManager = queryManager.where(pKey, ej.FilterOperators.equal, primaryKey);
        this._currentData = editingManager.executeLocal(queryManager);
        this._dblArgs.data = this._currentData[0];
        this._trigger("cardDoubleClick", this._dblArgs);
        if (!this._isEdit) {
            this._cardEditClick = true;
            if (!ej.isNullOrUndefined(this._cardEditClick) && this._cardEditClick) {
                if (this._dblArgs.cancel) {
                    this._cardEditClick = null;
                    return;
                }
            }
            if (this.model.editSettings.allowEditing)
                this.KanbanEdit.startEdit($(args.target).closest('.e-kanbancard'));
        }
    };
    Kanban.prototype._cellDblClickHandler = function (args) {
        if ($(args.target).hasClass('e-rowcell')) {
            this._isAddNewClick = true;
            this._newCard = $(args.target);
            this.KanbanEdit.addCard();
        }
    };
    Kanban.prototype._enableCardHover = function () {
        if (this.model.allowHover)
            this._on(this.element, "mouseenter mouseleave", ".e-columnrow .e-kanbancard", this._cardHover);
        else
            this._off(this.element, "mouseenter mouseleave", ".e-columnrow .e-kanbancard");
    };
    Kanban.prototype.refreshColumnConstraints = function () {
        this.KanbanCommon._renderLimit();
        if (this.KanbanSwimlane && this._enableSwimlaneCount)
            this.KanbanSwimlane._swimlaneLimit(args);
        this._enableSwimlaneCount = false;
    };
    Kanban.prototype.hideColumns = function (c) {
        var i, index, count = 0, args = {}, key, hidden = "_hiddenColumns", visible = "_visibleColumns";
        for (i = 0; i < this._visibleColumns.length; i++) {
            index = $.inArray(this._collapsedColumns[i], this._visibleColumns);
            if (index != -1)
                count++;
        }
        if (this._visibleColumns.length - 1 > count) {
            key = typeof (c) == "string" ? this.getColumnByHeaderText(c) : this.getColumnByHeaderText(c[0]);
            this.KanbanCommon._hideCollapseColumns(key, c, hidden, visible);
            this.KanbanCommon._showhide(this[hidden], "hide");
            if (this.model.stackedHeaderRows.length > 0)
                this.KanbanCommon._refreshStackedHeader();
        }
        else {
            if (this._visibleColumns.length == 1)
                return;
            else if (this._visibleColumns[0] == c)
                this.KanbanCommon._expandColumns(this._visibleColumns[1]);
            else
                this.KanbanCommon._expandColumns(this._visibleColumns[0]);
            this.hideColumns(c);
        }
        this.KanbanCommon._renderLimit();
        this.KanbanCommon._totalCount();
        this.KanbanCommon._stackedHeadervisible();
    };
    Kanban.prototype._cardHover = function (e) {
        var $target = $(e.target), $kanbanRows = $(this._kanbanRows), parentDiv = $($target).closest(".e-kanbancard");
        if (parentDiv.length <= 0)
            return false;
        if (this.model.allowHover) {
            if (e.type == "mouseenter") {
                if (!ej.isNullOrUndefined($kanbanRows))
                    parentDiv.index() != -1 && parentDiv.addClass("e-hover");
            }
            else
                $kanbanRows.find(".e-kanbancard").removeClass("e-hover");
        }
        return false;
    };
    Kanban.prototype.toggleCard = function ($target) {
        var $curCard;
        if (typeof $target == "string" || typeof $target == "number") {
            $curCard = this.element.find('div.e-kanbancard[id=' + $target + ']');
            this.KanbanCommon._toggleCardByTarget($($curCard).find(".e-cardheader .e-icon"));
        }
        else if (typeof $target == "object" && $target[0].nodeName != "DIV") {
            for (var i = 0; i < $target.length; i++) {
                $curCard = this.element.find('div.e-kanbancard[id=' + $target[i] + ']');
                this.KanbanCommon._toggleCardByTarget($($curCard).find(".e-cardheader .e-icon"));
            }
        }
        else
            this.KanbanCommon._toggleCardByTarget($target);
    };
    Kanban.prototype.toggleColumn = function ($target) {
        if (typeof $target === "string" || "object" && ($target[0].nodeName != "DIV" && $target[0].nodeName != "TD"))
            this.KanbanCommon._toggleField($target);
        else if ($target[0].nodeName == "TD")
            this.KanbanCommon._toggleField($target.closest(".e-shrink").find(".e-shrinkheader").text().split("[")[0]);
        else {
            var stackedHeaderCel, colHeader, headerCell, i, stackedHeaderColumns, cols = this.model.columns, cText;
            if (this.model.stackedHeaderRows.length)
                stackedHeaderColumns = this.model.stackedHeaderRows[0].stackedHeaderColumns;
            headerCell = $target.closest(".e-headercell").not(".e-stackedHeaderCell");
            colHeader = this.element.find(".e-columnheader").not(".e-stackedHeaderRow").find(".e-hide");
            if (headerCell.length > 0)
                this.KanbanCommon._toggleField(cols[headerCell.index()].headerText);
            else if ($target.closest(".e-shrink").find(".e-shrinkheader").length > 0) {
                for (i = 0; i < colHeader.length; i++) {
                    cText = $(colHeader[i]).find(".e-headerdiv").text().split('[')[0];
                    if (cText == $target.closest(".e-shrink").find(".e-shrinkheader").text().split("[")[0]) {
                        $(colHeader[i]).next().find(".e-clcollapse").addClass("e-clexpand");
                        $(colHeader[i]).next().find(".e-clexpand").removeClass("e-clcollapse");
                        this.KanbanCommon._toggleField(cText);
                    }
                }
            }
            else if ($target.closest(".e-stackedHeaderRow").length > 0) {
                stackedHeaderCel = $target.closest(".e-stackedHeaderCell");
                for (i = 0; i < stackedHeaderColumns.length; i++)
                    if (stackedHeaderColumns[i].headerText == $(stackedHeaderCel).text()) {
                        if (stackedHeaderCel.hasClass("e-collapse"))
                            this.element.find(".e-stackedHeaderCell").eq(i).removeClass("e-collapse");
                        else
                            this.element.find(".e-stackedHeaderCell").eq(i).addClass("e-collapse");
                        this.KanbanCommon._toggleField(stackedHeaderColumns[i].column.split(","));
                    }
            }
        }
        if (this.element.find(".e-targetdragclone").is(":visible")) {
            var nextEle = this.element.find(".e-targetdragclone").next(".e-kanbancard").eq(0);
            if (nextEle.length > 0)
                this.element.find(".e-targetdragclone").width(nextEle.width());
            else
                this.element.find(".e-targetdragclone").width("");
        }
        if (this.model.allowScrolling && this.model.allowToggleColumn) {
            this.KanbanCommon._setWidthToColumns();
            this.KanbanScroll._renderScroller();
        }
    };
    Kanban.prototype._clickevent = function (sender) {
        this.KanbanContext && this.KanbanContext._kanbanContextClick(sender, this);
    };
    Kanban.prototype._clickHandler = function (e) {
        var $target = $(e.target), parentDiv;
        var columnIndex = $target.hasClass("e-rowcell") ? $target.index() : $target.closest(".e-rowcell").index();
        var rowIndex = this.getIndexByRow($target.closest("tr.e-columnrow"));
        parentDiv = $target.closest('.e-kanbancard');
        if ($(e.target).hasClass("e-customaddbutton") || $(e.target).parents(".e-customaddbutton").length > 0) {
            this._isAddNewClick = true;
            this._newCard = $(e.target).parents('.e-rowcell');
            if (this.KanbanEdit)
                this.KanbanEdit.addCard();
        }
        if ($target.hasClass("e-cardexpand") || $target.hasClass("e-cardcollapse") || $target.hasClass("e-expandcollapse"))
            this.toggleCard($target);
        if (($target.closest(".e-clexpand").length || $target.closest(".e-clcollapse").length || $target.closest(".e-shrink").length || $target.closest(".e-stackedHeaderRow").length) && this.model.allowToggleColumn)
            this.toggleColumn($target);
        if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey) && ($target.hasClass("e-slexpandcollapse") || $target.hasClass("e-slexpand") || $target.hasClass("e-slcollapse")))
            this.KanbanSwimlane.toggle($target);
        if (this.model.allowSelection && this.KanbanSelection && parentDiv.length > 0 && $target.closest(".e-expandcollapse").length <= 0) {
            var parentIndex = $(parentDiv.parent()).children().eq(0).hasClass("e-limits") ? parentDiv.index() - 1 : parentDiv.index();
            if (this.model.selectionType == "single")
                this.KanbanSelection._cardSelection([[rowIndex, [columnIndex], [parentIndex]]], parentDiv, e);
            else if (this.model.selectionType == "multiple") {
                if (e.shiftKey || e.ctrlKey || this._enableMultiTouch) {
                    if (this._currentRowCellIndex.length == 0 || rowIndex == this._currentRowCellIndex[0][0])
                        this.KanbanSelection._cardSelection([[rowIndex, [columnIndex], [parentIndex]]], parentDiv, e);
                }
                else
                    this.KanbanSelection._cardSelection([[rowIndex, [columnIndex], [parentIndex]]], parentDiv, e);
            }
        }
        if (parentDiv.length > 0)
            this.KanbanCommon._cardClick($target, parentDiv);
        if ($target.attr('id') == this._id + "_Cancel" || $target.parent().attr("id") == this._id + "_closebutton")
            this.KanbanEdit.cancelEdit();
        if ($target.attr('id') == this._id + "_Save")
            this.KanbanEdit.endEdit();
        if ($target.hasClass("e-cardtouch")) {
            if (!$target.hasClass("e-spanclicked")) {
                $target.addClass("e-spanclicked");
                this._enableMultiTouch = true;
            }
            else {
                $target.removeClass("e-spanclicked");
                this._enableMultiTouch = false;
                this._kTouchBar.hide();
            }
        }
        this.KanbanCommon._kbnHeaderAndCellEvents($target);
    };
    Kanban.prototype.getRowByIndex = function (index) {
        if (!ej.isNullOrUndefined(index))
            return $((this._columnRows)[index]);
        return;
    };
    Kanban.prototype.getScrollObject = function () {
        if (this._scrollObject == null || ej.isNullOrUndefined(this._scrollObject.model))
            this._scrollObject = this.getContent().ejScroller("instance");
        return this._scrollObject;
    };
    Kanban.prototype.getIndexByRow = function ($tr) {
        return $(this._columnRows).index($tr);
    };
    Kanban.prototype._initialize = function () {
    };
    Kanban.prototype._initPrivateProperties = function () {
        this.currentViewData = null;
        this._filterCollection = [];
        this._collapsedColumns = [];
        this._expandedColumns = [];
        this._dataManager = this._dataSource() instanceof ej.DataManager ? this._dataSource() : this._dataSource() != null ? new ej.DataManager(this._dataSource()) : null;
        this._originalWidth = this.element.width();
        this._recordsCount = this._dataSource() !== null ? this._dataSource().length : 0;
        ej.Kanban.Locale["default"] = ej.Kanban.Locale["en-US"] = {
            EmptyCard: "No cards to display",
            SaveButton: "Save",
            CancelButton: "Cancel",
            EditFormTitle: "Details of ",
            AddFormTitle: "Add New Card",
            SwimlaneCaptionFormat: "- {{:count}}{{if count == 1 }} item {{else}} items {{/if}}",
            FilterSettings: "Filters:",
            FilterOfText: "of",
            Max: "Max",
            Min: "Min",
            Cards: "  Cards",
            ItemsCount: "Items Count :",
            Unassigned: "Unassigned",
            AddCard: "Add Card",
            EditCard: "Edit Card",
            DeleteCard: "Delete Card",
            TopofRow: "Top of Row",
            BottomofRow: "Bottom of Row",
            MoveUp: "Move Up",
            MoveDown: "Move Down",
            MoveLeft: "Move Left",
            MoveRight: "Move Right",
            MovetoSwimlane: "Move to Swimlane",
            HideColumn: "Hide Column",
            VisibleColumns: "Visible Columns",
            PrintCard: "Print Card",
            Search: "Search"
        };
        this.localizedLabels = this._getLocalizedLabels();
    };
    Kanban.prototype._init = function () {
        this._initPrivateProperties();
        this._initialKanbanModel = $.extend(true, {}, this.model);
        var args = { keyFiltering: true };
        this._trigger("load", args);
        this._keyFiltering = args.keyFiltering;
        if (ej.isNullOrUndefined(this.model.query) || !(this.model.query instanceof ej.Query))
            this.model.query = new ej.Query();
        this._initSubModules();
        this._initialize();
        if (this.model.columns.length == 0)
            return false;
        if (this.KanbanAdaptive)
            this.KanbanAdaptive._kbnAdaptSwimlaneData();
        this.element.removeClass("e-kanbanscroll");
        if (this.KanbanScroll)
            this.KanbanScroll._initScrolling();
        this._checkDataBinding();
    };
    Kanban.prototype._initSubModules = function () {
        var model = this.model;
        this.KanbanCommon = new ej.KanbanFeatures.Common(this);
        if (model.allowDragAndDrop)
            this.KanbanDragAndDrop = new ej.KanbanFeatures.DragAndDrop(this);
        if (model.editSettings.allowEditing || model.editSettings.allowAdding)
            this.KanbanEdit = new ej.KanbanFeatures.Edit(this);
        if (model.isResponsive)
            this.KanbanAdaptive = new ej.KanbanFeatures.Adaptive(this);
        if (model.isResponsive && model.minWidth > 0)
            model.allowScrolling = true;
        if (model.allowScrolling)
            this.KanbanScroll = new ej.KanbanFeatures.Scroller(this);
        if (model.contextMenuSettings.enable)
            this.KanbanContext = new ej.KanbanFeatures.Context(this);
        if (model.fields && !ej.isNullOrUndefined(model.fields.swimlaneKey))
            this.KanbanSwimlane = new ej.KanbanFeatures.Swimlane(this);
        if (model.allowSelection)
            this.KanbanSelection = new ej.KanbanFeatures.Selection(this);
        if (model.filterSettings.length > 0 || model.allowFiltering || model.customToolbarItems.length > 0 || model.allowPrinting || model.allowSearching)
            this.KanbanFilter = new ej.KanbanFeatures.Filter(this);
    };
    Kanban.prototype.kanbanWindowResize = function (e) {
        if (!this.KanbanAdaptive)
            return;
        if (this._kbnDdlWindowResize && ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
            e.stopImmediatePropagation();
        var toolbar = this.element.find('.e-kanbantoolbar'), curItem = this.model.fields.swimlaneKey, searchBar;
        if (this.model.isResponsive && (ej.isNullOrUndefined(this.model.minWidth) || this.model.minWidth == 0)) {
            var $filterWin = $('.e-kanbanfilter-window'), browResponsive = true;
            if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) <= 9)
                browResponsive = false;
            if (browResponsive) {
                if (window.matchMedia("(max-width: 801px)").matches || window.matchMedia("(max-device-width: 1200px)").matches) {
                    if (this.model.isResponsive && this.kanbanContent.hasClass('e-scroller'))
                        this.kanbanContent.data('ejScroller').destroy();
                    if (!this.element.hasClass('e-responsive')) {
                        this.element.addClass('e-responsive');
                        toolbar.css('display', 'table');
                        toolbar.find('.e-searchdiv').hide();
                        toolbar.find('.e-search').css({ 'border': 'none' });
                        if (!ej.isNullOrUndefined(curItem))
                            this.KanbanAdaptive._kbnAdaptSwimlaneDdl();
                        if (this.model.filterSettings.length > 0) {
                            this.KanbanAdaptive._kbnAdaptFilterWindow();
                            this._kbnFilterCollection = this._filterCollection.slice();
                        }
                        this._on($('.e-swimlane-window,.e-kanbanfilter-window,.e-kanbantoolbar'), ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", "", this._kbnAdaptClickHandler);
                    }
                    this.KanbanAdaptive._columnTimeoutAdapt();
                    if (!this.element.hasClass('e-swimlane-responsive')) {
                        var rowCell = this.element.find('.e-rowcell:visible');
                        for (var i = 0; i < rowCell.length; i++) {
                            if (rowCell.eq(i).height() + rowCell.eq(i).offset().top > $(window).height()) {
                                var cellScrollContent = rowCell.eq(i).find('.e-cell-scrollcontent');
                                if (cellScrollContent.length > 0) {
                                    cellScrollContent.ejScroller({ height: $(window).height() - (this.kanbanContent.offset().top + 2), buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
                                    rowCell.eq(i).find('.e-shrinkheader').prependTo(rowCell.eq(i));
                                }
                                else {
                                    cellScrollContent = ej.buildTag("div.e-cell-scrollcontent", "<div></div>");
                                    rowCell.eq(i).append(cellScrollContent);
                                    cellScrollContent.children().append(rowCell.eq(i).children(":not('.e-cell-scrollcontent')"));
                                    cellScrollContent.ejScroller({
                                        height: $(window).height() - (this.kanbanContent.offset().top + 2),
                                        thumbStart: $.proxy(this._kbnThumbStart, this),
                                        buttonSize: 0,
                                        scrollerSize: 9,
                                        enableTouchScroll: true,
                                        autoHide: true
                                    });
                                    rowCell.eq(i).find('.e-shrinkheader').prependTo(rowCell.eq(i));
                                }
                            }
                        }
                    }
                    searchBar = this.element.find('.e-searchbar');
                    if (searchBar.length > 0) {
                        if (searchBar.find('.e-ejinputtext').val().length > 0) {
                            var $target = searchBar.find('.e-searchitem');
                            $target.addClass('e-searchfind');
                            $target.prev().show();
                            searchBar.siblings().hide();
                            if (searchBar.find('.e-adapt-search').length == 0) {
                                var searchDiv = ej.buildTag('div.e-icon e-adapt-search e-searchfind', "", {}), cancelDiv;
                                cancelDiv = ej.buildTag('div.e-icon e-adapt-cancel e-cancel', "", {});
                                $target.siblings('.e-searchdiv').append(cancelDiv).prepend(searchDiv);
                            }
                            $target.parents('.e-search').css({ 'border': '' });
                            $target.parents('body').removeClass('e-kbnwindow-modal');
                            $target.parents('.e-kanbantoolbar').addClass('e-adaptive-search');
                            searchBar.find('.e-adapt-cancel').show();
                            $target.hide();
                        }
                    }
                    if (this.model.filterSettings.length > 0) {
                        var filters = this.element.find('.e-quickfilter').nextAll('.e-tooltxt');
                        for (var i = 0; i < filters.length; i++) {
                            if (filters.eq(i).hasClass('e-select')) {
                                var index = filters.index(filters.eq(i)), flIcon = this.element.find('.e-kanbanfilter-icon');
                                this._kbnAutoFilterCheck = true;
                                $filterWin.find('.e-filter-content span.e-chkbox-wrap').eq(index).click();
                                this._kbnAutoFilterCheck = false;
                                if (!flIcon.hasClass('e-kbnclearfl-icon'))
                                    flIcon.addClass('e-kbnclearfl-icon');
                                filters.eq(i).removeClass('e-select');
                            }
                        }
                    }
                    if (!ej.isNullOrUndefined(curItem))
                        this.kanbanContent.ejScroller({
                            height: $(window).height() - (this.headerContent.offset().top + this.headerContent.height() + 5),
                            scroll: $.proxy(this._freezeSwimlane, this),
                            thumbStart: $.proxy(this._kbnThumbStart, this),
                            buttonSize: 0,
                            scrollerSize: 9,
                            enableTouchScroll: true,
                            autoHide: true
                        });
                    if (!this.element.hasClass('e-swimlane-responsive')) {
                        var scrollEle = this.element.find('.e-rowcell .e-cell-scrollcontent:visible');
                        for (var i = 0; i < scrollEle.length; i++) {
                            var scrollObj = $(scrollEle[i]).data('ejScroller');
                            if (!ej.isNullOrUndefined(scrollObj))
                                scrollObj.refresh();
                        }
                    }
                    var kbnDialog = this.element.find('.e-kanbandialog'), slWindow = this.element.find('.e-swimlane-window');
                    if (kbnDialog.is(':visible') && this.KanbanAdaptive)
                        this.KanbanAdaptive._setAdaptEditWindowHeight();
                    if (!ej.isNullOrUndefined(curItem) && slWindow.is(':visible')) {
                        var slScroller = this.element.find('.e-slwindow-scrollcontent'), top = this.headerContent.offset().top;
                        slScroller.ejScroller({ height: $(window).height() - slScroller.offset().top, buttonSize: 0, scrollerSize: 9, enableTouchScroll: true, autoHide: true });
                        slScroller.data('ejScroller').refresh();
                        slWindow.css({ height: $(window).height() - top });
                    }
                    if (this.KanbanSwimlane)
                        this.KanbanSwimlane._removeFreezeRow();
                    if (this.model.allowSearching && ej.browserInfo().name == "webkit")
                        this.element.find('.e-searchitem').addClass('e-webkitadapt-search');
                }
                else {
                    if (this.KanbanAdaptive) {
                        var toolBar = $('#' + this._id + "_toolbarItems");
                        if (toolBar.parents('.e-kanban').length == 0) {
                            toolBar.removeClass('e-kbntoolbar-body').prependTo(this.element);
                            $('#' + this._id + "_slWindow").removeClass('e-kbnslwindow-body').appendTo(this.element);
                        }
                        this.KanbanAdaptive._removeKbnAdaptItems();
                        this.element.find('.e-webkitadapt-search').removeClass('e-webkitadapt-search');
                        if (this.model.allowScrolling) {
                            this.KanbanCommon._setWidthToColumns();
                            this.KanbanScroll._renderScroller();
                        }
                    }
                }
            }
            if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey) && this.kanbanContent.hasClass('e-scroller'))
                this.kanbanContent.data('ejScroller').refresh();
            this.KanbanAdaptive._setAdaptiveSwimlaneTop();
        }
        else {
            var width, height, winWidth, winHeight, elemHeight;
            this.model.scrollSettings.width = this._originalScrollWidth;
            this.element.outerWidth('100%');
            this.getContentTable().width('100%');
            this.getHeaderTable().width('100%');
            width = this.element.outerWidth();
            winWidth = $(window).width() - this.element.offset()['left'];
            winHeight = $(window).height() - this.element.offset()['top'];
            if (toolbar.length > 0)
                winHeight = winHeight - (toolbar.outerHeight() + 25);
            elemHeight = this.headerContent.outerHeight() + this.getContentTable().height();
            var isScroller = this.model.minWidth > width || winWidth <= width || winHeight <= elemHeight;
            if (this.KanbanAdaptive)
                this.KanbanAdaptive._renderResponsiveKanban(isScroller, elemHeight, width, winHeight, winWidth);
        }
    };
    Kanban.prototype._initKanbanRender = function () {
        var proxy = this;
        this._addInitTemplate();
        if (this.model.keySettings)
            $.extend(this.model.keyConfigs, this.model.keySettings);
        this._render();
        this._trigger("dataBound", {});
        if (this.model.contextMenuSettings.enable) {
            if (!this._dataManager.dataSource.offline) {
                var queryPromise = proxy._dataSource().executeQuery(this.model.query);
                queryPromise.done(ej.proxy(function (e) {
                    proxy._contextSwimlane = new ej.DataManager(e.result);
                    proxy.KanbanContext._renderContext();
                }));
            }
            else
                this.KanbanContext._renderContext();
        }
        if (this.KanbanEdit) {
            this.KanbanEdit._processEditing();
            if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate")
                this.element.append(this.KanbanEdit._renderDialog());
            else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                this.element.append(this.KanbanEdit._renderExternalForm());
        }
        if (this.KanbanAdaptive)
            this.KanbanAdaptive._setResponsiveHeightWidth();
        if (this.KanbanSelection)
            this.KanbanSelection._renderKanbanTouchBar();
        this._wireEvents();
        if (this.model.tooltipSettings.enable) {
            this.element.append($("<div class='e-kanbantooltip'></div>"));
            this.element.find('.e-kanbantooltip').hide();
        }
        this.initialRender = false;
    };
    Kanban.prototype._render = function () {
        this.element.addClass(this.model.cssClass + "e-widget");
        this._renderContent().insertAfter(this.element.children(".e-kanbanheader"));
        if (this.model.enableTotalCount)
            this.KanbanCommon._totalCount();
        this.KanbanCommon._renderLimit();
        this._enableDragandScroll();
        if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey))
            this._swimlaneRows = this.element.find('.e-swimlanerow');
        if (this.initialRender)
            this.KanbanCommon._addLastRow();
    };
    Kanban.prototype._renderHeader = function () {
        var $div = ej.buildTag('div.e-kanbanheader', "", {}, {}), $innerDiv = ej.buildTag('div', "", {}, {}), $colGroup = $(document.createElement('colgroup'));
        if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey))
            $div.addClass("e-slheader");
        if (this.model.allowScrolling)
            $innerDiv.addClass("e-headercontent");
        $div.append($innerDiv);
        var $table = ej.buildTag("table.e-table", "", {}, { cellspacing: "0.25px", role: "kanban" });
        var $thead = ej.buildTag("thead", "", {}, {}), $tbody = ej.buildTag("tbody.e-hide", "", {}, {});
        for (var index = 0; index < this.model.stackedHeaderRows.length; index++) {
            var $tr = this.KanbanCommon._createStackedRow(this.model.stackedHeaderRows[index]);
            $thead.append($tr);
        }
        var $columnHeader = ej.buildTag('tr.e-columnheader', "", {}, {}), $rowBody = $(document.createElement('tr'));
        var columns = this.model.columns;
        this._visibleColumns = [];
        this._expandedColumns = [];
        this._headerColumnNames = {};
        for (var columnCount = 0; columnCount < columns.length; columnCount++) {
            var column = columns[columnCount];
            var $headerCell = ej.buildTag('th.e-headercell', "", {}, { role: "columnheader" });
            var col = document.createElement('col'), bodyCell = document.createElement('td');
            var $headerCellDiv = ej.buildTag('div.e-headercelldiv', "", {}, {});
            var $headerDiv = ej.buildTag('div.e-headerdiv', column["headerText"] != null ? column["headerText"] : column["key"], {}, {});
            if (!ej.isNullOrUndefined(column["headerTemplate"]))
                $headerDiv.html($(column["headerTemplate"]).hide().html());
            var $totalCard, $totalCount, $limit = null;
            if (this.model.enableTotalCount) {
                $totalCard = ej.buildTag("div.e-totalcard", "", {}, {});
                $totalCount = ej.buildTag("span.e-totalcount", "", {}, {});
                if (!ej.isNullOrUndefined(column.totalCount) && !ej.isNullOrUndefined(column.totalCount.text))
                    $totalCard.append(column.totalCount.text + " : ").append($totalCount);
                else
                    $totalCard.append(this.localizedLabels.ItemsCount).append($totalCount);
                $headerCell.append($totalCard);
            }
            if (!ej.isNullOrUndefined(column.constraints)) {
                var isMin = !ej.isNullOrUndefined(column.constraints['min']), isMax = !ej.isNullOrUndefined(column.constraints['max']);
                $limit = ej.buildTag('div.e-limits', "", {}, {});
                if (isMin) {
                    var $min = ej.buildTag("div.e-min", this.localizedLabels.Min, "", {});
                    var $minLimit = ej.buildTag("span.e-minlimit", " " + column.constraints['min'].toString(), "", {});
                    $min.append($minLimit);
                    $limit.append($min);
                }
                if (isMax) {
                    var $max = ej.buildTag("div.e-max", this.localizedLabels.Max, "", {});
                    var $maxLimit = ej.buildTag("span.e-maxlimit", " " + column.constraints['max'].toString(), "", {});
                    $max.append($maxLimit);
                    if (isMin)
                        $limit.append("/");
                    $limit.append($max);
                }
                if (this.model.enableTotalCount && $limit.children().length > 0)
                    $limit.prepend("|");
            }
            $headerCellDiv.append($headerDiv);
            $headerCell.prepend($headerCellDiv);
            $headerCell.append($limit);
            if (this.model.allowToggleColumn) {
                if (columns[columnCount]["isCollapsed"] === true)
                    $headerCell.append(ej.buildTag('div.e-icon e-clcollapse', "", {}, {})).addClass("e-shrinkcol");
                else
                    $headerCell.append(ej.buildTag('div.e-icon e-clexpand', "", {}, {}));
            }
            if (columns[columnCount]["isCollapsed"] === true && this.model.allowToggleColumn) {
                $headerCell.find(".e-headercelldiv,.e-totalcard,.e-limits").addClass("e-hide") && $(col).addClass("e-shrinkcol");
                if ($.inArray(columns[columnCount].headerText, this._collapsedColumns) == -1)
                    this._collapsedColumns.push(columns[columnCount].headerText);
            }
            else {
                $headerCell.find(".e-headercelldiv,.e-totalcard").removeClass("e-hide") && $(col).removeClass("e-shrinkcol");
                if (!ej.isNullOrUndefined(columns[columnCount].constraints) && columns[columnCount].constraints.type == "column")
                    $headerCell.find(".e-limits").removeClass("e-hide");
                else
                    $headerCell.find(".e-limits").addClass("e-hide");
                this._expandedColumns.push(columns[columnCount].headerText);
                columns[columnCount]["isCollapsed"] = false;
            }
            $colGroup.append(col);
            $columnHeader.append($headerCell);
            $rowBody.append(bodyCell);
            if (column["visible"] === false) {
                $headerCell.addClass("e-hide") && $(col).css("display", "none");
                if ($.inArray(column.headerText, this._hiddenColumns) == -1)
                    this._hiddenColumns.push(column.headerText);
            }
            else {
                this._visibleColumns.push(column.headerText);
                column["visible"] = true;
            }
            var curLimits = $headerCell.find('.e-limits'), curTotal = $headerCell.find('.e-totalcard');
            if ($headerCell.find('.e-clexpand').length > 0 || columns[columnCount]["isCollapsed"]) {
                if (curTotal.length == 0 && curLimits.length == 0)
                    $headerCell.addClass('e-toggleonly');
                else if (curTotal.length == 0 && curLimits.children().length == 0)
                    $headerCell.addClass('e-toggleonly');
            }
            var curColumn;
            if ($headerCell.hasClass('e-toggleonly')) {
                for (var l = 0; l < this.model.columns.length; l++) {
                    curColumn = this.model.columns[l];
                    if (!ej.isNullOrUndefined(curColumn.constraints) && (!ej.isNullOrUndefined(curColumn.constraints['min']) || !ej.isNullOrUndefined(curColumn.constraints['max'])))
                        $headerCell.addClass('e-toggle-withoutcount');
                }
            }
            curColumn = this.model.columns[columnCount];
            if (this.model.enableTotalCount || (!ej.isNullOrUndefined(curColumn.constraints) && (!ej.isNullOrUndefined(curColumn.constraints['min']) || !ej.isNullOrUndefined(curColumn.constraints['max'])))) {
                $headerCell.addClass('e-toggle-withcount');
                $columnHeader.addClass('e-header-withcount');
            }
            if (ej.isNullOrUndefined(column["allowDrag"]) || column["allowDrag"] != false)
                column["allowDrag"] = true;
            if (ej.isNullOrUndefined(column["allowDrop"]) || column["allowDrop"] != false)
                column["allowDrop"] = true;
            if (!ej.isNullOrUndefined(column["headerTemplate"]))
                $headerCellDiv.parent().addClass("e-headertemplate");
            if (this.initialRender) {
                if (typeof (column.width) == "string" && column.width.indexOf("%") != -1)
                    this._columnsWidthCollection.push(parseInt(column["width"]) / 100 * this.element.width());
                else {
                    this._columnsWidthCollection.push(column["width"]);
                }
            }
        }
        $thead.append($columnHeader);
        $table.append($colGroup).append($thead);
        $tbody.append($rowBody);
        $table.append($tbody);
        $innerDiv.append($table);
        this.setHeaderContent($div);
        this.setHeaderTable($table);
        return $div;
    };
    Kanban.prototype._renderContent = function () {
        var $div = ej.buildTag('div.e-kanbancontent', "", {}, {}), $innderDiv = ej.buildTag('div', "", {}, {}), $tbody = ej.buildTag("tbody", "", {}, {});
        var $table = ej.buildTag('table.e-table', "", {}, { cellspacing: "0.25px", role: "kanban" });
        $table.append(this.getHeaderTable().find('colgroup').clone()).append($tbody);
        $innderDiv.append($table);
        $div.append($innderDiv);
        this.setContent($div);
        this.setContentTable($table);
        $table.attr("role", "kanban");
        var args = { requestType: "refresh" };
        this.sendDataRenderingRequest(args);
        return $div;
    };
    Kanban.prototype.refreshTemplate = function () {
        this._addInitTemplate();
        if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding)
            this.KanbanEdit._addDialogEditingTemplate();
    };
    Kanban.prototype.getContentTable = function () {
        return this.contentTable;
    };
    Kanban.prototype.setContentTable = function (value) {
        this.contentTable = value;
    };
    Kanban.prototype.getVisibleColumnNames = function () {
        return this._visibleColumns;
    };
    Kanban.prototype.getHeaderContent = function () {
        return this.headerContent;
    };
    Kanban.prototype.setHeaderContent = function (value) {
        this.headerContent = value;
    };
    Kanban.prototype.getContent = function () {
        return this.kanbanContent;
    };
    Kanban.prototype.setContent = function (value) {
        this.kanbanContent = value;
    };
    Kanban.prototype._initDataSource = function () {
        var proxy = this;
        this._isLocalData = (!(this._dataSource() instanceof ej.DataManager) || (this._dataSource().dataSource.offline));
        this._ensureDataSource();
        this._trigger("actionBegin");
        var queryPromise = this._dataSource().executeQuery(this.model.query);
        if (!this.element.is(":visible"))
            this.element.ejWaitingPopup("hide");
        queryPromise.done(ej.proxy(function (e) {
            proxy.element.ejWaitingPopup("hide");
            proxy._currentJsonData = proxy.currentViewData = e.result;
            if (e.count == 0 && e.result.length)
                proxy._recordsCount = e.result.length;
            else
                proxy._recordsCount = e.count;
            proxy._initKanbanRender();
        }));
    };
    Kanban.prototype.columns = function (details, keyValue, action) {
        if (ej.isNullOrUndefined(details))
            return;
        var isString = false;
        if (typeof details === "string") {
            details = [details];
            isString = true;
        }
        else if (details instanceof Array && details.length && typeof details[0] === "string")
            isString = true;
        for (var i = 0; i < details.length; i++) {
            var index = $.inArray(this.getColumnByHeaderText(isString ? details[i] : details[i]["headerText"]), this.model.columns);
            if (action == "add" || ej.isNullOrUndefined(action)) {
                if (index == -1)
                    this.model.columns.push(isString ? { headerText: details[i], key: keyValue } : details[i]);
                else
                    this.model.columns[index] = isString ? { headerText: details[i], key: keyValue } : details[i];
            }
            else {
                if (index != -1)
                    this.model.columns.splice(index, 1);
            }
        }
        var $header = this.element.find(".e-kanbanheader");
        this._columnsWidthCollection = [];
        for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++)
            if (!ej.isNullOrUndefined(this.model.columns[columnCount]["width"])) {
                this._columnsWidthCollection.push(this.model.columns[columnCount]["width"]);
            }
        if ($header.length == 0 && this.model.columns.length != 0)
            this._checkDataBinding();
        else if ($header.length != 0 && this.model.columns.length != 0) {
            this.element[0].replaceChild(this._renderHeader()[0], $header[0]);
            if (isString) {
                this._keyValue.push(keyValue);
                this.keyPredicates.push(new ej.Predicate(this.model.keyField, ej.FilterOperators.equal, keyValue, true));
            }
            else
                this._addColumnFilters();
            if (this.model.searchSettings.key.length == 0 && this._filterCollection.length == 0) {
                queryManagar = this.model.query;
                queryManagar.queries = [];
                queryManagar.where(ej.Predicate["or"](this.keyPredicates));
            }
            var args = { requestType: 'addcolumn' };
            this.refresh(true);
            this.KanbanScroll && this.KanbanScroll._refreshHeaderScroller();
            this.KanbanCommon._totalCount();
        }
        else if (this.model.columns.length == 0) {
            this.model.query.queries = [];
            this.element.children().remove();
        }
    };
    Kanban.prototype._checkDataBinding = function () {
        if (!this.model.columns.length && (((this._dataSource() == null || !this._dataSource().length) && !(this._dataSource() instanceof ej.DataManager)) || ((this._dataSource() instanceof ej.DataManager) && this._dataManager.dataSource.url == undefined && !this._dataSource().dataSource.json.length))) {
            return;
        }
        if (!ej.isNullOrUndefined(this.model.keyField))
            this._addColumnFilters();
        this.initialRender = true;
        if (this.model.cssClass != null)
            this.element.addClass(this.model.cssClass);
        if (this.model.filterSettings.length > 0 || this.model.allowSearching || this.model.customToolbarItems.length > 0 || this.model.allowPrinting)
            this.element.append(this._renderToolBar());
        var columns = this.model.columns;
        if (columns && columns.length) {
            this.element.append(this._renderHeader());
            this.KanbanCommon._stackedHeadervisible();
        }
        if ($.isFunction($.fn.ejWaitingPopup)) {
            this.element.ejWaitingPopup({ showOnInit: false });
            $("#" + this._id + "_WaitingPopup").addClass("e-kanbanwaitingpopup");
        }
        if (this._dataSource() instanceof ej.DataManager) {
            this.element.ejWaitingPopup("show");
            if (this._dataSource().ready != undefined) {
                var proxy = this;
                this._dataSource().ready.done(function (args) {
                    proxy._initDataSource();
                    proxy.model.dataSource = new ej.DataManager(args.result);
                });
            }
            else {
                this.element.ejWaitingPopup("show");
                this._initDataSource();
            }
        }
        else {
            this._trigger("actionBegin");
            this._ensureDataSource();
            this._initKanbanRender();
            this.KanbanCommon._enableKanbanRTL();
        }
    };
    Kanban.prototype._renderToolBar = function () {
        var $div = ej.buildTag('div.e-kanbantoolbar', "", {}, { id: this._id + "_toolbarItems" });
        if (this.model.allowSearching) {
            this._isWatermark = 'placeholder' in document.createElement('input');
            var $searchUl = ej.buildTag("ul.e-searchbar", "", {}, {});
            var $li = ej.buildTag("li.e-search", "", {}, { id: this._id + "_toolbarItems_search" });
            var $a = ej.buildTag("a.e-searchitem e-toolbaricons e-disabletool e-icon e-searchfind", "", { 'float': 'right' }, {});
            if (ej.browserInfo().name == "msie")
                $a.css("position", "absolute");
            var $input = ej.buildTag("input.e-ejinputtext e-input", "", {}, { type: "text", id: this._id + "_searchbar", placeholder: this.localizedLabels.Search, 'height': '33px' });
            var $searchDiv = ej.buildTag('div.e-searchdiv', "", { 'display': 'inline-table', 'width': '83%' }, {});
            $searchDiv.append($input);
            $li.append($searchDiv);
            $li.append($a);
            $searchUl.append($li);
            this._searchInput = $input;
            if (!ej.isNullOrUndefined(this.model.searchSettings.key))
                this._searchInput.val(this.model.searchSettings.key);
            this._searchBar = $li;
            if (!this._isWatermark)
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder", "Search", { display: "block" }, {}).insertAfter(this._searchInput);
        }
        if (!ej.isNullOrUndefined(this.model.customToolbarItems)) {
            var $customUl = ej.buildTag("ul.e-customtoolbar");
            if (this.model.filterSettings.length > 0) {
                $customUl.addClass("e-customtoolbarseparator");
            }
            (!ej.isNullOrUndefined(this.model.customToolbarItems) && this.model.customToolbarItems.length) && this._renderCustomLi($customUl);
            $div.append($customUl);
        }
        if (this.model.filterSettings.length > 0) {
            var $filterUl = ej.buildTag("ul", "", {}, {});
            var li = ej.buildTag("li", "", {}, { "class": "e-quickfilter", "tabindex": "0" });
            li.append("<label class='e-toolbartext e-text'>" + this.localizedLabels.FilterSettings + "</label>");
            $filterUl.append(li);
        }
        for (var i = 0; i < this.model.filterSettings.length; i++) {
            var desc = this.model.filterSettings[i].description;
            var $li = ej.buildTag("li", "", {}, { id: this._id + "_" + this.model.filterSettings[i].text, title: ej.isNullOrUndefined(desc) ? this.model.filterSettings[i].text : desc, "tabindex": "0", "class": "e-kbnfilter-tbtn" });
            var $item = ej.buildTag("a.e-toolbartext e-text", this.model.filterSettings[i].text, {}, {});
            $li.append($item);
            $filterUl.append($li);
        }
        if (this.model.allowPrinting) {
            var $printUl = ej.buildTag("ul.e-print", "", {}, {});
            var li = ej.buildTag("li", "", {}, { "class": "e-printlist", title: "Print", "tabindex": "0" });
            var $item = ej.buildTag("a.e-printicon e-icon", "", {});
            li.append($item);
            $printUl.append(li);
        }
        if (!ej.isNullOrUndefined($filterUl))
            $div.append($filterUl);
        if (!ej.isNullOrUndefined($printUl))
            $div.append($printUl);
        if (!ej.isNullOrUndefined($searchUl))
            $div.append($searchUl);
        var model = { click: this._onToolbarClick };
        $div.ejToolbar(model);
        this._filterToolBar = $div;
        return $div;
    };
    Kanban.prototype._renderCustomLi = function ($ul) {
        var $li, cusTb, $item;
        for (var i = 0; i < this.model.customToolbarItems.length; i++) {
            cusTb = this.model.customToolbarItems[i]["template"] ? this.model.customToolbarItems[i].template.replace("#", "") : this.model.customToolbarItems[i];
            $li = ej.buildTag("li", "", {}, { id: this._id + "_" + cusTb, title: cusTb });
            switch (typeof this.model.customToolbarItems[i]) {
                case "string":
                    $item = ej.buildTag("a.e-toolbaricons e-icon", "", {}).addClass(this.model.customToolbarItems[i].text);
                    break;
                case "object":
                    $li.attr("title", this.model.customToolbarItems[i].template.replace("#", ""));
                    $item = $(this.model.customToolbarItems[i].template).hide().html();
                    break;
            }
            $li.html($item);
            $ul.append($li);
        }
    };
    Kanban.prototype.dataSource = function (dataSource, templateRefresh) {
        if (templateRefresh)
            this._templateRefresh = true;
        this._dataSource(dataSource);
        this.KanbanCommon._refreshDataSource(dataSource);
        if (this.model.enableTotalCount)
            this.KanbanCommon._totalCount();
        this.KanbanCommon._addLastRow();
    };
    Kanban.prototype._ensureDataSource = function (args) {
        if (this._dataSource() == null && !(this._dataSource() instanceof ej.DataManager)) {
            if (!ej.isNullOrUndefined(args) && args.requestType == "add")
                this.dataSource([], false);
            else
                return;
        }
        this.model.query.requiresCount();
        var queryManagar = this.model.query, cloned = queryManagar.clone(), predicate;
        if (!(this._dataSource() instanceof ej.DataManager))
            this._currentJsonData = this.currentViewData = this._dataSource();
        if (((this.model.filterSettings.length || this.model.allowFiltering) && !ej.isNullOrUndefined(args) && args.requestType == "filtering") || (!ej.isNullOrUndefined(args) && args.requestType == "search" || this.model.searchSettings.key.length)) {
            queryManagar["queries"] = queryManagar["queries"].slice(queryManagar["queries"].length);
            if (this.model.allowSearching) {
                var $searchIcon = this._searchBar.find(".e-toolbaricons");
                if (this.model.searchSettings.key.length != 0) {
                    var searchDetails = this.model.searchSettings;
                    $searchIcon.removeClass("e-searchfind").addClass("e-cancel");
                    if (searchDetails.fields.length == 0) {
                        if (!ej.isNullOrUndefined(this.model.fields.content))
                            searchDetails.fields.push(this.model.fields.content);
                        if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey))
                            searchDetails.fields.push(this.model.fields.swimlaneKey);
                        if (!ej.isNullOrUndefined(this.model.fields.primaryKey))
                            searchDetails.fields.push(this.model.fields.primaryKey);
                        if (!ej.isNullOrUndefined(this.model.fields.title))
                            searchDetails.fields.push(this.model.fields.title);
                        if (!ej.isNullOrUndefined(this.model.fields.tag))
                            searchDetails.fields.push(this.model.fields.tag);
                        if (!ej.isNullOrUndefined(this.model.fields.imageUrl))
                            searchDetails.fields.push(this.model.fields.imageUrl);
                        if (!ej.isNullOrUndefined(this.model.fields.priority))
                            searchDetails.fields.push(this.model.fields.priority);
                        if (!ej.isNullOrUndefined(this.model.fields.color))
                            searchDetails.fields.push(this.model.fields.color);
                    }
                    queryManagar.search(searchDetails.key, searchDetails.fields, searchDetails.operator || "contains", searchDetails.ignoreCase);
                }
                else
                    $searchIcon.removeClass("e-cancel").addClass("e-searchfind");
            }
            if (this.element.hasClass('e-responsive'))
                this._filterCollection = this._kbnFilterCollection.slice();
            for (var i = 0; i < this._filterCollection.length; i++)
                predicate = predicate != undefined ? predicate["and"](this._filterCollection[i]) : this._filterCollection[i];
            if (this._keyFiltering) {
                queryManagar.where(ej.Predicate["or"](this.keyPredicates));
                for (var i = 0; i < queryManagar["queries"].length; i++) {
                    if (queryManagar["queries"][i].fn == "onWhere") {
                        predicate && (queryManagar["queries"][i].e = queryManagar["queries"][i].e.and(predicate));
                    }
                }
            }
            else if (this._filterCollection.length)
                queryManagar.where(predicate);
            if (this._isLocalData) {
                this._filteredRecords = this._dataManager.executeLocal(queryManagar).result;
                this._filteredRecordsCount = this._filteredRecords.length;
            }
            if (this._isLocalData && this.model.filterSettings.length == 0) {
                if (!ej.isNullOrUndefined(this._filteredRecordsCount) || this._filteredRecordsCount > 0) {
                    this._filteredRecordsCount = null;
                    this._filteredRecords = [];
                }
            }
        }
        if (this._isLocalData && (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) && (!ej.isNullOrUndefined(this._cModifiedData) || !ej.isNullOrUndefined(this._cAddedRecord)))
            queryManagar["queries"] = cloned["queries"];
        if (args && args.requestType == "delete" && !ej.isNullOrUndefined(this._cDeleteData) && this._isLocalData) {
            var index;
            if (!(this._dataSource() instanceof ej.DataManager)) {
                index = $.inArray(this._cDeleteData[0], this._dataSource());
                this._dataSource(undefined, true).splice(index, 1);
            }
            else {
                index = $.inArray(this._cDeleteData[0], this._dataSource().dataSource.json);
                this._dataSource().dataSource.json.splice(index, 1);
            }
        }
        this._cloneQuery = queryManagar.clone();
        if (this._isLocalData) {
            var qManagar;
            if (!ej.isNullOrUndefined(args) && args.requestType == "refresh" && this._filterCollection.length <= 0 && (ej.isNullOrUndefined(this._searchInput) || this._searchInput.val().length <= 0)) {
                var cloned = queryManagar.clone();
                cloned["queries"] = [];
                cloned.where(ej.Predicate["or"](this.keyPredicates));
                qManagar = cloned;
            }
            else
                qManagar = queryManagar;
            var dataMgrJson = this._dataManager.dataSource.json;
            var dataSource = this._dataSource().dataSource;
            if (!ej.isNullOrUndefined(dataSource) && this._dataSource() instanceof ej.DataManager)
                this._dataManager.dataSource.json = dataMgrJson != dataSource.json ? dataSource.json : dataMgrJson;
            var result = this._dataManager.executeLocal(qManagar);
            this.currentViewData = this._currentJsonData = result.result;
            this._recordsCount = result.count;
        }
    };
    Kanban.prototype._addColumnFilters = function () {
        var colms = this.model.columns, predicates = [], fPred;
        var qManager = this.model.query;
        for (var i = 0; i < colms.length; i++) {
            var key = colms[i].key;
            if (!ej.isNullOrUndefined(key))
                key = typeof (key) == "object" ? key : key.split(",");
            for (var j = 0; j < key.length; j++) {
                predicates.push(new ej.Predicate(this.model.keyField, ej.FilterOperators.equal, key[j], true));
                this._keyValue.push(key[j]);
            }
        }
        if (this._keyFiltering)
            predicates.length > 0 && (qManager.where(ej.Predicate["or"](predicates)));
        this.keyPredicates = predicates;
    };
    Kanban.prototype.refresh = function (refreshTemplate) {
        refreshTemplate && this.refreshTemplate();
        var args = { requestType: "refresh" };
        this.KanbanCommon._processBindings(args);
    };
    Kanban.prototype.sendDataRenderingRequest = function (args) {
        if (this._templateRefresh) {
            this.refreshTemplate();
            this._templateRefresh = false;
        }
        var queryManagar = this.model.query, cloned = queryManagar.clone();
        if (this.currentViewData != null && this.currentViewData.length) {
            switch (args.requestType) {
                case "save":
                case "drop":
                case "delete":
                case "refresh":
                case "search":
                case "filtering":
                    if (this.element.hasClass('e-responsive') && !ej.isNullOrUndefined(args.currentFilterObject))
                        this._kbnAdaptFilterObject = args.currentFilterObject.slice();
                case "cancel":
                    if (this.element.find('.e-kbnadapt-editdlg').length == 0 && this.element.hasClass('e-responsive') && (this.model.editSettings.allowAdding || this.model.editSettings.allowEditing))
                        $("#" + this._id + "_dialogEdit_wrapper").appendTo(this.element);
                    this.getContentTable().find("colgroup").first().replaceWith(this.KanbanCommon._getMetaColGroup());
                    if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey)) {
                        var proxy = this, swimlaneKey = this.model.fields.swimlaneKey, unassignedGroup = this.model.swimlaneSettings.unassignedGroup;
                        queryManagar = queryManagar.group(swimlaneKey);
                        if (!this.currentViewData.GROUPGUID) {
                            if (unassignedGroup.enable && unassignedGroup.keys.length > 0) {
                                $.map(proxy.currentViewData, function (obj, index) {
                                    proxy.currentViewData[index] = proxy._checkKbnUnassigned(obj);
                                });
                            }
                            if (!this.currentViewData.GROUPGUID)
                                this.currentViewData = new ej.DataManager(this.currentViewData).executeLocal(queryManagar)["result"];
                        }
                    }
                    this._renderAllCard();
                    if (!this._keyFiltering && this.model.swimlaneSettings.showCount)
                        this._getSwimlaneCount();
                    if (this.element.hasClass('e-responsive')) {
                        if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey)) {
                            this.element.find('.e-swimlanerow').hide();
                            if (this.KanbanAdaptive)
                                this.KanbanAdaptive._addSwimlaneName();
                        }
                    }
                    this._enableSwimlaneCount = true;
                    this._eventBindings();
                    this._enableDragandScroll();
                    break;
                case "beginedit":
                case "add":
                    if (this.KanbanEdit) {
                        this.KanbanEdit._editAdd(args);
                        this._enableSwimlaneCount = false;
                    }
                    break;
            }
            queryManagar["queries"] = cloned["queries"];
        }
        else {
            this.getContentTable().find('tbody').empty().first().append(this.KanbanCommon._getEmptyTbody());
        }
        if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
            this._editForm = this.element.find(".e-externalform");
            this.KanbanEdit._formFocus();
        }
        if ("beginedit" == args.requestType || "add" == args.requestType)
            (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "externalform") && this.KanbanEdit._refreshEditForm(args);
        this._renderComplete(args);
        if (this.KanbanSwimlane && this._enableSwimlaneCount) {
            this.KanbanSwimlane._swimlaneLimit(args);
            this._swimlaneRows = this.element.find('.e-swimlanerow');
        }
        this.KanbanCommon._renderLimit();
        if (this._filterCollection.length == 0 && this.model.searchSettings.key.length == 0)
            this.KanbanCommon._totalCount();
        if (this._filterCollection.length > 0 || this.model.searchSettings.key.length > 0)
            this.KanbanFilter._filterLimitCard(args);
        this._newData = null;
        if (this.element.hasClass('e-responsive')) {
            this.kanbanWindowResize();
            if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey))
                this.KanbanAdaptive._setAdaptiveSwimlaneTop();
        }
    };
    Kanban.prototype._checkKbnUnassigned = function (obj) {
        var unassignedGroup = this.model.swimlaneSettings.unassignedGroup, type = obj[this.model.fields.swimlaneKey], swimlaneKey = this.model.fields.swimlaneKey;
        for (var i = 0; i < unassignedGroup.keys.length; i++) {
            if (typeof unassignedGroup.keys[i] == "string") {
                if (unassignedGroup.keys[i].replace(/^\s+|\s+$/g, '') == "" && $.inArray("", unassignedGroup.keys) >= 0 && i < $.inArray("", unassignedGroup.keys))
                    unassignedGroup.keys.splice(i, 1);
                else if (unassignedGroup.keys[i].replace(/^\s+|\s+$/g, '') == "")
                    unassignedGroup.keys[i] = unassignedGroup.keys[i].replace(/^\s+|\s+$/g, '');
            }
        }
        if (type != undefined && type != null && typeof type == "string")
            type = type.replace(/^\s+|\s+$/g, '');
        if (type == null || type == undefined) {
            for (var i = 0; i < unassignedGroup.keys.length; i++) {
                if ((typeof unassignedGroup.keys[i] == "string") && (unassignedGroup.keys[i].toLowerCase() == "null" || unassignedGroup.keys[i].toLowerCase() == "undefined"))
                    obj[swimlaneKey] = this.localizedLabels.Unassigned;
                else if (unassignedGroup.keys[i] == null || unassignedGroup.keys[i] == undefined)
                    obj[swimlaneKey] = this.localizedLabels.Unassigned;
            }
        }
        else {
            for (var i = 0; i < unassignedGroup.keys.length; i++) {
                var key = unassignedGroup.keys[i];
                if (typeof type == "number" && key.startsWith("'") && key.endsWith("'"))
                    key = key.split("'")[1];
                if (key == type)
                    obj[swimlaneKey] = this.localizedLabels.Unassigned;
            }
        }
        return obj;
    };
    Kanban.prototype._renderAllCard = function () {
        var temp = document.createElement('div');
        temp.innerHTML = ['<table>', $.render[this._id + "_JSONTemplate"]({ columns: this.model.columns, dataSource: this.currentViewData }), '</table>'].join("");
        if (!ej.isNullOrUndefined(temp.firstChild) && !ej.isNullOrUndefined(temp.firstChild.lastChild))
            this.getContentTable().get(0).replaceChild(temp.firstChild.lastChild, this.getContentTable().get(0).lastChild);
        if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey))
            this._swimlaneRows = this.element.find('.e-swimlanerow');
        this._cardCollapse();
        this._swimlaneCollapse();
        if (this.KanbanSelection)
            this.KanbanSelection._selectionOnRerender();
    };
    Kanban.prototype._editEventTrigger = function (args) {
        if (args.requestType == "save" || args.requestType == "delete") {
            var params = {
                data: args.data,
                action: args.action !== undefined ? args.action : args.requestType,
            };
            this._trigger("end" + params.action.charAt(0).toUpperCase() + params.action.slice(1), params);
        }
    };
    Kanban.prototype._renderComplete = function (args) {
        if (args.requestType != 'beginedit')
            this.KanbanCommon._setWidthToColumns();
        if (args.requestType == "save" || args.requestType == "cancel") {
            this._isAddNew = false;
            this._isEdit = false;
        }
        if (args.requestType == 'beginedit')
            this._isEdit = true;
        if ("delete" == args.requestType || "save" == args.requestType)
            this._editEventTrigger(args);
        this._tableBEle = this.getContentTable().get(0);
        this._kanbanRows = this._tableBEle.rows;
        this._columnRows = $(this._kanbanRows).not(".e-swimlanerow");
        if (this.model.allowScrolling && !this.initialRender)
            this.getContentTable().find("tr:last").find("td").addClass("e-lastrowcell");
        this._trigger("actionComplete", args);
        if (!this.initialRender && this.model.allowScrolling && (args.requestType == "add" || args.requestType == "cancel" || args.requestType == "save" || args.requestType == "delete" || args.requestType == "filtering" || args.requestType == "search" || args.requestType == "refresh" || args.requestType == "drop"))
            this.KanbanScroll._refreshScroller(args);
        if (this.model.allowDragAndDrop && this.KanbanDragAndDrop)
            this.KanbanDragAndDrop._addDragableClass();
    };
    Kanban.prototype._createTemplate = function (elt, templateId) {
        var scriptElt = document.createElement("script");
        scriptElt.id = (this._id + templateId + "_Template");
        var $script = this.element.parents("body").find("#" + scriptElt.id);
        scriptElt.type = "text/x-jsrender";
        scriptElt.text = elt;
        if ($script)
            $script.remove();
        $("body").append(scriptElt);
        return scriptElt;
    };
    Kanban.prototype._addInitTemplate = function () {
        var proxy = this, helpers = {}, isKey = !ej.isNullOrUndefined(proxy.model.keyField), isIe8 = ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8, toggle = this.model.allowToggleColumn, isSwimlane = !ej.isNullOrUndefined(proxy.model.fields.swimlaneKey);
        this._slTemplate = "";
        helpers[proxy._id + "Object"] = this;
        helpers["_" + proxy._id + "columnKeys"] = this._getColumnKeyItems;
        helpers["_" + proxy._id + "tagItems"] = this._gettagItems;
        helpers["_" + proxy._id + "colorMaps"] = this._getColorMaps;
        helpers["_" + proxy._id + "getId"] = this.KanbanCommon._removeIdSymbols;
        helpers["_" + proxy._id + "getData"] = this._columnData;
        helpers["_" + proxy._id + "getCardCount"] = this._columnCardcount;
        helpers["_" + proxy._id + "getStatus"] = this._columnStatus;
        $.views.helpers(helpers);
        if (isSwimlane) {
            this._slTemplate += "{{for dataSource ~columns=columns ~ds=dataSource}}";
            this._slTemplate += "<tr id='{{: ~_" + proxy._id + "getId(key)}}' class='e-swimlanerow' role='kanbanrow'>" +
                "<td class='e-rowcell' role='kanbancell'  colspan='" + (proxy.getVisibleColumnNames().length) + "'>" +
                "<div class='e-slexpandcollapse'><div class='e-icon e-slexpand'></div></div>" +
                "<div class='e-slkey'>{{:key}}</div>" +
                "{{if " + this.model.swimlaneSettings.showCount + "}}" +
                "<div class='e-slcount'>" + proxy.localizedLabels.SwimlaneCaptionFormat + "</div>" +
                "{{/if}}" +
                "</td>" +
                "</tr>";
        }
        this._slTemplate += "<tr class='e-columnrow' role='kanbanrow'>";
        if (isSwimlane)
            this._slTemplate += "{{for ~columns ~items=#data.items}}";
        else
            this._slTemplate += "{{for columns}}";
        this._slTemplate += "<td ej-mappingkey='{{:key}}' class='e-rowcell " + "{{if !#data.visible}}  e-hide {{/if}}" + "{{if #data.allowDrag}}  e-drag {{/if}}" + "{{if #data.allowDrop}}  e-drop {{/if}}" + "{{if (#data.isCollapsed && " + toggle + ")}}e-shrink{{/if}}" + "'role='kanbancell'>" +
            "{{if " + isKey + "}}" +
            "{{for ~_" + proxy._id + "columnKeys('" + proxy._id + "Object')}}";
        this._slTemplate += this._cardCustomization() +
            "{{/for}}" +
            "{{/if}}" +
            "{{if " + this.model.allowToggleColumn + "}}" +
            "<div class='e-shrinkheader" +
            "{{if " + isIe8 + "}} IE{{/if}}" +
            "{{if !#data.isCollapsed}}  e-hide {{/if}}" + "'>" +
            "{{:headerText}}<div class='e-shrinklabel'>[<div class='e-shrinkcount'>" +
            "{{:~_" + proxy._id + "getCardCount(" + "~root.dataSource" + ",key,#parent.parent.getIndex(),'" + proxy._id + "Object') }}" +
            "</div>]</div></div>" +
            "{{/if}}" +
            "{{if " + this.model.editSettings.allowAdding + "}}" +
            "{{if #data.showAddButton}} " +
            "<div class='e-customaddbutton" +
            "{{if #data.isCollapsed}}  e-hide {{/if}}" + "'>" +
            "<div class='e-columnadd e-icon'>" +
            "</div>" +
            "</div>" +
            "{{/if}}" +
            "{{/if}}" +
            "</td>{{/for}}</tr>";
        if (isSwimlane)
            this._slTemplate += "{{/for}}";
        this.templates[this._id + "_JSONTemplate"] = $.templates(this._createTemplate(this._slTemplate, "_swinlaneContent"));
        this.templates[this._id + "_cardTemplate"] = $.templates(this._createTemplate(this._cardTemplate, "_cardTemplate"));
        $.templates(this.templates);
    };
    Kanban.prototype._cardCustomization = function () {
        var proxy = this, toggle = this.model.allowToggleColumn, userAppTemplId = (this.model.cardSettings.template) ? true : false, userImage = (this.model.fields.imageUrl) ? true : false, cardSets = this.model.fields, isTitle = !ej.isNullOrUndefined(cardSets.title), titleFld = cardSets.title ? cardSets.title : (cardSets.primaryKey ? cardSets.primaryKey : null), innerDiv = (!ej.isNullOrUndefined(cardSets.tag) || !ej.isNullOrUndefined(cardSets.content));
        if (!userImage)
            this.element.addClass('e-onlycontent');
        this._cardTemplate =
            "<div id='{{:" + proxy.model.fields.primaryKey + "}}' class='e-kanbancard " + "{{if ~_" + proxy._id + "getData(" + "#parent" + ")  && " + toggle + " }}e-hide{{/if}} " + "{{if " + userAppTemplId + "}}e-templatecell{{/if}}'>" +
                "{{if " + userAppTemplId + "}}" +
                $(proxy.model.cardSettings.template).html() +
                "{{else}}" +
                "{{if " + proxy.model.allowTitle + "}}" +
                "<div class='e-cardheader'>" +
                "<div class='e-primarykey'>" +
                "{{:" + titleFld + "}}" +
                "</div>" +
                "<div class='e-expandcollapse'><div class='e-icon e-cardexpand'></div></div>" +
                "</div>" +
                "{{/if}}" +
                "<div class='e-cardcontent'>" +
                "<table class='e-cardtable'><tbody><tr>" +
                "<td class='e-contentcell'>" +
                "{{if " + innerDiv + "}}" +
                "<div class='e-text'>{{:" + cardSets.content + "}}</div>" +
                "</td>" +
                "{{if " + userImage + " }} " +
                "<td class='e-imagecell'>" +
                "<div class='e-card_image'>" +
                "{{if " + cardSets.imageUrl + "}}" +
                "<img class='e-image' src='{{:" + cardSets.imageUrl + "}}'></img>" +
                "{{else}}" +
                "<div class='e-image e-no-user'></div>" +
                "{{/if}}</div></td>" +
                "{{/if}}" +
                "</tr>" +
                "<tr>" +
                "<td>" +
                "{{if " + cardSets.tag + "}}" +
                "{{for ~_" + proxy._id + "tagItems(" + cardSets.tag + ")}}" +
                "{{:#data}}" +
                "{{/for}}" +
                "{{/if}}" +
                "</div>" +
                "{{/if}}" +
                "</td>" +
                "<td class='e-trainglecell'>" +
                "<div class='e-bottom-triangle'" +
                "{{if " + cardSets.color + " }} " +
                "style='border-bottom-color" +
                ":{{for  ~_" + proxy._id + "colorMaps('" + proxy._id + "Object'," + cardSets.color + ")}}" +
                "{{:#data}}{{/for}}'" +
                "{{/if}}></div>" +
                "</td>" +
                "</tr>" +
                "</tbody></table>" +
                "</div>" +
                "{{/if}}" +
                "</div>" +
                "</div>";
        return this._cardTemplate;
    };
    Kanban.prototype._columnStatus = function (objectId) {
        var kanbanObject = this["getRsc"]("helpers", objectId);
        var browserDetails = kanbanObject.getBrowserDetails();
        if (browserDetails.browser == "msie")
            return true;
        else
            return false;
    };
    Kanban.prototype._columnCardcount = function (id, key, index, proxy) {
        var kanbanObject = proxy;
        if (typeof proxy === "string")
            kanbanObject = this["getRsc"]("helpers", proxy);
        var co = 0;
        var j, k;
        key = typeof (key) == "object" ? key : key.split(",");
        if (ej.isNullOrUndefined(index)) {
            for (j = 0; j < id.length; j++)
                for (k = 0; k < key.length; k++)
                    if (id[j][kanbanObject.model.keyField] === key[k])
                        co++;
            return co;
        }
        else
            for (j = 0; j < id[index].items.length; j++)
                for (k = 0; k < key.length; k++)
                    if (id[index].items[j][kanbanObject.model.keyField] === key[k])
                        co++;
        return co;
    };
    Kanban.prototype._columnData = function (id) {
        if (ej.isNullOrUndefined(id))
            return false;
        else
            return id.parent.data.isCollapsed;
    };
    Kanban.prototype._getColorMaps = function (objectId, items) {
        var kanbanObject = this["getRsc"]("helpers", objectId), colors, colorMaps = kanbanObject.model.cardSettings.colorMapping;
        for (var val in colorMaps) {
            if (colorMaps[val].indexOf(',') == -1 && colorMaps[val] == items)
                return val;
            else {
                colors = colorMaps[val].split(",");
                for (var i = 0; i < colors.length; i++) {
                    if (colors[i] == items)
                        return val;
                }
            }
        }
    };
    Kanban.prototype._gettagItems = function (tag) {
        var tags = "<div class='e-tags'>", i;
        tag = tag.split(",");
        for (i = 0; i < tag.length; i++)
            tags = tags.concat("<div class='e-tag'>" + tag[i] + "</div>");
        return tags.concat("</div>");
    };
    Kanban.prototype._getColumnKeyItems = function (objectId) {
        var kanbanObject = this["getRsc"]("helpers", objectId), keys, ds = this["ctx"].root.dataSource, dropKey;
        var queryManagar = kanbanObject.model.query;
        var cloned = queryManagar.clone();
        if (kanbanObject._filterCollection.length <= 0 && kanbanObject.model.allowSearching && kanbanObject._searchInput.val().length <= 0) {
            cloned.queries = [];
            cloned.where(ej.Predicate["or"](kanbanObject.keyPredicates));
        }
        else
            cloned.queries = cloned.queries.slice(0, cloned.queries.length - 1);
        var key = typeof (this["data"].key) == "object" ? this["data"].key : this["data"].key.split(",");
        var predicate = [];
        for (var i = 0; i < key.length; i++)
            predicate.push(new ej.Predicate(kanbanObject.model.keyField, ej.FilterOperators.equal, key[i], true));
        cloned = cloned.where(ej.Predicate["or"](predicate));
        if (ds.GROUPGUID)
            keys = new ej.DataManager(this["ctx"].items).executeLocal(cloned)["result"];
        else
            keys = new ej.DataManager(ds).executeLocal(cloned)["result"];
        dropKey = kanbanObject.model.fields.priority;
        if (dropKey)
            keys.sort(function (val1, val2) {
                return val1[dropKey] - val2[dropKey];
            });
        return keys;
    };
    Kanban.prototype._kbnThumbStart = function (e) {
        var target = $(e.originalEvent.target);
        if (target.hasClass("e-kanbancard") || target.parents(".e-kanbancard").hasClass("e-kanbancard"))
            return false;
        return false;
    };
    Kanban.prototype._enableDragandScroll = function () {
        if (this.model.allowDragAndDrop && this.KanbanDragAndDrop)
            this.KanbanDragAndDrop._addDragableClass();
        if (this.model.allowScrolling) {
            if (this.initialRender && this.element.find('.e-kanbancontent').length > 0) {
                if (!ej.isNullOrUndefined(this.model.fields.swimlaneKey))
                    this._swimlaneRows = this.element.find('.e-swimlanerow');
                this.KanbanScroll._renderScroller();
            }
            else
                this.KanbanScroll._refreshScroller({ requestType: "refresh" });
        }
    };
    Kanban.prototype._cardCollapse = function () {
        if (this._collapsedCards.length > 0)
            this.toggleCard(this._collapsedCards);
    };
    Kanban.prototype._getSwimlaneCount = function () {
        var swimRow = this.getContentTable().find('.e-swimlanerow .e-slcount');
        var data = [], proxy = this;
        $.map(proxy.currentViewData, function (obj, index) {
            data.push(obj.key);
        });
        for (var i = 0; i < swimRow.length; i++) {
            var swimkey = this.getContentTable().find('.e-swimlanerow .e-slkey').eq(i).html();
            var index = data.indexOf(swimkey);
            var object = new ej.DataManager(this.currentViewData[index].items).executeLocal(new ej.Query().where(ej.Predicate["or"](this.keyPredicates)));
            if (object.length != this.currentViewData[index].count) {
                swimRow.eq(i).html(swimRow.eq(i).html().replace(this.currentViewData[index].count, object.length));
                if (object.length == 1) {
                    var swimCaption = this.localizedLabels.SwimlaneCaptionFormat;
                    var index1 = swimCaption.search("{{else}}");
                    var index2 = swimCaption.search("count == 1");
                    if (index1 != -1 && index2 != -1) {
                        var localizedText = swimCaption.slice(index2 + 13, index1);
                        var curText = swimRow.eq(i).html().slice(4);
                        swimRow.eq(i).html(swimRow.eq(i).html().replace(curText, localizedText));
                    }
                }
            }
        }
    };
    Kanban.prototype._swimlaneCollapse = function () {
        if (this._collapsedSwimlane.length > 0) {
            var $swimRow = this.element.find(".e-swimlanerow");
            for (var i = 0; i < $swimRow.length; i++) {
                if ($.inArray($swimRow.eq(i).attr("id"), this._collapsedSwimlane) != -1)
                    this.KanbanSwimlane._toggleSwimlaneRow($($swimRow.eq(i)).find(".e-rowcell .e-slexpandcollapse"));
            }
        }
    };
    Kanban.prototype.updateCard = function (primaryKey, data) {
        this.KanbanCommon._kanbanUpdateCard(primaryKey, data);
    };
    Kanban.prototype._eventBindings = function () {
        this._kanbanRows = this.getContentTable().get(0)["rows"];
        var columnRows = $(this._kanbanRows).not(".e-swimlanerow");
        if (this._currentJsonData.length != 0 && this.model.queryCellInfo != null) {
            for (var row = 0; row < columnRows.length; row++) {
                var trRows = columnRows[row];
                var columns = this.model.columns;
                for (var i = 0; i < columns.length; i++) {
                    var cell = $(trRows).find(".e-rowcell")[i];
                    this._cellEventTrigger(cell, columns[i]);
                }
            }
        }
    };
    Kanban.prototype._cellEventTrigger = function (rowCell, curColumn) {
        var $kanbanCard = $(rowCell).find(".e-kanbancard");
        for (var i = 0; i < $kanbanCard.length; i++) {
            var cardId = $kanbanCard[i].id;
            var data = this.KanbanCommon._getKanbanCardData(this._currentJsonData, cardId);
            var args = { card: $kanbanCard[i], cell: rowCell, column: curColumn, data: data[0] };
            this._trigger("queryCellInfo", args);
        }
    };
    Kanban.prototype._getLocalizedLabels = function () {
        return ej.getLocalizedConstants(this["sfType"], this.model.locale);
    };
    return Kanban;
}(ej.WidgetBase));
window.ej.widget("ejKanban", "ej.Kanban", new Kanban());
ej.Kanban.Actions = {
    Filtering: "filtering",
    BeginEdit: "beginedit",
    Edit: "edit",
    Save: "save",
    Add: "add",
    Delete: "delete",
    Cancel: "cancel",
    Refresh: "refresh",
    Search: "searching",
    Print: "print"
};
ej.Kanban.EditingType = {
    String: "stringedit",
    Numeric: "numericedit",
    Dropdown: "dropdownedit",
    DatePicker: "datepicker",
    DateTimePicker: "datetimepicker",
    TextArea: "textarea",
    RTE: "rteedit",
};
ej.Kanban.EditMode = {
    Dialog: "dialog",
    DialogTemplate: "dialogtemplate",
    ExternalForm: "externalform",
    ExternalFormTemplate: "externalformtemplate",
};
ej.Kanban.FormPosition = {
    Bottom: "bottom",
    Right: "right"
};
ej.Kanban.Type = {
    Column: "column",
    Swimlane: "swimlane",
};
ej.Kanban.SelectionType = {
    Multiple: "multiple",
    Single: "single",
};
ej.Kanban.MenuItem = {
    AddCard: "Add Card",
    EditCard: "Edit Card",
    DeleteCard: "Delete Card",
    TopofRow: "Top of Row",
    BottomofRow: "Bottom of Row",
    MoveUp: "Move Up",
    MoveDown: "Move Down",
    MoveLeft: "Move Left",
    MoveRight: "Move Right",
    MovetoSwimlane: "Move to Swimlane",
    HideColumn: "Hide Column",
    VisibleColumns: "Visible Columns",
    PrintCard: "Print Card",
};
ej.Kanban.Target = {
    Header: "header",
    Content: "content",
    Card: "card",
    All: "all",
};
ej.Kanban.Locale = {};
;
(function ($, ej, undefined) {
    ej.widget("ejSpreadsheet", "ej.Spreadsheet", {
        _rootCSS: "e-spreadsheet",
        // widget element will be automatically set in this
        element: null,
        _excelFilter: null,
        validTags: ["div"],
        // user defined model will be automatically set in this
        model: null,
        _requiresID: true,
        defaults: {
            allowFreezing: true,
            enableContextMenu: true,
            allowEditing: true,
            allowResizing: true,
            allowMerging: true,
            allowWrap: true,
            allowUndoRedo: true,
            allowClipboard: true,
            allowDataValidation: true,
            allowConditionalFormats: true,
            allowSearching: true,
            allowKeyboardNavigation: true,
            allowAutoFill: true,
            allowSelection: true,
            allowSorting: true,
            allowDragAndDrop: true,
            allowCellType: true,
            allowAutoCellType: false,
            allowCharts: true,
            enablePersistence: false,
            allowCellFormatting: true,
            allowFormulaBar: true,
            showRibbon: true,
            showPager: true,
            allowComments: true,
            allowFiltering: true,
            allowInsert: true,
            allowDelete: true,
            allowFormatPainter: true,
            allowHyperlink: true,
            allowImport: true,
            allowFormatAsTable: true,
            allowAutoSum: true,
            enablePivotTable: false,
            allowLockCell: true,
            enableTouch: true,
            allowOverflow: true,
            allowClear: true,
            isReadOnly: false,
            columnCount: 21,
            rowCount: 20,
            rowHeight: 20,
            columnWidth: 64,
            sheetCount: 1,
            undoRedoStep: 20,
            activeSheetIndex: 1,
            apWidth: 300,
            activationPanelWidth: 300,
            _isActPanelVisible: false,
            cssClass: "",
            userName: "",
            locale: "en-US",
            pageSize: "A4",
            sheets: [],
            nameManager: [],
            customFormulas: [],
            currentViewData: null,
            query: null,
            create: null,
            actionBegin: null,
            actionComplete: null,
            beforeCellFormat: null,
            cellFormatting: null,
            beforeOpen: null,
            beforeDrop: null,
            drop: null,
            cellEdit: null,
            pagerClick: null,
            cellClick: null,
            _pivotPrint: null,
            tabClick: null,
            tabSelect: null,
            _createPivotTable: null,
            beforePanelOpen: null,
            load: null,
            loadComplete: null,
            editRangeBegin: null,
            editRangeComplete: null,
            cellHover: null,
            menuClick: null,
            contextMenuClick: null,
            ribbonClick: null,
            dragStart: null,
            drag: null,
            cellSave: null,
            beforeCellSelect: null,
            cellSelected: null,
            autoFillBegin: null,
            autoFillComplete: null,
            openFailure: null,
            onImport: null,
            onExport: null,
            beforeBatchSave: null,
            keyUp: null,
            keyDown: null,
            dragShape: null,
            resizeStart: null,
            resizeEnd: null,
            refresh: null,
            beforeEditComment: null,
            beforeTabClick: null,
            scrollStop: null,
            scrollSettings: {
                width: "100%",
                height: "100%",
                allowScrolling: true,
                scrollMode: "infinite",
                isResponsive: true,
                allowVirtualScrolling: true,
                allowSheetOnDemand: false
            },
            pageSettings: {
                pageCount: 10,
                currentPage: 1,
                pagerHeight: 26
            },
            exportSettings: {
                allowExporting: true,
                excelUrl: null,
                csvUrl: null,
                pdfUrl: null,
                password: null
            },
            pictureSettings: {
                allowPictures: true,
                height: 220,
                width: 440
            },
            selectionSettings: {
                selectionType: "default",
                selectionUnit: "multirange",
                enableAnimation: false,
                animationType: "linear",
                animationTime: 0.001,
                activeCell: ""
            },
            chartSettings: {
                height: 220,
                width: 440
            },
            formatSettings: {
                allowFontFamily: true,
                allowDecimalPlaces: true,
                allowCellBorder: true
            },
            autoFillSettings: {
                fillType: "fillseries",
                showFillOptions: true
            },
            "importSettings": {
                importMapper: "",
                importUrl: "",
                password: "",
                allowSheetOnDemand: false,
                importOnLoad: false
            },
            printSettings: {
                allowPageSetup: true,
                allowPageSize: false,
                allowPrinting: true
            },
            ribbonSettings: {
                enableOnDemand: false,
                applicationTab: {
                    type: ej.Ribbon.ApplicationTabType.Backstage,
                    menuSettings: {
                        isAppend: false,
                        dataSource: []
                    }
                }
            }
        },

        dataTypes: {
            pageSize: "enum",
            sheets: "array",
            nameManager: "array",
            scrollSettings: {
                scrollMode: "enum"
            },
            selectionSettings: {
                selectionType: "enum",
                selectionUnit: "enum",
                animationType: "enum"
            },
            autoFillSettings: {
                fillType: "enum"
            }
        },

        _dataSource: function (sheetIdx) {
            return this.getSheet(sheetIdx).dataSource;
        },

        getSheet: function (sheetIdx) {
            return this.model.sheets[this._getSheetIndex(sheetIdx)];
        },

        getSheets: function () {
            return this.model.sheets;
        },

        getSheetElement: function (sheetIdx) {
            return this.element.find("#" + this._id + "_" + this.getSheet(sheetIdx).sheetInfo.value);
        },

        getDataSettings: function (sheetIdx) {
            var setting, arr = [], sheet = this.getSheet(sheetIdx), i = sheet.rangeSettings.length;;
            if (i) {
                while (i--) {
                    setting = sheet.rangeSettings[i];
                    if (setting.dataSource)
                        arr.push(setting);
                }
            }
            return arr.length ? arr : (sheet.dataSource ? [sheet] : null);
        },

        _getJSSheetHeader: function (sheetIdx) {
            return this._sheets[sheetIdx]._sheetHeader;
        },

        _setJSSheetHeader: function (value, sheetIdx) {
            this._sheets[sheetIdx]._sheetHeader = value;
        },

        _getInputBox: function () {
            return this._inputBox;
        },

        _setInputBox: function (elem) {
            this._inputBox = elem;
        },

        _getIndexBox: function () {
            return this._indexBox;
        },

        _setIndexBox: function (elem) {
            this._indexBox = elem;
        },

        _getJSSheetRowHeader: function (sheetIdx) {
            return this._sheets[sheetIdx]._sheetRowHeader;
        },

        _setJSSheetRowHeader: function (value, sheetIdx) {
            this._sheets[sheetIdx]._sheetRowHeader = value;
        },

        _getJSSheetRowHeaderContent: function (sheetIdx) {
            return this._sheets[sheetIdx]._sheetRowHeaderContent;
        },

        _setJSSheetRowHeaderContent: function (value, sheetIdx) {
            this._sheets[sheetIdx]._sheetRowHeaderContent = value;
        },

        _getJSSheetContent: function (sheetIdx) {
            return this._sheets[sheetIdx]._sheetContent;
        },

        _setJSSheetContent: function (value, sheetIdx) {
            this._sheets[sheetIdx]._sheetContent = value;
        },

        _getContent: function (sheetIdx) {
            return this._sheets[sheetIdx]._content;
        },

        _setContent: function (value, sheetIdx) {
            this._sheets[sheetIdx]._content = value;
        },

        getPager: function () {
            return this._spreadSheetPager;
        },

        setPager: function (value) {
            this._spreadSheetPager = value;
        },

        getFooter: function () {
            return this._footer;
        },

        setFooter: function (value) {
            this._footer = value;
        },

        getMainPanel: function () {
            return this._mainPanel;
        },

        setMainPanel: function (value) {
            this._mainPanel = value;
        },

        getGroupPanel: function () {
            return this._groupPanel;
        },

        setGroupPanel: function (value) {
            this._groupPanel = value;
        },

        getActivationPanel: function () {
            return this._activationPanel;
        },

        setActivationPanel: function (value) {
            this._activationPanel = value;
        },

        getActiveSheetIndex: function () {
            return this.model.activeSheetIndex;
        },

        setActiveSheetIndex: function (value) {
            this.model.activeSheetIndex = value;
        },

        getRows: function (sheetIdx) {
            return this._sheets[sheetIdx]._Rows;
        },

        setRows: function (value, sheetIdx) {
            this._sheets[sheetIdx]._Rows = value;
        },

        getFrozenRows: function (sheetIdx) {
            return this.getSheet(this._getSheetIndex(sheetIdx)).frozenRows;
        },

        setFrozenRows: function (value, sheetIdx) {
            if (!this.model.isReadOnly)
       				this.getSheet(this._getSheetIndex(sheetIdx)).frozenRows = value;
        },

        getFrozenColumns: function (sheetIdx) {
            return this.getSheet(sheetIdx).frozenColumns;
        },

        setFrozenColumns: function (value, sheetIdx) {
            if (!this.model.isReadOnly)
                this.getSheet(sheetIdx).frozenColumns = value;
        },

        setFocusTopElem: function (elem) {
            this._focusTopElem = elem;
        },

        getFocusTopElem: function () {
            return this._focusTopElem;
        },

        setFocusRightElem: function (elem) {
            this._focusRightElem = elem;
        },

        getFocusRightElem: function () {
            return this._focusRightElem;
        },

        setFocusBottomElem: function (elem) {
            this._focusBottomElem = elem;
        },

        getFocusBottomElem: function () {
            return this._focusBottomElem;
        },

        setFocusLeftElem: function (elem) {
            this._focusLeftElem = elem;
        },

        getFocusLeftElem: function () {
            return this._focusLeftElem;
        },

        setAutoFillElem: function (elem) {
            this._autoFillElem = elem;
        },

        getAutoFillElem: function () {
            return this._autoFillElem;
        },

        _setAutoFillOptElem: function (elem) {
            this._autoFillOptElem = elem;
        },

        _getAutoFillOptElem: function () {
            return this._autoFillOptElem;
        },

        _getColWidth: function (colIdx, sheetIdx) {
            return this.getSheet(sheetIdx).columnsWidthCollection[colIdx];
        },

        _getRowHeight: function (rowIdx, sheetIdx) {
            return this.getSheet(sheetIdx).rowsHeightCollection[rowIdx];
        },

        setActiveCell: function (rowIdx, colIdx, sheetIdx) {
            var sheet = this.getSheet(sheetIdx ? sheetIdx : this.getActiveSheetIndex()), range;
            if (typeof (rowIdx) === "string") {
                range = this.getRangeIndices(rowIdx);
                rowIdx = range[0];
                colIdx = range[1];
            }
            sheet._activeCell = ej.isNullOrUndefined(rowIdx) && ej.isNullOrUndefined(colIdx) ? sheet._startCell : { rowIndex: rowIdx, colIndex: colIdx };
        },

        getActiveCell: function (sheetIdx) {
            return this.getSheet(this._getSheetIndex(sheetIdx))._activeCell;
        },

        _setFormulaSuggElem: function (elem) {
            this._formulaSuggElem = elem;
        },

        _getFormulaSuggElem: function () {
            return this._formulaSuggElem;
        },

        _setRowHdrTBody: function (elem, sheetIdx) {
            this._sheets[sheetIdx]._rowHdrTBody = elem;
        },

        _getRowHdrTBody: function (sheetIdx) {
            return this._sheets[sheetIdx]._rowHdrTBody;
        },

        _setContTBody: function (elem, sheetIdx) {
            this._sheets[sheetIdx]._contTBody = elem;
        },

        _getContTBody: function (sheetIdx) {
            return this._sheets[sheetIdx]._contTBody;
        },

        _init: function () {
            var isettings = this.model.importSettings;
            this._initBegin();
            if (this.model.allowImport && (isettings.importUrl.length || isettings.importOnLoad))
                this["import"]({ url: isettings.importUrl, password: this._encrypt(isettings.password), allowSheetOnDemand: isettings.allowSheetOnDemand });
            else {
                this.showWaitingPopUp();
                this._initBase();
                this._initComplete();
            }
			if (this._isAutoWHMode) {
				var dimension = this._getElementDimension();
                this.element.css({ height: dimension.height, width: dimension.width });
			}
        },

        _initBegin: function () {
            var tchProp = "touch-action", tchVal = "double-tap-zoom pinch-zoom", ssettings = this.model.scrollSettings, width = ssettings.width, height = ssettings.height;
            ej.support.stableSort = false;
            this._isInitLoad = true;
            this._isAutoWHMode = !ssettings.allowScrolling;
            if (this._isAutoWHMode) {
                ssettings.isResponsive = false;
                ssettings.scrollMode = "normal";
                ssettings.allowVirtualScrolling = false;
            }
            this._minWidth = 280;
            this._minHeight = 200;
            if (!this._isAutoWHMode)
                this.element.css({ 'min-height': this._minHeight, 'min-width': this._minWidth, height: ssettings.height, width: ssettings.width });
            this._updateResponsiveSettings();
            if (!this._isAutoWHMode && !ssettings.isResponsive) {
                if (ssettings.width.toString().indexOf("%") > -1)
                    ssettings.width = this._responsiveWidth;
                if (ssettings.height.toString().indexOf("%") > -1)
                    ssettings.height = this._responsiveHeight;
                this.element.css({ height: ssettings.height, width: ssettings.width });
            }
            this._browserDetails = ej.browserInfo();
            this.localizedLabels = ej.getLocalizedConstants(this.sfType, this.model.locale);
            this.element.attr("tabindex", 0);
            if (this._browserDetails.name === "msie")
                tchProp = "-ms-" + tchProp;
            this.element.css(tchProp, tchVal);
            var waitPopup = ej.buildTag("div#" + this._id + "_wait", "", { position: "absolute" });
            $(document.body).append(waitPopup);
            waitPopup.ejWaitingPopup({ showOnInit: false, target: this.element });
        },

        _initBase: function () {
            this._refreshModel(this.isImport ? this._impData.model : null);
            this._initProps();
            this._initCSSTag();
            this._initLayout();
            this._wireEvents("_on");
            this._isInitLoad = false;
            this.XLRibbon._renderNameManagerDlg(); // This dialog created initially
        },

        _initProps: function () {
            var model = this.model, features = ej.spreadsheetFeatures;
            this.XLClipboard = new features.clipboard(this);
            this.XLEdit = new features.editing(this);
            this.XLPrint = new features.print(this);
            this.XLRibbon = new features.ribbon(this);
            this.XLScroll = new features.scroller(this);
            if (model.allowDragAndDrop)
                this.XLDragDrop = new features.dragAndDrop(this);
            if (model.allowKeyboardNavigation)
                this.XLCellNav = new features.cellNavigation(this);
            if (model.allowFiltering)
                this.XLFilter = new features.filter(this);
            if (model.allowAutoFill)
                this.XLDragFill = new features.dragFill(this);
            if (model.allowCellFormatting || model.allowFormatAsTable || model.allowFormatPainter)
                this.XLFormat = new features.cellFormatting(this);
            if (model.allowCellFormatting)
                this.XLCellFrmtDlg = new features.formatCellDialog(this);
            if (model.allowConditionalFormats)
                this.XLCFormat = new features.cFormat(this);
            if (model.allowSearching)
                this.XLSearch = new features.findnreplace(this);
            if (model.allowCharts)
                this.XLChart = new features.chart(this);
            if (model.exportSettings.allowExporting)
                this.XLExport = new features.exporting(this);
            if (model.allowSorting)
                this.XLSort = new features.sorting(this);
            if (model.allowFreezing)
                this.XLFreeze = new features.freezepane(this);
            if (model.allowComments)
                this.XLComment = new features.comments(this);
            if (model.allowSelection)
                this.XLSelection = new features.selection(this);
            if (model.allowCharts || model.pictureSettings.allowPictures)
                this.XLShape = new features.shape(this);
            if (model.allowResizing)
                this.XLResize = new features.resizing(this);
            if (model.enableContextMenu)
                this.XLCMenu = new features.contextmenu(this);
            if (model.allowDataValidation)
                this.XLValidate = new features.validation(this);
            if (model.allowCellType)
                this.XLCellType = new features.cellType(this);
            if (model.enablePivotTable)
                this.XLPivot = new features.pivot(this);
            if (features.math)
                $.extend(ej.Spreadsheet.prototype, features.math);
            this._initPvtProps();
            this._initFATProps();
            if (this.model.customFormulas.length) // Update custom formulas
                this._updateCustomFormulas(this.model.customFormulas, "add");
            if (this.model.nameManager.length)
                this._refreshNameMngr(this.model.nameManager);
        },

        _initPvtProps: function () {
            var i = 1, obj = { rowIndex: 0, colIndex: 0 }, text = this._getLocStr("AutoFillOptions").split("/"),
                sheetIdx = this.getActiveSheetIndex(), numFormat = ej.preferredCulture(this.model.locale).numberFormat;
            this._dataContainer = this.isImport ? $.extend(true, {}, this._impData.dataContainer) : { sheets: {}, sheetCellType: {}, hashCode: [], sharedData: [], cellType: [], valData: [], cFormatData: [] };
            this._newSIndex = 1;
            this.isImport = this.isImport || false;
            this.mergeCenter = false;
            this.isDirty = false;
            this._calcID = CalcEngine.createSheetFamilyID();
            this._calcEngine = new CalcEngine(this, this._calcID);
            this._calcEngine.setUseDependencies(true);
            this._calcEngine.setExcelLikeComputations(true);
            this._calcEngine.setUseDatesInCalculations(true);
            this._calcEngine.setEnableFormulaErrorValidation(true);
            this._calcEngine.setCalculatingSuspended($("#" + this._id + "_CalcManual").find("span").hasClass("e-ss-calcauto"));
            this._sheets = [];
            this._cellProp = ["value", "value2", "type", "cFormatRule", "range", "thousandSeparator", "rule", "format", "border", "picture", "chart", "calcValue", "align", "hyperlink", "formats", "borders", "tformats", "tborders", "isFilterHeader", "filterState", "tableName", "comment", "formatStr", "decimalPlaces", "cellType", "isFilterHighlight", "pivot"];
            if (!this.isImport) {
                this.model.sheets.splice(0, 0, {});
                this._updateCellType();
            }
            while (i <= this.model.sheetCount) {
                if (!this.isImport)
                    this._dataContainer.sheets[i] = {};
                this._sheetSettings(i);
                this._newSIndex++;
                i++;
            }
            this._detachTable = null;
            this._isPrint = false;
            this._isSheetInsert = false;
            this._isSheetRename = false;
            this._isTableRename = false;
            this._tableClassName = null;
            this._isSheetNavigate = false;
            this._sheetCopy = { isSheetCopy: false, sheetContent: null };
            this._alertDialog = { element: null, action: null };
            this._dataManager = null;
            this._isUndo = false;
            this._undoCollection = [],
            this._redoCollection = [],
            this._ctrlKeyCount = 0;
            this._formulaRange = [];
            this._formulaHeight = 36;
            this._isSort = false;
            this._isPaste = false;
            this._isFATResize = false;
            this._isDisplayHeader = false;
            this._currencySymbol = numFormat.currency.symbol || "$";
            this._percentSymbol = numFormat.percent.symbol || "%";
            this._decimalSeparator = numFormat["."] || ".";
            this.operators = {
                '<': function (a, b) { return a < b },
                '>': function (a, b) { return a > b },
                '>=': function (a, b) { return a >= b },
                '<=': function (a, b) { return a <= b },
                '==': function (a, b) { return a === b },
                '!=': function (a, b) { return a !== b },
                '!': function (a) { return !a },
                '=': function (a) { return a }
            };
            this.parse = {
                "parseInt": function (a) { return parseInt(a); },
                "parseFloat": function (a) { return parseFloat(a); },
                "parseDate": function (a) { return new Date(a).getTime(); },
                "parseTime": function (a) { return new Date("01/01/1990 " + a).getTime(); },
                "length": function (a) { return (a.charAt(0) === "^") ? parseInt(a.split("^")[1]) : a.length; }
            };
            this._selMergeCells = [];
            this._mergeType = "merge-cells";
            this._delCells = [];
            this._deletedText = [];
            this._removeMergeColl = [];
            this._insData = {};
            this._deletedDimension = [];
            this._insDelStatus = "";
            this._isUndoRedo = false;
            this._indexBox = null;
            this._inputBox = null;
            this._focusTopElem = null;
            this._focusRightElem = null;
            this._focusBottomElem = null;
            this._focusLeftElem = null;
            this._dStartCell = obj;
            this._dEndCell = obj;
            this._pStartCell = obj;
            this._pEndCell = obj;
            this._pFillCell = obj;
            this._borderFocus = ["e-focusright", "e-focusbottom"];
            this._cutFocus = ["e-cutright", "e-cutbottom"];
            this._autoFillFocus = ["e-autofillright", "e-autofillbottom"];
            this._formulaBorder = [["e-bborderright", "e-bborderbottom"], ["e-rborderright", "e-rborderbottom"], ["e-vborderright", "e-vborderbottom"], ["e-gborderright", "e-gborderbottom"], ["e-pborderright", "e-pborderbottom"], ["e-oborderright", "e-oborderbottom"]];
            this._ctrlFormulaBorder = [["e-bctrlborderright", "e-bctrlborderbottom"], ["e-rctrlborderright", "e-rctrlborderbottom"], ["e-vctrlborderright", "e-vctrlborderbottom"], ["e-gctrlborderright", "e-gctrlborderbottom"], ["e-pctrlborderright", "e-pctrlborderbottom"], ["e-octrlborderright", "e-octrlborderbottom"]];
            this._borderTypes = [
               { id: "bottomborder", text: this._getLocStr("BottomBorder"), parentId: null, sprite: "e-icon e-ss-bottomborder" },
               { id: "topborder", text: this._getLocStr("TopBorder"), parentId: null, sprite: "e-icon e-ss-topborder" },
               { id: "leftborder", text: this._getLocStr("LeftBorder"), parentId: null, sprite: "e-icon e-ss-leftborder" },
               { id: "rightborder", text: this._getLocStr("RightBorder"), parentId: null, sprite: "e-icon e-ss-rightborder" },
               { id: "noborder", text: this._getLocStr("NoBorder"), parentId: null, sprite: "e-icon e-ss-noborder" },
               { id: "allborder", text: this._getLocStr("AllBorder"), parentId: null, sprite: "e-icon e-ss-allborder" }
            ];
            this._datePattern = ["year", "month", "day", "hours", "minutes", "seconds"];
            this._styleColl = {};
            this._borderStyle = "solid";
            this._borderColor = "#000000";
            this._borderStyles = ["solid", "dashed", "dotted"];
            this._ddlCell = null;
            this._cOpt = {};
            this._shapeChange = false;
            this._dupDetails = false;
            this._paste = false;
            this._autoFillElem = null;
            this._autoFillOptElem = null;
            this._fillOptionMenuData = [
              { id: "copycells", text: text[0], parentId: null, sprite: "e-icon e-ss-fillselect" },
              { id: "fillseries", text: text[1], parentId: null, sprite: "e-icon e-ss-filloption" },
              { id: "fillformattingonly", text: text[2], parentId: null, sprite: "e-icon e-ss-filloption" },
              { id: "fillwithoutformatting", text: text[3], parentId: null, sprite: "e-icon e-ss-filloption" },
              { id: "flashfill", text: text[4], parentId: null, sprite: "e-icon e-ss-filloption" }
            ];
            this._formulaSuggElem = null;
            this._isFormulaSuggestion = false;
            this._shiftKeyEnabled = false;
            this._preventctrlkey = false;
            this._rAlign = "e-ralign";
            this._cAlign = "e-calign";
            this._chartBorder = [["e-rcbright", "e-rcbbottom"], ["e-vcbright", "e-vcbbottom"], ["e-bcbright", "e-bcbbottom"]];
            this._selectionBorder = ["e-selecttop", "e-selectright", "e-selectbottom", "e-selectleft"];
            this._autofillBorder = ["e-autofilltop", "e-autofillright", "e-autofillbottom", "e-autofillleft"];
            this._thinBorder = ["e-thinright", "e-thinbottom"];
            this._rcRegx = new RegExp('\\b' + "e-rc" + '.*\\b', 'g');
            this._formatRegx = new RegExp('\\b' + "e-format" + '.*?\\b', 'g');
            this._borderRegx = new RegExp('\\b' + "e-border" + '.*?\\b', 'g');
            this._formulaChanged = [];
            this._ref = [];
            this._prevText = "";
            this._prevVal = "";
            this._dlgHLClick = false;
            this._selectDataval = {};
            this._undoInputobj = {};
            this._cureditedCell = '';
            this._colHeaderHeight = 22;
            this._rowHeaderWidth = 30;
            this._scrollerHeight = 18;
            this._scrollerWidth = 18;
            this._bufferCnt = 5;
            this._maxRowCnt = 1048576;
            this._maxColCnt = 16384;
            this._impData = this._impData || null;
            this._isNew = false;
            this._isSheetReq = false;
            this._intrnlReq = false;
            this._isFilterApplied = false;
            this._commentCount = 0;
            this._tableCnt = 1;
            this._uploadImage = false;
            this._responsiveWidth = 0;
            this._responsiveHeight = 0;
            this._celltypes = [];
            this._reqCnt = 0;
            this._resCnt = 0;
            this._pageClickArgs = null;
            this._gotoPageArgs = null;
            this._updateFormulaCollection();
            this._isRibbonClick = false;
            this._intrnlUpdate = false;
            this._isPvtNameEdit = false;
            this._hlColor = "#428bca";
            this._isFilter = false;
            this._isShowHide = false;
            this._insRows = {};
            this._isTotalRow = false;
            this._scrollReverse = false;
            this._phoneMode = this.model.scrollSettings.isResponsive && document.documentElement.clientWidth < 420;
            this._tabMode = this.model.scrollSettings.isResponsive && (document.documentElement.clientWidth > 419 && document.documentElement.clientWidth < 617);
            this._dlgHeight = this._responsiveHeight - 2;
            this._dlgWidth = this._responsiveWidth - 2;
            this._isTouchEvt = false;
            this._isTouchMoveSel = false;
            this._isTouchScroll = false;
            this._startXY = null;
            this._touchArgs = null;
            this._isResized = false;
            this._isRibbonDestroyed = false;
            this._resizeColl = [];
            this._delWrapColl = {};
            this._isInsdel = false;
            this._canOverflow = true;
            this.preventFilterPopup = false;
            this._FATStyles = {};
            this._isFiltered = false;
            this._dautoFillCell = { rowIndex: 0, colIndex: 0 };
            this._isPublic = false;
            this._fRow = { rowAdj: true, fRowCnt: 0 };
            this._fCol = { colAdj: true, fColCnt: 0 };
            this.isPasteValuesOnly = false;
            this._isSaveAsJSON = false;
        },

        _initFATProps: function () {
            var i, len, b = 'w:bold', c1 = 'c:#FFFFFF', c2 = 'c:#000000', c3 = 'c:#2F75B5', c4 = 'c:#ED7D31', c5 = 'c:#FFC000', b1 = '1px solid #000000', b2 = '1px solid #2f75b5', b3 = '1px solid #ED7D31', b4 = '1px solid #FFC000',
            d1 = 'b:#D9D9D9', d2 = 'b:#DDEBF7', d3 = 'b:#FCE4D6', d4 = 'b:#FFF2CC', d5 = 'b:#000000', d6 = 'b:#DBECF6', d7 = 'b:#FFE2C6', d8 = 'b:#FFF1BF', d9 = 'b:#000000', d10 = 'b:#D7D7D7', d11 = 'b:#FFC000', d12 = 'b:#5B9BD5', d13 = 'b:#Ed7D31',
            style = 'hl?' + b + ';' + c2 + ';bo:tb-' + b1 + '&cl?' + d1 + ';' + c2 + ',' + c2 + '&cb?b-' + b1 + '/hl?' + b + ';bo:tb-' + b2 + ';' + c3 + '&cl?' + d2 + ';' + c3 + ',' + c3 + '&cb?b-' + b2 + '/hl?' + b + ';bo:tb-' + b3 + ';' + c4 + '&cl?' + d3 + ';' + c4 + ',' + c4 + '&cb?b-' + b3 + '/hl?' + b + ';bo:tb-' + b4 + ';' + c5 + '&cl?' + d4 + ';' + c5 + ',' + c5 + '&cb?b-' + b4 + '/hl?' + b + ';' + d5 + ';' + c1 + ';bo:o-' + b1 + '&cl?bo:t-' + b1 + ';' + c2 + '&cb?o-' + b1 + '/hl?bo:o-' + b2 + ';' + b + ';' + d12 + ';' + c1 + '&cl?bo:t-' + b2 + ';' + c2 + '&cb?o-' + b2 + '/hl?' + b + ';b:#EB7E2F;' + c1 + ';bo:o-' + b3 + '&cl?bo:t-' + b3 + ';' + c2 + '&cb?o-' + b3 + '/hl?' + b + ';' + d11 + ';' + c1 + ';bo:o-' + b4 + '&cl?bo:t-' + b4 + ';' + c2 + '&cb?o-' + b4 + '/hl?' + b + ';bo:gb-' + b1 + ';' + c2 + '&cl?' + d1 + ';' + c2 + ',' + c2 + '&cb?gb-' + b1 + '/hl?' + b + ';bo:gb-' + b2 + ';' + c2 + '&cl?' + d2 + ';' + c2 + ',' + c2 + '&cb?gb-' + b2 + '/hl?' + b + ';bo:gb-' + b3 + ';' + c2 + '&cl?' + d3 + ';' + c2 + ',' + c2 + '&cb?gb-' + b3 + '/hl?' + b + ';bo:gb-' + b4 + ';' + c2 + '&cl?' + d4 + ';' + c2 + ',' + c2 + '&cb?gb-' + b4 + '/hl?' + b + ';' + d5 + ';' + c1 + '&cl?b:#A6A6A6;' + c2 + ',' + d1 + ';' + c2 + '/hl?' + b + ';' + d12 + ';' + c1 + '&cl?b:#BDD7EE;' + c2 + ',' + d2 + ';' + c2 + '/hl?' + b + ';' + d13 + ';' + c1 + '&cl?b:#F8CBAD;' + c2 + ',' + d3 + ';' + c2 + '/hl?' + b + ';' + d11 + ';' + c1 + '&cl?b:#FFE699;' + c2 + ',' + d4 + ';' + c2 + '/hl?' + b + ';' + d10 + ';' + c2 + ';bo:gb-' + b1 + '&cl?b:#A7A7A7;' + c2 + ',' + d10 + ';' + c2 + '&cb?gb-' + b1 + '/hl?' + b + ';' + d6 + ';' + c2 + ';bo:gb-' + b2 + '&cl?b:#BED8F1;' + c2 + ',' + d2 + ';' + c2 + '&cb?gb-' + b2 + '/hl?' + b + ';' + d7 + ';' + c2 + ';bo:gb-' + b3 + '&cl?b:#F6CAAD;' + c2 + ',' + d7 + ';' + c2 + '&cb?gb-' + b3 + '/hl?' + b + ';' + d8 + ';' + c2 + ';bo:gb-' + b4 + '&cl?b:#FDE18D;' + c2 + ',' + d8 + ';' + c2 + '&cb?gb-' + b4 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#404040;' + c1 + ',b:#737373;' + c1 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#2F75B5;' + c1 + ',' + d12 + ';' + c1 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#C65911;' + c1 + ',' + d13 + ';' + c1 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#BF8F00;' + c1 + ',' + d11 + ';' + c1,
            name = ["Light1", "Light2", "Light3", "Light5", "Light8", "Light9", "Light10", "Light12", "Light15", "Light16", "Light17", "Light19", "Medium8", "Medium9", "Medium10", "Medium12", "Medium22", "Medium23", "Medium24", "Medium26", "Dark1", "Dark2", "Dark3", "Dark5"];
            style = style.split('/');
            i = 0; len = name.length;
            while (i < len) {
                this._FATStyles["TableStyle" + name[i]] = { format: this.XLRibbon._getFormatAsTableInput(style[i]), formatName: "TableStyle" + name[i] };
                i++;
            }
            this.XLFormat._formatAsTableStyle = this._FATStyles["TableStyle" + name[0]];
        },

        _updateResponsiveSettings: function () {
            var isIE8 = ((ej.browserInfo().name === "msie") && (ej.browserInfo().version === "8.0"));
            var clientRect = this.element[0].getClientRects()[0];
            this._responsiveHeight = Math.floor(isIE8 ? this.element[0].offsetHeight : clientRect ? clientRect.height : 0);
            this._responsiveWidth = Math.floor(isIE8 ? this.element[0].offsetWidth : clientRect ? clientRect.width : 0);
        },

		_getElementDimension: function () {
            var rbnHt = 0, elemWidth, formulaHt = 0, contentHt = 0;
            if (this.model.showRibbon) {
                var rObj = $('#' + this._id + '_Ribbon').data('ejRibbon');
                elemWidth = rObj.element[0].offsetWidth;
                rbnHt = rObj.element[0].offsetHeight;
            }
            if (this.model.allowFormulaBar) {
                var formulaElem = $('#' + this._id + '_formulabar')[0];
                formulaHt = formulaElem.offsetHeight;
                if (!elemWidth)
                    elemWidth = formulaElem.offsetWidth;
            }
            var mPanel = this.element.find(".e-spreadsheetmainpanel")[0];
            contentHt = mPanel.offsetHeight;
            if (!elemWidth)
                elemWidth = mPanel.offsetWidth;
            return { width: elemWidth + 2, height: (rbnHt + formulaHt + contentHt + 1) }
        },

        _sheetSettings: function (sheetIdx) {
            var sIdx, sheet, impSheet, name, sheetName, msheet, psheet;
            if (!this._isSheetReq) {
                msheet = this.getSheet(sheetIdx);
                sheetName = this._generateSheetName(this._newSIndex);
                sheet = this.model.sheets[sheetIdx] = {
                    colCount: msheet && msheet.colCount || this.model.columnCount,
                    rowCount: msheet && msheet.rowCount || this.model.rowCount,
                    _formulaCollection: {},
                    columnsWidthCollection: [],
                    _colWidthCollection: [],
                    _ofColWidthColl: [],
                    rowsHeightCollection: [],
                    _rowHeightCollection: [],
                    _rowIdxColl: [],
                    _spreadSheetPager: null,
                    showHeadings: (msheet && !this.isUndefined(msheet.showHeadings)) ? msheet.showHeadings : true,
                    showGridlines: (msheet && !this.isUndefined(msheet.showGridlines)) ? msheet.showGridlines : true,
                    dataSource: (msheet && msheet.dataSource) || null,
                    _jsonData: msheet ? (msheet.dataSource instanceof ej.DataManager ? null : msheet.dataSource) : null,
                    _dataManager: (msheet && msheet.dataSource instanceof ej.DataManager) ? msheet.dataSource : null,
                    query: (msheet && msheet.query) || null,
                    primaryKey: (msheet && msheet.primaryKey) || "",
                    startCell: (msheet && msheet.startCell) || "A1",
                    topLeftCell: (msheet && msheet.topLeftCell) || "A1",
                    fieldAsColumnHeader: (msheet && msheet.fieldAsColumnHeader) || false,
                    showHeader: (msheet && msheet.showHeader === false) ? false : true,
                    headerStyles: (msheet && msheet.headerStyles) || null,
                    batchChanges: { added: [], changed: [], deleted: [] },
                    range: [0, 0, 0, 0],
                    fields: [],
                    _isDataManager: false,
                    _isOffline: false,
                    _hasDataSrc: false,
                    columns: msheet && msheet.columns || [],
                    _columnStyles: {},
                    _rowStyles: {},
                    cellTypes: msheet && msheet.cellTypes || [],
                    rows: msheet && msheet.rows || null,
                    _excelFilter: null,
                    filterSettings:
                    {
                        filteredColumns: [],
                        maxFilterChoices: 1000,
                        filteredRange: [],
                        range: "",
                        tableRange: []
                    },
                    frozenRows: msheet && msheet.frozenRows || 0,
                    frozenColumns: msheet && msheet.frozenColumns || 0,
                    _frozenRows: msheet && msheet.frozenRows && msheet.frozenRows + 1 || 1,
                    _frozenColumns: msheet && msheet.frozenColumns && msheet.frozenColumns + 1 || 1,
                    _fHMergeRows: [],
                    _fHMergeCols: [],
                    paneTopLeftCell: msheet && msheet.paneTopLeftCell || "A1",
                    _selectedRange: {},
                    _selectedCellColors: [],
                    columnWidth: (msheet && msheet.columnWidth) || this.model.columnWidth,
                    rowHeight: this.model.rowHeight,
                    _frozenHeight: 0,
                    _frozenWidth: 0,
                    _firstRow: { idx: 0, value: 0 },
                    _firstCol: { idx: 0, value: 0 },
                    _topRow: { idx: 0, value: 0 },
                    _bottomRow: { idx: 0, value: 0 },
                    _leftCol: { idx: 0, value: 0 },
                    _rightCol: { idx: 0, value: 0 },
                    _filterColl: {},
                    _filteredColumns: [],
                    _commentColl: {},
                    _mergeColl: {},
                    _unmergeColl: {},
                    _delmergeColl: {},
                    _hideMergeColl: {},
                    _clrMergeColl: [],
                    _clrWrapColl: [],
                    _selectedCells: [],
                    selectedRange: [0, 0, 0, 0],
                    tableManager: {},
                    _header: {},
                    _selectedCellIndexes: [],
                    _startCell: { rowIndex: 0, colIndex: 0 },
                    _endCell: { rowIndex: 0, colIndex: 0 },
                    _activeCell: { rowIndex: 0, colIndex: 0 },
                    _autoFillCell: { rowIndex: 0, colIndex: 0 },
                    rangeSettings: msheet && msheet.rangeSettings || [],
                    sheetInfo: { text: sheetName, value: this._getLocStr("Sheet") + this._newSIndex, isVisible: true },
                    _multipleFiltering: false,
                    _multifilterIdx: [],
                    _filteredByColor: "",
                    staticWidth: 0,
                    _fRow: 0,
                    _fCol: 0,
                    hideColsCollection: {},
                    hideRowsCollection: msheet && msheet.hideRowsCollection || [],
                    _hiddenFreezeRows: [],
                    _hiddenFreezeCols: [],
                    _filterHRowsColl: [],
                    _restrictedHeightRows: [],
                    filteredRowsCollection: [],
                    _rHeightCollection: [],
                    _frHiddenHeight: 0,
                    _fpHiddenHeight: 0,
                    _fpHiddenWidth: 0,
                    _pTarget: {},
                    _cSpan: 1,
                    _rSpan: 1,
                    usedRange: { rowIndex: 0, colIndex: 0 },
                    mergedCells: [],
                    shapeMngr: { picture: {}, chart: {}, sharedPics: [] },
                    pivotMngr: { pivot: {} },
                    _nmValue: {},
                    _nmEdit: false,
                    _wrapHtCollection: {},
                    _isChartBorderDrawn: false,
                    _virtualBlockCnt: 0,
                    _virtualBlockRowCnt: 0,
                    _virtualContBlockIdx: 1,
                    _virtualTopTBodyHgt: 0,
                    _virtualBottomTBodyHgt: 0,
                    _virtualTBodyHgt: 0,
                    _scrollTop: 0,
                    _scrollLeft: 0,
                    _virtualRowIdx: [],
                    _virtualTopTBodyOffset: { top: 0, bottom: 0 },
                    _virtualContTBodyOffset: { top: 0, bottom: 0 },
                    _virtualBottomTBodyOffset: { top: 0, bottom: 0 },
                    _virtualDataLoadedBlks: [],
                    _virtualDataMngrLoadedBlks: [1, 2],
                    _isVirtualTopReached: true,
                    _isVirtualEndReached: false,
                    _isLoaded: false,
                    _isImpSLoad: false,
                    _isRowSelected: false,
                    _isColSelected: false,
                    _isSheetSelected: false,
                    isSheetProtected: false,
                    _contWidth: 0,
                    _isRangeSelected: false,
                    _isEmptyActiveCell: false,
                    _isMultiSelect: false,
                    _isImported: this.isImport,
                    _isRequested: false,
                    _goToCollection: { multiple: false, selected: [] },
                    _showLockCellAlert: false,
                    _reqCnt: 0,
                    _resCnt: 0,
                    _templateColCount: 0,
                    _isTemplate: false,
                    _cFormatFormula: {},
                    _isVPRendered: false,
                    _isDataMoved: false,
                    _vPortHgt: 0,
                    _vPortWth: 0,
                    cFormatRule: msheet && msheet.cFormatRule || [],
                    mergeCells: msheet && msheet.mergeCells || [],
                    hideRows: msheet && msheet.hideRows || [],
                    hideColumns: msheet && msheet.hideColumns || [],
                    border: msheet && msheet.border || [],
                    isResized: false,
                    _isOpened:false,
                    _wrapColl: {},
					_formatColl: {},
                    _isFreezed: false,
                    _ftopRowIdx: 0,
                    _fleftColIdx: 0,
                    _contScrollTop: 0,
                    _contScrollLeft: 0,
                    _fDivTop: 0,
                    _fDivLeft: 0,
                    _isRibCollapsed: false
                };
                this._initRangeSettings(sheetIdx);
                name = sheet.sheetInfo.value;
                psheet = this._sheets[sheetIdx] = { _contentColGroup: null, _content: null, _sheetRowHeaderContent: null, _sheetHeader: null, _sheetRowHeader: null, _sheetContent: null, _Rows: null, _contTBody: null, _rowHdrTBody: null };
                this._calcEngine.registerGridAsSheet(name, name, this._calcID);
            }
            else
                sheet = this.getSheet(sheetIdx);
            if (this.isImport) {
                impSheet = this._impData.model.sheets[sheetIdx];
                sIdx = this.getRangeIndices(impSheet.topLeftCell || "A1");
                sheet.sheetInfo.text = impSheet.sheetInfo.text;
                if (this.isUndefined(impSheet.sheetInfo.isVisible))
                    sheet.sheetInfo.isVisible = true;
                else
                    sheet.sheetInfo.isVisible = impSheet.sheetInfo.isVisible;
                if (!this.model.importSettings.allowSheetOnDemand || sheetIdx === this.getActiveSheetIndex())
                    sheet._isRequested = true;
                if (sheet._isRequested) {
                    if (impSheet.usedRange) {
                        if (impSheet.usedRange.rowIndex)
                            sheet.usedRange.rowIndex = impSheet.usedRange.rowIndex;
                        if (impSheet.usedRange.colIndex)
                            sheet.usedRange.colIndex = impSheet.usedRange.colIndex;
                    }
                    if (impSheet._startCell) {
                        if (impSheet._startCell.rowIndex)
                            sheet._startCell.rowIndex = impSheet._startCell.rowIndex;
                        if (impSheet._startCell.colIndex)
                            sheet._startCell.colIndex = impSheet._startCell.colIndex;
                    }
                    if (impSheet._endCell) {
                        if (impSheet._endCell.rowIndex)
                            sheet._endCell.rowIndex = impSheet._endCell.rowIndex;
                        if (impSheet._endCell.colIndex)
                            sheet._endCell.colIndex = impSheet._endCell.colIndex;
                    }
                    if (impSheet._activeCell) {
                        if (impSheet._activeCell.rowIndex)
                            sheet._activeCell.rowIndex = impSheet._activeCell.rowIndex;
                        if (impSheet._activeCell.colIndex)
                            sheet._activeCell.colIndex = impSheet._activeCell.colIndex;
                    }
                    if (impSheet.columnsWidthCollection)
                        sheet.columnsWidthCollection = impSheet.columnsWidthCollection;
                    if (impSheet.rowsHeightCollection) {
                        var i, len, rowIdxCln = impSheet.hideRowsCollection || [];
                        for (i = 0, len = rowIdxCln.length; i < len; i++)
                            impSheet.rowsHeightCollection[parseInt(rowIdxCln[i])] = 0;
                        sheet.rowsHeightCollection = $.extend(true, [], impSheet.rowsHeightCollection);
                    }
                    if (!ej.isNullOrUndefined(impSheet.showGridlines))
                        sheet.showGridlines = impSheet.showGridlines;
                    if (impSheet.hideRowsCollection)
                        sheet.hideRowsCollection = impSheet.hideRowsCollection || [];
                    if (impSheet.shapeMngr.picture.length)
                        sheet.shapeMngr.sharedPics = impSheet.shapeMngr.sharedPics;
                    if (impSheet.isSheetProtected)
                        sheet.isSheetProtected = impSheet.isSheetProtected;
                    if (impSheet._restrictedHeightRows)
                        sheet._restrictedHeightRows = impSheet._restrictedHeightRows || [];
                    if (impSheet._isColSelected)
                        sheet._isColSelected = impSheet._isColSelected;
                    if (impSheet._isRowSelected)
                        sheet._isRowSelected = impSheet._isRowSelected;
                    if (impSheet.showHeadings === false)
                        sheet.showHeadings = false;
                    if (impSheet.frozenRows) {
                        sheet.frozenRows = sheet._frozenRows = sIdx[0] + impSheet.frozenRows;
                        sheet._frozenRows = sheet.frozenRows + 1;
                    }
                    if (impSheet.frozenColumns) {
                        sheet.frozenColumns = sheet._frozenColumns = sIdx[1] + impSheet.frozenColumns;
                        sheet._frozenColumns = sheet.frozenColumns + 1;
                    }
                }
            }
        },

        _generateSheetName: function (index) {
            var i, len, sName, sheet, shtNo = 1, sheetModel = this.model.sheets, txt = this._getLocStr("Sheet"),
                sheet = sheetModel[index];
            sName = sheet && sheet.sheetName || (txt + index);
            for (i = 1, len = sheetModel.length; i < len; i++) {
                if (sheetModel[i].sheetInfo && sName === sheetModel[i].sheetInfo.text) {
                    i = 0;
                    sName = sheet && sheet.sheetName ? (sheet.sheetName + shtNo++) : (txt + ++index);
                }
            }
            return sName;
        },

        _initRangeSettings: function (sheetIdx) {
            var setting, sheet = this.getSheet(sheetIdx), i = sheet.rangeSettings.length;
            if (i) {
                while (i--) {
                    setting = sheet.rangeSettings[i];
                    if (setting.dataSource) {
                        setting._jsonData = setting._dataManager = null;
                        if (setting.dataSource instanceof ej.DataManager)
                            setting._dataManager = setting.dataSource;
                        else
                            setting._jsonData = setting.dataSource;
                        if (setting.showHeader != false)
                            setting.showHeader = true;
                    }
                }
            }
        },

        _initCSSTag: function () {
            if (!document.getElementById(this._id + "_sscustomformat")) {
                if (this.isImport)
                    this._dataContainer.hashCode = [];
                var prop, len, i = 0, stag;
                stag = this._renderStyleTag("custom");
                if (this.isImport)
                    this._refreshImpStyles(this._impData.dataContainer.hashCode);
                else if (this.XLFormat) {
                    prop = "s:11pt/b:#FFC7CE;c:#82012A;f:calibri;s:11pt/b:#C6EED2;c:#0A7043;f:calibri;s:11pt/b:#FEEC9B;c:#826717;f:calibri;s:11pt/f:Calibri;w:bold;v:top;s:11pt/f:calibri;s:18pt/b:#DDE5F6;f:calibri;s:11pt/b:#FDE0D2;f:calibri;s:11pt/b:#EEEEEC;f:calibri;s:11pt/b:#FEF4CD;f:calibri;s:11pt/b:#9CC0E7;f:calibri;s:11pt/b:#F9AD7B;f:calibri;s:11pt/b:#C9C9C9;f:calibri;s:11pt/b:#FED965;f:calibri;s:11pt/b:#559AD9;c:#FFFFFF;f:calibri;s:11pt/b:#EB7E2F;c:#FFFFFF;f:calibri;s:11pt/b:#A5A5A5;c:#FFFFFF;f:calibri;s:11pt/b:#FDBF01;c:#FFFFFF;f:calibri;s:11pt".split("/");
                    len = prop.length;
                    while (i < len) {
                        this.XLFormat._createFormatClass(this._getStyleAsJSON(prop[i]), null, true);
                        i++;
                    }
                }
                prop = ".e-spreadsheet .e-hide, .e-spreadsheet .e-mc-hide, .e-spreadsheet .e-fr-hide, .e-spreadsheet .e-fc-hide, .e-spreadsheet .e-c-hide, .e-spreadsheet .e-r-hide, .e-spreadsheet .e-col-hide{ display: none}";
                prop += ".e-spreadsheet .e-rowcell.e-redft { background-color: #FFC7CE; color: #9C0055;} .e-spreadsheet .e-rowcell.e-yellowft { background-color: #FFEB9C; color: #9C6500;}";
                prop += ".e-spreadsheet .e-rowcell.e-greenft { background-color: #C6EFCE;   color: #006100;} .e-spreadsheet .e-rowcell.e-redf { background-color: #FFC7CE;} .e-spreadsheet .e-rowcell.e-redt { color: #9C0055;}";
                prop += ".e-spreadsheet .e-rowcell.e-hlcell { background-color: #FFFF00; color: #FF0000;} .e-spreadsheet .e-rowcell.e-goto-blank { background-color: #C6C6C6;}";
                stag.styleSheet ? stag.styleSheet.cssText += prop : stag.appendChild(document.createTextNode(prop));
            }
            this._renderStyleTag("showhide");
        },

        _initEditForm: function () {
            var $acElem, $form, $valElem;
            $acElem = ej.buildTag("input", "", { display: "none" }, { id: this._id + "_AutoComplete" });
            $acElem.addClass("e-hide");
            this.element.append($acElem);
            this.XLEdit._renderAutoComplete($acElem, "", null, true);
            $acElem.data("ejAutocomplete")._setListPosition = function () { }; //JS-35957
            $form = ej.buildTag("form", "", { width: 1, height: 1, display: "none" }, { id: this._id + "EditForm" }), $valElem = ej.buildTag("input", "", { width: 1, height: 1, overflow: "hidden", opacity: 0 }, { id: this._id + "_ValElem" });
            $form.append($valElem);
            $valElem.data("id", this._id);
            this.element.append($form);
        },

        _getStyleAsJSON: function (str) {
            var istr, len, lwn, i = 0, obj = {}, prop = { b: 'background-color', c: 'color', f: 'font-family', s: 'font-size', w: 'font-weight', v: 'vetical-align', bo: 'border' };
            str = str.split(';'), len = str.length;
            while (i < len) {
                istr = str[i].split(':');
                obj[prop[istr[0]]] = istr[0] === 'bo' ? this.XLRibbon._getBorderObj(istr[1].split('-')[0], istr[1].split('-')[1]) : istr[1];
                i++;
            }
            return obj;
        },

        _initLayout: function () {
            if (this.model.showRibbon) {
                this.XLRibbon._renderRibbon();
                if (this._tabMode)
                    $("#" + this._id + "_Ribbon").ejRibbon("collapse");
            }
            if (this.model.allowFormulaBar)
                this._renderFormulaBar();
            this._renderFUpload();
            this._renderLayout();
        },

        _renderLayout: function () {
            var i, cnt;
            this._renderPanel();
            this._initTags();
            this._initDependencies();
            this._renderFooter();
            this._refreshSheetLayout();
            if (this.model.scrollSettings.allowVirtualScrolling || this.model.scrollSettings.allowSheetOnDemand)
                i = cnt = this.getActiveSheetIndex()
            else {
                i = 1;
                cnt = this.model.sheetCount;
            }
            while (i <= cnt) {
                this._initSheet(i);
                i++;
            }
        },

        _renderPanel: function () {
            var $mainDiv, div, settings = this.model.scrollSettings;
            $mainDiv = ej.buildTag('div.e-spreadsheetgrppanel', "", {}, { id: this._id + "GroupPanel" });
            this.setGroupPanel($mainDiv);
            div = ej.buildTag('div.e-spreadsheetmainpanel', this._renderDIV("e-spreadsheet-list", ""), {}, { id: this._id + "MainPanel" });
            $mainDiv.append(div);
            this.setMainPanel(div);
            div = ej.buildTag('div.e-spreadsheetactpanel', "", { height: settings.height, width: this.model.activationPanelWidth - 1, display: "none" }, { id: this._id + "ActivationPanel" });
            $mainDiv.append(div);
            this.setActivationPanel(div);
            this.element.append($mainDiv);
        },

        _refreshSheetLayout: function () {
            var contentHt, formulaHeight, ribHgt, ribbonHeight, diffHt, ribContHeight = -1, pagerHt = this.model.pageSettings.pagerHeight + 1;
            this._updateResponsiveSettings();
            this.XLRibbon._ribbonState && (ribContHeight = $("#" + this._id + "_Ribbon").find(".e-content:eq(1)").height());
            ribHgt = this._phoneMode ? $("#" + this._id + "_Ribbon").height() : $("#" + this._id + "_Ribbon").find(".e-header").height() + ribContHeight + 2;
            formulaHeight = this.model.allowFormulaBar ? this._formulaHeight : 0;
            ribbonHeight = (ribHgt && this.model.showRibbon && $("#" + this._id + "_Ribbon").is(":visible")) ? ribHgt : 0;
            (!this.model.showPager || !this.element.find(".e-spreadsheetfooter").is(":visible")) && (pagerHt = 1);
            contentHt = this._responsiveHeight - (ribbonHeight + formulaHeight + 2);
            ((this._browserDetails.name != "msie") && !this._isAutoWHMode) && this.element.find(".e-spreadsheet-list").height(contentHt - pagerHt);
        },

        _initTags: function () {
            var span = ej.buildTag('span#' + this._id + '_emptySpan'), div = ej.buildTag('div#' + this._id + '_emptyDiv');
            this.element.find('.e-spreadsheetmainpanel')[0].insertBefore(span[0], this.element.find('.e-spreadsheetmainpanel').find(".e-spreadsheet-list")[0]);
            this.element.find('.e-spreadsheetmainpanel')[0].insertBefore(div[0], this.element.find('.e-spreadsheetmainpanel').find(".e-spreadsheet-list")[0]);
            this._refreshGlobalSpan();
        },

        _refreshGlobalSpan: function (span, width) {
            span = span || document.getElementById(this._id + (width ? '_emptyDiv' : '_emptySpan'));
            span.textContent = span.className = '';
            if (this._browserDetails.name === "msie" && this._browserDetails.version === "8.0")
                $(span).removeAttr('style').text("");
            else
                span.style = '';
        },

        _initSheet: function (sheetIdx) {
            var len, i = 0, sheet = this.getSheet(sheetIdx), settings = this.getDataSettings(sheetIdx);
            this._updateResponsiveSettings();
            this._initViewPort(sheetIdx);
            if (settings && !this._sheetCopy.isSheetCopy) {
                len = settings.length;
                while (i < len) {
                    this._initDataSrc(sheetIdx, sheet, settings[i]);
                    i++;
                }
            }
            if (sheet._reqCnt === sheet._resCnt)
                this._renderSheet(sheetIdx);
        },

        _initViewPort: function (sheetIdx) {
            var pagerHt = -1, actPnlWidth, ribbonHgt, scrollerHgt, scrollerWth, colHdrHgt, rowHdrWth, formulaHgt, settings = this.model.scrollSettings, sheet = this.getSheet(sheetIdx);
            actPnlWidth = ribbonHgt = scrollerHgt = scrollerWth = colHdrHgt = rowHdrWth = formulaHgt = 0;
            if (settings.allowScrolling) {
                scrollerHgt = this._scrollerHeight;
                scrollerWth = this._scrollerWidth;
            }
            if (sheet.showHeadings) {
                colHdrHgt = this._colHeaderHeight;
                rowHdrWth = this._rowHeaderWidth;
            }
            if (this.model.showRibbon) {
                ribbonHgt = $("#" + this._id + "_Ribbon").height();
                ribbonHgt = ribbonHgt < 189 ? ribbonHgt : 188; //188 max height of Ribbon
            }
            if (this.model.allowFormulaBar)
                formulaHgt = this._formulaHeight;
            if (this.model.showPager && this.element.find(".e-spreadsheetfooter").is(":visible"))
                pagerHt = this.model.pageSettings.pagerHeight;
            if (this.getActivationPanel().is(":visible"))
                actPnlWidth = this.getActivationPanel().width();
            sheet._vPortHgt = this._responsiveHeight - (ribbonHgt + formulaHgt + colHdrHgt + pagerHt + scrollerHgt);
            sheet._vPortWth = this._responsiveWidth - (actPnlWidth + scrollerWth + rowHdrWth);
            if (settings.allowVirtualScrolling)
                sheet._virtualBlockRowCnt = Math.ceil(sheet._vPortHgt / sheet.rowHeight) + this._bufferCnt;
        },

        _initDataSrc: function (sheetIdx, sheet, setting) {
            if (setting._dataManager) {
                if (setting._dataManager instanceof ej.DataManager) {
                    if (setting._dataManager.ready) {
                        var proxy = this;
                        sheet._reqCnt++;
                        this._reqCnt++;
                        setting._dataManager.ready.done(function (args) {
                            proxy._initDataMngr(sheetIdx, sheet, setting);
                        });
                    }
                    else
                        this._initDataMngr(sheetIdx, sheet, setting);
                }
            }
            else if (setting._jsonData)
                setting.count = setting._jsonData.length;
        },

        _initDataMngr: function (sheetIdx, sheet, setting) {
            var len, query, range, queries, promise, queryCnt, cnt = 0, proxy = this;
            setting._isDataManager = true;
            setting._isOffline = setting._dataManager.dataSource.offline;
            if (!setting.query)
                setting.query = new ej.Query();
            setting.query.requiresCount();
            if (this.model.scrollSettings.allowVirtualScrolling) {
                queries = setting.query.queries;
                len = queries.length;
                if (len) {
                    while (len--) {
                        query = queries[len];
                        if (query.fn === "onTake") {
                            cnt = query.e.nos;
                            queries.splice(len, 1);
                        }
                        else if (query.fn === "onSkip")
                            setting._skip = query.e.nos;
                    }
                }
                queryCnt = sheet._virtualBlockRowCnt * 2;
                if (setting.startCell) {
                    range = this.getRangeIndices(setting.startCell);
                    if (range[0])
                        queryCnt -= range[0] - 0;
                }
                if (cnt && cnt < queryCnt)
                    queryCnt = cnt;
                setting.query.take(queryCnt);
            }
            promise = setting._dataManager.executeQuery(setting.query);
            promise.done(function (e) {
                len = e.count || e.result.length;
                if (len) {
                    setting._jsonData = e.result;
                    setting.count = cnt || len;
                }
                proxy._respHandler(sheetIdx);
            });
            promise.fail(function (e) {
                proxy._respHandler(sheetIdx);
            });
            if (!setting._dataManager.isDataAvailable) {
                sheet._reqCnt++;
                this._reqCnt++;
            }
        },

        _respHandler: function (sheetIdx) {
            var sheet = this.getSheet(sheetIdx);
            sheet._resCnt++;
            this._resCnt++;
            if (sheet._reqCnt === sheet._resCnt)
                this._renderSheet(sheetIdx);
            this._initComplete();
        },

        _renderSheet: function (sheetIdx) {
            var div, sIdx, impData, hfreeze, actSheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), name = sheet.sheetInfo.value, settings = {},
                elem = this.element.find('#' + this._id + '_' + name);
            this._resizeColl[sheetIdx - 1] = false;
            if (this._isInitLoad)
                this._trigger("load", { sheetIndex: sheetIdx });
            this._initTmplColumns(sheetIdx);
            div = elem.length === 1 ? elem : ej.buildTag('div.e-sheet e-hide ', '', {}, { id: this._id + '_' + name });
            div.append(this._renderContent(sheetIdx));
            if (!elem.length) {
                if (this.model.allowFreezing)
                    hfreeze = this.XLFreeze._getHFreeze();
                if (hfreeze)
                    hfreeze.before(div);
                else
                    this.element.find(".e-spreadsheet-list").append(div);
            }
            if (sheet.showGridlines === false)
                $("#" + this._id + "_Ribbon_PageLayout_Show_Gridlines").ejCheckBox({ checked: sheet.showGridlines });
            if (this.model.enableContextMenu) {
                this.XLCMenu._initContextMenu();
                this.XLCMenu._initColorDialog();
                this.XLCMenu._initCMenuFooter();
            }
            this._updateResponsiveSettings();
            this._removeClass(div, "e-hide");
            settings.width = this._responsiveWidth;
            settings.height = this._responsiveHeight;
            (this.model.showRibbon && !this._isAutoWHMode && (this._tabMode || this._responsiveHeight < 280)) && $("#" + this._id + "_Ribbon").ejRibbon("collapse");
            this._setSheetWidthHeight(sheetIdx, settings, null, "refresh", "initial");
            this._refreshCellBinding(sheetIdx);
            this._refreshImpResRowHght(sheetIdx);
            this.refreshContent(sheetIdx);
            if (sheetIdx === actSheetIdx)
                this._updateHiddenRows(actSheetIdx);
            this._initializePicture(sheetIdx);
            if (this.isImport && this.model.allowCellType && this.model.allowAutoCellType && this._celltypes.length)
                this._processCellTypes(this._celltypes, sheetIdx);
            if (this.model.allowCellType && !this.model.scrollSettings.allowVirtualScrolling)
                this.XLCellType._rangeCellTypes(sheet.cellTypes, sheetIdx);
            if (sheet._isImported && !this._sheetCopy.isSheetCopy) {
                this.setActiveSheetIndex(sheetIdx);
                this._refreshImpSheets(sheetIdx);
                this.setActiveSheetIndex(actSheetIdx);
            }
            if (sheetIdx !== actSheetIdx)
                div.hide();
            else
                this._initSelection();
            this._initSheetModel(sheetIdx);
            if (this.isImport && sheet._isFreezed) {
                impData = this._impData.model.sheets[sheetIdx];
                sIdx = this.getRangeIndices(impData.paneTopLeftCell);
                if (this._isFrozen(sheet.frozenRows))
                    this.XLScroll._vScroller(sheetIdx).scroll(this._getRowOffsetTop(sheet, sIdx[0]) - sheet._frozenHeight);
                if (this._isFrozen(sheet.frozenColumns))
                    this.XLScroll._hScroller(sheetIdx).scroll(this._getColOffsetLeft(sheet, sIdx[1]) - sheet._frozenWidth);
            }
            sheet._isLoaded = true;
            if (!this._isSheetInsert && (this._pageClickArgs || this._gotoPageArgs))
                this._pageLoadComplete(sheetIdx);
            this.getSheet(actSheetIdx)._isOpened = true;
            if (this.model.showRibbon) {
                if ($("#" + this._id + "_Ribbon")[0].style.overflow === "hidden") {
                    $("#" + this._id + "_Ribbon")[0].style.overflow = "";
                    if (this.model.showRibbon)
                        this.XLRibbon._refreshBackstageHeight();
                }
                sheet._isRibCollapsed = !this.XLRibbon._ribbonState;
			}
			if (this._isAutoWHMode)
                this._autoSSWidthHeight(sheetIdx);
        },

        _initSheetModel: function (sheetIdx) {
            var sIdx, toprow, leftCol, impData, sheet = this.getSheet(sheetIdx), frows = this.getFrozenRows(sheetIdx), fcols = this.getFrozenColumns(sheetIdx);
            if (sheet.showHeadings === false)
                this.showHeadings(sheet.showHeadings);
            if (sheet._isImported) {
                impData = this._impData.model.sheets[sheetIdx];
                sIdx = this.getRangeIndices(impData.topLeftCell || "A1");
            }
            toprow = sheet._isImported ? sIdx[0] : ((this._isFrozen(frows) && sheet._bottomRow.idx <= frows) ? frows - 1 : 0);
            leftCol = sheet._isImported ? sIdx[1] : ((this._isFrozen(fcols) && sheet._rightCol.idx <= fcols) ? fcols - 1 : 0);
            if (this.model.scrollSettings.allowScrolling) {
                (toprow > 0) && this.XLScroll._vScroller(sheetIdx).scroll(this._getRowOffsetTop(sheet, toprow));
                (leftCol > 0) && this.XLScroll._hScroller(sheetIdx).scroll(this._getColOffsetLeft(sheet, leftCol));
            }
            if (this.model.allowFreezing) {
                if (this._isFrozen(frows) && this._isFrozen(fcols))
                    this.XLFreeze.freezePanes(frows, fcols);
                else if (this._isFrozen(frows))
                    this.XLFreeze._freeze(frows);
                else if (this._isFrozen(fcols))
                    this.XLFreeze._freeze(null, fcols);
            }
        },

        _initTmplColumns: function (sheetIdx) {
            var i, idx, value, field, data, range, sheet = this.getSheet(sheetIdx);
            if (!this._sheetCopy.isSheetCopy && !sheet.rangeSettings.length && sheet.dataSource && sheet._jsonData && sheet.fieldAsColumnHeader) {
                data = sheet._jsonData[0];
                range = this.getRangeIndices(sheet.startCell);
                i = range[1] + 1;
                if (data) {
                    for (field in data) {
                        if (data.hasOwnProperty(field)) {
                            value = data[field];
                            if (typeof data[field] === "object")
                                field = this._iterateComplxObj(data[field], field).prop;
                            sheet.columns[i - 1] = {
                                field: this._generateHeaderText(i),
                                text: field,
                                type: value != null ? (value.getDay ? "date" : typeof (value)) : null
                            };
                            i++;
                        }
                    }
                    sheet.colCount = sheet._templateColCount = sheet.columns.length;
                    sheet._isTemplate = true;
                }
            }
        },

        _refreshCellBinding: function (sheetIdx) {
            var i, j, len, sheet = this.getSheet(sheetIdx), mergeCellsCln = sheet.mergeCells, hideRowsCln = sheet.hideRows, rowIdx, curCell, cell;
            if (mergeCellsCln.length) {
                var k, range, rowCount, colCount, mergeObj;
                for (k = 0, len = mergeCellsCln.length; k < len; k++) {
                    range = this.getRangeIndices(mergeCellsCln[k]), rowCount = range[2] - range[0] + 1, colCount = range[3] - range[1] + 1, mergeObj;
                    for (i = 0; i < rowCount; i++) {
                        for (j = 0; j < colCount; j++) {
                            if (i == 0 && j == 0)
                                mergeObj = { merge: { isMerge: true, mRange: mergeCellsCln[k], isCenterAlign: false, mSpan: { colSpan: colCount, rowSpan: rowCount } } };
                            else
                                mergeObj = { isMHide: true, mergeIdx: { rowIndex: range[0], colIndex: range[1] } };
                            this.XLEdit._updateDataContainer({ rowIndex: range[0] + i, colIndex: range[1] + j }, { dataObj: mergeObj, sheetIdx: sheetIdx, skipCell: true });
                        }
                    }

                }
            }
            if (hideRowsCln.length && this.model.scrollSettings.allowVirtualScrolling) {
                for (i = 0, len = hideRowsCln.length; i < len; i++)
                    this._cellBindHiddenRows(hideRowsCln[i], hideRowsCln, sheetIdx);
            }

        },

        _cellBindHiddenRows: function (rowIdx, hideRowsCln, sheetIdx) {
            var curCell, cell, sheet = this.getSheet(sheetIdx), xlEdit = this.XLEdit;
            sheet.hideRowsCollection.push(rowIdx);
            this.XLScroll._getRowHeights(sheetIdx, hideRowsCln.sort()[0]);
            cell = (rowIdx === 0) ? { rowIndex: rowIdx, colIndex: 0 } : { rowIndex: rowIdx - 1, colIndex: 0 };
            curCell = { rowIndex: rowIdx, colIndex: 0 };
            xlEdit._updateDataContainer(cell, { dataObj: { hRow: true }, sheetIdx: sheetIdx, skipCell: true });
            xlEdit._updateDataContainer(curCell, { dataObj: { isRHide: true }, sheetIdx: sheetIdx, skipCell: true });
        },

        _updateHiddenRows: function (sheetIdx) {
            var i, len, rowColl, rows, hdrRows, sheet = this.getSheet(sheetIdx), hideRowsCln = sheet.hideRows, rowIdx, cFormatRuleCln = sheet.cFormatRule, cFormatRule, hideColsCln = sheet.hideColumns, borderColl = sheet.border;
            if (hideRowsCln.length && !this.model.scrollSettings.allowVirtualScrolling) {
                for (i = 0, len = hideRowsCln.length; i < len; i++) {
                    rowIdx = hideRowsCln[i];
                    rowColl = this.getRows(sheetIdx), rows = rowColl[1], hdrRows = rowColl[0];
                    this.addClass(rows[rowIdx], "e-r-hide");
                    this.addClass(hdrRows[rowIdx], "e-r-hide");
                    rowIdx > 0 && this.addClass(hdrRows.eq(rowIdx - 1).find("td")[0], "e-hrow");
                    this._cellBindHiddenRows(rowIdx, hideRowsCln, sheetIdx);
                }
            }
            if (hideColsCln.length && !this.model.scrollSettings.allowVirtualScrolling) {
                for (i = 0, len = hideColsCln.length; i < len; i++) {
                    if (!sheet.hideColsCollection[hideColsCln[i]])
                        this._updateHiddenColumns({ rowIndex: 0, colIndex: hideColsCln[i] }, sheetIdx);
                }
                this.XLScroll._getColWidths(sheetIdx, hideColsCln.sort()[0]);
            }
            if (!ej.isNullOrUndefined(cFormatRuleCln) && cFormatRuleCln.length) {
                for (i = 0, len = sheet.cFormatRule.length; i < len; i++) {
                    cFormatRule = sheet.cFormatRule[i];
                    this.XLCFormat._cFormat(cFormatRule.action, cFormatRule.inputs[0], cFormatRule.inputs[1], cFormatRule.color, cFormatRule.range, sheetIdx);
                }
            }

            if (borderColl.length && !this.model.scrollSettings.allowVirtualScrolling) {
                for (i = 0, len = borderColl.length; i < len; i++)
                    this._updateCellBorder(borderColl[i], sheetIdx);
            }
        },

        _updateHiddenColumns: function (cell, sheetIdx) {
            var rowIdx = cell.rowIndex, colIdx = cell.colIndex, sheet = this.getSheet(sheetIdx), dataObj = { isCHide: true }, curCell, prevCell, sheetHdr = this._getJSSheetHeader(sheetIdx), hdrElem = sheetHdr.find("th"), hdrcolgrp = sheetHdr.find("col"), colGrp = this._getContent(sheetIdx).find("col");
            sheet.hideColsCollection[colIdx] = sheet.columnWidth;
            sheet.columnsWidthCollection[colIdx] = 0;
            if (colIdx === 0)
                dataObj.hCol = true;
            this._writeRule(colIdx, sheetIdx);
            this.addClass(hdrElem[colIdx], "e-hide");
            this.addClass(hdrcolgrp[colIdx], "e-hide");
            this.addClass(colGrp[colIdx], "e-hide");
            !sheetHdr.find('th:eq(' + (colIdx - 1) + ')').hasClass("e-hide") && this.addClass(sheetHdr.find('th:eq(' + (colIdx - 1) + ')')[0], "e-hcol");
            this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: colIdx }, { dataObj: dataObj, sheetIdx: sheetIdx, skipCell: true });
            if (colIdx > 0)
                this.isUndefined(this.XLEdit.getPropertyValue(0, colIdx - 1, "isCHide")) && this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: colIdx - 1 }, { dataObj: { hCol: true }, sheetIdx: sheetIdx, skipCell: true });
        },


        _renderContent: function (sheetIdx) {
            var elems = [], div = ej.buildTag('div.e-spreadsheetheader'), innerDiv = ej.buildTag('div.e-headercontent'),
               colHeader = ej.buildTag('div.e-spreadsheetcolumnheader e-icon e-ss-selectall  e-ss-cursor', "", {}, {}),
               contentContainer = ej.buildTag('div.e-spreadsheetcontentcontainer', "", { "-webkit-tap-highlight-color": "rgba(0,0,0,0)" }), cont = ej.buildTag("div.e-content e-ss-cursor"),
               rowHeader = ej.buildTag('div.e-spreadsheetrowheader', "", { "float": "left", "width": "30px" }, {}), rowHdrCont = ej.buildTag("div.e-rowheadercontent");
            if (this._isAutoWHMode) {
                cont.addClass("e-rmvbtmbdr");
                innerDiv.addClass("e-rmvrghtbdr");
                rowHdrCont.addClass("e-rmvbtmbdr");
            }
            this._setJSSheetHeader(div, sheetIdx);
            div.append(colHeader);
            div.append(innerDiv);
            elems.push(div);
            div = ej.buildTag("div.e-spreadsheetcontent");
            this._setJSSheetContent(div, sheetIdx);
            this._setContent(contentContainer, sheetIdx);
            this._setJSSheetRowHeader(rowHeader, sheetIdx);
            this._setJSSheetRowHeaderContent(rowHdrCont, sheetIdx);
            rowHeader.append(rowHdrCont);
            contentContainer.append(cont);
            div.append(rowHeader);
            div.append(contentContainer);
            elems.push(div);
            return elems;
        },

        refreshContent: function (sheetIdx) {
            sheetIdx = sheetIdx || this.getActiveSheetIndex();
            var contentrows, rowhdrrows, settings = {}, sheet = this.getSheet(sheetIdx), scroll = this.model.scrollSettings,
                isVirtualScroll = scroll.allowVirtualScrolling, cont = this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content");
            this._initDataRange(sheetIdx);
            this._refreshRowColCnt(sheetIdx);
            this._getJSSheetHeader(sheetIdx).find(".e-headercontent").html(this._renderHeaderColumns(sheetIdx));
            this._refreshTemplates(sheetIdx);
            this._getJSSheetRowHeaderContent(sheetIdx).html(this._renderHdrRows(sheetIdx));
            cont.find(".e-table").remove();
            cont.prepend(this._renderContTable(sheetIdx));
            this._initViewPortCont(sheetIdx);
            if (this._isAutoWHMode) {
                if (!this._isInitLoad)
                    this._autoSSWidthHeight(sheetIdx);
            }
            else
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
            if (!isVirtualScroll) {
                this.XLScroll._getFirstRow(sheetIdx);
                this.XLScroll._getFirstColumn(sheetIdx);
            }
            contentrows = this._getContTBody(sheetIdx).find("tr");
            rowhdrrows = this._getRowHdrTBody(sheetIdx).find("tr");
            this.setRows([rowhdrrows, contentrows], sheetIdx);
        },

        _autoSSWidthHeight: function (sheetIdx, refrshWHSttgsOnly) {
            var settings = {}, scroll = this.model.scrollSettings, ribObj = $("#" + this._id + "_Ribbon").data("ejRibbon");
            sheetIdx = sheetIdx || this._getSheetIndex();
            this._responsiveWidth = this._dlgWidth = settings.width = this._getContTBody(sheetIdx).width() + this._getJSSheetRowHeader(sheetIdx).width();
            this._responsiveHeight = this._dlgHeight = settings.height = this.element.height();
            if (this.model.showRibbon && settings.width <= 480) {
                settings.width = 480;
                this._getContent(sheetIdx).find(".e-content").removeClass("e-rmvrghtbdr");
            }
            else if (!refrshWHSttgsOnly)
                this._getContent(sheetIdx).find(".e-content").addClass("e-rmvrghtbdr");
            if (!refrshWHSttgsOnly)
                this._setSheetWidthHeight(sheetIdx, settings, null, "refresh");
            if (this.model.showRibbon) {
				(settings.width <= 480) && this._alignFormulaBar(settings.width);
                this.XLRibbon._refreshBackstageHeight();
                ribObj.setModel({ width: settings.width });
            }
        },

        _initDataRange: function (sheetIdx) {
            var len, range, setting, rowCnt, colCnt, rowIdx, colIdx, i = 0, sheet = this.getSheet(sheetIdx), settings = this.getDataSettings(sheetIdx);
            if (settings) {
                len = settings.length;
                while (i < len) {
                    setting = settings[i];
                    if (setting._jsonData) {
                        setting.batchChanges = { added: [], changed: [], deleted: [] };
                        setting.fields = this.getObjectKeys(setting._jsonData[0]);
                        range = setting.startCell ? this._toIntrnlRange(setting.startCell, sheetIdx) : [0, 0, 0, 0];
                        range[2] = range[0] + (!setting.fieldAsColumnHeader && setting.showHeader ? setting.count : setting.count - 1);
                        range[3] = range[1] + this.getObjectLength(setting._jsonData[0]) - 1;
                        setting.range = range;
                        rowIdx = range[2], colIdx = range[3]; // used range update
                        if (this._isAutoWHMode || sheet.usedRange.rowIndex < rowIdx)
                            sheet.usedRange.rowIndex = rowIdx;
                        if (this._isAutoWHMode || sheet.usedRange.colIndex < colIdx)
                            sheet.usedRange.colIndex = colIdx;
                        rowCnt = rowIdx + 1, colCnt = colIdx + 1; // row and col count update
                        if (this._isAutoWHMode || sheet.rowCount < rowCnt)
                            sheet.rowCount = rowCnt;
                        if (this._isAutoWHMode || sheet.colCount <= colCnt)
                            sheet.colCount = colCnt;
                        sheet._hasDataSrc = true;
                    }
                    i++;
                }
            }
        },

        _renderStyleTag: function (type) {
            var rtag, stag;
            rtag = document.getElementsByTagName("head")[0] || document.getElementsByTagName("body")[0];
            stag = document.createElement("style");
            stag.type = "text/css";
            if (type == "custom") {
                stag.setAttribute("id", this._id + "_sscustomformat");
                rtag.appendChild(stag);
            }
            else if (type === "showhide" && !document.getElementById(this._id + "_sshide")) {
                stag.setAttribute("id", this._id + "_sshide");
                rtag.appendChild(stag);
            }
            return stag;
        },

        _renderHeaderColumns: function (sheetIdx) {
            var colHdr, table, colGroup, valColl, thead = document.createElement('thead');
            valColl = this._renderHeaderCol(sheetIdx, 0, this.getSheet(sheetIdx).colCount);
            table = ej.buildTag('table.e-table', "", ((this.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal) ? { width: this._getEntireColWidth(sheetIdx) } : {}), { cellspacing: "0.25px" })[0];
            colGroup = valColl[1];
            colHdr = valColl[0];
            thead.appendChild(colHdr);
            table.appendChild(colGroup);
            table.appendChild(thead);
            return table;
        },

        _renderHeaderCol: function (sheetIdx, startIdx, colCount) {
            var thCls, hdrCell, hdrCellDiv, col, colTxt, hTxt, hdrTxt, value, colWth, width = 0, arr = [], i = startIdx, sheet = this.getSheet(sheetIdx),
                colHdr = document.createElement('tr'), colGrp = document.createElement('colgroup');
            colHdr.className = "e-columnheader";
            if (!this.isImport) {
                sheet._colWidthCollection.length = 0;
                sheet._ofColWidthColl.length = 0;
            }
            sheet._colWidthCollection.push(width);
            sheet._ofColWidthColl.push(width);
            while (i < colCount) {
                thCls = "e-headercell";
                colTxt = "col";
                colWth = sheet.columnsWidthCollection[i];
                if (this.isUndefined(colWth))
                    colWth = sheet.columnsWidthCollection[i] = sheet.columnWidth;
                if (i != colCount - 1) {
                    width = sheet._colWidthCollection[sheet._colWidthCollection.length - 1] + colWth;
                    sheet._colWidthCollection.push(width);
                    sheet._ofColWidthColl.push(width);
                }
                if (this.model.allowSelection && this._inColumn(sheet.selectedRange, i)) {
                    thCls += " e-colhighlight";
                    if (sheet._isColSelected)
                        thCls += " e-colselected";
                }
                if (colWth < 1) {
                    colTxt += ".e-hide";
                    thCls += " e-hide";
                }
                else if (sheet._hiddenFreezeCols.indexOf(i) > -1) {
                    colTxt += ".e-fcol-hide";
                    thCls += " e-fcol-hide";
                }
                if(this.IsImport || sheet._isLoaded)
					this.XLEdit.getPropertyValue(0, i, "hCol") && (thCls += " e-hcol");
                hdrCell = document.createElement('th');
                hdrCell.className = thCls;
                hTxt = hdrTxt = this._generateHeaderText(i + 1);
                if (sheet.fieldAsColumnHeader && sheet.columns[i])
                    hTxt = sheet.columns[i].text;
                hdrCellDiv = document.createElement('div');
                hdrCellDiv.className = "e-headercelldiv";
                hdrCellDiv.innerHTML = hTxt;
                hdrCell.appendChild(hdrCellDiv);
                col = ej.buildTag(colTxt, "", { width: colWth }, {});
                colHdr.appendChild(hdrCell);
                colGrp.appendChild(col[0]);
                if (!this._sheetCopy.isSheetCopy && !sheet.columns[i]) {
                    sheet.columns[i] = {
                        field: hdrTxt,
                        text: hdrTxt,
                        type: value != null ? (value.getDay ? "date" : typeof (value)) : null,
                    };
                }
                i++;
            }
            arr.push(colHdr);
            arr.push(colGrp);
            return arr;
        },

        _getWidth: function (scolIdx, ecolIdx, sheetIdx) {
            var wth = 0, sheet = this.getSheet(sheetIdx);
            for (; scolIdx <= ecolIdx; scolIdx++)
                wth += sheet.columnsWidthCollection[scolIdx];
            return wth;
        },

        _getEntireColWidth: function (sheetIdx) {
            var sheet = this.getSheet(sheetIdx), lastColTop = this._getIdxWithOffset(null, this._getLastColIdx(sheet)).xOffset;
            return lastColTop + sheet.columnsWidthCollection[sheet.columnsWidthCollection.length - 1];
        },

        _getLastColIdx: function (sheet) {
            var colIdx = sheet.colCount - 1;
            while (colIdx > -1) {
                if (!(colIdx in sheet.hideColsCollection) && sheet._hiddenFreezeCols.indexOf(colIdx) === -1)
                    break;
                colIdx--;
            }
            return colIdx;
        },

        _getIdxWithOffset: function (y, x, isOffset, skipActions, sheetIdx) {
            skipActions = skipActions || [];
            var isDefaultHide, isFreezeHide, len, i, idx, pos, offset, obj = {}, hideTypes = ej.Spreadsheet.HideTypes, sheet = this.getSheet(sheetIdx);
            i = idx = pos = offset = 0;
            if (!ej.isNullOrUndefined(y)) {
                if (isOffset) {
                    len = sheet.rowsHeightCollection.length;
                    while (i < len) {
                        isDefaultHide = isFreezeHide = false;
                        if (skipActions.indexOf(hideTypes.Default) === -1 && sheet.hideRowsCollection.indexOf(i) > -1)
                            isDefaultHide = true;
                        if (skipActions.indexOf(hideTypes.Freeze) === -1 && sheet._hiddenFreezeRows.indexOf(i) > -1)
                            isFreezeHide = true;
                        if (!isDefaultHide && !isFreezeHide) {
                            pos += sheet.rowsHeightCollection[i];
                            if (pos > y) {
                                idx = i;
                                break;
                            }
                            offset = pos;
                        }
                        i++;
                    }
                }
                else {
                    while (i < y) {
                        isDefaultHide = isFreezeHide = false;
                        if (skipActions.indexOf(hideTypes.Default) === -1 && sheet.hideRowsCollection.indexOf(i) > -1)
                            isDefaultHide = true;
                        if (skipActions.indexOf(hideTypes.Freeze) === -1 && sheet._hiddenFreezeRows.indexOf(i) > -1)
                            isFreezeHide = true;
                        if (!isDefaultHide && !isFreezeHide)
                            offset += sheet.rowsHeightCollection[i];
                        i++;
                    }
                    idx = y;
                }
                obj.rowIdx = idx;
                obj.yOffset = offset;
            }
            if (!ej.isNullOrUndefined(x)) {
                if (isOffset) {
                    i = idx = pos = offset = 0, len = sheet.columnsWidthCollection.length;
                    while (i < len) {
                        isDefaultHide = isFreezeHide = false;
                        if (skipActions.indexOf(hideTypes.Default) === -1 && i in sheet.hideColsCollection)
                            isDefaultHide = true;
                        if (skipActions.indexOf(hideTypes.Freeze) === -1 && sheet._hiddenFreezeCols.indexOf(i) > -1)
                            isFreezeHide = true;
                        if (!isDefaultHide && !isFreezeHide) {
                            pos += sheet.columnsWidthCollection[i];
                            if (pos > x) {
                                idx = i;
                                break;
                            }
                            offset = pos;
                        }
                        i++;
                    }
                }
                else {
                    while (i < x) {
                        isDefaultHide = isFreezeHide = false;
                        if (skipActions.indexOf(hideTypes.Default) === -1 && i in sheet.hideColsCollection)
                            isDefaultHide = true;
                        if (skipActions.indexOf(hideTypes.Freeze) === -1 && sheet._hiddenFreezeCols.indexOf(i) > -1)
                            isFreezeHide = true;
                        if (!isDefaultHide && !isFreezeHide)
                            offset += sheet.columnsWidthCollection[i];
                        i++;
                    }
                    idx = x;
                }
                obj.colIdx = idx;
                obj.xOffset = offset;
            }
            return obj;
        },

        _getEntireRowHeight: function (sheetIdx) {
            var sheet = this.getSheet(sheetIdx);
            return sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1] + sheet.rowsHeightCollection[sheet.rowsHeightCollection.length - 1];
        },

        _renderHdrRows: function (sheetIdx) {
            var i, j, k, l, len, cnt, cls, hgt, row, cell, span, diff, table, rowHgt, rowIdx, minrIdx, cellData,
                sheet = this.getSheet(sheetIdx), isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling;
            table = ej.buildTag("table.e-table", "<colgroup><col style='width: 30px;'></colgroup>", {}, { cellspacing: "0" });
            if (!this._sheetCopy.isSheetCopy) {
                hgt = rowIdx = 0;
                cellData = sheet.rows;
                i = 0, cnt = sheet.rowCount;
                sheet._rowHeightCollection = [], sheet._rowIdxColl = [];
                sheet._rowHeightCollection.push(hgt);
                while (i < cnt) {
                    rowHgt = sheet.rowsHeightCollection[i];
                    if (!rowHgt)
                        rowHgt = sheet.rowsHeightCollection[i] = sheet.rowHeight;
                    if (!isVirtualScroll || (sheet.hideRowsCollection.indexOf(i) === -1 && sheet._hiddenFreezeRows.indexOf(i) === -1))
                        sheet._rowIdxColl.push(i);
                    else
                        rowHgt = 0;
                    if (i != cnt - 1)
                        sheet._rowHeightCollection.push(sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1] + rowHgt);
                    i++;
                }
                if (cellData) {
                    minrIdx = -1;
                    len = cellData.length;
                    diff = (this._browserDetails.name === "mozilla") ? 2 : 1;
                    for (j = 0; j < len; j++) {
                        row = cellData[j];
                        l = row.cells.length;
                        if (!this.isUndefined(row.index))
                            rowIdx = row.index;
                        hgt = row.height || sheet.rowHeight;
                        if (sheet.rowHeight < hgt) {
                            sheet.rowsHeightCollection[rowIdx] = hgt;
                            if (minrIdx === -1)
                                minrIdx = rowIdx;
                        }
                        for (k = 0; k < l; k++) {
                            cell = row.cells[k];
                            if (cell.style && cell.style["font-size"]) {
                                span = document.getElementById(this._id + '_emptySpan');
                                cls = this.XLFormat._createFormatClass(cell.style);
                                this.addClass(span, cls);
                                span.textContent = cell.value;
                                hgt = span.offsetHeight + diff;
                                if (hgt > sheet.rowsHeightCollection[rowIdx]) {
                                    sheet.rowsHeightCollection[rowIdx] = hgt;
                                    if (minrIdx === -1)
                                        minrIdx = rowIdx;
                                }
                                this._refreshGlobalSpan(span);
                            }
                            if (!this.isUndefined(cell.value))
                                sheet._hasDataSrc = true;
                        }
                        rowIdx++;
                    }
                    if (minrIdx !== -1)
                        this.XLScroll._getRowHeights(sheetIdx, minrIdx, true);
                }
            }
            if (isVirtualScroll)
                table.append("<tbody class='e-ss-virtualtop'></tbody><tbody></tbody><tbody class='e-ss-virtualbottom'></tbody>");
            else
                table.append("<tbody>" + this._renderRowHdr(sheet._rowIdxColl, sheetIdx) + "</tbody>");
            this._setRowHdrTBody(table.find("tbody").eq(isVirtualScroll ? 1 : 0), sheetIdx);
            return table;
        },

        _renderRowHdr: function (rowIdxArr, sheetIdx) {
            var idx, cnt, obj, i = 0, data = [], sheet = this.getSheet(sheetIdx);
            cnt = rowIdxArr ? rowIdxArr.length : sheet.rowCount;
            while (i < cnt) {
                idx = rowIdxArr ? rowIdxArr[i] : i;
                if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(idx, 0, "isFilterHide", sheetIdx)) || ej.isNullOrUndefined(this.XLEdit.getPropertyValue(idx, 0, "isRHide", sheetIdx))) {
                    obj = { height: sheet.rowsHeightCollection[idx] < this.model.rowHeight ? this.model.rowHeight : sheet.rowsHeightCollection[idx], rowidx: idx };
                    obj.className = this.XLEdit.getPropertyValue(idx, 0, "hRow", sheetIdx) ? "e-rowheader e-hrow " : "e-rowheader";
                    if (this.XLEdit.getPropertyValue(idx, 0, "isFilterHighlight", sheetIdx))
                        obj.className += " e-filterhiglight";
                    obj.wrap = this.XLEdit.getPropertyValue(idx, 0, "wrapRow", sheetIdx) ? " e-sswraprow" : "";
                    if (this.model.allowSelection && this._inRow(sheet.selectedRange, idx)) {
                        obj.className += " e-rowhighlight";
                        if (sheet._isRowSelected)
                            obj.className += " e-rowselected";
                    }
                    data.push(obj);
                }
                i++;
            }
            return $.render[this._id + "JSONRowHdrTemplate" + sheetIdx](data);
        },

        _refreshDataSrc: function (range, sheetIdx) {
            var j, k, l, m, n, data, setting, len, formatClass, dataObj, srange, field, showHdr, isSheetData, i = 0,
                sheet = this.getSheet(sheetIdx), settings = this.getDataSettings(sheetIdx);
            showHdr = isSheetData = false;
            if (!sheet.rangeSettings.length && sheet.dataSource)
                isSheetData = true;
            if (settings) {
                len = settings.length;
                while (i < len) {
                    setting = settings[i];
                    if (setting.range) {
                        srange = setting.range; // settings range
                        showHdr = isSheetData ? (!setting.fieldAsColumnHeader && setting.showHeader) : setting.showHeader;
                        if (this.getObjectLength(setting.headerStyles) && this.model.allowCellFormatting)
                            formatClass = this.XLFormat._createFormatClass(setting.headerStyles);
                        if (range) {
                            j = range[0], k = range[2], m = range[3];
                            while (j <= k) {
                                if (this._inRow(srange, j)) {
                                    l = range[1];
                                    while (l <= m) {
                                        if (this._inColumn(srange, l)) {
                                            field = setting.fields[l - setting.range[1]];
                                            if (showHdr && j === srange[0]) {
                                                data = setting._jsonData[j - setting.range[0]];
                                                if (data)
                                                    this._refreshCell(j, l, sheetIdx, setting, data, field, false, formatClass);
                                            }
                                            else {
                                                data = setting._jsonData[j - (setting.range[0] + (showHdr ? 1 : 0))];
                                                if (data)
                                                    this._refreshCell(j, l, sheetIdx, setting, data, field, true);
                                            }
                                        }
                                        l++;
                                    }
                                }
                                j++;
                            }
                        }
                        else {
                            j = 0, k = srange[0], m = srange[1], l = srange[2];
                            if (showHdr) {
                                data = setting._jsonData[j];
                                for (n in data) {
                                    this._refreshCell(k, m, sheetIdx, setting, data, n, false, formatClass);
                                    m++;
                                }
                                k++;
                            }
                            while (k <= l) {
                                data = setting._jsonData[j];
                                m = srange[1];
                                for (n in data) {
                                    this._refreshCell(k, m, sheetIdx, setting, data, n, true);
                                    m++;
                                }
                                j++, k++;
                            }
                        }
                    }
                    i++;
                }
            }
        },

        _refreshCell: function (rowIdx, colIdx, sheetIdx, setting, data, field, isCont, formatClass) {
            var dataObj, cmplxObj = this._iterateComplxObj(data[field], field), isSheetData, sheet = this.getSheet(sheetIdx);
            dataObj = this.XLEdit._parseValue(isCont ? cmplxObj.value : cmplxObj.prop, { rowIndex: rowIdx, colIndex: colIdx });
            dataObj.sheetIdx = sheetIdx;
            if (setting.rangeName)
                dataObj.rangeName = setting.rangeName;
            if (isCont) {
                if (setting.primaryKey === field)
                    dataObj.isReadOnly = true;
            }
            else {
                if (formatClass) {
                    dataObj.format = formatClass;
                    dataObj.formats = setting.headerStyles;
                }
                if (!sheet.rangeSettings.length && sheet.dataSource)
                    dataObj.isReadOnly = true;
            }
            this.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: dataObj, sheetIdx: sheetIdx, skipCell: true });
        },

        _iterateComplxObj: function (obj, prop, cxprop) {
            var i, value, sep, cmplxProp = cxprop || prop, reslt = { prop: cmplxProp, value: obj };
            if (this._isObject(obj)) {
                sep = ".";
                for (i in obj) {
                    value = obj[i];
                    if (this.isUndefined(value))
                        return reslt;
                    else {
                        if (obj.hasOwnProperty(i) && this._isObject(value) && !this._isDateTime(value)) {
                            cmplxProp += sep + i;
                            reslt = this._iterateComplxObj(value, i, cmplxProp);
                        }
                        else {
                            reslt.prop += sep + i;
                            reslt.value = value;
                            return reslt;
                        }
                    }
                }
            }
            return reslt;
        },

        _refreshCellData: function (range, sheetIdx) {
            var i, j, row, cell, cells, colIdx, dataObj, cellData, userName, isFormula, formatObj, len, l, rowIdx = 0, sheet = this.getSheet(sheetIdx), cellData = sheet.rows, hideColsCln = sheet.hideColumns, borderColl = sheet.border;
            if (cellData) {
                for (i = 0, len = cellData.length; i < len; i++) {
                    colIdx = 0;
                    row = cellData[i];
                    cells = cellData[i].cells;
                    if (row.index)
                        rowIdx = row.index;
                    if ((!range || this._inRow(range, rowIdx)) && cells) {
                        for (j = 0, l = cells.length; j < l; j++) {
                            cell = cells[j];
                            if (cell.index)
                                colIdx = cell.index;
                            if ((!range || this._inColumn(range, colIdx))) {
                                dataObj = this.isUndefined(cell.value) ? {} : this.XLEdit._parseValue(cell.value, { rowIndex: rowIdx, colIndex: colIdx });
                                dataObj.value = this.isUndefined(dataObj.value) ? (this.isUndefined(this.XLEdit.getPropertyValue(rowIdx, colIdx)) ? "" : this.XLEdit.getPropertyValue(rowIdx, colIdx)) : dataObj.value;
                                isFormula = this.isFormula(dataObj.value);
                                if (isFormula) {
                                    this.XLEdit._refreshCalcEngine(rowIdx, colIdx, true, dataObj.value, sheetIdx);
                                    this._applyFormula(sheetIdx, rowIdx, colIdx);
                                }
                                if (cell.format) {
                                    formatObj = this.XLFormat._getFormatObj(cell.format);
                                    dataObj.type = cell.format.type;
                                    dataObj.formatStr = formatObj.format.formatStr;
                                    dataObj.decimalPlaces = formatObj.format.decimalPlaces;
                                    dataObj.thousandSeparator = formatObj.format.thousandSeparator ? true : false;
                                }
                                dataObj.value2 = this.XLFormat._format(isFormula ? this.XLEdit.getPropertyValue(rowIdx, colIdx, "value2") : dataObj.value, { formatStr: dataObj.formatStr, type: dataObj.type, thousandSeparator: dataObj.thousandSeparator, decimalPlaces: dataObj.decimalPlaces, cellObj: dataObj });
                                if (cell.hyperlink) {
                                    if (cell.hyperlink.webAddr)
                                        dataObj.hyperlink = cell.hyperlink.webAddr.indexOf("http") === -1 ? { webAddr: "http://" + cell.hyperlink.webAddr } : { webAddr: cell.hyperlink.webAddr };
                                    else
                                        dataObj.hyperlink = { cellAddr: cell.hyperlink.cellAddr + "_" + cell.hyperlink.sheetIndex || sheetIdx };
                                    dataObj.formats = { "color": this._hlColor };
                                }
                                if (cell.comment) {
                                    userName = (this.model.userName.length ? this.model.userName : this._getLocStr("UserName")) + ":\n";
                                    dataObj.comment = { value: userName + (cell.comment.value || ""), isVisible: cell.comment.isVisible || false };
                                }
                                if (cell.isLocked) {
                                    dataObj.isLocked = true;
                                    this.protectSheet(true);
                                }
                                if (cell.style)
                                    dataObj.formats = $.extend(dataObj.formats, cell.style);
                                if (dataObj.formats)
                                    dataObj.format = this.XLFormat._createFormatClass(dataObj.formats);
                                this.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: dataObj, sheetIdx: sheetIdx, skipCell: true });
                                this.XLEdit._refreshCellAlignment({ cellIdx: { rowIndex: rowIdx, colIndex: colIdx }, value: dataObj.value, type: dataObj.type });
                                if (!isFormula)
                                    this.XLEdit._refreshCalcEngine(rowIdx, colIdx, false, null, sheetIdx);
                            }
                            colIdx++;
                        }
                    }
                    rowIdx++;
                }
                if (this.model.scrollSettings.allowVirtualScrolling)
                    sheet._virtualTBodyHgt = sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1] + sheet.rowsHeightCollection[sheet.rowsHeightCollection.length - 1];
            }
            if (hideColsCln.length && this.model.scrollSettings.allowVirtualScrolling) {
                for (i = 0, len = hideColsCln.length; i < len; i++) {
                    if (!sheet.hideColsCollection[hideColsCln[i]])
                        this._updateHiddenColumns({ rowIndex: 0, colIndex: hideColsCln[i] }, sheetIdx);
                }
                this.XLScroll._getColWidths(sheetIdx, hideColsCln.sort()[0]);
            }
            if (borderColl.length && this.model.scrollSettings.allowVirtualScrolling) {
                for (i = 0, len = borderColl.length; i < len; i++)
                    this._updateCellBorder(borderColl[i], sheetIdx);
            }
        },

        _updateCellBorder: function (border, sheetIdx) {
            var i, len, border1, option, borderColl, range = this.getRangeIndices(border.range);
            border1 = {
                top: { top: "1px solid" },
                right: { right: "1px solid" },
                bottom: { bottom: "1px solid" },
                left: { left: "1px solid" },
                outside: { top: "1px solid", right: "1px solid", bottom: "1px solid", left: "1px solid" },
                allborder: { top: "1px solid", right: "1px solid", bottom: "1px solid", left: "1px solid" },
                thickbox: { top: "2px solid", right: "2px solid", bottom: "2px solid", left: "2px solid" },
                thickbottom: { bottom: "2px solid" },
                topandbottom: { top: "1px solid", bottom: "1px solid" },
                topandthickbottom: { top: "1px solid", bottom: "2px solid" }
            };
            option = border1[border.type];
            borderColl = this.getObjectKeys((option));
            if (borderColl.length) {
                for (i = 0, len = borderColl.length; i < len; i++) {
                    option[borderColl[i]] = option[borderColl[i]].concat(" " + border.color);
                }
            }
            option.skipCell = true;
            option["sheetIdx"] = sheetIdx;
            border.type === "allborder" ? this.XLFormat._applyAllBorderCss(option, range) : this.XLFormat._applyBorderCss(option, range);
        },

        _renderContTable: function (sheetIdx) {
            var table;
            if (this._sheetCopy.isSheetCopy)
                table = $(this._sheetCopy.sheetContent);
            else {
                table = ej.buildTag("table.e-table", this._sheets[sheetIdx]._contentColGroup.outerHTML,
                    ((this.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal) ? { width: this._getEntireColWidth(sheetIdx) } : {}), { cellspacing: "0" });
                if (this.model.scrollSettings.allowVirtualScrolling)
                    table.append("<tbody class='e-ss-virtualtop'></tbody><tbody></tbody><tbody class='e-ss-virtualbottom'></tbody>");
                else
                    table.append("<tbody></tbody>");
            }
            this._setContTBody(table.find("tbody").eq(this.model.scrollSettings.allowVirtualScrolling ? 1 : 0), sheetIdx);
            return table;
        },

        _initViewPortCont: function (sheetIdx) {
            var rangeData, sheet = this.getSheet(sheetIdx), props = ["value", "value2", "comment", "hyperlink", "format", "border", "type", "isFilterHide", "isRHide", "isFHide",
                "isFilterHeader", "isFilterVisible", "filterState", "isMHide", "merge", "hRow", "isLocked", "wrap", "isOverflow", "align", "picture", "cFormatRule", "isOfBrdr", "formatStr"];
            if (this.model.scrollSettings.allowVirtualScrolling)
                this._refreshViewport(this._initLoad ? 0 : this._isFrozen(this.getFrozenRows()) ? sheet._contScrollTop : sheet._scrollTop, sheetIdx);
            else {
                rangeData = this.getRangeData({ property: props, sheetIdx: sheetIdx, rowIdxs: sheet._rowIdxColl, withRowIdx: true });
                this._getContTBody(sheetIdx).html(this._renderData(rangeData, sheetIdx));
                if (this.model.allowComments)
                    this.XLComment._updateCmntArrowPos(null, sheetIdx);
            }
            sheet._isVPRendered = true;
        },

        _processCellTypes: function (cellTypes, sheetIdx) {
            var i, len, arr = [];
            for (i = 0, len = cellTypes.length; i < len; i++) {
                if (cellTypes[i]['cellType']['type'] === "DatePicker")
                    arr.push({ 'range': this._getAlphaRange(sheetIdx, cellTypes[i].rowIndex, cellTypes[i].colIndex, cellTypes[i].rowIndex, cellTypes[i].colIndex), 'settings': { 'type': cellTypes[i]['cellType']['type'], 'value': cellTypes[i]['value'] } });
                else
                    arr.push({ 'range': this._getAlphaRange(sheetIdx, cellTypes[i].rowIndex, cellTypes[i].colIndex, cellTypes[i].rowIndex, cellTypes[i].colIndex), 'settings': { 'type': cellTypes[i]['cellType']['type'], 'isChecked': cellTypes[i]['cellType']['isChecked'] } });
            }
            this.XLCellType._rangeCellTypes(arr, sheetIdx);
            this._celltypes = [];
        },

        _initDependencies: function () {
            var i = 1, model = this.model;
            this._renderAlertdlg();
            this._renderAlertDlgContent($("#" + this._id + "_alertdlg"), "Alert", "");
            this._initEditForm();
            if (model.allowClipboard)
                this.XLClipboard._initCopyPaste();
            if (model.allowEditing) {
                this.XLEdit._processEditing();
                this.getMainPanel().append(this.XLEdit._editElem);
                this.XLEdit._editElem.hide();
            }
            this._renderDDownList();
            this.clearUndoRedo();
            if (model.showRibbon)
                this.XLRibbon._disableButtons(['clearfilter'], 'ejButton');
            if (model.allowDataValidation)
                this.XLValidate._addDVMethod();
            if (model.enableContextMenu)
                this.XLCMenu._initCMenuFooter();
            if (model.allowFiltering)
                this.XLFilter._renderExcelFilter();
            if (model.allowFreezing)
                this.XLFreeze._initFreeze();
        },

        _initComplete: function () {
            if (this._reqCnt === this._resCnt) {
                this._trigger("loadComplete", {});
                this.isDirty = false;
                this.clearUndoRedo();
                this.hideWaitingPopUp();
                this.XLRibbon.updateRibbonIcons();
            }
        },

        _showDialog: function (id, type) {
            var dlgHt, dlg, dlgclass = "e-dialog", model = this.model;
            switch (id) {
                case this._id + "_Ribbon_Home_Styles_ConditionalFormatting":
                    dlg = $("#" + this._id + "_CFDialog");
                    if (!dlg.length && model.allowConditionalFormats)
                        dlg = this.XLRibbon._initCFDialog();
                    dlg.ejDialog("open");
                    break;
                case this._id + "_chartname":
                    var dlg = $("#" + this._id + "_chartnamedlg");
                    if (!dlg.length)
                        this.XLRibbon._renderChartNameDlg();
                    break;
                case this._id + "_Ribbon_ChartDesign_Type_ChangeChartType":
                    var dlg = $("#" + this._id + "_charttypedlg");
                    if (!dlg.length)
                        dlg = this.XLRibbon._renderChartTypeDialog();
                    break;
                case this._id + "_ImportPasswordDialog":
                    var dlg = $("#" + this._id + "_ImportPasswordDialog");
                    if (!dlg.length)
                        dlg = this._importPasswordDlg();
                    dlg.ejDialog("open");
                    break;
                case this._id + "_Ribbon_Insert_Links_Hyperlink":
                    if (!this.model.isReadOnly) {
                        if (model.allowHyperlink && !this._hasClass(document.getElementById(this._id + "_HLDialog"), dlgclass))
                            this.XLRibbon._initHLDialog();
                        this._hlDlgOpen();
                    }
                    break;
                case this._id + "_Ribbon_Others_Cells_InsertCellOptions":
                    if (model.allowInsert) {
                        if (!this._hasClass(document.getElementById(this._id + "_insertdeletedlg"), dlgclass))
                            this._renderInsertDeleteDialog();
                        this._refreshInsDelDialog("Insert");
                    }
                    break;
                case this._id + "_Ribbon_Others_Cells_DeleteCellOptions":
                    if (model.allowDelete) {
                        if (!this._hasClass(document.getElementById(this._id + "_insertdeletedlg"), dlgclass))
                            this._renderInsertDeleteDialog("delete");
                        this._refreshInsDelDialog("Delete");
                    }
                    break;
                case this._id + "_FormatCells":
                    if (model.allowCellFormatting && !this._hasClass(document.getElementById(this._id + "_formatdlg"), dlgclass))
                        this.XLCellFrmtDlg._renderCellFrmtDlg();
                    this.XLCellFrmtDlg._initFormatCellDlg();
                    break;
                case this._id + "_MoveorCopy":
                    if (!this._hasClass(document.getElementById(this._id + "_moveCopyDlg", dlgclass)))
                        this._initMoveCopyDlg();
                    this._renderMoveCopyDlg();
                    break;
                case this._id + "_UnhideSheet":
                    if (!this._hasClass(document.getElementById(this._id + "_UnhideDlg", dlgclass)))
                        this._initUnhideDlg();
                    this._renderUnhideDlg();
                    break;
                case this._id + "_Ribbon_Data_DataTools_DataValidation":
                case this._id + "_Ribbon_Data_DataTools_DataValidationOptions":
                    if (this.model.allowDataValidation && !this._hasClass(document.getElementById(this._id + "_ValDialog"), dlgclass)) {
                        dlgHt = this.XLRibbon._initValDialog();
                        this.XLRibbon._renderValDialog(dlgHt);
                    }
                    break;
                case this._id + "_Filter":
                    if (!document.getElementById(this._id + type + "_excelDlg") && !document.getElementById(this._id + "_filter_custom_" + type))
                        this.XLFilter._renderFilterDialogs(type);
                    break;
                case this._id + "_Ribbon_Review_Changes_ProtectWorkbook":
                    if (!this._hasClass(document.getElementById(this._id + "_PasswordDialog"), dlgclass))
                        this._passwordDlg();
                    break;
                case this._id + "_Ribbon_Insert_Tables_Table":
                    if (model.allowFormatAsTable && !this._hasClass(document.getElementById(this._id + "_fatnamedlg"), dlgclass))
                        this.XLRibbon._renderFATNameDlg();
                    break;
                case this._id + "_Ribbon_Insert_Tables_PivotTable":
                    if (model.enablePivotTable && !this._hasClass(document.getElementById(this._id + "_PvtDialog"), dlgclass)) {
                        this.XLRibbon._initPvtDialog();
                        this.XLRibbon._renderPvtDialog();
                    }
                    break;
                case this._id + "_Ribbon_Others_Editing_FindSelect":
                    if (model.allowSearching && !this._hasClass(document.getElementById(this._id + "_FRDialog"), dlgclass)) {
                        this.XLRibbon._initFRDialog();
                        this.XLRibbon._renderFRDialog();
                        if (!this.model.isReadOnly) {
                            dlgHt = this.XLRibbon._initGoToDialog();
                            this.XLRibbon._renderGoToDialog(dlgHt);
                        }
                    }
                    if (this.model.isReadOnly)
                        $("#" + this._id + "_FRDialog_FPDlgTab").ejTab("option", { disabledItemIndex: [1, 2] });
                    else
                        $("#" + this._id + "_FRDialog_FPDlgTab").ejTab("option", { enabledItemIndex: [1, 2] });
                    break;
                case this._id + "_Ribbon_ChartDesign_Data_SelectData":
                    if (model.allowCharts && !this._hasClass(document.getElementById(this._id + "_chartrangedlg", dlgclass)))
                        this.XLChart._renderChartRangeDialog();
                    break;
                case this._id + "_Ribbon_Others_NameManager":
                    if (!document.getElementById(this._id + "_nmdlg"))
                        this.XLRibbon._renderNameManagerDlg();
                    break;
                case this._id + "_Ribbon_Design_Tools_ResizeTable":
                    if (!document.getElementById(this._id + '_fatresizetabledlg'))
                        this.XLRibbon._renderFATResizeTableDlg();
                    break;
            }
        },

        _generateHeaderText: function (colIndex) {
            var alphabet = "Z";
            if (colIndex / 26 > 1)
                return this._generateHeaderText((colIndex % 26 === 0) ? (colIndex / 26 - 1) : Math.floor(colIndex / 26)) + String.fromCharCode((colIndex % 26) === 0 ? alphabet.charCodeAt(alphabet) : 64 + (colIndex % 26));
            else
                return String.fromCharCode(64 + (colIndex));
        },

        _generateColCount: function (text) {
            var colCount = 0;
            text = text.split('').reverse().join('');
            for (var i = text.length - 1; i >= 0  ; i--) {
                colCount += (text[i].charCodeAt(text[i]) - 64) * (Math.pow(26, i));
            }
            return colCount;
        },

        _getSheetIndex: function (sheetIdx) {
            return sheetIdx || this.getActiveSheetIndex();
        },

        _getSheetIdxFromSheetValue: function (name) {
            var i = 1, sheets = this.model.sheets, len = sheets.length - 1;
            while (i <= len) {
                if (sheets[i].sheetInfo.value.toLowerCase() === name.toLowerCase())
                    return i;
                i++;
            }
            return -1;
        },

        getAlphaRange: function (sRIndex, sCIndex, eRIndex, eCIndex) {
            if (this.isUndefined(eRIndex) && this.isUndefined(eCIndex)) {
                eRIndex = sRIndex;
                eCIndex = sCIndex;
            }
            return this._getAlphaRange(null, sRIndex, sCIndex, eRIndex, eCIndex);
        },

        _getAlphaRange: function (sindex, srindex, scindex, erindex, ecindex) {
            srindex = srindex + 1, scindex = scindex + 1, erindex = erindex + 1, ecindex = ecindex + 1;
            return srindex === erindex && scindex === ecindex ? this._generateHeaderText(scindex) + srindex : this._generateHeaderText(scindex) + srindex + ":" + this._generateHeaderText(ecindex) + erindex;
        },

        _getProperAlphaRange: function (sindex, minrindex, mincindex, maxrindex, maxcindex) {
            var range = this._getAlphaRange(sindex, minrindex, mincindex, maxrindex, maxcindex);
            return range.indexOf(':') === -1 ? range + ':' + range : range;
        },

        _getDollarAlphaRange: function (range, checkRange) {
            var sheetIdx = this.getActiveSheetIndex(), sName = this.getSheet(sheetIdx).sheetInfo.text, sNameStr = sName.match(/\s/g) ? "'" + sName + "'" : sName;
            if (checkRange && !this.isRange(range))
                return sNameStr + "!$" + this._generateHeaderText(range[1] + 1) + "$" + (range[0] + 1);
            else
                return sNameStr + "!$" + this._generateHeaderText(range[1] + 1) + "$" + (range[0] + 1) + ":$" + this._generateHeaderText(range[3] + 1) + "$" + (range[2] + 1);
        },

        _toIntrnlRange: function (range, sheetIdx) {
            if (!range)
                range = this.getSheet(sheetIdx).selectedRange;
            else if (this._isString(range))
                range = this.getRangeIndices(range);
            return range;
        },

        _getMaxRowColCnt: function (sheets, fromUsedRange, sheetIdx) {
            var rowCount, colCount, sheet, rcnt = 0, ccnt = 0, sheets = sheets ? sheets : this.model.sheets,
                i = sheetIdx ? sheetIdx : 1, len = sheetIdx ? sheetIdx + 1 : sheets.length;
            while (i < len) {
                sheet = sheets[i];
                if (fromUsedRange && sheet.usedRange) {
                    rowCount = sheet.usedRange.rowIndex;
                    colCount = sheet.usedRange.colIndex;
                }
                else {
                    rowCount = sheet.rowCount;
                    colCount = sheet.colCount;
                }
                if (rcnt < rowCount)
                    rcnt = rowCount;
                if (ccnt < colCount)
                    ccnt = colCount;
                i++;
            }
            return { rowCount: rcnt, colCount: ccnt };
        },

        _generateEJMenu: function (type, orientation, cssClass) {
            return {
                menuType: (type === "normal") ? ej.MenuType.NormalMenu : ej.MenuType.ContextMenu,
                orientation: (orientation === "vertical") ? ej.Orientation.Vertical : ej.orientation.Horizontal,
                cssClass: cssClass
            };
        },

        _generateEJDD: function (datasource, fields, selectedIndex, width, height, evt) {
            return {
                dataSource: datasource,
                fields: fields,
                selectedItemIndex: selectedIndex,
                width: width,
                cssClass: "e-" + this._id + "-ddl",
                change: $.proxy(this.XLRibbon._frTypeChange, this, evt)
            };
        },

        _heightWidthCalculation: function (sheetIdx, args) {
            var height, actpanel = this.getActivationPanel(), isVisible = actpanel.is(':visible');
            if (!this._isDisplayHeader)
                height = (this.XLRibbon._ribbonState) ? this.element.find('.e-ribbon').height() - 1 : this.element.find('.e-ribbon .e-header').height();
            else {
                height = $("#" + this._id + "_Ribbon").height();
                this._isDisplayHeader = false;
            }
            this._refreshSheetWithScreen(sheetIdx);
            this._updateResponsiveSettings();
            this._initViewPort(sheetIdx);
            this._setSheetWidthHeight(sheetIdx, { width: this._responsiveWidth, height: this._responsiveHeight }, height, "refresh", args.action);
            isVisible && actpanel.height(this.getMainPanel().height() - 1);
            this.refreshContent(sheetIdx);
        },

        _refreshSheetWithScreen: function (sheetIdx) {
            $("#" + this._id + "GroupPanel")[0].style.height = "0px";
            $("#" + this._id + "MainPanel")[0].style.height = "0px";
            this.model.allowFormulaBar && (this.element.find('.e-formulabar')[0].style.width = "0px");
            this.getSheetElement(sheetIdx).find(".e-spreadsheetcontentcontainer")[0].style.height = "0px";
            this.getSheetElement(sheetIdx).find(".e-spreadsheetrowheader")[0].style.height = "0px";
        },

        _refreshWidthHeight: function (sheetIdx, settings, ribbonHeight, action, status) {
            var footer, colHdrHeight = 1, rowHdrHeight = 0, cont = this._getContent(sheetIdx), contentHt, formulaHeight, pagerHt = this.model.pageSettings.pagerHeight + 1, actTab,
                sheet = this.getSheet(sheetIdx), sheetRowHdr = this._getJSSheetRowHeader(sheetIdx), ribHgt, diffHt, ribContHeight = -1, ribObj = $("#" + this._id + "_Ribbon").ejRibbon("instance");
			actTab = this.model.showRibbon ? (ribObj.model.selectedItemIndex < 1 ? 1 : ribObj.model.selectedItemIndex)  : 0;
            this.XLRibbon._ribbonState && (ribContHeight = $("#" + this._id + "_Ribbon").find(".e-content:eq(" + actTab + ")").height());
            ribHgt = this._phoneMode ? $("#" + this._id + "_Ribbon").height() : $("#" + this._id + "_Ribbon").find(".e-header").height() + ribContHeight + 2;
            formulaHeight = this.model.allowFormulaBar ? this._formulaHeight : 0;
            ribbonHeight = (ribHgt && this.model.showRibbon && $("#" + this._id + "_Ribbon").is(":visible")) ? ribHgt : 0;
            if (sheet.showHeadings) {
                colHdrHeight = 20 + 2; // column header 20 + 2 //Border
                rowHdrHeight = sheetRowHdr.width();
            }
            if (!this._isAutoWHMode) {
                contentHt = settings.height - (ribbonHeight + formulaHeight + 1);
                this.getGroupPanel().height(contentHt - 1); // for Border
                this.getMainPanel().height(contentHt - 1); // for Border
                (!this.model.showPager || (action !== "initial" && !this.element.find(".e-spreadsheetfooter").is(":visible"))) && (pagerHt = 1);
                diffHt = (this._browserDetails.name === "chrome") ? 1 : 2;
                settings.height = settings.height - (colHdrHeight + pagerHt + formulaHeight + ribbonHeight + diffHt);
                this.element.find(".e-spreadsheet-list")[0].style.height = "";
            }
            if (this.model._isActPanelVisible)
                settings.width = (settings.width - (this.model.activationPanelWidth + 2)); //0.5 for border alignment
            else 
                (!ej.isNullOrUndefined(settings.isActPanel) && !settings.isActPanel) && (settings.width = settings.width + this.model.activationPanelWidth + 2);
            var orgSettings = this.model.scrollSettings;
            this.getMainPanel().width(!this.model._isActPanelVisible && orgSettings.isResponsive ? "100%" : settings.width);
            if (cont.find("#hscrollBar").length > 0) {
                cont.find("#hscrollBar").remove();
                sheetRowHdr.removeClass("e-scrollrowcss");
                this._getJSSheetRowHeaderContent(sheetIdx).height(settings.height);
                this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").height(settings.height - 1);
            }
            if (cont.find("#vscrollBar").length > 0) {
                var top = sheet._scrollTop;
                cont.find("#vscrollBar").data("ejScrollBar").scroll(0);
                sheet._scrollTop = top;
                cont.find("#vscrollBar").remove();
                this._getJSSheetHeader(sheetIdx).removeClass("e-scrollcss");
                this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").width(orgSettings.isResponsive ? settings.width - 2 : settings.width);
            }
            if (!this._isAutoWHMode) {
                cont.height(settings.height);
                sheetRowHdr.height(settings.height);
            }
            this._getJSSheetContent(sheetIdx).width(orgSettings.isResponsive ? "100%" : settings.width);
            footer = this.getFooter();
            if (footer)
                footer.width(orgSettings.isResponsive ? "100%" : settings.width);
            this._alignFormulaBar(this._responsiveWidth);
            this._initViewPort(sheetIdx);
            this.model.allowFreezing && this.XLFreeze._refreshFreeze();
            settings.width = settings.width - rowHdrHeight; // is for row Header  
            settings.height = settings.height;
            return settings;
        },

        _setSheetWidthHeight: function (sheetIdx, settings, ribbonHeight, status, action) {
            var sheet = this.getSheet(sheetIdx), content = $(document), cont = this._getContent(sheetIdx), hScroll, vScroll, hScrollObj, vScrollObj, contentHt, sheetRowHdr = this._getJSSheetRowHeader(sheetIdx);
            var currSettings, isResponsive = this.model.scrollSettings.isResponsive, rowHdrWidth = sheet.showHeadings ? sheetRowHdr.width() : 0;
            if (isResponsive) {
                if (action != "initial" && status != "resize") {
                    this._refreshSheetWithScreen(sheetIdx);
                    this._updateResponsiveSettings();
                    settings = { width: this._responsiveWidth, height: this._responsiveHeight };
                }
                this._resizeColl[sheetIdx - 1] = this._isResized;
                if (status === "resize" && (!this.model.allowResizing || (this.model.allowResizing && !this.XLResize._resizeStart)) && (action != "toggleBtn"))
                    this.model.activationPanelWidth = Math.floor(settings.width / 3);
                if (status === "refresh") {
                    var browser = this._browserDetails;
                    if (browser.name.indexOf("msie") > -1)
                        content = (this.model.showRibbon) ? $(document) : $('body');
                }
                currSettings = this._refreshWidthHeight(sheetIdx, $.extend(true, {}, settings), ribbonHeight, action, status);
                this._updateResponsiveSettings();
                if (status === "resize" && (!this.model.allowResizing || (this.model.allowResizing && !this.XLResize._resizeStart)) && (action != "toggleBtn"))
                    this.model.activationPanelWidth = Math.floor(settings.width / 3);
                settings = currSettings;
            }
            else {
                if (!this._isAutoWHMode)
                    settings.width = settings.width - 2; // border 2px
                settings = this._refreshWidthHeight(sheetIdx, $.extend(true, {}, settings), ribbonHeight, action, status);
            }
            this.getMainPanel().width(!this.model._isActPanelVisible && isResponsive ? "100%" : settings.width + rowHdrWidth);
            if (this.model.scrollSettings.allowScrolling) {
                if (this.model._isActPanelVisible)
                    settings.width += 2;
                this._renderScroller(sheetIdx, $.extend(true, {}, settings), action);
                vScroll = cont.find("#vscrollBar");
                hScroll = cont.find("#hscrollBar");
                if (vScroll.length > 0)
                    this._getJSSheetHeader(sheetIdx).addClass("e-scrollcss");
                if (hScroll.length > 0) {
                    contentHt = cont.height();
                    sheetRowHdr.height(contentHt - 18);
                    this._getJSSheetRowHeaderContent(sheetIdx).height(contentHt - (hScroll[0].style.display === "none" ? 0 : 18));
                    sheetRowHdr.addClass("e-scrollrowcss");
                }
                if (action != "initial") {
                    vScrollObj = vScroll.data("ejScrollBar");
                    hScrollObj = hScroll.data("ejScrollBar");
                    vScrollObj.scroll(sheet._scrollTop);
                    hScrollObj.scroll(sheet._scrollLeft);
                }
            }
            if (!sheet.showHeadings)
                cont.find(".e-content")[!this.model.allowFormulaBar ? "removeClass" : "addClass"]("e-viewbrdr");
            if (!this._isAutoWHMode) {
                this._dlgWidth = (this._phoneMode || this._tabMode || this._responsiveWidth < 350) ? this._responsiveWidth - 2 : this._responsiveWidth / 2;
                this._dlgHeight = (this._phoneMode || this._tabMode || this._responsiveHeight < 350) ? this._responsiveHeight - 2 : this._responsiveHeight / 1.5;
            }
        },

        setWidthToColumns: function (widthColl, sheetIndex) {
            var cellIdx, sheetIdx = sheetIndex || this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), col, hdrcol, staticWidth = 0, width, colIdx, isObj = false, overflowCells;
            if (this.isUndefined(sheet)) return;
            if (typeof (widthColl[0]) == "object")
                isObj = true;
            if (sheet._isLoaded) {
                col = this._getContent(sheetIdx).find("col");
                hdrcol = this._getJSSheetHeader(sheetIdx).find("col");
            }
            for (var i = 0, len = widthColl.length; i < len; i++) {
                width = isObj ? widthColl[i].width : widthColl[i];
                colIdx = isObj ? widthColl[i].colIndex : i;
                overflowCells = this.XLEdit._getPropWithCellIdx([0, colIdx, sheet.rowCount - 1, colIdx], "isOfBrdr", sheetIdx);
                (width === 0) && (width = 64);
                if (width < sheet.columnsWidthCollection[colIdx] && this.XLEdit.getPropertyValue(0, colIdx, "wrapCol")) {
                    staticWidth += width;
                    continue;
                }
                if (sheet._isLoaded) {
                    hdrcol[colIdx].style["width"] = width + "px";
                    col[colIdx].style["width"] = width + "px";
                }
                staticWidth += width;
                if (this.XLEdit.getPropertyValue(0, colIdx, "isCHide", sheetIdx)) {
                    sheet.hideColsCollection[colIdx] = width;
                    sheet.columnsWidthCollection[colIdx] = 0;
                }
                else
                    sheet.columnsWidthCollection[colIdx] = width;
                this.XLScroll._getColWidths(sheetIdx, colIdx);
                for (var j = 0; j < overflowCells.length; j++) {
                    cellIdx = overflowCells[j];
                    this._textClip(cellIdx.rowIdx, cellIdx.colIdx, 'delete', '', true);
                    this._textClip(cellIdx.rowIdx, cellIdx.colIdx, 'add', '', true);
                }
            }
            sheet.staticWidth = staticWidth;
            if (sheet._isLoaded && this.model.scrollSettings.allowScrolling)
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "horizontal");
            if (!sheet._isImported || sheet._isLoaded) {
                if (this.model.allowSelection)
                    this.XLSelection._refreshBorder();
                if (this.model.allowAutoFill)
                    this.XLDragFill.positionAutoFillElement();
                if (this.model.allowComments)
                    this.XLComment._updateCmntArrowPos();
                if (this._isAutoWHMode)
                    this._autoSSWidthHeight();
            }
        },

        setHeightToRows: function (heightColl) {
            var vPrtRIdx, height, rowIdx, hgt = "height", px = "px", sheetIdx = this.getActiveSheetIndex(), staticHeight = 0, sheet = this.getSheet(sheetIdx), isObj = false, rowColl = this.getRows(sheetIdx), rows = rowColl[1], rowHdrs = rowColl[0];
            if (typeof (heightColl[0]) == "object")
                isObj = true;
            for (var i = 0, len = heightColl.length; i < len; i++) {
                height = isObj ? heightColl[i].height : heightColl[i];
                rowIdx = isObj ? heightColl[i].rowIndex : i;
                (height === 0) && (height = 22);
                if (height < sheet.rowsHeightCollection[rowIdx] && this.XLEdit.getPropertyValue(rowIdx, 0, "wrapRow")) {
                    staticHeight += height;
                    continue;
                }
                if (this._isRowViewable(sheetIdx, rowIdx) && rowIdx != -1) {
                    vPrtRIdx = this._getRowIdx(rowIdx, sheetIdx);
                    rows[vPrtRIdx].style["height"] = height + "px";
                    rowHdrs[vPrtRIdx].style["height"] = height + "px";
                }
                staticHeight += height;
                sheet.rowsHeightCollection[rowIdx] = height;
            }
            if (this.model.scrollSettings.allowScrolling) {
                this.XLScroll._getRowHeights(sheetIdx, 1);
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical");
				this.XLScroll._getFirstRow(sheetIdx);
            }
            if (this.model.allowSelection)
                if (!sheet._isImported || sheet._isLoaded) {
                    this.XLSelection._refreshBorder();
                    if (this.model.allowAutoFill)
                        this.XLDragFill.positionAutoFillElement();
                }
        },

        _refreshRowColCnt: function (sheetIdx, status) {
            var totHgt, totWth, diff, srowCnt, pagerHt = -1, rowCnt, buffHgt, buffWth, actPnlWidth, ribbonHgt, formulaHgt, settings = this.model.scrollSettings,
                vPortWth, scrollerHgt, scrollerWth, colHdrHgt, rowHdrWth, isInfinite = settings.scrollMode === ej.Spreadsheet.scrollMode.Infinite,
                sheet = this.getSheet(sheetIdx), contHgt = this._responsiveHeight, contWth = this._responsiveWidth;
            rowCnt = buffHgt = buffWth = actPnlWidth = ribbonHgt = formulaHgt = vPortWth = scrollerHgt = scrollerWth = colHdrHgt = rowHdrWth = 0;
            if (sheet.rowCount > this._maxRowCnt)
                sheet.rowCount = this._maxRowCnt;
            totHgt = this._getMaxHgt(sheetIdx, this.isImport);
            if (isInfinite) {
                buffHgt = sheet._vPortHgt + (this._bufferCnt * sheet.rowHeight);
                if (totHgt < buffHgt) {
                    diff = buffHgt - totHgt;
                    rowCnt = Math.ceil(diff / sheet.rowHeight);
                    sheet.rowCount += rowCnt;
                    totHgt += rowCnt * sheet.rowHeight;
                }
            }
            if (settings.allowVirtualScrolling) {
                srowCnt = sheet.rowCount - (sheet.hideRowsCollection.length + (this.isImport ? sheet._hiddenFreezeRows.length : 0));
                if (isInfinite) {
                    diff = srowCnt % sheet._virtualBlockRowCnt;
                    if (diff) {
                        rowCnt = sheet._virtualBlockRowCnt - diff;
                        sheet.rowCount += rowCnt;
                        srowCnt += rowCnt;
                        totHgt += rowCnt * sheet.rowHeight;
                    }
                }
                sheet._virtualBlockCnt = Math.ceil(srowCnt / sheet._virtualBlockRowCnt);
                sheet._virtualTBodyHgt = totHgt;
            }
            if (sheet.colCount > this._maxColCnt) //col
                sheet.colCount = this._maxColCnt;
            else if (isInfinite) {
                buffWth = sheet._vPortWth + (this._bufferCnt * sheet.columnWidth);
                totWth = this.isImport ? this._getMaxWth(sheetIdx) : sheet.colCount * sheet.columnWidth;
                if (totWth < buffWth) {
                    diff = buffWth - totWth;
                    sheet.colCount += Math.ceil(diff / sheet.columnWidth);
                }
            }
        },

        _getMaxHgt: function (sheetIdx, fromHgtColl, processHide) {
            var len, i, val, sheet = this.getSheet(sheetIdx);
            i = val = 0;
            if (fromHgtColl) {
                len = sheet.rowsHeightCollection.length;
                while (i < len) {
                    if (!processHide || (sheet.hideRowsCollection.indexOf(i) === -1))
                        val += sheet.rowsHeightCollection[i];
                    i++;
                }
            }
            else
                val = (sheet.rowCount - (sheet.hideRowsCollection.length + sheet._hiddenFreezeRows.length)) * sheet.rowHeight;
            return val;
        },

        _getMaxWth: function (sheetIdx) {
            var val = 0, i = 0, sheet = this.getSheet(sheetIdx), len = sheet.columnsWidthCollection.length;
            while (i < len) {
                val += sheet.columnsWidthCollection[i];
                i++;
            }
            return val;
        },

        _refreshTemplates: function (sheetIdx, skipRowHdr, stColIdx, colCount) {
            var colWth, col, data, colHdr, htmlStr, i = ej.isNullOrUndefined(stColIdx) ? 0 : stColIdx, templates = {}, sheet = this.getSheet(sheetIdx),
                colgrp = ej.buildTag("colgroup"), isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, len = ej.isNullOrUndefined(colCount) ? sheet.colCount : colCount;
            htmlStr = isVirtualScroll ? "<tr style = 'height: {{:height}}px' idx = '{{:rowidx}}'>" : "<tr style = 'height: {{:height}}px'>";
            while (i < len) {
                colWth = sheet.columnsWidthCollection[i];
                colHdr = this._generateHeaderText(i + 1);
                col = document.createElement("col");
                if (colWth < 1)
                    col.setAttribute("class", "e-hide");
                else if (sheet._hiddenFreezeCols.indexOf(i) > -1)
                    col.setAttribute("class", "e-fcol-hide");
                col.style["width"] = colWth + "px";
                htmlStr += "<td class='{{:" + colHdr + "_className}}' rowspan=' {{:" + colHdr + "_rspan}}' colspan=' {{:" + colHdr + "_cspan}}'>{{:" + colHdr + "_value}}</td>";
                colgrp.append(col);
                i++;
            }
            templates[this._id + "JSONTemplate" + sheetIdx] = htmlStr + "</tr>";
            if (!skipRowHdr)
                templates[this._id + "JSONRowHdrTemplate" + sheetIdx] = isVirtualScroll ? "<tr class='{{:wrap}}' style='height:{{:height}}px' idx='{{:rowidx}}'><td class='{{:className}}'>{{:rowidx + 1}}</td></tr>" : "<tr class='{{:wrap}}' style='height:{{:height}}px'><td class='{{:className}}'>{{:rowidx + 1}}</td></tr>";
            $.templates(templates);
            this._sheets[sheetIdx]._contentColGroup = colgrp.get(0);
        },

        _renderData: function (rangeData, sheetIdx, stColIdx, colCount, isPrint, stRowIdx, rowCount) {
            var j, cls, val, obj, prop, text, data, rSpan, cSpan, mSpan, rowCnt, rowIdx, colIdx, colHdr, fltrStr, rowHgt, cFormat,
                isSelect, isVisible, sheetData, isVisCmnt, i, eCol, spc = " ", viewData = [], sheet = this.getSheet(sheetIdx),
                colCnt = isPrint ? colCount : sheet.colCount, goTo = sheet._goToCollection, goToLen = goTo.selected.length, rng, rowSpan;
            eCol = 0;
            i = stRowIdx ? stRowIdx : 0;
            if (rangeData) {
                data = rangeData.data;
                rowCnt = data.length / colCnt;
                while (i < rowCnt) {
                    obj = {}, j = eCol;
                    rowIdx = rangeData.rowIdx[i];
                    colIdx = isPrint ? stColIdx : 0;
                    while (j < (eCol + colCnt)) {
                        prop = data[j];
                        if (prop) {
                            colHdr = this._generateHeaderText(colIdx + 1);
                            cls = colHdr + "_className";
                            val = colHdr + "_value";
                            obj[cls] = "e-rowcell e-wrapword ";
                            if (!sheet.showGridlines)
                                obj[cls] += " e-hborder";
                            if (!isPrint && !goTo.multiple && goToLen && goTo.selected.indexOf(rowIdx + ":" + colIdx) > -1)
                                obj[cls] += " e-selected";
                            if (colIdx in sheet.hideColsCollection)
                                obj[cls] += " e-soverflow";
                            if (sheet._hiddenFreezeCols.indexOf(colIdx) > -1)
                                obj[cls] += " e-fcol-hide";
                            if (!isPrint && this.model.allowSelection && this.inRange(sheet.selectedRange, rowIdx, colIdx)) {
                                isSelect = true;
                                if (goTo.multiple) {
                                    isSelect = false;
                                    if (goToLen && goTo.selected.indexOf(rowIdx + ":" + colIdx) > -1)
                                        isSelect = true;
                                }
                                if (isSelect)
                                    obj[cls] += " e-selected";
                                if (sheet._activeCell.rowIndex === rowIdx && sheet._activeCell.colIndex === colIdx)
                                    obj[cls] += " e-activecell";
                            }
                            if (this.isImport && this.model.allowCellType && this.model.allowAutoCellType) {
                                if (prop.type == "shortdate" || prop.type == "longdate")
                                    this._celltypes.push({ rowIndex: rowIdx, colIndex: colIdx, sheetIndex: sheetIdx, cellType: { 'type': 'DatePicker' }, value: prop.value2 });
                                if (prop.value2 && ['true', 'yes', 'false', 'no'].indexOf(prop.value2.toLowerCase()) > -1)
                                    this._celltypes.push({ rowIndex: rowIdx, colIndex: colIdx, sheetIndex: sheetIdx, cellType: { 'type': 'CheckBox', 'isChecked': ['yes', 'true'].indexOf(prop.value2.toLowerCase()) > -1 ? true : false } });
                            }
                            if (this.isImport && prop.type == "date")
                                this.XLFormat.addCustomFormatSpecifier(null, prop.formatStr.replace(/^\{0\:|\}$/g, ""), prop.type);
                            // format
                            if (prop.format) {
                                obj[cls] += spc + prop.format;
                                if (this._isClassHasProperty(prop.format, 'text-align', 'right'))
                                    obj[cls] += " e-rightalign";
                            }
                            if (prop.border)
                                obj[cls] += spc + prop.border;
                            if (prop.align) {
                                if (prop.align === ej.Spreadsheet.Align.Center)
                                    obj[cls] += spc + this._cAlign;
                                else if (prop.align === ej.Spreadsheet.Align.Right)
                                    obj[cls] += spc + this._rAlign;
                            }
                            else if (this._isGeneral(prop.type) && ((typeof prop.value === "object" && this._isDateTime(prop.value)) || this.isNumber(prop.value)))
                                obj[cls] += spc + this._rAlign;
                            // merge
                            if (prop.isMHide) {
                                obj[cls] += " e-mc-hide";
                                obj[cls] += " e-moverflow";
                            }
                            if (prop.isOfBrdr)
                                obj[cls] += " e-ofbrdr";
                            if (prop.isOverflow === false)
                                obj[cls] += " e-overflow";
                            if (prop.merge) {
                                rSpan = colHdr + "_rspan";
                                cSpan = colHdr + "_cspan";
                                mSpan = prop.merge.mSpan;
                                obj[rSpan] = mSpan.rowSpan;
                                obj[cSpan] = mSpan.colSpan;
                                obj[cls] += " e-moverflow";
                                if (prop.merge.isCenterAlign)
                                    obj[cls] += spc + this._cAlign;
                            }
                            // conditional format
                            if (prop.cFormatRule) {
                                for (var k = 0, len = prop.cFormatRule.length; k < len; k++) {
                                    cFormat = prop.cFormatRule[k].split("_");
                                    if (cFormat[7] === "true")
                                        obj[cls] += " e-" + cFormat[4];
                                }
                            }
                            //wrap
                            if (prop.wrap && ((sheet._isImported && !this.isFormula(prop.value)) || !sheet._isImported)) {
                                obj[cls] += " e-sswraptext";
                                sheetData = this._dataContainer.sheets[sheetIdx];
                                (this.isUndefined(sheetData[rowIdx])) && (sheetData[rowIdx] = {});
                                (this.isUndefined(sheetData[rowIdx][0])) && (sheetData[rowIdx][0] = {});
                                sheetData[rowIdx][0].wrapRow = true;
                                (this.isUndefined(sheetData[0])) && (sheetData[0] = {});
                                if (this.isUndefined(sheetData[0][colIdx]))
                                    sheetData[0][colIdx] = { wrapCol: true, wrapWidth: sheet.columnsWidthCollection[colIdx] };
                                else {
                                    sheetData[0][colIdx]["wrapCol"] = true;
                                    sheetData[0][colIdx]["wrapWidth"] = sheet.columnsWidthCollection[colIdx];
                                }
                                this._wrapCollection(rowIdx, colIdx, this._detailsFromGlobalSpan(rowIdx, colIdx, "height", this.XLEdit.getPropertyValue(rowIdx, colIdx, "value2"), sheet.columnsWidthCollection[colIdx]), sheetIdx);
                            }
                            // data & hyperlink
                            text = prop.value2 || "";
                            if (prop.hyperlink) {
                                if (!isPrint) {
                                    if (prop.hyperlink.webAddr)
                                        obj[val] = String.format("<a href=\{0}\ class='e-hyperlinks' target='_blank'>\{1}\</a>", prop.hyperlink.webAddr, text);
                                    else
                                        obj[val] = String.format("<a class='e-hyperlinks'>\{0}\</a>",text);
                                }
                                else {
                                    obj[cls] += " e-hyperlinks";
                                    obj[val] = text;
                                }
                            }
                            else if(prop.merge && prop.wrap) {
								rowSpan = 0;
								rng = this.getRangeIndices(prop.merge.mRange);
								for(var k = rng[0]; k <= rng[2]; k++) {
									if(rangeData.rowIdx.indexOf(k) < 0)
										rowSpan++;
								}							
								obj[val] = "<div id =" + this._id + "_MergeWrap style = 'border :0px;overflow: hidden;max-height:" + (Math.floor(sheet._rowHeightCollection[rowIdx + (prop.merge.mSpan.rowSpan - rowSpan)] - sheet._rowHeightCollection[rowIdx]) - 1) + "px'>" + text + "</div>"; //-1 to set the height less than cell height to avoid misalignment
							}
                            else
                                obj[val] = text;
                            // comment
                            if (prop.comment) {
                                obj[cls] += " e-commentcell";
                                isVisCmnt = prop.comment.isVisible ? "visible" : "none";
                                obj[val] = String.format("<span class='e-comment'><span class='e-celltoparrow'></span><textarea class='e-comment-txtarea' style='display:\{0}\;z-index:9'>\{1}\</textarea></span>", isVisCmnt, prop.comment.value) + obj[val];
                            }
                            // validation
                            if (prop.rule && prop.rule.isApply && !(this.XLValidate._checkValidation(obj[val], prop.rule.customVal.split("_"), true, sheetIdx)))
                                obj[cls] += " e-hlcell";
                            // filter
                            if (prop.isFilterHeader && !this.isUndefined(sheet._filterColl[rowIdx]) && !this.isUndefined(sheet._filterColl[rowIdx][colIdx])) {
                                fltrStr = 'e-icon e-spanfilter e-filterspan ' + sheet._filterColl[rowIdx][colIdx].status;
                                isVisible = prop.isFilterVisible ? 'display: visible' : 'display: none';
                                obj[val] = String.format("<span class=\"{0}\" style=\"{1}\"></span>", fltrStr, isVisible) + obj[val];
                                obj[cls] = obj[cls].replace("e-ralign", "");
                                spc = spc.replace("e-ralign", "");
                            }
                            //Alt Text - unwrap state
                            if (prop.altTxt && !prop.wrap)
                                obj[cls] += " e-alt-unwrap";
                        }
                        colIdx++;
                        j++;
                    }
                    obj["rowidx"] = rowIdx;
                    rowHgt = sheet.rowsHeightCollection[rowIdx];
                    obj["height"] = (this.isUndefined(rowHgt) || rowHgt < this.model.rowHeight) ? this.model.rowHeight : rowHgt;
                    viewData.push(obj);
                    eCol = j;
                    i++;
                }
            }
            else {
                rowCnt = this.model.scrollSettings.allowVirtualScrolling ? sheet._virtualBlockRowCnt : sheet.rowCount;
                if (sheet._dummyData)
                    viewData = sheet._dummyData;
                else {
                    while (i < rowCnt) {
                        obj = {}, j = 0;
                        while (j < colCnt) {
                            colHdr = this._generateHeaderText(j + 1);
                            cls = colHdr + "_className";
                            obj[cls] = "e-rowcell e-wrapword ";
                            j++;
                        }
                        rowHgt = sheet.rowsHeightCollection[i];
                        obj["height"] = (this.isUndefined(rowHgt) || rowHgt < this.model.rowHeight) ? this.model.rowHeight : rowHgt;
                        obj["rowidx"] = rowIdx;
                        viewData.push(obj);
                        i++;
                    }
                }
            }
            sheet._dummyData = viewData;
            return $.render[this._id + "JSONTemplate" + sheetIdx](viewData);
        },

        _isGeneral: function (type) {
            if (this.isUndefined(type))
                type = ej.Spreadsheet.CellType.General;
            return type === ej.Spreadsheet.CellType.General;
        },

        _isFormulaError: function (error) {
            var i, len, formulaErr = ["#NA", "#DIV/0!", "#NAME?", "circular reference", "TypeError", "wrong"];
            for (i = 0, len = formulaErr.length; i < len; i++) {
                if (error.indexOf(formulaErr[i]) > -1)
                    return true;
            }
            return false;
        },

        _refreshViewport: function (top, sheetIdx) {
            var rangeData, rowCnt, rowIdxs, currIdx, nstartIdx, currRIdx, cendRIdx, nstartIdx, nstartRIdx, nendRIdx, pstartIdx, pstartRIdx, sheet = this.getSheet(sheetIdx), idx = this.XLShape._getCellIndexFromOffset(top, 0),
                props = ["value", "value2", "comment", "hyperlink", "rule", "cFormatRule", "format", "border", "type", "isFilterHide", "isRHide", "isFHide",
                        "isFilterHeader", "isFilterVisible", "filterState", "isMHide", "merge", "hRow", "isLocked", "wrap", "isOverflow", "align", "isOfBrdr", "altTxt", "formatStr"];
            sheet._virtualContBlockIdx = this._getVirtualBlockIdx(sheetIdx, idx.rowIndex).idx;
            currIdx = (sheet._virtualContBlockIdx - 1) * sheet._virtualBlockRowCnt;
            currRIdx = this._getRowIdx(currIdx, sheetIdx, true);
            nstartIdx = sheet._virtualContBlockIdx * sheet._virtualBlockRowCnt;
            nstartRIdx = this._getRowIdx(nstartIdx, sheetIdx, true);
            sheet._virtualContTBodyOffset.top = this._getRowOffsetTop(sheet, currRIdx);
            if (sheet._virtualBlockCnt === 1) {
                sheet._virtualTopTBodyOffset.top = sheet._virtualTopTBodyOffset.bottom = sheet._virtualTopTBodyHgt = 0;
                sheet._virtualBottomTBodyOffset.top = sheet._virtualBottomTBodyOffset.bottom = sheet._virtualBottomTBodyHgt = 0;
                sheet._virtualContTBodyOffset.bottom = this._getRowOffsetBottom(sheet._rowIdxColl[sheet._rowIdxColl.length - 1], sheetIdx);
                rowIdxs = sheet._rowIdxColl;
                sheet._isVirtualTopReached = sheet._isVirtualEndReached = true;
            }
            else if (sheet._virtualContBlockIdx === 1) {
                sheet._virtualTopTBodyOffset.top = sheet._virtualTopTBodyOffset.bottom = sheet._virtualTopTBodyHgt = 0;
                sheet._virtualContTBodyOffset.bottom = sheet._virtualBottomTBodyOffset.top = this._getRowOffsetTop(sheet, nstartRIdx);
                nendRIdx = this._getRowIdx(nstartIdx + (sheet._virtualBlockRowCnt - 1), sheetIdx, true);
                sheet._virtualBottomTBodyOffset.bottom = this._getRowOffsetBottom(nendRIdx, sheetIdx);
                sheet._virtualBottomTBodyHgt = sheet._virtualTBodyHgt - ((sheet._virtualContTBodyOffset.bottom - sheet._virtualContTBodyOffset.top) + (sheet._virtualBottomTBodyOffset.bottom - sheet._virtualBottomTBodyOffset.top));
                rowIdxs = sheet._rowIdxColl.slice(0, sheet._rowIdxColl.indexOf(nendRIdx) + 1);
                sheet._isVirtualTopReached = true;
                sheet._isVirtualEndReached = false;
            }
            else if (sheet._virtualContBlockIdx === sheet._virtualBlockCnt) {
                pstartIdx = (sheet._virtualContBlockIdx - 2) * sheet._virtualBlockRowCnt;
                sheet._virtualBottomTBodyOffset.top = sheet._virtualBottomTBodyOffset.bottom = sheet._virtualBottomTBodyHgt = 0;
                cendRIdx = this._getRowIdx(currIdx + (sheet._virtualBlockRowCnt - 1), sheetIdx, true);
                sheet._virtualContTBodyOffset.bottom = this._getRowOffsetBottom(cendRIdx, sheetIdx);
                pstartRIdx = this._getRowIdx(pstartIdx, sheetIdx, true);
                sheet._virtualTopTBodyOffset.top = this._getRowOffsetTop(sheet, pstartRIdx);
                sheet._virtualTopTBodyOffset.bottom = sheet._virtualContTBodyOffset.top;
                sheet._virtualTopTBodyHgt = sheet._virtualTBodyHgt - ((sheet._virtualContTBodyOffset.bottom - sheet._virtualContTBodyOffset.top) + (sheet._virtualTopTBodyOffset.bottom - sheet._virtualTopTBodyOffset.top));
                rowIdxs = sheet._rowIdxColl.slice(sheet._rowIdxColl.indexOf(pstartRIdx), sheet._rowIdxColl.indexOf(cendRIdx) + 1);
                sheet._isVirtualEndReached = true;
                sheet._isVirtualTopReached = false;
            }
            else {
                pstartIdx = currIdx - sheet._virtualBlockRowCnt;
                pstartRIdx = this._getRowIdx(pstartIdx, sheetIdx, true);
                sheet._virtualTopTBodyOffset.top = this._getRowOffsetTop(sheet, pstartRIdx);
                sheet._virtualTopTBodyOffset.bottom = sheet._virtualContTBodyOffset.top;
                sheet._virtualContTBodyOffset.bottom = sheet._virtualBottomTBodyOffset.top = this._getRowOffsetTop(sheet, nstartRIdx);
                nendRIdx = this._getRowIdx(nstartIdx + (sheet._virtualBlockRowCnt - 1), sheetIdx, true);
                sheet._virtualBottomTBodyOffset.bottom = this._getRowOffsetBottom(nendRIdx, sheetIdx);
                sheet._virtualTopTBodyHgt = top - ((sheet._virtualTopTBodyOffset.bottom - sheet._virtualTopTBodyOffset.top) + (top - sheet._virtualContTBodyOffset.top));
                sheet._virtualBottomTBodyHgt = sheet._virtualTBodyHgt - sheet._virtualBottomTBodyOffset.bottom;
                rowIdxs = sheet._rowIdxColl.slice(sheet._rowIdxColl.indexOf(pstartRIdx), sheet._rowIdxColl.indexOf(nendRIdx) + 1);
                sheet._isVirtualTopReached = sheet._isVirtualEndReached = false;
            }
            rangeData = this.getRangeData({ property: props, sheetIdx: sheetIdx, rowIdxs: rowIdxs, withRowIdx: true });
            this._getRowHdrTBody(sheetIdx).html(this._renderRowHdr(rangeData.rowIdx, sheetIdx));
            this._getContTBody(sheetIdx).html(this._renderData(rangeData, sheetIdx));
            this._refreshRows(sheetIdx);
            this._refreshTBodiesHgt(sheetIdx);
            if (this.model.allowComments)
                this.XLComment._updateCmntArrowPos(null, sheetIdx);
            sheet._virtualRowIdx = rangeData.rowIdx;
            if (this.model.allowCellType)
                this.XLCellType._rangeCellTypes(sheet.cellTypes, sheetIdx);
            this._refreshViewVar(top, sheet._isLoaded ? null : 0, sheetIdx);
        },

        refreshOverflow: function (range, sheetIdx) {
            this._refreshOverflow(range, sheetIdx);
        },

        _refreshOverflow: function (range, sheetIdx) {
            sheetIdx = this._getSheetIndex(sheetIdx);
            var i, cell, rowIdx, colIdx, cells, sheet = this.getSheet(sheetIdx);
            range = range || [0, 0, sheet.usedRange.rowIndex, sheet.usedRange.colIndex];
            cells = this.XLEdit._getPropWithCellIdx(range, 'value2');
            for (i = cells.length - 1; i > -1; i--) {
                rowIdx = cells[i].rowIdx, colIdx = cells[i].colIdx;
                if (this.model.allowOverflow)
                    this._textClip(rowIdx, colIdx, 'add', '', true);
                else {
                    if (this._isRowViewable(sheetIdx, rowIdx))
                        cell = this.getCell(rowIdx, colIdx)[0];
                    this._removeClass(cell, 'e-overflow');
                    this._textClip(rowIdx, colIdx, 'delete', '', true);
                    this.addClass(cell, 'e-overflow');
                    this.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { isOverflow: false }, skipCell: true });
                }
            }
        },

        _getVirtualBlockIdx: function (sheetIdx, rowIdx, withAllIdx) {
            var vrowIdx, i = 1, obj = {}, sheet = this.getSheet(sheetIdx);
            vrowIdx = this._getRowIdx(rowIdx, sheetIdx, false, true);
            while (i <= sheet._virtualBlockCnt) {
                if (vrowIdx < (i * sheet._virtualBlockRowCnt)) {
                    obj.idx = i;
                    break;
                }
                i++;
            }
            if (withAllIdx) {
                i = 0;
                while (++i) {
                    if (rowIdx < (i * sheet._virtualBlockRowCnt)) {
                        obj.orgIdx = i;
                        break;
                    }
                }
            }
            return obj;
        },

        _getBlockInfo: function (rowIdx, sheetIdx, withAllIdx) {
            var blkIdx, sheet = this.getSheet(sheetIdx), range = [0, 0, 0, sheet.colCount - 1];
            blkIdx = this._getVirtualBlockIdx(sheetIdx, rowIdx, withAllIdx);
            range[0] = (sheet._virtualBlockRowCnt * (blkIdx.idx - 1));
            range[2] = (sheet._virtualBlockRowCnt * blkIdx.idx) - 1;
            blkIdx.range = range;
            if (withAllIdx) {
                range = [0, 0, 0, sheet.colCount - 1];
                range[0] = (sheet._virtualBlockRowCnt * (blkIdx.orgIdx - 1));
                range[2] = (sheet._virtualBlockRowCnt * blkIdx.orgIdx) - 1;
                blkIdx.orgRange = range;
            }
            return blkIdx;
        },

        _getRowOffsetTop: function (sheet, rowIdx) {
            return sheet._rowHeightCollection[rowIdx];
        },

        _getRowOffsetBottom: function (rowIdx, sheetIdx) {
            return this.getSheet(sheetIdx)._rowHeightCollection[rowIdx] + this.getSheet(sheetIdx).rowsHeightCollection[rowIdx];
        },

        _getColOffsetLeft: function (sheet, colIdx) {
            return sheet._colWidthCollection[colIdx];
        },

        _getCellIdx: function (cell) {
            return { rowIndex: this.model.scrollSettings.allowVirtualScrolling ? Number(cell.parentNode.attributes.getNamedItem("idx").value) : cell.parentNode.rowIndex, colIndex: cell.cellIndex };
        },

        _getMidCell: function () {
            var diff, obj = {}, sheet = this.getSheet();
            diff = (sheet._bottomRow.idx - sheet._topRow.idx) + 1;
            obj.rowIdx = sheet._topRow.idx + Math.floor(diff / 2);
            diff = (sheet._rightCol.idx - sheet._leftCol.idx) + 1;
            obj.colIdx = sheet._leftCol.idx + Math.floor(diff / 2);
            return obj;
        },

        _removeRange: function (idx, cnt) {
            var sheetIdx = this.getActiveSheetIndex(), rowHdrTBody = this._getRowHdrTBody(sheetIdx), rowHdrRows = $(this._getRowHdrTBody(sheetIdx)[0].rows),
                contTBody = this._getContTBody(sheetIdx), contRows = $(this._getContTBody(sheetIdx)[0].rows);
            rowHdrRows.splice(idx, cnt);
            contRows.splice(idx, cnt);
            this.setRows([rowHdrRows, contRows], sheetIdx);
            contTBody.html(contRows);
            rowHdrTBody.html(rowHdrRows);
        },

        _refreshTBodiesHgt: function (sheetIdx) {
            var px = "px", sheetIdx = this._getSheetIndex(sheetIdx), sheet = this.getSheet(sheetIdx), hdrTBody = this._getJSSheetRowHeaderContent(sheetIdx)[0].getElementsByTagName("tbody"),
                contTBody = this._getContent(sheetIdx)[0].getElementsByTagName("tbody");
            hdrTBody[0].style.height = contTBody[0].style.height = sheet._virtualTopTBodyHgt + px;
            hdrTBody[2].style.height = contTBody[2].style.height = sheet._virtualBottomTBodyHgt + px;
        },

        _renderTD: function (className, styles, innerHtml) {
            return String.format("<td class='{0}' style='{1}' >{2}</td>", className, styles, innerHtml);
        },

        _renderDIV: function (className, innerHtml, title) {
            return title ? String.format("<div class='{0}' title='{2}'>{1}</div>", className, innerHtml, title) : String.format("<div class='{0}'>{1}</div>", className, innerHtml);
        },

        _renderTR: function (tdData, i, sheetIdx) {
            var trHeight = this._sheetCopy.isSheetCopy ? this.getSheet(sheetIdx).rowsHeightCollection[i] : this.model.rowHeight,
                height = "height:" + trHeight + "px";
            return String.format("<tr style='{0}'>" + tdData + "</tr>", height);
        },

        _renderFooter: function () {
            var scrollSettings = this.model.scrollSettings, pgrWidth, div = ej.buildTag('div.e-spreadsheetfooter', "", { "display": this.model.showPager ? "block" : "none" }), table = ej.buildTag("table.e-table", "", {}, {}),
                tbody = $(document.createElement("tbody")), tr = $(document.createElement("tr")), td = $(document.createElement("td")), settings = this.model.scrollSettings, pagerHt;
            this._updateResponsiveSettings();
            pgrWidth = scrollSettings.isResponsive ? "100%" : this._responsiveWidth - 2;
            td.append(this._renderSpreadSheetPager());
            td.find(".e-pagercontainer").append(ej.buildTag("div#" + this._id + "_AddSheet.e-new e-icon e-default", "", null, { title: this._getLocStr("NewSheet") }));
            tr.append(td);
            tbody.append(tr);
            table.append(tbody);
            div.append(table);
            this.getMainPanel().append(div);
            if (!(this.model.scrollSettings.isResponsive || this._isAutoWHMode))
                pgrWidth = pgrWidth;
            this._refreshSpreadSheetPager();
            pagerHt = this.element.find(".e-spreadsheetfooter").outerHeight();
            if (this.model.showPager && pagerHt > this.model.pageSettings.pagerHeight)
                this.model.pageSettings.pagerHeight = pagerHt < 37 ? pagerHt : 36; //pager max height
            div.width(pgrWidth).height(this.model.showPager ? this.model.pageSettings.pagerHeight : 0);
            this.element.find(".e-spreadsheetfooter .e-table").height(this.model.pageSettings.pagerHeight);
            this.setFooter(div);
        },

        //Pager
        gotoPage: function (sheetIdx, newSheet) {
            if ((!newSheet && sheetIdx > this.model.sheetCount) || sheetIdx < 1)
                return;
            var insertIndex, sheet, sheets = this.model.sheets, pagerObj = this.getPager(), settings = {}, impData = this._impData, scrollTop, scrollLeft,
                args = { reqType: "gotoSheet", gotoIndex: sheetIdx, newSheet: newSheet, prevSheetIdx: this.getActiveSheetIndex() }, cell, listProp, ribCollapsed = !this.XLRibbon._ribbonState,
                evtArgs = { reqType: args.reqType, gotoSheetIndex: args.gotoIndex, isNewSheet: args.newSheet, prevSheetIndex: args.prevSheetIdx };
            this._gotoPageArgs = $.extend(true, {}, args);
            this._isSheetNavigate = newSheet ? false : true;
            if (this._trigActionBegin(evtArgs))
                return;
            if (!this.isImport)
                this.hideActivationPanel();
            this.setActiveSheetIndex(sheetIdx);
            sheet = sheets[sheetIdx];
            if (!newSheet && !sheet._isRequested && sheet._isImported)
                this._importSheet(sheetIdx);
            else {
                this.element.find(".e-sheet").hide();
                if (newSheet) {
                    this._addSheet(sheetIdx);
                    sheet = sheets[sheetIdx];
                }
                if (this._isSheetInsert) {
                    insertIndex = pagerObj.ejPager("option", "currentPage");
                    this._swapSheetDtCntr(sheets.length - 1, insertIndex);
                    this.model.activeSheetIndex = sheetIdx = insertIndex;
                    this._isSheetInsert = false;
                }
                if (this._isNew || ((this.model.scrollSettings.allowVirtualScrolling || this.model.scrollSettings.allowSheetOnDemand) && !sheet._isLoaded)) {
                    this.showWaitingPopUp();
                    this._initSheet(sheetIdx);
                }
                else {
                    this.element.find("#" + this._id + "_" + sheet.sheetInfo.value).show();
                    !newSheet && this._initSelection();
                    if (this._isAutoWHMode) {
                        this._autoSSWidthHeight();
						!sheet._isOpened && this._refreshOverflow(undefined, sheetIdx);
					}
                    if (this._gotoPageArgs)
                        this._pageLoadComplete(sheetIdx);
                }
                if (sheet._isResized) {
                    this._refreshSheetWithScreen(sheetIdx);
                    this._updateResponsiveSettings();
                    settings.width = this._responsiveWidth;
                    settings.height = this._responsiveHeight;
                    this._setSheetWidthHeight(sheetIdx, settings, null, "refresh");
                    sheet._isResized = false;
                }
                if (!this.model.scrollSettings.allowVirtualScrolling && !sheet._isOpened)
                    this._updateHiddenRows(sheetIdx);
                if (this.model.allowFreezing)
                    this.XLFreeze._refreshFreeze();
                this._isSheetNavigate = false;
            }
            sheet._isOpened = true;
            if (impData && !this._isExport && !sheet._isImpSLoad && sheet._isImported) {
                scrollTop = impData.model.sheets[sheetIdx]._scrollTop, scrollLeft = impData.model.sheets[sheetIdx]._scrollLeft;
                (scrollTop > 0) && this.XLScroll._vScroller(sheetIdx).scroll(scrollTop);
                (scrollLeft > 0) && this.XLScroll._hScroller(sheetIdx).scroll(scrollLeft);
                sheet._isImpSLoad = true;
            }
            cell = this.getActiveCell(sheetIdx);
            listProp = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "rule", sheetIdx);
            if (listProp && listProp.type === "list")
                this._setddlCell();
            if (sheet._isRibCollapsed != ribCollapsed) {
                this._heightWidthCalculation(this.getActiveSheetIndex(), $.extend(true, {}, this.model.scrollSettings));
                sheet._isRibCollapsed = ribCollapsed;
            }
			if (this._isAutoWHMode) {
				var dimension = this._getElementDimension();
                this.element.css({ height: dimension.height, width: dimension.width });
			}
        },

        insertSheet: function () {
            if (!this.model.allowInsert || this.model.isReadOnly)
                return;
            var pager = this.getPager(), insertPage = pager.ejPager("option", "totalRecordsCount") + 1;
            pager.ejPager("option", { totalRecordsCount: insertPage });
            this._isSheetInsert = true;
            this.gotoPage(insertPage, true);
            this.setSheetFocus();
        },

        _renameSheet: function (sName) {
            var trgt = this.element.find(".e-currentitem"), input = ej.buildTag("input#" + this._id + "_Sheet_RenamePanel", "", { width: trgt.width() + 5 + "px", padding: 0 }, { type: "input", value: sName || trgt.text(), maxlength: "31" });
            trgt.hide();
            input.insertAfter(trgt).select().focus();
            this._isSheetRename = true;
            if (this.model.showRibbon)
                this.XLRibbon._disableRibbonIcons();
            if (this.model.enableContextMenu)
                $("#" + this._id + "_contextMenuFooter").data("ejMenu")._contextMenuEvents("_off"); //for enable default contextmenu - clipboard actions
        },

        deleteSheet: function (index) {
            if (!this.model.allowDelete || this.model.isReadOnly)
                return;
            var actShtIdx = this.getActiveSheetIndex(), sheetCount = this._getSheetNames(true).length;
            index = index || actShtIdx;
            if (sheetCount > 1) {
                if (index !== actShtIdx)
                    this.gotoPage(index, false);
                if (this.getObjectLength(this._dataContainer.sheets[index]))
                    this._showAlertDlg("", "SheetDeleteAlert", "sheetDeleteActn", 470);
                else
                    this._removeSheet(index);
            }
            else
                this._showAlertDlg("Alert", "SheetDeleteErrorAlert", "", 430);
        },

        hideSheet: function (shtInfo) {
            if (this.model.isReadOnly)
                return;
            var visibeSht = this._getSheetNames(true), shtNames = this._getSheetNames(),
                idx = $.isNumeric(shtInfo) ? shtInfo : this._getSheetIndexByName(shtInfo) || this.getActiveSheetIndex();
            if (visibeSht.length > 1) {
                shtNames[idx - 1].isVisible = false;
                this.gotoPage(this._getNxtVisibleSheet(idx, null, visibeSht));
            }
            else
                this._showAlertDlg("Alert", "SheetDeleteErrorAlert", "", 377);
        },

        unhideSheet: function (shtInfo) {
            if (this.model.isReadOnly)
                return;
            var shtNames = this._getSheetNames(), idx = $.isNumeric(shtInfo) ? shtInfo : this._getSheetIndexByName(shtInfo);
            if (!shtNames[idx - 1].isVisible) {
                shtNames[idx - 1].isVisible = true;
                this.gotoPage(idx);
            }
            this.hideWaitingPopUp();
        },

        _getNxtVisibleSheet: function (idx, isReverseDir, visibleSheets) {
            var shtNames = this._getSheetNames(), limit = shtNames.length, optr1 = "<=", optr2 = 1, visibeShts = this._getSheetNames(true),
                isLastSht = shtNames[idx - 1].value === (visibleSheets && visibleSheets[visibleSheets.length - 1].value || visibeShts[visibeShts.length - 1].value);
            if (isReverseDir || isLastSht) {
                limit = 0;
                optr1 = ">=";
                optr2 = -1;
            }
            while (this.operators[optr1](idx, limit)) {
                if (shtNames[idx - 1].isVisible)
                    return idx;
                idx = idx + optr2;
            }
        },

        _renderSpreadSheetPager: function () {
            var inst, parent, pagerModel = {}, div = $(document.createElement("div"));
            this.model.pageSettings.click = $.proxy(this._spreadSheetPagerClickHandler, this);
            this.model.pageSettings.totalRecordsCount = this.model.sheetCount;
            this.model.pageSettings.locale = this.model.locale
            $.extend(pagerModel, this.model.pageSettings);
            pagerModel.currentPage = this.getActiveSheetIndex();
            pagerModel.pageSize = 1;
            pagerModel.showGotoPage = false;
            this.setPager(div);
            div.ejPager(pagerModel);
            inst = div.data("ejPager");
            inst._$first[0].title = this._getLocStr("Firstsheet");
            inst._$last[0].title = this._getLocStr("Lastsheet");
            inst._$next[0].title = this._getLocStr("Nextsheet");
            inst._$prev[0].title = this._getLocStr("Prevsheet");
            div.find(".e-parentmsgbar").remove();
            parent = div.find(".e-pagercontainer")[0];
            parent.appendChild(div.find("a.e-PP")[0]);
            parent.appendChild(div.find(".e-numericcontainer")[0]);
            parent.appendChild(div.find("a.e-NP")[0]);
            return div;
        },

        _getPageCount: function () {
            var isResponsive = this.model.scrollSettings.isResponsive, count = this.model.pageSettings.pageCount;
            if (isResponsive) {
                var pageCount = 0, sheetTxt, isIE8Bwsr, spanElem, pager = this.getPager(), cavsElem, cavsTxt, currentItem = pager.find('.e-currentitem'), numericcontainer = pager.find(".e-numericcontainer"),
                    sheetNames = this._getSheetNames(), totalwidth = pager.width(), width = 250, //total width except numeric container
                    visibleLinks = numericcontainer.children(':visible'), actIdx = this.getActiveSheetIndex(), startPgIdx = $(visibleLinks[0]).data("index"), isFoundCnt = true;

                isIE8Bwsr = (this._browserDetails.name === "msie" && this._browserDetails.version === "8.0");
                if (isIE8Bwsr) {
                    spanElem = $('#' + this._id + '_emptySpan');
                    spanElem.css({ 'font-size': currentItem.css('font-size'), 'font-family': currentItem.css("font-family") });
                }
                else {
                    cavsElem = document.createElement("canvas");
                    cavsTxt = cavsElem.getContext("2d");
                    cavsTxt.font = currentItem.css('font-size') + " " + currentItem.css("font-family");
                }
                while (actIdx > (startPgIdx - 1)) {
                    if (isIE8Bwsr)
                        width += (spanElem.text(sheetNames[actIdx - 1].text).width() + 19);
                    else
                        width += (cavsTxt.measureText(sheetNames[actIdx - 1].text).width + 19); //19 for padding & border
                    if (totalwidth <= width)
                        return pageCount || 1;
                    actIdx--;
                    pageCount++;
                }

                actIdx = this.getActiveSheetIndex();
                while (isFoundCnt) {
                    if (this.isUndefined(sheetNames[actIdx]))
                        sheetTxt = this._getLocStr("Sheet") + actIdx;
                    else
                        sheetTxt = sheetNames[actIdx].text;
                    if (isIE8Bwsr)
                        width += (spanElem.text(sheetTxt).width() + 19);
                    else
                        width += (cavsTxt.measureText(sheetTxt).width + 19);
                    if (totalwidth <= width) {
                        isFoundCnt = false;
                        break;
                    }
                    actIdx++;
                    pageCount++;
                }
                isIE8Bwsr && this._refreshGlobalSpan();

                return pageCount || 1;
            }
            else
                return count;
        },

        _spreadSheetPagerClickHandler: function (sender) {
            var div, newPage, addnew = false, masterObj = this, args, trgt = $(sender.event.target), pagerObj = masterObj.getPager().data("ejPager");
            masterObj._filterClose(trgt);
            if (masterObj._hasClass(trgt[0], 'e-disable') || (trgt.hasClass("e-new") && masterObj.model.exportSettings.password))
                return;
            if (((masterObj.model.allowComments && masterObj.XLComment._isCommentEdit) || masterObj.XLEdit._isEdit || !masterObj.model.allowInsert || masterObj.model.isReadOnly) && (sender.event && (trgt.hasClass("e-pager") || trgt.hasClass("e-new")) || (masterObj.element.find(".e-field-validation-error").length)))
                return;
            else {
                masterObj.model.allowComments && masterObj.XLComment._isCommentEdit && masterObj.XLComment._updateCurCmntVal();
                masterObj.XLEdit._isEdit && masterObj.XLEdit.saveCell();
            }
            if (!ej.isNullOrUndefined(sender.event) && (trgt.hasClass("e-prevpage") || trgt.hasClass("e-nextpage") || trgt.hasClass("e-firstpage") || trgt.hasClass("e-lastpage")))
                sender.currentPage = masterObj._getNxtVisibleSheet(sender.currentPage, (trgt.hasClass("e-prevpage") || trgt.hasClass("e-lastpage")));
            args = {
                activeSheet: masterObj.getActiveSheetIndex(),
                gotoSheet: sender.currentPage,
                newSheet: sender.event && trgt.hasClass("e-new")
            };
            if (args.newSheet) {
                div = masterObj.getPager();
                newPage = div.ejPager("option", "totalRecordsCount") + 1;
                args.gotoSheet = newPage;
            }
            else
                args.gotoSheet = sender.currentPage;
            sender.currentPage = args.gotoSheet;
            if ((!ej.isNullOrUndefined(sender.event) && sender.event.target.id.indexOf("_Sheet_RenamePanel") > -1) || (masterObj._isSheetRename && !masterObj._updateSheetNames(null, false)) || (pagerObj._prevPageNo === sender.currentPage))
                return;
            else if (args.newSheet) {
                div.ejPager("option", { totalRecordsCount: newPage, currentPage: newPage });
                sender.currentPage = newPage;
                addnew = true;
            }
            masterObj._pageClickArgs = $.extend(true, {}, args);
            masterObj.gotoPage(sender.currentPage, addnew);
            if (!$(sender.event.target).hasClass("e-pager")) {
                masterObj._completeAction({ reqType: "paging", sheetIndex: args.activeSheet, nSheetIndex: sender.currentPage });
                masterObj._trigActionComplete({ reqType: "paging", sheetIndex: args.activeSheet, newSheetIndex: sender.currentPage });
            }
            return false;
        },

        _pageLoadComplete: function (sheetIdx) {
            var sheetCont, evtArgs, sheet = this.getSheet(sheetIdx), opt = "option", chkd = "checked", args = this._gotoPageArgs, isSelect = this.model.allowSelection;
            if (isSelect && (sheetIdx !== args.prevSheetIdx) && (this.XLSelection._isGridBordering || this.XLSelection._isOutsideBordering)) {
                this._getContent(args.prevSheetIdx).find("div:first-child").removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor").addClass("e-ss-cursor");
                this.XLSelection._isGridBordering = this.XLSelection._isOutsideBordering = false;
            }
            if ((!sheet._isImported || sheet._isLoaded) && this.model.enableContextMenu)
                this.XLCMenu.hideCMenu();
            this._refreshSpreadSheetPager(args.newSheet);
            if (isSelect && this.getSheetElement(sheetIdx).find(".e-ss-activeimg").length)
                this.XLSelection._cleanUp(true);
            if (this.model.showRibbon) {
                this._updateRibbonTab(sheet._activeCell);
                if (!this.isImport) {
                    if (this.model.allowLockCell) {
                        sheet.isSheetProtected ? this.XLRibbon._disableRibbonIcons() : this.XLRibbon._enableRibbonIcons();
                        this.XLRibbon._updateRibbonIcons();
                    }
                    if (this.model.allowComments)
                        this.XLComment._updateCmntRibIcons();
                }
                $("#" + this._id + "_Ribbon_PageLayout_Show_Headings").ejCheckBox(opt, chkd, sheet.showHeadings);
                $("#" + this._id + "_Ribbon_PageLayout_Show_Gridlines").ejCheckBox(opt, chkd, sheet.showGridlines);
            }
            if (this.model.allowCellFormatting) {
                sheetCont = this.getSheetElement(sheetIdx).find(".e-content")[0];
                if (this.XLFormat._formatEnable) {
                    this._removeClass(sheetCont, "e-ss-cursor");
                    this.addClass(sheetCont, "e-ss-fpcursor");
                }
                else {
                    this.addClass(sheetCont, "e-ss-cursor");
                    this._removeClass(sheetCont, "e-ss-fpcursor");
                }
            }
            if (this._pageClickArgs) {
                this._pageClickArgs.activeSheet = this.getActiveSheetIndex();
                if (this._trigger("pagerClick", this._pageClickArgs))
                    return;
                if (this.model.scrollSettings.isResponsive)
                    if (this._isResized && !this._resizeColl[sheetIdx - 1]) {
                        this._refreshSheetonResize();
                        if (this._resizeColl.toString().indexOf("f") < 0) {
                            this._isResized = false;
                            this._resizeColl.fill(false);
                        }
                    }
            }
            this.hideWaitingPopUp();
            this._pageClickArgs = this._gotoPageArgs = null;
            evtArgs = { gotoSheetIndex: args.gotoIndex, isNewSheet: args.newSheet, prevSheetIndex: args.prevSheetIdx, reqType: args.reqType };
            if (this._trigActionComplete(evtArgs))
                return;
        },

        _createTemplateElement: function (index, column) {
            var scriptElement = document.createElement("script");
            scriptElement.id = (this._id + index + column["field"] + $.inArray(column, this.getSheet(index).columns) + "_Template").split(" ").join("");
            scriptElement.type = "text/x-jsrender";
            scriptElement.text = column["templateContent"] ? column["templateContent"] : $(column["templateID"]).html();
            $("body").append(scriptElement);
            $(column["templateID"]).hide();
            return scriptElement;
        },

        _refreshSpreadSheetPager: function (refreshPgCnt) {
            var pager = this.getPager(), model = { currentPage: this.getActiveSheetIndex() }, prePgHght = pager.height(), curHght;
            if (this.isImport || this._isNew || pager === null)
                model.totalRecordsCount = this.model.sheetCount;
            if (refreshPgCnt || this._isInitLoad || this._isSheetInsert || this._isNew)
                model.pageCount = this._getPageCount();
            pager.ejPager("option", model).ejPager("refreshPager");
            this._updatePageContainer(pager, model.currentPage);
            curHght = pager.height();
            if (prePgHght !== curHght) {
                model.pageCount = this._getPageCount();
                pager.ejPager("option", model).ejPager("refreshPager");
                this._updatePageContainer(pager, model.currentPage);
            }
            if (!this.model.allowInsert)
                this.addClass(document.getElementById(this._id + "_AddSheet"), "e-disable");
        },

        _updatePageContainer: function (pagerContainer, currentPage) {
            var isFirst, isLast, index, pagerelem, sheetText, sheetinfo, i = 0, j = 0, pagerObj = pagerContainer.data("ejPager"), sheets = this.model.sheets,
                pager = pagerContainer.find(".e-numericcontainer").children(':visible'), pageCnt = pagerObj.model.pageCount, first = [pagerObj._$first[0], pagerObj._$prev[0]],
                firstcls = ["e-firstpagedisabled e-disable", "e-firstpage e-default", "e-prevpagedisabled e-disable", "e-prevpage e-default"],
                last = [pagerObj._$last[0], pagerObj._$next[0]], lastcls = ["e-lastpagedisabled e-disable", "e-lastpage e-default", "e-nextpagedisabled e-disable", "e-nextpage e-default"],
                len = pager.length, isSingleSht = ((i + 1) === len);
            pagerObj._$next[0].className = pagerObj._$next[0].className.replace("-2x", "");
            pagerObj._$prev[0].className = pagerObj._$prev[0].className.replace("-2x", "");
            while (i < len) {
                pagerelem = $(pager[i]);
                index = pagerelem.data("index");
                sheetinfo = sheets[index].sheetInfo;
                sheetText = sheetinfo.text;
                if (isSingleSht) {
                    var isIE8Bwsr, spanElem, pgrWidth = pagerContainer.outerWidth(), width, cavsElem,
                        cavsTxt, iterateElpstxt = true, temp = sheetText, sIdx = 3;
                    isIE8Bwsr = (this._browserDetails.name === "msie" && this._browserDetails.version === "8.0");
                    while (iterateElpstxt) {
                        if (isIE8Bwsr) {
                            spanElem = $('#' + this._id + '_emptySpan');
                            spanElem.css({ 'font-size': pagerelem.css('font-size'), 'font-family': pagerelem.css("font-family") });
                            width = 248 + (spanElem.text(temp).width() + 19);
                        }
                        else {
                            cavsElem = document.createElement("canvas");
                            cavsTxt = cavsElem.getContext("2d");
                            cavsTxt.font = pagerelem.css('font-size') + " " + pagerelem.css("font-family");
                            width = 248 + (cavsTxt.measureText(temp).width + 19); //total width except numeric container - 19(border & padding)
                        }
                        if (pgrWidth <= width && sheetText.length >= sIdx) {
                            temp = sheetText.slice(0, sheetText.length - sIdx++) + "...";
                            continue;
                        }
                        iterateElpstxt = false;
                        sheetText = temp;
                    }
                    isIE8Bwsr && this._refreshGlobalSpan();
                }
                pagerelem.text(sheetText);
                if (sheetinfo.isVisible)
                    isLast = index % pageCnt;
                else
                    pagerelem.hide();
                if (!isFirst && sheetinfo.isVisible)
                    isFirst = index % pageCnt;
                i++;
            }
            if (isFirst === currentPage) {
                for (i = 0; i < 2; i++) {
                    this.addClass(first[i], firstcls[j]);
                    this._removeClass(first[i], firstcls[j + 1]);
                    j += 2;
                }
            }
            j = 0;
            if (isLast === currentPage) {
                for (i = 0; i < 2; i++) {
                    this.addClass(last[i], lastcls[j]);
                    this._removeClass(last[i], lastcls[j + 1]);
                    j += 2;
                }
            }
        },

        _updateSheetNames: function (updatedValue, isCancel) {
            var args, pName, gridObj, rfrTo, calcObj, nMngr, pagerContainer = this.getPager(), i, len, $sheet = pagerContainer.find(".e-currentitem"),
                sheets = this.model.sheets, $input = $("#" + this._id + "_Sheet_RenamePanel"), isValidName = true,
                temp = [], cellRefrs, sheetNames, cellRef, fValue, rowIdx, colIdx, sheetIdx, regx, isReplaced, i, j, k, l, keys = [], calcDependent;
            if (ej.isNullOrUndefined(updatedValue))
                updatedValue = $input.val().trim();
            pName = sheets[$sheet.data("index")].sheetInfo.text;
            args = { reqType: "renameSheet", prevName: pName, newName: updatedValue };
            if (this._trigActionBegin(args))
                isCancel = true;
            updatedValue = args.newName;
            //Cancel rename action
            if (isCancel) {
                $input.remove();
                $sheet.show();
                if (this.model.showRibbon)
                    this.XLRibbon._enableRibbonIcons();
                if (this.model.enableContextMenu)
                    $("#" + this._id + "_contextMenuFooter").data("ejMenu")._contextMenuEvents("_on"); //for disable default contextmenu - clipboard actions
                this._isSheetRename = false;
                return false;
            }
            if (updatedValue.match(new RegExp(".*[\\[\\]\\*\\\\\/\\?].*")))
                updatedValue = false;
            if (!updatedValue) {
                this._showAlertDlg("Alert", ["SheetRenameEmptyAlert", "SheetRenameEmptyCharExceedAlert", "SheetRenameEmptySplCharAlert", "SheetRenameEmptyBlankAlert"], "sheetRenameActn", 500);
                return false;
            }
            //Check isValid name
            for (i = 1, len = sheets.length; i < len; i++) {
                if ($sheet.text() !== sheets[i].sheetInfo.text && updatedValue.toLowerCase() === sheets[i].sheetInfo.text.toLowerCase())
                    isValidName = false;
            }
            if (isValidName) {
                if (this.model.enablePivotTable)
                    this.XLPivot._updateSheetName(updatedValue);
                if (sheets[$sheet.data("index")].sheetInfo.text = updatedValue) {
                    $input.remove();
                    $sheet.show();
                    calcObj = this._calcEngine;
                    calcDependent = calcObj.getDependentCells().items;
                    for (var key in calcDependent)
                        if (calcDependent.hasOwnProperty(key))
                            keys.push(key);
                    cellRefrs = keys;
                    sheetNames = this._getSheetNames();
                    for (i = 0; i < cellRefrs.length; i++) {
                        cellRef = calcDependent[cellRefrs[i]];
                        for (j = 0; j < cellRef.length; j++) {
                            fValue = calcObj.getFormulaInfoTable().items[cellRef[j]];
                            if (fValue) {
                                fValue = fValue.getFormulaText();
                                for (k = 0; k < sheetNames.length; k++) {
                                    if (sheetNames[k].text !== sheetNames[k].value) {
                                        regx = new RegExp(sheetNames[k].value + '(?=[\'!])(?=[^"]*(?:"[^"]*"[^"]*)*$)', 'gi');
                                        if (fValue.match(regx)) {
                                            fValue = fValue.replace(regx, k + "/");
                                            temp.push(k);
                                            isReplaced = true;
                                        }
                                    }
                                }
                            }
                            if (isReplaced) {
                                l = 0;
                                while (l < temp.length) {
                                    regx = new RegExp(temp[l] + '/(?=[\'!])(?=[^"]*(?:"[^"]*"[^"]*)*$)', 'gi');
                                    fValue = fValue.replace(regx, sheetNames[temp[l]].text);
                                    l++;
                                }
                                rowIdx = calcObj.rowIndex(cellRef[j]) - 1;
                                colIdx = calcObj.colIndex(cellRef[j]) - 1;
                                sheetIdx = this._getSheetIdxFromSheetValue(this._getLocStr("Sheet") + (parseInt(cellRef[j].split("!")[1]) + 1));
                                this.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { value: fValue }, sheetIdx: sheetIdx });
                                isReplaced = false;
                            }
                        }
                    }
                    this._isSheetRename = false;
                }
                this._refreshSpreadSheetPager(true);
                this.model.allowFormulaBar && this.updateFormulaBar();
                //Refresh NM coll
                nMngr = this.model.nameManager;
                for (i in nMngr) {
                    rfrTo = nMngr[i].refersto;
                    if (rfrTo && rfrTo.indexOf(pName) > -1) {
                        rfrTo = rfrTo.replace(/[\']/g, "");
                        nMngr[i].refersto = rfrTo.replace(pName, updatedValue.match(/\s/g) ? "'" + updatedValue + "'" : updatedValue);
                    }
                }
                if (this.model.showRibbon) {
                    this.XLRibbon._enableRibbonIcons();
                    gridObj = $("#" + this._id + "_nmgrid").data("ejGrid");
                    if (gridObj) {
                        gridObj.refreshContent();
                        $("#" + this._id + "_nmrange").val("");
                    }
                }
                if (this.model.enableContextMenu)
                    $("#" + this._id + "_contextMenuFooter").data("ejMenu")._contextMenuEvents("_on"); //for disable default contextmenu - clipboard actions
                args = { reqType: "renameSheet", prevName: pName, newName: updatedValue };
                this._trigActionComplete(args);
                return true;
            }
            else
                this._showAlertDlg("Alert", "SheetRenameAlert", "sheetRenameActn", 325);
        },

        _getSheetIndexByName: function (sheetName) {
            var sheetNameCol = this._getSheetNames(), i, len;
            sheetName = sheetName && sheetName.replace(/^'|'$/g, '');
            if (sheetName)
                sheetName = sheetName.toLowerCase();
            for (i = 0, len = sheetNameCol.length; i < len; i++) {
                if (sheetNameCol[i].text.toLowerCase() === sheetName)
                    return (i + 1);
            }
            return false;
        },

        _removeSheet: function (index) {
            var sheetCount = this.model.sheetCount, shtDtCntr = this._dataContainer.sheets, i, sheets = this.model.sheets, args,
                j, cellRef, frmlaRefVal, frmlaVal, cellRefrs = [], regx, sIdx, rfr, delShtVal, nMngr, rfrTo, nMngrRefrs = [], calcObj, gridObj, calcDpdntCells;
            if (sheetCount > 1) {
                delShtVal = sheets[index].sheetInfo.value;
                this._getAutoFillOptElem().appendTo(this.element);
                this.element.find("#" + this._id + "_" + delShtVal).remove();
                if (sheetCount === this.getActiveSheetIndex()) {
                    for (i = 1; i < sheetCount; i++) {
                        if (sheets[index - i].sheetInfo.isVisible) {
                            this.setActiveSheetIndex(index - i);
                            break;
                        }
                    }
                }
                else
                    this.setActiveSheetIndex(index);
                this._swapSheetDtCntr(index, sheetCount);
                sheetCount in shtDtCntr && delete shtDtCntr[sheetCount];
                this._sheets.splice(sheetCount, 1);
                sheets.splice(sheetCount, 1);
                sheetCount = --this.model.sheetCount;
                this.getPager().ejPager("option", { totalRecordsCount: sheetCount, pageCount: this._getPageCount() });
                this.gotoPage(this.getActiveSheetIndex(), false);
                this._getAutoFillOptElem().appendTo(this._getJSSheetContent(this.getActiveSheetIndex()).find(".e-spreadsheetcontentcontainer > .e-content"));
                //Rebind sheet scroller event after delete sheets(index changed)
                this._rebindScrollEvnt();

                //Refresh NM coll
                nMngr = this.model.nameManager;
                for (i in nMngr) {
                    rfrTo = nMngr[i].refersto;
                    if (rfrTo.indexOf(delShtVal) > -1) {
                        nMngrRefrs.push(nMngr[i].name);
                        nMngr[i].refersto = "#REF!";
                    }
                }

                calcObj = this._calcEngine;
                calcDpdntCells = calcObj.getDependentCells().items;
                for (i in calcDpdntCells)
                    if (calcDpdntCells.hasOwnProperty(i))
                        cellRefrs.push(i);
                for (i = 0; i < cellRefrs.length; i++) {
                    cellRef = calcDpdntCells[cellRefrs[i]];
                    for (j = 0; j < cellRef.length; j++) {
                        frmlaRefVal = calcObj.getFormulaInfoTable().items[cellRef[j]];
                        sIdx = this._getSheetIdxFromSheetValue(this._getLocStr("Sheet") + (parseInt(cellRef[j].split("!")[1]) + 1));
                        if (frmlaRefVal && sIdx > -1) {
                            frmlaVal = frmlaRefVal.getFormulaText();
                            regx = new RegExp(delShtVal + '(?=[\'!])(?=[^"]*(?:"[^"]*"[^"]*)*$)', 'gi');
                            if (frmlaVal.match(regx)) {
                                frmlaVal = frmlaVal.replace(regx, "#REF");
                                this.XLEdit._updateDataContainer({ rowIndex: calcObj.rowIndex(cellRef[j]) - 1, colIndex: calcObj.colIndex(cellRef[j]) - 1 }, { dataObj: { value: frmlaVal }, sheetIdx: sIdx });
                                calcObj.refresh(frmlaRefVal.getParsedFormula());
                            }

                            for (rfr in nMngrRefrs)
                                if (frmlaVal.indexOf(nMngrRefrs[rfr]) > -1)
                                    calcObj.refresh(frmlaRefVal.getParsedFormula());
                        }
                    }
                }
                if (this.model.showRibbon) {
                    gridObj = $("#" + this._id + "_nmgrid").data("ejGrid");
                    if (gridObj) {
                        gridObj.refreshContent();
                        $("#" + this._id + "_nmrange").val("");
                    }
                }
                args = { sheetIndex: index, reqType: "remove-sheet" };
                this.clearUndoRedo();
                if (this._trigActionComplete(args))
                    return;
            }
        },

        _rebindScrollEvnt: function () {
            for (var i = 1; i <= this.model.sheetCount; i++) {
                if (this.getSheet(i)._isLoaded) {
                    this._getJSSheetContent(i).find(".e-spreadsheetcontentcontainer > .e-content").off("scroll");
                    this.element.find("#" + this._id + "_" + this.model.sheets[i].sheetInfo.value).find(".e-headercontent").off("scroll");
                    this._refreshScrollerEvent(i);
                }
            }
        },

        _getSheetNames: function (visible) {
            var i, len, sheetNames = [], sheets = this.model.sheets;
            for (i = 1, len = sheets.length; i < len; i++) {
                if (!this.isUndefined(visible) && ((visible && !sheets[i].sheetInfo.isVisible) || (!visible && sheets[i].sheetInfo.isVisible)))
                    continue;
                sheetNames.push(sheets[i].sheetInfo);
            }
            return sheetNames;
        },

        _initMoveCopyDlg: function () {
            var dlgId = this._id + "_moveCopyDlg", $dlg, $content, $okBtn, $cancelBtn, $btndiv, $listUl, $chkbox, $listCtn, $btnctnr;
            $dlg = ej.buildTag("div#" + dlgId, "", { display: "none" });
            $content = ej.buildTag("div#" + dlgId + "_sheetContent.e-dlgctndiv e-dlg-fields", ej.buildTag("label.e-dlg-fields", this._getLocStr("Beforesheet")));
            $listCtn = ej.buildTag("div.e-dlg-fields"), $listUl = ej.buildTag("ul#" + dlgId + "_list");
            $content.append($listCtn.append($listUl));
            $chkbox = ej.buildTag("input#" + dlgId + "_createcopy");
            $content.append($chkbox);
            $chkbox.ejCheckBox({ cssClass: "e-dlg-fields" });
            $chkbox.parent().append(ej.buildTag("label", this._getLocStr("CreateaCopy"), { "margin-left": 6 }));
            $dlg.append($content);
            $btndiv = ej.buildTag("div#" + dlgId + "_btndiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + dlgId + "_okbtn", "");
            $cancelBtn = ej.buildTag("input#" + dlgId + "_cnlbtn");
            $okBtn.ejButton({ text: this._getLocStr("Ok"), showRoundedCorner: true, click: ej.proxy(this._moveCopyBtnClick, this, "ok") , cssClass: "e-ss-okbtn", width: 60});
            $cancelBtn.ejButton({ text: this._getLocStr("Cancel"), click: ej.proxy(this._moveCopyBtnClick, this, "cancel"), showRoundedCorner: true, width: 60 });
            $btndiv.append($btnctnr.append($okBtn, $cancelBtn));
            $dlg.append($btndiv);
            this.element.append($dlg);
            $dlg.ejDialog({ showOnInit: false, enableModal: true, enableResize: false, allowKeyboardNavigation: false, title: this._getLocStr("MoveorCopy"), width: "auto", height: "auto", cssClass: "e-ss-dialog e-" + this._id + "-dlg e-ss-movedlg" });
            $listUl.ejListBox({
                dataSource: this._getSheetNames(),
                height: "197px",
                width: "250px",
                fields: { text: "text", value: "value" }
            });
        },

        _renderMoveCopyDlg: function () {
            var $dlg = $("#" + this._id + "_moveCopyDlg"), lbObj = $("#" + this._id + "_moveCopyDlg_list").data("ejListBox"), lbDataSrc = this._getSheetNames();
            lbDataSrc.push({ text: this._getLocStr('MoveToEnd'), value: this._getLocStr('MoveToEnd') });
            $dlg.ejDialog("open");
            lbObj.model.dataSource = lbDataSrc;
            lbObj.option("fields", { dataSource: lbDataSrc });
            lbObj.unSelectAll();
            lbObj.selectItemByIndex(0);
        },

        _initUnhideDlg: function () {
            var dlgId = this._id + "_UnhideDlg", $dlg, $content, $okBtn, $cancelBtn, $btndiv, $listUl, $btnctnr;
            $dlg = ej.buildTag("div#" + dlgId, "", { display: "none" });
            $content = ej.buildTag("div#" + dlgId + "_sheetContent.e-dlgctndiv e-dlg-fields", ej.buildTag("label.e-dlg-fields", this._getLocStr("UnhideDlgText")));
            $listUl = ej.buildTag("ul#" + dlgId + "_list");
            $content.append($listUl);
            $dlg.append($content);
            $btndiv = ej.buildTag("div#" + dlgId + "_btndiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + dlgId + "_okbtn");
            $cancelBtn = ej.buildTag("input#" + dlgId + "_cnlbtn");
            $okBtn.ejButton({ text: this._getLocStr("Ok"), showRoundedCorner: true, width: "25%", click: ej.proxy(this._unhideBtnClick, this, "ok"), cssClass: "e-ss-okbtn" });
            $cancelBtn.ejButton({ text: this._getLocStr("Cancel"), click: ej.proxy(this._unhideBtnClick, this, "cancel"), showRoundedCorner: true, width: "25%" });
            $btndiv.append($btnctnr.append($okBtn, $cancelBtn));
            $dlg.append($btndiv);
            this.element.append($dlg);
            $dlg.ejDialog({ showOnInit: false, enableModal: true, enableResize: false, allowKeyboardNavigation: false, title: this._getLocStr("UnhideSheet"), width: 280, height: "auto", cssClass: "e-ss-dialog e-" + this._id + "-dlg" });
            $listUl.ejListBox({
                dataSource: this._getSheetNames(),
                height: "197px",
                width: "250px",
                fields: { text: "text", value: "value" }
            });
        },

        _renderUnhideDlg: function () {
            var dlg = $("#" + this._id + "_UnhideDlg"), lbObj = $("#" + this._id + "_UnhideDlg_list").data("ejListBox"), lbDataSrc = this._getSheetNames(false);
            if (lbDataSrc.length > 0) {
                dlg.ejDialog("open");
                lbObj.model.dataSource = lbDataSrc;
                lbObj.option("fields", { dataSource: lbDataSrc });
                lbObj.unselectAll();
                lbObj.selectItemByIndex(0);
            }
        },

        _moveCopyBtnClick: function (action, e) {
            switch (action) {
                case "ok":
                    var args, spliceIndex, i, len, cpySheetName, isValid = false, sheetNameCount = 2, index, selectedItem = $(this.element).find(".e-currentitem"), lbObj = $("#" + this._id + "_moveCopyDlg_list").data("ejListBox"), checkObj = $("#" + this._id + "_moveCopyDlg_createcopy").data("ejCheckBox"), sText = lbObj.getSelectedItems()[0].text, mainIndex = lbObj.getIndexByText(sText), modelSheet = this.model.sheets;

                    //Check is same sheet
                    if (!checkObj.isChecked() && (sText === selectedItem.text())) {
                        $("#" + this._id + "_moveCopyDlg").ejDialog("close");
                        this.setSheetFocus();
                        return;
                    }

                    //Getting splice index and sheet position index
                    for (i = 1; i < modelSheet.length; i++) {
                        (sText === modelSheet[i].sheetInfo.text) && (spliceIndex = i);
                        (selectedItem.text() === modelSheet[i].sheetInfo.text) && (index = i);
                    }

                    args = { reqType: "moveSheet", toSheetIndex: mainIndex, fromSheetIndex: index, isCopy: checkObj.isChecked() };
                    if (this._trigActionBegin(args)) {
                        $("#" + this._id + "_moveCopyDlg").ejDialog("close");
                        return false;
                    }
                    mainIndex = args.toSheetIndex;
                    index = args.fromSheetIndex;

                    //Check is Copy sheet
                    if (checkObj.isChecked()) {
                        // Getting unique sheet name
                        if (selectedItem.text().match('.*[ ]+[(]+[0-9]+[)]$') === null) {
                            cpySheetName = selectedItem.text() + " (" + sheetNameCount + ")";
                        }
                        else {
                            if (selectedItem.text().lastIndexOf(' ') !== -1) {
                                sheetNameCount = parseInt(selectedItem.text().substring(selectedItem.text().lastIndexOf("(") + 1, selectedItem.text().lastIndexOf(")")));
                                cpySheetName = selectedItem.text().substring(0, selectedItem.text().lastIndexOf(" ")) + " (" + sheetNameCount + ")";
                            }
                        }
                        while (!isValid) {
                            cpySheetName = cpySheetName.substring(0, cpySheetName.lastIndexOf(" ")) + " (" + sheetNameCount + ")";
                            for (i = 1, len = modelSheet.length; i < len; i++) {
                                (cpySheetName === modelSheet[i].sheetInfo.text) && sheetNameCount++;
                            }
                            (sheetNameCount === parseInt(cpySheetName.substring(cpySheetName.lastIndexOf("(") + 1, cpySheetName.lastIndexOf(")")))) && (isValid = true);
                        }

                        //Copy Sheet Process      
                        this._copySheetProcess(index, cpySheetName);

                        index = this.model.sheetCount;
                        ej.isNullOrUndefined(spliceIndex) && (spliceIndex = index);
                    }
                    else {
                        !ej.isNullOrUndefined(spliceIndex) && spliceIndex > index && (spliceIndex = spliceIndex - 1);
                    }

                    ej.isNullOrUndefined(spliceIndex) && (spliceIndex = mainIndex);

                    //Sheets[] updates
                    if (!checkObj.isChecked() && spliceIndex === index) {
                        $("#" + this._id + "_moveCopyDlg").ejDialog("close");
                        this.setSheetFocus();
                        break;
                    }

                    //Update DataContainer positions
                    this._swapSheetDtCntr(index, spliceIndex);

                    $("#" + this._id + "_moveCopyDlg").ejDialog("close");

                    spliceIndex <= index && (mainIndex = mainIndex + 1);
                    this.getPager().ejPager("option", { currentPage: mainIndex });
                    this.gotoPage(mainIndex, false);
                    this._rebindScrollEvnt();
                    args = { reqType: "moveSheet", toSheetIndex: mainIndex, fromSheetIndex: index, isCopy: checkObj.isChecked() };
                    this._trigActionComplete(args);

                    //uncheck copy sheet checkbox
                    checkObj._unChecked();
                    checkObj._isChecked = false;

                    this.setSheetFocus();
                    break;
                case "cancel":
                    $("#" + this._id + "_moveCopyDlg").ejDialog("close");
                    break;
            }
        },

        _unhideBtnClick: function (action, e) {
            if (action === "ok") {
                var lbObj = $("#" + this._id + "_UnhideDlg_list").data("ejListBox");
                this.unhideSheet(lbObj.getSelectedItems()[0].text);
            }
            $("#" + this._id + "_UnhideDlg").ejDialog("close");

        },

        _swapSheetDtCntr: function (index, spliceIdx) {
            var sheetDtMngr = this._dataContainer.sheets, modelSheet = this.model.sheets, dtSheets = this._sheets, shtValue = this._getLocStr("Sheet"), backupDtCntr = [{}], newIdx,
                bckupModel = this._getSheetNames();
            for (var ind in sheetDtMngr) {
                if (sheetDtMngr.hasOwnProperty(ind))
                    backupDtCntr[parseInt(modelSheet[ind].sheetInfo.value.replace(shtValue, ""))] = sheetDtMngr[ind];
            }
            modelSheet.splice(spliceIdx, 0, modelSheet.splice(index, 1)[0]);
            dtSheets.splice(spliceIdx, 0, dtSheets.splice(index, 1)[0]);
            for (var indx = 1, len = modelSheet.length; indx < len; indx++) {
                newIdx = parseInt(modelSheet[indx].sheetInfo.value.replace(shtValue, ""));
                this._dataContainer.sheets[indx] = backupDtCntr[newIdx];
            }
            this.clearUndoRedo();
        },

        _copySheetProcess: function (index, cpySheetName) {
            var cellIdx, csheet, i, len, newSheetIdx, sheetvalue, shapeMngr, shapeDtl, pager = this.getPager(), newPage = pager.ejPager("option", "totalRecordsCount") + 1, modelSheet = this.model.sheets;
            this._impData && this.XLExport._renderAll();
            pager.ejPager("option", { totalRecordsCount: newPage, currentPage: newPage });
            //Sheet settings Copy
            modelSheet.push(jQuery.extend(true, {}, modelSheet[index]));
            this._sheetCopy = { isSheetCopy: true, sheetContent: this._getContent(index).find(".e-table").clone(true).get(0) };

            newSheetIdx = this.model.sheetCount + 1;
            modelSheet[newSheetIdx].sheetInfo.text = cpySheetName;
            sheetvalue = modelSheet[newSheetIdx].sheetInfo.value = this._getLocStr("Sheet") + this._newSIndex;
            this._newSIndex++;
            this.setActiveSheetIndex(newSheetIdx);

            //Copy Data Container
            this._dataContainer.sheets[newSheetIdx] = $.extend(true, {}, this._dataContainer.sheets[index]);
            csheet = this._sheets[newSheetIdx] = { _contentColGroup: null, _content: null, _sheetRowHeaderContent: null, _sheetHeader: null, _sheetRowHeader: null, _sheetContent: null, _Rows: null };

            this._initSheet(newSheetIdx);
            this.model.sheetCount++;

            this._sheetCopy = { isSheetCopy: false, sheetContent: null };


            //To register in calc engine
            this._calcEngine.registerGridAsSheet(sheetvalue, sheetvalue, this._calcID);

            //To update picture
            shapeMngr = modelSheet[newSheetIdx].shapeMngr.picture;
            len = this.getObjectLength(shapeMngr);
            for (i = 1; i <= len; i++) {
                shapeDtl = shapeMngr[this._id + "_picture" + i];
                this.XLShape._createPicture(newSheetIdx, { rowIndex: shapeDtl.rowIndex, colIndex: shapeDtl.colIndex }, this.getSheet(newSheetIdx).shapeMngr.sharedPics[shapeDtl.data], shapeDtl.top, shapeDtl.left, shapeDtl.width, shapeDtl.height, null, shapeDtl.bcolor, shapeDtl.bstyle, shapeDtl.bwidth);
            }

            //Comments update
            if (!this.model.scrollSettings.allowVirtualScrolling) {
                var commentCells = this._getContent(newSheetIdx).find(".e-commentcell"), elem, i, len;
                for (i = 0, len = commentCells.length; i < len; i++) {
                    elem = $(commentCells[i]);
                    cellIdx = this._getCellIdx($(".e-commentcell")[0]);
                    elem.removeClass("e-commentcell") && this.XLComment.setComment([cellIdx.rowIndex, cellIdx.colIndex, cellIdx.rowIndex, cellIdx.colIndex], null, false);
                }
            }
            if (this.model.allowComments)
                this.XLComment._updateCmntArrowPos();
        },

        showActivationPanel: function (rangeName) {
            var rangeInfo, sheetIdx = this.getActiveSheetIndex(), actpanel = this.getActivationPanel(), settings = this.model.scrollSettings;
            if (!this.model.enablePivotTable || this._phoneMode)
                return false;
            if (this.isUndefined(rangeName)) {
                if (this._getContent(sheetIdx).find(".e-ss-activepivot").length && this.XLPivot._displayActPanel) {
                    this.model._isActPanelVisible = true;
                    this._setSheetWidthHeight(sheetIdx, { width: this._responsiveWidth, height: this._responsiveHeight, isActPanel: true }, null, "refresh");
                    this._refreshActivationPanel();
                }
            }
            else {
                rangeInfo = this.getSheet(sheetIdx).rangeSettings[rangeName];
                if (rangeInfo.showPanel) {
                    if (this._trigger("beforePanelOpen", { activationPanel: actpanel, range: rangeInfo, sheetIndex: sheetIdx }))
                        return;
                    this.model._isActPanelVisible = true;
                    this._setSheetWidthHeight(sheetIdx, { width: this._responsiveWidth, height: this._responsiveHeight, isActPanel: true }, null, "refresh");
                    this._refreshActivationPanel();
                }
            }
        },

        _refreshActivationPanel: function () {
            var actpanel = this.getActivationPanel(), height = this.getMainPanel().height(), scrObj = actpanel.data("ejScroller"), desObj;
            actpanel.width(this.model.activationPanelWidth - 1).height(height);
            actpanel.find(".e-ss-pivotfield").hide();
            actpanel.find("#" + this._id + "_PivotTableSchema_" + this._getContent(this.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id).show();
            actpanel.find(".e-ss-pivotfield").width(this.model.activationPanelWidth - 20); //20 for scrollbar width
            actpanel.show();
            desObj = this.getActivationPanel().find("#" + this._id + "_PivotTableSchema_" + this._getContent(this.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id).data("ejPivotSchemaDesigner");
            desObj._reSizeHandler();
            if (scrObj) {
                scrObj.option({ width: this.model.activationPanelWidth - 1, height: height });
                scrObj.refresh();
            }
        },

        hideActivationPanel: function () {
            var actpanel = this.getActivationPanel(), settings = this.model.scrollSettings;
            if (actpanel.is(":visible")) {
                actpanel.find(".e-ss-pivotfield").hide();
                this.model._isActPanelVisible = false;
                actpanel.hide();
                if (!this._isNew)
                    this._setSheetWidthHeight(this.getActiveSheetIndex(), { width: this._responsiveWidth, height: this._responsiveHeight }, null, "refresh");
            }
        },

        _addSheet: function (index) {
            this._sheetSettings(index);
            this._dataContainer.sheets[index] = {};
            this._initSheet(index);
            this._newSIndex++;
            this.model.sheetCount++;
        },

        addNewSheet: function () {
            if (!this.model.allowInsert || this.model.isReadOnly)
                return;
            this.element.find(".e-pager .e-new").click();
        },

        _createFocusElement: function () {
            this.setFocusTopElem($("<div class='e-focustop e-hide' ></div>"));
            this.setFocusRightElem($("<div class='e-focusright e-hide' ></div>"));
            this.setFocusBottomElem($("<div class='e-focusbottom e-hide' ></div>"));
            this.setFocusLeftElem($("<div class='e-focusleft e-hide' ></div>"));
        },

        _createAutoFillElement: function () {
            var html, sheetCont = this._getJSSheetContent(this.getActiveSheetIndex()).find(".e-spreadsheetcontentcontainer > .e-content");
            if (this.model.allowAutoFill) {
                html = $("<div class='e-autofill e-hide'></div>");
                sheetCont.append(html);
                this.setAutoFillElem(html);
            }
            this.element.append(ej.buildTag("ul.e-spreadsheet", "", { "width": "auto" }, { id: this._id + "_ctxtmenu" }));
            html = $("<div class='e-splitspan e-hide' title=" + this._getLocStr("AutoFillTitle") + "><button id=" + this._id + "_dragfilloptionbtn type='button'></button></div>");
            sheetCont.append(html);
            this._setAutoFillOptElem(html);
            this._initializeSplitButton();
        },

        _initializeSplitButton: function () {
            this._getAutoFillOptElem().find("button").ejSplitButton({
                size: "normal",
                contentType: "imageonly",
                targetID: this._id + "_ctxtmenu",
                prefixIcon: "e-icon e-ss-autofill",
                isSeparator: false,
                buttonMode: ej.ButtonMode.Dropdown,
                imagePosition: ej.ImagePosition.ImageLeft,
                arrowPosition: ej.ArrowPosition.Right,
                fields: { dataSource: this._fillOptionMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" },
                beforeOpen: $.proxy(this.model.allowAutoFill && this.XLDragFill._autoFillClick, this),
                itemSelected: $.proxy(this.model.allowAutoFill && this.XLDragFill._autoFillOptionClick, this),
                width: "42px",
                height: "24px",
                cssClass: "e-spreadsheet e-autofillbtn"
            });
        },

        // formula bar
        _renderFormulaBar: function (isSetModel) {
            var inputBox, formulabar = "<div id=" + this._id + "_formulabar class='e-formulabar' ><div id=" + this._id + "_indexbox class='e-indexbox' title='" + this._getLocStr("NameBox") + "'></div><div class='e-inputbox' ><input id=" + this._id + "_inputbox type='text' title='" + this._getLocStr("FormulaBar") + "'/></div></div>", frmlaBarHt;
            if (isSetModel)
                this.model.showRibbon ? $("#" + this._id + "_Ribbon").after(formulabar) : this.element.prepend(formulabar);
            else
                this.element.append(formulabar);
            this._setIndexBox($("#" + this._id + "_indexbox"));
            inputBox = $("#" + this._id + "_inputbox");
            this._setInputBox(inputBox);
            this.XLEdit._renderAutoComplete(inputBox, "", 26);
            this._alignFormulaBar();
            frmlaBarHt = this.element.find(".e-formulabar").height();
            if (frmlaBarHt > 36)
                this._formulaHeight = frmlaBarHt;
            if (this.model.isReadOnly)
                this.element.find('.e-formulabar')[0].disabled = true;
        },

        _alignFormulaBar: function (width) {
            var orgSettings = this.model.scrollSettings;
            width = width || this._responsiveWidth;
            this.element.find('.e-formulabar').width(orgSettings.isResponsive ? width - 2 : width);
            width = parseInt(width);
            var idxWt, iptWt, inputBox;
            idxWt = width / 10;
            iptWt = width - (idxWt + 24); // 24 is for border and padding for the index box and input box
            inputBox = this.element.find(".e-inputbox");
            inputBox.hide();
            inputBox.width(Math.floor(iptWt));
            this.element.find(".e-indexbox").width(Math.floor(idxWt));
            inputBox.show();
        },

        hideFormulaBar: function () {
            $("#" + this._id + "_formulabar").hide();
        },

        showFormulaBar: function () {
            if (this.model.allowFormulaBar) {
                $("#" + this._id + "_formulabar").show();
                this.updateFormulaBar();
            }
        },

        _getlocaleNumVal: function (value, isCulValue) {
            value = (typeof value !== "object" && Number(value)) ? Number(value) : ((!ej.isNullOrUndefined(value) && typeof value !== "object") ? ej.parseFloat(value + "", this.model.locale) : null);
            if (value && isCulValue) {
                var culNumFmt = ej.preferredCulture(this.model.locale).numberFormat, temp = value.toString();
                if (culNumFmt["."] != "." && temp.indexOf(culNumFmt["."]) < 0)
                    value = temp.replace(".", culNumFmt["."]);
            }
            return value;
        },

        updateFormulaBar: function () {
            if (this.model.isReadOnly)
                return;
            var val, cellData, text, sheetIdx = this.getActiveSheetIndex(), activecell = this.getSheet(sheetIdx)._activeCell,
                trgt = this._getContent(sheetIdx).find(".e-ss-activeimg")[0];
            cellData = this.getRangeData({ range: [activecell.rowIndex, activecell.colIndex, activecell.rowIndex, activecell.colIndex], property: ["value", "value2", "isLocked"] })[0];
            if (!ej.isNullOrUndefined(cellData))
                val = ej.isNullOrUndefined(cellData.value) ? "" : cellData.value;
            else
                val = "";
            if (this._isDateTime(val))
                val = cellData.value2;
            if (this.isNumber(val))
                val = this._getlocaleNumVal(val, true);
            this._getInputBox().val(val);
            if (this.XLEdit.getPropertyValue(activecell.rowIndex, activecell.colIndex, "isReadOnly") || (this.model.allowLockCell && this.getSheet(sheetIdx).isSheetProtected && cellData.isLocked))
                this._getInputBox().attr("readonly", "readonly");
            else
                this._getInputBox().prop("readonly", false);
            if (trgt && (trgt.id.indexOf(this._id + "_picture") > -1 || trgt.id.indexOf(this._id + "_chart") > -1))
                text = trgt.id.replace($(trgt).data("parentID") + "_", "");
            else
                text = this._generateHeaderText(activecell.colIndex + 1) + (activecell.rowIndex + 1);
            this._getIndexBox().html(text);
        },

        _initSelection: function () {
            var range, model = this.model, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx),
                scont = this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"), type = model.selectionSettings.selectionType,
                types = ej.Spreadsheet.SelectionType, actCell = model.selectionSettings.activeCell;
            if (model.allowSelection) {
                if (!this.getFocusTopElem())
                    this._createFocusElement();
                scont.append(this.getFocusTopElem(), this.getFocusRightElem(), this.getFocusBottomElem(), this.getFocusLeftElem());
                if (actCell) {
                    range = this.getRangeIndices(actCell);
                    if (!this.isRange(range) && (range[0] < sheet.rowCount && range[1] < sheet.colCount))
                        sheet._startCell = sheet._endCell = sheet._activeCell = { rowIndex: range[0], colIndex: range[1] };
                }
                if ((!sheet._isImported || sheet._isLoaded) && sheet._selectedCells.length) {
                    this.XLSelection.selectRange(sheet._selectedCells[0], sheet._selectedCells[sheet._selectedCells.length - 1]);
                    this.XLSelection._refreshBorder();
                }
                else {
                    this.XLSelection._processBoundary();
                    if (type === types.Row || sheet._isRowSelected)
                        this.XLSelection.selectRows(sheet._startCell.rowIndex, sheet._endCell.rowIndex);
                    else if (type === types.Column || sheet._isColSelected)
                        this.XLSelection.selectColumns(sheet._startCell.colIndex, sheet._endCell.colIndex);
                    else
                        this.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                }
            }
            if (model.allowAutoFill) {
                if (!this.getAutoFillElem())
                    this._createAutoFillElement();
                this.getAutoFillElem().appendTo(scont);
                this.XLDragFill.positionAutoFillElement();
                if (model.autoFillSettings.showFillOptions && model.allowAutoFill) {
                    this._getAutoFillOptElem().appendTo(scont);
                    this.XLDragFill.hideAutoFillOptions();
                }
            }
            if (model.allowSelection && sheet._isFreezed)
                this.XLFreeze._refreshSelection();
        },

        _updateRibbonTab: function (cellIdx) {
            var actShape, tname, sheetIdx = this.getActiveSheetIndex(), robj = $("#" + this._id + "_Ribbon").data("ejRibbon"), xlRibbon = this.XLRibbon,
                ctabs = this.element.find(".e-ribbon .e-contextual a:visible"), len = ctabs.length,
                ribTabPinEle = robj.element.find("#" + this._id + "_Ribbon_togglebutton");
            if (cellIdx)
                tname = this.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "tableName", sheetIdx);
            if (len) {
                while (len--)
                    robj.hideTab(ctabs[len].text);
            }
            xlRibbon._toggleAnalyzeTab();
            if (ribTabPinEle.is(":visible") && ribTabPinEle.hasClass("e-ribbonpin"))
                this._refreshSheetonResize();
            actShape = this._getContent(sheetIdx).find(".e-ss-activeimg");
            if (actShape.length)
                actShape[0].id.indexOf("chart") > -1 ? this.XLRibbon._chartDesignTabUpdate(actShape) : this.XLRibbon._formatTabUpdate();
            else if (tname)
                xlRibbon._designTabUpdate(this._getTableID(tname), cellIdx);
            else if (this._getContent(sheetIdx).find(".e-ss-activepivot").length) {
                xlRibbon._analyzeTabUpdate();
                this.XLSelection._cleanUp(true);
                this.getActivationPanel().find("#" + this._id + "_PivotTableSchema_" + this._getContent(sheetIdx).find(".e-ss-activepivot")[0].id).show();
                this.showActivationPanel();
            }
        },

        _updateCellType: function () {
            var i, ctype = ej.Spreadsheet.CellType;
            for (i in ctype)
                this._dataContainer.cellType.push(ctype[i]);
        },

        _updateFormulaCollection: function () {
            var i, libraryFunc = this._calcEngine.getLibraryFunctions(), arr = [];
            for (i in libraryFunc.items)
                arr.push({ text: "=" + i, display: i });
            this._formulaCollection = arr;
        },

        _renderScroller: function (sheetIdx, settings, action) {
            this.XLScroll._createScroller(sheetIdx, settings, action);
            this._refreshScrollerEvent(sheetIdx);
        },

        _refreshScrollerEvent: function (sheetIdx) {
            this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").scroll(ej.proxy(function (e) {
                var sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), scrollLeft = this._isFrozen(this.getFrozenColumns(sheetIdx)) ? $(e.target).scrollLeft() : sheet._scrollLeft;
                this._getJSSheetHeader(sheetIdx).find(".e-headercontent").scrollLeft(scrollLeft);
                this._getJSSheetRowHeaderContent(sheetIdx).scrollTop($(e.currentTarget).scrollTop());
            }, this));

            this.element.find("#" + this._id + "_" + this.model.sheets[sheetIdx].sheetInfo.value).find(".e-headercontent").scroll(ej.proxy(function (e) {
                var sheetIdx = this.getActiveSheetIndex(), scrollLeft = this._isFrozen(this.getFrozenColumns(sheetIdx)) ? $(e.target).scrollLeft() : this.getSheet(sheetIdx)._scrollLeft;
                this._getContent(sheetIdx).find(".e-content").scrollLeft(scrollLeft);
                this.getSheet(sheetIdx)._scrollLeft = this._getContent(sheetIdx).find(".e-content").scrollLeft();
            }, this));
        },

        _clickHandler: function (e) {
            this.XLEdit._isFEdit = false;
            if (this._hasClass(e.target, "e-ssfilter")) {
                if (this._excelFilter._openedFltr && $(this._excelFilter._openedFltr).is(":visible"))
                    this._excelFilter.closeXFDialog();
                else
                    this.XLFilter._filterClickHandler(e);
            }
            else {
                if (this._isExport || !this.model.cellClick)
                    return false;
                var args, target = e.target, sheetIdx = this.getActiveSheetIndex(), colIndex, rowIndex, column;
                if (e.target.tagName === "TD" && $(e.target).parents("div")[0].className.indexOf("e-content") > -1 && e.target.className.indexOf('e-rowcell') > -1 && $(e.target).find('.e-chk-image').length < 1) {
                    colIndex = target.cellIndex, rowIndex = $.inArray($(target).closest("tr").get(0), this.getRows(sheetIdx)[1]);
                    column = this.getSheet(sheetIdx).columns[colIndex];
                    args = {
                        columnName: column.field, value: this.XLEdit.getPropertyValue(rowIndex, colIndex), columnIndex: colIndex, rowIndex: rowIndex, columnObject: column, cell: target, eventArgs: e, event: e,
                        target: e.target
                    };
                    if (this._trigger("cellClick", args))
                        return;
                }
                else if (!ej.isNullOrUndefined($(e.target).parents("div")) && $(e.target).parents("div")[0].className.indexOf("e-content") > -1 && e.target.className.indexOf('e-rowcell') > -1 && $(e.target).find('.e-chk-image').length < 1) {
                    target = $(e.target).parents("td").get(0);
                    if (!ej.isNullOrUndefined(target)) {
                        colIndex = target.cellIndex, rowIndex = $.inArray($(target).closest("tr").get(0), this.getRows(sheetIdx)[1]);
                        column = this.getSheet(sheetIdx).columns[colIndex];
                        args = {
                            columnName: column.field, value: this.XLEdit.getPropertyValue(rowIndex, colIndex), columnIndex: colIndex, rowIndex: rowIndex, columnObject: column, cell: target, eventArgs: e, event: e,
                            target: e.target
                        };
                        if (this._trigger("cellClick", args))
                            return;
                    }
                }
            }
        },

        _wireEvents: function (action) {
            var elem = this.element, id = this._id;
            if (this.model.enableTouch && parseInt(this._browserDetails.version) > 8)
                this._wireTouchEvts("_on");
            else
                this._wireTouchEvts("_off");
            this[action](elem, "mousedown", ".e-spreadsheetcontentcontainer .e-content, .e-spreadsheetrowheader, .e-spreadsheetheader, .e-spreadsheetactpanel, .e-ribbon, .e-spreadsheetcontentcontainer .e-vscroll, .e-spreadsheetcontentcontainer .e-hscroll", this._mouseDownHandler);
            this[action](elem, "mousemove", this._mouseMoveHandler);
            this[action](elem, "mouseup", this._mouseUpHandler);
            this[action](elem, "keydown", this._keyDownHandler);
            this[action](elem, "keyup", this._keyUpHandler);
            this[action](elem, "click", ".e-spreadsheetcontentcontainer .e-content,.e-spreadsheetrowheader,.e-spreadsheetheader,.e-spreadsheetactpanel, .e-ss-object", this._clickHandler);
            this[action](elem, ($.isFunction($.fn.doubletap) && (this.model.enableTouch && (parseInt(this._browserDetails.version) > 8)) && !this._browserDetails.isMSPointerEnabled) ? "doubletap" : "dblclick", ".e-spreadsheetcontentcontainer, .e-spreadsheetheader, .e-spreadsheetrowheader, .e-numericcontainer .e-numericitem", this._dblClickHandler);
            this[action](elem, "mouseleave", ".e-spreadsheetrowheader, .e-spreadsheetheader, .e-viewhdrlbl, .e-vheading, .e-viewlinlbl, .e-vgridlines", this._mouseLeaveHandler);
            this[action](elem, "mouseover", ".e-spreadsheetcontentcontainer .e-content .e-rowcell, .e-viewhdrlbl, .e-vheading, .e-viewlinlbl, .e-vgridlines, .e-rowheadercontent, .e-vscrollbar, .e-hscrollbar, .e-spreadsheetfooter, .e-spreadsheetheader", this._mouseHoverHandler);
            if (this.model.allowFormulaBar)
                this[action](this._getInputBox(), "input", this.XLEdit._formulaBoxInputChange);
            this[action]($(".e-" + id + ".e-chartcell"), "click", this._chartClickHandler);
            this[action]($('#' + id + '_cellstyles'), "click", this._cellStyleClick);
            this[action]($('#' + id + '_formatastable'), "click", this._formatAsTableClick);
            this[action]($('#' + id + '_nmuseinformula'), "click", ".e-nmuseinformularow", this._useInFormulaClick);
            if (this.model.scrollSettings.allowScrolling)
                this[action](this.element.find(".e-spreadsheet-list"), 'mousewheel DOMMouseScroll', $.proxy(this.XLScroll._spreadMouseWheel, this.XLScroll));
            if (this.model.scrollSettings.isResponsive)
                this[action]($(window), "resize", $.proxy(this._resizeHandler, this));
        },

        _wireTouchEvts: function (action) {
            if (this._browserDetails.name != "msie" || ["11.0", "10.0"].indexOf(this._browserDetails.version) === -1)
                this[action](this.element, this._getBrowserEvt(), ".e-spreadsheetcontentcontainer .e-content, .e-spreadsheetrowheader, .e-spreadsheetheader, .e-spreadsheetactpanel, .e-ribbon, .e-spreadsheetcontentcontainer .e-vscroll, .e-spreadsheetcontentcontainer .e-hscroll", this._mouseDownHandler);
            this[action](this.element, this._getBrowserEvt("move"), this._mouseMoveHandler);
            this[action](this.element, this._getBrowserEvt("end"), this._mouseUpHandler);
            this[action](this.element, "swipeleft swiperight", ".e-spreadsheetfooter", this._swipeHandler);
        },

        _getBrowserEvt: function (type, isMouse) {
            var evt;
            if (type === "move")
                evt = this._browserDetails.isMSPointerEnabled ? (this._browserDetails.pointerEnabled ? "pointermove" : "MSPointerMove") : (isMouse ? "mousemove" : "touchmove");
            else if (type === "end")
                evt = this._browserDetails.isMSPointerEnabled ? (this._browserDetails.pointerEnabled ? "pointerup" : "MSPointerUp") : (isMouse ? "mouseup" : "touchend");
            else
                evt = this._browserDetails.isMSPointerEnabled ? (this._browserDetails.pointerEnabled ? "pointerdown" : "MSPointerDown") : "touchstart";
            return evt;
        },

        _swipeHandler: function (e) {
            var sheetIdx = this.getActiveSheetIndex();
            this.gotoPage(e.type === "swiperight" ? --sheetIdx : ++sheetIdx);
        },

        _isTouchEvent: function (e) {
            if (this.model.enableTouch && (e.type.indexOf("touch") > -1 || e.type.indexOf("pointer") > -1) && e.originalEvent.pointerType !== "mouse" && e.originalEvent.pointerType !== 4)
                return true;
            return false;
        },

        _getOriginalEvt: function (e) {
            if (e.originalEvent.changedTouches)
                return e.originalEvent.changedTouches[0];
            return e.originalEvent;
        },

        _allChartType: function (e) {
            $("#" + this._id + "_allchart").find(".e-chartimg").removeClass("e-chartselect");
            $(e.target).addClass("e-chartselect");
        },

        refreshSpreadsheet: function () {
            if (this._responsiveHeight > 350) {
                this._refreshSheetonResize();
                if (this.model.showRibbon)
                    $("#" + this._id + "_Ribbon").data("ejRibbon")._ribbonResize();
            }
        },

        _resizeHandler: function () {
            var resizeTimer, proxy = this;
            if (proxy.element.is(":hidden"))
                return;
            if (resizeTimer) {
                clearTimeout(resizeTimer);
            }
            resizeTimer = setTimeout(function () {
                proxy._refreshSheetonResize();
                for (var i = 1, len = proxy.model.sheets.length; i < len; i++)
                    proxy.getSheet(i)._isResized = (i != proxy.getActiveSheetIndex());
            }, 100);
        },

        _refreshSheetonResize: function () {
            var contentrows, rowhdrrows, sheetIdx = this.getActiveSheetIndex(), settings, popupElem = $('.e-menu:visible[id^=' + this._id + '], .e-ddl-popup:visible[id^=' + this._id + ']'), elemId, sElem,
                popupIds = ["CFormat", "Validation", "PageSize", "FPane", "Ins", "Del", "FindRep"], pEleIds = ["Home_Styles_ConditionalFormatting", "Data_DataTools_DataValidationOptions", "PageLayout_PageLayout_PageSizeOptions", "Others_Window_FreezePanes", "Others_Cells_InsertCellOptions", "Others_Cells_DeleteCellOptions", "Others_Editing_FindSelect"],
                ePanel, sRnmVal, isPhoneMode = this._phoneMode;
            this._resizeColl[sheetIdx - 1] = this._isResized = true;
            this.element.find(".e-inputbox").hide();
            this.model.enablePivotTable && this.hideActivationPanel();
            this._phoneMode = this.model.scrollSettings.isResponsive && document.documentElement.clientWidth < 420;
            this._tabMode = this.model.scrollSettings.isResponsive && (document.documentElement.clientWidth > 419 && document.documentElement.clientWidth < 617);
            settings = { width: this._responsiveWidth, height: this._responsiveHeight };
            (this.model.showRibbon && (this._tabMode || this._responsiveHeight < 280)) && $("#" + this._id + "_Ribbon").ejRibbon("collapse");
            this._refreshSheetWithScreen(sheetIdx);
            this._updateResponsiveSettings();
            this._initViewPort(sheetIdx);
            this.refreshContent(sheetIdx);
            settings.width = this._responsiveWidth;
            settings.height = this._responsiveHeight;
            this._setSheetWidthHeight(sheetIdx, settings, null, "refresh");
            contentrows = this._getContTBody(sheetIdx).find("tr");
            rowhdrrows = this._getRowHdrTBody(sheetIdx).find("tr");
            this.setRows([rowhdrrows, contentrows], sheetIdx);
            this._dlgWidth = (this._phoneMode || this._tabMode || this._responsiveWidth < 350) ? this._responsiveWidth - 2 : this._responsiveWidth / 1.5;
            this._dlgHeight = (this._phoneMode || this._tabMode || this._responsiveHeight < 350) ? this._responsiveHeight - 2 : this._responsiveHeight / 1.2;
            if (this.model._isActPanelVisible)
                this._refreshActivationPanel();
            this.element.find(".e-inputbox").show();
            if (this.model.showPager) {
                if (this._isSheetRename) {
                    ePanel = this.getPager().find("#" + this._id + "_Sheet_RenamePanel");
                    sRnmVal = ePanel.val();
                    ePanel.remove();
                }
                this._refreshSpreadSheetPager(true);
                this._isSheetRename && this._renameSheet(sRnmVal);
            }
            if (this._phoneMode) {
                $("#" + this._id + "_CFormat").css("width", "");
                $("#" + this._id + "_Ribbon_Border").css("width", "");
                $('#' + this._id + '_indexbox').css({ 'text-overflow': 'ellipsis', 'overflow': 'hidden' });
            }
            if (this.model.showRibbon) {
                this.XLRibbon._refreshBackstageHeight();
                if (this._phoneMode && !isPhoneMode)
                    this.XLRibbon._hideRibbonElem();
            }
            //pop-up hide
            if (popupElem.length) {
                elemId = popupElem[0].id.split("_", 3);
                elemId.indexOf("Ribbon") === -1 && elemId.splice(1, 0, "Ribbon");
                elemId[2] = popupIds.indexOf(elemId[2]) > -1 ? pEleIds[popupIds.indexOf(elemId[2])] : elemId[2].toLowerCase();
                elemId = elemId.join("_");
                if (elemId.length) {
                    sElem = $("#" + elemId);
                    if (sElem.hasClass("e-splitbutton"))
                        sElem.ejSplitButton("hide");
                    if (sElem.hasClass("e-dropdownlist"))
                        sElem.ejDropDownList("hidePopup");
                }
            }
            this._isResized = false;
            if (this._isRibbonDestroyed) {
                var rbnObj = $("#" + this._id + "_Ribbon").ejRibbon("instance");
                if (this.model.ribbonSettings.enableOnDemand) {
                    tabText = rbnObj.getTabText(rbnObj.model.selectedItemIndex);
                    this.XLRibbon._createTabControls(tabText);
                }
                else {
                    var tabColl = [this._getLocStr("HOME"), this._getLocStr("DATATAB"), this._getLocStr("PAGELAYOUT"), this._getLocStr("OTHERS")];
                    for (var c = 0, cLen = tabColl.length; c < cLen; c++)
                        this.XLRibbon._updateRibCustomCss(tabColl[c]);
                }
                this._on($(".e-" + this._id + ".e-chartcell"), "click", this._chartClickHandler);
                this._on($('#' + this._id + '_cellstyles'), "click", this._cellStyleClick);
                this._on($('#' + this._id + '_formatastable'), "click", this._formatAsTableClick);
            }
            this._isRibbonDestroyed = false;
            this._trigger('refresh');
        },

        _chartClickHandler: function (e) {
            var trgt = $(e.target), prop = $.extend(true, {}, $(e.target).data());
            trgt.parents().eq(1).hide();
            this.XLChart.createChart(null, prop);
        },

        _useInFormulaClick: function (e) {  // defined names click
            var i, temp, formula, eql = "=", comma = ",", oBrkt = "(", isFrmla = false, txt = e.target.textContent, sheetIdx = this.getActiveSheetIndex(),
                actCell = this.getActiveCell(sheetIdx), editElem = this.XLEdit._editElem, text = editElem.text();
            this.XLEdit.editCell(actCell.rowIndex, actCell.colIndex, true);
            if (text === eql)
                editElem.text(eql + txt);
            else {
                formula = this.XLDragFill._parseFormula(text)
                i = formula.length;
                if (i) {
                    while (i--) {
                        if (formula[i] === comma || formula[i] === oBrkt) {
                            formula.splice(i + 1, 0, txt);
                            isFrmla = true;
                            break;
                        }
                        else if (this._isCellReference(formula[i]) || this.isNumber(formula[i])) {
                            formula[i] = txt;
                            isFrmla = true;
                            break;
                        }
                    }
                    txt = isFrmla ? formula.join("") : txt;
                }
                editElem.text(eql + txt);
            }
            editElem.focusEnd();
            $("#" + this._id + "_nmuseinformula").hide();
        },

        _formatAsTableClick: function (e) {
            var tname, fatName, target = e.target,
            sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), scells = sheet._selectedCells;
            if (scells.length === 0)
                return;
            if (target.parentNode.className === 'e-formatastablecell') {
                tname = this.XLEdit.getPropertyValue(scells[0].rowIndex, scells[0].colIndex, "tableName", sheetIdx);
                this._showDialog(this._id + "_Ribbon_Insert_Tables_Table");
                if (tname) {
                    this.XLFormat._formatAsTableStyle = this._FATStyles[target.parentNode.id.replace(/ /g, '')];
                    this.XLFormat._createTable(this._getTableID(tname), this.XLFormat._formatAsTableStyle);
                }
                else if (scells.length > 1) {
                    fatName = $("#" + this._id + '_fatname');
                    $('#' + this._id + '_fatnamedlg').ejDialog("open");
                    $("#" + this._id + "_fatheader").data("ejCheckBox").option("checked", false);
                    fatName.val('Table' + (this._tableCnt)).focus().setInputPos(fatName.val().length);
                    if (this.model.allowCellFormatting)
                        this.XLFormat._formatAsTableStyle = this._FATStyles[target.parentNode.id.replace(/ /g, '')];
                }
                else
                    this._showAlertDlg("Alert", "FormatAsTableAlert", null, 445);
            }
            if (target.className.indexOf("back") > -1 || target.parentNode.className === 'e-formatastablecell')
                $('#' + this._id + '_Ribbon_Home_Styles_FormatAsTable').length && $('#' + this._id + '_Ribbon_Home_Styles_FormatAsTable').data("ejSplitButton")._hidePopup();
        },

        _borderSelectionClick: function (e) {
            var args = { ID: e.target.parentNode.id }, alphRange, target = e.target, sheetIdx = this.getActiveSheetIndex(), selCells = this.getSheet(sheetIdx)._selectedCells;
            if (selCells.length === 0)
                return;
            if ((this._borderStyles.indexOf(args.ID) > -1))
                this.XLRibbon._updateBordeStyle(args);
            hexcode = this._borderColor || '#000000';
            alphRange = this._getAlphaRange(sheetIdx, selCells[0].rowIndex, selCells[0].colIndex, selCells[selCells.length - 1].rowIndex, selCells[selCells.length - 1].colIndex);
            if (this.model.allowSelection && (this.XLSelection._isOutsideBordering || this.XLSelection._isGridBordering))
                !(this._borderStyles.indexOf(args.ID) > -1) && (args.ID.indexOf("bordercolor") < 0) && (this.XLSelection._isOutsideBordering = this.XLSelection._isGridBordering = false);
            else
                this.setBorder({ "type": args.ID, "color": hexcode, "style": this._borderStyle }, alphRange);
            if (target.className.indexOf("back") > -1 || target.parentNode.className === 'e-bordercell')
                $('#' + this._id + '_bordercontainer').hide();
        },

        _getTableID: function (classname, name) {
            var i, tmgr = this.getSheet(this.getActiveSheetIndex()).tableManager;
            if (name) {
                for (i in tmgr)
                    if (name === tmgr[i].name)
                        return Number(i);
            }
            else {
                for (i in tmgr) {
                    if (classname.indexOf('e-table' + i) > -1)
                        return Number(i);
                }
            }
        },

        _cellStyleClick: function (e) {
            var elem, range = this.model.sheets[this.getActiveSheetIndex()].selectedRange, cname = e.target.className, formatstr = this.XLFormat.getFormatClass(cname);
            var details = { range: range, sheetIndex: this.getActiveSheetIndex(), reqType: "cell-styles", opr: e.target.innerText, beforeFormat: this.getRangeData({ range: range, property: ["format", "formats"] }) };
            if (cname.indexOf('e-cellstylecell') > -1)
                this.XLFormat.updateUniqueFormat(formatstr, range, e.target.innerText);
            if (cname.indexOf('e-cellstylecell') > -1 || cname.indexOf("back") > -1)
                $('#' + this._id + '_Ribbon_Home_Styles_CellStyles').length && $('#' + this._id + '_Ribbon_Home_Styles_CellStyles').data("ejSplitButton")._hidePopup();
            details.afterFormat = this.getRangeData({ range: range, property: ["format", "formats"] });
            if (!this.isUndoRedo) {
                this._completeAction(details);
                this._trigActionComplete(details);
            }
            if (this.model.showRibbon)
                this.XLRibbon._updateRibbonIcons();
        },

        _mouseHoverHandler: function (e) {
            var trgt = e.target, cellIdx;
            if (this._hasClass(e.target, "e-viewhdrlbl") || this._hasClass(e.target, "e-vheading"))
                this.element.find(".e-vheading .e-chk-act, .e-vheading .e-chk-inact").addClass("e-chkhover");
            else if (this._hasClass(e.target, "e-viewlinlbl") || this._hasClass(e.target, "e-vgridlines"))
                this.element.find(".e-vgridlines .e-chk-act, .e-vgridlines .e-chk-inact").addClass("e-chkhover")
            else if (this.model.allowDragAndDrop && this.XLDragDrop._allowDragAndDrop && ($(e.target).parents('.e-vscrollbar').length > 0 || e.target.className.indexOf('e-rowheader') > -1 || $(e.target).parents('.e-spreadsheetfooter').length > 0 ||
                    e.target.className.indexOf('e-headercell') > -1 || e.target.className.indexOf('e-spreadsheetfooter') > -1 || $(e.target).parents('.e-hscrollbar').length > 0 || (this.getSheet()._isFreezed && e.target.className.indexOf('e-rowcell') > -1)))
                this.XLDragDrop._scrollHover(e);
            else if (this._hasClass(e.target, "e-rowcell")) {
                cellIdx = this._getCellIdx(trgt);
                this._trigger("cellHover", { target: trgt, event: e, cellIndex: cellIdx });
            }
        },

        _mouseDownHandler: function (e) {
            var x, y, lmt, tid, obj, cell, elem, cname, tname, cellIdx, trgtCell, isNavigate = true, imgNavigate = true, str = "e-ss-object", pvt = "e-ss-pivot",
                trgt = e.target, $trgt = $(trgt), sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx),
                sheetElem = this.getSheetElement(sheetIdx), robj = $('#' + this._id + '_Ribbon').data('ejRibbon');
            e.currentTarget.className.indexOf("e-ribbon") < 0 && this.element.find(".e-bordercontainer").hide();
            if (this.element.find("#" + this._id + "ddl_popup").has(trgt).length)
                return false;
            this._isTouchEvt = this._isTouchEvent(e);
            if (this._isTouchEvt) {
                this._touchArgs = e;
                this._startXY = this._setXY(e, navigator.userAgent.indexOf("WebKit") > -1);
                if (this.model.allowDragAndDrop)
                    this.XLDragDrop._dragtouch(this._startXY[0], this._startXY[1]);
                if (!this._hasClass(trgt, "e-autofill") && this.model.allowAutoFill) {
                    lmt = (this._hasClass(trgt, "e-headercell")) ? 10 : 20;
                    x = this._setXY(e), y = x[1], x = x[0];
                    x = Math.abs(x - this.getAutoFillElem().offset().left);
                    y = Math.abs(y - this.getAutoFillElem().offset().top);
                    if (x <= lmt && x >= 0 && y <= lmt && y >= 0) {
                        $trgt = this.getAutoFillElem();
                        trgt = e.target = $trgt[0];
                    }
                }
            }
            if ($trgt.parents(".e-ribbon").length || $trgt.parents(".e-vscroll").length || $trgt.parents(".e-hscroll").length) {
                if (this._excelFilter) {
                    this.XLFilter._isSearchEdit = false;
                    this._excelFilter.closeXFDialog();
                }
            }
            else if (this._hasClass(trgt, "e-ssddl"))
                this._ddlopen(e);
            else {
                e.target = this._changeTargetWithOffset(e);
                if (this.model.allowCharts && sheet._isChartBorderDrawn)
                    this.XLChart._clearChartRange(this._arrayAsString(this._chartBorder));

                if ((this.model.pictureSettings.allowPictures || this.model.allowCharts) && ($trgt.hasClass(str) || $($trgt).parents("." + str).length)) {
                    if (!$trgt.hasClass(str))
                        trgt = e.target = $($trgt).parents("." + str)[0];
                    this.XLShape._shapeMouseDown(e);
                }
                else {
                    imgNavigate = false;
                    if (!this.XLShape._shapeROStart || !this.XLShape._shapeRSStart)
                        this._getContent(sheetIdx).find(".e-ss-activeimg").removeClass("e-ss-activeimg e-ss-imgcresize e-ss-imgrresize");
                }
                if (trgt.nodeName === "TD" || trgt.nodeName === "TH")
                    this.XLRibbon._isPanelVisible = false;
                if (this.model.enablePivotTable) {
                    if (this._isPvtNameEdit) {
                        this._isPvtNameEdit = false;
                        this.XLPivot._changePvtName();
                    }
                    if ($trgt.hasClass(pvt) || $trgt.parents("." + pvt).length) {
                        if (!$trgt.hasClass(pvt))
                            trgt = e.target = $trgt.parents("." + pvt)[0];
                        this.XLPivot._pivotMouseDown(e);
                    }
                    else if (!($trgt.parents(".e-ss-pivotfield").length || $trgt.hasClass("e-ss-pivotfield")) && !($trgt.hasClass("e-vhandle") || $trgt.hasClass("e-hhandle")) && $trgt.css("cursor") !== "col-resize") {
                        this.hideActivationPanel();
                        this.getSheetElement(sheetIdx).find(".e-ss-activepivot").removeClass("e-ss-activepivot");
                    }
                }
                cname = trgt.className;
                if (trgt.id.indexOf("picture") === -1) {
                    if (this.model.showRibbon && (robj.model.selectedItemIndex === this.XLRibbon._getTabIndex("format") || robj.isVisible(this._getLocStr("FORMAT"))))
                        this.XLRibbon._toggleFormatTab();
                }
                //Click the Chart
                if (this.model.showRibbon && trgt.id.indexOf("chart") > -1)
                    this.XLRibbon._chartDesignTabUpdate($(trgt));
                else if (this.model.showRibbon && (robj.model.selectedItemIndex === this.XLRibbon._getTabIndex("cdesign") || robj.isVisible(this._getLocStr("CHARTDESIGN"))))
                    this.XLRibbon._toggleChartDesignTab();
                if (this.XLEdit._isEdit && trgt.nodeName != "TD" && !(this._hasClass(trgt, "e-autofill")))
                    return;
                if (this.model.allowDragAndDrop && this.XLDragDrop._isDragAndDropStart && (cname !== "e-autofill" && cname.indexOf("e-filterspan") < 0))
                    this.XLDragDrop._dMouseDown(e);
                if (this.model.allowResizing && !this.XLEdit._isEdit) {
                    if ($(trgt).hasClass("e-headercelldiv") || $(trgt).hasClass("e-headercell"))
                        this.XLResize._headerMouseDown(e);
                    else if ($(trgt).hasClass("e-rowheader"))
                        this.XLResize._rowMouseDown(e);
                    else if ($(trgt).hasClass("e-spreadsheetactpanel") || $(trgt).parents(".e-spreadsheetactpanel").length)
                        this.XLResize._apMouseDown(e);
                }
                if ($(trgt).parents("div.e-spreadsheetactpanel").length > 0)
                    return;
                if (this.model.allowEditing && this.XLEdit._editElem.html() === "=") {
                    this._isFormulaSuggestion = false;
                    this.XLEdit._isFormulaEdit = true;
                }
                isNavigate = this.XLEdit._isEdit ? (this._isFormulaSuggestion || !this.XLEdit._isFormulaEdit) && this.XLEdit.saveCell() : true;
                if (!isNavigate && !this.XLEdit._isFormulaEdit)
                    return false;
                //Comment
                if (this.model.allowComments && !$trgt.hasClass("e-pager") && this.getSheetElement(sheetIdx).find(".e-commentcell").length)
                    this.XLComment._commentMouseDownHandler(e);
                if ((trgt.tagName === "SPAN" || trgt.tagName === "A") && (!ej.isNullOrUndefined($trgt.parent("td")[0]))) {
                    cell = $trgt.parent("td")[0];
                    obj = this._getCellIdx(cell);
                }
                else if (trgt.tagName === "TD" && this._hasClass(trgt, "e-rowcell")) {
                    cell = trgt;
                    obj = this._getCellIdx(cell);
                    if (this.model.showRibbon)
                        this.XLRibbon.updateRibbonIcons();
                }
                else
                    obj = this.getActiveCell();
                if (trgt.tagName === "A") {
                    sheet._activeCell = obj;
                    if (this.model.allowSelection) {
                        this.XLSelection.selectRange(obj, obj);
                        this.XLDragFill.positionAutoFillElement();
                    }
                    if (e.which !== 3)
                        this._hlClick(this.XLEdit.getPropertyValue(obj.rowIndex, obj.colIndex, "hyperlink", sheetIdx));
                }
                else if ((e.button !== 2 || e.which !== 3) || this.getSheetElement(sheetIdx).find(".e-selected, .e-colselected .e-headercelldiv, .e-rowselected").index(trgt) === -1) { // for context menu behavior                          
                    if (this.model.allowSelection && !imgNavigate) {
                        if (ej.isNullOrUndefined(this.XLDragDrop) || !this.XLDragDrop._allowDragAndDrop) {
                            if (!(this.XLResize && this.XLResize._resizeStart) && !$trgt.hasClass("e-comment-txtarea") && !($trgt.hasClass(pvt) || $($trgt).parents("." + pvt).length))
                                this.XLSelection._selectionMouseDownHandler(e);
                        }
                    }
                }
                this._filterClose(e.target);
                this._undoInputobj = {};
                if (trgt.tagName === "TD" && $(trgt).parents("div")[0].className === "e-content")
                    this.displayActivationPanel(this.XLEdit.getPropertyValue(obj.rowIndex, obj.colIndex, "range"));
                if ((trgt.tagName === "TD") && trgt.className.indexOf("e-rowheader") < 0) {
                    if (!ej.isNullOrUndefined(this._ddlCell)) {
                        this.element.find("#" + this._id + "ddl").ejDropDownList("hidePopup");
                        this.element.find("#" + this._id + "ddlspan").remove();
                        this._ddlCell = null;
                    }
                }
                if (trgt.tagName === "TD" && this._hasClass(trgt, "e-rowcell")) {
                    trgtCell = this._getCellIdx(trgt);
                    if (!ej.isNullOrUndefined(this.XLEdit.getPropertyValue(trgtCell.rowIndex, trgtCell.colIndex, "rule", sheetIdx)))
                        this._setddlCell(e);
                }
                //Table Rename
                if (this._isTableRename) {
                    this.XLFormat._renameTable(this._tableClassName);
                    this._isTableRename = false;
                }
                //Sheet Rename
                if (this._isSheetRename)
                    this._updateSheetNames(null, false);
                this.element.find("#" + this._id + "ddl").ejDropDownList("hidePopup");
                if (this._hasClass(trgt, "e-rowcell"))
                    tname = this.XLEdit.getPropertyValue(obj.rowIndex, obj.colIndex, "tableName", sheetIdx);
                if (tname) {
                    tid = this._getTableID(tname);
                    if (this.isNumber(tid))
                        this.XLRibbon._designTabUpdate(tid, obj);
                }
                else if (this.model.showRibbon && (robj.model.selectedItemIndex === this.XLRibbon._getTabIndex("design") || robj.isVisible(this._getLocStr("Design"))))
                    this.XLRibbon._toggleDesignTab(obj);
                if (this.model.allowEditing) {
                    cell = sheet._activeCell;
                    if (this.XLEdit._isEdit && e.target.id !== this._id + "_inputbox") {
                        elem = ($(e.target).hasClass("e-ss-input") || !this.XLEdit._isFBarFocused) ? this.element.find("#" + this._id + "_Edit") : this._getInputBox();
                        if (elem) {
                            if (e.target.id !== elem[0].id)
                                elem.focus().setInputPos(elem[0].selectionStart, elem[0].selectionEnd);
                            if (elem.hasClass("e-ss-input"))
                                this.XLEdit._isFBarFocused = false;
                        }
                    }
                    if (!(this.model.allowComments && this.XLComment._isCommentEdit) && !this._isSheetRename && e.target.id === this._id + "_inputbox") {
                        if (e.target.readOnly)
                            this.setSheetFocus();
                        else {
                            if (!this.XLEdit._isEdit)
                                this.XLEdit.editCell(cell.rowIndex, cell.colIndex, true);
                            this._getInputBox().focus();
                            this.XLEdit._isFBarFocused = true;
                        }
                    }
                }
            }
        },

        // Dropdownlist list validation
        _renderDDownList: function () {
            this.element.append(ej.buildTag("input.e-" + this._id + "-ddl", "", "", { id: this._id + "ddl", style: "display:none" }));
            $("#" + this._id + "ddl").ejDropDownList({
                fields: { id: "Types", text: "text", value: "text" },
                beforePopupShown: $.proxy(this._drppopupshow, this),
                cssClass: "e-" + this._id + "-ddl e-ss-ddlwrap",
                width: 0.1,
                height: 0.1,
                change: $.proxy(this._changeddl, this)
            });
            $(document.body).append($('#' + this._id + 'ddl_popup_wrapper'));
        },

        _setddlCell: function (e) {
            var i, elepos, len, range, value = [], value2 = [], listdatsrc = [], check, customvalue, cell, trgt, sheetIdx = this.getActiveSheetIndex(), pos, spanElem;
            if (!ej.isNullOrUndefined(e) && e.type === "mousedown") {
                cell = this._getCellIdx(e.target);
                trgt = e.currentTarget;
            }
            else {
                cell = this.getActiveCell();
                trgt = $("#" + this._id + "GroupPanel").find("div.e-content")[0];
            }
            customvalue = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "rule", sheetIdx);
            if (!customvalue)
                return;
            check = customvalue.customVal.split("_");
            if (customvalue && check[1] === "list") {
                this._ddlCell = cell;
                var dataSrc = check[0], i, len, values = [];
                if (dataSrc.startsWith("=") && dataSrc.indexOf(",") < 0) {
                    var value = $.trim(dataSrc.replace("=", "")), splitStr;
                    if (value.indexOf("!") > -1) {
                        splitStr = value.split("!");
                        sheetIdx = this._getSheetIndexByName(splitStr[0]);
                        value = splitStr[1];
                    }
                    value.indexOf("$") > -1 && (value = value.split("$").join(""));
                    value.indexOf(":") < 0 && (value = value + ":" + value);
                    range = this.getRangeIndices(value);
                    var cells = this._getMultiRangeCells(range);
                    var contValue = this.getRangeData({ range: [cells[0].rowIndex, cells[0].colIndex, cells[cells.length - 1].rowIndex, cells[cells.length - 1].colIndex], property: ["value", "value2"], sheetIdx: sheetIdx });
                    for (i = 0, len = contValue.length; i < len; i++) {
                        if (!ej.isNullOrUndefined(contValue[i].value) && !ej.isNullOrUndefined(contValue[i].value2)) {
                            values.push(contValue[i].value);
                            value2.push(contValue[i].value2);
                        }
                        else {
                            values.push("");
                            value2.push("");
                        }
                    }
                    if (!values.length) {
                        values.push(dataSrc);
                        value2.push(dataSrc);
                    }
                }
                else if (dataSrc.indexOf(",") > -1)
                    value2 = values = dataSrc.split(",");
                else {
                    values = [];
                    values.push(dataSrc);
                    value2.push(dataSrc);
                }
                for (i = 0, len = values.length; i < len; i++)
                    listdatsrc[i] = { id: i + 1, text: value2[i], value: values[i] };
                cell = this.getCell(cell.rowIndex, cell.colIndex);
                elepos = { "top": cell[0].offsetTop, "left": cell[0].offsetLeft };
                trgt.insertAdjacentHTML("beforeEnd", "<span id='" + this._id + "ddlspan' class='e-icon e-ssddl e-spanddl e-ddlspan' role='button'></span>");
                spanElem = $("#" + this._id + "ddlspan");
                pos = cell.height() - (spanElem.height() + 3);
                spanElem.css({ top: elepos.top + pos, left: elepos.left + cell.width() + 3 });
                $("#" + this._id + "ddl").ejDropDownList("option", "dataSource", listdatsrc);
            }
        },

        _drppopupshow: function () {
            if (this._ddlCell) {
                var cell = this.getCell(this._ddlCell.rowIndex, this._ddlCell.colIndex);
                $("#" + this._id + "ddl_popup").css({ "width": this.getActiveCellElem().width() + 20, "font-size": "11", top: cell.position().top, left: cell.position().left });
            }
        },

        _ddlPosition: function () {
            if (this._ddlCell) {
                var spanElem, cell = this.getCell(this._ddlCell.rowIndex, this._ddlCell.colIndex), elepos = { "top": cell[0].offsetTop, "left": cell[0].offsetLeft };
                spanElem = $("#" + this._id + "ddlspan");
                spanElem.css({ top: elepos.top + cell.height() - (spanElem.height() + 3), left: elepos.left + cell.width() + 3 });
            }
        },

        _changeddl: function (args) {
            if (this._ddlCell && this.model.allowEditing) {
                var actCell = this.getActiveCell(), selVal = args.model.dataSource[args.itemId].value, pValue = this.XLEdit.getPropertyValue(actCell.rowIndex, actCell.colIndex);
                this.XLEdit._updateCellValue(actCell, selVal);
                this.getActiveCellElem().hasClass("e-hlcell") && this.XLValidate.highlightInvalidData();
                this._trigrDdlActnCmplt(selVal, pValue, args.itemId);
                if (this.model.allowFormulaBar)
                    this.updateFormulaBar();
            }
        },

        _trigrDdlActnCmplt: function (selVal, pValue, ddlSIdx) {
            if (this.model.actionComplete === null)
                return;
            var refrSheetIdx, refrRange, range, actCell = this.getActiveCell(), sheetIdx = this.getActiveSheetIndex(), valRule, args, dtSrcRef, addr, rangeData;
            valRule = this.XLEdit.getPropertyValue(actCell.rowIndex, actCell.colIndex, "rule", sheetIdx);
            args = { reqType: "edit", sheetIndex: sheetIdx, currValue: selVal, prevValue: pValue, rowIndex: actCell.rowIndex, colIndex: actCell.colIndex, hasValidation: true, rule: valRule, isRefreshVal: false };
            if (valRule.type == "list" && selVal !== "") {
                dtSrcRef = valRule.customVal.split("_")[0];
                if (dtSrcRef[0] == "=" && dtSrcRef.indexOf(",") < 0) {
                    args.isRefrsVal = true;
                    dtSrcRef = dtSrcRef.replace("=", "");
                    addr = dtSrcRef.split("!");
                    args.refrValSheetIdx = refrSheetIdx = addr.length == 1 ? sheetIdx : this._getSheetIndexByName(addr[0]);
                    refrRange = addr.length == 1 ? addr[0] : addr[1];
                    refrRange.indexOf("$") > -1 && (refrRange = refrRange.replace(/\$/g, ""));
                    range = this.getRangeIndices(refrRange);
                    if (this.isUndefined(ddlSIdx)) {
                        rangeData = this.getRangeData({ range: range });
                        for (idx in rangeData)
                            if (rangeData[idx].value == selVal)
                                ddlSIdx = parseInt(idx);
                    }
                    if (range[0] === range[2])
                        args.refrValCellAddr = this.getAlphaRange(range[0], range[1] + ddlSIdx);
                    else
                        args.refrValCellAddr = this.getAlphaRange(range[0] + ddlSIdx, range[1]);
                }
            }
            this._trigActionComplete(args);
        },

        _ddlopen: function (e) {
            var sheetIdx = this.getActiveSheetIndex(), actCell = this.getActiveCell(sheetIdx), rowHt = this.getSheet(sheetIdx).rowsHeightCollection[actCell.rowIndex], position;
            if (this.XLEdit._isEdit && this.XLEdit.getPropertyValue(actCell.rowIndex, actCell.colIndex, "rule").customVal.split("_")[2] === "true")
                return false;
            this.XLEdit.saveCell();
            var actionObj = $("#" + this._id + "ddl").data("ejDropDownList"), cell = this.getCell(this._ddlCell.rowIndex, this._ddlCell.colIndex);
            e.stopPropagation();
            if (!ej.isNullOrUndefined(actionObj)) {
                if (actionObj._isPopupShown()) {
                    actionObj._hideResult();
                }
                else {
                    actionObj._showResult();
                    $("#" + this._id + "ddl_popup").css({ "width": this.getActiveCellElem().width() + 20, "font-size": "11", top: 20, left: 100 });
                    var position = this._getXYPos(cell, $("#" + this._id + "ddl_popup"), rowHt, 0);
                    $("#" + this._id + "ddl_popup_list_wrapper").css({ top: position.yPos + rowHt, left: position.xPos });
                }
            }
        },

        _mouseMoveHandler: function (e) {
            e.target = this._changeTargetWithOffset(e);
            var trgt = $(e.target), xy, clientDiff;
            this._isTouchEvt = this._isTouchEvent(e);
            if (this._isTouchEvt) {
                e.preventDefault();
                xy = this._setXY(e, navigator.userAgent.indexOf("WebKit") > -1);
                if (this.model.allowDragAndDrop)
                    this.XLDragDrop._dragtouch(xy[0], xy[1]);
            }
            if (this.model.allowResizing && (this.XLResize._resizeType === "Col" || trgt.hasClass("e-headercelldiv") || trgt.hasClass("e-headercell") || trgt.hasClass("e-reSizeColbg")) && !this.XLEdit._isEdit && !(this.XLCMenu && this.XLCMenu._isMenuOpened))
                this.XLResize._cMouseMove(e);
            else if (this.model.allowResizing && (this.XLResize._resizeType === "Row" || trgt.hasClass("e-rowheader") || trgt.hasClass("e-reSizeRowbg")) && !this.XLEdit._isEdit && !(this.XLCMenu && this.XLCMenu._isMenuOpened))
                this.XLResize._rMouseMove(e);
            else if (this.model.allowResizing && (this.XLResize._resizeType === "AP" || trgt.hasClass("e-spreadsheetactpanel") || trgt.parents(".e-spreadsheetactpanel").length > 0))
                this.XLResize._apMouseMove(e);
            else if ((this.model.pictureSettings.allowPictures || this.model.allowCharts) && (trgt.hasClass("e-ss-object") || trgt.parents(".e-ss-object").length || this.XLShape._shapeROStart || this.XLShape._shapeRSStart || trgt.hasClass("e-ss-imgvisual")))
                this.XLShape._imgMouseMove(e);
            if (this.model.allowSelection && this.model.allowDragAndDrop && ej.spreadsheetFeatures.dragAndDrop && trgt.parents(".e-spreadsheetmainpanel").length && trgt.hasClass("e-rowcell") && !this.XLEdit._isEdit && this._getJSSheetHeader(this.getActiveSheetIndex())[0].querySelector('.e-spreadsheetcolumnheader').className.indexOf('e-sheetselected') === -1)
                this.XLDragDrop._dMouseMove(e);
            if (this.model.allowComments && !this.XLComment._isCommentEdit && (this.getSheetElement(this.getActiveSheetIndex()).find(".e-commentcell").length > 0))
                this.XLComment._commentMouseMove(e);
            if (!ej.isNullOrUndefined(e.target.parentNode))
                ((e.target.id.indexOf('_svg') < 0) && e.target.parentNode.className.indexOf('e-content') < 0 && !$(e.target).is('td.e-rowcell')) && this.XLShape._shapeMouseUp(e);
            if (this._isTouchEvt && !this._isSelected(e.target) && !this._isTouchMoveSel && this._touchArgs && !this._isUniqueTarget(this._touchArgs, e) && trgt.parents(".e-table").length && trgt.parents(".e-spreadsheetcontentcontainer").length && !this.XLDragDrop._allowDragAndDrop) {
                clientDiff = this._getClientDiff(this._startXY, xy);
                this._scrollContent(clientDiff);
                this._startXY = xy;
                this._touchArgs = e;
                this._isTouchScroll = true;
            }
        },

        _mouseLeaveHandler: function (e) {
            if (this._hasClass(e.target, "e-viewhdrlbl") || this._hasClass(e.target, "e-vheading"))
                this.element.find(".e-vheading .e-chk-act, .e-vheading .e-chk-inact").removeClass("e-chkhover");
            else if (this._hasClass(e.target, "e-viewlinlbl") || this._hasClass(e.target, "e-vgridlines"))
                this.element.find(".e-vgridlines .e-chk-act,.e-vgridlines .e-chk-inact").removeClass("e-chkhover");
            else if (this.model.allowResizing)
                $(".e-ss-colresize, .e-ss-rowresize").removeClass("e-ss-colresize e-ss-rowresize");
        },

        _mouseUpHandler: function (e) {
            var trgt = $(e.target), sheetIdx = this.getActiveSheetIndex(), vScroll = this.XLScroll._vScroller(sheetIdx), hScroll = this.XLScroll._hScroller(sheetIdx);
            if (this.model.allowResizing) {
                if (this.XLResize._resizeType === "Col")
                    this.XLResize._cMouseUp(e);
                else if (this.XLResize._resizeType === "Row")
                    this.XLResize._rMouseUp(e);
                else if (this.XLResize._resizeType === "AP")
                    this.XLResize._apMouseUp(e);
            }
			if(this.model.showRibbon && !this._phoneMode) {
				if (this.element.find('.e-ribbonpin').is(':visible') && $(e.target).parents('.e-ribbon').length <= 0)
					$("#" + this._id + "_Ribbon").ejRibbon("collapse");
			}
            if (this.model.allowDragAndDrop && this.XLDragDrop._allowDragAndDrop)
                this.XLDragDrop._dMouseUp(e);
            if (this.model.allowComments && this.XLComment._isCommentEdit)
                this.getActiveCellElem().find("textarea").focus();
            if (this._isSheetRename)
                $("#" + this._id + "_Sheet_RenamePanel").focus();
            if (this.model.pictureSettings.allowPictures)
                this.XLShape._shapeMouseUp(e);
            if (this.model.enablePivotTable)
                this.XLPivot._pivotMouseUp(e);
            if (this.XLEdit._isEdit && trgt[0].id !== this.XLEdit._editElem[0].id)
                this.XLEdit._editElem.setCursorPosition((this._browserDetails.version === "8.0") ? document.selection.anchorOffset : window.getSelection().anchorOffset);
            if (this._hasClass(trgt[0], "e-vhandle") || this._hasClass(trgt[0], "e-vhandlespace") || this._hasClass(trgt[0], "e-vup") || this._hasClass(trgt[0], "e-vdown")) {
                if (this._trigger("scrollStop", { scrollData: vScroll._scrollData, position: vScroll.model.value, reqType: "vertical" }));
                return;
            }
            if (this._hasClass(trgt[0], "e-hhandle") || this._hasClass(trgt[0], "e-hhandlespace") || this._hasClass(trgt[0], "e-hdown") || this._hasClass(trgt[0], "e-hup")) {
                if (this._trigger("scrollStop", { scrollData: vScroll._scrollData, position: hScroll.model.value, reqType: "horizontal" }));
                return;
            }
        },

        _scrollContent: function (clientPos, isActPos) {
            var diff, scroll, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx);
            if (clientPos.x) {
                diff = (isActPos) ? clientPos.x : sheet._scrollLeft + clientPos.x;
                scroll = this.XLScroll._hScroller(sheetIdx);
                if (diff < 0)
                    diff = 0;
                else {
                    if (this.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal) {
                        if (clientPos.x > 0 && scroll.model.maximum < diff + scroll._scrollData.handle)
                            diff = scroll.model.maximum;
                    }
                    else
                        scroll._scrollData.step = clientPos.x < 0 ? -1 : 1;
                }
                if (sheet._scrollLeft != diff)
                    scroll.scroll(diff);
            }
            if (clientPos.y) {
                diff = (isActPos) ? clientPos.y : sheet._scrollTop + clientPos.y;
                scroll = this.XLScroll._vScroller(sheetIdx);
                if (diff < 0)
                    diff = 0;
                else {
                    if (this.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite)
                        scroll._scrollData.step = clientPos.y < 0 ? -1 : 1;
                }
                if (diff || (sheet._scrollTop != diff))
                    scroll.scroll(diff);
            }
        },

        _keyDownHandler: function (e) {
            var tid, cname, text, tname, trange, actElemId, editText, isNavigate = true, imgNavigate = false, sheetIdx = this.getActiveSheetIndex(), aComplete = this.element.find("#" + this._id + "_AutoComplete").data("ejAutocomplete"),
                robj = $('#' + this._id + '_Ribbon').data('ejRibbon'), activeCell = this.getSheet(sheetIdx)._activeCell;
            if (this._trigger("keyDown", { event: e, isEdit: this.model.allowEditing && this.XLEdit._isEdit, isCommentEdit: this.model.allowComments && this.XLComment._isCommentEdit, isSheetRename: this._isSheetRename, sheetIndex: this._getSheetIndex() }))
                return;
            if (this._getContent(sheetIdx).find(".e-ss-activeimg").length) {
                if ($(e.target).hasClass("e-numerictextbox") && e.keyCode === 13)
                    e.preventDefault();
                imgNavigate = true;
                actElemId = document.activeElement.id;
                actElemId.indexOf(this._id + "_Ribbon_Format_Size_PictureHeight") < 0 && actElemId.indexOf(this._id + "_Ribbon_Format_Size_PictureWidth") < 0 && this.XLShape._imgKeyDown(e);
            }
            if(navigator.platform.toLowerCase().indexOf('mac') > -1 && e.metaKey){
                if(e.keyCode == 67)
                    this.XLClipboard.copy();
                else if(e.keyCode == 86)
                    this.XLClipboard.paste();
                else if(e.keyCode == 88)
                    this.XLClipboard.cut();
                return;
            }
            if (aComplete.showSuggestionBox && aComplete.suggestionList) {
                if (e.keyCode === 38) {
                    aComplete._removeListHover();
                    if (aComplete._activeItem > 1)
                        aComplete._activeItem = aComplete._activeItem - 1;
                    else
                        aComplete._activeItem = aComplete._listSize;
                    aComplete._addListHover();
                    aComplete._targetFocus();
                    return;
                }
                else if (e.keyCode === 40) {
                    aComplete._removeListHover();
                    if (aComplete._activeItem < aComplete._listSize)
                        aComplete._activeItem = aComplete._activeItem + 1;
                    else
                        aComplete._activeItem = 1;
                    aComplete._addListHover();
                    return;
                }
            }
            if (e.target.id.indexOf("_Edit") > -1)
                this.model.allowKeyboardNavigation && (this.XLCellNav._canKeyBoardNavigate = true);
            if (this.XLEdit._editElem)
                editText = this.XLEdit._editElem.text();
            if (e.target.id.indexOf("_Edit") > -1 && e.keyCode === 9 && editText.indexOf("=") === 0 && editText.indexOf(")") != editText.length - 1) {
                e.preventDefault();
                if (!aComplete.suggestionList.is(":visible") && this.model.allowKeyboardNavigation) {
                    if (this._isFormulaSuggestion && (e.keyCode === 39 || e.keyCode === 37 || (e.keyCode === 13 && !e.altKey)))
                        this.XLEdit.saveCell();
                    this.XLCellNav._selectionKeyDownHandler(e);
                    activeCell = this.getSheet(sheetIdx)._activeCell;
                    return;
                }
                text = aComplete.getActiveText();
                if (!this.XLEdit._isNamedRange(text))
                    text += "(";
                this.XLEdit._editElem.text(text);
                if (this.model.allowFormulaBar)
                    this._getInputBox().val(text);
                if (e.target.id.indexOf("_Edit") > -1)
                    this.XLEdit._editElem.focusEnd();
                this.XLCellNav._canKeyBoardNavigate = false;
                return;
            }
            if (this.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, 'wrap') && this.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, 'merge') && e.keyCode === 46) {
                this.getCell(activeCell.rowIndex, activeCell.colIndex, sheetIdx).find('#' + this._id + '_MergeWrap')[0].textContent = "";
            }
            if (e.target.id.indexOf("_Custom") < 0 && e.target.id.indexOf("_Ribbon") < 0) {
                e.stopImmediatePropagation();
                if (this.model.allowFiltering && this.XLFilter._isSearchEdit && e.keyCode !== 27)
                    return true;
                if ($(e.target).parents(".e-formulabar").length && this.XLEdit._isEdit && this.model.allowKeyboardNavigation)
                    this.XLCellNav._isNavigate = e.keyCode === 13;
                !this._isSheetRename && !this.XLEdit._isEdit && !(this.XLComment && this.XLComment._isCommentEdit) && this.model.allowClipboard && this.XLClipboard._copyPasteHandler(e);
                if (!imgNavigate && !this._isSheetRename)
                    !(this.XLComment && this.XLComment._isCommentEdit) ? this.model.allowEditing && (document.activeElement.id.indexOf('_inputbox') === -1 || e.keyCode === 27) && this.XLEdit._editingHandler(e) : this.model.allowKeyboardNavigation && (this.XLCellNav._isNavigate = false);
                if (this._isFormulaSuggestion && (e.keyCode === 39 || e.keyCode === 37 || (e.keyCode === 13 && !e.altKey)))
                    this.XLEdit.saveCell();
                else if (!this.XLEdit._isFormulaEdit && (e.keyCode === 9 || (e.keyCode === 13 && !e.altKey) || e.keyCode === 37 || e.keyCode === 38 || e.keyCode === 39 || e.keyCode === 40))
                    isNavigate = this.XLEdit._isEdit && this.model.allowKeyboardNavigation && this.XLCellNav._isNavigate ? this.XLEdit.saveCell() : true;
                if ($(e.target).hasClass("e-field-validation-error") || (e.target.id == this._id + '_Ribbon_Home_Font_FontFamily_wrapper' || e.target.id == this._id + '_Ribbon_Home_Number_NumberFormat_wrapper' || e.target.id == this._id + '_Ribbon_Home_Font_FontSize_wrapper'))
                    return true;
                if (this.model.allowDataValidation && this.XLValidate._isErrorVisible && (e.keyCode === 37 || e.keyCode === 39 || e.keyCode === 38 || e.keyCode === 40)) {
                    this.XLValidate._isErrorVisible = false;
                    return true
                }
                if ((!isNavigate && !this.XLEdit._isFormulaEdit) || (e.keyCode === 13 && e.altKey))
                    return false;
                if (this.model.allowKeyboardNavigation && !imgNavigate && !this._isSheetRename) {
                    if (!(this.model.allowComments && this.XLComment._isCommentEdit))
                        if ((!$(e.target).parents(".e-formulabar").length || e.keyCode === 9 || (e.keyCode === 13 && !e.altKey)))
                            this.XLCellNav._selectionKeyDownHandler(e);
                    activeCell = this.getSheet(sheetIdx)._activeCell;
                    this._keyboardShortCuts(e);
                }
                if (this.model.allowUndoRedo)
                    if (this.model.allowComments && !this.XLComment._isCommentEdit)
                        this._undoRedoOperation(e);
                    else if (!this.model.allowComments)
                        this._undoRedoOperation(e);
                if (this.XLEdit._isFormulaEdit && e.keyCode === 9 && !this.XLCellNav._canKeyBoardNavigate) // enabling tab key while selecting formula
                    this.XLCellNav._canKeyBoardNavigate = true;
            }
            if (e.target.id === this._id + "_Ribbon_Analyze_PivotTable_PivotTableName") {
                this._isPvtNameEdit = true;
                return true;
            }
            else if (this._isPvtNameEdit) {
                this._isPvtNameEdit = false;
                this.XLPivot._changePvtName();
            }
            if ((e.target.tagName === "DIV") && !this.XLEdit._isEdit) {
                if (!ej.isNullOrUndefined(this._ddlCell)) {
                    this.element.find("#" + this._id + "ddl").ejDropDownList("hidePopup");
                    this.element.find("#" + this._id + "ddlspan").remove();
                    this._ddlCell = null;
                }
            }
            tname = this.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "tableName", sheetIdx);
            if (e.target.id === this._id + "_Ribbon_Design_Properties_TableName") {
                this._isTableRename = true;
                this._tableClassName = this.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "tableName") || "";
                if (this._isTableRename && (e.keyCode === 13 || e.keyCode === 9 || e.keyCode === 27)) {
                    if (e.keyCode === 13)
                        e.preventDefault();
                    this.XLFormat._renameTable(this._tableClassName);
                }
                else
                    return;
            }
            if (tname && this._getContent(sheetIdx).find('.e-ss-activeimg').length === 0) {
                tid = this._getTableID(tname);
                this.isNumber(tid) && this.XLRibbon._designTabUpdate(tid, activeCell);
            }
            else if (this.model.showRibbon && (robj.model.selectedItemIndex === this.XLRibbon._getTabIndex("design") || robj.isVisible(this._getLocStr("Design"))))
                this.XLRibbon._toggleDesignTab(activeCell);
            if (!this.XLEdit._isEdit && !ej.isNullOrUndefined(this.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, 'rule', sheetIdx)))
                this._setddlCell(e);

            if (this._isSheetRename && (e.keyCode === 13 || e.keyCode === 9 || e.keyCode === 27)) {
                e.preventDefault();
                this._updateSheetNames(null, e.keyCode === 27) && this.setSheetFocus();
            }
            if (aComplete.suggestionList.is(":visible") && (this.XLEdit._editElem.text() === "" || e.keyCode === 13))
                aComplete._hideResult();
            this.model.showRibbon && this.XLRibbon._updateRibbonIcons();
        },

        _keyUpHandler: function (e) {
            var formulatext = this.element.find("#" + this._id + "_Edit").text();
            if (this.model.allowEditing && this.XLEdit._isEdit) {
                if (formulatext.indexOf("=") > -1 && formulatext.length > 0 && formulatext.indexOf(")") == -1) {
                    if (!this.XLEdit._isFEdit)
                        this.XLCellNav._isNavigate = true;
                    if (e.keyCode !== 40 && e.keyCode !== 38 && formulatext.length > 1)
                        this.XLEdit._captureEditing(e);
                }
            }
            this._trigger("keyUp", { event: e, isEdit: this.model.allowEditing && this.XLEdit._isEdit, isCommentEdit: this.model.allowComments && this.XLComment._isCommentEdit, isSheetRename: this._isSheetRename, sheetIndex: this._getSheetIndex() });
        },

        _dblClickHandler: function (e) {
            var sheetCont, trgt, cellIdx, sheetIdx, sheet;
            this.XLEdit._isFEdit = false;
            if (e.target.tagName === "A")
                return;
            if (this._hasClass(e.target, "e-numericitem")) {
                if (this.XLEdit && this.XLEdit._isEdit) {
                    if (this.getActiveCellElem().find(".e-error").length)
                        return;
                }
                if (!this._isSheetRename)
                    this._renameSheet();
            }
            else {
                if (e.target.id.indexOf("chart") > -1 || this._hasClass(e.target, "e-comment-txtarea") || this._hasClass(e.target, "e-filterspan") || $(e.target).parents(".e-ss-pivot").length)
                    return;
                sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx);
                e.target = this._changeTargetWithOffset(e);
                if (!this.model.allowEditing || !this.model.allowSelection)
                    return;
                if (this.XLSelection._isOutsideBordering || this.XLSelection._isGridBordering) {
                    sheetCont = this._getContent(sheetIdx).find("div:first-child");
                    sheetCont.addClass("e-ss-cursor");
                    sheetCont.removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor");
                    this.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                    if (this.model.allowAutoFill)
                        this.XLDragFill.positionAutoFillElement();
                    this.XLSelection._isOutsideBordering = this.XLSelection._isGridBordering = false;
                    return;
                }
                if (!this.XLEdit._isEdit && ($(e.target).hasClass("e-rowcell") || $(e.target).parents("td").hasClass("e-rowcell")) && (!this._hasClass($(e.target), "e-readonly") && !$(e.target).hasClass("e-cellreadonly"))) {
                    if (this._isTouchEvt)
                        e.preventDefault();
                    if ($('.e-cdata').length)
                        $('.e-cutright, .e-cutbottom').removeClass('e-cutright e-cutbottom');
                    trgt = $(e.target);
                    if (trgt.closest("#" + this._id + "EditForm").length)
                        return;
                    if (e.target.id.length < 1)
                        cellIdx = this._getCellIdx(e.target);
                    else
                        cellIdx = this._getCellIdx($(e.target).parents('td')[0]);
                    this.XLEdit.editCell(cellIdx.rowIndex, cellIdx.colIndex, true);
                }
                if (this.model.allowResizing && ($(e.target).hasClass("e-headercell") || $(e.target).hasClass("e-headercelldiv")) && ($(e.target).css("cursor") === "col-resize" || this._isTouchEvt)) {
                    if ($(e.target).hasClass("e-headercelldiv"))
                        e.target = e.target.parentNode;
                    this.XLResize._resizeToFitWidth(e);
                }
                if (this.model.allowResizing && ($(e.target).hasClass("e-ss-rowresize") || (this._isTouchEvt && $(e.target).hasClass("e-rowheader"))))
                    this.XLResize._resizeToFitHeight(e);
            }
        },

        _setAndSelectActiveCell: function (rowIndex, colIndex, scrollOpt) {
            this.setActiveCell(rowIndex, colIndex);
            this._selectActiveCell(rowIndex, colIndex, '', scrollOpt);
        },

        _selectActiveCell: function (rowIndex, colIndex, range, scrollOpt) {
            var sheetIdx = this.getActiveSheetIndex(), obj = range ? { rowIndex: range.rowIndex, colIndex: range.colIndex } : { rowIndex: rowIndex, colIndex: colIndex }, sheet = this.getSheet(sheetIdx);
            if (this.model.allowSelection && this.model.allowKeyboardNavigation && this.model.scrollSettings.allowScrolling) {
                if (this.XLEdit.getPropertyValue(rowIndex, colIndex, "mergeIdx")) {
                    sheet._activeCell = sheet._endCell = sheet._startCell = obj;
                    this.XLSelection._processBoundary();
                    sheet._activeCell = sheet._startCell;
                    this.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                }
                else
                    this.XLSelection.selectRange(this._getAlphaRange(sheetIdx, rowIndex, colIndex, obj.rowIndex, obj.colIndex));
                if (this.model.allowAutoFill)
                    this.XLDragFill.positionAutoFillElement();
                switch (scrollOpt) {
                    case "Home":
				        this._scrollContent({ x: [range ? (range.colIndex * sheet.columnWidth) : 0] - sheet._scrollLeft }); break;
				    case "End":
				        if (sheet._isFreezed) 
				            this.XLCellNav._navToCell(rowIndex, colIndex);
				        else
				            if ((rowIndex < sheet._topRow.idx || rowIndex > sheet._bottomRow.idx) || colIndex < sheet._leftCol.idx || colIndex > sheet._rightCol.idx)
				                this.XLScroll.scrollToCell(this._getAlphaRange(sheetIdx, rowIndex, colIndex, obj.rowIndex, obj.colIndex));
				        break;
				    case "Ctrl + Home":
				    case "Ctrl + Shift + Home":
				        this.XLScroll.scrollToCell(this._getAlphaRange(sheetIdx, rowIndex, colIndex, obj.rowIndex, obj.colIndex)); break;
				}
                this.XLScroll._getFirstColumn(sheetIdx);
            }
        },

        _pageUpDown: function (isUp) {
            if (this._isAutoWHMode)
                return;
            var top, endCell, actTop, bottomRow, topRow, fdiff = 0, rowdiff, activeCell = this.getActiveCell(), sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling;
            actTop = sheet._rowHeightCollection[activeCell.rowIndex];
            if ((sheet.rowCount - 1 === sheet._bottomRow.idx && isUp === 1) || ((this._isFrozen(sheet.frozenRows) ? (activeCell.rowIndex > sheet.frozenRows && sheet._ftopRowIdx === sheet.frozenRows) : sheet._topRow.idx === 0) && isUp === -1))
                return;
            bottomRow = sheet._bottomRow.value + sheet.rowsHeightCollection[sheet._bottomRow.idx];
            if (this._isFrozen(sheet.frozenRows)) {
                if(activeCell.rowIndex < sheet.frozenRows && isUp === 1)
                    actTop = sheet._rowHeightCollection[sheet.frozenRows];
                fdiff = (isUp === 1) ? (this._getRowOffsetTop(sheet, sheet.frozenRows)) : this._getIdxWithOffset(sheet._ftopRowIdx, null, false, ["freeze"]).yOffset;
            }
            topRow = isUp * (bottomRow - (fdiff ? fdiff : sheet._topRow.value));
            top = (actTop + topRow) > 0 ? (actTop + topRow) : 0;
            if (fdiff) {
                if ((isUp === 1)) {
                    rowdiff = (activeCell.rowIndex > sheet._ftopRowIdx) ? this._getIdxWithOffset(activeCell.rowIndex).yOffset - sheet._frozenHeight : 0;
                    if (activeCell.rowIndex < sheet.frozenRows)
                        this._scrollContent({ 'y': isUp * ((bottomRow - sheet.rowsHeightCollection[sheet._bottomRow.idx]) - fdiff) + 1 });
                    else
                        this._scrollContent({ 'y': (this._getIdxWithOffset(sheet._bottomRow.idx, null, false, ["freeze"]).yOffset - sheet._frozenHeight) }, true);
                    top = this._getIdxWithOffset(sheet._ftopRowIdx).yOffset + rowdiff;
                }
                else {
                    rowdiff = (activeCell.rowIndex > sheet._ftopRowIdx) ? this._getIdxWithOffset(activeCell.rowIndex).yOffset - sheet._frozenHeight : 0;
                    if (activeCell.rowIndex > sheet.frozenRows && isVirtualScroll)
                        this._scrollContent({ 'y': (fdiff - (bottomRow - sheet.rowsHeightCollection[sheet._bottomRow.idx]) + 1) }, true);
                    else 
                        this._scrollContent({ 'y': ((top + sheet.rowsHeightCollection[sheet._bottomRow.idx]) - sheet._frozenHeight + 1) }, true);
                    top = this._getIdxWithOffset(sheet._ftopRowIdx).yOffset + rowdiff;
                }
            }
            else
            {
                if (isUp === 1 && this.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal && sheet._bottomRow.value + this.model.rowHeight + sheet._vPortHgt >= sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1])
                    top = sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1];
                else
                    this._scrollContent({ 'y': isUp * (bottomRow - sheet._scrollTop) });
            }
            endCell = this._getIdxWithOffset(top, sheet._colWidthCollection[activeCell.colIndex], true);
            this._setAndSelectActiveCell(endCell.rowIdx, endCell.colIdx);
        },

        _keyboardShortCuts: function (e) {
            if (this.model.allowEditing && this.XLEdit._isEdit || (this.model.allowComments && this.XLComment._isCommentEdit && e.keyCode !== 27)) //!Esc key
                return false;
            var activeCell, startCell, endCell, xlFormat = this.XLFormat, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), selCells = sheet._selectedCells, protect = false;
            if (this.model.allowLockCell && sheet.isSheetProtected)
                protect = true;
            if (!e.ctrlKey && !e.shiftKey) {
                switch (e.keyCode) {
                    case 33:  // PAGE UP
                        e.preventDefault();
                        this._pageUpDown(-1);
                        break;
                    case 34:  // PAGE DOWN
                        e.preventDefault();
                        this._pageUpDown(1);
                        break;
                    case 36: // HOME
                        e.preventDefault();
                        this._setAndSelectActiveCell(this.getActiveCell(sheetIdx).rowIndex, this._isFrozen(sheet.frozenColumns) ? sheet._frozenColumns - 1 : 0,"Home");
                        break;
                }
            }
            if (e.ctrlKey && !e.shiftKey) {
                if (!this.element.find("#" + this._id + "_Ribbon .e-ribbonbackstagepage").is(":visible")) {
                    switch (e.keyCode) {
                        case 65:  // Ctrl + A
                            e.preventDefault();
                            if (this.model.allowSelection) {
                                activeCell = this.getActiveCellElem();
                                this.selectAll();
                                !ej.isNullOrUndefined(this.XLCellNav) && this.XLCellNav._updateActiveCell($(activeCell[0]).closest('tr').index(), activeCell[0].cellIndex, { keyCode: e.keyCode });
                                if (this.model.allowAutoFill)
                                    this.XLDragFill.positionAutoFillElement();
                            }
                            break;
                        case 66:  // Ctrl + B
                            e.preventDefault();
                            if (!protect)
                                this._toggleFontPrpty("bold");
                            break;
                        case 68: // Ctrl + D
                        case 82: // Ctrl + R
                            e.preventDefault();
                            if (this.model.allowAutoFill)
                                this.XLDragFill._fillRange(e.keyCode === 68);
                            break;
                        case 73: // Ctrl + I
                            e.preventDefault();
                            if (!protect)
                                this._toggleFontPrpty("italic");
                            break;
                        case 75: // Ctrl + K  
                            e.preventDefault();
                            if (this.model.allowHyperlink && !protect)
                                this._showDialog(this._id + "_Ribbon_Insert_Links_Hyperlink");
                            break;
                        case 85: // Ctrl + U
                            e.preventDefault();
                            if (!protect)
                                this._toggleFontPrpty("underline");
                            break;
                        case 32: // Ctrl + space
                            e.preventDefault();
                            if (!this.model.allowSelection)
                                return;
                            var sColIdx = selCells[0].colIndex, eColIdx = selCells[selCells.length - 1].colIndex;
                            startCell = { rowIndex: 0, colIndex: sColIdx }, endCell = { rowIndex: sheet.rowCount - 1, colIndex: eColIdx };
                            this.model.allowSelection && this.XLSelection.selectRange(startCell, endCell);
                            sheet._startCell = startCell;
                            sheet._endCell = endCell;
                            sheet._isColSelected = true;
                            !ej.isNullOrUndefined(this.XLCellNav) && this.XLCellNav._updateActiveCell(selCells[0].rowIndex, sColIdx);
                            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
                            break;
                        case 35:  // Ctrl + End
                            e.preventDefault();
                            endCell = this._getUsedRangeFromSheet(sheetIdx).endCell;
                            this._setAndSelectActiveCell(endCell.rowIndex, endCell.colIndex, "End");
                            break;
                        case 36:  // Ctrl + Home
                            e.preventDefault();
                            this._setAndSelectActiveCell(this._isFrozen(sheet.frozenRows) ? sheet._frozenRows - 1 : 0, this._isFrozen(sheet.frozenColumns) ? sheet._frozenColumns - 1 : 0, "Ctrl + Home");
                            break;
                        case 49: // Ctrl + 1
                            e.preventDefault();
                            this._showDialog(this._id + "_FormatCells");
                            break;
                        case 53: // Ctrl + 5
                            e.preventDefault();
                            if (!protect)
                                this._toggleFontPrpty("line-through");
                            break;
                        case 56: // Ctrl + 8 
                            if (!e.shiftKey && !protect) {
                                e.preventDefault();
                                this._hideColumn(sheet._startCell.colIndex, sheet._endCell.colIndex);
                            }
                            break;
                        case 57: // Ctrl + 9 
                            if (!e.shiftKey) {
                                e.preventDefault();
                                if (!protect)
                                    this._hideRow(sheet._startCell.rowIndex, sheet._endCell.rowIndex, "isRHide");
                            }
                            break;
                        case 220: // Ctrl + \ 
                            if (!e.shiftKey) {
                                e.preventDefault();
                                if (this.model.allowSearching)
                                    this.XLSearch._applyGotoRowDiff();
                            }
                            break;
                        case 90:
                            e.preventDefault();
                            break;
                        case 89:
                            e.preventDefault();
                            break;
                        case 114://ctrl + f3
                            e.preventDefault();
                            if (this.model.showRibbon && !protect)
                                this.XLRibbon._openNameManagerDlg();
                            break;
                        case 70: //Ctrl + F
                            e.preventDefault();
                            this._showDialog(this._id + "_Ribbon_Others_Editing_FindSelect");
                            $("#" + this._id + "_FRDialog").ejDialog("open");
                            this.XLRibbon._refreshFRDlg();
                            $("#" + this._id + "_FRDialog_FPDlgTab").ejTab("option", "selectedItemIndex", 0);
                            break;
                        case 71: //Ctrl + G
                            e.preventDefault();
                            this._showDialog(this._id + "_Ribbon_Others_Editing_FindSelect");
                            $("#" + this._id + "_GoDialog").ejDialog("open");
                            $("#" + this._id + "_GoToDlgTab").ejTab("option", "selectedItemIndex", 0);
                            break;
                        case 72: //Ctrl + H
                            e.preventDefault();
                            this._showDialog(this._id + "_Ribbon_Others_Editing_FindSelect");
                            $("#" + this._id + "_FRDialog").ejDialog("open");
                            this.XLRibbon._refreshFRDlg();
                            $("#" + this._id + "_FRDialog_FPDlgTab").ejTab("option", "selectedItemIndex", 1);
                            break;
                    }
                }
                switch (e.keyCode) {
                    case 80: // Ctrl + P
                        e.preventDefault();
                        this.XLPrint.printSheet();
                        break;
                    case 79: //Ctrl + O
                        e.preventDefault();
                        if (this.model.allowImport) {
                            if (this.model.importSettings.importMapper.length < 1) {
                                this._showAlertDlg("Alert", "ImportExportUrl", "", 266);
                                return;
                            }
                            else if (this.isDirty && this._browserDetails.name !== "msie")
                                this._showAlertDlg("", "ImportAlert", "Open", 470, 135);
                            else
                                $("#" + this._id + "_file .e-uploadinput").click();
                        }
                        break;
                    case 83: //Ctrl + S
                        e.preventDefault();
                        this.model.exportSettings.allowExporting && this.XLExport["export"]("Excel");
                        break;
                }
            }
            if (e.ctrlKey && e.shiftKey) //Ctrl + Shift
            {
                if (!this.element.find("#" + this._id + "_Ribbon .e-ribbonbackstagepage").is(":visible")) {
                    if (this._browserDetails.name === "mozilla" && e.keyCode === 173)   // keycode for ( _ ) is 173 in firefox
                        e.keyCode = 189;
                    switch (e.keyCode) {
                        case 192:  // Ctrl + Shift + ~
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "general" });
                            break;
                        case 52:  // Ctrl + Shift + $
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "currency" });
                            break;
                        case 53:  // Ctrl + Shift + %
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "percentage" });
                            break;
                        case 54:  // Ctrl + Shift + ^
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "scientific" });
                            break;
                        case 51:  // Ctrl + Shift + #
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "shortdate" });
                            break;
                        case 50: // Ctrl + Shift + @
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "time" });
                            break;
                        case 49:  // Ctrl + Shift + ! 
                            e.preventDefault();
                            if (!protect)
                                xlFormat.format({ "type": "number" });
                            break;
                        case 55: // Ctrl + Shift + &    
                            e.preventDefault();
                            if (this.model.allowCellFormatting && this.model.formatSettings.allowCellBorder && !protect)
                                this.XLFormat.applyBorder({ top: '1px solid #000000', right: '1px solid #000000', bottom: '1px solid #000000', left: '1px solid #000000' });
                            break;
                        case 189: // Ctrl + Shift + _
                            e.preventDefault();
                            if (this.model.allowCellFormatting && this.model.formatSettings.allowCellBorder && !protect)
                                this.XLFormat.applyBorder('noborder');
                            break;
                        case 73: // Ctrl + Shift + I   
                            e.preventDefault();
                            if (this.model.allowInsert && !protect)
                                this._showDialog(this._id + "_Ribbon_Others_Cells_InsertCellOptions");
                            break;
                        case 68: // Ctrl + Shift + D 
                            e.preventDefault();
                            if (this.model.allowDelete && !protect)
                                this._showDialog(this._id + "_Ribbon_Others_Cells_DeleteCellOptions");
                            break;
                        case 113: // Ctrl + Shift + F2
                            e.preventDefault();
                            var rObj = $('#' + this._id + '_Ribbon').data('ejRibbon');
                            if (this.model.showRibbon) {
                                if (rObj._isCollapsed) {
                                    rObj.expand();
                                    rObj._removeRibbonPin();
                                }
                                else rObj.collapse();
                            }
                            break;
                        case 56: // Ctrl + Shift + 8  
                            e.preventDefault();
                            if (!protect && this.model.allowSelection)
                                this._showColumn(selCells[0].colIndex, selCells[selCells.length - 1].colIndex);
                            break;
                        case 57: // Ctrl + Shift + 9   
                            e.preventDefault();
                            if (!protect && this.model.allowSelection)
                                this._showRow(selCells[0].rowIndex, selCells[selCells.length - 1].rowIndex, "isRHide");
                            break;
                        case 79: // Ctrl + Shift + O
                            e.preventDefault();
                            this.XLSearch._applyGotoComments();
                            break;
                        case 220: // Ctrl + Shift + | 
                            e.preventDefault();
                            this.XLSearch._applyGotoColDiff();
                            break;
                        case 36: //Ctrl + Shift + Home
                            e.preventDefault();
                            endCell = this.getActiveCell(sheetIdx);
                            this._selectActiveCell(0, 0, endCell, 'Ctrl + Shift + Home');
                            break;
                    }
                }
            }
            else if (e.shiftKey) {
                if (e.keyCode === 32) {  // Shift + space           
                    e.preventDefault();
                    if (this.model.allowSelection) {
                        var sRowIdx = selCells[0].rowIndex, eRowIdx = selCells[selCells.length - 1].rowIndex;
                        startCell = { rowIndex: sRowIdx, colIndex: 0 }, endCell = { rowIndex: eRowIdx, colIndex: sheet.colCount - 1 };
                        this.XLSelection.selectRange(startCell, endCell);
                        sheet._startCell = startCell;
                        sheet._endCell = endCell;
                        sheet._isRowSelected = true;
                        !ej.isNullOrUndefined(this.XLCellNav) && this.XLCellNav._updateActiveCell(sRowIdx, selCells[0].colIndex);
                        this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
                    }
                }
                else if (e.keyCode === 113) {  // Shift + F2
                    this._dupDetails = true;
                    e.preventDefault();
                    activeCell = this.getActiveCellElem();
                    if (this.model.allowComments && !protect){
                        this._isRibbonClick = true;
                        activeCell.hasClass("e-commentcell") ? this.XLComment.editComment() : this.XLComment.setComment();
						this._isRibbonClick = false;
					}
                    this._dupDetails = false;
                }
                else if (e.keyCode === 122) {  // Shift + F11    
                    e.preventDefault();
                    this.addNewSheet();
                }
            }
            else if (e.keyCode === 27) { // Esc
                if (this.model.allowComments && this.XLComment._isCommentEdit) {
                    this.XLComment._updateCurCmntVal();
                    this.XLComment._updateCmntRibIcons();
                }
                if (this.model.allowContextMenu)
                    if (this.XLCMenu._isMenuOpened || $("#" + this._id + "_contextMenuColumnHeader").is(":visible") || $("#" + this._id + "_contextMenuRowHeader").is(":visible"))
                        this.XLCMenu.hideCMenu();
                if (this.model.allowFiltering)
                    if (this._excelFilter && this._excelFilter._openedFltr && $(this._excelFilter._openedFltr).is(":visible")) {
                        var mObj = this._excelFilter._menuWrap.data("ejMenu");
                        if (mObj.element.find(".e-mhover li:visible").length) {
                            if (!mObj._isContextMenuOpen)
                                mObj._closeMenu();
                            return;
                        }
                        this.XLFilter._isSearchEdit = false;
                        this._excelFilter.closeXFDialog();
                    }
                this.setSheetFocus();
            }
            else if (e.altKey) {
                if (e.keyCode === 112 && this.model.showRibbon && this.model.allowCharts && !protect)//alt +f1-Create chart
                {
                    e.preventDefault();
                    this.XLChart.createChart(null, { type: "column", enable3D: false, marker: { visible: false } });
                }
                else if (e.keyCode === 84 && this.model.showRibbon && !this.XLRibbon._isDirtySelect && !protect && this.model.allowFormatAsTable)//alt+T-create a table
                {
                    this._showDialog(this._id + "_Ribbon_Insert_Tables_Table");
                    e.preventDefault();
                    this.XLRibbon._openFATDlg();
                }
            }
        },

        _triggerTBtnClick: function (id) {
            var btnObj = $('#' + id).data("ejToggleButton");
            btnObj.buttontag.click();
        },

        _toggleFontPrpty: function (type) {
            var actCell = this.getActiveCell(), xlFormat = this.XLFormat, style = { "style": {} }, formatCode, fontPrpty, format, id;
            formatCode = this.XLEdit.getPropertyValue(actCell.rowIndex, actCell.colIndex, "format");
            format = !this.isUndefined(formatCode) && this.XLFormat.getFormatFromHashCode(formatCode);
            if (type === "bold")
                fontPrpty = "font-weight";
            else if (type === "italic")
                fontPrpty = "font-style";
            else
                fontPrpty = "text-decoration";
            id = type.charAt(0).toUpperCase() + type.slice(1).toLowerCase();
            if (id === "Line-through")
                id = "StrikeThrough";
            if (format[fontPrpty] === type) {
                this.model.showRibbon && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).length && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).ejToggleButton("option", "toggleState", false);
                style.style[fontPrpty] = "none";
            }
            else if (fontPrpty === "text-decoration" && (format[fontPrpty] === "underline" || format[fontPrpty] === "line-through")) {
                this.model.showRibbon && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).length && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).ejToggleButton("option", "toggleState", true);
                style.style[fontPrpty] = (format[fontPrpty] === "underline") ? type + " " + format[fontPrpty] : format[fontPrpty] + " " + type;
            }
            else if (fontPrpty === "text-decoration" && (format[fontPrpty] === "line-through underline" || format[fontPrpty] === "underline line-through")) {
                this.model.showRibbon && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).length && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).ejToggleButton("option", "toggleState", false);
                format[fontPrpty] = format[fontPrpty].split(" ").join("");
                style.style[fontPrpty] = format[fontPrpty].replace(type, "");
            }
            else {
                this.model.showRibbon && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).length && this.element.find("#" + this._id + "_Ribbon_Home_Font_" + id).ejToggleButton("option", "toggleState", true);
                style.style[fontPrpty] = type;
            }
            xlFormat.format(style);
        },

        _getLocStr: function (prop) {
            return this.localizedLabels[prop];
        },

        _checkIndicesInContainer: function (sheetIdx, rowIdx, colIdx, property) {
            var sheets = this._dataContainer.sheets;
            if (sheetIdx in sheets && rowIdx in sheets[sheetIdx] && colIdx in sheets[sheetIdx][rowIdx]) {
                if (property) {
                    if (property in sheets[sheetIdx][rowIdx][colIdx])
                        return true;
                    else
                        return false;
                }
                else
                    return true;
            }
            return false;
        },

        //Text Wrapping
        _textFormatting: function (operation) {
            switch (operation) {
                case 'wrapText':
                    var wrapToggle = $("#" + this._id + "_Ribbon_Home_Alignment_WrapText").data("ejToggleButton");
                    if (wrapToggle)
                        this.setWrapText(wrapToggle.model.toggleState ? "wrap" : "unwrap", null);
                    break;
            }
        },

        wrapText: function (range) {
            if (!this.model.allowWrap || this.model.isReadOnly)
                return;
            this.setWrapText("wrap", range);
        },

        unWrapText: function (range) {
            if (!this.model.allowWrap || this.model.isReadOnly)
                return;
            this.setWrapText("unwrap", range);
        },

        setWrapText: function (operation, range) {
            if (!this.model.allowWrap || this.model.isReadOnly)
                return;
            var selCell, rge, cell, sheetIdx = this.getActiveSheetIndex(), mergeWrap, wRowIdx, wColIdx, sheet = this.getSheet(sheetIdx), cellheight = 0, cellHt, rowHt = this.model.rowHeight, filterIcon, rowColl = this.getRows(sheetIdx), rows = rowColl[1], rowhdrrows = rowColl[0], aRange, j,
                rowHtColl = sheet.rowsHeightCollection, colWtColl = sheet.columnsWidthCollection, rowHt = 0, colWt = 0, wrapHtColl = sheet._wrapHtCollection, isWrap = false, rowIdx, isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, clrWrap = sheet._clrWrapColl, selLastCell;
            rge = this._getRangeArgs(range, "object");
            selCell = this._getSelectedCells(sheetIdx, rge).selCells;
            if (selCell.length === 0)
                return;
            else if (selCell.length > 1)
                aRange = this._getProperAlphaRange(sheetIdx, selCell[0].rowIndex, selCell[0].colIndex, selCell[selCell.length - 1].rowIndex, selCell[selCell.length - 1].colIndex)
            else
                aRange = this._getAlphaRange(sheetIdx, selCell[0].rowIndex, selCell[0].colIndex, selCell[selCell.length - 1].rowIndex, selCell[selCell.length - 1].colIndex);
            for (var i = 0, len = selCell.length; i < len; i++) {
                rowIdx = isVirtualScroll ? this._getRowIdx(selCell[i].rowIndex) : selCell[i].rowIndex;
                selLastCell = selCell[selCell.length - 1]; // Last cell of selected range. 
                isWrap = this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, "wrap");
                if (!this._isPaste && ((operation === "unwrap" && !isWrap) || (operation === "wrap" && isWrap)))
                    continue;
                if (operation === "unwrap" && isWrap) {
                    (!this._isUndoRedo) && clrWrap.push({ rowIdx: selCell[i].rowIndex, colIdx: selCell[i].colIndex });
                    if (this._isRowViewable(sheetIdx, selCell[i].rowIndex)) {
                        cell = this.getCell(selCell[i].rowIndex, selCell[i].colIndex);
                        if (this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, "merge") && !this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, "cellType")) {
                            mergeWrap = cell.find('#' + this._id + '_MergeWrap');
                            if (mergeWrap.length) {
                                cell[0].innerHTML = mergeWrap[0].innerHTML;
                                mergeWrap.remove();
                            }
                        }
                        wRowIdx = selCell[i].rowIndex; wColIdx = selCell[i].colIndex;
                        if (cell)
                            this._removeClass(cell[0], "e-sswraptext");
                        this._removeClass(rowhdrrows[wRowIdx], "e-sswraprow");
                        if (this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, "altTxt"))
                            this.addClass(cell[0], "e-alt-unwrap");
                        if (wRowIdx in sheet._wrapColl)
                            if (wColIdx in sheet._wrapColl[wRowIdx]) {
                                delete sheet._wrapColl[wRowIdx][wColIdx];
                                cellHt = ej.max(this._getObjectValues(sheet._wrapColl[wRowIdx]));
                                if (sheet._formatColl[wRowIdx] && sheet._formatColl[wRowIdx][wColIdx] && (cellHt < sheet._formatColl[wRowIdx][wColIdx]))
                                    cellHt = sheet._formatColl[wRowIdx][wColIdx];
                                !this.getObjectLength(sheet._wrapColl[wRowIdx]) && delete sheet._wrapColl[wRowIdx];
                            }
                        if (cell.find(".e-filterspan").length > 0) {
                            filterIcon = cell.find(".e-filterspan");
                            this.model.allowFiltering && this.XLFilter._postionFilterIcon(cell, filterIcon);
                        }
                    }
                    this.XLEdit._clearDataContainer({ cellIdx: selCell[i], property: ["wrap"] });
                    this.XLEdit._clearDataContainer({ cellIdx: { rowIndex: selCell[i].rowIndex, colIndex: 0 }, property: ["wrapRow"] });
                    this.XLEdit._clearDataContainer({ cellIdx: { rowIndex: 0, colIndex: selCell[i].colIndex }, property: ["wrapCol", "wrapWidth"] });
                    cellheight = this._getWrapCellHeight(sheetIdx, selCell[i].rowIndex, selCell[i].colIndex, cellHt);
                    this._textClip(selCell[i].rowIndex, selCell[i].colIndex, 'add');
                }
                else if (operation === "wrap" && !isWrap) {
                    if (this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, 'isFilterHeader'))
                        continue;
                    this._textClip(selCell[i].rowIndex, selCell[i].colIndex, 'delete');
                    this._wrapCollection(selCell[i].rowIndex, selCell[i].colIndex, rowHtColl[selCell[i].rowIndex], sheetIdx);
                    this.XLEdit._updateDataContainer({ rowIndex: selCell[i].rowIndex, colIndex: selCell[i].colIndex }, { dataObj: { wrap: true } });
                    if (this._isRowViewable(sheetIdx, selCell[i].rowIndex)) {
                        cell = this.getCell(selCell[i].rowIndex, selCell[i].colIndex);
                        if ((cell.is(":visible") || this._isPaste) && (this.model.allowResizing && !this.XLResize._preventRowResize(selCell[i].rowIndex))) {
                            this.addClass(cell[0], "e-sswraptext");
                            if (this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, "altTxt"))
                                this._removeClass(cell[0], "e-alt-unwrap");
                            if (cell.find(".e-filterspan").length > 0) {
                                filterIcon = cell.find(".e-filterspan");
                                this.model.allowFiltering && this.XLFilter._postionFilterIcon(cell, filterIcon);
                            }
                        }
                    }
                    cellheight = this._getWrapCellHeight(sheetIdx, selCell[i].rowIndex, selCell[i].colIndex);
                    (cellheight.rowHt < rowHt) && (cellheight.rowHt = rowHt);
                    rowHt = cellheight.rowHt;
                    this._wrapCollection(selCell[i].rowIndex, selCell[i].colIndex, cellheight.cellHt, sheetIdx);
                    this.XLEdit._updateDataContainer({ rowIndex: selCell[i].rowIndex, colIndex: selCell[i].colIndex }, { dataObj: { wrap: true } });
                    wrapHtColl[selCell[i].rowIndex] = (i > 0 && (selCell[i].rowIndex === selCell[i - 1].rowIndex)) ? wrapHtColl[selCell[i - 1].rowIndex] : wrapHtColl[selCell[i].rowIndex] = rowHtColl[selCell[i].rowIndex];
                    if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(selCell[i].rowIndex, 0, "wrapCol")))
                        this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: selCell[i].colIndex }, { dataObj: { wrapCol: true, wrapWidth: this.getSheet(sheetIdx).columnsWidthCollection[selCell[i].colIndex] } });
                }
                if (cellheight.rowHt > 0) {
                    if (selCell[i].colIndex === rge[3] || this.XLEdit.getPropertyValue(selCell[i].rowIndex, selCell[i].colIndex, "merge")) {
                        this.setHeightToRows([{ rowIndex: selCell[i].rowIndex, height: cellheight.rowHt }]);
                        rowHt = 0;
                    if(operation === 'wrap' && !isWrap)
						if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(selCell[i].rowIndex, 0, "wrapRow")))
							this.XLEdit._updateDataContainer({ rowIndex: selCell[i].rowIndex, colIndex: 0 }, { dataObj: { wrapRow: true } });
                    }
                }
                if (this.model.allowFreezing)
                {
                    this.XLFreeze._refreshFRowResize(selCell[i].rowIndex);
                    this.XLFreeze._refreshSelection();
                }
                (selCell[i].colIndex === rge[3]) && (rowHt = 0);
                cellheight = 0;
            }
            if (this.model.allowComments)
                this.XLComment._updateCmntArrowPos(); //Comments position update
            if (this.model.scrollSettings.allowScrolling)
                this.XLScroll._getRowHeights(sheetIdx, selCell[0].rowIndex + 1);
            if (!sheet._isImported || sheet._isLoaded) {
                var details = { sheetIndex: sheetIdx, selectedCell: selCell, reqType: "textwrap", operation: operation, range: aRange };
                if (this.model.scrollSettings.allowScrolling)
                    this.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
                this.model.allowSelection && this.XLSelection._refreshBorder();
                if (!this._isUndoRedo && !this._dupDetails) {
                    this._completeAction(details);
                    this._trigActionComplete(details);
                }
            }
        },

        _getWrapCellHeight: function (sheetIdx, rowIdx, colIdx, cellHeight) {
            var j, merge, rowHt = 0, colWt = 0, cellHt, sheet = this.getSheet(sheetIdx), rowHtColl = sheet.rowsHeightCollection, colWtColl = sheet.columnsWidthCollection;
            merge = this.XLEdit.getPropertyValue(rowIdx, colIdx, "merge");
            rowHt = rowHtColl[rowIdx];
            colWt = colWtColl[colIdx];
            if (merge) {
                for (j = rowIdx + 1; j < rowIdx + merge.mSpan.rowSpan; j++)
                    rowHt = rowHt + rowHtColl[j];
                for (j = colIdx + 1; j < colIdx + merge.mSpan.colSpan; j++)
                    colWt = colWt + colWtColl[j];
            }
            if (merge) {
				rowHt = this._getRowHeight(rowIdx, sheetIdx);
				cellHt = cellHeight ? cellHeight : rowHt;
			}
            else {
				cellHt = cellHeight ? cellHeight : this._detailsFromGlobalSpan(rowIdx, colIdx, "height", this.XLEdit.getPropertyValue(rowIdx, colIdx, "value2"), colWt);
                cellHt = cellHt < this.model.rowHeight ? this.model.rowHeight : cellHt;
				rowHt = cellHt;
			}
            return { cellHt: cellHt, rowHt: rowHt };
        },

        _wrapCollection: function (rowIdx, colIdx, cheight, sIdx) {
            var sheet = this.getSheet(sIdx ? sIdx : this.getActiveSheetIndex());
            !sheet._wrapColl[rowIdx] && (sheet._wrapColl[rowIdx] = {});
            if (this.getObjectLength(sheet._wrapColl[rowIdx]) > -1)
                sheet._wrapColl[rowIdx][colIdx] = cheight;
            if (sheet.rowsHeightCollection[rowIdx] < cheight && !this._isInMrgeRnge(rowIdx, colIdx, !sheet._isLoaded)) {
                sheet.rowsHeightCollection[rowIdx] = cheight;
                if (this.model.scrollSettings.allowScrolling)
                    this.XLScroll._getRowHeights(sIdx, rowIdx, true);
                this._getRowHdrTBody(sIdx).find('tr[idx="' + rowIdx + '"]').height(cheight);
            }
        },
         
        _isInMrgeRnge: function (rIdx, cIdx, isOnImport) {
            if (!isOnImport)
                return this.XLEdit.getPropertyValue(rIdx, cIdx, "merge");
            var i, range, sheetIdx = this._getSheetIndex(), mergedCells = this._impData ? this._impData.model.sheets[sheetIdx].mergedCells : [];
            !mergedCells && (mergedCells = []);
            for (i = 0; i < mergedCells.length; i++) {
                range = this.getRangeIndices(mergedCells[i]["range"]);
                if (range[0] <= rIdx && range[2] >= rIdx) {
                    if (range[1] <= cIdx && range[3] >= cIdx) {
                        return true;
                    }
                }
            }
            return false;
        },

        _setWrapHeight: function (sheetIdx, rowIdx, detachedRows, rowHdrs, emptyTable, status) {
            var rHt, newRow, tr = detachedRows[rowIdx], sheet = this.getSheet(sheetIdx), rowHtColl = sheet.rowsHeightCollection;
            if (rowHtColl[rowIdx] > 0)
                rHt = rowHtColl[rowIdx];
            else {
                if (sheet.hideRowsCollection.indexOf(rowIdx) === -1 || status === "visible") {
                    newRow = $(detachedRows[rowIdx].outerHTML).attr("id", "ss");
                    emptyTable[0].insertBefore(newRow[0], emptyTable[0].childNodes[0]);
                    rHt = emptyTable[0].rows[0].getBoundingClientRect().height;
                    emptyTable[0].rows[0].parentNode.removeChild(emptyTable[0].rows[0]);
                }
            }
            rHt = rHt < 20 ? 20 : rHt;
            if (parseInt(tr.style.height) < rHt) {
                tr.style.height = rHt + "px";
                $(rowHdrs[rowIdx])[0].style.height = rHt + "px";
                sheet.rowsHeightCollection[rowIdx] = rHt;
            }
        },

        _setRowHdrHeight: function (sheetIdx, rowIdx) {
            var dupRowIdx = this._getRowIdx(rowIdx), isIntrnlReq, ht;
            var sheet = this.getSheet(sheetIdx), rows = this.getRows(sheetIdx), height = sheet.rowsHeightCollection[rowIdx];
            if (this._isRowViewable(sheetIdx, rowIdx)) {
				ht = parseInt(rows[0][dupRowIdx].style.height);
				if (ht != height) {
				    rows[0][dupRowIdx].style.height = height + "px";
				    if (this.model.allowSelection) {
				        isIntrnlReq = this._intrnlReq;
				        this._intrnlReq = true;
				        this.XLSelection.refreshSelection();
				        if (sheet._isFreezed)
				            this.XLFreeze._refreshSelection();
				        this._intrnlReq = isIntrnlReq;
				    }
				    if ((!sheet._isImported || sheet._isLoaded) && this.model.allowAutoFill)
				        this.XLDragFill.positionAutoFillElement();
				}
			}
        },

        _refreshRangeTRHght: function (sheetIdx, range) {
            var i, sIdx = range[0] < 1 ? range[0] : range[0] - 1, sheet = this.getSheet(sheetIdx); // - 1 for border refresh
            for (i = sIdx; i <= range[2]; i++)
                this._setRowHdrHeight(sheetIdx, i);
            this.XLScroll._getRowHeights(sheetIdx, sIdx);
            if (!sheet._isImported || sheet._isLoaded)
                this.model.allowSelection && this.XLSelection._refreshBorder();
        },

        //Alert Dialog
        _renderAlertdlg: function () {
            var alertokBtn, alertbtndiv, confirmbtndiv, okCanButton, parent, str, cntrDiv = "<div class='e-dlg-btnctnr' id=", dlgId = this._id + "_alertdlg",
                opts = { text: this._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._alertOkClick, this), enabled: true , cssClass: "e-ss-okbtn"};
            if (document.getElementById(this._id + '_alertdlg'))
                return;
            okCanButton = "<input id=" + this._id + "_dialog_Ok ></input><input id=" + this._id + "_dialog_Can style= 'margin-left: 10'; ></input>";
            alertokBtn = "<input id=" + this._id + "_dialog_alertOk > </input>";
            confirmbtndiv = cntrDiv + dlgId + "_condiv >" + okCanButton + "</div>";
            alertbtndiv = cntrDiv + dlgId + "_alertdiv >" + alertokBtn + "</div>";
            str = "<div class='e-alertdlgcontent' id=" + dlgId + "_dlgcontent > </div>";
            str = str + "<div class='e-dlg-btnfields' id=" + dlgId + "_dlgbtncontent >" + confirmbtndiv + alertbtndiv + "</div>";
            parent = $("<div id=" + dlgId + " class='e-alertdlg' style= 'display : none;'>" + str + "</div>");
            this.element[0].appendChild(parent[0]);
            $("#" + this._id + "_dialog_alertOk").ejButton(opts);
            $("#" + this._id + "_dialog_Ok").ejButton(opts);
            $("#" + this._id + "_dialog_Can").ejButton({ text: this._getLocStr("Cancel"), showRoundedCorner: true, width: 60, click: ej.proxy(this._alertCanClick, this) });
        },

        alert: function (statusText) {
            var alertDlg = $("#" + this._id + "_alertdlg");
            this._renderAlertDlgContent(alertDlg, "Alert", statusText);
            alertDlg.ejDialog("open");
        },

        _renderAlertDlgContent: function ($dlg, type, content, targetName, dlgWidth, className) {
            var contentdiv = $dlg.find("#" + this._id + "_alertdlg_dlgcontent");
            var confirmdiv = $dlg.find("#" + this._id + "_alertdlg_condiv");
            var alertdiv = $dlg.find("#" + this._id + "_alertdlg_alertdiv");
            if (this._tabMode || this._phoneMode) {
                if (dlgWidth > (this._responsiveWidth / 1.2))
                    dlgWidth = (this._responsiveWidth / 1.2);
            }
            else
                dlgWidth = dlgWidth || 400;
            className = className || "";
            if (type === "Alert") {
                confirmdiv.hide();
                alertdiv.show();
            }
            else {
                confirmdiv.show();
                alertdiv.hide();
            }
            contentdiv.text("");
            contentdiv.html(content);
            $dlg.ejDialog({ showOnInit: false, enableModal: true, enableResize: false, enableAnimation: false, allowKeyboardNavigation: false, title: this._getLocStr("Title"), width: dlgWidth, height: "auto", minHeight: 0, cssClass: "e-ss-dialog e-" + this._id + "-dlg" + className, open: ej.proxy(this._alertDlgOpen) });
            this._alertDialog = { element: $dlg, action: targetName };
        },

        _alertDlgOpen: function () {
            this.element.find("input:visible:first").focus();
        },

        _alertOkClick: function ($dlg) {
            var shtModel, i = 1, sheetIdx = this.getActiveSheetIndex(), prtctWrkBk, isUndoRedo = this._isUndoRedo;
            this._alertDialog.element.ejDialog("close");
            switch (this._alertDialog.action) {
                case "findPrevComment":
                    this.gotoPage(this.model.sheetCount, false);
                    shtModel = this.model.sheets[this.model.sheetCount];
                    this.XLComment._updateCurrentCell(shtModel.rowCount - 1, shtModel.colCount - 1);
                    this.XLComment.findPrevComment();
                    this._alertDialog.action = null;
                    break;
                case "findNextComment":
                    this.gotoPage(1, false);
                    this.XLComment._updateCurrentCell(0, 0);
                    this.XLComment.findNextComment();
                    this._alertDialog.action = null;
                    break;
                case "sheetRenameActn":
                    $("#" + this._id + "_Sheet_RenamePanel").select().focus();
                    break;
                case "sheetDeleteActn":
                    this._removeSheet(sheetIdx);
                    this._alertDialog.action = null;
                    break;
                case "New":
                    this._isNew = true;
                    this._destroy();
                    this._dataContainer.sheets[i] = {};
                    this.clearUndoRedo();
                    this._updateCellType();
                    this.model.sheetCount = i;
                    this.model.activeSheetIndex = i;
                    this._sheetSettings(i);
                    this._newSIndex++;
                    this._initCSSTag();
                    this.gotoPage(i, false);
                    if (this.model.allowLockCell)
                        this.protectSheet(false);
                    prtctWrkBk = $("#" + this._id + "_Ribbon_Review_Changes_ProtectWorkbook").data("ejToggleButton");
                    if (prtctWrkBk) {
                        prtctWrkBk.option("toggleState", false);
                        this.model.exportSettings.password = null;
                        $("#" + this._id + "_AddSheet").removeClass("e-disable");
                    }
                    this.XLRibbon._toggleFormatTab();
                    this.XLRibbon._toggleChartDesignTab();
                    this.XLRibbon._toggleAnalyzeTab();
                    this._refreshSpreadSheetPager();
                    this.hideWaitingPopUp();
                    this._isNew = false;
                    break;
                case "Open":
                    $("#" + this._id + "_file .e-uploadinput").click();
                    break;
                case "MergeCells":
                    this._mergeCells(sheetIdx, this.model.sheets[sheetIdx]._selectedCells, {}, []);
                    this._alertDialog.action = null;
                    break;
                case "MergeAcrossCells":
                    this._mergeAcrossCells(sheetIdx, this.model.sheets[sheetIdx]._selectedCells);
                    this._alertDialog.action = null;
                    break;
                case "MergeInsertDelete":
                    this._refreshMergeCells();
                    this._alertDialog.action = null;
                    break;
                case "InvalidChartTitleActn":
                    $('#' + this._id + '_chartnamedlg').find("input:first").focus();
                    break;
                case "ConvertToRange":
                    this.XLFormat._convertToRange({});
                    break;
                case "TotalRow":
                    this._isUndoRedo = this._dupDetails = true;
                    this.insertEntireRow(this._insRows.startRow, this._insRows.endRow);
                    this.XLFormat._calculateTotalRow(sheetIdx, null, true, false, true);
                    this._isUndoRedo = isUndoRedo;
                    break;
                case "Drop":
                    var sheet = this.getSheet(sheetIdx);
                    this.XLDragDrop.moveRangeTo([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex], [this._dStartCell.rowIndex, this._dStartCell.colIndex, this._dEndCell.rowIndex, this._dEndCell.colIndex]);
                    sheet._startCell = this._dStartCell;
                    sheet._endCell = this._dEndCell;
                    this._trigger("drop", { sheetIndex: sheetIdx, target: this.XLDragDrop._target, currentCell: this.XLDragDrop._dragAndDropCell, dragAndDropRange: { startCell: sheet._startCell, endCell: sheet._endCell } });
                    break;
                case "FormulaAlert":
                    this.XLEdit._editElem.focus();
                    break;
                case "NMUniqueNameAlert":
                case "NMNameAlert":
                    document.getElementById(this._id + "_nmgridname").focus();
                    break;
                case "NMRangeAlert":
                    document.getElementById(this._id + "_nmgridrefersto").focus();
                    break;
                default:
                    this.setSheetFocus();
                    break;
            }
        },

        _alertCanClick: function () {
            var dlg = this._alertDialog;
            if (dlg.action == "findNextComment" || dlg.action == "findPrevComment")
                $(this.getActiveCellElem()).find('.e-comment-txtarea').css('display', 'inline-table');
            if (dlg.action == "TotalRow" && $("#" + this._id + "_Ribbon_Design_TableStyleOptions_TotalRow").length) {
                this.XLRibbon._isSetModel = true;
                $("#" + this._id + "_Ribbon_Design_TableStyleOptions_TotalRow").data("ejCheckBox").option("checked", false);
                this.XLRibbon._isSetModel = false;
            }
            dlg.element && dlg.element.ejDialog("close");
            switch (dlg.action) {
                case "Drop":
                    var sheet = this.getSheet(this.getActiveSheetIndex());
                    this.performSelection(sheet._startCell, sheet._endCell);
                    break;
            }
            this.hideWaitingPopUp();
        },

        _showAlertDlg: function (type, prop, targetName, dlgWidth, className) {
            var alertDlg = $("#" + this._id + "_alertdlg"), alert = "Alert", text, args = { reqType: "alert", action: targetName };
            if (prop instanceof Array) {
                if (prop[0] === "SheetRenameEmptyAlert")
                    text = "<ul><li>" + this._getLocStr(prop[0]) + "</li><li>" + this._getLocStr(prop[1]) + "</li><li>" + this._getLocStr(prop[2]) + "\\ \/ ? * [" + this._getLocStr("OR") + "  ] </li><li>" + this._getLocStr(prop[3]) + "</li></ul>";
                else if (prop[0] === "ClipboardAccessError")
                    text = this._getLocStr(prop[0]) + "<br /><br />" + this._getLocStr(prop[1]) + "<br />" + this._getLocStr(prop[2]) + "<br />" + this._getLocStr(prop[3]);
            }
            else
                text = (prop.indexOf("T-") === 0) ? prop.slice(2) : this._getLocStr(prop);
            if (this._trigActionBegin(args)) {
                this._alertDialog.action = targetName;
                this._alertCanClick();
                return;
            }
            if (type === alert)
                this._renderAlertDlgContent(alertDlg, alert, text, targetName, dlgWidth, className);
            else
                this._renderAlertDlgContent(alertDlg, "", text, targetName, dlgWidth, className);
            alertDlg.ejDialog("open");
        },

        _isSheetsDirty: function () {
            var i = 1, sheets = this._dataContainer.sheets, len = this.getObjectLength(sheets) + 1;
            if (this.model.nameManager.length || this.getObjectLength(sheets) > 1)
                return true;
            while (i < len) {
                if (this.getObjectLength(sheets[i]))
                    return true;
                i++;
            }
            return false;
        },

        getCell: function (rowindex, columnindex, sheetIdx) {
            var index = 0, sheetIdx = this._getSheetIndex(sheetIdx), sheet = this.getSheet(sheetIdx);
            if (this.model.scrollSettings.allowVirtualScrolling) {
                index = 1;
                rowindex = this._getRowIdx(rowindex, sheetIdx);
                if (rowindex === -1)
                    return null;
            }
            if ((this.isImport || sheet._isImported || this._isPrint) && this._detachTable)
                return $(this._detachTable[0].tBodies[index].rows[rowindex].cells[columnindex]);
            else {
                if (this._getContTBody(sheetIdx))
                    return $(this._getContTBody(sheetIdx)[0].rows[rowindex].cells[columnindex]);
                else
                    return null;
            }
        },

        getRange: function (range, sheetIdx, skipHiddenRow) {
            range = this._getRangeArgs(range, "object", sheetIdx);
            var startRIndex = range[0], startCIndex = range[1], endRIndex = range[2], endCIndex = range[3], i, rowIdx, rows,
                rowCells, temp, len, tempCells, cells = [], sheetIdx = this._getSheetIndex(sheetIdx), sheet = this.getSheet(sheetIdx);
            if ((this.isImport || sheet._isImported) && this._detachTable)
                rows = $(this._detachTable[0].tBodies[1].rows);
            else
                rows = $(this._getContTBody(sheetIdx)[0].rows);
            if (startRIndex > endRIndex) {
                temp = startRIndex;
                startRIndex = endRIndex;
                endRIndex = temp;
            }
            if (startCIndex > endCIndex) {
                temp = startCIndex;
                startCIndex = endCIndex;
                endCIndex = temp;
            }
            if (this.model.scrollSettings.allowVirtualScrolling) {
                for (i = startRIndex; i <= endRIndex; i++) {
                    rowIdx = this._getRowIdx(i);
                    if (rowIdx > -1) {
                        rowCells = $(rows[rowIdx].cells);
                        tempCells = (endCIndex === startCIndex) ? [rowCells[endCIndex]] : this._browserDetails.version === "8.0" ? rowCells.slice(startCIndex, endCIndex + 1).toArray() : rowCells.slice(startCIndex, endCIndex + 1);
                        ej.merge(cells, tempCells);
                    }
                }
            }
            else {
                rows = (endRIndex !== startRIndex) ? rows.slice(startRIndex, endRIndex + 1) : rows.eq(endRIndex);
                len = rows.length;
                for (i = 0; i < len; i++) {
                    if (!skipHiddenRow || !this._isHiddenRow(i, sheetIdx)) {
                        rowCells = $(rows[i].cells);
                        tempCells = (endCIndex === startCIndex) ? [rowCells[endCIndex]] : this._browserDetails.version === "8.0" ? rowCells.slice(startCIndex, endCIndex + 1).toArray() : rowCells.slice(startCIndex, endCIndex + 1);
                        ej.merge(cells, tempCells);
                    }
                }
            }
            return $(cells);
        },

        getRangeIndices: function (range) {
            range = range.indexOf(":") === -1 ? range + ":" + range : range;
            var rangeIndex = range.split(":"), rangeData, cells = [];
            rangeData = rangeIndex[0].split(/[A-Z]/i);
            cells.push(parseInt(rangeData[rangeData.length - 1]) - 1);
            cells.push(this._generateColCount(rangeIndex[0].split(/[0-9]/)[0].toUpperCase()) - 1);
            rangeData = rangeIndex[1].split(/[A-Z]/i);
            cells.push(parseInt(rangeData[rangeData.length - 1]) - 1);
            cells.push(this._generateColCount(rangeIndex[1].split(/[0-9]/)[0].toUpperCase()) - 1);
            this.swapRange(cells);
            return cells;
        },

        swapRange: function (cells) {
            if (cells[0] > cells[2])
                ej.dataUtil.swap(cells, 0, 2);
            if (cells[1] > cells[3])
                ej.dataUtil.swap(cells, 1, 3);
            return cells;
        },

        updateRange: function (sheetIdx, rangeSettings) {
            if (this.model.isReadOnly)
                return;
            var i, r, len, obj, cont, rangeData, startCell, rangeCells, contTable, range = [], data = [], dataSource = rangeSettings.dataSource,
                rowCount = dataSource.length, colCount = this.getObjectLength(dataSource[0]);
            startCell = rangeSettings.startCell;
            if (rangeSettings.range)
                range = rangeSettings.range;
            else {
                rangeData = startCell.split(/[A-Z]/i);
                range.push(parseInt(rangeData[rangeData.length - 1]) - 1);
                range.push(this._generateColCount(startCell[0].split(/[0-9]/)[0].toUpperCase()) - 1);
                range.push(range[0] + rowCount - (rangeSettings.showHeader ? 0 : 1));
                range.push(range[1] + colCount - 1);
            }
            rangeCells = this._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
            cont = this._getContent(sheetIdx);
            contTable = this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content >table");
            if (!this.model.allowAutoCellType || !this.model.allowCellType)
                contTable.detach();
            if (rangeSettings.showHeader) {
                for (obj in dataSource[0])
                    data.push(obj);
            }
            for (r = 0; r < rowCount; r++) {
                if (dataSource[r] != undefined)
                    for (obj in dataSource[0])
                        data.push(dataSource[r][obj]);
            }
            this._dupDetails = true;
            for (i = 0, len = rangeCells.length; i < len; i++) {
                this.XLEdit._updateCell(rangeCells[i], data[i], sheetIdx);
                if (rangeSettings.showHeader && i < colCount) {
                    range = rangeSettings.startCell + ":" + (this._generateHeaderText(rangeCells[rangeCells.length - 1].colIndex + 1) + (rangeCells[0].rowIndex + 1));
                    if (rangeSettings.headerStyles)
                        this.XLFormat.format({ style: rangeSettings.headerStyles }, range);
                }
            }
            this._dupDetails = false;
            if (!this.model.allowAutoCellType || !this.model.allowCellType)
                cont.find(".e-content").append(contTable);
            if (!this._isUndoRedo) {
				var details = { sheetIndex: sheetIdx, reqType: "update-range", rangeSettings: rangeSettings };
                this._completeAction(details);
                this._trigActionComplete(details);
            }
        },

        editRange: function (rangeName, fn) {
            var i, j, len, cell, cont, data, contTable, $cell, sheetIdx = this.getActiveSheetIndex(),
                rangeInfo = this.getSheet(sheetIdx).rangeSettings[rangeName], range = this.getRangeIndices(rangeInfo.range),
                rangeCells = this.getRange(range);
            this._trigger("editRangeBegin", { range: rangeInfo, sheetIndex: sheetIdx });
            if (rangeInfo.cssClass)
                rangeCells.addClass(rangeInfo.cssClass);
            if (rangeInfo.readOnly)
                rangeCells.addClass("e-readonly");
            cont = this._getContent(sheetIdx);
            contTable = this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content >table");
            contTable.detach();
            for (i = 0, len = rangeCells.length; i < len; i++) {
                cell = rangeCells[i], $cell = $(cell);
                if ($.trim(rangeName).length)
                    this.XLEdit._updateDataContainer({ rowIndex: cell.parentNode.rowIndex, colIndex: cell.cellIndex }, { dataObj: { range: rangeName } });
                data = fn(cell, cell.cellIndex, i);
                if (typeof data === 'string')
                    this.XLEdit._updateCell($cell, data);
                else if (typeof data === 'object') {
                    if (data.Value.indexOf("=") !== 0)
                        this.XLEdit._updateCell($cell, data.Value);
                    else
                        this.XLEdit._updateCellValue($cell, data.Value);
                    $cell.data("value2", data.Value2);
                    $cell.data("type", data.NumberFormat);
                    if (data.StyleIndex > 1)
                        $cell.addClass(this._styleColl[data.StyleIndex]);
                }
            }
            cont.find(".e-content").append(contTable);
            for (j = range[0]; j < range[2] + 1 ; j++)
                this._setRowHdrHeight(sheetIdx, j);
            this._trigger("editRangeComplete", { range: rangeInfo, sheetIndex: sheetIdx });
            this.XLScroll._getRowHeights(sheetIdx, range[0]);
        },

        removeRange: function (rangeName) {
            this.clearRange(rangeName);
            delete this.getSheet(this.getActiveSheetIndex()).rangeSettings[rangeName];
        },

        clearRange: function (rangeName) {
            if (this.model.isReadOnly)
                return;
            var range, rangeCells, rangeInfo = this.getSheet(this.getActiveSheetIndex()).rangeSettings[rangeName];
            range = this.getRangeIndices(rangeInfo.range);
            rangeCells = this.getRange(range);
            if (rangeInfo.cssClass)
                rangeCells.removeClass(rangeInfo.cssClass);
            if (rangeInfo.readOnly)
                rangeCells.removeClass("e-readonly");
            this.clearRangeData(null, ["range", "value", "type", "value2"], rangeCells);
            rangeCells.empty();
        },

        getObjectLength: function (obj) {
            var i, cnt = 0;
            obj = Object.prototype.toString.call(obj) === Object.prototype.toString() ? obj : {};
            if (Object.keys)
                return Object.keys(obj).length;
            for (i in obj) {
                if (obj.hasOwnProperty(i))
                    cnt++;
            }
            return cnt;
        },

        getObjectKeys: function (obj) {
            var i, keys = [];
            obj = Object.prototype.toString.call(obj) === Object.prototype.toString() ? obj : {};
            if (!Object.keys) {
                for (i in obj) {
                    if (obj.hasOwnProperty(i))
                        keys.push(i);
                }
                return keys;
            }
            if (Object.keys)
                return Object.keys(obj);
        },

        toArrayLowerCase: function (args) {
            for (var i = 0; i < args.length; i++)
                args[i] = args[i].toString().toLowerCase();
            return args;
        },

        _isValueAlreadyExist: function (arrObj, key, value) {
            var i = 0, len = arrObj.length;
            while (i < len) {
                if (arrObj[i][key] === value)
                    return true;
                i++;
            }
            return false;
        },

        addClass: function (elem, classname) {
            if (!elem)
                return;
            if (elem instanceof jQuery || elem instanceof Array)
                elem = elem[0];
            var classes = elem.className;
            if (classes.indexOf(classname) === -1)
                elem.className = classes + " " + classname;
        },

        _removeClass: function (elem, className) {
            if (!elem)
                return;
            if (elem instanceof jQuery || elem instanceof Array)
                elem = elem[0];
            elem.className = className ? elem.className.replace(new RegExp(className, "g"), '').replace(/ +/g, ' ') : "";
        },

        _hasClass: function (elem, className) {
            if (!elem)
                return false;
            if (elem instanceof jQuery || elem instanceof Array)
                elem = elem[0];
            if (!elem || this._isAnimatedString(elem.className))
                return false;
            return elem.className.indexOf(className) > -1;
        },

        isUndefined: function (val) {
            return val === undefined;
        },

        _isString: function (obj) {
            return typeof obj === "string";
        },

        _isEmptyString: function (val) {
            return !val.toString().length;
        },

        _isObject: function (obj) {
            if (typeof obj !== "object")
                return false;
            return Object.prototype.toString.call(obj) === "[object Object]";
        },
        _getObjectValues: function (obj) {
            var i, values = [];
            obj = Object.prototype.toString.call(obj) === Object.prototype.toString() ? obj : {};
            for (i in obj)
                obj.hasOwnProperty(i) && values.push(obj[i]);
            return values;
        },

        _isAnimatedString: function (className) {
            return Object.prototype.toString.call(className) === "[object SVGAnimatedString]";
        },

        _isBool: function (val) {
            val = val + '';
            val = val.toUpperCase();
            return (val === "TRUE" || val === "FALSE");
        },

        isRange: function (range) {
            return range[0] !== range[2] || range[1] !== range[3];
        },

        _isMultiRange: function (range) {
            return !this._isString(range) && !this.isNumber(range[0]);
        },

        inRange: function (range, rowIdx, colIdx) {
            return rowIdx >= range[0] && rowIdx <= range[2] && colIdx >= range[1] && colIdx <= range[3];
        },

        _inRow: function (range, rowIdx) {
            return rowIdx >= range[0] && rowIdx <= range[2];
        },

        _inColumn: function (range, colIdx) {
            return colIdx >= range[1] && colIdx <= range[3];
        },

        _isUniqueRange: function (oldRange, newRange) {
            return oldRange.toString() === newRange.toString();
        },

        _isUniqueTarget: function (sevt, eevt) {
            var epos = this._getOriginalEvt(eevt), etrgt = document.elementFromPoint(epos.clientX, epos.clientY);
            return sevt.target === etrgt;
        },

        _getClientDiff: function (sXY, eXY) {
            return {
                x: sXY[0] - eXY[0],
                y: sXY[1] - eXY[1]
            };
        },

        hasSpan: function (cellIdx) {
            return this.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "merge") ? true : false;
        },

        _isFrozen: function (idx) {
            return idx > 0;
        },

        _isSelected: function (trgt) {
            if (this._hasClass(trgt, "e-selected") || this._hasClass(trgt, "e-rowselected") || this._hasClass(trgt, "e-colselected") || $(trgt).parents(".e-colselected").length)
                return true;
            return false;
        },

        _getMergedIdx: function (rowIdx, colIdx) {
            var range, minr, maxr, minc, maxc, i, sheet, rcount, ccount, sheetIdx = this.getActiveSheetIndex(), merge = this.XLEdit.getPropertyValue(rowIdx, colIdx, "merge", sheetIdx);
            rcount = ccount = 0;
            if (merge) {
                if (merge.mRange) {
                    range = this.getRangeIndices(merge.mRange);
                    sheet = this.getSheet(sheetIdx);
                    if (sheet.hideRowsCollection.length) {
                        minr = range[0], maxr = range[2];
                        if (maxr - minr > 1) {
                            i = minr + 1;
                            while (i < maxr) {
                                if (this.XLEdit.getPropertyValue(i, 0, ["isRHide"], sheetIdx))
                                    rcount++;
                                i++;
                            }
                        }
                    }
                    if (this.getObjectLength(sheet.hideColsCollection)) {
                        minc = range[1], maxc = range[3];
                        if (maxc - minc > 1) {
                            i = minc + 1;
                            while (i < maxc) {
                                if (this.XLEdit.getPropertyValue(0, i, ["isCHide"], sheetIdx))
                                    ccount++;
                                i++;
                            }
                        }
                    }
                }
                if (merge.mSpan) {
                    return { rowIndex: rowIdx + merge.mSpan.rowSpan + rcount - 1, colIndex: colIdx + merge.mSpan.colSpan + ccount - 1 };
                }
            }
            return { rowIndex: rowIdx, colIndex: colIdx };
        },

        _getMergeParent: function (rowIdx, colIdx) {
            var mIndex = this.XLEdit.getPropertyValue(rowIdx, colIdx, "mergeIdx");
            if (mIndex)
                return { rowIndex: mIndex.rowIndex, colIndex: mIndex.colIndex };
            return { rowIndex: rowIdx, colIndex: colIdx };
        },

        _getCellInfo: function (cellIdx, sheetIdx) {
            var sheet = this.getSheet(this._getSheetIndex(sheetIdx)), top, left, merge, width = 0, height = 0, mSpan;
            top = (cellIdx.rowIndex >= sheet._frozenRows) ? sheet._rowHeightCollection[cellIdx.rowIndex] - (sheet._rowHeightCollection[sheet._ftopRowIdx] - sheet._rowHeightCollection[sheet._frozenRows - 1]) : sheet._rowHeightCollection[cellIdx.rowIndex];
            left = (cellIdx.colIndex >= sheet._frozenColumns) ? sheet._colWidthCollection[cellIdx.colIndex] - (sheet._colWidthCollection[sheet._fleftColIdx] - sheet._colWidthCollection[sheet._frozenColumns - 1]) : sheet._colWidthCollection[cellIdx.colIndex];
            merge = this.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "merge");
            if (merge) {
                mSpan = merge.mSpan;
                for (var i = 0; i < mSpan.rowSpan; i++)
                    height += sheet.hideRowsCollection.indexOf(cellIdx.rowIndex + i) === -1 ? sheet.rowsHeightCollection[cellIdx.rowIndex + i] : 0;
                for (var i = 0; i < mSpan.colSpan; i++)
                    width += sheet.columnsWidthCollection[cellIdx.colIndex + i];
            }
            else {
                height = sheet.hideRowsCollection.indexOf(cellIdx.rowIndex) === -1 ? sheet.rowsHeightCollection[cellIdx.rowIndex] : 0,
                width = sheet.columnsWidthCollection[cellIdx.colIndex];
            }
            return {
                top: top - 1,
                left: left - 1,
                height: height,
                width: width
            };
        },

        _getRowIdx: function (rowIdx, sheetIdx, isArrIdx, isRowIdx) {
            var idx, sheet = this.getSheet(sheetIdx);
            if (isArrIdx) {
                idx = sheet._rowIdxColl[rowIdx];
                rowIdx = this.isUndefined(idx) ? sheet._rowIdxColl[sheet._rowIdxColl.length - 1] : idx;
            }
            else if (isRowIdx) {
                idx = sheet._rowIdxColl.indexOf(rowIdx);
                rowIdx = idx === -1 ? rowIdx : idx;
            }
            else if (this.model.scrollSettings.allowScrolling && this.model.scrollSettings.allowVirtualScrolling)
                rowIdx = sheet._virtualRowIdx.indexOf(rowIdx);
            return rowIdx;
        },

        _getMinRowIdx: function (sheet) {
            for (var i = 0; i < sheet.rowCount; i++) {
                if (sheet.hideRowsCollection.indexOf(i) === -1 && sheet._hiddenFreezeRows.indexOf(i) === -1)
                    return i;
            }
            return 0;
        },

        _arrayAsString: function (arr) {
            return arr.join(" ").replace(/,/g, " ");
        },

        _rangeHasData: function (range) {
            var cells, i, cellIdx;
            range = this.swapRange(range);
            cells = this._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
            i = cells.length;
            while (i--) {
                cellIdx = cells[i];
                if (this.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex))
                    return true;
            }
            return false;
        },

        _isTableRange: function (rowIdx, colIdx, sheetIdx) {
            sheetIdx = this._getSheetIndex(sheetIdx);
            var i, tmngr = this.getSheet(sheetIdx).tableManager;
            for (i in tmngr) {
                if (this.inRange(tmngr[i].range, rowIdx, colIdx))
                    return true;
            }
            return false;
        },

        _hasCellStyle: function (rowIdx, colIdx, sheetIdx) {
            var style, props = ["borders", "formats"], i = props.length;
            while (i--) {
                style = this.XLEdit.getPropertyValue(rowIdx, colIdx, props[i], sheetIdx);
                if (style)
                    return true;
            }
            return false;
        },

        _isHiddenRow: function (rowIdx, sheetIdx) {
            return (this.XLEdit.getPropertyValue(rowIdx, 0, "isFilterHide", sheetIdx) || this.XLEdit.getPropertyValue(rowIdx, 0, "isRHide", sheetIdx)) || false;
        },

        _refreshViewVar: function (top, left, sheetIdx) {
            sheetIdx = this._getSheetIndex(sheetIdx);
            var rowIdx, sheet = this.getSheet(sheetIdx);
            if (!ej.isNullOrUndefined(top)) {
                sheet._topRow.idx = this.XLShape._getCellIndexFromOffset(top, null, sheetIdx).rowIndex;
                sheet._topRow.value = this._getRowOffsetTop(sheet, sheet._topRow.idx);
                sheet._bottomRow.idx = sheet._rowIdxColl[sheet._topRow.idx + (sheet._virtualBlockRowCnt - this._bufferCnt - 1)]; // -1 as virtualblockrowcnt is 1 index based.
                sheet._bottomRow.value = this._getRowOffsetTop(sheet, sheet._bottomRow.idx);
                sheet.topLeftCell = this.getAlphaRange(sheet._topRow.idx, sheet._leftCol.idx);
            }
            if (!ej.isNullOrUndefined(left)) {
                sheet._leftCol.idx = this.XLShape._getCellIndexFromOffset(null, left, sheetIdx).colIndex;
                sheet._leftCol.value = this._getColOffsetLeft(sheet, sheet._leftCol.idx);
                sheet._rightCol.idx = this.XLShape._getCellIndexFromOffset(null, left + sheet._vPortWth, sheetIdx).colIndex || sheet.colCount - 1;
                sheet._rightCol.value = this._getColOffsetLeft(sheet, sheet._rightCol.idx);
                sheet.topLeftCell = this.getAlphaRange(sheet._topRow.idx, sheet._leftCol.idx);
            }
        },

        _getFormatString: function (type, decimalplace) {
            var formatstr = ej.Spreadsheet.CellFormat[type];
            if (this.isNumber(decimalplace) && !ej.isNullOrUndefined(formatstr))
                formatstr = "{0:" + formatstr.substr(3, 1) + decimalplace + "}";
            return formatstr || "";
        },

        _refreshVrtlBlocks: function (sheetIdx) {
            var rowIdx, i, idx, cnt = 3, arr = ["_virtualTopTBodyOffset", "_virtualContTBodyOffset", "_virtualBottomTBodyOffset"],
                sheetIdx = this._getSheetIndex(sheetIdx), sheet = this.getSheet(sheetIdx);
            i = idx = 0;
            while (i < cnt) {
                if ((!i && !sheet._isVirtualTopReached) || i === 1 || (i === 2 && !sheet._isVirtualEndReached)) {
                    rowIdx = sheet._virtualRowIdx[idx];
                    sheet[arr[i]].top = this._getRowOffsetTop(sheet, rowIdx);
                    idx += sheet._virtualBlockRowCnt;
                    rowIdx = sheet._virtualRowIdx[idx - 1];
                    sheet[arr[i]].bottom = this._getRowOffsetBottom(rowIdx, sheetIdx);
                }
                i++;
            }
            sheet._virtualTBodyHgt = sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1] + sheet.rowsHeightCollection[sheet.rowsHeightCollection.length - 1];
        },

        getRangeDataAsObject: function (startcell, endcell, skipHiddenRow) {
            var i, columnName, celldata, temp, formatTemp, ctype = ej.Spreadsheet.CellType, container = this._dataContainer, sheetIdx = this.getActiveSheetIndex(),
                sheetdata = container.sheets[this.getActiveSheetIndex()], minrindex, maxrindex, mincindex, maxcindex, rangeData = [], formattedRangeData = [], data = [];
            startcell.rowIndex > endcell.rowIndex ? (minrindex = endcell.rowIndex, maxrindex = startcell.rowIndex) : (minrindex = startcell.rowIndex, maxrindex = endcell.rowIndex);
            startcell.colIndex > endcell.colIndex ? (mincindex = endcell.colIndex, maxcindex = startcell.colIndex) : (mincindex = startcell.colIndex, maxcindex = endcell.colIndex);
            while (minrindex <= maxrindex) {
                if (!skipHiddenRow || !this._isHiddenRow(minrindex)) {
                    temp = {}, formatTemp = {};
                    for (i = mincindex; i <= maxcindex; i++) {
                        columnName = this._generateHeaderText(i + 1);
                        if (minrindex in sheetdata && i in sheetdata[minrindex]) {
                            celldata = sheetdata[minrindex][i];
                            temp[columnName] = container.sharedData[celldata.value];
                            formatTemp[columnName] = [ctype.General, ctype.Text].indexOf(container.cellType[celldata.type]) === -1 ? celldata.value2 : container.sharedData[celldata.value2];
                        }
                    }
                    rangeData.push(temp);
                    formattedRangeData.push(formatTemp);
                }
                minrindex++;
            }
            data.push(rangeData);
            data.push(formattedRangeData);
            return data;
        },

        getRangeDataAsJSON: function (startcell, endcell, skipHiddenRow, sheetIdx) {
            var i, columnName, celldata, formatTemp, ctype = ej.Spreadsheet.CellType, container = this._dataContainer, sheetdata = container.sheets[sheetIdx ? sheetIdx : this.getActiveSheetIndex()], minrindex, maxrindex, mincindex, maxcindex;
            var formattedRangeData = [], isHeader = true, columns = [], value;
            if (startcell.rowIndex > endcell.rowIndex) {
                minrindex = endcell.rowIndex;
                maxrindex = startcell.rowIndex;
            }
            else {
                minrindex = startcell.rowIndex;
                maxrindex = endcell.rowIndex;
            }
            if (startcell.colIndex > endcell.colIndex) {
                mincindex = endcell.colIndex;
                maxcindex = startcell.colIndex;
            }
            else {
                mincindex = startcell.colIndex;
                maxcindex = endcell.colIndex;
            }
            while (minrindex <= maxrindex) {
                if (!skipHiddenRow || !this._isHiddenRow(minrindex)) {
                    formatTemp = {};
                    for (i = mincindex; i <= maxcindex; i++) {
                        if (!isHeader) {
                            columnName = columns[i];
                            if (minrindex in sheetdata && i in sheetdata[minrindex]) {
                                celldata = sheetdata[minrindex][i];
                                if (!this.isUndefined(celldata.type) && ([ctype.General, ctype.Text].indexOf(container.cellType[celldata.type]) === -1))
                                    value = celldata.value2;
                                else
                                    value = container.sharedData[celldata.value2];
                                if (!ej.isNullOrUndefined(value))
                                    formatTemp[columnName] = this.isNumber(value) ? parseInt(value) : value;
								else
								formatTemp[columnName] = "";
                            }
							else
							formatTemp[columnName] = "";
                        }
                        else if (minrindex in sheetdata && i in sheetdata[minrindex]) {
                            celldata = sheetdata[minrindex][i];
                            if (!this.isUndefined(celldata.type) && ([ctype.General, ctype.Text].indexOf(container.cellType[celldata.type]) === -1))
                                columns[i] = celldata.value2;
                            else
                                columns[i] = container.sharedData[celldata.value2];
                        }
                    }
                    if (!isHeader && this.getObjectLength(formatTemp)) {
                        formattedRangeData.push(formatTemp);
                    }
                }
                minrindex++;
                if (isHeader)
                    isHeader = false;
            }
            return formattedRangeData;
        },

        _getColorFromFormat: function (format) {
            var color = [], hashCode, fgcolor, bgcolor;
            if (!ej.isNullOrUndefined(format)) {
                hashCode = format.replace("e-format", "").toLowerCase();
                (hashCode.startsWith("6n")) ? fgcolor = "#" + hashCode.substr(2, 6) : fgcolor = "#" + hashCode.substr(6, 6);
                bgcolor = "#" + hashCode.substr(0, 6);
                color.push(bgcolor);
                color.push(fgcolor);
            }
            return color;
        },

        getRangeData: function (options) {
            options = options || {};
            options.sheetIdx = this._getSheetIndex(options.sheetIdx);
            options.range = this._toIntrnlRange(options.range, options.sheetIdx);
            options.property = options.property || ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "range", "format", "border", "comment", "hyperlink", "picture", "cFormatRule", "rule", "chart", "isLocked", "wrap", "formats", "cellType", "altTxt"];
            var i = 0, len, minc, minr, maxr, maxc, isHiddenRow, skipVirtualHiddenRow, rowIdx = [], arr = [], sheet = this.getSheet(options.sheetIdx);
            if (options.rowIdxs) {
                len = options.rowIdxs.length;
                while (i < len) {
                    this._pushRowData(options, options.rowIdxs[i], 0, sheet.colCount - 1, arr, rowIdx);
                    i++;
                }
            }
            else {
                skipVirtualHiddenRow = false;
                if (this.model.scrollSettings.allowVirtualScrolling && options.skipHiddenRow && !ej.isNullOrUndefined(options.virtualRowIdx)) {
                    skipVirtualHiddenRow = true;
                    minr = options.virtualRowIdx;
                    maxr = minr + (options.virtualRowCount - 1);
                    maxc = sheet.colCount - 1;
                }
                else {
                    minr = options.range[0];
                    maxr = options.range[2];
                    maxc = options.range[3];
                }
                while (minr <= maxr) {
                    isHiddenRow = this._isHiddenRow(minr, options.sheetIdx);
                    if (skipVirtualHiddenRow && isHiddenRow)
                        maxr++;
                    else if (!options.skipHiddenRow || !isHiddenRow) {
                        minc = skipVirtualHiddenRow ? 0 : options.range[1];
                        this._pushRowData(options, minr, minc, maxc, arr, rowIdx, true);
                    }
                    minr++;
                }
            }
            return options.withRowIdx ? { rowIdx: rowIdx, data: arr } : arr;
        },

        _pushRowData: function (options, minr, minc, maxc, arr, rowIdx, isDataSrcEnsured) {
            var val, obj, prop, cellData, sharedData, value = "value", intrnlUpdate = this._intrnlUpdate, container = this._dataContainer, sheetdata = container.sheets[options.sheetIdx];
            if (!isDataSrcEnsured)
                this.XLEdit._refreshContainer(minr, options.sheetIdx);
            if (sheetdata[minr]) {
                if (options.valueOnly) {
                    while (minc <= maxc) {
                        val = "";
                        cellData = sheetdata[minr][minc];
                        if (cellData && value in cellData) {
                            sharedData = container.sharedData;
                            val = sharedData[cellData[value]];
                            if (options.skipDateTime && this._isDateTime(val))
                                val = this.XLEdit.getPropertyValue(minr, minc, "value2", options.sheetIdx);
                            else if (options.skipFormula && this.isFormula(val))
                                val = this.XLEdit.getPropertyValue(minr, minc, "calcValue", options.sheetIdx);
                        }
                        if (!options.skipEmptyCell || (!this.isUndefined(val) && val.toString().length))
                            arr.push(val);
                        minc++;
                    }
                }
                else {
                    this._intrnlUpdate = true;
                    while (minc <= maxc) {
                        cellData = sheetdata[minr][minc];
                        if (cellData) {
                            obj = {};
                            for (prop in cellData) {
                                if (options.property.indexOf(prop) > -1)
                                    obj[prop] = this.XLEdit.getPropertyValue(minr, minc, prop, options.sheetIdx);
                            }
                            if (!options.skipEmptyCell || this.getObjectLength(obj))
                                arr.push(obj);
                        }
                        else if (!options.skipEmptyCell)
                            arr.push({});
                        minc++;
                    }
                    this._intrnlUpdate = intrnlUpdate;
                }
            }
            else if (!options.skipEmptyCell) {
                while (minc <= maxc) {
                    options.valueOnly ? arr.push("") : arr.push({});
                    minc++;
                }
            }
            rowIdx.push(minr);
        },

        _processBindings: function (args) {
            this.model.query = new ej.Query();
            if (this._trigger("actionBegin", args))
                return true;
            this._ensureDataSource(args);
            if (args.action === "sorting") {
                this.XLSort._sortComplete(args);
                if (!this._isUndoRedo) {
                    this._completeAction(args);
                    this._trigActionComplete(args);
                }
            }
            else {
                this._completeAction(args);
                this._trigActionComplete(args);
            }
        },

        _ensureDataSource: function (args) {
            var dataSource, dataSrc, prop, predicate, predicates, obj, result, tblrange, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx);
            if (args.action === "filtering" || args.action === "clearfiltering" || args.requestType === "filterbycell") {
                dataSource = (sheet.filterSettings.filteredRange == null) ? this._dataSource(sheetIdx) : sheet.filterSettings.filteredRange;
                tblrange = sheet.filterSettings.tableRange;
                for (var i = 0, len = tblrange.length; i < len; i++) {
                    if (tblrange[i].tableID === args.tableID) {
                        tblrange[i].filteredRange = dataSource;
                        break;
                    }
                }
                this._dataManager = ej.DataManager(dataSource);
                if (!(dataSource instanceof ej.DataManager))
                    this.model.currentViewData = dataSource;
                this.model.query.requiresCount();
                if (args.filteredcolumns.length) {
                    predicates = this._excelFilter._predicates[sheetIdx];
                    dataSrc = dataSource[0];
                    for (prop in predicates) {
                        (dataSrc.hasOwnProperty(prop)) && (obj = predicates[prop]);
                        obj = predicates[prop];
                        predicate = predicate != undefined ? predicate["and"](obj) : obj;
                    }
                    if (!ej.isNullOrUndefined(predicate))
                        this.model.query.where(predicate);
                    if (!(dataSource instanceof ej.DataManager)) {
                        result = this._dataManager.executeLocal(this.model.query);
                        this._filteredRecordsCount = result.count;
                        this.model.currentViewData = result.result;
                    }
                }
            }
            else if (args.requestType === "sorting") {
                this._dataManager = ej.DataManager(args.rangeData);
                if (!(args.rangeData instanceof ej.DataManager))
                    this.model.currentViewData = args.rangeData;
                this.model.query.sortBy(args.columnName, args.sortDirection);
                if (!(args.rangeData instanceof ej.DataManager)) {
                    result = this._dataManager.executeLocal(this.model.query);
                    this.model.currentViewData = result;
                }
            }
            this._dataManager = null;
        },

        _toArrayData: function (args) {
            var prop, obj, i = 0, temp = [], len = args.length;
            while (i < len) {
                obj = args[i];
                if (this.getObjectLength(obj)) {
                    for (prop in obj)
                        temp.push(obj[prop]);
                }
                else
                    temp.push("");
                i++;
            }
            return temp;
        },

        _updateRangeStyle: function (range, data, status) {
            var cells = this._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
            for (var i = 0; i < cells.length; i++) {
                if (this.model.allowCellFormatting && this.XLFormat._hasFormat(data[i].format)) {
                    this.XLFormat._updateFormatClass(cells[i], data[i].format);
                    this.XLEdit._updateDataContainer(cells[i], { dataObj: { formats: data[i].formats }, sheetIdx: this.getActiveSheetIndex(), status: status });
                }
            }
        },

        updateRangeData: function (range, data) {
            if (this.model.isReadOnly)
                return;
            range = this._getRangeArgs(range, "object");
            if (range.length) {
                range.startCell = { rowIndex: range[0], colIndex: range[1] };
                range.endCell = { rowIndex: range[2], colIndex: range[3] };
            }
            var cells = this._getSelectedRange(range.startCell, range.endCell), dataArray = this._toArrayData(data);
            if (dataArray.length === cells.length) {
                for (var i = 0; i < cells.length; i++) {
                    if (!ej.isNullOrUndefined(dataArray[i]))
                        this.XLEdit._updateCellValue(this.getCell(cells[i].rowIndex, cells[i].colIndex), dataArray[i]);
                }
            }
        },

        updateData: function (datas, range, status) {
            if (this.model.isReadOnly)
                return;
            var i, j, k, l, val, cell, isWrap, data, hlData, m = 0, clrFrmt = "clear-format", formatObj = {}, props = this._cellProp,
                sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx);
            range = this._getRangeArgs(range, "object");
            i = range[0], j = range[2], l = range[3];
            while (i <= j) {
                k = range[1];
                while (k <= l) {
                    data = datas[m];
                    cell = this.getCell(i, k, sheetIdx);
					if("wrap" in data)
					    this.setWrapText("wrap", range);
                    this.XLEdit._updateDataContainer({ rowIndex: i, colIndex: k }, { dataObj: data });
                    if (cell) {
                        if (props[13] in data) {
                            hlData = data.hyperlink;
                            if (hlData) {
                                if (status === clrFrmt)
                                    cell.find("a").css({ "color": this._hlColor, "text-decoration": "underline" }).addClass("e-hyperlinks");
                                else
                                    hlData.webAddr ? (cell.html(ej.buildTag("a", data.value2, "", { href: hlData.webAddr, target: "_blank", "class": "e-hyperlinks" }))) : (cell.html(ej.buildTag("a", data.value2, "", {"class": "e-hyperlinks" })));
                            }
                        }
                        if (status === clrFrmt) {
                            if (data.formatStr)
                                formatObj.formatStr = data.formatStr;
                            if (data.type)
                                formatObj.type = data.type;
                            if (!ej.isNullOrUndefined(data.decimalPlaces))
                                formatObj.decimalPlaces = data.decimalPlaces;
                            if (!ej.isNullOrUndefined(data.thousandSeparator))
                                formatObj.thousandSeparator = data.thousandSeparator;
                            this.XLFormat.format(formatObj, [i, k, i, k]);
                        }
                        if (props[21] in data)
                            this.XLComment._updateCmntFrmCntnr(i, k);
                        if (props[0] in data) {
                            val = data.value;
                            this.XLEdit._refreshCalcEngine(i, k, this.isFormula(val), val);
                        }
                    }
                    m++;
                    k++;
                }
                i++;
            }
        },

        updateUniqueData: function (data, range, skipCell, sheetIndex) {
            if (this.model.isReadOnly)
                return;
            range = this._getRangeArgs(range, "object");
            var minc, args = { dataObj: data }, minr = range[0], maxr = range[2], maxc = range[3];
            if (skipCell)
                args.skipCell = skipCell;
            args.sheetIdx = sheetIndex;
            while (minr <= maxr) {
                minc = range[1];
                while (minc <= maxc) {
                    this.XLEdit._updateDataContainer({ rowIndex: minr, colIndex: minc }, args);
                    minc++;
                }
                minr++;
            }
        },

        clearRangeData: function (range, property, cells, skipHiddenRow, status, skipCell) {
            if (this.model.isReadOnly)
                return;
            var minr, minc, maxr, maxc, sheetIdx = this.getActiveSheetIndex();
            range = this._getRangeArgs(range, "object", sheetIdx);
            property = property ? property : ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink", "isFilterHighlight"];
            minr = range[0], maxr = range[2], maxc = range[3];
            while (minr <= maxr) {
                if (!skipHiddenRow || !this._isHiddenRow(minr)) {
                    minc = range[1];
                    while (minc <= maxc) {
                        this.XLEdit._clearDataContainer({ cellIdx: { rowIndex: minr, colIndex: minc }, property: property, status: status, skipCell: skipCell });
                        minc++;
                    }
                }
                if (property.indexOf("wrap") > -1)
                    this._setRowHdrHeight(sheetIdx, minr);
                minr++;
            }
        },

        _getArrayRangeCells: function (range) {  // return cells if range specified else selected cells will returned
            return range ? (range = this.swapRange(range), this.getRange(range)) : this._getContent(this.getActiveSheetIndex()).find(".e-selected");
        },

        _getAlphaRangeCells: function (range) { // get range cells by alpha range input
            return range ? (range = this.getRangeIndices(range), this.getRange(range)) : this._getContent(this.getActiveSheetIndex()).find(".e-selected");
        },

        _getMultiRangeCells: function (range) {
            var i, val, cells, arr, len;
            if (!range) {
                range = this._getRangeArgs(range, "object");
                cells = this._getSelectedCells(this.getActiveSheetIndex(), range).selCells;
            }
            else {
                i = 0, cells = [], arr = [];
                if (this._isString(range))
                    arr.push(this.getRangeIndices(range));
                else {
                    if (this.isNumber(range[0]))
                        arr.push(range);
                    else {
                        len = range.length;
                        while (i < len) {
                            val = range[i];
                            arr.push(Array.isArray(val) ? val : this.getRangeIndices(val));
                            i++;
                        }
                    }
                }
                i = 0, len = arr.length;
                while (i < len) {
                    val = arr[i];
                    cells = cells.concat(this._getSelectedRange({ rowIndex: val[0], colIndex: val[1] }, { rowIndex: val[2], colIndex: val[3] }));
                    i++;
                }
            }
            return cells;
        },

        _completeAction: function (args) {
            var len, sheetIndex = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIndex), details, fltrdIdxes, fltrdVal;
            if (args.reqType === "filter") {
                if (args.operation !== "apply-filter" && args.operation !== "remove-filter" && args.operation !== "clearfilter") {
                    fltrdVal = args.model.currentViewData;
                    details = {
                        sheetIndex: sheetIndex,
                        range: sheet._selectedRange,
                        currentViewData: fltrdVal,
                        fieldName: args.currentFilteringColumn,
                        ejpredicate: args.ejpredicate,
                        activeCell: args.activeCell,
                        filteredValue: args.filteredValue,
                        filterCollection: args.filteredcolumns,
                        requestType: args.requestType,
                        reqType: args.reqType,
                        selectedCell: args.selectedCell,
                        action: args.action,
                        operation: "filter",
                        selectedDataSource: sheet.selectedDataSource,
                        tableID: args.tableID,
                        filteredCells: args.filteredCells,
                        fltrdIdxes: [],
                        selRange: args.selRange
                    };
                    for (i = 0, len = fltrdVal.length; i < len; i++)
                        details.fltrdIdxes.push(details.range.startRow + sheet.filterSettings.filteredRange.indexOf(fltrdVal[i]));
                }
                else if (args.operation === "remove-filter" || args.operation === "clearfilter")
                    details = args;
                else
                    details = { sheetIndex: sheetIndex, filteredCells: args.filteredCells, reqType: "filter", operation: "apply-filter", tableID: args.tableID, fRange: this.getSheet(sheetIndex).filterSettings.range };
                details.rowIndex = args.rowIndex;
                details.colIndex = args.colIndex;
            }
            else if (args.requestType === ej.Spreadsheet.Actions.Sorting) {
                var prevIcon, currIcon, fltrspan, rowIndex, filterIcons = [];
                rowIndex = (args.filterIcon.length > 0) ? args.range[0] - 1 : args.range[0];
                for (var i = 0; i < args.filterIcon.length; i++) {
                    fltrspan = this.XLFilter._getFilterHeader(sheetIndex, rowIndex, args.filterIcon[i].colIndex);
                    if (!ej.isNullOrUndefined(fltrspan)) {
                        if (fltrspan.status.indexOf("-asc") > -1)
                            prevIcon = "-asc";
                        else if (fltrspan.status.indexOf("-dsc") > -1)
                            prevIcon = "-dsc";
                        else
                            prevIcon = "";
                    } else
                        prevIcon = "";
                    if (args.filterIcon[i].colIndex === this._generateColCount(args.columnName) - 1)
                        currIcon = args.sortDirection === "ascending" ? "-asc" : "-dsc";
                    else
                        currIcon = "";
                    filterIcons.push({ rowIdx: rowIndex, colIdx: args.filterIcon[i].colIndex, prevIcon: prevIcon, currIcon: currIcon });
                }
                details = { sheetIndex: sheetIndex, filterIcons: filterIcons, isSortByFilter: args.isSortByFilter, colSelected: args.colSelected, range: args.range, columnName: args.columnName, rangeData: args.rangeData, reqType: "sort", direction: args.sortDirection, operation: "unsort" };
            }
            else if (args.requestType === "sortbycolor" || args.requestType === "filterbycolor") {
                details = { sheetIndex: sheetIndex, operation: args.operation, oprType: args.oprType, requestType: args.requestType, action: args.action, bgcolor: args.bgcolor, fgcolor: args.fgcolor, tableID: args.tableID, reqType: args.requestType, sortRange: args.sortRange };
                details.columnName = (args.requestType === "sortbycolor") ? args.sortColumn : args.filterColumn;
                var color;
                if (args.requestType === "filterbycolor") {
                    var fltrdIdxes = [], colIdx = this._generateColCount(details.columnName);
                    for (i = args.range.endRow; i >= args.range.startRow; i--) {
                        color = this.XLEdit.getPropertyValue(i, colIdx - 1, "formats");
                        if (!ej.isNullOrUndefined(color)) {
                            if (args.operation === "filterbgcolor") {
                                if (!ej.isNullOrUndefined(color["background-color"]))
                                    (args.bgcolor.toLowerCase() === color["background-color"].toLowerCase()) && fltrdIdxes.push(i);
                            }
                            else {
                                if (!ej.isNullOrUndefined(color["color"]))
                                    (args.fgcolor.toLowerCase() === color["color"].toLowerCase()) && fltrdIdxes.push(i);
                            }
                        }
                    }
                    details.fltrdIdxes = fltrdIdxes;
                    details.rowIndex = args.range.startRow - 1;
                    details.colIndex = colIdx - 1;
                }
            }
            else
                details = args;
            if (this.model.allowUndoRedo && !(details.requestType === "sortbycolor") && !this._dupDetails)
                this.updateUndoRedoCollection(details);
            if (args.requestType === "filtering" || args.requestType === "filterbycolor" || args.requestType === "sortbycolor" || args.requestType === "filterbycell")
                (args.operation !== "apply-filter" && args.operation !== "remove-filter") && this.sendDataRenderingRequest(details, this.getActiveSheetIndex());
            if (this.model.allowAutoFill && args.reqType !== "find-replace" && this.element.find('.e-ss-activeimg').length < 1 && !sheet._isFreezed)
                this.XLDragFill.positionAutoFillElement();
            if (!(this.XLComment && this.XLComment._isCommentEdit))
                this._updateUndoRedoIcons();
            if (args.reqType !== "paging")
                if (args.reqType === "edit" && args.hasValidation)
                    this._trigrDdlActnCmplt(args.cValue, args.pValue);
        },

        updateUndoRedoCollection: function (details) {
            if (!this._isUndoRedo && details.reqType !== 'update-range') {
                this._undoCollection.push(details);
                this._redoCollection = [];
            }
            if (this._undoCollection.length > this.undoRedoStep)
                this._undoCollection.splice(0, 1);
            if (this.model.showRibbon)
                this.XLRibbon._updateRibbonIcons();
            this._updateUndoRedoIcons();
        },

        _trigActionBegin: function (args) {
            return !this._isSaveAsJSON && this._trigger("actionBegin", args);
        },

        _trigActionComplete: function (args) {
            return !this._isSaveAsJSON && this._trigger("actionComplete", args);
        },

        _updateUndoRedoIcons: function () {
            if (!this.model.showRibbon || !this.model.allowUndoRedo) {
                if (!(this.XLComment && this.XLComment._isCommentEdit))
                    this.setSheetFocus();
                return;
            }
            if ($("#" + this._id + "_Ribbon_Home_Actions_Undo").length && $("#" + this._id + "_Ribbon_Home_Actions_Redo").length && !this.model.isReadOnly) {
                var args, undoBtn = $("#" + this._id + "_Ribbon_Home_Actions_Undo").data("ejButton"), redoBtn = $("#" + this._id + "_Ribbon_Home_Actions_Redo").data("ejButton");
                if (undoBtn)
                    this._undoCollection.length ? undoBtn.enable() : undoBtn.disable();
                if (redoBtn)
                    this._redoCollection.length ? redoBtn.enable() : redoBtn.disable();
                if (!this.XLEdit._isEdit && !(this.XLComment && this.XLComment._isCommentEdit) && !this._isSheetRename && (document.activeElement && document.activeElement.id.indexOf(this._id + "_Ribbon") < 0))
                    this.setSheetFocus();
            }
        },

        _filterMergeCells: function (rowIdx, status) {
            var sheetIdx = this.getActiveSheetIndex(), dataContainer = this._dataContainer.sheets[sheetIdx], dataKeys = this.getObjectKeys(dataContainer[rowIdx]),
                rc, mCell, isMerge = false, mCells;
            for (var i = 0; i < dataKeys.length; i++) {
                mCells = this.XLEdit.getPropertyValue(rowIdx, dataKeys[i], "mergeIdx");
                if (mCells) {
                    rc = mCells;
                    isMerge = true;
                }
            }
            if (isMerge) {
                mCell = this.getCell(rc.rowIndex, rc.colIndex)[0];
                mCell.rowSpan = (status === "incr") ? (mCell.rowSpan + 1) : (mCell.rowSpan - 1);
            }
        },

        _isRowVisible: function (sheetIdx, rowIdx) {
            var container = this._dataContainer.sheets[sheetIdx];
            if (rowIdx in container)
                if (0 in container[rowIdx] && (container[rowIdx][0].isRHide || container[rowIdx][0].isFRHide))
                    return false;
                else
                    return true;
            else
                return true;
        },

        _selectFirstCell: function (sheetIdx, rowIdx, colIdx, isSelect) {
            var sheet = this.getSheet(sheetIdx);
            if ((!sheet._isImported || sheet._isLoaded) && !isSelect) {
                isSelect = !isSelect;
                this.performSelection({ rowIndex: rowIdx, colIndex: colIdx }, { rowIndex: rowIdx, colIndex: colIdx });
            }
            return isSelect;
        },

        _clearAllMergeCells: function (sheetIdx, rowIdx, rowCount, colIdx, colCount, status) {
            var mergeObj, sheet = this.getSheet(sheetIdx), isAlert = false, isCancel = false, dupDetail = this._dupDetails, mRange, mCells = sheet._mergeColl,
                umCells = sheet._unmergeColl, remColl = this._removeMergeColl, rKey, cKey, rKeys, cKeys, container = this._dataContainer.sheets[sheetIdx], chkObj = { isCancel: false, isAlert: true };
            this._dupDetails = true;
            rKeys = this.getObjectKeys(mCells);
            if (rKeys.length < 1)
                isAlert = true;
            for (var i = 0, len = rKeys.length; i < len; i++) {
                cKeys = this.getObjectKeys(mCells[rKeys[i]]);
                for (var j = 0; j < cKeys.length; j++) {
                    mergeObj = $.extend(true, {}, this.XLEdit.getPropertyValue(rKeys[i], cKeys[j], "merge"));
                    mRange = this.getRangeIndices(mergeObj.mRange);
                    chkObj = this._checkFilterMerge(sheetIdx, mRange, rowIdx, rowCount, colIdx, colCount, status, "merge", isAlert, rKeys[i], cKeys[j], mergeObj);
                    if (chkObj.isClear) {
                        if (!(rKeys[i] in umCells))
							sheet._unmergeColl[rKeys[i]] = {};
						sheet._unmergeColl[rKeys[i]][cKeys[j]] = { type: mCells[rKeys[i]][cKeys[j]], merge: mergeObj, isClear: true };
                        this.unmergeCells(mergeObj.mRange, true);
                    }
                    chkObj.isClear = false;
                }
            }
            this._dupDetails = dupDetail;
            return { isCancel: chkObj.isCancel, isAlert: chkObj.isAlert };
        },

        _checkFilterMerge: function (sheetIdx, range, rowIdx, rowCount, colIdx, colCount, status, operation, isAlert, rKey, cKey, mergeObj) {
            var isCancel, sheet = this.getSheet(sheetIdx), rng = this._getSelectedCells(sheetIdx, range).range, mCells, isClear = false, isRow = false, isCol = false, mCells = sheet._mergeColl;
            if(status.indexOf("shift") > -1 || (operation != "merge" && (status.indexOf("insert") > -1 || status.indexOf("delete") > -1))) {
                (operation === "merge") && (this._removeMergeColl = []);
                if (status.indexOf("Bottom") > -1 || status.indexOf("Up") > -1 || (operation != "merge" && status.indexOf("Row") > -1)) {
                    if (((colIdx >= range[1]) || range[3] >= (colIdx + colCount - 1)) || status.indexOf("Row") > -1) {
                        if ((rowIdx >= range[2]) || (rowIdx <= range[2])) {
                            if (colIdx < range[1] && (colIdx + colCount - 1) < range[1])
                                isAlert = true;
                            else if (colIdx > range[3] && (colIdx + colCount - 1) > range[3])
                                isAlert = true;
                            else if (!this._isTotalRow && (colIdx === range[1] && range[3] === (colIdx + colCount - 1))) {
                                isClear = true;
                                isAlert = true;
                            }
                            if (!isAlert && (rowIdx > range[2]))
                                isAlert = true;
                        }
                    }
                    else if (colIdx < range[1] && range[3] < (colIdx + colCount - 1)) {
                        isAlert = true;
                        isClear = true;
                    }
                    if (operation === "merge" && !this._isUndoRedo)
                        if (status.indexOf("Up") > -1 && this.XLEdit._rangeHasProperty(rng, "merge")) {
                            this._showAlertDlg("Alert", "MergePreventInsertDelete", "MergePreventInsertDelete", 450);
                            isClear = false;
                            isCancel = true;
                        }
                }
                else if (status.indexOf("Right") > -1 || status.indexOf("Left") > -1 || (operation != "merge" && status.indexOf("Column") > -1)) {
                    if (((rowIdx >= range[0]) || range[2] >= (rowIdx + rowCount - 1)) || status.indexOf("Column") > -1) {
                        if ((colIdx >= range[3]) || (colIdx <= range[3])) {
                            if (rowIdx < range[0] && (rowIdx + rowCount - 1) < range[0])
                                isAlert = true;
                            else if (rowIdx > range[2] && (rowIdx + rowCount - 1) > range[2])
                                isAlert = true;
                            else if (rowIdx === range[0] && range[2] === (rowIdx + rowCount - 1)) {
                                isClear = true;
                                isAlert = true;
                            }
                            if (!isAlert && (colIdx > range[3]))
                                isAlert = true;
                        }
                    }
                    else if (rowIdx < range[0] && range[2] < (rowIdx + rowCount - 1)) {
                        isAlert = true;
                        isClear = true;
                    }
                    if (operation === "merge" && !this._isUndoRedo)
                        if (status.indexOf("Left") > -1 && this.XLEdit._rangeHasProperty(rng, "merge")) {
                            this._showAlertDlg("Alert", "CtrlKeyErrorAlert", "CtrlKeyErrorAction", 450);
                            isClear = false;
                            isCancel = true;
                        }
                }
                if ((operation === "merge") && !isAlert && !isClear)
                    this._removeMergeColl.push({ type: mCells[rKey][cKey], merge: mergeObj });
            }
            else {
                this._isUndoRedo && (isAlert = true);
                if ((rowIdx === -1) || ((rowIdx != -1) && ((range[0] <= rowIdx) && (range[2] > rowIdx))))
                    isClear = true;
                if ((colIdx === -1) || ((colIdx != -1) && ((range[1] <= colIdx) && (range[3] > colIdx))))
                    isClear = true;
            }
            return { isClear: isClear, isAlert: isAlert, isCancel: isCancel };
        },

		_checkTableApplied: function (sheetIdx, rowIdx, rowCount, colIdx, colCount, status) {
		    var chkObj, sheet = this.getSheet(sheetIdx), range, tblManager = sheet.tableManager, tblKeys = this.getObjectKeys(tblManager);
			this._isTableApplied = false;
            for (var i = 0, len = tblKeys.length; i < len; i++) {
				range = tblManager[tblKeys[i]].range;
				chkObj = this._checkFilterMerge(sheetIdx, range, rowIdx, rowCount, colIdx, colCount, status, "filter", false);
				this._isTableApplied = !chkObj.isAlert;
				if(this._isTableApplied)
					return true;
            }   
			return false;
        },
		
        _refreshAllMergeCells: function (sheetIdx, rowIdx, rowCount, colIdx, colCount, status) {
            var mergeObj, mRange, isPMerge, sheet = this.getSheet(sheetIdx), isSingleMerge = false, mCells = sheet._unmergeColl, dupDetail = this._dupDetails, rKey, cKey, rKeys, cKeys, range, container = this._dataContainer.sheets[sheetIdx], stRng, endRng, isClear;
            rKeys = this.getObjectKeys(mCells);
            this._dupDetails = true;
            for (var i = 0, len = rKeys.length; i < len; i++) {
                if (parseInt(rKeys[i]) > rowIdx) {
                    if (status.indexOf("insert") > -1)
                        rKey = parseInt(rKeys[i]) + rowCount;
                    else
                        rKey = parseInt(rKeys[i]) - rowCount;
                }
                else
                    rKey = rKeys[i];
                cKeys = this.getObjectKeys(mCells[rKeys[i]]);
                for (var j = 0; j < cKeys.length; j++) {
                    if (parseInt(cKeys[j]) > colIdx) {
                        if (status.indexOf("insert") > -1)
                            cKey = parseInt(cKeys[j]) + colCount;
                        else
                            cKey = parseInt(cKeys[j]) - colCount;
                    }
                    else
                        cKey = cKeys[j];
                    mergeObj = sheet._unmergeColl[rKeys[i]][cKeys[j]].merge;
                    this.mergeCenter = (sheet._unmergeColl[rKeys[i]][cKeys[j]].type === "center");
					isClear = sheet._unmergeColl[rKeys[i]][cKeys[j]].isClear;
                    range = this.getRangeIndices(mergeObj.mRange);
                    if (rowIdx > -1 || colIdx > -1) {
                        if (!ej.isNullOrUndefined(range)) {
                            if (status.indexOf("Shift") > -1) {
                                this._unMergeRange = mergeObj.mRange;
                                this._showAlertDlg("", "MergeCellsAlert", "MergeCellsInsertAlert", 498);
                            }
                            else {
                                if (rowIdx > -1) {
									if (range[0] === range[2])
                                        isSingleMerge = true;                             
                                    if (!isSingleMerge || isClear) {
										stRng = range[0];
										endRng = range[2];
										if (rowIdx <= range[0])
                                            stRng = (status === "insert") ? range[0] + rowCount : range[0] - rowCount;
                                        if (rowIdx <= range[2])
                                            endRng = (status === "insert") ? range[2] + rowCount : range[2] - rowCount;
										if(stRng <= endRng)
											range[0] = stRng;
										if(endRng >= stRng)
											range[2] = endRng;
									}
                                }
                                if (colIdx > -1) {
									if (range[1] === range[3])
                                        isSingleMerge = true;                           
                                    if (!isSingleMerge || isClear) {
										stRng = range[1];
										endRng = range[3];
                                        if (colIdx <= range[1])
                                            stRng = (status === "insert") ? range[1] + colCount : range[1] - colCount;
                                        if (colIdx <= range[3])
                                            endRng = (status === "insert") ? range[3] + colCount : range[3] - colCount;
										if(stRng <= endRng)
											range[1] = stRng;
										if(endRng >= stRng)
											range[3] = endRng;
									}
                                }
                                if (!isSingleMerge || (isSingleMerge && status === "insert")) {
                                    mRange = this._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);                               
                                    this.mergeCells(mRange, true);
                                    delete sheet._unmergeColl[rKeys[i]][cKeys[j]];
                                    isSingleMerge = false;
									isPMerge = false;
                                }
								else 
									sheet._unmergeColl[rKeys[i]][cKeys[j]]["isClear"] = false;
                            }
                        }
                    }
                }
            }
            this._dupDetails = dupDetail;
        },

        _clearMergeColl: function(mergeColl, rowIdx, colIdx) {
			mergeColl[rowIdx] && delete mergeColl[rowIdx][colIdx];
            if (this.getObjectKeys(mergeColl[rowIdx]).length < 1)
                delete mergeColl[rowIdx];
        },

		_refreshSHMergeCells: function(sheetIdx, idxColl, count, action, operation) {
		    var k, mcellValue, hideColl, isModified, newSpan, isSamePosn, isMerge, stIdx, enIdx, diff, mergeType, sheet = this.getSheet(sheetIdx), stRng, endRng, mCells = $.extend(true, {}, sheet._mergeColl), rKeys, cKeys,
				diffIdx = 0, mergeObj, mRange, isMoved, isMergeCell, isFullMerge = false, isSingleMerge = false, hideCount, kIdx,
				hideIdx, stRowIdx, stColIdx, endRowIdx, endColIdx, isWithinMerge = false, hideIdx, remRng, oldRange, oldRng, stOldRng, enOldRng;
           rKeys = this.getObjectKeys(mCells);
		   if (sheet._isFreezed)
		        hideColl = (action === "column") ? sheet._fHMergeCols : sheet._fHMergeRows;
		   else
		        hideColl = (action === "column") ? this.getObjectKeys(sheet.hideColsCollection) : sheet.hideRowsCollection;
			if (operation === "hide") {
			    for (var i = 0, ilen = rKeys.length; i < ilen; i++) {
                    cKeys = this.getObjectKeys(mCells[rKeys[i]]);
                    for (var j = 0, jlen = cKeys.length; j < jlen; j++) {
                        isModified = false; isMoved = false; newSpan = 0; isSamePosn = false, isMerge = false;
                        mergeObj = this.XLEdit.getPropertyValue(rKeys[i], cKeys[j], "merge");
                        if (this.getObjectKeys(mergeObj).length < 1)
                            continue;
                        mRange = this.getRangeIndices(mergeObj.mRange);
                        stRng = (action === "column") ? mRange[1] : mRange[0];
                        endRng = (action === "column") ? mRange[3] : mRange[2];
                        for (k = stRng; k <= endRng; k++) {
                            if (idxColl.indexOf(k) > -1){
                                isMerge = true;
                                break;
                            }
                        }
                        if (!isMerge)
                            continue;
                        this._dupDetails = true;
					    stIdx = idxColl[0]; enIdx = idxColl[idxColl.length - 1];
					    diff = (enIdx - stIdx) + 1;
					    this.mergeCenter = (mCells[rKeys[i]][cKeys[j]]["type"] === "center");
						oldRng = mCells[rKeys[i]][cKeys[j]]["oldRange"];
						remRng = oldRng ? oldRng : mergeObj.mRange;
					    this.unmergeCells(mergeObj.mRange);
					    if(enIdx < stRng) {
						    isMoved = true;
						    stRng = stRng + diff;
						    endRng = endRng + diff;
					    }
					    else if (endRng < stIdx)
						    isMoved = false;
					    else {
						    diffIdx = 0; isMergeCell = false; hideIdx = 0;
						    for (var k = 0, klen = idxColl.length; k < klen; k++) {
							    if(idxColl[k] >= stRng && idxColl[k] <= endRng )
								    diffIdx++;
							    if(idxColl[k] === stRng)
								    isMergeCell = true;
								kIdx = (action === "column") ? idxColl[k].toString() : idxColl[k];
								if(hideColl.indexOf(kIdx) > -1)
									hideIdx++;
						    }
						    if(idxColl.indexOf(stRng) > -1)
							    isMergeCell = true;
						    hideCount = 0;
						    for(var l = stRng; l <= endRng; l++) {
							    (action === "column") && (l = l.toString());
							    if(hideColl.indexOf(l) > -1)
								    hideCount++;
								
						    }
						    if((stRng === endRng) || (hideCount === (endRng - stRng)+ 1))
							    isFullMerge = true;
						    if(isMergeCell && !isFullMerge)
							    stRng = (stRng + diffIdx) + (hideCount - hideIdx);
					    }
                        mcellValue = this.XLEdit.getPropertyValue(parseInt(rKeys[i]), parseInt(cKeys[j]));
					    stRowIdx = (action === "row") ? stRng : mRange[0];
					    endRowIdx = (action === "row") ? endRng : mRange[2];
					    stColIdx = (action === "column") ? stRng : mRange[1];
					    endColIdx = (action === "column") ? endRng : mRange[3];
					    if (!isFullMerge) {
					        this.mergeCells(this._getAlphaRange(sheetIdx, stRowIdx, stColIdx, endRowIdx, endColIdx), true);
                            if (sheet._mergeColl[stRowIdx] && sheet._mergeColl[stRowIdx][stColIdx])
						        sheet._mergeColl[stRowIdx][stColIdx]["oldRange"] = remRng;
					        this._updateMergeColl(sheetIdx, stRowIdx, stColIdx, mCells[rKeys[i]][cKeys[j]]["type"], operation === "hide");
					        if (((enIdx + 1 === stRowIdx && action === "row") || (enIdx + 1 === stColIdx && action === "column")) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(stRowIdx, stColIdx)))
					            this.XLEdit.updateCellValue({ rowIndex: stRowIdx, colIndex: stColIdx }, mcellValue);
					    }
                        else {
                            if (rKeys[i] in sheet._delmergeColl)
                                sheet._delmergeColl[rKeys[i]][cKeys[j]] = { type: mCells[rKeys[i]][cKeys[j]]["type"], merge: mergeObj, oldRange : remRng };
                            else {
                                sheet._delmergeColl[rKeys[i]] = {};
                                sheet._delmergeColl[rKeys[i]][cKeys[j]] = { type: mCells[rKeys[i]][cKeys[j]]["type"], merge: mergeObj, oldRange : remRng };
                            }
					    }
					    this.mergeCenter = false;
                    }
			    }
			}
			if (operation === "show") {
			    if (this.getObjectLength(sheet._delmergeColl) > 0)
			        mCells = $.extend(true, mCells, sheet._delmergeColl);
				rKeys = this.getObjectKeys(mCells);
			    for (var i = 0, iLen = rKeys.length; i < iLen; i++) {
			        cKeys = this.getObjectKeys(mCells[rKeys[i]]);
			        for (var j = 0, jLen = cKeys.length; j < jLen; j++) {
				        isMerge = false;
						mergeType =  mCells[rKeys[i]][cKeys[j]].mergeType;
			            mergeObj = mCells[rKeys[i]][cKeys[j]].merge;
			            if (this.getObjectKeys(mergeObj).length < 1)
			                mergeObj = this.XLEdit.getPropertyValue(rKeys[i], cKeys[j], "merge");
			            if (this.getObjectKeys(mergeObj).length > 0) {
			                mRange = this.getRangeIndices(mergeObj.mRange);
							stRng = (action === "column") ? mRange[1] : mRange[0];
			                endRng = (action === "column") ? mRange[3] : mRange[2];						
							oldRng = mCells[rKeys[i]][cKeys[j]]["oldRange"];
							if(oldRng) {
								oldRange = this.getRangeIndices(oldRng);
								stOldRng = (action === "column") ? oldRange[1] : oldRange[0];
								enOldRng = (action === "column") ? oldRange[3] : oldRange[2];
			                }
							else {
								stOldRng = stRng;
								enOldRng = endRng;
							}
		                    stIdx = idxColl[0]; enIdx = idxColl[idxColl.length - 1];
			                for (k = stIdx; k <= enIdx; k++) {
			                    if (k >= stOldRng && k <= enOldRng) {
 			                        isMerge = true;
			                        break;
			                    }
			                }
			                if (!isMerge)
			                    continue;
							if(mergeType === "merge-cells") {
								this._dupDetails = true;
								diff = (enIdx - stIdx) + 1;	                    
								if (enIdx < stRng) {
									this.mergeCenter = mergeObj.isCenterAlign;
									this.unmergeCells(mergeObj.mRange);
									isMoved = true;
									if (diff != 1)
										endRng = endRng - diff;
									stRng = stRng - diff;
									stRowIdx = (action === "row") ? stRng : mRange[0];
									endRowIdx = (action === "row") ? endRng : mRange[2];
									stColIdx = (action === "column") ? stRng : mRange[1];
									endColIdx = (action === "column") ? endRng : mRange[3];
									this.mergeCells(this._getAlphaRange(sheetIdx, stRowIdx, stColIdx, endRowIdx, endColIdx), true);
									this._updateMergeColl(sheetIdx, stRowIdx, stColIdx, mCells[rKeys[i]][cKeys[j]]["type"], operation === "hide");
									sheet._mergeColl[stRowIdx][stColIdx]["oldRange"] = oldRng;
								}
							}
			                isWithinMerge = false;
			                for (var k = 0, klen = idxColl.length; k < klen; k++) {
			                    if (((action === "row") && mRange[0] <= idxColl[k]) || ((action === "column") && mRange[1] <= idxColl[k])) {
			                        isWithinMerge = true;
			                        break;
			                    }
			                }
			                if (isWithinMerge) {
								this.mergeCenter = mergeObj.isCenterAlign;
								this.unmergeCells(mergeObj.mRange);
			                    mRange = this.getRangeIndices(mergeObj.mRange);
			                    diff = 0;
			                    for (var l = stRng; l <= endRng; l++) {
									(action === "column") && (l = l.toString());
			                        if (hideColl.indexOf(l) > -1)
			                            diff++;
			                        else
			                            break;
			                    }
			                    stRng = stRng + diff;
			                    if (action === "column")
			                        mRange[1] = stRng;
			                    else
			                        mRange[0] = stRng;
			                    this.mergeCells(this._getAlphaRange(sheetIdx, mRange[0], mRange[1], mRange[2], mRange[3]), true);
			                    this._updateMergeColl(sheetIdx, mRange[0], mRange[1], mCells[rKeys[i]][cKeys[j]]["type"], true);
								sheet._mergeColl[mRange[0]][mRange[1]]["oldRange"] = oldRng;
			                    this._clearMergeColl(sheet._delmergeColl, rKeys[i], cKeys[j]);
			                }
			            }
						this.mergeCenter = false;
			        }
			    }
			}
            this._dupDetails = false;
		},
		
		_getSpanFromMCells: function(rowIdx, colIdx, span) {
            var sheet = this.getSheet(this.getActiveSheetIndex()), hideMColl = sheet._hideMergeColl;
            if (!this.isUndefined(hideMColl[rowIdx]) && !this.isUndefined(hideMColl[rowIdx][colIdx])) {
                if (span === "row")
                    return hideMColl[rowIdx][colIdx]["rowspan"];
                else
                    return hideMColl[rowIdx][colIdx]["colspan"];
            }
            return 0;
        },

        _setSpanToMCells: function (rowIdx, colIdx, span, value) {
            var sheet = this.getSheet(this.getActiveSheetIndex()), hideMColl = sheet._hideMergeColl;
            this.isUndefined(hideMColl[rowIdx]) && (hideMColl[rowIdx] = {});
            this.isUndefined(hideMColl[rowIdx][colIdx]) && (hideMColl[rowIdx][colIdx] = {});
            (span === "row") ? (hideMColl[rowIdx][colIdx]["rowspan"] = value) : (hideMColl[rowIdx][colIdx]["colspan"] = value);
        },

        sendDataRenderingRequest: function (args, sheetIdx) {
            var i, j, k, idx, isSelect = false, rowHtColl, hideRowColl, len, filteredValue, fltrRange, ln, ralign = this._rAlign, sheet = this.getSheet(sheetIdx), isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling,
                range = sheet._selectedRange, fltrdIdxes = [], cellIdx, columns, activeCell, filteredRowsColl = sheet.filteredRowsCollection, stRow, isHidden, tabIdx, tab = sheet.filterSettings.tableRange, hiddenIdx = [],
                filterColumn, predicate, valColl = [], filtered;
            for (i = 0, len = tab.length; i < len; i++) {
                if (tab[i].tableID == args.tableID) {
                    tabIdx = i;
                    break;
                }
            }
            if (isVirtualScroll) {
                rowHtColl = sheet.rowsHeightCollection;
                hideRowColl = sheet.hideRowsCollection;
            }
            this._dupDetails = true;
            if (!(ej.isNullOrUndefined(args)) && (args.reqType == "filter")) {
                cellIdx = this._generateColCount(args.fieldName) - 1;
                idx = $.inArray(args.fieldName, sheet._filteredColumns);
                if (args.action.indexOf("clearfiltering") > -1)
                    sheet._filteredColumns.splice(idx, 1);
                else if(idx < 0)
                    sheet._filteredColumns.push(args.fieldName);
                range = args.range;
                hiddenIdx = tab[tabIdx].hiddenIdx;
                filteredValue = args.currentViewData;
                if (args.requestType.indexOf("filtering") > -1 || args.requestType.indexOf("filterbycell") > -1 || args.action.indexOf("clearfiltering") === -1) {
                    fltrRange = sheet.filterSettings.filteredRange;
                    (filteredValue.length < 1) && fltrdIdxes.push(fltrRange[fltrRange.length - 1].idx + 1);
                    for (i = 0, len = filteredValue.length; i < len; i++) {
                        idx = fltrRange.indexOf(filteredValue[i]);
                        if (idx > -1)
                            fltrdIdxes.push(fltrRange[idx].idx);
                    }
                    tab[tabIdx].fltrdIdxes = fltrdIdxes;
                    stRow = (range.startRow === 0) ? 0 : range.startRow;
                    for (k = stRow; k <= range.endRow; k++) {
                        filtered = false;
                        for (j = 0, ln = fltrdIdxes.length; j < ln; j++)
                            (fltrdIdxes[j] == k) && (filtered = true);
                        if (filtered) {
                            if (!ej.isNullOrUndefined(this._dataContainer.sheets[sheetIdx][k])) {
                                if (!ej.isNullOrUndefined(this._dataContainer.sheets[sheetIdx][k][0])) {
                                    delete this._dataContainer.sheets[sheetIdx][k][0]["isFilterHide"];
                                    delete this._dataContainer.sheets[sheetIdx][k][0]["filterID"];
                                    if (sheet._filterHRowsColl.indexOf(k) > -1)
                                        sheet._filterHRowsColl.splice(sheet._filterHRowsColl.indexOf(k), 1);
                                }
                            }
                            if (!isVirtualScroll) {
                                this._dupDetails = this._isFilter = true;
                                this._showRow(k + 1, k);
                                this._dupDetails = this._isFilter = false;
                                if (filteredRowsColl.indexOf(k) > -1)
                                    filteredRowsColl.splice(filteredRowsColl.indexOf(k), 1);
                                if ((!sheet._isImported || sheet._isLoaded) && !isSelect) {
                                    isSelect = !isSelect;
                                    this.performSelection({ rowIndex: k, colIndex: cellIdx }, { rowIndex: k, colIndex: cellIdx });
                                }
                            }
                            else {
                                if (hideRowColl.indexOf(k) > -1) {
                                    this._refreshSHMergeCells(sheetIdx, [k], 1, "row", "show");
                                    hideRowColl.splice(hideRowColl.indexOf(k), 1);
                                }
                                stRow = (k === 0) ? 0 : k - 1;
                                if (this.XLEdit.getPropertyValue(stRow, 0, "hRow")) {
                                    delete this._dataContainer.sheets[sheetIdx][stRow][0]["hRow"];
                                    (filteredRowsColl.indexOf(k) > -1) && filteredRowsColl.splice(filteredRowsColl.indexOf(k), 1);
                                }
                            }
                        }
                        else {
                            if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(k, 0, "isRHide")) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(k, 0, "isFHide")) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(k, 0, "isFilterHide"))) {
                                this.XLEdit._updateDataContainer({ rowIndex: k, colIndex: 0 }, { dataObj: { "isFilterHide": true, "filterID": args.tableID } });
                                (filteredRowsColl.indexOf(k) < 0) && filteredRowsColl.push(k);
                                isHidden = true;
                            }
                            if (!isVirtualScroll) {
                                this._dupDetails = this._isFilter = true;
                                this._hideRow(k, k, "isFilterHide");
                                this._dupDetails = this._isFilter = false;
                                (filteredRowsColl.indexOf(k) === -1) && filteredRowsColl.push(k);
                            }
                            else {
                                if (isHidden) {
                                    hideRowColl.push(k);
                                    isHidden = false;
                                    this._refreshSHMergeCells(sheetIdx, [k], 1, "row", "hide");
                                }
                                stRow = (k === 0) ? 0 : k - 1;
                                this.XLEdit._updateDataContainer({ rowIndex: stRow, colIndex: 0 }, { dataObj: { hRow: true } });
                                (filteredRowsColl.indexOf(k) < 0) && filteredRowsColl.push(k);
                            }
                        }
                    }
                    stRow = (range.startRow === 0) ? 0 : range.startRow - 1;
                    if (isVirtualScroll && (!sheet._isImported || sheet._isLoaded)) {
                        this.refreshContent(sheetIdx);
                        this.performSelection({ rowIndex: stRow, colIndex: cellIdx }, { rowIndex: stRow, colIndex: cellIdx });
                    }
                    this.XLScroll._getRowHeights(sheetIdx, stRow);
                    columns = sheet.columns;
                    if (args.action === "clearfiltering") {
                        sheet._filteredByColor = -1;
                        this._excelFilter.closeXFDialog();
                    }
                    this.model.allowFiltering && this.XLFilter._updateFilterIcons(stRow, range.startRow, cellIdx, args.action);
                    tab[tabIdx].hiddenIdx = $.extend(true, [], hiddenIdx);
                    hiddenIdx = [];
                }
            }
            else if (!(ej.isNullOrUndefined(args)) && (args.requestType === "sortbycolor" || args.requestType === "filterbycolor")) {
                var startRow = range.startRow, count = [], color, tableFilteredColumn = [], newIdx, cellIdx = this._generateColCount(args.columnName) - 1, rng, rangeData, cells;
                args.prev = {}; args.cur = {};
                if (args.oprType.indexOf("Put") < 0) {
                    if (sheet._filterColl[range.startRow - 1][cellIdx].status.indexOf("e-ssfilter") > -1 && args.requestType === "filterbycolor") {
                        if (this._isRowViewable(sheetIdx, range.startRow - 1)) {
                            activeCell = this.getCell(range.startRow - 1, cellIdx);
                            activeCell.removeClass(ralign);
                            this.XLFilter._changeFilterIcon({ rowIndex: range.startRow - 1, colIndex: cellIdx }, "filter", this.XLEdit.getPropertyValue(range.startRow - 1, cellIdx, "filterState"));
                        }
                    }
                    else if (sheet._filterColl[range.startRow - 1][cellIdx].status.indexOf("-asc")) {
                        args.prev.icon = sheet._filterColl[range.startRow - 1][cellIdx].status;
                        if (this._isRowViewable(sheetIdx, range.startRow - 1)) {
                            activeCell = this.getCell(range.startRow - 1, cellIdx);
                            this.XLFilter._changeSortIcon({ rowIndex: range.startRow - 1, colIndex: cellIdx }, "ascending");
                        }
                        args.cur.icon = sheet._filterColl[range.startRow - 1][cellIdx].status;
                    }
                }
                if (args.requestType === "sortbycolor") {
                    rng = [range.startRow, cellIdx, range.endRow, cellIdx];
                    rangeData = this.getRangeData({ range: rng, skipHiddenRow: true });
                    for (var i = 0, ln = rangeData.length; i < ln; i++) {
                        color = rangeData[i].formats;
                        if (!ej.isNullOrUndefined(color)) {
                            if (args.operation === "sortbgcolor") {
                                if (!ej.isNullOrUndefined(color["background-color"]))
                                    (args.bgcolor === color["background-color"].toLowerCase()) && count.push(i);
                            }
                            else {
                                if (!ej.isNullOrUndefined(color["color"]))
                                    (args.fgcolor === color["color"].toLowerCase()) && count.push(i);
                            }
                        }
                    }
                    var multifilterIdx, remData, totData, j, c, len;
                    if (args.oprType === "PutCellColor" || args.oprType === "PutFontColor")
                        rng = args.sortRange;
                    if (this.isUndefined(args.tableID)) {
                        multifilterIdx = [];
                        for (var col = rng[1]; col <= rng[3]; col++)
                            multifilterIdx.push(col);
                    }
                    else
                        multifilterIdx = tab[tabIdx].multifilterIdx;
                    rng = [range.startRow, multifilterIdx[0], range.endRow, multifilterIdx[multifilterIdx.length - 1]];
                    rangeData = this.getRangeData({ range: rng, skipHiddenRow: true });
                    args.prev.data = $.extend(true, [], rangeData);
                    rng.colIndex = cellIdx;
                    args.range = rng;
                    for (j = 0, len = multifilterIdx.length; j < len; j++) {
                        remData = [], totData = [];
                        rng = [range.startRow, multifilterIdx[j], range.endRow, multifilterIdx[j]];
                        rangeData = this.getRangeData({ range: rng, skipHiddenRow: true });
                        for (c = count.length - 1; c >= 0; c--)
                            remData.push(rangeData.splice(count[c], 1)[0]);
                        totData = remData.reverse().concat(rangeData);
                        if (remData.length > 0) {
                            this._isSort = true;
                            this._dupDetails = true;
                            this.XLComment.deleteComment(rng, null, true, null);
                            this._removeHyperlink(null, null, true, rng);
                            this.clearRangeData(rng, ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "comment", "hyperlink", "format"], null, true);
                            this.XLFormat.removeStyle(rng, { cellStyle: true, tableStyle: true, format: true, skipHiddenRow: true });
                            this._isSort = false;
                            this._dupDetails = false;
                            this.XLEdit.updateCellWithContainer(totData, rng, sheetIdx, true);
                        }
                    }
                    rng = [range.startRow, multifilterIdx[0], range.endRow, multifilterIdx[multifilterIdx.length - 1]];
                    args.cur.data = $.extend(true, [], this.getRangeData({ range: rng, skipHiddenRow: true }));
                    this.updateUndoRedoCollection(args);
                }
                else {
                    var firstVal, isTake, fltrText;
                    tableFilteredColumn = [], hiddenIdx = [];
                    tab[tabIdx].fltrdIdxes = fltrdIdxes = args.fltrdIdxes;
                    stRow = (range.startRow === 0) ? 0 : range.startRow;
                    for (k = stRow ; k <= range.endRow; k++) {
                        filtered = false;
                        for (j = 0, ln = fltrdIdxes.length; j < ln; j++)
                            (fltrdIdxes[j] == k) && (filtered = true);
                        if (filtered) {
                            fltrText = this.XLEdit.getPropertyValue(k, cellIdx, "value2");
                            fltrText = ej.isNullOrUndefined(fltrText) ? "" : fltrText;
                            filterColumn = { field: args.columnName, value: fltrText, predicate: "or", operator: "equal", matchcase: false };
                            predicate = ej.Predicate(args.columnName, "equal", fltrText);
                            if (this.XLEdit.getPropertyValue(k, 0, "filterID") === args.tableID) {
                                delete this._dataContainer.sheets[sheetIdx][k][0]["isFilterHide"];
                                delete this._dataContainer.sheets[sheetIdx][k][0]["filterID"];
                                if (!isVirtualScroll) {
                                    this._dupDetails = this._isFilter = true;
                                    this._showRow(k + 1, k);
                                    this._dupDetails = this._isFilter = false;
                                    if (filteredRowsColl.indexOf(k) > -1)
                                        filteredRowsColl.splice(filteredRowsColl.indexOf(k), 1);
                                    if ((!sheet._isImported || sheet._isLoaded) && !isSelect) {
                                        isSelect = !isSelect;
                                        this.performSelection({ rowIndex: k, colIndex: cellIdx }, { rowIndex: k, colIndex: cellIdx });
                                    }
                                }
                                else {
                                    hideRowColl.splice(hideRowColl.indexOf(k), 1);
                                    this._refreshSHMergeCells(sheetIdx, [k], 1, "row", "show");
                                }
                            }
                            tableFilteredColumn.push(filterColumn);
                            valColl.push(filterColumn);
                            firstVal = valColl[0]; isTake = firstVal["from"];
                        }
                        else {
                            if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(k, 0, "isRHide")) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(k, 0, "isFHide")) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(k, 0, "isFilterHide"))) {
                                this.XLEdit._updateDataContainer({ rowIndex: k, colIndex: 0 }, { dataObj: { "isFilterHide": true, "filterID": args.tableID } });
                                isHidden = true;
                            }
                            if (!isVirtualScroll) {
                                this._dupDetails = this._isFilter = true;
                                this._hideRow(k, k, "isFilterHide");
                                this._dupDetails = this._isFilter = false;
                                (filteredRowsColl.indexOf(k) === -1) && filteredRowsColl.push(k);
                            }
                            else {
                                if (isHidden) {
                                    hideRowColl.push(k);
                                    this._refreshSHMergeCells(sheetIdx, [k], 1, "row", "hide");
                                }
                            }
                            isHidden = false;
                        }
                    }
                    if (isVirtualScroll && (!sheet._isImported || sheet._isLoaded)) {
                        this.refreshContent(sheetIdx);
                        this.performSelection({ rowIndex: fltrdIdxes[0], colIndex: cellIdx }, { rowIndex: fltrdIdxes[0], colIndex: cellIdx });
                    }
                    this.XLScroll._getRowHeights(sheetIdx, stRow); args.filterCollection = tableFilteredColumn;
                    predicate = firstVal["ejpredicate"] ? firstVal["ejpredicate"] : ej.Predicate(firstVal.field, firstVal.operator, firstVal.value, !firstVal.matchcase);
                    for (j = 1; j < valColl.length; j++)
                        predicate = valColl[j].ejpredicate != undefined ? predicate[valColl[j].predicate](valColl[j].ejpredicate) : predicate[valColl[j].predicate](valColl[j].field, valColl[j].operator, valColl[j].value, !valColl[j].matchcase);
                    if (ej.isNullOrUndefined(tab[tabIdx].predicate[args.columnName]))
                        tab[tabIdx].predicate[args.columnName] = {};
                    tab[tabIdx].filteredColumns = tableFilteredColumn;
                    tab[tabIdx].predicate[args.columnName] = !isTake ? predicate : { from: firstVal["from"], take: firstVal["take"] };
                    tab[tabIdx].hiddenIdx = $.extend(true, [], hiddenIdx);
                    hiddenIdx = [];
                }
            }
            if (!(ej.isNullOrUndefined(args)) && (args.action === "filter" || args.action === "filtering" || args.action === "filterbycolor")) {
                if (args.tableID > -1)
                    sheet.filterSettings.tableRange[tabIdx].filterColumnName.push(args.fieldName);
                this.XLFilter._fltrRowHighlight(range.startRow, range.endRow, "add", args.tableID, args.filterCollection.length);
            }
            else if (args.action === "clearfiltering") {
                if (args.tableID > -1)
                    sheet.filterSettings.tableRange[tabIdx].filterColumnName.pop(args.fieldName);
                this.XLFilter._fltrRowHighlight(range.startRow, range.endRow, "clear", args.tableID, args.filterCollection.length);
            }
            this._dupDetails = false;
            if (this.model.showRibbon && this.model.allowFiltering) {
                var btnObj = $("#" + this._id + "_Ribbon_Data_SortFilter_ClearFilter").data("ejButton"), target = { rowIndex: this.getActiveCell().rowIndex, colIndex: this.getActiveCell().colIndex };
                this.XLRibbon._changeClrFltrStatus(btnObj, "button", target);
            }
            if (this.model.scrollSettings.allowScrolling)
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical", "filter");
        },

        _filterClose: function (target) {
            if (!this.model.allowFiltering)
                return;
            if (!this._hasClass(target, "e-filterspan") && $(target).parents(".e-excelfilter").length < 1 && this._excelFilter._openedFltr && $(this._excelFilter._openedFltr).is(":visible")) {
                this._excelFilter.closeXFDialog();
                this.XLFilter._isSearchEdit = false;
            }
        },

        showPager: function (status) {
            var settings;
            this.model.showPager = status, settings = this.model.scrollSettings;
            this.element.find(".e-spreadsheetfooter").css("display", status ? "block" : "none");
            this._setSheetWidthHeight(this.getActiveSheetIndex(), { width: this._responsiveWidth, height: this._responsiveHeight });
        },

        _refreshClipboard: function (rObjElem, operation) {
            var model = this.model, xlId = this._id;
            if (rObjElem.length) {
                if (!model.allowFormatPainter || !model.allowCellFormatting)
                    rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard")[operation]();
                rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_1")[operation]();
                rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_Home_Clipboard_Cut")[operation]();
                rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_Home_Clipboard_Copy")[operation]();
            }
        },

        _setModel: function (options) {
            var val, option, formulaBar, expProp, picProp, autofillProp, importProp, sheetIdx = this.getActiveSheetIndex(), checkObj, model = this.model, settings = model.scrollSettings, xlId = this._id,
				rObj = $("#" + xlId + "_Ribbon").ejRibbon("instance"), rObjElem = this.model.showRibbon ? rObj.element : [];
            for (option in options) {
                val = options[option];
                switch (option) {
                    case "allowClipboard":
                        if (val) {
                            this._refreshClipboard(rObjElem, "show");
                            if (ej.isNullOrUndefined(this.XLClipboard))
                                this.XLClipboard = new ej.spreadsheetFeatures.clipboard(this);
                            this.XLClipboard._initCopyPaste();
                        }
                        else
                            this._refreshClipboard(rObjElem, "hide");
                        break;
                    case "activeSheetIndex":
                        this.gotoPage(val, false);
                        break;
                    case "pageSettings":
                        !this.isUndefined(options.pageSettings.currentPage) && this.gotoPage(options.pageSettings.currentPage, false);
                        if (!this.isUndefined(options.pageSettings.pageCount)) {
                            this.getPager().ejPager("option", "pageCount", options.pageSettings.pageCount);
                            this._refreshSpreadSheetPager(true);
                        }
                        break;
                    case "allowComments":
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLComment))
                                this.XLComment = new ej.spreadsheetFeatures.comments(this);
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_review_Comments").show();
                            this.XLComment._updateCmntRibIcons();
                        }
                        else
                            this.model.showRibbon && rObjElem.find("#" + xlId + "_Ribbon_review_Comments").hide();
                        break;
                    case "allowFormatPainter":
                        if (model.allowCellFormatting) {
                            if (val) {
                                if (!model.allowClipboard)
                                    rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard").show();
                                if (ej.isNullOrUndefined(this.XLFormat))
                                    this.XLFormat = new ej.spreadsheetFeatures.cellFormatting(this);
                                rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_Home_Clipboard_FormatPainter").show();
                            }
                            else if (rObjElem.length) {
                                if (!model.allowClipboard)
                                    rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard").hide();
                                rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_Home_Clipboard_FormatPainter").hide();
                            }
                        }
                        break;
                    case "allowFormulaBar":
                        if (val) {
                            formulaBar = $("#" + this._id + "_formulabar");
                            if (!formulaBar.length)
                                this._renderFormulaBar(true);
                            else
                                this.showFormulaBar();
                        }
                        else
                            this.hideFormulaBar();
                        this._setSheetWidthHeight(sheetIdx, { width: this._responsiveWidth, height: this._responsiveHeight });
                        break;
                    case "allowHyperlink":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#" + xlId + "_Ribbon_insert_Links").show();
                            else
                                rObjElem.find("#" + xlId + "_Ribbon_insert_Links").hide();
                        break;
                    case "enableContextMenu":
                        if (val && ej.isNullOrUndefined(this.XLCMenu)) {
                            this.XLCMenu = new ej.spreadsheetFeatures.contextmenu(this);
                            this.XLCMenu._initContextMenu();
                            this.XLCMenu._initColorDialog();
                            this.XLCMenu._initCMenuFooter();
                        }
                        break;
                    case "allowEditing":
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLEdit))
                                this.XLEdit = new ej.spreadsheetFeatures.editing(this);
                            this.model.showRibbon && rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_home_Editing").show();
                            this.XLEdit._processEditing();
                            this.model.enableContextMenu && this.XLCMenu._enableMenuOpt(["RenameSheet"], "contextMenuFooter");
                        }
                        else {
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_home_Editing").hide();
                            this.model.enableContextMenu && this.XLCMenu._disableMenuOpt(["RenameSheet"], "contextMenuFooter");
                        }
                        break;
                    case "allowResizing":
                        if (val && ej.isNullOrUndefined(this.XLResize))
                            this.XLResize = new ej.spreadsheetFeatures.resizing(this);
                        break;
                    case "allowDataValidation":
                        if (val) {
                            rObjElem.find("#" + xlId + "_Ribbon_data_DataTools").show();
                            if (ej.isNullOrUndefined(this.XLValidate)) {
                                this.XLValidate = new ej.spreadsheetFeatures.validation(this);
                                this.XLRibbon._renderValDialog(this.XLRibbon._initValDialog());
                                this.XLValidate._addDVMethod();
                            }
                        }
                        else
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_data_DataTools").hide();
                        break;
                    case "allowConditionalFormats":
                        if (val) {
                            rObjElem.find("#" + xlId + "_Ribbon_home_Styles_Home_Styles_ConditionalFormatting").show();
                            this.XLRibbon._initCFDialog();
                            if (ej.isNullOrUndefined(this.XLCFormat))
                                this.XLCFormat = new ej.spreadsheetFeatures.cFormat(this);
                        }
                        else
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_home_Styles_Home_Styles_ConditionalFormatting").hide();
                        break;
                    case "allowSearching":
                        this.model.allowSearching = val;
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLSearch))
                                this.XLSearch = new ej.spreadsheetFeatures.findnreplace(this);
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Editing").show();
                        }
                        else
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Editing").hide();

                        break;
                    case "pictureSettings":
                        for (picProp in val) {
                            switch (picProp) {
                                case "allowPictures":
                                    model.pictureSettings.allowPictures = val[picProp];
                                    if (val[picProp]) {
                                        if (ej.isNullOrUndefined(this.XLShape))
                                            this.XLShape = new ej.spreadsheetFeatures.shape(this);
                                        rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Illustrations").show();
                                    }
                                    else
                                        rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Illustrations").hide();
                                    break;
                            }
                        }
                        break;
                    case "showRibbon":
                        this.model.showRibbon = val;
                        var ribbonDiv = $("#" + xlId + "_Ribbon");
                        if (val) {
                            ribbonDiv.length ? ribbonDiv.show() : this.XLRibbon._renderRibbon(true);
                            rObj = $("#" + xlId + "_Ribbon").ejRibbon("instance");
                            rObjElem = rObj.element;
                            if (rObjElem[0].style.overflow === "hidden")
                                rObjElem[0].style.overflow = "";
                        }
                        else
                            ribbonDiv.hide();
                        this.refreshSpreadsheet();
                        break;
                    case "exportSettings":
                        for (expProp in val) {
                            switch (expProp) {
                                case "allowExporting":
                                    model.exportSettings.allowExporting = val[expProp];
                                    if (val[expProp]) {
                                        if (model.exportSettings.excelUrl || model.exportSettings.csvUrl || model.exportSettings.pdfUrl)
                                            rObjElem.length && rObjElem.find("#saveas_backStageTab").show();
                                        if (ej.isNullOrUndefined(this.XLExport))
                                            this.XLExport = new ej.spreadsheetFeatures.exporting(this);
                                    }
                                    else {
                                        rObjElem.length && rObjElem.find("#saveas_backStageTab").hide();
                                        rObjElem.length && rObjElem.find("#"+ xlId +"_Ribbon_BackStage_saveas").hide();
                                    }
                                    break;
                                case "excelUrl":
                                    model.exportSettings.excelUrl = val[expProp];
                                    if (val[expProp]) {
                                        rObjElem.length && rObjElem.find("#saveas_backStageTab").show();
                                        rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(0)').show();
                                    }
                                    else
                                        rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(0)').hide();
                                    break;
                                case "csvUrl":
                                    model.exportSettings.csvUrl = val[expProp];
                                    if (val[expProp]) {
                                        rObjElem.length && rObjElem.find("#saveas_backStageTab").show();
                                        rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(1)').show();
                                    }
                                    else
                                        rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(1)').hide();
                                    break;
                                case "pdfUrl":
                                    model.exportSettings.pdfUrl = options[option][expProp];
                                    if (val[expProp]) {
                                        rObjElem.length && rObjElem.find("#saveas_backStageTab").show();
                                        rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(2)').show();
                                    }
                                    else
                                        rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(2)').hide();
                                    break;

                            }
                        }
                        break;
                    case "allowKeyboardNavigation":
                        if (val && ej.isNullOrUndefined(this.XLCellNav))
                            this.XLCellNav = new ej.spreadsheetFeatures.cellNavigation(this);
                        break;
                    case "enablePivotTable":
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLPivot))
                                this.XLPivot = new ej.spreadsheetFeatures.pivot(this);
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Tables_Insert_Tables_PivotTable").show();
                        }
                        else {
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Tables_Insert_Tables_PivotTable").hide();
                            this.hideActivationPanel();
                            this.XLRibbon._toggleAnalyzeTab();
                            this.getSheetElement(sheetIdx).find(".e-ss-activepivot").removeClass("e-ss-activepivot");
                        }
                        break;
                    case "allowAutoFill":
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLDragFill)) {
                                this.XLDragFill = new ej.spreadsheetFeatures.dragFill(this);
                                this._createAutoFillElement();
                            }
                            else
                                this.getAutoFillElem().show();
                            this.XLDragFill.positionAutoFillElement();
                        }
                        else
                            this.getAutoFillElem().hide();
                        break;
                    case "autoFillSettings":
                        for (autofillProp in val) {
                            switch (autofillProp) {
                                case "fillType":
                                    if (model.allowAutoFill)
                                        model.autoFillSettings.fillType = val[autofillProp];
                                    break;
                                case "showFillOptions":
                                    if (model.allowAutoFill)
                                        model.autoFillSettings.showFillOptions = val.showFillOptions;
                                    break;
                            }
                        }
                        break;
                    case "allowSelection":
                        if (val && ej.isNullOrUndefined(this.XLSelection)) {
                            this.XLSelection = new ej.spreadsheetFeatures.selection(this);
                            this._initSelection();
                        }
                        break;
                    case "allowDragAndDrop":
                        if (val && ej.isNullOrUndefined(this.XLDragDrop))
                            this.XLDragDrop = new ej.spreadsheetFeatures.dragAndDrop(this);
                        break;
                    case "allowCellFormatting":
                        if (val) {
                            if (model.allowConditionalFormats || model.allowFormatAsTable)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Styles").show();
                            if (rObjElem.length) {
                                rObjElem.find("#" + xlId + "_Ribbon_home_Font").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Number").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_TopAlign").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_MiddleAlign").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_BottomAlign").show();
                                rObjElem.find("#" + xlId + "_Ribbon_separator_bottom").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_AlignLeft").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_AlignCenter").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_AlignRight").show();
                                rObjElem.find("#" + xlId + "_Ribbon_separator_right").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_DecreaseIndent").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_IncreaseIndent").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_separator_right").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Styles_Home_Styles_CellStyles").show();
                                if (model.allowFormatPainter)
                                    rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_Home_Clipboard_FormatPainter").show();
                                if (model.allowClipboard)
                                    rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard").show();
                            }
                            if (ej.isNullOrUndefined(this.XLFormat))
                                this.XLFormat = new ej.spreadsheetFeatures.cellFormatting(this);
                            if (ej.isNullOrUndefined(this.XLCellFrmtDlg))
                                this.XLCellFrmtDlg = new ej.spreadsheetFeatures.formatCellDialog(this);
                            if ($('#' + xlId + "_formatdlg").length === 0)
                                this.XLCellFrmtDlg._renderCellFrmtDlg();
                        }
                        else if (rObjElem.length) {
                            rObjElem.find("#" + xlId + "_Ribbon_home_Font").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Number").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_TopAlign").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_MiddleAlign").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_BottomAlign").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_separator_bottom").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_AlignLeft").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_AlignCenter").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_AlignRight").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_separator_right").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_DecreaseIndent").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_IncreaseIndent").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_separator_right").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Styles_Home_Styles_CellStyles").hide();
                            rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard_Home_Clipboard_FormatPainter").hide();
                            if (!model.allowClipboard)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Clipboard").hide();
                            if (!model.allowConditionalFormats && !model.allowFormatAsTable)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Styles").hide();
                        }
                        break;
                    case "allowImport":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#open_backStageTab").show();
                            else
                                rObjElem.find("#open_backStageTab").hide();
                        break;
                    case "importSettings":
                        for (importProp in val) {
                            switch (expProp) {
                                case "importMapper":
                                    model.importSettings.importMapper = val[importProp];
                                    break;
                                case "importUrl":
                                    model.importSettings.importUrl = val[importProp];
                                    break;
                                case "password":
                                    model.importSettings.password = val[importProp];
                                    break;
                            }
                        }
                        break;
                    case "allowSorting":
                        var numberDlg = document.getElementById(xlId + "number_MenuItem"), stringDlg = document.getElementById(xlId + "string_MenuItem");
                        if (val) {
                            var menuObj = $("#" + xlId + "_Ribbon_SortFilter").data("ejMenu");
                            if (ej.isNullOrUndefined(this.XLSort))
                                this.XLSort = new ej.spreadsheetFeatures.sorting(this);
                            if (rObjElem.length) {
                                rObjElem.find("#" + xlId + "_Ribbon_data_SortFilter_1").show();
                                rObjElem.find("#" + xlId + "_Ribbon_data_Sort").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_1").show();
                            }
                            menuObj.enableItemByID('Ribbon_SortAtoZ');
                            menuObj.enableItemByID('Ribbon_SortZtoA');
                        }
                        else if (rObjElem.length) {
                            rObjElem.find("#" + xlId + "_Ribbon_data_SortFilter_1").hide();
                            if (!this.model.allowFiltering) {
                                rObjElem.find("#" + xlId + "_Ribbon_data_Sort").hide();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_1").hide();
                            }
                        }
                        if (this.model.allowFiltering) {
                            for (var i = 0; i < 3; i++) {
                                if (!ej.isNullOrUndefined(numberDlg))
                                    numberDlg.childNodes[i].style.display = this.model.allowSorting ? (i === 2 ? "block" : "inline") : "none";
                                if (!ej.isNullOrUndefined(stringDlg))
                                    stringDlg.childNodes[i].style.display = this.model.allowSorting ? (i === 2 ? "block" : "inline") : "none";
                            }
                        }
                        break;
                    case "formatSettings":
                        if (model.allowCellFormatting) {
                            for (var formatSetting in val) {
                                switch (formatSetting) {
                                    case "allowFontFamily":
                                        model.formatSettings.allowFontFamily = val[formatSetting];
                                        if (rObjElem.length)
                                            if (val[formatSetting])
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Font_Home_Font_FontFamily").show();
                                            else
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Font_Home_Font_FontFamily").hide();
                                        break;
                                    case "allowDecimalPlaces":
                                        model.formatSettings.allowDecimalPlaces = val[formatSetting];
                                        if (rObjElem.length)
                                            if (val[formatSetting]) {
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Number_Home_Number_IncreaseDecimal").show();
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Number_Home_Number_DecreaseDecimal").show();
                                                rObjElem.find("#" + xlId + "_Ribbon_separator_Home_Number_CommaStyle").show();
                                            }
                                            else {
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Number_Home_Number_IncreaseDecimal").hide();
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Number_Home_Number_DecreaseDecimal").hide();
                                                rObjElem.find("#" + xlId + "_Ribbon_separator_Home_Number_CommaStyle").hide();
                                            }
                                        break;
                                    case "allowCellBorder":
                                        model.formatSettings.allowCellBorder = val[formatSetting];
                                        if (rObjElem.length)
                                            if (val[formatSetting]) {
                                                rObjElem.find("#" + xlId + "_Ribbon_separator_border").show();
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Font_Home_Font_Border").show();
                                            }
                                            else {
                                                rObjElem.find("#" + xlId + "_Ribbon_separator_border").hide();
                                                rObjElem.find("#" + xlId + "_Ribbon_home_Font_Home_Font_Border").hide();
                                            }
                                        break;
                                }
                            }
                        }
                        break;
                    case "sheets":
                        for (var i = 0, len = val.length; i < len; i++) {
                            for (var oper in val[i]) {
                                if ((this.model.sheetCount < i + 1) && val.length > sheetIdx)
                                    return;
                                switch (oper) {
                                    case "showGridlines":
                                        if (i + 1 === sheetIdx)
                                            this._showGridlines(val[i].showGridlines, sheetIdx);
                                        else
                                            this.getSheet(i + 1).showGridlines = val[i].showGridlines;
                                        break;
                                    case "showHeadings":
                                        if (i + 1 === sheetIdx)
                                            this._showHeadings(val[i].showHeadings, sheetIdx);
                                        else
                                            this.getSheet(i + 1).showHeadings = val[i].showHeadings;
                                        break;
                                }
                            }
                        }
                        break;
                    case "scrollSettings":
                        var settings = {}, isResponsive = model.scrollSettings.isResponsive;
                        if (!ej.isNullOrUndefined(options["scrollSettings"])) {
                            if (!ej.isNullOrUndefined(options["scrollSettings"]["allowScrolling"]))
                                model.scrollSettings.allowScrolling = options["scrollSettings"]["allowScrolling"];
                            if (!ej.isNullOrUndefined(options["scrollSettings"]["allowVirtualScrolling"]))
                                model.scrollSettings.allowVirtualScrolling = options["scrollSettings"]["allowVirtualScrolling"];
                            if (!ej.isNullOrUndefined(options["scrollSettings"]["isResponsive"]))
                                isResponsive = model.scrollSettings.isResponsive = options["scrollSettings"]["isResponsive"];

                            if (!ej.isNullOrUndefined(options["scrollSettings"]["scrollMode"]))
                                if (options["scrollSettings"]["scrollMode"] === "normal")
                                    model.scrollSettings.scrollMode = ej.Spreadsheet.scrollMode.Normal;
                                else
                                    model.scrollSettings.scrollMode = ej.Spreadsheet.scrollMode.Infinite;
                            if (!ej.isNullOrUndefined(options["scrollSettings"]["width"]))
                                model.scrollSettings.width = options["scrollSettings"]["width"];
                            if (!ej.isNullOrUndefined(options["scrollSettings"]["height"]))
                                model.scrollSettings.height = options["scrollSettings"]["height"];
                        }
                        if (!model.scrollSettings.isResponsive) {
                            $.extend(true, settings, this.model.scrollSettings);
                            this.element.height(settings.height).width(settings.width);
                            $("#" + this._id + "_Ribbon").ejRibbon("option", { width: settings.width });
                            this._updateResponsiveSettings();
                            this._setSheetWidthHeight(sheetIdx, { height: this._responsiveHeight, width: this._responsiveWidth });
                        }
                        break;
                    case "allowFiltering":
                        if (val) {
                            var menuObj = $("#" + xlId + "_Ribbon_SortFilter").data("ejMenu");
                            if (rObjElem.length) {
                                rObjElem.find("#" + xlId + "_Ribbon_data_SortFilter_2").show();
                                rObjElem.find("#" + xlId + "_Ribbon_data_Sort").show();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_1").show();
                            }
                            menuObj.enableItemByID('Ribbon_Filter');
                            if (ej.isNullOrUndefined(this.XLFilter))
                                this.XLFilter = new ej.spreadsheetFeatures.filter(this);
                            this.XLFilter._renderExcelFilter();
                        }
                        else if (rObjElem.length) {
                            if (!this.model.allowSorting) {
                                rObjElem.find("#" + xlId + "_Ribbon_data_Sort").hide();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_1").hide();
                            }
                            rObjElem.find("#" + xlId + "_Ribbon_data_SortFilter_2").hide();
                        }
                        break;
                    case "allowInsert":
                        if (val) {
                            if (rObjElem.length && !model.allowDelete)
                                rObjElem.find("#" + xlId + "_Ribbon_others_Cells").show();
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Cells_1").show();
                            this.getPager().find(".e-new").removeClass("e-disable");
                            model.enableContextMenu && this.XLCMenu._enableMenuOpt(["InsertSheet", "MoveorCopy"], "contextMenuFooter");

                        }
                        else {
                            if (rObjElem.length && !model.allowDelete)
                                rObjElem.find("#" + xlId + "_Ribbon_others_Cells").hide();
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Cells_1").hide();
                            this.getPager().find(".e-new").addClass("e-disable");
                            model.enableContextMenu && this.XLCMenu._disableMenuOpt(["InsertSheet", "MoveorCopy"], "contextMenuFooter");
                        }
                        break;
                    case "allowDelete":
                        if (val) {
                            if (!model.allowInsert && rObjElem.length)
                                rObjElem.find("#" + xlId + "_Ribbon_others_Cells").show();
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Cells_2").show();
                            if (model.enableContextMenu && this._getSheetNames(true).length > 1)
                                this.XLCMenu._enableMenuOpt(["DeleteSheet"], "contextMenuFooter");
                        }
                        else {
                            if (!model.allowInsert && rObjElem.length)
                                rObjElem.find("#" + xlId + "_Ribbon_others_Cells").hide();
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Cells_2").hide();
                            model.enableContextMenu && this.XLCMenu._disableMenuOpt(["DeleteSheet"], "contextMenuFooter");
                        }
                        break;
                    case "allowFreezing":
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLFreeze)) {
                                this.XLFreeze = new ej.spreadsheetFeatures.freezepane(this);
                                this.XLFreeze._initFreeze();
                            }
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_others_Window").show();
                        }
                        else if (rObjElem.length)
                            rObjElem.find("#" + xlId + "_Ribbon_others_Window").hide();
                        break;
                    case "allowMerging":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_Merge").show();
                            else
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_Merge").hide();
                        break;
                    case "allowWrap":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_WrapText").show();
                            else
                                rObjElem.find("#" + xlId + "_Ribbon_home_Alignment_Home_Alignment_WrapText").hide();
                        break;
                    case "allowUndoRedo":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Actions").show();
                            else
                                rObjElem.find("#" + xlId + "_Ribbon_home_Actions").hide();
                        break;
                    case "frozenRows":
                        if (model.allowFreezing)
                            this.XLFreeze.freezeRows(val);
                        break;
                    case "frozenColumns":
                        if (model.allowFreezing)
                            this.XLFreeze.freezeColumns(val);
                        break;
                    case "freezePanes":
                        if (model.allowFreezing)
                            this.XLFreeze.freezePanes(val.rowIndex, val.colIndex);
                    case "allowFormatAsTable":
                        if (val) {
                            if (!model.enablePivotTable)
                                rObjElem.find("#" + xlId + "_Ribbon_insert_Tables").show();
                            if (ej.isNullOrUndefined(this.XLFormat))
                                this.XLFormat = new ej.spreadsheetFeatures.cellFormatting(this);
                            if (rObjElem.length) {
                                rObjElem.find("#" + xlId + "_Ribbon_home_Styles_Home_Styles_FormatAsTable").show();
                                rObjElem.find("#" + xlId + "_Ribbon_insert_Tables_Insert_Tables_Table").show();
                            }
                        }
                        else {
                            if (rObjElem.length) {
                                if (!model.enablePivotTable)
                                    rObjElem.find("#" + xlId + "_Ribbon_insert_Tables").hide();
                                rObjElem.find("#" + xlId + "_Ribbon_home_Styles_Home_Styles_FormatAsTable").hide();
                                rObjElem.find("#" + xlId + "_Ribbon_insert_Tables_Insert_Tables_Table").hide();
                            }
                        }
                        break;
                    case "enablePivotTable":
                        if (rObjElem.length)
                            if (val) {
                                if (!model.allowFormatAsTable && rObjElem.length)
                                    rObjElem.find("#" + xlId + "_Ribbon_insert_Tables").show();
                                rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Tables_Insert_Tables_PivotTable").show();
                            }
                            else {
                                if (!model.allowFormatAsTable && rObjElem.length)
                                    rObjElem.find("#" + xlId + "_Ribbon_insert_Tables").hide();
                                rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Tables_Insert_Tables_PivotTable").hide();
                            }
                        break;
                    case "allowAutoSum":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_Home_Editing_AutoSum").show();
                            else
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_Home_Editing_AutoSum").hide();
                        break;
                    case "allowCharts":
                        if (val) {
                            if (ej.isNullOrUndefined(this.XLChart) || ej.isNullOrUndefined(this.XLShape)) {
                                this.XLShape = new ej.spreadsheetFeatures.shape(this);
                                this.XLChart = new ej.spreadsheetFeatures.chart(this);
                            }
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Charts").show();
                        }
                        else
                            rObjElem.length && rObjElem.find("#" + xlId + "_Ribbon_insert_Charts").hide();
                        break;
                    case "printSettings":
                        for (var pageProp in val) {
                            switch (pageProp) {
                                case "allowPrinting":
                                    model.printSettings.allowPrinting = val[pageProp];
                                    if (val[pageProp]) {
                                        this.XLPrint = new ej.spreadsheetFeatures.print(this);
                                        if (rObjElem.length) {
                                            rObjElem.find("#" + xlId + "_Ribbon_pagelayout_Print").show();
                                            rObjElem.find("#print_backStageTab").show();
                                        }
                                    }
                                    else if (rObjElem.length) {
                                        rObjElem.find("#print_backStageTab").hide();
                                        rObjElem.find("#" + xlId + "_Ribbon_pagelayout_Print").hide();
                                    }
                                    break;
                                case "allowPageSize":
                                    model.printSettings.allowPageSize = val[pageProp];
                                    if (rObjElem.length)
                                        if (val[pageProp])
                                            rObjElem.find("#" + xlId + "_Ribbon_pagelayout_PageLayout").show();
                                        else
                                            rObjElem.find("#" + xlId + "_Ribbon_pagelayout_PageLayout").hide();
                                    break;
                            }
                        }
                        break;
                    case "allowLockCell":
                        if (rObjElem.length)
                            if (val) {
                                rObjElem.find("#" + xlId + "_Ribbon_review_Changes_Review_Changes_ProtectSheet").show();
                                rObjElem.find("#" + xlId + "_Ribbon_review_Changes_Review_Changes_LockCell").show();
                            }
                            else {
                                rObjElem.find("#" + xlId + "_Ribbon_review_Changes_Review_Changes_ProtectSheet").hide();
                                rObjElem.find("#" + xlId + "_Ribbon_review_Changes_Review_Changes_LockCell").hide();
                            }
                        break;
                    case "undoRedoStep":
                        this.undoRedoStep = val;
                        break;
                    case "enableTouch":
                        this._wireTouchEvts(val ? "_on" : "_off");
                        break;
                    case "showPager":
                        this.showPager(options[option]);
                        this._refreshSpreadSheetPager();
                        break;
                    case "allowOverflow":
                        this._refreshOverflow();
                        break;
                    case "allowClear":
                        if (rObjElem.length)
                            if (val)
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_Home_Editing_Clear").show();
                            else
                                rObjElem.find("#" + xlId + "_Ribbon_home_Editing_Home_Editing_Clear").hide();
                        break;
                    case "isReadOnly":
                        this._readOnly();
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._destroy();
                        this.model.sheets.splice(0, 1);
                        this._init();
                        break;
                    case "allowCellType":
                        if (val)
                            this.XLCellType = new ej.spreadsheetFeatures.cellType(this);
                        break;
                    case "activationPanelWidth":
					         this.model.apWidth = val;
                             this.getActivationPanel().width(val - 1)
                        break;
                }
            }
            if (rObjElem && rObjElem.length) {
                if (!model.allowAutoSum && !model.allowFiltering && !model.allowUndoRedo && !model.allowSorting && !model.allowClipboard && !model.allowFormatPainter && !model.allowCellFormatting && !model.allowMerging && !model.allowWrap && !model.allowConditionalFormats && !model.allowFormatAsTable)
                    rObj.hideTab(this._getLocStr("HOME"));
                else
                    rObj.showTab(this._getLocStr("HOME"));
                if (!model.allowFormatAsTable && !model.allowPictures && !model.allowHyperlink && !model.allowCharts)
                    rObj.hideTab(this._getLocStr("INSERT"));
                else
                    rObj.showTab(this._getLocStr("INSERT"));
                if (!model.allowDataValidation && !model.allowFiltering && !model.allowSorting)
                    rObj.hideTab(this._getLocStr("DATATAB"));
                else
                    rObj.showTab(this._getLocStr("DATATAB"));
                if (!model.printSettings.allowPrinting)
                    rObj.hideTab(this._getLocStr("PAGELAYOUT"));
                else
                    rObj.showTab(this._getLocStr("PAGELAYOUT"));
                if (!model.allowComments && !model.allowLockCell)
                    rObj.hideTab(this._getLocStr("REVIEW"));
                else
                    rObj.showTab(this._getLocStr("REVIEW"));
                if (!model.allowFreezing && !model.allowInsert && !model.allowDelete && !model.allowSearching)
                    rObj.hideTab(this._getLocStr("OTHERS"));
                else
                    rObj.showTab(this._getLocStr("OTHERS"));
            }
        },

        // Importing
        "import": function (options) {
            if (!this.model.allowImport)
                return;
            if (!options.dataContainer && this.model.allowCellFormatting && this.XLFormat && (this.getObjectLength(this.XLFormat._customFontFamily) > 0))
                options.dataContainer = JSON.stringify({ "customFontFamily": this.XLFormat._customFontFamily });
            var proxy = this,
            opts = {
                type: "POST",
                data: this._import(options),
                async: this.isUndefined(options.async) ? true : options.async,
                url: this.model["importSettings"].importMapper,
                success: function (response) {
                    proxy._importSuccess(response);
                },
                error: function (err, type) {
                    proxy._importFailed({ type: type, xhr: { status: err.status, statusText: err.statusText } });
                }
            };
            if (this._browserDetails.name !== "msie" || this._browserDetails.version !== "9.0" || opts.data.append) { // !IE9 with for form only
                opts.processData = false;
                opts.contentType = false;
            }
            $('#' + this._id + "_Ribbon_BackStage").hide();
            proxy.showWaitingPopUp();
            $.ajax(opts);
        },

        _import: function (options) {
            if (window.FormData && this._isObject(options)) {
                var i, prop, formData = new FormData();
                for (prop in options) {
                    if (prop != "async")
                        formData.append(prop, options[prop]);
                }
                return formData;
            }
            else
                return options;
        },

        _importSuccess: function (response) {
            var error = ["UnsupportedFile", "IncorrectPassword", "InvalidUrl", "NeedPassword"];
            if (error.indexOf(response) > -1) {
                switch (response) {
                    case error[0]:
                    case error[1]:
                    case error[2]:
                        this._showAlertDlg("Alert", response, "", null, 110);
                        break;
                    case error[3]:
                        this._showDialog(this._id + "_ImportPasswordDialog");
                        this.model.importSettings.password = "";
                        break;
                }
                this.hideWaitingPopUp();
            }
            else
                this.loadFromJSON(JSON.parse(response));
        },

        loadFromJSON: function (response) {
            this.isImport = true;
            $("#" + this._id + "_file").ejUploadbox("option", "autoUpload", true);
            var sheetIdx, sheets, cnts, i = 1, args, nmgr = response.model && response.model.nameManager, j;
            if (nmgr && nmgr.length) {
                for (j in nmgr)
                    nmgr[j].refersto = this._decode(nmgr[j].refersto);
            }
            if (this._isSheetReq) {
                sheetIdx = Number(this.getObjectKeys(response.dataContainer.sheets)[0]);
                this._refreshImpStyles(response.dataContainer.hashCode);
                this._impData.dataContainer = $.extend(true, {}, response.dataContainer);
                this._impData.dataContainer.sheets = this._dataContainer.sheets;
                this._impData.dataContainer.cellType = this._dataContainer.cellType;
                this._impData.dataContainer.sheets[sheetIdx] = response.dataContainer.sheets[sheetIdx];
                this._impData.model.sheets[sheetIdx] = response.sheet;
                this._dataContainer = $.extend(true, {}, this._impData.dataContainer);
                this._dataContainer.sheetCellType = {};
                this._refreshModel(response.sheet, true, sheetIdx);
                this._sheetSettings(sheetIdx);
                if (!this._intrnlReq)
                    this.gotoPage(sheetIdx, false);
                this._isSheetReq = false;
            }
            else {
                if (!this.model.scrollSettings.allowVirtualScrolling)
                    cnts = this._getMaxRowColCnt(response.model.sheets, true);
                if (this.model.scrollSettings.allowVirtualScrolling || (response.dataContainer.sharedData.length < 50001 && cnts.rowCount < 10001 && cnts.colCount < 126)) {
                    this._impData = response;
                    args = { importData: response };
                    if (this._trigger("onImport", args))
                        return;
                    if (this._isInitLoad)
                        this._initBase();
                    else {
                        this._destroy();
                        this._refreshModel(response.model);
                        this._dataContainer = $.extend(true, {}, response.dataContainer);
                        this._dataContainer.sheetCellType = {};
                        this._initCSSTag();
                        while (i <= this.model.sheetCount) {
                            this._sheetSettings(i);
                            this._newSIndex++;
                            i++;
                        }
                        i = 1;
                        while (i <= this.model.sheetCount) {
                            if (!this.model.scrollSettings.allowVirtualScrolling && !this.model.importSettings.allowSheetOnDemand)
                                this._initSheet(i);
                            i++;
                        }
                        this._refreshNameMngr(response.model.nameManager);
                        this.gotoPage(this.getActiveSheetIndex(), false);
                        this._isRibbonDestroyed = false;
                    }
                    this._trigger("loadComplete");
                    this.clearUndoRedo();
                }
                else
                    this._showAlertDlg("Alert", "HugeDataAlert");
            }
            if (!this._intrnlReq)
                this.isImport = false;
            this._intrnlReq = false;
            this._renderDDownList();
            this.hideWaitingPopUp();
        },

        _importFailed: function (response) {
            var args = { failureType: response.type };
            if (response.xhr) {
                args.status = response.xhr.status;
                args.statusText = response.xhr.statusText;
            }
            else
                args.statusText = response.error;
            this.hideWaitingPopUp();
            this._trigger("openFailure", args);
        },

        _importSheet: function (sheetIdx, async) {
            var opts = {}, isettings = this.model.importSettings;
            this._isSheetReq = true;
            opts = { sheetIndex: sheetIdx, allowSheetOnDemand: isettings.allowSheetOnDemand, password: this._encrypt(isettings.password), async: async };
            opts.dataContainer = JSON.stringify({ hashCode: this._dataContainer.hashCode, sharedData: this._dataContainer.sharedData, valData: this._dataContainer.valData, cFormatData: this._dataContainer.cFormatData });
            this["import"](opts);
            this.getSheet(sheetIdx)._isRequested = true;
        },
        _decode: function (value) {
            return $('<div/>').html(value).text();
        },

        _refreshModel: function (options, isSheet, sheetIdx) {
            var len, prop, sheet, i = 1;
            if (options) {
                if (isSheet) {
                    sheet = this.model.sheets[this._getSheetIndex(sheetIdx)];
                    sheet.rowCount = options.rowCount || this.defaults.rowCount;
                    sheet.colCount = options.colCount || this.defaults.colCount;
                }
                else {
                    this.model.sheetCount = options.sheetCount || this.defaults.sheetCount;
                    this.model.activeSheetIndex = options.activeSheetIndex || this.defaults.activeSheetIndex;
                    this.model.rowHeight = options.rowHeight || this.defaults.rowHeight;
                    this.model.columnWidth = options.columnWidth || this.defaults.columnWidth;
                    this.model.sheets = [{}];
                    len = options.sheets.length;
                    while (i < len) {
                        sheet = options.sheets[i];
                        prop = {
                            rowCount: sheet.rowCount || this.defaults.rowCount,
                            colCount: sheet.colCount || this.defaults.colCount
                        };
                        this.model.sheets.push(prop);
                        i++;
                    }
                    if (options.nameManager && options.nameManager.length)
                        this.model.nameManager = options.nameManager;
                }
            }
            else {
                len = this.model.sheets.length;
                if (this.model.sheetCount < len)
                    this.model.sheetCount = len;
            }
            if (this.model.apWidth === 300 && this.model.activationPanelWidth !== 300)
                this.model.apWidth = this.model.activationPanelWidth;
            else if (this.model.apWidth !== 300 && this.model.activationPanelWidth === 300)
                this.model.activationPanelWidth = this.model.apWidth;
        },

        _refreshImpStyles: function (hashcode) {
            var format, code, i = 0, len = hashcode.length;
            while (i < len) {
                code = hashcode[i];
                if (this._dataContainer.hashCode.indexOf(code) === -1) {
                    if (code.indexOf("e-format") === -1) {
                        this._dataContainer.hashCode.push(code);
                        if (code.length < 25) // default border hashcode max len 24 
                            this.XLFormat._writeCssRules(code, this.XLFormat._getCssPropertyAsString({ border: this.XLFormat.getBorderFromHashCode(code) }));
                    }
                    else {
                        format = this.XLFormat.getFormatFromHashCode(code);
                        this.XLFormat._createFormatClass(format);
                    }
                }
                i++;
            }
        },

        _refreshImpSheets: function (sheetIdx) {
            var sheet = this._impData.model.sheets[sheetIdx];
            this._refreshImpCells(sheetIdx);
            this._refreshImpCF(sheetIdx);
            if (this.model.allowMerging && sheet.mergedCells)
                this._refreshImpMC(sheet.mergedCells); //possible
            if (this.model.allowFiltering && sheet.filterSettings && sheet.filterSettings.range)
                this.XLFilter._filterCellRange(sheetIdx, sheet.filterSettings.range);
            this._refreshImpHC(sheet.hideColsCollection);
            this._refreshImpHR(sheet.hideRowsCollection);
            this._refreshImpTable(sheet.tableManager);
            this._refreshOverflow();
            if (this.model.allowCellType)
                this._refreshSheetCellTypes(this._impData.dataContainer.sheetCellType, sheetIdx);
			this._refreshShapePosOnImp(sheet.shapeMngr, sheetIdx);
            this._refreshImpCharts(sheet.shapeMngr.chart);
            this._refreshImpPics(sheet.shapeMngr, sheetIdx);
            this._refreshImpPvts(sheet.pivotMngr, sheetIdx);
            if (sheet.showGridlines === false)
                $("#" + this._id + "_Ribbon_PageLayout_Show_Gridlines").ejCheckBox({ checked: sheet.showGridlines });
            if (sheet.isSheetProtected)
                this.protectSheet(true);
        },

        _refreshImpCells: function (sheetIdx) {
            var data, len, i = 0, usedRange = this.getSheet(sheetIdx).usedRange,
                datas = this.XLEdit._getPropWithCellIdx([0, 0, usedRange.rowIndex, usedRange.colIndex], "value", sheetIdx, true), len = datas.length;
            while (i < len) {
                data = datas[i];
                this.XLEdit._refreshCalcEngine(data.rowIdx, data.colIdx, true, data.value, sheetIdx);
                i++;
            }
            if (this.model.allowCellFormatting && this.model.formatSettings.allowCellBorder) {
                i = 0;
                datas = this.XLEdit._getPropWithCellIdx([0, 0, usedRange.rowIndex, usedRange.colIndex], "borders", sheetIdx);
                len = datas.length;
                while (i < len) {
                    data = datas[i];
                    this.XLFormat.applyBorder(data.value, [data.rowIdx, data.colIdx, data.rowIdx, data.colIdx]);
                    i++;
                }
            }
        },

        _refreshSheetCellTypes: function (sheets, sheetIdx) {
            var arr = [], i, len;
            if (this.getObjectLength(sheets) < 1)
                return;
            for (i = 1, len = this.getObjectLength(sheets[sheetIdx]) ; i <= len; i++)
                arr.push({ "range": sheets[sheetIdx][i].settings.range, "settings": sheets[sheetIdx][i].settings });
            this.XLCellType._rangeCellTypes(arr, sheetIdx, true);
        },

        _refreshImpCF: function (sheetIdx) {
            if (this.model.allowConditionalFormats) {
                var split, i, idx, len = this._impData.dataContainer.cFormatData.length;
                for (i = 0; i < len; i++) {
                    split = this._impData.dataContainer.cFormatData[i].split("_");
                    idx = Number(split[4]);
                    if (idx === sheetIdx) {
                        this.XLCFormat._cFormat(split[0], split[1], split[2], split[3], split[5], idx, this.getRangeIndices(split[5]));
                        this._impData.dataContainer.cFormatData.splice(i, 1);
                        len = this._impData.dataContainer.cFormatData.length;
                        i--;
                    }
                }
            }
        },

        _refreshImpMC: function (mergeCells) {
            var mergeCell, i = mergeCells.length;
            if (i) {
                while (i--) {
                    mergeCell = mergeCells[i];
                    if (mergeCell.isCenterAlign)
                        this.mergeCenter = true;
                    this.mergeCells(mergeCell.range, true);
                    this.mergeCenter = false;
                }
            }
        },

        _refreshImpHC: function (hideCols) {
            var colIdx, hideIdxCln = this.getObjectKeys(hideCols), i = hideIdxCln.length;
            if (i) {
                while (i--) {
                    colIdx = parseInt(hideIdxCln[i]);
                    this._hideColumn(colIdx, colIdx);
                }
            }
        },

        _refreshImpResRowHght: function (sheetIdx) {
            var i, k, span, cls, cIdx, rIdx, hashIdx, cellsData, sheet = this.getSheet(sheetIdx), rowsCols = sheet._restrictedHeightRows, sheetData = this._dataContainer.sheets[sheetIdx],
            hashCodes = this._dataContainer.hashCode, range, height, cellStyle, canRefresh = true, mergedCells = (this._impData && this._impData.model.sheets[sheetIdx] && this._impData.model.sheets[sheetIdx].mergedCells) ? this._impData.model.sheets[sheetIdx].mergedCells : [], mRangeCol = [], val;

            for (k = 0; k < mergedCells.length; k++) {
                range = this.getRangeIndices(mergedCells[k]["range"]);
                mRangeCol.push(range);
            }
            span = this.element.find("#" + this._id + "_emptyDiv");
            for (i = 0; i < rowsCols.length; i++) {
                rIdx = rowsCols[i];
                cellsData = sheetData[rIdx];
                for (cIdx in cellsData) {
                    val = this._dataContainer.sharedData[cellsData[cIdx].value];
                    if (!val || this.isFormula(val))
                        continue;
                    hashIdx = cellsData[cIdx].formats;
                    if (hashIdx) {
                        cls = hashCodes[hashIdx];
                        if (cellsData[cIdx].wrap) {
                            for (k in mRangeCol) {
                                range = mRangeCol[k];
                                if (range[0] <= rIdx && range[2] >= rIdx) {
                                    if (range[1] <= cIdx && range[3] >= cIdx) {
                                        canRefresh = false;
                                        break;
                                    }
                                }
                            }
                            if (canRefresh) {
                                span.width(sheet.columnsWidthCollection[cIdx] - 3); //3 - td padding (left = 2, right = 1)
                                cls += " e-sswraptext";
                            }
                        }
                        this.addClass(span[0], cls);
                        span.text(val);
                        height = span[0].offsetHeight + 1; // 1 - td bottom border
                        if (sheet.rowsHeightCollection[rIdx] < height)
                            sheet.rowsHeightCollection[rIdx] = height;
                        this._refreshGlobalSpan(null, true);
                        canRefresh = true;
                    }
                }
            }
        },

        _refreshImpHR: function (hideRows) {
            var i, idx, preRowIdx, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), hideRows = hideRows || [];
            var rowColl = this.getRows(sheetIdx), rows = rowColl[1], hdrRows = rowColl[0], rowHdrCon = this._getJSSheetRowHeaderContent(sheetIdx), rowHdrElem = rowHdrCon.find("tr"), len;
            for (i = 0, len = hideRows.length; i < len; i++) {
                idx = parseInt(hideRows[i]);
                preRowIdx = idx ? idx - 1 : 0;
                if (this.isUndefined(this.XLEdit.getPropertyValue(preRowIdx, 0, "isRHide")))
                    this.XLEdit._updateDataContainer({ rowIndex: preRowIdx, colIndex: 0 }, { dataObj: { "hRow": true } });
                if (this.model.scrollSettings.allowVirtualScrolling)
                    this.addClass(rowHdrCon.find("[idx =" + preRowIdx + "] .e-rowheader")[0], "e-hrow");
                else {
                    this.addClass(rowHdrElem.find(".e-rowheader")[preRowIdx], "e-hrow");
                    this.addClass(rows[idx], "e-r-hide");
                    this.addClass(hdrRows[idx], "e-r-hide");
                }
                this.XLScroll._getRowHeights(sheetIdx, sheet.hideRowsCollection.sort()[0]);
            }
        },

        _refreshImpTable: function (tmngr) {
            var range, format, table, i = this.getObjectLength(tmngr);
            if (this.model.allowFormatAsTable && i) {
                while (i--) {
                    table = tmngr[i];
                    range = table.range;
                    format = this.XLFormat._getTableLayoutFromName(table.formatName);
                    if (!format) {
                        format = this.XLFormat._formatAsTableStyle;
                        table.formatName = format.formatName;
                    }
                    this.XLFormat.createTable({ header: true, name: "Table" + (this._tableCnt), format: format.format, formatName: table.formatName, showHeaderRow: table.showHeaderRow }, this._getAlphaRange(this.getActiveSheetIndex(), range[0], range[1], range[2], range[3]));
                }
            }
        },

        _refreshImpCharts: function (charts) {
            if (this.model.allowCharts) {
                var sheet, chart, i = 0, len = this.getObjectLength(charts);
                while (i < len) {
                    chart = charts["chart" + i];
                    sheet = this.getSheet(chart.dataSheetIdx);
                    if (chart.dataSheetIdx != this.getActiveSheetIndex() && sheet._isImported && !sheet._isRequested) {
                        this._intrnlReq = true;
                        this._importSheet(chart.dataSheetIdx, false);
                    }
                    this.XLChart.createChart(chart.range, { type: chart.commonSeriesOptions.type, enable3D: chart.enable3D, marker: chart.commonSeriesOptions.marker, top: chart.top, left: chart.left, height: chart.size.height, width: chart.size.width, title: chart.title, legend: chart.legend, primaryYAxis: chart.primaryYAxis, primaryXAxis: chart.primaryXAxis, dataSheetIdx: chart.dataSheetIdx });
                    i++;
                }
            }
        },

        _refreshImpPics: function (shapeMngr, sheetIdx) {
            if (this.model.pictureSettings.allowPictures) {
                var pic, i = 0, picCln = this.getObjectKeys(shapeMngr.picture), len = picCln.length;
                while (i < len) {
                    pic = shapeMngr.picture[picCln[i]];
                    pic.sheetIdx = sheetIdx;
                    if (!this.getSheet(sheetIdx)._isUpdated)
                        this.XLShape._createPicture(sheetIdx, null, shapeMngr.sharedPics[pic.data], pic.top, pic.left, pic.width, pic.height, null, pic.bcolor, pic.bstyle, pic.bwidth, pic);
                    else {
                        pic.imgData = shapeMngr.sharedPics[pic.data];
                        this.XLShape._refreshPictureElement(pic);
                    }
                    i++;
                }
            }
        },

        _refreshShapePosOnImp: function (shapeMngr, sheetIdx) {
            var chartMngr = shapeMngr.chart, picMngr = shapeMngr.picture, i, diff, key, orgHght, topVal, sheet = this.getSheet(sheetIdx), rowHghtColl = sheet._rowHeightCollection, sRowHght = sheet.rowsHeightCollection, impRowHght = this._impData ? this._impData.model.sheets[sheetIdx].rowsHeightCollection : [];
            if (!this.getObjectLength(picMngr) && !this.getObjectLength(chartMngr))
                return false;
            for (i = 0; i < impRowHght.length; i++) {
                if (impRowHght[i] !== sRowHght[i]) {
                    diff = sRowHght[i] - impRowHght[i];
                    orgHght = rowHghtColl[i + 1] - diff;
                    for (key in picMngr) {
                        topVal = picMngr[key].top;
                        if (topVal > orgHght)
                            picMngr[key].top = topVal + diff;
                    }
                    for (key in chartMngr) {
                        topVal = chartMngr[key].top;
                        if (topVal > orgHght)
                            chartMngr[key].top = topVal + diff;
                    }
                }
            }
        },

        _refreshImpPvts: function (pivotMngr, sheetIdx) {
            if (this.model.enablePivotTable && pivotMngr) {
                var pvt, i = 0, len = this.getObjectLength(pivotMngr.pivot), objKeys = this.getObjectKeys(pivotMngr.pivot), settings;
                while (i < len) {
                    pvt = pivotMngr.pivot[objKeys[i]];
                    settings = {
                        rows: pvt.rows,
                        columns: pvt.columns,
                        values: pvt.values,
                        filters: pvt.filters
                    };
                    if (!this.getSheet(sheetIdx)._isUpdated)
                        this.XLPivot.createPivotTable(pvt.dataSheetName + "!" + this._getProperAlphaRange(this._getSheetIndexByName(pvt.dataSheetName), pvt.dataRange[0], pvt.dataRange[1], pvt.dataRange[2], pvt.dataRange[3]), this.getSheet(pvt.sheetIdx).sheetInfo.text + "!" + this._getProperAlphaRange(pvt.sheetIdx, pvt.rowIndex, pvt.colIndex, pvt.rowIndex, pvt.colIndex), objKeys[i], settings, pvt);
                    else
                        this.XLPivot._refreshPivotElement(pvt.dataSheetName + "!" + this._getProperAlphaRange(this._getSheetIndexByName(pvt.dataSheetName), pvt.dataRange[0], pvt.dataRange[1], pvt.dataRange[2], pvt.dataRange[3]), this.getSheet(pvt.sheetIdx).sheetInfo.text + "!" + this._getProperAlphaRange(pvt.sheetIdx, pvt.rowIndex, pvt.colIndex, pvt.rowIndex, pvt.colIndex), objKeys[i], settings, pvt);
                    i++;
                }
            }
            (!this._isExport) && this._getContent(sheetIdx).find(".e-ss-activepivot").removeClass("e-ss-activepivot");
            this.hideActivationPanel();
        },

        _refreshNameMngr: function (nameMgr) {
            nameMgr = nameMgr || this.model.nameManager;
            var i = nameMgr.length;
            if (this.model.showRibbon) {
                if (i) {
                    while (i--)
                        this.XLRibbon._updateNamedRanges(nameMgr[i].name, nameMgr[i].refersto, true);
                }
                $("#" + this._id + "_nmgrid").ejGrid("option", { dataSource: nameMgr });
                this.XLRibbon._updateUseInFormulaTrgt();
            }
            this.XLEdit._refreshAutoComplete();
        },

        _getBorderInput: function (str) {
            str = str.split("_");
            var i = 4, obj = {}, arr = ["top", "right", "bottom", "left"];
            while (i--) {
                if (str[i].length)
                    obj[arr[i]] = str[i];
            }
            return obj;
        },

        _refreshHashCode: function (hashCode) {
            hashCode = hashCode || this._dataContainer.hashCode;
            var code, i = hashCode.length;
            while (i--) {
                code = hashCode[i];
                if (code.indexOf("e-format") === -1 && code.indexOf("e-border") === -1)
                    hashCode[i] = "";
            }
        },

        clearUndoRedo: function () {
            this._undoCollection = [];
            this._redoCollection = [];
            this._updateUndoRedoIcons();
        },

        _initializePicture: function (sheetIdx) {
            this._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").append(ej.buildTag("div.e-ss-imgvisual"));
        },

        _getShapePositionInManager: function (rowIndex, colIndex, id, shapeType) {
            var sheetIdx = this.getActiveSheetIndex(), cellObj = this._dataContainer.sheets[sheetIdx][rowIndex][colIndex], i, len;
            for (i = 0, len = cellObj.length; i < len; i++)
                if (cellObj[shapeType][i].id === id)
                    break;
            return i;
        },

        _swapVal: function (val) {
            var temp = val.prev;
            val.prev = val.cur;
            val.cur = temp;
        },

        _getValue: function (coll, key) {
            var obj, i = coll.length;
            while (i--) {
                obj = coll[i];
                if (obj.value === key)
                    return obj.value;
            }
        },

        _isRowViewable: function (sheetIdx, rowIdx) {
            var sheet = this.getSheet(sheetIdx), isInView = sheet._isVPRendered;
            if (this.model.scrollSettings.allowVirtualScrolling)
                isInView = sheet._virtualRowIdx.indexOf(rowIdx) > -1;
            return isInView;
        },

        _isColumnViewable: function (sheetIdx, colIdx) {
            return true;
        },

        _undoRedoOperation: function (evtobj) {
            var val, undoVal, actCell = this.getActiveCell();
            if ((evtobj.which === 90 || evtobj.keyCode === 90) && evtobj.ctrlKey) {
                evtobj.preventDefault();
                if (evtobj.target.id.indexOf("_Edit") > -1 || evtobj.target.id.indexOf("_input") > -1) {
                    val = this.XLEdit.getCurrentEditCellData();
                    if (val !== this._cureditedCell) {
                        undoVal = val;
                        if (evtobj.target.id.indexOf("_Edit") > -1)
                            evtobj.target.textContent = this._cureditedCell;
                        else
                            $("#" + this._id + "_Edit")[0].textContent = this._cureditedCell;
                        if (this.model.allowFormulaBar)
                            this._getInputBox().val(this._cureditedCell);
                        this._undoInputobj = { value: undoVal, rowIndex: actCell.rowIndex, colIndex: actCell.colIndex };
                    }
                }
                else {
                    this._isUndo = true;
                    this._performUndoRedo();
                }
            }
            else if ((evtobj.which === 89 || evtobj.keyCode === 89) && evtobj.ctrlKey) {
                evtobj.preventDefault();
                if (evtobj.target.id.indexOf("_Edit") > -1 || evtobj.target.id.indexOf("_input") > -1) {
                    if (actCell.rowIndex === this._undoInputobj.rowIndex && actCell.colIndex === this._undoInputobj.colIndex) {
                        if (evtobj.target.id.indexOf("_Edit") > -1)
                            evtobj.target.textContent = this._undoInputobj.value;
                        else
                            $("#" + this._id + "_Edit")[0].textContent = this._undoInputobj.value;
                        if (this.model.allowFormulaBar)
                            this._getInputBox().val(this._undoInputobj.value);
                    }
                }
                else {
                    this._isUndo = false;
                    this._performUndoRedo();
                }
            }
        },

        _performUndoRedo: function () {
            var val = (this._isUndo) ? this._undoCollection.pop() : this._redoCollection.pop(), args;
            if (!ej.isNullOrUndefined(val)) {
                if (val.sheetIndex !== this.getActiveSheetIndex())
                    this.gotoPage(val.sheetIndex, null);
                this._isUndoRedo = true;
                switch (val.reqType) {
                    case "auto-fill":
                        this._undoForAutoFill(val);
                        break;
                    case "auto-sum":
                        this._undoForAutoSum(val);
                        break;
                    case "cell-format":
                        this._undoForFormat(val);
                        break;
                    case "cell-styles":
                        this._undoForStyle(val);
                        break;
                    case "clear-all":
                        this._undoForClAll(val);
                        break;
                    case "clear-comment":
                        this._undoForClComment(val);
                        break;
                    case "clear-content":
                        this._undoForClContent(val);
                        break;
                    case "clear-format":
                        this._undoForClFormat(val);
                        break;
                    case "clear-link":
                        this._undoForCLLink(val);
                        break;
                    case "comment":
                        this._undoForComment(val);
                        break;
                    case "cond-format":
                        this._undoForCondFormat(val);
                        break;
                    case "copy-paste":
                        this._undoForCopyPaste(val);
                        break;
                    case "cut-paste":
                        this._undoForCutPaste(val);
                        break;
                    case "delete":
                        this._undoForDel(val);
                        break;
                    case "edit":
                        this._undoForEdit(val);
                        break;
                    case "filter":
                        this._undoForFilter(val);
                        break;
                    case "filterbycolor":
                        this._undoForFilterByColor(val);
                        break;
                    case "find-replace":
                        this._undoForFind(val);
                        break;
                    case "format-painter":
                        this._undoForFormatPaint(val);
                        break;
                    case "format-table":
                        this._undoForFormatTable(val);
                        break;
                    case "hyperlink":
                        this._undoForHyperlink(val);
                        break;
                    case "insert":
                        this._undoForIns(val);
                        break;
                    case "merge-cells":
                        this._undoForMerge(val);
                        break;
                    case "paging":
                        var tmpIdx = val.nSheetIndex;
                        val.nSheetIndex = val.sheetIndex;
                        val.sheetIndex = tmpIdx;
                        break;
                    case "pivotgrid":
                        this._undoForPivot(val);
                        break;
                    case "resize-column":
                        this._undoForResizeCol(val);
                        break;
                    case "resize-row":
                        this._undoForResizeRow(val);
                        break;
                    case "resize-fit-height":
                        this._undoForResizeFHeight(val);
                        break;
                    case "resize-fit-width":
                        this._undoForResizeFWidth(val);
                        break;
                    case "reorder-cells":
                        this._undoForReOrder(val);
                        break;
                    case "show-hide":
                        this._undoForShowHide(val);
                        break;
                    case "shape":
                        this._undoForShape(val);
                        break;
                    case "sort":
                        this._undoForSort(val);
                        break;
                    case "sortbycolor":
                        this._undoForSortByColor(val);
                        break;
                    case "textwrap":
                        this._undoForTextWrap(val);
                        break;
                    case "validation":
                        this._undoForValidation(val);
                        break;

                }
                (this._isUndo) ? this._redoCollection.push(val) : this._undoCollection.push(val);
                args = { sheetIdx: val.sheetIndex, reqType: this._isUndo ? "undo" : "redo", operation: val };
                if (this._undoCollection.length > this.undoRedoStep)
                    this._undoCollection.splice(0, 1);
                if (this._redoCollection.length > this.undoRedoStep)
                    this._redoCollection.splice(0, 1);
                this._updateUndoRedoIcons();
                if (this.model.showRibbon)
                    this.XLRibbon._updateRibbonIcons();
                this._isUndoRedo = false;
                this._isUndo = false;
                (this.model.allowSelection && val.reqType != "shape") && this.XLSelection._refreshBorder();
				this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
                if (this._trigActionComplete(args))
                    return;
            }
        },

        _undoForAutoFill: function (val) {
            var sheet = this.getSheet(val.sheetIndex);
            if (this._isUndo) {
                this.clearRangeData(val.range, this._cellProp);
                if (this.model.allowCellFormatting) {
                    this.XLFormat.removeStyle(val.range);
                    this.XLFormat.updateFormat(val.bFormat, val.range);
                }
                this.updateData($.extend(true, [], val.bData), val.range);
                val.actionType == "flash-fill" && this.updateData($.extend(true, [], val.bdData), val.bRange);
                if (val.colSel)
                    this.XLSelection.selectColumns(sheet._startCell.colIndex, sheet._endCell.colIndex);
                else if (val.rowSel)
                    this.XLSelection.selectRows(sheet._startCell.rowIndex, sheet._endCell.rowIndex);
                else
                    this.performSelection({ rowIndex: val.bRange[0], colIndex: val.bRange[1] }, { rowIndex: val.bRange[2], colIndex: val.bRange[3] });
            }
            else {
                if (this.model.allowCellFormatting)
                    this.XLFormat.updateFormat(val.aFormat, val.range);
                this.updateData($.extend(true, [], val.aData), val.range);
                this.XLCFormat.refreshCFormat();
                val.actionType == "flash-fill" && this.updateData($.extend(true, [], val.adData), val.bRange);
                this.performSelection({ rowIndex: val.bRange[0], colIndex: val.bRange[1] }, { rowIndex: val.range[2], colIndex: val.range[3] });
            }
        },

        _undoForAutoSum: function (val) {
            var container = this._dataContainer.sheets[val.sheetIndex], cell, pObj;
            if (this._isUndo) {
                for (var i = 0, len = val.updCell.length; i < len; i++) {
                    cell = this.getCell(val.updCell[i].rowIndex, val.updCell[i].colIndex, val.sheetIndex);
                    this._clearFormula(val.updCell[i].rowIndex, val.updCell[i].colIndex);
                    this.clearRangeData([val.updCell[i].rowIndex, val.updCell[i].colIndex, val.updCell[i].rowIndex, val.updCell[i].colIndex], ["value2"], null, true);
                    pObj = $.extend(true, {}, val.updCell[i].pObj)
                    container[val.updCell[i].rowIndex][val.updCell[i].colIndex] = pObj;
                    cell.text(val.updCell[i].pValue);
                }
                this.performSelection(val.range);
            }
            else
                this.XLRibbon.autoSum(val.oprType, val.range);
        },

        _undoForClAll: function (val) {
            var activeCell, tblRange, tab, sheet = this.model.sheets[val.sheetIndex], rowIdx, colIdx;
            this._isPaste = this._dupDetails = true;
            if (this._isUndo) {
                this.updateData($.extend(true, [], val.bData), val.range);
                this.XLFormat.updateFormat($.extend(true, [], val.bBorder), val.range);
                for (var i = 0, len = val.wrapColl.length; i < len; i++)
                    this.setWrapText("wrap", [val.wrapColl[i].rowIdx, val.wrapColl[i].colIdx, val.wrapColl[i].rowIdx, val.wrapColl[i].colIdx]);
                for (var i = 0, len = val.mergeColl.length; i < len; i++) {
                    this.mergeCenter = val.mergeColl[i].mergeObj.isCenterAlign;
                    this.mergeCells(val.mergeColl[i].mergeObj.mRange, true);
                }
            }
            else {
                if (this.model.showRibbon && this.XLRibbon._isMergeSelect && this.XLRibbon._isFilterSelect.status) {
                    this.clearRangeData(val.range, ["value", "value2", "hyperlink", "cFormatRule", "comment"], "", false);
                    this.XLFormat.removeStyle(null, { cellStyle: true, format: true });
                }
                else
                    this.clearRangeData(val.range, ["value", "value2", "format", "formats", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink", "comment", "cFormatRule"]);
                this.setWrapText("unwrap", val.range);
                this.unmergeCells(val.range);
            }
            this._isPaste = this._dupDetails = false;
            if (val.tblObj) {
                if (this._isUndo) {
                    this.XLClipboard._isCut = true;
                    this.XLFormat.createTable(val.tblObj, val.tblObj.range);
                    this.XLClipboard._isCut = false;
                }
                else {
                    this.XLFormat.removeTable(val.tblObj.tblId);
                    this.clearRangeData(val.range, ["value", "value2", "format", "formats", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink", "comment", "cFormatRule"]);
                    this.XLRibbon._toggleDesignTab(this.getActiveCell());
                }
            }
            if (this.model.allowConditionalFormats)
                this.XLCFormat.refreshCFormat(val.range);
            (this.model.allowDataValidation && !this._isUndo) && this.XLValidate.clearDV();
            if (this.model.allowFormulaBar)
                this.updateFormulaBar();
        },

        _undoForClComment: function (val) {
            var cell, startCell, endCell;
            if (!val.selectedCell.length)
                return;
            startCell = { rowIndex: val.selectedCell[0].rowIndex, colIndex: val.selectedCell[0].colIndex };
            endCell = { rowIndex: val.selectedCell[val.selectedCell.length - 1].rowIndex, colIndex: val.selectedCell[val.selectedCell.length - 1].colIndex };
            if (this._isUndo) {
                for (var i = 0, len = val.selectedCell.length; i < len; i++) {
                    cell = { rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex };
                    this.XLEdit._updateDataContainer({ rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex }, { dataObj: { "comment": val.selectedCell[i].prevComment } });
                    this.XLSelection.selectRange(cell, cell);
                    this.XLComment.setComment();
                    this.XLComment._updateCurCmntVal();
                }
            }
            else {
                this.XLSelection.selectRange(startCell, endCell);
                this.XLComment.deleteComment(undefined, null, false, "clear");
            }
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
        },

        _undoForClContent: function (val) {
            (this._isUndo) ? this.updateData($.extend(true, [], val.bData), val.range) : this.clearRangeData(val.range, ["value", "value2", "type", "hyperlink"], val.reqType);
            if (this.model.allowConditionalFormats)
                this.XLCFormat.refreshCFormat(val.range);
            if (this.model.allowFormulaBar)
                this.updateFormulaBar();
        },

        _undoForClFormat: function (val) {
            var container = this._dataContainer.sheets[val.sheetIndex];
            if (this._isUndo) {
                for (var i = 0, len = val.wrapColl.length; i < len; i++)
                    this.setWrapText("wrap", [val.wrapColl[i].rowIdx, val.wrapColl[i].colIdx, val.wrapColl[i].rowIdx, val.wrapColl[i].colIdx]);
                for (var i = 0, len = val.mergeColl.length; i < len; i++) {
                    this.mergeCenter = val.mergeColl[i].mergeObj.isCenterAlign;
                    this.mergeCells(val.mergeColl[i].mergeObj.mRange, true);
                }
                this.updateData($.extend(true, [], val.bData), val.range, val.reqType);
            }
            else {
                if (this.XLRibbon._isMergeSelect && this.XLRibbon._isFilterSelect.status) {
                    this.clearRangeData(val.range, ["decimalPlaces", "thousandSeparator", "hyperlink", "cFormatRule"], "", false, details.reqType);
                    this.XLFormat.removeStyle(null, { cellStyle: true, format: true })
                }
                else
                    this.clearRangeData(val.range, ["format", "formats", "border", "type", "formatstr", "decimalPlaces", "thousandSeparator", "hyperlink", "cFormatRule"], "", false, val.reqType);
                this.setWrapText("unwrap", val.range);
                this.unmergeCells(val.range);
            }
            if (this.model.allowConditionalFormats)
                this.XLCFormat.refreshCFormat(val.range);
        },

        _undoForCLLink: function (val) {
            var startCell = { rowIndex: val.selectedCell[0].rowIndex, colIndex: val.selectedCell[0].colIndex }, temp, currentCell,
            endCell = { rowIndex: val.selectedCell[val.selectedCell.length - 1].rowIndex, colIndex: val.selectedCell[val.selectedCell.length - 1].colIndex };
            this.setActiveCell(val.selectedCell[0].rowIndex, val.selectedCell[0].colIndex);
            this.XLSelection.selectRange(startCell, endCell);
            if (this._isUndo) {
                for (var i = 0, len = val.selectedCell.length; i < len; i++) {
                    if (val.selectedCell[i].prevLink) {
                        currentCell = this.getCell(val.selectedCell[i].rowIndex, val.selectedCell[i].colIndex);
                        (!(val.selectedCell[i].prevLink.webAddr) ? currentCell.html(ej.buildTag("a.e-hyperlinks", val.selectedCell[i].prevText, "")) : currentCell.html(ej.buildTag("a.e-hyperlinks", val.selectedCell[i].prevText, "", { href: val.selectedCell[i].prevLink.webAddr, target: "_blank" })));
                        (this.isUndefined(val.selectedCell[i].prevLink.cellAddr)) ? this.XLEdit._updateDataContainer({ rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex }, { dataObj: { hyperlink: { "webAddr": val.selectedCell[i].prevLink.webAddr } } }) : this.XLEdit._updateDataContainer({ rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex }, { dataObj: { hyperlink: { "cellAddr": val.selectedCell[i].prevLink.cellAddr } } });
                    }
                }
            }
            else
                this._removeHyperlink("clear", val.selectedCell);
            this.XLSelection.selectRange(startCell, endCell);
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
            for (var i = 0, len = val.selectedCell.length; i < len; i++) {
                temp = val.selectedCell[i].prevLink;
                val.selectedCell[i].prevLink = val.selectedCell[i].curLink;
                val.selectedCell[i].curLink = temp;
            }
        },

        _undoForComment: function (val) {
            var cell, startCell, endCell, cmnt;
            startCell = { rowIndex: val.selectedCell[0].rowIndex, colIndex: val.selectedCell[0].colIndex };
            endCell = { rowIndex: val.selectedCell[val.selectedCell.length - 1].rowIndex, colIndex: val.selectedCell[val.selectedCell.length - 1].colIndex };
            for (var i = 0, len = val.selectedCell.length; i < len; i++) {
                cell = { rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex };
                this.XLSelection.selectRange(cell, cell);
                this.getSheet(val.sheetIndex)._startCell = cell;
                if (val.action === "add") {
                    val.selectedCell[i].prevComment = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "comment");
                    this.XLComment && this.XLComment.deleteComment();
                }
                else if (val.action === "edit") {
                    if (this._isRowViewable(val.sheetIndex, cell.rowIndex))
                        this.getCell(cell.rowIndex, cell.colIndex).find('.e-comment-txtarea').val(val.selectedCell[i].prevComment.value);
                    this.XLComment._updateCurCmntVal();
                    cmnt = val.selectedCell[i].prevComment;
                    val.selectedCell[i].prevComment = val.selectedCell[i].curComment;
                    val.selectedCell[i].curComment = cmnt;
                }
                else {
                    this.XLEdit._updateDataContainer(cell, { dataObj: { "comment": val.selectedCell[i].prevComment } });
                    this.XLComment.setComment([cell.rowIndex, cell.colIndex, cell.rowIndex, cell.colIndex], null, false);
                    this.XLSelection.selectRange(cell, cell);
                    this.XLComment._updateCurCmntVal();
                    cmnt = val.selectedCell[i].prevComment;
                    val.selectedCell[i].prevComment = val.selectedCell[i].curComment;
                    val.selectedCell[i].curComment = cmnt;
                }
            }
            if (val.action === "add")
                val.action = "delete";
            else if (val.action === "delete")
                val.action = "add";
            this.XLSelection.selectRange(startCell, endCell);
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
        },

        _undoForCondFormat: function (val) {
            var i, j, len, ln, sRule, rules, rule, totRules = [], allRules, actCell;
            val.range = val.data;
            if (this._isUndo) {
                if (val.action === "add") {
                    var selCells = this._getSelectedRange({ rowIndex: val.range[0], colIndex: val.range[1] }, { rowIndex: val.range[2], colIndex: val.range[3] });
                    rules = this.XLEdit.getPropertyValue(selCells[0].rowIndex, selCells[0].colIndex, 'cFormatRule');
                    val.poppedRule = rules[rules.length - 1];
                    for (i = 0, len = selCells.length; i < len; i++) {
                        allRules = this.XLEdit.getPropertyValue(selCells[i].rowIndex, selCells[i].colIndex, 'cFormatRule');
                        if (!this.isUndefined(allRules)) {
                            allRules.pop();
                            for (j = 0, ln = allRules.length; j < ln; j++) {
                                sRule = allRules[j];
                                if (totRules.length === 0) {
                                    rule = sRule.indexOf("true") > -1 ? sRule.replace("_true", "") : sRule.replace("_false", "");
                                    totRules.push(rule);
                                }
                                else
                                    totRules = this._addCondFormatRule(totRules, sRule);
                            }
                        }
                        if (this._isRowViewable(val.sheetIndex, selCells[i].rowIndex)) {
                            actCell = this.getCell(selCells[i].rowIndex, selCells[i].colIndex, val.sheetIndex);
                            actCell.removeClass("e-redft e-yellowft e-greenft e-redf e-redt");
                        }
                    }
                    this.clearRangeData(val.range, ["cFormatRule"], selCells);
                    for (i = 0, len = totRules.length; i < len; i++) {
                        rule = totRules[i].split("_");
                        this.XLCFormat._cFormat(rule[0], rule[2], rule[3], rule[4], rule[5], val.sheetIndex, val.range);
                    }
                }
                else if (val.action === "clear") {
                    for (i = 0, len = val.rule.length; i < len; i++)
                        for (var j = 0, length = val.rule[i].length; j < length; j++)
                            this.XLCFormat.setCFRule(val.rule[i][j]);
                }
            }
            else {
                if (val.action === "add") {
                    if (!ej.isNullOrUndefined(val.poppedRule)) {
                        rule = val.poppedRule.split("_");
                        this.XLCFormat._cFormat(rule[0], rule[2], rule[3], rule[4], rule[5], val.sheetIndex, val.range);
                    }
                }
                else if (val.action === "clear") {
                    val.selection ? this.XLCFormat.clearCF(val.range) : this.XLCFormat.clearCF();
                }
            }
        },

        _getCopyText: function (text) {
            var i, j, ln, len, selText = [], splitVal;
            for (i = 0, len = text.length; i < len; i++) {
                splitVal = text[i].split("\t");
                for (j = 0, ln = splitVal.length; j < ln; j++)
                    selText.push(splitVal[j]);
            }
            return selText;
        },

        _cutShape: function (cellObj, cutCell, shapeMgr, pSheetIndex) {
            var shape = ["picture", "chart"], shapeObj;
            for (var i = 0, len = shape.length; i < len; i++) {
                if (shape[i] in cellObj) {
                    this.XLShape._picCellIdx = { rowIndex: cutCell.rowIndex, colIndex: cutCell.colIndex };
                    for (var m = 0, rLen = cellObj[shape[i]].length; m < rLen; m++) {
                        shapeObj = $.extend(true, {}, shapeMgr[shape[i]][cellObj[shape[i]][m]]);
                        this.XLShape._deleteShape(pSheetIndex, this.element.find("#" + shapeObj.id));
                    }
                }
            }
        },

        _pasteShape: function (cellObj, pasteCell, shapeMgr, pSheetIdx) {
            var shape = ["picture", "chart"], shapeObj, range, repStr;
            for (var i = 0, len = shape.length; i < len; i++) {
                if (shape[i] in cellObj) {
                    for (var m = 0, rLen = cellObj.picture.length; m < rLen; m++) {
                        shapeObj = $.extend(true, {}, shapeMgr[shape[i]][cellObj[shape[i]][m]]);
                        !(this.XLChart._shapeCnt === 1) && this.XLChart._shapeCnt--;
                        if (shape[i] === "picture") {
                            repStr = this._id + "_picture";
                            this.XLShape._createPicture(pSheetIdx, { rowIndex: pasteCell.rowIndex, colIndex: pasteCell.colIndex }, shapeMgr.sharedPics[shapeObj.data], shapeObj.top, shapeObj.left, shapeObj.width, shapeObj.height, parseInt(shapeObj.id.replace(repStr, "")));
                        }
                        else {
                            range = shapeObj.range;
                            this.XLChart.createChart(this._getAlphaRange(pSheetIdx, range[0], range[1], range[2], range[3]), shapeObj);
                        }
                    }
                    (shape[i] === "chart") && this.XLSelection.selectRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, pSheetIndex);
                }
            }
        },

        _undoForCopyPaste: function (val) {
            var shapeObj = {}, container = this._dataContainer, type, shapeIdx, shapeMgr = this.getSheet(val.pSheetIndex).shapeMngr, cellObj, m, rLen;
            if (val.operation === "shape") {
                type = val.pShapeId.indexOf("picture") > -1 ? "picture" : "chart";
                cellObj = $.extend(true, {}, val.pasteCell.obj);
                if (!ej.isNullOrUndefined(cellObj)) {
                    this.XLShape._picCellIdx = { rowIndex: val.pasteCell.rowIndex, colIndex: val.pasteCell.colIndex };
                    if (type === "chart") {
                        if ("chart" in cellObj) {
                            if (this._isUndo) {
                                shapeObj = $.extend(true, {}, shapeMgr.chart[val.pShapeId]);
                                if (ej.isNullOrUndefined(container.sheets[val.pSheetIndex][val.pasteCell.rowIndex]))
                                    container.sheets[val.pSheetIndex][val.pasteCell.rowIndex] = {};
                                container.sheets[val.pSheetIndex][val.pasteCell.rowIndex][val.pasteCell.colIndex] = cellObj;
                                this.XLShape._deleteShape(val.pSheetIndex, this.element.find("#" + shapeObj.id));
                            }
                            else {
                                this.setActiveCell(val.pasteCell.rowIndex, val.pasteCell.colIndex, val.pSheetIndex);
                                shapeObj = $.extend(true, {}, val.pasteCell.shapeObj);
                                range = shapeObj.range;
                                this.XLChart.createChart(this._getAlphaRange(val.sheetIndex, range[0], range[1], range[2], range[3]), shapeObj);
                                this.XLSelection.selectRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, val.cSheetIndex);
                            }
                        }
                    }
                    else {
                        if ("picture" in cellObj) {
                            if (this._isUndo) {
                                shapeObj = $.extend(true, {}, shapeMgr.picture[val.pShapeId]);
                                if (ej.isNullOrUndefined(container.sheets[val.pSheetIndex][val.pasteCell.rowIndex]))
                                    container.sheets[val.pSheetIndex][val.pasteCell.rowIndex] = {};
                                container.sheets[val.pSheetIndex][val.pasteCell.rowIndex][val.pasteCell.colIndex] = cellObj;
                                this.XLShape._deleteShape(val.pSheetIndex, this.element.find("#" + shapeObj.id));
                            }
                            else {
                                shapeObj = $.extend(true, {}, val.pasteCell.shapeObj);
                                repStr = this._id + "_picture";
                                this.XLShape._createPicture(val.pSheetIndex, { rowIndex: val.pasteCell.rowIndex, colIndex: val.pasteCell.colIndex }, shapeMgr.sharedPics[shapeObj.data], shapeObj.top, shapeObj.left, shapeObj.width, shapeObj.height, parseInt(shapeObj.id.replace(repStr, "")), shapeObj.bcolor, shapeObj.bstyle, shapeObj.bwidth);
                            }
                        }
                    }
                }
                this.XLScroll._getRowHeights(val.pSheetIndex, val.pasteCell.rowIndex);
            }
            else {
                var i, j, m, ln, len, rLen, cell, addr, pObj, nBrdr, range, rowIdx, colIdx, repStr, overflow, settings, pasteCell, isViewed = false, selTxt = [], container = this._dataContainer;
                this._getCopyText(val.text);
                this._dupDetails = true;
                this.element.find(".e-cdata").length && $('td.e-cutright, td.e-cutbottom').removeClass('e-cutright e-cutbottom');
                this.setActiveSheetIndex(val.pSheetIndex);
                for (i = 0, len = val.pasteCells.length; i < len; i++) {
                    pasteCell = val.pasteCells[i];
                    cellObj = ej.isNullOrUndefined(container.sheets[val.pSheetIndex][pasteCell.rowIndex]) ? {} : container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex];
                    if (!this._isUndo) {
                        if ("merge" in pasteCell.prevObj) {
                            this.mergeCenter = pasteCell.prevObj.merge.isCenterAlign;
                            this.mergeCells(pasteCell.prevObj.merge.mRange, true);
                        }
                    }
                    if (this._isRowViewable(val.pSheetIndex, pasteCell.rowIndex)) {
                        cell = this.getCell(pasteCell.rowIndex, pasteCell.colIndex, val.pSheetIndex)[0];
                        (!this._isUndo) && (cell.textContent = selTxt[i]);
                        isViewed = true;
                    }
                    if (!ej.isNullOrUndefined(cellObj)) {
                        this._cutShape(cellObj, pasteCell, shapeMgr, val.pSheetIndex);
                        addr = this._generateHeaderText(pasteCell.colIndex + 1) + (pasteCell.rowIndex + 1);
                        ("wrap" in cellObj) && this.setWrapText("unwrap", addr + ":" + addr);
                        if ("merge" in cellObj) {
                            if (this._isUndo) {
                                pasteCell.newObj = $.extend(true, {}, container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex]);
                                this.unmergeCells(this._getAlphaRange(val.pSheetIndex, pasteCell.rowIndex, pasteCell.colIndex, pasteCell.rowIndex, pasteCell.colIndex));
                                this.getCell(pasteCell.rowIndex, pasteCell.colIndex, val.pSheetIndex).prop("rowspan", false).prop("colspan", false);
                                if ("merge" in pasteCell.prevObj) {
                                    this.mergeCenter = pasteCell.prevObj.merge.isCenterAlign;
                                    this.mergeCells(pasteCell.prevObj.merge.mRange, true);
                                    this.mergeCenter = false;
                                }
                            }
                        }
                    }
                    if (isViewed && this._isUndo) {
                        cell.textContent = "";
                        this._removeClass(cell, 'e-commentcell');
                    }
                    ej.isNullOrUndefined(container.sheets[val.pSheetIndex][pasteCell.rowIndex]) && (container.sheets[val.pSheetIndex][pasteCell.rowIndex] = {});
                    !ej.isNullOrUndefined(container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex]) && (overflow = container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex]['overflow']);
                    if (this.model.allowCellFormatting)
                        this.XLFormat.removeStyle(val.pasteBorder.range, { cellStyle: true, tableStyle: true, format: true, border: true });
                    container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex] = $.extend(true, {}, pasteCell.prevObj);
                    (overflow) && (container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex]['overflow'] = overflow);
                    this._textClip(pasteCell.rowIndex, pasteCell.colIndex, 'delete');
                    this._setRowHdrHeight(val.pSheetIndex, pasteCell.rowIndex);
                    cellObj = !ej.isNullOrUndefined(container.sheets[val.pSheetIndex][pasteCell.rowIndex]) ? container.sheets[val.pSheetIndex][pasteCell.rowIndex][pasteCell.colIndex] : {};
                    rowIdx = pasteCell.rowIndex; colIdx = pasteCell.colIndex;
                    this._applyCommentLink(cellObj, { rowIndex: pasteCell.rowIndex, colIndex: pasteCell.colIndex }, rowIdx, colIdx);
                    this._isPaste = true;
                    if (!ej.isNullOrUndefined(cellObj)) {
                        this._pasteShape(cellObj, { rowIndex: rowIdx, colIndex: colIdx }, shapeMgr, val.pSheetIndex);
                        if ('cellType' in cellObj) {
                            if (this._isUndo) {
                                this._removeClass(cell, 'e-cellreadonly');
                            }
                            else {
                                settings = this._dataContainer.sheetCellType[cellObj['cellType']];
                                settings.text = '';
                                this.model.allowCellType && this.XLCellType._renderControls(pasteCell.rowIndex, pasteCell.colIndex, val.pSheetIndex, settings, true);
                            }
                        }
                        addr = this._generateHeaderText(pasteCell.colIndex + 1) + (pasteCell.rowIndex + 1);
                        if ("wrap" in cellObj){
							this.XLEdit._clearDataContainer({ cellIdx: pasteCell, property: ['wrap']});
							this.setWrapText("wrap", addr + ":" + addr);
						}
                        this._isPaste = false;
                    }
                    pObj = pasteCell.prevObj;
                    pasteCell.prevObj = pasteCell.newObj;
                    pasteCell.newObj = pObj;
                }
                if (val.isSpecial) {
                    if (this.model.allowCellFormatting) {
                        this.XLFormat.removeStyle(val.pasteBorder.range, { cellStyle: true, tableStyle: true, format: true });
                        !this.isUndefined(val.pasteBorder.prevBorder) && this.XLFormat.updateFormat(val.pasteBorder.prevBorder, val.pasteBorder.range, "format"); //commented due to border issues
                    }
                    var nBrdr = val.pasteBorder.prevBorder;
                    val.pasteBorder.prevBorder = val.pasteBorder.newBorder;
                    val.pasteBorder.newBorder = nBrdr;
                }
                //table and filter
                if (!ej.isNullOrUndefined(val.pfat)) {
                    var tab = val.pfat.ptable;
                    for (var m = 0, rLen = tab.length; m < rLen; m++) {
                        if (!ej.isNullOrUndefined(val.pSheetIndex)) {
                            this.setActiveSheetIndex(val.pSheetIndex);
                            if (this._isUndo) {
                                this.XLFormat.removeTable(tab[m].id);
                                this.XLFormat.removeStyle(tab[m].range);
                            }
                            else {
                                tab[m].header = true;
                                this.XLFormat.createTable(tab[m], tab[m].range);
                            }
                        }
                    }
                }
                if (!ej.isNullOrUndefined(val.filter)) {
                    this.XLFilter.clearFilter();
                    this.XLFilter.filter(details.filter);
                }
                this._dupDetails = false;
            }
            if (val.operation !== "shape") {
                if (this._isUndo) {
                    (!ej.isNullOrUndefined(val.cSheetIndex)) && this.setActiveSheetIndex(val.cSheetIndex);
                    (val.cutCells.length > 0) && this.XLSelection._focusBorder(val.cutCells[0], val.cutCells[val.cutCells.length - 1], this._cutFocus);
                    this.setActiveSheetIndex(val.pSheetIndex);
                    this.XLSelection.selectRange(val.pasteCells[0], val.pasteCells[val.pasteCells.length - 1]);
                }
                else {
                    (!ej.isNullOrUndefined(val.cSheetIndex)) && this.setActiveSheetIndex(val.cSheetIndex);
                    (val.cutCells.length > 0) && this.XLSelection._focusBorder(val.cutCells[0], val.cutCells[val.cutCells.length - 1], this._cutFocus);
                    this.setActiveSheetIndex(val.pSheetIndex);
                    (val.pasteCells.length > 0) && this.XLSelection.selectRange(val.pasteCells[0], val.pasteCells[val.pasteCells.length - 1]);

                }
                this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
                this.XLScroll._getRowHeights(val.pSheetIndex, val.pasteCells[0].rowIndex);
            }

        },

        _undoForCutPaste: function (val) {
            var cellObj, overflow, m, rLen, nBrdr, shapeObj = {}, container = this._dataContainer, shapeMgr = this.getSheet(val.pSheetIndex).shapeMngr, repStr, cell, cellwrap, cname;
            if (val.operation === "shape") {
                var type, shapeIdx;
                type = val.pShapeId.indexOf("picture") > -1 ? "picture" : "chart";
                cellObj = $.extend(true, {}, val.pasteCell.obj);
                if (!ej.isNullOrUndefined(cellObj)) {
                    this.XLShape._picCellIdx = { rowIndex: val.pasteCell.rowIndex, colIndex: val.pasteCell.colIndex };
                    shapeObj = $.extend(true, {}, shapeMgr[type][val.pShapeId]);
                    if (ej.isNullOrUndefined(container.sheets[val.pSheetIndex][val.pasteCell.rowIndex]))
                        container.sheets[val.pSheetIndex][val.pasteCell.rowIndex] = {};
                    container.sheets[val.pSheetIndex][val.pasteCell.rowIndex][val.pasteCell.colIndex] = cellObj;
                    this.XLShape._deleteShape(val.pSheetIndex, this.element.find("#" + shapeObj.id));
                }
                cellObj = $.extend(true, {}, val.cutCell.obj);
                type = val.cShapeId.indexOf("picture") > -1 ? "picture" : "chart";
                if (!ej.isNullOrUndefined(cellObj)) {
                    this.setActiveCell(val.cutCell.rowIndex, val.cutCell.colIndex, val.cSheetIndex);
                    if (type === "chart") {
                        if ("chart" in cellObj) {
                            shapeObj = $.extend(true, {}, val.cutCell.shapeObj);
                            range = shapeObj.range;
                            this.setActiveSheetIndex(val.cSheetIndex);
                            this.XLChart.createChart(this._getAlphaRange(val.sheetIndex, range[0], range[1], range[2], range[3]), shapeObj);
                            this.setActiveSheetIndex(val.sheetIndex);
                            this.XLSelection.selectRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, val.cSheetIndex);
                        }
                    }
                    else {
                        if ("picture" in cellObj) {
                            shapeObj = $.extend(true, {}, val.cutCell.shapeObj);
                            repStr = this._id + "_picture";
                            this.XLShape._createPicture(val.cSheetIndex, { rowIndex: val.cutCell.rowIndex, colIndex: val.cutCell.colIndex }, shapeMgr.sharedPics[shapeObj.data], shapeObj.top, shapeObj.left, shapeObj.width, shapeObj.height, parseInt(shapeObj.id.replace(repStr, "")), shapeObj.bcolor, shapeObj.bstyle, shapeObj.bwidth);
                        }
                    }
                }
                this.XLShape._picCellIdx = { rowIndex: val.cutCell.rowIndex, colIndex: val.cutCell.colIndex };
                var pasteCell = val.pasteCell;
                val.pasteCell = val.cutCell;
                val.cutCell = pasteCell;
                var pShapeId = val.pShapeId;
                val.pShapeId = val.cShapeId;
                val.cShapeId = pShapeId;

            }
            else {
                var i, j, ln, len, pObj, addr, range, cell, cutCel, rowIdx, colIdx, curCell, selTxt = [], settings, container = this._dataContainer;
                this.element.find(".e-cdata").length && $('td.e-cutright, td.e-cutbottom').removeClass('e-cutright e-cutbottom');
                this._getCopyText(val.text);
                for (i = 0, len = val.pasteCells.length; i < len; i++) {
                    if (!ej.isNullOrUndefined(val.pSheetIndex)) {
                        if (!this.isUndefined(container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex]))
                            cellObj = container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex];
                        addr = this._generateHeaderText(val.pasteCells[i].colIndex + 1) + (val.pasteCells[i].rowIndex + 1);
                        ('wrap' in cellObj) && this.setWrapText("unwrap", addr + ":" + addr);
                        if (this._isRowViewable(val.pSheetIndex, val.pasteCells[i].rowIndex)) {
                            cell = this.getCell(val.pasteCells[i].rowIndex, val.pasteCells[i].colIndex, val.pSheetIndex)[0];
                            cell.textContent = "";
                            this._removeClass(cell, 'e-commentcell');
                        }
                        if (!this.isUndefined(cellObj)) {
                            this._cutShape(cellObj, val.pasteCells[i], shapeMgr, val.pSheetIndex);
                            if ("merge" in cellObj) {
                                if (this._isUndo) {
                                    $.extend(true, val.pasteCells[i].newObj, container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex]);
                                    this.setActiveSheetIndex(val.pSheetIndex);
                                    this.unmergeCells(cellObj.merge.mRange);
                                    this.getCell(val.pasteCells[i].rowIndex, val.pasteCells[i].colIndex, val.pSheetIndex).prop("rowspan", false).prop("colspan", false);
                                    if ("merge" in val.pasteCells[i].prevObj) {
                                        this.mergeCenter = val.pasteCells[i].prevObj.merge.isCenterAlign;
                                        this.mergeCells(val.pasteCells[i].prevObj.merge.mRange, true);
                                        this.mergeCenter = false;
                                    }
                                }
                                else {
                                    this.setActiveSheetIndex(val.pSheetIndex);
                                    this.unmergeCells(cellObj.merge.mRange, true);
                                    if ("merge" in val.pasteCells[i].prevObj) {
                                        this.mergeCenter = val.pasteCells[i].prevObj.merge.isCenterAlign;
                                        this.mergeCells(val.pasteCells[i].prevObj.merge.mRange, true);
                                        this.mergeCenter = false;
                                    }
                                    this.setActiveSheetIndex(val.cSheetIndex);
                                    this.unmergeCells(this._getAlphaRange(val.pSheetIndex, val.cutCells[i].rowIndex, val.cutCells[i].colIndex, val.cutCells[i].rowIndex, val.cutCells[i].colIndex));
                                    range = this.getRangeIndices(val.cutCells[i].prevObj.merge.mRange);
                                    this.XLSelection.selectRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, val.sheetIndex);
                                }
                            }
                            if ('cellType' in cellObj) {
                                this._removeClass(cell, 'e-cellreadonly');
                            }
                        }
                        if (this.isUndefined(container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex]))
                            container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex] = {};
                        !ej.isNullOrUndefined(container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex]) && (overflow = container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex]['overflow']);
                        if (this.model.allowCellFormatting)
                            this.XLFormat.removeStyle(val.pasteBorder.range, { cellStyle: true, tableStyle: true, format: true, border: true });
                        if (container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex].wrap)
                            cellwrap = true;
                        cname = this.XLEdit.getPropertyValue(val.pasteCells[i].rowIndex, val.pasteCells[i].colIndex, "tableName") || "";
                        container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex] = $.extend(true, {}, val.pasteCells[i].prevObj);
                        this._textClip(val.pasteCells[i].rowIndex, val.pasteCells[i].colIndex, 'delete');
                        if (!this.isUndefined(container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex])) {
                            (overflow) && (container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex]['overflow'] = overflow);
                            this._setRowHdrHeight(val.pSheetIndex, val.pasteCells[i].rowIndex);
                            cellObj = container.sheets[val.pSheetIndex][val.pasteCells[i].rowIndex][val.pasteCells[i].colIndex];
                            rowIdx = val.pasteCells[i].rowIndex, colIdx = val.pasteCells[i].colIndex;
                            this._applyCommentLink(cellObj, { rowIndex: rowIdx, colIndex: colIdx }, rowIdx, colIdx);
                            (cellwrap) && (cellObj.wrap = cellwrap);
                            this._isPaste = true;
                            if (!ej.isNullOrUndefined(cellObj)) {
                                this._pasteShape(cellObj, { rowIndex: rowIdx, colIndex: colIdx }, shapeMgr, val.pSheetIndex, val.sheetIndex);
                                addr = this._generateHeaderText(colIdx + 1) + (rowIdx + 1);
                                if ("wrap" in cellObj){
									this.XLEdit._clearDataContainer({ cellIdx: val.pasteCells[i], property: ['wrap']});
									this.setWrapText("wrap", addr + ":" + addr);
								}
                            }
                        }
                        pObj = val.pasteCells[i].prevObj;
                        val.pasteCells[i].prevObj = val.pasteCells[i].newObj;
                        val.pasteCells[i].newObj = pObj;
                        this._isPaste = false;
                    }
                }
                for (var i = 0; i < val.cutCells.length; i++) {
                    if (!ej.isNullOrUndefined(val.cSheetIndex)) {
                        cutCel = val.cutCells[i];
                        if (this._isRowViewable(val.cSheetIndex, cutCel.rowIndex)) {
                            curCell = this.getCell(cutCel.rowIndex, cutCel.colIndex, val.cSheetIndex)[0];
                            curCell.textContent = selTxt[i];
                        }
                        this.setActiveSheetIndex(val.cSheetIndex);
                        cellObj = ej.isNullOrUndefined(container.sheets[val.cSheetIndex][cutCel.rowIndex]) ? {} : container.sheets[val.cSheetIndex][cutCel.rowIndex][cutCel.colIndex];
                        if (!ej.isNullOrUndefined(cellObj))
                            this._cutShape(cellObj, cutCel, shapeMgr, val.cSheetIndex);
                        (ej.isNullOrUndefined(container.sheets[val.cSheetIndex][cutCel.rowIndex])) && (container.sheets[val.cSheetIndex][cutCel.rowIndex] = {});
                        !ej.isNullOrUndefined(container.sheets[val.cSheetIndex][cutCel.rowIndex][cutCel.colIndex]) && (overflow = container.sheets[val.cSheetIndex][cutCel.rowIndex][cutCel.colIndex]['overflow']);
                        (cutCel.prevObj.tableName) && delete cutCel.prevObj.tableName;
                        container.sheets[val.cSheetIndex][cutCel.rowIndex][cutCel.colIndex] = $.extend(true, {}, cutCel.prevObj);
                        if (this.getObjectLength(overflow) > 0)
                            (container.sheets[val.cSheetIndex][cutCel.rowIndex][cutCel.colIndex]['overflow'] = overflow) && (overflow = {});
                        pObj = cutCel.prevObj;
                        cutCel.prevObj = cutCel.newObj;
                        cutCel.newObj = pObj;
                        rowIdx = cutCel.rowIndex; colIdx = cutCel.colIndex;
                        this._setRowHdrHeight(val.cSheetIndex, rowIdx);
                        this.XLScroll._getRowHeights(val.cSheetIndex, rowIdx);
                        cellObj = ej.isNullOrUndefined(container.sheets[val.cSheetIndex][rowIdx]) ? {} : container.sheets[val.cSheetIndex][rowIdx][colIdx];
                        this._applyCommentLink(cellObj, { rowIndex: rowIdx, colIndex: colIdx }, rowIdx, colIdx);
                        this._isPaste = true;
                        if (!ej.isNullOrUndefined(cellObj)) {
                            this._pasteShape(cellObj, { rowIndex: rowIdx, colIndex: colIdx }, shapeMgr, val.cSheetIndex);
                            if ("merge" in cellObj) {
                                this.mergeCenter = cellObj.merge.isCenterAlign;
                                this.mergeCells(cellObj.merge.mRange, true);
                                this.mergeCenter = false;
                            }
                            if ('cellType' in cellObj) {
                                settings = this._dataContainer.sheetCellType[cellObj['cellType']];
                                settings.text = '';
                                this.model.allowCellType && this.XLCellType._renderControls(cutCel.rowIndex, cutCel.colIndex, val.pSheetIndex, settings, true);
                            }
                            this._dupDetails = true;
                            addr = this._generateHeaderText(cutCel.colIndex + 1) + (cutCel.rowIndex + 1);
                            if ("wrap" in cellObj){
								this.XLEdit._clearDataContainer({ cellIdx: cutCel, property: ['wrap']});
								this.setWrapText("wrap", addr + ":" + addr);
							}
                            this._dupDetails = false;
                        }
                        this._isPaste = false;
                    }
                }
                this.XLScroll._getRowHeights(val.pSheetIndex, (val.pasteCells[0].rowIndex < val.cutCells[0].rowIndex) ? val.pasteCells[0].rowIndex : val.cutCells[0].rowIndex);
                if (this.model.allowCellFormatting && !ej.isNullOrUndefined(val.pSheetIndex)) {
                    this.setActiveSheetIndex(val.pSheetIndex);
                    this.XLFormat.removeStyle(val.pasteBorder.range, { cellStyle: true, tableStyle: true, format: true });
                    !this.isUndefined(val.pasteBorder.prevBorder) && this.XLFormat.updateFormat(val.pasteBorder.prevBorder, val.pasteBorder.range, "format");      //commented due to border issues
                }
                nBrdr = val.pasteBorder.prevBorder;
                val.pasteBorder.prevBorder = val.pasteBorder.newBorder;
                val.pasteBorder.newBorder = nBrdr;
                if (this.model.allowCellFormatting && !ej.isNullOrUndefined(val.cSheetIndex)) {
                    this.setActiveSheetIndex(val.cSheetIndex);
                    if (val.isSpecial)
                        this.XLFormat.removeStyle(val.cutBorder.range, { cellStyle: true, tableStyle: true, format: true });
                    if (val.cutBorder.prevBorder)
                        this.XLFormat.updateFormat(val.cutBorder.prevBorder, val.cutBorder.range, "format");
                }
                nBrdr = val.cutBorder.prevBorder;
                val.cutBorder.prevBorder = val.cutBorder.newBorder;
                val.cutBorder.newBorder = nBrdr;

                //table and filter
                if (!ej.isNullOrUndefined(val.pfat)) {
                    var rng, tab = val.pfat.table, tblRange, minRowIdx = val.pfat.minRowIdx, minColIdx = val.pfat.minColIdx, tblId, prange = val.pfat.range;
                    for (var m = 0, rLen = tab.length; m < rLen; m++) {
                        tblRange = tab[m].range;
                        if (!ej.isNullOrUndefined(val.pSheetIndex)) {
                            this.setActiveSheetIndex(val.pSheetIndex);
                            tblId = tab[m].tblObj.tblId;
                            rng = val.pfat.ptable[m].range;
                            this.XLFormat.removeTable(tblId);
                            this.XLFormat.removeStyle(rng);
                        }
                        if (!ej.isNullOrUndefined(val.cSheetIndex)) {
                            this.setActiveSheetIndex(val.cSheetIndex);
                            this.XLClipboard._isCut = true;
                            if (this._isUndo) {
                                this.XLFormat.createTable(tab[m].tblObj, tab[m].range);
                                tab[m].tblObj.totalRow && this.XLFormat._updateTotalRow(val.sheetIndex, tblId, tab[m].tblObj.fnNumber, tab[m].range, true);
                            }
                            else {
                                rng = this.getRangeIndices(this._getAlphaRange(val.cSheetIndex, tblRange[0] + minRowIdx - prange[0], tblRange[1] + minColIdx - prange[1], minRowIdx - prange[0] + tblRange[2], minColIdx - prange[1] + tblRange[3]));
                                this.XLFormat.createTable(tab[m].tblObj, rng);
                                tab[m].tblObj.totalRow && this.XLFormat._updateTotalRow(val.sheetIndex, tblId, tab[m].tblObj.fnNumber, rng, true);
                            }
                            this.XLClipboard._isCut = false;
                        }
                    }
                }
                if (!ej.isNullOrUndefined(val.filter)) {
                    this.XLFilter.clearFilter();
                    this.XLFilter.filter(details.filter);
                }
            }
            if (val.operation !== "shape") {
                if (this._isUndo) {
                    if (!ej.isNullOrUndefined(val.cSheetIndex)) {
                        this.setActiveSheetIndex(val.cSheetIndex);
                        this.XLSelection.selectRange(val.cutCells[0], val.cutCells[val.cutCells.length - 1]);
                    }
                    if (!ej.isNullOrUndefined(val.pSheetIndex)) {
                        this.setActiveSheetIndex(val.pSheetIndex);
                        this.XLSelection.selectRange(val.pasteCells[0], val.pasteCells[val.pasteCells.length - 1]);
                    }
                }
                else {
                    if (!ej.isNullOrUndefined(val.pSheetIndex)) {
                        this.setActiveSheetIndex(val.pSheetIndex);
                        this.XLSelection._focusBorder(val.pasteCells[0], val.pasteCells[val.pasteCells.length - 1], this._cutFocus);
                        this.XLSelection.selectRange(val.pasteCells[0], val.pasteCells[val.pasteCells.length - 1]);
                    }
                    if (!ej.isNullOrUndefined(val.cSheetIndex)) {
                        this.setActiveSheetIndex(val.cSheetIndex);
                        this.XLSelection.selectRange(val.cutCells[0], val.cutCells[val.cutCells.length - 1]);
                    }
                }
            }
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
            var pasteCells = val.pasteCells;
            val.pasteCells = val.cutCells;
            val.cutCells = pasteCells;
            var pasteBorder = val.pasteBorder;
            val.pasteBorder = val.cutBorder;
            val.cutBorder = pasteBorder;
            var tempIdx = val.cSheetIndex;
            val.cSheetIndex = val.pSheetIndex;
            val.pSheetIndex = tempIdx;
        },

        _undoForDel: function (val) {
            this._delCells = $.extend(true, [], val.delCells);
            this._deletedText = $.extend(true, [], val.text);
            this._removeMergeColl = $.extend(true, [], val.removeMerge);
            this._deletedDimension = $.extend(true, [], val.deletedDimension);
            if (this._isUndo) {
                this._fRow.fRowCnt = val.fRow.fRowCnt;
                this._fCol.fColCnt = val.fCol.fColCnt;
                this._fRow.rowAdj = val.fRow.rowAdj;
                this._fCol.colAdj = val.fCol.colAdj;
            }
            switch (val.action) {
                case "deleteShiftUp":
                    this.deleteShiftUp(val.startCell, val.endCell);
                    break;
                case "deleteShiftLeft":
                    this.deleteShiftLeft(val.startCell, val.endCell);
                    break;
                case "deleteRow":
                    this.deleteEntireRow(val.startCell.rowIndex, val.endCell.rowIndex);
                    break;
                case "deleteColumn":
                    this.deleteEntireColumn(val.startCell.colIndex, val.endCell.colIndex);
                    break;
            }
        },

        _undoForEdit: function (val) {
            var i, hLink, curVal, fObj, temp, cFormatStr, len, cFormatRule = val.cFormatRule, selCell = { rowIndex: val.rowIndex, colIndex: val.colIndex }, cmnt, cell, textDecoration, rows = this.getRows(val.sheetIndex);
            this.setActiveCell(val.rowIndex, val.colIndex, val.sheetIndex);
            this.XLSelection.selectRange(val.startCell, val.endCell);
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
            if (this._isRowViewable(val.sheetIndex, val.rowIndex)) {
                cell = this.getCell(val.rowIndex, val.colIndex);
                textDecoration = cell.find("a").css("text-decoration");
                if (val.altwrap)
                    this._isUndo ? (this.XLEdit._clearDataContainer({ cellIdx: selCell, property: ["altTxt"] })) : (this.XLEdit._updateDataContainer(selCell, { dataObj: { altTxt: true } }));
            }
            hLink = this.XLEdit.getPropertyValue(val.rowIndex, val.colIndex, "hyperlink", val.sheetIndex);
            if (!ej.isNullOrUndefined(hLink)) {
                curVal = this.XLEdit.getPropertyValue(val.rowIndex, val.colIndex, "value2");
                val.action = (curVal.length < 1) ? "add" : "delete";
                val.reqType = "edit";
                selCell.prevLink = hLink;
                selCell.prevText = curVal;
                val.selectedCell = [];
            }
            cmnt = this.XLEdit.getPropertyValue(val.rowIndex, val.colIndex, "comment");
            this.XLEdit._updateCellValue({ rowIndex: val.rowIndex, colIndex: val.colIndex }, val.pValue);
            this._dupDetails = true;
            if (cFormatRule && cFormatRule.length) {
                for (i = 0, len = cFormatRule.length; i < len; i++) {
                    cFormatStr = cFormatRule[i].split("_");
                    this.XLCFormat._cFormat(cFormatStr[0], cFormatStr[2], cFormatStr[3], cFormatStr[4], cFormatStr[5]);
                }
                this.XLCFormat.refreshCFormat(this._getAlphaRange(val.sheetIndex, val.rowIndex, val.colIndex, val.rowIndex, val.colIndex));
            }
            if (val.prevFrmtObj && val.curFrmtObj) {
                fObj = this._isUndo ? val.prevFrmtObj : val.curFrmtObj;
                this.XLFormat.format(fObj, this._getAlphaRange(val.sheetIndex, val.rowIndex, val.colIndex, val.rowIndex, val.colIndex));
            }
            this._dupDetails = false;
            this._textClip(val.rowIndex, val.colIndex, (val.pValue.length > 0) ? 'add' : 'delete');
            if (!ej.isNullOrUndefined(cmnt)) {
                this.XLEdit._updateDataContainer({ rowIndex: val.rowIndex, colIndex: val.colIndex }, { dataObj: { "comment": cmnt } });
                this.XLComment.setComment();
                this.XLComment._updateCurCmntVal();
            }
            if (this._isRowViewable(val.sheetIndex, val.rowIndex)) {
                hLink && (!(hLink.webAdr) ? cell.html(ej.buildTag("a", cell.text(), "", {"class": "e-hyperlinks" })) : cell.html(ej.buildTag("a", cell.text(), "", { href: hldata.webAdr, target: "_blank", "class": "e-hyperlinks" })));
                cell.find("a").css("text-decoration", textDecoration);
                cell.removeClass("e-commentcell");
            }
            if (!ej.isNullOrUndefined(hLink)) {
                selCell.curLink = this.XLEdit.getPropertyValue(val.rowIndex, val.colIndex, "hyperlink");
                selCell.curText = this.XLEdit.getPropertyValue(val.rowIndex, val.colIndex, "value2");
                val.selectedCell.push(selCell);
            }
            if (val.prevHeight != val.newHeight) {
                this.getSheet(val.sheetIndex).rowsHeightCollection[val.rowIndex] = val.prevHeight;
                if (this._isRowViewable(val.sheetIndex, val.rowIndex)) {
                    rows[0][val.rowIndex].style.height = val.prevHeight + "px";
                    rows[1][val.rowIndex].style.height = val.prevHeight + "px";
                }
                this._setRowHdrHeight(val.sheetIndex, val.rowIndex);
                this.XLScroll._getRowHeights(val.sheetIndex, val.rowIndex);
                temp = val.newHeight;
                val.newHeight = val.prevHeight;
                val.prevHeight = temp;
            }
            temp = val.cValue;
            val.cValue = val.pValue;
            val.pValue = temp;
            this.XLEdit._isEdit = false;
            temp = val.previousValue;
            val.previousValue = val.value;
            val.value = temp;
            if (this.model.allowFormulaBar)
                this.updateFormulaBar();
        },

        _undoForFilter: function (val) {
            var fltrChk = false, filterdCol = [], prevFltr, cell, selCells = [], i, len, fltr, rIdx, cIdx, filterCell, sheetIdx = val.sheetIndex || this.getActiveSheetIndex(), container = this._dataContainer.sheets[sheetIdx];
            if (val.operation === "filter" && val.requestType !== "filterbycell") {
                if (this._isUndo) {
                    for (i = this._undoCollection.length - 1; i >= 0 ; i--) {
                        if (this._undoCollection[i].reqType === "filter" && this._undoCollection[i].tableID === val.tableID && this._undoCollection[i].action === "filtering" && this._undoCollection[i].status !== "apply-filterIcon") {
                            if (this._undoCollection[i].rowIndex === val.rowIndex && this._undoCollection[i].colIndex === val.colIndex) {
                                delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                                prevFltr = this._undoCollection[i];
                                this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, prevFltr.tableID);
                                for (i = 0, len = prevFltr.filterCollection.length; i < len; i++)
                                    filterdCol.push(prevFltr.filterCollection[i]);
                                this.model.sheets[prevFltr.sheetIndex].filterSettings.filteredColumns = filterdCol;
                                if (ej.isNullOrUndefined(this._excelFilter._predicates[prevFltr.sheetIndex][prevFltr.fieldName]))
                                    this._excelFilter._predicates[prevFltr.sheetIndex][prevFltr.fieldName] = {};
                                this._excelFilter._predicates[prevFltr.sheetIndex][prevFltr.fieldName] = prevFltr.ejpredicate;
                                this.model.sheets[prevFltr.sheetIndex]._selectedRange = prevFltr.range;
                                this.XLFilter._filterHandler(prevFltr);
                                fltr = "undo";
                                fltrChk = true;
                                break;
                            }
                        }
						if (this._undoCollection[i].reqType === "filter" && this._undoCollection[i].tableID === val.tableID && this._undoCollection[i].action === "clearfiltering") {
							delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                            prevFltr = this._undoCollection[i];
                            this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, prevFltr.tableID);
							fltrChk = true;
							break;
						}
                        if (this._undoCollection[i].requestType === "filterbycell") {
                            if (this._undoCollection[i].rowIndex === val.rowIndex && this._undoCollection[i].colIndex === val.colIndex) {
                                prevFltr = this._undoCollection[i];
                                delete this._excelFilter._predicates[prevFltr.sheetIndex][prevFltr.fieldName];
                                this.XLFilter._clearFilterColumn(prevFltr.fieldName, "", "", "Or", null, null, prevFltr.tableID);
                                $.extend(true, selCells, prevFltr.selCells);
                                this.XLFilter._filterActiveCell(prevFltr.sheetIndex, prevFltr.activeCell, selCells, prevFltr.filteredValue, prevFltr.selRange);
                                fltr = "undo";
                                fltrChk = true;
                                break;
                            }
                        }
                    }
                    if (!fltrChk) {
                        delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                        this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, val.tableID);
                    }
                }
                else {
                    filterdCol = [];
                    delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                    this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, val.tableID);
                    for (i = 0, len = val.filterCollection.length; i < len; i++)
                        filterdCol.push(val.filterCollection[i]);
                    this.model.sheets[val.sheetIndex].filterSettings.filteredColumns = filterdCol;
                    (ej.isNullOrUndefined(this._excelFilter._predicates[val.sheetIndex][val.fieldName])) && (this._excelFilter._predicates[val.sheetIndex][val.fieldName] = {});
                    this._excelFilter._predicates[val.sheetIndex][val.fieldName] = val.ejpredicate;
                    if (val.filterCollection.length)
                        this.XLFilter._filterHandler(val);
                    fltr = "redo";
                }
            }
            else {
                if (this._isUndo) {
                    if (val.operation === "apply-filter" && val.requestType !== "filterbycell") {
                        for (i = 0, len = val.filteredCells.length; i < len; i++) {
                            rIdx = val.filteredCells[i].rowIndex; cIdx = val.filteredCells[i].colIndex;
                            filterCell = this.getCell(rIdx, cIdx, val.sheetIndex);
                            filterCell.find(".e-ssfilter").remove();
                            this._removeClass(filterCell[0], "e-filterhdr");
                            this.addClass(filterCell[0], "e-wrapword");
                            (this.isNumber(filterCell.text()) || this.XLEdit._parseValue(filterCell.text(), { rowIndex: rIdx, colIndex: cIdx }).type === "datetime" || this.XLEdit._parseValue(filterCell.text(), { rowIndex: rIdx, colIndex: cIdx }).type === "currency" || this.XLEdit._parseValue(filterCell.text()).type === "percentage", { rowIndex: rIdx, colIndex: cIdx }) && filterCell.addClass(this._rAlign);
                            delete container[rIdx][cIdx]["isFilterHeader"];
                            delete container[rIdx][cIdx]["filterState"];
                            delete container[rIdx][cIdx]["isFilterVisible"];
							if(this.XLEdit.getPropertyValue(rIdx, cIdx, "isFilterWrap"))
								this.setWrapText("wrap", this._getAlphaRange(sheetIdx, rIdx,cIdx, rIdx, cIdx));
                        }
                    }
                    if (val.requestType === "filterbycell") {
                        delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                        this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, val.tableID);
                        if (!this.isUndefined(val.filteredCells)) {
                            for (i = 0, len = val.filteredCells.length; i < len; i++) {
                                filterCell = this.getCell(val.filteredCells[i].rowIndex, val.filteredCells[i].colIndex, val.sheetIndex);
                                filterCell.find(".e-ssfiltered, .e-ssfilter").remove();
                                this._removeClass(filterCell[0], "e-filterhdr");
                                this.addClass(filterCell[0], "e-wrapword");
                                (this.isNumber(filterCell.text()) || this.XLEdit._parseValue(filterCell.text(), { rowIndex: val.filteredCells[i].rowIndex, colIndex: val.filteredCells[i].colIndex }).type === "datetime" || this.XLEdit._parseValue(filterCell.text(), { rowIndex: val.filteredCells[i].rowIndex, colIndex: val.filteredCells[i].colIndex }).type === "currency" || this.XLEdit._parseValue(filterCell.text(), { rowIndex: val.filteredCells[i].rowIndex, colIndex: val.filteredCells[i].colIndex }).type === "percentage") && filterCell.addClass(this._rAlign);
                            }
                        }
                    }
                    this.model.sheets[val.sheetIndex].filterSettings.range = "";
                    if ((val.operation === "apply-filter" && val.requestType != "filterbycell") || (val.requestType === "filterbycell" && !this.isUndefined(val.filteredCells))) {
                        var tabRange = this.model.sheets[val.sheetIndex].filterSettings.tableRange, tabIdx;
                        for (var i = 0, len = tabRange.length; i < len; i++) {
                            if (tabRange[i].tableID === val.tableID) {
                                tabIdx = i;
                                break;
                            }
                        }
                        val.filterRange = tabRange.splice(tabIdx, 1)[0];
                    }
                    if (val.operation === "remove-filter") {
                        var pCol = this._undoCollection[this._undoCollection.length - 1], sheet = this.getSheet(val.sheetIndex);
                        if (pCol.requestType === "filterbycell") {
                            $.extend(true, selCells, pCol.selCells);
                            this.XLFilter._filterActiveCell(pCol.sheetIndex, pCol.activeCell, selCells, pCol.filteredValue, pCol.selRange);
                        }
                        else {
                            var filterIcon;
                            for (i = 0, len = val.filteredCells.length; i < len; i++) {
                                filterIcon = this.XLFilter._getFilterIcon();
                                this.XLFilter._applyFilterIcon(val.filteredCells[i], filterIcon);
                            }
                        }
						sheet._selectedRange = val.selRange;
						sheet.filterSettings.filteredRange = val.fltrdRange;
						sheet.filterSettings.filteredColumns = val.filteredCols;
						sheet.filterSettings.range = val.fRange;
						sheet.filterSettings.tableRange.push(val.filterRange);
						for(var k = 0, kLen = val.filterCollection.length; k < kLen; k++) {
							this._excelFilter._predicates[val.sheetIndex][val.filterCollection[k].fieldName] = val.filterCollection[k].predicate;
							this.XLFilter._filterHandler(val.filterCollection[k]);
						}
                    }
                }
                else {
                    if (val.operation === "remove-filter") {
                        if (val.requestType === "filterbycell") {
                            if (this._isRowViewable(val.sheetIndex, val.activeCell.rowIndex)) {
                                cell = this.getCell(val.activeCell.rowIndex, val.activeCell.colIndex);
                                cell.find("span.e-ssfilter").remove();
                            }
                            delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                            this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, val.tableID);
                            $.extend(true, selCells, val.selectedCell);
                            this.XLFilter._filterActiveCell(val.sheetIndex, val.activeCell, selCells, val.filteredValue, val.selRange);
                        }
                        else
                            this.XLFilter.clearFilter("remove");
                    }
                    if (val.operation === "filter") {
                        if (val.requestType === "filterbycell") {
                            delete this._excelFilter._predicates[val.sheetIndex][val.fieldName];
                            this.XLFilter._clearFilterColumn(val.fieldName, "", "", "Or", null, null, val.tableID);
                            $.extend(true, selCells, val.selectedCell);
                            this.XLFilter._filterActiveCell(val.sheetIndex, val.activeCell, selCells, val.filteredValue, val.selRange);
                        }
                    }
                    if (val.operation === "apply-filter") {
                        var filterIcon, sheet = this.getSheet(val.sheetIndex);
                        for (i = 0, len = val.filteredCells.length; i < len; i++) {
                            filterIcon = this.XLFilter._getFilterIcon();
                            this.XLFilter._applyFilterIcon({ rowIndex: val.filteredCells[i].rowIndex, colIndex: val.filteredCells[i].colIndex }, filterIcon);
                        }
                        sheet.filterSettings.range = val.fRange;
                        sheet.filterSettings.tableRange.push(val.filterRange);
                    }
                }
            }
        },

        _undoForFilterByColor: function (val) {
            var avble = false, filterColl, coll = [];
            coll.push(val);
            filterColl = (this._isUndo) ? this._undoCollection : coll;
            delete this._excelFilter._predicates[val.sheetIndex][val.columnName];
            this.XLFilter._clearFilterColumn(val.columnName, "", "", "Or", null, null, val.tableID);
            for (var i = filterColl.length - 1; i >= 0 ; i--) {
                if (filterColl[i].reqType === "filterbycolor" && filterColl[i].tableID === val.tableID) {
                    if (filterColl[i].rowIndex === val.rowIndex && filterColl[i].colIndex === val.colIndex) {
                        this.XLFilter._filterHandler(filterColl[i]);
                        break;
                    }
                }
            }
        },

        _undoForFind: function (val) {
            var cell, i, len, t;
            switch (val.operation) {
                case "replace": {
                    this.XLEdit._updateCellValue({ rowIndex: val.rowIndex, colIndex: val.colIndex }, val.prevData.value, null, val.sheetIndex);
                    t = val.prevData;
                    val.prevData = val.newData;
                    val.newData = t;
                    this.XLSelection.selectRange({ rowIndex: val.rowIndex, colIndex: val.colIndex }, { rowIndex: val.rowIndex, colIndex: val.colIndex });
                    break;
                }
                case "replaceAll": {
                    for (i = 0, len = val.selectedCell.length; i < len; i++) {
                        this.XLEdit._updateCellValue({ rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex }, val.selectedCell[i].prevData.value, null, val.selectedCell[i].sheetIndex);
                        t = val.selectedCell[i].prevData;
                        val.selectedCell[i].prevData = val.selectedCell[i].newData;
                        val.selectedCell[i].newData = t;
                    }
                    break;
                }
                case "blanks":
                case "conditions":
                case "validations":
                case "formulas":
                case "rowdiff":
                case "coldiff":
                case "comments":
                case "constants": {
                    for (i = 0, len = val.selectedCell.length; i < len; i++) {
                        cell = this.getCell(val.selectedCell[i].rowIndex, val.selectedCell[i].colIndex, val.sheetIndex);
                        if (this._isUndo) {
                            if (cell.operation === "coldiff" || cell.operation === "rowdiff")
                                (val.selectedCell[i].isApply) ? cell.removeClass("e-selected") : cell.addClass("e-selected");
                            else
                                (val.selectedCell[i].isApply) ? cell.addClass("e-selected") : cell.removeClass("e-selected");
                        }
                        else {
                            cell.removeClass("e-selected");
                        }
                    }
                    break;
                }
            }
            if (this.model.allowFormulaBar)
                this.updateFormulaBar();
        },

        _undoForFormat: function (val) {
            var isViewed = false, range, cell, formatCls, cElem, container = this._dataContainer.sheets[val.sheetIndex], val2, s, regx, prefix = "";
            if (ej.isNullOrUndefined(val.process)) {
                if (val.oprType === "style") {
                    this.XLFormat.removeStyle(val.range, { cellStyle: true, format: true });
                    prefix = "e-format";
                    if (!ej.isNullOrUndefined(val.process) && val.process.indexOf("border") > -1)
                        prefix = "e-border";
                    regx = new RegExp('\\b' + prefix + '.*?\\b', 'g')
                }
                range = { startCell: val.selectedCell[0], endCell: val.selectedCell[val.selectedCell.length - 1] };
                for (var i = 0, len = val.selectedCell.length; i < len; i++) {
                    cell = val.selectedCell[i];
                    if (this._isRowViewable(val.sheetIndex, cell.rowIndex)) {
                        cElem = this.getCell(cell.rowIndex, cell.colIndex)[0];
                        isViewed = true;
                    }
                    if (ej.isNullOrUndefined(container[cell.rowIndex]))
                        container[cell.rowIndex] = {};
                    if (ej.isNullOrUndefined(container[cell.rowIndex][cell.colIndex]))
                        container[cell.rowIndex][cell.colIndex] = {};
                    $.extend(true, container[cell.rowIndex][cell.colIndex], val.selectedCell[i].beforeFormat);
                    if (isViewed) {
                        if (val.oprType === "format") {
                            val2 = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "value2");
                            this.XLEdit._refreshTextNode(cElem, ej.isNullOrUndefined(val2) ? "" : val2);
							this.XLEdit._refreshCellAlignment({ 'cellIdx': { 'rowIndex': cell.rowIndex, 'colIndex': cell.colIndex } })
                        }
                        else {
                            formatCls = (prefix === "e-format") ? this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "format") : this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "border");
                            cElem.className = cElem.className.replace(regx, "");
                            formatCls = ej.isNullOrUndefined(formatCls) ? "" : formatCls;
                            this.addClass(cElem, formatCls);
                        }
                    }
                    if ((val.selectedCell[0].colIndex === val.selectedCell[i].colIndex) && this.model.allowResizing)
                        (this._isUndo) ? this.XLResize.setRowHeight(val.selectedCell[i].rowIndex, val.selectedCell[i].bRowHeight) : this.XLResize.setRowHeight(val.selectedCell[i].rowIndex, val.selectedCell[i].aRowHeight);
                    s = val.selectedCell[i].beforeFormat;
                    val.selectedCell[i].beforeFormat = val.selectedCell[i].afterFormat;
                    val.selectedCell[i].afterFormat = s;
                    isViewed = false;
                }
            }
            if (!ej.isNullOrUndefined(val.process) && val.process.indexOf("border") > -1) {
                this.XLFormat.removeStyle(val.range, { cellStyle: true, tableStyle: true, format: false, border: true });
                (this._isUndo) ? this.XLFormat.updateFormat(val.beforeFormat, val.range) : (val.process === "noborder") ? this.XLFormat.format({ border: {} }, val.range) : this.XLFormat.applyBorder($.extend(true, {}, val.options), val.range);
                s = val.beforeFormat;
                val.beforeFormat = val.afterFormat;
                val.afterFormat = s;
            }
            val.status = "undo-cellformat";
            this.performSelection(val.range);
        },

        _undoForFormatPaint: function (val) {
            var temp, i, rangeData, cells, sheet = this._dataContainer.sheets[val.sheetIndex], wraplen, unwraplen;
            this.XLCFormat.clearCF(val.range);
            this.XLFormat.removeStyle(val.range);
            this.updateData($.extend(true, [], val.beforeData), val.range);
            this.XLCFormat.refreshCFormat(val.range);
            rangeData = this.getRangeData({ range: val.range }), cells = this._getSelectedRange({ rowIndex: val.range[0], colIndex: val.range[1] }, { rowIndex: val.range[2], colIndex: val.range[3] });
            for (i = 0, unwraplen = val.unwrapCells.length; i < unwraplen; i++)
                this.setWrapText('unwrap', this._getAlphaRange(val.sheetIndex, val.unwrapCells[i].rowIndex, val.unwrapCells[i].colIndex, val.unwrapCells[i].rowIndex, val.unwrapCells[i].colIndex));
            for (i = 0, wraplen = val.wrapCells.length; i < wraplen; i++)
                this.setWrapText('wrap', this._getAlphaRange(val.sheetIndex, val.wrapCells[i].rowIndex, val.wrapCells[i].colIndex, val.wrapCells[i].rowIndex, val.wrapCells[i].colIndex));
            temp = val.unwrapCells;
            val.unwrapCells = val.wrapCells;
            val.wrapCells = temp;
            temp = val.beforeData;
            val.beforeData = val.afterData;
            val.afterData = temp;
        },

        _undoForFormatTable: function (val) {
            var j, ln, hdrCol, rng, selCells, tname, rangeData, merge, mlen, mergeData, range, i = 0, sheetIdx = val.sheetIndex,
                tmgr = this.getSheet(sheetIdx).tableManager, tclass, header = val.header, robj = $('#' + this._id + '_Ribbon').data('ejRibbon'), tabRange, isUndo = this._isUndo;
            switch (val.action) {
                case "Design_Tools_ConvertToRange":
                    if (this._isUndo) {
                        tmgr[val.tableID] = { name: val.name, range: val.beforeRange, format: val.format, formatName: val.formatName };
                        this.performSelection(this._getAlphaRange(sheetIdx, val.beforeRange[0], val.beforeRange[1], val.beforeRange[2], val.beforeRange[3]));
                        this.XLFilter._filterTable(sheetIdx, val.tableID);
                        this.updateUniqueData({ tableName: 'e-table' + val.tableID }, tmgr[val.tableID].range);
                        tmgr[val.tableID]["isFilter"] = val.isFilter;
                        tmgr[val.tableID]["firstColumn"] = val.firstColumn;
                        tmgr[val.tableID]["lastColumn"] = val.lastColumn;
                        tmgr[val.tableID]["totalRow"] = val.totalRow;
                        tmgr[val.tableID]["fnNumber"] = val.fnNumber;
                        this.getSheet(sheetIdx)._header[val.tableID] = header;
                        range = this._getDollarAlphaRange(tmgr[val.tableID].range, true);
                        this.XLRibbon.addNamedRange(val.name, range, null, sheetIdx);
                    }
                    else {
                        if (val.tableID in tmgr) {
                            tclass = 'e-table' + val.tableID;
                            this.XLFormat.removeTable(val.tableID);
                            this.XLFilter._clearFilterTable(sheetIdx, val.tableID);
                            delete tmgr[val.tableID];
                            delete this.model.sheets[sheetIdx]._header[val.tableID];
                        }
                    }
                    break;
                case "filtericon":
                    var fIcon = $("#" + val.id).data("ejCheckBox"), tid = val.tableId;
                    (val.check) ? fIcon.option("checked", false) : fIcon.option("checked", true);
                    tmgr[tid]["isFilter"] = !(val.check);
                    val.check = !(val.check);
                    break;
                case "firstlastcolumn":
                    var cc = $("#" + val.id).data("ejCheckBox");
                    if (val.check) {
                        this.XLFormat.format({ style: { 'font-weight': 'normal' } }, val.range);
                        cc.option("checked", false);
                    }
                    else {
                        this.XLFormat.format({ style: { 'font-weight': 'bold' } }, val.range);
                        cc.option("checked", true);
                    }
                    tmgr[val.tableId][val.prop] = !val.check;
                    val.check = !(val.check);
                    break;
                case "totalrow":
                    $("#" + val.id).ejCheckBox('option', { checked: !val.check });
                    val.check = !(val.check);
                    break;
                case "Design_Tools_ResizeTable":
                    if (this._isUndo) {
                        this._isFATResize = true;
                        val.afterRange = $.extend(true, [], val.afterRange);
                        if (val.totalRow) {
                            this._dupDetails = true;
                            this.XLFormat._calculateTotalRow(sheetIdx, val.tableId, false);
                            val.beforeRange[2] -= 1;
                            tmgr[val.tableId].range[2] -= 1;
                        }
                        tname = tmgr[val.tableId].name;
                        this.XLFormat.removeTable(val.tableId);
                        this.XLFormat.removeStyle(val.afterRange);
                        hdrCol = val.beforeRange[3] - val.beforeRange[1] + 1;
                        rangeData = header[val.tableId].header ? this.getRangeData({ range: val.beforeRange }) : this.getRangeData({ range: val.beforeRange }).splice(hdrCol, this.getRangeData({ range: val.beforeRange }).length);
                        this.clearRangeData(val.beforeRange);
                        header[val.tableId].header ? this.updateData(rangeData, [val.beforeRange[0], val.beforeRange[1], val.beforeRange[2], val.beforeRange[3]]) : this.updateData(rangeData, [val.beforeRange[0], val.beforeRange[1], val.beforeRange[2] - 1, val.beforeRange[3]]);
                        tmgr[val.tableId] = { header: header[val.tableId].header, tblId: val.tableId, name: tname, range: val.beforeRange, format: val.format, formatName: val.formatName, firstColumn: val.firstColumn, lastColumn: val.lastColumn, isFilter: val.isFilter, totalRow: val.totalRow };
                        this.XLClipboard._isCut = true;
                        header[val.tableId].header ? this.XLFormat.createTable(tmgr[val.tableId], val.beforeRange) : this.XLFormat.createTable(tmgr[val.tableId], [val.beforeRange[0], val.beforeRange[1], val.beforeRange[2] - 1, val.beforeRange[3]]);
                        if (val.totalRow) {
                            this._dupDetails = true;
                            this.XLFormat._calculateTotalRow(sheetIdx, val.tableId, true);
                            val.beforeRange = tmgr[val.tableId].range;
                        }
                        tabRange = this.getSheet(sheetIdx).filterSettings.tableRange;
                        for (i = 0; i < tabRange.length; i++) {
                            if (tabRange[i].tableID == val.tableId) {
                                tabRange[i].endRow = tabRange[i].selectedRange.endRow = val.beforeRange[2];
                                break;
                            }
                        }
                        this.XLClipboard._isCut = false;
                        this._isFATResize = false;
                    }
                    else {
                        this._isFATResize = true;
                        val.beforeRange = $.extend(true, [], val.beforeRange);
                        if (val.totalRow) {
                            this.XLFormat._calculateTotalRow(sheetIdx, val.tableId, false);
                            val.afterRange = tmgr[val.tableId].range = [val.afterRange[0], val.afterRange[1], val.afterRange[2] - 1, val.afterRange[3]];
                        }
                        tname = tmgr[val.tableId].name;
                        this.XLFormat.removeTable(val.tableId);
                        this.XLFormat.removeStyle(val.beforeRange);
                        hdrCol = val.beforeRange[3] - val.beforeRange[1] + 1;
                        rangeData = header[val.tableId].header ? this.getRangeData({ range: val.afterRange }) : this.getRangeData({ range: val.afterRange }).splice(hdrCol, this.getRangeData({ range: val.afterRange }).length);
                        this.clearRangeData(val.afterRange);
                        header[val.tableId].header ? this.updateData(rangeData, val.afterRange) : this.updateData(rangeData, [val.afterRange[0], val.afterRange[1], val.afterRange[2] - 1, val.afterRange[3]]);
                        tmgr[val.tableId] = { header: header[val.tableId].header, tblId: val.tableId, name: tname, range: val.beforeRange, format: val.format, formatName: val.formatName, firstColumn: val.firstColumn, lastColumn: val.lastColumn, isFilter: val.isFilter, totalRow: val.totalRow };
                        this.XLClipboard._isCut = true;
                        header[val.tableId].header ? this.XLFormat.createTable(tmgr[val.tableId], val.afterRange) : this.XLFormat.createTable(tmgr[val.tableId], [val.afterRange[0], val.afterRange[1], val.afterRange[2] - 1, val.afterRange[3]]);
                        this.XLFilter._extendFilterRange(val.tableId, val.afterRange);
                        if (val.totalRow) {
                            this.XLFormat._calculateTotalRow(sheetIdx, val.tableId, true);
                            val.afterRange = tmgr[val.tableId].range;
                        }
                        this.XLClipboard._isCut = false;
                        this._isFATResize = false;
                    }
                    break;
                case "renaming":
                    this.XLRibbon.removeNamedRange(tmgr[val.tableId].name);
                    if (document.getElementById(this._id + '_Ribbon_Design_Properties_TableName'))
                        document.getElementById(this._id + '_Ribbon_Design_Properties_TableName').value = tmgr[val.tableId].name = (this._isUndo) ? val.prevName : val.newName;
                    this.XLRibbon.addNamedRange(tmgr[val.tableId].name, val.range, null, sheetIdx);
                    robj.showTab(this._getLocStr('Design'));
                    break;
                default:
                    if (this._isUndo) {
                        tname = tmgr[val.tableID].name;
                        this.XLFormat.removeTable(val.tableID);
                        this.XLFormat.removeStyle(val.afterRange);
                        if (!val.tableStyle.header) {
                            hdrCol = val.afterRange[3] - val.afterRange[1] + 1;
                            this.clearRangeData(val.afterRange);
                            this.updateData($.extend(true, [], val.beforeRangeData), val.afterRange);
                        }
                        else {
                            for (j = 0, ln = val.beforeRangeHeader.length; j < ln; j++) {
                                if (ej.isNullOrUndefined(val.beforeRangeHeader[j].value2))
                                    this.XLEdit._updateCellValue(this._getCellIdx(val.pcells[j]), "");
                                else {
                                    if (this.isNumber(val.pcells[j].innerHTML))
                                        this.XLEdit._refreshCellAlignment({ cellIdx: this._getCellIdx(val.pcells[j]) });
                                }
                            }
                        }
                        this.XLFormat.updateFormat(val.beforeFormat, val.afterRange);
                        merge = val.beforeMergeRange;
                        mlen = merge.length;
                        if (mlen) {
                            while (i < mlen) {
                                mergeData = merge[i].value;
                                if (mergeData) {
                                    rng = this.getRangeIndices(mergeData.mRange);
                                    selCell = this._getSelectedRange({ rowIndex: rng[0], colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });
                                    this.mergeCenter = mergeData.isCenterAlign;
                                    this._mergeCells(val.sheetIndex, selCell, {}, []);
                                }
                                i++;
                            }
                        }
                    }
                    else
                        this.XLFormat.createTable(val.tableStyle, val.beforeRange);
                    break;
            }
        },

        _autosumFormatUpdate: function (data, range, isTable, isChecked) {
            var temp = {}, aRange, sheetIdx = this.getActiveSheetIndex();
            if (data.type !== "general") {
                this._dupDetails = true;
                temp["type"] = data.type;
                if (isTable)
                    aRange = this._getAlphaRange(sheetIdx, range[2] + 1, range[3], range[2] + 1, range[3]);
                else
                    aRange = this._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);
                if (isChecked)
                    this.XLFormat.format({ type: "general" }, aRange + ":" + aRange);
                else
                    this.XLFormat.format(temp, aRange + ":" + aRange);
                this._dupDetails = false;
            }
        },
        _undoForHyperlink: function (val) {
            var i, len, endCell = { rowIndex: val.selectedCell[val.selectedCell.length - 1].rowIndex, colIndex: val.selectedCell[val.selectedCell.length - 1].colIndex },
            startCell = { rowIndex: val.selectedCell[0].rowIndex, colIndex: val.selectedCell[0].colIndex }, lnk, txt, color;
            this.setActiveCell(val.selectedCell[0].rowIndex, val.selectedCell[0].colIndex);
            this.XLSelection.selectRange(startCell, endCell);
            if (val.action === "add")
                this._removeHyperlink(val.reqType, val.selectedCell);
            else if (val.action === "edit")
                this._setLink(val.selectedCell);
            else
                this._setLink(val.selectedCell);
            for (i = 0, len = val.selectedCell.length; i < len; i++) {
                lnk = val.selectedCell[i].prevLink;
                val.selectedCell[i].prevLink = val.selectedCell[i].curLink;
                val.selectedCell[i].curLink = lnk;
                txt = val.selectedCell[i].prevText;
                val.selectedCell[i].prevText = val.selectedCell[i].curText;
                val.selectedCell[i].curText = txt;
                color = val.selectedCell[i].prevColor;
                val.selectedCell[i].prevColor = val.selectedCell[i].curColor;
                val.selectedCell[i].curColor = color;
            }
            if (val.action === "add")
                val.action = "delete";
            else if (val.action === "delete")
                val.action = "add";
            this.XLSelection.selectRange(startCell, endCell);
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
        },

        _undoForIns: function (val) {
            $.extend(true, this._delCells, val.delCells);
            $.extend(true, this._deletedText, val.text);
            $.extend(true, this._removeMergeColl, val.removeMerge);
            switch (val.action) {
                case "insertShiftRight":
                    this.insertShiftRight(val.startCell, val.endCell);
                    break;
                case "insertShiftBottom":
                    this.insertShiftBottom(val.startCell, val.endCell);
                    break;
                case "insertRow":
                    this.insertEntireRow(val.startCell.rowIndex, val.endCell.rowIndex);
                    break;
                case "insertColumn":
                    this.insertEntireColumn(val.startCell.colIndex, val.endCell.colIndex);
                    break;
            }
        },

        _undoForMerge: function (val) {
            var rng, selectedCells, hiddenCount, pObj, cObj;
            this._delCells = val.hideCells;
            this._selMergeCells = [];
            switch (val.action) {
                case "merge-all":
                case "merge-across":
                case "un-merge":
                    for (var i = 0, len = val.mCells.length; i < len; i++) {
                        pObj = ej.isNullOrUndefined(val.mCells[i].prevObj) ? {} : ej.isNullOrUndefined(val.mCells[i].prevObj.merge) ? {} : val.mCells[i].prevObj.merge;
                        cObj = ej.isNullOrUndefined(val.mCells[i].curObj) ? {} : ej.isNullOrUndefined(val.mCells[i].curObj.merge) ? {} : val.mCells[i].curObj.merge;
                        if (val.action === "un-merge") {
                            if (!ej.isNullOrUndefined(pObj.mRange)) {
                                rng = this.getRangeIndices(pObj.mRange);
                                selectedCells = this._getSelectedRange({ rowIndex: rng[0], colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });
                                this.mergeCenter = pObj.isCenterAlign;
                                this._mergeCells(val.sheetIndex, selectedCells, {}, []);
                            }
                        }
                        else {
                            hiddenCount = this._getHiddenRowColumnCount(val.sheetIndex, cObj.mRange);
                            this._unMergeAllCells(val.sheetIndex, i, val.mCells, [], hiddenCount.hRow, hiddenCount.hCol);
                        }
                        var nObj = val.mCells[i].prevObj;
                        val.mCells[i].prevObj = val.mCells[i].curObj;
                        val.mCells[i].curObj = nObj;
                    }
                    if (val.action !== "un-merge") {
                        for (var i = 0, len = val.mCells.length; i < len; i++) {
                            pObj = ej.isNullOrUndefined(val.mCells[i].prevObj) ? {} : ej.isNullOrUndefined(val.mCells[i].prevObj.merge) ? {} : val.mCells[i].prevObj.merge;
                            cObj = ej.isNullOrUndefined(val.mCells[i].curObj) ? {} : ej.isNullOrUndefined(val.mCells[i].curObj.merge) ? {} : val.mCells[i].curObj.merge;
                            if (!ej.isNullOrUndefined(cObj.mRange)) {
                                rng = this.getRangeIndices(cObj.mRange);
                                selectedCells = this._getSelectedRange({ rowIndex: rng[0], colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });
                                this.mergeCenter = cObj.isCenterAlign;
                                this._mergeCells(val.sheetIndex, selectedCells, {}, []);
                            }
                        }
                    }
                    val.action = (val.action === "un-merge") ? "merge-all" : "un-merge";
                    break;
            }
            rng = this._getSelectedCells(val.sheetIndex, val.range).range;
            selectedCells = this._getSelectedRange({ rowIndex: rng[0], colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });
            this.performSelection(selectedCells[0], selectedCells[selectedCells.length - 1]);
            this._delCells = [];
        },

        _undoForReOrder: function (val) {
            var sheet = this.getSheet(val.sheetIndex), tmgr = this.getSheet(val.sheetIndex).tableManager;
            if (this._isUndo) {
                this.XLComment && this.XLComment.deleteComment();
                this.clearRangeData(val.destinationRange);
                this.XLFormat.removeStyle(val.destinationRange);
                this.XLCFormat.clearCF(val.destinationRange);
                if (!this.isUndefined(val.tblObj)) {
                    this.XLFormat.removeTable(val.tblObj.tblId);
                    this.XLClipboard._isCut = true;
                    this.XLFormat.createTable(val.tblObj, val.sourceRange);
                    val.tblObj.totalRow && this.XLFormat._updateTotalRow(val.sheetIndex, val.tblObj.tblId, val.tblObj.fnNumber, val.sourceRange, false);
                    this.XLClipboard._isCut = false;
                }
                this.updateData($.extend(true, [], val.sourceData), val.sourceRange);
                this.updateData($.extend(true, [], val.destinationData), val.destinationRange);
                if (val.tRange) {
                    this._dupDetails = true;
                    this.XLFilter.clearFilter("remove");
                    this.XLFilter.filter(val.tRange);
                    this._dupDetails = false;
                }
                this.XLFormat.updateFormat(val.sourceFormat, val.sourceRange);
                this.XLFormat.updateFormat(val.destinationFormat, val.destinationRange);
                if (!this.isUndefined(val.sourceCFormat) && !(val.sourceCFormat instanceof Array))
                    this.XLCFormat.setCFRule(val.sourceCFormat);
                this.setActiveCell(val.sourceRange[0], val.sourceRange[1]);
                this.XLSelection.selectRange({ rowIndex: val.sourceRange[0], colIndex: val.sourceRange[1] }, { rowIndex: val.sourceRange[2], colIndex: val.sourceRange[3] }, val.sheetIndex);
                sheet._startCell = { rowIndex: val.sourceRange[0], colIndex: val.sourceRange[1] };
                sheet._endCell = { rowIndex: val.sourceRange[2], colIndex: val.sourceRange[3] };
                this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
                this.setHeightToRows(val.prevDestRowHt);
            }
            else {
                this.XLSelection.selectRange({ rowIndex: val.sourceRange[0], colIndex: val.sourceRange[1] }, { rowIndex: val.sourceRange[2], colIndex: val.sourceRange[3] }, val.sheetIndex);
                this.XLComment && this.XLComment.deleteComment();
                this.clearRangeData(val.sourceRange);
                this.clearRangeData(val.destinationRange);
                if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(val.destinationRange[0], val.destinationRange[1], "tableName")))
                    this.XLFormat.removeStyle(val.destinationRange);
                if (!this.isUndefined(val.tblObj)) {
                    this.XLFormat.removeTable(val.tblObj.tblId);
                    this.XLClipboard._isCut = true;
                    this.XLFormat.createTable(val.tblObj, val.destinationRange);
                    this.XLClipboard._isCut = false;
                }
                if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(val.sourceRange[0], val.sourceRange[1], "tableName")))
                    this.XLFormat.removeStyle(val.sourceRange);
                this.XLCFormat.clearCF(val.sourceRange);
                this.updateData($.extend(true, [], val.sourceData), val.destinationRange);
                if (val.tRange) {
                    this._dupDetails = true;
                    this.XLFilter.clearFilter("remove");
                    this.XLFilter.filter(val.destinationRange);
                    this._dupDetails = false;
                }
                this.XLFormat.updateFormat(val.sourceFormat, val.destinationRange);
                val.tblObj && val.tblObj.totalRow && this.XLFormat._updateTotalRow(val.sheetIndex, val.tblObj.tblId, val.tblObj.fnNumber, val.destinationRange, false);
                if (!this.isUndefined(val.destinationCFormat) && !(val.destinationCFormat instanceof Array))
                    this.XLCFormat.setCFRule(val.destinationCFormat);
                this.setHeightToRows(val.destHeight);
                this.setActiveCell(val.destinationRange[0], val.destinationRange[1]);
                this.XLSelection.selectRange({ rowIndex: val.destinationRange[0], colIndex: val.destinationRange[1] }, { rowIndex: val.destinationRange[2], colIndex: val.destinationRange[3] }, val.sheetIndex);
                sheet._startCell = { rowIndex: val.destinationRange[0], colIndex: val.destinationRange[1] };
                sheet._endCell = { rowIndex: val.destinationRange[2], colIndex: val.destinationRange[3] };
                this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
            }
        },

        _undoForPivot: function (val) {
            var coll = (this._isUndo) ? this._undoCollection : this._redoCollection;
            var args = { curOperation: val, prevOperation: coll[coll.length - 1], isUndo: this._isUndo };
            this._trigger("_readUndoRedo", args);
        },

        _undoForResizeCol: function (val) {
            this.XLResize._resizeColumnUsingDiff(val.oldWidth, val.newWidth, val.cols);
            var temp = val.oldWidth;
            val.oldWidth = val.newWidth;
            val.newWidth = temp;
            if (this.model.allowAutoFill)
                this.XLDragFill.positionAutoFillElement();
        },

        _undoForResizeRow: function (val) {
            this.XLResize._resizeRowUsingDiff(val.oldHeight, val.newHeight, val.rows);
            var temp = val.oldHeight;
            val.oldHeight = val.newHeight;
            val.newHeight = temp;
            if (this.model.allowAutoFill)
                this.XLDragFill.positionAutoFillElement();
        },

        _undoForResizeFHeight: function (val) {
            var isUndo = this._isUndo,
			temp = val.newHeight;
			val.newHeight = val.oldHeight;
			val.oldHeight = temp;
            this.XLResize.setRowHeight(val.rowIndex, val.newHeight);
            this._isUndo ? this.XLEdit._clearDataContainer({ sheetIdx: val.sheetIndex, cellIdx: { rowIndex: val.rowIndex, colIndex: 0 }, property: ["isFitHeight"] }) : this.XLEdit._updateDataContainer({ rowIndex: val.rowIndex, colIndex: 0 }, { dataObj: { "isFitHeight": true } });
            if (this.model.allowAutoFill)
                this.XLDragFill.positionAutoFillElement();
            this._isUndo = isUndo;
        },

        _undoForResizeFWidth: function (val) {
            var cell = this.getCell(0, val.colIndex).get(0), isUndo = this._isUndo;
            var newWidth = val.newWidth;
            val.newWidth = (cell.offsetWidth === val.oldWidth) ? val.newWidth : val.oldWidth;
            val.oldWidth = newWidth;
            this.XLResize._applyWidth(val.target, val.sheetIndex, val.colIndex, val.newWidth);
            this.XLScroll._getColWidths(val.sheetIndex, val.colIndex);
            this._isUndo ? this.XLEdit._clearDataContainer({ sheetIdx: val.sheetIndex, cellIdx: { rowIndex: 0, colIndex: val.colIndex }, property: ["isFitWidth"] }) : this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: val.colIndex }, { dataObj: { "isFitWidth": true } });
            if (this.model.allowAutoFill)
                this.XLDragFill.positionAutoFillElement();
            this._isUndo = isUndo;
        },

        _undoForShape: function (val) {
            var cObj, dataVal, chartId, ddObj, idx = 0, chartThemes, shapeMgr = this.getSheet(val.sheetIndex).shapeMngr;
            (this.model.showRibbon) && (chartThemes = this.XLRibbon._chartThemes);
            if (val.action != "chartType" && val.action !== "create" && val.action !== "remove" && val.action !== "edit" && val.action !== "border" && val.action !== "resetpicture" && val.action !== "changepicture" && val.action !== "picturesize" && val.action !== "chartTheme" && val.action !== "chartType" && val.action !== "selectData") {
                cObj = $("#" + val.cid).data("ejChart");
                dataVal = this.getSheet(val.sheetIndex).shapeMngr.chart[this.XLEdit.getPropertyValue(val.rowIndex, val.colIndex, "chart")[0]];
            }
            switch (val.action) {
                case "remove":
                    this.XLShape._picCellIdx = this.XLShape._getCellIndexFromOffset(val.position.top, val.position.left);
                    this.XLShape._deleteShape(val.sheetIndex, $("#" + val.id));
                    val.action = "create";
                    break;
                case "create":
                    if (val.shapeType === "picture") {
                        this.XLShape._createPicture(val.sheetIndex, val.actCell, val.img, val.position.top, val.position.left, val.position.width, val.position.height, val.cnt, val.bcolor, val.bstyle, val.bwidth);
                        this.XLRibbon._formatTabUpdate();
                        $(val.actCell).addClass("e-activecell");
                    }
                    else {
                        this.XLSelection.selectRange({ rowIndex: val.range[0], colIndex: val.range[1] }, { rowIndex: val.range[0], colIndex: val.range[1] }, val.sheetIndex);
                        this.setActiveCell(val.range[0], val.range[1], val.sheetIndex);
                        this.XLChart.createChart(this._getAlphaRange(val.sheetIndex, val.range[0], val.range[1], val.range[2], val.range[3]), val.options, val.id);
                    }
                    val.action = "remove";
                    break;
                case "edit":
                    var rng, container = this._dataContainer.sheets[val.sheetIndex], shapeType = val.id.split("_")[1].replace(/[0-9]/g, ''), imgElem = {}, objIdx, prevCellIdx;
                    $("#" + val.id).css({ left: val.prev.left, top: val.prev.top, height: val.prev.height, width: val.prev.width });
                    (shapeType === "chart") && this.XLChart.resizeChart(val.id, val.prev.height, val.prev.width);
                    val.visualImg.hide();
                    this.XLShape._picCellIdx = this.XLShape._getCellIndexFromOffset(val.prev.top, val.prev.left), prevCellIdx = this.XLShape._getCellIndexFromOffset(val.cur.top, val.cur.left);
                    rng = this._getShapePositionInManager(prevCellIdx.rowIndex, prevCellIdx.colIndex, val.id, shapeType);
                    imgElem[shapeType] = val.obj[shapeType][rng];
                    if (val.actionType != "resize") {
                        if (this.getObjectLength(container[prevCellIdx.rowIndex][prevCellIdx.colIndex]) < 2 && container[prevCellIdx.rowIndex][prevCellIdx.colIndex][shapeType].length < 2)
                            delete container[prevCellIdx.rowIndex][prevCellIdx.colIndex];
                        else if (container[prevCellIdx.rowIndex][prevCellIdx.colIndex][shapeType].length < 2)
                            delete container[prevCellIdx.rowIndex][prevCellIdx.colIndex][shapeType];
                        else {
                            container[prevCellIdx.rowIndex][prevCellIdx.colIndex][shapeType].some(function (obj, i) { if (imgElem.id === obj.id) { objIdx = i; return true; } });
                            container[prevCellIdx.rowIndex][prevCellIdx.colIndex][shapeType].splice(objIdx, 1);
                        }
                    }
                    this.XLEdit._updateDataContainer({ rowIndex: this.XLShape._picCellIdx.rowIndex, colIndex: this.XLShape._picCellIdx.colIndex }, { dataObj: imgElem });
                    this.getCell(this.XLShape._picCellIdx.rowIndex, this.XLShape._picCellIdx.colIndex, val.sheetIndex).addClass("e-activecell");
                    if (this.model.showRibbon && this.element.find(".e-ss-activeimg").length < 1)
                        shapeType === "picture" ? this.XLRibbon._toggleFormatTab() : this.XLRibbon._toggleChartDesignTab();
                    this.XLRibbon._setShapeWidthHeight({ "width": val.prev.width, "height": val.prev.height, "shapeType": shapeType });
                    this._swapVal(val);
                    break;
                case "PHAxis":
                case "PVAxis":
                    var pAxis = (val.action == "PHAxis") ? "primaryXAxis" : "primaryYAxis", axis = (val.action === "PHAxis") ? "xAxis" : "yAxis";
                    val.visibility = !(val.visibility);
                    cObj.option(pAxis, { visible: val.visibility });
                    dataVal[axis].visible = val.visibility;
                    break;
                case "PX":
                case "PY":
                    var pAxis = (val.action == "PX") ? "primaryXAxis" : "primaryYAxis", axis = (val.action === "PX") ? "xAxis" : "yAxis";
                    ej.isNullOrUndefined(val.prev.text) && (val.prev.text = "");
                    cObj.option(pAxis, { title: { text: val.prev.text } });
                    dataVal[axis].title.text = val.prev.text;
                    this._swapVal(val);
                    break;
                case "CT":
                    cObj.option("title", { textAlignment: val.prev.align, text: val.prev.text });
                    dataVal.title = { text: val.prev.text, textAlignment: val.prev.align };
                    this._swapVal(val);
                    break;
                case "DLNone":
                    cObj.option({ series: val.prev.series });
                    dataVal.dataLabel = { visible: val.prev.series[0].marker.dataLabel.visible };
                    this._swapVal(val);
                    break;
                case "DL":
                    cObj.option({ series: val.prev.series });
                    dataVal.dataLabel = { visible: val.prev.series[0].marker.dataLabel.visible, vAlign: val.prev.series[0].marker.dataLabel.verticalTextAlignment, tPosn: val.prev.series[0].marker.dataLabel.textPosition };
                    this._swapVal(val);
                    break;
                case "PMajorH":
                    val.visibility = !(val.visibility);
                    cObj.option("primaryYAxis", { majorGridLines: { visible: val.visibility } });
                    dataVal.yAxis.majorGridLines = { visible: val.visibility };
                    break;
                case "PMajorV":
                    val.visibility = !(val.visibility);
                    cObj.option("primaryXAxis", { majorGridLines: { visible: val.visibility } });
                    dataVal.xAxis.majorGridLines = { visible: val.visibility };
                    break;
                case "PMinorH":
                    val.visibility = !(val.visibility);
                    cObj.option("primaryYAxis", { minorGridLines: { visible: val.visibility }, minorTicksPerInterval: 5, minorTickLines: { visible: val.visibility } });
                    dataVal.yAxis.minorGridLines = { visible: val.visibility };
                    break;
                case "PMinorV":
                    val.visibility = !(val.visibility);
                    cObj.option("primaryXAxis", { minorGridLines: { visible: val.visibility }, minorTicksPerInterval: 5, minorTickLines: { visible: val.visibility } });
                    dataVal.xAxis.minorGridLines = { visible: val.visibility };
                    break;
                case "LNone":
                    val.visibility = !(val.visibility);
                    cObj.option("legend", { visible: val.visibility });
                    dataVal.legend.visible = val.visibility;
                    break;
                case "Legend":
                    cObj.option("legend", { position: val.prev.position });
                    dataVal.legend.position = val.prev.position;
                    this._swapVal(val);
                    break;
                case "width":
                    var opt = { width: val.prev.width, height: val.prev.height,'shapeType': 'chart' };
                    var chartEle = $("#" + cObj._id);
                    cObj.option("size", $.extend(true, {}, opt));
                    chartEle[0].style.height = val.prev.height + "px";
                    chartEle[0].style.width = val.prev.width + "px";
                    dataVal.width = val.prev.width;
                    dataVal.height = val.prev.height;
                    this.XLRibbon._setShapeWidthHeight(opt);
                    this._swapVal(val);
                    break;
                case "height":
                    var opt = { width: val.prev.width, height: val.prev.height, 'shapeType': 'chart' };
                    var chartEle = $("#" + cObj._id);
                    cObj.option("size", $.extend(true, {}, opt));
                    chartEle[0].style.height = val.prev.height + "px";
                    chartEle[0].style.width = val.prev.width + "px";
                    dataVal.width = val.prev.width;
                    dataVal.height = val.prev.Height;
                    this.XLRibbon._setShapeWidthHeight(opt);
                    this._swapVal(val);
                    break;
                case "srcolumn":
                    var obj, chOptions;
                    cObj.model.series.length = 0;
                    dataVal.isRowColSwitched = !dataVal.isRowColSwitched;
                    obj = { xRange: dataVal.xRange, yRange: dataVal.yRange, lRange: dataVal.lRange, isRowColSwitched: dataVal.isRowColSwitched, dataSheetIdx: dataVal.dataSheetIdx };
                    chOptions = this.XLChart._processChartSeries(obj);
                    cObj.option({ series: chOptions.series });
                    this.getActiveSheetIndex() === dataVal.dataSheetIdx && this.XLChart._focusChartRange(chOptions.xRange, chOptions.yRange, chOptions.lRange);
                    dataVal.xAxis.range = chOptions.xRange;
                    dataVal.yAxis.range = chOptions.yRange;
                    dataVal.legend.range = chOptions.lRange;
                    break;
                case "border":
                    var temp, style, shapeObj = this._dataContainer.sheets[val.sheetIndex][val.cellIdx.rowIndex][val.cellIdx.colIndex].picture[val.picIdx], elem = $("#" + val.id);
                    this._removeClass(elem[0], val.curClass);
                    this.addClass(elem[0], val.prevClass);
                    style = this.XLShape._getImgStyleFromHashCode(val.prevClass);
                    shapeObj = { bcolor: style["border-color"], bstyle: style["border-style"], bwidth: style["border-width"] };
                    temp = val.prevClass;
                    val.prevClass = val.curClass;
                    val.curClass = temp;
                    break;
                case "resetpicture":
                    var elem = $("#" + val.id), regx = new RegExp("\\b" + "e-shapebdr" + ".*?\\b", "g");
                    if (this._isUndo)
                        (elem[0].className.match(regx)) && this.XLShape.changePictureBorder(elem[0].id, val.prev.bwidth, val.prev.bstyle, val.prev.bcolor);
                    else
                        elem[0].className = elem[0].className.replace(regx, "");
                    if (val.actionType !== "resetpicture") {
                        elem.css({ width: val.prev.width, height: val.prev.height });
                        this.XLShape._selectImg(elem);
                        this.XLShape._updateShapeObj(elem[0]);
                    }
                    this._swapVal(val);
                    break;
                case "changepicture":
                    var num, container = this._dataContainer;
                    $("#" + val.id).css("background-image", "url('" + val.prev.img + "')");
                    shapeMgr.picture[val.prev.pcIdx].data = val.prev.data;
                    this._swapVal(val);
                    break;
                case "picturesize":
                    var elem = $("#" + val.id), opt = { "width": val.prev.width, "height": val.prev.height, "shapeType": "picture" };
                    elem.css(opt);
                    this.XLRibbon._setShapeWidthHeight(opt);
                    this._swapVal(val);
                    break;
                case "chartTheme":
                    chartId = this.element.find("#" + this._id + "_chart").val(), ddObj = $("#" + this._id + "_Ribbon_ChartDesign_ChartThemes_ChartThemes").data("ejDropDownList");
                    (val.prev.theme.indexOf("dark") > -1) ? ($("#" + chartId).addClass('e-ss-charttheme')) : ($("#" + chartId).removeClass('e-ss-charttheme'));
                    this.XLChart.refreshChart(chartId, { theme: val.prev.theme });
                    for (var i = 0, len = chartThemes.length; len > i ; i++) {
                        if (val.prev.theme === chartThemes[i].value.toLowerCase()) {
                            idx = i;
                            break;
                        }
                    }
                    ddObj && ddObj.option({ selectedItemIndex: idx })
                    this._swapVal(val);
                    break;
                case "chartType":
                    this.XLChart.refreshChart(val.chartId, { type: val.prev.chartType, enable3D: val.prev.enable3D, marker: val.prev.marker });
                    this._swapVal(val);
                    break;
                case "selectData":
                    this.XLChart.changeDataRange(document.getElementById(this._id + "_chart").value, val.prev.xRange, val.prev.yRange, val.prev.lRange);
                    this._swapVal(val);
                    break;
            }
        },

        _undoForShowHide: function (val) {
            var i, len, rowHdrs, colHdrs;
            if (val.operation === "row") {
                rowHdrs = this._getJSSheetRowHeaderContent(val.sheetIndex);
                (val.action === "show") ? this._hideRow(val.hideRows[0], val.hideRows[val.hideRows.length - 1], "isRHide") : this._showRow(val.hideRows[0], val.hideRows[val.hideRows.length - 1], "isRHide");
                for (i = 0, len = val.remBRows.length; i < len; i++) {
                    this.addClass(rowHdrs.find('td')[val.remBRows[i]], "e-hrow");
                    this.XLEdit._updateDataContainer({ rowIndex: val.remBRows[i], colIndex: 0 }, { dataObj: { hRow: true } });
                }
                for (i = 0, len = val.addBRows.length; i < len; i++) {
                    this._removeClass(rowHdrs.find('td')[val.addBRows[i]], "e-hrow");
                    this._dataContainer.sheets[val.sheetIndex][val.addBRows[i]][0]["hRow"];
                }
                this.setActiveCell(val.bSelect.startRow, 0);
                (val.bSelect.startRow === val.bSelect.endRow) ? this.XLSelection.selectRow(val.bSelect.startRow, val.sheetIndex) : this.XLSelection.selectRows(val.bSelect.startRow, val.bSelect.endRow, val.sheetIndex);
                var addBRows = val.addBRows;
                val.addBRows = val.remBRows;
                val.remBRows = addBRows;
            }
            else {
                colHdrs = this._getJSSheetHeader(val.sheetIndex).find('th');
                (val.action === "show") ? this._hideColumn(val.hideCols[0], val.hideCols[val.hideCols.length - 1]) : this._showColumn(val.hideCols[0], val.hideCols[val.hideCols.length - 1]);
                for (i = 0, len = val.remBCols.length; i < len; i++) {
                    this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: val.remBCols[i] }, { dataObj: { hCol: true } });
                    this.addClass(colHdrs[val.remBCols[i]], "e-hcol");
                }
                for (i = 0, len = val.addBCols.length; i < len; i++) {
                    this._removeClass(colHdrs[val.addBCols[i]], "e-hcol");
                    this._dataContainer.sheets[val.sheetIndex][0][val.addBCols[i]]["hCol"];
                }
                this.setActiveCell(0, val.bSelect.startCol);
                (val.bSelect.startCol === val.bSelect.endCol) ? this.XLSelection.selectColumn(val.bSelect.startCol, val.sheetIndex) : this.XLSelection.selectColumns(val.bSelect.startCol, val.bSelect.endCol, val.sheetIndex);
                var addBCols = val.addBCols;
                val.addBCols = val.remBCols;
                val.remBCols = addBCols;
            }
            val.action = (val.action === "show") ? "hide" : "show";
            var bSelect = val.bSelect;
            val.bSelect = val.aSelect;
            val.aSelect = bSelect;
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
        },

        _undoForSort: function (val) {
            var colIdx = this.XLEdit.getColumnIndexByField(val.columnName), prevIcon, fSpan, fCol, rng, filterColl = this.getSheet(val.sheetIndex)._filterColl;
            if (val.colSelected < 1) {
                rng = val.range[0];
                if (val.range[0] > 0)
                    rng = val.range[0] - 1;
            }
            if (val.operation === "unsort") {
                this._dupDetails = true;
                this.XLComment.deleteComment(val.range, null, true, null);
                this._removeHyperlink(null, null, true, val.range);
                this.clearRangeData(val.range, ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "comment", "hyperlink", "format"], null, true);
                this.XLFormat.removeStyle(val.range, { cellStyle: true, tableStyle: true, format: true, skipHiddenRow: true });
                this.XLEdit.updateCellWithContainer(val.rangeData, val.range, val.sheetIndex, true);
                this.XLSort._refreshRowHeight(val.range, val.rangeData);
                this._dupDetails = false;
                val.operation = "sort";
            }
            else {
                this.XLSort._isSortByFilter = val.isSortByFilter;
                this.XLSort.sortByRange(val.range, val.columnName, val.direction);
                val.operation = "unsort";
            }
            if (val.isSortByFilter) {
                for (var i = 0; i < val.filterIcons.length; i++) {
                    fCol = filterColl[val.filterIcons[i].rowIdx][val.filterIcons[i].colIdx];
                    if (fCol.status.indexOf("-asc") > 1)
                        fCol.status = fCol.status.replace("-asc", val.filterIcons[i].prevIcon);
                    else if (fCol.status.indexOf("-dsc") > 1)
                        fCol.status = fCol.status.replace("-dsc", val.filterIcons[i].prevIcon);
                    else
                        fCol.status = fCol.status + val.filterIcons[i].prevIcon;
                    if (this._isRowViewable(val.sheetIndex, val.filterIcons[i].rowIdx)) {
                        fSpan = this.getCell(val.filterIcons[i].rowIdx, val.filterIcons[i].colIdx).find(".e-filterspan")[0];
                        if (fSpan.className.indexOf("-asc") > 1)
                            fSpan.className = fSpan.className.replace("-asc", val.filterIcons[i].prevIcon);
                        else if (fSpan.className.indexOf("-dsc") > 1)
                            fSpan.className = fSpan.className.replace("-dsc", val.filterIcons[i].prevIcon);
                        else {
                            if (fSpan.className.indexOf("e-ssfiltered") > -1)
                                fSpan.className = fSpan.className.replace("e-ssfiltered", "e-ssfiltered" + val.filterIcons[i].prevIcon);
                            else
                                fSpan.className = fSpan.className.replace("e-ssfilter", "e-ssfilter" + val.filterIcons[i].prevIcon);
                        }
                    }
                    prevIcon = val.filterIcons[i].prevIcon;
                    val.filterIcons[i].prevIcon = val.filterIcons[i].currIcon;
                    val.filterIcons[i].currIcon = prevIcon;
                }
            }
        },

        _undoForSortByColor: function (val) {
            var rng = val.range, pData = val.prev.data, i, format, colIdx = this._generateColCount(val.columnName) - 1;
            this.XLComment.deleteComment(rng, null, true, null);
            this._isSort = true;
            this._dupDetails = true;
            this._removeHyperlink(null, null, true, rng);
            this._isSort = false;
            this._dupDetails = false;
            this.clearRangeData(rng, ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "comment", "hyperlink", "format"], null, true);
            this.XLFormat.removeStyle(rng, { cellStyle: true, tableStyle: true, format: true, skipHiddenRow: true });
            this.XLEdit.updateCellWithContainer(pData, rng, val.sheetIndex, true);
            if (val.oprType.indexOf("Put") < 0) {
                var filterSpan = this.getCell(rng[0] - 1, colIdx).find(".e-filterspan");
                if (filterSpan.length > 0)
                    filterSpan[0].className = filterSpan[0].className.replace(val.cur.icon, val.prev.icon);
            }
            this._swapVal(val);
        },

        _undoForStyle: function (val) {
            this.XLFormat.updateUniqueFormat(val.beforeFormat, val.range, val.opr);
            this._updateRangeStyle(val.range, val.beforeFormat);
            var s = this.changePosition(val.beforeFormat, val.afterFormat);
            this._refreshRangeTRHght(this.getActiveSheetIndex(), val.range);
            val.beforeFormat = s[1];
            val.afterFormat = s[0];
            this._isUndoRedo = true;
            val.status = "undo-cellstyles";
        },

        _undoForTextWrap: function (val) {
            if (val.operation === "wrap") {
                this.setWrapText("unwrap", val.range);
                val.operation = "unwrap";
            }
            else {
                this.setWrapText("wrap", val.range);
                val.operation = "wrap";
            }
            this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
        },

        _undoForValidation: function (val) {
            var i, len, range = this.getRangeIndices(val.range);
            this.performSelection({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
            if (val.operation === "cl-hl-data") {
                this.XLValidate.highlightInvalidData(val.range);
                val.operation = "hl-data";
            }
            else if (val.operation === "apply-validation") {
                var selCells = val.selectedCell, rule, curRule, selected = [];
                for (i = 0, len = selCells.length; i < len; i++) {
                    curRule = this.XLEdit.getPropertyValue(selCells[i].rowIndex, selCells[i].colIndex, "rule");
                    rule = this.changePosition(selCells[i].prevRule, curRule);
                    val.selectedCell[i].prevRule = rule[1];
                    if (!ej.isNullOrUndefined(rule[0])) {
                        rule[0].customVal = rule[0].customVal;
                        this.XLEdit._updateDataContainer({ rowIndex: selCells[i].rowIndex, colIndex: selCells[i].colIndex }, { dataObj: { "rule": rule[0] } });
                    }
                    selected.push(selCells[i]);
                }
                if (ej.isNullOrUndefined(rule[0]))
                    this.clearRangeData(null, ["rule"], selected);
            }
            else if (val.operation === "hl-data") {
                this.XLValidate.clearHighlightedValData(val.range);
                val.operation = "cl-hl-data";
            }
            else {
                if (this._isUndo) {
                    for (i = 0, len = val.selectedCell.length; i < len; i++)
                        this.XLEdit._updateDataContainer({ rowIndex: val.selectedCell[i].rowIndex, colIndex: val.selectedCell[i].colIndex }, { dataObj: { "rule": val.selectedCell[i].rules } });
                    if (val.hlStatus)
                        this.XLValidate.highlightInvalidData(val.range);
                }
                else
                    this.XLValidate.clearDV(val.range);
            }
        },

        _applyCommentLink: function (cellObj, cell, rowIdx, colIdx) {
            var container = this._dataContainer, hldata, cFormatData = container.cFormatData, actCell, isViewed = false, sheetIdx = this.getActiveSheetIndex();
            if (this._isRowViewable(sheetIdx, cell.rowIndex)) {
                actCell = this.getCell(cell.rowIndex, cell.colIndex);
                isViewed = true;
                $(actCell).removeClass("e-redft e-yellowft e-greenft e-redf e-redt");
            }
            if (cellObj) {
                var value2 = this.isNumber(cellObj.value2) ? container.sharedData[cellObj.value2] : cellObj.value2;
                cellObj = $.extend(true, {}, cellObj);
                this.XLEdit._updateCellValue(cell, value2);
                if ("cFormatRule" in cellObj) {
                    var cFormatRule = cellObj.cFormatRule, splitStr;
                    for (var m = 0, rLen = cFormatRule.length; m < rLen; m++) {
                        splitStr = cFormatData[m].split("_");
                        this.XLCFormat._cFormat(splitStr[0], splitStr[2], splitStr[3], splitStr[4], null, null, [rowIdx, colIdx, rowIdx, colIdx]);
                    }
                }
                if ("hyperlink" in cellObj) {
                    var hldata = cellObj.hyperlink;
                    if (isViewed) {
                        if (hldata && !hldata.webAddr)
                            actCell.html(ej.buildTag("a.e-hyperlinks", this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, 'value2', sheetIdx), ""));
                        else
                            actCell.html(ej.buildTag("a.e-hyperlinks", this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, 'value2', sheetIdx), "", { href: hldata.webAddr, target: "_blank" }));
                    }
                }
                if ("comment" in cellObj) {
                    isViewed && actCell.removeClass("e-commentcell");
                    this.XLComment.setComment([cell.rowIndex, cell.colIndex, cell.rowIndex, cell.colIndex], null, false);
                }
            }
        },

        changePosition: function (first, second) {
            var swap = [];
            swap.push(second);
            swap.push(first);
            ej.swap(swap, 0, 1);
            return swap;
        },

        _addValidationRule: function (totRules, rule) {
            var dupRule = [];
            $.extend(true, dupRule, totRules);
            for (var i = 0, len = totRules.length; i < len; i++)
                if (totRules[i].customVal !== rule.customVal && totRules[i].required !== rule.required && totRules[i].Number !== rule.number)
                    dupRule.push(rule);
            totRules = dupRule;
            return totRules;
        },

        _addCondFormatRule: function (totRules, rule) {
            var avble = false, dupRule = [];
            $.extend(true, dupRule, totRules);
            for (var i = 0, len = totRules.length; i < len; i++) {
                rule = rule.indexOf("true") > -1 ? rule.replace("_true", "") : rule.replace("_false", "");
                if (totRules[i] === rule) {
                    avble = true;
                    break;
                }
            }
            (!avble) && dupRule.push(rule);
            totRules = dupRule;
            return totRules;
        },

        getCellClass: function (curCell) {
            var regx = this._formatRegx;
            var currClass = curCell && (curCell.className.indexOf("e-format") > -1) ? curCell.className.match(regx)[0] : "";
            return currClass;
        },


        //Insert Or Delete Rows and Columns
        _renderInsertDeleteDialog: function (operation) {
            var dlgId = this._id + "_insertdeletedlg", $dlg, $content, $okBtn, $canBtn, $btndiv, $btnctn, $content, text;
            $dlg = ej.buildTag("div#" + dlgId, "", { display: "none" });
            $content = ej.buildTag("div#" + dlgId + "_content.e-dlg-fields e-dlgctndiv");
            $dlg.append($content);
            $btndiv = ej.buildTag("div#" + dlgId + "_btndiv.e-dlg-btnfields");
            $btnctn = ej.buildTag("div");
            $okBtn = ej.buildTag("input#" + dlgId + "_okbtn", "", { "margin-left": 4 });
            $canBtn = ej.buildTag("input#" + dlgId + "_cantn");
            $okBtn.ejButton({ text: this._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._insertDeleteOk, this), enabled: true , cssClass: "e-ss-okbtn"});
            $canBtn.ejButton({ text: this._getLocStr("Cancel"), click: ej.proxy(this._insertDeleteCancel, this), showRoundedCorner: true, width: 60 });
            $btndiv.append($btnctn.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            $dlg.ejDialog({ showOnInit: false, enableModal: true, enableResize: false, allowKeyboardNavigation: false, width: "auto", height: "auto", cssClass: "e-ss-dialog e-" + this._id + "-dlg e-ss-insdeldlg", minWidth: 150 });
        },

        _refreshInsDelDialog: function (operation) {
            var enableBtn, $dlg = $("#" + this._id + "_insertdeletedlg"), $content, text;
            $dlg.ejDialog({ title: this._getLocStr(operation) });
            $dlg.ejDialog("open");
            this._insDelStatus = operation.toLowerCase();
            $content = $("#" + $dlg[0].id + "_content");
            text = (this._insDelStatus === "insert") ? ["ShiftRight", "ShiftBottom", "EntireRow", "EntireColumn"] : ["ShiftLeft", "ShiftUp", "EntireRow", "EntireColumn"];
            $content.children().empty();
            this._createRadioButton($dlg, $content, text);
            enableBtn = (this._insDelStatus === "insert") ? "ShiftBottom" : "ShiftLeft";
            $("#" + $dlg[0].id + "_" + enableBtn).ejRadioButton({ checked: true });
            $dlg.find("input[type='submit']:first").focus();
        },

        _createRadioButton: function ($dlg, $content, text) {
            var input, lbl, table, tr1, td1;
            table = ej.buildTag("table");
            for (var i = 0, len = text.length; i < len; i++) {
                tr1 = ej.buildTag("tr");
                td1 = ej.buildTag("td");
                lbl = ej.buildTag("label", this._getLocStr(text[i]), { "padding-bottom": 4 }, { "for": $dlg[0].id + "_" + text[i] });
                input = ej.buildTag("input#" + $dlg[0].id + "_" + text[i], "", {}, { type: "radio", name: "inserdelete" });
                td1.append(input);
                tr1.append(td1);
                td1 = ej.buildTag("td");
                td1.append(lbl);
                input.ejRadioButton({ size: "medium" });
                tr1.append(td1);
                table.append(tr1);
            }
            $content.append(table);
        },

        _getSelectedOption: function (text) {
            var dlgId = this._id + "_insertdeletedlg", selIdx = 0;
            for (var i = 0; i < 4; i++) {
                var rbtn = $("#" + dlgId + "_" + text[i]).data("ejRadioButton");
                if (rbtn.model.checked) {
                    selIdx = i;
                    break;
                }
            }
            return selIdx;
        },

        _insertDeleteOk: function () {
            this._isUndo = false, this._isUndoRedo = false;
            this._delCells = [];
            this._deletedText = [];
            this._removeMergeColl = [];
            this._deletedDimension = [];
            var text, selIdx, sheetIdx = this.getActiveSheetIndex(),
                startCell = this.model.sheets[sheetIdx]._selectedCells[0], endCell = this.model.sheets[sheetIdx]._selectedCells[this.model.sheets[sheetIdx]._selectedCells.length - 1];
            if (this._insDelStatus.indexOf("insert") > -1) {
                text = ["ShiftRight", "ShiftBottom", "EntireRow", "EntireColumn"];
                selIdx = this._getSelectedOption(text);
                if (text[selIdx].indexOf("ShiftRight") > -1)
                    this.insertShiftRight(startCell, endCell);
                else if (text[selIdx].indexOf("ShiftBottom") > -1)
                    this.insertShiftBottom(startCell, endCell);
                else if (text[selIdx].indexOf("EntireRow") > -1)
                    this.insertEntireRow(startCell.rowIndex, endCell.rowIndex);
                else
                    this.insertEntireColumn(startCell.colIndex, endCell.colIndex);
            }
            else {
                text = ["ShiftLeft", "ShiftUp", "EntireRow", "EntireColumn"];
                selIdx = this._getSelectedOption(text);
                if (text[selIdx].indexOf("ShiftLeft") > -1)
                    this.deleteShiftLeft(startCell, endCell);
                else if (text[selIdx].indexOf("ShiftUp") > -1)
                    this.deleteShiftUp(startCell, endCell);
                else if (text[selIdx].indexOf("EntireRow") > -1)
                    this.deleteEntireRow(startCell.rowIndex, endCell.rowIndex);
                else
                    this.deleteEntireColumn(startCell.colIndex, endCell.colIndex);
            }
            $("#" + this._id + "_insertdeletedlg").ejDialog("close");
            var sheetChart = this.model.sheets[this.model.activeSheetIndex].shapeMngr.chart;
            for (var i = 0; i < sheetChart.length; i++)
                this.XLChart._refreshChart(sheetChart[i]);
        },

        _insertDeleteCancel: function () {
            $("#" + this._id + "_insertdeletedlg").ejDialog("close");
        },

        _undoredoDetails: function (sheetIndex, startCell, endCell, reqType, action) {
            var details = { sheetIndex: sheetIndex, startCell: startCell, endCell: endCell, reqType: reqType, action: action, delCells: $.extend(true, [], this._delCells), text: this._deletedText, deletedDimension: this._deletedDimension, removeMerge: this._removeMergeColl, fRow: $.extend(true, {}, this._fRow), fCol: $.extend(true, {}, this._fCol) };
            if (!this.isImport && !this._isExport && !this._intrnlReq) {
                this._completeAction(details);
                this._trigActionComplete(details);
            }
            this._removeMergeColl = [];
            this._delCells = [];
            this._fRow.fRowCnt = 0;
            this._fCol.fColCnt = 0;
            this._fRow.rowAdj = true;
            this._fCol.colAdj = true;
        },

        _getRangeFrmFormula: function (formula) {
            var pAlpha = formula.substring(formula.indexOf("(") + 1, formula.indexOf(")")), regx = new RegExp('^\\b[a-zA-Z][0-9]*:[a-zA-Z][0-9]*\\b$', 'g');
            if (regx.test(pAlpha))
                return pAlpha;
            else if (pAlpha.indexOf(',') > 1)
                if (regx.test(pAlpha.split(',')[1]))
                    return pAlpha.split(',')[1];
                else if (regx.test(pAlpha.replace(',', ':')))
                    return pAlpha.replace(',', ':');
        },

        _refreshFormula: function (rowIdx, colIdx, count, status, type, startIdx, isShift) {
            var sheetIdx = this.getActiveSheetIndex(), diff, diff1, val = this.XLEdit.getPropertyValue(rowIdx, colIdx, "value"), pAlpha, nAlpha, range, cellArgs, actSheet = this.getSheet(sheetIdx);
            if (this._isUndo && (this._formulaChanged.pop() === "true"))
                return;
            if (this.isFormula(val)) {
                pAlpha = this._getRangeFrmFormula(val);
                if (ej.isNullOrUndefined(pAlpha))
                    return;
                range = this.getRangeIndices(pAlpha);
                diff = (type === "column") ? (status === "insert") ? range[3] + count : range[3] - count : (status === "insert") ? range[2] + count : range[2] - count;
                diff1 = (type === "column") ? (status === "insert") ? range[1] + count : range[1] - count : (status === "insert") ? range[0] + count : range[0] - count;
                (type === "column") ? (startIdx > range[1] && (diff1 = range[1])) : (startIdx > range[0] && (diff1 = range[0]));
                (type === "column") ? (startIdx > range[3] && (diff = range[3])) : (startIdx > range[2] && (diff = range[2]));
                if (isShift) {
                    if (!(range[1] === range[3]) && (range[0] === range[2]))
                        (type === "column") ? (range[1] === range[3]) && (diff = range[3], diff1 = range[1]) : (range[0] === range[2]) && (diff = range[2], diff1 = range[0]);
                    (type === "column") ? (diff < range[1]) && (diff = range[3]) : (diff < range[0]) && (diff = range[2]);
                    (type === "column") ? (diff1 < range[1]) && (diff1 = range[1]) : (diff1 < range[0]) && (diff1 = range[0]);
                    type === "row" && ((status === "delete") ? ((diff1 < range[2] && range[1] != colIdx) && (diff = range[2], diff1 = range[0])) : ((range[1] != colIdx) && (diff = range[2], diff1 = range[0])));
                    type === "column" && ((status === "delete") ? ((diff1 < range[3] && range[0] != rowIdx) && (diff = range[3], diff1 = range[1])) : ((range[0] != rowIdx) && (diff = range[3], diff1 = range[1])));
                }
                nAlpha = (type === "column") ? this._getAlphaRange(sheetIdx, range[0], diff1, range[2], diff) : this._getAlphaRange(sheetIdx, diff1, range[1], diff, range[3]);
                (rowIdx === range[0] && colIdx === range[1]) && (nAlpha = "#REF!", this._ref.push(pAlpha));
                if (this._isUndo && pAlpha === "#REF!")
                    nAlpha = this._ref.pop();
                val = val.replace(pAlpha, nAlpha);
                cellArgs = new ValueChangedArgs(rowIdx + 1, colIdx + 1, val);
                this._calcEngine.valueChanged(actSheet.sheetInfo.value, cellArgs);
                this.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { value: val } });
                this._applyFormula(sheetIdx, rowIdx, colIdx);
                !this._isUndo && ((pAlpha === nAlpha) ? this._formulaChanged.push("true") : this._formulaChanged.push("false"));
            }
        },

        _applyFormula: function (sheetIdx, rowIdx, colIdx) {
            var formulaColl, sheet = this.getSheet(sheetIdx), rowColl = sheet._formulaCollection[rowIdx];
            if (ej.isNullOrUndefined(rowColl))
                sheet._formulaCollection[rowIdx] = {};
            formulaColl = this._calcEngine.getFormulaInfoTable().values();
            sheet._formulaCollection[rowIdx][colIdx] = formulaColl[formulaColl.length - 1];
        },

        _clearFormula: function (i, j) {
            var formulaInfo, formulaIdx, formulaColl, sheetIdx = this.getActiveSheetIndex(), val = this.XLEdit.getPropertyValue(i, j, "value");
            if (this.isFormula(val)) {
                //clear formula for the particular cell
                formulaInfo = this.model.sheets[sheetIdx]._formulaCollection[i][j];
                formulaColl = this._calcEngine.getFormulaInfoTable().values();
                formulaIdx = formulaColl.indexOf(formulaInfo);
                formulaColl.splice(formulaIdx, 1);
                this._calcEngine.getFormulaInfoTable().clear();
                for (var k = 0, len = formulaColl.length; k < len; k++)
                    this._calcEngine.getFormulaInfoTable().add(formulaColl[k]);
                delete this.model.sheets[sheetIdx]._formulaCollection[i][j];
            }
        },

        _refreshValAndCF: function (i, j, vRule, cRule, rCount, cCount, action) {
            var cFormatRule, sheetIdx = this.getActiveSheetIndex(), container = this._dataContainer.sheets[sheetIdx], cFormatData = this._dataContainer.cFormatData, rule,
                oldRng, newRng, rngIndices, dupRuleIdx, dupRule;
            if (this.isUndefined(vRule) && this.isUndefined(cRule))
                delete container[i][j];
            else {
                if (!this.isUndefined(vRule))
                    container[i][j] = { rule: vRule };
                if (!this.isUndefined(cRule)) {
                    cFormatRule = cFormatData[cRule[0]];
                    if (cFormatRule.indexOf("true") > -1) {
                        dupRule = cFormatRule.replace("true", "false");
                        dupRuleIdx = cFormatData.indexOf();
                    }
                    else {
                        dupRule = cFormatRule.replace("false", "true");
                        dupRuleIdx = cFormatData.indexOf(dupRule);
                    }
                    oldRng = cFormatRule.split("_")[5];
                    rngIndices = this.getRangeIndices(oldRng);
                    if (action.indexOf("Bottom") > -1 || action.indexOf("Row") > -1)
                        rngIndices[2] = rngIndices[2] + rCount;
                    else
                        rngIndices[3] = rngIndices[3] + cCount;
                    newRng = this._getAlphaRange(sheetIdx, rngIndices[0], rngIndices[1], rngIndices[2],rngIndices[3])
                    cFormatRule = cFormatRule.replace(oldRng, newRng);
                    dupRule = dupRule.replace(oldRng, newRng);
                    cFormatData[cRule[0]] = cFormatRule;
                    cFormatData[dupRuleIdx] = dupRule;
                    rule = cFormatRule.replace("true", "false");
                    if (cFormatData.indexOf(rule) < 0)
                        cFormatData.push(rule);
                    container[i][j] = { cFormatRule: [cFormatData.indexOf(rule)] };
                }
            }
        },

        _refreshRows: function (sheetIdx) {
            var rowhdrrows = this._getRowHdrTBody(sheetIdx).find("tr"), contentrows = this._getContTBody(sheetIdx).find("tr");
            this.setRows([rowhdrrows, contentrows], sheetIdx);
        },

        _refreshFilterColl: function (sheetIdx, stIdx, count, operation, action) {
            var colDiff, i, j, sheet = this.getSheet(sheetIdx), filterColl = sheet._filterColl, fCollKeys = this.getObjectKeys(filterColl), fCollCKeys, filterVal, delIdx, addIdx;
            if (operation === "row") {
                if (action === "insert") {
                    for (var rIdx = fCollKeys.length - 1; rIdx >= 0; rIdx--) {
                        i = parseInt(fCollKeys[rIdx]);
                        if (i >= stIdx) {
                            sheet._filterColl[i + count] = $.extend(true, {}, sheet._filterColl[i]);
                            delete sheet._filterColl[i];
                        }
                    }
                }
                else {
                    for (var rIdx = 0; rIdx < fCollKeys.length; rIdx++) {
                        i = parseInt(fCollKeys[rIdx]);
                        if (i >= stIdx) {
                            sheet._filterColl[i - count] = $.extend(true, {}, sheet._filterColl[i]);
                            delete sheet._filterColl[i];
                        }
                    }
                }
            }
            else {
				var isInside, isSameTable = false, isVScroll = this.model.scrollSettings.allowVirtualScrolling;
                for (var rIdx = 0 ; rIdx < fCollKeys.length; rIdx++) {
                    i = parseInt(fCollKeys[rIdx]);
					fCollCKeys = this.getObjectKeys(sheet._filterColl[i]);
					if (action === "insert") {
						isInside = false;
                        for (var cIdx = fCollCKeys.length - 1; cIdx >= 0; cIdx--) {
							colDiff = fCollCKeys[cIdx] - fCollCKeys[cIdx - ((cIdx === 0) ? 0 : 1)];
							if(colDiff === 1 || colDiff === 0)
								isSameTable = true;
							else
								isSameTable = false;
                            j = parseInt(fCollCKeys[cIdx]);
							if (j >= stIdx || isInside) {
								isInside = true;
                                filterVal = sheet._filterColl[i][j];
                                if (filterVal.status.indexOf("filtered") > -1) {
                                    delIdx = $.inArray(this._generateHeaderText(j + 1), sheet._filteredColumns);
                                    if (delIdx > -1)
                                        sheet._filteredColumns.splice(delIdx, 1);
                                    addIdx = $.inArray(this._generateHeaderText(j + count + 1), sheet._filteredColumns);
                                    if (addIdx < 0)
                                        sheet._filteredColumns.push(this._generateHeaderText(j + count + 1));
                                }
                                sheet._filterColl[i][j + count] = $.extend(true, {}, sheet._filterColl[i][j]);
                                if(!isVScroll && !this._isUndoRedo) 
									delete sheet._filterColl[i][j];
								else {
									if(isSameTable) {
										sheet._filterColl[i][j].status = "e-ssfilter";
										this.XLEdit._updateDataContainer({ rowIndex: i, colIndex: j }, { dataObj: { isFilterHeader: true, filterState: "filter", isFilterVisible: true }, sheetIdx: sheetIdx })
									}
									else
										delete sheet._filterColl[i][j];
								}
								if(!isSameTable)
									isInside = false;
                            }
                        }
                    }
                    else {
                        for (var cIdx = 0; cIdx < fCollCKeys.length; cIdx++) {
                            j = parseInt(fCollCKeys[cIdx]);
                            if (j >= stIdx) {
                                filterVal = sheet._filterColl[i][j];
                                if (filterVal.status.indexOf("filtered") > -1) {
                                    delIdx = $.inArray(this._generateHeaderText(j + 1), sheet._filteredColumns);
                                    if (delIdx > -1)
                                        sheet._filteredColumns.splice(delIdx, 1);
                                    addIdx = $.inArray(this._generateHeaderText(j - count + 1), sheet._filteredColumns);
                                    if (addIdx < 0)
                                        sheet._filteredColumns.push(this._generateHeaderText(j - count + 1));
                                }
                                (j - count >= 0) && (sheet._filterColl[i][j - count] = $.extend(true, {}, sheet._filterColl[i][j]));
                                delete sheet._filterColl[i][j];
                            }
                        }
                    }
                }
            }
        },

        _refreshDataContainer: function (sIdx, value) {
            var stRow, enRow, stCol, enCol, vRule, cRule, i, j, k, len, ln, currText, remText, maxCol = 0, lt = 0, nContainer, maxRow, freezeRow, freezeCol, topIdx, leftIdx, hiddenHgt = 0, hiddenWth = 0, container = this._dataContainer.sheets[sIdx], cCount, rCount, sCol, remCells, rmColl, columns, count, picture, chart, index,
                isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, sheet = this.getSheet(sIdx), usedRange = sheet.usedRange, fRowIdx = this.getFrozenRows(), fColIdx = this.getFrozenColumns() , currCell, remCell, currTxt, remTxt;
            maxRow = parseInt(this.getObjectKeys(container)[this.getObjectLength(container) - 1]), rowHtColl = sheet.rowsHeightCollection, colWtColl = sheet.columnsWidthCollection;
            for (i = 0; i <= maxRow; i++) {
                if (!ej.isNullOrUndefined(container[i])) {
                    nContainer = this.getObjectKeys(container[i]);
                    lt = parseInt(nContainer[nContainer.length - 1]);
                    (lt > maxCol) && (maxCol = lt);
                }
            }
            sCol = (value.startCol <= maxCol) ? value.colCount + value.startCol : maxCol - 1;
            cCount = (value.status.indexOf("shift") > -1) ? sCol : maxCol - 1;
            rCount = (value.status.indexOf("shift") > -1) ? value.rowCount + value.startRow : maxRow;
            stRow = value.startRow; enRow = (value.startRow + value.rowCount) - 1;
            stCol = value.startCol; enCol = (value.startCol + value.colCount) - 1;
            if (this._isFrozen(fRowIdx - 1) && fRowIdx > stRow) {
                for (i = sheet._frozenRows - 1; i < sheet._ftopRowIdx; i++)
                    hiddenHgt += sheet.rowsHeightCollection[i];
                this._scrollContent({ y: -hiddenHgt });
            }
            if (this._isFrozen(fColIdx - 1) && fColIdx > stCol) {
                for (i = sheet._frozenColumns - 1; i < sheet._fleftColIdx; i++)
                    hiddenWth += sheet.columnsWidthCollection[i];
                this._scrollContent({ x: -hiddenWth });
            }
            switch (value.status) {
                case "insertRow":
                    for (i = maxRow, len = value.startRow; i >= len; i--) {
                        if (!ej.isNullOrUndefined(container[i])) {
                            container[i + value.rowCount] = $.extend(true, {}, container[i]);
                            if (!ej.isNullOrUndefined(container[i + value.rowCount])) {
                                columns = this.getObjectKeys(container[i + value.rowCount]);
                                for (j = 0, ln = columns.length; j < ln; j++) {
                                    this._clearFormula(i, columns[j]);
                                    //refresh Validation
                                    if (this._checkIndicesInContainer(sIdx, i, columns[j], "wrap")) {
                                        this._wrapCollection(i + value.rowCount, columns[j], sheet._wrapColl[i][columns[j]], sIdx);
                                        delete sheet._wrapColl[i][columns[j]];
                                    }
                                    if (i >= stRow && i <= enRow) {
                                        vRule = this._checkIndicesInContainer(sIdx, stRow, columns[j], "rule") ? (this._dataContainer.sheets[sIdx][stRow][columns[j]]["rule"]) : undefined;
                                        cRule = this._checkIndicesInContainer(sIdx, stRow, columns[j], "cFormatRule") ? (this._dataContainer.sheets[sIdx][stRow][columns[j]]["cFormatRule"]) : undefined;
                                        this._refreshValAndCF(i, columns[j], vRule, cRule, value.rowCount, 0, value.status);
                                        if (!isVirtualScroll)
                                            !(stRow < 1) && this.addClass(this.getCell(i, columns[j])[0], this.XLFormat.getFormatClass(this.getCell(stRow - 1, columns[j])[0].className, false));
                                    }
                                    else
                                        delete container[i][columns[j]];
                                    this._refreshFormula(i + value.rowCount, parseInt(columns[j]), value.rowCount, "insert", "row", value.startRow, false);
                                    this.XLEdit._refreshCalcEngine(i + value.rowCount, parseInt(columns[j]));
                                }
                            }
                            (this.getObjectLength(container[i]) < 1) && delete container[i];
                        }
                        rowHtColl[i + value.rowCount] = rowHtColl[i];
                        rowHtColl[i] = this.model.rowHeight;
                        sheet._rowIdxColl[i + value.rowCount] = sheet._rowIdxColl[i] + value.rowCount;
                    }
                    this._refreshHideRowColCollection(sheet.hideRowsCollection, value.startRow, value.rowCount, "row", "insert")
                    this._refreshFilterColl(sIdx, value.startRow, value.rowCount, "row", "insert");
                    if (this._isUndo && this._delCells.length > 0) {
                        remCells = this._delCells;
                        count = remCells[remCells.length - 1].row - remCells[0].row;
                        for (i = 0, len = remCells.length; i < len; i++) {
                            container[remCells[i].row] = remCells[i].value;
                            columns = this.getObjectKeys(container[remCells[i].row]);
                            for (j = 0, ln = columns.length; j < ln; j++) {
                                this._refreshFormula(remCells[i].row, parseInt(columns[j]), count, "insert", "row", "", false);
                                this.XLEdit._refreshCalcEngine(remCells[i].row, parseInt(columns[j]));
                                if (this._checkIndicesInContainer(sIdx, remCells[i].row, columns[j], "wrap"))
                                    this._wrapCollection(remCells[i].row, columns[j], this._delWrapColl[remCells[i].row][columns[j]], sIdx);
                            }
                            rowHtColl[remCells[i].row] = remCells[i].height;
                        }
                        this._delWrapColl = {};
                    }
                    if (this.model.allowFreezing && this._isFrozen(fRowIdx) && (stRow < fRowIdx || (this._isUndo && this._fRow.fRowCnt > 0))) {
                        freezeRow = sheet.frozenRows + ((this._fRow.fRowCnt > 0) ? this._fRow.fRowCnt : value.rowCount);
                        freezeCol = sheet.frozenColumns;
                        this._fRow.fRowCnt = 0;
                        if (!this._fRow.rowAdj) {
                            freezeRow -= 1;
                            this._fRow.rowAdj = !this._fRow.rowAdj;
                        }
                        if (this._isFrozen(fColIdx)) {
                            this.XLFreeze.unfreezePanes();
                            this.XLFreeze.freezePanes(freezeRow, freezeCol);
                        }
                        else
                            this.XLFreeze.freezeRows(freezeRow);
                    }
                    this.XLScroll._getRowHeights(sIdx, value.startRow);
                    break;
                case "insertColumn":
                    var isDeletCol = false;
                    for (i = 0 ; i <= rCount; i++) {
                        for (j = maxCol, len = value.startCol; j >= len ; j--) {
                            picture = chart = null;
                            if (i == 0) {
                                if (!ej.isNullOrUndefined(container[0])) {
                                    if (!ej.isNullOrUndefined(container[0][j])) {
                                        if ("isCHide" in container[0][j]) {
                                            this._deleteRule(j, sIdx);
                                            isDeletCol = true;
                                        }
                                    }
                                }
                            }
                            if (!ej.isNullOrUndefined(container[i])) {
                                if (!ej.isNullOrUndefined(container[i][j])) {
                                    if (!ej.isNullOrUndefined(container[i][j + value.colCount])) {
                                        if (!ej.isNullOrUndefined(container[i][j + value.colCount].picture))
                                            picture = container[i][j + value.colCount].picture;
                                        if (!ej.isNullOrUndefined(container[i][j + value.colCount].chart))
                                            chart = container[i][j + value.colCount].chart;
                                    }
                                    container[i][j + value.colCount] = container[i][j];
                                    if (!ej.isNullOrUndefined(container[i][j].picture) || !ej.isNullOrUndefined(container[i][j].chart)) {
                                        if (!ej.isNullOrUndefined(container[i][j].picture))
                                            picture = container[i][j].picture;
                                        if (!ej.isNullOrUndefined(container[i][j].chart))
                                            chart = container[i][j].chart;
                                    }
                                    if (!ej.isNullOrUndefined(container[i][j + value.colCount])) {
                                        if (!ej.isNullOrUndefined(picture))
                                            container[i][j + value.colCount].picture = picture;
                                        if (!ej.isNullOrUndefined(chart))
                                            container[i][j + value.colCount].chart = chart;
                                    }
                                    if (container[i][j].wrap) {
                                        this._wrapCollection(i, j + value.colCount, sheet._wrapColl[i][j], sIdx);
                                        delete sheet._wrapColl[i][j];
                                    }
                                }
                                this._clearFormula(i, j);
                                //refresh Validation
                                if (j >= stCol && j <= enCol) {
                                    vRule = this._checkIndicesInContainer(sIdx, i, stCol, "rule") ? (this._dataContainer.sheets[sIdx][i][stCol]["rule"]) : undefined;
                                    cRule = this._checkIndicesInContainer(sIdx, i, stCol, "cFormatRule") ? (this._dataContainer.sheets[sIdx][i][stCol]["cFormatRule"]) : undefined;
                                    this._refreshValAndCF(i, j, vRule, cRule, 0, value.colCount, value.status);
                                    if (!isVirtualScroll)
                                        (!stCol < 1) && this.addClass(this.getCell(i, j)[0], this.XLFormat.getFormatClass(this.getCell(i, stCol - 1)[0].className, false));
                                }
                                else
                                    delete container[i][j];
                                if (ej.isNullOrUndefined(container[i][j]) && (!ej.isNullOrUndefined(picture) || !ej.isNullOrUndefined(chart)))
                                    container[i][j] = {};
                                if (!ej.isNullOrUndefined(picture))
                                    container[i][j].picture = picture;
                                if (!ej.isNullOrUndefined(chart))
                                    container[i][j].chart = chart;
                                this._refreshFormula(i, j + value.colCount, value.colCount, "insert", "column", value.startCol, false);
                                this.XLEdit._refreshCalcEngine(i, j + value.colCount);
                            }
                            if (i === 0) {
                                if (isDeletCol) {
                                    this._writeRule(j + value.colCount, sIdx);
                                    isDeletCol = false;
                                }
                                if (isVirtualScroll && !this._isUndoRedo) {
                                    colWtColl[j + value.colCount] = colWtColl[j];
                                    colWtColl[j] = sheet.columnWidth;
                                }
                            }
                        }
                    }
                    this._refreshHideRowColCollection(sheet.hideColsCollection, value.startCol, value.colCount, "column", "insert")
                    this._refreshFilterColl(sIdx, value.startCol, value.colCount, "column", "insert");
                    if (this.model.allowFreezing && this._isFrozen(fColIdx) && (stCol < fColIdx || (this._isUndo && this._fCol.fColCnt > 0))) {
                        freezeRow = sheet.frozenRows;
                        freezeCol = sheet.frozenColumns + (this._fCol.fColCnt > 0 ? this._fCol.fColCnt : value.colCount);
                        this._fCol.fColCnt = 0;
                        if (!this._fCol.colAdj) {
                            freezeCol -= 1;
                            this._fCol.colAdj = !this._fCol.colAdj;
                        }
                        if (this._isFrozen(fRowIdx)) {
                            this.XLFreeze.unfreezePanes();
                            this.XLFreeze.freezePanes(freezeRow, freezeCol);
                        }
                        else
                            this.XLFreeze.freezeColumns(freezeCol);
                    }
                    if (this._isUndo && this._delCells.length > 0) {
                        remCells = this._delCells;
                        count = remCells[remCells.length - 1].col - remCells[0].col;
                        for (k = 0, len = remCells.length; k < len; k++) {
                            if (ej.isNullOrUndefined(container[remCells[k].row]))
                                container[remCells[k].row] = {};
                            container[remCells[k].row][remCells[k].col] = remCells[k].value;
                            this._refreshFormula(remCells[k].row, remCells[k].col, count, "insert", "column", "", false);
                            this.XLEdit._refreshCalcEngine(remCells[k].row, remCells[k].col);
                            if (remCells[k].value.wrap)
                                this._wrapCollection(remCells[k].row, remCells[k].col, remCells[k].height, sIdx);
                        }
                    }
                    break;
                case "deleteRow":
                    this._delCells = [];
                    rmColl = [];
                    for (i = value.startRow; i <= maxRow; i++) {
                        if (i < (value.startRow + value.rowCount)) {
                            this._delCells.push({ row: i, value: $.extend(true, {}, container[i]), height: rowHtColl[i] });
                            if (!ej.isNullOrUndefined(container[i])) {
                                columns = this.getObjectKeys(container[i]);
                                for (j = 0, len = columns.length; j < len; j++) {
                                    this._clearFormula(i, columns[j]);
                                    if (this._checkIndicesInContainer(sIdx, i, columns[j], "wrap")) {
                                        if (!this._delWrapColl[i])
                                            this._delWrapColl[i] = {};
                                        this._delWrapColl[i][columns[j]] = $.extend(true, {}, sheet._wrapColl[i][columns[j]]);
                                        delete sheet._wrapColl[i][columns[j]];
                                    }
                                    container[i][columns[j]] = {};
                                }
                            }
                            container[i] = {};
                            rmColl.push({ row: i });
                        }
                        if (!ej.isNullOrUndefined(container[i + value.rowCount])) {
                            container[i] = $.extend(true, {}, container[i + value.rowCount]);
                            columns = this.getObjectKeys(container[i]);
                            for (j = 0, len = columns.length; j < len; j++) {
                                if (this._checkIndicesInContainer(sIdx, i + value.rowCount, columns[j], "wrap")) {
                                    this._wrapCollection(i, columns[j], sheet._wrapColl[i + value.rowCount][columns[j]], sIdx);
                                    delete sheet._wrapColl[i + value.rowCount][columns[j]];
                                }
                                this._clearFormula(i + value.rowCount, columns[j]);
                                container[i + value.rowCount][columns[j]] = {};
                                this._refreshFormula(i, parseInt(columns[j]), value.rowCount, "delete", "row", value.startRow, false);
                            }
                            container[i + value.rowCount] = {};
                            rmColl.push({ row: i + value.rowCount });
                        }
                        if (!this.isUndefined(rowHtColl[i + value.rowCount])) {
                            rowHtColl[i] = rowHtColl[i + value.rowCount];
                            rowHtColl[i + value.rowCount] = this.model.rowHeight;
                            sheet._rowIdxColl[i] = sheet._rowIdxColl[i + value.rowCount] - value.rowCount;
                        }
                    }
                    if (this.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal) {
                        rowHtColl.splice(rowHtColl.length - value.rowCount, value.rowCount);
                        sheet._rowHeightCollection.splice(sheet._rowHeightCollection.length - value.rowCount, value.rowCount);
                    }
                    this._refreshHideRowColCollection(sheet.hideRowsCollection, value.startRow, value.rowCount, "row", "delete")
                    for (k = 0, len = rmColl.length; k < len; k++) {
                        if (this.getObjectLength(container[rmColl[k].row]) === 0) {
                            this._clearFormula(rmColl[k].row, rmColl[k].col);
                            delete container[rmColl[k].row];
                        }
                    }
                    this._refreshFilterColl(sIdx, value.startRow, value.rowCount, "row", "delete");
                    this.XLScroll._getRowHeights(sIdx, value.startRow);
                    if (this.model.allowFreezing && this._isFrozen(fRowIdx) && stRow < fRowIdx ) {
                        if (enRow >= fRowIdx )
                            for (var i = stRow; i < fRowIdx ; i++)
                                this._fRow.fRowCnt++;
                        else
                            this._fRow.fRowCnt = 0;
                        freezeRow = sheet.frozenRows - ((this._fRow.fRowCnt > 0) ? this._fRow.fRowCnt : value.rowCount);
                        topIdx = sheet.frozenRows - ((this._fRow.fRowCnt > 0) ? this._fRow.fRowCnt : value.rowCount) - sheet._topRow.idx;
                        freezeCol = sheet.frozenColumns;
                        this._fRow.rowAdj = topIdx > 1;
                        if (this._isFrozen(fColIdx )) {
                            this.XLFreeze.unfreezePanes();
                            this.XLFreeze.freezePanes(this._fRow.rowAdj ? freezeRow : freezeRow + 1, freezeCol);
                        }
                        else
                            this.XLFreeze.freezeRows(this._fRow.rowAdj ? freezeRow : 1);
                    }
                    break;
                case "deleteColumn":
                    this._delCells = [];
                    rmColl = [];
                    var isDeleteCol = false, dupContainer = $.extend(true, {}, container[0]);
                    for (i = 0 ; i <= rCount; i++) {
                        for (j = value.startCol; j <= maxCol; j++) {
                            picture = chart = null;
                            if (i == 0) {
                                if (!ej.isNullOrUndefined(dupContainer)) {
                                    if (!ej.isNullOrUndefined(dupContainer[j])) {
                                        if ("isCHide" in dupContainer[j]) {
                                            this._deleteRule(j, sIdx);
                                            isDeleteCol = true;
                                        }
                                    }
                                }
                            }
                            if (j < (value.startCol + value.colCount)) {
                                if (!ej.isNullOrUndefined(container[i])) {
                                    if (!ej.isNullOrUndefined(container[i][j])) {
                                        this._delCells.push({ row: i, col: j, value: $.extend(true, {}, container[i][j], container[i][j].wrap ? sheet._wrapColl[i][j] : rowHtColl[i]) });
                                        this._clearFormula(i, j);
                                        container[i][j] = {};
                                        if (!ej.isNullOrUndefined(this._delCells[this._delCells.length - 1])) {
                                            index = this._delCells.length - 1;
                                            if (!ej.isNullOrUndefined(this._delCells[index].value.picture))
                                                container[i][j].picture = this._delCells[index].value.picture;
                                            if (!ej.isNullOrUndefined(this._delCells[index].value.chart))
                                                container[i][j].chart = this._delCells[index].value.chart;
                                        }
                                        rmColl.push({ row: i, col: j });
                                        if (sheet._wrapColl[i])
                                            delete sheet._wrapColl[i][j];
                                    }
                                }
                            }
                            if (!ej.isNullOrUndefined(container[i]) && (!ej.isNullOrUndefined(container[i][j + value.colCount]))) {
                                container[i][j] = $.extend(true, {}, container[i][j + value.colCount]);
                                if (container[i][j + value.colCount].wrap) {
                                    this._wrapCollection(i, j, sheet._wrapColl[i][j + value.colCount], sIdx);
                                    delete sheet._wrapColl[i][j + value.colCount];
                                }
                                if (!ej.isNullOrUndefined(container[i][j + value.colCount].picture))
                                    picture = container[i][j + value.colCount].picture;
                                if (!ej.isNullOrUndefined(container[i][j + value.colCount].chart))
                                    chart = container[i][j + value.colCount].chart;
                                this._clearFormula(i, j + value.colCount);
                                container[i][j + value.colCount] = {};
                                if (!ej.isNullOrUndefined(picture))
                                    container[i][j + value.colCount].picture = picture;
                                if (!ej.isNullOrUndefined(chart))
                                    container[i][j + value.colCount].chart = chart
                                if (!ej.isNullOrUndefined(this._delCells[this._delCells.length - 1])) {
                                    index = this._delCells.length - 1;
                                    if (!ej.isNullOrUndefined(this._delCells[index].value.picture))
                                        container[i][j].picture = this._delCells[index].value.picture;
                                    if (!ej.isNullOrUndefined(this._delCells[index].value.chart))
                                        container[i][j].chart = this._delCells[index].value.chart;
                                }
                                rmColl.push({ row: i, col: j + value.colCount });
                                this._refreshFormula(i, j, value.colCount, "delete", "column", value.startCol, false);
                                if (!isVirtualScroll)
                                    if(this.XLComment) {
										if(this._isRowViewable(sIdx, i))
											this._removeClass(this.getCell(i, j), "e-commentcell");
										this.XLComment._updateCmntFrmCntnr(i, j);
									}
                            }
                            if (i == 0) {
                                if (isDeleteCol) {
                                    this._writeRule(j - value.colCount, sIdx);
                                    isDeleteCol = false;
                                }
                            }
                        }
                        for (k = 0, len = rmColl.length; k < len; k++)
                            if (this.getObjectLength(container[rmColl[k].row][rmColl[k].col]) === 0) {
                                this._clearFormula(rmColl[k].row, rmColl[k].col);
                                delete container[rmColl[k].row][rmColl[k].col];
                            }
                        rmColl = [];
                    }
                    this._refreshHideRowColCollection(sheet.hideColsCollection, value.startCol, value.colCount, "column", "delete")
                    if (this.model.allowFreezing && this._isFrozen(fColIdx) && stCol < fColIdx) {
                        if (enCol >= fColIdx )
                            for (var i = stCol; i < fColIdx ; i++)
                                this._fCol.fColCnt++;
                        else
                            this._fCol.fColCnt = 0;
                        freezeRow = sheet.frozenRows;
                        freezeCol = sheet.frozenColumns - (this._fCol.fColCnt > 0 ? this._fCol.fColCnt : value.colCount);
                        leftIdx = sheet.frozenColumns - (this._fCol.fColCnt > 0 ? this._fCol.fColCnt : value.colCount) - sheet._leftCol.idx;
                        this._fCol.colAdj = leftIdx > 1;
                        if (this._isFrozen(fRowIdx )) {
                            this.XLFreeze.unfreezePanes();
                            this.XLFreeze.freezePanes(freezeRow, this._fCol.colAdj ? freezeCol : freezeCol + 1);
                        }
                        else
                            this.XLFreeze.freezeColumns(this._fCol.colAdj ? freezeCol : 1);
                    }
                    this._refreshFilterColl(sIdx, value.startCol, value.colCount, "column", "delete");
                    break;
                case "shiftRight":
                    var cValue;
                    for (i = value.startRow ; i < rCount; i++) {
                        for (j = maxCol, len = value.startCol; j >= len ; j--) {
                            if (!ej.isNullOrUndefined(container[i])) {
                                if (!ej.isNullOrUndefined(container[i][j])) {
                                    container[i][j + value.colCount] = $.extend(true, {}, container[i][j]);
                                    if (container[i][j].wrap) {
                                        this._wrapCollection(i, j + value.colCount, sheet._wrapColl[i][j], sIdx);
                                        delete sheet._wrapColl[i][j];
                                    }
                                    this._clearFormula(i, j);
                                    //refresh Validation
                                    if (j >= stCol && j <= enCol) {
                                        this._checkIndicesInContainer(sIdx, i, stCol, "rule") && (vRule = this._dataContainer.sheets[sIdx][i][stCol]["rule"]);
                                        this._checkIndicesInContainer(sIdx, i, stCol, "cFormatRule") && (cRule = this._dataContainer.sheets[sIdx][i][stCol]["cFormatRule"]);
                                        this._refreshValAndCF(i, j, vRule, cRule, 0, value.colCount, value.status);
                                        !(stCol < 1) && this.addClass(this.getCell(i, j)[0], this.XLFormat.getFormatClass(this.getCell(i, stCol - 1)[0].className, false));
                                    }
                                    else
                                        delete container[i][j];
                                    this._refreshFormula(i, j + value.colCount, value.colCount, "insert", "column", value.startCol, true);
                                    this.XLEdit._refreshCalcEngine(i, j + value.colCount);
                                    this.XLEdit._refreshCalcEngine(i, j);
                                }
                            }
                        }
                    }
                    if (this._isUndo && this._delCells.length > 0) {
                        remCells = this._delCells;
                        count = remCells[remCells.length - 1].col - remCells[0].col;
                        for (k = 0, len = remCells.length; k < len; k++) {
                            container[remCells[k].row][remCells[k].col] = remCells[k].value;
                            this._refreshFormula(remCells[k].row, remCells[k].col, count, "insert", "column", value.startRow, false);
                            this.XLEdit._refreshCalcEngine(remCells[k].row, remCells[k].col);
                            if (!isVirtualScroll)
                                this.XLComment && this.XLComment._updateCmntFrmCntnr(remCells[k].row, remCells[k].col);
                            if (remCells[k].value.wrap)
                                this._wrapCollection(remCells[k].row, remCells[k].col, remCells[k].height, sIdx);
                        }
                    }
                    break;
                case "shiftLeft":
                    this._delCells = [];
                    rmColl = [];
                    for (i = value.startRow ; i < rCount; i++) {
                        for (j = value.startCol; j <= maxCol; j++) {
                            if (j < (value.startCol + value.colCount) && !ej.isNullOrUndefined(container[i])) {
                                if (!ej.isNullOrUndefined(container[i][j])) {
                                    this._delCells.push({ row: i, col: j, value: $.extend(true, {}, container[i][j]), height: container[i][j].wrap ? sheet._wrapColl[i][j] : rowHtColl[i] });
                                    this._clearFormula(i, j);
                                    if (container[i][j].wrap)
                                        delete sheet._wrapColl[i][j];
                                    container[i][j] = {};
                                    rmColl.push({ row: i, col: j });
                                }
                            }
                            if (!ej.isNullOrUndefined(container[i]))
                                if (!ej.isNullOrUndefined(container[i][j + value.colCount])) {
                                    container[i][j] = $.extend(true, {}, container[i][j + value.colCount]);
                                    if (container[i][j + value.colCount].wrap) {
                                        this._wrapCollection(i, j, sheet._wrapColl[i][j + value.colCount], sIdx);
                                        delete sheet._wrapColl[i][j + value.colCount];
                                    }
                                    currCell = this.getCell(i + value.rowCount, j);
                                    remCell = this.getCell(i, j);
                                    if (currCell) {
                                        currText = currCell[0].outerHTML;
                                        this.clearTextNode(currCell);
                                    }
                                    if (remCell) {
                                        remText = remCell[0].outerHTML;
                                        this.clearTextNode(remCell, this.XLEdit.getPropertyValue(i, j, "value2"));
                                    }
                                    rmColl.push({ row: i, col: j + value.colCount });
                                    this._clearFormula(i, j + value.colCount);
                                    container[i][j + value.colCount] = {};
                                    this._refreshFormula(i, j, value.colCount, "delete", "column", value.startCol, true);
                                    currCell && (currCell[0].outerHTML = currText);
                                    remCell && (remCell[0].outerHTML = remText);
                                }
                            this.XLEdit._refreshCalcEngine(i, j);
                        }
                        for (k = 0, len = rmColl.length; k < len; k++) {
                            if (this.getObjectLength(container[rmColl[k].row][rmColl[k].col]) === 0) {
                                this._clearFormula(rmColl[k].row, rmColl[k].col);
                                this.XLEdit._refreshCalcEngine(rmColl[k].row, rmColl[k].col);
                                delete container[rmColl[k].row][rmColl[k].col];
                            }
                        }
                        rmColl = [];
                    }
                    break;
                case "shiftBottom":
                    var isWrapRow, colWtColl = this.getSheet(sIdx).columnsWidthCollection, rowHtColl = this.getSheet(sIdx).rowsHeightCollection, rowHt;
                    for (i = maxRow, len = value.startRow; i >= len; i--) {
                        isWrapRow = this._checkIndicesInContainer(sIdx, i, 0, "wrapRow");
                        for (j = value.startCol; j < cCount; j++) {
                            if (!ej.isNullOrUndefined(container[i])) {
                                if (!ej.isNullOrUndefined(container[i][j])) {
                                    if (ej.isNullOrUndefined(container[i + value.rowCount]))
                                        container[i + value.rowCount] = {};
                                    if (isWrapRow) {
                                        rowHt = sheet._wrapColl[i][j];
                                        rowHtColl[i + value.rowCount] = ej.max([rowHt, rowHtColl[i + value.rowCount]]);
                                        if (!this._checkIndicesInContainer(sIdx, i + value.rowCount, 0, "wrapRow"))
                                            this.XLEdit._updateDataContainer({ rowIndex: i + value.rowCount, colIndex: 0 }, { dataObj: { wrapRow: true } });
                                        this._wrapCollection(i + value.rowCount, j, rowHt, sIdx);
                                    }
                                    container[i + value.rowCount][j] = $.extend(true, {}, container[i][j]);
                                    this._clearFormula(i, j);
                                    //refresh Validation
                                    if (i >= stRow && i <= enRow) {
                                        this._checkIndicesInContainer(sIdx, stRow, j, "rule") && (vRule = this._dataContainer.sheets[sIdx][stRow][j]["rule"]);
                                        this._checkIndicesInContainer(sIdx, stRow, j, "cFormatRule") && (cRule = this._dataContainer.sheets[sIdx][stRow][j]["cFormatRule"]);
                                        this._refreshValAndCF(i, j, vRule, cRule, value.rowCount, 0, value.status);
                                        if (!isVirtualScroll)
                                            !(stRow < 1) && this.addClass(this.getCell(i, j)[0], this.XLFormat.getFormatClass(this.getCell(stRow - 1, j)[0].className, false));
                                    }
                                    else
                                        delete container[i][j];
                                    isWrapRow && delete sheet._wrapColl[i][j];
                                    this._refreshFormula(i + value.rowCount, j, value.rowCount, "insert", "row", value.startRow, true);
                                }
                            }
                            this.XLEdit._refreshCalcEngine(i, j);
                            this.XLEdit._refreshCalcEngine(i + value.rowCount, j);
                        }
                        if (isWrapRow) {
                            rowHtColl[i] = ej.max(this._getObjectValues(sheet._wrapColl[i])); //this.XLResize._getContentHeight(i, sIdx, true);
                            !rowHtColl[i] && (rowHtColl[i] = this.model.rowHeight);
                            //check and remove wrapRow value
                            if (!this.getObjectLength(sheet._wrapColl[i]))
                                delete this._dataContainer.sheets[sIdx][i][0]["wrapRow"];
                        }
                        if (!ej.isNullOrUndefined(container[i]))
                            (this.getObjectLength(container[i]) === 0) && delete container[i];
                    }
                    if (this._isUndo && this._delCells.length > 0) {
                        var rRowIdx, rColIdx, isWrapCell;
                        remCells = this._delCells;
                        count = remCells[remCells.length - 1].row - remCells[0].row;
                        for (i = 0, len = remCells.length; i < len; i++) {
                            rRowIdx = remCells[i].row;
                            rColIdx = remCells[i].col;
                            if (ej.isNullOrUndefined(container[rRowIdx]))
                                container[rRowIdx] = {};
                            container[rRowIdx][rColIdx] = remCells[i].value;
                            this._refreshFormula(rRowIdx, rColIdx, count, "insert", "row", value.startRow, true);
                            this.XLEdit._refreshCalcEngine(rRowIdx, rColIdx);
                            isWrapRow = this._checkIndicesInContainer(sIdx, rRowIdx, 0, "wrapRow");
                            isWrapCell = remCells[i].value.wrap;
                            if (isWrapRow || isWrapCell) {
                                rowHt = isWrapCell ? remCells[i].height : this.model.rowHeight; //this._detailsFromGlobalSpan(rRowIdx, rColIdx, "height", this.XLEdit.getPropertyValue(rRowIdx, rColIdx, "value2"), colWtColl[rColIdx]);
                                rowHtColl[rRowIdx] = ej.max([rowHt, rowHtColl[rRowIdx]]);
                                if (!this._checkIndicesInContainer(sIdx, rRowIdx, 0, "wrapRow"))
                                    this.XLEdit._updateDataContainer({ rowIndex: rRowIdx, colIndex: 0 }, { dataObj: { wrapRow: true } });
                                this._wrapCollection(rRowIdx, rColIdx, rowHt, sIdx);
                            }
                            if (!isVirtualScroll)
                                this.XLComment && this.XLComment._updateCmntFrmCntnr(rRowIdx, rColIdx);
                        }
                    }
                    break;
                case "shiftUp":
                    rmColl = [];
                    var currCell, isDelWrapRow, isWrapRow, colWtColl = this.getSheet(sIdx).columnsWidthCollection, rowHtColl = this.getSheet(sIdx).rowsHeightCollection, rowHt;
                    for (i = value.startRow; i <= maxRow; i++) {
                        isDelWrapRow = this._checkIndicesInContainer(sIdx, i, 0, "wrapRow");
                        isWrapRow = this._checkIndicesInContainer(sIdx, i + value.rowCount, 0, "wrapRow");
                        for (j = value.startCol; j < cCount; j++) {
                            if (i < (value.startRow + value.rowCount) && !ej.isNullOrUndefined(container[i]))
                                if (!ej.isNullOrUndefined(container[i][j])) {
                                    this._delCells.push({ row: i, col: j, value: $.extend(true, {}, container[i][j]), height: isDelWrapRow ? sheet._wrapColl[i][j] : rowHtColl[i] });
                                    this._clearFormula(i, j);
                                    container[i][j] = {};
                                    rmColl.push({ row: i, col: j });
                                    if (isDelWrapRow)
                                        delete sheet._wrapColl[i][j];
                                }
                            if (!ej.isNullOrUndefined(container[i + value.rowCount])) {
                                if (!ej.isNullOrUndefined(container[i + value.rowCount][j])) {
                                    if (ej.isNullOrUndefined(container[i]))
                                        container[i] = {};
                                    container[i][j] = $.extend(true, {}, container[i + value.rowCount][j]);
                                    if (isWrapRow) {
                                        this._wrapCollection(i, j, sheet._wrapColl[i + value.rowCount][j], sIdx);
                                        delete sheet._wrapColl[i + value.rowCount][j];
                                    }
                                    currCell = this.getCell(i + value.rowCount, j);
                                    remCell = this.getCell(i, j);
                                    if (currCell) {
                                        currText = currCell[0].outerHTML;
                                        this.clearTextNode(currCell);
                                    }
                                    if (remCell) {
                                        remText = remCell[0].outerHTML;
                                        this.clearTextNode(remCell, this.XLEdit.getPropertyValue(i, j, "value2"));
                                    }
                                    this._clearFormula(i + value.rowCount, j);
                                    container[i + value.rowCount][j] = {};
                                    rmColl.push({ row: i + value.rowCount, col: j });
                                    this._refreshFormula(i, j, value.rowCount, "delete", "row", value.startRow, true);
                                    currCell && (currCell[0].outerHTML = currText);
                                    remCell && (remCell[0].outerHTML = remText);
                                }
                            }
                            else
                                rowHtColl[i + value.rowCount] = this.model.rowHeight;
                            this.XLEdit._refreshCalcEngine(i, j);
                        }
                        if (isDelWrapRow) {
                            if (this.getObjectLength(sheet._wrapColl[i]) < 1)
                                delete this._dataContainer.sheets[sIdx][i][0]["wrapRow"];
                        }
                        if (isWrapRow) {
                            this.XLEdit._updateDataContainer({ rowIndex: i, colIndex: 0 }, { dataObj: { wrapRow: true } });
                            rowHtColl[i + value.rowCount] = ej.max(this._getObjectValues(sheet._wrapColl[i + value.rowCount]));
                            !rowHtColl[i + value.rowCount] && (rowHtColl[i + value.rowCount] = this.model.rowHeight);
                            if (!this.getObjectLength(sheet._wrapColl[i + value.rowCount]))
                                delete this._dataContainer.sheets[sIdx][i + value.rowCount][0]["wrapRow"];
                        }
                        if (isDelWrapRow || isWrapRow) {
                            rowHtColl[i] = ej.max(this._getObjectValues(sheet._wrapColl[i]));
                            !rowHtColl[i] && (rowHtColl[i] = this.model.rowHeight);
                        }
                    }
                    for (k = 0, len = rmColl.length; k < len; k++) {
                        if (this.getObjectLength(container[rmColl[k].row][rmColl[k].col]) === 0) {
                            this._clearFormula(rmColl[k].row, rmColl[k].col);
                            delete container[rmColl[k].row][rmColl[k].col];
                        }
                        (this.getObjectLength(container[rmColl[k].row]) === 0) && delete container[rmColl[k].row];
                    }
                    break;
            }
            if (value.status.indexOf("insert") > -1) {
                usedRange.rowIndex = usedRange.rowIndex + value.rowCount;
                usedRange.colIndex = usedRange.colIndex + value.colCount;
                this.getSheet(sIdx).usedRange = usedRange;
            }
        },

        _undoInsDelMerge: function () {
            if (this._isUndo) {
                this._dupDetails = true;
                for (var k = 0, kLen = this._removeMergeColl.length; k < kLen; k++) {
                    this.mergeCenter = this._removeMergeColl[k].merge.isCenterAlign;
                    this.mergeCells(this._removeMergeColl[k].merge.mRange, true);
                }
                this._dupDetails = false;
            }
        },
        _updateCommentColl: function (sheetIdx) {
            this.getSheet(sheetIdx)._commentColl = {};
            this._isInsdel = true;
            this.XLComment._updateCmntArrowPos();
            this._isInsdel = false;
        },
        insertShiftRight: function (startCell, endCell) {
            if (!this.model.allowInsert || this.model.isReadOnly)
                return;
            var status, isInsert = false, iTd, len, sheetIdx = this.getActiveSheetIndex(), value;
            if (this._isUndo) {
                status = "shiftLeft";
                this._insDelStatus = "delete";
            }
            else {
                status = "shiftRight";
                this._insDelStatus = "insert";
            }
            value = { startCol: startCell.colIndex, colCount: (endCell.colIndex - startCell.colIndex) + 1, startRow: startCell.rowIndex, rowCount: (endCell.rowIndex - startCell.rowIndex) + 1, status: status };
            if (this.model.allowFiltering)
                this.XLFilter._checkFilterApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
            this._checkTableApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
			if (this._isFilterApplied || this._isTableApplied)
                this._showAlertDlg("Alert", "InsertDeleteAlert", "InsertDeleteAlert", 630);
            else {
                isInsert = this._clearAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
                if (!isInsert.isAlert) {
                    this._insData = { sheetIdx: sheetIdx, startCell: startCell, endCell: endCell, value: value };
                    if (!this._isUndoRedo)
                        this._showAlertDlg("Alert", "MergeInsertAlert", "MergeInsertDelete", 498);
                    else
                        this._refreshMergeCells();
                }
                else
                    this._insertShiftRight(sheetIdx, startCell, endCell, value);
                this._undoInsDelMerge();
            }
        },

        _insertShiftRight: function (sheetIdx, startCell, endCell, value) {
            var iTd, count = endCell.colIndex - startCell.colIndex + 1, rows = this.getRows(sheetIdx)[1], hdrcolgrp = this._getJSSheetHeader(sheetIdx).find("col"), colgrp = this._getContent(sheetIdx).find("col"), len;
            if (this._isUndo) {
                for (var i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                    iTd = $(rows[this._getRowIdx(i)]).find('td');
                    len = iTd.length - 1;
                    for (var j = startCell.colIndex; j <= len - count; j++)
                        iTd[j].outerHTML = iTd[j + count].outerHTML;
                }
                for (var k = len; k > len - count; k--) {
                    hdrcolgrp.eq(k).remove();
                    colgrp.eq(k).remove();
                    for (var m = 0; m < rows.length; m++)
                        $(rows[this._getRowIdx(m)]).find('td:eq(' + k + ')').remove();
                }
            }
            else
                this.XLScroll._createNewColumn(sheetIdx, startCell, endCell, "shift");
            this.performSelection(startCell, endCell);
            this._refreshDataContainer(sheetIdx, value);
            !this._isUndo ? this._refreshAllMergeCells(sheetIdx, -1, 0, startCell.colIndex, value.colCount, "insert") : this._refreshAllMergeCells(sheetIdx, -1, 0, startCell.colIndex, value.colCount, "delete");
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            if (this.model.allowComments)
                this.XLComment._curCommentHCell = null;
            if (!this._isUndoRedo)
                this._undoredoDetails(sheetIdx, startCell, endCell, "insert", "insertShiftRight");
            this._refreshRows(sheetIdx);
        },

        insertShiftBottom: function (startCell, endCell) {
            if (!this.model.allowInsert || this.model.isReadOnly)
                return;
            var isInsert = false, sheetIdx = this.getActiveSheetIndex(), status, value;
            status = (!this._isUndo) ? "shiftBottom" : "shiftUp";
            value = { startCol: startCell.colIndex, colCount: (endCell.colIndex - startCell.colIndex) + 1, startRow: startCell.rowIndex, rowCount: (endCell.rowIndex - startCell.rowIndex) + 1, status: status };
            if (this.model.allowFiltering)
                this.XLFilter._checkFilterApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
			this._checkTableApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
			if (this._isFilterApplied || this._isTableApplied) {
                if (this._isTotalRow)
                    if (!this._isUndoRedo) {
                        this._showAlertDlg("", "TotalRowAlert", "TotalRow", 630);
                        return true;
                    }
                    else {
                        this._isUndoRedo = this._dupDetails = true;
                        this.deleteEntireRow(this._insRows.startRow, this._insRows.endRow);
                        this.XLFormat._calculateTotalRow(sheetIdx, null, true, false);
                        this._isUndoRedo = false;
                    }
                else
                    this._showAlertDlg("Alert", "InsertDeleteAlert", "InsertDeleteAlert", 630);
            }
            else {
                isInsert = this._clearAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
                if (!isInsert.isAlert) {
                    this._insData = { sheetIdx: sheetIdx, startCell: startCell, endCell: endCell, value: value };
                    if(!this._isUndoRedo)
                        this._showAlertDlg("Alert", "MergeInsertAlert", "MergeInsertDelete", 498);
                    else
                        this._refreshMergeCells();
                }
                else
                    this._insertShiftBottom(sheetIdx, startCell, endCell, value);
                this._undoInsDelMerge();
            }
        },

        _insertShiftBottom: function (sheetIdx, startCell, endCell, value) {
            var isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, i, j, k, len;
            this._refreshDataContainer(sheetIdx, value);
            if (isVirtualScroll)
                this._refreshViewport(this.getSheet(sheetIdx)._scrollTop, sheetIdx);
            else {
                var x, xTd, iTd, rowHtColl = this.getSheet(sheetIdx).rowsHeightCollection, rowColl = this.getRows(sheetIdx), rows = rowColl[1], rowHdrs = rowColl[0];
                if (!this._isUndo) {
                    for (i = startCell.rowIndex; i <= endCell.rowIndex; i++)
                        this.XLScroll._createNewRow(sheetIdx, -1, -1, "insert");
                    for (i = rows.length - 1; i >= startCell.rowIndex  ; i--) {
                        x = i - ((endCell.rowIndex - startCell.rowIndex) + 1);
                        iTd = $(rows[i]).find('td');
                        if (x >= startCell.rowIndex) {
                            xTd = $(rows[x]).find('td')
                            for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                                iTd[j].outerHTML = xTd[j].outerHTML;
                                xTd[j].innerHTML = "";
                                iTd[j].className = xTd[j].className;
                                xTd[j].className = "e-rowcell e-wrapword";
                            }
                        }
                        rows[i].style.height = rowHtColl[i] + "px";
                        rowHdrs[i].style.height = rowHtColl[i] + "px";
                    }
                }
                else {
                    rows = this._getContent(sheetIdx).find("tbody").get(0).rows;
                    for (i = startCell.rowIndex, len = rows.length; i < len ; i++) {
                        x = i + ((endCell.rowIndex - startCell.rowIndex) + 1);
                        iTd = $(rows[i]).find('td');
                        if (x < rows.length) {
                            xTd = $(rows[x]).find('td')
                            for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                                iTd[j].outerHTML = xTd[j].outerHTML;
                                xTd[j].innerHTML = "";
                            }
                        }
                        rows[i].style.height = rowHtColl[i] + "px";
                        rowHdrs[i].style.height = rowHtColl[i] + "px";
                    }
                    for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                        for (k = len - 1, length = (len - 1) - ((endCell.rowIndex - startCell.rowIndex) + 1) ; k > length; k--) {
                            $(rows[k]).remove();
                            $(rowHdrs[k]).remove();
                            this.model.sheets[sheetIdx].rowCount = this.model.sheets[sheetIdx].rowCount - 1;
                        }
                    }
                    this.XLScroll._refreshScroller(1, { rowIndex: -1, colIndex: -1 }, { rowIndex: -1, colIndex: -1 }, "all");
                }
                this._refreshRows(sheetIdx);
            }
            this.XLScroll._getRowHeights(sheetIdx, startCell.rowIndex);
            this.performSelection(startCell, endCell);
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            if (this.model.allowComments)
                this.XLComment._curCommentHCell = null;
            (!this._isUndo) ? this._refreshAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, -1, 0, "insert") : this._refreshAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, -1, 0, "delete");
            if (!this._isUndoRedo && !this._dupDetails)
                this._undoredoDetails(sheetIdx, startCell, endCell, "insert", "insertShiftBottom");
        },

        insertEntireRow: function (startRow, endRow) {
            if (!this.model.allowInsert || this.model.isReadOnly)
                return;
            var isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, i, sRange, len, status, value, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), rowHtColl = sheet.rowsHeightCollection, rowhdrSel = sheet._isRowSelected,
                selCell = sheet._selectedCells, stCol = selCell[0].colIndex, endCol = selCell[selCell.length - 1].colIndex;
            if (!this._isUndo) {
                status = "insertRow";
                this._insDelStatus = "insert";
            }
            else {
                status = "deleteRow";
                this._insDelStatus = "delete";
            }
            value = { startCol: 0, colCount: sheet.colCount, startRow: startRow, rowCount: (endRow - startRow) + 1, status: status };
            if (this.XLRibbon._isDirtySelect || (this.model.allowFiltering && this.XLFilter._checkFilterApplied(sheetIdx, startRow, value.rowCount, 0, sheet.colCount, status))) {
                this._showAlertDlg("Alert", "InsertDeleteAlert", 440);
                return;
            }
            this._clearAllMergeCells(sheetIdx, startRow, value.rowCount, -1, 0, status);
            this._refreshDataContainer(sheetIdx, value);
            if (this._isUndo)
                this._batchDeleteRow(startRow, endRow, sheetIdx, true);
            else
                this._batchAddRow(startRow, endRow, sheetIdx);
            if (isVirtualScroll) {
                this.model.allowFiltering && this.XLFilter._updateFilterCollection(sheetIdx, startRow, endRow - startRow, "row", this._insDelStatus);
                sheet.rowCount = this._isUndo ? (sheet.rowCount - value.rowCount) : (sheet.rowCount + value.rowCount);
                this.refreshContent(sheetIdx);
            }
            else {
                var rowColl, rows, rowHdrs, tbodyRowHdr;
                if (!this._isUndo) {
                    for (i = startRow; i <= endRow; i++)
                        this.XLScroll._createNewRow(sheetIdx, i, 0, "insert");
                }
                else {
                    rowColl = this.getRows(sheetIdx), rows = rowColl[1], rowHdrs = rowColl[0];
                    for (i = endRow; i >= startRow; i--) {
                        $(rows[i]).remove();
                        $(rowHdrs[i]).remove();
                        sheet.rowCount = sheet.rowCount - 1;
                    }
                    var thdr = rowHdrs.find('td');
                    for (i = 0, len = thdr.length; i < len; i++)
                        $(thdr[i]).text(i + 1);
                }
                this.model.allowFiltering && this.XLFilter._updateFilterCollection(sheetIdx, startRow, endRow - startRow, "row", this._insDelStatus);
                this.XLScroll._getRowHeights(sheetIdx, startRow);
                this._refreshRows(sheetIdx);
            }
            if (this._isFrozen(sheet.frozenRows)) {
                if (startRow < sheet._frozenRows || endRow < sheet._frozenRows)
                    this.XLFreeze._refreshFreezeRowDiv();
            }
            if (this._isUndo)
                this._refreshAllMergeCells(sheetIdx, startRow, value.rowCount, -1, 0, "delete");
            else
                this._refreshAllMergeCells(sheetIdx, startRow, value.rowCount, -1, 0, "insert");
            rowhdrSel ? this.XLSelection.selectRows(startRow, endRow) : this.performSelection({ rowIndex: startRow, colIndex: stCol }, { rowIndex: endRow, colIndex: endCol });
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            if (!this._isUndoRedo && !this._dupDetails)
                this._undoredoDetails(sheetIdx, { rowIndex: startRow, colIndex: 0 }, { rowIndex: endRow, colIndex: sheet.colCount - 1 }, "insert", "insertRow");
        },

        insertEntireColumn: function (startCol, endCol) {
            if (!this.model.allowInsert || this.model.isReadOnly)
                return;
            var j, isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, status, sheetIdx = this.getActiveSheetIndex(), value, sheet = this.getSheet(sheetIdx), colHdrSel = sheet._isColSelected, startCell, endCell,
                selCell = sheet._selectedCells, stRow = selCell[0].rowIndex, endRow = selCell[selCell.length - 1].rowIndex, colWtColl = sheet.columnsWidthCollection, colWt, newWidthColl = [];
            if (this._isUndo) {
                this._insDelStatus = "delete";
                status = "deleteColumn";
            }
            else {
                status = "insertColumn";
                this._insDelStatus = "insert";
            }
            if (sheet._isTemplate && (startCol < sheet._templateColCount || endCol < sheet._templateColCount))
                return;
            value = { startCol: startCol, colCount: (endCol - startCol) + 1, startRow: 0, rowCount: sheet.rowCount, status: status };
            if (this.XLRibbon._isDirtySelect || (this.model.allowFiltering && this.XLFilter._checkFilterApplied(sheetIdx, value.startRow, sheet.rowCount, startCol, value.colCount, status))) {
                this._showAlertDlg("Alert", "InsertDeleteAlert", 440);
                return;
            }
            this._clearAllMergeCells(sheetIdx, -1, 0, startCol, value.colCount, status);
            if (status === "deleteColumn" && isVirtualScroll) {
                for (j = endCol; j >= startCol; j--) {
                    colWtColl.splice(j, 1);
                    colWtColl.push(sheet.columnWidth);
                }
            }
            startCell = { rowIndex: stRow, colIndex: startCol };
            endCell = { rowIndex: endRow, colIndex: endCol };
            if (isVirtualScroll) {
	            this._refreshDataContainer(sheetIdx, value);
                this.refreshContent(sheetIdx);
			}
            else {
                this.XLScroll._createNewColumn(sheetIdx, startCell, endCell, "insert");
				this._refreshDataContainer(sheetIdx, value);
			}
            (!this._isUndo) ? this._refreshAllMergeCells(sheetIdx, -1, 0, startCol, value.colCount, "insert") : this._refreshAllMergeCells(sheetIdx, -1, 0, startCol, value.colCount, "delete");
            this.model.allowFiltering && this.XLFilter._updateFilterCollection(sheetIdx, startCol, endCol - startCol, "column", this._insDelStatus);
            if (this._isFrozen(sheet.frozenColumns)) {
                if (startCol < sheet._frozenColumns || endCol < sheet._frozenColumns)
                    this.XLFreeze._refreshFreezeColDiv();
            }
            if (!this._isUndoRedo)
                this._undoredoDetails(sheetIdx, startCell, endCell, "insert", "insertColumn");
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            colHdrSel ? this.XLSelection.selectColumns(startCol, endCol) : this.performSelection(startCell, endCell);
            this._refreshRows(sheetIdx);
            if (this._isAutoWHMode)
                this._autoSSWidthHeight(sheetIdx);
        },

        deleteShiftLeft: function (startCell, endCell) {
            if (!this.model.allowDelete || this.model.isReadOnly)
                return;
            var isDelete = false, sheetIdx = this.getActiveSheetIndex(), status, value;
            if (!this._isUndo) {
                this._insDelStatus = "delete";
                status = "shiftLeft";
            }
            else {
                this._insDelStatus = "insert";
                status = "shiftRight";
            }
            value = { startCol: startCell.colIndex, colCount: (endCell.colIndex - startCell.colIndex) + 1, startRow: startCell.rowIndex, rowCount: (endCell.rowIndex - startCell.rowIndex) + 1, status: status };
            if (this.model.allowFiltering)
                this.XLFilter._checkFilterApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
            this._checkTableApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
			if (this._isFilterApplied || this._isTableApplied)
                this._showAlertDlg("Alert", "InsertDeleteAlert", "InsertDeleteAlert", 630);
            else {
                isDelete = this._clearAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
                if (!isDelete.isAlert) {
                    this._insData = { sheetIdx: sheetIdx, startCell: startCell, endCell: endCell, value: value };
                    if (!this._isUndoRedo)
                        this._showAlertDlg("Alert", "MergeInsertAlert", "MergeInsertDelete", 498);
                    else
                        this._refreshMergeCells();
                }
                else
                    !isDelete.isCancel && this._deleteShiftLeft(sheetIdx, startCell, endCell, value);
                this._undoInsDelMerge();
            }
        },

        _deleteShiftLeft: function (sheetIdx, startCell, endCell, value) {
            var i, j, tds, k, rowElemIdx, colCount = endCell.colIndex - startCell.colIndex + 1, rows = this.getRows(sheetIdx)[1], text = [], uLength;
            if (!this._isUndo) {
                this._insDelStatus = "delete";
                for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                    rowElemIdx = this._getRowIdx(i);
                    tds = $(rows[rowElemIdx]).find('td');
                    for (j = startCell.colIndex; j <= endCell.colIndex; j++)
                        text.push(tds[j].outerHTML);
                    for (k = startCell.colIndex, length = tds.length; k < length - colCount; k++)
                        tds[k].outerHTML = tds[k + colCount].outerHTML;
                }
            }
            else {
                $.extend(true, text, this._deletedText);
                for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                    rowElemIdx = this._getRowIdx(i);
                    tds = $(rows[rowElemIdx]).find('td');
                    uLength = tds.length - 1;
                    for (k = uLength - colCount; k > startCell.colIndex - 1; k--)
                        tds[k + colCount].outerHTML = tds[k].outerHTML;
                    for (j = startCell.colIndex; j <= endCell.colIndex; j++)
                        tds[j].outerHTML = text.shift();
                }
            }
            this.performSelection(startCell, endCell);
            this._refreshDataContainer(sheetIdx, value);
            if (this.model.allowComments) this.XLComment._curCommentHCell = null;
            this._deletedText = text;
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            (!this._isUndo) ? this._refreshAllMergeCells(sheetIdx, -1, 0, startCell.colIndex, value.colCount, "delete") : this._refreshAllMergeCells(sheetIdx, -1, 0, startCell.colIndex, value.colCount, "insert");
            (!this._isUndoRedo) && this._undoredoDetails(sheetIdx, startCell, endCell, "delete", "deleteShiftLeft");
            this._refreshRows(sheetIdx);
        },
        deleteShiftUp: function (startCell, endCell) {
            if (!this.model.allowDelete || this.model.isReadOnly)
                return;
            var isDelete = false, sheetIdx = this.getActiveSheetIndex(), status, value;
            status = (!this._isUndo) ? "shiftUp" : "shiftBottom";
            value = { startCol: startCell.colIndex, colCount: (endCell.colIndex - startCell.colIndex) + 1, startRow: startCell.rowIndex, rowCount: (endCell.rowIndex - startCell.rowIndex) + 1, status: status };
            if (this.model.allowFiltering)
                this.XLFilter._checkFilterApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
			this._checkTableApplied(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
			if (this._isFilterApplied || this._isTableApplied) {
                if (this._isTotalRow)
                    return;
                this._showAlertDlg("Alert", "InsertDeleteAlert", "InsertDeleteAlert", 630);
            }
            else {
                isDelete = this._clearAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, startCell.colIndex, value.colCount, status);
                if (!isDelete.isAlert) {
                    this._insData = { sheetIdx: sheetIdx, startCell: startCell, endCell: endCell, value: value };
                    if (!this._isUndoRedo)
                        this._showAlertDlg("Alert", "MergeInsertAlert", "MergeInsertDelete", 498);
                    else
                        this._refreshMergeCells();
                }
                else
                    !isDelete.isCancel && this._deleteShiftUp(sheetIdx, startCell, endCell, value);
                this._undoInsDelMerge();
            }
        },

        _deleteShiftUp: function (sheetIdx, startCell, endCell, value) {
            var isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, i, j, len, text = [], x, rowElemIdx;
            this._refreshDataContainer(sheetIdx, value);
            if (isVirtualScroll)
                this._refreshViewport(this.getSheet(sheetIdx)._scrollTop, sheetIdx);
            else {
                var itds, xtds, rowHtColl = this.getSheet(sheetIdx).rowsHeightCollection, rowsColl = this.getRows(sheetIdx), rows = rowsColl[1], rowHdrs = rowsColl[0];
                if (!this._isUndo || this._isTotalRow) {
                    for (i = startCell.rowIndex, len = rows.length; i < len ; i++) {
                        x = i + ((endCell.rowIndex - startCell.rowIndex) + 1);
                        rowElemIdx = this._getRowIdx(i);
                        itds = $(rows[rowElemIdx]).find('td');
                        if (x < rows.length) {
                            xtds = $(rows[this._getRowIdx(x)]).find('td');
                            for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                                text.push(itds[j].outerHTML);
                                itds[j].outerHTML = xtds[j].outerHTML;
                                xtds[j].innerHTML = "";
                            }
                        }
                        rows[rowElemIdx].style.height = rowHtColl[i] + "px";
                        rowHdrs[rowElemIdx].style.height = rowHtColl[i] + "px";
                    }
                }
                else {
                    $.extend(true, text, this._deletedText);
                    for (i = rows.length - 1; i >= startCell.rowIndex  ; i--) {
                        x = i - ((endCell.rowIndex - startCell.rowIndex) + 1);
                        rowElemIdx = this._getRowIdx(i);
                        itds = $(rows[rowElemIdx]).find('td');
                        if (x >= startCell.rowIndex) {
                            xtds = $(rows[this._getRowIdx(x)]).find('td');
                            for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                                itds[j].outerHTML = xtds[j].outerHTML;
                                xtds[j].innerHTML = "";
                            }
                        }
                        rows[rowElemIdx].style.height = rowHtColl[i] + "px";
                        rowHdrs[rowElemIdx].style.height = rowHtColl[i] + "px";
                    }
                    for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                        itds = $(rows[this._getRowIdx(i)]).find('td');
                        for (j = startCell.colIndex; j <= endCell.colIndex; j++)
                            itds[j].outerHTML = text.shift();
                    }
                }
                this._refreshRows(sheetIdx);
            }
            this.XLScroll._getRowHeights(sheetIdx, startCell.rowIndex);
            this.performSelection(startCell, endCell);
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            if (this.model.allowComments) this.XLComment._curCommentHCell = null;
            this._deletedText = text;
            (!this._isUndo) ? this._refreshAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, -1, 0, "delete") : this._refreshAllMergeCells(sheetIdx, startCell.rowIndex, value.rowCount, -1, 0, "insert");
            if (!this._isUndoRedo && !this._dupDetails)
                this._undoredoDetails(sheetIdx, startCell, endCell, "delete", "deleteShiftUp");
        },

        deleteEntireRow: function (startRow, endRow) {
            if (!this.model.allowDelete || this.model.isReadOnly)
                return;
            var isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, i, len, status, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx),
                selCell = sheet._selectedCells, stCol = selCell[0].colIndex, endCol = selCell[selCell.length - 1].colIndex, rowHeightColl = sheet.rowsHeightCollection;
            if (!this._isUndo) {
                status = "deleteRow";
                this._insDelStatus = "delete";
            }
            else {
                this._insDelStatus = "insert";
                status = "insertRow";
            }
            value = { startCol: 0, colCount: sheet.colCount, startRow: startRow, rowCount: (endRow - startRow) + 1, status: status };
            if (!this._isUndoRedo && (this.XLRibbon._isDirtySelect || (this.model.allowFiltering && this.XLFilter._checkFilterApplied(sheetIdx, startRow, value.rowCount, 0, sheet.colCount, status)))) {
                this._showAlertDlg("Alert", "InsertDeleteAlert", 440);
                return;
            }
            this._clearAllMergeCells(sheetIdx, startRow, value.rowCount, -1, 0, status);
            this._refreshDataContainer(sheetIdx, value);
            if (this._isUndo)
                this._batchAddRow(startRow, endRow, sheetIdx, true);
            else
                this._batchDeleteRow(startRow, endRow, sheetIdx);
            if (isVirtualScroll) {
                if (this.model.scrollSettings.scrollMode === "normal")
                    sheet.rowCount = this._isUndo ? (sheet.rowCount + value.rowCount) : (sheet.rowCount - value.rowCount);
                this.refreshContent(sheetIdx);
            }
            else {
                var thdr, rowElemIdx, tdHdr, text = [], dimension = [], rowHt, tr, value, rowColl = this.getRows(sheetIdx), rows = rowColl[1], rowHdrs = rowColl[0];
                if (!this._isUndo) {
                    for (i = endRow; i >= startRow; i--) {
                        rowElemIdx = this._getRowIdx(i);
                        text.push(rows[rowElemIdx].outerHTML);
                        $(rows[rowElemIdx]).remove();
                        $(rowHdrs[rowElemIdx]).remove();
                        sheet.rowCount = sheet.rowCount - 1;
                        this.XLScroll._createNewRow(sheetIdx, -1, -1, "insert");
                    }
                }
                else {
                    $.extend(true, text, this._deletedText);
                    for (i = startRow; i <= endRow; i++) {
                        rowElemIdx = this._getRowIdx(i);
                        tr = text.pop();
                        $(rows[rowElemIdx]).before(tr);
                        tdHdr = this.XLScroll._rowHeaderTemplate(1, rowHeightColl[i]);
                        $(rowHdrs[rowElemIdx]).before(tdHdr);
                        sheet.rowCount = sheet.rowCount + 1;
                    }
                    this._refreshRows(sheetIdx);
                }
                thdr = $(this.getRows(sheetIdx)[0]).find('td');
                for (i = 0, len = thdr.length; i < len; i++)
                    $(thdr[i]).text(i + 1);
                this._refreshRows(sheetIdx);
            }
            if (this._isFrozen(sheet.frozenRows)) {
                if (startRow < sheet._frozenRows || endRow < sheet._frozenRows)
                    this.XLFreeze._refreshFreezeRowDiv();
            }
            (sheet._isRowSelected) ? this.XLSelection.selectRows(startRow, endRow) : this.performSelection({ rowIndex: startRow, colIndex: stCol }, { rowIndex: endRow, colIndex: endCol });
            this._deletedText = text;
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            if (this._isUndo)
                this._refreshAllMergeCells(sheetIdx, startRow, value.rowCount, -1, 0, "insert");
            else
                this._refreshAllMergeCells(sheetIdx, startRow, value.rowCount, -1, 0, "delete");
            this.model.allowFiltering && this.XLFilter._updateFilterCollection(sheetIdx, startRow, endRow - startRow, "row", this._insDelStatus);
            this.XLScroll._getRowHeights(sheetIdx, startRow);
            (!this._isUndoRedo && !this._dupDetails) && this._undoredoDetails(sheetIdx, { rowIndex: startRow, colIndex: 0 }, { rowIndex: endRow, colIndex: sheet.colCount - 1 }, "delete", "deleteRow");
        },

        deleteEntireColumn: function (startCol, endCol) {
            if (!this.model.allowDelete || this.model.isReadOnly)
                return;
            var i, j, len, tds, hiddenWth = 0, sheetIdx = this.getActiveSheetIndex(), fColIdx = this.getFrozenColumns(), sheet = this.getSheet(sheetIdx), rows = this.getRows(sheetIdx)[1], colgrp = this._getContent(sheetIdx).find("col"),
                hdrcolgrp = this._getJSSheetHeader(sheetIdx).find("col"), colHdr = this._getJSSheetHeader(sheetIdx).find("th"), selCell = sheet._selectedCells, stRow = selCell[0].rowIndex, endRow = selCell[selCell.length - 1].rowIndex,
                tdColgrp, status, text = [], value, tdRowData, colWt, tdColgrp = this.XLScroll._colGroupTemplate(1), colWidthColl = sheet.columnsWidthCollection, isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling,
                tbody = isVirtualScroll ? this._getContent(sheetIdx).find("tbody").get(1) : this._getContent(sheetIdx).find("tbody").get(0);
            if (!this._isUndo) {
                status = "deleteColumn";
                this._insDelStatus = "delete";
            }
            else {
                status = "insertColumn";
                this._insDelStatus = "insert";
            }
            if (sheet._isTemplate && (startCol < sheet._templateColCount || endCol < sheet._templateColCount))
                return;
            value = { startCol: startCol, colCount: (endCol - startCol) + 1, startRow: 0, rowCount: sheet.rowCount, status: status };
            if (!this._isUndoRedo && (this.XLRibbon._isDirtySelect || (this.model.allowFiltering && this.XLFilter._checkFilterApplied(sheetIdx, value.startRow, value.rowCount, 0, sheet.colCount, status)))) {
                this._showAlertDlg("Alert", "InsertDeleteAlert", 440);
                return;
            }
            this._clearAllMergeCells(sheetIdx, -1, 0, startCol, value.colCount, status);
            if (!this._isUndo) {
                this._deletedDimension = [];
                if (this._isFrozen(fColIdx) && fColIdx >= startCol) {
                    for (i = sheet._frozenColumns - 1; i < sheet._fleftColIdx; i++)
                        hiddenWth += sheet.columnsWidthCollection[i];
                    this._scrollContent({ x: -hiddenWth });
                }
                for (j = endCol; j >= startCol; j--) {
                    text.push(hdrcolgrp[j].outerHTML);
                    text.push(colgrp[j].outerHTML);
                    this._deletedDimension.push(colWidthColl.splice(j, 1)[0]);
                    hdrcolgrp.eq(j).remove();
                    colgrp.eq(j).remove();
                    hdrcolgrp.parent().append(tdColgrp);
                    colgrp.parent().append(tdColgrp);
                    colWidthColl.push(sheet.columnWidth);
                }
                for (i = 0, len = rows.length; i < len; i++) {
                    tds = $(rows[i]).find('td');
                    for (j = endCol; j >= startCol; j--) {
                        tdRowData = this.XLScroll._columnTemplate();
                        $(rows[i]).append(tdRowData);
                        text.push(tds[j].outerHTML);
                        $(tbody.rows[i]).find('td:eq(' + j + ')').remove();
                    }
                }
            }
            else {
                text = $.extend(true, text, this._deletedText);
                var diff = 0;
                for (i = rows.length - 1; i >= 0; i--) {
                    tds = $(rows[i]).find('td');
                    for (j = startCol; j <= endCol; j++) {
                        tds.eq(j - diff).before(text.pop());
                        diff++;
                    }
                    diff = 0;
                }
                for (j = startCol; j <= endCol; j++) {
                    colgrp.eq(j - diff).before(text.pop());
                    colHdr.eq(j - diff).before("<th class='e-headercell'><div class='e-headercelldiv'></div></th>");
                    hdrcolgrp.eq(j - diff).before(text.pop());
                    diff++;
                }
                colWt = colWidthColl.splice(0, startCol);
                ej.merge(colWt, this._deletedDimension.reverse());
                ej.merge(colWt, colWidthColl);
                sheet.columnsWidthCollection = colWt;
                this._deletedDimension = [];
            }
            this.XLScroll._getColWidths(sheetIdx, startCol);
            if (this._isFrozen(sheet.frozenColumns)) {
                if (startCol < sheet._frozenColumns || endCol < sheet._frozenColumns)
                    this.XLFreeze._refreshFreezeColDiv();
            }
            this.model.allowFiltering && this.XLFilter._updateFilterCollection(sheetIdx, startCol, endCol - startCol, "column", this._insDelStatus);
            sheet.colCount = colgrp.length;
            colHdr = this._getJSSheetHeader(sheetIdx).find('th');
            this._refreshDataContainer(sheetIdx, value);
            var cls;
            for (i = 0, len = colHdr.length; i < len; i++) {
                if (this._checkIndicesInContainer(sheetIdx, 0, i, "hCol"))
                    cls = "e-hcol";
                if(this._checkIndicesInContainer(sheetIdx, 0, i, "isCHide"))
                    cls += "e-hide";
                this._removeClass(colHdr[i], "e-hcol");
                this._removeClass(colHdr[i], "e-hide");
                this.addClass(colHdr[i], cls);
                cls = "";
                $(colHdr[i]).find('div').text(this._generateHeaderText(i + 1));
            }
            if (isVirtualScroll)
                this.refreshContent(sheetIdx);
            (!this._isUndo) ? this._refreshAllMergeCells(sheetIdx, -1, 0, startCol, value.colCount, "delete") : this._refreshAllMergeCells(sheetIdx, -1, 0, startCol, value.colCount, "insert");
            sheet._isColSelected ? this.XLSelection.selectColumns(startCol, endCol) : this.performSelection({ rowIndex: stRow, colIndex: startCol }, { rowIndex: endRow, colIndex: endCol });
            this._deletedText = text;
            if (this.model.allowComments)
                this._updateCommentColl(sheetIdx);
            (!this._isUndoRedo) && this._undoredoDetails(sheetIdx, { rowIndex: 0, colIndex: startCol }, { rowIndex: sheet.rowCount - 1, colIndex: endCol }, "delete", "deleteColumn");
            this._refreshRows(sheetIdx);
        },

        _getSelectedRange: function (startcell, endcell) {
            var i, j, k, l, arr = [],
                range = this.swapRange([startcell.rowIndex, startcell.colIndex, endcell.rowIndex, endcell.colIndex]);
            i = range[0], j = range[2];
            while (i <= j) {
                k = range[1];
                l = range[3];
                while (k <= l) {
                    arr.push({ rowIndex: i, colIndex: k });
                    k++;
                }
                i++;
            }
            return arr;
        },

        performSelection: function (startCell, endCell) {
            var sheetIdx = this.getActiveSheetIndex(), range, sheet = this.getSheet(sheetIdx), tname, tid, stMerge, endMerge, stRange, endRange;
            if (!this.getObjectLength(startCell)) {
                range = this._getRangeArgs(startCell, "object");
                startCell = { rowIndex: range[0], colIndex: range[1] };
                endCell = { rowIndex: range[2], colIndex: range[3] };
            }
            if (this.model.scrollSettings.allowScrolling)
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
            this.setActiveCell(startCell.rowIndex, startCell.colIndex);
            if (this.model.allowSelection) {
                stMerge = this.XLEdit.getPropertyValue(startCell.rowIndex, startCell.colIndex, "merge");
                endMerge = this.XLEdit.getPropertyValue(endCell.rowIndex, endCell.colIndex, "merge");
                if (stMerge) {
                    stRange = this.getRangeIndices(stMerge.mRange);
                    startCell = { rowIndex: stRange[0], colIndex: stRange[1] }
                }
                if (endMerge) {
                    endRange = this.getRangeIndices(endMerge.mRange);
                    endCell = { rowIndex: endRange[2], colIndex: endRange[3] }
                }
                this.XLSelection.selectRange(startCell, endCell);
            }
            if (this.model.allowAutoFill)
                this.XLDragFill.positionAutoFillElement();
            sheet._startCell = startCell;
            sheet._endCell = endCell;
            if (this.model.showRibbon)
                this.XLRibbon._updateRibbonIcons();
            tname = this.XLEdit.getPropertyValue(startCell.rowIndex, startCell.colIndex, "tableName", sheetIdx);
            if (tname) {
                tid = this._getTableID(tname);
                if (this.isNumber(tid))
                    this.XLRibbon._designTabUpdate(tid, startCell);
            }
        },

        _checkRowCol: function (start, end) {
            if (start === 0 || end === 0)
                return;
            if (ej.isNullOrUndefined(end))
                end = start;
            return { start: start, end: end };
        },

        hideRow: function (startRow, endRow) {
            var rowColl = this._checkRowCol(startRow, endRow);
            this._hideRow(rowColl.start - 1, rowColl.end - 1, "isRHide");
        },

        showRow: function (startRow, endRow) {
            var rowColl = this._checkRowCol(startRow, endRow);
            this._showRow(rowColl.start, rowColl.end, "isRHide");
        },

        hideColumn: function (startCol, endCol) {
            var hideCol = this._checkRowCol(startCol, endCol);
            this._hideColumn(hideCol.start - 1, hideCol.end - 1);
        },

        showColumn: function (startCol, endCol) {
            var showCol = this._checkRowCol(startCol, endCol);
            this._showColumn(showCol.start, showCol.end);
        },

        _hideRow: function (startRow, endRow, type, isFrz) {
            var sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), rowColl = this.getRows(sheetIdx), rows = rowColl[1], hdrRows = rowColl[0], scrollSettings = this.model.scrollSettings, isVirtualScroll = scrollSettings.allowVirtualScrolling,
                hideRowsColl = sheet.hideRowsCollection, hRows = [], rowHtColl = sheet.rowsHeightCollection;
            if (!this._isUndoRedo && !isFrz) {
                this.XLEdit._updateDataContainer({ rowIndex: (startRow ? startRow - 1 : startRow), colIndex: 0 }, { dataObj: { hRow: true } });
                if (!isVirtualScroll)
                    this.addClass(this._getJSSheetRowHeaderContent(sheetIdx).find('.e-rowheader')[startRow ? startRow - 1 : startRow], "e-hrow");
            }
            for (var i = startRow; i <= endRow; i++) {
                if (type === "isRHide")
                    this.XLEdit._updateDataContainer({ rowIndex: i, colIndex: 0 }, { dataObj: { "isRHide": true } });
                hRows.push(i);
                if (hideRowsColl.indexOf(i) === -1) {
                    hideRowsColl.push(i);
                    if (!isVirtualScroll) {
                        if (this._isRowViewable(sheetIdx, i)) {
                            this.addClass(rows[i], "e-r-hide");
                            this.addClass(hdrRows[i], "e-r-hide");
                        }
                        if (scrollSettings.allowScrolling && (scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite) && (!sheet._isImported || sheet._isLoaded))
                            this.XLScroll._createNewRow(sheetIdx, -1, -1, "insert");
                    }
                }
            }
            if (this.model.allowCellFormatting)
                this.XLFormat._refreshHiddenBorder(startRow, endRow, true, true);
            (!this._isFilter) && this.XLScroll._getRowHeights(sheetIdx, startRow);
            this._showHideRows(sheetIdx, sheet, hRows, startRow, endRow, isVirtualScroll, "hide");
            if ((!sheet._isImported || sheet._isLoaded) && !this._isFilter && !this._isExport) {
                this.model.allowComments && this.XLComment._updateCmntArrowPos();
                if (this._isFrozen(sheet.frozenRows)) {
                    if (startRow < sheet._frozenRows || endRow < sheet._frozenRows)
                        this.XLFreeze._refreshFreezeRowDiv();
                }
                if (this.model.scrollSettings.allowScrolling && !isVirtualScroll)
                    this.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical");
                if (!this._isUndoRedo && !isFrz) {
                    sheet._activeCell.rowIndex = endRow + 1;
                    var details = { sheetIndex: sheetIdx, reqType: "show-hide", action: "hide", operation: "row", bSelect: { startRow: startRow, endRow: endRow }, aSelect: { startRow: endRow + 1, endRow: endRow + 1 }, addBRows: startRow ? [startRow - 1] : [startRow], remBRows: [], hideRows: hRows };
                    this._completeAction(details);
                    this._trigActionComplete(details);
                }
            }
            if (!isFrz) {
                this.XLSelection.selectRow(endRow + 1, sheetIdx);
                if (this.model.allowAutoFill)
                    this.XLDragFill.hideAutoFillElement();
            }
        },

        _showRow: function (startRow, endRow, type, isFrz, colHdr, colgrp, rowHdrTd) {
            var index, j, aSelect, sheetIdx = this.getActiveSheetIndex(), strtIdx = this._isUndoRedo ? startRow : (startRow - 1 > 0) ? startRow - 1 : 0, sheet = this.getSheet(sheetIdx), rowColl = this.getRows(sheetIdx), rows = rowColl[1], rowHeaders = rowColl[0], idx,
                hRows = [], addBRow = [], remBRow = [], rowHtColl = sheet.rowsHeightCollection, hideRowsColl = sheet.hideRowsCollection,
				emptyTable = ej.buildTag("table#wrapTable.e-table", {}), dataContainer = this._dataContainer.sheets[sheetIdx],
                isVirtualScroll = this.model.scrollSettings.allowVirtualScrolling, colWtColl = sheet.columnsWidthCollection;
				rowHdr = this.element.find('.e-spreadsheetcolumnheader');
            if (!isVirtualScroll) {
                emptyTable.append(colgrp);
                this.element[0].insertBefore(emptyTable[0], this.element[0].childNodes[0]);
            }
            if (this.model.allowCellFormatting)
                this.XLFormat._refreshHiddenBorder(startRow, endRow, true);
            for (j = strtIdx; j <= endRow; j++) {
                index = hideRowsColl.indexOf(j);
                if (index > -1) {
                    if (type === "isRHide")
                        delete dataContainer[j][0]["isRHide"];
                    hRows.push(j);
                    hideRowsColl.splice(index, 1);
                    if (!isVirtualScroll) {
                        this._removeClass(rows[j], "e-r-hide");
                        this._removeClass(rowHeaders[j], "e-r-hide");
                    }
                    if (!this._isUndoRedo && (j > 0) && !isFrz) {
                        remBRow.push(j - 1);
                        delete dataContainer[j - 1][0].hRow;
                        if (!isVirtualScroll)
                            this._removeClass($(rowHeaders[j - 1]).find('td')[0], "e-hrow");
                    }
                    else if (j === 0 && !isFrz) {
                        delete dataContainer[0][0].hRow;
                        if (!isVirtualScroll) {
                            rowHdr.height(20.5);
                            this._removeClass(rowHdr[0], "e-hrow");
                        }
                    }
                }
                if (!isVirtualScroll) {
                    this._setWrapHeight(sheetIdx, j, rows, rowHeaders, emptyTable, "visible");
                    emptyTable.remove();
                }
                this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
            }
            if (!this._isFilter)
                this.XLScroll._getRowHeights(sheetIdx, strtIdx);
            this._showHideRows(sheetIdx, sheet, hRows, startRow, endRow, isVirtualScroll, "show");
            if (!isFrz)
                if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo && !this._isFilter) {
                    if (startRow < endRow) {
                        this.setActiveCell(startRow, 0);
                        this.XLSelection.selectRows(startRow, endRow, sheetIdx);
                        aSelect = { startRow: startRow, endRow: endRow };
                    }
                    else {
                        if (startRow > 0) {
                            this.setActiveCell(startRow - 1, 0);
                            this.XLSelection.selectRow(startRow - 1, sheetIdx);
                            aSelect = { startRow: startRow - 1, endRow: startRow - 1 };
                        }
                    }
                    this.XLDragFill.positionAutoFillElement();
                    var details = { sheetIndex: sheetIdx, reqType: "show-hide", action: "show", operation: "row", bSelect: { startRow: startRow, endRow: endRow }, aSelect: aSelect, addBRows: addBRow, remBRows: remBRow, hideRows: hRows };
                    this._completeAction(details);
                    this._trigActionComplete(details);
                }
            if (this._isFrozen(sheet.frozenRows)) {
                if (startRow < sheet._frozenRows || endRow < sheet._frozenRows)
                    this.XLFreeze._refreshFreezeRowDiv();
            }
            if (!this._isFilter) {
                if ((!sheet._isImported || sheet._isLoaded) && this.model.allowComments)
                    this.XLComment._updateCmntArrowPos();
                if (this.model.scrollSettings.allowScrolling)
                    this.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical");
            }
        },

        _showHideRows: function (sheetIdx, sheet, hRows, startRow, endRow, isVScroll, operation) {
            if (isVScroll) {
				(operation === "show") && this.refreshContent(sheetIdx);
				this._refreshViewport(this._isFrozen(sheet.frozenRows) ? sheet._contScrollTop : sheet._scrollTop, sheetIdx);
			}
            this._refreshSHMergeCells(sheetIdx, hRows, (endRow - startRow) + 1, "row", operation);
			if (isVScroll)
				(operation === "hide") && this.refreshContent(sheetIdx);            
			if (sheet.selectedRange[0] < startRow && sheet.selectedRange[2] > endRow) {
                this.model.allowSelection && this.XLSelection.selectRange(sheet._activeCell, sheet._activeCell);
                this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();
            }
        },

        _colgroupRefresh: function (sheetIdx) {
            if (this.model.allowResizing) {
                var headerCol = this._getJSSheetHeader(sheetIdx).find('colgroup');
                var contentCol = this._getContent(sheetIdx).find('colgroup');
            }
            var headerColClone = $(headerCol).clone();
            var contentColClone = $(contentCol).clone();
            $(contentCol).remove();
            $(headerCol).remove();
            $(headerColClone).prependTo(this._getJSSheetHeader(sheetIdx).find('.e-table'));
            $(contentColClone).prependTo(this._getContent(sheetIdx).find('.e-table'));
        },

        _updateFilterIcon: function (colIdx, status, sheetIdx) {
            ej.isNullOrUndefined(sheetIdx) && (sheetIdx = this.getActiveSheetIndex());
            var tableRange = this.getSheet(sheetIdx).filterSettings.tableRange, stRow, colIdxes, i, iLen;
            for (i = 0, iLen = tableRange.length; i < iLen; i++) {
                colIdxes = tableRange[i].multifilterIdx;
                if (colIdx >= colIdxes[0] && colIdx <= colIdxes[colIdxes.length - 1]) {
                    stRow = tableRange[i].startRow - 1;
                    if (this._isRowViewable(sheetIdx, stRow)) {
                        if (status === "hide")
                            this.addClass(this.getCell(stRow, colIdx).find(".e-filterspan")[0], "e-hide");
                        else
                            this._removeClass(this.getCell(stRow, colIdx).find(".e-filterspan")[0], "e-hide");
                    }
                    this.XLEdit._updateDataContainer({ rowIndex: stRow, colIndex: colIdx }, { dataObj: { isFilterVisible: (status != "hide") } });
                }
            }
        },

        _hideColumn: function (startCol, endCol) {
            var i, j, len, aSelect, fltrKeys, isViewed = false, sheetIdx = this.getActiveSheetIndex(), hdr = this._getJSSheetHeader(sheetIdx).find("th"), hdrcolgrp = this._getJSSheetHeader(sheetIdx).find("col"),
                filterSpan, isCHide, sheet = this.getSheet(sheetIdx), hideColsColl = sheet.hideColsCollection, hCols = [], addBCol = [], range, colgrp = this._getContent(sheetIdx).find("col"),
                filterColl = sheet._filterColl, fRowIdx, filterKeys, colWidthColl = sheet.columnsWidthCollection, colHdr = this.element.find('.e-spreadsheetcolumnheader');
            for (j = startCol; j <= endCol; j++) {
                this._getContent(sheetIdx).find(".e-rowcell:nth-child(" + (j + 1) + ")").addClass('e-soverflow');
                isCHide = this.XLEdit.getPropertyValue(0, j, "isCHide");
                if (this._isColumnViewable(sheetIdx, j))
                    isViewed = true;
                if (ej.isNullOrUndefined(isCHide)) {
                    this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: j }, { dataObj: { isCHide: true } });
                    this._writeRule(j, sheetIdx);
                    if (isViewed) {
                        this.addClass(hdr[j], "e-hide");
                        this.addClass(hdrcolgrp[j], "e-hide");
                        this.addClass(colgrp[j], "e-hide");
                    }
                    hCols.push(j);
                    hideColsColl[j] = colWidthColl[j];
                    colWidthColl[j] = 0;
                    fltrKeys = this.getObjectKeys(filterColl);
                    for (i = 0, len = fltrKeys.length; i < len; i++) {
                        if (!ej.isNullOrUndefined(filterColl[fltrKeys[i]])) {
                            fRowIdx = fltrKeys[i];
                            if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(fltrKeys[i], j, "isSpanHide")))
                                this.XLEdit._updateDataContainer({ rowIndex: fltrKeys[i], colIndex: j }, { dataObj: { isSpanHide: true } });
                        }
                    }
                }
            }
            if (this.model.allowCellFormatting)
                this.XLFormat._refreshHiddenBorder(startCol, endCol, false, true);
            if (!this._isUndoRedo) {
                if (startCol)
                    addBCol.push(startCol - 1);
                else
                    addBCol.push(startCol);
                if (this._isColumnViewable(sheetIdx, startCol)) {
                    if (startCol === 0) {
                        colHdr.width(28);
                        this.addClass(colHdr[0], "e-hfcol");
                        this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: 0 }, { dataObj: { hCol: true } });
                    }
                    else {
                        this.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: startCol - 1 }, { dataObj: { hCol: true } });
                        this.addClass(this._getJSSheetHeader(sheetIdx).find('th:eq(' + (startCol - 1) + ')')[0], "e-hcol");
                    }
                }
            }
            this._refreshSHMergeCells(sheetIdx, hCols, (endCol - startCol) + 1, "column", "hide");
            this.XLScroll._getColWidths(sheetIdx, startCol);
            if (this._isFrozen(sheet.frozenColumns)) {
				this.XLScroll._refreshContHgt(sheetIdx);
                if (startCol < sheet._frozenColumns || endCol < sheet._frozenColumns)
                    this.XLFreeze._refreshFreezeColDiv();
            }
            if (this.model.scrollSettings.allowScrolling)
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "horizontal");
            if (!sheet._isImported || sheet._isLoaded) {
                if (colWidthColl.length - 1 === endCol) {
                    this.XLSelection.selectColumn(endCol - 1, sheetIdx);
                    this.setActiveCell(0, endCol - 1);
                    aSelect = { startCol: endCol - 1, endCol: endCol - 1 };
                }
                else {
                    aSelect = { startCol: endCol + 1, endCol: endCol + 1 };
                    this.setActiveCell(0, endCol + 1);
                    this.XLSelection.selectColumn(endCol + 1, sheetIdx);
                }
                this.XLDragFill.positionAutoFillElement();
                if (!this._isUndoRedo) {
                    var details = { sheetIndex: sheetIdx, reqType: "show-hide", action: "hide", operation: "column", bSelect: { startCol: startCol, endCol: endCol }, aSelect: aSelect, hideCols: hCols, addBCols: addBCol, remBCols: [] };
                    this._completeAction(details);
                    this._trigActionComplete(details);
                }
                if (this.model.allowComments)
                    this.XLComment._updateCmntArrowPos();
            }
            else
                this.setActiveCell(0, 0);
            if (this._browserDetails.name.indexOf("msie") > -1)
                this._colgroupRefresh(sheetIdx);
        },

        _showColumn: function (startCol, endCol) {
            var j, aSelect, sheetIdx = this.getActiveSheetIndex(), colIdx = this._isUndoRedo ? startCol : (startCol - 1 > 0) ? startCol - 1 : 0, sheet = this.getSheet(sheetIdx), hideColsColl = sheet.hideColsCollection,
				hCols = [], addBCol = [], isViewed = false, remBCol = [], hdr = this._getJSSheetHeader(sheetIdx).find("th"), colgrp = this._getContent(sheetIdx).find("col"),
                hdrcolgrp = this._getJSSheetHeader(sheetIdx).find('col'), range, colWtColl = sheet.columnsWidthCollection, colHdr = this.element.find('.e-spreadsheetcolumnheader');
            if (this.model.allowCellFormatting)
                this.XLFormat._refreshHiddenBorder(startCol, endCol);
            for (j = colIdx; j <= endCol; j++) {
                this._getContent(sheetIdx).find(".e-rowcell:nth-child(" + (j + 1) + ")").removeClass('e-soverflow');
                if (j in hideColsColl) {
                    this._deleteRule(j, sheetIdx);
                    this._isColumnViewable(sheetIdx, j) && (isViewed = true);
                    if (isViewed) {
                        this._removeClass(hdr[j], "e-hide");
                        this._removeClass(hdrcolgrp[j], "e-hide");
                        this._removeClass(colgrp[j], "e-hide");
                        colgrp[j].style["width"] = hideColsColl[j] + "px";
                        hdrcolgrp[j].style["width"] = hideColsColl[j] + "px";
                    }
                    colWtColl[j] = hideColsColl[j];
                    delete hideColsColl[j];
                    delete this._dataContainer.sheets[sheetIdx][0][j]["isCHide"];
                    if (this.model.allowFiltering)
                        this._updateFilterIcon(j, "show", sheetIdx)
                    hCols.push(j);
                    if (!this._isUndoRedo && (j > 0)) {
                        isViewed && this._removeClass(hdr.get(j - 1), "e-hcol");
                        delete this._dataContainer.sheets[sheetIdx][0][j - 1]["hCol"];
                        remBCol.push(j - 1);
                    }
                    else if (j === 0) {
                        colHdr.width(29);
                        this._removeClass(colHdr[0], "e-hfcol");
                        delete this._dataContainer.sheets[sheetIdx][0][0]["hCol"];
                    }
                }
            }
            this._refreshSHMergeCells(sheetIdx, hCols, (endCol - startCol) + 1, "column", "show");
            this.XLScroll._getColWidths(sheetIdx, colIdx);
            if (!this._isUndoRedo && (!sheet._isImported || sheet._isLoaded)) {
                if (startCol < endCol) {
                    this.XLSelection.selectColumns(startCol, endCol, sheetIdx);
                    aSelect = { startCol: startCol, endCol: endCol };
                }
                else {
                    this.XLSelection.selectColumn(colIdx, sheetIdx);
                    aSelect = { startCol: colIdx, endCol: colIdx };
                }
                this.XLDragFill.positionAutoFillElement();
                var details = { sheetIndex: sheetIdx, reqType: "show-hide", action: "show", operation: "column", bSelect: { startCol: startCol, endCol: endCol }, aSelect: aSelect, addBCols: addBCol, remBCols: remBCol, hideCols: hCols };
                this._completeAction(details);
                this._trigActionComplete(details);
            }
            if (this._browserDetails.name.indexOf("msie") > -1)
                this._colgroupRefresh(sheetIdx);
            if ((!sheet._isImported || sheet._isLoaded) && this.model.allowComments)
                this.XLComment._updateCmntArrowPos();
            if (this._isFrozen(sheet.frozenColumns)) {
                if (startCol < sheet._frozenColumns || endCol < sheet._frozenColumns)
                    this.XLFreeze._refreshFreezeColDiv();
            }
            if (this.model.scrollSettings.allowScrolling)
                this.XLScroll._refreshScroller(sheetIdx, "refresh", "horizontal");
        },

        _refreshHideRowColCollection: function (collection, idx, count, type, action) {
            var coll;
            if (type === "row") {
                for (var i = 0; i < collection.length; i++) {
                    if (collection[i] >= (idx + count)) {
                        if(action === "insert")
                            collection[i] += count;
                        else
                            collection[i] -= count;
                        break;
                    }
                }
            }
            else {
                coll = this.getObjectKeys(collection);
                for (var i = coll.length - 1; i >= 0; i--) {
                    if (coll[i] >= (idx + count)) {
                        if (action === "insert") {
                            collection[parseInt(coll[i]) + count] = collection[coll[i]];
                            delete collection[coll[i]];
                        }
                        else {
                            collection[parseInt(coll[i]) - count] = collection[coll[i]];
                            delete collection[coll[i]];
                        }
                        break;
                    }
                }
            }
        },

        _destroySheet: function (index) {
            this.element.find("#" + this._id + "_" + this.model.sheets[index].sheetInfo.value).empty();
        },
        _destroy: function () {
            var name, i = 1, calcObj;
            $("#" + this._id + "_sscustomformat").remove();
            if (this.isImport || this._isNew) {
                while (i <= this.model.sheetCount) {
                    delete $.templates[this._id + "JSONTemplate" + i];
                    delete $.templates[this._id + "JSONRowHdrTemplate" + i];
                    name = this.getSheet(i).sheetInfo.value;
                    CalcEngine.unregisterGridAsSheet(name, name);
                    i++;
                }
                this.model.sheets = [];
                this.model.nameManager = [];
                this._sheets = [];
                this.getActivationPanel().empty();
                if (this.model.enablePivotTable)
                    this.XLPivot._hasPvtField = false;
                this.isDirty = false;
                calcObj = this.getCalcEngine();
                calcObj.getFormulaInfoTable().clear();
                calcObj.getDependentCells().clear();
                calcObj.getDependentFormulaCells().clear();
                calcObj.getNamedRanges().clear();
                calcObj.getDependentNamedRangeCells().clear();
                if (this.isImport) {
                    this._detachTable = null;
                    this._updateFormulaCollection();
                }
                else {
                    document.getElementById(this._id + "_nmgrid") && $("#" + this._id + "_nmgrid").ejGrid("option", { dataSource: [] });
                    this._dataContainer = { sheets: {}, hashCode: [], sharedData: [], cellType: [], valData: [], cFormatData: [] };
                    this.XLRibbon._updateUseInFormulaTrgt();
                    this.XLEdit._refreshAutoComplete();
                }
                this.element.append([this.getFocusTopElem(), this.getFocusRightElem(), this.getFocusBottomElem(), this.getFocusLeftElem(), this.getAutoFillElem(), this._getAutoFillOptElem()]);
                this.element.find(".e-spreadsheet-list .e-sheet").remove();
                document.getElementById($("#" + this._id + "ddl")) && $("#" + this._id + "ddl").data('ejDropDownList').destroy();
                $("#" + this._id + "ddl").remove();
                this._tableCnt = this._newSIndex = 1;
                if (this.XLChart)
                    this.XLChart._shapeCnt = 1;
                CalcEngine._tokenCount = 0;
                this._isVPRendered = false;
            }
            else {
                this._wireEvents("_off");
                this._destroySubControls();
                this.element.empty();
                this.element.css({ "height": "", "width": "", "min-height": "", "min-width": "" });
                this.element.prop("tabindex", false);
                this.element.removeEleEmptyAttrs();
                this._removeClass(this.element[0], "e-spreadsheet");
                document.getElementById(this._id + "_sshide") && document.getElementById(this._id + "_sshide").remove();
                $("#" + this._id + " _formatastable").parent().remove();
                $("#" + this._id + " _cellstyles").parent().remove();
                $("#" + this._id + "_Ribbon_Home_Font_BorderColor_popup").remove();
            }
			this._isRibbonDestroyed = true;
        },

        _destroySubControls: function () {
            var dlgs, id = this._id, ddl, ddlItem;
            //destroying dropdown list
            ddl = $("span.e-" + id + "-ddl input.e-dropdownlist");
            if (ddl.length)
                for (var i = 0, len = ddl.length; i < len; i++) {
                    ddlItem = $(ddl[i]).data("ejDropDownList")
                    if (ddlItem)
                        ddlItem.destroy();
                }
            if (this.model.allowFiltering) {
                var custddl = $(".e-" + this._id + "_customddl");
                custddl.length && custddl.ejDropDownList("destroy").remove();
                var strip = $("#" + this._id + "_filter_custom_string_acString"), numip = $("#" + this._id + "_filter_custom_number_acString"), dateip = $("#" + this._id + "_filter_custom_date_acString");
                strip.length && strip.ejAutocomplete("destroy").remove();
                numip.length && numip.ejNumericTextbox("destroy").remove();
                dateip.length && dateip.ejDatePicker("destroy").remove();
            }
            $("#" + this._id + "_colordlg_cpicker").ejColorPicker("destroy").remove();
            if (this.model.showRibbon) {
                this.XLRibbon._rbnDestroy({ destroy: true });
                document.getElementById(this._id + "_nmgrid") && $("#" + this._id + "_nmgrid").ejGrid("destroy");
                $(".e-" + this._id + "-spltbtn").ejSplitButton("destroy");
                $("#" + this._id + "_Ribbon").ejRibbon("destroy");
            }
            //Removing dialogs appended in body
            dlgs = $(".e-" + id + "-dlg");
            if (dlgs.length)
                dlgs.remove();
            if (this.model.allowFormulaBar)
                $("#" + this._id + "_inputbox").ejAutocomplete("destroy");
            $("#" + this._id + "_AutoComplete").ejAutocomplete("destroy");
            if (this.model.allowAutoFill)
                $("#" + this._id + "_dragfilloptionbtn").ejSplitButton("destroy")
            if (this.model.enableContextMenu) {
                $("#" + this._id + "_contextMenuCell").ejMenu("destroy").remove();
                $("#" + this._id + "_contextMenuColumnHeader").ejMenu("destroy").remove();
                $("#" + this._id + "_contextMenuRowHeader").ejMenu("destroy").remove();
                $("#" + this._id + "_contextMenuFooter").ejMenu("destroy").remove();
                $(".e-" + id + "-cmenu").remove();
            }
            if (this.model.allowFiltering) { //destroy filter
                this._excelFilter.resetExcelFilter();
                $("#" + this._id + "number_excelDlg").remove();
                $("#" + this._id + "string_excelDlg").remove();
                $("#" + this._id + "date_excelDlg").remove();
            }
            $("#" + this._id + "_copyPaste").remove();
            $("#" + this._id + "_wait").ejWaitingPopup("destroy");
            $("#" + this._id + "_wait").remove();
        },

        _getXYPos: function ($target, $element, diffHt, diffWt) {
            var elemTop = this.element.offset().top, elemLeft = this.element.offset().left, dlgHeight = $element.height(), dlgWidth = $element.width(), xPos = $target.offset().left - elemLeft, yPos = $target.offset().top - elemTop;
            if ((yPos + diffHt + dlgHeight) > this._responsiveHeight)
                yPos = yPos - ((yPos + diffHt + dlgHeight) - this._responsiveHeight) + (elemTop - 6); //6 for borders
            else
                yPos += elemTop;
            if (yPos < elemTop)
                yPos += elemTop - yPos;
            if ((xPos + diffWt + dlgWidth) > this._responsiveWidth)
                xPos = xPos - ((xPos + diffWt + dlgWidth) - this._responsiveWidth) + (elemLeft - 6); //6 for borders
            else
                xPos += elemLeft + diffWt;
            if (xPos < elemLeft)
                xPos += elemLeft - xPos;
            return { xPos: xPos, yPos: yPos };
        },

        getValueRowCol: function (sheetIdx, rowIdx, colIdx) {
            var sheetIdx = this._getSheetIdxFromSheetValue(this._getLocStr("Sheet") + sheetIdx), sheet = this.getSheet(sheetIdx);
            if (sheetIdx == -1)
                return "#REF!";
            if (sheet._isImported && !sheet._isRequested) {
                this._intrnlReq = true;
                this._importSheet(sheetIdx, false);
            }
            return this.XLEdit.getPropertyValue(rowIdx - 1, colIdx - 1, "value", sheetIdx);
        },

        setValueRowCol: function (sheetIdx, value, rowIdx, colIdx) {
            rowIdx--, colIdx--;
            if ((rowIdx === -2) && (colIdx === -2))
                return;
            var cellInfo, value2, cellIdx = { rowIndex: rowIdx, colIndex: colIdx }, skipCell = false, obj, args;
            if (typeof value === "string")
                value = value.replace(/^\"|\"$/g, "");
            sheetIdx = this._getSheetIdxFromSheetValue(this._getLocStr("Sheet") + sheetIdx);
            cellInfo = this.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx], property: ["value", "formatStr", "type", "thousandSeparator", "decimalPlaces"], sheetIdx: sheetIdx })[0];
            if (cellInfo.formatStr) {
                if (isNaN(parseInt(value)) && !isNaN(Date.parse(value)))
                    value = new Date(value);
                value2 = this.XLFormat._format(value, { formatStr: cellInfo.formatStr, type: cellInfo.type, thousandSeparator: cellInfo.thousandSeparator, decimalPlaces: cellInfo.decimalPlaces });
            }
            if (cellInfo.type == "fraction")
                value2 = this.XLFormat._format(value, { type: cellInfo.type });
            value2 = ej.isNullOrUndefined(value2) ? value : value2;
            if (this._isInitLoad && !this.isImport)
                skipCell = true;
            obj = { value2: value2, calcValue: this.XLEdit._parseValue(value, { rowIndex: rowIdx, colIndex: colIdx }).value };
            cellInfo.type && (obj.type = cellInfo.type);
            args = {
                isRefCells: true,
                calcValue: obj.calcValue,
                value: cellInfo.value,
                rowIndex: rowIdx,
                colIndex: colIdx
            };
            if (!this._isInitLoad && !this.isImport && (this.XLEdit._EditCellDetails.rowIndex !== rowIdx || this.XLEdit._EditCellDetails.columnIndex !== colIdx) && this._trigger("cellSave", args))
                return;
            this.XLEdit._updateDataContainer(cellIdx, { dataObj: obj, sheetIdx: sheetIdx, skipCell: skipCell });
            this.XLEdit._refreshCellAlignment({ cellIdx: cellIdx, value: value, type: cellInfo.type });
        },

        getActiveCellElem: function (sheetIdx) {
            sheetIdx = this._getSheetIndex(sheetIdx);
            var sheet = this.getSheet(sheetIdx);
            return this.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, sheetIdx);
        },

        //HyperLink 
        _hlDlgOpen: function () {
            var sheetIdx = this.getActiveSheetIndex(), selected = this.getActiveCellElem(sheetIdx), propValue;
            if (!selected.length || !this.model.allowEditing)
                return false;
            if (this.XLEdit._rangeHasProperty(this.getSheet(sheetIdx).selectedRange, "cellType")) {
                this._showAlertDlg("Alert", "CellTypeAlert", "CellTypeAlert", 372);
                return;
            }
            var xlId = this._id, hlTabObj, webAddrElem = $("#" + xlId + "_Ribbon_webAddress"), cellAddrElem = $("#" + xlId + "_Ribbon_cellAddress"), webValElem = $("#" + xlId + "_Ribbon_findText"), value;
            var data = this.XLEdit.getPropertyValue(selected.parent("tr").index(), selected[0].cellIndex, "hyperlink", sheetIdx), node, treeObj, cellValElem = $("#" + xlId + "_Ribbon_cellText");
            $("#" + xlId + "_HLDialog").ejDialog("open");
            (this._responsiveHeight < 365) && $("#" + this._id + "_HLDialog_wrapper").css('top', '0px');
            treeObj = $("#" + xlId + "_Ribbon_sheentName").data("ejTreeView");
            treeObj.option("fields", { dataSource: this.XLRibbon._sheetData() });
            hlTabObj = $("#" + xlId + "_HLDialogTab").data("ejTab");
            cellValElem.attr("disabled", false);
            webValElem.attr("disabled", false);
            if (!this.isUndefined(data)) {
                this.isUndefined(data.webAddr) ? hlTabObj.option({ selectedItemIndex: 1 }) : hlTabObj.option({ selectedItemIndex: 0 });
                if (!this.isUndefined(data.cellAddr)) {
                    cellAddrElem.val(data.cellAddr.split("_")[0]);
                    node = parseInt(data.cellAddr.split("_")[1]) + 1;
                    treeObj.selectNode(node);
                    webAddrElem.val("http://");
                }
                else {
                    webAddrElem.val(data.webAddr);
                    cellAddrElem.val("A1");
                }
            }
            else {
                if (hlTabObj.model.selectedItemIndex === 0) {
                    webAddrElem.val("http://");
                    cellValElem.val("");
                }
                else {
                    treeObj.selectNode(sheetIdx + 1);
                    cellValElem.val(treeObj.getText(sheetIdx + 1) + "!A1");
                    cellAddrElem.val("A1");
                }
            }
            if ($.validator) {
                $("#" + xlId + "_Form_Ribbon_cellAddress").validate().resetForm();
                $("#" + xlId + "_Form_Ribbon_webAddress").validate().resetForm();
            }
            webValElem.val("");
            value = this.XLEdit.getPropertyValueByElem(selected);
            if (!this.isUndefined(value)) {
			    propValue = this.XLEdit.getPropertyValueByElem(selected, "type");
                if (this.isFormula(value) || (propValue && propValue.indexOf("date") > -1) || $.isNumeric(value) || (propValue && propValue.indexOf("time") > -1)) {
                    cellValElem.val(this._getLocStr("HyperLinkHide"));
                    webValElem.val(this._getLocStr("HyperLinkHide"));
                    cellValElem.attr("disabled", true);
                    webValElem.attr("disabled", true);
                }
                else {
                    cellValElem.val(value);
                    webValElem.val(value);
                }
            }
        },


        _setLink: function (selCells) {
            var cellText, cellAddr, webText, webAddr, range, sheetIdx, treeObj, actShtIdx = this.getActiveSheetIndex(), linkAdr, value, cell = this.getActiveCell(actShtIdx), cellVal, tabIdx;
            range = this.getSheet(actShtIdx).selectedRange;
            !$("#" + this._id + "_HLDialog").length && this.XLRibbon._initHLDialog();
            tabIdx = $("#" + this._id + "_HLDialogTab").ejTab("option", "selectedItemIndex");
            cellText = $("#" + this._id + "_Ribbon_cellText").val();
            cellAddr = $("#" + this._id + "_Ribbon_cellAddress").val();
            webText = $("#" + this._id + "_Ribbon_findText").val();
            webAddr = $("#" + this._id + "_Ribbon_webAddress").val();
            treeObj = $("#" + this._id + "_Ribbon_sheentName").data("ejTreeView"), sheetIdx = this._getSheetIndexByName(treeObj.getSelectedNode().text() || this._getSheetNames()[this.getActiveSheetIndex() - 1].text);
            if (!cellText.length && !webText.length) {
                cellText = treeObj.getSelectedNode().text() + "!" + cellAddr;
                webText = webAddr;
            }
            cellVal = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex);
            this._prevText = ej.isNullOrUndefined(cellVal) ? "" : this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "value2");
            this._prevVal = ej.isNullOrUndefined(cellVal) ? "" : this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "value");
            if (this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "type") && (this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "type").indexOf("date") > -1 || this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "type").indexOf("time") > -1))
                value = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "value2");
            else if ($.isNumeric(cellVal) || this.isFormula(cellVal))
                value = cellVal;
            else
                value = (tabIdx === 0) ? webText : cellText;
            if (this._isUndoRedo)
                value = selCells[0].prevText;
            this.XLEdit._updateCellValue(cell, value);
            (this.isFormula(value) || $.isNumeric(value)) && (value = this.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "value2"));
            linkAdr = (tabIdx === 0) ? { webAddr: webAddr, text: value } : { cellAddr: cellAddr, text: value };
            this.setHyperlink(this._getAlphaRange(actShtIdx, range[0], range[1], range[2], range[3]), linkAdr, sheetIdx, selCells);
            this._dlgHLClick = false;
        },

        _getRangeArgs: function (range, type, sheetIdx) {
            if (ej.isNullOrUndefined(range))
                range = this.getSheet(sheetIdx).selectedRange;
            if (type === typeof (range))
                return range;
            else {
                if (typeof (range) === "object")
                    return this._getAlphaRange(this.getActiveSheetIndex(), range[0], range[1], range[2], range[3]);
                else
                    return this.getRangeIndices(range);
            }
        },

        setHyperlink: function (range, linkRefer, sheetIdx, selCells) {
            range = this._getRangeArgs(range, "string");
            if (this.model.allowHyperlink && !this.model.isReadOnly) {
                var args = {
                    range: range,
                    address: linkRefer.webAddr,
                    text: linkRefer.text,
                    sheetIndex: sheetIdx,
                    reqType: "hyperlink",
                    action: "add"
                };
                if (this.XLEdit._rangeHasProperty(range, "cellType")) {
                    this._showAlertDlg("Alert", "CellTypeAlert", "CellTypeAlert", 372);
                    return;
                }
                if (this._trigActionBegin(args))
                    return;
                range = args.range, linkRefer.webAddr = args.address, linkRefer.text = args.text, sheetIdx = args.sheetIndex;
                var cellText, cellAddr, evtArgs, webText, webAddr, isViewed, rng, selCellObj, actSheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(actSheetIdx), splitStr, value, selCell = [], data, val, i, len, selected = this._getAlphaRangeCells(range);
                var details = { sheetIndex: this.getActiveSheetIndex(), reqType: "hyperlink" }, cValue, cellVal;
                rng = this._getRangeArgs(range, "object");
                selCellObj = this._getSelectedCells(details.sheetIndex, rng).selCells;
                details.action = ej.isNullOrUndefined(this.XLEdit.getPropertyValue(selCellObj[0].rowIndex, selCellObj[0].colIndex, "hyperlink")) ? "add" : "edit";
                if (!this._isUndoRedo) {
                    if (!ej.isNullOrUndefined(linkRefer.webAddr)) {
                        webAddr = linkRefer.webAddr;
                        webText = !ej.isNullOrUndefined(linkRefer.text) ? linkRefer.text : this.XLEdit.getPropertyValue(selCellObj[0].rowIndex, selCellObj[0].colIndex, "value2");
                        value = ej.isNullOrUndefined(webText) ? webAddr : webText;
                    }
                    else {
                        cellAddr = linkRefer.cellAddr;
                        cellText = !ej.isNullOrUndefined(linkRefer.text) ? linkRefer.text : this.XLEdit.getPropertyValue(selCellObj[0].rowIndex, selCellObj[0].colIndex, "value2");
                        if (cellAddr.indexOf("!") > -1) {
                            splitStr = cellAddr.split("!");
                            sheetIdx = splitStr[0].indexOf("=") > -1 ? this._getSheetIndexByName(splitStr[0].split("=")[1]) : this._getSheetIndexByName(splitStr[0]);
                            cellAddr = splitStr[1];
                        }
                        cellAddr.indexOf("$") > -1 && (cellAdr = cellAddr.split("$").join(""));
                        value = ej.isNullOrUndefined(cellText) ? cellAddr : cellText;
                    }
                    if (!this._dlgHLClick) {
                        cellVal = this.XLEdit.getPropertyValue(selCellObj[0].rowIndex, selCellObj[0].colIndex, "value2");
                        this._prevText = ej.isNullOrUndefined(cellVal) ? "" : cellVal;
						this._prevVal = ej.isNullOrUndefined(cellVal) ? "" : this.XLEdit.getPropertyValue(selCellObj[0].rowIndex, selCellObj[0].colIndex, "value");
                        this.XLEdit._updateCellValue({ rowIndex: selCellObj[0].rowIndex, colIndex: selCellObj[0].colIndex }, value);
                    }
                    for (i = 0, len = selCellObj.length; i < len; i++)
                        selCell.push({ rowIndex: selCellObj[i].rowIndex, colIndex: selCellObj[i].colIndex, prevLink: this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink"), prevColor: this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "formats") });
                    !this.isUndefined(args.text) && this.XLEdit._updateCellValue(selCellObj[0], args.text);
                    (this.isUndefined(cellAddr)) ? this.updateUniqueData({ hyperlink: { "webAddr": webAddr } }, rng) : this.updateUniqueData({ hyperlink: { "cellAddr": cellAddr + "_" + (sheetIdx) } }, rng);
                    for (i = 0, len = selCellObj.length; i < len; i++) {
                        val = this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "value2");
                        selCell[i].prevText = (i === 0) ? this._prevText : val;
                        selCell[i].prevVal = (i === 0) ? this._prevVal : this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "value");
                        if (this._isRowViewable(actSheetIdx, selCellObj[i].rowIndex)) {
                            $(selected.eq(i).find("a")).remove();
                            this.XLEdit._refreshTextNode(selected[i]);
                            isViewed = true;
                        }
                        data = this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink", actSheetIdx);
                        if (data.cellAddr) {
                            val = (i === 0) ? cellText : val;
                            isViewed && selected.eq(i).append(ej.buildTag("a", val, ""));
                            selCell[i].curText = cellText;
                        }
                        else {
                            val = (i === 0) ? webText : val;
                            isViewed && selected.eq(i).append(ej.buildTag("a", val, "", { href: data.webAddr, target: "_blank" }));
                            selCell[i].curText = webText;
                        }
                        selCell[i].curLink = this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink");
                        if (isViewed)
                            $(selected[i]).find("a").addClass("e-hyperlinks");
                    }
                    this._dupDetails = true;
                    this.XLFormat.format({ "style": { "color": this._hlColor } }, range);
                    this._dupDetails = false;
                    details.selectedCell = selCell;
                    evtArgs = { sheetIndex: this.getActiveSheetIndex(), range: range, linkData: linkRefer, reqType: "hyperlink", selectedCell: details.selectedCell, action: details.action };
                    if (!sheet._isImported || sheet._isLoaded && !this._isExport) {
                        this._completeAction(details);
                        this._trigActionComplete(evtArgs)
                    }
                }
                else {
                    for (i = 0, len = selCellObj.length; i < len; i++) {
                        if (selCells && !ej.isNullOrUndefined(selCells[i]) && !ej.isNullOrUndefined(selCells[i].prevLink)) {
                            this.XLEdit._updateDataContainer({ rowIndex: selCellObj[i].rowIndex, colIndex: selCellObj[i].colIndex }, { dataObj: { "hyperlink": selCells[i].prevLink } });
                            if (this._isRowViewable(sheetIdx, selCellObj[i].rowIndex)) {
                                cValue = $(selected[i]).text();
                                $(selected[i]).find("a").remove();
                                (selected[i].lastChild) ? selected[i].lastChild.textContent = "" : $(selected[i]).text("");
                                if (i === 0) {
                                    if (!(ej.isNullOrUndefined(this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink").cellAddr)))
                                        $(selected[i]).append(ej.buildTag("a", selCells[i].prevText, ""));
                                    else
                                        $(selected[i]).append(ej.buildTag("a", selCells[i].prevText, "", { href: this.XLEdit.getPropertyValueByElem($(selected[i]), "hyperlink").webAddr, target: "_blank" }));
                                }
                                else {
                                    if (!(ej.isNullOrUndefined(this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink").cellAddr)))
                                        $(selected[i]).append(ej.buildTag("a", cValue, ""))
                                    else
                                        $(selected[i]).append(ej.buildTag("a", cValue, "", { href: this.XLEdit.getPropertyValueByElem($(selected[i]), "hyperlink").webAddr, target: "_blank" }));
                                }
                                $(selected[i]).find("a").addClass("e-hyperlinks");
                            }
                            this._dupDetails = true;
                            this.XLFormat.format({ style: { color: this._hlColor } });
                            this._dupDetails = false;
                        }
                    }
                }
            }
        },

        removeHyperlink: function (range, isClearHLink, status, cells, skipHiddenRow) {
            if (!this.model.allowHyperlink || this.model.isReadOnly)
                return false;
            var i, len, obj, color, rLink = [], temp = this._dupDetails, selCellObj, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), selCell = [], cell;
            var details = { sheetIndex: sheetIdx, reqType: "hyperlink", action: "delete", range: range };
            selCellObj = this._getMultiRangeCells(range);
            for (i = 0, len = selCellObj.length; i < len; i++) {
                if (!skipHiddenRow || !this._isHiddenRow(selCellObj[i].rowIndex)) {
                    obj = { rowIndex: selCellObj[i].rowIndex, colIndex: selCellObj[i].colIndex, prevLink: this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink"), prevText: this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "value2"), prevVal: this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "value"), prevColor: this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "formats") };
                    this._dupDetails = true;
                    if (obj.prevLink) {
                        if (isClearHLink)
                            this.XLFormat.format({ style: { "text-decoration": "underline" } }, this._getAlphaRange(sheetIdx, selCellObj[i].rowIndex, selCellObj[i].colIndex, selCellObj[i].rowIndex, selCellObj[i].colIndex));
                        else {
                            if (!ej.isNullOrUndefined(cells) && !this.isUndefined(cells[i].prevColor))
                                color = cells[i].prevColor.color;
                            this.XLFormat.format({ style: { color: this.isUndefined(color) ? "#444445" : color, "text-decoration": "none" } }, this._getAlphaRange(sheetIdx, selCellObj[i].rowIndex, selCellObj[i].colIndex, selCellObj[i].rowIndex, selCellObj[i].colIndex));
                        }
                        obj.curColor = this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "formats");
                    }
                    this._dupDetails = temp;
                    this.clearRangeData([selCellObj[i].rowIndex, selCellObj[i].colIndex, selCellObj[i].rowIndex, selCellObj[i].colIndex], ["hyperlink"]);
                    !this._isUndoRedo && (obj.curLink = this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "hyperlink"));
                    if (this._isUndoRedo && !this._dupDetails)
                        !ej.isNullOrUndefined(cells[i].prevText) && this.XLEdit._updateDataContainer({ rowIndex: selCellObj[i].rowIndex, colIndex: selCellObj[i].colIndex }, { dataObj: { "value2": cells[i].prevText, "value": cells[i].prevVal }, sheetIdx: sheetIdx });
                    !this._isUndoRedo && (obj.curText = this.XLEdit.getPropertyValue(selCellObj[i].rowIndex, selCellObj[i].colIndex, "value2"));
                    if ((this._isUndoRedo && !this._dupDetails) && !ej.isNullOrUndefined(cells[i].prevLink)) {
                        this.XLEdit._updateDataContainer({ rowIndex: selCellObj[i].rowIndex, colIndex: selCellObj[i].colIndex }, { dataObj: { "hyperlink": cells[i].prevLink } });
                        cell = { rowIndex: cells[i].rowIndex, colIndex: cells[i].colIndex };
                        this.XLSelection.selectRange(cell, cell);
                        this._setLink([cells[i]]);
                        rLink.push(i);
                    }
                    selCell.push(obj);
                }
            }
            for (i = 0, len = rLink.length; i < len; i++)
                selCellObj.splice(rLink[i], 1);
            details.selectedCell = selCell;
            details.reqType = (ej.isNullOrUndefined(status)) ? "hyperlink" : "clear-link";
            if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo && !this._dupDetails && !this._isExport) {
                this._completeAction(details);
                this._trigActionComplete(details);
            }
        },

        _removeHyperlink: function (status, cells, skipHiddenRow, range) {
            var sheetIdx = this.getActiveSheetIndex(), range = range ? range : this.getSheet(sheetIdx).selectedRange;
            this.removeHyperlink(this._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]), status === "clear", status, cells, skipHiddenRow);
        },

        _openLink: function () {
            var sheetIdx = this.getActiveSheetIndex(), selected = this.getSheetElement(sheetIdx).find(".e-activecell");
            this._hlClick(this.XLEdit.getPropertyValue(selected.closest("tr").index(), selected[0].cellIndex, "hyperlink", sheetIdx));
        },

        _hlClick: function (data) {
            var range, sheetIdx, startCell, endCell, urlregex, actSheetIdx = this.getActiveSheetIndex(), alertText, alertMsg = this._getLocStr("HyperLinkAlert").split("-"), value, splitStr;
            var sheet = this.getSheet(actSheetIdx);
            this.model.enableContextMenu && this.XLCMenu.hideCMenu();
            if (data.cellAddr) {
                splitStr = data.cellAddr.split("_");
                if (splitStr[0].indexOf("$") > -1)
                    value = splitStr[0].split("$").join("");
                else
                    value = splitStr[0];
                range = this.getRangeIndices(value);
                startCell = { rowIndex: range[0], colIndex: range[1] };
                endCell = { rowIndex: range[2], colIndex: range[3] };
                sheetIdx = Number(splitStr[1]);
                this.gotoPage(sheetIdx, false);
                sheet._activeCell = startCell;
                this.XLSelection.selectRange(startCell, endCell, sheetIdx);
                sheet._startCell = startCell;
                sheet._endCell = endCell;
                this.XLScroll._scrollSelectedPosition(sheetIdx, startCell);
                this.model.allowAutoFill && this.XLDragFill.positionAutoFillElement();

            }
            else {
                startCell = { rowIndex: sheet._activeCell.rowIndex, colIndex: sheet._activeCell.colIndex };
                sheet._startCell = startCell;
                sheet._endCell = startCell;
                if (this._isValidUrl(data.webAddr))
                    window.open(data.webAddr, "_blank");
                else
                    this._showAlertDlg("Alert", "HyperLinkAlert");
            }
        },

        _isValidUrl: function (url) {
            return /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/.test(url);
        },

        showWaitingPopUp: function () {
            $("#" + this._id + "_wait").data("ejWaitingPopup").show();
        },

        hideWaitingPopUp: function () {
            $("#" + this._id + "_wait").data("ejWaitingPopup").hide();
        },

        _getSelRange: function (selCells) {
            var sCell, eCell, sheetIdx = this.getActiveSheetIndex();
            sCell = selCells[0], eCell = selCells[selCells.length - 1];
            return (this._generateHeaderText(sCell.colIndex + 1) + (sCell.rowIndex + 1) + ":" + this._generateHeaderText(eCell.colIndex + 1) + (eCell.rowIndex + 1));
        },

        _getSelectedCells: function (sheetIdx, range) {
            var selCells, rng, sheet = this.getSheet(sheetIdx ? sheetIdx : this.getActiveSheetIndex());
            if (ej.isNullOrUndefined(range)) {
                selCells = sheet._selectedCells;
                if (selCells.length > 0) {
                    range = this._getSelRange(selCells);
                    rng = this.getRangeIndices(range);
                }
                else {
                    rng = [0, 0, 0, 0];
                    selCells = [{ rowIndex: 0, colIndex: 0 }];
                }
            }
            else {
                rng = this._getRangeArgs(range, "object");
                selCells = this._getSelectedRange({ rowIndex: rng[0], colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });
            }
            return { range: rng, selCells: selCells };
        },

        _getHiddenCells: function (sheetIdx, altCells, selectedCell, hideCells) {
            var container = this._dataContainer.sheets[sheetIdx], value, wrap, wrapRow;
            (ej.isNullOrUndefined(hideCells[selectedCell.rowIndex])) && (hideCells[selectedCell.rowIndex] = {});
            (ej.isNullOrUndefined(hideCells[selectedCell.rowIndex][selectedCell.colIndex])) && (hideCells[selectedCell.rowIndex][selectedCell.colIndex] = { value: {}, text: "" });
            if (!ej.isNullOrUndefined(container[selectedCell.rowIndex])) {
                hideCells[selectedCell.rowIndex][selectedCell.colIndex]["value"] = $.extend(true, {}, container[selectedCell.rowIndex][selectedCell.colIndex]);
                value = this.XLEdit.getPropertyValue(altCells.rowIndex, altCells.colIndex, "value2", sheetIdx);
				wrap = this.XLEdit.getPropertyValue(altCells.rowIndex, altCells.colIndex, "wrap", sheetIdx);
				wrapRow = this.XLEdit.getPropertyValue(altCells.rowIndex, altCells.colIndex, "wrapRow", sheetIdx);
                delete container[selectedCell.rowIndex][selectedCell.colIndex];
                hideCells[selectedCell.rowIndex][selectedCell.colIndex]["text"] = (ej.isNullOrUndefined(value) ? "" : value); //Checking for empty td cell
				if(wrap || wrapRow){
					if(ej.isNullOrUndefined(container[selectedCell.rowIndex]))
						container[selectedCell.rowIndex] = {};
					if(ej.isNullOrUndefined(container[selectedCell.rowIndex][selectedCell.colIndex]))
						container[selectedCell.rowIndex][selectedCell.colIndex] = {};
					wrap && (container[selectedCell.rowIndex][selectedCell.colIndex]["wrap"] = wrap);
					wrapRow && (container[selectedCell.rowIndex][selectedCell.colIndex]["wrapRow"] = wrapRow);
				}
            }
            if (this._isRowViewable(sheetIdx, altCells.rowIndex))
                altCells = this.getCell(altCells.rowIndex, altCells.colIndex, sheetIdx).empty();
            return hideCells;
        },

        _getRowSpan: function (sheetIdx, selectedCells) {
            var rowSpan = 0, isVscroll = this.model.scrollSettings.allowVirtualScrolling;
            for (var i = selectedCells[0].rowIndex, len = selectedCells[selectedCells.length - 1].rowIndex; i <= len; i++) {
                if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(i, 0, "isRHide", sheetIdx)) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(i, 0, "isFHide", sheetIdx)) && ej.isNullOrUndefined(this.XLEdit.getPropertyValue(i, 0, "isFilterHide", sheetIdx)) && this.getSheet(sheetIdx)._fHMergeRows.indexOf(i) === -1)
                    rowSpan = rowSpan + 1;
            }
            return rowSpan;
        },

        _getColSpan: function (sheetIdx, selectedCells) {
            var colSpan = 0, isVscroll = this.model.scrollSettings.allowVirtualScrolling, colgrp;
            !isVscroll && (colgrp = this._getJSSheetHeader(sheetIdx).find("col"))
            for (var i = selectedCells[0].colIndex, len = selectedCells[selectedCells.length - 1].colIndex; i <= len; i++) {
                if (ej.isNullOrUndefined(this.XLEdit.getPropertyValue(0, i, "isCHide", sheetIdx)) && this.getSheet(sheetIdx)._fHMergeCols.indexOf(i.toString()) === -1)
                    colSpan = colSpan + 1;
            }
            return colSpan;
        },

        _getHiddenRowColumnCount: function (sheetIdx, range) {
            var rng = this.getRangeIndices(range), hr = 0, hc = 0, i, j, isVscroll = this.model.scrollSettings.allowVirtualScrolling, colgrp;
            !isVscroll && (colgrp = this._getJSSheetHeader(sheetIdx).find("col"))
            for (i = rng[0]; i <= rng[2]; i++) {
                if (!ej.isNullOrUndefined(this.XLEdit.getPropertyValue(i, 0, "isRHide", sheetIdx)) || !ej.isNullOrUndefined(this.XLEdit.getPropertyValue(i, 0, "isFHide", sheetIdx)))
                    hr = hr + 1;
            }
            for (j = rng[1]; j <= rng[3]; j++) {
                if ((isVscroll || (!isVscroll && this._hasClass(colgrp[j], "e-hide"))) || !ej.isNullOrUndefined(this.XLEdit.getPropertyValue(0, j, "isCHide", sheetIdx)))
                    hc = hc + 1;
            }
            return { hRow: hr, hCol: hc };
        },

         _updateMergeColl: function (sheetIdx, rowIdx, colIdx, type, isSamePosn, range, isCenterAlign, mType) {
            var sheet = this.getSheet(sheetIdx), mergeColl = sheet._mergeColl;
            if (ej.isNullOrUndefined(mergeColl[rowIdx])) {
                mergeColl[rowIdx] = {};
                mergeColl[rowIdx][colIdx] = {};
            }
            else if (ej.isNullOrUndefined(mergeColl[rowIdx][colIdx])) 
                mergeColl[rowIdx][colIdx] = {};
            mergeColl[rowIdx][colIdx]["type"] = type;
			mType && (mergeColl[rowIdx][colIdx]["mergeType"] = mType);
            isSamePosn && (mergeColl[rowIdx][colIdx]["isSamePosn"] = isSamePosn);
            sheet.mergedCells.push({ isCenterAlign: isCenterAlign, range: range });
        },

        mergeCells: function (range, alertStatus) {
            if (this.model.isReadOnly)
                return;
            var i, mergeObj, details, rSpan = 1, cSpan = 1, len, cells = [], sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), alertdlg = $("#" + this._id + "_alertdlg"), selectedCells, isMerged = false, actCell, hiddenCount,
            rng = this._getRangeArgs(range, "object", sheetIdx), isMultiCell = (rng[2] - rng[0]) || (rng[3] - rng[1])
            if (!this.model.allowMerging || (!this.model.allowSelection && !isMultiCell) || this.getSheetElement(sheetIdx).find(".e-ss-activeimg").length > 0 || this.model.isReadOnly)
                return;
            selectedCells = this._getSelectedCells(sheetIdx, rng).selCells;
            this._selMergeCells = [];
            this._mergeType = "merge-cells";
            if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo) {
                this.performSelection(rng);
                if (this.mergeCenter) {
                    isMerged = false;
                    for (i = 0, len = selectedCells.length; i < len; i++) {
                        mergeObj = this.XLEdit.getPropertyValue(selectedCells[i].rowIndex, selectedCells[i].colIndex, "merge", sheetIdx);
                        if (!ej.isNullOrUndefined(mergeObj)) {
                            rSpan = mergeObj.mSpan.rowSpan;
                            cSpan = mergeObj.mSpan.colSpan;
                            if (rSpan > 1 || cSpan > 1) {
                                hiddenCount = this._getHiddenRowColumnCount(sheetIdx, this.XLEdit.getPropertyValue(selectedCells[i].rowIndex, selectedCells[i].colIndex, 'merge').mRange);
                                this._unMergeAllCells(sheetIdx, i, selectedCells, cells, hiddenCount.hRow, hiddenCount.hCol);
                                isMerged = true;
                            }
                        }
                    }
                    if (isMerged && !this._dupDetails && !this._isUndoRedo) {
                        ej.isNullOrUndefined(range) && (range = this._getSelRange(selectedCells));
                        details = { sheetIndex: sheetIdx, cells: selectedCells, range: range, reqType: "merge-cells", action: "un-merge", operation: "un-merge", mCells: cells };
                        this._completeAction(details);
                        this._trigActionComplete(details);
                    }
                    this.performSelection(rng);
                }
                else {
                    for (i = 0, len = selectedCells.length; i < len; i++) {
                        mergeObj = this.XLEdit.getPropertyValue(selectedCells[i].rowIndex, selectedCells[i].colIndex, "merge", sheetIdx);
                        if (!ej.isNullOrUndefined(mergeObj)) {
                            rSpan = mergeObj.mSpan.rowSpan;
                            cSpan = mergeObj.mSpan.colSpan;
                        }
                        if (rSpan === 1 && cSpan === 1) {
                            isMerged = false;
                            break;
                        }
                    }
                }
            }
            if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo && this._rangeHasData(rng) && !alertStatus && !isMerged && isMultiCell)
                this._showAlertDlg("", "MergeCellsAlert", "MergeCells", 498);
            else if (!isMerged)
                this._mergeCells(sheetIdx, selectedCells, {}, []);
            if (this.model.showRibbon)
                this.XLRibbon._updateRibbonIcons();
        },

        _mergeCells: function (sheetIdx, selectedCells, hideCells, mCells) {
            var mSpan, tRIdx, xCellsHght = 0, container = this._dataContainer.sheets[sheetIdx], details, range, startrowIdx, startcolIdx, prevObj = {},
                activeCell, altCells, cols, sheet = this.getSheet(sheetIdx), xlEdit = this.XLEdit, rHgt, colWtColl = sheet.columnsWidthCollection, mergewrap;
            tRIdx = startrowIdx = selectedCells[0].rowIndex; startcolIdx = selectedCells[0].colIndex;
            !this.model.scrollSettings.allowVirtualScrolling && (cols = this._getJSSheetHeader(sheetIdx).find('col'));
            if ((ej.isNullOrUndefined(xlEdit.getPropertyValue(startrowIdx, 0, "isFRHide")) || ej.isNullOrUndefined(xlEdit.getPropertyValue(startrowIdx, 0, "isRHide"))) && (cols && cols.eq(startcolIdx).hasClass("e-fc-hide")))
                return { hideCell: [], mCells: [] };
            mSpan = { rowSpan: this._getRowSpan(sheetIdx, selectedCells), colSpan: this._getColSpan(sheetIdx, selectedCells) };
            if (!ej.isNullOrUndefined(container[startrowIdx]) && !ej.isNullOrUndefined(container[startrowIdx][startcolIdx])) {
                delete container[startrowIdx][startcolIdx]["isMHide"];
                delete container[startrowIdx][startcolIdx]["mergeIdx"];
            }
            if (this._isRowViewable(sheetIdx, startrowIdx)) {
                activeCell = this.getCell(startrowIdx, startcolIdx);
                activeCell[0].colSpan = mSpan.colSpan;
                activeCell[0].rowSpan = mSpan.rowSpan;
                activeCell[0].className = activeCell[0].className.replace("e-mc-hide", "");
                this.mergeCenter && activeCell.addClass("e-calign ");
                if (activeCell.hasClass("e-commentcell"))
                    this.model.allowComments && this.XLComment._updateCmntArrowPos(activeCell);
            }
            this._selMergeCells.push(selectedCells[0]);
            this._textClip(selectedCells[0].rowIndex, selectedCells[0].colIndex, 'add');
            this._textClip(selectedCells[0].rowIndex, selectedCells[0].colIndex, 'delete', '', true);
            if (this._isRowViewable(sheetIdx, selectedCells[0].rowIndex))
                this.addClass(this.getCell(selectedCells[0].rowIndex, selectedCells[0].colIndex)[0], "e-moverflow");
            xCellsHght = this._getRowHeight(selectedCells[0].rowIndex, sheetIdx);
            for (var i = 1, len = selectedCells.length; i < len; i++) {
                if (this._isRowViewable(sheetIdx, selectedCells[i].rowIndex)) {
                    altCells = this.getCell(selectedCells[i].rowIndex, selectedCells[i].colIndex);
                    if (!this._hasClass(altCells[0], "e-mc-hide"))
                        this.addClass(altCells[0], "e-mc-hide");
                    this.addClass(altCells[0], "e-moverflow");
                }
                if ((tRIdx !== selectedCells[i].rowIndex) && sheet.hideRowsCollection.indexOf(selectedCells[i].rowIndex) == -1) {
                    xCellsHght += this._getRowHeight(selectedCells[i].rowIndex, sheetIdx);
                    tRIdx = selectedCells[i].rowIndex;
                }
                this._textClip(selectedCells[i].rowIndex, selectedCells[i].colIndex, 'add');
                this._textClip(selectedCells[i].rowIndex, selectedCells[i].colIndex, 'delete', '', true);
                hideCells = this._getHiddenCells(sheetIdx, { rowIndex: selectedCells[i].rowIndex, colIndex: selectedCells[i].colIndex }, selectedCells[i], hideCells);
                this.XLEdit._updateDataContainer({ rowIndex: selectedCells[i].rowIndex, colIndex: selectedCells[i].colIndex }, { dataObj: { isMHide: true, mergeIdx: { rowIndex: startrowIdx, colIndex: startcolIdx } }, sheetIdx: sheetIdx });
                this._selMergeCells.push(selectedCells[i]);
            }
            if (!ej.isNullOrUndefined(container[startrowIdx]))
                $.extend(true, prevObj, container[startrowIdx][startcolIdx]);
            range = this._getSelRange(selectedCells);
            sheet._activeCell = selectedCells[0];
            if (!sheet._isImported || sheet._isLoaded)
                this.performSelection(selectedCells[0], selectedCells[selectedCells.length - 1]);
            this.XLEdit._updateDataContainer({ rowIndex: startrowIdx, colIndex: startcolIdx }, { dataObj: { merge: { mSpan: mSpan, isMerge: true, mRange: range, isCenterAlign: this.mergeCenter } } }); // mRange denones Merged Range
            this._updateMergeColl(sheetIdx, startrowIdx, startcolIdx, this.mergeCenter ? "center" : "merge",null, range, this.mergeCenter, this._mergeType);
            mCells.push({ rowIndex: startrowIdx, colIndex: startcolIdx, prevObj: prevObj, curObj: $.extend(true, {}, container[startrowIdx][startcolIdx]) });
            if (xlEdit.getPropertyValue(startrowIdx, startcolIdx, "wrap")) {
                rHgt = this._getWrapCellHeight(sheetIdx, startrowIdx, startcolIdx).rowHt;
                if (this._getRowHeight(startrowIdx, sheetIdx) <= rHgt || sheet._isImported || !sheet._isLoaded)
                    this.setHeightToRows([{ rowIndex: startrowIdx, height: rHgt }]);
            }
            if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo && !this._dupDetails && !this._paste && this._mergeType === "merge-cells") {
                details = { sheetIndex: sheetIdx, cells: [{ rowIndex: startrowIdx, colIndex: startcolIdx }], range: range, reqType: "merge-cells", action: "merge-all", hideCells: hideCells, mCells: mCells };
                details.operation = (this.mergeCenter) ? "merge-center" : "merge-all";
                if(!this._paste) {
                    this._completeAction(details);
                    this._trigActionComplete(details);
                }
            }
            if (this.model.showRibbon)
                this.XLRibbon._updateRibbonIcons();
            this.mergeCenter = false;
            this._paste = false;
            this.XLEdit._updateUsedRange(startrowIdx + mSpan.rowSpan, startcolIdx + mSpan.colSpan, sheetIdx);
            return { hideCells: hideCells, mCells: mCells };
        },

        mergeAcrossCells: function (range, alertStatus) {
            if (this.model.isReadOnly)
                return;
            var sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), alertdlg = $("#" + this._id + "_alertdlg"), selRange, 
            rng = this._getRangeArgs(range, "object", sheetIdx), isMultiCell = (rng[2] - rng[0]) || (rng[3] - rng[1]), isMultiCol = rng[3] - rng[1];
            if (!this.model.allowMerging || this.getSheetElement(sheetIdx).find(".e-ss-activeimg").length > 0 || !isMultiCell || this.model.isReadOnly)
                return;
            this._selMergeCells = [];
            selRange = this._getSelectedCells(sheetIdx, rng);
            !this.isUndefined(range) && this.performSelection(rng);
            if (!this._isUndoRedo && this._rangeHasData(rng) && (!sheet._isImported || sheet._isLoaded) && !alertStatus && isMultiCol)
                this._showAlertDlg("", "MergeCellsAlert", "MergeAcrossCells", 498);
            else if (isMultiCol)
                this._mergeAcrossCells(sheetIdx, selRange.selCells);
            this.performSelection(rng);
            this.model.showRibbon && this.XLRibbon._updateRibbonIcons();
        },

        _mergeAcrossCells: function (sheetIdx, selectedCells) {
            var i, j, len, mergeObj, rSpan = 1, cSpan = 1, isMerged = true, details, sCol, eCol, sRow, eRow, selCell = [],
                mValue = { mCells: [], hideCells: {} }, sheet = this.getSheet(sheetIdx);
            this._mergeType = "merge-across";
            for (i = 0, len = selectedCells.length; i < len ; i++) {
                mergeObj = this.XLEdit.getPropertyValue(selectedCells[i].rowIndex, selectedCells[i].colIndex, "merge", sheetIdx);
                if (!ej.isNullOrUndefined(mergeObj)) {
                    rSpan = mergeObj.mSpan.rowSpan;
                    cSpan = mergeObj.mSpan.colSpan;
                }
                if (rSpan === 1 && cSpan === 1) {
                    isMerged = false;
                    break;
                }
                else if (rSpan > 1)
                    isMerged = false;
            }
            if (!isMerged) {
                sRow = selectedCells[0].rowIndex, eRow = selectedCells[selectedCells.length - 1].rowIndex;
                sCol = selectedCells[0].colIndex, eCol = selectedCells[selectedCells.length - 1].colIndex;
                for (i = sRow; i <= eRow; i++) {
                    selCell = [];
                    for (j = sCol; j <= eCol; j++)
                        selCell.push({ rowIndex: i, colIndex: j });
                    mValue = this._mergeCells(sheetIdx, selCell, mValue.hideCells, mValue.mCells);
                }
            }
            if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo && !this._dupDetails) {
                details = { sheetIndex: sheetIdx, cells: $.extend(true, [], this._selMergeCells), range: this._getSelRange(this._selMergeCells), reqType: "merge-cells", action: "merge-across", operation: "merge-across", hideCells: mValue.hideCells, mCells: mValue.mCells };
                if (!this._paste) {
                    this._completeAction(details);
                    this._trigActionComplete(details);
                }
                this._paste = false;
            }
			this._mergeType = "merge-cells";
            this.performSelection(selectedCells[0], selectedCells[selectedCells.length - 1]);
        },

        unmergeCells: function (range) {
            if (this.model.isReadOnly)
                return;
            var sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), cells = [], selectedCells, details, hiddenCount, mergeObj, clrMerge = sheet._clrMergeColl,
                rng = this._getRangeArgs(range, "object", sheetIdx);
            if (!this.model.allowMerging || this.getSheetElement(sheetIdx).find(".e-ss-activeimg").length > 0 || this.model.isReadOnly)
                return;
            this._selMergeCells = [];
            selectedCells = this._getSelectedCells(sheetIdx, rng).selCells;
            for (var k = 0, len = selectedCells.length; k < len; k++) {
                mergeObj = this.XLEdit.getPropertyValue(selectedCells[k].rowIndex, selectedCells[k].colIndex, "merge", sheetIdx);
                if (!this.isUndefined(mergeObj)) {
                    hiddenCount = this._getHiddenRowColumnCount(sheetIdx, mergeObj.mRange);
                    cells = this._unMergeAllCells(sheetIdx, k, selectedCells, cells, hiddenCount.hRow, hiddenCount.hCol);
                    clrMerge.push({ rowIdx: selectedCells[k].rowIndex, colIdx: selectedCells[k].colIndex, mergeObj: mergeObj });
                }
            }
            ej.isNullOrUndefined(range) && (range = this._getSelRange(selectedCells));
            this.performSelection(rng);
            if ((!sheet._isImported || sheet._isLoaded) && !this._isUndoRedo && !this._dupDetails && !this._isExport) {
                details = { sheetIndex: sheetIdx, cells: selectedCells, range: range, reqType: "merge-cells", action: "un-merge", operation: "un-merge", mCells: cells };
                this._completeAction(details);
                this._trigActionComplete(details);
            }
            if (this.model.showRibbon)
                this.XLRibbon._updateRibbonIcons();
        },
 
        _unMergeAllCells: function (sheetIdx, rowIdx, selectedCells, cells, hr, hc) {
            var i, j, hr, hc, mergeObj, mergeWrap, mergeIdx, rSpan = 1, cSpan = 1, mSpanObj, isViewable = false, container = this._dataContainer.sheets[sheetIdx], prevObj = {},
                activeCell, overflow, cell, startrowIdx, startcolIdx, rowhdrrows, mCells, mergeContainer, sheet = this.getSheet(sheetIdx), aCellHgt, isWrap; // mCells denotes merged cells
            startrowIdx = selectedCells[rowIdx].rowIndex; startcolIdx = selectedCells[rowIdx].colIndex, rowhdrrows = this.getRows(sheetIdx)[0];
            activeCell = this.getCell(startrowIdx, startcolIdx);
            mergeObj = this.XLEdit.getPropertyValue(startrowIdx, startcolIdx, "merge", sheetIdx);
            if (!ej.isNullOrUndefined(mergeObj)) {
                rSpan = mergeObj.mSpan.rowSpan;
                cSpan = mergeObj.mSpan.colSpan;
            }
            if (cSpan > 1 || rSpan > 1) {
                mergeContainer = container[startrowIdx][startcolIdx];
                $.extend(true, prevObj, mergeContainer);
				delete mergeContainer["merge"];
				this._clearMergeColl(sheet._mergeColl, startrowIdx, startcolIdx);
                if (this._isRowViewable(sheetIdx, startrowIdx)) {
                    activeCell = this.getCell(startrowIdx, startcolIdx);
                    if (this.XLEdit.getPropertyValue(startrowIdx, startcolIdx, "wrap", sheetIdx) && !this.XLEdit.getPropertyValue(startrowIdx, startcolIdx, "cellType", sheetIdx)) {
                        mergeWrap = activeCell.find('#' + this._id + '_MergeWrap');
                        if (mergeWrap.length) {
                            activeCell[0].innerHTML = mergeWrap[0].innerHTML;
                            mergeWrap.remove();
                        }
                    }
                    if (!ej.isNullOrUndefined(mergeObj.isCenterAlign))
                        activeCell.removeClass("e-calign");
                    activeCell[0].colSpan = activeCell[0].rowSpan = 1;
                    aCellHgt = activeCell[0].offsetHeight;
                    if ($(rowhdrrows[startrowIdx]).height() < aCellHgt) {
                        if (this.XLEdit.getPropertyValue(startrowIdx, startcolIdx, "wrap"))
                            this.setHeightToRows([{ rowIndex: startrowIdx, height: aCellHgt }]);
                    }
                    this.XLScroll._getRowHeights(sheetIdx, startrowIdx);
                }
                cells.push({ rowIndex: startrowIdx, colIndex: startcolIdx, prevObj: prevObj, curObj: $.extend(true, {}, container[startrowIdx][startcolIdx]) });
                mCells = [];
                for (i = startrowIdx ; i < (startrowIdx + rSpan + hr) ; i++) {
                    for (j = startcolIdx ; j < (startcolIdx + cSpan + hc) ; j++) {
                        this._selMergeCells.push({ rowIndex: i, colIndex: j });
                        if (this._isRowViewable(sheetIdx, i)) {
                            cell = this.getCell(i, j, sheetIdx);
                            isViewable = true;
                        }
                        if (!ej.isNullOrUndefined(this.XLEdit.getPropertyValue(i, j, "isMHide", sheetIdx))) {
                            if (this._isUndoRedo) {
                                mSpanObj = this.XLEdit.getPropertyValue(i, j, "merge", sheetIdx);
                                if (!ej.isNullOrUndefined(mSpanObj)) {
                                    if (mSpanObj.mergeSpan.rowSpan > 1 || mSpanObj.mergeSpan.colSpan > 1) {
                                        mCells.push({ rowIndex: i, colIndex: j, rowSpan: mSpanObj.mergeSpan.rowSpan, colSpan: mSpanObj.mergeSpan.colSpan });
                                        container[i][j].merge.mSpan = { rowSpan: 1, colSpan: 1 };
                                        cell[0].rowSpan = 1; cell[0].colSpan = 1;
                                    }
                                }
                            }
                            mergeIdx = this.XLEdit.getPropertyValue(i, j, "mergeIdx", sheetIdx);
                            if (!ej.isNullOrUndefined(mergeIdx))
                                if (mergeIdx.rowIndex === startrowIdx && mergeIdx.colIndex === startcolIdx) {
                                    if (isViewable) {
                                        cell.removeClass("e-mc-hide");
                                        cell[0].rowSpan = 1; cell[0].colSpan = 1;
                                    }
                                    delete container[i][j]["isMHide"];
                                    delete container[i][j]["mergeIdx"];
                                }
                        }
                        if (this._isUndoRedo && !ej.isNullOrUndefined(this._delCells)) {
                            if (!ej.isNullOrUndefined(this._delCells[i]) && !ej.isNullOrUndefined(this._delCells[i][j])) {
                                if (!ej.isNullOrUndefined(container[i])) {
                                    overflow = !ej.isNullOrUndefined(container[i][j]) && container[i][j]['overflow'];
                                    container[i][j] = this._delCells[i][j]['value'];
                                    (overflow) && (container[i][j]['overflow'] = overflow);
                                    isViewable && cell.text(this._delCells[i][j]["text"]);
                                    mergeObj = this.XLEdit.getPropertyValue(i, j, "merge");
                                    if (!ej.isNullOrUndefined(mergeObj) && mergeObj.isMerge)
                                        this.mergeCells(mergeObj.mRange, true);
                                }
                            }
                        }
                        if (isViewable && cell.hasClass("e-commentcell"))
                            this.model.allowComments && this.XLComment._updateCmntArrowPos(cell);
                        if (isViewable) {
                            this._removeClass(cell[0], "e-moverflow");
                            if (cell.text().length > 0)
                                this._textClip(i, j, 'add');
                            else
                                this._textClip(i, j, 'delete');
                        }
                        if (!ej.isNullOrUndefined(container[i])) {
                            if (this.getObjectLength(container[i][j]) < 1)
                                delete container[i][j];
                            if (this.getObjectLength(container[i]) < 1)
                                delete container[i];
                        }
                    }
                }
            }
            return cells;
        },

        _refreshMergeCells: function() {
            this._dupDetails = true;
            var mCells = this._removeMergeColl;
            for (var i = 0, len = mCells.length; i < len; i++)
                this.unmergeCells(mCells[i].merge.mRange, true);
            this._dupDetails = false;
            var data = this._insData;
            switch (data.value.status) {
                case "shiftRight":
                    this._insertShiftRight(data.sheetIdx, data.startCell, data.endCell, data.value);
                    break;
                case "shiftBottom":
                    this._insertShiftBottom(data.sheetIdx, data.startCell, data.endCell, data.value);
                    break;
                case "shiftUp":
                    this._deleteShiftUp(data.sheetIdx, data.startCell, data.endCell, data.value);
                    break;
                case "shiftLeft":
                    this._deleteShiftLeft(data.sheetIdx, data.startCell, data.endCell, data.value);
                    break;
            }
        },

        _showHeadings: function (status, sheetIdx) {
            if (this.model.isReadOnly)
                return;
            var checkObj, sheetIdx = sheetIdx ? sheetIdx : this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), shdr = this._getJSSheetHeader(sheetIdx),
                cont = this._getContent(sheetIdx).find('.e-content'), rhdr = this._getJSSheetRowHeader(sheetIdx), fRowIdx = this.getFrozenRows(), fColIdx = this.getFrozenColumns();
            sheet.showHeadings = status;
            this._isDisplayHeader = true;
            if (sheet.showHeadings) {
                rhdr.show();
                shdr.show();
                cont.removeClass('e-viewbrdr');
            }
            else {
                rhdr.hide();
                shdr.hide();
                cont.addClass('e-viewbrdr');
            }
            this._heightWidthCalculation(sheetIdx, { action: sheet._isLoaded ? "" : "initial" });
            if (this.model.showRibbon) {
                checkObj = this.element.find("#" + this._id + "_Ribbon_PageLayout_Show_Headings").data("ejCheckBox");
                if (checkObj)
                    status ? checkObj._checked() : checkObj._unChecked();
            }
            if (this.model.allowFreezing && sheet._isFreezed) {
                this.XLFreeze.unfreezePanes();
                if (this._isFrozen(fRowIdx) && this._isFrozen(fColIdx))
                    this.XLFreeze.freezePanes(fRowIdx, fColIdx);
                else if (this._isFrozen(fRowIdx))
                    this.XLFreeze.freezeRows(fRowIdx);
                else if (this._isFrozen(fColIdx))
                    this.XLFreeze.freezeColumns(fColIdx);
            }
        },

        showHeadings: function (status) {
            this._showHeadings(status);
        },

        showGridlines: function (status) {
            this._showGridlines(status);
        },

        _showGridlines: function (status, sheetIdx) {
            if (this.model.isReadOnly)
                return;
            var checkObj, sheetIdx = sheetIdx ? sheetIdx : this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), cells = this._getContent(sheetIdx).find(".e-rowcell");
            if (this.model.showRibbon) {
                checkObj = this.element.find("#" + this._id + "_Ribbon_PageLayout_Show_Gridlines").data("ejCheckBox");
                if (checkObj)
                    (status) ? checkObj._checked() : checkObj._unChecked();
            }
            sheet.showGridlines = status;
            sheet.showGridlines ? cells.removeClass('e-hborder') : cells.addClass("e-hborder");
        },

        //Spreadsheet Common Prop
        setSheetFocus: function () {
            if (!this._hasClass(document.activeElement, "e-datepicker")) {
                if (ej.browserInfo().name == "msie") {
					try { this.element[0].setActive(); } catch (e) { }
				}
                else
                    this.element.focus();
			}
            if (!this._isInitLoad)
                window.scrollTo(window.pageXOffset, window.pageYOffset);
        },

        _diffNumbers: function (a, b) {
            return a - b;
        },

        _isValidDate: function (date) {
            var dateFormat = /^\d{1,4}[\.|\/|-]\d{1,2}[\.|\/|-]\d{1,4}$/;
            if (dateFormat.test(date)) {
                date = date.replace(/0*(\d*)/gi, "$1");
                var dateArray = date.split(/[\.|\/|-]/);
                // correct month value
                dateArray[0] = dateArray[0] - 1;
                // correct year value
                if (dateArray[2].length < 4) {
                    // correct year value
                    dateArray[2] = (parseInt(dateArray[2]) < 50) ? 2000 + parseInt(dateArray[2]) : 1900 + parseInt(dateArray[2]);
                }
                var testDate = new Date(dateArray[2], dateArray[0], dateArray[1]);
                if (testDate.getDate() != dateArray[1] || testDate.getMonth() != dateArray[0] || testDate.getFullYear() != dateArray[2]) {
                    return false;
                } else {
                    return true;
                }
            } else {
                return false;
            }
        },

        _isValidTime: function (value) {
            var colonCount = 0, status = false, mm, ss;
            for (var i = 0, len = value.length; i < len; i++) {
                var ch = value.substring(i, i + 1);
                if ((ch < "0") || (ch > "9")) {
                    if ((ch != ":") && (ch != " ") && (ch != "a") && (ch != "A") && (ch != "p") && (ch != "P") && (ch != "m") && (ch != "M")) {
                        return false;
                    }
                }
                if (ch == ":") { colonCount++; }
                if ((ch == "p") || (ch == "P") || (ch == "a") || (ch == "A")) { status = true; }
            }
            if ((colonCount < 1) || (colonCount > 2)) { return false; }
            var hh = value.substring(0, value.indexOf(":"));
            if ((parseFloat(hh) < 0) || (parseFloat(hh) > 23)) { return false; }
            if (status) {
                if ((parseFloat(hh) < 1) || (parseFloat(hh) > 12)) { return false; }
            }
            if (colonCount == 2) {
                mm = value.substring(value.indexOf(":") + 1, value.lastIndexOf(":"));
            } else {
                mm = value.substring(value.indexOf(":") + 1, value.length);
            }
            if ((parseFloat(mm) < 0) || (parseFloat(mm) > 59)) { return false; }
            if (colonCount == 2) {
                ss = value.substring(value.lastIndexOf(":") + 1, value.length);
            } else {
                ss = "00";
            }
            if ((parseFloat(ss) < 0) || (parseFloat(ss) > 59)) { return false; }
            return true;
        },

        _setXY: function (e, isPage) {
            var x = 0, y = 0;
            isPage = isPage ? "page" : "client";
            if (e.type === "mousemove" || e.type === "mousedown" || e.type === "mouseup") {
                x = e[isPage + "X"];
                y = e[isPage + "Y"];
            }
            else if (e.type === "touchmove" || e.type === "touchstart" || e.type === "touchend") {
                x = e.originalEvent.changedTouches[0][isPage + "X"];
                y = e.originalEvent.changedTouches[0][isPage + "Y"];
            }
            else if (e.type === "MSPointerMove" || e.type === "pointermove" || e.type === "MSPointerUp" || e.type === "pointerup" || e.type === "MSPointerDown" || e.type === "pointerdown") {
                x = e.originalEvent[isPage + "X"];
                y = e.originalEvent[isPage + "Y"];
            }
            return [x, y];
        },

        _getSelectedItems: function (sheetIdx, range, addr) {
            var selected, sCIdx, eCIdx, actSheet;
            sheetIdx = sheetIdx ? sheetIdx : this.getActiveSheetIndex(), actSheet = this.getSheet(sheetIdx);
            if (ej.isNullOrUndefined(addr) && ej.isNullOrUndefined(range)) {
                selected = actSheet._selectedCells;
                sCIdx = actSheet._startCell, eCIdx = actSheet._endCell;
                addr = this._generateHeaderText(sCIdx.colIndex + 1) + (sCIdx.rowIndex + 1) + ":" + this._generateHeaderText(eCIdx.colIndex + 1) + (eCIdx.rowIndex + 1);
            }
            else {
                range = this.isUndefined(range) ? this.getRangeIndices(addr) : range;
                selected = this.getRange(range, sheetIdx);
                addr = this._generateHeaderText(range[1] + 1) + (range[0] + 1) + ":" + this._generateHeaderText(range[3] + 1) + (range[2] + 1);
            }
            return [selected, addr];
        },

        setBorder: function (property, range) {
            if (!this.model.allowCellFormatting || this.model.isReadOnly)
                return;
            var i, str = "", isGridBdr = false, borderStyle = property.style, borderType = property.type, hexcode = property.color, arr1, arr2, arr3, border1, border2, prop, sprop, sheetCont = this._getContent(this.getActiveSheetIndex()).find("div:first-child");
            if (!this.model.allowSelection && (borderType === "drawborder" || borderType === "drawbordergrid"))
                return;
            arr1 = ["bottom", "top", "left", "right", "outside", "allborder"];
            arr2 = ["thickbox", "thickbottom", "topandbottom", "topandthickbottom"];
            border1 = {
                top: { top: "" },
                right: { right: "" },
                bottom: { bottom: "" },
                left: { left: "" },
                outside: { top: "", right: "", bottom: "", left: "" },
                thickbox: { top: "2px solid", right: "2px solid", bottom: "2px solid", left: "2px solid" },
                thickbottom: { bottom: "2px solid" },
                topandbottom: { top: "1px solid", bottom: "1px solid" },
                topandthickbottom: { top: "1px solid", bottom: "2px solid" }
            };
            border2 = { solid: "1px solid", dashed: "1px dashed", dotted: "1px dotted" };
            if (this.model.allowSelection)
                this.XLSelection._isGridBordering = this.XLSelection._isOutsideBordering = false;
            switch (true) {
                case arr1.indexOf(borderType) > -1:
                    isGridBdr = borderType === arr1[5];
                    prop = border1[isGridBdr ? arr1[4] : borderType];
                    for (i in prop)
                        prop[i] = border2[borderStyle] + " " + hexcode;
                    if (isGridBdr)
                        prop.isGridBorder = isGridBdr;
                    prop['property'] = property;
                    this.XLFormat.applyBorder(prop, range);
                    break;
                case arr2.indexOf(borderType) > -1:
                    prop = border1[borderType];
                    for (i in prop) {
                        str = "";
                        sprop = prop[i].split(" ");
                        str = sprop.length === 2 ? str + prop[i] + " " + hexcode : str + prop[i] + " " + borderStyle + " " + hexcode; // consider
                        prop[i] = str;
                    }
                    prop['property'] = property;
                    this.XLFormat.applyBorder(prop, range);
                    break;
                case borderType === "noborder":
                    this.XLFormat.applyBorder("noborder", range);
                    break;
                case borderType === "drawborder":
                    this.XLSelection._isOutsideBordering = true;
                    sheetCont.removeClass("e-ss-cursor");
                    sheetCont.addClass("e-ss-drwbrdrcursor");
                    this.XLSelection._cleanUp(true);
                    break;
                case borderType === "drawbordergrid":
                    this.XLSelection._isGridBordering = true;
                    sheetCont.removeClass("e-ss-cursor");
                    sheetCont.addClass("e-ss-drwbrdrgridcursor");
                    this.XLSelection._cleanUp(true);
                    break;
            }
        },

        clearBorder: function (range) {
            if (this.model.isReadOnly)
                return;
            range = this._getRangeArgs(range, "object");
            this.XLFormat.removeStyle(range, { cellStyle: true, tableStyle: true, border: true });
        },

        clearHyperlinks: function () {
            if (this.model.allowClear && !this.model.isReadOnly)
                this._removeHyperlink("clear");
        },

        clearComments: function (sheetIdx) {
            if (this.model.allowClear && !this.model.isReadOnly)
                this.model.allowComments && this.XLComment.deleteComment(undefined, sheetIdx, false, "clear");
        },

        clearAllFormat: function (aRange) {
            if (!this.model.allowClear || this.model.isReadOnly)
                return;
            var evtArgs, sheetIdx = this.getActiveSheetIndex(), container = this._dataContainer.sheets[sheetIdx], nRange = [], rKeys, cKeys, sheet = this.getSheet(sheetIdx),
                range = this._getRangeArgs(aRange, "object"), isTable,
                details = { sheetIndex: sheetIdx, reqType: "clear-format", range: range };
            details.bData = $.extend(true, [], this.getRangeData({ range: range, property: ["format", "tformats", "type", "formatStr", "decimalPlaces", "thousandSeparator", "formats", "hyperlink", "cFormatRule"] }));
            this._dupDetails = true;
            rKeys = this.getObjectKeys(container);
            nRange[0] = (range[0] > parseInt(rKeys[0])) ? range[0] : parseInt(rKeys[0]);
            nRange[2] = (range[2] < parseInt(rKeys[rKeys.length - 1])) ? range[2] : parseInt(rKeys[rKeys.length - 1]);
            cKeys = this.getObjectKeys(container[nRange[2]]);
            nRange[1] = (range[1] > parseInt(cKeys[0])) ? range[1] : parseInt(cKeys[0]);
            nRange[3] = (range[3] < parseInt(cKeys[cKeys.length - 1])) ? range[3] : parseInt(cKeys[cKeys.length - 1]);
            if (ej.isNullOrUndefined(rKeys))
                return;
            isTable = this._checkTableRange(this._getAlphaRange(sheetIdx, nRange[0], nRange[1], nRange[2], nRange[3]));
            if (isTable.status === 'partial')
                return;
            this.clearRangeData(range, ["format", "formatStr", "decimalPlaces", "thousandSeparator", "formats", "hyperlink", "cFormatRule", "border"], "", false, details.reqType);
            this.clearBorder(aRange);
            this.model.allowConditionalFormats && this.XLCFormat.refreshCFormat(range);
            sheet._clrWrapColl = [];
            sheet._clrMergeColl = [];
            this._isPaste = true;
            this.setWrapText("unwrap", range);
            this._isPaste = false;
            this.unmergeCells(range);
            details.wrapColl = $.extend(true, [], sheet._clrWrapColl);
            details.mergeColl = $.extend(true, [], sheet._clrMergeColl);
            (this.model.showRibbon) && this.XLRibbon._updateRibbonIcons();
            this._dupDetails = false;
            if (!this._isUndoRedo) {
                this._completeAction(details);
                evtArgs = { sheetIndex: details.sheetIndex, reqType: details.reqType, range: details.range, prevData: details.bData, prevMergeColl: details.mergeColl, prevWrapColl: details.wrapColl };
                this._trigActionComplete(evtArgs);
            }
        },

        clearContents: function (range) {
            if (this.model.isReadOnly)
                return;
            range = this._getRangeArgs(range, "object");
            var sheetIdx = this.getActiveSheetIndex(), evtArgs, rangeData = this.getRangeData({ range: range, property: ["value", "value2", "type", "hyperlink"] }), details = { sheetIndex: sheetIdx, reqType: "clear-content", range: range, bData: $.extend(true, [], rangeData) };
            if (!this.model.allowClear || this._isPropExists([range], "isReadOnly", sheetIdx))
                return;
            this.clearRangeData(range, ["value", "value2", "hyperlink"], "", false, details.reqType);
            (this.model.allowConditionalFormats) && this.XLCFormat.refreshCFormat(range); {
                this._completeAction(details);
                evtArgs = { sheetIndex: details.sheetIndex, reqType: details.reqType, range: details.range, prevData: details.bData };
                this._trigActionComplete(evtArgs);
            }
            this.setSheetFocus();
            if (this.model.allowFormulaBar)
                this.updateFormulaBar();
        },

        clearAll: function (aRange) {
            if (this.model.isReadOnly)
                return;
            var rKeys, cKeys, evtArgs, alpRange, isTable, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), nRange = [], range = this._getRangeArgs(aRange, "object"), rangeData,
                details = { sheetIndex: sheetIdx, reqType: "clear-all", range: range }, container = this._dataContainer.sheets[sheetIdx];
            if (!this.model.allowClear || this._isPropExists([range], "isReadOnly", sheetIdx))
                return;
            this._dupDetails = true;
            rKeys = this.getObjectKeys(container);
            nRange[0] = (range[0] > parseInt(rKeys[0])) ? range[0] : parseInt(rKeys[0]);
            nRange[2] = (range[2] < parseInt(rKeys[rKeys.length - 1])) ? range[2] : parseInt(rKeys[rKeys.length - 1]);
            cKeys = this.getObjectKeys(container[nRange[2]]);
            nRange[1] = (range[1] > parseInt(cKeys[0])) ? range[1] : parseInt(cKeys[0]);
            nRange[3] = (range[3] < parseInt(cKeys[cKeys.length - 1])) ? range[3] : parseInt(cKeys[cKeys.length - 1]);
            alpRange = this._getAlphaRange(sheetIdx, nRange[0], nRange[1], nRange[2], nRange[3]);
            if ((ej.isNullOrUndefined(rKeys)) || (ej.isNullOrUndefined(cKeys)))
                return;
            details.bData = $.extend(true, [], this.getRangeData({ range: range, property: ["value", "value2", "hyperlink", "merge", "rule", "cFormatRule", "comment", "format", "formatStr", "formats", "tformat", "decimalPlaces", "thousandSeparator", "type", "borders", "tborders"], sheetIdx: sheetIdx }));
            details.bBorder = this.XLFormat.getHashCodeClassAsArray(range);
            isTable = this._checkTableRange(alpRange);
            if (isTable.status === 'full') {
                details.tblObj = isTable.tableObj;
                details.tblObj.tblId = isTable.tblId;
                details.tblObj.header = true;
                this.XLFormat.removeTable(details.tblObj.tblId);
            }
            else if (isTable.status === 'partial')
                return;
            this.clearRangeData(range, ["value", "value2", "hyperlink", "cFormatRule", "comment", "format", "formats", "formatStr", "decimalPlaces", "thousandSeparator"], "", false);
            this.clearBorder(alpRange);
            this.model.allowFiltering && this.XLFilter.clearFilter('remove');
            sheet._clrMergeColl = [];
            sheet._clrWrapColl = [];
            (this.model.allowConditionalFormats) && this.XLCFormat.refreshCFormat(range);
            (this.model.allowDataValidation) && this.XLValidate.clearDV();
            this._isPaste = true;
            this.setWrapText("unwrap", range);
            this._isPaste = false;
            this.unmergeCells(range);
            details.mergeColl = $.extend(true, [], sheet._clrMergeColl);
            details.wrapColl = $.extend(true, [], sheet._clrWrapColl);
            this._dupDetails = false;
            if (this.model.showRibbon) {
                this.XLRibbon._updateRibbonIcons();
                this.XLRibbon._toggleDesignTab(this.getActiveCell());
            }
            this._completeAction(details);
            evtArgs = { sheetIndex: details.sheetIndex, reqType: details.reqType, range: details.range, prevData: details.bData, prevBorder: details.bBorder, tblObj: details.tblObj, mergeColl: details.mergeColl, wrapColl: details.wrapColl };
            this._trigActionComplete(evtArgs);
        },

        _checkTableRange: function (aRange, cellIdx) {
            var tAlphaRange, sheetIdx = this.getActiveSheetIndex(), sheet = this.model.sheets[sheetIdx], tId, tblObj, tRange,
                range = this.getRangeIndices(aRange), tName, prop;
            if (cellIdx)
                tName = this.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "tableName");
            else {
                prop = this.XLEdit._getPropWithCellIdx(range, 'tableName');
                prop.length && (tName = prop[0].value);
            }
            if (tName) {
                tId = this._getTableID(tName);
                tblObj = sheet.tableManager[tId];
                tRange = tblObj.range;
                tAlphaRange = this._getAlphaRange(sheetIdx, tRange[0], tRange[1], tRange[2], tRange[3])
                return (aRange === tAlphaRange) ? { status: 'full', tableObj: tblObj, tblId: tId } : { status: 'partial' };
            }
            else
                return { status: 'no-table' };
        },

        _checkFilterRange: function (aRange, cellIdx) {
            var tAlphaRange, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), tId, tblObj,
                range = this.getRangeIndices(aRange), isHdr, prop, tableRange = sheet.filterSettings.tableRange;
            if (cellIdx)
                isHdr = this.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "isFilterHeader");
            else {
                prop = this.XLEdit._getPropWithCellIdx(range, 'isFilterHeader');
                prop.length && (isHdr = prop[0].value);
            }
            if (isHdr) {
                for (var i = 0; i < tableRange.length; i++) {
                    if (tableRange[i].tableID === -1) {
                        tblObj = tableRange[i];
                        tAlphaRange = this._getAlphaRange(sheetIdx, tblObj.startRow - 1, tblObj.multifilterIdx[0], tblObj.endRow, tblObj.multifilterIdx[tblObj.multifilterIdx.length - 1]);
                        return (aRange === tAlphaRange) ? { status: 'full', tRange: tAlphaRange, tblId: -1 } : { status: 'partial' };
                        break;
                    }
                }
				return { status: 'no-table' };
            }
            else
                return { status: 'no-table' };
        },

        clearTextNode: function (td, text) {
            if (ej.isNullOrUndefined(td) || this.model.isReadOnly)
                return;
            var sheetIdx = this.getActiveSheetIndex(), rowIndex = td[0].parentNode.rowIndex, colIndex = td[0].cellIndex, container = this._dataContainer.sheets[sheetIdx], node = td[0].childNodes[td[0].childNodes.length - 1];
            text = text || "";
            if (this._checkIndicesInContainer(sheetIdx, rowIndex, colIndex, "rule"))
                if (container[rowIndex][colIndex].rule.type === "list")
                    return;
            if (ej.isNullOrUndefined(node) || node.hasChildNodes("a"))
                return;
            else
                td[0].lastChild.textContent = text;
        },

        _isClassHasProperty: function (cls, property, value) {
            var format = this.XLFormat.getFormatFromHashCode(cls);
            if (format[property] && format[property].toLowerCase() === value)
                return true;
            else
                return false;
        },

        _changeTargetWithOffset: function (e) {                       //get a cell by position of mouse pointer
            var trgt, $trgt =  $(e.target), offset = e.offsetX || e.pageX - $trgt.offset().left;
            if (this._hasClass(document.activeElement, 'e-datepicker') && e.type === "mouseup")
                $('#' + this._id).focus();
            if ($trgt.is('a')) {
                trgt = e.target;
                e.target = e.target.parentNode;
            }
            if ($trgt.is('#' + this._id + '_MergeWrap'))
                return $trgt.parents().closest('td')[0];
            if (this._hasClass($trgt.parents().closest('td'), 'e-cellreadonly')) {
                if (this._hasClass($trgt, 'e-datepicker') && e.type === 'mouseup') {
                    $trgt.focus();
                }
                return $trgt.parents().closest('td')[0];
            }
            if ($trgt.is('td') && this._hasClass($trgt, 'e-cellreadonly'))
                if ($trgt.find('.e-chk-image').length > 0 && e.type === "mouseup") {
                    $('#' + $trgt.find('.e-checkbox')[0].id).ejCheckBox('instance')._checkedHandler();
                    return e.target;
                }
            if ((offset > e.target.offsetWidth || offset < 0) && ($trgt.is('td') && $trgt.parents(".e-spreadsheetmainpanel").length && this._hasClass($trgt, "e-rowcell"))) {
                var sheet = this.getSheet(this.getActiveSheetIndex()), cell = this._getCellIdx(e.target),
                 left = sheet._colWidthCollection[cell.colIndex] + offset,
                 top = sheet._rowHeightCollection[cell.rowIndex];
                trgt && this.addClass(trgt, 'e-rmanchor');
                return this.getCell(this.XLShape._getCellIndexFromOffset(top, left).rowIndex, this.XLShape._getCellIndexFromOffset(top, left).colIndex)[0];
            }
            else {
                if (trgt) {
                    this._removeClass(trgt, 'e-rmanchor');
                    return trgt;
                }
                else {
                    this._removeClass($trgt.find('a')[0], 'e-rmanchor');
                    return e.target;
                }
            }
        },

        _textClip: function (rowIndex, colIndex, action, width, isOnlyRemoval) {
            if (!this._canOverflow || this.XLEdit.getPropertyValue(rowIndex, colIndex, 'merge') || this.XLEdit.getPropertyValue(rowIndex, colIndex, 'wrap'))
                return;
            var keys, parseCell, val, cell, elem, rIdx, cIdx, prop, ofObj, endCell, tempCell, rowsColl, colsColl, overflow, container, cellStyle, span, chngd = false, isText = false, isFormat = false,
               isPrevOverflow = false, xlEdit = this.XLEdit, sheetIndex = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIndex),
			 load = (sheet._isLoaded || this.isImport), $cell = this.getCell(rowIndex, colIndex), format = xlEdit.getPropertyValue(rowIndex, colIndex, 'format', sheetIndex);
            if ($cell)
                cell = $cell[0];
            if (this._isClassHasProperty(format, 'text-align', 'right'))
                isFormat = true;
            if (xlEdit.getPropertyValue(rowIndex, colIndex, 'cellType', sheetIndex) > -1)
                return;
            if (!this._dupDetails)
                this._dupDetails = chngd = true;
            if (action === 'add') {
                if (!this.model.allowOverflow) {
                    this.addClass(cell, 'e-overflow');
                    xlEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { dataObj: { isOverflow: false }, skipCell: true });
                    chngd && (this._dupDetails = false);
                    return;
                }
                if (this._hasClass(cell, 'e-overflow'))
                    this._removeClass(cell, 'e-overflow');
                this.clearRangeData([rowIndex, colIndex, rowIndex, colIndex], ['isOverflow'], '', '', '', true);
                if (xlEdit.getPropertyValue(rowIndex, colIndex + 1, 'value2', sheetIndex) && !isFormat)
                    isText = true;
                if (!isText) {
                    rowsColl = sheet._rowHeightCollection;
                    colsColl = sheet._ofColWidthColl;
                    cellStyle = cell ? this.XLFormat.getFormatFromHashCode(this.XLFormat.getFormatClass(cell.className)) : {};
                    if (!width) {
                        span = document.getElementById(this._id + '_emptySpan');
                        this.addClass(span, 'e-rowcell e-wrapword');
                        this.addClass(span, format);
                        span.textContent = xlEdit.getPropertyValue(rowIndex, colIndex, 'value2', sheetIndex);
                        if ("text-indent" in cellStyle)
                            width = Math.round((4 / 3) * Number(cellStyle[ej.Spreadsheet.SupportedStyles.TextIndent].replace("pt", "")) + this._detailsFromGlobalSpan(rowIndex, colIndex, "width", span.textContent));     //calculating offset for text + indent 
                        else
                            width = span.offsetWidth;
                    }
                    this._refreshGlobalSpan(span);
                    endCell = this.XLShape._getCellIndexFromOffset(null, (colsColl[colIndex] + width), sheetIndex, true);
                    val = endCell.colIndex - colIndex;
                }
                if (!isOnlyRemoval && xlEdit.getPropertyValue(rowIndex, colIndex, 'value2', sheetIndex)) {
                    overflow = xlEdit.getPropertyValue(rowIndex, colIndex, 'overflow', sheetIndex);
                    if (!ej.isNullOrUndefined(overflow) && overflow.rowIndex === rowIndex) {
                        tempCell = this.getCell(overflow.rowIndex, overflow.colIndex);
                        if (tempCell)
                            this.addClass(tempCell[0], 'e-overflow');
                        xlEdit._updateDataContainer({ rowIndex: overflow.rowIndex, colIndex: overflow.colIndex }, { dataObj: { isOverflow: false }, skipCell: true });
                        if (overflow.colIndex < colIndex)
                            for (var j = 0, len = overflow['cellCount']; j <= len; j++) {
                                (j !== 0) && this.clearRangeData([rowIndex, overflow.colIndex + j, rowIndex, overflow.colIndex + j], ['overflow'], '', '', '', true);
                                if (j !== len) {
                                    elem = this.getCell(rowIndex, overflow.colIndex + j);
                                    if (load && elem)
                                        this._removeClass(elem[0], 'e-ofbrdr');
                                    this.clearRangeData([rowIndex, overflow.colIndex + j, rowIndex, overflow.colIndex + j], ['isOfBrdr'], '', '', '', true);
                                }
                            }
                        else {
                            for (var j = overflow['cellCount']; j > 0; j--) {
                                this.clearRangeData([rowIndex, overflow.colIndex - j, rowIndex, overflow.colIndex - j], ['overflow'], '', '', '', true);
                                elem = this.getCell(rowIndex, overflow.colIndex - j);
                                if (load && elem)
                                    this._removeClass(elem[0], 'e-ofbrdr');
                                this.clearRangeData([rowIndex, overflow.colIndex - j, rowIndex, overflow.colIndex - j], ['isOfBrdr'], '', '', '', true);
                            }
                        }
                    }
                }
                if (!isFormat && !isText) {
                    for (var j = 1; j <= val; j++)
                        if (xlEdit.getPropertyValue(rowIndex, colIndex + j, 'value2', sheetIndex) || xlEdit.getPropertyValue(rowIndex, colIndex + j, 'merge', sheetIndex) || xlEdit.getPropertyValue(rowIndex, colIndex + j, 'isMHide', sheetIndex) || (xlEdit.getPropertyValue(rowIndex, colIndex + j, 'overflow', sheetIndex) && xlEdit.getPropertyValue(rowIndex, colIndex + j, 'overflow', sheetIndex).colIndex !== colIndex)) {
                            isText = true;
                            break;
                        }
                }
                else
                    for (var j = colIndex - 1, len = colIndex - val; j >= len; j--) {
                        ofObj = xlEdit.getPropertyValue(rowIndex, j, 'overflow', sheetIndex);
                        if (ofObj && ofObj.colIndex !== colIndex && !isPrevOverflow) {
                            isPrevOverflow = true;
                            this._textClip(ofObj.rowIndex, ofObj.colIndex, 'delete', '', true);
                            var $cell = this.getCell(ofObj.rowIndex, ofObj.colIndex);
                            if ($cell)
                                this.addClass($cell[0], 'e-overflow');
                        }
                        if (xlEdit.getPropertyValue(rowIndex, j, 'value2', sheetIndex)) {
                            isText = true;
                            break;
                        }
                    }
                if (!isText) {
                    if (val !== 0)
                        for (var j = 0; j <= val; j++) {
                            cIdx = (isFormat) ? colIndex - j : colIndex + j;
                            if (j)
                                xlEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: cIdx }, { dataObj: { overflow: { rowIndex: rowIndex, colIndex: colIndex, cellCount: val } }, skipCell: true });
                            if (((!isFormat || (isFormat && j !== 0)) && j !== val) || (j === val && isFormat)) {
                                if (load && this._isRowViewable(sheetIndex, rowIndex))
                                    this.addClass(this.getCell(rowIndex, cIdx)[0], 'e-ofbrdr');
                                xlEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: cIdx }, { dataObj: { isOfBrdr: true }, skipCell: true });
                            }
                        }
                }
                else {
                    this.addClass(cell, 'e-overflow');
                    xlEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { dataObj: { isOverflow: false }, skipCell: true });
                }
            }
            else if (action === 'delete') {
                container = this._dataContainer.sheets[sheetIndex];
                keys = this.getObjectKeys(container[rowIndex]);
                if (this._hasClass(cell, 'e-overflow')) {
                    this._removeClass(cell, 'e-overflow');
                    this.clearRangeData([rowIndex, colIndex, rowIndex, colIndex], ['isOverflow'], '', '', '', true);
                }
                else {
                    if (!isFormat) {
                        ofObj = xlEdit.getPropertyValue(rowIndex, colIndex + 1, 'overflow', sheetIndex);
                        if (!ej.isNullOrUndefined(ofObj) && ofObj.colIndex === colIndex)
                            for (var i = colIndex, len = colIndex + 1 + ofObj['cellCount']; i < len; i++) {
                                (i !== colIndex) && this.clearRangeData([rowIndex, i, rowIndex, i], ['overflow'], '', '', '', true);
                                if (i !== len) {
                                    if (load) {
                                        elem = this.getCell(rowIndex, i);
                                        if (elem)
                                            this._removeClass(elem[0], 'e-ofbrdr');
                                    }
                                    this.clearRangeData([rowIndex, i, rowIndex, i], ['isOfBrdr'], '', '', '', true);
                                }
                            }
                    }
                    else {
                        ofObj = xlEdit.getPropertyValue(rowIndex, colIndex - 1, 'overflow', sheetIndex);
                        if (!ej.isNullOrUndefined(ofObj) && ofObj.colIndex === colIndex)
                            for (var i = colIndex - 1, len = colIndex - ofObj['cellCount']; i >= len; i--) {
                                this.clearRangeData([rowIndex, i, rowIndex, i], ['overflow'], '', '', '', true);
                                if (load) {
                                    elem = this.getCell(rowIndex, i);
                                    if (elem)
                                        this._removeClass(elem[0], 'e-ofbrdr');
                                }
                                this.clearRangeData([rowIndex, i, rowIndex, i], ['isOfBrdr'], '', '', '', true);
                            }
                    }
                }
                if (!isOnlyRemoval && this.model.allowOverflow) {
                    for (var i = keys.indexOf(colIndex.toString()) - 1; i > -1; i--) {
                        if (load)
                            parseCell = this.getCell(rowIndex, keys[i]);
                        if (xlEdit.getPropertyValue(rowIndex, keys[i], 'value2', sheetIndex) || xlEdit.getPropertyValue(rowIndex, keys[i], 'isMHide', sheetIndex)) {
                            if (this._hasClass(parseCell, 'e-overflow')) {
                                if (parseCell)
                                    this._removeClass(parseCell[0], 'e-overflow');
                                this.clearRangeData([rowIndex, keys[i], rowIndex, keys[i]], ['isOverflow'], '', '', '', true);
                                this._textClip(rowIndex, parseInt(keys[i]), 'add');
                            }
                            break;
                        }
                    }
                    for (var i = keys.indexOf(colIndex.toString()) + 1; i < keys.length; i++) {
                        if (load)
                            parseCell = this.getCell(rowIndex, keys[i]);
                        if (xlEdit.getPropertyValue(rowIndex, keys[i], 'value2', sheetIndex) || xlEdit.getPropertyValue(rowIndex, keys[i], 'isMHide', sheetIndex)) {
                            format = xlEdit.getPropertyValue(rowIndex, keys[i], 'format', sheetIndex);
                            if (this._hasClass(parseCell, 'e-overflow') && this._isClassHasProperty(format, 'text-align', 'right')) {
                                if (parseCell)
                                    this._removeClass(parseCell[0], 'e-overflow');
                                this.clearRangeData([rowIndex, keys[i], rowIndex, keys[i]], ['isOverflow'], '', '', '', true);
                                this._textClip(rowIndex, parseInt(keys[i]), 'add');
                            }
                            break;
                        }
                    }
                }
            }
            chngd && (this._dupDetails = false);
        },

        selectAll: function (isbgSelect) {
            if (!this.model.allowSelection)
                return;
            var len, eColArr = [], sRowArr = [], eRowArr = [], sColArr = [], i, j, k, multiSelect = false, loopLength = 0, xlEdit = this.XLEdit, activeCell = this.getActiveCell(), rIdx = activeCell.rowIndex, cIdx = activeCell.colIndex,
            sheetIdx = this.getActiveSheetIndex(), container = this._dataContainer.sheets[sheetIdx], rows = this.getObjectKeys(container),
            startRowIdx = parseInt(rows[0]), endRowIdx = parseInt(rows[rows.length - 1]), sheet = this.getSheet(sheetIdx),
            usedRange = this._getUsedRangeFromSheet(sheetIdx, false), length = usedRange.rowCount + usedRange.colCount, rowsCount, colsCount;
            if (sheet._startCell.rowIndex !== sheet._endCell.rowIndex || sheet._startCell.colIndex !== sheet._endCell.colIndex && sheet._isMultiSelect) {
                var startCell = { rowIndex: sheet._startCell.rowIndex, colIndex: sheet._startCell.colIndex },
                    endCell = { rowIndex: sheet._endCell.rowIndex, colIndex: sheet._endCell.colIndex },
                    tempStart = { rowIndex: sheet._startCell.rowIndex, colIndex: sheet._startCell.colIndex },
                    tempEnd = { rowIndex: sheet._endCell.rowIndex, colIndex: sheet._endCell.colIndex };
                multiSelect = true;
                for (i = 1; i < length; i++) {
                    for (j = tempStart.colIndex; j < tempEnd.colIndex + 2; j++) {                            // Multiselect
                        if (xlEdit.getPropertyValue(tempStart.rowIndex - 1, j, 'value2') || this._getDataObj(tempStart.rowIndex - 1, j, 'mergeIdx', sheetIdx)) {
                            startCell.colIndex = tempStart.colIndex < j ? tempStart.colIndex : j;
                            endCell.colIndex = tempEnd.colIndex > j ? tempEnd.colIndex : j;
                            startCell.rowIndex = tempStart.rowIndex < tempStart.rowIndex - 1 ? tempStart.rowIndex : tempStart.rowIndex - 1;
                        }
                    }
                    for (j = tempStart.rowIndex; j < tempEnd.rowIndex + 2; j++) {
                        if (xlEdit.getPropertyValue(j, tempEnd.colIndex + 1, 'value2') || this._getDataObj(j, tempEnd.colIndex + 1, 'mergeIdx', sheetIdx)) {
                            endCell.rowIndex = tempEnd.rowIndex > j ? tempEnd.rowIndex : j;
                        }
                    }
                    for (j = tempEnd.colIndex; j > tempStart.colIndex - 2; j--) {
                        if (xlEdit.getPropertyValue(tempEnd.rowIndex + 1, j, 'value2') || this._getDataObj(tempEnd.rowIndex + 1, j, 'mergeIdx', sheetIdx)) {
                            endCell.rowIndex = tempEnd.rowIndex > tempEnd.rowIndex + 1 ? tempEnd.rowIndex : tempEnd.rowIndex + 1;
                            startCell.colIndex = tempStart.colIndex < j ? tempStart.colIndex : j;
                        }
                    }
                    for (j = tempEnd.rowIndex; j > tempStart.rowIndex - 2; j--) {
                        if (xlEdit.getPropertyValue(tempEnd.rowIndex + 1, j, 'value2') || this._getDataObj(tempEnd.rowIndex + 1, j, 'mergeIdx', sheetIdx)) {
                            endCell.rowIndex = tempEnd.rowIndex > tempEnd.rowIndex + 1 ? tempEnd.rowIndex : tempEnd.rowIndex + 1;
                            startCell.colIndex = tempStart.colIndex < j ? tempStart.colIndex : j;
                        }
                    }
                    if (endCell.colIndex === tempEnd.colIndex && endCell.rowIndex === tempEnd.rowIndex && startCell.rowIndex === tempStart.rowIndex && startCell.colIndex === tempStart.colIndex) {
                        if (i === 1) {
                            sheet._isRangeSelected = true;
                            break;
                        }
                        else {
                            sheet._isRangeSelected = false;
                            break;
                        }
                    }
                    tempStart = { rowIndex: startCell.rowIndex, colIndex: startCell.colIndex };
                    tempEnd = { rowIndex: endCell.rowIndex, colIndex: endCell.colIndex };
                }
            }
            if (!sheet._isRangeSelected && !multiSelect) {
                var startCell = { rowIndex: rIdx, colIndex: cIdx },
                    endCell = { rowIndex: rIdx, colIndex: cIdx },
                    tempStart = { rowIndex: rIdx, colIndex: cIdx },
                    tempEnd = { rowIndex: rIdx, colIndex: cIdx };
                for (i = 1; i < length + 1; i++) {
                    for (j = -loopLength; j < loopLength + 1; j++) {                            // start from right
                        if (xlEdit.getPropertyValue(rIdx + j, cIdx + i, 'value2') || this._getDataObj(rIdx + j, cIdx + i, 'mergeIdx', sheetIdx)) {
                            endCell.rowIndex = endCell.rowIndex > rIdx + j ? endCell.rowIndex : rIdx + j;
                            endCell.colIndex = endCell.colIndex > cIdx + i ? endCell.colIndex : cIdx + i;
                        }
                    }
                    if (xlEdit.getPropertyValue(rIdx + i, cIdx + i, 'value2') || this._getDataObj(rIdx + i, cIdx + i, 'mergeIdx', sheetIdx)) {
                        endCell.rowIndex = endCell.rowIndex > rIdx + i ? endCell.rowIndex : rIdx + i;
                        endCell.colIndex = endCell.colIndex > cIdx + i ? endCell.colIndex : cIdx + i;
                    }
                    for (j = -loopLength; j < loopLength + 1; j++) {
                        if (xlEdit.getPropertyValue(rIdx + i, cIdx + j, 'value2') || this._getDataObj(rIdx + i, cIdx + j, 'mergeIdx', sheetIdx)) {
                            endCell.rowIndex = endCell.rowIndex > rIdx + i ? endCell.rowIndex : rIdx + i;
                            endCell.colIndex = endCell.colIndex > cIdx + j ? endCell.colIndex : cIdx + j;
                        }
                    }
                    if (!xlEdit.getPropertyValue(rIdx, cIdx, 'value2')) {
                        if (endCell.colIndex === tempEnd.colIndex && endCell.rowIndex === tempEnd.rowIndex && startCell.rowIndex === tempStart.rowIndex && startCell.colIndex === tempStart.colIndex) {
                            if (loopLength === 0) {
                                sheet._isRangeSelected = true;
                                break;
                            }
                        }
                    }
                    if (xlEdit.getPropertyValue(rIdx + i, cIdx - i, 'value2') || this._getDataObj(rIdx + i, cIdx - i, 'mergeIdx', sheetIdx)) {
                        endCell.rowIndex = endCell.rowIndex > rIdx + i ? endCell.rowIndex : rIdx + i;
                        startCell.colIndex = startCell.colIndex < cIdx - i ? startCell.colIndex : cIdx - i;
                    }
                    for (j = -loopLength; j < loopLength + 1; j++) {
                        if (xlEdit.getPropertyValue(rIdx + j, cIdx - i, 'value2') || this._getDataObj(rIdx + j, cIdx - i, 'mergeIdx', sheetIdx)) {
                            startCell.rowIndex = startCell.rowIndex < rIdx + j ? startCell.rowIndex : rIdx + j;
                            startCell.colIndex = startCell.colIndex < cIdx - i ? startCell.colIndex : cIdx - i;
                            endCell.rowIndex = endCell.rowIndex > rIdx + j ? endCell.rowIndex : rIdx + j;
                        }
                    }
                    if (xlEdit.getPropertyValue(rIdx - i, cIdx - i, 'value2') || this._getDataObj(rIdx - i, cIdx - i, 'mergeIdx', sheetIdx)) {
                        startCell.rowIndex = startCell.rowIndex < rIdx - i ? startCell.rowIndex : rIdx - i;
                        startCell.colIndex = startCell.colIndex < cIdx - i ? startCell.colIndex : cIdx - i;
                    }
                    for (j = -loopLength; j < loopLength + 1; j++) {
                        if (xlEdit.getPropertyValue(rIdx - i, cIdx + j, 'value2') || this._getDataObj(rIdx - i, cIdx + j, 'mergeIdx', sheetIdx)) {
                            startCell.rowIndex = startCell.rowIndex < rIdx - i ? startCell.rowIndex : rIdx - i;
                            startCell.colIndex = startCell.colIndex < cIdx + j ? startCell.colIndex : cIdx + j;
                            endCell.colIndex = endCell.colIndex > cIdx + j ? endCell.colIndex : cIdx + j;
                        }
                    }
                    if (xlEdit.getPropertyValue(rIdx - i, cIdx + i, 'value2') || this._getDataObj(rIdx - i, cIdx + i, 'mergeIdx', sheetIdx)) {
                        startCell.rowIndex = startCell.rowIndex < rIdx - i ? startCell.rowIndex : rIdx - i;
                        endCell.colIndex = endCell.colIndex > cIdx + i ? endCell.colIdx : cIdx + i;
                    }
                    if (endCell.colIndex === tempEnd.colIndex && endCell.rowIndex === tempEnd.rowIndex && startCell.rowIndex === tempStart.rowIndex && startCell.colIndex === tempStart.colIndex) {
                        if (loopLength !== 0) {
                            sheet._isRangeSelected = false;
                            break;
                        }
                        else {
                            sheet._isRangeSelected = true;
                            break;
                        }
                    }
                    tempStart = { rowIndex: startCell.rowIndex, colIndex: startCell.colIndex };
                    tempEnd = { rowIndex: endCell.rowIndex, colIndex: endCell.colIndex };
                    loopLength++;
                    eColArr.push(endCell.colIndex);
                    sRowArr.push(startCell.rowIndex);
                    eRowArr.push(endCell.rowIndex);
                    sColArr.push(startCell.colIndex);
                }
                sColArr = ej.dataUtil.mergeSort(ej.distinct(sColArr));
                startCell.colIndex = sColArr[sColArr.length - 1];
                for (k = sColArr.length - 1; k > -1; k--) {
                    if (sColArr[k - 1] === sColArr[k] - 1)
                        startCell.colIndex = sColArr[k - 1];
                    else
                        break;
                }
                eRowArr = ej.dataUtil.mergeSort(ej.distinct(eRowArr));
                endCell.rowIndex = eRowArr[0];
                for (k = 0, len = eRowArr.length - 1; k < len; k++) {
                    if (eRowArr[k + 1] === eRowArr[k] + 1)
                        endCell.rowIndex = eRowArr[k + 1];
                    else
                        break;
                }
                sRowArr = ej.dataUtil.mergeSort(ej.distinct(sRowArr));
                startCell.rowIndex = sRowArr[sRowArr.length - 1];
                for (k = sRowArr.length - 1; k > -1; k--) {
                    if (sRowArr[k - 1] === sRowArr[k] - 1)
                        startCell.rowIndex = sRowArr[k - 1];
                    else
                        break;
                }
                eColArr = ej.dataUtil.mergeSort(ej.distinct(eColArr));
                endCell.colIndex = eColArr[0];
                for (k = 0, len = eColArr.length - 1; k < len; k++) {
                    if (eColArr[k + 1] === eColArr[k] + 1)
                        endCell.colIndex = eColArr[k + 1];
                    else
                        break;
                }
                for (k = 0, len = eColArr.length - 1; k < len; k++) {
                    if (eColArr[k + 1] === eColArr[k] + 1)
                        endCell.colIndex = eColArr[k + 1];
                    else
                        break;
                }
            }
            if (!sheet._isEmptyActiveCell) {
                if (!sheet._isRangeSelected && !rows.length < 1) {
                    this.XLSelection.selectRange(startCell, endCell, sheetIdx, isbgSelect);
                    sheet._isMultiSelect = false;
                    sheet._startCell = startCell;
                    sheet._endCell = endCell;
                    sheet._isRangeSelected = true;
                    if (!xlEdit.getPropertyValue(rIdx, cIdx, 'value2'))
                        sheet._isEmptyActiveCell = true;
                    else
                        sheet._isEmptyActiveCell = false;
                }
                else {
                    this.XLSelection.selectSheet();
                    sheet._isRangeSelected = true;
                }
            }
        },

        _getDataObj: function (rowIdx, colIdx, property, sheetIdx) {
            var sheetData = this._dataContainer.sheets[sheetIdx ? sheetIdx : this.getActiveSheetIndex()];
            if (sheetData[rowIdx])
                if (sheetData[rowIdx][colIdx])
                    return sheetData[rowIdx][colIdx][property];
            return false;
        },

        _getUsedRangeFromSheet: function (sheetIdx, val) {
            sheetIdx = this._getSheetIndex(sheetIdx);
            var i, colKeys, sheet = this.getSheet(sheetIdx), container = this._dataContainer, value,
                rows = container.sheets[sheetIdx], rowKeys = this.getObjectKeys(rows), startCell = { rowIndex: parseInt(rowKeys[0]) || 0, colIndex: 0 }, endCell = { rowIndex: parseInt(rowKeys[rowKeys.length - 1]) || 0, colIndex: 0 };
            for (i = 0, length = rowKeys.length; i < length; i++) {
                colKeys = this.getObjectKeys(rows[parseInt(rowKeys[i])]);
                if (i === 0) {
                    startCell.colIndex = parseInt(colKeys[0]);
                    endCell.colIndex = parseInt(colKeys[colKeys.length - 1])
                }
                else {
                    startCell.colIndex = (startCell.colIndex < parseInt(colKeys[0])) ? startCell.colIndex : parseInt(colKeys[0]);
                    endCell.colIndex = (endCell.colIndex > parseInt(colKeys[colKeys.length - 1])) ? endCell.colIndex : parseInt(colKeys[colKeys.length - 1]);
                }
            }
            // compare with existing used range
            if (endCell.rowIndex < sheet.usedRange.rowIndex)
                endCell.rowIndex = sheet.usedRange.rowIndex;
            if (endCell.colIndex < sheet.usedRange.colIndex)
                endCell.colIndex = sheet.usedRange.colIndex;
            if (val)
                return this._getAlphaRange(sheetIdx, startCell.rowIndex, startCell.colIndex, endCell.rowIndex, endCell.colIndex);
            else {
                value = { startCell: startCell, endCell: endCell, rowCount: endCell.rowIndex - startCell.rowIndex + 1, colCount: endCell.colIndex - startCell.colIndex + 1 };
                return value;
            }
        },

        sheetRename: function (sheetName) {
            if (!this.model.isReadOnly)
                this._updateSheetNames(sheetName);
        },

        _isSubMenuOpen: function () {
            var arr = ["_formatastable", "_cellstyles", "_Ribbon_CElement", "_contextMenuCell", "_contextMenuColumnHeader", "_contextMenuRowHeader", "_contextMenuFooter"], i = 0, len = arr.length;
            while (i < len) {
                if ($("#" + this._id + arr[i]).is(":visible"))
                    return true;
                i++;
            }
            return false;
        },

        copySheet: function (fromIndex, toIndex, isCopySheet) {
            if (this.model.isReadOnly)
                return;
            var sheetIdx = this._getSheetIndex(sheetIdx);
            var spliceIndex, i, len, cpySheetName, isValid = false, sheetNameCount = 2, index, sheets = this.model.sheets,
                selectedItem = this.element.find(".e-numericcontainer").children().eq(fromIndex - 1), mainIndex = toIndex;
            //Check is same sheet
            if (!isCopySheet && sheets[mainIndex].sheetInfo.text === selectedItem.text()) {
                this.setSheetFocus();
                return;
            }
            //Getting splice index and sheet position index
            for (i = 1, len = sheets.length; i < len; i++) {
                if (sheets.length - 1 !== mainIndex && sheets[mainIndex].sheetInfo.text === sheets[i].sheetInfo.text)
                    spliceIndex = i;
                if (selectedItem.text() === sheets[i].sheetInfo.text)
                    index = i;
            }
            //Check is Copy sheet
            if (isCopySheet) {
                // Getting unique sheet name
                if (selectedItem.text().match('.*[ ]+[(]+[0-9]+[)]$') === null)
                    cpySheetName = selectedItem.text() + " (" + sheetNameCount + ")";
                else {
                    if (selectedItem.text().lastIndexOf(' ') > -1) {
                        sheetNameCount = parseInt(selectedItem.text().substring(selectedItem.text().lastIndexOf("(") + 1, selectedItem.text().lastIndexOf(")")));
                        cpySheetName = selectedItem.text().substring(0, selectedItem.text().lastIndexOf(" ")) + " (" + sheetNameCount + ")";
                    }
                }
                while (!isValid) {
                    cpySheetName = cpySheetName.substring(0, cpySheetName.lastIndexOf(" ")) + " (" + sheetNameCount + ")";
                    for (i = 1, len = sheets.length; i < len; i++) {
                        if (cpySheetName === sheets[i].sheetInfo.text)
                            sheetNameCount++;
                    }
                    if (sheetNameCount === parseInt(cpySheetName.substring(cpySheetName.lastIndexOf("(") + 1, cpySheetName.lastIndexOf(")"))))
                        isValid = true;
                }
                //Copy Sheet Process      
                this._copySheetProcess(index, cpySheetName);
                index = this.model.sheetCount;
                if (ej.isNullOrUndefined(spliceIndex))
                    spliceIndex = index;
            }
            else {
                if (!ej.isNullOrUndefined(spliceIndex) && spliceIndex > index)
                    spliceIndex = spliceIndex - 1;
            }
            if (ej.isNullOrUndefined(spliceIndex))
                spliceIndex = mainIndex;
            //Sheets[] updates
            if (!isCopySheet && spliceIndex === index)
                this.setSheetFocus();
            else {
                //Update DataContainer positions
                this._swapSheetDtCntr(index, spliceIndex);
                this.getPager().ejPager("option", { currentPage: mainIndex });
                this.gotoPage(mainIndex, false);
                this.setSheetFocus();
            }
        },

        getHyperlink: function (cell) {
            return this.XLEdit.getPropertyValueByElem(cell, "hyperlink", this.getActiveSheetIndex());
        },

        getComment: function (cell) {
            return this.XLEdit.getPropertyValueByElem(cell, "comment", this.getActiveSheetIndex());
        },

        saveAsJSON: function () {
            if (this.model.isReadOnly)
                return;
            var JSONData, charts, sheets, tables, tbMngr, i = 1, sheet, dtContainer, model, len, sIdx, rIdx, cIdx, sKey, chartMngr, spliceStr = [], minHashIdx, cellTypesColl, range, pictures, picMngr, key, index, sheetProp = ["_activeCell", "_endCell", "_startCell", "colCount", "rowHeight", "columnWidth", "columnsWidthCollection",
                "rowsHeightCollection", "rowCount", "frozenColumns", "frozenRows", "styleIndex", "usedRange", "sheetName", "dataAttribute", "filterSettings", "tableManager", "sheetInfo",
                "hideColsCollection", "hideRowsCollection", "mergedCells", "showGridlines", "showHeadings", "isSheetProtected", "shapeMngr", "pivotMngr", "chart", "rangeSettings",
                "cellTypes", "startCell", "primaryKey", "showHeader", "fieldAsColumnHeader", "headerStyles", "rows"],
                dtSheetProp = ["type", "value", "value2", "decimalPlaces", "format", "formats", "borders", "formatStr", "comment", "hyperlink", "rule", "cFormatRule", "wrap", "merge", "picture", "chart", "pivot", "thousandSeparator", "isLocked", "align", "isRHide"];
            this._isSaveAsJSON = true;
            this._isExport = true;
            if (this.model.exportSettings.allowExporting)
                this.XLExport._renderAll();
            this._isExport = false;

            JSONData = { dataContainer: $.extend(true, {}, this._dataContainer), model: $.extend(true, {}, this.model) };
            dtContainer = JSONData.dataContainer;
            model = JSONData.model;
            minHashIdx = len = dtContainer.hashCode.length;
            cellTypesColl = dtContainer.sheetCellType;
            dtContainer.sheetCellType = {};

            //border prop hashcode - removed
            for (key in dtContainer.hashCode) {
                sKey = dtContainer.hashCode[key];
                if (sKey.indexOf("e-border") > -1 && sKey.length < 25)
                    spliceStr.push(sKey);
            }
            for (key = 0; key < spliceStr.length; key++)
                dtContainer.hashCode.splice(dtContainer.hashCode.indexOf(spliceStr[key]), 1);


            key = "sheets"; //unwanted sheets prop - skipped
            for (sIdx in dtContainer[key]) {
                for (rIdx in dtContainer[key][sIdx]) {
                    for (cIdx in dtContainer[key][sIdx][rIdx]) {
                        for (sKey in dtContainer[key][sIdx][rIdx][cIdx]) {
                            if (["format", "formats", "borders"].indexOf(sKey) > -1) {
                                var fStr = this._dataContainer.hashCode[this._dataContainer[key][sIdx][rIdx][cIdx][sKey]];
                                dtContainer[key][sIdx][rIdx][cIdx][sKey] = dtContainer.hashCode.indexOf(fStr);
                            }
                            if (dtSheetProp.indexOf(sKey) < 0)
                                delete dtContainer[key][sIdx][rIdx][cIdx][sKey];
                        }
                        if (!this.getObjectLength(dtContainer[key][sIdx][rIdx][cIdx]))
                            delete dtContainer[key][sIdx][rIdx][cIdx];
                    }
                    if (!this.getObjectLength(dtContainer[key][sIdx][rIdx]))
                        delete dtContainer[key][sIdx][rIdx];
                }
            }

            //model default value - skipped
            for (key in model) {
                if (model[key] === this.defaults[key] || Object.prototype.toString.call(model[key]) === Object.prototype.toString())
                    delete model[key];
                else if (Array.isArray(model[key]))
                    if (!model[key].length)
                        delete model[key];
            }

            sheets = model.sheets;

            while (i < sheets.length) {
                sheet = sheets[i];

                for (key in sheet) {

                    switch (key) {
                        case "frozenColumns":
                        case "frozenRows":
                            if (sheet[key] === 0) // 0 - default
                                delete sheet[key];
                            break;
                        case "fieldAsColumnHeader":
                        case "isSheetProtected":
                            if (!sheet[key]) // false - default
                                delete sheet[key];
                            break;
                        case "showHeadings":
                        case "showGridlines":
                        case "showHeader":
                            if (sheet[key]) // true - default
                                delete sheet[key];
                            break;
                        case "filterSettings":
                            for (sKey in sheet[key]) {
                                if (sKey === "range") {
                                    if (this._isEmptyString(sheet[key][sKey]))
                                        delete sheet[key][sKey];
                                }
                                else
                                    delete sheet[key][sKey];
                            }
                            break;
                        case "sheetInfo":
                            for (sKey in sheet[key]) {
                                if (sKey !== "text") {
                                    if (sKey === "isVisible")
                                        if (!sheet[key][sKey])
                                            continue;
                                    delete sheet[key][sKey];
                                }
                            }
                            break;
                        case "_startCell":
                        case "_endCell":
                        case "_activeCell":
                        case "usedRange":
                            for (sKey in sheet[key]) {
                                if (sheet[key][sKey] === 0) // 0 index - default
                                    delete sheet[key][sKey];
                            }
                            break;
                        case "columnWidth":
                            if (sheet[key] === 64) // 64 - default 
                                delete sheet[key];
                            break;
                        case "rowHeight":
                            if (sheet[key] === 20) // 20 - default
                                delete sheet[key];
                            break;
                        case "primaryKey":
                            if (!sheet[key].length)
                                delete sheet[key];
                            break;
                        case "startCell":
                            if (sheet[key] === "A1")
                                delete sheet[key];
                            break;
                    }

                    if (sheetProp.indexOf(key) < 0 || sheet[key] === null)
                        delete sheet[key];
                    else if (Object.prototype.toString.call(sheet[key]) === Object.prototype.toString()) {
                        if (!this.getObjectLength(sheet[key]))
                            delete sheet[key];
                    }
                    else if (Array.isArray(sheet[key])) {
                        if (!sheet[key].length)
                            delete sheet[key];
                    }
                }

                //picture collection changes
                pictures = sheets[i].shapeMngr["picture"];
                picMngr = {};
                if (this.getObjectLength(pictures)) {
                    index = 0;
                    for (key in pictures) {
                        picMngr["picture" + index] = pictures[key];
                        index++;
                    }
                    sheets[i].shapeMngr["picture"] = $.extend(true, {}, picMngr);
                }

                //chart collection changes
                charts = sheets[i].shapeMngr["chart"];
                chartMngr = {};
                if (this.getObjectLength(charts)) {
                    index = 0;
                    for (key in charts) {
                        var cObj = $.extend(true, {}, charts[key]), cModel;
                        cModel = {
                            commonSeriesOptions: { type: cObj.type, marker: cObj.marker },
                            enable3D: cObj.enable3D,
                            top: cObj.top,
                            left: cObj.left,
                            size: { width: cObj.width, height: cObj.height },
                            title: cObj.title,
                            legend: cObj.legend,
                            primaryXAxis: cObj.xAxis,
                            primaryYAxis: cObj.yAxis,
                            dataSheetIdx: cObj.dataSheetIdx,
                            animation: cObj.animation,
                            isRowColSwitched: cObj.isRowColSwitched,
                            colIndex: cObj.colIndex,
                            rowIndex: cObj.rowIndex,
                            theme: cObj.theme,
                            range: this._getAlphaRange(i, cObj.range[0], cObj.range[1], cObj.range[2], cObj.range[3])
                        };
                        if (cObj.colIndex && cObj.rowIndex)
                            dtContainer.sheets[i][cObj.rowIndex][cObj.colIndex]["chart"] = [];
                        else
                            dtContainer.sheets[i][cObj.activeCell.rowIndex][cObj.activeCell.colIndex]["chart"] = [];
                        chartMngr["chart" + index] = cModel;
                        index++;
                    }
                    sheets[i].shapeMngr["chart"] = chartMngr;
                }

                //table processing
                tables = sheets[i].tableManager;
                tbMngr = {};
                if (this.getObjectLength(tables)) {
                    index = 0;
                    for (key in tables) {
                        var prop = $.extend(true, {}, tables[key]);
                        delete prop["format"];
                        for (sKey in model.nameManager)
                            if (model.nameManager[sKey].name === prop.name)
                                model.nameManager.splice(parseInt(sKey), 1);
                        tbMngr[index] = prop;
                        index++;
                    }
                    sheets[i].tableManager = tbMngr;
                }

                //Cell types
                sheet.cellTypes = [];
                len = this.getObjectLength(cellTypesColl);
                if (len)
                    dtContainer.sheetCellType[i] = {};
                index = 1;
                for (key in cellTypesColl) {
                    sKey = cellTypesColl[key];
                    if (!this.getObjectLength(sKey))
                        continue;
                    range = sKey.id.split('_')[2];
                    sIdx = parseInt(range.match(/[0-9]+/)[0]);
                    if (i === sIdx) {
                        delete sKey["id"];
                        sKey["range"] = range.replace(/[0-9]+/, "");
                        dtContainer.sheetCellType[i][index] = { "settings": sKey };
                        cellTypesColl[key] = {};
                        index++;
                    }
                }
                sheets[i]._scrollTop = this.getSheet(i)._scrollTop;
                sheets[i]._scrollLeft = this.getSheet(i)._scrollLeft;
                i++;
            }
            this._isSaveAsJSON = false;
            return JSONData;
        },

        _isvalidRange: function (alphaRange) {
            var regx = new RegExp(/^\$?(?:\b[a-z]{1,3})\$?(?:\d{1,7}):\$?(?:\b[a-z]{1,3})\$?(?:\d{1,7})$/i);
            return regx.test(alphaRange);
        },

        // upload
        _renderFUpload: function () {
            this.element.append(ej.buildTag("div", "", { height: "0px" }, { id: this._id + "_file" }));
            $("#" + this._id + "_file").ejUploadbox({
                width: "0px",
                height: "0px",
                uploadName: "file",
                autoUpload: true,
                showFileDetails: false,
                dialogAction: { content: this.element },
                saveUrl: this.model["importSettings"].importMapper,
                fileSelect: $.proxy(this._fileSelect, this),
                complete: $.proxy(this._changeImport, this),
                error: $.proxy(this._importFailed, this)
            });
            $("#" + this._id + "_file_SelectButton").hide();
        },

        _fileSelect: function (args) {
		    if(!args.files.length)
			    return;
            var file = args.files[0], extension = file.extension;
            if ((this._uploadImage && extension === ".xlsx") || (!this._uploadImage && (!(this._browserDetails.name === "msie" && parseInt(this._browserDetails.version) < 10) ? (file.rawFile.type.indexOf("image") > -1) : (extension.indexOf("jpg") > -1 || extension.indexOf("png") > -1 || extension.indexOf("jpeg") > -1 || extension.indexOf("gif") > -1)))) {
                this._showAlertDlg("Alert", "CorrectFormat", "", 290);
                this._uploadImage = false;
                return false;
            }
            if (!(this._browserDetails.name === "msie" && parseInt(this._browserDetails.version) < 10) && !this._uploadImage) {
                $("#" + this._id + "_file").ejUploadbox("option", "autoUpload", false);
                this["import"]({ file: file.rawFile, password: this._encrypt(this.model.importSettings.password), allowSheetOnDemand: this.model.importSettings.allowSheetOnDemand });
                this._uploadImage = false;
                return false;
            }
            else
                this.showWaitingPopUp();
            this._uploadImage = false;
        },

        _changeImport: function (args) {
            var response, upObj = $("#" + this._id + "_file").data("ejUploadbox");
            if (!(this._browserDetails.name === "msie" && parseInt(this._browserDetails.version) < 10) ? (args.files.rawFile.type.indexOf("image") > -1) : (args.files[0].extension.indexOf("jpg") > -1 || args.files[0].extension.indexOf("png") > -1 || args.files[0].extension.indexOf("jpeg") > -1 || args.files[0].extension.indexOf("gif") > -1)) {
                upObj.updialog.ejDialog("close");
                this.XLShape._insertPicture(args);
                if (this.model.showRibbon)
                    this.XLRibbon._formatTabUpdate();
                upObj.option("autoUpload", true);
            }
            else {
                response = this._browserDetails.name === "msie" && parseInt(this._browserDetails.version) < 10 ? args.responseText : args.xhr.response;
                upObj.updialog.ejDialog("close");
                this._importSuccess(response);
            }
            this.hideWaitingPopUp();
        },

        _dlgBeforeOpen: function (args) {
            var dlgObj = $("#" + this._id + "_PasswordDialog").data("ejDialog");
            this.hideWaitingPopUp();
            $("#" + this._id + "_workBookName").text("'" + $("#" + this._id + "_file").data("ejUploadbox")._files[0].name + "'" + this._getLocStr("Protect"));
        },

        _dlgOk: function (args) {
            var tgleObj, dlgObj = $("#" + this._id + "_PasswordDialog").data("ejDialog"), pwdEle = $("#" + this._id + "_xlpassword"), cPwdEle = $("#" + this._id + "_confirmpassword");
            tgleObj = $("#" + this._id + "_Ribbon_Review_Changes_ProtectWorkbook").data("ejToggleButton");
            if (dlgObj.model.title === "Protect Workbook") {
                if (pwdEle.val().length && cPwdEle.val().length) {
                    if (pwdEle.val() === cPwdEle.val()) {
                        this.model.exportSettings.password = pwdEle.val();
                        $("#" + this._id + "_AddSheet").addClass("e-disable");
                        $("#" + this._id + "_confirm").hide();
                        dlgObj.option("title", this._getLocStr("UnProtectWorkbook"));
                    }
                    else {
                        $("#" + this._id + "_confirm").show();
                        this._showAlertDlg("Alert", "PasswordAlert1");
                        tgleObj && tgleObj.option("toggleState", false);
                        dlgObj.option("title", this._getLocStr("ProtectWorkbook"));
                    }
                }
                else {
                    $("#" + this._id + "_confirm").show();
                    tgleObj && tgleObj.option("toggleState", false);
                    dlgObj.option("title", this._getLocStr("ProtectWorkbook"));
                    this._showAlertDlg("Alert", "PasswordAlert2");
                }
            }
            else if (dlgObj.model.title === "Unprotect Workbook") {
                if (this.model.exportSettings.password === pwdEle.val()) {
                    $("#" + this._id + "_AddSheet").removeClass("e-disable");
                    this.model.exportSettings.password = null;
                    $("#" + this._id + "_confirm").show();
                    dlgObj.option("title", this._getLocStr("ProtectWorkbook"));
                }
                else {
                    dlgObj.option("title", this._getLocStr("UnProtectWorkbook"));
                    tgleObj && tgleObj.option("toggleState", true);
                    this._showAlertDlg("Alert", "PasswordAlert3");
                }
            }
            pwdEle.val("");
            cPwdEle.val("");
            $("#" + this._id + "_PasswordDialog").ejDialog("close");
        },

        _passwordDlg: function () {
            var $dlg, $label, $okBtn, $canBtn, $btndiv, $div;
            $dlg = ej.buildTag("div", "", "", { id: this._id + "_PasswordDialog" });
            $btndiv = ej.buildTag("div.e-dlg-btnfields");
            $div = ej.buildTag("div.e-dlg-btnctnr");
            $label = "<div class= 'e-dlgctndiv'><table><tr class= 'e-dlgtd-fields'><td><label>" + this._getLocStr("Password") + ":</label></td><td><input id ='" + this._id + "_xlpassword' type ='password' class = 'ejinputtext'/></td></tr><tr class= 'e-dlgtd-fields' id ='" + this._id + "_confirm'><td><label>" + this._getLocStr("ConfirmPassword") + "</label></td><td><input id ='" + this._id + "_confirmpassword' type ='password'  class = 'ejinputtext'/></td></tr></table></div>";
            $dlg.append($label);
            $okBtn = ej.buildTag("input", "", "", { type: "submit" });
            $canBtn = ej.buildTag("input");
            $okBtn.ejButton({ text: this._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._dlgOk, this), enabled: true, cssClass:"e-ss-okbtn" });
            $canBtn.ejButton({ text: this._getLocStr("Cancel"), click: ej.proxy(this._dlgCancel, this), showRoundedCorner: true, width: 60 });
            $btndiv.append($div.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: this._getLocStr("ProtectWorkbook"), width: "auto", height: "auto", cssClass: "e-ss-dialog e-" + this._id + "-dlg e-ss-pwddlg", close: ej.proxy(this._dlgCancel, this) });
        },

        _importPasswordDlg: function () {
            var $dlg, $label, $okBtn, $canBtn, $btndiv, $div;
            $dlg = ej.buildTag("div", "", "", { id: this._id + "_ImportPasswordDialog" });
            $btndiv = ej.buildTag("div.e-dlg-btnfields");
            $div = ej.buildTag("div.e-dlg-btnctnr");
            $label = "<div class= 'e-dlgctndiv'><table><tr class= 'e-dlgtd-fields'><td><label id ='" + this._id + "_workBookName' ></label></td></tr><tr class= 'e-dlgtd-fields'><td><label>" + this._getLocStr("Password") + ":</label></td><td><input id ='" + this._id + "_importpassword' type ='password'  class = 'ejinputtext'/></td></tr></table></div>";
            $dlg.append($label);
            $okBtn = ej.buildTag("input", "", "", { type: "submit" });
            $canBtn = ej.buildTag("input");
            $okBtn.ejButton({ text: this._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._importDlgOk, this), enabled: true });
            $canBtn.ejButton({ text: this._getLocStr("Cancel"), click: ej.proxy(this._dlgCancel, this), showRoundedCorner: true, width: 60 });
            $btndiv.append($div.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: this._getLocStr("Password"), beforeOpen: $.proxy(this._dlgBeforeOpen, this), width: 420, height: "auto", cssClass: "e-ss-dialog e-" + this._id + "-dlg", close: ej.proxy(this._dlgCancel, this) });
            return $dlg;
        },

        _dlgCancel: function (args) {
            this._showDialog(this._id + "_Ribbon_Review_Changes_ProtectWorkbook");
            var dlgObj = $("#" + this._id + "_PasswordDialog").data("ejDialog");
            if (dlgObj.model.title === "Protect Workbook")
                $("#" + this._id + "_Ribbon_Review_Changes_ProtectWorkbook").ejToggleButton("option", "toggleState", false);
            else if (dlgObj.model.title === "Unprotect Workbook")
                $("#" + this._id + "_Ribbon_Review_Changes_ProtectWorkbook").ejToggleButton("option", "toggleState", true);
            $("#" + this._id + "_confirmpassword").val("");
            $("#" + this._id + "_xlpassword").val("");
            $("#" + this._id + "_importpassword").val("");
            $("#" + this._id + "_PasswordDialog").ejDialog("close");
            $("#" + this._id + "_ImportPasswordDialog").ejDialog("close");
        },

        _importDlgOk: function (args) {
            var opts = {}, pwdEle = $("#" + this._id + "_importpassword");
            this.model.importSettings.password = pwdEle.val();
            pwdEle.val("");
            $("#" + this._id + "_ImportPasswordDialog").ejDialog("close");
            opts.file = $("#" + this._id + "_file").data("ejUploadbox")._files[0].rawFile;
            opts.password = this._encrypt(this.model.importSettings.password);
            opts.allowSheetOnDemand = this.model.importSettings.allowSheetOnDemand;
            this["import"](opts);
        },

        lockCells: function (range, isLocked) {
            if (this.model.isReadOnly)
                return;
            var args, status, len, cells, i = 0, btn, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx);
            status = (isLocked != false);
            if (this.model.allowLockCell && !sheet.isSheetProtected) {
                range = this._getRangeArgs(range, "object", sheetIdx);
                args = { reqType: "lockCells", range: range, isLock: status };
                if (this._trigActionBegin(args))
                    return;
                range = args.range;
                status = args.isLock;
                status ? this.updateUniqueData({ isLocked: true }, range) : this.clearRangeData(range, ["isLocked"]);
                if (this.model.showRibbon)
                    this.XLRibbon._updateRibbonIcons();
                args = { reqType: "lockCells", range: range, isLocked: status };
                if (this._trigActionComplete(args))
                    return;
            }
        },

        protectSheet: function (isProtected) {
            if (this.model.isReadOnly)
                return;
            var args, status, btn, sheetIdx = this.getActiveSheetIndex(), sheet = this.getSheet(sheetIdx), rObj = this.XLRibbon;
            status = (isProtected !== false);
            if (this.model.allowLockCell) {
                args = { reqType: "protectSheet", isProtect: isProtected, sheetIdx: sheetIdx };
                if (this._trigActionBegin(args))
                    return;
                status = args.isProtect;
                sheet.isSheetProtected = status;
                if (this.model.showRibbon) {
                    btn = $("#" + this._id + "_Ribbon_Review_Changes_LockCell").data("ejToggleButton");
                    btn && btn.option("enabled", !status);
                    status ? rObj._disableRibbonIcons() : rObj._enableRibbonIcons();
                    rObj._updateRibbonIcons();
                }
                sheet._showLockCellAlert = true;
                if (this.model.allowFormulaBar)
                    this.updateFormulaBar();
                if (this.model.allowUndoRedo) {
                    if (this.model.sheetCount > 1)
                        this._removeUndoRedoForCurSheet(sheetIdx, "undo");
                    else {
                        this._undoCollection = [];
                        this._redoCollection = [];
                    }
                }
                args = { reqType: "protectSheet", isSheetProtected: isProtected, sheetIdx: sheetIdx };
                if (!this._isSheetNavigate && this._trigActionComplete(args))
                    return;
            }
        },

        _readOnly: function () {
            var xlRibbon = this.XLRibbon, tabObj = $("#" + this._id + "_FRDialog_FPDlgTab").data("ejTab"), backStageElem = this.element.find("#" + this._id + "_Ribbon_BackStage"), formulaElem = this.element.find("#" + this._id + "_inputbox");
            if (this.model.isReadOnly) {
                xlRibbon._disableRibbonIcons();
                xlRibbon.enableRibbonItems(["Spreadsheet_Ribbon_Home_Clipboard_Copy", "Spreadsheet_Ribbon_Review_Comments_ShowAllComments", "Spreadsheet_Ribbon_Others_Editing_FindSelect"]);
                this.XLCMenu && this.XLCMenu._disableMenuOpt(["Replace", "GoTo", "GoToSpecial", "Formulas", "Comments", "CFormat", "Constants", "DataValidation"], "Ribbon_FindRep");
                if (backStageElem.length) {
                    backStageElem.find("#saveas_backStageTab").hide();
                    backStageElem.find("#print_backStageTab").hide();
                }
                this.addClass(this.element.find("#" + this._id + "_AddSheet")[0], "e-disable");
                if (formulaElem.length)
                    formulaElem[0].disabled = true;
            }
            else {
                xlRibbon._enableRibbonIcons();
                this.XLCMenu && this.XLCMenu._enableMenuOpt(["Replace", "GoTo", "GoToSpecial", "Formulas", "Comments", "CFormat", "Constants", "DataValidation"], "Ribbon_FindRep");
                if (backStageElem.length) {
                    backStageElem.find("#saveas_backStageTab").show();
                    backStageElem.find("#print_backStageTab").show();
                }
                this._removeClass(this.element.find("#" + this._id + "_AddSheet")[0], "e-disable");
                if (formulaElem.length)
                    formulaElem[0].disabled = false;
            }

        },

        _isPropExists: function (range, prop, sheetIdx, skipAlert) {
            var curRange, i, j, k, l, m = 0, flag = false;
            while (m < range.length) {
                curRange = this.swapRange(range[m]);
                i = curRange[0], j = curRange[2]
                while (i <= j) {
                    k = curRange[1];
                    l = curRange[3];
                    while (k <= l) {
                        if (this.XLEdit.getPropertyValue(i, k, prop, sheetIdx)) {
                            if (!skipAlert) {
                                if (prop === "isLocked")
                                    this._popUplockCellAlert();
                                else if (prop === "isReadOnly")
                                    this._showAlertDlg("Alert", "ReadOnly", "", 400);
                            }
                            flag = true;
                            break;
                        }
                        k++;
                    }
                    if (flag)
                        break;
                    i++;
                }
                if (flag)
                    break;
                m++;
            }
            return flag;
        },

        _isCellProtected: function (rIndex, colIndex, alertStatus) {
            if (this.model.allowLockCell && this.getSheet(this.getActiveSheetIndex()).isSheetProtected && this.XLEdit.getPropertyValue(rIndex, colIndex, "isLocked")) {
                alertStatus && this._popUplockCellAlert();
                return true;
            }
            else if (this.XLEdit.getPropertyValue(rIndex, colIndex, "isReadOnly")) {
                this._showAlertDlg("Alert", "ReadOnly", "", 400);
                return true;
            }
        },

        _popUplockCellAlert: function () {
            if (this.getSheet(this.getActiveSheetIndex())._showLockCellAlert)
                this._showAlertDlg("Alert", "LockAlert", "", 500);
        },

        _removeUndoRedoForCurSheet: function (sheetIdx, state) {
            var collection = (state === "undo") ? this._undoCollection : this._redoCollection, len = collection.length;
            if (len) {
                while (len--) {
                    if (sheetIdx === collection[len].sheetIndex)
                        collection.splice(len, 1);
                }
            }
            if (state === "undo")
                this._removeUndoRedoForCurSheet(sheetIdx, "redo");
        },

        _detailsFromGlobalSpan: function (rowIndex, colIndex, type, value, width, isFromContent) {
            var span, req, value = value || 'K', cls = "e-rowcell e-wrapword ", data = this.getRangeData({range: [rowIndex, colIndex, rowIndex, colIndex], property: ['format', 'border', 'wrap'] })[0], format = data.format, border = data.border, wrap = data.wrap, isWidth;
            isWidth = !ej.isNullOrUndefined(width);
            span = isWidth ? $('#' + this._id + '_emptyDiv') : $('#' + this._id + '_emptySpan');
            width && (span[0].style.width = width - 4 + "px"); // 2 for left padding, 1 for right paddding, 1 for right border
            if (!ej.isNullOrUndefined(format))
                cls += format + " ";
            if (!ej.isNullOrUndefined(border))
                cls += border + " ";
            else if (span[0].className.indexOf('e-rowcell') > -1)
                span[0].style.borderRight = 0; // border-right property value should 0 in span when span has 'e-rowcell' class.
            if (!ej.isNullOrUndefined(wrap))
                cls += "e-sswraptext";
            this.addClass(span[0], cls);
            (span[0].className.indexOf('e-rowcell') > -1) && (span[0].style.padding = 0); // padding property value should 0 in span when span has 'e-rowcell' class.
            span.text(value);
            if (type === 'height') {
                req = span.outerHeight();
                (!isFromContent && (this.model.rowHeight > req)) && (req = this.model.rowHeight);
            }
            else {
                req = span.outerWidth();
                (!isFromContent && (this.model.columnWidth > req)) && (req = this.model.columnWidth);
            }
            this._refreshGlobalSpan(null, isWidth);
            return req;
        },

        _encrypt: function (str) {
            if (!ej.isNullOrUndefined(str)) {
                var i, xorKey = 129, result = "";
                for (i = 0; i < str.length; ++i)
                    result += String.fromCharCode(xorKey ^ str.charCodeAt(i));
                return result;
            }
        },

        _writeRule: function (colIdx, sheetIdx) {
            var stag, cellProp, sheetIdx = this.getSheetElement(sheetIdx).index() + 1;
            cellProp = "#" + this._id + " .e-sheet:nth-child(" + sheetIdx + ") .e-content td.e-rowcell:nth-of-type(" + (colIdx + 1) + ")";
            stag = document.getElementById(this._id + "_sshide");
            stag.sheet.insertRule(cellProp + "{display: none}", stag.sheet.cssRules.length);
        },

        _deleteRule: function (colIdx, sheetIdx) {
            var sheetIdx = this.getSheetElement(sheetIdx).index() + 1, stag, cellProp;
            stag = document.getElementById(this._id + "_sshide");
            var rules = stag.sheet.cssRules, sheetRule = " .e-sheet:nth-child(" + sheetIdx + ") ", cellRule = ".e-rowcell:nth-of-type(" + (colIdx + 1) + ")";
            if (this._browserDetails.name === "msie") {
                sheetRule = " :nth-child(" + sheetIdx + ").e-sheet ";
                cellRule = ":nth-of-type(" + (colIdx + 1) + ").e-rowcell";
            }
            cellProp = "#" + this._id + sheetRule + ".e-content td" + cellRule;
            for (var i = 0, len = rules.length; i < len; i++) {
                if (rules[i].selectorText === cellProp) {
                    stag.sheet.deleteRule(i);
                    break;
                }
            }
        },

        _refreshRowHeight: function (sheetIdx, rowIdx) {
            var pHeight = this.XLEdit.getPropertyValue(rowIdx, 0, "pHeight"), sheet = this.getSheet(sheetIdx);
            if (!this.isUndefined(pHeight)) {
                this.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: 0 }, { dataObj: { cHeight: pHeight, pHeight: sheet.rowsHeightCollection[rowIdx] } });
                sheet.rowsHeightCollection[rowIdx] = pHeight;
                if (this._isRowViewable(sheetIdx, rowIdx))
                    this.getRows(sheetIdx)[1][this._getRowIdx(rowIdx)].style.height = pHeight + "px";
            }
        },

        _batchAddRow: function (sRIndex, eRIndex, sheetIdx, isReverse) {
            var rowData, setting, bindex, curRange, deleted, dindex, j = 0, i = sRIndex, sheet = this.getSheet(sheetIdx),
                settings = this.getDataSettings(sheetIdx);
            if (settings) {
                while (i <= eRIndex) {
                    while (j < settings.length) {
                        setting = settings[j];
                        curRange = setting.range;
                        deleted = setting.batchChanges.deleted;
                        if (i > curRange[0] && i <= (curRange[2] + 1)) {
                            bindex = curRange[0] ? this._getPosDiff(i, curRange[0]) : i;
                            if (!setting.fieldAsColumnHeader && setting.showHeader)
                                bindex = bindex - 1;
                            rowData = this._getRowData(i, curRange[1], curRange[3], setting);
                            setting._jsonData.splice(bindex, 0, rowData);
                            if (setting._isDataManager) {
                                if (isReverse)
                                    deleted.length ? deleted.pop() : deleted.push(rowData);
                                else
                                    setting.batchChanges.added.push(setting._jsonData[bindex]);
                            }
                            curRange[2]++;
                            setting.count++;
                        }
                        else if (i <= curRange[0]) {
                            curRange[2]++;
                            curRange[0]++;
                        }
                        j++;
                    }
                    j = 0;
                    i++;
                }
            }
        },

        _batchDeleteRow: function (sRIndex, eRIndex, sheetIdx, isReverse) {
            var delData, setting, bindex, curRange, added, dindex, j = 0, i = eRIndex, sheet = this.getSheet(sheetIdx),
                settings = this.getDataSettings(sheetIdx);
            if (settings) {
                while (i >= sRIndex) {
                    while (j < settings.length) {
                        setting = settings[j];
                        curRange = setting.range;
                        added = setting.batchChanges.added;
                        if (i >= curRange[0] && i <= (curRange[2])) {
                            bindex = curRange[0] ? this._getPosDiff(i, curRange[0]) : i;
                            if (!setting.fieldAsColumnHeader && setting.showHeader)
                                bindex = bindex - 1;
                            delData = setting._jsonData.splice(bindex, 1)[0];
                            if (setting._isDataManager) {
                                if (!isReverse)
                                    setting.batchChanges.deleted.push(delData);
                                else {
                                    if (added.length) {
                                        dindex = added.indexOf(delData);
                                        if (dindex > -1)
                                            added.splice(dindex, 1);
                                    }
                                    else
                                        added.push(delData);
                                }
                            }
                            curRange[2]--;
                            setting.count--;
                        }
                        else if (i < curRange[0]) {
                            curRange[2]--;
                            curRange[0]--;
                        }
                        j++;
                    }
                    j = 0;
                    i--;
                }
            }
        },

        _updateBatchDetails: function (rowIndex, colIndex, sheetIdx) {
            var bindex, findex, range, actdata, curField, value, batchData, changed, setting, canIterate = true, i = 0, sheet = this.getSheet(sheetIdx),
            settings = this.getDataSettings(sheetIdx);
            if (settings) {
                while (i < settings.length) {
                    setting = settings[i];
                    range = setting.range;
                    if (range && this.inRange(range, rowIndex, colIndex)) {
                        changed = setting.batchChanges.changed;
                        bindex = range[0] ? this._getPosDiff(rowIndex, range[0]) : rowIndex;
                        findex = range[1] ? this._getPosDiff(colIndex, range[1]) : colIndex;
                        if (!setting.fieldAsColumnHeader && setting.showHeader) {
                            if (rowIndex === range[0])
                                canIterate = false;
                            else
                                bindex = bindex - 1;
                        }
                        if (canIterate) {
                            batchData = setting._jsonData[bindex];
                            curField = setting.fields[findex];
                            value = this.getRangeData({ range: [rowIndex, colIndex, rowIndex, colIndex], valueOnly: true, sheetIdx: sheetIdx, skipFormula: true })[0];
                            if (this.isUndefined(value) || this._isEmptyString(value))
                                value = null;
                            if (batchData[curField] !== value) {
                                batchData[curField] = value;
                                if (setting.primaryKey && curField === setting.primaryKey && !this.XLEdit.getPropertyValue(rowIndex, colIndex, "isReadOnly", sheetIdx) && !this.isUndefined(value))
                                    this.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { dataObj: { isReadOnly: true } });
                                if (setting._isDataManager && $.inArray(batchData, changed) === -1 && $.inArray(batchData, setting.batchChanges.added) === -1)
                                    changed.push(batchData);
                            }
                        }
                        break;
                    }
                    i++;
                }
            }
        },

        _getRowData: function (rowIndex, scolIndex, ecolIndex, setting) {
            var value, data = {}, i = scolIndex, j = 0, sheet = this.getSheet(this.getActiveSheetIndex()), fields = setting.fields;
            while (i <= ecolIndex) {
                value = this.getRangeData({ range: [rowIndex, i, rowIndex, i], valueOnly: true, skipDateTime: true })[0];
                if (this._isEmptyString(value))
                    value = null;
                if (setting.primaryKey && fields[j] === setting.primaryKey && ej.isNullOrUndefined(value))
                    value = 0;
                data[fields[j]] = value;
                i++;
                j++;
            }
            return data;
        },


        saveBatchChanges: function (sheetIdx) {
            var args, promise, batchChanges, returnValue, i = 0, proxy = this, sheet = this.getSheet(sheetIdx), settings = this.getDataSettings(sheetIdx);
            if (settings) {
                while (i < settings.length) {
                    setting = settings[i];
                    if (setting._isDataManager) {
                        batchChanges = setting.batchChanges;
                        args = { sheetIdx: sheetIdx, dataSetting: setting, batchChanges: batchChanges };
                        returnValue = this._trigger("beforeBatchSave", args);
                        if (!returnValue && (batchChanges.changed.length || batchChanges.added.length || batchChanges.deleted.length)) {
                            promise = setting._dataManager.saveChanges(batchChanges, setting.primaryKey, setting.query._fromTable);
                            if (!setting._isOffline) {
                                this.showWaitingPopUp();
                                promise.done(function (e) {
                                    sheet._resCnt++;
                                    if (sheet._reqCnt === sheet._resCnt)
                                        proxy.hideWaitingPopUp();
                                });
                                promise.fail(function (e) {
                                    sheet._resCnt++;
                                    if (sheet._reqCnt === sheet._resCnt)
                                        proxy.hideWaitingPopUp();
                                });
                            }
                            sheet._reqCnt++;
                            setting.batchChanges = { added: [], changed: [], deleted: [] };
                        }
                    }
                    i++;
                }
            }
        },

        setReadOnly: function (range) {
            this.updateUniqueData({ isReadOnly: true }, range);
        },

        removeReadOnly: function (range) {
            this.clearRangeData(range, ["isReadOnly"]);
        },

        _updateCustomFormulas: function (formulasArr, action) {
            var calcEngine = this._calcEngine, isComplete, key;
            for (key in formulasArr) {
                if (action === "add" && this.isUndefined(this.getCalcEngine().getLibraryFunctions().getItem(formulasArr[key].formulaName)) && !this.XLEdit._isNamedRange("=" + formulasArr[key].formulaName)) {
                    isComplete = calcEngine["addCustomFunction"](formulasArr[key].formulaName, formulasArr[key].functionName);
                    this._formulaCollection.push({ text: "=" + formulasArr[key].formulaName, display: formulasArr[key].formulaName });
                }
                else if (action === "delete" && calcEngine.getCustomLibraryFunctions().contains(formulasArr[key].formulaName))
                    isComplete = calcEngine["removeFunction"](formulasArr[key].formulaName, formulasArr[key].functionName);
                else
                    this._showAlertDlg("Alert", "CorrectFormula", "FormulaAlert", 372); // To pass correct argument
            }
            return isComplete;
        },

        addCustomFormula: function (formulaName, functionName) {
            if (this.model.isReadOnly)
                return;
            var isComplete = this._updateCustomFormulas([{ formulaName: formulaName, functionName: functionName }], "add");
            if (isComplete) {
                this.model.customFormulas.push({ formulaName: formulaName, functionName: functionName });
                this.XLEdit._refreshAutoComplete();
            }
        },

        removeCustomFormula: function (formulaName, functionName) {
            if (this.model.isReadOnly)
                return;
            var key, isComplete = this._updateCustomFormulas([{ formulaName: formulaName.toUpperCase(), functionName: functionName }], "delete"), formulaColl;
            if (isComplete) {
                formulaColl = this.model.customFormulas;
                for (key in formulaColl)
                    if (formulaColl[key].formulaName === formulaName)
                        formulaColl.splice(1, parseInt(key));
                this._updateFormulaCollection();
                this.XLEdit._refreshCalcEngine(null, null, false, null, null);
                this.XLEdit._refreshAutoComplete();
            }
        },

        getValueFromFormulaArg: function (args) {
            var i = 1, key, sheetIdx = this._getSheetIndex(), calcEngine = this._calcEngine, splitArgs, tVal, values = {}, totalArgs = [], n, len;
            splitArgs = args.split(calcEngine.getParseArgumentSeparator());
            for (n = 0, len = splitArgs.length; n < len; n++)
                totalArgs = totalArgs.concat((splitArgs[n].indexOf(":") > -1) ? calcEngine.getCellsFromArgs(splitArgs[n]) : [splitArgs[n]]);
            for (key in totalArgs) {
                tVal = calcEngine.getValueFromArg(totalArgs[key]);
                values["arg" + i] = this.XLEdit._parseValue(tVal).value;
                if (totalArgs.indexOf(tVal) > -1 && tVal[0] === '"' && tVal[tVal.length - 1] === '"')
                    values["arg" + i] = tVal.substring(1, tVal.length - 1);
                i++;
            }
            return values;
        },

        getCalcEngine: function () {
            return this._calcEngine;
        },
		
		_updateFormatColl: function(sheetIdx, rowIdx, colIdx, cellHt) {
			var sheet = this.getSheet(sheetIdx), formatColl = sheet._formatColl;
			if(cellHt > this.model.rowHeight) {
				if(this.isUndefined(formatColl[rowIdx]))
					formatColl[rowIdx] = {};
				formatColl[rowIdx][colIdx] = cellHt;
			}
			else {
				if(rowIdx in formatColl && colIdx in formatColl[rowIdx]) 
					delete formatColl[rowIdx][colIdx];
				if(this.getObjectLength(formatColl[rowIdx]) < 1)
					delete formatColl[rowIdx];
			}
		},

		_getFormattedHeight: function (sheetIdx, rowIdx) {
		    var sheet = this.getSheet(sheetIdx), cellHt;
		    cellHt = ej.max(this._getObjectValues(sheet._formatColl[rowIdx]));
		    cellHt = cellHt ? cellHt : this.model.rowHeight;
		    return cellHt;
		}
    });


    ej.Spreadsheet.Locale = ej.Spreadsheet.Locale || {};

    ej.Spreadsheet.Locale['default'] = ej.Spreadsheet.Locale["en-US"] = {
        Cut: "Cut",
        Copy: "Copy",
        FormatPainter: "Format Painter",
        Paste: "Paste",
        PasteValues: "Paste Values Only",
        PasteSpecial: "Paste",
        Filter: "Filter",
        FilterContent: "Turn on filtering for the selected cells.",
        FilterSelected: "Filter by Selected Cell's value",
        Sort: "Sort",
        Clear: "Clear",
        ClearContent: "Delete everything in the cell, or remove just the formatting, contents, comments or hyperlinks.",
        ClearFilter: "Clear Filter",
        ClearFilterContent: "Clear the filter and sort state for the current range of data.",
        SortAtoZ: "Sort A to Z",
        SortAtoZContent: "Lowest to Highest.",
        SortZtoA: "Sort Z to A",
        SortZtoAContent: "Highest to Lowest.",
        SortSmallesttoLargest: "Sort Smallest to Largest",
        SortLargesttoSmallest: "Sort Largest to Smallest",
        SortOldesttoNewest: "Sort Oldest to Newest",
        SortNewesttoOldest: "Sort Newest to Oldest",
        Insert: "Insert",
        InsertTitle: "Insert Cells",
        InsertContent: "Add new cells, rows, or columns to your workbook.",
		MultipleInsertContent:"FYI: To insert multiple rows or columns at a time, select multiple rows or columns in the sheet, and click Insert.",
        InsertSBContent: "Add cells, rows, columns, or sheets to your workbook.",
        Delete: "Delete",
        DeleteTitle: "Delete Cells",
        DeleteContent: "Delete cells, rows, columns, or sheets from your workbook. ",
		MultipleDeleteContent:"FYI: To delete multiple rows or columns at a time, select multiple rows or columns in the sheet, and click Delete.",
        FindSelectTitle: "Find & Select",
        FindSelectContent: "Click to see options for finding text in your document.",
        CalculationOptions: "Calculation Options",
        CalcOptTitle: "Calculation Options",
        CalcOptContent: "Choose to calculate formulas automatically or manually.",
		CalcOptRecalcContent: "If you make a change that affects a value, Spreadsheet will automatically recalculate it.",
        CalculateSheet: "Calculate Sheet",
        CalculateNow: "Calculate Now",
        CalculateNowContent: "Calculate the entire workbook now.",
		CalculateNowTurnOffContent: "You only need to use this if automatic calculation is turned off.",
        CalculateSheetContent: "Calculate the active sheet now.",
		CalculateSheetTurnOffContent: "You only need to use this if automatic calculation is turned off.",
        Title: "Spreadsheet",
        ColorPicker: "Color Picker",
        Ok: "OK",
        Cancel: "Cancel",
        Alert: "We couldn't do this for the selected range of cells. Select a single cell within a range of data and then try again.",
        HeaderAlert: "The command could not be completed as you are attempting to filter with the filter header. Select a single cell in the filter range and try the command again.",
        FlashFillAlert: "All the data next to your selection was checked and there was no pattern for filling in values.",
        Formatcells: "Format Cells",
        FontFamily: "Font",
        FFContent: "Pick a new font for your text.",
        FontSize: "Font Size",
        FSContent: "Change the size of your text.",
        IncreaseFontSize: "Increase Font Size",
        IFSContent: "Make your text a bit bigger.",
        DecreaseFontSize: "Decrease Font Size",
        DFSContent: "Make your text a bit smaller.",
        Bold: "Bold",
        Italic: "Italic",
        Underline: "Underline",
        Linethrough: "Linethrough",
        FillColor: "Fill Color",
        FontColor: "Font Color",
        TopAlign: "Top Align",
        TopAlignContent: "Align text to the top.",
        MiddleAlign: "Middle Align",
        MiddleAlignContent: "Align text so that it is centered between the top and bottom of the cell.",
        BottomAlign: "Bottom Align",
        BottomAlignContent: "Align text to the bottom.",
        WrapText: "Wrap Text",
        WrapTextContent: "Wrap extra-long text into multiple lines so you can see all of it.",
        AlignLeft: "Align Left",
        AlignLeftContent: "Align your content to the left.",
        AlignCenter: "Center",
        AlignCenterContent: "Center your content.",
        AlignRight: "Align Right",
        AlignRightContent: "Align your content to the right.",
        IncreaseIndent: "Increase Indent",
        IncreaseIndentContent: "Move your content farther away from the cell border.",
        DecreaseIndent: "Decrease Indent",
        DecreaseIndentContent: "Move your content closer to the cell border.",
        Undo: "Undo",
        Redo: "Redo",
        NumberFormat: "Number Format",
        NumberFormatContent: "Choose the format for your cells, such as percentage, currency, date or time.",
        AccountingStyle: "Accounting Style",
        AccountingStyleContent: "Format as dollar accounting number format.",
        PercentageStyle: "Percent Style",
        PercentageStyleContent: "Format as a percent.",
        CommaStyle: "Comma Style",
        CommaStyleContent: "Format with a thousands separator.",
        IncreaseDecimal: "Increase Decimal",
        IncreaseDecimalContent: "Show more decimal places for a more precise value.",
        DecreaseDecimal: "Decrease Decimal",
        DecreaseDecimalContent: "Show fewer decimal places.",
        AutoSum: "AutoSum",
        AutoSumTitle: "Sum",
        AutoSumContent: "Automatically add a quick calculation to your worksheet, such as sum or average.",
        Fill: "Fill",
        ExportXL: "Excel",
        ExportCsv: "CSV",
        ExportPdf: "PDF",
        SaveXml: "Save XML",
        BackgroundColor: "Fill Color",
        BGContent: "Color the background of the cells to make them stand out.",
        ColorContent: "Change the color of your text.",
        Border: "Border",
        BorderContent: "Apply borders to the currently selected cells.",
        BottomBorder: "Bottom Border",
        TopBorder: "Top Border",
        LeftBorder: "Left Border",
        RightBorder: "Right Border",
        OutsideBorder: "Outside Borders",
        NoBorder: "No Border",
        AllBorder: "All Borders",
        ThickBoxBorder: "Thick Box Border",
        ThickBottomBorder: "Thick Bottom Border",
        TopandThickBottomBorder: "Top and Thick Bottom Border",
        DrawBorderGrid: "Draw Border Grid",
        DrawBorder: "Draw Border",
        TopandBottomBorder: "Top and Bottom Border",
        BorderColor: "Line Color",
        BorderStyle: "Line Style",
        Number: "Number is used for general display of numbers.  Currency and Accounting offer specialized formatting for monetary value.",
        General: "General format cells have no specific number format.",
        Currency: "Currency formats are used for general monetary values.  Use Accounting formats to align decimal points in a column.",
        Accounting: "Accounting formats line up the currency symbols and decimal points in a column.",
        Text: "Text format cells are treated as text even when a number is in the cell. The cell is displayed exactly as entered.",
        Percentage: "Percentage formats multiply the cell value by 100 and displays the result with a percent symbol.",
        CustomMessage: "Type number format code, using one of existing codes as a starting point.",
        Fraction: "Fraction is used to indicate a part of a whole number or a ratio between two numbers.",
        Scientific: "Scientific is used to represent a decimal number between 1 and 10 multiplied by ten, so the large numbers using less digits.",
        Type: "Type:",
        CustomFormatAlert: "Enter a valid format",
        Date: "Date formats display date and time serial numbers as date values.",
        Time: "Time formats display date and time serial numbers as date values.",
        File: "FILE",
        New: "New",
        Open: "Open",
        SaveAs: "Save As",
        Print: "Print",
        PrintContent: "Print the current sheet.",
        PrintSheet: "Print Sheet",
        PrintSelected: "Print Selected",
        PrintSelectedContent: "Select an area on the sheet you would like to print.",
        HighlightVal: "Format Invalid Data",
        ClearVal: "Clear Validation",
        Validation: "Validation",
        DataValidation: "Data Validation",
        DVContent: "Pick from a list of rules to limit the type of data that can be entered in a cell.",
        A4: "A4",
        A3: "A3",
        Letter: "Letter",
        PageSize: "Page Size",
        PageSizeContent: "Choose a page size for your document.",
        FormatCells: "FormatCells",
        ConditionalFormat: "Conditional Formatting",
        CFContent: "Easily spot trends and patterns in your data using colors to visually highlight important values.",
        And: "and",
        With: "with",
        GTTitle: "Greater Than",
        GTContent: "Format cells that are GREATER THAN:",
        LTTitle: "Less Than",
        LTContent: "Format cells that are LESS THAN:",
        BWTitle: "Between",
        BWContent: "Format cells that are BETWEEN:",
        EQTitle: "Equal To",
        EQContent: "Format cells that are EQUAL TO:",
        DateTitle: "A Date Occurring",
        DateContent: "Format cells that contain a DATE:",
        ContainsTitle: "Text That Contains",
        ContainsContent: "Format cells that contain the text:",
        GreaterThan: "Greater Than",
        LessThan: "Less Than",
        Between: "Between",
        EqualTo: "Equal To",
        TextthatContains: "Text that Contains",
        DateOccurring: "A Date Occurring",
        ClearRules: "Clear Rules",
        ClearRulesfromSelected: "Clear Rules from Selected Cells",
        ClearRulesfromEntireSheets: "Clear Rules from Entire Sheet",
        CellStyles: "Cell Styles",
        CellStylesContent: "A colorful style is a great way to make important data stand out on the sheet.",
        CellStyleHeaderText: "Good, Bad and Neutral/Titles and Headings/Themed Cell Styles",
        Custom: "Type the number format code, using one of the existing codes as starting point.",
        CellStyleGBN: "Normal/Bad/Good/Neutral",
        CellStyleTH: "Heading 4/Title",
        CellsStyleTCS: "20% - Accent1/20% - Accent2/20% - Accent3/20% - Accent4/60% - Accent1/60% - Accent2/60% - Accent3/60% - Accent4/Accent1/Accent2/Accent3/Accent4",
        Style: "Style",
        FormatAsTable: "Format As Table",
        FormatasTable: "Format as Table",
        FATContent: "Quickly convert a range of cells to a table with its own style.",
        FATHeaderText: "Light/Medium/Dark",
        FATNameDlgText: "Table Name:/My table has headers",
        InvalidReference: "The range you have specified is invalid",
        ResizeAlert: "The specified range is invalid. The top of the table must remain in the same row, and the resulting table must overlap the original table. Specify a valid range.",
        RangeNotCreated: "Increasing the row beyond the maximum sheet rowcount is restricted in Format as Table.",
        ResizeRestrictAlert: "Increase or decrease of column count and decrease of row count is restricted in Format as Table.",
        FATResizeTableText: "Enter new data range for your table:",
        FATReizeTableNote: "Note: The headers must remain in the same row and the resulting table range must overlap the original table range.",
        FormatAsTableAlert: "Cannot create a table with a single row. A table must have at least two rows, one for the table header, and one for data",
        FormatAsTableTitle: "Light 1/Light 2/Light 3/Light 5/Light 8/Light 9/Light 10/Light 12/Light 15/Light 16/Light 17/Light 19/Medium 8/Medium 9/Medium 10/Medium 12/Medium 22/Medium 23/Medium 24/Medium 26/Dark 1/Dark 2/Dark 3/Dark 5",
        NewTableStyle: "New Table Style",
        ResizeTable: "Resize Table",
        ResizeTableContent: "Resize this table by adding or removing rows and columns.",
        ConvertToRange: "Convert to Range",
        ConvertToRangeContent: "Convert this table into a normal range of cells.",
        ConverToRangeAlert: "Do you want to convert the table to a normal range?",
        TableID: "Table ID:",
        Table: "Table",
        TableContent: "Create a table to organize and analyze related data.",
        TableStyleOptions: "First Column/Last Column/Total Row/Filter Button",
        Format: "Format",
        NameManager: "Name Manager",
        NameManagerContent: "Create, edit, delete and find all the names used in the workbook.",
        NameManagerFormulaContent: "Names can be used in formulas as substitutes for cell references.",
        DefinedNames: "Defined Names",
        DefineName: "Define Name",
        DefineNameContent: "Define and apply names.",
        UseInFormula: "Use In Formula",
        UseInFormulaContent: "Choose a name used in this workbook and insert it into the current formula.",
        RefersTo: "Refers To",
        Name: "Name",
        Scope: "Scope",
        NMNameAlert: "The name that you entered is not valid./Reason for this can include:/The name does not begin with a letter or an underscore/The name contains a space or other invalid characters/The name conflicts with a spreadsheet built-in name or the name of another object in the workbook", // not used completely
        NMUniqueNameAlert: "The name entered already exists. Enter a unique name.",
        NMRangeAlert: "Enter a valid range",
        FORMULAS: "FORMULAS",
        Value: "Values",
        DataValue: "Values:",
        Formula: "Formulas",
        MissingParenthesisAlert: "Your formula is missing a parenthesis--) or (. Check the formula, and then add the parenthesis in the appropriate place.",
        UnsupportedFile: "Unsupported File",
        IncorrectPassword: "Unable to open the file or worksheet with the given password",
        InvalidUrl: "Please specify proper URL",
        Up: "Up",
        Down: "Down",
        Sheet: "Sheet",
        Workbook: "Workbook",
        Rows: "By Rows",
        Columns: "By Columns",
        FindReplace: "Find Replace",
        FindnReplace: "Find and Replace",
        Find: "Find",
        Replace: "Replace",
        FindLabel: "Find what:",
        ReplaceLabel: "Replace with:",
        ReplaceAll: "Replace All",
        Close: "Close",
        FindNext: "Find Next",
        FindPrev: "Find Prev",
        Automatic: "Automatic",
        Manual: "Manual",
        Settings: "Settings",
        MatchCase: "Match case",
        MatchAll: "Match entire cell contents",
        Within: "Within:",
        Search: "Search:",
        Lookin: "Look in:",
        ShiftRight: "Shift cells right",
        ShiftBottom: "Shift cells down",
        EntireRow: "Entire row",
        EntireColumn: "Entire column",
        ShiftUp: "Shift cells up",
        ShiftLeft: "Shift cells left",
        Direction: "Direction:",
        GoTo: "Go To",
        GoToName: "Go to:",
        Reference: "Reference:",
        Special: "Special",
        Select: "Select",
        Comments: "Comments",
        Formulas: "Formulas",
        Constants: "Constants",
        RowDiff: "Row differences",
        ColDiff: "Column differences",
        LastCell: "Last cell",
        CFormat: "Conditional formats",
        Blanks: "Blanks",
        GotoError: "Error",
        GotoLogicals: "Logicals",
        GotoNumbers: "Numbers",
        GotoText: "Text",
        FindSelect: "Find & Select",
        Comment: "Comment",
        NewComment: "New",
        InsertComment: "Insert Comment",
        EditComment: "Edit",
        DeleteComment: "Delete Comment",
        DeleteCommentContent: "Delete the selected comment.",
        HideComment: "Hide Comment",
        Next: "Next",
        NextContent: "Jump to the next comment.",
        Previous: "Previous",
        PreviousContent: "Jump to the previous comment.",
        ShowHide: "Show/Hide Comment",
        ShowHideContent: "Show or hide the comment on the active cell.",
        ShowAll: "Show All Comments",
        ShowAllContent: "Display all comments in the sheet.",
        UserName: "User Name",
        Hide: "Hide",
        Unhide: "Unhide",
        Add: "Add",
        DropAlert: "Do you want to replace the existing data?",
        PutCellColor: "Put Selected Cell Color To The Top",
        PutFontColor: "Put Selected Font Color To The Top",
        WebPage: "Web Page",
        WorkSheet: "Worksheet Reference",
        SheetReference: "Sheet Reference",
        InsertHyperLink: "Insert Hyperlink",
        HyperLink: "Hyperlink",
        EditLink: "Editlink",
        OpenLink: "Openlink",
        HyperlinkText: "Text:",
        RemoveLink: "Removelink",
        WebAddress: "Web Address:",
        CellAddress: "Cell Reference:",
        SheetIndex: "Select a place in this document",
        ClearAll: "Clear All",
        ClearFormats: "Clear Formats",
        ClearContents: "Clear Contents",
        ClearComments: "Clear Comments",
        ClearHyperLinks: "Clear Hyperlinks",
        SortFilter: "Sort & Filter",
        SortFilterContent: "Organize your data so it's easier to analyze.",
        NumberStart: "Minimum:",
        NumberEnd: "Maximum:",
        DecimalStart: "Minimum:",
        DecimalEnd: "Maximum:",
        DateStart: "Start Date:",
        DateEnd: "End Date:",
        ListStart: "Source:",
        FreeText: "Show error after invalid data is entered",
        ListEnd: "Cell Reference:",
        TimeStart: "Start Time:",
        TimeEnd: "End Time:",
        TextLengthStart: "Minimum:",
        TextLengthEnd: "Maximum:",
        CommentFindEndAlert: "Spreadsheet reached the end of the workbook. Do you want to continue reviewing from the beginning of the workbook?",
        InsertSheet: "Insert",
        DeleteSheet: "Delete",
        RenameSheet: "Rename",
        MoveorCopy: "Move or Copy",
        HideSheet: "Hide",
        UnhideSheet: "Unhide",
        SheetRenameAlert: "That name is already taken. Try a different one.",
        SheetRenameEmptyAlert: "You typed an invalid name for a sheet. Make sure that:",
		SheetRenameEmptyCharExceedAlert: "The name that you type does not exceed 31 characters.",
		SheetRenameEmptySplCharAlert: "The name does not contain any of the following characters: ",
		SheetRenameEmptyBlankAlert: "You did not leave the name blank.",
        SheetDeleteAlert: "You can't undo deleting sheets, and you might be removing some data. If you don't need it, click OK to delete.",
        SheetDeleteErrorAlert: "A workbook must contain at least one visible worksheet. To hide, delete, or move the selected sheet, you must first insert a new sheet or unhide a sheet that is already hidden.",
        CtrlKeyErrorAlert: "That command cannot be used on  multiple selections.",
        ClipboardAccessError: "Your browser can't access the clipboard, so use these shortcuts:",
		ClipboardAccessCutError: "Cut = Ctrl + X",
		ClipboardAccessCopyError: "Copy = Ctrl + C",
		ClipboardAccessPasteError: "Paste = Ctrl + V",
        MoveToEnd: "Move To End",
        Beforesheet: "Before sheet:",
        CreateaCopy: "Create a copy",
        AutoFillOptions: "Copy Cells/Fill Series/Fill Formatting Only/Fill Without Formatting/Flash Fill",
        NumberValidationMsg: "Enter only digits",
        DateValidationMsg: "Enter only date",
        Required: "Required",
        TimeValidationMsg: "The time you entered for the Time is invalid.",
        CellAddrsValidationMsg: "Reference is not valid.",
        PivotTable: "Pivot Table",
        PivotTableContent: "Easily arrange and summarize complex data in a PivotTable.",
        NumberTab: "Number",
        AlignmentTab: "Alignment",
        FontTab: "Font",
        FillTab: "Fill",
        TextAlignment: "Text alignment",
        Horizontal: "Horizontal:",
        Vertical: "Vertical:",
        Indent: "Indent",
        TextControl: "Text Control",
        FontGroup: "Font:",
        FontStyle: "Font style:",
        Size: "Size:",
        PSize: "Page size",
        Effects: "Effects:",
        StrikeThrough: "Strikethrough",
        Overline: "Overline",
        NormalFont: "Normal font",
        Preview: "Preview",
        PreviewText: "AaBbCcYyZz",
        Line: "Line",
        Presets: "Presets",
        None: "None",
        Outline: "Outline",
        AllSide: "All sides",
        InsCells: "Insert Cells",
        InsRows: "Insert Sheet Rows",
        InsCols: "Insert Sheet Columns",
        InsSheet: "Insert Sheet",
        DelCells: "Delete Cells",
        DelRows: "Delete Sheet Rows",
        DelCols: "Delete Sheet Columns",
        DelSheet: "Delete Sheet",
        HyperLinkAlert: "The address of this site is not valid.Check the address and try again.",
        ReplaceData: "All done. We made / replacements.",
        NotFound: "We couldn't find what you were looking for. Select settings tab for more ways to search",
        Data: "Data:",
        Allow: "Allow:",
        IgnoreBlank: "Ignore blank",
        NotFind: "Unable to find the match to replace",
        FreezeTopRow: "Freeze Top Row",
        FreezeFirstColumn: "Freeze First Column",
        UnFreezePanes: "Unfreeze Panes",
        DestroyAlert: "Are you sure you want to destroy the current workbook without saving and create a new workbook?",
        ImageValAlert: "Upload image files only",
        Pictures: "Pictures",
        PicturesTitle: "From File",
        PicturesContent: "Insert pictures from computer or from other computers that you are connected to.",
        ImportAlert: "Are you sure you want to destroy the current workbook without saving and open a new workbook?",
        UnmergeCells: "Unmerge Cells",
        MergeCells: "Merge Cells",
        MergeAcross: "Merge Across",
        MergeAndCenter: "Merge & Center",
        MergeAndCenterContent: "Combine and center the contents of the selected cells in a new larger cell.",
        MergeCellsAlert: "Merging Cells keeps only upper left cell value and discards the other values.",
        MergeInsertAlert: "This operation will causes some merged cells to unmerge. Do you wish to continue ?",
        Axes: "Axes",
        PHAxis: "Primary Horizontal",
        PVAxis: "Primary Vertical",
        AxisTitle: "Axis Title",
        CTNone: "None",
        CTCenter: "Center",
        CTFar: "Far",
        CTNear: "Near",
        DataLabels: "Data Labels",
        DLNone: "None",
        DLCenter: "Center",
        DLIEnd: "Inside End",
        DLIBase: "Inside Base",
        DLOEnd: "Outside End",
        ErrorBar: "Error Bars",
        Gridline: "Gridlines",
        PMajorH: "Primary Major Horizontal",
        PMajorV: "Primary Major Vertical",
        PMinorH: "Primary Minor Horizontal",
        PMinorV: "Primary Minor Vertical",
        Legend: "Legends",
        LNone: "None",
        LLeft: "Left",
        LRight: "Right",
        LBottom: "Bottom",
        LTop: "Top",
        ChartTitleDlgText: "Enter Title",
        ChartTitle: "Title",
        InvalidTitle: "You typed an invalid name for the Title.",
        CorrectFormat: "Select the correct Format File",
        ResetPicture: "Reset Picture",
        ResetPictureContent: "Discard all of the formatting changes made to this picture.",
        PictureBorder: "Picture Border",
        PictureBorderContent: "Pick the color, width, and line style for the outline of your shape.",
        ResetSize: "Reset Picture & Size",
        Height: "Height",
        Width: "Width",
        ThemeColor: "Theme Colors",
        NoOutline: "No Outline",
        Weight: "Weight",
        Dashes: "Dashes",
        ColumnChart: "2-D Column/3-D Column",
        ColumnChartTitle: "Insert Column Chart",
        ColumnChartContent: "Use this chart type to visually compare values across a few categories.",
        BarChart: "2-D Bar/3-D Bar",
        BarChartTitle: "Insert Bar Chart",
        BarChartContent: "Use this chart type to visually compare values across a few categories when the chart shows duration or the category text is long.",
        StockChart: "Radar",
        StockChartTitle: "Insert Radar Chart",
        StockChartContent: "Use this chart type to show values relative to a center point.",
        LineChart: "2-D Line",
        LineChartTitle: "Insert Line Chart",
        LineChartContent: "Use this chart type to show trends over time (years, months, and days) or categories.",
        AreaChart: "2-D Area/3-D Area",
        AreaChartTitle: "Insert Area Chart",
        AreaChartContent: "Use this chart type to show trends over time (years, months, and days) or categories. Use it to highlight the magnitude of change over time.",
        ComboChart: "Combo",
        PieChart: "Pie",
        PieChartTitle: "Insert Pie/Doughnut Chart",
        PieChartContent: "Use this chart type to show proportions of a whole. Use it when the total of your numbers is 100%.",
        ScatterChart: "Scatter",
        ScatterChartTitle: "Insert Scatter (X, Y) Chart",
        ScatterChartContent: "Use this chart type to show the relationship between sets of values.",
        ClusteredColumn: "Clustered&nbsp;Column",
        StackedColumn: "Stacked&nbsp;Column",
        Stacked100Column: "100%&nbsp;Stacked&nbsp;Column",
        Cluster3DColumn: "3-D&nbsp;Clustered&nbsp;Column",
        Stacked3DColumn: "3-D&nbsp;Stacked&nbsp;Column",
        Stacked100Column3D: "3-D&nbsp;100%&nbsp;Stacked&nbsp;Column",
        ClusteredBar: "Clustered&nbsp;Bar",
        StackedBar: "Stacked&nbsp;Bar",
        Stacked100Bar: "100%&nbsp;Stacked&nbsp;Bar",
        Cluster3DBar: "3-D&nbsp;Clustered&nbsp;Bar",
        Stacked3DBar: "3-D&nbsp;Stacked&nbsp;Bar",
        Stacked100Bar3D: "3-D&nbsp;100%&nbsp;Stacked&nbsp;Bar",
        Radar: "Radar",
        RadarMarkers: "Radar&nbsp;with&nbsp;Markers",
        LineMarkers: "Line&nbsp;with&nbsp;Markers",
        Area: "Area",
        StackedArea: "Stacked&nbsp;Area",
        Stacked100Area: "100%&nbsp;Stacked&nbsp;Area",
        Pie: "Pie",
        Pie3D: "3-D&nbsp;Pie",
        Doughnut: "Doughnut",
        Scatter: "Scatter",
        ChartRange: "Chart Range",
        XAxisRange: "Enter X-axis range:",
        YAxisRange: "Enter Y-axis range:",
        LegendRange: "Enter legend range:",
        YAxisMissing: "Enter Y-axis range to create chart",
        InvalidYAxis: "Y-axis range must be within the selected range",
        InvalidXAxis: "X-axis range must be within the selected range",
        InvalidLegend: "Legend range must be within the selected range",
        InvalidXAxisColumns: "X-axis range should be within a single column",
        FreezePanes: "Freeze Panes",
        FreezePanesContent: "Freeze a portion of the sheet to keep it visible while you scroll through the rest of the sheet.",
        PasteTitle: "Paste (Ctrl+V)",
        PasteContent: "Add content on the Clipboard to your document.",
        PasteSplitContent: "Pick a paste option, such as keeping formatting or pasting only content.",
        CutTitle: "Cut (Ctrl+X)",
        CutContent: "Remove the selection and put it on the Clipboard so you can paste it somewhere else.",
        CopyTitle: "Copy (Ctrl+C)",
        CopyContent: "Put a copy of the selection on the Clipboard so you can paste it somewhere else.",
        FPTitle: "Format Painter",
        FPContent: "Like the look of a particular selection? You can apply that look to other content in the document.",
        BoldTitle: "Bold (Ctrl+B)",
        BoldContent: "Make your text bold.",
        ItalicTitle: "Italic (Ctrl+I)",
        ItalicContent: "Italicize your text.",
        ULineTitle: "Underline (Ctrl+U)",
        ULineContent: "Underline your text.",
        LineTrTitle: "Strike Through (Ctrl+5)",
        LineTrContent: "Cross something out by drawing a strike through it.",
        UndoTitle: "Undo (Ctrl+Z)",
        UndoContent: "Undo your last action.",
        RedoTitle: "Redo (Ctrl+Y)",
        RedoContent: "Redo your last action.",
        TableTitle: "Table (Ctrl+T)",
        HyperLinkTitle: "Add a Hyperlink (Ctrl+K)",
        HyperLinkContent: "Create a link in your document for quick access to webpages and files. ",
        HyperLinkPlaceContent: "Hyperlinks can also take you to places in your document.",
        NewCommentTitle: "Insert a Comment",
        NewCommentContent: "Add a note about this part of the document.",
        RefreshTitle: "Refresh",
        RefreshContent: "Get the latest data from the source connected to the active cell",
        FieldListTitle: "Field List",
        FieldListContent: "Show or hide the Field List." ,
		FieldListRemoveContent: "The field list allows you to add and remove fields from your PivotTable report",
        AddChartElement: "Add Chart Element",
        AddChartElementContent: "Add elements to the created chart.",
        SwitchRowColumn: "Switch Row/ Column",
        SwitchRowColumnContent: "Swap the data over the axis.",
        MergeAlert: "We can't do that to a merged cell.",
        UnhideDlgText: "Unhide Sheet:",
        ChartThemes: "Chart Themes",
        ChartThemesContent: "Pick a new theme for your chart.",
        ChangePicture: "Change Picture",
        ChangePictureContent: "Change to a different picture, preserving the formatting and size of the current picture.",
        ChangeChartType: "Change Chart Type",
        SelectData: "Select Data",
        SelectDataContent: "Change the data range included in the chart.",
        Sum: "Sum",
        Average: "Average",
        CountNumber: "Count Numbers",
        Max: "Max",
        Min: "Min",
        ChartType: "Change Chart Type",
        ChartTypeContent: "Change to a different chart type.",
        AllCharts: "All Charts",
        defaultfont: "Default",
        LGeneral: "General",
        LCurrency: "Currency",
        LAccounting: "Accounting",
        LDate: "Date",
        LTime: "Time",
        LPercentage: "Percentage",
        LFraction: "Fraction",
        LScientific: "Scientific",
        LText: "Text",
        LCustom: "Custom",
        FormatSample: "Sample",
        Category: "Category:",
        Top: "Top",
        Center: "Center",
        Bottom: "Bottom",
        Left: "Left (Indent)",
        Right: "Right",
        Justify: "Justify",
        GeneralTxt: "General format cells have no specific number format.",
        NegativeNumbersTxt: "Negative Numbers",
        ThousandSeparatorTxt: "Use 1000 Separator",
        DecimalPlacesTxt: "Decimal Places:",
        TextTxt: "Text format cells are treated as text even when a number is in the cell. The cell is displayed exactly as entered.",
        BoldItalic: "Bold Italic",
        Regular: "Regular",
        HyperLinkHide: "<<Selection in Document>>",
        InvalidSheetIndex: "Specify proper SheetIndex",
        HugeDataAlert: "File too large to open.",
        ImportExportUrl: "Give import/export URL and try again.",
        TitleColumnChart: "Clustered Column/Stacked Column/100% Stacked Column/3D Clustered Column/3D Stacked Column/ 3D 100% Stacked Column",
        TitleBarChart: "Clustered Bar/Stacked Bar/100% Stacked Bar/3D Clustered Bar/3D Stacked Bar/3D 100% Stacked Bar",
        TitleRadarChart: "Radar/Radar with Markers",
        TitleLineChart: "Line/Line with Markers",
        TitleAreaChart: "Area/Stacked Area/100% Stacked Area",
        TitlePieChart: "Pie/3D Pie/Doughnut",
        TitleScatterChart: "Scatter",
        BetweenAlert: "The Maximum must be greater or equal to the Minimum.",
        BorderStyles: "Solid/Dashed/Dotted",
        FPaneAlert: "Freeze Pane is not applied for the First Cell",
        ReplaceNotFound: "Spreadsheet cannot find a match.",
        BlankWorkbook: "Blank workbook",
        SaveAsExcel: "Save As Excel",
        SaveAsCsv: "Save As CSV",
        SaveAsPdf: "Save As PDF",
        Design: "DESIGN",
        NewName: "New Name",
        FormulaBar: "Formula Bar",
        NameBox: "Name Box",
        NumberValMsg: "Decimal values cannot be used for number conditions.",
        NumberAlertMsg: "Enter only digits.",
        ListAlert: "Cell range is incorrect, Please enter correct cell range.",
        ListValAlert: "The list source must be a delimited list, or a reference to single row or column.",
        ListAlertMsg: "The value you entered is not valid",
        AutoFillTitle: "AutoFillOptions",
        NewSheet: "New Sheet",
        FullSheetCopyPasteAlert: "We can't paste because the Copy area and paste area aren't the same size.",
        Heading: "Headings",
        Gridlines: "Gridlines",
        Firstsheet: "Scroll to the first sheet",
        Lastsheet: "Scroll to the last sheet",
        Nextsheet: "Scroll to the next sheet",
        Prevsheet: "Scroll to the previous sheet",
        ProtectWorkbook: "Protect Workbook",
        UnProtectWorkbook: "Unprotect Workbook",
        ProtectWBContent: "Keep others from making structural changes to your workbook",
        Password: "Password",
        ConfirmPassword: "Reenter password to proceed:",
        PasswordAlert1: "Confirmation password is not identical.",
        PasswordAlert2: "Please enter a password.",
        PasswordAlert3: "The password you supplied is not correct. Verify that the CAPS LOCK key is off and be sure to use the correct capitalization.",
        Protect: "is protected.",
        Lock: "LockCell",
        Unlock: "UnlockCell",
        Protectsheet: "Protect Sheet",
        ProtectSheetToolTip: "Prevent unwanted changes from others by limiting their ability to edit",
        Unprotect: "Unprotect Sheet",
        LockAlert: "The cell you are trying to change is on protected sheet. To make changes, click Unprotect Sheet in the Review tab.",
        InsertDeleteAlert: "This operation is not allowed. The operation is attempting to shift cells in a table/Filter range on your worksheet.",
        CreateRule: "New Rule",
        NewRule: "New Formatting Rule",
        NewRuleLabelContent: "Format values where this formula is true:",
        ReadOnly: "The range you are trying to change contains readonly cells.",
        CreatePivotTable: "Create PivotTable",
        Range: "Range:",
        ChoosePivotTable: "Choose where you want the PivotTable to be placed",
        NewWorksheet: "New Worksheet",
        ExistingWorksheet: "Existing Worksheet",
        Location: "Location:",
        Refresh: "Refresh",
        PivotRowsAlert: "This command requires at least two rows of source data. You cannot use the command on a selection in only one row.",
        PivotLabelsAlert: "The PivotTable field name is not valid, To create a PivotTable report, you must use data that is organized as a list with labeled columns. If you are changing the name of a PivotTable field, you must type a new name for the field.",
        FieldList: "Field List",
        MergeSortAlert: "To do this, all the merged cells need to be the same size.",
        FormulaSortAlert: "The sort range with formula cannot be sorted.",
        MergePreventInsertDelete: "This operation is not allowed. The operation is attempting to shift a merge cells on your worksheet.",
        FormulaRuleMsg: "Please enter correct format.",
        MovePivotTable: "Move PivotTable",
        MovePivotTableContent: "Move the PivotTable to another location in the workbook.",
        ClearAllContent: "Remove fields and filters.",
        ChangeDataSource: "Modify",
        ChangeDataSourceContent: "Change the source data for this PivotTable",
        ChangePivotTableDataSource: "Change PivotTable Data Source",
        TotalRowAlert: "This operation is not allowed. The operation is attempting to shift cells in a table on your worksheet. Click OK to proceed with entire row.",
        CellTypeAlert: "This operation is not allowed in cell type applied range.",
        PivotOverlapAlert: "A PivotTable report cannot overlap another PivotTable report",
        NoCellFound: "No cells were found",
        CorrectArgument: "Please enter the correct argument",
        CorrectFormula: "Please enter the correct formula",
        CorrectCellAddress: "Please enter the correct cell address",
        ChartType: "Chart Type",
        NumberValidationAlert: "The Maximum must be greater than or equal to Minimum",
        DateValidationAlert: "The End Date must be greater than or equal to Start Date",
        TimeValidationAlert: "The End Time must be greater than or equal to Start Time",
        NewRuleAlert: "There's a problem with this formula",
        DragAlert: "The command could not be completed as you are attempting to move cells within the filter range. Select a range out of the filter range and try the command again.",
        OR: "or",
        HOME: "HOME",
        INSERT: "INSERT",
        DATATAB: "DATA",
        PAGELAYOUT: "PAGE LAYOUT",
        REVIEW: "REVIEW",
        OTHERS: "OTHERS",
        FORMAT: "Format",
        DESIGN: "DESIGN",
        CHARTDESIGN: "Chart Design",
        ANALYZE: "Analyze"
    };

    ej.Spreadsheet.scrollMode = {
        Normal: "normal",
        Infinite: "infinite"
    };

    ej.Spreadsheet.AutoFillOptions = {
        CopyCells: "copycells",
        FillSeries: "fillseries",
        FillFormattingOnly: "fillformattingonly",
        FillWithoutFormatting: "fillwithoutformatting",
        FlashFill: "flashfill"
    };

    ej.Spreadsheet.autoFillDirection = {
        Up: "up",
        Right: "right",
        Down: "down",
        Left: "left"
    };

    ej.Spreadsheet.pageSize = {
        A4: "A4",
        A3: "A3",
        Letter: "Letter"
    };

    ej.Spreadsheet.Actions = {
        Sorting: "sorting",
        Selection: "selection",
        AutoFill: "autofill",
        CellNavigation: "cellnavigation",
        Filtering: "filtering"
    };

    ej.Spreadsheet.exportType = {
        Excel: "Excel",
        Csv: "Csv",
        Pdf: "Pdf"
    };

    ej.Spreadsheet.CustomCellType = {
        Button: "Button",
        CheckBox: "CheckBox",
        DropDownList: "DropDownList",
        DatePicker: "DatePicker"
    };

    ej.Spreadsheet.CellType = {
        String: "string",
        Number: "number",
        Custom: "custom",
        Formula: "formula",
        Time: "time",
        LongDate: "longdate",
        ShortDate: "shortdate",
        Scientific: "scientific",
        Fraction: "fraction",
        Text: "text",
        General: "general",
        Accounting: "accounting",
        Currency: "currency",
        Percentage: "percentage",
        Date: "date",
        DateTime: "datetime"
    };

    ej.Spreadsheet.SupportedStyles = {
        FontFamily: "font-family",
        FontSize: "font-size",
        FontStyle: "font-style",
        FontWeight: "font-weight",
        TextAlign: "text-align",
        TextDecoration: "text-decoration",
        VerticalAlign: "vertical-align",
        TextIndent: "text-indent"
    };

    ej.Spreadsheet.Validation = {
        ">": "GreaterThan",
        ">=": "GreaterOrEqualTo",
        "<": "LessThan",
        "<=": "LessThanOrEqualTo",
        "==": "EqualTo",
        "!=": "NotEqualTo",
        "!": "Not",
        "=": ""
    };

    ej.Spreadsheet.ValidationText = {
        ">": "greater than",
        ">=": "greater than or equal to",
        "<": "less than",
        "<=": "less than or equal to",
        "==": "equal to",
        "!=": "not equal to",
        "!": " not",
        "=": ""
    };

    ej.Spreadsheet.msg = " ";

    ej.Spreadsheet.getMsg = function () {
        return ej.Spreadsheet.msg;
    };

    ej.Spreadsheet.SelectionType = {
        Row: "row",
        Column: "column",
        Default: "default"
    };

    ej.Spreadsheet.SelectionUnit = {
        Single: "single",
        Range: "range",
        MultiRange: "multirange"
    };

    ej.Spreadsheet.Align = {
        Left: "left",
        Right: "right",
        Center: "center"
    };

    ej.Spreadsheet.CFormatRule = {
        GreaterThan: "greaterthan",
        LessThan: "lessthan",
        Between: "between",
        EqualTo: "equalto",
        TextContains: "textcontains",
        DateOccur: "dateoccur"
    };

    ej.Spreadsheet.ContextMenu = {
        Cell: "cell",
        RowHeader: "rowheader",
        ColumnHeader: "columnheader",
        Footer: "footer"
    };

    ej.Spreadsheet.CFormatHighlightColor = {
        RedFillwithDarkRedText: "redft",
        YellowFillwithDarkYellowText: "yellowft",
        GreenFillwithDarkGreenText: "greenft",
        RedFill: "redf",
        RedText: "redt",
    };


    ej.Spreadsheet.BorderType = {
        Top: "top",
        Left: "left",
        Right: "right",
        Bottom: "bottom",
        OutSide: "outside",
        AllBorder: "allborder",
        ThickBox: "thickbox",
        ThickBottom: "thickbottom",
        TopandBottom: "topandbottom",
        TopandThickBottom: "topandthickbottom"
    };
    ej.Spreadsheet.ChartProperties = {
        PrimaryHorizontal: "PHAxis",
        PrimaryVertical: "PVAxis",
        PrimaryHorizontalAxisTitle: "PHAxisTitle",
        PrimaryVerticalAxisTitle: "PVAxisTitle",
        TitleNone: "CTNone",
        TitleCenter: "CTCenter",
        TitleFar: "CTFar",
        TitleNear: "CTNear",
        DataLabelNone: "DLNone",
        DataLabelCenter: "DLCenter",
        DataLabelInsideBase: "DLIBase",
        DataLabelInsideEnd: "DLIEnd",
        DataLabelOutsideEnd: "DLOEnd",
        PrimaryMajorHorizontal: "PMajorH",
        PrimaryMajorVertical: "PMajorV",
        PrimaryMinorHorizontal: "PMinorH",
        PrimaryMinorVertical: "PMinorV",
        LegendsNone: "LNone",
        LegendsLeft: "LLeft",
        LegendsRight: "LRight",
        LegendsBottom: "LBottom",
        LegendsTop: "LTop"
    };
    ej.Spreadsheet.HideTypes = {
        Default: "default",
        Freeze: "freeze"
    }
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.selection = function (obj) {
        this.XLObj = obj;
        this._isRightClick = false;
        this._colhdrClick = false;
        this._rowhdrClick = false;
        this._aFillDownHandler = false;
        this._isOutsideBordering = false;
        this._isGridBordering = false;
        this._isRowSelected = false;
        this._isColSelected = false;
        this._isEndReached = true;
        this._canTouchMove = false;
    };

    ej.spreadsheetFeatures.selection.prototype = {
        _selectionMouseDownHandler: function (e) {
            var moveEvt, endEvt, xlObj = this.XLObj, sheet = xlObj.getSheet(), trgt = e.target;
            if (xlObj._isTouchEvt) {
                if (xlObj._browserDetails.name === "msie")
                    e.preventDefault();
                if (xlObj._isSelected(e.target) || xlObj._hasClass(e.target, "e-autofill")) {
                    moveEvt = xlObj._getBrowserEvt("move");
                    this._canTouchMove = true;
                }
                endEvt = xlObj._getBrowserEvt("end");
            }
            else {
                e.preventDefault();
                moveEvt = xlObj._getBrowserEvt('move', true);
                endEvt = xlObj._getBrowserEvt('end', true);
                endEvt += " mouseleave"
            }
            xlObj._on($(document), endEvt, this._mouseUpHandler);
            if ((e.which === 3 || e.button === 2) || xlObj.model.selectionSettings.selectionUnit === ej.Spreadsheet.SelectionUnit.Single)
                this._isRightClick = true;
            else if (moveEvt)
                xlObj._on(xlObj.element, moveEvt, this._mouseMoveHandler);
            if (trgt.tagName == "TD") {
                if (xlObj.XLEdit._isFormulaEdit) {
                    if (e.ctrlKey) {
                        this._clearBorder(xlObj._arrayAsString(xlObj._ctrlFormulaBorder));
                        xlObj._ctrlKeyCount = xlObj._formulaRange.length;
                    }
                    xlObj._dStartCell = xlObj._getCellIdx(trgt);
                }
                else if (e.shiftKey && sheet._startCell.rowIndex != -1)
                    sheet._endCell = xlObj._getCellIdx(trgt);
                else {
                    sheet._startCell = xlObj._getCellIdx(trgt);
                    sheet._activeCell = xlObj._getCellIdx(trgt);
                }
                if (trgt.className.indexOf("e-rowheader") > -1)
                    this._rowhdrClick = true;
            }
            else if (trgt.parentNode.tagName == "TH") {  // check for parentnode issue for all
                if (e.shiftKey && sheet._startCell.rowIndex != -1)
                    sheet._endCell = { rowIndex: 0, colIndex: trgt.parentNode.cellIndex };
                else {
                    sheet._startCell = { rowIndex: 0, colIndex: trgt.parentNode.cellIndex };
                    sheet._activeCell = { rowIndex: 0, colIndex: trgt.parentNode.cellIndex };
                }
                if (trgt.className.indexOf("e-headercelldiv") > -1)
                    this._colhdrClick = true;
            }
            else if (trgt.className == "e-autofill")
                this._aFillDownHandler = true;
        },

        _mouseMoveHandler: function (e) {
            var status, chngdTouch, trgtCell, xlObj = this, selObj = xlObj.XLSelection, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx),
                trgt = e.target, range, type = xlObj.model.selectionSettings.selectionType, types = ej.Spreadsheet.SelectionType, imgElem = $(e.target).get(0);
            if (xlObj._isTouchEvt) {
                xlObj._isTouchMoveSel = true;
                chngdTouch = xlObj._getOriginalEvt(e);
                trgt = document.elementFromPoint(chngdTouch.clientX, chngdTouch.clientY);
                if (!trgt)
                    return;
            }
            if ($(trgt).hasClass("e-rowcell") || $(trgt).hasClass("e-rowheader")) {
                this.XLSelection._isEndReached = false;
                xlObj._getContent(sheetIdx).find("td").removeClass(xlObj._ctrlFormulaBorder[xlObj._ctrlKeyCount % 6].join(" "));
                if (xlObj.XLEdit._isFormulaEdit) {
                    if (e.ctrlKey) {
                        xlObj._dEndCell = xlObj._getCellIdx(trgt);
                        selObj._processFormulaRange(xlObj._ctrlFormulaBorder, true);
                    }
                    else {
                        xlObj._dEndCell = xlObj._getCellIdx(trgt);
                        selObj._processFormulaRange(xlObj._ctrlFormulaBorder, true);
                    }
                    return;
                }
                else if (selObj._aFillDownHandler && $(trgt).parents(".e-rowheadercontent").length === 0) {
                    if (xlObj.model.allowAutoFill) {
                        trgtCell = xlObj._getCellIdx(e.target);
                        if (sheet._isFreezed && trgtCell.rowIndex <= sheet.frozenRows && sheet._hiddenFreezeRows.indexOf(sheet.frozenRows) > -1)
                            selObj._scrollCalculation(sheetIdx, trgt, { position: "vertical", action: "Decrement" });
                        else if (sheet._isFreezed && trgtCell.colIndex <= sheet.frozenColumns && sheet._hiddenFreezeCols.indexOf(sheet.frozenColumns) > -1)
                            selObj._scrollCalculation(sheetIdx, trgt, { position: "horizontal", action: "Decrement" });
                        else
                            xlObj.XLDragFill._selectAutoFillRange(trgt);
                        return;
                    }  
                }
                else {
                    sheet._startCell = sheet._activeCell;
                    sheet._endCell = xlObj._getCellIdx(trgt);
                    if (sheet._isFreezed)
                        xlObj.XLFreeze._selectionScroll();
                    selObj._processBoundary();
                    if ($(trgt).parents(".e-spreadsheetcontentcontainer").length > 0) {
                        if (e.ctrlKey && xlObj.model.selectionSettings.selectionType === ej.Spreadsheet.SelectionType.Default && xlObj.model.selectionSettings.selectionUnit === ej.Spreadsheet.SelectionUnit.MultiRange) {
                            xlObj._getContent(xlObj.getActiveSheetIndex()).find("td").removeClass("e-activecell e-focusright e-focusbottom");
                            range = xlObj.swapRange([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]);
                            xlObj.getRange(range).addClass("e-ctrlselected");
                            selObj._focusRange(sheet._startCell, sheet._endCell, xlObj._selectionBorder);
                            xlObj.model.allowAutoFill && xlObj.XLDragFill.hideAutoFillElement();
                            return;
                        }
                        else {
                            if (type === types.Row || selObj._rowhdrClick)
                                selObj.selectRows(sheet._startCell.rowIndex, sheet._endCell.rowIndex);
                            else if (type === types.Column || selObj._colhdrClick)
                                selObj.selectColumns(sheet._startCell.colIndex, sheet._endCell.colIndex);
                            else
                                selObj.selectRange(sheet._startCell, sheet._endCell, trgt);
                            if (sheet._isFreezed)
                                xlObj.XLFreeze._refreshSelection();
                        }
                    }
                    else if ($(trgt).parents(".e-rowheadercontent").length > 0)
                        if (selObj._colhdrClick || selObj._rowhdrClick) {
                            if (type === types.Column)
                                selObj.selectColumns(0, sheet.colCount - 1);
                            else
                                selObj.selectRows(sheet._startCell.rowIndex, sheet._endCell.rowIndex);
                            if (sheet._isFreezed)
                                xlObj.XLFreeze._refreshSelection();
                        }
                        else {
                            status = { position: "horizontal", action: "Decrement" };
                            selObj._scrollCalculation(sheetIdx, trgt, status);
                        }
                    else
                        return;
                }
            }
            else if (!ej.isNullOrUndefined(trgt.parentNode) && trgt.parentNode.tagName == "TH") {
                sheet._endCell = { rowIndex: 0, colIndex: trgt.parentNode.cellIndex };
                sheet._startCell = sheet._activeCell;
                if (sheet._isFreezed)
                        xlObj.XLFreeze._selectionScroll();
                selObj._processBoundary();
                if (selObj._colhdrClick || selObj._rowhdrClick) {
                    if (type === types.Row)
                        selObj.selectRows(0, sheet.rowCount - 1);
                    else
                        selObj.selectColumns(sheet._startCell.colIndex, sheet._endCell.colIndex);
                    if (sheet._isFreezed)
                        xlObj.XLFreeze._refreshSelection();
                }
                else {
                    status = { position: "vertical", action: "Decrement" };
                    selObj._scrollCalculation(sheetIdx, trgt, status);
                }
            }
            else if (imgElem.id.indexOf("chart") < 1 && (trgt.className.indexOf("e-hhandlespace") > -1 || trgt.className.indexOf("e-hhandle") > -1 || trgt.className.indexOf("e-hup") > -1 || trgt.className.indexOf("e-hdown") > -1)) {
                status = { position: "vertical", action: "Increment" };
                selObj._scrollCalculation(sheetIdx, trgt, status);
            }

            else if (imgElem.id.indexOf("chart") < 1 && (trgt.className.indexOf("e-vhandlespace") > -1 || trgt.className.indexOf("e-vhandle") > -1 || trgt.className.indexOf("e-vup") > -1 || trgt.className.indexOf("e-vdown") > -1)) {
                status = { position: "horizontal", action: "Increment" };
                selObj._scrollCalculation(sheetIdx, trgt, status);
            }
            else
                return;
        },

        _mouseUpHandler: function (e) {
            e.target = this._changeTargetWithOffset(e);
            var trgt, $trgt, mergeBtn, style, prctRange, cells, cell, currcell, autofillRange, options, btnObj, moveEvt, endEvt, chngdTouch, prfmDragFill = true,
                xlObj = this, selObj = xlObj.XLSelection, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), range = sheet.selectedRange,
                sheetElement = xlObj.getSheetElement(sheetIdx), type = xlObj.model.selectionSettings.selectionType, scell = sheet._startCell, eCell = sheet._endCell,
                types = ej.Spreadsheet.SelectionType,cont = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content");
            if (!xlObj.XLEdit._isEdit)
                xlObj.setSheetFocus();
            if (xlObj._isTouchEvt) {
                endEvt = xlObj._getBrowserEvt("end");
                if (selObj._canTouchMove)
                    moveEvt = xlObj._getBrowserEvt("move");
                xlObj._isTouchMoveSel = false;
            }
            else {
                moveEvt = xlObj._getBrowserEvt('move', true);
                endEvt = xlObj._getBrowserEvt('end', true);
                endEvt += " mouseleave"
            }
            if (moveEvt)
                xlObj._off(xlObj.element, moveEvt, selObj._mouseMoveHandler);
            xlObj._off($(document), endEvt, selObj._mouseUpHandler);
            if (xlObj._isTouchEvt) {
                if (!selObj._aFillDownHandler && xlObj._isTouchScroll || (!selObj._canTouchMove && !xlObj._isUniqueTarget(xlObj._touchArgs, e))) {
                    selObj._canTouchMove = xlObj._isTouchScroll = false;
                    return;
                }
                selObj._canTouchMove = xlObj._isTouchScroll = false;
                chngdTouch = xlObj._getOriginalEvt(e);
                trgt = document.elementFromPoint(chngdTouch.clientX, chngdTouch.clientY);
                if (!trgt) {
                    if (this.model.allowAutoFill)
                        this.XLDragFill.positionAutoFillElement();
                    return;
                }
            }            
            trgt = trgt || e.target, $trgt = $(trgt);
			if (trgt.tagName == "TD" || (trgt.tagName == "INPUT" && !$trgt.parents(".e-formulabar").length) || selObj._aFillDownHandler) {
			    if ($trgt.parents(".e-rowheadercontent").length) {
			        selObj._isOutsideBordering = selObj._isGridBordering = false;
					cont.removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor").addClass("e-ss-cursor");
				}
			    xlObj._preventctrlkey = e.ctrlKey;
			    if (xlObj.XLEdit._isFormulaEdit) {
			        cont.find("td").removeClass(xlObj._ctrlFormulaBorder.join(" ").replace(/,/g, " "));
                    if (e.ctrlKey) {
                        xlObj._dEndCell = xlObj._getCellIdx(trgt);
                        selObj._processFormulaRange(xlObj._formulaBorder);
                    }
                    else {
                        selObj._clearBorder(xlObj._formulaBorder.join(" ").replace(/,/g, " ") + " " + xlObj._ctrlFormulaBorder.join(" ").replace(/,/g, " "));
                        xlObj._ctrlKeyCount = 0;
                        xlObj._dEndCell = xlObj._getCellIdx(trgt);
                        selObj._processFormulaRange(xlObj._formulaBorder);
                        xlObj._formulaRange = [];
                    }
                    xlObj._formulaRange.push(xlObj._getProperAlphaRange(sheetIdx, xlObj._dStartCell.rowIndex, xlObj._dStartCell.colIndex, xlObj._dEndCell.rowIndex, xlObj._dEndCell.colIndex));
                    return;
                }
                else if (selObj._aFillDownHandler) {
                    currcell = trgt.tagName === "TD" ? xlObj._getCellIdx(trgt) : xlObj._dautoFillCell;
                    if (xlObj.model.allowAutoFill)
                        autofillRange = xlObj.XLDragFill._getAutoFillRange(currcell);
                    if (!autofillRange || !autofillRange.fillRange) {
                        selObj._aFillDownHandler = false;
                        xlObj.XLDragFill.positionAutoFillElement();
                        return;
                    }
                    prctRange = xlObj.swapRange(autofillRange.fillRange);
                    if (xlObj.model.allowLockCell && xlObj.getSheet(sheetIdx).isSheetProtected) {                  
                        if (xlObj._isPropExists([prctRange], "isLocked", sheetIdx))
                           prfmDragFill=false;                       
                    }
                    if (prfmDragFill && xlObj._isPropExists([prctRange], "isReadOnly", sheetIdx))
                        prfmDragFill = false;
                    if (!prfmDragFill) {
                        selObj._aFillDownHandler = false;
                        xlObj.XLSelection.selectRange(scell, eCell);
                        xlObj.XLDragFill.positionAutoFillElement();
                        return;
                    }
                    else if ("direction" in autofillRange) {
                        xlObj._pStartCell = sheet._startCell;
                        xlObj._pEndCell = sheet._endCell;
                        xlObj._pFillCell = currcell;
                        if (xlObj.inRange(sheet.selectedRange, currcell.rowIndex, currcell.colIndex))
                            xlObj.clearRangeData(null, null, $(selObj.getSelectedCells()).not(".e-autofillcell"));
                        else if(xlObj.model.allowAutoFill)
                            xlObj.XLDragFill.autoFill({ dataRange: sheet.selectedRange, fillRange: autofillRange.fillRange, direction: autofillRange.direction, fillType: xlObj.model.autoFillSettings.fillType });
                        sheet._startCell = autofillRange.startCell;
                        sheet._endCell = autofillRange.endCell;
                    }
                    else
                        selObj._aFillDownHandler = false;
                    selObj.refreshSelection(xlObj.swapRange([autofillRange.startCell.rowIndex, autofillRange.startCell.colIndex, autofillRange.endCell.rowIndex, autofillRange.endCell.colIndex]));
                }
                else if (selObj._isOutsideBordering || selObj._isGridBordering) {  // for border drawing
                    style = "1px " + xlObj._borderStyle + " " + xlObj._borderColor;
                    if (selObj._isRightClick)
                        sheet._endCell = sheet._startCell;
                    else {
                        sheet._startCell = sheet._activeCell;
                        sheet._endCell = xlObj._getCellIdx(trgt);
                        selObj._processBoundary();
                    }
                    if ($trgt.parents(".e-spreadsheetcontentcontainer").length) {
                        options = { top: style, right: style, bottom: style, left: style };
                        if (selObj._isGridBordering)
                            options.isGridBorder = true;
                        xlObj.XLFormat.applyBorder(options, xlObj.swapRange([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]));
                        selObj._cleanUp(true);
                    }
                    else
                        return;
                }
                else {
                    if (trgt.tagName == "INPUT" && $trgt.parents("tr").length)
                        sheet._endCell = selObj._isRightClick ? sheet._startCell : xlObj._getCellIdx($trgt.parents("td")[0]);
                    else {
                        if (selObj._isRightClick)
                            sheet._endCell = sheet._startCell;
                        else {
                            sheet._startCell = sheet._activeCell;
                            sheet._endCell = xlObj._getCellIdx(trgt);
                            selObj._processBoundary();
                        }
                    }
                    if ($trgt.parents(".e-spreadsheetcontentcontainer").length) {
                        if (e.ctrlKey && xlObj.model.selectionSettings.selectionType === ej.Spreadsheet.SelectionType.Default && xlObj.model.selectionSettings.selectionUnit === ej.Spreadsheet.SelectionUnit.MultiRange) {
                            cont.find("td").removeClass("e-activecell e-focustop e-focusleft e-ctrlselected");
                            range = xlObj.swapRange([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]);
                            xlObj.getRange(range).addClass("e-selected");
                            xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex).addClass('e-activecell');
                            selObj._focusRange(sheet._startCell, sheet._endCell, xlObj._selectionBorder);
                            if(xlObj.model.allowAutoFill)
                                xlObj.XLDragFill.hideAutoFillElement();
                            xlObj.getSheet(sheetIdx)._selectedCells.push(xlObj._getSelectedRange(xlObj.getSheet(sheetIdx)._startCell, xlObj.getSheet(sheetIdx)._endCell));  // consider
                            if(xlObj.model.showRibbon && xlObj.model.allowComments && sheetElement.find(".e-selected.e-commentcell").length)
                                xlObj.XLRibbon._enableButtons(["Review_Comments_DeleteComment"], "ejButton");
                            return;
                        }
                        else {
                            if (type === types.Row || selObj._rowhdrClick)
                                selObj.selectRows(sheet._startCell.rowIndex, sheet._endCell.rowIndex);
                            else if (type === types.Column || selObj._colhdrClick)
                                selObj.selectColumns(sheet._startCell.colIndex, sheet._endCell.colIndex);
                            else
                                selObj.selectRange(sheet._startCell, sheet._endCell, trgt);
                            if (sheet._isFreezed)
                                xlObj.XLFreeze._refreshSelection();
                        }
                    }
                    else if ($trgt.parents(".e-rowheadercontent").length) {
                        if (selObj._colhdrClick || selObj._rowhdrClick) {
                            if (type === types.Column)
                                selObj.selectColumns(0, sheet.colCount - 1);
                            else
                                selObj.selectRows(sheet._startCell.rowIndex, sheet._endCell.rowIndex);
                            selObj._hdrClick = false;
                        }
                        selObj._isOutsideBordering = selObj._isGridBordering = false;
						cont.removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor").addClass("e-ss-cursor");
                    }
                    else
                        return;
                }
                if (trgt.tagName === "TD" && xlObj.model.showRibbon) {
                    btnObj = $("#" + xlObj._id + "_Ribbon_clearfilter").data("ejButton");
                    if (btnObj)
                        xlObj.XLRibbon._changeClrFltrStatus(btnObj, "button", xlObj._getCellIdx(trgt));
                }
			}
            else if (!selObj._aFillDownHandler && !ej.isNullOrUndefined(trgt.parentNode) && trgt.parentNode.tagName == "TH") {
                sheet._startCell = sheet._activeCell;
                sheet._endCell = selObj._isRightClick ? sheet._startCell : { rowIndex: 0, colIndex: trgt.parentNode.cellIndex };
                selObj._processBoundary();
                if (selObj._colhdrClick || selObj._rowhdrClick) {
                    if (type === types.Row)
                        selObj.selectRows(0, sheet.rowCount - 1);
                    else
                        selObj.selectColumns(sheet._startCell.colIndex, sheet._endCell.colIndex);
                }
                selObj._isOutsideBordering = selObj._isGridBordering = false;
				cont.removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor").addClass("e-ss-cursor");
            }
            else if (typeof trgt.className != "object" && trgt.className && trgt.className.indexOf("e-spreadsheetcolumnheader") > -1) {
                selObj.selectSheet(true);
                selObj._isOutsideBordering = selObj._isGridBordering = false;
				cont.removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor").addClass("e-ss-cursor");
            }
			if(xlObj.model.allowCellFormatting && xlObj.XLFormat._formatEnable)
			    xlObj.XLFormat._fPMouseUp(e);
			if(xlObj.model.showRibbon)
			    xlObj.XLEdit._isEdit ? xlObj.XLRibbon._disableRibbonIcons() : xlObj.XLRibbon._updateRibbonIcons();
			if (xlObj.model.allowAutoFill && !selObj._isOutsideBordering && !selObj._isGridBordering)
			    xlObj.XLDragFill.positionAutoFillElement(selObj._aFillDownHandler);
            selObj._isRightClick = selObj._aFillDownHandler = false;
            selObj._colhdrClick = selObj._rowhdrClick = false;
            if (xlObj.model.showRibbon) {
                mergeBtn = $("#" + xlObj._id + "_Ribbon_merge").data("ejSplitButton");
                if (!ej.isNullOrUndefined(mergeBtn) && (xlObj.model.allowLockCell && !sheet.isSheetProtected))
                    xlObj.XLRibbon._isDirtySelect ? mergeBtn.option("enabled", false) : mergeBtn.option("enabled", true);
            }
            if (xlObj.model.allowEditing && this.XLEdit._isEdit) {
                cell = xlObj.getSheet(sheetIdx)._startCell;
                xlObj.getCell(cell.rowIndex, cell.colIndex).find('.e-ss-input').focus();
            }
        },

        _processBoundary: function () {
            var i, status, cell, cells, mergeIdx, idx, arr = [], xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                sheet = xlObj.getSheet(sheetIdx), sCell = sheet._startCell, eCell = sheet._endCell,
                range = xlObj.swapRange([sCell.rowIndex, sCell.colIndex, eCell.rowIndex, eCell.colIndex]);
            sheet._startCell = { rowIndex: range[0], colIndex: range[1] };
            sheet._endCell = { rowIndex: range[2], colIndex: range[3] }; 
            cells = xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[0], colIndex: range[3] });// top
            cells = cells.concat(xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[3] }, { rowIndex: range[2], colIndex: range[3] }));// right
            cells = cells.concat(xlObj._getSelectedRange({ rowIndex: range[2], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }));// bottom
            cells = cells.concat(xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[1] }));// left
            i = cells.length;
            while (i--) {
                cell = cells[i];
                mergeIdx = xlObj.XLEdit.getPropertyValue(cells[i].rowIndex, cells[i].colIndex, "mergeIdx", sheetIdx);
                idx = (cell.rowIndex + ":" + cell.colIndex).toString();
                status = xlObj.hasSpan(cell) && arr.indexOf(idx) === -1 && (arr.push(idx), this._updateRange(cell, range));
                if (mergeIdx) {
                    idx = (mergeIdx.rowIndex + ":" + mergeIdx.colIndex).toString();
                    if (arr.indexOf(idx) === -1) {
                        arr.push(idx);
                        status = this._updateRange(mergeIdx, range);
                    }
                }
                if (status)
                    break;
            }
            if(status)
                this._processBoundary();
        },

        _updateRange: function (cell, range) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), temp = range.slice(0),
            mergeRange = xlObj._getMergedIdx(cell.rowIndex, cell.colIndex), minr = cell.rowIndex,
            minc = cell.colIndex, maxr = mergeRange.rowIndex, maxc = mergeRange.colIndex;
            minr < range[0] && (range[0] = minr);
            minc < range[1] && (range[1] = minc);
            maxr > range[2] && (range[2] = maxr);
            maxc > range[3] && (range[3] = maxc);
            if (range[0] != temp[0] || range[1] != temp[1] || range[2] != temp[2] || range[3] != temp[3]) {
                sheet._startCell = { rowIndex: range[0], colIndex: range[1] };
                sheet._endCell = { rowIndex: range[2], colIndex: range[3] };
                return true;
            }
        },

        selectRange: function (range, endCell, trgt, isbgSelect) {
            var args, cells, cnt, currRange, isTrue, isUndefined, isVirScroll, prevRange, sheet, sheetIdx, startCell = range,
                xlObj = this.XLObj, selected = "e-selected";
            if (!xlObj.model.allowSelection)
                return;
            if (!xlObj._isObject(range)) {
                range = xlObj._getRangeArgs(range, "object");
                startCell = { rowIndex: range[0], colIndex: range[1] };
                endCell = { rowIndex: range[2], colIndex: range[3] };
            }
            sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            isVirScroll = xlObj.model.scrollSettings.allowVirtualScrolling;
            if (isVirScroll)
                sheet._goToCollection = { multiple: false, selected: [] };
            prevRange = sheet.selectedRange;
            currRange = xlObj.swapRange([startCell.rowIndex, startCell.colIndex, endCell.rowIndex, endCell.colIndex]);
            isTrue = !xlObj.isImport && (!sheet._isImported || sheet._isLoaded);
            if (isTrue && xlObj.model.beforeCellSelect) {
                args = { prevRange: prevRange, currRange: currRange, sheetIdx: sheetIdx };
                if (trgt)
                    args.target = trgt;
                if (!xlObj._intrnlReq && xlObj._trigger("beforeCellSelect", args))
                    return;
            }
            xlObj._dStartCell = startCell;
            xlObj._dEndCell = endCell;
            sheet.selectedRange = currRange.slice(0);
            this._cleanUp(false);
            if (xlObj.model.scrollSettings.allowScrolling && isVirScroll && sheet._isColSelected) {
                if (sheet._virtualRowIdx.indexOf(currRange[0]) === -1)
                    currRange[0] = sheet._virtualRowIdx[0];
                if (sheet._virtualRowIdx.indexOf(currRange[2]) === -1)
                    currRange[2] = sheet._virtualRowIdx[sheet._virtualRowIdx.length - 1];
            }
            isUndefined = xlObj.isUndefined(isbgSelect);
            if (isUndefined) {
                cells = xlObj.getRange(currRange);
                cnt = cells.length;
                if (cnt) {
                    while (cnt--)
                        xlObj.addClass(cells[cnt], selected);
                }
            }            
            if (!xlObj.inRange(sheet.selectedRange, sheet._activeCell.rowIndex, sheet._activeCell.colIndex)) // to set first cell as active cell #default
                sheet._activeCell = { rowIndex: sheet.selectedRange[0], colIndex: sheet.selectedRange[1] };
            sheet._activeCell = xlObj._getMergeParent(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);            
            if (xlObj._isRowViewable(sheetIdx, sheet._activeCell.rowIndex))
                xlObj.addClass(xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex)[0], "e-activecell");               
            if (isUndefined) {
                this._focusRange(startCell, endCell, xlObj._selectionBorder);
                this._highlightHeader(currRange);
            }
            sheet._selectedCells = xlObj._getSelectedRange(startCell, endCell);
            if (xlObj.model.allowFormulaBar)                
                xlObj.updateFormulaBar();
			if(startCell.rowIndex === 0 && (endCell.rowIndex === sheet.rowCount - 1))
				this._isColSelected = true;
			if(startCell.colIndex === 0 && (endCell.colIndex === sheet.colCount - 1))
				this._isRowSelected = true;
            if(isUndefined && (xlObj.model.enableContextMenu || xlObj.model.showRibbon))
                xlObj.XLRibbon._dirtySelect(cells);
            xlObj._isMultiSelect = true;
            if (xlObj.model.showRibbon)
                xlObj.XLRibbon._updateRibbonIcons();
            if (!xlObj._isSheetNavigate)
                sheet._isEmptyActiveCell = sheet._isRangeSelected = sheet._isRowSelected = sheet._isColSelected = sheet._isSheetSelected = false;
            if (isTrue && xlObj.model.cellSelected) {
                args = { selectedRange: sheet.selectedRange, target: trgt, sheetIdx: sheetIdx };
                if (!xlObj._intrnlReq)
                    xlObj._trigger("cellSelected", args);
            }
        },

        selectRow: function (rowIdx) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());
            if (!xlObj.model.allowSelection)
                return;
            sheet._startCell = { rowIndex: rowIdx, colIndex: 0 };
            sheet._endCell = { rowIndex: rowIdx, colIndex: sheet.colCount - 1 };
            this.selectRange(sheet._startCell, sheet._endCell);
            this._selectRow(xlObj._getRowIdx(rowIdx), "e-rowselected");
            sheet._isRowSelected = true;
        },

        selectRows: function (startIndex, endIndex) {
            var sheet, xlObj = this.XLObj;
            if (!xlObj.model.allowSelection)
                return;
            sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());            
            sheet._startCell = { rowIndex: startIndex, colIndex: 0 };
            sheet._endCell = { rowIndex: endIndex, colIndex: sheet.colCount - 1 };
            this.selectRange(sheet._startCell, sheet._endCell);
            this._markHeaderSelection([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex], "row");
            sheet._isRowSelected = true;
        },

        selectColumn: function (colIdx) {
            var sheet, xlObj = this.XLObj;
            if (!xlObj.model.allowSelection)
                return;
            sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());
            sheet._startCell = { rowIndex: 0, colIndex: colIdx };
            sheet._endCell = { rowIndex: sheet.rowCount - 1, colIndex: colIdx };
            this.selectRange(sheet._startCell, sheet._endCell);
            this._selectColumn(colIdx, "e-colselected");
            sheet._isColSelected = true;
        },

        selectColumns: function (startIndex, endIndex) {
            var sheet, xlObj = this.XLObj;
            if (!xlObj.model.allowSelection)
                return;
            sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());
            sheet._startCell = { rowIndex: 0, colIndex: startIndex };
            sheet._endCell = { rowIndex: sheet.rowCount - 1, colIndex: endIndex };
            this.selectRange(sheet._startCell, sheet._endCell);
            this._markHeaderSelection([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex], "column");
            sheet._isColSelected = true;
        },

        selectSheet: function (isMouse) {
            var  xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());
            if (!xlObj.model.allowSelection)
                return;
            if(isMouse)
                sheet._activeCell = { rowIndex: sheet._topRow.idx, colIndex: 0 };
            sheet._startCell = { rowIndex: 0, colIndex: 0 };
            sheet._endCell = { rowIndex: sheet.rowCount - 1, colIndex: sheet.colCount - 1 };
            this.selectRange(sheet._startCell, sheet._endCell);
            xlObj.element.find(".e-spreadsheetcolumnheader").addClass("e-sheetselected");           
            sheet._isSheetSelected = true;
        },

        refreshSelection: function (range) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), range = xlObj._getRangeArgs(range, "object"),
                minr = range[0], minc = range[1], maxr = range[2], maxc = range[3];
            if (sheet._isRowSelected)
                this.selectRows(minr, maxr);
            else if (sheet._isColSelected)
                this.selectColumns(minc, maxc);
            else if (sheet._isSheetSelected)
                this.selectSheet();
            else
                this.selectRange({ rowIndex: minr, colIndex: minc }, { rowIndex: maxr, colIndex: maxc });
        },

        getSelectedCells: function (sheetIdx) {
            return this.XLObj._getContent(this.XLObj._getSheetIndex(sheetIdx))[0].querySelectorAll("td.e-selected");
        },

        _select: function (args, classname) {
            var elem = this.XLObj.getCell(args.rowIndex, args.colIndex);
            if (elem)
                elem.addClass(classname);
        },

        _selectRow: function (args, classname) {
            var elem = this.XLObj._getJSSheetRowHeaderContent(this.XLObj.getActiveSheetIndex()).find("td:eq(" + args + ")");
            if (elem)
                elem.addClass(classname);
        },

        _selectRows: function (startRIndex, endRIndex, classname) {
            var len, sRIndex, eRIndex, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                sheet = xlObj.getSheet(sheetIdx), elems = xlObj._getJSSheetRowHeaderContent(sheetIdx).find("td");
            sRIndex = xlObj._getRowIdx(startRIndex);
            eRIndex = xlObj._getRowIdx(endRIndex);
            if (sRIndex === -1) {
                if (startRIndex < sheet._virtualRowIdx[0])
                    sRIndex = 0;
                else
                    return;
            }
            if (eRIndex === -1) {
                len = sheet._virtualRowIdx.length - 1;
                if (endRIndex > sheet._virtualRowIdx[len])
                    eRIndex = len;
                else
                    return;
            }
            elems = (sRIndex !== eRIndex) ? elems.slice(sRIndex, eRIndex + 1) : elems.eq(eRIndex);
            len = elems.length;
            if (len) {
                while (len--)
                    xlObj.addClass(elems[len], classname);
            }            
        },


        _selectColumn: function (args, classname) {
            var elem = this.XLObj._getJSSheetHeader(this.XLObj.getActiveSheetIndex()).find("th:eq(" + args + ")");
            if (elem)
                elem.addClass(classname);
        },

        _selectColumns: function (startCIndex, endCIndex, classname) {
            var i, xlObj = this.XLObj, elems = xlObj._getJSSheetHeader(xlObj.getActiveSheetIndex()).find("th");
            elems = (endCIndex !== startCIndex) ? elems.slice(startCIndex, endCIndex + 1) : elems.eq(endCIndex);
            i = elems.length;            
            if (i) {
                while (i--)
                    xlObj.addClass(elems[i], classname);
            }
        },

        _focusBorder: function (startcell, endcell, classes) {  // consider
            var xlObj = this.XLObj, range = xlObj.swapRange([startcell.rowIndex, startcell.colIndex, endcell.rowIndex, endcell.colIndex]),
            minr = range[0], minc = range[1], maxr = range[2], maxc = range[3];
            if(minr)
                xlObj.getRange([minr - 1, minc, minr - 1, maxc]).addClass(classes[1]); // top, original minr -1 in 3rd args, minc in 2nd args                            
            xlObj.getRange([minr, maxc, maxr, maxc]).addClass(classes[0]); // right
            xlObj.getRange([maxr, minc, maxr, maxc]).addClass(classes[1]); // bottom
            if(minc)
                xlObj.getRange([minr, minc - 1, maxr, minc - 1]).addClass(classes[0]); // left, original is minc - 1 in 2nd args, maxr in 3rd args
        },

        _focusRange: function (startcell, endcell, border) {
            var elem, i = 4, xlObj = this.XLObj, elems = [xlObj.getFocusTopElem(), xlObj.getFocusRightElem(), xlObj.getFocusBottomElem(), xlObj.getFocusLeftElem()],
                classes = ["e-focustop ", "e-focusright ", "e-focusbottom ", "e-focusleft "];            
            while (i--) {
                elem = elems[i][0];
                xlObj._removeClass(elem);
                xlObj.addClass(elem, classes[i] + border[i]);
            }
            this._refreshBorder(xlObj.swapRange([startcell.rowIndex, startcell.colIndex, endcell.rowIndex, endcell.colIndex]));
        },

        _refreshBorder: function (range) {
            range = range ? range : this.XLObj.getSheet().selectedRange;
            var type, time, bleft, lleft, ttop, tleft, hide = "e-hide", i = 4, minr = range[0], minc = range[1], xlObj = this.XLObj, focusInfo = this._focusInfo(range), 
                topElem = xlObj.getFocusTopElem(), rightElem = xlObj.getFocusRightElem(), bottomElem = xlObj.getFocusBottomElem(),
                leftElem = xlObj.getFocusLeftElem(), elems = [topElem, rightElem, bottomElem, leftElem], ltop = ttop = focusInfo.topLeft.top,      
                twid = (focusInfo.topRight.left + focusInfo.topRight.width) - focusInfo.topLeft.left,
                rtop = focusInfo.topRight.top, rleft = focusInfo.topRight.left + focusInfo.topRight.width, rhgt = (focusInfo.bottomRight.top + focusInfo.bottomRight.height) - rtop,
                btop = focusInfo.bottomLeft.top + focusInfo.bottomLeft.height, bwid = (focusInfo.bottomRight.left + focusInfo.bottomRight.width) - focusInfo.bottomLeft.left, lhgt = btop - ttop;
            bleft = lleft = tleft = focusInfo.topLeft.left;
            while (i--)
                xlObj._removeClass(elems[i][0], hide);
            if (xlObj.model.selectionSettings.enableAnimation) {
                type = xlObj.model.selectionSettings.animationType;
                time = xlObj.model.selectionSettings.animationTime;
                minr ? topElem.animate({ top: ttop.toString(), left: tleft.toString(), width: twid.toString() }, time, type) : topElem.addClass(hide);
                rightElem.animate({ top: rtop.toString(), left: rleft.toString(), height: rhgt.toString() }, time, type);
                bottomElem.animate({ top: btop.toString(), left: bleft.toString(), width: bwid.toString() }, time, type);
                minc ? leftElem.removeClass(hide).animate({ top: ltop.toString(), left: lleft.toString(), height: lhgt.toString() }, time, type) : leftElem.addClass(hide);
            }
            else {
                minr ? topElem.css({ top: ttop, left: tleft, width: twid }) : topElem.addClass(hide);
                rightElem.css({ top: rtop, left: rleft, height: rhgt });
                bottomElem.css({ top: btop, left: bleft, width: bwid });
                minc ? leftElem.css({ top: ltop, left: lleft, height: lhgt }) : leftElem.addClass(hide);
            }
        },

        _focusInfo: function (range) {
            var obj = {}, minr = range[0], minc = range[1], maxr = range[2], maxc = range[3], xlObj = this.XLObj;
            obj.topLeft = xlObj._getCellInfo({ rowIndex: minr, colIndex: minc });
            obj.topRight = xlObj._getCellInfo((minc === maxc) ? { rowIndex: minr, colIndex: maxc } : xlObj._getMergedIdx(minr, maxc));
            obj.bottomLeft = xlObj._getCellInfo({ rowIndex: maxr, colIndex: minc });
            obj.bottomRight = xlObj._getCellInfo(xlObj._getMergedIdx(maxr, maxc));
            return obj;
        },

        _highlightHeader: function (range) {
            this._selectRows(range[0], range[2], "e-rowhighlight");
            this._selectColumns(range[1], range[3], "e-colhighlight");
        },

        _hideShowSelElem: function (dsply) {
            var xlObj = this.XLObj, method = (dsply === "block") ? "_removeClass" : "addClass";
            if (!xlObj.model.allowSelection)
                return;
            xlObj[method](xlObj.getAutoFillElem()[0], "e-hide");
            xlObj[method](xlObj.getFocusBottomElem()[0], "e-hide");
            xlObj[method](xlObj.getFocusTopElem()[0], "e-hide");
            xlObj[method](xlObj.getFocusLeftElem()[0], "e-hide");
            xlObj[method](xlObj.getFocusRightElem()[0], "e-hide");
        },

        _markHeaderSelection: function (range, type) {
            var i, j, xlObj = this.XLObj;
            range = xlObj.swapRange(range);
            i = range[0];
            if (type === "row") {
                j = range[2];
                while (i <= j) {
					if(xlObj._isRowViewable(xlObj.getActiveSheetIndex(), i))
						this._selectRow(xlObj._getRowIdx(i), "e-rowselected");
                    i++;
                }
            }
            else {
                i = range[1];
                j = range[3];
                while (i <= j) {
                    this._selectColumn(i, "e-colselected");
                    i++;
                }
            }
        },

        _processFormulaRange: function (border, ismousemove) {
            var alpharange, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), scell = xlObj._dStartCell, ecell = xlObj._dEndCell,
                editcell = xlObj._getContent(sheetIdx).find(".e-editedcell");
            this._focusBorder(scell, ecell, border[xlObj._ctrlKeyCount % 6]);                        
            if (xlObj.model.allowAutoFill) {
                alpharange = xlObj._getAlphaRange(sheetIdx, scell.rowIndex, scell.colIndex, ecell.rowIndex, ecell.colIndex);
                xlObj.XLDragFill.hideAutoFillElement();
                xlObj.XLEdit._updateFormulaCellRange(alpharange);
            }
            xlObj.XLEdit._isCellEdit ? xlObj.XLEdit._focusElements(editcell) : xlObj._getInputBox().focus();
        },


        _scrollCalculation: function (sheetIdx, target, status) {
            var interval, reachedEnd, hScroll, vScroll, xlObj = this.XLObj, sheet, diff;
            if (xlObj.model.scrollSettings.allowVirtualScrolling)
                return;
            sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());
            xlObj.XLSelection._isEndReached = true;
            interval = setInterval(function (e) {
                hScroll = xlObj.XLScroll._hScroller(sheetIdx);
                vScroll = xlObj.XLScroll._vScroller(sheetIdx);
                if (!xlObj.XLSelection._isEndReached) {
                    clearInterval(interval);
                    return;
                }
                if (status.position === "horizontal") {
                    if (status.action == "Increment") {
                        reachedEnd = Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").css('left'))) + Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").width())) >= hScroll.element.find(".e-hhandlespace").width() - 2;
                        if (reachedEnd) {
                            if (xlObj.model.scrollSettings.scrollMode != ej.Spreadsheet.scrollMode.Normal)
                                xlObj.XLScroll._scrollX(sheetIdx);
                            else
                                clearInterval(interval);
                        }
                        else
                            hScroll.scroll(hScroll.value() + sheet.columnWidth, true);
                        if (!xlObj.XLShape._shapeROStart && !xlObj.XLShape._shapeRSStart)
                            sheet._endCell.colIndex = sheet.colCount - 1;
                    }
                    else {
                        diff = hScroll.value() - sheet.columnWidth;
                        if(diff < 0)
                            diff = 0;
                        if(hScroll.value() >= 0)
                            hScroll.scroll(diff, true);
                        if (xlObj.XLSelection._aFillDownHandler)
                            sheet._endCell.colIndex = sheet._leftCol.idx;
                        if (sheet._frozenColumns > 1) {
                            sheet._startCell = sheet._activeCell;
                            sheet._endCell.rowIndex = (sheet.selectedRange[2] === sheet._startCell.rowIndex) ? sheet.selectedRange[0] : sheet.selectedRange[2];
                            sheet._endCell.colIndex = sheet._fleftColIdx;
                        }
                    }
                }
                else if (status.position === "vertical") {
                    if (status.action == "Increment") {
                        reachedEnd = Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").css('top'))) + Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").height())) >= vScroll.element.find(".e-vhandlespace").height() - 2;
                        if (reachedEnd) {
                            if (xlObj.model.scrollSettings.scrollMode != ej.Spreadsheet.scrollMode.Normal)
                                xlObj.XLScroll._scrollY(sheetIdx);
                            else
                                clearInterval(interval);
                        }
                        else
                            vScroll.scroll(vScroll.value() + xlObj.model.rowHeight, true);
                        if (!xlObj.XLShape._shapeROStart && !xlObj.XLShape._shapeRSStart)
                            sheet._endCell.rowIndex = sheet.rowCount - 1;
                    }
                    else {
                        diff = vScroll.value() - xlObj.model.rowHeight;
                        if(diff < 0)
                            diff = 0;
                        if(vScroll.value() > 0)
                            vScroll.scroll(diff, true);
                        if (!xlObj.XLShape._shapeROStart && !xlObj.XLShape._shapeRSStart) {
                            if (sheet._topRow.idx < 1 && sheet._ftopRowIdx + 1 === sheet._frozenRows)
                                return;
                            sheet._startCell = sheet._activeCell;
                            sheet._endCell.rowIndex = sheet._frozenRows > 1 ? sheet._ftopRowIdx : sheet._topRow.idx - 1;
                            sheet._endCell.colIndex = sheet._frozenRows > 1 ? (sheet.selectedRange[3] === sheet._startCell.colIndex) ? sheet.selectedRange[1] : sheet.selectedRange[3] : target.parentNode.cellIndex;
                        }
                    }
                }
                if (!xlObj.XLShape._shapeROStart && !xlObj.XLShape._shapeRSStart) {
                    if (xlObj.XLSelection._aFillDownHandler)
                        xlObj.XLDragFill._selectAutoFillRange(null, sheet._endCell)
                    else
                        xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                }
            }, 200);
            if (xlObj._browserDetails.name === "msie" && xlObj._browserDetails.version === "8.0") {
                target.attachEvent("onmouseup", function (e) {
                    clearInterval(interval);
                });
                document.attachEvent("onmouseup", function (e) {
                    clearInterval(interval);
                });
            }
            else {
            target.addEventListener("mouseup", function (e) {
                clearInterval(interval);
            });
            document.addEventListener("mouseup", function (e) {
                clearInterval(interval);
            });
            }
        },

        _cleanUp: function (border) {
            var i, cells, isNormal = false, hide = "e-hide", xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), topElem = xlObj.getFocusTopElem(),
               sElem = xlObj.getSheetElement(sheetIdx), className = "e-activecell|e-selected|e-rowhighlight|e-colhighlight|e-rowselected|e-colselected|e-sheetselected";
            if (xlObj.model.allowAutoFill)
                xlObj.XLDragFill._autoFillCleanUp();
            if (sheet._isSheetSelected && !xlObj.model.scrollSettings.allowVirtualScrolling) {
                isNormal = true;
                sElem.detach();
            }
            cells = sElem[0].querySelectorAll(".e-selected,.e-rowselected,.e-colselected,.e-rowhighlight,.e-colhighlight,.e-sheetselected,.e-activecell");
            i = cells.length;
            while (i--)
                cells[i].className = cells[i].className.replace(new RegExp(className, "g"), '').replace(/ +/g, ' ');
            if (isNormal)
                xlObj.getMainPanel(sheetIdx).find(".e-spreadsheet-list").append(sElem);
            if (border && topElem) {
                xlObj.addClass(topElem[0], hide);
                xlObj.addClass(xlObj.getFocusRightElem()[0], hide);
                xlObj.addClass(xlObj.getFocusBottomElem()[0], hide);
                xlObj.addClass(xlObj.getFocusLeftElem()[0], hide);
            }
            sheet._selectedCells = [];
        },
        clearAll: function (skipBorder) {
            this._cleanUp(!skipBorder);
        },
        _clearBorder: function (classes) {
            var xlObj = this.XLObj;
            xlObj._getContent(xlObj.getActiveSheetIndex()).find("td").removeClass(classes);
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.filter = function (obj) {
        this.XLObj = obj;
        this._isSearchEdit = false;
        this._isDecimal = false;
        this._colName = "";
        this._colType = "";
        this._tableId = "";
    };

    ej.spreadsheetFeatures.filter.prototype = {
        //Filtering
        _renderExcelFilter: function () {
            var xlObj = this.XLObj, model = { instance: xlObj, showSortOptions: xlObj.model.allowSorting, maxFilterLimit: xlObj.model.sheets[xlObj.getActiveSheetIndex()].filterSettings.maxFilterChoices, filterHandler: ej.proxy(this._filterHandler, this), cancelHandler: ej.proxy(this._cancelHandler, this), customFilterHandler: ej.proxy(this._customFilterHandler, this), enableComplexBlankFilter: false, blankValue: "", interDeterminateState: true };
            xlObj._excelFilter = new ej.excelFilter(model);
            xlObj.element.append(ej.buildTag("div#" + xlObj._id + "_filter_custom.e-filterdlg" + ".e-" + xlObj._id + "-dlg", "", { display: 'none' }));
        },

        _customFilterHandler: function () {
            var xlObj = this.XLObj;
            if (this._isDecimal) {
                $("#" + xlObj._id + "number_CustomValue1").ejNumericTextbox("option", { decimalPlaces: 2 });
                $("#" + xlObj._id + "number_CustomValue2").ejNumericTextbox("option", { decimalPlaces: 2 });
            }
        },

        _renderFilterDialogs: function (type) {
            var xlObj = this.XLObj;
            if(document.getElementById(xlObj._id + "_filter_custom").className.indexOf("e-dialog") < 0)
                this._renderCustomFilter();
            xlObj._excelFilter.renderDialog(type);
            this._refreshCustomFilter(type);
            xlObj.element.find(".e-excelfilter.e-dlgcontainer").hide();
            $(document.body).append($("#" + xlObj._id + type + "_excelDlg"));
        },

        _createSelection: function (sheetIdx, startrowIndex, endrowIndex, colIndex, filteredIndex) {
            var xlObj = this.XLObj, usedRow = xlObj.getSheet(sheetIdx).usedRange.rowIndex, endRowIdx = endrowIndex, x = 0, isHide, value2;
            for (var i = endrowIndex; i <= usedRow; i++) {
                isHide = xlObj.XLEdit.getPropertyValue(i, x, "isHide");
                value2 = xlObj.XLEdit.getPropertyValue(i, colIndex, "value2", sheetIdx);
                if (xlObj.XLEdit.getPropertyValue(i, colIndex, "tableName", sheetIdx))
                    break;
                if ((!isHide && !xlObj.XLEdit.getPropertyValue(i, colIndex, "isMHide") && !value2) && i >= endrowIndex)
                    return { endRowIndex: i, filteredIndex: filteredIndex };
                else if (!isHide && value2) {
                    endRowIdx = i + 1;
                    filteredIndex.push(i);
                }
                else
                    endRowIdx = endRowIdx;
            }
            return { endRowIndex: endRowIdx, filteredIndex: filteredIndex };
        },

        _getSelectedRangeData: function (startCell, endCell, tableId, cellIndex) {
            var temp, xlObj = this.XLObj, x = 0, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), filteredRangeIndex = [], columnName, i, j, cellData,
                selCellColor = [], color, cells, celldatatemp, rangeData = [], container = xlObj._dataContainer, sheetData = container.sheets[sheetIdx], multiFltrIdx = xlObj.getSheet(sheetIdx)._multifilterIdx;
            if (tableId === -1)
                sheet.filterSettings.range = xlObj._generateHeaderText(multiFltrIdx[0] + 1) + startCell.rowIndex + ":" + xlObj._generateHeaderText(multiFltrIdx[multiFltrIdx.length - 1] + 1) + (endCell.rowIndex + 1);
            if (sheet._multipleFiltering)
                endCell.colIndex = sheet._multifilterIdx[sheet._multifilterIdx.length - 1];
            for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
				temp = {};
				for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
				    columnName = xlObj._generateHeaderText(j + 1);
				    if (i in sheetData) {
				        if (!(x in sheetData[i]) || (x in sheetData[i] && (ej.isNullOrUndefined(sheetData[i][x].isRHide) && ej.isNullOrUndefined(sheetData[i][x].isFHide)))) {
				            if (!(x in sheetData[i]) || (x in sheetData[i] && (ej.isNullOrUndefined(sheetData[i][x].isFilterHide) || (!ej.isNullOrUndefined(sheetData[i][x].isFilterHide) && sheetData[i][x].filterID === tableId)))) {
				                temp["idx"] = i;
				                if (i in sheetData && j in sheetData[i]) {
				                    cellData = sheetData[i][j];
				                    if (j === cellIndex) {
				                        color = xlObj.XLEdit.getPropertyValue(i, j, "formats");
				                        if (!ej.isNullOrUndefined(color)) {
				                            cells = { id: j, background: color["background-color"], foreground: color["color"] };
				                            selCellColor.push(cells);
				                        }
				                    }
				                    if (ej.isNullOrUndefined(container.sharedData[cellData.value]))
				                        temp[columnName] = ""; 
				                    else
				                        temp[columnName] = (xlObj._isDateTime(container.sharedData[cellData.value]) || xlObj.isFormula(container.sharedData[cellData.value])) ? cellData.value2 : container.sharedData[cellData.value];
				                }
				                else
				                    temp[columnName] = "";
				            }
				        }
				    }
				    if (!(i in sheetData) && i < endCell.rowIndex) {
				        temp["idx"] = i;
				        temp[columnName] = "";
				    }
                }
                if (xlObj.getObjectLength(temp) > 0) {
                    rangeData.push(temp);
                    filteredRangeIndex.push(i);
                }
            }
            sheet._selectedCellColors = selCellColor;
            sheet._selectedRange = { startRow: startCell.rowIndex, endRow: endCell.rowIndex, dataSourceIndexes: filteredRangeIndex };
            sheet.filterSettings.filteredRange = rangeData;
        },

        _getColumnType: function (sheetIdx, startRow, endRow, cellIndex) {
            var cellType = "string", value, type;
            for (var i = startRow; i < endRow; i++) {
                value = this.XLObj.XLEdit.getPropertyValue(i, cellIndex, "value", sheetIdx);
                type = this.XLObj.XLEdit.getPropertyValue(i, cellIndex, "type", sheetIdx);
                if (type == "text" || ( !$.isNumeric(value)) ) {
                    cellType = "string";
                    return cellType;
                }
                else {
                    if (!this._isDecimal)
                        this._isDecimal = ((value % 1) != 0);
                    cellType = "number";
                }
            }
            return cellType;
        },

        _getColumnByField: function (sheetIdx, field) {
            var xlObj = this.XLObj, column, sheet = xlObj.getSheet(sheetIdx);
            for (column = 0; column < sheet.columns.length; column++)
                if (sheet.columns[column]["field"] === field)
                    break;
            return column === sheet.columns.length ? null : sheet.columns[column];
        },

		_checkEmptyText: function (sheetIdx) {
            var xlObj = this.XLObj, selectedCell = xlObj.model.sheets[sheetIdx]._selectedCells;
            for (var i = 0, len = selectedCell.length; i < len; i++) {
                if (!ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(selectedCell[i].rowIndex, selectedCell[i].colIndex, "value", sheetIdx)))
                    return true;
            }
            xlObj._showAlertDlg("Alert", "Alert", null, 440);
            return false;
        },

        _getFilterIcon: function () {
            var filterIcon = ej.buildTag("span .e-icon", "", {});
            filterIcon.addClass("e-spanfilter e-filterspan e-ssfilter");
            return filterIcon;
        },

        filterByActiveCell: function () {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), value;
            if (!xlObj.model.allowFiltering || xlObj.model.isReadOnly)
                return;
                var activeCell = xlObj.model.sheets[sheetIdx]._activeCell, activeElem = xlObj.getCell(activeCell.rowIndex, activeCell.colIndex), selCells = xlObj.model.sheets[sheetIdx]._selectedCells;
                if (this._checkEmptyText(sheetIdx)) {
                    if (activeElem.find("span").is('.e-ssfiltered, .e-ssfilter, .e-ssfilter-asc, .e-ssfiltered-asc, .e-ssfilter-dsc, .e-ssfiltered-dsc'))
                        xlObj._showAlertDlg("Alert", "HeaderAlert", "", 440);
                    else {
                        value = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "value", sheetIdx);
                        value = xlObj._isDateTime(value) ? xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "value2", sheetIdx) : value;
                        this._filterActiveCell(sheetIdx, activeCell, selCells, value);
                    }
                }
        },

        _filterActiveCell: function (sheetIdx, activeCell, selCells, value, range) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx);
            sheet._activeCell = activeCell;
            this._filterByValue(sheetIdx, range, sheet.columns[activeCell.colIndex].field, "or", "equal", value, selCells);
            xlObj.model.allowComments && xlObj.XLComment._updateCmntArrowPos();
        },

        _filterByValue: function (sheetIdx, range, columnName, pred, operator, value, selCells) {
            var xlObj = this.XLObj, selCells, rng, activeCell, filterColumn, fQMgr, query, obj, objectIndex = -1, i, len, fltrVal,
                arg = {}, tabRange, details, colIdx = xlObj.XLEdit.getColumnIndexByField(columnName), sheet = xlObj.getSheet(sheetIdx);
            if (ej.isNullOrUndefined(range))
                selCells = selCells;
            else {
                rng = xlObj.getRangeIndices(range);
                selCells = xlObj._getSelectedRange({ rowIndex: rng[0] + 1, colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });            }
            activeCell = selCells[0];
            if (!ej.isNullOrUndefined(range)) {
                fltrVal = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "value2", sheetIdx);
                if (ej.isNullOrUndefined(fltrVal) || fltrVal !== value) {
                    for (i = rng[0]; i < rng[2]; i++) {
                        fltrVal = xlObj.XLEdit.getPropertyValue(i, colIdx, "value2", sheetIdx);
                        if (!ej.isNullOrUndefined(fltrVal) && fltrVal === value) {
                            activeCell = { rowIndex: i, colIndex: colIdx };
                            break;
                        }
                    }
                }
            }
            details = { currentFilteringColumn: columnName, action: "filter", predicated: pred, requestType: "filterbycell", reqType: "filter", filteredValue: value, selCells: $.extend(true, [], selCells), activeCell: activeCell };
            tabRange = this._applyFilterByValue(sheetIdx, activeCell, selCells, value);
            xlObj._excelFilter._predicates[sheetIdx] = {};
            filterColumn = { field: columnName, value: value, predicate: pred, operator: operator, matchcase: false };
            arg.currentFilterCollection = value;
            xlObj._excelFilter._predicates[sheetIdx][columnName] = ej.Predicate(columnName, operator, value);
            sheet.filterSettings.filteredColumns.push(filterColumn);
            fQMgr = ej.DataManager(sheet.filterSettings.filteredColumns);
            query = new ej.Query().where("field", ej.FilterOperators.equal, columnName);
            obj = fQMgr.executeLocal(query);
            for (i = 0, len = obj.length; i < len; i++) {
                objectIndex = $.inArray(obj[i], sheet.filterSettings.filteredColumns);
                (objectIndex > -1) && sheet.filterSettings.filteredColumns.splice(objectIndex, 1);
            }
            sheet.filterSettings.filteredColumns.push(filterColumn);
            details.filteredcolumns = tabRange.filteredColumns = sheet.filterSettings.filteredColumns;
            if (tabRange.filteredColumns.length < 1) {
                var multiIdx = tabRange.multifilterIdx, fieldName;
                for (var i = multiIdx[0]; i <= multiIdx[multiIdx.length - 1]; i++) {
                    fieldName = xlObj._generateHeaderText(i + 1);
                    if (!ej.isNullOrUndefined(tabRange.fColumns[fieldName]))
                        tabRange.fColumns[fieldName] = [];
                }
            }
            else
                tabRange.fColumns[columnName] = $.extend(true, [], tabRange.filteredColumns);
            tabRange.predicate = xlObj._excelFilter._predicates[sheetIdx];
            details.tableID = tabRange.tableID;
            details.filteredCells = tabRange.filteredCells;
            xlObj.XLSelection._refreshBorder();
            details.operation = "filterbycell";
            details.selRange = xlObj._getAlphaRange(sheetIdx, tabRange.startRow - 1, tabRange.multifilterIdx[0], tabRange.endRow, tabRange.multifilterIdx[tabRange.multifilterIdx.length - 1]);
            xlObj._processBindings(details) && (sheet.filterSettings.filteredColumns = temp);
        },

        _applyFilterByValue: function (sheetIdx, activeCell, selCells, value) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), cellIndex = [], endCell, startRowIdx, endRowIdx, filterIcon, filtrIconsCol, tableID, actCellCls = xlObj.getCell(activeCell.rowIndex, activeCell.colIndex)[0].className,
                tab = sheet.filterSettings.tableRange, filteredCells = [], tabRange, tabIdx, exists = false, activeObj, i, j, len, isVirtualScroll = xlObj.model.scrollSettings.allowVirtualScrolling, filterColl = xlObj.getSheet(sheetIdx)._filterColl, filterCollObj;
            tableID = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "tableName", sheetIdx);
            tableID = tableID ? xlObj._getTableID(tableID) : -1;
            for (i = 0, len = tab.length; i < len; i++) {
                if (tab[i].tableID === tableID) {
                    tabIdx = i;
                    break;
                }
            }
            if (!ej.isNullOrUndefined(tabIdx) && ((tab[tabIdx].tableID === tableID) && tab[tabIdx].selectedCellIndexes.indexOf(activeCell.colIndex) !== -1) && ((tab[i].startRow <= activeCell.rowIndex) && (tab[i].endRow >= activeCell.rowIndex))) {
                tabRange = tab[tabIdx];
                sheet.filterSettings.filteredRange = tab[tabIdx].filteredRange;
                sheet._selectedRange = tab[tabIdx].selectedRange;
            }
            else {
                sheet._multipleFiltering = false;
                sheet._multifilterIdx = [];
                xlObj._dupDetails = true;
                this.clearFilter("remove");
                xlObj._dupDetails = false;
                var rowKeys = xlObj.getObjectKeys(filterColl), colKeys, cell;
                for (i = rowKeys.length - 1; i >= 0; i--) {
                    colKeys = xlObj.getObjectKeys(filterColl[i]);
                    for (j = colKeys.length - 1; j >= 0; j--) {
                        if (xlObj._isRowViewable(sheetIdx, rowKeys[i])) {
                            cell = xlObj.getCell(rowKeys[i], colKeys[j]);
                            cell.find(".e-filterspan").remove();
                            cell.removeClass("e-filterhdr");
                        }
                        delete filterColl[rowKeys[i]][colKeys[j]];
                    }
                }
                if (selCells.length < 2 || (selCells[0].rowIndex === selCells[selCells.length - 1].rowIndex)) {
                    startRowIdx = -1;
                    endRowIdx = selCells[selCells.length - 1].rowIndex;
                    for (var i = selCells[0].rowIndex; i >= 0; i--) {
                        if (ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(i, selCells[0].colIndex, "value2"))) {
                            startRowIdx = i;
                            break;
                        }
                    }
                    startRowIdx = (startRowIdx === -1) ? 1 : startRowIdx + 2; // For text cell is act as a header
                    endRowIdx = this._createSelection(sheetIdx, startRowIdx, endRowIdx, selCells[0].colIndex, []).endRowIndex - 1;
                    endCell = { rowIndex: endRowIdx, colIndex: activeCell.colIndex };
                    this._getSelectedRangeData({ rowIndex: startRowIdx, colIndex: activeCell.colIndex }, endCell, -1, activeCell.colIndex);
                }
                else {
                    startRowIdx = activeCell.rowIndex;
                    endRowIdx = this._createSelection(sheetIdx, startRowIdx, selCells[selCells.length - 1].rowIndex, selCells[0].colIndex, []).endRowIndex - 1;
                    endCell = { rowIndex: endRowIdx, colIndex: activeCell.colIndex };
                    this._getSelectedRangeData({ rowIndex: startRowIdx, colIndex: activeCell.colIndex }, endCell, -1, activeCell.colIndex);
                }
                var fltrColl = xlObj.getSheet(sheetIdx)._filterColl;
                for (i = selCells[0].colIndex, len = selCells[selCells.length - 1].colIndex; i <= len; i++) {
                    cellIndex.push(i);
                    filterIcon = this._getFilterIcon();
                    startRowIdx = (startRowIdx === 0) ? 1 : startRowIdx;
                    activeObj = { rowIndex: startRowIdx - 1, colIndex: i };
                    this._applyFilterIcon(activeObj, filterIcon);
                    filteredCells.push(activeObj);
                }
                xlObj.XLScroll._getColWidths(sheetIdx, selCells[0].colIndex);
                (cellIndex.length > 1) && (sheet._multipleFiltering = true);
                sheet._multifilterIdx = cellIndex;
                sheet._selectedCellIndexes = cellIndex;
                for (i = 0, len = tab.length; i < len; i++) {
                    if (tab[i].tableID === tableID) {
                        tabIdx = i;
                        exists = true;
                        break;
                    }
                }
                if (!exists) {
                    sheet.filterSettings.tableRange.push({ filterCollection: [],
                        startRow: startRowIdx, endRow: endCell.rowIndex, tableID: -1, fColumns: {}, flterdIdxes: [], multiFiltering: sheet._multipleFiltering, multifilterIdx: sheet._multifilterIdx, selectedCellIndexes: sheet._multifilterIdx, selectedRange: $.extend(true, {}, sheet._selectedRange), filteredRange: sheet.filterSettings.filteredRange, hiddenIdx: []
                    });
                    tabRange = tab[tab.length - 1];
                }
                else {
                    tabRange = tab[tabIdx];
                    tabRange.startRow = activeCell.rowIndex;
                    tabRange.endRow = endCell.rowIndex;
                    tabRange.multiFiltering = sheet._multipleFiltering;
                    tabRange.multifilterIdx = sheet._multifilterIdx;
                    tabRange.selectedCellIndexes = sheet._multifilterIdx;
                    tabRange.selectedRange = $.extend(true, {}, sheet._selectedRange);
                    tabRange.filteredRange = $.extend(true, {}, sheet.filterSettings.filteredRange);
                    tabRange.hiddenIdx = [];
                    tabRange.flterdIdxes = [];
                    tabRange.fColumns = {};
                    tabRange.tableID = tableID;
                    tabRange.filterCollection = [];
                }
                tabRange.filteredCells = filteredCells;
            }
            return tabRange;
        },

        clearFilter: function (status) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var isCleared = false, isFilterApplied = false, sheetIdx = xlObj.getActiveSheetIndex(), columnName, fltrdCol, sheet = xlObj.getSheet(sheetIdx), filterColl = $.extend(true, {}, sheet._filterColl), dupDetails = xlObj._dupDetails,
                selRange, tblRange = sheet.filterSettings.tableRange, tabIdx = -1, i, j, len, filterRange, filteredCells = [], container = xlObj._dataContainer.sheets[sheetIdx];
            var rowKey, colKey, rowKeys = xlObj.getObjectKeys(filterColl), colKeys, cell, filterCollection = [], fltrdRange = sheet.filterSettings.filteredRange, filteredCols = sheet.filterSettings.filteredColumns, range = sheet.filterSettings.range;
            if(!tblRange.length)
				return;
			for (i = 0; i < tblRange.length; i++) {
                if (tblRange[i].tableID === -1) {
                    tabIdx = i;
					isFilterApplied = true;
                    break;
                }
            }
			if(!isFilterApplied)
				return;
			selRange = tblRange[tabIdx].selectedRange;
			for (i = rowKeys.length - 1; i >= 0; i--) {
                colKeys = xlObj.getObjectKeys(filterColl[rowKeys[i]]);
                for (j = colKeys.length - 1; j >= 0; j--) {
					rowKey = parseInt(rowKeys[i]);
					colKey = parseInt(colKeys[j]);
                    if (ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowKey, colKey, "tableName", sheetIdx))) {
                        filteredCells.push({ rowIndex: rowKey, colIndex: colKey });
                        fltrdCol = filterColl[rowKeys[i]][colKeys[j]];
                        if (fltrdCol.status.indexOf("e-ssfiltered") > -1) {
                            columnName = xlObj.model.sheets[sheetIdx].columns[colKeys[j]].field;
							filterCollection.push({"fieldName": columnName, "predicate": tblRange[tabIdx].predicate, "filterCollection": tblRange[tabIdx].filterCollection, action: "filtering", tableID: -1, predicate : xlObj._excelFilter._predicates[sheetIdx][columnName]} );
                            delete xlObj._excelFilter._predicates[sheetIdx][columnName];
							xlObj._dupDetails = true;
                            this._clearFilterColumn(columnName, "", "", "Or", "", "", -1);
							xlObj._dupDetails = false;
                            isCleared = true;
                        }
                        if (status === "remove") {
                            delete filterColl[rowKeys[i]][colKeys[j]];
                            delete container[rowKeys[i]][colKeys[j]]["isFilterHeader"];
                            delete container[rowKeys[i]][colKeys[j]]["filterState"];
                            delete container[rowKeys[i]][colKeys[j]]["isFilterVisible"];
                            if(xlObj._isRowViewable(sheetIdx, rowKey)) {
                                cell = xlObj.getCell(rowKey, colKey);
                                $.isNumeric(xlObj.XLEdit.getPropertyValue(rowKey, colKey)) && cell.addClass(xlObj._rAlign);
                                cell.find(".e-filterspan").remove();
								xlObj.addClass(cell[0], "e-wrapword");
								if(xlObj.XLEdit.getPropertyValue(rowKey, colKey, "isFilterWrap"))
									xlObj.setWrapText("wrap", xlObj._getAlphaRange(sheetIdx, rowKey,colKey, rowKey, colKey));
                                xlObj._removeClass(cell[0], "e-filterhdr");
                            }
                        }
                    }
                }
            }
			if (status === "remove") {
			    xlObj._dupDetails = dupDetails;
			    sheet._filterColl = filterColl;
                (tabIdx > -1) && (filterRange = tblRange.splice(tabIdx, 1)[0]);
                xlObj.model.allowComments && xlObj.XLComment._updateCmntArrowPos();
                if (!xlObj._isUndoRedo && !xlObj._dupDetails) {
                    var details = { sheetIndex: sheetIdx, operation: "remove-filter", status: status, process: "apply-filter", filteredCells: filteredCells, requestType: "filter", reqType: "filter", fRange: xlObj.getSheet(sheetIdx).filterSettings.range, filterRange: filterRange, filterCollection: filterCollection, filteredCols : filteredCols, fltrdRange: fltrdRange, selRange: selRange};
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            }
            if (isCleared) {
                $("#" + xlObj._id + "_Ribbon_Data_SortFilter_ClearFilter").ejButton("disable");
                $("#" + xlObj._id + "_Ribbon_SortFilter").ejMenu("disableItemByID", "Ribbon_ClearFilter");
            }
        },

        filter: function (range) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowFiltering || xlObj.model.isReadOnly)
                return;
                var sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), applyFltr = false, activeCell = sheet._activeCell, tableId, colIdx,
					tabRange = sheet.filterSettings.tableRange, tabIdx, i, len, stRow, fltrStr, args;
                sheet._multipleFiltering = false;
                sheet._multifilterIdx = [];
                tableId = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "tableName", sheetIdx);
				if (!ej.isNullOrUndefined(tableId))
					tableId = xlObj._getTableID(tableId);
                for (i = 0, len = tabRange.length; i < len; i++) {
                    if (tabRange[i].tableID === -1)
                        applyFltr = true;
                    tabIdx = i;
                }
                args = { range: xlObj._getRangeArgs(range, "string"), reqType: ej.Spreadsheet.Actions.Filtering, sheetIndex: sheetIdx };
                if (xlObj._trigActionBegin(args))
                    return true;
                range = args.range;
                if (applyFltr) {
                    this.clearFilter("remove");
                    sheet.filterSettings.filteredRange = [];
                    sheet._selectedRange = {};
                    sheet._selectedCellIndexes = [];
                    sheet.filterSettings.filteredColumns = [];
                    xlObj._excelFilter._predicates[sheetIdx] = {};
                }
                if (!ej.isNullOrUndefined(tableId) && tableId > -1) {
                    stRow = tabRange[tabIdx].startRow;
                    colIdx = tabRange[tabIdx].multifilterIdx;
                    for (i = 0, len = colIdx.length; i < len; i++) {
                        fltrStr = this._getFilterHeader(sheetIdx, stRow, colIdx[i]);
                        if (!ej.isNullOrUndefined(fltrStr) && fltrStr.status.indexOf("e-ssfiltered") > -1)
                            this._clearFilterColumn(sheet.columns[i].field, "", "", "", "", "", tableId);
                    }
                    this._clearFilterTableIcon(sheetIdx, tableId);
                    applyFltr = true;
                }
                if (applyFltr) {
                    args = { sheetIdx: sheetIdx, reqType: "clear-Filter" };
                    if (xlObj._trigActionComplete(args))
                        return;
                }
                else
                    this._filterCellRange(sheetIdx, range);
                xlObj._isFiltered = !applyFltr;
                xlObj.model.allowComments && xlObj.XLComment._updateCmntArrowPos();
        },

        _applyFilterIcon: function (activeObj, filterIcon) {
            var activeEle, xlObj = this.XLObj, ralign = this.XLObj._rAlign, sheetIdx = xlObj.getActiveSheetIndex(), rowIdx = activeObj.rowIndex, colIdx = activeObj.colIndex, sheet = xlObj.getSheet(sheetIdx),
			    isViewed = xlObj._isRowViewable(sheetIdx, rowIdx), filterColl = sheet._filterColl, isWrap = false;
			if (isViewed) {
                activeEle = xlObj.getCell(rowIdx, colIdx, sheetIdx);
                activeEle[0].insertBefore(filterIcon[0], activeEle[0].childNodes[activeEle[0].childNodes.length - 1]);
				activeEle.addClass("e-filterhdr");
                activeEle.removeClass("e-ralign");
            }
			if(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "wrap", sheetIdx)) {
				isWrap = true;
				xlObj.setWrapText("unwrap", xlObj._getAlphaRange(sheetIdx, rowIdx,colIdx, rowIdx, colIdx));
            }
			xlObj.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { isFilterHeader: true, filterState: "filter", isFilterVisible: true, isFilterWrap: isWrap }, sheetIdx: sheetIdx })
            if (xlObj.isNumber(xlObj.model.allowFiltering && xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2", sheetIdx)))
                isViewed && xlObj._removeClass(activeEle[0], ralign);
            if (!(rowIdx in filterColl))
                filterColl[rowIdx] = {};
            if (!(colIdx in filterColl[rowIdx]))
                filterColl[rowIdx][colIdx] = {};
            filterColl[rowIdx][colIdx].status = "e-ssfilter";
            filterColl[rowIdx][colIdx].isTable = (filterIcon[0].className.indexOf("e-ft") > -1);
        },

        _postionFilterIcon: function (activeElem, filterIcon) {
            var xlObj = this.XLObj, actCell = activeElem || xlObj.getActiveCellElem(), fltrIcon = filterIcon || actCell.find(".e-filterspan"), contWidth, contHeight,
                cellIdx = xlObj._getCellIdx(actCell[0]);
            if (xlObj.model.allowResizing) {
                contWidth = xlObj.XLResize._getContentWidth(cellIdx.colIndex, xlObj.getActiveSheetIndex(), cellIdx.rowIndex, cellIdx.rowIndex);
                contHeight = xlObj.XLResize._getContentHeight(cellIdx.rowIndex, xlObj.getActiveSheetIndex());
            }
            //fltrIcon.css("margin-top", (xlObj._hasClass(actCell[0], "e-sswraptext") && contWidth > actCell.width()) ? Math.floor(contHeight - 25) : ""); //25px - filter span height + padding
        },

        _filterCellRange: function (sheetIdx, range) {
            var xlObj = this.XLObj, selCells, addFilter = false, exists, tableIdx, tableRange, isVisible, cellIndex = [], rowIconIdx = -1, selFilterPosn = false, colCount = 0,
                filterIcon, i, j, k, len, ln, rng, startCell, endCell, tabRange, sheet = xlObj.getSheet(sheetIdx), filteredRangeIndex = [], isSingleCell = false, pCells,
                filterCellIndex = [], filteredCells = [], isEmpty = false, details = { sheetIndex: sheetIdx, reqType: "filter", operation: "apply-filter" };
            if (ej.isNullOrUndefined(range)) {
                if (!xlObj.model.allowSelection)
                    return;
                selCells = sheet._selectedCells;
            }
            else {
                rng = xlObj.getRangeIndices(range);
                selCells = xlObj._getSelectedRange({ rowIndex: rng[0], colIndex: rng[1] }, { rowIndex: rng[2], colIndex: rng[3] });
            }
            if (selCells.length < 2) {
                pCells = selCells;
                !ej.isNullOrUndefined(range) && xlObj.performSelection(range, sheetIdx);
                xlObj.selectAll(false);
                selCells = sheet._selectedCells;
                isSingleCell = true;                
            }
			xlObj.XLRibbon._dirtySelect();
			if(xlObj.XLRibbon._isDirtySelect)
				return;
            for (i = selCells[0].colIndex, len = selCells[selCells.length - 1].colIndex; i <= len ; i++) {
                cellIndex.push(i);
                rowIconIdx = selCells[0].rowIndex;
                if (isSingleCell) {
                    if (!sheet._isSheetSelected) {
                        filterCellIndex.push(i);
                        sheet._multifilterIdx.push(i);
                        addFilter = true;
                    }
                }
                else {
                    if (!selFilterPosn || cellIndex.length > 0)
                        for (j = rowIconIdx, ln = selCells[selCells.length - 1].rowIndex; j <= ln; j++) {
                            isVisible = xlObj._isRowVisible(sheetIdx, j);
                            if (isVisible) {
                                if (xlObj.XLEdit.getPropertyValue(j, i, "value2", sheetIdx) || (filterCellIndex.length && xlObj.XLEdit.getPropertyValue(0, i, "isCHide", sheetIdx))) {
                                    if (rowIconIdx === -1 || rowIconIdx > j)
                                        rowIconIdx = j;
                                    selFilterPosn = true;
                                    addFilter = true;
                                    isEmpty = true;
                                }
                            }
                            (rowIconIdx < j && colCount === 0) && filteredRangeIndex.push(j);
                        }
                    if (isEmpty) {
                        filterCellIndex.push(i);
                        sheet._multifilterIdx.push(i);
                        isEmpty = false;
                    }
                }
                colCount++;
            }
            (filterCellIndex.length > 1) && (sheet._multipleFiltering = true);
            filteredCells = [];
            if (addFilter) {
                for (i = 0, len = filterCellIndex.length; i < len; i++) {
                    filterIcon = this._getFilterIcon();
                    this._applyFilterIcon({ rowIndex: rowIconIdx, colIndex: filterCellIndex[i] }, filterIcon);
                    filteredCells.push({ rowIndex: rowIconIdx, colIndex: filterCellIndex[i] });
                }
                startCell = { rowIndex: rowIconIdx + 1, colIndex: selCells[0].colIndex };
                endCell = { rowIndex: selCells[selCells.length - 1].rowIndex };
                sheet._selectedRange = { startRow: startCell.rowIndex, endRow: endCell.rowIndex, dataSourceIndexes: filteredRangeIndex };
                this._getSelectedRangeData(startCell, selCells[selCells.length - 1], -1, startCell.colIndex);
                sheet._selectedCellIndexes = cellIndex;
                details = {
                    sheetIndex: sheetIdx,
                    filteredCells: filteredCells,
                    reqType: "filter",
                    operation: "apply-filter",
                    tableID: -1
                }
                tableRange = sheet.filterSettings.tableRange;
                for (i = 0, len = tableRange.length; i < len; i++) {
                    if (tableRange[i].tableID === -1) {
                        exists = true;
                        tableIdx = i;
                    }
                }
                if (!exists)
                    sheet.filterSettings.tableRange.push({ filterCollection: [], startRow: startCell.rowIndex, endRow: endCell.rowIndex, tableID: -1, multiFiltering: sheet._multipleFiltering, multifilterIdx: sheet._multifilterIdx, selectedCellIndexes: sheet._multifilterIdx, selectedRange: sheet._selectedRange, filteredRange: sheet.filterSettings.filteredRange, filteredColumns: sheet.filterSettings.filteredColumns, fColumns: {}, predicate: {}, hiddenIdx: [], fltrdIdxes: [], filterColumnName: [] });
                else {
                    tabRange = sheet.filterSettings.tableRange[tableIdx];
                    tabRange.startRow = startCell.rowIndex;
                    tabRange.endRow = endCell.rowIndex;
                    tabRange.multiFiltering = sheet._multipleFiltering;
                    tabRange.multifilterIdx = sheet._multifilterIdx;
                    tabRange.selectedCellIndexes = sheet._multifilterIdx;
                    tabRange.selectedRange = sheet._selectedRange;
                    tabRange.filteredRange = sheet.filterSettings.filteredRange;
                    tabRange.filteredColumns = sheet.filterSettings.filteredColumns;
                    tabRange.predicate = xlObj._excelFilter._predicates[sheetIdx];
                    tabRange.hiddenIdx = [];
                    tabRange.flterdIdxes = [];
                    tabRange.fColumns = {};
                    tabRange.filterColumnName = [];
                    tabRange.filterCollection = [];
                }
                xlObj.XLScroll._getColWidths(sheetIdx, sheet._multifilterIdx[0]);
                if ((!sheet._isImported || sheet._isLoaded)&& !xlObj._isExport) {
                    if (pCells)
                        range = [pCells[0].rowIndex, pCells[0].colIndex, pCells[pCells.length - 1].rowIndex, pCells[pCells.length - 1].colIndex];
                    else if (xlObj.isUndefined(range))
                        range = [selCells[0].rowIndex, selCells[0].colIndex, selCells[selCells.length - 1].rowIndex, selCells[selCells.length - 1].colIndex];
                    else
                        range = xlObj.getRangeIndices(range);
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
					!ej.isNullOrUndefined(range) && xlObj.performSelection(range, sheetIdx);
                }
            }
            else
                xlObj._showAlertDlg("Alert", "Alert", "", 440);

        },
      
        openFilterDialog: function (range) {
            var filterSpan, xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            if (typeof (range) === "string")
                range = xlObj.getRangeIndices(range);
            filterSpan = xlObj.getCell(range[0], range[1]).find('span.e-filterspan');
            (filterSpan.length > 0) && this._filterClickHandler({ target: filterSpan[0] });
        },

        _filterClickHandler: function (e) {
            var xlObj = this.XLObj, trgtCell, isTable, $target = $(e.target), sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), isFiltered = false, endRowIdx, columnName, columns, colType, i, len, startIdx, endIdx, curIdx,
                actCell, fltrVal, tableId, selectedRange, tableRange, tableFilteredColumn = [], tablePredicate = {}, position, startCell, endCell, tabIdx, selection, isVirtualScroll = xlObj.model.scrollSettings.allowVirtualScrolling, trgtPos = $(e.target).position(), shtPos = xlObj.getSheetElement(sheetIdx).find('.e-spreadsheetcontentcontainer').position(), strMenuObj, numMenuObj, oper = ["showItems", "hideItems"];
            columnName = xlObj._generateHeaderText(e.target.parentNode.cellIndex + 1);
            this._isDecimal = false;
            if ((xlObj.model.allowLockCell && xlObj.getSheet(sheetIdx).isSheetProtected) || xlObj.preventFilterPopup)
                return;
            ($target[0].className.indexOf("e-ssfiltered") > -1) && (isFiltered = true);
            curIdx = e.target.parentNode.cellIndex;
            if ($target[0].className.indexOf("e-ssfilter") > -1) {
                tableRange = xlObj.model.sheets[sheetIdx].filterSettings.tableRange;
				trgtCell = xlObj._getCellIdx($target.parent()[0]);
				isTable = xlObj.XLEdit.getPropertyValue(trgtCell.rowIndex, trgtCell.colIndex, "tableName");
				tableId = (!ej.isNullOrUndefined(isTable)) ? parseInt(isTable.replace("e-table","")) : -1;
                for (i = 0, len = tableRange.length; i < len; i++) {
                    if (tableRange[i].tableID === tableId) {
                        tabIdx = i;
                        if (tableRange[i].multiFiltering) {
                            startIdx = tableRange[i].multifilterIdx[0];
                            endIdx = tableRange[i].multifilterIdx[tableRange[i].multifilterIdx.length - 1];
                        }
                        else
                            startIdx = endIdx = e.target.parentNode.cellIndex;
                        startCell = { rowIndex: tableRange[i].startRow, colIndex: startIdx };
                        endCell = { rowIndex: tableRange[i].endRow, colIndex: endIdx };
                        sheet._multipleFiltering = tableRange[i].multiFiltering;
                        sheet._multifilterIdx = tableRange[i].multifilterIdx;
                        selectedRange = sheet._selectedRange = tableRange[i].selectedRange;
                        sheet.filterSettings.filteredRange = tableRange[i].filteredRange;
                        sheet._selectedCellIndexes = tableRange[i].selectedCellIndexes;
                    }
                }
                if (tableId === -1) {
                    selection = this._createSelection(sheetIdx, selectedRange.startRow, selectedRange.endRow, curIdx, selectedRange.dataSourceIndexes);
                    endRowIdx = (selection.endRowIndex > selectedRange.endRow) ? selection.endRowIndex - 1 : selection.endRowIndex;
                    if (selectedRange.endRow != endRowIdx) {
                        for (var i = selectedRange.endRow + 1; i <= endRowIdx; i++) {
                            fltrVal = { field: columnName, value: xlObj.XLEdit.getPropertyValue(i, curIdx, "value2", sheetIdx), matchcase: false, operator: "equal", predicate: "or" };
                            sheet.filterSettings.filteredColumns.push(fltrVal);
                            tableRange[tabIdx].filteredColumns.push(fltrVal);
                            tableRange[tabIdx].selectedRange.endRow = endRowIdx;
                        }
                    }
                    endCell = { rowIndex: endRowIdx, colIndex: curIdx };
                    tableRange[tabIdx].selectedRange = sheet._selectedRange = { startRow: startCell.rowIndex, endRow: endCell.rowIndex, dataSourceIndexes: selection.filteredIndex };
                    tableRange[tabIdx].endRow = endRowIdx;
                }
                this._getSelectedRangeData(startCell, endCell, tableId, curIdx);
                columns = sheet.columns;
                colType = this._getColumnType(sheetIdx, selectedRange.startRow, selectedRange.endRow, curIdx);
                for (i = 0, len = columns.length; i < len; i++) {
                    if (columns[i].field === columnName) {
                        xlObj._$colType = colType;
                        xlObj._$curFieldName = columns[i].field;
                        break;
                    }
                }
                xlObj._showDialog(xlObj._id + "_Filter", xlObj._$colType);
                position = xlObj._getXYPos($target, $("#" + xlObj._id + xlObj._$colType + "_excelDlg"), 18, 18); // 18 for filter Icons
                tableRange = xlObj.model.sheets[sheetIdx].filterSettings.tableRange;
                for (i = 0, len = tableRange.length; i < len; i++) {
                    if (tableRange[i].tableID === tableId) {
                        tableFilteredColumn = tableRange[i].filteredColumns;
                        tablePredicate = tableRange[i].predicate;
                    }
                }
                xlObj._excelFilter._predicates[sheetIdx] = tablePredicate;
                this._isSearchEdit = true;
                $.extend(true, xlObj._excelFilter._columnsFiltered, sheet._filteredColumns);
                if (xlObj._phoneMode || xlObj._tabMode)
                    this._openNormalFilterDlg(columnName, xlObj._$colType, tableId, tabIdx);
                else
                    xlObj._excelFilter.openXFDialog({ field: columnName, dataSource: sheet.filterSettings.filteredRange ? sheet.filterSettings.filteredRange : sheet.dataSource, position: { X: position.xPos, Y: position.yPos }, type: xlObj._$colType, format: xlObj._$colFormat, filteredColumns: tableFilteredColumn, sortedColumns: [], key: sheetIdx, tableID: tableId, selectedColors: sheet._selectedCellColors, isFiltered: isFiltered, blank: "", enableColor: true, filteredByColor: sheet._filteredByColor });
            }
			strMenuObj = $("#" + xlObj._id + "string_MenuItem").data("ejMenu");
			numMenuObj = $("#" + xlObj._id + "number_MenuItem").data("ejMenu");
			strMenuObj && strMenuObj[xlObj.model.allowSorting ? oper[0] : oper[1]](strMenuObj.element.find("li:lt(4)"));
			numMenuObj && numMenuObj[xlObj.model.allowSorting ? oper[0] : oper[1]](numMenuObj.element.find("li:lt(4)"));			
        },

        _cancelHandler: function () {
            this._isSearchEdit = false;
        },

        applyFilter: function (args) {
            var xlObj = this.XLObj, predicate = args.predicate || ej.Predicate(args.field, args.operator, args.value, !args.matchcase), tablePredicate, tableRange, fColl = [], sheetIdx = xlObj.getActiveSheetIndex(), i, field;
            tableRange = xlObj.model.sheets[sheetIdx].filterSettings.tableRange;
            !xlObj._isFiltered && xlObj.XLFilter.filter(args.filterRange);
            if (ej.isNullOrUndefined(xlObj._excelFilter._predicates[sheetIdx])) {
                xlObj._excelFilter._predicates[sheetIdx] = {};
                xlObj._excelFilter._predicates[sheetIdx][args.field] = {};
            }
            xlObj._excelFilter._predicates[sheetIdx][args.field] = predicate;
            if (args.filterCollection)
                fColl = args.filterCollection;
            else
                fColl.push({ actualFilterOperator: args.operator, actualFilterValue: args.value, actualPredicate: args.predicate, field: args.field, isCustom: true, matchcase: args.matchcase, operator: args.operator, predicate: args.predicate, value: args.value });
            this._filterHandler({ action: "filtering", fieldName: args.field, tableID: args.tableID || -1, ejpredicate: predicate, filterCollection: fColl });
        },


        _filterHandler: function (args) {
			if(args.originalEvent) {
				var clName = args.originalEvent.target.parentElement.className;
				if(clName && clName.indexOf("hdr") > -1)
					return;
			}
			var i, len, tab, startRow, avble = false, tabIdx = -1, colIdx, range, arg = {}, fQMgr, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), query, obj, objectIndex, filterObj, tableFilteredColumn = [], tablePredicate = {}, cell, isSelAllChkBox, isSrchVal;
            arg.requestType = (args.action === "sorting" || args.action === "filterbycolor") ? args.action : "filtering";
            tab = sheet.filterSettings.tableRange;
            xlObj.XLFilter._isSearchEdit = false;
            for (i = 0, len = tab.length; i < len; i++) {
                if (tab[i].tableID === args.tableID) {
                    $.extend(true, tableFilteredColumn, tab[i].filteredColumns);
                    tablePredicate = tab[i].predicate;
                    avble = true;
                    tabIdx = i;
                }
            }
            arg.tableID = args.tableID;
            if (args.action === "filtering" || args.action === "clearfiltering") {
				arg.rowIndex = tab[tabIdx].startRow - 1;
				arg.colIndex = xlObj._generateColCount(args.fieldName) - 1;
                fQMgr = ej.DataManager(tableFilteredColumn);
                query = new ej.Query().where("field", ej.FilterOperators.equal, args.fieldName);
                obj = fQMgr.executeLocal(query);
                arg.filteredColumns = tableFilteredColumn;
                for (i = 0, len = obj.length; i < len; i++) {
                    objectIndex = $.inArray(obj[i], tableFilteredColumn);
                    (objectIndex >= 0) && tableFilteredColumn.splice(objectIndex, 1);
                }
                if (args.action === "clearfiltering")
                    delete xlObj._excelFilter._predicates[sheetIdx][args.fieldName];
                else
                    ej.merge(tableFilteredColumn, args.filterCollection);
                tablePredicate = xlObj._excelFilter._predicates[sheetIdx];
            }
            if (avble) {
                tab[tabIdx].filteredColumns = tableFilteredColumn;
                tab[tabIdx].filterCollection = args.filterCollection;
                tab[tabIdx].predicate = tablePredicate;
                tab[tabIdx].action = args.action;
                if (tableFilteredColumn.length < 1) {
                    var multiIdx = tab[tabIdx].multifilterIdx, fieldName;
                    for (var i = multiIdx[0]; i <= multiIdx[multiIdx.length - 1]; i++) {
                        fieldName = xlObj._generateHeaderText(i + 1);
                        if (!ej.isNullOrUndefined(tab[tabIdx].fColumns[fieldName]))
                            tab[tabIdx].fColumns[fieldName] = [];
                    }
                }
                else
                    tab[tabIdx].fColumns[args.fieldName] = $.extend(true, [], tableFilteredColumn);
            }
			range = sheet.filterSettings.tableRange[tabIdx].selectedRange;
            var colIndexs = sheet.filterSettings.tableRange[tabIdx].selectedCellIndexes, filterColl = sheet._filterColl;
            if (args.action === "filtering" || args.action === "clearfiltering") {
                arg.currentFilteringColumn = args.fieldName;
                arg.ejpredicate = args.ejpredicate;
                arg.filterCollection = $.extend(true, [], args.filterCollection);
                arg.action = args.action;
                arg.reqType = "filter";
                arg.sheetIndex = sheetIdx;
                arg.filteredcolumns = tableFilteredColumn;
                arg.predicate = tablePredicate;
            }
            else if (args.action === "sorting") {
                if (!xlObj.model.allowSorting)
                    return;
                arg.requestType = arg.action = args.action;
                colIdx = xlObj.XLEdit.getColumnIndexByField(args.sortDetails.field);
                xlObj.XLSort._isSortByFilter = true;
				if(xlObj.XLSort.sortByRange(xlObj.swapRange([range.startRow, colIndexs[0], range.endRow, colIndexs[colIndexs.length - 1]]), args.sortDetails.field, args.sortDetails.direction, args.tableID))
					return;
                this._changeSortIcon({ rowIndex: range.startRow - 1, colIndex: colIdx }, args.sortDetails.direction);
                for (var i = 0, len = colIndexs.length; i < len; i++) {
                    if (colIndexs[i] != colIdx && ((filterColl[range.startRow - 1][colIndexs[i]].status.indexOf("-asc") > -1) || (filterColl[range.startRow - 1][colIndexs[i]].status.indexOf("-dsc") > -1))) {
                        filterColl[range.startRow - 1][colIndexs[i]].status = "e-ssfilter";
                        if (xlObj._isRowViewable(sheetIdx, range.startRow - 1)) {
                            cell = xlObj.getCell(range.startRow - 1, colIndexs[i]).find('.e-filterspan')[0];
                            xlObj._removeClass(cell, "e-ssfilter-asc");
                            xlObj._removeClass(cell, "e-ssfilter-dsc");
                            xlObj.addClass(cell, "e-ssfilter");
                        }
                    }
                }
            }
            else {
                arg.requestType = arg.action = args.action;
                arg.range = sheet._selectedRange;
				if(xlObj.model.allowSorting && xlObj.XLSort._sortRangeAlert([range.startRow, colIndexs[0], range.endRow, colIndexs[colIndexs.length - 1]]))
					return;
                var colors;
                if (args.action === "sortbycolor") {
                    arg.sortColumn = args.sortDetails.field;
                    arg.operation = args.sortDetails.operation;
                    colors = args.sortDetails.color.replace("rgb(", "").replace(")", "").split(",");
                }
                else {
                    if (xlObj._isUndoRedo) {
                        arg.filterColumn = args.columnName;
                        arg.operation = args.operation;
                    }
                    else {
                        arg.filterColumn = args.filterDetails.field;
                        arg.operation = args.filterDetails.operation;
                        colors = args.filterDetails.color.replace("rgb(", "").replace(")", "").split(",");
                    }
                    arg.tableID = args.tableID;
                    xlObj.model.sheets[sheetIdx]._filteredByColor = arg.filterColumn;
                }
                var r, g, b;
                if (!xlObj._isUndoRedo) {
                    r = colors[0];
                    g = colors[1];
                    b = colors[2];
                }
                if (arg.operation === "sortbgcolor" || arg.operation === "filterbgcolor")
                    arg.bgcolor = xlObj._isUndoRedo ? args.bgcolor : this._convertrgbtohex(parseInt(r), parseInt(g), parseInt(b));
                else
                    arg.fgcolor = xlObj._isUndoRedo ? args.fgcolor : this._convertrgbtohex(parseInt(r), parseInt(g), parseInt(b));
            }
            arg.oprType = "filter";
            arg.selRange = xlObj._getAlphaRange(sheetIdx, tab[tabIdx].startRow - 1, tab[tabIdx].multifilterIdx[0], tab[tabIdx].endRow, tab[tabIdx].multifilterIdx[tab[tabIdx].multifilterIdx.length - 1]);
            if (args.action !== "sorting")
                xlObj._processBindings(arg) && (tableFilteredColumn = temp);
            if (args.action === "clearfiltering")
                xlObj.XLRibbon._isFilterSelect.status = false;
            xlObj.model.allowComments && xlObj.XLComment._updateCmntArrowPos();
            xlObj.XLSelection._refreshBorder();
			if(xlObj.model.showRibbon)
				xlObj.XLRibbon._refreshRibbonIcons();
			if (xlObj._isFrozen(xlObj.getFrozenRows()))
			    xlObj.XLFreeze._refreshFreezeRowDiv();
        },

        _convertrgbtohex: function (r, g, b) {
            return "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
        },

        _clearFilterColumn: function (fieldName, filterOperator, filterValue, predicate, matchcase, actualFilterValue, tableId) {
            var xlObj = this.XLObj, tabRange, args = {}, i, len, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), firstLoop = false, filterObject = {}, dataManger, query, obj, objectIndex,
                tab = sheet.filterSettings.tableRange, filteredcolumns = [], fltrcolIdx;
            args.requestType = ej.Grid.Actions.Filtering;
            args.currentFilterObject = [];
            (!$.isArray(filterOperator)) && (filterOperator = $.makeArray(filterOperator));
            (!$.isArray(filterValue)) && (filterValue = $.makeArray(filterValue));
            this._currentFilterColumn = this._getColumnByField(sheetIdx, fieldName);
            for (var idx = 0, ln = filterOperator.length; idx < ln; idx++) {
                filterObject = { field: fieldName, operator: filterOperator[idx], value: filterValue[idx], matchcase: matchcase, predicate: predicate, actualFilterValue: actualFilterValue };
                if (!firstLoop) {
                    for (i = 0, len = tab.length; i < len; i++) {
                        if (tab[i].tableID === tableId) {
                            tabRange = tab[i];
                            $.extend(true, filteredcolumns, tab[i].filteredColumns);
                            xlObj._excelFilter._predicates[sheetIdx] = tab[i].predicate;
                            sheet.filterSettings.filteredRange = sheet.filterSettings.tableRange[i].filteredRange;
                            sheet._selectedCellIndexes = tab[i].selectedCellIndexes;
                            sheet._selectedRange = tab[i].selectedRange;
                            sheet._multifilterIdx = tab[i].multifilterIdx;
                        }
                    }
                    dataManger = ej.DataManager(filteredcolumns);
                    query = new ej.Query().where("field", ej.FilterOperators.equal, filterObject.field);
                    obj = dataManger.executeLocal(query);
                    for (i = 0, len = obj.length; i < len; i++) {
                        objectIndex = $.inArray(obj[i], filteredcolumns);
                        if (objectIndex !== -1)
                            filteredcolumns.splice(objectIndex, 1);
                    }
                }
            }
            fltrcolIdx = $.inArray(fieldName, sheet._filteredColumns);
            if (fltrcolIdx > -1)
                sheet._filteredColumns.splice(fltrcolIdx, 1);
            if (xlObj._isUndoRedo && xlObj.isUndefined(tabRange))
                return;
            firstLoop = true;
            delete xlObj._excelFilter._predicates[sheetIdx][fieldName];
            tabRange.filteredColumns = filteredcolumns;
            tabRange.predicate = xlObj._excelFilter._predicates[sheetIdx];
            args.currentFilterObject.push(filterObject);
            args.filterCollection = filteredcolumns;
            args.currentFilteringColumn = fieldName;
            args.filteredcolumns = filteredcolumns;
            args.action = "clearfiltering";
            args.reqType = "filter";
            args.tableID = tableId;
            args.selRange = xlObj._getAlphaRange(sheetIdx, tabRange.startRow - 1, tabRange.multifilterIdx[0], tabRange.endRow, tabRange.multifilterIdx[tabRange.multifilterIdx.length - 1]);
            if (xlObj._processBindings(args)) {
                sheet.filterSettings.filteredColumns.reverse().splice(0, filterOperator.length);
                sheet.filterSettings.filteredColumns.reverse();
            }
            xlObj.model.allowComments && xlObj.XLComment._updateCmntArrowPos();
            this.XLObj.XLSelection._refreshBorder();
        },

        _getFilterHeader: function (sheetIdx, rowIdx, colIdx) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), filterColl = sheet._filterColl;
            if (!ej.isNullOrUndefined(filterColl[rowIdx]) && !ej.isNullOrUndefined(filterColl[rowIdx][colIdx]))
                return filterColl[rowIdx][colIdx];
        },

        //Format As Table
        _filterTable: function (sheetIdx, id, range) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), cellIndex = [], alfltr = false, multiFltr = false, tabRange, filterIcon, filClass,
                filterHdr;
            sheet._multipleFiltering = false;
            sheet._multifilterIdx = [];
            var endCell = range ? range.endCell : $.extend(true, {}, sheet._endCell), startCell = range ? range.startCell : $.extend(true, {}, sheet._startCell);
            for (var i = startCell.colIndex; i <= endCell.colIndex; i++) {
                filterHdr = this._getFilterHeader(sheetIdx, startCell.rowIndex, i);
                if (!ej.isNullOrUndefined(filterHdr) && filterHdr.status.indexOf("e-ssfilter") > -1)
                    alfltr = true;
                else {
                    filterIcon = this._getFilterIcon();
                    filClass = "e-ft" + id;
                    filterIcon.addClass(filClass);
                    this._applyFilterIcon({ rowIndex: startCell.rowIndex, colIndex: i }, filterIcon);
                    cellIndex.push(i);
                    sheet._multifilterIdx.push(i);
                }
            }
            xlObj.XLScroll._getColWidths(sheetIdx, startCell.colIndex);
            if (!alfltr) {
                if (cellIndex.length > 1) {
                    sheet._multipleFiltering = true;
                    multiFltr = true;
                }
                startCell.rowIndex = startCell.rowIndex + 1;
                this._getSelectedRangeData(startCell, endCell, id, startCell.colIndex);
                if (!xlObj._isFATResize)
                    sheet.filterSettings.tableRange.push({filterCollection: [], startRow: startCell.rowIndex, endRow: endCell.rowIndex, tableID: id, multiFiltering: multiFltr, multifilterIdx: cellIndex, selectedCellIndexes: cellIndex, selectedRange: $.extend(true, {}, sheet._selectedRange), filteredRange: sheet.filterSettings.filteredRange, filteredColumns: sheet.filterSettings.filteredColumns, fColumns: {}, predicate: {}, hiddenIdx: [], filterColumnName:[] });
                else {
                    tabRange = sheet.filterSettings.tableRange;
                    if (tabRange.length)
                        for (var i = 0, len = tabRange.length; i < len; i++) {
                            if (tabRange[i].tableID === id) {
                                tabRange[i].endRow = endCell.rowIndex;
                                break;
                            }
                        }
                    xlObj._isFATResize = false;
                }
            }
        },

        _clearFilterTable: function (sheetIdx, tableId, rmFltr) {
			var sheet = this.XLObj.getSheet(sheetIdx ? sheetIdx : this.getActiveSheetIndex()),tableRange;
            tableRange = sheet.filterSettings.tableRange; 
            for (var i = 0, len = tableRange.length; i < len; i++) {
                if (tableRange[i].tableID === tableId){
                    this._clearAllFilter(sheetIdx, i, rmFltr);
					len = tableRange.length;
				}
			}
        },

        _clearAllFilter: function (sheetIdx, tabIdx, rmFltr) {
            var len, xlObj = this.XLObj, container = xlObj._dataContainer.sheets[sheetIdx], sheet = xlObj.getSheet(sheetIdx), tableRange = sheet.filterSettings.tableRange, fltrCell, cell, j, ln, field,
                multiIdx, startRow, isViewable, fltrState;
            sheet._selectedRange = tableRange[tabIdx].selectedRange;
            multiIdx = tableRange[tabIdx].multifilterIdx;
            startRow = tableRange[tabIdx].startRow;
            for (j = 0, ln = multiIdx.length; j < ln; j++) {
                field = sheet.columns[multiIdx[j]].field;
                fltrState = xlObj.XLEdit.getPropertyValue(startRow - 1, multiIdx[j], "filterState");
                if (!ej.isNullOrUndefined(fltrState) && fltrState.indexOf("filtered") > -1)
                    this._clearFilterColumn(field, "", "", "Or", "", "", tableRange[tabIdx].tableID);
                if (!rmFltr) {
                    if (xlObj._isRowViewable(sheetIdx, startRow - 1)) {
                        fltrCell = xlObj.getCell(startRow - 1, multiIdx[j]);
						xlObj.addClass(fltrCell[0], "e-wrapword");
                        cell = fltrCell.find('.e-filterspan');
                        $(cell).remove();
                        fltrCell.removeClass("e-filterhdr");
                    }
                    if (container[startRow - 1][multiIdx[j]])
                    {
                        delete container[startRow - 1][multiIdx[j]]["isFilterHeader"];
                        delete container[startRow - 1][multiIdx[j]]["filterState"];
                    }
                    delete sheet._filterColl[startRow - 1][multiIdx[j]];
                }
            }
            if (!rmFltr) {
                tableRange.splice(tabIdx, 1);
                len = tableRange.length;
            }
        },

        _clearFilterTableIcon: function (sheetIdx, tableId) {
            var xlObj = this.XLObj, isFilterVisible, filterSpan, sheet = xlObj.getSheet(sheetIdx), tableRange = sheet.filterSettings.tableRange, multiIdx, startRow, j, ln, cell;
            for (var i = 0, len = tableRange.length; i < len; i++) {
                if (tableRange[i].tableID === tableId) {
                    sheet._selectedRange = tableRange[i].selectedRange;
                    sheet.filterSettings.filteredRange = tableRange[i].filteredRange;
                    multiIdx = tableRange[i].multifilterIdx;
                    startRow = tableRange[i].startRow;
                    for (j = 0, ln = multiIdx.length; j < ln; j++) {
                        //Need to Update in Container ( filter Icon is hidden or not )
                        isFilterVisible = xlObj.XLEdit.getPropertyValue(startRow - 1, multiIdx[j], "isFilterVisible");
                        if (xlObj._isRowViewable(sheetIdx, startRow - 1)) {
                            cell = xlObj.getCell(startRow - 1, multiIdx[j]);
							filterSpan = cell.find('.e-filterspan');
                            if(isFilterVisible) {
								filterSpan.hide();
								xlObj._removeClass(cell[0], "e-filterhdr");
							}
							else {
								xlObj.addClass(cell[0], "e-filterhdr");
								filterSpan.show();
							}
                        }
                        xlObj.XLEdit._updateDataContainer({ rowIndex: startRow - 1, colIndex: multiIdx[j] }, { dataObj: { isFilterVisible: !isFilterVisible } });
                    }
                }
            }
        },

        _insertFilterIcon: function (i, j, tabRange, fRow, fApplied) { //fRow- Filtered Row, fApplied - filter Applied
            var filterIcon, filClass;
            filterIcon = this._getFilterIcon();
            if (tabRange.tableID > -1) 
                this.XLObj.XLEdit._updateDataContainer({ rowIndex: i, colIndex: j }, { dataObj: { tableName: "e-table" + tabRange.tableID } });
            this._applyFilterIcon({ rowIndex: i, colIndex: j }, filterIcon);
        },

        _changeFilterIcon: function (cellObj, status, fltrState) {
            var fSpan, activeCell, fltrStr, isViewed = false, xlObj = this.XLObj, rowIdx = cellObj.rowIndex, colIdx = cellObj.colIndex, ralign = xlObj._rAlign, sheetIdx = xlObj.getActiveSheetIndex();
            fltrStr = this._getFilterHeader(sheetIdx, rowIdx, colIdx).status;
            if (xlObj._isRowViewable(sheetIdx, rowIdx)) {
                activeCell = xlObj.getCell(rowIdx, colIdx);
                fSpan = activeCell.find('.e-filterspan')[0];
                activeCell.removeClass(ralign);
                isViewed = true;
            }
            if (status === "filter") {
                if (fltrState.indexOf("filtered") < 0) {
                    xlObj.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { filterState: fltrState.replace("filter", "filtered") } });
                    xlObj.getSheet(sheetIdx)._filterColl[rowIdx][colIdx].status = fltrStr.replace("e-ssfilter", "e-ssfiltered");
                    if (isViewed)
                        fSpan.className = fSpan.className.replace("e-ssfilter", "e-ssfiltered");
                }
            }
            else {
                xlObj.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { filterState: fltrState.replace("filtered", "filter") } });
                xlObj.getSheet(sheetIdx)._filterColl[rowIdx][colIdx].status = fltrStr.replace("e-ssfiltered", "e-ssfilter");
                if (isViewed && !xlObj.isUndefined(fSpan))
                    fSpan.className = fSpan.className.replace("e-ssfiltered", "e-ssfilter");
            }
        },

        _changeSortIcon: function (cellObj, status) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), fSpan, idx, fltrStr, fStr, isViewed = false, filterColl = xlObj.getSheet(sheetIdx)._filterColl;
            fltrStr = filterColl[cellObj.rowIndex][cellObj.colIndex].status;
            idx = (fltrStr.indexOf("e-ssfiltered") > -1) ? 12 : 10;
            fStr = fltrStr.substr(0, idx);
            if (xlObj._isRowViewable(sheetIdx, cellObj.rowIndex)) {
                var fSpan = xlObj.getCell(cellObj.rowIndex, cellObj.colIndex).find('.e-filterspan')[0];
                fltrStr = fSpan.className;
                idx = fltrStr.indexOf("e-ssfilter") + idx;
                isViewed = true;
            }
            if (status === "ascending") {
                filterColl[cellObj.rowIndex][cellObj.colIndex]["status"] = fStr + "-asc";
                if (isViewed)
                    fSpan.className = fltrStr.substr(0, idx) + "-asc";
            }
            else {
                filterColl[cellObj.rowIndex][cellObj.colIndex]["status"] = fStr + "-dsc";
                if (isViewed)
                    fSpan.className = fltrStr.substr(0, idx) + "-dsc";
            }
        },

        _extendFilterRange: function (tid, range) {//extend the filter range
            var xlObj = this.XLObj, dataSrcIdx, tabRange = xlObj.getSheet(xlObj.getActiveSheetIndex()).filterSettings.tableRange;
            if (tabRange.length) {
                for (var i = 0, len = tabRange.length; i < len; i++) {
                    if (tabRange[i].tableID == tid) {
                        if (tabRange[i].endRow < range[2]) {
                            dataSrcIdx = tabRange[i].selectedRange.dataSourceIndexes;
                            tabRange[i].endRow = tabRange[i].selectedRange.endRow = range[2];
                            if (dataSrcIdx[dataSrcIdx.length - 1] < tabRange[i].endRow) {
                                for (var j = dataSrcIdx[dataSrcIdx.length - 1], len = tabRange[i].endRow; j < len; j++)
                                    dataSrcIdx.push(j + 1);
                            }
                        }
                        break;
                    }
                }
            }
        },

        _updateFilterIcons: function (stRow, endRow, colIdx, action) {
            var xlObj = this.XLObj, fltrState, cellObj, numFltr = $("#" + xlObj._id + "numberSelectAll").ejCheckBox("instance"), isNumFltr = numFltr ? false : numFltr.model.checked,
                strFltr = $("#" + xlObj._id + "stringSelectAll").ejCheckBox("instance"), isStrFltr = strFltr ? false : strFltr.model.checked;
            for (var i = stRow; i <= endRow; i++) {
                cellObj = { rowIndex: i, colIndex: colIdx };
                fltrState = xlObj.XLEdit.getPropertyValue(i, colIdx, "filterState");
                if (fltrState.indexOf("filtered") > -1 && (action == "clearfiltering" || (isNumFltr || isStrFltr)))
                    this._changeFilterIcon(cellObj, "filtered", fltrState);
                else if (fltrState.indexOf("filtered") < 0 && action != "clearfiltering")
                    this._changeFilterIcon(cellObj, "filter", fltrState);
                break;
            }
        },

        _fltrRowHighlight: function (startRow, endRow, status, tableID, fltrLen) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), rowHdrCnt = xlObj._getJSSheetRowHeaderContent(sheetIdx), rowHdrCell = rowHdrCnt.find("table tr:gt(" + (startRow - 1) + "):lt(" + ((endRow - startRow) + 1) + ")"), range, tableCltn = xlObj.model.sheets[sheetIdx].filterSettings.tableRange, len, i, startHdrRow, endHdrRow;
            var filterRowCln = xlObj.model.sheets[sheetIdx].filteredRowsCollection;
            if (xlObj.model.scrollSettings.allowVirtualScrolling) {
                rowHdrCell = rowHdrCnt.find("table tr").filter(function () { return ($(this).attr("idx") >= startRow && $(this).attr("idx") <= endRow); });
            }
            if (status === "clear") {
                rowHdrCell.find("td").removeClass("e-filterhiglight");
                xlObj.clearRangeData([startRow, 0, endRow, 0], ["isFilterHighlight"]);
                if (filterRowCln.length) {
                    for (var j = 0; j < filterRowCln.length; j++) {
                        for (i = 0, len = tableCltn.length; i < len; i++) {
                            if (filterRowCln[j] >= tableCltn[i].startRow && filterRowCln[j] <= tableCltn[i].endRow && !xlObj.XLEdit.getPropertyValue(filterRowCln[j], 0, "isRHide")) {
                                xlObj.updateUniqueData({ "isFilterHighlight": true }, [tableCltn[i].startRow, 0, tableCltn[i].endRow, 0]);
                                if (xlObj.model.scrollSettings.allowVirtualScrolling)
                                    rowHdrCnt.find("table tr").filter(function () { return ($(this).attr("idx") >= tableCltn[i].startRow && $(this).attr("idx") <= tableCltn[i].endRow); }).find("td").addClass("e-filterhiglight");
                                else
                                    rowHdrCnt.find("table tr:gt(" + (tableCltn[i].startRow - 1) + "):lt(" + ((tableCltn[i].endRow - tableCltn[i].startRow) + 1) + ")").find("td").addClass("e-filterhiglight");
                            }
                        }
                    }
                }
            }
            else if (status === "add") {
                rowHdrCell.find("td").addClass("e-filterhiglight");
                xlObj.updateUniqueData({ "isFilterHighlight": true }, [startRow, 0, endRow, 0]);
            }
        },

        _checkFilterApplied: function (sheetIdx, rowIdx, rowCount, colIdx, colCount, status) {
            var chkObj, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), tblRange = sheet.filterSettings.tableRange, isAlert;
            xlObj._isFilterApplied = false;
            for (var i = 0, len = tblRange.length; i < len; i++) {
                isAlert = false;
				if(tblRange[i].filteredColumns.length) {
					chkObj = xlObj._checkFilterMerge(sheetIdx, [tblRange[i].startRow - 1, tblRange[i].multifilterIdx[0], tblRange[i].endRow, tblRange[i].multifilterIdx[tblRange[i].multifilterIdx.length - 1]], rowIdx, rowCount, colIdx, colCount, status, "filter", isAlert);
					xlObj._isFilterApplied = !chkObj.isAlert;
				}
				else
					xlObj._isFilterApplied = false;
				if(xlObj._isFilterApplied)
					return true;
            }   
			return false;
        },

        _updateFilterCollection: function (sheetIdx, idx, count, position, operation) {
            var i, j, c, iLen,fTable, jLen,tid, cLen, startCell, endCell, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), tblRange = sheet.filterSettings.tableRange, tbl, colIdx,
                isVirtualScroll = xlObj.model.scrollSettings.allowVirtualScrolling, fltrState, field;
            count = count + 1;
            if (position === "row") {
                for (i = 0, iLen = tblRange.length; i < iLen; i++) {
                    tbl = tblRange[i];
                    colIdx = tbl.multifilterIdx;
                    if (operation === "insert") {
                        if (idx <= tbl.endRow) {
                            tbl.endRow = tbl.endRow + count;
                            if (idx < tbl.startRow) {
                                tbl.startRow = tbl.startRow + count;
                                if (tbl.tableID > -1)
                                    xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: count, isInsertBefore: true });
                            }
                            else {
                                if (tbl.tableID > -1)
                                    xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: count});
                            }
                        }
                    }
                    else {
                        if (idx <= tbl.endRow) {
                            tbl.endRow = tbl.endRow - count;                            
                            if (idx < tbl.startRow) {
                                tbl.startRow = tbl.startRow - count;
                                if (tbl.tableID > -1)
                                    xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: -count, isInsertBefore: true });
                            }
                            else {
                                if (tbl.tableID > -1)
                                    xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: -count });
                            }
                        }
                    }
                    startCell = { rowIndex: tbl.startRow, colIndex: colIdx[0] };
                    endCell = { rowIndex: tbl.endRow, colIndex: colIdx[colIdx.length - 1] };
                    this._getSelectedRangeData(startCell, endCell, tbl.tableID);
                    tbl.selectedRange = $.extend(true, {}, sheet._selectedRange);
                    tbl.filteredRange = $.extend(true, {}, sheet.filterSettings.filteredRange);
                }
            }
            else {
                var container = xlObj._dataContainer.sheets[sheetIdx], cIdx, dupCol;
                for (i = 0, iLen = tblRange.length; i < iLen; i++) {
                    tbl = tblRange[i], colIdx = tbl.multifilterIdx;
                    dupCol = $.extend(true, [], colIdx);
					cIdx = 0;
                    this._updateFilteredColumns(i, idx, count, operation);
                    if (operation === "insert") {
                        if (idx <= colIdx[0]) {
                            for (j = colIdx.length - 1; j >= 0; j--) {
                                colIdx[cIdx] = colIdx[cIdx] + count;
                                cIdx++;
                            }
                            if (tbl.tableID > -1)
                                xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: count,isInsertBefore:true });
                        }
                        else if (idx <= colIdx[colIdx.length - 1]) {
                            if (tbl.tableID > -1)
                                xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: count });
                            for (j = dupCol[dupCol.length - 1], jLen = dupCol[dupCol.length - 1] + count; j <= jLen; j++) {
                                if (colIdx.indexOf(j) === -1)
                                    colIdx.push(j);
                            }
                        }
                    }
                    else {
                        if (idx <= colIdx[0]) {
                            for (j = 0; j < colIdx.length; j++)
                                colIdx[j] = colIdx[j] - count;
                            if (tbl.tableID > -1)
                                xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: -count, isInsertBefore: true });
                        }
                        else if (idx <= colIdx[colIdx.length - 1]) {
                            for (c = idx, cLen = colIdx[colIdx.length - 1]; c <= cLen; c++) {
                                field = xlObj._generateHeaderText(c + 1);
                                fltrState = xlObj.XLEdit.getPropertyValue(tbl.startRow - 1, c, "filterState");
                                if (!ej.isNullOrUndefined(fltrState) && fltrState.indexOf("filtered") > -1)
                                    this._clearFilterColumn(field, "", "", "Or", "", "", tbl.tableID);
                            }
                            colIdx.splice(colIdx.length - count, count);
                            if (tbl.tableID > -1)
                                xlObj.XLFormat._refreshTableRowCol({ tid: tbl.tableID, pos: position, cnt: -count });
                        }
                    }
                    startCell = { rowIndex: tbl.startRow, colIndex: colIdx[0] };
                    endCell = { rowIndex: tbl.endRow, colIndex: colIdx[colIdx.length - 1] };
                    this._getSelectedRangeData(startCell, endCell, tbl.tableID);
                    tbl.selectedRange = $.extend(true, {}, sheet._selectedRange);
                    tbl.filteredRange = $.extend(true, {}, sheet.filterSettings.filteredRange);
                    if (colIdx.length < 2)
                        tbl.multiFiltering = false;
                }
            }
        },

        _updateFilteredColumns: function (tabIdx, cIdx, count, operation) {
            var xlObj = this.XLObj, filterIdx, sheetIdx = xlObj.getActiveSheetIndex(), field, tableRange = xlObj.getSheet(sheetIdx).filterSettings.tableRange[tabIdx],
                filteredColumns = $.extend(true, [], tableRange.filteredColumns), fColumns = $.extend(true, {}, tableRange.fColumns), fCols = $.extend(true, {}, tableRange.fColumns),
                colIdxes = tableRange.multifilterIdx;
            for (var i = 0, len = filteredColumns.length; i < len; i++) {
                colIdx = xlObj.XLEdit.getColumnIndexByField(tableRange.filteredColumns[i]["field"]);
                if (cIdx <= colIdx) {
                    if (operation === "delete")
                        if (cIdx === colIdx)
                            filteredColumns.splice(i, 1);
                        else
                            filteredColumns[i]["field"] = xlObj._generateHeaderText(colIdx - count + 1);
                    else
                        filteredColumns[i]["field"] = xlObj._generateHeaderText(colIdx + count + 1);
                }
            }
            tableRange.filteredColumns = filteredColumns;
            var filter, pCol, cCol, pColHeaderTxt, cColHeaderTxt, avble = false, fColKeys1 = xlObj.getObjectKeys(tableRange.fColumns), fColKeys = xlObj.getObjectKeys(fColumns);
            tableRange.predicate = tableRange.predicate;
            for (var i = fColKeys.length - 1; i >= 0 ; i--) {
                filterIdx = xlObj.XLEdit.getColumnIndexByField(fColKeys[i]);
                for (var k = cIdx; k < cIdx + count; k++) {
                    if (k <= filterIdx) {
                        filter = $.extend(true, [], fColumns[fColKeys[i]]);
                        for (var j = 0; j < filter.length; j++) {
                            colIdx = xlObj.XLEdit.getColumnIndexByField(filter[j]["field"]);
                            if (k <= colIdx) {
                                if (operation === "delete")
                                    if (k === colIdx)
                                        filter.splice(i, 1);
                                    else
                                        filter[j]["field"] = xlObj._generateHeaderText(colIdx - count + 1);
                                else
                                    filter[j]["field"] = xlObj._generateHeaderText(colIdx + count + 1);
                            }
                        }
                        pCol = xlObj.XLEdit.getColumnIndexByField(fColKeys[i]);
                        pColHeaderTxt = xlObj._generateHeaderText(pCol + 1);
                        if (operation === "delete") {
                            cCol = pCol - count;
                            if (k === pCol) {
                                delete tableRange.predicate[pColHeaderTxt];
                                delete fCols[pColHeaderTxt];
                            }
                            else {
                                cColHeaderTxt=xlObj._generateHeaderText(cCol + 1);
                                fCols[cColHeaderTxt] = filter;
                                delete fCols[pColHeaderTxt];
                                tableRange.predicate[cColHeaderTxt] = xlObj._excelFilter.generatePredicate(filter);
                                delete tableRange.predicate[pColHeaderTxt];
                            }
                        }
                        else {
                            cCol = pCol + count;
                            cColHeaderTxt = xlObj._generateHeaderText(cCol + 1);
                            fCols[cColHeaderTxt] = filter;
                            delete fCols[pColHeaderTxt];
                            tableRange.predicate[cColHeaderTxt] = xlObj._excelFilter.generatePredicate(filter);
                            delete tableRange.predicate[pColHeaderTxt];
                        }
                    }
                }            
			}
            tableRange.fColumns = fCols;       
        },
        
        _renderCustomFilter: function () {
            var xlObj = this.XLObj, dlgId = xlObj._id + "_filter_custom", $dlg = $("#" + dlgId), $content = ej.buildTag("div#" + dlgId + "_content"),
                $filter = ej.buildTag("input#" + dlgId + "_filterBtn.e-filter", {}, {}, { "type": "button", "value": "Filter" }), $clear = ej.buildTag("input#" + dlgId + "_clearBtn.e-clear", {}, {}, { "type": "button", "value": "Clear" });
            $dlg.append($content.append(ej.buildTag("div.e-fltrbtndiv").append($filter).append($clear)));
            this._createButton("filter", $filter);
            this._createButton("clear", $clear);
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("Filter"), width: "100%", height: "100%", cssClass: "e-ss-dialog e-" + xlObj._id + "-dlg", open: function () { $("#" + xlObj._id + "_formatdlg_okbtn").focus(); }, close: ej.proxy(this._customFltrDlgClose, this) });
        },

        _customFltrDlgClose: function () {
            $("#" + this.XLObj._id + "_filter_custom_" + this._colType).hide(); 
        },

        _refreshCustomFilter: function (type) {
            var xlObj = this.XLObj, dlgId = xlObj._id + "_filter_custom", $drpdown = ej.buildTag("input#" + dlgId + "_" + type + "_ddinput.e-" + xlObj._id + "_customddl", {}, {}, { "type": "text" }), $tBox = ej.buildTag("input#" + dlgId + "_" + type + "_acString.e-filterval", {}, {"height": "26px", "width": "100%"}, { "type": "text" }), filterType, strMenuOpt = [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Starts With", value: "startswith" }, { text: "Ends With", value: "endswith" }, { text: "Contains", value: "contains" }],
                $content = $("#" + dlgId + "_content"), numMenuOpt = [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }];
            $content.prepend(ej.buildTag("div#" + dlgId + "_" + type, "", { display: "none" }).append(ej.buildTag("div.e-operdiv").append($drpdown)).append(ej.buildTag("div.e-textdiv").append($tBox)));
            $drpdown.ejDropDownList({ dataSource: numMenuOpt, width: "100%", fields: { id: "value", text: "text", value: "value" }, select: $.proxy(this._onNumFormatSelect, this), selectedItemIndex: 0 });
            switch (type) {
                case "string":
                    $drpdown.ejDropDownList("option", { dataSource: strMenuOpt, selectedItemIndex: 0 });
                    $tBox.ejAutocomplete({
                        width: "100%", height: 26, enableDistinct: true,
                        focusIn: function (args) {
                            filterType = $drpdown.ejDropDownList("model.value");
                        },
                    });
                    break;
                case "number":
                    $tBox.ejNumericTextbox({ showSpinButton: false, height: "26px", decimalPlaces: 2, width: "100%" });
                    break;
                case "boolean":
                    $tchkBox.ejCheckBox({});
                    break;
                case "date":
                    $tBox.ejDatePicker({ width: "100%" });
                    break;
            }
        },

        _createButton: function (name, element) {
            var $func = (name == "filter") ? ej.proxy(this._fltrBtnHandler, this) : ej.proxy(this._fltrClrHandler, this);
            element.ejButton({ size: "normal", type: "button", height: 22, width: 60, "click": $func, showRoundedCorner: true});
        },

        _fltrBtnHandler: function(e){
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), dlgId = xlObj._id + "_filter_custom", filterType = $("#" + dlgId + "_" + this._colType + "_ddinput").ejDropDownList("model.value"), filterVal = $("#" + dlgId + "_" + this._colType + "_acString").val();            
            arg = { action: "filtering", filterCollection: [{ field: this._colName, matchcase: true, operator: filterType, value: filterVal, predicate: "or" }], fieldName: this._colName, ejpredicate: { field: this._colName, operator: filterType, value: filterVal, isComplex: false, ignoreCase: false }, tableID: this._tableId };
            xlObj._excelFilter._predicates[sheetIdx][this._colName] = ej.Predicate(this._colName, filterType, filterVal);
            this._filterHandler(arg);
            $("#" + dlgId).ejDialog("close");
            $("#" + dlgId + "_" + this._colType).hide();
        },

        _fltrClrHandler: function(e) {
            var xlObj = this.XLObj, dlgId = xlObj._id + "_filter_custom", filterType = $("#" + dlgId + "_" + this._colType + "_ddinput").ejDropDownList("model.value");
            this._clearFilterColumn(this._colName, "", "", "Or", "", "", this._tableId);
            $("#" + dlgId).ejDialog("close");
            $("#" + dlgId + "_" + this._colType).hide();
        },

        _openNormalFilterDlg: function (colName, type, tableId, tableIdx) {
            var xlObj = this.XLObj, dlgId = xlObj._id + "_filter_custom";
            $("#" + dlgId + "_" + type).show();
            $("#" + dlgId).ejDialog("open");
            $("#" + dlgId + "_" + type + "_ddinput").ejDropDownList("option", { selectedItemIndex: 0 });
            this._colName = colName; this._colType = type; this._tableId = tableId;
            if (type === "string")
                $("#" + dlgId + "_" + type + "_acString").ejAutocomplete("option", { fields: { key: this._colName, text: this._colName }, dataSource: xlObj.getSheet(xlObj.getActiveSheetIndex()).filterSettings.tableRange[tableIdx].filteredRange })
        }
	};
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.ribbon = function (obj) {
        this.XLObj = obj;
        this._appTabCollection = {};
        this._tabCollection = [];
        this._contextualTabCollection = [];
        this._smallBtnHeight = 25;
        this._mediumBtnHeight = 35;
        this._bigBtnHeight = 75;
        this._splitBtnHeight = 75;
        this._dropDownHeight = 25;
        this._ribbonState = true;
        this._isSetModel = false;
        this._isDesignTab = true;
        this._isDirtySelect = false;
        this._isMergeSelect = false;
        this._isFilterSelect = {};
        this._hasTitle = "";
        this._isNmgrid = "";
        this._isPanelVisible = false;
        this._ctrlCreated = false;
        this._homeBtnIds = ["Home_Clipboard_Paste", "Home_Font_IncreaseFontSize", "Home_Font_DecreaseFontSize", "Home_Alignment_DecreaseIndent", "Home_Alignment_IncreaseIndent", "Home_Number_IncreaseDecimal", "Home_Number_DecreaseDecimal", "Home_Actions_Undo", "Home_Actions_Redo", "Home_Number_Accounting", "Home_Number_CommaStyle", "Home_Number_Percentage", "Home_Clipboard_Cut", "Home_Clipboard_Copy"];
        this._homeSptBtnIds = ["Home_Clipboard_PasteOptions", "Home_Font_Border", "Home_Styles_ConditionalFormatting", "Home_Styles_FormatAsTable", "Home_Styles_CellStyles", "Others_Editing_FindSelect", "Home_Editing_Clear", "Home_Alignment_Merge", "Home_Editing_SortFilter", "Home_Editing_AutoSum"];
        this._homeToggleBtnIds = ["Home_Font_Bold", "Home_Font_Italic", "Home_Font_Underline", "Home_Font_StrikeThrough", "Home_Alignment_AlignLeft", "Home_Alignment_AlignRight", "Home_Alignment_AlignCenter", "Home_Alignment_TopAlign", "Home_Alignment_MiddleAlign", "Home_Alignment_BottomAlign", "Home_Alignment_WrapText", "Home_Clipboard_FormatPainter"];
        this._homeDdIds = ["Home_Number_NumberFormat", "Home_Font_FontSize", "Home_Font_FontFamily"];
        this._homeCpIds = ["Home_Font_FillColor", "Home_Font_FontColor"];
        this._insertBtnIds = ["Insert_Tables_PivotTable", "Insert_Tables_Table", "Insert_Links_Hyperlink", "Insert_Illustrations_Pictures"];
        this._insertSptBtnIds = ["Insert_Charts_ColumnChart", "Insert_Charts_BarChart", "Insert_Charts_StockChart", "Insert_Charts_LineChart", "Insert_Charts_AreaChart", "Insert_Charts_PieChart", "Insert_Charts_ScatterChart"];
        this._dataBtnIds = ["Data_SortFilter_SortAtoZ", "Data_SortFilter_SortZtoA", "Data_SortFilter_Filter", "Data_SortFilter_ClearFilter", "Data_DataTools_DataValidation"];
        this._dataSptBtnIds = ["Data_DataTools_DataValidationOptions"];
        this._pageLayChckBxIds = ["PageLayout_Show_Headings", "PageLayout_Show_Gridlines"];
        this._pageLayBtnIds = ["PageLayout_PageLayout_PageSize", "PageLayout_Print_Print", "PageLayout_Print_PrintSelected"];
        this._pageLaySptBtnIds = ["PageLayout_PageLayout_PageSizeOptions"];
        this._reviewTglBtnIds = ["Review_Changes_ProtectSheet", "Review_Changes_ProtectWorkbook", "Review_Changes_LockCell"];
        this._cmntBtnIds = ["Review_Comments_NewComment", "Review_Comments_DeleteComment", "Review_Comments_PreviousComment", "Review_Comments_NextComment", "Review_Comments_ShowHideComment"];
        this._cmntTglBtnIds = ["Review_Comments_ShowAllComments"];
        this._othersBtnIds = ["Others_Cells_InsertCell", "Others_Cells_DeleteCell", "Others_Formulas_NameManager", "Others_Formulas_DefineName", "Others_CalCulation_CalculateNow", "Others_CalCulation_CalculateSheet"];
        this._othersSptBtnIds = ["Others_Cells_InsertCellOptions", "Others_Cells_DeleteCellOptions", "Others_Editing_FindSelect", "Others_Window_FreezePanes", "Others_CalCulation_CalculationOptions"];
        this._contextualBtnIds = ["Design_Tools_ResizeTable", "Design_Tools_ConvertToRange"];
        this._contextualInputIds = ["Ribbon_Design_Properties_TableName"];
        this._contextualCheckBoxIds = ["Design_TableStyleOptions_FirstColumn", "Design_TableStyleOptions_LastColumn", "Design_TableStyleOptions_TotalRow", "Design_TableStyleOptions_FilterColumn"];
        this._protectStateBtnIds = ["Home_Clipboard_Cut", "Home_Clipboard_Copy", "Others_Editing_FindSelect", "Home_Clipboard_Paste", "Home_Clipboard_PasteOptions", "Home_Actions_Undo", "Home_Actions_Redo", "Review_Changes_ProtectSheet", "Review_Changes_ProtectWorkbook", "PageLayout_Print_Print", "PageLayout_Print_PrintSelected", "Others_Cells_InsertCellOptions", "Others_Cells_DeleteCellOptions", "Others_Cells_InsertCell", "Others_Cells_DeleteCell"];
        this._chartDesignBtnIds = ["ChartDesign_Data_SwitchRowColumn", "ChartDesign_Data_SelectData", "ChartDesign_Type_ChangeChartType"];
        this._chartDesignSptBtnIds = ["ChartDesign_ChartLayouts_AddChartElement"];
        this._chartDesignDdIds = ["ChartDesign_ChartThemes_ChartThemes"];
        this._formatBtnIds = ["Format_Adjust_ChangePicture"];
        this._formatSptBtnIds = ["Format_Adjust_ResetPicture", "Format_Border_PictureBorder"];
        this._pasteMenuData = [
                 { id: "PasteSpecial", text: obj._getLocStr("PasteSpecial"), parentId: null },
                 { id: "PasteValues", text: obj._getLocStr("PasteValues"), parentId: null }
        ];
        this._fontFamily = [{ value: "1", text: "Angsana New" }, { value: "2", text: "Arial" }, { value: "3", text: "Arial Black" }, { value: "4", text: "Batang" }, { value: "5", text: "Book Antiqua" }, { value: "6", text: "Browallia New" }, { value: "7", text: "Calibri" }, { value: "8", text: "Cambria" }, { value: "9", text: "Candara" }, { value: "10", text: "Century" }, { value: "11", text: "Comic Sans MS" }, { value: "12", text: "Consolas" }, { value: "13", text: "Constantia" }, { value: "14", text: "Corbel" }, { value: "15", text: "Cordia New" }, { value: "16", text: "Courier" }, { value: "17", text: "Courier New" }, { value: "18", text: "DilleniaUPC" }, { value: "19", text: "Dotum" }, { value: "20", text: "FangSong" }, { value: "21", text: "Garamond" }, { value: "22", text: "Georgia" }, { value: "23", text: "Gulim" }, { value: "24", text: "GungSuh" }, { value: "25", text: "KaiTi" }, { value: "26", text: "JasmineUPC" }, { value: "27", text: "Malgun Gothic" }, { value: "28", text: "Mangal" }, { value: "29", text: "Meiryo" }, { value: "30", text: "Microsoft JhengHei" }, { value: "31", text: "Microsoft YaHei" }, { value: "32", text: "MingLiu" }, { value: "33", text: "MingLiU_HKSCS" }, { value: "34", text: "MS Gothic" }, { value: "35", text: "MS Mincho" }, { value: "36", text: "MS PGothic" }, { value: "37", text: "MS PMincho" }, { value: "38", text: "PMingliU" }, { value: "39", text: "PMingLiU-ExtB" }, { value: "40", text: "SimHei" }, { value: "41", text: "SimSun" }, { value: "42", text: "SimSun-ExtB" }, { value: "43", text: "Tahoma" }, { value: "44", text: "Times" }, { value: "45", text: "Times New Roman" }, { value: "46", text: "Trebuchet MS" }, { value: "47", text: "Verdana" }, { value: "48", text: "Yu Gothic" }, { value: "49", text: "Yu Mincho" }];
        this._fontSize = [{ value: "8pt", text: "8" }, { value: "9pt", text: "9" }, { value: "10pt", text: "10" }, { value: "11pt", text: "11" }, { value: "12pt", text: "12" }, { value: "14pt", text: "14" }, { value: "16pt", text: "16" }, { value: "18pt", text: "18" }, { value: "20pt", text: "20" }, { value: "22pt", text: "22" }, { value: "24pt", text: "24" }, { value: "26pt", text: "26" }, { value: "28pt", text: "28" }, { value: "36pt", text: "36" }, { value: "48pt", text: "48" }, { value: "72pt", text: "72" }];
        this._mergeMenuData = [
                { id: "MergeAndCenter", text: obj._getLocStr("MergeAndCenter"), parentId: null, sprite: "e-icon e-ss-mergecenter" },
                { id: "MergeAcross", text: obj._getLocStr("MergeAcross"), parentId: null, sprite: "e-icon e-ss-mergeacross" },
                { id: "MergeCells", text: obj._getLocStr("MergeCells"), parentId: null, sprite: "e-icon e-ss-merge" },
                { id: "UnmergeCells", text: obj._getLocStr("UnmergeCells"), parentId: null, sprite: "e-icon e-ss-unmerge" }
        ];
        this._sortFltrMenuData = [
                { id: 'Ribbon_SortAtoZ', text: this.XLObj._getLocStr('SortAtoZ'), parentId: null, sprite: 'e-icon e-ssdrop-sortatoz' },
                { id: 'Ribbon_SortZtoA', text: this.XLObj._getLocStr('SortZtoA'), parentId: null, sprite: 'e-icon e-ssdrop-sortztoa' },
                { id: 'Ribbon_Filter', text: this.XLObj._getLocStr('Filter'), parentId: null, sprite: 'e-icon e-ssdrop-filter' },
                { id: 'Ribbon_ClearFilter', text: this.XLObj._getLocStr('ClearFilter'), parentId: null, sprite: 'e-icon e-ssdrop-clearfilter' }
        ];
        this._findMenuData = [
                { id: "Find", text: obj._getLocStr("Find") + "...", parentId: null, sprite: "e-icon e-ss-find" },
                { id: "Replace", text: obj._getLocStr("Replace") + "...", parentId: null, sprite: "e-icon e-ss-replace" },
                { id: "GoTo", text: obj._getLocStr("GoTo") + "...", parentId: null, sprite: "e-icon e-ss-goto" },
                { id: "GoToSpecial", text: obj._getLocStr("GoTo") + " " + obj._getLocStr("Special") + "...", parentId: null },
                { id: "Formulas", text: obj._getLocStr("Formulas"), parentId: null },
                { id: "Comments", text: obj._getLocStr("Comments"), parentId: null },
                { id: "CFormat", text: obj._getLocStr("ConditionalFormat"), parentId: null },
                { id: "Constants", text: obj._getLocStr("Constants"), parentId: null },
                { id: "DataValidation", text: obj._getLocStr("DataValidation"), parentId: null }
        ];
		this._calcOptData = [
            { id: this.XLObj._id + "_CalcAuto", text: obj._getLocStr("Automatic"), parentId: null, sprite: "e-icon e-ss-calcauto" },
            { id: this.XLObj._id + "_CalcManual", text: obj._getLocStr("Manual"), parentId: null, sprite: "e-icon" }
        ];
        this._valMenuData = [
                { id: "Validation", text: obj._getLocStr("DataValidation") + "...", parentId: null, sprite: "e-icon e-ss-validation" },
                { id: "HighlightVal", text: obj._getLocStr("HighlightVal"), parentId: null, sprite: "e-icon e-ss-hlval" },
                { id: "ClearHLVal", text: obj._getLocStr("ClearFormats"), parentId: null, sprite: "e-icon e-ss-clearval" },
                { id: "ClearVal", text: obj._getLocStr("ClearVal"), parentId: null, sprite: "e-icon e-ss-clearval" }
        ];
        this._pageSizes = [
                { id: "A4", text: obj._getLocStr("A4"), parentId: null, sprite: "e-icon e-ss-A4size" },
                { id: "A3", text: obj._getLocStr("A3"), parentId: null, sprite: "e-icon e-ss-A3size" },
                { id: "Letter", text: obj._getLocStr("Letter"), parentId: null, sprite: "e-icon e-ss-lettersize" }
        ];
        this._viewMenuData = [
                { id: "freezePanes", text: obj._getLocStr("FreezePanes"), parentId: null, sprite: "e-icon e-ss-frzpane" },
                { id: "FreezeTopRow", text: obj._getLocStr("FreezeTopRow"), parentId: null, sprite: "e-icon e-ss-frzrow" },
                { id: "FreezeFirstColumn", text: obj._getLocStr("FreezeFirstColumn"), parentId: null, sprite: "e-icon e-ss-frzcln" }
        ];
        this._insertMenuData = [
                { id: 'InsertCells', text: obj._getLocStr('InsCells') + "...", parentId: null, sprite: 'e-icon e-ssr-inscell' },
                { id: 'InsertSheetRows', text: obj._getLocStr('InsRows'), parentId: null, sprite: 'e-icon e-ssr-insrow' },
                { id: 'InsertSheetColumns', text: obj._getLocStr('InsCols'), parentId: null, sprite: 'e-icon e-ssr-inscol' },
                { id: 'InsertSheet', text: obj._getLocStr('InsSheet'), parentId: null, sprite: 'e-icon e-ssr-inssheet' }
        ];
        this._resetPicture = [
                { id: "resetpicture", text: obj._getLocStr("ResetPicture"), parentId: null, sprite: "e-icon e-ss-resetpicture" },
                { id: "resetsize", text: obj._getLocStr("ResetSize"), parentId: null, sprite: "e-icon e-ss-resetpicture" }
        ];
        var borderstyle = obj._getLocStr("BorderStyles").split("/");
        this._borderMenuData = [
              { id: "bottom", text: obj._getLocStr("BottomBorder"), parentId: null, sprite: "e-icon e-ss-bottom" },
              { id: "top", text: obj._getLocStr("TopBorder"), parentId: null, sprite: "e-icon e-ss-top" },
              { id: "left", text: obj._getLocStr("LeftBorder"), parentId: null, sprite: "e-icon e-ss-left" },
              { id: "right", text: obj._getLocStr("RightBorder"), parentId: null, sprite: "e-icon e-ss-right" },
              { id: "noborder", text: obj._getLocStr("NoBorder"), parentId: null, sprite: "e-icon e-ss-noborder" },
              { id: "allborder", text: obj._getLocStr("AllBorder"), parentId: null, sprite: "e-icon e-ss-allborder" },
              { id: "outside", text: obj._getLocStr("OutsideBorder"), parentId: null, sprite: "e-icon e-ss-outside" },
              { id: "thickbox", text: obj._getLocStr("ThickBoxBorder"), parentId: null, sprite: "e-icon e-ss-thickbox" },
              { id: "thickbottom", text: obj._getLocStr("ThickBottomBorder"), parentId: null, sprite: "e-icon e-ss-thickbottom" },
              { id: "topandbottom", text: obj._getLocStr("TopandBottomBorder"), parentId: null, sprite: "e-icon e-ss-topandbottom" },
              { id: "topandthickbottom", text: obj._getLocStr("TopandThickBottomBorder"), parentId: null, sprite: "e-icon e-ss-topandthickbottom" },
              { id: "drawborder", text: obj._getLocStr("DrawBorder"), parentId: null, sprite: "e-icon e-ss-drawborder" },
              { id: "drawbordergrid", text: obj._getLocStr("DrawBorderGrid"), parentId: null, sprite: "e-icon e-ss-drawbordergrid" },
              { id: obj._id + "_bordercolor", text: obj._getLocStr("BorderColor"), parentId: null },
              { id: obj._id + "_Ribbon_borderstyle", text: obj._getLocStr("BorderStyle"), parentId: null },
              { id: obj._id + "_Ribbon_bordercolor", text: "", parentId: obj._id + "_bordercolor" },
              { id: "solid", text: borderstyle[0], parentId: obj._id + "_Ribbon_borderstyle" },
              { id: "dashed", text: borderstyle[1], parentId: obj._id + "_Ribbon_borderstyle" },
              { id: "dotted", text: borderstyle[2], parentId: obj._id + "_Ribbon_borderstyle" }
        ];
        this._cFormatMenuData = [
             { id: obj._id + "_HLCellRules", text: "Highlight Cell Rules", parentId: null, sprite: "e-icon e-ss-hlcellrules" },
             { id: "greaterthan", text: obj._getLocStr("GreaterThan") + "...", parentId: obj._id + "_HLCellRules", sprite: "e-icon e-ss-greaterthan" },
             { id: "lessthan", text: obj._getLocStr("LessThan") + "...", parentId: obj._id + "_HLCellRules", sprite: "e-icon e-ss-lessthan" },
             { id: "between", text: obj._getLocStr("Between") + "...", parentId: obj._id + "_HLCellRules", sprite: "e-icon e-ss-between" },
             { id: "equalto", text: obj._getLocStr("EqualTo") + "...", parentId: obj._id + "_HLCellRules", sprite: "e-icon e-ss-equalto" },
             { id: "textcontains", text: obj._getLocStr("TextthatContains") + "...", parentId: obj._id + "_HLCellRules", sprite: "e-icon e-ss-textcontains" },
             { id: "dateoccur", text: obj._getLocStr("DateOccurring") + "...", parentId: obj._id + "_HLCellRules", sprite: "e-icon e-ss-dateoccur" },
			 { id: obj._id + "_CreateRule", text: obj._getLocStr('CreateRule'), parentId: null, sprite: "e-icon e-ss-createrule" },
             { id: obj._id + "_ClearRules", text: obj._getLocStr('ClearRules'), parentId: null, sprite: "e-icon e-ss-clearrules" },
             { id: "clearselected", text: obj._getLocStr('ClearRulesfromSelected'), parentId: obj._id + "_ClearRules" },
             { id: "clearall", text: obj._getLocStr('ClearRulesfromEntireSheets'), parentId: obj._id + "_ClearRules" }
        ];
        this._textAlign = [{ value: "1", text: "Left" }, { value: "2", text: "Center" }, { value: "3", text: "Right" }];
        this._verticalAlign = [{ value: "1", text: "Top" }, { value: "2", text: "Middle" }, { value: "3", text: "Bottom" }];
        this._actions = [{ value: "Greater", text: "greater than", }, { value: "GreaterOrEqual", text: "greater or equal to" }, { value: "Less", text: "less than" }, { value: "LessOrEqual", text: "less than or equal to" }, { value: "Equal", text: "equal to" }, { value: "NotEqual", text: "not equal to" }, { value: "Between", text: "between" }, { value: "NotBetween", text: "not between" }];
        this._types = [{ value: "number", text: "Number", }, { value: "decimal", text: "Decimal" }, { value: "date", text: "Date" }, { value: "time", text: "Time" }, { value: "text", text: "TextLength" }, { value: "list", text: "List" }];
        this._cFormatData = { greaterthan: ["GTTitle", "GTContent"], lessthan: ["LTTitle", "LTContent"], between: ["BWTitle", "BWContent"], equalto: ["EQTitle", "EQContent"], textcontains: ["ContainsTitle", "ContainsContent"], dateoccur: ["DateTitle", "DateContent"] };
        this._styles = [{ value: "redft", text: "Light Red Fill with Dark Red Text", }, { value: "yellowft", text: "Yellow Fill with Dark Yellow Text" }, { value: "greenft", text: "Green Fill with Dark Green Text" }, { value: "redf", text: "Red Fill" }, { value: "redt", text: "Red Text" }];
        this._currentCFormat = "";
        this._addrList = [];
        this._within = [{ value: "sheet", text: obj._getLocStr("Sheet") }, { value: "workbook", text: obj._getLocStr("Workbook") }];
        this._sType = [{ value: "columns", text: obj._getLocStr("Columns") }, { value: "rows", text: obj._getLocStr("Rows") }];
        this._vType = [{ value: "value", text: obj._getLocStr("Value"), }, { value: "formula", text: obj._getLocStr("Formula") }, { value: "comment", text: obj._getLocStr("Comments") }];
        this._direction = [{ value: "down", text: obj._getLocStr("Down") }, { value: "up", text: obj._getLocStr("Up") }];
        this._gotoRBtnSet1 = ["Comments", "Blanks", "LastCell", "Formulas", "Constants"];
        this._gotoRBtnSet2 = ["RowDiff", "ColDiff", "CFormat", "DataValidation"];
        this._gotoChkBox = ["GotoNumbers", "GotoText", "GotoLogicals", "GotoError"];
        this._numberFormat = [{ value: "1", text: "General" }, { value: "2", text: "Number" }, { value: "3", text: "Currency" }, { value: "4", text: "Accounting" }, { value: "5", text: "Percentage" }, { value: "6", text: "Text" }, { value: "7", text: "Shortdate" }, { value: "8", text: "Longdate" }, { value: "9", text: "Time" }, { value: "10", text: "Scientific" }, { value: "11", text: "Fraction" }, { value: "12", text: "Custom" }];
        this._deleteMenuData = [
                { id: "DeleteCells", text: obj._getLocStr("DelCells") + "...", parentId: null, sprite: "e-icon e-ssr-delcell" },
                { id: "DeleteSheetRows", text: obj._getLocStr("DelRows"), parentId: null, sprite: "e-icon e-ssr-delrow" },
                { id: "DeleteSheetColumns", text: obj._getLocStr("DelCols"), parentId: null, sprite: "e-icon e-ssr-delcol" },
                { id: "DeleteSheet", text: obj._getLocStr("DelSheet"), parentId: null, sprite: "e-icon e-ssr-delsheet" }
        ];
        this._clearMenuData = [
                { id: "Clear_All", text: obj._getLocStr("ClearAll"), parentId: null, sprite: "e-icon e-ss-clear" },
                { id: "Clear_Formats", text: obj._getLocStr("ClearFormats"), parentId: null, sprite: "e-icon e-ss-clearformat" },
                { id: "Clear_Contents", text: obj._getLocStr("ClearContents"), parentId: null },
                { id: "Clear_Comments", text: obj._getLocStr("ClearComments"), parentId: null },
                { id: "Clear_Hyperlinks", text: obj._getLocStr("ClearHyperLinks"), parentId: null }
        ];
        this._autosumMenuData = [
                { id: "Sum", text: obj._getLocStr("Sum"), parentId: null, sprite: "e-icon e-ss-autosum" },
                { id: "Average", text: obj._getLocStr("Average"), parentId: null },
                { id: "Count", text: obj._getLocStr("CountNumber"), parentId: null },
                { id: "Max", text: obj._getLocStr("Max"), parentId: null },
                { id: "Min", text: obj._getLocStr("Min"), parentId: null }
        ];
        this._chartThemes = [{ value: "flatlight", text: "Flat Light" }, { value: "flatdark", text: "Flat Dark" }, { value: "azure", text: "Azure" }, { value: "azuredark", text: "Azure Dark" }, { value: "lime", text: "Lime" }, { value: "limedark", text: "Lime Dark" }, { value: "saffron", text: "Saffron" }, { value: "saffrondark", text: "Saffron Dark" }];
        this._isCustomCellStyleReset = false;
        this.allButtonIds =  ["Home_Clipboard_Paste", "Home_Font_IncreaseFontSize", "Home_Font_DecreaseFontSize","Home_Alignment_DecreaseIndent", "Home_Alignment_IncreaseIndent", "Home_Number_IncreaseDecimal", "Home_Number_DecreaseDecimal", "Home_Actions_Undo", "Home_Actions_Redo", "Home_Number_Accounting", "Home_Number_CommaStyle", "Home_Number_Percentage", "Home_Clipboard_Cut", "Home_Clipboard_Copy","Insert_Tables_PivotTable", "Insert_Tables_Table", "Insert_Links_Hyperlink", "Insert_Illustrations_Pictures","Data_SortFilter_SortAtoZ", "Data_SortFilter_SortZtoA", 
	                           "Data_SortFilter_Filter", "Data_SortFilter_ClearFilter", "Data_DataTools_DataValidation", "PageLayout_PageLayout_PageSize", "PageLayout_Print_Print", "PageLayout_Print_PrintSelected", "Review_Comments_NewComment", "Review_Comments_DeleteComment", "Review_Comments_PreviousComment", "Review_Comments_NextComment", "Review_Comments_ShowHideComment", "Others_Cells_InsertCell", "Others_Cells_DeleteCell", "Others_Formulas_NameManager", "Others_Formulas_DefineName", "Others_CalCulation_CalculateNow", "Others_CalCulation_CalculateSheet","Design_Tools_ResizeTable", "Design_Tools_ConvertToRange", "ChartDesign_Data_SwitchRowColumn", "ChartDesign_Data_SelectData", "ChartDesign_Type_ChangeChartType", "Format_Adjust_ChangePicture"]; 
        this.allSplitButtonIds = ["Home_Clipboard_PasteOptions", "Home_Font_Border", "Home_Styles_ConditionalFormatting", "Home_Styles_FormatAsTable", "Home_Styles_CellStyles", "Others_Editing_FindSelect", "Home_Editing_Clear", "Home_Alignment_Merge", "Home_Editing_SortFilter", "Home_Editing_AutoSum", "Insert_Charts_ColumnChart", "Insert_Charts_BarChart", "Insert_Charts_StockChart", "Insert_Charts_LineChart", "Insert_Charts_AreaChart", "Insert_Charts_PieChart", "Insert_Charts_ScatterChart", "Data_DataTools_DataValidationOptions", "PageLayout_PageLayout_PageSizeOptions", "Others_Cells_InsertCellOptions", "Others_Cells_DeleteCellOptions", "Others_Editing_FindSelect", "Others_Window_FreezePanes", "Others_CalCulation_CalculationOptions", "ChartDesign_ChartLayouts_AddChartElement","Format_Adjust_ResetPicture", "Format_Border_PictureBorder"]
        this.allToggleButtonIds = ["Home_Font_Bold", "Home_Font_Italic", "Home_Font_Underline", "Home_Font_StrikeThrough", "Home_Alignment_AlignLeft", "Home_Alignment_AlignRight", "Home_Alignment_AlignCenter", "Home_Alignment_TopAlign", "Home_Alignment_MiddleAlign", "Home_Alignment_BottomAlign", "Home_Alignment_WrapText", "Home_Clipboard_FormatPainter", "Review_Comments_ShowAllComments", "Review_Changes_ProtectSheet", "Review_Changes_ProtectWorkbook", "Review_Changes_LockCell"]	 
        this.allDropDownIds = ["ChartDesign_ChartThemes_ChartThemes", "Home_Number_NumberFormat", "Home_Font_FontSize", "Home_Font_FontFamily"];
        this.colorPickerIds = ["Home_Font_FillColor", "Home_Font_FontColor"];
        this.checkBoxIds = ["PageLayout_Show_Headings", "PageLayout_Show_Gridlines","Design_TableStyleOptions_FirstColumn", "Design_TableStyleOptions_LastColumn", "Design_TableStyleOptions_TotalRow", "Design_TableStyleOptions_FilterColumn"];
        this.InputIds = ["Ribbon_Design_Properties_TableName"];
        this._fileMenuData = [
                { id: "File", text: obj._getLocStr("File"), parentId: null },
                { id: "New", text: obj._getLocStr("New"), parentId: "File", sprite: "e-icon e-ss-newsheet" },
                { id: "Open", text: obj._getLocStr("Open") + "...", parentId: "File", sprite: "e-icon e-ss-open" },
                { id: "Save", text: obj._getLocStr("SaveAs"), parentId: "File", sprite: "e-icon e-ss-saveas" },
                { id: "Print", text: obj._getLocStr("Print"), parentId: "File", sprite: "e-icon e-ssm-print" },
                { id: "ExportXL", text: obj._getLocStr("ExportXL"), parentId: "Save", sprite: "e-icon e-ssm-exportxl" },
                { id: "ExportCsv", text: obj._getLocStr("ExportCsv"), parentId: "Save", sprite: "e-icon e-ssm-exportcsv" },
                { id: "ExportPdf", text: obj._getLocStr("ExportPdf"), parentId: "Save", sprite: "e-icon e-ssm-exportpdf" },
                { id: "PrintSheet", text: obj._getLocStr("PrintSheet"), parentId: "Print", sprite: "e-icon e-ssm-print" },
                { id: "PrintSelected", text: obj._getLocStr("PrintSelected"), parentId: "Print", sprite: "e-icon e-ssm-printselected" }
        ];
        this._isAppTabCreate = false,
        this._isHomeTabCreate = false,
        this._isInsertTabCreate = false,
        this._isDataTabCreate = false,
        this._isPageLayoutTabCreate = false,
        this._isReviewTabCreate = false,
        this._isOthersTabCreate = false,
        this._isDesignTabCreate = false,
        this._isFormatTabCreate = false,
        this._isChartTabCreate = false,
        this._analyzeTabCreate = false,

        this._isHomeTabTrgt = false,
        this._isInsertTabTrgt = false,
        this._isDataTabTrgt = false,
        this._isPageLayoutTrgtTab = false,
        this._isReviewTabTrgt = false,
        this._isOthersTabTrgt = false,
        this._isDesignTabTrgt = false,
        this._isFormatTabTrgt = false,
        this._isChartTabTrgt = false,
        this._analyzeTabTrgt = false
    };

    ej.spreadsheetFeatures.ribbon.prototype = {

        _renderChartTypeDialog: function () {
            var $dlg, $tab, $okBtn, $canBtn, $btndiv, $ul, borderHt, $li, $aTag, $divctnr, $btnctnr, xlObj = this.XLObj, dlgId = xlObj._id + "_charttypedlg";
            $dlg = ej.buildTag("div#" + dlgId + ".e-chartdialog", "", {}, {"overflow" : "hidden"});
            $tab = ej.buildTag("div#" + dlgId + "_allcharttab.e-chtdlgtab");
            $divctnr = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
            $ul = ej.buildTag("ul .e-ul", "", "");
            $aTag = ej.buildTag("a", xlObj._getLocStr("AllCharts"), {}, { href: "#" + xlObj._id + "_allchart" });
            $li = ej.buildTag("li", $aTag);
            $dlg.append($divctnr.append($tab.append($ul.append($li))));
            $btndiv = ej.buildTag("div#" + dlgId + "_btndiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + dlgId + "_okbtn", "", {}, { type: "button" });
            $canBtn = ej.buildTag("input#" + dlgId + "_cantn", "", {}, { type: "button" });
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._chartTypeOk, this), enabled: true,  cssClass: "e-ss-okbtn" });
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), click: ej.proxy(this._chartTypeCancel, this), showRoundedCorner: true, width: 60 });
            $btndiv.append($btnctnr.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            xlObj.element.append($dlg);
            $tab.ejTab({ cssClass: "e-ss-dlgtab", width: "100%", height: "auto" });
            this._renderAllChartTab();
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("ChartType"), width: "auto", height: "auto", cssClass: "e-ss-dialog e-charttype-dlg e-ss-mattab e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this) });
            return $dlg;
        },

        _renderAllChartTab: function () {
            var i, j, len, chartCnt, chartLen, splt, $contentdiv, chart, colChart, chartTitle, $leftdiv, $listUl, chartColl = [],
                content = "", $li = "", xlObj = this.XLObj, xlId = xlObj._id, charttabId = xlId + "_chartdlg_allcharttab",
                chartName = ["Column-6", "Bar-6", "Radar-2", "Line-2", "Area-3", "Pie-3", "Scatter-1"], $table, $tr, $td, $div;
            $leftdiv = ej.buildTag("div#" + charttabId + "_content.e-ss-leftdiv", "");
            $contentdiv = ej.buildTag("div#" + charttabId + "_content.e-chtdlgcontent e-ss-rightdiv", "", { overflow: "auto", float: "right" });
            $listUl = ej.buildTag("ul #" + charttabId + "_list .e-ul");
            for (var chartCnt = 0, chartLen = chartName.length; chartCnt < chartLen; chartCnt++) {
                chart = chartName[chartCnt].split("-")[0];
                $li += "<li><span class='e-icon e-ss-dlg" + chart.toLowerCase() + "chart'></span>" + chart + "</li>";
                chartColl.push(chart);
            }
            $listUl.append($($li));
			$div = ej.buildTag("div#" + xlId + "_allchart_table.e-ss-maindiv", "", { cellspacing: "0", cellpadding: "0", display: "inline-flex", width: "100%"});
			$("#" + xlId + "_allchart").append($div);
			$div.append($leftdiv.append($listUl));
			this._createChartList(chartColl);
			$div.append($contentdiv);        
            for (j = 0, chartLen = chartName.length; j < chartLen; j++) {
                splt = chartName[j].split("-");
                chartTitle = xlObj._getLocStr("Title" + splt[0] + "Chart").split("/");
                chart = splt[0].toLowerCase();
                colChart = ej.buildTag("div#" + xlId + "_" + chart + "chart");
                for (i = 1, len = parseInt(splt[1]) ; i <= len; i++)
                    content += "<div class='e-chartimg e-dlg" + chart + "chart" + i + "' title='" + chartTitle[i - 1] + "'></div>";
                $contentdiv.append(colChart.append(content));
                $("#" + xlId + "_" + chart + "chart").find(".e-dlg" + chart + "chart1").addClass("e-chartselect");
                colChart.hide();
                content = "";
            }
			xlObj._on($("#" + xlId + "_allchart").find(".e-chartimg"), "click", xlObj._allChartType);
            $("#" + xlId + "_columnchart").show();
        },
       
        _createChartList: function (chartName) {
            var xlObj = this.XLObj, chart, charttabId = xlObj._id + "_chartdlg_allcharttab", $td, tabHt = $("#" + xlObj._id + "_allchart").height(), $ddlInput, $listUl = $("#" + charttabId + "_list"), $drpdiv = ej.buildTag("div.e-ss-drpdiv");
            $ddlInput = ej.buildTag("input#" + charttabId + "_input");
            $("#" + xlObj._id + "_allchart").prepend($drpdiv.append($ddlInput));
            $ddlInput.ejDropDownList({ dataSource: chartName, width: "100%", fields: { id: "value", text: "text", value: "text" }, select: $.proxy(this._onChartChange, this), selectedItemIndex: 0 });
            $listUl.ejListBox({
                selectedItemIndex: 0, width: "120", height: "250",
                fields: { text: "text", value: "value" }, select: $.proxy(this._onChartChange, this),
                allowMultiSelection: false
            });
        },

        _onChartChange: function (args) {
            var i, xlObj = this.XLObj, chart = args.value ? args.value.toLowerCase() : args.text.toLowerCase(), allChart = ["column", "bar", "radar", "line", "area", "pie", "scatter"];
            for (i = 0; i < allChart.length; i++)
                $("#" + xlObj._id + "_" + allChart[i] + "chart").hide();
            $("#" + xlObj._id + "_" + chart + "chart").show();
            $("#" + xlObj._id + "_allchart").find(".e-chartimg").removeClass("e-chartselect");
            $("#" + xlObj._id + "_" + chart + "chart").find(".e-dlg" + chart + "chart1").addClass("e-chartselect");
        },

        _initValDialog: function () {
            var $dlg, $tab, $okBtn, $canBtn, $btndiv, $ul, $li, $aTag, xlObj = this.XLObj, $divctnr, $btnctnr;
            $dlg = ej.buildTag("div#" + xlObj._id + "_ValDialog");
            $tab = ej.buildTag("div#" + xlObj._id + "_ValDialog_valDlgTab");
            $divctnr = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
            //create tab Content
            $ul = ej.buildTag("ul .e-ul");
            $aTag = ej.buildTag("a", "Settings", {}, { href: "#" + xlObj._id + "_Validation" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $tab.append($ul);
            $dlg.append($divctnr.append($tab));
            $btndiv = ej.buildTag("div#" + xlObj._id + "btnDiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + xlObj._id + "Dialog_OkBtn", "", {}, { type: "button" });
            $canBtn = ej.buildTag("input#" + xlObj._id + "Dialog_CancelBtn", "", {}, { type: "button" });
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._valDlgBtnClick, this, "ok"), enabled: true, cssClass: "e-ss-okbtn" });
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), click: ej.proxy(this._valDlgBtnClick, this, "cancel"), showRoundedCorner: true, width: 60 });
            $btndiv.append($btnctnr.append($okBtn, $canBtn));
            xlObj.element.append($dlg.append($btndiv));
            $tab.ejTab({ width: "100%", height: "auto", cssClass: "e-ss-dlgtab" });
            this._renderValDialog();
			$dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("DataValidation"), width: "auto", height: "auto", cssClass: "e-ss-dialog e-ss-valdlg e-ss-mattab e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this) });
			this._dialogValidate("_ValDialog");
        },

        _initCFDialog: function () {
            var xlObj = this.XLObj, $dlg, $div, $okBtn, $canBtn, $btndiv, $btnctnr;
            $dlg = ej.buildTag("div#" + xlObj._id + "_CFDialog");
            xlObj.element.append($dlg);
            $div = ej.buildTag("div#" + xlObj._id + "_CondFormat.e-dlgctndiv");
            $dlg.append($div);
            $btndiv = ej.buildTag("div#" + xlObj._id + "cfBtnDiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + xlObj._id + "cfDialog_OkBtn", "", {}, { type: "button" });
            $canBtn = ej.buildTag("input#" + xlObj._id + "cfDialog_CancelBtn", "", {}, { type: "button" });
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: "25%", click: ej.proxy(this._dlgCFOk, this), enabled: true, cssClass: "e-ss-okbtn" });
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), click: ej.proxy(this._dlgCFCancel, this), showRoundedCorner: true, width: "25%" });
            $btndiv.append($btnctnr.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("ConditionalFormat"), width: "auto", cssClass: "e-ss-dialog e-ss-cfdlg e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this) });
            return $dlg;
        },

        _initHLDialog: function () {
            var xlObj = this.XLObj, $dlg, $tab, $ul, $li, $aTag, $btndiv, $okBtn, $canBtn, $divctnr, $btnctnr;
            $dlg = ej.buildTag("div#" + xlObj._id + "_HLDialog");
            $tab = ej.buildTag("div#" + xlObj._id + "_HLDialogTab");
            $divctnr = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
            //create tab Content
            $ul = ej.buildTag("ul .e-ul");
            $aTag = ej.buildTag("a", xlObj._getLocStr("WebPage"), {}, { href: "#" + xlObj._id + "_Web" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $aTag = ej.buildTag("a", xlObj._getLocStr("WorkSheet"), {}, { href: "#" + xlObj._id + "_Doc" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $tab.append($ul);
            $dlg.append($divctnr.append($tab));
            $btndiv = ej.buildTag("div#" + xlObj._id + "hlBtnDiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + xlObj._id + "hlDialog_OkBtn", "", {}, { type: "button" });
            $canBtn = ej.buildTag("input#" + xlObj._id + "hlDialog_CancelBtn", "", {}, { type: "button" });
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._dlgHLOk, this), enabled: true, cssClass: "e-ss-okbtn" });
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), click: ej.proxy(this._dlgHLCancel, this), showRoundedCorner: true, width: 60 });
            $btndiv.append($btnctnr.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            $dlg.ejDialog({
                enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("InsertHyperLink"), width: "auto", cssClass: "e-ss-dialog e-ss-hyperlinkdlg e-ss-mattab e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this), open: ej.proxy(function (e) {
                    var webAddr = $("#" + xlObj._id + "_Ribbon_webAddress"), cellAddr = $("#" + xlObj._id + "_Ribbon_cellAddress");
                    webAddr.focus().setInputPos(webAddr.val().length);
                    cellAddr.focus().setInputPos(cellAddr.val().length);
                })
            });
            $tab.ejTab({ width: "100%", itemActive: ej.proxy(this._hlTabChange, this), cssClass: "e-ss-dlgtab" });
            this._renderHLDialog();
        },

        _initFRDialog: function () {
            var xlObj = this.XLObj, $dlg, $tab, $findNextBtn, $findPrevBtn, $close, $btndiv, $btnctnr, $ul, $li, $ctnr, $aTag, $replaceBtn, $replaceAllBtn;
            $dlg = ej.buildTag("div#" + xlObj._id + "_FRDialog");
            $tab = ej.buildTag("div#" + xlObj._id + "_FRDialog_FPDlgTab");
            $ctnr = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
            //create tab Content
            $ul = ej.buildTag("ul .e-ul");
            $aTag = ej.buildTag("a", xlObj._getLocStr("Find"), {}, { href: "#" + xlObj._id + "_Find" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $aTag = ej.buildTag("a", xlObj._getLocStr("Replace"), {}, { href: "#" + xlObj._id + "_Replace" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $aTag = ej.buildTag("a", xlObj._getLocStr("Settings"), {}, { href: "#" + xlObj._id + "_Settings" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $tab.append($ul);
            $dlg.append($ctnr.append($tab));
            $btndiv = ej.buildTag("div#" + xlObj._id + "btnFRDiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $replaceBtn = ej.buildTag("input#" + xlObj._id + "FR_ReplaceBtn", "", { "margin-left": 0 }, { type: "button" });
            $replaceAllBtn = ej.buildTag("input#" + xlObj._id + "FR_ReplaceAllBtn", "", {}, { type: "button" });
            $findNextBtn = ej.buildTag("input#" + xlObj._id + "FR_NextBtn", "", {}, { type: "button" });
            $findPrevBtn = ej.buildTag("input#" + xlObj._id + "FR_PrevBtn", "", {}, { type: "button" });
            $close = ej.buildTag("input#" + xlObj._id + "FR_CloseBtn", "", {}, { type: "button" });
            $replaceBtn.ejButton({ text: xlObj._getLocStr("Replace"), showRoundedCorner: true, width: 55, click: ej.proxy(this._btnFROnClick, this, "FR_ReplaceBtn"), enabled: true }).css("visibility", "hidden");
            $replaceAllBtn.ejButton({ text: xlObj._getLocStr("ReplaceAll"), showRoundedCorner: true, click: ej.proxy(this._btnFROnClick, this, "FR_ReplaceAllBtn"), enabled: true }).css("visibility", "hidden");
            $findNextBtn.ejButton({ text: xlObj._getLocStr("FindNext"), showRoundedCorner: true, width: 69, click: ej.proxy(this._btnFROnClick, this, "FR_NextBtn"), enabled: true });
            $findPrevBtn.ejButton({ text: xlObj._getLocStr("FindPrev"), showRoundedCorner: true, width: 69, click: ej.proxy(this._btnFROnClick, this, "FR_PrevBtn"), enabled: true });
            $close.ejButton({ text: xlObj._getLocStr("Close"), click: ej.proxy(this._btnFROnClick, this, "FR_CloseBtn"), showRoundedCorner: true, width: 47 });
            $btndiv.append($btnctnr.append($replaceBtn, $replaceAllBtn, $findNextBtn, $findPrevBtn, $close));
            $dlg.append($btndiv);
            $dlg.ejDialog({
                showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("FindnReplace"), width: "auto", height: "auto", cssClass: "e-ss-dialog e-ss-mattab e-ss-frdlg e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this), open: ej.proxy(function (e) {
                    if (xlObj._phoneMode) {
                        $("#" + xlObj._id + "FR_ReplaceBtn").hide();
                        $("#" + xlObj._id + "FR_ReplaceAllBtn").hide();
                    }
                    else {
                        $("#" + xlObj._id + "FR_ReplaceBtn").show();
                        $("#" + xlObj._id + "FR_ReplaceAllBtn").show();
                    }
					var findTxt = $("#" + xlObj._id + "_Ribbon_textFind");
                    findTxt.focus().setInputPos(findTxt.val().length);
                })
            });
            $tab.ejTab({ width: "100%", itemActive: ej.proxy(this._findTabChange, this), cssClass: "e-ss-dlgtab" });
        },

        _initGoToDialog: function () {
            var xlObj = this.XLObj, $dlg, $tab, $btndiv, $ul, $li, $aTag, $okBtn, $canBtn, $ctnr, $btnctnr;
            $dlg = ej.buildTag("div#" + xlObj._id + "_GoDialog");
            $tab = ej.buildTag("div#" + xlObj._id + "_GoToDlgTab");
            $ctnr = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
            //create tab Content
            $ul = ej.buildTag("ul .e-ul");
            $aTag = ej.buildTag("a", xlObj._getLocStr("GoTo"), {}, { href: "#" + xlObj._id + "_GoTo" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $aTag = ej.buildTag("a", xlObj._getLocStr("GoTo") + " " + xlObj._getLocStr("Special"), {}, { href: "#" + xlObj._id + "_GoToSp" });
            $li = ej.buildTag("li", $aTag);
            $ul.append($li);
            $tab.append($ul);
            $dlg.append($ctnr.append($tab));
            $btndiv = ej.buildTag("div#" + xlObj._id + "btnDiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $dlg.append($btndiv.append($btnctnr));
            $okBtn = ej.buildTag("input#" + xlObj._id + "Dialog_GoOkBtn", "", {}, { type: "button" });
            $canBtn = ej.buildTag("input#" + xlObj._id + "Dialog_GoCancelBtn", "", {}, { type: "button" });
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: "23%", click: ej.proxy(this._gotoBtnClick, this, "ok") , cssClass: "e-ss-okbtn"});
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), click: ej.proxy(this._gotoBtnClick, this, "cancel"), showRoundedCorner: true, width: 60});
            $btnctnr.append($okBtn, $canBtn);
            xlObj.element.append($dlg);
        },

        _initPvtDialog: function () {
            var xlObj = this.XLObj, $dlg, $okBtn, $canBtn, $btndiv, $btnctnr;
            $dlg = ej.buildTag("div#" + xlObj._id + "_PvtDialog");
            xlObj.element.append($dlg);
            $dlg.append(ej.buildTag("div#" + xlObj._id + "_Pivot.e-dlgctndiv"));
            $btndiv = ej.buildTag("div#" + xlObj._id + "pvtBtnDiv.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + xlObj._id + "PvtDialog_OkBtn");
            $canBtn = ej.buildTag("input#" + xlObj._id + "PvtDialog_CancelBtn");
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: "25%", click: ej.proxy(this._dlgPvtOk, this), enabled: true, cssClass: "e-ss-okbtn" });
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), click: ej.proxy(this._dlgPvtCancel, this), showRoundedCorner: true, width: "25%" });
            $btndiv.append($btnctnr.append($okBtn, $canBtn));
            $dlg.append($btndiv);
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("CreatePivotTable"), width: "auto", cssClass: "e-ss-dialog e-" + xlObj._id + "-dlg e-ss-pvtdlg", close: ej.proxy(this._dialogClose, this) });
        },

        _dialogClose: function () {
            this.XLObj.setSheetFocus();
        },

        _beforeDlgClose: function (args) {
            var gridOlay = $("#" + this.XLObj._id + "_nmgrid_dialogEdit_overLay");
            gridOlay.length && (args.cancel = true);
        },

        _homeTabObj: function () {
            var createdObj, xlObj = this.XLObj, imgtop = "imagetop", homeTab = { id: "home", text: xlObj._getLocStr("HOME"), groups: [] }, xlId = xlObj._id, xlMod = xlObj.model;
            createdObj = {
                text: "Clipboard",
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateBtn("Home_Clipboard_Paste", "paste", "textandimage", "e-icon e-ssr-paste", 45, this._mediumBtnHeight, "PasteTitle", "PasteContent", false, imgtop),
                        this._generateSplitBtn("Home_Clipboard_PasteOptions", "Paste", "textandimage", xlId + "_Ribbon_Paste", { dataSource: this._pasteMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "", false, 45, this._mediumBtnHeight, "bottom", "", "dropdown", "e-ssr-pastesbtn", "PasteTitle", "PasteSplitContent")
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Home_Clipboard_Cut", "Cut", "textandimage", "e-icon e-ssr-cut", 58, this._smallBtnHeight, "CutTitle", "CutContent"),
                        this._generateBtn("Home_Clipboard_Copy", "Copy", "textandimage", "e-icon e-ssr-copy", 67, this._smallBtnHeight, "CopyTitle", "CopyContent"),
                        this._generateToggleBtn("Home_Clipboard_FormatPainter", "FormatPainter", "textandimage", "e-icon e-ss-formatpainter", "FPTitle", 110, this._smallBtnHeight, "FPContent")
                    ],
                }]
            };
            homeTab.groups.push(createdObj);
            createdObj = {
                text: "Font",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
						 this._generateDD("Home_Font_FontFamily", "FontFamily", this._fontFamily, "7", 150, this._smallBtnHeight, "FontFamily", "FFContent"),
                        this._generateDD("Home_Font_FontSize", "FontSize", this._fontSize, "11pt", 65, this._smallBtnHeight, "FontSize", "FSContent"),
                        this._generateBtn("Home_Font_IncreaseFontSize", "IncreaseFontSize", "imageonly", "e-icon e-ss-increasefontsize", "", this._smallBtnHeight, "IncreaseFontSize", "IFSContent"),
                        this._generateBtn("Home_Font_DecreaseFontSize", "DecreaseFontSize", "imageonly", "e-icon e-ss-decreasefontsize", "", this._smallBtnHeight, "DecreaseFontSize", "DFSContent")
                    ],
                },
                {
                    groups: [
                        this._generateToggleBtn("Home_Font_Bold", "Bold", "imageonly", "e-icon e-ss-bold", "BoldTitle", "", this._smallBtnHeight, "BoldContent"),
                        this._generateToggleBtn("Home_Font_Italic", "Italic", "imageonly", "e-icon e-ss-italic", "ItalicTitle", "", this._smallBtnHeight, "ItalicContent"),
                        this._generateToggleBtn("Home_Font_Underline", "Underline", "imageonly", "e-icon e-ss-underline", "ULineTitle", "", this._smallBtnHeight, "ULineContent"),
                        this._generateToggleBtn("Home_Font_StrikeThrough", "Linethrough", "imageonly", "e-icon e-ss-linethrough", "LineTrTitle", 25, this._smallBtnHeight, "LineTrContent", true),
                        this._generateSplitBtn("Home_Font_Border", "Border", "imageonly", xlId + "_Ribbon_Border", { dataSource: this._borderMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ss-bottom", true, 37, this._smallBtnHeight, "", "", "", "e-borderbtn", "Border", "BorderContent"),
                        this._generateCustomControl(xlId + "_Ribbon_Home_Font_FillColor", "BackgroundColor", "BackgroundColor", "BGContent"),
                        this._generateCustomControl(xlId + "_Ribbon_Home_Font_FontColor", "FontColor", "Color", "ColorContent")
                    ],
                }]
            };
            homeTab.groups.push(createdObj);
            createdObj = {
                text: "Alignment",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateToggleBtn("Home_Alignment_TopAlign", "TopAlign", "imageonly", "e-icon e-ss-topalign", "TopAlign", "", "", "TopAlignContent"),
                        this._generateToggleBtn("Home_Alignment_MiddleAlign", "MiddleAlign", "imageonly", "e-icon e-ss-middlealign", "MiddleAlign", "", "", "MiddleAlignContent"),
                        this._generateToggleBtn("Home_Alignment_BottomAlign", "BottomAlign", "imageonly", "e-icon e-ss-bottomalign", "BottomAlign", "", "", "BottomAlignContent", true),
						this._generateToggleBtn("Home_Alignment_WrapText", "WrapText", "textandimage", "e-icon e-ss-wraptext", "WrapText", 85, 25, "WrapTextContent")
                    ],
                },
                {
                    groups: [
                        this._generateToggleBtn("Home_Alignment_AlignLeft", "AlignLeft", "imageonly", "e-icon e-ss-alignleft", "AlignLeft", "", "", "AlignLeftContent"),
                        this._generateToggleBtn("Home_Alignment_AlignCenter", "AlignCenter", "imageonly", "e-icon e-ss-aligncenter", "AlignCenter", "", "", "AlignCenterContent"),
                        this._generateToggleBtn("Home_Alignment_AlignRight", "AlignRight", "imageonly", "e-icon e-ss-alignright", "AlignRight", "", "", "AlignRightContent", true),
                        this._generateSplitBtn("Home_Alignment_Merge", "MergeAndCenter", "textandimage", xlId + "_Ribbon_Merge", { dataSource: this._mergeMenuData, id: 'id', parentId: 'parentId', text: 'text', spriteCssClass: 'sprite' }, "e-icon e-ssr-merge", false, 136, 25, "right", "", "", "e-spreadsheet e-mergebtn", "MergeAndCenter", "MergeAndCenterContent")
                    ],
                },
               {
                   groups: [
                      this._generateBtn("Home_Alignment_DecreaseIndent", "DecreaseIndent", "imageonly", "e-icon e-ss-decreaseindent", "", this._smallBtnHeight, "DecreaseIndent", "DecreaseIndentContent"),
                      this._generateBtn("Home_Alignment_IncreaseIndent", "IncreaseIndent", "imageonly", "e-icon e-ss-increaseindent", "", this._smallBtnHeight, "IncreaseIndent", "IncreaseIndentContent")
                   ],
               }]
            };
            homeTab.groups.push(createdObj);
            createdObj = {
                text: "Actions",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateBtn("Home_Actions_Undo", "Undo", "textandimage", "e-icon e-ss-undo", 40, this._bigBtnHeight, "UndoTitle", "UndoContent", false, imgtop, ""),
                        this._generateBtn("Home_Actions_Redo", "Redo", "textandimage", "e-icon e-ss-redo", 40, this._bigBtnHeight, "RedoTitle", "RedoContent", false, imgtop, "")
                    ],
                }]
            };
            homeTab.groups.push(createdObj);
            createdObj = {
                text: "Number",
                alignType: ej.Ribbon.alignType.rows,
                enableGroupExpander: true,
                content: [{
                    groups: [
                        this._generateDD("Home_Number_NumberFormat", "NumberFormat", this._numberFormat, "1", 125, this._smallBtnHeight, "NumberFormat", "NumberFormatContent")
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Home_Number_Accounting", "AccountingStyle", "imageonly", "e-icon e-ss-accounting", "", this._smallBtnHeight, "AccountingStyle", "AccountingStyleContent"),
                        this._generateBtn("Home_Number_Percentage", "PercentageStyle", "imageonly", "e-icon e-ss-percentage", "", this._smallBtnHeight, "PercentageStyle", "PercentageStyleContent"),
                        this._generateBtn("Home_Number_CommaStyle", "CommaStyle", "imageonly", "e-icon e-ss-comma", "", this._smallBtnHeight, "CommaStyle", "CommaStyleContent", true),
                        this._generateBtn("Home_Number_IncreaseDecimal", "IncreaseDecimal", "imageonly", "e-icon e-ss-increasedecimal", "", this._smallBtnHeight, "IncreaseDecimal", "IncreaseDecimalContent"),
                        this._generateBtn("Home_Number_DecreaseDecimal", "DecreaseDecimal", "imageonly", "e-icon e-ss-decreasedecimal", "", this._smallBtnHeight, "DecreaseDecimal", "DecreaseDecimalContent")
                    ],
                }]
            };
            homeTab.groups.push(createdObj);
            createdObj = {
                text: "Styles",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateSplitBtn("Home_Styles_ConditionalFormatting", "ConditionalFormat", "textandimage", xlId + "_CFormat", { dataSource: this._cFormatMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ssr-condformat", false, 75, this._splitBtnHeight, "bottom", imgtop, "dropdown", "e-spreadsheet e-cformatbtn", "ConditionalFormat", "CFContent"),
                        this._generateSplitBtn("Home_Styles_FormatAsTable", "FormatasTable", "textandimage", xlId + "_formatastable", "", "e-icon e-ssr-formatastable", false, 65, this._splitBtnHeight, "bottom", ej.ImagePosition.ImageTop, "dropdown", "e-spreadsheet e-formatastablebtn", "FormatAsTable", "FATContent"),
                        this._generateSplitBtn("Home_Styles_CellStyles", "CellStyles", "textandimage", xlId + "_cellstyles", "", "e-icon e-ssr-cellstyles", false, 55, this._splitBtnHeight, "bottom", ej.ImagePosition.ImageTop, "dropdown", "e-spreadsheet e-cellstylebtn", "CellStyles", "CellStylesContent")
                    ],
                }]
            };
            homeTab.groups.push(createdObj);
            createdObj = {
                text: 'Editing',
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateSplitBtn("Home_Editing_SortFilter", "SortFilter", "textandimage", xlId + "_Ribbon_SortFilter", { dataSource: this._sortFltrMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ss-sortfilter", false, 50, this._splitBtnHeight, "bottom", "imagetop", "dropdown", "e-spreadsheet e-sortfltrbtn", "SortFilter", "SortFilterContent")
                    ],
                },
                {
                    groups: [
                        this._generateSplitBtn("Home_Editing_AutoSum", "AutoSum", "textandimage", xlId + "_Ribbon_AutoSum", { dataSource: this._autosumMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ssr-autosum", false, 100, 25, "right", "", "", "e-spreadsheet e-autosumbtn", "AutoSumTitle", "AutoSumContent"),
                        this._generateSplitBtn("Home_Editing_Clear", "Clear", "textandimage", xlId + "_Ribbon_Clear", { dataSource: this._clearMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ssr-clear", false, 80, 25, "right", "", "dropdown", "e-spreadsheet e-clearbtn", "Clear", "ClearContent")
                    ],
                }]
            };
            homeTab.groups.push(createdObj);
            this._tabCollection.push(homeTab);
        },

        _insertTabObj: function () {
            var createdObj, xlObj = this.XLObj, imgtop = "imagetop", insertTab = { id: "insert", text: xlObj._getLocStr("INSERT"), groups: [] }, xlId = xlObj._id;
            createdObj = {
                text: "Tables",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateBtn("Insert_Tables_PivotTable", "PivotTable", "textandimage", "e-icon e-ssr-pivottable", 65, this._bigBtnHeight, "PivotTable", "PivotTableContent", false, imgtop),
                        this._generateBtn("Insert_Tables_Table", "Table", "textandimage", "e-icon e-ssr-table", 50, this._bigBtnHeight, "Table", "TableContent", false, imgtop)
                    ],
                }]
            };
            insertTab.groups.push(createdObj);
            createdObj = {
                text: "Illustrations",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateBtn("Insert_Illustrations_Pictures", "Pictures", "textandimage", "e-icon e-ssr-pictures", 50, this._bigBtnHeight, "PicturesTitle", "PicturesContent", false, imgtop, "")
                    ],
                }]
            };
            insertTab.groups.push(createdObj);
            createdObj = {
                text: "Links",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateBtn("Insert_Links_Hyperlink", "HyperLink", "textandimage", "e-icon e-ssr-hyperlink", 60, this._bigBtnHeight, "HyperLinkTitle", ["HyperLinkContent", "HyperLinkPlaceContent"], false, imgtop, "")
                    ],
                }]
            };
            insertTab.groups.push(createdObj);
            createdObj = {
                text: "Charts",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateSplitBtn("Insert_Charts_ColumnChart", "ColumnChart", "imageonly", xlId + "_Ribbon_ColumnChart", "", "e-icon e-ss-colchart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "ColumnChartTitle", "ColumnChartContent"),
                        this._generateSplitBtn("Insert_Charts_BarChart", "BarChart", "imageonly", xlId + "_Ribbon_BarChart", "", "e-icon e-ss-barchart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "BarChartTitle", "BarChartContent"),
                        this._generateSplitBtn("Insert_Charts_StockChart", "StockChart", "imageonly", xlId + "_Ribbon_StockChart", "", "e-icon e-ss-stockchart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "StockChartTitle", "StockChartContent")
                    ],
                },
                {
                    groups: [
                        this._generateSplitBtn("Insert_Charts_LineChart", "LineChart", "imageonly", xlId + "_Ribbon_LineChart", "", "e-icon e-ss-linechart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "LineChartTitle", "LineChartContent"),
                        this._generateSplitBtn("Insert_Charts_AreaChart", "AreaChart", "imageonly", xlId + "_Ribbon_AreaChart", "", "e-icon e-ss-areachart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "AreaChartTitle", "AreaChartContent"),
                        this._generateSplitBtn("Insert_Charts_PieChart", "PieChart", "imageonly", xlId + "_Ribbon_PieChart", "", "e-icon e-ss-piechart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "PieChartTitle", "PieChartContent")
                    ],
                },
                {
                    groups: [
                        this._generateSplitBtn("Insert_Charts_ScatterChart", "ScatterChart", "imageonly", xlId + "_Ribbon_ScatterChart", "", "e-icon e-ss-scterchart", false, 41, this._smallBtnHeight, "bottom", "ej.ImagePosition.ImageTop", "dropdown", "e-spreadsheet e-chartbtn", "ScatterChartTitle", "ScatterChartContent")
                    ],
                }]
            };
            insertTab.groups.push(createdObj);
            this._tabCollection.push(insertTab);
        },

        _dataTabObj: function () {
            var createdObj, xlObj = this.XLObj, imgtop = "imagetop", dataTab = { id: "data", text: xlObj._getLocStr("DATATAB"), groups: [] };
            createdObj = {
                text: "Sort & Filter",
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateBtn("Data_SortFilter_SortAtoZ", "SortAtoZ", "textandimage", "e-icon e-ssr-sortatoz", 90, this._smallBtnHeight, "SortAtoZ", "SortAtoZContent", false, "", "e-datapadding"),
                        this._generateBtn("Data_SortFilter_SortZtoA", "SortZtoA", "textandimage", "e-icon e-ssr-sortztoa", 90, this._smallBtnHeight, "SortZtoA", "SortZtoAContent", false, "", "e-datapadding")
                    ]
                },
                {
                    groups: [
                        this._generateBtn("Data_SortFilter_Filter", "Filter", "textandimage", "e-icon e-ssr-filter", 60, this._smallBtnHeight, "Filter", "FilterContent", false, "", "e-datapadding"),
                        this._generateBtn("Data_SortFilter_ClearFilter", "ClearFilter", "textandimage", "e-icon e-ss-clearfilter", 90, this._smallBtnHeight, "ClearFilter", "ClearFilterContent", false, "", "e-datapadding")
                    ],
                }]
            };
            dataTab.groups.push(createdObj);
            createdObj = {
                text: "Data Tools",
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateBtn("Data_DataTools_DataValidation", "Validation", "imageonly", "e-icon e-ssr-validation", 70, 39, "DataValidation", "DVContent", false, imgtop),
                        this._generateSplitBtn("Data_DataTools_DataValidationOptions", "DataValidation", "textandimage", xlObj._id + "_Ribbon_Validation", { dataSource: this._valMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "", false, 70, this._mediumBtnHeight, "bottom", "", "dropdown", "e-ssr-validationsbtn", "DataValidation", "DVContent")
                    ],
                }]
            };
            dataTab.groups.push(createdObj);
            this._tabCollection.push(dataTab);
        },

        _pageTabObj: function () {
            var createdObj, xlObj = this.XLObj, imgtop = "imagetop", pageTab = { id: "pagelayout", text: xlObj._getLocStr("PAGELAYOUT"), groups: [] };
            createdObj = {
                text: "Show",
                alignType: ej.Ribbon.alignType.rows,
                width: 105,
                content: [{
                    groups: [
                        { contentID: xlObj._id + "_Ribbon_pagesetupleft", type: ej.Ribbon.type.custom, height: 80 },
                    ],
                }]
            };
            pageTab.groups.push(createdObj);
            createdObj = {
                text: "Page Layout",
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateBtn("PageLayout_PageLayout_PageSize", "size", "imageonly", "e-icon e-ssr-pagesize", 65, 44, "size", "PageSizeContent", false, imgtop, ""),
                        this._generateSplitBtn("PageLayout_PageLayout_PageSizeOptions", "PageSize", "textandimage", xlObj._id + "_Ribbon_PageSize", { dataSource: this._pageSizes, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "", false, 65, this._mediumBtnHeight, "bottom", "", "dropdown", "e-ssr-pagesizesbtn", "PageSize", "PageSizeContent")
                    ],
                }]
            };
            pageTab.groups.push(createdObj);
            createdObj = {
                text: "Print", alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
						this._generateBtn("PageLayout_Print_Print", "Print", "textandimage", "e-icon e-ssr-print", 50, this._bigBtnHeight, "Print", "PrintContent", false, imgtop, "")
                    ]
                },
                {
                    groups: [
                        this._generateBtn("PageLayout_Print_PrintSelected", "PrintSelected", "textandimage", "e-icon e-ssr-printselected", 55, this._bigBtnHeight, "PrintSelected", "PrintSelectedContent", true, imgtop, "")
                    ],
                }]
            };
            pageTab.groups.push(createdObj);
            this._tabCollection.push(pageTab);
        },

        _reviewTabObj: function () {
            var createdObj, xlObj = this.XLObj, imgtop = "imagetop", reviewTab = { id: "review", text: xlObj._getLocStr("REVIEW"), groups: [] };
            createdObj = {
                text: "Comments", alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
						this._generateBtn("Review_Comments_NewComment", "New", "textandimage", "e-icon e-ssr-newcmnt", 49, this._bigBtnHeight, "NewCommentTitle", "NewCommentContent", false, imgtop)
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Review_Comments_DeleteComment", "Delete", "textandimage", "e-icon e-ssr-deletecmnt", 49, this._bigBtnHeight, "DeleteComment", "DeleteCommentContent", false, imgtop)
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Review_Comments_PreviousComment", "Previous", "textandimage", "e-icon e-ssr-previouscmnt", 49, this._bigBtnHeight, "Previous", "PreviousContent", false, imgtop)
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Review_Comments_NextComment", "Next", "textandimage", "e-icon e-ssr-nextcmnt", 49, this._bigBtnHeight, "Next", "NextContent", false, imgtop)
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Review_Comments_ShowHideComment", "ShowHide", "textandimage", "e-icon e-ssr-showhidecmnt", 160, this._smallBtnHeight, "ShowHide", "ShowHideContent", false, "imageLeft", "e-ssr-cmntcolbtn"),
                        this._generateToggleBtn("Review_Comments_ShowAllComments", "ShowAll", "textandimage", "e-icon e-ssr-showallcmnt", "ShowAll", 155, this._smallBtnHeight, "ShowAllContent", false, "e-ssr-cmntcolbtn")
                    ],
                }]
            };
            reviewTab.groups.push(createdObj);
            createdObj = {
                text: "Changes",
                alignType: ej.Ribbon.alignType.row,
                content: [{
                    groups: [
                          this._generateToggleBtn("Review_Changes_ProtectSheet", "Protectsheet", "textandimage", "e-icon e-ssr-protectsheet", "Protectsheet", 60, this._bigBtnHeight, "ProtectSheetToolTip", false, "e-ssr-protectsheetbtn", "imagetop", "Unprotect"),
                          this._generateToggleBtn("Review_Changes_ProtectWorkbook", "ProtectWorkbook", "textandimage", "e-icon e-ssr-protect", "ProtectWorkbook", 60, this._bigBtnHeight, "ProtectWBContent", false, "e-ssr-cmntcolbtn", "imagetop"),
                          this._generateToggleBtn("Review_Changes_LockCell", "Lock", "textandimage", "e-icon e-ssr-protlockcell", "lock", 90, this._smallBtnHeight, "Lock", false, "e-ssr-lockbtn", "", "Unlock", "e-icon e-ssr-protunlockcell"),
                    ],
                },
			   
                ]
            };
            reviewTab.groups.push(createdObj);
            this._tabCollection.push(reviewTab);
        },

        _otherTabObj: function () {
            var createdObj, xlObj = this.XLObj, imgtop = "imagetop", otherTab = { id: "others", text: xlObj._getLocStr("OTHERS"), groups: [] }, xlId = xlObj._id, conttype = ej.ContentType;
            createdObj = {
                text: "Window", alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
						this._generateSplitBtn("Others_Window_FreezePanes", "FreezePanes", "textandimage", xlObj._id + "_Ribbon_FPane", { dataSource: this._viewMenuData, id: 'id', parentId: 'parentId', text: 'text', spriteCssClass: 'sprite' }, "e-icon e-ssr-frzpane", false, 55, this._splitBtnHeight, "bottom", imgtop, "dropdown", "e-spreadsheet e-fpanebtn", "FreezePanes", "FreezePanesContent")
                    ],
                }]
            };
            otherTab.groups.push(createdObj);
            createdObj = {
                text: xlObj._getLocStr("Formula"),
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateBtn("Others_Formulas_NameManager", "NameManager", conttype.TextAndImage, "e-icon e-ssr-namemngr", 55, this._bigBtnHeight, "NameManager", ["NameManagerContent", "NameManagerFormulaContent"], false, imgtop, "")
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Others_Formulas_DefineName", "DefineName", conttype.TextAndImage, "e-icon e-ssr-definename", 110, 25, "DefineName", "DefineNameContent"),
                        this._generateSplitBtn("Others_Formulas_UseInFormula", "UseInFormula", "textandimage", xlObj._id + "_nmuseinformula", "", "e-icon e-ssr-useformula", false, 125, 25, ej.ArrowPosition.Bottom, ej.ImagePosition.ImageLeft, "dropdown", "e-spreadsheet e-useinformulabtn", "UseInFormula", "UseInFormulaContent")
                    ],
                }]
            };
            otherTab.groups.push(createdObj);
            createdObj = {
                text: "Cells",
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateBtn("Others_Cells_InsertCell", "Insert", "imageonly", "e-icon e-ssr-insert", 54, 40, "InsertTitle", ["InsertContent", "MultipleInsertContent"], false, imgtop),
                        this._generateSplitBtn("Others_Cells_InsertCellOptions", "Insert", "textandimage", xlId + "_Ribbon_Ins", { dataSource: this._insertMenuData, id: 'id', parentId: 'parentId', text: 'text', spriteCssClass: 'sprite' }, "", false, 54, this._mediumBtnHeight, "bottom", "", "dropdown", "e-insertsbtn", "InsertTitle", "InsertSBContent")
                    ],
                },
                {
                    groups: [
                        this._generateBtn("Others_Cells_DeleteCell", "Delete", "imageonly", "e-icon e-ssr-delete", 54, 40, "DeleteTitle", ["DeleteContent", "MultipleDeleteContent"], false, imgtop),
                        this._generateSplitBtn("Others_Cells_DeleteCellOptions", "Delete", "textandimage", xlId + "_Ribbon_Del", { dataSource: this._deleteMenuData, id: 'id', parentId: 'parentId', text: 'text', spriteCssClass: 'sprite' }, "", false, 54, this._mediumBtnHeight, "bottom", "", "dropdown", "e-deletesbtn", "DeleteTitle", ["DeleteContent", "MultipleDeleteContent"])
                    ],
                }]
            };
            otherTab.groups.push(createdObj);
            createdObj = {
                text: "Editing",
                alignType: ej.Ribbon.alignType.rows,
                content: [{
                    groups: [
                        this._generateSplitBtn("Others_Editing_FindSelect", "FindSelect", "textandimage", xlId + "_Ribbon_FindRep", { dataSource: this._findMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ss-findselect", false, 55, this._splitBtnHeight, "bottom", "imagetop", "dropdown", "e-spreadsheet e-findbtn", "FindSelectTitle", "FindSelectContent")
                    ],
                }]
            };
            otherTab.groups.push(createdObj);
            createdObj = {
                text: "Calculation",
                alignType: ej.Ribbon.alignType.columns,
                content: [{
                    groups: [
                        this._generateSplitBtn("Others_CalCulation_CalculationOptions", "CalculationOptions", "textandimage", xlId + "_Ribbon_CalcOpt", { dataSource: this._calcOptData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ss-calcopt", false, 67, this._splitBtnHeight, "bottom", "imagetop", "dropdown", "e-spreadsheet e-coptbtn", "CalcOptTitle", ["CalcOptContent", "CalcOptRecalcContent"])
                    ]
                },
                {
                    groups: [
                                    this._generateBtn("Others_CalCulation_CalculateNow", "CalculateNow", conttype.TextAndImage, "e-icon e-ss-calcnow", 110, 30, "CalculateNow", ["CalculateNowContent", "CalculateNowTurnOffContent"]),
                                    this._generateBtn("Others_CalCulation_CalculateSheet", "CalculateSheet", conttype.TextAndImage, "e-icon e-ss-calcsheet", 110, 30, "CalculateSheet", ["CalculateSheetContent", "CalculateSheetTurnOffContent"])
                    ]
                }],
            };
            otherTab.groups.push(createdObj);
            this._tabCollection.push(otherTab);
        },

        _renderRibbon: function (isSetModel) {
            var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, click, xlMod = xlObj.model, ribbonElem = ej.buildTag("div", "", "", { id: xlId + "_Ribbon" }), i, tabName = [xlObj._getLocStr("HOME"), xlObj._getLocStr("INSERT"), xlObj._getLocStr("DATATAB"), xlObj._getLocStr("PAGELAYOUT"), xlObj._getLocStr("REVIEW"), xlObj._getLocStr("OTHERS")];
            isSetModel ? xlEle.prepend(ribbonElem) : xlEle.append(ribbonElem);
            xlMod.ribbonSettings.applicationTab.type === "menu" && xlEle.append(ej.buildTag("ul", "", "", { id: xlId + "_Menu" }));
            click = ej.SplitButton.prototype._documentClick;
            ej.SplitButton.prototype._documentClick = function (e) { // for ejmenu document click issue(JS-10113)
                if (!$(e.target).is(".e-formatastable") && !$(e.target).is(".e-formatastable-adaptive"))
                    click.call(this, e);
            };
            var tabColl = [xlObj._getLocStr("HOME"), xlObj._getLocStr("INSERT"), xlObj._getLocStr("PAGELAYOUT"), xlObj._getLocStr("DATATAB"), xlObj._getLocStr("OTHERS"), xlObj._getLocStr("FORMAT"), xlObj._getLocStr("DESIGN"), xlObj._getLocStr("CHARTDESIGN"), xlObj._getLocStr("ANALYZE")];
            if (xlObj.model.ribbonSettings.enableOnDemand && !xlObj._isRibbonDestroyed) 
                this._createTrgtElement(xlObj._getLocStr("HOME"));
            else {
                for (var i = 0; i < tabColl.length; i++)
                    this._createTrgtElement(tabColl[i], ribbonElem);
            }
            this._menuCustomize();
            this._homeTabObj();
            this._insertTabObj();
            this._dataTabObj();
            this._pageTabObj();
            this._reviewTabObj();
            this._otherTabObj();
            this._contextualTabObj();
            ribbonElem.attr('style', 'overflow:hidden');
            ribbonElem.height(0);
            ribbonElem.width(0);
            ribbonElem.ejRibbon({
                width: "100%",
                allowResizing: true,
                applicationTab: this._appTabCollection,
                tabs: this._tabCollection,
                contextualTabs: this._contextualTabCollection,
                tabClick: $.proxy(this._onTabClick, this),
                tabSelect: $.proxy(this._onTabSelect, this),
                create: $.proxy(this._onControlCreated, this),
                collapse: $.proxy(this._onCollapse, this),
                backstageItemClick: $.proxy(this._onBackStageItemClick, this),
                groupExpand: $.proxy(this._onGroupExpander, this),
                pinState: $.proxy(this._onRibbonPin, this),
                expand: $.proxy(this._onRibbonExpand, this),
                groupClick: $.proxy(this._onRibbonGroupClick, this),
                _destroyed: $.proxy(this._rbnDestroy, this),
                enableOnDemand: xlObj.model.ribbonSettings.enableOnDemand,
                beforeTabClick: $.proxy(this._onBeforeTabClick, this)
            });
            ribbonElem.css("height", "auto");
            ribbonElem.width("100%");
            if (xlMod.scrollSettings.isResponsive) {
                ribbonElem.ejRibbon("option", { allowResizing: true });
                if ((xlObj._phoneMode || xlObj._tabMode) && (xlObj._orientation === "landscape"))
                    ribbonElem.ejRibbon("collapse");
            }
            if (xlObj.model.ribbonSettings.enableOnDemand && !xlObj._isRibbonDestroyed) {
                this._homeTabControls();
                this._updateRibCustomCss(xlObj._getLocStr("HOME"));
                this._isHomeTabCreate = true;
                this._hideRibbonElem(xlObj._getLocStr("HOME"));
            }
            else {
                this._isHomeTabCreate = true,
                this._isInsertTabCreate = true,
                this._isDataTabCreate = true,
                this._isPageLayoutTabCreate = true,
                this._isReviewTabCreate = true,
                this._isOthersTabCreate = true,
                this._isDesignTabCreate = true,
                this._isFormatTabCreate = true,
                this._isChartTabCreate = true,
                this._analyzeTabCreate = true,
                this._isAppTabCreate = true;
                $("#" + xlId + "_Ribbon_review_Comments_5").css("vertical-align", "middle");
                for (i = 0; i < 6; i++) {
                    if (i !== 1 && i !== 4)
                        this._updateRibCustomCss(tabName[i]);
                    this._hideRibbonElem(tabName[i]);
                }
            }
            this._hideOtherControls();
        },

        _createTabControls: function (tabName) {
            var xlObj = this.XLObj;
            switch (tabName) {
                case xlObj._getLocStr("HOME"):
                    if (!this._isHomeTabCreate) {
                        this._homeTabControls();
                        this._isHomeTabCreate = true;
                        xlObj._on($('#' + xlObj._id + '_cellstyles'), "click", xlObj._cellStyleClick);
                        xlObj._on($('#' + xlObj._id + '_formatastable'), "click", xlObj._formatAsTableClick);
                        this._updateRibCustomCss(tabName);
                        this._hideRibbonElem(tabName);
                    }
                    break;
                case xlObj._getLocStr("INSERT"):
                    if (!this._isInsertTabCreate) {
                        this._isInsertTabCreate = true;
                        xlObj._on($(".e-" + xlObj._id + ".e-chartcell"), "click", xlObj._chartClickHandler);
                        this._hideRibbonElem(tabName);
                    }
                    break;
                case xlObj._getLocStr("DATATAB"):
                    if (!this._isDataTabCreate) {
                        this._isDataTabCreate = true;
                        this._updateRibCustomCss(tabName);
                        this._hideRibbonElem(tabName);
                    }
                    break;
                case xlObj._getLocStr("PAGELAYOUT"):
                    if (!this._isPageLayoutTabCreate) {
                        this._pageTabControls();
                        this._isPageLayoutTabCreate = true;
                        this._updateRibCustomCss(tabName);
                        this._hideRibbonElem(tabName);
                    }
                    break;
                case xlObj._getLocStr("REVIEW"):
                    if (!this._isReviewTabCreate) {
                        $("#" + xlObj._id + "_Ribbon_review_Comments_5").css("vertical-align", "middle");
                        this._isReviewTabCreate = true;
                        this._hideRibbonElem(tabName);
                    }
                    break;
                case xlObj._getLocStr("OTHERS"):
                    if (!this._isOthersTabCreate) {
                        this._othersTabControls();
                        this._isOthersTabCreate = true;
                        this._updateRibCustomCss(tabName);
                        xlObj._on($('#' + xlObj._id + '_nmuseinformula'), "click", ".e-nmuseinformularow", xlObj._useInFormulaClick);
                        this._hideRibbonElem(tabName);
                    }
                    break;
                case xlObj._getLocStr("FORMAT"):
                    if (!this._isFormatTabCreate)
                        this._isFormatTabCreate = true;
                    break;
                case xlObj._getLocStr("DESIGN"):
                    if (!this._isDesignTabCreate)
                        this._isDesignTabCreate = true;
                    break;
                case xlObj._getLocStr("CHARTDESIGN"):
                    if (!this._isChartTabCreate)
                        this._isChartTabCreate = true;
                    break;
                case xlObj._getLocStr("ANALYZE"):
                    if (!this._analyzeTabCreate)
                        this._isFormatTabCreate = true;
                    break;
            }
        },

        _createTrgtElement: function (actTab, ribbonElem) {
            var xlObj = this.XLObj, ribbonElem = ribbonElem ? ribbonElem : $("#" + xlObj._id + "_Ribbon");
            switch (actTab) {
                case xlObj._getLocStr("HOME"):
                    !this._isHomeTabTrgt && this._homeTabTrgtElem();
                    this._isHomeTabTrgt = true;
                    break;
                case xlObj._getLocStr("INSERT"):
                    !this._isInsertTabTrgt && this._onTabCreate();
                    this._isInsertTabTrgt = true;
                    break;
                case xlObj._getLocStr("DATATAB"):
                    !this._isDataTabTrgt && this._dataTabTrgtElem();
                    this._isDataTabTrgt = true;
                    break;
                case xlObj._getLocStr("PAGELAYOUT"):
                    !this._isPageLayoutTabTrgt && this._pageTabTrgtElem(ribbonElem);
                    this._isPageLayoutTabTrgt = true;
                    break;
                case xlObj._getLocStr("OTHERS"):
                    !this._isOthersTabTrgt && this._othersTabTrgtElem();
                    this._isOthersTabTrgt = true;
                    break;
                case xlObj._getLocStr("CHARTDESIGN"):
                    !this._isChartTabTrgt && this._renderChartDesignTab();
                    this._isChartTabTrgt = true;
                    break;
                case xlObj._getLocStr("ANALYZE"):
                    !this._analyzeTabTrgt && this._renderAnalyzeTab();
                    this._analyzeTabTrgt = true;
                    break;
                case xlObj._getLocStr("FORMAT"):
                    !this._isFormatTabTrgt && this._renderFormatTab();
                    this._isFormatTabTrgt = true;
                    break;
                case xlObj._getLocStr("DESIGN"):
                    !this._isDesignTabTrgt && this._renderDesignTab();
                    this._isDesignTabTrgt = true;
                    break;
            }
        },

		_onTabCreate: function() {
			var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, ribbonElem = $("#" + xlObj._id + "_Ribbon");
			xlEle.append(this._chartType("ColumnChart", 6, 2, 2, ["column", "stackingcolumn", "stackingcolumn100", "column", "stackingcolumn", "stackingcolumn100"], ["ClusteredColumn", "StackedColumn", "Stacked100Column", "Cluster3DColumn", "Stacked3DColumn", "Stacked100Column3D"]));
            xlEle.append(this._chartType("BarChart", 6, 2, 2, ["bar", "stackingbar", "stackingbar100", "bar", "stackingbar", "stackingbar100"], ["ClusteredBar", "StackedBar", "Stacked100Bar", "Cluster3DBar", "Stacked3DBar", "Stacked100Bar3D"]));
            xlEle.append(this._chartType("StockChart", 2, 2, 2, ["radar", "radar"], ["Radar", "RadarMarkers"]));
            xlEle.append(this._chartType("LineChart", 2, 2, 3, ["line", "line"], ["Line", "LineMarkers"]));
            xlEle.append(this._chartType("AreaChart", 3, 3, 3, ["Area", "stackingarea", "stackingarea100"], ["Area", "StackedArea", "Stacked100Area"]));
            xlEle.append(this._chartType("PieChart", 3, 3, 4, ["pie", "pie", "doughnut"], ["Pie", "Pie3D", "Doughnut"]));
            xlEle.append(this._chartType("ScatterChart", 1, 2, 2, ["scatter"], ["Scatter"]));
            ribbonElem.append("<div id='" + xlObj._id + "_nmuseinformula' class='e-nmuseinformula' style='width:125px'></div>");
		},
		
		_rbnDestroy: function(args) {
			var xlObj = this.XLObj, xlId = xlObj._id, fillColor = "#" + xlId + "_Ribbon_Home_Font_FillColor", fontColor = "#" + xlId + "_Ribbon_Home_Font_FontColor",
				pictureColor = "#" + xlId + "_Ribbon_PictureColor", borderColor = "#" + xlId + "_Ribbon_Home_Font_BorderColor", borderCP = "#" + xlId + "_Ribbon_BorderCP",
			    rObj = $("#" + xlId + "_Ribbon").ejRibbon("instance"), actTab = rObj.getTabText(rObj.model.selectedItemIndex), isRibDemand = xlObj.model.ribbonSettings.enableOnDemand;
			$(fillColor).data("ejColorPicker") && $(fillColor).ejColorPicker("destroy");
			$(fontColor).data("ejColorPicker") && $(fontColor).ejColorPicker("destroy");
			$(pictureColor).data("ejColorPicker") && $(pictureColor).ejColorPicker("destroy");
			$(borderColor).data("ejColorPicker") && $(borderColor).ejColorPicker("destroy");
			$("#" + xlId + "_Ribbon_Home_Font_BorderColor_Presets").parent().remove();
			$(borderCP).data("ejColorPicker") && $(borderCP).ejColorPicker("destroy");			
			if (args && !args.destroy) {
			    xlObj._off($('#' + xlId + '_cellstyles'), "click", xlObj._cellStyleClick);
			    xlObj._off($('#' + xlId + '_formatastable'), "click", xlObj._formatAsTableClick);
			    $(borderColor)[0].style.display = "none";
			    xlObj._off($(".e-" + xlId + ".e-chartcell"), "click", xlObj._chartClickHandler);
			    if (!isRibDemand || (this._isHomeTabTrgt && actTab === xlObj._getLocStr("HOME"))) {
			        var xlId = xlObj._id, xlEle = xlObj.element, rbnId = xlId + "_Ribbon_", fontElem = rbnId + "Home_Font_";
			        xlEle.append(ej.buildTag("input", "", { display: "none" }, { id: fontElem + "FillColor", type: "text" }));
			        xlEle.append(ej.buildTag("input", "", { display: "none" }, { id: fontElem + "FontColor", type: "text" }));
			        xlEle.append(ej.buildTag("input", "", { display: "none" }, { id: fontElem + "BorderColor", type: "text" }));
			        xlEle.append(ej.buildTag("div.e-spreadsheet e-formatastable", "", { display: "none" }, { id: xlObj._id + "_formatastable" }));
			        xlObj.element.append(this._renderCellStyles());
			    }
			    else
			        this._isHomeTabTrgt = false;
			    if (!isRibDemand || (this._isInsertTabTrgt && actTab === xlObj._getLocStr("INSERT")))
			        this._onTabCreate();
			    else
			        this._isInsertTabTrgt = false;
			    this._isHomeTabCreate = this._isInsertTabCreate = this._isDataTabCreate = this._isPageLayoutTabCreate = this._isReviewTabCreate = false;
			    this._isOthersTabCreate = this._isDesignTabCreate = this._isFormatTabCreate = this._isChartTabCreate = this._analyzeTabCreate = this._isAppTabCreate = false;
			    xlObj._isRibbonDestroyed = true;
			}
			else {
			    $(document.body).append($("#" + xlId + " _formatastable").parent());
			    $(document.body).append($("#" + xlId + " _cellstyles").parent());
			}
		},
		
		_updateRibCustomCss: function (tabName) {
		    var xlObj = this.XLObj, xlId = xlObj._id, appenchild1, appenchild2, before, child, newnode, newnode1, parent, i = 0, len, opts = "Options", parentid, beforeid, appenchild2id, btncls;
		    switch (tabName) {
		        case xlObj._getLocStr("HOME"):
		            var colorcls = "e-ssr-colpickHprt", fnt = "_Ribbon_Home_Font", font = "_Ribbon_home_Font_Home_Font_", pst = "_Ribbon_home_Clipboard_Home_Clipboard_Paste", btn = ["e-mergebtn", "e-borderbtn", "e-autosumbtn"];
		            var id = [xlId + font + "FontFamily", xlId + font + "FontSize"], cls = ["e-ssr-fontfamily", "e-ssr-fontsize"];
		            appenchild2id = [xlId + pst + opts], beforeid = [xlId + pst], parentid = [xlId + "_Ribbon_home_Clipboard_1"], btncls = [" e-ssr-pastebtnHprt"];
		            //add class for fill color
		            xlObj.addClass(document.getElementById(xlId + fnt + "_FillColorWrapper").children[0], colorcls);
		            //add class for font color
		            xlObj.addClass(document.getElementById(xlId + fnt + "_FontColorWrapper").children[0], colorcls);
		            //add class for fillcolor fontcolor 4 span tags
		            child = xlObj.element[0].querySelectorAll(".e-ssr-colpickHprt .e-color-container,.e-ssr-colpickHprt .e-select");
		            while (i < 4) {
		                xlObj.addClass(child[i], "e-ssr-colorcontainer");
		                i++;
		            }
		            //add class for border,merge,autosum buttons
		            i = 0;
		            while (i < 3) {
		                xlObj.addClass(document.querySelectorAll("." + btn[i])[0].parentNode, "e-ssr-horizontalprt");
		                i++;
		            }
		            //add class for font family,font size
		            i = 0;
		            while (i < 2) {
		                xlObj.addClass(document.getElementById(id[i]), cls[i]);
		                i++;
		            }
		            break;
		        case xlObj._getLocStr("DATATAB"):
		            var datavalid = "_Ribbon_data_DataTools_Data_DataTools_DataValidation";
		            appenchild2id = [xlId + datavalid + opts], beforeid = [xlId + datavalid], parentid = [xlId + "_Ribbon_data_DataTools_1"], btncls = [" e-ssr-dtvaldtnHprt"];
		            break;
		        case xlObj._getLocStr("PAGELAYOUT"):
		            var pagelayout = "_Ribbon_pagelayout_PageLayout_PageLayout_PageLayout_PageSize", ribshow = "_Ribbon_PageLayout_Show_", id = ["ej" + xlId + ribshow + "Headings", "ej" + xlId + ribshow + "Gridlines"], cls = ["e-vheading", "e-vgridlines"];
		            appenchild2id = [xlId + pagelayout + opts], beforeid = [xlId + pagelayout], parentid = [xlId + "_Ribbon_pagelayout_PageLayout_1"], btncls = [" e-ssr-pagesizebtnHprt", " e-ssr-sizebtnHprt"];
		            //add class for heading, gridlines
		            i = 0;
		            while (i < 2) {
		                xlObj.addClass(document.getElementById(id[i]), cls[i]);
		                i++;
		            }
		            break;
		        case xlObj._getLocStr("OTHERS"):
		            var insCell = "InsertCell", insDelCell = "_Ribbon_others_Cells_Others_Cells_", delCell = "DeleteCell";
		            appenchild2id = [xlId + insDelCell + insCell + opts, xlId + insDelCell + delCell + opts], beforeid = [xlId + insDelCell + insCell, xlId + insDelCell + delCell], parentid = [xlId + "_Ribbon_others_Cells_1", xlId + "_Ribbon_others_Cells_2"], btncls = [" e-ssr-insertbtnHprt", " e-ssr-deletebtnHprt"];
		            break;
		    }
		    // add class for insert,delete,data validation,paste,pagelayout
		    i = 0, len = parentid.length;
		    while (i < len) {
		        parent = document.getElementById(parentid[i]);
		        before = document.getElementById(beforeid[i]);
		        appenchild1 = document.getElementById(beforeid[i]);
		        appenchild2 = document.getElementById(appenchild2id[i]);
		        newnode = document.createElement("span");
		        newnode.className = "e-ssr-verticalHparent" + btncls[i];
		        newnode.style.display = "inherit";
		        parent.insertBefore(newnode, before);
		        newnode.appendChild(appenchild1);
                newnode.appendChild(appenchild2);
                if (btncls[0] === " e-ssr-pagesizebtnHprt") {
                    newnode1 = document.createElement("span");
                    newnode1.className = "e-ssr-verticalHparent" + btncls[i + 1];
                    newnode1.style.display = "inherit";
                    newnode1.appendChild(newnode);
                    parent.appendChild(newnode1);
                }
                i++;
            }
        },

        _hideOtherControls: function () {
            var i = 0, arr = ["CElement", "Paste", "Border", "Merge", "SortFilter", "Clear", "ColumnChart", "BarChart", "Validation", "PageSize",
                "FPane", "Ins", "Del", "FindRep", "PastePic", "PictureBorder", "AutoSum", "ResetPic", "PictureBorder", "StockChart",
                "LineChart", "AreaChart", "PieChart", "ScatterChart", "color_Presets", "PictureColor_Presets", "Home_Font_BorderColor_Presets"],
                len = arr.length;
            while (i--)
                $("#" + this._id + "_Ribbon_" + arr[i]).hide();
            i = 0, arr = ["CFormat", "formatastable", "cellstyles", "ctxtmenu"], len = arr.length;
            while (i--)
                $("#" + this._id + "_" + arr[i]).hide();
        },

        // ribbon backstage
        _renderAppTab: function () {
            var htmlStr, xlObj = this.XLObj, bspage = [];
            // backstage content elements
            htmlStr = "<div  id='" + xlObj._id + "_backstagetabnew' style='display:none' class='e-ssr-bstabnew'><div class='e-ssr-bscontent' title='" + xlObj._getLocStr("BlankWorkbook") + "'><div class='e-ssr-bsnewtmpl' ><button id='" + xlObj._id + "_bstab_new_blank' type='button' class = 'e-rbn-button' ></button></div></div></div>";
            htmlStr = htmlStr.concat("<div id='" + xlObj._id + "_backstagetabsaveas' style='display:none' class='e-ssr-bstabsaveas'><div class='e-ssr-bscontent'><div class='e-ssr-bssaveasopt'><button id='" + xlObj._id + "_bstab_saveas_excel' type='button' class = 'e-rbn-button'></button><span>" + xlObj._getLocStr("SaveAsExcel") + "</span></div><div class='e-ssr-bssaveasopt'><button id='" + xlObj._id + "_bstab_saveas_csv' type='button' class = 'e-rbn-button'></button><span>" + xlObj._getLocStr("SaveAsCsv") + "</span></div><div class='e-ssr-bssaveasopt'><button id='" + xlObj._id + "_bstab_saveas_pdf' type='button' class = 'e-rbn-button'></button><span>" + xlObj._getLocStr("SaveAsPdf") + "</span></div></div></div>");
            htmlStr = htmlStr.concat("<div id='" + xlObj._id + "_backstagetabprint' style='display:none' class='e-ssr-bstabprint'><div class='e-ssr-bscontent'><div class='e-ssr-bsprintopt'><button id='" + xlObj._id + "_bstab_print_sheet' type='button' class = 'e-rbn-button'></button><span>" + xlObj._getLocStr("PrintSheet") + "</span></div><div class='e-ssr-bsprintopt'><button id='" + xlObj._id + "_bstab_print_selected' type='button' class = 'e-rbn-button'></button><span>" + xlObj._getLocStr("PrintSelected") + "</span></div></div></div>");
            xlObj.element.append(htmlStr);
            // backstage object construction
            bspage.push({ id: "new", text: xlObj._getLocStr("New"), itemType: ej.Ribbon.itemType.tab, contentID: xlObj._id + "_backstagetabnew" });
            bspage.push({ id: "open", text: xlObj._getLocStr("Open") + "...", itemType: ej.Ribbon.itemType.tab });
            bspage.push({ id: "saveas", text: xlObj._getLocStr("SaveAs"), itemType: ej.Ribbon.itemType.tab, contentID: xlObj._id + "_backstagetabsaveas" });
            bspage.push({ id: "print", text: xlObj._getLocStr("Print"), itemType: ej.Ribbon.itemType.tab, contentID: xlObj._id + "_backstagetabprint" });
            this._appTabCollection = { type: ej.Ribbon.applicationTabType.backstage, backstageSettings: { text: xlObj._getLocStr("File"), headerWidth: 124, height: xlObj._responsiveHeight - 2, width: xlObj._responsiveWidth - 3, pages: bspage } };
        },

        _onBackStageItemClick: function (args) {
            if (!this._isAppTabCreate) {
                this._appTabControls();
                this._isAppTabCreate = true;
            }
            var xlObj = this.XLObj, evnt, arg, settings = xlObj.model.ribbonSettings.applicationTab;
            xlObj.XLEdit._isEdit && xlObj.XLEdit.saveCell();
            xlObj.XLComment && xlObj.XLComment._isCommentEdit && xlObj.XLComment._updateCurCmntVal();
            if (xlObj._isSheetRename && !xlObj._updateSheetNames(null, false)) {
                xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("hideBackstage");
                return;
            }
           if (settings.type === "menu") {
              evnt = { element: args.element };
              if (xlObj._trigger("menuClick", evnt))
                  return;
              if (args.ID === "Open") {
                  xlObj.XLEdit._isEdit && xlObj.XLEdit.saveCell();
                  this._bSBtnClickHandler(args.ID.toLowerCase(), args);
                }
                else
                  this._bSBtnClickHandler(args.ID.toLowerCase(), args);
           }
            if (settings.type === "backstage") {
                if (args.type === "backstageItemClick") {
                    arg = { id: args.id, text: args.text, type: args.type, target: args.target, prop: args.model };
                    if (xlObj._trigger("menuClick", arg))
                        return;
                    if (args.id === "open_backStageTab") {
                        xlObj.XLEdit._isEdit && xlObj.XLEdit.saveCell();
                        this._bSBtnClickHandler("open", args);
                    }
               }
               else {
                    arg = { e: args.e, type: args.type, status: args.status, target: args.target, id: args.target.id };
                   if (xlObj._trigger("menuClick", arg))
                       return;
                   $("#" + xlObj._id + "_Ribbon").ejRibbon("hideBackstage");
                   xlObj._phoneMode && $("#" + xlObj._id + "_Ribbon").ejRibbon("goToMainContent");
				   var icon = args.model.prefixIcon;
				   this._bSBtnClickHandler(icon.indexOf("blank") > -1 ? icon.split("-")[2] : icon.split("-")[3], args);
               }
           }
        },

        _bSBtnClickHandler: function (tab, args) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), exportType,
            arg = { id: args.id || args.ID || args.target.id, status: args.status, prop: args.model, model: xlObj.model };
            if (xlObj._trigger("ribbonClick", arg))
                return;
            $("#" + xlObj._id + "_Ribbon").ejRibbon("hideBackstage");
            switch (tab) {
                case "open":
                    if (xlObj.isDirty)
                        xlObj._showAlertDlg("confirm", "ImportAlert", "Open", 470);
                    else if (xlObj.model.importSettings.importMapper.length < 1) {
                        xlObj._showAlertDlg("Alert", "ImportExportUrl");
                        return;
                    }
                    else {
                        $("#" + xlObj._id + "_file .e-uploadinput").click();
                        (xlObj._browserDetails.name != "msie" && xlObj._browserDetails.name != "edge") && $("#" + xlObj._id + "_Ribbon_BackStage").show();
                        $("#" + xlObj._id + "_Ribbon").find(".e-backstagetitlecontent").text('').append("Open");
                    }
					break;
                case "new":
                case "blank":
                   xlObj._isSheetsDirty() && xlObj._showAlertDlg("confirm", "DestroyAlert", "New", 470);
                   break;
                case "exportxl":
                   xlObj.XLExport["export"](ej.Spreadsheet.exportType.Excel);
                   break;
                case "exportcsv":
                   xlObj.XLExport["export"](ej.Spreadsheet.exportType.Csv);
                   break;
                case "exportpdf":
                   xlObj.XLExport["export"](ej.Spreadsheet.exportType.Pdf);
                   break;
                case "print":
                case "printsheet":
                    xlObj.XLPrint.printSheet(sheetIdx);
                    break;
                case "printselected":
                    xlObj.XLPrint.printSelection(sheetIdx);
                    break;
            }
        },

        _contextualTabObj: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, imgtop = "imagetop", createdObj;
                createdObj = {
                    backgroundColor: "#FCFBEB",
                    borderColor: "#F2CC1C",
                    tabs: [
                        {
                            id: "design",
                            text: xlObj._getLocStr("Design"),
                            groups: [
                                {
                                    text: "Properties",
                                    alignType: ej.Ribbon.alignType.rows,
                                    type: "custom",
                                    contentID: xlId + "_Ribbon_Design_Properties_TableProperties"
                                },
                                {
                                    text: "Tools",
                                    alignType: ej.Ribbon.alignType.columns,
                                    content: [{
                                        groups: [
                                            this._generateBtn("Design_Tools_ResizeTable", "ResizeTable", "textandimage", "e-icon e-ssr-resizetable", 101, this._smallBtnHeight, "ResizeTable", "ResizeTableContent"),
                                            this._generateBtn("Design_Tools_ConvertToRange", "ConvertToRange", "textandimage", "e-icon e-ssr-range", 130, this._smallBtnHeight, "ConvertToRange", "ConvertToRangeContent")
                                        ],
                                    }
                                    ]
                                },
                                {
                                    text: "Table Style Options",
                                    alignType: ej.Ribbon.alignType.rows,
                                    type: "custom",
                                    contentID: xlId + "_Ribbon_Design_TableStyleOptions"
                                }
                            ]
                        }]
                };
                this._contextualTabCollection.push(createdObj);
                createdObj = {
                    backgroundColor: "#EAF6BD",
                    borderColor: "#90AA3C",
                    tabs: [
                        {
                            id: "chartdesign",
                            text: xlObj._getLocStr("CHARTDESIGN"),
                            groups: [
                                {
                                    text: "Chart Layouts",
                                    alignType: ej.Ribbon.alignType.columns,
                                    content: [{
                                        groups: [
                                            this._generateSplitBtn("ChartDesign_ChartLayouts_AddChartElement", "AddChartElement", "textandimage", xlId + "_Ribbon_CElement", "", "e-icon e-ssr-celements", true, 65, this._bigBtnHeight, "bottom", "imagetop", "dropdown", "e-spreadsheet e-chartlayoutbtn", "AddChartElement", "AddChartElementContent")
                                        ]
                                    }]
                                },
                                {
                                    text: "Data",
                                    alignType: ej.Ribbon.alignType.rows,
                                    content: [{
                                        groups: [
                                            this._generateBtn("ChartDesign_Data_SwitchRowColumn", "SwitchRowColumn", "textandimage", "e-icon e-ssr-srcolumn", 72, this._bigBtnHeight, "SwitchRowColumn", "SwitchRowColumnContent", "", "imagetop"),
                                            this._generateBtn("ChartDesign_Data_SelectData", "SelectData", "textandimage", "e-icon e-ssr-selectdata", 50, this._bigBtnHeight, "SelectData", "SelectDataContent", false, imgtop)
                                        ]
                                    }]
                                },
                                {
                                    text: "Type",
                                    alignType: ej.Ribbon.alignType.rows,
                                    content: [{
                                        groups: [
                                            this._generateBtn("ChartDesign_Type_ChangeChartType", "ChartType", "textandimage", "e-icon e-ssr-charttype", 65, this._bigBtnHeight, "ChartType", "ChartTypeContent", false, imgtop)
                                        ]
                                    }]
                                },
                                {
                                    text: "Chart Themes",
                                    alignType: ej.Ribbon.alignType.columns,
                                    content: [{
                                        groups: [
                                            this._generateDD("ChartDesign_ChartThemes_ChartThemes", "ChartThemes", this._chartThemes, "1", 130, this._smallBtnHeight, "ChartThemes", "ChartThemesContent")
                                        ],
                                    }]
                                },
                                {
                                    text: "Size",
                                    alignType: ej.Ribbon.alignType.columns,
                                    content: [{
                                        groups: [{
                                            contentID: xlId + "_Ribbon_ChartDesign_Size_ChartSize",
                                            enableSeparator: true,
                                            type: ej.Ribbon.type.custom,
                                            height: 80
                                        }]
                                    }]
                                }
                            ]
                        }]
                };
                this._contextualTabCollection.push(createdObj);
                createdObj = {
                    backgroundColor: "#FCFBEB",
                    borderColor: "#F2CC1C",
                    tabs: [
                        {
                            id: "format",
                            text: xlObj._getLocStr("FORMAT"),
                            groups: [
                                {
                                    text: "Adjust",
                                    alignType: ej.Ribbon.alignType.columns,
                                    content: [{
                                        groups: [
                                            this._generateBtn("Format_Adjust_ChangePicture", "ChangePicture", "textandimage", "e-icon e-ssr-changepicture", 120, this._mediumBtnHeight, "ChangePicture", "ChangePictureContent"),
                                            this._generateSplitBtn("Format_Adjust_ResetPicture", "ResetPicture", "textandimage", xlId + "_Ribbon_ResetPic", { dataSource: this._resetPicture, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" }, "e-icon e-ssr-resetpicture", false, 120, this._mediumBtnHeight, "left", "", "dropdown", "e-ss-resetpictbtn", "ResetPicture", "ResetPictureContent")
                                        ],
                                    }
                                    ]
                                },
                                {
                                    text: "Border",
                                    alignType: ej.Ribbon.alignType.columns,
                                    content: [{
                                        groups: [
                                            this._generateSplitBtn("Format_Border_PictureBorder", "PictureBorder", "textandimage", xlId + "_Ribbon_PictureBorder", "", "e-icon e-ssr-pictureborder", false, 120, this._mediumBtnHeight, "left", "", "dropdown", "e-ss-pictbrdrbtn", "PictureBorder", "PictureBorderContent")
                                        ],
                                    }
                                    ]
                                },
                                {
                                    text: "Size",
                                    alignType: ej.Ribbon.alignType.columns,
                                    type: "custom",
                                    contentID: xlId + "_Ribbon_Format_Size_PictureSize"
                                }
                            ]
                        }]
                };
                this._contextualTabCollection.push(createdObj);       
                createdObj = {
                    backgroundColor: "#FCF0F7",
                    borderColor: "#C9599C",
                    tabs: [
                        {
                            id: "analyze",
                            text: xlObj._getLocStr("ANALYZE"),
                            groups: [
                                {
                                    text: "PivotTable",
                                    alignType: ej.Ribbon.alignType.rows,
                                    type: "custom",
                                    contentID: xlId + "_pvttableproperties"                                    
                                },
                                 {
                                     text: "DataSource",
                                     alignType: ej.Ribbon.alignType.rows,
                                     content: [{
                                         groups: [
                                             this._generateBtn("Analyze_DataSource_Refresh", "Refresh", "textandimage", "e-icon e-ssr-datarefresh", 50, this._bigBtnHeight, "RefreshTitle", "RefreshContent", false, imgtop),
                                             this._generateBtn("Analyze_DataSource_ChangeDataSource", "ChangeDataSource", "textandimage", "e-icon e-ssr-changedatasource", 50, this._bigBtnHeight, "ChangeDataSource", "ChangeDataSourceContent", false, imgtop)
                                         ],
                                     }
                                     ]
                                 },
                                 {
                                     text: "Actions",
                                     alignType: ej.Ribbon.alignType.columns,
                                     content: [{
                                         groups: [
                         this._generateBtn("Analyze_Actions_ClearAll", "ClearAll", "textandimage", "e-icon e-ssr-pivotclearall", 75, this._smallBtnHeight, "ClearAll", "ClearAllContent", false, "", "e-datapadding"),
                         this._generateBtn("Analyze_Actions_MovePivotTable", "MovePivotTable", "textandimage", "e-icon e-ssr-movepivottable", 120, this._smallBtnHeight, "MovePivotTable", "MovePivotTableContent", false, "", "e-datapadding")
                                         ],
                                     }
                                     ]
                                 },
                                   {
                                       text: "Show",
                                       alignType: ej.Ribbon.alignType.columns,
                                       content: [{
                                           groups: [
                                               this._generateToggleBtn("Analyze_Show_FieldList", "FieldList", "textandimage", "e-icon e-ssr-fieldlist", "FieldListTitle", 50, this._bigBtnHeight, ["FieldListContent", "FieldListRemoveContent"], false, "", imgtop, null, null, true)
                                           ],
                                       }
                                       ]
                                   }
                            ]
                        }]
                };
                this._contextualTabCollection.push(createdObj);            
        },

        _onRibbonPin: function (args) {
            var xlObj = this.XLObj, settings = $.extend(true, {}, xlObj.model.scrollSettings);
            this._ribbonState = true;
            args.action = "toggleBtn";
            xlObj.model._isActPanelVisible = this._isPanelVisible;
            if (xlObj._isAutoWHMode) {
                this._refreshBackstageHeight();
                var dimension = xlObj._getElementDimension();
                xlObj.element.css({ height: dimension.height, width: dimension.width });
            }
            else
                xlObj._heightWidthCalculation(xlObj.getActiveSheetIndex(), settings, args);
            xlObj.model._isActPanelVisible && xlObj._refreshActivationPanel();
            xlObj.getSheet(xlObj.getActiveSheetIndex())._isRibCollapsed = false;
        },
		
        _onRibbonExpand: function (args) {
            var xlObj = this.XLObj, settings = $.extend(true, {}, xlObj.model.scrollSettings);
            args.action = "toggleBtn";
            if ((args.type === "expand" && args.clickType === "dblclick") || xlObj._phoneMode) {
				this._ribbonState = true;
				if (xlObj._isAutoWHMode) {
				    this._refreshBackstageHeight();
				    var dimension = xlObj._getElementDimension();
				    xlObj.element.css({ height: dimension.height, width: dimension.width });
				}
				else
				    xlObj._heightWidthCalculation(xlObj.getActiveSheetIndex(), settings, args);
				this.XLObj.model._isActPanelVisible && xlObj._refreshActivationPanel();
				xlObj.getSheet(xlObj.getActiveSheetIndex())._isRibCollapsed = false;
		    }
		    else if (this.XLObj.model._isActPanelVisible) {
		        xlObj.getActivationPanel().hide();
		        this._isPanelVisible = xlObj.model._isActPanelVisible;
		        xlObj.model._isActPanelVisible = false;
		        xlObj._heightWidthCalculation(xlObj.getActiveSheetIndex(), settings, args);
		    }
        },

        _onRibbonGroupClick: function (args) {
			var xlObj = this.XLObj;
			if(!xlObj._phoneMode)
				return;
            if ($(args.target).parents(".e-resizegroupdiv").length > 0 || (args.target.className.indexOf("e-resizegroupdiv") > -1) || (args.target.className.indexOf("e-ribdownarrow") > -1) || (args.target.className.indexOf("e-ribuparrow") > -1) || (args.target.className.indexOf("e-ribleftarrow") > -1)) {
                var settings = $.extend(true, {}, xlObj.model.scrollSettings);
                this._ribbonState = true;
                args.action = "toggleBtn";
                xlObj.model._isActPanelVisible = this._isPanelVisible;
                if (xlObj._isAutoWHMode) {
                    this._refreshBackstageHeight();
                    var dimension = xlObj._getElementDimension();
                    xlObj.element.css({ height: dimension.height, width: dimension.width });
                }
                else
                    xlObj._heightWidthCalculation(xlObj.getActiveSheetIndex(), settings, args);
                xlObj.model._isActPanelVisible && xlObj._refreshActivationPanel();
            }
        },

        _hideTabs: function () {  // to hide ribbon tabs
            var i, robj = $("#" + this.XLObj._id + "_Ribbon").ejRibbon("instance"), tnames = ["", this.XLObj._getLocStr("Design"), this.XLObj._getLocStr("CHARTDESIGN"), this.XLObj._getLocStr("FORMAT"), this.XLObj._getLocStr("ANALYZE")];
            i = tnames.length;
            while (i = i - 1)
                robj.hideTab(tnames[i]);
        },

        // ribbon design tab
        _renderDesignTab: function () {
            var proxy = this.XLObj, htmlstr = '', tsotext = proxy._getLocStr('TableStyleOptions').split('/'), groupId = proxy._id + "_Ribbon_Design_TableStyleOptions";
            proxy.element.append('<input id=' + proxy._id + '_tableid type="text" style = "display:none"/>');
            htmlstr = '<div id=' + proxy._id + '_Ribbon_Design_Properties_TableProperties><div class="e-tablepropertiesrow" ><div class="e-tablepropertiescell">Table Name:</div></div><div class="e-tablepropertiesrow" ><div class="e-tablepropertiescell"><input type="text" id=' + proxy._id + '_Ribbon_Design_Properties_TableName class="ejinputtext" style="width:86px;opacity:0.7;height: 18px;text-indent: 3px;padding-left: 0px;box-sizing: content-box;" /></div></div></div>';
            htmlstr = htmlstr + '<div id=' + groupId + '><div class="e-tablestyleoptionsrow" ><div class="e-tablestyleoptionscell"><input id=' + groupId + '_FirstColumn type="checkbox" /><label class="e-tablestyleoptionslabel" for="' + groupId + '_FirstColumn">' + tsotext[0] + '</label></div><div class="e-tablestyleoptionscell" ><input id=' + groupId + '_LastColumn type="checkbox" /><label class="e-tablestyleoptionslabel" for="' + groupId + '_LastColumn">' + tsotext[1] + '</label></div></div><div class="e-tablestyleoptionsrow" ><div class="e-tablestyleoptionscell"><input id=' + groupId + '_TotalRow type="checkbox" /><label class="e-tablestyleoptionslabel" for="' + groupId + '_TotalRow">' + tsotext[2] + '</label></div><div class="e-tablestyleoptionscell" ><input id=' + groupId + '_FilterColumn type="checkbox" /><label class="e-tablestyleoptionslabel" for="' + groupId + '_FilterColumn">' + tsotext[3] + '</label></div></div></div>';
            proxy.element.append(htmlstr);
            $("#" + groupId + "_FirstColumn").ejCheckBox({ change: this._ribbonClickHandler });
            $("#" + groupId + "_LastColumn").ejCheckBox({ change: this._ribbonClickHandler });
            $("#" + groupId + "_TotalRow").ejCheckBox({ change:this._ribbonClickHandler });
            $("#" + groupId + "_FilterColumn").ejCheckBox({ change: this._ribbonClickHandler });
        },

        _renderFormatTab: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, rbnId = xlId + "_Ribbon", formatElem = rbnId + "_Format_Size_";
            xlEle.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: rbnId + "_ResetPic" }));
            xlEle.append(this._borderPicture());
            xlEle.append("<div id=" + formatElem + "PictureSize class= e-ss-numeric style='display:none'><table><tr><td style='padding-right:4px;'>" + xlObj._getLocStr("Height") + ": </label></td><td style='padding-bottom:3px;'><input id='" + formatElem + "PictureHeight' type='text' /></td></tr><tr><td><labe>" + xlObj._getLocStr("Width") + ": </label></td><td><input id='" + formatElem + "PictureWidth' type='text' /></td></tr></table></div>");
            $("#" + formatElem + "PictureHeight").ejNumericTextbox({ name: "numeric", value: 100, minValue: 25, incrementStep: 5, change: $.proxy(this._pictureSizeChange, this, "PictureWidth") });
            $("#" + formatElem + "PictureWidth").ejNumericTextbox({ name: "numeric", value: 100, minValue: 25, incrementStep: 5, change: $.proxy(this._pictureSizeChange, this, "PictureHeight") });
            $("#" + rbnId + "_PictureColor").ejColorPicker({ modelType: "palette", presetType: "basic", cssClass: "e-ss-colorpicker e-ss-menuclrpkr", change: this._ribbonClickHandler });
            $("#" + rbnId + "_PictureColorWrapper").hide();
            $("#" + rbnId + "_PictureColor_popup").css({ "display": "block" });
            $("#" + xlId + "picturecolor ul li").find("a").remove();
            $("#" + xlId + "picturecolor ul li").append($("#" + rbnId + "_PictureColor_popup"));
        },

        _renderAnalyzeTab: function () {
            var xlObj = this.XLObj;
            xlObj.element.find("#" + xlObj._id + "_Ribbon_analyze_PivotTable_content").width(132);
            if (!xlObj.element.find("#" + xlObj._id + "_pvttableproperties").length)
                xlObj.element.append('<div id=' + xlObj._id + '_pvttableproperties style="display:none" ><div class="e-tablepropertiesrow" ><div class="e-tablepropertiescell">PivotTable Name:</div></div><div class="e-tablepropertiesrow" ><div class="e-tablepropertiescell"><input type="text" id=' + xlObj._id + '_Ribbon_Analyze_PivotTable_PivotTableName class="ejinputtext" style="width:106px;opacity:0.7;height: 18px;text-indent: 3px;" /></div></div></div>');
        },

        _renderChartDesignTab: function () {
            var xlObj = this.XLObj, xlEle = xlObj.element, xlId = xlObj._id, chartElem = xlId + "_Ribbon_ChartDesign_Size_";
            xlEle.append('<input id=' + xlId + '_chart type="text" style="display:none;"/>');
            xlEle.append(this._chartElementTag());
            xlEle.append("<div id=" + chartElem + "ChartSize class= e-ss-numeric style='width: 180;height: 80;'><table><tr><td><label class ='e-icon e-ssr-chartheight' style='width:25;height:25;display: visible' id = " + xlId + "_Ribbon_chartheightlbl /></td><td><input id='" + chartElem + "ChartHeight' type='text' /></td></tr><tr><td><label class ='e-icon e-ssr-chartwidth' style='width: 180;height: 80;' id = " + xlId + "_Ribbon_chartwidthlbl /></td><td><input id='" + chartElem + "ChartWidth' type='text' /></td></tr></table></div>");
            $("#" + chartElem + "ChartWidth").ejNumericTextbox({ name: "numeric", value: 200, minValue: 180, decimalPlaces: 1, incrementStep: 5, change: this._ribbonClickHandler });
            $("#" + chartElem + "ChartHeight").ejNumericTextbox({ name: "numeric", value: 200, minValue: 180, decimalPlaces: 1, incrementStep: 5, change: this._ribbonClickHandler });
        },

        // Name Manager(NM)
        _renderNameManagerDlg: function () {
            var xlObj = this.XLObj, htmlStr = "<div id = '" + xlObj._id + "_nmdlg' style=display:'none'; ><div class='e-dlgctndiv' style='width: 100%;' ><div class='e-dlg-fields e-nmdlg-content' style='width: 100%;'><div class='e-ss-nm-dlg-grid' style='height: 180px;'><div id='" + xlObj._id + "_nmgrid' style=display:'none';></div></div></div><div class='e-dlg-fields'><label class='e-dlg-fields'>" + xlObj._getLocStr("RefersTo") + ":</label><input type='text' class='e-nmrange ejinputtext' id='" + xlObj._id + "_nmrange' disabled='true' /></div><div class='e-dlg-btnfields' ><div class='e-dlg-btnctnr'><button id='" + xlObj._id + "_nmclose' >" + xlObj._getLocStr("Close") + "</button></div></div></div></div>";
            htmlStr = htmlStr + "<script id='" + xlObj._id + "_nmeditortemplate' class='e-hide' type='text/template' ><div class='e-dlg-fields e-dlgctndiv'><table cellpadding='0' cellspacing='0'><tr><td>" + xlObj._getLocStr("Name") + ":</td><td><input id='" + xlObj._id + "_nmgridname' type='text' class='ejinputtext' name='name' value='{{: name}}'/></td></tr><tr class='e-dlgtd-fields'><td>" + xlObj._getLocStr("Scope") + ":</td><td><input class='e-nmscope ejinputtext' id='" + xlObj._id + "_nmgridscope' type='text' disabled='disabled' name='scope' value='Workbook'/></td></tr><tr class='e-dlgtd-fields'><td>" + xlObj._getLocStr("Comment") + ":</td><td><textarea id='" + xlObj._id + "_nmgridcomment' class='e-ss-textarea' style=' resize: none; height: 44px; width: 100%;' name='comment' value='{{: comment}}'>{{: comment}}</textarea></td></tr><tr class='e-dlgtd-fields'><td>" + xlObj._getLocStr("RefersTo") + ":</td><td><input type='text' class='ejinputtext' id='" + xlObj._id + "_nmgridrefersto' name = 'refersto' value='{{: refersto}}' /></td></tr></table></div></script>";
            xlObj.element.append(htmlStr);
            $("#" + xlObj._id + "_nmclose").ejButton({ showRoundedCorner: true, width: 68, click: $.proxy(this._nmdlgClose, xlObj) });
			this._renderNMGrid();
            $("#" + xlObj._id + "_nmdlg").ejDialog({ enableResize: false, showOnInit: false, title: xlObj._getLocStr('NameManager'), enableModal: true, width: "auto", height: "auto", cssClass: "e-ss-dialog e-ss-nmdlg e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this), beforeClose: ej.proxy(this._beforeDlgClose, this), open: ej.proxy(this._nmDlgOpen, this) });
		},

        _renderNMGrid: function () {
            var xlObj = this.XLObj;
            $("#" + xlObj._id + "_nmgrid").ejGrid({
                dataSource: xlObj.model.nameManager.slice(0),
                allowScrolling: true,
                allowSorting: true,
                enableAltRow: false,
                isResponsive: true,
                allowPaging: false,
                minWidth: 400,
                scrollSettings: { height: "100%" },
                cssClass: "e-ss-dialog ej-ssgrid e-"+xlObj._id+"-dlg",
                selectionType: ej.Grid.SelectionType.Single,
                editSettings: { allowAdding: true,allowDeleting: false, editMode: ej.Grid.EditMode.DialogTemplate, dialogEditorTemplateID: "#" + xlObj._id + "_nmeditortemplate" },
                toolbarSettings: { showToolbar: true, toolbarItems: [ej.Grid.ToolBarItems.Add] },
                actionBegin: $.proxy(this._nmActionBegin, xlObj),
                actionComplete: $.proxy(this._nmActionComplete, xlObj),
                rowSelected: $.proxy(this._nmRecordSelected, xlObj),
                columns: [
                       { field: "name", headerText: xlObj._getLocStr("Name"), isPrimaryKey: true, width: 100 },
                       { field: "refersto", headerText: xlObj._getLocStr("RefersTo"), width: 120 },
                       { field: "scope", headerText: xlObj._getLocStr("Scope"), width: 80 },
                       { field: "comment", headerText: xlObj._getLocStr("Comment"), width: 100 }
                ]
            });
        },

        _updateNMRange: function () {
            var xlObj = this.XLObj;
            $("#" + xlObj._id + "_nmgridEditForm").find("#" + xlObj._id + "_nmgridrefersto").val("=" + xlObj._getDollarAlphaRange(xlObj.getSheet(xlObj.getActiveSheetIndex()).selectedRange, true));
        },

        _nmdlgClose: function () {
            $("#" + this._id + "_nmdlg").ejDialog("close");
        },

        _nmRecordSelected: function (args) {
            $("#" + this._id + "_nmdlg").find(".e-nmrange").val(args.data.refersto);
        },
        _nmDlgOpen:function(args)
        {
            var xlObj = this.XLObj;
			if (this._isNmgrid === "DefineName") {
                $("#" + xlObj._id + "_nmgrid").ejGrid("instance").addRecord();
                ($("#" + xlObj._id + "_nmgridEditForm input")[0]).focus();
            }
            this._isNmgrid = "";
        },
        _nmActionBegin: function (args) {  // validating input
            var i = 0, canBreak = false, len, prop, data, sheet = this.getSheet(this.getActiveSheetIndex());
            if (args.requestType === "save" && args.data.refersto) {
                data = args.data;
                data.sheetIndex = this._getSheetIndexByName(args.data.refersto.split("!")[0].replace(/[=\']/g, ""));
                args.cancel = true;
                if (!data.sheetIndex) {
                    this._showAlertDlg("Alert", "InvalidSheetIndex", "NMRangeAlert", 275);
                    return;
                }
                if (sheet._nmEdit) {
                    for (prop in sheet._nmValue) {
                        len = this.model.nameManager.length;
                        while (i < len) {
                            if (this.model.nameManager[i].name === sheet._nmValue.name) {
                                this.model.nameManager.splice(i, 1);
                                this._calcEngine.removeNamedRange(sheet._nmValue.name);
                                break;
                            }
                            i++;
                        }
                        i = this._formulaCollection.length;
                        while (i--) {
                            if (this._formulaCollection[i].display === sheet._nmValue.name) {
                                canBreak = true;
                                this._formulaCollection.splice(i, 1);
                                break;
                            }
                        }
                        if (canBreak)
                            break;
                    }
                }
                if (this.XLRibbon._validateNamedRange(data.name, data.refersto))
                    args.cancel = false;
                else
                    canBreak && this.model.nameManager.push(sheet._nmValue);
            }
            if (args.requestType === "beginedit") {
                sheet._nmEdit = true;
                sheet._nmValue = { name: args.model.dataSource[args.model.selectedRowIndex].name, refersto: args.model.dataSource[args.model.selectedRowIndex].refersto, comment: args.model.dataSource[args.model.selectedRowIndex].comment, sheetIndex: args.model.dataSource[args.model.selectedRowIndex].sheetIndex, scope: args.model.dataSource[args.model.selectedRowIndex].scope };
            }
        },

        _nmActionComplete: function (args) {
            var gridInst = $("#" + this._id + "_nmgrid").data("ejGrid"), reqType = args.requestType, editDlgInst, editDlgInpElem;
            switch (reqType) {
                case "add":
                    editDlgInst = $("#" + this._id + "_nmgrid_dialogEdit").data("ejDialog");
                    editDlgInst.model.open = $.proxy(this.XLRibbon._updateNMRange(), this);
                    editDlgInst.option("allowDraggable", false);
                    editDlgInst.option("title", this._getLocStr("NewName"));
                    editDlgInpElem = $("#" + this._id + "_nmgridEditForm").find("input[type='button']:first");
                    editDlgInpElem.data("ejButton").option({"text":"OK", cssClass:"e-ss-okbtn"});
                    editDlgInpElem.parent().addClass("e-dlg-btnfields").css("text-align", "right");
                    break;
                case "save":
                    this.XLRibbon._addNamedRange(gridInst, args.data.name, args.data.refersto, args.data.comment, args.data.sheetIndex);
                    break;
                case "delete":
                    this.XLRibbon._removeNamedRange(gridInst, args.data.name);
                    break;
                case "cancel":
                    gridInst.element.focus();
                    break;
            }
        },

        _updateNamedRanges: function (name, refersto, skipAutoComp) {
            var xlObj = this.XLObj;
            refersto = xlObj.XLEdit._parseSheetRef(refersto, true);
            xlObj._calcEngine.addNamedRange(name, refersto.replace("=", ""));
            xlObj._formulaCollection.push({ text: "=" + name, display: name });
            if (!skipAutoComp)
                xlObj.XLEdit._refreshAutoComplete();
        },

        _updateUseInFormulaTrgt: function () {
            var i = 0, xlObj = this.XLObj, htmlStr = "", trgt = $("#" + xlObj._id + "_nmuseinformula"), nameMgr = xlObj.model.nameManager, len = nameMgr.length;
            while (i < len) {
                htmlStr = htmlStr + "<div class='e-nmuseinformularow' style = 'color:#333333'>" + nameMgr[i].name + "</div>";
                i++;
            }
            len ? $("#" + xlObj._id + "_Ribbon_Others_Formulas_UseInFormula").ejSplitButton("enable") : $("#" + xlObj._id + "_Ribbon_Others_Formulas_UseInFormula").ejSplitButton("disable");
            trgt.html("<div>" + htmlStr + "</div>");
        },

        addNamedRange: function (name, refersTo, comment, sheetIdx) {
            var xlObj = this.XLObj, gridInst;
            xlObj._showDialog(xlObj._id + "_Ribbon_Others_NameManager");
            gridInst = $("#" + xlObj._id + "_nmgrid").data("ejGrid");
            if (this._validateNamedRange(name, refersTo)) {
                gridInst.addRecord({ name: name, refersto: refersTo, comment: comment ? comment : "", scope: "WorkBook", sheetIndex: sheetIdx });
                gridInst.refreshContent();
            }
        },

        _addNamedRange: function (gridInst, name, refersTo, comment, sheetIdx) {
            var xlObj = this.XLObj;
            xlObj.model.nameManager = gridInst.model.dataSource.slice(0);
            this._updateNamedRanges(name, refersTo);
            this._updateUseInFormulaTrgt();
            !xlObj._isSheetNavigate && xlObj._trigActionComplete({ sheetIndex: sheetIdx, reqType: "named-range", name: name, refersTo: refersTo, comment: comment });
        },

        removeNamedRange: function (name) {
            if (!name)
                return;
            var gridInst = $("#" + this.XLObj._id + "_nmgrid").data("ejGrid");
            gridInst.option("editSettings", { "allowDeleting": true });
            gridInst.deleteRecord("name", { name: name })
            gridInst.option("editSettings", { "allowDeleting": false });
        },

        _removeNamedRange: function (gridInst, name) {
            var i, nameMgr, xlObj = this.XLObj, nm = xlObj.model.nameManager[xlObj.model.nameManager.length - 1];
            xlObj.model.nameManager = gridInst.model.dataSource.slice(0);
            nameMgr = xlObj.model.nameManager;
            xlObj._calcEngine.removeNamedRange(name);
            xlObj._updateFormulaCollection();
            i = nameMgr.length;
            if (i) {
                while (i--)
                    xlObj._formulaCollection.push({ text: "=" + nameMgr[i].name, display: nameMgr[i].name });
            }
            this._updateUseInFormulaTrgt();
        },

        _validateNamedRange: function (name, refersTo) {
            var range, libMgr, nameMgr, adlg, text, xlObj = this.XLObj, rangeAlert = "NMRangeAlert", invalidName = "NMNameAlert", uniqueName = "NMUniqueNameAlert", action;
            range = this._validateDollarRange(refersTo);
            if (name)
                (name.length > 0) && (libMgr = /^([a-zA-Z_0-9]){0,255}$/.test(name) && this._validateLibraryFunctions(name));
            nameMgr = this._validateNameManager(name);
            if (xlObj._isUndoRedo || (range && libMgr && nameMgr))
                return true;
            else {
                adlg = $("#" + xlObj._id + "_alertdlg");
                if (!range)
                    text = xlObj._getLocStr(rangeAlert), action = rangeAlert;
                else if (!libMgr)
                    text = xlObj._getLocStr(invalidName).split("/")[0], action = invalidName;  // not used completely
                else
                    text = xlObj._getLocStr(uniqueName), action = uniqueName;
                xlObj._showAlertDlg("Alert", "T-" + text, action, 370);
            }
        },

        _validateLibraryFunctions: function (name) {
            var i, arr = [], libraryFunc = this.XLObj.getCalcEngine().getLibraryFunctions();
            name = ej.isNullOrUndefined(name) ? "" : name.toString().toUpperCase();
            for (i in libraryFunc.items)  // for hashable issue (return false => always return true)
                arr.push(i);
            i = arr.length;
            while (i--)
                if (arr[i] === name) return false;
            return true;
        },

        _validateNameManager: function (name) {
            var i = 0, nameMgr = this.XLObj.model.nameManager, length = nameMgr.length;
            name = ej.isNullOrUndefined(name) ? "" : name.toString().toUpperCase();
            while (i < length) {
                if (nameMgr[i].name.toUpperCase() === name)
                    return false;
                i++;
            }
            return true;
        },

        _validateDollarRange: function (range) {
            try {
                if (range && range.indexOf("!") > -1) {
                    range = range.split("!")[1].replace(/\$/g, "");
                    this.XLObj.getRangeIndices(range);
                    return true;
                }
            }
            catch (err) {
                return false;
            }
        },

        // Format as table(FAT)
        _renderFormatAsTable: function () {
            var parent, child, len, xlObj = this.XLObj, i = 0, separator = [11, 19], j = 0, str = '', htmlstr = '',
            b = 'w:bold', c1 = 'c:#FFFFFF', c2 = 'c:#000000', c3 = 'c:#2F75B5', c4 = 'c:#ED7D31', c5 = 'c:#FFC000', b1 = '1px solid #000000', b2 = '1px solid #2f75b5', b3 = '1px solid #ED7D31', b4 = '1px solid #FFC000',
            d1 = 'b:#D9D9D9', d2 = 'b:#DDEBF7', d3 = 'b:#FCE4D6', d4 = 'b:#FFF2CC', d5 = 'b:#000000', d6 = 'b:#DBECF6', d7 = 'b:#FFE2C6', d8 = 'b:#FFF1BF', d9 = 'b:#000000', d10 = 'b:#D7D7D7', d11 = 'b:#FFC000', d12 = 'b:#5B9BD5', d13 = 'b:#Ed7D31',
            style = 'hl?' + b + ';' + c2 + ';bo:tb-' + b1 + '&cl?' + d1 + ';' + c2 + ',' + c2 + '&cb?b-' + b1 + '/hl?' + b + ';bo:tb-' + b2 + ';' + c3 + '&cl?' + d2 + ';' + c3 + ',' + c3 + '&cb?b-' + b2 + '/hl?' + b + ';bo:tb-' + b3 + ';' + c4 + '&cl?' + d3 + ';' + c4 + ',' + c4 + '&cb?b-' + b3 + '/hl?' + b + ';bo:tb-' + b4 + ';' + c5 + '&cl?' + d4 + ';' + c5 + ',' + c5 + '&cb?b-' + b4 + '/hl?' + b + ';' + d5 + ';' + c1 + ';bo:o-' + b1 + '&cl?bo:t-' + b1 + ';' + c2 + '&cb?o-' + b1 + '/hl?bo:o-' + b2 + ';' + b + ';' + d12 + ';' + c1 + '&cl?bo:t-' + b2 + ';' + c2 + '&cb?o-' + b2 + '/hl?' + b + ';b:#EB7E2F;' + c1 + ';bo:o-' + b3 + '&cl?bo:t-' + b3 + ';' + c2 + '&cb?o-' + b3 + '/hl?' + b + ';' + d11 + ';' + c1 + ';bo:o-' + b4 + '&cl?bo:t-' + b4 + ';' + c2 + '&cb?o-' + b4 + '/hl?' + b + ';bo:gb-' + b1 + ';' + c2 + '&cl?' + d1 + ';' + c2 + ',' + c2 + '&cb?gb-' + b1 + '/hl?' + b + ';bo:gb-' + b2 + ';' + c2 + '&cl?' + d2 + ';' + c2 + ',' + c2 + '&cb?gb-' + b2 + '/hl?' + b + ';bo:gb-' + b3 + ';' + c2 + '&cl?' + d3 + ';' + c2 + ',' + c2 + '&cb?gb-' + b3 + '/hl?' + b + ';bo:gb-' + b4 + ';' + c2 + '&cl?' + d4 + ';' + c2 + ',' + c2 + '&cb?gb-' + b4 + '/hl?' + b + ';' + d5 + ';' + c1 + '&cl?b:#A6A6A6;' + c2 + ',' + d1 + ';' + c2 + '/hl?' + b + ';' + d12 + ';' + c1 + '&cl?b:#BDD7EE;' + c2 + ',' + d2 + ';' + c2 + '/hl?' + b + ';' + d13 + ';' + c1 + '&cl?b:#F8CBAD;' + c2 + ',' + d3 + ';' + c2 + '/hl?' + b + ';' + d11 + ';' + c1 + '&cl?b:#FFE699;' + c2 + ',' + d4 + ';' + c2 + '/hl?' + b + ';' + d10 + ';' + c2 + ';bo:gb-' + b1 + '&cl?b:#A7A7A7;' + c2 + ',' + d10 + ';' + c2 + '&cb?gb-' + b1 + '/hl?' + b + ';' + d6 + ';' + c2 + ';bo:gb-' + b2 + '&cl?b:#BED8F1;' + c2 + ',' + d2 + ';' + c2 + '&cb?gb-' + b2 + '/hl?' + b + ';' + d7 + ';' + c2 + ';bo:gb-' + b3 + '&cl?b:#F6CAAD;' + c2 + ',' + d7 + ';' + c2 + '&cb?gb-' + b3 + '/hl?' + b + ';' + d8 + ';' + c2 + ';bo:gb-' + b4 + '&cl?b:#FDE18D;' + c2 + ',' + d8 + ';' + c2 + '&cb?gb-' + b4 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#404040;' + c1 + ',b:#737373;' + c1 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#2F75B5;' + c1 + ',' + d12 + ';' + c1 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#C65911;' + c1 + ',' + d13 + ';' + c1 + '/hl?' + b + ';' + d9 + ';' + c1 + '&cl?b:#BF8F00;' + c1 + ',' + d11 + ';' + c1,
            hdrtext = xlObj._getLocStr('FATHeaderText').split('/'),
            title = xlObj._getLocStr('FormatAsTableTitle').split('/'),
            name = ["Light1", "Light2", "Light3", "Light5", "Light8", "Light9", "Light10", "Light12", "Light15", "Light16", "Light17", "Light19", "Medium8", "Medium9", "Medium10", "Medium12", "Medium22", "Medium23", "Medium24", "Medium26", "Dark1", "Dark2", "Dark3", "Dark5"];
            style = style.split('/');
            while (i < 24) {
                str = str + xlObj._renderDIV('e-formatastablecell', '<div class="e-ss-cellstyles-' + (i + 1) + '" ></div>');
                if (i === separator[j]) {
                    str += '</br>';
                    j++;
                }
                i++;
            }
            i = 0, str = str.split('</br>');
            while (i < hdrtext.length * 2) {
                htmlstr += xlObj._renderDIV(i % 2 === 0 ? 'e-formatastableheader' : 'e-formatastablecontent', i % 2 === 0 ? hdrtext[i / 2] : str[0]);
                if(i % 2 != 0)
                    str.shift();
                i++;
            }
            parent = document.getElementById(xlObj._id + '_formatastable');
            parent.innerHTML = htmlstr;
            parent = $(parent);
            child = parent.find('.e-formatastablecell');
            i = 0, len = child.length;
            while (i < len) {
				$(child[i]).attr("id", "Table Style " + name[i]);
                $(child[i]).attr("title", "Table Style " + title[i]);
                i++;
            }
            if (xlObj.XLFormat)
                xlObj.XLFormat._formatAsTableStyle = xlObj._FATStyles['TableStyleLight1'];
            parent.find(".e-formatastableheader:eq(0)").append("<span id ='" + xlObj._id + "_formatastable_back' class = 'e-formatastable-back e-icon e-ss-leftarrow'/>");
            parent.data("ejMenu").model.open = function (args) {
                parent.scrollTop(0);
            };
            return parent;
        },

        _renderFATNameDlg: function () {
            var htmlstr, xlObj = this.XLObj, proptext = xlObj._getLocStr('FATNameDlgText').split('/'), obj = { showRoundedCorner: true, width: "27%", click: $.proxy(this._fatNameDlgBtnClick, this) };
            htmlstr = '<div id=' + xlObj._id + '_fatnamedlg><div class="e-dlg-fields e-dlgctndiv e-ss-nmdlg"><table cellspacing="0" cellpadding="0"><tr><td>' + proptext[0] + '</td><td><input id="' + xlObj._id + '_fatname" class="ejinputtext" /></td></tr><tr class="e-dlgtd-fields"><td></td><td><input type="checkbox" id="' + xlObj._id + '_fatheader" style="background-color:#ffffff"/> <label for="' + xlObj._id + '_fatheader" class="e-ss-fathdr">' + proptext[1] + '</label></td></tr></table></div><div class="e-dlg-btnfields"><div class="e-dlg-btnctnr"><button id=' + xlObj._id + '_fatnamedlgok>' + xlObj._getLocStr('Ok') + '</button><button id=' + xlObj._id + '_fatnamedlgcancel>' + xlObj._getLocStr('Cancel') + '</button></div></div></div>'
            xlObj.element.append(htmlstr);
            $("#" + xlObj._id + "_fatheader").ejCheckBox();
            $('#' + xlObj._id + '_fatnamedlgok').ejButton(obj);
			$('#' + xlObj._id + '_fatnamedlgok').ejButton("option", "cssClass", "e-ss-okbtn");
            $('#' + xlObj._id + '_fatnamedlgcancel').ejButton(obj);
            $('#' + xlObj._id + '_fatnamedlg').ejDialog({ showOnInit: false, width: "auto", showRoundedCorner: true, title: xlObj._getLocStr('FormatAsTable'), enableModal: true, enableResize: false, cssClass: "e-ss-dialog e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this) });
        },

        _renderChartNameDlg: function () {
            var htmlstr, xlObj = this.XLObj, proptext = xlObj._getLocStr('ChartTitleDlgText'), obj = { showRoundedCorner: true, width: "23%", click: $.proxy(this._chartNameDlgBtnClick, this) };
            htmlstr = '<div id=' + xlObj._id + '_chartnamedlg ><div class="e-dlg-fields e-dlgctndiv"><table cellpadding="0" cellspacing="0"><tr><td>' + proptext + '</td><td><input id="' + xlObj._id + '_chartname" class="ejinputtext" /></td></tr></table></div><div class="e-dlg-btnfields"><div class="e-dlg-btnctnr"><button id=' + xlObj._id + '_chartnamedlgok >' + xlObj._getLocStr('Ok') + '</button><button id=' + xlObj._id + '_chartnamedlgcancel>' + xlObj._getLocStr('Cancel') + '</button></div></div>';
            xlObj.element.append(htmlstr);
            $('#' + xlObj._id + '_chartnamedlgok').ejButton(obj);
			$('#' + xlObj._id + '_chartnamedlgok').ejButton("option", "cssClass", "e-ss-okbtn");
            $('#' + xlObj._id + '_chartnamedlgcancel').ejButton(obj);
            $('#' + xlObj._id + '_chartnamedlg').ejDialog({ showOnInit: false, width: "334px", minHeight: "auto", showRoundedCorner: true, title: xlObj._getLocStr('ChartTitle'), enableModal: true, enableResize: false, cssClass: "e-ss-dialog e-"+xlObj._id+"-dlg", close: ej.proxy(this._dialogClose, this) });
        },

        _renderFATResizeTableDlg: function () {
            var xlObj = this.XLObj, obj = { showRoundedCorner: true, width: "15%", click: $.proxy(this._fatResizeTableBtnClick, this) },
            htmlstr = '<div id=' + xlObj._id + '_fatresizetabledlg ><div class="e-dlgctndiv"><table><tr><td>' + xlObj._getLocStr('FATResizeTableText') + '</td><td style="width: 50%;"><input id="' + xlObj._id + '_fatresizetablerange" class="ejinputtext" style="margin-left: 2px;"></td></tr></table><div class="e-dlg-fields">' + xlObj._getLocStr('FATReizeTableNote') + '</div></div><div class="e-dlg-btnfields"><div class="e-dlg-btnctnr"><button id=' + xlObj._id + '_fatresizetabledlgok >' + xlObj._getLocStr('Ok') + '</button><button id=' + xlObj._id + '_fatresizetabledlgcancel >' + xlObj._getLocStr('Cancel') + '</button></div></div></div>';
            xlObj.element.append(htmlstr);
            $('#' + xlObj._id + '_fatresizetabledlgok').ejButton(obj);
			$('#' + xlObj._id + '_fatresizetabledlgok').ejButton("option", "cssClass", "e-ss-okbtn");
            $('#' + xlObj._id + '_fatresizetabledlgcancel').ejButton(obj);
            $('#' + xlObj._id + '_fatresizetabledlg').ejDialog({ showOnInit: false, width: "494px", showRoundedCorner: true, title: xlObj._getLocStr('ResizeTable'), enableModal: true, enableResize: false, cssClass: "e-ss-dialog e-"+xlObj._id+"-dlg", close: ej.proxy(this._dialogClose, this) });
        },


        _fatResizeTableBtnClick: function (args) {
            var xlObj = this.XLObj, alertText, rrange = document.getElementById(xlObj._id + '_fatresizetablerange').value, dataSrcIdx, sheetIndex = xlObj.getActiveSheetIndex();
            var tid = document.getElementById(xlObj._id + '_tableid').value, tmgr = xlObj.getSheet(sheetIndex).tableManager, totRow, range,
            details = { sheetIndex: sheetIndex, reqType: "format-table", action: "Design_Tools_ResizeTable", tableId: tid }, canclose = true;
            if (args.model.text === xlObj._getLocStr('Ok')) {
                if (!xlObj._isvalidRange(rrange)) {
                    canclose = false;
                    xlObj._showAlertDlg("Alert", "InvalidReference", "", 375);
                }
                else {
                    rrange = rrange.indexOf(':') != -1 ? xlObj.getRangeIndices(rrange) : [];
                    alertText = this._validateResizeRange(rrange, tmgr[tid].range);
                    if (!alertText) {
                        details.beforeRange = $.extend(true, [], tmgr[tid].range);
                        if (tmgr[tid].totalRow) {
                            totRow = $("#" + xlObj._id + "_Ribbon_Design_TableStyleOptions_TotalRow").data("ejCheckBox");
                            xlObj._dupDetails = true;
                            totRow.option("checked", false);
                            tmgr[tid].range = [rrange[0], rrange[1], rrange[2] - 1, rrange[3]];
                        }
                        else
                            tmgr[tid].range = rrange;
                        this._isFilterSelect.isFiltered && xlObj.XLFilter._clearFilterTable(sheetIndex, parseInt(tid), true);
                        xlObj.XLFormat._createTable(tid, { format: tmgr[tid].format });
                        xlObj.XLFilter._extendFilterRange(tid, tmgr[tid].range);
                        if (tmgr[tid].range[2] == rrange[2] - 1) {
                            xlObj._dupDetails = true;
                            totRow.option("checked", true);
                        }
                        if (tmgr[tid].firstColumn) {
                            xlObj._dupDetails = true;
                            range = xlObj._getProperAlphaRange(sheetIndex, tmgr[tid].range[0] + 1, tmgr[tid].range[1], tmgr[tid].range[2], tmgr[tid].range[1]);
                            xlObj.XLFormat.format({ style: { 'font-weight': 'bold' } }, range);
                            xlObj._dupDetails = false;
                        }
                        if (tmgr[tid].lastColumn) {
                            xlObj._dupDetails = true;
                            range = xlObj._getProperAlphaRange(sheetIndex, tmgr[tid].range[0] + 1, tmgr[tid].range[3], tmgr[tid].range[2], tmgr[tid].range[3]);
                            xlObj.XLFormat.format({ style: { 'font-weight': 'bold' } }, range);
                            xlObj._dupDetails = false;
                        }
                        details.afterRange = rrange;
                        details.format = tmgr[tid].format;
                        details.formatName = tmgr[tid].formatName;
                        details.header = $.extend(true, {}, xlObj.model.sheets[sheetIndex]._header);
                        details.isFilter = tmgr[tid].isFilter;
                        details.firstColumn = tmgr[tid].firstColumn;
                        details.lastColumn = tmgr[tid].lastColumn;
                        details.totalRow = tmgr[tid].totalRow;
                        xlObj.XLSelection.selectRange( tmgr[tid].range );
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                    else
                        xlObj._showAlertDlg("Alert", alertText, "", 500);
                }
            }
            if(canclose)
                $('#' + xlObj._id + '_fatresizetabledlg').ejDialog('close');
        },

        _fatNameDlgBtnClick: function (args) {
            var obj, xlObj = this.XLObj, sid = xlObj._id;
            $('#' + sid + '_fatnamedlg').ejDialog('close');
            if (args.model.text === xlObj._getLocStr('Ok')) {
                obj = { header: $("#" + sid + "_fatheader").ejCheckBox("checked"), name: document.getElementById(sid + '_fatname').value, format: xlObj.XLFormat._formatAsTableStyle.format };
                if(xlObj.XLFormat._formatAsTableStyle.formatName)
                    obj["formatName"] = xlObj.XLFormat._formatAsTableStyle.formatName;
                xlObj.XLFormat.createTable(obj);
            }
        },

        _validateResizeRange: function (rrange, trange) {
            var xlObj = this.XLObj;
            if (rrange.length) {
                if (rrange[0] != trange[0] || rrange[1] != trange[1])
                    return "ResizeAlert";
                else if (rrange[3] != trange[3] || rrange[2] < trange[2])
                    return "ResizeRestrictAlert";
                else if (rrange[2] > xlObj.getSheet(xlObj.getActiveSheetIndex()).rowCount)
                    return "RangeNotCreated"
            }
            else
                return "InvalidReference";
        },

        _chartNameDlgBtnClick: function (args, title, action) {
            var cObj, details, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), dataVal = xlObj.getSheet(sheetIdx).shapeMngr.chart[xlObj.XLEdit.getPropertyValue(xlObj.XLShape._picCellIdx.rowIndex, xlObj.XLShape._picCellIdx.colIndex, 'chart')[0]], cname, sid = xlObj._id, cid = document.getElementById(sid + '_chart').value;
            cObj = $("#" + cid).data("ejChart");
            details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex, prev: {}, cur: {} };
            cname = title || document.getElementById(sid + '_chartname').value;
            if (args.model.text === xlObj._getLocStr('Ok')) {
                if (!cname.length) {
                    xlObj._showAlertDlg("Alert", "InvalidTitle", "InvalidChartTitleActn", 375);
                    return;
                }
                switch (xlObj._hasTitle) {
                    case "PX":
                        cObj.option("primaryXAxis", { title: { text: cname } });
                        dataVal.xAxis.title.text = cname;
                        details.action = "PX";
                        details.operation = action ? action : "PHAxisTitle";
                        break;
                    case "PY":
                        cObj.option("primaryYAxis", { title: { text: cname } });
                        dataVal.yAxis.title.text = cname;
                        details.action = "PY";
                        details.operation = action ? action : "PVAxisTitle";
                        break;
                    case "CT":
                        cObj.option("title", { text: cname });
                        dataVal.title.text = cname;
                        details.action = details.operation = "CT";
                        break;
                }
            }
            details.prev.text = xlObj._cOpt.prevText;
            if (xlObj._hasTitle == "CT") {
                details.prev.align = xlObj._cOpt.prevAlign;
                details.cur.align = xlObj._cOpt.curAlign;
            }
            details.cur.text = cname;
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
            xlObj._cOpt = {};
            document.getElementById(sid + '_chartname').value = "";
            $('#' + sid + '_chartnamedlg').ejDialog('close');
        },

        _designTabUpdate: function (tid, cellIdx) {
            var xlObj = this.XLObj;
            if (xlObj.model.showRibbon && !xlObj._phoneMode) {
                var xlId = xlObj._id, btnObj, robj = $('#' + xlObj._id + '_Ribbon').ejRibbon('instance'), tmgr = xlObj.getSheet(xlObj.getActiveSheetIndex()).tableManager;
                robj.showTab(xlObj._getLocStr('Design'));
                if(this._isDesignTab && !robj._isCollapsed)
                    robj.option({ selectedItemIndex: this._getTabIndex("design") });
                document.getElementById(xlObj._id + '_Ribbon_Design_Properties_TableName') && (document.getElementById(xlObj._id + '_Ribbon_Design_Properties_TableName').value = tmgr[tid].name);
                document.getElementById(xlObj._id + '_tableid') && (document.getElementById(xlObj._id + '_tableid').value = tid);
                this._isSetModel = true;
                $("#" + xlId + "_Ribbon_Design_TableStyleOptions_TotalRow").data("ejCheckBox").option({ checked: (tmgr[tid]["totalRow"] ? true : false) });
                $("#" + xlId + "_Ribbon_Design_TableStyleOptions_FirstColumn").data("ejCheckBox").option({ checked: (tmgr[tid]["firstColumn"] ? true : false) });
                $("#" + xlId + "_Ribbon_Design_TableStyleOptions_LastColumn").data("ejCheckBox").option({ checked: (tmgr[tid]["lastColumn"] ? true : false) });
				$("#" + xlId + "_Ribbon_Design_TableStyleOptions_FilterColumn").data("ejCheckBox").option({ enabled : xlObj.model.allowFiltering ? true : false });
                $("#" + xlId + "_Ribbon_Design_TableStyleOptions_FilterColumn").data("ejCheckBox").option({ checked: (tmgr[tid]["isFilter"] ? true : false) });
                this._isSetModel = false;
                btnObj = $("#" + xlObj._id + "_Ribbon_Data_SortFilter_ClearFilter").data("ejButton");
                if (btnObj)
                this._changeClrFltrStatus(btnObj, "button", cellIdx);
            }
        },

        _formatTabUpdate: function () {
            var xlObj = this.XLObj;
            if (xlObj.model.showRibbon && !xlObj._phoneMode) {
                var robj = $("#" + xlObj._id + "_Ribbon").ejRibbon("instance"), heightElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Format_Size_PictureHeight"), widthElem =  xlObj.element.find("#" + xlObj._id + "_Ribbon_Format_Size_PictureWidth");
                robj.showTab(xlObj._getLocStr("FORMAT"));
                xlObj._shapeChange = true;
                heightElem.length && heightElem.ejNumericTextbox("option", "value", xlObj.element.find(".e-ss-activeimg").height());
                widthElem && widthElem.ejNumericTextbox("option", "value", xlObj.element.find(".e-ss-activeimg").width());
                if (xlObj.model.showRibbon && !robj._isCollapsed)
                    robj.option({ selectedItemIndex: xlObj.XLRibbon._getTabIndex("format") });
                xlObj._shapeChange = false;
            }
        },

        _analyzeTabUpdate: function () {
            var xlObj = this.XLObj, elem, ribObj;
            if (!xlObj.model.enablePivotTable)
                return false;
            elem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Analyze_PivotTable_PivotTableName");
			ribObj = $("#" + xlObj._id + "_Ribbon").data("ejRibbon");
            elem.length && elem.val(xlObj.XLPivot.names[xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id]);
            ribObj.showTab(xlObj._getLocStr("ANALYZE"));
			if (!ribObj._isCollapsed)
				ribObj.option({ selectedItemIndex: xlObj.XLRibbon._getTabIndex("analyze") });
        },

        _chartDesignTabUpdate: function (chartElem) {
            var xlObj = this.XLObj, index;
            if (xlObj.model.showRibbon && !xlObj._phoneMode) {
                var robj = $('#' + xlObj._id + '_Ribbon').data('ejRibbon'), cid = chartElem.get(0).id, left = chartElem.get(0).offsetLeft, top = chartElem.get(0).offsetTop, cModel = chartElem.ejChart("model"),  themesElem = robj.element.find("#" + xlObj._id + "_Ribbon_ChartDesign_ChartThemes_ChartThemes");
                index = xlObj._getIdxWithOffset(top, left, true);
                xlObj.XLShape._picCellIdx = { rowIndex: index.rowIdx, colIndex: index.colIdx };
                robj.showTab(xlObj._getLocStr("CHARTDESIGN"));
                if (!robj._isCollapsed)
                    robj.option({ selectedItemIndex: xlObj.XLRibbon._getTabIndex("chartdesign") });
                document.getElementById(xlObj._id + '_chart').value = cid;
                this._isSetModel = true;
                this._setShapeWidthHeight({ height: cModel.size.height, width: cModel.size.width, shapeType: "chart" });
                themesElem.length && themesElem.ejDropDownList("setSelectedValue", chartElem.ejChart("option", "theme"));
                this._isSetModel = false;
                if (xlObj.model.allowFormulaBar)
                    xlObj.updateFormulaBar();
            }
        },

        _setShapeWidthHeight: function (options) {
            var xlObj = this.XLObj, wNum, hNum;
            if (options.shapeType == "chart") {
                wNum = $("#" + xlObj._id + "_Ribbon_ChartDesign_Size_ChartWidth").data("ejNumericTextbox");
                hNum = $("#" + xlObj._id + "_Ribbon_ChartDesign_Size_ChartHeight").data("ejNumericTextbox");
            }
            else {
                wNum = $("#" + xlObj._id + "_Ribbon_Format_Size_PictureWidth").data("ejNumericTextbox");
                hNum = $("#" + xlObj._id + "_Ribbon_Format_Size_PictureHeight").data("ejNumericTextbox");
            }
            xlObj._shapeChange = true;
            if (xlObj.model.showRibbon) {
                hNum.option({ value: options.height });
                wNum.option({ value: options.width });
            }
            xlObj._shapeChange = false;
        },

        changeDimension: function (options) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), actImg, elem, opt, details, chartEle, picElem, details = { sheetIndex: sheetIdx, reqType: "shape", rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex, actionType: "shapechange" }, cObj;
            if (options.shapeType == "picture") {
                actImg = xlObj.getSheetElement(sheetIdx).find('.e-ss-activeimg');
                picElem = actImg.length ? actImg[0] : $('#' + options.id);
                details.prev = { width: picElem.width(), height: picElem.height() }
                elem = $("#" + options.id); opt = { width: options.width, height: options.height };
                elem.css(opt);
                details.action = "picturesize";
                details.shapeType = "picture";
                details.cur = { width: picElem.width(), height: picElem.height() };
            }
            else {
                cObj = $("#" + options.id).data('ejChart');
                details.prev = { width: cObj.model.size.width, height: cObj.model.size.height };
                opt = { width: options.width.toString(), height: options.height.toString() };
                chartEle = cObj.element;
                cObj.option("size", opt);
                chartEle[0].style.height = options.height + "px";
                chartEle[0].style.width = options.width + "px";
                details.action = "width";
                details.shapeType = "chart";
                details.cid = options.id;
                details.cur = { width: cObj.model.size.width, height: cObj.model.size.height };
            }
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
            this._setShapeWidthHeight(options);
        },

        _toggleDesignTab: function (cellObj) {
            var xlObj = this.XLObj, btnObj, rObj, sheetIdx = xlObj.getActiveSheetIndex();
			if(xlObj.model.showRibbon) {
				rObj = $('#' + xlObj._id + '_Ribbon').data("ejRibbon");
				if (ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(cellObj.rowIndex, cellObj.colIndex, "tableName")) || xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg").length) {
					rObj.hideTab(xlObj._getLocStr('Design'));
					if(!rObj._isCollapsed)
						rObj.option({ selectedItemIndex: 1 });
				}
			}
			btnObj = $("#" + xlObj._id + "_Ribbon_Data_SortFilter_ClearFilter").data("ejButton");
            this._changeClrFltrStatus(btnObj, "button", cellObj);
        },

        _toggleChartDesignTab: function () {
            this._toggleContextualTab(this.XLObj._getLocStr("CHARTDESIGN"));
        },

        _toggleFormatTab: function () {
            this._toggleContextualTab(this.XLObj._getLocStr("FORMAT"));
        },

        _toggleAnalyzeTab: function () {
            this._toggleContextualTab(this.XLObj._getLocStr("ANALYZE"));
        },

		_toggleContextualTab: function(tabName) {
			var xlObj = this.XLObj;
            if (xlObj.model.showRibbon) {
                var rObj = $('#' + xlObj._id + '_Ribbon').data("ejRibbon");
                rObj.hideTab(tabName);
                if (!rObj._isCollapsed)
                    rObj.option({ selectedItemIndex: 1 });
            }
		},
		
        _getTabIndex: function (name) {
            if (!this.XLObj.model.showRibbon)
                return;
            var model = $('#' + this.XLObj._id + '_Ribbon').ejRibbon("model"), tabs = model.tabs, ctabs = model.contextualTabs, i = 0;
            while (i < ctabs.length) {
                tabs = tabs.concat(ctabs[i].tabs);
                i++;
            }
            i = tabs.length;
            while (i--)
                if (tabs[i].id === name) return ++i;
        },

        _getFormatAsTableInput: function (str) {
            var xlObj = this.XLObj, str1, str2, istr, cstr, i = 0, j = 0, arr = [], abbr = { hl: 'headerLayout', cl: 'contentLayout', hb: 'headerBorder', cb: 'contentBorder' }, obj = {};
            str = str.split('&'); // for layout input
            while (i < str.length) {
                istr = str[i].split('?'); // to separate headerlayout: '' like that
                str1 = istr[0], str2 = istr[1];
                if (str1 === 'hl')
                    obj[abbr[str1]] = xlObj._getStyleAsJSON(str2, true);
                else if (str1 === 'cl') {
                    cstr = str2.split(','); // for multiple content layout
                    while (j < cstr.length) {
                        arr.push(cstr[j].length ? xlObj._getStyleAsJSON(cstr[j], true) : {});
                        j++;
                    }
                    obj[abbr[str1]] = arr;
                }
                else if (str1 === 'cb') {
                    cstr = str2.split('-'); // for border
                    obj[abbr[str1]] = { border: this._getBorderObj(cstr[0], cstr[1]) };
                }
                i++;
            }
            return obj;
        },

        _getBorderObj: function (prop, value) {
            var i, border = { t: { top: '' }, r: { right: '' }, b: { bottom: '' }, l: { left: '' }, o: { top: '', right: '', bottom: '', left: '' }, tb: { top: '', bottom: '' }, gb: { top: '', right: '', bottom: '', left: '' } };
            for (i in border[prop])
                border[prop][i] = value;
            if (prop === 'gb')
                border[prop]["isGridBorder"] = true;
            return border[prop];
        },

        // Cell Style Feature
        _renderCellStyles: function () {
            var indx, txt, i = 0, index = 4, cdiv = [], cls = 'e-cellstylecell ', str = '', xlObj = this.XLObj, fcoll = xlObj._dataContainer.hashCode,
                cstylehdrtext = xlObj._getLocStr('CellStyleHeaderText').split('/'), gbntext = xlObj._getLocStr('CellStyleGBN').split('/'),
                gbnformat = [fcoll[0], fcoll[1], fcoll[2], fcoll[3]], thtext = xlObj._getLocStr('CellStyleTH').split('/'), thformat = fcoll.slice(4, 6),
                tcstext = xlObj._getLocStr('CellsStyleTCS').split('/'), tcsformat = fcoll.slice(6, 18);
            while (i < index) {
                txt = gbntext[i];
                str = str + xlObj._renderDIV(cls + gbnformat[i], txt, txt);
                i++;
            }
            cdiv.push(str), str = '', i = 0, index = 2;
            while (i < index) {
                txt = thtext[i];
                if (i === 1)
                    str = str + '<div class="' + cls + thformat[i] + '"  style="font-size: 11pt;" title="' + txt + '">' + txt + '</div>';
                else
                    str = str + xlObj._renderDIV(cls + thformat[i], txt, txt);
                i++;
            }
            cdiv.push(str), str = '', i = 0, index = 12;
            while (i < index) {
                txt = tcstext[i];
                str = str + xlObj._renderDIV(cls + tcsformat[i], txt, txt);
                i++;
            }
            cdiv.push(str), str = '', i = 0;
            while (i < cstylehdrtext.length * 2) {
                indx = i % 2;
                str = str + xlObj._renderDIV(indx === 0 ? 'e-cellstyleheader' : 'e-cellstylecontent', indx === 0 ? cstylehdrtext[i / 2] : cdiv[0]);
                if (indx != 0)
                    cdiv.shift();
                i++;
            }
            var parent = $('<div id=' + xlObj._id + '_cellstyles class="e-spreadsheet e-cellstyles" style="display:none;">' + str + '</div>');
            parent.find(".e-cellstyleheader:eq(0)").append("<span id ='" + xlObj._id + "_cellstyles_back' class = 'e-cellstyles-back e-icon e-ss-leftarrow'/>");
            return parent;
        },

        _homeTabTrgtElem: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, rbnId = xlId + "_Ribbon_", fontElem = rbnId + "Home_Font_";
            xlEle.append(ej.buildTag("input", "", { display: "none" }, { id: fontElem + "FillColor", type: "text" }));
            xlEle.append(ej.buildTag("input", "", { display: "none" }, { id: fontElem + "FontColor", type: "text" }));
            xlEle.append(ej.buildTag("input", "", { display: "none" }, { id: fontElem + "BorderColor", type: "text" }));
            xlEle.append(ej.buildTag("div.e-spreadsheet e-formatastable", "", { display: "none" }, { id: xlObj._id + "_formatastable" }));
            xlEle.append(this._renderCellStyles());
            xlEle.append(ej.buildTag("ul", "", { display: "none" }, { id: xlId + "_Ribbon_Merge" }));
            xlEle.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: rbnId + "Paste" }));
            xlEle.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: rbnId + "Border" }));
            xlEle.append(ej.buildTag("ul.e-spreadsheet", "", { display: "none" }, { id: xlId + "_CFormat" }));
            xlEle.append(ej.buildTag("ul", "", { display: "none" }, { id: rbnId + "Clear" }));
            xlEle.append(ej.buildTag("ul", "", { display: "none" }, { id: rbnId + "SortFilter" }));
            xlEle.append(ej.buildTag("ul", "", { display: "none" }, { id: rbnId + "AutoSum" }));
        },
        _pageTabTrgtElem: function (ribbonElem) {
            var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, pagesetupdiv, pagesetupleftdiv, table, td1, td2, td11, td, tr, tr1, td12,  gdlnviewlbl, hdrviewlbl, headerVchk, gridVchk, rbnId = xlId + "_Ribbon_", pageId = rbnId + "PageLayout_Show_";
            ribbonElem = xlObj.isUndefined(ribbonElem) ? $("#" + xlId + "_Ribbon").data("ejRibbon").element : ribbonElem;
            xlEle.append(ej.buildTag("ul", "", { display: "none" }, { id: rbnId + "PageSize" }));
            pagesetupdiv = ej.buildTag("div", "", { width: "140", height: "80", display: "none" }, { id: rbnId + "pagesetup" });
            pagesetupleftdiv = ej.buildTag("div", "", { width: "70", height: "80", "float": "left" }, { id: rbnId + "pagesetupleft" });
            table = ej.buildTag("table"); tr = ej.buildTag("tr"); tr1 = ej.buildTag("tr"); td1 = ej.buildTag("td", "", { padding: "6px 0px 6px 6px" }); td2 = ej.buildTag("td", "", { padding: "6px 0px 6px 6px" }); td11 = ej.buildTag("td", "", { padding: "6px 0px 6px 6px" }); td12 = ej.buildTag("td", "", { padding: "6px 0px 6px 6px" });
            gdlnviewlbl = ej.buildTag("label.e-viewlinlbl", "", { width: "40" }, { id: rbnId + "pagesetup_viewgrdlnlbl", "for": pageId + "Gridlines" });
            hdrviewlbl = ej.buildTag("label.e-viewhdrlbl", "", { width: "40", display: "visible" }, { id: rbnId + "pagesetup_viewhdrlbl", "for": pageId + "Headings" });
            headerVchk = ej.buildTag("input", "", "", { id: pageId + "Headings" });
            gridVchk = ej.buildTag("input", "", "", { id: pageId + "Gridlines" });
            td1.append(gridVchk);
            td2.append(gdlnviewlbl);
            tr.append(td1).append(td2);
            td11.append(headerVchk);
            td12.append(hdrviewlbl);
            tr1.append(td11).append(td12);
            table.append(tr1).append(tr);
            pagesetupleftdiv.append(table);
            pagesetupdiv.append(pagesetupleftdiv);
            ribbonElem.append(pagesetupdiv);
        },
        _othersTabTrgtElem: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, rbnId = xlId + "_Ribbon_";
            xlEle.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: rbnId + "FPane" }));
            xlEle.append(ej.buildTag("ul", "", { width: "auto" }, { id: rbnId + "Ins" }));
            xlEle.append(ej.buildTag("ul", "", { width: "auto" }, { id: rbnId + "Del" }));
            xlEle.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: rbnId + "FindRep" }));
            xlEle.append(ej.buildTag("ul", "", { display: "none" }, { id: rbnId + "CalcOpt" }));
        },
        _dataTabTrgtElem: function () {
            var xlObj = this.XLObj;
            xlObj.element.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: xlObj._id + "_Ribbon_Validation" }));
        },
        _formatTabTrgtElem: function () {
            var xlObj = this.XLObj;
            xlObj.element.append(ej.buildTag("ul", "", { width: "auto", display: "none" }, { id: xlObj._id + "_Ribbon_ResetPic" }));
        },

        _onBeforeTabClick: function (args) {
            this.XLObj.model.ribbonSettings.enableOnDemand && this._createTrgtElement(args.activeHeader.innerText);            
        },

        _onTabClick: function (args) {
            var xlObj = this.XLObj, settings = $.extend(true, {}, xlObj.model.scrollSettings), tabName = args.activeHeader.innerText;
            xlObj._trigger("beforeTabClick", args);
            args.prevActiveIndex !== -1 && xlObj.model.allowComments && xlObj.model.allowEditing && (xlObj.XLEdit._isEdit || xlObj.XLComment._isCommentEdit || xlObj._isSheetRename || !xlObj.getSheet(xlObj.getActiveSheetIndex()).isSheetProtected) && !this._isDirtySelect && this._enableRibbonIcons(args.activeIndex);
            xlObj.model.ribbonSettings.enableOnDemand && this._createTabControls(tabName);
            xlObj._trigger("tabClick", args);
        },

        _onCollapse: function (args, e) {
            var xlObj = this.XLObj, settings = $.extend(true, {}, xlObj.model.scrollSettings);
			if(this._ribbonState || args.isMobile) {
			    !xlObj._phoneMode && (this._ribbonState = false);
				args.action = "toggleBtn";
				if (xlObj._isAutoWHMode) {
				    this._refreshBackstageHeight();
				    var dimension = xlObj._getElementDimension();
				    xlObj.element.css({ height: dimension.height, width: dimension.width });
				}
				else
				    xlObj._heightWidthCalculation(xlObj.getActiveSheetIndex(), settings, args);
				xlObj.model._isActPanelVisible && xlObj._refreshActivationPanel();
				xlObj.getSheet(xlObj.getActiveSheetIndex())._isRibCollapsed = true;
			}
        },

        _onTabSelect: function (args) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex());
            if (xlObj.model.showRibbon) {
                if (xlObj.XLEdit._isEdit || (xlObj.model.allowComments && xlObj.XLComment._isCommentEdit) || xlObj._isSheetRename || sheet.isSheetProtected)
                    this._disableRibbonIcons();
                else
                    this._enableRibbonIcons();
                this._updateRibbonIcons();
                if (xlObj.model.isReadOnly)
                    xlObj._readOnly();
                if (xlObj._phoneMode) {
                    var settings = $.extend(true, {}, xlObj.model.scrollSettings);
                    this._ribbonState = true;
                    args.action = "toggleBtn";
                    xlObj.model._isActPanelVisible = this._isPanelVisible;
                    if (xlObj._isAutoWHMode) {
                        this._refreshBackstageHeight();
                        var dimension = xlObj._getElementDimension();
                        xlObj.element.css({ height: dimension.height, width: dimension.width });
                    }
                    else
                        xlObj._heightWidthCalculation(xlObj.getActiveSheetIndex(), settings, args);
                }
            }
            if (xlObj.XLEdit.getPropertyValue(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, "tableName"))
                this._isDesignTab = (args.activeIndex == this._getTabIndex("design") || args.activeIndex == this._getTabIndex("format") || args.activeIndex == this._getTabIndex("chartdesign"));
            xlObj._trigger("tabSelect", args);
        },

        _valDTypeOnChange: function (args) {
            var xlObj = this.XLObj;
            if ($.validator)
                $("#" + xlObj._id + "_Form_ValDialog").validate().resetForm();
            if (args.value === "Between" || args.value === "NotBetween") {
                $("#" + xlObj._id + "_Ribbon_lbMax").show();
                $("#" + xlObj._id + "_Ribbon_btnMax").show();
                $("#" + xlObj._id + "_Ribbon_lbMin").text(xlObj._getLocStr("NumberStart"));
            }
            else {
                $("#" + xlObj._id + "_Ribbon_lbMax").hide();
                $("#" + xlObj._id + "_Ribbon_btnMax").hide();
                $("#" + xlObj._id + "_Ribbon_lbMin").text(xlObj._getLocStr("DataValue"));
            }
            this._dialogValidate("_ValDialog");
        },

        _valTypeOnChange: function (args) {
            var xlObj = this.XLObj, actionObj = $("#" + xlObj._id + "_Ribbon_ddAction").data("ejDropDownList");
            actionObj.enable();
            if (args.value === "List") {
                $("#" + xlObj._id + "_Ribbon_lbMax").hide();
                $("#" + xlObj._id + "_Ribbon_btnMax").hide();
                actionObj.disable();
            }
            else if (actionObj._selectedValue === "Between" || actionObj._selectedValue === "NotBetween") {
                $("#" + xlObj._id + "_Ribbon_lbMax").show();
                $("#" + xlObj._id + "_Ribbon_btnMax").show();
            }
            $("#" + xlObj._id + "_Ribbon_lbMin").text(xlObj._getLocStr(args.selectedText + "Start"));
            $("#" + xlObj._id + "_Ribbon_lbMax").text(xlObj._getLocStr(args.selectedText + "End"));
            this._dialogValidate("_ValDialog");
        },

        _valDlgBtnClick: function (id, args) {
            var xlObj = this.XLObj, alertdlg, sheetIdx;
            if (id === "ok" && $.validator && $("#" + xlObj._id + "_Form_ValDialog").valid()) {
                var cbObj = $("#" + xlObj._id + "_Ribbon_blank").data("ejCheckBox");
                var showErrorAlert = $("#" + xlObj._id + "_Ribbon_freetext").data("ejCheckBox").isChecked();
                var typeObj = $("#" + xlObj._id + "_Ribbon_ddType").data("ejDropDownList");
                var actionObj = $("#" + xlObj._id + "_Ribbon_ddAction").data("ejDropDownList");
                if (typeObj._selectedValue === "List") {
                    var value = $("#" + xlObj._id + "_Ribbon_btnMin").val(), val = value, splitStr, range, alertdlg = $("#" + xlObj._id + "_alertdlg"), getSheet;
                    if (value.indexOf("=") > -1) {
                        value = value.split("=")[1];
                        if (value.indexOf("!") > -1) {
                            splitStr = value.split("!");
                            sheetIdx = xlObj._getSheetIndexByName(splitStr[0]);
                            value = splitStr[1];
                        }
                        if (sheetIdx === false) {
                            xlObj._renderAlertDlgContent(alertdlg, "Alert", xlObj._getLocStr("ListAlert"), "ListValidation");
                            xlObj._alertDialog.element.ejDialog("open") && alertdlg.focus();
                            return;
                        }
                        value.indexOf("$") > -1 && (value = value.split("$").join(""));
                        value.indexOf(":") < 0 && (value = value + ":" + value);
                        sheetIdx = xlObj.isUndefined(sheetIdx) ? xlObj.getActiveSheetIndex() : sheetIdx;
                        getSheet = xlObj.getSheet(sheetIdx);
                        range = xlObj.getRangeIndices(value);
                        if (isNaN(range[0]) || isNaN(range[1]) || isNaN(range[2]) || isNaN(range[3]) || getSheet.colCount <= range[3] || getSheet.rowCount <= range[2]) {
                            xlObj._renderAlertDlgContent(alertdlg, "Alert", xlObj._getLocStr("ListAlert"), "ListValidation");
                            xlObj._alertDialog.element.ejDialog("open") && alertdlg.focus();
                            return;
                        }
                        if (range[2] === range[0] || range[3] === range[1]) {
                            xlObj.XLValidate.applyDVRules(null, ["list", val], this._types[typeObj.selectedIndexValue].value, cbObj.isChecked(), showErrorAlert);
                        }
                        else {
                            xlObj._renderAlertDlgContent(alertdlg, "Alert", xlObj._getLocStr("ListValAlert"), "ListValidation");
                            xlObj._alertDialog.element.ejDialog("open") && alertdlg.focus();
                            return;
                        }
                    }
                    else
                        xlObj.XLValidate.applyDVRules(null, ["list", val], this._types[typeObj.selectedIndexValue].value, cbObj.isChecked(), showErrorAlert);
                }
                else
                    xlObj.XLValidate.applyDVRules(null, [this._actions[actionObj.selectedIndexValue].value, $("#" + xlObj._id + "_Ribbon_btnMin").val(), $("#" + xlObj._id + "_Ribbon_btnMax").val()], this._types[typeObj.selectedIndexValue].value, cbObj.isChecked(), showErrorAlert);
                xlObj._setddlCell();
            }
            else if (!$.validator)
                id = "cancel";
            if (id === "cancel" || (id === "ok" && $.validator && $("#" + xlObj._id + "_Form_ValDialog").valid())) {
                $("#" + xlObj._id + "_Ribbon_ddType").data("ejDropDownList").option({ selectedItemIndex: 0 });
                $("#" + xlObj._id + "_Ribbon_ddAction").data("ejDropDownList").option({ selectedItemIndex: 6 });
                $("#" + xlObj._id + "_Ribbon_blank").data("ejCheckBox").option({ checked: true });
                $("#" + xlObj._id + "_Ribbon_freetext").data("ejCheckBox").option({ checked: true });
                $("#" + xlObj._id + "_Ribbon_btnMin").val("");
                $("#" + xlObj._id + "_Ribbon_btnMax").val("");
                $("#" + xlObj._id + "_ValDialog").ejDialog("close");
                xlObj.setSheetFocus();
            }
        },

        _renderValDialog: function () {
            var xlObj = this.XLObj;
            if ($("#" + xlObj._id + "_Ribbon_MainDiv").length < 1) {
                var $stgctnr = ej.buildTag("div.e-dlgctndiv", "", {}, {height: "100%"}), $mainDiv = ej.buildTag("div.e-dlg-fields", "", {}, { id: xlObj._id + "_Ribbon_MainDiv" }), $subDiv;
                $("#" + xlObj._id + "_Validation").append($stgctnr);
                $("#" + xlObj._id + "_Validation").append($mainDiv);
                var $label = ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("Allow"));
                $mainDiv.append($label);
                var $ddType = ej.buildTag("input.e-"+xlObj._id + "-ddl", "", "", { id: xlObj._id + "_Ribbon_ddType", type: "text" });
                $mainDiv.append($ddType);
                $ddType.ejDropDownList({
                    dataSource: this._types,
                    fields: { id: "Types", text: "text", value: "text" }, selectedItemIndex: 1,
                    cssClass: "e-" + xlObj._id + "-ddl",
                    width: "100%",
                    change: $.proxy(this._valTypeOnChange, this)
                });
                var $chkinput = ej.buildTag("input#" + xlObj._id + "_Ribbon_blank");
                var $chklabel = ej.buildTag("label", xlObj._getLocStr("IgnoreBlank"), {}, { "for": xlObj._id + "_Ribbon_blank" });
                var table = ej.buildTag("table");
                var tr = ej.buildTag("tr");
                var td = ej.buildTag("td", "", {}, {width: 30});
                td.append($chkinput);
                tr.append(td);
                td = ej.buildTag("td");
                td.append($chklabel);
                tr.append(td);
                table.append(tr);
                $chkinput.ejCheckBox();
                $chkinput = ej.buildTag("input#" + xlObj._id + "_Ribbon_freetext");
                $chklabel = ej.buildTag("label#" + xlObj._id + "_Ribbon_lblfreetext", xlObj._getLocStr("FreeText"), {}, { "for": xlObj._id + "_Ribbon_lblfreetext" });
                var tr = ej.buildTag("tr#" + xlObj._id + "_val_freetext");
                td = ej.buildTag("td", "", {}, {width: 30});
                td.append($chkinput);
                tr.append(td);
                td = ej.buildTag("td");
                td.append($chklabel);
                tr.append(td);
                table.append(tr);
                $mainDiv.append(table);
                $chkinput.ejCheckBox({ checked: true });
                $label = ej.buildTag("label.e-dlg-fields").text(xlObj._getLocStr("Data"));
                $mainDiv.append($label);
                var $ddAction = ej.buildTag("input.e-" + xlObj._id + "-ddl", "", "", { id: xlObj._id + "_Ribbon_ddAction", type: "text" });
                $mainDiv.append($ddAction);
                $ddAction.ejDropDownList({
                    dataSource: this._actions,
                    fields: { id: "Types", text: "text", value: "value" }, selectedItemIndex: 6,
                    cssClass: "e-" + xlObj._id + "-ddl",
                    width: "100%",
                    change: $.proxy(this._valDTypeOnChange, this)
                });
                $subDiv = ej.buildTag("div.e-dlgctndiv e-dlg-fields", "", {}, { id: xlObj._id + "_Ribbon_SubDiv" });
                table = ej.buildTag("table");
                tr = ej.buildTag("tr"), td = ej.buildTag("td");
                $label = ej.buildTag("label.e-dlg-fields", "", "", { id: xlObj._id + "_Ribbon_lbMin" }).text(xlObj._getLocStr("NumberStart"));
                table.append(tr.append(td.append($label)));
                tr = ej.buildTag("tr"), td = ej.buildTag("td");
                var $min = ej.buildTag("input.ejinputtext", "", { width: "100%" }, { id: xlObj._id + "_Ribbon_btnMin", type: "text", name: xlObj._id + "_valMin" });
                table.append(tr.append(td.append($min)));
                tr = ej.buildTag("tr"), td = ej.buildTag("td");
                $label = ej.buildTag("label.e-dlg-fields", "", "", { id: xlObj._id + "_Ribbon_lbMax" }).text(xlObj._getLocStr("NumberEnd"));
                table.append(tr.append(td.append($label)));
                tr = ej.buildTag("tr"), td = ej.buildTag("td");
                var $max = ej.buildTag("input.ejinputtext", "", { width: "100%" }, { id: xlObj._id + "_Ribbon_btnMax", type: "text", name: xlObj._id + "_valMax" });
                table.append(tr.append(td.append($max)));
                $stgctnr.append($mainDiv, $subDiv.append(table));
                $("#" + xlObj._id + "_Ribbon_SubDiv").wrapInner('<form id="' + xlObj._id + '_Form_ValDialog" onsubmit="return false"></form>');
            }
        },

        _dialogValidate: function (dlgid, inputid) {
            var xlObj = this.XLObj, id = xlObj._id, obj, elem = $("#" + id + "_Form" + dlgid), val, i, len, cellAddr, webAddr, date, inputLength, input, number, time, splitStr, sheetName = true, type, condType, decimal, formulaRule;
            if ($.validator) {
                elem.validate({
                    errorElement: "div",
                    wrapper: "div",
                    errorPlacement: function (error, elem) {
                        error.insertAfter(elem.closest("input"));
                        error.children().addClass("e-dlg-field-validation-error");
                        error.css({ "position": "relative" });
                        error.offset({ left: elem.offset().left, top: elem.offset().top + 19 });
                    },
                    onfocusout: function (element) {
                        this.element(element);
                    },
                });
                type = $("#" + id + "_Ribbon_ddAction").ejDropDownList("getValue");
                switch (dlgid) {
                    case "_ValDialog":
                        obj = $("#" + id + "_Ribbon_ddType").data("ejDropDownList");
                        val = obj.getSelectedValue();
                        break;
                    case "_CFDialog":
                        if (inputid === id + "_CreateRule")
                            val = "formulaRule";
                        else
                        val = inputid.charAt(0).toUpperCase() + inputid.slice(1).toLowerCase();
                        break;
                    case "_GoToDiv":
                        val = "cellAddr";
                        break;
                    case "_Ribbon_PvtRange":
                    case "_Ribbon_PvtLocation":
                    case "_Ribbon_cellAddress":
                        val = "cellAddr";
                        break;
                    case "_Ribbon_webAddress":
                        val = "webAddr";
                        break;
                }
                $("#" + id + "_Form" + dlgid).validate().resetForm();
                input = new Array(), inputLength = $("#" + id + "_Form" + dlgid).find("input").length, date = { required: true, date: true, messages: { date: xlObj._getLocStr("DateValidationMsg"), required: xlObj._getLocStr("RequiredField") } }, cellAddr = { required: true, celladdr: true }, number = { required: true, numberVal: true };
                decimal = { required: true, number: true, messages: { required: xlObj._getLocStr("RequiredField"), number: xlObj._getLocStr("NumberValidationMsg") } }, time = { required: true, time: true }, webAddr = { required: true }, condType = { required: true, betweentype: true };
                formulaRule = { required: true, formularule: true },
                $.validator.addMethod("time", function (value, elem, param) {
                    return value === "" || value.match(/^(([0-1]?[0-9])|([2][0-3])):([0-5]?[0-9])(:([0-5]?[0-9]))?(\s(AM|am|PM|pm))?$/);
                }, xlObj._getLocStr("TimeValidationMsg"));
                $.validator.addMethod("date", function (value, elem, param) {
                    var dateSplit = value.split("/");
                    return this.optional(elem) || !/Invalid|NaN/.test(new Date((/chrom(e|ium)/.test(navigator.userAgent.toLowerCase())) ? value : dateSplit[1] + "/" + dateSplit[0] + "/" + dateSplit[2]));
                }, xlObj._getLocStr("DateValidationMsg"));
                $.validator.addMethod("celladdr", function (value, elem, param) {
                    var range, id = $(elem).data("parentID"), xlObj = $("#" + id).data("ejSpreadsheet"),sheetIdx, getSheet;
                    if ($("#" + xlObj._id + "_Ribbon_sheentName").length) 
                        sheetIdx = $("#" + xlObj._id + "_Ribbon_sheentName").ejTreeView("option", "selectedNode");
                        if(xlObj.isUndefined(sheetIdx) || sheetIdx < 0)
                            sheetIdx = xlObj.getActiveSheetIndex();
                    (value.indexOf("=") > -1) && (value = value.split('=')[1]);
                    if (value.indexOf("!") > -1) {
                        splitStr = value.split("!");
                        sheetIdx = xlObj._getSheetIndexByName(splitStr[0]);
                        value = splitStr[1];
                    }
                    if (sheetIdx < 1)
                        sheetName = false;
                    getSheet = xlObj.getSheet(sheetIdx);
                    value.indexOf("$") > -1 && (value = value.split("$").join(""));
                    range = xlObj.getRangeIndices(value);
                    range = (getSheet.colCount <= range[3] || getSheet.rowCount <= range[2]) ? null : value;
                    return (value.match(/^(?:\bxfXF[a-zA-D]|xX[a-eA-E][a-zA-Z]|[a-wA-W][a-zA-Z]{2}|[a-zA-Z]{2}|[a-zA-Z])\$?(?:104857[0-6]|10485[0-6]\d|1048[0-4]\d{2}|104[0-7]\d{3}|10[0-3]\d{4}|[1-9]\d{1,5}|[1-9]):(?:\bxfXF[a-zA-D]|xX[a-eA-E][a-zA-Z]|[a-wA-W][a-zA-Z]{2}|[a-zA-Z]{2}|[a-zA-Z])\$?(?:104857[0-6]|10485[0-6]\d|1048[0-4]\d{2}|104[0-7]\d{3}|10[0-3]\d{4}|[1-9]\d{1,5}|[1-9])$/) || value.match(/^(?:\bxfXF[a-zA-D]|xX[a-eA-E][a-zA-Z]|[a-wA-W][a-zA-Z]{2}|[a-zA-Z]{2}|[a-zA-Z])\$?(?:104857[0-6]|10485[0-6]\d|1048[0-4]\d{2}|104[0-7]\d{3}|10[0-3]\d{4}|[1-9]\d{1,5}|[1-9])$/) && (sheetName)) && range;
                }, xlObj._getLocStr("CellAddrsValidationMsg"));
                $.validator.addMethod("betweentype", function (value, elem, param) {
                    var id = elem.id.split("_")[0], val = $("#" + elem.id.split("_")[0] + "_Ribbon_ddType").ejDropDownList("getSelectedValue"), minVal = $("#" + id + "_Ribbon_btnMin").val(), maxVal = $("#" + elem.id.split("_")[0] + "_Ribbon_btnMax").val();
                    if (minVal === "" || maxVal === "" || parseFloat(minVal) > parseFloat(maxVal))
                        value = null;
                    if (val === "Date" && Date.parse(minVal) > Date.parse(maxVal))
                        value = null;
                    if (val === "Time" && new Date("01/01/1990 " + minVal).getTime() > new Date("01/01/1990 " + maxVal).getTime())
                        value = null;
                    return value;
                }, xlObj._getLocStr("BetweenAlert"));
                $.validator.addMethod("numberVal", function (value, elem, param) {
                    if ($.isNumeric(value)) {
                        if (parseFloat(value) % 1 !== 0)
                            value = null;
                        $.validator.messages.numberVal = xlObj._getLocStr("NumberValMsg");
                        return value;
                    }
                    else
                        $.validator.messages.numberVal = xlObj._getLocStr("NumberAlertMsg");
                }, $.validator.messages.numberVal);
                $.validator.addMethod("formularule", function (value, elem, param) {
                    return value === "" || (value.startsWith("=") && value.indexOf("!")<0);
                }, xlObj._getLocStr("FormulaRuleMsg"));

                for (i = 0, len = inputLength; i < len ; i++) {
                    input[i] = $("#" + id + "_Form" + dlgid).find("input")[i].id;
                    switch (val) {
                        case "Date":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", date);
                            break;
                        case "Time":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", time);
                            break;
                        case "Number":
                        case "TextLength":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", number);
                            break;
                        case "Decimal":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", decimal);
                            break;
                        case "List":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", webAddr);
                            break;
                        case "cellAddr":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", cellAddr);
                            break;
                        case "webAddr":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", webAddr);
                            break;
                        case "formulaRule":
                            $("#" + input[i]).rules("remove");
                            $("#" + input[i]).rules("add", formulaRule);
                            break;
                            
                    }
                    if (val !== "List" && (type === "Between" || type === "NotBetween"))
                        $("#" + id + "_Ribbon_btnMax").rules("add", condType);
                }
            }
        },

        _renderCFDialog: function (args) {
            var $mainDiv, $subDiv, $label, $input, dlgObj, xlObj = this.XLObj;
            dlgObj = $("#" + xlObj._id + "_CFDialog").data("ejDialog");
            if (args.ID === xlObj._id + "_CreateRule")
                dlgObj.option({ title: xlObj._getLocStr("NewRule") });
            else
                dlgObj.option({ title: xlObj._getLocStr(this._cFormatData[args.ID][0]) });
            if ($("#" + xlObj._id + "_Ribbon_CFSubDiv").length < 1) {
                $subDiv = ej.buildTag("div.e-dlg-fields", "", {}, { id: xlObj._id + "_Ribbon_CFSubDiv" });
                $label = ej.buildTag("label.e-dlg-fields").text(xlObj._getLocStr("With"));
                $subDiv.append($label);
                var $ddStyle = ej.buildTag("input.e-" + xlObj._id + "-ddl", "", {}, { id: xlObj._id + "_Ribbon_ddStyle", type: "text" });
                $subDiv.append($ddStyle);
                $ddStyle.ejDropDownList({
                    dataSource: this._styles,
                    fields: { id: "Types", text: "text", value: "value" }, selectedItemIndex: 0,
                    cssClass: "e-" + xlObj._id + "-ddl",
                    width: "100%",
                    change: $.proxy(this._ddOnChange, this),
                });
                $("#" + xlObj._id + "_CondFormat").append($subDiv);
                $("#" + xlObj._id + "_CondFormat").addClass("e-cfdiv");
            }
            if ($("#" + xlObj._id + "_Ribbon_CFMainDiv").length > 0)
                $("#" + xlObj._id + "_Ribbon_CFMainDiv").remove();
            $mainDiv = ej.buildTag("div.e-dlg-fields", "", "", { id: xlObj._id + "_Ribbon_CFMainDiv" });
            $("#" + xlObj._id + "_CondFormat").prepend($mainDiv);
            if (args.ID == "between") {
                $input = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_input2", type: "text" });
                $mainDiv.prepend($input);
                $label = ej.buildTag("label.e-dlg-fields").text(xlObj._getLocStr("And")).css('display', "table");
                $mainDiv.prepend($label);
            }
            $input = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_input1", type: "text" });
            $mainDiv.prepend($input);
            if (args.ID === xlObj._id + "_CreateRule")
                $label = ej.buildTag("label.e-dlg-fields").text(xlObj._getLocStr("NewRuleLabelContent"));
            else
                $label = ej.buildTag("label.e-dlg-fields").text(xlObj._getLocStr(this._cFormatData[args.ID][1]));
            $mainDiv.prepend($label);
            (args.ID === "aboveavg" || args.ID === "belowavg") && $input.hide();
            $("#" + xlObj._id + "_Ribbon_CFMainDiv").wrapInner('<form id="' + xlObj._id + '_Form_CFDialog" onsubmit="return false"></form>');
            this._dialogValidate("_CFDialog", args.ID);
        },

        _dlgCFOk: function () {
            var xlObj = this.XLObj;
            if ($("#" + xlObj._id + "_Form_CFDialog").valid()) {
                var ddObj = $("#" + xlObj._id + "_Ribbon_ddStyle").data("ejDropDownList"),rule;
                rule = (xlObj.XLRibbon._currentCFormat === xlObj._id + "_CreateRule") ? "formularule" : xlObj.XLRibbon._currentCFormat;
                xlObj.XLCFormat._cFormat(rule, $("#" + xlObj._id + "_Ribbon_input1").val(), $("#" + xlObj._id + "_Ribbon_input2").val(), ddObj.getSelectedValue());
                $("#" + xlObj._id + "_CFDialog").ejDialog("close");
                xlObj.setSheetFocus();
            }
        },

        _dlgCFCancel: function () {
            var xlObj = this.XLObj;
            $("#" + xlObj._id + "_Form_CFDialog").validate().resetForm();
            $("#" + xlObj._id + "_CFDialog").ejDialog("close");
            xlObj.setSheetFocus();
        },

        _sheetData: function (e) {
            var xlObj = this.XLObj, sheetname = new Array(), shtnameclt = new Array(), i, len, sheets = xlObj._getSheetNames();
            shtnameclt[0] = { id: 1, name: xlObj._getLocStr("SheetReference"), hasChild: true, expanded: true };
            for (i = 1, len = sheets.length; i <= len; i++) {
                if (sheets[i - 1].isVisible) {
                    sheetname[i] = sheets[i - 1].text;
                    shtnameclt[i] = { id: i + 1, pid: 1, name: sheetname[i], hasChild: true, expanded: true };
                }
            }
            return shtnameclt;
        },

        _renderHLDialog: function () {
            var xlObj = this.XLObj;
            if ($("#" + xlObj._id + "_Ribbon_WebDiv").length < 1) {
                var $WebDiv, $label, $find, $SheetDiv, $lb, $div, $table, $tr, $tr, $divctnr, $td;
                $WebDiv = ej.buildTag("div.e-dlgctndiv", "", {}, { id: xlObj._id + "_Ribbon_WebDiv" });
                $table = ej.buildTag("table", "", {}, { "cellpadding": 0, "cellspacing": 0 }), $tr = ej.buildTag("tr"), $td = ej.buildTag("td", "", { width: "32%" });
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("HyperlinkText"));
                $td.append($label);
                $td = ej.buildTag("td");
                $find = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_findText", type: "text" });
                $tr.append($td.append($find));

                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("WebAddress"), "", { id: xlObj._id + "_Ribbon_address" });
                $td.append($label);
                $td = ej.buildTag("td");
                $find = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_webAddress", type: "text" });
                $tr.append($td.append($find));
                $("#" + xlObj._id + "_Web").append($WebDiv.append($table));

                $SheetDiv = ej.buildTag("div.e-dlgctndiv", "", "", { id: xlObj._id + "_Ribbon_DocDiv" });
                $divctnr = ej.buildTag("div.e-dlg-fields");
                $table = ej.buildTag("table"), $tr = ej.buildTag("tr"), $td = ej.buildTag("td", "", { width: "32%" });
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("HyperlinkText"));
                $td.append($label);
                $td = ej.buildTag("td");
                $find = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_cellText", type: "text" });
                $tr.append($td.append($find));

                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("CellAddress"));
                $td.append($label);
                $td = ej.buildTag("td");
                $find = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_cellAddress", type: "text" });
                $find.data("parentID", xlObj._id);
                $tr.append($td.append($find));
                $div = ej.buildTag("div.e-dlg-fields", "", "", { id: xlObj._id + "_Ribbon_Sheet" });
                $SheetDiv.append($divctnr.append($table), $div);
                $label = ej.buildTag("label", xlObj._getLocStr("SheetIndex"));
                $div.append($label);
                $lb = ej.buildTag("div", "", "", { id: xlObj._id + "_Ribbon_sheentName" });
                $div.append($lb);
                $lb.ejTreeView({ fields: { id: "id", parentId: "pid", text: "name", hasChild: "hasChild", dataSource: this._sheetData(), expanded: "expanded" }, nodeSelect: $.proxy(this._sheetSelect, xlObj), height: 90 });
                $("#" + xlObj._id + "_Doc").append($SheetDiv);
                $("#" + xlObj._id + "_Ribbon_cellAddress").wrap("<form id='" + xlObj._id + "_Form_Ribbon_cellAddress' onsubmit='return false'></form>");
                this._dialogValidate("_Ribbon_cellAddress");
                $("#" + xlObj._id + "_Ribbon_webAddress").wrap("<form id='" + xlObj._id + "_Form_Ribbon_webAddress' onsubmit='return false'></form>");
                this._dialogValidate("_Ribbon_webAddress");
            }
        },

        _sheetSelect: function (args) {
            var i, len, shtName = this._getSheetNames(), cellElem = $("#" + this._id + "_Ribbon_cellAddress"), btnElem = $("#" + this._id + "hlDialog_OkBtn").data("ejButton"), valElem = $("#" + this._id + "_Ribbon_cellText");
            if (args.model.selectedNode > 0) {
                cellElem.attr("disabled", false);
                btnElem.enable();
                cellElem.focus().setInputPos(1);
                for (i = 0, len = shtName.length; i < len ; i++) {
                    if (shtName[i].text === valElem.val().split("!")[0])
                        valElem.val(args.value + "!" + cellElem.val());
                }

            }
            else {
                cellElem.attr("disabled", true);
                btnElem.disable();
            }
        },


        _dlgHLOk: function () {
            var xlObj = this.XLObj;
            if ($("#" + xlObj._id + "_Form_Ribbon_cellAddress").valid() && $("#" + xlObj._id + "_Form_Ribbon_webAddress").valid()) {
                this.XLObj._dlgHLClick = true;
                xlObj._setLink();
                this._dlgHLCancel();
            }
        },

        _dlgHLCancel: function () {
            $("#" + this.XLObj._id + "_HLDialog").ejDialog("close");
        },

        _renderFRDialog: function () {
            var $findDiv, $label, $find, $replace, $chkinput, $dd, $divleft, $divright, $maindiv, $settingsDiv, xlObj = this.XLObj, $table, $tr, $td;
            if ($("#" + xlObj._id + "_Ribbon_FindDiv").length < 1) {
                $findDiv = ej.buildTag("div.e-dlgctndiv e-ss-finddiv", "", { height: "auto" }, { id: xlObj._id + "_Ribbon_FindDiv" });
                $("#" + xlObj._id + "_Find").append($findDiv);
                $table = ej.buildTag("table");
                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td", "", { width: "30%" });
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("FindLabel"), "", { id: xlObj._id + "_Ribbon_lbFind" });
                $td.append($label);
                $td = ej.buildTag("td");
                $find = ej.buildTag("input.ejinputtext", "", "", { id: xlObj._id + "_Ribbon_textFind", type: "text" });
                $td.append($find);
                $tr.append($td);
                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("ReplaceLabel"), "", { id: xlObj._id + "_Ribbon_lbReplace" });
                $td.append($label);
                $td = ej.buildTag("td");
                $replace = ej.buildTag("input.ejinputtext", "", "", { id: xlObj._id + "_Ribbon_textReplace", type: "text" });
                $td.append($replace);
                $tr.append($td);
                $findDiv.append($table);
                $("#" + xlObj._id + "_Ribbon_lbReplace").hide();
                $("#" + xlObj._id + "_Ribbon_textReplace").hide();
                $settingsDiv = ej.buildTag("div.e-dlgctndiv e-ss-stgdiv", "", {}, { id: xlObj._id + "_Ribbon_SettingsDiv" });
                $table = ej.buildTag("table");
                $tr = ej.buildTag("tr"), $td = ej.buildTag("td", "", { width: "50%" });
                $table.append($tr.append($td));
                $chkinput = ej.buildTag("input#" + xlObj._id + "_Ribbon_Case");
                $label = ej.buildTag("label", xlObj._getLocStr("MatchCase"), {}, { "for": xlObj._id + "_Ribbon_Case" });
                $td.append($chkinput);
                $td.append($label);
                $chkinput.ejCheckBox();
                $td = ej.buildTag("td");
                $chkinput = ej.buildTag("input#" + xlObj._id + "_Ribbon_AllContent");
                $label = ej.buildTag("label", xlObj._getLocStr("MatchAll"), {}, { "for": xlObj._id + "_Ribbon_AllContent" });
                $td.append($chkinput);
                $chkinput.ejCheckBox();
                $td.append($label);
                $tr.append($td);
                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $label = ej.buildTag("label").text(xlObj._getLocStr("Within"));
                $td.append($label);
                $td = ej.buildTag("td");
                $label = ej.buildTag("label").text(xlObj._getLocStr("Search"));
                $td.append($label);
                $tr.append($td);
                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $dd = ej.buildTag("input", "", "", { id: xlObj._id + "_Ribbon_ddWithin", type: "text" });
                $td.append($dd);
                $dd.ejDropDownList(xlObj._generateEJDD(this._within, { id: "Types", text: "text", value: "value" }, 0, 110, 25));
                $td = ej.buildTag("td");
                $dd = ej.buildTag("input", "", "", { id: xlObj._id + "_Ribbon_ddSearch", type: "text" });
                $td.append($dd);
                $dd.ejDropDownList(xlObj._generateEJDD(this._sType, { id: "Types", text: "text", value: "value" }, 0, 120, 25));
                $tr.append($td);
                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $label = ej.buildTag("label", xlObj._getLocStr("Lookin"));
                $td.append($label);
                $td = ej.buildTag("td");
                $label = ej.buildTag("label", xlObj._getLocStr("Replace") + " " + xlObj._getLocStr("Direction"));
                $tr.append($td.append($label));
                $tr = ej.buildTag("tr.e-dlgtd-fields"), $td = ej.buildTag("td");
                $table.append($tr.append($td));
                $dd = ej.buildTag("input", "", "", { id: xlObj._id + "_Ribbon_ddLookin", type: "text" });
                $td.append($dd);
                $dd.ejDropDownList(xlObj._generateEJDD(this._vType, { id: "Types", text: "text", value: "value" }, 0, 110, 25, "Type"));
                $td = ej.buildTag("td");
                $dd = ej.buildTag("input", "", "", { id: xlObj._id + "_Ribbon_ddDirection", type: "text" });
                $tr.append($td.append($dd));
                $dd.ejDropDownList(xlObj._generateEJDD(this._direction, { id: "Types", text: "text", value: "value" }, 0, 120, 25));
                $("#" + xlObj._id + "_Settings").append($settingsDiv.append($table));
            }
        },

        _frTypeChange: function (name, args) {
            if (name === "Type" && (args.value === "comment")) {
                $("#" + this._id + "_Ribbon_textReplace").attr("disabled", true);
                $("#" + this._id + "FR_ReplaceBtn").ejButton("disable");
                $("#" + this._id + "FR_ReplaceAllBtn").ejButton("disable");
            }
            else {
                $("#" + this._id + "_Ribbon_textReplace").prop("disabled", false);
                $("#" + this._id + "FR_ReplaceBtn").ejButton("enable");
                $("#" + this._id + "FR_ReplaceAllBtn").ejButton("enable");
            }
        },

        _hlTabChange: function (args) {
            var xlObj = this.XLObj, treeObj = $("#" + xlObj._id + "_Ribbon_sheentName").data("ejTreeView"), sheetIdx = xlObj.getActiveSheetIndex(), docTab = $("#" + xlObj._id + "_Doc"), webTab = $("#" + xlObj._id + "_Web"),
            webAddrElem = $("#" + xlObj._id + "_Ribbon_webAddress"), webElem = $("#" + xlObj._id + "_Ribbon_findText"), cellAddrElem = $("#" + xlObj._id + "_Ribbon_cellAddress"), cellElem = $("#" + xlObj._id + "_Ribbon_cellText"),
            activeCell = xlObj.getActiveCell(sheetIdx), cellIdx = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "hyperlink", sheetIdx);
            switch (args.activeIndex) {
                case 0:
                    webAddrElem.focus().setInputPos(webAddrElem.val().length);
                    webElem.val(cellElem.val());
                    docTab.hide();
                    webTab.show();
                    $("#" + xlObj._id + "hlDialog_OkBtn").ejButton("enable");
                    break;
                case 1:
                    !cellAddrElem.val().length && cellAddrElem.val("A1");
                    docTab.show();
                    webTab.hide();
                    if (cellIdx && cellIdx.cellAddr)
                        sheetIdx = parseInt(cellIdx.cellAddr.split("_")[1]);
                    treeObj.selectNode(sheetIdx + 1);
                    webElem.val().length ? cellElem.val(webElem.val()) : cellElem.val(treeObj.getText(sheetIdx + 1) + "!A1");
                    cellAddrElem.focus().setInputPos(cellAddrElem.val().length);
                    break;
            }
        },

        _findTabChange: function (args) {
            var $findDiv, xlObj = this.XLObj;
            switch (args.activeIndex) {
                case 0:
                    $findDiv = $("#" + xlObj._id + "_Ribbon_FindDiv");
                    $("#" + xlObj._id + "_Ribbon_lbReplace").hide();
                    $("#" + xlObj._id + "_Ribbon_textReplace").hide();
                    $("#" + xlObj._id + "FR_ReplaceBtn").css("visibility", "hidden");
                    $("#" + xlObj._id + "FR_ReplaceAllBtn").css("visibility", "hidden");
                    $("#" + xlObj._id + "_Find").append($findDiv);
                    $("#" + xlObj._id + "FR_PrevBtn").show();
                    $("#" + xlObj._id + "FR_NextBtn").show();
                    $("#" + xlObj._id + "_Ribbon_textFind").focus().setInputPos($("#" + xlObj._id + "_Ribbon_textFind").val().length);
                    if (xlObj._phoneMode) {
                        $("#" + xlObj._id + "FR_ReplaceBtn").hide();
                        $("#" + xlObj._id + "FR_ReplaceAllBtn").hide();
                    }
                    else {
                        $("#" + xlObj._id + "FR_ReplaceBtn").show();
                        $("#" + xlObj._id + "FR_ReplaceAllBtn").show();
                    }
					break;
                case 1:
                    $findDiv = $("#" + xlObj._id + "_Ribbon_FindDiv");
                    $("#" + xlObj._id + "_Ribbon_lbReplace").show();
                    $("#" + xlObj._id + "_Ribbon_textReplace").show();
                    $("#" + xlObj._id + "FR_ReplaceBtn").css("visibility", "visible").show();
                    $("#" + xlObj._id + "FR_ReplaceAllBtn").css("visibility", "visible").show();
                    if (xlObj._phoneMode) {
                        $("#" + xlObj._id + "FR_PrevBtn").hide();
                        $("#" + xlObj._id + "FR_NextBtn").hide();
                    }
                    else {
                        $("#" + xlObj._id + "FR_PrevBtn").show();
                        $("#" + xlObj._id + "FR_NextBtn").show();
                    }
                    $("#" + xlObj._id + "_Replace").append($findDiv);
                    $("#" + xlObj._id + "_Ribbon_textFind").focus().setInputPos($("#" + xlObj._id + "_Ribbon_textFind").val().length);
                    break;
                case 2:
                    $("#" + xlObj._id + "FR_PrevBtn").hide();
                    $("#" + xlObj._id + "FR_NextBtn").hide();
                    $("#" + xlObj._id + "FR_ReplaceBtn").css("visibility", "hidden");
                    $("#" + xlObj._id + "FR_ReplaceAllBtn").css("visibility", "hidden");
                    $("#" + xlObj._id + "_Ribbon_ddWithin").focus();
                    xlObj._phoneMode ? $("#" + xlObj._id + "_Ribbon_SettingsDiv").find('td:eq(1)').hide() : $("#" + xlObj._id + "_Ribbon_SettingsDiv").find('td:eq(1)').show();
                    break;
            }
        },

        _gotoTabChange: function (args) {
            var xlObj = this.XLObj;
            if (args.activeIndex == 0)
                $("#" + xlObj._id + "_textRef").focus().setInputPos($("#" + xlObj._id + "_textRef").val().length);
        },

        _btnFROnClick: function (id, e) {
            var xlObj = this.XLObj;
            xlObj.showWaitingPopUp();
            var sheetIdx = xlObj.getActiveSheetIndex(), rowIndex = xlObj.getSheet(sheetIdx)._startCell.rowIndex, colIndex = xlObj.getSheet(sheetIdx)._startCell.colIndex, mCase = $("#" + xlObj._id + "_Ribbon_Case").data("ejCheckBox").isChecked(), mAll = $("#" + xlObj._id + "_Ribbon_AllContent").data("ejCheckBox").isChecked();
            var within = this._within[$("#" + xlObj._id + "_Ribbon_ddWithin").data("ejDropDownList").selectedIndexValue].value, search = this._sType[$("#" + xlObj._id + "_Ribbon_ddSearch").data("ejDropDownList").selectedIndexValue].value, lookin = this._vType[$("#" + xlObj._id + "_Ribbon_ddLookin").data("ejDropDownList").selectedIndexValue].value, direction = this._direction[$("#" + xlObj._id + "_Ribbon_ddDirection").data("ejDropDownList").selectedIndexValue].value, isFinded;
            switch (id) {
                case "FR_NextBtn":
                case "FR_PrevBtn":
                    xlObj.XLSearch._findCount = 0;
                    isFinded = id === "FR_NextBtn" ? xlObj.XLSearch._findNext($("#" + xlObj._id + "_Ribbon_textFind").val(), sheetIdx, mCase, mAll, lookin, within, search) : xlObj.XLSearch._findPrev($("#" + xlObj._id + "_Ribbon_textFind").val(), sheetIdx, mCase, mAll, lookin, within, search);
                    if (!isFinded) {
                        xlObj.XLSearch._updateSelection(rowIndex, colIndex, sheetIdx);
                        xlObj.hideWaitingPopUp();
                        xlObj._showAlertDlg("Alert", "NotFound");
                    }
                    break;
                case "FR_ReplaceBtn":
                    xlObj.XLSearch._replaceData($("#" + xlObj._id + "_Ribbon_textFind").val(), $("#" + xlObj._id + "_Ribbon_textReplace").val(), sheetIdx, mCase, mAll, lookin, direction, within, search);
                    break;
                case "FR_ReplaceAllBtn":
                    xlObj.XLSearch._replaceAllData($("#" + xlObj._id + "_Ribbon_textFind").val(), $("#" + xlObj._id + "_Ribbon_textReplace").val(), mCase, mAll, lookin, within);
                    break;
                case "FR_CloseBtn":
                    $("#" + xlObj._id + "_FRDialog").ejDialog("close");
                    xlObj.setSheetFocus();
                    break;
            }
            xlObj.hideWaitingPopUp();
        },

        _renderGoToDialog: function () {
            var $gotoDiv, $gotoSpDiv, $label, $list, $input, xlObj = this.XLObj, $subdiv;
            $("#" + xlObj._id + "_GoToDlgTab").ejTab({ width: "100%", itemActive: ej.proxy(this._gotoTabChange, this), cssClass: "e-ss-dlgtab" });
            if ($("#" + xlObj._id + "_GoToDiv").length < 1) {
                $gotoDiv = ej.buildTag("div.e-dlgctndiv", "", {}, { id: xlObj._id + "_GoToDiv" });
                $("#" + xlObj._id + "_GoTo").append($gotoDiv);
                $subdiv = ej.buildTag("div.e-dlg-fields");
                $label = ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("GoToName"));
                $list = ej.buildTag("ul#" + xlObj._id + "_GotoAddr");
                $gotoDiv.append($subdiv.append($label, $list));
                $("#" + xlObj._id + "_GotoAddr").ejListBox({
                    dataSource: this._addrList,
                    height: "120",
                    width: "100%",
                    selected: $.proxy(this._gotoValChange, this),
                    fields: { id: "Types", text: "text", value: "value" }
                });

                $subdiv = ej.buildTag("div.e-dlg-fields");
                $label = ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("Reference"));
                $input = ej.buildTag("input.ejinputtext", "", "", { id: xlObj._id + "_textRef", type: "text" });
                $input.data("parentID", xlObj._id);
                $gotoDiv.append($subdiv.append($label, $input));

                $gotoSpDiv = ej.buildTag("div#" + xlObj._id + "_GoToSpDiv.e-dlgctndiv", "", "");
                $subdiv = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
                $("#" + xlObj._id + "_GoToSp").append($gotoSpDiv.append($subdiv));
                $("#" + xlObj._id + "_GoToSp").css({'overflow':'auto', 'height': 'auto'}); // buttons and headers
                $label = ej.buildTag("label.e-dlg-fields").text(xlObj._getLocStr("Select")).css('display', "table");
                $subdiv.append($label);
                this._renderGotoSp($subdiv, this._gotoRBtnSet1, this._gotoRBtnSet2, this._gotoChkBox);
                $("#" + xlObj._id + "_GoDialog").ejDialog({
                    showOnInit: false, enableModal: true, enableResize: false, width: "auto", allowKeyboardNavigation: false, title: xlObj._getLocStr("GoTo"), cssClass: "e-ss-dialog e-ss-gotodlg e-ss-mattab e-" + xlObj._id + "-dlg", close: ej.proxy(this._dialogClose, this), open: ej.proxy(function (e) {
                        var gotoipt = $("#" + xlObj._id + "_textRef");
                        gotoipt.focus().setInputPos(gotoipt.val().length);
                    })
                });
                $('#' + xlObj._id + '_GoToDiv').wrapInner('<form id="' + xlObj._id + '_Form_GoToDiv" onsubmit="return false"></form>');
                this._dialogValidate('_GoToDiv');
            }
        },

        _renderGotoSp: function ($content, rBtnIdSet1, rBtnIdSet2, chkBoxIDs) {
            var input, lbl, table, tr, td, i, xlObj = this.XLObj, tabId = xlObj._id + "_gotoSpDiv", $chkinput;
            table = ej.buildTag("table");
            for (i = 0; i < rBtnIdSet1.length; i++) {
                tr = ej.buildTag("tr", "", { height: 35 });
                td = ej.buildTag("td");
                input = ej.buildTag("input#" + tabId + "_" + rBtnIdSet1[i], "", {}, { type: "radio", name: "gotospecial" });
                td.append(input);
                tr.append(td);
                input.ejRadioButton({ size: "medium", change: $.proxy(this._rBtnOnClick, this, rBtnIdSet1[i]) });
                td = ej.buildTag("td", "", { width: 100 });
                lbl = ej.buildTag("label", xlObj._getLocStr(rBtnIdSet1[i]), {}, { "for": tabId + "_" + rBtnIdSet1[i] });
                td.append(lbl);
                tr.append(td);
                if (!xlObj.isUndefined(rBtnIdSet2[i])) {
                    td = ej.buildTag("td");
                    input = ej.buildTag("input#" + tabId + "_" + rBtnIdSet2[i], "", {}, { type: "radio", name: "gotospecial" });
                    td.append(input);
                    tr.append(td);
                    input.ejRadioButton({ size: "medium", change: $.proxy(this._rBtnOnClick, this, rBtnIdSet2[i]) });
                    td = ej.buildTag("td");
                    lbl = ej.buildTag("label", xlObj._getLocStr(rBtnIdSet2[i]), {}, { "for": tabId + "_" + rBtnIdSet2[i] });
                    td.append(lbl);
                    tr.append(td);
                }
                table.append(tr);
            }
            for (i = 0; i < chkBoxIDs.length; i = i + 2) {
                tr = ej.buildTag("tr");
                td = ej.buildTag("td");
                $chkinput = ej.buildTag("input#" + xlObj._id + "_" + chkBoxIDs[i]);
                td.append($chkinput);
                tr.append(td);
                td = ej.buildTag("td");
                lbl = ej.buildTag("label", xlObj._getLocStr(chkBoxIDs[i]), {}, { "for": xlObj._id + "_" + chkBoxIDs[i] });
                td.append(lbl);
                tr.append(td);
                $chkinput.ejCheckBox({ checked: true, enabled: false });
                td = ej.buildTag("td");
                $chkinput = ej.buildTag("input#" + xlObj._id + "_" + chkBoxIDs[i + 1]);
                td.append($chkinput);
                tr.append(td);
                td = ej.buildTag("td");
                lbl = ej.buildTag("label", xlObj._getLocStr(chkBoxIDs[i + 1]), {}, { "for": xlObj._id + "_" + chkBoxIDs[i + 1] });
                td.append(lbl);
                tr.append(td);
                $chkinput.ejCheckBox({ checked: true, enabled: false });
                table.append(tr);

            }
            $content.append(table);
            $("#" + tabId + "_" + "Blanks").ejRadioButton("option", { checked: true });
        },

        _renderPvtDialog: function () {
            var xlObj = this.XLObj;
            if ($("#" + xlObj._id + "_Ribbon_PvtDiv").length < 1) {
                var $pvtDiv, $label, $table, $tr, $td, input;
                $pvtDiv = ej.buildTag("div.e-dlgctndiv", "", {}, { id: xlObj._id + "_Ribbon_PvtDiv" });
                $table = ej.buildTag("table", "", {}, { "cellpadding": 0, "cellspacing": 0 });             
                $tr = ej.buildTag("tr.e-ss-changerange");
                $td = ej.buildTag("td", "");
                $label = ej.buildTag("label", xlObj._getLocStr("Range"));
                $td.append($label);
                $tr.append($td);
                $td = ej.buildTag("td", "");
                input = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_PvtRange", type: "text" });
                input.data("parentID", xlObj._id);
                $tr.append($td.append(input));
                $table.append($tr);

                $tr = ej.buildTag("tr.e-ss-movepvttbl");
                $td = ej.buildTag("td");                
                $label = ej.buildTag("label", xlObj._getLocStr("ChoosePivotTable"));
                $td.append($label);
                $td.attr("colspan", 2);
                $table.append($tr.append($td));

                $tr = ej.buildTag("tr.e-ss-movepvttbl");
                $td = ej.buildTag("td");
                $td.attr("colspan", 2);            
                input = ej.buildTag("input#" + xlObj._id + "_dlg_newsheet", "", {}, { type: "radio", name: "sheet" });
                $td.append(input);
                $label = ej.buildTag("label", " "+xlObj._getLocStr("NewWorksheet"));
                $td.append($label);
                $table.append($tr.append($td));
                input.ejRadioButton({ size: "medium", checked: true, change: $.proxy(this._rBtnPvtOnClick, this, "new") });

                $tr = ej.buildTag("tr.e-ss-movepvttbl");
                $td = ej.buildTag("td");
                $td.attr("colspan", 2);
                input = ej.buildTag("input#" + xlObj._id + "_dlg_existsheet", "", {}, { type: "radio", name: "sheet" });
                $td.append(input);
                $label = ej.buildTag("label", " " + xlObj._getLocStr("ExistingWorksheet"));
                $td.append($label);
                $table.append($tr.append($td));
                input.ejRadioButton({ size: "medium", change: $.proxy(this._rBtnPvtOnClick, this, "existing") });  

                $tr = ej.buildTag("tr.e-ss-movepvttbl");
                $td = ej.buildTag("td");
                $label = ej.buildTag("label", xlObj._getLocStr("Location"));
                $td.append($label);
                $tr.append($td);
                $td = ej.buildTag("td");
                input = ej.buildTag("input.ejinputtext", "", {}, { id: xlObj._id + "_Ribbon_PvtLocation", type: "text" });
                input.data("parentID", xlObj._id);
                $tr.append($td.append(input));
                $table.append($tr);
               
                $("#" + xlObj._id + "_Pivot").append($pvtDiv.append($table));
                $("#" + xlObj._id + "_Ribbon_PvtLocation").wrap("<form id='" + xlObj._id + "_Form_Ribbon_PvtLocation' onsubmit='return false'></form>").prop("disabled", true);
                this._dialogValidate("_Ribbon_PvtLocation");
                $("#" + xlObj._id + "_Ribbon_PvtRange").wrap("<form id='" + xlObj._id + "_Form_Ribbon_PvtRange' onsubmit='return false'></form>");
                this._dialogValidate("_Ribbon_PvtRange");               
            }
        },

        _dlgPvtOk: function () {
            var xlObj = this.XLObj, dlg = $("#" + xlObj._id + "_PvtDialog");
            if ($("#" + xlObj._id + "_Form_Ribbon_PvtRange").valid() && $("#" + xlObj._id + "_Form_Ribbon_PvtLocation").valid()) {
                var error = xlObj.XLPivot._checkRange($("#" + xlObj._id + "_Ribbon_PvtRange").val(), $("#" + xlObj._id + "_Ribbon_PvtLocation").val());          
                if (error.isRows)
                    xlObj._showAlertDlg("Alert", "PivotRowsAlert", "", 450);
                else if (error.isHeader)
                    xlObj._showAlertDlg("Alert", "PivotLabelsAlert", "", 550);
                else if (error.isOverlap)
                    xlObj._showAlertDlg("Alert", "PivotOverlapAlert", "", 450);
                else {
                    $("#" + xlObj._id + "_PvtDialog").ejDialog("close");
                    if (dlg.find(".e-ss-changerange:visible").length && dlg.find(".e-ss-movepvttbl:visible").length)
                        xlObj.XLPivot.createPivotTable($("#" + xlObj._id + "_Ribbon_PvtRange").val(), $("#" + xlObj._id + "_Ribbon_PvtLocation").val(), null);
                    else if (dlg.find(".e-ss-changerange:visible").length)
                        xlObj.XLPivot._changeDataSource();
                    else
                        xlObj.XLPivot._movePivotTable();
                }
            }
        },

        _dlgPvtCancel: function () {
            var xlObj = this.XLObj;
            $("#" + xlObj._id + "_PvtDialog").ejDialog("close");
            xlObj.setSheetFocus();
        },

        _rBtnPvtOnClick: function (id, e) {
            var xlObj = this.XLObj, newId = $("#" + xlObj._id + "_Ribbon_PvtRange"), existingId = $("#" + xlObj._id + "_Ribbon_PvtLocation");
            existingId.prop("disabled", id === "new");
            if (id === "new")
            {
                newId.focus().setInputPos(newId.val().length);
                $('#' + this.XLObj._id + '_Form_Ribbon_PvtLocation').validate().resetForm();
            }
            else
                existingId.setInputPos(existingId.val().length);
        },

        _rBtnOnClick: function (id, e) {
            var xlObj = this.XLObj, i;
            if (id === "Formulas" || id === "Constants") {
                for (i = 0; i < this._gotoChkBox.length; i++)
                    $("#" + xlObj._id + "_" + this._gotoChkBox[i]).data("ejCheckBox").option({ enabled: true });
            }
            else {
                for (i = 0; i < this._gotoChkBox.length; i++)
                    $("#" + xlObj._id + "_" + this._gotoChkBox[i]).data("ejCheckBox").option({ enabled: false });
            }
        },

        _gotoValChange: function (args) {
            $("#" + this.XLObj._id + "_textRef").val(args.model.value);
        },

        _getAddrFromDollarAddr: function (value) {
            var sIdx, splitStr
            if (value.indexOf("!") > -1) {
                splitStr = value.split("!");
                sIdx = this.XLObj._getSheetIndexByName(splitStr[0]);
                value = splitStr[1];
            }
            value.indexOf("$") > -1 && (value = value.split("$").join(""));
            value.indexOf(":") < 0 && (value = value + ":" + value);
            value = value.replace("=", "");            
            return [sIdx,value];
        },

        _gotoBtnClick: function (id, e) {
            var xlObj = this.XLObj;
            switch (id) {
                case "ok":
                    if ($('#' + xlObj._id + '_Form_GoToDiv').valid()) {
                        var tabObj = $("#" + xlObj._id + "_GoToDlgTab").data("ejTab");
                        if (!tabObj.model.selectedItemIndex)
                            xlObj.XLSearch.goTo($.trim($("#" + xlObj._id + "_textRef").val().toString()));
                        else
                            xlObj.XLSearch._applyGoToRule($("#" + xlObj._id + "_GoToSpDiv").find(".e-circle_01").parents("div")[0].id.split("ej" + xlObj._id + "_gotoSpDiv_")[1].toLowerCase(), $("#" + xlObj._id + "_" + this._gotoChkBox[0]).data("ejCheckBox").isChecked(), $("#" + xlObj._id + "_" + this._gotoChkBox[1]).data("ejCheckBox").isChecked(), $("#" + xlObj._id + "_" + this._gotoChkBox[2]).data("ejCheckBox").isChecked(), $("#" + xlObj._id + "_" + this._gotoChkBox[3]).data("ejCheckBox").isChecked());
                        $("#" + xlObj._id + "_GoDialog").ejDialog("close");
                    }
                    break;
                case "cancel":
                    if ($.validator)
                        $('#' + xlObj._id + '_Form_GoToDiv').validate().resetForm();
                    $("#" + xlObj._id + "_GoDialog").ejDialog("close");
                    break;
            }
            xlObj.setSheetFocus();
        },

        _borderPicture: function () {
            var xlObj = this.XLObj;
            return "<ul id=" + xlObj._id + "_Ribbon_PictureBorder style='display:none' class='e-ss-pictureborder'><li id='" + xlObj._id + "picturecolor'><a>" + xlObj._getLocStr("ThemeColor") + "</a><ul><li><input id='" + xlObj._id + "_Ribbon_PictureColor'></input></li></ul></li><li id='nooutline' class='picturecolor'><a>" + xlObj._getLocStr("NoOutline") + "</a></li><li id='weight' class='picturecolor'><a>" + xlObj._getLocStr("Weight") + "</a><ul><li id='1px'><a>1px</a></li><li id='2px'><a>2px</a></li><li id='3px'><a>3px</a></li></ul></li><li id='dashes' class='picturecolor'><a>" + xlObj._getLocStr("Dashes") + "</a><ul><li id='solid'><a><div style='border:2px solid black'></div></a></li><li id='dotted'><a><div style='border:2px dotted black'></div></a></li><li id='dashed'><a><div style='border:2px dashed black'></div></a></li></ul></li></ul>";
        },

        _chartElementTag: function () {
            var xlObj = this.XLObj, element = '<ul id=' + xlObj._id + '_Ribbon_CElement class="e-spreadsheet" style="display:none">';
            element += '<li class="axes" id="Axes"><a><span class="e-ss-chartimg e-icon e-ss-axes"></span>' + xlObj._getLocStr("Axes") + '</a><ul><li class="phaxis e-ss-cmenuitem" id="PHAxis"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-phaxis"></span>' + xlObj._getLocStr("PHAxis") + '</a></li><li class="pvaxis e-ss-cmenuitem" id="PVAxis"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-pvaxis"></span>' + xlObj._getLocStr("PVAxis") + '</a></li></ul></li>';
            element += '<li class="axistitle" id="AxisTitle"><a><span class="e-ss-chartimg e-icon e-ss-axistitle"></span>' + xlObj._getLocStr("AxisTitle") + '</a><ul><li class="phaxistitle e-ss-cmenuitem" id="PHAxisTitle"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-phaxistitle"></span>' + xlObj._getLocStr("PHAxis") + '</a></li><li class="pvaxistitle e-ss-cmenuitem" id="PVAxisTitle"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-pvaxistitle"></span>' + xlObj._getLocStr("PVAxis") + '</a></li></ul></li>';
            element += '<li class="charttitle" id="ChartTitle"><a><span class="e-ss-chartimg e-icon e-ss-charttitle"></span>' + xlObj._getLocStr("ChartTitle") + '</a><ul><li class="ctnone e-ss-cmenuitem" id="CTNone"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-ctnone"></span>' + xlObj._getLocStr("CTNone") + '</a></li><li class="ctcenter e-ss-cmenuitem" id="CTCenter"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-ctcenter"></span>' + xlObj._getLocStr("CTCenter") + '</a></li><li class="ctfar e-ss-cmenuitem" id="CTFar"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-ctfar"></span>' + xlObj._getLocStr("CTFar") + '</a></li><li class="ctnear e-ss-cmenuitem" id="CTNear"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-ctnear"></span>' + xlObj._getLocStr("CTNear") + '</a></li></ul></li>';
            element += '<li class="datalabels" id="DataLabels"><a><span class="e-ss-chartimg e-icon e-ss-datalabels"></span>' + xlObj._getLocStr("DataLabels") + '</a><ul><li class="dlnone e-ss-cmenuitem" id="DLNone"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-dlnone"></span>' + xlObj._getLocStr("DLNone") + '</a></li><li class="dlcenter e-ss-cmenuitem" id="DLCenter"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-dlcenter"></span>' + xlObj._getLocStr("DLCenter") + '</a></li><li class="dliend e-ss-cmenuitem" id="DLIEnd"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-dliend"></span>' + xlObj._getLocStr("DLIEnd") + '</a></li><li class="dlibase e-ss-cmenuitem" id="DLIBase"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-dlibase"></span>' + xlObj._getLocStr("DLIBase") + '</a></li><li class="dloend e-ss-cmenuitem" id="DLOEnd"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-dloend"></span>' + xlObj._getLocStr("DLOEnd") + '</a></li></ul></li>';
            element += '<li class="gridline" id="Gridline"><a><span class="e-ss-chartimg e-icon e-ss-gridline"></span>' + xlObj._getLocStr("Gridline") + '</a><ul><li class="pmajorh e-ss-cmenuitem" id="PMajorH"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-pmajorh"></span>' + xlObj._getLocStr("PMajorH") + '</a></li><li class="pmajorv e-ss-cmenuitem" id="PMajorV"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-pmajorv"></span>' + xlObj._getLocStr("PMajorV") + '</a></li><li class="pminorh e-ss-cmenuitem" id="PMinorH"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon  e-ss-pminorh"></span>' + xlObj._getLocStr("PMinorH") + '</a></li><li class="pminorv e-ss-cmenuitem" id="PMinorV"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-pminorv"></span>' + xlObj._getLocStr("PMinorV") + '</a></li></ul></li>';
            element += '<li class="legend" id="Legend"><a><span class="e-ss-chartimg e-icon e-ss-legend"></span>' + xlObj._getLocStr("Legend") + '</a><ul><li class="lnone e-ss-cmenuitem" id="LNone"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-lnone"></span>' + xlObj._getLocStr("LNone") + '</a></li><li class="lright e-ss-cmenuitem" id="LRight"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-lright"></span>' + xlObj._getLocStr("LRight") + '</a></li><li class="lleft e-ss-cmenuitem" id="LLeft"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-lleft"></span>' + xlObj._getLocStr("LLeft") + '</a></li><li class="lbottom e-ss-cmenuitem" id="LBottom"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-lbottom"></span>' + xlObj._getLocStr("LBottom") + '</a></li><li class="ltop e-ss-cmenuitem" id="LTop"><a class="e-ss-chartlayout"><span class="e-ss-chartimg e-icon e-ss-ltop"></span>' + xlObj._getLocStr("LTop") + '</a></li></ul></li>';
            return element;
        },

        _cpClickHandler: function (name, args) {
            var xlObj = this.XLObj;
            if (name === "Ribbon_Home_Font_FillColor")
                xlObj.XLFormat.format({ "style": { "background-color": $("#" + xlObj._id + "_Ribbon_Home_Font_FillColor").ejColorPicker('option', 'value') } });
            else if (name === "Ribbon_Home_Font_FontColor")
                xlObj.XLFormat.format({ "style": { "color": $("#" + xlObj._id + "_Ribbon_Home_Font_FontColor").ejColorPicker('option', 'value') } });
            xlObj.setSheetFocus();
        },

        _ribbonClickHandler: function (args) {
            var i, cfObj, cid, hexcode, gotoTabObj, cellRange, curProp, startCell, endCell, info, details, elem, element, cname, selectedIndex, activeCell, fsObj, tid, tmgr, range, obj = {}, xlObj = $("#" + this._id.split("_Ribbon")[0]).data("ejSpreadsheet"), sheetIdx = xlObj.getActiveSheetIndex(),    sheet = xlObj.getSheet(sheetIdx), temp = {}, style = {}, splitId = this._id.split("_"), sstyles = ej.Spreadsheet.SupportedStyles, size, arg, sheetCont, sheetPanel, dataVal, selCells = sheet._selectedCells;
            if (xlObj._shapeChange || xlObj.XLRibbon._isSetModel)
                return;
            xlObj._isRibbonClick = true;
            sheetCont = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"), sheetPanel = xlObj.getMainPanel();
            cfObj = $("#" + xlObj._id + "_Ribbon_Home_Number_NumberFormat").data("ejDropDownList");
            fsObj = $("#" + xlObj._id + "_Ribbon_Home_Font_FontSize").data("ejDropDownList");
            activeCell = $(xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex));
            if (xlObj.model.allowSelection && ((xlObj.model.allowFormatAsTable && xlObj.model.allowCellFormatting))) {
                if ((xlObj.XLFormat._formatEnable || xlObj.XLSelection._isOutsideBordering || xlObj.XLSelection._isGridBordering)) {
                    if (xlObj._id + "_Ribbon_Home_Font_BorderColor" !== this._id && xlObj._id + "_Ribbon_bordercolor" !== args.ID && !(xlObj._borderStyles.indexOf(args.ID) > -1)) {
                        xlObj.XLSelection._isGridBordering = xlObj.XLSelection._isOutsideBordering = xlObj.XLFormat._formatEnable = false;
                        $("#" + xlObj._id + "_Ribbon_Home_Clipboard_FormatPainter").ejToggleButton("option", { toggleState: false });
                        if ((args.type === "itemSelected" || args.type === "click") && !xlObj.isUndefined(args.model.prefixIcon) && (args.model.prefixIcon.split("e-ss-")[1] === args.ID || (args.model.prefixIcon.indexOf("e-ss-drawborder") > -1 || args.model.prefixIcon.indexOf("e-ss-drawbordergrid") > -1)))
                            xlObj.XLSelection._isGridBordering = xlObj.XLSelection._isOutsideBordering = true;                        
                        sheetCont.addClass("e-ss-cursor");
                        sheetCont.removeClass("e-ss-drwbrdrcursor e-ss-drwbrdrgridcursor e-ss-fpcursor");
                        xlObj.XLSelection._cleanUp(true);
                    }
                }
            }
            arg = { Id: this._id, isChecked: args.isChecked, status: args.status, prop: args.model, model: xlObj.model };
            if (xlObj._trigger("ribbonClick", arg)) {
                if (xlObj.model.showRibbon)
                    xlObj.XLRibbon._updateRibbonIcons();
                return;
            }
            if (!ej.isNullOrUndefined(xlObj._getAutoFillOptElem()) && xlObj.model.autoFillSettings.showFillOptions) {
                xlObj._getAutoFillOptElem().addClass("e-hide");
                $("#" + xlObj._id + "_ctxtmenu").hide();
            }
            switch (this._id) {
                case xlObj._id + "_Ribbon_Home_Clipboard_Cut":
                    xlObj.XLClipboard.cut();
                    break;
                case xlObj._id + "_Ribbon_Home_Clipboard_Copy":
                    xlObj.XLClipboard.copy();
                    break;
                case xlObj._id + "_Ribbon_Home_Clipboard_Paste":
                case xlObj._id + "_Ribbon_Home_Clipboard_PasteOptions":
                    xlObj.XLClipboard._isSpecial = !(args.ID === "PasteValues");
                    xlObj.XLClipboard.paste();
                    break;
                case xlObj._id + "_Ribbon_Home_Actions_Undo":
                    xlObj.XLClipboard._triggerKeyDown(90, true);
                    break;
                case xlObj._id + "_Ribbon_Home_Actions_Redo":
                    xlObj.XLClipboard._triggerKeyDown(89, true);
                    break;
                case xlObj._id + "_Ribbon_Home_Alignment_WrapText":
                    xlObj._textFormatting("wrapText");
                    break;
                case xlObj._id + "_Ribbon_exportXL":
                    xlObj.XLExport["export"](ej.Spreadsheet.exportType.Excel);
                    break;
                case xlObj._id + "_Ribbon_exportCsv":
                    xlObj.XLExport["export"](ej.Spreadsheet.exportType.Csv);
                    break;
                case xlObj._id + "_Ribbon_exportPdf":
                    xlObj.XLExport["export"](ej.Spreadsheet.exportType.Pdf);
                    break;
                case xlObj._id + "_Ribbon_PageLayout_Print_Print":
                    xlObj.XLPrint.printSheet(sheetIdx);
                    break;
                case xlObj._id + "_Ribbon_PageLayout_Print_PrintSelected":
                    xlObj.XLPrint.printSelection(sheetIdx);
                    break;
                case xlObj._id + "_Ribbon_new":
                    xlObj._cellFormatHandler(this._id.replace(xlObj._id + "_Ribbon_", ""), args.selectedText);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_Bold":
                    style[sstyles.FontWeight] = args.model.toggleState ? "bold" : "normal";
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_Italic":
                    style[sstyles.FontStyle] = args.model.toggleState ? "italic" : "normal";
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_Underline":
                case xlObj._id + "_Ribbon_Home_Font_StrikeThrough":
                    var txtDStyle = xlObj.XLFormat.getFormatFromHashCode(xlObj.XLFormat.getFormatClass(activeCell[0].className))["text-decoration"] || "";
                    if(splitId.indexOf("StrikeThrough")>-1)
						splitId[splitId.indexOf("StrikeThrough")] = "line-through";
					else if(splitId.indexOf("Underline")>-1)
						splitId[splitId.indexOf("Underline")] = "underline";
					if (args.model.toggleState) {
                        txtDStyle = txtDStyle.replace("none", "");
                        if (txtDStyle) {
                            if (txtDStyle.indexOf("underline") < 0)
                                style[sstyles.TextDecoration] = txtDStyle + " " + splitId[splitId.length - 1];
                            else
                                style[sstyles.TextDecoration] = splitId[splitId.length - 1] + " " + txtDStyle;
                        }
                        else
                            style[sstyles.TextDecoration] = splitId[splitId.length - 1];
                    }
                    else {
                        txtDStyle = $.trim(txtDStyle.replace(splitId[splitId.length - 1], ""));
                        style[sstyles.TextDecoration] = txtDStyle.length ? txtDStyle : "none";
                    }
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_FontSize":
                    style[sstyles.FontSize] = args.value;
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_IncreaseFontSize":
                case xlObj._id + "_Ribbon_Home_Font_DecreaseFontSize":
                    if (this._id == xlObj._id + "_Ribbon_Home_Font_IncreaseFontSize") {
                        selectedIndex = !ej.isNullOrUndefined(fsObj.selectedIndexValue) ? fsObj.selectedIndexValue + 1 : 6; //6-default increase fonsize index
                        !ej.isNullOrUndefined(xlObj.XLRibbon._fontSize[selectedIndex]) && fsObj.option({ selectedItemIndex: selectedIndex });
                    }
                    else if (this._id == xlObj._id + "_Ribbon_Home_Font_DecreaseFontSize") {
                        selectedIndex = !ej.isNullOrUndefined(fsObj.selectedIndexValue) ? fsObj.selectedIndexValue - 1 : 4; //6-default decrease fonsize index
                        !ej.isNullOrUndefined(xlObj.XLRibbon._fontSize[selectedIndex]) && fsObj.option({ selectedItemIndex: selectedIndex });
                    }
                    break;
                case xlObj._id + "_Ribbon_Home_Alignment_AlignLeft":
                case xlObj._id + "_Ribbon_Home_Alignment_AlignRight":
                case xlObj._id + "_Ribbon_Home_Alignment_AlignCenter":
                    element = $(this.element.parents("div").eq(1)).find(".e-text-align");
                    if (!ej.isNullOrUndefined(element[0])) {
                        $("#" + element[0].id).ejToggleButton("option", "toggleState", false);
                        element.removeClass("e-text-align");
                        (element[0].id != this.element[0].id) && this.element.addClass("e-text-align");
                    }
                    else
                        this.element.addClass("e-text-align");
                    style[sstyles.TextAlign] = args.model.toggleState ? splitId[splitId.length - 1].split("Align")[1] : "left";
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_Home_Alignment_DecreaseIndent":
                case xlObj._id + "_Ribbon_Home_Alignment_IncreaseIndent":
                    var cellStyle, i, len, rightCnt = 0, size, isRightAlign = false, cellIndex;
                    if (selCells.length < 2) {
                        cellIndex = xlObj.getActiveCell();
                        cellStyle = xlObj.XLFormat.getFormatFromHashCode(xlObj.XLFormat.getFormatClass(xlObj.getCell(cellIndex.rowIndex, cellIndex.colIndex)[0].className));
                        size = (sstyles.TextIndent in cellStyle ? (this._id === xlObj._id + "_Ribbon_Home_Alignment_IncreaseIndent" ? Number(cellStyle[sstyles.TextIndent].replace("pt", "")) + 6 : Number(cellStyle[sstyles.TextIndent].replace("pt", "")) - 6) : (this._id === xlObj._id + "_Ribbon_Home_Alignment_DecreaseIndent" ? -6 : 6));
                        xlObj.XLRibbon._applyTextIndent(cellIndex, cellStyle, size, this);
                    }
                    else {
                        for (i = 0, len = selCells.length; i < len; i++) {
                            cellStyle = xlObj.XLFormat.getFormatFromHashCode(xlObj.XLFormat.getFormatClass(xlObj.getCell(selCells[i].rowIndex, selCells[i].colIndex)[0].className));
                            if (cellStyle[sstyles.TextAlign] == "right")
                                rightCnt++;
                        }
                        if (rightCnt === selCells.length)
                            isRightAlign = true;
                        for (i = 0, len = selCells.length; i < len; i++) {
                            cellStyle = xlObj.XLFormat.getFormatFromHashCode(xlObj.XLFormat.getFormatClass(xlObj.getCell(selCells[i].rowIndex, selCells[i].colIndex)[0].className));
                            if (!isRightAlign)
                                cellStyle[sstyles.TextAlign] = "left";
                            size = (sstyles.TextIndent in cellStyle ? (this._id === xlObj._id + "_Ribbon_Home_Alignment_IncreaseIndent" ? Number(cellStyle[sstyles.TextIndent].replace("pt", "")) + 6 : Number(cellStyle[sstyles.TextIndent].replace("pt", "")) - 6) : (this._id === xlObj._id + "_Ribbon_Home_Alignment_DecreaseIndent" ? -6 : 6));
                            xlObj.XLRibbon._applyTextIndent(selCells[i], cellStyle, size, this);
                        }
                    }
                    xlObj.XLSelection.refreshSelection();
                    xlObj.XLDragFill.positionAutoFillElement();
                    break;
                case xlObj._id + "_Ribbon_Home_Alignment_TopAlign":
                case xlObj._id + "_Ribbon_Home_Alignment_MiddleAlign":
                case xlObj._id + "_Ribbon_Home_Alignment_BottomAlign":
                    element = $(this.element.parents("div").eq(1)).find(".e-vertical-align");
                    if (!ej.isNullOrUndefined(element[0])) {
                        $("#" + element[0].id).ejToggleButton("option", "toggleState", false);
                        element.removeClass("e-vertical-align");
                        (element[0].id != this.element[0].id) && this.element.addClass("e-vertical-align");
                    }
                    else
                        this.element.addClass("e-vertical-align");
                    style[sstyles.VerticalAlign] = args.model.toggleState ? splitId[splitId.length - 1].split("Align")[0] : "bottom";
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_FontFamily":
                    style[sstyles.FontFamily] = args.text;
                    temp["style"] = style;
                    xlObj.XLFormat.format(temp);
                    break;
                case xlObj._id + "_Ribbon_PageLayout_Show_Headings":
                    xlObj.showHeadings(args.isChecked);
                    break;
                case xlObj._id + "_Ribbon_PageLayout_Show_Gridlines":
                    xlObj.showGridlines(args.isChecked);
                    break;
                case xlObj._id + "_Ribbon_PageLayout_PageLayout_PageSize":
                case xlObj._id + "_Ribbon_PageLayout_PageLayout_PageSizeOptions":
                    var value = !ej.isNullOrUndefined(args.ID) ? args.ID : args.model.prefixIcon.substring(12);
                    xlObj.XLPrint._printSetting(value);
                    break;
                case xlObj._id + "_Ribbon_Home_Number_NumberFormat":
                    temp["type"] = args.text.toLowerCase();
                    if (temp.type !== "custom")
                        xlObj.XLFormat.format(temp);
                    else 
                        xlObj._showDialog(xlObj._id + "_FormatCells");
                    break;
                case xlObj._id + "_Ribbon_Home_Number_IncreaseDecimal":
                case xlObj._id + "_Ribbon_Home_Number_DecreaseDecimal":
                    if (activeCell.data("type") != "number" && $.isNumeric(xlObj.XLEdit.getPropertyValueByElem(activeCell))) {
                        xlObj.XLRibbon._isSetModel = true;
                        cfObj.option({ selectedItemIndex: 1 }); //number type
                        xlObj.XLRibbon._isSetModel = false;
                    }
                    xlObj.XLFormat.updateDecimalPlaces(splitId[splitId.length - 1]);
                    break;
                case xlObj._id + "_Ribbon_Home_Number_Accounting":
                case xlObj._id + "_Ribbon_Home_Number_Percentage":
                    this._id === xlObj._id + "_Ribbon_Home_Number_Accounting" ? cfObj.option({ selectedItemIndex: 3 }) : cfObj.option({ selectedItemIndex: 4 });
                    temp["type"] = cfObj.selectedTextValue.toLowerCase();
                    break;
                case xlObj._id + "_Ribbon_Home_Number_CommaStyle":
                    cfObj.option({ selectedItemIndex: 1 });
                    temp["type"] = cfObj.selectedTextValue.toLowerCase();
                    break;
                case xlObj._id + "_Ribbon_Data_SortFilter_SortAtoZ":
                    xlObj.XLSort._sortHandler("SortAtoZ");
                    break;
                case xlObj._id + "_Ribbon_Data_SortFilter_SortZtoA":
                    xlObj.XLSort._sortHandler("SortZtoA");
                    break;
                case xlObj._id + "_Ribbon_Data_SortFilter_Filter":
                    xlObj.XLFilter.filter();
                    break;
                case xlObj._id + "_Ribbon_Data_SortFilter_ClearFilter":
                    cname = xlObj.XLEdit.getPropertyValue(xlObj.getActiveCell().rowIndex, xlObj.getActiveCell().colIndex, "tableName");
                    if (ej.isNullOrUndefined(cname))
                        xlObj.XLFilter.clearFilter();
                    else {
                        tid = xlObj._getTableID(cname);
                        xlObj.XLFilter._clearFilterTable(xlObj.getActiveSheetIndex(), tid, true);
                    }
                    break;
                case xlObj._id + "_Ribbon_Home_Font_BorderColor":
                    obj = $('#' + xlObj._id + '_Ribbon_BorderColor').data('ejColorPicker');
                    !ej.isNullOrUndefined(obj) && (obj.hide());
                    !ej.isNullOrUndefined(args.value) && (xlObj._borderColor = args.value);
                    break;
                case xlObj._id + "_Ribbon_Home_Font_Border":
                    var alphRange;
                    if ((xlObj._borderStyles.indexOf(args.ID) < 0)) {
                        if (ej.isNullOrUndefined(args.ID))
                            args.ID = args.model.prefixIcon.substring(12);
                        else
                            args.ID.indexOf("bordercolor") < 0 && $(this.element).find(".e-icon ").removeClass().addClass("e-icon e-ss-" + args.ID) && this.option({ prefixIcon: "e-icon e-ss-" + args.ID });
                    }
                    else
                        xlObj.XLRibbon._updateBordeStyle(args);
                    hexcode = xlObj._borderColor || '#000000';
                    startCell = sheet._startCell;
                    endCell = sheet._endCell;
                    alphRange = xlObj._getAlphaRange(sheetIdx, startCell.rowIndex, startCell.colIndex, endCell.rowIndex, endCell.colIndex);
                    if (xlObj.model.allowSelection && (xlObj.XLSelection._isOutsideBordering || xlObj.XLSelection._isGridBordering))
                        !(xlObj._borderStyles.indexOf(args.ID) > -1) && (args.ID.indexOf("bordercolor") < 0) && (xlObj.XLSelection._isOutsideBordering = xlObj.XLSelection._isGridBordering = false);
                    else
                        xlObj.setBorder({ "type": args.ID, "color": hexcode, "style": xlObj._borderStyle }, alphRange);
                    break;
                case xlObj._id + "_Ribbon_Data_DataTools_DataValidation":
                case xlObj._id + "_Ribbon_Data_DataTools_DataValidationOptions":
                    xlObj._showDialog(this._id);
                    if (args.ID == "ClearVal")
                        xlObj.XLValidate.clearDV();
                    else if (args.ID == "HighlightVal")
                        xlObj.XLValidate.highlightInvalidData();
                    else if (args.ID == "ClearHLVal")
                        xlObj.XLValidate.clearHighlightedValData();
                    else {
                        $("#" + xlObj._id + "_ValDialog").ejDialog("open");
                        if ($.validator)
                            $("#" + xlObj._id + "_Form_ValDialog").validate().resetForm();
                        $("#" + xlObj._id + "_Ribbon_ddType_wrapper").focus();
                        var rules = xlObj.XLEdit.getPropertyValueByElem(xlObj.getActiveCellElem(sheetIdx), "rule");
                        if (rules) {
                            var rule = rules.customVal, splitStr = rule.split("_");
                            if (rule.indexOf("list") > -1) {
                                $("#" + xlObj._id + "_Ribbon_ddType").ejDropDownList('option', 'selectedItemIndex', 5);
                                $("#" + xlObj._id + "_Ribbon_btnMin").val(splitStr[0]);
                            }
                            else {
                                var index;
                                xlObj.XLRibbon._types.filter(function (value, i) { if (splitStr[4] === value.value) { index = i; return true; } });
                                $("#" + xlObj._id + "_Ribbon_ddType").ejDropDownList('option', 'selectedItemIndex', index);
                                xlObj.XLRibbon._actions.filter(function (value, i) { if (splitStr[0] === value.value) { index = i; return true; } });
                                $("#" + xlObj._id + "_Ribbon_ddAction").ejDropDownList('option', 'selectedItemIndex', index);
                                $("#" + xlObj._id + "_Ribbon_btnMin").val(splitStr[1].replace("^", ""));
                                $("#" + xlObj._id + "_Ribbon_btnMax").val(splitStr[2].replace("^", ""));
                            }
                            $("#" + xlObj._id + "_Ribbon_blank").ejCheckBox("option", "checked", !rules.required);
                            $("#" + xlObj._id + "_Ribbon_freetext").ejCheckBox("option", "checked", JSON.parse(splitStr[splitStr.length - 3]));
                        }
                        else {
                            $("#" + xlObj._id + "_Ribbon_ddType").ejDropDownList('option', 'selectedItemIndex', 1);
                            $("#" + xlObj._id + "_Ribbon_ddAction").ejDropDownList('option', 'selectedItemIndex', 6);
                            $("#" + xlObj._id + "_Ribbon_btnMin").val("");
                            $("#" + xlObj._id + "_Ribbon_btnMax").val("");
                            $("#" + xlObj._id + "_Ribbon_blank").ejCheckBox("option", "checked", true);
                            $("#" + xlObj._id + "_Ribbon_freetext").ejCheckBox("option", "checked", true);
                        }
                    }
                    break;
                case xlObj._id + "_Ribbon_Home_Styles_ConditionalFormatting":
                    if (!args.ID.length)
                        break;
                    xlObj.XLRibbon._currentCFormat = args.ID;
                    if (args.ID.startsWith("clear"))
						(args.ID === "clearselected") ? xlObj.XLCFormat.clearCF(xlObj.getSheet(sheetIdx).selectedRange) : xlObj.XLCFormat.clearCF();
                    else {
                        if (!(args.ID.indexOf("_HLCellRules") > 0 || args.ID.indexOf("_ClearRules") > 0 || args.ID.indexOf("_CreateRule") < -1)) {
                            xlObj._showDialog(this._id);
                            xlObj.XLRibbon._renderCFDialog(args);
                        }
                    }
                    break;
                case xlObj._id + "_Ribbon_Others_Editing_FindSelect":
                    var fRTabObj;
                    xlObj._showDialog(this._id);
                    gotoTabObj = $("#" + xlObj._id + "_GoToDlgTab").data("ejTab"), fRTabObj = $("#" + xlObj._id + "_FRDialog_FPDlgTab").data("ejTab");
                    switch (args.ID) {
                        case "Find":
							(xlObj._responsiveHeight < 365) && $("#" + xlObj._id + "_FRDialog_wrapper").css('top', '0px');
                            $("#" + xlObj._id + "_FRDialog").ejDialog("open");
                            xlObj.XLRibbon._refreshFRDlg();
                            fRTabObj.option({ selectedItemIndex: 0 });
                            $("#" + xlObj._id + "_Ribbon_textFind").focus().setInputPos($("#" + xlObj._id + "_Ribbon_textFind").val().length);
                            if (xlObj.model.isReadOnly)
                                $("#" + xlObj._id + "_FRDialog_FPDlgTab").ejTab("option", { disabledItemIndex: [1, 2] });
                            else
                                $("#" + xlObj._id + "_FRDialog_FPDlgTab").ejTab("option", { enabledItemIndex: [1, 2] });
                            break;
                        case "Replace":
							(xlObj._responsiveHeight < 365) && $("#" + xlObj._id + "_FRDialog_wrapper").css('top', '0px');
                            $("#" + xlObj._id + "_FRDialog").ejDialog("open");
                            xlObj.XLRibbon._refreshFRDlg();
                            fRTabObj.option({ selectedItemIndex: 1 });
                            $("#" + xlObj._id + "_Ribbon_textFind").focus().setInputPos($("#" + xlObj._id + "_Ribbon_textFind").val().length);
                            break;
                        case "GoTo":
                            $("#" + xlObj._id + "_GoDialog").ejDialog("open");
                            gotoTabObj.option({ selectedItemIndex: 0 });
                            $("#" + xlObj._id + "_textRef").focus().setInputPos($("#" + xlObj._id + "_Ribbon_textFind").val().length);
                            if ($.validator)
                                $('#' + xlObj._id + '_Form_GoToDiv').validate().resetForm();
                            break;
                        case "GoToSpecial":
                            $("#" + xlObj._id + "_GoDialog").ejDialog("open");
                            gotoTabObj.option({ selectedItemIndex: 1 });
                            $("#" + xlObj._id + "_Blanks").focus();
                            break;
                        default:
                            xlObj.XLSearch._applyGoToRule(args.ID.toLowerCase(), true, true, true, true);
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Others_CalCulation_CalculationOptions":
                    switch (args.ID) {
                        case xlObj._id + "_CalcAuto":
                            xlObj.XLEdit.calcOption(true);
                            break;
                        case xlObj._id + "_CalcManual":
                            xlObj.XLEdit.calcOption(false);
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Others_CalCulation_CalculateNow":
                    xlObj.XLEdit.calcNow();
                    break;
                case xlObj._id + "_Ribbon_Others_CalCulation_CalculateSheet":
                    xlObj.XLEdit.calcNow(xlObj.getActiveSheetIndex());
                    break;
                case xlObj._id + "_Ribbon_Home_Clipboard_FormatPainter":
                    if (!args.model.toggleState) {
                        xlObj.performSelection(xlObj.getActiveCell(), xlObj.getActiveCell());
                        return false;
                    }
                    xlObj.XLFormat._formatEnable = true;
                    sheetCont.removeClass("e-ss-cursor");
                    sheetCont.addClass("e-ss-fpcursor");
                    xlObj.XLFormat._formatPainter();
                    break;
                case xlObj._id + '_Ribbon_Design_Tools_ConvertToRange':
                    xlObj.XLFormat.convertToRange({alert: true});
                    break;
                case xlObj._id + '_Ribbon_Design_Tools_ResizeTable':
                    tid = parseInt(document.getElementById(xlObj._id + '_tableid').value);
                    range = sheet.tableManager[tid].range;
					xlObj._showDialog(xlObj._id + '_Ribbon_Design_Tools_ResizeTable')
                    $('#' + xlObj._id + '_fatresizetablerange').val(xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]));
                    $('#' + xlObj._id + '_fatresizetabledlg').ejDialog('open');
                    break;
                case xlObj._id + '_Ribbon_Design_TableStyleOptions_FirstColumn':
                case xlObj._id + '_Ribbon_Design_TableStyleOptions_LastColumn':
                    tmgr = sheet.tableManager, tid = document.getElementById(xlObj._id + '_tableid').value;
                    if (tid in tmgr) {
                        range = tmgr[tid].range;
                        range = this._id === xlObj._id + '_Ribbon_Design_TableStyleOptions_FirstColumn' ? xlObj._getProperAlphaRange(sheetIdx, range[0] + 1, range[1], range[2], range[1]) : xlObj._getProperAlphaRange(sheetIdx, range[0] + 1, range[3], range[2], range[3]);
                        if (this._id === xlObj._id + '_Ribbon_Design_TableStyleOptions_FirstColumn') {
                            args.isChecked ? tmgr[tid]["firstColumn"] = true : delete tmgr[tid]["firstColumn"];
                            curProp = "firstColumn";
                        }
                        else {
                            args.isChecked ? tmgr[tid]["lastColumn"] = true : delete tmgr[tid]["lastColumn"];
                            curProp = "lastColumn";
                        }
                        xlObj._dupDetails = true;
                        xlObj.XLFormat.format({ style: { 'font-weight': args.isChecked ? 'bold' : 'normal' } }, range);
                        xlObj._dupDetails = false;
                        details = { sheetIndex: sheetIdx, reqType: "format-table", action: "firstlastcolumn", range: range, check: args.isChecked, id: args.model.id, tableId: parseInt(tid), prop: curProp };
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                    break;
                case xlObj._id + '_Ribbon_Design_TableStyleOptions_TotalRow':
                    var tid = document.getElementById(xlObj._id + '_tableid').value;
                    (tid in sheet.tableManager) && xlObj.XLFormat._calculateTotalRow(sheetIdx, tid, args.isChecked, args.isChecked);
                    break;
                case xlObj._id + '_Ribbon_Design_TableStyleOptions_FilterColumn':
					if(!xlObj.model.allowFiltering)
						return;
                    tmgr = sheet.tableManager, tid = document.getElementById(xlObj._id + '_tableid').value;
                    xlObj.XLFilter._clearFilterTableIcon(sheetIdx, parseInt(document.getElementById(xlObj._id + '_tableid').value));
                    tmgr[tid]["isFilter"] = args.isChecked;
                    details = { sheetIndex: sheetIdx, reqType: "format-table", action: "filtericon", id: args.model.id, check: args.isChecked, tableId:parseInt(tid) };
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                    break;
                case xlObj._id + '_Ribbon_Insert_Tables_Table':
                    xlObj._showDialog(this._id);
                    xlObj.XLRibbon._openFATDlg();
                    break;
                case xlObj._id + "_Ribbon_Review_Comments_NewComment":
                    $("#" + xlObj._id + "_Ribbon_Review_Comments_NewComment").text() === xlObj._getLocStr("NewComment") ? xlObj.XLComment.setComment() : xlObj.XLComment.editComment();
                    break;
                case xlObj._id + "_Ribbon_Review_Comments_DeleteComment":
                    xlObj.XLComment.deleteComment();
                    break;
                case xlObj._id + "_Ribbon_Review_Comments_ShowAllComments":
                    xlObj.XLComment.showAllComments();
                    break;
                case xlObj._id + "_Ribbon_Review_Comments_ShowHideComment":
                    xlObj.XLComment.showHideComment();
                    break;
                case xlObj._id + "_Ribbon_Review_Comments_NextComment":
                    xlObj.XLComment.findNextComment();
                    break;
                case xlObj._id + "_Ribbon_Review_Comments_PreviousComment":
                    xlObj.XLComment.findPrevComment();
                    break;
                case xlObj._id + "_Ribbon_Insert_Links_Hyperlink":
                    xlObj._showDialog(this._id);
                    break;
                case xlObj._id + "_Ribbon_Home_Editing_SortFilter":
                    switch (args.ID) {
                        case "Ribbon_SortAtoZ":
                        case "Ribbon_SortZtoA":
                            xlObj.model.allowSorting && xlObj.XLSort._sortHandler(args.ID);
                            break;
                        case "Ribbon_Filter":
                            xlObj.model.allowFiltering && xlObj.XLFilter.filter();
                            break;
                        default:
                            cname = xlObj.getCell(xlObj.getActiveCell().rowIndex, xlObj.getActiveCell().colIndex)[0].className;
                            if (cname.indexOf("e-table") < 0)
                                xlObj.XLFilter.clearFilter();
                            else {
                                tid = xlObj._getTableID(cname);
                                xlObj.XLFilter._clearFilterTable(xlObj.getActiveSheetIndex(), parseInt(tid), true);
                            }
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Others_Cells_InsertCell":
                case xlObj._id + "_Ribbon_Others_Cells_InsertCellOptions":
                    if (selCells.length < 1)
                        return;
                    startCell = selCells[0], endCell = selCells[selCells.length - 1];
                    switch (args.ID) {
                        case "InsertCells":
                            if (xlObj._getJSSheetRowHeaderContent(sheetIdx).find('.e-rowselected').length)
                                xlObj.insertEntireRow(startCell.rowIndex, endCell.rowIndex);
                            else if (xlObj._getJSSheetHeader(sheetIdx).find('.e-colselected').length) {
                                xlObj._insDelStatus = "insert";
                                xlObj.insertEntireColumn(startCell.colIndex, endCell.colIndex);
                            }
                            else 
                                xlObj._showDialog(this._id);
                            break;
                        case "InsertSheetRows":
                            xlObj.insertEntireRow(startCell.rowIndex, endCell.rowIndex);
                            break;
                        case "InsertSheetColumns":
                            xlObj._insDelStatus = "insert";
                            xlObj.insertEntireColumn(startCell.colIndex, endCell.colIndex);
                            break;
                        case "InsertSheet":
                            xlObj.insertSheet();
                            break;
                        default:
                            if (xlObj.element.find('.e-rowselected').length > 0)
                                xlObj.insertEntireRow(startCell.rowIndex, endCell.rowIndex);
                            else if (xlObj.element.find('.e-colselected').length > 0) {
                                xlObj._insDelStatus = "insert";
                                xlObj.insertEntireColumn(startCell.colIndex, endCell.colIndex);
                            }
                            else
                                xlObj.insertShiftBottom(startCell, endCell);
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Others_Cells_DeleteCell":
                case xlObj._id + "_Ribbon_Others_Cells_DeleteCellOptions":
                    if (selCells.length < 1)
                        return;
                    startCell = selCells[0], endCell = selCells[selCells.length - 1];
                    switch (args.ID) {
                        case "DeleteCells":
                            if (xlObj._getJSSheetRowHeaderContent(sheetIdx).find('.e-rowselected').length)
                                xlObj.deleteEntireRow(startCell.rowIndex, endCell.rowIndex, []);
                            else if (xlObj._getJSSheetHeader(sheetIdx).find('.e-colselected').length) {
                                xlObj._insDelStatus = "delete";
                                xlObj.deleteEntireColumn(startCell.colIndex, endCell.colIndex, []);
                            }
                            else 
                                xlObj._showDialog(this._id);
                            break;
                        case "DeleteSheetRows":
                            xlObj.deleteEntireRow(startCell.rowIndex, endCell.rowIndex, []);
                            break;
                        case "DeleteSheetColumns":
                            xlObj._insDelStatus = "delete";
                            xlObj.deleteEntireColumn(startCell.colIndex, endCell.colIndex, []);
                            break;
                        case "DeleteSheet":
                            xlObj.deleteSheet(sheetIdx);
                            break;
                        default:
                            if (xlObj.element.find('.e-rowselected').length > 0)
                                xlObj.deleteEntireRow(startCell.rowIndex, endCell.rowIndex);
                            else if (xlObj.element.find('.e-colselected').length > 0) {
                                xlObj._insDelStatus = "insert";
                                xlObj.deleteEntireColumn(startCell.colIndex, endCell.colIndex);
                            }
                            else
                                xlObj.deleteShiftUp(startCell, endCell);
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Home_Editing_Clear":
                    range = sheet.selectedRange;
                    switch (args.ID) {
                        case "Clear_All":
                            range = xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);
                            xlObj.clearAll(range);
                            break;
                        case "Clear_Formats":
                            range = xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);
                            xlObj.clearAllFormat(range);
                            break;
                        case "Clear_Contents":
                            range = xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);
                            xlObj.clearContents(range);
                            break;
                        case "Clear_Comments":
                            xlObj.clearComments(sheetIdx);
                            break;
                        default:
                            xlObj.clearHyperlinks();
                            break;
                    }
                    xlObj.model.allowSelection && xlObj.XLSelection._clearBorder(xlObj._arrayAsString(xlObj._cutFocus), sheetIdx);
                    break;
                case xlObj._id + "_Ribbon_Insert_Tables_PivotTable":
                    xlObj._showDialog(this._id);
                    var dlg = $("#" + xlObj._id + "_PvtDialog"), sheet = xlObj.getSheet(sheetIdx);
                    info = { sheetIndex: sheetIdx, model: xlObj.model.sheets };
                    if (xlObj._trigger("_createPivotTable", info))
                        return;
                    $("#" + xlObj._id + "_Ribbon_PvtRange").val("");
                    $("#" + xlObj._id + "_Ribbon_PvtLocation").val("");
                    if (sheet._selectedCells.length > 1) {
                        var range = sheet.selectedRange;
                        $("#" + xlObj._id + "_Ribbon_PvtRange").val(sheet.sheetInfo.text + "!$" + xlObj._generateHeaderText(range[1] + 1) + "$" + (range[0] + 1) + ":$" + xlObj._generateHeaderText(range[3] + 1) + "$" + (range[2] + 1));
                    }
                    else if (!xlObj.isUndefined(xlObj.XLEdit.getPropertyValueByElem(xlObj.getActiveCellElem()))) {
                        xlObj.selectAll(false);
                        $("#" + xlObj._id + "_Ribbon_PvtRange").val(sheet.sheetInfo.text + "!$" + xlObj._generateHeaderText(sheet._startCell.colIndex + 1) + "$" + (sheet._startCell.rowIndex + 1) + ":$" + xlObj._generateHeaderText(sheet._endCell.colIndex + 1) + "$" + (sheet._endCell.rowIndex + 1));
                    }
                    dlg.find(".e-ss-changerange").show();
                    dlg.find(".e-ss-movepvttbl").show();
                    dlg.data("ejDialog").option("title", xlObj._getLocStr("CreatePivotTable"));
                    $("#" + xlObj._id + "_dlg_newsheet").click();
                    dlg.ejDialog("open");
                    break;
                case xlObj._id + "_Ribbon_Analyze_Show_FieldList":
                    if (args.model.toggleState) {
                        xlObj.XLPivot._displayActPanel = true;
                        xlObj.getActivationPanel().find("#" + xlObj._id + "_PivotTableSchema_" + xlObj._getContent(sheetIdx).find(".e-ss-activepivot")[0].id).show();
                        xlObj.showActivationPanel();
                    }
                    else {
                        xlObj.hideActivationPanel();
                        xlObj.XLPivot._displayActPanel = false;
                    }
                    break;
                case xlObj._id + "_Ribbon_Analyze_Actions_ClearAll":
                    var pvtID = xlObj.element.find(".e-ss-activepivot")[0].id, pivotGrid = $("#" + pvtID).data("ejPivotGrid"), pivotSchema;                                            
                    pivotSchema = $("#" + xlObj._id + "_PivotTableSchema_" + pvtID).data("ejPivotSchemaDesigner");
                    xlObj.XLPivot._clearFilters(pivotGrid, pivotSchema);
                    pivotSchema.model.pivotControl = pivotGrid;                
                    break;
                case xlObj._id + "_Ribbon_Analyze_Actions_MovePivotTable":
                    var dlg = $("#" + xlObj._id + "_PvtDialog"), pvtObj, range, sheetIdx = xlObj.getActiveSheetIndex();
                    dlg.find(".e-ss-movepvttbl").show();
                    dlg.find(".e-ss-changerange").hide();                 
                    pvtObj = xlObj.getSheet(sheetIdx).pivotMngr.pivot[xlObj.element.find(".e-ss-activepivot")[0].id];                                     
                    $("#" + xlObj._id + "_Ribbon_PvtLocation").val(xlObj.getSheet(sheetIdx).sheetInfo.text + "!$" + xlObj._generateHeaderText(pvtObj.colIndex + 1) + "$" + (pvtObj.rowIndex + 1));
                    dlg.data("ejDialog").option("title", xlObj._getLocStr("MovePivotTable"));
                    $("#" + xlObj._id + "_dlg_existsheet").click();
                    dlg.ejDialog("open");                   
                    break;
                case xlObj._id + "_Ribbon_Analyze_DataSource_Refresh":
                    xlObj.XLPivot.refreshDataSource();
                    break;
                case xlObj._id + "_Ribbon_Analyze_DataSource_ChangeDataSource":
                    var dlg = $("#" + xlObj._id + "_PvtDialog"), pvtObj, range, dataSheetIdx;
                    dlg.find(".e-ss-changerange").show();
                    dlg.find(".e-ss-movepvttbl").hide();                    
                    pvtObj = xlObj.getSheet(sheetIdx).pivotMngr.pivot[xlObj.element.find(".e-ss-activepivot")[0].id];
                    range = pvtObj.dataRange;
                    dataSheetIdx = xlObj.XLPivot._getSheetIdxFromName(pvtObj.dataSheetName);
                    $("#" + xlObj._id + "_Ribbon_PvtRange").val(pvtObj.dataSheetName + "!$" + xlObj._generateHeaderText(range[1] + 1) + "$" + (range[0] + 1) + ":$" + xlObj._generateHeaderText(range[3] + 1) + "$" + (range[2] + 1));
                    dlg.data("ejDialog").option("title", xlObj._getLocStr("ChangePivotTableDataSource"));
                    dlg.ejDialog("open");
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_Type_ChangeChartType":
                    xlObj._showDialog(this._id);
                    xlObj.XLRibbon._refreshChartTypeDlg();
                    break;
                case xlObj._id + "_Ribbon_Insert_Illustrations_Pictures":
                    if (xlObj.model.importSettings.importMapper.length < 1) {
                        xlObj._showAlertDlg("Alert", "ImportExportUrl", "", 266);
                        return;
                    }
                    xlObj._uploadImage = true;
                    $("#" + xlObj._id + "_file .e-uploadinput").click();
                    xlObj.XLRibbon._toggleFormatTab();
                    break;
                case xlObj._id + "_Ribbon_Others_Formulas_NameManager":
                    xlObj.XLRibbon._openNameManagerDlg();
                    xlObj.XLRibbon._isNmgrid = "NameManager";
                    break;
                case xlObj._id + "_Ribbon_Others_Formulas_DefineName":
					xlObj._showDialog(xlObj._id + "_Ribbon_Others_NameManager");
                    var grid = $("#" + xlObj._id + "_nmgrid").data("ejGrid");
                    grid.getContentTable().find('td').addClass("e-ss-emptyrecord")
                    if (grid.model.dataSource.length < 1)
                        grid.getContentTable().find('td').addClass("e-ss-emptyrecord");
                    else
                        grid.getContentTable().find('.e-ss-emptyrecord').removeClass("e-ss-emptyrecord");
                    xlObj.XLRibbon._refreshNMDlg();
                    xlObj.XLRibbon._isNmgrid = "DefineName";
                    break;
                case xlObj._id + "_Ribbon_Others_Window_FreezePanes":
                    switch (args.ID) {
                        case "freezePanes":
                            xlObj.XLFreeze.freezePanes();
                            break;
                        case "FreezeTopRow":
                            xlObj.XLFreeze.freezeTopRow();
                            break;
                        case "FreezeFirstColumn":
                            xlObj.XLFreeze.freezeLeftColumn();
                            break;
                        case "UnFreezePanes":
                            xlObj.XLFreeze.unfreezePanes();
                        default:
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Home_Alignment_Merge":
                    if (ej.isNullOrUndefined(args.ID)) {
                        xlObj.mergeCenter = true;
                        xlObj.mergeCells();
                    }
                    switch (args.ID) {
                        case "MergeCells":
                            xlObj.mergeCells();
                            break;
                        case "MergeAcross":
                            xlObj.mergeAcrossCells();
                            break;
                        case "MergeAndCenter":
                            xlObj.mergeCenter = true;
                            xlObj.mergeCells();
                            break;
                        case "UnmergeCells":
                            xlObj.unmergeCells(sheet.selectedRange);
                            break;
                    }
                    break;
                case xlObj._id + "_Ribbon_Home_Editing_AutoSum":
                    cellRange = sheet.selectedRange;
                    if (args.type === "click")
                        xlObj.XLRibbon.autoSum("SUM", xlObj._getAlphaRange(sheetIdx, cellRange[0], cellRange[1], cellRange[2], cellRange[3]));
                    else
                        xlObj.XLRibbon.autoSum(args.ID.toUpperCase(), xlObj._getAlphaRange(sheetIdx, cellRange[0], cellRange[1], cellRange[2], cellRange[3]));
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_ChartLayouts_AddChartElement":
                    xlObj.XLChart.updateChartElement(null, args.ID);
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_Size_ChartWidth":
                    xlObj.XLRibbon._changeChartSize("height", args.value);
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_Size_ChartHeight":
                    xlObj.XLRibbon._changeChartSize("width", args.value);
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_Data_SwitchRowColumn":
                    xlObj.XLChart.switchRowColumn();
                    break;
                case xlObj._id + "_Ribbon_PictureColor":
                case xlObj._id + "_Ribbon_Format_Border_PictureBorder":
                    if (["weight", "dashes", xlObj._id + "picturecolor", ""].indexOf(args.ID) === -1) {
                        elem = xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg");
                        var regx = new RegExp("\\b" + "e-shapebdr" + ".*?\\b", "g"), style;
                        if (elem[0].className.match(regx))
                            style = xlObj.XLShape._getImgStyleFromHashCode(elem[0].className.match(regx)[0]);
                        else
                            style = { "border-color": "transparent", "border-width": "1px", "border-style": "solid" };
                        var color = style["border-color"], width = style["border-width"], style = style["border-style"];
                        if (elem[0]) {
                            switch (true) {
                                case this._id.indexOf("PictureColor") > -1:
                                    color = args.value;
                                    break;
                                case args.ID.indexOf("px") > -1:
                                    width = args.ID;
                                    break;
                                case args.ID === "nooutline":
                                    color = "transparent";
                                    break;
                                default:
                                    style = args.ID;
                                    break;
                            }
                            xlObj.XLShape.changePictureBorder(elem[0].id, width, style, color);
                        }
                    }
                    break;
                case xlObj._id + "_Ribbon_Format_Adjust_ResetPicture":
                    xlObj.XLShape.resetPicture(null, args.ID);
                    break;
                case xlObj._id + "_Ribbon_Format_Adjust_ChangePicture":
                    xlObj._uploadImage = true;
                    xlObj.XLShape._changePicture = true;
                    xlObj.element.find("#" + xlObj._id + "_file .e-uploadinput").click();
                    xlObj.XLRibbon._toggleFormatTab();
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_Data_SelectData":
                    xlObj._showDialog(this._id);
                    cid = document.getElementById(xlObj._id + "_chart").value, dataVal = xlObj.XLChart._getShapeObj(cid, "chart");
                    $("#" + xlObj._id + "_crxaxis").val(dataVal.xRange ? xlObj._getAlphaRange(sheetIdx, dataVal.xRange[0], dataVal.xRange[1], dataVal.xRange[2], dataVal.xRange[3]) : "");
                    $("#" + xlObj._id + "_cryaxis").val(dataVal.yRange ? xlObj._getAlphaRange(sheetIdx, dataVal.yRange[0], dataVal.yRange[1], dataVal.yRange[2], dataVal.yRange[3]) : "");
                    $("#" + xlObj._id + "_crlaxis").val(dataVal.lRange ? xlObj._getAlphaRange(sheetIdx, dataVal.lRange[0], dataVal.lRange[1], dataVal.lRange[2], dataVal.lRange[3]) : "");
                    xlObj._selectDataval = { xRange: $("#" + xlObj._id + "_crxaxis").val(), yRange: $("#" + xlObj._id + "_cryaxis").val(), lRange: $("#" + xlObj._id + "_crlaxis").val() }
                    $("#" + xlObj._id + "_chartrangedlg").ejDialog("open");
                    $("#" + xlObj._id + "_crxaxis").focus().setInputPos(0);
                    break;
                case xlObj._id + "_Ribbon_ChartDesign_ChartThemes_ChartThemes":
                    xlObj.XLChart.changeTheme(xlObj.element.find("#" + xlObj._id + "_chart").val(), this._selectedValue);
                    break;
                case xlObj._id + "_Ribbon_Review_Changes_LockCell":
                    xlObj.lockCells(null, args.model.toggleState);
                    break;
                case xlObj._id + "_Ribbon_Review_Changes_ProtectSheet":
                    xlObj.protectSheet(args.model.toggleState);
                    break;
                case xlObj._id + "_Ribbon_Review_Changes_ProtectWorkbook":
                    xlObj._showDialog(this._id);
                    var wrkDlgOption = $("#" + xlObj._id + "_PasswordDialog").data("ejDialog");
                    if (!xlObj.model.exportSettings.password) {
                        wrkDlgOption.option("title", xlObj._getLocStr("ProtectWorkbook"));
                        $("#" + xlObj._id + "_confirm").show();
                    }
                    wrkDlgOption.open();
                    break;              
            }
            if ((this._id.indexOf("Comment") < 0 && this._id.indexOf("FindSelect") < 0) || xlObj.XLSearch._isApplied) {
                xlObj.setSheetFocus();
                xlObj.XLSearch._isApplied = false;
            }
            xlObj._isRibbonClick = false;
        },

        _applyTextIndent: function (cellIdx, cellStyle, size, btnObj) {
          var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), temp = {}, sstyles = ej.Spreadsheet.SupportedStyles,
          textWidth, indentWidth, indent, colWidth, value2, value, cHght, cell = xlObj.getCell(cellIdx.rowIndex, cellIdx.colIndex), sheet = xlObj.getSheet(sheetIdx);
          value2 = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "value2");
          value = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "value");
          if(btnObj._id.indexOf("DecreaseIndent") < 0 && xlObj._hasClass(cell[0], "e-sswraptext") && Math.round((4 / 3) * size) + xlObj._detailsFromGlobalSpan(cellIdx.rowIndex, cellIdx.colIndex, "width", "W") > sheet.columnsWidthCollection[cellIdx.colIndex]) //pt to px onversion and text indent level twice for restrict overflow, while wrap.
              return;
          if (xlObj.isFormula(value))
              value = value2;
          if ((!cellStyle[sstyles.TextIndent] && btnObj._id === xlObj._id + "_Ribbon_Home_Alignment_DecreaseIndent") || (size < 0))
              return false;
          cellStyle[sstyles.TextIndent] = size + "pt";
          if (cellStyle[sstyles.TextAlign] === "center" || (xlObj.isNumber(value) && !cellStyle[sstyles.TextAlign]))
              cellStyle[sstyles.TextAlign] = "left";
          temp["style"] = cellStyle;
          xlObj.XLFormat.format(temp, [cellIdx.rowIndex, cellIdx.colIndex, cellIdx.rowIndex, cellIdx.colIndex]);
          if (cellStyle[sstyles.TextIndent] && !xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "merge") && !xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "mergeIdx")) {
              cHght = cell.outerHeight();
              if (cHght >= xlObj.model.rowHeight) {
                  cell.parent().outerHeight(cHght);
                  sheet.rowsHeightCollection[cellIdx.rowIndex] = cHght;
                  xlObj._updateFormatColl(sheetIdx, cellIdx.rowIndex, cellIdx.colIndex, cHght);
                  xlObj._setRowHdrHeight(sheetIdx, cellIdx.rowIndex);
              }
              textWidth = xlObj._detailsFromGlobalSpan(cellIdx.rowIndex, cellIdx.colIndex, "width", value2, null, true);
              indent = (4 / 3) * size;     //pt to px convertion
              indentWidth = Math.round(indent + textWidth);
              colWidth = sheet.columnsWidthCollection[cellIdx.colIndex];              
              if (xlObj.XLResize && xlObj.isNumber(value) && btnObj._id === xlObj._id + "_Ribbon_Home_Alignment_IncreaseIndent" && indentWidth >= colWidth)
                  xlObj.XLResize.setColWidth(cellIdx.colIndex, 8 + colWidth); // 8 - pt to pix conversion ((4 / 3) * 6)
          }
        },

        _changeChartSize: function (status, value) {
			if(this._ctrlCreated)
				return;
            var xlObj = this.XLObj, formulaBar, pSize, newVal, dataVal = xlObj.XLEdit.getPropertyValue(xlObj.XLShape._picCellIdx.rowIndex, xlObj.XLShape._picCellIdx.colIndex, 'chart')[0], cid = document.getElementById(xlObj._id + "_chart").value, cObj = $("#" + cid).ejChart("instance"), chartEle = $("#" + cid), cProp = xlObj.XLChart._getShapeObj(cid, "chart"), details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "shape", shapeType: "chart", action: status, cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex, prev: { width: cObj.model.size.width, height: cObj.model.size.height } };
            pSize = cObj.model.size;
			if (xlObj.model.allowFormulaBar)
			    formulaBar = xlObj.element.find('.e-formulabar')[0];
			formulaBar && (formulaBar.style.display = "none");			
            if (status === "height") {
                cObj.option("size", { width: value.toString() });
                dataVal.width = value;
				cProp['width'] = value;
                chartEle[0].style.width = value + "px";
                details.cur = { width: value.toString(), height: cObj.model.size.height };
            }
            else {
                cObj.option("size", { height: value.toString() });
                dataVal.height = value;
				cProp['height'] = value;
                chartEle[0].style.height = value + "px";
                details.cur = { width: cObj.model.size.width, height: value.toString() };
            }
			formulaBar && (formulaBar.style.display = "block");
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
			xlObj.XLShape._shapeType = "chart";
			xlObj.XLShape._updateShapeObj(chartEle[0]);
			xlObj.XLShape._shapeType = "img";
        },

        _updateBordeStyle: function (args) {
            var xlObj = this.XLObj;
            xlObj._borderStyle = args.ID && args.ID.length > 0 && args.ID;
        },

        _colorPickerHandler: function (name, args) {
            var xlFormat, xlObj = this.XLObj;
            if (args.type === "open") {
                $("#" + xlObj._id + "_" + name + "_popup").find(".e-buttons, .e-button").hide();
                $("#" + xlObj._id + "_" + name + "_popup").focus();
            }
            else if (args.type === "change") { //color change  
                xlFormat = xlObj.XLFormat;
                var cpObj = $("#" + xlObj._id + "_" + name).data("ejColorPicker");
                if (name === "Ribbon_Home_Font_FontColor") {
                    xlFormat.format({ "style": { "color": args.value } });
                    $("#" + xlObj._id + "_Ribbon_home_Font_Color").find(".e-selected-color").css("background-color", args.value);
                }
                else {
                    xlFormat.format({ "style": { "background-color": args.value } });
                    $("#" + xlObj._id + "_Ribbon_home_Font_Background").find(".e-selected-color").css("background-color", args.value);
                }
                cpObj.hide();
                xlObj._dupDetails = true;
                cpObj.setValue(args.value);
                xlObj._dupDetails = false;
            }
        },

        updateRibbonIcons: function () {
            this._updateRibbonIcons();
        },

        _updateRibbonIcons: function () { //scrip error
            var format, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), actSheet = xlObj.getSheet(sheetIdx);
            if (!this.XLObj.model.showRibbon || (actSheet._isImported && !actSheet._isLoaded))
                return;
            var isLocked, lockbtObj, merge, isWrap, type, style, activeCell,  cfObj = $("#" + xlObj._id + "_Ribbon_Home_Number_NumberFormat").data("ejDropDownList"), tgleBtnElem;
            var fsObj = $("#" + xlObj._id + "_Ribbon_Home_Font_FontSize").data("ejDropDownList"), isVertical = false;
            $("#" + xlObj._id + "_Ribbon_Home_Font_FontSize").css("width", "auto");
            var ffObj = $("#" + xlObj._id + "_Ribbon_Home_Font_FontFamily").data("ejDropDownList"), index = -1, rObj = $("#" + xlObj._id + "_Ribbon").data("ejRibbon"), tabName = rObj.getTabText(rObj.model.selectedItemIndex);
            switch (tabName) {
                case xlObj._getLocStr("HOME"):
                    activeCell = actSheet._activeCell, isWrap = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "wrap"), merge = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "merge");
                    format = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "format"),type = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "type");
                    if (!ej.isNullOrUndefined(xlObj.XLFormat))
                        style = xlObj.XLFormat.getFormatFromHashCode(format);
                    if (xlObj.isUndefined(isWrap))
                        (isWrap = false);
                    $("#" + xlObj._id + "_Ribbon_Home_Alignment_WrapText").ejToggleButton("option", { toggleState: isWrap });
                    if (!xlObj.isUndefined(merge)) {
                        $("#" + xlObj._id + "_Ribbon_Home_Alignment_Merge").addClass("e-ss-active");
                        $("#" + xlObj._id + "_Ribbon_Home_Alignment_Mergedrpbtn").addClass("e-ss-active");
                    }
                    else {
                        $("#" + xlObj._id + "_Ribbon_Home_Alignment_Merge").removeClass("e-ss-active");
                        $("#" + xlObj._id + "_Ribbon_Home_Alignment_Mergedrpbtn").removeClass("e-ss-active");
                    }
					if (["date"].indexOf(type) > -1)
                        type = "custom";
                    if (type) {
                        index = -1;
                        for (var i = 0, len = this._numberFormat.length; i < len; i++) {
                            if (type === this._numberFormat[i].text.toLowerCase()) {
                                index = i;
                                break;
                            }
                        }
                    }
            		if(!ej.isNullOrUndefined(cfObj))
            		{
            			cfObj._initValue = true;
            			index > -1 ? cfObj.option({ selectedItemIndex: index }) : (!ej.isNullOrUndefined(cfObj.selectedIndexValue) && cfObj.selectedIndexValue != 0 && cfObj.option({ selectedItemIndex: 0 }));
            			cfObj._initValue = false;
            		}
            		if (style) {
            		    index = -1;
                        if (!ej.isNullOrUndefined(style["font-size"])) {
                            for (var i = 0, len = this._fontSize.length; i < len; i++) {
                                if (style["font-size"] === this._fontSize[i].value) {
                                    index = i;
                                    break;
                                }                                
                            }
                        }                           
                        if (!ej.isNullOrUndefined(fsObj)) {
                            fsObj._initValue = true;
                            index > -1 ? (fsObj.option({ selectedItemIndex: index }) || (index = -1)) : (!ej.isNullOrUndefined(fsObj.selectedIndexValue) && fsObj.selectedIndexValue != 3 && fsObj.option({ selectedItemIndex: 3 }));
                            fsObj._initValue = false;
                            index = -1
                            if (!ej.isNullOrUndefined(style["font-family"])) {
                                for (var i = 0, len = this._fontFamily.length; i < len; i++) {
                                    if (style["font-family"] === this._fontFamily[i].text.toLowerCase()) {
                                        index = i;
                                        break;
                                    }
                                }
                            }
                                    
                        }
                        if (!ej.isNullOrUndefined(ffObj)) {
                            ffObj._initValue = true;
                            index > -1 ? ffObj.option({ selectedItemIndex: index }) : (!ej.isNullOrUndefined(ffObj.selectedIndexValue) && ffObj.selectedIndexValue != 6 && ffObj.option({ selectedItemIndex: 6 }));
                            ffObj._initValue = false;
                        }
                        if ($("#" + xlObj._id + "_Ribbon_Home_Font_Bold").length)
                        style["font-weight"] == "bold" ? $("#" + xlObj._id + "_Ribbon_Home_Font_Bold").data("ejToggleButton").option("toggleState", true) : $("#" + xlObj._id + "_Ribbon_Home_Font_Bold").data("ejToggleButton").option("toggleState", false);
                        if ($("#" + xlObj._id + "_Ribbon_Home_Font_Italic").length)
                        style["font-style"] == "italic" ? $("#" + xlObj._id + "_Ribbon_Home_Font_Italic").data("ejToggleButton").option("toggleState", true) : $("#" + xlObj._id + "_Ribbon_Home_Font_Italic").data("ejToggleButton").option("toggleState", false);
                        style["text-decoration"] = style["text-decoration"] || "";
                        if ($("#" + xlObj._id + "_Ribbon_Home_Font_Underline").length)
                        $("#" + xlObj._id + "_Ribbon_Home_Font_Underline").data("ejToggleButton").option("toggleState", style["text-decoration"].indexOf("underline") !== -1);
                        if ($("#" + xlObj._id + "_Ribbon_Home_Font_StrikeThrough").length)
                        $("#" + xlObj._id + "_Ribbon_Home_Font_StrikeThrough").data("ejToggleButton").option("toggleState", style["text-decoration"].indexOf("line-through") !== -1);
						this._tglAlignBtn($(xlObj.element).find(".e-text-align"), style, "text-align");
						isVertical = this._tglAlignBtn($(xlObj.element).find(".e-vertical-align"), style, "vertical-align").isVertical;
						if(!isVertical) {
							tgleBtnElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Home_Alignment_BottomAlign");
							if (tgleBtnElem.length) {
								tgleBtnElem.data("ejToggleButton").option("toggleState", true)
								tgleBtnElem.addClass("e-vertical-align");
							}
						}
                        if (xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg").length > 0) {
                            tgleBtnElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Home_Alignment_Merge");
                            tgleBtnElem.length && tgleBtnElem.data('ejSplitButton').option("enabled", false);
                        }
                    }
                    break;
                case xlObj._getLocStr("REVIEW"):
                    var lockElem = $("#" + xlObj._id + "_Ribbon_Review_Changes_LockCell");
                    if (xlObj.model.allowLockCell && !(xlObj.XLComment && xlObj.XLComment._isCommentEdit) && !xlObj.XLEdit._isEdit && !xlObj._isSheetRename && lockElem.length) {
                        lockbtObj = lockElem.data("ejToggleButton");
                        isLocked = xlObj.XLEdit.getPropertyValue(actSheet._activeCell.rowIndex, actSheet._activeCell.colIndex, "isLocked");
                        xlObj.isUndefined(isLocked) && (isLocked = false)
                        lockbtObj.option("toggleState", isLocked);
                        $("#" + xlObj._id + "_Ribbon_Review_Changes_ProtectSheet").length && $("#" + xlObj._id + "_Ribbon_Review_Changes_ProtectSheet").data("ejToggleButton").option("toggleState", actSheet.isSheetProtected);
                        if (!actSheet.isSheetProtected)
                            lockbtObj.enable();
                        else
                            lockbtObj.disable();
                    }
                    if (!actSheet.isSheetProtected || !xlObj.model.allowLockCell) {
                        if ((xlObj.model.allowComments && !xlObj.XLComment._isCommentEdit) && !xlObj.XLEdit._isEdit && !xlObj._isSheetRename)
                            xlObj.XLComment._updateCmntRibIcons(xlObj.getActiveCell());
                    }
                    break;
            }
            if (xlObj.model.allowLockCell && !actSheet.isSheetProtected && xlObj.model.allowComments && !xlObj.XLComment._isCommentEdit && !xlObj._isSheetRename)
                this._refreshRibbonIcons(tabName);
            if (xlObj.model.isReadOnly)
                xlObj._readOnly();
        },
		
		_tglAlignBtn: function(element, style, elemId) {
			var isVertical = false, tgleBtnElem, xlObj = this.XLObj;
			if (!ej.isNullOrUndefined(element[0])) {
                tgleBtnElem = xlObj.element.find("#" + element[0].id);
                tgleBtnElem.length && tgleBtnElem.data("ejToggleButton").option("toggleState", false);
				element.removeClass("e-" + elemId);
            }
			if (!ej.isNullOrUndefined(style[elemId])) {
			    if (elemId === "vertical-align")
			        tgleBtnElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Home_Alignment_" + style[elemId].charAt(0).toUpperCase() + style[elemId].slice(1) + "Align");
                else
                    tgleBtnElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Home_Alignment_Align" + style[elemId].charAt(0).toUpperCase() + style[elemId].slice(1));
                if (tgleBtnElem.length) {
                    tgleBtnElem.data("ejToggleButton").option("toggleState", true);
                    tgleBtnElem.addClass("e-" + elemId);
                }
				if(elemId === "vertical-align")
					isVertical = true;
            } 
			return {isVertical : isVertical};
		},

        _disableButtons: function (idCollection, type) {
            var i, index = -1, len, elem, xlObj = this.XLObj;
            for (i = 0, len = idCollection.length; i < len; i++) {
                if (xlObj.model.allowLockCell)
                    if (!xlObj.XLEdit._isEdit && !xlObj._isSheetRename && xlObj.getSheet(xlObj.getActiveSheetIndex()).isSheetProtected)
                        index = this._protectStateBtnIds.indexOf(idCollection[i]);
                if (index === -1) {
                    elem = xlObj.element.find("#" + xlObj._id + "_Ribbon_" + idCollection[i]);
                    elem.length && !ej.isNullOrUndefined(elem.data(type)) && elem.data(type).disable();
                }
            }
        },

        _enableButtons: function (idCollection, type) {
            var i, index = 0, len, elem, xlObj = this.XLObj;
            for (i = 0, len = idCollection.length; i < len; i++) {
                if (xlObj.model.allowLockCell && !xlObj._isSheetRename && xlObj.getSheet(xlObj.getActiveSheetIndex()).isSheetProtected)
                    index = this._protectStateBtnIds.indexOf(idCollection[i]);
                if (index > -1) {
                    elem = xlObj.element.find("#" + xlObj._id + "_Ribbon_" + idCollection[i]);
                    elem.length && !ej.isNullOrUndefined(elem.data(type)) && elem.data(type).enable();
                }
            }
        },

        _disableInputs: function (idColl, disable) {
            for (var i = 0, len = idColl.length; i < len; i++)
                $("#" + this.XLObj._id + "_" + idColl[i]).attr("disabled", disable);
        },

        _enableRibbonIcons: function (rbnActTabIndex) {
            if (!this.XLObj.model.showRibbon)
                return;
            var index, xlObj = this.XLObj, rObj = $("#" + xlObj._id + "_Ribbon").data("ejRibbon"), sheetIdx = xlObj.getActiveSheetIndex(), filterColl = xlObj.getSheet(sheetIdx)._filterColl, filterKeys, filterKeyCol, i, j, len, fKeylen;
            index = rbnActTabIndex ? rbnActTabIndex : rObj.model.selectedItemIndex;
            switch (rObj.getTabText(index)) {
                case xlObj._getLocStr("HOME"):
                    this._enableButtons(this._homeBtnIds, "ejButton");
                    this._enableButtons(this._homeSptBtnIds, "ejSplitButton");
                    this._enableButtons(this._homeToggleBtnIds, "ejToggleButton");
                    this._enableButtons(this._homeDdIds, "ejDropDownList");
                    this._enableButtons(this._homeCpIds, "ejColorPicker");
                    xlObj._removeClass(rObj.element.find("#" + rObj._id + "_Number_e-groupexpander")[0], "e-disable");
                    break;
                case xlObj._getLocStr("INSERT"):
                    this._enableButtons(this._insertBtnIds, "ejButton");
                    this._enableButtons(this._insertSptBtnIds, "ejSplitButton");
                    break;
                case xlObj._getLocStr("DATATAB"):
                    this._enableButtons(this._dataBtnIds, "ejButton");
                    this._enableButtons(this._dataSptBtnIds, "ejSplitButton");
                    break;
                case xlObj._getLocStr("PAGELAYOUT"):
                    this._enableButtons(this._pageLayBtnIds, "ejButton");
                    this._enableButtons(this._pageLaySptBtnIds, "ejSplitButton");
                    this._enableButtons(this._pageLayChckBxIds, "ejCheckBox");
                    $("#" + rObj._id + "_pagesetup_viewhdrlbl").eq(0).removeClass("e-disable");
                    $("#" + rObj._id + "_pagesetup_viewgrdlnlbl").eq(0).removeClass("e-disable");
                    break;
                case xlObj._getLocStr("REVIEW"):
                    xlObj.model.allowComments && !xlObj.XLComment._isCommentEdit && xlObj.XLComment._updateCmntRibIcons();
                    this._enableButtons(this._reviewTglBtnIds, "ejToggleButton");
                    break;
                case xlObj._getLocStr("OTHERS"):
                    this._enableButtons(this._othersBtnIds, "ejButton");
                    this._enableButtons(this._othersSptBtnIds, "ejSplitButton");
                    break;
                case xlObj._getLocStr("Design"):
                    this._enableButtons(this._contextualBtnIds, "ejButton");
                    this._enableButtons(this._contextualCheckBoxIds, "ejCheckBox");
                    this._disableInputs(this._contextualInputIds, false);
                    break;
            }
            if (!xlObj.XLClipboard._copyBackup.cells && !xlObj.XLClipboard._copyBackup.elem) {
                (xlObj.XLRibbon._disableButtons(["Home_Clipboard_Paste"], "ejButton") || xlObj.XLRibbon._disableButtons(["Home_Clipboard_PasteOptions"], "ejSplitButton"));
                if (xlObj.isPasteValuesOnly)
                    $("#" + xlObj._id + "_Ribbon_Paste").data("ejMenu").disableItemByID("PasteSpecial");
            }
            if ($.isEmptyObject(filterColl))
                this._disableButtons(["Data_SortFilter_ClearFilter"], "ejButton");
			fKeylen = xlObj.getObjectKeys(filterColl);
            for (i = 0, len = fKeylen.length; i < len; i++) {
                filterKeyCol = xlObj.getObjectKeys(filterColl[fKeylen[i]]);
                for (j = 0, len = filterKeyCol.length; j < len; j++) {
                    if (filterColl[fKeylen[i]][filterKeyCol[j]].status.indexOf("e-ssfiltered") < 0)
                        this._disableButtons(["Data_SortFilter_ClearFilter"], "ejButton");
                }
            }
            xlObj._updateUndoRedoIcons();
        },

        _disableRibbonIcons: function () {
            var xlObj = this.XLObj;
            if (!xlObj.model.showRibbon)
                return;
            var rObj = $("#" + xlObj._id + "_Ribbon").data("ejRibbon");
            switch (rObj.getTabText(rObj.model.selectedItemIndex)) {
                case xlObj._getLocStr("HOME"):
                    this._disableButtons(this._homeBtnIds, "ejButton");
                    this._disableButtons(this._homeSptBtnIds, "ejSplitButton");
                    this._disableButtons(this._homeToggleBtnIds, "ejToggleButton");
                    this._disableButtons(this._homeDdIds, "ejDropDownList");
                    this._disableButtons(this._homeCpIds, "ejColorPicker");
                    xlObj.addClass(rObj.element.find("#" + rObj._id + "_Number_e-groupexpander"), "e-disable");
                    break;
                case xlObj._getLocStr("INSERT"):
                    this._disableButtons(this._insertBtnIds, "ejButton");
                    this._disableButtons(this._insertSptBtnIds, "ejSplitButton");
                    break;
                case xlObj._getLocStr("DATATAB"):
                    this._disableButtons(this._dataBtnIds, "ejButton");
                    this._disableButtons(this._dataSptBtnIds, "ejSplitButton");
                    break;
                case xlObj._getLocStr("PAGELAYOUT"):
                    this._disableButtons(this._pageLayBtnIds, "ejButton");
                    this._disableButtons(this._pageLaySptBtnIds, "ejSplitButton");
                    this._disableButtons(this._pageLayChckBxIds, "ejCheckBox");
                    $("#" + rObj._id + "_pagesetup_viewhdrlbl:eq(0)").addClass("e-disable");
                    $("#" + rObj._id + "_pagesetup_viewgrdlnlbl:eq(0)").addClass("e-disable");
                    break;
                case xlObj._getLocStr("REVIEW"):
                    this._disableButtons(this._cmntBtnIds, "ejButton");
                    this._disableButtons(this._cmntTglBtnIds, "ejToggleButton");
                    this._disableButtons(this._reviewTglBtnIds, "ejToggleButton");
                    break;
                case xlObj._getLocStr("OTHERS"):
                    this._disableButtons(this._othersBtnIds, "ejButton");
                    this._disableButtons(this._othersSptBtnIds, "ejSplitButton");
                    break;
                case this.XLObj._getLocStr("Design"):
                    this._disableButtons(this._contextualBtnIds, "ejButton");
                    this._disableButtons(this._contextualCheckBoxIds, "ejCheckBox");
                    this._disableInputs(this._contextualInputIds, true);
                    break;
            }
        },

        _capitalize: function (s) {
            return s[0].toUpperCase() + s.slice(1);
        },

        _generateToggleBtn: function (id, text, contentType, prefixIcon, title, width, height, content, isSeparator, cssClass, imagePosition, actText, actImg, togggleState) {
		  var  conText = content instanceof Array ? this.XLObj._getLocStr(content[0]) + "<br /><br />" + this.XLObj._getLocStr(content[1]) : this.XLObj._getLocStr(content);
            return {
                id: id,
                toolTip: this.XLObj._getLocStr(text),
                type: ej.Ribbon.type.toggleButton,
                enableSeparator: isSeparator,             
                toggleButtonSettings: {
                    width: width,
                    height: height,
                    contentType: contentType,
                    cssClass: cssClass,
                    toggleState: togggleState,
                    defaultPrefixIcon: prefixIcon,
                    activePrefixIcon: actImg ? actImg : prefixIcon,
                    defaultText: this.XLObj._getLocStr(text),
                    activeText: actText ? this.XLObj._getLocStr(actText) : this.XLObj._getLocStr(text),
                    imagePosition: imagePosition == "imagetop" ? ej.ImagePosition.ImageTop : ej.ImagePosition.ImageLeft,
                    click: this._ribbonClickHandler
                },
                customToolTip:
                  {
                      title: this.XLObj._getLocStr(title),
                      content: "<h6>" + conText+ "</h6>"
                  }
            };
        },

        _generateBtn: function (id, text, contentType, prefixIcon, width, height, title, content, isSeparator, imagePosition, cssClass) {
		   var  conText = content instanceof Array ? this.XLObj._getLocStr(content[0]) + "<br /><br />" + this.XLObj._getLocStr(content[1]) : this.XLObj._getLocStr(content);
			return {
                id: id,
                text: this.XLObj._getLocStr(text),
                toolTip: this.XLObj._getLocStr(text),
                cssClass: cssClass,
                enableSeparator: isSeparator,
                buttonSettings: {
                    type: ej.Ribbon.type.button,
                    contentType: contentType,
                    width: width,
                    height: height,
                    imagePosition: imagePosition == "imagetop" ? ej.ImagePosition.ImageTop : ej.ImagePosition.ImageLeft,
                    prefixIcon: prefixIcon,
                    click: this._ribbonClickHandler
                },
                customToolTip:
                  {
                      title: this.XLObj._getLocStr(title),
                      content:  "<h6>" + conText +  "</h6>",
                  }
            };
        },

        _generateDD: function (id, text, data, value, width, height, title, content) {
            return {
                id: id,
                text: this.XLObj._getLocStr(text),
                toolTip: this.XLObj._getLocStr(text),
                type: ej.Ribbon.type.dropDownList,
                dropdownSettings: {
                    dataSource: data,
                    value: value,
                    change: this._ribbonClickHandler,
                    width: width,
                    height: height - 1,
                    cssClass: "e-" + this.XLObj._id+"-ddl"
                },
                customToolTip:
                  {
                      title: this.XLObj._getLocStr(title),
                      content: "<h6>" + this.XLObj._getLocStr(content) + "</h6>"
                  }
            };
        },

        _generateCustomControl: function (contentId, toolTip, title, content) {
            return {
                type: ej.Ribbon.type.custom,
                contentID: contentId,
                toolTip: this.XLObj._getLocStr(toolTip),
                click: this._ribbonClickHandler,
                change: this._ribbonClickHandler,
                customToolTip:
                  {
                      title: this.XLObj._getLocStr(title),
                      content: "<h6>" + this.XLObj._getLocStr(content) + "</h6>"
                  }
            };
        },

        _generateSplitBtn: function (id, text, contentType, targetId, fields, prefixIcon, isSeparator, width, height, arrowPos, imagePosition, btnMode, cssClass, title, content) {
              var  conText = content instanceof Array ? this.XLObj._getLocStr(content[0]) + "<br /><br />" + this.XLObj._getLocStr(content[1]) : this.XLObj._getLocStr(content);
			return {
                id: id,
                toolTip: this.XLObj._getLocStr(text),
                text: this.XLObj._getLocStr(text),
                type: ej.Ribbon.type.splitButton,
                cssClass: cssClass+" e-"+this.XLObj._id+"-spltbtn",
                enableSeparator: isSeparator,
                splitButtonSettings: {
                    contentType: contentType,
                    targetID: targetId,
                    arrowPosition: arrowPos == "bottom" ? ej.ArrowPosition.Bottom : ej.ArrowPosition.Right,
                    imagePosition: imagePosition == "imagetop" ? ej.ImagePosition.ImageTop : ej.ImagePosition.ImageLeft,
                    buttonMode: btnMode == "dropdown" ? ej.ButtonMode.Dropdown : ej.ButtonMode.Split,
                    fields: fields,
                    prefixIcon: prefixIcon,
                    click: this._ribbonClickHandler,
                    itemSelected: this._ribbonClickHandler,
                    height: height,
                    width: width,
                    beforeOpen: $.proxy(this._splitBeforeOpen, this, id),
                   close: (id === "Others_Cells_InsertCellOptions" || id === "Others_Cells_DeleteCellOptions" || id === "Data_DataTools_DataValidationOptions" || id === "Home_Clipboard_PasteOptions") ? $.proxy(this._splitbtnClose, this, id) : null,
                },
                customToolTip:
                {
                    title: this.XLObj._getLocStr(title),
                    content: "<h6>" + conText + "</h6>"
                }
            };
        },

        _splitBeforeOpen: function (id, args) {
            var xlObj = this.XLObj;
            if (id === "Home_Editing_SortFilter")
                this._sfbeforeOpen(args);
            else if (id === "Others_Cells_InsertCellOptions" || id === "Others_Cells_DeleteCellOptions")
                this._insdelbeforOpen(args);
            else if (id === "Others_Window_FreezePanes")
                this._fpbeforeOpen(args);
            else if (id === "ChartDesign_ChartLayouts_AddChartElement")
                this._celementpbeforeOpen(args);
            else if (id === "Data_DataTools_DataValidationOptions" || id === "Home_Clipboard_PasteOptions")
                this._validpasteOpen(args);
            else if (id === "Home_Editing_Clear")
                this._clearbeforeOpen(args);
            else if (id === "Home_Styles_FormatAsTable") {
                var frmtTab = document.getElementById(xlObj._id + "_formatastable");
                if (!frmtTab || frmtTab && !frmtTab.children.length)
                    this._renderFormatAsTable();
                xlObj.XLFormat._resizeFormatTableMenu();
            }
            else if (id === "Home_Styles_CellStyles")
                xlObj.XLFormat._resizeStyleMenu();
            else if (id === "Home_Font_Border")
                xlObj.XLFormat._resizeBorderMenu(args);
            else if (id === "Home_Styles_ConditionalFormatting")
                xlObj._phoneMode ? $("#" + xlObj._id + "_CFormat").find("ul").addClass("e-adaptive") : $("#" + xlObj._id + "_CFormat").find("ul").removeClass("e-adaptive");
        },

        _splitbtnClose: function (id, args) {
            this.XLObj.element.find("#" + this.XLObj._id + "_Ribbon_" + id).parents("div.e-controlpadding").siblings().children("button").removeClass("e-active");
        },

        _fpbeforeOpen: function (args) {
            var xlObj = this.XLObj, fpaneMenu = $("#" + xlObj._id + "_Ribbon_FPane").data("ejMenu"), dataSource = fpaneMenu.model.fields.dataSource.slice(0);
            if (xlObj.getSheet()._isFreezed) {
                dataSource[0].id = "UnFreezePanes";
                dataSource[0].text = xlObj._getLocStr("UnFreezePanes");
            }
            else {
                dataSource[0].id = "freezePanes";
                dataSource[0].text = xlObj._getLocStr("FreezePanes");
            }
            fpaneMenu.option("fields", { id: "id", dataSource: dataSource, parentId: "parentId" });
        },

        _sfbeforeOpen: function (args) {
            var xlObj = this.XLObj, menuObj = $("#" + xlObj._id + "_Ribbon_SortFilter").data("ejMenu");
            (!xlObj.model.allowFiltering) && menuObj.disableItemByID("Ribbon_Filter");
            if (!xlObj.model.allowSorting) {
                menuObj.disableItemByID("Ribbon_SortAtoZ");
                menuObj.disableItemByID("Ribbon_SortZtoA");
            }
            this._refreshRibbonIcons();
        },

        _validpasteOpen: function (args) {
            var xlObj = this.XLObj;
            if (args.model.targetID === xlObj._id + "_Ribbon_Validation")
                 xlObj.element.find("#" + xlObj._id + "_Ribbon_Data_DataTools_DataValidation").addClass("e-active");
            else
                xlObj.element.find("#" + xlObj._id + "_Ribbon_Home_Clipboard_Paste").addClass("e-active");
        },

        _insdelbeforOpen: function (args) {
            var xlObj = this.XLObj, insMenuObj = $("#" + xlObj._id + "_Ribbon_Ins").data("ejMenu"), delMenuObj = $("#" + xlObj._id + "_Ribbon_Del").data("ejMenu"), colSel, rowSel,
                delids = ["DeleteCells", "DeleteSheetRows", "DeleteSheetColumns"], insids = ["InsertCells", "InsertSheetRows", "InsertSheetColumns"], insDelRows, insDelCols, insDelSheet;
            if (args.model.targetID === xlObj._id + "_Ribbon_Ins")
                xlObj.element.find("#" + xlObj._id + "_Ribbon_Others_Cells_InsertCell").addClass("e-active");
            else
                xlObj.element.find("#" + xlObj._id + "_Ribbon_Others_Cells_DeleteCell").addClass("e-active");
			insDelRows = xlObj.element.find(".e-colselected").length ? "disableItemByID" : "enableItemByID";
			insMenuObj && insMenuObj[insDelRows]("InsertSheetRows");
            delMenuObj && delMenuObj[insDelRows]("DeleteSheetRows");
            insDelCols = xlObj.element.find(".e-rowselected").length ? "disableItemByID" : "enableItemByID";
			insMenuObj && insMenuObj[insDelCols]("InsertSheetColumns");
            delMenuObj && delMenuObj[insDelCols]("DeleteSheetColumns");
            insDelSheet = xlObj.model.exportSettings.password ? "disableItemByID" : "enableItemByID";
			insMenuObj && insMenuObj[insDelSheet]("InsertSheet");
            delMenuObj && delMenuObj[insDelSheet]("DeleteSheet");
            if (xlObj.getSheet(xlObj.getActiveSheetIndex()).isSheetProtected) {
                for (var i = 0; i < 3 ; i++) {
                    delMenuObj && delMenuObj.disableItemByID(delids[i]);
                    insMenuObj && insMenuObj.disableItemByID(insids[i]);
                }
            }
            else {
                delMenuObj && delMenuObj.enableItemByID("DeleteCells");
                insMenuObj && insMenuObj.enableItemByID("InsertCells");
            }
        },

        _celementpbeforeOpen: function (args) {
            var xlObj = this.XLObj, chartEle = $("#" + xlObj._id + "_chart").val(), chType = xlObj.XLChart._getShapeObj(chartEle, "chart").type,
            cEleMenuObj = $("#" + xlObj._id + "_Ribbon_CElement").data("ejMenu"), pieChart = ["Axes", "AxisTitle", "Gridline"],
            radarChart = ["AxisTitle", "PMinorH", "PMinorV"], menuEle = ["Axes", "AxisTitle", "Gridline", "PMinorH", "PMinorV"], i, len = 0;
            if (cEleMenuObj)
                return false;
            for (i = 0, len = menuEle.length; i < len; i++)
                cEleMenuObj.enableItemByID(menuEle[i]);
            if (chType === "pie" || chType === "doughnut") {
                for (i = 0, len = pieChart.length; i < len; i++)
                    cEleMenuObj.disableItemByID(pieChart[i]);
            }
            else if (chType === "radar") {
                for (i = 0, len = radarChart.length; i < len; i++)
                    cEleMenuObj.disableItemByID(radarChart[i]);
            }
        },

        _clearbeforeOpen: function (args) {
            var xlObj = this.XLObj, i = 0, clearMenuObj = $("#" + xlObj._id + "_Ribbon_Clear").data("ejMenu"), eleId = ["Clear_Hyperlinks", "Clear_Comments"];
            if (xlObj.model.allowLockCell) {
                if (xlObj.getSheet(xlObj.getActiveSheetIndex()).isSheetProtected) {
                    while (i < eleId.length) {
                        clearMenuObj.disableItemByID(eleId[i]);
                        i++;
                    }
                }
                else {
                    while (i < eleId.length) {
                        clearMenuObj.enableItemByID(eleId[i]);
                        i++;
                    }
                }
            }

        },

        _changeClrFltrStatus: function (obj, control, target) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), nfat = false, i, j;
            if (xlObj.isUndefined(obj))
                return;
			
            if(this._isFilterSelect.isFiltered) {
                if (control === "menu")
					(obj._id.indexOf("Ribbon") > -1) ? obj.enableItemByID("Ribbon_ClearFilter") : obj.enableItemByID("ClearFilter");				else
					obj.enable();
			}			
            else{
				 if (control === "menu")
					(obj._id.indexOf("Ribbon") > -1) ? obj.disableItemByID("Ribbon_ClearFilter") : obj.disableItemByID("ClearFilter");
				else
					obj.disable();
			}              
        },

        _onControlCreated: function () {
            var xlRbn = $("#" + this.XLObj._id + "_Ribbon").ejRibbon("instance");
            this._ctrlCreated = true;
            if (!this.XLObj.model.ribbonSettings.enableOnDemand) {
                this._homeTabControls();
                this._othersTabControls();
                this._pageTabControls();
                this._appTabControls();
            }
            this._hideTabs();
            //Css update
            this._ctrlCreated = false;
        },

        _appTabControls: function () {
            var xlObj = this.XLObj, xlEle = xlObj.element, xlId = xlObj._id, bsBtnOpt = { height: 158, width: 163, text: xlObj._getLocStr("BlankWorkbook"), contentType: "textandimage", imagePosition: "imagetop", prefixIcon: "e-ss-blank", click: $.proxy(this._onBackStageItemClick, this) };
            $("#" + xlId + "_bstab_new_blank").ejButton(bsBtnOpt);
            delete bsBtnOpt.text;
            bsBtnOpt.height = bsBtnOpt.width = 72;
            bsBtnOpt.prefixIcon = "e-icon e-ss-exportxl";
            $("#" + xlId + "_bstab_saveas_excel").ejButton(bsBtnOpt);
            bsBtnOpt.prefixIcon = "e-icon e-ss-exportcsv";
            $("#" + xlId + "_bstab_saveas_csv").ejButton(bsBtnOpt);
            bsBtnOpt.prefixIcon = "e-icon e-ss-exportpdf";
            $("#" + xlId + "_bstab_saveas_pdf").ejButton(bsBtnOpt);
            bsBtnOpt.prefixIcon = "e-icon e-ss-print";
            $("#" + xlId + "_bstab_print_sheet").ejButton(bsBtnOpt);
            bsBtnOpt.prefixIcon = "e-icon e-ss-printselected";
            $("#" + xlId + "_bstab_print_selected").ejButton(bsBtnOpt);
             },
        _othersTabControls: function () {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowInsert && xlObj.model.scrollSettings.allowScrolling) {
                this._disableButtons(["Others_Cells_InsertCellOptions"], "ejSplitButton");
                this._disableButtons(["Others_Cells_InsertCell"], "ejButton");
            }
            if (!xlObj.model.allowDelete && xlObj.model.scrollSettings.allowScrolling) {
                this._disableButtons(["Others_Cells_DeleteCellOptions"], "ejSplitButton");
                this._disableButtons(["Others_Cells_DeleteCell"], "ejButton");
            }
        },
        
        _pageTabControls: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, rbnId = xlId + "_Ribbon_pagesetup", pageStr = xlId + "_Ribbon_PageLayout_Show_";
            $("#" + rbnId + "left").show();
            $("#" + pageStr + "Headings").ejCheckBox({ change: this._ribbonClickHandler, checked: true });
            $("#" + pageStr + "Gridlines").ejCheckBox({ change: this._ribbonClickHandler, checked: true });
            $("#" + rbnId + "_viewhdrlbl").text(xlObj._getLocStr("Heading"));
            $("#" + rbnId + "_viewgrdlnlbl").text(xlObj._getLocStr("Gridlines"));
        },

        _homeTabControls: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, xlEle = xlObj.element, rbnId = xlId + "_Ribbon_", fontStr = rbnId + "Home_Font_";
            $("#" + fontStr + "FillColor").ejColorPicker({ value: "#FFFF00", modelType: "palette", showSwitcher: false, cssClass: "e-ss-colorpicker", toolIcon: "e-ss-backgroundcolor", open: $.proxy(this._colorPickerHandler, this, "Ribbon_Home_Font_FillColor"), change: $.proxy(this._colorPickerHandler, this, "Ribbon_Home_Font_FillColor"), select: $.proxy(this._cpClickHandler, this, "Ribbon_Home_Font_FillColor") });
            $("#" + fontStr + "FontColor").ejColorPicker({ value: "#FF0000", modelType: "palette", showSwitcher: false, cssClass: "e-ss-colorpicker", toolIcon: "e-ss-fontcolor", open: $.proxy(this._colorPickerHandler, this, "Ribbon_Home_Font_FontColor"), change: $.proxy(this._colorPickerHandler, this, "Ribbon_Home_Font_FontColor"), select: $.proxy(this._cpClickHandler, this, "Ribbon_Home_Font_FontColor") });
            $("#" + fontStr + "BorderColor").ejColorPicker({ modelType: "palette", presetType: "basic", cssClass: "e-ss-colorpicker e-ss-menuclrpkr", change: this._ribbonClickHandler });
            $("#" + fontStr + "BorderColorWrapper").hide();
            $("#" + xlId + "_bordercolor ul li").find("a").remove();
            $("#" + xlId + "_bordercolor ul li").append($("#" + fontStr + "BorderColor_popup"));
            $("#" + fontStr + "BorderColor_popup").css({ "display": "block" });
            $("#" + rbnId + "BorderCP").ejColorPicker({ value: "#278787", displayInline: true, modelType: "picker" });
            $("#" + rbnId + "BorderCP_Presets").hide();
            $("#" + xlId + "_CFormat").width(200);
            $("#" + rbnId + "Border").addClass("e-spreadsheet e-border");
            $("#" + fontStr + "FontColor_Presets").css({top:"40px"});
            $("#" + fontStr + "FillColor_Presets").css({top: "40px" });
            this._disableButtons(["Home_Clipboard_Paste"], "ejButton");
            this._disableButtons(["Home_Clipboard_PasteOptions", "Others_Formulas_UseInFormula"], "ejSplitButton");
            $("#" + fontStr + "FillColor_popup").find(".e-buttons, .e-button").hide();
            $("#" + fontStr + "FontColor_popup").find(".e-buttons, .e-button").hide();
        },

        _hideRibbonElem: function (tabName) {
            var xlObj = this.XLObj, xlId = xlObj._id, rObj = $("#" + xlObj._id + "_Ribbon").data("ejRibbon"), model = xlObj.model, rObjElem = rObj.element;
            var rbnId = xlId + "_Ribbon", ClpStr = rbnId + "_home_Clipboard_Home_Clipboard_", algnStr = rbnId + "_home_Alignment_Home_Alignment_", sptrStr = rbnId + "_separator_Home_Alignment_", homeStyStr = rbnId + "_home_Styles_Home_Styles_";
            var fontStr = rbnId + "_home_Font_Home_Font_", numberStr = rbnId + "_home_Number_Home_Number_", editStr = rbnId + "_home_Editing_Home_Editing_", insStr = rbnId + "_insert_", dataStr = rbnId + "_data_", layoutStr = rbnId + "_pagelayout_PageLayout";
            var reviewStr = rbnId + "_review_Changes_Review_Changes_", othrStr = rbnId + "_others_";
            if (!model.allowFormulaBar)
                xlObj.hideFormulaBar();
            switch (tabName) {
                case xlObj._getLocStr("HOME"):
                    if (!model.allowAutoSum && !model.allowFiltering && !model.allowUndoRedo && !model.allowSorting && !model.allowClipboard && !model.allowFormatPainter && !model.allowCellFormatting && !model.allowMerging && !model.allowWrap && !model.allowConditionalFormats && !model.allowFormatAsTable)
                        rObj.hideTab(xlObj._getLocStr("HOME"));
                    if (!model.allowFormatPainter)
                        rObjElem.find("#" + ClpStr + "FormatPainter").hide();
                    if (!model.allowClipboard) {
                        rObjElem.find("#" + rbnId + "_home_Clipboard_1").hide();
                        rObjElem.find("#" + ClpStr + "Cut").hide();
                        rObjElem.find("#" + ClpStr + "Copy").hide();
                    }
                    if (!model.allowClipboard && !model.allowFormatPainter)
                        rObjElem.find("#" + rbnId + "_home_Clipboard").hide();
                    if (!model.allowCellFormatting) {
                        rObjElem.find("#" + rbnId + "_home_Font").hide();
                        rObjElem.find("#" + rbnId + "_home_Number").hide();
                        rObjElem.find("#" + algnStr + "TopAlign").hide();
                        rObjElem.find("#" + algnStr + "MiddleAlign").hide();
                        rObjElem.find("#" + algnStr + "BottomAlign").hide();
                        rObjElem.find("#" + sptrStr + "BottomAlign").hide();
                        rObjElem.find("#" + algnStr + "AlignLeft").hide();
                        rObjElem.find("#" + algnStr + "AlignCenter").hide();
                        rObjElem.find("#" + algnStr + "AlignRight").hide();
                        rObjElem.find("#" + sptrStr + "AlignRight").hide();
                        rObjElem.find("#" + algnStr + "DecreaseIndent").hide();
                        rObjElem.find("#" + algnStr + "IncreaseIndent").hide();
                        rObjElem.find("#" + sptrStr + "IncreaseIndent").hide();
                        rObjElem.find("#" + homeStyStr + "CellStyles").hide();
                        if (!model.allowConditionalFormats && !model.allowFormatAsTable)
                            rObjElem.find("#" + rbnId + "_home_Styles").hide();
                    }
                    if (model.allowCellFormatting) {
                        if (!model.formatSettings.allowFontFamily)
                            rObjElem.find("#" + fontStr + "FontFamily").hide();
                        if (!model.formatSettings.allowDecimalPlaces) {
                            rObjElem.find("#" + numberStr + "IncreaseDecimal").hide();
                            rObjElem.find("#" + numberStr + "DecreaseDecimal").hide();
                            rObjElem.find("#" + rbnId + "_separator_Home_Number_CommaStyle").hide();
                        }
                        if (!model.formatSettings.allowCellBorder)
                            rObjElem.find("#" + fontStr + "Border").hide();
                    }
                    if (!model.allowMerging)
                        rObjElem.find("#" + algnStr + "Merge").hide();
                    if (!model.allowWrap)
                        rObjElem.find("#" + algnStr + "WrapText").hide();
                    if (!model.allowUndoRedo)
                        rObjElem.find("#" + rbnId + "_home_Actions").hide();
                    if (!model.allowFormatAsTable)
                        rObjElem.find("#" + homeStyStr + "FormatAsTable").hide();
                    if (!model.allowConditionalFormats && !model.allowFormatAsTable && !model.allowCellFormatting)
                        rObjElem.find("#" + rbnId + "_home_Styles").hide();
                    if (!model.allowConditionalFormats)
                        rObjElem.find("#" + homeStyStr + "ConditionalFormatting").hide();
                    if (model.allowEditing) {
                        if (!model.allowAutoSum)
                            rObjElem.find("#" + editStr + "AutoSum").hide();
                        if (!model.allowSorting && !model.allowFiltering)
                            rObjElem.find("#" + xlObj._id + "_Ribbon_home_Editing_1").hide();
                    }
                    if (!model.allowAutoSum)
                        rObjElem.find("#" + editStr + "AutoSum").hide();
                    if (!model.allowClear)
                        rObjElem.find("#" + editStr + "Clear").hide();
                    break;
                case xlObj._getLocStr("INSERT"):
                    if (!model.allowFormatAsTable && !model.allowPictures && !model.allowHyperlink && !model.allowCharts)
                        rObj.hideTab(xlObj._getLocStr("INSERT"));
                    if (!model.enablePivotTable && !model.allowFormatAsTable) {
                        rObjElem.find("#" + insStr + "Tables").hide();
                        rObjElem.find("#" + homeStyStr + "FormatAsTable").hide();
                        rObjElem.find("#" + insStr + "Tables_Insert_Tables_PivotTable").hide();
                    }
                    else if (!model.enablePivotTable)
                        rObjElem.find("#" + insStr + "Tables_Insert_Tables_PivotTable").hide();
                    if (!model.pictureSettings.allowPictures)
                        rObjElem.find("#" + insStr + "Illustrations").hide();
                    if (!model.allowHyperlink)
                        rObjElem.find("#" + insStr + "Links").hide();
                    if (!model.allowCharts)
                        rObjElem.find("#" + insStr + "Charts").hide();
                    if (!model.allowFormatAsTable && !model.enablePivotTable)
                        rObjElem.find("#" + insStr + "Tables").hide();
                    break;
                case xlObj._getLocStr("DATATAB"):
                    if (!model.allowDataValidation && !model.allowFiltering && !model.allowSorting)
                        rObj.hideTab(xlObj._getLocStr("DATATAB"));
                    if (!model.allowFiltering)
                        rObjElem.find("#" + dataStr + "SortFilter_2").hide();
                    if (!model.allowSorting)
                        rObjElem.find("#" + dataStr + "SortFilter_1").hide();
                    if (!model.allowDataValidation)
                        rObjElem.find("#" + dataStr + "DataTools").hide();
                    if (!model.allowFiltering && !model.allowSorting)
                        rObjElem.find("#" + dataStr + "Sort").hide();
                    break;
                case xlObj._getLocStr("PAGELAYOUT"):
                    if (!model.printSettings.allowPrinting)
                        rObj.hideTab(xlObj._getLocStr("PAGELAYOUT"));
                    if (!model.printSettings.allowPrinting)
                        rObjElem.find("#" + layoutStr + "Print_Print").hide();
                    if (!model.printSettings.allowPageSize)
                        rObjElem.find("#" + layoutStr).hide();

                    if (!model.allowComments && !model.allowLockCell)
                        rObj.hideTab(xlObj._getLocStr("REVIEW"));
                    if (!model.allowLockCell) {
                        rObjElem.find("#" + reviewStr + "ProtectSheet").hide();
                        rObjElem.find("#" + reviewStr + "LockCell").hide();
                    }
                    if (!model.allowComments)
                        rObjElem.find("#" + rbnId + "_review_Comments").hide();
                    break;
                case xlObj._getLocStr("OTHERS"):
                    if (!model.allowFreezing && !model.allowInsert && !model.allowDelete && !model.allowSearching)
                        rObj.hideTab(xlObj._getLocStr("OTHERS"));
                    if (!model.allowInsert && !model.allowDelete)
                        rObjElem.find("#" + othrStr + "Cells").hide();
                    if (!model.allowInsert)
                        rObjElem.find("#" + othrStr + "Cells_1").hide();
                    if (!model.allowDelete)
                        rObjElem.find("#" + othrStr + "Cells_2").hide();
                    if (!model.allowFreezing)
                        xlObj._phoneMode ? rObjElem.find("#" + othrStr + "Window_1").hide() : rObjElem.find("#" + othrStr + "Window").hide();
                    if (!model.allowSearching)
                        rObjElem.find("#" + othrStr + "Editing").hide();
                    break;
            }
            if (!model.allowImport)
                rObjElem.find("#open_backStageTab").hide();
			if(model.serverEvents) {
			   var serverEvents = model.serverEvents;
			   if(serverEvents.indexOf("excelExporting") < 0 && !model.exportSettings.excelUrl)
			      rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(0)').hide();
			   if(serverEvents.indexOf("csvExporting") < 0 && !model.exportSettings.csvUrl)
			      rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(1)').hide();
			   if(serverEvents.indexOf("pdfExporting") < 0 && !model.exportSettings.pdfUrl)
			      rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(2)').hide();
			   if (!serverEvents.length && !model.exportSettings.excelUrl && !model.exportSettings.csvUrl && !model.exportSettings.pdfUrl)
                  rObjElem.find("#saveas_backStageTab").hide();
			 }
			 else {
            if (!model.exportSettings.excelUrl)
                rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(0)').hide();
            if (!model.exportSettings.csvUrl)
                rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(1)').hide();
            if (!model.exportSettings.pdfUrl)
                rObjElem.find('#' + xlId + '_backstagetabsaveas .e-ssr-bssaveasopt:eq(2)').hide();
            if (!model.exportSettings.allowExporting || (!model.exportSettings.excelUrl) && !(model.exportSettings.csvUrl) && !(model.exportSettings.pdfUrl))
                rObjElem.find("#saveas_backStageTab").hide();
				}
            if (!model.printSettings.allowPrinting)
                rObjElem.find("#print_backStageTab").hide();
        },

        _pictureSizeChange: function (name, args) {
            var xlObj = this.XLObj, newVal, sheetIndex = xlObj.getActiveSheetIndex(), elem = xlObj.getSheetElement(sheetIndex).find(".e-ss-activeimg"), details = { sheetIndex: sheetIndex, reqType: "shape", shapeType: "picture", action: "picturesize", name: name, id: $(elem).attr("id"), prev: {}, cur: {} };
            if (xlObj._shapeChange || this._isSetModel)
                return;
            details.prev = { width: elem.width(), height: elem.height() };
            if (name === "PictureHeight") {
                newVal = parseInt((elem.height() * args.value) / elem.width());
                elem.css({ width: args.value, height: newVal });
                details.cur = { width: args.value, height: newVal };
            }
            else {
                newVal = parseInt((elem.width() * args.value) / elem.height());
                elem.css({ height: args.value, width: newVal });
                details.cur = { height: args.value, width: newVal };
            }
            this._isSetModel = true;
            $("#" + xlObj._id + "_Ribbon_Format_Size_" + name).ejNumericTextbox("option", { value: newVal });
            this._isSetModel = false;
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
            xlObj.XLShape._updateShapeObj(elem[0]);
        },

        _chartTypeOk: function (args) {
            var xlObj = this.XLObj, id = xlObj.element.find("#" + xlObj._id + "_chart").val(), chartObj = $("#" + id).data('ejChart'), details, chartType, className, allChart, markerChart, option;
            className = $("#" + xlObj._id + "_allchart").find(".e-chartselect:eq(0)").attr("class").split(" ")[1], chartType = className.split("e-dlg")[1].split("chart");
            allChart = ["e-dlgcolumnchart4", "e-dlgcolumnchart5", "e-dlgcolumnchart6", "e-dlgbarchart4", "e-dlgbarchart5", "e-dlgbarchart6", "e-dlgpiechart2"];
            markerChart = ["e-dlgstockchart2", "e-dlglinechart2", "dlgradarchart2"], option = { type: chartType[0], enable3D: false, marker: { visible: false } };
            if (chartType[0] === "column" || chartType[0] === "bar" || chartType[0] === "area") {
                if (chartType[1] === "1" || chartType[1] === "4")
                    option["type"] = chartType[0];
                else if (chartType[1] === "2" || chartType[1] === "5")
                    option["type"] = "stacking" + chartType[0];
                else if (chartType[1] === "3" || chartType[1] === "6")
                    option["type"] = "stacking" + chartType[0] + "100";
            }
            allChart.indexOf(className) > -1 && (option["enable3D"] = true);
            markerChart.indexOf(className) > -1 && (option["marker"] = { visible: true });
            className === "e-dlgpiechart3" && (option["type"] = "doughnut");
            details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "shape", shapeType: "chart", action: "chartType", chartId: id };
            details.prev = { chartType: chartObj.model.series[0].type, enable3D: chartObj.model.enable3D, marker: chartObj.model.series[0].marker.visible };
            xlObj.XLChart.refreshChart(id, option);
            details.cur = { chartType: chartObj.model.series[0].type, enable3D: chartObj.model.enable3D, marker: chartObj.model.series[0].marker.visible };
            $("#" + xlObj._id + "_charttypedlg").ejDialog("close");
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);

        },
        _chartTypeCancel: function (args) {
            var xlObj = this.XLObj;
            $("#" + xlObj._id + "_charttypedlg").ejDialog("close");
            xlObj.setSheetFocus();
        },

        _chartType: function (chart, len, cnt, typecnt, type, title) {
            var cell, childs, child, elem, i, parent, typ, hdr = "<div class='e-chartheader'><span>", elem = "<div class='e-chartcontent'</div>",
                chartIcon = chart.toLowerCase(), obj = { visible: false }, xlObj = this.XLObj, text = xlObj._getLocStr(chart).split("/");
            for (i = 0; i < len; i++) {
                cell = "<div class='e-" + xlObj._id + " e-chartcell e-" + chartIcon + (i + 1) + "' title=" + xlObj._getLocStr(title[i]) + "></div>";
                elem += cell;
                if (i === cnt)
                    elem += "</div>" + hdr + text[1] + "</span></div><div class='e-chartcontent'</div>";
            }
            parent = $("<div id=" + xlObj._id + "_Ribbon_" + chart + " class='e-ss-dialog e-ss-chart e-ss-" + xlObj._id + "' style='height:auto;'>" + hdr + text[0] + "</span></div>" + elem + "</div>");
            childs = parent.find(".e-chartcell");
            for (i = 0; i < len; i++) {
                child = $(childs[i]);
                typ = type[i];
                child.data({ type: typ, enable3D: false, marker: obj });
                if (i > typecnt)
                    child.data({ type: typ, enable3D: true, marker: obj });
            }
            elem = $(parent).find(".e-" + chartIcon + "2");
            if (chart === "StockChart" || chart === "LineChart")
                elem.data({ marker: { visible: true } });
            if (chart === "PieChart")
                elem.data({ enable3D: true });
            xlObj.element[0].appendChild(parent[0]);
        },

        autoSum: function (type, range) {
            if (!this.XLObj.model.allowAutoSum)
                return;
            var xlObj = this.XLObj, xlEdit = xlObj.XLEdit, sheetIdx = xlObj.getActiveSheetIndex(), elem, cellIdx = xlObj.getActiveCell(sheetIdx), sCell = false, value;
			if(ej.isNullOrUndefined(cellIdx))
                return;
            var i, inputElem, colLen, actCell = xlObj.getActiveCell(sheetIdx);
            var alphRange, rangeIdx = xlObj._getRangeArgs(range, "object"), selectCell = xlObj._getSelectedCells(sheetIdx, rangeIdx).selCells, cellCnt = selectCell.length - 1;
            var rowCnt = selectCell[cellCnt].rowIndex - selectCell[0].rowIndex, colCnt = selectCell[cellCnt].colIndex - selectCell[0].colIndex, details = { sheetIndex: sheetIdx, range: range, reqType: "auto-sum", oprType: type, updCell: [] };
            var rowIdx, colIdx, cell, textLength = xlObj.getRangeData({ range: [selectCell[0].rowIndex, selectCell[0].colIndex, selectCell[cellCnt].rowIndex, selectCell[cellCnt].colIndex], valueOnly: true }).length, container = xlObj._dataContainer.sheets[sheetIdx];
            if (cellCnt === 0 || !textLength) {
                rowIdx = cellIdx.rowIndex; colIdx = cellIdx.colIndex;
                details.updCell.push({ rowIndex: rowIdx, colIndex: colIdx, pObj: {}, pValue: ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2")) ? "" : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2") });
                (ej.isNullOrUndefined(container[rowIdx])) && (container[rowIdx] = {});
                (ej.isNullOrUndefined(container[rowIdx][colIdx])) && (container[rowIdx][colIdx] = {});
                $.extend(true, details.updCell[0].pObj, container[rowIdx][colIdx]);
                if (!xlObj._isRowViewable(sheetIdx, actCell.rowIndex))
                    xlObj.XLScroll._scrollSelectedPosition(sheetIdx,actCell);
                xlEdit.editCell(actCell.rowIndex, actCell.colIndex, true);
                if(xlObj.model.allowFormulaBar)
                xlObj._getInputBox().val("=" + type + "()");
                if (xlObj._isRowViewable(sheetIdx, rowIdx)) {
                    xlObj.XLEdit._editElem.text("=" + type + "()");
                    xlObj.XLEdit._editElem.focusEnd();
                }
                sCell = true;
            }
            else if (rowCnt === 0 && colCnt > 0) {
                alphRange = xlObj._getAlphaRange(sheetIdx, selectCell[0].rowIndex, selectCell[0].colIndex, selectCell[cellCnt].rowIndex, selectCell[cellCnt].colIndex);
                rowIdx = selectCell[cellCnt].rowIndex; colIdx = selectCell[cellCnt].colIndex + 1;
                value = this.XLObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2");
                while (!ej.isNullOrUndefined(value) && value != "") {
                    colIdx++
                    value = this.XLObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2");
                }
                if (colIdx === xlObj.getSheet(sheetIdx).colCount)
                    xlObj.XLScroll._createNewColumn(sheetIdx, { rowIndex: -1, colIndex: -1 }, { rowIndex: -1, colIndex: -1 }, "insert");
                !xlObj._isUndoRedo && details.updCell.push({ rowIndex: rowIdx, colIndex: colIdx, pObj: {}, pValue: ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2")) ? "" : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2") });
                (ej.isNullOrUndefined(container[rowIdx])) && (container[rowIdx] = {});
                (ej.isNullOrUndefined(container[rowIdx][colIdx])) && (container[rowIdx][colIdx] = {});
                !xlObj._isUndoRedo && $.extend(true, details.updCell[0].pObj, container[rowIdx][colIdx]);
                if (xlObj._isRowViewable(sheetIdx, rowIdx)) {
                    cell = xlObj.getCell(rowIdx, colIdx, sheetIdx);
                    cell.addClass("e-ralign");
                }
                xlEdit._updateCellValue({ rowIndex: rowIdx, colIndex: colIdx }, "=" + type + "(" + alphRange + ")");
                if ('COUNT'.indexOf(type) < 0)
                    xlObj._autosumFormatUpdate(xlObj.getRangeData({ range: [selectCell[0].rowIndex, selectCell[0].colIndex, selectCell[0].rowIndex, selectCell[0].colIndex] })[0], [rowIdx, colIdx, rowIdx, colIdx], false, false);
            }
            else {
                colLen = selectCell[cellCnt].colIndex - selectCell[0].colIndex;
                rowIdx = selectCell[cellCnt].rowIndex + 1;
                for (i = 0; i <= colLen; i++) {
                    colIdx = selectCell[i].colIndex;
                    value = this.XLObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2");
                    var maxRowIdx = rowIdx;
                    while (!ej.isNullOrUndefined(value) && value != "") {
                        rowIdx++;
                        maxRowIdx = rowIdx;
                        value = this.XLObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2");
                    }
                }
                for (i = 0; i <= colLen; i++) {
                    colIdx = selectCell[i].colIndex;
                    rowIdx = maxRowIdx;
                    alphRange = xlObj._getAlphaRange(sheetIdx, selectCell[0].rowIndex, colIdx, selectCell[cellCnt].rowIndex, colIdx);
                    if (selectCell[cellCnt].rowIndex === xlObj.getSheet(sheetIdx).rowCount - 1)
                        xlObj.XLScroll._createNewRow(sheetIdx, -1, -1, "insert");
                    !xlObj._isUndoRedo && details.updCell.push({ rowIndex: rowIdx, colIndex: colIdx, pObj: {}, pValue: ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2")) ? "" : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2") });
                    (ej.isNullOrUndefined(container[rowIdx])) && (container[rowIdx] = {});
                    (ej.isNullOrUndefined(container[rowIdx][colIdx])) && (container[rowIdx][colIdx] = {});
                    !xlObj._isUndoRedo && $.extend(true, details.updCell[i].pObj, container[rowIdx][colIdx]);
                    if (xlObj._isRowViewable(sheetIdx, rowIdx)) {
                        cell = xlObj.getCell(rowIdx, colIdx, sheetIdx);
                        cell.addClass("e-ralign");
                    }
                    xlEdit._updateCellValue({ rowIndex: rowIdx, colIndex: colIdx }, "=" + type + "(" + alphRange + ")");
                    if ('COUNT'.indexOf(type) < 0)
                        xlObj._autosumFormatUpdate(xlObj.getRangeData({ range: [selectCell[0].rowIndex, selectCell[i].colIndex, selectCell[0].rowIndex, selectCell[i].colIndex] })[0], [rowIdx, colIdx, rowIdx, colIdx], false, false);
                }
            }
            xlObj.performSelection({ rowIndex: rangeIdx[0], colIndex: rangeIdx[1] }, { rowIndex: rowIdx, colIndex: colIdx });
            if (!xlObj._isUndoRedo && !sCell) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _openNameManagerDlg: function () {
            var xlObj = this.XLObj, grid;
			xlObj._showDialog(xlObj._id + "_Ribbon_Others_NameManager");
			grid = $("#" + xlObj._id + "_nmgrid").data("ejGrid");
            grid.getContentTable().find('td').addClass("e-ss-emptyrecord")
            if (grid.model.dataSource.length < 1)
                grid.getContentTable().find('td').addClass("e-ss-emptyrecord");
            else
                grid.getContentTable().find('.e-ss-emptyrecord').removeClass("e-ss-emptyrecord");
            this._refreshNMDlg();
            if (xlObj._browserDetails.name == "msie")
                grid.refreshContent();
            $("#" + xlObj._id + "_nmgrid").focus();
        },

        _openFATDlg: function () {
            var xlObj = this.XLObj;
            $('#' + xlObj._id + '_fatnamedlg').ejDialog('open');
            $("#" + xlObj._id + "_fatheader").ejCheckBox("option", "checked", false);
            $("#" + xlObj._id + "_fatname").val('Table' + xlObj._tableCnt).focus().setInputPos($("#" + xlObj._id + "_fatname").val().length);
        },

        _dirtySelect: function () {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), selCells, tabRange = xlObj.getSheet(sheetIdx).filterSettings.tableRange, isTableCell = false, isDirtyCell = false, isFilterCell = false, isTop = false, isBottom = false, isLeft = false, isRight = false, isRowDirty = false, isColDirty = false, isColInside = false, isRowInside = false, tableIdx = -2,
                isTopToBottom = false, isLeftToRight = false;
            if (xlObj.model.allowLockCell && xlObj.getSheet(sheetIdx).isSheetProtected)
                return;
            selCells = xlObj.getSheet(sheetIdx)._selectedCells;
            if (selCells.length > 0) {
                for (var i = 0, len = tabRange.length; i < len; i++) {
					isRowInside = isRowDirty = isTop = isBottom = isTopToBottom = false;
					isColInside = isColDirty = isLeft = isRight = isLeftToRight = false;
                    // Selection is inside the Row Range
                    if ((tabRange[i].startRow - 1 <= selCells[0].rowIndex) && (tabRange[i].endRow >= selCells[selCells.length - 1].rowIndex))
                        isRowInside = true;
                        //Out To In
                    else if ((tabRange[i].startRow - 1 > selCells[0].rowIndex) && (selCells[selCells.length - 1].rowIndex >= tabRange[i].startRow - 1) && (tabRange[i].endRow >= selCells[selCells.length - 1].rowIndex))
                        isRowDirty = true;
                        //In To Out
                    else if ((tabRange[i].startRow - 1 <= selCells[0].rowIndex) && (selCells[0].rowIndex <= tabRange[i].endRow) && (tabRange[i].endRow < selCells[selCells.length - 1].rowIndex)) 
                        isRowDirty = true;
                        //In Top
                    else if (tabRange[i].startRow - 1 > selCells[selCells.length - 1].rowIndex)
                        isTop = true;
                        //In Bottom
                    else if (tabRange[i].endRow < selCells[0].rowIndex)
                        isBottom = true;
                        //Top to Bottom
                    else if ((tabRange[i].endRow < selCells[selCells.length - 1].rowIndex) && tabRange[i].startRow > selCells[0].rowIndex)
                        isTopToBottom = true;
                        //Out To Out
                    else
                        isRowInside = false;
                    
                    // Selection is inside the Column Range
                    if ((tabRange[i].multifilterIdx[0] <= selCells[0].colIndex) && (tabRange[i].multifilterIdx[tabRange[i].multifilterIdx.length - 1] >= selCells[selCells.length - 1].colIndex)) 
                        isColInside = true;
                        //Out To In
                    else if ((tabRange[i].multifilterIdx[0] > selCells[0].colIndex) && (selCells[selCells.length - 1].colIndex >= tabRange[i].multifilterIdx[0]) && (tabRange[i].multifilterIdx[tabRange[i].multifilterIdx.length - 1] >= selCells[selCells.length - 1].colIndex)) 
                        isColDirty = true;
                        //In To Out
                    else if ((tabRange[i].multifilterIdx[0] <= selCells[0].colIndex) && (selCells[0].colIndex <= tabRange[i].multifilterIdx[tabRange[i].multifilterIdx.length - 1]) && (tabRange[i].multifilterIdx[tabRange[i].multifilterIdx.length - 1] < selCells[selCells.length - 1].colIndex))
                        isColDirty = true;
                        //In Left
                    else if (tabRange[i].multifilterIdx[0] > selCells[selCells.length - 1].colIndex)
                        isLeft = true;
                        //In Right
                    else if (tabRange[i].multifilterIdx[tabRange[i].multifilterIdx.length - 1] < selCells[0].colIndex)
                        isRight = true;
                        //Left To Right
                    else if ((tabRange[i].multifilterIdx[0] > selCells[0].colIndex) && (tabRange[i].multifilterIdx[tabRange[i].multifilterIdx.length - 1] < selCells[selCells.length - 1].colIndex))
                        isLeftToRight = true;
                        //Out To Out
                    else 
                        isColInside = false;
                    if ((isRowDirty && isColDirty) || (isRowDirty && isColInside) || (isRowInside && isColDirty) || (isRowDirty && !isRight && !isLeft) || (isColDirty && !isTop && !isBottom) || (isTopToBottom && isLeftToRight) || (isRowInside && isLeftToRight) || (isColInside && isTopToBottom)) {
                        isDirtyCell = true;
						if(xlObj.XLSelection._isRowSelected && isRowInside)
							isDirtyCell = false;
						if(xlObj.XLSelection._isColSelected && isColInside)
							isDirtyCell = false;
                        if(isDirtyCell)
							break;
                    }
					if (!isDirtyCell) {
                        tableIdx = i;
                        if (isTop || isBottom || isLeft ) {
                            isDirtyCell = false;
                            isTableCell = false;
                        }
                        if ((isRowInside && isColInside)) //Need to add Condition for outside the selection
                            isFilterCell = true;
                        if ((!isRowInside && !isColInside))
                            isTableCell = true;
                    }
                }
            }
            this._isDirtySelect = isDirtyCell;
            this._isMergeSelect = (isFilterCell || isDirtyCell);
            this._isFilterSelect = { status: isFilterCell, tableIdx: tableIdx, isFiltered: false };
        },

        _refreshRibbonIcons: function (tabName) {
            var filterVal, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), menuObj = $("#" + xlObj._id + "_contextMenuCell").data("ejMenu"), splitBtnIds = ["Home_Editing_SortFilter", "Home_Editing_Clear", "Home_Styles_FormatAsTable"],
                btnIds = ["Insert_Tables_Table", "Design_Tools_ConvertToRange", "Data_SortFilter_Filter", "Data_SortFilter_ClearFilter"], mergeBtn = $("#" + xlObj._id + "_Ribbon_Home_Alignment_Merge").data("ejSplitButton");
            (!xlObj.XLEdit._isEdit && xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg").length < 1) && mergeBtn && mergeBtn.option("enabled", !this._isMergeSelect);
           	if (this._isDirtySelect) {
               	this._disableButtons(splitBtnIds, "ejSplitButton");
               	this._disableButtons(btnIds, "ejButton");
               	menuObj && menuObj.disableItemByID("Sort");
           	}
           	else if(!xlObj.XLEdit._isEdit){
               	this._enableButtons(splitBtnIds, "ejSplitButton");
               	this._enableButtons(btnIds, "ejButton");
               	if (!xlObj.model.isReadOnly && menuObj && xlObj.model.allowSorting)
                   	menuObj.enableItemByID("Sort");
           	}
           	var tabRange = xlObj.getSheet(sheetIdx).filterSettings.tableRange[this._isFilterSelect.tableIdx];
           	if (this._isFilterSelect.status && tabRange) {
               	var clrFltr = false, filterIdx = tabRange.multifilterIdx;
               	for (var i = 0, len = filterIdx.length; i < len; i++) {
               		filterVal = xlObj.XLEdit.getPropertyValue(tabRange.startRow - 1, filterIdx[i], "filterState");
               		if (filterVal && filterVal.indexOf("filtered") > -1) {
                    	this._isFilterSelect.isFiltered = true;
                       	break;
                   	}
               	}
           	}
			if(this._isFilterSelect.isFiltered) {
				this._isDataTabCreate  && this._enableButtons(["Data_SortFilter_ClearFilter"], "ejButton");
				this._isHomeTabCreate  && $("#" + xlObj._id + "_Ribbon_SortFilter").ejMenu("enableItemByID", "Ribbon_ClearFilter");
			}
			else {
				this._isDataTabCreate  && this._disableButtons(["Data_SortFilter_ClearFilter"], "ejButton");
				this._isHomeTabCreate  && $("#" + xlObj._id + "_Ribbon_SortFilter").ejMenu("disableItemByID", "Ribbon_ClearFilter");
			}
       	},

        _onGroupExpander: function (args) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly || xlObj.XLEdit._isEdit)
                return;
            switch (args.target.id) {
                case xlObj._id + '_Ribbon_Number_e-groupexpander':
                    xlObj._showDialog(xlObj._id + "_FormatCells");
                    break;
            }
        },

        disableRibbonItems: function (idCollection)
        {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var type, tabName, i, j, len, Id;
            for (i = 0, len = idCollection.length; i < len; i++) {
                tabName = idCollection[i].split("_")[2].toUpperCase();
                Id = idCollection[i].split("_Ribbon_")[1];
                do {
                switch (tabName) {
                    case "HOME":
                        if (this._homeBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._homeBtnIds.splice(this._homeBtnIds.indexOf(Id), 1);
                        }
                        else if (this._homeSptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._homeSptBtnIds.splice(this._homeSptBtnIds.indexOf(Id), 1);
                        }
                        else if (this._homeToggleBtnIds.indexOf(Id) > -1) {
                            type = "ejToggleButton";
                            this._homeToggleBtnIds.splice(this._homeToggleBtnIds.indexOf(Id), 1);
                        }
                        else if (this._homeDdIds.indexOf(Id) > -1) {
                            type = "ejDropDownList";
                            this._homeDdIds.splice(this._homeDdIds.indexOf(Id), 1);
                        }
                        else if (this._homeCpIds.indexOf(Id) > -1) {
                            type = "ejColorPicker";
                            this._homeCpIds.splice(this._homeCpIds.indexOf(Id), 1);
                        }
                        break;
                    case "INSERT":
                        if (this._insertBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._insertBtnIds.splice(this._insertBtnIds.indexOf(Id), 1);
                        }
                        else if (this._insertSptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._insertSptBtnIds.splice(this._insertSptBtnIds.indexOf(Id), 1);
                        }
                        break;
                    case "DATA":
                        if (this._dataBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._dataBtnIds.splice(this._dataBtnIds.indexOf(Id), 1);
                        }
                        else if (this._dataSptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._dataSptBtnIds.splice(this._dataSptBtnIds.indexOf(Id), 1);
                        }
                        break;
                    case "PAGELAYOUT":
                        if (this._pageLayBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._pageLayBtnIds.splice(this._pageLayBtnIds.indexOf(Id), 1);
                        }
                        else if (this._pageLaySptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._pageLaySptBtnIds.splice(this._pageLaySptBtnIds.indexOf(Id), 1);
                        }
                        else if (this._pageLayChckBxIds.indexOf(Id) > -1) {
                            type = "ejCheckBox";
                            this._pageLayChckBxIds.splice(this._pageLayChckBxIds.indexOf(Id), 1);
                        }
                        break;
                    case "REVIEW":
                        if (this._cmntBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._cmntBtnIds.splice(this._cmntBtnIds.indexOf(Id), 1);
                        }
                        else if (this._cmntTglBtnIds.indexOf(Id) > -1) {
                            type = "ejToggleButton";
                            this._cmntTglBtnIds.splice(this._cmntTglBtnIds.indexOf(Id), 1);
                        }
                        else if (this._reviewTglBtnIds.indexOf(Id) > -1) {
                            type = "ejToggleButton";
                            this._reviewTglBtnIds.splice(this._reviewTglBtnIds.indexOf(Id), 1);
                        }
                        break;
                    case "OTHERS":
                        if (this._othersBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._othersBtnIds.splice(this._othersBtnIds.indexOf(Id), 1);
                        }
                        else if (this._othersSptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._othersSptBtnIds.splice(this._othersSptBtnIds.indexOf(Id), 1);
                        }
                        break;
                    case "FORMAT":
                        if (this._formatBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._formatBtnIds.splice(this._formatBtnIds.indexOf(Id), 1);
                        }
                        else if (this._formatSptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._formatSptBtnIds.splice(this._formatSptBtnIds.indexOf(Id), 1);
                        }
                        break;
                    case "DESIGN":
                        if (this._contextualBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._contextualBtnIds.splice(this._contextualBtnIds.indexOf(Id), 1);
                        }
                        else if (this._contextualCheckBoxIds.indexOf(Id) > -1) {
                            type = "ejCheckBox";
                            this._contextualCheckBoxIds.splice(this._contextualCheckBoxIds.indexOf(Id), 1);
                        }
                        else if (this._contextualInputIds.indexOf(Id) > -1)
                            type = true;
                        break;
                    case "CHARTDESIGN":
                        if (this._chartDesignBtnIds.indexOf(Id) > -1) {
                            type = "ejButton";
                            this._chartDesignBtnIds.splice(this._chartDesignBtnIds.indexOf(Id), 1);
                        }
                        else if (this._chartDesignSptBtnIds.indexOf(Id) > -1) {
                            type = "ejSplitButton";
                            this._chartDesignSptBtnIds.splice(this._chartDesignSptBtnIds.indexOf(Id), 1);
                        }
                        else if (this._chartDesignDdIds.indexOf(Id) > -1) {
                            type = "ejDropDownList";
                            this._chartDesignDdIds.splice(this._chartDesignDdIds.indexOf(Id), 1);
                        }
                        break;
                }
                this._disableButtons([Id], type);
            }
                while ((Id === "PageLayout_PageLayout_PageSize" || Id === "Home_Clipboard_Paste" || Id === "Others_Cells_InsertCell" || Id === "Others_Cells_DeleteCell" || Id === "Data_DataTools_DataValidation") && (Id = Id + "Options"));
            }
        },

        enableRibbonItems: function (idCollection) {
            var xlObj = this.XLObj;
            var type, tabName, i, j, len, Id;
            for (i = 0, len = idCollection.length; i < len; i++) {
                tabName = idCollection[i].split("_")[2].toUpperCase();
                Id = idCollection[i].split("_Ribbon_")[1];
                do {
                    switch (tabName) {
                        case "HOME":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._homeBtnIds.push(Id);
                            }
                            else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                type = "ejSplitButton";
                                this._homeSptBtnIds.push(Id);
                            }
                            else if (this.allToggleButtonIds.indexOf(Id) > -1) {
                                type = "ejToggleButton";
                                this._homeToggleBtnIds.push(Id);
                            }
                            else if (this.allDropDownIds.indexOf(Id) > -1) {
                                type = "ejDropDownList";
                                this._homeDdIds.push(Id);
                            }
                            else if (this.colorPickerIds.indexOf(Id) > -1) {
                                type = "ejColorPicker";
                                this._homeCpIds.push(Id);
                            }
                            break;
                        case "INSERT":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._insertBtnIds.push(Id);
                            }
                            else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                type = "ejSplitButton";
                                this._insertSptBtnIds.push(Id);
                            }
                            break;
                        case "DATA":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._dataBtnIds.push(Id);
                            }
                            else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                type = "ejSplitButton";
                                this._dataSptBtnIds.push(Id);
                            }
                            break;
                        case "PAGELAYOUT":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._pageLayBtnIds.push(Id);
                            }
                            else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                type = "ejSplitButton";
                                this._pageLaySptBtnIds.push(Id);
                            }
                            else if (this.checkBoxIds.indexOf(Id) > -1) {
                                type = "ejCheckBox";
                                this._pageLayChckBxIds.push(Id);
                            }
                            break;
                        case "REVIEW":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._cmntBtnIds.push(Id);
                            }
                            else if (this.allToggleButtonIds.indexOf(Id) > -1 && idCollection[i].split("_")[4] === "ShowAllComment") {
                                type = "ejToggleButton";
                                this._cmntTglBtnIds.push(Id);
                            }
                            else if (this.allToggleButtonIds.indexOf(Id) > -1) {
                                type = "ejToggleButton";
                                this._reviewTglBtnIds.push(Id);
                            }
                            break;
                        case "OTHERS":
                                if (this.allButtonIds.indexOf(Id) > -1) {
                                    type = "ejButton";
                                    this._othersBtnIds.push(Id);
                                }
                                else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                    type = "ejSplitButton";
                                    this._othersSptBtnIds.push(Id);
                                }
                            break;
                        case "FORMAT":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._formatBtnIds.push(Id);
                            }
                            else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                type = "ejSplitButton";
                                this._formatSptBtnIds.push(Id);
                            }
                            break;
                        case "DESIGN":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._contextualBtnIds.push(Id);
                            }
                            else if (this.checkBoxIds.indexOf(Id) > -1) {
                                type = "ejCheckBox";
                                this._contextualCheckBoxIds.push(Id);
                            }
                            else if (this._contextualInputIds.indexOf(Id) > -1)
                                type = true;
                            break;
                        case "CHARTDESIGN":
                            if (this.allButtonIds.indexOf(Id) > -1) {
                                type = "ejButton";
                                this._chartDesignBtnIds.push(Id);
                            }
                            else if (this.allSplitButtonIds.indexOf(Id) > -1) {
                                type = "ejSplitButton";
                                this._chartDesignSptBtnIds.push(Id);
                            }
                            else if (this.allDropDownIds.indexOf(Id) > -1) {
                                type = "ejDropDownList";
                                this._chartDesignDdIds.push(Id);
                            }
                            break;
                    }
                    this._enableButtons([Id], type);
                }
                while ((Id === "PageLayout_PageLayout_PageSize" || Id === "Home_Clipboard_Paste" || Id === "Others_Cells_InsertCell" || Id === "Others_Cells_DeleteCell" || Id === "Data_DataTools_DataValidation") && (Id = Id + "Options"));
            }
        },

        _refreshFRDlg: function () {
            var xlObj = this.XLObj;
			if(xlObj._dlgWidth < 365) {
				$("#" + xlObj._id + "_Ribbon_lbFind").text("Find");
				$("#" + xlObj._id + "_Ribbon_lbReplace").text("Replace");
			}
			else {
				$("#" + xlObj._id + "_Ribbon_lbFind").text("Find What");
				$("#" + xlObj._id + "_Ribbon_lbReplace").text("Replace With");
			}
        },

        _refreshChartTypeDlg: function () {
            var xlObj = this.XLObj;           
            $("#" + xlObj._id + "_charttypedlg").ejDialog("open");
            $("#" + xlObj._id + "_chartdlg_allcharttab_list").ejListBox('refresh');
        },

        _refreshNMDlg: function () {
            var xlObj = this.XLObj, nmgrid;
			$("#" + xlObj._id + "_nmdlg").ejDialog("open"); // due to grid issue
			nmgrid = $("#" + xlObj._id + "_nmgrid").data("ejGrid");
			nmgrid._refreshScroller({requestType: "refresh"})
        },

        _menuCustomize: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, settings = xlObj.model.ribbonSettings.applicationTab, settingsOpt = settings.menuSettings;
            if (settings.type === "menu") {
                if (settingsOpt.isAppend)
                    this._fileMenuData = this._fileMenuData.concat(settingsOpt.dataSource);
                else if (settingsOpt.dataSource.length)
                    this._fileMenuData = [{ id: "File", text: xlObj._getLocStr("File"), parentId: null }, ].concat(settingsOpt.dataSource);
                this._appTabCollection = { type: ej.Ribbon.ApplicationTabType.Menu, menuItemID: xlId + "_Menu", menuSettings: { click: $.proxy(this._onBackStageItemClick, this), openOnClick: false, fields: { dataSource: this._fileMenuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "sprite" } } };
            }
            else {
                if (settingsOpt.isAppend) {
                    this._renderAppTab();
                    this._appTabCollection.backstageSettings.pages = this._appTabCollection.backstageSettings.pages.concat(settingsOpt.dataSource);
                }
                else {
                    if (settingsOpt.dataSource.length)
                        this._appTabCollection = { type: ej.Ribbon.applicationTabType.backstage, backstageSettings: { text: xlObj._getLocStr("File"), headerWidth: 124, height: xlObj._responsiveHeight, width: xlObj.model.scrollSettings.width, pages: settingsOpt.dataSource } };
                    else
                        this._renderAppTab();
                }
            }
        },

        _refreshBackstageHeight: function () {
            var xlObj = this.XLObj, ribObj = xlObj.element.find("#" + xlObj._id + "_Ribbon").data("ejRibbon"), respHt = xlObj._isAutoWHMode ? xlObj._responsiveHeight : xlObj._responsiveHeight - 2;
            if (ribObj.model.applicationTab.type === ej.Ribbon.ApplicationTabType.Backstage) {
                ribObj.setModel({ "applicationTab": { "backstageSettings": { "height": respHt, "width": xlObj._isAutoWHMode ? xlObj._responsiveWidth : xlObj._responsiveWidth - 2 } } });
				ribObj.element.find(".e-responsivebackstagecontent .e-resbackstagecontent").css({ "height": respHt - (10 + ribObj.element.find(".e-backstagerestop").outerHeight()) }); //10 for margin
			}
        },

        hideMenu: function () {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            if (xlObj.model.ribbonSettings.applicationTab.type === "menu")
                $("#" + xlObj._id + "_Menu").hide();
            else
                xlObj.element.find("#" + xlObj._id + "_Ribbon").find(".e-backstagetab").hide();
        },

        showMenu: function () {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            if (xlObj.model.ribbonSettings.applicationTab.type === "menu")
                $("#" + xlObj._id + "_Menu").show();
            else
                xlObj.element.find("#" + xlObj._id + "_Ribbon").find(".e-backstagetab").show();
        },

        addTab: function (tabText, ribbonGroups, index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
            xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("addTab", tabText, ribbonGroups, index);
        },

        addTabGroup: function (tabIndex, tabGroup, groupIndex) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
            xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("addTabGroup", tabIndex, tabGroup, groupIndex);
        },

        addContextualTabs: function (contextualTabSet, index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
            xlObj.element.find("#" + this.XLObj._id + "_Ribbon").ejRibbon("addContextualTabs", contextualTabSet, index);
        },

        removeTab: function (index, isRemoveMenu) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            if (ej.isNullOrUndefined(index) && isRemoveMenu) {
                var tabUl = xlObj.element.find("#" + xlObj._id + "_Ribbon .e-apptab");
                if (tabUl.length) {
                    tabUl.find("a").empty();
                    tabUl.find(".e-menu-wrap").remove();
                    tabUl.hide();
                    xlObj.element.find("#" + xlObj._id + "_Ribbon_BackStage").remove();
                }
            }
            else
                xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("removeTab", index);
        },

        removeTabGroup: function (tabIndex, groupText) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
            xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("removeTabGroup", tabIndex, groupText);

        },

        addBackStageItem: function (pageItem, index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
            xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("addBackStageItem", pageItem, index);
        },

        removeBackStageItem: function (index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
            xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("removeBackStageItem", index);
        },

        updateBackStageItem: function (pageItem, index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly)
                xlObj.element.find("#" + xlObj._id + "_Ribbon").ejRibbon("updateBackStageItem", index, pageItem);
        },

        removeMenuItem: function (index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly) {
                var menuElem = $("#" + xlObj._id + "_Menu"), menuObj = menuElem.data("ejMenu");
                menuObj.remove(["#" + menuElem.find("li").eq(index).attr("id")]);
            }
        },

        updateMenuItem: function (item, index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly) {
                var menuElem = $("#" + xlObj._id + "_Menu"), menuObj = menuElem.data("ejMenu");
                menuObj.insertBefore(item, "#" + menuElem.find("li").eq(index).attr("id"));
                menuObj.remove(["#" + menuElem.find("li").eq(index + 1).attr("id")]);
            }
        },

        addMenuItem: function (item, index) {
            var xlObj = this.XLObj;
            if (!xlObj.model.isReadOnly) {
                var menuElem = $("#" + xlObj._id + "_Menu"), menuObj = menuElem.data("ejMenu");
                menuObj.insertAfter(item, "#" + menuElem.find("li").eq(index).attr("id"));
            }
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.freezepane = function (obj) {
        this.XLObj = obj;
        this._hfreeze = null;
        this._vfreeze = null;
    };

    ej.spreadsheetFeatures.freezepane.prototype = {
        _setHFreeze: function(elem) {
            this._hfreeze = elem;
         },

         _getHFreeze: function() {
            return this._hfreeze;
         },

         _setVFreeze: function(elem) {
            this._vfreeze = elem;
         },

         _getVFreeze: function() {
            return this._vfreeze;
         },

        _initFreeze: function() {
            var hfreeze, vfreeze, px = "px", div = "div", hide = "e-hide", xlObj = this.XLObj,
                sheet = xlObj.getSheet(), sslist = xlObj.getMainPanel().find(".e-spreadsheet-list")[0];
            hfreeze = document.createElement(div);
            hfreeze.id = xlObj._id + "_hfreeze";
            hfreeze.className = "e-frow " + hide;
            sslist.appendChild(hfreeze);
            this._setHFreeze($(hfreeze));
            vfreeze = document.createElement(div);
            vfreeze.id = xlObj._id + "_vfreeze";
            vfreeze.className = "e-fcol " + hide;
            sslist.appendChild(vfreeze);
            this._setVFreeze($(vfreeze));
        },

        _refreshFreeze: function() {
            var px = "px", hide = "e-hide", xlObj = this.XLObj, sheet = xlObj.getSheet(), freeze = this._getHFreeze()[0];
            if (!freeze)
                this._initFreeze();
            if (xlObj._isFrozen(xlObj.getFrozenRows())) {
                xlObj._removeClass(freeze, hide);
                freeze.style.top = sheet._fDivTop;
                if (xlObj.model._isActPanelVisible)
                    freeze.style.width = (xlObj._getJSSheetContent(xlObj.getActiveSheetIndex()).width() - (sheet.showHeadings ? xlObj._rowHeaderWidth : 0) + 10) + px;
                else
                    freeze.style.width = sheet._vPortWth + (sheet.showHeadings ? xlObj._rowHeaderWidth : 0) - 4 + px;
            }
            else
                xlObj.addClass(freeze, hide);
            freeze = this._getVFreeze()[0];
            if (xlObj._isFrozen(xlObj.getFrozenColumns())) {
                xlObj._removeClass(freeze, hide);
                freeze.style.left = sheet._fDivLeft;
                freeze.style.height = (sheet._vPortHgt + (sheet.showHeadings ? xlObj._colHeaderHeight : 0)) - 4  + px;
            }
            else
                xlObj.addClass(freeze, hide);
        },

        freezeTopRow: function() {
            var sheet = this.XLObj.getSheet();
            if (this.XLObj._isFrozen(sheet.frozenRows) || this.XLObj._isFrozen(sheet.frozenColumns))
                this.unfreezePanes();
            this._freeze(sheet._topRow.idx + 1);
        },

        freezeLeftColumn: function() {
            var sheet = this.XLObj.getSheet();
            if (this.XLObj._isFrozen(sheet.frozenColumns))
                this.unfreezePanes();
            this._freeze(null, sheet._leftCol.idx + 1);
        },

        freezeRows: function(rowIdx) {
            var sheet = this.XLObj.getSheet();
            if (this.XLObj._isFrozen(sheet.frozenRows) || this.XLObj._isFrozen(sheet.frozenColumns))
                this.unfreezePanes();
            this._freeze(rowIdx);
        },

        freezeColumns: function(colIdx) {
            var sheet = this.XLObj.getSheet();
            if (this.XLObj._isFrozen(sheet.frozenColumns))
                this.unfreezePanes();
            this._freeze(null, colIdx);
        },

        freezePanes: function(rowIdx, colIdx) {
            var range, xlObj = this.XLObj;
            if (!xlObj.isNumber(rowIdx)) {
                range = xlObj._toIntrnlRange(rowIdx);
                rowIdx = range[0], colIdx = range[1];
            }
            this._freeze(rowIdx, colIdx);
        },

        unfreezePanes: function() {
            this._freeze();
            this._refreshSelection();
        },

        _freeze: function(rowIdx, colIdx) {
            var px, idx, hide, sheet, offset, freeze, rrefresh, crefresh, xlObj = this.XLObj, ftopRowIdx, fleftColIdx;
            rrefresh = crefresh = true;
            if (!xlObj.model.allowFreezing)
                 return;
            px = "px", hide = "e-hide", sheet = xlObj.getSheet(), freeze = this._getHFreeze()[0];
            if (!ej.isNullOrUndefined(rowIdx)) {
                if (rowIdx === 0 || rowIdx < sheet._topRow.idx || rowIdx > sheet._bottomRow.idx)
                    rowIdx = xlObj._getMidCell().rowIdx;
                offset = xlObj._getIdxWithOffset(rowIdx).yOffset;
                if (sheet._topRow.idx === rowIdx && sheet._scrollTop !== offset)
                    xlObj.XLScroll._vScroller().scroll(offset);
                xlObj._removeClass(freeze, hide);
                sheet._isFreezed = true;
                freeze.style.top = sheet._fDivTop = (offset - sheet._scrollTop + (sheet.showHeadings ? (xlObj._colHeaderHeight - 2) : 0)) + px;
                freeze.style.width = sheet._vPortWth + (sheet.showHeadings ? xlObj._rowHeaderWidth : 0) - 4 + px;
                sheet._contScrollTop = sheet._scrollTop;
             }
             else {
                 idx = xlObj.getFrozenRows();
                 if (xlObj._isFrozen(idx)) {
                     rowIdx = 0;
                     ftopRowIdx = sheet._ftopRowIdx - 1;
                     this._showFreezeRow(idx, ftopRowIdx);
                    if (xlObj.model.scrollSettings.allowVirtualScrolling)
                        xlObj.refreshContent();  
                    while (ftopRowIdx >= idx) {
                        if (sheet._fHMergeRows.indexOf(idx) > -1) {
                            sheet._fHMergeRows.splice(sheet._fHMergeRows.indexOf(idx), 1);
                            xlObj._refreshSHMergeCells(null, [idx], 1, "row", "show");
                        }
                        idx++;
                    }
                    xlObj.addClass(freeze, hide);
                    sheet._isFreezed = false;
                 }
                else
                    rrefresh = false;
             }
             if (rrefresh) {
                 sheet._ftopRowIdx = rowIdx;
                 sheet._frozenHeight = xlObj._getRowOffsetTop(sheet, rowIdx);
                 sheet.paneTopLeftCell = xlObj.getAlphaRange(rowIdx, sheet._fleftColIdx);
                 xlObj.setFrozenRows(rowIdx);
                 sheet._frozenRows = rowIdx + 1;
             }
             freeze = this._getVFreeze()[0];
             if (!ej.isNullOrUndefined(colIdx)) {
                 if (colIdx === 0 || colIdx < sheet._leftCol.idx || colIdx > sheet._rightCol.idx)
                     colIdx = xlObj._getMidCell().colIdx;
                 offset = xlObj._getIdxWithOffset(null, colIdx).xOffset;
                 if (sheet._leftCol.idx === colIdx && sheet._scrollLeft !== offset)
                     xlObj.XLScroll._hScroller().scroll(offset);
                 offset = (offset + (sheet.showHeadings ? xlObj._rowHeaderWidth : 0)) - 1;
                 xlObj._removeClass(freeze, hide);
                 sheet._isFreezed = true;
                 freeze.style.left = sheet._fDivLeft = (offset - sheet._scrollLeft) + px;
                 freeze.style.height = (sheet._vPortHgt + (sheet.showHeadings ? xlObj._colHeaderHeight : 0)) - 4 + px;
                 sheet._contScrollLeft = sheet._scrollLeft;
             }
             else {
                 idx = xlObj.getFrozenColumns();
                 if (xlObj._isFrozen(idx)) {
                     colIdx = 0;
                     fleftColIdx = sheet._fleftColIdx - 1;
                     this._showFreezeCol(idx, fleftColIdx);
                     while (fleftColIdx >= idx) {
                         if (sheet._fHMergeCols.indexOf(idx.toString()) > -1) {
                             sheet._fHMergeCols.splice(sheet._fHMergeCols.indexOf(idx.toString()), 1);
                             xlObj._refreshSHMergeCells(null, [idx], 1, "column", "show");
                         }
                         idx++;
                     }
                     xlObj.addClass(freeze, hide);
                     sheet._isFreezed = false;
                 }
                 else
                     crefresh = false;
             }
             if (crefresh) {
                 sheet._fleftColIdx = colIdx;
                 sheet._frozenWidth = xlObj._getColOffsetLeft(sheet, colIdx);
                 sheet.paneTopLeftCell = xlObj.getAlphaRange(sheet._ftopRowIdx, colIdx);
                 xlObj.setFrozenColumns(colIdx);
                 sheet._frozenColumns = colIdx + 1;
             }
             if (rrefresh || crefresh) {
                xlObj.XLScroll._refreshScroller(null, null, rrefresh && crefresh ? "all" : (rrefresh ? "vertical" : "horizontal"));
                if (rrefresh)
                    xlObj.XLScroll._vScroller().scroll(xlObj._isFrozen(xlObj.getFrozenRows()) ? 0 : sheet._contScrollTop);
                if (crefresh)
                    xlObj.XLScroll._hScroller().scroll(xlObj._isFrozen(xlObj.getFrozenColumns()) ? 0 : sheet._contScrollLeft);
             }             
        },    

        _frozenScrollHandler: function(args) {
            var count, retVal, i = 0, xlObj = this.XLObj, xlScroll = xlObj.XLScroll, sheet = xlObj.getSheet(),
                sheetIdx = xlObj.getActiveSheetIndex(), vScroll = xlScroll._vScroller(sheetIdx), hScroll = xlScroll._hScroller(sheetIdx);
            if (args.model.orientation === ej.ScrollBar.Orientation.Vertical) {
                args["reachedEnd"] = Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").css('top'))) + Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").height())) >= vScroll.element.find(".e-vhandlespace").height() - 2;
                if (args.reachedEnd && xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite) {
                    count = ((args.scrollTop - sheet._scrollTop) / sheet.rowHeight);
                    if (sheet._bottomRow.idx + count >= sheet.rowCount - 1) {
                        if (!xlObj.model.scrollSettings.allowVirtualScrolling)
                            xlObj.XLScroll._scrollBottom(sheetIdx);
                        else {
                            sheet._virtualBlockCnt++;
                            sheet.rowCount += sheet._virtualBlockRowCnt;
                            while (i < sheet._virtualBlockRowCnt) {
                                sheet.rowsHeightCollection.push(sheet.rowHeight);
                                i++;
                            }
                        }
                    }
                    xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical");
                }
                if (xlScroll._isIntrnlScroll) {
                    this._scrollFreeze(xlScroll._scrollIdx);
                    xlScroll._scrollIdx = 0;
                    sheet._scrollTop = args.scrollTop;
                }
                else {
                    if (args.scrollTop != sheet._scrollTop && (!args.reachedEnd || xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite)) {
                        retVal = this._ensureFreezeScrollPos(args);
                        if (!xlObj.isUndefined(retVal.resetTo)) {
                            xlScroll._isIntrnlScroll = true;
                            xlScroll._scrollIdx = retVal.rowIdx;
                            xlScroll._vScroller().scroll(retVal.resetTo);
                            xlScroll._isIntrnlScroll = false;
                        }
                        else {
                            this._scrollFreeze(retVal.rowIdx);
                            sheet._scrollTop = args.scrollTop;
                        }
                    }
                }
            }
            else {
                args["reachedEnd"] = Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").css('left'))) + Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").width())) >= xlObj.element.find(".e-hhandlespace").width() - 2;
                count = ((args.scrollLeft - sheet._scrollLeft) / sheet.columnWidth);
                if (args.reachedEnd || (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite && sheet._rightCol.idx + count >= sheet.colCount - 1)) {
                    xlObj.XLScroll._scrollRight(sheetIdx);
                    xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "horizontal");
                }
                if (xlScroll._isIntrnlScroll) {
                    this._scrollFreeze(null, xlScroll._scrollIdx);
                    xlScroll._scrollIdx = 0;
                    sheet._scrollLeft = args.scrollLeft;
                }
                else {
                    if (args.scrollLeft != sheet._scrollLeft && (!args.reachedEnd || xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite)) {
                        retVal = this._ensureFreezeScrollPos(args);
                        if (!xlObj.isUndefined(retVal.resetTo)) {
                            xlScroll._isIntrnlScroll = true;
                            xlScroll._scrollIdx = retVal.colIdx;
                            xlScroll._hScroller().scroll(retVal.resetTo);
                            xlScroll._isIntrnlScroll = false;
                        }
                        else {
                            this._scrollFreeze(null, retVal.colIdx);
                            sheet._scrollLeft = args.scrollLeft;
                        }
                    }
                }
            }
			 if(xlObj.model.allowComments) 
				 xlObj.XLComment._updateCmntArrowPos();
        },

         _ensureFreezeScrollPos: function(args) {
             var pos, retVal, obj = {}, hideTypes = [ej.Spreadsheet.HideTypes.Freeze], xlObj = this.XLObj, sheet = xlObj.getSheet();
            if (args.model.orientation === ej.ScrollBar.Orientation.Vertical) {
                pos = args.scrollTop + sheet._frozenHeight;
                retVal = xlObj._getIdxWithOffset(pos, null, true, hideTypes);
                obj.rowIdx = retVal.rowIdx;
                if (pos !== retVal.yOffset)
                    obj.resetTo = retVal.yOffset - sheet._frozenHeight;
            }
            else {
                pos = args.scrollLeft + sheet._frozenWidth;
                retVal = xlObj._getIdxWithOffset(null, pos, true, hideTypes);
                obj.colIdx = retVal.colIdx;
                if (pos !== retVal.xOffset)
                    obj.resetTo = retVal.xOffset - sheet._frozenWidth;
            }
            return obj;
         },
         
         _scrollFreeze: function (rowIdx, colIdx) {
            var idx, xlObj = this.XLObj, sheet = xlObj.getSheet();
            if (rowIdx && sheet._ftopRowIdx !== rowIdx) {
                if (sheet._ftopRowIdx < rowIdx) {
                    idx = rowIdx - sheet._ftopRowIdx === 1 ? sheet._ftopRowIdx : rowIdx - 1;
                    this._hideFreezeRow(sheet._ftopRowIdx, idx);
                    this._refreshShape(sheet._ftopRowIdx, idx, true);
                 }
                else {
                    idx = sheet._ftopRowIdx - rowIdx === 1 ? rowIdx : sheet._ftopRowIdx - 1;
                    this._showFreezeRow(rowIdx, idx);
                    this._refreshShape(rowIdx, idx, true);
                }
                if (xlObj.model.scrollSettings.allowVirtualScrolling)
                    xlObj.refreshContent();
                while (idx >= rowIdx) {
                    if(sheet._fHMergeRows.indexOf(idx) > -1){
                        sheet._fHMergeRows.splice(sheet._fHMergeRows.length - 1, 1);
                        xlObj._refreshSHMergeCells(null, [idx], 1, "row", "show");
                    }
                    idx--;
                }
                sheet._ftopRowIdx = rowIdx;
                sheet.paneTopLeftCell = xlObj.getAlphaRange(rowIdx, sheet._fleftColIdx);
             }
             else if (colIdx && sheet._fleftColIdx !== colIdx) {
                 if (sheet._fleftColIdx < colIdx) {
                     idx = colIdx - sheet._fleftColIdx === 1 ? sheet._fleftColIdx : colIdx - 1;
                     this._hideFreezeCol(sheet._fleftColIdx, idx);
                     this._refreshShape(sheet._fleftColIdx, idx);
                 }
                 else {
                     idx = sheet._fleftColIdx - colIdx === 1 ? colIdx : sheet._fleftColIdx - 1;
                     this._showFreezeCol(colIdx, idx);
                     this._refreshShape(colIdx, idx);
                 }
                 while (idx >= colIdx) {
                     if (sheet._fHMergeCols.indexOf(idx.toString()) > -1) {
                         sheet._fHMergeCols.splice(sheet._fHMergeCols.length - 1, 1);
                         xlObj._refreshSHMergeCells(null, [idx], 1, "column", "show");
                     }
                     idx--;
                 }
                 sheet._fleftColIdx = colIdx;
                 sheet.paneTopLeftCell = xlObj.getAlphaRange(sheet._ftopRowIdx, colIdx);
             }
            this._refreshSelection();
         },

         _refreshShape: function (sIdx, eIdx, isRow) {
             var i, cellIdx, shapeData, chartId, shapeId, picId, pivotId, range, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), shape = sheet.shapeMngr, pvtMngr = sheet.pivotMngr;
             range = isRow ? [sIdx, 0, eIdx, sheet.colCount] : [0, sIdx, sheet.rowCount, eIdx];
             shapeData = xlObj.getRangeData({ range: range, property: ["picture", "chart"] });
             for (i = 0; i < shapeData.length; i++) {
                 if (shapeData[i].picture) {
                     picId = shapeData[i].picture[xlObj.getObjectLength(shapeData[i].picture)];
                     shapeId = isRow ? shape.picture[picId].rowIndex : shape.picture[picId].colIndex;
                     this._freezeShape($("#" + picId)[0], isRow ? sheet._hiddenFreezeRows.indexOf(shapeId) > -1 : sheet._hiddenFreezeCols.indexOf(shapeId) > -1);
                 }
                 if (shapeData[i].chart) {
                     chartId = shapeData[i].chart[xlObj.getObjectLength(shapeData[i].chart)];
                     shapeId = isRow ? shape.chart[chartId].rowIndex : shape.chart[chartId].colIndex;
                     this._freezeShape($("#" + chartId)[0], isRow ? sheet._hiddenFreezeRows.indexOf(shapeId) > -1 : sheet._hiddenFreezeCols.indexOf(shapeId) > -1);
                 }
                 if (shapeData[i].pivot) {
                     pivotId = shapeData[i].pivot[xlObj.getObjectLength(shapeData[i].pivot)];
                     shapeId = isRow ? pvtMngr.pivot[pivotId].rowIndex : pvtMngr.pivot[pivotId].colIndex;
                     this._freezeShape($("#" + pivotId)[0], isRow ? sheet._hiddenFreezeRows.indexOf(shapeId) > -1 : sheet._hiddenFreezeCols.indexOf(shapeId) > -1);
                 }
             }
         },
         
         _freezeShape: function (shapeElem, isHidden) {
             var xlObj = this.XLObj;
             if (isHidden)
                 xlObj.addClass(shapeElem, "e-hide");
             else
                 xlObj._removeClass(shapeElem, "e-hide");
         },

         _hideFreezeRow: function(srowIdx, eRowIdx) {
             var i, xlObj = this.XLObj, scrollSettings = xlObj.model.scrollSettings, isVirtualScroll = scrollSettings.allowScrolling && scrollSettings.allowVirtualScrolling, 
                sheetIdx = xlObj.getActiveSheetIndex(), rowColl = xlObj.getRows(sheetIdx), hdrRows = rowColl[0], rows = rowColl[1], sheet = xlObj.getSheet(sheetIdx), usedRange = sheet.usedRange;
             while (srowIdx <= eRowIdx) {
                 i = 0;
                if (sheet._hiddenFreezeRows.indexOf(srowIdx) === -1)
                    sheet._hiddenFreezeRows.push(srowIdx);
                if (!isVirtualScroll && xlObj._isRowViewable(sheetIdx, srowIdx)) {
                    xlObj.addClass(rows[srowIdx], "e-r-hide");
                    xlObj.addClass(hdrRows[srowIdx], "e-r-hide");
                }
                while (i < usedRange.colIndex) {
                    if(xlObj.XLCellNav._isMergedCell({ rowIndex: srowIdx, colIndex: i }))
                    {   
                        sheet._fHMergeRows.push(srowIdx);
                        xlObj._refreshSHMergeCells(sheetIdx, [srowIdx], 1, "row", "hide");
                        break;
                    }
                    i++;
                }
                srowIdx++;
             }
         },

         _showFreezeRow: function(srowIdx, eRowIdx) {
             var idx, isFHide, xlObj = this.XLObj, scrollSettings = xlObj.model.scrollSettings, isVirtualScroll = scrollSettings.allowScrolling && scrollSettings.allowVirtualScrolling,
                sheetIdx = xlObj.getActiveSheetIndex(), rowColl = xlObj.getRows(sheetIdx), hdrRows = rowColl[0], rows = rowColl[1], sheet = xlObj.getSheet();
             while (srowIdx <= eRowIdx) {
                idx = sheet._hiddenFreezeRows.indexOf(srowIdx);
                if (xlObj.model.allowFiltering)
                     isFHide = this._refreshFiltering(srowIdx);
                if (idx > -1) {
                    sheet._hiddenFreezeRows.splice(idx, 1);
                    if (!isVirtualScroll && xlObj._isRowViewable(sheetIdx, srowIdx) && !isFHide) {
                        xlObj._removeClass(rows[srowIdx], "e-r-hide");
                        xlObj._removeClass(hdrRows[srowIdx], "e-r-hide");
                    }
                }
                srowIdx++;
            }
        },
         _refreshFiltering: function (rowIdx) {
             var isFHide = false, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet();
             if (!ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, 0, "isFilterHide", sheetIdx))) {
                 if (sheet._filterHRowsColl.indexOf(rowIdx) === -1)
                     sheet._filterHRowsColl.push(rowIdx);
                 isFHide = true;
                 return isFHide;
             }
             return isFHide;
         },
        _hideFreezeCol: function(scolIdx, ecolIdx) {
            var diff, cells, j, hide = "e-fcol-hide", i = scolIdx, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(),
                usedRange = sheet.usedRange, idxColl = xlObj.model.scrollSettings.allowVirtualScrolling ? sheet._virtualRowIdx : sheet._rowIdxColl,
                hdr = xlObj._getJSSheetHeader(sheetIdx), cont = xlObj._getContent(sheetIdx), th = hdr.find("th"),
                hdrColGrp = hdr.find("col"), contColGrp = cont.find("col"), hdrTable = hdr.find("table");
            diff = xlObj._getWidth(scolIdx, ecolIdx);
            while (i <= ecolIdx) {
                j = 0;
                if (sheet._hiddenFreezeCols.indexOf(i) === -1)
                    sheet._hiddenFreezeCols.push(i);
                xlObj.addClass(th[i], hide);
                xlObj.addClass(hdrColGrp[i], hide);
                xlObj.addClass(contColGrp[i], hide);
                while (j < usedRange.rowIndex) {
                    if (xlObj.XLCellNav._isMergedCell({ rowIndex: j, colIndex: i })) {
                        sheet._fHMergeCols.push(i.toString());
                        xlObj._refreshSHMergeCells(sheetIdx, [i], 1, "column", "hide");
                        break;
                    }
                    j++;
                }
                i++; 
            }
            cells = xlObj.getRange([idxColl[0], scolIdx, idxColl[idxColl.length - 1], ecolIdx]);
            i = cells.length;
            if (i) {
                while (i--)
                    xlObj.addClass(cells[i], hide);
            }
            diff = hdrTable.width() - diff;
            hdrTable.width(diff);
            cont.find(".e-table").width(diff);
        },

        _getWidth: function(scolIdx, ecolIdx) {
            var wth = 0, sheet = this.XLObj.getSheet();
            for (; scolIdx <= ecolIdx; scolIdx++)
                wth += sheet.columnsWidthCollection[scolIdx];
            return wth;
        },

        _showFreezeCol: function(scolIdx, ecolIdx) {
            var idx, diff, cells, hide = "e-fcol-hide", i = scolIdx, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(), hdr = xlObj._getJSSheetHeader(sheetIdx), cont = xlObj._getContent(sheetIdx), th = hdr.find("th"),
                idxColl = xlObj.model.scrollSettings.allowVirtualScrolling ? sheet._virtualRowIdx : sheet._rowIdxColl,
                hdrColGrp = hdr.find("col"), contColGrp = cont.find("col"), hdrTable = hdr.find("table");
            diff = xlObj._getWidth(0, sheet.colCount - 1) - (sheet._frozenColumns - 1 < scolIdx ? xlObj._getWidth(sheet._frozenColumns - 1, scolIdx) : 0);
            while (i <= ecolIdx) {
                idx = sheet._hiddenFreezeCols.indexOf(i);
                if (idx > -1) {
                    sheet._hiddenFreezeCols.splice(idx, 1);
                    xlObj._removeClass(th[i], hide);
                    xlObj._removeClass(hdrColGrp[i], hide);
                    xlObj._removeClass(contColGrp[i], hide);
                }
                i++; 
            }
            cells = xlObj.getRange([idxColl[0], scolIdx, idxColl[idxColl.length - 1], ecolIdx]);
            i = cells.length;
            if (i) {
                while (i--)
                    xlObj._removeClass(cells[i], hide);
            }
            hdrTable.width(diff);
            cont.find(".e-table").width(diff);
        },

        _refreshSelection: function () {
            var sRIdx, eRIdx, sCIdx, eCIdx, isTrue = false, xlObj = this.XLObj, sheet = xlObj.getSheet(),
                sRange = sheet.selectedRange, rIdx = sRange[2], cIdx = sRange[3], startRow = sRange[0], startCol = sRange[1];
            if (sheet._endCell.rowIndex + 1 >= sheet._frozenRows && sheet._endCell.rowIndex < sheet._ftopRowIdx && sheet._startCell.rowIndex < sheet._frozenRows - 1) {
                rIdx = sheet._frozenRows - 2;
                isTrue = true;
            }
            else {
                sRIdx = sRange[0], eRIdx = sRange[2];
                if (sheet._frozenRows - 1 <= sRIdx)
                    while (sRIdx <= eRIdx) {
                        if (sRIdx < sheet._ftopRowIdx)
                            sRIdx++;
                        else {
                            startRow = sRIdx;
                            break;
                        }
                    }
            }
            if (sRange[3] + 1 >= sheet._frozenColumns && sRange[3] < sheet._fleftColIdx && sRange[1] < sheet._frozenColumns - 1) {
                cIdx = sheet._frozenColumns - 2;
                isTrue = true;
            }
            else {
                sCIdx = sRange[1], eCIdx = sRange[3];
                if (sheet._frozenColumns - 1 <= sCIdx)
                    while (sCIdx <= eCIdx) {
                        if (sCIdx < sheet._fleftColIdx)
                            sCIdx++;
                        else {
                            startCol = sCIdx;
                            break;
                        }
                    }
            }
            if (sRIdx == eRIdx + 1 || sCIdx == eCIdx + 1)
                xlObj.XLSelection._hideShowSelElem("hide");
            else {
                xlObj.XLSelection._refreshBorder([startRow, startCol, rIdx, cIdx]);
                if (isTrue)
					xlObj.addClass(xlObj.getAutoFillElem()[0], "e-hide")
				else
					xlObj.model.allowAutoFill && xlObj.XLDragFill.positionAutoFillElement();
            }
        },
        
        _selectionScroll: function (isShiftKey) {
            var i, diff, trgt, hiddenWth, hiddenHgt = hiddenWth = 0, xlObj = this.XLObj, sheet = xlObj.getSheet(), sheetIdx = xlObj.getActiveSheetIndex();
            if (xlObj._isFrozen(sheet.frozenRows)) {
                // To Scroll vertically from top to bottom
                if (sheet._startCell.rowIndex + 1 < sheet._frozenRows && sheet._endCell.rowIndex + 1 > sheet._frozenRows && sheet.selectedRange[2] < sheet._ftopRowIdx) {
                    if (sheet._ftopRowIdx + 1 - sheet._frozenRows > 0) {
                        diff = sheet._endCell.rowIndex - sheet._ftopRowIdx;
                        sheet._endCell.rowIndex = sheet._frozenRows - 1 + diff;
                        for (i = sheet._frozenRows - 1; i < sheet._ftopRowIdx; i++)
                            hiddenHgt += sheet.rowsHeightCollection[i];
                        xlObj._scrollContent({ y: -hiddenHgt });
                    }
                }
                // To Scroll vertically from bottom to top
                else if (sheet.selectedRange[2] - sheet._endCell.rowIndex > 0 && sheet._ftopRowIdx > sheet._frozenRows - 1 && !sheet._isColSelected
                    && sheet._endCell.rowIndex < sheet._frozenRows - 1 && sheet.selectedRange[2] - sheet.selectedRange[0] > 0 && sheet.selectedRange[2] >= sheet._ftopRowIdx - 1) {
                    sheet._endCell.rowIndex = sheet._ftopRowIdx - 1;
                    trgt = xlObj.getCell(sheet._frozenRows - 2, sheet._endCell.colIndex)[0];
                    xlObj.XLSelection._scrollCalculation(sheetIdx, trgt, { position: "vertical", action: "Decrement" });
                }
            }
            if (xlObj._isFrozen(sheet.frozenColumns)) {
                // To Scroll Horizontally from left to right
                if (sheet._startCell.colIndex + 1 < sheet._frozenColumns && sheet._endCell.colIndex + 1 > sheet._frozenColumns && sheet.selectedRange[3] < sheet._fleftColIdx) {
                    if (sheet._fleftColIdx + 1 - sheet._frozenColumns > 0) {
                        diff = sheet._endCell.colIndex - sheet._fleftColIdx;
                        sheet._endCell.colIndex = sheet._frozenColumns - 1 + diff;
                        for (i = sheet._frozenColumns - 1; i < sheet._fleftColIdx; i++)
                            hiddenWth += sheet.columnsWidthCollection[i];
                        xlObj._scrollContent({ x: -hiddenWth });
                    }
                }
                // To Scroll Horizontally from right to left
                else if (sheet.selectedRange[3] - sheet._endCell.colIndex > 0 && sheet._fleftColIdx > sheet._frozenColumns - 1 && !sheet._isRowSelected
                    && sheet._endCell.colIndex < sheet._frozenColumns - 1 && sheet.selectedRange[3] - sheet.selectedRange[1] > 0 && sheet.selectedRange[3] >= sheet._fleftColIdx - 1) {
                    sheet._endCell.colIndex = sheet._fleftColIdx - 1;
                    trgt = xlObj.getCell(sheet._frozenColumns - 2, sheet._endCell.colIndex)[0];
                    xlObj.XLSelection._scrollCalculation(sheetIdx, trgt, { position: "horizontal", action: "Decrement" });
                }
            }
        },
        _refreshFColResize: function (colIdx) {
            var diff, offset, px = "px", xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(), fCol = xlObj.getFrozenColumns() + 1, vfreeze = this._getVFreeze()[0], width = sheet._frozenWidth, left = parseInt(this._getVFreeze()[0].style.left);
            xlObj.XLScroll._getColWidths(sheetIdx, colIdx);
            sheet._frozenWidth = xlObj._getColOffsetLeft(sheet, fCol - 1);
            diff = (width > sheet._frozenWidth) ? width - sheet._frozenWidth : sheet._frozenWidth - width;
            if (colIdx < fCol - 1)
                vfreeze.style.left = sheet._fDivLeft = (width >= sheet._frozenWidth) ? (left - diff) + px : (left + diff) + px;
        },
        _refreshFRowResize: function (rowIdx) {
            var diff, offset, px = "px", xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(), fRow = xlObj.getFrozenRows() + 1, hfreeze = this._getHFreeze()[0], height = sheet._frozenHeight, top = parseInt(this._getHFreeze()[0].style.top);
            xlObj.XLScroll._getRowHeights(sheetIdx, rowIdx);
            sheet._frozenHeight = xlObj._getRowOffsetTop(sheet, fRow - 1);
            diff = (height > sheet._frozenHeight) ? height - sheet._frozenHeight : sheet._frozenHeight - height;
            if (rowIdx < fRow - 1)
                hfreeze.style.top = sheet._fDivTop = (height >= sheet._frozenHeight) ? (top - diff) + px : (top + diff) + px;
        },

        _refreshFreezeRowDiv: function () {
            var xlObj = this.XLObj; sheet = xlObj.getSheet();
            sheet._fDivTop = xlObj._getIdxWithOffset(sheet._frozenRows - 1).yOffset - sheet._contScrollTop + (sheet.showHeadings ? (xlObj._colHeaderHeight - 2) : 0) + "px";
            sheet._frozenHeight = xlObj._getRowOffsetTop(sheet, sheet._frozenRows - 1);
            this._refreshFreeze();
        },

        _refreshFreezeColDiv: function () {
            var xlObj = this.XLObj; sheet = xlObj.getSheet();
            sheet._fDivLeft = xlObj._getColOffsetLeft(sheet, sheet._frozenColumns - 1) - sheet._contScrollLeft + (sheet.showHeadings ? xlObj._rowHeaderWidth : 0) - 1 + "px";
            sheet._frozenWidth = xlObj._getColOffsetLeft(sheet, sheet._frozenColumns - 1);
            this._refreshFreeze();
        }
    };
})(jQuery, Syncfusion);
;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};
    ej.spreadsheetFeatures.math = {
        toFraction: function (val) {
            if (this.isNumber(val)) {
                var input = val.toString(), integerval = input.split(".")[0], decimalval = input.split(".")[1];
                if (!decimalval)
                    return { integer: val };
                var wholeval = (+decimalval).toString(), placeval = this.getPlaceValue(decimalval, wholeval), gcd = this.getGcd(wholeval, placeval);
                return { integer: integerval, numerator: Number(wholeval) / gcd, denominator: Number(placeval) / gcd };
            }
            return null;
        },

        toExponential: function (val, decimalplaces) {
            if (this.isNumber(val)) {
                var expval, input = Number(val);
                decimalplaces = decimalplaces || 2;
                if (decimalplaces > 20)
                    decimalplaces = 20;
                expval = input.toExponential(decimalplaces).split("e+");
                return expval[0] + "E+" + this.padZeros(expval[1]);
            }
            return null;
        },

        toAccounting: function (formatstr, value, locale) {
            if (this.isNumber(value) && formatstr) {
                var prefix, suffix, val = ej.widgetBase.formatting(formatstr, value, locale), symbol = this._currencySymbol,
                    trunval = $.trim(val.replace(symbol, "")), idx = val.indexOf(symbol);
                if (!idx || (value < 0 && idx === 1)) {
                    prefix = symbol;
                    suffix = !Number(value) ? "-" : trunval;
                }
                else {
                    prefix = !Number(value) ? "-" : trunval;
                    suffix = symbol;
                }
                value = prefix + "   " + suffix;
            }
            return value;
        },

        intToDate: function (num) {
            return new Date(((Number(num) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
        },

        getGcd: function (a, b) {  //make generic gcd of multiple no
            a = Number(a);
            b = Number(b);
            if (!b)
                return a;
            return this.getGcd(b, a % b);
        },

        isNumber: function (val) {
            return val - parseFloat(val) >= 0;
        },

        isTime: function (val) {
            return !val ? false : val.toString().indexOf(":") !== -1;
        },

        isFormula: function (formula) {
            var obrackets, cbrackets;
            if (formula) {
                if (!formula.toString().indexOf("=") && formula.length > 1) {
                    obrackets = formula.split("(").length - 1;
                    cbrackets = formula.split(")").length - 1;
                    return obrackets === cbrackets;
                }
            }
            return false;
        },

        getPlaceValue: function (val, digit) {
            var index = val.indexOf(digit) + digit.length;
            return "1" + Array(index + 1).join("0");
        },

        padZeros: function (val, digits, position) {
            if (this.isNumber(val)) {
                digits = this.isNumber(digits) ? digits : 2;
                position = ej.isNullOrUndefined(ej.Spreadsheet.autoFillDirection[position]) ? ej.Spreadsheet.autoFillDirection.Left : ej.Spreadsheet.autoFillDirection[position];
                if (position === ej.Spreadsheet.autoFillDirection.Left)
                    return val <= this.maxValue(digits) ? Array(digits - this.getDigits(val) + 1).join("0") + val.toString() : val.toString();
                else
                    return val < this.minValue(digits) ? val.toString() + Array(digits - this.getDigits(val) + 1).join("0") : val.toString();
            }
            return null;
        },

        maxValue: function (digits) {
            if (this.isNumber(digits))
                return Number(Array(digits + 1).join("9"));
            return null;
        },

        minValue: function (digits) {
            if (this.isNumber(digits))
                return Number("1" + Array(digits).join("0"));
            return null;
        },

        getDigits: function (val) {
            if (this.isNumber(val))
                return val.toString().length;
            return null;
        },

        _round: function round(val, digits) {
            return Number(Math.round(val + 'e' + digits) + 'e-' + digits);
        },

        _parseTime: function (val) {   // will return object as input of new date
            var len, sval, i = 0, j = 3, obj = {}, cval;
            if (this.isTime(val)) {
                val = val.toString();
                sval = val.split(" ");
                len = sval.length;
                while (i < len) {
                    if (this.isTime(sval[i])) {
                        cval = sval[i].split(":");
                        while (j < 6) {
                            obj[this._datePattern[j]] = cval[j - 3] || "0";
                            j++;
                        }
                    }
                    i++;
                }
            }
            return obj;
        },

        _dateToInt: function (date, isTime) {
            var date1 = new Date("01/01/1900"), date2 = this._isDateTime(date) ? date : new Date(date),
                timeDiff = (date2.getTime() - date1.getTime()),
                diffDays = (timeDiff / (1000 * 3600 * 24)) + 2;
            return isTime ? diffDays % 1 : diffDays;
        },

        _defTimeFormat: function (d) {
            var dformat = [d.getHours(),
                    d.getMinutes(),
                    d.getSeconds()].join(":");
            return dformat;
        },

        _isDate: function (text) {
            var regx = /^((0?[1-9]|1[012])[-.](0?[1-9]|[12][0-9]|3[01])[-.](19|20)?[0-9]{2})*$/, value = {};
            if (!ej.isNullOrUndefined(ej.parseDate(text.toString())))
                text = this._dateToInt(text.toString());
            if (regx.test(text.toString())) {
                text = text.toString().replace("-", "/", "g");
                text = this._dateToInt(text.toString());
                value.text = text;
                value.isDate = true;
            }
            else {
                value.text = text;
                value.isDate = false;
            }
            return value;
        },

        _defDateFormat: function (d) {
            var dformat = [(d.getMonth() + 1),
                        d.getDate(),
                        d.getFullYear()].join("/");
            return dformat;
        },

        _isCellReference: function (text) {
            return /^[a-z]{1,3}\d{1,7}$/gi.test(text) ? "relative" : (/^\$[a-z]{1,3}\$\d{1,7}$/gi.test(text) ? "absolute" : (/^((\$[a-z]{1,3})\d{1,7}|[a-z]{1,3}(\$\d{1,7}))$/gi.test(text) ? "mixed" : false));
        },

        _isDateTime: function (date) {
            return Object.prototype.toString.call(date) === "[object Date]" && !isNaN(date.valueOf());
        },

        _decimalCnt: function (val) {
            var strVal, fixVal;
            if (this.isNumber(val)) {
                val = Number(val);
                strVal = val.toString();
                if (strVal.indexOf(this._decimalSeparator) > -1) {
                    fixVal = val.toFixed();
                    return (strVal.length - fixVal.length) - 1;
                }
            }
            return 0;
        },

        _getPosDiff: function (x, y) {
            return x > y ? x - y : y - x;
        }
    };
})(jQuery, Syncfusion);
;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.resizing = function (obj) {
        this.XLObj = obj;
        this._$visualElem = $();
        this._currentHCell = -1;
        this._colMinWidth = 15;
        this._rowMinHeight = 20;
        this._allowStart = false;
        this._resizeStart = false;
        this._resizeType = "";
        this._tableY = null;
        this._oldWidth = null;
        this._orgX = null;
        this._orgY = null;
        this._extra = null;
        this._initialTableWidth = null;
        this._resizeElt = null;
        this._tableX = null;
        this._oldHeight = null;
        this._initialTableHeight = null;
        this._resizerowId = 0;
    };

    ej.spreadsheetFeatures.resizing.prototype = {
        //Resizing

        getColWidth: function (colIdx) {
            return this.XLObj.getSheet(this.XLObj.getActiveSheetIndex()).columnsWidthCollection[colIdx];
        },

        getRowHeight: function (rowIdx) {
            return this.XLObj.getSheet(this.XLObj.getActiveSheetIndex()).rowsHeightCollection[rowIdx];
        },

        setColWidth: function (colIdx, size) {
            if (!this.XLObj.model.allowResizing)
                return;
            var sheetIdx = this.XLObj.getActiveSheetIndex();
            this._currentHCell = colIdx;
            this._resizeColumnUsingDiff(size, this.XLObj.getSheet(sheetIdx).columnsWidthCollection[colIdx], [colIdx]);
            this.XLObj.XLScroll._getColWidths(sheetIdx, colIdx);
            this.XLObj.XLSelection.refreshSelection();
        },

        setRowHeight: function (rowIdx, size) {
			var xlObj = this.XLObj;
            if (!this.XLObj.model.allowResizing)
                return;
            var sheetIdx = this.XLObj.getActiveSheetIndex()
            this._currentHCell = rowIdx;
            this._resizeRowUsingDiff(size, this.XLObj.getSheet(sheetIdx).rowsHeightCollection[rowIdx], [rowIdx]);
        },

        _headerMouseDown: function (e) {
            e.preventDefault();
            this._colMouseDown(e);
        },

        _colMouseDown: function (e) {
            var xy, xlObj = this.XLObj, args = {};
            xy = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1);
            this._orgX = xy[0] + document.documentElement.scrollLeft;
            this._orgY = xy[1];
            if (xlObj._isTouchEvt)
                this._mouseHover(e);
            if (this._allowStart && (($(e.target).css("cursor") === "col-resize") || xlObj._isTouchEvt)) {
                args.event = e;
                args.target = e.target;
                args.colIndex = this._currentHCell;
                args.oldWidth = e.target.getBoundingClientRect().width;
                args.reqType = "column-resize";
                if (xlObj._trigger("resizeStart", args)) {
                    return;
                }
                if (e.button !== 2)
                    this._start(this._orgX, this._orgY);
                this._resizeType = "Col";
                e.preventDefault();
            }
        },

        _mouseHover: function (e) {
            var nlx, xlObj = this.XLObj, trgt = e.target, sheetIdx = xlObj.getActiveSheetIndex(), header = xlObj._getJSSheetHeader(sheetIdx);
            if (this._$visualElem.is(":visible"))
                return;
            if (xlObj._hasClass(trgt, "e-headercelldiv"))
                trgt = trgt.parentNode;
            if (xlObj._hasClass(trgt, "e-headercell")) {
                var resCell = trgt, location = resCell.getBoundingClientRect(), xy = xlObj._setXY(e), x = xy[0], y = xy[1];
                nlx = $(header.find(".e-table")[0]).width() + $(header.find(".e-columnheader")[0]).offset().left;
                if (((x >= (location.left + document.documentElement.scrollLeft + resCell.offsetWidth - (xlObj._isTouchEvt ? 15 : 5))) || ((x <= (location.left + (xlObj._isTouchEvt ? 13 : 3))))) && (x < nlx) && (x >= location.left) && (y <= location.top + document.documentElement.scrollTop + trgt.offsetHeight)) {
                    this._currentHCell = header.find(".e-headercell").index(resCell);
                    if (this._currentHCell < 1 && x < (location.left + resCell.offsetWidth - (xlObj._isTouchEvt ? 15 : 5)) || (this._preventColResize(this._currentHCell, false)))
                        return;
                    xlObj.addClass(trgt, "e-ss-colresize");
                    this._allowStart = true;
                }
                else {
                    xlObj._removeClass($(".e-ss-colresize")[0], "e-ss-colresize");
                    this._allowStart = false;
                    this._currentHCell = -1;
                }
            }
        },
        _preventColResize: function (colIdx, isCMenu) {
            this._currentHCell = colIdx;
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), pivotIdCol = [], pvtMngr = xlObj.getSheet(sheetIdx).pivotMngr.pivot,
            pivotIdCol = xlObj.getObjectKeys(pvtMngr), pvtColIdx, colCount, pvtObj, count, i,
            pivotCount = pivotIdCol.length;
            if (pivotIdCol.length) {
                for (i = 0; i < pivotCount; i++) {
                    pvtColIdx = pvtMngr[pivotIdCol[i]].colIndex;
                    pvtObj = xlObj.element.find('#' + pivotIdCol[i]).data("ejPivotGrid");
                    count = (pvtObj.calculateCellWidths().columnWidths).length;
                    if (!count)
                        count = 3;
                    colCount = pvtColIdx + count;
                    if (isCMenu)
                        return this._currentHCell >= pvtColIdx && this._currentHCell < colCount;
                    else
                        return this._currentHCell >= pvtColIdx && this._currentHCell <= colCount;
                }
            }
        },

        _start: function (x, y) {
            var xlObj = this.XLObj, height, sheetIdx = xlObj.getActiveSheetIndex(), header = xlObj._getJSSheetHeader(sheetIdx), row = header.find(".e-columnheader"), cells = row.find(".e-headercell"), cell, rect;
            if (this._currentHCell > -1 && this._currentHCell < cells.length)
                cell = cells[this._currentHCell];
            if (ej.isNullOrUndefined(cell))
                return;
            rect = cell.getBoundingClientRect();
            this._tableY = rect.top + parseInt(navigator.userAgent.indexOf("WebKit") > -1 ? document.body.scrollTop : document.documentElement.scrollTop);
            if (this._allowStart) {
                this._$visualElem = $(document.createElement("div"));
                height = xlObj._getJSSheetContent(sheetIdx).height() + header.height();
                this._$visualElem.addClass("e-reSizeColbg").appendTo(xlObj.element).css({ height: height + "px" }).addClass("e-ss-colresize");
                this._$visualElem.css({ left: x - 1, top: this._tableY });
                this._oldWidth = cell.offsetWidth;
                this._extra = x - this._orgX;
                this._resizeStart = true;
            }
            else {
                this._currentHCell = -1;
            }
        },

        _cMouseMove: function (e) {
            if (this._resizeStart) {
                var x = this.XLObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1)[0];
                x += document.documentElement.scrollLeft;
                e.preventDefault();
                this._moveVisual(x);
                this.XLObj.addClass(e.target, "e-ss-colresize");
            }
            else
                this._mouseHover(e);
        },

        _reSize: function (x) {
            // Function used for Resizing the column                     
            var oldWidth, xlObj = this.XLObj,  groupedColumn, sheetIdx = xlObj.getActiveSheetIndex(), i, header = xlObj._getJSSheetHeader(sheetIdx), colSelected = header.find(".e-colselected"), colLen = colSelected.length, currentCHCellIdx, currentCHCells = [];
            this._initialTableWidth = xlObj._getJSSheetHeader(sheetIdx).find(".e-headercontent").width();
            this._getResizableCell();
            if (this._currentHCell > -1 && this._resizeStart) {
                oldWidth = xlObj.getSheet(sheetIdx).columnsWidthCollection[this._currentHCell];
                (colLen > 0) && (currentCHCellIdx = colSelected[0].cellIndex);
				for (i = 0; i < colLen; i++) {
				    (this._currentHCell === currentCHCellIdx) && (groupedColumn = true);
				    currentCHCells.push(currentCHCellIdx);
				    currentCHCellIdx++;
				}
				(!groupedColumn) && (currentCHCells = [this._currentHCell]);
				this._resizeColumnUsingDiff(x - this._orgX + oldWidth, oldWidth, currentCHCells);
				if (xlObj._isAutoWHMode)
				    xlObj._autoSSWidthHeight();
                if(xlObj.model.allowAutoFill){
					xlObj.XLDragFill.positionAutoFillElement();
					xlObj.XLDragFill.hideAutoFillOptions();
				}
                if ($("#" + xlObj._id + "ddlspan").length)
                    xlObj._ddlPosition();
            }
			xlObj.XLScroll._getRowHeights(sheetIdx, this._currentHCell);
            if(xlObj.model.allowFreezing)
                xlObj.XLFreeze._refreshFColResize(this._currentHCell);
            xlObj.model.allowSelection && xlObj.XLSelection._refreshBorder();
            this._removeVisualElem();
        },

        _resizeColumnUsingDiff: function (newWidth, oldWidth, currentCHCells) {
            var span, cellObj, txtVal, txtWidth, columnCells, overflowCells, $headerCol, $ContentCol, xlObj = this.XLObj, details = {}, sheetIdx = xlObj.getActiveSheetIndex(), header = xlObj._getJSSheetHeader(sheetIdx);
            if (newWidth > 0) {
                newWidth = newWidth > this._colMinWidth ? newWidth : this._colMinWidth;
				for (var i = 0, len = currentCHCells.length; i < len; i++) {
				    if (xlObj.XLEdit.getPropertyValue(0, currentCHCells[i], "wrapCol") && xlObj.XLEdit.getPropertyValue(0, currentCHCells[i], "wrapWidth") > newWidth) {
				        xlObj._dupDetails = true;
				        continue;
				    }
				    $headerCol = header.find("col:eq(" + currentCHCells[i] + ")");
				    $ContentCol = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer").find("col:eq(" + currentCHCells[i] + ")");
				    $headerCol.outerWidth(newWidth);
				    $ContentCol.width(newWidth);
				    xlObj.getSheet(sheetIdx).columnsWidthCollection[currentCHCells[i]] = newWidth;
				    if (newWidth < oldWidth) {
				        columnCells = xlObj._getContent(sheetIdx).find(".e-rowcell:nth-child(" + (currentCHCells[i] + 1) + ")");
				        for (var j = 0, length = columnCells.length; j < length; j++) {
				            cellObj = xlObj._getCellIdx(columnCells[j]);
				            txtVal = xlObj.XLEdit.getPropertyValue(cellObj.rowIndex, cellObj.colIndex, "value2");
				            if (txtVal) {
				                xlObj._refreshGlobalSpan();
				                span = $('#' + xlObj._id + '_emptySpan');
				                xlObj.addClass(span[0], 'e-rowcell');
				                span.text(txtVal);
				                txtWidth = span.outerWidth();
				                xlObj._refreshGlobalSpan();
				                if (newWidth < txtWidth) {
				                    xlObj._textClip(cellObj.rowIndex, cellObj.colIndex, "delete");
				                    xlObj._textClip(cellObj.rowIndex, cellObj.colIndex, "add", txtWidth);
				                }
				            }
				        }
				    }
				    else {
				        overflowCells = xlObj._getContent(sheetIdx).find(".e-rowcell.e-ofbrdr:nth-child(" + (currentCHCells[i] + 1) + ")");
				        for (var j = 0, leng = overflowCells.length; j < leng; j++) {
				            cellObj = xlObj._getCellIdx(overflowCells[j]);
				            xlObj._textClip(cellObj.rowIndex, cellObj.colIndex, "delete", "", true);
				            xlObj._textClip(cellObj.rowIndex, cellObj.colIndex, "add", "", true);
				        }
				    }
				}
				header.find(".e-columnheader").css("cursor", "default");
				if (!xlObj._dupDetails) {
				    details = { sheetIndex: sheetIdx, cols: currentCHCells, newWidth: newWidth, oldWidth: oldWidth, reqType: "resize-column" };
				    if (oldWidth !== newWidth) {
				        xlObj._completeAction(details);
				        xlObj._trigActionComplete(details);
				    }
				}
				xlObj._dupDetails && (xlObj._dupDetails = false);
				xlObj.XLScroll._getColWidths(sheetIdx, currentCHCells[0]);
				if (xlObj.model.scrollSettings.allowScrolling) {
				    xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
				    xlObj.XLScroll._getFirstColumn(sheetIdx);
				}
            }
        },

        _calculateWidth: function () {
            var xlObj = this.XLObj, colgroup = xlObj._getJSSheetHeader(xlObj.getActiveSheetIndex()).find("col"), width = 0;
            for (var i = 0; i < colgroup.length; i++)
                width += colgroup.eq(i).width();
            return width;

        },

        _cMouseUp: function (e) {
            if (this._resizeStart) {
                var x, xlObj = this.XLObj, currentHCell = this._currentHCell, cWidthColl = xlObj.getSheet(xlObj.getActiveSheetIndex()).columnsWidthCollection, args = {};
                x = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1)[0];
                x += document.documentElement.scrollLeft;
                args.event = e;
                args.target = e.target;
                args.oldWidth = cWidthColl[currentHCell];
                args.colIndex = this._currentHCell;
                this._reSize(x);
                args.newWidth = cWidthColl[currentHCell];
                args.reqType = "column-resize";
                if (this.XLObj._trigger("resizeEnd", args)) {
                    return;
                }
                xlObj.element.find("#" + xlObj._id + "ddl").ejDropDownList("hidePopup");
            }
        },

        _getResizableCell: function (e) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), row = xlObj._getJSSheetHeader(sheetIdx).find(".e-columnheader"), cell = row.find(".e-headercell");
            var scrollLeft = navigator.userAgent.indexOf("WebKit") > -1 ? document.body.scrollLeft : document.documentElement.scrollLeft, xlimit, point, hdnColCnt = 0;
            for (var i = 0, len = cell.length; i < len; i++) {
                point = cell[i].getBoundingClientRect();
                xlimit = point.left + scrollLeft + 5;
                if (xlimit > this._orgX) {
                    if (xlObj.isUndefined(e))
                        this._currentHCell = i - 1;
                    else
                        e.target = xlObj._getJSSheetHeader(sheetIdx).find('th:eq(' + (i - 1) + ')')[0];
                    return;
                }
            }
        },

        _moveVisual: function (x) {
            /// Used to move the visual element in mouse move
            var xlObj = this.XLObj, bounds = xlObj._getJSSheetHeader(xlObj.getActiveSheetIndex()).find(".e-headercontent")[0].getBoundingClientRect();
            if ((bounds.left + document.documentElement.scrollLeft + bounds.width < x) || (x < bounds.left + document.documentElement.scrollLeft))
                this._$visualElem.remove();
            else if (this._currentHCell > -1)
                this._$visualElem.css({ left: x - 1, top: this._tableY });
        },

        _rowMouseDown: function (e) {
            var x, y, xy, args = {}, xlObj = this.XLObj;
            if (xlObj._isTouchEvt)
                this._rowMouseHover(e);
            if (this._allowStart && ($(e.target).css("cursor") === "row-resize")) {
                xy = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1);
                x = xy[0];
                y = xy[1];
                y += document.documentElement.scrollTop;
                args.event = e;
                args.target = e.target;
                args.rowIndex = this._currentHCell;
                args.oldHeight = e.target.getBoundingClientRect().height;
                args.reqType = "row-resize";
                if (this.XLObj._trigger("resizeStart", args)) {
                    return;
                }
                if (e.button !== 2)
                    this._rowStart(x, y);
                this._resizeType = "Row";
                e.preventDefault();
            }
            return false;
        },

        _rowMouseHover: function (e) {
            if (this._$visualElem.is(":visible"))
                return;
            var $trgt = $(e.target);
            if ($trgt.hasClass("e-rowheader")) {
                var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), rHContent = xlObj._getJSSheetRowHeaderContent(sheetIdx);
                var resCell = $trgt.get(0), location = resCell.getBoundingClientRect(), xy = xlObj._setXY(e), x = xy[0], y = xy[1];
                var nly = xlObj._getJSSheetRowHeader(sheetIdx).find(".e-table").height() + rHContent.find("tbody").offset().top;
                if (((y >= (location.top + document.documentElement.scrollTop + resCell.offsetHeight - (xlObj._isTouchEvt ? 8 : 5))) || ((y <= (location.top + (xlObj._isTouchEvt ? 8 : 3))))) && (y < nly) && (y >= location.top) && (x <= location.left + document.documentElement.scrollLeft + e.target.offsetWidth)) {
                    this._resizeElt = $trgt.parent();
					this._currentHCell = xlObj.model.scrollSettings.allowVirtualScrolling ? parseInt(this._resizeElt.attr('idx')) : this._resizeElt[0].rowIndex;
					if (this._currentHCell < 1 && y < (location.top + resCell.offsetHeight - (xlObj._isTouchEvt ? 8 : 5)) || (this._preventRowResize(this._currentHCell, false)))
					    return;
					$trgt.addClass("e-ss-rowresize");
                    this._allowStart = true;
                }
                else {
                    $(".e-ss-rowresize").removeClass("e-ss-rowresize");
                    this._allowStart = false;
                    this._currentHCell = -1;
                }
                this._resizerowId = e.target.parentNode.getAttribute('idx') ;
            }
        },

        _preventRowResize: function (rowIdx, isCMenu) {
            this._currentHCell = rowIdx;
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), pivotIdCol = [], pvtMngr = xlObj.getSheet(sheetIdx).pivotMngr.pivot,
             pivotIdCol = xlObj.getObjectKeys(pvtMngr), pvtRowIdx, rowCount, pvtObj, count, i,
             pivotCount = pivotIdCol.length;
            if (pivotIdCol.length) {
                for (i = 0; i < pivotCount; i++) {
                    pvtRowIdx = pvtMngr[pivotIdCol[i]].rowIndex;
                    pvtObj = xlObj.element.find('#' + pivotIdCol[i]).data("ejPivotGrid");
                    count = pvtObj._rowCount;
                    if (!count)
                        count = 4;
                    rowCount = pvtRowIdx + count;
                    if (isCMenu)
                        return this._currentHCell >= pvtRowIdx && this._currentHCell < rowCount;
                    else
                        return this._currentHCell >= (pvtRowIdx - 1) && this._currentHCell <= rowCount;
                }
            }
        },
        _rowStart: function (x, y) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), currHCell = this._resizeElt[0].rowIndex, cells = xlObj._getJSSheetRowHeader(sheetIdx).find(".e-rowheader"), cell, rect, width;
            if (this._currentHCell > -1 && currHCell < cells.length)
                cell = cells[currHCell];
            if (!cell)
                return;
            rect = cell.getBoundingClientRect();
            this._tableX = rect.left + parseInt(navigator.userAgent.indexOf("WebKit") > -1 ? document.body.scrollLeft : document.documentElement.scrollLeft);
            if (this._allowStart) {
                this._$visualElem = $(document.createElement("div"));
                width = xlObj._getJSSheetContent(sheetIdx).width();
                this._$visualElem.addClass("e-reSizeRowbg").appendTo(xlObj.element).css({ width: width + "px" }).addClass("e-ss-rowresize");
                this._$visualElem.css({ top: y - 3, left: this._tableX });
                this._oldHeight = cell.offsetHeight;
                this._orgX = x;
                this._orgY = y;
                this._extra = y - this._orgY;
                this._resizeStart = true;
            }
            else {
                this._currentHCell = -1;
            }
        },

        _rMouseMove: function (e) {
            if (this._resizeStart) {
                var y = this.XLObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1)[1];
                y += document.documentElement.scrollTop;
                e.preventDefault();
                $(e.target).addClass("e-ss-rowresize");
                this._moveRowVisual(y);
            }
            else
                this._rowMouseHover(e);
        },

        _rowResize: function (x, y) {
            // Function used for Resizing the row                      
            var oldHeight, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), rows = xlObj.getRows(sheetIdx)[1], isWrap = false, i, rHContent = xlObj._getJSSheetRowHeaderContent(sheetIdx), selRHCells = rHContent.find(".e-rowselected"), rowLen = selRHCells.length, currentRHCellIdx, groupedRow, currentRHCells = [], hdnRowCnt = 0, k;
            this._initialTableHeight = xlObj._getJSSheetRowHeader(sheetIdx).find(".e-rowheadercontent").height();
            this._getResizableRowCell();
            isWrap = $(rows[this._currentHCell]).find(".e-sswraptext").length > 0;
            if (this._currentHCell > -1 && this._resizeStart) {
                for (k = 0; k <= this._resizerowId; k++) 
                    (xlObj.XLEdit.getPropertyValue(k, 0, "isRHide")) && hdnRowCnt++;
                oldHeight = xlObj.getSheet(sheetIdx).rowsHeightCollection[this._currentHCell + hdnRowCnt];
                if (!isWrap || (isWrap && (y - this._orgY + oldHeight) > oldHeight)){
					(rowLen > 0) && (currentRHCellIdx = selRHCells[0].parentNode.rowIndex);
					for (i = 0; i < rowLen; i++) {
						(this._currentHCell === currentRHCellIdx) && (groupedRow = true);
						currentRHCells.push(currentRHCellIdx);
						currentRHCellIdx++;
					}
					(!groupedRow) && (currentRHCells = [this._currentHCell]);
					this._resizeRowUsingDiff(y - this._orgY + oldHeight, oldHeight, currentRHCells);
				}
                if(xlObj.model.allowAutoFill){
					xlObj.XLDragFill.positionAutoFillElement();
					xlObj.XLDragFill.hideAutoFillOptions();
                }
                if (xlObj._isAutoWHMode && xlObj.model.showRibbon)
                    xlObj._autoSSWidthHeight(sheetIdx, true);
            }
			if(xlObj.model.allowSelection)
				xlObj.XLSelection._refreshBorder();
            this._removeVisualElem();
        },

      _resizeRowUsingDiff: function (newHeight, oldHeight, currentRHCells) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), details = {}, rHContent = xlObj._getJSSheetRowHeaderContent(sheetIdx), len, $headerCol, $ContentCol, rowIdx, virtRowIdx, isHtOk;
            if (newHeight > 0) {
                newHeight = newHeight > this._rowMinHeight ? newHeight : this._rowMinHeight;				
				for (var i = 0, len = currentRHCells.length; i < len; i++) {
				    rowIdx = currentRHCells[i];
				    virtRowIdx = xlObj.model.scrollSettings.allowVirtualScrolling ? xlObj.getSheet(sheetIdx)._virtualRowIdx.indexOf(rowIdx) : rowIdx;
				    isHtOk = this._getContentHeight(rowIdx, sheetIdx) <= newHeight;
				    if (xlObj._isRowViewable(sheetIdx, rowIdx) && (xlObj._isUndoRedo || isHtOk)) {
				        $headerCol = rHContent.find("tr:eq(" + virtRowIdx + ")");
				        $ContentCol = xlObj._getJSSheetContent(sheetIdx).find(".e-content").find("tr:eq(" + virtRowIdx  + ")");
				        $headerCol.outerHeight(newHeight);
				        $ContentCol.height(newHeight);
				    }
				    if (xlObj._isUndoRedo || isHtOk)
				        xlObj.getSheet(sheetIdx).rowsHeightCollection[rowIdx] = newHeight;
				}
		        xlObj.XLScroll._getRowHeights(sheetIdx, currentRHCells[0]);
				rHContent.find("tbody").css("cursor", "default");
                rHContent.find("tbody").children().css("cursor", "default");
                if (!xlObj._dupDetails) {
                    details = { sheetIndex: sheetIdx, rows: currentRHCells, newHeight: newHeight, oldHeight: oldHeight, reqType: "resize-row" };
                    if (oldHeight !== newHeight) {
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                }
                if (xlObj.model.allowFreezing)
                    xlObj.XLFreeze._refreshFRowResize(rowIdx);
                if (xlObj.model.scrollSettings.allowScrolling) {
                    xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
                    xlObj.XLScroll._getFirstRow(sheetIdx);
                }
            }
        },

        _findRowsHeight: function (rows) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), actSheet = xlObj.getSheet(sheetIdx), trColl = xlObj._getJSSheetContent(sheetIdx).find("tbody").children(), index;
            for (var i = 0, len = rows.length; i < len; i++){
                index =rows[i];
                if (xlObj._sheets[sheetIdx]._Rows[0])
                    actSheet.rowsHeightCollection[index] = trColl.eq(index).height();
            }
        },

        _calculateHeight: function () {
            var xlObj = this.XLObj, rows = xlObj.getRows(xlObj.getActiveSheetIndex())[0], height = 0;
            for (var i = 0, len = rows.length; i < len; i++)
                height += rows.eq(i).height();
            return height;
        },

        _rMouseUp: function (e) {
            if (this._resizeStart) {
                var xlObj = this.XLObj, currentHCell = this._currentHCell, rHeightColl = xlObj.getSheet(xlObj.getActiveSheetIndex()).rowsHeightCollection, args = {}, xy = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1);
                x = xy[0];
                y = xy[1];
                y += document.documentElement.scrollTop;
                args.event = e;
                args.target = e.target;
                args.oldHeight = rHeightColl[currentHCell];
                args.rowIndex = this._currentHCell;
                this._rowResize(x, y);
                args.newHeight = rHeightColl[currentHCell];
                args.reqType = "row-resize";
                if (this.XLObj._trigger("resizeEnd", args)) {
                    return;
                }
                if ($("#" + this.XLObj._id + "ddlspan").length)
                    this.XLObj._ddlPosition();
            }
        },

        _getResizableRowCell: function (e) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), cell = xlObj._getJSSheetContent(sheetIdx).find(".e-rowheader"), scrollTop = navigator.userAgent.indexOf("WebKit") > -1 ? document.body.scrollTop : document.documentElement.scrollTop, ylimit, point, count = 1, idx;
            for (var i = 0, len = cell.length; i < len; i++) {
                point = cell[i].getBoundingClientRect();
                if (point.top === 0) count++;
                ylimit = point.top + scrollTop + 5;
                if (ylimit > this._orgY) {
                    if (xlObj.isUndefined(e)) {
						idx = $(cell[i - 1]).is(":visible") ? i - 1 : i - count;
                        this._currentHCell = xlObj._getCellIdx(cell[idx]).rowIndex;
					}
                    else
                        e.target = xlObj._getJSSheetRowHeader(sheetIdx).find('tr:eq(' + i + ') td')[0];
                    return;
                }
            }
        },

        _moveRowVisual: function (y) {
            /// Used to move the visual element in mouse move
            var xlObj = this.XLObj, bounds = xlObj._getJSSheetContent(xlObj.getActiveSheetIndex()).find(".e-rowheadercontent")[0].getBoundingClientRect();
            if ((bounds.top + document.documentElement.scrollTop + bounds.height < y) || (y < bounds.top + document.documentElement.scrollTop))
                this._$visualElem.remove();
            else if (this._currentHCell > -1)
                this._$visualElem.css({ top: y - 3, left: this._tableX });
        },

        //Activation panel resizing
        _apMouseDown: function (e) {
            var x, xlObj = this.XLObj;
            if (xlObj._isTouchEvt)
                this._apMouseHover(e);
            if (this._allowStart && ($(e.target).closest("div").css("cursor") === "col-resize")) {
                x = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1)[0];
                x += document.documentElement.scrollLeft;
                if (e.button !== 2)
                    this._apStart(x);
                this._resizeType = "AP";
                e.preventDefault();
            }
            return false;
        },

        _apMouseHover: function (e) {
            var xlObj = this.XLObj;
            if (this._$visualElem.is(":visible"))
                return;
            var $trgt = $(e.target), resizableElt = $trgt.get(0), location = xlObj.getActivationPanel()[0].getBoundingClientRect(), x = xlObj._setXY(e)[0];
            if ((x <= (location.left + (xlObj._isTouchEvt ? 20 : 4))) && (x >= location.left)) {
                $trgt.parent().addClass("e-ss-apresize");
                this._allowStart = true;
            }
            else {
                xlObj.element.find(".e-ss-apresize").removeClass("e-ss-apresize");
                this._allowStart = false;
            }
        },

        _apStart: function (x) {
            var xlObj = this.XLObj, cell = xlObj.getActivationPanel()[0], rect = cell.getBoundingClientRect(), sheetIdx = xlObj.getActiveSheetIndex(), height;
            this._tableY = rect.top + parseInt(navigator.userAgent.indexOf("WebKit") > -1 ? document.body.scrollTop : document.documentElement.scrollTop);
            if (this._allowStart) {
                this._$visualElem = $(document.createElement("div"));
                height = xlObj._getJSSheetContent(sheetIdx).height() + xlObj._getJSSheetHeader(sheetIdx).height();
                this._$visualElem.addClass("e-reSizeAPbg").appendTo(xlObj.element).css({ height: height + "px" }).addClass("e-ss-apresize");
                this._$visualElem.css({ left: x, top: this._tableY });
                this._resizeStart = true;
            }
        },

        _apMouseMove: function (e) {
            if (this._resizeStart) {
                var xlObj = this.XLObj, x = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1)[0];
                x += document.documentElement.scrollLeft;
                e.preventDefault();
                this._apMoveVisual(x);
            }
            else
                this._apMouseHover(e);
        },

        _apMouseUp: function (e) {
            if (this._resizeStart) {
                var xlObj = this.XLObj, x = xlObj._setXY(e, navigator.userAgent.indexOf("WebKit") > -1)[0];
                x += document.documentElement.scrollLeft;
                this._apReSize(x);
            }
        },

        _apMoveVisual: function (x) {
            this._$visualElem.css({ left: x - 5, top: this._tableY });
        },

        _apReSize: function (x) {
            var xlObj = this.XLObj, prevWidth = xlObj.model.activationPanelWidth, isScrollWidth = 0, settings = $.extend(true, {}, xlObj.model.scrollSettings), actPanel = xlObj.getActivationPanel(), desObj;
            settings.width = xlObj._responsiveWidth;
			settings.height = xlObj._responsiveHeight;
            xlObj.model.activationPanelWidth = Math.abs(settings.width - (x - xlObj.element.offset().left));
            if (xlObj.model.enablePivotTable) {
                var scrObj = xlObj.getActivationPanel().data("ejScroller");
                isScrollWidth = xlObj.getActivationPanel().find(".e-vscrollbar").length ? 20 : 2;
                actPanel.find(".e-ss-pivotfield").width(xlObj.model.activationPanelWidth - isScrollWidth);
                actPanel.find("#" + xlObj._id + "_PivotField").width(xlObj.model.activationPanelWidth - isScrollWidth);
                if (prevWidth > xlObj.model.activationPanelWidth) {
                    scrObj.option({ width: xlObj.model.activationPanelWidth - 1});
                    xlObj._setSheetWidthHeight(xlObj.getActiveSheetIndex(), { width: settings.width, height: settings.height }, null, "resize");
                }
                else {
                    xlObj._setSheetWidthHeight(xlObj.getActiveSheetIndex(), { width: settings.width, height: settings.height }, null, "resize");
                    scrObj.option({ width: xlObj.model.activationPanelWidth - 1});
                }
                desObj = xlObj.getActivationPanel().find("#" + xlObj._id + "_PivotTableSchema_" + xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id).data("ejPivotSchemaDesigner");
                desObj._reSizeHandler();
                scrObj.refresh();
            }
            this._removeVisualElem();
        },

        _removeVisualElem: function () {
            var xlObj = this.XLObj;
            this._$visualElem.remove();
            xlObj.element.find(".e-reSizeRowbg").remove();
            this._resizeStart = false;
            this._currentHCell = -1;
            this._resizeType = "";
            this._allowStart = false;
            if (xlObj.model.allowComments)
                xlObj.XLComment._updateCmntArrowPos();
        },

        //Resize To Fit Width
        fitWidth: function (colIdxes) {
            //colIdxes is the array of column indexes to be resized
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex();
			if (!xlObj.model.allowResizing)
                return;
            for (var i = 0, len = colIdxes.length; i < len; i++)
                this._fitWidth(colIdxes[i], 0,  xlObj.getSheet(sheetIdx).usedRange.rowIndex);
            if (xlObj.model.scrollSettings.allowScrolling) {
                xlObj.XLScroll._getColWidths(sheetIdx, colIdxes[0] + 1);
                xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "horizontal");
            }
            xlObj.model.allowSelection && xlObj.XLSelection._refreshBorder();
            if (xlObj.model.allowComments)
                xlObj.XLComment._updateCmntArrowPos(null, sheetIdx, { colIndex: colIdxes[i] });
        },

        _resizeToFitWidth: function (e) {
            var xlObj = this.XLObj, $trgt = $(e.target), sheetIdx = xlObj.getActiveSheetIndex(), endRowIdx = xlObj.getSheet(sheetIdx).usedRange.rowIndex;
            this._getResizableCell(e);
            this._fitWidth(e.target.cellIndex, 0, endRowIdx);
            if (xlObj.model.scrollSettings.allowScrolling) {
                xlObj.XLScroll._getColWidths(xlObj.getActiveSheetIndex(), e.target.cellIndex + 1);
                xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "horizontal");
            }
            xlObj.model.allowSelection && xlObj.XLSelection._refreshBorder();
            if (xlObj.model.allowAutoFill)
                xlObj.XLDragFill.positionAutoFillElement();
            if (xlObj.model.allowComments)
                xlObj.XLComment._updateCmntArrowPos(null, sheetIdx, { colIndex: e.target.cellIndex });
        },

        _fitWidth: function (colIdx, stRowIdx, endRowIdx) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), trgt = xlObj._getJSSheetHeader(sheetIdx).find(".e-headercell")[colIdx], $cellDiv = $(trgt).children(".e-headercelldiv"),
                finalWidth = 0, headerWidth = 0, contentWidth = 0, sheet = xlObj.getSheet(sheetIdx);
            endRowIdx = endRowIdx ? endRowIdx : sheet.usedRange.rowIndex;
            contentWidth = this._getContentWidth(colIdx, sheetIdx, stRowIdx, endRowIdx);
            headerWidth = this._getHeaderContentWidth($cellDiv, sheetIdx);
            if (contentWidth > 1) {
                finalWidth = headerWidth > contentWidth ? headerWidth : contentWidth;
                var details = { target: trgt, sheetIndex: sheetIdx, colIndex: colIdx, newWidth: finalWidth, oldWidth: trgt.offsetWidth, reqType: "resize-fit-width" };
                if (finalWidth > 0) {
                    if (finalWidth < 20)
                        finalWidth = 30;
                    this._applyWidth(trgt, sheetIdx, colIdx, finalWidth);
                    if (xlObj.model.allowFreezing)
                        xlObj.XLFreeze._refreshFColResize(colIdx);
                    xlObj.model.allowAutoFill && xlObj.XLDragFill.positionAutoFillElement();
                    if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && !xlObj._dupDetails && !xlObj._isExport) {
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                }
            }
            xlObj.XLEdit._updateDataContainer({ rowIndex: 0, colIndex: colIdx }, { dataObj: { isFitWidth: true } });
        },

        _applyWidth: function (trgt, activeIdx, cellIndex, finalWidth) {
            var xlObj = this.XLObj;
            xlObj._getJSSheetHeader(activeIdx).find("col:eq("+ cellIndex +")").width(finalWidth);
            xlObj._getJSSheetContent(activeIdx).find("col:eq("+ (cellIndex + 1) +")").width(finalWidth);
            xlObj.getSheet(activeIdx).columnsWidthCollection[cellIndex] = finalWidth;
            xlObj.getSheet(activeIdx).columns[cellIndex].width = finalWidth;
        },

        _getContentWidth: function (colIdx, sheetIdx, stRowIdx, endRowIdx) {
            var j, contentWidth = 0, cellObj, cellWidth, xlObj = this.XLObj, sheetData = xlObj._dataContainer.sheets[sheetIdx], tdWidth;
            for (j = stRowIdx; j <= endRowIdx; j++) {
                if (!ej.isNullOrUndefined(sheetData[j]))
                    cellObj = sheetData[j][colIdx];
                if (!ej.isNullOrUndefined(cellObj))
                    cellWidth = this._getCalculatedCellWidth(sheetIdx, cellObj);
                else {
                    cellObj = {};
                    cellWidth = {spanWidth: 0, paddingWidth: 0};
                }
                tdWidth = xlObj._detailsFromGlobalSpan(j, colIdx, "width", xlObj.XLEdit.getPropertyValue(j, colIdx, "value2"), undefined, true);
                tdWidth = tdWidth + cellWidth.spanWidth + cellWidth.paddingWidth + 4; // for some spacing
                if (tdWidth > contentWidth)
                    contentWidth = tdWidth;               
            }
            return contentWidth;
        },

        _getCalculatedCellWidth: function (sheetIdx, object) {
            var spanWidth = 0, paddingWidth = 0;
            if ("isFilterHeader" in object){
                if ("isFilterVisible" in object)
                    spanWidth += 17; //15 for filter span width, 2 for right and left border               
            }
            else {
                spanWidth += 0;
                // add spanWidth for Pivot Table spans
            }
            paddingWidth = 3; // 1 for padding right, 2 for padding left
            return {spanWidth: spanWidth, paddingWidth: paddingWidth};
        },

        _getHeaderContentWidth: function ($cellDiv, sheetIndex) {
            var headerWidth = 0, $span = ej.buildTag("span", {}, {}), content = $cellDiv.html();
            $span.html(content);
            $cellDiv.html($span);
            headerWidth = $cellDiv.find("span:first").width();
            headerWidth = headerWidth + 10; // for some space
            $cellDiv.html(content);
            return headerWidth;
        },

        //Resize To Fit Height
        fitHeight: function (rowIdxes) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowResizing)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(); // rowIdxes is the array of rows to be resized
            for (var i = 0, len = rowIdxes.length; i < len; i++) {               
                if (ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdxes[i], 0, "wrapRow")))
                    this._fitHeight(rowIdxes[i], rowIdxes[i]);
				xlObj._setRowHdrHeight(sheetIdx, rowIdxes[i]);
			}
            if (xlObj.model.scrollSettings.allowScrolling) {
                xlObj.XLScroll._getRowHeights(sheetIdx, rowIdxes[0]);
                xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical");
            }
            if(xlObj.model.allowSelection)
				xlObj.XLSelection._refreshBorder();
            if (xlObj.model.allowComments)
                xlObj.XLComment._updateCmntArrowPos(null, sheetIdx, { rowIndex: rowIdxes[0] });
        },

        _resizeToFitHeight: function (e) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), rowIndex = e.target.parentNode.rowIndex, orgRowIdx;
            orgRowIdx = xlObj.model.scrollSettings.allowVirtualScrolling ? xlObj.getSheet(sheetIdx)._virtualRowIdx[rowIndex] : rowIndex;
            this._getResizableRowCell(e);
            this._fitHeight(rowIndex, orgRowIdx);
            xlObj._setRowHdrHeight(sheetIdx, orgRowIdx);
            if (xlObj.model.scrollSettings.allowScrolling) {
                xlObj.XLScroll._getRowHeights(xlObj.getActiveSheetIndex(), orgRowIdx);
                xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "vertical");
            }
            if (xlObj.model.allowSelection)
                xlObj.XLSelection._refreshBorder();
            if (xlObj.model.allowAutoFill)
                xlObj.XLDragFill.positionAutoFillElement();
            if (xlObj.model.allowComments)
                xlObj.XLComment._updateCmntArrowPos(null, sheetIdx, { rowIndex: rowIndex });
        },

        _fitHeight: function (rowIndex, orgRowIdx) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), trgt = xlObj._getJSSheetRowHeader(sheetIdx).find(".e-rowheader")[rowIndex], 
                finalHeight = 0, contentHeight = 0, headerHeight, $span = ej.buildTag("span", {}, {height: 20, width: 30});
            contentHeight = this._getContentHeight(orgRowIdx, sheetIdx, xlObj.XLEdit.getPropertyValue(orgRowIdx, 0, "wrapRow"));
            $span.html(orgRowIdx + 1);
            xlObj.element.append($span);
            headerHeight = xlObj.element.find("span:last").outerHeight(true);
            xlObj.element.find("span:last").remove();
            headerHeight = headerHeight + 4; // some Spacing.
            finalHeight = (contentHeight < headerHeight) ? headerHeight : contentHeight;
            var details = { target: trgt, sheetIndex: sheetIdx, rowIndex: orgRowIdx, newHeight: finalHeight, oldHeight: sheet.rowsHeightCollection[rowIndex], reqType: "resize-fit-height" };
            if (xlObj._isRowViewable(sheetIdx, orgRowIdx)) {
                $(trgt.parentElement).height(finalHeight);
                $(xlObj._getContent(sheetIdx).find("tr")[rowIndex]).height(finalHeight);
            }
            xlObj.getSheet(sheetIdx).rowsHeightCollection[orgRowIdx] = finalHeight;
            if (xlObj.model.allowFreezing)
                xlObj.XLFreeze._refreshFRowResize(rowIndex);
            if(xlObj.model.scrollSettings.allowScrolling)
				xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
            if ((!sheet._isImported || sheet._isLoaded) && !xlObj._dupDetails && !xlObj._isExport) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
            if(xlObj.model.allowAutoFill)
				xlObj.XLDragFill.positionAutoFillElement();
            xlObj.XLEdit._updateDataContainer({ rowIndex: orgRowIdx, colIndex: 0 }, { dataObj: { "isFitHeight": true } });
        },

        _getContentHeight: function (rowIdx, sheetIdx, isWrapRow) {
            var xlObj = this.XLObj, contentHeight = 0, $span, tdHeight, format = "", regx = xlObj._formatRegx, $td, content, sheet = xlObj.getSheet(sheetIdx),
            cKeys = xlObj.getObjectKeys(xlObj._dataContainer.sheets[sheetIdx][rowIdx]), rHtColl = sheet.rowsHeightCollection[rowIdx],  cWtColl = sheet.columnsWidthCollection;
            for (var i = 0, len = cKeys.length; i < len; i++) {
                tdHeight = xlObj._detailsFromGlobalSpan(rowIdx, cKeys[i], "height", xlObj.XLEdit.getPropertyValue(rowIdx, cKeys[i], "value2"), isWrapRow ? cWtColl[i] : undefined, true);
                if (tdHeight > contentHeight)
                    contentHeight = tdHeight;
            }
            return contentHeight + 3;// is for adding row's padding and margin with content.
        },

        _setRowHdrHeightResize: function (sheetIdx, colIdx) {
            var xlObj = this.XLObj, shtRows = xlObj.getRows(sheetIdx), rowHdrs = shtRows[0], endRowIdx =  xlObj.getSheet(sheetIdx).usedRange.rowIndex;
            for (var i = 0; i <= endRowIdx; i++) {
                if (!ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(i, colIdx, "mergeIdx")) || !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(i, colIdx, "merge")))
                    continue;
                if (xlObj._isRowViewable(sheetIdx, i)) {
                    tdHeight = xlObj._detailsFromGlobalSpan(i, colIdx, "height", xlObj.XLEdit.getPropertyValue(i, colIdx, "value2"));
                    $(rowHdrs[i]).height(tdHeight);
                }
            }
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.editing = function (obj) {
        this.XLObj = obj;
        this._EditCellDetails = {
            value: null,
            rowIndex: -1,
            columnIndex: -1,
            fieldName: null,
            cell: null
        };        
        this._isEdit = false;
		this._isFEdit = false;
        this._isFormulaEdit = false;
        this._isFBarFocused = false;
        this._skipHTML = false;      
        this._editElem = null;
        this._filterIcon = null;
        this._isCellEdit = true;
        this._validOperators = ["+", "-", "*", "/", ","];
        this._invalidOperators = ["%"];
        this._validCharacters = ["+", "-", "*", "/", ",", "(", "="];
        this._textDecoration = false;
        this._editCell = null;
        this._acPosition = { left: 0, top: 0 };
        this._isValidation = false;
    };

    ej.spreadsheetFeatures.editing.prototype = {
        //Editing 
        getCurrentEditCellData: function () {
            var elem, value, xlObj = this.XLObj, cellIdx;
            if (this._isEdit) {
                elem = xlObj.element.find("#" + xlObj._id + "_Edit");
                value = elem.text();
                cellIdx = xlObj._getCellIdx(this._editCell[0]);
                if (this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "type") != "text" && xlObj.isNumber(value))
                    value = parseFloat(value);
                return value;
            }
            return null;
        },

        getColumnIndexByField: function (field) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), column, len;
            for (column = 0, len = sheet.columns.length; column < len; column++) {
                if (sheet.columns[column]["field"] === field)
                    break;
            }
            return column;
        },

        _processEditing: function () {
            if (this._editElem)
                return;
            this._editElem = ej.buildTag("div.e-field e-ss-input", "", {}, { id: this.XLObj._id + "_Edit", contenteditable: true });
			this._editElem.data("parentID", this.XLObj._id);
        },
		
        editCell: function (rowIdx, colIdx, oldData) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowEditing || !xlObj.model.allowSelection || xlObj._isCellProtected(rowIdx, colIdx, true) || xlObj.model.isReadOnly)
                return;
            var column, sheetIdx, sheet, input, args, actCell, prevValue, trgtTd, selObj, xlObj = this.XLObj, valElem = xlObj.element.find("#" + xlObj._id + "_ValElem");
            selObj = { rowIndex: rowIdx, colIndex: colIdx };
            sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), actCell = xlObj.getActiveCell(sheetIdx);
            if (xlObj._isRowViewable(sheetIdx,rowIdx))
                this._textDecoration = xlObj.getCell(rowIdx, colIdx).find("a").css("text-decoration") === "none";
            trgtTd = xlObj.getCell(rowIdx, colIdx), column = sheet.columns[colIdx];
			this._editCell = trgtTd;
            args = { 
                columnName: column.field,
                value: xlObj.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx], valueOnly: true, sheetIdx: sheetIdx, skipDateTime: true })[0],
                columnObject: column,
                cell: trgtTd,
                rowIndex: rowIdx,
                colIndex:colIdx
            };
            if (xlObj._trigger("cellEdit", args))
                return;
            xlObj._cureditedCell = args.value;            
            if (this._isValidation) {              
                valElem.rules("remove");               
                this._isValidation = false;
            }
            if (actCell.rowIndex !== rowIdx || actCell.colIndex !== colIdx) {
                sheet._activeCell = selObj;
                if (sheet._startCell.rowIndex <= rowIdx && sheet._startCell.colIndex <= colIdx && sheet._endCell.rowIndex >= rowIdx && sheet._endCell.colIndex >= colIdx)
                    xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                else
                    xlObj.XLSelection.selectRange(selObj, selObj);
                if(xlObj.model.allowAutoFill)
					xlObj.XLDragFill.positionAutoFillElement();
            }
            this._EditCellDetails = {
                rowIndex: rowIdx,
                value: args.value,
                columnIndex: colIdx,
                fieldName: column.field,
                cell: trgtTd
            };
            if (!oldData)
                args.value = "";
			prevValue = args.value;
            this._renderBulkEditObject(args, trgtTd, prevValue);
            if (this.getPropertyValue(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, "rule", sheetIdx) && xlObj.model.allowDataValidation)
                xlObj.XLValidate._setValidation();
            input = $("#" + xlObj._id + "_Edit");
            if (this.getPropertyValue(rowIdx, colIdx, "hyperlink", sheetIdx))
                input.addClass("e-hyperlinks");
            if (this._textDecoration)
                input.css("text-decoration", "none");
            if (xlObj.model.allowComments && trgtTd.hasClass("e-commentcell"))
                xlObj.XLComment._visibleCmntCnt(trgtTd);
            args.cell.addClass(xlObj._browserDetails.name === "msie" ? "e-editedcell e-msie-edit" : "e-editedcell");
            if (xlObj.isFormula(args.value))
                this._processFormulaEditRange(args.value);
			if (xlObj.model.allowKeyboardNavigation)
                xlObj.XLCellNav._isNavigate = false;
            if (xlObj.model.enableContextMenu)
                $("#" + xlObj._id + "_contextMenuCell").data("ejMenu")._contextMenuEvents("_off"); //for enable default contextmenu - clipboard actions
        },

        _renderBulkEditObject: function (cellArgs, td, prevValue) {
            var htmlString, currHeight, filterIcon, cellData = {}, xlObj = this.XLObj, prevHeight = td.height(), sheetIdx = xlObj.getActiveSheetIndex(),
                tdSpan = td.find(".e-filterspan"), content = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"), format = xlObj.XLFormat.getFormatClass(td[0].className), obj;
            cellData[cellArgs.columnObject.field] = cellArgs.value;
            if (tdSpan.length) {
                filterIcon = { filterIcon: tdSpan, rowIndex: tdSpan.parentsUntil("table").eq(1).index(), colIndex: tdSpan.parent().index() };
                this._filterIcon = filterIcon;
            }
            currHeight = td.height();
            this._refreshTextNode(td[0]);
            if (td.hasClass('e-sswraptext') && prevHeight !== currHeight)
                td.height(prevHeight);
            var $elem = this._editElem;	
            $elem.text("");
            if (!ej.isNullOrUndefined(prevValue))
                $elem.text(xlObj.isNumber(prevValue) ? xlObj._getlocaleNumVal(prevValue, true) : prevValue);
            content.append($elem);
			if(xlObj._isClassHasProperty(format, 'text-align', 'right'))
				obj = {
					right: content.width() - td[0].offsetLeft - td[0].offsetWidth + 2,
					left: '',
					maxWidth : td[0].offsetLeft + td[0].offsetWidth + 2   //+2px for left padding like excel
				}
			else
				obj = {
					left: td[0].offsetLeft + 2,   //+2px for left padding like excel
					right: '',
					maxWidth : content.width() - (td.offset().left - (xlObj.element.offset().left + $(xlObj.getRows(sheetIdx)[0][0]).width())) - 2
				}
			$elem.css({ left: obj.left, right: obj.right, top: td[0].offsetTop + 1, '-webkit-user-select': 'text', cursor: "text", "min-height": currHeight - 1, height: "auto", lineHeight: "normal", wordWrap: "break-word", position: "absolute", minWidth: td.width(), whiteSpace: "pre-wrap" });   //+1px for top padding like excel
            if (this._editCell.hasClass("e-sswraptext")) {
                $elem.css({ width: td.width(), maxWidth: "" });
                $(xlObj.getRows(sheetIdx)[1][td.parent().attr("idx")]).height(xlObj.model.sheets[sheetIdx].rowsHeightCollection[td.parent().attr("idx")]);
                xlObj.XLScroll._getRowHeights(sheetIdx, td.parent().index());
            }
            else
                $elem.css({ width: "", maxWidth: obj.maxWidth });
            $elem.show();           
            this._refreshEditForm(td, $elem, cellArgs.value, prevValue, currHeight);			           
            this._isEdit = true;
            (xlObj.model.showRibbon) && xlObj.XLRibbon._disableRibbonIcons();
        },       

        _refreshEditForm: function (cell, elem, cellvalue, prevValue,height) {
            var i, len, clsNm, splitStr, cFormatRule, cellType, cellObj = {}, xlObj = this.XLObj, form = document.getElementById(xlObj._id + "EditForm"),
                formElem = $(form).find("input,select"), sheet = xlObj._dataContainer.sheets[xlObj.getActiveSheetIndex()],
                rowIdx = cell.parent().index();
            if(sheet && sheet[rowIdx] && sheet[rowIdx][cell[0].cellIndex])
                cellObj = sheet[rowIdx][cell[0].cellIndex];                           
            elem[0].className = "";
            cellType = this.getPropertyValueByElem(cell, "type") || "";
            if (xlObj.isNumber(prevValue) && !(cellType.indexOf("text")>-1))
                    elem.addClass("e-ralign");
                if(cellType.indexOf("date") > -1 || cellType.indexOf("time") > -1)
                    elem.addClass("e-ralign");
                elem.css({ "border": "none", "outline": "none" });
                if(this.XLObj.model.allowCellFormatting)
                    clsNm = xlObj.XLFormat.getFormatClass(cell[0].className);
                elem.addClass(clsNm);
                if (xlObj.model.allowCellFormatting) {
                        elem.css({ "color": cell.css('color') });
                        elem.css({ "background-color": cell.css('background-color') });
                }
                elem.on("keyup", { xlObj: xlObj }, function (e) {
                    var sObj = e.data.xlObj;
                    sObj.XLEdit._isFormulaEdit = !$(e.target).text().indexOf("=");
                    if(sObj.XLEdit._isFormulaEdit)
                        sObj.XLEdit._processFormulaEditRange($(e.target).text());
                    if(sObj.model.allowFormulaBar)
                    sObj._getInputBox().val($(e.target).text());
                    sObj.XLEdit._isCellEdit = true;
                });
                elem.on("focus", { xlObj: xlObj }, function (e) {
                    var sObj = e.data.xlObj;
                    sObj.XLEdit._isCellEdit = true;
                });             
                xlObj._setFormulaSuggElem($("#" + xlObj._id+"_AutoComplete_suggestion"));            
                elem.focusEnd();
        },

        _renderAutoComplete: function (elem, value, height , flag) {
            var xlObj = this.XLObj, tmpClass = flag ? " e-cell-ac e-ss-editinput" : "";
            elem.ejAutocomplete({
                dataSource: xlObj._formulaCollection,
                value: value,
                cssClass: "e-ss-autocomplete" + tmpClass,
                width: "100%",
                height: height,
                htmlattributes: flag ? { display: "none" }:"",
                delaySuggestionTimeout: 10,
                minCharacter: 2,
                popupWidth: "170px",
                popupHeight: "150px",
                showEmptyResultText: false,
                autoFocus: true,
                template: "<span class='e-icon e-ss-function'> </span>" + "<div> ${display} </div>",
                select: $.proxy(this._formulaSelect, xlObj),
                open: $.proxy(this._formulaSuggestionStatus, xlObj),
                close: $.proxy(this._formulaSuggestionStatus, xlObj)
            });
            elem.data("ejAutocomplete")._bubbleEvent(true);
        },

        _refreshAutoComplete: function () {
            var xlObj = this.XLObj, acElem, inptBoxElem, wgt = "ejAutocomplete", dataSrc = "dataSource";
            inptBoxElem = $("#" + xlObj._id + "_inputbox").data(wgt);
            acElem = $("#" + xlObj._id + "_AutoComplete").data(wgt);
            if (xlObj.model.allowFormulaBar)
                inptBoxElem && inptBoxElem.option(dataSrc, xlObj._formulaCollection);
            acElem && acElem.option(dataSrc, xlObj._formulaCollection);
        },

		 _captureEditing: function () {
            var xlObj = this.XLObj, acElem, editCell, editElem, location, actElem = document.activeElement,
                actCell = xlObj.getActiveCell(); 
            if (actElem && actElem.tagName === "DIV" && xlObj._isRowViewable(null, actCell.rowIndex)) {
                acElem = xlObj.element.find("#" + xlObj._id + "_AutoComplete");
                acElem.val($(actElem).text());
                acElem.data("ejAutocomplete").search();
                editCell = xlObj.getActiveCellElem();
                editElem = xlObj.element.find("#" + xlObj._id + "_Edit")[0];
                location = editCell[0].getBoundingClientRect();
                this._acPosition.left = location.left + window.pageXOffset;
                this._acPosition.top = location.top + window.pageYOffset + $(editElem).height();
                $("#" + xlObj._id + "_AutoComplete_suggestion").css({ left: this._acPosition.left, top: this._acPosition.top });
             }
		 },
		
		 saveCell: function () {
		     var xlObj = this.XLObj;
		     if (!xlObj.model.allowEditing || xlObj.model.isReadOnly)
		         return;
		     var i, j, actCell, form, autoEle, temp, formulaStr, prevFrmtObj, flen, column, cFormatStr, trgtTd, elem, obj, rHgt,
                cFormatRule, len, rowIdx, colIdx, args, prevValue, details, sheetIdx, sheet, cellIdx, rowHgt, fRange, fObj,
                rowIdx, isFormatChanged = false, rows, cellHeight, skipFormulaColl = ["ABS", "LEFT", "RIGHT", "TRIM", "UPPER", "VALUE"];
            if (this._isEdit) {
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), rows = xlObj.getRows(sheetIdx), form = $("#" + xlObj._id + "EditForm");
                trgtTd = this._editCell, column = sheet.columns[this._EditCellDetails.columnIndex];
                elem = xlObj.element.find("#" + xlObj._id + "_ValElem");
				var editElem = xlObj.element.find("#" + xlObj._id + "_Edit")[0], htmlVal=$(editElem).html();				 
				obj = xlObj._getCellIdx(trgtTd[0]);
				rowIdx = obj.rowIndex, colIdx = obj.colIndex;
                args = {
                    columnName: column.field,
                    value: this.getCurrentEditCellData(),
                    prevValue: this._EditCellDetails.value,
                    columnObject: column,
					rowIndex: rowIdx,
                    colIndex: colIdx,
                    cell: trgtTd,
					 isRefCells: false
                };
				if (xlObj.model.allowDataValidation && this._isValidation) {
				    elem.val(args.value);
				    form.css("display", "block");
				    if (!form.validate().element(elem[0])) {
				        form.css("display", "none");
				        return false;
				    }
				    form.css("display", "none");
				    args.hasValidation = true;
				}
				if ((args.value !== args.prevValue) && xlObj._trigger("cellSave", args))
                    return;
				prevFrmtObj = xlObj.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx], property: ["type", "formatStr", "decimalPlaces"] })[0];
				if (xlObj.isFormula(args.value) && !this._formulaValidate(args.value))
				    return;
				prevValue = this._EditCellDetails.value || "";
                details = { sheetIndex: sheetIdx, rowIndex: rowIdx, colIndex: colIdx, cValue: args.value, reqType: "edit", iconName: "", pValue: prevValue };
                details.prevHeight = sheet.rowsHeightCollection[rowIdx];
				xlObj._dupDetails = true;
				this._updateCellValue({ rowIndex: rowIdx, colIndex: colIdx }, args.value);
				xlObj._dupDetails = false;
				if (this.getPropertyValue(rowIdx, colIdx, "wrap", sheetIdx)) {
					rHgt = xlObj._getWrapCellHeight(sheetIdx, rowIdx, colIdx);
					xlObj._wrapCollection( rowIdx, colIdx, rHgt.cellHt, sheetIdx);
					if (xlObj._getRowHeight(rowIdx, sheetIdx) < rHgt.rowHt) {
						xlObj.setHeightToRows([{ rowIndex: rowIdx, height: rHgt.rowHt }]);
						xlObj.model.allowAutoFill && xlObj.XLDragFill.positionAutoFillElement();
					}
					this._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, {dataObj: {}});
				}
				if (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isFilterHeader"))
				    xlObj._removeClass(args.cell[0], xlObj._rAlign);
                if(this._textDecoration)
                    args.cell.find("a").css("text-decoration", "none");				
                if (args.hasValidation)
                    details["hasValidation"] = true;
                if (xlObj.isFormula(args.value) && (!xlObj.getObjectLength(prevFrmtObj) || prevFrmtObj.type==="general")) {
                    details.operation = "formula";
                    formulaStr = args.value;
                    formulaStr = xlObj.XLDragFill._parseFormula(formulaStr);
                    if (skipFormulaColl.indexOf(formulaStr[0]) === -1) {
                        for (j = 0, flen = formulaStr.length; j < flen; j++) {
                            temp = formulaStr[j];
                            if (temp != "(" && formulaStr[j + 1] != "(")
                                break;
                        }
                        if (temp.indexOf(":") > -1)
                            temp = temp.split(":")[0];
                        if (xlObj._isCellReference(temp)) {
                            temp = temp.replace(/\$/g, "");
                            fRange = xlObj.getRangeIndices(temp);
                            fObj = xlObj.getRangeData({ range: fRange, property: ["type", "formatStr", "decimalPlaces"] })[0];
                            if (xlObj.getObjectLength(fObj) && fObj.type != prevFrmtObj.type && fObj.type !== "general") {
                                xlObj._dupDetails = true;
                                isFormatChanged = true;
                                xlObj.XLFormat.format(fObj, xlObj._getAlphaRange(xlObj.getActiveSheetIndex(), rowIdx, colIdx, rowIdx, colIdx));
                                xlObj._dupDetails = false;
                                details.prevFrmtObj = xlObj.getObjectLength(prevFrmtObj) ? prevFrmtObj : { type: "general" };
                                details.curFrmtObj = fObj;
                            }
                        }
                    }
                }
                xlObj._setRowHdrHeight(sheetIdx, rowIdx);
				xlObj.model.allowFormulaBar && xlObj.updateFormulaBar();
				if(xlObj.model.scrollSettings.allowScrolling)
					xlObj.XLScroll._getRowHeights(sheetIdx, rowIdx);
                this._isEdit = this._isFormulaEdit = false;
                args.cell.removeClass("e-editedcell e-msie-edit");
                if (xlObj.model.allowKeyboardNavigation)
                    xlObj.XLCellNav._isNavigate = true;
                if (xlObj.model.showRibbon) {
                    xlObj.XLRibbon._enableRibbonIcons();
                    xlObj.XLRibbon._updateRibbonIcons();
                }
                xlObj._updateUndoRedoIcons();
                if (!xlObj.model.allowInsert) {
                    xlObj.XLRibbon._disableButtons(["Others_Cells_InsertCellOptions"], "ejSplitButton");
                    xlObj.XLRibbon._disableButtons(["Others_Cells_InsertCell"], "ejButton");
                }
                if (!xlObj.model.allowDelete) {
                    xlObj.XLRibbon._disableButtons(["Others_Cells_DeleteCellOptions"], "ejSplitButton");
                    xlObj.XLRibbon._disableButtons(["Others_Cells_DeleteCell"], "ejButton");
                }
                details.cFormatRule = cFormatRule = this.getPropertyValue(rowIdx, colIdx, "cFormatRule", sheetIdx);
				xlObj._dupDetails = true;
                if (xlObj.model.allowConditionalFormats && cFormatRule) {
                    for (i = 0, len = cFormatRule.length; i < len; i++) {
                        cFormatStr = cFormatRule[i].split("_");
                        cFormatStr[0] !== "formularule" && xlObj.XLCFormat._cFormat(cFormatStr[0], cFormatStr[2], cFormatStr[3], cFormatStr[4], xlObj._generateHeaderText(colIdx + 1) + (rowIdx + 1));
                    }
					xlObj.XLCFormat.refreshCFormat(xlObj._getAlphaRange(sheetIdx, rowIdx, colIdx, rowIdx, colIdx));
                }
				xlObj._dupDetails = false;
                details["endCell"] = sheet._endCell;
                details["startCell"] = sheet._startCell;
				actCell = xlObj.getActiveCellElem();
				if (actCell) {
                    if (xlObj.model.allowComments && actCell.hasClass("e-commentcell"))
                        xlObj.XLComment._visibleCmntCnt(actCell, true);
                    if (actCell.hasClass("e-hlcell"))
                        xlObj.XLValidate.highlightInvalidData();
                }
                this._shiftKeyEnabled = this._isFBarFocused = false;
                xlObj._ctrlKeyCount = 0;
                if (!this._isFormulaEdit && xlObj.model.allowSelection)
                    xlObj.XLSelection._clearBorder(xlObj._formulaBorder.join(" ").replace(/,/g, " ") + " " + xlObj._ctrlFormulaBorder.join(" ").replace(/,/g, " "));
                if (xlObj.model.allowFormulaBar)
                {
                    autoEle = $("#" + xlObj._id + "_inputbox").data("ejAutocomplete");
                    if (autoEle)
                        autoEle.hide();
                }
                this._editElem.hide();
                xlObj.setSheetFocus();
                if (xlObj._browserDetails.name === "mozilla")  //ff issue - https://bugzilla.mozilla.org/show_bug.cgi?id=744408
                    htmlVal = htmlVal.slice(0, -4);
                if (htmlVal.indexOf('\n') > -1) {
                    details.altwrap = true;
                    this._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { altTxt: true } });
                }
                if (this.getPropertyValue(rowIdx, colIdx, "altTxt", sheetIdx)) {
                    if (!this.getPropertyValue(rowIdx, colIdx, "wrap", sheetIdx))
                        xlObj.wrapText([rowIdx, colIdx, rowIdx, colIdx]);
                    if (!htmlVal.match(/\n/g))
                        this._clearDataContainer({ cellIdx: { rowIndex: rowIdx, colIndex: colIdx }, property: ["altTxt"] });
                }
				details.newHeight = sheet.rowsHeightCollection[rowIdx]
                xlObj.XLScroll._getRowHeights(sheetIdx, rowIdx);
                if (xlObj.model.enableContextMenu)
                    $("#" + xlObj._id + "_contextMenuCell").data("ejMenu")._contextMenuEvents("_on"); //for disable default contextmenu - clipboard actions
                if (args.value !== args.prevValue || isFormatChanged) {
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
                return true;
            }
        },

        _formulaValidate: function (value) {
            var i, len, fValue, lPrnthsLen, rPrnthsLen, formulaLen, subStr, formulaCln, leftPos, rightPos, splitStr, formulaValue = value, xlObj = this.XLObj;
            var argsFormula = ["TODAY", "NOW", "TRUE", "FALSE","ROW", "COLUMN", "SHEET", "SHEETS"];
			if (!this._isNamedRange(value)) {
                formulaLen = formulaValue.length;
                lPrnthsLen = formulaValue.split("(").length;
                rPrnthsLen = formulaValue.split(")").length;
                formulaCln = xlObj.getCalcEngine().getLibraryFunctions();
                if (formulaValue.startsWith("=") && formulaLen > 1) {
                    fValue = formulaValue = formulaValue.substring(1);
                    if (lPrnthsLen !== rPrnthsLen) {
                        xlObj._showAlertDlg("Alert", "MissingParenthesisAlert", "FormulaAlert", 440); // To check the parenthesis
                        return;
                    }
                    if (lPrnthsLen === 1 && rPrnthsLen === 1 && xlObj.isUndefined(formulaCln.getItem(fValue.toUpperCase())) && !this._isValidCell(formulaValue) && !(fValue.substring(0, leftPos) == "TRUE" || fValue.substring(0, leftPos) == "FALSE")) {
                        xlObj._showAlertDlg("Alert", "CorrectFormula", "FormulaAlert", 372);// To enter the correct formula
                        return;
                    }
                    do {
                        leftPos = fValue.indexOf("(");
                        rightPos = fValue.indexOf(")");
                        if (argsFormula.indexOf(fValue.substring(0, leftPos).toUpperCase()) < 0) {
                            if (leftPos + 1 === rightPos) {
                                xlObj._showAlertDlg("Alert", "CorrectArgument", "FormulaAlert", 372); // To pass correct argument
                                return;
                            }
                        }
                        fValue = fValue.substring(leftPos + 1);
                        if (fValue.indexOf(",") > -1)
                            fValue = fValue.substring(fValue.indexOf(",") + 1);
                    }
                    while (fValue.indexOf("(") > -1);
                    splitStr = formulaValue.split(",");
                    for (i = 0, len = splitStr.length; i < len; i++) {
                        if (splitStr[i].indexOf("(") > -1) {
                            subStr = splitStr[i].split("(");
                            if (xlObj.isUndefined(formulaCln.getItem(subStr[0].toUpperCase()))) {
                                xlObj._showAlertDlg("Alert", "CorrectFormula", "FormulaAlert", 372); // To enter the correct formula
                                return;
                            }
                        }
                    }
                }
            }
            return true;
        },

        _isValidCell: function (cellRange) {
           var xlObj = this.XLObj, splt, rangeSplt,rangeLen, isSheet = true, isVisible, i, j, len, operandCln = ["<=", ">=", "<", ">", "=","+","-","/","*","^", "&"];
            for (i = 0, len = operandCln.length; i < len; i++) {
                if (cellRange.indexOf(operandCln[i]) > -1){
					rangeSplt = cellRange.split(operandCln[i]);
					for(j=0, rangeLen = rangeSplt.length;j<rangeLen;j++){
						if(!rangeSplt[j].length)
							return false; 
						else if(rangeLen == j+1 && rangeSplt[j].length)
							return true; 
					}
				} 
                if(cellRange.indexOf("%") > -1 && cellRange.split("%").length == 2)
                      return true;					
            }
            cellRange = cellRange.trim();
            cellRange = cellRange.startsWith("=") ? cellRange.substring(1) : cellRange;
            if (cellRange.indexOf("!") > -1) {
                splt = cellRange.split("!");
                cellRange = splt[1];
                if (xlObj._getSheetIndexByName(splt[0]) < 1)
                    isSheet = false;
            }
            isVisible = cellRange.indexOf(":") > -1 ? xlObj._isvalidRange(cellRange) : xlObj._isvalidRange(cellRange + ":" + cellRange);
            return isVisible && isSheet;
        },
		
		updateValue: function(aRange, val, formatclass, sheetIdx){
		    var xlObj = this.XLObj, range, cellIdx;
		    if (xlObj.model.isReadOnly)
		        return;
		    range = xlObj.getRangeIndices(aRange);
		    cellIdx = {rowIndex: range[0], colIndex: range[1]};
		    xlObj._isPublic = true;
			if (xlObj.model.allowCellFormatting && xlObj.XLFormat._hasFormat(formatclass)) {
			    xlObj.XLFormat._createFormatClass(xlObj.XLFormat.getFormatFromHashCode(formatclass), formatclass);
			    xlObj.XLFormat._updateFormatClass(cellIdx, formatclass);
            }
			this._updateCellValue(cellIdx, val, formatclass, sheetIdx);
			xlObj._isPublic = false;
		},

		updateCellValue: function (cellIdx, val, formatclass, sheetIdx) {
		    var xlObj = this.XLObj;
		    xlObj._isPublic = true;
		    if (xlObj.model.allowCellFormatting && xlObj.XLFormat._hasFormat(formatclass)) {
		        xlObj.XLFormat._createFormatClass(xlObj.XLFormat.getFormatFromHashCode(formatclass), formatclass);
		        xlObj.XLFormat._updateFormatClass(cellIdx, formatclass);
		    }
		    this._updateCellValue(cellIdx, val, formatclass, sheetIdx);
		    xlObj._isPublic = false;
		},

		_updateCellValue: function (cellIdx, val, formatclass, sheetIdx) {
		    var xlObj = this.XLObj;
		    if (!cellIdx || xlObj.model.isReadOnly)
		        return;
            var colIdx = cellIdx.colIndex, rowIdx = cellIdx.rowIndex, sheetIdx = xlObj._getSheetIndex(sheetIdx), actCell = xlObj.getActiveCell();
		    if (xlObj.isFormula(val)) {
		        this._refreshCalcEngine(rowIdx, colIdx, true, val, sheetIdx);
		        this._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { value: val }, sheetIdx: sheetIdx });
		        xlObj._isFormulaSuggestion = false;
		    }
		    else {
		        this._updateCell({ rowIndex: rowIdx, colIndex: colIdx }, val, sheetIdx);
		        this._refreshCalcEngine(rowIdx, colIdx, false, null, sheetIdx);
		    }
		    if (xlObj._isPublic) {
		        if (xlObj.model.allowDataValidation && this.getPropertyValue(rowIdx, colIdx, "isHighlight", sheetIdx))
		            xlObj.XLValidate.highlightInvalidData();
		        if (xlObj.model.allowConditionalFormats)
		            xlObj.XLCFormat.refreshCFormat([rowIdx, colIdx, rowIdx, colIdx]);
		        if (xlObj.model.allowComments)
		            xlObj.XLComment._updateCmntArrowPos();
		        if (actCell.rowIndex === rowIdx && actCell.colIndex === colIdx) {
		            xlObj.model.showRibbon && xlObj.XLRibbon._updateRibbonIcons();
		            xlObj.model.allowFormulaBar && xlObj.updateFormulaBar();
		        }
		    }
		},

		updateCell: function (cell, val, sheetIdx) {
		    var xlObj = this.XLObj;
		    xlObj._isPublic = true;
		    this._updateCell(cell, val, sheetIdx);
		    xlObj._isPublic = false;
		},

		_updateCell: function (cell, val, sheetIdx) {
		    var xlObj = this.XLObj;
		    if (!cell || xlObj.model.isReadOnly)
		        return;
		     sheetIdx = xlObj._getSheetIndex(sheetIdx);
		    var cHght, isUpdtDtcnr = true, sheet = xlObj.getSheet(sheetIdx), rIdx = cell.rowIndex, cIdx = cell.colIndex, ctype = ej.Spreadsheet.CellType, details, pValue = this.getPropertyValue(rIdx, cIdx, 'value2') || "", height = sheet.rowsHeightCollection[rIdx],
            // parse value
            valObj = this._parseValue(val, cell),
           cellInfo = xlObj.getRangeData({ range: [rIdx, cIdx, rIdx, cIdx], property: ["formatStr", "type", "thousandSeparator", "decimalPlaces", "cellType"], sheetIdx: sheetIdx })[0];
			if(xlObj.model.isReadOnly)
				return;
            // cell type
            if (cellInfo.type && cellInfo.type != ctype.General) {
                valObj.type = cellInfo.type;
                delete valObj.formatStr;
            }
            // cell format
            if (cellInfo.formatStr || cellInfo.type === ctype.Scientific || cellInfo.type === ctype.Fraction)
                valObj.value2 = xlObj.XLFormat._format(valObj.value, { formatStr: cellInfo.formatStr, type: cellInfo.type, thousandSeparator: cellInfo.thousandSeparator, decimalPlaces: cellInfo.decimalPlaces });
			if (xlObj.model.allowCellType && !xlObj.isUndefined(cellInfo.cellType))
		        isUpdtDtcnr = xlObj.XLCellType._rfrshCtrlText(cellInfo, valObj.value);
		    if (isUpdtDtcnr)// data updation
		        this._updateDataContainer(cell, { dataObj: valObj, sheetIdx: sheetIdx });
            if (xlObj._isPublic) {
                cHght = xlObj._getWrapCellHeight(sheetIdx, rIdx, cIdx);
                if (this.getPropertyValue(rIdx, cIdx, "wrap") || cHght.cellHt > sheet.rowsHeightCollection[rIdx]) {
                    if (xlObj._isRowViewable(sheetIdx, rIdx))
                        xlObj.setHeightToRows([{ rowIndex: rIdx, height: cHght.rowHt }]);
                    else {
                        sheet.rowsHeightCollection[rIdx] = cHght.rowHt;
                        xlObj.XLScroll._getRowHeights(sheetIdx, rIdx);
                    }
                }
            }
			details = { sheetIndex: sheetIdx ? sheetIdx : xlObj.getActiveSheetIndex(), rowIndex: rIdx, colIndex: cIdx, reqType: 'edit', cValue: val, pValue: pValue ? pValue: "", prevHeight: height, newHeight: sheet.rowsHeightCollection[rIdx] };
			if (xlObj._isPublic && !xlObj._dupDetails) {
			    xlObj._completeAction(details);
			    xlObj._trigActionComplete(details);
			}
        },

        _parseValue: function (value, cell) {
		    var localeNum;
            if (!cell || (this.getPropertyValue(cell.rowIndex, cell.colIndex, "type") != "text")) {
                localeNum = this.XLObj._getlocaleNumVal(value);
                value = this.XLObj.isNumber(value) ? Number(value) : (ej.isNullOrUndefined(value) ? "" : ((typeof value === "object" && !this.XLObj._isDateTime(value)) ? JSON.stringify(value) : value));
            }
            var prop, temp, tSep, patrns, isRExp, regExp, prefCul, formatStr, decPlaces, xlObj = this.XLObj, locale = xlObj.model.locale, ctype = ej.Spreadsheet.CellType, rAlign = ej.Spreadsheet.Align.Right,
                value2 = (typeof value === "object" && !this.XLObj._isDateTime(value)) ? JSON.stringify(value) : value + "", type = ctype.General, idx = value2.indexOf(xlObj._currencySymbol);
            if (localeNum)
                value = localeNum;
            if (idx === 0 || (idx > -1 && idx === value2.length - 1)) {
                temp = ej.parseFloat(value2, 10, locale);
                if (temp) {
                    decPlaces = value2.indexOf(xlObj._decimalSeparator) > -1 ? xlObj._decimalCnt(temp) : 0;
                    return { type: ctype.Currency, value: temp, value2: value2, formatStr: xlObj._getFormatString(ctype.Currency, decPlaces), decimalPlaces: decPlaces, align: rAlign };
                }
            }
            if (value2.indexOf(xlObj._percentSymbol) > -1) {
                temp = $.trim(value2).replace(xlObj._percentSymbol, "");
                if (xlObj.isNumber(temp)) {
                    decPlaces = value2.indexOf(xlObj._decimalSeparator) > -1 ? xlObj._decimalCnt(temp) : 0;
                    return { type: ctype.Percentage, value: Number(temp) / 100, value2: value2, formatStr: xlObj._getFormatString(ctype.Percentage, decPlaces), decimalPlaces: decPlaces, align: rAlign };
                }
            }
            prefCul = ej.preferredCulture(locale);
            tSep = prefCul.numberFormat[","] || ",";
            regExp = new RegExp("\\" + tSep + "\\d{3}");
            if (value2.indexOf(xlObj._decimalSeparator) > -1 && regExp.test(value2)) {
                temp = ej.parseFloat(value2, 10, locale);
                if (temp) {
                    decPlaces = value2.substr(value2.indexOf(xlObj._decimalSeparator) + 1).length;
                    if (decPlaces > 2)
                        decPlaces = 2;
                    value2 = ej.format(temp, "N" + decPlaces, locale);
                    return { type: ctype.Number, value: temp, value2: value2, formatStr: xlObj._getFormatString(ctype.Number, decPlaces), decimalPlaces: decPlaces, thousandSeparator: true };
                }
            }
            if (value2.indexOf(tSep) > -1) {
                if (regExp.test(value2)) {
                    temp = ej.parseInt(value2, 10, locale);
                    if (temp) {
                        decPlaces = 0;
                        value2 = ej.format(temp, "N" + decPlaces, locale);
                        return { type: ctype.Number, value: temp, value2: value2, formatStr: xlObj._getFormatString(ctype.Number, decPlaces), decimalPlaces: decPlaces, thousandSeparator: true };
                    }
                }
                else
                    value = value2;
            }
            patrns = prefCul.calendar.patterns
            isRExp = true, regExp = prefCul.calendar._parseRegExp;
            for (prop in patrns) {
                if (regExp && patrns[prop] in regExp)
                    temp = new RegExp(regExp[patrns[prop]].regExp).exec(value2);
                else {
                    isRExp = false;
                    temp = ej.parseDate(value2, patrns[prop], locale);
                }
                if (temp)
                    break;
            }
            if (temp) {
                if (isRExp)
                    temp = ej.parseDate(value2, patrns[prop], locale);
                if (temp) {
                    if (prop === "T" || prop === "t" || xlObj.XLFormat._customFormatSpecifierType[prop] === ctype.Time) {
                        temp.setYear(1990);
                        temp.setMonth(0);
                        temp.setDate(1);
                        type = ctype.Time;
                    }                    
                    else if (prop === "d")
                        type = ctype.ShortDate;
                    else if (prop === "D")
                        type = ctype.LongDate;
                    else
                        type = ctype.Date;
                    formatStr = "{0:" + patrns[prop] + "}";
                    value2 = xlObj.XLFormat._format(temp, { type: type, formatStr: formatStr });
                    return { type: type, value: temp, value2: value2, formatStr: formatStr, align: rAlign };                }
            }
            if (value2.toLowerCase() === "true" || value2.toLowerCase() === "false")
                value = value2 = value2.toUpperCase();
            return { type: type, value: value, value2: value2 };
        },

        updateCellWithContainer: function (data, range, sheetIdx, skipHiddenRow) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var actCell, colIdx, rowIdx, cellData, cellIdx, cells, len, i = 0, j = 0,
                sheetIdx = xlObj._getSheetIndex(sheetIdx), range = range ? range : xlObj.getSheet(sheetIdx).selectedRange;
            cells = xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
            len = cells.length;
            while (i < len) {
                cellIdx = cells[i];
                rowIdx = cellIdx.rowIndex;
                if (!skipHiddenRow || !xlObj._isHiddenRow(rowIdx)) {
                    colIdx = cellIdx.colIndex;
                    cellData = data[j];
                    actCell = xlObj.getCell(rowIdx, colIdx, sheetIdx);                                         
                    this._updateDataContainer(cellIdx, { dataObj: cellData });
                    this._refreshCalcEngine(rowIdx, colIdx, xlObj.isFormula(cellData.value), cellData.value);
                    if (actCell && cellData.format)
                        xlObj.addClass(actCell[0], cellData.format);
                    if (actCell && cellData.hyperlink)
                        actCell.html(ej.buildTag('a.e-hyperlinks', cellData.value2, '', "cellAdr" in cellData.hyperlink ? { href: '#' } : { href: cellData.hyperlink.webAdr, target: '_blank' }));
                    if (cellData.comment)
                        xlObj.XLComment.setComment([rowIdx, colIdx, rowIdx, colIdx], null, false);
                    if (cellData.border)
                        xlObj.XLFormat.applyBorder(xlObj.XLFormat.getBorderFromHashCode(cellData.border), xlObj._getAlphaRange(sheetIdx, rowIdx, colIdx, rowIdx, colIdx));
                    if (actCell) {
                        if (cellData.rule && cellData.rule.isApply)
                            xlObj.addClass(actCell[0], 'e-hlcell');
                        else
                            xlObj._removeClass(actCell[0], 'e-hlcell');
                    }
                    j++;
                }
                i++;
            }
            if (xlObj.model.allowConditionalFormats)
                xlObj.XLCFormat.refreshCFormat(range);
        },

        _refreshCellAlignment: function (options) {
            options = options || {};
            var prop, skipCell, align = ej.Spreadsheet.Align, xlObj = this.XLObj, rowIdx = options.cellIdx.rowIndex, colIdx = options.cellIdx.colIndex, isMergeCell = this.getPropertyValue(rowIdx, colIdx, "merge");
            if (!(align in options)) {
                options.value = ej.isNullOrUndefined(options.value) ? this.getPropertyValue(rowIdx, colIdx, "value") : options.value;
                if (xlObj.isFormula(options.value))
                    options.value = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "calcValue");
                options.type = options.type ? options.type : this.getPropertyValue(rowIdx, colIdx, "type");
                if ((xlObj.isNumber(options.value) || typeof options.value === "object") && options.type !== ej.Spreadsheet.CellType.Text && !(isMergeCell && isMergeCell.isCenterAlign))
                    options.align = align.Right;
                else if (xlObj._isBool(options.value) || (isMergeCell && isMergeCell.isCenterAlign))
                    options.align = align.Center;
                else
                    options.align = align.Left;
            }
            prop = this.getPropertyValue(rowIdx, colIdx, "align");
            if (xlObj._isInitLoad && !xlObj.isImport)
                skipCell = true;
            if (!options.align || (prop && prop != options.align))
                xlObj.clearRangeData([rowIdx, colIdx, rowIdx, colIdx], ["align"], "", "", "", skipCell);
            if (options.align)
                this._updateDataContainer(options.cellIdx, { dataObj: { align: options.align }, skipCell: skipCell });
        },

        _editingHandler: function (e) {
			if($(e.target).parents(".e-backstagecontent").length)
				return;
			var text, isRowVisible, xlObj = this.XLObj, sheetIdx, sheet, $trgt, readOnlyCells, sheetDt, cellObj, rIdx, cIdx, selRowIdx, rowIdx, colIdx,
                cName, i, j, len, m, n, rLen, cFormatStr, aRange, regxFormat, cFormatRule, selected, details, cell, mergeWrap, cellobjval;
            if ((e.keyCode === 61 || (!e.shiftKey && e.keyCode === 32) || (e.keyCode >= 48 && e.keyCode <= 59) || (e.keyCode >= 65 && e.keyCode <= 90) || (e.keyCode >= 96 && e.keyCode <= 111) || (e.keyCode === 173) || (e.keyCode >= 186 && e.keyCode <= 192) || (e.keyCode >= 219 && e.keyCode <= 222)) && !e.ctrlKey && !e.altKey) {
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), $trgt = xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                if (!this._isEdit && (!xlObj._hasClass($trgt, "e-readonly") && !xlObj._hasClass($trgt, "e-cellreadonly"))) {
                    xlObj.element.find(".e-cdata").length && xlObj.element.find(".e-cutright, .e-cutbottom").removeClass("e-cutright e-cutbottom");                    
                    xlObj.XLCellNav._navToCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                    this.editCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, false);
                }
            }
            else if (e.keyCode === 113 && !e.shiftKey && !e.ctrlKey) { //F2            
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), $trgt = xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex), this._isFEdit = true;
                if (!this._isEdit && (!xlObj._hasClass($trgt, "e-readonly") && !xlObj._hasClass($trgt, "e-cellreadonly"))) {
                    xlObj.element.find(".e-cdata").length && xlObj.element.find(".e-cutright, .e-cutbottom").removeClass("e-cutright e-cutbottom");
                    xlObj.XLCellNav._navToCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                    this.editCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, true);
                }
            }
            else if (e.keyCode === 27 && this._isEdit) { //escape                
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), rIdx = sheet._activeCell.rowIndex, cIdx = sheet._activeCell.colIndex, $trgt = xlObj.getCell(rIdx, cIdx), sheetDt = xlObj._dataContainer.sheets[sheetIdx];
                if (xlObj.XLEdit.getPropertyValue(rIdx, cIdx, 'wrap') && xlObj.XLEdit.getPropertyValue(rIdx, cIdx, 'merge')) {
                    cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                    mergeWrap = cell.find('#' + xlObj._id + '_MergeWrap')[0];
                }
                cellObj = rIdx in sheetDt && cIdx in sheetDt[rIdx] ? sheetDt[rIdx][cIdx] : cellObj;
                cellobjval = cellObj ? (typeof cellObj["value2"] === "string") ? cellObj["value2"] : xlObj._dataContainer.sharedData[cellObj["value"]] : "";
                xlObj.isFormula(cellobjval) && (cellobjval = this.getPropertyValue(rIdx, cIdx, "value2"));
                xlObj.element.find("#" + xlObj._id + "_Edit").hide();
                isRowVisible=xlObj._isRowViewable(sheetIdx,rIdx);
                if (isRowVisible) {
                    mergeWrap ? (mergeWrap.innerHTML = cellobjval) : this._refreshTextNode($trgt[0], cellobjval);
                    xlObj.setSheetFocus();
                    xlObj._setRowHdrHeight(sheetIdx, sheet._selectedCells[0].rowIndex);
                }
                else if (xlObj.model.allowFormulaBar)
                    xlObj.updateFormulaBar();
                if (this._isFormulaEdit)
                    $("#" + xlObj._id + "_AutoComplete").data("ejAutocomplete").suggestionList.hide();
                this._isEdit = this._isFormulaEdit = this._isFBarFocused = false;
                xlObj._getContent(sheetIdx).find("td").removeClass(xlObj._formulaBorder.join(" ").replace(/,/g, " ") + " " + xlObj._ctrlFormulaBorder.join(" ").replace(/,/g, " "));
                if(isRowVisible){
                    if (xlObj.model.allowComments && $trgt.hasClass("e-commentcell"))
                        xlObj.XLComment._visibleCmntCnt($trgt, true);
                if(xlObj.model.allowAutoFill)
                    xlObj.XLDragFill.positionAutoFillElement();
                $trgt.removeClass("e-editedcell e-msie-edit");
            }
                xlObj.model.showRibbon && xlObj.XLRibbon._enableRibbonIcons();
				xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-error").remove();
                if(!ej.isNullOrUndefined(xlObj.XLCellNav)) xlObj.XLCellNav._isNavigate = true;
            }
            else if (e.keyCode === 46) { //delete   
                if (!this._isEdit) {
					if (xlObj._preventctrlkey) {
						xlObj._showAlertDlg("Alert", "CtrlKeyErrorAlert", "CtrlKeyErrorAction", 450);
						return;
					}
                    sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), $trgt = xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                    regxFormat = new RegExp("\\b" + "e-format" + ".*?\\b", "g"), cFormatRule;
                    selected = sheet._selectedCells, text = xlObj.getRangeData({ range: [selected[0].rowIndex, selected[0].colIndex, selected[selected.length - 1].rowIndex, selected[selected.length - 1].colIndex] });
                    if (xlObj.model.allowLockCell && sheet.isSheetProtected) {
                        if (xlObj._isPropExists([sheet.selectedRange], "isLocked", sheetIdx))
                            return;
                    }
                    if (xlObj._isPropExists([sheet.selectedRange], "isReadOnly", sheetIdx))
                        return;          
                    if (!this._isEdit) {
                        xlObj.element.find(".e-cdata").length && xlObj.element.find(".e-cutright, .e-cutbottom").removeClass("e-cutright e-cutbottom");
                        var tblMgr = xlObj.model.sheets[sheetIdx].tableManager, tblObj, tblRange, tblCells, objKeys = xlObj.getObjectKeys(tblMgr);
                        for (m = 0, rLen = xlObj.getObjectLength(tblMgr) ; m < rLen; m++) {
                            tblRange = tblMgr[objKeys[m]].range;
                            if (xlObj.XLClipboard._compareRange([selected[0].rowIndex, selected[0].colIndex, selected[selected.length - 1].rowIndex, selected[selected.length - 1].colIndex], tblRange)) {
                                aRange = xlObj._getAlphaRange(sheetIdx, tblRange[0], tblRange[1], tblRange[2], tblRange[3]);
                                xlObj.clearAll(aRange);
                                return;
                            }
                        }
                        if (!xlObj._hasClass($trgt, "e-readonly")) // need to remove e-readonly
                            xlObj.clearRangeData(null, ["value2", "value", "hyperlink"]);
                            selRowIdx = selected[0].rowIndex;
                        for (i = 0, len = selected.length; i < len; i++) {
                            rowIdx = selected[i].rowIndex;
                            colIdx = selected[i].colIndex;
                            xlObj._textClip(rowIdx, colIdx, "delete");
                            if (!this.getPropertyValue(rowIdx, colIdx, "isReadOnly")) {
                                if (xlObj.model.allowFormulaBar)
                                    xlObj._getInputBox().val('');
                                cFormatRule = this.getPropertyValue(rowIdx, colIdx, "cFormatRule");
                                if (xlObj.model.allowConditionalFormats && cFormatRule && cFormatRule.length) {
                                    for (j = 0, rLen = cFormatRule.length; j < rLen; j++) {
                                        cFormatStr = cFormatRule[j].split("_");
                                        xlObj.XLCFormat._cFormat(cFormatStr[0], cFormatStr[2], cFormatStr[3], cFormatStr[4], cFormatStr[5]);
                                    }
                                }
                             if(selRowIdx !== rowIdx){
                               xlObj._setRowHdrHeight(sheetIdx, rowIdx);
                               selRowIdx++;
                               }
                            }
                        }
                        xlObj.XLSelection._refreshBorder();
                    }
                     details = { sheetIndex: sheetIdx, range: [selected[0].rowIndex, selected[0].colIndex, selected[selected.length - 1].rowIndex, selected[selected.length - 1].colIndex], bData: text, reqType: "clear-content" };
                     xlObj._completeAction(details);
                     xlObj._trigActionComplete(details);
                }
                else {
                    if (xlObj._ctrlKeyCount > 0) {
                        xlObj._ctrlKeyCount = 0;
                        xlObj._formulaRange = [];
                        xlObj.XLSelection._clearBorder(xlObj._formulaBorder.join(" ").replace(/,/g, " ") + " " + xlObj._ctrlFormulaBorder.join(" ").replace(/,/g, " "));
                    }
                }
            }
            else if (!e.ctrlKey && !e.shiftKey && e.keyCode === 8) { //backspace
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), $trgt = xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                if (!this._isEdit && (!xlObj._hasClass($trgt, "e-readonly") && !xlObj._hasClass($trgt, "e-cellreadonly"))) {
                    xlObj.element.find(".e-cdata").length && xlObj.element.find(".e-cutright, .e-cutbottom").removeClass("e-cutright e-cutbottom");
                    $trgt = xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                    this.editCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, false);
                    xlObj._setRowHdrHeight(sheetIdx, sheet._activeCell.rowIndex);
                    if (xlObj.model.allowFormulaBar)
                    xlObj._getInputBox().val("");
                }
            }
            else if ((((e.keyCode === 13 && !e.altKey) || e.keyCode === 9)) && this._isEdit && xlObj.model.allowKeyboardNavigation && !xlObj.XLCellNav._isNavigate && !this._isFormulaEdit) { //enter  
                e.preventDefault();
                if(!ej.isNullOrUndefined(xlObj.XLCellNav)) xlObj.XLCellNav._isNavigate = true;
            }
            else if ((e.keyCode === 13 && e.altKey) && this._isEdit) { //alt + enter  
                e.preventDefault();
                var editElem = xlObj.element.find("#" + xlObj._id + "_Edit");
                editElem.focus();
                editElem.altEnter();
            }
        },

        _focusElements: function (cell) {
            $(cell).not(":hidden").focus().setInputPos($(cell).text().length);
        },

        _updateUsedRange: function (rowIdx, colIdx, sheetIdx) {
            var xlObj = this.XLObj, usedRange = xlObj.getSheet(sheetIdx ? sheetIdx : xlObj.getActiveSheetIndex()).usedRange;
            if(usedRange.rowIndex < rowIdx)
                usedRange.rowIndex = rowIdx;
            if(usedRange.colIndex < colIdx)
                usedRange.colIndex = colIdx;
        },

        _updateDataContainer: function (cellIdx, options) {
            var i, j, k, $cell, cell, mergeWrap, mergeWrapval, newText, ctype, atype, colObj, index, data, arr, cellData, colIdx, rowIdx, isDate, isBool, cellObj, id,
                innerTag, container, sheetData, rowData, prefix, regx, prevVal, textNode, bool, hcode, child, format = "e-format",
                canRefresh = false, border = "e-border", dataObj = options.dataObj, xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(options.sheetIdx), sheet = xlObj.getSheet(sheetIdx);
            if (!options.skipCell && xlObj._isRowViewable(sheetIdx, cellIdx.rowIndex)) {
                $cell = xlObj.getCell(cellIdx.rowIndex, cellIdx.colIndex, sheetIdx);
                cell = $cell[0];
            }
            if (dataObj) {
                ctype = ej.Spreadsheet.CellType, atype = ej.Spreadsheet.Align, container = xlObj._dataContainer,
                colIdx = cellIdx.colIndex, rowIdx = cellIdx.rowIndex, arr = xlObj._cellProp, sheetData = container.sheets[sheetIdx];
                if (rowIdx in sheetData) {
                    rowData = sheetData[rowIdx];
                    if (colIdx in rowData)
                        colObj = rowData[colIdx];
                    else
						rowData[colIdx] = colObj = {};
                }
                else {
                    rowData = sheetData[rowIdx] = {};
					rowData[colIdx] = colObj = {};
                }
                if (cell) {
                    if (xlObj._hasClass(cell, 'e-sswraptext')) {
						xlObj._removeClass(cell, 'e-sswraptext');
						xlObj.addClass(cell, 'e-sswraptext');
					}
                    if (this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'wrap', sheetIdx) && this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'merge', sheetIdx)) {
                        mergeWrap = $cell.find('#' + xlObj._id + '_MergeWrap')[0];
                        if (mergeWrap) {
                            textNode = mergeWrap.lastChild;
                            if (textNode) {
                                if (textNode.nodeType === 1) {
                                    xlObj._hasClass(textNode, 'e-hyperlinks') && (textNode.textContent = '');
                                    xlObj._hasClass(textNode, 'e-comment') && (textNode.lastChild.textContent = '');
                                }
                                else
                                    textNode.textContent = '';
                            }
                            else
                                mergeWrap.textContent = '';
                            mergeWrapval = mergeWrap.innerHTML;
                            mergeWrap.remove();
                        }
					}
				}					
                for (i in dataObj) {
                    data = dataObj[i];
                    switch (i) {
                        case arr[0]:
                        case arr[4]:
                        case arr[5]:
                        case arr[11]:
                            index = container.sharedData.indexOf(data);
                            if (index === -1) {
                                index = container.sharedData.push(data);
                                index--;
                            }
                            colObj[i] = index;
                            if (sheet._isLoaded && i === arr[0] && !xlObj._intrnlUpdate)
                                canRefresh = true;
                            break;
                        case arr[1]:
                            prevVal = this.getPropertyValue(rowIdx, colIdx, "value2", sheetIdx);
                            if (dataObj.type && dataObj.type != ctype.General && dataObj.type != ctype.Text)
                                colObj[i] = dataObj.value2;
                            else {
                                index = container.sharedData.indexOf(dataObj.value2);
                                if (index === -1) {
                                    index = container.sharedData.push(dataObj.value2);
                                    index--;
                                }
                                colObj[i] = index;
                            }
                            if (cell && !('cellType' in dataObj)) {
                                innerTag = cell.getElementsByTagName("a");
                                if (innerTag.length)
                                    this._refreshTextNode(cell, dataObj.value2);
                                else if (colObj[arr[24]] > -1) {
									cellObj = container.sheetCellType[colObj[arr[24]]], id = cellObj.id;
									if ($('#' + id).length === 0)
										return;
									if (dataObj.value2) {
										switch (cellObj.type) {
											case 'Button':
											$('#' + id).ejButton('instance').option('text', dataObj.value2);
											 break;
										}
									}
								}
								else {
									isDate = (dataObj.value2.toString().length > 7) && !isNaN(new Date(dataObj.value2).valueOf()), isBool = ['true', 'yes', 'false', 'no'].indexOf(dataObj.value2.toString().toLowerCase()) > -1;
									if (xlObj.model.allowCellType && xlObj.model.allowAutoCellType && (isDate || isBool)) {
										if (isDate) {
											xlObj.XLCellType._rangeCellTypes([{ 'type': 'DatePicker', 'range':  xlObj._getAlphaRange(sheetIdx, rowIdx, colIdx, rowIdx, colIdx) }], sheetIdx, true);
											$("#" + xlObj._dataContainer.sheetCellType[colObj[arr[24]]].id).ejDatePicker('instance').option('value', dataObj.value2);
										}
										else if (isBool) {
											xlObj.XLCellType._rangeCellTypes([{ 'type': 'CheckBox', 'range':  xlObj._getAlphaRange(sheetIdx, rowIdx, colIdx, rowIdx, colIdx) }], sheetIdx, true);
											$("#" + xlObj._dataContainer.sheetCellType[colObj[arr[24]]].id).ejCheckBox('instance').option('checked', (['true', 'yes'].indexOf(dataObj.value2.toString().toLowerCase()) > -1) ? true : false);
										}
									}
									else 
										this._skipHTML ? cell.innerHTML.concat(dataObj.value2) : this._refreshTextNode(cell, dataObj.value2);
                                }
                                this._refreshCellAlignment({ cellIdx: cellIdx, value: dataObj.value, type: dataObj.type });
                            }
                            if (xlObj.model.allowOverflow && xlObj._canOverflow) {
                                if (prevVal || dataObj.value2) {
                                    if (ej.isNullOrUndefined(prevVal))
                                        bool = true;
                                    else {
                                        if (prevVal.length <= dataObj.value2.length)
                                            bool = true;
                                        else
                                            bool = false;
                                    }
                                    xlObj._textClip(rowIdx, colIdx, bool ? 'add' : 'delete');
                                    if (!bool && dataObj.value2.length > 0)
                                        xlObj._textClip(rowIdx, colIdx, 'add');
                                }
                            }
							else if(xlObj._canOverflow)
								xlObj.refreshOverflow([rowIdx, colIdx, rowIdx, colIdx], sheetIdx);
                            colObj["isDirty"] = true;
                            break;
                        case arr[2]:
                            colObj[i] = container.cellType.indexOf(dataObj.type);
                            break;
                        case arr[3]:
                            j = 0, k = data.length;
                            while (j < k) {
                                index = container.cFormatData.indexOf(data[j]);
                                if (index === -1) {
                                    index = container.cFormatData.push(data[j]);
                                    index--;
                                }
                                if (colObj[i]) {
                                    if (colObj[i].indexOf(index) === -1)
                                        colObj[i].push(index);
                                }
                                else
                                    colObj[i] = [index];
                                j++;
                            }
                            break;
                        case arr[6]:
                            index = container.valData.indexOf(data.customVal);
                            if (index === -1) {
                                index = container.valData.push(data.customVal);
                                index--;
                            }
                            colObj[i] = JSON.parse(JSON.stringify(data));
                            colObj[i].customVal = index;
                            break;
                        case arr[7]:
                        case arr[8]:
                            if (cell) {
                                prefix = i === arr[8] ? border : format, regx = new RegExp('\\b' + prefix + '.*?\\b', 'g');
                                cell.className = cell.className.replace(regx, "");                                                                
                                xlObj.addClass(cell, data);
                            }
                            index = container.hashCode.indexOf(data);
                            if (index === -1) {
                                index = container.hashCode.push(data);
                                index--;
                            }
                            colObj[i] = index;
                            break;
                        case arr[9]:
                        case arr[10]:
                        case arr[26]:
                            if (colObj[i]) {
                                if (colObj[i].indexOf(data) === -1)
                                    colObj[i].push(data);
                            }
                            else
                                colObj[i] = [data];
                            break;
                        case arr[12]:
                            colObj[i] = data;
                            if (cell) {
                                if (data === atype.Center)
                                    xlObj.addClass(cell, xlObj._cAlign);
                                else if (data === atype.Right)
                                    xlObj.addClass(cell, xlObj._rAlign);
                                else
                                    $(cell).removeClass(xlObj._rAlign + " " + xlObj._cAlign);
                            }
                            break;
                        case arr[14]:
                        case arr[16]:
                            hcode = xlObj.XLFormat.getFormatHashCode(data);
                            index = container.hashCode.indexOf(hcode);
                            if (index === -1) {
                                xlObj.XLFormat._createFormatClass(data, hcode);
                                index = container.hashCode.push(hcode);
                                index--;
                            }
                            colObj[i] = index;
                            break;
                        case arr[15]:
                        case arr[17]:
                            data = xlObj.XLFormat._getBorderHashCode(data, true);
                            index = container.hashCode.indexOf(data);
                            if (index === -1) {
                                index = container.hashCode.push(data);
                                index--;
                            }
                            colObj[i] = index;
                            break;
                        default:
                            colObj[i] = data;
                    }
                }
                this._updateUsedRange(cellIdx.rowIndex, cellIdx.colIndex, sheetIdx);
                if (canRefresh) {
                    if (xlObj.model.allowCharts)
                        xlObj.XLChart._refreshChartElements(rowIdx, colIdx, sheetIdx);
                    if (xlObj.model.allowConditionalFormats)
                        xlObj.XLCFormat._refreshCFormatFormula(rowIdx, colIdx, sheetIdx);
                    xlObj._updateBatchDetails(rowIdx, colIdx, sheetIdx);
                    canRefresh = false;
                }
                if (cell && this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'wrap', sheetIdx) && this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'merge', sheetIdx)) {
                    var cellMerge = this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'merge', sheetIdx), cellHeight = (sheet._rowHeightCollection[cellIdx.rowIndex + cellMerge.mSpan.rowSpan] - sheet._rowHeightCollection[cellIdx.rowIndex]) || Math.floor($cell.height());
                    if (xlObj._isRowViewable(sheetIdx, cellIdx.rowIndex)) {
                        newText = this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'value2', sheetIdx);
				        this._refreshTextNode(cell);
				        mergeWrapval = (mergeWrapval) ? mergeWrapval.concat(dataObj.value2 || newText) : (dataObj.value2 || newText);
				        mergeWrap = $cell.find('#' + xlObj._id + '_MergeWrap')[0];
				        if (!mergeWrap) {
				            cell.innerHTML = "<div id =" + xlObj._id + "_MergeWrap style = 'border :0px;overflow: hidden;max-height:" + (cellHeight - 1) + "px'>" + cell.innerHTML.concat(mergeWrapval || '') + "</div>"; //-1 to set the height less than cell height to avoid misalignment
				            mergeWrap = $cell.find('#' + xlObj._id + '_MergeWrap')[0];
				        }
				        child = mergeWrap.children;
				        if (child.length) {
							for(var i = 0;i < child.length; i++){
								if(xlObj._hasClass(mergeWrap.children[i], 'e-comment'))
									mergeWrap.children[i].lastChild.textContent = this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'comment', sheetIdx).value;
								if(xlObj._hasClass(mergeWrap.children[i], 'e-hyperlinks')){
									mergeWrap.lastChild.textContent = '';
									mergeWrap.children[i].textContent = this.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, 'value2', sheetIdx);
								}
							}
				        }
				    }
				}
                if ((Object.keys ? Object.keys(colObj).length : xlObj.getObjectLength(colObj)) === 3) {
                    cellData = xlObj.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx], property: arr.slice(0, 3) })[0];
                    if (cellData.value === "" && cellData.value2 === "" && cellData.type === ej.Spreadsheet.CellType.General)
                        xlObj.clearRangeData([rowIdx, colIdx, rowIdx, colIdx], arr.slice(0, 3));
                }
                if (sheet._isLoaded && !xlObj.isDirty && !xlObj._intrnlReq && !xlObj.isImport)
                    xlObj.isDirty = true;
            }
            else if (cell)
                this._refreshTextNode(cell);
        },

        _clearDataContainer: function (options) {
            var i, cell, rng, aTag, prop, mergeWrap, prevVal, colData, hl, canRefresh, value, canClip = false, dupdetails, xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(options.sheetIdx), arr = xlObj._cellProp,
                rowIdx = options.cellIdx.rowIndex, colIdx = options.cellIdx.colIndex, props = options.property || [], isClear = false, formattedval, dataObj,
                container = xlObj._dataContainer, sheetData = container.sheets[sheetIdx];
            if (props.length && rowIdx in sheetData && colIdx in sheetData[rowIdx]) {                
                colData = sheetData[rowIdx][colIdx], i = props.length;
                if (!options.skipCell && xlObj._isRowViewable(sheetIdx, rowIdx))
                    cell = xlObj.getCell(rowIdx, colIdx, sheetIdx);
                while (i--) {
                    value = null, canRefresh = false;
                    prop = props[i];
                    switch (prop) {
                        case arr[0]:
                            value = this.getPropertyValue(rowIdx, colIdx, prop, sheetIdx);                                                       
                            xlObj._updateBatchDetails(rowIdx, colIdx, sheetIdx);                            
                            canRefresh = true;
                            break;
                        case arr[1]:
                            prevVal = this.getPropertyValue(rowIdx, colIdx, 'value2');
                            if (cell)
                                this._refreshTextNode(cell[0]);
                            if (prevVal)
								canClip = true;
                            break;
                        case arr[3]:
                            value = this.getPropertyValue(rowIdx, colIdx, prop, sheetIdx);
                            if (value && cell)
                                $(cell).removeClass("e-redft e-yellowft e-greenft e-redf e-redt");
                            break;
                        case arr[7]:
                        case arr[8]:
                            value = this.getPropertyValue(rowIdx, colIdx, prop, sheetIdx);
                            if (value && cell)
                                xlObj._removeClass(cell[0], value);
                            break;
						case arr[14]:
							value = this.getPropertyValue(rowIdx, colIdx, prop, sheetIdx);
							if (value && value['text-align'] && value['text-align'] === 'right' && cell)
								xlObj._removeClass(cell[0], 'e-rightalign');
							break;
                        case arr[12]:
                            value = colData[prop];
                            if (value && cell)
                                xlObj._removeClass(cell[0], value === ej.Spreadsheet.Align.Center ? xlObj._cAlign : xlObj._rAlign);
                            break;
                        case arr[13]:
							value = colData[prop];
							if(value && cell){
							    hl = cell[0].lastChild.textContent;
							    if (options.status === "clear-content") {
							        cell[0].lastChild.textContent = "";
							        break;
							    }
							    else if (options.status === "clear-format") {
							        aTag = cell.find("a");
							        if (xlObj._hasClass(aTag[0], "e-hyperlinks"))
							            aTag.css({ "color": "#444445", "text-decoration": "none" }).removeClass("e-hyperlinks");
							        break;
							    }
							    cell.find("a").remove();
								if(ej.isNullOrUndefined(cell[0].lastChild))
								    cell[0].textContent = hl;
                                else
								    cell[0].lastChild.textContent = hl;
							}
							break;
                        case arr[18]:
                            value = colData[prop];
                            if (value && cell) {
                                cell.removeClass("e-filterhdr");
                                cell.find(".e-filterspan").remove();
                            }
                            break;
                        case arr[21]:
                            xlObj.XLComment && xlObj.XLComment.deleteComment([rowIdx, colIdx,rowIdx, colIdx]);
                            break;
                        case arr[5]:
                        case arr[22]:
                        case arr[23]:
							if(!isClear){
								value = this.getPropertyValue(rowIdx, colIdx);
								dataObj = {decimalPlaces: 0, thousandSeparator: false, formatStr: "", type: "general", value: value};
								dataObj.value2 = formattedval = xlObj.XLFormat._getFormattedValue(rowIdx, colIdx, dataObj, value);
							    xlObj.XLEdit._updateDataContainer({rowIndex: rowIdx, colIndex: colIdx}, { dataObj: dataObj });
								isClear = true;
							}
							break;
                        case arr[25]:
                            delete sheetData[rowIdx][colIdx][prop];
							break;                        
                    }
                    if (options.status === "clear-content" && prop === "hyperlink") {
                        if (this.getPropertyValue(rowIdx, colIdx, prop, sheetIdx)) {
                            delete sheetData[rowIdx][colIdx][prop]["webAddr"];
                            delete sheetData[rowIdx][colIdx][prop]["cellAddr"];
                        }
                    }
                    else
                        delete sheetData[rowIdx][colIdx][prop];
					if(prop === 'wrap' && cell){
						mergeWrap = cell.find('#' + xlObj._id + '_MergeWrap');
                        if(mergeWrap.length){
                            cell[0].innerHTML = mergeWrap[0].innerHTML;
                            mergeWrap.remove();
                        }
					}
					if (canRefresh) {
					    this._refreshCalcEngine(rowIdx, colIdx, false, value);
					    xlObj.model.allowCharts && xlObj.XLChart._refreshChartElements(rowIdx, colIdx, sheetIdx);
					}
                }
				if(canClip)
					xlObj._textClip(rowIdx, colIdx, 'delete');
                if(!xlObj.getObjectLength(sheetData[rowIdx][colIdx]))
                    delete sheetData[rowIdx][colIdx];
                if (!xlObj.getObjectLength(sheetData[rowIdx]))
                    delete sheetData[rowIdx];
            }
        },

        getPropertyValue: function (rowIdx, colIdx, prop, sheetIdx) {
            var value, coldata, val, i, j, ctype, xlObj = this.XLObj, container = xlObj._dataContainer,
                sheets = container.sheets, cellProp = xlObj._cellProp;
            sheetIdx = xlObj._getSheetIndex(sheetIdx);
            if (!xlObj._intrnlUpdate)
                this._refreshContainer(rowIdx, sheetIdx);
            if (sheets[sheetIdx] && sheets[sheetIdx][rowIdx] && sheets[sheetIdx][rowIdx][colIdx]) {
                coldata = sheets[sheetIdx][rowIdx][colIdx];
                if (coldata) {
                    prop = prop || "value";
                    val = coldata[prop];
                    switch (prop) {
                        case "value":
                        case "range":
                        case "thousandSeparator":
                        case "calcValue":
                            value = container.sharedData[val];
                            break;
                        case "format":
                        case "border":
                            value = container.hashCode[val];
                            break;
                        case "value2":
                            ctype = ej.Spreadsheet.CellType;
                            value = (!xlObj.isUndefined(coldata.type) && [ctype.General, ctype.Text].indexOf(container.cellType[coldata.type]) === -1) ? coldata.value2 : container.sharedData[coldata.value2];
                            break;
                        case "type":
                            value = container.cellType[coldata.type];
                            break;
                        case "cFormatRule":
                            i = j = 0;
                            value = [];
                            if (!xlObj.isUndefined(val))
                                j = val.length;
                            while (i < j) {
                                if (coldata[prop][i] in container.cFormatData)
                                    value.push(container.cFormatData[coldata[prop][i]]);
                                i++;
                            }
                            break;
                        case "rule":
                            if (!xlObj.isUndefined(val)) {
                                value = {};
                                $.extend(true, value, val);
                                value.customVal = container.valData[value.customVal];
                            }
                            break;
                        case cellProp[14]:
                        case cellProp[15]:
                        case cellProp[16]:
                        case cellProp[17]:
                            if (!xlObj.isUndefined(val)) {
                                value = container.hashCode[val];
                                value = value.indexOf("e-format") === -1 ? xlObj.XLFormat.getBorderFromHashCode(value, true) : xlObj.XLFormat.getFormatFromHashCode(value);
                            }
                            break;
                        default:
                            value = val;
                    }
                }
            }
            return value;
        },

        _refreshContainer: function (rowIdx, sheetIdx) {
            var blkInfo, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx);
            if (!sheet._isImported && sheet._hasDataSrc) { // data source => data container
                xlObj._intrnlUpdate = true;
                if (xlObj.model.scrollSettings.allowVirtualScrolling) {
                    blkInfo = xlObj._getBlockInfo(rowIdx, sheetIdx, true);
                    if (sheet._virtualDataMngrLoadedBlks.indexOf(blkInfo.orgIdx) === -1) {
                        sheet._virtualDataMngrLoadedBlks.push(blkInfo.orgIdx);
                        this._ensureDataMngr(blkInfo.orgRange, sheetIdx);
                    }
                    if (sheet._virtualDataLoadedBlks.indexOf(blkInfo.orgIdx) === -1) {
                        sheet._virtualDataLoadedBlks.push(blkInfo.orgIdx);
                        xlObj._canOverflow = false;
                        xlObj._refreshDataSrc(blkInfo.orgRange, sheetIdx);
                        xlObj._refreshCellData(blkInfo.orgRange, sheetIdx);
                        xlObj._canOverflow = true;
                        xlObj._refreshOverflow(blkInfo.orgRange);
                    }
                }
                else if (!sheet._isLoaded && !sheet._isDataMoved) {
                    sheet._isDataMoved = true;
                    xlObj._canOverflow = false;
                    xlObj._refreshDataSrc(null, sheetIdx);
                    xlObj._refreshCellData(null, sheetIdx);
                    xlObj._canOverflow = true;
                    xlObj._refreshOverflow();
                }
                xlObj._intrnlUpdate = false;
            }
        },

        _ensureDataMngr: function (range, sheetIdx) {
            var len, k, skip, props, setting, promise, i = 0, xlObj = this.XLObj, settings = xlObj.getDataSettings(sheetIdx), j, queryObj;
            if (settings) {
                j = settings.length;
                while (i < j) {
                    setting = settings[i];
                    if (xlObj._inRow(setting.range, range[0]) && setting._dataManager) {
                        props = this._getQueryPropWithValues(range.slice(0), setting.range);
                        queryObj = ej.pvt.filterQueries(setting.query.queries, "onSkip");
                        skip = props.skip || 0;
                        if (setting._skip)
                            skip += setting._skip;
                        if (skip)
                            if (queryObj.length)
                                queryObj[0]["e"]["nos"] = skip;
                            else
                                setting.query.skip(skip);
                        queryObj = ej.pvt.filterQueries(setting.query.queries, "onTake");
                        if (props.take)
                            if (queryObj.length)
                                queryObj[0]["e"]["nos"] = props.take;
                            else
                                setting.query.take(props.take);
                        setting._dataManager.dataSource.async = false;
                        promise = setting._dataManager.executeQuery(setting.query);
                        promise.done(function (e) {
                            len = e.result.length;
                            if (len) {
                                k = 0;
                                while (k < len) {
                                    setting._jsonData[props.skip + k] = e.result[k];
                                    k++;
                                }
                            }
                        });
                        setting._dataManager.dataSource.async = true;
                    }
                    i++;
                }
            }
        },

        _getQueryPropWithValues: function (crange, arange) {
            var cnt, obj = {}, xlObj = this.XLObj;
            cnt = crange[0] - arange[0];
            obj.skip = cnt;
            if (arange[2] < crange[2])
                crange[2] = arange[2];
            if (xlObj._inRow(arange, crange[2])) {
                cnt = (crange[2] - crange[0]) + 1;
                obj.take = cnt;
            }
            return obj;
        },

        getPropertyValueByElem: function (elem, property, sheetIdx) {
            if (!ej.isNullOrUndefined(elem[0])) {
                var cellIndex;
                if (elem.hasClass("e-hyperlinks"))
                    cellIndex = this.XLObj._getCellIdx(elem.parent()[0]);
                else
                    cellIndex = this.XLObj._getCellIdx(elem[0]);
                return (this.getPropertyValue(cellIndex.rowIndex, cellIndex.colIndex, property, sheetIdx));
            }
        },

        _getPropWithCellIdx: function (range, prop, sheetIdx, formulaOnly) {
            var val, arr = [], minr = range[0], maxr = range[2], minc, maxc = range[3], xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(sheetIdx),
                sheet = xlObj._dataContainer.sheets[sheetIdx];
            while (minr <= maxr) {
                if (sheet[minr]) {
                    minc = range[1];
                    while (minc <= maxc) {
                        if (sheet[minr][minc]) {
                            val = this.getPropertyValue(minr, minc, prop, sheetIdx);
                            if (!xlObj.isUndefined(val)) {
                                if (formulaOnly) {
                                    if (xlObj.isFormula(val))
                                        arr.push({ rowIdx: minr, colIdx: minc, value: val });
                                }
                                else
                                    arr.push({ rowIdx: minr, colIdx: minc, value: val });
                            }
                        }
                        minc++;
                    }
                }
                minr++;
            }
            return arr;
        },

        _refreshCalcEngine: function (rowIdx, colIdx, isFormula, val, sheetIdx) {
            var cellArgs, family, cellRef, xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(sheetIdx),
                sheet = xlObj.getSheet(sheetIdx), calcEngine = xlObj._calcEngine;
            if (isFormula) {
                val = this._parseSheetRef(val);
                cellArgs = new ValueChangedArgs(rowIdx + 1, colIdx + 1, val);
                calcEngine.valueChanged(sheet.sheetInfo.value, cellArgs);
                xlObj._applyFormula(sheetIdx, rowIdx, colIdx);
            }
            else {
                family = CalcEngine.getSheetFamilyItem(sheet.sheetInfo.value);
                cellRef = RangeInfo.getAlphaLabel(colIdx + 1) + (rowIdx + 1);
                if (calcEngine.isSheetMember() && !ej.isNullOrUndefined(family.parentObjectToToken))
                    cellRef = family.parentObjectToToken.getItem(sheet.sheetInfo.value) + cellRef;
                if (calcEngine.getFormulaInfoTable().containsKey(cellRef)) {
                    calcEngine.getFormulaInfoTable().remove(cellRef);
                    if (calcEngine.getDependentCells().contains(cellRef))
                        calcEngine.clearFormulaDependentCells(cellRef);
                }
                calcEngine.refresh(cellRef);
            }
        },

        _parseSheetRef: function (fValue, isNMValue) {
            var regx, i = 0, xlObj = this.XLObj, sheetCount = xlObj.model.sheetCount, temp = [], sheetNames = [], sheetInfo = xlObj._getSheetNames(), exp = '(?=[\'!])(?=[^"]*(?:"[^"]*"[^"]*)*$)';

            while (i < sheetInfo.length) {
                sheetNames.push(sheetInfo[i].text);
                i++;
            }

            for (i = 0; i < sheetCount; i++) {
                if (sheetInfo[i].value !== sheetInfo[i].text) {
                    regx = new RegExp(sheetInfo[i].text + exp, 'gi');
                    if (fValue.match(regx)) {
                        fValue = fValue.replace(regx, i + "/");
                        temp.push(i);
                    }
                    if (sheetNames.indexOf(sheetInfo[i].value) < 0 && fValue.indexOf(sheetInfo[i].value) > -1 && !isNMValue) {
                        regx = new RegExp(sheetInfo[i].value + exp, 'gi');
                        if (fValue.match(regx)) {
                            fValue = fValue.replace(regx, xlObj._newSIndex + "/");
                            temp.push(xlObj._newSIndex);
                        }
                    }
                }
            }

            i = 0;

            while (i < temp.length) {
                regx = new RegExp(temp[i] + "/" + exp, 'gi');
                fValue = fValue.replace(regx, temp[i] === xlObj._newSIndex ? xlObj._generateSheetName(xlObj._newSIndex) : sheetInfo[temp[i]].value);
                i++;
            }
            return fValue;
        },

        _refreshTextNode: function (td, value) {
            var xlObj = this.XLObj;
            value = ej.isNullOrUndefined(value) ? "" : value;
            if (!xlObj.isUndefined(td)) {
                var node = td.lastChild;
                if (node && (node.nodeType === 3 || (node.nodeType === 1 && node.tagName === "A")))
                    (xlObj._browserDetails.name === "msie" && xlObj._browserDetails.version === "8.0") ? (node.nodeValue = value) : (node.textContent = value);
                else
                    td.appendChild(document.createTextNode(value));
            }
        },

        _formulaSelect: function (args) {
            var text = value = args.text;
            if (!this.XLEdit._isNamedRange(value) && !(text.slice(1) == "TRUE" || text.slice(1) == "FALSE"))
                text += "(";
            this.XLEdit._editElem.text(text);
            if (this.model.allowFormulaBar)
                this._getInputBox().val(text);
            this.XLEdit._editElem.focusEnd();
            this._isFormulaSuggestion = false;
            this.XLCellNav._canKeyBoardNavigate = false;
        },

        _isNamedRange: function(value) {
            var nameMngr = this.XLObj.model.nameManager, i = nameMngr.length;
            value = value.slice(1);
            if (i) {
                while (i--) {
                    if (nameMngr[i].name.toUpperCase() === value.toUpperCase())
                        return true;
                }
            }
            return false;
        },

        _formulaBoxInputChange: function (e) {
            var sheetIdx = this.getActiveSheetIndex(), acell = this.getSheet(sheetIdx)._activeCell;
            var ielem = this.element.find("#"+this._id+"_Edit");
            this.XLEdit._isFormulaEdit = !e.target.value.indexOf("=");
            this.XLEdit._isFormulaEdit && this.XLEdit._processFormulaEditRange(e.target.value, true);
            if (!this.XLEdit._isEdit) {
                this.XLCellNav._navToCell(acell.rowIndex, acell.colIndex);
                this.XLEdit.editCell(acell.rowIndex, acell.colIndex, true);
                ielem = this.element.find("#" + this._id + "_Edit");
            }
            ielem.text(e.target.value);
            e.target.focus();
            this.XLEdit._isCellEdit = false;
        },

        _formulaSuggestionStatus: function (args) {
            this._isFormulaSuggestion = args.type === "open";
        },

        _updateFormulaCellRange: function (val, ctrlKey) {
            var idx, xlObj = this.XLObj, ielem = xlObj.element.find("#" + xlObj._id + "_Edit").not(":hidden"),
               otext = ielem.text(), lastChar = otext[otext.length - 1];
            if (ctrlKey && this._validCharacters.indexOf(lastChar) === -1)
                otext = otext + ",";
            else {
                idx = this._getCharPosition(otext);
                if (idx > -1)
                    otext = otext.substr(0, [idx + 1]);
            }
            val = otext + val;
            ielem.text(val);
            this._editElem.focusEnd();
            if(xlObj.model.allowFormulaBar)
            xlObj._getInputBox().val(val);
        },

        _getCharPosition: function (val) {
            var len = val.length;
            while (len--) {
                if (this._validCharacters.indexOf(val[len]) > -1)
                    return len;
            }
            return -1;
        },

        _processFormulaEditRange: function (val, isInputBox) {
            var str, lastChar, i = 0, xlObj = this.XLObj, parsedVal = xlObj.XLDragFill._parseFormula(val), len = parsedVal.length;
            xlObj._ctrlKeyCount = 0;
            xlObj._formulaRange = [];
            xlObj.XLSelection._clearBorder(xlObj._arrayAsString(xlObj._ctrlFormulaBorder.concat(xlObj._formulaBorder)));
            while (i < len) {
                str = parsedVal[i];
                if (this._invalidOperators.indexOf(str) > -1)
                    break;
                if (xlObj._isCellReference(str)) {
                    str = str.replace(/\$/g, "");
                    if (parsedVal[i + 1] === ":") {
                        i++;
                        if (xlObj._isCellReference(parsedVal[i + 1])) {
                            str = str + ":" + parsedVal[i + 1];
                            i++;
                        }
                    }
                    this._updateFormulaEditRange(str, xlObj._ctrlKeyCount)
                    xlObj._ctrlKeyCount++;
                }
                i++;
            }
            lastChar = val.charAt(val.length - 1);
            if (lastChar === "(" && val.split("(").length === 2) {
                xlObj._isFormulaSuggestion = false;
                if (xlObj.model.allowFormulaBar)
                    xlObj._getInputBox().val(val);
                isInputBox ? $("#" + xlObj._id + "_inputbox_suggestion").hide() : xlObj._getFormulaSuggElem().hide();
            }
            else if (lastChar === ")" && xlObj.isFormula(val)) {
                xlObj.XLEdit._isFormulaEdit = false;
                xlObj._formulaRange = [];
                xlObj._ctrlKeyCount = 0;
            }
            if (lastChar === ":") {
                xlObj._shiftKeyEnabled = true;
                xlObj._ctrlKeyCount--;
            }
            else if (this._validOperators.indexOf(lastChar) > -1) {
                xlObj._dStartCell = xlObj.getSheet(xlObj.getActiveSheetIndex())._activeCell;
                xlObj._shiftKeyEnabled = false;
            }
        },

        _updateFormulaEditRange: function (str, i) {
            var xlObj = this.XLObj, indices = xlObj.getRangeIndices(str);
            xlObj._formulaRange[i] = str;
            xlObj._dStartCell = { rowIndex: indices[0], colIndex: indices[1] };
            xlObj._dEndCell = { rowIndex: indices[2], colIndex: indices[3] };
            xlObj.XLSelection._focusBorder(xlObj._dStartCell, xlObj._dEndCell, xlObj._formulaBorder[i % 6]);
        },

        calcOption: function (isAutomatic) {
            var xlObj = this.XLObj;
			if(xlObj.model.isReadOnly)
			    return;
			var calcObj, range, aIdx = xlObj.getActiveSheetIndex(), i;
            if (isAutomatic) {
                $("#" + xlObj._id + "_CalcAuto").find("span").addClass("e-ss-calcauto");
                $("#" + xlObj._id + "_CalcManual").find("span").removeClass("e-ss-calcauto");
            }
            else {
                $("#" + xlObj._id + "_CalcManual").find("span").addClass("e-ss-calcauto");
                $("#" + xlObj._id + "_CalcAuto").find("span").removeClass("e-ss-calcauto");
            }        
            for (var i = 1, len = xlObj._sheets.length; i < len; i++) {
                calcObj = xlObj._calcEngine;
                if (isAutomatic) {
                    calcObj.setCalculatingSuspended(false);
                    range = xlObj.getSheet(i).usedRange;
                    xlObj.setActiveSheetIndex(i);
                    calcObj.grid = xlObj.model.sheets[i].sheetInfo.value;
                    calcObj.refreshRange(RangeInfo.cells(1, 1, range.rowIndex + 1, range.colIndex + 1));
                }
                else
                    calcObj.setCalculatingSuspended(true);
            }
            xlObj.setActiveSheetIndex(aIdx);
        },

        calcNow: function (sheetIdx) {
            var xlObj = this.XLObj;
			if(xlObj.model.isReadOnly)
			    return;
			var i = 1, calcObj, range, len = xlObj._sheets.length, aIdx = xlObj.getActiveSheetIndex(), details;
            if (sheetIdx) {
                i = sheetIdx;
                len = sheetIdx + 1;
            }
            while (i < len) {
                calcObj = xlObj._calcEngine;
                calcObj.setCalculatingSuspended(false);
                range = xlObj.getSheet(i).usedRange;
                xlObj.setActiveSheetIndex(i);
                calcObj.grid = xlObj.model.sheets[i].sheetInfo.value;
                calcObj.refreshRange(RangeInfo.cells(1, 1, range.rowIndex + 1, range.colIndex + 1));
                calcObj.setCalculatingSuspended(true);
                i++;
            }
            xlObj.setActiveSheetIndex(aIdx);
            details = { sheetIndex: aIdx, reqType: "calc-now" };
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },

        _rangeHasProperty: function (range, property, rDataColl) {
            if (range)
                rDataColl = this.XLObj.getRangeData({ range: range, property: [property] });
            var i = 0, len = rDataColl.length;
            while (i < len) {
                if (!this.XLObj.isUndefined(rDataColl[i][property]))
                    return true;
                i++;
            }
        },

        saveEditingValue: function () {
        var xlObj = this.XLObj;
		if(xlObj.model.isReadOnly)
		    return;
		var i, j, sheet, sheetCln, rowIdx, colIdx, len, value, rowCln, editedValue = [], sheets = {}, colCln, rLen, cLen, container = xlObj._dataContainer, sheetIdx;
        sheetCln = Object.getOwnPropertyNames(container.sheets);
        sheets["EditedData"] = [];
        for (sheet = 0, len = sheetCln.length; sheet < len; sheet++) {
            conSheet = container.sheets[sheetCln[sheet]];
            rowCln = Object.getOwnPropertyNames(conSheet);
            for (i = 0, rLen = rowCln.length; i < rLen; i++) {
                rowIdx = parseInt(rowCln[i]);
                colCln = Object.getOwnPropertyNames(conSheet[rowIdx]);
                for (j = 0, cLen = colCln.length; j < cLen; j++) {
                    colIdx = parseInt(colCln[j]);
                    if (conSheet[rowIdx][colIdx]["isDirty"]) {
                        sheetIdx = parseInt(sheetCln[sheet]);
                        value = { "SheetIndex": sheetIdx, "Value": this.getPropertyValue(rowIdx, colIdx, "value2", sheetIdx), "CellIndex": { "RowIndex": rowIdx, "ColIndex": colIdx } };
                        delete conSheet[rowIdx][colIdx]["isDirty"];
                        sheets["EditedData"].push(value);
                    }
                }
            }
        }
        return sheets;
    }

       };

    $.fn.focusEnd = function () {  
        $(this).focus();
        var tmp = $('<span />').appendTo($(this)),
            node = tmp.get(0),
            range = null,
            sel = null;
        if (document.selection) {
            range = document.body.createTextRange();
            range.moveToElementText(node);
            range.select();
        } else if (window.getSelection) {
            var ele = this[0];
            range = document.createRange();
            sel = window.getSelection();
            range.setStart(ele, 1);
            range.collapse(true);
            sel.removeAllRanges();
            sel.addRange(range);
            ele.focus();
        }
        tmp.remove();
        return this;
    }

    $.fn.altEnter = function () {      
            var sel, node, offset, text, textBefore, textAfter, range;
            sel = window.getSelection();
            node = sel.anchorNode;
            offset = sel.anchorOffset;
            text = node.textContent;
            textBefore = text.slice(0, offset);
            textAfter = text.slice(offset) || ' ';
            node.textContent = textBefore + '\n' + textAfter;
            range = document.createRange();
            range.setStart(node, offset + 1);
            range.setEnd(node, offset + 1);
            sel.removeAllRanges();
            sel.addRange(range);               
    }

    $.fn.setCursorPosition = function (position) {
        var node = this;
        node.focus();
        var textNode = node[0].firstChild, range = document.createRange(), sel;
        if(textNode){
			range.setStart(textNode, position);
			range.setEnd(textNode, position);
		}
        sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
    }
   

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.validation = function (obj) {
        this.XLObj = obj;
        this._ruleSymbols = { "Greater": ">", "GreaterOrEqual": ">=", "Less": "<", "LessOrEqual": "<=", "Equal": "==", "NotEqual": "!=", "Between": ">=&&<=&&=", "NotBetween": ">=&&<=&&!" };
        this._isErrorVisible = false;
    };

    ej.spreadsheetFeatures.validation.prototype = {
        //Validation
        _setValidation: function () {
            if (!this.XLObj.model.allowDataValidation || !$.validator)
                return;
            this._initValidator();
            this._setValidationToField();
        },

        _initValidator: function () {
            var elem = $("#" + this.XLObj._id + "EditForm");
            if (ej.isOnWebForms)
                $.data(elem[0], "validator", null);
            elem.validate({
                errorClass: "e-field-validation-error",
                errorElement: "div",
                wrapper: "div",
                errorPlacement: function (error, ele) {
                    var xlObj = $("#" + $(ele).data("id")).data("ejSpreadsheet"), $content = xlObj._getJSSheetContent(xlObj.getActiveSheetIndex()).find(".e-spreadsheetcontentcontainer > .e-content");
                    var $td = xlObj.XLEdit._editCell, $container = $(error).addClass("e-error");                   
                    $content.append($container);
                    $container.prepend(ej.buildTag("div.e-errortail e-toparrow"));
                    $container.css({ left: $td[0].offsetLeft, top: $td[0].offsetTop + $td.height() });
                    xlObj.XLValidate._isErrorVisible = true;
                }
            });
        },

        _setValidationToField: function () {
            var xlObj = this.XLObj, rules = xlObj.XLEdit.getPropertyValueByElem(xlObj.getActiveCellElem(), "rule");
            delete rules.type;
            delete rules.isApply;
			delete rules.isHighlight;
            xlObj.element.find("#" + xlObj._id + "_ValElem").rules("add", rules);
            var validator = xlObj.element.find("#" + xlObj._id + "EditForm").validate();
            if (!ej.isNullOrUndefined(rules.required)) {
                validator.settings.messages[name] = {};
                validator.settings.messages[name].required = xlObj.XLEdit._EditCellDetails.fieldName + (xlObj.XLEdit._EditCellDetails.rowIndex + 1) + " is required";
            }
            xlObj.XLEdit._isValidation = true;
        },

        applyDVRules: function (range, values, type, required, showErrorAlert) {
            var details, $trgt, dlgHt, len, evtArgs, rule = {}, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), isHLight = false, rng, selected, detailVal;
            switch (type) {
                case "decimal":
                    if (parseFloat(values[1]) > parseFloat(values[2])) {
                        xlObj._showAlertDlg("Alert", "NumberValidationAlert", "", 400);
                        return;
                    }
                    break;
                case "date":
                    if(new Date(values[1]) > new Date(values[2])) {
                        xlObj._showAlertDlg("Alert", "DateValidationAlert", "", 400);
                        return;
                    }
                    break;
                case "time":
                    var time1 = Date.parse("01/01/1990 " + values[1]), time2 = Date.parse("01/01/1990 " + values[2]);
                    if (values[2] && values[2].length && time1 > time2) {
                        xlObj._showAlertDlg("Alert", "TimeValidationAlert", "", 400);
                        return;
                    }
                    break;
                default:
                    if (parseInt(values[1]) > parseInt(values[2])) {
                        xlObj._showAlertDlg("Alert", "NumberValidationAlert", "", 400);
                        return;
                    }
                    break;
            }
			if (xlObj.model.isReadOnly || !xlObj.model.allowDataValidation || (!xlObj.model.allowSelection && ej.isNullOrUndefined(range)))
			    return;
			rng = xlObj._getRangeArgs(range, "object");
			selected = xlObj._getSelectedCells(sheetIdx, rng).selCells;
			xlObj._showDialog(xlObj._id + "_Ribbon_Data_DataTools_DataValidation");
            rule.required = !required;
			if ((values[0] != "Between" || values[0] != "NotBetween") && values.length < 3)                 
                values.push("");                            
            switch (type) {
                case "number":
                    values.push("parseInt");
                    rule.digits = true;
                    values.push("number");
                    break;
                case "decimal":
                    values.push("parseFloat");
                    rule.number = true;
                    values.push("decimal");
                    break;
                case "date":
                    values.push("parseDate");
                    rule.date = true;
                    values.push("date");
                    break;
                case "time":
                    values.push("parseTime");
                    values.push("time");
                    break;
                case "text":
                    values[1] = "^" + values[1];
                    values[2] = "^" + values[2];
                    values.push("length");
                    values.push("text");
                    break;
                case "list":
                    var dataSrc = values[1];
                    values = [];
                    values.push(dataSrc);
                    values.push("list");
                    break;
            }
            values.push(showErrorAlert);
            values.push(range ? range : xlObj._getSelectedItems(sheetIdx, range)[1]);
            values.push(sheetIdx);
            rule.customVal = values.join("_");
            rule.isApply = false;
            rule.type = type;
            var selCells = [], cell = {}, cellObj;
            for (var i = 0, len = selected.length; i < len; i++) {
                cell = { rowIndex: selected[i].rowIndex, colIndex: selected[i].colIndex, prevRule: xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "rule") };
                if(xlObj._isRowViewable(sheetIdx, selected[i].rowIndex)) {
                    $trgt = xlObj.getCell(selected[i].rowIndex, selected[i].colIndex);
                    $trgt.hasClass("e-hlcell") && (isHLight = true);
                    $trgt.removeData("rule");
                    $trgt.removeClass("e-hlcell");
                }         
                xlObj.XLEdit._updateDataContainer({ rowIndex: selected[i].rowIndex, colIndex: selected[i].colIndex }, { dataObj: { "rule": rule } });
                if (xlObj.model.actionComplete !== null)
                    cell["newRule"] = xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "rule");
                selCells.push(cell);
            }
            if (isHLight === true)
                this.highlightInvalidData();
            if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && !xlObj._isExport) {
                detailVal = (values[2] == "") ? ([values[0], values[1]]) : ([values[0], values[1], values[2]])
                details = { showErrorAlert: values[5], values: detailVal, required: !rule.required, rule: rule, sheetIndex: sheetIdx, reqType: "validation", operation: "apply-validation", selectedCell: selCells, range: xlObj._getAlphaRange(sheetIdx, selected[0].rowIndex, selected[0].colIndex, selected[selected.length - 1].rowIndex, selected[selected.length - 1].colIndex) };
                evtArgs = { showErrorAlert: details.showErrorAlert, values: details.values, isRequired: details.required, rule: details.rule, sheetIndex: details.sheetIndex, reqType: details.reqType, operation: details.operation, selectedCell: details.selectedCell, range: details.range };
                xlObj._completeAction(details);
                xlObj._trigActionComplete(evtArgs);
            }
        },

        clearDV: function (range) {
            var xlObj = this.XLObj, selected;
            if(!xlObj.model.allowDataValidation || xlObj.model.isReadOnly || !xlObj.model.allowSelection)
				return;
            var $trgt, selectedCells, rng, sheetIdx = xlObj.getActiveSheetIndex(), details = { sheetIndex: sheetIdx, reqType: "validation", operation: "clear-validation", selectedCell: [] };
            rng = xlObj._getRangeArgs(range, "object");
            selectedCells = xlObj._getSelectedCells(sheetIdx, rng).selCells;
            for (var i = 0, len = selectedCells.length; i < len; i++) {
                details.selectedCell.push({ rowIndex: selectedCells[i].rowIndex, colIndex: selectedCells[i].colIndex, rules: xlObj.XLEdit.getPropertyValue(selectedCells[i].rowIndex , selectedCells[i].colIndex, "rule") });
                xlObj.clearRangeData([selectedCells[i].rowIndex, selectedCells[i].colIndex, selectedCells[i].rowIndex, selectedCells[i].colIndex], ["rule"]);
                if (xlObj._isRowViewable(sheetIdx, selectedCells[i].rowIndex)) {
                    $trgt = xlObj.getCell(selectedCells[i].rowIndex, selectedCells[i].colIndex);
					if (!ej.isNullOrUndefined(xlObj._ddlCell)) {
                        xlObj.element.find("#" + xlObj._id + "ddl").ejDropDownList("hidePopup");
                        xlObj.element.find("#" + xlObj._id + "ddlspan").remove();
                        xlObj._ddlCell = null;
                    }
					details.hlStatus = $trgt.hasClass("e-hlcell");
                    $trgt.removeClass("e-hlcell");
                }
            }
			details.range = xlObj._getAlphaRange(sheetIdx, selectedCells[0].rowIndex, selectedCells[0].colIndex, selectedCells[selectedCells.length - 1].rowIndex, selectedCells[selectedCells.length - 1].colIndex);
			if (!xlObj._isUndoRedo && !xlObj._dupDetails)
			{
			    xlObj._completeAction(details);
			    xlObj._trigActionComplete(details);
			}
        },

        clearHighlightedValData: function (range) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowDataValidation || xlObj.model.isReadOnly)
                return;
            var selected, rng, trgt, sheetIdx = xlObj.getActiveSheetIndex();
            rng = xlObj._getRangeArgs(range, "object");
            selected = xlObj._getSelectedCells(sheetIdx, rng).selCells;
            for (var i = 0, len = selected.length; i < len; i++) {
                if (xlObj._isRowViewable(sheetIdx, selected[i].rowIndex)) {
                    trgt = xlObj.getCell(selected[i].rowIndex, selected[i].colIndex);
                    trgt.removeClass("e-hlcell");
                }
               if (!ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "rule")))
                    xlObj._dataContainer.sheets[sheetIdx][selected[i].rowIndex][selected[i].colIndex].rule.isApply = false;
            }
            if (!xlObj._isUndoRedo) {
                var details = { sheetIndex: sheetIdx, reqType: "validation", operation: "cl-hl-data", range: (ej.isNullOrUndefined(range)) ? this.XLObj._getAlphaRange(1, selected[0].rowIndex, selected[0].colIndex, selected[selected.length - 1].rowIndex, selected[selected.length - 1].colIndex) : range };
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _checkValidation: function (value, params, isHighlight, sheetIdx) {
            var xlObj = this.XLObj, len, listVal, cellAddr;
            sheetIdx = xlObj._getSheetIndex(sheetIdx);
            if (!JSON.parse(params[params.length - 3]) && !isHighlight)
                return true;
            value = this._convertValueByType(value, params[4]);
            params[1] = this._convertValueByType(params[1], params[4]);
            params[2] = this._convertValueByType(params[2], params[4]);
            if (value.length) {
                if (params[params.length - 4] === "list") {
                    var i, isMatch = false;
                    if (params[0].indexOf(",") > -1)
                        listVal = params[0].split(",");
                    else if (params[0].indexOf("=") > -1) {
                        cellAddr = params[0].split("=")[1];
                        if(cellAddr.indexOf('!') > -1)
							listVal = (cellAddr.split('!')[1].indexOf('$') > -1) ? xlObj.getRangeData({ sheetIdx: sheetIdx, range: xlObj.getRangeIndices(cellAddr.split('!')[1].split('$').join("")), valueOnly: true }) : (cellAddr.indexOf('$') > -1) ? xlObj.getRangeData({ sheetIdx: sheetIdx, range: xlObj.getRangeIndices(cellAddr.split('$').join("")), valueOnly: true }) : xlObj.getRangeData({ sheetIdx: sheetIdx, range: xlObj.getRangeIndices(cellAddr.split('!')[1]), valueOnly: true });
						else
							listVal = xlObj.getRangeData({ sheetIdx: sheetIdx, range: xlObj.getRangeIndices(cellAddr), valueOnly: true });
                    }
                    else
                        listVal = value;
                    for (i = 0, len = listVal.length; i < len; i++) {
                        isMatch = listVal[i].toString() === value;
                        if (isMatch)
                            break;
                    }
                    ej.Spreadsheet.msg = xlObj._getLocStr("ListAlertMsg");
                    return isMatch;
                }
                else {
                    var val, range;
                    params[0] = this._ruleSymbols[params[0]];
                    if (params[1].indexOf("=") > -1) {
                        val = params[1].replace("=", "");
                        range = this.getRangeIndices(val + ":" + val);
                        params[1] = xlObj.XLEdit.getPropertyValue(range[0], range[1], null, sheetIdx).toString();
                    }
                    if (params[2].indexOf("=") > -1) {
                        val = params[2].replace("=", "");
                        range = this.getRangeIndices(val + ":" + val);
                        params[2] = xlObj.XLEdit.getPropertyValue(range[0], range[1], null, sheetIdx).toString();
                    }
                    if (params[0].length <= 2) {
                        ej.Spreadsheet.msg = "The " + params[4] + " should be " + ej.Spreadsheet.ValidationText[params[0]] + " " + params[1].replace("^", "");
                        return xlObj.operators[params[0]](xlObj.parse[params[3]](value), xlObj.parse[params[3]](params[1]));
                    }
                    else {
                        var op = [];
                        op = params[0].split("&&");
                        ej.Spreadsheet.msg = "The " + params[4] + " should" + ej.Spreadsheet.ValidationText[op[2]] + " be between" + " " + params[1].replace("^", "") + " and " + params[2].replace("^", "");
                        return xlObj.operators[op[2]]((xlObj.operators[op[0]](xlObj.parse[params[3]](value), xlObj.parse[params[3]](params[1])) && xlObj.operators[op[1]](xlObj.parse[params[3]](value), xlObj.parse[params[3]](params[2]))));
                    }
                }
            }
            else
                return true;
        },

        _convertValueByType: function (value, type) {
            if (value.length) {
                var xlObj = this.XLObj;
                switch (type) {
                    case "number":
                    case "decimal":
                        if (xlObj._isValidDate(value))
                            value = xlObj._dateToInt(value);
                        break;
                    case "date":
                        if ($.isNumeric(value))
                            value = xlObj.intToDate(value).toString();
                        break;
                }
            }
            return value;
        },

        highlightInvalidData: function (range) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowDataValidation || xlObj.model.isReadOnly)
				return;
            var len, value, selected, cell, isApply, i, rng, sheetIdx = xlObj.getActiveSheetIndex(), rule;
            rng = xlObj._getRangeArgs(range, "object");
            selected = xlObj._getSelectedCells(sheetIdx, rng).selCells;
            range = xlObj._getAlphaRange(sheetIdx, rng[0], rng[1], rng[2], rng[3]);
            for (i = 0, len = selected.length; i < len; i++) {
                rule = xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "rule", sheetIdx);
				if (!rule)
                    continue;
				if (xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, null, sheetIdx) && !ej.isNullOrUndefined(rule)) {
				    value = (xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "type", sheetIdx) === "datetime" || xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "type", sheetIdx) === "time") ? xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, "value2", sheetIdx).toString() : xlObj.XLEdit.getPropertyValue(selected[i].rowIndex, selected[i].colIndex, null, sheetIdx).toString();
                    isApply = rule ? !(this._checkValidation(value, rule.customVal.split("_"), true, sheetIdx)) : false;
                    xlObj._dataContainer.sheets[sheetIdx][selected[i].rowIndex][selected[i].colIndex].rule.isApply = isApply;
                }
                else if (!ej.isNullOrUndefined(rule))
                    isApply = rule.required;
                if(xlObj._isRowViewable(sheetIdx, selected[i].rowIndex)){
                    cell = xlObj.getCell(selected[i].rowIndex, selected[i].colIndex, sheetIdx);
                    if (isApply)
                        cell.addClass("e-hlcell");
                    else
                        cell.removeClass("e-hlcell");
                }
				xlObj.XLEdit._updateDataContainer({ rowIndex: selected[i].rowIndex, colIndex: selected[i].colIndex }, { dataObj: { isHighlight: true }, sheetIdx: sheetIdx });
            }
            if (!xlObj._isUndoRedo) {
                var details = { sheetIndex: sheetIdx, reqType: "validation", operation: "hl-data", range: range };
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _replaceRule: function (idx, newRule, range) {
            // replace the rules in shared data
            this.XLObj._dataContainer.cFormatData[idx] = newRule;
        },
		
		 _addDVMethod: function(){
            !ej.isNullOrUndefined($.validator) && $.validator.addMethod("customVal", function (value, elem, params) {        
                var xlObj = $("#" + $(elem).data("id")).data("ejSpreadsheet"), $content = xlObj._getJSSheetContent(xlObj.getActiveSheetIndex()).find(".e-spreadsheetcontentcontainer > .e-content");
                $content.find(".e-error").remove();
                if (xlObj.model.showRibbon && $("#" + xlObj._id + "_Ribbon_freetext").length && !$("#" + xlObj._id + "_Ribbon_freetext").data("ejCheckBox").isChecked())
                    return true;
                return xlObj.XLValidate._checkValidation(value, params.split("_"));
            }, ej.Spreadsheet.getMsg);
        }			
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.dragFill = function (obj) {
        this.XLObj = obj;
        this._customList = [
            ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
            ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
            ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
            ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
        ];
        this._property = ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink", "format", "rule"];
        this._fillInfo = null;
        this._verticalFill = false;
        this._uniqueOBracket = String.fromCharCode(129);
        this._uniqueCBracket = String.fromCharCode(130);
        this._uniqueCSeparator = String.fromCharCode(131);
        this._uniqueCOperator = String.fromCharCode(132);
        this._uniquePOperator = String.fromCharCode(133);
        this._uniqueSOperator = String.fromCharCode(134);
        this._uniqueMOperator = String.fromCharCode(135);
        this._uniqueDOperator = String.fromCharCode(136);
        this._uniqueModOperator = String.fromCharCode(137);
        this._uniqueConcateOperator = String.fromCharCode(138);
    };

    ej.spreadsheetFeatures.dragFill.prototype = {
        positionAutoFillElement: function (isdragfill) {
            var mergeIdx, rowIdx, colIdx, cellInfo, hdrInfo, sheetIdx, sheet, top = 0, left = 0,
                tdiff = 0, ldiff = 0, otdiff = 0, oldiff = 0, xlObj = this.XLObj, hide = "e-hide";
            if (!xlObj.model.allowAutoFill || !xlObj.model.allowSelection)
                return;
            sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            if (sheet._isRowSelected) {
                tdiff = -3;
                ldiff = -1;
                otdiff = 5;
                oldiff = 4;
                rowIdx = sheet.selectedRange[2];
                colIdx = sheet.selectedRange[1];
                left = xlObj._isFrozen(sheet.frozenColumns) ? xlObj._getContent(sheetIdx).find(".e-content").scrollLeft() : sheet._scrollLeft;
            }
            else if (sheet._isColSelected) {
                ldiff = -3;
                oldiff = 5;
                rowIdx = sheet.selectedRange[0];
                colIdx = sheet.selectedRange[3];
                top = xlObj._isFrozen(sheet.frozenRows) ? xlObj._getContent(sheetIdx).find(".e-content").scrollTop() : sheet._scrollTop;
            }
            else if (sheet._isSheetSelected) {
                this.hideAutoFillElement();
                return;
            }
            else {
                tdiff = -3;
                ldiff = -3;
                otdiff = 1;
                oldiff = 3;
                rowIdx = sheet.selectedRange[2];
                colIdx = sheet.selectedRange[3];
            }
            mergeIdx = xlObj._getMergedIdx(rowIdx, colIdx);
            rowIdx = mergeIdx.rowIndex;
            colIdx = mergeIdx.colIndex;
            cellInfo = xlObj._getCellInfo({ rowIndex: rowIdx, colIndex: colIdx });
            if (!sheet._isColSelected)
                top += cellInfo.height;
            if (!sheet._isRowSelected)
                left += cellInfo.width;
            top += cellInfo.top;
            left += cellInfo.left;
            xlObj.getAutoFillElem() && xlObj.getAutoFillElem().removeClass(hide).css({top: Math.round(top) + tdiff, left: Math.round(left) + ldiff });
            if (xlObj.model.autoFillSettings.showFillOptions && isdragfill && xlObj.model.allowEditing && !xlObj.model.isReadOnly)
                xlObj._getAutoFillOptElem().removeClass(hide).css({ top: top + otdiff, left: left + oldiff });
            sheet._autoFillCell = xlObj._dautoFillCell = { rowIndex: rowIdx, colIndex: colIdx };
        },

        hideAutoFillElement: function () {
            var elem = this.XLObj.getAutoFillElem();
            if (elem)
                elem.addClass("e-hide");
        },

        hideAutoFillOptions: function () {
            var elem = this.XLObj._getAutoFillOptElem();
            if (elem) {
                elem.find("button").data("ejSplitButton")._hidePopup();
                elem.addClass("e-hide");
            }
        },

        autoFill: function (options) {
            var xlObj = this.XLObj;
            options = options || {};
            if (!xlObj.model.allowAutoFill || !options.dataRange || !options.fillRange || !options.direction || !xlObj.model.allowEditing || xlObj.model.isReadOnly)
                return;
            var details, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), aOpt = ej.Spreadsheet.AutoFillOptions;
            this._fillInfo = this._getFillInfo(options);
            options.fillType = options.fillType || this._fillInfo.fillType;
            this._verticalFill = (options.direction === "down" || options.direction === "up");
            options.sheetIdx = sheetIdx;
			options.dataRange = xlObj._toIntrnlRange(options.dataRange, sheetIdx);
            options.fillRange = xlObj._toIntrnlRange(options.fillRange, sheetIdx);
            details = { sheetIndex: options.sheetIdx, reqType: "auto-fill", direction: options.direction, range: options.fillRange, bRange: options.dataRange, bData: xlObj.getRangeData({ range: options.fillRange }), bFormat: xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(options.fillRange) };
            details.rowSel = sheet._isRowSelected;
            details.colSel = sheet._isColSelected;
            if (xlObj._trigger("autoFillBegin", options))
                return;
            switch (options.fillType) {
                case aOpt.FillSeries:
                case aOpt.FillWithoutFormatting:
                    this._fillSeries(options);
                    break;
                case aOpt.CopyCells:
                case aOpt.FillFormattingOnly:
                    this._copyCells(options);
                    break;
                case aOpt.FlashFill:
                    details.actionType = "flash-fill";
                    details.bdData = xlObj.getRangeData({ range: options.dataRange });
                    this._flashFill(options);
                    details.adData = xlObj.getRangeData({ range: options.dataRange });
                    break;
            }
            details.aData = xlObj.getRangeData({ range: options.fillRange });
            if (xlObj.model.allowCellFormatting)
                details.aFormat = xlObj.XLFormat.getHashCodeClassAsArray(options.fillRange);
            if (!options.isKeyFill)
                this.positionAutoFillElement(true);
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
            xlObj._trigger("autoFillComplete", options);
        },

		_updateFillValues: function(isVFill, dminr, dminc, dmaxr, dmaxc, fminr, fminc, fmaxr, fmaxc, i) {
		    var pStart, pEnd, fStart, fEnd, patrnRange, fillRange;
			if (isVFill) {
				pStart = { rowIndex: dminr, colIndex: dminc + i };
                pEnd = { rowIndex: dmaxr, colIndex: dminc + i };
                fStart = { rowIndex: fminr, colIndex: fminc + i };
                fEnd = { rowIndex: fmaxr, colIndex: fminc + i };
            }
            else {
                pStart = { rowIndex: dminr + i, colIndex: dminc };
                pEnd = { rowIndex: dminr + i, colIndex: dmaxc };
                fStart = { rowIndex: fminr + i, colIndex: fminc };
                fEnd = { rowIndex: fminr + i, colIndex: fmaxc };
            }
			patrnRange = [pStart.rowIndex, pStart.colIndex, pEnd.rowIndex, pEnd.colIndex];
            fillRange = [fStart.rowIndex, fStart.colIndex, fEnd.rowIndex, fEnd.colIndex];
			return {patrnRange : patrnRange, fillRange: fillRange};
		},
		
        _fillSeries: function (options) {
            var val, plen, patterns, patrn, pRanges, patrnRange, fillRange, formatObj, linkData, data, temp, dlen, j, k, l, tlen, tot, hasRef, format, formats,
                cells, clen, cellIdx, cellProps, i = 0, dataObj = {}, xlObj = this.XLObj, pos = ej.Spreadsheet.autoFillDirection, ctype = ej.Spreadsheet.CellType,
                dminr = options.dataRange[0], dminc = options.dataRange[1], dmaxr = options.dataRange[2], dmaxc = options.dataRange[3],
                fminr = options.fillRange[0], fminc = options.fillRange[1], fmaxr = options.fillRange[2], fmaxc = options.fillRange[3],
                isVFill = [pos.Down, pos.Up].indexOf(options.direction) > -1, isRFill = [pos.Up, pos.Left].indexOf(options.direction) > -1,
                len = isVFill ? dmaxc - dminc : dmaxr - dminr, withFrmt = options.fillType === ej.Spreadsheet.AutoFillOptions.FillSeries;
            while (i <= len) {
				pRanges = this._updateFillValues(isVFill, dminr, dminc, dmaxr, dmaxc, fminr, fminc, fmaxr, fmaxc, i);
				patrnRange = pRanges.patrnRange;
				fillRange = pRanges.fillRange;
                patterns = this._getPattern(patrnRange, { isRFill: isRFill, isVFill: isVFill });
                data = xlObj.getRangeData({ range: patrnRange, property: ["hyperlink", "rule", "cFormatRule", "type", "formatStr", "decimalPlaces", "wrap"] });
                dlen = data.length;
                if (!patterns)
                    return;
                plen = patterns.length;
                xlObj.clearRangeData(fillRange, [withFrmt ? "formatStr" : null, "hyperlink", withFrmt ? "cFormatRule" : null, "rule"]);
                if (withFrmt) {
                    if (xlObj.model.allowCellFormatting)
                        xlObj.XLFormat.removeStyle(fillRange);
                    format = xlObj.getRangeData({ range: patrnRange, property: ["format", "formats"] });
                }
                cells = xlObj._getSelectedRange({ rowIndex: fillRange[0], colIndex: fillRange[1] }, { rowIndex: fillRange[2], colIndex: fillRange[3] });
                clen = cells.length;
                if (isRFill) {
                    cells = cells.reverse();
                    patterns = patterns.reverse();
                    patterns = this._ensurePattern(patterns);
                    data = data.reverse();
                    if (withFrmt)
                        format = format.reverse();
                }
                j = 0;
                while (j < clen) {
                    dataObj = {};
                    cellIdx = cells[j];
                    patrn = patterns[j % plen];
                    if (xlObj.isNumber(patrn))
                        patrn = patterns[patrn];
                    switch (patrn.type) {
                        case ctype.Number:
                            val = xlObj._round(patrn.regVal.a + (patrn.regVal.b * patrn.i), 5);
                            if (isRFill)
                                patrn.i--;
                            else
                                patrn.i++;
                            break;
                        case ctype.String:
                            val = patrn.val[patrn.i % patrn.val.length];
                            patrn.i++;
                            break;
                        case ctype.Formula:
                            hasRef = false;
                            val = "=";
                            k = 0;
                            tlen = patrn.val.length;
                            while (k < tlen) {
                                temp = patrn.val[k];
                                if (xlObj._isObject(temp)) {
                                    hasRef = true;
                                    tot = xlObj._round(temp.a + (temp.b * patrn.i), 0);
                                    if (tot < 1)
                                        val += "#REF!";
                                    else
                                        val += isVFill ? temp.c + (temp.b ? tot : '$' + tot) : (temp.b ? xlObj._generateHeaderText(tot) : '$' + xlObj._generateHeaderText(tot)) + temp.c;
                                }
                                else
                                    val += temp;
                                k++;
                            }
                            if (hasRef && isRFill)
                                patrn.i--;
                            else
                                patrn.i++;
                            break;
                        case ctype.Custom:
                            val = xlObj._round(patrn.regVal.a + (patrn.regVal.b * patrn.i), 0);
                            if (val < 0)
                                val = (val % patrn.len) + patrn.len;
                            if (val >= patrn.len)
                                val = val % patrn.len;
                            val = patrn.val[val];
                            if (isRFill)
                                patrn.i--;
                            else
                                patrn.i++;
                            break;
                    }
                    l = j % dlen;
                    cellProps = data[l];
                    xlObj._dupDetails = true;
                    xlObj.XLEdit.updateCellValue(cellIdx, val, withFrmt ? format[l].format : null);
                    xlObj._dupDetails = false;
                    if (withFrmt) {
                        if (xlObj.model.allowCellFormatting && (cellProps.type && cellProps.type != "general"))
                            this._updateNFormat(cellProps, cellIdx.rowIndex, cellIdx.colIndex);
                        if (xlObj.model.allowConditionalFormats && cellProps.cFormatRule)
                            this._updateCFormat(cellIdx, cellProps.cFormatRule);
                        formats = format[l].formats;
                        if (formats)
                            dataObj.formats = formats;
                    }
                    if (xlObj.model.allowHyperlink && cellProps.hyperlink)
                        this._updateHyperlinkTag(cellProps.hyperlink, cellIdx);
                    if (xlObj.model.allowDataValidation && cellProps.rule)
                        dataObj.rule = cellProps.rule;
                    if (xlObj.getObjectLength(dataObj))
                        xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: dataObj });
                    if (xlObj.model.allowWrap && cellProps.wrap) 
                        xlObj.setWrapText("wrap",[cellIdx.rowIndex, cellIdx.colIndex, cellIdx.rowIndex, cellIdx.colIndex]);
                    j++;
                }
                i++;
            }
        },

        _copyCells: function (options) {
            var i, j, k, l, patrnRange, fillRange, linkData, pRanges, data, flen, hlen, format, formats, cells, clen, props,
                cellProps, cellIdx, dataObj = {}, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), i = 0, pos = ej.Spreadsheet.autoFillDirection,
                dminr = options.dataRange[0], dminc = options.dataRange[1], dmaxr = options.dataRange[2], dmaxc = options.dataRange[3],
                fminr = options.fillRange[0], fminc = options.fillRange[1], fmaxr = options.fillRange[2], fmaxc = options.fillRange[3],
                isVFill = [pos.Down, pos.Up].indexOf(options.direction) > -1, isRFill = [pos.Up, pos.Left].indexOf(options.direction) > -1,
                len = isVFill ? dmaxc - dminc : dmaxr - dminr, formatOnly = options.fillType === ej.Spreadsheet.AutoFillOptions.FillFormattingOnly;
            while (i <= len) {
                pRanges = this._updateFillValues(isVFill, dminr, dminc, dmaxr, dmaxc, fminr, fminc, fmaxr, fmaxc, i);
				patrnRange = pRanges.patrnRange;
				fillRange = pRanges.fillRange;                
                if (xlObj.model.allowCellFormatting) {
                    if (fillRange[0] == fillRange[2])
                        for (var m = [1]; m <= [3]; m++) {
                             if (!xlObj.XLEdit.getPropertyValue(fillRange[0], m, "tformats") && !xlObj.XLEdit.getPropertyValue(fillRange[0], m, "formats"))
                                xlObj.XLFormat.removeStyle([fillRange[0], m, fillRange[2], m]);
                        }
                    else
                        for (var n = fillRange[0]; n <= fillRange[2]; n++) {
                            if (!xlObj.XLEdit.getPropertyValue(n, fillRange[1], "tformats") && !xlObj.XLEdit.getPropertyValue(fillRange[0], m, "formats"))
                                xlObj.XLFormat.removeStyle([n, fillRange[1], n, fillRange[3]]);
                        }
                }
                if (!formatOnly) {
                    props = ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink"];
                    if (xlObj.model.allowConditionalFormats)
                        props.push("cFormatRule");
                    if (xlObj.model.allowDataValidation)
                        props.push("rule");
                    xlObj.clearRangeData(fillRange, props);
                    data = xlObj.getRangeData({ range: patrnRange, property: ["value", "hyperlink", "rule", "cFormatRule", "type", "decimalPlaces", "formatStr"] });
                }
                else
                    data = xlObj.getRangeData({ range: patrnRange, property: ["cFormatRule", "type", "decimalPlaces", "formatStr"] });
                format = xlObj.getRangeData({ range: patrnRange, property: ["format", "formats"] });
                flen = format.length;
                cells = xlObj._getSelectedRange({ rowIndex: fillRange[0], colIndex: fillRange[1] }, { rowIndex: fillRange[2], colIndex: fillRange[3] });
                clen = cells.length;
                j = 0;
                if (isRFill) {
                    cells = cells.reverse();
                    format = format.reverse();
                    if (!formatOnly)
                        data = data.reverse();
                }
                if (formatOnly) {
                    while (j < clen) {
                        dataObj = {};
                        k = j % flen;
                        cellIdx = cells[j];
                        cellProps = data[k];
                        if (xlObj.model.allowCellFormatting) {
                            xlObj.XLFormat._updateFormatClass(cellIdx, format[k].format);
                            this._updateNFormat(cellProps, cellIdx.rowIndex, cellIdx.colIndex);
                        }
                        formats=format[k].formats;
                        if (formats)
                            dataObj.formats = formats;
                        if (xlObj.getObjectLength(dataObj))
                            xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: dataObj });
                        if (xlObj.model.allowConditionalFormats && cellProps.cFormatRule)
                            this._updateCFormat(cellIdx, cellProps.cFormatRule);
                        if (xlObj.model.allowCellType)
                            xlObj.XLCellType._rfrshCtrlText(cellIdx);
                        j++;
                    }
                }
                else {
                    while (j < clen) {
                        dataObj = {};
                        k = j % flen;
                        cellIdx = cells[j];
                        cellProps = data[k];
                        xlObj._dupDetails = true;
                        xlObj.XLEdit.updateCellValue(cellIdx, cellProps.value, format[k].format);
                        xlObj._dupDetails = false;
                        if (xlObj.model.allowCellFormatting &&(cellProps.type && cellProps.type != "general"))
                            this._updateNFormat(cellProps, cellIdx.rowIndex, cellIdx.colIndex);
                        if (xlObj.model.allowHyperlink && cellProps.hyperlink)
                            this._updateHyperlinkTag(cellProps.hyperlink, cellIdx);
                        formats = format[k].formats;
                        if (formats)
                            dataObj.formats = formats;
                        if (xlObj.model.allowDataValidation && cellProps.rule)
                            dataObj.rule = cellProps.rule;
                        if (xlObj.getObjectLength(dataObj))
                            xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: dataObj });
                        if (xlObj.model.allowConditionalFormats && cellProps.cFormatRule)
                            this._updateCFormat(cellIdx, cellProps.cFormatRule);
                        j++;
                    }
                }
                i++;
            }
        },

        _flashFill: function (options) {
            var cells, data, i, xlObj = this.XLObj, dminr = options.dataRange[0], dmaxr = options.dataRange[2], fminr = options.fillRange[0];
            var fminc = options.fillRange[1], fmaxr = options.fillRange[2], fmaxc = options.fillRange[3], patrn = this._getFlashFillPattern(options.dataRange, "left");
            if (patrn) {
                data = xlObj.getRangeData({ range: [fminr, patrn.colIndex, fmaxr, patrn.colIndex], valueOnly: true, skipDateTime: true });
                if (patrn.subStr > -1)
                    data = this._splitString(data, " ", patrn.subStr);
                cells = xlObj._getSelectedRange({ rowIndex: fminr, colIndex: fminc }, { rowIndex: fmaxr, colIndex: fmaxc });
                i = cells.length;
                while (i--)
                    xlObj.XLEdit._updateCellValue(cells[i], data[i]);
            }
            else {
                if (fminr > dminr)
                    fminr = dminr;
                if (fmaxr < dmaxr)
                    fmaxr = dmaxr;
                xlObj._getAutoFillOptElem().addClass("e-hide");
                xlObj.updateUniqueData({ value: "", value2: "", type: "general" }, [fminr, fminc, fmaxr, fmaxc]);
                xlObj._showAlertDlg("Alert", "FlashFillAlert");
            }
        },

        _getFlashFillPattern: function (range, move) {
            var resp, value, splval, slen, j, val, i = 0, subStr = -1, xlObj = this.XLObj, data = xlObj.getRangeData({ range: range, valueOnly: true, skipDateTime: true }),
                dlen = data.length, minr = range[0], right = ej.Spreadsheet.autoFillDirection.Right, isRight = move === right;
            if (!data.join().replace(/,/g, '').length)
                return;
            val = data[0].toString();
            i = range[1];
            if (i === 0)
				isRight = true;
			isRight ? i++ : i--;
            while ( i > -1) {
                    value = xlObj.XLEdit.getPropertyValue(minr, i);
                    value = xlObj.isUndefined(value) ? "" : value.toString();
                    if (!value.length)
                        break;
                    else {
                        if (value === val) {
                            if (dlen > 1) {
                                resp = this._matchData(minr, i, data);
                                if (resp)
                                    return resp;
                            }
                            else
                                return { colIndex: i, subStr: subStr };
                        }
                        splval = value.split(" ");
                        slen = splval.length;
                        j = 0;
                        while (j < slen) {
                            if (val === splval[j]) {
                                subStr = j;
                                if (dlen > 1) {
                                    resp = this._matchData(minr, i, data);
                                    if (resp) {
                                        if (subStr > resp.subStr)
                                            resp.subStr = subStr;
                                        return resp;
                                    }
                                }
                                else
                                    return { colIndex: i, subStr: subStr };
                            }
                            j++;
                        }
						isRight ? i++ : i--;
                    }
            }
            if (!isRight)
                    return this._getFlashFillPattern(range, right);
        },

        _matchData: function (rowIdx, colIdx, data) {
            var j, match = false, val, value, splval, slen, i = 1, subStr = -1, dlen = data.length;
            while (i < dlen) {
                match = false;
                val = data[i].toString();
                value = this.XLObj.XLEdit.getPropertyValue(rowIdx + i, colIdx);
                value = ej.isNullOrUndefined(value) ? "" : value.toString();
                if (val === value) {
                    match = true;
                    i++;
                    continue;
                }
                splval = value.split(" ");
                slen = splval.length;
                j = 0;
                while (j < slen) {
                    if (val === splval[j]) {
                        if (subStr < j)
                            subStr = j;
                        match = true;
                        break;
                    }
                    j++;
                }
                i++;
            }
            if (match && i === dlen)
                return { colIndex: colIdx, subStr: subStr };
        },

        _splitString: function (array, splitter, index) {
            var data, val, i = array.length, j;
            while (i--) {
                j = index;
                data = array[i].split(splitter);
                while (j > -1) {
                    val = data[j];
                    if (val)
                        break;
                    j--;
                }
                array[i] = val;
            }
            return array;
        },

        _getPattern: function (range, options) {
            var j, idx, temp, regVal, custColl, lCaseColl, lCaseVal, isLCase, diff, len, i = 0, pattern = [], xlObj = this.XLObj,
                ctype = ej.Spreadsheet.CellType, patrns = this._getDataPattern(range), plen = patrns.length, patrn;
            if (patrns) {
                while (i < plen) {
                    patrn = patrns[i];
                    switch (patrn.type) {
                        case ctype.Number:
                            idx = pattern.length;
                            len = patrn.val.length;
                            diff = options.isRFill ? -1 : len;
                            if (len === 1)
                                patrn.val.push(patrn.val[0] + 1);
                            regVal = this._getPredictionValue(patrn.val);
                            temp = { regVal: regVal, type: patrn.type, i: diff };
                            pattern.push(temp);
                            j = 1;
                            while (j < len) {
                                pattern.push(idx);
                                j++;
                            }
                            break;
                        case ctype.String:
                            idx = pattern.length;
                            temp = { val: patrn.val, type: patrn.type, i: 0 };
                            pattern.push(temp);
                            j = 1;
                            len = patrn.val.length;
                            while (j < len) {
                                pattern.push(idx);
                                j++;
                            }
                            break;
                        case ctype.Formula:
                            len = patrn.val.length;
                            patrn = this._getFormulaPattern(patrn.val, options);
                            diff = options.isRFill ? -1 : len;
                            if (patrn.isInPattern) {
                                idx = pattern.length;
                                temp = { val: patrn.val, type: ctype.Formula, i: diff };
                                pattern.push(temp);
                                j = 1;
                                while (j < len) {
                                    pattern.push(idx);
                                    j++;
                                }
                            }
                            else {
                                j = 0;
                                diff = options.isRFill ? -1 : 1;
                                while (j < len) {
                                    pattern.push({ val: patrn.val[j], type: ctype.Formula, i: diff });
                                    j++;
                                }
                            }
                            break;
                        default:
                            if (patrn.type.indexOf(ctype.Custom) > -1) {
                                idx = pattern.length;
                                len = patrn.val.length;
                                diff = options.isRFill ? -1 : len;
                                custColl = this._customList[Number(patrn.type.replace(ctype.Custom, ''))];
                                isLCase = custColl.indexOf(patrn.val[0]) === -1;
                                lCaseColl = xlObj.toArrayLowerCase(custColl.slice(0));
                                lCaseVal = xlObj.toArrayLowerCase(patrn.val);
                                regVal = this._getCustomPredictionValue(lCaseVal, lCaseColl);
                                temp = { val: isLCase ? lCaseColl : custColl, regVal: regVal, i: diff, type: ctype.Custom, len: custColl.length };
                                pattern.push(temp);
                                j = 1;
                                while (j < len) {
                                    pattern.push(idx);
                                    j++;
                                }
                            }
                    }
                    i++;
                }
                return pattern;
            }
        },

        _getCustomPredictionValue: function (data, coll) {
            var i = 0, temp = [], len = data.length;
            while (i < len) {
                temp.push(coll.indexOf(data[i]));
                i++;
            }
            if (temp.length === 1)
                temp.push(temp[0] + 1);
            return this._getPredictionValue(temp);
        },

        _getDataPattern: function (range) {
            var val, type, i = 0, obj = {}, patrn = [], data = this.XLObj.getRangeData({ range: range, valueOnly: true, skipDateTime: true }), dlen = data.length;
            if (dlen) {
                while (i < dlen) {
                    val = data[i];
                    type = this._getType(val);
                    if (i === 0)
                        obj = { val: [val], type: type };
                    else if (type === obj.type)
                        obj.val.push(val);
                    else {
                        patrn.push(obj);
                        obj = { val: [val], type: type };
                    }
                    i++;
                }
                patrn.push(obj);
                return patrn;
            }
        },

        _getFormulaPattern: function (data, options) {
            var patrn, j, temp, isInPatrn, xlObj = this.XLObj, patrns = [], i = 0, len = data.length, cRfrType;
            while (i < len) {
                patrns.push(this._parseFormula(data[i]));
                i++;
            }
            isInPatrn = this._isInPattern(patrns, options.isVFill);
            if (isInPatrn) {
                patrn = patrns[0];
                i = patrn.length;
                while (i--) {
                    temp = patrn[i];
                    cRfrType = xlObj._isCellReference(temp);
                    if (cRfrType && (cRfrType !== "absolute"))
                        patrn[i] = this._getCellRefPrediction(temp, options, null, cRfrType);
                }
                return { isInPattern: isInPatrn, val: patrn };
            }
            else {
                i = 0;
                while (i < len) {
                    patrn = patrns[i];
                    j = patrn.length;
                    while (j--) {
                        temp = patrn[j];
                        cRfrType = xlObj._isCellReference(temp);
                        if (cRfrType && (cRfrType !== "absolute"))
                            patrns[i][j] = this._getCellRefPrediction(temp, options, len, cRfrType);
                    }
                    i++;
                }
                return { isInPattern: isInPatrn, val: patrns };
            }
        },

        _getCellRefPrediction: function (text, options, length, rfrType) {
            text = text.toUpperCase();
            var eStr = "", aRegx = new RegExp("[a-z$]", "gi"), nRegx = new RegExp("[0-9$]", "g"), str = options.isVFill ? text.replace(nRegx, eStr) : text.replace(aRegx, eStr),
                temp = options.isVFill ? Number(text.replace(aRegx, eStr)) : this.XLObj._generateColCount(text.replace(nRegx, eStr)), arr = [temp], isColAbslt = text[0] === '$';            
            if (length && length !== 1)
                arr.push(temp + length);
            else
                arr.push(temp + 1);
            temp = this._getPredictionValue(arr);
            if (rfrType && (rfrType === "mixed")) {
                if (isColAbslt === options.isVFill)
                    str = '$' + str;
                else
                    temp.b = 0;
            }
            temp.c = str;
            return temp;
        },

        _isInPattern: function (patrn, isVFill) {
            var oldPatrn, olen, newPatrn, nlen, oldStr, newStr, oldInt, newInt, xlObj = this.XLObj, eStr = "",
                i = 0, j = 1, plen = patrn.length, nregx = new RegExp("[0-9$]", "g"), aregx = new RegExp("[a-z$]", "gi");
            if (plen === 1)
                return false;
            while (j < plen) {
                oldPatrn = patrn[i];
                newPatrn = patrn[j];
                olen = oldPatrn.length;
                nlen = newPatrn.length;
                if (olen !== nlen)
                    return false;
                else {
                    while (olen--) {
                        oldStr = oldPatrn[olen];
                        newStr = newPatrn[olen];
                        if (xlObj._isCellReference(oldStr) === xlObj._isCellReference(newStr)) {
                            if (isVFill) {
                                oldInt = Number(oldStr.replace(aregx, eStr));
                                newInt = Number(newStr.replace(aregx, eStr));
                            }
                            else {
                                oldInt = xlObj._generateColCount(oldStr.replace(nregx, eStr));
                                newInt = xlObj._generateColCount(newStr.replace(nregx, eStr));
                            }
                            if (oldInt !== newInt - 1)
                                return false;
                        }
                        else if (oldStr !== newStr)
                            return false;
                    }
                }
                i++;
                j++;
            }
            return true;
        },

        _parseFormula: function (formula) {
            var temp, str, len, i = 0, arr = [];
            formula = this._markSpecialChar(formula.replace("=", ""));
            formula = formula.split(/\(|\)|,|:|\+|-|\*|\/|%|&/g);
            len = formula.length;
            while (i < len) {
                temp = formula[i];
                if (!temp) {
                    i++;
                    continue;
                }
                if (temp.length === 1)
                    arr.push(this._isUniqueChar(temp) ? this._getUniqueCharVal(temp) : temp);
                else {
                    str = temp[0];
                    if (temp.indexOf('!') > 0) {
                        if (this._isUniqueChar(str)) {
                            arr.push(this._getUniqueCharVal(str));
                            temp = temp.substr(1);
                        }
                        str = temp.indexOf('!') + 1;
                        arr.push(temp.substr(0, str));
                        arr.push(temp.substr(str));
                    }
                    else if (this._isUniqueChar(str)) {
                        arr.push(this._getUniqueCharVal(str));
                        arr.push(temp.substr(1));
                    }
                    else
                        arr.push(temp);
                }
                i++;
            }
            return arr;
        },

        _getUniqueCharVal: function (str) {
            switch (str) {
                case this._uniqueOBracket:
                    return "(";
                case this._uniqueCBracket:
                    return ")";
                case this._uniqueCSeparator:
                    return ",";
                case this._uniqueCOperator:
                    return ':';
                case this._uniquePOperator:
                    return "+";
                case this._uniqueSOperator:
                    return "-";
                case this._uniqueMOperator:
                    return "*";
                case this._uniqueDOperator:
                    return "/";
                case this._uniqueModOperator:
                    return "%";
                case this._uniqueConcateOperator:
                    return "&";
            }
            return "";
        },

        _isUniqueChar: function (str) {
            var code = str.charCodeAt(str);
            return code >= 129 && code <= 138;
        },

        _markSpecialChar: function (formula) {
            formula = formula.replace(/\(/g, "(" + this._uniqueOBracket).replace(/\)/g, ")" + this._uniqueCBracket);
            formula = formula.replace(/,/g, "," + this._uniqueCSeparator).replace(/:/g, ":" + this._uniqueCOperator);
            formula = formula.replace(/\+/g, "+" + this._uniquePOperator).replace(/-/g, "-" + this._uniqueSOperator);
            formula = formula.replace(/\*/g, "*" + this._uniqueMOperator).replace(/\//g, "/" + this._uniqueDOperator);
            formula = formula.replace(/&/g, "&" + this._uniqueConcateOperator);
            return formula.replace(/%/g, "%" + this._uniqueModOperator);
        },

        _getPredictionValue: function (args) {
            var i = 0, sumx = 0, sumy = 0, sumxy = 0, sumxx = 0, n = args.length;
            while (i < n) {
                sumx = sumx + i;
                sumy = sumy + Number(args[i]);
                sumxy = sumxy + (i * Number(args[i]));
                sumxx = sumxx + (i * i);
                i++;
            }
            var a = this.XLObj._round(((sumy * sumxx) - (sumx * sumxy)) / ((n * sumxx) - (sumx * sumx)), 5), b = this.XLObj._round(((n * sumxy) - (sumx * sumy)) / ((n * sumxx) - (sumx * sumx)), 5);
            return { a: a, b: b };
        },

        _getType: function (val) {
            var type = this._isCustomType(val), ctype = ej.Spreadsheet.CellType, xlObj = this.XLObj;
            if (type)
                type = type;
            else if (xlObj.isFormula(val))
                type = ctype.Formula;
            else if (xlObj.isNumber(val))
                type = ctype.Number;
            return type || ctype.String;
        },

        _isCustomType: function (val) {
            val = val + "";
            val = val.toLowerCase();
            var i = this._customList.length;
            while (i--) {
                if (this.XLObj.toArrayLowerCase(this._customList[i].slice(0)).indexOf(val) > -1)
                    return ej.Spreadsheet.CellType.Custom + i;
            }
            return false;
        },

        _ensurePattern: function (patterns) {
            var patrn, idx = -1, i = patterns.length;
            while (i--) {
                patrn = patterns[i];
                if (this.XLObj._isObject(patrn)) {
                    idx = i;
                    if (patrn.type === ej.Spreadsheet.CellType.String)
                        patrn.val = patrn.val.reverse();
                }
                else
                    patterns[i] = idx;
            }
            return patterns;
        },

        _selectAutoFillRange: function (trgt, idx) {
            if (trgt)
                idx = this.XLObj._getCellIdx(trgt);
            var i, cells, xlObj = this.XLObj, range = this._getAutoFillRange(idx);
            if (!range)
                return;
            this._autoFillCleanUp();
            cells = xlObj.getRange([range.startCell.rowIndex, range.startCell.colIndex, range.endCell.rowIndex, range.endCell.colIndex]);
            i = cells.length;
            while (i--)
                xlObj.addClass(cells[i], "e-autofillcell");
            xlObj.XLSelection._focusRange(range.startCell, range.endCell, xlObj._autofillBorder);
            xlObj._dautoFillCell = idx;
        },

        _getAutoFillRange: function (idx) {
            var dir = ej.Spreadsheet.autoFillDirection, xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), scell = sheet._startCell,
                ecell = sheet._endCell, acell = sheet._autoFillCell, range = sheet.selectedRange, minr = range[0], minc = range[1], maxr = range[2],
                maxc = range[3], inRange = xlObj.inRange(range, idx.rowIndex, idx.colIndex), minIdx = { rowIndex: minr, colIndex: minc },
                maxIdx = { rowIndex: maxr, colIndex: maxc };
            if (idx.rowIndex < acell.rowIndex) {// up 
                if (sheet._isFreezed && idx.rowIndex <= sheet.frozenRows && sheet._hiddenFreezeRows.indexOf(sheet.frozenRows) > -1)
                    idx.rowIndex = sheet._ftopRowIdx;
                if ((minr - idx.rowIndex > idx.colIndex - maxc) && (minr - idx.rowIndex > minc - idx.colIndex))
                    return inRange ? { startCell: minIdx, endCell: { rowIndex: idx.rowIndex, colIndex: maxc } } : { startCell: maxIdx, endCell: { rowIndex: idx.rowIndex, colIndex: minc }, fillRange: [idx.rowIndex, minc, minr - 1, maxc], direction: dir.Up };
               else if (idx.colIndex > acell.colIndex )
                    return { startCell: minIdx, endCell: { rowIndex: maxr, colIndex: idx.colIndex }, fillRange: [minr, maxc + 1, maxr, idx.colIndex], direction: dir.Right };
                else if(idx.colIndex < acell.colIndex )
                    return inRange ? { startCell: minIdx, endCell: maxIdx } : { startCell: maxIdx, endCell: { rowIndex: minr, colIndex: idx.colIndex }, fillRange: [minr, idx.colIndex, maxr, minc - 1], direction: dir.Left };
              
            }
            else if (idx.colIndex > acell.colIndex) {// right
                if ((idx.rowIndex - maxr > idx.colIndex - maxc))
                    return { startCell: minIdx, endCell: { rowIndex: idx.rowIndex, colIndex: maxc }, fillRange: [maxr + 1, minc, idx.rowIndex, maxc], direction: dir.Down };
                else
                    return { startCell: minIdx, endCell: { rowIndex: maxr, colIndex: idx.colIndex }, fillRange: [minr, maxc + 1, maxr, idx.colIndex], direction: dir.Right };
            }

            else if (idx.colIndex < acell.colIndex) { // left
                if (sheet._isFreezed && idx.colIndex <= sheet.frozenColumns && sheet._hiddenFreezeCols.indexOf(sheet.frozenColumns) > -1)
                    idx.colIndex = sheet._fleftColIdx;
                if ((idx.rowIndex - maxr > maxc - idx.colIndex) || ((idx.rowIndex - minr > maxc - idx.colIndex) && idx.rowIndex !== maxr))
                    return { startCell: minIdx, endCell: { rowIndex: idx.rowIndex, colIndex: maxc }, fillRange: [maxr + 1, minc, idx.rowIndex, maxc], direction: dir.Down };
                else
                    return inRange ? { startCell: minIdx, endCell: maxIdx } : { startCell: maxIdx, endCell: { rowIndex: minr, colIndex: idx.colIndex }, fillRange: [minr, idx.colIndex, maxr, minc - 1], direction: dir.Left };
            }
            else if (idx.rowIndex > acell.rowIndex) // down                
                return { startCell: minIdx, endCell: { rowIndex: idx.rowIndex, colIndex: maxc }, fillRange: [maxr + 1, minc, idx.rowIndex, maxc], direction: dir.Down };
            else if (idx.rowIndex === acell.rowIndex && idx.colIndex === acell.colIndex)
                return { startCell: scell, endCell: ecell };
        },

        _getDirection: function (endCell, currcell, isVerticalFill) {
            var dir = ej.Spreadsheet.autoFillDirection;
            isVerticalFill = this.XLObj.isUndefined(isVerticalFill) ? this._verticalFill : isVerticalFill;
            if (isVerticalFill) {
                if (currcell.rowIndex < endCell.rowIndex) // up
                    return dir.Up;
                else if (currcell.rowIndex > endCell.rowIndex) // down
                    return dir.Down;
                else if (currcell.colIndex > endCell.colIndex) // right
                    return dir.Right;
                else if (currcell.colIndex < endCell.colIndex) // left
                    return dir.Left;
            }
            else {
                if (currcell.colIndex > endCell.colIndex) // right
                    return dir.Right;
                else if (currcell.colIndex < endCell.colIndex) // left
                    return dir.Left;
                else if (currcell.rowIndex < endCell.rowIndex) // up
                    return dir.Up;
                else if (currcell.rowIndex > endCell.rowIndex) // down
                    return dir.Down;
            }
            return null;
        },

        _getFillRange: function (pStartCell, pEndCell, pFillCell, direction) {
            var dir = ej.Spreadsheet.autoFillDirection;
            switch (direction) {
                case dir.Up:
                    return [pFillCell.rowIndex, pStartCell.colIndex, pStartCell.rowIndex - 1, pEndCell.colIndex];
                case dir.Right:
                    return [pStartCell.rowIndex, pEndCell.colIndex + 1, pEndCell.rowIndex, pFillCell.colIndex];
                case dir.Down:
                    return [pEndCell.rowIndex + 1, pStartCell.colIndex, pFillCell.rowIndex, pEndCell.colIndex];
                case dir.Left:
                    return [pStartCell.rowIndex, pFillCell.colIndex, pEndCell.rowIndex, pStartCell.colIndex - 1];
            }
            return null;
        },

        _autoFillOptionClick: function (args) {
            var dragFill, sheet, dir, dataRange, fillRange, sCell, eCell, autoElem = $("#" + args.model.targetID).find("#" + args.ID).find(">>");
            if (this._hasClass(autoElem[0], "e-ss-fillselect"))
                return;
            dragFill = this.XLDragFill, sheet = this.getSheet(this.getActiveSheetIndex()), dir = dragFill._getDirection(this._pEndCell, this._pFillCell);
            dataRange = this.swapRange([this._pStartCell.rowIndex, this._pStartCell.colIndex, this._pEndCell.rowIndex, this._pEndCell.colIndex]);
            fillRange = dragFill._getFillRange(this._pStartCell, this._pEndCell, this._pFillCell, dir), sCell = sheet._startCell, eCell = sheet._endCell;
            this._isUndo = true;
            this._performUndoRedo();
            if (!sheet._isColSelected && !sheet._isRowSelected) {
                sheet._startCell = sCell;
                sheet._endCell = eCell;
                this.XLSelection.selectRange(sheet._startCell, sheet._endCell);
            }
            dragFill.positionAutoFillElement(true);
            dragFill.autoFill({ dataRange: dataRange, fillRange: fillRange, direction: dir, fillType: args.ID });
            dragFill._fillInfo.fillType = args.ID;
            this._isUndo = false;
        },

        _autoFillCleanUp: function () {
            var i, cname, cells, cell, hide = "e-hide", xlObj = this.XLObj, aElem = xlObj.getAutoFillElem(), aOpt = xlObj._getAutoFillOptElem();
            if (aElem)
                xlObj.addClass(aElem[0], hide);
            if (aOpt)
                xlObj.addClass(aOpt[0], hide);
            cells = xlObj._getContent(xlObj.getActiveSheetIndex())[0].querySelectorAll("td.e-autofillcell");
            i = cells.length;
            while (i--) {
                cell = cells[i];
                cname = cell.className;
                cname = cname.replace(/e-autofillcell|e-blur/g, "");
                cname = cname.replace(/ +/g, " ");
                cell.className = cname;
            }
        },

        _autoFillClick: function () {
            var len, i = 0, cname = "e-ss-fillselect", elems = $("#" + this._id + "_ctxtmenu").find("li"), enabledItem = elems.find("." + cname);
            // to remove existing enabled item
            if (enabledItem.length) {
                enabledItem = enabledItem[0];
                this._removeClass(enabledItem, cname);
                this.addClass(enabledItem, "e-ss-filloption");
            }
            // to show all elements 
            elems.show();
            // to hide some options based on scenario
            len = this.XLDragFill._fillInfo.disableItems.length;
            while (i < len) {
                $(elems[this.XLDragFill._fillInfo.disableItems[i]]).hide();
                i++;
            }
            // to select fill type item
            elems.filter("#" + this.XLDragFill._fillInfo.fillType).find("span").addClass(cname);
        },

        _fillRange: function (verticalFill, range) {
            var dirc, isProperKey, pRange, cells, minr, minc, maxr, maxc, args = { isKeyFill: true }, xlObj = this.XLObj,
                sheetIdx=xlObj.getActiveSheetIndex(),sheet = xlObj.getSheet(sheetIdx), direction = ej.Spreadsheet.autoFillDirection;
            range = range ? range : sheet.selectedRange;
            minr = range[0], minc = range[1], maxr = range[2], maxc = range[3];
            dirc = this._getDirection({ rowIndex: minr, colIndex: minc }, { rowIndex: maxr, colIndex: maxc }, verticalFill);
            isProperKey = verticalFill ? dirc === direction.Down : dirc === direction.Right;
            if (xlObj.isRange(range) && isProperKey) {
                if (verticalFill) {
                    args.dataRange = [minr, minc, minr, maxc];
                    args.fillRange = [minr + 1, minc, maxr, maxc];
                }
                else {
                    args.dataRange = [minr, minc, maxr, minc];
                    args.fillRange = [minr, minc + 1, maxr, maxc];
                }
            }
            else {
                if (verticalFill) {
                    if (!minr)
                        return;
                    args.dataRange = [minr - 1, minc, minr - 1, maxc];
                }
                else {
                    if (!minc)
                        return;
                    args.dataRange = [minr, minc - 1, maxr, minc - 1];
                }
                args.fillRange = range;
            }
            args.direction = verticalFill ? direction.Down : direction.Right;
            args.fillType = ej.Spreadsheet.AutoFillOptions.CopyCells;
            pRange = xlObj.swapRange(args.fillRange);
            if (xlObj.model.allowLockCell && sheet.isSheetProtected) {            
                if (xlObj._isPropExists(([pRange]),"isLocked", sheetIdx))
                    return;
            }
            if (xlObj._isPropExists(([pRange]), "isReadOnly", sheetIdx))
                return;
            this.autoFill(args);
        },

        _getFillInfo: function (options) {
            var i, val, isStringType = true, fillType = ej.Spreadsheet.AutoFillOptions.CopyCells, disableItems = [],
                xlObj = this.XLObj, pos = ej.Spreadsheet.autoFillDirection, isVFill = [pos.Down, pos.Up].indexOf(options.direction) > -1,
                data = xlObj.getRangeData({ range: options.dataRange, valueOnly: true, skipDateTime: true }), len = data.join().replace(/,/g, '').length;
            if (xlObj.isRange(options.dataRange) && len) {
                i = data.length;
                while (i--) {
                    val = data[i];
                    if (xlObj.isNumber(val) || xlObj.isFormula(val) || this._isCustomType(val)) {
                        isStringType = false;
                        fillType = xlObj.model.autoFillSettings.fillType;
                        break;
                    }
                }
            }
            else {
                val = data[0];
                if (xlObj.isNumber(val) || xlObj.isFormula(val) || this._isCustomType(val)) {
                    isStringType = false;
                    fillType = xlObj.model.autoFillSettings.fillType;
                }
            }            
            if (!len || isStringType) {
                disableItems.push(1);
                fillType = (options.fillType == "fillseries") ? fillType : options.fillType;
            }
            if (!isVFill || (isVFill && options.dataRange[1] !== options.dataRange[3]))
                disableItems.push(4);
            return { fillType: fillType, disableItems: disableItems };
        },

        _updateHyperlinkTag: function (hlData, cellIdx) {
            var cell, xlObj = this.XLObj, val = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "value2");
            if (xlObj._isRowViewable(xlObj.getActiveSheetIndex(), cellIdx.rowIndex)) {
                cell = xlObj.getCell(cellIdx.rowIndex, cellIdx.colIndex);
                if(cell[0].lastChild.nodeType === 3)
                    $(cell[0].lastChild).remove();
              cell.append(ej.buildTag("a.e-hyperlinks", val, "", !hlData.webAddr ? { href: "#" } : { href: hlData.webAddr, target: "_blank" }));

            }
            xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: { hyperlink: hlData } });
        },

        _updateCFormat: function (cellIdx, rule) {
            var splitStr,  i = 0, xlObj = this.XLObj, len = rule.length;
            xlObj._dupDetails = true;
            while (i < len) {
                splitStr = rule[i].split("_");
                xlObj.XLCFormat._cFormat(splitStr[0], splitStr[2], splitStr[3], splitStr[4], null, null, [cellIdx.rowIndex, cellIdx.colIndex, cellIdx.rowIndex, cellIdx.colIndex]);
                i++;
            }
            xlObj._dupDetails = false;
        },

        _updateNFormat: function (data, rowIdx, colIdx) {
            var formatObj = { type: data.type }, xlObj = this.XLObj;            
            if (data.type != "general") {
                if (data.formatStr)
                    formatObj.formatStr = data.formatStr;
                if ("decimalPlaces" in data)
                    formatObj.decimalPlaces = data.decimalPlaces;
            }
            xlObj._dupDetails = true;
            xlObj.XLFormat.format(formatObj, xlObj._getAlphaRange(xlObj.getActiveSheetIndex(), rowIdx, colIdx, rowIdx, colIdx));
            xlObj._dupDetails = false;
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.cellNavigation = function (obj) {
        this.XLObj = obj;
        this._canKeyBoardNavigate = true;
        this._isNavigate = true;
    };

    ej.spreadsheetFeatures.cellNavigation.prototype = {
        _selectionKeyDownHandler: function (e) {
            var val, selRange, scell, cellInfo, ecell, range, classname, obj, startCell, isRowcolSel, isMergeCell = false, cells = [], xlObj = this.XLObj,
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), keyCode = e.keyCode, shiftKey = e.shiftKey,
                ctrlKey = e.ctrlKey, key = { keyCode: keyCode, shiftKey: shiftKey, ctrlKey: ctrlKey, altKey: e.altKey }, _isChanged = false,
                activecell = sheet._activeCell, endCell = sheet._endCell, rowCount = sheet.rowCount, colCount = sheet.colCount, container = xlObj._dataContainer, rowdata, i, j, usedrange = sheet.usedRange;
            if (((keyCode === 9 && this._canKeyBoardNavigate) || keyCode === 13) && !ctrlKey) { // tab & Enter Key
                e.preventDefault(); // to prevent default browser actions
                val = xlObj.XLEdit.getCurrentEditCellData();
                if (xlObj.isFormula(val) && !xlObj.XLEdit._formulaValidate(val))
                    return;
                if (xlObj.XLEdit._isFormulaEdit && !xlObj._isFormulaSuggestion) {
                    if (val.length > 1) {
                        if (!this._isValidParameter(val)) {
                            xlObj._showAlertDlg("Alert", "MissingParenthesisAlert", "FormulaAlert", 440);
                            return;
                        }
                        else {
                            if (!xlObj.isFormula(val)) {
                                val = val + ")";
                                xlObj.XLEdit._editElem.text(val);
                                if(xlObj.model.allowFormulaBar)
                                xlObj._getInputBox().val(val);
                            }
                            xlObj.XLEdit.saveCell();
                            xlObj._getContent(sheetIdx).find("td").removeClass(xlObj._formulaBorder.join(" ").replace(/,/g, " ") + " " + xlObj._ctrlFormulaBorder.join(" ").replace(/,/g, " "));
                            xlObj.XLSelection._cleanUp();
                            xlObj.XLSelection.selectRange(sheet._activeCell, sheet._activeCell);
                            xlObj.XLEdit._isFormulaEdit = false;
                            xlObj._formulaRange = [];
                            xlObj._ctrlKeyCount = 0;
                        }
                    }
                    else {
                        xlObj.XLEdit.saveCell();
                        xlObj.XLEdit._isFormulaEdit = false;
                    }
                }
                else if (keyCode === 9 && xlObj.XLEdit._isEdit)
                    xlObj.XLEdit.saveCell();
                selRange = sheet.selectedRange;
                isRowcolSel = sheet._isRowSelected || sheet._isColSelected;
                if (isRowcolSel) {
                    if (selRange[0] === selRange[2] || selRange[1] === selRange[3])
                        cells.push({ rowIndex: selRange[0], colIndex: selRange[1] });
                    else
                        cells = sheet._selectedCells;
                }
                else
                    cells = sheet._selectedCells;
                if (cells.length) {
                    if (cells.length === 1 || (!isRowcolSel && this._isRangeMerged(cells))) {
                        if (sheet._isRowSelected) {
                            if (shiftKey) {
                                if (activecell.colIndex > 0)
                                    this._navigateRow("Backward", key);
                            }
                            else {
                                if (activecell.colIndex < 39)
                                    this._navigateRow("Forward", key);
                            }
                        }
                        else if (sheet._isColSelected) {
                            if (shiftKey) {
                                if (activecell.rowIndex > 0)
                                    this._navigateCol("Backward", key);
                            }
                            else {
                                if (activecell.rowIndex < 39)
                                    this._navigateCol("Forward", key);
                            }
                        }
                        else {
                            if (shiftKey) {
                                if (keyCode === 9 && activecell.colIndex > 0)
                                    this._navigateCell(activecell.rowIndex, activecell.colIndex - 1, key); //shifttab
                                else if (keyCode === 13 && activecell.rowIndex > 0)
                                    this._navigateCell(activecell.rowIndex - 1, activecell.colIndex, key); //shiftenter
                            }
                            else {
                                if (keyCode === 9 && activecell.colIndex < colCount)
                                    this._navigateCell(activecell.rowIndex, activecell.colIndex + 1, key); //tab
                                else if (keyCode === 13 && activecell.rowIndex < rowCount)
                                    this._navigateCell(activecell.rowIndex + 1, activecell.colIndex, key); //enter
                            }
                        }
                    }
                    else {
                        if (shiftKey)
                            keyCode === 9 ? this._navigateRange("ShiftTab", key) : this._navigateRange("ShiftEnter", key);
                        else
                            keyCode === 9 ? this._navigateRange("Tab", key) : this._navigateRange("Enter", key);
                    }
                }
            } else if ((keyCode === 37 || (keyCode === 38 && !xlObj._isFormulaSuggestion) || keyCode === 39 || (keyCode === 40 && !xlObj._isFormulaSuggestion)) && this._isNavigate) { //left ,up, right & down arrow
                e.preventDefault(); // to prevent default browser actions
                if (xlObj.XLEdit._isFormulaEdit) { // for formula navigation
                    range = xlObj.swapRange([xlObj._dStartCell.rowIndex, xlObj._dStartCell.colIndex, xlObj._dEndCell.rowIndex, xlObj._dEndCell.colIndex]);
                    xlObj.getRange([!range[0] ? range[0] : range[0] - 1, !range[1] ? range[1] : range[1] - 1, range[2], range[3]]).removeClass(xlObj._formulaBorder[xlObj._ctrlKeyCount % 6].join(' ') + " " + xlObj._ctrlFormulaBorder[xlObj._ctrlKeyCount % 6].join(' '));
                    if (ctrlKey) { //ctrl key support
                        scell = xlObj._dStartCell;
                        if (keyCode === 37 && scell.colIndex > 0)  // min column count reached? left arrow 
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: scell.rowIndex, colIndex: 0 };
                        else if (keyCode === 38 && scell.rowIndex > 0)  // min row count reached? up arrow
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: 0, colIndex: scell.colIndex };
                        else if (keyCode === 39 && scell.colIndex < sheet.colCount) // max column count reached ? right arrow
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: scell.rowIndex, colIndex: sheet.colCount };
                        else if (keyCode === 40 && scell.rowIndex < rowCount) //max row count reached? down arrow
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: sheet.colCount, colIndex: scell.colIndex };
                    }
                    if (shiftKey || xlObj._shiftKeyEnabled) { // shift key support
                        ecell = xlObj._dEndCell;
                        scell = xlObj._dStartCell;
                        if (keyCode === 37 && scell.colIndex > 0)
                            xlObj._dStartCell = { rowIndex: scell.rowIndex, colIndex: scell.colIndex - 1 };
                        else if (keyCode === 38 && scell.rowIndex > 0)
                            xlObj._dStartCell = { rowIndex: scell.rowIndex - 1, colIndex: scell.colIndex };
                        else if (keyCode === 39 && ecell.colIndex < sheet.colCount)
                            xlObj._dEndCell = { rowIndex: ecell.rowIndex, colIndex: ecell.colIndex + 1 };
                        else if (keyCode === 40 && ecell.rowIndex < sheet.rowCount)
                            xlObj._dEndCell = { rowIndex: ecell.rowIndex + 1, colIndex: ecell.colIndex };
                    }
                    else {
                        scell = xlObj._dStartCell;
                        if (keyCode === 37 && scell.colIndex > 0)  // min column count reached? left arrow
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: scell.rowIndex, colIndex: scell.colIndex - 1 }; // left
                        else if (keyCode === 38 && scell.rowIndex > 0) // min row index reached?
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: scell.rowIndex - 1, colIndex: scell.colIndex }; // up
                        else if (keyCode === 39 && scell.colIndex < sheet.colCount) // max col count reached?
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: scell.rowIndex, colIndex: scell.colIndex + 1 }; // right
                        else if (keyCode === 40 && scell.rowIndex < sheet.rowCount)  // max row count reached?
                            xlObj._dStartCell = xlObj._dEndCell = { rowIndex: scell.rowIndex + 1, colIndex: scell.colIndex }; // down   
                    }
                    xlObj.XLSelection._processFormulaRange(xlObj._ctrlFormulaBorder);
                    xlObj._formulaRange[xlObj._ctrlKeyCount] = xlObj._getProperAlphaRange(sheetIdx, xlObj._dStartCell.rowIndex, xlObj._dStartCell.colIndex, xlObj._dEndCell.rowIndex, xlObj._dEndCell.colIndex);
                }
                else {
                    if (ctrlKey) { //ctrl key support
                        if (keyCode === 37 && activecell.colIndex > 0){  //  left arrow 
                            rowdata = container.sheets[sheetIdx][activecell.rowIndex];
                            i = activecell.colIndex - 1;
                            if (rowdata && i < usedrange.colIndex) { //Active row is non -empty && active column less than used range column
                                if ( xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i+1, "value2") && xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2")) { //active column is non - empty
                                    while (xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2") && i <= usedrange.colIndex)
                                        i--;
                                    colCount = i + 1;
                                }
                                else { //Active column is empty
                                    while (!xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2") && i < usedrange.colIndex && i > 0)
                                        i--;
                                    colCount = i;
                                }
                            }
                            else {// Active column greater than used range column
                                if (!xlObj.XLEdit.getPropertyValue(activecell.rowIndex, usedrange.colIndex, "value2")) {//used range is empty
                                    i = usedrange.colIndex;
                                    while ( i > 0 && !xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2"))
                                        i--;
                                    colCount = i;
                                }
                                else //used range is non - empty
                                    colCount = usedrange.colIndex;  //used range is non-empty 
                            }
                            this._navigateCell(activecell.rowIndex, colCount, key);
                        }  
                        else if (keyCode === 38 && activecell.rowIndex > 0) {  // up arrow
                            rowdata = container.sheets[sheetIdx];
                            i = activecell.rowIndex - 1;
                            if (i <= usedrange.rowIndex) {//Active row lees then used range
                                if (rowdata[i] && xlObj.XLEdit.getPropertyValue(i + 1, activecell.colIndex, "value2") && xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2")) { //previous row is non-empty and active column in previous row is non - empty
                                    while (xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2") && i <= usedrange.rowIndex)
                                        i--;
                                    rowCount = i + 1;
                                }
                                else {  //active column in previous row is empty
                                    while (!xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2") && i > 0)
                                        i--
                                    rowCount = i;
                                }
                            }
                            else { //active row greatrer than used range
                                if (!xlObj.XLEdit.getPropertyValue(usedrange.rowIndex, activecell.colIndex, "value2")) { //used range is empty
                                    i = usedrange.rowIndex;
                                    while (i > 0 && !xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2"))
                                        i--;
                                    rowCount = i;
                                }
                                else //used range is non - empty
                                    rowCount = usedrange.rowIndex;
                            }
                            this._navigateCell(rowCount, activecell.colIndex, key);
                        }
                        else if (keyCode === 39 && activecell.colIndex < colCount - 1){//  right arrow
                            rowdata = container.sheets[sheetIdx][activecell.rowIndex];
                            i = activecell.colIndex + 1;
                            if (rowdata && i <= usedrange.colIndex) {// Active row is non - empty and active column less than / equalto used range
                                if (xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i-1, "value2") && xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2")) {//Active column is non - empty
                                    while (xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2") && i <= usedrange.colIndex)
                                        i++;
                                    colCount = i - 1;
                                }
                                else { //Active column is empty
                                    while (!xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2") && i < usedrange.colIndex)
                                        i++;
                                    colCount = (!xlObj.XLEdit.getPropertyValue(activecell.rowIndex, i, "value2")) ? sheet.colCount : i;
                                }
                            }
                            else // Active column is greater than used range column
                                colCount = sheet.colCount;
                            (colCount === sheet.colCount) && --colCount;
                            this._navigateCell(activecell.rowIndex, colCount, key);
                        }
                        else if (keyCode === 40 && activecell.rowIndex < rowCount - 1) {// down arrow
                            rowdata = container.sheets[sheetIdx];
                            i = activecell.rowIndex + 1;
                            if (i < usedrange.rowIndex) {// active row index less than used range row index
                                if (rowdata[i] && xlObj.XLEdit.getPropertyValue(i - 1, activecell.colIndex, "value2") && xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2")) {//active column  next row is non - empty
                                    while (xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2") && i <= usedrange.rowIndex)
                                        i++;
                                    rowCount = i - 1;
                                }
                                else {//active column in next row is empty 
                                    while (!xlObj.XLEdit.getPropertyValue(i, activecell.colIndex, "value2") && i < sheet.rowCount)
                                        i++
                                    rowCount = i;
                                }
                            }
                            else //Active row greater or equal to used range
                                rowCount = sheet.rowCount - 1;
                            (rowCount === sheet.rowCount) && --rowCount;
                            this._navigateCell(rowCount, activecell.colIndex, key);
                        }
                    }
                    else if (shiftKey) {
                        if (keyCode === 37 && endCell.colIndex > 0)
                            sheet._endCell = { rowIndex: endCell.rowIndex, colIndex: endCell.colIndex - 1 };
                        else if (keyCode === 38 && endCell.rowIndex > 0){
							_isChanged = true;
                            sheet._endCell = { rowIndex: endCell.rowIndex - 1, colIndex: endCell.colIndex };
						}
                        else if (keyCode === 39 && endCell.colIndex < colCount)
                            sheet._endCell = { rowIndex: endCell.rowIndex, colIndex: endCell.colIndex + 1 };
                        else if (keyCode === 40 && endCell.rowIndex < rowCount){
                            _isChanged = true;
							sheet._endCell = { rowIndex: endCell.rowIndex + 1, colIndex: endCell.colIndex };
						}
                        if ((sheet.rowCount === sheet._endCell.rowIndex || sheet.colCount === sheet._endCell.colIndex) && xlObj.model.scrollSettings.scrollMode === "normal")
                            return;
                        if ((sheet.rowCount === sheet._endCell.rowIndex || sheet.colCount === sheet._endCell.colIndex) && !xlObj.model.scrollSettings.allowScrolling)
                            return;
                        if (xlObj.model.scrollSettings.allowScrolling) {
                            if (sheet.rowCount === sheet._endCell.rowIndex && keyCode === 40)
                                xlObj._scrollContent({ x: 0, y: +xlObj.model.rowHeight });
                            else if (sheet.colCount - 1 === sheet._endCell.colIndex && keyCode === 39)
                                xlObj._scrollContent({ x: +xlObj.model.columnWidth, y: 0 });
                        }
                        if (this._isHiddenCell(sheet._endCell)) {
                            obj = { rowIndex: sheet._endCell.rowIndex, colIndex: sheet._endCell.colIndex };
                            this._skipHiddenRowsAndCols(obj, key);
                            sheet._endCell.rowIndex = obj.rowIndex;
                            sheet._endCell.colIndex = obj.colIndex;
                        }
                        if (xlObj._isPropExists([[sheet._startCell.rowIndex, sheet._endCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]], "merge") || xlObj._isPropExists([[sheet._startCell.rowIndex, sheet._endCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]], "isMHide")) //Row wise support
                            isMergeCell = true;
                        if (xlObj.XLEdit.getPropertyValue(sheet._endCell.rowIndex, sheet._endCell.colIndex, "isMHide") || xlObj.XLEdit.getPropertyValue(sheet._endCell.rowIndex, sheet._endCell.colIndex, "merge") || (_isChanged && xlObj._isPropExists([[sheet._endCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]], "merge") || xlObj._isPropExists([[sheet._endCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]], "isMHide")) || isMergeCell) {
							_isChanged = false;
                            xlObj.XLSelection._processBoundary();
							if(keyCode === 37 || keyCode == 38){
								startCell = sheet._endCell;
								sheet._endCell = sheet._startCell;
								sheet._startCell = startCell;
							}
						}
                        if (sheet._endCell.colIndex <= sheet._leftCol.idx || sheet._endCell.colIndex >= sheet._rightCol.idx || sheet._endCell.rowIndex <= sheet._topRow.idx || sheet._endCell.rowIndex >= sheet._bottomRow.idx)
                            this._scrollToCell(sheet._endCell, key);
                        xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                        if (xlObj.model.allowAutoFill)
                            xlObj.XLDragFill.positionAutoFillElement();
                    }
                    else {
                        key = { keyCode: keyCode, shiftKey: false, ctrlKey: false, altKey: false };
                        if (keyCode === 37 && activecell.colIndex > 0)  // min column count reached? left arrow
                            this._navigateCell(activecell.rowIndex, activecell.colIndex - 1, key);//left
                        else if (keyCode === 38 && activecell.rowIndex > 0) // min row index reached?
                            this._navigateCell(activecell.rowIndex - 1, activecell.colIndex, key);//up
                        else if (keyCode === 39 && activecell.colIndex < colCount) // max col count reached?
                            this._navigateCell(activecell.rowIndex, activecell.colIndex + 1, key);//right
                        else if (keyCode === 40 && activecell.rowIndex < rowCount)  // max row count reached?
                            this._navigateCell(activecell.rowIndex + 1, activecell.colIndex, key);//down
                        else
                            return false;
                    }
                }
            }
        },

        _navigateCell: function (rowindex, colindex, key) { // select cell by rowindex and colindex
            var colgrp, cellInfo, isSpan, activeCell, cell, actCell, leftCol, actCellMerge, rows, rowIdx, colIdx, rIdx, cIdx, hiddenHgt, hiddenWth, obj = { rowIndex: rowindex, colIndex: colindex },
                xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), cont = xlObj._getContent(sheetIdx),
                hScroll = cont.find("#hscrollBar").data("ejScrollBar"), vScroll = cont.find("#vscrollBar").data("ejScrollBar"),
                content = cont.find(".e-content"), xlEdit = xlObj.XLEdit, scrollReach = false, cntOffsetWidth = content[0].offsetWidth;
            hiddenHgt = hiddenWth = 0;
            if ((sheet.rowCount === obj.rowIndex || sheet.colCount === obj.colIndex) && (xlObj.model.scrollSettings.scrollMode === "normal"))
                return;
            if (sheet.rowCount === obj.rowIndex && xlObj.model.scrollSettings.allowVirtualScrolling)
                return;
            if ((sheet.rowCount === obj.rowIndex || sheet.colCount === obj.colIndex) && !xlObj.model.scrollSettings.allowScrolling)
                return;
            if (sheet.rowCount === obj.rowIndex) {
                xlObj.XLScroll._scrollY(sheetIdx);
                scrollReach = true;
            }
            if (!xlObj._isAutoWHMode && sheet.colCount === obj.colIndex && xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite) {
                xlObj.XLScroll._scrollX(sheetIdx);
                scrollReach = true;
            }
            this._navToCell(rowindex, colindex);
            activeCell = xlObj.getCell(obj.rowIndex, obj.colIndex);
            if (this._isHiddenCell(obj))
                this._skipHiddenRowsAndCols(obj, key);
            actCellMerge = xlEdit.getPropertyValue(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, "merge");
            if (actCellMerge && xlEdit.getPropertyValue(obj.rowIndex, obj.colIndex, "mergeIdx"))
                this._updateMergeRange(actCellMerge, obj, key);
            sheet._activeCell = sheet._endCell = sheet._startCell = obj;
            if ((xlObj.XLEdit.getPropertyValue(obj.rowIndex, obj.colIndex, "mergeIdx") || xlObj.hasSpan(obj))) {
                xlObj.XLSelection._processBoundary();
                sheet._activeCell = sheet._startCell;
                activeCell = xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex);
                isSpan = true;
            }
            cellInfo = xlObj._getCellInfo(obj, sheetIdx);
            leftCol = sheet._leftCol.idx > 0 ? sheet._leftCol.idx - 1 : sheet._leftCol.idx;
            if (xlObj.model.scrollSettings.allowScrolling && (sheet._bottomRow.idx <= obj.rowIndex) && (key.keyCode === 40 || (key.keyCode === 13 && !key.shiftKey)) && !scrollReach && !sheet._isFreezed) {
                vScroll._scrollData.step = 1;
                if ((key.ctrlKey && key.keyCode === 40))
                    xlObj.XLScroll._scrollSelectedPosition(sheetIdx, xlObj.getActiveCell(sheetIdx));
                else
                    vScroll.scroll(vScroll.value() + (xlObj._isFrozen(sheet.frozenRows) ? xlObj._getRowHeight(sheet._ftopRowIdx, sheetIdx) : cellInfo.height), true);
            }
            else if (xlObj.model.scrollSettings.allowScrolling && !xlObj._isFrozen(sheet.frozenRows) && (sheet._topRow.idx > obj.rowIndex) && (key.keyCode === 38 || (key.keyCode === 13 && key.shiftKey)) && !scrollReach && !xlObj._hasClass(cont.find("tr").eq(obj.rowIndex)[0], 'e-fr-hide')) {
                vScroll._scrollData.step = -1;
                if (obj.rowIndex > 0)
                    (key.ctrlKey) ? vScroll.scroll(cellInfo.top , true) : vScroll.scroll(vScroll.value() - cellInfo.height, true);
                else
                    vScroll.scroll(0);
            }
            if (xlObj.model.scrollSettings.allowScrolling && colindex >= sheet._rightCol.idx && cntOffsetWidth <= ((sheet._colWidthCollection[sheet._activeCell.colIndex] - sheet._colWidthCollection[leftCol]) + cellInfo.width) && (key.keyCode === 39 || (key.keyCode === 9 && !key.shiftKey)) && !scrollReach && !sheet._isFreezed) {
                hScroll._scrollData.step = 1;
                if ((key.ctrlKey && key.keyCode === 39))
                    hScroll.scroll((cellInfo.left + cellInfo.width) - hScroll._scrollData.handleSpace, true);
                else
                    hScroll.scroll(hScroll.value() + (xlObj._isFrozen(sheet.frozenColumns) ? xlObj._getColWidth(sheet._fleftColIdx, sheetIdx) : cellInfo.width), true);
            }
            else if (xlObj.model.scrollSettings.allowScrolling && !xlObj._isFrozen(sheet.frozenColumns) && (leftCol >= obj.colIndex) && (key.keyCode === 37 || (key.keyCode === 9 && key.shiftKey)) && !scrollReach && !sheet._isFreezed) {
                hScroll._scrollData.step = -1;
                if (obj.colIndex > 0)
                    (key.ctrlKey) ? hScroll.scroll(cellInfo.left, true) : hScroll.scroll(hScroll.value() - cellInfo.width, true);
                else
                    hScroll.scroll(0);
            }
            else if (xlObj.model.scrollSettings.allowScrolling && key.ctrlKey && !scrollReach && !sheet._isFreezed) {
                if (key.keyCode === 37)
                    hScroll.scroll(cellInfo.left, true)
                else if (key.keyCode === 38)
                    vScroll.scroll(cellInfo.top, true);
                else if (key.keyCode === 39)
                    hScroll.scroll(cellInfo.left - hScroll._scrollData.handleSpace, true);
                else
                    xlObj.XLScroll._scrollSelectedPosition(sheetIdx, xlObj.getActiveCell(sheetIdx));
            }
            colgrp = cont.find("col");
            rows = $(xlObj.getRows(sheetIdx)[1]), rowIdx = sheet._startCell.rowIndex, colIdx = sheet._startCell.colIndex;
            if ((cntOffsetWidth >= cellInfo.left || content.offset().left + cntOffsetWidth >= (cellInfo.left + cellInfo.width)) && (key.keyCode == 39 || (key.keyCode == 9 && !key.shiftKey))) 
                xlObj.XLSelection.selectRange(sheet._startCell, sheet._startCell);
            else if (!colgrp.eq(colIdx).hasClass("e-fc-hide") || (key.keyCode == 37 || (key.keyCode == 9 && key.shiftKey))) 
                xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
            else if (!rows.eq(rowIdx).hasClass("e-fr-hide") && (key.keyCode == 38 || (key.keyCode == 13 && key.shiftKey))) 
                xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
            else if (((content.offset().top + content[0].offsetHeight) >= cellInfo.top || content.offset().top + content[0].offsetHeight >= (cellInfo.top + cellInfo.height)) && (key.keyCode == 40 || (key.keyCode == 13 && !key.shiftKey))) 
                xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
            if (isSpan) {
                if (key.keyCode === 37 || (key.shiftKey && key.keyCode === 9))
                    obj.colIndex = sheet._startCell.colIndex;
                else if (key.keyCode === 38 || (key.shiftKey && key.keyCode === 13))
                    obj.rowIndex = sheet._startCell.rowIndex;
                else if (key.keyCode === 39 || key.keyCode === 9)
                    obj.colIndex = sheet._endCell.colIndex;
                else if (key.keyCode === 40 || key.keyCode === 13)
                    obj.rowIndex = sheet._endCell.rowIndex;
                sheet._activeCell = obj;
            }
            sheet._startCell = obj;
            while ((key.keyCode === 37 || (key.shiftKey && key.keyCode === 9)) && xlObj._hasClass(colgrp[sheet._startCell.colIndex], 'e-c-hide')) {
                xlObj._removeClass(colgrp[sheet._startCell.colIndex], 'e-fc-hide');
                sheet._startCell.colIndex--;
            }
            while ((key.keyCode === 38 || (key.shiftKey && key.keyCode === 13)) && xlObj._hasClass(cont.find('tr')[sheet._startCell.rowIndex], 'e-r-hide')) {
                xlObj._removeClass(cont.find('tr')[sheet._startCell.rowIndex], 'e-fr-hide');
                sheet._startCell.rowIndex--;
            }
            while ((key.keyCode === 39 || key.keyCode === 9) && xlObj._hasClass(colgrp[sheet._startCell.colIndex], 'e-c-hide'))
                sheet._startCell.colIndex++;
            while ((key.keyCode === 40 || key.keyCode === 13) && xlObj._hasClass(cont.find('tr')[sheet._startCell.rowIndex], 'e-r-hide'))
                sheet._startCell.rowIndex++;
            rIdx = sheet._startCell.rowIndex, cIdx = sheet._startCell.colIndex;
			if(xlObj.model.selectionSettings.selectionType === "row")
			    xlObj.XLSelection.selectRows(rIdx, rIdx);
			else if( xlObj.model.selectionSettings.selectionType === "column")
			    xlObj.XLSelection.selectColumns(cIdx, cIdx);
			if (xlObj.model.showRibbon)
			    xlObj.XLRibbon._updateRibbonIcons();
            if (xlObj.model.allowAutoFill)
                xlObj.XLDragFill.positionAutoFillElement();
        },

        _navToCell: function (rowIdx, colIdx) {
            var xlObj = this.XLObj, actSheet = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(), hiddenHgt, hiddenWth;
			hiddenHgt = hiddenWth = 0;
            if (sheet._isFreezed) {
                if (sheet._frozenRows - 1 <= rowIdx && rowIdx < sheet._ftopRowIdx) {
                    for (i = rowIdx; i < sheet._ftopRowIdx; i++)
                        hiddenHgt += sheet.rowsHeightCollection[i];
                    xlObj._scrollContent({ y: -hiddenHgt });
                }
                else if (sheet._frozenRows - 1 <= rowIdx && rowIdx > sheet._bottomRow.idx) {
                    for (i = sheet._bottomRow.idx; i < rowIdx; i++)
                        hiddenHgt += sheet.rowsHeightCollection[i];
                    xlObj._scrollContent({ y: +hiddenHgt });
                }
                    
                if (sheet._frozenColumns - 1 <= colIdx && colIdx < sheet._fleftColIdx) {
                    for (i = colIdx; i < sheet._fleftColIdx; i++)
                        hiddenWth += sheet.columnsWidthCollection[i];
                    xlObj._scrollContent({ x: -hiddenWth });
                }
                else if (sheet._frozenColumns - 1 <= colIdx && colIdx > sheet._rightCol.idx) {
                    for (i = sheet._rightCol.idx; i < colIdx; i++)
                        hiddenWth += sheet.columnsWidthCollection[i];
                    xlObj._scrollContent({ x: +hiddenWth });
                }
            }
        },
        _navigateRange: function (args, key) { // active cell changes at range of cells,rows,columns
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), startcell = sheet._startCell, endcell = sheet._endCell, activecell = sheet._activeCell,
                minrowindex = startcell.rowIndex < endcell.rowIndex ? startcell.rowIndex : endcell.rowIndex,
                maxrowindex = startcell.rowIndex > endcell.rowIndex ? startcell.rowIndex : endcell.rowIndex,
                mincolindex = startcell.colIndex < endcell.colIndex ? startcell.colIndex : endcell.colIndex,
                maxcolindex = startcell.colIndex > endcell.colIndex ? startcell.colIndex : endcell.colIndex;
            if (args == "Tab") {
                if (activecell.colIndex < maxcolindex)
                    this._navigateRow("Forward", key);
                else if (activecell.rowIndex < maxrowindex)
                    this._updateActiveCell(activecell.rowIndex + 1, mincolindex, key, args);
                else if (activecell.rowIndex == maxrowindex && activecell.colIndex == maxcolindex)
                    this._updateActiveCell(minrowindex, mincolindex, key, args);
                else
                    return false;
            }
            else if (args == "Enter") {
                if (activecell.rowIndex < maxrowindex)
                    this._navigateCol("Forward", key);
                else if (activecell.colIndex < maxcolindex)
                    this._updateActiveCell(minrowindex, activecell.colIndex + 1, key, args);
                else if (activecell.rowIndex == maxrowindex && activecell.colIndex == maxcolindex)
                    this._updateActiveCell(minrowindex, mincolindex, key, args);
                else
                    return false;
            }
            else if (args == "ShiftTab") {
                if (activecell.colIndex > mincolindex)
                    this._navigateRow("Backward", key);
                else if (activecell.rowIndex > minrowindex)
                    this._updateActiveCell(activecell.rowIndex - 1, maxcolindex, key, args);
                else if (activecell.rowIndex == minrowindex && activecell.colIndex == mincolindex)
                    this._updateActiveCell(maxrowindex, maxcolindex, key, args);
                else
                    return false;
            }
            else { // shift enter
                if (activecell.rowIndex > minrowindex)
                    this._navigateCol("Backward", key);
                else if (activecell.colIndex > mincolindex)
                    this._updateActiveCell(maxrowindex, activecell.colIndex - 1, key, args);
                else if (activecell.rowIndex == minrowindex && activecell.colIndex == mincolindex)
                    this._updateActiveCell(maxrowindex, maxcolindex, key, args);
                else
                    return false;
            }
        },

        _navigateRow: function (args, key) { // active cell changes at single row
            var idx, action, xlObj = this.XLObj, activecell = xlObj.getSheet(xlObj.getActiveSheetIndex())._activeCell;
            if (args === "Forward") {
                idx = 1;
                action = "Tab";
            }
            else {
                idx = -1;
                action = "ShiftTab";
            }
            this._updateActiveCell(activecell.rowIndex, activecell.colIndex + idx, key, action);
        },

        _navigateCol: function (args, key) { // active cell changes at single column
            var idx, action, xlObj = this.XLObj, activecell = xlObj.getSheet(xlObj.getActiveSheetIndex())._activeCell;
            if (args === "Forward") {
                idx = 1;
                action = "Enter";
            }
            else {
                idx = -1;
                action = "ShiftEnter";
            }
            this._updateActiveCell(activecell.rowIndex + idx, activecell.colIndex, key, action);
        },

        _updateActiveCell: function (rowindex, colindex, key, args) { // to update active cell by removing existing active cell
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), activecell = sheet._activeCell;
            xlObj._removeClass(xlObj.getCell(activecell.rowIndex, activecell.colIndex), "e-activecell");
            sheet._activeCell = { rowIndex: rowindex, colIndex: colindex };
            if (key && this._isHiddenCell(sheet._activeCell))
                this._skipHiddenRowsAndCols(sheet._activeCell, key, true, args);
            if (this._isMergedCell(sheet._activeCell))
                this._skipMergedCells(sheet._activeCell, key);
            this._scrollToCell(sheet._activeCell, key);
            xlObj.addClass(xlObj.getCell(sheet._activeCell.rowIndex, sheet._activeCell.colIndex), "e-activecell")
            if(xlObj.model.allowFormulaBar)
            xlObj.updateFormulaBar();
            xlObj.setSheetFocus();
        },

        _isValidParameter: function (val) {
            var index = val.indexOf("(");
            if (index > -1) {
                val = val.split("(");
                return val[1].length > 0;
            }
            return true;
        },

        _skipHiddenRowsAndCols: function (obj, key, inRange, args) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), canIterate = true;
            if (inRange)
                this._navigateRange(args, key);
            else {
                if ((key.keyCode === 37 || (key.keyCode === 9 && key.shiftKey) || (key.keyCode === 39 && key.ctrlKey)) && obj.colIndex)
                    obj.colIndex--;
                else if ((key.keyCode === 38 || (key.keyCode === 13 && key.shiftKey) || (key.keyCode === 40 && key.ctrlKey)) && obj.rowIndex)
                    obj.rowIndex--;
                else if ((key.keyCode === 39 || key.keyCode === 9 || (key.keyCode === 37 && key.ctrlKey)) && obj.colIndex < sheet.colCount)
                    obj.colIndex++;
                else if ((key.keyCode === 40 || key.keyCode === 13 || (key.keyCode === 38 && key.ctrlKey)) && obj.rowIndex < sheet.rowCount)
                    obj.rowIndex++;
                else
                    canIterate = false;
                if (this._isHiddenCell(obj) && canIterate)
                    this._skipHiddenRowsAndCols(obj, key);
                else if (!canIterate) {
                    if ((key.keyCode === 37 || (key.keyCode === 9 && key.shiftKey)) && !obj.colIndex)
                        obj.colIndex = (key.keyCode === 37 && key.shiftKey) ? sheet._endCell.colIndex + 1 : sheet._startCell.colIndex;
                    else if ((key.keyCode === 38 || (key.keyCode === 13 && key.shiftKey)) && !obj.rowIndex)
                        obj.rowIndex = (key.keyCode === 38 && key.shiftKey) ? sheet._endCell.rowIndex + 1 : sheet._startCell.rowIndex;
                }
            }
        },

        _isHiddenCell: function (cellIdx) {
            return this.XLObj.XLEdit.getPropertyValue(0, cellIdx.colIndex, "isCHide") || this.XLObj.XLEdit.getPropertyValue(cellIdx.rowIndex, 0, "isRHide") || false;
        },

        _isMergedCell: function (cellIdx) {
            return this.XLObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "isMHide") || this.XLObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "merge");
        },

        _skipMergedCells: function (obj, key, xtendSelection) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()), startcell = sheet._startCell,
                endcell = sheet._endCell, canIterate = true, regx = xlObj._rcRegx, isSelected = false;
            minr = startcell.rowIndex < endcell.rowIndex ? startcell.rowIndex : endcell.rowIndex,
            maxr = startcell.rowIndex > endcell.rowIndex ? startcell.rowIndex : endcell.rowIndex,
            minc = startcell.colIndex < endcell.colIndex ? startcell.colIndex : endcell.colIndex,
            maxc = startcell.colIndex > endcell.colIndex ? startcell.colIndex : endcell.colIndex;
            if (key.shiftKey && key.keyCode === 9)
                obj.colIndex--;
            else if (key.keyCode === 9)
                obj.colIndex++;
            else if (key.shiftKey && key.keyCode === 13)
                obj.rowIndex--;
            else if (key.keyCode === 13)
                obj.rowIndex++;
            else
                canIterate = false;
            if (obj.colIndex > maxc) {
                obj.colIndex = minc;
                obj.rowIndex = (obj.rowIndex === maxr ? minr : obj.rowIndex + 1);
            }
            else if (obj.colIndex < minc) {
                obj.colIndex = maxc;
                obj.rowIndex = (obj.rowIndex === minr ? maxr : obj.rowIndex - 1);
            }
            else if (obj.rowIndex > maxr) {
                obj.rowIndex = minr;
                obj.colIndex = (obj.colIndex === maxc ? minc : obj.colIndex + 1);
            }
            else if (obj.rowIndex < minr) {
                obj.rowIndex = maxr;
                obj.colIndex = (obj.colIndex === minc ? maxc : obj.colIndex - 1);
            }
            if (this._isMergedCell(obj) && canIterate)
                this._skipMergedCells(obj, key);
        },

        _updateMergeRange: function (merge, obj, key) {
            var xlObj = this.XLObj, colspan = merge.mSpan.colSpan - 1, rowspan = merge.mSpan.rowSpan - 1;
            if (!key.shiftKey && (key.keyCode === 39 || key.keyCode === 9))
                obj.colIndex = obj.colIndex + colspan;
            else if (!key.shiftKey && (key.keyCode === 40 || key.keyCode === 13))
                obj.rowIndex = obj.rowIndex + rowspan;
        },

        _isRangeMerged: function (cells) {
            var mergeCells, obj = {}, xlObj = this.XLObj, cell = cells[0], merge = xlObj.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "merge");
            if (merge) {
                obj = { rowIndex: cells[0].rowIndex + merge.mSpan.rowSpan - 1, colIndex: cells[0].colIndex + merge.mSpan.colSpan - 1 };
                mergeCells = xlObj._getSelectedRange(cells[0], obj);
                if (mergeCells.length === cells.length)
                    return true;
            }
        },

        _scrollToCell: function (obj, key) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), cellInfo = xlObj._getCellInfo(obj, sheetIdx),
                sheet = xlObj.getSheet(sheetIdx), cont = xlObj._getContent(sheetIdx), content = cont.find(".e-content"),
                hScroll = cont.find("#hscrollBar").data("ejScrollBar"), vScroll = cont.find("#vscrollBar").data("ejScrollBar");
            if (xlObj.model.scrollSettings.scrollMode === "normal" && sheet.colCount - 1 === obj.colIndex)
                return;
            if (sheet._bottomRow.idx > 0 && obj.rowIndex > sheet._bottomRow.idx - 1 && sheet.rowCount - 1 > obj.rowIndex && key.keyCode === 40)
                 vScroll.scroll(vScroll.value() + cellInfo.height, true);
            else if (obj.rowIndex - 1 < sheet._topRow.idx && key.keyCode === 38) {
                vScroll._scrollData.step = -1;
                (obj.rowIndex > 0) ? vScroll.scroll(cellInfo.top, true) : vScroll.scroll(0);
            }
            else if (obj.colIndex < sheet._leftCol.idx)
                (obj.colIndex > 0) ? hScroll.scroll(hScroll.value() - cellInfo.width, true) : hScroll.scroll(0);
            else if (content[0].offsetWidth <= (cellInfo.left + cellInfo.width)) {
                    if (key.keyCode === 39) 
                        (sheet.colCount === obj.colIndex + 1) ? xlObj.XLScroll._scrollX(sheetIdx) : hScroll.scroll(hScroll.value() + cellInfo.width, true);
                    else if (key.keyCode === 37) {
                        hScroll._scrollData.step = -1;
                        hScroll.scroll(cellInfo.left, true);
                    }
            }              
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.cellType = function (obj) {
        this.XLObj = obj;
		this._isIntrnlUpdate = false;
    };

    ej.spreadsheetFeatures.cellType.prototype = {
        _renderControls: function (rowIndex, colIndex, sheetIndex, cellType, isCntnrUpdated) {
            if (!cellType)
                return;
            var id, cell, data, cont, index, dataRange, xlObj = this.XLObj, browser = xlObj._browserDetails.name, actSheetIndex, sheetIdx = xlObj._getSheetIndex(sheetIndex), $cell = xlObj.getCell(rowIndex, colIndex, sheetIdx), sheet = xlObj.getSheet(sheetIdx), value = xlObj.XLEdit.getPropertyValue(rowIndex, colIndex, 'value2', sheetIdx), cntrl = cellType['type'], headerTxt = xlObj._generateHeaderText(colIndex + 1),
                container = xlObj._dataContainer.sheetCellType, width = xlObj._getColWidth(colIndex, sheetIndex), height = xlObj._getRowHeight(rowIndex, sheetIndex), propVal = xlObj.XLEdit.getPropertyValue(rowIndex, colIndex, 'cellType'), index = (propVal > -1) ? propVal : xlObj.getObjectLength(container);
			xlObj._textClip(rowIndex, colIndex, 'delete', '', true);
			xlObj._textClip(rowIndex, colIndex, 'add', '');
			if ($cell)
			    cell = $cell[0];
            xlObj.addClass(cell, 'e-cellreadonly');
			if(!xlObj._dupDetails)
				if(propVal)
					cellType['isChecked'] = container[index]['isChecked'];
				else
					sheet.cellTypes.push({ 'range': xlObj._getAlphaRange(sheetIndex, rowIndex, colIndex, rowIndex, colIndex), 'settings': cellType });
            switch (cntrl) {
                case 'Button':
                    id = xlObj._id + '_btn_' + sheetIdx + headerTxt + (rowIndex + 1);
					xlObj.XLFormat._writeCssRules('e-btncls' + rowIndex + colIndex , 'border: 0px; vertical-align: middle;padding: 0px;color:' + cellType['color'] + ';background:' + cellType['background-color'] + ';', true, true);
                    if (cell)
                        cell.innerHTML = '<button id =' + id + ' class = "e-btncls'+ rowIndex + colIndex + '"></button>';
					if (cell && (browser === 'mozilla' || browser === 'msie')) {
						xlObj.addClass(cell, 'e-btnhgt');
						xlObj.addClass($cell.parents('.e-table')[0],'e-btnhgt');
					}
                    if (!isCntnrUpdated) {
                        data = { 'type': cntrl, 'id': id, 'text': cellType['text'] || value || cellType['type'] + headerTxt + (rowIndex + 1), 'color': cellType['color'] || '', 'background-color': cellType['background-color'] || '' };
                        container[index] = data;
                        xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': { 'cellType': index }, 'sheetIdx': sheetIdx });
                    }
                    $('#' + id).ejButton({ type: "button", width: '100%', height: '100%', text: cellType['text'] || value || cellType['type'] + headerTxt + (rowIndex + 1), create: $.proxy(this._onButtonCreate), click: $.proxy(this.onButtonClick), cssClass: cellType['class'] || '' });
                    break;
                case 'CheckBox':
                    id = xlObj._id + '_chk_' + sheetIdx + headerTxt + (rowIndex + 1);
                    cell && (cell.innerHTML = '<input id =' + id + ' style = "" />');
                    if (!isCntnrUpdated) {
 						data = { 'type': cntrl, 'id': id, 'isChecked': cellType['isChecked'] || (value && value.toLowerCase() === 'true') || false };
 						container[index] = data;
						cont = xlObj.XLEdit._parseValue(data['isChecked'], { rowIndex: rowIndex, colIndex: colIndex });
						cont['cellType'] = index;
						xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': cont, 'sheetIdx': sheetIdx });
						cell && (cell.lastChild.textContent = '');
                    }
                    $('#' + id).ejCheckBox({ size: 'small', change: $.proxy(this.onActiveStateChange), checked: data['isChecked'], cssClass: cellType['class'] || '' });
                    break;
                case 'DropDownList':
					actSheetIndex = cellType['dataSourceSheetIndex'] || sheetIdx;
                    id = xlObj._id + '_drpdwn_' + sheetIdx + headerTxt + (rowIndex + 1), dataRange = cellType['dataSourceRange'] && xlObj.getRangeIndices(cellType['dataSourceRange']);
                    cell && (cell.innerHTML = '<input id =' + id + ' />');
                    if (actSheetIndex !== sheetIdx && !xlObj.getSheet(actSheetIndex)._isLoaded)
                        xlObj._initSheet(actSheetIndex);
                    if (xlObj.isUndefined(cellType["selectedIndex"]) && value) {
                        var dSrc, field, i;
                        dSrc = (cellType['dataSource'] || xlObj.getRangeData({ range: dataRange, sheetIdx: actSheetIndex }));
                        field = cellType['field'] = (cellType['field'] || 'value2');
                        i = dSrc.length;
                        while (--i >= 0) {
                            if (dSrc[i][field] === value) {
                                cellType["selectedIndex"] = i;
                                break;
                            }
                        }
                    }
                    if (!isCntnrUpdated) {
                        data = { 'type': cntrl, 'id': id, 'text': value, 'style': '', 'dataSource': cellType['dataSource'] || '', 'dataSourceRange': cellType['dataSourceRange'] || '', 'selectedIndex': cellType['selectedIndex'] > -1 ? cellType['selectedIndex'] : -1, 'dataSourceSheetIndex': actSheetIndex };
                        container[index] = data;
                        xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': { 'cellType': index }, 'sheetIdx': sheetIdx });
                    }
                    if(cellType['dataSourceRange']){
						var datacells = xlObj._getSelectedRange({ rowIndex: dataRange[0], colIndex: dataRange[1] }, { rowIndex: dataRange[2], colIndex: dataRange[3] }),  ddlCells = xlObj.XLEdit._getPropWithCellIdx([ datacells[0].rowIndex, datacells[0].colIndex, datacells[datacells.length - 1].rowIndex, datacells[datacells.length - 1].colIndex ], "ddlRange", actSheetIndex);
						if (ddlCells.length === 0)
							xlObj.updateUniqueData( { 'ddlRange': [{ rowIndex: rowIndex, colIndex: colIndex, sheetIndex: sheetIdx }] }, [ datacells[0].rowIndex, datacells[0].colIndex, datacells[datacells.length - 1].rowIndex, datacells[datacells.length - 1].colIndex ],'', actSheetIndex );
						else
							for(var j = 0; j < datacells.length; j++){
								ddlCells = xlObj.XLEdit.getPropertyValue(datacells[j].rowIndex, datacells[j].colIndex, 'ddlRange', actSheetIndex)
								if(ddlCells){
									ddlCells.push({ rowIndex: rowIndex, colIndex: colIndex });
									xlObj.XLEdit._updateDataContainer({ rowIndex: datacells[j].rowIndex, colIndex: datacells[j].colIndex }, { 'dataObj': {'ddlRange': ddlCells }, 'sheetIdx': actSheetIndex });
								}
								else
									xlObj.XLEdit._updateDataContainer({ rowIndex: datacells[j].rowIndex, colIndex: datacells[j].colIndex }, { 'dataObj': {'ddlRange': [{ rowIndex: rowIndex, colIndex: colIndex }]}, 'sheetIdx': actSheetIndex });
							}
					}
					$('#' + id).ejDropDownList({ width: '100%', height: xlObj.model.rowHeight - 1, change: $.proxy(this.onActiveValueChange), dataSource: cellType['dataSource'] || xlObj.getRangeData({ range : dataRange, sheetIdx : actSheetIndex }), fields: { text: cellType['field'] || 'value2' }, watermarkText: cellType['watermarkText'] || 'Select an option', cssClass: cellType['class'] || '' , selectedIndex: cellType['selectedIndex'] > -1 ? cellType['selectedIndex'] : -1, beforePopupShown: $.proxy(this._onBeforePopupOpen) });
                    break;
                case 'DatePicker':
                    id = xlObj._id + '_dp_' + sheetIdx + headerTxt + (rowIndex + 1);
                    cell && (cell.innerHTML = '<input id =' + id + ' style = "height:' + (height - 1) +'px" />');
                    if (!isCntnrUpdated) {
                        data = { 'type': cntrl, 'id': id, 'text': value, 'style': '' };
                        container[index] = data;
                        xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': { 'cellType': index }, 'sheetIdx': sheetIdx });
                    }
                    $('#' + id).ejDatePicker({ width: '100%', height: xlObj.model.rowHeight - 1, value: cellType['value'] || (value && ej.parseDate(value)) || new Date(), create : $.proxy(this._onDateCreate), change: $.proxy(this.onDateChange), cssClass: cellType['class'] || '' });
                    break;
            }
        },
		
		addCellTypes: function (range, settings, sheetIndex){
			var xlObj = this.XLObj;
			if(!xlObj.model.allowCellType)
			    return;
			if(xlObj.model.isReadOnly)
				return;
			if(Array.isArray(range))
				range = xlObj._getAlphaRange(sheetIndex, range[0], range[1], range[2], range[3]);
			this._rangeCellTypes([{'range': range, 'settings': settings}], sheetIndex, true);
		},

        _rangeCellTypes: function (cellType, sheetIndex, isNew) {
            if (!cellType)
                return;
            var text, xlObj = this.XLObj, cont, headerTxt, actSheetIndex, refrshArr = [], browser = xlObj._browserDetails.name, sheetIdx = xlObj._getSheetIndex(sheetIndex), data, container = xlObj._dataContainer, cells, type, cell, id, dataRange, datacells, range, index, sheet = xlObj.getSheet(sheetIdx), celTypData,
			cellTypesLen = 0, rowIndex, colIndex;
			if(isNew || !sheet._isLoaded) {
				cellTypesLen = sheet.cellTypes.length;
				ej.merge(sheet.cellTypes, cellType);
				cellType = sheet.cellTypes;
			}
            for (var i = cellTypesLen, length = sheet.cellTypes.length; i < length; i++) {
                range = xlObj.getRangeIndices(cellType[i]['range']), type = cellType[i]['settings'],
                cells = xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
                if (cells.length === 1){
					xlObj._dupDetails= true;
                    this._renderControls(cells[0].rowIndex, cells[0].colIndex, sheetIdx, type);
					xlObj._dupDetails = false;
				}
                else {
                    for (var j = 0, len = cells.length; j < len; j++) {
						actSheetIndex = type['dataSourceSheetIndex'] || sheetIdx;
						rowIndex = cells[j].rowIndex; colIndex = cells[j].colIndex;
						xlObj._textClip(rowIndex, colIndex, 'delete', '', true);
						xlObj._textClip(rowIndex, colIndex, 'add');
                        index = xlObj.getObjectLength(container.sheetCellType);
                        cell = xlObj._isRowViewable(sheetIdx, rowIndex) ? xlObj.getCell(rowIndex, colIndex, sheetIdx)[0] : null;
						text = xlObj.XLEdit.getPropertyValue(rowIndex, colIndex, 'value2', sheetIdx);
                        cell && (cell.innerHTML = '');
                        if (!xlObj._hasClass(cell, 'e-cellreadonly'))
                            xlObj.addClass(cell, 'e-cellreadonly');
                        headerTxt = xlObj._generateHeaderText(colIndex + 1);
                        switch (type['type']) {
                            case 'Button':
                                id = xlObj._id + '_btn' + i + '_' + sheetIdx + headerTxt + (rowIndex + 1);
								xlObj.XLFormat._writeCssRules('e-btncls' + rowIndex + colIndex , 'border: 0px; vertical-align: middle; padding: 0px;color:' + (type['color'] || '') + ';background:' + (type['background-color'] || '') + ';', true, true);
								if (cell)
                                    cell.innerHTML = '<button id =' + id + ' type="button" class = "e-btncls'+ rowIndex + colIndex + '"></button>';
                                if(cell && browser === 'mozilla' || browser === 'msie') {
									xlObj.addClass(cell, 'e-btnhgt');
									xlObj.addClass($cell.parents('.e-table')[0],'e-btnhgt');                                    
								}
								if(isNew || !sheet._isLoaded){
									data = { 'type': type['type'], 'id': id, 'text': type['text'] || text || type['type'] + xlObj._generateHeaderText(cells[j].colIndex + 1) + (cells[j].rowIndex + 1), 'color': (type['color'] || ''), 'background-color': (type['background-color'] || '') };
									cont = { 'cellType': index };
								}
                                break;
                            case 'CheckBox':
                                id = xlObj._id + '_chk' + i + '_' + sheetIdx + headerTxt + (rowIndex + 1);
                                cell && (cell.innerHTML = '<input id =' + id + ' />');
								if(isNew || !sheet._isLoaded){
									if(text && ["false", "true", "yes", "no"].indexOf(text.toLowerCase()) === -1)
										text = '';
									data = { 'type': type['type'], 'id': id, 'isChecked': type['isChecked'] || text || false };
									cont = xlObj.XLEdit._parseValue(data['isChecked'], { rowIndex: rowIndex, colIndex: colIndex });
									cont['cellType'] = index;
									(data['isChecked'].toString().toLowerCase() === 'true') && (refrshArr.push({ 'type': data['type'], 'id': data['id'] }));
								}
								cell && (cell.lastChild.textContent = '');
                                break;
                            case 'DropDownList':
                                id = xlObj._id + '_drpdwn' + i + '_' + sheetIdx + headerTxt + (rowIndex + 1);
                                cell && (cell.innerHTML = '<input id =' + id + ' value = ' + text + ' />');
								data = { 'type': type['type'], 'id': id, 'style': '', 'dataSource': type['dataSource'] || '', 'dataSourceRange': type['dataSourceRange'] || '', 'selectedIndex': type['selectedIndex'] > -1 ? type['selectedIndex'] : '', 'dataSourceSheetIndex': actSheetIndex};
								dataRange = xlObj.getRangeIndices(type['dataSourceRange']), datacells = xlObj._getSelectedRange({ rowIndex: dataRange[0], colIndex: dataRange[1] }, { rowIndex: dataRange[2], colIndex: dataRange[3] });
                                if(isNew || !sheet._isLoaded){
									if(type['dataSourceRange']){
										var ddlCells = xlObj.XLEdit._getPropWithCellIdx([ datacells[0].rowIndex, datacells[0].colIndex, datacells[datacells.length - 1].rowIndex, datacells[datacells.length - 1].colIndex ], "ddlRange", actSheetIndex)
										if (ddlCells.length === 0)
											xlObj.updateUniqueData( { 'ddlRange': [{ rowIndex: rowIndex, colIndex: colIndex, sheetIndex: sheetIdx }] }, [ datacells[0].rowIndex, datacells[0].colIndex, datacells[datacells.length - 1].rowIndex, datacells[datacells.length - 1].colIndex ], '', actSheetIndex );
										else
											for(var k = 0; k < datacells.length; k++){
												ddlCells = xlObj.XLEdit.getPropertyValue(datacells[k].rowIndex, datacells[k].colIndex, 'ddlRange', actSheetIndex)
												if(ddlCells){
													ddlCells.push({ rowIndex: rowIndex, colIndex: colIndex, sheetIndex: sheetIdx });
													xlObj.XLEdit._updateDataContainer({ rowIndex: datacells[k].rowIndex, colIndex: datacells[k].colIndex }, { 'dataObj': {'ddlRange': ddlCells }, 'sheetIdx': actSheetIndex });
												}
												else
													xlObj.XLEdit._updateDataContainer({ rowIndex: datacells[k].rowIndex, colIndex: datacells[k].colIndex }, { 'dataObj': {'ddlRange': [{ rowIndex: rowIndex, colIndex: colIndex, sheetIndex: sheetIdx }]}, 'sheetIdx': actSheetIndex });
											}
									}
									if (actSheetIndex !== sheetIdx && !xlObj.getSheet(actSheetIndex)._isLoaded)
									    xlObj._initSheet(actSheetIndex);
									if (xlObj.isUndefined(type["selectedIndex"]) && text) {
									    var dSrc, field, k;
									    dSrc = type['dataSource'] || xlObj.getRangeData({ range: dataRange, sheetIdx: actSheetIndex });
									    field = type['field'] || 'value2';
									    if (!type['field'])
									        type['field'] = field;
									    k = dSrc.length;
									    while (--k >= 0) {
									        if (dSrc[k][field] === text) {
									            data["selectedIndex"] = k;
									            break;
									        }
									        if (k == 0)
									            delete data["selectedIndex"];
									    }
									}
									data['selectedIndex'] > -1 && (refrshArr.push({ 'type': data['type'], 'id': data['id'], 'selectedIndex': data['selectedIndex'] }));
									cont = { 'cellType': index };
								}
                                break;
                            case "DatePicker":
                                id = xlObj._id + '_dp' + i + '_' + sheetIdx + headerTxt + (rowIndex + 1);
                                cell && (cell.innerHTML = '<input id =' + id + ' value = ' + text + ' style = "height:' + (xlObj._getRowHeight(rowIndex, sheetIdx) - 1) + 'px" />');
                                if(isNew || !sheet._isLoaded){
									data = { 'type': type['type'], 'id': id, 'value': type['value'] || (text && ej.parseDate(text)) || new Date() };
									cont = { 'cellType': index };
									data['value'] && (refrshArr.push({ 'type': data['type'], 'id': data['id'], 'value': data['value'] }));
								}
                                break;
                        }
						if(isNew || !sheet._isLoaded){
							container.sheetCellType[index] = data;
							xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': cont, 'sheetIdx': sheetIdx });
						}
                    }
                    switch (type['type']) {
                        case 'Button':
                            $("[id^='" + xlObj._id + '_btn' + i + '_' + sheetIdx + "']").ejButton({ type: "button", width: '100%', height: '100%', text: text, create: $.proxy(this._onButtonCreate), click: $.proxy(this.onButtonClick), cssClass: cellType['class'] || ''  });
                            break;
                        case 'CheckBox':
                            $("[id^='" + xlObj._id + '_chk' + i + '_' + sheetIdx + "']").ejCheckBox({ change: $.proxy(this.onActiveStateChange), checked: false, cssClass: cellType['class'] || ''  });
                            break;
                        case 'DropDownList':
                           $("[id^='" + xlObj._id + '_drpdwn' + i + '_' + sheetIdx + "']").ejDropDownList({ width: '100%', height: xlObj.model.rowHeight - 1, change: $.proxy(this.onActiveValueChange), 'dataSource': type['dataSource'] || xlObj.getRangeData({ range : dataRange, sheetIdx : actSheetIndex}),fields: { text: type['field'] || 'value2' }, watermarkText: type['watermarkText'] || 'Select an option', cssClass: type['class'] || '' , selectedIndex: type['selectedIndex'] > -1 ? type['selectedIndex'] : '' , beforePopupShown: $.proxy(this._onBeforePopupOpen)});
                            break;
                        case "DatePicker":
                            $("[id^='" + xlObj._id + '_dp' + i + '_' + sheetIdx + "']").ejDatePicker({ width: '100%', height: xlObj.model.rowHeight - 1, value: type['value'] || new Date(), create : $.proxy(this._onDateCreate), change: $.proxy(this.onDateChange), cssClass: cellType['class'] || ''  });
                            break;
                    }
					for(var k = 0, kLen = refrshArr.length; k < kLen; k++){
						this._isIntrnlUpdate = true;
						if(refrshArr[k].type === 'CheckBox')
							$('#'+ refrshArr[k].id).length && $('#'+refrshArr[k].id).ejCheckBox('instance').option('checked', true);
						else if(refrshArr[k].type === 'DropDownList')
							$('#'+ refrshArr[k].id).length && $('#'+refrshArr[k].id).ejDropDownList('instance').option('selectedIndex', refrshArr[k]['selectedIndex']);
						else if(refrshArr[k].type === 'DatePicker')
							$('#'+ refrshArr[k].id).length && $('#'+refrshArr[k].id).ejDatePicker('instance').option('value', refrshArr[k]['value']);
						this._isIntrnlUpdate = false;
					}
                }
            }
        },
		
        removeCellTypes: function (aRange, sheetIdx) {
            var xlObj = this.XLObj;
		    if (xlObj.model.isReadOnly)
		        return;
		    var i, len, sheetIdx = xlObj._getSheetIndex(sheetIdx), range = xlObj._getRangeArgs(aRange, "object"), cells = xlObj.XLEdit._getPropWithCellIdx(range, 'cellType', sheetIdx);
			for(i = 0, len = cells.length; i < len; i++)
				this._removeControls(cells[i].rowIdx, cells[i].colIdx, sheetIdx);
		},

        _removeControls: function (rowIndex, colIndex, sheetIdx, cntnrUpdate) {
            var cell, xlObj = this.XLObj, sheetIdx =  xlObj._getSheetIndex(sheetIdx), container = xlObj._dataContainer, sheet = xlObj.getSheet(sheetIdx), index;
            if (!cntnrUpdate) {
                delete container.sheetCellType[container.sheets[sheetIdx][rowIndex][colIndex]['cellType']];
                delete container.sheets[sheetIdx][rowIndex][colIndex]['cellType'];
				index = this._rangeInColl(xlObj._getAlphaRange(sheetIdx, rowIndex, colIndex, rowIndex, colIndex), sheetIdx);
				(index > -1) && sheet.cellTypes.splice(index, 1);
            }
            if (xlObj._isRowViewable(sheetIdx, rowIndex)) {
                cell = xlObj.getCell(rowIndex, colIndex, sheetIdx)[0];
                cell.innerHTML = xlObj.XLEdit.getPropertyValue(rowIndex, colIndex, 'value2', sheetIdx) || '';
                xlObj._removeClass(cell, 'e-cellreadonly');
            }
        },

        onActiveValueChange: function (args) {
            var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet")
			if(xlObj.model.isReadOnly)
				return;
            var container = xlObj._dataContainer, cell = this.element.closest('td'), sheetIdx = xlObj.getActiveSheetIndex(), cellIndex = xlObj._getCellIdx(cell[0]), rowIndex = xlObj._getRowIdx(cellIndex.rowIndex, sheetIdx), colIndex = cellIndex.colIndex, cType = container.sheetCellType[container.sheets[sheetIdx][rowIndex][colIndex]['cellType']], dRange = cType['dataSourceRange'] && xlObj.getRangeIndices(cType['dataSourceRange']);
            cType['selectedIndex'] = args.itemId;
            xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': xlObj.XLEdit._parseValue(args.text, { rowIndex: rowIndex, colIndex: colIndex }) });
			if (dRange && (xlObj.XLEdit.getPropertyValue(dRange[0] + args.itemId, dRange[1], 'type') === "number"))
				xlObj.XLFormat.format({ 'type': "number"}, [rowIndex, colIndex, rowIndex, colIndex]);
            args.cellIndex = cellIndex;
            args.cellType = "dropdownlist";
            xlObj._trigger('cellSave', args);
            (xlObj.model.allowFormulaBar) && xlObj.updateFormulaBar();
        },

        onActiveStateChange: function (args) {
            var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet");
			if(xlObj.model.isReadOnly || xlObj.XLCellType._isIntrnlUpdate)
				return;
            var container = xlObj._dataContainer, text, cell = this.element.closest('td'), sheetIdx = xlObj.getActiveSheetIndex(), cellIndex = xlObj._getCellIdx(cell[0]), rowIndex = xlObj._getRowIdx(cellIndex.rowIndex, sheetIdx), colIndex = cellIndex.colIndex;
            container.sheetCellType[container.sheets[sheetIdx][cellIndex.rowIndex][colIndex]['cellType']]['isChecked'] = args.isChecked;
			if(['yes','no'].indexOf(xlObj.XLEdit.getPropertyValue(cellIndex.rowIndex, colIndex, 'value2').toString().toLowerCase()) > -1){
				if(args.isChecked)
					text = 'YES';
				else
					text = 'NO';
			}
			else
				text = args.isChecked.toString().toUpperCase();
			xlObj.XLEdit._updateDataContainer({ rowIndex: cellIndex.rowIndex, colIndex: colIndex }, { 'dataObj': xlObj.XLEdit._parseValue(text, { rowIndex: cellIndex.rowIndex, colIndex: colIndex }) });
			args.cellIndex = cellIndex;
			args.cellType = "checkbox";
            xlObj._trigger('cellSave', args);
			(xlObj.model.allowFormulaBar) && xlObj.updateFormulaBar();
        },
		
		_onDateCreate: function (args){
			var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet"), container = xlObj._dataContainer, cell = this.element.closest('td'), sheetIdx = xlObj.getActiveSheetIndex(), cellIndex = xlObj._getCellIdx(cell[0]), rowIndex = xlObj._getRowIdx(cellIndex.rowIndex, sheetIdx), colIndex = cellIndex.colIndex;
             xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': xlObj.XLEdit._parseValue(args.model.value.toLocaleString().split(', ')[0], { rowIndex: rowIndex, colIndex: colIndex }) });
		},

        onDateChange: function (args) {
            var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet");
			if(xlObj.model.isReadOnly)
				return;
            var container = xlObj._dataContainer, cell = this.element.closest('td'), sheetIdx = xlObj.getActiveSheetIndex(), cellIndex = xlObj._getCellIdx(cell[0]), rowIndex = xlObj._getRowIdx(cellIndex.rowIndex, sheetIdx), colIndex = cellIndex.colIndex;
            xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': xlObj.XLEdit._parseValue(args.model.value.toLocaleString().split(ej.isNullOrUndefined(args.model.value.toLocaleString().match(/[,]/)) ? ' ' : ', ')[0], { rowIndex: rowIndex, colIndex: colIndex }) });
            args.cellIndex = cellIndex;
            args.cellType = "datepicker";
            xlObj._trigger('cellSave', args);
        },
		
		_onButtonCreate: function (args){
			var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet"), container = xlObj._dataContainer, cell = this.element.closest('td'), sheetIdx = xlObj.getActiveSheetIndex(), cellIndex = xlObj._getCellIdx(cell[0]), rowIndex = xlObj._getRowIdx(cellIndex.rowIndex, sheetIdx), colIndex = cellIndex.colIndex;
			 xlObj.XLEdit._updateDataContainer({ rowIndex: rowIndex, colIndex: colIndex }, { 'dataObj': xlObj.XLEdit._parseValue(args.model.text, { rowIndex: rowIndex, colIndex: colIndex }) });
		},

        onButtonClick: function (args) {
            var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet");
			if(xlObj.model.isReadOnly)
			    return;
			args.cellIndex = xlObj._getCellIdx($(args.target).closest('td')[0]);
			args.cellType = "button";
			xlObj._trigger('cellClick', args);
        },
		
		_onBeforePopupOpen: function(args){
            var xlObj = this.element.closest(".e-spreadsheet").data("ejSpreadsheet"), sheetIdx = xlObj.getActiveSheetIndex(), container = xlObj._dataContainer, cell = this.element.closest('td'), cellIndex = xlObj._getCellIdx(cell[0]), rowIndex = cellIndex.rowIndex,
			colIndex = cellIndex.colIndex, ddlCont = container.sheetCellType[container.sheets[sheetIdx][rowIndex][colIndex]['cellType']], 
			actSheetIndex = ddlCont['dataSourceSheetIndex'] || sheetIdx, dataSource;
			!xlObj.getSheet(actSheetIndex)._isLoaded && xlObj._initSheet(actSheetIndex);
			dataSource = ddlCont['dataSource'] || xlObj.getRangeData({ range: xlObj.getRangeIndices(ddlCont['dataSourceRange']), sheetIdx: actSheetIndex });
			$('#' + ddlCont['id']).ejDropDownList('instance').option( "dataSource" , dataSource);
			$('#' + ddlCont['id']).ejDropDownList('instance').option( "selectedItemIndex" , ddlCont['selectedIndex']);
		},
		
		_rangeInColl: function(range, sheetIndex) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj._getSheetIndex(sheetIndex)), type = sheet.cellTypes;
            for (var i = 0, len = type.length; i < len; i++)
                if (type[i].range === range)
                    return i;
        },

        _rfrshCtrlText: function (cellInfo, val, sheetIdx) {
            var xlObj = this.XLObj, isUpdtDtcnr = true, cType, cTypeObj, selectedIndex;
            if (!xlObj.isUndefined(cellInfo.rowIndex) && !xlObj.isUndefined(cellInfo.colIndex)) {
                cellInfo = xlObj.getRangeData({ range: [cellInfo.rowIndex, cellInfo.colIndex, cellInfo.rowIndex, cellInfo.colIndex], property: ["cellType", "value"] })[0];
                val = cellInfo.value;
            }
            cType = xlObj._dataContainer.sheetCellType[cellInfo.cellType];
            if (cType) {
                switch (cType.type) {
                    case ej.Spreadsheet.CustomCellType.DropDownList:
                        cTypeObj = $("#" + cType.id).data("ej" + cType.type);
                        if (cTypeObj) {
                            selectedIndex = cTypeObj.selectedIndexValue;
                            cTypeObj._raiseEvents = false;
                            cTypeObj.selectItemByText(val);
                            cTypeObj._raiseEvents = true;
                            if (selectedIndex !== -1 && selectedIndex !== cTypeObj.selectedIndexValue)
                                cType.selectedIndex = cTypeObj.selectedIndexValue;
                            else
                                isUpdtDtcnr = false;
                        }
                        break;
                }
            }
            return isUpdtDtcnr;
        }

    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.cellFormatting = function (obj) {
        this.XLObj = obj;
        this._formatEnable = false;
        this._thousandSeparator = ej.preferredCulture(this.XLObj.model.locale).numberFormat[","];
        this._formatAsTableStyle = {};
        this._rowLength = null;
        this._colLength = null;
        this._getFormat = null;
        this._getEformatClass = null;
        this._borderPosition = ["top", "right", "bottom", "left"];
        this._cellObj = null;
        this._isFAT = false;
        this._customFormatSpecifierType = {};
        this._customFontFamily = {};
    };

    ej.spreadsheetFeatures.cellFormatting.prototype = {
        format: function (formatObj, range) {
			var xlObj = this.XLObj;
			if (!xlObj.model.allowCellFormatting || xlObj.model.isReadOnly)
				return;
			var info, cellIdx, cells, colWidh, tFormats, cellInfo, globalWidth, $cell, cell, len, cssclass, formattedval, args, cHght, cWidth, rows, val, extFormat, maxc, i = 0,
                cellObj = {}, selCells = [], style = "style", options = {}, format = "format", sep = "thousandSeparator",
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), ralign = xlObj._rAlign, container = xlObj._dataContainer,
                details = { sheetIndex: sheetIdx, reqType: "cell-format" }, dupDetails = xlObj._dupDetails, isRfrshCmtPos = false, rowHtColl = sheet.rowsHeightCollection, rowHt = 0;
            cells = xlObj._getMultiRangeCells(range);
            len = cells.length;
            if (xlObj._trigger("beforeCellFormat", { sheetIndex: sheetIdx, format: formatObj, cells: cells }))
                return;
            if (len) {
                formatObj = this._getFormatObj(formatObj);
                if (style in formatObj || format in formatObj) {
                    details.oprType = style in formatObj ? "style" : "format";
                    maxc = cells[len - 1].colIndex;
                    while (i < len) {
                        cellIdx = cells[i], args = { sheetIndex: sheetIdx, format: formatObj, cell: cellIdx };
                        this._cellObj = {};
                        info = { rowIndex: cellIdx.rowIndex, colIndex: cellIdx.colIndex, beforeFormat: {}, afterFormat: {}, bRowHeight: xlObj.model.allowResizing && xlObj.XLResize.getRowHeight(cellIdx.rowIndex) };
                        if (!ej.isNullOrUndefined(container.sheets[sheetIdx][info.rowIndex]))
                            cellObj = ej.isNullOrUndefined(container.sheets[sheetIdx][info.rowIndex][info.colIndex]) ? {} : container.sheets[sheetIdx][info.rowIndex][info.colIndex];
                        else
                            cellObj = {};
                        if (xlObj._isRowViewable(sheetIdx, cellIdx.rowIndex)) {
                            $cell = xlObj.getCell(cellIdx.rowIndex, cellIdx.colIndex);
                            cell = $cell[0];
                        }
                        if (style in formatObj) {
                            info.prevClass = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, format);
                            info.prevClass = info.prevClass ? info.prevClass : "";
                            extFormat = this._getExtendedFormat(cellIdx, formatObj.style);
							if(extFormat['format']['text-align'] && extFormat['format']['text-align'].toLowerCase() === 'right' && !xlObj._hasClass(cell, 'e-rightalign'))
								xlObj.addClass(cell, 'e-rightalign');
							else if((!extFormat['format']['text-align'] || extFormat['format']['text-align'].toLowerCase() !== 'right') && xlObj._hasClass(cell, 'e-rightalign'))
								xlObj._removeClass(cell, 'e-rightalign');
                            this._cellObj.formats = $.extend(true, {}, extFormat.format);
                            tFormats = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "tformats");
                            if (tFormats)
                                extFormat.format = $.extend(tFormats, extFormat.format);
                            this._cellObj.format = info.className= this._createFormatClass(extFormat.format);                     
                            info.beforeFormat = $.extend(true, {}, cellObj);
                            if (("font-family" in formatObj["style"] || "font-size" in formatObj["style"]) && !xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "isMHide") && ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "merge"))) {              val = xlObj.XLEdit.getPropertyValue(info.rowIndex, info.colIndex);
                                if (xlObj.model.allowResizing && (xlObj.isNumber(val) || xlObj._isDateTime(val) || xlObj.isTime(val))) {
                                    cWidth = xlObj.XLResize._getContentWidth(info.colIndex, sheetIdx, info.rowIndex, info.rowIndex) + 2;
                                    if (cWidth > sheet.columnsWidthCollection[info.colIndex])
                                        xlObj.setWidthToColumns([{ colIndex: info.colIndex, width: cWidth }]);
                                }
                                if (xlObj.model.allowSelection)
                                    xlObj.XLSelection._refreshBorder();
                                isRfrshCmtPos = true;
                            }
                            args.cssClass = extFormat.className;
                        }
                        if (format in formatObj && formatObj.type) {
                            formattedval = xlObj.XLEdit.getPropertyValue(info.rowIndex, info.colIndex);
                            formattedval = ej.isNullOrUndefined(formattedval) ? "" : formattedval;
                            this._cellObj.value = formattedval;
                            this._cellObj.type = formatObj.type;
                            this._cellObj.formatStr = formatObj.format.formatStr;
                            this._cellObj.decimalPlaces = formatObj.format.decimalPlaces;
                            this._cellObj.thousandSeparator = formatObj.format[sep] ? true : false;
                            this._cellObj.canUpdate = true;
                            info.beforeFormat = $.extend(true, {}, cellObj);
							formattedval = this._getFormattedValue(info.rowIndex, info.colIndex, this._cellObj, formattedval);
                            args.value = this._cellObj.value;
                            args.value2 = this._cellObj["value2"] = ej.isNullOrUndefined(formattedval) ? "" : formattedval + "";
                            delete this._cellObj.canUpdate;
                            info.beforeFormat.Oprtype = this._cellObj.type;
                        }
						if(xlObj.XLEdit.getPropertyValue(info.rowIndex, info.colIndex, 'value2'))
                            xlObj._textClip(info.rowIndex, info.colIndex, 'delete');
                        xlObj.XLEdit._updateDataContainer(info, { dataObj: this._cellObj });
                        if ((style in formatObj && ("font-family" in formatObj["style"] || "font-size" in formatObj["style"])) && !xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "isMHide")) {
                            colWidh = sheet.columnsWidthCollection[info.colIndex];
                            if (xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "merge") && xlObj._isRowViewable(sheetIdx, cellIdx.rowIndex)) {
                                if (cell.colSpan > 1) {
                                    for (var j = cellIdx.colIndex + 1, length = cellIdx.colIndex + cell.colSpan; j < length; j++)
                                        colWidh = colWidh + sheet.columnsWidthCollection[j];
                                }
                                cHght = xlObj._detailsFromGlobalSpan(info.rowIndex, info.colIndex, "height", xlObj.XLEdit.getPropertyValue(info.rowIndex, info.colIndex, "value2"), colWidh);
                                if (cell.rowSpan > 1)
                                    for (var j = cellIdx.rowIndex; j < cellIdx.rowIndex + cell.rowSpan; j++)
                                        rowHt = rowHt + rowHtColl[j];
                                cHght = cHght - (rowHt - rowHtColl[cellIdx.rowIndex]);
                            }
                            else
                                cHght = xlObj._detailsFromGlobalSpan(info.rowIndex, info.colIndex, "height", xlObj.XLEdit.getPropertyValue(info.rowIndex, info.colIndex, "value2"), colWidh);
                            if (xlObj.XLEdit.getPropertyValue(info.rowIndex, 0, "wrapRow") ? (sheet.rowsHeightCollection[info.rowIndex] < cHght) : true)
                                if (cHght >= xlObj.model.rowHeight) {
                                    xlObj._updateFormatColl(sheetIdx, info.rowIndex, info.colIndex, cHght);
                                    cHght = xlObj._getFormattedHeight(sheetIdx, info.rowIndex);
                                    if (cell)
                                        $cell.parent().outerHeight(cHght);
                                    sheet.rowsHeightCollection[info.rowIndex] = cHght;
                                    xlObj.XLEdit._updateDataContainer({ rowIndex: info.rowIndex, colIndex: 0 }, { dataObj: { pHeight: sheet.rowsHeightCollection[info.rowIndex], cHeight: cHght } });
                                    isRfrshCmtPos = true;
                                    if (xlObj.model.allowFreezing) {
                                        xlObj.XLFreeze._refreshFRowResize(cellIdx.rowIndex);
                                        xlObj.XLFreeze._refreshFColResize(cellIdx.colIndex);
                                    }
                                }
                        }
                        cellInfo = xlObj._getCellInfo(cellIdx);
                        xlObj._dupDetails = true;
                        if (format in formatObj && ["text", "general"].indexOf(this._cellObj.type) === -1) {
                            globalWidth = xlObj._detailsFromGlobalSpan(cellIdx.rowIndex, cellIdx.colIndex, "width", this._cellObj.value2);
                            if (globalWidth > cellInfo.width)
                                xlObj.XLResize.setColWidth(cellIdx.colIndex, globalWidth);
                            if (xlObj.model.allowFreezing)
                                xlObj.XLFreeze._refreshFColResize(cellIdx.colIndex);
                        }
                        xlObj._dupDetails = false;
                        xlObj._dupDetails = dupDetails;
                        if (sheet._isColSelected && sheet.selectedRange[1] <= info.colIndex && info.colIndex <= sheet.selectedRange[3])
                            sheet._columnStyles[info.colIndex] = $.extend(true, sheet._columnStyles[info.colIndex], this._cellObj);
                        if (sheet._isRowSelected && sheet.selectedRange[0] <= info.rowIndex && info.rowIndex <= sheet.selectedRange[2])
                            sheet._rowStyles[info.rowIndex] = $.extend(true, sheet._rowStyles[info.rowIndex], this._cellObj);
                        this._cellObj = null;
                        if (!ej.isNullOrUndefined(container.sheets[sheetIdx][info.rowIndex]))
                            cellObj = ej.isNullOrUndefined(container.sheets[sheetIdx][info.rowIndex][info.colIndex]) ? {} : container.sheets[sheetIdx][info.rowIndex][info.colIndex];
                        else
                            cellObj = {};
                        info.afterFormat = $.extend(true, {}, cellObj);
                        info.afterFormat.Oprtype = info.beforeFormat.Oprtype;
                        info.aRowHeight = xlObj.model.allowResizing && xlObj.XLResize.getRowHeight(cellIdx.rowIndex);
                        selCells.push(info);
						xlObj._trigger("cellFormatting", args);
						if(xlObj.XLEdit.getPropertyValue(info.rowIndex, info.colIndex, 'value2'))
                            xlObj._textClip(info.rowIndex, info.colIndex, 'add');
						if (maxc === info.colIndex)
						    xlObj._setRowHdrHeight(sheetIdx, info.rowIndex);
						i++;						
                    }
                    details.selectedCell = selCells;
                    details.range = sheet.selectedRange;
                    xlObj.XLScroll._getRowHeights(sheetIdx, cells[0].rowIndex);
                    if (isRfrshCmtPos && (!sheet._isImported || sheet._isLoaded) && xlObj.model.allowComments && !xlObj._isExport)
                        xlObj.XLComment._updateCmntArrowPos(null, sheetIdx);
                }
                if ("border" in formatObj && !xlObj._isMultiRange(range))
                    this.applyBorder(formatObj.border, range, details);
                else if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && !xlObj._dupDetails && !xlObj._isSort && !xlObj._isExport) {
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            }
        },

		_getFormattedValue: function(rowIdx, colIdx, cellObj, formattedval) {
			var type, xlObj = this.XLObj, options = {}, formattedval = ej.isNullOrUndefined(formattedval) ? "" : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx);
			if (ej.isNullOrUndefined(formattedval))
			    formattedval = "";
			if (xlObj.isFormula(formattedval)) {
				formattedval = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "calcValue");
                cellObj.canUpdate = false;
            }
            if (["text", "general"].indexOf(cellObj.type) !== -1) {
                if (xlObj._isDateTime(formattedval)) {
                    type = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type");
                    formattedval = xlObj._dateToInt(formattedval, type === ej.Spreadsheet.CellType.Time);
                    cellObj.value = formattedval;
                }
                if(cellObj.type === ej.Spreadsheet.CellType.Text)
                    options.align = "";
                else if (xlObj.isNumber(formattedval) && xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "align") != "right")
                    options.align = ej.Spreadsheet.Align.Right;
                if ("align" in options) {
                    options.cellIdx = {rowIndex: rowIdx, colIndex: colIdx};
                    xlObj.XLEdit._refreshCellAlignment(options);
                }
			}
            else
                formattedval = this._format(formattedval, { formatStr: cellObj.formatStr, type: cellObj.type, thousandSeparator: cellObj.thousandSeparator, decimalPlaces: cellObj.decimalPlaces, cellObj: cellObj });
			return formattedval;
		},
		
        _format: function (value, formatObj) {
            var xlObj = this.XLObj, formatstr = formatObj.formatStr,
                temp = xlObj.isUndefined(value) ? "" : value, type = formatObj.type || "", ctype = ej.Spreadsheet.CellType,
                locale = xlObj.model.locale, prefix = ["."].indexOf(this._thousandSeparator) > -1 ? '\\' : "", regx = new RegExp(prefix + this._thousandSeparator, "g");
            value = temp.toString();
            switch (type) {
                case ctype.Accounting:
                    if (xlObj._isDateTime(temp)) {
                        temp = xlObj._dateToInt(temp);
                        if (this._cellObj && this._cellObj.canUpdate)
                            this._cellObj.value = temp;
                    }
                    if (xlObj.isNumber(temp))
                        temp = xlObj.toAccounting(formatstr, temp, locale);
                    break;
                case ctype.Currency:
                case ctype.Number:
                case ctype.Percentage:
                    if (xlObj._isDateTime(temp)) {
                        temp = xlObj._dateToInt(temp);
                        if (this._cellObj && this._cellObj.canUpdate)
                            this._cellObj.value = temp;
                    }
                    if (xlObj.isNumber(temp)) {
                        temp = xlObj.formatting(formatstr, temp, locale);
                        if (!formatObj.thousandSeparator && [ctype.Number, ctype.Percentage].indexOf(type) > -1 && this._thousandSeparator)
                            temp = temp.replace(regx, "");
                    }
                    break;
                case ctype.Scientific:
                    if (xlObj._isDateTime(temp)) {
                        temp = xlObj._dateToInt(temp);
                        if (this._cellObj && this._cellObj.canUpdate)
                            this._cellObj.value = temp;
                    }
                    if (xlObj.isNumber(temp))
                        temp = xlObj.toExponential(temp, formatObj.decimalPlaces);
                    break;
                case ctype.Fraction:
                    if (xlObj._isDateTime(temp)) {
                        temp = xlObj._dateToInt(temp);
                        if (this._cellObj && this._cellObj.canUpdate)
                            this._cellObj.value = temp;
                    }
                    if (xlObj.isNumber(temp)) {
                        temp = xlObj.toFraction(temp);
                        temp = "numerator" in temp ? temp.integer + " " + temp.numerator + "/" + temp.denominator : temp.integer;
                    }
                    break;
                case ctype.LongDate:
                case ctype.ShortDate:
                case ctype.Date:
                case ctype.Time:
                case ctype.DateTime:
                    if (xlObj.isNumber(temp)) {
                        temp = xlObj.intToDate(temp);
                        if (this._cellObj && this._cellObj.canUpdate)
                            this._cellObj.value = temp;
                    }
                    else if (!xlObj._isDateTime(temp))
                        temp = ej.parseDate(temp);
                    if (xlObj._isDateTime(temp))
                        temp = xlObj.formatting(formatstr, temp, locale);
                    break;
                case ctype.String:
                    var pos = formatstr.indexOf("\\"), hasPos = formatstr.indexOf("#"), str = formatstr.split("\\").join("");
                    if (hasPos < 0)
                        hasPos = formatstr.indexOf("0");
                    if (pos < hasPos)
                        temp = str.substr(pos, str.length - 1) + value;
                    else if (pos > hasPos)
                        temp = value + str.substr(hasPos + 1, str.length);
                    break;
            }
            return ej.isNullOrUndefined(temp) ? value : temp;
        },

        createTable: function (tableObj, range) {
			var xlObj = this.XLObj;
			if (!xlObj.model.allowFormatAsTable || (!xlObj.model.allowSelection && ej.isNullOrUndefined(range) || xlObj.model.isReadOnly))
                return;
            ej.isNullOrUndefined(tableObj.format) && (tableObj.format = this._getTableLayoutFromName(tableObj.formatName).format);
            ej.isNullOrUndefined(tableObj.showHeaderRow) && (tableObj.showHeaderRow = true);
            var details, evtArgs, pcells, trange, cname, tmpRange, tlength, minr, minc, maxr, maxc, tname = tableObj.name || "",
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), tmgr = sheet.tableManager, scell = sheet._startCell,
                ecell = sheet._endCell, str = "formatName", args = { sheetIndex: sheetIdx, tableStyle: tableObj, reqType: "format-table" },
                format = tableObj.format || this._getTableLayoutFromName(tableObj.formatName).format, obj = { format: format }, dupDetails = xlObj._dupDetails, fltrColElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_tsofiltercolumn");
            evtArgs = { range: ej.isNullOrUndefined(range) ? [scell.rowIndex, scell.colIndex, ecell.rowIndex, ecell.colIndex] : range, sheetIndex: args.sheetIndex, tableStyle: args.tableStyle, reqType: args.reqType}
            if (xlObj._trigActionBegin(evtArgs) || !format)
                return;
            tableObj = args.tableStyle;
            this._isFAT = true;
            range = xlObj._getRangeArgs(range, "object");
            if (xlObj._isUndoRedo)
                trange = $.merge([], range);
            else
                trange = range ? range : sheet.selectedRange;
            if (tableObj.name && !xlObj.XLRibbon._validateNamedRange(tableObj.name, xlObj._getDollarAlphaRange(trange, true)) && !xlObj.XLClipboard._isCut)
                return;
            cname = xlObj.XLEdit.getPropertyValue(trange[0], trange[1], "tableName") || "";
            if (!sheet._isImported || sheet._isLoaded) {
				pcells = xlObj.getRange(trange);
				details = { sheetIndex: sheetIdx, reqType: "format-table", beforeFormat: this.getHashCodeClassAsArray(), beforeRange: $.extend(true, [], trange), pcells: pcells, beforeRangeHeader: xlObj.getRangeData({ range: [trange[0], trange[1], trange[0], trange[3]] }) };
                tmpRange = tableObj.header?[trange[0], trange[1], trange[2], trange[3]]:[trange[0], trange[1], trange[2] + 1, trange[3]];
                details.beforeRangeData = xlObj.getRangeData({ range: tmpRange }),
                details.beforeMergeRange = xlObj.XLEdit._getPropWithCellIdx(tmpRange, "merge", sheetIdx);
                xlObj._dupDetails = true;
                if (details.beforeMergeRange.length)
                    xlObj.unmergeCells(xlObj._getAlphaRange(sheetIdx, tmpRange[0], tmpRange[1], tmpRange[2], tmpRange[3]));
                xlObj._dupDetails = false;
            }
            if (str in tableObj)
                obj[str] = tableObj.formatName;
            if ("showHeaderRow" in tableObj)
                obj["showHeaderRow"] = tableObj.showHeaderRow;
            if (!cname) {
                if (xlObj.XLClipboard._isCut)
                    tlength = parseInt(tableObj.tblId);
                else
                    tlength = xlObj.getObjectLength(tmgr) + 1;
                tname = tname.length ? tname : 'Table' + tlength;
                xlObj.model.sheets[sheetIdx]._header[tlength] = { header: tableObj.header };
                if (sheet._isLoaded) {
                    if (tableObj.header) {
                        if (range) {
                            sheet._startCell = { rowIndex: range[0], colIndex: range[1] };
                            sheet._endCell = { rowIndex: range[2], colIndex: range[3] };
                            xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                            if (xlObj.model.allowAutoFill && (!sheet._isImported || sheet._isLoaded))
                                xlObj.XLDragFill.positionAutoFillElement();
                        }
                        else
                            range = xlObj.swapRange([scell.rowIndex, scell.colIndex, ecell.rowIndex, ecell.colIndex]);
                        if (range[0] === range[2]) {
                            trange = range;
                            trange[2] = trange[2] + 1;
                        }
                    }
                    else {
                        if (xlObj._isUndoRedo)
                            trange = $.extend(true, [], range);
                        else {
                            trange = range ? range : xlObj.swapRange([scell.rowIndex, scell.colIndex, ecell.rowIndex, ecell.colIndex]);
                            range = trange;
                        }
                        if (xlObj.model.allowDragAndDrop)
                            xlObj.XLDragDrop._moveRangeTo(trange, [trange[0] + 1, trange[1], trange[2] + 1, trange[3]], ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "range", "format", "border", "borders", "comment", "hyperlink", "picture", "cFormatRule", "rule", "chart", "isLocked", "wrap", "formats", "tformats", "tborders", "tableName"]);
                        sheet._startCell = { rowIndex: trange[0], colIndex: trange[1] };
                        sheet._endCell = { rowIndex: trange[2] + 1, colIndex: trange[3] };
                        xlObj.XLSelection.selectRange(sheet._startCell, sheet._endCell);
                        if (xlObj.model.allowAutoFill && (!sheet._isImported || sheet._isLoaded))
                            xlObj.XLDragFill.positionAutoFillElement();
                        trange[2] = trange[2] + 1;
                    }
                }
                if("dataSource" in tableObj)
                    xlObj.updateRange(sheetIdx, { showHeader: "showHeader" in tableObj ? tableObj.showHeader : true, startCell: xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[0], range[1]), dataSource: tableObj.dataSource });
                xlObj.updateUniqueData({ tableName: 'e-table' + tlength }, range);
                tmgr[tlength] = { name: tname, range: trange, showHeaderRow: tableObj.showHeaderRow };
                tableObj.fnNumber && (tmgr[tlength].fnNumber = tableObj.fnNumber);
                tmgr[tlength]["isFilter"] = tableObj.showHeaderRow;
                xlObj.XLRibbon._isDesignTab = true;
                xlObj._dupDetails = true;
                this._createTable(tlength, obj);
                tableObj.showHeaderRow && xlObj.model.allowFiltering && xlObj.XLFilter._filterTable(sheetIdx, tlength, { startCell: { rowIndex: range[0], colIndex: range[1] }, endCell: { rowIndex: range[2], colIndex: range[3] } });
                xlObj._dupDetails = false;
                this._updateTblStyleOptns(tlength, tableObj);
                if ((!sheet._isImported || sheet._isLoaded) && !tableObj.hideTab)
                    xlObj.XLRibbon._designTabUpdate(tlength, { rowIndex: range[0], colIndex: range[1] });
                if (xlObj.model.allowComments)
                    xlObj.XLComment._updateCmntArrowPos();
            }
            else {
                this._formatAsTableStyle = obj;
                xlObj._dupDetails = true;
                this._createTable(xlObj._getTableID(cname), obj);
                xlObj._dupDetails = false;
                xlObj._undoCollection.pop();
                xlObj._undoCollection.pop();
            }
            if (!sheet._isImported || sheet._isLoaded) {
                xlObj.XLRibbon._dirtySelect(xlObj.getRange(range));
                details.tableID = tlength;
                details.tableStyle = tableObj;
                details.afterRange = trange;
                xlObj._dupDetails = dupDetails;
                evtArgs = { pCells: details.pcells, reqType: details.reqType, sheetIndex: details.sheetIndex, tableID: details.tableID, tableStyle: details.tableStyle };
                if (!xlObj._isPaste && !xlObj._isUndoRedo && !xlObj._dupDetails && !xlObj._isExport)
                {
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(evtArgs);
                }
            }
            fltrColElem.length && fltrColElem.ejCheckBox("option", { checked: true });
			xlObj.XLRibbon.addNamedRange(tname, xlObj._getDollarAlphaRange(range, true), null, sheetIdx);
			sheet._isLoaded && xlObj.XLSelection._refreshBorder();
			this._isFAT = false;
			return tableObj.name;
        },

        _createTable: function (tableId, options) {
            var cellIdx, i, j, k, l, style, arange, val, txt, len, eformat, canUpdate, args, dstyle, idx = 1, col = "Column", frmt = "format", frmts = frmt + "s",
                tfrmts = "t" + frmts, bdr = "border", frmtName = "formatName", hdrLyt = "headerLayout", cntLyt = "contentLayout",
                cntBdr = "contentBorder", val2 = "value2", tblName = "tableName", hlk = "hyperlink", tableName = "e-table" + tableId,
                hasStyle = false, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx),
                table = sheet.tableManager[tableId], range = table.range, minr = range[0],
                minc = range[1], maxr = range[2], maxc = range[3], fltrColElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_tsofiltercolumn");
            table[frmt] = options.format;
            if (options.formatName)
                table[frmtName] = options.formatName;
            if (table.showHeaderRow)
                options["showHeaderRow"] = table.showHeaderRow;
            this.removeStyle(range, { tableStyle: true, border: true, sheetIdx: sheetIdx });
            if (options.showHeaderRow && hdrLyt in options.format) {
                style = $.extend(true, {}, options.format.headerLayout);
                if (bdr in style) {
                    arange = xlObj._getProperAlphaRange(sheetIdx, minr, minc, minr, maxc);
                    xlObj._intrnlReq = true;
                    this.applyBorder(style.border, arange);
                    xlObj._intrnlReq = false;
                    delete style.border;
                }
            }
            hasStyle = xlObj.getObjectLength(style) > 0;
            i = minr, j = minc, k = maxc;
            if (options.showHeaderRow) {
                while (j <= k) {
                    canUpdate = false, args = {};
                    cellIdx = { rowIndex: i, colIndex: j };
                    val = xlObj.XLEdit.getPropertyValue(i, j, val2) || "";
                    txt = col + idx;
                    if (xlObj.XLEdit.getPropertyValue(i, j, tblName, sheetIdx) !== tableName) {
                        args.tableName = tableName;
                        canUpdate = true;
                    }
                    if (!val.length) {
                        xlObj.XLEdit._updateCell(cellIdx, txt);
                        idx++;
                    }
                    else if (val.toLowerCase() === txt.toLowerCase())
                        idx++;
                    if (hasStyle) {
                        eformat = this._getExtendedFormat(cellIdx, style, this._isFAT);
                        args.format = this._createFormatClass(eformat.format);
                        args.tformats = style;
                        canUpdate = true;
                    }
                    if (canUpdate)
                        xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: args, sheetIdx: sheetIdx });
                    j++;
                }
            }
            if (cntLyt in options.format) {
                len = options.format.contentLayout.length;
                idx = 0, i = options.showHeaderRow ? (minr + 1) : minr, j = maxr;
                while (i <= j) {
                    style = $.extend(true, {}, options.format.contentLayout[idx % len]);
                    if (bdr in style) {
                        arange = xlObj._getProperAlphaRange(sheetIdx, i, minc, i, maxc);
                        xlObj._intrnlReq = true;
                        this.applyBorder(style.border, arange);
                        xlObj._intrnlReq = false;
                        delete style.border;
                    }
                    if (xlObj.getObjectLength(style)) {
                        k = minc, l = maxc;
                        while (k <= l) {
                            args = {}, cellIdx = { rowIndex: i, colIndex: k };
                            dstyle = $.extend({}, style);
                            if (xlObj.XLEdit.getPropertyValue(i, k, tblName, sheetIdx) !== tableName)
                                args.tableName = tableName;                                                            
                            if (dstyle.color && xlObj.XLEdit.getPropertyValue(i, k, hlk))
                                delete dstyle.color;
                            eformat = this._getExtendedFormat(cellIdx, dstyle, this._isFAT);
                            args.format = this._createFormatClass(eformat.format);
                            args.tformats = style;
                            xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: args, sheetIdx: sheetIdx });
                            k++;
                        }
                    }
                    i++;
                    idx++;
                }
            }
            if (cntBdr in options.format) {
                arange = xlObj._getProperAlphaRange(sheetIdx, minr + 1, minc, maxr, maxc);
                xlObj._intrnlReq = true;
                this.applyBorder($.extend({}, options.format.contentBorder.border), arange);
                xlObj._intrnlReq = false;
            }
            if (!xlObj.XLClipboard._isCut)
                xlObj._tableCnt++;
        },

        _updateTblStyleOptns: function (tdId, tbObj) {
            var tmgrDt, tRange, fstCol = "firstColumn", lstCol = "lastColumn", bold = "bold", normal = "normal", trow = "totalRow",
                isFilter = "isFilter", xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(), sheet = xlObj.getSheet(sheetIdx), tmgr = sheet.tableManager;
            if (tdId in tmgr) {
                tmgrDt = tmgr[tdId];
                tRange = tmgrDt.range;
                tmgrDt[isFilter] = isFilter in tbObj ? tbObj.isFilter : ("showHeaderRow" in tbObj ? tbObj["showHeaderRow"] : true);
                if (xlObj.model.allowFiltering && !tmgrDt[isFilter])
                    xlObj.XLFilter._clearFilterTableIcon(sheetIdx, tdId);
                xlObj._dupDetails = true;
                if (fstCol in tbObj) {
                    tmgrDt[fstCol] = tbObj.firstColumn;
                    this.format({ style: { "font-weight": tmgrDt[fstCol] ? bold : normal } }, xlObj._getProperAlphaRange(sheetIdx, tRange[0] + 1, tRange[1], tRange[2], tRange[1]));
                }
                if (lstCol in tbObj) {
                    tmgrDt[lstCol] = tbObj.lastColumn;
                    this.format({ style: { "font-weight": tmgrDt[lstCol] ? bold : normal } }, xlObj._getProperAlphaRange(sheetIdx, tRange[0] + 1, tRange[3], tRange[2], tRange[3]));
                }
                xlObj._dupDetails = false
                if (trow in tbObj)
                    tmgrDt[trow] = tbObj.totalRow;
            }
        },

        removeTable: function (tableId) {
			var xlObj = this.XLObj;
			if (!xlObj.model.allowFormatAsTable || xlObj.model.isReadOnly)
                return;
            var tclass, cells, len, formats, tformats, borders, tborders, i = 0, sheetIdx = xlObj.getActiveSheetIndex(), tmgr = xlObj.getSheet(sheetIdx).tableManager, range = tmgr[tableId].range, name = tmgr[tableId].name, fltrColElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_tsofiltercolumn");
            if (tableId in tmgr) {               
                xlObj.clearRangeData(range, ["tableName"]);
                cells = xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
                len=cells.length;
                if (len){
                    while (i < len){
                        formats = xlObj.XLEdit.getPropertyValue(cells[i].rowIndex, cells[i].colIndex, "formats");
                        tformats = xlObj.XLEdit.getPropertyValue(cells[i].rowIndex, cells[i].colIndex, "tformats");
                        borders = xlObj.XLEdit.getPropertyValue(cells[i].rowIndex, cells[i].colIndex, "borders");
                        tborders = xlObj.XLEdit.getPropertyValue(cells[i].rowIndex, cells[i].colIndex, "tborders");
                        if (tformats) {
                            $.extend(tformats, formats);
                            xlObj.XLEdit._updateDataContainer(cells[i], { dataObj: { formats: tformats } });
                        }

                        if (tborders) {
                            $.extend(tborders, borders);
                            xlObj.XLEdit._updateDataContainer(cells[i], { dataObj: { borders: tborders } });
                        }
                        xlObj.XLEdit._clearDataContainer({ cellIdx:{rowIndex:cells[i].rowIndex,colIndex:cells[i].colIndex}, property: ["tformats", "tborders"] });
                        i++;
                    }
                }
                if (xlObj.model.allowFiltering && !xlObj._isFATResize)
                    xlObj.XLFilter._clearFilterTable(sheetIdx, parseInt(tableId));
                delete tmgr[tableId];
                delete xlObj.model.sheets[sheetIdx]._header[tableId];
                xlObj.XLRibbon.removeNamedRange(name);
                fltrColElem.length && fltrColElem.ejCheckBox("option", { checked: false });
                xlObj.XLRibbon._toggleDesignTab(xlObj.getActiveCell(sheetIdx));
            }
        },

        _renameTable: function (cname) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), tmgr = xlObj.getSheet(sheetIdx).tableManager, tid = xlObj._getTableID(cname), tname, trange, details, robj = $('#' + xlObj._id + '_Ribbon').data('ejRibbon'), newName;
            if (tid) {
                newName = document.getElementById(xlObj._id + '_Ribbon_Design_Properties_TableName') && document.getElementById(xlObj._id + '_Ribbon_Design_Properties_TableName').value;
                tname = tmgr[tid].name;
                if (tname != newName) {
                    trange = xlObj._getDollarAlphaRange(tmgr[tid].range, true);
                    if (xlObj.XLRibbon._validateNamedRange(newName, trange)) {
                        details = { sheetIndex: sheetIdx, reqType: "format-table", action: "renaming", range: trange, tableId: parseInt(tid), prevName: tname };
                        xlObj.XLRibbon.removeNamedRange(tname);
                        tmgr[tid].name = newName;
                        xlObj.XLRibbon.addNamedRange(tmgr[tid].name, trange, null, sheetIdx);
                        details.newName = tmgr[tid].name;
                        robj.showTab(xlObj._getLocStr('Design'));
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                }
            }
        },

        _getTableLayoutFromName: function (name) {
            if (!name)
                return;
            return this.XLObj._FATStyles[name];
        },

        _getTableIdxFromName: function (name) {
            var xlObj = this.XLObj, tmgr = xlObj.getSheet(xlObj.getActiveSheetIndex()).tableManager,
                len = xlObj.getObjectLength(tmgr);
            if (len) {
                while (len--) {
                    if (tmgr[len].name === name)
                        return len;
                }
            }
            return -1;
        },

        convertToRange: function (options) {
			var xlObj = this.XLObj;
			if(xlObj.model.isReadOnly)
				return;
            if (options.alert)
                xlObj._showAlertDlg("", "ConverToRangeAlert", "ConvertToRange", 498);
            else
                this._convertToRange(options);
        },

        _convertToRange: function(options) {
            var i, tableId, xlObj = this.XLObj, sheetIdx = options.sheetIdx || xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), tid, details,
            tmgr = xlObj.getSheet(sheetIdx).tableManager, tableRange = sheet.filterSettings.tableRange;
            tid = options.tableId || xlObj._getTableID(null, document.getElementById(xlObj._id + '_Ribbon_Design_Properties_TableName') && document.getElementById(xlObj._id + '_Ribbon_Design_Properties_TableName').value);
            for (i = 0; i < tableRange.length; i++)
                tableRange[i].tableID == tid && (tableId = i);
            if (xlObj.getObjectLength(tmgr))
                details = {
                    sheetIndex: sheetIdx, reqType: "format-table", action: "Design_Tools_ConvertToRange", beforeFormat: xlObj.XLFormat.getHashCodeClassAsArray(),
                    tableID: tid, name: tmgr[tid].name, format: tmgr[tid].format, formatName: tmgr[tid].formatName, tableRange: tableRange[tableId], beforeRange: tmgr[tid].range,
                    isFilter: tmgr[tid].isFilter, header: $.extend(true, [], sheet._header[tid]), firstColumn: tmgr[tid].firstColumn, lastColumn: tmgr[tid].lastColumn, totalRow: tmgr[tid].totalRow, fnNumber: tmgr[tid].fnNumber
                };
            if (xlObj.isNumber(tid))
                xlObj.XLFormat.removeTable(tid);
            xlObj.model.showRibbon && xlObj.XLRibbon._toggleDesignTab(xlObj.getActiveCell());
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },

        _calculateTotalRow: function (sheetIdx, tid, isChecked, isShift, isOk) {
            var i, xlObj = this.XLObj, cells, pCells = [], cCells = [], aRange, tRange, range, isString = false, rData, sheet = xlObj.getSheet(sheetIdx), tmgr = sheet.tableManager, insAlert,
                details, chkboxId = xlObj._id + "_Ribbon_Design_TableStyleOptions_TotalRow", chkBoxObj = $("#" + chkboxId).data("ejCheckBox"), startCell, endCell, isUndo = xlObj._isUndo, isUndoRedo = xlObj._isUndoRedo, isDupDetails = xlObj._dupDetails;
            tid = tid || parseInt(document.getElementById(xlObj._id + '_tableid').value);
            range = tmgr[tid].range;
            pCells.push(xlObj.getRangeData({ range: [range[2] + 1, range[1], range[2] + 1, range[3]] }))
            aRange = xlObj._getProperAlphaRange(sheetIdx, range[0] + 1, range[3], range[2], range[3]);
            cells = xlObj._getSelectedRange({ rowIndex: range[2] + 1, colIndex: range[1] }, { rowIndex: range[2] + 1, colIndex: range[3] });
            if (isChecked) {
                startCell = { rowIndex: range[2] + 1, colIndex: range[1] };
                endCell = { rowIndex: range[2] + 1, colIndex: range[3] };
                xlObj._dupDetails = xlObj._isTotalRow = true;
                xlObj._insRows = { startRow: startCell.rowIndex, endRow: endCell.rowIndex };
                xlObj._isUndo = false;
                if (!isOk) {
                    if (!xlObj._isUndoRedo)
                        insAlert = xlObj.insertShiftBottom(startCell, endCell);
                    else
                        xlObj.insertEntireRow(startCell.rowIndex, endCell.rowIndex);
                    if (insAlert)
                        return;
                }
                xlObj._isUndo = isUndo;
                xlObj._isUndoRedo = isUndoRedo;
                xlObj._dupDetails = xlObj._isTotalRow = false;
                if (!xlObj._isFilterApplied || xlObj._insDelStatus == "insert") {
                    if (cells.length > 1)
                        xlObj.XLEdit._updateCellValue(cells[0], isChecked ? 'Total' : '');
                    if (!tmgr[tid]["fnNumber"] && isChecked) {
                        rData = ej.distinct(xlObj.getRangeData({ range: xlObj.getRangeIndices(aRange), valueOnly: true }));
                        rData = rData.filter(Boolean);
                        i = rData.length;
                        if (i) {
                            while (i--) {
                                if (!xlObj.isNumber(rData[i])) {
                                    isString = true;
                                    break;
                                }
                            }
                        }
                        else
                            isString = true;
                        tmgr[tid]["fnNumber"] = isString ? 103 : 109;
                    }
                    xlObj.XLEdit._updateCellValue(cells[cells.length - 1], isChecked ? '=SUBTOTAL(' + tmgr[tid]["fnNumber"] + ',' + aRange + ')' : '');
                    tmgr[tid].range[2] += 1;
                    xlObj._insDelStatus == "";
                }
            }
            else {
                startCell = { rowIndex: range[2], colIndex: range[1] };
                endCell = { rowIndex: range[2], colIndex: range[3] };
                xlObj._dupDetails = xlObj._isTotalRow = true;
				if(xlObj.model.allowFiltering)
					xlObj.XLFilter._checkFilterApplied(sheetIdx, startCell.rowIndex, 1, startCell.colIndex, 1, "filter");
				xlObj._checkTableApplied(sheetIdx, startCell.rowIndex, 1, startCell.colIndex, 1, "filter");
                if (xlObj._isFilterApplied || xlObj._isTableApplied) {
                    xlObj._intrnlReq = true;
                    xlObj._isUndo = false;
                    xlObj.deleteEntireRow(startCell.rowIndex, endCell.rowIndex);
                    xlObj._isUndo = isUndo;
                    xlObj._intrnlReq = false;
                    isShift = false;
                }
                else
                    xlObj._deleteShiftUp(sheetIdx, startCell, endCell, { startCol: startCell.colIndex, colCount: (endCell.colIndex - startCell.colIndex) + 1, startRow: startCell.rowIndex, rowCount: (endCell.rowIndex - startCell.rowIndex) + 1, status: "shiftUp" });
                xlObj._isTotalRow = false;
                tmgr[tid].range[2] -= 1;
            }
            xlObj._dupDetails = isDupDetails;
            isChecked ? tmgr[tid]["totalRow"] = true : "totalRow" in tmgr[tid] && delete tmgr[tid]["totalRow"];
            tRange = tmgr[tid].range;
            xlObj.XLFormat._createTable(tid, { format: tmgr[tid].format });
            cCells.push(xlObj.getRangeData({ range: [tRange[2] + 1, tRange[1], tRange[2] + 1, tRange[3]] }))
            details = { sheetIndex: sheetIdx, reqType: "format-table", action: "totalrow", range: aRange, check: isChecked, id: chkboxId, cell: cells, tmgr: tmgr, tableId: tid, pcells: pCells[0], curCells: cCells[0], fnNumber: tmgr[tid]["fnNumber"] , isShift: isShift};
            if(isOk)
                xlObj._dupDetails = xlObj._isUndoRedo = false;
            if (!xlObj._dupDetails) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
            xlObj._dupDetails = false;
        },

        _updateTotalRow: function (sheetIdx, tblId, fnNumber, range, isClear) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), tmgr = sheet.tableManager;
            tmgr[tblId].fnNumber = fnNumber;
            isClear && xlObj._clearFormula(range[2], range[3]);
            xlObj.XLEdit._updateCellValue({ rowIndex: range[2], colIndex: range[3] }, '=SUBTOTAL(' + tmgr[tblId].fnNumber + ',' + xlObj._getAlphaRange(sheetIdx, range[0] + 1, range[3], range[2] - 1, range[3]) + ')');
        },

        customFormatParser: function (input) {
            if (!this.XLObj.model.allowCellFormatting)
                return;
            var str, type, splitter, formatObj = {}, ctype = ej.Spreadsheet.CellType, pre = "{0:", suf = "}", n = "N",
                p = "P", d = ".", c = ",", z = "0";
            input = ej.isNullOrUndefined(input) ? "" : input.toString();
            if (Number(input) === 0) {
                if (input.indexOf(d) > -1) {
                    splitter = input.split(d);
                    str = pre + n + splitter[1].length + suf;
                }
                else
                    str = pre + "D" + input.length + suf;
                type = ctype.Number;
            }
            else if (!input.indexOf("#") && input.indexOf(c) > -1 && input.lastIndexOf(z) === input.length - 1) {
                if (input.indexOf(d) > -1) {
                    splitter = input.split(d);
                    str = pre + n + splitter[1].length + suf;
                }
                else
                    str = pre + n + z + suf;
                formatObj["thousandSeparator"] = true;
                type = ctype.Number;
            }
            else if (input.lastIndexOf("%") === input.length - 1 && Number(input.replace(/%/g, "")) === 0) {
                if (input.indexOf(d) > -1) {
                    splitter = input.split(d);
                    str = pre + p + --splitter[1].length + suf;
                }
                else
                    str = pre + p + z + suf;
                type = ctype.Percentage;
            }
            else if (/^[dMy/\-\s,]+$/.test(input)) {
                str = pre + input + suf;
                type = ctype.Date;
            }
            else if (/^[hmst:\s]+$/.test(input)) {
                str = pre + input + suf;
                type = ctype.Time;
            }
            else if (input.indexOf("\\")>-1)
            {
                formatObj["formatStr"] = input;
                formatObj["type"] = "string";
            }
            if (str) {
                formatObj["formatStr"] = str;
                formatObj["type"] = type;
            }
            return formatObj;
        },

        addCustomFormatSpecifier: function (name, formatSpecifier, type) {
            var i, cellTypes = ej.Spreadsheet.CellType, culture = ej.cultures[this.XLObj.model.locale];
            if ([cellTypes.Date, cellTypes.DateTime, cellTypes.LongDate, cellTypes.ShortDate, cellTypes.Time].indexOf(type) > -1) {
                for (i in culture.calendar.patterns)
                    if (culture.calendar.patterns[i] == formatSpecifier)
                        return;
                if (!name)
                    name = "cDFrmt" + Object.keys(culture.calendar.patterns).length;
                culture.calendar.patterns[name] = formatSpecifier;
                this._customFormatSpecifierType[name] = type;
            }
        },

        addFontFamily: function (fontName) {
            var key, ddObj, ddDataSrc, selectedIdx, ddText = fontName, customFont = this._customFontFamily, xlObj = this.XLObj, fontVal = 49, tVal;
            fontName = fontName.toLowerCase();
            if (xlObj.isUndefined(customFont[fontName])) {
                for (key in customFont) {
                    tVal = parseInt(customFont[key]);
                    if (tVal > fontVal)
                        fontVal = tVal;
                }
                fontVal++;
                if (xlObj.model.showRibbon) {
                    ddObj = $("#" + xlObj._id + "_Ribbon_Home_Font_FontFamily").data("ejDropDownList");
                    ddDataSrc = $.extend(true, [], xlObj.XLRibbon._fontFamily);
                    ddDataSrc.push({ text: ddText, value: fontVal });
                    if (ddObj) {
                        selectedIdx = ddObj.model.selectedItemIndex;
                        ddObj.option({ dataSource: ddDataSrc });
                        ddObj._initValue = true;
                        ddObj.selectItemByIndex(selectedIdx);
                        ddObj._initValue = false;
                        xlObj.XLRibbon._fontFamily = ddDataSrc;
                    }
                }
                customFont[fontName] = fontVal + "";
                ej.Spreadsheet.FontFamily[fontName] = fontVal + "";
            }
        },

        removeFontFamily: function (fontName) {            
            var i, ddObj, customFont = this._customFontFamily, xlObj = this.XLObj, ddDataSrc, selectedIdx;
            if (xlObj.model.showRibbon) {
                ddObj = $("#" + xlObj._id + "_Ribbon_Home_Font_FontFamily").data("ejDropDownList");
                ddDataSrc = $.extend(true, [], xlObj.XLRibbon._fontFamily);
                for (i = 0; i < ddDataSrc.length; i++) {
                    if (ddDataSrc[i]["text"] === fontName) {
                        ddDataSrc.splice(i, 1);
                        if (ddObj) {
                            selectedIdx = ddObj.model.selectedItemIndex;
                            ddObj.option({ dataSource: ddDataSrc });
                            ddObj._initValue = true;
                            ddObj.selectItemByIndex(selectedIdx);
                            ddObj._initValue = false;
                        }
                        xlObj.XLRibbon._fontFamily = ddDataSrc;
                        break;
                    }
                }
            }
            fontName = fontName.toLowerCase();
            if (!xlObj.isUndefined(customFont[fontName])) {
                delete customFont[fontName];
                if (!xlObj.isUndefined(ej.Spreadsheet.FontFamily[fontName]))
                    delete ej.Spreadsheet.FontFamily[fontName];
            }
        },

        applyBorder: function (options, range, details) {
			var xlObj = this.XLObj;
			if (!xlObj.model.allowCellFormatting || !xlObj.model.formatSettings.allowCellBorder || xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            range = xlObj._getRangeArgs(range, "object", sheetIdx);
            if (!sheet._isImported || sheet._isLoaded) {
                if (!details)
                    details = { sheetIndex: sheetIdx, reqType: "cell-format", process: "border", options: $.extend(true, {}, options) };
                details.range = range;
                details.beforeFormat = this.getHashCodeClassAsArray(range);
                details.property = options.property;
                delete options.property;
            }
            if (xlObj.getObjectLength(options)) {
                if (options.isGridBorder)
                    this._applyAllBorderCss(options, range, details);
                else
                    this._applyBorderCss(options, range, details)
            }
            else
                this.removeStyle(range, { cellStyle: true, border: true, sheetIdx: sheetIdx });
            if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo) {
                xlObj._refreshRangeTRHght(sheetIdx, range);
                if (ej.isNullOrUndefined(options.tableID) && !this._dupDetails) {
                    details.afterFormat = this.getHashCodeClassAsArray(range);
                    if (!xlObj._intrnlReq) {
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                }
            }
        },

        updateDecimalPlaces: function (type, range) {
			var xlObj = this.XLObj;
			if (!xlObj.model.allowCellFormatting || !xlObj.model.formatSettings.allowDecimalPlaces || xlObj.model.isReadOnly)
                return;
            var len, cell, temp, cells, rowIdx, colIdx, dataAttr, i = 0, obj = {}, cellObj,
                sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), container = xlObj._dataContainer,
                details = { action: "decimal", reqType: "cell-format", sheetIndex: sheetIdx, oprType: "format" }, selCells = [];
            range = xlObj._getRangeArgs(range, "object");
            cells = xlObj._getSelectedCells(sheetIdx, range).selCells;
            len = cells.length;
            while (i < len) {
                rowIdx = cells[i].rowIndex; colIdx = cells[i].colIndex;
                dataAttr = xlObj.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx] })[0];
                cell = { rowIndex: rowIdx, colIndex: colIdx, afterFormat: {}, beforeFormat: {} };
                cellObj = xlObj._dataContainer.sheets[sheetIdx][rowIdx][colIdx];
                $.extend(true, cell.beforeFormat, cellObj);
                if (xlObj.isNumber(dataAttr.value)) {
                    if (xlObj.isUndefined(dataAttr.decimalPlaces))
                        dataAttr.decimalPlaces = xlObj._decimalCnt(dataAttr.value);
                    obj["type"] = dataAttr.type === ej.Spreadsheet.CellType.General ? ej.Spreadsheet.CellType.Number : dataAttr.type;
                    obj["decimalPlaces"] = dataAttr.decimalPlaces = type === "DecreaseDecimal" ? (dataAttr.decimalPlaces > 0 ? dataAttr.decimalPlaces - 1 : dataAttr.decimalPlaces) : dataAttr.decimalPlaces + 1;
                    obj["formatStr"] = xlObj._getFormatString(obj.type, obj.decimalPlaces);
                    temp = this._format(dataAttr.value, { formatStr: obj.formatStr, type: obj.type, thousandSeparator: dataAttr.thousandSeparator, decimalPlaces: obj.decimalPlaces });
                    obj["value2"] = temp;
                    if (xlObj.XLResize && xlObj.XLResize._getContentWidth(colIdx, sheetIdx, 0, xlObj.getSheet(sheetIdx).usedRange.rowIndex) >= (sheet.columnsWidthCollection[colIdx] - 5)) {
                        xlObj._dupDetails = true;
                        xlObj.XLResize._fitWidth(colIdx);
                        xlObj._dupDetails = false;
                        xlObj.XLSelection.refreshSelection();
                        if (xlObj.model.allowAutoFill)
                            xlObj.XLDragFill.positionAutoFillElement();
                    }
                    xlObj.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: obj });
                    cell.beforeFormat.Oprtype = obj.type;
                }
                dataAttr = xlObj.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx] })[0];
                cellObj = xlObj._dataContainer.sheets[sheetIdx][rowIdx][colIdx];
                $.extend(true, cell.afterFormat, cellObj);
                cell.afterFormat.Oprtype = cell.beforeFormat.Oprtype;
                selCells.push(cell);
                i++;
            }
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        getFormatClass: function (classname, isborder) {
            var str = isborder ? "e-border" : "e-format", regx = new RegExp('\\b' + str + '.*?\\b', 'g');
            return classname.indexOf(str) !== -1 ? classname.match(regx)[0] : "";
        },

        getHashCodeClassAsArray: function (range) {
            var cells, len, cname, i = 0, obj = { format: [] }, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), arr = ["topborder", "leftborder"];
            range = xlObj._toIntrnlRange(range, sheetIdx);
            range = range ? xlObj.swapRange(range) : xlObj.getSheet(sheetIdx).selectedRange;
            cells = xlObj.getRange(range), len = cells.length;
            while (i < len) {
                cname = cells[i].className;
                obj.format.push(this.getFormatClass(cname) + " " + this.getFormatClass(cname, true));
                i++;
            }
            i = 2;
            while (i--)
                obj[arr[i]] = this._getBorderArray(range, arr[i]);
            return obj;
        },

        _getBorderArray: function (range, position) {
            var length, i = 0, arr = [], xlObj = this.XLObj, str = "topborder", minindex = position === str ? range[0] - 1 : range[1] - 1, cells;
            if (minindex >= 0) {
                cells = position === str ? xlObj.getRange([range[0] - 1, range[1], range[0] - 1, range[3]]) : xlObj.getRange([range[0], range[1] - 1, range[2], range[1] - 1]);
                length = cells.length;
                while (i < length) {
                    arr.push(this.getFormatClass(cells[i].className, true));
                    i++;
                }
            }
            else {
                length = position === str ? (range[3] - range[1]) + 1 : (range[2] - range[0]) + 1;
                while (length--)
                    arr.push("");
            }
            return arr;
        },

        removeStyle: function (range, options) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            options = options || { cellStyle: true, tableStyle: true, format: true, border: true };
            var cells, len, idx, cellIdx, hcode, styles, cstyles, tstyles, hstyles, ncstyles, ntstyles, props, maxr, maxc, canRemove, canClear, i = 0, pos = this._borderPosition,
                sheetIdx = xlObj._getSheetIndex(options.sheetIdx), sheet = xlObj.getSheet(sheetIdx);
            range = xlObj._getRangeArgs(range, "object");
            cells = xlObj._getSelectedCells(sheetIdx, range).selCells;           
            len = cells.length;
            while (i < len) {
                canRemove = false;
                cellIdx = cells[i];
                if (!options.skipHiddenRow || !xlObj._isHiddenRow(cellIdx.rowIndex, options.sheetIdx)) {
                    if (options.format) {
                        if (options.cellStyle && options.tableStyle)
                            xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["format", "formats", "tformats"] });
                        else if ((options.cellStyle && xlObj._hasCellStyle(cellIdx.rowIndex, cellIdx.colIndex, options.sheetIdx) || (options.tableStyle && xlObj._isTableRange(cellIdx.rowIndex, cellIdx.colIndex, options.sheetIdx)))) {
                            props = [options.cellStyle ? "formats" : "tformats"];
                            styles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, options.cellStyle ? "tformats" : "formats", options.sheetIdx);
                            if (styles) {
                                hcode = this.getFormatHashCode(styles);
                                this._updateFormatClass(cellIdx, hcode);
                            }
                            else
                                props.push("format");
                            xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: props });
                        }
                    }
                    if (options.border) {
                        if (options.cellStyle && options.tableStyle) {
                            cstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                            tstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                            $.extend(tstyles, cstyles);                            
                            if (pos[0] in tstyles && cellIdx.rowIndex) {
                                idx = cellIdx.rowIndex - 1;
                                hcode = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                ncstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                                ntstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                                $.extend(ntstyles, ncstyles);
                                this._remStyle(idx, cellIdx.colIndex, ntstyles, hstyles, "bottom", "bottom", true);
                                canRemove = true;
                            }                            
                            if (pos[1] in tstyles) {
                                canClear = true;
                                idx = cellIdx.colIndex + 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                if (idx < sheet.colCount) {
                                    ncstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "borders", options.sheetIdx) || {};
                                    ntstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "tborders", options.sheetIdx) || {};
                                    $.extend(ntstyles, ncstyles);
                                    if (pos[3] in ntstyles) {
                                        if (hstyles.right != ntstyles.left) {
                                            hstyles.right = ntstyles.left;
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass(cellIdx, hcode, true);
                                        }
                                        canClear = false;
                                    }
                                }
                                if (canClear) {                                    
                                    delete hstyles.right;
                                    if (xlObj.getObjectLength(hstyles)) {
                                        hcode = this._getBorderHashCode(hstyles);
                                        this._updateFormatClass(cellIdx, hcode, true);
                                    }
                                    else
                                        xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["border"] });
                                }
                                canRemove = true;
                            }
                            if (pos[2] in tstyles) {
                                canClear = true;
                                idx = cellIdx.rowIndex + 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                if (idx < sheet.rowCount) {
                                    ncstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                                    ntstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                                    $.extend(ntstyles, ncstyles);
                                    if (pos[0] in ntstyles) {
                                        if (hstyles.bottom != ntstyles.top) {
                                            hstyles.bottom = ntstyles.top;
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass(cellIdx, hcode, true);
                                        }
                                        canClear = false;
                                    }
                                }
                                if (canClear) {
                                    delete hstyles.bottom;
                                    if (xlObj.getObjectLength(hstyles)) {
                                        hcode = this._getBorderHashCode(hstyles);
                                        this._updateFormatClass(cellIdx, hcode, true);
                                    }
                                    else
                                        xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["border"] });
                                }
                                canRemove = true;
                            }
                            if (pos[3] in tstyles && cellIdx.colIndex) {
                                idx = cellIdx.colIndex - 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                ncstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "borders", options.sheetIdx) || {};
                                ntstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "tborders", options.sheetIdx) || {};
                                $.extend(ntstyles, ncstyles);
                                this._remStyle(cellIdx.rowIndex, idx, ntstyles, hstyles, "right", "right", true);
                                canRemove = true;
                            }
                            if(canRemove)
                                xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["borders", "tborders"] });
                        }
                        else if (options.cellStyle) {                          
                            cstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                            tstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                            if (pos[0] in cstyles && cellIdx.rowIndex) {
                                idx = cellIdx.rowIndex - 1;
                                hcode = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                ncstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                                ntstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                                $.extend(ntstyles, ncstyles);
                                if ("bottom" in ntstyles) {
                                    if (cstyles.bottom === hstyles.bottom) {
                                        if ("top" in tstyles) {                                            
                                            hstyles.bottom = tstyles.top;
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass({ rowIndex: idx, colIndex: cellIdx.colIndex }, hcode, true);
                                        }
                                        else if (ntstyles.bottom != hstyles.bottom) {
                                            hstyles.bottom = ntstyles.bottom;
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass({ rowIndex: idx, colIndex: cellIdx.colIndex }, hcode, true);
                                        }
                                    }
                                }
                                else
                                    this._remStyle(idx, cellIdx.colIndex, ntstyles, hstyles, "top", "bottom");
                                canRemove = true;
                            }
                            if (pos[1] in cstyles) {
                                idx = cellIdx.colIndex + 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                if (idx < sheet.colCount) {
                                    ncstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "borders", options.sheetIdx) || {};
                                    ntstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "tborders", options.sheetIdx) || {};
                                    $.extend(ntstyles, ncstyles);
                                    if ("left" in ntstyles) {
                                        if (cstyles.right === hstyles.right) {
                                            if ("right" in tstyles) {
                                                hstyles.right = tstyles.right;
                                                hcode = this._getBorderHashCode(hstyles);
                                                this._updateFormatClass(cellIdx, hcode, true);
                                            }
                                            else if (ntstyles.left != hstyles.right) {
                                                hstyles.right = ntstyles.left;
                                                hcode = this._getBorderHashCode(hstyles);
                                                this._updateFormatClass(cellIdx, hcode, true);
                                            }
                                        }
                                    }
                                    else
                                       this._remStyle(cellIdx.rowIndex, cellIdx.colIndex, tstyles, hstyles, "right", "right");
                                }
                                else
                                    this._remStyle(cellIdx.rowIndex, cellIdx.colIndex, tstyles, hstyles, "right", "right");
                                canRemove = true;
                            }
                            if (pos[2] in cstyles) {
                                idx = cellIdx.rowIndex + 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                if (idx < sheet.rowCount) {
                                    ncstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                                    ntstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                                    $.extend(ntstyles, ncstyles);
                                    if ("top" in ntstyles) {
                                        if (cstyles.bottom === hstyles.bottom) {
                                            if ("bottom" in tstyles) {
                                                hstyles.bottom = tstyles.bottom;
                                                hcode = this._getBorderHashCode(hstyles);
                                                this._updateFormatClass(cellIdx, hcode, true);
                                            }
                                            else if (ntstyles.top != hstyles.bottom) {
                                                hstyles.bottom = ntstyles.top;
                                                hcode = this._getBorderHashCode(hstyles);
                                                this._updateFormatClass(cellIdx, hcode, true);
                                            }
                                        }
                                    }
                                    else
                                        this._remStyle(cellIdx.rowIndex, cellIdx.colIndex, tstyles, hstyles, "bottom", "bottom");
                                }
                                else
                                    this._remStyle(cellIdx.rowIndex, cellIdx.colIndex, tstyles, hstyles, "bottom", "bottom");
                                canRemove = true;
                            }
                            if (pos[3] in cstyles && cellIdx.colIndex) {
                                idx = cellIdx.colIndex - 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                ncstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "borders", options.sheetIdx) || {};
                                ntstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "tborders", options.sheetIdx) || {};
                                $.extend(ntstyles, ncstyles);
                                if ("right" in ntstyles) {
                                    if (cstyles.left === hstyles.right) {
                                        if ("left" in tstyles) {
                                            hstyles.right = tstyles.left;
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass({ rowIndex: cellIdx.rowIndex, colIndex: idx }, hcode, true);
                                        }
                                        else if (ntstyles.right != hstyles.right) {
                                            hstyles.right = ntstyles.right;
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass({ rowIndex: cellIdx.rowIndex, colIndex: idx }, hcode, true);
                                        }
                                    }
                                }
                                        else
                                    this._remStyle(cellIdx.rowIndex, idx, tstyles, hstyles, "left", "right");
                                canRemove = true;
                            }
                            if (canRemove)
                                xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["borders"] });
                        }
                        else if (options.tableStyle) {
                            cstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                            tstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                            if ("top" in tstyles && !("top" in cstyles) && cellIdx.rowIndex) {
                                idx = cellIdx.rowIndex - 1;
                                hcode = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                ncstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                                ntstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                                $.extend(ntstyles, ncstyles);
                                this._remStyle(idx, cellIdx.colIndex, ntstyles, hstyles, "bottom", "bottom", true);
                                canRemove = true;
                            }
                            if ("right" in tstyles && !("right" in cstyles)) {
                                idx = cellIdx.colIndex + 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                if (idx < sheet.colCount) {
                                    ncstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "borders", options.sheetIdx) || {};
                                    ntstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "tborders", options.sheetIdx) || {};
                                    $.extend(ntstyles, ncstyles);
                                    this._remStyle(cellIdx.rowIndex, cellIdx.colIndex, ntstyles, hstyles, "left", "right", true);
                                        }
                                    else {
                                        delete hstyles.right;
                                        if (xlObj.getObjectLength(hstyles)) {
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass(cellIdx, hcode, true);
                                        }
                                        else
                                            xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["border"] });
                                    }
                                canRemove = true;
                            }
                            if ("bottom" in tstyles && !("bottom" in cstyles)) {
                                idx = cellIdx.rowIndex + 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                if (idx < sheet.rowCount) {
                                    ncstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "borders", options.sheetIdx) || {};
                                    ntstyles = xlObj.XLEdit.getPropertyValue(idx, cellIdx.colIndex, "tborders", options.sheetIdx) || {};
                                    $.extend(ntstyles, ncstyles);
                                    this._remStyle(cellIdx.rowIndex, cellIdx.colIndex, ntstyles, hstyles, "top", "bottom", true);
                                        }
                                    else {
                                        delete hstyles.bottom;
                                        if (xlObj.getObjectLength(hstyles)) {
                                            hcode = this._getBorderHashCode(hstyles);
                                            this._updateFormatClass(cellIdx, hcode, true);
                                        }
                                        else
                                            xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["border"] });
                                    }
                                canRemove = true;
                            }
                            if ("left" in tstyles && !("left" in cstyles) && cellIdx.colIndex) {
                                idx = cellIdx.colIndex - 1;
                                hcode = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "border", options.sheetIdx);
                                hstyles = this.getBorderFromHashCode(hcode);
                                ncstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "borders", options.sheetIdx) || {};
                                ntstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, idx, "tborders", options.sheetIdx) || {};
                                $.extend(ntstyles, ncstyles);
                                this._remStyle(cellIdx.rowIndex, idx, ntstyles, hstyles, "right", "right", true);
                                canRemove = true;
                            }
                            if (canRemove)
                                xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: ["tborders"] });
                        }
                    }
                }
                i++;
            }
        },

        _remStyle: function (rowIdx, colIdx, ntstyles, hstyles, type1, type2, isCond) {
            var xlObj = this.XLObj;
            if (type1 in ntstyles) {
				if(!isCond || (ntstyles[type1] != hstyles[type2])) {
                    hstyles[type2] = ntstyles[type1];
                    this._updateFormatClass({ rowIndex: rowIdx, colIndex: colIdx }, this._getBorderHashCode(hstyles), true);
                }
            }
            else {
                delete hstyles[type2];
                if (xlObj.getObjectLength(hstyles))
                    this._updateFormatClass({ rowIndex: rowIdx, colIndex: colIdx }, this._getBorderHashCode(hstyles), true);
                else
                    xlObj.XLEdit._clearDataContainer({ cellIdx: { rowIndex: rowIdx, colIndex: colIdx }, property: ["border"] });
            }
        },

        _refreshStyles: function (range, type, isTable) {
            var styles, tstyles, cssClass, frmt = "format", bdr = "border", frmts = "formats", bdrs = "borders", tfrmts = "tformats",
                tbdrs = "tborders", rgt = "right", btm = "bottom", isFormat = !type || type === frmt, isBorder = !type || type === bdr, xlObj = this.XLObj,
                cells = xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }),
                i = cells.length;
            while (i--) {
                cellIdx = cells[i];
                if (isFormat) {
                    styles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, frmts) || {};
                    tstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, tfrmts) || {};
                    $.extend(tstyles, styles);
                    if (xlObj.getObjectLength(tstyles)) {
                        cssClass = this._createFormatClass(tstyles);
                        this._updateFormatClass(cellIdx, cssClass, false);
                    }
                    else if(xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, frmt))
                        xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: [frmt] });
                }
                if (isBorder) {
                    styles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, bdrs) || {};
                    tstyles = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, tbdrs) || {};
                    $.extend(tstyles, styles);
                    if (xlObj.getObjectLength(tstyles)) {
                        cssClass = this._getBorderHashCode(tstyles);
                        this._updateFormatClass(cellIdx, cssClass, true);
                    }
                    else if (xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, bdr)) {
                        if (isTable) {

                        }
                        style = this.getBorderFromHashCode(hCode);
                        if (rgt in style) {

                        }
                        if (xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, bdr))
                            xlObj.XLEdit._clearDataContainer({ cellIdx: cellIdx, property: [bdr] });
                    }
                }
            }
        },

        updateFormat: function (formatobj, range) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var i, cells, pos = ["topborder", "leftborder"], arr = formatobj.format;
            range = xlObj._getRangeArgs(range, "object");
            cells = xlObj._getSelectedCells(xlObj.getActiveSheetIndex(), range).selCells;
            i = cells.length;
            while (i--)
                this._updateHashCodeClass(cells[i], arr[i]);
            i = 2;
            while (i--)
                this._updateBorderClass(range, formatobj[pos[i]], pos[i]);
        },

        _updateBorderClass: function (range, format, position) {
            var i, cells, xlObj = this.XLObj, str = "topborder", index = position === str ? range[0] - 1 : range[1] - 1;
            if (index >= 0) {
                cells = position === str ? xlObj._getSelectedRange({ rowIndex: range[0] - 1, colIndex: range[1]},{ rowIndex: range[0] - 1, colIndex: range[3]}) : xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] - 1}, {rowIndex: range[2], colIndex: range[1] - 1});
                i = cells.length;
                while (i--)
                    this._updateFormatClass(cells[i], format[i], true);
            }
        },

        updateUniqueFormat: function (formatcls, range, cellstyle) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), range, cells, formatclass, i, cHght, cell;
            range = xlObj._getRangeArgs(range, "object");
            cells = xlObj._getSelectedCells(sheetIdx, range).selCells;
            i = cells.length;
            while (i--) {
                formatclass = xlObj._isUndoRedo ? ((ej.isNullOrUndefined(formatcls[i]['format'])) ? "e-format" : formatcls[i]['format']) : formatcls;
                this._updateFormatClass(cells[i], formatclass);
                xlObj.XLEdit._updateDataContainer(cells[i], { dataObj: { formats: this.getFormatFromHashCode(formatclass) }, sheetIdx: sheetIdx });
                if (cellstyle == "Title" || cellstyle == "Heading 4") {
                    if (xlObj._isRowViewable(sheetIdx, cells[i].rowIndex))
                        cell = xlObj.getCell(cells[i].rowIndex, cells[i].colIndex);
                    cHght = xlObj._detailsFromGlobalSpan(cells[i].rowIndex, cells[i].colIndex, "height", xlObj.XLEdit.getPropertyValue(cells[i].rowIndex, cells[i].colIndex, "value2"), sheet.columnsWidthCollection[cells[i].colIndex]);
                    if (cHght >= xlObj.model.rowHeight) {
                        xlObj._updateFormatColl(sheetIdx, cells[i].rowIndex, cells[i].colIndex, cHght);
                        cHght = xlObj._getFormattedHeight(sheetIdx, cells[i].rowIndex);
                        (cell) && cell.parent().outerHeight(cHght);
                        xlObj.XLEdit._updateDataContainer({rowIndex: cells[i].rowIndex, colIndex: 0 }, { dataObj: { pHeight: sheet.rowsHeightCollection[cells[i].rowIndex], cHeight: cHght } });
                        sheet.rowsHeightCollection[cells[i].rowIndex] = cHght;
                    }
                    if (xlObj.model.allowFreezing)
                        xlObj.XLFreeze._refreshFRowResize(cells[i].rowIndex);
                }
            }
            xlObj._refreshRangeTRHght(sheetIdx, xlObj.swapRange(range));
        },

        _hasFormat: function (formatclass) {
            if (formatclass)
                return !ej.isNullOrUndefined(formatclass.match(/e-format|e-border/));
            return false;
        },

        getFormatHashCode: function (style) {
            var hcode, key, code = "", i = 0, bg = "background-color", clr = "color", ff = "font-family", fs = "font-size",
                arr = ["font-style", "text-decoration", "vertical-align", "text-align", "font-weight"], cnt = arr.length,
                prop = ["FontStyle", "TextDecoration", "VerticalAlign", "TextAlign", "FontWeight"], ti = "text-indent";
            code = bg in style ? style[bg].replace("#", "") : "6N";
            code += clr in style ? style[clr].replace("#", "") : "6N";
            if (ff in style) {
                hcode = this._getStyleCode("FontFamily", style[ff]);
                code += hcode || "2N";
            }
            else
                code += "2N";
            code += fs in style ? this._getFontCode(style[fs]) : "2N";
            while (i < cnt) {
                key = arr[i];
                if (key in style) {
                    hcode = this._getStyleCode(prop[i], style[key]);
                    code += hcode || "1N";
                }
                else
                    code += "1N";
                i++;
            }
            if (!code.endsWith("N"))
                code = code + "N";
            if (ti in style)
                code += style[ti].replace(/pt|-|\+/g, "");
            return "e-format" + code;
        },

        getFormatFromHashCode: function (code) {
            var i, j, pt, ff, FF, fs, arr, cnt, len, prop, temp, style = {}, str = "e-format";
            code = code || "";
            if (!code.indexOf(str)) {
                pt = "pt";
                i = j = 0;
                prop = ["FontStyle", "TextDecoration", "VerticalAlign", "TextAlign"];
                arr = ["font-style", "text-decoration", "vertical-align", "text-align"];
                cnt = arr.length;
                temp = code.replace(str, "").split("N");
                if (temp[i].length === 1)
                    i++;
                else {
                    style["background-color"] = "#" + temp[i].slice(0, 6);
                    temp[i] = temp[i].substr(6);
                }
                if (temp[i].length === 1)
                    i++;
                else {
                    style["color"] = "#" + temp[i].slice(0, 6);
                    temp[i] = temp[i].substr(6);
                }
                len = temp[i].length;
                if (len === 1)
                    i++;
                else {
                    FF = "FontFamily";
                    ff = "font-family";
                    if (len === 2) {
                        style[ff] = this._getCodeStyle(FF, temp[i].slice(0, 1) + "1N");
                        i++;
                    }
                    else {
                        style[ff] = this._getCodeStyle(FF, temp[i].slice(0, 2));
                        temp[i] = temp[i].substr(2);
                    }
                }
                len = temp[i].length;
                if (len === 1)
                    i++;
                else {
                    fs = "font-size";
                    if (len === 2) {
                        style[fs] = temp[i].slice(0, 1) + pt;
                        i++;
                    }
                    else {
                        style[fs] = temp[i].slice(0, 2) + pt;
                        temp[i] = temp[i].substr(2);
                    }
                }
                while (j < cnt) {
                    if (temp[i].length === 1)
                        i++;
                    else {                        
                        style[arr[j]] = this._getCodeStyle(prop[j], temp[i].slice(0, 1));
                        temp[i] = temp[i].substr(1);
                    }
                    j++;
                }
                if (temp[i] === "2")
                    style["font-weight"] = "bold";
                 i++;
                if (temp[i])
                    style["text-indent"] = temp[i] + pt;
            }
            return style;
        },

        getBorderFromHashCode: function (code, isComplete) {
            var temp, i = 0, obj = {}, prefix = "e-border", bdrPos = this._borderPosition;
            code = code || "";
            if (!code.indexOf(prefix)) {
                temp = code.replace(prefix, "").split("N");
                if (temp[i].length > 1) {
                    obj[bdrPos[1]] = this._concatBorderCode(temp[i]);
                    temp[i] = temp[i].substr(8);
                }
                else
                    i += 3;
                if (temp[i].length > 1) {
                    obj[bdrPos[2]] = this._concatBorderCode(temp[i]);
                    if (isComplete)
                        temp[i] = temp[i].substr(8);
                }
                else
                    i += 3;
                if (isComplete) {
                    if (temp[i].length > 1) {
                        obj[bdrPos[0]] = this._concatBorderCode(temp[i]);
                        temp[i] = temp[i].substr(8);
                    }
                    else
                        i += 3;
                    if (temp[i].length > 1)
                        obj[bdrPos[3]] = this._concatBorderCode(temp[i]);
                }
            }
            return obj;
        },

        _formatPainter: function () {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowFormatPainter || !xlObj.model.allowCellFormatting)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), i, j, cellIdx = 0, sheet = xlObj.getSheet(sheetIdx), startCell = sheet._startCell, endCell = sheet._endCell;
            this._rowLength = (endCell.rowIndex - startCell.rowIndex) + 1, this._colLength = (endCell.colIndex - startCell.colIndex) + 1;
            var rowLen = this._rowLength, colLen = this._colLength, getData;
            getData = xlObj.getRangeData({ range: [startCell.rowIndex, startCell.colIndex, endCell.rowIndex, endCell.colIndex], property: ["value", "value2", "type", "wrap", "formatStr", "thousandSeparator", "decimalPlaces", "cFormatRule", "hyperlink", "format", "cellType"] });
            this._getEformatClass = new Array(rowLen);
            for (i = 0; i < rowLen; i++) {
                this._getEformatClass[i] = new Array(colLen);
                for (j = 0; j < colLen; j++) {
                    this._getEformatClass[i][j] = { "rangeData": getData[cellIdx] };
                    cellIdx++;
                }
            }
        },

        _fPMouseUp: function (e) {
            var obj, cell, cellType, evtArgs, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), sheetCont = xlObj._getContent(sheetIdx).find("div.e-content"),
                colcount = 0, topborder = 0, leftborder = 0, cFRule, fClass, getCell = sheet._selectedCells, startCell = sheet._startCell, endCell = sheet._endCell,
                i, j, cellIndex = 0, cellCount = 0, cFormatStr, rule, cellAddr, len, k, rowlength = (endCell.rowIndex - startCell.rowIndex), collength = (endCell.colIndex - startCell.colIndex),
                alphaRange, xlEdit = xlObj.XLEdit, getType, selRange = sheet.selectedRange, rangeVal = xlObj.getRangeData({ range: selRange, property: ["wrap", "hyperlink", "value", "value2", "cFormatRule", "format", "cellType", "formats", "formatStr", "decimalPlaces", "thousandSeparator","type"] }),
             details = { sheetIndex: sheetIdx, reqType: "format-painter", range: selRange, beforeData: rangeVal, bFormat: this.getHashCodeClassAsArray(selRange), unwrapCells: [], wrapCells: [] }, fpElem = xlObj.element.find("#" + xlObj._id + "_Ribbon_Home_Clipboard_FormatPainter");
            xlObj._dupDetails = true;
            for (i = 0; i <= rowlength; i++) {
                cellCount++; 
                for (j = 0; j <= collength; j++) {
                    colcount++;
                    alphaRange = xlObj._getAlphaRange(sheetIdx, getCell[cellIndex].rowIndex, getCell[cellIndex].colIndex, getCell[cellIndex].rowIndex, getCell[cellIndex].colIndex);
                    cell = getCell[cellIndex];
                    getType = this._getEformatClass[i][j];
                    this.removeStyle([getCell[cellIndex].rowIndex, getCell[cellIndex].colIndex, getCell[cellIndex].rowIndex, getCell[cellIndex].colIndex], { cellStyle: true, tableStyle: false, format: true });               
                    obj = { type: getType.rangeData.type ? getType.rangeData.type : "general" };
                    if (getType.rangeData.format)
                        obj.style=this.getFormatFromHashCode(getType.rangeData.format);
                    if (getType.rangeData.formatStr)
                        obj.formatStr = getType.rangeData.formatStr;
                    if (getType.rangeData.decimalPlaces)
                        obj.decimalPlaces = getType.rangeData.decimalPlaces;
                    if (getType.rangeData.thousandSeparator)
                        obj.thousandSeparator = getType.rangeData.thousandSeparator;
                    this.format(obj, alphaRange);
					if (getType.rangeData.cellType) {
						cellType = xlObj._dataContainer.sheetCellType[getType.rangeData.cellType];
						cellType.text = '';
						xlObj.XLCellType._renderControls(getCell[cellIndex].rowIndex, getCell[cellIndex].colIndex, sheetIdx, cellType);
					}
                    if (!ej.isNullOrUndefined(getType.rangeData.cFormatRule)) {
                        for (k = 0, len = getType.rangeData.cFormatRule.length; k < len; k++) {
                            cFRule = getType.rangeData.cFormatRule[k];
                            rule = cFRule.split("_");
                            cellAddr = rule[5];
                            rule[rule.indexOf(cellAddr)] = alphaRange;
                            xlObj._dataContainer.cFormatRule = rule.join("_");
                            cFormatStr = xlObj._dataContainer.cFormatRule.split("_");
                            xlObj.XLCFormat._cFormat(cFormatStr[0], cFormatStr[2], cFormatStr[3], cFormatStr[4], cFormatStr[5]);
                        }
                    }
                    if (rangeVal[cellIndex].wrap && !getType.rangeData.wrap){
                        xlObj.setWrapText("unwrap", alphaRange);
						details.wrapCells.push({rowIndex: getCell[cellIndex].rowIndex, colIndex: getCell[cellIndex].colIndex});
					}
                    else if (!rangeVal[cellIndex].wrap && getType.rangeData.wrap){
                        xlObj.setWrapText("wrap", alphaRange);
						details.unwrapCells.push({rowIndex: getCell[cellIndex].rowIndex, colIndex: getCell[cellIndex].colIndex});
					}
                    if (getType.rangeData.hyperlink && !rangeVal[cellIndex].hyperlink)
                        this.format({ style: { "text-decoration": "underline", "color": xlObj._hlColor } }, alphaRange);
                    else if (!getType.rangeData.hyperlink && rangeVal[cellIndex].hyperlink) {
                        this.format({ style: { "text-decoration": "none" } }, alphaRange);
                        xlObj.addClass(xlObj.getCell(cell.rowIndex, cell.colIndex, sheetIdx).find("a"), xlEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "format", sheetIdx));
                    }
                    //if (i === 0) {    // border not supported in formatpainter
                    //    startCell.rowIndex > 0 && this._updateFormatClass(xlObj.getCell(startCell.rowIndex - 1, startCell.colIndex + (colcount - 1), sheetIdx)[0], this._getFormat.topborder[topborder]);
                    //    topborder++;
                    //    (this._getFormat.topborder.length === topborder) && (topborder = 0);
                    //}
                    //if (j === 0) {
                    //    startCell.colIndex > 0 && this._updateFormatClass(xlObj.getCell(startCell.rowIndex + (cellCount - 1), startCell.colIndex - 1, sheetIdx)[0], this._getFormat.leftborder[leftborder]);
                    //    leftborder++;
                    //    (this._getFormat.topborder.length === leftborder) && (leftborder = 0);
                    //}
                    cellIndex++;
                    if (colcount === collength + 1) {
                        colcount = 0;
                        break;
                    }
                    (this._colLength === j + 1) && (j = -1);
                }
                if (cellCount === rowlength + 1)
                    break;
                (this._rowLength === i + 1) && (i = -1);
            }
            this._formatEnable = false;
            sheetCont.addClass("e-ss-cursor");
            sheetCont.removeClass("e-ss-fpcursor");
            fpElem.length && fpElem.ejToggleButton("option", { toggleState: false });
            xlObj._dupDetails = false;
            details["afterData"] = xlObj.getRangeData({ range: selRange, property: ["wrap", "hyperlink", "value", "value2", "cFormatRule", "format", "cellType", "formats", "formatStr", "decimalPlaces", "thousandSeparator","type"] });
			details.aFormat = this.getHashCodeClassAsArray(selRange);
			xlObj.XLSelection.refreshSelection();
			xlObj.XLDragFill.positionAutoFillElement();
			evtArgs = { sheetIndex: details.sheetIndex, currData:details["afterData"], currFormat:details.aFormat, reqType: details.reqType, range: details.range, prevData:details.beforeData, prevFormat: details.bFormat, unwrapCells: details.unwrapCells, wrapCells: details.wrapCells };
			if (!xlObj._isUndoRedo) {
			    xlObj._completeAction(details);
			    xlObj._trigActionComplete(evtArgs);
			}
        },

        _getFormatObj: function (obj) {
            if ("type" in obj || "formatStr" in obj) {
                var format = {}, sep = "thousandSeparator";
                format["formatStr"] = "formatStr" in obj ? obj.formatStr : this.XLObj._getFormatString(obj.type, obj.decimalPlaces);
                format["decimalPlaces"] = "decimalPlaces" in obj ? obj.decimalPlaces : ["currency", "accounting", "number"].indexOf(obj.type) !== -1 ? parseInt(format.formatStr.replace(/{0:|[A-Z]|}/g, "")) : 0;
                if (sep in obj)
                    format[sep] = obj[sep];
                else if (obj.type === "number")
                    format[sep] = true;
                obj["format"] = format;
            }
            if ("style" in obj && obj.style.border) {
                obj["border"] = obj.style.border;
                delete obj.style.border;
                if (!this.XLObj.getObjectLength(obj.style))
                    delete obj.style;
            }
            return obj;
        },

        _createFormatClass: function (args, hashcode, isCellStyle) {
            var properties, container = this.XLObj._dataContainer.hashCode;
            hashcode = hashcode || this.getFormatHashCode(args);
            if (container.indexOf(hashcode) !== -1)
                return hashcode;
            properties = this._getCssPropertyAsString(args);
            this._writeCssRules(hashcode, properties, isCellStyle);
            container.push(hashcode);
            return hashcode;
        },

        _writeCssRules: function (hashcode, rules, isCellStyle, isCellType) {
            var stag = document.getElementById(this.XLObj._id + "_sscustomformat"), pnlCss = "  ", prop = ".e-spreadsheet .e-spreadsheetmainpanel ." + hashcode + " {" + rules + "}";
            !isCellType && (stag.styleSheet ? stag.styleSheet.cssText += prop : stag.appendChild(document.createTextNode(prop)));
			if(isCellStyle) {
				prop = prop.replace(".e-spreadsheetmainpanel ", "");
				stag.styleSheet ? stag.styleSheet.cssText += prop : stag.appendChild(document.createTextNode(prop));
			}			
        },

        _getCssPropertyAsString: function (args) {
            var str = "", prop, j, k;
            if ("border" in args) {
                prop = args.border;
                for (j in prop)
                    args["border-" + j] = prop[j];
                delete args.border;
            }
            for (k in args)
                str = str + (k + ":" + args[k] + ";");
            return str;
        },

        _splitBorderCode: function (code) {
            code = code.split(" ");
            return code[0].replace("px", "") + this._getStyleCode("BorderStyle", code[1]) + code[2].replace("#", "");
        },

        _concatBorderCode: function (code) {
            return code.substr(0, 1) + "px " + this._getCodeStyle("BorderStyle", code.substr(1, 1)) + " #" + code.substr(2, 6);
        },

        _getCodeStyle: function (obj, value) {
            obj = ej.Spreadsheet[obj];
            for (var prop in obj) {
                if (obj.hasOwnProperty(prop)) {
                    if (obj[prop] === value)
                        return prop;
                }
            }
        },

        _getStyleCode: function (prop, val) {
            val = val || "";
            return ej.Spreadsheet[prop][val.toLowerCase()];
        },

        _getFontCode: function (args) {
            var temp = args.replace(/pt|-|\+/g, "");
            return temp.length === 2 ? temp : (temp.length === 1 ? temp + "1N" : "2N");
        },

        _getExtendedFormat: function (cellIdx, style, isTable) {
            var format = this.XLObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "formats") || {};
            if (isTable) {
                $.extend(style, format);
                return { format: style };
            }
            if (format["text-indent"] && style["text-align"]) {
                delete format["text-indent"];
                delete format["text-align"];
                $.extend(style, format);
                return { format: style };
            }
            else {
                $.extend(format, style);
                return { format: format };
            }
        },

        _updateHashCodeClass: function (cellIdx, cssclass) {
            var format, border, xlObj = this.XLObj, frmt = "e-format", bdr = "e-border", obj = {},
                fregx = xlObj._formatRegx, bregx = xlObj._borderRegx;
            if (cssclass) {
                format = cssclass.indexOf(frmt) > -1;
                border = cssclass.indexOf(bdr) > -1;
                if (format)
                    obj.format = cssclass.match(fregx)[0];
                if (border)
                    obj.border = cssclass.match(bregx)[0];
                if(format || border)
                    xlObj.XLEdit._updateDataContainer({ rowIndex: cellIdx.rowIndex, colIndex: cellIdx.colIndex }, { dataObj: obj });
            }
        },

        _updateFormatClass: function (cellIdx, cssclass, isborder) {
            var format = "e-format", border = "e-border";
            if (cssclass && (cssclass.indexOf(format) > -1 || cssclass.indexOf(border) > -1))                                
                this.XLObj.XLEdit._updateDataContainer(cellIdx, { dataObj: isborder ? { border: cssclass } : { format: cssclass } });
        },

        _applyBorderCss: function (options, range, details) {
            var i, bdrpos = this._borderPosition, top = bdrpos[0], rgt = bdrpos[1], btm = bdrpos[2], lft = bdrpos[3],
                minr = range[0], minc = range[1], maxr = range[2], maxc = range[3];
            if (top in options) {
                if (minr)
                    this._updateBorder([minr - 1, minc, minr - 1, maxc], options, btm, true);
                else
                    this._updateBorderObj([minr, minc, minr, maxc], options, top);
            }
            if (rgt in options)
                this._updateBorder([minr, maxc, maxr, maxc], options, rgt);
            if (btm in options)
                this._updateBorder([maxr, minc, maxr, maxc], options, btm);
            if (lft in options) {
                if (minc)
                    this._updateBorder([minr, minc - 1, maxr, minc - 1], options, rgt, true);
                else
                    this._updateBorderObj([minr, minc, maxr, minc], options, lft);
            }
        },

        _applyAllBorderCss: function (options, range, details) {
            var right = this._borderPosition[1], btm = this._borderPosition[2], minr = range[0], minc = range[1],
                maxr = range[2], maxc = range[3];
            this._updateBorder(range, options, right + " " + btm);
            if (minr)
                this._updateBorder([minr - 1, minc, minr - 1, maxc], options, btm, true);
            if (minc)
                this._updateBorder([minr, minc - 1, maxr, minc - 1], options, right, true);
        },

        _updateBorderObj: function (range, options, props) {
            var k, l , pBdr, cellIdx, i = range[0], j = range[2];
            while (i <= j) {
                k = range[1], l = range[3];
                while (k <= l) {
                    cellIdx = { rowIndex: i, colIndex: k };
                    pBdr = this._extendBorderObj(cellIdx, this._parseBorder(options, props).border, this._isFAT);
                    this.XLObj.XLEdit._updateDataContainer(cellIdx, { dataObj: this._isFAT ? { tborders: pBdr } : { borders: pBdr } });
                    k++;
                }
                i++;
            }
        },

        _updateBorder: function (range, options, props, isDuplicate) {
            var k, l, rowIdx, colIdx, hColIdx, hRowIdx, cellIdx, prevIdx, hCode, extBdr, pextBdr, bdrObj, pbdrObj, borders, canUpdt = false, isTop = false,
                bdrPos = this._borderPosition, i = range[0], j = range[2], isGridBdr = options.isGridBorder, xlObj = this.XLObj; // pextbdr - previous cell extended border
            delete options.isGridBorder;
            while (i <= j) {
                k = range[1], l = range[3];
                while (k <= l) {
                    cellIdx = { rowIndex: i, colIndex: k };
                    rowIdx = i;
                    colIdx = k;
                    if (isDuplicate) {
                        isTop = props === bdrPos[2];
                        if (isTop)
                            rowIdx++;
                        else
                            colIdx++;
                        extBdr = this._parseBorder(options, isTop ? bdrPos[0] : bdrPos[3]).border;
                    }
                    else
                        extBdr = this._parseBorder(options, props).border;
                    if (!isGridBdr) {
                        if (isDuplicate) {
                            prevIdx = { rowIndex: rowIdx, colIndex: colIdx };
                            pextBdr = this._extendBorderObj(prevIdx, extBdr, this._isFAT);
                            xlObj.XLEdit._updateDataContainer(prevIdx, { dataObj: this._isFAT ? { tborders: pextBdr } : { borders: pextBdr }, skipCell: options.skipCell });
                        }
                        else {
                            pextBdr = this._extendBorderObj(cellIdx, this._parseBorder(options, props).border, this._isFAT);
                            canUpdt = true;
                        }
                    }
                    else if (!isDuplicate) {
                        pextBdr = this._extendBorderObj(cellIdx, options, this._isFAT);
                        canUpdt = true;
                    }
                    if (canUpdt)
                        xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: this._isFAT ? { tborders: pextBdr } : { borders: pextBdr }, skipCell: options.skipCell });
                    if (!(isDuplicate && xlObj.hasSpan(cellIdx))) {
                        hColIdx = cellIdx.colIndex;
                        if (props === bdrPos[1] && isDuplicate && hColIdx) {
                            while (hColIdx) {
                                if (!xlObj.XLEdit.getPropertyValue(0, hColIdx, "isCHide"))
                                    break;
                                hColIdx--;
                            }
                        }
                        hRowIdx = cellIdx.rowIndex;
                        if (props === bdrPos[2] && isDuplicate && hRowIdx) {
                            while (hRowIdx) {
                                if (!xlObj.XLEdit.getPropertyValue(hRowIdx, 0, "isRHide"))
                                    break;
                                hRowIdx--;
                            }
                        }
                        pbdrObj = xlObj.XLEdit.getPropertyValue(hRowIdx, hColIdx, "border");
                        if (pbdrObj)
                            pbdrObj = this.getBorderFromHashCode(pbdrObj);
                        else
                            pbdrObj = xlObj.XLEdit.getPropertyValue(hRowIdx, hColIdx, "borders") || {};
                        if (isDuplicate) {
                            pextBdr = {};
                            if (bdrPos[1] in pbdrObj)
                                pextBdr[bdrPos[3]] = pbdrObj[bdrPos[1]];
                            if (bdrPos[2] in pbdrObj)
                                pextBdr[bdrPos[0]] = pbdrObj[bdrPos[2]];
                            extBdr = this._isFAT ? $.extend(extBdr, pextBdr) : $.extend(pextBdr, extBdr);
                        }
                        else
                            extBdr = this._isFAT ? $.extend(extBdr, pbdrObj) : $.extend(pbdrObj, extBdr);
                        bdrObj = this._parseBorder(extBdr, bdrPos[1] + " " + bdrPos[2], isDuplicate);
                        hCode = this._getBorderHashCode(bdrObj.border);
                        this._createFormatClass(bdrObj, hCode);
                        this._updateFormatClass({ rowIndex: hRowIdx, colIndex: hColIdx }, hCode, true);
                    }
                    k++;
                }
                i++;
            }
        },

        _extendBorderObj: function (cellIdx, options, isTable) {
            var xlObj = this.XLObj, bdrObj = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, isTable ? "tborders" : "borders") || {};
            $.extend(bdrObj, options);
            return bdrObj;
        },

        _getBorderHashCode: function (args, isComplete) {
            var code = "", def = "1N1N6N", bdrPos = this._borderPosition, top = bdrPos[0], rgt = bdrPos[1], btm = bdrPos[2], lft = bdrPos[3];
            code = rgt in args ? this._splitBorderCode(args[rgt]) : def;
            code += btm in args ? this._splitBorderCode(args[btm]) : def;
            if (isComplete) {
                code += top in args ? this._splitBorderCode(args[top]) : def;
                code += lft in args ? this._splitBorderCode(args[lft]) : def;
            }
            return "e-border" + code;
        },

        _parseBorder: function (options, props, isDuplicate) {
            var i, key, prop, value, obj = { border: {} }, bdrPos = this._borderPosition;
            props = props.split(" ");
            i = props.length;
            while (i--) {
                prop = key = props[i];
                if (isDuplicate)
                    prop = key === bdrPos[1] ? bdrPos[3] : bdrPos[0];
                value = options[prop];
                if (value)
                    obj.border[key] = value;
            }
            return obj;
        },

        _refreshTableRowCol: function (options) {
            var xlObj = this.XLObj,sheet = xlObj.getSheet(xlObj.getActiveSheetIndex()) , tableMngr = sheet.tableManager, curTable = tableMngr[options.tid];           
            if (curTable) {
                if (options.isInsertBefore)
                {
                    if (options.pos === "row")
                    {
                        curTable.range[0] += options.cnt;
                        curTable.range[2] += options.cnt;
                    }
                    else {
                        curTable.range[1] += options.cnt;
                        curTable.range[3] += options.cnt;
                    }
                }
                else {
                    if (options.pos === "row")
                        curTable.range[2] = curTable.range[2] + options.cnt;
                    else
                        curTable.range[3] = curTable.range[3] + options.cnt;
                    xlObj._dupDetails = true;
                    xlObj.XLFormat._createTable(options.tid, { format: curTable.format });
                    xlObj._dupDetails = false;
                }
            }

        },

        _refreshHiddenBorder: function (start, end, isRow, hide) {
            var i, j, k, l, m, n, o, pRoC, eRoC, hCode, brdr, isHide, cStyle, dupBrdr, pCelBrdr, sCelBrdr, pTblBrdr, sTblBrdr, eCelBrdr, eTblBrdr, xlEdit = this.XLObj.XLEdit, uIdx = this.XLObj.getSheet().usedRange;
            if (isRow) {
                brdr = "bottom";
                dupBrdr = "top";
                isHide = "isRHide";
                uIdx = uIdx.colIndex;
            }
            else {
                brdr = "right";
                dupBrdr = "left";
                isHide = "isCHide";
                uIdx = uIdx.rowIndex;
            }
            if (hide) {
                pRoC = start, eRoC = end;
                while (eRoC++) {
                    l = isRow ? eRoC : 0;
                    m = isRow ? 0 : eRoC;
                    if (!xlEdit.getPropertyValue(l, m, isHide))
                        break;
                }
                while (pRoC) {
                    l = isRow ? pRoC : 0;
                    m = isRow ? 0 : pRoC;
                    if (!xlEdit.getPropertyValue(l, m, isHide))
                        break;
                    pRoC--;
                }
                for (i = 0; i <= uIdx; i++) {
                    if (isRow) {
                        l = pRoC;
                        j = n = start;
                        k = m = o = i;
                    }
                    else {
                        m = pRoC;
                        j = l = n = i;
                        k = o = start;
                    }
                    if (xlEdit.getPropertyValue(j, k, "isMHide")) {
                        j = xlEdit.getPropertyValue(j, k, "mergeIdx");
                        k = j.colIndex;
                        j = j.rowIndex;
                    }
                    pCelBrdr = xlEdit.getPropertyValue(l, m, "borders");
                    sCelBrdr = xlEdit.getPropertyValue(j, k, "borders");
                    pTblBrdr = xlEdit.getPropertyValue(l, m, "tborders");
                    sTblBrdr = xlEdit.getPropertyValue(n, o, "tborders");
                    if ((!pCelBrdr || (pCelBrdr && !pCelBrdr[brdr])) && ((sCelBrdr && sCelBrdr[dupBrdr]) || ((!pTblBrdr || (pTblBrdr && !pTblBrdr[brdr])) && sTblBrdr && sTblBrdr[dupBrdr]))) {
                        hCode = xlEdit.getPropertyValue(l, m, "border");
                        cStyle = this.getBorderFromHashCode(hCode);
                        delete cStyle[brdr];
                        if (pTblBrdr && pTblBrdr[brdr])
                            cStyle[brdr] = pTblBrdr[brdr];
                        if (cStyle.bottom || cStyle.right) {
                            hCode = this._getBorderHashCode(cStyle);
                            xlEdit._updateDataContainer({ rowIndex: l, colIndex: m }, { dataObj: { border: hCode } });
                        }
                        else
                            xlEdit._clearDataContainer({ cellIdx: { rowIndex: l, colIndex: m }, property: ["border"] });
                    }
                    if (isRow) {
                        o = pRoC;
                        j = l = eRoC;
                        k = m = n = i;
                    }
                    else {
                        n = pRoC;
                        k = m = eRoC;
                        j = l = o = i;
                    }
                    if (xlEdit.getPropertyValue(j, k, "isMHide")) {
                        j = xlEdit.getPropertyValue(j, k, "mergeIdx");
                        k = j.colIndex;
                        j = j.rowIndex;
                    }
                    eCelBrdr = xlEdit.getPropertyValue(j, k, "borders");
                    eTblBrdr = xlEdit.getPropertyValue(l, m, "tborders");
                    if ((!pCelBrdr || (pCelBrdr && !pCelBrdr[brdr])) && ((eCelBrdr && eCelBrdr[dupBrdr]) || ((!pTblBrdr || (pTblBrdr && !pTblBrdr[brdr])) && eTblBrdr && eTblBrdr[dupBrdr]))) {
                        cStyle = {};
                        if (pCelBrdr || xlEdit.getPropertyValue(o, n, "border")) {
                            hCode = xlEdit.getPropertyValue(o, n, "border");
                            cStyle = this.getBorderFromHashCode(hCode);
                        }
                        cStyle[brdr] = (eCelBrdr && eCelBrdr[dupBrdr]) ? eCelBrdr[dupBrdr] : eTblBrdr[dupBrdr];
                        hCode = this._getBorderHashCode(cStyle);
                        xlEdit._updateDataContainer({ rowIndex: o, colIndex: n }, { dataObj: { border: hCode } });
                    }
                }
            }
            else {
                l = isRow ? start - 1 : 0;
                m = isRow ? 0 : start - 1;
                if (xlEdit.getPropertyValue(l, m, isHide)) {
                    pRoC = start - 1;
                    while (pRoC) {
                        l = isRow ? pRoC : 0;
                        m = isRow ? 0 : pRoC;
                        if (!xlEdit.getPropertyValue(l, m, isHide))
                            break;
                        pRoC--;
                    }
                    for (i = 0; i <= uIdx; i++) {
                        if (isRow) {
                            l = pRoC;
                            k = m = o = i;
                            j = n = start - 1;
                        }
                        else {
                            m = pRoC;
                            j = l = n = i;
                            k = o = start - 1;
                        }
                        if (xlEdit.getPropertyValue(j, k, "isMHide")) {
                            j = xlEdit.getPropertyValue(j, k, "mergeIdx");
                            k = j.colIndex;
                            j = j.rowIndex;
                        }
                        pCelBrdr = xlEdit.getPropertyValue(l, m, "borders");
                        sCelBrdr = xlEdit.getPropertyValue(j, k, "borders");
                        pTblBrdr = xlEdit.getPropertyValue(l, m, "tborders");
                        sTblBrdr = xlEdit.getPropertyValue(n, o, "tborders");
                        cStyle = this.getBorderFromHashCode(xlEdit.getPropertyValue(l, m, "border"));
                        if ((((!pCelBrdr || (pCelBrdr && !pCelBrdr[brdr])) || (pCelBrdr && pCelBrdr[brdr] !== (cStyle && cStyle[brdr]))) && ((!pTblBrdr || (pTblBrdr && !pTblBrdr[brdr])) || (pTblBrdr && pTblBrdr[brdr] && (xlEdit.getPropertyValue(l, m, "border") !== this._getBorderHashCode(pTblBrdr)
                            || (sCelBrdr && sCelBrdr[dupBrdr]))))) && (((sCelBrdr && sCelBrdr[dupBrdr]) || ((cStyle && cStyle[brdr]) && (!sCelBrdr || (sCelBrdr && !sCelBrdr[dupBrdr])))) || ((sTblBrdr && sTblBrdr[dupBrdr])))) {
                            l = isRow ? j : k;
                            m = isRow ? k : j;
                            this._showHiddenBorder(pRoC, l, m, i, isRow);
                        }

                    }
                    for (i = 0; i <= uIdx; i++) {
                        if (isRow) {
                            l = j - 1;
                            j = n = start;
                            k = o = m = i;
                        }
                        else {
                            m = k - 1;
                            j = l = n = i;
                            k = o = start;
                        }
                        if (xlEdit.getPropertyValue(j, k, "isMHide")) {
                            j = xlEdit.getPropertyValue(j, k, "mergeIdx");
                            k = j.colIndex;
                            j = j.rowIndex;
                        }
                        sCelBrdr = xlEdit.getPropertyValue(l, m, "borders");
                        eCelBrdr = xlEdit.getPropertyValue(j, k, "borders");
                        sTblBrdr = xlEdit.getPropertyValue(l, m, "tborders");
                        eTblBrdr = xlEdit.getPropertyValue(n, o, "tborders");
                        cStyle = this.getBorderFromHashCode(xlEdit.getPropertyValue(l, m, "border"));
                        if ((((!sCelBrdr || (sCelBrdr && !sCelBrdr[brdr])) || (sCelBrdr && sCelBrdr[brdr] !== (cStyle && cStyle[brdr]))) && ((!sTblBrdr || (sTblBrdr && !sTblBrdr[brdr])) || (sTblBrdr && sTblBrdr[brdr] && xlEdit.getPropertyValue(n, o, "border") !== this._getBorderHashCode(sTblBrdr))))
                            && (((eCelBrdr && eCelBrdr[dupBrdr]) || ((cStyle && cStyle[brdr]) && (!eCelBrdr || (eCelBrdr && !eCelBrdr[dupBrdr])))) || (eTblBrdr && eTblBrdr[dupBrdr]))) {
                            l = isRow ? j : k;
                            m = isRow ? k : j;
                            this._showHiddenBorder(start - 1, l, m, i, isRow);
                        }
                    }
                }
                for (start; start < end; start++) {
                    eRoC = start + 1;
                    if (isRow) {
                        l = eRoC;
                        m = k = 0;
                        j = start;
                    }
                    else {
                        m = eRoC;
                        l = j = 0;
                        k = start;
                    }
                    if (xlEdit.getPropertyValue(l, m, isHide) || xlEdit.getPropertyValue(j, k, isHide)) {
                        for (i = 0; i <= uIdx; i++) {
                            if (isRow) {
                                j = eRoC;
                                k = m = i;
                                l = start;
                            }
                            else {
                                j = l = i;
                                k = eRoC;
                                m = start;
                            }
                            if (xlEdit.getPropertyValue(j, k, "isMHide")) {
                                j = xlEdit.getPropertyValue(j, k, "mergeIdx");
                                k = j.colIndex;
                                j = j.rowIndex;
                            }
                            sCelBrdr = xlEdit.getPropertyValue(l, m, "borders");
                            eCelBrdr = xlEdit.getPropertyValue(j, k, "borders");
                            sTblBrdr = xlEdit.getPropertyValue(l, m, "tborders");
                            eTblBrdr = xlEdit.getPropertyValue(j, k, "tborders");
                            cStyle = this.getBorderFromHashCode(xlEdit.getPropertyValue(l, m, "border"));
                            if ((((!sCelBrdr || (sCelBrdr && !sCelBrdr[brdr])) || (sCelBrdr && sCelBrdr[brdr] !== (cStyle && cStyle[brdr]))) && ((!sTblBrdr || (sTblBrdr && !sTblBrdr[brdr])) || (sTblBrdr && sTblBrdr[brdr] && (xlEdit.getPropertyValue(l, m, "border") !== this._getBorderHashCode(sTblBrdr)
                                || (eCelBrdr && eCelBrdr[dupBrdr]))))) && (((eCelBrdr && eCelBrdr[dupBrdr]) || ((cStyle && cStyle[brdr]) && (!eCelBrdr || (eCelBrdr && !eCelBrdr[dupBrdr])))) || (eTblBrdr && eTblBrdr[dupBrdr]))) {
                                j = isRow ? k : j;
                                this._showHiddenBorder(start, eRoC, j, i, isRow);
                            }
                        }
                    }
                }
            }
        },

        _showHiddenBorder: function (start, end, idx, mrgIdx, isRow) {
            var i, j, l, m, n, o, brdr, hCode, cStyle, sCelBrdr, eCelBrdr, eTblBrdr, sTblBrdr, dupBrdr, xlEdit = this.XLObj.XLEdit;
            if (isRow) {
                l = end;
                o = mrgIdx;
                j = m = idx;
                i = n = start;
                brdr = "bottom";
                dupBrdr = "top";
            }
            else {
                m = end;
                n = mrgIdx;
                i = l = idx;
                j = o = start;
                brdr = "right";
                dupBrdr = "left";
            }
            hCode = xlEdit.getPropertyValue(i, j, "border");
            cStyle = this.getBorderFromHashCode(hCode);
            if (cStyle[brdr])
                delete cStyle[brdr];
            sTblBrdr = xlEdit.getPropertyValue(i, j, "tborders");
            eCelBrdr = xlEdit.getPropertyValue(l, m, "borders");
            eTblBrdr = xlEdit.getPropertyValue(l, m, "tborders");
            sCelBrdr = xlEdit.getPropertyValue(n, o, "borders");
            if (sCelBrdr && sCelBrdr[brdr])
                cStyle[brdr] = sCelBrdr[brdr];
            else if (eCelBrdr && eCelBrdr[dupBrdr])
                cStyle[brdr] = eCelBrdr[dupBrdr];
            else if ((sTblBrdr && sTblBrdr[brdr]) || (eTblBrdr && eTblBrdr[dupBrdr]))
                cStyle[brdr] = (sTblBrdr && sTblBrdr[brdr]) ? sTblBrdr[brdr] : eTblBrdr[dupBrdr];
            if (cStyle.bottom || cStyle.right) {
                hCode = this._getBorderHashCode(cStyle);
                xlEdit._updateDataContainer({ rowIndex: n, colIndex: o }, { dataObj: { border: hCode } });
            }
            else
                xlEdit._clearDataContainer({ cellIdx: { rowIndex: i, colIndex: j }, property: ["border"] });
        },

		 _resizeFormatTableMenu: function () {
            var xlObj = this.XLObj, elem = document.getElementById(xlObj._id + "_formatastable");
            if (xlObj._tabMode || xlObj._phoneMode) {
	            $("#" + xlObj._id + "_Ribbon").append($("#" + xlObj._id + "_formatastable").parent());
                xlObj._removeClass(elem, "e-formatastable");
                xlObj.addClass(elem, "e-formatastable-adaptive");
                elem.style.height = xlObj._dlgHeight + "px";
            }
            else {
                xlObj._removeClass(elem, "e-formatastable-adaptive");
                xlObj.addClass(elem, "e-formatastable");
            }
        },

        _resizeStyleMenu: function () {
            var xlObj = this.XLObj, elem = document.getElementById(xlObj._id + "_cellstyles");
            if (xlObj._tabMode || xlObj._phoneMode) {
	            $("#" + xlObj._id + "_Ribbon").append($("#" + xlObj._id + "_cellstyles").parent());
                xlObj._removeClass(elem, "e-cellstyles");
                xlObj.addClass(elem, "e-cellstyles-adaptive");
                elem.style.height = xlObj._dlgHeight + "px";
            }
            else {
                xlObj._removeClass(elem, "e-cellstyles-adaptive");
                xlObj.addClass(elem, "e-cellstyles");
                elem.style.height = "auto";
            }
        },

        _resizeBorderMenu: function (args) {
            var xlObj = this.XLObj, $borderElem = xlObj.element.find(".e-bordercontainer");
            if (xlObj._phoneMode) {
	            $("#" + xlObj._id + "_Ribbon").append($("#" + xlObj._id + "_Ribbon_Border").parent());
                if ($borderElem.length)
                    $borderElem.show();
                else {
                    this._createBorderDiv();
                    xlObj.element.find(".e-bordercontainer").show();
                }
				xlObj.addClass($borderElem[0], "e-border e-adaptive");
                args.cancel = true;
                var splitBtn = $("#" + xlObj._id + "_Ribbon_Home_Font_Border").ejSplitButton("instance");
                splitBtn.contstatus = true;
            }				
        },

        _createBorderDiv: function () {
            var xlObj = this.XLObj, hdrdiv = "<div class='e-ss-bdr-header'><span id ='" + xlObj._id + "_border_back' class = 'e-border-back e-icon e-ss-leftarrow'/></div><div class='e-ss-border-content'>", contDiv = '', div = ej.buildTag("div#" + xlObj._id + "_bordercontainer.e-bordercontainer", {}, { display: 'none', height: xlObj._responsiveHeight - 2 }), borderObj = xlObj.XLRibbon._borderMenuData;
            for (var i = 0;i < 13; i++)
                contDiv += "<div class = 'e-bordercell' id=" + borderObj[i].id + ">" + xlObj._renderDIV('e-ss-border ' + borderObj[i].sprite + " e-ss-menu", "", borderObj[i].text) + "</div>";
            hdrdiv += contDiv + "</div>";
            div.append($(hdrdiv));
            $("#" + xlObj._id + "_Ribbon").append(div);
            xlObj._on($('#' + xlObj._id + '_bordercontainer'), "click", xlObj._borderSelectionClick);
        }
    };

    ej.Spreadsheet.FontFamily = {
        "angsana new": "11N",
        "arial": "21N",
        "arial black": "31N",
        "batang": "41N",
        "book antiqua": "51N",
        "browallia new": "61N",
        "calibri": "71N",
        "cambria": "81N",
        "candara": "91N",
        "century": "10",
        "comic sans ms": "11",
        "consolas": "12",
        "constantia": "13",
        "corbel": "14",
        "cordia new": "15",
        "courier": "16",
        "courier new": "17",
        "dilleniaupc": "18",
        "dotum": "19",
        "fangsong": "20",
        "garamond": "21",
        "georgia": "22",
        "gulim": "23",
        "gungsuh": "24",
        "kaiti": "25",
        "jasmineupc": "26",
        "malgun gothic": "27",
        "mangal": "28",
        "meiryo": "29",
        "microsoft jhenghei": "30",
        "microsoft yahei": "31",
        "mingliu": "32",
        "mingliu_hkscs": "33",
        "ms gothic": "34",
        "ms mincho": "35",
        "ms pgothic": "36",
        "ms pmincho": "37",
        "pmingliu": "38",
        "pmingliu-extb": "39",
        "simhei": "40",
        "simsun": "41",
        "simsun-extb": "42",
        "tahoma": "43",
        "times": "44",
        "times new roman": "45",
        "trebuchet ms": "46",
        "verdana": "47",
        "yu gothic": "48",
        "yu mincho": "49"
    };

    ej.Spreadsheet.FontStyle = {
        "normal": "1",
        "italic": "2",
        "oblique": "3"
    };

    ej.Spreadsheet.TextAlign = {
        "left": "1",
        "right": "2",
        "center": "3",
        "justify": "4"
    };

    ej.Spreadsheet.VerticalAlign = {
        "top": "1",
        "middle": "2",
        "bottom": "3"
    };

    ej.Spreadsheet.TextDecoration = {
        "none": "1",
        "underline": "2",
        "overline": "3",
        "line-through": "4",
        "line-through underline": "5"
    };

    ej.Spreadsheet.FontWeight = {
        normal: "1",
        bold: "2"
    };

    ej.Spreadsheet.BorderStyle = {
        solid: "1",
        dashed: "2",
        dotted: "3"
    };

    ej.Spreadsheet.CellFormat = {
        number: "{0:N2}",
        currency: "{0:C2}",
        accounting: "{0:C2}",
        percentage: "{0:P2}",
        shortdate: "{0:M/d/yyyy}",
        longdate: "{0:dddd, MMMM dd, yyyy}",
        time: "{0:h:mm:ss tt}",
        scientific: "{0:N2}",
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.cFormat = function (obj) {
        this.XLObj = obj;
    };

    ej.spreadsheetFeatures.cFormat.prototype = {

        //Conditional formatting   

        getCFRule: function (rowIdx, colIdx) {
            var xlObj = this.XLObj, sIndex=xlObj.getActiveSheetIndex();
            var ruleColl = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, ["cFormatRule"]);
            var rules = [], names = xlObj._dataContainer.cFormatData, splitStr;
            if (ruleColl) {
                for (var i = 0, len = ruleColl.length; i < len; i++) {
                    splitStr = names[ruleColl[i]].split("_");
                    rules.push({ "action": splitStr[0], "inputs": [splitStr[2], splitStr[3]], "color": splitStr[4], "range": splitStr[5], "isApplied": JSON.parse(splitStr[7]) });
                }
            }
            return rules;
        },

        setCFRule: function (rule) {
            var xlObj = this.XLObj;
			if(xlObj.model.isReadOnly)
				return;
            if (!xlObj.model.allowConditionalFormats)
                return;
            var input1 = rule.inputs[0], input2 = rule.inputs[1];
            this._cFormat(rule.action, input1, input2, rule.color, rule.range, xlObj.getActiveSheetIndex());
        },

        _updateCFormatRule: function (rule, isApply) {
            rule = rule.indexOf("true") > -1 ? rule.replace("true", isApply) : rule.replace("false", isApply);
            return rule;
        },

        _getRuleIndex: function (rule, ruleCol) {
            if (ej.isNullOrUndefined(ruleCol))
                return -1;
            for (var i = 0, len = ruleCol.length; i < len; i++) {
                if (ruleCol[i] === rule)
                    return i;
            }
            return -1;
        },
        _refreshCFormatFormula: function (rowIdx, colIdx, sheetIdx) {
            var xlObj = this.XLObj, sheetData = xlObj.getSheet(sheetIdx)._cFormatFormula, cellDetail, action, range;
            if(!xlObj.isUndefined(sheetData[rowIdx]) && !xlObj.isUndefined(sheetData[rowIdx][colIdx]))
            {
                cellDetail = sheetData[rowIdx][colIdx][0].Formula;
                this._applyFormulaValues(cellDetail.referCell, cellDetail.cFColor, "formularule", cellDetail.addr, sheetIdx, range, cellDetail.applyCell);
            }
        },

        _applyFormulaValues: function (input, cFColor, action, addr, sheetIdx, range, cell,status, copyCell) {
            var xlObj = this.XLObj, selected, i,j, len, value,inputSplt, rangeIndex, formula, getSheet = xlObj.getSheet(sheetIdx), formulaCell, rowIdx, colIdx, operandCln, tRule, isApply, prevStatus = true, ruleIdx = -1, input2, splt = [], operand, calcEngine, referCell;
            if (ej.isNullOrUndefined(range) && ej.isNullOrUndefined(addr))
                selected = getSheet._selectedCells;
            else if (!ej.isNullOrUndefined(addr))
                selected = xlObj._getMultiRangeCells(addr);
            else
                selected = xlObj._getMultiRangeCells(range);
            addr = xlObj._getAlphaRange(sheetIdx, selected[0].rowIndex, selected[0].colIndex, selected[selected.length - 1].rowIndex, selected[selected.length - 1].colIndex);
            if (xlObj.isUndefined(action)) {
                calcEngine = xlObj._calcEngine;
                var cellArgs = new ValueChangedArgs(-1, -1, input);
                calcEngine.valueChanged(getSheet.sheetInfo.value, cellArgs);
                input = (calcEngine.getFormulaInfoTable().getItem("!" + (sheetIdx - 1) + "!-1").getFormulaValue() === "TRUE") ? true : false;
                if (xlObj._isBool(input))
                    isApply = input;
                else
                    isApply = false;
                tRule = "formularule" + "_" + action + "_" + input + "__" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                this._applyCFormatRule({ rowIndex: cell.rowIndex, colIndex: cell.colIndex }, tRule, ruleIdx, isApply, prevStatus, cFColor);
            }
            else {
                operandCln = ["<=",">=","<",">","="];
                if (input.startsWith("="))
                    input = input.substr(1);
				if (input.indexOf("==") > -1) {
                    xlObj._showAlertDlg("Alert", "NewRuleAlert", "", 430);
                    return true;
                }
                for (i = 0, len = operandCln.length; i < len;i++) {
                    if (input.indexOf(operandCln[i]) > -1) {
                        splt = input.split(operandCln[i]);
                        operand = operandCln[i];
                    }
                }
              if(!splt.length)
                  splt[0] = input;
              inputSplt = splt.slice();
                if (status === "paste") {
                    var difRowIdx, difColIdx, cell, input = "";
                    for(i=0,len=splt.length;i<len;i++){  
                        if (xlObj._isvalidRange(splt[i] + ":" + splt[i])) {
                            cell = xlObj._getMultiRangeCells(splt[i]);
                            difRowIdx = range[0] - copyCell.rowIndex;
                            difColIdx = range[1] - copyCell.colIndex;
                            splt[i] = xlObj._getAlphaRange(sheetIdx, cell[0].rowIndex + difRowIdx, cell[0].colIndex + difColIdx, cell[0].rowIndex + difRowIdx, cell[0].colIndex + difColIdx);
                        }
                    }
                    input = (len === 2) ? splt[0] + operand + splt[1] : splt[0];
                }
                rangeIndex = this._formulaCellRefer(splt, selected);
                for (i = 0, len = selected.length; i < len; i++) {
                    rowIdx = selected[i].rowIndex;
                    colIdx = selected[i].colIndex;
                    referCell = this._formulaCellRange({ rowIndex: rowIdx, colIndex: colIdx }, rangeIndex, inputSplt, operand, sheetIdx);
                    formula = referCell.formula;
                    calcEngine = xlObj._calcEngine;
                    var cellArgs = new ValueChangedArgs(-1,-1 , formula);
                    calcEngine.valueChanged(getSheet.sheetInfo.value, cellArgs);
                    input2 = (calcEngine.getFormulaInfoTable().getItem("!" + (sheetIdx - 1) + "!-1").getFormulaValue() === "TRUE") ? true : false;
                    if (xlObj._isBool(input2))
                        isApply = input2;
                    else
                        isApply = false;
                    tRule = "formularule" + "_" + operand + "_" + input +"/"+formula + "__" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                    for (j = 0; j < xlObj.getObjectLength(referCell)-1;j++)
                        this._formulaCellUpdate({ rowIndex: referCell["referCell" + j].rowIndex, colIndex: referCell["referCell" + j].colIndex }, { rowIndex: rowIdx, colIndex: colIdx }, input, formula, addr, cFColor, sheetIdx);
                    this._applyCFormatRule({ rowIndex: rowIdx, colIndex: colIdx }, tRule, ruleIdx, isApply, prevStatus, cFColor);
                    if (!isApply && xlObj._isRowViewable(sheetIdx, rowIdx))
                        xlObj.getCell(rowIdx, colIdx, sheetIdx).removeClass("e-redft e-yellowft e-greenft e-redf e-redt");
                }
            }
        },

        _formulaCellUpdate: function (referCell, currCell, input, formula, addr, cFColor, sheetIdx) {
            var xlObj = this.XLObj, sheetData = xlObj.getSheet(sheetIdx)._cFormatFormula, rowData, referRowIdx = referCell.rowIndex, referColIdx = referCell.colIndex;
            if (referRowIdx in sheetData) {
                rowData = sheetData[referRowIdx];
                if (referColIdx in rowData)
                    rowData[referColIdx].push({ "Formula": { "applyCell": currCell, "formula": input, "referCell": formula, "addr": addr, "cFColor": cFColor } });
                else {
                    rowData[referColIdx] = [];
                    rowData[referColIdx].push({ "Formula": { "applyCell": currCell, "formula": input, "referCell": formula, "addr": addr, "cFColor": cFColor } });
                }
            }
            else {
                rowData = sheetData[referRowIdx] = {};
                rowData[referColIdx] = [];
                rowData[referColIdx].push({ "Formula": { "applyCell": currCell, "formula": input, "referCell": formula, "addr": addr, "cFColor": cFColor } });
            }
        },

        _formulaCellRange: function (selected, rangeIndex, inputFormula, operand,sheetIdx) {
            var i, len, formula, xlObj = this.XLObj, k = 0, j, aRange = [], index = 0, objLen = xlObj.getObjectLength(rangeIndex), spltFormula, referRowIdx, referColIdx, alphaRange = {}, range = {};
            for (i = 0; i < objLen; i++) {
                if (xlObj._isObject(rangeIndex["range" + i])) {
                    referRowIdx = selected.rowIndex + rangeIndex["range" + i].rowIndex;
                    referColIdx = selected.colIndex + rangeIndex["range" + i].colIndex;
                    alphaRange["range" + i] = xlObj._getAlphaRange(sheetIdx, referRowIdx, referColIdx, referRowIdx, referColIdx);
                }
                else {
                    referRowIdx = selected.rowIndex;
                    referColIdx = selected.colIndex;
                    alphaRange["range" + i] = rangeIndex["range" + i];
                }
                range["referCell" + i] = { rowIndex: referRowIdx, colIndex: referColIdx };
            }
            for (j = 0; j < inputFormula.length; j++) {
                spltFormula = xlObj.XLDragFill._parseFormula("=" + inputFormula[j]);
                for (i = 0, len = spltFormula.length; i < len; i++) {
                    if (xlObj._isvalidRange(spltFormula[i] + ":" + spltFormula[i])) {
                        spltFormula[i] = alphaRange["range" + k];
                        k++;
                    }

                }
                aRange[index] = spltFormula.join("");
                index++;
            }
            if(xlObj.isUndefined(operand))
                formula = "=" + aRange[0];
            else
                formula = "=" + aRange[0] + operand + aRange[1];
            range["formula"] =formula ;
            return range;
        },

        _formulaCellRefer: function (splt, selected) {
            var xlObj = this.XLObj, j, i, len, formulaCell, index = 0, spltFormula, aRange = [], alphRange, rangeSplit, difRowIndex, difColIndex, rangeIndex = {}, refer;
            for (j = 0; j < splt.length; j++) {
                if (xlObj.isFormula("=" + splt[j])) {
                    spltFormula = xlObj.XLDragFill._parseFormula(splt[j]);
                    for (i = 0, len = spltFormula.length; i < len; i++) {
                        if (xlObj._isvalidRange(spltFormula[i] + ":" + spltFormula[i])) {
                            aRange[index] = spltFormula[i];
                            index++;
                        }
                    }
                }
                else {
                    aRange[index] = splt[j];
                    index++;
                }
                }
            splt = aRange;
            for (i = 0; i < splt.length; i++) {
                alphRange = splt[i].startsWith("=") ? splt[i].split("=")[1] : splt[i];
                rangeSplit = alphRange.split("$").length;
                if (xlObj._isvalidRange(splt[i] + ":" + splt[i])) {
                    if (xlObj._isvalidRange(alphRange + ":" + alphRange)) {
                        if (alphRange.indexOf("$") < 0)
                            refer = "RCRefer";
                        else if (alphRange.startsWith("$") && rangeSplit === 3)
                            refer = "CellRefer"
                        else if (alphRange.startsWith("$") && rangeSplit === 2)
                            refer = "RRefer";
                        else if (!alphRange.startsWith("$") && alphRange.indexOf("$") > -1)
                            refer = "CRefer";
                    }
                    if (splt[i].indexOf("$") > -1)
                        splt[i] = splt[i].split("$").join("");
                    formulaCell = xlObj._getMultiRangeCells(splt[i]);
                    switch (refer) {
                        case "RCRefer":
                            difRowIndex = formulaCell[0].rowIndex - selected[0].rowIndex;
                            difColIndex = formulaCell[0].colIndex - selected[0].colIndex;
                            break;
                        case "RRefer":
                            difRowIndex = formulaCell[0].rowIndex - selected[0].rowIndex;
                            difColIndex = formulaCell[0].colIndex;
                            break;
                        case "CRefer":
                            difRowIndex = formulaCell[0].rowIndex;
                            difColIndex = formulaCell[0].colIndex - selected[0].colIndex;
                            break;
                        case "CellRefer":
                            difRowIndex = formulaCell[0].rowIndex;
                            difColIndex = formulaCell[0].colIndex;
                            break;

                    }
                    splt[i] = { rowIndex: difRowIndex, colIndex: difColIndex };
                }
                rangeIndex["range" + i] = splt[i];
            }
            return rangeIndex;
        },

        _clearCFormula: function (rowIdx, colIdx, sheetIdx) {
            var xlObj = this.XLObj, splt=[],aRange=[],index=0,spltFormula, i,len,sheetdata, cFormatRule = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "cFormatRule"),referCell, operandCln,
            sheetData = xlObj.getSheet(sheetIdx)._cFormatFormula;
            if (cFormatRule && cFormatRule[0].split("_")[0] === 'formularule') {
                input = cFormatRule[0].split("_")[2].split("/")[1];
                if (input.startsWith("="))
                    input = input.substr(1);
                if (xlObj.isFormula("=" + input)) {
                    operandCln = ["<=", ">=", "<", ">", "="];
                    for (i = 0, len = operandCln.length; i < len; i++) {
                        if (input.indexOf(operandCln[i]) > -1)
                            splt = input.split(operandCln[i]);
                    }
                    if (!splt.length)
                        splt[0] = input;
                    for (i = 0, len = splt.length; i < len ; i++) {
                        if (xlObj.isFormula("=" + splt[i])) {
                            spltFormula = xlObj.XLDragFill._parseFormula(splt[i]);
                            for (j = 0; j < spltFormula.length; j++) {
                                if (xlObj._isvalidRange(spltFormula[j] + ":" + spltFormula[j])) {
                                    aRange[index] = spltFormula[j];
                                    index++;
                                }
                            }
                        }
                        else {
                            aRange[index] = splt[i];
                            index++;
                        }
                    }
                            for (i = 0, len = aRange.length; i < len ; i++) {
                                referCell = xlObj._getMultiRangeCells(aRange[i])[0];
                            if (!xlObj.isUndefined(sheetData[referCell.rowIndex])) {
                            if (!xlObj.isUndefined(sheetData[referCell.rowIndex][referCell.colIndex]))
                                delete sheetData[referCell.rowIndex][referCell.colIndex];
                            if (!xlObj.getObjectLength(sheetData[referCell.rowIndex]))
                                delete sheetData[referCell.rowIndex];
                        }

                    }
                }
            }
        },

        _cFormat: function (action, input1, input2, cFColor, addr, sheetIdx, range, status, copyCell) {
            var xlObj = this.XLObj, cell, isApplied;
            if (!xlObj.model.allowConditionalFormats)
                return;
            xlObj.showWaitingPopUp();
            sheetIdx = sheetIdx ? sheetIdx : xlObj.getActiveSheetIndex();
            if (ej.isNullOrUndefined(action))
                action = "lessthan";
            var sheet = xlObj.getSheet(sheetIdx), rangeData = (!range) ? xlObj._getRangeArgs(addr, "object") : xlObj._getRangeArgs(range, "object"), details = { cFAction: action, input1: input1, input2: input2, cFColor: cFColor, sheetIndex: sheetIdx, reqType: "cond-format", action: "add", range: addr, data: rangeData };
            switch (action) {
                case "greaterthan":
                    this._applyGLEValues(">", input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "greaterequalto":
                    this._applyGLEValues(">=", input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "lessthan":
                    this._applyGLEValues("<", input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "lessequalto":
                    this._applyGLEValues("<=", input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "equalto":
                    this._applyGLEValues("==", input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "notequalto":
                    this._applyGLEValues("!=", input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "between":
                    this._applyBetweenValues("=", input1, input2, cFColor, action, addr, sheetIdx, range);
                    break;
                case "notbetween":
                    this._applyBetweenValues("!", input1, input2, cFColor, action, addr, sheetIdx, range);
                    break;
                case "textcontains":
                    this._applyContainsValues(input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "dateoccur":
                    this._applyDateContainsValues(input1, cFColor, action, addr, sheetIdx, range);
                    break;
                case "formularule":
                    if (input1.indexOf("/") > -1)
                        input1 = input1.split("/")[1];
                    isApplied = this._applyFormulaValues(input1, cFColor, action, addr, sheetIdx, range, cell, status, copyCell);
                    break;
            }
            if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && status !== "paste" && !xlObj._dupDetails && !xlObj._isExport && !isApplied){
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
            xlObj.hideWaitingPopUp();
        },

        clearCF: function (range) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), rowIdx, colIdx, details = { sheetIndex: sheetIdx, reqType: "cond-format", action: "clear", rule: [] }, sheet = xlObj.getSheet(sheetIdx);
            if (!xlObj.model.allowConditionalFormats)
                return;
            var i, len, cFormatData = xlObj._dataContainer.cFormatData, selected;
            details.selection = !xlObj.isUndefined(range);
            range = range ? xlObj._getRangeArgs(range, "object") : [0, 0, sheet.rowCount - 1, sheet.colCount - 1];
            selected = xlObj._getSelectedCells(sheetIdx, range).selCells;
            for (i = 0, len = selected.length; i < len; i++) {
				rowIdx = selected[i].rowIndex, colIdx = selected[i].colIndex;
                if (!ej.isNullOrUndefined(xlObj._dataContainer.sheets[sheetIdx][rowIdx]))
                    if (!ej.isNullOrUndefined(xlObj._dataContainer.sheets[sheetIdx][rowIdx][colIdx]))
                        if (!ej.isNullOrUndefined(xlObj._dataContainer.sheets[sheetIdx][rowIdx][colIdx].cFormatRule)) {
                            details.rule.push(this.getCFRule(rowIdx, colIdx));
                            this._clearCFormula(rowIdx, colIdx, sheetIdx);
                            xlObj.clearRangeData([rowIdx, colIdx, rowIdx, colIdx], ["cFormatRule"]);
                        }
            }
            var rule = details.selection ? "clear_" + sheetIdx + "_" + xlObj._getSelectedItems()[1] : "clear_" + sheetIdx + "_" + "entire";
            if (cFormatData.indexOf(rule) === -1)
                cFormatData.push(rule);
            if (!xlObj._isUndoRedo && !xlObj._dupDetails) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _getValueForCFormat: function (cell, sheetIdx) {
            var xlObj = this.XLObj, rowIdx = cell.rowIndex, colIdx = cell.colIndex, cellObj = xlObj.getRangeData({ range: [rowIdx, colIdx, rowIdx, colIdx], sheetIdx: sheetIdx });
            var value = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx), value2 = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2");
            value = value ? value.toString() : "";
            if (value2 && (typeof value2 == "string" && !cellObj.formatStr && value[0] === "=") || (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") === "datetime") || (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") === "shortdate") || (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") === "longdate") || (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") === "time"))
                value = value2;
            return value;
        },

        _applyGLEValues: function (op, input, cFColor, action, addr, sheetIdx, range) {
            var len, xlObj = this.XLObj, value, selected, rowIdx, colIdx, temp, isApply, prevStatus, tRule, ruleIdx, type, numRegx = new RegExp(/[^.0-9]+/g), txtRegx = new RegExp(/[^.-a-zA-Z 0-9]+/g);
            var sheet = xlObj.getSheet(sheetIdx), startCell = sheet._startCell, endCell = sheet._endCell, j, inputValue = input;
            var referCell, rangeIndex, inputSplit = [], rangeData = (!range) ? xlObj._getRangeArgs(addr, "object") : xlObj._getRangeArgs(range, "object");
            selected = xlObj._getSelectedCells(sheetIdx, rangeData).selCells;
            if (inputValue.startsWith("=")) {
                var operand, operandCln;
                inputValue = inputValue.substr(1);
                operandCln = ["<=", ">=", "<", ">", "="];
                for (i = 0, len = operandCln.length; i < len; i++) {
                    if (inputValue.indexOf(operandCln[i]) > -1) {
                        inputSplit = inputSplit.split(operandCln[i]);
                        operand = operandCln[i];
                    }
                }
                if (!inputSplit.length)
                    inputSplit[0] = inputValue;
                rangeIndex = this._formulaCellRefer(inputSplit, selected);
            }
            for (var i = 0, len = selected.length; i < len; i++) {
                rowIdx = selected[i].rowIndex; colIdx = selected[i].colIndex;
                if (input.startsWith("=")) {
                    var calcEngine = xlObj._calcEngine;
                    referCell = this._formulaCellRange({ rowIndex: rowIdx, colIndex: colIdx }, rangeIndex, inputSplit, operand, sheetIdx);
                    var cellArgs = new ValueChangedArgs(-1, -1, referCell.formula);
                    calcEngine.valueChanged(xlObj.getSheet(sheetIdx).sheetInfo.value, cellArgs);
                    input = calcEngine.getFormulaInfoTable().getItem("!0!-1").getFormulaValue();
                    if (xlObj._isBool(input))
                        isApply = (input === "TRUE") ? true : false;
                    else
                        isApply = false;
                    if (ej.isNullOrUndefined(input))
                        input = "0";
                }
                if (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isMHide") || xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isFilterHide"))
                    continue;
                value = this._getValueForCFormat({rowIndex: rowIdx, colIndex: colIdx}, sheetIdx);
                type = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") ? xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") : "general";
                prevStatus = true;
                ruleIdx = -1;
                if (ej.isNullOrUndefined(value) || !value.length){
                    if ($.isNumeric(input)){
                        if ( input > 0 )
                            isApply = (action === "lessthan" || action === "lessequalto" || action === "notequalto");
                        else if ( input < 0)
                            isApply = (action === "greaterthan" || action === "greaterequalto" || action === "notequalto");
                        else 
                            isApply = (action === "equalto" || action === "lessequalto" || action === "greaterequalto");
                    }
                }
                else if ($.isNumeric(input)) {
                    if ($.isNumeric(value)) {
                        value = parseFloat(value);
                        isApply = xlObj.operators[op](value, parseFloat(input.replace(txtRegx, "")));
                    }
                    else if (xlObj._isValidDate(value)) {
                        isApply = xlObj.operators[op](xlObj._dateToInt(value), parseFloat(input));
                    }
                    else if (xlObj._isValidTime(value))
                        continue;
                    else
                        isApply = xlObj.operators[op](value.toLowerCase(), input.toLowerCase());
                }
                else if (input.lastIndexOf("%") === input.length - 1 && $.isNumeric(input.replace(numRegx, ""))) {
                    if (type === "percentage")
                        isApply = xlObj.operators[op](parseFloat(value), parseFloat(input.replace(numRegx, "")));
                    else
                        isApply = $.isNumeric(value) ? xlObj.operators[op](parseFloat(value), 0) : xlObj.operators[op](value.length, 0);
                }
                else if (input.indexOf("$") === 0 && $.isNumeric(input.replace(numRegx, ""))) {
                    if (type === "accounting" || type !== "currency" || $.isNumeric(value))
                        isApply = xlObj.operators[op](parseFloat(value), parseFloat(input.replace(numRegx, "")));
                    else
                        isApply = ((xlObj.operators[op](value.length, 0) || xlObj._isValidDate(value)) && !xlObj._isValidTime(value));
                }
                else if (xlObj._isValidDate(input)) {
                    if (xlObj._isValidDate(value)) {
                        isApply = xlObj.operators[op](xlObj._dateToInt(new Date(value)), xlObj._dateToInt(new Date(input)));
                    }
                    else if (!xlObj._isValidTime(value)) {
                        if ($.isNumeric(value))
                            isApply = xlObj.operators[op](parseFloat(value), xlObj._dateToInt(input));
                        else
                            isApply = xlObj.operators[op](value.length, xlObj._dateToInt(input));
                    }
                }
                else if (xlObj._isValidTime(input)) {
                    if (xlObj._isValidTime(value))
                        isApply = xlObj.operators[op](xlObj.parse.parseTime(value), xlObj.parse.parseTime(input));
                    else
                        isApply = $.isNumeric(value) ? xlObj.operators[op](parseFloat(value), 0) : xlObj.operators[op](value.length, 0);
                }
                else
                    isApply = xlObj.operators[op](value.toLowerCase(), input.toLowerCase());
                if (ej.isNullOrUndefined(addr))
                    addr = xlObj._generateHeaderText(startCell.colIndex + 1) + (startCell.rowIndex + 1) + ":" + xlObj._generateHeaderText(endCell.colIndex + 1) + (endCell.rowIndex + 1);
                tRule = action + "_" + op + "_" + input + "__" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                if (inputValue.startsWith("=")) {
                    input = inputValue.substr(1);
                    tRule = action + "_" + op + "_" + input + "__" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                    for (j = 0; j < xlObj.getObjectLength(referCell) - 1 ; j++)
                        this._formulaCellUpdate({ rowIndex: referCell["referCell" + j].rowIndex, colIndex: referCell["referCell" + j].colIndex }, { rowIndex: rowIdx, colIndex: colIdx }, input, referCell.formula, addr, cFColor, sheetIdx);
                }
                this._applyCFormatRule({ rowIndex: rowIdx, colIndex: colIdx }, tRule, ruleIdx, isApply, prevStatus, cFColor);
            }
        },

        _applyBetweenValues: function (op, input1, input2, cFColor, action, addr, sheetIdx, range) {
            var rowIdx, colIdx, xlObj = this.XLObj, value, $trgt, selected, temp, isApply, prevStatus, tRule, ruleIdx, type, numRegx = new RegExp(/[^.0-9]+/g), txtRegx = new RegExp(/[^.-a-zA-Z 0-9]+/g), convDate;
            var sheet = xlObj.getSheet(sheetIdx), startCell = sheet._startCell, endCell = sheet._endCell;
            if (!xlObj.operators["<"](xlObj.isNumber(input1) ? parseFloat(input1) : input1, xlObj.isNumber(input2) ? parseFloat(input2) : input2)) {
                temp = input2;
                input2 = input1;
                input1 = temp;
            }
            selected = (ej.isNullOrUndefined(range) && ej.isNullOrUndefined(addr)) ? xlObj.getSheet(sheetIdx)._selectedCells : xlObj._getSelectedCells(sheetIdx, addr).selCells;          
            for (var i = 0, len = selected.length; i < len; i++) {
                rowIdx = selected[i].rowIndex; colIdx = selected[i].colIndex;
                if (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isMHide") || xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isFilterHide"))
                    continue;
                value = this._getValueForCFormat({rowIndex: rowIdx, colIndex: colIdx}, sheetIdx);
                type = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") ? xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") : "general";
                prevStatus = true;
                ruleIdx = -1;
                if (ej.isNullOrUndefined(value) || !value.length){
                    if ($.isNumeric(input1) && $.isNumeric(input2)){
                        if ( (input1 > 0 && input2 > 0) || ( input1 < 0 && input2 < 0) )
                            isApply = (action === "notbetween");
                        else
                            isApply = (action === "between");
                    }
                }
                else if ($.isNumeric(input1.replace(txtRegx, "")) && $.isNumeric(input2.replace(txtRegx, "")) && type !== "percentage" && type !== "currency" && type !== "accounting") {
                    input1 = input1.replace(txtRegx, "");
                    input2 = input2.replace(txtRegx, "");
                    if ($.isNumeric(value))
                        isApply = xlObj.operators[op](parseFloat(value) >= parseFloat(input1) && parseFloat(value) <= parseFloat(input2));
                    else if (xlObj._isValidDate(value)) {
                        isApply = xlObj.operators[op](xlObj._dateToInt(value) >= parseFloat(input1) && convDate <= parseFloat(input2));
                    }
                    else if (xlObj._isValidTime(value))
                        continue;
                    else
                        isApply = xlObj.operators[op](value.toLowerCase() >= input1.toLowerCase() && value.toLowerCase() <= input2.toLowerCase());
                }
                else if (input1.lastIndexOf("%") === input1.length - 1 && $.isNumeric(input1.replace(numRegx, "")) && input2.lastIndexOf("%") === input2.length - 1 && $.isNumeric(input2.replace(numRegx, "")) && type === "percentage")
                    isApply = xlObj.operators[op](parseFloat(value) >= parseFloat(input1.replace(numRegx, "")) && parseFloat(value) <= parseFloat(input2.replace(numRegx, "")));
                else if (input1.indexOf("$") === 0 && $.isNumeric(input1.replace(numRegx, "")) && input2.indexOf("$") === 0 && $.isNumeric(input2.replace(numRegx, "")) && (type === "accounting" || type !== "currency"))
                    isApply = xlObj.operators[op](parseFloat(value) >= parseFloat(input1.replace(numRegx, "")) && parseFloat(value) <= parseFloat(input2.replace(numRegx, "")));
                else if (xlObj._isValidDate(input1) && xlObj._isValidDate(input2)) {
                    var date1 = xlObj._dateToInt(new Date(value)), date2 = xlObj._dateToInt(new Date(input1)), date3 = xlObj._dateToInt(new Date(input2));
                    isApply = xlObj.operators[op](date1 >= date2 && date1 <= date3);
                }
                else if (xlObj._isValidTime(input1) && xlObj._isValidTime(input2) && xlObj._isValidTime(value))
                    isApply = xlObj.operators[op](xlObj.parse.parseTime(value) >= xlObj.parse.parseTime(input1) && xlObj.parse.parseTime(value) <= xlObj.parse.parseTime(input2));
                else if ($.isNumeric(value))
                    isApply = xlObj.operators[op](parseFloat(value) >= parseFloat(input1) && parseFloat(value) <= parseFloat(input2));
                else
                    isApply = xlObj.operators[op](value.toLowerCase() >= input1.toLowerCase() && value.toLowerCase() <= input2.toLowerCase());
                if (ej.isNullOrUndefined(addr))
                    addr = xlObj._generateHeaderText(startCell.colIndex + 1) + (startCell.rowIndex + 1) + ":" + xlObj._generateHeaderText(endCell.colIndex + 1) + (endCell.rowIndex + 1);
                tRule = action + "_" + op + "_" + input1 + "_" + input2 + "_" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                this._applyCFormatRule({ rowIndex: rowIdx, colIndex: colIdx }, tRule, ruleIdx, isApply, prevStatus, cFColor);
            }
        },

        _applyContainsValues: function (input, cFColor, action, addr, sheetIdx, range) {
            var rowIdx, colIdx, type, xlObj = this.XLObj, value, $trgt, selected, temp, isApply, prevStatus, tRule, ruleIdx, txtRegx = new RegExp(/[^.-a-zA-Z 0-9]+/g);
            var sheet = xlObj.getSheet(sheetIdx), startCell = sheet._startCell, endCell = sheet._endCell;
            selected = (ej.isNullOrUndefined(range) && ej.isNullOrUndefined(addr)) ? xlObj.getSheet(sheetIdx)._selectedCells : xlObj._getSelectedCells(sheetIdx, addr).selCells;
            for (var i = 0, len = selected.length; i < len; i++) {
                rowIdx = selected[i].rowIndex; colIdx = selected[i].colIndex;
                if (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isMHide") || xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isFilterHide"))
                    continue;
                value = this._getValueForCFormat({ rowIndex: rowIdx, colIndex: colIdx }, sheetIdx);
                type = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") ? xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "type") : "general";
                prevStatus = true;
                ruleIdx = -1;
                if (ej.isNullOrUndefined(value) || !value.length)
                    isApply = false;
                else if ($.isNumeric(input.replace(txtRegx, ""))) {
                    input = input.replace(txtRegx, "");
                    if (xlObj._isValidDate(value))
                        value = ((xlObj._dateToInt(value))).toString();
                    isApply = value.indexOf(input) > -1;
                }
                else if (xlObj._isValidDate(input)) {
                    if (xlObj._isValidDate(value))
                        value = xlObj._dateToInt(value).toString();
                    isApply = value.indexOf(xlObj._dateToInt(input)) > -1;
                }
                else if (xlObj._isValidTime(input)) {
                    if (xlObj._isValidTime(value))
                        value = xlObj._dateToInt("01/01/1990 " + value).toString();
                    isApply = value.indexOf(xlObj._dateToInt("01/01/1990 " + input)) > -1;
                }
                else
                    isApply = value.toLowerCase().indexOf(input.toLowerCase()) > -1;
                if (ej.isNullOrUndefined(addr))
                    addr = xlObj._generateHeaderText(startCell.colIndex + 1) + (startCell.rowIndex + 1) + ":" + xlObj._generateHeaderText(endCell.colIndex + 1) + (endCell.rowIndex + 1);
                tRule = action + "__" + input + "__" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                this._applyCFormatRule({rowIndex: rowIdx, colIndex: colIdx}, tRule, ruleIdx, isApply, prevStatus, cFColor);
            }
        },

        _applyDateContainsValues: function (input, cFColor, action, addr, sheetIdx, range) {
            var rowIdx, colIdx, xlObj = this.XLObj, value, $trgt, isApply = false, tRule, ruleIdx;
            var sheet = xlObj.getSheet(sheetIdx), startCell = sheet._startCell, endCell = sheet._endCell, selected;
            selected = (ej.isNullOrUndefined(range) && ej.isNullOrUndefined(addr)) ? xlObj.getSheet(sheetIdx)._selectedCells : xlObj._getSelectedCells(sheetIdx, addr).selCells;
            for (var i = 0, len = selected.length; i < len; i++) {
                rowIdx = selected[i].rowIndex; colIdx = selected[i].colIndex;
                if (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isMHide") || xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isFilterHide"))
                    continue;
                value = this._getValueForCFormat({ rowIndex: rowIdx, colIndex: colIdx }, sheetIdx);
                ruleIdx = -1;
                if (ej.isNullOrUndefined(value) || !value.length)
                    isApply = false;
                else if (xlObj._isValidDate(input)) {
                    var date1 = new Date(value), date2 = new Date(input);
                    isApply = (date1 - date2) === 0;
                }
                if (ej.isNullOrUndefined(addr))
                    addr = xlObj._generateHeaderText(startCell.colIndex + 1) + (startCell.rowIndex + 1) + ":" + xlObj._generateHeaderText(endCell.colIndex + 1) + (endCell.rowIndex + 1);
                tRule = action + "__" + input + "__" + cFColor + "_" + addr + "_" + xlObj.getActiveSheetIndex();
                this._applyCFormatRule({rowIndex: rowIdx, colIndex: colIdx}, tRule, ruleIdx, isApply, true, cFColor);
            }
        },

        refreshCFormat: function (range) {
            var xlObj = this.XLObj, dupDetails = xlObj._dupDetails;
			if(xlObj.model.isReadOnly)
				return;
			xlObj._dupDetails = true;
            if (!xlObj.model.allowConditionalFormats)
                return;
            var i, j, rules = [], sheetIdx = xlObj.getActiveSheetIndex(), cFormatStr, selected, cFormatRule, len, rLen, rowIdx, colIdx;
            selected = xlObj._getSelectedCells(sheetIdx, range).selCells;
            for (i = 0, len = selected.length; i < len; i++) { //getting rules & clear rules
                rowIdx = selected[i].rowIndex; colIdx = selected[i].colIndex;
                cFormatRule = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "cFormatRule");
                if (!xlObj.isUndefined(cFormatRule) && cFormatRule.length)
                    for (j = 0, rLen = cFormatRule.length; j < rLen; j++) {
                        cFormatRule[j] = cFormatRule[j].replace("_true", "").replace("_false", "");
                        if (rules.indexOf(cFormatRule[j]) < 0)
                            rules.push(cFormatRule[j]);
                    }
                if(xlObj._isRowViewable(sheetIdx, rowIdx))
                    xlObj.getCell(rowIdx, colIdx, sheetIdx).removeClass("e-redft e-yellowft e-greenft e-redf e-redt");
                xlObj.clearRangeData([rowIdx, colIdx, rowIdx, colIdx], ["cFormatRule"], selected[i]);
            }
            //apply rules
            for (j = 0, rLen = rules.length; j < rLen; j++) {
                cFormatStr = rules[j].split("_");
                this._cFormat(cFormatStr[0], cFormatStr[2], cFormatStr[3], cFormatStr[4], cFormatStr[5]);
            }
            xlObj._dupDetails = dupDetails;
        },

        _applyCFormatRule: function (cell, tRule, ruleIdx, isApply, prevStatus, cFColor) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), rowIdx = cell.rowIndex, colIdx = cell.colIndex, isViewed, actCell, cFormatRule = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "cFormatRule"), rule, idx, isUpdate = true;
            if (this._getRuleIndex(tRule + "_true", cFormatRule) > -1)
                ruleIdx = this._getRuleIndex(tRule + "_true", cFormatRule); //check already rule exists
            if (this._getRuleIndex(tRule + "_false", cFormatRule) > -1)
                ruleIdx = this._getRuleIndex(tRule + "_false", cFormatRule);
            if (ruleIdx > -1) { //change rule index in cellobj and container for rule true, false changes
                rule = cFormatRule[ruleIdx];
                idx = xlObj._dataContainer.cFormatData.indexOf(this._updateCFormatRule(rule, isApply));
                if (idx > -1)
                    xlObj._dataContainer.sheets[sheetIdx][rowIdx][colIdx].cFormatRule[ruleIdx] = idx;
                else {
                    xlObj._dataContainer.cFormatData.push(this._updateCFormatRule(rule, isApply));
                    xlObj._dataContainer.sheets[sheetIdx][rowIdx][colIdx].cFormatRule[ruleIdx] = xlObj._dataContainer.cFormatData.length - 1;
                }
            }
            cFormatRule = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "cFormatRule");
            if (xlObj._isRowViewable(sheetIdx, rowIdx)) {
                isViewed = true;
                actCell = xlObj.getCell(rowIdx, colIdx);
            }
            if (!xlObj.isUndefined(cFormatRule) && (cFormatRule.length > 0 && (!(tRule + "_true" === cFormatRule[ruleIdx] || tRule + "_false" === cFormatRule[ruleIdx]) || (cFormatRule.length > 1)))) { //check and change prev applied status for multirule
                for (var j = 0, len = cFormatRule.length; j < len; j++) {
                    rule = cFormatRule[j].split("_");
                    //if (rule[7] === "true" && rule[4] === cFColor)
                    //    prevStatus = false;
                }
                if (isViewed)
                    if (isApply)
                        actCell.removeClass("e-redft e-yellowft e-greenft e-redf e-redt").addClass("e-" + cFColor);
            }
			else {
                if (isViewed)
                    if (isApply)
                        actCell.removeClass("e-redft e-yellowft e-greenft e-redf e-redt").addClass("e-" + cFColor);
            }
            //for editing 
            if (cFormatRule && cFormatRule.length) {
                var range1 = xlObj.getRangeIndices(tRule.split("_")[5]), range2 = xlObj.getRangeIndices(cFormatRule[0].split("_")[5]), ruleArray = tRule.split("_");
                ruleArray.splice(6, 1);//remove sheet index
                ruleArray.splice(5, 1);//remove address
                if (cFormatRule[0].indexOf(ruleArray.join("_")) > -1 && xlObj.inRange(range2, range1[0], range1[1]))
                    isUpdate = false;
            }
            if (isUpdate && (this._getRuleIndex(tRule + "_true", cFormatRule) < 0 && this._getRuleIndex(tRule + "_false", cFormatRule) < 0))  //apply rule for first time while applying        
                xlObj.XLEdit._updateDataContainer(cell, { dataObj: { "cFormatRule": [tRule + "_" + isApply] }, skipCell: !isApply });
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.clipboard = function (obj) {
        this.XLObj = obj;
        this._cutCells = [];
        this._copyCells = [];
        this._copyBackup = {};
        this._cData = "";
        this._isCut = false;
        this._copyRange = [];
        this._isSpecial = !obj.isPasteValuesOnly;
        this._isShape = false;
    };

    ej.spreadsheetFeatures.clipboard.prototype = {
        //Cut, copy and paste
        copy: function () {
            this._triggerKeyDown(67, true);
        },

        cut: function () {
            if (this.XLObj.model.isReadOnly)
                return;
            this._triggerKeyDown(88, true);
        },

        paste: function () {
			if(this.XLObj.model.isReadOnly)
				return;
            this._triggerKeyDown(86, true);
        },

        _initCopyPaste: function () {
            var xlId = this.XLObj._id, $div = ej.buildTag("div", {}, { position: "fixed", top: -1000, left: -1000 }, { id: xlId + "_copyPaste" });
            $("body").append($div);
            $div.append(ej.buildTag("textarea " + "." + xlId + "_copyTxt", {}, { width: 1, height: 1, overflow: "hidden", opacity: 0, resize: "none", cursor: "default" }, { id: xlId + "_hiddenTxt" }));
        },

        _copyPasteHandler: function (e) {
            var selCells, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), actSheet = xlObj.getSheet(sheetIdx);
            xlObj._isUndoRedo = false;
            if(!xlObj.model.allowEditing && (e.keyCode === 88 || e.keyCode === 86)){
             return false;
             }
            if ((e.keyCode === 67 || e.keyCode === 88 || e.keyCode === 86) && xlObj._preventctrlkey) {
                xlObj._showAlertDlg("Alert", "CtrlKeyErrorAlert", "CtrlKeyErrorAction", 450);
                return;
            }
            if (e.ctrlKey) {
                if (e.keyCode === 67) //copy
                {
                    this._getClipboard(e);
                    this._cutCells = [];
                    $.extend(true, this._copyCells,actSheet._selectedCells);
                    if (!this._copyCells.length)
                        this._copyCells = [xlObj.XLShape._picCellIdx];
                    setTimeout(function () {
                        xlObj.setSheetFocus();
                    }, 0);
                }
                else if (e.keyCode === 88) //cut
                {              
                    selCells = actSheet._selectedCells;
                    if (xlObj.model.allowLockCell && actSheet.isSheetProtected) {
                        if (xlObj._isPropExists([actSheet.selectedRange], "isLocked", sheetIdx))
                            return;
                    }
                    if (selCells.length && xlObj._isPropExists([actSheet.selectedRange], "isReadOnly", sheetIdx))
                        return;
                    this._copyCells = [];
                    $.extend(true, this._cutCells, selCells);
                    if (!this._cutCells.length)
                        this._cutCells = [xlObj.XLShape._picCellIdx];
                    this._getClipboard(e);
                    setTimeout(function () {
                        xlObj.setSheetFocus();
                    }, 0);
                }
                else if (e.keyCode === 86) //paste
                {
                    if (!xlObj.isUndefined(e.bubbles))
                        this._isSpecial = !xlObj.isPasteValuesOnly;
                    if (this._cData.length || this._copyBackup.elem)
                        $("#" + xlObj._id + "_hiddenTxt").val(this._cData);
                    else if (e.originalEvent)
                        $("#" + xlObj._id + "_hiddenTxt").select();
                    else {
                        $("#" + xlObj._id + "_hiddenTxt").val("");
                        xlObj._showAlertDlg("Alert", ["ClipboardAccessError", "ClipboardAccessCutError", "ClipboardAccessCopyError", "ClipboardAccessPasteError"], "ClipboardAccessError", 450);
                        return;
                    }
                    setTimeout(function () {
                        xlObj.XLClipboard._setClipboard();
                    }, 0);
                }
            }
            else if (e.keyCode === 27 && xlObj.element.find(".e-cdata").length) { //escape          
                xlObj.element.find("td.e-cutright, td.e-cutbottom").removeClass("e-cutright e-cutbottom");
                $("#" + xlObj._id + "_hiddenTxt").val("");
                this._cData = "";
                this._copyCells = [];
            }
        },

        _triggerKeyDown: function (keyCode, ctrlKey) {
            var xlObj = this.XLObj;
            xlObj.setSheetFocus();
            var e = $.Event("keydown");
            e.keyCode = keyCode;
            e.ctrlKey = ctrlKey;
            $("#" + xlObj._id).trigger(e);
        },

        _getClipboard: function (e) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), actSheet = xlObj.getSheet(sheetIdx), startcell = actSheet._startCell, endcell = actSheet._endCell;
            var selected = xlObj._getContent(sheetIdx).find(".e-selected"), actCell = xlObj.getActiveCellElem(sheetIdx)[0];
            if (!xlObj.model.allowClipboard)
                return;
            if (!xlObj.XLClipboard._copyBackup.cells && xlObj.model.showRibbon && !xlObj.model.isReadOnly) {
                xlObj.XLRibbon._enableButtons(["Home_Clipboard_Paste"], "ejButton");
                xlObj.XLRibbon._enableButtons(["Home_Clipboard_PasteOptions"], "ejSplitButton");
                if (xlObj.isPasteValuesOnly)
                    $("#" + xlObj._id + "_Ribbon_Paste").data("ejMenu").disableItemByID("PasteSpecial");
            }
            if (selected.length) {
                this._copyBackup = { cells: [], border: xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(), table: [], filterRange: [] };
                var textContent = this._getSelectedData(startcell, endcell);
                if (xlObj.element.find(".e-cdata").length)
                    xlObj.element.find("td.e-cutright, td.e-cutbottom").removeClass("e-cutright e-cutbottom");
                $(selected).addClass("e-cdata");
                xlObj.XLSelection._focusBorder(startcell, endcell, xlObj._cutFocus);
                if (selected.length < 2 && !textContent.length)
                    this._cData = textContent = " ";
                else
                    this._cData = textContent;
                this._isCut = false;
                $("#" + xlObj._id + "_hiddenTxt").val(textContent).select();
                navigator.platform.toLowerCase().indexOf('mac') > -1 && document.execCommand("copy");
				this._copyBackup.actCellPos = { "top": actCell.offsetTop, "left": actCell.offsetLeft };
                if (this._copyBackup.cells[0]["cell"]["wrap"])
                    this._copyBackup.cells[0]["cell"]["wrap"] = "";
                if (e.keyCode == 67)
                    this._copyBackup.copypaste = true;
                this._isShape = false;
            }
            else {
                this._isShape = true;
                this._copyBackup = { elem: xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg"), isCut: e.keyCode === 88, sIdx: sheetIdx };
            }
        },

        _getSelectedData: function (startCell, endCell) {
            var cData, xlObj = this.XLObj, textContent = "", cell, i, j, value, sheetIdx = xlObj.getActiveSheetIndex();
            if (startCell.rowIndex >= endCell.rowIndex) {
                var t = startCell;
                startCell = endCell;
                endCell = t;
            }
            this._copyRange = [];
            this._copyRange.push(xlObj.getActiveSheetIndex());
            this._copyRange.push(xlObj._getSelectedItems()[1]);
            for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                if (i !== startCell.rowIndex)
                    textContent += "\n";
                if (startCell.colIndex <= endCell.colIndex) {
                    for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                        cData = xlObj.getRangeData({ range: [i, j, i, j], property: ["type", "value", "value2"] })[0];
                        if (xlObj.getObjectLength(cData))
                            value = cData.type !== "general" ? cData.value2 : cData.value;
                        else
                            value = "";
                        this._updateCBackupData(i, j);
                        //if (cell) {
                            if (j !== endCell.colIndex)
                                textContent += value + "\t";
                            else {
                                textContent += value;
                            }
                        }
                    }
                else {
                    for (j = endCell.colIndex; j <= startCell.colIndex; j++) {
                        cData = xlObj.getRangeData({ range: [i, j, i, j], property: ["type", "value", "value2"] })[0];
                        if (xlObj.getObjectLength(cData))
                            value = cData.type !== "general" ? cData.value2 : cData.value;
                        else
                            value = "";
                        this._updateCBackupData(i, j);
                        //if (cell) {
                            if (j !== startCell.colIndex)
                                textContent += value + "\t";
                            else {
                                textContent += value;
                            }
                        //}
                        }
                    }
                }
            //get table details
            var tblMgr = xlObj.model.sheets[sheetIdx].tableManager, tblKeys, tblObj, tblRange, tblName = [], selectedRange = xlObj.model.sheets[sheetIdx].selectedRange;
            tblKeys = xlObj.getObjectKeys(tblMgr);
			for (var m = 0, rLen = tblKeys.length; m <= rLen; m++) {
                tblObj = $.extend(true, {}, tblMgr[tblKeys[m]]);
				if(xlObj.getObjectLength(tblObj)) {
					tblRange = tblObj.range;
					if (this._compareRange(selectedRange, tblRange)) {
						tblName.push(tblObj.name);
						tblObj.header = true;
						tblObj.tblId = tblKeys[m];
						this._copyBackup.table.push({ tblName: tblName, tblObj: tblObj, range: tblRange });
						break;
					}
				}
            }
            //get filtering details
            var fltrRange = xlObj.getRangeIndices(xlObj.model.sheets[sheetIdx].filterSettings.range);
            if (this._compareRange(selectedRange, fltrRange))
                this._copyBackup.filterRange = fltrRange;
            return textContent;
        },

        _updateCBackupData: function (rowIdx, colIdx) {
            var xlObj = this.XLObj;           
            var sheetIdx = xlObj.getActiveSheetIndex(), format, container = xlObj._dataContainer.sheets[sheetIdx], cellObj, regx = new RegExp("\\b" + "e-format" + ".*?\\b", "g");
            if (rowIdx in container && colIdx in container[rowIdx]) {
                cellObj = $.extend(true, {}, container[rowIdx][colIdx]);
                format = cellObj.format ? cellObj.format : "";
            }
            else {
                cellObj = {};
                format = "";
            }
            this._copyBackup.cells.push({ cell: cellObj, format: format });
        },

        _setClipboard: function () {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var currentCellIdx, cHeight, tRange, pval, evtArgs, settings, contentRows, fval, overflow, prop, cellObj, prtctRange, row = [], cell = [], type, regx = new RegExp("\\b" + "e-format" + ".*?\\b", "g"), currentCell, isColor = false, partialTbl = false, currCell, sheetIdx = xlObj.getActiveSheetIndex(), details = { cSheetIndex: this._copyRange[0], pSheetIndex: sheetIdx, sheetIndex: sheetIdx }, pastedTable = [];
            var startCell = xlObj.getSheet(sheetIdx)._startCell, endCell = xlObj.getSheet(sheetIdx)._endCell, i, j, k = 0, m, rLen, addr, cFormatRule, splitStr, shapeObj = {}, shapeElem, fltr, currCellObj, shapeRegx = new RegExp("\\b" + "e-shapebdr" + ".*?\\b", "g"), bstyle = ["solid", "dashed", "dotted"], cname;
            var minRowIdx = (startCell.rowIndex < endCell.rowIndex) ? startCell.rowIndex : endCell.rowIndex, tblName, tblRange, tableObj = this._copyBackup.table, style, bcolor, copyRowIdx;
            var minColIdx = (startCell.colIndex < endCell.colIndex) ? startCell.colIndex : endCell.colIndex, container = xlObj._dataContainer, range, cellPos;
            var pstCells, selCells, cpyLen = this._copyCells.length, cutLen = this._cutCells.length;
            xlObj.isPasteValuesOnly && (this._isSpecial = false);
            if (this._copyRange.length) {
                prtctRange = xlObj.swapRange(xlObj.getRangeIndices(this._copyRange[1]));
                selCells = xlObj._getSelectedRange({ rowIndex: prtctRange[0], colIndex: prtctRange[1] }, { rowIndex: prtctRange[2], colIndex: prtctRange[3] });
                tRange = [minRowIdx, minColIdx, minRowIdx + (prtctRange[2] - prtctRange[0]), minColIdx + (prtctRange[3] - prtctRange[1])];
                pstCells = xlObj._getSelectedRange({ rowIndex: tRange[0], colIndex: tRange[1] }, { rowIndex: tRange[2], colIndex: tRange[3] });
				if (xlObj.model.allowLockCell && xlObj.getSheet(sheetIdx).isSheetProtected) {
					if (xlObj._isPropExists([tRange], "isLocked", sheetIdx))
						return;
				}
				if (xlObj._isPropExists([tRange], "isReadOnly", sheetIdx))
					return;
			}
            if ((minRowIdx === 0 && minColIdx === 0 && cpyLen === (this.XLObj.model.rowCount * this.XLObj.model.columnCount)) || cpyLen !== (this.XLObj.model.rowCount * this.XLObj.model.columnCount)) {
                var objIdx, actSheet = xlObj.model.sheets[sheetIdx], psheet = xlObj.model.sheets[this._copyBackup.sIdx], actCell = xlObj.getSheetElement(sheetIdx).find(".e-activecell"), shapeMgr = xlObj.getSheet(this._copyBackup.sIdx || this._copyRange[0] || sheetIdx).shapeMngr, pRange, className, len, cLen, isCut, cutCells, cSheetIdx = this._copyRange[0];
                if (this._isShape) {
                    if (!this._isSpecial)
                        return false;
                    var shapeIdx, id, cellIdx = xlObj.XLShape._picCellIdx, actCellIdx = xlObj.getActiveCell(sheetIdx);
                    shapeElem = this._copyBackup.elem;
                    id = shapeElem[0].id;
                    type = id.indexOf("picture") > -1 ? "picture" : "chart";
                    details = { sheetIndex: sheetIdx, cSheetIndex: this._copyBackup.sIdx, pSheetIndex: sheetIdx, operation: "shape", cShapeId: id, reqType: (this._copyBackup.isCut) ? "cut-paste" : "copy-paste" };
                    cellObj = $.extend(true, {}, container.sheets[this._copyBackup.sIdx][cellIdx.rowIndex][cellIdx.colIndex]);
                    cell = xlObj.getCell(actCellIdx.rowIndex, actCellIdx.colIndex);
                    $.extend(true, shapeObj, shapeMgr[type][id]);
                    details.cutCell = { rowIndex: cellIdx.rowIndex, colIndex: cellIdx.colIndex, obj: cellObj, shapeObj: $.extend(true, {}, shapeObj)};
                    shapeElem = xlObj.element.find("#" + shapeObj.id);
                    if (type === "picture") {
                        className = shapeElem[0].className;
                        if (className.indexOf("e-shapebdr") > -1) {
                            className = shapeElem[0].className.match(shapeRegx)[0];
                            style = className.replace("e-shapebdr", "").split("N");
                            bcolor = style[2];
                            xlObj.XLShape._createPicture(sheetIdx, actCellIdx, shapeMgr.sharedPics[shapeObj.data], cell[0].offsetTop, cell[0].offsetLeft, shapeObj.width, shapeObj.height, null, "#" + bcolor, bstyle[parseInt(style[1]) - 1], style[0] + "px");
                            (xlObj.model.showRibbon) && xlObj.XLRibbon._formatTabUpdate();
                        }
                        else {
                            xlObj.XLShape._createPicture(sheetIdx, actCellIdx, shapeMgr.sharedPics[shapeObj.data], cell[0].offsetTop, cell[0].offsetLeft, shapeObj.width, shapeObj.height);
                            (xlObj.model.showRibbon) && xlObj.XLRibbon._formatTabUpdate();
                        }
                    }
                    else {
                        range = shapeObj.range;
                        range = xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);
                        if (range.indexOf(":") === -1)
                            range = range + ":" + range;
                        shapeObj.top = cell[0].offsetTop;
                        shapeObj.left = cell[0].offsetLeft;
                        xlObj.XLChart.createChart(range, $.extend(true, {}, shapeObj));
                    }
                    this._isShape = this._copyBackup.isCut ? false : true;
                    this._cutCells = [];
                    if (!xlObj._isUndoRedo) {
                        cellObj = $.extend(true, {}, container.sheets[sheetIdx][actCellIdx.rowIndex][actCellIdx.colIndex]);
                        shapeObj = $.extend(true, {}, actSheet.shapeMngr[type][cellObj[type][0]]);
                        details.pShapeId = cellObj[type][0];
                        details.pasteCell = { rowIndex: actCellIdx.rowIndex, colIndex: actCellIdx.colIndex, obj: cellObj, shapeObj: shapeObj };
                        evtArgs = { sheetIndex: details.sheetIndex, cutCell: details.cutCell, pasteSheetIndex: details.pSheetIndex, operation: details.operation, reqType: details.reqType, pasteShapeId: details.pShapeId, pasteCell: details.pasteCell };
                        if (evtArgs.reqType === "cut-paste") {
                            evtArgs.cutSheetIndex = details.cSheetIndex;
                            evtArgs.cutShapeId = details.cShapeId;
                        }
                        else {
                            evtArgs.copySheetIndex = details.cSheetIndex;
                            evtArgs.copyshapeId = details.cShapeId;
                        }
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(evtArgs);
                        if (this._copyBackup.isCut) {
                            cellObj = $.extend(true, {}, container.sheets[this._copyBackup.sIdx][cellIdx.rowIndex][cellIdx.colIndex]);
                            cellObj[type].some(function (obj, i) {
                                if (shapeElem[0].id === psheet.shapeMngr[type][cellObj[type][i]].id) {
                                    objIdx = i;
                                    return true;
                                }
                                return false;
                            });
                            if (Object.keys(cellObj).length < 2 && cellObj[type].length < 2) {
                                delete container.sheets[this._copyBackup.sIdx][cellIdx.rowIndex][cellIdx.colIndex];
                                if (xlObj.getObjectLength(container.sheets[this._copyBackup.sIdx][cellIdx.rowIndex]) < 1)
                                    delete container.sheets[this._copyBackup.sIdx][cellIdx.rowIndex]
                            }
                            else if (cellObj[type].length < 2)
                                delete cellObj[type];
                            else
                                cellObj[type].splice(objIdx, 1);
                            delete psheet.shapeMngr[type][details.cShapeId];
                        }
                    }
                    if (this._copyBackup.isCut)
                        shapeElem.remove();
                }
                else {
                    isColor = (this._cData === $("#" + xlObj._id + "_hiddenTxt").val()) && (this._copyRange.length > 0);
                    if (isColor) {
                        if (xlObj.model.allowLockCell && xlObj.getSheet(sheetIdx).isSheetProtected) {
                            if (xlObj._isPropExists([tRange], "isLocked", sheetIdx))
                                return;
                        }
                        if (xlObj._isPropExists([tRange], "isReadOnly", sheetIdx))
                            return;
                    }
                    var shapes = [];
                    details.reqType = (cutLen > 0) ? "cut-paste" : "copy-paste";
                    if (xlObj.element.find(".e-selected").hasClass("e-readonly")) {
                        if (xlObj.element.find(".e-cdata").length)
                            xlObj.element.find(".e-cutright, .e-cutbottom").removeClass("e-cutright e-cutbottom");
                        return;
                    }
                    details.text = row = $("#" + xlObj._id + "_hiddenTxt").val().length ? $("#" + xlObj._id + "_hiddenTxt").val().split("\n") : [];
                    if (this._cData.length < 1 && details.text.length < 1)
                        return;
                    if (!isColor && row[row.length - 1] === "")
                        row.splice(row.length - 1, 1);
                    var pasteCells = [], shapes = [], hldata, value2, rowIdx, colIdx, cRowIdx, cColIdx;
                    if (isColor) {
                        details.isSpecial = this._isSpecial;
                        range = xlObj.getRangeIndices(this._copyRange[1]);
                        xlObj.setActiveSheetIndex(this._copyRange[0]);
                        details.cutBorder = { range: range, prevBorder: xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(range) };
                        xlObj.setActiveSheetIndex(sheetIdx);
                    }
                    else
                        details.isSpecial = false;
                    if (cutLen) { //cut special
                        cutCells = [];
                        cSheetIdx = this._copyRange[0];
                        (!tableObj.length) && this._cutPasteBorder(prtctRange, tRange);
                        for (i = 0; i < cutLen; i++) {
                            rowIdx = this._cutCells[i].rowIndex;
                            colIdx = this._cutCells[i].colIndex;
                            currentCell = xlObj.getCell(rowIdx, colIdx, cSheetIdx);   //this._copyRange[0] is cutcell sheetIndex
                            cname = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "tableName") || "";
                            cell = { rowIndex: rowIdx, colIndex: colIdx, prevObj: {}, newObj: {}, shapes: [] };
                            if (!ej.isNullOrUndefined(container.sheets[cSheetIdx][rowIdx]))
                                $.extend(true, cell.prevObj, container.sheets[cSheetIdx][rowIdx][colIdx]);
                            else
                                cell.prevObj = {};
                            cellObj = ej.isNullOrUndefined(container.sheets[cSheetIdx][rowIdx]) ? {} : $.extend(true, {}, container.sheets[cSheetIdx][rowIdx][colIdx]);
                            if (currentCell && currentCell[0]) {
                                if (!("merge" in cell.prevObj)) {
                                    xlObj.XLEdit._updateCellValue({ rowIndex: rowIdx, colIndex: colIdx }, "", "", cSheetIdx);
                                    xlObj._refreshRowHeight(cSheetIdx, rowIdx);
                                }
                                if ("wrap" in cellObj) {
                                    addr = xlObj._generateHeaderText(colIdx + 1) + (rowIdx + 1);
                                    xlObj._dupDetails = true;
			                        xlObj.setActiveSheetIndex(cSheetIdx);
                                    xlObj.setWrapText("unwrap", addr + ":" + addr);
									xlObj.setActiveSheetIndex(sheetIdx);
                                    xlObj._dupDetails = false;
                                }
                                if ('cellType' in cellObj)
                                    xlObj.model.allowCellType && xlObj.XLCellType._removeControls(rowIdx, colIdx, cSheetIdx, true);
                                currentCell.removeClass("e-hyperlinks e-redft e-yellowft e-greenft e-redf e-redt");
                                currentCell.find('a').remove();
                                if (currentCell.hasClass("e-commentcell"))
                                    xlObj.XLComment.deleteComment([rowIdx, colIdx, rowIdx, colIdx], cSheetIdx);
                                if (xlObj.model.allowCellFormatting && !xlObj.XLRibbon._isDirtySelect)
                                    tableObj.length ? xlObj.XLFormat.removeStyle(range) : xlObj.XLFormat.removeStyle(range, { cellStyle: true, tableStyle: true, format: true });
                                if ((rowIdx in container.sheets[cSheetIdx]) && (colIdx in container.sheets[cSheetIdx][rowIdx])) {
                                    !ej.isNullOrUndefined(container.sheets[cSheetIdx][rowIdx][colIdx]) && (overflow = container.sheets[cSheetIdx][rowIdx][colIdx]['overflow']);
                                    delete container.sheets[cSheetIdx][rowIdx][colIdx];
                                    xlObj._textClip(rowIdx, colIdx, 'delete');
                                }
                                if (currentCell[0].className.match(regx))
                                    currentCell[0].className = currentCell[0].className.replace(regx, "");
                                if (!ej.isNullOrUndefined(container.sheets[cSheetIdx][rowIdx]))
                                    $.extend(true, cell.newObj, container.sheets[cSheetIdx][rowIdx][colIdx]);
                                else
                                    cell.newObj = {};
                                xlObj._setRowHdrHeight(cSheetIdx, xlObj._getCellIdx(currentCell[0]).rowIndex);
                            }
                            else if (xlObj.getObjectLength(cellObj)) {
                                prop = xlObj.getObjectKeys(cellObj);
                                xlObj.clearRangeData([rowIdx, colIdx, rowIdx, colIdx], prop);
                                if (xlObj.model.allowCellType && ('cellType' in cellObj))
                                    delete container.sheetCellType[container.sheets[cSheetIdx][rowIdx][colIdx]['cellType']];                              
                            }
                            cutCells.push(cell);
                        }
                        for (m = 0, rLen = tableObj.length; m < rLen; m++) {
                            var tempIdx = xlObj.getActiveSheetIndex();
                            xlObj.gotoPage(cSheetIdx, false);
                            tblName = $.trim(tableObj[m].tblName);
                            xlObj.XLFormat.removeTable(xlObj._getTableID(null, tblName, cSheetIdx));
                            xlObj.gotoPage(tempIdx, false);
                        }
                        if (xlObj.model.allowCellFormatting)
                            xlObj.XLFormat.removeStyle(range, { cellStyle: true, tableStyle: true, format: true });
                        xlObj.setActiveSheetIndex(cSheetIdx);
                        //xlObj.model.allowCellFormatting && xlObj.XLFormat.removeStyle(range, { cellStyle: true, tableStyle: true, border: true });
                        xlObj.setActiveSheetIndex(sheetIdx);
                        details.cutCells = cutCells;
                        details.cfat = { table: tblName, range: range };
                        isCut = true;
                        if (xlObj.element.find(".e-cdata").length)
                            xlObj.element.find(".e-cutright, .e-cutbottom").removeClass("e-cutright e-cutbottom");
                    }
                    else {
                        var copyCells = [];
                        if (this._isSpecial) {
                            for (i = 0; i < cpyLen; i++) {
                                rowIdx = this._copyCells[i].rowIndex;
                                colIdx = this._copyCells[i].colIndex;
                                cell = { rowIndex: rowIdx, colIndex: colIdx, prevObj: {}, newObj: {} };
                                if (!ej.isNullOrUndefined(container.sheets[sheetIdx][rowIdx]))
                                    $.extend(true, cell.prevObj, container.sheets[sheetIdx][rowIdx][colIdx]);
                                copyCells.push(cell);
                            }
                        }
                        else
                            copyCells = this._copyCells;
                        details.cutCells = copyCells;
                    }
                    if (row.length)
                        pRange = [minRowIdx, minColIdx, minRowIdx + row.length - 1, minColIdx + row[0].split("\t").length - 1];
                    else {
                        pRange = [minRowIdx, minColIdx, minRowIdx, minColIdx];
                        i = j = 1;
                    }
                    details.pasteBorder = { range: pRange, prevBorder: xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(pRange) };
                    if (cpyLen) {
                        var l, pIdx, plen, colIdx, rowIdx, bordrs = [];
                        xlObj.XLFormat.removeStyle(tRange, { border: true, cellStyle: true, format: true });
                        for (l = 0, plen = pstCells.length; l < plen; l++) {
                            pIdx = pstCells[l];
                            rowIdx = selCells[l].rowIndex;
                            colIdx = selCells[l].colIndex;
                            bordrs = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "borders", this._copyRange[0]);
                            if (!xlObj.isUndefined(bordrs))
                                xlObj.XLFormat.applyBorder(bordrs, [pIdx.rowIndex, pIdx.colIndex, pIdx.rowIndex, pIdx.colIndex]);
                        }
                    }
                    var merge, isMHide, mergeIdx, cutCntnr, contentRows = xlObj._getContTBody(sheetIdx).find("rows");
                    for (i = 0, len = row.length; i < len; i++) {
                        cell = row[i].split("\t");
                        for (j = 0, cLen = cell.length; j < cLen; j++) {
                            currentCell = contentRows[xlObj._getRowIdx(minRowIdx + i)] ? xlObj.getCell(minRowIdx + i, minColIdx + j)[0] : undefined;
                            if (ej.isNullOrUndefined(currentCell)) {
                                if (actSheet.colCount <= minColIdx + j)
                                    xlObj.XLScroll._createNewColumn(sheetIdx, { rowIndex: -1, colIndex: -1 }, { rowIndex: -1, colIndex: -1 }, "insert");
                                else if (xlObj.model.scrollSettings.allowScrolling && !xlObj.model.scrollSettings.allowVirtualScrolling)
                                    xlObj.XLScroll._createNewRow(sheetIdx, -1, -1, "insert");
                                xlObj.XLScroll._refreshScroller(sheetIdx, "refresh", "all");
                                currentCell = xlObj.getCell(minRowIdx + i, minColIdx + j);
                            }
                            else
                                currentCell = $(currentCell);
                                currCell = { rowIndex: minRowIdx + i, colIndex: minColIdx + j };
                                currCell.prevObj = (!ej.isNullOrUndefined(container.sheets[sheetIdx][minRowIdx + i])) ? $.extend(true, {}, container.sheets[sheetIdx][minRowIdx + i][minColIdx + j]) : {};
                                if (!ej.isNullOrUndefined(currCell.prevObj)) {
                                    delete currCell.prevObj["isMHide"];
                                    delete currCell.prevObj["mergeIdx"];
                                }
                                if (this._isCut && isColor)
                                    return;
                                currentCellIdx = { rowIndex: minRowIdx + i, colIndex: minColIdx + j };
                                if (this._isSpecial && isColor) { //paste special 
                                    rowIdx = currentCellIdx.rowIndex;
                                    colIdx = currentCellIdx.colIndex;
                                    cRowIdx = selCells[k].rowIndex;
                                    cColIdx = selCells[k].colIndex;
									className = xlObj._dataContainer.hashCode[this._copyBackup.cells[k].format];
									if (!("merge" in this._copyBackup.cells[k].cell) && !ej.isNullOrUndefined(className))
										xlObj.addClass(currentCell, className);
									cellObj = $.extend(true, {}, this._copyBackup.cells[k].cell);
									if (!(rowIdx in container.sheets[sheetIdx]))
										container.sheets[sheetIdx][rowIdx] = {};
									if (!(colIdx in container.sheets[sheetIdx][rowIdx]))
										container.sheets[sheetIdx][rowIdx][colIdx] = {};
									else {
										if ("comment" in container.sheets[sheetIdx][rowIdx][colIdx])
											xlObj.getCell(rowIdx, colIdx).removeClass("e-commentcell");
									}
									if (cellObj) {
										merge = $.extend(true, {}, xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "merge"));
										isMHide = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isMHide");
										mergeIdx = $.extend(true, {}, xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "mergeIdx"));
										delete cellObj['overflow'];
										delete cellObj['isOverflow'];
										delete cellObj['tableName'];
										$.extend(true, container.sheets[sheetIdx][rowIdx][colIdx], cellObj);
										cutCntnr = container.sheets[sheetIdx][rowIdx][colIdx];
										if (xlObj.getObjectLength(merge))
											cutCntnr.merge = merge;
										else
											delete cutCntnr.merge;
										if (xlObj.getObjectLength(mergeIdx))
											cutCntnr.mergeIdx = mergeIdx;
										else
											delete cutCntnr.mergeIdx;
										if (!xlObj.isUndefined(isMHide))
											cutCntnr.isMHide = isMHide;
										else
											delete cutCntnr.isMHide;
										if(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2")){
											xlObj._textClip(rowIdx, colIdx, 'delete');
											xlObj._textClip(rowIdx, colIdx, 'add');
										}
										if (cellObj.value2 && typeof cellObj.value2 == "string" && !cellObj.formatStr)
											value2 = container.sharedData[cellObj.value][0] === "=" ? container.sharedData[cellObj.value] : cellObj.value2;
										else
											value2 = container.sharedData[cellObj.value];
										if (cellObj.type === 3)
											value2 = this._getUpdatedCellFormula(value2, this._copyCells[k], { rowIdx: rowIdx, colIdx: colIdx });
										if (!("merge" in cellObj)) {
											xlObj.XLEdit._updateCellValue(currentCellIdx, value2);
											cHeight = xlObj.XLEdit.getPropertyValue(cRowIdx, 0, (details.reqType === "copy-paste") ? "cHeight" : "pHeight", this._copyRange[0]);
                                            if (!xlObj.isUndefined(cHeight)) {
                                                xlObj.XLEdit._updateDataContainer({ rowIndex: currentCellIdx.rowIndex, colIndex: 0 }, { dataObj: { pHeight: xlObj.getSheet(sheetIdx).rowsHeightCollection[currentCellIdx.rowIndex], cHeight: cHeight } });
                                                xlObj.getSheet(sheetIdx).rowsHeightCollection[currentCellIdx.rowIndex] = cHeight;
                                                if (xlObj._isRowViewable(sheetIdx, currentCellIdx.rowIndex))
                                                    xlObj.getRows(sheetIdx)[1][xlObj._getRowIdx(currentCellIdx.rowIndex)].style.height = cHeight + "px";
											}
										}
										if ("merge" in cellObj) {
											var length = 0, pstCell, pstCellObj, rowSpan, colSpan, merge = cellObj.merge;
											range = xlObj.getRangeIndices(merge.mRange);
											var rowCnt = range[2] - range[0], colCnt = range[3] - range[1], selectCells = xlObj.getSheet(sheetIdx)._selectedCells;
											var cellRange = xlObj._getAlphaRange(sheetIdx, currCell.rowIndex, currCell.colIndex, currCell.rowIndex + rowCnt, currCell.colIndex + colCnt);
											var mCell, sRowCnt = endCell.rowIndex - startCell.rowIndex, sColCnt = endCell.colIndex - startCell.colIndex;//sRowCnt is selected cell row count & sColCnt is selectedcell Colcount
											pstCell = xlObj._getSelectedRange({ rowIndex: currCell.rowIndex, colIndex: currCell.colIndex }, { rowIndex: currCell.rowIndex + rowCnt, colIndex: currCell.colIndex + colCnt });
											if (selCells.length >= selectCells.length || !(((sColCnt + 1) % (colCnt + 1)) === 0 && ((sRowCnt + 1) % (rowCnt + 1)) === 0)) {
												for (m = 0, rLen = pstCell.length; m < rLen; m++) {
													if (ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(pstCell[m].rowIndex, pstCell[m].colIndex, "isMHide"))) {
														pstCellObj = xlObj.XLEdit.getPropertyValue(pstCell[m].rowIndex, pstCell[m].colIndex, "merge");
														length++;
														if (!ej.isNullOrUndefined(pstCellObj)) {
															if (pstCellObj) {
																rowSpan = pstCellObj.mSpan.rowSpan;
																colSpan = pstCellObj.mSpan.colSpan;
															}
															if (!ej.isNullOrUndefined(rowSpan) && !ej.isNullOrUndefined(colSpan))
																length += (parseInt(rowSpan) * parseInt(colSpan)) - 1;
															if (pstCellObj.isCenterAlign) {
																if (xlObj._isRowViewable(sheetIdx, pstCell[m].rowIndex))
																	xlObj.getCell(pstCell[m].rowIndex, pstCell[m].colIndex).addClass("e-calign").removeClass("e-ralign");
															}
														}                                                   
													}
												}
												if (pstCell.length === length) {
												    if (cutLen) {
														var fCell = false, mCell = xlObj._getSelectedCells(cSheetIdx, merge.mRange).range, r, c, cpycontainer = xlObj._dataContainer.sheets[cSheetIdx];
														for (r = mCell[0]; r <= mCell[2]; r++) {
															for (c = mCell[1]; c <= mCell[3]; c++) {
																if (xlObj._isRowViewable(cSheetIdx, r))
																	xlObj.getCell(r, c, cSheetIdx).text("");
																(ej.isNullOrUndefined(cpycontainer[r])) && (cpycontainer[r] = {});
																(ej.isNullOrUndefined(cpycontainer[r][c])) && (cpycontainer[r][c] = {});
																if (!fCell) {
																	cpycontainer[r][c].merge = merge;
																	fCell = true;
																}
																else {
																	cpycontainer[r][c].isMHide = true;
																	cpycontainer[r][c].mergeIdx = { rowIndex: range[0], colIndex: range[1] };
																}
															}
														}
														xlObj.setActiveSheetIndex(cSheetIdx);
														xlObj._unMergeAllCells(this._copyRange[0], 0, xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }), [], 0, 0);
														xlObj.setActiveSheetIndex(sheetIdx);
                                                    }
												}
                                                xlObj._paste = true;
                                                xlObj._dupDetails = true;
                                                if (!xlObj.isUndefined(currCell.prevObj.merge))
                                                    xlObj.unmergeCells(currCell.prevObj.merge.mRange);
                                                xlObj.unmergeCells(cellRange);
                                                xlObj.mergeCenter = merge.isCenterAlign;
                                                if (!xlObj.isUndefined(mCell) && mCell === "1")
                                                    xlObj.mergeAcrossCells(cellRange, true);
                                                else
                                                    xlObj.mergeCells(cellRange, true);
                                                xlObj._dupDetails = false;
                                                xlObj.XLEdit._updateCellValue(currentCellIdx, value2);
                                                if (!ej.isNullOrUndefined(className))
                                                    xlObj.addClass(currentCell, className);
                                            }
                                            else {
                                                var obj = $.extend(true, {}, cellObj);
                                                obj.value = obj.value2 = value2;
                                                if (!ej.isNullOrUndefined(className))
                                                    xlObj.getCell(range[0], range[1], this._copyRange[0]).addClass(className);
                                                xlObj.XLEdit._updateDataContainer({ rowIndex: range[0], colIndex: range[1] }, { dataObj: obj });
                                                xlObj._showAlertDlg("Alert", "MergeAlert", "", 250);
                                                return;
                                            }
                                        }                                  
										if ("hyperlink" in cellObj) {
											hldata = cellObj.hyperlink;
                                            if(currentCell) {
											    if (hldata && !hldata.webAddr)
												    currentCell.html(ej.buildTag("a.e-hyperlinks", xlObj.XLEdit.getPropertyValue(rowIdx,colIdx,'value2'), "", { href: "#" }));
											    else
												    currentCell.html(ej.buildTag("a.e-hyperlinks", xlObj.XLEdit.getPropertyValue(rowIdx,colIdx,'value2'), "", { href: hldata.webAddr, target: "_blank" }));
                                            }
										}
										if ("comment" in cellObj) {
											xlObj._removeClass(currentCell, "e-commentcell");
											xlObj.XLComment.setComment([rowIdx, colIdx, rowIdx, colIdx], null, false);
										}
										if ("cFormatRule" in cellObj) {
											cFormatRule = $.extend(true, [], cellObj.cFormatRule);
											cellObj.cFormatRule = [];
											for (m = 0, rLen = cFormatRule.length; m < rLen; m++) {
												splitStr = xlObj._dataContainer.cFormatData[cFormatRule[m]].split("_");
												xlObj.XLCFormat._cFormat(splitStr[0], splitStr[2], splitStr[3], splitStr[4], null, null, [rowIdx, colIdx, rowIdx, colIdx], "paste", this._copyCells[k]);
											}
										}
										xlObj._isPaste = true;
										if ("wrap" in cellObj) {
											xlObj._dupDetails = true;
											addr = xlObj._generateHeaderText(colIdx + 1) + (rowIdx + 1);
											xlObj.setWrapText("wrap", addr + ":" + addr);
											xlObj._dupDetails = false;
										}
										if ('cellType' in cellObj) {
											settings = xlObj._dataContainer.sheetCellType[cellObj['cellType']];
											settings.text = '';
											xlObj.model.allowCellType && xlObj.XLCellType._renderControls(rowIdx, colIdx, sheetIdx, settings, !cutLen);
										}
										xlObj._isPaste = true;
										if ("picture" in cellObj) {
										    delete cutCntnr.picture;
											for (m = 0, rLen = cellObj.picture.length; m < rLen; m++) {
											    cell = cpyLen ? this._copyCells[k] : this._cutCells[k];
												cellPos = this._copyBackup.actCellPos;
												currCellObj = xlObj.getRangeData([cell.rowIndex, cell.colIndex, cell.rowIndex, cell.colIndex], "", "", this._copyRange[0])[0];
												if ((!xlObj.isUndefined(currCellObj.picture) && currCellObj.picture.indexOf(cellObj.picture[m]) > -1) || !cpyLen) {
													$.extend(true, shapeObj, shapeMgr.picture[cellObj.picture[m]]);
													shapeElem = xlObj.element.find("#" + shapeObj.id);
													if (shapeObj.rowIndex === cell.rowIndex && shapeObj.colIndex === cell.colIndex) {
														shapeElem = xlObj.element.find("#" + shapeObj.id);
														className = shapeElem[0].className;
														if (className.indexOf("e-shapebdr") > -1) {
															className = shapeElem[0].className.match(shapeRegx)[0];
															style = className.replace("e-shapebdr", "").split("N");
															bcolor = style[2];
															xlObj.XLShape._createPicture(sheetIdx, currentCellIdx, shapeMgr.sharedPics[shapeObj.data], parseInt(shapeElem.css("top")) - cellPos.top + actCell[0].offsetTop, parseInt(shapeElem.css("left")) - cellPos.left + actCell[0].offsetLeft, shapeObj.width, shapeObj.height, null, "#" + bcolor, bstyle[parseInt(style[1]) - 1], style[0] + "px");
														}
														else
															xlObj.XLShape._createPicture(sheetIdx, currentCellIdx, shapeMgr.sharedPics[shapeObj.data], parseInt(shapeElem.css("top")) - cellPos.top + actCell[0].offsetTop, parseInt(shapeElem.css("left")) - cellPos.left + actCell[0].offsetLeft, shapeObj.width, shapeObj.height);
														if (this._copyRange[0] === sheetIdx)
															container.sheets[sheetIdx][minRowIdx + i][minColIdx + j].picture[m] = xlObj.getObjectKeys(shapeMgr.picture)[xlObj.getObjectLength(shapeMgr.picture) - 1];
														if (cutLen)
															shapeElem.remove();
													}
												}
											}
										}
										if ("chart" in cellObj) {
										    delete cutCntnr.chart;
											currCellObj = xlObj.getRangeData([rowIdx, colIdx, rowIdx, colIdx]);
											for (m = 0, rLen = cellObj.chart.length; m < rLen; m++) {
											    cell = cpyLen ? this._copyCells[k] : this._cutCells[k];
												cellPos = this._copyBackup.actCellPos;
												currCellObj = xlObj.getRangeData([cell.rowIndex, cell.colIndex, cell.rowIndex, cell.colIndex])[0];
												if ((!xlObj.isUndefined(currCellObj.chart) && currCellObj.chart.indexOf(cellObj.chart[m]) > -1) || !cpyLen) {
													$.extend(true, shapeObj, shapeMgr.chart[cellObj.chart[m]]);
													shapeElem = xlObj.element.find("#" + shapeObj.id);
													if (shapeObj.rowIndex === cell.rowIndex && shapeObj.colIndex === cell.colIndex) {
														range = shapeObj.range;
														range = xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]);
														if (range.indexOf(":") < 0)
															range = range + ":" + range;
														shapeObj.top = parseInt(shapeElem.css("top")) - cellPos.top + actCell[0].offsetTop;
														shapeObj.left = parseInt(shapeElem.css("left")) - cellPos.left + actCell[0].offsetLeft;
														xlObj.XLChart.createChart(range, shapeObj);
														container.sheets[sheetIdx][minRowIdx + i][minColIdx + j].chart[m] = xlObj.getObjectKeys(shapeMgr.chart)[xlObj.getObjectLength(shapeMgr.chart) - 1];
														if (cutLen)
															shapeElem.remove();
													}
												}
											}
										}
										if ('rule' in cellObj) {
										    if (cellObj.rule.type === "list")
										        xlObj._setddlCell();
										}
										xlObj._isPaste = false;
									}
									else {
										xlObj.XLEdit._updateCellValue(currentCellIdx, "");
										if (!ej.isNullOrUndefined(container.sheets[sheetIdx][rowIdx]))
											delete container.sheets[sheetIdx][rowIdx][colIdx];
									}
								}
								else { //paste values only
									pval = xlObj.XLEdit._parseValue(cell[j], currentCellIdx);
								    if (pval.type == "time" || pval.type == "datetime")
									{
										fval = xlObj._dateToInt(pval.value);
										xlObj.XLEdit._updateCellValue(currentCellIdx, fval);
									}
								    else
										xlObj.XLEdit._updateCellValue(currentCellIdx, pval.value);	
									if (cell[j].indexOf("=") > -1)
										xlObj.XLEdit._updateCellValue(currentCellIdx, currentCell.html()); //remove formula 
								}
                            k++;
                            currCell.newObj = (!ej.isNullOrUndefined(container.sheets[sheetIdx][minRowIdx + i])) ? $.extend(true, {}, container.sheets[sheetIdx][minRowIdx + i][minColIdx + j]) : {};
                            if ((ej.isNullOrUndefined(currCell.newObj)))
                                currCell.newObj = {};
                            pasteCells.push(currCell);
                        }
                        if (!ej.isNullOrUndefined(currentCell)) {
                            xlObj._setRowHdrHeight(sheetIdx, xlObj._getCellIdx(currentCell[0]).rowIndex);
                            if (xlObj.model.allowFreezing && xlObj.getSheet(sheetIdx)._isFreezed)
                                xlObj.XLFreeze._refreshFRowResize(xlObj._getCellIdx(currentCell[0]).rowIndex);
                        }  
                    }
                    if (row.length < 1)
                        i = 1;                   
                    if (cutLen) {
                        this._isCut = isCut;
                        this._cutCells = [];
                        this._cData = "";
                    }
                    if (this._isSpecial && isColor) { //paste - border, filtering, table                        
                        var table = this._copyBackup.table, tObj, tmgr = xlObj.getSheet(sheetIdx).tableManager, tabId;
                        range = xlObj.getRangeIndices(this._copyRange[1]);
                        for (m = 0, rLen = table.length; m < rLen; m++) {
                            tblRange = this._copyBackup.table[m].range;
                            tObj = $.extend(true, {}, this._copyBackup.table[m].tblObj);
                            if (this._copyBackup.copypaste)
                                tObj.name = "Table" + (xlObj._tableCnt);
                            xlObj._dupDetails = true;
                            xlObj.XLFormat.createTable(tObj, xlObj._getAlphaRange(this._copyRange[0], tblRange[0] + minRowIdx - range[0], tblRange[1] + minColIdx - range[1], minRowIdx -
                            range[0] + tblRange[2], minColIdx - range[1] + tblRange[3]));
                            xlObj._dupDetails = false;
                            tabId = this._isCut ? tObj.tblId : this.XLObj.getObjectLength(tmgr);
                            pastedTable.push(tmgr[tabId]);
                            pastedTable[m].id = tabId;
                            pastedTable[m].totalRow && xlObj.XLFormat._updateTotalRow(sheetIdx, pastedTable[m].id, table[0].tblObj.fnNumber, pastedTable[m].range, true);
                        }
                        pRange = [minRowIdx, minColIdx, (i + minRowIdx - 1), (j + minColIdx - 1)];
                        //xlObj.model.allowCellFormatting && xlObj.XLFormat.updateFormat(this._copyBackup["border"], pRange);             //commented due to border issues      
                        if (cutLen && this._copyBackup.filterRange.length > 0 && this._copyRange[0] === sheetIdx) {
                            var fltrRange = this._copyBackup.filterRange;
                            xlObj.XLFilter.clearFilter();
                            fltr = xlObj._generateHeaderText(fltrRange[1] + minColIdx - range[1] + 1) + (fltrRange[0] + minRowIdx - range[0] + 1) + ":" + xlObj._generateHeaderText(minColIdx - range[1] + fltrRange[3] + 1) + (minRowIdx - range[0] + fltrRange[2] + 1);
                            xlObj.XLFilter.filter(fltr);
                        }
                        details.pasteBorder.newBorder = xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(pRange);
                        xlObj.setActiveSheetIndex(this._copyRange[0]);
                        details.cutBorder.newBorder = xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(range);
                        xlObj.setActiveSheetIndex(sheetIdx);
                    }
                    details.pfat = { table: this._copyBackup.table, range: range, minRowIdx: minRowIdx, minColIdx: minColIdx, ptable: pastedTable };
                    details.pfilter = fltr;
                    details.pasteCells = pasteCells;
                    xlObj.XLSelection.selectRange(({ rowIndex: minRowIdx, colIndex: minColIdx }), ({ rowIndex: (i + minRowIdx - 1), colIndex: (j + minColIdx - 1) }));
                    xlObj.getSheet(sheetIdx)._startCell = ({ rowIndex: minRowIdx, colIndex: minColIdx });
                    xlObj.getSheet(sheetIdx)._endCell = ({ rowIndex: (i + minRowIdx - 1), colIndex: (j + minColIdx - 1) });
                    if (xlObj.model.allowAutoFill)
                        xlObj.XLDragFill.positionAutoFillElement();
                    details.sheetIndex = sheetIdx;
                    xlObj.setSheetFocus();
                    xlObj.model.showRibbon && xlObj.XLRibbon._updateRibbonIcons();
                    evtArgs = { sheetIndex: details.sheetIndex, pasteCells: details.pasteCells, reqType: details.reqType, isSpecial: details.isSpecial, cutCells: details.cutCells, pasteSheetIndex: details.pSheetIndex };
                    if (evtArgs.reqType === "cut-paste")
                        evtArgs.cutSheetIndex = details.cSheetIndex;
                    else
                        evtArgs.copySheetIndex = details.cSheetIndex;
                    if (!xlObj._isUndoRedo) {
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(evtArgs);
                    }
                    copyRowIdx = (details.cutCells.length < 1) ? minRowIdx : details.cutCells[0].rowIndex;
                    xlObj.XLScroll._getRowHeights(sheetIdx, (minRowIdx < copyRowIdx) ? (minRowIdx > 0) ? minRowIdx - 1 : 0 : (copyRowIdx > 0) ? copyRowIdx - 1 : 0);
                }
                xlObj._isPaste = false;
                this._isCut = false;
                xlObj.XLSelection._refreshBorder();
                xlObj.model.allowAutoFill && xlObj.XLDragFill.positionAutoFillElement();
                if (xlObj.getSheet(sheetIdx)._isFreezed)
                    xlObj.XLFreeze._refreshSelection();
            }
            else
                xlObj._showAlertDlg("Alert", "FullSheetCopyPasteAlert", "", 375);
        },

        _getUpdatedCellFormula: function (val, addr, curAddr) {
            var xlObj = this.XLObj, regx = /([A-Z].*?[0-9])/g, rowDiff = curAddr.rowIdx - addr.rowIndex, colDiff = curAddr.colIdx - addr.colIndex,
                addrs = xlObj.XLDragFill._parseFormula(val), i, len, sAdr, newCAdr, newRAdr;

            for (i = 0, len = addrs.length; i < len; i++) {
                if (addrs[i].match(regx)) {
                    sAdr = addrs[i].trim().match(/(\d+|\D+)/g);
                    newCAdr = xlObj._generateColCount(sAdr[0]) + colDiff;
                    newRAdr = parseInt(sAdr[1]) + rowDiff;
                    addrs[i] = newRAdr > 0 && newCAdr > 0 ? xlObj._generateHeaderText(newCAdr) + newRAdr.toString() : "#REF!";
                }
            }
            addrs = addrs.join('');
            return "=" + addrs;
        },

        _compareRange: function (range1, range2) {
            return (range1[0] <= range2[0] && range1[1] <= range2[1] && range1[2] >= range2[2] && range1[3] >= range2[3]);
        },
        _cutPasteBorder: function (startRange, endRange) {
            var k, pstIdx, colIdx, rowIdx, pstlen, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), bdrs = [], cCells = [], pstCells = [];
            xlObj.XLFormat.removeStyle(endRange, { cellStyle: true, border: true, format: true, sheetIdx: sheetIdx });
            cCells = xlObj._getSelectedRange({ rowIndex: startRange[0], colIndex: startRange[1] }, { rowIndex: startRange[2], colIndex: startRange[3] });
            pstCells = xlObj._getSelectedRange({ rowIndex: endRange[0], colIndex: endRange[1] }, { rowIndex: endRange[2], colIndex: endRange[3] });
            for (k = 0, pstlen = pstCells.length; k < pstlen; k++) {
                pstIdx = pstCells[k];
                rowIdx = cCells[k].rowIndex;
                colIdx = cCells[k].colIndex;
                bdrs = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "borders", this._copyRange[0]);
                if (!xlObj.isUndefined(bdrs))
                    xlObj.XLFormat.applyBorder(bdrs, [pstIdx.rowIndex, pstIdx.colIndex, pstIdx.rowIndex, pstIdx.colIndex]);
            }
            xlObj.setActiveSheetIndex(this._copyRange[0]);
            xlObj.XLFormat.removeStyle(startRange, { cellStyle: true, border: true, format: true });
            xlObj.setActiveSheetIndex(sheetIdx);
        }

    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.comments = function (obj) {
        this.XLObj = obj;
        this._isCommentEdit = false;
        this._isShowAllComments = false;
        this._curCommentHCell = null;
    };

    ej.spreadsheetFeatures.comments.prototype = {

        setComment: function (range, data, showEditPanel, showUserName) {
            var xlObj = this.XLObj, args; 
            if (!xlObj.model.allowComments || !xlObj.model.allowEditing || xlObj.model.isReadOnly)
                return;
            var prevCmnt, rng, isViewed = false, activeCell, cellIdx, trgtCell, rowIdx, colIdx, cmntData, activeCmnt, userName,
                sheetIdx, sheet, cmnt, selCell = [], details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "comment" };
            sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            if (xlObj.model.allowLockCell && sheet.isSheetProtected)
                return false;
            if (range) {
                rng = xlObj._getRangeArgs(range, "object");;
                rowIdx =  rng[0];
                colIdx = rng[1];
                cellIdx = {rowIndex: rowIdx, colIndex: colIdx};
            }
            else {
                if (!xlObj.model.allowSelection)
                    return;
                cellIdx = xlObj.getActiveCell(sheetIdx);
                rowIdx = cellIdx.rowIndex, colIdx = cellIdx.colIndex;
            }
            args = { reqType: "beforeEditComment", cellIndex: cellIdx,value:data, sheetIdx: sheetIdx, disable:false};
            if (xlObj._trigger("beforeEditComment",args ))
                args.disable = true;
            data = args.value;
            if (xlObj._isCellProtected(rowIdx, colIdx, false))
                return;
            if (!xlObj.isUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, 'cellType'))) {
                xlObj._showAlertDlg("Alert", "CellTypeAlert", "CellTypeAlert", 372);
                return;
            }
            if (xlObj.model.showRibbon && (xlObj._isPaste ? !xlObj.XLClipboard._cutCells.length: true))
                xlObj._commentCount++;
            if(!xlObj._isRibbonClick){
                details.action = "add";
                selCell.push(cellIdx);
                details.selectedCell = selCell;
                details.selectedCell[0].prevComment = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment");
            }
            if (!xlObj._isAutoWHMode && !xlObj.XLClipboard._copyCells.length && !sheet._isFreezed)
                xlObj.XLScroll._scrollSelectedPosition(sheetIdx, cellIdx);
            if (!(rowIdx in sheet._commentColl))
                sheet._commentColl[rowIdx] = {};
            sheet._commentColl[rowIdx][colIdx] = { isComment: true };
            showEditPanel = ej.isNullOrUndefined(showEditPanel) ? true : showEditPanel;
            showUserName = ej.isNullOrUndefined(showUserName) ? true : showUserName;
            userName = (xlObj.model.userName.length > 0 ? xlObj.model.userName : xlObj._getLocStr("UserName")) + ":\n";
            prevCmnt = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx);
            if (!ej.isNullOrUndefined(data)){
				if (showUserName)
				    data = userName + data;
				xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: { comment: { value: data, isVisible: ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx)) ? showEditPanel : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx).isVisible } } });
            }
            else if (args.disable)
                xlObj.XLEdit._updateDataContainer(cellIdx, { dataObj: { comment: { value: userName, isVisible: ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx)) ? showEditPanel : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx).isVisible } } });
			cmntData = ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx)) ? (xlObj.model.userName.length > 0 ? xlObj.model.userName : xlObj._getLocStr("UserName")) + ":\n" : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx).value;
			if (xlObj.model.allowComments  && !xlObj.XLEdit._isEdit && !xlObj._isSheetRename) {
			    if (xlObj._isRowViewable(sheetIdx, rowIdx)) {
			        activeCell = xlObj.getCell(rowIdx, colIdx);
			        activeCell.prepend(ej.buildTag("span.e-comment", ej.buildTag("span.e-celltoparrow")).append(ej.buildTag("textarea.e-comment-txtarea", cmntData, { "z-index": 10 }))).addClass("e-commentcell");
			        this._updateCmntArrowPos(activeCell);
			        activeCmnt = activeCell.find(".e-comment-txtarea");
			        this._updateCmtAreaPos(activeCell, activeCmnt);
			        activeCmnt.focus().setInputPos(activeCmnt.val().length);
			        isViewed = true;
			        if(args.disable)
			           activeCmnt[0].disabled = true;
			    }
			    if (!sheet._isImported || sheet._isLoaded) {
			        cmnt = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx);
			        if (!ej.isNullOrUndefined(cmnt))
			            cmnt.value = cmntData;
			    }
			    if (showEditPanel && isViewed) {
			        activeCmnt.focus();
			        if (this._curCommentHCell && !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValueByElem(this._curCommentHCell, "comment")) && !xlObj.XLEdit.getPropertyValueByElem(this._curCommentHCell, "comment").isVisible) {
			            this._curCommentHCell.find(".e-comment-txtarea").hide();
			            this._curCommentHCell = null;
			        }
			        if (xlObj.model.allowDragAndDrop && !xlObj.XLDragDrop._isDragAndDropped)
			            this._updateCurrentCell(rowIdx, colIdx);
			        if (!args.disable) {
			            this._isCommentEdit = true;
			            if (xlObj.model.showRibbon)
			                xlObj.XLRibbon._disableRibbonIcons();
			        }
			        else
			            this._updateCmntRibIcons();
			    }
			    else if (isViewed) {
			        if (!this._isShowAllComments && !xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx).isVisible)
			            activeCmnt.hide();
			        if (xlObj.model.showRibbon && (!sheet._isImported || sheet._isLoaded) && xlObj.model.allowDragAndDrop && !xlObj.XLDragDrop._isDragAndDropped)
			            this._updateCmntRibIcons(xlObj.XLClipboard._isSpecial ? xlObj.getActiveCell() : { rowIndex: rowIdx, colIndex: colIdx });
			    }
			    if (!xlObj._isRibbonClick && !xlObj._isUndoRedo && !xlObj._hasComment && !xlObj._isExport && !xlObj._dupDetails) {
                    details.selectedCell[0].curComment = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment");
                    details.showUserName = showUserName;
                    details.showEditPanel = showEditPanel;
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            }
        },

        _updateCmtAreaPos: function (activeCell, cmtTxtArea) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), hScroll = xlObj._getContent(sheetIdx).find("#hscrollBar").offset(), vScroll = xlObj._getContent(sheetIdx).find("#vscrollBar").offset(), hdrOffset = xlObj._getJSSheetHeader(sheetIdx).offset(),
                txtOffset = cmtTxtArea.offset(), cHeight = cmtTxtArea.height(), cWidth = cmtTxtArea.width();
            if (xlObj.model.scrollSettings.allowScrolling) {
                if ((txtOffset.top + cHeight + 5) > hScroll.top && (txtOffset.left + cWidth) < vScroll.left)
                    cmtTxtArea.css({ top: -77 });
                else if ((txtOffset.left + cWidth) > vScroll.left && (txtOffset.top + cHeight + 5) > hScroll.top)
                    cmtTxtArea.css({ left: -136, top: -81 });
                else if ((txtOffset.top + cHeight) > hdrOffset.top && (txtOffset.left + cWidth) > vScroll.left)
                    cmtTxtArea.css({ left: -137, top: activeCell.height() + 8 });
            }
        },

        deleteComment: function (range, sheetIdx, skipHiddenRow,  status) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowComments || xlObj.model.isReadOnly)
                return;
            var actCell, rowIdx, colIdx, cmnt, cmntCells = [], selCell = [], activeShtIdx = sheetIdx || xlObj.getActiveSheetIndex(), activeCells, details = { sheetIndex: activeShtIdx, reqType: "comment", action: "delete", range: range };
            range = xlObj._getRangeArgs(range, "object");
            activeCells = xlObj._getSelectedCells(sheetIdx, range).selCells;
            for (var i = 0; i < activeCells.length; i++) {
                if (xlObj.XLEdit.getPropertyValue(activeCells[i].rowIndex, activeCells[i].colIndex, "comment", sheetIdx))
                    cmntCells.push(activeCells[i]);
            }
            if (xlObj.model.allowComments) {
                for (var i = 0; i < activeCells.length; i++) {
                    rowIdx = activeCells[i].rowIndex;
                    colIdx = activeCells[i].colIndex;
                    cmnt = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx);
                    if (!ej.isNullOrUndefined(cmnt)) {
                        actCell = $(activeCells[i]);
                        if (skipHiddenRow && xlObj._isHiddenRow(rowIdx)) {
                            activeCells.splice(i, 1);
                            continue;
                        }
                        if (xlObj.model.showRibbon && xlObj._commentCount)
                            xlObj._commentCount--;
                        selCell.push({ rowIndex: rowIdx, colIndex: colIdx, prevComment: cmnt, currComment: {} });
                        if (xlObj._isRowViewable(activeShtIdx, rowIdx))
                            xlObj.getCell(rowIdx, colIdx, activeShtIdx).removeClass("e-commentcell").find('.e-comment').remove();
                        if (xlObj.getSheet(activeShtIdx)._commentColl[rowIdx])
                            delete xlObj.getSheet(activeShtIdx)._commentColl[rowIdx][colIdx];
                        delete xlObj._dataContainer.sheets[activeShtIdx][rowIdx][colIdx]["comment"];
                    }                   
                }
                details.selectedCell = selCell;
                //Delete action
                if (xlObj.model.showRibbon && cmntCells.length && xlObj.model.allowDragAndDrop && !xlObj.XLDragDrop._isDragAndDropped)
                    xlObj.XLComment._updateCmntRibIcons();
                details.reqType = ej.isNullOrUndefined(status) ? "comment" : "clear-comment";
                if (!xlObj._isUndoRedo && !xlObj._dupDetails) {
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            }
        },

        editComment: function (target) {
            var xlObj = this.XLObj, args, cmntData;
			if (!xlObj.model.allowComments || xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), txtArea;
			if (xlObj.model.allowLockCell && xlObj.getSheet(sheetIdx).isSheetProtected)
			    return false;
            ej.isNullOrUndefined(target) && (target = xlObj.getActiveCell());
            cmntData = xlObj.XLEdit.getPropertyValue(target.rowIndex, target.colIndex, "comment", sheetIdx);
            args = { reqType: "beforeEditComment", cellIndex: target, value: cmntData.value, sheetIndex: sheetIdx, isDisable: false };
            if (xlObj._trigger("beforeEditComment", args))
                args.disable = true;
            cmntData.value = args.value;
            xlObj.XLEdit._updateDataContainer(target, { dataObj: { comment: { value: cmntData.value, isVisible: cmntData.isVisible } } });
            if (!xlObj.XLEdit._isEdit && !xlObj._isSheetRename) {
                if (xlObj.model.allowComments) {
                    if (!ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(target.rowIndex, target.colIndex, "comment"))) {
                        !xlObj._isAutoWHMode && xlObj.XLScroll._scrollSelectedPosition(sheetIdx, target);
                        if (xlObj._isRowViewable(sheetIdx, target.rowIndex)) {
                            txtArea = xlObj.getCell(target.rowIndex, target.colIndex).find(".e-comment-txtarea");
                            txtArea.text(args.data);
                            txtArea.css("display", "inline-table").focus().setInputPos(txtArea.text().length);
                        }
                        if(!args.disable)
                           this._isCommentEdit = true;
                    }
                }
                if (xlObj.model.showRibbon && !args.disable)
                    xlObj.XLRibbon._disableRibbonIcons();
            }
        },

        showHideComment: function (trgtCell) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowComments || xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), activeCell, cmnt, $target, isViewed = false, visibility = false;
            if(ej.isNullOrUndefined(trgtCell))
				activeCell = xlObj.getActiveCell();
			else
				activeCell = xlObj._getCellIdx(trgtCell[0]);
            cmnt = xlObj.XLEdit.getPropertyValue(activeCell.rowIndex, activeCell.colIndex, "comment");
            if (!ej.isNullOrUndefined(cmnt)) {
                if (xlObj._isRowViewable(sheetIdx, activeCell.rowIndex)) {
                    $target = xlObj.getCell(activeCell.rowIndex, activeCell.colIndex).find(".e-comment-txtarea");
                    isViewed = true;
                }
                if (cmnt.isVisible) {
                    isViewed && $target.hide();
                    visibility = false;
                }
                else {
                    isViewed && $target.css("display", "inline-table");
                    this._curCommentHCell = null;
                    visibility = true;
                }
            }
            if (!xlObj.isUndefined(visibility))
                cmnt.isVisible = visibility;
        },

        showAllComments: function () {
            var xlObj = this.XLObj; 
            if (!xlObj.model.allowComments)
                return;
            var rowKeys, colKeys, j, sheetIdx = xlObj.getActiveSheetIndex(), allComments, $getAllComments, isAvble, showToglBtObj = $("#" + xlObj._id + "_Ribbon_Review_Comments_ShowAllComments").data("ejToggleButton"), ribIconsIds = ["Review_Comments_PreviousComment", "Review_Comments_NextComment"], i, len, visibleStatus;
            if (this._isShowAllComments)
                visibleStatus = false;
            else 
                visibleStatus = true;
            for (i = 1; i <= xlObj.model.sheetCount; i++) {
                allComments = xlObj.getSheet(i)._commentColl;
                rowKeys = xlObj.getObjectKeys(allComments);
                for (j = 0; j < rowKeys.length; j++) {
                    colKeys = xlObj.getObjectKeys(allComments[rowKeys[j]]);
                    for (var k = 0; k < colKeys.length; k++) {
                        if (xlObj._isRowViewable(sheetIdx, parseInt(rowKeys[j]))) {
                            $getAllComments = xlObj.getCell(parseInt(rowKeys[j]), parseInt(colKeys[k]),i).find(".e-comment-txtarea");
                            if(this._isShowAllComments)
                                $getAllComments.hide();
                            else
                                $getAllComments.css("display", "inline-table");
                        }
                        xlObj.XLEdit.getPropertyValue(rowKeys[j], colKeys[k], "comment", i).isVisible = !this._isShowAllComments;
                    }
                    if (j == 0)
                        isAvble = true;
                }
            }
            this._isShowAllComments = !this._isShowAllComments;
            if (xlObj.model.showRibbon && showToglBtObj && showToglBtObj.model.toggleState)
                xlObj.XLRibbon._disableButtons(ribIconsIds, "ejButton");
            else if (xlObj.model.showRibbon && isAvble)
                xlObj.XLRibbon._enableButtons(ribIconsIds, "ejButton");
        },

        findPrevComment: function () {
            var xlObj = this.XLObj; 
            if (!xlObj.model.allowComments || xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), sheet, rowCount, colCount, rowIndex, colIndex, i, j, k, cell, insCmtEle = $("#" + xlObj._id + "_Ribbon_Review_Comments_NewComment"), commentPanel, tabIdx;
            for (i = sheetIdx; i > 0; i--) {
                sheet = xlObj.getSheet(i);
                if (!xlObj.getObjectLength(sheet._commentColl))
                    continue;
                if (i !== sheetIdx)
                    xlObj.gotoPage(i, false);
                if (xlObj.model.showRibbon) {
                    tabIdx = xlObj.XLRibbon._getTabIndex("review");
                    tabIdx && $("#" + xlObj._id + "_Ribbon").ejRibbon("option", "selectedItemIndex", tabIdx);
                }
                rowCount = sheet.rowCount - 1;
                colCount = sheet.colCount - 1;
                if (i !== sheetIdx)
                    this._updateCurrentCell(rowCount - 1, colCount - 1);
                rowIndex = sheet._activeCell.rowIndex;
                colIndex = sheet._activeCell.colIndex;
                for (j = rowIndex; j >= 0; j--) {
                    if (j !== rowIndex)
                        colIndex = colCount - 1;
                    for (k = colIndex; k >= 0; k--) {
                        if (xlObj.XLEdit.getPropertyValue(j, k, "comment", sheetIdx)) {
                            if (sheet._hiddenFreezeRows.indexOf(j) > -1 && sheet._isFreezed)
                                xlObj.XLSearch._freezeScroll(j, k, sheet);
                            else if (!xlObj._isRowViewable(sheetIdx, j))
                                xlObj._scrollContent({ y: xlObj._getRowOffsetTop(sheet, j) }, true);
                        }
                        if (xlObj._isRowViewable(sheetIdx, j)) {
                            cell = $(xlObj.getCell(j, k));
                            commentPanel = $(cell.find(".e-comment-txtarea"));
                            if (sheet._activeCell.rowIndex !== j && sheet._activeCell.colIndex !== k && !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValueByElem(cell, "comment")) && xlObj.XLEdit.getPropertyValueByElem(cell, "comment").isVisible)
                                commentPanel.hide();
                            if (cell.hasClass("e-commentcell") && !commentPanel.is(":visible")) {
                                if (commentPanel.css("display", "inline-table").focus())
                                    this._updateCurrentCell(j, k);
                                this._updateCommentsBtns(insCmtEle);
                                xlObj.setSheetFocus();
                                return true;
                            }
                            if (!this._isShowAllComments && !this._isCommentEdit && cell.hasClass("e-commentcell") && !xlObj.XLEdit.getPropertyValueByElem(cell, "comment").isVisible)
                                commentPanel.hide();
                        }                        
                    }
                }
            }
            if (i === 0)
                xlObj._showAlertDlg("", "CommentFindEndAlert", "findPrevComment", 630);
        },

		_updateCommentsBtns: function(insCmtEle) {
			var xlObj = this.XLObj;
			if (xlObj.model.showRibbon) {
                xlObj.XLRibbon._enableButtons(["Review_Comments_DeleteComment", "Review_Comments_ShowHideComment"], "ejButton");
                insCmtEle.find(".e-icon").removeClass("e-ssr-newcmnt").addClass("e-ssr-editcmnt");
                insCmtEle.find(".e-btntxt").text(xlObj._getLocStr("EditComment"));
            }
		},
		
        findNextComment: function () {
            var xlObj = this.XLObj; 
            if (!xlObj.model.allowComments || xlObj.model.isReadOnly)
                return;
            var sheet, rowIndex, colIndex, rowCount, colCount, i, j, k, cell, commentPanel, tabIdx, isScrolled = false, sheetIdx = xlObj.getActiveSheetIndex(), insCmtEle = $("#" + xlObj._id + "_Ribbon_Review_Comments_NewComment");
            for (i = sheetIdx; i <= xlObj.model.sheetCount; i++) {
                sheet = xlObj.getSheet(i);
                if (!xlObj.getObjectLength(sheet._commentColl))
                    continue;
                if (i !== sheetIdx)
                    xlObj.gotoPage(i, false);
                if (xlObj.model.showRibbon) {
                    tabIdx = xlObj.XLRibbon._getTabIndex("review");
                    tabIdx && $("#" + xlObj._id + "_Ribbon").ejRibbon("option", "selectedItemIndex", tabIdx);
                }
                if (i !== sheetIdx)
                    this._updateCurrentCell(0, 0);
                rowIndex = sheet._activeCell.rowIndex;
                colIndex = sheet._activeCell.colIndex;
                rowCount = sheet.rowCount - 1;
                colCount = sheet.colCount - 1;
                for (j = rowIndex; j < rowCount; j++) {
                    if (j !== rowIndex)
                        colIndex = 0;
                    for (k = colIndex; k < colCount; k++) {
                        if (xlObj.XLEdit.getPropertyValue(j, k, "comment", sheetIdx)) {
                            if (sheet._isFreezed)
                                xlObj.XLSearch._freezeScroll(j, k, sheet);
                            else if (!xlObj._isRowViewable(sheetIdx, j))
                                xlObj._scrollContent({ y: xlObj._getRowOffsetTop(sheet, j) }, true);
                            isScrolled = !xlObj.getActiveCellElem();
                        }
                        if (xlObj._isRowViewable(sheetIdx, j)) {
                            cell = $(xlObj.getCell(j, k));
                            commentPanel = $(cell.find(".e-comment-txtarea"));
                            if (!isScrolled && xlObj.getActiveCellElem()[0] !== cell[0] && !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValueByElem(cell, "comment")) && xlObj.XLEdit.getPropertyValueByElem(cell, "comment").isVisible)
                                commentPanel.hide();
                            if (cell.hasClass("e-commentcell") && !commentPanel.is(":visible")) {
                                commentPanel.css("display", "inline-table").focus();
                                this._updateCurrentCell(j, k);
                                this._updateCommentsBtns(insCmtEle);
                                xlObj.setSheetFocus();
                                return true;
                            }
                        }
                        if (!this._isShowAllComments && !this._isCommentEdit && cell.hasClass("e-commentcell") && !xlObj.XLEdit.getPropertyValueByElem(cell, "comment").isVisible)
                            commentPanel.hide();
                    }
                }
            }
            if (i === xlObj.model.sheetCount + 1)
                xlObj._showAlertDlg("", "CommentFindEndAlert", "findNextComment", 630);
        },

        _commentMouseMove: function (e) {
            var xlObj = this.XLObj, $target, commentPanel;
            $target = (e.target.tagName === "TD") ? $(e.target) : $(e.target).parent("td");
            if (!$target.length)
                return;
            commentPanel = $target.find(".e-comment-txtarea");
            if (!this._isCommentEdit) {
                if (!ej.isNullOrUndefined(this._curCommentHCell)) {
                    if ($target !== this._curCommentHCell) {
                        var cellData = xlObj.XLEdit.getPropertyValueByElem(this._curCommentHCell, "comment");
                        if (!ej.isNullOrUndefined(cellData) && !cellData.isVisible) {
                            this._curCommentHCell.find(".e-comment-txtarea").hide();
                            this._curCommentHCell = null;
                        }
                    }
                }
                if ($target[0].tagName === "TD" && $target.hasClass("e-commentcell")) {
                    commentPanel.css("display", "inline-table");
                    this._curCommentHCell = $target;
                }
            }
        },

        _commentMouseDownHandler: function (e) {
            var xlObj = this.XLObj, cellIdx = xlObj.getActiveCell(), sheetIdx = xlObj.getActiveSheetIndex();
            if (xlObj._isRowViewable(sheetIdx, cellIdx.rowIndex)) {
                var activeCell = xlObj.getCell(cellIdx.rowIndex, cellIdx.colIndex, sheetIdx), cellData, commentPanel = $(activeCell.find(".e-comment-txtarea"));
                if (activeCell.hasClass("e-commentcell") && commentPanel.get()[0] !== e.target) {
                    cellData = xlObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, "comment");
                    if (this._isCommentEdit)
                        this._updateCurCmntVal(cellIdx);
                    if (!this._isShowAllComments && !xlObj.isUndefined(cellData) && !cellData.isVisible)
                        commentPanel.hide();
                }
            }

            if (xlObj._hasClass(e.target,"e-comment-txtarea") && !e.target.disabled) {
                if ($(e.target).focus().css("z-index", 10))
                    this._isCommentEdit = true;
                this._updateCurrentCell($(e.target).parents("td").parent().index(), $(e.target).parents("td").index());
                if (xlObj.model.showRibbon)
                    xlObj.XLRibbon._disableRibbonIcons();
            }
        },

        _updateCmntRibIcons: function (trgtCell) {
            var comment, xlObj = this.XLObj, ribIconsIds = ["Review_Comments_ShowHideComment", "Review_Comments_DeleteComment"], activeSheet = xlObj.getActiveSheetIndex(),
                sheetElement = xlObj.getSheetElement(activeSheet), insCmtEle = $('#' + xlObj._id + '_Ribbon_Review_Comments_NewComment'),
                actCell = xlObj.getActiveCell(), sheet = xlObj.getSheet(activeSheet), selectedCells = sheet._selectedCells, selRange = sheet.selectedRange;
            trgtCell = (xlObj.model.allowDragAndDrop && !xlObj.XLDragDrop._isDragAndDropped) ? (trgtCell ? trgtCell : actCell) : { rowIndex: xlObj._dStartCell.rowIndex, colIndex: xlObj._dStartCell.colIndex };
            xlObj.XLRibbon._enableButtons(["Review_Comments_NewComment"], "ejButton");
            xlObj.XLRibbon._enableButtons(xlObj.XLRibbon._cmntTglBtnIds, "ejToggleButton");
            comment = xlObj.XLEdit.getPropertyValue(trgtCell.rowIndex, trgtCell.colIndex, "comment", activeSheet);
            if (comment) {
                xlObj.XLRibbon._enableButtons(ribIconsIds, "ejButton");
                insCmtEle.find(".e-icon").removeClass("e-ssr-newcmnt").addClass("e-ssr-editcmnt");
                insCmtEle.find(".e-btntxt").text(xlObj._getLocStr("EditComment"));
            }
            else {
                insCmtEle.find(".e-icon").removeClass("e-ssr-editcmnt").addClass("e-ssr-newcmnt");
                insCmtEle.find(".e-btntxt").text(xlObj._getLocStr("NewComment"));
                xlObj.XLRibbon._disableButtons(ribIconsIds, "ejButton");
            }
            if (this._isShowAllComments || xlObj._commentCount === 0)
                xlObj.XLRibbon._disableButtons(["Review_Comments_PreviousComment", "Review_Comments_NextComment"], "ejButton");
            else
                xlObj.XLRibbon._enableButtons(["Review_Comments_PreviousComment", "Review_Comments_NextComment"], "ejButton");
            if (selectedCells.length && xlObj.inRange(selRange, trgtCell.rowIndex, trgtCell.colIndex)) {
                if (xlObj.XLEdit._rangeHasProperty(selRange, "comment"))
                    xlObj.XLRibbon._enableButtons(["Review_Comments_DeleteComment"], "ejButton");
            }
        },

        _updateCurCmntVal: function (trgtCell, status) {
            status = ej.isNullOrUndefined(status) ? "" : status;
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), activeCell = ej.isNullOrUndefined(trgtCell) ? xlObj.getActiveCell() : trgtCell, commentPanel, cmntVal, selCell = [], cmntVal = "User Name:", isViewed = false;;
            var details = { sheetIndex: sheetIdx, reqType: "comment" }, rowIdx = activeCell.rowIndex, colIdx = activeCell.colIndex;
            if(xlObj._isRowViewable(details.sheetIndex, rowIdx)){
                commentPanel = xlObj.getCell(rowIdx, colIdx, sheetIdx).find(".e-comment-txtarea");
                isViewed = true;
                commentPanel.scrollTop(0);
            }
            selCell.push({ rowIndex: rowIdx, colIndex: colIdx });
            details.action = (ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment"))) ? "add" : "edit";
            details.selectedCell = selCell;
            details.selectedCell[0].prevComment = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment");
            isViewed && (cmntVal = commentPanel.css("z-index", 9).val());
            xlObj.XLEdit._updateDataContainer({ rowIndex: rowIdx, colIndex: colIdx }, { dataObj: { comment: { value: cmntVal, isVisible: xlObj.isUndefined(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment")) ? this._isShowAllComments : xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment").isVisible } } });
            if (isViewed && !this._isShowAllComments && !xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment").isVisible)
                commentPanel.hide();
            xlObj.setSheetFocus();
            this._isCommentEdit = false;
            xlObj.XLCellNav._isNavigate = true;
            if (xlObj.model.showRibbon)
                xlObj.XLRibbon._enableRibbonIcons();
            xlObj.XLEdit._updateUsedRange(rowIdx, colIdx, sheetIdx);
            details.selectedCell[0].curComment = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment");
            if (!xlObj._isUndoRedo && status !== "paste") {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _updateCurrentCell: function (rIndex, cIndex, sheetIdx) {
            var xlObj = this.XLObj, cellObj = { rowIndex: rIndex, colIndex: cIndex };
            sheetIdx = sheetIdx ? sheetIdx : xlObj.model.activeSheetIndex;
            var shtModel = xlObj.getSheet(sheetIdx);
            shtModel._activeCell = cellObj;
            xlObj.model.allowSelection && xlObj.XLSelection.selectRange(cellObj, cellObj, sheetIdx);
            shtModel._startCell = shtModel._endCell = cellObj;
            if(xlObj.model.allowAutoFill)
				xlObj.XLDragFill.positionAutoFillElement();
        },

        _visibleCmntCnt: function (cell, isVisible) {
            cell.find(".e-comment")[isVisible ? "show" : "hide"]();
        },

        _updateCmntArrowPos: function (cells, sheetIdx, startCell) {
            var i, len, cell, cellInfo, cmntElem, activeCell, xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(sheetIdx), sheet = xlObj.getSheet(sheetIdx), commentCells = cells || xlObj._getContent(sheetIdx).find(".e-commentcell");
            startCell = startCell || {};
            if (xlObj.model.allowComments) {
                for (i = 0, len = commentCells.length; i < len; i++) {
                    activeCell = $(commentCells[i]);
                    cell = xlObj._getCellIdx(activeCell[0]);
                    if ((cell.rowIndex < startCell.rowIndex) || (cell.colIndex < startCell.colIndex))
                        continue;
                    cmntElem = activeCell.find(".e-comment");
                    if (xlObj._isInsdel) {
                        if (!(cell.rowIndex in sheet._commentColl))
                            sheet._commentColl[cell.rowIndex] = {};
                        sheet._commentColl[cell.rowIndex][cell.colIndex] = { isComment: true };
                    }
                    if (cmntElem.length) {
                        cellInfo = xlObj._getCellInfo(cell, sheetIdx);
                        if (sheet.columnsWidthCollection[cell.colIndex] < 5) { // 5 - comment arrow indicator width
                            cmntElem.hide();
                            continue;
                        }
                        if (cmntElem.is(":hidden"))
                            cmntElem.show();
                        cmntElem.css({ "top": cellInfo.top + "px", "left": (cellInfo.left + activeCell.width()) + "px" });
                    }
                }
            }
        },

        _updateCmntFrmCntnr: function (rowIdx, colIdx) {
            var xlObj = this.XLObj;
            if (xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment")) {
                if (xlObj._isRowViewable(null, colIdx))
                    if (xlObj.getCell(rowIdx, colIdx).hasClass("e-commentcell"))
                        this.deleteComment([rowIdx, colIdx, rowIdx, colIdx]);
				xlObj._dupDetails = true;
                this.setComment([rowIdx, colIdx, rowIdx, colIdx], null, false);
				xlObj._dupDetails = false;
            }
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.contextmenu = function (obj) {
        this.XLObj = obj;
        this._clrFltrEnable = false;
        this._isMenuOpened = false;
        this._uniqueClass = obj._id + "-cmenu";
        this._selColor = "";
		this._changedDataSource = false;
        this._rowCellMenuDataMobile = [
            { id: "Cut", text: obj._getLocStr("Cut"), parentId: null, spriteCssClass: "e-icon e-ss-cut" },
			{ id: "Copy", text: obj._getLocStr("Copy"), parentId: null, spriteCssClass: "e-icon e-ss-copy" },
			{ id: "PasteSpecial", text: obj._getLocStr("Paste"), parentId: null, spriteCssClass: "e-icon e-ss-paste" },
            { id: "FormatCells", text: obj._getLocStr("FormatCells") + "...", parentId: null, spriteCssClass: "e-icon e-ss-formatcells" },
            { id: "BackgroundColor", text: obj._getLocStr("BackgroundColor"), parentId: null, spriteCssClass: "e-icon e-ss-backgroundcolor" },
            { id: "FontColor", text: obj._getLocStr("FontColor"), parentId: null, spriteCssClass: "e-icon e-ss-fontcolor" },
        ];
        this._headerMenuDataMobile = [
            { id: "Cut", text: obj._getLocStr("Cut"), parentId: null, spriteCssClass: "e-icon e-ss-cut" },
			{ id: "Copy", text: obj._getLocStr("Copy"), parentId: null, spriteCssClass: "e-icon e-ss-copy" },
			{ id: "PasteSpecial", text: obj._getLocStr("Paste"), parentId: null, spriteCssClass: "e-icon e-ss-paste" },
            { id: "Insert", text: obj._getLocStr("Insert"), parentId: null },
            { id: "Delete", text: obj._getLocStr("Delete"), parentId: null },
            { id: "Hide", text: obj._getLocStr("Hide"), parentId: null },
            { id: "Unhide", text: obj._getLocStr("Unhide"), parentId: null },
        ],

        this._rowCellMenuData = [
				{ id: "Cut", text: obj._getLocStr("Cut"), parentId: null, spriteCssClass: "e-icon e-ss-cut" },
				{ id: "Copy", text: obj._getLocStr("Copy"), parentId: null, spriteCssClass: "e-icon e-ss-copy" },
				{ id: "Paste", text: obj._getLocStr("Paste"), parentId: null, spriteCssClass: "e-icon e-ss-paste" },
                { id: "PasteSpecial", text: obj._getLocStr("PasteSpecial"), parentId: "Paste" },
                { id: "PasteValues", text: obj._getLocStr("PasteValues"), parentId: "Paste" },
                { id: "Insert", text: obj._getLocStr("Insert") + "...", parentId: null },
                { id: "Delete", text: obj._getLocStr("Delete") + "...", parentId: null },
				{ id: "Filter", text: obj._getLocStr("Filter"), parentId: null, spriteCssClass: "e-icon e-ss-filter" },
                { id: "ClearFilter", parentId: "Filter", text: obj._getLocStr("ClearFilter"), spriteCssClass: "e-icon e-ss-filternone" },
				{ id: "FilterSelected", parentId: "Filter", text: obj._getLocStr("FilterSelected"), spriteCssClass: "e-icon e-ss-filter" },
				{ id: "Sort", text: obj._getLocStr("Sort"), parentId: null, spriteCssClass: "e-icon e-ss-sortatoz" },
                { id: "SortAtoZ", parentId: "Sort", text: obj._getLocStr("SortAtoZ"), spriteCssClass: "e-icon e-ss-sortatoz" },
				{ id: "SortZtoA", parentId: "Sort", text: obj._getLocStr("SortZtoA"), spriteCssClass: "e-icon e-ss-sortztoa" },
                { id: "PutCellColor", parentId: "Sort", text: obj._getLocStr("PutCellColor"), spriteCssClass: "" },
				{ id: "PutFontColor", parentId: "Sort", text: obj._getLocStr("PutFontColor"), spriteCssClass: "" },
				{ id: "ctxComment", parentId: null, text: obj._getLocStr("Comment") },
                { id: "ctxInsrtCmnt", text: obj._getLocStr("InsertComment"), parentId: "ctxComment", spriteCssClass: "e-icon e-ss-newcmnt" },
                { id: "ctxEditCmnt", text: obj._getLocStr("EditComment"), parentId: "ctxComment", spriteCssClass: "e-icon e-ss-editcmnt" },
                { id: "ctxDeleteCmnt", text: obj._getLocStr("DeleteComment"), parentId: "ctxComment", spriteCssClass: "e-icon e-ss-deletecmnt" },
                { id: "ctxShwHdCmnt", text: obj._getLocStr("ShowHide"), parentId: "ctxComment", spriteCssClass: "e-icon" },
                { id: "FormatCells", text: obj._getLocStr("FormatCells") + "...", parentId: null, spriteCssClass: "e-icon e-ss-formatcells" },
                { id: "CmHyperLink", text: obj._getLocStr("HyperLink"), parentId: null, spriteCssClass: "e-icon e-ss-hyperlink" },
                { id: "HyperLink", text: obj._getLocStr("HyperLink") + "...", parentId: "CmHyperLink", spriteCssClass: "e-icon e-ss-hyperlink" },
                { id: "EditLink", text: obj._getLocStr("EditLink") + "...", parentId: "CmHyperLink" },
                { id: "OpenLink", text: obj._getLocStr("OpenLink"), parentId: "CmHyperLink" },
                { id: "RemoveLink", text: obj._getLocStr("RemoveLink"), parentId: "CmHyperLink", spriteCssClass: "e-icon e-ss-removelink" },
                { id: "ClearContents", text: obj._getLocStr("ClearContents"), parentId: null, spriteCssClass: "e-icon e-ss-clear" }
        ];
		
        this._rowHeaderMenuData = this._columnHeaderMenuData = [
				{ id: "Cut", text: obj._getLocStr("Cut"), parentId: null, spriteCssClass: "e-icon e-ss-cut" },
				{ id: "Copy", text: obj._getLocStr("Copy"), parentId: null, spriteCssClass: "e-icon e-ss-copy" },
				{ id: "Paste", text: obj._getLocStr("Paste"), parentId: null, spriteCssClass: "e-icon e-ss-paste" },
                { id: "PasteSpecial", text: obj._getLocStr("PasteSpecial"), parentId: "Paste" },
                { id: "PasteValues", text: obj._getLocStr("PasteValues"), parentId: "Paste" },
                { id: "Insert", text: obj._getLocStr("Insert"), parentId: null },
                { id: "Delete", text: obj._getLocStr("Delete"), parentId: null },
                { id: "ClearContents", text: obj._getLocStr("ClearContents"), parentId: null, spriteCssClass: "e-icon e-ss-clear" },
                { id: "Hide", text: obj._getLocStr("Hide"), parentId: null },
                { id: "Unhide", text: obj._getLocStr("Unhide"), parentId: null }
        ];

        this._footerMenuData = [
            { id: "InsertSheet", text: obj._getLocStr("InsertSheet"), parentId: null },
            { id: "DeleteSheet", text: obj._getLocStr("DeleteSheet"), parentId: null, spriteCssClass: "e-icon e-ss-delete" },
            { id: "RenameSheet", text: obj._getLocStr("RenameSheet"), parentId: null, spriteCssClass: "e-icon " },
            { id: "MoveorCopy", text: obj._getLocStr("MoveorCopy") + "...", parentId: null, spriteCssClass: "e-icon " },
            { id: "HideSheet", text: obj._getLocStr("HideSheet"), parentId: null, spriteCssClass: "e-icon " },
            { id: "UnhideSheet", text: obj._getLocStr("UnhideSheet"), parentId: null, spriteCssClass: "e-icon " },
            { id: "ProtectSheet", text: obj._getLocStr("Protectsheet"), parentId: null, spriteCssClass: "e-icon e-ss-cmenuprotect" }
        ];
        this._chartMenuData = [
            { id: "Cut", text: obj._getLocStr("Cut"), parentId: null, spriteCssClass: "e-icon e-ss-cut" },
            { id: "Copy", text: obj._getLocStr("Copy"), parentId: null, spriteCssClass: "e-icon e-ss-copy" },
            { id: "ChartType", text: obj._getLocStr("ChangeChartType") + "...", parentId: null },
            { id: "SelectData", text: obj._getLocStr("SelectData") + "...", parentId: null }
        ];
        this._imgMenuData = [
            { id: "Cut", text: obj._getLocStr("Cut"), parentId: null, spriteCssClass: "e-icon e-ss-cut" },
            { id: "Copy", text: obj._getLocStr("Copy"), parentId: null, spriteCssClass: "e-icon e-ss-copy" },
            { id: "ChangePicture", text: obj._getLocStr("ChangePicture"), parentId: null }
        ];
        this._pivotMenuData = [
           { id: "Refresh", text: obj._getLocStr("Refresh"), parentId: null, spriteCssClass: "e-icon e-ss-pivotrefresh" }        
        ];
        this._protectRowMenuIds = ["Insert", "Delete", "Filter", "ctxComment", "Sort", "LockCells", "CmHyperLink", "FormatCells", "ClearContents"];
        this._prtctHeaderIds = ["Insert", "Delete", "Hide", "Unhide", "ClearContents"];
        this._footerIds = ["InsertSheet", "DeleteSheet", "RenameSheet", "MoveorCopy", "HideSheet", "UnhideSheet"];
    };

    ej.Menu.prototype._calculateContextMenuPosition = function (e) {
        var menuId = this.element.get(0).id, spreadId = this.element.data("id"), xlObj = $("#" + spreadId).data('ejSpreadsheet'), locationX, locationY, totHeight;
        locationX = (e.clientX + this.element.width() < $(window).width()) ? e.pageX : e.pageX - this.element.width();
        totHeight = (xlObj && menuId.indexOf(spreadId + '_contextMenuFooter') > -1) ? xlObj.element.height() : $(window).height();
        locationY = (e.clientY + this.element.height() < totHeight) ? e.pageY : (e.clientY > this.element.height()) ? e.pageY - this.element.height() : totHeight - this.element.outerHeight();
        var bodyPos = $("body").css("position") != "static" ? $("body").offset() : { left: 0, top: 0 };
        locationX -= bodyPos.left, locationY -= bodyPos.top;
        return {
            X: locationX,
            Y: locationY
        };
    };

    ej.spreadsheetFeatures.contextmenu.prototype = {
        //Contextmenu
        _initContextMenu: function () {
            var createMenu = ej.buildTag("ul .e-spreadsheet e-" + this._uniqueClass, " ", { display: "none", width: "auto" }, { id: this.XLObj._id + "_contextMenuCell" });
            this._createMenu(createMenu, (this.XLObj._phoneMode || this.XLObj._tabMode) ? this._rowCellMenuDataMobile : this._rowCellMenuData, "#" + this.XLObj._id + " .e-spreadsheetcontentcontainer");
            createMenu = ej.buildTag("ul .e-spreadsheet e-" + this._uniqueClass, " ", { display: "none" }, { id: this.XLObj._id + "_contextMenuColumnHeader" });
            this._createMenu(createMenu, this._columnHeaderMenuData, "#" + this.XLObj._id + " .e-spreadsheetheader .e-headercontent");
            createMenu = ej.buildTag("ul .e-spreadsheet e-" + this._uniqueClass, " ", { display: "none" }, { id: this.XLObj._id + "_contextMenuRowHeader" });
            this._createMenu(createMenu, this._rowHeaderMenuData, "#" + this.XLObj._id + " .e-rowheadercontent");
        },

        _initCMenuFooter: function () {
            var createMenu = ej.buildTag("ul .e-spreadsheet e-" + this._uniqueClass, " ", { display: "none" }, { id: this.XLObj._id + "_contextMenuFooter" });
            createMenu.data("id", this.XLObj._id);
            this._createMenu(createMenu, this._footerMenuData, "#" + this.XLObj._id + " .e-pagercontainer");
        },

        _createMenu: function (createMenu, data, target) {
            createMenu.ejMenu(
            {
                fields: { dataSource: data, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" },
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                beforeOpen: $.proxy(this._beforeOpen, this),
                close: $.proxy(this._menuClose, this),
                click: $.proxy(this._menuClick, this),
                contextMenuTarget: target
            });
        },
        
        hideCMenu: function () {
            var xlObj = this.XLObj;
            if (!xlObj.model.enableContextMenu)
                return;
            $("#" + xlObj._id + "_contextMenuCell").data("ejMenu").element.hide();
            $("#" + xlObj._id + "_contextMenuColumnHeader").data("ejMenu").element.hide();
            $("#" + xlObj._id + "_contextMenuRowHeader").data("ejMenu").element.hide();
            $("#" + xlObj._id + "_contextMenuFooter").data("ejMenu").element.hide();
        },
		
		_getCMenuObj: function(target){
			var xlObj = this.XLObj;
			switch(target){
				case ej.Spreadsheet.ContextMenu.Cell:
					return $("#" + xlObj._id + "_contextMenuCell").data("ejMenu");
				case ej.Spreadsheet.ContextMenu.RowHeader:
					return $("#" + xlObj._id + "_contextMenuRowHeader").data("ejMenu");
				case ej.Spreadsheet.ContextMenu.ColumnHeader:
					return $("#" + xlObj._id + "_contextMenuColumnHeader").data("ejMenu");
				case ej.Spreadsheet.ContextMenu.Footer:
					return $("#" + xlObj._id + "_contextMenuFooter").data("ejMenu");
			}
		},
		
		addItem: function(target, itemColl, operation, itemIdx){
			if(!target || this.XLObj.model.isReadOnly)
				return;
		    var menuObj = this._getCMenuObj(target), isChangedDtSrc = false, dataSource, len, i, spliceIdx;
		    dataSource = $.extend(true, [], menuObj.model.fields.dataSource);
		    switch (operation) {
		        case "insert":
		            $.merge(dataSource, itemColl);
		            isChangedDtSrc = true;
		            break;
		        case "insertbefore":
		            len = itemColl.length, spliceIdx = (itemIdx - 1) || 0;
		            while (len > 0) {
		                dataSource.splice(spliceIdx, 0, itemColl[len - 1]);
		                len--;
		            }
		            isChangedDtSrc = true;
		            break;
		        case "insertafter":
		            len = itemColl.length, i = 0, spliceIdx = itemIdx || dataSource.length;
		            while (i < len) {
		                dataSource.splice(spliceIdx, 0, itemColl[i]);
		                i++;
		                spliceIdx++;
		            }
		            isChangedDtSrc = true;
		            break;
		    }

		    if (isChangedDtSrc)
		        this.changeDataSource(target, dataSource);
		},
		
		removeItem: function(target, idxColl){
		    if (!target || this.XLObj.model.isReadOnly)
				return;
		    var menuObj = this._getCMenuObj(target), itemColl = [], i, dataSource, newDataSource = [];
		    dataSource = $.extend(true, [], menuObj.model.fields.dataSource);
		    for (i = 0, length = dataSource.length; i < length; i++) {
		        if (idxColl.indexOf(i + 1) == -1)
		            newDataSource.push(dataSource[i]);
		    }
		    this.changeDataSource(target, newDataSource);
		},
		
		enableItem: function(target, idxColl){
		    if (!target || this.XLObj.model.isReadOnly)
				return;
			var menuObj = this._getCMenuObj(target), i;
			if(idxColl && idxColl.length > 0)
				for(i = 0, length = idxColl.length; i < length; i++)
					menuObj.enableItemByID(menuObj.element.find('li:eq(' + (idxColl[i] - 1) + ')')[0].id);
			else
				menuObj.enable();
		},
		
		disableItem: function(target, idxColl){
		    if (!target || this.XLObj.model.isReadOnly)
				return;
			var menuObj = this._getCMenuObj(target), i;
			if(idxColl && idxColl.length > 0)
				for(i = 0, length = idxColl.length; i < length; i++)
					menuObj.disableItemByID(menuObj.element.find('li:eq(' + (idxColl[i] - 1) + ')')[0].id);
			else
				menuObj.disable();
		},
		
		changeDataSource: function(target, data){
		    if (!target || this.XLObj.model.isReadOnly)
				return;
			if(data){
				var menuObj = this._getCMenuObj(target);
				this._changedDataSource = true;
				switch(target){
					case ej.Spreadsheet.ContextMenu.Cell:
						this._rowCellMenuDataMobile = this._rowCellMenuData = data;
						break;
					case ej.Spreadsheet.ContextMenu.RowHeader:
						this._headerMenuDataMobile = this._rowHeaderMenuData = data;
						break;
					case ej.Spreadsheet.ContextMenu.ColumnHeader:
						this._headerMenuDataMobile = this._columnHeaderMenuData = data;
						break;
					case ej.Spreadsheet.ContextMenu.Footer:
						this._footerMenuData = data;
						break;
				}
				menuObj && menuObj.option("fields", { dataSource: data });
			}
		},

        _updateContextMenuItems: function($trgt){
			var xlObj = this.XLObj, fltrIcon, dataSource;
			var colMenuObj = $("#" + xlObj._id + "_contextMenuColumnHeader").data("ejMenu"), rowMenuObj = $("#" + xlObj._id + "_contextMenuRowHeader").data("ejMenu"), text, Locked, trgt = $trgt[0], sheetIdx = xlObj.getActiveSheetIndex(), actSheet = xlObj.getSheet(sheetIdx), actCell = (!ej.isNullOrUndefined(xlObj.getActiveCellElem()) && xlObj.getActiveCellElem().length > 0) ? xlObj.getActiveCellElem() : $trgt, menuData = (xlObj._phoneMode || xlObj._tabMode) ? this._rowCellMenuDataMobile : this._rowCellMenuData, menuObj = $("#" + xlObj._id + "_contextMenuCell").data("ejMenu"), footMenuObj = $("#" + xlObj._id + "_contextMenuFooter").data("ejMenu"), actElem = xlObj.getActiveCell(sheetIdx), tabId, tabIdx, tabRange;
            if ($trgt.hasClass("e-rowcell") || $trgt.hasClass("e-hyperlinks")) {
                var insrtDt, sortData = [], colHdr = xlObj._getJSSheetHeader(sheetIdx).find('th'), rowHdr = xlObj._getJSSheetRowHeader(sheetIdx).find('td');
                var value = xlObj.XLEdit.getPropertyValue(actSheet._activeCell.rowIndex, actSheet._activeCell.colIndex), cellIndex = xlObj._getCellIdx(!xlObj._hasClass($trgt, "e-hyperlinks") ? trgt : $trgt.parents("td")[0]);
                this._isMenuOpened = true;
                if (xlObj.model.allowLockCell && actSheet.isSheetProtected && xlObj.XLEdit.getPropertyValue(cellIndex.rowIndex, cellIndex.colIndex, "isLocked", sheetIdx))
                    this._disableMenuOpt(this._protectRowMenuIds);
                else {
                    if ($trgt.hasClass("e-hyperlinks")) {
                        $trgt = $trgt.parents("td");
                        trgt = $trgt[0];
                    }
                    if (xlObj.model.allowHyperlink) {
                        this._enableMenuOpt(["CmHyperLink"]);
                        var data = xlObj.XLEdit.getPropertyValue(cellIndex.rowIndex, cellIndex.colIndex, "hyperlink", sheetIdx), hlItem = ["EditLink", "OpenLink", "RemoveLink"];
                        if (ej.isNullOrUndefined(data)) {
                            this._disableMenuOpt(hlItem);
                            this._enableMenuOpt(["HyperLink"]);
                        }
                        else {
                            this._enableMenuOpt(hlItem);
                            this._disableMenuOpt(["HyperLink"]);
                        }
                    }
                    else
                        this._disableMenuOpt(["CmHyperLink"]);
                    if (!xlObj.model.allowFiltering)
                        menuObj.disableItemByID("Filter");
                    else {
                        menuObj.enableItemByID("Filter");
                        tabRange = xlObj.model.sheets[sheetIdx].filterSettings.tableRange;
                        var actvCell = xlObj.getCell(actElem.rowIndex, actElem.colIndex, sheetIdx)[0];
                        if (tabRange.length > 0) {
                            tabId = (actvCell.className.indexOf("e-table") > -1) ? (actvCell.className[actvCell.className.indexOf("e-table") + 7]) : -1;
                            for (var i = 0, n = tabRange.length; i < n; i++)
                                if (tabRange[i].tableID === parseInt(tabId)) {
                                    tabIdx = i;
                                    break;
                                }
                            if (!ej.isNullOrUndefined(tabIdx) && actElem.rowIndex < tabRange[tabIdx].selectedRange.endRow + 1 && actElem.rowIndex > tabRange[tabIdx].selectedRange.startRow - 2)
                                if (actElem.colIndex < tabRange[tabIdx].multifilterIdx[tabRange[tabIdx].multifilterIdx.length - 1] + 1 && actElem.colIndex > tabRange[tabIdx].multifilterIdx[0] - 1) {
                                    fltrIcon = xlObj.getCell(tabRange[tabIdx].selectedRange.startRow - 1, actElem.colIndex, sheetIdx).find("span");
                                    if (fltrIcon.length && fltrIcon[0].className.indexOf("e-ssfiltered") > -1) {
                                        menuObj.enableItemByID("ClearFilter");
                                        this._clrFltrEnable = true;
                                    }
                                }
                        }
                        if (!this._clrFltrEnable)
                            menuObj.disableItemByID("ClearFilter");
                    }
                    if (xlObj.model.allowInsert)
                       menuObj.enableItemByID("Insert");
                    else 
                       menuObj.disableItemByID("Insert");
                    if (xlObj.model.allowDelete)
                       menuObj.enableItemByID("Delete");
                    else
                        menuObj.disableItemByID("Delete");
                    if ((xlObj.XLClipboard._copyBackup.cells || xlObj.XLClipboard._copyBackup.elem) && !xlObj.model.isReadOnly){
                        this._enableMenuOpt(["Paste"]);
                        if (xlObj.isPasteValuesOnly)
                            menuObj.disableItemByID("PasteSpecial");
                    }
                    else
                        this._disableMenuOpt(["Paste"]);
                    if (xlObj.model.allowSorting)
                        this._enableMenuOpt(["Sort"]);
                    else
                        this._disableMenuOpt(["Sort"]);
					if (xlObj.model.allowClear)
                        this._enableMenuOpt(["ClearContents"]);
                    else
                        this._disableMenuOpt(["ClearContents"]);
                    if (xlObj.model.allowCellFormatting) 
                        this._enableMenuOpt(["FormatCells"]);
                    else
                        this._disableMenuOpt(["FormatCells"]);
                    if (!xlObj._phoneMode && !xlObj._tabMode) {
                        sortData = !ej.isNullOrUndefined(value) && $.isNumeric(value) ? [xlObj._getLocStr("SortSmallesttoLargest"), xlObj._getLocStr("SortLargesttoSmallest")] : (!ej.isNullOrUndefined(ej.parseDate(value)) ? [xlObj._getLocStr("SortOldesttoNewest"), xlObj._getLocStr("SortNewesttoOldest")] : [xlObj._getLocStr("SortAtoZ"), xlObj._getLocStr("SortZtoA")]);
                        //Comments
                        if (xlObj.model.allowComments) {
                            if (menuObj.element.find("#ctxComment").hasClass("e-disable-item"))
                                this._enableMenuOpt(["ctxComment"]);
                            var selectedCells = xlObj.getSheetElement(xlObj.getActiveSheetIndex()).find(".e-selected"), trgtCell = selectedCells.length > 1 ? actCell : $trgt;
                            if (trgtCell.hasClass("e-commentcell")) {
                                this._disableMenuOpt(["ctxInsrtCmnt"]);
                                if (xlObj.XLEdit.getPropertyValueByElem(trgtCell, "comment").isVisible) {
                                    insrtDt = $.extend(menuData[19], { text: xlObj._getLocStr("HideComment") });
                                    menuObj.remove(["#" + menuData[19].id]);
                                    menuObj.insert([insrtDt], "#" + menuData[15].id);
                                }
                                else {
                                    insrtDt = $.extend(menuData[19], { text: xlObj._getLocStr("ShowHide") });
                                    menuObj.remove(["#" + menuData[19].id]);
                                    menuObj.insert([insrtDt], "#" + menuData[15].id);
                                }
                                this._enableMenuOpt(["ctxEditCmnt", "ctxDeleteCmnt", "ctxShwHdCmnt"]);
                            }
                            else {
                                this._enableMenuOpt(["ctxInsrtCmnt"]);
                                this._disableMenuOpt(["ctxEditCmnt", "ctxDeleteCmnt", "ctxShwHdCmnt"]);
                            }
                            if (selectedCells.filter(trgt).length > 0 && selectedCells.filter(".e-commentcell").length > 0)
                                this._enableMenuOpt(["ctxDeleteCmnt"]);
                        }
                        else
                            this._disableMenuOpt(["ctxComment"]);
                        if (menuData[11].text !== sortData[0]) {
                            insrtDt = $.extend(menuData[11], { text: sortData[0], spriteCssClass: menuData[11].sprite });
                            menuObj.remove(["#" + menuData[11].id]);
                            menuObj.insertBefore([insrtDt], "#" + menuData[13].id);
                        }
                        if (menuData[12].text !== sortData[1]) {
                            insrtDt = $.extend(menuData[12], { text: sortData[1], spriteCssClass: menuData[12].sprite });
                            menuObj.remove(["#" + menuData[12].id]);
                            menuObj.insertBefore([insrtDt], "#" + menuData[13].id);
                        }
                    }
                    
                    if (xlObj.model.showRibbon)
                        xlObj.XLRibbon._dirtySelect(xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-selected"));
                }
                if (xlObj.model.allowInsert)
                    footMenuObj.enableItemByID("InsertSheet");
                else
                    footMenuObj.disableItemByID("InsertSheet");
                if (xlObj.model.allowDelete)
                    footMenuObj.enableItemByID("DeleteSheet");
                else
                    footMenuObj.disableItemByID("DeleteSheet");
                if (xlObj.model.allowClipboard)
                    this._enableMenuOpt(["Cut", "Copy"]);
                else
                    this._disableMenuOpt(["Cut", "Copy"]);
                if ((xlObj.XLClipboard._copyBackup.cells || xlObj.XLClipboard._copyBackup.elem) && !xlObj.model.isReadOnly)
                    this._enableMenuOpt(["Paste"], cmenuId);
                else
                    this._disableMenuOpt(["Paste"], cmenuId);
            }
            else if ($trgt.hasClass("e-link")) {
                dataSource = footMenuObj.model.fields.dataSource.slice(0);
                if (xlObj._isSheetRename && !xlObj._updateSheetNames()) {
                    args.cancel = true;
                    return;
                }
                if (xlObj.model.allowLockCell && actSheet.isSheetProtected)
                    text = xlObj._getLocStr("Unprotect");
                else
                    text = xlObj._getLocStr("Protectsheet");
                dataSource[6].text = text;                 
                footMenuObj.option("fields", { id: "id", dataSource: dataSource, parentId: "parentId" });
                this._isMenuOpened = true;
                if (xlObj._isCommentEdit)
                    xlObj.XLComment._updateCurCmntVal();
                if ($trgt.not("a.e-currentitem, a.e-PP, a.e-NP").hasClass("e-numericitem"))
                    xlObj.gotoPage($trgt.data("index"));
                if (!xlObj.model.exportSettings.password) {
                    if (xlObj._getSheetNames(false).length > 0)
                        footMenuObj.enableItemByID("UnhideSheet");
                    else
                        footMenuObj.disableItemByID("UnhideSheet");
                    if (xlObj._getSheetNames(true).length > 1) {
                        footMenuObj.enableItemByID("DeleteSheet");
                        footMenuObj.enableItemByID("HideSheet");
                        footMenuObj.enableItemByID("MoveorCopy");
                    }
                    else {
                        footMenuObj.disableItemByID("DeleteSheet");
                        footMenuObj.disableItemByID("HideSheet");
                        footMenuObj.disableItemByID("MoveorCopy");
                    }
                }
                else 
                    this._disableMenuOpt(this._footerIds, "contextMenuFooter");
                if (xlObj.model.allowLockCell)
                    footMenuObj.enableItemByID("ProtectSheet");
                else
                    footMenuObj.disableItemByID("ProtectSheet");
            }
            else if ($trgt.hasClass("e-headercelldiv") || $trgt.hasClass("e-headercell") || $trgt.hasClass("e-rowheader")) {
                var cmenuId = $trgt.hasClass("e-rowheader") ? "contextMenuRowHeader" : "contextMenuColumnHeader";
                
                if (xlObj.model.allowClipboard)
                    this._enableMenuOpt(["Cut", "Copy"], cmenuId);
                else
                    this._disableMenuOpt(["Cut", "Copy"], cmenuId);
                if ((xlObj.XLClipboard._copyBackup.cells || xlObj.XLClipboard._copyBackup.elem) && !xlObj.model.isReadOnly)
                    this._enableMenuOpt(["Paste"], cmenuId);
                else
                    this._disableMenuOpt(["Paste"], cmenuId);
				if (xlObj.model.allowLockCell && actSheet.isSheetProtected)
                    this._disableMenuOpt(this._prtctHeaderIds, cmenuId);
                else {
					if (xlObj.model.allowClear)
						this._enableMenuOpt(["ClearContents"], cmenuId);
					else
						this._disableMenuOpt(["ClearContents"], cmenuId);
					if (xlObj.model.allowInsert)
						this._enableMenuOpt(["Insert"], cmenuId);
					else
						this._disableMenuOpt(["Insert"], cmenuId);
					if (xlObj.model.allowDelete)
						this._enableMenuOpt(["Delete"], cmenuId);
					else
						this._disableMenuOpt(["Delete"], cmenuId);
					this._enableMenuOpt(["Hide", "Unhide"], cmenuId);
				 }
                if(xlObj.model.showRibbon)
					xlObj.XLRibbon._dirtySelect(xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-selected"));
           }
           if (xlObj.model.allowInsert && ej.isNullOrUndefined(xlObj.model.exportSettings.password))
               this._enableMenuOpt(["InsertSheet", "MoveorCopy"], "contextMenuFooter");
           else
               this._disableMenuOpt(["InsertSheet", "MoveorCopy"], "contextMenuFooter");
		   xlObj.model.exportSettings.password ? this._disableMenuOpt(["RenameSheet"]) : this._enableMenuOpt(["RenameSheet"])
           if (xlObj.model.allowDelete && xlObj._getSheetNames(true).length > 1)
               this._enableMenuOpt(["DeleteSheet"], "contextMenuFooter");
           else
               this._disableMenuOpt(["DeleteSheet"], "contextMenuFooter");
           if (xlObj.model.allowEditing)
               this._enableMenuOpt(["RenameSheet"], "contextMenuFooter");
           else
               this._disableMenuOpt(["RenameSheet"], "contextMenuFooter");
			if (xlObj.model.isReadOnly) {
               this._disableMenuOpt(["Cut", "Insert", "Delete", "ClearContents"], "contextMenuColumnHeader");
               this._disableMenuOpt(["Cut", "Insert", "Delete", "ClearContents"], "contextMenuRowHeader");
               this._disableMenuOpt(["Cut", "Insert", "Delete", "Filter", "Sort", "ctxComment", "FormatCells", "CmHyperLink", "ClearContents"], "contextMenuCell");
			}
		},

        _beforeOpen: function (args) {
            var xlObj = this.XLObj, xlResize = xlObj.XLResize;
            if (!xlObj.model.enableContextMenu || (args.events.type == "mousedown" && args.target.id.indexOf("_picture") > -1)) {
                args.cancel = true;
                return false;
            }
			if ($(args.target).hasClass("e-numericitem") && xlObj.model.isReadOnly) {
                args.cancel = true;
                return false;
			} 
            this._clrFltrEnable = false;
            this.hideCMenu();
            var colMenuObj = $("#" + xlObj._id + "_contextMenuColumnHeader").data("ejMenu"), rowMenuObj = $("#" + xlObj._id + "_contextMenuRowHeader").data("ejMenu"), trgt = args.target, text, Locked, evnt = { target: trgt }, $trgt = $(trgt), sheetIdx = xlObj.getActiveSheetIndex(), actSheet = xlObj.getSheet(sheetIdx), actCell = (!ej.isNullOrUndefined(xlObj.getActiveCellElem()) && xlObj.getActiveCellElem().length > 0) ? xlObj.getActiveCellElem() : $trgt, menuData = (xlObj._phoneMode || xlObj._tabMode) ? this._rowCellMenuDataMobile : this._rowCellMenuData, menuObj = $("#" + xlObj._id + "_contextMenuCell").data("ejMenu"), footMenuObj = $("#" + xlObj._id + "_contextMenuFooter").data("ejMenu"), actElem = xlObj.getActiveCell(sheetIdx), tabId, tabIdx, tabRange;
            if (xlObj._trigger("beforeOpen", evnt))
                return;
            if (xlObj.XLEdit._isEdit || (xlObj.model.allowComments && xlObj.XLComment._isCommentEdit) || $trgt.hasClass("e-filterspan") || (args.events.which === 1 && $trgt.hasClass("e-hyperlinks")) || $trgt.parents("div").hasClass("e-vscroll") || $trgt.parents("div").hasClass("e-hscroll") || ($(trgt.parentNode).hasClass("e-pagercontainer") && !$trgt.hasClass("e-link")) || (!ej.isNullOrUndefined(xlObj.XLResize) && xlObj.XLResize._resizeStart) || args.target.id.indexOf("Sheet_RenamePanel") > -1 || $trgt.parents().hasClass("e-grid") || $trgt.hasClass("e-autofill"))
                args.cancel = true;
            if (xlResize && xlResize._preventColResize($trgt.parent()[0].cellIndex, true) && $trgt.hasClass('e-headercelldiv'))
                args.cancel = true;
            if (xlResize && xlResize._preventRowResize(parseInt($trgt.parent().attr('idx')), true) && $trgt.hasClass('e-rowheader'))
                args.cancel = true;
            if ($trgt.hasClass("e-rowcell") || $trgt.hasClass("e-hyperlinks")) {
				var colHdr = xlObj._getJSSheetHeader(sheetIdx).find('th'), rowHdr = xlObj._getJSSheetRowHeader(sheetIdx).find('td');
				if (!ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValueByElem(xlObj.getCell(actSheet._activeCell.rowIndex, actSheet._activeCell.colIndex), "range"))) {
				    var rangeInfo = xlObj.model.sheets[sheetIdx].rangeSettings[xlObj.XLEdit.getPropertyValueByElem(xlObj.getCell(actSheet._activeCell.rowIndex, actSheet._activeCell.colIndex), "range")];
                    menuObj.option("fields", { dataSource: rangeInfo.contextMenuSettings.dataSource, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" });
                    menuObj.option("width", rangeInfo.contextMenuSettings.width);
                    menuObj.option("height", rangeInfo.contextMenuSettings.height);
                }
				else if ($(colHdr[$trgt.index()]).hasClass('e-colselected') || $(rowHdr[$trgt.parent().index()]).hasClass("e-rowselected")) {
                    menuData = $(colHdr[$trgt.index()]).hasClass('e-colselected') ? this._columnHeaderMenuData : this._rowHeaderMenuData;
                    if (JSON.stringify(menuData) !== JSON.stringify(args.model.fields.dataSource) && this._changedDataSource)
                       menuObj.option("fields", { dataSource: menuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" });
                }
                else {
                    if (JSON.stringify(menuData) !== JSON.stringify(args.model.fields.dataSource))
                        menuObj.option("fields", { dataSource: menuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" });
				}
			}
			else if ($trgt.hasClass("e-ss-imgvisual") || $trgt.hasClass("e-ss-object") || $trgt.closest("div").hasClass("e-ss-object")) {
                var chartMenuData = $.extend(true, [], this._chartMenuData);
                this._isMenuOpened = true;
                chartMenuData = this.XLObj.model.showRibbon ? this._chartMenuData : chartMenuData.splice(0, 2);
                menuData = xlObj.XLShape._shapeType === "chart" ? chartMenuData : this._imgMenuData;              
                if (JSON.stringify(menuData) !== JSON.stringify(args.model.fields.dataSource))
                    menuObj.option("fields", { dataSource: menuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" });
            }
			else if ($trgt.hasClass("e-ss-pivot") || $trgt.closest("div").hasClass("e-ss-pivot")) {
                menuData = this._pivotMenuData;
                if (JSON.stringify(menuData) !== JSON.stringify(args.model.fields.dataSource))
                    menuObj.option("fields", { dataSource: menuData, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" });
            }
			else if ($trgt.hasClass("e-headercelldiv") || $trgt.hasClass("e-headercell") || $trgt.hasClass("e-rowheader")){
				if (xlObj._phoneMode || xlObj._tabMode) {
                    colMenuObj.option("fields", { dataSource: this._headerMenuDataMobile });
                    rowMenuObj.option("fields", { dataSource: this._headerMenuDataMobile });
                }
                else if(this._changedDataSource){
                    colMenuObj.option("fields", { dataSource: this._columnHeaderMenuData });
                    rowMenuObj.option("fields", { dataSource: this._rowHeaderMenuData });
                }
			}
			if(!this._changedDataSource)
				this._updateContextMenuItems($trgt);
           if (args.cancel)
               this._isMenuOpened = false;
        },

        _menuClick: function (args) {
            if (this.XLObj._trigger("contextMenuClick", args))
                return;
            this._processCMenu(args.ID, args.events.element);
        },

        _menuClose: function () {
            this._isMenuOpened = false;
        },

        _processCMenu: function (key, elem) {
            var cid, dataVal, selCells, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), stCellIdx, enCellIdx,
                sheet = xlObj.getSheet(sheetIdx), actElem, columnName, selCols, selRows, selCells = sheet._selectedCells;;
            switch (key) {
                case "Cut":
                    xlObj.XLClipboard.cut();
                    break;
                case "Copy":
                    xlObj.XLClipboard.copy();
                    break;
                case "PasteSpecial":
                case "PasteValues":
                    xlObj.XLClipboard._isSpecial = !(key === "PasteValues");
                    xlObj.XLClipboard.paste();
                    break;
                case "Insert":
                    xlObj._insDelStatus = "insert";
                    if (sheet._isColSelected) {
                        selCols = xlObj._getJSSheetHeader(sheetIdx).find(".e-colhighlight");
                        xlObj.insertEntireColumn(selCols[0].cellIndex, selCols[selCols.length - 1].cellIndex);
                    }
                    else if (sheet._isRowSelected) {
                        selRows = xlObj._getJSSheetRowHeader(sheetIdx).find(".e-rowhighlight");
                        stCellIdx = xlObj._getCellIdx(selRows[0]);
                        enCellIdx = xlObj._getCellIdx(selRows[selRows.length - 1]);
                        xlObj.insertEntireRow(stCellIdx.rowIndex, enCellIdx. rowIndex);
                    }
                    else
                        xlObj._showDialog(xlObj._id + "_Ribbon_Others_Cells_InsertCellOptions");
                    break;
                case "Delete":
                    selCols = $(xlObj._getJSSheetHeader(sheetIdx).find("tr")[0]).find(".e-colselected");
                    selRows = $(xlObj.getRows(sheetIdx)[0]).find(".e-rowselected");
                    if (elem.parentElement.id.indexOf("ColumnHeader") > -1 || sheet._isColSelected) {
                        selCols = xlObj._getJSSheetHeader(sheetIdx).find(".e-colhighlight");
                        xlObj.deleteEntireColumn(selCols[0].cellIndex, selCols[selCols.length - 1].cellIndex, []);
                    }
                    else if (elem.parentElement.id.indexOf("RowHeader") > -1 || sheet._isRowSelected) {
                        selRows = xlObj._getJSSheetRowHeader(sheetIdx).find(".e-rowhighlight");
                        stCellIdx = xlObj._getCellIdx(selRows[0]);
                        enCellIdx = xlObj._getCellIdx(selRows[selRows.length - 1]);
                        xlObj.deleteEntireRow(stCellIdx.rowIndex, enCellIdx.rowIndex, []);
                    }
                    else
                        xlObj._showDialog(xlObj._id + "_Ribbon_Others_Cells_DeleteCellOptions");
                    break;
                case "FilterSelected":
                    xlObj._showDialog(xlObj._id + "_Ribbon_Data_SortFilter_Filter");
                    xlObj.XLFilter.filterByActiveCell();
                    this._clrFltrEnable = false;
                    break;
                case "ClearFilter":
                    actElem = xlObj.getActiveCell(sheetIdx);
                    var tabName = xlObj.XLEdit.getPropertyValue(actElem.rowIndex, actElem.colIndex, "tableName"), tabId;
                    tabId = (!ej.isNullOrUndefined(tabName)) ? parseInt(tabName.replace("table", "")) : -1;
                    if (tabId > -1) {
                        columnName = xlObj.model.sheets[sheetIdx].columns[actElem.colIndex].field;
                        xlObj.XLFilter._clearFilterColumn(columnName, "", "", "", "", "", tabId);
                        delete xlObj._excelFilter._predicates[sheetIdx][columnName];
                    }
                    else
                        xlObj.XLFilter.clearFilter("apply");
                    this._clrFltrEnable = false;
                    break;
                case "SortAtoZ":
                case "SortZtoA":
                case "SortSmallesttoLargest":
                case "SortLargesttoSmallest":
                case "SortOldesttoNewest":
                case "SortNewesttoOldest":
                case "PutCellColor":
                case "PutFontColor":
                    if (xlObj.model.allowSorting)
                        xlObj.XLSort._sortHandler(key);
                    break;
                case "ClearContents":
                    var range = xlObj.model.sheets[sheetIdx].selectedRange;
                    xlObj.clearContents(xlObj._getAlphaRange(sheetIdx, range[0], range[1], range[2], range[3]));
                    break;
                case "InsertSheet":
                    xlObj.insertSheet();
                    break;
                case "DeleteSheet":
                    xlObj.deleteSheet(sheetIdx);
                    break;
                case "RenameSheet":
                    xlObj._renameSheet();
                    break;
                case "MoveorCopy":
                    xlObj._showDialog(xlObj._id + "_MoveorCopy");
                    break;
                case "Hide":
                    sheet._isColSelected && xlObj._hideColumn(selCells[0].colIndex, selCells[selCells.length - 1].colIndex);
                    sheet._isRowSelected && xlObj._hideRow(selCells[0].rowIndex, selCells[selCells.length - 1].rowIndex, "isRHide");
                    break;
                case "Unhide":
                    sheet._isColSelected && xlObj._showColumn(selCells[0].colIndex, selCells[selCells.length - 1].colIndex);
                    sheet._isRowSelected && xlObj._showRow(selCells[0].rowIndex, selCells[selCells.length - 1].rowIndex, "isRHide");
                    break;
                case "HyperLink":
                case "EditLink":
                    xlObj._showDialog(xlObj._id + "_Ribbon_Insert_Links_Hyperlink");
                    break;
                case "RemoveLink":
                    xlObj._removeHyperlink();
                    break;
                case "OpenLink":
                    xlObj._openLink();
                    break;
                case "ctxInsrtCmnt":
                    xlObj._dupDetails = true;
                    xlObj.XLComment.setComment();
                    xlObj._dupDetails = false;
                    break;
                case "ctxEditCmnt":
                    xlObj.XLComment.editComment();
                    break;
                case "ctxDeleteCmnt":
                    xlObj.XLComment.deleteComment();
                    break;
                case "ctxShwHdCmnt":
                    xlObj.XLComment.showHideComment();
                    break;
                case "ChangePicture":
                    xlObj._uploadImage = true;
                    xlObj.XLShape._changePicture = true;
                    xlObj.element.find("#" + xlObj._id + "_file .e-uploadinput").click();
                    break;
                case "ChartType":
                    xlObj._showDialog(xlObj._id + "_Ribbon_ChartDesign_Type_ChangeChartType");
					xlObj.XLRibbon._refreshChartTypeDlg();
                    break;
                case "SelectData":
                    xlObj._showDialog(xlObj._id + "_Ribbon_ChartDesign_Data_SelectData");
                    cid = document.getElementById(xlObj._id + "_chart").value;
                    dataVal = xlObj.XLChart._getShapeObj(cid, "chart");
                    $("#" + xlObj._id + "_crxaxis").val(dataVal.xRange ? xlObj._getAlphaRange(sheetIdx, dataVal.xRange[0], dataVal.xRange[1], dataVal.xRange[2], dataVal.xRange[3]) : "");
                    $("#" + xlObj._id + "_cryaxis").val(dataVal.yRange ? xlObj._getAlphaRange(sheetIdx, dataVal.yRange[0], dataVal.yRange[1], dataVal.yRange[2], dataVal.yRange[3]) : "");
                    $("#" + xlObj._id + "_crlaxis").val(dataVal.lRange ? xlObj._getAlphaRange(sheetIdx, dataVal.lRange[0], dataVal.lRange[1], dataVal.lRange[2], dataVal.lRange[3]) : "");
                    xlObj._selectDataval = { xRange: $("#" + xlObj._id + "_crxaxis").val(), yRange: $("#" + xlObj._id + "_cryaxis").val(), lRange: $("#" + xlObj._id + "_crlaxis").val() };
                    $("#" + xlObj._id + "_chartrangedlg").ejDialog("open");
                    break;
                case "HideSheet":
                    xlObj.hideSheet();
                    break;
                case "UnhideSheet":
                    xlObj._showDialog(xlObj._id + "_UnhideSheet");
                    break;
                case "ProtectSheet":
                    xlObj.protectSheet(!sheet.isSheetProtected);
                    break;
                case "FormatCells":
                    xlObj._showDialog(xlObj._id + "_FormatCells");
                    break;
                case "Refresh":
                    xlObj.XLPivot.refreshDataSource();
                    break;
                case "BackgroundColor":
                    $("#" + this.XLObj._id + "_colordlg").ejDialog("open");
                    this._selColor = {action: "bg-color", color: ""};
                    break;
                case "FontColor":
                    $("#" + this.XLObj._id + "_colordlg").ejDialog("open");
                    this._selColor = { action: "color", color: "" };
                    break;
            }
        },

        _disableMenuOpt: function (idCollection, cMenuId) {
            var cName = cMenuId || "contextMenuCell", menuObj = $("#" + this.XLObj._id + "_" + cName).data("ejMenu");
            if (menuObj)
                for (var i = 0, len = idCollection.length; i < len; i++)
                    menuObj.disableItemByID(idCollection[i]);
        },

        _enableMenuOpt: function (idCollection, cMenuId) {
            var cName = cMenuId || "contextMenuCell", menuObj = $("#" + this.XLObj._id + "_" + cName).data("ejMenu");
            if (menuObj)
                for (var i = 0, len = idCollection.length; i < len; i++)
                    menuObj.enableItemByID(idCollection[i]);
        },

        _initColorDialog: function () {
            var xlObj = this.XLObj, dlgId = xlObj._id + "_colordlg";
            if ($("#" + dlgId).length)
                return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-colordlg e-" + xlObj._id + "-dlg " , "", { display: "none" }), contentdiv = ej.buildTag("div#" + dlgId + "_dlgcontent .e-colordlgcontent"), cpinput = ej.buildTag("input#" + dlgId + "_cpicker"), confirmbtndiv = ej.buildTag("div#" + dlgId + "_condiv .e-dlg-btnctnr"),
                okButton = ej.buildTag("input#" + this._id + "_dialog_Ok"), canButton = ej.buildTag("input#" + this._id + "_dialog_Can", "", { "margin-left": 10 }), btncontentdiv = ej.buildTag("div#" + dlgId + "_dlgbtncontent .e-dlg-btnfields");
            contentdiv.append(cpinput);
            $dlg.append(contentdiv);
            xlObj.element.append($dlg);
            $dlg.ejDialog({ showOnInit: false, enableModal: true, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("ColorPicker"), width: "240", height: "auto", minHeight: 0, cssClass: "e-ss-dialog e-" + xlObj._id + "-dlg" });
            $("#" + dlgId + "_cpicker").ejColorPicker({ value: "#278787", modelType: "palette", presetType: "basic", cssClass: "e-ss-colorpicker e-ss-menuclrpkr", select: $.proxy(this._cpClickHandler, this), showApplyCancel: false });
            $("#" + dlgId + "_cpickerWrapper").hide();
            contentdiv.append($("#" + dlgId + "_cpicker_popup").css("display", "block"));
            okButton.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._colorOkClick, this), enabled: true });
            canButton.ejButton({ text: xlObj._getLocStr("Cancel"), showRoundedCorner: true, width: 60, click: ej.proxy(this._colorCanClick, this) });
            btncontentdiv.append(confirmbtndiv.append(okButton, canButton));
            $dlg.append(btncontentdiv);
        },

        _cpClickHandler: function (args) {
            this._selColor.color = args.value;
        },

        _colorOkClick: function (args) {
            var xlObj = this.XLObj;
            xlObj.XLFormat.format({ "style": (this._selColor.action === "bg-color") ? { "background-color": this._selColor.color } : { "color": this._selColor.color } });
            xlObj.setSheetFocus();
            $("#" + xlObj._id + "_colordlg").ejDialog("close");
        },

        _colorCanClick: function (args) {
            $("#" + this.XLObj._id + "_colordlg").ejDialog("close");
        }
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.sorting = function (obj) {
        this.XLObj = obj;
		this._isSortByFilter = false;
    };

    ej.spreadsheetFeatures.sorting.prototype = {
        _sortHandler: function (args) {
            var i, ctype1, ctype2, val1, val2, direction, tname, tableId, rIdx, cIdx, alphRange, format, cellIdx, color = {},
                columnName = "", range = {}, xlObj = this.XLObj, regx = xlObj._formatRegx, sheetIdx = xlObj.getActiveSheetIndex(),
                sheet = xlObj.getSheet(sheetIdx), cell = sheet._selectedCells, stRowIdx;
            columnName = sheet.columns[sheet._activeCell.colIndex].field;
			this._isSortByFilter = false;
            if (args != "PutCellColor" && args != "PutFontColor") {
                if (!xlObj.model.allowSorting || !sheet._selectedCells.length)
                    return;
                (cell.length === 1) && xlObj.selectAll();
                direction = (args === "Ribbon_SortZtoA" || args === "SortZtoA") ? ej.sortOrder.Descending : ej.sortOrder.Ascending;
                tname = xlObj.XLEdit.getPropertyValue(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, "tableName", sheetIdx) || "";
                tableId = xlObj._getTableID(tname);
                if (!ej.isNullOrUndefined(tableId)) {
                    range = sheet.tableManager[tableId].range.slice(0);
                    range[0]++;						
                }
                else {
                    range = sheet.selectedRange.slice(0), rIdx = range[0], cIdx = range[1];
                    if (rIdx === range[2])
                        return;
                    val1 = xlObj.XLEdit.getPropertyValue(rIdx, cIdx);
                    for (i = rIdx + 1; i <= range[2]; i++) {
                        if (!xlObj._isHiddenRow(i)) {
                            val2 = xlObj.XLEdit.getPropertyValue(i, cIdx);
                            break;
                        }
                    }
                    ctype1 = xlObj.isNumber(val1) ? ej.Spreadsheet.CellType.Number : ej.Spreadsheet.CellType.String;
                    ctype2 = xlObj.isNumber(val2) ? ej.Spreadsheet.CellType.Number : ej.Spreadsheet.CellType.String;
					 if(!xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "merge") && !xlObj.XLEdit.getPropertyValue(i, cIdx, "merge"))
						if(!xlObj.XLEdit.getPropertyValue(range[0], range[1], "calcValue"))
						    if (ctype1 != ctype2 || (xlObj.XLEdit.getPropertyValue(range[0], range[1], "wrap")) || xlObj.XLEdit.getPropertyValue(range[0], range[1], "isFilterHeader"))
								range[0]++;
                }
                this.sortByRange(range, columnName, direction);
            }
            else {
                stRowIdx = (cell.length === 1) ? this._selectSortRange(sheetIdx, cell[0]) : sheet._startCell.rowIndex;
                alphRange = xlObj._getAlphaRange(sheetIdx, stRowIdx, cell[0].colIndex, (cell.length === 1) ? cell[0].rowIndex : sheet._endCell.rowIndex, cell[0].colIndex);
				format = xlObj.XLEdit.getPropertyValue(sheet._activeCell.rowIndex, sheet._activeCell.colIndex, "formats");
                if (!xlObj.isUndefined(format)) {
                    format["background-color"] && (color["background-color"] = format["background-color"].toLowerCase());
                    format["color"] && (color["color"] = format["color"].toLowerCase());
                    this.sortByColor(args, color, alphRange);
                }
            }
			if (cell.length === 1) {
                xlObj.XLSelection.selectRange(cell[0], cell[0], sheetIdx)
                sheet._startCell = sheet._endCell = cell[0];
                xlObj.model.allowAutoFill && xlObj.XLDragFill.positionAutoFillElement();
            }
        },

        _selectSortRange: function (sheetIdx, activeCell) {
            var xlObj = this.XLObj, tableRange = xlObj.getSheet(sheetIdx).filterSettings.tableRange;
            for (var i = 0, len = tableRange.length; i < len; i++)
                if ((tableRange[i].multifilterIdx.indexOf(activeCell.colIndex) > -1) && (activeCell.rowIndex > tableRange[i].startRow - 1) && (activeCell.rowIndex < tableRange[i].endRow + 1))
                    return tableRange[i].startRow;
            xlObj.selectAll();
            return xlObj.getSheet(sheetIdx)._selectedCells[0].rowIndex;
        },

        sortByColor: function (operation, color, range) {
            var xlObj = this.XLObj;
            range = xlObj._getRangeArgs(range, "object");
            if (!xlObj.model.allowSorting || this._sortRangeAlert(range) || xlObj.model.isReadOnly)
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), sortObj = {oprType: operation}, startRowIndex, endRowIndex, sheet = xlObj.getSheet(sheetIdx), columnName;
            columnName = sheet.columns[range[1]].field;
            if (!ej.isNullOrUndefined(color)) {
                if (operation === "PutCellColor") {
                    if (color["background-color"])
                        color = color["background-color"];
                    sortObj.operation = "sortbgcolor";
                    sortObj.bgcolor = color;
                }
                else {
                    if (color["color"])
                        color = color["color"];
                    sortObj.operation = "sortfgcolor";
                    sortObj.fgcolor = color;
                }
                sortObj.requestType = sortObj.action = "sortbycolor";
                sortObj.sortColumn = columnName;
                sortObj.selRange = { startCell: { "rowIndex": range[0], "colIndex": range[1] }, endCell: { "rowIndex": range[2], "colIndex": range[3] } };
                sortObj.rangeData = xlObj.getRangeDataAsObject(sortObj.selRange.startCell, sortObj.selRange.endCell, true)[0];
				sortObj.sortRange = range;
                startRowIndex = range[0]; //this._getSortColorRange({ "rowIndex": range[0], "colIndex": range[1] });
                if (!ej.isNullOrUndefined(startRowIndex)) {
                    endRowIndex = xlObj.XLFilter._createSelection(sheetIdx, startRowIndex, range[2], range[1], []).endRowIndex;
                    startRowIndex = (operation === "PutCellColor" || operation === "PutFontColor") ? startRowIndex : startRowIndex;
                    sortObj.range = xlObj.model.sheets[sheetIdx]._selectedRange = { startRow: startRowIndex, endRow: endRowIndex, dataSourceIndexes: [] };
                    xlObj._processBindings(sortObj);
                }
            }
        },

        _getSortColorRange: function (activeCell) {
            var xlObj = this.XLObj, actElem = xlObj.getCell(activeCell.rowIndex, activeCell.colIndex), addSort = false, k, j;
            var startRowIndex = 0, prevText = false, rowIndex = activeCell.rowIndex, colIndex = activeCell.colIndex;
            if (actElem.text().length < 1) {
                //Active Element is Empty in the Top
                for (j = rowIndex; j < (rowIndex + 2) ; j++) {
                    actElem = xlObj.getCell(j, colIndex);
                    if (actElem.is(":visible") && actElem.text().length > 0) {
                        addSort = true;
                        startRowIndex = j;
                        break;
                    }
                }

                //Active Element is Empty in the Bottom
                if (!addSort) {
                    for (j = rowIndex; j > (rowIndex - 2); j--) {
						if (j > -1) {
							actElem = xlObj.getCell(j, colIndex);
							if (actElem.text().length === 0) {
								if (j > 0) {
									actElem = xlObj.getCell(j - 1, colIndex);
									actElem.text().length == 0 && (prevText = true);
								}
							}
						}
                    }
                    if (!prevText) {
                        for (j = rowIndex - 2; j > 0; j--) {
							actElem = xlObj.getCell(j, colIndex);
							if (actElem.is(":visible") && actElem.text().length === 0) {
								k = j + 1;
								addSort = true;
								startRowIndex = k;
								break;
							}
                        }
                    }
                }
            } else {
                //Active Element is Middle of the Column
                for (j = rowIndex; j >= 0; j--) {
                    actElem = xlObj.getCell(j, colIndex);
                    if (actElem.is(":visible") && actElem.text().length === 0) {
                        k = j + 1;
                        addSort = true;
                        startRowIndex = k;
                        break;
                    }
                    if (!addSort && j == 0) {
                        startRowIndex = j;
                        addSort = true;
                    }
                }
            }
            if (!addSort) {
                //display an alert message to select the cell which is having a value
                xlObj._showAlertDlg("Alert", "Alert", null, 630);
            } else
                return startRowIndex;
        },

		_sortRangeAlert: function(range){
			var xlObj = this.XLObj;
			var cKeys, mRange, sheetIdx = sheetIdx ? sheetIdx : xlObj.getActiveSheetIndex(), mergeObj, mCells = xlObj.getSheet(sheetIdx)._mergeColl, range = xlObj._getRangeArgs(range, "object"),
				rKeys = xlObj.getObjectKeys(mCells);
			for(var i = 0, rLen = rKeys.length; i < rLen; i++) {
				cKeys = xlObj.getObjectKeys(mCells[rKeys[i]]);
                for (var j = 0, jlen = cKeys.length; j < jlen; j++) {
                    mergeObj = xlObj._dataContainer.sheets[sheetIdx][rKeys[i]][cKeys[j]]["merge"];
					mRange = xlObj.getRangeIndices(mergeObj.mRange)
					if((range[0] <= mRange[0] && range[2] >= mRange[2]) || (range[0] >= mRange[0] && range[2] < mRange[2])) {
		                xlObj._showAlertDlg("Alert", "MergeSortAlert", '', 380);
						return true;
					}
				}
			}
			if(xlObj.XLEdit._rangeHasProperty(range, 'calcValue')){
				xlObj._showAlertDlg("Alert", "FormulaSortAlert", '', 315);
				return true;
			}
			return false;
		},
		
        sortByRange: function (range, columnName, direction, tableID) {
            var xlObj = this.XLObj;
            if(!xlObj.model.allowSorting || xlObj.model.isReadOnly)
				return;
            var len, sheetIdx = xlObj.getActiveSheetIndex(), i = 0, rangeData = [], args = {}, filterIcon = [], filterIcons,
                alpRange, fltrRng, colSelected = xlObj._getJSSheetHeader(sheetIdx).find(".e-colselected").length;
            if (!xlObj.model.allowSorting)
                return;
            range = xlObj._getRangeArgs(range, "object");
			if(this._sortRangeAlert(range))
				return true;
			if(this._isSortByFilter && colSelected < 1) {
				fltrRng = this._isSortByFilter ? range[0] - 1 : range[0];
				alpRange = xlObj._getAlphaRange(sheetIdx, fltrRng, range[1], fltrRng + 1, range[3]);
				filterIcons = xlObj._getAlphaRangeCells(alpRange).find(".e-filterspan");
				len = filterIcons.length;
				while (i < len) {
					filterIcon.push({ colIndex: filterIcons[i].parentNode.cellIndex, rowIndex: filterIcons.eq(i).parents("tr").index() });
					i++;
				}
				if(filterIcons.length)
					range[0] = this._isSortByFilter ? range[0] : range[0] + 1;
			}
			rangeData = xlObj.getRangeDataAsObject({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, true)[0];
			args.requestType = args.reqType = ej.Spreadsheet.Actions.Sorting;
            args.range = range;
            args.columnName = columnName;
            args.rangeData = rangeData;
            args.action = "sorting";
            args.sortDirection = direction;
            args.filterIcon = filterIcon;
			args.isSortByFilter = this._isSortByFilter;
			args.colSelected = colSelected;
            xlObj._processBindings(args);
			if(colSelected && this._isSortByFilter)
				xlObj.XLFilter._changeSortIcon({rowIndex: range[0] - 1, colIndex: range[1]}, direction);
			return false;
        },

        _sortComplete: function (args) {
            var i, xlObj = this.XLObj, range = args.range, data = this._swapSortedDatas(args), swappedData = data[1];
            xlObj._dupDetails = true;
            args.rangeData = data[0];
            if (xlObj.model.allowComments)
                xlObj.XLComment.deleteComment(range, null, true, "comment");
            xlObj._removeHyperlink(null, null, true, range);
            xlObj.clearRangeData(range, ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "comment", "hyperlink", "format"], null, true);
            if (xlObj.model.allowCellFormatting)
                xlObj.XLFormat.removeStyle(range, { cellStyle: true, tableStyle: true, format: true, skipHiddenRow: true });
            xlObj.XLEdit.updateCellWithContainer(swappedData, range, null, true);
            this._refreshRowHeight(range, swappedData);
            xlObj._dupDetails = false;
        },

        _refreshRowHeight: function (range, swappedData) {
            var rowIdx, idx, i = 0, j = 0, xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(), sheet = xlObj.getSheet(sheetIdx), trContent = xlObj._getJSSheetContent(sheetIdx).find(".e-content"), rHContent = xlObj._getJSSheetRowHeaderContent(sheetIdx);
            while (range[0] + i <= range[2]) {
                rowIdx = range[0] + i;
                idx = (i - j) * ((range[3] - range[1]) + 1); // first cell Idx in each row, excluding hidden row
                while (sheet.hideRowsCollection.indexOf(rowIdx) > -1 || sheet._hiddenFreezeRows.indexOf(rowIdx) > -1 && rowIdx < range[2])
                    rowIdx++ && i++ && j++;
				if(!xlObj.model.scrollSettings.allowVirtualScrolling && swappedData[idx]){
					trContent.find("tr:eq(" + rowIdx + ")").height(swappedData[idx].rheight);
					rHContent.find("tr:eq(" + rowIdx + ")").height(swappedData[idx].rheight);
				}
                if (swappedData[idx])
                    sheet.rowsHeightCollection[rowIdx] = swappedData[idx].rheight;
                i++;
            }
            xlObj.XLScroll._getRowHeights(sheetIdx, rowIdx);
			if(xlObj.model.scrollSettings.allowVirtualScrolling)
				xlObj.refreshContent(sheetIdx);
            if (sheet._isFreezed)
                xlObj.XLFreeze._refreshFreezeRowDiv();
        },

        _swapSortedDatas: function (args) {
            var text, idx, oIdx, j, rowIdx, i = 0, k = 0, l = 0, oldInst = [], total = [], arr = [], sheet = this.XLObj.getSheet(), viewData = args.model.currentViewData,
                vlen = viewData.length, colIdx = this.XLObj._generateColCount(args.columnName) - 1, olen,
                range = args.range, tCols = (range[3] - range[1]) + 1, ccIdx = colIdx - range[1],
                oldData = this.XLObj.getRangeData({ range: range, property: ["value", "value2", "type", "formatStr", "formats","decimalPlaces","thousandSeparator", "range", "format", "comment", "hyperlink", "rule"], skipHiddenRow: true });
            while (range[0] + k <= range[2]) {
                rowIdx = range[0] + k;
                idx = (k - l) * ((range[3] - range[1]) + 1);// first cell Idx in each row, excluding hidden row
                while ((sheet.hideRowsCollection.indexOf(rowIdx) > -1 || sheet._hiddenFreezeRows.indexOf(rowIdx) > -1) && rowIdx < range[2])
                    rowIdx++ && k++ && l++;
                if (oldData[idx])
                    oldData[idx].rheight = sheet.rowsHeightCollection[rowIdx];
                k++;
            }
            $.extend(true, oldInst, oldData);
			total.push(oldInst);
			while (i < vlen) {
                text = viewData[i][args.columnName];
                j = ccIdx;
                olen = oldData.length;
                while (j < olen) {
                    if (oldData[j].value === text) {
                        idx = this._getMinIdx(j, tCols);
						arr = arr.concat(oldData.splice(idx, tCols));
                        break;
                    }
                    j += tCols;
                }
                i++;
            }
			total.push(arr);
            return total;
        },

        _getMinIdx: function (ccIdx, tCols) {
            var i, j;
            i = j = tCols;
            if (ccIdx < tCols)
                return 0;
            while (i <= ccIdx) {
                j += tCols;
                if (j > ccIdx)
                    return i;
                i += tCols;
            }
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.dragAndDrop = function (obj) {
        this.XLObj = obj;
        this._isDragAndDropStart = false;
        this._dragAndDropCell = { rowIndex: 0, colIndex: 0 };
        this._isDragAndDropped = false;
        this._allowDragAndDrop = false;
		this._target = null;
        this._cellIdx = {};
    };

    ej.spreadsheetFeatures.dragAndDrop.prototype = {
        moveRangeTo: function (sourcerange, destinationrange) {
            this._moveRangeTo(sourcerange, destinationrange);
        },

        _moveRangeTo: function(sourcerange, destinationrange, property) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowDragAndDrop || xlObj.model.isReadOnly || !xlObj.model.allowEditing)
                return;
            var sheetIdx, sheet, data, details, format, dStartCell, dEndCell, tabDetails, sourcecformatrule, destinationcformatrule, trule, range, isTable,
                sourceRowHt = [], destRowHt = [], prevDestRowHt = [], isFilter;
            sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            sourcerange = xlObj.swapRange(xlObj._toIntrnlRange(sourcerange, sheetIdx));
            destinationrange = xlObj.swapRange(xlObj._toIntrnlRange(destinationrange, sheetIdx));
            destinationrange[2] = destinationrange[0] + (sourcerange[2] - sourcerange[0]);
            destinationrange[3] = destinationrange[1] + (sourcerange[3] - sourcerange[1]);
            dStartCell = { rowIndex: destinationrange[0], colIndex: destinationrange[1] };
            dEndCell = { rowIndex: destinationrange[2], colIndex: destinationrange[3] };
            data = xlObj.getRangeData({ range: sourcerange, property: property || ["value", "value2", "type", "formatStr", "decimalPlaces", "thousandSeparator", "range", "format", "border", "borders", "comment", "hyperlink", "picture", "cFormatRule", "rule", "chart", "isLocked", "wrap", "formats", "tformats", "tborders", "isFilterHeader", "filterState", "isFilterVisible", "tableName"] });
            if (xlObj.model.allowCellFormatting)
                format = xlObj.XLFormat.getHashCodeClassAsArray(sourcerange);
            if (xlObj.model.allowConditionalFormats)
                sourcecformatrule = xlObj.XLEdit.getPropertyValue(sourcerange[0], sourcerange[1], "cFormatRule");
            if (!xlObj.isUndefined(sourcecformatrule) && sourcecformatrule.length > 0) {
                trule = sourcecformatrule[0].split("_");
                sourcecformatrule = { action: trule[0], inputs: [trule[2], trule[3]], color: trule[4], range: trule[5] };
            }
            for (var i = sourcerange[0]; i <= sourcerange[2]; i++){
                sourceRowHt.push({ rowIndex: i, height: sheet.rowsHeightCollection[i] });
				for (var j = sourcerange[1]; j <= sourcerange[3]; j++)
					if (xlObj.XLEdit.getPropertyValue(i, j, 'wrap'))
						xlObj.setWrapText("unwrap", xlObj._getAlphaRange(sheetIdx, i, j, i, j));
			}
            details = {
                sheetIndex: sheetIdx,
                reqType: "reorder-cells",
                sourceData: $.extend(true, [], data),
                sourceRange: sourcerange,
                destinationRange: destinationrange,
                sourceFormat: format,
                destinationFormat: xlObj.model.allowCellFormatting && xlObj.XLFormat.getHashCodeClassAsArray(destinationrange),
                destinationData: xlObj.getRangeData({ range: destinationrange }),
                sourceCFormat: sourcecformatrule,
                sourceHeight: sourceRowHt
            };
            if (xlObj.XLRibbon._isDirtySelect) {
                xlObj._showAlertDlg("Alert", "DragAlert", null, 440);
                xlObj.performSelection(sourcerange);
                return;
            }
            else {
                isTable = xlObj._checkTableRange(xlObj._getAlphaRange(sheetIdx, sourcerange[0], sourcerange[1], sourcerange[2], sourcerange[3]));
                isFilter = xlObj._checkFilterRange(xlObj._getAlphaRange(sheetIdx, sourcerange[0], sourcerange[1], sourcerange[2], sourcerange[3]));
                xlObj._dupDetails = true;
                if (isTable.status === 'full') {
                    details.tblObj = isTable.tableObj;
                    details.tblObj.tblId = isTable.tblId;
                    details.tblObj.header = true;
                    xlObj.XLFormat.removeTable(isTable.tblId);
                    xlObj.XLFormat.removeStyle(isTable.range);
                }
                else if (isFilter.status === "full") {
                    details.tRange = isFilter.tRange;
                    xlObj.XLFilter.clearFilter("remove");
                }
                else if (isTable.status === 'partial' || isFilter.status === "partial" || xlObj.XLRibbon._isFilterSelect.isFiltered) {
                    xlObj._showAlertDlg("Alert", "DragAlert", null, 440);
                    xlObj.performSelection(sourcerange);
                    return;
                }
                if (xlObj.model.allowComments)
                    xlObj.XLComment.deleteComment();
                xlObj.clearRangeData(sourcerange, property || ["value2", "value", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink", "isFilterHeader", "filterState", "isFilterVisible", "tableName", "rule", "wrap", "comment"]);
                xlObj.clearRangeData(destinationrange, property || ["value2", "value", "type", "formatStr", "decimalPlaces", "thousandSeparator", "hyperlink", "rule", "wrap", "comment"]);
                if (!ej.isNullOrUndefined(xlObj._ddlCell)) {
                    xlObj.element.find("#" + xlObj._id + "ddl").ejDropDownList("hidePopup");
                    xlObj.element.find("#" + xlObj._id + "ddlspan").remove();
                    xlObj._ddlCell = null;
                }
                if (xlObj.model.allowCellFormatting && !xlObj.XLRibbon._isDirtySelect) {
                    xlObj.XLFormat.removeStyle(sourcerange);
                    xlObj.XLFormat.removeStyle(destinationrange, { cellStyle: true, format: true, border: true });
                }
                if (xlObj.model.allowConditionalFormats)
                    xlObj.XLCFormat.clearCF(sourcerange, true);
                data[0].cFormatRule = [];
                if (details.tblObj) {
                    details.tblObj.destrange = xlObj._getAlphaRange(sheetIdx, destinationrange[0], destinationrange[1], destinationrange[2], destinationrange[3]);
                    xlObj.XLClipboard._isCut = true;
                    xlObj.XLFormat.createTable(details.tblObj, details.tblObj.destrange);
                    xlObj.XLClipboard._isCut = false;
                }
                xlObj.updateData(data, destinationrange);
                if (isFilter.tRange) {
                    xlObj.XLFilter.filter(xlObj._getAlphaRange(sheetIdx, destinationrange[0], destinationrange[1], destinationrange[2], destinationrange[3]));
                    xlObj._dupDetails = false;
                }
                (details.tblObj && details.tblObj.totalRow) && xlObj.XLFormat._updateTotalRow(sheetIdx, details.tblObj.tblId, details.tblObj.fnNumber, destinationrange, false);
                if (xlObj.model.allowCellFormatting)
                    xlObj.XLFormat.updateFormat(format, destinationrange);
                if (xlObj.model.allowConditionalFormats && !xlObj.isUndefined(trule)) {
                    range = xlObj._getAlphaRange(1, destinationrange[0], destinationrange[1], destinationrange[2], destinationrange[3]);
                    destinationcformatrule = { action: trule[0], inputs: [trule[2], trule[3]], color: trule[4], range: range };
                    details.destinationCFormat = destinationcformatrule;
                    xlObj.XLCFormat.setCFRule(destinationcformatrule);
                }
                var k = 0;
                for (var i = destinationrange[0]; i <= destinationrange[2]; i++) {
                    prevDestRowHt.push({ rowIndex: i, height: sheet.rowsHeightCollection[i] })
                    destRowHt.push({ rowIndex: xlObj._getRowIdx(i), height: sourceRowHt[k].height });
                    k++;
					for (var j = destinationrange[1]; j <= destinationrange[3]; j++)
						if (xlObj.XLEdit.getPropertyValue(i, j, 'wrap')){
							xlObj.XLEdit._clearDataContainer({ cellIdx: {rowIndex: i, colIndex: j}, property: ['wrap']});
							xlObj.setWrapText("wrap", xlObj._getAlphaRange(sheetIdx, i, j, i, j));
						}
                }
                xlObj.setHeightToRows(destRowHt);
                details.destHeight = destRowHt;
                details.prevDestRowHt = prevDestRowHt;
                xlObj.setActiveCell(dStartCell.rowIndex, dStartCell.colIndex);
                if (xlObj.model.allowSelection) {
                    if (!dStartCell.rowIndex && dEndCell.rowIndex === sheet.rowCount - 1)
                        xlObj.XLSelection.selectColumns(dStartCell.colIndex, dEndCell.colIndex);
                    else if (!dStartCell.colIndex && dEndCell.colIndex === sheet.colCount - 1)
                        xlObj.XLSelection.selectRows(dStartCell.rowIndex, dEndCell.rowIndex);
                    else
                        xlObj.XLSelection.selectRange(dStartCell, dEndCell);
                    if (sheet._isFreezed)
                        xlObj.XLFreeze._refreshSelection();
                }
                xlObj._dupDetails = false;
                if (!xlObj._isUndoRedo && xlObj.XLFormat && !xlObj.XLFormat._isFAT) {
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            }
        },

        _dMouseHover: function (e) {
            var cellIdx, isLeft, isTop, isRight, isBottom, post, xy, x, y, target = e.target, xlObj = this.XLObj,
                sheetIdx = xlObj.getActiveSheetIndex(), range = xlObj.getSheet(sheetIdx).selectedRange;
            if (xlObj._hasClass(target, "e-rowcell"))
                cellIdx = xlObj._getCellIdx(target);
            if (cellIdx && xlObj.inRange(range, cellIdx.rowIndex, cellIdx.colIndex) && (cellIdx.rowIndex === range[0] || cellIdx.rowIndex === range[2] || cellIdx.colIndex === range[1] || cellIdx.colIndex === range[3]) && !xlObj._isTouchEvt) {
                post = e.target.getBoundingClientRect();
                xy = xlObj._setXY(e);
                x = xy[0];
                y = xy[1];
                isLeft = x - xlObj.getFocusLeftElem().offset().left;
                isLeft = isLeft >= 0 && isLeft <= 5;
                isTop = y - xlObj.getFocusTopElem()[0].getBoundingClientRect().top;
                isTop = isTop >= 0 && isTop <= 5;
                isRight = xlObj.getFocusRightElem().offset().left - x;
                isRight = isRight >= 0 && isRight <= 5;
                isBottom = xlObj.getFocusBottomElem()[0].getBoundingClientRect().top - y;
                isBottom = isBottom >= 0 && isBottom <= 5;
                if ((isLeft && x <= post.left + 5 && x >= post.left)/*left*/ || (isTop && y <= post.top + 5 && y >= post.top)/*top*/ || (isRight && x >= post.right - 5 && x <= post.right)/*right*/ || (isBottom && y >= post.bottom - 5 && y <= post.bottom)/*bottom*/) {
                    xlObj.addClass(target, 'e-cursormove');
                    this._isDragAndDropStart = true;
                    return;
                }
            }
            if (this._isDragAndDropStart && !xlObj._isTouchEvt) {
                xlObj._getContent(sheetIdx).find(".e-cursormove").removeClass("e-cursormove");
                this._isDragAndDropStart = false;
            }
        },

        _dragtouch: function (x, y) {
            var isLeft, isTop, isRight, isBottom, xlObj = this.XLObj;
            isLeft = x - xlObj.getFocusLeftElem().offset().left;
            isTop = y - xlObj.getFocusTopElem().offset().top;
            isRight = xlObj.getFocusRightElem().offset().left - x;
            isBottom = xlObj.getFocusBottomElem().offset().top - y;
            if (isLeft >= -10 && isLeft <= 10 || isTop >= -5 && isTop <= 0 || isRight >= -10 && isRight <= 10 || isBottom >= -5 && isBottom <= 0)
                this._isDragAndDropStart = true;
            else
                this._isDragAndDropStart = false;
        },

        _dMouseDown: function (e) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly || !xlObj.model.allowEditing)
                return;
            var range, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            e.preventDefault();
            e.stopImmediatePropagation();
            range = xlObj.swapRange([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex]);
            (e.target.nodeName === "TD") && (this._dragAndDropCell = xlObj._getCellIdx(e.target));
            xlObj._dStartCell = { rowIndex: range[0], colIndex: range[1] };
            xlObj._dEndCell = { rowIndex: range[2], colIndex: range[3] };
            if (xlObj._trigger('dragStart', { sheetIndex: sheetIdx, target: e.target, currentCell: this._dragAndDropCell, dragAndDropRange: { startCell: sheet._startCell, endCell: sheet._endCell } }))
                return;
            this._allowDragAndDrop = true;
        },

        _dMouseMove: function (e) {
            if (this._allowDragAndDrop) {
                var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), target = e.target, cellIdx = xlObj._getCellIdx(target), touchEnd;
                if (xlObj._isTouchEvt) {
                    touchEnd = xlObj._getOriginalEvt(e);
                    target = document.elementFromPoint(touchEnd.clientX, touchEnd.clientY);
                    if (target.parentNode && target.parentNode.attributes.getNamedItem("idx"))
                        cellIdx = xlObj._getCellIdx(target);
                }
                if (xlObj._trigger("drag", { sheetIndex: sheetIdx, target: target, currentCell: cellIdx, dragAndDropRange: { startCell: sheet._startCell, endCell: sheet._endCell } }))
                    return;
                if (xlObj._isFrozen(sheet.frozenRows) && this._isDragAndDropped && sheet._frozenRows - 1 < sheet._ftopRowIdx && sheet._startCell.rowIndex > sheet._frozenRows - 1 && cellIdx.rowIndex < sheet._frozenRows - 1)
                    cellIdx.rowIndex = sheet._ftopRowIdx;
                if (xlObj._isFrozen(sheet.frozenColumns) && this._isDragAndDropped && sheet._frozenColumns - 1 < sheet._fleftColIdx && sheet._startCell.colIndex > sheet._frozenColumns - 1 && cellIdx.colIndex < sheet._frozenColumns - 1)
                    cellIdx.colIndex = sheet._fleftColIdx;
                this._cellIdx = cellIdx;
                xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                this._updateDCells(cellIdx);
                if (sheet._isFreezed)
                    this._refreshFocusRange();
                else
                    xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
            }
            else if (!this.XLObj._isTouchEvt)
                this._dMouseHover(e);
        },
        
        _refreshFocusRange: function () {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(), eCIdx = xlObj._dEndCell.colIndex, eRIdx = xlObj._dEndCell.rowIndex, sCIdx = xlObj._dStartCell.colIndex, sRIdx = xlObj._dStartCell.rowIndex;
            if (sheet._frozenRows - 1 < sheet._ftopRowIdx) {
                if (sheet._startCell.rowIndex < sheet._frozenRows - 1) {
                    if (eRIdx >= sheet._frozenRows - 1) {
                        if (eRIdx < sheet._ftopRowIdx)
                            eRIdx = sheet._frozenRows - 2;
                        else if (eRIdx > sheet._ftopRowIdx && sRIdx < sheet._ftopRowIdx)
                            sRIdx = sheet._ftopRowIdx;
                    }
                }
                else
                    sRIdx = (sRIdx < sheet._ftopRowIdx && sRIdx > sheet._frozenRows - 1) ? sheet._ftopRowIdx : xlObj._dStartCell.rowIndex;
            }
            if (sheet._frozenColumns - 1 < sheet._fleftColIdx) {
                if (sheet._startCell.colIndex < sheet._frozenColumns - 1) {
                    if (eCIdx >= sheet._frozenColumns - 1) {
                        if (eCIdx < sheet._fleftColIdx)
                            eCIdx = sheet._frozenColumns - 2;
                        else if (eCIdx > sheet._fleftColIdx && sCIdx < sheet._fleftColIdx)
                            sCIdx = sheet._fleftColIdx;
                    }
                }
                else
                    sCIdx = (sCIdx < sheet._fleftColIdx && sCIdx > sheet._frozenColumns - 1) ? sheet._fleftColIdx : xlObj._dStartCell.colIndex;
            }
                xlObj.XLSelection._focusRange({ rowIndex: sRIdx, colIndex: sCIdx }, { rowIndex: eRIdx, colIndex: eCIdx }, xlObj._autofillBorder);
        },
        
        _dMouseUp: function (e) {
            if (this._isDragAndDropped) {
                var xlObj = this.XLObj, prfmDragDrop = true, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), vscroll = $("#vscrollBar").data('ejScrollBar'), hscroll = $("#hscrollBar").data('ejScrollBar'),
                    preventDrop = false, range = [xlObj._dStartCell.rowIndex, xlObj._dStartCell.colIndex, xlObj._dEndCell.rowIndex, xlObj._dEndCell.colIndex], startCell = { rowIndex: -1, colIndex: -1 },
                    args = { sheetIndex: sheetIdx, isAlert: false, target: e.target, currCell: this._dragAndDropCell, dragAndDropRange: { startCell: sheet._startCell, endCell: sheet._endCell } },
                    thinBorder = xlObj._arrayAsString(xlObj._thinBorder);
                if (xlObj.model.scrollSettings.allowScrolling && (xlObj._dEndCell.rowIndex > sheet.rowCount)) {
                    for (var i = 0, len = (xlObj._dEndCell.rowIndex - xlObj._dStartCell.rowIndex); i < len; i++){
                        xlObj.XLScroll._createNewRow(sheetIdx, -1, -1, "insert");
                    }
                    vscroll._scrollData.step = 1;
                    vscroll.scroll(sheet._scrollTop + ((xlObj._dEndCell.rowIndex - xlObj._dStartCell.rowIndex) * sheet.rowHeight));
                }
                if (xlObj._dEndCell.colIndex > sheet.colCount) {
                    for (var i = 0, len = (xlObj._dEndCell.colIndex - xlObj._dStartCell.colIndex) ; i < len; i++) {
                        xlObj.XLScroll._createNewColumn(sheetIdx, startCell, startCell, "insert");
                    }
                    hscroll._scrollData.step = 1;
                    hscroll.scroll(sheet._scrollLeft + ((xlObj._dEndCell.colIndex - xlObj._dStartCell.colIndex) * sheet.columnWidth));
                }
                this._target = e.target;
                if (xlObj._isUniqueRange(sheet.selectedRange, xlObj.swapRange(range)))
                    this._preventDrop(sheet);
                else {
                    if (xlObj.model.allowLockCell && sheet.isSheetProtected) {
                        if (xlObj._isPropExists([range, sheet.selectedRange], "isLocked", sheetIdx))
                            prfmDragDrop = false;
                    }
                    if (prfmDragDrop && xlObj._isPropExists([range, sheet.selectedRange], "isReadOnly", sheetIdx))
                        prfmDragDrop = false;
                    if (!prfmDragDrop) {
                        this._preventDrop(sheet);
                        xlObj.XLSelection._clearBorder(thinBorder);
                        this._allowDragAndDrop = this._isDragAndDropStart = this._isDragAndDropped = false;
                        return;
                    }
                    preventDrop = xlObj._trigger("beforeDrop", args);
                    if (!args.isAlert && !preventDrop && xlObj._rangeHasData(range))
                        xlObj._showAlertDlg("", "DropAlert", "Drop", 498);
                    else if (!xlObj._rangeHasData(range)) {
                        this.moveRangeTo([sheet._startCell.rowIndex, sheet._startCell.colIndex, sheet._endCell.rowIndex, sheet._endCell.colIndex], [xlObj._dStartCell.rowIndex, xlObj._dStartCell.colIndex, xlObj._dEndCell.rowIndex, xlObj._dEndCell.colIndex]);
                        sheet._startCell = xlObj._dStartCell;
                        sheet._endCell = xlObj._dEndCell;
                        if (sheet._isFreezed)
                            xlObj.XLFreeze._refreshSelection();
                    }
                    else
                        this._preventDrop(sheet);
                }
                xlObj.XLSelection._clearBorder(thinBorder);
                if (xlObj.model.allowAutoFill)                    
					xlObj.XLDragFill.positionAutoFillElement();            
			}
            this._allowDragAndDrop = this._isDragAndDropStart = this._isDragAndDropped = false;
        },
        _scrollHover: function (e) {
            var pix, interval, trgtIdx, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), dColIdx = this._cellIdx.colIndex, dRowIdx = this._cellIdx.rowIndex,
                scrollObj = xlObj.XLScroll, vScroll = scrollObj._vScroller(sheetIdx), hScroll = scrollObj._hScroller(sheetIdx);
            if ($(e.target).parents('.e-vscrollbar').length > 0) {
                interval = setInterval(function () {
                    pix = sheet._scrollLeft + (xlObj._isFrozen(sheet.frozenColumns) ? sheet.columnsWidthCollection[sheet._fleftColIdx] : sheet.columnWidth);
                    hScroll._scrollData.step = 1;
                    hScroll.scroll(pix);
                    xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                    xlObj.XLDragDrop._updateDCells({ rowIndex: dRowIdx, colIndex: sheet._rightCol.idx - 1 });
                    xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
                    return;
                }, 200);
            }
            else if (e.target.className.indexOf('e-rowheader') > -1) {
                interval = setInterval(function () {
                    pix = sheet._scrollLeft - sheet.columnWidth;
                    hScroll._scrollData.step = -1;
                    if (pix > -1)
                        hScroll.scroll(pix);
                    else
                        hScroll.scroll(0);
                        xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                        xlObj.XLDragDrop._updateDCells({ rowIndex: dRowIdx, colIndex: sheet._leftCol.idx });
                        xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
                    return;
                }, 200);
            }
            else if ($(e.target).parents('.e-spreadsheetfooter').length > 0 || e.target.className.indexOf('e-spreadsheetfooter') > -1 || $(e.target).parents('.e-hscrollbar').length > 0) {
                interval = setInterval(function () {
                    if (xlObj.model.scrollSettings.allowVirtualScrolling)
                        sheet._isVirtualEndReached ? vScroll.scroll(sheet._scrollTop) : vScroll.scroll(sheet._scrollTop + (xlObj._isFrozen(sheet.frozenRows) ? sheet.rowsHeightCollection[sheet._ftopRowIdx] : sheet.rowHeight));
                    else {
                        vScroll._scrollData.step = 1;
                        vScroll.scroll(sheet._scrollTop + (xlObj._isFrozen(sheet.frozenRows) ? sheet.rowsHeightCollection[sheet._ftopRowIdx] : sheet.rowHeight));
                    }
                    xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                    xlObj.XLDragDrop._updateDCells({ rowIndex: sheet._bottomRow.idx - 1, colIndex: dColIdx });
                    xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
                    return;
                }, 200);
            }
            else if (e.target.className.indexOf('e-headercell') > -1) {
                interval = setInterval(function () {
                    pix = sheet._scrollTop - sheet.rowHeight;
                    vScroll._scrollData.step = -1;
                    (pix > -1) ? vScroll.scroll(pix): vScroll.scroll(0);
                    xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                    xlObj.XLDragDrop._updateDCells({ rowIndex: sheet._topRow.idx, colIndex: dColIdx });
                    xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
                    return;
                }, 200);
            }
            else if (e.target.className.indexOf("e-rowcell") > -1) {
                trgtIdx = xlObj._getCellIdx(e.target);
                if ((xlObj._isFrozen(sheet.frozenRows) && trgtIdx.rowIndex < sheet._frozenRows - 1) && sheet._startCell.rowIndex >= sheet._frozenRows - 1) {
                    interval = setInterval(function () {
                        if (xlObj._dStartCell.rowIndex > sheet._ftopRowIdx || !xlObj.XLDragDrop._isDragAndDropped || sheet._frozenRows - 1 === sheet._ftopRowIdx) {
                            if (xlObj._dStartCell.colIndex > sheet._fleftColIdx || !xlObj.XLDragDrop._isDragAndDropped || sheet._frozenColumns - 1 === sheet._fleftColIdx)
                                clearInterval(interval);
                            return;
                        }
                        pix = sheet._scrollTop - sheet.rowHeight;
                        vScroll._scrollData.step = -1;
                        (pix > -1) ? vScroll.scroll(pix) : vScroll.scroll(0);
                        xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                        xlObj.XLDragDrop._updateDCells({ rowIndex: sheet._ftopRowIdx, colIndex: xlObj.XLDragDrop._cellIdx.colIndex });
                        xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
                        xlObj.XLDragDrop._refreshFocusRange();
                        return;
                    }, 200);
                }
                if ((xlObj._isFrozen(sheet.frozenColumns) && trgtIdx.colIndex < sheet._frozenColumns - 1) && sheet._startCell.colIndex >= sheet._frozenColumns - 1) {
                    interval = setInterval(function () {
                        if (xlObj._dStartCell.colIndex > sheet._fleftColIdx || !xlObj.XLDragDrop._isDragAndDropped || sheet._frozenColumns - 1 === sheet._fleftColIdx) {
                            if (xlObj._dStartCell.rowIndex > sheet._ftopRowIdx || !xlObj.XLDragDrop._isDragAndDropped || sheet._frozenRows - 1 === sheet._ftopRowIdx)
                                clearInterval(interval);
                            return;
                        }
                        pix = sheet._scrollLeft - sheet.columnWidth;
                        hScroll._scrollData.step = -1;
                        (pix > -1) ? hScroll.scroll(pix) : hScroll.scroll(0);
                        xlObj.XLSelection._focusBorder(sheet._startCell, sheet._endCell, xlObj._thinBorder);
                        xlObj.XLDragDrop._updateDCells({ rowIndex: xlObj.XLDragDrop._cellIdx.rowIndex, colIndex: sheet._fleftColIdx });
                        xlObj.XLSelection._focusRange(xlObj._dStartCell, xlObj._dEndCell, xlObj._autofillBorder);
                        xlObj.XLDragDrop._refreshFocusRange();
                        return;
                    }, 200);
                }
            }
            if (xlObj._browserDetails.name === "msie" && xlObj._browserDetails.version === "8.0") {
                e.target.attachEvent("onmouseleave", function () {
                    clearInterval(interval);
                    return;
                });
                document.attachEvent("onmouseleave", function () {
                    clearInterval(interval);
                    return;
                });
                e.target.attachEvent("onmouseup", function () {
                    clearInterval(interval);
                    return;
                });
            }
            else {
            e.target.addEventListener("mouseleave", function () {
                clearInterval(interval);
                return;
            });
            document.addEventListener("mouseleave", function () {
                clearInterval(interval);
                return;
            });
            e.target.addEventListener("mouseup", function () {
                clearInterval(interval);
                xlObj.XLDragDrop._dMouseUp(e);
                return;
                });
            }
        },
        _preventDrop: function (sheet) {
            var xlObj = this.XLObj;
            xlObj.XLSelection._focusRange(sheet._startCell, sheet._endCell, xlObj._selectionBorder);
            xlObj._dStartCell = sheet._startCell;
            xlObj._dEndCell = sheet._endCell;
        },

        _updateDCells: function (cellIdx) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx),
                isRange = xlObj.isRange(sheet.selectedRange);
            if (!(sheet._isColSelected && xlObj.inRange(sheet.selectedRange, 0, sheet._startCell.colIndex))) {
                if (cellIdx.rowIndex < this._dragAndDropCell.rowIndex && xlObj._dStartCell.rowIndex) {
                    xlObj._dStartCell.rowIndex = xlObj._dStartCell.rowIndex - (this._dragAndDropCell.rowIndex - cellIdx.rowIndex);
                    xlObj._dEndCell.rowIndex = isRange ? xlObj._dEndCell.rowIndex - (this._dragAndDropCell.rowIndex - cellIdx.rowIndex) : xlObj._dStartCell.rowIndex;
                }
                else if (cellIdx.rowIndex > this._dragAndDropCell.rowIndex) {
                    xlObj._dStartCell.rowIndex = xlObj._dStartCell.rowIndex + (cellIdx.rowIndex - this._dragAndDropCell.rowIndex);
                    xlObj._dEndCell.rowIndex = isRange ? xlObj._dEndCell.rowIndex + (cellIdx.rowIndex - this._dragAndDropCell.rowIndex) : xlObj._dStartCell.rowIndex;
                }
            }
            if (!(sheet._isRowSelected && xlObj.inRange(sheet.selectedRange, sheet._startCell.rowIndex, 0))) {
                if (cellIdx.colIndex < this._dragAndDropCell.colIndex && xlObj._dStartCell.colIndex) {
                    xlObj._dStartCell.colIndex = xlObj._dStartCell.colIndex - (this._dragAndDropCell.colIndex - cellIdx.colIndex);
                    xlObj._dEndCell.colIndex = isRange ? xlObj._dEndCell.colIndex - (this._dragAndDropCell.colIndex - cellIdx.colIndex) : xlObj._dStartCell.colIndex;
                }
                else if (cellIdx.colIndex > this._dragAndDropCell.colIndex) {
                    xlObj._dStartCell.colIndex = xlObj._dStartCell.colIndex + (cellIdx.colIndex - this._dragAndDropCell.colIndex);
                    xlObj._dEndCell.colIndex = isRange ? xlObj._dEndCell.colIndex + (cellIdx.colIndex - this._dragAndDropCell.colIndex) : xlObj._dStartCell.colIndex;
                }
            }
            this._dragAndDropCell = cellIdx;
            this._isDragAndDropped = true;
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.exporting = function (obj) {
        this.XLObj = obj;
    };

    ej.spreadsheetFeatures.exporting.prototype = {
        //Exporting        
        "export": function (type) {
            var xlObj = this.XLObj;
            if (!xlObj.model.exportSettings.allowExporting || xlObj.model.isReadOnly)
                return;
            xlObj._isExport = true;
            this._renderAll();
            xlObj._isExport = false;
            var expSettings = xlObj.model.exportSettings, attr, form, inputAttr, input, url, expObj, serverEvent, args, clientArgs, evtArgs, param;
            if (type === ej.Spreadsheet.exportType.Excel) 
                url = expSettings.excelUrl;
            else if (type === ej.Spreadsheet.exportType.Csv) 
                url = expSettings.csvUrl;
            else 
                url = expSettings.pdfUrl;
            expObj = this.getExportProps();
            evtArgs = { exportType: type, url: url, customParams: {} };
            serverEvent = ej.raiseWebFormsServerEvents ? type.toLowerCase() + "Exporting" : "";
            if (ej.raiseWebFormsServerEvents && xlObj.model.serverEvents && xlObj.model.serverEvents.indexOf(serverEvent) > -1) {
                args = { model: $.extend(true, {}, xlObj.model), originalEventType: serverEvent };
                clientArgs = { sheetModel: expObj.model, sheetData: expObj.data, password: expSettings.password ? xlObj._encrypt(expSettings.password) : "" };
                if (xlObj._trigger("onExport", evtArgs))
                    return;
                if (xlObj.getObjectLength(evtArgs.customParams))
                    $.extend(clientArgs, evtArgs.customParams)
                ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
                setTimeout(function () {
                    ej.isOnWebForms = true;
                }, 1000);
            }
            else {
                if (ej.isNullOrUndefined(url)) {
                    xlObj._showAlertDlg("Alert", "ImportExportUrl", "", 266);
                    return;
                }
                if (!expSettings.allowExporting || xlObj.isUndefined(url))
                    return;
                if (xlObj._trigger("onExport", evtArgs))
                    return;
                url = evtArgs.url;
                attr = { action: url, method: "post" };
                form = ej.buildTag("form", "", null, attr);
                inputAttr = { name: "sheetData", type: "hidden", value: expObj.data };
                input = ej.buildTag("input", "", null, inputAttr);
                form.append(input);
                inputAttr = { name: "sheetModel", type: "hidden", value: expObj.model };
                input = ej.buildTag("input", "", null, inputAttr);
                form.append(input);
                inputAttr = { name: "Password", type: "hidden", value: xlObj._encrypt(expSettings.password) };
                input = ej.buildTag("input", "", null, inputAttr);
                form.append(input);
                for (param in evtArgs.customParams) {
                    inputAttr = { name: param, type: "hidden", value: evtArgs.customParams[param] };
                    input = ej.buildTag("input", "", null, inputAttr);
                    form.append(input);
                }  
                $("body").append(form);
                form.submit();
            }
        },
       
        _dropElements: function (model) {
            var actSheet = model.sheets, arr = ["_spreadSheetPager", "dataSource", "rangeSettings"], i, j, content;
            model.undoCollection = [];
            for (i in actSheet) {
                content = actSheet[i];
                for (j in content) {
                    if (arr.indexOf(j) > -1)
                        content[j] = null;
                }
            }
            return model;
        },
         
         _getRequriedProp: function (model) {
            var xlObj = this.XLObj, modelClone = {}, i, j, len, arr = ["sheetCount", "activeSheetIndex", "nameManager"], content, actSheet, cloneSheet;
            for (i = 0, len = arr.length; i < len; i++) {
                modelClone[arr[i]] = model[arr[i]];
            }         
            if (xlObj.model.allowCellFormatting && xlObj.getObjectLength(xlObj.XLFormat._customFontFamily) > 0)
                modelClone["customFontFamily"] = xlObj.XLFormat._customFontFamily;
            actSheet = model.sheets;
            modelClone["sheets"] = [];
            arr = ["_activeCell", "_endCell", "_startCell", "colCount", "columnsWidthCollection", "rowsHeightCollection", "rowCount", "frozenColumns", "frozenRows", "usedRange", "dataAttribute", "filterSettings", "tableManager", "sheetInfo", "hideColsCollection", "hideRowsCollection", "showGridlines", "showHeadings", "isSheetProtected", "shapeMngr", "chart", "pivotMngr", "topLeftCell", "paneTopLeftCell"];
            for (i in actSheet) {
                modelClone["sheets"][i] = {};
                cloneSheet = modelClone["sheets"][i];
                content = actSheet[i];
                for (j = 0, len = arr.length; j < len; j++) {
                    cloneSheet[arr[j]] = content[arr[j]];
                }
            }           
            return modelClone;
        },
        getExportProps: function () {
            var xlObj = this.XLObj, i, j, k, len, slen, chartObj, modelClone, series, contClone = $.extend(true, {}, xlObj._dataContainer), model = {}, objKeys=[];		
            var key, pivot, chart = {}, range;
            xlObj._refreshHashCode(contClone.hashCode);
            model = JSON.parse(JSON.stringify(xlObj.model));    
            for (i = 1; i < model.sheets.length; i++) { 
                chart = {};
                pivot = {};
                $.extend(true, chart, model.sheets[i].shapeMngr.chart);
                objKeys = xlObj.getObjectKeys(chart);
                model.sheets[i].shapeMngr.chart = {};           
                for (j = 0, len = objKeys.length; j < len; j++) {
					key = chart[objKeys[j]].id;
                    chartObj = $("#" + key).data("ejChart");
                    if (chartObj) {						
                        chartObj.model.event = null;
                        modelClone = JSON.parse(JSON.stringify(chartObj.model));                      
                        series = modelClone.series;
                        for (k = 0, slen = series.length; k < slen; k++) {
                            delete series[k].dataSource;
                            delete series[k].query;
                            series[k].fill = jQuery.type(series[k].fill) == "array" ? series[k].fill[0].color : series[k].fill;
                        }
                        model.sheets[i].shapeMngr.chart[key]=modelClone;
						range=chart[key]["range"];						
						model.sheets[i].shapeMngr.chart[key]["range"]=xlObj._generateHeaderText(range[1] + 1) + (range[0] + 1) + ":" + xlObj._generateHeaderText(range[3] + 1) + (range[2] + 1);
						model.sheets[i].shapeMngr.chart[key]["top"]=chart[key]["top"];
						model.sheets[i].shapeMngr.chart[key]["left"]=chart[key]["left"];
						model.sheets[i].shapeMngr.chart[key]["height"]=chart[key]["height"];
						model.sheets[i].shapeMngr.chart[key]["width"]=chart[key]["width"];
                    }
                }               
                objKeys = xlObj.getObjectKeys(model.sheets[i].pivotMngr.pivot);
                for (j = 0, len = objKeys.length; j < len; j++) {
                    key = objKeys[j];
                    pivotObj = $("#" + key).data("ejPivotGrid");
                    if (pivotObj) {
                        model.sheets[i].pivotMngr.pivot[key]["rows"] = pivotObj.getOlapReport().rows;
                        model.sheets[i].pivotMngr.pivot[key]["columns"] = pivotObj.getOlapReport().columns;
                        model.sheets[i].pivotMngr.pivot[key]["filters"] = pivotObj.getOlapReport().filters;
                        model.sheets[i].pivotMngr.pivot[key]["values"] = pivotObj.getOlapReport().values;
                    }
                }
            }
            model.sheets.shift();         
            return { model: JSON.stringify(this._getRequriedProp(model)), data: JSON.stringify(contClone) };
        },

        _renderAll: function () {
            var i, j, sheet, range, xlObj = this.XLObj, sheets = xlObj.getSheets(), actSheetIdx = xlObj.getActiveSheetIndex();
            for (i = 1; i < sheets.length; i++) {
                sheet = sheets[i];
                if (xlObj.model.importSettings.allowSheetOnDemand && sheet._isImported && !sheet._isRequested)
                    xlObj._importSheet(i, false);
                if (!sheet._isLoaded)
                    xlObj.gotoPage(i);
                if (xlObj.model.scrollSettings.allowVirtualScrolling && !sheet._isImported && sheet._hasDataSrc) {
                    for (j = 1; j <= sheet._virtualBlockCnt; j++) {
                        if (sheet._virtualDataLoadedBlks.indexOf(j) === -1) {
                            sheet._virtualDataLoadedBlks.push(j);
                            range = this._getRange(j, i);
                            xlObj._refreshDataSrc(range, i);
                            xlObj._refreshCellData(range, i);
                        }
                    }
                }
            }
            xlObj.hideWaitingPopUp();
            xlObj.gotoPage(actSheetIdx);
        },

        _getRange: function (i, sheetIdx) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), range = [0, 0, 0, sheet.colCount - 1];
            range[0] = (sheet._virtualBlockRowCnt * (i - 1));
            range[2] = (sheet._virtualBlockRowCnt * i) - 1;
            return range;
        }
        
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.findnreplace = function (obj) {
        this.XLObj = obj;
        this._findCount = 0;
        this._isApplied = false;
        this.caseSen = {
            "true": function (a) { return a.toString(); },
            "false": function (a) { return a.toString().toLowerCase(); }
        };
        this.isEMatch = {
            "true": function (a, b) {
                return a == b;
            },
            "false": function (a, b) {
                if (a.length && !b.length)
                    return;
                return a.indexOf(b) > -1;
            }
        };
    };

    ej.spreadsheetFeatures.findnreplace.prototype = {
        //Find and Replace       

        replaceAllBySheet: function (findData, replaceData, isCSen, isEMatch) {
			if (!this.XLObj.model.allowSearching || !this.XLObj.model.allowEditing || this.XLObj.model.isReadOnly)
                return;
            this._replaceAllData(findData, replaceData, isCSen, isEMatch, "value", "sheet");
        },

        replaceAllByBook: function (findData, replaceData, isCSen, isEMatch) {
			if (!this.XLObj.model.allowSearching || !this.XLObj.model.allowEditing || this.XLObj.model.isReadOnly)
                return;
            this._replaceAllData(findData, replaceData, isCSen, isEMatch, "value", "workbook");
        },

        findNext: function (value, options, sIndex) {
			ej.isNullOrUndefined(sIndex) && (sIndex = this.XLObj.getActiveSheetIndex());
            this._findNext(value, sIndex, options.isCSen, options.isEMatch, options.type, options.mode, options.searchBy);
        },

        findPrevious: function (value, options, sIndex) {
			ej.isNullOrUndefined(sIndex) && (sIndex = this.XLObj.getActiveSheetIndex());
            this._findPrev(value, sIndex, options.isCSen, options.isEMatch, options.type, options.mode, options.searchBy);
        },

        _findNext: function (input, sIndex, isCSen, isEMatch, type, mode, searchBy) {
            var i, j, s, k, tmp, selCells, cell, rowIdx, usedRange, len, rfrshcIdx, rfrshrIdx, colIdx, rowCount, colCount, evtArgs,
                matched, tmpSIndex, isFinded, fRange = [], searchRows = searchBy === "rows",
                xlObj = this.XLObj, isFindSelected = false, sheetIdx = sIndex ? sIndex : xlObj.getActiveSheetIndex(),
                actSheet = xlObj.getSheet(sheetIdx), actCell = actSheet._activeCell, args = {
                    sheetIndex: sIndex,
                    value: input,
                    isCaseSensitive: isCSen,
                    isEntireMatch: isEMatch,
                    searchBy: searchBy,
                    mode: mode,
                    findType: type,
                    reqType: "findNext"
                };
            evtArgs = { sheetIndex: args.sheetIndex, value: args.value, isCaseSensitive: args.isCaseSensitive, isEntireMatch: args.isEntireMatch, searchBy: args.searchBy, mode: args.mode, findType: args.findType, reqType: args.reqType };
            if (!xlObj._intrnlReq && xlObj._trigActionBegin(evtArgs))
                return true;
            if (xlObj.model.allowEditing && xlObj.XLEdit._isEdit)
                xlObj.XLEdit.saveCell();
            input = args.value;
            sIndex = args.sheetIndex;
            isCSen = args.isCaseSensitive;
            isEMatch = args.isEntireMatch;
            type = args.findType; mode = args.mode;
            searchBy = args.searchBy;
            selCells = actSheet._selectedCells;
            len = selCells.length;
            usedRange = actSheet.usedRange;
            if (len === 1 || mode === "workbook")
                fRange = [actCell.rowIndex, actCell.colIndex, usedRange.rowIndex + 1, usedRange.colIndex + 1];
            else {
                isFindSelected = true;
                cell = selCells[len - 1];
                fRange = [actCell.rowIndex, actCell.colIndex, cell.rowIndex + 1, cell.colIndex + 1];
            }
            rowIdx = fRange[0], colIdx = fRange[1], rowCount = fRange[2], colCount = fRange[3];
            if (!searchRows) {
                tmp = rowIdx;
                rowIdx = colIdx;
                colIdx = tmp;
                tmp = rowCount;
                rowCount = colCount;
                colCount = tmp;
            }
            if (mode === "sheet") {
                for (i = rowIdx; i < rowCount; i++) {
                    if (i !== rowIdx) {
                        cell = selCells[0];
                        colIdx = isFindSelected ? (searchRows ? cell.colIndex : cell.rowIndex) : 0;
                    }
                    for (j = colIdx; j < colCount; j++) {
                        matched = this._compareValues(searchRows ? i : j, searchRows ? j : i, sheetIdx, input, isCSen, isEMatch, type);
                        if (matched) {
                            if (!(i === rowIdx && j === colIdx)) {
                                this._updateSelection(searchRows ? i : j, searchRows ? j : i);
                                this._findCount++;
                                args = { reqType: "findNext", activeCell: xlObj.getActiveCellElem() };
                                if (xlObj._trigActionComplete(args))
                                    return;
                                return true;
                            }
                        }
                    }
                }
            }
            else {
                for (s = sheetIdx, k = xlObj.model.sheetCount; s <= k; s++) {
                    usedRange = xlObj.model.sheets[s].usedRange;
                    if (s !== sheetIdx) {
                        colIdx = 0;
                        rowIdx = 0;
                        rowCount = searchRows ? usedRange.rowIndex : usedRange.colIndex;
                        colCount = searchRows ? usedRange.colIndex : usedRange.rowIndex;
                    }
                    for (i = rowIdx; i < rowCount + 1; i++) {
                        if (i !== rowIdx)
                            colIdx = 0;
                        for (j = colIdx; j < colCount + 1; j++) {
                            matched = this._compareValues(searchRows ? i : j, searchRows ? j : i, s, input, isCSen, isEMatch, type);
                            if (matched) {
                                if (!(s === sheetIdx && i === rowIdx && j === colIdx)) {
                                    this._updateSelection(searchRows ? i : j, searchRows ? j : i, s);
                                    this._findCount++;
                                    xlObj._intrnlReq = false;
                                    args = { reqType: "findNext", activeCell: xlObj.getActiveCellElem() };
                                    if (xlObj._trigActionComplete(args))
                                        return;
                                    return true;
                                }
                            }
                        }
                    }
                }
            }
            if (!this._findCount) {
                rfrshcIdx = 0, rfrshrIdx = 0;
                tmpSIndex = (mode === "sheet") ? sheetIdx : 1;
                if (isFindSelected) {
                    cell = selCells[0];
                    rfrshrIdx = selCells[0].rowIndex, rfrshcIdx = selCells[0].colIndex;
                }
                this._updateSelection(rfrshrIdx, rfrshcIdx, tmpSIndex);
                this._findCount++;
                if (this._compareValues(rfrshrIdx, rfrshcIdx, tmpSIndex, input, isCSen, isEMatch, type))
                    return true;
                else {
                    xlObj._intrnlReq = true;
                    isFinded = this._findNext(input, tmpSIndex, isCSen, isEMatch, type, mode, searchBy);
                    return isFinded;
                }

            }
            return false;
        },

        _findPrev: function (input, sIndex, isCSen, isEMatch, type, mode, searchBy) {
            var i, j, s, matched, tmpSIndex, isFinded, cell, selCells, len, rfrshcIdx, rfrshrIdx, rowIdx, colIdx, rowCount, evtArgs,
                colCount, isFindSelected = false, fRange = [], tmpRIdx = 0, tmpCIdx = 0, searchRows = searchBy === "rows", tmp,
                xlObj = this.XLObj, sheetIdx = sIndex ? sIndex : xlObj.getActiveSheetIndex(),
                actSheet = xlObj.getSheet(sheetIdx), usedRange = actSheet.usedRange,
                actCell = actSheet._activeCell, args = {
                    sheetIndex: sIndex,
                    value: input,
                    isCaseSensitive: isCSen,
                    isEntireMatch: isEMatch,
                    searchBy: searchBy,
                    mode: mode,
                    findType: type,
                    reqType: "findPrevious"
                };
            evtArgs = { sheetIndex: args.sheetIndex, value: args.value, isCaseSensitive: args.isCaseSensitive, isEntireMatch: args.isEntireMatch, searchBy: args.searchBy, mode: args.mode, findType: args.findType, reqType: args.reqType };
            if (xlObj._trigActionBegin(evtArgs))
                return true;
            if (xlObj.model.allowEditing && xlObj.XLEdit._isEdit)
                xlObj.XLEdit.saveCell();
            input = args.value;
            sIndex = args.sheetIndex;
            isCSen = args.isCaseSensitive;
            isEMatch = args.isEntireMatch;
            type = args.findType;
            mode = args.mode;
            searchBy = args.searchBy;
            selCells = actSheet._selectedCells;
            len = selCells.length;
            if (len === 1 || mode === "workbook")
                fRange = [actCell.rowIndex, actCell.colIndex, usedRange.rowIndex + 1, usedRange.colIndex + 1];
            else {
                cell = selCells[len - 1];
                fRange = [actCell.rowIndex, actCell.colIndex, cell.rowIndex, cell.colIndex];
                isFindSelected = true;
            }
            rowIdx = fRange[0], colIdx = fRange[1], rowCount = fRange[2], colCount = fRange[3];
            if (!searchRows) {
                tmp = rowIdx;
                rowIdx = colIdx;
                colIdx = tmp;
                tmp = rowCount;
                rowCount = colCount;
                colCount = tmp;
            }
            if (mode === "sheet") {
                if (isFindSelected) {
                    cell = selCells[0];
                    tmpRIdx = searchRows ? cell.rowIndex : cell.colIndex, tmpCIdx = searchRows ? cell.colIndex : cell.rowIndex;
                }
                for (i = rowIdx; i >= tmpRIdx; i--) {
                    if (i !== rowIdx)
                        colIdx = colCount;
                    for (j = colIdx; j >= tmpCIdx; j--) {
                        matched = this._compareValues(searchRows ? i : j, searchRows ? j : i, sheetIdx, input, isCSen, isEMatch, type);
                        if (matched) {
                            if (!(i === rowIdx && j === colIdx)) {
                                this._updateSelection(searchRows ? i : j, searchRows ? j : i);
                                this._findCount++;
                                args = { reqType: "findPrevious", activeCell: xlObj.getActiveCellElem() };
                                if (xlObj._trigActionComplete(args))
                                    return;
                                return true;
                            }
                        }
                    }
                }
            }
            else {
                for (s = sheetIdx; s >= 1; s--) {
                    usedRange = xlObj.model.sheets[s].usedRange;
                    if (s !== sheetIdx) {
                        rowCount = searchRows ? usedRange.rowIndex : usedRange.colIndex;
                        colCount = searchRows ? usedRange.colIndex : usedRange.rowIndex;
                        colIdx = colCount;
                        rowIdx = rowCount;
                    }
                    for (i = rowIdx; i >= 0; i--) {
                        if (i !== rowIdx)
                            colIdx = colCount + 1;
                        for (j = colIdx; j >= 0; j--) {
                            matched = this._compareValues(searchRows ? i : j, searchRows ? j : i, s, input, isCSen, isEMatch, type);
                            if (matched) {
                                if (!(s === sheetIdx && i === rowIdx && j === colIdx)) {
                                    this._updateSelection(searchRows ? i : j, searchRows ? j : i, s);
                                    this._findCount++;
                                    args = { reqType: "findPrevious", activeCell: xlObj.getActiveCellElem() };
                                    if (xlObj._trigActionComplete(args))
                                        return;
                                    return true;
                                }
                            }
                        }
                    }
                }
            }
            if (!this._findCount) {
                tmpSIndex = (mode === "sheet") ? sheetIdx : xlObj.model.sheetCount;
                rfrshrIdx = xlObj.model.sheets[tmpSIndex].usedRange.rowIndex, rfrshcIdx = xlObj.model.sheets[tmpSIndex].usedRange.colIndex;
                if (isFindSelected) {
                    cell = selCells[len - 1];
                    rfrshrIdx = cell.rowIndex, rfrshcIdx = cell.colIndex;
                }
                this._updateSelection(rfrshrIdx, rfrshcIdx, tmpSIndex);
                this._findCount++;
                if (this._compareValues(rfrshrIdx, rfrshcIdx, tmpSIndex, input, isCSen, isEMatch, type))
                    return true;
                else {
                    isFinded = this._findPrev(input, tmpSIndex, isCSen, isEMatch, type, mode, searchBy);
                    return isFinded;
                }
            }
            return false;
        },

        _compareValues: function (rowIdx, colIdx, sheetIdx, input, isCSen, isEMatch, type) {
            var xlObj = this.XLObj, value = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, null, sheetIdx) ? xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, null, sheetIdx).toString() : "";
            var isFormula = xlObj.isFormula(value) || (type === "formula" && value === "=");
            var isDateTime = xlObj._isDateTime(xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value", sheetIdx));
            if (type === "value")
                if (isDateTime)
                    value = value ? this.caseSen[isCSen](xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "value2", sheetIdx)) : "";
                else
                    value = value && !isFormula ? this.caseSen[isCSen](value) : "";
            else if (type === "formula") {
                value = isFormula ? this.caseSen[isCSen](value) : "";
            }
            else
                value = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx) ? this.caseSen[isCSen](xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "comment", sheetIdx).value) : "";
            input = this.caseSen[isCSen](input);
            return (this.isEMatch[isEMatch](value, input));
        },

        _replace: function (cell, sIndex, input1, input2, isCSen) {
            var xlObj = this.XLObj, cellElem, sheetIdx = xlObj.getActiveSheetIndex();
            if(xlObj.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, "isLocked", sheetIdx))
               return false;
            var value = xlObj.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, null, sIndex) ? xlObj.XLEdit.getPropertyValue(cell.rowIndex, cell.colIndex, null, sIndex).toString() : "", regx = new RegExp(input1.toString().replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), "ig"),
            newData = (value !== "" && input1 !== "") ? (isCSen ? value.replace(input1, input2) : value.replace(regx, input2)) : input2;
            if (!(sIndex === sheetIdx))
                xlObj.gotoPage(sIndex);
            xlObj.XLEdit._updateCellValue(cell, newData);
        },

        _replaceData: function (input1, input2, sIndex, isCSen, isEMatch, type, direction, mode, searchBy) {
            var details, prop ,cell, xlObj = this.XLObj, sheetIdx = sIndex ? sIndex : xlObj.model.activeSheetIndex, actSheet = xlObj.getSheet(sheetIdx), rowIdx = actSheet._activeCell.rowIndex, colIdx = actSheet._activeCell.colIndex, isFinded;
            if(!xlObj.model.allowEditing)
            return false;
            if (xlObj.model.allowLockCell && xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, "isLocked", sheetIdx)) {
                xlObj._popUplockCellAlert();
                return;
            }
            if (xlObj.model.allowEditing && xlObj.XLEdit._isEdit)
                xlObj.XLEdit.saveCell();
            if (this._compareValues(rowIdx, colIdx, sheetIdx, input1, isCSen, isEMatch, type)) {
                prop = (type === "formula") ? "value" : "value2";
                details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "replace", rowIndex: rowIdx, colIndex: colIdx, sIndex: sIndex };
                details.prevData = { value: xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, prop) };
                this._replace({ rowIndex: rowIdx, colIndex: colIdx }, sIndex, input1, input2, isCSen);
                details.newData = { value: xlObj.XLEdit.getPropertyValue(rowIdx, colIdx, prop) };
                this._findCount = 0;
                isFinded = direction === "up" ? this._findPrev(input1, sheetIdx, isCSen, isEMatch, type, mode, searchBy) : this._findNext(input1, sheetIdx, isCSen, isEMatch, type, mode, searchBy);
                if (!isFinded)
                    this._updateSelection(rowIdx, colIdx, sheetIdx);
                if (!xlObj._isUndoRedo) {
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            }
            else
                xlObj._showAlertDlg("Alert", "ReplaceNotFound", "");

        },

        _replaceAllData: function (input1, input2, isCSen, isEMatch, type, sType) {
            var details, cell, prop , cellInfo, selCells = [], skipCount = 0, sheetProtected = false, curSheet, xlObj = this.XLObj, sheetCount = xlObj.model.sheetCount, sheetIdx = xlObj.model.activeSheetIndex, actSheet = xlObj.getSheet(sheetIdx), usedRange = actSheet.usedRange, rowIdx = actSheet._activeCell.rowIndex, colIdx = actSheet._activeCell.colIndex, i, j, s, m, n, count = 0;
            details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "replaceAll", isCSen: isCSen, isEMatch: isEMatch };
            prop = (type === "formula") ? "value" : "value2";
            if(!xlObj.model.allowEditing)
              return false;
		    xlObj._dupDetails = true;
            if (xlObj.model.allowEditing && xlObj.XLEdit._isEdit)
                xlObj.XLEdit.saveCell();
            if (sType === "sheet") {
                if (xlObj.model.allowLockCell && actSheet.isSheetProtected)
                    sheetProtected = true;
                else {
                    for (i = 0, m = usedRange.rowIndex + 1; i < m; i++) {
                        for (j = 0, n = usedRange.colIndex + 1; j < n; j++)
                            if (this._compareValues(i, j, sheetIdx, input1, isCSen, isEMatch, type)) {
                                cellInfo = { rowIndex: i, colIndex: j, prevData: { value: xlObj.XLEdit.getPropertyValue(i, j, prop) }, sheetIndex: sheetIdx };
                                this._replace({ rowIndex: i, colIndex: j }, sheetIdx, input1, input2, isCSen);
                                count++;
                                cellInfo.newData = { value: xlObj.XLEdit.getPropertyValue(i, j, prop) };
                                selCells.push(cellInfo);
                            }
                    }
                }
            }
            else {
                for (s = 1; s <= sheetCount; s++) {
                    curSheet = xlObj.model.sheets[s];
                    if (xlObj.model.allowLockCell && curSheet.isSheetProtected) {
                        skipCount++;
                        continue;
                    }
                    usedRange = curSheet.usedRange;
                    for (i = 0, m = usedRange.rowIndex + 1; i < m; i++) {
                        for (j = 0, n = usedRange.colIndex + 1; j < n; j++)
                            if (this._compareValues(i, j, s, input1, isCSen, isEMatch, type)) {
                                cellInfo = { rowIndex: i, colIndex: j, prevData: { value: xlObj.XLEdit.getPropertyValue(i, j, prop,s) }, sheetIndex: s };
                                this._replace({ rowIndex: i, colIndex: j }, s, input1, input2, isCSen);
                                count++;
                                cellInfo.newData = { value: xlObj.XLEdit.getPropertyValue(i, j, prop) };
                                selCells.push(cellInfo);
                            }
                    }
                }
            }
            if (sheetProtected || skipCount === sheetCount) {
                xlObj._popUplockCellAlert();
                return;
            }
			xlObj._dupDetails = false;
            details.selectedCell = selCells;
            this._updateSelection(rowIdx, colIdx);
            if (!xlObj._isUndoRedo) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
            xlObj.hideWaitingPopUp();
            var alertText = xlObj._getLocStr("ReplaceData").split("/");
            alertText = "T-" + alertText[0] + count + " " + alertText[1];
            $("#" + xlObj._id + "_FRDialog").ejDialog("close");
            xlObj._showAlertDlg("Alert", alertText, "", 325);
        },

        _updateSelection: function (rowIdx, colIdx, sIndex) {
            var cellIdx = { rowIndex: rowIdx, colIndex: colIdx }, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);
            if (!sIndex)
                sIndex = sheetIdx;
            if (sIndex && sIndex !== sheetIdx)
                xlObj.gotoPage(sIndex, false);
            if (xlObj.getSheetElement(sheetIdx).find(".e-selected:visible").length < 2 || !xlObj.inRange(sheet.selectedRange, rowIdx, colIdx)) {
                xlObj.setActiveCell(cellIdx.rowIndex, cellIdx.colIndex, sIndex);
                xlObj.XLSelection.selectRange(cellIdx, cellIdx);
                sheet._startCell = cellIdx;
                sheet._endCell = cellIdx;
            }
            else {
                xlObj.XLCellNav._updateActiveCell(rowIdx, colIdx);
            }
            if (xlObj.model.scrollSettings.allowScrolling)
                if (xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns)) 
                    this._freezeScroll(cellIdx.rowIndex, cellIdx.colIndex, sheet);
                else
                    xlObj.XLScroll._scrollSelectedPosition(sIndex, xlObj.getActiveCell(sIndex));
            if (xlObj.model.allowAutoFill)
                xlObj.XLDragFill.positionAutoFillElement();
        },
 
        //GoTo
        _getSelRangeDetails: function (selected) {
            var rowIdx = selected[selected.length - 1].rowIndex - selected[0].rowIndex, colIdx = selected[selected.length - 1].colIndex - selected[0].colIndex;
            var startRow = selected[0].rowIndex, startCol = selected[0].colIndex;
            return [rowIdx, colIdx, startRow, startCol];
        },

        goTo: function (range) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            xlObj._showDialog(xlObj._id + "_Ribbon_Others_Editing_FindSelect");
            if (range.startsWith("="))
                range = range.split("=")[1];
            var isApply, lbObj, rangeCells, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), startCell, endCell, txt = xlObj._getDollarAlphaRange(sheet.selectedRange);
            var temp = xlObj.XLRibbon._getAddrFromDollarAddr(range);
            range = temp[1];
            temp[0] && xlObj.gotoPage(temp[0], false);
            range = xlObj.getRangeIndices(range), rangeCells = xlObj._getSelectedRange({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] });
            startCell = rangeCells[0];
            endCell = rangeCells[rangeCells.length - 1];
            xlObj.setActiveCell(startCell.rowIndex, startCell.colIndex);
            xlObj.model.allowSelection && xlObj.XLSelection.selectRange(startCell, endCell);
            if (xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns)) 
                this._freezeScroll(startCell.rowIndex, startCell.colIndex, sheet);
            else
                xlObj.XLScroll._scrollSelectedPosition(xlObj.getActiveSheetIndex(), startCell);
            xlObj.XLDragFill.positionAutoFillElement();
            sheet._startCell = startCell;
            sheet._endCell = endCell;
            xlObj.setSheetFocus();
            isApply = $.grep(xlObj.XLRibbon._addrList, function (e) {
                return e.value === txt;
            });
            if (isApply.length < 1) {
                xlObj.XLRibbon._addrList.push({ value: txt, text: txt });
                lbObj = $("#" + xlObj._id + "_GotoAddr").data("ejListBox");
                xlObj.XLRibbon._addrList = JSON.parse(JSON.stringify(xlObj.XLRibbon._addrList));
                lbObj.model.dataSource = xlObj.XLRibbon._addrList;
                lbObj.option("fields", { dataSource: xlObj.XLRibbon._addrList });
            }
        },

        goToSpecial: function (type, options){
            this._applyGoToRule(type, options.isNumber, options.isText, options.isLogical, options.isError);
        },

        _applyGoToRule: function (type, isNumber, isText, isLogical, isError) {
            var xlObj = this.XLObj;
            xlObj.showWaitingPopUp();
            switch (type) {
                case "blanks":
                    this._applyGotoBlanks();
                    break;
                case "formulas":
                    this._applyGotoFormulas(isNumber, isText, isLogical, isError);
                    break;
                case "comments":
                    this._applyGotoComments();
                    break;
                case "datavalidation":
                    this._applyGotoValidation();
                    break;
                case "cformat":
                    this._applyGotoCFormat();
                    break;
                case "lastcell":
                    var sheetIdx = xlObj.getActiveSheetIndex(), usedRange = xlObj.model.sheets[sheetIdx].usedRange;
                    xlObj.XLSelection.selectRange({ rowIndex: usedRange.rowIndex, colIndex: usedRange.colIndex }, { rowIndex: usedRange.rowIndex, colIndex: usedRange.colIndex });
                    this._updateSelection(usedRange.rowIndex, usedRange.colIndex, sheetIdx);
                    break;
                case "constants":
                    this._applyGotoConstants(isNumber, isText, isLogical, isError);
                    break;
                case "rowdiff":
                    this._applyGotoRowDiff();
                    break;
                case "coldiff":
                    this._applyGotoColDiff();
                    break;
                case "visiblecells":
                    break;
            }
            xlObj.hideWaitingPopUp();
        },

        _applyGotoBlanks: function () {
            var i, j, cell, lastcell, goToLen, rIdx, cIdx, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                usedRange = xlObj.model.sheets[sheetIdx].usedRange, value, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex,
                sheet=xlObj.getSheet(sheetIdx),selected = sheet._selectedCells, startRow = 0, startCol = 0,
                details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "blanks" };
            sheet._goToCollection = { multiple: false, selected: [] };
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
            }
            for (i = 0; i <= rowIdx; i++) {
                for (j = 0; j <= colIdx; j++) {
                    rIdx = i + startRow, cIdx = j + startCol;
                    value = xlObj.XLEdit.getPropertyValue(rIdx, cIdx) ? xlObj.XLEdit.getPropertyValue(rIdx, cIdx).toString() : "";
                    if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                        cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                        isViewed = true;
                    }
                    if (!value.length) {
                        selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                        if (xlObj.model.scrollSettings.allowVirtualScrolling)
                            sheet._goToCollection.selected.push(rIdx + ":" + cIdx);
                        if (isViewed) {
                            cell.addClass("e-selected");
                            lastcell = [rIdx, cIdx];
                        }
                    } else {
                        if (isViewed)
                            cell.removeClass("e-selected");                      
                    }
                }
                isViewed = false;
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _applyGotoComments: function () {
            var i, j, cell, lastcell, goToLen, rIdx, cIdx, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), usedRange = xlObj.getSheet(sheetIdx).usedRange,
                value, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex, sheet = xlObj.getSheet(sheetIdx), selected = sheet._selectedCells, startRow = 0, startCol = 0;
            var details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "comments" };
            sheet._goToCollection = { multiple: false, selected: [] };
            this._isApplied = false;
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
            }
            for (i = 0; i <= rowIdx; i++) {
                for (j = 0; j <= colIdx; j++) {
                    rIdx = i + startRow, cIdx = j + startCol;
                    value = xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "comment");
                    if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                        cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                        isViewed = true;
                    }
                    if (!ej.isNullOrUndefined(value)) {
                        selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                        if (xlObj.model.scrollSettings.allowVirtualScrolling)
                            sheet._goToCollection.selected.push(rIdx + ":" + cIdx);
                        if (isViewed) {
                            cell.addClass("e-selected");
                            this._isApplied = true;
                            lastcell = [rIdx, cIdx];
                        }
                    } else {
                        if (isViewed)
                            cell.removeClass("e-selected");                         
                    }
                }
                isViewed = false;
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);          
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo && this._isApplied) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _applyGotoFormulas: function (isNumber, isText, isLogical, isError) {
            var i, j, cell, rIdx, cIdx, lastcell, goToLen, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                value, value2, isFormula, usedRange = xlObj.model.sheets[sheetIdx].usedRange, rowIdx = usedRange.rowIndex,
                colIdx = usedRange.colIndex, sheet=xlObj.getSheet(sheetIdx) , selected = sheet._selectedCells, startRow = 0, startCol = 0,
                details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "formulas" };
            sheet._goToCollection = { multiple: false, selected: [] };
            this._isApplied = false;
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
            }
            for (i = 0; i <= rowIdx; i++) {
                for (j = 0; j <= colIdx; j++) {
                    rIdx = i + startRow, cIdx = j + startCol;
                    value = !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rIdx, cIdx)) ? xlObj.XLEdit.getPropertyValue(rIdx, j + startCol).toString() : "";
                    value2 = !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "value2")) ? xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "value2").toString() : "";
                    isFormula = value.charAt(0) === "=" && typeof value2 === "string";
                    if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                        cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                        isViewed = true;
                    }
                    if (isFormula && ((isNumber && ($.isNumeric(value2))) || (isText && (!(value2.toLowerCase() === "true" || value2.toLowerCase() === "false") && !$.isNumeric(value2) && !(value2.length !== 0 && (value2.indexOf("#") === 0 && value2.lastIndexOf("?") === value2.length - 1) && value2.length > 0))) || (isLogical && (value2.toLowerCase() === "true" || value2.toLowerCase() === "false")) || (isError && value2.length !== 0 && (xlObj._calcEngine.getErrorStrings().indexOf(value2) > -1)))) {
                        selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                        if (xlObj.model.scrollSettings.allowVirtualScrolling)
                            sheet._goToCollection.selected.push(rIdx + ":" + cIdx);
                        if (isViewed) {
                            cell.addClass("e-selected");
                            this._isApplied = true;
                            lastcell = [rIdx, cIdx];
                        }
                    } else {
                        if (isViewed) 
                            cell.removeClass("e-selected");
                    }
                }
                isViewed = false;
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if(goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);         
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo && this._isApplied) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _applyGotoValidation: function () {
            var i, j, cell, rIdx, cIdx, lastcell, goToLen, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                usedRange = xlObj.model.sheets[sheetIdx].usedRange, value, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex,
                sheet=xlObj.getSheet(sheetIdx) , selected = sheet._selectedCells, startRow = 0, startCol = 0,
                details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "validations" };
            this._isApplied = false;
            sheet._goToCollection = {multiple:false,selected:[]};
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
            }
            for (i = 0; i <= rowIdx; i++) {
                for (j = 0; j <= colIdx; j++) {
                    rIdx = i + startRow, cIdx = j + startCol;
                    value = xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "rule");
                    if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                        cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                        isViewed = true;
                    }
                    if (!ej.isNullOrUndefined(value)) {
                        selCells.push({ rowIndex: rIdx , colIndex: cIdx , isApply: true });
                        if (xlObj.model.scrollSettings.allowVirtualScrolling)
                            sheet._goToCollection.selected.push(rIdx + ":" + cIdx);
                        if (isViewed) {
                            cell.addClass("e-selected");
                            this._isApplied = true;
                            lastcell = [rIdx, cIdx];
                        }
                    } else {
                        if (isViewed)
                            cell.removeClass("e-selected");                   
                    }
                }
                isViewed = false;
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);          
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo && this._isApplied) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _applyGotoCFormat: function () {
            var i, j, cell, rIdx, cIdx, lastcell, goToLen, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                usedRange = xlObj.model.sheets[sheetIdx].usedRange, value, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex,
                sheet = xlObj.getSheet(sheetIdx), selected = sheet._selectedCells, startRow = 0, startCol = 0,
                details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "conditions" };
            this._isApplied = false;
            sheet._goToCollection = {multiple:false,selected:[]};
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
            }
            for (i = 0; i <= rowIdx; i++) {
                for (j = 0; j <= colIdx; j++) {
                    rIdx=i + startRow,cIdx=j + startCol;
                    value = xlObj.XLEdit.getPropertyValue(rIdx,cIdx, "cFormatRule");
                    if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                        cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                        isViewed = true;
                    }
                    if (!ej.isNullOrUndefined(value) && value.length) {
                        selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                        if(xlObj.model.scrollSettings.allowVirtualScrolling) 
                            sheet._goToCollection.selected.push(rIdx + ":" + cIdx);
                        if (isViewed) {
                            cell.addClass("e-selected");
                            this._isApplied = true;
                            lastcell = [rIdx, cIdx];
                        }
                    } else {
                        if (isViewed) 
                            cell.removeClass("e-selected");
                    }
                }
                isViewed = false;
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);           
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo && this._isApplied) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _applyGotoConstants: function (isNumber, isText, isLogical, isError) {
            var i, j, cell, rIdx, cIdx, lastcell, goToLen, isViewed = false, selCells = [], isFormula, temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                value, value2, usedRange = xlObj.model.sheets[sheetIdx].usedRange, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex,
                sheet = xlObj.getSheet(sheetIdx), selected = sheet._selectedCells, startRow = 0, startCol = 0;
            this._isApplied = false;
            sheet._goToCollection = { multiple: false, selected: [] };
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
            }
            for (i = 0; i <= rowIdx; i++) {
                for (j = 0; j <= colIdx; j++) {
                    rIdx=i + startRow,cIdx=j + startCol;
                    value = ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rIdx,cIdx )) ? "" : xlObj.XLEdit.getPropertyValue(rIdx, cIdx).toString();
                    value2 = ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "value2")) ? "" : xlObj.XLEdit.getPropertyValue(rIdx, cIdx, "value2").toString();
                    isFormula = value.charAt(0) === "=" && typeof value2 === "string";
                    if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                        cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                        isViewed = true;
                    }
                    if (!isFormula && ((isNumber && ($.isNumeric(value))) || (isText && (!(value.toLowerCase() === "true" || value.toLowerCase() === "false") && !$.isNumeric(value) && value.length > 0)) || (isLogical && (value.toLowerCase() === "true" || value.toLowerCase() === "false") || (isError && value2.length !== 0 && (value2.indexOf("#") === 0 ))))) {
                        selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                        if (xlObj.model.scrollSettings.allowVirtualScrolling)
                            sheet._goToCollection.selected.push(rIdx + ":" + cIdx);

                        if (isViewed) {
                            cell.addClass("e-selected");
                            this._isApplied = true;
                            lastcell = [rIdx, cIdx];
                        }
                    } else {
                        if (isViewed) 
                            cell.removeClass("e-selected");                           
                    }
                }
                isViewed = false;
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);
        },

        _applyGotoColDiff: function () {
            var i, j, cell, cIdx, rIdx, lastcell, goToLen, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                usedRange = xlObj.model.sheets[sheetIdx].usedRange, value, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex,
                sheet=xlObj.getSheet(sheetIdx), selected = sheet._selectedCells, startRow = 0, startCol = 0,
               details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "coldiff" }, result;
            this._isApplied = false;
            sheet._goToCollection = { multiple: false, selected: [] };
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
                for (i = 0; i <= colIdx; i++) {
                    cIdx=i + startCol;
                    result = xlObj.XLEdit.getPropertyValue(startRow, cIdx) ? xlObj.XLEdit.getPropertyValue(startRow, cIdx).toString() : "";
                    for (j = 0; j <= rowIdx; j++) {
                        rIdx = j + startRow;
                        value = xlObj.XLEdit.getPropertyValue(rIdx, cIdx) ? xlObj.XLEdit.getPropertyValue(rIdx, cIdx).toString() : "";
                        if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                            cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                            isViewed = true;
                        }
                        if (value === result) {
                            if (isViewed)
                                cell.removeClass("e-selected");
                        }
                        else {
                            selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                            if (xlObj.model.scrollSettings.allowVirtualScrolling)
                                sheet._goToCollection.selected.push(rIdx+":"+cIdx);
                            if (isViewed) {
                                cell.addClass("e-selected");
                                this._isApplied = true;
                                lastcell = [rIdx, cIdx];
                            }
                        }
                    }
                    isViewed = false;
                }
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);      
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo && this._isApplied) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },
        _applyGotoRowDiff: function () {
            var i, j, cell, lastcell, goToLen, rIdx, cIdx, isViewed = false, selCells = [], temp, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(),
                usedRange = xlObj.model.sheets[sheetIdx].usedRange, value, rowIdx = usedRange.rowIndex, colIdx = usedRange.colIndex,
                sheet=xlObj.getSheet(sheetIdx), selected = sheet._selectedCells, startRow = 0, startCol = 0, result,
                details = { sheetIndex: sheetIdx, reqType: "find-replace", operation: "rowdiff" };
            this._isApplied = false;
            sheet._goToCollection = { multiple: false, selected: [] };
            if (selected.length > 1) {
                temp = this._getSelRangeDetails(selected);
                rowIdx = temp[0];
                colIdx = temp[1];
                startRow = temp[2];
                startCol = temp[3];
                sheet._goToCollection.multiple = true;
                for (i = 0; i <= rowIdx; i++) {
                    rIdx = i + startRow;
                    result = xlObj.XLEdit.getPropertyValue(rIdx, startCol) ? xlObj.XLEdit.getPropertyValue(rIdx, startCol).toString() : "";
                    for (j = 0; j <= colIdx; j++) {
                        cIdx = j + startCol;
                        value = xlObj.XLEdit.getPropertyValue(rIdx, cIdx) ? xlObj.XLEdit.getPropertyValue(rIdx, cIdx).toString() : "";
                        if (xlObj._isRowViewable(sheetIdx, rIdx)) {
                            cell = xlObj.getCell(rIdx, cIdx, sheetIdx);
                            isViewed = true;
                        }
                        if (value === result) {
                            if (isViewed)
                                cell.removeClass("e-selected");                          
                        }
                        else {
                            selCells.push({ rowIndex: rIdx, colIndex: cIdx, isApply: true });
                            if (xlObj.model.scrollSettings.allowVirtualScrolling)
                                sheet._goToCollection.selected.push(rIdx + ":" + cIdx);
                            if (isViewed) {
                                cell.addClass("e-selected");
                                this._isApplied = true;
                                lastcell = [rIdx, cIdx];
                            }
                        }
                    }
                    isViewed = false;
                }
            }
            goToLen = sheet._goToCollection.selected.length;
            if ((xlObj._isFrozen(sheet.frozenRows) || xlObj._isFrozen(sheet.frozenColumns))) {
                if (goToLen)
                    lastcell = sheet._goToCollection.selected[goToLen - 1].split(":");
                if (lastcell && lastcell.length)
                    this._freezeScroll(lastcell[0], lastcell[1], sheet);
            }
            if (!this._isApplied && !goToLen)
                xlObj._showAlertDlg("Alert", "NoCellFound", "", 200);
            details.selectedCell = selCells;
            if (!xlObj._isUndoRedo && this._isApplied) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },
        _freezeScroll: function (rowIdx, colIdx, sheet) { // To scroll last found cell when rows and columns are freezed
            var diff, xlObj = this.XLObj;
            diff = xlObj._getIdxWithOffset(rowIdx, colIdx, false, ["freeze"]);
            if (sheet._ftopRowIdx > rowIdx || rowIdx > sheet._bottomRow.idx)
                xlObj._scrollContent({ y: (diff.yOffset - sheet._frozenHeight) + 1 }, true);
            if (sheet._fleftColIdx > colIdx || colIdx > sheet._rightCol.idx)
                xlObj._scrollContent({ x: ((diff.xOffset) - sheet._frozenWidth) + 1 }, true);
        }
    };
})(jQuery, Syncfusion);

$.fn.setInputPos = function (start, end) {
    if (!end) end = start;
    if ($(this).is(":visible")) {
        return this.each(function () {
            if (this.setSelectionRange) {
                this.focus();
                this.setSelectionRange(start, end);
            } else if (this.createTextRange) {
                var range = this.createTextRange();
                range.collapse(true);
                range.moveEnd("character", end);
                range.moveStart("character", start);
                range.select();
            }
        });
    }
};;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.shape = function (obj) {
        this.XLObj = obj;
        this._imgX = 0;
        this._imgY = 0;
        this._imgOffsetleft = 0;
        this._imgOffsetTop = 0;
        this._shapeType = "img";
        this._shapeROStart = false;
        this._shapeRSStart = false;
        this._imgRSWStart = false;
        this._imgRSEStart = false;
        this._imgRSNStart = false;
        this._imgRSSStart = false;
        this._changePicture = false;
        this._picCellIdx = {};
        this._insertShape = false;
    };

    ej.spreadsheetFeatures.shape.prototype = {
        _insertPicture: function (e) {
            var xlObj = this.XLObj, imgData = xlObj._browserDetails.name === "msie" && parseInt(xlObj._browserDetails.version) < 10 ? e.responseText : e.xhr.response;
            if (imgData.startsWith("Invalid"))
                xlObj._showAlertDlg("Alert", "ImageValAlert");
            else {
                var sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), left, top, imgElem, cellIdx;
                if (this._changePicture) 
                    this.changePicture(null, imgData);
                else {
                    var activeCell = xlObj.getActiveCell(), picSettings = xlObj.model.pictureSettings;
                    var height = picSettings.height, width = picSettings.width;
                    if (ej.isNullOrUndefined(activeCell)) {
                        imgElem = xlObj.element.find(".e-ss-activeimg").get(0);
                        cellIdx = this._getCellIndexFromOffset(imgElem.offsetTop, imgElem.offsetLeft);
                    }
                    left = sheet._colWidthCollection[activeCell.colIndex];
                    top = sheet._rowHeightCollection[activeCell.rowIndex];
                    this._insertShape = true;
                    this._createPicture(sheetIdx, activeCell, imgData, top, left, width, height);
                }
            }
        },
        changePicture: function (pictureId, url) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), imgElem, left, top, cellIdx, shapeMngr, shapeObj, details;
            imgElem = pictureId ? $('#' + pictureId).get(0) : xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg").get(0);
            left = imgElem.offsetLeft;
            top = imgElem.offsetTop;
            cellIdx = this._getCellIndexFromOffset(top, left);
            shapeMngr = sheet.shapeMngr;
            $(imgElem).css('background-image', "url('" + url + "')");
            shapeObj = shapeMngr.picture[imgElem.id];
            details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "picture", action: "changepicture", id: $(imgElem).attr("id"), cell: cellIdx, prev: { img: shapeMngr.sharedPics[shapeObj.data], data: shapeObj.data, pcIdx: imgElem.id }, cur: { img: url, pcIdx: imgElem.id } };
            if (shapeMngr.sharedPics.indexOf(url) === -1)
                shapeMngr.sharedPics.push(url);
            shapeObj.data = shapeMngr.sharedPics.indexOf(url);
            details.cur.data = shapeObj.data;
            this._changePicture = false;
            xlObj.setSheetFocus();
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },
        setPicture: function (range, url, width, height, top, left) {
            var xlObj = this.XLObj, rowIdx, colIdx, rng, id;
            if (!xlObj.model.pictureSettings.allowPictures || xlObj.model.isReadOnly)
                return;
            range = xlObj._getRangeArgs(range, "object");
            rowIdx = range[0];
            colIdx = range[1];
			if (xlObj.model.allowLockCell && xlObj._isCellProtected(rowIdx, colIdx, false))
                return;
            var sheetIdx = xlObj.getActiveSheetIndex(), activeCell, picSettings = xlObj.model.pictureSettings;
            height = height ? height : picSettings.height;
            width = width ? width : picSettings.width;
            if(xlObj._isRowViewable(sheetIdx, rowIdx)){
                activeCell = xlObj.getCell(rowIdx, colIdx)[0];
                top = top ? top : activeCell.offsetTop;
                left = left ? left : activeCell.offsetLeft;
            }
            else {
                top = top ? top : 0;
                left = left ? left : 0;
            }
            return this._createPicture(sheetIdx, { rowIndex: rowIdx, colIndex: colIdx }, url, top, left, width, height);
        },

        resetPicture: function (pictureId, action) {
            var xlObj = this.XLObj, elem, regx, details, imgStyle
            elem = pictureId ? $('#' + pictureId) : xlObj.element.find(".e-ss-activeimg"), regx = new RegExp("\\b" + "e-shapebdr" + ".*?\\b", "g");
            details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "shape", shapeType: "picture", action: "resetpicture", id: $(elem).attr("id"), actionType: action };
            xlObj._dupDetails = true;
            if (!ej.isNullOrUndefined(elem[0].className.match(regx))) {
                imgStyle = xlObj.XLShape._getImgStyleFromHashCode(elem[0].className.match(regx)[0]);
            }
            details.prev = imgStyle ? { bcolor: imgStyle["border-color"], bstyle: imgStyle["border-style"], bwidth: imgStyle["border-width"] } : {};
            elem[0].className = elem[0].className.replace(regx, "");
            details.cur = { bcolor: elem.css("border-color"), bstyle: elem.css("border-style"), bwidth: elem.css("border-width") };
            if (action != "resetpicture") {
                details.prev.width = elem.css("width");
                details.prev.height = elem.css("height");
                elem.css({ width: xlObj.model.pictureSettings.width, height: xlObj.model.pictureSettings.height });
                details.cur.width = elem.css("width");
                details.cur.height = elem.css("height");
                xlObj.XLShape._updateShapeObj(elem[0]);
                xlObj._hasClass(elem[0], 'e-ss-activeimg') && xlObj.XLRibbon._formatTabUpdate();
            }
            xlObj._dupDetails = false;
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },

        _createPicture: function (sheetIdx, activeCell, imgData, top, left, width, height, cnt, bcolor, bstyle, bwidth, pic) {
            bcolor = bcolor ? bcolor : "transparent";
            bstyle = bstyle ? bstyle : "solid";
            bwidth = bwidth ? bwidth : "1px";
            var xlObj = this.XLObj, evtArgs, sheet = xlObj.getSheet(sheetIdx), args = { sheetIndex: sheetIdx, targetCell: activeCell, top: top, left: left,
                width: width, height: height, bcolor: bcolor, bstyle: bstyle, bwidth: bwidth, reqType: "picture", add: "add" }, id;
            evtArgs = { sheetIndex: args.sheetIndex, targetCell: args.targetCell, top: args.top, left: args.left, width: args.width, height: args.height, bcolor: args.bcolor, bstyle: args.bstyle, bwidth: args.bwidth, reqType: "picture", action: "add" };
            if (xlObj._trigActionBegin(evtArgs))
                return;
            !sheet._isImported && ( this._insertShape = true );
			top = args.top;
            left = args.left;
            width = args.width;
            height = args.height;
            cnt = ej.isNullOrUndefined(cnt) ? (xlObj.model.allowCharts && xlObj.XLChart._shapeCnt) : cnt;
            xlObj._isExport && (pic.cnt = cnt);
            id = xlObj._id + "_picture" + cnt;
            var $elem, details;
            if (!activeCell)
                activeCell = this._getCellIndexFromOffset(top, left, sheetIdx);            
            var rowIdx = activeCell.rowIndex, colIdx = activeCell.colIndex;
            if(!xlObj._isUndoRedo && xlObj.model.allowCharts)
				xlObj.XLChart._shapeCnt++;
            this._updateShapeMngr(activeCell, { "picture": { data: imgData, id: id, height: height, width: width, left: left, top: top, rowIndex: rowIdx, colIndex: colIdx, bwidth: bwidth, bcolor: bcolor, bstyle: bstyle } }, "picture");
            if (!xlObj._isExport)
                this._refreshPictureElement({top: top, left: left, width: width, height: height, bcolor: bcolor, bstyle: bstyle, bwidth: bwidth, imgData: imgData, cnt: cnt, sheetIdx: sheetIdx});
            xlObj.setSheetFocus();
            if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && !xlObj._isPaste && !xlObj.XLClipboard._isShape && !xlObj._isExport) {
                details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "picture", action: "remove", id: id, actCell: activeCell, img: imgData, cnt: cnt };
                details.position = { top: top, left: left, height: height, width: width };
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details)
            }
            xlObj.model.showRibbon && xlObj.XLRibbon._formatTabUpdate();
            return id;
        },

        _refreshPictureElement: function (cellObj) {
            var xlObj = this.XLObj, $elem;
            xlObj._getJSSheetContent(cellObj.sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").append(ej.buildTag("div.e-ss-object", "", "", { id: xlObj._id + "_picture" + cellObj.cnt }));
            $elem = $("#" + xlObj._id + "_picture" + cellObj.cnt);
            $elem.data("parentID", xlObj._id);
            $elem.css({ 'background-image': "url('" + cellObj.imgData + "')", height: cellObj.height, width: cellObj.width, left: cellObj.left, top: cellObj.top });
            var borderCss = cellObj.bwidth + " " + cellObj.bstyle + " " + cellObj.bcolor;
            var hashCode = this._getImgBorderHashCode({ "border-color": cellObj.bcolor, "border-style": cellObj.bstyle, "border-width": cellObj.bwidth });
            if (xlObj.model.allowCellFormatting)
                xlObj.XLFormat._writeCssRules(hashCode, xlObj.XLFormat._getCssPropertyAsString({ "border": { "left": borderCss, "right": borderCss, "top": borderCss, "bottom": borderCss } }));
            $elem.addClass(hashCode);
            this._selectImg($elem);
        },

        _shapeMouseDown: function (e) {
            e.preventDefault();
            var xlObj = this.XLObj, actElemId = document.activeElement.id;
            if (xlObj._isTouchEvt)
                this._imgMouseMove(e);
            if (actElemId.indexOf("PictureHeight") > -1 || actElemId.indexOf("PictureWidth") > -1)
                xlObj.setSheetFocus();
            var prop, id = e.target.id, $trgt = $(e.target), imgElem = $trgt.get(0), left = imgElem.offsetLeft, top = imgElem.offsetTop, xy = xlObj._setXY(e);
            this._selectImg($trgt);
            this._picCellIdx = this._getCellIndexFromOffset(top, left);
            this._imgOffsetleft = left;
            this._imgOffsetTop = top;
            this._imgX = xy[0];
            this._imgY = xy[1];
            this._shapeType = id.indexOf("chart") > -1 ? "chart" : "img";
            if ($trgt.css("cursor") === "move")
                this._shapeROStart = true;
            else if ($trgt.css("cursor") === "col-resize" || $trgt.css("cursor") === "row-resize") {
                this._shapeRSStart = true;
                xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-imgvisual").css({ left: left, top: top, height: $trgt.height(), width: $trgt.width() });
            }
            if (this._shapeType === "chart") {
                prop = xlObj.XLChart._getShapeObj(id, this._shapeType);
                if (xlObj.getActiveSheetIndex() === prop.dataSheetIdx)
                    xlObj.XLChart._focusChartRange(prop.xAxis.range, prop.yAxis.range, prop.legend.range);
            }
			if(xlObj.model.enableContextMenu && xlObj.XLCMenu._isMenuOpened)
				xlObj.XLCMenu.hideCMenu();
        },

        _imgKeyDown: function (e) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), $trgt = xlObj._getContent(sheetIdx).find(".e-ss-activeimg"), imgElem = $trgt.get(0);
            var left = imgElem.offsetLeft, top = imgElem.offsetTop, height, width;
            this._shapeType = $trgt[0].id.indexOf("chart") > -1 ? "chart" : "img";
            this._picCellIdx = this._getCellIndexFromOffset(top, left);
            if (!e.shiftKey && !e.ctrlKey) {
                switch (e.keyCode) {
                    case 39:
                        //right
                        e.preventDefault();
                        $trgt.css({ left: left + 2 });
                        this._updateShapeObj(imgElem);
                        break;
                    case 37:
                        //left
                        e.preventDefault();
                        if (left > 1)
                            $trgt.css({ left: left - 2 });
                        this._updateShapeObj(imgElem);
                        break;
                    case 38:
                        //up
                        e.preventDefault();
                        if (top > 1)
                            $trgt.css({ top: top - 2 });
                        this._updateShapeObj(imgElem);
                        break;
                    case 40:
                        //down
                        e.preventDefault();
                        $trgt.css({ top: top + 2 });
                        this._updateShapeObj(imgElem);
                        break;
                }
                this._onKeyscrollShape(sheetIdx, $trgt, e);
            } else if (e.shiftKey && !e.ctrlKey) {
                if (e.keyCode === 39 || e.keyCode === 38) { //right or up
                    e.preventDefault();
                    height = $trgt.height() + 2;
                    width = $trgt.width() + 2;
                    if (height < 400 && width < 600)
                        $trgt.css({ width: width, height: height });
                    this._updateShapeObj(imgElem);
                    xlObj.XLRibbon._formatTabUpdate();
                } else if (e.keyCode === 37 || e.keyCode === 40) { //left or down
                    e.preventDefault();
                    height = $trgt.height() - 2;
                    width = $trgt.width() - 2;
                    if (height > 40 && width > 60)
                        $trgt.css({ width: width, height: height });
                    this._updateShapeObj(imgElem);
                    xlObj.XLRibbon._formatTabUpdate();
                }
            }
            if (e.keyCode === 46) { //delete
                e.preventDefault();
                var changed = false;
                if (xlObj.XLClipboard._isShape) {
                    xlObj.XLClipboard._isShape = false;
                    changed = true;
                }
                this._deleteShape(sheetIdx, $trgt);
                (changed) && (xlObj.XLClipboard._isShape = true);
            }
        },

        _shapeMouseUp: function (e) {
            var xlObj = this.XLObj, args = {};
            if (xlObj._isExport)
                return;
            var cellIdx, touchend, chart = "chart", details, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), $content = xlObj._getContent(sheetIdx), $actImg = $content.find(".e-ss-activeimg"), $visualImg = $content.find(".e-ss-imgvisual");
            var $trgt = $(e.target), imgElem = $trgt.get(0);
            if ($trgt.hasClass("e-ss-picture") || $trgt[0].id.indexOf(xlObj._id + "_picture") > -1)
                if(xlObj.model.showRibbon)
                xlObj.XLRibbon._formatTabUpdate();
            if (imgElem.id.indexOf(chart) > -1 && imgElem.id.indexOf("Ribbon") < 0)
                imgElem = (imgElem.id.indexOf('_svg') > -1) ? ($(imgElem).parents(".e-ss-object").get(0)) : imgElem;
            ($actImg.length < 1) && (this._shapeROStart = false);
            if (!(imgElem.className.indexOf('e-ss-imgvisual') > -1) && !(imgElem.className.indexOf('e-ss-object') > -1)) {
                if (this._shapeROStart)
                    imgElem = $actImg[0];
                if (this._shapeRSStart)
                    imgElem = $visualImg[0];
            }
            if (this._shapeROStart) {
                if (xlObj._isTouchEvt) {
                    touchend = xlObj._getOriginalEvt(e);
                    imgElem = document.elementFromPoint(touchend.clientX, touchend.clientY);
                }
                if (!xlObj._isUndoRedo) {
                    if (parseInt($actImg.css("top")) !== imgElem.offsetTop || parseInt($actImg.css("left")) !== imgElem.offsetLeft) {
                        details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", action: "edit", actionType: "reorder", id: $($actImg).attr("id"), visualImg: $visualImg, trgt: $trgt };
                        details.prev = { top: parseInt($actImg.css("top")), left: parseInt($actImg.css("left")), height: parseInt($actImg.css("height")), width: parseInt($actImg.css("width")) };
                        details.cur = { top: imgElem.offsetTop, left: imgElem.offsetLeft, height: $trgt.height(), width: $trgt.width() };
                        if ($actImg[0].id.indexOf(chart) > -1) {
                            cellIdx = xlObj._getIdxWithOffset(details.cur.top, details.cur.left, true);
                            sheet.shapeMngr[chart][$actImg[0].id]["rowIndex"] = cellIdx.rowIdx;
                            sheet.shapeMngr[chart][$actImg[0].id]["colIndex"] = cellIdx.colIdx;
                        }
                        if(xlObj._checkIndicesInContainer(sheetIdx, this._picCellIdx.rowIndex, this._picCellIdx.colIndex)){
                            details.obj = $.extend(true, {}, xlObj._dataContainer.sheets[sheetIdx][this._picCellIdx.rowIndex][this._picCellIdx.colIndex]);
                            xlObj._completeAction(details);
                            xlObj._trigActionComplete(details);
                        }
                    }
                }
                $actImg.css({ left: imgElem.offsetLeft, top: imgElem.offsetTop });
                this._updateShapeObj(imgElem);
                $visualImg.removeClass("e-ss-picture").hide();
            } else if (this._shapeRSStart) {
                if (!xlObj._isUndoRedo) {
                    if (xlObj._isTouchEvt)
                        imgElem = $visualImg[0];
                    if (imgElem.className.indexOf("e-ss-imgvisual") < 0 && $visualImg.length > 0)
                        (this._shapeROStart) && (imgElem = $visualImg[0]);
                    $trgt = $(imgElem);
                    if ((parseInt($actImg.css("height")) !== $trgt.height() || parseInt($actImg.css("width")) !== $trgt.width()) && xlObj._checkIndicesInContainer(sheetIdx, this._picCellIdx.rowIndex, this._picCellIdx.colIndex)) {
                        details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", action: "edit", actionType: "resize", id: $($actImg).attr("id"), visualImg: $visualImg, trgt: $trgt };
                        details.prev = { top: parseInt($actImg.css("top")), left: parseInt($actImg.css("left")), height: parseInt($actImg.css("height")), width: parseInt($actImg.css("width")) };
                        details.cur = { top: imgElem.offsetTop, left: imgElem.offsetLeft, height: $trgt.height(), width: $trgt.width() };
                        details.obj = $.extend(true, {}, xlObj._dataContainer.sheets[sheetIdx][this._picCellIdx.rowIndex][this._picCellIdx.colIndex]);
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                }
                if (details)
                    $actImg.css({ left: imgElem.offsetLeft, top: imgElem.offsetTop, height: $trgt.height(), width: $trgt.width() });
                this._updateShapeObj(imgElem);
                $visualImg.removeClass("e-ss-picture").hide();
                if (this._shapeType === "img" && xlObj.model.showRibbon)
                    xlObj.XLRibbon._formatTabUpdate();
                if (this._shapeType === chart) {
                    xlObj.XLChart.resizeChart($actImg.attr("id"), $trgt.height(), $trgt.width());
                    if (xlObj.model.showRibbon)
                        xlObj.XLRibbon._chartDesignTabUpdate($("#" + $actImg.attr("id")));
                }
                args.event = e;
                args.target = e.target;
                if (details && details.cur && details.prev) {
                    args.newHeight = details.cur.height;
                    args.newWidth = details.cur.width;
                    args.oldHeight = details.prev.height;
                    args.oldWidth = details.prev.width;
                }
                args.reqType = imgElem.id.indexOf(chart) > -1 ? "chart-resize" : "picture-resize";
                if (this.XLObj._trigger("resizeEnd", args)) {
                    this._refreshImgResizing();
                    this._shapeRSStart = false;
                    return;
                }
            }
            this._refreshImgResizing();
            this._shapeROStart = this._shapeRSStart = false;
        },

        _imgMouseMove: function (e) {
            var xlObj = this.XLObj, args = {};
            if (xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activeimg").length) {
                e.preventDefault();
                var sheetIdx = xlObj.getActiveSheetIndex(), $content = xlObj._getContent(sheetIdx), $actImg = $content.find(".e-ss-activeimg"), $visualImg = $content.find(".e-ss-imgvisual");
                var imgElem = $actImg.get(0), location = imgElem.getBoundingClientRect(), xy = xlObj._setXY(e), x = xy[0], y = xy[1], extra, left, top;
                if (this._shapeROStart) {
                    if (this.XLObj._trigger("dragShape", e))
                        return;
                    $visualImg.show();
                    if (imgElem.id.indexOf("picture") > -1)
                        $visualImg.addClass("e-ss-picture");
                    left = x - (this._imgX - this._imgOffsetleft);
                    top = y - (this._imgY - this._imgOffsetTop);
                    if (left > -1 && top > -1)
                        $visualImg.css({ left: left, top: top, height: $actImg.height(), width: $actImg.width() });
                    //this._scrollShape(sheetIdx, $visualImg, x, y); // shape resize in scrolling - consider it later
                } else {
                    var width = $visualImg.width(), height = $visualImg.height(), offsetWidth = imgElem.offsetWidth, offsetHeight = imgElem.offsetHeight,
                        vCont = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"), hScroll = $content.find(".e-hscrollbar").data("ejScrollBar"), vScroll = $content.find(".e-vscrollbar").data("ejScrollBar");
                    if (this._shapeRSStart) {
                        args.event = e;
                        args.target = e.target;
                        args.height = $actImg.height();
                        args.width = $actImg.width();
                        args.reqType = imgElem.id.indexOf("chart") > -1 ? "chart-resize" : "picture-resize";
                        if (this.XLObj._trigger("resizeStart", args)) {
                            this._shapeRSStart = false;
                            return;
                        }
                        $visualImg.show();
                        if (imgElem.id.indexOf("picture") > -1)
                            $visualImg.addClass("e-ss-picture");
                        if ($actImg.css("cursor") === "col-resize" || $actImg.css("cursor") === "row-resize") {
                            switch (true) {
                                case this._imgRSWStart:
                                    extra = this._imgX - x;
                                    left = $visualImg[0].offsetLeft - extra;
                                    if (left > -1) {
                                        $visualImg.css({ width: width + extra, left: left });
                                        this._imgX = x;
                                    }
                                    break;
                                case this._imgRSEStart:
                                    extra = this._imgX - x;
                                    if (xlObj.model.scrollSettings.allowScrolling && (width - extra + $visualImg[0].offsetLeft + 5) < (vCont.width() + hScroll.value())) {
                                        $visualImg.css({ width: width - extra });
                                        this._imgX = x;
                                    }
                                    break;
                                case this._imgRSNStart:
                                    extra = this._imgY - y;
                                    top = $visualImg[0].offsetTop - extra;
                                    if (top > -1) {
                                        $visualImg.css({ height: height + extra, top: top });
                                        this._imgY = y;
                                    }
                                    break;
                                case this._imgRSSStart:
                                    extra = this._imgY - y;
                                    if (xlObj.model.scrollSettings.allowScrolling && (height - extra + $visualImg[0].offsetTop + 5) < (vCont.height() + vScroll.value())) {
                                        $visualImg.css({ height: height - extra });
                                        this._imgY = y;
                                    }
                                    break;
                            }
                        }
                        // this._scrollShape(sheetIdx, $visualImg, x, y); // shape resize in scrolling - consider it later
                    } else {
                        this._refreshImgResizing();
                        if ((x <= (location.left + (xlObj._isTouchEvt ? 20 : 4))) && (x >= location.left)) {
                            $actImg.addClass("e-ss-imgcresize");
                            this._imgRSWStart = true;
                        } else if ((x <= (location.left + offsetWidth)) && (x >= location.left + offsetWidth - (xlObj._isTouchEvt ? 20 : 4))) {
                            $actImg.addClass("e-ss-imgcresize");
                            this._imgRSEStart = true;
                        } else {
                            $content.find(".e-ss-imgcresize").removeClass("e-ss-imgcresize");
                        }

                        if ((y <= (location.top + (xlObj._isTouchEvt ? 20 : 4))) && (y >= location.top)) {
                            $actImg.addClass("e-ss-imgrresize");
                            this._imgRSNStart = true;
                        } else if ((y <= (location.top + offsetHeight)) && (y >= location.top + offsetHeight - (xlObj._isTouchEvt ? 20 : 4))) {
                            $actImg.addClass("e-ss-imgrresize");
                            this._imgRSSStart = true;
                        } else {
                            $content.find(".e-ss-imgrresize").removeClass("e-ss-imgrresize");
                        }
                    }
                }
            }
        },

        _deleteShape: function (sheetIdx, $trgt) {
            var selCell, xlObj = this.XLObj, cellIdx = this._picCellIdx, container = xlObj._dataContainer, sheet = xlObj.getSheet(sheetIdx), shapeMngr = sheet.shapeMngr, cellObj = container.sheets[sheetIdx][cellIdx.rowIndex][cellIdx.colIndex], details;
            var xlId = $trgt.data("parentID"), shapeId = $trgt.get(0).id.replace(xlId + "_", ""), shapeType = shapeId.replace(/[0-9]/g, ''), imgElem = $trgt.get(0), objIdx, picIdx, shapeObj = shapeMngr[shapeType][cellObj[shapeType][0]];
           	if (!xlObj._isUndoRedo)
                if (!xlObj._isPaste && !xlObj.XLClipboard._isShape) {
                    details = { sheetIndex: sheetIdx, id: imgElem.id, picIndex: imgElem.id, reqType: "shape", shapeType: shapeType, action: "create", options: shapeObj, range: shapeObj.range, img: shapeMngr.sharedPics[shapeObj.data], bcolor: shapeObj.bcolor, bstyle: shapeObj.bstyle, bwidth :shapeObj.bwidth };
                    details.actCell = {rowIndex: cellIdx.rowIndex, colIndex: cellIdx.colIndex};
                    details.position = { height: shapeObj.height, width: shapeObj.width, top: shapeObj.top, left: shapeObj.left };
                    details.cnt = shapeId.replace(/[a-z]/g, '');
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
                }
            cellObj[shapeType].some(function (obj, i) {
                if (imgElem.id === shapeMngr[shapeType][cellObj[shapeType][i]].id) {
                    objIdx = i;
                    return true;
                }
                return false;
            });
            if (Object.keys(cellObj).length < 2 && cellObj[shapeType].length < 2){
               delete container.sheets[sheetIdx][cellIdx.rowIndex][cellIdx.colIndex];
                if(xlObj.getObjectLength(container.sheets[sheetIdx][cellIdx.rowIndex]) < 1)
                    delete container.sheets[sheetIdx][cellIdx.rowIndex]
                } 
            else if (cellObj[shapeType].length < 2)
                delete cellObj[shapeType];
            else
                cellObj[shapeType].splice(objIdx, 1);
            delete shapeMngr[shapeType][imgElem.id];
            selCell = { rowIndex: cellIdx.rowIndex, colIndex: cellIdx.colIndex };
            if (sheetIdx === xlObj._getSheetIndex()) { // check for cut paste sheet to sheet
                xlObj.setActiveCell(cellIdx.rowIndex, cellIdx.colIndex);
                xlObj.performSelection(selCell, selCell);
            }
            $trgt.remove();
            if(xlObj.model.allowFormulaBar)
            xlObj.updateFormulaBar();
            if (xlObj.model.showRibbon) {
                if (shapeType === "picture")
                    xlObj.XLRibbon._toggleFormatTab();
                else
                    xlObj.XLRibbon._toggleChartDesignTab();
            }
            if (sheet._isChartBorderDrawn)
                xlObj.XLChart._clearChartRange(xlObj._arrayAsString(xlObj._chartBorder));
        },

        _selectImg: function (elem) {
            this.XLObj._getContent(this.XLObj.getActiveSheetIndex()).find(".e-ss-activeimg").removeClass("e-ss-activeimg");
            elem.addClass("e-ss-activeimg");
            this.XLObj.XLSelection._cleanUp(true);
			if(this.XLObj.model.allowFormulaBar)
               this.XLObj.updateFormulaBar();
        },

        _refreshImgResizing: function () {
            this._imgRSEStart = false;
            this._imgRSWStart = false;
            this._imgRSNStart = false;
            this._imgRSSStart = false;
        },

        _getShapePropeties: function (cellIdx, id, type) {
            var i, data = this.XLObj.XLEdit.getPropertyValue(cellIdx.rowIndex, cellIdx.colIndex, type);
            while (i in data) {
                if (data[i].id === id)
                    return data[i];
                else
                    return;
            }
        },

        _updateShapeMngr: function (cell, shapeObj, type, shtIdx) {
            var shapeIdx, obj = {}, xlObj = this.XLObj, sheetIdx = shtIdx || xlObj.getActiveSheetIndex(),
                shapeMngr = xlObj.getSheet(sheetIdx).shapeMngr, shape = shapeMngr[type];
			shape[shapeObj[type].id] = ($.extend(true, {}, shapeObj[type]));
            if (type === "picture") {
                if(shapeMngr.sharedPics.indexOf(shapeObj[type].data) < 0)
                     shapeMngr.sharedPics.push(shapeObj[type].data);
                shapeIdx = shapeMngr.sharedPics.indexOf(shapeObj[type].data);
                shape[shapeObj[type].id].data = shapeIdx;
            }
            if (xlObj._isPaste || this._insertShape || xlObj.XLClipboard._isShape || xlObj.isImport || !xlObj.getSheet(sheetIdx)._isUpdated) {
				obj[type] = shapeObj[type].id;
                xlObj.XLEdit._updateDataContainer(cell, { dataObj: obj, sheetIdx: sheetIdx });
                this._insertShape = false;
            }
        },

        _updateShapeObj: function (imgElem) {
            var oldElem, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), container = xlObj._dataContainer, shapeObj, cellObj, picIdx;
            var chart = "chart", type = this._shapeType === "img" ? "picture" : chart, cellIdx = this._picCellIdx;
            var shapeMngr = xlObj.getSheet(sheetIdx).shapeMngr, cellPicIdx, cObj = {}, actImg = xlObj._getContent(sheetIdx).find(".e-ss-activeimg");
            if (!xlObj.getObjectLength(this._picCellIdx))
                cellIdx = this._picCellIdx = this._getCellIndexFromOffset(imgElem.offsetTop, imgElem.offsetLeft);
            oldElem = actImg.length ? actImg: $('#' + imgElem.id);
            cellObj = container.sheets[sheetIdx][cellIdx.rowIndex][cellIdx.colIndex];
            if (!cellObj || !cellObj[type])
                return;
            shapeObj = shapeMngr[type][oldElem[0].id];
			cellObj[type].some(function (obj, i) {
                if (oldElem[0].id === shapeMngr[type][cellObj[type][i]].id) {
                    cellPicIdx = i;
                    return true;
                }
                return false;
            });
            cObj[type] = cellObj[type][cellPicIdx];
            if (xlObj.getObjectLength(cellObj) < 2 && cellObj[type].length < 2)
                delete container.sheets[sheetIdx][cellIdx.rowIndex][cellIdx.colIndex];
            else if (cellObj[type].length < 2)
                delete container.sheets[sheetIdx][cellIdx.rowIndex][cellIdx.colIndex][type];
            else
                container.sheets[sheetIdx][cellIdx.rowIndex][cellIdx.colIndex][type].splice(cellPicIdx, 1);
            this._picCellIdx = cellIdx = this._getCellIndexFromOffset(imgElem.offsetTop, imgElem.offsetLeft);
            shapeObj.height = oldElem.height();
            shapeObj.width = oldElem.width();
            shapeObj.left = oldElem[0].offsetLeft;
            shapeObj.top = oldElem[0].offsetTop;
            shapeObj.rowIndex = cellIdx.rowIndex;
            shapeObj.colIndex = cellIdx.colIndex;
            xlObj.XLEdit._updateDataContainer({ rowIndex: cellIdx.rowIndex, colIndex: cellIdx.colIndex }, { dataObj: cObj });
        },

        changePictureBorder: function (pictureId, width, style, color) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), imgElem = $('#' + pictureId)[0], left = imgElem.offsetLeft, top = imgElem.offsetTop, details;
            var cellIdx = this._getCellIndexFromOffset(top, left), shapeMngr = xlObj.getSheet(sheetIdx).shapeMngr, shapeObj, picIdx, regx = new RegExp("\\b" + "e-shapebdr" + ".*?\\b", "g");
            shapeObj = shapeMngr.picture[imgElem.id];
            details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "picture", action: "border", id: $(xlObj.getSheetElement(sheetIdx).find(".e-ss-activeimg")).attr("id"), prevClass: ej.isNullOrUndefined(imgElem.className.match(regx)) ? imgElem.className : imgElem.className.match(regx)[0], picIdx: picIdx, cellIdx: cellIdx };
            var borderCss = width + " " + style + " " + color;
            var hashCode = this._getImgBorderHashCode({ "border-color": color, "border-style": style, "border-width": width });
            if(xlObj.model.allowCellFormatting)
				xlObj.XLFormat._writeCssRules(hashCode, xlObj.XLFormat._getCssPropertyAsString({ "border": { "left": borderCss, "right": borderCss, "top": borderCss, "bottom": borderCss } }));
            shapeObj.bcolor = color;
            shapeObj.bstyle = style;
            shapeObj.bwidth = width;
            if(imgElem.className.match(regx))
                imgElem.className = imgElem.className.replace(regx, "");
            $(imgElem).addClass(hashCode);
            details.curClass = hashCode;
            details.borderProp = this._getImgStyleFromHashCode(hashCode);
            if (!xlObj._dupDetails && !xlObj._isUndoRedo) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        _getCellIndexFromOffset: function (top, left, sheetIdx, isOverflow) {
            var i, len, value = 0, obj = {}, xlObj = this.XLObj, sheet = xlObj.getSheet(xlObj._getSheetIndex(sheetIdx));
            if (!ej.isNullOrUndefined(top)) {
                obj.rowIndex = xlObj._getMinRowIdx(sheet);
                for (i = 0, len = sheet._rowHeightCollection.length; i < len; i++) {
                    value = sheet._rowHeightCollection[i];
                    if (value > top) {
                        obj.rowIndex = i - 1;
                        break;
                    }
                }
            }
            if (!ej.isNullOrUndefined(left)) {
                obj.colIndex = 0;
                for (i = 0, value = 0, len = sheet.columnsWidthCollection.length; i < len; i++) {
					value += (sheet.columnsWidthCollection[i] === 0 && isOverflow) ? sheet.hideColsCollection[i] : sheet.columnsWidthCollection[i];
                    if (value > left) {
                        obj.colIndex = i;
                        break;
                    }
                }
            }
            return obj;
        },

        _getImgBorderHashCode: function (style) {
            var xlObj = this.XLObj, code = "";
            "border-width" in style && (code = parseInt(style["border-width"]) + "N");
            if(xlObj.model.allowCellFormatting && "border-style" in style) 
				code = (code + xlObj.XLFormat._getStyleCode("BorderStyle", style["border-style"]) +"N");
            "border-color" in style && (code = code + style["border-color"].replace("#", ""));
            return "e-shapebdr" + code;
        },

        _getImgStyleFromHashCode: function (code) {
            var xlObj = this.XLObj;
            var style = {}, bStyle = ["", "solid", "dashed", "dotted"];
            code = code || "";
            code = code.replace("e-shapebdr", "").split("N");
            if (code.length > 1) {
                style["border-width"] = code[0] + "px";
                style["border-style"] = bStyle[code[1]];
                style["border-color"] = "#" + code[2];
            }
            return style;
        },

        _scrollShape: function (sheetIdx, $visualImg, x, y) {
            var status = { position: "none", action: "none" }, xlObj = this.XLObj, $content = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content");
            if (((parseInt($visualImg.css('width')) + ($visualImg.offset().left - xlObj._getContent(sheetIdx).find(".e-content").offset().left)) > xlObj._getContent(sheetIdx).find(".e-content").width()) && (this._imgX <= x))
                status = { position: "horizontal", action: "Increment" };
            else if (($visualImg.offset().left - $content.offset().left) <= 0)
                status = { position: "horizontal", action: "Decrement" };
            else if (((parseInt($visualImg.css('height')) + ($visualImg.offset().top - xlObj._getContent(sheetIdx).find(".e-content").offset().top)) > xlObj._getContent(sheetIdx).find(".e-content").height()) && (this._imgY <= y))
                status = { position: "vertical", action: "Increment" };
            else if (($visualImg.offset().top - $content.offset().top) <= 0)
                status = { position: "vertical", action: "Decrement" };
            xlObj.XLSelection._scrollCalculation(sheetIdx, $visualImg.get(0), status);
        },

        _onKeyscrollShape: function (sheetIdx, $trgt, key) {
            var xlObj = this.XLObj, content = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"), hScroll = xlObj._getContent(sheetIdx).find("#hscrollBar").ejScrollBar("instance"), vScroll = xlObj._getContent(sheetIdx).find("#vscrollBar").ejScrollBar("instance");
            if (content.offset().top + content[0].offsetHeight <= ($trgt.offset().top + $trgt[0].offsetHeight) && (key.keyCode === 40 || (key.keyCode === 13 && !key.shiftKey)))
                vScroll.scroll(vScroll.value() + 2, true);
            else if ((($trgt.offset().top - xlObj.model.sheets[sheetIdx]._frozenHeight) <= content.offset().top) && (key.keyCode === 38 || (key.keyCode === 13 && key.shiftKey))) {
                if (vScroll.value() - 2 >= 0)
                    vScroll.scroll(vScroll.value() - 2, true);
            }
            if (content[0].offsetWidth <= ($trgt.offset().left + $trgt[0].offsetWidth) && (key.keyCode === 39 || (key.keyCode === 9 && !key.shiftKey)))
                hScroll.scroll(hScroll.value() + 2, true);
            else if ((($trgt.offset().left - xlObj.model.sheets[sheetIdx]._frozenWidth) <= content.offset().left) && (key.keyCode === 37 || (key.keyCode === 9 && key.shiftKey))) {
                if (hScroll.value() - 2 >= 0)
                    hScroll.scroll(hScroll.value() - 2, true);
            }
        }
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.chart = function (obj) {
        this.XLObj = obj;
        this._shapeCnt = 1;
    };

    ej.spreadsheetFeatures.chart.prototype = {
        createChart: function (range, options) {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowCharts || xlObj.model.isReadOnly)
                return;
            options = options || {};
            var cnt, chartElem, chartOptions, details, cellInfo, chartModel, chartRange, type = "chart", cellIdx, 
                sheetIdx = xlObj._getSheetIndex(options.sheetIdx), sheet = xlObj.getSheet(sheetIdx), sId, formulaBar, formulaWt;
            if (xlObj._isUndoRedo) {
                sId = options.id.split("_");
                cnt = sId[sId.length - 1].replace(/[a-z]/g, '');
            }
            range = xlObj._getRangeArgs(range, "object");
            if (!ej.isNullOrUndefined(options.top) && !ej.isNullOrUndefined(options.left))
                options.activeCell = xlObj.XLShape._getCellIndexFromOffset(options.top, options.left);
            if (!options.activeCell)
                options.activeCell = sheet._activeCell;
            if (!xlObj.isRange(range) || !options.activeCell)
                return;
            cellInfo = xlObj._getCellInfo(options.activeCell);
            options.id = cnt ? xlObj._id + "_" + type + cnt : xlObj._id + "_" + type + this._shapeCnt;
            options.type = options.type ? options.type : "column";
            options.animation = options.animation ? options.animation : false;
            options.range = range;
            options.dataSheetIdx = options.dataSheetIdx ? options.dataSheetIdx : sheetIdx;
            options.height = options.height ? options.height : xlObj.model.chartSettings.height;
            options.width = options.width ? options.width : xlObj.model.chartSettings.width;
            options.top = options.top ? options.top : cellInfo.top + 2;
            options.left = options.left ? options.left : cellInfo.left + 2;
            options.isRowColSwitched = options.isRowColSwitched ? options.isRowColSwitched : false;
            cellIdx = xlObj._getIdxWithOffset(options.top, options.left, true);
            options.rowIndex = cellIdx.rowIdx;
            options.colIndex = cellIdx.colIdx;
            options.isResponsive = false;
			options.canResize = false;
            if (xlObj.isUndefined(options.xRange)) {
                chartRange = this._processChartRange(range, options.dataSheetIdx);
                options.xRange = chartRange.xRange;
                options.yRange = chartRange.yRange;
                options.lRange = chartRange.lRange;
            }
            chartOptions = this._processChartSeries(options);
			if(options.series && (xlObj.XLClipboard._copyCells.length || xlObj.XLClipboard._copyCells.length))
			    chartOptions["series"] = options.series;
            options.xRange = chartOptions.xRange;
            options.yRange = chartOptions.yRange;
            options.lRange = chartOptions.lRange;
            if ((xlObj.getActiveSheetIndex() === options.dataSheetIdx))
                this._focusChartRange(chartOptions.xRange, chartOptions.yRange, chartOptions.lRange);
            chartElem = this._renderBaseElem(type, options.top, options.left, cnt);
            chartElem.ejChart(this._processChartOptions(options, chartOptions.series));
            this._afterChartRefresh();
            chartModel = chartElem.ejChart("model");
            options.theme = chartModel.theme;
            options.title = { text: chartModel.title.text.length ? chartModel.title.text : "", align: chartModel.title.textAlignment };
            options.xAxis = { min: chartModel.primaryXAxis.range.min, max: chartModel.primaryXAxis.range.max, interval: chartModel.primaryXAxis.range.interval, title: { text: chartModel.primaryXAxis.title.text.length ? chartModel.primaryXAxis.title.text : "" }, range: chartOptions.xRange };
            options.yAxis = { min: chartModel.primaryYAxis.range.min, max: chartModel.primaryYAxis.range.max, interval: chartModel.primaryYAxis.range.interval, title: { text: chartModel.primaryYAxis.title.text.length ? chartModel.primaryYAxis.title.text : "" }, range: chartOptions.yRange };
            options.legend = { visible: chartModel.legend.visible, range: chartOptions.lRange, position: chartModel.legend.position };
            !sheet._isImported && (xlObj.XLShape._insertShape = true);
            xlObj.XLShape._updateShapeMngr(options.activeCell, { chart: options }, "chart");
                if (options.theme.indexOf("dark") > -1)
                    chartElem.addClass('e-ss-charttheme');
                if (xlObj.model.showRibbon && !options.hideTab)
                    xlObj.XLRibbon._chartDesignTabUpdate(chartElem);
                xlObj._on(chartElem, ej.eventType.mouseDown, xlObj._mouseDownHandler);
                xlObj._on(chartElem, ej.eventType.mouseMove, xlObj._mouseMove);
                xlObj.setSheetFocus();
                if (!xlObj._isSheetNavigate && (!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && !xlObj._isPaste && !xlObj.XLClipboard._isShape) {
                    details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", action: "remove", options: options, range: options.range, id: options.id, position: { top: options.top, left: options.left }, operation: "create" };
                    xlObj._completeAction(details);
                    xlObj._trigActionComplete(details);
              
                }
                return options.id;
        },

        resizeChart: function (id, height, width) {
            var obj = {}, elem = $("#" + id), cModel = elem.ejChart("model"), xlObj = this.XLObj, formulaBar;
            if (xlObj.model.isReadOnly)
                return;
            if (elem.length) {
                (!ej.isNullOrUndefined(height) && height > 180) ? obj.height = height.toString() : obj.height = "180";
                (!ej.isNullOrUndefined(width) && width > 180) ? obj.width = width.toString() : obj.width = "180";
				if (xlObj.model.allowFormulaBar)
					formulaBar = xlObj.element.find('.e-formulabar')[0];
				formulaBar && (formulaBar.style.display = "none");
                elem.ejChart("option", { size: obj });
   				formulaBar && (formulaBar.style.display = "block");
                xlObj.XLRibbon._setShapeWidthHeight({ height: cModel.size.height, width: cModel.size.width, shapeType: "chart" });
            }
        },

        refreshChart: function (id, options) {// can update type, enable3D, marker and theme in chart           
            var xlObj = this.XLObj;
            if (!xlObj.model.allowCharts || xlObj.model.isReadOnly)
                return;
            var i, marker = "marker", cProp = this._getShapeObj(id, "chart");
            if (cProp) {
                for (i in options)
                    cProp[i] = options[i];
                if (options.type) {
                    options.commonSeriesOptions = { type: options.type };
                    delete options.type;
                }
                if (marker in options) {
                    if(options.commonSeriesOptions)
                        options.commonSeriesOptions.marker = { visible: options.marker.visible };
                    else
                        options.commonSeriesOptions = { marker: options.marker };
                    delete options[marker];
                }
                $("#" + id).ejChart("option", options);
            }
        },

        _processChartOptions: function (options, chartOptions) {
            var xVisiblity, yVisiblity, opt = { commonSeriesOptions: { type: options.type, enableAnimation: options.animation }, series: chartOptions == null ? options.series : chartOptions , canResize: options.canResize, size: { height: options.height.toString(), width: options.width.toString() }, enableRotation: false, depth: 100, wallSize: 2, tilt: 0, rotation: 34, perspectiveAngle: 90, sideBySideSeriesPlacement: true };
            xVisiblity = yVisiblity = false;
			if (options.enable3D)
                opt.enable3D = true;
            if (options.marker)
                opt.commonSeriesOptions.marker = options.marker;
            if (options.theme)
                opt.theme = options.theme;
            opt.title = options.title || {};
            if (this.XLObj.getObjectLength(opt.title) > 0) {
                opt.title.textAlignment = options.title.align;
                delete opt.title.align;
            }
            opt.legend = options.legend || {};
            if (options.xAxis && options.xAxis.minorGridLines)
                xVisiblity = options.xAxis.minorGridLines.visible;
            if (options.yAxis && options.yAxis.minorGridLines)
                yVisiblity = options.yAxis.minorGridLines.visible;
           opt.primaryYAxis = options.primaryYAxis || { labelFormat: this._chartYAxisFormat(options.yRange), minorTicksPerInterval: 5, minorGridLines: { visible: yVisiblity }, minorTickLines: { visible: false } };
           opt.primaryXAxis = options.primaryXAxis || { labelFormat: this._chartYAxisFormat(options.xRange), minorTicksPerInterval: 5, minorGridLines: { visible: xVisiblity }, minorTickLines: { visible: false }, valueType: "category" };
            return opt;
        },

         _chartYAxisFormat: function (range) {
           if (ej.isNullOrUndefined(range))
                return;
             var xlObj = this.XLObj, type, currencySymbol = ej.globalize.preferredCulture().numberFormat.currency.symbol;
             type = xlObj.XLEdit.getPropertyValue(range[0], range[1], "type");
           if (type === "accounting")
               return currencySymbol + " {value}";
           else if(type === "currency")
               return currencySymbol + "{value}";
           else if (type === "percentage")
               return "{value}%";
           else 
               return "{value}";
       },

        _processChartRange: function (range, dataSheetIdx) {
            var xlObj = this.XLObj, xRange, yRange, lRange, minr = range[0], minc = range[1], maxr = range[2], maxc = range[3],
                trVal = xlObj.XLEdit.getPropertyValue(minr, maxc, null, dataSheetIdx), blVal = xlObj.XLEdit.getPropertyValue(maxr, minc, null, dataSheetIdx),
                tlVal = xlObj.XLEdit.getPropertyValue(minr, minc, null, dataSheetIdx), isSingleRow = minr === maxr, isSingleCol = minc === maxc;
            if (xlObj.isUndefined(tlVal) && !isSingleRow && !isSingleCol) {
                xRange = [minr + 1, minc, maxr, minc];
                yRange = [minr + 1, minc + 1, maxr, maxc];
                lRange = [minr, minc + 1, minr, maxc];
            }
            else if ((!ej.isNullOrUndefined(blVal) && !xlObj.isNumber(blVal) && !isSingleRow && !isSingleCol)) {
                if (!ej.isNullOrUndefined(trVal) && !xlObj.isNumber(trVal)) {
                    xRange = [minr + 1, minc, maxr, minc];
                    yRange = [minr + 1, minc + 1, maxr, maxc];
                    lRange = [minr, minc + 1, minr, maxc];
                }
                else {
                    xRange = [minr, minc, maxr, minc];
                    yRange = [minr, minc + 1, maxr, maxc];
                }
            }
            else {
                yRange = [minr, minc, maxr, maxc];
                if ((!ej.isNullOrUndefined(trVal) && !xlObj.isNumber(trVal) && !xlObj._isDateTime(trVal))) {
                    lRange = [minr, minc, minr, maxc];
                    yRange[0] = yRange[0] + 1;
                }
                else if (ej.isNullOrUndefined(tlVal) && (isSingleRow || isSingleCol)) {
                    lRange = [minr, minc, minr, maxc];
                    if (isSingleRow) {
                        yRange[1] = yRange[1] + 1;
                        lRange[3] = lRange[1];
                    }
                    else
                        yRange[0] = yRange[0] + 1;
                }
            }
            return { xRange: xRange, yRange: yRange, lRange: lRange };
        },

        _processChartSeries: function (options) {
            options = options || {};
            var xlObj = this.XLObj, val, len, xRange = options.xRange, yRange = options.yRange, lRange = options.lRange, xValue, yValue,
                lValue, diff, rDiff, cDiff, pArr, pObj, j, inc, i = 0, yInc = 0, sArr = [], tArr = ["value2"];
            yValue = xlObj.getRangeData({ range: yRange, valueOnly: true, sheetIdx: options.dataSheetIdx, skipFormula: true });
            rDiff = (yRange[2] - yRange[0]) + 1;
            cDiff = (yRange[3] - yRange[1]) + 1;
            if (options.isRowColSwitched) {
                xValue = lRange ? xlObj._toArrayData(xlObj.getRangeData({ range: lRange, property: tArr, sheetIdx: options.dataSheetIdx })) : this._getVirtualXValues(cDiff + 1);
                if (xRange)
                    lValue = xlObj._toArrayData(xlObj.getRangeData({ range: xRange, property: tArr, sheetIdx: options.dataSheetIdx }));
                diff = rDiff;
            }
            else {
                xValue = xRange ? xlObj._toArrayData(xlObj.getRangeData({ range: xRange, property: tArr, sheetIdx: options.dataSheetIdx })) : this._getVirtualXValues(rDiff + 1);
                if (lRange)
                    lValue = xlObj._toArrayData(xlObj.getRangeData({ range: lRange, property: tArr, sheetIdx: options.dataSheetIdx }));
                diff = cDiff;
            }
            len = xValue.length;
            inc = options.isRowColSwitched ? 1 : diff;
            while (i < diff) {
                j = 0;
                pArr = [];
                yInc = options.isRowColSwitched ? yInc : i;
                while (j < len) {
                    val = yValue[yInc];
                    pArr.push({ x: xValue[j], y: xlObj.isNumber(val) ? Number(val) : 0 }); // Number(val) - numbers returned as string while import  
                    yInc += inc;
                    j++;
                }
                pObj = { points: pArr };
                if (lValue)
                    pObj.name = lValue[i];
                sArr.push(pObj);
                i++;
            }
            return { series: sArr, xRange: options.isRowColSwitched ? lRange : xRange, yRange: yRange, lRange: options.isRowColSwitched ? xRange : lRange };
        },

        _getVirtualXValues: function (limit) {
            var i = 1, arr = [];
            while (i < limit) {
                arr.push(i.toString());
                i++;
            }
            return arr;
        },

        _focusChartRange: function (xRange, yRange, lRange) {
            var xlObj = this.XLObj, border = xlObj._chartBorder;
            this._clearChartRange(xlObj._arrayAsString(border));
            if (lRange)
                xlObj.XLSelection._focusBorder({ rowIndex: lRange[0], colIndex: lRange[1] }, { rowIndex: lRange[2], colIndex: lRange[3] }, border[0]);
            if (xRange)
                xlObj.XLSelection._focusBorder({ rowIndex: xRange[0], colIndex: xRange[1] }, { rowIndex: xRange[2], colIndex: xRange[3] }, border[1]);
            xlObj.XLSelection._focusBorder({ rowIndex: yRange[0], colIndex: yRange[1] }, { rowIndex: yRange[2], colIndex: yRange[3] }, border[2]);
            xlObj.getSheet(xlObj.getActiveSheetIndex())._isChartBorderDrawn = true;
        },

        _clearChartRange: function (classes) {
            var xlObj = this.XLObj;
            xlObj.XLSelection._clearBorder(classes);
            xlObj.getSheet(xlObj.getActiveSheetIndex())._isChartBorderDrawn = false;
        },

        _renderBaseElem: function (type, top, left, cnt) {
            cnt = ej.isNullOrUndefined(cnt) ? this._shapeCnt : cnt;
            var xlObj = this.XLObj, div = $("<div id='" + xlObj._id + "_" + type + cnt + "' class='e-ss-object' style='top:" + top + "px;left:" + left + "px; min-height:180px; min-width:180px' ></div>");
            div.data("parentID", xlObj._id);
            xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-content").first().append(div);
            xlObj.XLShape._selectImg(div);
            if (!xlObj._isUndoRedo)
                this._shapeCnt++;
            return div;
        },

        _refreshChartElements: function (rowIdx, colIdx, sheetIdx) { // if rowIdx not passed then whole column consider and viceversa for colIdx
            var charts, i, chartProp, xlObj = this.XLObj, j = 1, cnt = xlObj.model.sheetCount + 1;
            while (j < cnt) {
                charts = xlObj.getSheet(j).shapeMngr.chart;
                i = xlObj.getObjectLength(charts);
                if (i) {
                    while (i--) {
                        chartProp = charts[xlObj.getObjectKeys(charts)[i]];
                        if (chartProp.dataSheetIdx === sheetIdx && (this.XLObj.inRange(chartProp.range, rowIdx, colIdx) || this.XLObj._inRow(chartProp.range, rowIdx) || this.XLObj._inColumn(chartProp.range, colIdx)))
                            this._refreshChart(chartProp);
                    }
                }
                j++;
            }
        },

        _refreshChart: function (chartProp) {
			if($("#" + chartProp.id).length !== 0){
				var xlObj = this.XLObj, formulaBar, cObj = $("#" + chartProp.id).data("ejChart"), obj = { xRange: chartProp.xRange, yRange: chartProp.yRange, lRange: chartProp.lRange, isRowColSwitched: chartProp.isRowColSwitched, dataSheetIdx: chartProp.dataSheetIdx }, cOptions;
				cObj.model.series.length = 0;
				cOptions = this._processChartSeries(obj);
				if (xlObj.model.allowFormulaBar)
					formulaBar = xlObj.element.find('.e-formulabar')[0];
				formulaBar && (formulaBar.style.display = "none");
				cObj.option({ series: cOptions.series, primaryXAxis: { labelFormat: this._chartYAxisFormat(chartProp.xRange) },primaryYAxis: { labelFormat: this._chartYAxisFormat(chartProp.yRange) } });
				formulaBar && (formulaBar.style.display = "block");
			}
        },

        switchRowColumn: function (chartId) {
			var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            var chOptions, obj, cid = chartId || document.getElementById(xlObj._id + "_chart").value, cObj = $("#" + cid).ejChart("instance"), dataVal = xlObj.XLChart._getShapeObj(cid, "chart"), details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "shape", shapeType: "chart", action: "srcolumn", cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex };
            cObj.model.series.length = 0;
            dataVal.isRowColSwitched = !dataVal.isRowColSwitched;
            obj = { xRange: dataVal.xRange, yRange: dataVal.yRange, lRange: dataVal.lRange, isRowColSwitched: dataVal.isRowColSwitched, dataSheetIdx: dataVal.dataSheetIdx };
            chOptions = xlObj.XLChart._processChartSeries(obj);
            cObj.option({ series: chOptions.series });
            xlObj.getActiveSheetIndex() === dataVal.dataSheetIdx && xlObj.XLChart._focusChartRange(chOptions.xRange, chOptions.yRange, chOptions.lRange);
            dataVal.xAxis.range = chOptions.xRange;
            dataVal.yAxis.range = chOptions.yRange;
            dataVal.legend.range = chOptions.lRange;
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },

        updateChartElement: function (chartId, value, title) {
            var xlObj = this.XLObj;
            if (xlObj.model.isReadOnly)
                return;
            xlObj._showDialog(xlObj._id + "_chartname");
            var formulaBar, cid = chartId || document.getElementById(xlObj._id + "_chart").value, args, series, cObj = $("#" + cid).ejChart("instance"), sheetIdx = xlObj.getActiveSheetIndex(),
            details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex }, dataVal = xlObj.getSheet(sheetIdx).shapeMngr.chart[xlObj.XLEdit.getPropertyValue(xlObj.XLShape._picCellIdx.rowIndex, xlObj.XLShape._picCellIdx.colIndex, 'chart')[0]];
            title ? (args = { model: { text: xlObj._getLocStr('Ok') } }) : (title = "");
            if (xlObj.model.allowFormulaBar)
				formulaBar = xlObj.element.find('.e-formulabar')[0];
			formulaBar && (formulaBar.style.display = "none");
			switch (value) {
                case "PHAxis":
                    details.visibility = !(cObj.model.primaryXAxis.visible);
                    cObj.option("primaryXAxis", { visible: details.visibility });
                    dataVal.xAxis.visible = details.visibility;
                    details.action = details.operation = value;
                    break;
                case "PVAxis":
                    details.visibility = !(cObj.model.primaryYAxis.visible);
                    cObj.option("primaryYAxis", { visible: details.visibility });
                    dataVal.yAxis.visible = details.visibility;
                    details.action = details.operation = value;
                    break;
                case "PHAxisTitle":
                    xlObj._cOpt.prev = { text: dataVal.xAxis.title.text };
                    if (cObj.model.primaryXAxis.title.text.length != 0) {
                        cObj.option("primaryXAxis", { title: { text: "" } });
                        dataVal.xAxis.title.text = "";
                        details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", operation: "PHAxisTitle", action: "PX", cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex, prev: { text: xlObj._cOpt.prev.text }, cur: { text: "" } };
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                    else {
                        xlObj._hasTitle = "PX";
                        document.getElementById(xlObj._id + '_chartname').value = dataVal.xAxis.title.text;
                        if (title.length < 1) {
                            $('#' + xlObj._id + '_chartnamedlg').ejDialog("open");
                            $("#" + xlObj._id + '_chartname').focus().setInputPos(dataVal.xAxis.title.text.length);
                        }
                        else
                            xlObj.XLRibbon._chartNameDlgBtnClick(args, title, "PHAxisTitle");
                        xlObj._cOpt = { prevText: dataVal.title.text, prevAlign: cObj.model.title.textAlignment, curAlign: cObj.model.title.textAlignment };
                    }
                    break;
                case "PVAxisTitle":
                    xlObj._cOpt.prev = { text: dataVal.yAxis.title.text };
                    if (cObj.model.primaryYAxis.title.text.length != 0) {
                        cObj.option("primaryYAxis", { title: { text: "" } });
                        dataVal.yAxis.title.text = "";
                        details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", operation: "PVAxisTitle", action: "PY", cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex, prev: { text: xlObj._cOpt.prev.text }, cur: { text: "" } };
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                    else {
                        xlObj._hasTitle = "PY";
                        document.getElementById(xlObj._id + '_chartname').value = dataVal.yAxis.title.text;
                        if (title.length < 1) {
                            $('#' + xlObj._id + '_chartnamedlg').ejDialog("open");
                            $("#" + xlObj._id + '_chartname').focus().setInputPos(dataVal.yAxis.title.text.length);
                        }
                        else
                            xlObj.XLRibbon._chartNameDlgBtnClick(args, title, "PVAxisTitle");
                        xlObj._cOpt = { prevText: dataVal.title.text, prevAlign: cObj.model.title.textAlignment, curAlign: cObj.model.title.textAlignment };
                    }
                    break;
			    case "CTNone":
                case "CTnone":
                    xlObj._cOpt.prev = { text: dataVal.title.text };
                    if (cObj.model.title.text.length) {
                        cObj.option("title", { text: "" });
                        dataVal.title.text = "";
                        details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", action: "CT", operation: "CTNone", cid: cid, rowIndex: xlObj.XLShape._picCellIdx.rowIndex, colIndex: xlObj.XLShape._picCellIdx.colIndex, prev: { text: xlObj._cOpt.prev.text }, cur: { text: "" } };
                        xlObj._completeAction(details);
                        xlObj._trigActionComplete(details);
                    }
                    break;
			    case "CTCenter":
			    case "CTcenter":
                    xlObj._hasTitle = "CT";
                    xlObj._cOpt = { prevText: cObj.model.title.text, prevAlign: cObj.model.title.textAlignment };
                    document.getElementById(xlObj._id + '_chartname').value = dataVal.title.text;
                    if (title.length < 1) {
                        $('#' + xlObj._id + '_chartnamedlg').ejDialog("open");
                        $("#" + xlObj._id + '_chartname').focus().setInputPos(dataVal.title.text.length);
                    }
                    else
                        xlObj.XLRibbon._chartNameDlgBtnClick(args, title, "CTCenter");
                    cObj.option("title", { textAlignment: "center" });
                    xlObj._cOpt.curAlign = cObj.model.title.textAlignment;
                    dataVal.title.align = "center";
                    break;
			    case "CTFar":
			    case "CTfar":
                    xlObj._hasTitle = "CT";
                    xlObj._cOpt = { prevText: cObj.model.title.text, prevAlign: cObj.model.title.textAlignment };
                    document.getElementById(xlObj._id + '_chartname').value = dataVal.title.text;
                    if (title.length < 1) {
                        $('#' + xlObj._id + '_chartnamedlg').ejDialog("open");
                        $("#" + xlObj._id + '_chartname').focus().setInputPos(dataVal.title.text.length);
                    }
                    else
                        xlObj.XLRibbon._chartNameDlgBtnClick(args, title, "CTFar");
                    cObj.option("title", { textAlignment: "far" });
                    xlObj._cOpt.curAlign = cObj.model.title.textAlignment;
                    dataVal.title.align = "far";
                    break;
			    case "CTNear":
			    case "CTnear":
                    xlObj._hasTitle = "CT";
                    xlObj._cOpt = { prevText: cObj.model.title.text, prevAlign: cObj.model.title.textAlignment };
                    document.getElementById(xlObj._id + '_chartname').value = dataVal.title.text;
                    if (title.length < 1) {
                        $('#' + xlObj._id + '_chartnamedlg').ejDialog("open");
                        $("#" + xlObj._id + '_chartname').focus().setInputPos(dataVal.title.text.length);
                    }
                    else
                        xlObj.XLRibbon._chartNameDlgBtnClick(args, title, "CTNear");
                    cObj.option("title", { textAlignment: "near" });
                    xlObj._cOpt.curAlign = cObj.model.title.textAlignment;
                    dataVal.title.align = "near";
                    break;
                case "DLNone":
                    series = [];
                    details.action = "DL";
                    details.operation = "DLNone";
                    details.prev = { series: $.extend(true, [], cObj.model.series) };
                    for (i = 0; i < cObj.model.series.length; i++)
                        series.push({ marker: { dataLabel: { visible: false, verticalTextAlignment: "far", textPosition: "top" } } });
                    cObj.option({ series: series });
                    details.cur = { series: $.extend(true, [], cObj.model.series) };
                    dataVal.dataLabel = { visible: false };
                    dataVal.series = cObj.model.series;
                    break;
                case "DLCenter":
                    series = [];
                    details.action = "DL";
                    details.operation = "DLCenter";
                    details.prev = { series: $.extend(true, [], cObj.model.series) };
                    for (i = 0; i < cObj.model.series.length; i++)
                        series.push({ marker: { dataLabel: { visible: true, verticalTextAlignment: "center", textPosition: "middle", offset: { y: 0 } } } });
                    cObj.option({ series: series });
                    details.cur = { series: $.extend(true, [], cObj.model.series) };
                    dataVal.dataLabel = { visible: true, vAlign: "center", tPosn: "middle" }; 
                    dataVal.series = cObj.model.series;
                    break;
                case "DLIBase":
                    series = [];
                    details.action = "DL";
                    details.operation = "DLIBase";
                    details.prev = { series: $.extend(true, [], cObj.model.series) };
                    for (i = 0; i < cObj.model.series.length; i++)
                        series.push({ marker: { dataLabel: { visible: true, verticalTextAlignment: "far", textPosition: "bottom", offset: { y: 0 } } } });
                    cObj.option({ series: series });
                    details.cur = { series: $.extend(true, [], cObj.model.series) };
                    dataVal.dataLabel = { visible: true, vAlign: "far", tPosn: "bottom" };
                    dataVal.series = cObj.model.series;
                    break;
                case "DLIEnd":
                    series = [];
                    details.action = "DL";
                    details.operation = "DLIEnd";
                    details.prev = { series: $.extend(true, [], cObj.model.series) };
                    for (i = 0; i < cObj.model.series.length; i++)
                        series.push({ marker: { dataLabel: { visible: true, verticalTextAlignment: "near", textPosition: "top", offset: { y: -10 } } } });
                    cObj.option({ series: series });
                    details.cur = { series: $.extend(true, [], cObj.model.series) };
                    dataVal.dataLabel = { visible: true, vAlign: "near", tPosn: "top" };
                    dataVal.series = cObj.model.series;
                    break;
                case "DLOEnd":
                    series = [];
                    details.action = "DL";
                    details.operation = "DLOEnd";
                    details.prev = { series: $.extend(true, [], cObj.model.series) };
                    for (i = 0; i < cObj.model.series.length; i++)
                        series.push({ marker: { dataLabel: { visible: true, verticalTextAlignment: "near", textPosition: "top", offset: { y: 0 } } } });
                    cObj.option({ series: series });
                    details.cur = { series: $.extend(true, [], cObj.model.series) };
                    dataVal.dataLabel = { visible: true, vAlign: "near", tPosn: "top" };
                    dataVal.series = cObj.model.series;
                    break;
                case "PMajorH":
                    details.visibility = !(cObj.model.primaryYAxis.majorGridLines.visible);
                    cObj.option("primaryYAxis", { majorGridLines: { visible: details.visibility } });
                    dataVal.yAxis.majorGridLines = { visible: details.visibility };
                    details.action = details.operation = value;
                    break;
                case "PMajorV":
                    details.visibility = !(cObj.model.primaryXAxis.majorGridLines.visible);
                    cObj.option("primaryXAxis", { majorGridLines: { visible: details.visibility } });
                    dataVal.xAxis.majorGridLines = { visible: details.visibility };
                    details.action = details.operation = value;
                    break;
                case "PMinorH":
                    details.visibility = !(cObj.model.primaryYAxis.minorGridLines.visible);
                    cObj.option("primaryYAxis", { minorGridLines: { visible: details.visibility }, minorTicksPerInterval: 5, minorTickLines: { visible: details.visibility } });
                    dataVal.yAxis.minorGridLines = { visible: details.visibility };
                    details.action = details.operation = value;
                    break;
                case "PMinorV":
                    details.visibility = !(cObj.model.primaryXAxis.minorGridLines.visible);
                    cObj.option("primaryXAxis", { minorGridLines: { visible: details.visibility }, minorTicksPerInterval: 5, minorTickLines: { visible: details.visibility } });
                    dataVal.xAxis.minorGridLines = { visible: details.visibility };
                    details.action = details.operation = value;
                    break;
                case "LNone":
                    details.visibility = false;
                    cObj.option("legend", { visible: details.visibility });
                    dataVal.legend.visible = details.visibility;
                    details.action = value;
                    details.operation = "LNone";
                    break;
                case "LLeft":
                    details.prev = { position: cObj.model.legend.position };
                    cObj.option("legend", { position: "left", visible: true });
                    dataVal.legend.position = "left";
                    details.cur = { position: cObj.model.legend.position };
                    details.action = "Legend";
                    details.operation = "LLeft";
                    break;
                case "LRight":
                    details.prev = { position: cObj.model.legend.position };
                    cObj.option("legend", { position: "right", visible: true });
                    dataVal.legend.position = "right";
                    details.cur = { position: cObj.model.legend.position };
                    details.action = "Legend";
                    details.operation = "LRight";
                    break;
                case "LBottom":
                    details.prev = { position: cObj.model.legend.position };
                    cObj.option("legend", { position: "bottom", visible: true });
                    dataVal.legend.position = "bottom";
                    details.cur = { position: cObj.model.legend.position };
                    details.action = "Legend";
                    details.operation = "LBottom";
                    break;
                case "LTop":
                    details.prev = { position: cObj.model.legend.position };
                    cObj.option("legend", { position: "top" });
                    dataVal.legend.position = "top";
                    details.cur = { position: cObj.model.legend.position };
                    details.action = "Legend";
                    details.operation = "LTop";
                    break;
            }
			formulaBar && (formulaBar.style.display = "block");
            if (!ej.isNullOrUndefined(details.action)) {
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },

        changeTheme: function (chartId, theme) {
            var xlObj = this.XLObj, chartId = chartId || xlObj.element.find("#" + xlObj._id + "_chart").val(), details;
            details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "shape", action: "chartTheme", chartId: chartId };
            details.prev = { theme: $("#" + chartId).data("ejChart").model.theme };
            theme && (theme.indexOf("dark") > -1) ? ($("#" + chartId).addClass('e-ss-charttheme')) : ($("#" + chartId).removeClass('e-ss-charttheme'));
            xlObj.XLChart.refreshChart(chartId, { theme: theme });
            details.cur = { theme: theme };
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },

        changeType: function (chartId, option) {
            var xlObj = this.XLObj, chartObj = $('#' + chartId).data('ejChart'), details = { sheetIndex: xlObj.getActiveSheetIndex(), reqType: "shape", shapeType: "chart", action: "chartType", chartId: chartId };
            details.prev = { chartType: chartObj.model.series[0].type, enable3D: chartObj.model.enable3D, marker: chartObj.model.series[0].marker.visible };
            xlObj.XLChart.refreshChart(chartId, option);
            details.cur = { chartType: chartObj.model.series[0].type, enable3D: chartObj.model.enable3D, marker: chartObj.model.series[0].marker.visible };
            $("#" + xlObj._id + "_charttypedlg").ejDialog("close");
            xlObj._completeAction(details);
            xlObj._trigActionComplete(details);
        },

        _getShapeObj: function (id, type) {
            var shape, xlObj = this.XLObj, shapeMngr = xlObj.getSheet(xlObj.getActiveSheetIndex()).shapeMngr[type], i = xlObj.getObjectLength(shapeMngr);
            if (i)
                 return shapeMngr[id];
        },

        _validateChartRange: function (range, xRange, yRange, lRange) {
            var xlObj = this.XLObj;
            if (!yRange)
                return { msg: xlObj._getLocStr("YAxisMissing") };
            if (!(xlObj.inRange(range, yRange[0], yRange[1]) || xlObj.inRange(range, yRange[2], yRange[3])))
                return { msg: xlObj._getLocStr("InvalidYAxis") };
            if (xRange) {
                if (!(xlObj.inRange(range, xRange[0], xRange[1]) || xlObj.inRange(range, range[2], range[3])))
                    return { msg: xlObj._getLocStr("InvalidXAxis") };
                else if (xRange[3] - xRange[1] !== 0)
                    return { msg: xlObj._getLocStr("InvalidXAxisColumns") };
            }
            if (lRange && !(xlObj.inRange(range, lRange[0], lRange[1]) || xlObj.inRange(range, lRange[2], lRange[3])))
                return { msg: xlObj._getLocStr("InvalidLegend") };
            return { status: true };
        },

        _renderChartRangeDialog: function () {
            var xlObj = this.XLObj, opt = { width: "25%", showRoundedCorner: true, click: $.proxy(this._chartRangeDlgBtnClick, this) }, htmlElem = $("<div id='" + xlObj._id + "_chartrangedlg'><div class='e-dlgctndiv e-dlg-fields'><table cellpadding='0' cellspacing='0'><tr class='e-dlgtd-fields'><td>" + xlObj._getLocStr("XAxisRange") + "</td><td><input type='text' class='ejinputtext' id='" + xlObj._id + "_crxaxis'/></td></tr><tr class='e-dlgtd-fields'><td>" + xlObj._getLocStr("YAxisRange") + "</td><td><input type='text' class='ejinputtext' id='" + xlObj._id + "_cryaxis' /></td></tr><tr class='e-dlgtd-fields'><td>" + xlObj._getLocStr("LegendRange") + "</td><td><input type='text' class='ejinputtext' id='" + xlObj._id + "_crlaxis'/></td></tr></table></div><div class='e-dlg-btnfields' ><div class='e-dlg-btnctnr'><button id='" + xlObj._id + "_crok' >" + xlObj._getLocStr("Ok") + "</button><button id='" + xlObj._id + "_crcancel'>" + xlObj._getLocStr("Cancel") + "</button></div></div></div>");
            xlObj.element.append(htmlElem);
            htmlElem.ejDialog({
                width: 310,
                height: "auto",
                enableResize: false,
                showOnInit: false,
                enableModal: true,
                cssClass: "e-ss-dialog e-"+xlObj._id+"-dlg e-ss-chartrange",
                title: xlObj._getLocStr("ChartRange")
            });
            $("#" + xlObj._id + "_crok").ejButton(opt);
			$("#" + xlObj._id + "_crok").ejButton("option", "cssClass", "e-ss-okbtn");
            $("#" + xlObj._id + "_crcancel").ejButton(opt);
        },

        _chartRangeDlgBtnClick: function (args) {
            var cid, xRange, yRange, lRange, canDlgClose = true, xlObj = this.XLObj;
            if (args.model.text === xlObj._getLocStr("Ok")) {
                cid = document.getElementById(xlObj._id + "_chart").value;
                xRange = $("#" + xlObj._id + "_crxaxis").val();
                yRange = $("#" + xlObj._id + "_cryaxis").val();
                lRange = $("#" + xlObj._id + "_crlaxis").val();
                this.changeDataRange(cid, xRange, yRange, lRange);
            }
            if (canDlgClose)
                $("#" + xlObj._id + "_chartrangedlg").ejDialog("close");
            
        },

        changeDataRange: function (cid, xRange, yRange, lRange) {
            var resp, chartData, xlObj = this.XLObj, canDlgClose, xIdx, yIdx, lIdx, sheetIdx = xlObj._getSheetIndex(xlObj.getActiveSheetIndex()), sheet = xlObj.getSheet(sheetIdx), details, selectData;
            chartData = this._getShapeObj(cid, "chart");
            if (xRange.length)
                xIdx = xlObj.getRangeIndices(xRange);
            if (yRange.length)
                yIdx = xlObj.getRangeIndices(yRange);
            if (lRange.length)
                lIdx = xlObj.getRangeIndices(lRange);
            selectData = { xRange: xRange, yRange: yRange, lRange: lRange };
            resp = this._validateChartRange(chartData.range, xIdx, yIdx, lIdx);
            if (resp.status) {
                chartData.xRange = xIdx;
                chartData.yRange = yIdx;
                chartData.lRange = lIdx;
                this._refreshChart(chartData);
                var cModel = $("#" + cid).ejChart("model");
                chartData.xAxis = { min: cModel.primaryXAxis.range.min, max: cModel.primaryXAxis.range.max, interval: cModel.primaryXAxis.range.interval, title: { text: cModel.primaryXAxis.title.text.length ? cModel.primaryXAxis.title.text : "" }, range: xIdx };
                chartData.yAxis = { min: cModel.primaryYAxis.range.min, max: cModel.primaryYAxis.range.max, interval: cModel.primaryYAxis.range.interval, title: { text: cModel.primaryYAxis.title.text.length ? cModel.primaryYAxis.title.text : "" }, range: yIdx };
                chartData.legend = { visible: cModel.legend.visible, range: lIdx };
                if (xlObj.getActiveSheetIndex() === chartData.dataSheetIdx)
                    this._focusChartRange(xIdx, yIdx, lIdx);
            }
            else {
                canDlgClose = false;
                xlObj._showAlertDlg("Alert", "T-" + resp.msg, "", 400);
            }
            if ((!sheet._isImported || sheet._isLoaded) && !xlObj._isUndoRedo && !xlObj._isExport) {
                details = { sheetIndex: sheetIdx, reqType: "shape", shapeType: "chart", action: "selectData", id: cid, prev: xlObj._selectDataval, cur: selectData };
                xlObj._completeAction(details);
                xlObj._trigActionComplete(details);
            }
        },
		
		_afterChartRefresh: function() {
			var xlObj = this.XLObj, formulaBar, formulaWt, settings = xlObj.model.scrollSettings;
			if (xlObj.model.allowFormulaBar) {
			    formulaBar = xlObj.element.find('.e-formulabar')[0];
				formulaBar.style.display = "none";
				formulaBar.style.display = "block";
            }
		}
    };
})(jQuery, Syncfusion);;
/// <reference path="ej.spreadsheet.print.js" />
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.print = function (obj) {
        this.XLObj = obj;
        this._printHeight = 950;
        this._pageHeight = 970;
        this._pageWidth = 750;
        this._marginTop = 30;
        this._marginBottom = 150;
        this._printRowLabels = false;
        this._isPrintSelection = false;
        this._stRow = 0;
        this._stColumn = 0;
    };
    ej.spreadsheetFeatures.print.prototype = {
        //Printing Feature
        _printSetting: function (value) {
            this.XLObj.model.pageSize = value;
            switch (value) {
                case ej.Spreadsheet.pageSize.A4:
                    this._printHeight = 950;
                    this._pageHeight = 970;
                    this._pageWidth = 750;
                    this._marginTop = 30;
                    this._marginBottom = 150;
                    break;
                case ej.Spreadsheet.pageSize.A3:
                    this._printHeight = 1350;
                    this._pageHeight = 1330;
                    this._pageWidth = 860;
                    this._marginTop = 30;
                    this._marginBottom = 150;
                    break;
                case ej.Spreadsheet.pageSize.Letter:
                    this._printHeight = 1040;
                    this._pageHeight = 920;
                    this._pageWidth = 860;
                    this._marginTop = 30;
                    this._marginBottom = 60;
                    break;
            }
        },

        printSelection: function () {
            var xlObj = this.XLObj;
            if (!xlObj.model.printSettings.allowPrinting || xlObj.model.isReadOnly)
                return;
            if (xlObj.model.printSettings.allowPageSize) {
                var j, len, rangeData, sheetIdx = xlObj.getActiveSheetIndex(), selectedCells = xlObj.getSheet(sheetIdx)._selectedCells, startCell = selectedCells[0], endCell = selectedCells[selectedCells.length - 1],
                    cellCount = endCell.colIndex - startCell.colIndex, selTable = ej.buildTag("table.e-table"), colgroup = ej.buildTag("colgroup"), col = xlObj._getContent(sheetIdx).find("col"), printDiv = ej.buildTag("div#printDiv.e-spreadsheet e-js", null, { border: "none" });
                xlObj._refreshTemplates(sheetIdx, true, startCell.colIndex, (startCell.colIndex + cellCount + 1));
                xlObj._isPrint = true;
                for (j = startCell.colIndex; j < endCell.colIndex; j++)
                    $(col[j].outerHTML).attr("id", "cc").appendTo(colgroup);
                rangeData = xlObj.getRangeData({ range: [startCell.rowIndex, startCell.colIndex, endCell.rowIndex, endCell.colIndex], property: ["value", "value2", "format", "border", "type", "isFilterHide", "isRHide", "isFHide", "isMHide", "merge", "hRow", "wrap", "overflow", "align", "hyperlink", "cFormatRule", "rule"], sheetIdx: sheetIdx, withRowIdx: true });
                selTable.html(xlObj._renderData(rangeData, sheetIdx, startCell.colIndex, cellCount + 1, true));
                colgroup.insertBefore(selTable.find('tbody'));
                this._stRow = startCell.rowIndex;
                this._stCol = startCell.colIndex;
                this._isPrintSelection = true;
                xlObj._isPrint = false;
                if (this._printRowLabels)
                    this._calculateTabCount(printDiv, sheetIdx, selTable);
                else
                    this._constructSheet(printDiv, sheetIdx, selTable, selTable[0].rows);
                xlObj._refreshTemplates(sheetIdx, true);
            }
            else {
                var i, links, link, stylesLink = [], selectedCells = xlObj.getSheet(sheetIdx)._selectedCells, startCell = selectedCells[0], endCell = selectedCells[selectedCells.length - 1], chartPicElem = xlObj.element.find(".e-ss-activeimg").clone();
                if (selectedCells.length)
                    this._flatPrint([startCell.rowIndex, startCell.colIndex, endCell.rowIndex, endCell.colIndex]);
                else if (chartPicElem.length) {
                    links = $("head").find("link").add("style");
                    for (i = 0, len = links.length; i < len; i++) {
                        link = links[i].href || "";
                        if ((links[i].tagName === "STYLE" && (links[i].id.indexOf(xlObj._id + "_sshide") > -1 || links[i].id.indexOf(xlObj._id + "_sscustomformat") > -1)) || link.indexOf("ej.pivotintegration.css") > -1 || link.indexOf("ej.widgets.core") > -1 || link.indexOf("ej.web.all") > -1 || link.indexOf("ej.theme") > -1) {
                            stylesLink.push(links[i]);
                        }
                    }
                    this.print(ej.buildTag("div#printDiv.e-spreadsheet e-js", chartPicElem.css({ top: 0, left: 0 }), { border: "none" }), stylesLink);
                }
            }
        },

        printSheet: function () {
            var xlObj = this.XLObj;
            if(!xlObj.model.printSettings.allowPrinting || xlObj.model.isReadOnly)
                return;
            if (xlObj.model.printSettings.allowPageSize) {
                var j, jLen, rangeData, printDiv = ej.buildTag("div#printDiv"), sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), colWtColl = sheet.columnsWidthCollection,
                    col = xlObj._getContent(sheetIdx).find("col"), selTable = ej.buildTag("table"), colgroup = ej.buildTag("colgroup");
                xlObj._refreshTemplates(sheetIdx, true, 0, sheet.usedRange.colIndex + 1);
                xlObj._isPrint = true;
                for (j = 0, jLen = colWtColl.length; j < jLen; j++)
                    $(col[j].outerHTML).attr("id", "cc").appendTo(colgroup);
                rangeData = xlObj.getRangeData({ range: [0, 0, sheet.usedRange.rowIndex, sheet.usedRange.colIndex], property: ["value", "value2", "format", "border", "type", "isFilterHide", "isRHide", "isFHide", "isMHide", "merge", "hRow", "wrap", "overflow", "align", "hyperlink", "cFormatRule", "rule"], sheetIdx: sheetIdx, withRowIdx: true });
                selTable.html(xlObj._renderData(rangeData, sheetIdx, 0, sheet.usedRange.colIndex + 1, true));
                colgroup.insertBefore(selTable.find('tbody'));
                if (this._printRowLabels)
                    this._calculateTabCount(printDiv, sheetIdx, selTable);
                else
                    this._constructSheet(printDiv, sheetIdx, selTable, selTable[0].rows);
                xlObj._isPrint = false;
                xlObj._refreshTemplates(sheetIdx, true);
            }
            else
                this._flatPrint();
        },

        _flatPrint: function (range) {
            var len, xlObj = this.XLObj, i, j, sIdx = 0, printCntElem, totWidth = 0, diffLeft, top, left, diffTop, rangeData, printDiv = ej.buildTag("div#printDiv.e-spreadsheet e-js", null, { border: "none" }), sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), colWtColl = sheet.columnsWidthCollection,
                jLen = sheet.usedRange.colIndex, col = xlObj._getContent(sheetIdx).find("col"), selTable = ej.buildTag("table.e-table"), colgroup = ej.buildTag("colgroup"), links = $("head").find("link").add("style"), stylesLink = [], chartPicElems = xlObj.element.find(".e-ss-object").clone(), link, inlineStyle = "", hRowCol = sheet.hideRowsCollection;
            xlObj._refreshTemplates(sheetIdx, true, 0, sheet.usedRange.colIndex + 1);
            xlObj._isPrint = true;
            if (range) { //for print selection
                sIdx = range[1];
                jLen = range[3];
            }
            for (j = sIdx; j <= jLen; j++) {
                $(col[j].outerHTML).attr("id", "cc").appendTo(colgroup);
                totWidth += colWtColl[j];
                if (colWtColl[j] === 0)
                    inlineStyle += "td.e-rowcell:nth-of-type(" + (j + 1) + "){display: none}";
            }
            printDiv.width(totWidth);
            rangeData = xlObj.getRangeData({ range: range ? range : [0, 0, sheet.usedRange.rowIndex, sheet.usedRange.colIndex], property: ["value", "value2", "format", "border", "type", "isFilterHide", "isRHide", "isFHide", "isMHide", "merge", "hRow", "wrap", "overflow", "align", "hyperlink", "cFormatRule", "rule", "isOverflow", "isOfBrdr"], sheetIdx: sheetIdx, withRowIdx: true });
            selTable.append(colgroup, xlObj._renderData(rangeData, sheetIdx, range ? range[1] : 0, (range ? range[3] - range[1] : sheet.usedRange.colIndex) + 1, true));
            selTable.width(totWidth);
            range && selTable.find('td[class=""]').remove(); //remove unwanted td in print selection
            for (j = 0; j < hRowCol.length; j++) { //hide row update
                if (range && !xlObj.inRange(range, j, range[1]))
                    continue;
                selTable.find("tr:eq(" + hRowCol[j] + ")").addClass("e-r-hide");
            }
            if (range) {
                printDiv.css({ overflow: "hidden" }); //Chart picture position update
                diffLeft = sheet._colWidthCollection[range[1]], diffTop = sheet._rowHeightCollection[range[0]];
                for (j = 0; j < chartPicElems.length; j++) {
                    top = parseInt(chartPicElems[j].style.top), left = parseInt(chartPicElems[j].style.left);
                    $(chartPicElems[j]).css({ top: (top - diffTop), left: (left - diffLeft) });
                }
            }
            printCntElem = ej.buildTag("div.e-content e-ss-cursor", selTable);
            printCntElem.append(chartPicElems);
            printCntElem = ej.buildTag("div.e-spreadsheetmainpanel", printCntElem, { width: totWidth, float: "none" });
            inlineStyle += ".e-spreadsheet .e-spreadsheetmainpanel .e-content .e-table tr td:first-child{ border-left-width: 1px; }.e-spreadsheet .e-spreadsheetmainpanel .e-content .e-table tr:first-child td{border-top-width: 1px;}table{page-break-inside: auto !important;}table tr{page-break-inside: avoid !important;}html,body{margin: 0; padding: 0; }";
            printDiv.append(printCntElem, ej.buildTag("style", inlineStyle, {}, { type: 'text/css' }));
            for (i = 0, len = links.length; i < len; i++) {
                link = links[i].href || "";
                if ((links[i].tagName === "STYLE" && (links[i].id.indexOf(xlObj._id + "_sshide") > -1 || links[i].id.indexOf(xlObj._id + "_sscustomformat") > -1)) || link.indexOf("ej.pivotintegration.css") > -1 || link.indexOf("ej.widgets.core") > -1 || link.indexOf("ej.web.all") > -1 || link.indexOf("ej.theme") > -1) {
                    stylesLink.push(links[i]);
                }
            }
            this.print(printDiv, stylesLink);
            xlObj._isPrint = false;
            xlObj._refreshTemplates(sheetIdx, true);
        },

        _calculateTabCount: function (printDiv, sheetIdx, table) {
            var xlObj = this.XLObj, cColl = [], tCount = 0, actualWidth = 0, colWtColl = xlObj.getSheet(xlObj.getActiveSheetIndex()).columnsWidthCollection;
            for (var i = 0, len = colWtColl.length; i < len; i++) {
                actualWidth += colWtColl[i];
                if (actualWidth >= this._pageWidth) {
                    cColl.push({ tCount: tCount + 1, cellCount: i });
                    actualWidth = 0;
                }
            }
        },

        _calculateCellRowCount: function (rows, startCell, startRow) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), colWtColl = sheet.columnsWidthCollection, rowHtColl = sheet.rowsHeightCollection, extra, actualWidth = 0, actualHeight = 0, cellCount = 12, rowCount = 40, endRow = 0, endCell = 0, len, i, j;
            for (i = startCell, len = colWtColl.length; i < len; i++) {
                actualWidth += colWtColl[i];
                if (actualWidth >= this._pageWidth) {
                    endCell = cellCount = i;
                    break;
                }
                else {
                    extra = Math.floor((this._pageWidth - actualWidth) / sheet.columnWidth);
                    endCell = cellCount = colWtColl.length + extra;
                }
            }

            for (j = startRow, len = rowHtColl.length; j < len; j++) {
                actualHeight += rowHtColl[j];
                if (actualHeight >= this._pageHeight) {
                    endRow = rowCount = j;
                    break;
                }
                else {
                    extra = Math.floor((this._pageHeight - actualHeight) / xlObj.model.rowHeight);
                    endRow = rowCount = rowHtColl.length + extra;
                }
            }
            var cells = { startCell: startCell, endCell: endCell, startRow: startRow, endRow: endRow, cellCount: cellCount, rowCount: rowCount };
            return cells;
        },

        _constructSheet: function (printDiv, sheetIdx, table, rows) {
            var maindiv = ej.buildTag("div .e-spreadsheet", "", {}), subdiv = ej.buildTag("div .e-spreadsheetmainpanel", "", {}), pageCount = 0, cells = this._calculateCellRowCount(rows, 0, 0);
            var totCellCount = rows[0].cells.length, totRowCount = rows.length;
            pageCount = Math.ceil(totCellCount / cells.cellCount);
            pageCount = pageCount * (Math.ceil(totRowCount / cells.rowCount));
            if(pageCount == 1)
                cells.rowCount = rows.length;
            maindiv.append(subdiv);
            this._constructPrintableElement(sheetIdx, printDiv, maindiv.find(".e-spreadsheetmainpanel"), table, rows, totRowCount, totCellCount, pageCount, cells.cellCount, cells.rowCount, cells.startRow, cells.startCell, cells.endRow, cells.endCell);
        },

        _constructPrintableElement: function (sheetIdx, printDiv, maindiv, maintable, rows, totRowCount, totCellCount, pageCount, cellCount, rowCount, startRow, startCell, endRow, endCell) {
            var trRow, tdTemplate, isFirst = false, table, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), duplicateDiv = ej.buildTag("div"), pageTable, rIdx,
                isEmpty = false, rowHt, isavbleRow = true, isRHide = false, isCHide = false, emptyTr = 0, currTable, i, j, cell, len, dupTab, cols = xlObj._getContent(sheetIdx).find('col'),
                colWtColl = sheet.columnsWidthCollection, rowHtColl = sheet.rowsHeightCollection;
            for (var h = pageCount; h > 0; h--) {
                pageTable = this._calculateCellRowCount(rows, startCell, startRow);
                startCell = pageTable.startCell; endCell = pageTable.endCell; startRow = pageTable.startRow; endRow = pageTable.endRow; cellCount = pageTable.cellCount; rowCount = pageTable.rowCount;
                table = this._constructTable(sheetIdx, startCell, endCell);
                if (sheet.showHeadings)
                    this._constructHeaders(startCell, endCell, endRow, table);
				if (this._isPrintSelection)
				    rIdx = (startRow < this._stRow) ? this._stRow : startRow;
                else
                    rIdx = startRow;
				for (i = startRow; i < endRow; i++) {
                    if (!ej.isNullOrUndefined(maintable[0].rows[i])) {
                        rowHt = rowHtColl[i];
                        isavbleRow = true;
                        trRow = (rowHt > 0) ? ej.buildTag("tr", "", { height: rowHt }) : ej.buildTag("tr", "", { height: xlObj.model.rowHeight });
                    }
                    else {
                        isavbleRow = false;
                        trRow = ej.buildTag("tr", "", { height: xlObj.model.rowHeight });
                    }
                    if (isavbleRow) {
                        isRHide = xlObj.XLEdit.getPropertyValue(i, 0, "isRHide");
                        if(!ej.isNullOrUndefined(isRHide))
                            xlObj.addClass(trRow[0], "e-r-hide");
                    }                       
                    for (j = startCell; j < endCell; j++) {
                        if (sheet.showHeadings && !isFirst) {
                            tdTemplate = "<td class=\"{0}\">{1}</td>";
                            $(String.format(tdTemplate, "e-rowcell e-header", (i + 1))).appendTo(trRow);
                            isFirst = true;
                        }
                        if ($(rows[i]).length > 0 && $(rows[i].cells[j]).length > 0) {
                            cell = $(rows[i].cells[j].outerHTML).attr("id", "ss");
                            cell.appendTo(trRow);
                        }
                        else {
                            cell = ej.buildTag("td.e-rowcell");
                            cell.appendTo(trRow);
                        }
                        isCHide = xlObj.XLEdit.getPropertyValue(0, j, "isCHide");
                        if (!ej.isNullOrUndefined(isCHide))
                            xlObj.addClass(cell[0], "e-col-hide");
                    }
                    isFirst = false;
                    table.append(trRow);
                }
                printDiv.append(table);
                if (endRow < totRowCount) {
                    startRow = endRow;
                    endRow = endRow + rowCount;
                }
                else if (endRow >= totRowCount) {
                    if (endCell >= totCellCount)
                        break;
                    startRow = 0;
                    endRow = rowCount;
                    startCell = endCell;
                    endCell = endCell + cellCount;
                }
            }
            for (i = printDiv.find("table").length - 1; i >= 0 ; --i) {
                currTable = $(printDiv.find("table")[i]);
                if (!isEmpty)
                    this._checkEmptyRow(sheetIdx, currTable, "first");
                emptyTr = sheet.showHeadings ? currTable.find("tr.empty").length + 1 : currTable.find("tr.empty").length;
                if ((currTable.find("tr").length !== emptyTr) || isEmpty) {
                    $(currTable.get(0).outerHTML).attr("id", "cc").appendTo(duplicateDiv);
                    isEmpty = true;
                }

            }
            dupTab = duplicateDiv.find("table");
            for (i = dupTab.length - 1 ; i >= 0 ; --i) {
                if (dupTab.length - 1 !== i) {
                    if (xlObj.model.pageSize === ej.Spreadsheet.pageSize.A4)
                        dupTab.eq(i).css({ 'margin-top': 300, 'margin-bottom': 300 });
                    if (xlObj.model.pageSize === ej.Spreadsheet.pageSize.A3)
                        dupTab.eq(i).css({ 'margin-top': 120, 'margin-bottom': 110 });
                    if (xlObj.model.pageSize === ej.Spreadsheet.pageSize.Letter)
                        if(sheet.showHeadings)
                            dupTab.eq(i).css({ 'margin-top': 70, 'margin-bottom': 50 });
                        else
                            dupTab.eq(i).css({ 'margin-top': 0, 'margin-bottom': 50 });
                }
                else if (dupTab.length - 1 === i)
                    dupTab.eq(i).css({ 'margin-top': 30, 'margin-bottom': sheet.showHeadings ? 20 : 0 });
                if (!i) {
                    if (dupTab.length > 1)
                        dupTab.eq(i).css({ 'margin-top': 120, 'margin-bottom': 0 });
                    this._checkEmptyRow(sheetIdx, dupTab.eq(i), "last");
                }
                $(dupTab[i].outerHTML).attr("id", "cc").appendTo(maindiv);
            }
            var links = $("head").find("link"), stylesLink = [];
            for ( i = 0, len = links.length; i < len; i++) {
                if (links[i].href.indexOf("ej.pivotintegration.css") > -1) {
                    stylesLink.push(links[i]);
                    break;
                }
            }
            maindiv = maindiv.parent();
            xlObj._trigger("_pivotPrint", { element: maindiv });
            this._isPrintSelection = false;
            this.print(maindiv, stylesLink, sheetIdx);
        },

        _checkEmptyRow: function (sheetIdx, currTable, tablePosn) {
            var emptyTd, emptyCnt, curTr = currTable.find("tr"), unformatted, unBordered, isMHide;
            for (var j = curTr.length - 1; j >= 0 ; --j) {
				emptyTd = $(curTr[j]).find(".e-rowcell").length;
                emptyCnt = $(curTr[j]).find(".e-rowcell:empty").length;
                emptyCnt = this.XLObj.getSheet(sheetIdx).showHeadings ? emptyCnt + 1 : emptyCnt;
				unformatted = $(curTr[j]).find('td[class *= "e-format"]').length;
				unBordered = $(curTr[j]).find('td[class *= "e-border"]').length;
				isMHide = $(curTr[j]).find('td[class *= "e-mc-hide"]').length;
				if ((emptyCnt === emptyTd) && unformatted < 1 && unBordered < 1 && isMHide < 1)
                    $(curTr[j]).addClass("empty");
                else {
                    $(curTr[j]).addClass("nonempty");
                    break;
                }
            }
            if (tablePosn === "last") {
                currTable.find("tr.empty").find("td").removeClass("e-rowcell");
                currTable.find("tr.empty").find("td.e-header").text("");
            }
        },

        _constructTable: function (sheetIdx, startCell, endCell) {
            var colgroup = ej.buildTag("colgroup"), xlObj = this.XLObj, pDiv =  ej.buildTag("div", "", { height: this._printHeight, 'margin-top': this._marginTop, 'margin-bottom': this._marginBottom}),  table = ej.buildTag("table.e-table", "", { height: this._printHeight, 'margin-top': this._marginTop, 'margin-bottom': this._marginBottom}),
                col = xlObj._getContent(xlObj.getActiveSheetIndex()).find("col"), newcol;
            if (xlObj.getSheet(sheetIdx).showHeadings) {
                newcol = "<col class=\"{0}\" style= \"width: 30px;\" >{1}</col>";
                $(newcol).appendTo(colgroup);
            }
            for (var j = startCell; j < endCell; j++)
                if ($(col[j]).length > 0)
                    $(col[j].outerHTML).attr("id", "cc").appendTo(colgroup);
                else {
                    newcol = "<col style= \"width: 64px;\" ></col>";
                    $(newcol).appendTo(colgroup);
                }
            table.append(colgroup);
            pDiv.append(table);
            return table;
        },

        _constructHeaders: function (startCell, endCell, endRow, table) {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), trRow = ej.buildTag("tr", "", { height: 30 }), tdTemplate, divTemplate, divcell, divCellData, tdCellData, isFirst = false,
                cols = xlObj._getContent(sheetIdx).find('col'), rClass = "e-rowcell";
            if (this._isPrintSelection) {
                if (startCell < this._stCol) {
                    endCell = endCell + (this._stCol - startCell);
                    startCell = this._stCol;
                }
            }
            tdTemplate = "<td class=\"{0}\">{1}</td>";
            divTemplate = "<div class = \"{0}\" > {1}</div>";
            for (var i = startCell; i <= endCell; i++) {
                if (!isFirst) {
                    divcell = "";
                    isFirst = true;
                }
                else {
                    divcell = xlObj._generateHeaderText(i);
                    rClass = !ej.isNullOrUndefined(xlObj.XLEdit.getPropertyValue(0, i - 1, "isCHide")) ? "e-rowcell e-col-hide" : "e-rowcell e-headercell";
                }
                divCellData = String.format(divTemplate, "e-headercelldiv", divcell);
                tdCellData = String.format(tdTemplate, rClass, divCellData);
                $(trRow[0]).append(tdCellData);
            }
            table.append(trRow);
        },

        print: function (element, links, sheetIdx) {
            var xlObj = this.XLObj;
            if (!xlObj.model.printSettings.allowPrinting || xlObj.model.isReadOnly)
				return;
            var printWin = window.open('', 'print', "height=" + screen.height + ",width=" + screen.width + ",tabbar=no");
			if(xlObj.isUndefined(printWin))
				return;
			var styletext, sty, a, $div = ej.buildTag("div"), elementClone = element.clone();
			$div.append(elementClone);
			printWin.document.write("<!DOCTYPE html>");
			if (xlObj._browserDetails.name === "msie") {
                a = "";
                if (links.length > 0)
                    $(links).each(function (index, obj) {
                        $(obj).attr("href", obj.href);
                        a += obj.outerHTML;
                    });
                printWin.document.write('<html><head></head><body>' + a + $div[0].innerHTML + '</body></html>');
            }
            else {
                a = "";
                printWin.document.write("<html><head>");
                if (links.length > 0)
                    $(links).each(function (index, obj) {
                        $(obj).attr("href", obj.href);
                        a += obj.outerHTML;
                    });
                printWin.document.writeln(a + "</head><body>");
                printWin.document.writeln($div[0].innerHTML + "</body></html>");
			}
			printWin.document.close();
            printWin.focus();
            setTimeout(function () {
                if ((xlObj._browserDetails.name === "msie") ? (xlObj.getObjectLength(printWin) && !ej.isNullOrUndefined(printWin.window) && !ej.isNullOrUndefined(printWin.location)) : (!ej.isNullOrUndefined(printWin.window) && !ej.isNullOrUndefined(printWin.location)))
                    printWin.print();                    
                setTimeout(function () { printWin.close(); }, 2000);
            }, 2000);
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.scroller = function (obj) {
        this.XLObj = obj;
        this._isIntrnlScroll = false;
    };

    ej.spreadsheetFeatures.scroller.prototype = {
        
        _getColWidths: function (sheetIdx, colIdx) {
            var i, len, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), colWidthColl = sheet.columnsWidthCollection,
                colWidth = sheet._colWidthCollection, val, ofColWidth = sheet._ofColWidthColl;
            if(!colIdx)
                colIdx = 1;
            for (i = colIdx, len = colWidthColl.length; i < len ; i++){
                colWidth[i] = colWidth[i - 1] + colWidthColl[i - 1];
				val = (colWidthColl[i - 1] === 0) ? sheet.hideColsCollection[i - 1] : colWidthColl[i - 1];
				ofColWidth[i] = ofColWidth[i - 1] + val;
			}
        },

        _getRowHeights: function (sheetIdx, rowIdx, cellHgt) { // no need this logic
            var i, blkIdx, len, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), rowHtColl = sheet.rowsHeightCollection, rowHeight = sheet._rowHeightCollection, hideRowsColl = sheet.hideRowsCollection;
            if (!rowIdx)
                rowIdx = 1;
            for (i = rowIdx, len = rowHtColl.length; i < len ; i++)
                rowHeight[i] = rowHeight[i - 1] + (hideRowsColl.indexOf(i - 1) > -1 ? 0 : rowHtColl[i - 1]);
            rowHeight[rowHeight.length - 1] = rowHeight[rowHeight.length - 2] + (hideRowsColl.indexOf(rowHtColl.length - 1) === -1 ? rowHtColl[rowHtColl.length - 2] : 0);
            if (!cellHgt && xlObj.model.scrollSettings.allowScrolling) {
                if (xlObj.model.scrollSettings.allowVirtualScrolling)
                    xlObj._refreshVrtlBlocks(sheetIdx);
                this._refreshScroller(sheetIdx, "refresh", "vertical");
            }
        },
		
        _createScroller: function (sheetIdx, settings, action) {
            var xlObj = this.XLObj, isHScroll = true, isVScroll = true, $content = xlObj._getContent(sheetIdx), vscroll = ej.buildTag("div#vscrollBar"),
                hscroll = ej.buildTag("div#hscrollBar"), sheet = xlObj.getSheet(sheetIdx), width = xlObj.model.scrollSettings.isResponsive ? settings.width - 2 : settings.width;
            sheet._contWidth = width;
            sheet._contHeight = settings.height;
            if (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal) {
                if (sheet._contWidth > xlObj._getEntireColWidth(sheetIdx))
                    isHScroll = false;
                if (sheet._contHeight > xlObj._getEntireRowHeight(sheetIdx))
                    isVScroll = false;
                hscroll[0].style.display = isHScroll ? "block" : "none";
                vscroll[0].style.display = isVScroll ? "block" : "none";
            }
            $content.append(vscroll).append(hscroll);
            xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").width(width - (isVScroll ? 18 : 0)).height(settings.height - (isHScroll ? 18 : 0));
            vscroll.ejScrollBar({
                orientation: "vertical",
                height: settings.height - (isHScroll ? 18 : 0),
                minimum: 0,
                viewportsize: settings.height,
                infiniteScrolling: true,
                scroll: $.proxy(this._scrollSpreadY, this)
            });
            hscroll.ejScrollBar({
                orientation: "horizontal",
                width: width - (isVScroll ? 17 : 0),
                minimum: 0,
                infiniteScrolling: true,
                viewportsize: settings.width,
                scroll: $.proxy(this._scrollSpreadX, this)
            });
            (action != "initial") && this._refreshScroller(sheetIdx, "initial", "all");
        },
        
        _hScroller: function (sheetIdx) {
            return this.XLObj._getContent(this.XLObj._getSheetIndex(sheetIdx)).find("#hscrollBar").data("ejScrollBar");
        },

        _vScroller: function (sheetIdx) {
            return this.XLObj._getContent(this.XLObj._getSheetIndex(sheetIdx)).find("#vscrollBar").data("ejScrollBar");
        },
		
        _refreshScroller: function (sheetIdx, status, type) {
            var modelWt, scrollWt, modelHt, scrollHt, noOfCol, noOfRow, fdiff = 0, xlObj = this.XLObj, sheetIdx = xlObj._getSheetIndex(sheetIdx), sheet = xlObj.getSheet(sheetIdx), hScroll = this._hScroller(sheetIdx),
                colWt = sheet.columnWidth, rowHt = sheet.rowHeight, vScroll = this._vScroller(sheetIdx), isScrlNrml = (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal),
                content = xlObj._getContent(sheetIdx), cont = content.find(".e-content")[0];
            if (isScrlNrml && hScroll && vScroll && content.find("table").length) {
                this._refreshContHgt(sheetIdx);
                type = (type === "horizontal") ? "all" : type;
            }
            /* ----------- Horizontal Scrollbar--------- */
            if (hScroll && (type === "all" || type === "horizontal")) {
                modelWt = cont.offsetWidth;
                scrollWt = xlObj._getWidth(0, sheet.colCount - 1, sheetIdx) - sheet._frozenWidth;
                if ((scrollWt < modelWt + 2 * colWt) && !isScrlNrml) {
                    noOfCol = Math.floor(((modelWt + (colWt * 5)) - scrollWt) / colWt);
                    for (var i = 0; i < noOfCol; i++) {
                        this._createNewColumn(sheetIdx, { rowIndex: -1, colIndex: -1 }, { rowIndex: -1, colIndex: -1 }, "insert");
                        scrollWt = scrollWt + colWt;
                    }
                }
                hScroll._scrollData.handleSpace = modelWt - (2 * hScroll.model.buttonSize);
                fdiff = xlObj._isFrozen(xlObj.getFrozenColumns()) ? xlObj._getColOffsetLeft(sheet, (xlObj.getFrozenColumns())) - sheet._contScrollLeft : 0;
                hScroll._scrollData.handle = Math.floor((modelWt - fdiff) / scrollWt * hScroll._scrollData.handleSpace);
                if (hScroll._scrollData.handle < 15)
                    hScroll._scrollData.handle = 15;
                hScroll._scrollData.scrollable = hScroll.model.maximum = scrollWt - (modelWt - fdiff);
                hScroll._scrollData.onePx = hScroll._scrollData.scrollable / (hScroll._scrollData.handleSpace - hScroll._scrollData.handle) || 1;
                hScroll["e-hhandle"].width(hScroll._scrollData.handle);
                hScroll.model.scrollLeft = hScroll._scrollData.handleSpace - hScroll._scrollData.handle;
            }
            if (vScroll && (type === "all" || type === "vertical")) {
                /* ----------- Vertical Scrollbar--------- */
                modelHt = cont.offsetHeight;
                scrollHt = xlObj._getMaxHgt(sheetIdx, true, true) - sheet._frozenHeight;
                if (!isScrlNrml && scrollHt < modelHt + (2 * rowHt)) {
                    noOfRow = Math.floor(((modelHt + (rowHt * 5)) - scrollHt) / rowHt);
                    for (var i = 0; i < noOfRow; i++) {
                        this._createNewRow(sheetIdx, -1, -1, "insert");
                        scrollHt = scrollHt + rowHt;
                    }
                }
                vScroll._scrollData.handleSpace = modelHt - (2 * vScroll.model.buttonSize);
                fdiff = xlObj._isFrozen(xlObj.getFrozenRows()) ? xlObj._getRowOffsetTop(sheet, (xlObj.getFrozenRows())) - sheet._contScrollTop : 0;
                vScroll._scrollData.handle = Math.floor((modelHt - fdiff) / scrollHt * vScroll._scrollData.handleSpace);
                if (vScroll._scrollData.handle < 15)
                    vScroll._scrollData.handle = 15;
                if (vScroll._scrollData.handle > vScroll._scrollData.handleSpace && xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Normal)
                    vScroll._scrollData.handle = vScroll._scrollData.handleSpace;
                vScroll._scrollData.scrollable = vScroll.model.maximum = scrollHt - (modelHt - fdiff);
                vScroll._scrollData.onePx = vScroll._scrollData.scrollable / (vScroll._scrollData.handleSpace - vScroll._scrollData.handle);
                vScroll["e-vhandle"].height(vScroll._scrollData.handle);
                vScroll.model.scrollTop = vScroll._scrollData.handleSpace - vScroll._scrollData.handle;
            }
        },

        _refreshContHgt: function (sheetIdx) {
            var hgt, cWidth, isHScrl, isVScrl, vScroll, hdlSpceHgt, hdlSpceWdth, hScroll, px = "px", none = "none", blk = "block", width = "width", height = "height", xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx),
                colWidth = xlObj._getEntireColWidth(sheetIdx), rowHeight = xlObj._getEntireRowHeight(sheetIdx), content = xlObj._getContent(sheetIdx), cont = content.find(".e-content"), hScrlStyle = content.find("#hscrollBar")[0].style, vScrlStyle = content.find("#vscrollBar")[0].style;
            hgt = cont[0].offsetHeight;
            cWidth = cont[0].offsetWidth;
            isHScrl = (hScrlStyle.display === none && sheet._contWidth < colWidth);
            isVScrl = (vScrlStyle.display === none && sheet._contHeight < rowHeight);
            if (isHScrl || (hScrlStyle.display === blk && sheet._contWidth > colWidth)) {
                hScrlStyle.display = isHScrl ? blk : none;
                hgt = isHScrl ? (hgt - 18) : (hgt + 19);
                isHScrl = true;
            }
            if (isVScrl || (vScrlStyle.display === blk && sheet._contHeight > rowHeight)) {
                vScrlStyle.display = isVScrl ? blk : none;
                cWidth = isVScrl ? (cWidth - 19) : (cWidth + 19);
                isVScrl = true;
            }
            if (isHScrl || isVScrl) {
                hdlSpceHgt = hgt - (2 * 18) + px;
                hgt += px;
                vScroll = content.find("#vscrollBar");
                cont[0].style[height] = hgt;
                xlObj._getJSSheetRowHeaderContent(sheetIdx)[0].style[height] = hgt;
                vScroll[0].style[height] = hgt;
                vScroll.find(".e-vscroll")[0].style[height] = hgt;
                vScroll.find(".e-vhandlespace")[0].style[height] = hdlSpceHgt;
                hScroll = content.find("#hscrollBar");
                cont[0].style[width] = cWidth + px;
                if (vScrlStyle.display === blk)
                    cWidth++;
                hdlSpceWdth = cWidth - (2 * 18) + px;
                cWidth += px;
                hScroll[0].style[width] = cWidth;
                hScroll.find(".e-hscroll")[0].style[width] = cWidth;
                hScroll.find(".e-hhandlespace")[0].style[width] = hdlSpceWdth;
            }
            colWidth += px;
            cont.find("table")[0].style[width] = colWidth;
            xlObj._getJSSheetHeader(sheetIdx).find("table")[0].style[width] = colWidth;
        },

        _changeTopSpread: function (vScroll, d, step, source) {
            var start = vScroll.value(), t = start + step;
            d.step = step;
            (!d.enableRTL ? t > d.scrollable : t < d.scrollable) && (t = d.scrollable);
            (!d.enableRTL ? t < 0 : t > 0) && (t = 0);
            vScroll["scroll"](t, source);
        },

        _spreadMouseWheel: function (e) {
            var xlObj = this.XLObj, activeCell, vScroll = this._vScroller(xlObj.getActiveSheetIndex());           
            if (ej.isNullOrUndefined(vScroll))
                return;
			xlObj._filterClose(e.target);
            e.stopImmediatePropagation();
            e.preventDefault();
            if (xlObj.element.find(".e-excelfilter.e-dlgcontainer").is(":visible") || xlObj._isSubMenuOpen() || xlObj._isSheetRename)
                return;
			if (xlObj.model.allowComments && xlObj.XLComment._isCommentEdit){
				activeCell = xlObj.getActiveCell();
				if(!ej.isNullOrUndefined(activeCell))
				xlObj.XLComment._updateCurCmntVal({ rowIndex: activeCell.rowIndex, colIndex: activeCell.colIndex });	
			}
			if (xlObj.model.allowDataValidation)
			    $("#" + xlObj._id + "ddl").ejDropDownList("hidePopup");
            var delta = 0, ori = e;
            e = e.originalEvent;
            if (e.wheelDelta) {
                delta = -e.wheelDelta / 120;
                if (window.opera) {
                    if (parseFloat(window.opera.version, 10) < 10)
                        delta = -delta;
                }
            } else if (e.detail) delta = e.detail / 3;
            if (!delta) return;
            if (this._changeTopSpread(vScroll, vScroll._scrollData, (delta * vScroll._scrollData.scrollOneStepBy), "wheel"))
                e.preventDefault ? e.preventDefault() : ori.preventDefault();
            $.data(this, 'timer', setTimeout(function () {
                xlObj._trigger("scrollStop", { originalEvent: e, scrollData: vScroll._scrollData, reqType: "vertical", position: vScroll.model.value });
            }, 250));
        },

        _scrollSpreadX: function (args) {
            var xlObj = this.XLObj;
            if (xlObj.getSheet()._isFreezed && xlObj._isFrozen(xlObj.getFrozenColumns())) {
                xlObj.XLFreeze._frozenScrollHandler(args)
                this._getFirstColumn(xlObj.getActiveSheetIndex());
            }
            else
                this._spreadHS(args);
		},

		_scrollDirection: function(scroller, pix){
            var xlObj = this.XLObj, scroller = xlObj._getContent(xlObj.getActiveSheetIndex()).find('#' + scroller).ejScrollBar('instance');
            if(scroller.value() < pix)
                scroller._scrollData.step = 1;
            else if(scroller.value() > pix)
                scroller._scrollData.step = -1;
            scroller.scroll(pix);
        },

		_spreadHS: function(args) {
		    var pix, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), hScroll = this._hScroller(sheetIdx), content = xlObj._getContent(sheetIdx),
                cont = content.find(".e-content"), colgrp = content.find('col'), sheet = xlObj.getSheet(sheetIdx), count = ((args.scrollLeft - sheet._scrollLeft) / sheet.columnWidth);
            args["reachedEnd"] = Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").css('left'))) + Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").width())) >= xlObj.element.find(".e-hhandlespace").width() - 2;
            pix = args.scrollLeft;
            if (xlObj.model.enableContextMenu)
                xlObj.XLCMenu.hideCMenu();
            if (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite && args.scrollData.step > -1 && !xlObj._scrollReverse) {
                if (args.reachedEnd && sheet._leftCol.idx + count <= sheet.colCount) {
                    args.cancel = true;
                    this._scrollRight(sheetIdx);
                    pix = (hScroll._scrollData.handleSpace - hScroll._scrollData.handle) * hScroll._scrollData.onePx;
                    this._refreshScroller(sheetIdx, "refresh", "horizontal");
                    hScroll.element.find(".e-hhandle").css("left", (hScroll._scrollData.handleSpace - (hScroll._scrollData.handle + 1)));
                    hScroll.value(pix);
                }
                else if (sheet._leftCol.idx + count > sheet.colCount && args.scrollLeft >= sheet._scrollLeft && args.scrollLeft > 0 && sheet.colCount < xlObj._maxColCnt) {
                    while (args.scrollLeft > sheet._colWidthCollection[sheet._colWidthCollection.length - 1])
                        this._scrollRight(sheetIdx);
                    this._refreshScroller(sheetIdx, "refresh", "horizontal");
                }
            }
            sheet._scrollLeft = args.scrollLeft = pix;
		    xlObj._scrollReverse = false;
            cont.scrollLeft(args.scrollLeft);
            sheet._scrollLeft = cont.scrollLeft();
            hScroll.value(args.scrollLeft);
            this._getFirstColumn(sheetIdx);
            xlObj._refreshViewVar(null, args.scrollLeft, sheetIdx);
        },

		_scrollSpreadY: function (args) {
		    var newCnt, ndiff, diff, oldCnt, activeCell, wdiff = 0, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), vScroll = xlObj.getSheetElement(sheetIdx).find("#vscrollBar");
		    if (sheet._isFreezed && xlObj._isFrozen(xlObj.getFrozenRows())) {
                xlObj.XLFreeze._frozenScrollHandler(args);
                this._getFirstRow(xlObj.getActiveSheetIndex());
            }
            else {
                oldCnt = xlObj.getDigits(sheet._bottomRow.idx);
                this.XLObj.model.scrollSettings.allowVirtualScrolling ? this._scrollHandler(args) : this._spreadVS(args);
                if (this.XLObj.model.allowComments && this.XLObj.XLComment._isCommentEdit) {
                    activeCell = this.XLObj.getActiveCell();
                    if (!ej.isNullOrUndefined(activeCell))
                        this.XLObj.XLComment._updateCurCmntVal({ rowIndex: activeCell.rowIndex, colIndex: activeCell.colIndex });
                }
                newCnt = xlObj.getDigits(sheet._bottomRow.idx);
                diff = newCnt - oldCnt;
                if (diff) {
                    if (newCnt > 3)
                        wdiff = ((newCnt - 3) * 10);
                    ndiff = xlObj._rowHeaderWidth + wdiff;
                    xlObj._getJSSheetRowHeaderContent(sheetIdx).find("col").width(ndiff);
                    xlObj._getJSSheetRowHeader(sheetIdx).width(ndiff);
                    xlObj._getJSSheetHeader(sheetIdx).find(".e-spreadsheetcolumnheader").width(ndiff - 1);
                    xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").width(sheet._contWidth - wdiff - (vScroll[0].style.display === "none" ? 0 : 18));//18 scroll bar width
                }
            }
		},

		_scrollHandler: function (args) {
		    var j, key, rIdx, rowIdx, contTBody, cellTypes, rowHdrTBody, rangeData, clKeys, nstartRIdx, nendRIdx, pstartRIdx, pendRIdx, rowIdxs, currentTopRow, offset, i, hgt, height, canRefresh, isRefreshed, prop, len, fitWidth,
                xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), aCell = xlObj.getActiveCell(sheetIdx), isScrollDown = args.scrollTop >= sheet._scrollTop, vScroll = this._vScroller(sheetIdx),
                count = ((args.scrollTop - sheet._scrollTop) / sheet.rowHeight) + 1, cont = xlObj._getContent(sheetIdx).find(".e-content"); // +1 for adding one extra row for creating a new block
		    offset = i = hgt = height = 0;
		    canRefresh = isRefreshed = false;
			if ((args.scrollTop === sheet._scrollTop || (sheet._bottomRow.idx + count > sheet.rowCount)) && xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite ) {
		        if (isScrollDown && args.scrollTop > 0 && sheet.rowCount < xlObj._maxRowCnt) {
		            rowIdx = sheet.rowCount;
		            do {
		                sheet._virtualBlockCnt++;
		                sheet.rowCount += sheet._virtualBlockRowCnt;
		                for (key in sheet._columnStyles) {
		                    rIdx = sheet._virtualBlockRowCnt;
		                    while (rIdx < sheet.rowCount) {
		                        xlObj.XLEdit._updateDataContainer({ rowIndex: rIdx, colIndex: parseInt(key) }, { dataObj: sheet._columnStyles[key] });
		                        rIdx++;
		                    }
		                }
		                while (i < sheet._virtualBlockRowCnt) {
		                    sheet.rowsHeightCollection.push(sheet.rowHeight);
		                    if (sheet.hideRowsCollection.indexOf(rowIdx) === -1 && sheet._hiddenFreezeRows.indexOf(rowIdx) === -1) {
		                        sheet._rowIdxColl.push(rowIdx);
		                        hgt = sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1] + sheet.rowHeight;
		                        sheet._virtualTBodyHgt += sheet.rowHeight;
		                    }
		                    else
		                        hgt = sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1];
		                    sheet._rowHeightCollection.push(hgt);
		                    rowIdx++;
		                    i++;
		                }
		                i = 0;
		            } while ((args.scrollTop + (sheet._virtualBlockRowCnt * sheet.rowHeight)) > sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1]);
		            this._refreshScroller(sheetIdx, "refresh", "vertical");
		            sheet._scrollTop = args.scrollTop;
                    xlObj._refreshViewport(args.scrollTop, sheetIdx);
                    cont.scrollTop(args.scrollTop);
                    sheet._scrollTop = cont.scrollTop();
		            canRefresh = true;
		        }
		    }
		    else {
		        prop = ["value", "value2", "comment", "hyperlink", "format", "border", "type", "isFilterHide", "filterState", "isMHide", "isFHide", "merge", "isFilterHeader", "isFilterVisible", "text", "general", "cFormatRule", "wrap", "wrapRow", "rule", "align", "isOverflow", "isOfBrdr", "altTxt"];
		        rowHdrTBody = xlObj._getRowHdrTBody(sheetIdx);
		        contTBody = xlObj._getContTBody(sheetIdx);
		        if (isScrollDown) {
		            if (args.scrollTop >= sheet._virtualContTBodyOffset.bottom && args.scrollTop <= sheet._virtualBottomTBodyOffset.bottom) {
		                height = sheet._virtualTopTBodyOffset.bottom - sheet._virtualTopTBodyOffset.top;
		                sheet._virtualTopTBodyOffset.top = sheet._virtualContTBodyOffset.top;
		                sheet._virtualTopTBodyOffset.bottom = sheet._virtualContTBodyOffset.bottom;
		                sheet._virtualContTBodyOffset.top = sheet._virtualBottomTBodyOffset.top;
		                sheet._virtualContTBodyOffset.bottom = sheet._virtualBottomTBodyOffset.bottom;
		                sheet._virtualContBlockIdx++;
		                if (sheet._virtualContBlockIdx === sheet._virtualBlockCnt) {
		                    sheet._virtualBottomTBodyOffset.top = sheet._virtualBottomTBodyOffset.bottom = 0;
		                    sheet._isVirtualEndReached = true;
		                }
		                else {
		                    sheet._virtualBottomTBodyOffset.top = sheet._virtualBottomTBodyOffset.bottom;
		                    nstartRIdx = xlObj._getRowIdx(sheet._virtualContBlockIdx * sheet._virtualBlockRowCnt, sheetIdx, true);
		                    nendRIdx = xlObj._getRowIdx((sheet._virtualContBlockIdx * sheet._virtualBlockRowCnt) + (sheet._virtualBlockRowCnt - 1), sheetIdx, true);
		                    sheet._virtualBottomTBodyOffset.bottom = xlObj._getRowOffsetBottom(nendRIdx, sheetIdx);
		                    rowIdxs = sheet._rowIdxColl.slice(sheet._rowIdxColl.indexOf(nstartRIdx), sheet._rowIdxColl.indexOf(nendRIdx) + 1);
		                    rangeData = xlObj.getRangeData({ property: prop, sheetIdx: sheetIdx, rowIdxs: rowIdxs, withRowIdx: true });
		                    rowHdrTBody.append(xlObj._renderRowHdr(rangeData.rowIdx, sheetIdx));
		                    contTBody.append(xlObj._renderData(rangeData, sheetIdx));
		                    sheet._virtualRowIdx = sheet._virtualRowIdx.concat(rangeData.rowIdx);
		                    canRefresh = true;
		                }
		                if (!sheet._isVirtualTopReached) {
		                    xlObj._removeRange(0, sheet._virtualBlockRowCnt);
		                    sheet._virtualRowIdx.splice(0, sheet._virtualBlockRowCnt);
		                    sheet._virtualTopTBodyHgt += height;
		                }
		                sheet._virtualBottomTBodyHgt = sheet._virtualTBodyHgt - (sheet._virtualTopTBodyHgt + Math.floor(parseFloat(window.getComputedStyle(contTBody[0],null).height)));
		                xlObj._refreshTBodiesHgt();
		                sheet._isVirtualTopReached = false;
		            }
		            else if (!sheet._isVirtualEndReached && args.scrollTop >= sheet._virtualBottomTBodyOffset.bottom) {
                        xlObj._refreshViewport(args.scrollTop, sheetIdx);
                        canRefresh = isRefreshed = true;
		            }
					if (xlObj.model.allowCellType)
						xlObj.XLCellType._rangeCellTypes(sheet.cellTypes, sheetIdx);
		        }
		        else {
		            if ((args.scrollTop + args.model.viewportsize) < sheet._virtualContTBodyOffset.top && (args.scrollTop + args.model.viewportsize) >= sheet._virtualTopTBodyOffset.top) {
		                height = sheet._virtualBottomTBodyOffset.bottom - sheet._virtualBottomTBodyOffset.top;
		                sheet._virtualBottomTBodyOffset.top = sheet._virtualContTBodyOffset.top;
		                sheet._virtualBottomTBodyOffset.bottom = sheet._virtualContTBodyOffset.bottom;
		                sheet._virtualContTBodyOffset.top = sheet._virtualTopTBodyOffset.top;
		                sheet._virtualContTBodyOffset.bottom = sheet._virtualTopTBodyOffset.bottom;
		                sheet._virtualContBlockIdx--;
		                sheet._virtualTopTBodyOffset.bottom = sheet._virtualContTBodyOffset.top;
		                if (sheet._virtualContBlockIdx === 1) {
		                    sheet._virtualTopTBodyOffset.top = 0;
		                    sheet._isVirtualTopReached = true;
		                }
		                else {
		                    pstartRIdx = xlObj._getRowIdx((sheet._virtualContBlockIdx - 2) * sheet._virtualBlockRowCnt, sheetIdx, true);
		                    pendRIdx = xlObj._getRowIdx((((sheet._virtualContBlockIdx - 2) * sheet._virtualBlockRowCnt) + (sheet._virtualBlockRowCnt - 1)), sheetIdx, true);
		                    sheet._virtualTopTBodyOffset.top = xlObj._getRowOffsetTop(sheet, pstartRIdx);
		                    rowIdxs = sheet._rowIdxColl.slice(sheet._rowIdxColl.indexOf(pstartRIdx), sheet._rowIdxColl.indexOf(pendRIdx) + 1);
		                    rangeData = xlObj.getRangeData({ property: prop, sheetIdx: sheetIdx, rowIdxs: rowIdxs, withRowIdx: true });
		                    rowHdrTBody.prepend(xlObj._renderRowHdr(rangeData.rowIdx, sheetIdx));
		                    contTBody.prepend(xlObj._renderData(rangeData, sheetIdx));
		                    sheet._virtualRowIdx = rangeData.rowIdx.concat(sheet._virtualRowIdx);
		                    canRefresh = true;
		                }
		                if (!sheet._isVirtualEndReached) {
		                    xlObj._removeRange(sheet._virtualContBlockIdx === 1 ? 2 * sheet._virtualBlockRowCnt : 3 * sheet._virtualBlockRowCnt, sheet._virtualBlockRowCnt);
		                    sheet._virtualRowIdx.splice(sheet._virtualContBlockIdx === 1 ? 2 * sheet._virtualBlockRowCnt : 3 * sheet._virtualBlockRowCnt, sheet._virtualBlockRowCnt);
		                    sheet._virtualBottomTBodyHgt += height;
		                }
		                sheet._virtualTopTBodyHgt = sheet._virtualTBodyHgt - (sheet._virtualBottomTBodyHgt + Math.floor(parseFloat(window.getComputedStyle(contTBody[0],null).height)));
		                xlObj._refreshTBodiesHgt();
		                sheet._isVirtualEndReached = false;
		                if (xlObj.model.allowCellType)
							xlObj.XLCellType._rangeCellTypes(sheet.cellTypes, sheetIdx);
		            }
		            else if (!sheet._isVirtualTopReached && (args.scrollTop + args.model.viewportsize) <= sheet._virtualTopTBodyOffset.top) {
		                xlObj._refreshViewport(args.scrollTop, sheetIdx);
		                canRefresh = isRefreshed = true;
		            }
		        }
		        if (!isRefreshed)
		            xlObj._refreshViewVar(args.scrollTop, null, sheetIdx);
		        sheet._scrollTop = args.scrollTop;
		    }
		    cont.scrollTop(args.scrollTop);
		    sheet._scrollTop = cont.scrollTop();
		    this._getFirstRow(sheetIdx);
		    if (xlObj.model.allowSelection && (sheet._isRowSelected || sheet._isColSelected || sheet._isSheetSelected)) {
		        xlObj.XLSelection.refreshSelection();
		        xlObj.XLDragFill.positionAutoFillElement();
		    }
		    if (canRefresh) {
		        if (xlObj.XLComment)
		            xlObj.XLComment._updateCmntArrowPos(xlObj._getContent(sheetIdx).find('.e-commentcell'));
		        clKeys = xlObj.getObjectKeys(xlObj._dataContainer.sheets[sheetIdx][0]);
		        xlObj._dupDetails = true;
		        for (i = 0, len = clKeys.length; i < len; i++) {
		            fitWidth = xlObj.XLEdit.getPropertyValue(0, clKeys[i], "isFitWidth");
		            if (!ej.isNullOrUndefined(fitWidth))
		                xlObj.XLResize._fitWidth(clKeys[i]);
		        }
		        xlObj._dupDetails = false;
		    }
		},
		
		_spreadVS: function(args) {
		    var pix, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), vScroll = this._vScroller(sheetIdx),
                content = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"), count = ((args.scrollTop - sheet._scrollTop) / sheet.rowHeight);
            args["reachedEnd"] = Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").css('top'))) + Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").height())) >= vScroll.element.find(".e-vhandlespace").height() - 2;
            pix = args.scrollTop;
            if (xlObj.model.enableContextMenu)
                xlObj.XLCMenu.hideCMenu();
            if (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite && args.scrollData.step > -1 && !xlObj._scrollReverse) {
                if (args.reachedEnd && sheet._bottomRow.idx + count <= sheet.rowCount) {
                    var hold = false, btnClk = false, proxy = this, interval;
                    if (!xlObj.isUndefined(args.scrollData.target) && xlObj._hasClass(args.scrollData.target, "e-vdown")) {
                        interval = setInterval(function (e) {
                            hold = true;
                            for (var i = 0; i < 20; i++)
                                proxy._scrollBottom(sheetIdx);
                            pix = (vScroll._scrollData.handleSpace - vScroll._scrollData.handle) * vScroll._scrollData.onePx;
                            proxy._refreshScroller(sheetIdx, "refresh", "vertical");
                            vScroll.element.find(".e-vhandle").css("top", (vScroll._scrollData.handleSpace - (vScroll._scrollData.handle)));
                            vScroll.scroll(pix);
                            clearInterval(interval);
                            return;
                        }, 1000);
                        if (xlObj._browserDetails.name === "msie" && xlObj._browserDetails.version === "8.0") {
                            vScroll.element.find(".e-vdown")[0].attachEvent("onmouseup", function (e) {
                                clearInterval(interval);
                                return;
                            });
                            document.attachEvent("onmouseup", function (e) {
                                clearInterval(interval);
                                return;
                            });
                        }
                        else {
                            vScroll.element.find(".e-vdown")[0].addEventListener("mouseup", function (e) {
                                clearInterval(interval);
                                return;
                            });
                            document.addEventListener("mouseup", function (e) {
                                clearInterval(interval);
                                return;
                            });
                        }
                        btnClk = true;
                    }
                    args.cancel = true;
                    if (!hold || !btnClk) {
                        this._scrollBottom(sheetIdx, (args.scrollTop - sheet._scrollTop)/20 + 1);
                        pix = (vScroll._scrollData.handleSpace - vScroll._scrollData.handle) * vScroll._scrollData.onePx;
                        proxy._refreshScroller(sheetIdx, "refresh", "vertical");
                        vScroll.element.find(".e-vhandle").css("top", (vScroll._scrollData.handleSpace - (vScroll._scrollData.handle)));
                        vScroll.value(pix);
                    }
                }
                else if (sheet._bottomRow.idx + count > sheet.rowCount - 1 && args.scrollTop >= sheet._scrollTop && args.scrollTop > 0 && sheet.rowCount < xlObj._maxRowCnt) {
                    this._scrollBottom(sheetIdx, (args.scrollTop - sheet._scrollTop)/20 + 1);
                    this._refreshScroller(sheetIdx, "refresh", "vertical");
                }
            }
            args.scrollTop = sheet._scrollTop = pix;
			xlObj._scrollReverse = false;
            content.scrollTop(args.scrollTop);
            sheet._scrollTop = content.scrollTop();
            this._getFirstRow(sheetIdx);
        },

        _scrollX: function (sheetIdx) {
            var i, len, xlObj = this.XLObj, hScroll = this._hScroller(sheetIdx), pix, colWtColl = [1], colgroup = xlObj._getContent(sheetIdx).find("colgroup"), sheet=xlObj.getSheet(sheetIdx);
            if (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite)
                this._scrollRight(sheetIdx);
            hScroll.model.maximum = hScroll.model.maximum + sheet.columnWidth;
            hScroll._scrollData.scrollable = hScroll._scrollData.scrollable + sheet.columnWidth;
            this._refreshScroller(sheetIdx, "refresh", "horizontal");
            hScroll.element.find(".e-hhandle").css("left", (hScroll._scrollData.handleSpace - (hScroll._scrollData.handle + 1)));
            pix = (hScroll._scrollData.handleSpace - hScroll._scrollData.handle) * hScroll._scrollData.onePx;
            hScroll.value(pix);
            for (i = 0, len = xlObj.model.sheets[sheetIdx]._fCol; i < len; i++)
                colWtColl.push(colWtColl[colWtColl.length - 1] + $(colgroup.find('col')[i]).width());
            if (sheet._isFreezed && xlObj._isFrozen(xlObj.getFrozenColumns())) 
                hScroll.scroll(hScroll.value() + xlObj._getColWidth(sheet._fleftColIdx, sheetIdx), true);
            else
                xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").scrollLeft(pix, hScroll._scrollData.onePx);
            sheet._scrollLeft = pix;
            this._getFirstColumn(sheetIdx);
        },

        _scrollY: function (sheetIdx) {
            var i, xlObj = this.XLObj, vScroll = this._vScroller(sheetIdx), pix, rowHtColl = [1], rows = xlObj.getRows(sheetIdx)[1];
            if (xlObj.model.scrollSettings.scrollMode === ej.Spreadsheet.scrollMode.Infinite)
                this._scrollBottom(sheetIdx);
            vScroll.model.maximum = vScroll.model.maximum + xlObj.model.rowHeight;
            vScroll._scrollData.scrollable = vScroll._scrollData.scrollable + xlObj.model.rowHeight;
            this._refreshScroller(sheetIdx, "refresh", "vertical");
            vScroll.element.find(".e-vhandle").css("top", (vScroll._scrollData.handleSpace - (vScroll._scrollData.handle + 1)));
            pix = (vScroll._scrollData.handleSpace - vScroll._scrollData.handle) * vScroll._scrollData.onePx;
            vScroll.value(pix);
            for (i = 0, len = xlObj.model.sheets[sheetIdx]._fRow; i < len; i++)
                rowHtColl.push(rowHtColl[rowHtColl.length - 1] + $(rows[i]).height());
            xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content").scrollTop(pix, vScroll._scrollData.onePx);
            this._getFirstRow(sheetIdx);
        },

        _getFirstRow: function (sheetIdx) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), top, topIdx, bottomIdx, rowHtColl = sheet._rowHeightCollection;
            top = xlObj._getContent(sheetIdx).find(".e-content").scrollTop();
            topIdx = xlObj._getIdxWithOffset(top, null, true, null, sheetIdx).rowIdx;
            sheet._topRow = { idx: topIdx, value: rowHtColl[topIdx] };
            bottomIdx = xlObj._getIdxWithOffset(top + sheet._vPortHgt, null, true, null, sheetIdx).rowIdx || sheet.rowCount - 1;
            sheet._bottomRow = { idx: bottomIdx, value: rowHtColl[bottomIdx] };
            sheet.topLeftCell = xlObj.getAlphaRange(sheet._topRow.idx, sheet._leftCol.idx);
        },

        _getFirstColumn: function (sheetIdx) {
            var xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), left, leftIdx, rightIdx, colWtColl = sheet._colWidthCollection;
            left = xlObj._getContent(sheetIdx).find(".e-content").scrollLeft();
            leftIdx = xlObj._getIdxWithOffset(null, left, true, null, sheetIdx).colIdx;
            sheet._leftCol = { idx: leftIdx, value: colWtColl[leftIdx] };
            rightIdx = xlObj._getIdxWithOffset(null, left + sheet._vPortWth, true, null, sheetIdx).colIdx || sheet.colCount - 1;
            sheet._rightCol = { idx: rightIdx, value: colWtColl[rightIdx] };
            sheet.topLeftCell = xlObj.getAlphaRange(sheet._topRow.idx, sheet._leftCol.idx);
        },

        scrollToCell: function (addr) {
            var rowhgt, colWdth, frowDiff = 0, fcolDiff = 0, xlObj = this.XLObj, range = xlObj.getRangeIndices(addr), sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx);

            if (range[0] > sheet.rowCount)
                rowhgt = xlObj._getRowOffsetBottom(sheet.rowCount - 1, sheetIdx) + ((range[0] - sheet.rowCount) * sheet.rowHeight);
            else
                rowhgt = xlObj._getRowOffsetBottom(range[0] - 1, sheetIdx);

            if (range[1] > sheet.colCount)
                colWdth = xlObj._getWidth(0, sheet.colCount - 1) + ((range[1] - sheet.colCount) * sheet.columnWidth);
            else
                colWdth = xlObj._getWidth(0, range[1] - 1);

            if (xlObj._isFrozen(sheet.frozenRows))
                frowDiff = xlObj._getRowOffsetTop(sheet, sheet._frozenRows - 1);

            if (xlObj._isFrozen(sheet.frozenColumns))
                fcolDiff = xlObj._getColOffsetLeft(sheet, sheet._frozenColumns - 1);

            xlObj._scrollContent({ x: (colWdth ? colWdth : 0) - sheet._scrollLeft - fcolDiff, y: (rowhgt ? rowhgt : 0) - sheet._scrollTop - frowDiff });
        },

        _scrollSelectedPosition: function (sheetIdx, aCell) {
            if (this.XLObj._isExport)
                return;
            var leftPx, topPx, buffHeight = 0, xlObj = this.XLObj, hScroll = this._hScroller(sheetIdx), vScroll = this._vScroller(sheetIdx), actCellInfo = xlObj._getCellInfo(aCell), sheet = xlObj.getSheet(sheetIdx), content = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer > .e-content"),
            dupDetails = xlObj._dupDetails, vReachedEnd = (Math.ceil(parseFloat(vScroll.element.find(".e-vhandle").css('top'))) + vScroll._scrollData.handle) >= (vScroll._scrollData.handleSpace), hReachedEnd = (Math.ceil(parseFloat(hScroll.element.find(".e-hhandle").css('left'))) + hScroll._scrollData.handle) >= (hScroll._scrollData.handleSpace);
            if (!xlObj.isUndefined(hScroll)) {
                if ((parseInt(actCellInfo.width) + (actCellInfo.left - content.offset().left)) > content.width())
                {
                    leftPx = actCellInfo.left - (hScroll._scrollData.handleSpace + hScroll.model.buttonSize);
                    if (leftPx < 0)
                        hScroll.scroll(0);
                    else {
                        hReachedEnd && (xlObj._scrollReverse = true);
                        if ((((parseInt(actCellInfo.width) + actCellInfo.left) > (hScroll._scrollData.handleSpace + (hScroll.model.buttonSize * 2))) || (actCellInfo.left - content.offset().left) <= 0) && leftPx != 0)
                            hScroll.scroll((actCellInfo.left + actCellInfo.width + 1) - (hScroll._scrollData.handleSpace + (hScroll.model.buttonSize * 2)));
                        xlObj._scrollReverse = false;
                    }
                } 
            }
            if (!xlObj.isUndefined(vScroll)) {
                if ((((parseInt(actCellInfo.height) + (actCellInfo.top - content.offset().top)) > content.height()) || ((actCellInfo.top - content.offset().top) <= 0)) && (aCell.rowIndex < sheet._topRow.idx || aCell.rowIndex > sheet._bottomRow.idx)) {
                    if (!aCell.rowIndex < sheet._bottomRow.idx && aCell.rowIndex < sheet.rowCount - 1)
                        buffHeight = actCellInfo.height;
                    topPx = actCellInfo.top + buffHeight - (vScroll._scrollData.handleSpace + vScroll.model.buttonSize);
                    if (topPx < 0)
                        vScroll.scroll(0);
                    else {
                        vReachedEnd && (xlObj._scrollReverse = true);
                        vScroll.scroll((actCellInfo.top + actCellInfo.height + 1) - (vScroll._scrollData.handleSpace + (vScroll.model.buttonSize * 2)));
                        xlObj._scrollReverse = false;
                    }
                }
            }
            xlObj._dupDetails = dupDetails;
        },

        //Infinite Scrolling JS	
        _rowTemplate: function (sheetIdx, value) {
            var i, len, rowCls, trRData, tdCell = "", xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx);
            for (i = 0, len = xlObj.model.sheets[sheetIdx].colCount; i < len; i++) {
                rowCls = "e-rowcell";
                !sheet.showGridlines && (rowCls = rowCls.concat(" e-hborder"));
                if (sheet._hiddenFreezeCols.indexOf(i) > -1)
                    rowCls += " e-fcol-hide";
                tdCell += String.format("<td class=\"{0}\" style=\"{2}\"  >{1}</td>", rowCls, "");
            }
            trRData = String.format("<tr style='{0}' idx=\"{1}\">" + tdCell + "</tr>", "height:" + xlObj.model.rowHeight + "px;", value - 1);
            return trRData;
        },

        _rowHeaderTemplate: function (value, height) {
            var tdRHdrCData, trRHdrData, height = height ? height : this.XLObj.model.rowHeight;
            tdRHdrCData = String.format("<td class=\"{0}\"  >{1}</td>", "e-rowheader", value);
            trRHdrData = String.format("<tr style='{0}' idx=\"{1}\">" + tdRHdrCData + "</tr>", "height:" + height + "px;", value - 1);
            return trRHdrData;
        },

        _columnTemplate: function (rowIndex) {
            var rowCls = "e-rowcell e-wrapword", tdCData, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex();
            !xlObj.getSheet(sheetIdx).showGridlines && (rowCls = rowCls.concat(" e-hborder"));
            tdCData = String.format("<td class=\"{0}\" style=\"{2}\" >{1}</td>", rowCls, "");
            return tdCData;
        },

        _colGroupTemplate: function (sheetIdx, width) {
            var width = width ? width : this.XLObj.getSheet(sheetIdx).columnWidth;
            var tdCData = String.format("<col style = '{0}'></col>", "width:" + width + "px;");
            return tdCData;
        },

        _columnHeaderTemplate: function (colCnt, sheetIdx) {
            var divcell, divCData, tdCData;
            divcell = this.XLObj._generateHeaderText(colCnt);
            divCData = String.format("<div class = \"{0}\" > {1}</div>", "e-headercelldiv", divcell);
            tdCData = String.format("<th class=\"{0}\"  >{1}</th>", "e-headercell", divCData);
            return tdCData;
        },

        _createNewRow: function (sheetIdx, rowIdx, colIdx, status) {
            var tbody, trow, trRData, tbodyRHdr, thdr, xlObj = this.XLObj, isVirtualScroll = xlObj.model.scrollSettings.allowVirtualScrolling, xlSelc = xlObj.XLSelection, sheet = xlObj.getSheet(sheetIdx), rowElemIdx;
            if (!isVirtualScroll) {
                tbody = xlObj._getContent(sheetIdx).find("tbody")[0];
                tbodyRHdr = xlObj._getJSSheetRowHeaderContent(sheetIdx).find("tbody")[0];
            }
            else {
                tbody = xlObj._getContent(sheetIdx).find("tbody")[1];
                tbodyRHdr = xlObj._getJSSheetRowHeaderContent(sheetIdx).find("tbody")[1];
            }
            trRData = this._rowTemplate(sheetIdx, parseInt(tbodyRHdr.lastChild.textContent) + 1);
            if (rowIdx === -1 || (colIdx > -1 && rowIdx > -1 && status === "shift")) {
                $(tbodyRHdr).append(this._rowHeaderTemplate(parseInt(tbodyRHdr.lastChild.textContent) + 1));
                $(tbody).append(trRData);
                if (status == "shift") {
                    $(tbody).find("tr:last td:last").remove();
                    rowElemIdx = xlObj._getRowIdx(rowIdx)
                    $(tbody).find("tr: eq(' + rowElemIdx + ') td:eq(' + (colIdx - 1) + ')").after(this._columnTemplate());
                }
            }
            else {
                trow = tbody.insertRow(rowIdx);
                $(trow).height(xlObj.model.rowHeight);
                $(trow).append($(trRData)[0].innerHTML);
                trow = tbodyRHdr.insertRow(rowIdx);
                $(trow).height(xlObj.model.rowHeight);
                $(trow).append("<td class='e-rowheader'></td>");
            }
            sheet.rowCount = xlObj.model.sheets[sheetIdx].rowCount + 1;
            sheet.rowsHeightCollection.push(xlObj.model.rowHeight);
            if (rowIdx > -1) {
				thdr = $(tbodyRHdr).find('td');
				for (var i = 0, len = thdr.length; i < len; i++)
					$(thdr[i]).text(i + 1);
				xlObj.XLScroll._getRowHeights(sheetIdx, rowIdx + 1 );
			}
            sheet._rowHeightCollection.push(sheet._rowHeightCollection[sheet._rowHeightCollection.length - 1] + xlObj.model.rowHeight);
			if (xlObj.model.allowSelection && (sheet._isColSelected || sheet._isSheetSelected))
			    xlSelc.refreshSelection();
			xlObj._refreshRows(sheetIdx);
        },

        _createNewColumn: function (sheetIdx, startCell, endCell, status) {
            var i, j, len, xlObj = this.XLObj, sheet = xlObj.getSheet(sheetIdx), xlSelc = xlObj.XLSelection, tbody, tbodyCHdr, colgrp, hdrcolgrp, colCnt, tdColgrp, tdRData, tdCHdrData, value,
            thdr, field, $outerDiv, $innerDiv, fIndex, fApplied = false, fRow, tabRange, colWtColl = sheet.columnsWidthCollection, isVScroll = xlObj.model.scrollSettings.allowVirtualScrolling, rowElemIdx;
            tbody = xlObj._getContTBody(sheetIdx)[0],
            tbodyCHdr = xlObj._getJSSheetHeader(sheetIdx).find("tr")[0];
            colgrp = xlObj._getJSSheetContent(sheetIdx).find(".e-spreadsheetcontentcontainer colgroup");
            hdrcolgrp = xlObj._getJSSheetHeader(sheetIdx).find("colgroup");
            colCnt = sheet.colCount;
            tabRange = sheet.filterSettings.tableRange;
            for (i = 0, len = tabRange.length; i < len; i++) {
                fIndex = tabRange[i].multifilterIdx;
                if ((startCell.colIndex > fIndex[0]) && (endCell.colIndex < fIndex[fIndex.length - 1])) {
                    fApplied = true;
                    fRow = tabRange[i].startRow - 1;
                    tabRange = tabRange[i];
                    break;
                }
            }
            if (startCell.colIndex === -1 || (startCell.colIndex > -1 && startCell.rowIndex > -1 && status === "shift")) {
                if (startCell.colIndex === -1 && status === "insert") {
                    tdCHdrData = this._columnHeaderTemplate(colCnt + 1, sheetIdx);
                    $(tbodyCHdr).append(tdCHdrData);
                    tdColgrp = this._colGroupTemplate(sheetIdx);
                    hdrcolgrp.append(tdColgrp);
                    for (i = 0, len = tbody.rows.length; i < len; i++) {
                        tdRData = this._columnTemplate(i);
                        $(tbody.rows[xlObj._getRowIdx(i, sheetIdx, false, true)]).append(tdRData);
                    }
                    colgrp.append(tdColgrp);
                }
                if (status === "shift") {
                    var x = colCnt;
                    for (i = startCell.colIndex; i <= endCell.colIndex; i++) {
                        tdCHdrData = this._columnHeaderTemplate(x + 1, sheetIdx);
                        $(tbodyCHdr).append(tdCHdrData);
                        tdColgrp = this._colGroupTemplate(sheetIdx);
                        hdrcolgrp.append(tdColgrp);
                        colgrp.append(tdColgrp);
                        x = x + 1;
                    }
                    for (i = 0, len = tbody.rows.length; i < len ; i++) 
                        for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                            tdRData = this._columnTemplate(i);
                            $(tbody.rows[xlObj._getRowIdx(i)]).append(tdRData);
                        }
                    if (xlObj._insDelStatus.indexOf("insert") > -1)
                        for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                            for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                                $(tbody).find('tr:eq(' + xlObj._getRowIdx(i) + ') td:last').remove();
                                tdRData = this._columnTemplate(i);
                                $(tbody).find("tr").eq(xlObj._getRowIdx(i)).find('td:eq(' + j + ')').before(tdRData);
                                if (fApplied && i === fRow)
                                    xlObj.model.allowFiltering && xlObj.XLFilter._insertFilterIcon(i, j, tabRange, fRow, fApplied);
                            }
                        }
                    else
                        for (i = startCell.rowIndex; i <= endCell.rowIndex; i++) {
                            for (j = endCell.colIndex; j >= startCell.colIndex; j--) {
                                $(tbody).find('tr:eq(' + xlObj._getRowIdx(i) + ') td:eq(' + j + ')').remove();
                                tdRData = this._columnTemplate(i);
                                $(tbody).find('tr:eq(' + xlObj._getRowIdx(i) + ')').append(tdRData);
                                if (fApplied && i === fRow)
                                    xlObj.model.allowFiltering && xlObj.XLFilter._insertFilterIcon(i, j, tabRange, fRow, fApplied);
                            }
                        }
                }
                sheet.colCount = sheet.colCount + 1;
                sheet.columnsWidthCollection.push(sheet.columnWidth);
            }
            else {
                if (sheet._isTemplate && (startCell.colIndex < sheet._templateColCount || endCell.colIndex < sheet._templateColCount))
                    return;
                //insert a column in particular position
                var fiCol, colWidthColl = $.extend(true, [], xlObj.getSheet(sheetIdx).columnsWidthCollection);
                if (xlObj._insDelStatus.indexOf("insert") > -1) {
                    fiCol = colWidthColl.splice(0, startCell.colIndex);
                    for (i = startCell.colIndex; i <= endCell.colIndex; i++) {
                        tdCHdrData = this._columnHeaderTemplate(i + 1, sheetIdx);
                        $(tbodyCHdr).find('th:eq(' + i + ')').before(tdCHdrData);
                        tdColgrp = this._colGroupTemplate(sheetIdx);
                        fiCol.push(sheet.columnWidth);
                        hdrcolgrp.find('col:eq(' + i + ')').before(tdColgrp);
                        colgrp.find('col:eq(' + i + ')').before(tdColgrp);      
						sheet.colCount = sheet.colCount + 1;					
                    }
                    ej.merge(fiCol, colWidthColl);
                    sheet.columnsWidthCollection = fiCol;
                    for (i = 0, len = tbody.rows.length; i < len  ; i++) {
                        for (j = startCell.colIndex; j <= endCell.colIndex; j++) {
                            tdRData = this._columnTemplate(i);
                            $(tbody.rows[xlObj._getRowIdx(i)]).find('td:eq(' + j + ')').before(tdRData);
                            if(fApplied && (i === fRow))
                                xlObj.model.allowFiltering && xlObj.XLFilter._insertFilterIcon(i, j, tabRange, fRow, fApplied);
                        }
                    }
                }
                else {
                    fiCol = colWidthColl.splice(0, startCell.colIndex);
                    for (i = endCell.colIndex; i >= startCell.colIndex; i--) {
                        $(tbodyCHdr).find('th:eq(' + i + ')').remove();
                        hdrcolgrp.find('col:eq(' + i + ')').remove();
                        colgrp.find('col:eq(' + i + ')').remove();
						sheet.colCount = sheet.colCount - 1;
                    }
                    colWidthColl.splice(0, (endCell.colIndex - startCell.colIndex) + 1);
                    ej.merge(fiCol, colWidthColl);
                    sheet.columnsWidthCollection = fiCol;
                    for (i = 0, len = tbody.rows.length; i < len; i++)
                        for (j = endCell.colIndex; j >= startCell.colIndex; j--)
                            $(tbody.rows[xlObj._getRowIdx(i)]).find('td:eq(' + j + ')').remove();
                }
                thdr = $(tbodyCHdr).find('th>.e-headercelldiv');
                for (i = 0, len = thdr.length; i < len ; i++)
                    $(thdr[i]).text(xlObj._generateHeaderText(i + 1));
            }
            field = $.trim($(tdCHdrData).text());
            value = $(tdRData).text();
            sheet.columns.push({
                field: field,
                type: value != null ? (value.getDay ? "date" : typeof (value)) : null,
                width: $(tdRData).width()
            });           
            xlObj.XLScroll._getColWidths(sheetIdx, (startCell.colIndex > -1) ? startCell.colIndex : sheet.colCount - 2); // 2 for delete or insert
			if (xlObj.model.allowSelection && (sheet._isRowSelected || sheet._isSheetSelected))
			    xlSelc.refreshSelection();
			xlObj._refreshTemplates(sheetIdx, true);
        },

        _insertColHeaders: function (sheetIdx, colCnt, tbodyCHdr) {
            var tdCHdrData = this._columnHeaderTemplate(colCnt + 1, sheetIdx), tdColgrp;
            $(tbodyCHdr).append(tdCHdrData);
            tdColgrp = this._colGroupTemplate(sheetIdx);
            $(tbodyCHdr.parentNode.previousSibling).append(tdColgrp);
        },

        _scrollBottom: function (sheetIdx, count) {
            var sheet = this.XLObj.getSheet(sheetIdx), key, cIdx;
			if(!count){
				this._createNewRow(sheetIdx, -1, -1, "insert");
				for (key in sheet._columnStyles) {
					cIdx = parseInt(key);
					this.XLObj.XLEdit._updateDataContainer({ rowIndex: sheet.rowCount - 1, colIndex: cIdx }, { dataObj: sheet._columnStyles[key] });
				}
			}
			else
				this._createRows(sheet.rowCount - 1, sheet.rowCount + count, sheetIdx);
        },
		
		_createRows: function (stRowIdx, rowCount, sheetIdx) {
            var xlObj = this.XLObj, sheetIdx = sheetIdx || xlObj.getActiveSheetIndex(), rhTdCellData, rhTrRow, sheet = xlObj.getSheet(sheetIdx), contTab, hdrTab, newContColl, newHdrColl, rhTrRow = "", data = [], sheetElem = xlObj.getSheetElement(sheetIdx);
            for (var i = stRowIdx, len = rowCount; i < len; i++)
                this._createNewRow(sheetIdx, -1, -1, "insert");

        },

        _scrollRight: function (sheetIdx) {
            var startCell = { rowIndex: -1, colIndex: -1 }, sheet, rIdx, key;
            this._createNewColumn(sheetIdx, startCell, startCell, "insert");

            sheet = this.XLObj.getSheet(sheetIdx);
            for (key in sheet._rowStyles) {
                rIdx = parseInt(key);
                this.XLObj.XLEdit._updateDataContainer({ rowIndex: rIdx, colIndex: sheet.colCount - 1 }, { dataObj: sheet._rowStyles[key] });
            }
        },

        _refreshRowCol: function (range, sheetIdx) {
            sheetIdx = this.XLObj._getSheetIndex(sheetIdx);
            var i, sheet = this.XLObj.getSheet(sheetIdx), refreshScroll = false;
            if (sheet.colCount < (range[3] + 1)) {
                i = range[3] - (sheet.colCount - 1);
                while (i--)
                    this._scrollRight(sheetIdx);
                refreshScroll = true;
            }
            if (sheet.rowCount < (range[2] + 1)) {
                i = range[2] - (sheet.rowCount - 1);
                while (i--)
                    this._scrollBottom(sheetIdx);
                refreshScroll = true;
            }
            refreshScroll && this._refreshScroller(sheetIdx, "refresh", "all");
        }
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.formatCellDialog = function (obj) {
        this.XLObj = obj;
        this._categories = [
               { value: "General", text: obj._getLocStr("LGeneral") }, { value: "Number", text: obj._getLocStr("NumberTab") }, { value: "Currency", text: obj._getLocStr("LCurrency") }, { value: "Accounting", text: obj._getLocStr("LAccounting") },
               { value: "Date", text: obj._getLocStr("LDate") }, { value: "Time", text: obj._getLocStr("LTime") }, { value: "Percentage", text: obj._getLocStr("LPercentage") }, { value: "Fraction", text: obj._getLocStr("LFraction") }, { value: "Scientific", text: obj._getLocStr("LScientific") }, { value: "Text", text: obj._getLocStr("LText") }, { value: "Custom", text: obj._getLocStr("LCustom") }
        ];
        this._selValue = "General";
    };

    ej.spreadsheetFeatures.formatCellDialog.prototype = {
        //Render Format Cell dialog
        _renderCellFrmtDlg: function () {
            var xlObj = this.XLObj, xlId = xlObj._id, dlgId = xlId + "_formatdlg", $dlg, $tab, $ctnr, $ul, $aTag, $li, $btndiv, $btnctnr, $okBtn, $canBtn;
			$dlg = ej.buildTag("div#" + dlgId);
            $tab = ej.buildTag("div#" + dlgId + "_formattab");
            $ctnr = ej.buildTag("div.e-dlg-fields e-dlgctndiv");
            //create tab Content
            $ul = ej.buildTag("ul .e-ul");
            $aTag = ej.buildTag("a", xlObj._getLocStr("NumberTab"), {}, { href: "#" + dlgId + "_number" });
            $li = ej.buildTag("li", $aTag);
            //extend other tabs here
            $ul.append($li);
            $tab.append($ul);
            $ctnr.append($tab);
            //create button content
            $btndiv = ej.buildTag("div.e-dlg-btnfields");
            $btnctnr = ej.buildTag("div.e-dlg-btnctnr");
            $okBtn = ej.buildTag("input#" + dlgId + "_okbtn");
            $canBtn = ej.buildTag("input#" + dlgId + "_cantn");
            $okBtn.ejButton({ text: xlObj._getLocStr("Ok"), showRoundedCorner: true, width: 60, click: ej.proxy(this._dlgCFOk, this) , cssClass: "e-ss-okbtn"});
            $canBtn.ejButton({ text: xlObj._getLocStr("Cancel"), showRoundedCorner: true, width: 60, click: ej.proxy(this._dlgCFCancel, this) });
            $btndiv.append($btnctnr.append($okBtn, $canBtn));
            //element for maintain data's(font-family, size, color, bgcolor,..etc)
            $ctnr.append(ej.buildTag("div#" + dlgId + "_format_dataMnger", "", { display: "none" }));
            xlObj.element.append($dlg.append($ctnr, $btndiv));
            //control rendering
            $tab.ejTab({ width: "100%", height: "auto", cssClass: "e-ss-dlgtab", allowKeyboardNavigation: false });
	        this._renderNumberTab();
            $dlg.ejDialog({ enableModal: true, showOnInit: false, enableResize: false, allowKeyboardNavigation: false, title: xlObj._getLocStr("Formatcells"), width: "auto", height: "auto", cssClass: "e-ss-dialog e-ss-mattab e-ss-fcdlg e-" + xlObj._id + "-dlg", open: function () { $("#" + xlObj._id + "_formatdlg_okbtn").focus(); } });
        },

        _renderNumberTab: function () {
            var $div, xlObj = this.XLObj, numbertabId = xlObj._id + "_fdlg_nTab", categories = this._categories, dateTypes, customList, timeTypes, $chkelem, $table, $tr, $tdlbl,
                $listUl, $td, $inputelem, $subTable, $subtr, $subtd, $opttd, $listDate, $listTime, $inputelem1, $customList, $custDelBtn, $custBtndiv, infodiv, $formatDrawer;
            dateTypes = [
              { text: "Wednesday, March 14, 2012", value: "{0:dddd, MMMM dd, yyyy}" }, { text: "3/14/2012", value: "{0:M/d/yyyy}" },
              { text: "March 03", value: "{0:MMMM dd}" }, { text: "2012 March", value: "{0:yyyy MMMM}" },
              { text: "3/14/12 1:30 PM", value: "{0:dd/MM/yyyy h:mm tt}" }
            ];
            customList = [
                { text: "0", type: "default" }, { text: "0.00", type: "default" }, { text: "#,##0", type: "default" }, { text: "#,##00.00", type: "default" },
                { text: "0%", type: "default" }, { text: "0.00%", type: "default" }, { text: "MM/dd/yyyy", type: "default" }, { text: "d-MMM", type: "default" },
                { text: "h:mm", type: "default" }, { text: "mm:ss", type: "default" }
            ];
            timeTypes = [
             { text: "1:30:55 PM", value: "{0:h:mm:ss tt}" }, { text: "1:30 PM", value: "{0:h:mm tt}" },
             { text: "13:30:55", value: "{0:h:mm:ss}" }, { text: "1:30", value: "{0:hh:mm}" }
            ];
            var $maindiv = ej.buildTag("div.e-ss-maindiv"), $top = ej.buildTag("div.e-ss-topdiv", "", { display: "inline-flex", width: "100%" }), $center = ej.buildTag("div.e-ss-centerdiv", "", { display: "inline-flex", width: "100%" }), $left = ej.buildTag("div.e-ss-lefttopdiv", ""), $right = ej.buildTag("div.e-ss-righttopdiv", "", {"float": "right" });
            $tdlbl = ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("FormatSample"));
            $right.append($tdlbl);
            $top.append($left, $right);
            $left = ej.buildTag("div.e-ss-leftdiv", ""), $right = ej.buildTag("div.e-ss-rightdiv", "", { "float": "right" })
            $inputelem = ej.buildTag("input#" + numbertabId + "_sinput.ejinputtext", "", {}, { disabled: "disabled" });
            $right.append($inputelem);
            $div = ej.buildTag("div#div" + numbertabId, "");
            
            //Decimal places prop
            $subTable = ej.buildTag("table", "", { "white-space": "normal" });
            $subtr = ej.buildTag("tr#" + numbertabId + "_decimal.e-fdlg-num-options");
            $subtd = ej.buildTag("td", ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("DecimalPlacesTxt")), "", { width: "103px" });
            $subTable.append($subtr.append($subtd));
            $subtr = ej.buildTag("tr#" + numbertabId + "_decimaldrop.e-fdlg-num-options");
            $subtd = ej.buildTag("td");
            $inputelem = ej.buildTag("input#" + numbertabId + "_decimalplace", "");
            $right.append($div.append($subTable.append($subtr.append($subtd.append($inputelem)))));
            //Thousand separator prop
            $subtr = ej.buildTag("tr#" + numbertabId + "_tseparator.e-fdlg-num-options");
            $subtd = ej.buildTag("td", "", "", { colspan: "2" });
            $chkelem = ej.buildTag("input#" + numbertabId + "_kseptr");
            $subTable.append($subtr.append($subtd.append($chkelem)));
            //Date types prop
            $subtr = ej.buildTag("tr#" + numbertabId + "_dtypes.e-fdlg-num-options");
            $subtd = ej.buildTag("td", ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("Type")));
            $listDate = ej.buildTag("ul#" + numbertabId + "_datetypes");
            $subTable.append($subtr.append($subtd.append($listDate)));
            //Time types prop
            $subtr = ej.buildTag("tr#" + numbertabId + "_ttypes.e-fdlg-num-options");
            $subtd = ej.buildTag("td", ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("Type")));
            $listTime = ej.buildTag("ul#" + numbertabId + "_timetypes");
            $subTable.append($subtr.append($subtd.append($listTime)));
            //Custom type prop
            $subtr = ej.buildTag("tr#" + numbertabId + "_custom.e-fdlg-num-options");
            $subtd = ej.buildTag("td", ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("Type")));
            $inputelem1 = ej.buildTag("input#" + numbertabId + "_custominput.ejinputtext");
            $customList = ej.buildTag("ul#" + numbertabId + "_customtypes");
            $custDelBtn = ej.buildTag("button#" + numbertabId + "_delBtn", xlObj._getLocStr("Delete"), {}, { type: "button" });
            $custBtndiv = ej.buildTag("div", $custDelBtn);
            $subTable.append($subtr.append($subtd.append($inputelem1, $customList, $custBtndiv)));
            xlObj._on($inputelem1, "keydown", this._validateCustomFormat);
            //Format type description elem
            infodiv = ej.buildTag("div#" + numbertabId + "_typeinfo.e-ss-fcgdiv", "", {});
            $right.append($div);
            $center.append($left, $right);
            $("#" + xlObj._id + "_formatdlg_number").append($maindiv.append($top, $center, infodiv));
            $subTable.find('.e-fdlg-num-options').hide();
            this._createNumList(categories, $left);
            //control creations
            $inputelem.ejNumericTextbox({
                name: "numeric",
                value: 2,
                height: 27,
                width: "100%",
                minValue: 0,
                maxValue: 30,
                change: $.proxy(this._refreshFrmtPropChanges, this)
            });
            $chkelem.ejCheckBox({ change: $.proxy(this._refreshFrmtPropChanges, this) });
            $chkelem.parent().append(ej.buildTag("label.e-dlg-fields", xlObj._getLocStr("ThousandSeparatorTxt"), { "margin-left": 6 }));
            $listDate.ejListBox({
                selectedItemIndex: "0",
                dataSource: dateTypes,
                fields: { text: "text", value: "value" },
                width: "100%",
                height: "120",
                selected: $.proxy(this._refreshFrmtPropChanges, this)
            });
            $listTime.ejListBox({
                selectedItemIndex: "0",
                dataSource: timeTypes,
                fields: { text: "text", value: "value" },
                width: "100%",
                height: "120",
                selected: $.proxy(this._refreshFrmtPropChanges, this)
            });
            $customList.ejListBox({
                selectedItemIndex: "0",
                dataSource: customList,
                fields: { text: "text", value: "value" },
                width: "100%",
                height: "100",
                selected: $.proxy(this._refreshFrmtPropChanges, this)
            });
            $("#" + numbertabId + "_datetypes_container").addClass("e-ss-datetypes");
            $("#" + numbertabId + "_timetypes_container").addClass("e-ss-timetypes");
            $("#" + numbertabId + "_customtypes_container").addClass("e-ss-customtypes");
            $custDelBtn.ejButton({ showRoundedCorner: true, width: 60, click: $.proxy(this._customFormatDelete, this) });
        },

        _initFormatCellDlg: function () {
            var xlObj = this.XLObj;
            if (!xlObj.model.allowCellFormatting)
                return false;
            $("#" + xlObj._id + "_formatdlg").ejDialog("open");
            this._updateFormtdata();
            $("#" + xlObj._id + "_formatdlg_format_dataMnger").removeData();
        },

        _updateFormtdata: function () {
            var xlObj = this.XLObj, actCell = xlObj.getActiveCell(), numlObj = $("#" + xlObj._id + "_fdlg_nTab_list").data("ejListBox"), decimalTxtbox = $("#" + xlObj._id + "_fdlg_nTab_decimalplace").data("ejNumericTextbox"),
                datetype = $("#" + xlObj._id + "_fdlg_nTab_datetypes").data("ejListBox"), timetype = $("#" + xlObj._id + "_fdlg_nTab_timetypes").data("ejListBox"), numddlObj = $("#" + xlObj._id + "_fdlg_nTab_input").data("ejDropDownList"),
                customList = $("#" + xlObj._id + "_fdlg_nTab_customtypes").data("ejListBox"), cellData, decimalPlaces, separator, type, dTypeIdx, tTypeIdx, dataSrc, frmtStr, cTypeIdx;
            numlObj && numlObj._refreshScroller();
            cellData = xlObj.getRangeData({ range: [actCell.rowIndex, actCell.colIndex, actCell.rowIndex, actCell.colIndex] })[0];
            decimalPlaces = "decimalPlaces" in cellData ? cellData.decimalPlaces : 2;
            separator = "thousandSeparator" in cellData ? cellData.thousandSeparator : false;
            type = "type" in cellData ? cellData.type.indexOf("date") > -1 ? "date" : cellData.type : "general";
            if ("formatStr" in cellData) {
                dTypeIdx = datetype.getIndexByValue(cellData.formatStr);
                tTypeIdx = timetype.getIndexByValue(cellData.formatStr);
                if (xlObj.isUndefined(dTypeIdx) && xlObj.isUndefined(tTypeIdx) && ["date"].indexOf(type) > -1) {
                    dataSrc = customList.model.dataSource;
                    frmtStr = cellData.formatStr.replace(/^\{0\:|\}$/g, "");
                    if (!xlObj._isValueAlreadyExist(dataSrc, "text", frmtStr)) {
                        dataSrc.push({ text: frmtStr, type: "custom" });
                        customList._setModel({ dataSource: dataSrc });
                    }
                    cTypeIdx = customList.getIndexByText(frmtStr);
                    type = "custom";
                }
            }
            else
                dTypeIdx = tTypeIdx = 0;
            numlObj && numlObj.selectItemByValue($.camelCase("-" + type));
            datetype.selectItemByIndex(dTypeIdx > -1 ? dTypeIdx : 0);
            timetype.selectItemByIndex(tTypeIdx > -1 ? tTypeIdx : 0);
            customList.selectItemByIndex(cTypeIdx > -1 ? cTypeIdx : 0);
            if (type === "string") {
                numlObj.selectItemByIndex(10);
                customList.selectItemByText(cellData.formatStr);
            }
            decimalTxtbox.option("value", decimalPlaces);
            $("#" + xlObj._id + "_fdlg_nTab_kseptr").ejCheckBox({ checked: separator });
            this._onNumFormatSelect({ value: numlObj ? numlObj.model.value : numddlObj.model.value });
        },

        _onNumFormatSelect: function (args) {
            var xlObj = this.XLObj, optId = "#" + xlObj._id + "_fdlg_nTab_", infoLbl = $("#" + xlObj._id + "_fdlg_nTab_typeinfo"), formattedText, value = args.value;
            $("#" + xlObj._id + "_formatdlg_number").find(".e-fdlg-num-options").hide();
            switch (value) {
                case "Number":
                    if (xlObj.model.formatSettings.allowDecimalPlaces)
                        $(optId + "decimal, " + optId + "tseparator, " + optId + "decimaldrop").show();
                    break;
                case "Currency":
                case "Accounting":
                case "Percentage":
                case "Scientific":
                    $(optId + "decimal").show();
                    $(optId + "decimaldrop").show();
                    break;
                case "Date":
                    $(optId + "dtypes").show();
                    $("#" + xlObj._id + "_fdlg_nTab_datetypes").data("ejListBox")._refreshScroller();
                    break;
                case "Time":
                    $(optId + "ttypes").show();
                    $("#" + xlObj._id + "_fdlg_nTab_timetypes").data("ejListBox")._refreshScroller();
                    break;
                case "Custom":
                    $(optId + "custom").show();
                    $("#" + xlObj._id + "_fdlg_nTab_customtypes").data("ejListBox")._refreshScroller();
                    break;
            }
            formattedText = this._getFormattedText(value);
            $("#" + xlObj._id + "_fdlg_nTab_decimalplace").data("ejNumericTextbox").option("maxValue", value === "Scientific" ? 20 : 30);
            $("#" + xlObj._id + "_fdlg_nTab_sinput").val(formattedText);
            infoLbl.text(xlObj._getLocStr(value));
            this._selValue = value
        },

        _getFormattedText: function (type) {
            var formatStr, isSeparator, value, cValue, formatObj, decimal = 0, xlObj = this.XLObj, actCell = xlObj.getActiveCell(), decimalTxtbox = $("#" + xlObj._id + "_fdlg_nTab_decimalplace").data("ejNumericTextbox"), datetype = $("#" + xlObj._id + "_fdlg_nTab_datetypes").data("ejListBox"),
                formattype = { Number: "0:N", Currency: "0:C", Accounting: "0:C", Percentage: "0:P", Scientific: "0:N" }, timetype = $("#" + xlObj._id + "_fdlg_nTab_timetypes").data("ejListBox"), cellType = ej.Spreadsheet.CellType, cellFormat = ej.Spreadsheet.CellFormat,
                customList = $("#" + xlObj._id + "_fdlg_nTab_customtypes").data("ejListBox");
            if (xlObj.model.formatSettings.allowDecimalPlaces)
                decimal = decimalTxtbox.getValue();
            value = xlObj.XLEdit.getPropertyValue(actCell.rowIndex, actCell.colIndex) || "";
            isSeparator = $("#" + xlObj._id + "_fdlg_nTab_kseptr").ejCheckBox("checked");
            switch (type) {
                case "Number":
                case "Currency":
                case "Accounting":
                case "Percentage":
                    formatStr = "{" + formattype[type] + decimal + "}";
                    if (xlObj._isDateTime(value))
                        value = xlObj._dateToInt(value);
                    value = xlObj.XLFormat._format(value, xlObj.XLFormat._getFormatObj({ formatStr: formatStr, thousandSeparator: isSeparator, type: cellType[type], decimalPlaces: decimal }));
                    break;
                case "Date":
                    formatStr = datetype.getSelectedItems()[0].value;
                    type = formatStr === cellFormat["longdate"] ? "longdate" : formatStr === cellFormat["shortdate"] ? "shortdate" : "date";
                    value = xlObj.XLFormat._format(value, xlObj.XLFormat._getFormatObj({ formatStr: formatStr, type: type }));
                    break;
                case "Time":
                    formatStr = timetype.getSelectedItems()[0].value;
                    value = xlObj.XLFormat._format(value, xlObj.XLFormat._getFormatObj({ formatStr: formatStr, type: cellType[type] }));
                    decimal = 0;
                    break;
                case "Scientific":
                    formatStr = "{" + formattype[type] + decimal + "}";
                    if (xlObj._isDateTime(value))
                        value = xlObj._dateToInt(value);
                    value = xlObj.XLFormat._format(value, xlObj.XLFormat._getFormatObj({ formatStr: formatStr, thousandSeparator: isSeparator, type: cellType[type], decimalPlaces: decimal }));
                    break;
                case "Fraction":
                    if (xlObj._isDateTime(value))
                        value = xlObj._dateToInt(value);
                    value = xlObj.toFraction(value);
                    if (value)
                        value = ej.isNullOrUndefined(value.numerator) ? value.integer : value.integer + " " + value.numerator + "/" + value.denominator;
                    break;
                case "General":
                case "Text":
                    if (xlObj._isDateTime(value))
                        value = xlObj._dateToInt(value);
                    break;
                case "Custom":
                    cValue = customList.getSelectedItems()[0].text;
                    formatObj = xlObj.XLFormat.customFormatParser(cValue);
                    $("#" + xlObj._id + "_fdlg_nTab_custominput").val(cValue);
                    value = xlObj.XLFormat._format(value, formatObj);
                    if (customList.getSelectedItems()[0].index > -1)
                        $("#" + xlObj._id + "_fdlg_nTab_delBtn").data("ejButton")._setModel({ enabled: customList.model.dataSource[customList.getSelectedItems()[0].index].type === "custom" });
                    break;
            }
            $("#" + xlObj._id + "_formatdlg_format_dataMnger").data("NumFormat", type === "Custom" ? formatObj : { type: type.toLowerCase(), decimalPlaces: decimal, thousandSeparator: isSeparator, formatStr: formatStr });
            return value;
        },

        _refreshFrmtPropChanges: function (args) {
            var xlObj = this.XLObj, formattedText;
            formattedText = this._getFormattedText(this._selValue);
            $("#" + xlObj._id + "_fdlg_nTab_sinput").val(formattedText);
        },

        _dlgCFCancel: function (args) {
            var xlObj = this.XLObj;
            $("#" + xlObj._id + "_formatdlg").ejDialog("close");
            xlObj.model.showRibbon && xlObj.XLRibbon._updateRibbonIcons();
            xlObj.setSheetFocus();
        },

        _dlgCFOk: function (args) {
            var xlObj = this.XLObj, dataMngr = $("#" + xlObj._id + "_formatdlg_format_dataMnger").data();
            if (args && this._selValue === "Custom" && this._validateCustomFormat())
                return;
            if (xlObj.getObjectLength(dataMngr.NumFormat)) {
                xlObj.XLFormat.format(dataMngr.NumFormat);            
            }
            xlObj.model.showRibbon && xlObj.XLRibbon._updateRibbonIcons();
            $("#" + xlObj._id + "_formatdlg").ejDialog("close");
            xlObj.setSheetFocus();
        },

        _customFormatDelete: function (args) {
            var lbInst = $("#" + this.XLObj._id + "_fdlg_nTab_customtypes").data("ejListBox"), dataSrc = lbInst.model.dataSource;
            dataSrc.splice(lbInst.model.selectedItemIndex, 1);
            lbInst._setModel({ dataSource: dataSrc });
            lbInst.selectItemByIndex(0);
            this._refreshFrmtPropChanges();
        },

        _validateCustomFormat: function (e) {
            var xlObj = e ? this : this.XLObj, lbInst, dataSrc, alertDlg, text = $("#" + xlObj._id + "_fdlg_nTab_custominput").val(), format = xlObj.XLFormat.customFormatParser(text);
            if (e && e.keyCode !== 13)
                return;
            if (xlObj.getObjectLength(format)) {
                lbInst = $("#" + xlObj._id + "_fdlg_nTab_customtypes").data("ejListBox");
                dataSrc = lbInst.model.dataSource;
                if (!xlObj._isValueAlreadyExist(dataSrc, "text", text)) {
                    dataSrc.push({ text: text, type: "custom" });
                    lbInst._setModel({ dataSource: dataSrc });
                }
                $("#" + xlObj._id + "_formatdlg_format_dataMnger").data("NumFormat", format);
                e && xlObj.XLCellFrmtDlg._dlgCFOk();
            }
            else {
                alertDlg = $("#" + xlObj._id + "_alertdlg");
                xlObj._renderAlertDlgContent(alertDlg, "Alert", xlObj._getLocStr("CustomFormatAlert"));
                alertDlg.ejDialog("open");
                return true;
            }
        },

        _createNumList: function (categories, $left) {
            var xlObj = this.XLObj, numbertabId = xlObj._id + "_fdlg_nTab", $tdlbl, $td, $ddlInput, $listUl, $drpdiv = ej.buildTag("div.e-ss-drpdiv");
            $ddlInput = ej.buildTag("input#" + numbertabId + "_input");
            $drpdiv.append($ddlInput)
            $("#" + xlObj._id + "_formatdlg_number").prepend($drpdiv);
            $ddlInput.ejDropDownList({ dataSource: categories, cssClass: "e-ss-num-format", width: "100%", fields: { id: "value", text: "text", value: "text" }, select: $.proxy(this._onNumFormatSelect, this), selectedItemIndex: 0 });

            $tdlbl = ej.buildTag("label#" + numbertabId + "_clabel.e-dlg-fields", xlObj._getLocStr("Category"));
            xlObj.element.find(".e-ss-lefttopdiv").append($tdlbl);
            $listUl = ej.buildTag("ul#" + numbertabId + "_list");
            $left.append($listUl);
            $listUl.ejListBox({
                selectedItemIndex: "0", width: "120", height: "250", dataSource: categories,
                fields: { text: "text", value: "value" }, select: $.proxy(this._onNumFormatSelect, this),
                allowMultiSelection: false
            });
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.spreadsheetFeatures = ej.spreadsheetFeatures || {};

    ej.spreadsheetFeatures.pivot = function (obj) {
        this.XLObj = obj;
        this._pivotCnt = 1;
        this._hasPvtField = false;
        this._displayActPanel = true;
        this.names = {};
    };

    ej.spreadsheetFeatures.pivot.prototype = {
       
        createPivotTable: function (range, location, name, settings, pvt) {
            var xlObj = this.XLObj, id;
            if (!xlObj.model.enablePivotTable || xlObj.model.isReadOnly)
                return;
            var xlRibbon = xlObj.XLRibbon, sheetIdx = xlObj.getActiveSheetIndex(), pvtRange = [], dataSheetName, datasource, details;
            var temp, left = 0, top = 0, pvtObj;
            xlObj._showDialog(xlObj._id + "_Ribbon_Insert_Tables_PivotTable");
            temp = xlRibbon._getAddrFromDollarAddr(range);
            dataSheetName = xlObj.model.sheets[temp[0]].sheetInfo.text;
            range = xlObj.getRangeIndices(temp[1]);
            datasource = xlObj.getRangeDataAsJSON({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, false, temp[0]);
            if ($("#" + xlObj._id + "_dlg_existsheet").data("ejRadioButton").model.checked || xlObj.isImport || !xlObj.getSheet(sheetIdx)._isLoaded) {
                temp = xlRibbon._getAddrFromDollarAddr(location);
                pvtRange = xlObj.getRangeIndices(temp[1]);
                if (!xlObj._isExport && (sheetIdx !== temp[0])) {
                    xlObj.gotoPage(temp[0], false);
                    sheetIdx = temp[0];
                }
            }
            else {
                xlObj.insertSheet();
                sheetIdx = xlObj.getActiveSheetIndex();
                pvtRange = [2, 0];
            }
            if (xlObj.isUndefined(pvt))
                pvt = {};
            top = xlObj.model.sheets[temp[0]]._rowHeightCollection[pvtRange[0]];
            left = xlObj.model.sheets[temp[0]]._colWidthCollection[pvtRange[1]];
            xlObj.hideActivationPanel();         
            if (name && name.length) {
                if (xlObj.getObjectKeys(this.names).indexOf(name) > -1) {
                    do {
                        name = name + this._pivotCnt;
                        this._pivotCnt++;
                    }
                    while (xlObj.getObjectKeys(this.names).indexOf(name) > -1);
                }
            }
            else {
                do {
                    name = "PivotTable" + this._pivotCnt;
                    this._pivotCnt++;
                }
                while (xlObj.getObjectKeys(this.names).indexOf(name) > -1);
            }
            id = xlObj._id + "_" + name;
            this.names[id] = name;
            pvt.pvtRange = pvtRange;
            pvt.sheetIdx = sheetIdx;
            pvt.temp = temp[0];
            pvt.datasource = datasource;
            !xlObj.getSheet(sheetIdx)._isUpdated && this._updatePivotMngr({}, { pivot: { id: id, top: top, left: left, rowIndex: pvtRange[0], colIndex: pvtRange[1], dataRange: range, dataSheetName: dataSheetName, sheetIdx: sheetIdx } });            
            this._refreshPivotElement(range, location, name, settings, pvt);
            pvtObj = xlObj.element.find("#" + id).data("ejPivotGrid");
            this._refreshRowColumn(pvtRange, pvtObj);
            xlObj.showActivationPanel();
            details = { sheetIndex: pvt.sheetIdx, reqType: "shape", shapeType: "pivot", range: pvt.pvtRange, ID: id, dataSource: pvt.datasource };
            xlObj._trigActionComplete(details);
            return id;
        },
            
        _refreshRowColumn: function (pvtRange, pvtObj) {
            var colCount, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), sheet = xlObj.getSheet(sheetIdx), width = [], rowCount, pvtObj, i, rowHeight;
            rowCount = pvtObj._rowCount, rowHeight = pvtObj.calculateCellWidths().rowHeight, width = pvtObj.calculateCellWidths().columnWidths, colCount = width.length;
            if (!rowCount) {
                rowCount = 4;
            }
            for (i = pvtRange[0]; i < rowCount + pvtRange[0]; i++)
                xlObj.XLResize.setRowHeight(i, rowHeight);
            if (colCount > 0) {
                for (i = 0; i < colCount + pvtRange[1]; i++)
                    xlObj.XLResize.setColWidth(i + pvtRange[1], width[i]);
            }
            else {
                for (i = 0; i < 3 + pvtRange[1]; i++)       //  default colcount 3, default column width 81px
                    xlObj.XLResize.setColWidth(i + pvtRange[1], 81);
            }
            if (sheet._isFreezed) {
                xlObj.XLFreeze._refreshFreezeRowDiv();
                xlObj.XLFreeze._refreshFreezeColDiv();
            }
        },

        _refreshPivotElement: function (range, location, name, settings, pvt) {
            var xlObj = this.XLObj, $pvtBase, $pvtSchema, pvtSettings, top, left;
            top = xlObj.model.sheets[pvt.sheetIdx]._rowHeightCollection[pvt.pvtRange[0]];
            left = xlObj.model.sheets[pvt.sheetIdx]._colWidthCollection[pvt.pvtRange[1]];
            pvtSettings = {
                dataSource: {
                    data: pvt.datasource,
                },
				enableToolTipAnimation: false,
                cellDoubleClick: $.proxy(this._cellDblClick, this),
                enableCellDoubleClick: true,
                renderSuccess: $.proxy(this._renderSuccess, this),
                drillSuccess: $.proxy(this._renderSuccess, this),
            };
            if (!ej.isNullOrUndefined(settings))
                pvtSettings.dataSource = {
                    data: pvt.datasource,
                    rows: settings.rows,
                    columns: settings.columns,
                    values: settings.values,
                    filters: settings.filters,
                };
            xlObj.getSheetElement(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot").removeClass("e-ss-activepivot");
            $pvtBase = ej.buildTag("div.e-ss-pivot", "", "", { id: xlObj._id + "_" + name });
            $pvtBase.css({ left: left - 2, top: top -2 }).addClass("e-ss-activepivot");
                xlObj._getContent(pvt.sheetIdx).find(".e-content").append($pvtBase);
                if (!this._hasPvtField)
                    xlObj.getActivationPanel().append(ej.buildTag("div", "", { overflow: "hidden" }, { id: xlObj._id + "_PivotField" }));
                xlObj.element.find("#" + xlObj._id + "_PivotField").append(ej.buildTag("div.e-ss-pivotfield", "", "", { id: xlObj._id + "_PivotTableSchema_" + xlObj._id + "_" + name }));
                $pvtSchema = xlObj.element.find("#" + xlObj._id + "_PivotTableSchema_" + xlObj._id + "_" + name);
                xlObj.getActivationPanel().find("#" + $pvtSchema[0].id).show();
                $pvtBase.ejPivotGrid(pvtSettings);                                             
                $pvtSchema.find("#" + xlObj._id + "_PivotTableSchema_" + xlObj._id + "_" + name + "_schemaFieldTree").data("ejTreeView").option("allowDragAndDrop", false);
                $pvtSchema.css({ "float": "left", "width": xlObj.model.activationPanelWidth - 20 });
                $pvtSchema.find(".schemaFieldList").css({ "height": 150 });
                if (!this._hasPvtField) {
                    xlObj.getActivationPanel().ejScroller({ width: xlObj.model.activationPanelWidth, height: xlObj._getContent(pvt.sheetIdx).height(), scroll: $.proxy(this._pivotScroll, this) });
                    this._hasPvtField = true;
                }
                this._clearBackgroundData($pvtBase.data("ejPivotGrid"), xlObj.getSheet(pvt.sheetIdx).pivotMngr.pivot[$pvtBase[0].id], pvt.sheetIdx, "update");                               
                xlObj.XLRibbon && xlObj.XLRibbon._analyzeTabUpdate();
                xlObj.XLSelection._cleanUp(true);   
                xlObj.getActivationPanel().data("ejScroller").refresh();
           
        },

        deletePivotTable: function (pivotName) {
            var len, pvtID = this._getPivotIDFromName(pivotName), xlObj = this.XLObj, cellObj, container = xlObj._dataContainer, pvtObj, i;
            if (!xlObj.model.enablePivotTable || xlObj.model.isReadOnly)
				return;
            for (i = 1, len = xlObj.model.sheetCount; i <= len; i++) {
                if (xlObj._getContent(i).find("#" + pvtID).length) {
                    pvtObj = xlObj.getSheet(i).pivotMngr.pivot[pvtID];
                    cellObj = container.sheets[i][pvtObj.rowIndex][pvtObj.colIndex];
                    if (xlObj.getObjectLength(cellObj) < 2 && cellObj.pivot.length < 2)
                        delete container.sheets[i][pvtObj.rowIndex][pvtObj.colIndex];
                    else if (cellObj.pivot.length < 2)
                        delete container.sheets[i][pvtObj.rowIndex][pvtObj.colIndex].pivot;
                    delete xlObj.getSheet(i).pivotMngr.pivot[pvtID];
                    xlObj._getContent(i).find("#" + pvtID).remove();
                    xlObj.hideActivationPanel();
                    xlObj.getActivationPanel().find("#" + xlObj._id + "_PivotTableSchema_" + pvtID).remove();
                    xlObj.XLRibbon._toggleAnalyzeTab();
                    xlObj._trigActionComplete({ ID: pvtID, rowIndex: pvtObj.rowIndex, colIndex: pvtObj.colIndex, reqType: "shape", shapeType: "pivot", sheetIndex: i });
                }
            }
        },

        refreshDataSource: function (name, sheetIdx) {
            var xlObj = this.XLObj, elem, id, pivObj, range, datasource;
            if(!xlObj.model.enablePivotTable || xlObj.model.isReadOnly)
				return;
            if (name && sheetIdx) {
                elem = xlObj.element.find("#" + xlObj._id + "_" + name);
                if (elem)
                    id = elem[0].id;
            }
            else {
                sheetIdx = xlObj.getActiveSheetIndex();
                elem = xlObj._getContent(sheetIdx).find(".e-ss-activepivot");
                id = elem[0].id;
            }
            pivObj = elem.data("ejPivotGrid");
            if (pivObj) {
                range = xlObj.getSheet(sheetIdx).pivotMngr.pivot[id].dataRange;
                datasource = xlObj.getRangeDataAsJSON({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, false, xlObj._getSheetIndexByName(xlObj.getSheet(sheetIdx).pivotMngr.pivot[id].dataSheetName));
                pivObj.model.dataSource.data = datasource;
                pivObj.refreshPivotGrid();
            }
        },

        clearPivotFieldList: function (pivotName) {
            var xlObj = this.XLObj, pvtID = this._getPivotIDFromName(pivotName);
            if (!xlObj.model.enablePivotTable || xlObj.model.isReadOnly)
				return;
            this._clearFilters(xlObj.element.find("#" + pvtID).data("ejPivotGrid"), xlObj.getActivationPanel().find("#" + xlObj._id + "_PivotTableSchema_" + pvtID).data("ejPivotSchemaDesigner"));
        },
               
        _cellDblClick: function (args) {
            if (args.selectedData.length) {
                var xlObj = this.XLObj, xlFormat = xlObj.XLFormat, sheetIdx;
                xlObj.insertSheet();
                sheetIdx = xlObj.getActiveSheetIndex();
                xlObj.updateRange(sheetIdx, { dataSource: args.selectedData, startCell: "A1", showHeader: true });
                xlFormat.createTable({ "header": true, name: "Table" + xlObj._tableCnt, "format": xlFormat._getTableLayoutFromName("TableStyleMedium9").format, "formatName": "TableStyleMedium9" }, "A1:" + xlObj._generateHeaderText(xlObj.getObjectLength(args.selectedData[0])) + (args.selectedData.length + 1));
            }
        },

        _dragMove: function (ars) {
            var xlObj = this.XLObj, interval, scrollObj = xlObj.getActivationPanel().data("ejScroller"), actPanel = xlObj.element.find(".e-spreadsheetactpanel"), top =  actPanel.offset().top;
            if (actPanel.height() + top - 45 < $(".e-dragedNode").offset().top) {
                interval = setInterval(function (e) {
                    if(actPanel.height() + top - 45 < $(".e-dragedNode").offset().top)
                    scrollObj.scrollY(scrollObj.model.scrollTop + 25);
                }, 300);
            }          
            else if (top + 45 > $(".e-dragedNode").offset().top) {
                interval = setInterval(function (e) {
                    if (top + 45 > $(".e-dragedNode").offset().top)
                        scrollObj.scrollY(scrollObj.model.scrollTop - 25);
                }, 300);
            }
            if (xlObj._browserDetails.name === "msie" && xlObj._browserDetails.version === "8.0") {
                $(".e-dragedNode")[0].attachEvent("onmouseup", function (e) {
                    clearInterval(interval);
                });
                document.attachEvent("onmouseup", function (e) {
                    clearInterval(interval);
                });
            }
            else {
                $(".e-dragedNode")[0].addEventListener("mouseup", function (e) {
                    clearInterval(interval);
                });
                document.addEventListener("mouseup", function (e) {
                    clearInterval(interval);
                });
            }
        },

        _renderSuccess: function (args) {
            if (args.type === 'drillSuccess')
                args = args.gridObj;
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), colCount, rowCount, rowIndex, pvtDataObj, colIndex, pvtObj = args, pvtRange = [];
            (!xlObj._isExport) && this._clearBackgroundData(args, xlObj.getSheet(sheetIdx).pivotMngr.pivot[args._id], sheetIdx, "update");
            xlObj.element.find("#" + xlObj._id + "_PivotTableSchema_" + args._id).ejPivotSchemaDesigner({
                pivotControl: args, layout: ej.PivotSchemaDesigner.Layouts.Excel, dragMove: $.proxy(this._dragMove, this), fieldItemDropped: $.proxy(this._fieldItemDropped, this),
            });
            pvtDataObj = xlObj.getSheet(sheetIdx).pivotMngr.pivot[args._id];
            rowCount = pvtObj._rowCount;
            colCount = pvtObj.getJSONRecords().length / pvtObj._rowCount;
            pvtRange = [pvtDataObj.rowIndex, pvtDataObj.colIndex, pvtDataObj.rowIndex + rowCount, pvtDataObj.colIndex + colCount];
            this._refreshRowColumn(pvtRange, pvtObj);
            $(".e-spreadsheet .e-pivotgrid th[role='columnheader'").addClass("e-ss-pivottableheader");
            $(".e-spreadsheet .e-pivotgrid tr:last th.rgtot").addClass("e-ss-pivottableheader");
            xlObj.XLDragFill.hideAutoFillElement();
        },

        _clearBackgroundData: function (pvtObj, pvtDataObj, sheetIdx, type) {        
            var xlObj = this.XLObj;
            var colCount, rowCount, rowIndex, colIndex;
            colCount = pvtObj.getJSONRecords().length / pvtObj._rowCount;
            rowCount = pvtObj._rowCount;
            rowIndex = (!rowCount || isNaN(rowCount)) ? pvtDataObj.rowIndex + 17 : pvtDataObj.rowIndex + rowCount; // 17 is excel default pivot row count
            colIndex = (!colCount || isNaN(colCount)) ? pvtDataObj.colIndex + 2 : pvtDataObj.colIndex + colCount - 1;  // 2 is excel default pivot col count
            if (!type || type === "update")
                xlObj.getRange([pvtDataObj.rowIndex, pvtDataObj.colIndex, rowIndex, colIndex], sheetIdx).removeClass("e-readOnly").addClass("e-readonly");
            else
                xlObj.getRange([pvtDataObj.rowIndex, pvtDataObj.colIndex, rowIndex, colIndex], sheetIdx).removeClass("e-readOnly");                  
            xlObj._dupDetails = true;
            xlObj.clearRangeData([pvtDataObj.rowIndex, pvtDataObj.colIndex, rowIndex, colIndex], ["value", "value2", "hyperlink", "cFormatRule", "comment", "format", "formats"], "", false);
            xlObj._dupDetails = false;
        },

        _fieldItemDropped: function (args) {          
            if (args.axis === "filter") {
                var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), cell, pvtObj;
                pvtObj = xlObj._getContent(sheetIdx).find(".e-ss-activepivot").data("ejPivotGrid"), pivot = xlObj.getSheet(sheetIdx).pivotMngr.pivot[pvtObj._id];              
                while(pivot.rowIndex <= pvtObj.getOlapReport().filters.length) {
                    pivot.rowIndex = pivot.rowIndex + 1;
                    cell = xlObj.getCell(pivot.rowIndex, pivot.colIndex)[0];
                    pvtObj.element.css({ left: cell.offsetLeft - 2, top: cell.offsetTop - 2 });
                }
            }
        },    
       
        _updatePivotMngr: function (cell, pivotObj) {
            var xlObj = this.XLObj, pivotMngr = xlObj.getSheet(xlObj.getActiveSheetIndex()).pivotMngr, pivot = pivotMngr["pivot"];
            pivot[pivotObj["pivot"].id] = $.extend(true, {}, pivotObj["pivot"]);
            xlObj.XLEdit._updateDataContainer({ rowIndex: pivotObj.pivot.rowIndex, colIndex: pivotObj.pivot.colIndex }, { dataObj: { pivot: pivotObj["pivot"].id } });
        },

        _pivotMouseDown: function (e) {
            var xlObj = this.XLObj;
            e.preventDefault();                     
            xlObj.getActivationPanel().find("#" + xlObj._id + "_PivotTableSchema_" + e.target.id).show();
            xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot").removeClass("e-ss-activepivot");
            if ($(e.target).hasClass("e-ss-pivot"))             
                $(e.target).addClass("e-ss-activepivot");            
            else
                $(e.target).parents("e-ss-object").addClass("e-ss-activepivot");
            xlObj.XLSelection._cleanUp(true);
            xlObj.showActivationPanel();
        },

        _pivotScroll: function (args) {
            var xlObj = this.XLObj, desObj = xlObj.getActivationPanel().find("#" + xlObj._id + "_PivotTableSchema_" + xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id).data("ejPivotSchemaDesigner");
            if (args.source === "thumb" && ($(".e-dragedNode").length || desObj._isDragging || this.XLObj.XLResize._allowStart))
                args.cancel = true;                         
        },

        _pivotMouseUp: function (e) {
            var xlObj = this.XLObj, $trgt = $(e.target), robj = $('#' + xlObj._id + '_Ribbon').data("ejRibbon");
            if (xlObj.model.showRibbon) {              
                if (xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot").length && ($trgt.hasClass("e-ss-pivot") || $trgt.parents(".e-ss-pivot").length))
                    xlObj.XLRibbon._analyzeTabUpdate();
                else if (!xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot").length && (robj.model.selectedItemIndex === xlObj.XLRibbon._getTabIndex("analyze") || robj.isVisible("Analyze")))
                    xlObj.XLRibbon._toggleAnalyzeTab();
            }
        },

        _changePvtName: function () {
            var xlObj = this.XLObj, newName = xlObj.element.find("#" + xlObj._id + "_Ribbon_Analyze_PivotTable_PivotTableName").val();
            this.names[xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id] = newName;
            xlObj._trigActionComplete({ pvtName: newName, reqType: "shape", shapeType: "pivot", sheetIndex: xlObj.getActiveSheetIndex(), ID: xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot")[0].id });
        },

       
        _checkRange: function (dataAddr, tblAddr) {          
            var xlObj = this.XLObj, activeCell = xlObj.getActiveCell(), sheetIdx, rowIdx = activeCell.rowIndex, colIdx = activeCell.colIndex, value, range = [];
            var selected = xlObj._getContent(xlObj.getActiveSheetIndex()).find(".e-ss-activepivot");
            var temp, i, len, isError = {isHeader: false, isRows: false};
            temp = xlObj.XLRibbon._getAddrFromDollarAddr(dataAddr);
            sheetIdx = temp[0];
            range = xlObj.getRangeIndices(temp[1]);
            rowIdx = range[0];
            colIdx = range[1];
            if(dataAddr.length)
            for (i = 0, len = range[3] - colIdx + 1; i < len; i++) {
                value = xlObj.XLEdit.getPropertyValue(rowIdx, colIdx + i, "value", sheetIdx);
                if ((xlObj.isUndefined(value) || value == ""))
                    isError["isHeader"] = true;
            }
            if (rowIdx === range[2])
                isError["isRows"] = true;
            if (tblAddr.length) {
                var pvtMngr, keys, j, keyLen, pvtObj, columnCount, rowCount, rowIndex, colIndex, pivot;
                temp = xlObj.XLRibbon._getAddrFromDollarAddr(tblAddr);
                sheetIdx = temp[0];
                range = xlObj.getRangeIndices(temp[1]);
                for (i = 1, len = xlObj.model.sheetCount; i <= len; i++) {
                    pvtMngr=xlObj.model.sheets[i].pivotMngr.pivot;
                    keys=xlObj.getObjectKeys(pvtMngr);
                    for (j = 0, keyLen = keys.length; j < keyLen; j++) {
                        if (!selected.length || (selected.length && keys[j] !== selected[0].id)) {
                            pvtObj = xlObj.element.find("#" + keys[j]).data("ejPivotGrid");
                            pivot = pvtMngr[keys[j]];
                            colCount = pvtObj.getJSONRecords().length / pvtObj.rowCount;
                            rowCount = pvtObj.rowCount;
                            rowIndex = (!rowCount || isNaN(rowCount)) ? pivot.rowIndex + 17 : pivot.rowIndex + rowCount - 1; // 18 is excel default pivot row count
                            colIndex = (!colCount || isNaN(colCount)) ? pivot.colIndex + 2 : pivot.colIndex + colCount - 1;  // 2 is excel default pivot col count
                            if (range[0] >= pivot.rowIndex && range[0] <= rowIndex && range[1] >= pivot.colIndex && range[1] <= colIndex) {
                                isError["isOverlap"] = true;
                                break;
                            }
                        }
                }
                }
            }
            return isError;
        },

        _updateSheetName: function (updatedValue) {
            var xlObj = this.XLObj, i, j, len, pvt, keys, kLen, oldValue = xlObj.getSheet(xlObj.getActiveSheetIndex()).sheetInfo.text;
            for (i = 1, len = xlObj.model.sheetCount; i <= len; i++) {
                pvt = xlObj.getSheet(i).pivotMngr.pivot;
                keys = xlObj.getObjectKeys(pvt);
                for (j = 0, kLen = keys.length; j < kLen; j++) {
                    if (pvt[keys[j]].dataSheetName === oldValue)
                        pvt[keys[j]].dataSheetName = updatedValue;
                }
            }
        },

        _getSheetIdxFromName: function (name) {
            var xlObj = this.XLObj, i, len;
            for (i = 1, len = xlObj.model.sheetCount; i <= len; i++)
                if(xlObj.model.sheets[i].sheetInfo.text == name)
                    return i;            
        },
        
        _changeDataSource: function () {
            var range, xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), pvtID = xlObj._getContent(sheetIdx).find(".e-ss-activepivot")[0].id, pivotGrid = $("#" + pvtID).data("ejPivotGrid");
            var pivotSchema, temp, dataSheetName, pivotData, pvtObj;
            temp = xlObj.XLRibbon._getAddrFromDollarAddr($("#" + xlObj._id + "_Ribbon_PvtRange").val());
            dataSheetName = xlObj.model.sheets[temp[0]].sheetInfo.text;
            range = xlObj.getRangeIndices(temp[1]);
            pvtObj = xlObj.getSheet(xlObj.getActiveSheetIndex()).pivotMngr.pivot[pvtID];
            pvtObj.dataRange = range;
            pvtObj.dataSheetName = dataSheetName;
            pivotData = xlObj.getRangeDataAsJSON({ rowIndex: range[0], colIndex: range[1] }, { rowIndex: range[2], colIndex: range[3] }, false, temp[0]);
            pivotGrid.getOlapReport().data = pivotData;           
            pivotSchema = $("#" + xlObj._id + "_PivotTableSchema_" + pvtID).data("ejPivotSchemaDesigner");
            pivotGrid.model.dataSource.data = pivotData;
            this._clearFilters(pivotGrid, pivotSchema);
            xlObj._trigActionComplete({ sheetIndex: sheetIdx, dataRange: pvtObj.dataRange, ID: pvtID, pvtData: pivotData, reqType: "shape", shapeType: "pivot" });
        },

        _getPivotIDFromName: function(name){
            for (var key in this.names) {
                if (name === this.names[key])                   
                    return key;                
            }
        },        

        _clearFilters: function (pivotGrid, pivotSchema) {
            var xlObj = this.XLObj, olapReport = pivotGrid.getOlapReport();
            olapReport.rows = [];
            olapReport.columns = [];
            olapReport.values = [];
            olapReport.filters = [];
            pivotGrid.refreshPivotGrid();
            pivotSchema.model.pivotControl = pivotGrid;
            $(pivotSchema.element).html("");
            pivotSchema._load();           
			xlObj._refreshActivationPanel();
        },

        _movePivotTable: function () {
            var xlObj = this.XLObj, sheetIdx = xlObj.getActiveSheetIndex(), pvtElem = xlObj._getContent(sheetIdx).find(".e-ss-activepivot"), pvtID = pvtElem[0].id, pivot, pvtObj = pvtElem.data("ejPivotGrid");;
            var splitStr, tblSheetIdx, cell, $cell, pvtRange, newSheetIdx, isUpdate = true, moveRange, colCount, rowCount;
            pivot = xlObj.getSheet(sheetIdx).pivotMngr.pivot[pvtID];          
            if ($("#" + xlObj._id + "_dlg_existsheet").data("ejRadioButton").model.checked) {
                isUpdate = false;
                splitStr = $("#" + xlObj._id + "_Ribbon_PvtLocation").val().split("!");
                tblSheetIdx = this._getSheetIdxFromName(splitStr[0]);
                pvtRange = xlObj.getRangeIndices(xlObj.XLRibbon._getAddrFromDollarAddr(splitStr[1])[1]);
                if (sheetIdx !== tblSheetIdx) {
                    xlObj._getContent(tblSheetIdx).find(".e-content").append(pvtElem);
                    xlObj.gotoPage(tblSheetIdx, false);
                    xlObj.XLSelection._cleanUp(true);
                    isUpdate = true;                   
                }               
                pivot.rowIndex = pvtRange[0];
                pivot.colIndex = pvtRange[1];
            }
            else {
                xlObj.insertSheet();
                sheetIdx=xlObj.getActiveSheetIndex();
                xlObj._getContent(sheetIdx).find(".e-content").append(pvtElem);
                pvtRange = [2, 0];               
            }
            if (isUpdate) {
                newSheetIdx = xlObj.getActiveSheetIndex();
                xlObj.getSheet(newSheetIdx).pivotMngr.pivot[pvtID] = {};                
                $.extend(true, xlObj.getSheet(newSheetIdx).pivotMngr.pivot[pvtID], pivot);
                if(newSheetIdx !== sheetIdx)
                delete xlObj.getSheet(sheetIdx).pivotMngr.pivot[pvtID];
            }
            $cell = xlObj.getCell(pvtRange[0], pvtRange[1]);
			if(!$cell && xlObj.model.scrollSettings.allowVirtualScrolling){ 
				var sheet =xlObj.getSheet(xlObj.getActiveSheetIndex());									
				xlObj._scrollContent({y: sheet._rowHeightCollection[pvtRange[0]+1] - sheet._scrollTop});
				$cell = xlObj.getCell(pvtRange[0], pvtRange[1]);
			}
		    cell=$cell[0];
            pvtElem.css({ left: cell.offsetLeft - 2, top: cell.offsetTop -2 });
            if(pvtObj.getOlapReport().filters.length)
            while (pivot.rowIndex <= pvtObj.getOlapReport().filters.length) {
                pivot.rowIndex = pivot.rowIndex + 1;
                cell = xlObj.getCell(pivot.rowIndex, pivot.colIndex)[0];
                pvtElem.css({ left: cell.offsetLeft -2, top: cell.offsetTop -2});
            }
            rowCount = pvtObj._rowCount;
            colCount = (pvtObj.calculateCellWidths().columnWidths).length;
            moveRange = [pvtRange[0], pvtRange[1], pvtRange[0] + rowCount, pvtRange[1] + colCount];
            this._refreshRowColumn(moveRange, pvtObj);
            xlObj._trigActionComplete({ sheetIndex: sheetIdx, newRange: moveRange, ID: pvtID, reqType: "shape", shapeType: "pivot" });
        },
    
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html ReportViewer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws.
* @version 12.1
* @author &lt;a href="mailto:licensing@syncfusion.com"&gt;Syncfusion Inc&lt;/a&gt;
*/

(function ($, ej, undefined) {



    ej.widget("ejReportViewer", "ej.ReportViewer", {
        _rootCSS: "e-reportviewer",
        element: null,
        model: null,
        validTags: ["div"],

        //#region Defaults
        defaults: {
            reportServiceUrl: "",
            reportServerId: "",
            reportPath: "",
            reportServerUrl: "",
            dataSources: [],
            parameters: [],
            exportSettings: {
                exportOptions: 1 | 2 | 4 | 8 | 16,
                excelFormat: "excel97to2003",
                pptFormat: "powerpoint97to2003",
                wordFormat: "doc"
            },
            toolbarSettings: {
                items: 1 | 2 | 4 | 8 | 16 | 32 | 64 | 128 | 256| 512,
                showToolbar: true,
                templateId: "",
                click: "",
                showTooltip: true
            },
            locale: "en-US",
            printMode: false,
            renderMode: 1 | 2,
            printOption: "Default",
            enablePageCache: false,
            enablePageVirtualization: false,
            pageSettings: {
                height: 0,
                width: 0,
                orientation: null,
                paperSize: null,
                margins: {
                    top: 0,
                    right: 0,
                    bottom: 0,
                    left: 0
                }
            },
            processingMode: "remote",
            zoomFactor: 1,
            isResponsive: true,
            reportLoaded: null,
            ajaxBeforeLoad: null,
            ajaxSuccess: null,
            ajaxError: null,
            renderingBegin: null,
            renderingComplete: null,
            reportError: null,
            reportExport: null,
            drillThrough: null,
            reportPrint: null,
            viewReportClick: null,
            destroy: null,
            enableNotificationBar: true,
            enableDropDownSearch: false
        },

        dataTypes: {
            dataSources: "array",
            parameters: "array",
            toolbarSettings: {
                showToolbar: "boolean"
            }
        },
        //#endregion

        //#region Local Members
        _dataSources: null,
        _svg: true,
        _authenticationToken: null,
        _dataRefresh: false,
        _isForwardDirection: false,
        _isSelectedPage: false,
        _refresh: false,
        _isToolbarClick: false,
        _printMode: false,
        _pageSetup: false,
        _pageModel: null,
        _currentPage: 1,
        _pageLayoutPage: 1,
        _machineCulture: null,
        _reportParameters: null,
        _reportDataSources: null,
        _reporDataSets: null,
        _zoomLevel: 2,
        _preZoomVal: 1,
        _actionUrl: null,
        _isDocumentMap: false,
        _isPageDocMap: false,
        _pageDocMapFlag: false,
        _childReportAuthentication: null,
        _parents: [],
        _parentPageXY: null,
        _browserInfo: null,
        _isDevice: false,
        _zoomVal: 1,
        _originX: 0,
        _originY: 0,
        _paperName: null,
        _isPercentHeight: -1,
        _isPercentWidth: -1,
        _isHeight: false,
        _isWidth: false,
        _paperOrientation: null,
        _pageCache: [],
        _printPageCache: [],
        _paperSetup: {
            paperHeight: null,
            paperWidth: null,
            MarginTop: 0.0,
            MarginRight: 0.0,
            MarginBottom: 0.0,
            MarginLeft: 0.0
        },
        _reportAction: {
            reportLoad: 'ReportLoad',
            getDataSourceCredential: 'GetDataSourceCredential',
            validateDSCredential: 'ValidateDSCredential',
            updateDSCredential: 'UpdateDSCredential',
            getParameters: 'GetParameters',
            setParameters: 'SetParameters',
            updateParameters: 'UpdateParameters',
            updateDataSource: 'UpdateDataSource',
            getPageModel: 'GetPageModel',
            getPrintModel: 'GetPrintModel',
            drillDown: 'DrillDown',
            clearCache: 'ClearCache',
            documentMap: 'DocumentMap',
            drillThrough: 'DrillThrough',
            sorting: 'Sorting'
        },
        //#endregion

        //#region angular
        _tags: [{
            tag: "parameters",
            attr: ["",
                [{
                    tag: "parameter", attr: ["name", "labels", "values", "nullable"]
                }]
            ]
        },
        {
            tag: "dataSources",
            attr: ["",
                [{
                    tag: "datasource", attr: ["name", "value"]
                }]
            ]
        }],
        //#endregion

        //#region Initialization
        _setModel: function (options) {
            var reload = false;
            var update = false;
            for (var prop in options) {
                switch (prop) {
                    case "reportPath":
                    case "reportServerUrl":
                    case "reportServiceUrl":
                        reload = true;
                        break;
                    case "dataSources":
                        this._refresh = true;
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getDataSourceCredential, 'dataSources': options[prop], 'parameters': this.model.parameters }), "_getDataSourceCredential");
                        break;
                    case "parameters":
                        this._refresh = true;
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.setParameters, 'parameters': options.parameters }), "_setParameters");
                        break;
                    case "processingMode":
                        update = true;
                        break;
                    case "zoomFactor":
                        this._zoomContainer(options[prop], false);
                        break;
                    case "printMode":
                        this._updatePreviewLayout(options[prop], false);
                        break;
                    case "toolbarSettings":
                        this._updateToolbarmodel();
                        break;
                    case "locale":
                        this._setCultureInfo();
                        break;
                    case "renderMode":
                        this._reInit();
                        break;
                    case "pageSettings":
                        for (var setting in options[prop]) {
                            switch (setting) {
                                case "height":
                                    this._paperSetup.paperHeight = options[prop][setting];
                                    this._paperName = "Custom";
                                    break;
                                case "width":
                                    this._paperSetup.paperWidth = options[prop][setting];
                                    this._paperName = "Custom";
                                    break;
                                case "orientation":
                                    this._paperOrientation = options[prop][setting];
                                    break;
                                case "paperSize":
                                    this._paperName = options[prop][setting];
                                    break;
                                case "margins":
                                    for (var margin in options[prop][setting]) {
                                        switch (margin) {
                                            case "top":
                                                this._paperSetup.MarginTop = options[prop][setting][margin];
                                                break;
                                            case "bottom":
                                                this._paperSetup.MarginBottom = options[prop][setting][margin];
                                                break;
                                            case "left":
                                                this._paperSetup.MarginLeft = options[prop][setting][margin];
                                                break;
                                            case "right":
                                                this._paperSetup.MarginRight = options[prop][setting][margin];
                                                break;
                                        }
                                    }
                                    break;
                            }
                        }
                        if (this._printMode) {
                            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode, 'PageSetup': this._paperSetup }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                        }
                        break;
                }
            }
            if (update && !reload) {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getDataSourceCredential, 'dataSources': this.model.dataSources, 'parameters': this.model.parameters }), "_getDataSourceCredential");
            }

            if (reload) {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.clearCache }), '_reportReload');
            }
        },

        _reInit: function () {
            this._destroy();
            this._init();
        },

        _destroyEJObjects: function (_ejObjects) {
            for (var i = 0; i < _ejObjects.length; i++) {
                var _ejEle = $(_ejObjects[i]);
                var _ejName = _ejEle.data('ejWidgets');
                if (_ejName) {
                    var _ejObj = _ejEle.data(_ejName[0]);
                    if (_ejObj) {
                        var _ejInnerObjs = _ejObj.element.find('.e-js');
                        if (_ejInnerObjs && _ejInnerObjs.length > 0) {
                            this._destroyEJObjects(_ejInnerObjs);
                        }
                        _ejInnerObjs = null;
                        _ejObj.destroy();
                    }
                }
            }
        },

        _destroy: function () {

            var _ejObjects = this.element.find('.e-js');
            if (_ejObjects && _ejObjects.length > 0) {
                this._destroyEJObjects(_ejObjects);
            }
            _ejObjects = null;

            this._clearPageCache();
            $('#' + this._id + '_exportForm').remove();
            $('#' + this._id + '_toolbar_exportListTip').remove();
            $('#' + this._id + '_toolbar_fittoPagePopup').remove();
            $('#' + this._id + '_device_toolbarContainer').remove();
            $('#' + this._id + '_rptTooltip').remove();
            $(this.element).find('.e-reportviewer-viewer').remove();
            $('#' + this._id + '_pageInfoPopup').remove();
            $('#' + this._id + '_printPageIframe').remove();
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.clearCache }), '_clearCurrentServerCache');
        },

        _destroyExistingObj: function(){
            $('#' + this._id + '_printPageSetup').remove();
            if (this._parents.length > 0) {
                this._parents.pop();
            }
        },

        _init: function () {
            this._svg = (window.SVGSVGElement) ? true : false;
            this._actionUrl = this.model.reportServiceUrl + "/PostReportAction";
            this._authenticationToken = this._getAuthenticationToken();
            this._browserInfo = ej.browserInfo();
            this._destroyExistingObj();
            this._renderViewer();
            this._initViewer();
            this._on($(window), "resize", this._viewerResize);
            if (this.model.reportServiceUrl) {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({
                    'reportAction': this._reportAction.reportLoad, 'controlId': this._id, 'reportPath': this.model.reportPath,
                    'reportServerUrl': this.model.reportServerUrl, 'processingMode': this.model.processingMode
                }), "_reportLoaded");
            }
        },

        _initViewer: function () {
            this._wireEvents();
            this._initToolbar();
            this._clearPageCache();
            this._currentPage = 1;
            this._pageLayoutPage = this._currentPage;
            this._setPageSettings();
            if (!this._refresh) {
                this._preZoomVal = 1;
                this._zoomLevel = 2;
            }
            this._isDocumentMap = false;
            this._printMode = this.model.printMode;
            this._isPageDocMap = false;
            this._pageDocMapFlag = false;
            var tbSettings = this.model.toolbarSettings;
            if (!tbSettings.templateId) {
                this._showToolbar(tbSettings.showToolbar);
                this._showPrintButton(tbSettings.items & ej.ReportViewer.ToolbarItems.Print);
                this._showRefreshButton(tbSettings.items & ej.ReportViewer.ToolbarItems.Refresh);
                this._showZoomControl(tbSettings.items & ej.ReportViewer.ToolbarItems.Zoom);
                this._showFittoPage(tbSettings.items & ej.ReportViewer.ToolbarItems.FittoPage);
                this._showExportControls(tbSettings.items & ej.ReportViewer.ToolbarItems.Export);
                this._showPrintPageSetupButton(tbSettings.items & ej.ReportViewer.ToolbarItems.PageSetup);
                this._showExportList();
                this._showPageNavigationControls(tbSettings.items & ej.ReportViewer.ToolbarItems.PageNavigation);
                this._showParameterBlock(tbSettings.items & ej.ReportViewer.ToolbarItems.Parameters);
                this._showPreviewButton(tbSettings.items & ej.ReportViewer.ToolbarItems.PrintLayout);
                this._showDrillThrough(this._parents.length > 0);
                this._showDocumentMap(false);
            }
            this._showViewerBlock(false);
            this._setContainerSize();
            this._showloadingIndicator(true);
        },

        _setPageSettings: function(){
            var isEnabled = false;
            var width = 0;
            var height = 0;
            this._paperName = null;
            this._paperOrientation = null;
            this._paperSetup.paperHeight = null;
            this._paperSetup.paperWidth = null;
            this._paperSetup.MarginBottom = 0.0;
            this._paperSetup.MarginLeft = 0.0;
            this._paperSetup.MarginRight = 0.0;
            this._paperSetup.MarginTop = 0.0;

            if (this.model.pageSettings && this.model.pageSettings.height > 0) {
                height = this.model.pageSettings.height;
                isEnabled = true;
            }

            if (this.model.pageSettings && this.model.pageSettings.width > 0) {
                width = this.model.pageSettings.width;
                isEnabled = true;
            }

            if (this.model.pageSettings.paperSize) {
                this._paperName = this.model.pageSettings.paperSize;
                var paperDimension = this._getPaperSize(this.model.pageSettings.paperSize);
                if (isEnabled) {
                    if (width > 0) {
                        paperDimension.width = width;
                    }
                    if (height > 0) {
                        paperDimension.height = height;
                    }
                    this._paperName = "Custom";
                }
                this._paperOrientation = this.model.pageSettings.orientation == "Landscape" ? "Landscape" : "Portrait";
                if (this.model.pageSettings.orientation == "Landscape") {
                    this._paperSetup.paperHeight = paperDimension.width;
                    this._paperSetup.paperWidth = paperDimension.height;
                } else {
                    this._paperSetup.paperHeight = paperDimension.height;
                    this._paperSetup.paperWidth = paperDimension.width;
                }
            } else {
                if (isEnabled) {
                    if (width > 0) {
                        this._paperSetup.paperWidth = width;
                    }
                    if (height > 0) {
                        this._paperSetup.paperHeight = height;
                    }
                    this._paperName = "Custom";
                }
            }

            if (this.model.pageSettings && this.model.pageSettings.margins) {
                if (this.model.pageSettings.margins.left > 0) {
                    this._paperSetup.MarginLeft = this.model.pageSettings.margins.left;
                }
                if (this.model.pageSettings.margins.right > 0) {
                    this._paperSetup.MarginRight = this.model.pageSettings.margins.right;
                }
                if (this.model.pageSettings.margins.bottom > 0) {
                    this._paperSetup.MarginBottom = this.model.pageSettings.margins.bottom;
                }
                if (this.model.pageSettings.margins.top > 0) {
                    this._paperSetup.MarginTop = this.model.pageSettings.margins.top;
                }
            }
        },
        //#endregion

        //-------------------- Render the ReportViewer Ctrl [start] -------------------------//
        _renderPageInfoPopup: function () {
            var pagePopup = $('#' + this._id + '_pageInfoPopup');
            if (!(pagePopup.length > 0)) {
                pagePopup = ej.buildTag("div.e-reportviewer-pagepopupinfo", "", { 'WHITE-SPACE': 'nowrap' }, { id: this._id + '_pageInfoPopup' });
                var pageNoDiv = ej.buildTag("input.e-reportviewer-pagenumber e-reportviewer-elementalignments ejinputtext", "", {}, { 'type': 'text', 'value': this._currentPage, id: this._id + '_popupPageNo' });
                pageNoDiv.css('height', '25.5px');
                pageNoDiv.css('width', '25px');
                pageNoDiv.css('background-color', 'black');
                pageNoDiv.css('color', 'white');
                pageNoDiv.css('border-color', 'black');

                var pageSeparateSpan = ej.buildTag("span.e-reportviewer-popuptotalpage", "", {}, {});
                pageSeparateSpan.append(' / ' + this._pageModel.TotalPages);
                pagePopup.append(pageNoDiv);
                pagePopup.append(pageSeparateSpan);
                $('body').append(pagePopup);
                this._on($('#' + this._id + '_popupPageNo'), "click", this._popupClick);
                this._on($('#' + this._id + '_popupPageNo'), "keypress", this._onkeyPress);
            }

            if (pagePopup.css('display') == 'block') {
                pagePopup.stop().fadeIn();
                pagePopup.stop().fadeOut(3000);
                pagePopup.hide(3000);
            }
            else {
                pagePopup.show();
                pagePopup.stop().fadeIn();
                pagePopup.stop().fadeOut(3000);
                pagePopup.hide(3000);
            }

            var viewerContainer = $('#' + this._id + '_viewerContainer');
            var popupX = (viewerContainer.offset().left + (viewerContainer.width() / 2)) - (pagePopup.width() / 2);
            var popupY = (viewerContainer.offset().top + (viewerContainer.height() / 2)) - (pagePopup.height() / 2);
            pagePopup.css({ 'left': popupX, 'top': popupY });
            this._updatePageNo();
        },

        _renderToolTip: function () {
            var $divTooltip = ej.buildTag("div.e-reportviewer-tbdiv e-reportviewer-tooltip", "", { 'display': 'none' }, { 'id': this._id + '_rptTooltip' });
            var $tooltipHeader = ej.buildTag("span.e-reportviewer-headerspan", "", { 'display': 'block' }, { 'id': this._id + '_rptTooltip_Header' });
            var $tooltipContent = ej.buildTag("span.e-reportviewer-contentspan", "", { 'display': 'block' }, { 'id': this._id + '_rptTooltip_Content' });
            $divTooltip.append($tooltipHeader);
            $divTooltip.append($tooltipContent);
            $('body').append($divTooltip);
        },

        _renderToolBar: function (targetTag) {
            if (!this.model.toolbarSettings.templateId) {
                var div = ej.buildTag("div.e-reportviewer-toolbarcontainer .e-reportviewer-viewer", "", { 'width': '100%' }, { 'id': this._id + '_toolbarContainer' });
                targetTag.append(div);

                if (this._isDevice) {
                    var $ultoolbaritems = ej.buildTag("ul.e-reportviewer-toolbarul", "", {});
                    this._appendToolbarItems($ultoolbaritems, 'export');
                    this._appendToolbarItems($ultoolbaritems, 'gotoparent');
                    this._appendToolbarItems($ultoolbaritems, 'zoomin');
                    this._appendToolbarItems($ultoolbaritems, 'zoomout');
                    this._appendToolbarItems($ultoolbaritems, 'pagefit');
                    this._appendToolbarItems($ultoolbaritems, 'refresh');
                    //this._appendToolbarItems($ultoolbaritems, 'documentmap');
                    this._appendToolbarItems($ultoolbaritems, 'parameter');
                    this._renderNavigationItems(div);
                    div.append($ultoolbaritems);
                } else {
                    var $ulprintExport = ej.buildTag("ul.e-reportviewer-toolbarul", "", {});
                    this._appendToolbarItems($ulprintExport, 'print');
                    this._appendToolbarItems($ulprintExport, 'export');
                    this._appendToolbarItems($ulprintExport, 'preview');
                    this._appendToolbarItems($ulprintExport, 'pagesetup');
                    div.append($ulprintExport);

                    var $ulnavigate = ej.buildTag("ul.e-reportviewer-toolbarul", "", {});
                    this._appendToolbarItems($ulnavigate, 'gotofirst');
                    this._appendToolbarItems($ulnavigate, 'gotoprevious');
                    this._appendToolbarItems($ulnavigate, 'gotopage');
                    this._appendToolbarItems($ulnavigate, 'gotonext');
                    this._appendToolbarItems($ulnavigate, 'gotolast');
                    this._appendToolbarItems($ulnavigate, 'gotoparent');
                    div.append($ulnavigate);

                    var $ulzoom = ej.buildTag("ul.e-reportviewer-toolbarul", "", {});
                    this._appendToolbarItems($ulzoom, 'zoomin');
                    this._appendToolbarItems($ulzoom, 'zoomout');
                    this._appendToolbarItems($ulzoom, 'zoom');
                    this._appendToolbarItems($ulzoom, 'pagefit');
                    div.append($ulzoom);

                    var $ulro = ej.buildTag("ul.e-reportviewer-toolbarul", "", {});
                    this._appendToolbarItems($ulro, 'refresh');
                    this._appendToolbarItems($ulro, 'documentmap');
                    this._appendToolbarItems($ulro, 'parameter');
                    div.append($ulro);
                    $('#' + this._id + '_toolbar_zoomSelection').ejDropDownList({ height: "27px", width: "80px", change: this._zoomValChange, selectedItem: 2 });
                }
                div.ejToolbar({ enableSeparator: !this._isDevice, click: $.proxy(this._toolbarClick, this) });
            } else {
                var templateDiv = $('#' + this.model.toolbarSettings.templateId);
                targetTag.append(templateDiv);
                templateDiv.ejToolbar({ enableSeparator: true, height: templateDiv.height(), click: this.model.toolbarSettings.click });
                templateDiv.css('display', 'block');
            }
        },

        _renderNavigationItems: function (target) {
            var _deviceToolBar = ej.buildTag("div.e-device-reportviewer-toolbarcontainer .e-reportviewer-viewer", "", {}, { 'id': this._id + '_device_toolbarContainer' });
            var $ulnavigate = ej.buildTag("ul.e-reportviewer-toolbarul", "", {});
            this._appendToolbarItems($ulnavigate, 'gotofirst');
            this._appendToolbarItems($ulnavigate, 'gotoprevious');
            this._appendToolbarItems($ulnavigate, 'gotopage');
            this._appendToolbarItems($ulnavigate, 'gotonext');
            this._appendToolbarItems($ulnavigate, 'gotolast');
            _deviceToolBar.append($ulnavigate);
            $('body').append(_deviceToolBar);

            var _deviceToolBarSpan = ej.buildTag("span.e-device-reportviewer-toolbarspan", "", { 'display': 'block', 'float': 'right' }, { 'id': this._id + '_device_toolbarspan' });
            _deviceToolBarSpan.addClass("e-icon e-toolbar-res-arrow e-reportviewer-toolbarul e-ul e-horizontal");
            _deviceToolBarSpan.css("padding", "3px");
            target.append(_deviceToolBarSpan);

            _deviceToolBar.ejToolbar({ enableSeparator: !this._isDevice, click: $.proxy(this._toolbarClick, this) });
            _deviceToolBar.removeClass("e-toolbarspan").addClass("e-abs-position");
            _deviceToolBar.css('display', 'none');
            _deviceToolBar.css("z-index", "1001");
        },

        _appendToolbarItems: function (litag, eletype) {
            var $divouter;
            var localeObj = ej.ReportViewer.Locale[this.model.locale] ? ej.ReportViewer.Locale[this.model.locale] : ej.ReportViewer.Locale["en-us"];
            switch (eletype) {
                case 'print':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanprint = ej.buildTag("span.e-reportviewer-icon e-reportviewer-print", "", {}, { 'id': this._id + '_toolbar_Print' });
                    $divouter.append($spanprint);
                    break;
                case 'export':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanexport = ej.buildTag("span.e-reportviewer-icon e-reportviewer-export", "", {}, { 'id': this._id + '_ejtb_export' });
                    $divouter.append($spanexport);
                    break;
                case 'pagesetup':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanpagesetup = ej.buildTag("span.e-reportviewer-icon e-reportviewer-pagesetup", "", {}, { 'id': this._id + '_ejtb_PageSetup' });
                    $divouter.append($spanpagesetup);
                    break;
                case 'gotofirst':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spangotofirst = ej.buildTag("span.e-reportviewer-icon e-reportviewer-gotofirst", "", {});
                    $divouter.append($spangotofirst);
                    break;
                case 'gotolast':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spangotolast = ej.buildTag("span.e-reportviewer-icon e-reportviewer-gotolast", "", {});
                    $divouter.append($spangotolast);
                    break;
                case 'gotonext':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spangotonext = ej.buildTag("span.e-reportviewer-icon e-reportviewer-gotonext", "", {});
                    $divouter.append($spangotonext);
                    break;
                case 'gotoprevious':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spangotoprevious = ej.buildTag("span.e-reportviewer-icon e-reportviewer-gotoprevious", "", {});
                    $divouter.append($spangotoprevious);
                    break;
                case 'gotoparent':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spangotoparentreport = ej.buildTag("span.e-reportviewer-icon e-reportviewer-gotoparent", "", {});
                    $divouter.append($spangotoparentreport);
                    break;
                case 'gotopage':
                    $divouter = ej.buildTag("div.e-reportviewer-tbpage", "", { 'display': 'block' }, {});
                    var $inputpageno = ej.buildTag("input.e-reportviewer-pagenumber e-reportviewer-elementalignments ejinputtext", "", {}, { 'type': 'text', 'value': '0', 'id': this._id + '_txtpageNo', 'data-role': 'none' });
                    var $spanpageno = ej.buildTag("span.e-reportviewer-labelpageno", "", {}, {});
                    $divouter.append($inputpageno);
                    $divouter.append($spanpageno);
                    break;
                case 'zoomin':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanzoomin = ej.buildTag("span.e-reportviewer-icon e-reportviewer-zoomin", "", {}, { 'id': this._id + '_toolbar_zoomin' });
                    $divouter.append($spanzoomin);
                    break;
                case 'zoomout':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanzoomout = ej.buildTag("span.e-reportviewer-icon e-reportviewer-zoomout", "", {}, { 'id': this._id + '_toolbar_zoomout' });
                    $divouter.append($spanzoomout);
                    break;
                case 'zoom':
                    $divouter = ej.buildTag("div.e-reportviewer-ejdropdownlist", "", {}, {});
                    var $sltzoom = ej.buildTag("select.e-reportviewer-tbdiv e-reportviewer-zoomlist", "", {}, { 'id': this._id + '_toolbar_zoomSelection', 'data-role': 'none' });
                    $sltzoom.append("<option>50%</option>");
                    $sltzoom.append("<option>75%</option>");
                    $sltzoom.append("<option Selected>100%</option>");
                    $sltzoom.append("<option>125%</option>");
                    $sltzoom.append("<option>150%</option>");
                    $sltzoom.append("<option>200%</option>");
                    $sltzoom.append("<option>400%</option>");
                    $divouter.append($sltzoom);
                    break;
                case 'pagefit':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanexport = ej.buildTag("span.e-reportviewer-icon e-reportviewer-pagefit", "", {}, { 'id': this._id + '_ejtb_fittopage' });
                    $divouter.append($spanexport);
                    break;
                case 'preview':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, { 'id': this._id + '_ejtb_preview' });
                    var $spanpreview = ej.buildTag("span.e-reportviewer-icon e-reportviewer-preview", "", {}, {});
                    $divouter.append($spanpreview);
                    break;
                case 'refresh':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, {});
                    var $spanrefresh = ej.buildTag("span.e-reportviewer-icon e-reportviewer-refresh", "", {}, { 'id': this._id + '_toolbar_refresh' });
                    $divouter.append($spanrefresh);
                    break;
                case 'documentmap':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", { 'display': 'none' }, { 'id': this._id + '_ejtb_documentmap' });
                    var $spandocumentMap = ej.buildTag("span.e-reportviewer-icon e-reportviewer-documentmap", "", {});
                    $divouter.append($spandocumentMap);
                    break;
                case 'parameter':
                    $divouter = ej.buildTag("li.e-reportviewer-toolbarli", "", {}, { 'id': this._id + '_ejtb_parameter' });
                    var $spanparameter = ej.buildTag("span.e-reportviewer-icon e-reportviewer-parameter", "", {});
                    $divouter.append($spanparameter);
                    break;
                case 'pdf':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-pdf", "", {}, { 'id': this._id + '_pdf' });
                    $spanTag = ej.buildTag("span .e-reportviewer-popupspan e-pdf", "", {}, {});
                    $spanTag.append(localeObj['toolbar']['exportformat']['Pdf']);
                    $divouter.append($spanTag);
                    break;
                case 'xls':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-excel", "", {}, { 'id': this._id + '_xls' });
                    $spanTag = ej.buildTag("span .e-reportviewer-popupspan e-excel", "", {}, {});
                    $spanTag.append(localeObj['toolbar']['exportformat']['Excel']);
                    $divouter.append($spanTag);
                    break;
                case 'word':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-word", "", {}, { 'id': this._id + '_word' });
                    $spanTag = ej.buildTag("span .e-reportviewer-popupspan e-word", "", {}, {});
                    $spanTag.append(localeObj['toolbar']['exportformat']['Word']);
                    $divouter.append($spanTag);
                    break;
                case 'html':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-html", "", {}, { 'id': this._id + '_html' });
                    $spanTag = ej.buildTag("span .e-reportviewer-popupspan e-html", "", {}, {});
                    $spanTag.append(localeObj['toolbar']['exportformat']['Html']);
                    $divouter.append($spanTag);
                    break;
                case 'ppt':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-ppt", "", {}, { 'id': this._id + '_ppt' });
                    $spanTag = ej.buildTag("span .e-reportviewer-popupspan e-ppt", "", {}, {});
                    $spanTag.append(localeObj['toolbar']['exportformat']['PPT']);
                    $divouter.append($spanTag);
                    break;
                case 'fittopage':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli", "", {}, { 'id': this._id + '_fittoPage' });
                    break;
                case 'fittopagewidth':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-fitpagewidth", "", { 'padding-right': '5px', 'width': 'auto' }, { 'id': this._id + '_pageWidth', 'isSelect': 'false' });
                    var $spanTagWidth = ej.buildTag("span.e-reportviewer-icon e-reportviewer-emptyconetent", "", { 'padding-right': '4px', 'cursor': 'pointer' }, { 'id': this._id + 'Pagewidthspan', 'fitType': 'PAGEWIDTH' });
                    $divouter.append($spanTagWidth);
                    $divouter.append(localeObj['toolbar']['fittopage']['pageWidth']);
                    break;
                case 'fittowholepage':
                    $divouter = ej.buildTag("li.e-reportviewer-popupli e-fitpageheight", "", { 'padding-right': '5px', 'width': 'auto' }, { 'id': this._id + '_pageHeight', 'isSelect': 'false' });
                    var $spanTagHeight = ej.buildTag("span.e-reportviewer-icon e-reportviewer-emptyconetent", "", { 'padding-right': '4px', 'cursor': 'pointer' }, { 'id': this._id + 'pageheightSpan', 'fitType': 'WHOLEPAGE' });
                    $divouter.append($spanTagHeight);
                    $divouter.append(localeObj['toolbar']['fittopage']['pageHeight']);
                    break;
            }
            litag.append($divouter);
        },

        _renderToolTipExport: function () {
            var $tipExport = ej.buildTag("div.e-reportviewer-tbdiv e-reportviewer-icon e-reportviewer-exporttip", "", { 'display': 'none' }, { 'id': this._id + '_toolbar_exportListTip' });
            this._appendToolbarItems($tipExport, 'pdf');
            this._appendToolbarItems($tipExport, 'xls');
            this._appendToolbarItems($tipExport, 'word');
            this._appendToolbarItems($tipExport, 'html');
            this._appendToolbarItems($tipExport, 'ppt');
            return $tipExport;
        },

        _renderPageFitPopup: function () {
            var $tipFittoPage = ej.buildTag("div.e-reportviewer-tbdiv e-reportviewer-icon e-reportviewer-fittopagetip", "", { 'display': 'none' }, { 'id': this._id + '_toolbar_fittoPagePopup' });
            //this._appendToolbarItems($tipFittoPage, 'fittopage');
            this._appendToolbarItems($tipFittoPage, 'fittopagewidth');
            this._appendToolbarItems($tipFittoPage, 'fittowholepage');
            return $tipFittoPage;
        },

        _renderFitopagePopup: function () {
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var _pageWidth = $('#' + this._id + '_pageWidth');
            var _pageHeight = $('#' + this._id + '_pageHeight');
            var w = pageViewerContainer.width();
            var h = pageViewerContainer.height();
            var pageW = pageViewline.width();
            var pageH = pageViewline.height();
            if (h > pageH && _pageHeight.attr('isSelect') == 'false') {
                _pageHeight.css('opacity', '0.4');
            } else {
                _pageHeight.css('opacity', '1');
            }
            if (w > pageW && _pageWidth.attr('isSelect') == 'false') {
                _pageWidth.css('opacity', '0.4');
            }
            else {
                _pageWidth.css('opacity', '1');
            }
        },

        //------------------------Render Print Page Setup [Start] ------------------------//

        _showPrintPageSetupButton: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-pagesetup').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-pagesetup').parent().css("display", "none");
            }
        },

        _renderPrintPageSetup: function () {
            var localeObj = ej.ReportViewer.Locale[this.model.locale] ? ej.ReportViewer.Locale[this.model.locale] : ej.ReportViewer.Locale["en-us"];
            var printPageWidth = null, printPageHeight = null;
            var $printPageSetup = ej.buildTag("div", "", { 'display': 'table' }, { 'id': this._id + '_printPageSetup' });
            var $paperSetup = ej.buildTag("div", "", { 'display': 'table-row' }, { 'id': this._id + '_paperSetup' });
            var paperTable = ej.buildTag('table', '', {}, {'border-collapse': 'collapse'});
            var $defaultSetup = ej.buildTag("div", "", {}, { 'id': this._id + '_defaultSetup', 'display': 'table-row' });
            var position = $('#' + this._id + '.e-reportviewer')[0].getBoundingClientRect();
            var row1 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', {});
            var row2 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', { });
            var row3 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', { });
            var cell11 = ej.buildTag('td.e-reportviewer-pagesetupheader', '', { 'padding-top': '0px' }, { 'colspan': '8' });
            var cell21 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', {}, { 'colspan': '12' });
            $paperSetup.append(paperTable);
            paperTable.append(row1);
            paperTable.append(row2);
            paperTable.append(row3);
            row1.append(cell11);
            row2.append(cell21);
            $printPageSetup.append($paperSetup);
            $printPageSetup.append($defaultSetup);
            var mrow1 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', {});
            var mrow2 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', {});
            var mrow3 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', {});
            paperTable.append(mrow1);
            paperTable.append(mrow2);
            paperTable.append(mrow3);
            var mcell11 = ej.buildTag('td.e-reportviewer-pagesetupheader', '', {}, { 'colspan': '8' });
            mrow1.append(mcell11);
            var orow1 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', {});
            var orow2 = ej.buildTag('tr.e-reportviewer-pagesetuptr', '', {});
            var ocell11 = ej.buildTag('td.e-reportviewer-pagesetupheader', '', {}, { 'colspan': '8' });
            orow1.append(ocell11);
            paperTable.append(orow1);
            paperTable.append(orow2);

            if (this._browserInfo.name == "msie" && this._browserInfo.version == 8) {
                printPageWidth = position.right;
                printPageHeight = position.bottom;
            }
            else {
                printPageWidth = position.width;
                printPageHeight = position.height;
            }
            $printPageSetup.ejDialog({ width: 400, position: { X: (position.left + (printPageWidth) / 3) + 20, Y: (position.top + (printPageHeight / 2)) / 2 }, enableModal: false, title: localeObj['toolbar']['pagesetup']['headerText'], enableResize: false, enablePersistance: false, close: $.proxy(this._pageSettingClose, this) });
            var $sizeHeader = ej.buildTag("div", "", { 'font-weight': 'bold', 'width': '100%' }, { 'id': this._id + '_paperSizeLabel' });
            var $paperSizeType = ej.buildTag("div.e-reportviewer-ejdropdownlist", "", { }, {});
            $sizeHeader.append(localeObj['pagesetupDialog']['paperSize']);
            cell11.append($sizeHeader);
            $paperSizeDDl = ej.buildTag("select", "", {}, { 'id': this._id + '_PaperSize' });
            $paperSizeDDl.append('<option value="A3">A3</option>');
            $paperSizeDDl.append('<option value="A4">A4</option>');
            $paperSizeDDl.append('<option value="B4(JIS)">B4(JIS)</option>');
            $paperSizeDDl.append('<option value="B5(JIS)">B5(JIS)</option>');
            $paperSizeDDl.append('<option value="Envelope #10">Envelope #10</option>');
            $paperSizeDDl.append('<option value="Envelope Monarch">Envelope Monarch</option>');
            $paperSizeDDl.append('<option value="Executive">Executive</option>');
            $paperSizeDDl.append('<option value="Legal">Legal</option>');
            $paperSizeDDl.append('<option value="Letter">Letter</option>');
            $paperSizeDDl.append('<option value="Tabloid">Tabloid</option>');
            $paperSizeDDl.append('<option value="Custom">Custom</option>');
            $paperSizeType.append($paperSizeDDl);
            $paperSizeDDl.ejDropDownList({ height: '32px', selectedIndex: 10, watermarkText: 'Select Option', change: $.proxy(this._setUpChange, this), enableIncrementalSearch: true });
            cell21.append($paperSizeType);
            var $paperSizeWidthLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_widthLabel" });
            var $paperSizeWidth = ej.buildTag("div", "", { }, {});
            var $paperSizeHeightLabel = ej.buildTag("span", "", { }, { 'id': this._id + "_heightLabel" });
            var $paperSizeHeight = ej.buildTag("div", "", {}, {});
            var $paperHeightUnitLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_heightUnitLabel" });
            var $paperWidthUnitLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_widthUnitLabel" });
            var $height = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'id': this._id + "_paperHeight" });
            var $width = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'id': this._id + "_paperWidth" });
            $paperSizeHeight.append($height);
            $paperSizeWidth.append($width);
            $paperSizeHeightLabel.append(localeObj['pagesetupDialog']['height'] + '&nbsp;');
            $paperHeightUnitLabel.append(localeObj['pagesetupDialog']['unit'] + '&nbsp;');
            $paperSizeWidthLabel.append(localeObj['pagesetupDialog']['width'] + '&nbsp;');
            $paperWidthUnitLabel.append(localeObj['pagesetupDialog']['unit'] + '&nbsp;');
            row3.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var cell31 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '15px' });
            cell31.append($paperSizeHeightLabel);
            row3.append(cell31);
            var cell32 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '75px' });
            cell32.append($paperSizeHeight);
            row3.append(cell32);
            var cell33 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '10px' });
            cell33.append($paperHeightUnitLabel);
            row3.append(cell33);
            row3.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var cell34 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '15px' });
            cell34.append($paperSizeWidthLabel);
            row3.append(cell34);
            var cell35 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '75px' });
            cell35.append($paperSizeWidth);
            row3.append(cell35);
            var cell36 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '10px' });
            cell36.append($paperWidthUnitLabel);
            row3.append(cell36);
            $height.ejNumericTextbox({ decimalPlaces: 2, enableStrictMode: true, width: '75px', minValue: 1, enable: false });
            $width.ejNumericTextbox({ decimalPlaces: 2, enableStrictMode: true, width: "75px", minValue: 1, enable: false });
            var $marginHeader = ej.buildTag("div", "", { 'font-weight': 'bold' }, { 'id': this._id + '_marginheader' });
            var $tbsubrow1Cell1 = ej.buildTag("span", "", {}, { 'id': this._id + "_topLabel"});
            var $tbsubrow1Cell2 = ej.buildTag("div", "", {}, {});
            var $topUnitLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_topUnitLabel" });
            var $tbsubrow1Cell3 = ej.buildTag("span", "", {}, { 'id': this._id + "_rightLabel" });
            var $tbsubrow1Cell4 = ej.buildTag("div", "", {}, {});
            var $rightUnitLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_rightUnitLabel" });
            var $tbsubrow2Cell1 = ej.buildTag("div", "", {}, { 'id': this._id + "_bottomLabel"});
            var $tbsubrow2Cell2 = ej.buildTag("div", "", {}, {});
            var $bottomUnitLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_bottomUnitLabel" });
            var $tbsubrow2Cell3 = ej.buildTag("span", "", {}, { 'id': this._id + "_leftLabel" });
            var $tbsubrow2Cell4 = ej.buildTag("div", "", {}, {});
            var $leftUnitLabel = ej.buildTag("span", "", {}, { 'id': this._id + "_leftUnitLabel" });
            $marginHeader.append(localeObj['pagesetupDialog']['margins']);
            mcell11.append($marginHeader);
            var $top = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'id': this._id + "_paperMarginTop" });
            var $right = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'id': this._id + "_paperMarginRight" });
            var $bottom = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'id': this._id + "_paperMarginBottom" });
            var $left = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'id': this._id + "_paperMarginLeft" });
            $tbsubrow1Cell1.append(localeObj['pagesetupDialog']['top'] + '&nbsp;');
            $topUnitLabel.append(localeObj['pagesetupDialog']['unit'] + '&nbsp;');
            $tbsubrow1Cell2.append($top);
            $tbsubrow1Cell3.append(localeObj['pagesetupDialog']['right'] + '&nbsp;');
            $rightUnitLabel.append(localeObj['pagesetupDialog']['unit'] + '&nbsp;');
            $tbsubrow1Cell4.append($right);
            $tbsubrow2Cell1.append(localeObj['pagesetupDialog']['bottom'] + '&nbsp;');
            $bottomUnitLabel.append(localeObj['pagesetupDialog']['unit'] + '&nbsp;');
            $tbsubrow2Cell2.append($bottom);
            $tbsubrow2Cell3.append(localeObj['pagesetupDialog']['left'] + '&nbsp;');
            $leftUnitLabel.append(localeObj['pagesetupDialog']['unit'] + '&nbsp;');
            $tbsubrow2Cell4.append($left);
            mrow2.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var mcell21 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '15px' });
            mcell21.append($tbsubrow1Cell1);
            mrow2.append(mcell21);
            var mcell22 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '75px' });
            mcell22.append($tbsubrow1Cell2);
            mrow2.append(mcell22);
            var mcell23 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '50px' });
            mcell23.append($topUnitLabel);
            mrow2.append(mcell23);
            mrow2.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var mcell24 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '15px' });
            mcell24.append($tbsubrow1Cell3);
            mrow2.append(mcell24);
            var mcell25 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '75px' });
            mcell25.append($tbsubrow1Cell4);
            mrow2.append(mcell25);
            var mcell26 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '10px' });
            mcell26.append($rightUnitLabel);
            mrow2.append(mcell26);
            mrow3.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var mcell31 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '15px' });
            mcell31.append($tbsubrow2Cell1);
            mrow3.append(mcell31);
            var mcell32 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '75px' });
            mcell32.append($tbsubrow2Cell2);
            mrow3.append(mcell32);
            var mcell33 = ej.buildTag('td .e-reportviewer-pagesetupcontent', '', { 'width': '10px' });
            mcell33.append($bottomUnitLabel);
            mrow3.append(mcell33);
            mrow3.append(ej.buildTag('td .e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var mcell34 = ej.buildTag('td .e-reportviewer-pagesetupcontent', '', { 'width': '15px' });
            mcell34.append($tbsubrow2Cell3);
            mrow3.append(mcell34);
            var mcell35 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '75px' });
            mcell35.append($tbsubrow2Cell4);
            mrow3.append(mcell35);
            var mcell36 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '10px' });
            mcell36.append($leftUnitLabel);
            mrow3.append(mcell36);
            $top.ejNumericTextbox({ decimalPlaces: 2, width: "75px", minValue: 0, maxValue: 22 });
            $right.ejNumericTextbox({ decimalPlaces: 2, width: "75px", minValue: 0, maxValue: 22 });
            $bottom.ejNumericTextbox({ decimalPlaces: 2, width: "75px", minValue: 0, maxValue: 22 });
            $left.ejNumericTextbox({ decimalPlaces: 2, width: "75px", minValue: 0, maxValue: 22 });
            var $orientation = ej.buildTag("div", "", { 'font-weight': 'bold' }, { 'id': this._id + '_orientationLabel' });
            $orientation.append(localeObj['pagesetupDialog']['orientation']);
            ocell11.append($orientation);
            var $radio1 = ej.buildTag("div", "", { 'float': 'left' }, {});
            var $radio1div1 = ej.buildTag("div", "", { 'float': 'left' }, {});
            var $radio1div2 = ej.buildTag("div", "", { 'float': 'left' }, { 'id': this._id + '_portraitLabel'});
            var $portraitradio = ej.buildTag("input", "", {}, { 'type': 'radio', 'id': this._id + '_portrait', 'value': 'Portrait' });
            $radio1div1.append($portraitradio);
            $radio1div2.append('&nbsp;' + localeObj['pagesetupDialog']['portrait']);
            $radio1.append($radio1div1);
            $radio1.append($radio1div2);
            $portraitradio.ejRadioButton({ name: 'orientation', checked: true, size: 'small' });
            var $radio2 = ej.buildTag("div", "", { 'float': 'left' }, {});
            var $radio2div1 = ej.buildTag("div", "", { 'float': 'left'}, {});
            var $radio2div2 = ej.buildTag("div", "", { 'float': 'left' }, { 'id': this._id + '_landscapeLabel' });
            var $landscaperadio = ej.buildTag("input", "", {}, { 'type': 'radio', 'id': this._id + '_landscape', 'value': 'Landscape' });
            $radio2div1.append($landscaperadio);
            $radio2div2.append("&nbsp;" + localeObj['pagesetupDialog']['landscape']);
            $radio2.append($radio2div1);
            $radio2.append($radio2div2);
            orow2.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var ocell21 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '90px' }, { 'colspan': '3' });
            ocell21.append($radio1);
            orow2.append(ocell21);
            orow2.append(ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '3px' }));
            var ocell22 = ej.buildTag('td.e-reportviewer-pagesetupcontent', '', { 'width': '90px' }, { 'colspan': '3' });
            ocell22.append($radio2);
            orow2.append(ocell22);
            $landscaperadio.ejRadioButton({ name: 'orientation', size: 'small' });
            var $confirm = ej.buildTag("div", "", { 'padding-top': '10px', 'float': 'right', 'padding-right': '13px', 'padding-bottom': '20px' }, {});
            var $submitButton = ej.buildTag("input.e-reportviewer-viewreportbutton e-btn", "", { 'min-width': '65px' }, { 'type': 'button', 'value': localeObj['pagesetupDialog']['doneButton'], 'id': this._id + '_Submit' });
            var $cancelButton = ej.buildTag("input.e-reportviewer-viewreportbutton e-btn", "", { 'margin-left': '6px', 'min-width': '65px' }, { 'type': 'button', 'value': localeObj['pagesetupDialog']['cancelButton'], 'id': this._id + '_Cancel' });
            $submitButton.ejButton({ showRoundedCorner: true, height: 30, click: $.proxy(this._pageSetupSubmit, this) });
            $cancelButton.ejButton({ showRoundedCorner: true, height: 30, click: $.proxy(this._pageSetupCancel, this) });
            $confirm.append($submitButton);
            $confirm.append($cancelButton);
            $defaultSetup.append($confirm);

            if ($paperSizeDDl.data('ejDropDownList')) {
                var _paperDllWidth = $printPageSetup[0].clientWidth - $($paperHeightUnitLabel.parent())[0].clientWidth - $($paperWidthUnitLabel.parent())[0].clientWidth;
                $paperSizeDDl.data('ejDropDownList')._setModel({ width: _paperDllWidth });
            }

            if (this._browserInfo.name == 'msie') {
                $('#' + this._id + '_PaperSize_input').css('margin-top', '-2px');
            } else if (this._browserInfo.name == 'opera' || this._browserInfo.name == 'webkit' || this._browserInfo.name == 'chrome' || this._browserInfo.name == 'mozilla') {
                $('#' + this._id + '_PaperSize_input').css('padding-bottom', '3px');
            }
        },

        //------------------------Render Print Page Setup [End] ------------------------//

        _renderViewerBlockinDevice: function (targetTag) {
            var div = ej.buildTag("div.e-reportviewer-viewer e-reportviewer-viewerblock e-reportviewer-blockstyle", "", {}, { 'id': this._id + '_viewBlockContainer' });
            targetTag.append(div);

            var $innerConetnt = ej.buildTag("div.e-reportviewer-viewerblockcellcontent", "", { 'margin': '1px', 'padding': '1px', 'width': '99%', 'height': '99%', 'display': 'inline-table' });
            var $blockContent = ej.buildTag("div.e-reportviewer-viewerblockcontent", "", { 'width': '100%', 'height': 'auto' });
            var $buttonConetnt = ej.buildTag("div.e-reportviewer-viewreport", "", { 'width': '100%', 'height': '30px', 'border-left': '0px', 'padding': '10px 0' });
            var $button = ej.buildTag("input.e-reportviewer-viewreportbutton e-btn", "", {}, { 'type': 'button', 'value': ej.ReportViewer.Locale[this.model.locale] ? ej.ReportViewer.Locale[this.model.locale]["viewButton"] : ej.ReportViewer.Locale["en-us"]["viewButton"], 'id': this._id + '_viewReportClick', 'data-role': 'none' });
            $buttonConetnt.append($button);
            $innerConetnt.append($blockContent);
            $innerConetnt.append($buttonConetnt);

            $button.ejButton({ showRoundedCorner: true });

            div.append($innerConetnt);
            return div;
        },

        _renderViewerBlockinWeb: function (targetTag) {
            var div = ej.buildTag("div.e-reportviewer-viewer e-reportviewer-viewerblock", "", {}, { 'id': this._id + '_viewBlockContainer' });
            targetTag.append(div);

            var $innerConetnt = ej.buildTag("table.e-reportviewer-viewerblockcellcontent e-reportviewer-blockcontainer", "", { 'margin': '1px', 'padding': '5px 5px 10px' });
            var $tr = ej.buildTag("tr", "", { 'width': '100%' });
            var $tdleft = ej.buildTag("td.e-reportviewer-viewerblockcontent", "", {});
            var $tdright = ej.buildTag("td.e-reportviewer-viewreport", "", {});
            var $button = ej.buildTag("input.e-reportviewer-viewreportbutton e-btn", "", {}, { 'type': 'button', 'value': ej.ReportViewer.Locale[this.model.locale] ? ej.ReportViewer.Locale[this.model.locale]["viewButton"] : ej.ReportViewer.Locale["en-US"]["viewButton"], 'id': this._id + '_viewReportClick', 'data-role': 'none' });
            $button.ejButton({ height: 32, cssClass: 'e-accent' });
            $tdright.append($button);
            $tr.append($tdleft);
            $tr.append($tdright);
            $innerConetnt.append($tr);

            $button.ejButton({ showRoundedCorner: true });

            div.append($innerConetnt);
            return div;
        },

        _renderViewerContainer: function (targetTag) {
            var div = ej.buildTag("div", "", {}, { 'id': this._id + '_reportviewerContainer' });
            targetTag.append(div);

            var $reportviewContainer = ej.buildTag("div.e-reportviewer-viewer e-reportviewer-scrollcontainer e-reportviewer-viewercontainer", "", { 'height': '100%', 'width': '100%', 'font-size': '8pt' }, { 'id': this._id + '_viewerContainer' });

            var $loadingindicator = ej.buildTag("div", "", { 'margin': '0px', 'height': '99.8%', 'width': '100%' }, { 'id': this._id + '_loadingIndicator' });
            var $loadingemptybackview = ej.buildTag("div", "", { 'margin': '0px', 'height': '99.8%', 'width': '100%', 'background-color': 'rgba(164, 183, 216, 0.18)', 'display': 'block' }, { 'id': this._id + '_loadingIndicatorBackView' });

            var $pageviewOuterContainer = ej.buildTag("div.e-reportviewer-pageviewcontainer", "", {}, { 'id': this._id + '_pageviewOuterContainer' });
            var $pageviewOuterline = ej.buildTag("div.e-reportviewer-pageouterline", "", {}, { 'id': this._id + '_pageviewOuterline' });
            var $pageviewContainer = ej.buildTag("div.e-reportviewer-pageview", "", { 'background-color': '#FFFFFF' }, { 'id': this._id + '_pageviewContainer' });

            var $pageviewheaderContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent' }, { 'id': this._id + '_pageviewheaderContainer' });
            var $pageviewbodyContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent' }, { 'id': this._id + '_pageviewbodyContainer' });
            var $pageviewfooterContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent' }, { 'id': this._id + '_pageviewfooterContainer' });

            var $pageviewheaderborder = ej.buildTag("div.pageHeaderBorder", "", { 'position': 'relative', 'background-color': '#FFFFFF' });
            var $pageviewbodyborder = ej.buildTag("div.pageBodyBorder", "", { 'position': 'relative', 'background-color': '#FFFFFF' });
            var $pageviewfooterborder = ej.buildTag("div.pageFooterBorder", "", { 'position': 'relative', 'background-color': '#FFFFFF' });

            if (this._printMode) {
                $pageviewheaderContainer.css('overflow', 'hidden');
                $pageviewfooterContainer.css('overflow', 'hidden');
            }

            $pageviewheaderborder.append($pageviewheaderContainer);
            $pageviewbodyborder.append($pageviewbodyContainer);
            $pageviewfooterborder.append($pageviewfooterContainer);
            $pageviewContainer.append($pageviewheaderborder);
            $pageviewContainer.append($pageviewbodyborder);
            $pageviewContainer.append($pageviewfooterborder);

            $loadingindicator.append($loadingemptybackview);
            $reportviewContainer.append($loadingindicator);
            $pageviewOuterline.append($pageviewContainer);
            $pageviewOuterContainer.append($pageviewOuterline);
            $reportviewContainer.append($pageviewOuterContainer);

            if (this._isDevice) {
                this._renderViewerBlockinDevice($reportviewContainer);
            } else {
                var $documentmapcontainer = ej.buildTag("div.e-reportviewer-documentmapcontainer", "", { 'display': 'none' }, { 'id': this._id + '_documentmapContainer' });
                div.append($documentmapcontainer);
            }

            div.append($reportviewContainer);

            return div;
        },

        _renderViewer: function () {
            var height = this.element.height();
            var width = this.element.width();

            var viewer = ej.buildTag("div.e-reportviewer-viewer", "", {});

            if (!this.element[0].style.height && this.element[0].parentElement.clientHeight != 0) {
                this._isHeight = true;
            }

            if (!this.element[0].style.width && this.element[0].parentElement.clientWidth != 0) {
                this._isWidth = true;
            }

            if (height === 0 && this.element[0].parentElement.clientHeight != 0) {
                this.element.height(this.element[0].parentElement.clientHeight);
                //viewer.height(this.element[0].parentElement.clientHeight);
            } else if (this._browserInfo.name == 'msie' && this._browserInfo.version == 8.0 && this.element[0].style.height.indexOf("%") != -1) {
                var isPercentHeight = parseInt(this.element[0].style.height);
                var containerHeight = this.element[0].parentElement.clientHeight
                containerHeight = ((containerHeight / 100) * isPercentHeight);
                this.element.height(containerHeight);
            }

            if (width === 0 && this.element[0].parentElement.clientWidth != 0) {
                this.element.width(this.element[0].parentElement.clientWidth);
                //viewer.width(this.element[0].parentElement.clientWidth);
            } else if (this._browserInfo.name == 'msie' && this._browserInfo.version == 8.0 && this.element[0].style.width.indexOf("%") != -1) {
                var isPercentWidth = parseInt(this.element[0].style.width);
                var containerWidth = this.element[0].parentElement.clientWidth
                containerWidth = ((containerWidth / 100) * isPercentWidth);
                this.element.width(containerWidth);
            }

            this.element.append(viewer);
            if ((this.model.renderMode & ej.ReportViewer.RenderMode.Mobile) && (this.model.renderMode & ej.ReportViewer.RenderMode.Desktop)) {
                this._isDevice = this._isMobileDevice();
            } else if (this.model.renderMode & ej.ReportViewer.RenderMode.Mobile) {
                this._isDevice = true;
            } else {
                this._isDevice = false;
            }
            this._renderToolBar(viewer);
            if (!this._isDevice) {
                this._renderViewerBlockinWeb(viewer);
                this._renderToolTip();
            }
            this._renderViewerContainer(viewer);
        },
        //-------------------- Render the ReportViewer Ctrl [End] -------------------------//

        //-------------------- Render Credential Block and Actions [Start] -------------------------//
        _renderCredentialBlock: function (datasources) {
            var table = ej.buildTag("table", "", {}, {});
            for (var index = 0; index < datasources.length; index++) {
                var datasource = datasources[index];
                var $headertr = ej.buildTag("tr", "", {}, {});
                var $headertd = ej.buildTag("td", "", {}, { 'colspan': !this._isDevice ? '5' : '1' });
                $headertd.html(!this._isDevice ? datasource.Prompt : 'Specify the ' + datasource.Name + ':');
                $headertr.append($headertd);

                if (!this._isDevice) {
                    var $row = ej.buildTag("tr", "", {}, {});
                    this._appendCredentialItems($row, 'namelbl', datasource);
                    this._appendCredentialItems($row, 'nametxt', datasource);
                    $row.append(ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", { 'width': '7px' }, {}));
                    this._appendCredentialItems($row, 'passwdlbl', datasource);
                    this._appendCredentialItems($row, 'passwdtxt', datasource);

                    table.append($headertr);
                    table.append('<tr height="6px"/>');
                    table.append($row);
                    table.append('<tr height="6px"/>');
                } else {
                    table.append($headertr);
                    table.append('<tr height="4px"/>');

                    var $row1 = ej.buildTag("tr", "", {}, {});
                    this._appendCredentialItems($row1, 'namelbl', datasource);
                    var $row2 = ej.buildTag("tr", "", {}, {});
                    this._appendCredentialItems($row2, 'nametxt', datasource);
                    var $row3 = ej.buildTag("tr", "", {}, {});
                    this._appendCredentialItems($row3, 'passwdlbl', datasource);
                    var $row4 = ej.buildTag("tr", "", {}, {});
                    this._appendCredentialItems($row4, 'passwdtxt', datasource);

                    table.append($row1);
                    table.append($row2);
                    table.append($row3);
                    table.append($row4);
                    table.append('<tr height="6px"/>');
                }
            }
            this._wiredViewClickEvent(datasources);
            var viewerBlock = $('#' + this._id + '_viewBlockContainer').find(".e-reportviewer-viewerblockcontent");
            viewerBlock.html(table);
        },

        _wiredViewClickEvent: function(datasources){
            this._on($('#' + this._id + '_viewReportClick'), "click", { ds: datasources }, this._viewReportCredentialClick);
        },

        _unwiredViewClickEvent: function () {
            this._off($('#' + this._id + '_viewReportClick'), "click", this._viewReportCredentialClick);
        },

        _appendCredentialItems: function (targetTag, eleType, datasource) {
            var $tbcell;
            switch (eleType) {
                case 'namelbl':
                    $tbcell = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", {}, {});
                    $tbcell.append('Login Name&nbsp;');
                    break;
                case 'nametxt':
                    $tbcell = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", {}, {});
                    var $loginname = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'autocomplete': 'off', 'id': datasource.ControlId + "_loginName" });
                    $tbcell.append($loginname);
                    break;
                case 'passwdlbl':
                    $tbcell = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", {}, {});
                    $tbcell.append('Password&nbsp;');
                    break;
                case 'passwdtxt':
                    $tbcell = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", {}, {});
                    var $password = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'password', 'autocomplete': 'off', 'id': datasource.ControlId + "_password" });
                    $tbcell.append($password);
                    break;
            }
            targetTag.append($tbcell);
        },

        _viewReportCredentialClick: function (event) {
            var datasources = event.data.ds;
            var jsdatasource = [];
            for (var index = 0; index < datasources.length; index++) {
                var datasource = datasources[index];
                var username = $('#' + datasource.ControlId + '_loginName').val();
                var password = $('#' + datasource.ControlId + '_password').val();
                jsdatasource.push({ 'Name': datasource.Name, 'UserName': username, 'Password': password });
            }
            this._dataSources = jsdatasource;
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.validateDSCredential, 'datasoures': jsdatasource }), "_validateDSCredential");
        },
        //-------------------- Render Credential Block and Actions [End] -------------------------//

        //-------------------- Render Parameter Block and Actions [Start] -------------------------//
        _renderParameterBlock: function (parameters) {
            var table = ej.buildTag("table", "", {}, { 'isViewClick': false });
            if (this._isDevice) {
                table.css('width', '100%');
            }
            if (parameters != null && parameters.length > 0) {
                var viewerBlock = $('#' + this._id + '_viewBlockContainer').find(".e-reportviewer-viewerblockcontent");
                var isRender = this._onRenderingBegin({ reportParameters: $.extend(true, {}, parameters), parameterBlock: $('#' + this._id + '_viewBlockContainer') });
                if (!isRender) {
                    viewerBlock.html(table);
                    for (var index = 0; index < parameters.length; index++) {
                        var parameter = parameters[index];

                        var tablerow;
                        var $contentDiv;
                        var $tdCell01;
                        var $tdCell02;
                        if (!this._isDevice) {
                            if (index % 2 == 0) {
                                if (index !=0) {
                                    table.append('<tr style="height: 15px;"/>');
                                }
                                else {
                                    table.append('<tr class="e-reportviewer-tr"/>');
                                }
                                tablerow = ej.buildTag("tr", "", {}, {});
                                table.append(tablerow);
                            } else {
                                var $tdmiddle = ej.buildTag("td", "", {}, {});
                                tablerow.append($tdmiddle);
                            }
                            $tdCell01 = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", {}, {});
                            $tdCell01.append(parameter.Prompt + '&nbsp;&nbsp;');
                            tablerow.append($tdCell01);
                            $tdCell02 = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", { 'min-width': '130px', 'max-width': '185px', 'padding-right': '20px' }, {});
                            tablerow.append($tdCell02);

                            $contentDiv = ej.buildTag("div", "", { 'width': '100%', 'display': 'flex', 'white-space': 'nowrap' }, { 'id': parameter.ControlId + '_div' });
                            $tdCell02.append($contentDiv);

                        } else {
                            table.append('<tr class="e-reportviewer-tr"/>');
                            tablerow = ej.buildTag("tr", "", {}, {});
                            table.append(tablerow);
                            $tdCell01 = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", {}, {});
                            $tdCell01.append(parameter.Prompt + '&nbsp;&nbsp;');
                            tablerow.append($tdCell01);

                            tablerow = ej.buildTag("tr", "", {}, {});
                            table.append(tablerow);
                            $tdCell02 = ej.buildTag("td.e-reportviewer-viewerblockcellcontent", "", { 'min-width': '130px', 'max-width': '185px' }, {});
                            tablerow.append($tdCell02);

                            $contentDiv = ej.buildTag("div", "", { 'width': '100%', 'display': 'flex', 'white-space': 'nowrap' }, { 'id': parameter.ControlId + '_div' });
                            $tdCell02.append($contentDiv);
                        }
                        this._renderParameterElements(parameter, $contentDiv);
                    }
                }
            }
            else {
                this._showParameterBlock(false);
            }
            table.append('<tr class="e-reportviewer-tr"/>');
            this._onRenderingComplete({ reportParameters: $.extend(true, {}, parameters) });
            this._on($('#' + this._id + '_viewReportClick'), "click", { params: parameters }, this._viewReportParamsClick);
            return isRender;
        },

        _renderParameterElements: function (parameter, $contentDiv) {
            var indexddl;
            var $parameterSpan;
            var $parameterNull;
            var $optionText;
            if (parameter.IsMultiValue) {
                var itemindex = [];
                if ($("#" + parameter.ControlId + "_popup_wrapper").length > 0) {
                    $("#" + parameter.ControlId + "_popup_wrapper").remove();
                }
                var $paramMultiValuedropdown = ej.buildTag("select", "", {}, { 'id': parameter.ControlId, 'name': parameter.Name, 'sf-name': parameter.Name });
                if (parameter.AvailableLabels) {
                    var $CheckBoxInput = $('<input id =' + parameter.ControlId + '_check type=\'checkbox\'/>');
                    var $checkBoxDiv = ej.buildTag("div", "", { 'border-bottom': '1px solid #c8c8c8' });
                    $checkBoxDiv.append($CheckBoxInput);
                    var _selectedFieldVals = $.extend(parameter.DefaultValuesfields, true);
                    if (parameter.Values && parameter.Values.length > 0) {
                        _selectedFieldVals = parameter.Values;
                    }

                    for (var indexddl = 0; indexddl < parameter.AvailableLabels.length; indexddl++) {
                        $optionText = $('<option value="' + parameter.AvailableValues[indexddl] + '">' + parameter.AvailableLabels[indexddl] + '</option>');
                        if (jQuery.inArray(parameter.AvailableValues[indexddl], _selectedFieldVals) != -1) {
                            itemindex.push(indexddl);
                        }
                        $paramMultiValuedropdown.append($optionText);
                    }
                    $contentDiv.append($paramMultiValuedropdown);
                    $paramMultiValuedropdown.ejDropDownList({ cssClass: 'e-reportviewer-param', width: '100%', showCheckbox: true, selectedIndices: itemindex, watermarkText: 'Select Option', change: parameter.IsDependent ? this._paramsChangeEvent : '', popupHide: parameter.IsDependent ? this._paramsChangeEvent : '', enableFilterSearch: this.model.enableDropDownSearch, headerTemplate: $checkBoxDiv[0].outerHTML });
                    $("#" + parameter.ControlId + "_check").ejCheckBox({ cssClass: 'e-reportviewer-paramcheckbox', size: "small", text: "Select All", change: this._onCheckAll });
                    var textEle = $($("#" + parameter.ControlId + "_check")).siblings('.e-text');
                    textEle[0].className = textEle[0].className + " e-reportviewer-paramcheckbox";
                    textEle.css('font-size', '14px');
                    textEle.css('width', '69%');
                    textEle.css('padding-left', '15.5%');
                }
                else if (parameter.DefaultValues) {
                    $optionText = $('<option value="parameter_SelectAll">Select All</option>"');
                    $paramMultiValuedropdown.append($optionText);
                    var _selectedFieldVals = $.extend(parameter.DefaultValuesfields, true);
                    if (parameter.Values && parameter.Values.length > 0) {
                        _selectedFieldVals = parameter.Values;
                    }
                    for (var indexddl = 0; indexddl < parameter.DefaultValues.length; indexddl++) {
                        $optionText = $('<option value="' + parameter.DefaultValues[indexddl] + '">' + parameter.DefaultValues[indexddl] + '</option>');
                        if (jQuery.inArray(parameter.DefaultValues[indexddl], _selectedFieldVals) != -1) {
                            itemindex.push(indexddl + 1);
                        }
                        $paramMultiValuedropdown.append($optionText);
                    }
                    if (parameter.DefaultValues.length == itemindex.length) {
                        itemindex.push(0);
                    }
                    $contentDiv.append($paramMultiValuedropdown);
                    $paramMultiValuedropdown.ejDropDownList({ cssClass: 'e-reportviewer-param', width: '100%', showCheckbox: true, selectedIndices: itemindex, watermarkText: 'Select Option', change: parameter.IsDependent ? this._paramsChangeEvent : '', popupHide: parameter.IsDependent ? this._paramsChangeEvent : '', checkChange: this._selectionChanged, enableFilterSearch: this.model.enableDropDownSearch });
                }
            } else if (parameter.AvailableValues != null) {
                var $parameterdropdown = ej.buildTag("select", "", {}, { 'id': parameter.ControlId, 'name': parameter.Name, 'data': 'select', 'sf-name': parameter.Name });
                var selectindex = 9999;
                var isSelectVal = false;
                for (indexddl = 0; indexddl < parameter.AvailableLabels.length; indexddl++) {
                    if (parameter.AvailableLabels[indexddl] != 'Select a value') {
                        $optionText = $('<option value="' + parameter.AvailableValues[indexddl] + '">' + parameter.AvailableLabels[indexddl] + '</option>');
                        if (parameter.AvailableLabels[indexddl] == parameter.Label) {
                            selectindex = indexddl;
                        }
                        $parameterdropdown.append($optionText);
                    } else if (parameter.AvailableLabels[indexddl] == 'Select a value') {
                        isSelectVal = true;
                    }
                }

                if (isSelectVal) {
                    selectindex = selectindex - 1;
                }

                $contentDiv.append($parameterdropdown);
                var _dropDownJson = { cssClass: 'e-reportviewer-param', width: '100%', watermarkText: 'Select a Value', change: parameter.IsDependent ? this._paramsChangeEvent : '', popupHide: parameter.IsDependent ? this._paramsChangeEvent : '', enableIncrementalSearch: true, enableFilterSearch: this.model.enableDropDownSearch };
                if (selectindex != 9999) {
                    _dropDownJson.selectedIndex = selectindex;
                }
                $parameterdropdown.ejDropDownList(_dropDownJson);
            } else if (parameter.DataType == "DateTime") {
                var $parameterdatepicker = ej.buildTag("input.e-reportviewer-textbox e-reportviewer-DateTime", "", {}, { 'type': 'text', 'id': parameter.ControlId, 'maxlength': '256', 'name': parameter.Name });
                $contentDiv.append($parameterdatepicker);
                var datestring = ((parameter.Label.indexOf('-')) ? (parameter.Label.replace(/\-/g, "/")) : parameter.Label);
                $parameterdatepicker.ejDatePicker({ cssClass: 'e-reportviewer-param', width: parameter.IsNullable ? "75%" : "100%", value: parameter.Label != null && parameter.Label.length > 0 ? new Date(datestring ? datestring : parameter.Label) : null, change: parameter.IsDependent ? this._paramsChangeEvent : '', locale: (this.model.locale != this._machineCulture) ? this._machineCulture : this.model.locale });
                if (parameter.IsNullable) {
                    $parameterSpan = ej.buildTag("span", "", { 'WHITE-SPACE': 'nowrap', 'display': 'block' }, {});
                    $parameterNull = ej.buildTag("input", "", {}, { 'type': 'checkbox', 'name': 'chkDateTime', 'id': parameter.ControlId + '~chk', 'value': this._id });
                    $parameterSpan.append($parameterNull);
                    $parameterSpan.append('&nbsp;<span class=e-reportviewer-label>Null</span>');
                    $contentDiv.append('&nbsp;');
                    $contentDiv.append($parameterSpan);
                    if (parameter.Label != null && parameter.Label.length > 0) {
                        $parameterNull.ejCheckBox({ "change": this._paramNullChange });
                    } else {
                        $parameterNull.ejCheckBox({ "change": this._paramNullChange, checked: true });
                        this._paramElementDisable(parameter.ControlId, 'chkDateTime', true);
                    }
                }
            } else if (parameter.DataType == "Boolean") {
                var $parametertable = ej.buildTag("table", "", {}, {});
                var $parametertr = ej.buildTag("tr", "", {}, {});
                $parametertable.append($parametertr);

                var propStat = false;
                if (parameter.Label != null && parameter.Label.length > 0) {
                    if (parameter.Label.toLowerCase() == "true") {
                        propStat = true;
                    }
                }

                var $parametertd01 = ej.buildTag("td", "", {}, {});
                var $parameterradio01 = ej.buildTag("input", "", {}, { 'type': 'radio', 'name': parameter.Name, 'id': parameter.ControlId + '_01' });
                $parametertd01.append($parameterradio01);
                $parametertd01.append("&nbsp;<span>True</span>");
                $parameterradio01.ejRadioButton({ checked: propStat });
                $parametertr.append($parametertd01);

                $parametertr.append('<td width=10px/>');

                var $parametertd02 = ej.buildTag("td", "", {}, {});
                var $parameterradio02 = ej.buildTag("input", "", {}, { 'type': 'radio', 'name': parameter.Name, 'id': parameter.ControlId + '_02' });
                $parametertd02.append($parameterradio02);
                $parametertd02.append("&nbsp;<span>False</span>");
                if (parameter.Label != null && parameter.Label.length > 0) {
                    propStat = !propStat;
                }
                $parameterradio02.ejRadioButton({ checked: propStat });
                $parametertr.append($parametertd02);

                $contentDiv.append($parametertable);

                if (parameter.IsNullable) {
                    $parameterSpan = ej.buildTag("span", "", { 'WHITE-SPACE': 'nowrap', 'display': 'block' }, {});
                    $parameterNull = ej.buildTag("input", "", {}, { 'type': 'checkbox', 'name': 'chkRadio', 'id': parameter.ControlId + '~chk', 'value': this._id });
                    $parameterSpan.append($parameterNull);
                    $parameterSpan.append('&nbsp;<span class=e-reportviewer-label>Null</span>');
                    $contentDiv.append('&nbsp;');
                    $contentDiv.append($parameterSpan);
                    $parameterNull.ejCheckBox({ "change": this._paramNullChange });
                    if (parameter.Label != null && parameter.Label.length > 0) {
                        $parameterNull.ejCheckBox({ "change": this._paramNullChange });
                    } else {
                        $parameterNull.ejCheckBox({ "change": this._paramNullChange, checked: true });
                        this._paramElementDisable(parameter.ControlId, 'chkRadio', true);
                    }
                }
            } else {
                var $parametertxtbx = ej.buildTag("input.e-reportviewer-textbox", "", {}, { 'type': 'text', 'autocomplete': 'off', 'id': parameter.ControlId, 'maxlength': '256', 'name': parameter.Name, 'value': parameter.Label });
                $contentDiv.append($parametertxtbx);
                if (parameter.IsNullable) {
                    $parametertxtbx.css('width', '75%');
                    $parameterSpan = ej.buildTag("span", "", { 'WHITE-SPACE': 'nowrap', 'display': 'block' }, {});
                    $parameterNull = ej.buildTag("input", "", {}, { 'type': 'checkbox', 'name': 'chkTextbox', 'id': parameter.ControlId + '~chk', 'value': this._id });
                    $parameterSpan.append($parameterNull);
                    $parameterSpan.append('&nbsp;<span class=e-reportviewer-label>Null</span>');
                    $contentDiv.append('&nbsp;');
                    $contentDiv.append($parameterSpan);
                    $parameterNull.ejCheckBox({ "change": this._paramNullChange });
                    if (parameter.Label != null && parameter.Label.length > 0) {
                        $parameterNull.ejCheckBox({ "change": this._paramNullChange });
                    } else {
                        $parameterNull.ejCheckBox({ "change": this._paramNullChange, checked: true });
                        this._paramElementDisable(parameter.ControlId, 'chkTextbox', true);
                    }
                } else {
                    $parametertxtbx.css('width', '96%');
                }

                if (parameter.IsDependent) {
                    this._on($parametertxtbx, "change", this._paramsChangeEvent);
                }
            }
        },

        _onCheckAll: function (event) {
            var paramId = event.model.id.substring(0, event.model.id.indexOf("_check"));
            var obj = $("#" + paramId).ejDropDownList("instance");
            if (event.isChecked) obj.checkAll();
            else obj.uncheckAll();
        },

        _selectionChanged: function (event) {
            var activeItem = this._activeItem;
            if (this.selectedIndexValue == 0 && this.selectedTextValue == "Select All") {
                if (this.checkedStatus) {
                    for (var index = 1; index < this.listitems.length; index++) {
                        this._setModel({ selectedIndex: index });
                    };
                }
                else {
                    for (var index = 1; index < this.listitems.length; index++) {
                        this.unselectItemsByIndices(index);
                    };
                }
            }
            else if (this._selectedIndices.length == this.listitems.length - 1) {
                if (this.checkedStatus) {
                    this._setModel({ selectedIndex: 0 });
                }
                else {
                    this.unselectItemsByIndices(0);
                }
            }
            this._activeItem = activeItem;
        },

        _updateParamElements: function (parameters) {
            var isRender = this._onRenderingBegin({ reportParameters: $.extend(true, {}, parameters) });
            if (!isRender) {
                for (var index = 0; index < parameters.length; index++) {
                    var parameter = parameters[index];
                    var targetTag = $('#' + parameter.ControlId + '_div');
                    if (parameter.IsMultiValue || parameter.AvailableValues != null || parameter.DataType == "Boolean") {
                        targetTag.empty();
                        parameter.Labels = parameter.Values = null;
                        this._renderParameterElements(parameter, targetTag);
                    } else if (parameter.DataType == "DateTime") {
                        var ejDatePick = $('#' + parameter.ControlId).data("ejDatePicker");
                        ejDatePick.setModel({ value: parameter.Label });
                    } else {
                        $('#' + parameter.ControlId).val(parameter.Label);
                    }
                }
            }
            this._onRenderingComplete({ reportParameters: $.extend(true, {}, parameters) });
            return isRender;
        },

        _paramsChangeEvent: function (event) {
            var ejViewerId = this._id.substr(0, (this._id.lastIndexOf('Param') - 1));
            var proxy = $('#' + ejViewerId).data('ejReportViewer');
            var updateParam = {
                Name: '',
                Labels: [],
                Values: []
            };
            var targetTag = $('#' + this._id);
            updateParam.Name = targetTag.attr('name');
            if (this.pluginName == 'ejDropDownList') {
                if (updateParam.Name == undefined) {
                    updateParam.Name = targetTag.attr('sf-name');
                }
                if (this.model.showCheckbox) {
                    for (var optIndex = 0; optIndex < this.model.selectedIndices.length; optIndex++) {
                        updateParam.Labels.push(this.selectOptionItems[this.model.selectedIndices[optIndex]].text);
                        updateParam.Values.push(this.selectOptionItems[this.model.selectedIndices[optIndex]].value);
                    }
                } else {
                    updateParam.Labels.push(this.selectOptionItems[this.model.selectedIndex].text);
                    updateParam.Values.push(this.selectOptionItems[this.model.selectedIndex].value);
                }
                if (event.type != "popupHide")
                    return;
            } else if (this.pluginName == 'ejDatePicker') {
                var dateTime = targetTag.data("ejDatePicker").getValue();
                updateParam.Labels.push(dateTime);
                updateParam.Values.push(dateTime);
            } else if (this.pluginName == 'ejRadioButton') {
                var isCheck = data("ejRadioButton").model.checked;
                updateParam.Labels.push(isCheck);
                updateParam.Values.push(isCheck);
            } else {
                updateParam.Labels.push(targetTag.val());
                updateParam.Values.push(targetTag.val());
            }
            proxy.doAjaxPost("POST", proxy._actionUrl, JSON.stringify({ 'reportAction': proxy._reportAction.updateParameters, 'updateParam': updateParam }), "_updateParameters");
        },

        _viewReportParamsClick: function (event) {
            this._showloadingIndicator(true);
            var parameters = event.data.params;
            var reportParams = this._getParameterJson(parameters, true);
            if (reportParams) {
                this._viewReportEnableDisable(true);
                this._refresh = true;
                $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcontent table:first').attr('isviewclick', 'true');
                this._onViewReportClick(reportParams);
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.setParameters, 'parameters': reportParams }), "_setParameters");
            }
        },

        _viewReportEnableDisable: function (enable) {
            $('#' + this._id + '_viewReportClick').attr('disabled', enable)
        },

        _getDefaultParameters: function (defaultparameters) {
            var values = [];
            var labels = [];
            for (var parameterIndex = 0; parameterIndex < defaultparameters.length; defaultparameters++) {
                if (defaultparameters[parameterIndex].DefaultValues) {
                    for (var optIndex = 0; optIndex < defaultparameters[parameterIndex].DefaultValues.length; optIndex++) {
                        labels.push(defaultparameters[0].DefaultValues[optIndex]);
                        values.push(defaultparameters[0].DefaultValues[optIndex]);
                    }
                    var reportParams = [{ Name: defaultparameters[parameterIndex].Name, Values: values, Labels: labels, Nullable: defaultparameters[parameterIndex].IsNullable }];
                    this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.setParameters, 'parameters': reportParams }), "_setParameters");
                }
            }
        },

        _getParameterJson: function (parameters, isUIUpdate) {
            var reportParams = [];
            for (var index = 0; index < parameters.length; index++) {
                var parameter = parameters[index];
                var values = [];
                var labels = [];
                var nullable = false;
                var isNull;
                if (parameter.IsMultiValue) {
                    var ddl = $('#' + parameter.ControlId).data("ejDropDownList");
                    var selectedIndex = ddl._selectedIndices;
                    for (var optIndex = 0; optIndex < selectedIndex.length; optIndex++) {
                        labels.push(ddl.selectOptionItems[selectedIndex[optIndex]].text);
                        values.push(ddl.selectOptionItems[selectedIndex[optIndex]].value);
                    }
                } else if (parameter.AvailableValues != null) {
                    if (parameter.IsNullable) {
                        nullable = parameter.IsNullable;
                    }
                    var ddlVal = $('#' + parameter.ControlId).data("ejDropDownList").getSelectedValue();
                    var ddltxt = $('#' + parameter.ControlId).data("ejDropDownList").getSelectedItem();
                    ddlVal = (ddlVal == "") ? parameter.Value : ddlVal;
                    ddltxt = (ddltxt && $(ddltxt).text() == "") ? parameter.Label : $(ddltxt).text();
                    labels.push(ddltxt);
                    values.push(ddlVal);
                } else if (parameter.DataType == "DateTime") {
                    isNull = $('#' + parameter.ControlId + '_div').find('.e-chkbox-wrap').attr('aria-checked');
                    if (isNull == 'true') {
                        nullable = true;
                    } else {
                        var dateTime = $('#' + parameter.ControlId).data("ejDatePicker").getValue();
                        labels.push(dateTime);
                        values.push(dateTime);
                    }
                } else if (parameter.DataType == "Boolean") {
                    var radio1 = $('#' + parameter.ControlId + '_01').data("ejRadioButton");
                    var radio2 = $('#' + parameter.ControlId + '_02').data("ejRadioButton");
                    isNull = $('#' + parameter.ControlId + '_div').find('.e-chkbox-wrap').attr('aria-checked');
                    if (isNull == 'true') {
                        nullable = true;
                    } else if (radio1.model.checked || radio2.model.checked) {
                        labels.push(radio1.model.checked);
                        values.push(radio1.model.checked);
                    }
                } else {
                    isNull = $('#' + parameter.ControlId + '_div').find('.e-chkbox-wrap').attr('aria-checked');
                    if (isNull == 'true') {
                        nullable = true;
                    } else {
                        var val = $('#' + parameter.ControlId).val();
                        if (isUIUpdate) {
                            if (parameter.DataType == "Float" && !val.match('^[-+]?[0-9]+\.[0-9]+$')) {
                                alert('Please give the float data type input');
                                return false;
                            } else if (parameter.DataType == "Integer" && !val.match('^[-+]?[0-9]+$')) {
                                alert('Please give the integer data type input');
                                return false;
                            }
                        }
                        labels.push(val);
                        values.push(val);
                    }
                }

                var parameterValue = { Name: parameter.Name, Values: values, Labels: labels, Nullable: nullable };
                reportParams.push(parameterValue);
            }
            return reportParams;
        },

        _paramNullChange: function (event) {
            var id = event.model.id.split('~');
            var ejReport = $('#' + event.model.value).data("ejReportViewer");
            ejReport._paramElementDisable(id[0], event.model.name, event.isChecked);
        },

        _paramElementDisable: function (elementId, elementType, isEnable) {
            if (elementType == 'chkDateTime') {
                var dateTime = $('#' + elementId).data("ejDatePicker");
                if (isEnable) {
                    dateTime.disable();
                } else {
                    dateTime.enable();
                }
            } else if (elementType == 'chkTextbox') {
                if (isEnable) {
                    $('#' + elementId).attr('disabled', 'disabled');
                    $('#' + elementId).css('opacity', '0.45');
                } else {
                    $('#' + elementId).removeAttr('disabled');
                    $('#' + elementId).css('opacity', '1');
                }
            } else if (elementType == 'chkRadio') {
                var radio1 = $('#' + elementId + '_01').data("ejRadioButton");
                var radio2 = $('#' + elementId + '_02').data("ejRadioButton");
                if (isEnable) {
                    radio1.disable();
                    radio2.disable();
                } else {
                    radio1.enable();
                    radio2.enable();
                }
            }
        },

        _selectparamToolItem: function (enable) {
            if (!this.model.toolbarSettings.templateId) {
                var _ejToolbar = $('#' + this._id + '_toolbarContainer').data("ejToolbar");
                if (enable) {
                    _ejToolbar.selectItemByID(this._id + '_ejtb_parameter');
                } else {
                    _ejToolbar.deselectItemByID(this._id + '_ejtb_parameter');
                }
            }
        },

        _showParameterBlock: function (enable) {
            if (enable) {
                $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').css("display", "block");
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-parameter').parent().css("display", "block");
            } else {
                $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').css("display", "none");
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-parameter').parent().css("display", "none");
            }

            if (this._isDevice) {
                this._showViewerBlock(enable);
                this._showViewerPage(!enable);
            }
        },

        _toggleParameterBlock: function () {
            this._selectparamToolItem(!($('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').css("display") == 'block'));
            $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').toggle();
            this._setContainerSize();

            if (this._isDevice) {
                var isEnable = $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').css("display") == "block";
                this._showViewerBlock(isEnable);
                this._showViewerPage(!isEnable);
            }
        },
        //-------------------- Render Parameter Block and Actions [End] -------------------------//

        //-------------------- Render Exception Block and Actions [Start] -------------------------//
        _renderExceptionBlock: function (errmsg) {
            this._resetExceptionBlock();
            $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').css("display", "none");
            var table = ej.buildTag("table.errmsg e-reportviewer-blockcontainer", "", {});
            table[0].style.cssText = 'padding: 6px 0px 5px 20px !important';
            var $row = ej.buildTag("tr", "", {}, {});
            var $cell = ej.buildTag("td", "", { 'width': '100%' }, {});
            var $closeCell = ej.buildTag("td", "", { 'width': '100%' }, {});
            var $cancelbutton = ej.buildTag("span.e-reportviewer-icon e-reportviewer-close", "", {}, { 'id': this._id + '_closebutton', 'title': 'Close this message' });
            $row.append($cell);
            $row.append($closeCell);
            $closeCell.append($cancelbutton);
            $cell.append("<span>Report Viewer encountered some issues loading this report. Please click <a id=" + this._id + '_viewBlockContainer_errmsg' + " href=javascript:void(0); >here</a>  to see the error details</span>");
            table.append($row);
            $('#' + this._id + '_viewBlockContainer').append(table);
            this._on($('#' + this._id + '_viewBlockContainer_errmsg'), "click", { err: errmsg }, this._errorPopupblock);
            this._on($('#' + this._id + '_closebutton'), "click", this._closeException);
        },

        _closeException: function () {
            $('#' + this._id + '_viewBlockContainer table.errmsg').remove();
            this._setContainerSize();
        },

        _errorPopupblock: function (event) {
            alert(event.data.err);
        },

        _resetExceptionBlock: function () {
            $('#' + this._id + '_viewBlockContainer table.errmsg').remove();
        },

        _renderExcpetion: function (exception) {
            this._showloadingIndicator(false);
            //$('#' + this._id + '_viewerContainer').html('Exception:' + exception);
            this._renderExceptionBlock(exception);
            this._showViewerBlock(true);
        },

        _showExceptionResult: function (isError, reportresult) {
            if (!isError && this.model.enableNotificationBar) {
                if (this._isDevice) {
                    alert(reportresult);
                } else {
                    this._renderExceptionBlock(reportresult);
                    this._showViewerBlock(true);
                }
            }
        },
        //-------------------- Render Exception Block and Actions [End] -------------------------//

        //-------------------- Apply Page Style and Actions [Start] -------------------------//
        _setContainerSize: function () {
            var ctrlheight = $('#' + this._id).height();



            var viewerblockHeight = 0;
            if (!this._isDevice) {
                var viewerContainer = $('#' + this._id + '_viewBlockContainer');
                if (viewerContainer.length > 0 && viewerContainer.css('display').toLowerCase() == 'block') {
                    viewerblockHeight = $('#' + this._id + '_viewBlockContainer').height();
                }
            }

            var toolbarHeight = this.model.toolbarSettings.templateId ? $('#' + this.model.toolbarSettings.templateId).height() : $('#' + this._id + '_toolbarContainer').height();

            var calcHeight = ctrlheight - viewerblockHeight - toolbarHeight - 4;
            $('#' + this._id + '_viewerContainer').css({ "height": calcHeight + "px" });
        },

        _setPageSize: function (pageHeight, pageWidth, headerHeight, footerHeight) {
            var pageSizeWidth = null, pageSizeHeight = null;
            var totalpageHeight = pageHeight + headerHeight + footerHeight + 3;

            $('#' + this._id + '_pageviewContainer').css({ "width": pageWidth + "px", "height": totalpageHeight + "px" });
            $('#' + this._id + '_pageviewheaderContainer').css({ "width": pageWidth + "px", "height": headerHeight + "px" });
            $('#' + this._id + '_pageviewfooterContainer').css({ "width": pageWidth + "px", "height": footerHeight + "px" });
            $('#' + this._id + '_pageviewbodyContainer').css({ "height": pageHeight + "px", "width": pageWidth + "px" });
            var scalePageSize = $('#' + this._id + '_pageviewContainer')[0].getBoundingClientRect();

            if (this._browserInfo.name == 'msie' && this._browserInfo.version == 8) {
                pageSizeWidth = scalePageSize.right - scalePageSize.left;
                pageSizeHeight = scalePageSize.bottom - scalePageSize.top;
            }
            else {
                pageSizeWidth = scalePageSize.width;
                pageSizeHeight = scalePageSize.height;
            }
            $('#' + this._id + '_pageviewOuterline').css({ "width": pageSizeWidth + "px", "height": pageSizeHeight + "px" });
        },

        _renderPageModels: function (pageData) {
            $('#' + this._id + '_pageviewheaderContainer').empty();
            $('#' + this._id + '_pageviewfooterContainer').empty();
            $('#' + this._id + '_pageviewbodyContainer').empty();
            if (pageData) {
                if (pageData.ReportStyleModel) {
                    this._applyPageStyle($('#' + this._id + '_pageviewContainer'), pageData.ReportStyleModel, false);
                }

                if (pageData.HeaderStyleModel) {
                    this._applyPageStyle($('#' + this._id + '_pageviewContainer .pageHeaderBorder'), pageData.HeaderStyleModel, false);
                }

                if (pageData.FooterStyleModel) {
                    this._applyPageStyle($('#' + this._id + '_pageviewContainer .pageFooterBorder'), pageData.FooterStyleModel, false);
                }

                if (pageData.BodyStyleModel) {
                    this._applyPageStyle($('#' + this._id + '_pageviewContainer .pageBodyBorder'), pageData.BodyStyleModel, false);
                }

                if (pageData.HeaderModel && pageData.HeaderModel.length > 0) {
                    this._renderPageControls(pageData.HeaderModel, $('#' + this._id + '_pageviewheaderContainer'), false, null);
                    if (this._printMode) {
                        $('#' + this._id + '_pageviewheaderContainer').css('overflow', 'hidden');
                    }
                }

                if (pageData.FooterModel && pageData.FooterModel.length > 0) {
                    this._renderPageControls(pageData.FooterModel, $('#' + this._id + '_pageviewfooterContainer'), false, null);
                    if (this._printMode) {
                        $('#' + this._id + '_pageviewfooterContainer').css('overflow', 'hidden');
                    }
                }

                if (pageData.PageModel && pageData.PageModel.length > 0) {
                    this._renderPageControls(pageData.PageModel, $('#' + this._id + '_pageviewbodyContainer'), false, null);
                }
            }

            if ($('.txtToggle_' + this._id).length > 0) {
                this._drillAction();
            }

            if ($('.drillAction_' + this._id).length > 0) {
                this._drillThroughAction();
            }

            if ($('.txtSorting_' + this._id).length > 0) {
                this._sortingAction();
            }

            if (this._isDocumentMap && !this._printMode) {
                this._documentMapAction();
                this._isDocumentMap = false;
                this._pageDocMapFlag = true;
            }

            if (this._parentPageXY) {
                $('#' + this._id + '_viewerContainer').animate({ scrollTop: this._parentPageXY.y, scrollLeft: this._parentPageXY.x }, 1000);
                this._parentPageXY = null;
            }

            //if (this._isDevice) {
            //    this._renderPageInfoPopup();
            //}

            if (this.model.printMode) {
                $('#' + this._id + '_pageviewContainer').css({ 'padding-left': this._pageModel.MarginLeft, 'padding-top': this._pageModel.MarginTop, 'padding-right': this._pageModel.MarginRight, 'padding-bottom': this._pageModel.MarginBottom });
            } else {
                $('#' + this._id + '_pageviewContainer').css('padding', '0px');
            }
        },

        _applyPageStyle: function (page, styleModel, printMode) {
            var resourceName = printMode ? 'PrintImage' : 'GetResource';
            if (styleModel.BackgroundColor) {
                page.css("background-color", styleModel.BackgroundColor);
            }
            if (styleModel.BackgroundSrc) {
                page.css("background-image", "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + styleModel.BackgroundSrc + '&resourcetype=sfimg&isPrint=' + printMode + ")");
            }
            if (styleModel.Border) {
                this._applyBorderStyle(styleModel.Border, page);
            }
        },

        _renderPageControls: function (pageModelItems, renderArea, printMode, printPageId) {
            var $reportItemsContainer = ej.buildTag("div", "", {}, {});
            renderArea.html($reportItemsContainer);
            for (var index = 0; index < pageModelItems.length; index++) {
                var reportItem = pageModelItems[index];
                if (reportItem.ItemType == "TextBoxModel") {
                    var textboxControl = this._renderTextBoxControl(reportItem, false, null, printMode, printPageId);
                    $reportItemsContainer.append(textboxControl);
                }
                else if (reportItem.ItemType == "LineModel") {
                    var lineControl = this._renderLineControl(reportItem, null, printMode, printPageId);
                    $reportItemsContainer.append(lineControl);
                }
                else if (reportItem.ItemType == "ImageModel") {
                    this._renderImageControl(reportItem, false, $reportItemsContainer, null, printMode, printPageId);
                }
                else if (reportItem.ItemType == "TablixModel") {
                    this._renderTablixControl(reportItem, false, {}, $reportItemsContainer, null, printMode, printPageId);
                }
                else if (reportItem.ItemType == "GaugeModel") {
                    this._renderGaugeControl(reportItem, false, false, {}, $reportItemsContainer, null, printMode, printPageId);
                }
                else if (reportItem.ItemType == "RectangleModel") {
                    this._renderRectangleControl(reportItem, false, $reportItemsContainer, null, printMode, printPageId);
                }
                else if (reportItem.ItemType == "ChartModel") {
                    this._renderChartControl(reportItem, false, false, {}, $reportItemsContainer, null, printMode, printPageId);
                }
                else if (reportItem.ItemType == "MapModel") {
                    this._renderMapControl(reportItem, false, $reportItemsContainer, null, printMode, printPageId);
                }
                else if (reportItem.ItemType == "SubReportModel") {
                    this._renderSubReportControl(reportItem, false, $reportItemsContainer, null, printMode, printPageId);
                }
            }
        },
        //-------------------- Apply Page Style and Actions [End] -------------------------//

        //-------------------- Render the Page ReportItems [start] -------------------------//
        _controlKeyGenerator: function (currentKey, parentId, printMode, printPageId) {
            var objId = !ej.isNullOrUndefined(parentId) ? '^' + parentId : '';
            if (printMode) {
                objId = objId.length == 0 ? '^' + printPageId : objId + '_' + printPageId;
            }
            return currentKey + objId;
        },

        _applyBorderStyle: function (border, tag) {
            if (border.Default) {
                tag.css("border-width", border.Default.Thickness + 'px');
                tag.css("border-color", border.Default.BorderBrush);
                tag.css("border-style", border.Default.BorderStyle);
            }

            if (border.LeftBorder) {
                tag.css("border-left-width", border.LeftBorder.Thickness + 'px');
                tag.css("border-left-color", border.LeftBorder.BorderBrush);
                tag.css("border-left-style", border.LeftBorder.BorderStyle);
            }

            if (border.RightBorder) {
                tag.css("border-right-width", border.RightBorder.Thickness + 'px');
                tag.css("border-right-color", border.RightBorder.BorderBrush);
                tag.css("border-right-style", border.RightBorder.BorderStyle);
            }

            if (border.TopBorder) {
                tag.css("border-top-width", border.TopBorder.Thickness + 'px');
                tag.css("border-top-color", border.TopBorder.BorderBrush);
                tag.css("border-top-style", border.TopBorder.BorderStyle);
            }

            if (border.BottomBorder) {
                tag.css("border-bottom-width", border.BottomBorder.Thickness + 'px');
                tag.css("border-bottom-color", border.BottomBorder.BorderBrush);
                tag.css("border-bottom-style", border.BottomBorder.BorderStyle);
            }
        },

        _applyTextStyle: function (textboxModel, tag, textbox, tabcolWidth, tabcolHeight) {
            var paddingTop = 0, paddingRight = 0, paddingBottom = 0, paddingLeft = 0;
            var topBorder = 0, rightBorder = 0, bottomBorder = 0, leftBorder = 0;
            if (textboxModel.Padding) {
                if (textboxModel.Padding.Top) {
                    tag.css("padding-top", textboxModel.Padding.Top);
                    paddingTop = textboxModel.Padding.Top;
                }

                if (textboxModel.Padding.Right) {
                    tag.css("padding-right", textboxModel.Padding.Right);
                    paddingRight = textboxModel.Padding.Right;
                }

                if (textboxModel.Padding.Bottom) {
                    tag.css("padding-bottom", textboxModel.Padding.Bottom);
                    paddingBottom = textboxModel.Padding.Bottom;
                }

                if (textboxModel.Padding.Left) {
                    tag.css("padding-left", textboxModel.Padding.Left);
                    paddingLeft = textboxModel.Padding.Left;
                }
            }

            if (textboxModel.TextBoxBackgroundColor) {
                tag.css("backgroundColor", textboxModel.TextBoxBackgroundColor);
            }

            if (textboxModel.VerticalAlign && textboxModel.VerticalAlign != 'Default') {
                tag.css("vertical-align", textboxModel.VerticalAlign);
            }

            if (textboxModel.Border) {
                if (textboxModel.Border.Default) {
                    tag.css({ "border-width": textboxModel.Border.Default.Thickness + 'px', "border-color": textboxModel.Border.Default.BorderBrush, "border-style": textboxModel.Border.Default.BorderStyle });
                    topBorder = rightBorder = bottomBorder = leftBorder = textboxModel.Border.Default.Thickness;
                }

                if (textboxModel.Border.LeftBorder) {
                    tag.css({ "border-left-width": textboxModel.Border.LeftBorder.Thickness + 'px', "border-left-color": textboxModel.Border.LeftBorder.BorderBrush, "border-left-style": textboxModel.Border.LeftBorder.BorderStyle });
                    leftBorder = textboxModel.Border.LeftBorder.Thickness;
                }

                if (textboxModel.Border.RightBorder) {
                    tag.css({ "border-right-width": textboxModel.Border.RightBorder.Thickness + 'px', "border-right-color": textboxModel.Border.RightBorder.BorderBrush, "border-right-style": textboxModel.Border.RightBorder.BorderStyle });
                    rightBorder = textboxModel.Border.RightBorder.Thickness;
                }

                if (textboxModel.Border.TopBorder) {
                    tag.css({ "border-top-width": textboxModel.Border.TopBorder.Thickness + 'px', "border-top-color": textboxModel.Border.TopBorder.BorderBrush, "border-top-style": textboxModel.Border.TopBorder.BorderStyle });
                    topBorder = textboxModel.Border.TopBorder.Thickness;
                }

                if (textboxModel.Border.BottomBorder) {
                    tag.css({ "border-bottom-width": textboxModel.Border.BottomBorder.Thickness + 'px', "border-bottom-color": textboxModel.Border.BottomBorder.BorderBrush, "border-bottom-style": textboxModel.Border.BottomBorder.BorderStyle });
                    bottomBorder = textboxModel.Border.BottomBorder.Thickness;
                }
            }

            var tagName = tag.get(0).tagName;
            if (tagName.toLowerCase() == 'td') {

                var padwidthadjust = parseFloat(paddingLeft, 10) + parseFloat(paddingRight, 10);
                var padheightadjust = parseFloat(paddingTop, 10) + parseFloat(paddingBottom, 10);

                var borderwidthadjust = parseFloat(leftBorder, 10) + parseFloat(rightBorder, 10);
                var borderheightadjust = parseFloat(topBorder, 10) + parseFloat(bottomBorder, 10);

                var adjusWidth = (parseFloat(tabcolWidth, 10) - (padwidthadjust + borderwidthadjust));
                var adjusHeight = (parseFloat(textboxModel.CanGrow ? textboxModel.Height : tabcolHeight, 10) - (padheightadjust + borderheightadjust));

                tag.css('width', adjusWidth + 'px');
                tag.css('height', adjusHeight + 'px');
                if (!textboxModel.ToggleInfo) {
                    var childrens = $(textbox).children();
                    for (var i = 0; i < childrens.length; i++) {
                        var _child = $(childrens[i]);
                        if (!_child.hasClass('e-reportviewer-usersort')) {
                            _child.width(adjusWidth);
                        }
                    }
                    $(textbox).height(adjusHeight);
                }
            }
        },

        //-------------------- Render the Tablix ReportItem [start] -------------------------//
        _renderTablixControl: function (tablixmodel, isTablixCell, cellSize, renderarea, parentId, printMode, printPageId) {
            var proxy = this;
            var _height = tablixmodel.Height;
            var _width = tablixmodel.Width;
            var ctrlId = proxy._controlKeyGenerator(proxy._id + '_' + tablixmodel.Name, parentId, printMode, printPageId);
            var tablixDiv = ej.buildTag("div", "", {}, { 'id': ctrlId, title: tablixmodel.Tooltip });
            var _tablixDivCss = {};
            renderarea.append(tablixDiv);
            _tablixDivCss["top"] = tablixmodel.Top;
            _tablixDivCss["left"] = tablixmodel.Left;

            if (isTablixCell) {
                _height = cellSize.height;
                var borderwidthadjust = parseFloat(tablixDiv.css("border-left-width"), 10) + parseFloat(tablixDiv.css("border-right-width"), 10);
                var borderheightadjust = parseFloat(tablixDiv.css("border-top-width"), 10) + parseFloat(tablixDiv.css("border-bottom-width"), 10);
                _width = (_width - (borderwidthadjust));
                _height = (_height - (borderheightadjust));
                _tablixDivCss["position"] = 'relative';
            } else {
                _tablixDivCss["position"] = 'absolute';
            }

            _tablixDivCss["width"] = _width;
            _tablixDivCss["height"] = _height;

            var tablixtable = ej.buildTag("table", "", { 'border-collapse': 'collapse', 'font-size': '8pt' }, { 'cellspacing': '0', 'cellpadding': '0' });
            var _tablixtableCss = {};
            tablixDiv.append(tablixtable);

            if (tablixmodel.BackgroundColor) {
                _tablixtableCss["background-color"] = tablixmodel.BackgroundColor;
            }

            if (tablixmodel.StyleVal) {
                if (tablixmodel.StyleVal.Font) {
                    if (tablixmodel.StyleVal.Font.FontFamily) {
                        _tablixtableCss["font-family"] = tablixmodel.StyleVal.Font.FontFamily;
                    }

                    if (tablixmodel.StyleVal.Font.FontSize) {
                        _tablixtableCss["font-size"] = tablixmodel.StyleVal.Font.FontSize;
                    }

                    if (tablixmodel.StyleVal.Font.FontStyle) {
                        _tablixtableCss["font-style"] = tablixmodel.StyleVal.Font.FontStyle;
                    }

                    if (tablixmodel.StyleVal.Font.FontWeight) {
                        _tablixtableCss["font-weight"] = tablixmodel.StyleVal.Font.FontWeight + ' !important';
                    }
                }

                _tablixtableCss["color"] = tablixmodel.StyleVal.TextColor ? tablixmodel.StyleVal.TextColor : 'black';

                if (tablixmodel.StyleVal.TextDecoration) {
                    _tablixtableCss["text-decoration"] = tablixmodel.StyleVal.TextDecoration;
                }
            }

            if (tablixmodel.Padding) {
                if (tablixmodel.Padding.Left) {
                    _tablixtableCss["padding-left"] = tablixmodel.Padding.Left;
                }

                if (tablixmodel.Padding.Right) {
                    _tablixtableCss["padding-right"] = tablixmodel.Padding.Right;
                }

                if (tablixmodel.Padding.Top) {
                    _tablixtableCss["padding-top"] = tablixmodel.Padding.Top;
                }

                if (tablixmodel.Padding.Bottom) {
                    _tablixtableCss["padding-bottom"] = tablixmodel.Padding.Bottom;
                }
            }

            //if (tablixmodel.LineHeight) {
            //    tablixtable.css("line-height", tablixmodel.LineHeight);
            //}

            if (tablixmodel.TextAlign) {
                _tablixtableCss["text-align"] = tablixmodel.TextAlign;
            }

            if (tablixmodel.VerticalAlign) {
                _tablixtableCss["vertical-align"] = tablixmodel.VerticalAlign;
            }

            var resourceName = printMode ? 'PrintImage' : 'GetResource';
            if (tablixmodel.BackgroundImageSrc) {
                _tablixtableCss["background-image"] = "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + tablixmodel.BackgroundImageSrc + '&resourcetype=sfimg&isPrint=' + printMode + ")";
            }

            if (tablixmodel.Border) {
                var _topBorder = tablixmodel.Border.TopBorder;
                tablixmodel.Border.TopBorder = null;
                this._applyBorderStyle(tablixmodel.Border, tablixtable);
                if (_topBorder) {
                    _tablixDivCss["border-top-width"] = _topBorder.Thickness + 'px';
                    _tablixDivCss["border-top-color"] = _topBorder.BorderBrush;
                    _tablixDivCss["border-top-style"] = _topBorder.BorderStyle;
                }
                tablixmodel.Border.TopBorder = _topBorder;
            }
            tablixtable.css(_tablixtableCss);
            tablixDiv.css(_tablixDivCss);

            if (tablixmodel.CellModels && tablixmodel.CellModels.length > 0) {
                var emptyRow = ej.buildTag("tr", "", { 'padding': '0px', 'margin': '0px', 'height': '0px', 'visibility': 'collapse' }, {});

                if (tablixmodel.Border && ((tablixmodel.Border.TopBorder && tablixmodel.Border.TopBorder.BorderStyle != "None") || (tablixmodel.Border.Default && tablixmodel.Border.Default.BorderStyle != "None"))) {
                    emptyRow.css('visibility', 'visible');
                }

                tablixtable.append(emptyRow);
                var colindex;
                var headerEmptyRow = null;
                var headerTableRow = null;
                for (colindex = 0; colindex < tablixmodel.CellModels[0].length; colindex++) {
                    var emptyCol = ej.buildTag("td", "", { 'padding': '0px', 'margin': '0px', 'width': tablixmodel.ColWidths[colindex] + 'px' }, { 'rowSpan': '1', 'colSpan': '1' });
                    emptyRow.append(emptyCol);
                }

                for (var rowindex = 0; rowindex < tablixmodel.CellModels.length; rowindex++) {
                    var tableRow = ej.buildTag("tr", "", { 'padding': '0px', 'margin': '0px', 'text-align': 'left', 'height': tablixmodel.RowHeights[rowindex] + 'px' }, { 'vAlign': 'top' });
                    tablixtable.append(tableRow);
                    var row = tablixmodel.CellModels[rowindex];
                    for (colindex = 0; colindex < row.length; colindex++) {
                        var tableCol = ej.buildTag("td", "", { 'padding': '0px', 'margin': '0px', 'text-align': 'left', 'height': '100%' }, { 'rowSpan': '1', 'colSpan': '1' });
                        tableRow.append(tableCol);
                        var cell = row[colindex].ItemModel;

                        if (cell) {
                            var border = row[colindex].Border;
                            var rowSpan = row[colindex].RowSpan;
                            var colSpan = row[colindex].ColSpan;

                            if (!cell.Hidden)
                            {
                                if (border) {
                                    proxy._applyBorderStyle(border, tableCol);
                                }

                                if (cell.ItemType == "TextBoxModel") {
                                    var textboxControl = proxy._renderTextBoxControl(cell, true, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                    textboxControl.css('max-height', '99.9% !important');
                                    tableCol.css('height', tablixmodel.RowHeights[rowindex] + 'px');
                                    proxy._applyTextStyle(cell, tableCol, textboxControl, tablixmodel.ColWidths[colindex], tablixmodel.RowHeights[rowindex]);
                                    tableCol.append(textboxControl);
                                } else if (cell.ItemType == "LineModel") {
                                    var lineControl = proxy._renderLineControl(cell, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                    lineControl.css("position", "relative");
                                    tableCol.append(lineControl);
                                } else if (cell.ItemType == "ImageModel") {
                                    proxy._renderImageControl(cell, true, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                } else if (cell.ItemType == "TablixModel") {
                                    proxy._renderTablixControl(cell, true, { height: tablixmodel.RowHeights[rowindex] }, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                } else if (cell.ItemType == "GaugeModel") {
                                    proxy._renderGaugeControl(cell, false, true, { height: tablixmodel.RowHeights[rowindex] }, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                } else if (cell.ItemType == "RectangleModel") {
                                    proxy._renderRectangleControl(cell, true, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                } else if (cell.ItemType == "ChartModel") {
                                    this._renderChartControl(cell, false, true, { height: tablixmodel.RowHeights[rowindex] }, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                } else if (cell.ItemType == "MapModel") {
                                    this._renderMapControl(cell, false, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                } else if (cell.ItemType == "SubReportModel") {
                                    proxy._renderSubReportControl(cell, true, tableCol, ctrlId + 'tablixRow' + rowindex + 'xCol' + colindex, printMode, printPageId);
                                }
                            }

                            if (rowSpan > 1) {
                                tableCol.attr("rowspan", rowSpan);
                            }

                            if (colSpan > 1) {
                                tableCol.attr("colspan", colSpan);
                            }
                        } else {
                            tableCol.css('display', 'none');
                        }
                    }

                    if (row[0].FixedData) {
                        if (headerEmptyRow == null && headerTableRow == null) {
                            var tablixheaderDiv = ej.buildTag("div", "", { 'top': tablixmodel.Top, 'left': tablixmodel.Left, 'position': 'absolute' }, { 'id': ctrlId + '_headertable' });
                            tablixDiv.addClass('fixed-data');
                            renderarea.append(tablixheaderDiv);
                            var tabixheadertable = ej.buildTag("table", "", { 'border-collapse': 'collapse', 'font-size': '8pt' }, { 'cellspacing': '0', 'cellpadding': '0' });
                            tablixheaderDiv.append(tabixheadertable);
                        }

                        headerEmptyRow = $(emptyRow).clone();
                        headerTableRow = $(tableRow).clone(true);
                        tabixheadertable.append(headerEmptyRow);
                        tabixheadertable.append(headerTableRow);
                    }
                }
            }
        },
        //-------------------- Render the Tablix ReportItem [end] -------------------------//
        _renderTextBoxControl: function (textboxModel, isTablixCell, parentId, printMode, printPageId) {
            var ctrlId = this._controlKeyGenerator(this._id + '_' + textboxModel.Name, parentId, printMode, printPageId);

            var textboxDiv = ej.buildTag("div", "", {}, { 'id': ctrlId, title: textboxModel.ToolTip });
            var _textboxCss = {};
            if (!isTablixCell) {
                _textboxCss["position"] = 'absolute';
                _textboxCss["top"] = textboxModel.Top;
                _textboxCss["left"] = textboxModel.Left;
                _textboxCss["width"] = textboxModel.Width;
                _textboxCss["height"] = textboxModel.Height;
                this._applyTextStyle(textboxModel, textboxDiv, null, null, null);
            } else if (isTablixCell) {
                _textboxCss["word-wrap"] = 'break-word';
                _textboxCss["white-space"] = 'pre-wrap';
            }

            if (!textboxModel.CanGrow) {
                _textboxCss["overflow"] = 'hidden';
            }

            var resourceName = printMode ? 'PrintImage' : 'GetResource';
            if (textboxModel.BackgroundSrc) {
                _textboxCss["background-image"] = "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + textboxModel.BackgroundSrc + '&resourcetype=sfimg&isPrint=' + printMode + ")";
            }

            if (textboxModel.ToggleInfo && !this._printMode) {
                var cssToggleName = textboxModel.IsToggle ? 'e-reportviewer-collapsetoggle' : 'e-reportviewer-expandtoggle';
                var toogleiconDiv = ej.buildTag('div.' + cssToggleName + ' txtToggle_' + this._id, '', { 'display': 'block', 'width': '14px', 'height': '14px', 'margin-Top': '1px' }, {});
                var _objToogleDivCss = {};
                if (this._browserInfo.name == 'msie') {
                    _objToogleDivCss["margin-right"] = '1px';
                    _objToogleDivCss["float"] = 'left';
                } else if (this._browserInfo.name == 'opera' || this._browserInfo.name == 'webkit' || this._browserInfo.name == 'chrome' || this._browserInfo.name == 'mozilla' || this._browserInfo.name == 'edge') {
                    _objToogleDivCss["display"] = 'table';
                    _objToogleDivCss["margin-right"] = '2px';
                    _objToogleDivCss["float"] = 'left';
                }

                toogleiconDiv.data('drillObj', textboxModel.ToggleInfo);
                toogleiconDiv.css(_objToogleDivCss);
                textboxDiv.append(toogleiconDiv);
                _textboxCss["display"] = this._browserInfo.name == 'msie' ? 'inline-block' : 'flex';
                _textboxCss["word-wrap"] = 'inherit';
                _textboxCss["white-space"] = 'inherit';
            }

            if (textboxModel.WritingMode != "Default" && textboxModel.WritingMode == "Vertical") {
                    if (this._browserInfo.name == 'msie') {
                        _textboxCss["writing-mode"] = 'tb-rl';
                    } else {
                        _textboxCss["transform"] = 'rotate(90deg)';
                    }
            }

            if (textboxModel.ActionInfo) {
                textboxDiv.data('actionObj', textboxModel.ActionInfo);
                textboxDiv.addClass('drillAction_' + this._id + ' e-reportviewer-drillhover');
            }

            if (textboxModel.Paragraphval) {
                for (var indexi = 0; indexi < textboxModel.Paragraphval.length; indexi++) {
                    var $textboxParaDiv = ej.buildTag("div.e-reportviewer-paragrap", "", {});
                    var _objParaDivCss = {};
                    var paragraph = textboxModel.Paragraphval[indexi];
                    for (var indexj = 0; indexj < paragraph.Runs.length; indexj++) {
                        var run = paragraph.Runs[indexj];
                        var $textboxSpanDiv = ej.buildTag("span", "", {});
                        var _objSpanDivCss = {};

                        _objSpanDivCss["white-space"] = (textboxModel.ToggleInfo && !printMode) ? 'inherit' : 'pre-wrap';

                        //if (paragraph.HangingIndent && paragraph.HangingIndent != 0) {
                        //    $textboxSpanDiv.css("text-indent", paragraph.HangingIndent)
                        //}

                        if (run.ActionInfo) {
                            $textboxSpanDiv.data('actionObj', run.ActionInfo);
                            $textboxSpanDiv.addClass('drillAction_' + this._id + ' e-reportviewer-drillhover');
                        }

                        if (run.Style.Font.FontFamily) {
                            _objSpanDivCss["font-family"] = run.Style.Font.FontFamily;
                        }

                        if (run.Style.Font.FontSize) {
                            _objSpanDivCss["font-size"] = run.Style.Font.FontSize;
                        }

                        if (run.Style.Font.FontStyle) {
                            _objSpanDivCss["font-style"] = run.Style.Font.FontStyle;
                        }

                        if (run.Style.Font.FontWeight) {
                            _objSpanDivCss["font-weight"] = run.Style.Font.FontWeight;
                        }

                        if (run.Style.TextColor) {
                            _objSpanDivCss["color"] = run.Style.TextColor;
                        } else {
                            _objSpanDivCss["color"] = 'black';
                        }

                        if (run.Style.TextDecoration) {
                            _objSpanDivCss["text-decoration"] = run.Style.TextDecoration;
                        }

                        if (run.RunText) {
                            run.IsHtmlText ? $textboxSpanDiv.append(run.RunText) : $textboxSpanDiv.text(run.RunText).text();
                        }

                        if (run.IsHtmlText && run.RunText != null && (run.RunText.indexOf("<p>") > -1)) {
                            $textboxSpanDiv.find("p:first").css("padding-top", "12px");
                            $textboxSpanDiv.find("p").css({ "padding-bottom": "12px", "margin": "0px" });
                        }

                        if (this._browserInfo.name == 'mozilla' && run.Style != null && run.Style.Font != null && run.Style.Font.FontSize != null) {
                            _objSpanDivCss["line-height"] = run.Style.Font.FontSize * 1.17 + "px";
                        }

                        $textboxSpanDiv.css(_objSpanDivCss);
                        $textboxParaDiv.append($textboxSpanDiv);
                    }

                    if (!isTablixCell) {
                        _objParaDivCss["word-wrap"] = 'break-word';
                    }

                    if (paragraph.TextAlignment) {
                        _objParaDivCss["text-align"] = paragraph.TextAlignment;
                    }

                    if (textboxModel.Direction != "Default") {
                        if (textboxModel.Direction != "LTR") {
                            _objParaDivCss["text-align"] = 'right';
                        }
                    }

                    if (textboxModel.VerticalAlign != "Default" && textboxModel.CanGrow) {
                        _objParaDivCss["vertical-align"] = textboxModel.VerticalAlign;
                    }

                    //if (!isTablixCell || textboxModel.IsNoRowMessage) {
                    //    _textboxCss["display"] = 'table';
                    //    _objParaDivCss["display"] = 'table-cell';
                    //}

                    if (paragraph.LeftIndent) {
                        _objParaDivCss["padding-left"] = paragraph.LeftIndent;
                    }

                    if (paragraph.RightIndent) {
                        if (paragraph.TextAlignment == "Right") {
                            _objParaDivCss["padding-right"] = paragraph.RightIndent;
                            _objParaDivCss["float"] = 'right';
                        }
                        else {
                            _objParaDivCss["padding-right"] = paragraph.RightIndent;
                        }
                    }

                    if (paragraph.SpaceBefore) {
                        _objParaDivCss["padding-top"] = paragraph.SpaceBefore;
                    }

                    if (paragraph.SpaceAfter) {
                        _objParaDivCss["padding-bottom"] = paragraph.SpaceAfter;
                    }

                    if (paragraph.LineHeight) {
                        _objParaDivCss["line-height"] = paragraph.LineHeight + 'px';
                    }

                    if (paragraph.ListStyle) {
                        _objParaDivCss["list-style-type"] = paragraph.ListStyle;
                    }

                    if (paragraph.HangingIndent) {
                        _objParaDivCss["text-indent"] = paragraph.HangingIndent;
                    }

                    if (isTablixCell) {
                        _objParaDivCss["min-width"] = '99.9%';
                    }

                    if (paragraph.ListLevel && paragraph.ListLevel != 0 && textboxModel.Direction != "RTL") {
                        _objParaDivCss["margin-left"] = paragraph.ListLevel * '30';
                    }
                    else if (paragraph.ListLevel != 0 && textboxModel.Direction == "RTL") {
                        _objParaDivCss["margin-Right"] = paragraph.ListLevel * '30';
                        _objParaDivCss["direction"] = 'rtl';
                    }

                    if (paragraph.ListStyle == "Numbered" && paragraph.ListLevel >= 1) {
                        if (paragraph.ListLevel == 1 || paragraph.ListLevel == 4 || paragraph.ListLevel == 7) {
                            _objParaDivCss["display"] = 'list-item';
                            _objParaDivCss["list-style-type"] = 'decimal';
                        }
                        else if (paragraph.ListLevel == 2 || paragraph.ListLevel == 5 || paragraph.ListLevel == 8) {
                            _objParaDivCss["display"] = 'list-item';
                            _objParaDivCss["list-style-type"] = 'lower-roman';
                        }
                        else if (paragraph.ListLevel == 3 || paragraph.ListLevel == 6 || paragraph.ListLevel == 9) {
                            _objParaDivCss["display"] = 'list-item';
                            _objParaDivCss["list-style-type"] = 'lower-alpha';
                        }
                    }
                    else if (paragraph.ListStyle == "Bulleted" && paragraph.ListLevel >= 1) {
                        _objParaDivCss["display"] = 'list-item';
                        _objParaDivCss["list-style-type"] = paragraph.ListStyle;
                    }
                    $textboxParaDiv.css(_objParaDivCss);
                    textboxDiv.append($textboxParaDiv);
                }
            }

            if (textboxModel.Sorting) {
                var _sortingType = "sortingUpDown";
                if (textboxModel.Sorting.Sorting == 'UpDown') {
                    _sortingType = "sortingUpDown";
                } else if (textboxModel.Sorting.Sorting == 'Up') {
                    _sortingType = "sortingUp";
                } else {
                    _sortingType = "sortingDown";
                }
                var sortingiconDiv = ej.buildTag('div.e-reportviewer-' + _sortingType + ' txtSorting_' + this._id + ' e-reportviewer-usersort', '', { 'display': 'block', 'width': '14px', 'height': '14px', 'padding-right': '1px', 'margin-Top': '1px', 'float': 'right', 'vertical-align': 'middle', 'position': 'absolute', 'left': (textboxModel.Width - 14) < 0 ? '80%' : ((textboxModel.Width - 14)+ 'px'), 'top': '10%' }, {});
                sortingiconDiv.data('sortingObj', textboxModel.Sorting);
                textboxDiv.append(sortingiconDiv);
                _textboxCss["position"] = "relative";
            }
            textboxDiv.css(_textboxCss);
            return textboxDiv;
        },

        //-------------------- Render the Chart ReportItem [start] -------------------------//
        _renderChartControl: function (chartModel, webExport, isTablixCell, cellSize, parentObj, parentId, printMode, printPageId) {
            if (chartModel.ChartAreas) {
                var _height = chartModel.Height;
                var _width = chartModel.Width;
                var _parentID = 'chartCtrl';
                if (webExport) {
                    this._id = parentId;
                    chartModel.Top = 0;
                    chartModel.Left = 0;
                }
                var ctrlId = this._controlKeyGenerator(this._id + '_' + chartModel.Name, parentId, printMode, printPageId);
                var chartDiv = ej.buildTag("div", "", {}, { 'id': ctrlId, 'title': chartModel.ToolTip });
                parentObj.append(chartDiv);
                chartDiv.css("position", "absolute");

                if (chartModel.ChartStyle) {
                    if (chartModel.ChartStyle.Border) {
                        this._applyBorderStyle(chartModel.ChartStyle.Border, chartDiv);
                    }

                    if (chartModel.ChartStyle.FillStyle) {
                        chartDiv.css('background-color', chartModel.ChartStyle.FillStyle.BackgroundColor);
                        this._applyBackgroundGradientStyle(chartModel.ChartStyle.FillStyle, chartDiv);
                    }
                    var resourceName = printMode ? 'PrintImage' : 'GetResource';
                    if (chartModel.BackgroundImge) {
                        chartDiv.css({ 'background-image': 'url(' + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + chartModel.BackgroundImge + '&resourcetype=sfimg&isPrint=' + printMode + ')', 'background-size': '100% 100%' });
                    }
                }

                if (isTablixCell) {
                    _parentID = parentId;
                    _height = cellSize.height;
                    var borderwidthadjust = parseFloat(chartDiv.css("border-left-width"), 10) + parseFloat(chartDiv.css("border-right-width"), 10);
                    var borderheightadjust = parseFloat(chartDiv.css("border-top-width"), 10) + parseFloat(chartDiv.css("border-bottom-width"), 10);
                    _width = (_width - (borderwidthadjust));
                    _height = (_height - (borderheightadjust));
                    chartDiv.css("position", "relative");
                }

                var chartAreaHeight = ((_height) / (chartModel.ChartAreas.length));

                if (chartModel.Top) {
                    chartDiv.css("top", chartModel.Top);
                }

                if (chartModel.Left) {
                    chartDiv.css("left", chartModel.Left);
                }

                if (_width) {
                    chartDiv.css("width", _width);
                }

                if (_height) {
                    chartDiv.css("height", _height);
                }

                for (var areaIndex = 0; areaIndex < chartModel.ChartAreas.length; areaIndex++) {
                    var chartArea = chartModel.ChartAreas[areaIndex];
                    var chartChildDiv = null;
                    if (printMode) {
                        chartChildDiv = ej.buildTag("div", "", {}, { 'id': _parentID + '_' + this._id + '_' + chartModel.Name + '_' + chartArea.Name + '_' + printPageId, 'title': chartModel.ToolTip });
                    } else {
                        chartChildDiv = ej.buildTag("div", "", {}, { 'id': _parentID + '_' + this._id + '_' + chartModel.Name + '_' + chartArea.Name, 'title': chartModel.ToolTip });
                    }

                    chartDiv.append(chartChildDiv);
                    chartChildDiv.css("height", chartAreaHeight);
                    //chartChildDiv.css("margin", "1px");
                    chartChildDiv.ejChart();
                    var ejChartCtrl = chartChildDiv.data("ejChart");

                    var ejchartSeries = ejChartCtrl.model.series[0];
                    ejChartCtrl.model.series.pop(ejchartSeries);
                    ejChartCtrl.model.chartClick = this._onReporClick;
                    //ejChartCtrl.model.displayTextRendering = this._chartAreaDisplayText;

                    if (chartArea.Style) {
                        if (chartArea.Style.FillStyle && chartArea.Style.FillStyle.BackgroundColor != "#00ffffff") {
                            ejChartCtrl.model.chartArea.background = chartArea.Style.FillStyle.BackgroundColor;
                        }

                        var resourceName = printMode ? 'PrintImage' : 'GetResource';
                        if (chartArea.BackgroundImg) {
                            ejChartCtrl.model.backGroundImageUrl = (this.model.reportServiceUrl + '/' + resourceName + '/?key=' + chartArea.BackgroundImg+ '&resourcetype=sfimg&isPrint=' + printMode);
                        }

                        if (chartArea.Style.Border && chartArea.Style.Border.Default) {
                            if (chartArea.Style.Border.Default.BorderBrush) {
                                ejChartCtrl.model.chartArea.border.color = chartArea.Style.Border.Default.BorderBrush;
                            }
                            if (chartArea.Style.Border.Default.BorderStyle == "Default" || chartArea.Style.Border.Default.BorderStyle == "None") {
                                ejChartCtrl.model.chartArea.border.width = 0;
                                ejChartCtrl.model.chartArea.border.opacity = 0;
                            }
                            else {
                                ejChartCtrl.model.chartArea.border.width = chartArea.Style.Border.Default.Thickness;
                            }
                        }
                        else {
                            ejChartCtrl.model.chartArea.border.opacity = 1;
                            ejChartCtrl.model.chartArea.border.color = "Transparent";
                        }
                    }

                    if (areaIndex == 0 && chartModel.ChartTiles.length > 0) {
                        var charttile = chartModel.ChartTiles[areaIndex];
                        if (charttile.Caption && charttile.Visible) {
                            ejChartCtrl.model.title.text = charttile.Caption;
                            if (charttile.Style) {
                                if (charttile.Style.Color) {
                                    ejChartCtrl.model.title.font.color = charttile.Style.Color;
                                }

                                if (charttile.Style.Font) {
                                    if (charttile.Style.Font.FontFamily) {
                                        ejChartCtrl.model.title.font.fontFamily = charttile.Style.Font.FontFamily;
                                    }

                                    if (charttile.Style.Font.FontStyle) {
                                        ejChartCtrl.model.title.font.fontStyle = charttile.Style.Font.FontStyle;
                                    }

                                    if (charttile.Style.Font.FontWeight) {
                                        ejChartCtrl.model.title.font.fontWeight = charttile.Style.Font.FontWeight;
                                    }

                                    if (charttile.Style.Font.FontSize != 0) {
                                        ejChartCtrl.model.title.font.size = charttile.Style.Font.FontSize + 'px';
                                    }
                                }
                            }
                        }
                    }

                    for (var seriesIndex = 0; seriesIndex < chartArea.ChartSeries.length; seriesIndex++) {
                        var chartseries = chartArea.ChartSeries[seriesIndex];
                        var seriesObj = $.extend(true, {}, ejchartSeries);
                        var seriesPoints = seriesObj.points[0];
                        seriesObj.points = [];
                        seriesObj.type = chartseries.Type;
                        seriesObj.name = (chartseries.Legend && chartseries.Legend.LegendText) ? chartseries.Legend.LegendText : chartseries.Label;
                        seriesObj.name = (seriesObj.name == "" && chartseries.Name == "EmptySeriesName") ? chartseries.Name : seriesObj.name;

                        if (chartseries.Type == "explodedpie") {
                            seriesObj.type = "pie";
                            seriesObj.explodeAll = true;
                            seriesObj.explodeOffset = 8;
                        }

                        else if (chartseries.Type == "explodeddoughnut") {
                            seriesObj.type = "doughnut";
                            seriesObj.explodeAll = true;
                            seriesObj.explodeOffset = 10;
                        }

                        if (chartseries.Type == "stackingcolumn") {
                            seriesObj.isStacking = true;
                        } else {
                            seriesObj.isStacking = false;
                        }

                        if (seriesObj.isStacking){
                            ejChartCtrl.model.legendBoundsCalculate = this._legendOrder;
                        }

                        var actionInfos = [];
                        for (var pointIndex = 0; pointIndex < chartseries.PointValues.length; pointIndex++) {
                            var pointObj = $.extend(true, {}, seriesPoints);
                            var point = chartseries.PointValues[pointIndex];
                            pointObj.YValues = [];
                            if (point.X) {
                                pointObj.X = pointObj.x = point.X;
                            } else {
                                pointObj.X = pointObj.x = 0;
                            }

                            if (point.Y) {
                                pointObj.Y = pointObj.y = point.Y;
                                pointObj.YValues.push(pointObj.Y);
                            } else {
                                pointObj.Y = pointObj.y = 0;
                                pointObj.YValues.push(pointObj.Y);
                            }

                            if (point.Low) {
                                pointObj.YValues.push(point.Low);
                            }

                            if (point.High) {
                                pointObj.YValues.push(point.High);
                            }

                            if (point.Start) {
                                pointObj.YValues.push(point.Start);
                            }

                            if (point.End) {
                                pointObj.YValues.push(point.End);
                            }

                            if (chartseries.Type == "bubble") {
                                pointObj.size = 0.5;
                            }

                            if (point.ChartDataLabel) {
                                pointObj.text = point.ChartDataLabel.Label;
                            }

                            if (point.ActionInfo) {
                                actionInfos.push(point.ActionInfo);
                            }

                            if (chartModel.ColorPalette == "Custom") {
                                ejChartCtrl.model.colors = [];
                                for (var paletteIndex = 0; paletteIndex < chartModel.CustomPaletteColors.length; paletteIndex++) {
                                    ejChartCtrl.model.colors[paletteIndex] = chartModel.CustomPaletteColors[paletteIndex];
                                }
                            }
                            else {
                                if (!chartseries.Type == "doughnut" || !chartseries.Type == "pie") {
                                    ejChartCtrl.model.colors = [];
                                }
                                else if (point.Style && point.Style.Color) {
                                    ejChartCtrl.model.colors[pointIndex] = point.Style.Color;
                                }
                            }

                            if (point.Style && point.Style.Color) {
                                pointObj.fill = point.Style.Color;
                                seriesObj.fill = point.Style.Color;
                            }

                            if (chartModel.CustomPaletteColors && (chartModel.ColorPalette) && chartModel.ColorPalette == "Custom") {
                                seriesObj.fill = chartModel.CustomPaletteColors[seriesIndex];
                            }
                            else if (point.Style != null && point.Style.Color == null) {
                                seriesObj.fill = ejChartCtrl.model.colors[seriesIndex];
                            }

                            seriesObj.points.push(pointObj);

                        }

                        if (actionInfos.length > 0) {
                            ejChartCtrl.model.pointRegionClick = this._drillThroughClick;
                            ejChartCtrl.ejreportid = this._id;
                            chartChildDiv.data(ejChartCtrl._id + 'actionObj_Series' + seriesIndex, actionInfos);
                            ejChartCtrl.model.pointRegionMouseMove = function chartSeriesMouseHover(event) {
                                if (ej.isNullOrUndefined($('#' + this._id).data(this._id + 'actionObj_Series' + event.data.region.SeriesIndex))) {
                                    return false;
                                }
                                $('#' + this._id + '_svg_Series' + event.data.region.SeriesIndex + '_Point' + event.data.region.Region.PointIndex).css("cursor", "pointer");
                            };
                        }

                        seriesObj.visibility = chartseries.Visibility ? 'visible' : 'hide';
                        seriesObj.tooltip.format = " x: #point.x#<br/>y: #point.y#";
                        seriesObj.tooltip.visible = true;
                        seriesObj.enableAnimation = false;

                        if (chartseries.Style && chartseries.Style.Border && chartseries.Style.Border.Default) {
                            if (chartseries.Style.Border.Default.BorderBrush) {
                                seriesObj.border.color = chartseries.Style.Border.Default.BorderBrush;
                            }

                            if (chartseries.Style.Border.Default.Thickness != 0) {
                                seriesObj.border.width = chartseries.Style.Border.Default.Thickness;
                            }

                            if (chartseries.Style.Border.Default.BorderStyle == "Dashed") {
                                seriesObj.border.dashArray = "2,4";
                            }
                            else if (chartseries.Style.Border.Default.BorderStyle == "Dotted") {
                                seriesObj.border.dashArray = "2,2";
                            }
                        }

                        if (chartseries.DataPointsStyle && chartseries.DataPointsStyle.length > 0) {
                            if (chartseries.Type == "scatter") {
                                var datapointStyle = chartseries.DataPointsStyle[0];

                                if (datapointStyle.ChartMarker && datapointStyle.ChartMarker.MarkerType) {
                                    seriesObj.marker.shape = datapointStyle.ChartMarker.MarkerType;
                                } else {
                                    seriesObj.marker.shape = "Circle";
                                }
                                if (datapointStyle.ChartMarker.Color) {
                                    seriesObj.marker.fill = datapointStyle.ChartMarker.Color;
                                }

                                if (datapointStyle.ChartMarker.BorderColor) {
                                    seriesObj.marker.border.color = datapointStyle.ChartMarker.BorderColor;
                                }

                                if (datapointStyle.ChartMarker.Borderwidth) {
                                    seriesObj.marker.border.width = datapointStyle.ChartMarker.Borderwidth == 0 ? 2 : datapointStyle.ChartMarker.Borderwidth;
                                }

                                if (datapointStyle.ChartMarker.Size) {
                                    seriesObj.marker.size.height = seriesObj.marker.size.width = parseInt((datapointStyle.ChartMarker.Size == 0 || datapointStyle.ChartMarker.Size < 6)) ? 6 : (datapointStyle.ChartMarker.Size);
                                } else {
                                    seriesObj.marker.size.height = seriesObj.marker.size.width = 10;
                                }
                                seriesObj.marker.visible = true;
                            } else {
                                var datapointStyle = chartseries.DataPointsStyle[0];
                                if (datapointStyle.ChartMarker) {
                                    if (datapointStyle.ChartMarker.MarkerType) {
                                        seriesObj.marker.shape = datapointStyle.ChartMarker.MarkerType;
                                    }

                                    if (datapointStyle.ChartMarker.Color) {
                                        seriesObj.marker.fill = datapointStyle.ChartMarker.Color;
                                    }

                                    if (datapointStyle.ChartMarker.BorderColor) {
                                        seriesObj.marker.border.color = datapointStyle.ChartMarker.BorderColor;
                                    }

                                    if (datapointStyle.ChartMarker.Borderwidth) {
                                        seriesObj.marker.border.width = datapointStyle.ChartMarker.Borderwidth == 0 ? 2 : datapointStyle.ChartMarker.Borderwidth;
                                    }

                                    if (datapointStyle.ChartMarker.Size) {
                                        seriesObj.marker.size.height = seriesObj.marker.size.width = parseInt((datapointStyle.ChartMarker.Size == 0 || datapointStyle.ChartMarker.Size < 6)) ? 6 : (datapointStyle.ChartMarker.Size);
                                    }
                                }

                                if (chartseries.Visibility && datapointStyle.ChartMarker && datapointStyle.ChartMarker.MarkerType) {
                                    seriesObj.marker.visible = true;
                                }
                                else {
                                    seriesObj.marker.visible = false;
                                }

                                if (chartseries.PointValues.length > 0 && chartseries.PointValues[0].ChartDataLabel) {
                                    seriesObj.marker.dataLabel.visible = false;
                                    var pointDatalbl = chartseries.PointValues[0].ChartDataLabel;
                                    seriesObj.marker.dataLabel.visible = pointDatalbl.Visible;
                                    if (pointDatalbl.Visible) {
                                        seriesObj.marker.dataLabel.connectorLine.type = "line";
                                        seriesObj.marker.dataLabel.connectorLine.width = 0.5;
                                        if (seriesObj.isStacking) {
                                            seriesObj.marker.dataLabel.textPosition = (pointDatalbl.Position && pointDatalbl.Position == "Default") ? "middle" : pointDatalbl.Position;
                                        }
                                        else {
                                            seriesObj.marker.dataLabel.textPosition = (pointDatalbl.Position && pointDatalbl.Position == "Default") ? "top" : pointDatalbl.Position;
                                        }

                                        seriesObj.marker.dataLabel.font.color = !pointDatalbl.TextColor ? "Black" : pointDatalbl.TextColor;
                                        if(pointDatalbl.Font){
                                            seriesObj.marker.dataLabel.font.fontFamily = pointDatalbl.Font.FontFamily;
                                            seriesObj.marker.dataLabel.font.fontStyle = pointDatalbl.Font.FontStyle;
                                            seriesObj.marker.dataLabel.font.fontWeight = pointDatalbl.Font.FontWeight;
                                            seriesObj.marker.dataLabel.font.size = pointDatalbl.Font.FontSize + "px";
                                        }
                                        if (pointDatalbl.BorderStyle && pointDatalbl.BorderStyle != "None") {
                                            seriesObj.marker.dataLabel.border.color = pointDatalbl.BorderColor;
                                            seriesObj.marker.dataLabel.border.width = pointDatalbl.BorderWidth;
                                            seriesObj.marker.dataLabel.shape = "Rectangle";
                                        }
                                        if (pointDatalbl.BackGroundColor && pointDatalbl.BackGroundColor != "Transparent") {
                                            seriesObj.marker.dataLabel.fill = pointDatalbl.BackGroundColor;
                                            seriesObj.marker.dataLabel.shape = "Rectangle";
                                        }
                                    }
                                }
                            }
                        }
                        ejChartCtrl.model.series.push(seriesObj);
                    }

                    if (chartModel.ChartLegends && chartModel.ChartLegends.length > 0) {
                        var chartLegend = chartModel.ChartLegends[0];
                        ejChartCtrl.model.legend.visible = chartLegend.Visibilty;

                        if (chartLegend.Alignment) {
                            ejChartCtrl.model.legend.alignment = chartLegend.Alignment;
                        }

                        if (chartLegend.Position) {
                            ejChartCtrl.model.legend.position = chartLegend.Position;
                        }

                        if (chartLegend.Style) {
                            if (chartLegend.Style.Color) {
                                ejChartCtrl.model.legend.font.color = chartLegend.Style.Color;
                            }

                            if (chartLegend.Style.Font) {
                                if (chartLegend.Style.Font.FontFamily) {
                                    ejChartCtrl.model.legend.font.fontFamily = chartLegend.Style.Font.FontFamily;
                                }

                                if (chartLegend.Style.Font.FontStyle) {
                                    ejChartCtrl.model.legend.font.fontStyle = chartLegend.Style.Font.FontStyle;
                                }

                                if (chartLegend.Style.Font.FontWeight) {
                                    ejChartCtrl.model.legend.font.fontWeight = chartLegend.Style.Font.FontWeight;
                                }

                                if (chartLegend.Style.Font.FontSize != 0) {
                                    ejChartCtrl.model.legend.font.size = chartLegend.Style.Font.FontSize + 'px';
                                }
                            }

                            if (chartLegend.Style.Border && chartLegend.Style.Border.Default) {
                                if (chartLegend.Style.Border.Default.BorderBrush) {
                                    ejChartCtrl.model.legend.border.color = chartLegend.Style.Border.Default.BorderStyle == "Default" ? "transparent" : chartLegend.Style.Border.Default.BorderBrush;
                                }

                                if (chartLegend.Style.Border.Default.Thickness != 0) {
                                    ejChartCtrl.model.legend.border.width = chartLegend.Style.Border.Default.Thickness;
                                }
                            }
                        }
                    }
                    else {
                        ejChartCtrl.model.legend.visible = false;
                    }

                    if (ejChartCtrl.model.series.length > 0 && ejChartCtrl.model.series[0].type != 'polar' && ejChartCtrl.model.series[0].type != 'radar') {
                        for (var chartAreaXaxisIndex = 0; chartAreaXaxisIndex < chartArea.ChartAreaXAxis.length; chartAreaXaxisIndex++) {
                            var chartXAxis = chartArea.ChartAreaXAxis[chartAreaXaxisIndex];
                            if (chartXAxis.Name.toString().toLowerCase() == "primary") {
                                this._applyAxis(chartXAxis, ejChartCtrl.model.primaryXAxis, chartModel.IsLabelIndex, 'XAxis', 'primary', ejChartCtrl.model.series[0].type, chartArea.Chart3D ? chartArea.Chart3D.Enabled : null);
                            }
                            //else if (chartXAxis.Name.toString().toLowerCase() == "secondary") {
                            //    if (!ej.isNullOrUndefined(ejChartCtrl.model.axes)) {
                            //        var xaxesObj = $.extend(true, {}, ejChartCtrl.model._axes[0]);
                            //        this._applyAxis(chartXAxis, xaxesObj, 'XAxis', 'secondary');
                            //        xaxesObj.opposedPosition = true;
                            //        xaxesObj.orientation = 'Horizontal';
                            //        ejChartCtrl.model.axes.push(xaxesObj);
                            //    }
                            //}
                        }

                        for (var chartAreaYaxisIndex = 0; chartAreaYaxisIndex < chartArea.ChartAreaYAxis.length; chartAreaYaxisIndex++) {
                            var chartYAxis = chartArea.ChartAreaYAxis[chartAreaYaxisIndex];
                            if (chartYAxis.Name.toString().toLowerCase() == "primary") {
                                this._applyAxis(chartYAxis, ejChartCtrl.model.primaryYAxis, chartModel.IsLabelIndex, 'YAxis', 'primary', ejChartCtrl.model.series[0].type, chartArea.Chart3D ? chartArea.Chart3D.Enabled : null);
                            }
                            //else if (chartYAxis.Name.toString().toLowerCase() == "secondary") {
                            //    if (!ej.isNullOrUndefined(ejChartCtrl.model.axes)) {
                            //        var yaxesObj = $.extend(true, {}, ejChartCtrl.model._axes[0]);
                            //        yaxesObj.opposedPosition = true;
                            //        yaxesObj.orientation = "vertical";
                            //        this._applyAxis(chartYAxis, yaxesObj, 'YAxis', 'secondary');
                            //        ejChartCtrl.model.axes.push(yaxesObj);
                            //    }
                            //}
                        }
                    }

                    if (chartArea.Chart3D && chartArea.Chart3D.Enabled) {
                        ejChartCtrl.model.enable3D = chartArea.Chart3D.Enabled;
                        ejChartCtrl.model.depth = chartArea.Chart3D.DepthRatio;
                        ejChartCtrl.model.wallSize = chartArea.Chart3D.WallThickness;
                        ejChartCtrl.model.tilt = 0;
                        ejChartCtrl.model.rotation = 20;
                        ejChartCtrl.model.perspectiveAngle = chartArea.Chart3D.Perspective == 0 ? 90 : chartArea.Chart3D.Perspective;
                        ejChartCtrl.model.crosshair.visible = true;
                    }

                    if (chartseries && chartseries.PointValues.length <= 0) {
                        ejChartCtrl.model.legend.visible = false;
                        ejChartCtrl.model.primaryXAxis.visible = false;
                        ejChartCtrl.model.primaryYAxis.visible = false;
                        ejChartCtrl.model.series = [];
                        ejChartCtrl.model.chartArea.visible = false;
                        var chartsubtile = chartModel.ChartNoDataMessage;
                        if (ejChartCtrl.model.title.text == "") {
                            ejChartCtrl.model.title.text = " ";
                        }
                        if (chartsubtile.Caption && chartsubtile.Visible) {
                            ejChartCtrl.model.title.subTitle.textAlignment = "center";
                            ejChartCtrl.model.title.subTitle.text = chartsubtile.Caption;
                            if (chartsubtile.Style) {
                                if (chartsubtile.Style.Color) {
                                    ejChartCtrl.model.title.subTitle.font.color = chartsubtile.Style.Color;
                                }

                                if (chartsubtile.Style.Font) {
                                    if (chartsubtile.Style.Font.FontFamily) {
                                        ejChartCtrl.model.title.subTitle.font.fontFamily = chartsubtile.Style.Font.FontFamily;
                                    }

                                    if (chartsubtile.Style.Font.FontStyle) {
                                        ejChartCtrl.model.title.subTitle.font.fontStyle = chartsubtile.Style.Font.FontStyle;
                                    }

                                    if (chartsubtile.Style.Font.FontWeight) {
                                        ejChartCtrl.model.title.subTitle.font.fontWeight = chartsubtile.Style.Font.FontWeight;
                                    }

                                    if (chartsubtile.Style.Font.FontSize != 0) {
                                        ejChartCtrl.model.title.subTitle.font.size = chartsubtile.Style.Font.FontSize + 'px';
                                    }
                                }
                            }
                        }
                    }
                    ejChartCtrl.redraw();
                }
            }
        },

        _legendOrder: function (event) {
            event.model.legendCollection.reverse();
        },

        _chartAreaDisplayText: function (event) {
            if (event.data.text == "0") {
                event.data.text = "";
            }
        },

        _applyBackgroundGradientStyle: function (style, tag) {
            var type;
            switch (style.BackgroundGradientType) {
                case "None":
                    break;
                case "Default":
                    break;
                case "LeftRight":
                    type = "to right";
                    tag.css('background', 'linear-gradient(' + type + ',' + style.BackgroundColor + ', ' + style.BackgroundGradientEndcolor + ')');
                    break;
                case "TopBottom":
                    tag.css('background', 'linear-gradient(' + style.BackgroundColor + ', ' + style.BackgroundGradientEndcolor + ')');
                    break;
                case "Center":
                    tag.css('background', 'radial-gradient(' + style.BackgroundColor + ', ' + style.BackgroundGradientEndcolor + ')');
                    break;
                case "DiagonalLeft":
                    type = "to bottom right";
                    tag.css('background', 'linear-gradient(' + type + ',' + style.BackgroundColor + ', ' + style.BackgroundGradientEndcolor + ')');
                    break;
                case "DiagonalRight":
                    type = "to bottom left";
                    tag.css('background', 'linear-gradient(' + type + ',' + style.BackgroundColor + ', ' + style.BackgroundGradientEndcolor + ')');
                    break;
                case "HorizontalCenter":
                    tag.css('background', 'linear-gradient(' + style.BackgroundColor + ',' + style.BackgroundGradientEndcolor + ', ' + style.BackgroundColor + ')');
                    break;
                case "VerticalCenter":
                    tag.css('background', 'linear-gradient(90deg,' + style.BackgroundColor + ',' + style.BackgroundGradientEndcolor + ', ' + style.BackgroundColor + ')');
                    break;
            }
        },

        _applyAxis: function (axisModelProp, axisName, isIndexed, axisSpecific, axistype, seriestype, threeDEnabled) {
            if (seriestype != 'pie' && !threeDEnabled) {
                axisName.labelPlacement = 'onticks';
            }

            if (axisSpecific == "XAxis" && axisModelProp.Labels && axisModelProp.Labels.length > 0) {
                axisName.crosshairLabel.visible = true;
                axisName.valueType = "category";
                axisName.isIndexed = isIndexed;
                axisName.labelBorder.width = 1;
                axisName.labelBorder.color = "grey";
                var ejgroupingLabel = axisName.multiLevelLabels[0];
                axisName.multiLevelLabels.pop(ejgroupingLabel);
                for (var index = 0; index < axisModelProp.Labels.length; index++) {
                    for (var groupIndex = 0; groupIndex < axisModelProp.Labels[index].Categories.length; groupIndex++) {
                        var groupObj = $.extend(true, {}, ejgroupingLabel);
                        groupObj.visible = true;
                        groupObj.text = axisModelProp.Labels[index].Categories[groupIndex].Text;
                        groupObj.start = axisModelProp.Labels[index].Categories[groupIndex].Start;
                        groupObj.end = axisModelProp.Labels[index].Categories[groupIndex].End;
                        groupObj.level = axisModelProp.Labels[index].Index;
                        axisName.multiLevelLabels.push(groupObj);
                    }
                }
            }

            if (axisModelProp.ChartAxisTitle) {

                if (axisModelProp.ChartAxisTitle.Caption) {
                    axisName.title.text = axisModelProp.ChartAxisTitle.Caption;
                }

                if (axisModelProp.ChartAxisTitle.TextColor) {
                    axisName.title.font.color = axisModelProp.ChartAxisTitle.TextColor;
                }

            if (axisModelProp.ChartAxisTitle.Font) {
                if (axisModelProp.ChartAxisTitle.Font.FontSize) {
                    axisName.title.font.size = axisModelProp.ChartAxisTitle.Font.FontSize;
                }

                if (axisModelProp.ChartAxisTitle.Font.FontFamily) {
                    axisName.title.font.fontFamily = axisModelProp.ChartAxisTitle.Font.FontFamily;
                }

                    if (axisModelProp.ChartAxisTitle.Font.FontStyle) {
                        axisName.title.font.fontStyle = axisModelProp.ChartAxisTitle.Font.FontStyle;
                    }
                }
            }

            if (axisModelProp.Maximum != null && axisModelProp.Maximum != "NaN" && axisModelProp.Maximum != 0
                && axisModelProp.Minimum != null && axisModelProp.Minimum != "NaN") {
                axisName.setRange = true;
                axisName.range.min = axisModelProp.Minimum;
                axisName.range.max = axisModelProp.Maximum;
            }

            if (axisModelProp.Interval != "NaN") {
                //axisName.range.interval = axisModelProp.Interval;
            }

            if (axisModelProp.IntervalType) {
                //axisName.intervalType = axisModelProp.IntervalType;
            }

            axisName.font.color = axisModelProp.LabelColor ? axisModelProp.LabelColor : "Black";
            axisName.labelFormat = axisModelProp.LabelFormat;
            if (axisModelProp.LabelFont) {
                axisName.font.fontFamily = axisModelProp.LabelFont.FontFamily;
                axisName.font.size = axisModelProp.LabelFont.FontSize;
                axisName.font.fontStyle = axisModelProp.LabelFont.FontStyle == "Default" ? "Normal" : axisModelProp.LabelFont.FontStyle;
                axisName.font.fontWeight = axisModelProp.LabelFont.FontWeight;
            }

            if (axisModelProp.ChartMajorGridLines) {
                this._applyGridLines(axisModelProp.ChartMajorGridLines, axisName.majorGridLines);
            }

            if (axisModelProp.ChartMinorGridLines) {
                this._applyGridLines(axisModelProp.ChartMinorGridLines, axisName.minorGridLines);
            }

            if (axisModelProp.ChartMajorTickMarks) {
                this._applyTickMarks(axisModelProp.ChartMajorTickMarks, axisName.majorTickLines);
            }

            if (axisModelProp.ChartMinorTickMarks) {
                this._applyTickMarks(axisModelProp.ChartMinorTickMarks, axisName.minorTickLines);
            }

            if (axisName.minorTicksPerInterval == null)
            {
                axisName.minorTicksPerInterval = 1;
            }

            if (axisModelProp.Labels != null && axisModelProp.Labels.length > 0) {
                axisName.labelIntersectAction = "trim";
            }
            else if (axisModelProp.LabelsAutoFitEnabled) {
                if (axisModelProp.PrExventWordWrap && axisModelProp.PrExventLabelOffset) {
                    if (axisModelProp.AllowLabelRotation != 'none') {
                        axisName.labelIntersectAction = axisModelProp.AllowLabelRotation;
                    } else {
                        axisName.labelIntersectAction = 'trim';
                    }
                } else if (axisModelProp.PrExventLabelOffset) {
                    axisName.labelIntersectAction = 'wrapByWord';
                } else {
                    axisName.labelIntersectAction = 'multipleRows';
                }
            }
            else if (axisModelProp.Angle) {
                axisName.labelRotation = axisModelProp.Angle;
            } else {
                axisName.labelIntersectAction = 'wrap';
            }

            if (axisModelProp.LineColor) {
                axisName.axisLine.color = axisModelProp.LineColor;
            }
            if (axisModelProp.LineWidth) {
                axisName.axisLine.width = axisModelProp.LineWidth;
            }

            if (axisModelProp.HideEndLabels) {
                axisName.edgeLabelPlacement = 'hide';
            }

            if (axisModelProp.VisibleStatus == "True" || (axistype == 'primary' && axisModelProp.VisibleStatus == 'Auto')) {
                axisName.visible = true;
                axisName.axisLine.visible = true;
            } else {
                axisName.visible = false;
                axisName.axisLine.visible = false;
            }
            axisName.rangePadding = 'none';
        },

        _applyGridLines: function (applySrc, applyTarget) {
            applyTarget.visible = applySrc.Enabled;
            if (applySrc.Enabled) {
                if (applySrc.Style && applySrc.Style.Default) {
                    if (applySrc.Style.Default.BorderBrush) {
                        applyTarget.color = applySrc.Style.Default.BorderBrush;
                    }

                    applyTarget.width = applySrc.Style.Default.BorderStyle == "None" ? applyTarget.width : applySrc.Style.Default.Thickness;

                    if (applySrc.Style.Default.BorderStyle == "Dashed") {
                        applyTarget.dashArray = "2,4";
                    }
                    else if (applySrc.Style.Default.BorderStyle == "Dotted") {
                        applyTarget.dashArray = "2,2";
                    }
                }
            }
        },

        _applyTickMarks: function (applySrc, applyTarget) {
            applyTarget.visible = applySrc.Enabled;

            if (applySrc.Style && applySrc.Style.Default) {
                if (applySrc.Style.Default.BorderBrush) {
                    applyTarget.color = applySrc.Style.Default.BorderBrush;
                }

                if (applySrc.Style.Default.Thickness) {
                    applyTarget.width = applySrc.Style.Default.Thickness;
                }
            }

            if (applySrc.Length) {
                applyTarget.size = applySrc.Length;
            }
        },
        //-------------------- Render the Chart ReportItem [end] -------------------------//

        _renderImageControl: function (imgModel, isTablixCell, parnetObj, parentId, printMode, printPageId) {
            var ctrlId = this._controlKeyGenerator(this._id + '_' + imgModel.Name, parentId, printMode, printPageId);
            var imageDiv = ej.buildTag("div", "", {}, { id: ctrlId, title: imgModel.ToolTip });
            var _imageDivCss = {};
            parnetObj.append(imageDiv);
            _imageDivCss["position"] = (isTablixCell && imgModel.IsTablixChild) ? 'relative' : 'absolute';
            _imageDivCss["top"] = imgModel.Top;
            _imageDivCss["left"] = imgModel.Left;
            _imageDivCss["width"] = imgModel.Width;
            _imageDivCss["height"] = imgModel.Height;
            _imageDivCss["overflow"] = "hidden";

            _imageDivCss["padding-left"] = imgModel.PaddingLeft;
            _imageDivCss["padding-right"] = imgModel.PaddingRight;
            _imageDivCss["padding-top"] = imgModel.PaddingTop;
            _imageDivCss["padding-bottom"] = imgModel.PaddingBottom;

            if (imgModel.ActionInfo) {
                imageDiv.data('actionObj', imgModel.ActionInfo);
                imageDiv.addClass('drillAction_' + this._id + ' e-reportviewer-drillhover');
            }

            if (imgModel.Border && !imgModel.IsTablixChild) {
                this._applyBorderStyle(imgModel.Border, imageDiv);
            }

            var imagetag = ej.buildTag("img", "", { 'width': imgModel.ImageWidth, 'height': imgModel.ImageHeight }, { 'src': printMode ? '' : this.model.reportServiceUrl + '/GetResource/?key=' + imgModel.ImageUrl + '&resourcetype=sfimg&isPrint=' + printMode, 'imgUrl': this.model.reportServiceUrl + '/GetResource/?key=' + imgModel.ImageUrl + '&resourcetype=sfimg&isPrint=' + printMode });
            imageDiv.append(imagetag);
            imageDiv.css(_imageDivCss);
        },

        _renderRectangleControl: function (rectModel, isTablixCell, parentObj, parentId, printMode, printPageId) {
            var ctrlId = this._controlKeyGenerator(this._id + '_' + rectModel.Name, parentId, printMode, printPageId);
            var rectDiv = ej.buildTag("div", "", {}, { 'id': ctrlId, title: rectModel.ToolTip });
            var _rectDivCss = {};
            parentObj.append(rectDiv);
            _rectDivCss["position"] = isTablixCell ? 'relative' : 'absolute';
            _rectDivCss["top"] = rectModel.Top;
            _rectDivCss["left"] = rectModel.Left;
            _rectDivCss["width"] = rectModel.Width;
            _rectDivCss["height"] = rectModel.Height;
            _rectDivCss["background-color"] = rectModel.BackgroundColor;

            var resourceName = printMode ? 'PrintImage' : 'GetResource';
            if (rectModel.BackgroundImageSrc) {
                _rectDivCss["background-image"] = "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + rectModel.BackgroundImageSrc + '&resourcetype=sfimg&isPrint=' + printMode + ")";
            }

            if (rectModel.Border && !isTablixCell) {
                this._applyBorderStyle(rectModel.Border, rectDiv);
            }

            if (rectModel.IsTablixChild && rectModel.ReportModels && rectModel.ReportModels.length > 0) {
                for (var i = 0; i < rectModel.ReportModels.length; i++) {
                    var innerItem = rectModel.ReportModels[i];
                    if (innerItem) {
                        if (innerItem.ItemType == "TextBoxModel") {
                            var textboxControl = this._renderTextBoxControl(innerItem, false, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                            rectDiv.append(textboxControl);
                        }
                        else if (innerItem.ItemType == "LineModel") {
                            var lineControl = this._renderLineControl(innerItem, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                            rectDiv.append(lineControl);
                        }
                        else if (innerItem.ItemType == "ImageModel") {
                            this._renderImageControl(innerItem, false, rectDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        }
                        else if (innerItem.ItemType == "TablixModel") {
                            this._renderTablixControl(innerItem, false, {}, rectDiv, ctrlId + '_' + innerItem.Name, printPageId);
                        }
                        else if (innerItem.ItemType == "GaugeModel") {
                            this._renderGaugeControl(innerItem, false, false, {}, rectDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        }
                        else if (innerItem.ItemType == "RectangleModel") {
                            this._renderRectangleControl(innerItem, false, rectDiv, ctrlId + + '_' + innerItem.Name, printMode, printPageId);
                        }
                        else if (innerItem.ItemType == "ChartModel") {
                            this._renderChartControl(innerItem, false, false, {}, rectDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        }
                        else if (innerItem.ItemType == "MapModel") {
                            this._renderMapControl(innerItem, false, rectDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        }
                        else if (innerItem.ItemType == "SubReportModel") {
                            this._renderSubReportControl(innerItem, false, rectDiv, ctrlId + + '_' + innerItem.Name, printMode, printPageId);
                        }
                    }
                }
            }
            rectDiv.css(_rectDivCss);
        },

        _renderMapControl: function (mapModel, webExport, parentObj, parentId, printMode, printPageId) {
            var mapContainer = mapModel.MapProperties;
            if (webExport) {
                this._id = parentId;
                mapModel.Top = 0;
                mapModel.Left = 0;
            }
            var ctrlId = this._controlKeyGenerator(this._id + '_' + mapModel.Name, parentId, printMode, printPageId);
            var mapDiv = ej.buildTag("div", "", {}, { 'id': ctrlId });
            var titleContainerHeight = 0;
            parentObj.append(mapDiv);

            mapDiv.css("position", "absolute");
            mapDiv.css("top", mapModel.Top);
            mapDiv.css("left", mapModel.Left);
            mapDiv.css("height", mapModel.Height);
            mapDiv.css("width", mapModel.Width);
            if (mapContainer.Background && mapContainer.Background.BackgroundColor) {
                mapDiv.css("background-color", mapContainer.Background.BackgroundColor);
            }

            if (mapModel.IsTablixChild) {
                mapDiv.css("position", "relative");
            }

            if (mapContainer.ActionInfo) {
                mapDiv.data('actionObj', mapContainer.ActionInfo);
                mapDiv.addClass('drillAction_' + this._id + ' e-reportviewer-drillhover');
            }

            if (mapContainer.Border) {
                this._applyBorderStyle(mapContainer.Border, mapDiv);
            }
            var title = mapContainer.MapTitles;
            if (title && title.length > 0) {

                for (var i = 0; i < title.length; i++) {
                    var titleDiv = ej.buildTag("div", "", {}, { 'id': ctrlId + '_' + title[i].Name });
                    titleDiv.css("position", "relative");
                    titleDiv.css("left", "1px");
                    titleDiv.css("height", title[i].Style.Font.FontSize - (3 * title[i].Border.Thickness));
                    titleDiv.css("width", mapModel.Width - (3 * title[i].Border.Thickness));
                    titleDiv.css("text-align", "center");
                    titleDiv.css("background-color", title[i].BackGround.BackgroundColor);
                    titleDiv.css("border-color", title[i].Border.BorderBrush);
                    titleDiv.css("border-width", title[i].Border.Thickness);
                    titleDiv.css("border-style", title[i].Border.BorderStyle);

                    var span = ej.buildTag("span", "", {}, { 'id': ctrlId + '_' + title[i].Name + '_' + i });
                    span.css("font-family", title[i].Style.Font.FontFamily);
                    span.css("font-size", (title[i].Style.Font.FontSize / 1.33));
                    span.css("font-style", title[i].Style.Font.FontStyle);
                    span.css("font-weight", title[i].Style.Font.FontWeight);
                    span.append(title[i].Text);
                    titleDiv.append(span);
                    mapDiv.append(titleDiv);
                }
            }

            if (mapContainer.MapViewport) {
                var viewPort = mapContainer.MapViewport;
                var shapDiv = ej.buildTag("div", "", {}, { 'id': ctrlId + '_' + mapModel.Name });
                mapDiv.append(shapDiv);
                shapDiv.css("left", "1px");
                shapDiv.css("top", "1px");

                if (title && title.length > 0) {
                    for (var titleIndex = 0; titleIndex < title.length; titleIndex++) {
                        titleContainerHeight = titleContainerHeight + title[titleIndex].Style.Font.FontSize;
                    }
                    shapDiv.css("height", ((mapModel.Height - titleContainerHeight) - (3 * viewPort.Border.Thickness)));
                    shapDiv.css("top", "10px");
                }
                else {
                    shapDiv.css("height", (mapModel.Height - (3 * viewPort.Border.Thickness)));
                }

                shapDiv.css("width", mapModel.Width - (3 * viewPort.Border.Thickness));
                shapDiv.css("background-color", viewPort.BackGround.BackgroundColor);
                shapDiv.css("border-color", viewPort.Border.BorderBrush);
                shapDiv.css("border-width", viewPort.Border.Thickness);
                shapDiv.css("border-style", viewPort.Border.BorderStyle);

                shapDiv.ejMap({ layers: [{ layerType: "geometry" }] });
                var map = shapDiv.data("ejMap");
                map.model.zoomSettings.minValue = 1;
                map.model.zoomSettings.level = 1;
                map.model.zoomSettings.enableZoom = false;

                map.model.centerPosition = [viewPort.MapView.CenterX, viewPort.MapView.CenterY];

                if (mapContainer.MapPolygonLayers && mapContainer.MapPolygonLayers.length > 0) {
                    for (var polygonIndex = 0; polygonIndex < mapContainer.MapPolygonLayers.length; polygonIndex++) {
                        var polygon = mapContainer.MapPolygonLayers[polygonIndex];
                        var layer = $.extend(true, {}, map.model.layers[0]);
                        layer.layerType = "geometry";
                        layer.enableSelection = false;
                        layer.enableMouseHover = false;
                        layer.shapeData = polygon.MapFields;
                        if (polygon.MapBindingFieldPairs) {
                            layer.shapePropertyPath = polygon.MapBindingFieldPairs.FieldName;
                        }
                        layer.shapeDataPath = 'Value';
                        layer.dataSource = mapModel.MapModelData;

                        if (mapModel.MapModelData && mapModel.MapModelData.length > 0 && mapModel.MapModelData[0].ShapeActionInfo) {
                            map.ejreportid = this._id;
                            map.model.shapeSelected = this._drillThroughClick;
                            layer.enableSelection = true;
                            layer.enableMouseHover = true;
                            map.model.mouseover = function (event) {
                                if (event.originalEvent.data && event.originalEvent.data.ShapeActionInfo) {
                                    $(event.originalEvent.shape).css('cursor', 'pointer');
                                }
                            };
                        }

                        if (polygon.ShapeSettings) {
                            var shapesettings = $.extend(true, {}, layer.shapeSettings);
                            shapesettings.colorValuePath = polygon.ShapeSettings.ShapeColorValuePath;
                            shapesettings.valuePath = polygon.ShapeSettings.ShapeValuePath;
                            if (polygon.ShapeColorMappings && polygon.ShapeColorMappings.length > 1) {
                                shapesettings.colorMappings = { equalColorMapping: polygon.ShapeColorMappings };
                            }
                            else {
                                shapesettings.autoFill = true;
                                shapesettings.colorPalette = "palette1";
                            }
                            layer.shapeSettings = shapesettings;
                        }
                        if (polygon.MapCenterPointRules && polygon.MapCenterPointRules.length > 0 && polygon.MapCenterPointRules.MapSizeRule) {
                            var bubblesettings = $.extend(true, {}, layer.bubbleSettings);
                            bubblesettings.maxValue = polygon.BubbleSettings.MaxSize;
                            bubblesettings.minValue = polygon.BubbleSettings.MinSize;
                            bubblesettings.colorValuePath = polygon.BubbleSettings.ColorValuePath == null ? "Value" : polygon.BubbleSettings.ColorValuePath;
                            bubblesettings.valuePath = polygon.BubbleSettings.ValuePath;
                            if (polygon.BubbleColorMappings && polygon.BubbleColorMappings.length > 1) {
                                bubblesettings.colorMappings = { equalColorMapping: polygon.BubbleColorMappings };
                            }
                            layer.bubbleSettings = bubblesettings;
                        }

                        if (polygon.MapPolygonTemplate) {
                            var labelsettings = $.extend(true, {}, layer.labelSettings);
                            labelsettings.showLabels = true;
                            if (polygon.ShapeSettings) {
                                labelsettings.labelPath = polygon.ShapeSettings.LabelPath;
                            }
                            labelsettings.enableSmartLabel = false;
                            layer.labelSettings = labelsettings;
                        }

                        if (mapContainer.MapLegends && mapContainer.MapLegends.length > 0) {
                            var legendsettings = $.extend(true, {}, layer.legendSettings);
                            legendsettings.showLegend = true;
                            layer.legendSettings = legendsettings;
                        }
                        map.model.layers[polygonIndex] = layer;
                    }
                }
                map.refresh();
                shapDiv.css("position", "relative");
            }
        },

        //-------------------- Render the Gauge ReportItem [start] -------------------------//
        _renderGaugeControl: function (gaugeModel, webExport, isTablixCell, cellSize, parentObj, parentId, printMode, printPageId) {
            var gaugePanel = gaugeModel.GaugePanel;
            if (webExport) {
                this._id = parentId;
                gaugeModel.Top = 0;
                gaugeModel.Left = 0;
            }
            var ctrlId = this._controlKeyGenerator(this._id + '_' + gaugeModel.Name, parentId, printMode, printPageId);
            var gaugeDiv = ej.buildTag("div", "", {}, { 'id': ctrlId });
            parentObj.append(gaugeDiv);
            gaugeDiv.css("position", "absolute");
            var containerHeight = gaugeModel.Height;
            var containerWidth = gaugeModel.Width;

            if (gaugeModel.Top) {
                gaugeDiv.css("top", gaugeModel.Top);
            }

            if (gaugeModel.Left) {
                gaugeDiv.css("left", gaugeModel.Left);
            }
            var panelOrientation = 'Horizontal';
            var itemCount = 0;

            if (gaugePanel.RadialGauges && gaugePanel.RadialGauges.length > 0) {
                itemCount = itemCount + gaugePanel.RadialGauges.length;
            }

            if (gaugePanel.LinearGauges && gaugePanel.LinearGauges.length > 0) {
                itemCount = itemCount + gaugePanel.LinearGauges.length;
            }

            if (gaugePanel.Indicator && gaugePanel.Indicator.length > 0) {
                itemCount = itemCount + gaugePanel.Indicator.length;
            }

            var resourceName = printMode ? 'PrintImage' : 'GetResource';
            if (gaugePanel.GaugeFrame && gaugePanel.GaugeFrame.FrameImage) {
                gaugeDiv.css("background-image", "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + gaugePanel.GaugeFrame.FrameImage + '&resourcetype=sfimg&isPrint=' + printMode + ")");
            }

            if (gaugePanel.Border) {
                this._applyBorderStyle(gaugePanel.Border, gaugeDiv);
            }

            if (isTablixCell) {
                _parentID = parentId;
                containerHeight = cellSize.height;
                var borderwidthadjust = parseFloat(gaugeDiv.css("border-left-width"), 10) + parseFloat(gaugeDiv.css("border-right-width"), 10);
                var borderheightadjust = parseFloat(gaugeDiv.css("border-top-width"), 10) + parseFloat(gaugeDiv.css("border-bottom-width"), 10);
                containerWidth = (containerWidth - (borderwidthadjust));
                containerHeight = (containerHeight - (borderheightadjust));
            }

            if (itemCount != 0) {
                if (containerHeight > containerWidth) {
                    containerHeight = containerHeight / itemCount;
                    panelOrientation = 'Vertical';
                } else {
                    containerWidth = containerWidth / itemCount;
                }
            }

            if (gaugePanel.GaugeLabel) {
                this._renderGaugeLabels(gaugePanel.GaugeLabel, gaugeDiv, gaugeModel.Name, parentId, printMode, printPageId);
            }

            if (gaugePanel.RadialGauges && gaugePanel.RadialGauges.length > 0) {
                this._renderRadialGauge(gaugePanel.RadialGauges, gaugeDiv, gaugeModel.Name, panelOrientation, containerWidth, containerHeight, parentId, printMode, printPageId);
            }

            if (gaugePanel.LinearGauges && gaugePanel.LinearGauges.length > 0) {
                this._renderLinearGauge(gaugePanel.LinearGauges, gaugeDiv, gaugeModel.Name, panelOrientation, containerWidth, containerHeight, parentId, printMode, printPageId);
            }

            if (gaugePanel.Indicator && gaugePanel.Indicator.length > 0) {
                this._renderIndicator(gaugePanel.Indicator, gaugeDiv, gaugeModel.Name, containerWidth, containerHeight, parentId, printMode, printPageId);
            }

            if (isTablixCell) {
                gaugeDiv.css({ 'position': 'relative', 'width': containerWidth, 'height': containerHeight, 'background-color': gaugePanel.BackgroundColor });
            } else {
                gaugeDiv.css({ 'width': gaugeModel.Width, 'height': gaugeModel.Height, 'background-color': gaugePanel.BackgroundColor });
            }
        },

        _renderIndicator: function (indicators, gaugeDiv, gaugeName, containerWidth, containerHeight, parentId, printMode, printPageId) {
            var svgNs = "http://www.w3.org/2000/svg";
            for (var guageIndex = 0; guageIndex < indicators.length; guageIndex++) {
                var svgelement = document.createElementNS(svgNs, "svg");
                var groupElement = document.createElementNS(svgNs, "g");
                var scaleXy = (containerWidth < containerHeight) ? containerWidth : containerHeight;
                var indicator = indicators[guageIndex];
                var indicatorDiv = ej.buildTag("div", "", { 'width': containerWidth, 'height': containerHeight, 'top': '0px', 'left': '0px' }, { 'id': this._controlKeyGenerator(this._id + '_' + gaugeName + '_' + indicator.Name, parentId, printMode, printPageId), title: indicator.ToolTip });
                var indicatorinnerDiv = ej.buildTag("div", "", { 'width': '20px', 'height': '20px', 'position': 'relative', 'display': 'block' });
                //svgelement.setAttributeNS(null, 'width', 'auto');
                //svgelement.setAttributeNS(null, 'height', 'auto');
                svgelement.setAttributeNS(null, 'style', 'display: block;margin:auto');
                for (var state = 0; state < indicator.IndicatorState.length; state++) {
                    var style = indicator.IndicatorState[state].IndicatorStyle;
                    var startValue = indicator.IndicatorState[state].StartValue.Value;
                    var endValue = indicator.IndicatorState[state].EndValue.Value;

                    var temStart=startValue;
                    var temEnd=endValue;
                    if(startValue >= endValue){
                        startValue = temEnd;
                        endValue = temStart;
                    }

                    if ((indicator.IndicatorData.Value >= startValue && indicator.IndicatorData.Value <= endValue)) {
                        var fillColor = indicator.IndicatorState[state].FillColor;
                        var svgAttribute = 'display: block;';
                        var innerDivWidth = 17;
                        var innerDivHeight = 17;
                        switch (style) {
                            case "ArrowDown":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M7.60501098632813,16.3990020751953L14.06298828125,10.0289993286133 10.3890075683594,10.0289993286133 10.3890075683594,2.32599639892578 4.61099243164063,2.32599639892578 4.61099243164063,10.0289993286133 1.14801025390625,10.0289993286133 7.60501098632813,16.3990020751953z" });
                                innerDivWidth = 16;
                                innerDivHeight = 19;
                                svgAttribute = svgAttribute + 'margin-left:.5px;';
                                break;
                            case "ArrowDownIncline":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M13.5499877929688,13.8919982910156L13.6119995117188,4.822998046875 11.0130004882813,7.42100524902344 5.5670166015625,1.9739990234375 1.48101806640625,6.05900573730469 6.92901611328125,11.5059967041016 4.47900390625,13.9550018310547 13.5499877929688,13.8919982910156z" });
                                innerDivWidth = innerDivHeight = 16;
                                svgAttribute = svgAttribute + 'margin-left:.5px;';
                                break;
                            case "ArrowSide":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.1960144042969,8.43499755859375L8.8280029296875,1.97899627685547 8.8280029296875,5.65299987792969 1.125,5.65299987792969 1.125,11.4300003051758 8.8280029296875,11.4300003051758 8.8280029296875,14.8919982910156 15.1960144042969,8.43499755859375z" });
                                svgAttribute = svgAttribute + 'margin-left:.5px;';
                                break;
                            case "ArrowUp":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M7.27099609375,1.47299957275391L0.81500244140625,7.84200286865234 4.48800659179688,7.84200286865234 4.48800659179688,15.5439987182617 10.2659912109375,15.5439987182617 10.2659912109375,7.84200286865234 13.7279968261719,7.84200286865234 7.27099609375,1.47299957275391z" });
                                innerDivWidth = 16;
                                svgAttribute = svgAttribute + 'margin-left:.5px;';
                                break;
                            case "ArrowUpIncline":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M13.0830078125,2.04299926757813L4.0159912109375,1.98199462890625 6.61300659179688,4.58000183105469 1.16598510742188,10.0269927978516 5.25100708007813,14.1119995117188 10.697998046875,8.66499328613281 13.14599609375,11.1130065917969 13.0830078125,2.04299926757813z" });
                                innerDivWidth = 15;
                                innerDivHeight = 16;
                                svgAttribute = svgAttribute + 'margin-left:.5px;';
                                break;
                            case "BoxesAllFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M2.031005859375,7.5L8.031005859375,7.5 8.031005859375,1.5 2.031005859375,1.5 2.031005859375,7.5z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M8.96798706054688,7.5L14.9679870605469,7.5 14.9679870605469,1.5 8.96798706054688,1.5 8.96798706054688,7.5z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M2.031005859375,14.43701171875L8.031005859375,14.43701171875 8.031005859375,8.43798828125 2.031005859375,8.43798828125 2.031005859375,14.43701171875z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M8.96798706054688,14.43701171875L14.9679870605469,14.43701171875 14.9679870605469,8.43798828125 8.96798706054688,8.43798828125 8.96798706054688,14.43701171875z" });
                                svgAttribute = svgAttribute + 'margin-top:2.5px;';
                                break;
                            case "BoxesNoneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M2.031005859375,7.5L8.031005859375,7.5 8.031005859375,1.5 2.031005859375,1.5 2.031005859375,7.5z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.96798706054688,7.5L14.9679870605469,7.5 14.9679870605469,1.5 8.96798706054688,1.5 8.96798706054688,7.5z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M2.031005859375,14.43701171875L8.031005859375,14.43701171875 8.031005859375,8.43798828125 2.031005859375,8.43798828125 2.031005859375,14.43701171875z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.96798706054688,14.43701171875L14.9679870605469,14.43701171875 14.9679870605469,8.43798828125 8.96798706054688,8.43798828125 8.96798706054688,14.43701171875z" });
                                innerDivHeight = 16;
                                break;
                            case "BoxesOneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M2.031005859375,7.5L8.031005859375,7.5 8.031005859375,1.5 2.031005859375,1.5 2.031005859375,7.5z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.96798706054688,7.5L14.9679870605469,7.5 14.9679870605469,1.5 8.96798706054688,1.5 8.96798706054688,7.5z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M2.031005859375,14.43701171875L8.031005859375,14.43701171875 8.031005859375,8.43798828125 2.031005859375,8.43798828125 2.031005859375,14.43701171875z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.96798706054688,14.43701171875L14.9679870605469,14.43701171875 14.9679870605469,8.43798828125 8.96798706054688,8.43798828125 8.96798706054688,14.43701171875z" });
                                innerDivHeight = 16;
                                break;
                            case "BoxesThreeFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M2.031005859375,7.5L8.031005859375,7.5 8.031005859375,1.5 2.031005859375,1.5 2.031005859375,7.5z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.96798706054688,7.5L14.9679870605469,7.5 14.9679870605469,1.5 8.96798706054688,1.5 8.96798706054688,7.5z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M2.031005859375,14.43701171875L8.031005859375,14.43701171875 8.031005859375,8.43798828125 2.031005859375,8.43798828125 2.031005859375,14.43701171875z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M8.96798706054688,14.43701171875L14.9679870605469,14.43701171875 14.9679870605469,8.43798828125 8.96798706054688,8.43798828125 8.96798706054688,14.43701171875z" });
                                innerDivHeight = 16;
                                break;
                            case "BoxesTwoFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M2.031005859375,7.5L8.031005859375,7.5 8.031005859375,1.5 2.031005859375,1.5 2.031005859375,7.5z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.96798706054688,7.5L14.9679870605469,7.5 14.9679870605469,1.5 8.96798706054688,1.5 8.96798706054688,7.5z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M2.031005859375,14.43701171875L8.031005859375,14.43701171875 8.031005859375,8.43798828125 2.031005859375,8.43798828125 2.031005859375,14.43701171875z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M8.96798706054688,14.43701171875L14.9679870605469,14.43701171875 14.9679870605469,8.43798828125 8.96798706054688,8.43798828125 8.96798706054688,14.43701171875z" });
                                innerDivHeight = 16;
                                break;
                            case "Circle":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.3310852050781,8.3330078125L14.7622108459473,11.150749206543 13.2108383178711,13.4517440795898 10.9098434448242,15.003116607666 8.09210205078125,15.5719909667969 5.27377843856812,15.003116607666 2.97248458862305,13.4517440795898 1.42100191116333,11.150749206543 0.85211181640625,8.3330078125 1.42100191116333,5.51524877548218 2.97248458862305,3.2142448425293 5.27377843856812,1.66286897659302 8.09210205078125,1.093994140625 10.9098434448242,1.66286897659302 13.2108383178711,3.2142448425293 14.7622108459473,5.51524877548218 15.3310852050781,8.3330078125" });
                                innerDivWidth = innerDivHeight = 17;
                                svgAttribute = svgAttribute + 'margin-left:0.5px;';
                                break;
                            case "Flag":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M1.53518676757813,1.97268676757813L1.71956861019135,1.87765264511108 2.22404956817627,1.65059661865234 3.90132141113281,1.14869689941406 5.98302745819092,1.16354370117188 6.99305105209351,1.58242082595825 7.88519287109375,2.39169311523438 9.55474090576172,4.09454298019409 11.1795692443848,5.14020156860352 12.5349636077881,5.63535928726196 13.3962097167969,5.68670654296875 13.5080919265747,5.78957939147949 13.3250951766968,6.16205215454102 12.1980743408203,7.28895568847656 10.2623682022095,8.2137336730957 9.06851482391357,8.33354949951172 7.76519775390625,8.08270263671875 5.64992141723633,7.59151554107666 4.50045776367188,7.73744964599609 4.02486801147461,8.11925792694092 3.93121337890625,8.335693359375 1.53518676757813,1.97268676757813z" });
                                innerDivWidth = 16;
                                innerDivHeight = 15;
                                break;
                            case "QuartersAllFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.3310852050781,8.3330078125L14.7622108459473,11.150749206543 13.2108383178711,13.4517440795898 10.9098434448242,15.003116607666 8.09210205078125,15.5719909667969 5.27377843856812,15.003116607666 2.97248458862305,13.4517440795898 1.42100191116333,11.150749206543 0.85211181640625,8.3330078125 1.42100191116333,5.51524877548218 2.97248458862305,3.2142448425293 5.27377843856812,1.66286897659302 8.09210205078125,1.093994140625 10.9098434448242,1.66286897659302 13.2108383178711,3.2142448425293 14.7622108459473,5.51524877548218 15.3310852050781,8.3330078125" });
                                svgAttribute = svgAttribute + 'margin-left:0.5px;';
                                break;
                            case "QuartersNoneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M15.3310852050781,8.3330078125L14.7622108459473,11.150749206543 13.2108383178711,13.4517440795898 10.9098434448242,15.003116607666 8.09210205078125,15.5719909667969 5.27377843856812,15.003116607666 2.97248458862305,13.4517440795898 1.42100191116333,11.150749206543 0.85211181640625,8.3330078125 1.42100191116333,5.51524877548218 2.97248458862305,3.2142448425293 5.27377843856812,1.66286897659302 8.09210205078125,1.093994140625 10.9098434448242,1.66286897659302 13.2108383178711,3.2142448425293 14.7622108459473,5.51524877548218 15.3310852050781,8.3330078125" });
                                svgAttribute = svgAttribute + 'margin-left:0.5px;';
                                break;
                            case "QuartersOneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M1.2958984375,8.71868896484375L1.864914894104,11.5364475250244 3.41652679443359,13.8374519348145 5.71757793426514,15.3888282775879 8.534912109375,15.9577026367188 11.353235244751,15.3888282775879 13.6545295715332,13.8374519348145 15.2060127258301,11.5364475250244 15.77490234375,8.71868896484375 15.2060127258301,5.90094757080078 13.6545295715332,3.59995269775391 11.353235244751,2.04858016967773 8.534912109375,1.47970581054688 5.71757793426514,2.04858016967773 3.41652679443359,3.59995269775391 1.864914894104,5.90094757080078 1.2958984375,8.71868896484375" });
                                createElement(groupElement, "path", { fill: fillColor, d: "M8.57321166992188,1.86428833007813L11.3244533538818,2.38370847702026 13.4967041015625,3.80480575561523 14.9227085113525,5.96914529800415 15.4352111816406,8.71829223632813 15.5302124023438,8.7222900390625 8.57321166992188,8.7222900390625 8.57321166992188,1.86428833007813z" });
                                svgAttribute = svgAttribute + 'margin-top:0.5px;';
                                break;
                            case "QuartersThreeFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M16.033203125,9.3330078125L15.4643287658691,12.150749206543 13.9129524230957,14.4517440795898 11.6119480133057,16.003116607666 8.794189453125,16.5719909667969 5.97586584091187,16.003116607666 3.6745719909668,14.4517440795898 2.12308931350708,12.150749206543 1.55419921875,9.3330078125 2.12308931350708,6.51524877548218 3.6745719909668,4.2142448425293 5.97586584091187,2.66286897659302 8.794189453125,2.093994140625 11.6119480133057,2.66286897659302 13.9129524230957,4.2142448425293 15.4643287658691,6.51524877548218 16.033203125,9.3330078125" });
                                createElement(groupElement, "path", { fill: "white", d: "M8.75729370117188,2.4794921875L6.00546979904175,2.99834585189819 3.83292007446289,4.41925430297852 2.40680551528931,6.58378267288208 1.894287109375,9.33349609375 1.79928588867188,9.33648681640625 8.75729370117188,9.33648681640625 8.75729370117188,2.4794921875z" });
                                svgAttribute = svgAttribute + 'margin-top:0.5px;';
                                break;
                            case "QuartersTwoFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.1328125,8.3330078125L14.563796043396,11.150749206543 13.0121841430664,13.4517440795898 10.7111330032349,15.003116607666 7.893798828125,15.5719909667969 5.07547521591187,15.003116607666 2.7741813659668,13.4517440795898 1.22269868850708,11.150749206543 0.65380859375,8.3330078125 1.22269868850708,5.51524877548218 2.7741813659668,3.2142448425293 5.07547521591187,1.66286897659302 7.893798828125,1.093994140625 10.7111330032349,1.66286897659302 13.0121841430664,3.2142448425293 14.563796043396,5.51524877548218 15.1328125,8.3330078125" });
                                createElement(groupElement, "path", { fill: "white", d: "M7.81930541992188,1.45999145507813L5.0907883644104,1.99271726608276 2.95392227172852,3.42375564575195 1.56049299240112,5.59241724014282 1.06228637695313,8.3380126953125 1.57205629348755,11.0836029052734 2.99092483520508,13.252254486084 5.1532301902771,14.6832828521729 7.893310546875,15.2160034179688 7.81930541992188,1.45999145507813z" });
                                svgAttribute = svgAttribute + 'margin-top:0.5px;margin-left:0.5px;';
                                break;
                            case "SignalMeterFourFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M3.44400024414063,17.3070068359375L1.53201293945313,17.3070068359375 1.53201293945313,11.5700073242188 3.44400024414063,11.5700073242188 3.44400024414063,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M7.14999389648438,17.3070068359375L5.23699951171875,17.3070068359375 5.23699951171875,9.65701293945313 7.14999389648438,9.65701293945313 7.14999389648438,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M10.8550109863281,17.3070068359375L8.9429931640625,17.3070068359375 8.9429931640625,5.83200073242188 10.8550109863281,5.83200073242188 10.8550109863281,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M14.56201171875,17.3070068359375L12.6489868164063,17.3070068359375 12.6489868164063,2.00698852539063 14.56201171875,2.00698852539063 14.56201171875,17.3070068359375z" });
                                innerDivHeight = 19;
                                svgAttribute = svgAttribute + 'margin-top:-10px;;margin-left:0.5px;';
                                break;
                            case "SignalMeterNoneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M3.44400024414063,17.3070068359375L1.53201293945313,17.3070068359375 1.53201293945313,11.5700073242188 3.44400024414063,11.5700073242188 3.44400024414063,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M7.14999389648438,17.3070068359375L5.23699951171875,17.3070068359375 5.23699951171875,9.65701293945313 7.14999389648438,9.65701293945313 7.14999389648438,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M10.8550109863281,17.3070068359375L8.9429931640625,17.3070068359375 8.9429931640625,5.83200073242188 10.8550109863281,5.83200073242188 10.8550109863281,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M14.56201171875,17.3070068359375L12.6489868164063,17.3070068359375 12.6489868164063,2.00698852539063 14.56201171875,2.00698852539063 14.56201171875,17.3070068359375z" });
                                innerDivHeight = 19;
                                svgAttribute = svgAttribute + 'margin-top:-10px;;margin-left:0.5px;';
                                break;
                            case "SignalMeterThreeFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M3.44400024414063,17.3070068359375L1.53201293945313,17.3070068359375 1.53201293945313,11.5700073242188 3.44400024414063,11.5700073242188 3.44400024414063,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M7.14999389648438,17.3070068359375L5.23699951171875,17.3070068359375 5.23699951171875,9.65701293945313 7.14999389648438,9.65701293945313 7.14999389648438,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M10.8550109863281,17.3070068359375L8.9429931640625,17.3070068359375 8.9429931640625,5.83200073242188 10.8550109863281,5.83200073242188 10.8550109863281,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M14.56201171875,17.3070068359375L12.6489868164063,17.3070068359375 12.6489868164063,2.00698852539063 14.56201171875,2.00698852539063 14.56201171875,17.3070068359375z" });
                                innerDivHeight = 19;
                                svgAttribute = svgAttribute + 'margin-top:-10px;;margin-left:0.5px;';
                                break;
                            case "SignalMeterOneFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M3.44400024414063,17.3070068359375L1.53201293945313,17.3070068359375 1.53201293945313,11.5700073242188 3.44400024414063,11.5700073242188 3.44400024414063,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M7.14999389648438,17.3070068359375L5.23699951171875,17.3070068359375 5.23699951171875,9.65701293945313 7.14999389648438,9.65701293945313 7.14999389648438,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M10.8550109863281,17.3070068359375L8.9429931640625,17.3070068359375 8.9429931640625,5.83200073242188 10.8550109863281,5.83200073242188 10.8550109863281,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M14.56201171875,17.3070068359375L12.6489868164063,17.3070068359375 12.6489868164063,2.00698852539063 14.56201171875,2.00698852539063 14.56201171875,17.3070068359375z" });
                                innerDivHeight = 19;
                                svgAttribute = svgAttribute + 'margin-top:-10px;;margin-left:0.5px;';
                                break;
                            case "SignalMeterTwoFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M3.44400024414063,17.3070068359375L1.53201293945313,17.3070068359375 1.53201293945313,11.5700073242188 3.44400024414063,11.5700073242188 3.44400024414063,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M7.14999389648438,17.3070068359375L5.23699951171875,17.3070068359375 5.23699951171875,9.65701293945313 7.14999389648438,9.65701293945313 7.14999389648438,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M10.8550109863281,17.3070068359375L8.9429931640625,17.3070068359375 8.9429931640625,5.83200073242188 10.8550109863281,5.83200073242188 10.8550109863281,17.3070068359375z" });
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M14.56201171875,17.3070068359375L12.6489868164063,17.3070068359375 12.6489868164063,2.00698852539063 14.56201171875,2.00698852539063 14.56201171875,17.3070068359375z" });
                                innerDivHeight = 19;
                                svgAttribute = svgAttribute + 'margin-top:-10px;;margin-left:0.5px;';
                                break;
                            case "StarQuartersAllFilled":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M6.41500854492188,6.37100219726563L1.56698608398438,7.07400512695313 5.07501220703125,10.4939880371094 4.24700927734375,15.3210144042969 8.58200073242188,13.0409851074219 12.9169921875,15.3210144042969 12.0899963378906,10.4939880371094 15.5979919433594,7.07400512695313 10.75,6.37100219726563 8.58200073242188,1.97698974609375 6.41500854492188,6.37100219726563z" });
                                break;
                            case "StarQuartersNoneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M6.41500854492188,6.37100219726563L1.56698608398438,7.07400512695313 5.07501220703125,10.4939880371094 4.24700927734375,15.3210144042969 8.58200073242188,13.0409851074219 12.9169921875,15.3210144042969 12.0899963378906,10.4939880371094 15.5979919433594,7.07400512695313 10.75,6.37100219726563 8.58200073242188,1.97698974609375 6.41500854492188,6.37100219726563z" });
                                break;
                            case "StarQuartersOneFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.64109802246094,1.97750854492188L10.80810546875,6.37149047851563 15.6560974121094,7.07449340820313 12.1490936279297,10.4945068359375 12.9761047363281,15.3204956054688 8.64109802246094,13.0404968261719 4.30610656738281,15.3204956054688 5.13409423828125,10.4945068359375 1.6260986328125,7.07449340820313 6.47309875488281,6.37149047851563 8.64109802246094,1.97750854492188z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "none", d: "M6.22300720214844,6.37100219726563L1.50100708007813,7.07400512695313 5.07099914550781,10.4939880371094 4.06300354003906,15.531005859375 7.08399963378906,13.864013671875 7.072998046875,4.968994140625 6.22300720214844,6.37100219726563z" });
                                break;
                            case "StarQuartersThreeFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.60209655761719,1.97750854492188L10.7691040039063,6.37149047851563 15.6170959472656,7.07449340820313 12.110107421875,10.4945068359375 12.9371032714844,15.3204956054688 8.60209655761719,13.0404968261719 4.26710510253906,15.3204956054688 5.0950927734375,10.4945068359375 1.58709716796875,7.07449340820313 6.43409729003906,6.37149047851563 8.60209655761719,1.97750854492188z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "none", d: "M6.40199279785156,6.37100219726563L1.58700561523438,7.07400512695313 5.11000061035156,10.4939880371094 4.28999328613281,15.3210144042969 8.49000549316406,13.0989990234375 10.6970062255859,14.27099609375 10.6970062255859,6.2239990234375 8.60200500488281,1.97698974609375 6.40199279785156,6.37100219726563z" });
                                break;
                            case "StarQuartersTwoFilled":
                                createElement(groupElement, "path", { fill: "none", stroke: "lightgray", d: "M8.17819213867188,1.97750854492188L10.34521484375,6.37149047851563 15.1932067871094,7.07449340820313 11.6861877441406,10.4945068359375 12.5132141113281,15.3204956054688 8.17819213867188,13.0404968261719 3.84320068359375,15.3204956054688 4.67120361328125,10.4945068359375 1.1632080078125,7.07449340820313 6.01019287109375,6.37149047851563 8.17819213867188,1.97750854492188z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "none", d: "M6.010009765625,6.37100219726563L1.16299438476563,7.07400512695313 4.67098999023438,10.4939880371094 3.84298706054688,15.3210144042969 7.83499145507813,13.2219848632813 7.90399169921875,2.53201293945313 6.010009765625,6.37100219726563z" });
                                break;
                            case "ThreeSignsCircle":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.3310852050781,8.3330078125L14.7622108459473,11.150749206543 13.2108383178711,13.4517440795898 10.9098434448242,15.003116607666 8.09210205078125,15.5719909667969 5.27377843856812,15.003116607666 2.97248458862305,13.4517440795898 1.42100191116333,11.150749206543 0.85211181640625,8.3330078125 1.42100191116333,5.51524877548218 2.97248458862305,3.2142448425293 5.27377843856812,1.66286897659302 8.09210205078125,1.093994140625 10.9098434448242,1.66286897659302 13.2108383178711,3.2142448425293 14.7622108459473,5.51524877548218 15.3310852050781,8.3330078125" });
                                svgAttribute = svgAttribute + 'margin-top:1px;margin-left:0.5px;';
                                break;
                            case "ThreeSignsDiamond":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M1.08401489257813,8.01901245117188L8.10400390625,15.1589965820313 15.2929992675781,8.01901245117188 8.10400390625,0.878997802734375 1.08401489257813,8.01901245117188z" });
                                innerDivWidth = 16;
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:1px;';
                                break;
                            case "ThreeSignsTriangle":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M0.83099365234375,14.2340087890625L15.7950134277344,14.2340087890625 8.31298828125,1.27499389648438 0.83099365234375,14.2340087890625z" });
                                svgAttribute = svgAttribute + 'margin-top:1px;';
                                break;
                            case "ThreeSymbolCheck":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.3310852050781,8.3330078125L14.7622108459473,11.150749206543 13.2108383178711,13.4517440795898 10.9098434448242,15.003116607666 8.09210205078125,15.5719909667969 5.27377843856812,15.003116607666 2.97248458862305,13.4517440795898 1.42100191116333,11.150749206543 0.85211181640625,8.3330078125 1.42100191116333,5.51524877548218 2.97248458862305,3.2142448425293 5.27377843856812,1.66286897659302 8.09210205078125,1.093994140625 10.9098434448242,1.66286897659302 13.2108383178711,3.2142448425293 14.7622108459473,5.51524877548218 15.3310852050781,8.3330078125" });
                                createElement(groupElement, "path", { fill: "white", stroke: "lightgray", d: "M12.15869140625,4.38958740234375L11.3836975097656,3.86260986328125 10.7337036132813,3.98660278320313 6.94171142578125,9.57958984375 5.19769287109375,7.83660888671875 4.53570556640625,7.83660888671875 3.87469482421875,8.49859619140625 3.87469482421875,9.16061401367188 6.5546875,11.8416137695313 7.1536865234375,12.1086120605469 7.71771240234375,11.7735900878906 12.28369140625,5.03860473632813 12.15869140625,4.38958740234375" });
                                svgAttribute = svgAttribute + 'margin-top:1px;margin-left:0.5px;';
                                break;
                            case "ThreeSymbolCross":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M1.10299682617188,7.94601440429688L1.66799592971802,10.7435569763184 3.20874404907227,13.0283813476563 5.49386739730835,14.569019317627 8.2919921875,15.1340026855469 8.2919921875,15.1340026855469 11.0901165008545,14.569019317627 13.3752403259277,13.0283813476563 14.9159889221191,10.7435569763184 15.4809875488281,7.94601440429688 15.4809875488281,7.94601440429688 14.9159889221191,5.14773225784302 13.3752403259277,2.86226272583008 11.0901165008545,1.32116842269897 8.2919921875,0.756011962890625 8.2919921875,0.756011962890625 5.49386739730835,1.32116842269897 3.20874404907227,2.86226272583008 1.66799592971802,5.14773225784302 1.10299682617188,7.94601440429688" });
                                createElement(groupElement, "path", { fill: "white", stroke: "lightgray", d: "M10.0479125976563,7.94430541992188L11.9789123535156,6.0133056640625 11.9789123535156,5.31130981445313 10.9259033203125,4.25729370117188 10.222900390625,4.25729370117188 8.2908935546875,6.18930053710938 6.35989379882813,4.25729370117188 5.65689086914063,4.25729370117188 4.60488891601563,5.31130981445313 4.60488891601563,6.0133056640625 6.534912109375,7.94430541992188 4.60488891601563,9.87728881835938 4.60488891601563,10.5783081054688 5.65689086914063,11.6322937011719 6.35989379882813,11.6322937011719 8.2908935546875,9.70028686523438 10.2239074707031,11.6322937011719 10.9259033203125,11.6322937011719 11.9789123535156,10.5783081054688 11.9789123535156,9.87728881835938 10.0479125976563,7.94430541992188z" });
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:1px;';
                                break;
                            case "ThreeSymbolExclamation":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M0.983001708984375,7.94601440429688L1.54785919189453,10.7435569763184 3.08837127685547,13.0283813476563 5.37344741821289,14.569019317627 8.1719970703125,15.1340026855469 8.1719970703125,15.1340026855469 10.9699649810791,14.569019317627 13.2547416687012,13.0283813476563 14.7951431274414,10.7435569763184 15.3599853515625,7.94601440429688 15.3599853515625,7.94601440429688 14.7951431274414,5.14773225784302 13.2547416687012,2.86226272583008 10.9699649810791,1.32116842269897 8.1719970703125,0.756011962890625 8.1719970703125,0.756011962890625 5.37344741821289,1.32116842269897 3.08837127685547,2.86226272583008 1.54785919189453,5.14773225784302 0.983001708984375,7.94601440429688" });
                                createElement(groupElement, "path", { fill: "white", stroke: "lightgray", d: "M7.59280395507813,9.60159301757813L8.71978759765625,9.60159301757813 9.00180053710938,9.60159301757813 9.12579345703125,2.8916015625 7.143798828125,2.8916015625 7.31280517578125,9.60159301757813 7.59280395507813,9.60159301757813z" });
                                createElement(groupElement, "path", { fill: "white", stroke: "lightgray", d: "M8.96728515625,10.69140625L8.17428588867188,10.3753967285156 7.37130737304688,10.6924133300781 7.03228759765625,11.4764099121094 7.37530517578125,12.244384765625 8.17428588867188,12.54541015625 8.96328735351563,12.244384765625 9.310302734375,11.4764099121094 8.96728515625,10.69140625" });
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:1px;';
                                break;
                            case "ThreeSymbolUnCircledCheck":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M13.8515930175781,2.2255859375L12.6495971679688,1.402587890625 12.1062202453613,1.29134368896484 11.6416015625,1.59561157226563 5.755615234375,10.32958984375 3.04959106445313,7.60760498046875 2.53897094726563,7.39609527587891 2.02459716796875,7.60760498046875 0.997589111328125,8.64260864257813 0.785346984863281,9.15935516357422 0.997589111328125,9.6776123046875 5.1575927734375,13.8635864257813 6.0845947265625,14.2785949707031 6.96060180664063,13.755615234375 14.0445861816406,3.2406005859375 14.1565895080566,2.69297027587891 13.8515930175781,2.2255859375" });
                                innerDivWidth = innerDivHeight = 16;
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:.5px;';
                                break;
                            case "ThreeSymbolUnCircledCross":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M9.36907958984375,6.86331176757813L12.423095703125,3.71530151367188 12.6540832519531,3.14280700683594 12.423095703125,2.5703125 10.7581176757813,0.851287841796875 10.2026062011719,0.613548278808594 9.6470947265625,0.851287841796875 6.59613037109375,4.00131225585938 3.5421142578125,0.851287841796875 2.98759841918945,0.613548278808594 2.43310546875,0.851287841796875 0.768096923828125,2.5703125 0.537109375,3.14205169677734 0.768096923828125,3.71530151367188 3.82012939453125,6.86331176757813 0.768096923828125,10.0133056640625 0.537109375,10.5845413208008 0.768096923828125,11.1572875976563 2.43310546875,12.8763122558594 2.98723220825195,13.1140518188477 3.5421142578125,12.8763122558594 6.59613037109375,9.72628784179688 9.6480712890625,12.8763122558594 10.2027282714844,13.1140518188477 10.7581176757813,12.8763122558594 12.423095703125,11.1572875976563 12.6540832519531,10.5845413208008 12.423095703125,10.0133056640625 9.36907958984375,6.86331176757813z" });
                                innerDivWidth = innerDivHeight = 16;
                                svgAttribute = svgAttribute + 'margin-top:5px;margin-left:1.5px;';
                                break;
                            case "ThreeSymbolUnCircledExclamation":
                                createElement(groupElement, "path", { fill: "none", stroke: "none", d: "M0.983001708984375,7.94601440429688L1.54785919189453,10.7435569763184 3.08837127685547,13.0283813476563 5.37344741821289,14.569019317627 8.1719970703125,15.1340026855469 8.1719970703125,15.1340026855469 10.9699649810791,14.569019317627 13.2547416687012,13.0283813476563 14.7951431274414,10.7435569763184 15.3599853515625,7.94601440429688 15.3599853515625,7.94601440429688 14.7951431274414,5.14773225784302 13.2547416687012,2.86226272583008 10.9699649810791,1.32116842269897 8.1719970703125,0.756011962890625 8.1719970703125,0.756011962890625 5.37344741821289,1.32116842269897 3.08837127685547,2.86226272583008 1.54785919189453,5.14773225784302 0.983001708984375,7.94601440429688" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "none", d: "M7.59280395507813,9.60159301757813L8.71978759765625,9.60159301757813 9.00180053710938,9.60159301757813 9.12579345703125,2.8916015625 7.143798828125,2.8916015625 7.31280517578125,9.60159301757813 7.59280395507813,9.60159301757813z" });
                                createElement(groupElement, "path", { fill: fillColor, stroke: "none", d: "M8.96728515625,10.69140625L8.17428588867188,10.3753967285156 7.37130737304688,10.6924133300781 7.03228759765625,11.4764099121094 7.37530517578125,12.244384765625 8.17428588867188,12.54541015625 8.96328735351563,12.244384765625 9.310302734375,11.4764099121094 8.96728515625,10.69140625" });
                                svgAttribute = svgAttribute + 'margin-top:1px;margin-left:1px;';
                                break;
                            case "TrafficLight":
                                createElement(groupElement, "path", { fill: "black", stroke: "lightgray", d: "M3.83200073242188,1.46800231933594L2.76542282104492,1.68336224555969 1.89412689208984,2.27062797546387 1.3065185546875,3.14157843589783 1.09100341796875,4.20799255371094 1.09100341796875,4.20799255371094 1.09100341796875,13.3419952392578 1.3065185546875,14.4091548919678 1.89412689208984,15.2807502746582 2.76542282104492,15.8684692382813 3.83200073242188,16.0839996337891 3.83200073242188,16.0839996337891 12.9670104980469,16.0839996337891 14.0340003967285,15.8684692382813 14.9052505493164,15.2807502746582 15.4926300048828,14.4091548919678 15.7080078125,13.3419952392578 15.7080078125,13.3419952392578 15.7080078125,4.20799255371094 15.4926300048828,3.14157843589783 14.9052505493164,2.27062797546387 14.0340003967285,1.68336224555969 12.9670104980469,1.46800231933594 12.9670104980469,1.46800231933594 3.83200073242188,1.46800231933594z" });
                                createElement(groupElement, "path", { fill: fillColor, d: "M3.78421020507813,8.77540588378906L4.14698934555054,6.97894716262817 5.13620376586914,5.51202392578125 6.60316896438599,4.52304029464722 8.39920043945313,4.160400390625 10.1958141326904,4.52304029464722 11.6630783081055,5.51202392578125 12.6524028778076,6.97894716262817 13.0151977539063,8.77540588378906 12.6524028778076,10.5718555450439 11.6630783081055,12.0387744903564 10.1958141326904,13.027756690979 8.39920043945313,13.3903961181641 6.60316896438599,13.027756690979 5.13620376586914,12.0387744903564 4.14698934555054,10.5718555450439 3.78421020507813,8.77540588378906" });
                                innerDivWidth = innerDivHeight = 18;
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:.5px;';
                                break;
                            case "TrafficLightUnrimmed":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M15.3310852050781,8.3330078125L14.7622108459473,11.150749206543 13.2108383178711,13.4517440795898 10.9098434448242,15.003116607666 8.09210205078125,15.5719909667969 5.27377843856812,15.003116607666 2.97248458862305,13.4517440795898 1.42100191116333,11.150749206543 0.85211181640625,8.3330078125 1.42100191116333,5.51524877548218 2.97248458862305,3.2142448425293 5.27377843856812,1.66286897659302 8.09210205078125,1.093994140625 10.9098434448242,1.66286897659302 13.2108383178711,3.2142448425293 14.7622108459473,5.51524877548218 15.3310852050781,8.3330078125" });
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:.5px;';
                                break;
                            case "TriangleDash":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M13.9800109863281,7.56300354003906L0.501007080078125,7.56300354003906 0.501007080078125,4.67400360107422 13.9800109863281,4.67400360107422 13.9800109863281,7.56300354003906z" });
                                innerDivWidth = 15;
                                innerDivHeight = 9;
                                break;
                            case "TriangleDown":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M14.06201171875,0.788002014160156L7.60501098632813,7.15699768066406 1.14801025390625,0.788002014160156 14.06201171875,0.788002014160156z" });
                                innerDivWidth = 15;
                                innerDivHeight = 9;
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:.5px;';
                                break;
                            case "TriangleUp":
                                createElement(groupElement, "path", { fill: fillColor, stroke: "lightgray", d: "M0.89599609375,7.30400085449219L7.35198974609375,0.93499755859375 13.8089904785156,7.30400085449219 0.89599609375,7.30400085449219z" });
                                innerDivWidth = 15;
                                innerDivHeight = 9;
                                svgAttribute = svgAttribute + 'margin-top:3px;margin-left:.5px;';
                                break;
                        }
                        indicatorinnerDiv.css({ 'width': innerDivWidth + 'px', 'height': innerDivHeight + 'px' });
                        svgelement.setAttributeNS(null, 'style', svgAttribute);
                        svgelement.appendChild(groupElement);
                        break;
                    }
                }
                indicatorinnerDiv.append(svgelement);
                indicatorDiv.append(indicatorinnerDiv);
                gaugeDiv.append(indicatorDiv);

                var innerScaleWidth = indicatorinnerDiv.width();
                var innerScaleHeight = indicatorinnerDiv.height();
                var indidenomintaorLen = innerScaleWidth < innerScaleHeight ? innerScaleWidth : innerScaleHeight;
                scaleXy = scaleXy / indidenomintaorLen;

                if (this._browserInfo.name == 'msie') {
                    indicatorinnerDiv.css('transform', 'scale(' + scaleXy + ',' + scaleXy + ')');
                } else if (this._browserInfo.name == 'opera') {
                    indicatorinnerDiv.css('-o-transform', 'scale(' + scaleXy + ',' + scaleXy + ')');
                } else if (this._browserInfo.name == 'mozilla') {
                    indicatorinnerDiv.css('-ms-transform', 'scale(' + scaleXy + ',' + scaleXy + ')');
                } else if (this._browserInfo.name == 'webkit' || this._browserInfo.name == 'chrome') {
                    indicatorinnerDiv.css('-webkit-transform', 'scale(' + scaleXy + ',' + scaleXy + ')');
                }

                if (innerScaleWidth < innerScaleHeight) {
                    indicatorinnerDiv.css({ 'left': '50%', 'margin-left': -(innerScaleWidth / 2), 'top': '50%', 'margin-top': -(innerScaleWidth / 2) });
                } else {
                    indicatorinnerDiv.css({ 'left': '50%', 'margin-left': -(innerScaleHeight / 2), 'top': '50%', 'margin-top': -(innerScaleHeight / 2) });
                }
            }

            function createElement(root, name, attrs) {
                var element = document.createElementNS(svgNs, name);
                for (var attr in attrs) {
                    if (attrs.hasOwnProperty(attr)) {
                        element.setAttribute(attr, attrs[attr]);
                    }
                }
                root.appendChild(element);
            }
        },

        _renderGaugeLabels: function (gaugeLabels, gaugeDiv, gaugeName, parentId, printMode, printPageId) {
            var guageIndex;
            for (guageIndex = 0; guageIndex < gaugeLabels.length; guageIndex++) {
                var labelModel = gaugeLabels[guageIndex];
                var labelGaugeDiv = ej.buildTag("div", "", {}, { 'id': this._controlKeyGenerator(this._id + '_' + gaugeName + '_' + labelModel.Name, parentId, printMode, printPageId), title: labelModel.ToolTip });
                labelGaugeDiv.css({ "position": "absolute", "top": labelModel.Top, "left": labelModel.Left, "width": labelModel.length + 10, "height": labelModel.Height + 10, "background-color": labelModel.BackgroundColor, "border-color": labelModel.Style.BorderColor, "border-style": labelModel.Style.BorderStyle, "border-width": labelModel.Style.BorderWidth });
                var span = document.createElement("span");
                span.innerHTML = labelModel.Text;
                span.style.fontFamily = labelModel.Font.FontFamily;
                span.style.fontSize = labelModel.Font.FontSize;
                span.style.fontStyle = labelModel.Font.FontStyle;
                span.style.fontWeight = labelModel.Font.FontWeight;
                span.style.textAlign = labelModel.TextAlign;
                span.style.color = labelModel.TextColor;
                span.style.textDecoration = labelModel.TextDecoration;
                labelGaugeDiv.append(span);
                gaugeDiv.append(labelGaugeDiv);
            }
        },

        _renderRadialGauge: function (radialGauges, gaugeDiv, gaugeName, panelOrientation, containerWidth, containerHeight, parentId, printMode, printPageId) {
            for (var guageIndex = 0; guageIndex < radialGauges.length; guageIndex++) {
                var radialGauge = radialGauges[guageIndex];
                var radialframe = radialGauge.GaugeFrame;
                var radialGaugeDiv = ej.buildTag("div", "", {}, { 'id': this._controlKeyGenerator(this._id + '_' + gaugeName + '_' + radialGauge.Name, parentId, printMode, printPageId), title: radialGauge.ToolTip });
                gaugeDiv.append(radialGaugeDiv);
                radialGaugeDiv.ejCircularGauge();
                var resourceName = printMode ? 'PrintImage' : 'GetResource';
                if (radialframe.FrameImage) {
                    radialGaugeDiv.css("background-image", "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + radialframe.FrameImage + '&resourcetype=sfimg&isPrint=' + printMode + ")");
                }
                var circular = radialGaugeDiv.data("ejCircularGauge");
                var radialscaleobj = circular.model.scales[0];
                circular.model.scales.pop(circular.model.scales[0]);

                var radialheight = (containerWidth < containerHeight) ? (containerWidth / 2) - radialframe.FrameWidth : (containerHeight / 2) - radialframe.FrameWidth;
                circular.model.radius = radialheight;
                circular.model.width = containerWidth;
                circular.model.height = containerHeight;
                circular.model.backgroundColor = radialGauge.BackgroundColor;
                circular.model.enableAnimation = false;

                if (radialGauge.ScaleProperties && radialGauge.ScaleProperties.length > 0) {
                    var radialscaleLen = radialGauge.ScaleProperties.length;
                    for (var radialscaleIndex = 0; radialscaleIndex < radialscaleLen; radialscaleIndex++) {
                        var radialScale = radialGauge.ScaleProperties[radialscaleIndex];
                        var radialscale = $.extend(true, {}, radialscaleobj);
                        radialscale.radius = (radialheight * ((radialscaleLen - radialscaleIndex) / radialscaleLen)) - radialframe.FrameWidth;
                        radialscale.startAngle = radialScale.StartAngle + 90;
                        radialscale.sweepAngle = radialScale.SweepAngle;
                        radialscale.showRanges = true;
                        radialscale.showScaleBar = true;
                        radialscale.maximum = radialScale.Maximum;
                        radialscale.minimum = radialScale.Minimum;
                        radialscale.border.color = radialScale.BorderColor;
                        radialscale.border.width = radialScale.BorderWidth;
                        radialscale.showPointers = true;
                        radialscale.showTicks = true;
                        radialscale.showLabels = true;
                        radialscale.showIndicators = true;
                        radialscale.backgroundColor = radialScale.ScaleWidth == 0 ? "Transparent" : radialScale.BackgroundColor;
                        radialscale.shadowOffset = radialScale.ShadowOffset;

                        if (radialScale.ScaleInterval != 0) {
                            radialscale.majorIntervalValue = radialScale.ScaleInterval;
                        }
                        else {
                            radialscale.majorIntervalValue = Math.round((radialscale.maximum - radialscale.minimum) / 10);;
                            radialscale.minorIntervalValue =  Math.round(radialscale.majorIntervalValue / 4);
                        }

                        if (radialScale.RadialPointer && radialScale.RadialPointer.length > 0) {
                            var radialpointerobj = radialscale.pointers[0];
                            radialscale.pointers.pop(radialscale.pointers[0]);
                            var radialpointerLen = radialScale.RadialPointer.length;
                            for (var radialpointerIndex = 0; radialpointerIndex < radialpointerLen; radialpointerIndex++) {
                                var radialpointer = $.extend(true, {}, radialpointerobj);
                                var scalePointer = radialScale.RadialPointer[radialpointerIndex];
                                radialpointer.value = scalePointer.Value;
                                radialpointer.length = radialheight * ((radialscaleLen - radialscaleIndex) / radialscaleLen) - 30;
                                radialpointer.backgroundColor = scalePointer.BackgroundColor;
                                radialpointer.type = scalePointer.Type == "Needle" ? "needle" : "marker";
                                radialpointer.showBackNeedle = false;
                                radialpointer.width = scalePointer.Width;
                                radialpointer.border.width = scalePointer.BorderWidth;
                                radialpointer.border.color = scalePointer.BorderColor;

                                switch (scalePointer.NeedleStyle) {
                                    case "Rectangular":
                                        radialpointer.needleType = "rectangle";
                                        break;
                                    case "Arrow":
                                        radialpointer.needleType = "arrow";
                                        break;
                                    default:
                                        radialpointer.needleType = "triangle";
                                        break;
                                }

                                if (scalePointer.MarkerStyle == "wedge" || scalePointer.MarkerStyle == "triangle" || scalePointer.MarkerStyle == "circle" || scalePointer.MarkerStyle == "diamond" || scalePointer.MarkerStyle == "pentagon" || scalePointer.MarkerStyle == "trapezoid") {
                                    radialpointer.markerType = scalePointer.MarkerStyle.toLowerCase();
                                } else {
                                    radialpointer.markerType = "rectangle";
                                }

                                radialpointer.distanceFromScale = scalePointer.distanceFromScale;
                                radialscale.pointerCap.backgroundColor = scalePointer.CapBackGroundColor;
                                radialscale.pointerCap.radius = scalePointer.CapRadius / 3;
                                radialscale.pointers.push(radialpointer);
                            }
                        } else {
                            radialscale.pointers = [];
                        }

                        if (radialScale.Range && radialScale.Range.length > 0) {
                            var radialrangeobj = radialscale.ranges[0];
                            radialscale.ranges.pop(radialscale.ranges[0]);
                            var raddialrangeLen = radialScale.Range.length;
                            for (var raddialrangeIndex = 0; raddialrangeIndex < raddialrangeLen; raddialrangeIndex++) {
                                var radialrange = $.extend(true, {}, radialrangeobj);
                                var radialscaleRange = radialScale.Range[raddialrangeIndex];
                                radialrange.distanceFromScale = radialscaleRange.DistanceFromScale;
                                radialrange.backgroundColor = radialscaleRange.BackgroundColor;
                                if (radialscaleRange.EndValue == 0 && radialscaleRange.StartValue == 0) {
                                    radialrange.startValue = 70;
                                    radialrange.endValue = 100;
                                } else {
                                    radialrange.startValue = radialscaleRange.StartValue;
                                    radialrange.endValue = radialscaleRange.EndValue;
                                }
                                radialrange.startWidth = radialscaleRange.StartWidth;
                                radialrange.endWidth = radialscaleRange.EndWidth;
                                radialrange.border.color = radialscaleRange.BorderColor;
                                radialrange.border.width = radialscaleRange.BorderWidth;
                                radialscale.ranges.push(radialrange);
                            }
                        } else {
                            radialscale.ranges = [];
                        }

                        var radialtick = radialScale.TickMark;
                        var radialmajortickobj = radialscale.ticks[0];
                        var radialminortickobj = radialscale.ticks[1];
                        radialscale.ticks.pop(radialscale.ticks[0]);
                        radialscale.ticks.pop(radialscale.ticks[1]);

                        if (!radialtick.MajorTickHide) {
                            radialmajortickobj.type = "major";
                            radialmajortickobj.width = radialtick.MajorTickWidth + 1;
                            radialmajortickobj.distanceFromScale = radialtick.MajorTickDistanceFromScale;
                            radialmajortickobj.height = radialtick.MajorTickLength - 2;
                            radialmajortickobj.color = radialtick.MajorTickColor == null ? "black" : radialtick.MajorTickColor;
                            radialmajortickobj.placement = "near";
                            radialscale.ticks.push(radialmajortickobj);
                        }

                        if (!radialtick.MinorTickHide) {
                            radialminortickobj.type = "minor";
                            radialminortickobj.width = radialtick.MinorTickWidth;
                            radialminortickobj.distanceFromScale = radialtick.MinorTickDistanceFromScale;
                            radialminortickobj.height = radialtick.MinorTickLength - 1;
                            radialminortickobj.color = radialtick.MinorTickColor == null ? "black" : radialtick.MinorTickColor;
                            radialminortickobj.placement = "near";
                            radialscale.ticks.push(radialminortickobj);
                        }

                        var radiallabelValue = radialScale.Label;
                        var radialscalelabel = radialscale.labels[0];
                        radialscale.labels.pop(radialscale.labels[0]);
                        radialscalelabel.font.fontFamily = radiallabelValue.FontFamily;
                        radialscalelabel.font.size = radiallabelValue.FontSize;
                        radialscalelabel.font.fontStyle = radiallabelValue.FontStyle;
                        radialscalelabel.distanceFromScale = radiallabelValue.DistanceFromScale;
                        radialscalelabel.color = radiallabelValue.Color;
                        radialscale.labels.push(radialscalelabel);
                        radialscale.indicators = null;
                        circular.model.scales.push(radialscale);
                    }
                }
                circular.refresh();
                circular.contextEl.beginPath();
                circular.contextEl.arc((containerWidth / 2), (containerHeight / 2), radialheight, 0, 2 * Math.PI, false);
                circular.contextEl.fillStyle = "transparent";
                circular.contextEl.fill();
                circular.contextEl.lineWidth = radialframe.FrameWidth;
                circular.contextEl.strokeStyle = (radialframe.FrameColor != null) ? radialframe.FrameColor : "Transparent";
                circular.contextEl.stroke();
                circular.contextEl.closePath();

                if (printMode) {
                    radialGaugeDiv.append('<img src=' + circular.contextEl.canvas.toDataURL("image/png") + ' width=100% height=100%/>');
                    $(circular.contextEl.canvas).remove();
                }
                radialGaugeDiv.css({ 'width': containerWidth, 'height': containerHeight, 'float': panelOrientation == 'Horizontal' ? 'left' : 'top' });
            }
        },

        _renderLinearGauge: function (linearGauges, gaugeDiv, gaugeName, panelOrientation, containerWidth, containerHeight, parentId, printMode, printPageId) {
            for (var guageIndex = 0; guageIndex < linearGauges.length; guageIndex++) {
                var linearGauge = linearGauges[guageIndex];

                if (guageIndex % 2 != 0) {
                    var emptyDiv = ej.buildTag("div", "", { 'width': panelOrientation == 'Horizontal' ? '3px' : containerWidth - (frame.FrameWidth * 2), 'float': panelOrientation == 'Horizontal' ? 'left' : 'top', 'height': panelOrientation == 'Horizontal' ? containerHeight - (frame.FrameWidth * 2) : '3px' }, {});
                    gaugeDiv.append(emptyDiv);
                }

                var frame = linearGauge.GaugeFrame;
                var linearGaugeDiv = ej.buildTag("div", "", {}, { 'id': this._controlKeyGenerator(this._id + '_' + gaugeName + '_' + linearGauge.Name, parentId, printMode, printPageId), title: linearGauge.ToolTip });
                var resourceName = printMode ? 'PrintImage' : 'GetResource';
                if (frame.FrameImage) {
                    linearGaugeDiv.css("background-image", "url(" + this.model.reportServiceUrl + '/' + resourceName + '/?key=' + frame.FrameImage + '&resourcetype=sfimg&isPrint=' + printMode + ")");
                }

                gaugeDiv.append(linearGaugeDiv);
                linearGaugeDiv.ejLinearGauge();
                var linear = linearGaugeDiv.data("ejLinearGauge");

                var scaleobj = linear.model.scales[0];
                linear.model.scales.pop(linear.model.scales[0]);
                linear.model.width = containerWidth - (frame.FrameWidth * 2);
                linear.model.height = containerHeight - (frame.FrameWidth * 2);

                linear.model.enableAnimation = false;
                linear.model.backgroundColor = linearGauge.BackgroundColor;
                linear.model.orientation = linearGauge.Orientation;

                if (linearGauge.Orientation == "Horizontal") {
                    linear.model.orientation = linearGauge.Orientation;
                } else if (linearGauge.Orientation == "Vertical") {
                    linear.model.orientation = linearGauge.Orientation;
                } else {
                    if (containerWidth > containerHeight) {
                        linear.model.orientation = "Horizontal";
                    } else {
                        linear.model.orientation = "Vertical";
                    }
                }

                if (linearGauge.ScaleProperties && linearGauge.ScaleProperties.length > 0) {
                    var scaleLen = linearGauge.ScaleProperties.length;

                    for (var scaleIndex = 0; scaleIndex < scaleLen; scaleIndex++) {
                        var linearScale = linearGauge.ScaleProperties[scaleIndex];
                        var scale = $.extend(true, {}, scaleobj);
                        scale.maximum = linearScale.Maximum;
                        scale.minimum = linearScale.Minimum;
                        scale.length = linear.model.orientation == "Horizontal" ? (containerWidth / 100) * 85 : (containerHeight / 100) * 85;                         scale.border.color = linearScale.BorderColor;
                        scale.border.width = linearScale.BorderWidth;
                        scale.backgroundColor = linearScale.BackgroundColor;
                        scale.shadowOffset = linearScale.ShadowOffset;
                        scale.width = linear.model.orientation == "Vertical" ? (linear.model.width / 4) : (linear.model.height / 4);

                        if (linearScale.PointerType && linearScale.PointerType == "thermometer") {
                            scale.type = linearScale.PointerType;
                        }

                        if (linearScale.LinearPointer && linearScale.LinearPointer.length > 0) {


                            var pointerobj;
                            if (linearScale.PointerType != "thermometer") {
                                pointerobj = $.extend(true, {}, scale.markerPointers[0]);
                                scale.markerPointers.pop(scale.markerPointers[0]);
                            } else {
                                pointerobj = $.extend(true, {}, scale.barPointers[0])
                                scale.barPointers.pop(scale.barPointers[0]);
                            }
                            var pointerLen = linearScale.LinearPointer.length;
                            for (var pointerIndex = 0; pointerIndex < pointerLen; pointerIndex++) {
                                var pointer = $.extend(true, {}, pointerobj);
                                var scaleMarkerPointer = linearScale.LinearPointer[pointerIndex];
                                pointer.value = scaleMarkerPointer.MarkerValue;
                                pointer.length = scaleMarkerPointer.MarkerLength;
                                pointer.backgroundColor = scaleMarkerPointer.MarkerBackgroundColor;
                                pointer.width = scaleMarkerPointer.MarkerWidth;
                                pointer.border.width = scaleMarkerPointer.MarkerBorderWidth;
                                pointer.border.color = scaleMarkerPointer.MarkerBorderColor;
                                pointer.type = scaleMarkerPointer.MarkerStyle.toLowerCase();
                                pointer.distanceFromScale = scaleMarkerPointer.MarkerDistanceFromScale;
                                if (linearScale.PointerType != "thermometer") {
                                    scale.markerPointers.push(pointer);
                                } else {
                                    scale.showBarPointers = true;
                                    scale.barPointers.push(pointer);
                                    scale.markerPointers[pointerIndex].opacity = 0;
                                }
                            }
                        } else {
                            scale.markerPointers = [];
                            scale.barPointers = [];
                        }

                        if (linearScale.Range && linearScale.Range.length > 0) {
                            var rangeobj = $.extend(true, {}, scale.ranges[0]);
                            scale.ranges.pop(scale.ranges[0]);
                            var rangeLen = linearScale.Range.length;

                            for (var rangeIndex = 0; rangeIndex < rangeLen; rangeIndex++) {
                                var range = $.extend(true, {}, rangeobj);
                                var scaleRange = linearScale.Range[rangeIndex];

                                range.distanceFromScale = scaleRange.DistanceFromScale;
                                range.backgroundColor = scaleRange.BackgroundColor;
                                range.startValue = scaleRange.StartValue;
                                range.startWidth = scaleRange.StartWidth;
                                range.endValue = scaleRange.EndValue;
                                range.endWidth = scaleRange.EndWidth;
                                range.border.color = scaleRange.BorderColor;
                                range.border.width = scaleRange.BorderWidth;
                                scale.ranges.push(range);
                            }
                        } else {
                            scale.ranges = [];
                        }

                        var tick = linearScale.TickMark;
                        var majortickobj = scale.ticks[0];
                        var minortickobj = scale.ticks[1];
                        scale.ticks.pop(scale.ticks[0]);
                        scale.ticks.pop(scale.ticks[1]);
                        majortickobj.type = "majorInterval";
                        majortickobj.width = tick.MajorTickWidth;
                        majortickobj.height = tick.MajorTickLength / 2;
                        majortickobj.color = tick.MajorTickColor == null ? "black" : tick.MajorTickColor;
                        scale.ticks.push(majortickobj);
                        minortickobj.type = "minorInterval";
                        minortickobj.width = tick.MinorTickWidth;
                        minortickobj.height = tick.MinorTickLength * 2;
                        minortickobj.color = tick.MinorTickColor == null ? "black" : tick.MinorTickColor;
                        scale.ticks.push(minortickobj);

                        var labelValue = linearScale.Label;
                        var scalelabel = scale.labels[0];
                        scale.labels.pop(scale.labels[0]);
                        scalelabel.font.fontFamily = labelValue.LinearLabelFontFamily;
                        scalelabel.font.size = labelValue.LinearLabelFontSize;
                        scalelabel.font.fontStyle = labelValue.LinearLabelFontStyle;
                        scalelabel.distanceFromScale = labelValue.LinearLabelDistanceFromScale;
                        scalelabel.textColor = labelValue.TextColor;
                        scale.labels.push(scalelabel);

                        scale.indicators = null;
                        scale.customLabels = [];

                        linear.model.scales.push(scale);
                    }
                    linear.refresh();

                    if (printMode) {
                        linearGaugeDiv.append('<img src=' + linear.contextEl.canvas.toDataURL("image/png") + ' width=100% height=100%/>');
                        $(linear.contextEl.canvas).remove();
                    }
                    linearGaugeDiv.css({ 'width': panelOrientation == 'Horizontal' ? (containerWidth - (frame.FrameWidth * 2) - 3) : containerWidth - (frame.FrameWidth * 2), 'height': panelOrientation == 'Horizontal' ? containerHeight - (frame.FrameWidth * 2) : ((containerHeight - (frame.FrameWidth * 2)) - 3), 'float': panelOrientation == 'Horizontal' ? 'left' : 'top', 'border-color': (frame.FrameColor != null) ? frame.FrameColor : "Transparent", 'border-width': frame.FrameWidth, 'border-style': 'solid', 'background-color': linearGauge.BackgroundColor });
                }
            }
        },
        //-------------------- Render the Gauge ReportItem [start] -------------------------//

        _renderLineControl: function (lineModel, parentId, printMode, printPageId) {
            var svgNs = "http://www.w3.org/2000/svg";
            var ctrlId = this._controlKeyGenerator(this._id + '_' + lineModel.Name, parentId, printMode, printPageId);
            var linDiv = ej.buildTag("div", "", {}, { 'id': ctrlId });
            var _linDivCss = {};
            _linDivCss["position"] = 'absolute';
            _linDivCss["top"] = lineModel.Top;
            _linDivCss["left"] = lineModel.Left;
            _linDivCss["width"] = lineModel.Width == 0 ? '11.00064' : (lineModel.Width);
            _linDivCss["height"] = lineModel.Height == 0 ? '16.00128' : (lineModel.Height);
            linDiv.css(_linDivCss);

            if (this._svg) {
                var svgelement = document.createElementNS(svgNs, "svg");
                svgelement.setAttributeNS(null, 'width', lineModel.Width == 0 ? "11.00064" : (lineModel.Width));
                svgelement.setAttributeNS(null, 'height', lineModel.Height == 0 ? "16.00128" : (lineModel.Height));

                var svgtagelement = document.createElementNS(svgNs, "line");
                svgtagelement.setAttributeNS(null, "x1", lineModel.X1 == 0 ? lineModel.LineWidth : (lineModel.X1 - lineModel.LineWidth));
                svgtagelement.setAttributeNS(null, "y1", lineModel.Y1 == 0 ? lineModel.LineWidth : (lineModel.Y1 - lineModel.LineWidth));
                svgtagelement.setAttributeNS(null, "x2", lineModel.X2 == 0 ? lineModel.LineWidth : (lineModel.X2 - lineModel.LineWidth));
                svgtagelement.setAttributeNS(null, "y2", lineModel.Y2 == 0 ? lineModel.LineWidth : (lineModel.Y2 - lineModel.LineWidth));
                svgtagelement.setAttributeNS(null, "stroke", lineModel.LineColor);
                svgtagelement.setAttributeNS(null, "stroke-width", lineModel.LineWidth);
                svgtagelement.setAttributeNS(null, "shape-rendering", "crispEdges");
                if (lineModel.LineStyle == "Dashed") {
                    svgtagelement.setAttributeNS(null, "stroke-dasharray", "" + (lineModel.LineWidth * 2) + "," + (lineModel.LineWidth * 2) + "");
                } else if (lineModel.LineStyle == "Dotted") {
                    svgtagelement.setAttributeNS(null, "stroke-dasharray", lineModel.LineWidth);
                }
                svgelement.appendChild(svgtagelement);
                linDiv.append(svgelement);
            } else {
                document.namespaces.add('v', 'urn:schemas-microsoft-com:vml');
                document.createStyleSheet().cssText = 'v\\:fill, v\\:path, v\\:polyline, v\\:line, v\\:rect,v\\:shape,v\\:oval, v\\:stroke' + '{ behavior:url(#default#VML); display: inline-block; } ';

                var vmlObject = document.createElement("<v:line id='line' from='" + lineModel.X1 + ',' + lineModel.Y1 + "' to='" + lineModel.X2 + ',' + lineModel.Y2 + "' strokecolor='" + lineModel.LineColor + "' strokeweight='" + lineModel.LineWidth + "pt'>" + "<v:stroke dashstyle='dot'></v:stroke>" + "</v:line>");
                var str = document.createElement("v:stroke");
                if (lineModel.LineStyle == "Dotted") {
                    str.setAttribute("dashstyle", "dot");
                } else if (lineModel.LineStyle == "Dashed") {
                    str.setAttribute("dashstyle", "dash");
                } else {
                    str.setAttribute("dashstyle", "solid");
                }
                str.outerHTML = str.outerHTML;
                vmlObject.appendChild(str);

                vmlObject.style.position = "absolute";
                vmlObject.style.width = lineModel.Width;
                vmlObject.style.height = lineModel.Height;
                vmlObject.style.visibility = "visible";

                linDiv.append(vmlObject);
            }
            return linDiv;
        },

        _renderSubReportControl: function (subreportModel, isTablixCell, parentObj, parentId, printMode, printPageId) {
            var ctrlId = this._controlKeyGenerator(this._id + '_' + subreportModel.Name, parentId, printMode, printPageId);
            var subReportDiv = ej.buildTag("div", "", {}, { 'id': ctrlId, title: subreportModel.ToolTip });

            parentObj.append(subReportDiv);
            subReportDiv.css('position', isTablixCell ? 'relative' : 'absolute');
            subReportDiv.css('top', subreportModel.Top);
            subReportDiv.css('left', subreportModel.Left);
            subReportDiv.css('width', subreportModel.Width);
            subReportDiv.css('height', subreportModel.Height);
            subReportDiv.css('background-color', subreportModel.BackgroundColor);

            if (subreportModel.Padding) {
                if (subreportModel.Padding.Left) {
                    subReportDiv.css("padding-left", subreportModel.Padding.Left);
                }

                if (subreportModel.Padding.Right) {
                    subReportDiv.css("padding-right", subreportModel.Padding.Right);
                }

                if (subreportModel.Padding.Top) {
                    subReportDiv.css("padding-top", subreportModel.Padding.Top);
                }

                if (subreportModel.Padding.Bottom) {
                    subReportDiv.css("padding-bottom", subreportModel.Padding.Bottom);
                }
            }

            if (subreportModel.Style) {
                if (subreportModel.Style.Font) {
                    if (subreportModel.Style.Font.FontFamily) {
                        subReportDiv.css("font-family", subreportModel.Style.Font.FontFamily);
                    }

                    if (subreportModel.Style.Font.FontSize) {
                        subReportDiv.css("font-size", subreportModel.Style.Font.FontSize);
                    }

                    if (subreportModel.Style.Font.FontStyle) {
                        subReportDiv.css("font-style", subreportModel.Style.Font.FontStyle);
                    }

                    if (subreportModel.Style.Font.FontWeight) {
                        subReportDiv.css("font-weight", subreportModel.Style.Font.FontWeight);
                    }
                }

                subReportDiv.css("color", subreportModel.Style.TextColor ? subreportModel.Style.TextColor : "black");

                if (subreportModel.Style.TextDecoration) {
                    subReportDiv.css("text-decoration", subreportModel.Style.TextDecoration);
                }
            }

            if (subreportModel.LineHeight) {
                subReportDiv.css("line-height", subreportModel.LineHeight);
            }

            if (subreportModel.TextAlign) {
                subReportDiv.css("text-align", subreportModel.TextAlign);
            }

            if (subreportModel.VerticalAlign) {
                subReportDiv.css("vertical-align", subreportModel.VerticalAlign);
            }

            if (subreportModel.Border && !isTablixCell) {
                this._applyBorderStyle(subreportModel.Border, subReportDiv);
            }

            if (subreportModel.ReportItemModels && subreportModel.ReportItemModels.length > 0) {
                for (var i = 0; i < subreportModel.ReportItemModels.length; i++) {
                    var innerItem = subreportModel.ReportItemModels[i];
                    if (innerItem) {
                        if (innerItem.ItemType == "TextBoxModel") {
                            var textboxControl = this._renderTextBoxControl(innerItem, false, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                            subReportDiv.append(textboxControl);
                        } else if (innerItem.ItemType == "LineModel") {
                            var lineControl = this._renderLineControl(innerItem, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                            subReportDiv.append(lineControl);
                        } else if (innerItem.ItemType == "ImageModel") {
                            this._renderImageControl(innerItem, false, subReportDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        } else if (innerItem.ItemType == "TablixModel") {
                            this._renderTablixControl(innerItem, false, {}, subReportDiv, ctrlId + '_' + innerItem.Name, printPageId);
                        } else if (innerItem.ItemType == "GaugeModel") {
                            this._renderGaugeControl(innerItem, false, false, {}, subReportDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        } else if (innerItem.ItemType == "RectangleModel") {
                            this._renderRectangleControl(innerItem, false, subReportDiv, ctrlId + +'_' + innerItem.Name, printMode, printPageId);
                        } else if (innerItem.ItemType == "ChartModel") {
                            this._renderChartControl(innerItem, false, false, {}, subReportDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        } else if (innerItem.ItemType == "MapModel") {
                            this._renderMapControl(innerItem, false, subReportDiv, ctrlId + '_' + innerItem.Name, printMode, printPageId);
                        } else if (innerItem.ItemType == "SubReportModel") {
                            this._renderSubReportControl(innerItem, false, subReportDiv, ctrlId + +'_' + innerItem.Name, printMode, printPageId);
                        }
                    }
                }
            }
        },
        //-------------------- Render the Page ReportItems[End] -------------------------//

        //-------------------- Ajax Web API Call back methods[start] -------------------------//
        doAjaxPost: function (type, url, jsondata, onSuccess) {
            var proxy = this;
            var inVokemethod = onSuccess;
            var headerReq = [];
            var jsonArray = [];
            proxy._onAjaxRequest({ headerReq: headerReq, jsonArray: jsonArray, inVokemethod: onSuccess });
            if (jsonArray.length > 0) {
                var _jsonstring = jQuery.parseJSON(jsondata);
                for (var index = 0; index < jsonArray.length; index++) {
                    _jsonstring[jsonArray[index].Key] = jsonArray[index].Value;
                }
                jsondata = JSON.stringify(_jsonstring);
            }
            $.ajax({
                type: type,
                url: url,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsondata,
                beforeSend: function (req) {
                    if (inVokemethod == "_getPageModel" || inVokemethod == "_getPreviewModel") {
                        if (!proxy._isToolbarClick) {
                            proxy._showloadingIndicator(true);
                        } else {
                            proxy._showNavigationIndicator(true);
                        }
                    }
                    req.setRequestHeader('ejAuthenticationToken', proxy._authenticationToken);
                    if (headerReq.length > 0) {
                        for (var index = 0; index < headerReq.length; index++) {
                            req.setRequestHeader(headerReq[index].Key, headerReq[index].Value);
                        }
                    }
                    if (proxy.model.reportServerId) {
                        req.setRequestHeader('ejServerInstance', proxy.model.reportServerId);
                    }
                },
                success: function (data) {
                    if (data && typeof (data.Data) != "undefined") {
                        data = data.Data;
                    }
                    if (typeof (data) == "string") {
                        if (data.indexOf("Sf_Exception") != -1) {
                            proxy._renderExcpetion(inVokemethod + ":" + data);
                            return;
                        }
                    }
                    if (typeof (data) == "object") {
                        proxy._onAjaxSuccess(data);
                    }
                    proxy[inVokemethod](data);
                },
                error: function (msg, textStatus, errorThrown) {
                    if (inVokemethod != "_clearCurrentServerCache") {
                        if (msg.readyState == 0) {
                            return;
                        }
                        proxy._onAjaxFailure(msg);
                        alert('Exception' + msg.responseText);
                    }
                }
            });
        },

        _reportLoaded: function (reportresult) {
            if (typeof (reportresult) == "object" && reportresult.isReportLoad) {
                if (reportresult) {
                    this._reportParameters = reportresult.parameters;
                    this._reportDataSources = reportresult.dataSources;
                    this._reporDataSets = reportresult.dataSets;
                    this._machineCulture = reportresult.currentCulture;
                    this._onReportLoaded();
                    this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getDataSourceCredential, 'dataSources': this.model.dataSources, 'parameters': this.model.parameters }), "_getDataSourceCredential");
                }
                else {
                    this._renderExcpetion("Could not load the report");
                    var isError = this._onReportError({ errmsg: "Could not load the report" });
                    this._showExceptionResult(isError, "Could not load the report");
                }
            } else {
                this._renderExcpetion("Report Loaded:" + reportresult);
                var isError = this._onReportError({ errmsg: "Report Loaded:" + reportresult, innerMessage: reportresult });
                this._showExceptionResult(isError, "Report Loaded:" + reportresult);
            }
        },

        _getDataSourceCredential: function (jsondata) {
            if (ej.isNullOrUndefined(jsondata) || jsondata == "Sf_legacy") {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.updateDataSource }), "_updateDataSource");
            } else {
                this._renderCredentialBlock(jsondata);
                this._showViewerBlock(true);
            }
            this._showloadingIndicator(false);
            this._setContainerSize();
            this._showloadingIndicator(true);
        },

        _validateDSCredential: function (jsondata) {
            if (jsondata == "Sf_legacy") {
                this._showloadingIndicator(false);
                this._showViewerBlock(false);
                this._setContainerSize();
                this._showloadingIndicator(true);
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.updateDSCredential, 'datasoures': this._dataSources }), "_updateDSCredential");
                this._dataSources = null;
				this._unwiredViewClickEvent();
            }
            else {
                alert(jsondata);
            }
        },

        _updateDSCredential: function (jsondata) {
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.updateDataSource }), "_updateDataSource");
        },

        _getParameters: function (jsondata) {
            if (jsondata != "Sf_legacy") {
                var isCustomBlock = this._renderParameterBlock(jsondata);
                if (!isCustomBlock) {
                    this._showViewerBlock(true);
                    this._showloadingIndicator(false);
                    this._setContainerSize();
                    this._showloadingIndicator(true);
                    var reportParams = this._getParameterJson(jsondata, false);
                    this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.setParameters, 'parameters': reportParams }), "_setParameters");
                } else {
                    this._setContainerSize();
                    this._getDefaultParameters(jsondata);
                }
            }
            else {
                this._showParameterBlock(false);
                this._isForwardDirection = true;
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
            }
        },

        _setParameters: function (jsondata) {
            var isClick = $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcontent table:first').attr('isviewclick');
            if (typeof (jsondata) == "boolean") {
                if (jsondata == false) {
                    this._showloadingIndicator(true);
                    this._setContainerSize();
                    if (this._isDevice) {
                        this._showViewerBlock(false);
                        this._showViewerPage(true);
                        this._selectparamToolItem(false);
                    }
                    this._currentPage = 1;
                    this._clearPageCache();
                    this._isForwardDirection = true;
                    this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                } else {
                    this._showloadingIndicator(false);
                    if (isClick == 'true') {
                        this._viewReportEnableDisable(false);
                        alert('Please select the parameter values.');
                    }
                }
            }
        },

        _updateParameters: function (jsondata) {
            if (jsondata != "Sf_legacy") {
                this._updateParamElements(jsondata);
            }
        },

        _updateDataSource: function (jsondata) {
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getParameters }), "_getParameters");
        },

        _getPageModel: function (jsondata) {
            var jsData = jsondata;
            this._showNavigationIndicator(false);
            this._showloadingIndicator(false);
            this._viewReportEnableDisable(false);
            if (jsData) {
                if (jsData === 'IsDrillDown' || jsData === 'IsSorting') {
                    return;
                }
                if (jsData.isDocumentMap) {
                    this._isDocumentMap = this._isPageDocMap = jsData.isDocumentMap;
                }
                if (jsData.errmsg && jsData.errmsg.length > 0) {
                    var isError = this._onReportError({ errmsg: jsData.errmsg });
                    this._showExceptionResult(isError, jsData.errmsg);
                } else {
                    this._resetExceptionBlock();
                }
                if (jsData.pgmodel && jsData.pgmodel.PageData) {
                    this._pageModel = jsData.pgmodel;
                    if (!this._isToolbarClick) {
                        this._enableToolbarItems();
                    }
                    this._onRenderingBegin();
                    this._gotoPage(this._currentPage);
                    this._pageLayoutPage = this._currentPage;
                    this._onRenderingComplete();
                    this._refresh = false;
                    this._dataRefresh = false;
                }
                if (jsData.pgsetting) {
                    this._updatePageSetup(jsData.pgsetting);
                }
                if (this.model.enablePageVirtualization || this.model.enablePageCache) {
                    this._storePageCache(this._currentPage);
                    this._renderPages();
                }
            }
        },

        _getPreviewModel: function (jsonData) {
            this._showNavigationIndicator(false);
            this._showloadingIndicator(false);
            if (jsonData) {
                if (jsonData.isDocumentMap) {
                    this._isDocumentMap = jsonData.isDocumentMap;
                    this._isPageDocMap = this._isDocumentMap;
                    this._pageDocMapFlag = false;
                }
                if (jsonData.pgmodel && jsonData.pgmodel.PageData) {
                    this._pageModel = jsonData.pgmodel;
                    if (!this._isToolbarClick) {
                        this._selectPreviewToolItem(true);
                        this._enableToolbarItems();
                    }
                    this._gotoPage(this._currentPage);
                    this._refresh = false;
                    this._initialPageSetup(jsonData);
                }
                if (this.model.enablePageVirtualization || this.model.enablePageCache) {
                    this._storePageCache(this._currentPage);
                    this._renderPages();
                }
            }
        },

        _getPrintModel: function (jsonData) {
            if (jsonData && jsonData.PageData && jsonData.PageData.length > 0) {
                if (this.model.printOption == "None") {
                    this._renderSilentPrinting(jsonData);
                }
                else {
                    this._printReport(jsonData);
                }
            }
        },

        _documentMapModel: function (jsondata) {
            if (jsondata && jsondata.indexOf("<ul id=treeViewID>") != -1) {
                this._showDocumentMap(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.DocumentMap);
                this._containerSplit(jsondata);
            }
        },

        _drillThroughModel: function (jsondata) {
            var pageXy = { x: $('#' + this._id + '_viewerContainer').scrollLeft(), y: $('#' + this._id + '_viewerContainer').scrollTop() };
            var reportProperties = this._cloneReportViewerProperties();
            this._parents.push({ pagePos: pageXy, parentPro: reportProperties });
            this._setInitialization();
            this._authenticationToken = reportProperties._childReportAuthentication;
            this._unwireEvents();
            this._initViewer();
            this._reportLoaded(jsondata);
        },

        _gotoParentReportModel: function (jsondata) {
            this._setParentReportViewerProperties();
            var currentpgno = this._currentPage;
            this._unwireEvents();
            this._initViewer();
            this._currentPage = currentpgno;
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getParameters }), "_getParameters");
        },

        _clearCurrentServerCache: function (jsonData) {
        },
        //-------------------- Ajax Web API Call back methods[end] -------------------------//

        //-------------------- Print Actions[Start] -------------------------//
        _print: function () {
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPrintModel }), "_getPrintModel");
        },

        _printReport: function (printModel) {
            var reportModel = printModel;

            var pageHeight = reportModel.PaperHeight;
            var pageWidth = reportModel.PaperWidth;
            var headerTop = reportModel.MarginTop;
            var contentLeft = reportModel.MarginLeft;
            var links = $('head').find('link');
            var isIe9 = (this._browserInfo.name == 'msie' && (parseInt(this._browserInfo.version) <= 9.0));
            var printWind = this.model.printOption == "Default" ? window.open('', 'pint', "tabbar=no,scrollbars = yes,resizable = yes") : window.open('', '_blank');
            var pageStyle = '<style>h1 {display:block;height:0px;page-break-after:always;}@page { size:' + pageWidth + 'px ' + pageHeight + 'px; margin:0px;}@media print{ div {-webkit-print-color-adjust: exact;} #header, #footer { display:none } }</style>';
            var isCssLoad = true;

            if (printWind != null) {
                printWind.document.write('<!DOCTYPE html>');
                printWind["printDelay"] = 500;
                isCssLoad = this._onReportPrint({ printWind: printWind, isStyleLoad: true });
                var bodyTag = this._browserInfo.name === "msie" ? '<body style="width:' + pageWidth + 'px">' : '<body>';

                if (isCssLoad) {
                    var a = "";
                    links.each(function (index, obj) {
                        $(obj).attr('href', obj.href);
                        a += obj.outerHTML;
                    });
                    printWind.document.write('<html><head>' + a + pageStyle + '</head>' + bodyTag);
                }else{
				    printWind.document.write('<html><head>' + pageStyle + '</head>' + bodyTag);
				}

                for (var i = 0; i < reportModel.TotalPages; i++) {
                    var pagdata = reportModel.PageData[i];
                    if (!ej.isNullOrUndefined(pagdata)) {
                        printWind.document.write('<div style="position:relative;height:' + pageHeight + 'px;width:' + pageWidth + 'px;'+(this._browserInfo.name == 'mozilla' ? 'page-break-inside:avoid' : '' )+';">');
                        var printContent = this._renderPrintContainer(pagdata, headerTop, contentLeft, i);
                        printWind.document.write(printContent);
                        printWind.document.write('</div>');

                        if (!isIe9) {
                            printWind.document.write('<h1></h1>');
                        }
                        else if (isIe9 && (i < reportModel.TotalPages)) {
                            printWind.document.write('<h1></h1>');
                        }
                    }
                }
                var delay = (printWind.printDelay && printWind.printDelay === parseInt(printWind.printDelay, 10)) ? printWind.printDelay : 500;
                printWind.document.write('</body></html>');
                printWind.document.close();
                printWind.focus();
                setTimeout(function () {
                    if (!ej.isNullOrUndefined(printWind.window)) {
                        printWind.print();
                        setTimeout(function () { printWind.close() }, 300);
                    }
                }, delay);
            }
        },

        _renderSilentPrinting: function (printModel) {
            var reportModel = printModel;

            var pageHeight = reportModel.PaperHeight;
            var pageWidth = reportModel.PaperWidth;
            var headerTop = reportModel.MarginTop;
            var contentLeft = reportModel.MarginLeft;
            var links = $('head').find('link');
            var isIe9 = (this._browserInfo.name == 'msie' && (parseInt(this._browserInfo.version) <= 9.0));
            var pageStyle = '<style>h1 {display:block;height:0px;page-break-after:always;}@page { size:' + pageWidth + 'px ' + pageHeight + 'px; margin:0px;}@media print{ div {-webkit-print-color-adjust: exact;} #header, #footer { display:none } }</style>';

            var PrintPageIframe = $('#' + this._id + '_printPageIframe');
            if (!(PrintPageIframe.length > 0)) {
                PrintPageIframe = $('<iframe id="' + (this._id + '_printPageIframe') + '"></iframe>');
                PrintPageIframe.css({ 'height': '.0001px', 'width': '.0001px', 'backgroundColor': 'Transparent', 'border': 'none' });
                $('body').append(PrintPageIframe);
            }

            var printFrame = PrintPageIframe[0].contentWindow ? PrintPageIframe[0].contentWindow : PrintPageIframe[0].contentDocument.document ? PrintPageIframe[0].contentDocument.document : PrintPageIframe[0].contentDocument;

            if (printFrame != null) {
                printFrame.document.open();
                printFrame.document.write('<!DOCTYPE html>');
                printFrame["printDelay"] = 500;
                isCssLoad = this._onReportPrint({ printFrame: printFrame, isStyleLoad: true });
                var bodyTag = this._browserInfo.name === "msie" ? '<body style="width:' + pageWidth + 'px">' : '<body>';
				if (isCssLoad) {
                    var a = "";
                    links.each(function (index, obj) {
                        $(obj).attr('href', obj.href);
                        a += obj.outerHTML;
                    });
                    printFrame.document.write('<html><head>' + a + pageStyle + '</head>' + bodyTag);
                } else{
				    printFrame.document.write('<html><head>' + pageStyle + '</head>' + bodyTag);
				}

                for (var i = 0; i < reportModel.TotalPages; i++) {
                    var pagdata = reportModel.PageData[i];
                    if (!ej.isNullOrUndefined(pagdata)) {
                        printFrame.document.write('<div style="position:relative;height:' + pageHeight + 'px;width:' + pageWidth + 'px;' + (this._browserInfo.name == 'mozilla' ? 'page-break-inside:avoid' : '') + ';">');
                        var printContent = this._renderPrintContainer(pagdata, headerTop, contentLeft, i);
                        printFrame.document.write(printContent);
                        printFrame.document.write('</div>');

                        if (!isIe9) {
                            printFrame.document.write('<h1></h1>');
                        }
                        else if (isIe9 && (i < reportModel.TotalPages)) {
                            printFrame.document.write('<h1></h1>');
                        }
                    }
                }
                var delay = (printFrame.printDelay && printFrame.printDelay === parseInt(printFrame.printDelay, 10)) ? printFrame.printDelay : 500;
                printFrame.document.write('</body></html>');
                printFrame.document.close();
                printFrame.focus();
                setTimeout(function () {
                    if (!ej.isNullOrUndefined(printFrame.window)) {
                        printFrame.print();
                        setTimeout(function () { printFrame.window.close(); }, 300);
                    }
                }, delay);
            }
        },

        _renderPrintContainer: function (pagedata, top, left, index) {
            var oDiv = document.createElement("div");
            document.body.appendChild(oDiv);
            $(oDiv).css({ 'overflow': 'auto', 'width': '1px', 'height': '1px' });
            //$(oDiv).hide();

            var $printviewContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent' });
            $(oDiv).append($printviewContainer);

            var $printviewheaderContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent', 'width': pagedata.Width + 'px', 'height': pagedata.HeaderHeight + 'px' }, {});
            var $printviewheaderborder = ej.buildTag("div.pageHeaderBorder", "", { 'position': 'relative', 'background-color': '#FFFFFF', 'left': left, 'top': top });
            $printviewheaderborder.append($printviewheaderContainer);
            $printviewContainer.append($printviewheaderborder);

            var $printviewbodyContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent', 'width': pagedata.Width + 'px', 'height': pagedata.Height + 'px' }, {});
            var $printviewbodyborder = ej.buildTag("div.pageBodyBorder", "", { 'position': 'relative', 'background-color': '#FFFFFF', 'left': left, 'top': top });
            $printviewbodyborder.append($printviewbodyContainer);
            $printviewContainer.append($printviewbodyborder);

            var $printviewfooterContainer = ej.buildTag("div", "", { 'position': 'relative', 'background-color': 'transparent', 'width': pagedata.Width + 'px', 'height': pagedata.FooterHeight + 'px' }, {});
            var $printviewfooterborder = ej.buildTag("div.pageFooterBorder", "", { 'position': 'relative', 'background-color': '#FFFFFF', 'left': left, 'top': top });
            $printviewfooterborder.append($printviewfooterContainer);
            $printviewContainer.append($printviewfooterborder);

            if (this._printMode) {
                $printviewheaderContainer.css('overflow', 'hidden');
                $printviewfooterContainer.css('overflow', 'hidden');
            }

            if (pagedata.ReportStyleModel) {
                this._applyPageStyle($printviewContainer, pagedata.ReportStyleModel, true);
            }

            if (pagedata.HeaderStyleModel) {
                this._applyPageStyle($printviewheaderborder, pagedata.HeaderStyleModel, true);
            }

            if (pagedata.FooterStyleModel) {
                this._applyPageStyle($printviewfooterborder, pagedata.FooterStyleModel, true);
            }

            if (pagedata.BodyStyleModel) {
                this._applyPageStyle($printviewbodyborder, pagedata.BodyStyleModel, true);
            }

            if (pagedata.HeaderModel && pagedata.HeaderModel.length > 0) {
                this._renderPageControls(pagedata.HeaderModel, $printviewheaderContainer, true, 'Print' + index);
            }

            if (pagedata.FooterModel && pagedata.FooterModel.length > 0) {
                this._renderPageControls(pagedata.FooterModel, $printviewfooterContainer, true, 'Print' + index);
            }

            if (pagedata.PageModel && pagedata.PageModel.length > 0) {
                this._renderPageControls(pagedata.PageModel, $printviewbodyContainer, true, 'Print' + index);
            }

            var imageTag = $(oDiv).find('img');
            imageTag.each(function (index, obj) {
                $(obj).attr('src', obj.attributes['imgUrl'].value)
            });

            var htmlele = oDiv.innerHTML.replace(/PrintImage/g, 'GetResource');
            document.body.removeChild(oDiv);
            return htmlele;
        },

        _showPrintButton: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbar_Print').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbar_Print').parent().css("display", "none");
            }
        },
        //-------------------- Print Actions[end] -------------------------//

        //-------------------- Export Actions[Start] -------------------------//
        _exportMenuClick: function (event) {
            var exportType;
            var exportformat = $(event.target);
            if (exportformat) {
                if (exportformat.hasClass('e-pdf')) {
                    exportType = 'PDF';
                } else if (exportformat.hasClass('e-word')) {
                    exportType = 'Word_' + this.model.exportSettings.wordFormat;
                } else if (exportformat.hasClass('e-excel')) {
                    exportType = 'Excel_' + this.model.exportSettings.excelFormat;
                } else if (exportformat.hasClass('e-html')) {
                    exportType = 'Html';
                } else if (exportformat.hasClass('e-ppt')) {
                    exportType = 'PPT_' + this.model.exportSettings.pptFormat;
                }
                this._exportReport(exportType);
            }
        },

        _exportReport: function (exportType) {
            var _exportFormObj = null;
            if (exportType && exportType.length > 0) {
                var requrl = this.model.reportServiceUrl + '/PostReportAction';
                if ($('#' + this._id + '_exportForm').length > 0) {
                    var _exportForm = $('#' + this._id + '_exportForm');
                    _exportForm.attr("action", requrl);
                    $('#' + this._id + "_exportKey").val(this._authenticationToken);
                    $('#' + this._id + "_exportRes").val(exportType);
                    _exportFormObj = { exportAction: _exportForm };
                    this._onReportExport(_exportFormObj);
                    _exportForm.submit();
                } else {
                    var exportForm = document.createElement("form");
                    $(exportForm).attr({ "id": this._id + "_exportForm", "method": "post", "action": requrl, "data-ajax": "false" });

                    var exportKey = document.createElement("input");
                    $(exportKey).attr({ "type": "hidden", "id": this._id + "_exportKey", "name": "controlID", "value": this._authenticationToken });

                    var exportRes = document.createElement("input");
                    $(exportRes).attr({ "type": "hidden", "id": this._id + "_exportRes", "name": "resourcetype", "value": exportType });

                    var exportPrint = document.createElement("input");
                    $(exportPrint).attr({ "type": "hidden", "id": this._id + "_exportPrint", "name": "isPrint", "value": false });

                    var exportName = document.createElement("input");
                    $(exportName).attr({ "type": "hidden", "id": this._id + "_exportfileName", "name": "reportName", "value": "" });

                    $(exportForm).append(exportKey);
                    $(exportForm).append(exportRes);
                    $(exportForm).append(exportPrint);
                    $(exportForm).append(exportName);
                    $('body').append(exportForm);
                    $(exportForm).hide();
                    _exportFormObj = { exportAction: exportForm };
                    this._onReportExport(_exportFormObj);
                    $(exportForm).submit();
                }
            }
            $('#' + this._id + '_toolbar_exportListTip').hide();
        },

        _showExportList: function () {
            if (this.model.exportSettings.exportOptions & ej.ReportViewer.ExportOptions.Html) {
                $('#' + this._id + '_html').css('display', 'block');
            } else {
                $('#' + this._id + '_html').css('display', 'none');
            }

            if (this.model.exportSettings.exportOptions & ej.ReportViewer.ExportOptions.Word) {
                $('#' + this._id + '_word').css('display', 'block');
            } else {
                $('#' + this._id + '_word').css('display', 'none');
            }

            if (this.model.exportSettings.exportOptions & ej.ReportViewer.ExportOptions.Excel) {
                $('#' + this._id + '_xls').css('display', 'block');
            } else {
                $('#' + this._id + '_xls').css('display', 'none');
            }

            if (this.model.exportSettings.exportOptions & ej.ReportViewer.ExportOptions.Pdf) {
                $('#' + this._id + '_pdf').css('display', 'block');
            } else {
                $('#' + this._id + '_pdf').css('display', 'none');
            }

            if (this.model.exportSettings.exportOptions & ej.ReportViewer.ExportOptions.PPT) {
                $('#' + this._id + '_ppt').css('display', 'block');
            } else {
                $('#' + this._id + '_ppt').css('display', 'none');
            }
        },

        _showExportControls: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbarContainer .e-reportviewer-export').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbarContainer .e-reportviewer-export').parent().css("display", "none");
            }
        },

        _showTooltip: function () {
            var exportTooltip = $('#' + this._id + '_toolbar_exportListTip');
            if (!(exportTooltip.length > 0)) {
                exportTooltip = this._renderToolTipExport();
                $('body').append(exportTooltip);
                this._showExportList();
                this._on($('#' + this._id + '_toolbar_exportListTip .e-reportviewer-popupli'), "click", this._exportMenuClick);
            }

            if (exportTooltip.css('display') == 'block') {
                exportTooltip.css('display', 'none');
            } else {
                exportTooltip.css('display', 'block');
            }

            var exportTagHeight = $('#' + this._id + '_toolbarContainer .e-reportviewer-export').height();
            var expoTagPos = $($('#' + this._id + '_toolbarContainer .e-reportviewer-export')[0]).offset();
            exportTooltip.css({ 'top': (expoTagPos.top + exportTagHeight) - 3, 'left': (expoTagPos.left - 5) });
        },

        //-------------------- Export Actions[End] -------------------------//

        //-------------------- Page Navigation Actions[Start] -------------------------//
        _updatePageNavigation: function (pageNo, totalPage) {
            var _toolBarId = (this._isDevice) ? '_device_toolbarContainer' : '_toolbarContainer';
            if (pageNo > 1 && pageNo < totalPage) {
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotofirst').removeClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotoprevious').removeClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotonext').removeClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotolast').removeClass('e-reportviewer-disabled');
            } else if (pageNo == 1 && pageNo < totalPage) {
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotofirst').addClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotoprevious').addClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotonext').removeClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotolast').removeClass('e-reportviewer-disabled');
            } else if (pageNo == totalPage && totalPage != 1) {
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotofirst').removeClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotoprevious').removeClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotonext').addClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotolast').addClass('e-reportviewer-disabled');
            } else {
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotofirst').addClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotoprevious').addClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotonext').addClass('e-reportviewer-disabled');
                $('#' + this._id + _toolBarId + ' .e-reportviewer-gotolast').addClass('e-reportviewer-disabled');
            }
        },

        _gotoRenderPage: function () {
            this._onRenderingBegin();
            this._pageModel = this._retrievePageCache(this._currentPage);
            this._gotoPage(this._currentPage);
            this._onRenderingComplete();
            this._refresh = false;
            if (this.model.enablePageVirtualization || this.model.enablePageCache) {
                this._renderPages();
            }
        },

        _gotoFirstPage: function () {
            if (this._pageModel && this._pageModel.TotalPages) {
                if (this._pageModel.TotalPages > 0) {
                    this._currentPage = 1;
                    this._refresh = false;
                    this._isForwardDirection = true;
                    this._isSelectedPage = false;
                    if ((this.model.enablePageVirtualization || this.model.enablePageCache) && this._pageContains(this._currentPage)) {
                        this._gotoRenderPage();
                    } else {
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                    }
                }
            }
        },

        _gotoLastPage: function () {
            if (this._pageModel && this._pageModel.TotalPages) {
                if (this._pageModel.TotalPages > 0) {
                    this._currentPage = this._pageModel.TotalPages;
                    this._refresh = false;
                    this._isForwardDirection = false;
                    this._isSelectedPage = false;
                    if ((this.model.enablePageVirtualization || this.model.enablePageCache) && this._pageContains(this._currentPage)) {
                        this._gotoRenderPage();
                    } else {
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                    }
                }
            }
        },

        _gotoNextPage: function () {
            if (this._pageModel && this._pageModel.TotalPages) {
                if (this._currentPage < this._pageModel.TotalPages) {
                    this._currentPage = this._currentPage + 1;
                    this._refresh = false;
                    this._isForwardDirection = true;
                    this._isSelectedPage = false;
                    if ((this.model.enablePageVirtualization || this.model.enablePageCache) && this._pageContains(this._currentPage)) {
                        this._gotoRenderPage();
                    } else {
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                    }
                }
            }
        },

        _gotoPreviousPage: function () {
            if (this._pageModel && this._pageModel.TotalPages) {
                if (this._currentPage > 1) {
                    this._currentPage = this._currentPage - 1;
                    this._refresh = false;
                    this._isForwardDirection = false;
                    this._isSelectedPage = false;
                    if ((this.model.enablePageVirtualization || this.model.enablePageCache) && this._pageContains(this._currentPage)) {
                        this._gotoRenderPage();
                    } else {
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                    }
                }
            }
        },

        _gotoPageNo: function (pageNo) {
            if (this._pageModel && this._pageModel.TotalPages) {
                var pagenumber = parseInt(pageNo);
                if (pagenumber >= 1 && pagenumber <= this._pageModel.TotalPages && this._currentPage != pagenumber) {
                    this._currentPage = pagenumber;
                    this._refresh = false;
                    this._isForwardDirection = false;
                    this._isSelectedPage = true;
                    if ((this.model.enablePageVirtualization || this.model.enablePageCache) && this._pageContains(this._currentPage)) {
                        this._gotoRenderPage();
                    } else {
                        this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
                    }
                }
            }
        },

        _gotoPage: function (pageNo) {
            if (this._pageModel && this._pageModel.PageData && this._pageModel.PageData.length > 0) {
                var pagenumber = parseInt(pageNo);
                this._updatePageNavigation(pagenumber, this._pageModel.TotalPages);
                if (this._pageModel.TotalPages > 0 && this._pageModel.TotalPages) {
                    var _toolBarId = (this._isDevice) ? "_device_toolbarContainer" : "_toolbarContainer";
                    $('#' + this._id + _toolBarId + ' span.e-reportviewer-labelpageno').html(" / " + this._pageModel.TotalPages);
                    $('#' + this._id + '_txtpageNo').val(pagenumber);
                }

                var _ejObjects = $('#' + this._id + '_viewerContainer').find('.e-js');
                if (_ejObjects && _ejObjects.length > 0) {
                    this._destroyEJObjects(_ejObjects);
                }
                _ejObjects = null;

                var pageData = this._pageModel.PageData[0];
                this._renderPageModels(pageData);
                if (pageData) {
                    this._setPageSize(pageData.Height, pageData.Width, pageData.HeaderHeight, pageData.FooterHeight);
                }
            }
        },

        _onkeyPress: function (event) {
            if (event.keyCode == 13) {
                try {
                    var val = parseInt($(event.currentTarget).val());
                    this._gotoPageNo(val);
                } catch (err) {
                }
            }
            if (event.keyCode > 31 && (event.keyCode < 48 || event.keyCode > 57)) {
                return false;
            }
        },

        _showPageNavigationControls: function (enable) {
            if (enable) {
                $('#' + this._id + '_txtpageNo').parents(".e-reportviewer-toolbarul").css("display", "block");
            } else {
                $('#' + this._id + '_txtpageNo').parents(".e-reportviewer-toolbarul").css("display", "none");
            }
        },
        //-------------------- Page Navigation Actions[End] -------------------------//

        //-------------------- Print Page Setup [Start] -----------------------------//

        _showPrintPageSetup: function () {
            var pageSetup = $('#' + this._id + '_printPageSetup');
            var eDialog;
            if (!(pageSetup.length > 0)) {
                this._renderPrintPageSetup();
                this._bindPageSetupModel();
                $('#' + this._id + '_landscape').data('ejRadioButton').model.change = $.proxy(this._orientationChanged, this);
                $('#' + this._id + '_portrait').data('ejRadioButton').model.change = $.proxy(this._orientationChanged, this);
            } else {
                eDialog = $('#' + this._id + '_printPageSetup').data('ejDialog');
            }

            if (eDialog && eDialog.model) {
                var _isopen = eDialog.isOpen();
                if (_isopen) {
                    $('#' + this._id + '_printPageSetup').ejDialog("close");
                } else {
                    $('#' + this._id + '_printPageSetup').ejDialog("open");
                    this._bindPageSetupModel();
                }
            }

            this._enableToolbarContents(false);
        },

        _pageSettingClose: function(args){
            this._enableToolbarContents(true);
        },

        _updatePageSetup: function (_pageSetting) {
            if (!ej.isNullOrUndefined(_pageSetting)) {
                this._paperSetup.paperHeight = (this._paperSetup.paperHeight) ? this._paperSetup.paperHeight : (_pageSetting.PaperHeight / 96).toFixed(2);
                this._paperSetup.paperWidth = (this._paperSetup.paperWidth) ? this._paperSetup.paperWidth : (_pageSetting.PaperWidth / 96).toFixed(2);
                this._paperSetup.MarginTop = this._paperSetup.MarginTop && this._paperSetup.MarginTop > 0 ? this._paperSetup.MarginTop : (_pageSetting.MarginTop / 96).toFixed(2);
                this._paperSetup.MarginRight = this._paperSetup.MarginRight && this._paperSetup.MarginRight > 0 ? this._paperSetup.MarginRight : (_pageSetting.MarginRight / 96).toFixed(2);
                this._paperSetup.MarginBottom = this._paperSetup.MarginBottom && this._paperSetup.MarginBottom > 0 ? this._paperSetup.MarginBottom : (_pageSetting.MarginBottom / 96).toFixed(2);
                this._paperSetup.MarginLeft = this._paperSetup.MarginLeft && this._paperSetup.MarginLeft > 0 ? this._paperSetup.MarginLeft : (_pageSetting.MarginLeft / 96).toFixed(2);
                this._paperOrientation = parseFloat(this._paperSetup.paperHeight) < parseFloat(this._paperSetup.paperWidth) ? "Landscape" : "Portrait";
                this._paperName = (this._paperName) ? this._paperName : this._paperOrientation == "Landscape" ? this._getPaperName(this._paperSetup.paperHeight, this._paperSetup.paperWidth) : this._getPaperName(this._paperSetup.paperWidth, this._paperSetup.paperHeight);
            }
        },

        _initialPageSetup: function (jsonData) {
            if (!ej.isNullOrUndefined(jsonData.pgmodel.PaperHeight)) {
                this._paperSetup.paperHeight = (this._paperSetup.paperHeight) ? this._paperSetup.paperHeight : (jsonData.pgmodel.PaperHeight / 96).toFixed(2);
            }
            if (!ej.isNullOrUndefined(jsonData.pgmodel.PaperWidth)) {
                this._paperSetup.paperWidth = (this._paperSetup.paperWidth) ? this._paperSetup.paperWidth : (jsonData.pgmodel.PaperWidth / 96).toFixed(2);
            }
            if (!ej.isNullOrUndefined(jsonData.pgmodel.MarginTop)) {
                this._paperSetup.MarginTop = this._paperSetup.MarginTop && this._paperSetup.MarginTop > 0 ? this._paperSetup.MarginTop : (jsonData.pgmodel.MarginTop / 96).toFixed(2);
            }
            if (!ej.isNullOrUndefined(jsonData.pgmodel.MarginRight)) {
                this._paperSetup.MarginRight = this._paperSetup.MarginRight && this._paperSetup.MarginRight > 0 ? this._paperSetup.MarginRight : (jsonData.pgmodel.MarginRight / 96).toFixed(2);
            }
            if (!ej.isNullOrUndefined(jsonData.pgmodel.MarginBottom)) {
                this._paperSetup.MarginBottom = this._paperSetup.MarginBottom && this._paperSetup.MarginBottom > 0 ? this._paperSetup.MarginBottom : (jsonData.pgmodel.MarginBottom / 96).toFixed(2);
            }
            if (!ej.isNullOrUndefined(jsonData.pgmodel.MarginLeft)) {
                this._paperSetup.MarginLeft = this._paperSetup.MarginLeft && this._paperSetup.MarginLeft > 0 ? this._paperSetup.MarginLeft : (jsonData.pgmodel.MarginLeft / 96).toFixed(2);
            }
        },

        _bindPageSetupModel: function () {
            var heightNum = $('#' + this._id + '_paperHeight').data('ejNumericTextbox');
            var widthNum = $('#' + this._id + '_paperWidth').data('ejNumericTextbox');
            var marginLeft = $('#' + this._id + '_paperMarginLeft').data('ejNumericTextbox');
            var marginTop = $('#' + this._id + '_paperMarginTop').data('ejNumericTextbox');
            var marginRight = $('#' + this._id + '_paperMarginRight').data('ejNumericTextbox');
            var marginBottom = $('#' + this._id + '_paperMarginBottom').data('ejNumericTextbox');

            var paperDDL = $('#' + this._id + '_PaperSize').data("ejDropDownList");
            paperDDL.selectItemByText(this._paperName);

            heightNum.option('value', this._paperSetup.paperHeight ? this._paperSetup.paperHeight : 1);
            widthNum.option('value', this._paperSetup.paperWidth ? this._paperSetup.paperWidth : 1);
            marginTop.option('value', this._paperSetup.MarginTop);
            marginRight.option('value', this._paperSetup.MarginRight);
            marginBottom.option('value', this._paperSetup.MarginBottom);
            marginLeft.option('value', this._paperSetup.MarginLeft);

            (this._paperOrientation == "Landscape") ? $('#' + this._id + '_landscape').data('ejRadioButton').option("checked", true) : $('#' + this._id + '_portrait').data('ejRadioButton').option("checked", true);
        },

        _orientationChanged: function (event) {
            var heightNum = $('#' + this._id + '_paperHeight').data('ejNumericTextbox');
            var widthNum = $('#' + this._id + '_paperWidth').data('ejNumericTextbox');
            var marginLeft = $('#' + this._id + '_paperMarginLeft').data('ejNumericTextbox');
            var marginTop = $('#' + this._id + '_paperMarginTop').data('ejNumericTextbox');
            var marginRight = $('#' + this._id + '_paperMarginRight').data('ejNumericTextbox');
            var marginBottom = $('#' + this._id + '_paperMarginBottom').data('ejNumericTextbox');
            if (heightNum && widthNum) {
                var height = heightNum.getValue();
                var width = widthNum.getValue();

                if (this._paperName == "Custom") {
                    if ((event.model.id == this._id + '_portrait' && (height > width)) || (event.model.id == this._id + '_landscape' && (height < width))) {
                        heightNum.option('value', height);
                        widthNum.option('value', width);
                    } else {
                        heightNum.option('value', width);
                        widthNum.option('value', height);
                    }
                }
                else {
                    heightNum.option('value', width);
                    widthNum.option('value', height);
                }

                if (event.model.id == this._id + '_landscape' && event.model.checked == true) {
                    var temp1 = marginLeft.getValue();
                    marginLeft.option('value', marginTop.getValue());
                    var temp2 = marginBottom.getValue();
                    marginBottom.option('value', temp1);
                    temp1 = marginRight.getValue();
                    marginRight.option('value', temp2);
                    marginTop.option('value', temp1);
                    this._paperOrientation = ej.ReportViewer.Orientation.Landscape;
                }
                else {
                    var temp1 = marginRight.getValue();
                    marginRight.option('value', marginTop.getValue());
                    var temp2 = marginBottom.getValue();
                    marginBottom.option('value', temp1);
                    temp1 = marginLeft.getValue();
                    marginLeft.option('value', temp2);
                    marginTop.option('value', temp1);
                    this._paperOrientation = ej.ReportViewer.Orientation.Portrait;
                }
            }
        },

        _setUpChange: function (event) {
            var paperType = event.value;
            var initVal = 0;
            var heightNum = $('#' + this._id + '_paperHeight').data('ejNumericTextbox');
            var widthNum = $('#' + this._id + '_paperWidth').data('ejNumericTextbox');
            var marginLeft = $('#' + this._id + '_paperMarginLeft').data('ejNumericTextbox');
            var marginTop = $('#' + this._id + '_paperMarginTop').data('ejNumericTextbox');
            var marginRight = $('#' + this._id + '_paperMarginRight').data('ejNumericTextbox');
            var marginBottom = $('#' + this._id + '_paperMarginBottom').data('ejNumericTextbox');
            var paperSize = this._getPaperSize(paperType);

            if (paperType == "Custom") {
                if ((this._paperOrientation == "Portrait" && (paperSize.height > paperSize.width)) || (this._paperOrientation == "Landscape" && (paperSize.height < paperSize.width))) {
                    heightNum.option('value', paperSize.height);
                    widthNum.option('value', paperSize.width);
                } else {
                    heightNum.option('value', paperSize.width);
                    widthNum.option('value', paperSize.height);
                }
            }
            else if (this._paperOrientation == "Landscape") {
                heightNum.option('value', paperSize.width);
                widthNum.option('value', paperSize.height);
            }
            else {
                heightNum.option('value', paperSize.height);
                widthNum.option('value', paperSize.width);
            }

            if (!marginTop.getValue()) {
                marginTop.option('value', initVal.toFixed(2));
            }
            if (!marginRight.getValue()) {
                marginRight.option('value', initVal.toFixed(2));
            }
            if (!marginBottom.getValue()) {
                marginBottom.option('value', initVal.toFixed(2));
            }
            if (!marginLeft.getValue()) {
                marginLeft.option('value', initVal.toFixed(2));
            }
            if (paperType == "Custom") {
                heightNum.enable();
                widthNum.enable();
            } else {
                heightNum.disable();
                widthNum.disable();
            }
        },

        _getPaperName: function (width, height) {
            if (width == 11.70 && height == 16.50) {
                return "A3";
            } else if (width == 8.27 && height == 11.69) {
                return "A4";
            } else if (width == 10.12 && height == 14.33) {
                return "B4(JIS)";
            } else if (width == 7.17 && height == 10.12) {
                return "B5(JIS)";
            } else if (width == 4.13 && height == 9.50) {
                return "Envelope #10";
            } else if (width == 3.88 && height == 7.50) {
                return "Envelope Monarch";
            } else if (width == 7.25 && height == 10.50) {
                return "Executive";
            } else if (width == 8.50 && height == 14.00) {
                return "Legal";
            } else if (width == 8.50 && height == 11.00) {
                return "Letter";
            } else if (width == 11.00 && height == 17.00) {
                return "Tabloid";
            } else {
                return "Custom";
            }
        },

        _getPaperSize: function (paperType) {
            var paperSize = {};
            var height;
            var width;
            switch (paperType) {
                case "A3":
                    width = 11.70;
                    height = 16.50;
                    break;
                case "A4":
                    width = 8.27;
                    height = 11.69;
                    break;
                case "B4(JIS)":
                    width = 10.12;
                    height = 14.33;
                    break;
                case "B5(JIS)":
                    width = 7.17;
                    height = 10.12;
                    break;
                case "Envelope #10":
                    width = 4.13;
                    height = 9.50;
                    break;
                case "Envelope Monarch":
                    width = 3.88;
                    height = 7.50;
                    break;
                case "Executive":
                    width = 7.25;
                    height = 10.50;
                    break;
                case "Legal":
                    width = 8.50;
                    height = 14.00;
                    break;
                case "Letter":
                    width = 8.50;
                    height = 11.00;
                    break;
                case "Tabloid":
                    width = 11.00;
                    height = 17.00;
                    break;
                case "Custom":
                    height = $('#' + this._id + '_paperHeight').data('ejNumericTextbox').getValue();
                    width = $('#' + this._id + '_paperWidth').data('ejNumericTextbox').getValue();
                    break;
            }
            paperSize.height = height;
            paperSize.width = width;
            return paperSize;
        },

        _pageSetupSubmit: function () {
            var _paperHeight = $('#' + this._id + '_paperHeight').data('ejNumericTextbox').getValue();
            var _paperWidth = $('#' + this._id + '_paperWidth').data('ejNumericTextbox').getValue();
            var _paperMarginTop = $('#' + this._id + '_paperMarginTop').data('ejNumericTextbox').getValue();
            var _paperMarginRight = $('#' + this._id + '_paperMarginRight').data('ejNumericTextbox').getValue();
            var _paperMarginBottom = $('#' + this._id + '_paperMarginBottom').data('ejNumericTextbox').getValue();
            var _paperMarginLeft = $('#' + this._id + '_paperMarginLeft').data('ejNumericTextbox').getValue();

            this._paperSetup.paperHeight = (!ej.isNullOrUndefined(_paperHeight) ? _paperHeight : null);
            this._paperSetup.paperWidth = (!ej.isNullOrUndefined(_paperWidth) ? _paperWidth : null);
            this._paperSetup.MarginTop = (!ej.isNullOrUndefined(_paperMarginTop) ? _paperMarginTop : null);
            this._paperSetup.MarginRight = (!ej.isNullOrUndefined(_paperMarginRight) ? _paperMarginRight : null);
            this._paperSetup.MarginBottom = (!ej.isNullOrUndefined(_paperMarginBottom) ? _paperMarginBottom : null);
            this._paperSetup.MarginLeft = (!ej.isNullOrUndefined(_paperMarginLeft) ? _paperMarginLeft : null);
            var paperSizeDDl = $('#' + this._id + '_PaperSize').data('ejDropDownList');
            this._paperName = paperSizeDDl.model.value;
            this._paperOrientation = (_paperHeight < _paperWidth) ? "Landscape" : "Portrait";
            this._pageSetup = true;
            this.model.pageSettings.height = this._paperSetup.paperHeight;
            this.model.pageSettings.width = this._paperSetup.paperWidth;
            this.model.pageSettings.orientation = this._paperOrientation;
            this.model.pageSettings.paperSize = this._paperName;
            this.model.pageSettings.margins.top = this._paperSetup.MarginTop;
            this.model.pageSettings.margins.right = this._paperSetup.MarginRight;
            this.model.pageSettings.margins.bottom = this._paperSetup.MarginBottom;
            this.model.pageSettings.margins.left = this._paperSetup.MarginLeft;

            if (!ej.isNullOrUndefined(_paperHeight) && !ej.isNullOrUndefined(_paperWidth) && !ej.isNullOrUndefined(_paperMarginTop)
                && !ej.isNullOrUndefined(_paperMarginRight) && !ej.isNullOrUndefined(_paperMarginBottom) && !ej.isNullOrUndefined(_paperMarginLeft)) {
                if ((_paperMarginTop + _paperMarginBottom) >= _paperHeight || (_paperMarginLeft + _paperMarginRight) >= _paperWidth) {
                    alert('The margins are overlapped or they are off the paper.Enter a different margin size.');
                }
                else if ($('#' + this._id + '_ejtb_preview').hasClass('e-active')) {
                    if (!ej.isNullOrUndefined(this._paperSetup.paperWidth) && !ej.isNullOrUndefined(this._paperSetup.paperHeight)) {
                        this._updatePreviewLayout(!this._id._printMode, true);
                        $('#' + this._id + '_printPageSetup').ejDialog('close');
                    }
                } else {
                    $('#' + this._id + '_printPageSetup').ejDialog('close');
                }
            }
        },

        _pageSetupCancel: function (events) {
            var ejDialog = $('#' + this._id + '_printPageSetup').ejDialog('close');
        },

        //-------------------- Print Page Setup [End] -------------------------------//


        //-------------------- FitToPage[start] -------------------------//
        _showFittoPage: function (enable) {
            if (enable) {
                $('#' + this._id + '_ejtb_fittopage').parents("li.e-reportviewer-toolbarli").css("display", "block");
            } else {
                $('#' + this._id + '_ejtb_fittopage').parents("li.e-reportviewer-toolbarli").css("display", "none");
            }
        },

        _resetPage: function () {
            var pageContainerWidth = null, pageContainerHeight = null;

            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            pageViewline.css({ "width": pagecontainer.width(), "height": pagecontainer.height() });
            this._applyPageTransform(pagecontainer,this._preZoomVal, this._preZoomVal);

            if (this._browserInfo.name == 'msie' && this._browserInfo.version == 8) {
                pageContainerWidth = pagecontainer[0].getBoundingClientRect().right;
                pageContainerHeight = pagecontainer[0].getBoundingClientRect().bottom;
            }
            else {
                pageContainerWidth = pagecontainer[0].getBoundingClientRect().width;
                pageContainerHeight = pagecontainer[0].getBoundingClientRect().height;
            }
            pageViewline.css({ "width": pageContainerWidth, "height": pageContainerHeight });
        },

        _fitToPage: function (fitType) {
            var pageContainerWidth = null, pageContainerHeight = null;
            this._resetPage();
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            var w = pageViewerContainer.width();
            var h = pageViewerContainer.height();
            var pageW = pageViewline.width();
            var pageH = pageViewline.height();
            var scaleX = 1;
            var scaleY = 1;

            if (this._browserInfo.name == 'msie' && this._browserInfo.version == 8) {
                pageContainerWidth = pagecontainer[0].getBoundingClientRect().right;
                pageContainerHeight = pagecontainer[0].getBoundingClientRect().bottom;
            }
            else {
                pageContainerWidth = pagecontainer[0].getBoundingClientRect().width;
                pageContainerHeight = pagecontainer[0].getBoundingClientRect().height;
            }

            if (fitType == "fitToPage") {
                scaleX = (w - 40) / pageW * this._preZoomVal;
                scaleY = (h - 40) / pageH * this._preZoomVal;
                if (h > pageH) {
                    scaleY = this._preZoomVal;
                }

                if (w > pageW) {
                    scaleX = this._preZoomVal;
                }

                this._applyPageTransform(pagecontainer,scaleX , scaleY , fitType);
                pageViewline.css({ "width": pageContainerWidth, "height": pageContainerHeight });
            } else if (fitType == "wholepage") {
                if (h < pageH) {
                    scaleY = (h - 40) / pageH * this._preZoomVal;
                    this._applyPageTransform(pagecontainer,this._preZoomVal , scaleY , fitType);
                    scaleX = this._preZoomVal;
                    pageViewline.css({ "width": pageContainerWidth, "height": pageContainerHeight });
                }
            } else if (fitType == "fitToWidth") {
                if (w < pageW) {
                    scaleX = (w - 40) / pageW * this._preZoomVal;
                     this._applyPageTransform(pagecontainer, scaleX,this._preZoomVal, fitType);
                    scaleY = this._preZoomVal;
                    pageViewline.css({ "width": pageContainerWidth, "height": pageContainerHeight });
                }
            }
            return { scalX: scaleX, scalY: scaleY }
        },

        _selectDropDownIndex: function (index) {
            var _selectedObj = $($('#' + this._id + '_toolbar_zoomSelection_popup li')[index]);
            _selectedObj.addClass('e-active');
            $('#' + this._id + '_toolbar_zoomSelection_input').val(_selectedObj.text());
        },

        _applyDropDownVal: function (scaleXY, orientationX, isFittoPage) {
            if (isFittoPage) {
                var _maxScale = scaleXY.scalX > scaleXY.scalY ? scaleXY.scalY : scaleXY.scalX;
                $('#' + this._id + '_toolbar_zoomSelection_input').val(Math.round((_maxScale * 100)) + "%");
                $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
            }
            else if (orientationX) {
                $('#' + this._id + '_toolbar_zoomSelection_input').val(Math.round((scaleXY.scalX * 100)) + "%");
                $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
            } else {
                $('#' + this._id + '_toolbar_zoomSelection_input').val(Math.round((scaleXY.scalY * 100)) + "%");
                $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
            }
        },

        _pageFitMenuClick: function (event) {
            var pagefitTxt;
            if ($(event.target).hasClass('e-reportviewer-icon')) {
                pagefitTxt = $(event.target).attr('fitType');
            } else {
                pagefitTxt = (event.target).className;
            }
            if (pagefitTxt) {
                var _anchorWidth = $('#' + this._id + '_pageWidth');
                var spanWidth = _anchorWidth.find('span.e-reportviewer-icon');
                var _anchorHeight = $('#' + this._id + '_pageHeight');
                var spanHeight = _anchorHeight.find('span.e-reportviewer-icon');
                var pageViewerContainer = $('#' + this._id + '_viewerContainer');
                var pageViewline = $('#' + this._id + '_pageviewOuterline');
                var viewContainer = $('#' + this._id + '_pageviewContainer')
                var w = pageViewerContainer.width();
                var h = pageViewerContainer.height();
                var pageW = pageViewline.width();
                var pageH = pageViewline.height();
                var previousPageWidth = viewContainer.width();
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                var _scaleXY;
                var _pageFitType = pagefitTxt;

                switch (_pageFitType) {
                    case "FITTOPAGE":
                        _scaleXY = this._fitToPage("fitToPage");
                        this._applyDropDownVal(_scaleXY, false, true);
                        break;
                    case "PAGEWIDTH":
                    case 'e-reportviewer-popupli e-fitpagewidth':
                        if (_anchorWidth.attr('isSelect') == 'true') {
                            if (_anchorHeight.attr('isSelect') == 'true') {
                                _scaleXY = this._fitToPage("fitToPage");
                                this._applyDropDownVal(_scaleXY, false, true);
                            } else {
                                this._resetPage();
                                this._selectDropDownIndex(this._zoomLevel);
                            }
                            spanWidth.removeClass('e-reportviewer-pagefittopage');
                            spanWidth.addClass('e-reportviewer-emptyconetent');
                            _anchorWidth.attr('isSelect', 'false');
                        } else {
                            if (w > pageW) {
                                if (_anchorHeight.attr('isSelect') == 'true' && pageW != previousPageWidth) {
                                    _scaleXY = this._fitToPage("fitToWidth");
                                    this._applyDropDownVal(_scaleXY, true, false);
                                    _anchorWidth.attr('isSelect', 'true');
                                    spanWidth.addClass('e-reportviewer-pagefittopage');
                                    spanWidth.removeClass('e-reportviewer-emptyconetent');
                                    spanHeight.addClass('e-reportviewer-emptyconetent');
                                    spanHeight.removeClass('e-reportviewer-pagefittopage');
                                    _anchorHeight.attr('isSelect', 'false');
                                }
                                return;
                            }
                            if (_anchorHeight.attr('isSelect') == 'true') {
                                _scaleXY = this._fitToPage("fitToPage");
                                this._applyDropDownVal(_scaleXY, false, true);
                            } else {
                                _scaleXY = this._fitToPage("fitToWidth");
                                this._applyDropDownVal(_scaleXY, true, false);
                            }
                            _anchorWidth.attr('isSelect', 'true');
                            spanWidth.addClass('e-reportviewer-pagefittopage');
                            spanWidth.removeClass('e-reportviewer-emptyconetent');
                        }
                        break;
                    case "WHOLEPAGE":
                    case 'e-reportviewer-popupli e-fitpageheight':
                        if (_anchorHeight.attr('isSelect') == 'true') {
                            if (_anchorWidth.attr('isSelect') == 'true') {
                                _scaleXY = this._fitToPage("fitToWidth");
                                this._applyDropDownVal(_scaleXY, true, false);
                            } else {
                                this._resetPage();
                                this._selectDropDownIndex(this._zoomLevel);
                            }
                            spanHeight.addClass('e-reportviewer-emptyconetent');
                            spanHeight.removeClass('e-reportviewer-pagefittopage');
                            _anchorHeight.attr('isSelect', 'false');
                        } else {
                            if (h > pageH) {
                                return;
                            }
                            _scaleXY = this._fitToPage("fitToPage");
                            this._applyDropDownVal(_scaleXY, false, true);
                            spanHeight.addClass('e-reportviewer-pagefittopage');
                            spanHeight.removeClass('e-reportviewer-emptyconetent');
                            _anchorHeight.attr('isSelect', 'true');
                            spanWidth.removeClass('e-reportviewer-pagefittopage');
                            spanWidth.addClass('e-reportviewer-emptyconetent');
                            _anchorWidth.attr('isSelect', 'false');
                        }
                        break;
                }
                $('#' + this._id + '_toolbar_fittoPagePopup').hide();
            }
        },

        _showFitToPagetip: function () {
            var fittoPage = $('#' + this._id + '_toolbar_fittoPagePopup');
            if (!(fittoPage.length > 0)) {
                fittoPage = this._renderPageFitPopup();
                $('body').append(fittoPage);
                this._on($('#' + this._id + '_toolbar_fittoPagePopup li.e-reportviewer-popupli'), "click", this._pageFitMenuClick);
            }

            if (fittoPage.css('display') == 'block') {
                fittoPage.css('display', 'none');
            } else {
                fittoPage.css('display', 'block');
                this._renderFitopagePopup();
            }

            var exportTagHeight = $('#' + this._id + '_toolbarContainer .e-reportviewer-pagefit').height();
            var expTagPos = $($('#' + this._id + '_toolbarContainer .e-reportviewer-pagefit')[0]).offset();
            fittoPage.css({ 'top': (expTagPos.top + exportTagHeight) - 3, 'left': (expTagPos.left - 5) });
        },
        //-------------------- FitToPage[end] -------------------------//

        //-------------------- Page Zoom[start] -------------------------//
        _zoomValChange: function (sender) {
            var ejViewer = $(this.element).closest(".e-reportviewer");
            var ejViewerInstance = ejViewer.ejReportViewer("instance");
            var zoomVal = parseInt(sender.value) / 100;
            ejViewerInstance._zoomLevel = sender.itemId;
            ejViewerInstance._zoomContainer(zoomVal, false);
        },

        _zoomIn: function () {
            if (this._zoomLevel >= 6) {
                this._zoomLevel = 6;
            } else {
                this._zoomLevel++;
            }
            if (this._isDevice) {
                this._mobileLayoutZoomChange();
            } else {
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                zoomddl.selectItemsByIndices(this._zoomLevel);
            }
        },

        _zoomOut: function () {
            if (this._zoomLevel <= 0) {
                this._zoomLevel = 0;
            } else {
                this._zoomLevel--;
            }
            if (this._isDevice) {
                this._mobileLayoutZoomChange();
            } else {
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                zoomddl.selectItemsByIndices(this._zoomLevel);
            }
        },

        _mobileLayoutZoomChange: function () {
            var _zoomLevels = [0.5, 0.75, 1, 1.25, 1.5, 2, 4];
            this._zoomContainer(_zoomLevels[this._zoomLevel], false);
        },

        _zoomInContainer: function (isFactor, scaleFactor) {
            var zoomFactor = scaleFactor;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            if (isFactor) {
                this._zoomVal = this._zoomVal + zoomFactor;
            }
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            if (this.model.printMode) {
                w = w + (this._pageModel.MarginLeft + this._pageModel.MarginRight);
                h = h + (this._pageModel.MarginTop + this._pageModel.MarginBottom);
            }

            this._applyPageTransform(pagecontainer, this._zoomVal , this._zoomVal);
            pageViewline.css({ "width": w * this._zoomVal, "height": h * this._zoomVal });
        },

        _zoomOutContainer: function (isFactor, scaleFactor) {
            var zoomFactor = scaleFactor;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            if (isFactor) {
                this._zoomVal = this._zoomVal - zoomFactor;
            }
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            this._applyPageTransform(pagecontainer, this._zoomVal , this._zoomVal);
            pageViewline.css({ "width": w * this._zoomVal, "height": h * this._zoomVal });
        },

        _applyPageTransform: function (targetTag, transformX, transformY, fittype) {
            var transform = "scale(" + transformX + "," + transformY + ")";
            if (this._browserInfo.name == 'msie') {
				if (this._browserInfo.version == "8.0") {
					 targetTag.css({ 'zoom': transformX })
				}
				else {
						 targetTag.css({ '-ms-transform': transform, '-ms-transform-origin': '0 0' });
				}
                this._setZoomScrollerIE();
                var scrollContainer = $('#' + this._id + '_viewerContainer');
                switch (fittype) {
                    case 'fitToPage':
                        scrollContainer.css({ "overflow-x": "hidden", "overflow-y": "hidden" });
                        break;
                    case 'wholepage':
                        scrollContainer.css({ "overflow-y": "hidden" });
                        break;
                    case 'fitToWidth':
                        scrollContainer.css({ "overflow-x": "hidden" });
                        break;
                }
            } else if (this._browserInfo.name == 'opera') {
                targetTag.css({ '-o-transform': transform, '-o-transform-origin': '0 0' });
            }
            else if (this._browserInfo.name == 'mozilla') {
                if (this._browserInfo.version == '11.0') {
                    targetTag.css({ 'transform': transform, 'transform-origin': '0 0' });
                } else {
                    targetTag.css({ '-moz-transform': transform, '-moz-transform-origin': '0 0' });
                }
            } else if (this._browserInfo.name == 'webkit' || this._browserInfo.name == 'chrome') {
                targetTag.css({ '-webkit-transform': transform, '-webkit-transform-origin': '0 0' });
            }
        },

        _zoomContainer: function (zoomfactor, isMode) {
            this._zoomVal = zoomfactor;
            var _anchorWidth = $('#' + this._id + '_pageWidth');
            var _anchorHeight = $('#' + this._id + '_pageHeight');
            var spanWidth = _anchorWidth.find('span.e-reportviewer-icon');
            var spanHeight = _anchorHeight.find('span.e-reportviewer-icon');
            if (_anchorWidth.attr('isSelect') == 'true' || _anchorHeight.attr('isSelect') == 'true') {
                this._resetPage();
            }
            if (spanWidth) {
                spanWidth.removeClass('e-reportviewer-pagefittopage');
                spanWidth.addClass('e-reportviewer-emptyconetent');
            }
            if (spanHeight) {
                spanHeight.addClass('e-reportviewer-emptyconetent');
                spanHeight.removeClass('e-reportviewer-pagefittopage');
            }

            var scalefactor = Math.abs(this._preZoomVal - zoomfactor);
            if (scalefactor == 0) return false;
            if (this._preZoomVal > zoomfactor) {
                this._zoomOutContainer(isMode, scalefactor);
            } else {
                this._zoomInContainer(isMode, scalefactor);
            }
            this._preZoomVal = zoomfactor;
        },

        _setZoomScrollerIE: function (zoomfact) {
            if (this._browserInfo.name == 'msie') {
                if (this._pageModel && this._pageModel.PageData && this._pageModel.PageData.length > 0) {
                    var scrollContainer = $('#' + this._id + '_viewerContainer');
                    var pagdata = this._pageModel.PageData[0];
                    var pageHeight = pagdata.Height;
                    var pageWidth = pagdata.Width;

                    var headerHeight = pagdata.HeaderHeight;
                    var footerHeight = pagdata.FooterHeight;

                    var totalpageHeight = pageHeight + headerHeight + footerHeight;

                    var height = scrollContainer.height();
                    var width = scrollContainer.width();

                    totalpageHeight = totalpageHeight * zoomfact;
                    pageWidth = pageWidth * zoomfact;

                    scrollContainer.css({ "overflow": "hidden" });
                    scrollContainer.css({ "overflow-x": "Auto" });
                    scrollContainer.css({ "overflow-y": "Auto" });

                    if (totalpageHeight < height && pageWidth < width) {
                        scrollContainer.css({ "overflow-x": "hidden" });
                        scrollContainer.css({ "overflow-y": "hidden" });
                    } else if (pageWidth < width) {
                        scrollContainer.css({ "overflow-x": "hidden" });
                    } else if (totalpageHeight < height) {
                        scrollContainer.css({ "overflow-y": "hidden" });
                    }
                }
            }
        },

        _showZoomControl: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbar_zoomin').parents("li.e-reportviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_toolbar_zoomout').parents("li.e-reportviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_toolbar_zoomSelection').parents("div.e-reportviewer-ejdropdownlist").css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbar_zoomin').parents("li.e-reportviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_toolbar_zoomout').parents("li.e-reportviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_toolbar_zoomSelection').parents("div.e-reportviewer-ejdropdownlist").css("display", "none");
            }
        },
        //-------------------- Page Zoom[end] -------------------------//

        //-------------------- Refresh Report[Start] -------------------------//
        _refreshReport: function () {
            this._refresh = true;
            this._dataRefresh = true;
            this._unwireEvents();
            this._initViewer();
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getDataSourceCredential, 'dataSourceCredentials': this.model.dataSourceCredentials, 'dataSources': this.model.dataSources, 'parameters': this.model.parameters }), "_getDataSourceCredential");
        },

        _showRefreshButton: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbar_refresh').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbar_refresh').parent().css("display", "none");
            }
        },
        //-------------------- Refresh Report[End] -------------------------//

        //-------------------- Toolbar Actions[Start] -------------------------//
        _wireEvents: function () {
            if (!this.model.toolbarSettings.templateId) {
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._onkeyPress);
                this._on($('#' + this._id + '_txtpageNo'), "click ", this._onToolbarItemClick);
                this._on($('#' + this._id + '_zoomSelection'), "change", this._zoomValChange);
                this._on($('#' + this._id + '_toolbar_zoomSelection_container'), "click ", this._onToolbarItemClick);
            }

            this._on($('#' + this._id + '_viewerContainer'), "scroll", this._scrollPage);
            this._on($('#' + this._id + '_pageviewOuterContainer'), "click", this._viewerClick);
            //this._on($('#' + this._id + '_viewerContainer'), "pinchin pinchout swipeleft swiperight", this._pinchAndSwipe);
            this._on($(document), "click", this._onReporClick);


            if (this._isDevice) {
                //this._on($('#' + this._id + '_viewerContainer'), "scroll", this._scrollPage);
                //this._on($('#' + this._id + '_viewerContainer'), "scrollstop", this._containerScrollStop);
            } else {
                this._on($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-reportviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-reportviewer-tbpage'), "mouseover", this._showIconToolTip);
                this._on($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-reportviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-reportviewer-tbpage'), "mouseout", this._hideIconToolTip);
            }
        },

        _unwireEvents: function () {
            if (!this.model.toolbarSettings.templateId) {
                this._off($('#' + this._id + '_txtpageNo'), "keypress", this._onkeyPress);
                this._off($('#' + this._id + '_txtpageNo'), "click ", this._onToolbarItemClick);
                this._off($('#' + this._id + '_zoomSelection'), "change", this._zoomValChange);
                this._off($('#' + this._id + '_toolbar_zoomSelection_container'), "click ", this._onToolbarItemClick);
            }

            this._off($('#' + this._id + '_viewerContainer'), "scroll", this._scrollPage);
            this._off($('#' + this._id + '_pageviewOuterContainer'), "click", this._viewerClick);
            //this._off($('#' + this._id + '_viewerContainer'), "pinchin pinchout swipeleft swiperight", this._pinchAndSwipe);
            this._off($(document), "click", this._onReporClick);
            this._off($('#' + this._id + '_viewReportClick'), "click", this._viewReportParamsClick);
            this._off($(window), "resize", this._viewerResize);

            if (this._isDevice) {
                //this._off($('#' + this._id + '_viewerContainer'), "scroll", this._scrollPage);
                //this._off($('#' + this._id + '_viewerContainer'), "scrollstop", this._containerScrollStop);
            } else {
                this._off($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-reportviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-reportviewer-tbpage'), "mouseover", this._showIconToolTip);
                this._off($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-reportviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-reportviewer-tbpage'), "mouseout", this._hideIconToolTip);
            }
        },

        _onReporClick: function (event) {
            if (!($(event.target).hasClass('e-reportviewer-export') || $($(event.target).children()).hasClass('e-reportviewer-export'))) {
                $('#' + this._id + '_toolbar_exportListTip').css('display', 'none');
            } else {
                if ($('#' + this._id + '_toolbar_exportListTip').css('display') != "block") {
                    $('#' + this._id + '_toolbar_exportListTip').css('display', 'none');
                }
            }

            if (!($(event.target).hasClass('e-reportviewer-pagefit') || $($(event.target).children()).hasClass('e-reportviewer-pagefit'))) {
                $('#' + this._id + '_toolbar_fittoPagePopup').css('display', 'none');
            } else {
                if ($('#' + this._id + '_toolbar_fittoPagePopup').css('display') != "block") {
                    $('#' + this._id + '_toolbar_fittoPagePopup').css('display', 'none');
                }
            }

            if (this._isDevice) {
                var deviceToolBarContainer = $('#' + this._id + '_device_toolbarContainer')
                var _targetItem = event.target;

                if ((!deviceToolBarContainer.is(':visible') && $(_targetItem).hasClass('e-device-reportviewer-toolbarspan')) || $(_targetItem).closest('#' + this._id + '_device_toolbarContainer').hasClass("e-device-reportviewer-toolbarcontainer")) {
                    deviceToolBarContainer.css('display', 'block');
                    var _toolBarOffset = $('#' + this._id + '_toolbarContainer')[0].getBoundingClientRect();
                    var _deviceToolBarOffset = deviceToolBarContainer[0].getBoundingClientRect();
                    deviceToolBarContainer.css("left", _toolBarOffset.left + _toolBarOffset.width - _deviceToolBarOffset.width + "px");
                    deviceToolBarContainer.css("top", +_toolBarOffset.top + _toolBarOffset.height + "px");
                }
                else {
                    deviceToolBarContainer.css('display', 'none');
                }
            }
        },

        _onToolbarItemClick: function (event) {
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },

        _toolbarClick: function (event) {
            var clickedItem = event.target;
            if (this._isToolbarClick) {
                if (this._isPageDialogOpened()) {
                    return;
                }

                $('#' + this._id + '_rptTooltip').css('display', 'none');
                if ($(clickedItem).hasClass('e-reportviewer-toolbarli')) {
                    clickedItem = $(clickedItem).find('span');
                }
                if ($(clickedItem).hasClass("e-reportviewer-print")) {
                    this._print();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-export")) {
                    this._showTooltip();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-pagesetup")) {
                    this._showPrintPageSetup();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-gotofirst") && !($(clickedItem).hasClass("e-reportviewer-disabled"))) {
                    this._gotoFirstPage();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-gotolast") && !($(clickedItem).hasClass("e-reportviewer-disabled"))) {
                    this._gotoLastPage();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-gotonext") && !($(clickedItem).hasClass("e-reportviewer-disabled"))) {
                    this._gotoNextPage();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-gotoprevious") && !($(clickedItem).hasClass("e-reportviewer-disabled"))) {
                    this._gotoPreviousPage();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-gotoparent")) {
                    this._gotoParentReport();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-documentmap") && !this._printMode) {
                    this._documentMapClick();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-zoomin")) {
                    this._zoomIn();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-zoomout")) {
                    this._zoomOut();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-pagefit")) {
                    this._showFitToPagetip();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-preview")) {
                    this._printlayout();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-refresh")) {
                    this._refreshReport();
                }
                else if ($(clickedItem).hasClass("e-reportviewer-parameter")) {
                    this._toggleParameterBlock();
                }
            }
        },

        _showToolbar: function (enableToolbar) {
            if (enableToolbar) {
                $('#' + this._id + '_toolbarContainer').css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbarContainer').css("display", "none");
            }
        },

        _initToolbar: function () {
            this._isToolbarClick = false;

            if (!this.model.toolbarSettings.templateId) {
                if (!this._isDevice) {
                    var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                    if (this._refresh) {
                        zoomddl.selectItemsByIndices(zoomddl.model.selectedIndex);
                    } else {
                        zoomddl.selectItemsByIndices(2);
                    }
                    zoomddl.disable();

                    $('#' + this._id + '_txtpageNo').attr('disabled', 'disabled');

                    $('#' + this._id + '_toolbarContainer .e-reportviewer-gotofirst').addClass('e-reportviewer-disabled');
                    $('#' + this._id + '_toolbarContainer .e-reportviewer-gotoprevious').addClass('e-reportviewer-disabled');
                    $('#' + this._id + '_toolbarContainer .e-reportviewer-gotonext').addClass('e-reportviewer-disabled');
                    $('#' + this._id + '_toolbarContainer .e-reportviewer-gotolast').addClass('e-reportviewer-disabled');
                }
            }
        },

        _enableToolbarItems: function () {
            this._isToolbarClick = true;
            if (!this.model.toolbarSettings.templateId) {
                if (!this._isDevice) {
                    $('#' + this._id + '_txtpageNo').removeAttr('disabled');
                    $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList').enable();
                }
            }
        },

        _enableToolbarContents: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList').enable();
                $('#' + this._id + '_txtpageNo').attr('readonly', false);
            } else {
                $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList').disable();
                $('#' + this._id + '_txtpageNo').attr('readonly', true);
            }
        },

        //-------------------- Toolbar Actions[End] -------------------------//

        //-------------------- Tooltip Localization Actions[Start]------------------------//
        _showIconToolTip: function (event) {
            if ($('#' + this._id + '_rptTooltip').css('display') == 'none') {
                this._showTooltipContent(event);
            }
        },

        _hideIconToolTip: function () {
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },

        _viewpopupBlockNone: function (jqueryEement) {
            if (ej.isNullOrUndefined(jqueryEement) || jqueryEement.length == 0 || jqueryEement.css('display') != 'block') {
                return false;
            }
            return true;
        },

        _isPageDialogOpened: function () {
            var _ejPageDialog = $('#' + this._id + '_printPageSetup').data("ejDialog");
            if (!ej.isNullOrUndefined(_ejPageDialog) && _ejPageDialog.isOpen()) {
                return true;
            }
            return false;
        },

        _showTooltipContent: function (event) {
            var currentToolbarItem = event.target;
            if (this.model.toolbarSettings.showTooltip && !this._isDevice) {
                var TagPos;
                var toolTipText;
                var isShowTooltip = true;
                if ($(currentToolbarItem).hasClass('e-reportviewer-toolbarli')) {
                    currentToolbarItem = $(currentToolbarItem).find('span');
                }

                if (this._viewpopupBlockNone($('#' + this._id + '_toolbar_fittoPagePopup')) || this._viewpopupBlockNone($('#' + this._id + '_toolbar_exportListTip')) || this._isPageDialogOpened()) {
                    isShowTooltip = false;
                }

                if ($(currentToolbarItem).hasClass("e-reportviewer-print")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-print')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('print');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-export")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-export')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('export');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-gotofirst")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-gotofirst')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('first');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-gotolast")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-gotolast')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('last');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-gotonext")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-gotonext')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('next');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-gotoprevious")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-gotoprevious')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('previous');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-documentmap")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-documentmap')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('documentmap');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-zoomin")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-zoomin')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoomin');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-zoomout")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-zoomout')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoomout');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-preview")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-preview')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('preview');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-refresh")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-refresh')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('refresh');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-parameter")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-parameter')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('parameter');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-gotoparent")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-gotoparent')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('back');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-tbpage") || $(currentToolbarItem).hasClass("e-reportviewer-pagenumber") || $(currentToolbarItem).hasClass("e-reportviewer-labelpageno")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-tbpage')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('pageIndex');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-ejdropdownlist") || $(currentToolbarItem).hasClass("e-dropdownlist") || $(currentToolbarItem).hasClass("e-select") || $(currentToolbarItem).hasClass("e-down-arrow")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-ejdropdownlist')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoom');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-pagefit")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-pagefit')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('fittopage');
                }
                else if ($(currentToolbarItem).hasClass("e-reportviewer-pagesetup")) {
                    TagPos = $('#' + this._id + '_toolbarContainer .e-reportviewer-pagesetup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('pagesetup');
                }

                if (toolTipText && isShowTooltip) {
                    $('#' + this._id + '_rptTooltip_Header').html(toolTipText.header);
                    $('#' + this._id + '_rptTooltip_Content').html(toolTipText.content);
                    if (this._browserInfo.name == 'msie' && this._browserInfo.version == 8.0) {
                        $('#' + this._id + '_rptTooltip').css({ 'top': (TagPos.top + (TagPos.bottom - TagPos.top)) + 5, 'left': (TagPos.left + ((TagPos.right - TagPos.left) / 2)), 'display': 'block', 'position': 'fixed' });
                    }
                    else {
                        $('#' + this._id + '_rptTooltip').css({ 'top': (TagPos.top + TagPos.height) + 5, 'left': (TagPos.left + (TagPos.width / 2)), 'display': 'block', 'position': 'fixed' });
                    }
                }
            }
        },

        _getTootipText: function (tipType) {
            var localeObj = ej.ReportViewer.Locale[this.model.locale] ? ej.ReportViewer.Locale[this.model.locale] : ej.ReportViewer.Locale["en-us"];
            var headerTxt = '';
            var contentTxt = '';
            switch (tipType) {
                case 'print':
                    headerTxt = localeObj['toolbar']['print']['headerText'];
                    contentTxt = localeObj['toolbar']['print']['contentText'];
                    break;
                case 'export':
                    headerTxt = localeObj['toolbar']['exportformat']['headerText'];
                    contentTxt = localeObj['toolbar']['exportformat']['contentText'];
                    break;
                case 'first':
                    headerTxt = localeObj['toolbar']['first']['headerText'];
                    contentTxt = localeObj['toolbar']['first']['contentText'];
                    break;
                case 'previous':
                    headerTxt = localeObj['toolbar']['previous']['headerText'];
                    contentTxt = localeObj['toolbar']['previous']['contentText'];
                    break;
                case 'next':
                    headerTxt = localeObj['toolbar']['next']['headerText'];
                    contentTxt = localeObj['toolbar']['next']['contentText'];
                    break;
                case 'last':
                    headerTxt = localeObj['toolbar']['last']['headerText'];
                    contentTxt = localeObj['toolbar']['last']['contentText'];
                    break;
                case 'zoomin':
                    headerTxt = localeObj['toolbar']['zoomIn']['headerText'];
                    contentTxt = localeObj['toolbar']['zoomIn']['contentText'];
                    break;
                case 'zoomout':
                    headerTxt = localeObj['toolbar']['zoomOut']['headerText'];
                    contentTxt = localeObj['toolbar']['zoomOut']['contentText'];
                    break;
                case 'preview':
                    headerTxt = localeObj['toolbar']['printLayout']['headerText'];
                    contentTxt = localeObj['toolbar']['printLayout']['contentText'];
                    break;
                case 'documentmap':
                    headerTxt = localeObj['toolbar']['documentMap']['headerText'];
                    contentTxt = localeObj['toolbar']['documentMap']['contentText'];
                    break;
                case 'refresh':
                    headerTxt = localeObj['toolbar']['refresh']['headerText'];
                    contentTxt = localeObj['toolbar']['refresh']['contentText'];
                    break;
                case 'parameter':
                    headerTxt = localeObj['toolbar']['parameter']['headerText'];
                    contentTxt = localeObj['toolbar']['parameter']['contentText'];
                    break;
                case 'back':
                    headerTxt = localeObj['toolbar']['back']['headerText'];
                    contentTxt = localeObj['toolbar']['back']['contentText'];
                    break;
                case 'pageIndex':
                    headerTxt = localeObj['toolbar']['pageIndex']['headerText'];
                    contentTxt = localeObj['toolbar']['pageIndex']['contentText'];
                    break;
                case 'zoom':
                    headerTxt = localeObj['toolbar']['zoom']['headerText'];
                    contentTxt = localeObj['toolbar']['zoom']['contentText'];
                    break;
                case 'fittopage':
                    headerTxt = localeObj['toolbar']['fittopage']['headerText'];
                    contentTxt = localeObj['toolbar']['fittopage']['contentText'];
                    break;
                case 'pagesetup':
                    headerTxt = localeObj['toolbar']['pagesetup']['headerText'];
                    contentTxt = localeObj['toolbar']['pagesetup']['contentText'];
                    break;
            }
            return { header: headerTxt, content: contentTxt };
        },
        //-------------------- Tooltip Localization Actions[End]------------------------//

        //-------------------- DrillDown Actions[Start] -------------------------//
        _drillAction: function () {
            if ($._data($('.txtToggle_' + this._id).get(0), 'events') == undefined) {
                this._on($('.txtToggle_' + this._id), "click", this._drillClick);
            }
        },

        _drillClick: function (event) {
            var drillInfo = $(event.currentTarget).data('drillObj');
            if (drillInfo) {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.drillDown, 'pageindex': this._currentPage, 'toggleInfo': drillInfo, 'refresh': false, 'dataRefresh': false, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
            }
        },
        //-------------------- DrillDown Actions[End] -------------------------//

        //-------------------- Sorting Actions[Start] -------------------------//
        _sortingAction: function () {
            if ($._data($('.txtSorting_' + this._id).get(0), 'events') == undefined) {
                this._on($('.txtSorting_' + this._id), "click", this._sortingClick);
            }
        },

        _sortingClick: function (event) {
            var sortingInfo = $(event.currentTarget).data('sortingObj');
            if (sortingInfo) {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.sorting, 'pageindex': this._currentPage, 'sortingInfo': sortingInfo, 'refresh': false, 'dataRefresh': false, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
            }
        },
        //-------------------- Sorting Actions[End] -------------------------//

        //-------------------- Document Map Actions[Start]----------------------//
        _showDocumentMap: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-documentmap').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-documentmap').parent().css("display", "none");
            }
        },

        _appendDocumentMapDiv: function () {
            if (this._isDevice) {
                var documentMapDiv = $('#' + this._id + '_documentmapContainer');
                if (documentMapDiv.length == 0) {
                    documentMapDiv = ej.buildTag("div.e-reportviewer-documentmappopup", "", { 'display': 'none' }, { id: this._id + '_documentmapContainer' });
                    $('body').append(documentMapDiv);
                }
            }
        },

        _selectDocMapToolItem: function (enable) {
            if (!this.model.toolbarSettings.templateId) {
                var _ejToolbar = $('#' + this._id + '_toolbarContainer').data("ejToolbar");
                if (enable) {
                    _ejToolbar.selectItemByID(this._id + '_ejtb_documentmap');
                } else {
                    _ejToolbar.deselectItemByID(this._id + '_ejtb_documentmap');
                }
            }
        },

        _documentMapClick: function () {
            if (!this._isDevice) {
                var ejSplitterCtrl = $('#' + this._id + '_reportviewerContainer').data('ejSplitter');
                if ($(ejSplitterCtrl.panes[0]).hasClass('collapsed')) {
                    this._pageDocMapFlag = true;
                    ejSplitterCtrl.expand(0);
                    this._selectDocMapToolItem(true);
                } else {
                    this._pageDocMapFlag = false;
                    ejSplitterCtrl.collapse(0);
                    this._selectDocMapToolItem(false);
                }
            } else {
                var documentMapDiv = $('#' + this._id + '_documentmapContainer');
                if (documentMapDiv.css('display') == 'block') {
                    this._pageDocMapFlag = true;
                    documentMapDiv.css('display', 'none');
                    this._selectDocMapToolItem(false);
                } else {
                    this._pageDocMapFlag = false;
                    documentMapDiv.css('display', 'block');
                    this._selectDocMapToolItem(true);
                }
            }
        },

        _showDocumentMapContainer: function (enable) {
            if (!this._isDevice) {
                var ejSplitterCtrl = $('#' + this._id + '_reportviewerContainer').data('ejSplitter');
                if (enable) {
                    ejSplitterCtrl.expand(0);
                } else {
                    ejSplitterCtrl.collapse(0);
                }
            } else {
                if (enable) {
                    $('#' + this._id + '_documentmapContainer').css('display', 'block');
                } else {
                    $('#' + this._id + '_documentmapContainer').css('display', 'none');
                }
            }
        },

        _documentMapAction: function () {
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.documentMap }), "_documentMapModel");
        },

        _containerSplit: function (jsondocmap) {
            var viewerContainer = $('#' + this._id + '_viewerContainer');
            this._appendDocumentMapDiv();
            jsondocmap = jsondocmap.replace("treeViewID", this._id + '_ejtreeView');
            $('#' + this._id + '_documentmapContainer').css("height", "100%");
            $('#' + this._id + '_documentmapContainer').html(jsondocmap);
            $('#' + this._id + '_ejtreeView').css("display", "none");
            $('#' + this._id + '_ejtreeView').ejTreeView({ height: viewerContainer.height(), nodeSelect: this._pageNavigate });

            if (this._isDevice) {
                $('#' + this._id + '_documentmapContainer').css({ 'position': 'absolute', 'left': viewerContainer.offset().left, 'top': viewerContainer.offset().top, 'height': viewerContainer.height(), 'width': viewerContainer.width() / 6 });
            } else {
                $('#' + this._id + '_reportviewerContainer').ejSplitter({ height: viewerContainer.height() + 1, orientation: ej.Orientation.Horizontal, properties: [{ paneSize: 140 }, {}] });
            }
            $('#' + this._id + '_ejtreeView').css("display", "block");
            this._selectDocMapToolItem(true);
        },

        _pageNavigate: function (args) {
            try {
                var jsondata = JSON.parse($(args.currentElement).attr('id'));
                var ejviewerCtrlId = this._id.replace('_ejtreeView', '');
                var ejReportViewer = $('#' + ejviewerCtrlId).data('ejReportViewer');
                if (ejReportViewer._isDevice) {
                    $('#' + ejviewerCtrlId + '_documentmapContainer').css('display', 'none');
                    this._selectDocMapToolItem(false);
                }
                ejReportViewer._gotoPageNo(jsondata.PageNo);
                $('#' + ejviewerCtrlId + '_viewerContainer').animate({ scrollTop: jsondata.TopPos - 12, scrollLeft: jsondata.LeftPos - 12 }, "600");
            } catch (err) {
            }
        },
        //-------------------- Document Map Actions[End]------------------------//

        //-------------------- DrillThrough Actions[Start]----------------------//
        _showDrillThrough: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-gotoparent').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-gotoparent').parent().css("display", "none");
            }
        },

        _drillThroughAction: function () {
            if ($._data($('.drillAction_' + this._id).get(0), 'events') == undefined) {
                this._on($('.drillAction_' + this._id), "click", this._drillThroughClick);
            }
        },

        _drillThroughClick: function (event) {
            var drillActionInfo = null;
            var proxy = null;
            if (this.pluginName == 'ejChart') {
                proxy = $('#' + this.ejreportid).data('ejReportViewer');
                $('#' + this._id + '_svg_TrackToolTip').css('display', 'none');
                var chartActionInfo = $('#' + this._id).data(this._id + 'actionObj_Series' + event.data.region.SeriesIndex);
                if (ej.isNullOrUndefined(chartActionInfo)) {
                    return false;
                }
                drillActionInfo = chartActionInfo[event.data.region.Region.PointIndex];
            } else if (this.pluginName == 'ejMap') {
                proxy = $('#' + this.ejreportid).data('ejReportViewer');
                if (event.originalEvent[0] == null || ej.isNullOrUndefined(event.originalEvent[0].data)) {
                    return;
                }
                drillActionInfo = event.originalEvent[0].data.ShapeActionInfo;
            } else {
                proxy = this;
                drillActionInfo = $(event.currentTarget).data('actionObj');
            }

            if (drillActionInfo) {
                var actionInfo = { actionInfo: $.extend(true, {}, drillActionInfo) };
                var isDrill = proxy._onDrillThrough(actionInfo);
                if (!isDrill) {
                    if (drillActionInfo.Hyperlink) {
                        window.open(drillActionInfo.Hyperlink);
                    } else if (drillActionInfo.ReportName) {
                        var _actionInfo = actionInfo.actionInfo;
                        proxy._childReportAuthentication = proxy._getAuthenticationToken();
                        proxy._showloadingIndicator(true);
                        proxy.doAjaxPost("POST", proxy._actionUrl, JSON.stringify({ 'reportAction': proxy._reportAction.drillThrough, 'reportName': _actionInfo.ReportName, 'parameters': _actionInfo.Parameters, 'authKey': proxy._childReportAuthentication }), "_drillThroughModel");
                    }
                }
            }
        },

        _gotoParentReport: function () {
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.clearCache }), '_gotoParentReportModel');
        },

        _setInitialization: function () {
            this._dataSources = null;
            this._authenticationToken = null;
            this._childReportAuthentication = null;
            this._refresh = false;
            this._isToolbarClick = false;
            this._pageModel = null;
            this._currentPage = 1;
            this._reportParameters = null;
            this._reportDataSources = null;
            this._reporDataSets = null;
            this._zoomLevel = 2;
            this._isDocumentMap = false;
        },

        _cloneReportViewerProperties: function () {
            var reportProperties = {};
            reportProperties.model = $.extend(true, {}, this.model);
            reportProperties._dataSources = $.extend(true, {}, this._dataSources);
            reportProperties._authenticationToken = this._authenticationToken;
            reportProperties._childReportAuthentication = this._childReportAuthentication;
            reportProperties._refresh = this._refresh;
            reportProperties._isToolbarClick = this._isToolbarClick;
            reportProperties._pageModel = $.extend(true, {}, this._pageModel);
            reportProperties._currentPage = this._currentPage;
            reportProperties._reportParameters = $.extend(true, {}, this._reportParameters);
            reportProperties._reportDataSources = $.extend(true, {}, this._reportDataSources);
            reportProperties._reporDataSets = $.extend(true, {}, this._reporDataSets);
            reportProperties._zoomLevel = this._zoomLevel;
            reportProperties._preZoomVal = this._preZoomVal;
            reportProperties._isDevice = this._isDevice;
            reportProperties._originX = this._originX;
            reportProperties._originY = this._originY;
            reportProperties._printMode = this._printMode;
            reportProperties._pageSetup = this._pageSetup;
            reportProperties._isDocumentMap = this._isDocumentMap;
            return reportProperties;
        },

        _setParentReportViewerProperties: function () {
            var parentObj = this._parents[this._parents.length - 1];
            var parentProperties = parentObj.parentPro;
            this.model = parentProperties.model;
            this._dataSources = parentProperties._dataSources;
            this._authenticationToken = parentProperties._authenticationToken;
            this._childReportauthentication = parentProperties._childReportAuthentication;
            this._refresh = parentProperties._refresh;
            this._isToolbarClick = parentProperties._isToolbarClick;
            this._pageModel = parentProperties._pageModel;
            this._currentPage = parentProperties._currentPage;
            this._reportParameters = parentProperties._reportParameters;
            this._reportDataSources = parentProperties._reportDataSources;
            this._reporDataSets = parentProperties._reporDataSets;
            this._zoomLevel = parentProperties._zoomLevel;
            this._isDocumentMap = parentProperties._isDocumentMap;
            this._preZoomVal = parentProperties._preZoomVal;
            this._printMode = parentProperties._printMode;
            this._originX = parentProperties._originX;
            this._originY = parentProperties._originY;
            this._parentPageXY = parentObj.pagePos;
            this._parents.pop();
        },
        //-------------------- DrillThrough Actions[End]----------------------//

        //-------------------- Print Preview Layout[Start]----------------------//
        _printlayout: function () {
            this._updatePreviewLayout(!this._printMode, this._pageSetup);
        },

        _selectPreviewToolItem: function (enable) {
            if (!this.model.toolbarSettings.templateId) {
                var _ejToolbar = $('#' + this._id + '_toolbarContainer').data("ejToolbar");
                if (enable) {
                    _ejToolbar.selectItemByID(this._id + '_ejtb_preview');
                } else {
                    _ejToolbar.deselectItemByID(this._id + '_ejtb_preview');
                }
            }
        },

        _updatePreviewLayout: function (isPrintMode, isPageSetup) {
            this._printMode = isPrintMode;
            this._isSelectedPage = false;
            if (this._printMode) {
                this._currentPage = 1;
                this._pageLayoutPage = this._currentPage;
            } else {
                this._currentPage = this._pageLayoutPage;
            }

            this._selectPreviewToolItem(this._printMode);

            if (this._isPageDocMap && !this._isDocumentMap) {
                this._showDocumentMapContainer(this._printMode ? false : this._pageDocMapFlag);
            }
            this.model.printMode = this._printMode;
            if (isPageSetup) {
                var paperType = $('#' + this._id + '_PaperSize').data("ejDropDownList");
                var paperDimension = this._getPaperSize(paperType.model.value);
                var landscape = $('#' + this._id + '_landscape').data('ejRadioButton');
                var portrait = $('#' + this._id + '_portrait').data('ejRadioButton');

                if (paperType.model.value == "Custom") {
                    if ((this._paperOrientation == "Portrait" && (paperDimension.height > paperDimension.width)) || (this._paperOrientation == "Landscape" && (paperDimension.height < paperDimension.width))) {
                        this._paperSetup.paperHeight = paperDimension.height;
                        this._paperSetup.paperWidth = paperDimension.width;
                    } else {
                        this._paperSetup.paperHeight = paperDimension.width;
                        this._paperSetup.paperWidth = paperDimension.height;
                    }
                }
                else if (this._paperOrientation == "Landscape") {
                    this._paperSetup.paperHeight = paperDimension.width;
                    this._paperSetup.paperWidth = paperDimension.height;
                }
                else {
                    this._paperSetup.paperHeight = paperDimension.height;
                    this._paperSetup.paperWidth = paperDimension.width;
                }
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode, 'PageSetup': this._paperSetup }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
            } else {
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'dataRefresh': this._dataRefresh, 'pageindex': this._currentPage, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), !this._printMode ? "_getPageModel" : "_getPreviewModel");
            }
        },

        _showPreviewButton: function (enable) {
            if (enable) {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-preview').parent().css("display", "block");
            }
            else {
                $('#' + this._id + '_toolbarContainer').find('.e-reportviewer-preview').parent().css("display", "none");
            }
        },
        //-------------------- Print Preview Layput[End]----------------------//

        //-------------------- SetCulture Layput[Start]----------------------//
        _setCultureInfo: function () {
            var culture = this.model.locale;
            var spanTagWidth = $('#' + this._id + 'Pagewidthspan');
            var spanTagHeight = $('#' + this._id + 'pageheightSpan');
            var _pageWidth = $('#' + this._id + '_pageWidth');
            var _pageHeight = $('#' + this._id + '_pageHeight');
            $('#' + this._id + '_viewReportClick').val(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]["viewButton"] : ej.ReportViewer.Locale["en-US"]["viewButton"]);
            $('#' + this._id + '_pdf').html(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['exportformat']["Pdf"] : ej.ReportViewer.Locale["en-US"]['toolbar']['exportformat']["Pdf"]);
            $('#' + this._id + '_xls').html(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['exportformat']["Excel"] : ej.ReportViewer.Locale["en-US"]['toolbar']['exportformat']["Excel"]);
            $('#' + this._id + '_word').html(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['exportformat']["Word"] : ej.ReportViewer.Locale["en-US"]['toolbar']['exportformat']["Word"]);
            $('#' + this._id + '_html').html(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['exportformat']["Html"] : ej.ReportViewer.Locale["en-US"]['toolbar']['exportformat']["Html"]);
            $('#' + this._id + '_ppt').html(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['exportformat']["PPT"] : ej.ReportViewer.Locale["en-US"]['toolbar']['exportformat']["PPT"]);

            var pagesetupDialog = $('#' + this._id + '_printPageSetup').data("ejDialog");
            if (pagesetupDialog) {
                pagesetupDialog.setTitle(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['pagesetup']['headerText'] : ej.ReportViewer.Locale["en-US"]['toolbar']['pagesetup']['headerText'] );
            }

            $('#' + this._id + '_Submit').val(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['pagesetupDialog']['doneButton'] : ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['doneButton']);
            $('#' + this._id + '_Cancel').val(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['pagesetupDialog']['cancelButton'] : ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['cancelButton']);

            $('#' + this._id + "_heightLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['height'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['height'] + '&nbsp;'));
            $('#' + this._id + "_widthLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['width'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['width'] + '&nbsp;'));
            $('#' + this._id + "_topLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['top'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['top'] + '&nbsp;'));
            $('#' + this._id + "_bottomLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['bottom'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['bottom'] + '&nbsp;'));
            $('#' + this._id + "_rightLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['right'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['right'] + '&nbsp;'));
            $('#' + this._id + "_leftLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['left'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['left'] + '&nbsp;'));
            $('#' + this._id + "_heightUnitLabel", '#' + this._id + "_widthUnitLabel", '#' + this._id + "_topUnitLabel", '#' + this._id + "_rightUnitLabel", '#' + this._id + "_bottomUnitLabel", '#' + this._id + "_leftUnitLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['unit'] + '&nbsp;') : (ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['unit'] + '&nbsp;'));

            $('#' + this._id + "_portraitLabel").html(ej.ReportViewer.Locale[culture] ? ('&nbsp;' + ej.ReportViewer.Locale[culture]['pagesetupDialog']['portrait']) : ('&nbsp;' + ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['portrait']));
            $('#' + this._id + "_landscapeLabel").html(ej.ReportViewer.Locale[culture] ? ('&nbsp;' + ej.ReportViewer.Locale[culture]['pagesetupDialog']['landscape']) : ('&nbsp;' + ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['landscape']));

            $('#' + this._id + "_paperSizeLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['paperSize']) : ('&nbsp;' + ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['paperSize']));
            $('#' + this._id + "_marginheader").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['margins']) : ('&nbsp;' + ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['margins']));
            $('#' + this._id + "_orientationLabel").html(ej.ReportViewer.Locale[culture] ? (ej.ReportViewer.Locale[culture]['pagesetupDialog']['orientation']) : ('&nbsp;' + ej.ReportViewer.Locale["en-US"]['pagesetupDialog']['orientation']));
            _pageWidth.html(spanTagWidth);
            _pageWidth.append(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['fittopage']["pageWidth"] : ej.ReportViewer.Locale["en-US"]['toolbar']['fittopage']["pageWidth"]);
            _pageHeight.html(spanTagHeight);
            _pageHeight.append(ej.ReportViewer.Locale[culture] ? ej.ReportViewer.Locale[culture]['toolbar']['fittopage']["pageHeight"] : ej.ReportViewer.Locale["en-US"]['toolbar']['fittopage']["pageHeight"]);

            var _dateTimePicker = $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').find('.e-reportviewer-DateTime');
            if (_dateTimePicker && _dateTimePicker.length > 0) {
                for (var i = 0; i < _dateTimePicker.length; i++) {
                    $('#' + $(_dateTimePicker[i]).attr('id')).data('ejDatePicker').setModel({ 'locale': this.model.locale });
                }
            }
        },
        //-------------------- SetCulture Layput[End]----------------------//

        //-------------------- ReportViewer PageVirtualization[start]----------------------//
        _renderPages: function () {
            if (this.model.enablePageVirtualization || this.model.enablePageCache) {
                var pages = !(this._printMode) ? this._pageCache : this._printPageCache;
                if (pages.length - 1 < this._pageModel.TotalPages) {
                    for (var index = this._currentPage + 1; index <= this._pageModel.TotalPages; index++) {
                        pages[index] = null;
                    }
                }
                _pageNos = [];
                var startIndex = (this._isForwardDirection) ? this._currentPage + 1 : this._currentPage - 1;
                if (!this._isSelectedPage) {
                    for (var index = startIndex; index <= this._pageModel.TotalPages && index > 1; (this._isForwardDirection) ? index++ : index--) {
                        if (pages[index] == null) {
                            if (typeof pages[index] != 'undefined') {
                                _pageNos.push(index);
                            }
                            if (_pageNos.length == 3) {
                                break;
                            }
                        }
                    }
                } else {
                    for (var index = startIndex; index <= this._pageModel.TotalPages; (this._isForwardDirection) ? index++ : index--) {
                        if (pages[index] == null && typeof pages[index] != 'undefined') {
                            _pageNos.push(index);
                            if (_pageNos.length == 2) {
                                index = (index > this._currentPage) ? index : this._currentPage;
                                this._isForwardDirection = true;
                            }
                            if (_pageNos.length == 4) {
                                break;
                            }
                        } else if (typeof pages[index] == 'undefined') {
                            index = this._currentPage;
                            this._isForwardDirection = true;
                        }
                    }
                }
                this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.getPageModel, 'refresh': this._refresh, 'pageVirtualization': this.model.enablePageVirtualization, 'dataRefresh': this._dataRefresh, 'pageNumbers': _pageNos, 'pageInit': this._isToolbarClick, 'isPrint': this._printMode }), "_getRenderedPages");
            }
        },

        _getRenderedPages: function (jsPageData) {
            if (jsPageData.pgmodel.length > 0) {
                for (var pageIndex = 0; pageIndex < jsPageData.pgmodel.length; pageIndex++) {
                    if (jsPageData.pgmodel[pageIndex] && jsPageData.pgmodel[pageIndex].Value.PageData) {
                        this._pageModel = jsPageData.pgmodel[pageIndex].Value;
                        this._storePageCache(jsPageData.pgmodel[pageIndex].Key);
                    }
                }
            }
        },

        //-------------------- ReportViewer PageVirtualization[end]----------------------//

        //-------------------- ReportViewer Page Cache[start]----------------------//
        _storePageCache: function (key) {
            if (this._pageModel && this._pageModel.PageData && this._pageModel.PageData.length > 0) {
                if (!this._pageContains(key)) {
                    if (this.model.enablePageVirtualization || this.model.enablePageCache) {
                        !(this._printMode) ? this._pageCache[key] = this._pageModel : this._printPageCache[key] = this._pageModel;
                    }
                }
            }
        },

        _retrievePageCache: function (key) {
            return !(this._printMode) ? this._pageCache[key] : this._printPageCache[key];
        },

        _pageContains: function (key) {
            var _page = !(this._printMode) ? this._pageCache[key] : this._printPageCache[key];
            return !ej.isNullOrUndefined(_page);
        },

        _clearPageCache: function () {
            this._pageCache = [];
            this._printPageCache = [];
        },
        //-------------------- ReportViewer Page Cache[end]----------------------//

        //-------------------- Common ReportViewer events & utils[start]----------------------//
        _itemfadeToggle: function (targetTag) {
            targetTag.fadeToggle();
        },

        _popupClick: function (event) {
            var pagePopup = $('#' + this._id + '_pageInfoPopup');
            pagePopup.fadeIn();
            pagePopup.finish();
        },

        _containerScrollStop: function (event) {
            var pagePopup = $('#' + this._id + '_pageInfoPopup');
            pagePopup.finish().fadeIn();
            pagePopup.finish().fadeOut(3000);
        },

        _viewerClick: function (event) {
            //if (this._isDevice) {
            //    var pagePopup = $('#' + this._id + '_pageInfoPopup');
            //    pagePopup.finish().fadeIn(1000);
            //    pagePopup.finish().fadeOut(3000);
            //    pagePopup.hide(4000);
            //    $('#' + this._id + '_documentmapContainer').css('display', 'none');
            //}
            $('#' + this._id + '_toolbar_exportListTip').css('display', 'none');
        },

        _pinchAndSwipe: function (event) {
            switch (event.type) {
                case "pinchin":
                    this._zoomOut();
                    break;
                case "pinchout":
                    this._zoomIn();
                    break;
                case "swipeleft":
                    this._gotoNextPage();
                    if (this._isDevice) {
                        this._updatePageNo();
                    }
                    break;
                case "swiperight":
                    this._gotoPreviousPage();
                    if (this._isDevice) {
                        this._updatePageNo();
                    }
                    break;
            }
        },

        _scrollPage: function (event) {
            var scrollContainer = $(event.target);
            var scrollY = this._orginY = scrollContainer.scrollTop();
            this._orginX = scrollContainer.scrollLeft();
            var headertabletop = $('#' + this._id + '_reportviewerContainer').offset().top;
            $('.fixed-data').each(function () {
                var tablixH = $(this).height();
                var tablixActualT = $(this).offset().top;
                var tablixFixedT = $(this).position().top;
                var tablixB = ((tablixH) + (tablixActualT)) - (headertabletop);
                if ((tablixActualT <= headertabletop) && !(tablixB <= headertabletop)) {
                    var tablixD = ((headertabletop) - (tablixActualT))
                    var tablixS = ((tablixFixedT) + (tablixD));
                    $(this).next('div').css({ 'top': tablixS, 'visibility': 'visible' });
                } else {
                    $(this).next('div').css("visibility", "collapse");
                }
            })

            if (this._isDevice) {
                if (scrollY + scrollContainer.innerHeight() >= scrollContainer[0].scrollHeight) {
                    scrollContainer.scrollTop(2);
                    if (!this._pageModel || this._currentPage == this._pageModel.TotalPages) {
                        return;
                    }
                    this._gotoNextPage();
                    this._updatePageNo();
                } else if (scrollY == 0) {
                    scrollContainer.scrollTop(2);
                    if (!this._pageModel || this._currentPage == 1) {
                        return;
                    }
                    this._gotoPreviousPage();
                    this._updatePageNo();
                }
            }
        },

        _showViewerBlock: function (showblock) {
            if (showblock) {
                $('#' + this._id + '_viewBlockContainer').css("display", "block");
                var parameterBlock = $('#' + this._id + '_viewBlockContainer .e-reportviewer-viewerblockcellcontent').find('table');
                this._selectparamToolItem(parameterBlock.is('[isviewclick]'));
            } else {
                $('#' + this._id + '_viewBlockContainer').css("display", "none");
            }
            if (this._isDevice) {
                $('#' + this._id + '_viewBlockContainer.e-reportviewer-blockstyle').css('z-index', showblock ? '10' : '0');
            }
        },

        _showNavigationIndicator: function (isShow) {
            $('#' + this._id + '_viewerContainer').ejWaitingPopup({ showOnInit: isShow });
            $('#' + this._id + '_viewerContainer_WaitingPopup').addClass('e-reportviewer-waitingpopup');
        },

        _showloadingIndicator: function (isShow) {
            if (isShow) {
                $('#' + this._id + '_loadingIndicator').css('display', 'block');
                $('#' + this._id + '_pageviewOuterContainer').css('display', 'none');
            }
            else {
                $('#' + this._id + '_loadingIndicator').css('display', 'none');
                $('#' + this._id + '_pageviewOuterContainer').css('display', 'block');
            }
            $('#' + this._id + '_loadingIndicator').ejWaitingPopup({ showOnInit: isShow });
            $('#' + this._id + '_loadingIndicator_WaitingPopup').addClass('e-reportviewer-waitingpopup');
        },

        _isMobileDevice: function () {
            //return (/mobile|tablet|android|kindle/i.test(navigator.userAgent.toLowerCase()));
            return (/windows phone|android|iphone/i.test(navigator.userAgent.toLowerCase()));
        },

        _getAuthenticationToken: function () {
            function _guid() {
                function guid() {
                    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
                }
                return (guid() + guid() + "-" + guid() + "-" + guid() + "-" + guid() + "-" + guid() + guid() + guid()).toUpperCase();
            }
            return _guid() + "^" + this._id;
        },

        _updateToolbarmodel: function () {
            this._showToolbar(this.model.toolbarSettings.showToolbar);
            this._showPrintButton(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.Print);
            this._showRefreshButton(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.Refresh);
            this._showZoomControl(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.Zoom);
            this._showFittoPage(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.FittoPage);
            this._showExportControls(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.Export);
            this._showExportList();
            this._showPageNavigationControls(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.PageNavigation);
            this._showParameterBlock(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.Parameters);
            this._showPreviewButton(model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.PrintLayout);
            this._showPrintPageSetupButton(this.model.toolbarSettings.items & ej.ReportViewer.ToolbarItems.PageSetup);
        },

        _viewerResize: function (event) {
            var proxy = this;
            if (this.model.isResponsive) {
                if (this.resizeTO) clearTimeout(this.resizeTO);
                this.resizeTO = setTimeout(function () {
                    var elementWidth = proxy._isWidth ? proxy.element[0].parentElement.style.width : proxy.element[0].style.width;
                    var elementHeight = proxy._isHeight ? proxy.element[0].parentElement.style.height : proxy.element[0].style.height;
                    var _height = $(proxy.element).height();
                    var _width = $(proxy.element).width();

                    if (elementHeight.indexOf("%") != -1) {
                        proxy._isPercentHeight = parseInt(elementHeight);
                        var containerHeight = proxy._isHeight ? $(proxy.element).parent().height() : _height;
                        _height = !proxy._isHeight ? ((containerHeight / 100) * proxy._isPercentHeight) : containerHeight;
                    } else if (proxy.element[0].parentElement.clientHeight != 0 && proxy._isPercentHeight != -1) {
                        _height = !proxy._isHeight ? ((proxy.element[0].parentElement.clientHeight / 100) * proxy._isPercentHeight) : proxy.element[0].parentElement.clientHeight;
                    } else if (proxy._isHeight && proxy.element[0].parentElement.clientHeight != 0) {
                        _height = proxy.element[0].parentElement.clientHeight;
                    } else if (proxy._browserInfo.name == 'msie' && proxy._browserInfo.version == 8.0 && proxy.element[0].parentElement.clientHeight != 0) {
                        _height = proxy.element[0].parentElement.clientHeight;
                    }
                    proxy.element.height(_height);

                    if (elementWidth.indexOf("%") != -1) {
                        proxy._isPercentWidth = parseInt(elementWidth);
                        var containerWidth = proxy._isWidth ? $(proxy.element).parent().width() : _width;
                        _width = !proxy._isWidth ? (containerWidth / 100) * proxy._isPercentWidth : containerWidth;
                    } else if (proxy.element[0].parentElement.clientWidth != 0 && proxy._isPercentWidth != -1) {
                        _width = !proxy._isWidth ? (proxy.element[0].parentElement.clientWidth / 100) * proxy._isPercentWidth : proxy.element[0].parentElement.clientWidth;
                    } else if (proxy._isWidth && proxy.element[0].parentElement.clientWidth != 0) {
                        _width = proxy.element[0].parentElement.clientWidth;
                    } else if (proxy._browserInfo.name == 'msie' && proxy._browserInfo.version == 8.0 && proxy.element[0].parentElement.clientWidth != 0) {
                        _width = proxy.element[0].parentElement.clientWidth;
                    }
                    proxy.element.width(_width);

                    proxy._setContainerSize();
                }, 200);
            }
        },

        _showViewerPage: function (isEnable) {
            if (isEnable) {
                $('#' + this._id + '_pageviewOuterline').css('display', 'block');
            } else {
                $('#' + this._id + '_pageviewOuterline').css('display', 'none');
            }
            if (this._isDevice) {
                $('#' + this._id + '_pageviewOuterline').css('z-index', isEnable ? '10' : '0');
            }
        },

        _updatePageNo: function () {
            $('#' + this._id + '_popupPageNo').val(this._currentPage);
            $('#' + this._id + '_pageInfoPopup .e-reportviewer-popuptotalpage').html(' / ' + this._pageModel.TotalPages);
        },

        _reportReload: function () {
            this._refresh = true;
            this._unwireEvents();
            this._initViewer();
            this.doAjaxPost("POST", this._actionUrl, JSON.stringify({ 'reportAction': this._reportAction.reportLoad, 'controlId': this._id, 'reportPath': this.model.reportPath, 'reportServerUrl': this.model.reportServerUrl, 'processingMode': this.model.processingMode }), "_reportLoaded");
        },
        //-------------------- Common ReportViewer events & utils[End]----------------------//

        /*---------------------client side methods[start]----------------------------------------------------------*/

        getDataSetNames: function () {
            var reportdatasets = $.extend(true, {}, this._reporDataSets);
            return reportdatasets;
        },


        getParameters: function () {
            var reportparameters = $.extend(true, {}, this._reportParameters);
            return reportparameters;
        },


        gotoPageIndex: function (pageNo) {
            this._gotoPageNo(pageNo);
        },


        gotoLastPage: function () {
            this._gotoLastPage();
        },


        gotoFirstPage: function () {
            this._gotoFirstPage();
        },


        gotoNextPage: function () {
            this._gotoNextPage();
        },


        gotoPreviousPage: function () {
            this._gotoPreviousPage();
        },


        print: function () {
            this._print();
        },


        printLayout: function () {
            this._printlayout();
        },


        exportReport: function (format) {
            this._exportReport(format);
        },


        refresh: function () {
            this._refreshReport();
        },


        fitToPage: function () {
            this._fitToPage('fitToPage');
        },


        fitToPageWidth: function () {
            this._fitToPage('fitToWidth');
        },

        fitToPageHeight: function () {
            this._fitToPage('wholepage');
        },
        /*---------------------client side methods[end]----------------------------------------------------------*/

        /*---------------------client side Events[start]----------------------------------------------------------*/
        _onReportLoaded: function () {
            this._trigger("reportLoaded");
        },

        _onRenderingBegin: function (args) {
            return this._trigger("renderingBegin", args);
        },

        _onAjaxRequest: function (args) {
            this._trigger("ajaxBeforeLoad", args);
        },

        _onAjaxSuccess: function (args) {
            this._trigger("ajaxSuccess", args);
        },

        _onAjaxFailure: function (args) {
            this._trigger("ajaxError", args);
        },

        _onRenderingComplete: function (args) {
            this._trigger("renderingComplete", args);
        },

        _onReportError: function (args) {
            return this._trigger("reportError", args);
        },

        _onViewReportClick: function (args) {
            return this._trigger("viewReportClick", args);
        },

        _onDrillThrough: function (args) {
            return this._trigger("drillThrough", args);
        },

        _onReportExport: function (args) {
            this._trigger("reportExport", args);
        },

        _onReportPrint: function (args) {
            this._trigger("reportPrint", args);
            return args.isStyleLoad;
        }
        /*---------------------client side Events[end]----------------------------------------------------------*/
    });

    ej.ReportViewer.ExportOptions = {
        Excel: 1 << 0,
        Html: 1 << 1,
        Pdf: 1 << 2,
        Word: 1 << 3,
        PPT: 1 << 4,
        All: 1 << 0 | 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4
    };
    ej.ReportViewer.ExcelFormats = {
        Excel97to2003: "excel97to2003",
        Excel2007: "excel2007",
        Excel2010: "excel2010",
        Excel2013: "excel2013"
    };
    ej.ReportViewer.PPTFormats = {
        PowerPoint97to2003: "powerpoint97to2003",
        PowerPoint2007: "powerpoint2007",
        PowerPoint2010: "powerpoint2010",
        PowerPoint2013: "powerpoint2013"
    };
    ej.ReportViewer.WordFormats = {
        Doc: "doc",
        Dot: "dot",
        Docx: "docx",
        Word2007: "word2007",
        Word2010: "word2010",
        Word2013: "word2013",
        Word2007Dotx: "word2007dotx",
        Word2010Dotx: "word2010dotx",
        Word2013Dotx: "word2013dotx",
        Word2007Docm: "word2007docm",
        Word2010Docm: "word2010docm",
        Word2013Docm: "word2013docm",
        Word2007Dotm: "word2007dotm",
        Word2010Dotm: "word2010dotm",
        Word2013Dotm: "word2013dotm",
        Rtf: "rtf",
        Txt: "txt",
        EPub: "epub",
        Html: "html",
        Xml: "xml",
        Automatic: "automatic"
    };
    ej.ReportViewer.ProcessingMode = {
        Remote: "remote",
        Local: "local"
    };
    ej.ReportViewer.Orientation = {
        Portrait: "Portrait",
        Landscape: "Landscape"
    };
    ej.ReportViewer.PaperSize = {
        A3: "A3",
        A4: "A4",
        B4_JIS: "B4(JIS)",
        B5_JIS: "B5(JIS)",
        Envelope_10: "Envelope #10",
        Envelope_Monarch: "Envelope Monarch",
        Executive: "Executive",
        Legal: "Legal",
        Letter: "Letter",
        Tabloid: "Tabloid",
        Custom: "Custom"
    };
    ej.ReportViewer.ToolbarItems = {
        Export: 1 << 0,
        Zoom: 1 << 1,
        PageNavigation: 1 << 2,
        Refresh: 1 << 3,
        Print: 1 << 4,
        DocumentMap: 1 << 5,
        Parameters: 1 << 6,
        PrintLayout: 1 << 7,
        FittoPage: 1 << 8,
        PageSetup: 1 << 9,
        All: 1 << 0 | 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7 | 1 << 8 | 1 << 9
    };
    ej.ReportViewer.RenderMode = {
        Default: 1 << 0 | 1 << 1,
        Mobile: 1 << 0,
        Desktop: 1 << 1
    };

    ej.ReportViewer.PrintOptions = {
        Default: "Default",
        NewTab: "NewTab",
        None: "None"
    };

    ej.ReportViewer.Locale = {};

    ej.ReportViewer.Locale["en-US"] = {
        toolbar: {
            print: {
                headerText: 'Print',
                contentText: 'Print the report.'
            },
            exportformat: {
                headerText: 'Export',
                contentText: 'Select the exported file format.',
                Pdf: 'PDF',
                Excel: 'Excel',
                Word: 'Word',
                Html: 'Html',
                PPT: 'PPT',
            },
            first: {
                headerText: 'First',
                contentText: 'Go to the first page of the report.'
            },
            previous: {
                headerText: 'Previous',
                contentText: 'Go to the previous page of the report.'
            },
            next: {
                headerText: 'Next',
                contentText: 'Go to the next page of the report.'
            },
            last: {
                headerText: 'Last',
                contentText: 'Go to the last page of the report.'
            },
            documentMap: {
                headerText: 'Document Map',
                contentText: 'Show or hide the document map.'
            },
            parameter: {
                headerText: 'Parameter',
                contentText: 'Show or hide the parameters pane.'
            },
            zoomIn: {
                headerText: 'Zoom-In',
                contentText: 'Zoom in to the report.'
            },
            zoomOut: {
                headerText: 'Zoom-Out',
                contentText: 'Zoom out of the report.'
            },
            refresh: {
                headerText: 'Refresh',
                contentText: 'Refresh the report.'
            },
            printLayout: {
                headerText: 'Print Layout',
                contentText: 'Change between print layout and normal modes.'
            },
            pageIndex: {
                headerText: 'Page Number',
                contentText: 'Current page number to view.'
            },
            zoom: {
                headerText: 'Zoom',
                contentText: 'Zoom in or out on the report.'
            },
            back: {
                headerText: 'Back',
                contentText: 'Go back to the parent report.'
            },
            fittopage: {
                headerText: 'Fit to Page',
                contentText: 'Fit the report page to the container.',
                pageWidth: 'Page Width',
                pageHeight: 'Whole Page'
            },
            pagesetup: {
                headerText: 'Page Setup',
                contentText: 'Choose page setup option to change paper size, orientation and margins.'
            }
        },
        pagesetupDialog: {
            paperSize: 'Paper Size',
            height: 'Height',
            width: 'Width',
            margins: 'Margins',
            top: 'Top',
            bottom: 'Bottom',
            right: 'Right',
            left: 'Left',
            unit: 'in',
            orientation: 'Orientation',
            portrait: 'Portrait',
            landscape: 'Landscape',
            doneButton: 'Done',
            cancelButton: 'Cancel'
        },
        viewButton: 'View Report'
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html PDFViewer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author &lt;a href="mailto:licensing@syncfusion.com"&gt;Syncfusion Inc&lt;/a&gt;
*/
(function ($, ej, undefined) {
    ej.widget("ejPdfViewer", "ej.PdfViewer", {

        _rootCSS: "e-pdfviewer",
        _requiresID: true,
        element: null,
        model: null,
        validTags: ["div"],

        //#region Defaults
        defaults: {
            serviceUrl: "",
            hyperlinkOpenState: 1,
            serverActionSettings: {
                load: "Load",
                fileUpload: "FileUpload",
                print: "Load",
                download: "Download"
            },
            documentPath: null,
            toolbarSettings: {
                toolbarItem: 1 | 2 | 4 | 8 | 16 | 32,
                showTooltip: true
            },
            enableHyperlink: true,
            enableTextSelection: true,
            pdfService: 1,
            locale: "en-US",
            pageChange: "",
            documentLoad: "",
            hyperlinkClick: "",
            beforePrint: "",
            afterPrint: "",
            zoomchange: "",
            bufferStart: "",
            bufferEnd: "",
            annotationAdd: "",
            annotationRemove: "",
            annotationPropertiesChange: "",
            annotationResize: "",
            isResponsive: true,
            pageClick: "",
            allowClientBuffering: false,
            documentUnload: "",
            ajaxRequestFailure: "",
            annotationType: null,
            enableTextMarkupAnnotations: true,
            enableHighlightAnnotation: true,
            enableStrikethroughAnnotation: true,
            enableUnderlineAnnotation: true,
            strikethroughSettings: {
                color: "#ff0000",
                author: "Guest",
                opacity: 1,
                subject: "Strikethrough",
                modifiedDate: null,
                isLocked: false
            },
            underlineSettings: {
                color: "#00ff00",
                author: "Guest",
                opacity: 1,
                subject: "Underline",
                modifiedDate: null,
                isLocked: false
            },
            highlightSettings: {
                color: "#ffff00",
                author: "Guest",
                opacity: 1,
                subject: "Highlight",
                modifiedDate: null,
                isLocked: false
            }
        },
        //#endregion

        //#region Local Members
        _isToolbarClick: false,
        _curYPos: 0,
        _curXPos: 0,
        _curDown: false,
        _pageModel: null,
        _currentPage: 1,
        _zoomLevel: 2,
        _preZoomVal: 1,
        _fitType: null,
        _higherZoomIndex: 0,
        _lowerZoomIndex: 0,
        _actionUrl: null,
        _isDevice: false,
        _contextMenu: false,
        _zoomVal: 1,
        _currentPageBackup: 0,
        _zoomValBackup: 0,
        _zoomLevelBackup: 0,
        _fitTypeBackup: null,
        _scrollTop: 0,
        _bgRenderTimer: 0,
        _renderCount: 0,
        _prevDiff: -1,
        _pointerCount: 0,
        _searchText: null,
        _selectedIndex: 0,
        _searchPageIndex: 0,
        _isRenderedByPinch: false,
        _isPinchLimitReached: false,
        _isRerenderCanvasCreated: false,
        _isPrinting: false,
        _isContainImage: false,
        _isPercentHeight: -1,
        _isPercentWidth: -1,
        _isHeight: false,
        _isWidth: false,
        _isFindboxPresent: false,
        _isTextSearch: false,
        _isTextHighlighted: false,
        _isRequestFired: false,
        _isPageScrollHighlight: false,
        _isPageScrolledForSearch: false,
        _searchAjaxRequestState: null,
        _isPrevSearch: false,
        _isMatchCase: false,
        _isPrintHidden: false,
        _isNavigationHidden: false,
        _isMagnificationHidden: false,
        _isDownloadHidden: false,
        _isTextSearchHidden: false,
        _isZoomCntlHidden: false,
        _isDownloadCntlHidden: false,
        _isToolbarHidden: false,
        _viewerAction: {
            getPageModel: 'GetPageModel',
        },
        _scrollTimer: null,
        _isDestroyed: false,
        _pdfService: null,
        _toolbar: null,
        _printIframe: null,
        _currentPrintPage: 0,
        _abortPrinting: false,
        _isWindowResizing: false,
        _ejViewerInstance: null,
        _isAutoZoom: false,
        _ejDropDownInstance: null,
        _clientx: null,
        _clienty: null,
        _curPosX: null,
        _curPosY: null,
        _previousBounds: null,
        _topValue: false,
        _clearText: false,
        _timers: null,
        _scrollMove: null,
        _rangePosition: null,
        _selectedRanges: null,
        _longTouch: false,
        _ranges: false,
        _touchcontextMenu: false,
        _selectionNodes: null,
        _selectionRange: null,
        _touched: false,
        _lockTimer: null,
        _timer: null,
        _displaySearch: false,
        _isCopyRestrict: false,
        _isPrintRestrict: false,
        _isFormFieldsDisabled: false,
        _isTargetPage: false,
        _targetPage: 0,
        _isBuffering: false,
        _isBufferStart: false,
        _pagesGot: null,
        _isPrintingProcess: false,
        _isRequestSuccess: false,
        _fileId: null,
        _isFormFields: false,
        _imageObj: null,
        _isJsondataAvailable: false,
        _highestWidth: 0,
        _horizontalResolution: null,
        _isAsynchronousDownload: true,
        _searchedText: null,
        _annotationActive: false,
        _isHighlight: false,
        _isUnderline: false,
        _isStrikeout: false,
        _drawColor: null,
        _selectedAnnotation: null,
        _selectedAnnotationObject: null,
        _isPopupNoteFocused: false,
        _colorpickerObject: null,
        _toolbarColorpickerObject: null,
        _isBackwardSelection: false,
        _isPropertiesWindowOpen: false,
        _isAnnotationSelected: false,
        _currentAnnotationRectangle: [],
        _currentAnnotationRectangleBackup: [],
        _annotationBackupNoteSave: [],
        _isPopupNoteVisible: false,
        _isUnderlineEnabled: false,
        _isHighlightEnabled: false,
        _isStrikeOutEnabled: false,
        _isContextMenuPresent: false,
        _isDefaultColorSet: false,
        _isTextSelection: false,
        _colorPickerStatus: null,
        _annotationsDeletedNo: null,
        _selectedValue: null,
        _highestHeight: 0,
        _removeSearch: false,
        _ajaxInProgress: false,
        _isNonBreackingCharacter: false,
        //#endregion

        //#region public members
        pageCount: 0,
        currentPageNumber: 1,
        zoomPercentage: 100,
        fileName: null,
        isDocumentEdited: false,
        //#endregion

        //#region Initialization
        _init: function () {
            this._actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.load;
            this._renderViewer();
            this._initViewer();
            this._createContextMenu();
            this._createHighlightContextMenu();
            this._createWaterDropDiv();
            this._createTouchContextMenu();
            this._createPopupMenu();
            this._createNote();
            this._createPropertiesMenu();
            this._createColorPalette();
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            this._ejDropDownInstance = $('#' + this._id + '_toolbar_zoomSelection').data("ejDropDownList");
            this._getPdfService(this.model.pdfService);
            if (this.model.serviceUrl) {
                var jsonResult = new Object();
                jsonResult["viewerAction"] = "GetPageModel";
                jsonResult["controlId"] = this._id;
                jsonResult["pageindex"] = "1";
                jsonResult["isInitialLoading"] = "true";

                if (this.model.documentPath) {
                    var documentPath = this.model.documentPath;
                    var base64String = documentPath.split("base64,")[1];
                    var isNotFileName = false; var isFilePath = false;
                    if (!base64String) {
                        //For handling File path
                        if (this.model.documentPath.indexOf('\\') != -1 || this.model.documentPath.indexOf('/') != -1) {
                            isNotFileName = true;
                            isFilePath = true;
                            if (!this.model.documentPath.toLowerCase().endsWith('.pdf')) {
                                documentPath = this.model.documentPath + '.pdf';
                            }
                        } else {
                            jsonResult["newFileName"] = documentPath;
                            this._fileName = jsonResult["newFileName"];
                        }
                    }
                    jsonResult["file"] = documentPath;
                }
                jsonResult["id"] = this._createGUID();
                this._fileId = jsonResult["id"];
                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                    this._doAjaxPost("POST", this._actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                else
                    this._doAjaxPost("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
            }
            this._printIframe = document.createElement("iframe");
        },

        _getPdfService: function (isLocal) {
            if (isLocal == 1)
                this._pdfService = ej.PdfViewer.PdfService.Local;
            else
                this._pdfService = ej.PdfViewer.PdfService.Remote;
        },

        _initViewer: function () {
            this._wireEvents();
            this._initToolbar();
            this._currentPage = 1;
            this._textMarkupAnnotationList = new Array();
            this._newAnnotationList = new Array();
            this._colorModifiedAnnotationList = new Array();
            this._existingAnnotationsModified = new Array();
            this._deletedAnnotationList = new Array();
            this._undoAnnotationCollection = new Array();
            this._redoAnnotationCollection = new Array();
            this._deletedAnnotationCollection = new Array();
            this._recentOperation = new Array();
            this._annotationsDeletedNo = new Array();
            this._redoActions = new Array();
            this._totalAnnotations = new Array();
            var tbSettings = this.model.toolbarSettings;
            if (!tbSettings.templateId) {
                this._showToolbar(true);
                this._showPrintButton(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.PrintTools);
                this._showZoomControl(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.MagnificationTools);
                this._showFittoPage(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.MagnificationTools);
                this._showPageNavigationControls(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.PageNavigationTools);
                this._showDownloadButton(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.DownloadTool);
                this._showTextSearchButton(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.TextSearchTool);
                this._showTextMarkupButtons(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.TextMarkupAnnotationTools);
            }
            this._showViewerBlock(false);
            this._setContainerSize();
            this._showloadingIndicator(true);
            this._on($('#' + this._id + 'e-pdf-viewer'), "keydown", this._keyboardShortcutFind);
        },

        _unLoad: function () {
            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + "0");
            $('#' + this._id + '_txtpageNo').val(0);
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoom');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_Print');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_download');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_search');
            var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
            zoomddl._selectItemByIndex(0);
            zoomddl.disable();
            clearTimeout(this._scrollTimer);
            var count = this._canvascount;
            while (count >= 1) {
                $('#' + this._id + 'pageDiv_' + count).remove();
                $('#' + this._id + 'selectioncanvas_' + count).remove();
                count--;
            }
            if (this._renderedCanvasList)
                this._renderedCanvasList.length = 0;
            this._showloadingIndicator(false);
            this._showPageLoadingIndicator(false);
            this._raiseClientEvent("documentUnload", null);
        },

        _destroy: function () {
            this._isDestroyed = true;
            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + 0);
            $('#' + this._id + '_txtpageNo').val(0);
            clearTimeout(this._scrollTimer);
            this._unwireEvents();
            var count = this._canvascount;
            while (count >= 1) {
                $('#' + this._id + 'pageDiv_' + count).remove();
                $('#' + this._id + 'selectioncanvas_' + count).remove();
                count--;
            }
            $('#' + this._id + '_pageviewContainer').remove();
            $('#' + this._id + '_toolbarContainer').remove();
            $('#' + this._id + '_viewerContainer').remove();
            $('#' + this._id + '_viewBlockContainer').remove();
            $('#' + this._id + '_toolbar_zoomSelection_popup_wrapper').remove();
            $('#' + this._id + '_rptTooltip').remove();
            $('#' + this._id + '_loadingIndicator_WaitingPopup').remove();
            $('#' + this._id + '_viewerContainer_WaitingPopup').remove();
            $('#' + this._id + '_WaitingPopup').remove();

            $(this.element).find('.e-pdfviewer-viewer').remove();
            this._renderedCanvasList.length = 0;
            this._raiseClientEvent("destroy", null);
        },
        //#endregion

        //-------------------- Render the pdfviewer Ctrl [start] -------------------------//

        _renderToolTip: function () {
            var $divTooltip = ej.buildTag("div.e-pdfviewer-tbdiv e-pdfviewer-tooltip", "", { 'display': 'none' }, { 'id': this._id + '_rptTooltip' });
            var $tooltipHeader = ej.buildTag("span.e-pdfviewer-headerspan", "", { 'display': 'block' }, { 'id': this._id + '_rptTooltip_Header' });
            var $tooltipContent = ej.buildTag("span.e-pdfviewer-contentspan", "", { 'display': 'block' }, { 'id': this._id + '_rptTooltip_Content' });
            $divTooltip.append($tooltipHeader);
            $divTooltip.append($tooltipContent);
            return $divTooltip;
        },

        _renderToolBar: function (targetTag) {
            if (!this.model.toolbarSettings.templateId) {
                var div = ej.buildTag("div.e-pdfviewer-toolbarcontainer .e-pdfviewer-viewer", "", { 'width': '100%' }, { 'id': this._id + '_toolbarContainer' });
                targetTag.append(div);

                if (this._isDevice) {
                    var $ultoolbaritems = ej.buildTag("ul.e-pdfviewer-toolbarul", "", {});
                    this._appendToolbarItems($ultoolbaritems, 'zoomin');
                    this._appendToolbarItems($ultoolbaritems, 'zoomout');
                    this._appendToolbarItems($ultoolbaritems, 'fitWidth');
                    this._appendToolbarItems($ultoolbaritems, 'fitPage');
                    div.append($ultoolbaritems);
                } else {
                    var $ulnavigate = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, {});
                    this._appendToolbarItems($ulnavigate, 'gotoprevious');
                    this._appendToolbarItems($ulnavigate, 'gotonext');
                    this._appendToolbarItems($ulnavigate, 'gotopage');
                    div.append($ulnavigate);

                    var $ulzoom = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, { 'id': this._id + '_pdfviewer_zoomul' });
                    this._appendToolbarItems($ulzoom, 'zoomin');
                    this._appendToolbarItems($ulzoom, 'zoomout');
                    this._appendToolbarItems($ulzoom, 'zoom');
                    //Appending the fitWidth and the fitPage buttons to the toolbar
                    this._appendToolbarItems($ulzoom, 'fitWidth');
                    this._appendToolbarItems($ulzoom, 'fitPage');
                    div.append($ulzoom);

                    var $ultextmarkup = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, { 'id': this._id + '_pdfviewer_textmarkupul' });
                    this._appendToolbarItems($ultextmarkup, 'underline');
                    this._appendToolbarItems($ultextmarkup, 'strikeout');
                    this._appendToolbarItems($ultextmarkup, 'highlight');
                    div.append($ultextmarkup);

                    var $uldownload = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'float': 'right' }, { 'id': this._id + '_pdfviewer_downloadul' });
                    this._appendToolbarItems($uldownload, 'download');
                    div.append($uldownload);

                    var $ulprintExport = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'float': 'right' }, { 'id': this._id + '_pdfviewer_printul' });
                    this._appendToolbarItems($ulprintExport, 'print');
                    div.append($ulprintExport);

                    var $ulsearch = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'float': 'right' }, { 'id': this._id + '_pdfviewer_searchul' });
                    this._appendToolbarItems($ulsearch, 'search');
                    div.append($ulsearch);

                    $('#' + this._id + '_toolbar_zoomSelection').ejDropDownList({ height: "27px", width: "75px", cssClass: "e-pdfviewer-ddl", change: this._zoomValChange, selectedItem: 0 });
                }
                div.ejToolbar({ enableSeparator: !this._isDevice, click: $.proxy(this._toolbarClick, this), isResponsive: true, overflowClose: $.proxy(this._overflowToolbarClose, this) });
                this._toolbar = $('#' + this._id + '_toolbarContainer').data('ejToolbar');
                $('#' + this._id + '_toolbarContainer_hiddenlist').removeClass("e-responsive-toolbar").addClass("e-pdfviewer-responsivesecondarytoolbar");
                $('#' + this._id + '_pdfviewer_searchul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_printul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_textmarkupul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_downloadul').removeClass('e-separator');
                $('#' + this._id + '_toolbarContainer_hiddenlist').removeClass("e-toolbarspan");
            } else {
                var templateDiv = document.getElementById(this.model.toolbarSettings.templateId);
                targetTag.append(templateDiv);
                templateDiv.ejToolbar({ enableSeparator: true, height: templateDiv.height(), click: this.model.toolbarSettings.click, isResponsive: true });
                templateDiv.css('display', 'block');
            }
        },

        _appendToolbarItems: function (litag, eletype) {
            var $divouter;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            switch (eletype) {
                case 'print':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_Print' });
                    var $spanprint = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-print", "", {}, { 'id': this._id + '_toolbar_Print' });
                    $divouter.append($spanprint);
                    break;
                case 'download':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_download' });
                    var $spandownload = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-download", "", {}, { 'id': this._id + '_toolbar_download' });
                    $divouter.append($spandownload);
                    break;
                case 'gotofirst':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotofirst' });
                    var $spangotofirst = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotofirst", "", {});
                    $divouter.append($spangotofirst);
                    break;
                case 'gotolast':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotolast' });
                    var $spangotolast = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotolast", "", {});
                    $divouter.append($spangotolast);
                    break;
                case 'gotonext':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotonext' });
                    var $spangotonext = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotonext", "", {});
                    $divouter.append($spangotonext);
                    break;
                case 'gotoprevious':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotoprevious' });
                    var $spangotoprevious = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotoprevious", "", {});
                    $divouter.append($spangotoprevious);
                    break;
                case 'gotopage':
                    $divouter = ej.buildTag("div.e-pdfviewer-tbpage", "", { 'display': 'block' }, {});
                    var $inputpageno = ej.buildTag("input.e-pdfviewer-pagenumber e-pdfviewer-elementalignments ejinputtext", "", {}, { 'type': 'text', 'value': '0', 'id': this._id + '_txtpageNo', 'data-role': 'none' });
                    var $spanpageno = ej.buildTag("span.e-pdfviewer-labelpageno", "", {}, {});
                    $divouter.append($inputpageno);
                    $divouter.append($spanpageno);
                    break;
                case 'zoomin':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoomin' });
                    var $spanzoomin = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-zoomin", "", {}, { 'id': this._id + '_toolbar_zoomin' });
                    $divouter.append($spanzoomin);
                    break;
                case 'zoomout':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoomout' });
                    var $spanzoomout = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-zoomout", "", {}, { 'id': this._id + '_toolbar_zoomout' });
                    $divouter.append($spanzoomout);
                    break;
                case 'zoom':
                    $divouter = ej.buildTag("div.e-pdfviewer-ejdropdownlist", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoom' });
                    var $sltzoom = ej.buildTag("select.e-pdfviewer-tbdiv e-pdfviewer-zoomlist", "", {}, { 'id': this._id + '_toolbar_zoomSelection', 'data-role': 'none' });
                    var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                    var text = localeObj['contextMenu']['auto']['contentText'];
                    $sltzoom.append("<option Selected>" + text + "</option>");
                    $sltzoom.append("<option>50%</option>");
                    $sltzoom.append("<option>75%</option>");
                    $sltzoom.append("<option>100%</option>");
                    $sltzoom.append("<option>125%</option>");
                    $sltzoom.append("<option>150%</option>");
                    $sltzoom.append("<option>200%</option>");
                    $sltzoom.append("<option>400%</option>");
                    $divouter.append($sltzoom);
                    break;
                    //Creating the fitWidth and the fitPage spans in the HTML page and appending them to the toolbar of the PDF viewer
                case 'fitWidth':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_fitWidth' });
                    var $spanexport = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-fitwidth", "", {}, { 'id': this._id + '_fitWidth' });
                    $divouter.append($spanexport);
                    break;
                case 'fitPage':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_fitPage' });
                    var $spanFitPage = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-fitpage", "", {}, { 'id': this._id + '_fitPage' });
                    $divouter.append($spanFitPage);
                    break;
                case 'search':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_search' });
                    var $spansearch = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-find", "", {}, { 'id': this._id + '_find' });
                    $divouter.append($spansearch);
                    break;
                case 'highlight':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-highlight", "", {}, { 'id': this._id + '_pdfviewer_toolbar_highlight' });
                    var $spanhighlight = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-highlight-markup", "", {}, { 'id': this._id + '_highlight_markup' });
                    var dropdownspan = ej.buildTag("span.e-pdfviewer-dropdown-wrapper", "", {}, { 'id': this._id + '_highlight_dropdown' });
                    var dropdownarrowspan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-dropdown-arrow", "", {}, { 'id': this._id + '_highlight_dropdown_arrow' });
                    dropdownspan.append(dropdownarrowspan);
                    $divouter.append($spanhighlight);
                    $divouter.append(dropdownspan);
                    break;
                case 'underline':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-underline", "", {}, { 'id': this._id + '_pdfviewer_toolbar_underline' });
                    var $spanunderline = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-underline-markup", "", {}, { 'id': this._id + '_underline_markup' });
                    var dropdownspan = ej.buildTag("span.e-pdfviewer-dropdown-wrapper", "", {}, { 'id': this._id + '_underline_dropdown' });
                    var dropdownarrowspan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-dropdown-arrow", "", {}, { 'id': this._id + '_underline_dropdown_arrow' });
                    dropdownspan.append(dropdownarrowspan);
                    $divouter.append($spanunderline);
                    $divouter.append(dropdownspan);
                    break;
                case 'strikeout':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-strikeout", "", {}, { 'id': this._id + '_pdfviewer_toolbar_strikeout' });
                    var $spanstrikeout = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-strikeout-markup", "", {}, { 'id': this._id + '_strikeout_markup' });
                    var dropdownspan = ej.buildTag("span.e-pdfviewer-dropdown-wrapper", "", {}, { 'id': this._id + '_strikeout_dropdown' });
                    var dropdownarrowspan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-dropdown-arrow", "", {}, { 'id': this._id + '_strikeout_dropdown_arrow' });
                    dropdownspan.append(dropdownarrowspan);
                    $divouter.append($spanstrikeout);
                    $divouter.append(dropdownspan);
                    break;
            }
            litag.append($divouter);
        },

        _renderViewerBlockinWeb: function (targetTag) {
            var div = ej.buildTag("div.e-pdfviewer-viewer e-pdfviewer-viewerblock", "", {}, { 'id': this._id + '_viewBlockContainer' });
            targetTag.append(div);

            var $innerContent = ej.buildTag("table.e-pdfviewer-viewerblockcellcontent", "", { 'margin': '1px', 'padding': '5px 5px 10px' });
            var $tr = ej.buildTag("tr", "", { 'width': '100%' });
            var $tdleft = ej.buildTag("td.e-pdfviewer-viewerblockcontent", "", {});
            $tr.append($tdleft);
            $innerContent.append($tr);
            div.append($innerContent);
            return div;
        },

        _renderViewerContainer: function (targetTag) {
            var div = ej.buildTag("div", "", {}, { 'id': this._id + '_pdfviewerContainer' });
            targetTag.append(div);

            var $pdfviewContainer = ej.buildTag("div.e-pdfviewer-viewer e-pdfviewer-scrollcontainer e-pdfviewer-viewercontainer", "", { 'height': '100%', 'width': '100%', 'font-size': '8pt' }, { 'id': this._id + '_viewerContainer' });
            var $loadingindicator = ej.buildTag("div", "", { 'margin': '0px', 'height': '99.8%', 'width': '100%' }, { 'id': this._id + '_loadingIndicator' });
            var $loadingemptybackview = ej.buildTag("div", "", { 'margin': '0px', 'height': '99.8%', 'width': '100%', 'background-color': 'rgba(164, 183, 216, 0.18)', 'display': 'block' }, { 'id': this._id + '_loadingIndicatorBackView' });

            var $pageviewContainer = ej.buildTag("div", "", {}, { 'id': this._id + '_pageviewContainer' });

            $loadingindicator.append($loadingemptybackview);
            $pdfviewContainer.append($loadingindicator);

            $pdfviewContainer.append($pageviewContainer);

            if (this._isDevice) {
                this._renderViewerBlockinDevice($pdfviewContainer);
            }

            div.append($pdfviewContainer);

            return div;
        },

        _renderViewer: function () {
            var height = this.element.height();
            var width = this.element.width();
            //control root div tag.
            var viewer = ej.buildTag("div.e-pdfviewer-viewer", "", {}, { 'id': this._id + 'e-pdf-viewer' });

            if (!this.element[0].style.height && this.element[0].parentElement.clientHeight != 0) {
                this._isHeight = true;
            }

            if (!this.element[0].style.width && this.element[0].parentElement.clientWidth != 0) {
                this._isWidth = true;
            }

            if (height === 0 && this.element[0].parentElement.clientHeight != 0) {
                this.element.height(this.element[0].parentElement.clientHeight);
            }

            if (width === 0 && this.element[0].parentElement.clientWidth != 0) {
                this.element.width(this.element[0].parentElement.clientWidth);
            }

            this.element.append(viewer);
            this._renderToolBar(viewer);
            if (!this._isDevice) {
                this._renderViewerBlockinWeb(viewer);
                var tooltip = this._renderToolTip();
            }
            var div = this._renderViewerContainer(viewer);
            div.append(tooltip);
            this._renderSearchBox();
        },

        _renderSearchBox: function () {
            var div = ej.buildTag('div.e-pdfviewer-searchbox e-pdfviewer-arrow', "", {}, { 'id': this._id + '_pdfviewer_searchbox' });
            var ulItem = ej.buildTag('ul.e-pdfviewer-toolbarul-search', "", {});
            div.append(ulItem);
            var inputContainer = ej.buildTag('div.e-pdfviewer-searchboxitem e-pdfviewer-search-inputcontainer', "", {}, {});
            var findLabel = ej.buildTag('span.e-pdfviewer-label e-pdfviewer-searchboxitem', "Find : ", { 'float': 'left', 'padding-top': '1px', 'margin-right': '5px', 'width': '29px', 'overflow': 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }, {});
            var input = ej.buildTag('input.e-pdfviewer-searchinput e-pdfviewer-elementalignments ejinputtext', '', { 'width': '150px' }, { 'id': this._id + '_pdfviewer_searchinput' });
            inputContainer.append(findLabel);
            inputContainer.append(input);
            var prevbutton = ej.buildTag('li.e-pdfviewer-toolbarli-search e-pdfviewer-search-previous', '', { 'float': 'left' }, { 'id': this._id + '_pdfviewer_previous_search' });
            var nextbutton = ej.buildTag('li.e-pdfviewer-toolbarli-search e-pdfviewer-search-next', '', { 'float': 'left' }, { 'id': this._id + '_pdfviewer_next_search' });
            var closebutton = ej.buildTag('li.e-pdfviewer-toolbarli-search e-pdfviewer-search-close', '', { 'float': 'left', 'margin-left': '4px' }, { 'id': this._id + '_pdfviewer_close_search' });
            var prevBtnSpan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-prevfind", "", {}, { 'id': this._id + '_prevfind' });
            prevbutton.append(prevBtnSpan);
            $(prevbutton).css({ "pointer-events": "none", "opacity": "0.6" });
            $(nextbutton).css({ "pointer-events": "none", "opacity": "0.6" });
            var nextBtnSpan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-nextfind", "", {}, { 'id': this._id + '_nextfind' });
            nextbutton.append(nextBtnSpan);
            var checkboxContainer = ej.buildTag('div.e-pdfviewer-searchboxitem e-pdfviewer-search-checkboxcontainer', "", { 'float': 'left' }, {});
            var checkbox = ej.buildTag("input", "", {}, { 'type': 'checkbox' });
            var spanElement = ej.buildTag("span.e-pdfviewer-label e-pdfviewer-searchboxitem", "Match case", { 'float': 'left', 'padding-top': '3px', 'margin-left': '5px', 'margin-top': '4px', 'width': '67.5px', 'overflow': 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }, {});
            checkboxContainer.append(checkbox);
            checkboxContainer.append(spanElement);
            var closeBtnSpan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-closefind", "", {}, { 'id': this._id + '_closefind' });
            closebutton.append(closeBtnSpan);
            ulItem.append(inputContainer);
            ulItem.append(prevbutton);
            ulItem.append(nextbutton);
            ulItem.append(checkboxContainer);
            ulItem.append(closebutton);
            div.ejToolbar({ enableSeparator: false, isResponsive: false, width: '400px', hide: true });
            checkbox.ejCheckBox({ cssClass: 'e-pdfviewer-match-checkbox', id: this._id + '_search_matchcase', size: ej.CheckboxSize.Medium, change: $.proxy(this._matchcase, this) });
            checkbox.ejCheckBox("disable");
            $('#' + this._id + '_pdfviewerContainer').append(div);
        },

        _createColorPalette: function () {
            var palette = ej.buildTag('div.e-pdfviewer-colorpicker', "", {}, { 'id': this._id + '_pdfviewer_colorpicker' });
            $('#' + this._id + '_pdfviewerContainer').append(palette);
            palette.ejColorPicker({ displayInline: true, modelType: "palette", change: $.proxy(this._setDrawColor, this) });
            this._toolbarColorpickerObject = palette.data('ejColorPicker');
        },
        //-------------------- Render the pdfviewer Ctrl [End] -------------------------//

        //-------------------- Apply Page Style and Actions [Start] -------------------------//
        _setContainerSize: function () {
            var ctrlheight = document.getElementById(this._id).clientHeight;
            var viewerblockHeight = 0;
            if (!this._isDevice) {
                var viewerContainer = $('#' + this._id + '_viewBlockContainer');
                if (viewerContainer.css('display').toLowerCase() == 'block') {
                    viewerblockHeight = viewerContainer.height();
                }
            }

            var toolbarHeight = this.model.toolbarSettings.templateId ? $('#' + this.model.toolbarSettings.templateId).height() : $('#' + this._id + '_toolbarContainer').height();

            var calcHeight = ctrlheight - viewerblockHeight - toolbarHeight - 4;
            $('#' + this._id + '_viewerContainer').css({ "height": calcHeight + "px" });
        },

        _setPageSize: function (pageHeight, pageWidth, headerHeight, footerHeight) {
            headerHeight = 0;
            var scalePageSize = $('#' + this._id + '_pageviewContainer')[0].getBoundingClientRect();
            var ins = this;
            this._renderPreviousPage = false;
            $('#' + this._id + '_viewerContainer').unbind('scroll').on('scroll', function () {
                ins._computeCurrentPage(pageHeight);
            });
            $('#' + this._id + '_pageviewContainer').mouseup(function (e) {
                ins._raiseClientEvent("pageClick", e);
            });
            //timer
            this._scrollTimer = setInterval(function () { ins._pageviewscrollchanged(pageHeight) }, 500);
            ins._backgroundPage = 1;

            this._previousZoom = 1;
            ins._previousPage = ins._currentPage;
            this._pageLocation = new Array();
            this._renderedCanvasList = new Array();
            this._pageContents = new Array();
            this._pageText = new Array();
            this._textDivs = new Array();
            this._textContents = new Array();
            this._searchMatches = new Array();
            this._searchCollection = new Array();
            this._pageLocation[1] = 0;
            this._searchedPages = new Array();
            this._canvascount = this._totalPages;
            this._pointers = new Array();
            this._imageObj = new Array();
            this._pagesGot = new Array();
            this._imageSrcCollection = new Array();
            this._selectionPages = new Array();
            this._designPageCanvas();
        },

        _designPageCanvas: function () {
            var cummulativepageheight = 5;
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            var w = pageViewerContainer.width();
            var h = pageViewerContainer.height();
            var pageW = this._pageWidth;
            var pageH = this._pageHeight;
            var scaleX = 1;
            var scaleY = 1;
            scaleX = (w - 25) / pageW;
            scaleX = Math.min(1, scaleX);
            this._zoomVal = scaleX;
            for (var index = 1; index <= this._totalPages; index++) {
                var leftpos;
                if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                    leftpos = (this.element.width() - this._pageSize[index - 1].PageHeight) / 2;
                } else {
                    leftpos = (this.element.width() - this._pageSize[index - 1].PageWidth) / 2;
                }
                if (leftpos < 0)
                    leftpos = 5;
                var imageDiv = ej.buildTag("div", "", {}, { id: this._id + 'pageDiv_' + index });
                pageviewcontainer.append(imageDiv);
                imageDiv.css("position", "absolute");
                imageDiv.css("top", this._zoomVal * cummulativepageheight);
                imageDiv.css("left", leftpos + "px");
                this._pageLocation[index] = cummulativepageheight;
                var imgwidth = '100%';
                var imgheight = '100%';

                var secondarycanvas = document.createElement('canvas');
                secondarycanvas.id = this._id + '_secondarycanvas_' + index;
                secondarycanvas.className = 'e-pdfviewer-secondarycanvas';
                secondarycanvas.style.position = 'absolute';
                secondarycanvas.style.left = 0;
                secondarycanvas.style.top = 0;
                secondarycanvas.style.backgroundColor = 'transparent';
                imageDiv.append(secondarycanvas);
                var proxy = this;

                var canvas = document.createElement('canvas');
                canvas.id = this._id + "pagecanvas_" + index;
                canvas.className = "e-pdfviewer-pageCanvas";
                if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                    canvas.width = this._zoomVal * this._pageSize[index - 1].PageHeight;
                    canvas.height = this._zoomVal * this._pageSize[index - 1].PageWidth;
                    canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                    canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
                } else {
                    canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
                    canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                    canvas.height = this._zoomVal * this._pageSize[index - 1].PageHeight;
                    canvas.width = this._zoomVal * this._pageSize[index - 1].PageWidth;
                }
                canvas.style.backgroundColor = "white";
                imageDiv.append(canvas);

                secondarycanvas.height = canvas.height;
                secondarycanvas.width = canvas.width;
                secondarycanvas.style.height = canvas.height + 'px';
                secondarycanvas.style.width = canvas.width + 'px';

                var selectionlayer = document.createElement('div');
                selectionlayer.id = this._id + 'selectioncanvas_' + index;
                selectionlayer.className = 'e-pdfviewer-selectiondiv';
                selectionlayer.style.height = canvas.height + 'px';
                selectionlayer.style.width = canvas.width + 'px';
                selectionlayer.style.position = 'absolute';
                selectionlayer.style.left = 0;
                selectionlayer.style.top = 0;
                selectionlayer.style.backgroundColor = 'transparent';
                selectionlayer.style.zIndex = '2';
                imageDiv.append(selectionlayer);
                //Add loading indicator in every page
                $('#' + this._id + 'pageDiv_' + index).ejWaitingPopup({ showOnInit: true, appendTo: '#' + this._id + 'pageDiv_' + index, target: '#' + this._id + 'pageDiv_' + index });
                $('#' + this._id + 'pageDiv_' + index + '_WaitingPopup').appendTo($('#' + this._id + 'pageDiv_' + index)).css({ 'left': '0px', 'top': '0px', 'background-color': '#dbdbdb' });

                if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                    cummulativepageheight = parseFloat(cummulativepageheight) + parseFloat(this._pageSize[index - 1].PageWidth) + 8;
                } else {
                    cummulativepageheight = parseFloat(cummulativepageheight) + parseFloat(this._pageSize[index - 1].PageHeight) + 8;
                }
            }
            this._cummulativeHeight = cummulativepageheight;
        },

        _computeCurrentPage: function (pageHeight) {
            var sum = 0;
            var currentPageNum = 0;
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolvalue = vscrolBar.scrollTop;
            if (this._zoomVal != 1) {
                vscrolvalue = vscrolvalue + ((this._currentPage) * (8 - this._zoomVal * 8));
            }
            var pagevalue = 0;
            var pageupdatevalue = 0;
            var pagenumbervalue = { currentPageNumber: 0 };
            for (var i = 0; i < this._totalPages; i++) {
                if (this._isDestroyed)
                    return;
                if (sum > vscrolvalue && vscrolvalue >= 0) {
                    currentPageNum = i;

                    var currentpageheightinview = parseFloat(sum) - parseFloat(vscrolvalue);
                    var nextpageheightinview = this.element[0].parentElement.clientHeight - currentpageheightinview;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    if (this.element[0].parentElement.clientHeight < ((this._pageSize[i - 1].PageHeight * this._zoomVal) + (this._pageSize[i].PageHeight * this._zoomVal)) && (parseInt(this._pageLocation[i] * this._zoomVal) < pageviewcontainer.scrollTop)) {
                        if (nextpageheightinview > currentpageheightinview) {
                            currentPageNum = parseFloat(currentPageNum) + 1;
                            $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("visibility", "");
                            this._renderPreviousPage = true;
                        }
                    }
                    this._renderPreviousPage = false;
                    break;
                }
                else {
                    if (this._pageSize[i].PageRotation == 90 || this._pageSize[i].PageRotation == 270) {
                        sum = parseFloat(sum) + parseFloat(this._pageSize[i].PageWidth * this._zoomVal) + 8;
                    } else {
                        sum = parseFloat(sum) + parseFloat(this._pageSize[i].PageHeight * this._zoomVal) + 8;
                    }
                }
                if (vscrolvalue >= 0) {
                    currentPageNum = i + 1;
                }
                else {
                    currentPageNum = 1;
                }
            }
            if (this._fitType == "fitToPage") {
                var currentPageHeight = parseFloat($('#' + this._id + 'pageDiv_' + (currentPageNum)).css("height"));
                var currentPageTop = this._pageLocation[currentPageNum] * this._zoomVal;
                var viewerContainerHeight = parseFloat($(pageviewcontainer).css("height"));
                var totalHeight = ((viewerContainerHeight - currentPageHeight) / 2);
                $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("top", (currentPageTop + totalHeight) + "px");
                $('#' + this._id + 'pageDiv_' + (currentPageNum + 1)).css("visibility", "hidden");
                $('#' + this._id + 'pageDiv_' + (currentPageNum - 1)).css("visibility", "hidden");
            }
            $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("visibility", "");
            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + this._totalPages);
            pagevalue = document.getElementById(this._id + "_txtpageNo").value;
            $('#' + this._id + '_txtpageNo').val(currentPageNum);
            this._updatePageNavigation(currentPageNum, this._totalPages);
            pageupdatevalue = document.getElementById(this._id + "_txtpageNo").value;
            pagenumbervalue.currentPageNumber = pageupdatevalue;
            this._currentPage = currentPageNum;
            this.currentPageNumber = this._currentPage;
            if (pagevalue != pageupdatevalue) {
                this._raiseClientEvent("pageChange", pagenumbervalue);
            }
        },

        _pageviewscrollchanged: function (pageHeight) {
            var sum = 0;
            var currentPageNum = 0;
            var vscrolvalue = $('#' + this._id + '_viewerContainer').scrollTop();
            if (this._isTargetPage) {
                if (this.model.allowClientBuffering) {
                    this._isTargetPage = false;
                    this._isBuffering = true;
                    if (this._targetPage <= this._totalPages) {
                        if (!this._isBufferStart) {
                            this._raiseClientEvent("bufferStart", this._isBuffering);
                            this._isBufferStart = true;
                        }
                        var jsonString = { "viewerAction": this._viewerAction.getPageModel, "pageindex": this._targetPage.toString(), "enableOfflineMode": true, "isPageScrolled": "false" };
                        var proxy = this;
                        this._ajaxRequestState = $.ajax({
                            type: 'POST',
                            url: this.model.serviceUrl + '/' + this.model.serverActionSettings.load,
                            crossDomain: true,
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            data: JSON.stringify(jsonString),
                            traditional: true,
                            success: function (data) {
                                if (typeof data === 'object')
                                    jsondata = JSON.parse(JSON.stringify(data));
                                else
                                    jsondata = JSON.parse(data);
                                jsondata = jsondata["pdf"];
                                var count = 0;
                                var isLoopBreak = false;
                                if (jsondata) {
                                    for (var i = proxy._targetPage; i <= proxy._totalPages; i++) {
                                        var backupjson = jsondata[i];
                                        if (backupjson) {
                                            proxy._pageContents[parseInt(backupjson["currentpage"])] = JSON.stringify(backupjson);
                                            proxy._pageText[parseInt(backupjson["currentpage"])] = backupjson["pageContents"];
                                            proxy._pagesGot.push(parseInt(backupjson["currentpage"]));
                                            count++;
                                        } else {
                                            isLoopBreak = true;
                                            break;
                                        }
                                    }
                                    if (backupjson == undefined && !isLoopBreak) {
                                        for (var i = proxy._targetPage; i <= proxy._totalPages; i++) {
                                            if (proxy._pagesGot.indexOf(i)) {
                                                count++;
                                            }
                                        }
                                    }
                                    if (count) {
                                        proxy._targetPage = proxy._targetPage + count;
                                    } else {
                                        proxy._targetPage = proxy._targetPage
                                    }
                                    if (proxy._targetPage >= proxy._totalPages) {
                                        proxy._raiseClientEvent("bufferEnd", this._isBuffering);
                                        proxy._isBufferStart = false;
                                    }
                                    proxy._isTargetPage = true;
                                    proxy._isBuffering = false;
                                }
                            },
                            error: function () {

                            }
                        });
                    }
                }
            }
            if (vscrolvalue == this._previousPosition) {
                currentPageNum = this._currentPage;

                if (this._totalPages && this._previousPage != currentPageNum) {
                    var pagenumber = parseInt(currentPageNum);
                    this._previousPage = currentPageNum;
                    if (pagenumber >= 1 && pagenumber <= this._totalPages) {
                        if (!this._isJsondataAvailable) {
                            this._showloadingIndicator(true);
                            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html("");
                            $('#' + this._id + '_txtpageNo').val('0');
                        }
                        else {

                            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + this._totalPages);
                            $('#' + this._id + '_txtpageNo').val(pagenumber);
                        }
                        this._currentPage = pagenumber;
                        this._updatePageNavigation(this._currentPage, this._totalPages);
                        if (this._renderedCanvasList.indexOf(parseInt(this._currentPage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && !this._pageContents[parseInt(this._currentPage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = this._currentPage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                    }
                }
            }
            if (this._renderedCanvasList.indexOf(parseInt(this._currentPage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && this._currentPage <= this._totalPages) {
                if (!this._pageContents[parseInt(this._currentPage)]) {
                    if (!this._scrollTriggered) {
                        this._scrollTriggered = true;
                        var jsonResult = new Object();
                        jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                        jsonResult["pageindex"] = this._currentPage.toString();
                        jsonResult["id"] = this._fileId;
                        if (this._pdfService == ej.PdfViewer.PdfService.Local)
                            this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                        else
                            this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                    }
                }
                else {
                    var jsdata = this._pageContents[parseInt(this._currentPage)];
                    this._drawPdfPage(jsdata);
                }
            }
            var nextpage = parseInt(this._currentPage) + 1;
            if (this.model.allowClientBuffering) {
                if (!this._renderPreviousPage) {
                    if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    jsonResult["isPageScrolled"] = true;
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    } else if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    var isTargetFire = true;
                                    if (!this._isPrintingProcess) {
                                        jsonResult["isPageScrolled"] = false;
                                    }
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult), isTargetFire);
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
                else {
                    if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    jsonResult["isPageScrolled"] = true;
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    }
                    else if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    jsonResult["isPageScrolled"] = true;
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
            } else {
                if (!this._renderPreviousPage) {
                    if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                    else if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
                else {
                    if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    }
                    else if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
            }
            this._previousPosition = vscrolvalue;
            var proxy = this;
            setTimeout(function () {
                $('.e-pdfviewer-formFields').show();
                if (proxy.model) {
                    var localeObj = ej.PdfViewer.Locale[proxy.model.locale] ? ej.PdfViewer.Locale[proxy.model.locale] : ej.PdfViewer.Locale["default"];
                    var text = localeObj['contextMenu']['auto']['contentText'];
                    var zoomddl = $('#' + proxy._id + '_toolbar_zoomSelection').data('ejDropDownList');
                    var values = $('#container_toolbar_zoomSelection_hidden').val();
                    $('#' + proxy._id + '_toolbar_zoomSelection_popup li')[0].innerHTML = text;
                    var index = zoomddl.selectedIndex();
                    if (index == 0 && isNaN(parseFloat(values))) {
                        $('#' + proxy._id + '_toolbar_zoomSelection_hidden').val(text);
                        proxy._ejDropDownInstance.model.value = text;
                    }
                    proxy._searchBoxLocalization();
                }
                if (proxy._selectionRange != null && !proxy._displaySearch) {
                    proxy._selectionNodes.addRange(proxy._selectionRange);
                    proxy._selectionRange = null;
                    proxy._selectionNodes = null;
                }
            }, 5000);
        },

        _doAjaxPostscroll: function (type, url, jsonResult, isTargetFire) {
            var proxy = this;
            if (this._ajaxRequestState != null) {
                this._ajaxRequestState.abort();
                this._ajaxRequestState = null;
            }
            this._ajaxInProgress = true;
            ($.ajax({
                type: type,
                url: url,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    proxy._ajaxInProgress = false;
                    if (typeof data === 'object')
                        proxy._drawPdfPage(JSON.stringify(data));
                    else
                        proxy._drawPdfPage(data);
                    proxy._scrollTriggered = false;
                    if (proxy._searchText && proxy._isRequestFired) {
                        if (typeof data === 'object')
                            var backupjson = (JSON.stringify(data));
                        else
                            var backupjson = data;
                        if (typeof data === 'object') {
                            if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                                jsondata = JSON.parse((JSON.stringify(data)));
                            else
                                jsondata = JSON.parse((JSON.stringify(data))["d"]);
                        }
                        else {
                            if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                                jsondata = JSON.parse(data);
                            else
                                jsondata = JSON.parse(data["d"]);
                        }
                        proxy._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
                        proxy._pageText[parseInt(jsondata["currentpage"])] = jsondata["pageContents"];
                        if (proxy._searchText && proxy._isRequestFired) {
                            proxy._initSearch(proxy._searchPageIndex);
                        }
                    }
                    if (isTargetFire) {
                        if (proxy.model.allowClientBuffering) {
                            if (typeof data === 'object')
                                var jsonData = JSON.parse(JSON.stringify(data));
                            else
                                var jsonData = JSON.parse(data);
                            proxy._pagesGot.push(parseInt(jsonData["currentpage"]));
                            if (parseInt(jsonData["currentpage"]) <= proxy._totalPages) {
                                proxy._targetPage = jsonData["currentpage"] + 1;
                                proxy._isTargetPage = true;
                            }
                        }
                    }
                },
                error: function (msg, textStatus, errorThrown) {
                    if (msg.readyState == 0) {
                        return;
                    }
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }));
        },

        _drawPdfPage: function (jsondata) {
            var backupjson = jsondata;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsondata = JSON.parse(jsondata);
            else
                jsondata = JSON.parse(jsondata["d"]);
            this._renderedCanvasList.push(parseInt(jsondata["currentpage"]));
            var pageindex = parseInt(jsondata["currentpage"]);
            if (!this._isWindowResizing)
                this._showPageLoadingIndicator(pageindex, true);
            var pageimageList = jsondata["imagestream"];
            var canvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
            var context = canvas.getContext('2d');
            var ratio = this._scalingTextContent(context);
            if (this._pageSize[pageindex - 1].PageRotation == 90 || this._pageSize[pageindex - 1].PageRotation == 270) {
                canvas.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth;
                canvas.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight;
                canvas.style.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight + 'px';
                canvas.style.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth + 'px';
            }
            else {
                canvas.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth * ratio;
                canvas.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight * ratio;
                canvas.style.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight + 'px';
                canvas.style.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth + 'px';
            }
            if (canvas) {
                var context = canvas.getContext('2d');
                this._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
                this._pageText[parseInt(jsondata["currentpage"])] = jsondata["pageContents"];
                this._imageObj = new Array();
                if (!$('#' + this._id + 'selectioncanvas_' + pageindex).hasClass('text_container')) {
                    this._textSelection(jsondata, pageindex, context);
                    this._textMarkupAnnotationList[parseInt(jsondata["currentpage"])] = jsondata["textMarkupAnnotation"];
                    if (this._textMarkupAnnotationList[parseInt(jsondata["currentpage"])]) {
                        this._totalAnnotations[pageindex] = jsondata["textMarkupAnnotation"].slice();
                    }
                } else {
                    this._resizeSelection(jsondata, pageindex, context);
                }
                if (!$('#' + this._id + 'selectioncanvas_' + pageindex).hasClass('input_container')) {
                    this._createFormFields(jsondata, pageindex);
                } else {
                    this._generateFormFields(jsondata, pageindex);
                }
                if (navigator.userAgent.indexOf("Firefox") != -1) {
                    var shapes = pageimageList["textelements"];
                    for (var n = 0; n < shapes.length; n++) {
                        var pathdata = shapes[n];
                        var textureBrush = pathdata["textureBrushs"];
                        if (textureBrush) {
                            var textureImageData = pathdata.texturFields[0].Image;
                            var imageData = "data:image/png;base64," + textureImageData;
                            var imageObjects = new Image();
                            imageObjects.src = imageData;
                            this._imageSrcCollection.push(imageObjects.src);
                        }
                    }
                }
                if (this._isTextSearch) {
                    var proxy = this;
                    setTimeout(function () {
                        proxy._isPageScrollHighlight = true;
                        proxy._isPageScrolledForSearch = true;
                        proxy._highlightOtherOccurrences();
                    }, 100)
                }
                // Hyperlink
                var children = $('#' + this._id + 'selectioncanvas_' + pageindex).children();
                for (i = 0; i < children.length; i++) {
                    if (children[i].hasAttribute('href'))
                        $(children[i]).remove();
                }
                var linkannot = jsondata["linkannotation"];
                var documentlinkpagenumber = jsondata["annotpagenum"];
                var ins = this;
                if (this.model.enableHyperlink) {
                    for (var l = 0; l < linkannot.length; l++) {
                        var aTag = document.createElement('a');
                        aTag.id = 'linkdiv_' + l;
                        var rect = linkannot[l].AnnotRectangle;
                        aTag.style.background = 'transparent';
                        aTag.style.position = 'absolute';
                        aTag.style.left = this._convertPointToPixel(rect.Left * this._zoomVal) + 'px';
                        aTag.style.top = this._convertPointToPixel(rect.Top * this._zoomVal) + 'px';
                        aTag.style.width = this._convertPointToPixel(rect.Width * this._zoomVal) + 'px';
                        aTag.style.height = this._convertPointToPixel(rect.Height * this._zoomVal) + 'px';
                        aTag.style.color = 'transparent';
                        if (linkannot[l].URI.indexOf("mailto:") != -1) {
                            var mail = linkannot[l].URI.substring(linkannot[l].URI.indexOf("mailto:"), linkannot[l].URI.length);
                            aTag.title = mail;
                            aTag.setAttribute('href', mail);
                        } else {
                            aTag.title = linkannot[l].URI;
                            aTag.setAttribute('href', linkannot[l].URI);
                        }
                        if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.Default) {
                            aTag.target = "_self";
                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);
                            }
                        } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewTab) {
                            aTag.target = "_blank";
                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);

                            }
                        } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewWindow) {

                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);
                                window.open(this.href, '_blank', 'scrollbars=yes,resizable=yes');
                                return false;
                            }
                        }
                        if (documentlinkpagenumber[l] != undefined) {
                            var destPageHeight = (this._pageSize[pageindex - 1].PageHeight);
                            var destAnnotLoc = this._convertPointToPixel(linkannot[l].AnnotLocation);
                            var dest = (destPageHeight - destAnnotLoc);
                            var scrollvalue = (parseFloat(this._pageLocation[documentlinkpagenumber[l]] * this._zoomVal)) + parseFloat(dest * this._zoomVal);
                            aTag.name = scrollvalue;
                            aTag.onclick = function () {
                                var pageviewcontainer = document.getElementById(ins._id + '_viewerContainer');
                                pageviewcontainer.scrollTop = this.name;
                                return false;
                            }
                        }
                        if (documentlinkpagenumber[l] != null) {
                            var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                            selectioncanvas.appendChild(aTag);
                        }
                    }
                }
                //Hyperlink

                if (this._textMarkupAnnotationList[pageindex]) {
                    this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageindex], pageindex);
                }

                var index = parseInt(jsondata["currentpage"]);
                var imageObjCollection = new Array();
                var imageTransformCollection = new Array();
                var imageDataCollection = new Array();
                var currentIndexCollection = new Array();
                var pageDataCollection = new Array();
                var zoomFactor;
                var browserUserAgent = navigator.userAgent;
                var offsett;
                var imageIndex = 0;

                var charPath = new Array();
                var shapes = pageimageList["textelements"];
                for (var j = 0; j < shapes.length; j++) {
                    var pathdata = shapes[j];
                    var color = pathdata["color"];
                    var matrix = pathdata["matrix"];
                    if (matrix != null)
                        matrix = matrix["Elements"];
                    var brushMode = pathdata["brush"];
                    var pathValue = pathdata["pathValue"];
                    var isClipping = pathdata["iscliping"];
                    var restoreCanvas = pathdata["restorecanvas"];
                    var imageData = pathdata["imagedata"];
                    var fillMode = pathdata["fillrule"];
                    var fillStroke = pathdata["isFillandStroke"];
                    var fillColor = pathdata["fillcolor"];
                    var strokeColor = pathdata["strokecolor"];
                    var lineWidth = pathdata["linewidth"];
                    var lineCap = pathdata["linecap"];
                    var linearGradient = pathdata["linearGradientBrush"];
                    var textureBrush = pathdata["textureBrushs"];
                    var charID = pathdata["charID"];
                    var rectangle = pathdata["rectvalue"];
                    if (pathValue != null) {
                        pathValue = pathValue.split(";");
                        if (charID)
                            charPath[charID] = pathValue;
                    }
                    else if (pathValue == null && charID) {
                        pathValue = charPath[charID];
                    }
                    if (restoreCanvas == false) {
                        context.save();
                    }
                    if (pathValue != undefined) {
                        context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1] * this._zoomVal * ratio, matrix[2] * this._zoomVal * ratio, matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                    }
                    if (pathValue != null) {
                        context.beginPath();

                        for (var i = 0; i < pathValue.length; i++) {
                            var val = pathValue[i];
                            var pathType = val[0];
                            if (pathType == "M") {
                                val = val.substring(1, val.length);
                                val = val.split(" ");
                                context.moveTo((val[0]), val[1]);
                            }
                            else if (pathType == "L") {
                                val = val.substring(1, val.length);
                                val = val.split(" ");
                                context.lineTo((val[0]), val[1]);
                            }
                            else if (pathType == "C") {
                                val = val.substring(1, val.length);
                                val = val.split(" ");
                                context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                            }
                            else if (pathType == "Z") {
                                context.closePath();
                            }
                        }
                        if (isClipping == true) {
                            if (fillMode == "evenodd") {
                                context.msFillRule = "evenodd";
                                context.mozFillRule = "evenodd";
                                context.clip(fillMode);
                            }
                            context.clip();

                        }
                        else {
                            if (fillStroke == undefined) {
                                if (brushMode == "Fill") {
                                    if (linearGradient != undefined) {
                                        context.fillStyle = this._getGradientBrush(linearGradient, context);
                                    }
                                    else if (textureBrush != undefined) {
                                        context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                    }
                                    else
                                        context.fillStyle = color;
                                    if (fillMode == "evenodd") {
                                        context.msFillRule = "evenodd";
                                        context.mozFillRule = "evenodd";
                                        context.fill(fillMode);
                                    }
                                    context.fill();
                                }
                                else if (brushMode == "FillandStroke") {
                                    context.fillStyle = color;
                                    context.fill();
                                    context.strokeStyle = strokeColor;
                                    context.stroke();
                                }
                                else if (brushMode == "Stroke") {
                                    context.strokeStyle = strokeColor;
                                    context.lineWidth = lineWidth;
                                    context.lineCap = lineCap;
                                    context.stroke();
                                }
                                else {
                                    context.strokeStyle = color;
                                    context.lineWidth = lineWidth;
                                    context.lineCap = lineCap;
                                    context.stroke();
                                }
                            }
                            else {
                                context.strokeStyle = strokeColor;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                                if (linearGradient != undefined) {
                                    context.fillStyle = this._getGradientBrush(linearGradient, context);
                                }
                                else if (textureBrush != undefined) {
                                    context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                }
                                else
                                    context.fillStyle = fillColor;
                                if (fillMode == "evenodd") {
                                    context.msFillRule = "evenodd";
                                    context.mozFillRule = "evenodd";
                                    context.fill(fillMode);
                                }
                                context.fill();
                            }
                        }
                    }

                    if (restoreCanvas)
                        context.restore();
                    if (imageData != undefined) {
                        if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                            imageObjCollection.push(imageData);
                            imageTransformCollection.push(matrix);
                            pageDataCollection.push(shapes);
                            currentIndexCollection.push(j);
                            zoomFactor = this._zoomVal;
                            this._isContainImage = true;
                            break;
                        }
                        else {
                            var imageObj = new Image();
                            imageObj.src = imageData;
                            context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1] * this._zoomVal * ratio, matrix[2] * this._zoomVal * ratio, matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                            context.drawImage(imageObj, 0, 0, 1, 1);
                        }
                    }
                }

                if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                    for (var k = 0; k < imageObjCollection.length; k++) {
                        this._imageRendering(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, k, pageDataCollection, currentIndexCollection, charPath, canvas, index, imageIndex);
                        imageIndex++;
                    }
                }
                var tempcanvas = canvas;
                var proxy = this;
                if (this._pageSize[index - 1].PageRotation != 0) {
                    if (!(imageData != undefined && browserUserAgent.indexOf("Firefox") != -1)) {
                        tempcanvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                        var canvasUrl = tempcanvas.toDataURL();
                        var context = tempcanvas.getContext('2d');
                        var image = new Image();
                        image.onload = function () {
                            context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            }
                            context.save();
                            context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                            context.drawImage(image, -image.width / 2, -image.height / 2);
                            context.restore();
                        }
                        image.src = canvasUrl;
                    }
                }
                this._showPageLoadingIndicator(pageindex, false);
                return tempcanvas;
            }
        },
     _scalingTextContent: function (context) {
           var backingPixel = context.webkitBackingStorePixelRatio ||
          context.mozBackingStorePixelRatio ||
          context.msBackingStorePixelRatio ||
           context.oBackingStorePixelRatio ||
           context.backingStorePixelRatio || 1;
          var ratio = window.devicePixelRatio / backingPixel;
          return ratio;
      },
        _convertPointToPixel: function (value) {
            if (this._horizontalResolution)
                return (parseFloat(value) * (this._horizontalResolution / 72));
            else
                return (parseFloat(value) * (96 / 72));
        },

        _getRandomNum: function () {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        },

        _createGUID: function () {
            var guid;
            return guid = "Syncfusion_PDFviewer_" + (this._getRandomNum() + this._getRandomNum() + "-" + this._getRandomNum() + "-4" + this._getRandomNum().substr(0, 3) + "-" + this._getRandomNum() + this._getRandomNum() + this._getRandomNum()).toLowerCase();
        },

        _createFormFields: function (jsondata, pageindex) {
            var TextBoxField = jsondata["PdfRenderedFields"];
            var browserUserAgent = navigator.userAgent;
            var backgroundcolor;
            var proxy = this;
            if (TextBoxField != null) {
                for (var l = 0; l < TextBoxField.length; l++) {
                    var inputdiv;
                    if ((TextBoxField[l].PageIndex + 1) == pageindex) {
                        var boundingRect = TextBoxField[l].LineBounds;
                        if (TextBoxField[l].Name == "Textbox") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "text";
                            var backColor = TextBoxField[l].BackColor;
                            var foreColor = TextBoxField[l].FontColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "rgb(" + foreColor.R + "," + foreColor.G + "," + foreColor.B + ")");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            $(inputdiv).attr("name", TextBoxField[l].FieldName);
                            var fontSize = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            if (TextBoxField[l].MaxLength > 0) {
                                $(inputdiv).attr("maxlength", TextBoxField[l].MaxLength);
                            }
                            if (TextBoxField[l].InsertSpaces)
                                $(inputdiv).css("letter-spacing", fontSize);
                            if (TextBoxField[l].Text != "")
                                $(inputdiv).val(TextBoxField[l].Text);
                            else
                                $(inputdiv).val('');
                        }
                        else if (TextBoxField[l].Name == "Password") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "password";
                            var backColor = TextBoxField[l].BackColor;
                            var foreColor = TextBoxField[l].FontColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "rgb(" + foreColor.R + "," + foreColor.G + "," + foreColor.B + ")");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).attr("disabled", true);
                            $(inputdiv).attr("name", TextBoxField[l].FieldName);
                            var fontSize = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            if (TextBoxField[l].MaxLength > 0) {
                                $(inputdiv).attr("maxlength", TextBoxField[l].MaxLength);
                            }
                            if (TextBoxField[l].InsertSpaces)
                                $(inputdiv).css("letter-spacing", fontSize);
                            if (TextBoxField[l].Text != "")
                                $(inputdiv).val(TextBoxField[l].Text);
                            else
                                $(inputdiv).val('');
                        }
                        else if (TextBoxField[l].Name == "RadioButton") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "radio";
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].Selected == true)
                                $(inputdiv).prop("checked", true);
                            $(inputdiv).val(TextBoxField[l].Value);
                            $(inputdiv).attr("name", TextBoxField[l].GroupName);
                            $(inputdiv).css("cursor", "pointer");
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            if (browserUserAgent.indexOf('Chrome') != -1)
                                $(inputdiv).css("-webkit-apperance", "none");
                        }
                        else if (TextBoxField[l].Name == "CheckBox") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "checkbox";
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].Selected == true)
                                $(inputdiv).prop('checked', true);
                            else if (browserUserAgent.indexOf('Chrome') != -1)
                                $(inputdiv).css("-webkit-appearance", "none");
                            $(inputdiv).attr("name", TextBoxField[l].GroupName);
                            var backColor = TextBoxField[l].BackColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else {
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                                $(inputdiv).css("cursor", "pointer");
                            }
                        }
                        else if (TextBoxField[l].Name == "DropDown") {
                            inputdiv = document.createElement("select");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            $(inputdiv).attr("name", TextBoxField[l].Text);
                            if (TextBoxField[l].SelectedValue == "") {
                                var option = document.createElement("option");
                                option.id = "dropdownhide";
                                $(option).css("display", "none");
                                option.selected = "selected";
                                option.innerHTML = "";
                                inputdiv.appendChild(option);
                            }
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = document.createElement("option");
                                option.className = "e-dropdownSelect";
                                if (TextBoxField[l].SelectedValue == TextBoxField[l].TextList[j])
                                    $(option).prop("selected", true);
                                else
                                    $(option).prop("selected", false);
                                option.innerHTML = TextBoxField[l].TextList[j];
                                inputdiv.appendChild(option);
                            }
                            var backColor = TextBoxField[l].BackColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "black");
                        }
                        else if (TextBoxField[l].Name == "ListBox") {
                            inputdiv = document.createElement("select");
                            $(inputdiv).attr("multiple", "multiple");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            $(inputdiv).attr("name", TextBoxField[l].Text);
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = document.createElement("option");
                                option.className = "e-pdfviewer-ListBox"
                                for (var k = 0; k < TextBoxField[l].SelectedList.length; k++) {
                                    if (TextBoxField[l].SelectedList[k] == j)
                                        $(option).prop("selected", true);
                                }
                                option.innerHTML = TextBoxField[l].TextList[j];
                                inputdiv.appendChild(option);
                                var backColor = TextBoxField[l].BackColor;
                                var backColor = TextBoxField[l].BackColor;
                                if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                    $(inputdiv).attr("disabled", true);
                                    $(inputdiv).css("background-color", "none");
                                    $(inputdiv).css("cursor", "default");
                                }
                                else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            }
                            $(inputdiv).css("color", "black");
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).attr("disabled", true);
                        }
                        if (TextBoxField[l].Font != null) {
                            if (TextBoxField[l].Font.Bold || TextBoxField[l].Font.Italic || TextBoxField[l].Font.Strikeout ||
                                 TextBoxField[l].Font.Underline) {
                                if (TextBoxField[l].Font.Italic)
                                    inputdiv.style.fontStyle = "italic";
                                if (TextBoxField[l].Font.Bold)
                                    inputdiv.style.fontWeight = "Bold";
                            }
                            $(inputdiv).css("font-family", TextBoxField[l].Font.Name);
                            var heights = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            $(inputdiv).css("font-size", heights);
                        }
                        if ($(inputdiv).css("background-color") == "rgba(255, 255, 255, 0.2)") {
                            $(inputdiv).css("background-color", "rgba(0, 20, 200, 0.2)");
                        }
                        inputdiv.style.borderStyle = "solid";
                        inputdiv.id = this._id + 'input_' + pageindex + '_' + l;
                        inputdiv.className = 'e-pdfviewer-formFields';
                        inputdiv.style.margin = "0px";
                        inputdiv.style.zIndex = 1000;
                        inputdiv.style.left = this._convertPointToPixel(boundingRect.X * this._zoomVal) + 'px';
                        inputdiv.style.top = this._convertPointToPixel(boundingRect.Y * this._zoomVal) + 'px';
                        inputdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                        inputdiv.style.height = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                        inputdiv.style.position = 'absolute';
                        var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                        $('#' + this._id + 'selectioncanvas_' + pageindex).addClass('input_container');
                        selectioncanvas.appendChild(inputdiv);
                        var borderwidth;
                        var proxy = this;
                        var is_chrome = navigator.userAgent.indexOf('Chrome') != -1;
                        $(inputdiv).on("focus", function (e) {
                            var type = $(e.target).attr('type');
                            var list = $(e.target)[0].type;
                            var backgroundColour = $(e.target).css("background-color");
                            var currentIndex = backgroundColour.lastIndexOf(',');
                            var color = backgroundColour.slice(0, currentIndex + 1) + 0 + ")";
                            if (type == "checkbox" && is_chrome)
                                $(e.target).css("-webkit-appearance", "");
                            $(e.target).css("background-color", color);
                            borderwidth = e.target.style.borderWidth;
                            $(e.target).css('border-width', '0');
                            proxy._isFormFields = true;
                        });
                        $(inputdiv).on("blur", function (e) {
                            var type = $(e.target).attr('type');
                            var list = $(e.target)[0].type;
                            if (is_chrome)
                                var backgroundColour = $(e.target).css("background-color");
                            else
                                var backgroundColour = e.target.style["background-color"];
                            var currentIndex = backgroundColour.lastIndexOf(',');
                            if (type == "checkbox" && $(e.target).prop("checked") == true) {
                                var colors = backgroundColour.slice(0, currentIndex + 1) + 0 + ")";
                                $(e.target).css("background-color", colors);
                            }
                            else {
                                var color = backgroundColour.slice(0, currentIndex + 1) + 0.2 + ")";
                                $(e.target).css("background-color", color);
                            }
                            if (parseFloat(borderwidth) == 0)
                                $(e.target).css('border-width', "1px");
                             else
                                $(e.target).css('border-width', borderwidth);
                            proxy._isFormFields = false;
                        });
                        $(inputdiv).on("change", function (e) {
                            proxy.isDocumentEdited = true;
                        });
                        $(inputdiv).unbind('click').on("click touchstart", function (e) {
                            var type = $(e.target).attr('type');
                            var list = $(e.target)[0].type;
                            if (type == "password" || type == "text") {
                                $(e.target).select();
                                var target = $(e.target)[0];
                                $(target).on('keypress', function (e) {
                                    var MaxLength = $(target).attr("maxlength");
                                    if ($(target).val().length > (MaxLength - 2)) {
                                        var value = $(target).val() + String.fromCharCode(e.keyCode);
                                        $(target).val(value);
                                        $(target).blur();

                                    }
                                });
                                $(target).on("keyup", function (e) {
                                    var value = $(target).val();
                                    var jsonData = proxy._pageContents[proxy._currentPage];
                                    var jsdata = JSON.parse(jsonData);
                                    var TextBoxField = jsdata["PdfRenderedFields"];
                                    var field = (target.id).split("_");
                                    var fieldPosition = field[field.length - 1];
                                    if (value != TextBoxField[fieldPosition].Text) {
                                        proxy.isDocumentEdited = true;
                                    } else {
                                        proxy.isDocumentEdited = false;
                                    }
                                });
                                $(target).unbind('change').on("change", function (e) {
                                    var value = $(target).val();
                                    $(target).val(value);
                                });
                            }
                            if (type == "radio") {
                                var name = $(e.target).attr("name");
                                var radioButton = $('.e-pdfviewer-formFields:radio');
                                for (var m = 0; m < radioButton.length; m++) {
                                    if ($(radioButton[m]).attr("name") == name) {
                                        $(radioButton[m]).prop("checked", false);
                                    }
                                }
                                $(e.target).prop("checked", true);
                            }
                            else if (type == "checkbox") {
                                if ($(e.target).prop("checked") == true) {
                                    $(e.target).prop("checked", true);
                                    if (is_chrome)
                                        $(e.target).css("-webkit-appearance", "");
                                    $(e.target).css('border-width', "1px");
                                }
                                else {
                                    $(e.target).prop("checked", false);
                                    if (is_chrome)
                                        $(e.target).css("-webkit-appearance", "none");
                                }
                            }
                            else if (list == "select-one") {
                                proxy.isDocumentEdited = true;
                                var target = $(e.target)[0];
                                $(target).unbind('change').on("change", function (e) {
                                    var target = $(e.target)[0];
                                    var value = target.options[target.selectedIndex].text;
                                    var childrens = target.children;
                                    for (var k = 0; k < childrens.length; k++) {
                                        if (childrens[k].text == value)
                                            $(childrens[k]).prop("selected", true);
                                        else
                                            $(childrens[k]).prop("selected", false);
                                    }
                                });
                            }
                        });
                    }
                }
            }
        },
        _saveFormFieldsValue: function () {
            var result = {};
            var values = {};
            $('#' + this._id + '_toolbar_download').parent().parents(".e-pdfviewer-toolbarul").css("visibility", "");
            var input = $('.e-pdfviewer-formFields');
            if (input != null) {
                for (var i = 0; i < input.length; i++) {
                    if (input[i].type == "text" || input[i].type == "password")
                        result[input[i].name] = input[i].value;
                    else if (input[i].type == "radio" && $(input[i]).prop("checked") == true)
                        result[input[i].name] = input[i].value;
                    else if (input[i].type == "checkbox") {
                        if ($(input[i]).prop("checked") == true)
                            result[input[i].name] = $(input[i]).prop("checked");
                        else
                            result[input[i].name] = $(input[i]).prop("checked");
                    }
                    else if (input[i].type == "select-one") {
                        result[input[i].name] = input[i].options[input[i].selectedIndex].text;
                    }
                    else if (input[i].type == "select-multiple") {
                        var text = [];
                        var children = $(input[i]).children();
                        for (var j = 0; j < children.length; j++) {
                            if ($(children[j]).prop("selected") == true)
                                text.push(children[j].text);
                        }
                        text = JSON.stringify(text);
                        result[input[i].name] = text;
                    }
                }
            }
            var annotationList = new Array();
            for (var i = 1; i <= this._totalPages; i++) {
                var newArray = [];
                var existingAnnotationList = this._textMarkupAnnotationList[i];
                if (existingAnnotationList) {
                    for (var j = 0; j < existingAnnotationList.length; j++) {
                        var annotation = existingAnnotationList[j];
                        if (annotation) {
                            var opacity = annotation.Opacity;
                            if (annotation.TextMarkupAnnotationType == "Highlight")
                                opacity = opacity * 0.5;
                            if (annotation.Author == null) {
                                annotation.Author = this.model.strikethroughSettings.author;
                            }
                            for (var k = 0; k < annotation.Bounds.length; k++) {
                                var newObject = {
                                    index: annotation.index,
                                    colorA: annotation.Opacity * 255,
                                    colorR: annotation.Color.R,
                                    colorG: annotation.Color.G,
                                    colorB: annotation.Color.B,
                                    opacity: opacity,
                                    type: annotation.TextMarkupAnnotationType,
                                    author: annotation.Author,
                                    subject: annotation.Subject,
                                    text: annotation.note,
                                    xPosition: annotation.Bounds[k].X,
                                    yPosition: annotation.Bounds[k].Y,
                                    height: annotation.Bounds[k].Height,
                                    width: annotation.Bounds[k].Width
                                }
                                newArray.push(newObject);
                            }
                        }
                    }
                }
                annotationList[i - 1] = newArray;
            }
            var newAnnotationList = new Array();
            for (var i = 1; i <= this._totalPages; i++) {
                var newArray = [];
                newAnnotationList[i - 1] = newArray;
                for (var j = 0; j < this._newAnnotationList[i - 1].length; j++) {
                    var annotation = this._newAnnotationList[i - 1][j];
                    var opacity = annotation.opacity;
                    if (annotation.type == "Highlight")
                        opacity = opacity * 0.5;
                    for (var k = 0; k < annotation.bounds.length; k++) {
                        var newObject = {
                            type: annotation.type,
                            xPosition: annotation.bounds[k].xPosition,
                            yPosition: annotation.bounds[k].yPosition,
                            height: annotation.bounds[k].height,
                            width: annotation.bounds[k].width,
                            colorA: annotation.colorA,
                            colorR: annotation.colorR,
                            colorG: annotation.colorG,
                            colorB: annotation.colorB,
                            opacity: opacity,
                            author: annotation.author,
                            subject: annotation.subject,
                            text: annotation.note
                        }
                        newArray.push(newObject);
                    }
                }
                newAnnotationList[i - 1] = newArray;
            }
            values["savetextMarkupAnnotation"] = JSON.stringify(newAnnotationList);
            values["existingAnnotations"] = JSON.stringify(annotationList);
            values["savedFields"] = JSON.stringify(result);
            values["id"] = this._fileId;
            this._saveAs("POST", this.model.serviceUrl, JSON.stringify(values));
        },
        _saveAs: function (type, actionUrl, data) {
            var proxy = this;
            ($.ajax({
                type: type,
                url: actionUrl + '/' + this.model.serverActionSettings.download,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: data,
                traditional: true,
                async: this._isAsynchronousDownload,
                success: function (data) {
                    if (data)
                        proxy._save(data);
                },
                error: function (msg, textStatus, errorThrown) {
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }))
        },
        _generateFormFields: function (jsondata, pageindex) {
            var TextBoxField = jsondata["PdfRenderedFields"];
            var backgroundcolor;
            if (TextBoxField != null) {
                for (var l = 0; l < TextBoxField.length; l++) {
                    var boundingRect = TextBoxField[l].LineBounds;
                    var inputdiv = document.getElementById(this._id + 'input_' + pageindex + '_' + l);
                    if ((TextBoxField[l].PageIndex + 1) == pageindex) {
                        if (TextBoxField[l].Name == "Password" || TextBoxField[l].Name == "Textbox") {
                            var backColor = TextBoxField[l].BackColor;
                            var foreColor = TextBoxField[l].FontColor;
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "rgb(" + foreColor.R + "," + foreColor.G + "," + foreColor.B + ")");
                            var fontSize = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            if (TextBoxField[l].MaxLength > 0) {
                                $(inputdiv).attr("maxlength", TextBoxField[l].MaxLength);
                            }
                            if (TextBoxField[l].InsertSpaces)
                                $(inputdiv).css("letter-spacing", fontSize);
                            var value = $(inputdiv).val();
                            $(inputdiv).val(value);
                        }
                        else if (TextBoxField[l].Name == "RadioButton") {
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            if ($(inputdiv).prop("checked") == true)
                                $(inputdiv).prop("checked", true);
                            $(inputdiv).attr("name", TextBoxField[l].GroupName);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("cursor", "pointer");
                        }
                        else if (TextBoxField[l].Name == "CheckBox") {
                            var backColor = TextBoxField[l].BackColor;
                       
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            if ($(inputdiv).prop("checked") == true)
                                $(inputdiv).prop('checked', true);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else {
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                                $(inputdiv).css("cursor", "pointer");
                            }
                        }
                        else if (TextBoxField[l].Name == "DropDown") {
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            if (TextBoxField[l].SelectedValue == "") {
                                var option = $(inputdiv).children()[0];
                                option.id = "dropdownhide";
                                $(option).css("display", "none");
                                if ($(option).prop("selected") == true)
                                    $(option).prop('selected', true);
                                option.innerHTML = "";
                            }
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option;
                                if ($(inputdiv).children()[0].id == "dropdownhide")
                                    option = $(inputdiv).children()[j + 1];
                                else
                                    option = $(inputdiv).children()[j];
                                if ($(option).prop("selected") == true)
                                    $(option).prop('selected', true);
                                option.innerHTML = TextBoxField[l].TextList[j];
                                var backColor = TextBoxField[l].BackColor;
                                if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                    $(inputdiv).attr("disabled", true);
                                    $(inputdiv).css("background-color", "none");
                                    $(inputdiv).css("cursor", "default");
                                }
                                else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            }
                            $(inputdiv).css("color", "black");
                        }
                        else if (TextBoxField[l].Name == "ListBox") {
                            $(inputdiv).attr("multiple", "multiple");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = $(inputdiv).children()[j];
                                if ($(option).prop("selected") == true)
                                    $(option).prop('selected', true);
                                else
                                    $(option).prop('selected', false);
                                option.innerHTML = TextBoxField[l].TextList[j];
                                var backColor = TextBoxField[l].BackColor;
                                if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                    $(inputdiv).attr("disabled", true);
                                    $(inputdiv).css("background-color", "none");
                                    $(inputdiv).css("cursor", "default");
                                }
                                else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            }
                            $(inputdiv).css("color", "black");
                        }
                        if (TextBoxField[l].Font != null) {
                            if (TextBoxField[l].Font.Bold || TextBoxField[l].Font.Italic || TextBoxField[l].Font.Strikeout ||
                                 TextBoxField[l].Font.Underline) {
                                if (TextBoxField[l].Font.Italic)
                                    inputdiv.style.fontStyle = "italic";
                                if (TextBoxField[l].Font.Bold)
                                    inputdiv.style.fontWeight = "Bold";
                            }
                            $(inputdiv).css("font-family", TextBoxField[l].Font.Name);
                            var heights = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            $(inputdiv).css("font-size", heights);
                        }
                        if ($(inputdiv).css("background-color") == "rgba(255, 255, 255, 0.2)") {
                            $(inputdiv).css("background-color", "rgba(0, 20, 200, 0.2)");
                        }
                        inputdiv.style.borderStyle = "solid";
                        inputdiv.style.margin = "0px";
                        inputdiv.style.zIndex = 1000;
                        inputdiv.style.left = this._convertPointToPixel(boundingRect.X * this._zoomVal) + 'px';
                        inputdiv.style.top = this._convertPointToPixel(boundingRect.Y * this._zoomVal) + 'px';
                        inputdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                        inputdiv.style.height = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                        inputdiv.style.position = 'absolute';
                    }
                }
            }
        },

        _textSelection: function (jsondata, pageindex, context) {
            //Text selection line by line
            var is_edge = navigator.userAgent.indexOf("Edge") != -1;
            var isnbsp;
            var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            var selectionlines = jsondata["selection"];
            var textDivs = [];
            var textContents = [];
            var re = new RegExp(String.fromCharCode(160), "g");
            for (var l = 0; l < selectionlines.length; l++) {
                var innerText = " ";
                var boundingRect = selectionlines[l].LineBounds;
                var textdiv = document.createElement("DIV");
                textdiv.id = this._id + 'text_' + pageindex + '_' + l;
                textdiv.className = 'e-pdfviewer-textLayer';
                var text = selectionlines[l].Line;
                text = text.replace(/</g, "&lt;");
                text = text.replace(/>/g, "&gt;");
                var x = new RegExp("[\x00-\x80]+"); // is ascii
                var isAscii = x.test(text);
                var isRtl = this._isRtl(text);
                if (!isAscii && isRtl) {
                    var re = new RegExp(String.fromCharCode(160), "g");
                    text = text.replace(re, " ");
                    text = text.split("").reverse().join("");
                    textContents.push(text);
                }
                else {
                    textContents.push(selectionlines[l].Line.toString());
                }
                if (is_edgeNew && !is_ie) {
                    textdiv.innerHTML = text;
                }
                else {
                    if (this._previousBounds == parseInt(boundingRect.Y) || this._previousBounds == parseInt((boundingRect.Y) + 1) || this._previousBounds == parseInt((boundingRect.Y) - 1)) {
                        innerText = document.getElementById(this._id + 'text_' + pageindex + '_' + (l - 1));
                        if (innerText.innerHTML != " ") {
                            innerText.innerHTML = innerText.innerHTML.replace(/&nbsp;/g, ' ');
                            innerText.innerHTML = innerText.innerHTML.replace(/(\r\n|\n|\r)/gm, "");
                        }
                    }
                    this._previousBounds = parseInt(boundingRect.Y);
                    textdiv.innerHTML = text + "\r\n";
                    $(textdiv).filter(function () {
                        isnbsp = $(textdiv).html().match(/&nbsp;/);
                    });
                    if (isnbsp !== null) {
                        this._isNonBreackingCharacter = true;
                    }
                    textdiv.innerHTML = textdiv.innerHTML.replace(/&nbsp;/g, ' ');
                }
                textdiv.innerHTML = textdiv.innerHTML.replace(/&nbsp;/g, ' ')
                var newLines = text.replace(/  +/g, ' ');
                if (newLines != " ") {
                    textdiv.style.whiteSpace = 'pre';
                }
                textdiv.style.background = 'transparent';
                textdiv.style.position = 'absolute';
                textdiv.style.left = this._convertPointToPixel(boundingRect.X * this._zoomVal) + 'px';
                textdiv.style.top = this._convertPointToPixel(boundingRect.Y * this._zoomVal) + 'px';
                textdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                textdiv.style.color = 'transparent';
                textdiv.style.fontSize = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                textdiv.style.fontFamily = 'sans-serif';
                textdiv.style.opacity = '0.2';
                textdiv.style.transformOrigin = '0%';
                //settting the properties of div to context to calculate the width of the text in canvas
                context.fontFamily = 'sans-serif'
                context.fontSize = textdiv.style.fontSize;
                context.font = textdiv.style.fontSize + " " + textdiv.style.fontFamily;
                //scaling the div to match the width of the line in canvas
                var ctxwidth = context.measureText(selectionlines[l].Line).width;
                var scale = parseFloat(textdiv.style.width) / ctxwidth;
                textdiv.style.transform = 'scaleX(' + scale + ')';
                var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                $('#' + this._id + 'selectioncanvas_' + pageindex).addClass('text_container');
                selectioncanvas.appendChild(textdiv);
                var selectioncanvasWidth = selectioncanvas.getBoundingClientRect();
                var textDivWidth = textdiv.getBoundingClientRect();
                if ((textDivWidth.width + textDivWidth.left) >= (selectioncanvasWidth.width + selectioncanvasWidth.left) || (textDivWidth.width > selectioncanvasWidth.width)) {
                    $(textdiv).css("width", "auto");
                    var newWidth = textdiv.clientWidth;
                    $(textdiv).css("width", newWidth + "px");
                }
                textDivs.push(textdiv);
            }
            this._previousBounds = null;
            this._textDivs[pageindex] = textDivs;
            this._textContents[pageindex] = textContents;
            //Text selection line by line
        },

        _resizeSelection: function (jsondata, pageindex, context) {
            var selectionlines = jsondata["selection"];
            for (var l = 0; l < selectionlines.length; l++) {
                var boundingRect = selectionlines[l].LineBounds;
                var textdiv = document.getElementById(this._id + 'text_' + pageindex + '_' + l);
                if (textdiv) {
                    var text = selectionlines[l].Line;
                    textdiv.style.position = 'absolute';
                    textdiv.style.left = this._convertPointToPixel(boundingRect.X * this._zoomVal) + 'px';
                    textdiv.style.top = this._convertPointToPixel(boundingRect.Y * this._zoomVal) + 'px';
                    textdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                    var newLines = text.replace(/  +/g, ' ');
                    if (newLines != " ") {
                        textdiv.style.whiteSpace = 'pre';
                    }
                    textdiv.style.transformOrigin = '0%';
                    textdiv.style.opacity = '0.2';
                    textdiv.style.fontSize = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                    context.font = textdiv.style.fontSize + " " + textdiv.style.fontFamily;
                    context.fontSize = textdiv.style.fontSize;
                    var ctxwidth = context.measureText(selectionlines[l].Line).width;
                    var scale = parseFloat(textdiv.style.width) / ctxwidth;
                    textdiv.style.transform = 'scaleX(' + scale + ')';
                    var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                    var selectioncanvasWidth = selectioncanvas.getBoundingClientRect();
                    var textDivWidth = textdiv.getBoundingClientRect();
                    if ((textDivWidth.width + textDivWidth.left) >= (selectioncanvasWidth.width + selectioncanvasWidth.left) || (textDivWidth.width > selectioncanvasWidth.width)) {
                        $(textdiv).css("width", "auto");
                        var newWidth = textdiv.clientWidth;
                        $(textdiv).css("width", newWidth + "px");
                    }
                }
            }
        },

        _maintainSelection: function () {
            var selection = this._selectionNodes;
            var range = document.createRange();
            if (selection.anchorNode != null) {
                var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                var backward = false;
                if (!position && selection.anchorOffset > selection.focusOffset ||
                  position === Node.DOCUMENT_POSITION_PRECEDING)
                    backward = true;
                if (backward) {
                    range.setStart(selection.focusNode, selection.focusOffset);
                    range.setEnd(selection.anchorNode, selection.anchorOffset);
                }
                else {
                    range.setStart(selection.anchorNode, selection.anchorOffset);
                    range.setEnd(selection.focusNode, selection.focusOffset);
                }
                this._selectionRange = range;
            }
            selection.removeAllRanges();
        },

        /*function helps to enable and disable the loading indicator of the requested page*/
        _showPageLoadingIndicator: function (pageIndex, isShow) {
            if (isShow) {
                $('#' + this._id + 'pageDiv_' + pageIndex + '_WaitingPopup').css('display', 'block');
            }
            else {
                $('#' + this._id + 'pageDiv_' + pageIndex + '_WaitingPopup').css('display', 'none');
            }
        },

        _imageRendering: function (shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, index, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex) {
            var zoomValue = this._zoomVal;
            var imageObject = new Image();
            var proxy = this;
            var browserUserAgent = navigator.userAgent;
            imageObject.onload = function () {
                var isImageContentChanged = false;
                var ratio = proxy._scalingTextContent(context);
                    for (var l = 0; l < imageTransformCollection.length; l++) {
                        if (isImageContentChanged == false) {
                            var matrixData = imageTransformCollection[l];
                            context.setTransform(matrixData[0] * zoomValue * ratio, matrixData[1] * zoomValue * ratio, matrixData[2] * zoomValue * ratio, matrixData[3] * zoomValue * ratio, matrixData[4] * zoomValue * ratio, matrixData[5] * zoomValue * ratio);
                            if (imageDataCollection[imageIndex] != undefined) {
                                context.drawImage(imageDataCollection[imageIndex], 0, 0, 1, 1);
                            }
                            var dataIndex = currentIndexCollection[l];
                            dataIndex = dataIndex + 1;
                            var data = pageDataCollection[l];
                            while (dataIndex < data.length) {
                                var pathdata = data[dataIndex];
                                var color = pathdata["color"];
                                var matrix = pathdata["matrix"];
                                if (matrix != null)
                                    matrix = matrix["Elements"];
                                var brushMode = pathdata["brush"];
                                var pathValue = pathdata["pathValue"];
                                var isClipping = pathdata["iscliping"];
                                var restoreCanvas = pathdata["restorecanvas"];
                                var imageData = pathdata["imagedata"];
                                var fillMode = pathdata["fillrule"];
                                var fillStroke = pathdata["isFillandStroke"];
                                var fillColor = pathdata["fillcolor"];
                                var strokeColor = pathdata["strokecolor"];
                                var lineWidth = pathdata["linewidth"];
                                var lineCap = pathdata["linecap"];
                                var linearGradient = pathdata["linearGradientBrush"];
                                var textureBrush = pathdata["textureBrushs"];
                                var charID = pathdata["charID"];
                                var rectangle = pathdata["rectvalue"];
                                if (pathValue != null) {
                                    pathValue = pathValue.split(";");
                                    if (charID)
                                        charPath[charID] = pathValue;
                                }
                                else if (pathValue == null && charID) {
                                    pathValue = charPath[charID];
                                }
                                if (restoreCanvas == false) {
                                    context.save();
                                }
                                if (pathValue != undefined) {
                                    context.setTransform(matrix[0] * zoomValue * ratio, matrix[1], matrix[2], matrix[3] * zoomValue * ratio, matrix[4] * zoomValue * ratio, matrix[5] * zoomValue * ratio);
                                }

                                if (pathValue != null) {
                                    context.beginPath();

                                    for (var i = 0; i < pathValue.length; i++) {
                                        var val = pathValue[i];
                                        var pathType = val[0];
                                        if (pathType == "M") {
                                            val = val.substring(1, val.length);
                                            val = val.split(" ");
                                            context.moveTo((val[0]), val[1]);
                                        }
                                        else if (pathType == "L") {
                                            val = val.substring(1, val.length);
                                            val = val.split(" ");
                                            context.lineTo((val[0]), val[1]);
                                        }
                                        else if (pathType == "C") {
                                            val = val.substring(1, val.length);
                                            val = val.split(" ");
                                            context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                                        }
                                        else if (pathType == "Z") {
                                            context.closePath();
                                        }
                                    }
                                    if (isClipping == true) {
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                            context.clip(fillMode);
                                        }
                                        context.clip();

                                    }
                                    else {
                                        if (fillStroke == undefined) {
                                            if (brushMode == "Fill") {
                                                if (linearGradient != undefined) {
                                                    context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                                }
                                                else if (textureBrush != undefined) {
                                                    context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                                }
                                                else
                                                    context.fillStyle = color;
                                                if (fillMode == "evenodd") {
                                                    context.msFillRule = "evenodd";
                                                    context.mozFillRule = "evenodd";
                                                    context.fill(fillMode);
                                                }
                                                context.fill();
                                            }
                                            else if (brushMode == "FillandStroke") {
                                                context.fillStyle = color;
                                                context.fill();
                                                context.strokeStyle = strokeColor;
                                                context.stroke();
                                            }
                                            else if (brushMode == "Stroke") {
                                                context.strokeStyle = strokeColor;
                                                context.lineWidth = lineWidth;
                                                context.lineCap = lineCap;
                                                context.stroke();
                                            }
                                            else {
                                                context.strokeStyle = color;
                                                context.lineWidth = lineWidth;
                                                context.lineCap = lineCap;
                                                context.stroke();
                                            }
                                        }
                                        else {
                                            context.strokeStyle = strokeColor;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                            if (linearGradient != undefined) {
                                                context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                            }
                                            else if (textureBrush != undefined) {
                                                context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                            }
                                            else
                                                context.fillStyle = fillColor;
                                            if (fillMode == "evenodd") {
                                                context.msFillRule = "evenodd";
                                                context.mozFillRule = "evenodd";
                                                context.fill(fillMode);
                                            }
                                            context.fill();
                                        }
                                    }
                                }

                                if (restoreCanvas)
                                    context.restore();
                                if (imageData != undefined) {
                                    isImageContentChanged = true;
                                    imageObjCollection.pop();
                                    imageTransformCollection.pop();
                                    pageDataCollection.pop();
                                    currentIndexCollection.pop();
                                    imageObjCollection.push(imageData);
                                    imageTransformCollection.push(matrix);
                                    pageDataCollection.push(shapes);
                                    currentIndexCollection.push(dataIndex);
                                    l = -1;
                                    imageIndex++;
                                    break;
                                }
                                dataIndex++;
                            }
                        }
                        else {
                            proxy._imageRendering(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, l, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex);
                            imageIndex++;
                        }
                    }
                    if (dataIndex == shapes.length) {
                        if (proxy._pageSize[currentindex - 1].PageRotation != 0) {
                            var tempcanvas = document.getElementById(proxy._id + 'pagecanvas_' + currentindex);
                            var canvasUrl = tempcanvas.toDataURL();
                            var ctx = tempcanvas.getContext('2d');
                            var image = new Image();
                            image.onload = function () {
                                ctx.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                                if (proxy._pageSize[currentindex - 1].PageRotation == 90 || proxy._pageSize[currentindex - 1].PageRotation == 270) {
                                    tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                    tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                    tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                    tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                                } else {
                                    tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                    tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                    tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                    tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                                }
                                ctx.save();
                                ctx.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                                ctx.rotate((proxy._pageSize[currentindex - 1].PageRotation / 2) * Math.PI / 2);
                                ctx.drawImage(image, -image.width / 2, -image.height / 2);
                                ctx.restore();
                            }
                            image.src = canvasUrl;
                        }
                    }
                };
            imageObject.src = imageObjCollection[index];
            imageDataCollection.push(imageObject);
            this._imageObj.push(imageObject);
        },

        _createTextureBrush: function (textureBrush, context, pathdata) {
            var imageSrc = pathdata.texturFields[0].Image;
            var width = pathdata.texturFields[0].Width;
            var height = pathdata.texturFields[0].Height;
            var imageData = "data:image/png;base64," + imageSrc;
            var imageObjects = new Image();
            if (navigator.userAgent.indexOf("Firefox") != -1) {
                imageObjects.src = this._imageSrcCollection[0];
                this._loadimages(imageObjects, width, height, context);
                this._imageSrcCollection.shift();
            }
            else {
                imageObjects.src = imageData;
                this._loadimages(imageObjects, width, height, context);
            }
        },
        _loadimages: function (img, width, height, context) {
            var tempCanvas = document.createElement("canvas");
            var tempContext = tempCanvas.getContext("2d");
            tempCanvas.width = width;
            tempCanvas.height = height;
            tempContext.drawImage(img, 0, 0, img.width, img.height, 0, 0, tempCanvas.width, tempCanvas.height);
            var pattern = context.createPattern(tempCanvas, 'repeat');
            context.fillStyle = pattern;
            context.fill();
            return pattern;
        },
        _getGradientBrush: function (linearGradient, context) {
            var rectangle = linearGradient["Rectangle"];
            var interpolationColors = linearGradient["InterpolationColors"];
            var gradientColor = interpolationColors["Colors"];
            var gradientPosition = interpolationColors["Positions"];
            var gradient = context.createLinearGradient(rectangle["X"], rectangle["Y"], rectangle["Width"], rectangle["Height"]);
            for (var k = 0; k < gradientPosition.length; k++) {
                var colorCodeString = gradientColor[k];
                colorCodeString = colorCodeString.split(",");
                var colorCode = this._rgb2Color(colorCodeString[0], colorCodeString[1], colorCodeString[2]);
                gradient.addColorStop(gradientPosition[k], colorCode);
            }
            return gradient;
        },

        _rgb2Color: function (r, g, b) {
            return '#' + this._byte2Hex(r) + this._byte2Hex(g) + this._byte2Hex(b);
        },
        _byte2Hex: function (n) {
            var nybHexString = "0123456789ABCDEF";
            return String(nybHexString.substr((n >> 4) & 0x0F, 1)) + nybHexString.substr(n & 0x0F, 1);
        },
        //-------------------- Apply Page Style and Actions [End] -------------------------//

        //-------------------- Ajax Web API Call back methods[start] -------------------------//
        _doAjaxPost: function (type, url, jsonResult, onSuccess) {
            var proxy = this;
            var inVokemethod = onSuccess;
            if (this._ajaxRequestState != null) {
                this._ajaxRequestState.abort();
                this._ajaxRequestState = null;
            }
            this._ajaxRequestState = ($.ajax({
                type: type,
                url: url,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    if (typeof data === 'object')
                        data = JSON.stringify(data);
                    var jsData = JSON.parse(data);
                    var pagecount = jsData["pagecount"];
                    if (pagecount == 0) {
                        proxy._unLoad();
                    } else {
                        if (typeof data === 'object')
                            proxy[inVokemethod](JSON.stringify(data));
                        else
                            proxy[inVokemethod](data);
                        var name = (jsData["filename"]).split('\\');
                        var pdfFileName;
                        if (name.length > 1) {
                            pdfFileName = name[name.length - 1];
                        }
                        else if (proxy._fileName != "" && proxy._fileName != null) {
                            pdfFileName = proxy._fileName;
                        }
                        else {
                            pdfFileName = null;
                        }
                        var filename = { fileName: pdfFileName };
                        proxy._raiseClientEvent("documentLoad", filename);
                        if (proxy.model.allowClientBuffering) {
                            if (typeof data === 'object')
                                var jsonData = JSON.parse(JSON.stringify(data));
                            else
                                var jsonData = JSON.parse(data);
                            proxy._pagesGot.push(parseInt(jsonData["currentpage"]));
                        }
                    }
                },
                error: function (msg, textStatus, errorThrown) {
                    if (inVokemethod != "_clearCurrentServerCache") {
                        if (msg.readyState == 0) {
                            return;
                        }
                    }
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }));
        },

        /*
         * This function [_raiseClientEvent] is triggered when client side events (documentload,beforePrint,afterPrint,zoomchange,pageChange) are occured.
         */
        _raiseClientEvent: function (eventName, argument) {
            var eventfunction = this.model[eventName];
            var val = new Array();
            if (argument === null) {
                val = "";
            }
            else {
                val = argument;
            }
            if (eventfunction) {

                if (typeof eventfunction === "string") {
                    eventfunction = ej.util.getObject(eventfunction, window);
                }
                if ($.isFunction(eventfunction)) {
                    var args;
                    if (eventName == "pageChange")
                        args = { currentPageNumber: parseInt(argument.currentPageNumber) };
                    else if (eventName == "zoomChange")
                        args = { previousZoomPercentage: argument.previousZoomPercentage, currentZoomPercentage: argument.currentZoomPercentage };
                    else if (eventName == "hyperlinkClick")
                        args = { hyperlink: argument.hyperlink };
                    else if (eventName == "pageClick")
                        args = { XCoordinate: argument.offsetX, YCoordinate: argument.offsetY };
                    else if (eventName == "bufferStart")
                        args = { isBuffering: true };
                    else if (eventName == "bufferEnd")
                        args = { isBuffering: false };
                    else if (eventName == "documentLoad")
                        args = { fileName: argument.fileName };
                    else if (eventName == "ajaxRequestFailure")
                        args = { message: argument };
                    else if (eventName == "annotationAdd")
                        args = { annotationSettings: argument.annotationSettings, annotationID: argument.annotationId, pageID: argument.pageId, annotationBound: argument.annotationBound, annotationType: argument.annotationType };
                    else if (eventName == "annotationRemove")
                        args = { annotationID: argument.annotationId, pageID: argument.pageId, annotationType: argument.annotationType };
                    else if (eventName == "annotationPropertiesChange")
                        args = { annotationID: argument.annotationId, pageID: argument.pageId, annotationType: argument.annotationType, isColorChanged: argument.isColorChanged, isOpacityChanged: argument.isOpacityChanged };
                    else if (eventName == "annotationResize")
                        args = { annotationSettings: argument.annotationSettings, annotationID: argument.annotationID, pageID: argument.pageID, annotationBound: argument.annotationBound, annotationType: argument.annotationType };
                    this._trigger(eventName, args);
                }
            }
        },

        _getPageModel: function (jsondata) {
            this._on($(window), "resize", this._viewerResize);
            if (jsondata) {
                this._isJsondataAvailable = true;
            }
            if (jsondata == "" || jsondata == null) {
                this._showloadingIndicator(true);
                $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html("");
                $('#' + this._id + '_txtpageNo').val('0');
            }
            var jsData;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsData = JSON.parse(jsondata);
            else
                jsData = JSON.parse(jsondata["d"]);
            if (jsData) {
                this._pageWidth = jsData["pagewidth"];
                this._pageHeight = jsData["pageheight"];
                this._imageUrl = jsData["imageurl"];
                this._pageSize = jsData["pagesize"];
                this._totalPages = jsData["pagecount"];
                this.pageCount = this._totalPages;
                this._pdfFileName = jsData["filename"];
                if (this.fileName) {
                    this._pdfFileName = this.fileName;
                } else {
                    if (this._pdfFileName) {
                        this.fileName = this._pdfFileName;
                    }
                }
                this._currentPage = jsData["currentpage"];
                this._restrictionSummary = jsData["restrictionSummary"];
                this._horizontalResolution = jsData["horizontalResolution"];
                this._isRestrictionEnabled();
                if (this._isPrintRestrict)
                    this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_Print');
                else if (!this._isPrintRestrict)
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_Print');
                this.currentPageNumber = this._currentPage;
                if (!this._isToolbarClick) {
                    this._enableToolbarItems();
                }
                this._gotoPage(this._currentPage);
                this._toolbarResizeHandler();
                this._setSearchToolbarTop();
                this._resizeSearchToolbar();
                this._drawPdfPage(jsondata);
                for (var i = 0; i < this._totalPages; i++) {
                    var pageArray = [], newArray = [], deleteArray = [], undoArray = [], redoArray = [], modifiedArray = [], totalArray = [];
                    this._newAnnotationList[i] = pageArray;
                    this._colorModifiedAnnotationList[i] = newArray;
                    this._deletedAnnotationList[i] = deleteArray;
                    this._existingAnnotationsModified[i] = modifiedArray;
                    this._redoAnnotationCollection[i] = redoArray;
                    this._annotationsDeletedNo[i] = 0;
                    this._totalAnnotations[i + 1] = totalArray;
                }
                this._showNavigationIndicator(false);
                this._showloadingIndicator(false);
            }
        },
        _isRestrictionEnabled: function () {
            if (this._restrictionSummary) {
                for (var i = 0; i < this._restrictionSummary.length; i++) {
                    switch (this._restrictionSummary[i]) {
                        case 'Print':
                            this._isPrintRestrict = true;
                            break;
                        case 'CopyContent':
                            this._isCopyRestrict = true;
                            break;
                        case 'FillFields':
                            this._isFormFieldsDisabled = true;
                            break;
                        case 'EditAnnotations':
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_highlight');
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_underline');
                            break;
                    }
                }
            }
        },
        //-------------------- Ajax Web API Call back methods[end] -------------------------//

        //-------------------- Print Actions[Start] -------------------------//
        _print: function () {
            this._abortPrinting = false;
            this._isPrintingProcess = true;
            this._raiseClientEvent("beforePrint", null);
            this._showPrintLoadingIndicator(true);
            this._setViewerForPrint();
            this._scrollPageByPage();

        },

        //Set the viewer for printing with zoom as 100% and moves the page to first page.
        _setViewerForPrint: function () {
            this._isPrinting = true;
            this._currentPageBackup = this._currentPage;
            this._scrollTop = $('#' + this._id + '_viewerContainer').scrollTop();
            this._zoomValBackup = this._zoomVal;
            this._zoomLevelBackup = this._zoomLevel;
            if (this._zoomVal != 1) {
                this._zoomVal = 1;
                this._zoomLevel = 2;
                this._fitTypeBackup = this._fitType;
                this._zoomContainer(this._zoomVal, false);
            }
        },

        //Changes the page one by one to render the pages in the viewer.
        _scrollPageByPage: function () {

            for (var i = 1; i <= this._totalPages; i++) {
                this._scrollTriggered = false;
                var isPrintingStarted = this._scrollToPageNo(i);
                if (isPrintingStarted)
                    break;
            }
            this._isPrinting = false;
            if (!isPrintingStarted) {
                var browserUserAgent = navigator.userAgent;
                if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                    var proxy = this;
                    setTimeout(function () { proxy._printPages() }, 1000);
                } else {
                    this._printPages();
                }
                this._raiseClientEvent("afterPrint", null);
            }
        },

        //Gets the current page canvas and the scroll position.
        _scrollToPageNo: function (pageNo) {
            var currentPageNum = this._currentPage;
            if (this._totalPages) {
                var pagenumber = parseInt(pageNo);
                if (pagenumber >= 1 && pagenumber <= this._totalPages) {
                    this._currentPage = pagenumber;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    var isPrintingStarted = this._scrollPage(this._pageHeight);
                    return isPrintingStarted;
                }
            }
        },

        //Renders the current page and the next page in the viewer canvas.
        _scrollPage: function (pageHeight) {
            var currentPageNum = 0;
            this._scrollTriggered = true;
            var jsonResult = new Object();
            jsonResult["viewerAction"] = this._viewerAction.getPageModel;
            jsonResult["pageindex"] = this._currentPage.toString();
            jsonResult["id"] = this._fileId;
            var actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.print;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                this._doAjaxPostPrint("POST", actionUrl, JSON.stringify(jsonResult));
            else
                this._doAjaxPostPrint("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
            return true;
        },

        //Opens the print window, displays print dialog box and closes the print function.
        _printPages: function () {
            var browserUserAgent = navigator.userAgent;
            var proxy = this;
            var iframe = this._printIframe;
            iframe.name = "printFrame";
            iframe.style.position = "absolute";
            iframe.style.top = "-100000000px";
            document.body.appendChild(iframe);
            var frameDoc = iframe.contentWindow ? iframe.contentWindow : iframe.contentDocument.document ? iframe.contentDocument.document : iframe.contentDocument;
            frameDoc.document.open();
            if (browserUserAgent.indexOf('Edge') == -1) {
                if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                    //chrome and firefox
                    frameDoc.document.write('<!DOCTYPE html>');
                    frameDoc.document.write('<html moznomarginboxes mozdisallowselectionprint><head><style>html, body { height: 100%; } img { height: 100%; width: 100%; display: block; }@media print { body { margin: 0cm; }img { box-sizing: border-box; }br, button { display: none; }} @page{margin:0cm; size: 816px 1056px;}</style></head><body><center>');
                    //chrome and firefox
                }
                else {
                    //ie
                    frameDoc.document.write('<!DOCTYPE html>');
                    frameDoc.document.write('<html><head><style>html, body { height: 99%; } img { height: 99%; width: 100%; display: block; }@media print { body { margin: 0cm; }img { box-sizing: border-box; }br, button { display: none; }} @page{margin:0cm; size: 816px 1056px;}</style></head><body><center>');

                }
            }
            else {
                //ie
                frameDoc.document.write('<!DOCTYPE html>');
                frameDoc.document.write('<html><head><style>html, body { height: 99%; } img { height: 99%; width: 100%; display: block; }@media print { body { margin: 0cm; }img { box-sizing: border-box; }br, button { display: none; }} @page{margin:0cm; size: 816px 1056px;}</style></head><body><center>');
            }

            for (var i = 1; i <= proxy._totalPages; i++) {
                var canvasUrl = "", values = "";
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var selectionCanvas = document.getElementById(this._id + 'selectioncanvas_' + i);
                var secondaryCanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                canvasUrl = canvas.toDataURL();
                var secCanvasUrl = secondaryCanvas.toDataURL();

                if (window.innerWidth < screen.width) {
                    values = proxy._zoomVal;
                    proxy._topValue = true;
                    var jsdata = proxy._pageContents[parseInt(i)];
                    var newData = proxy._printPdfPages(jsdata);
                    canvasUrl = newData.toDataURL();
                    secCanvasUrl = secondaryCanvas.toDataURL();
                }
                else
                    values = 1;
                if ((browserUserAgent.indexOf("Firefox")) == -1) {
                    if (proxy._pageSize[i - 1].PageWidth > proxy._pageSize[i - 1].PageHeight) {
                        var context = canvas.getContext('2d');
                        var seccontext = secondaryCanvas.getContext('2d');
                        var image = new Image();
                        context.clearRect(0, 0, canvas.width, canvas.height);
                        canvas.width = proxy._pageSize[i - 1].PageHeight;
                        canvas.height = proxy._pageSize[i - 1].PageWidth;
                        canvas.style.height = proxy._pageSize[i - 1].PageWidth + 'px';
                        canvas.style.width = proxy._pageSize[i - 1].PageHeight + 'px';
                        context.save();
                        context.translate(canvas.width / 2, canvas.height / 2);
                        context.rotate(-Math.PI / 2);
                        image.src = canvasUrl;
                        context.drawImage(image, -image.width / 2, -image.height / 2);
                        context.restore();
                        canvasUrl = canvas.toDataURL();

                        seccontext.clearRect(0, 0, secondaryCanvas.width, secondaryCanvas.height);
                        secondaryCanvas.width = proxy._pageSize[i - 1].PageHeight;
                        secondaryCanvas.height = proxy._pageSize[i - 1].PageWidth;
                        secondaryCanvas.style.height = proxy._pageSize[i - 1].PageWidth + 'px';
                        secondaryCanvas.style.width = proxy._pageSize[i - 1].PageHeight + 'px';
                        seccontext.save();
                        seccontext.translate(secondaryCanvas.width / 2, secondaryCanvas.height / 2);
                        seccontext.rotate(-Math.PI / 2);
                        image.src = secCanvasUrl;
                        seccontext.drawImage(image, -image.width / 2, -image.height / 2);
                        seccontext.restore();
                        secCanvasUrl = secondaryCanvas.toDataURL();
                    }
                }
                frameDoc.document.write('<div style="margin:0px;width:816px;height:1056px;position:relative"><img src="' + canvasUrl + '" id="' + 'image_' + i + '" /><img src="' + secCanvasUrl + '" id = "secimage_' + i + '" style="margin:0px;top:0px;left:0px;position:absolute;width:816px;height:1056px;z-index:2" /><div id="' + 'fields_' + i + '"></div></div><br/>');
                var length = $(selectionCanvas).find('.e-pdfviewer-formFields').length;
                var cummulativepageheight = 2;
                for (var l = 0; l < length; l++) {
                    var index = "";
                    var inputdiv = $(selectionCanvas).find('.e-pdfviewer-formFields')[l];
                    var currentInput = inputdiv.cloneNode(true);
                    if (inputdiv.type == "select-one") {
                        index = inputdiv.selectedIndex;
                        var childrens = currentInput.children;
                        $(childrens[index]).prop("selected", true);
                    }
                    var PagesWidth = proxy._pageSize[i - 1].PageWidth;
                    var PagesHeight = proxy._pageSize[i - 1].PageHeight;
                    var heightRatio = PagesHeight / 1056;
                    var widthRatio = PagesWidth / 816;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    if (is_ie || browserUserAgent.indexOf('Edge') != -1) {
                        $(currentInput).css("left", ((parseFloat($(currentInput).css("left")))) + "px");
                        $(currentInput).css("top", ((parseFloat($(currentInput).css("top")) - 6)) + "px");
                    }
                    if (window.innerWidth < screen.width) {
                        $(currentInput).css("left", ((parseFloat($(currentInput).css("left")) / values)) + "px");
                        $(currentInput).css("top", ((parseFloat($(currentInput).css("top")) / values)) + "px");
                    }
                    $(currentInput).css("left", ((parseFloat($(currentInput).css("left")) / widthRatio)) + "px");
                    $(currentInput).css("top", ((parseFloat($(currentInput).css("top")) / heightRatio)) + "px");
                    $(currentInput).css("width", (parseFloat($(currentInput).css("width")) / values) + "px");
                    $(currentInput).css("height", (parseFloat($(currentInput).css("height")) / values) + "px");
                    $(frameDoc.document.getElementById('fields_' + i)).append(currentInput);
                }
            }
            this._topValue = false;
            frameDoc.document.write('</center></body></html>');
            if (navigator.userAgent.match("Firefox")) {
                window.frames["printFrame"].close();
            } else {
                frameDoc.document.close();
            }
            if (browserUserAgent.indexOf('Edge') == -1) {
                if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                    var proxy = this;
                    setTimeout(function () {
                        window.frames["printFrame"].focus();
                        window.frames["printFrame"].print();
                        document.body.removeChild(iframe);
                    }, 500);
                }
                else {
                    var target = $('iframe')[0];
                    try {
                        target.contentWindow.document.execCommand('print', false, null);
                    } catch (e) {
                        target.contentWindow.print();
                    }
                }
            }
            else {
                var target = $('iframe')[0];
                try {
                    target.contentWindow.document.execCommand('print', false, null);
                } catch (e) {
                    target.contentWindow.print();
                }
            }
            this._restoreViewer();
        },

        //Cancels the printing and restores the PDF viewer.
        _printCancel: function () {
            this._abortPrinting = true;
            this._restoreViewer();
            this._raiseClientEvent("afterPrint", null);
        },

        //Restores the viewer with the current zoom value and scroll position.
        _restoreViewer: function () {
            this._isPrintingProcess = false;
            this._currentPage = this._currentPageBackup;
            this._zoomVal = this._zoomValBackup;
            this._zoomLevel = this._zoomLevelBackup;
            for (var i = 1; i <= this._totalPages; i++) {
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                if (this._pageSize[i - 1].PageWidth > this._pageSize[i - 1].PageHeight) {
                    canvas.style.height = this._pageSize[i - 1].PageHeight + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageWidth + 'px';
                    canvas.width = this._pageSize[i - 1].PageWidth;
                    canvas.height = this._pageSize[i - 1].PageHeight;
                    this._renderedCanvasList.length = 0;
                }
            }
            if (this._fitTypeBackup == null) {
                this._zoomContainer(this._zoomVal, false);
            } else {
                var _scaleXY = this._fitToPage(this._fitTypeBackup);
                this._applyDropDownVal(_scaleXY, true, false);
                this._updatePageFitModel(this._fitType);
            }
            var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
            pageviewcontainer.scrollTop = this._scrollTop;
            this._showPrintLoadingIndicator(false);
        },

        _doAjaxPostPrint: function (type, url, jsonResult) {
            var parseJson = JSON.parse(jsonResult);
            if (this._pdfService == ej.PdfViewer.PdfService.Local) {
                this._currentPrintPage = parseJson["pageindex"];
            }
            else {
                var jsonData = parseJson["jsonResult"];
                this._currentPrintPage = jsonData["pageindex"];
            }
            if (this.model.allowClientBuffering && this._isBuffering) {
                if (this._ajaxRequestState != null) {
                    this._ajaxRequestState.abort();
                    this._ajaxRequestState = null;
                }
            }
            var proxy = this;
            ($.ajax({
                type: type,
                url: url,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    if (typeof data === 'object')
                        proxy._printPdfPages(JSON.stringify(data));
                    else
                        proxy._printPdfPages(data);
                    proxy._scrollTriggered = false;
                    if (proxy._abortPrinting) {
                        return;
                    }
                    if (parseFloat(proxy._currentPrintPage) < proxy.pageCount) {
                        var jsonResult = new Object();
                        jsonResult["viewerAction"] = proxy._viewerAction.getPageModel;
                        jsonResult["pageindex"] = (parseFloat(proxy._currentPrintPage) + 1).toString();//proxy._currentPage.toString();
                        jsonResult["id"] = proxy._fileId;
                        var actionUrl = proxy.model.serviceUrl + "/" + proxy.model.serverActionSettings.print;
                        if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                            proxy._doAjaxPostPrint("POST", actionUrl, JSON.stringify(jsonResult));
                        else
                            proxy._doAjaxPostPrint("POST", proxy.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                    }
                    else {
                        var browserUserAgent = navigator.userAgent;
                        if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                            setTimeout(function () { proxy._printPages() }, 1000);
                        } else {
                            proxy._printPages();
                        }
                        proxy._raiseClientEvent("afterPrint", null);
                    }
                },
                error: function (msg, textStatus, errorThrown) {
                    if (msg.readyState == 0) {
                        return;
                    }
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }));
        },

        //Rendering function for print.
        _printPdfPages: function (printData) {
            var imageIndex = 0;
            var backupjson = printData;
            var jsondata;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsondata = JSON.parse(printData);
            else
                jsondata = JSON.parse(printData["d"]);
            var pageindex = parseInt(jsondata["currentpage"]);
            this._showPageLoadingIndicator(pageindex, true);
            var pageimageList = jsondata["imagestream"];
            var index = parseInt(jsondata["currentpage"]);
            if (this._renderedCanvasList.indexOf(index) == -1) {
                this._renderedCanvasList.push(parseInt(jsondata["currentpage"]));
            }
            if (!this._pageContents[pageindex]) {
                this._textMarkupAnnotationList[parseInt(jsondata["currentpage"])] = jsondata["textMarkupAnnotation"];
            }
            this._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
            if (this._textMarkupAnnotationList[pageindex] || this._newAnnotationList[pageIndex - 1]) {
                this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageindex], pageindex);
            }
            var canvas;
            if (this._topValue == true) {
                var currentpage = parseInt(jsondata["currentpage"]);
                var canvas = document.createElement('canvas');
                var height = this._pageSize[currentpage - 1].PageHeight;
                var width = this._pageSize[currentpage - 1].PageWidth;
                canvas.style.visibility = 'hidden';
                canvas.style.width = width + "px";
                canvas.style.height = height + "px";
                canvas.style.backgroundColor = 'white';
                canvas.className = "e-pdfviewer-pageCanvas";
                canvas.height = height;
                canvas.width = width;
            }
            else
                canvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
            if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                canvas.height = this._zoomVal * this._pageSize[index - 1].PageHeight;
                canvas.width = this._zoomVal * this._pageSize[index - 1].PageWidth;
                canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
            }
            var context = canvas.getContext('2d');
            var imageObjCollection = new Array();
            var imageTransformCollection = new Array();
            var imageDataCollection = new Array();
            var currentIndexCollection = new Array();
            var pageDataCollection = new Array();
            var zoomFactor;
            var browserUserAgent = navigator.userAgent;
            var offsett;

            var charPath = new Array();
            this._regenerateFormFields(jsondata, pageindex);
            var children = $('#' + this._id + 'selectioncanvas_' + pageindex).children();
            for (i = 0; i < children.length; i++) {
                if (children[i].hasAttribute('href') || $(children[i]).hasClass('e-pdfviewer-formFields'))
                    $(children[i]).remove();
            }
            this._createFormFields(jsondata, pageindex);
            var shapes = pageimageList["textelements"];
            for (var j = 0; j < shapes.length; j++) {
                var pathdata = shapes[j];
                var color = pathdata["color"];
                var matrix = pathdata["matrix"];
                if (matrix != null)
                    matrix = matrix["Elements"];
                var brushMode = pathdata["brush"];
                var pathValue = pathdata["pathValue"];
                var isClipping = pathdata["iscliping"];
                var restoreCanvas = pathdata["restorecanvas"];
                var imageData = pathdata["imagedata"];
                var fillMode = pathdata["fillrule"];
                var fillStroke = pathdata["isFillandStroke"];
                var fillColor = pathdata["fillcolor"];
                var strokeColor = pathdata["strokecolor"];
                var lineWidth = pathdata["linewidth"];
                var lineCap = pathdata["linecap"];
                var linearGradient = pathdata["linearGradientBrush"];
                var textureBrush = pathdata["textureBrushs"];
                var charID = pathdata["charID"];
                if (pathValue != null) {
                    pathValue = pathValue.split(";");
                    if (charID)
                        charPath[charID] = pathValue;
                }
                else if (pathValue == null && charID) {
                    pathValue = charPath[charID];
                }
                if (restoreCanvas == false) {
                    context.save();
                }
                if (pathValue != undefined) {
                    context.setTransform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
                }

                if (pathValue != null) {
                    context.beginPath();

                    for (var i = 0; i < pathValue.length; i++) {
                        var val = pathValue[i];
                        var pathType = val[0];
                        if (pathType == "M") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.moveTo((val[0]), val[1]);
                        }
                        else if (pathType == "L") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.lineTo((val[0]), val[1]);
                        }
                        else if (pathType == "C") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                        }
                        else if (pathType == "Z") {
                            context.closePath();
                        }
                    }
                    if (isClipping == true) {
                        if (fillMode == "evenodd") {
                            context.msFillRule = "evenodd";
                            context.mozFillRule = "evenodd";
                            context.clip(fillMode);
                        }
                        context.clip();

                    }
                    else {
                        if (fillStroke == undefined) {
                            if (brushMode == "Fill") {
                                if (linearGradient != undefined) {
                                    context.fillStyle = this._getGradientBrush(linearGradient, context);
                                }
                                else if (textureBrush != undefined) {
                                    context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                }
                                else
                                    context.fillStyle = color;
                                if (fillMode == "evenodd") {
                                    context.msFillRule = "evenodd";
                                    context.mozFillRule = "evenodd";
                                    context.fill(fillMode);
                                }
                                context.fill();
                            }
                            else if (brushMode == "FillandStroke") {
                                context.fillStyle = color;
                                context.fill();
                                context.strokeStyle = strokeColor;
                                context.stroke();
                            }
                            else {
                                context.strokeStyle = color;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                            }
                        }
                        else {
                            context.strokeStyle = strokeColor;
                            context.lineWidth = lineWidth;
                            context.lineCap = lineCap;
                            context.stroke();
                            if (linearGradient != undefined) {
                                context.fillStyle = this._getGradientBrush(linearGradient, context);
                            }
                            else if (textureBrush != undefined) {
                                context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                            }
                            else
                                context.fillStyle = fillColor;
                            if (fillMode == "evenodd") {
                                context.msFillRule = "evenodd";
                                context.mozFillRule = "evenodd";
                                context.fill(fillMode);
                            }
                            context.fill();
                        }
                    }
                }

                if (restoreCanvas)
                    context.restore();
                if (imageData != undefined) {
                    if (((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) && !this._topValue) {
                        imageObjCollection.push(imageData);
                        imageTransformCollection.push(matrix);
                        this._printWinImageRendering(imageObjCollection, imageTransformCollection, imageDataCollection, context, canvas, imageIndex, index);
                        imageIndex++;
                    }
                    else {
                        var imageObj = new Image();
                        imageObj.src = imageData;
                        context.setTransform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
                        context.drawImage(imageObj, 0, 0, 1, 1);
                    }
                }
            }
            var tempcanvas = canvas;
            var proxy = this;
            if (this._pageSize[index - 1].PageRotation != 0) {
                if (!(imageObjCollection.length != 0 && (browserUserAgent.indexOf("Firefox") != -1 || browserUserAgent.indexOf("Chrome") != -1))) {
                    tempcanvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                    var canvasUrl = tempcanvas.toDataURL();
                    var context = tempcanvas.getContext('2d');
                    var image = new Image();
                    if ((browserUserAgent.indexOf("Firefox")) != -1) {
                        image.onload = function () {
                            context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px'
                            }
                            context.save();
                            context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                            context.drawImage(image, -image.width / 2, -image.height / 2);
                            context.restore();
                        }
                        image.src = canvasUrl;
                    } else {
                        context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                        if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                            tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                            tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                            tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                            tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                        } else {
                            tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                            tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                            tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px'
                        }
                        context.save();
                        context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                        context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                        image.src = canvasUrl;
                        context.drawImage(image, -image.width / 2, -image.height / 2);
                        context.restore();
                    }
                }
            }
            this._showPageLoadingIndicator(pageindex, false);
            return tempcanvas;
        },

        //Renders images while the image is loaded.
        _printWinImageRendering: function (imageObjCollection, imageTransformCollection, imageDataCollection, context, canvas, index, currentindex) {
            var proxy = this;
            var imageObject = new Image();
            imageObject.onload = function () {
                var matrixData = imageTransformCollection[index];
                context.setTransform(matrixData[0], matrixData[1], matrixData[2], matrixData[3], matrixData[4], matrixData[5]);
                if (imageDataCollection[index] != undefined) {
                    context.drawImage(imageDataCollection[index], 0, 0, 1, 1);
                }
                if (imageDataCollection.length - 1 == index) {
                    if (proxy._pageSize[currentindex - 1].PageRotation != 0) {
                        var tempcanvas = document.getElementById(proxy._id + 'pagecanvas_' + currentindex);
                        var canvasUrl = tempcanvas.toDataURL();
                        var ctx = tempcanvas.getContext('2d');
                        var image = new Image();
                        image.onload = function () {
                            ctx.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[currentindex - 1].PageRotation == 90 || proxy._pageSize[currentindex - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                            }
                            ctx.save();
                            ctx.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            ctx.rotate((proxy._pageSize[currentindex - 1].PageRotation / 2) * Math.PI / 2);
                            ctx.drawImage(image, -image.width / 2, -image.height / 2);
                            ctx.restore();
                        }
                        image.src = canvasUrl;
                    }
                }
            };
            imageObject.src = imageObjCollection[index];
            imageDataCollection.push(imageObject);
        },

        _showPrintButton: function (show) {
            if (show) {
                $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("display", "block");
                this._isPrintHidden = false;
            }
            else {
                $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("display", "none");
                this._isPrintHidden = true;
            }
        },
        _showDownloadButton: function (show) {
            if (show) {
                $('#' + this._id + '_toolbar_download').parent().parents(".e-pdfviewer-toolbarul").css("display", "block");
                this._isDownloadHidden = false;
            }
            else {
                $('#' + this._id + '_toolbar_download').parent().parents(".e-pdfviewer-toolbarul").css("display", "none");
                this._isDownloadHidden = true;
            }
        },
        //-------------------- Print Actions[end] -------------------------//

        //-------------------- Page Navigation Actions[Start] -------------------------//
        _updatePageNavigation: function (pageNo, totalPage) {
            if (pageNo > 1 && pageNo < totalPage) {
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            } else if (pageNo == 1 && pageNo < totalPage) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            } else if (pageNo == totalPage && totalPage != 1) {
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            } else {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            }
            if (!this._isJsondataAvailable) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            }

            this.currentPageNumber = this._currentPage;
        },

        _gotoFirstPage: function () {
            if (this._totalPages) {
                if (this._totalPages > 0) {
                    this._currentPage = 1;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoLastPage: function () {
            if (this._totalPages) {
                if (this._totalPages > 0) {
                    this._currentPage = this._totalPages;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoNextPage: function () {
            if (this._totalPages) {
                if (this._currentPage < this._totalPages) {
                    this._currentPage = this._currentPage + 1;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoPreviousPage: function () {
            if (this._totalPages) {
                if (this._currentPage > 1) {
                    this._currentPage = this._currentPage - 1;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoPageNo: function (pageNo) {
            var pagenumbervalue = { currentPageNumber: 0 };
            var pagenoentered = pageNo;
            var currentPageNum = this._currentPage;
            if (this._totalPages) {
                var pagenumber = parseInt(pageNo);
                if (pagenumber >= 1 && pagenumber <= this._totalPages && this._currentPage != pagenumber) {
                    this._currentPage = pagenumber;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
            if (currentPageNum != pagenoentered) {
                pagenumbervalue.currentPageNumber = pagenoentered;
                this._raiseClientEvent("pageChange", pagenumbervalue);
            }
        },

        _gotoPage: function (pageNo) {
            this._setPageSize(this._pageHeight, this._pageWidth, null, null);
            var pagenumber = parseInt(pageNo);
            this._updatePageNavigation(pagenumber, this._totalPages);
            if (this._totalPages > 0 && this._totalPages) {
                $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + this._totalPages);
                $('#' + this._id + '_txtpageNo').val(pagenumber);
            }
        },

        _allowOnlyNumbers: function (event) {
            if ((event.which < 48 || event.which > 57) && event.which != 8 && event.which != 13) {
                return false;
            }
            else {
                return true;
            }
        },

        _onkeyPress: function (event) {
            if (event.which == 13) {
                event.preventDefault();
                try {
                    var val = parseInt($(event.currentTarget).val());
                    if (val > 0 && val <= this.pageCount)
                        this._gotoPageNo(val);
                    else
                        $(event.currentTarget).val(this.currentPageNumber);
                } catch (err) {
                }
            }
        },

        _showPageNavigationControls: function (show) {
            if (show) {
                $('#' + this._id + '_txtpageNo').parents(".e-pdfviewer-toolbarul").css("display", "block");
                $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("border-right-width", "1px");
                this._isNavigationHidden = false;
            } else {
                $('#' + this._id + '_txtpageNo').parents(".e-pdfviewer-toolbarul").css("display", "none");
                this._isNavigationHidden = true;
                if (!this._isPrintHidden && this._isNavigationHidden && this._isMagnificationHidden) {
                    $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("border-right-width", "0px");
                }
            }
        },
        //-------------------- Page Navigation Actions[End] -------------------------//


        //-------------------- FitToPage[start] -------------------------//
        _showFittoPage: function (show) {
            if (show) {
                $('#' + this._id + '_fitWidth').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_fitPage').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_fitPage').parents("ul.e-pdfviewer-toolbarul").css("display", "block");
            } else {
                $('#' + this._id + '_fitWidth').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_fitPage').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_fitPage').parents("ul.e-pdfviewer-toolbarul").css("display", "none");
            }
        },

        _resetPage: function () {
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            if (pagecontainer[0] != undefined) {
                pageViewline.css({ "width": pagecontainer.width(), "height": pagecontainer.height() });
                pageViewline.css({ "width": pagecontainer[0].getBoundingClientRect().width, "height": pagecontainer[0].getBoundingClientRect().height });
            }
        },

        /*  _applyFitToWidth() is a event handler for the fitWidth button. This function fits the page to width of the container and applies the
            dropDown value to the zoom dropdown list. Then updates the page fit button.
        */
        _applyFitToWidth: function () {
            this._isAutoZoom = false;
            var _scaleXY = this._fitToPage("fitToWidth");
            this._applyDropDownVal(_scaleXY, true, false);
            this._updatePageFitModel(this._fitType);
            this.model.isResponsive = false;
        },

        /*  _applyFitToPage() is a event handler for the fitPage button. This function fits the page to the container and applies the
            dropDown value to the zoom dropdown list. Then updates the page fit button.
        */
        _applyFitToPage: function () {
            this._isAutoZoom = false;
            var _scaleXY = this._fitToPage("fitToPage");
            this._applyDropDownVal(_scaleXY, false, true);
            this._updatePageFitModel(this._fitType);
            this.model.isResponsive = false;
        },


        /* _updatePageFitModel() function is used to enable or disable the PageFit button. This is done by adding and removing 
          a class "e-pdfviewer-disabled-fitButton".
        */
        _updatePageFitModel: function (fitType) {
            if (fitType == "fitToWidth") {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
                $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            } else if (fitType == "fitToPage") {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
            }
        },

        _applyFitToWidthAuto: function () {
            var _scaleXY = this._fitToAuto("fitToWidth");
            this._applyDropDownValAuto(_scaleXY, true, false);
        },

        _fitToAuto: function (fitType) {
            this._resetPage();
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            if (pageViewerContainer[0] != undefined) {
                var w = pageViewerContainer.width();
                var h = pageViewerContainer.height();
                var pageW = this._pageWidth;
                var pageH = this._pageHeight;
                var scaleX = 1;
                var scaleY = 1;
                scaleX = (w - 25) / pageW;
                if (this._isAutoZoom) {
                    scaleX = Math.min(1, scaleX);
                    if (scaleX == 1)
                        this._zoomLevelBackup = this._zoomLevel = 3;

                }
                if (window.innerWidth >= screen.width) {
                    this._isWindowResizing = false;
                }
                scaleY = scaleX;
                this._zoomVal = scaleX;
                this._fitToAutoSize();
                this._calculateZoomLevel(this._zoomVal);
                this._initRerendering();
                this._updateZoomButtons();
                return { scalX: scaleX, scalY: scaleY }
            }
        },

        _fitToPage: function (fitType) {
            if (this._pageSize != undefined) {
                this._resetPage();
                var pageViewerContainer = $('#' + this._id + '_viewerContainer');
                var pagecontainer = $('#' + this._id + '_pageviewContainer');
                var pageViewline = $('#' + this._id + '_pageviewOuterline');
                var w = pageViewerContainer.width();
                var h = pageViewerContainer.height();
                if (fitType == "fitToWidth") {
                    for (var i = 0; i < this._pageSize.length; i++) {
                        var pageWidth = 0;
                        if (this._pageSize[i].PageRotation == 90 || this._pageSize[i].PageRotation == 270) {
                            pageWidth = this._pageSize[i].PageHeight;
                        } else {
                            pageWidth = this._pageSize[i].PageWidth;
                        }
                        if (pageWidth > this._highestWidth) {
                            this._highestWidth = pageWidth;
                        }
                    }
                } else {
                    this._highestWidth = this._pageWidth;
                }
                if (fitType == "fitToPage") {
                    for (var i = 0; i < this._pageSize.length; i++) {
                        var pageHeight = 0;
                        if (this._pageSize[i].PageRotation == 90 || this._pageSize[i].PageRotation == 270) {
                            pageHeight = this._pageSize[i].PageWidth;
                        } else {
                            pageHeight = this._pageSize[i].PageHeight;
                        }
                        if (pageHeight > this._highestHeight) {
                            this._highestHeight = pageHeight;
                        }
                    }
                } else {
                    this._highestHeight = this._PageHeight;
                }
                var pageW = this._highestWidth;
                var pageH = this._highestHeight;
                var scaleX = 1;
                var scaleY = 1;
                this._fitType = fitType;
                if (fitType == "fitToPage") {
                    scaleX = (w - 25) / pageW;
                    scaleY = (h) / pageH;
                    if (h > pageH) {
                        scaleY = this._preZoomVal;
                    }

                    if (w > pageW) {
                        scaleX = this._preZoomVal;
                    }
                    scaleX = scaleY;
                    this._zoomVal = scaleX;
                    this._zoomInContainer();
                    this._calculateZoomLevel(this._zoomVal);
                    $('#' + this._id + 'pageDiv_' + (this._currentPage + 1)).css("visibility", "hidden");
                    var proxy = this;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    $('#' + this._id + '_viewerContainer').on('mousewheel DOMMouseScroll', function (e) {
                        var pageviewcontainer = document.getElementById(proxy._id + '_viewerContainer');
                        var fittopage = $('#' + proxy._id + '_pdfviewer_toolbar_fitPage').attr('aria-disabled');
                        if (fittopage == "true") {
                            if (e.originalEvent.wheelDelta > 0 || e.originalEvent.detail < 0) {
                                if (proxy._currentPage > 1) {
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage - 1)).css("visibility", "");
                                    pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage - 1] * proxy._zoomVal));
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                                }
                            }
                            else {
                                if (proxy._currentPage != proxy._totalPages) {
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 1)).css("visibility", "");
                                    pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage + 1] * proxy._zoomVal));
                                    if ((proxy._currentPage + 1) == proxy._totalPages) {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                                    }
                                    else {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 2)).css("visibility", "hidden");
                                    }
                                }
                            }
                            e.preventDefault();
                        }
                    });
                    $(window).on('keydown', function (e) {
                        var pageviewcontainer = document.getElementById(proxy._id + '_viewerContainer');
                        var fittopage = $('#' + proxy._id + '_pdfviewer_toolbar_fitPage').attr('aria-disabled');
                        if (fittopage == "true") {
                            if (proxy._currentPage > 1 && e.keyCode == '38') {
                                $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage - 1)).css("visibility", "");
                                pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage - 1] * proxy._zoomVal));
                                $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                            }
                            else {
                                if (proxy._currentPage != proxy._totalPages && e.keyCode == '40') {
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 1)).css("visibility", "");
                                    pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage + 1] * proxy._zoomVal));
                                    if ((proxy._currentPage + 1) == proxy._totalPages) {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                                    }
                                    else {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 2)).css("visibility", "hidden");
                                    }
                                }
                            }
                        }
                    });
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage - 1)).css("visibility", "hidden");
                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 1)).css("visibility", "hidden");

                } else if (fitType == "fitToWidth") {
                    scaleX = (w - 25) / pageW;
                    scaleY = scaleX;
                    this._zoomVal = scaleX;
                    this._zoomInContainer();
                    this._calculateZoomLevel(this._zoomVal);
                }
                this._updateZoomButtons();
                return { scalX: scaleX, scalY: scaleY }
            }
        },

        _selectDropDownIndex: function (index) {
            var _selectedObj = $($('#' + this._id + '_toolbar_zoomSelection_popup li')[index]);
            _selectedObj.addClass('e-active');
            $('#' + this._id + '_toolbar_zoomSelection_input').val(_selectedObj.text());
        },

        _applyDropDownVal: function (scaleXY, orientationX, isFittoPage) {
            if (scaleXY != undefined) {
                if (isFittoPage) {
                    var _maxScale = scaleXY.scalX > scaleXY.scalY ? scaleXY.scalY : scaleXY.scalX;
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((_maxScale * 100)) + "%");
                    this._ejDropDownInstance.model.value = Math.round(_maxScale * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                }
                else if (orientationX) {
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((scaleXY.scalX * 100)) + "%");
                    this._ejDropDownInstance.model.value = Math.round(scaleXY.scalX * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                } else {
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((scaleXY.scalY * 100)) + "%");
                    this._ejDropDownInstance.model.value = Math.round(scaleXY.scalY * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                }
            }
        },

        _applyDropDownValAuto: function (scaleXY, orientationX, isFittoPage) {
            if (!this._isAutoZoom) {
                $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((scaleXY.scalY * 100)) + "%");
                this._ejDropDownInstance.model.value = Math.round(scaleXY.scalY * 100) + "%";
                this._ejDropDownInstance.model.selectedIndices[0] = "";
            }
            else {
                var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                var text = localeObj['contextMenu']['auto']['contentText'];
                $('#' + this._id + '_toolbar_zoomSelection_hidden').val(text);
                this._ejDropDownInstance.model.value = text;
            }
            $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
        },

        _showFitToPagetip: function () {
            var fittoPage = $('#' + this._id + '_toolbar_fittoPagePopup');
            if (!(fittoPage.length > 0)) {
                fittoPage = this._renderPageFitPopup();
                $('body').append(fittoPage);
                this._on($('#' + this._id + '_toolbar_fittoPagePopup li.e-pdfviewer-popupli'), "click", this._pageFitMenuClick);
            }

            if (fittoPage.css('display') == 'block') {
                fittoPage.css('display', 'none');
            } else {
                fittoPage.css('display', 'block');
            }

            var exportTagPos = $('#' + this._id + '_toolbarContainer .e-pdfviewer-pagefit')[0].getBoundingClientRect();
            var expTagPos = $($('#' + this._id + '_toolbarContainer .e-pdfviewer-pagefit')[0]).offset();
            fittoPage.css({ 'top': (expTagPos.top + exportTagPos.height) - 3, 'left': (expTagPos.left - 5) });
        },
        //-------------------- FitToPage[end] -------------------------//

        //-------------------- Page Zoom[start] -------------------------//
        _zoomValChange: function (sender) {
            if (!this._ejViewerInstance) {
                var id = this._id.split('_toolbar')[0];
                var ejViewer = $("#" + id);
                var ejViewerInstance = ejViewer.ejPdfViewer("instance");
            }
            var zoomVal;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var text = localeObj['contextMenu']['auto']['contentText'];
            if (sender.value != undefined) {
                if (sender.value == text) {
                    ejViewerInstance.model.isResponsive = true;
                    zoomVal = 1;
                    ejViewerInstance._zoomLevel = 3;
                    ejViewerInstance._isAutoZoom = true;
                }
                else {
                    zoomVal = parseInt(sender.value) / 100;
                    ejViewerInstance.model.isResponsive = false;
                    ejViewerInstance._zoomLevel = sender.itemId;
                    ejViewerInstance._isAutoZoom = false;
                }

                ejViewerInstance._zoomContainer(zoomVal, false);
            } else if (sender.target.innerHTML != undefined) {
                var str = sender.target.innerHTML;
                if (sender.target.innerHTML == text) {
                    ejViewerInstance.model.isResponsive = true;
                    zoomVal = 1;
                    ejViewerInstance._isAutoZoom = true;
                }
                else {
                    var str = str.substring(0, str.length - 1);
                    zoomVal = parseInt(str) / 100;
                    ejViewerInstance.model.isResponsive = false;
                    ejViewerInstance._isAutoZoom = false;
                }
                ejViewerInstance._zoomContainer(zoomVal, false);
            }
        },

        _zoomIn: function () {
            if (this._zoomLevel >= 7) {
                this._zoomLevel = 7;
            } else {
                this._zoomLevel++;
            }
            if (this._isDevice) {
                this._mobileLayoutZoomChange();
            } else {
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                zoomddl._selectItemByIndex(this._zoomLevel);
            }
            this.model.isResponsive = false;
        },

        _zoomOut: function () {
            if (this._zoomLevel <= 1) {
                this._zoomLevel = 1;
            } else {
                this._zoomLevel--;
            }
            if (this._isDevice) {
                this._mobileLayoutZoomChange();
            } else {
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                zoomddl._selectItemByIndex(this._zoomLevel);
            }
            this.model.isResponsive = false;
        },

        _zoomInContainer: function (isFactor, scaleFactor) {
            var zoomFactor = scaleFactor;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            this._selectionNodes = window.getSelection();
            $('.e-pdfviewer-formFields').hide();
            if (!(this._selectionNodes.anchorOffset == 0 && this._selectionNodes.focusOffset == 0)) {
                this._maintainSelection();
            }
            if (isFactor) {
                this._zoomVal = this._zoomVal + zoomFactor;
            }
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            var zoomineventvalue = { currentZoomPercentage: 0, previousZoomPercentage: 0 };
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolValue = vscrolBar.scrollTop;
            var scrollValue = (vscrolValue / this._previousZoom) * this._zoomVal;
            var transform = "scale(" + this._zoomVal + "," + this._zoomVal + ")";
            for (var i = 1; i <= this._totalPages; i++) {
                var leftpos;
                var pageWidth = 0;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                    pageWidth = this._pageSize[i - 1].PageHeight;
                } else {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                    pageWidth = this._pageSize[i - 1].PageWidth;
                }
                if (leftpos < 0 || (this._fitType == "fitToWidth" && pageWidth == this._highestWidth))
                    leftpos = 5;
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var seccanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                var context = canvas.getContext('2d');
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    canvas.height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.style.height = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                    var height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    var width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.style.width = width + "px";
                    canvas.style.height = height + "px";
                    seccanvas.width = width;
                    seccanvas.height = height;
                    seccanvas.style.width = width + "px";
                    seccanvas.style.height = height + "px";
                }
                else {
                    canvas.height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.style.height = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                    var height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    var width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.style.width = width + "px";
                    canvas.style.height = height + "px";
                    seccanvas.width = width;
                    seccanvas.height = height;
                    seccanvas.style.width = width + "px";
                    seccanvas.style.height = height + "px";
                }
                context.clearRect(0, 0, canvas.clientWidth, canvas.clientHeight);
                var pagediv = $('#' + this._id + 'pageDiv_' + i);
                pagediv[0].style.top = this._pageLocation[i] * this._zoomVal + "px";
                pagediv[0].style.left = leftpos + "px";
                pagediv[0].style.width = width + 'px';
                pagediv[0].style.height = height + 'px';
                //Hyperlink canvas

                var hyperlinklayer = document.getElementById(this._id + 'selectioncanvas_' + i);
                hyperlinklayer.style.height = canvas.height + 'px';
                hyperlinklayer.style.width = canvas.width + 'px';
                hyperlinklayer.style.position = 'absolute';
                hyperlinklayer.style.left = 0;
                hyperlinklayer.style.top = 0;
                hyperlinklayer.style.backgroundColor = 'transparent';
                hyperlinklayer.style.zIndex = '2';

                if (!this._isAutoZoom) {
                    //resizing the loding indicator of the page
                    $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'block', 'height': canvas.height + 'px', 'width': canvas.width + 'px', 'left': '0px', 'top': '0px' });
                    var loadingindicator = document.getElementById(this._id + 'pageDiv_' + i + '_WaitingPopup');
                    var spanDiv = loadingindicator.childNodes[0];
                    spanDiv.style.top = (canvas.height - spanDiv.clientHeight) / 2 + 'px';
                }
            }
            if (this._renderedCanvasList)
                this._renderedCanvasList.length = 0;

            if (this._zoomVal < 1)
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': (this._cummulativeHeight * this._zoomVal) - this.element.height() + 50 + "px" });
            else {
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': "" });
            }
            if (this._imageObj) {
                for (var i = 0; i < this._imageObj.length; i++) {
                    this._imageObj[i].onload = null;
                }
            }
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            vscrolBar.scrollTop = scrollValue;
            this._eventpreviouszoomvalue = this._preZoomVal;
            this._eventzoomvalue = this._zoomVal;
            this._preZoomVal = this._zoomVal;
            this._previousZoom = this._zoomVal;
            zoomineventvalue.previousZoomPercentage = Math.round(this._eventpreviouszoomvalue * 100);
            zoomineventvalue.currentZoomPercentage = Math.round(this._eventzoomvalue * 100);
            this._raiseClientEvent("zoomChange", zoomineventvalue);
            this.zoomPercentage = Math.round(this._zoomVal * 100);
            this._highestWidth = 0;
            this._highestHeight = 0;
            var annotationArray = [];
            if (this._selectedAnnotationObject) {
                annotationArray.push(this._selectedAnnotationObject.annotation);
                this._drawAnnotSelectRect(this._selectedAnnotationObject.pageIndex, annotationArray);
            }
        },

        _zoomOutContainer: function (isFactor, scaleFactor) {

            var zoomFactor = scaleFactor;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            this._selectionNodes = window.getSelection();
            $('.e-pdfviewer-formFields').hide();
            if (!(this._selectionNodes.anchorOffset == 0 && this._selectionNodes.focusOffset == 0)) {
                this._maintainSelection();
            }
            if (isFactor) {
                this._zoomVal = this._zoomVal + zoomFactor;
            }
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            var zoomouteventvalue = { currentZoomPercentage: 0, previousZoomPercentage: 0 };
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolValue = vscrolBar.scrollTop;
            var scrollValue = (vscrolValue / this._previousZoom) * this._zoomVal;
            var transform = "scale(" + this._zoomVal + "," + this._zoomVal + ")";
            for (var i = 1; i <= this._totalPages; i++) {
                var leftpos;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    var leftpos = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                } else {
                    var leftpos = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                }
                if (leftpos < 0)
                    leftpos = 5;
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var context = canvas.getContext('2d');
                var seccanvas = document.getElementById(this._id + "_secondarycanvas_" + i);
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    canvas.height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.style.height = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                    var height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    var width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.style.width = width + "px";
                    canvas.style.height = height + "px";
                    seccanvas.width = width;
                    seccanvas.height = height;
                    seccanvas.style.width = width + "px";
                    seccanvas.style.height = height + "px";
                }
                else {
                    canvas.height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.style.height = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                    var height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    var width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.style.width = width + "px";
                    canvas.style.height = height + "px";
                    seccanvas.width = width;
                    seccanvas.height = height;
                    seccanvas.style.width = width + "px";
                    seccanvas.style.height = height + "px";
                }
                context.clearRect(0, 0, canvas.clientWidth, canvas.clientHeight);
                var pagediv = $('#' + this._id + 'pageDiv_' + i);
                pagediv[0].style.top = this._pageLocation[i] * this._zoomVal + "px";
                pagediv[0].style.left = leftpos + "px";
                pagediv[0].style.width = width + 'px';
                pagediv[0].style.height = height + 'px';

                //Hyperlink canvas

                var hyperlinklayer = document.getElementById(this._id + 'selectioncanvas_' + i);
                hyperlinklayer.style.height = canvas.height + 'px';
                hyperlinklayer.style.width = canvas.width + 'px';
                hyperlinklayer.style.position = 'absolute';
                hyperlinklayer.style.left = 0;
                hyperlinklayer.style.top = 0;
                hyperlinklayer.style.backgroundColor = 'transparent';
                hyperlinklayer.style.zIndex = '2';

                //resizing the loding indicator of the page
                $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'block', 'height': canvas.height + 'px', 'width': canvas.width + 'px', 'left': '0px', 'top': '0px' });
                var loadingindicator = document.getElementById(this._id + 'pageDiv_' + i + '_WaitingPopup');
                var spanDiv = loadingindicator.childNodes[0];
                spanDiv.style.top = (canvas.height - spanDiv.clientHeight) / 2 + 'px';
            }
            if (this._renderedCanvasList)
                this._renderedCanvasList.length = 0;
            if (this._zoomVal < 1)
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': (this._cummulativeHeight * this._zoomVal) - this.element.height() + 50 + "px" });
            else {
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': "" });
            }
            if (this._imageObj) {
                for (var i = 0; i < this._imageObj.length; i++) {
                    this._imageObj[i].onload = null;
                }
            }
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            vscrolBar.scrollTop = scrollValue;
            this._eventpreviouszoomvalue = this._preZoomVal;
            this._eventzoomvalue = this._zoomVal;
            this._previousZoom = this._zoomVal;
            zoomouteventvalue.previousZoomPercentage = Math.round(this._eventpreviouszoomvalue * 100);
            zoomouteventvalue.currentZoomPercentage = Math.round(this._eventzoomvalue * 100);
            this._raiseClientEvent("zoomChange", zoomouteventvalue);
            this.zoomPercentage = Math.round(this._zoomVal * 100);
            var annotationArray = [];
            if (this._selectedAnnotationObject) {
                annotationArray.push(this._selectedAnnotationObject.annotation);
                this._drawAnnotSelectRect(this._selectedAnnotationObject.pageIndex, annotationArray);
            }
        },

        _zoomContainer: function (zoomfactor, isMode) {
            this._fitType = null;
            this._zoomVal = zoomfactor;
            /*When the zoom options are used after the page fit operations, the buttons that are disabled during page fit operation
               must be enabled. So the class that disables the button is removed.
            */
            $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');

            if (this._isAutoZoom && this._renderedCanvasList && this._isWindowResizing) {
                this._applyFitToWidthAuto();
                zoomfactor = this._zoomVal;
            }
            else {
                var scalefactor = Math.abs(this._preZoomVal - zoomfactor);
                if (scalefactor == 0) return false;
                if (this._preZoomVal > zoomfactor) {
                    this._zoomOutContainer(isMode, scalefactor);
                } else {
                    this._zoomInContainer(isMode, scalefactor);
                }
            }
            this._preZoomVal = zoomfactor;
            this._updateZoomButtons();
        },

        /*  *Since the pageFit option does not have a index for zoom level,assign the zoom level based on its nearest value. 
            * _calculateZoomLevel() function  does this function by getting the nearest lower index and higher index of 
            zoom percent in "container_toolbar_zoomSelection_popup" using binary search algorithm.
        */

        _calculateZoomLevel: function (zoomfactor) {
            this._calculateZoomArrayValues();
            //searching the nearest lower index and higher index for the fitType in the zoom level.
            var zoomVal = zoomfactor;
            var min = 0, max = this._zoomArray.length - 1;
            while ((min <= max) && !(min == 0 && max == 0)) {
                var mid = Math.round((min + max) / 2);
                if (this._zoomArray[mid] <= zoomVal) {
                    min = mid + 1;
                } else if (this._zoomArray[mid] >= zoomVal) {
                    max = mid - 1;
                }
            }
            this._lowerZoomIndex = max;
            this._higherZoomIndex = min;
            this._zoomLevel = this._lowerZoomIndex;
        },

        /*  If zoomIn() function is used after the page fit option, the lower zoom index must be set as the value for _zoomLevel.
            This is done by _applyLowerZoomIndex(). This function is executed only if the fitType is "fitToWidth" or "fitToPage".
        */

        _applyLowerZoomIndex: function () {
            var currentZoomArrayCount = 0;
            this._calculateZoomArrayValues();
            for (var i = 0; i < this._zoomArray.length; i++) {
                if (this._preZoomVal != this._zoomArray[i]) {
                    currentZoomArrayCount++;
                }
            }
            if (currentZoomArrayCount == this._zoomArray.length)
                this._zoomLevel = this._lowerZoomIndex;
            this._fitType = null;
        },

        /*  If zoomOut() function is used after the page fit option, the higher zoom index must be set as the value for _zoomLevel.
            This is done by _applyHigherZoomIndex(). This function is executed only if the fitType is "fitToWidth" or "fitToPage".
        */

        _applyHigherZoomIndex: function () {
            var currentZoomArrayCount = 0;
            this._calculateZoomArrayValues();
            for (var i = 0; i < this._zoomArray.length; i++) {
                if (this._preZoomVal != this._zoomArray[i]) {
                    currentZoomArrayCount++;
                }
            }
            if (currentZoomArrayCount == this._zoomArray.length)
                this._zoomLevel = this._higherZoomIndex;
            this._fitType = null;
        },
        _calculateZoomArrayValues: function () {
            if (this._zoomArray == undefined) {
                var popupLiItems = document.getElementById(this._id + "_toolbar_zoomSelection_popup").getElementsByTagName("li"); //getting the list of zoom percent in the div
                var zoomArray = [];
                this._zoomArray = zoomArray;
                //Converting the list into an array.
                for (var i = 0; i < popupLiItems.length; i++) {
                    zoomArray.push(parseInt(popupLiItems[i].textContent) / 100);
                }
            }
        },

        _updateZoomButtons: function () {
            if (this._zoomVal <= 0.5) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            } else if (this._zoomVal == 4) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
            } else {
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            }
        },

        _showZoomControl: function (show) {
            if (show) {
                $('#' + this._id + '_toolbar_zoomin').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_toolbar_zoomout').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_toolbar_zoomSelection').parents("div.e-pdfviewer-ejdropdownlist").css("display", "block");
                this._isMagnificationHidden = false;
            }
            else {
                $('#' + this._id + '_toolbar_zoomin').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_toolbar_zoomout').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_toolbar_zoomSelection').parents("div.e-pdfviewer-ejdropdownlist").css("display", "none");
                this._isMagnificationHidden = true;
            }
        },
        //-------------------- Page Zoom[end] -------------------------//

        _fitToAutoSize: function () {
            var zoomFactor = this._zoomVal;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            var zoomouteventvalue = { currentZoomPercentage: 0, previousZoomPercentage: 0 };
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolValue = vscrolBar.scrollTop;
            var scrollValue = (vscrolValue / this._previousZoom) * this._zoomVal;
            var transform = "scale(" + this._zoomVal + "," + this._zoomVal + ")";
            for (var i = 1; i <= this._totalPages; i++) {
                var leftpos;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                } else {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                }
                if ((this._isAutoZoom && this._zoomVal < 1) || leftpos < 0)
                    leftpos = 5;
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var seccanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                var context = canvas.getContext('2d');
                var height, width;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                } else {
                    height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                }
                canvas.style.height = height + 'px';
                canvas.style.width = width + 'px';
                seccanvas.style.width = width + "px";
                seccanvas.style.height = height + "px";
                var pagediv = $('#' + this._id + 'pageDiv_' + i);
                pagediv[0].style.top = this._pageLocation[i] * this._zoomVal + "px";
                pagediv[0].style.left = leftpos + "px";
                pagediv[0].style.width = width + 'px';
                pagediv[0].style.height = height + 'px';

                var selectionlayer = document.getElementById(this._id + 'selectioncanvas_' + i);
                selectionlayer.style.height = height + 'px';
                selectionlayer.style.width = width + 'px';
                selectionlayer.style.position = 'absolute';
                selectionlayer.style.left = 0;
                selectionlayer.style.top = 0;
                selectionlayer.style.backgroundColor = 'transparent';
                selectionlayer.style.zIndex = '2';
                //resizing the loding indicator of the page
                var jsonData = this._pageContents[parseInt(i)];
                var jsondata;
                if (jsonData && this._renderedCanvasList.indexOf(i) != -1) {
                    if (this._pdfService == ej.PdfViewer.PdfService.Local)
                        jsondata = JSON.parse(jsonData);
                    else
                        jsondata = JSON.parse(jsonData["d"]);
                    var children = $('#' + this._id + 'selectioncanvas_' + i).children();
                    for (var k = 0; k < children.length; k++) {
                        if ($(children[k]).hasClass('e-pdfviewer-textLayer')) {
                            $(children[k]).remove();
                            $('#' + this._id + 'selectioncanvas_' + i).removeClass('text_container');
                        }
                    }
                    if (!$('#' + this._id + 'selectioncanvas_' + i).hasClass('text_container')) {
                        this._textSelection(jsondata, i, context);
                    } else {
                        this._resizeSelection(jsondata, i, context);
                    }
                }

                $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'none', 'height': height + 'px', 'width': width + 'px', 'left': '0px', 'top': '0px' });
                var loadingindicator = document.getElementById(this._id + 'pageDiv_' + i + '_WaitingPopup');
                if (loadingindicator) {
                    var spanDiv = loadingindicator.childNodes[0];
                    spanDiv.style.top = (canvas.height - spanDiv.clientHeight) / 2 + 'px';
                }
            }
            if (this._zoomVal < 1)
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': (this._cummulativeHeight * this._zoomVal) - this.element.height() + 50 + "px" });
            else {
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': "" });
            }
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            vscrolBar.scrollTop = scrollValue;
            this._eventpreviouszoomvalue = this._preZoomVal;
            this._eventzoomvalue = this._zoomVal;
            this._previousZoom = this._zoomVal;
            this._preZoomVal = this._zoomVal;
            zoomouteventvalue.previousZoomPercentage = Math.round(this._eventpreviouszoomvalue * 100);
            zoomouteventvalue.currentZoomPercentage = Math.round(this._eventzoomvalue * 100);
            this._raiseClientEvent("zoomChange", zoomouteventvalue);
            this.zoomPercentage = Math.round(this._zoomVal * 100);
            var annotationArray = [];
            if (this._selectedAnnotationObject) {
                annotationArray.push(this._selectedAnnotationObject.annotation);
                this._drawAnnotSelectRect(this._selectedAnnotationObject.pageIndex, annotationArray);
            }
        },

        _initRerendering: function () {
            if (!this._isRerenderCanvasCreated) {
                this._designNewCanvas();
                var renderList = [];
                var currentPage = this._currentPage;
                renderList.push(parseInt(this._currentPage));
                var prevPage; var nextPage;
                if (this._renderedCanvasList) {
                    prevPage = parseInt(this._currentPage) - 1;
                    if (this._renderedCanvasList.indexOf(prevPage) != -1)
                        renderList.push(prevPage);
                    nextPage = parseInt(this._currentPage) + 1;
                    if (this._renderedCanvasList.indexOf(nextPage) != -1)
                        renderList.push(nextPage);
                }
                else {
                    prevPage = parseInt(this._currentPage) - 1;
                    renderList.push(prevPage);
                    nextPage = parseInt(this._currentPage) + 1;
                    renderList.push(nextPage);
                }
                this._rerenderCanvasList = renderList;
                if (true) {
                    var proxy = this;
                    clearInterval(proxy._scrollTimer);
                    proxy._bgRenderTimer = setInterval(function () { proxy._rerenderCanvas(currentPage) }, 10);
                }
                this._renderedCanvasList.length = 0;
            }
        },

        _designNewCanvas: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                var pageDiv = document.getElementById(this._id + 'pageDiv_' + i);
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var newCanvas = document.createElement('canvas');
                var height, width;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    width = this._pageSize[i - 1].pageHeight * this._zoomVal;
                } else {
                    height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                }
                newCanvas.style.visibility = 'hidden';
                newCanvas.style.width = width + "px";
                newCanvas.style.height = height + "px";
                newCanvas.style.backgroundColor = 'white';
                newCanvas.height = height;
                newCanvas.width = width;
                newCanvas.id = canvas.id;
                newCanvas.className = "e-pdfviewer-pageCanvas";
                canvas.id = this._id + 'oldcanvas_' + i;
                pageDiv.appendChild(newCanvas);
                $(newCanvas).css({ 'user-select': 'none' });
                var seccanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                seccanvas.style.width = width + "px";
                seccanvas.style.height = height + "px";
                seccanvas.width = width;
                seccanvas.height = height;
            }
            this._isRerenderCanvasCreated = true;
        },

        _replaceOldCanvas: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                var pageDiv = document.getElementById(this._id + 'pageDiv_' + i);
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var oldcanvas = document.getElementById(this._id + 'oldcanvas_' + i);
                canvas.style.visibility = 'visible';
                pageDiv.removeChild(oldcanvas);
            }
            this._isRerenderCanvasCreated = false;
            var proxy = this;
            clearInterval(proxy._bgRenderTimer);
            proxy._scrollTimer = setInterval(function () { proxy._pageviewscrollchanged(proxy._pageHeight) }, 500);
        },

        _rerenderCanvas: function (currentPage) {
            if (this._renderedCanvasList.indexOf(parseInt(currentPage)) == -1 && currentPage <= this._totalPages && this._rerenderCanvasList.indexOf(parseInt(currentPage)) != -1) {
                var jsdata = this._pageContents[parseInt(currentPage)];
                this._rerenderPdfPage(jsdata);
                this._renderCount = this._renderCount + 1;
            } else if (this._renderedCanvasList.indexOf(parseInt(currentPage) - 1) == -1 && (currentPage - 1) <= this._totalPages && this._rerenderCanvasList.indexOf(parseInt(currentPage) - 1) != -1) {
                var jsdata = this._pageContents[parseInt(currentPage) - 1];
                this._rerenderPdfPage(jsdata);
                this._renderCount = this._renderCount + 1;
            } else if (this._renderedCanvasList.indexOf(parseInt(currentPage) + 1) == -1 && (currentPage + 1) <= this._totalPages && this._rerenderCanvasList.indexOf(parseInt(currentPage) + 1) != -1) {
                var jsdata = this._pageContents[parseInt(currentPage) + 1];
                this._rerenderPdfPage(jsdata);
                this._renderCount = this._renderCount + 1;
            }
            if (this._renderCount == this._rerenderCanvasList.length) {
                this._replaceOldCanvas();
                for (var i = 1; i <= this._totalPages; i++) {
                    if (this._renderedCanvasList.indexOf(i) == -1) {
                        $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'block' });
                    }
                }
                this._renderCount = 0;
                this._rerenderCanvasList.length = 0;
            }
        },

        _rerenderPdfPage: function (jsondata) {
            var backupjson = jsondata;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsondata = JSON.parse(jsondata);
            else
                jsondata = JSON.parse(jsondata["d"]);
            this._renderedCanvasList.push(parseInt(jsondata["currentpage"]));
            var pageindex = parseInt(jsondata["currentpage"]);
            var pageimageList = jsondata["imagestream"];

            this._pageContents[parseInt(jsondata["currentpage"])] = backupjson;

            //  Hyperlink
            this._regenerateFormFields(jsondata, pageindex);
            var children = $('#' + this._id + 'selectioncanvas_' + pageindex).children();
            for (i = 0; i < children.length; i++) {
                if (children[i].hasAttribute('href') || $(children[i]).hasClass('e-pdfviewer-formFields'))
                    $(children[i]).remove();
            }
            this._createFormFields(jsondata, pageindex);
            var linkannot = jsondata["linkannotation"];
            var documentlinkpagenumber = jsondata["annotpagenum"];
            var ins = this;
            if (this.model.enableHyperlink) {
                for (var l = 0; l < linkannot.length; l++) {
                    var aTag = document.createElement('a');
                    aTag.id = 'linkdiv_' + l;
                    var rect = linkannot[l].AnnotRectangle;
                    aTag.style.background = 'transparent';
                    aTag.style.position = 'absolute';
                    aTag.style.left = this._convertPointToPixel(rect.Left * this._zoomVal) + 'px';
                    aTag.style.top = this._convertPointToPixel(rect.Top * this._zoomVal) + 'px';
                    aTag.style.width = this._convertPointToPixel(rect.Width * this._zoomVal) + 'px';
                    aTag.style.height = this._convertPointToPixel(rect.Height * this._zoomVal) + 'px';
                    aTag.style.color = 'transparent';
                    if (linkannot[l].URI.indexOf("mailto:") != -1) {
                        var mail = linkannot[l].URI.substring(linkannot[l].URI.indexOf("mailto:"), linkannot[l].URI.length);
                        aTag.title = mail;
                        aTag.setAttribute('href', mail);
                    } else {
                        aTag.title = linkannot[l].URI;
                        aTag.setAttribute('href', linkannot[l].URI);
                    }
                    if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.Default) {
                        aTag.target = "_self";
                        aTag.onclick = function () {
                            var hyperlink = { hyperlink: this.href }
                            ins._raiseClientEvent("hyperlinkClick", hyperlink);
                        }
                    } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewTab) {
                        aTag.target = "_blank";
                        aTag.onclick = function () {
                            var hyperlink = { hyperlink: this.href }
                            ins._raiseClientEvent("hyperlinkClick", hyperlink);

                        }
                    } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewWindow) {

                        aTag.onclick = function () {
                            var hyperlink = { hyperlink: this.href }
                            ins._raiseClientEvent("hyperlinkClick", hyperlink);
                            window.open(this.href, '_blank', 'scrollbars=yes,resizable=yes');
                            return false;
                        }
                    }
                    if (documentlinkpagenumber[l] != undefined) {
                        var destPageHeight = (this._pageSize[pageindex - 1].PageHeight);
                        var destAnnotLoc = this._convertPointToPixel(linkannot[l].AnnotLocation);
                        var dest = (destPageHeight - destAnnotLoc);
                        var scrollvalue = (parseFloat(this._pageLocation[documentlinkpagenumber[l]] * this._zoomVal)) + parseFloat(dest * this._zoomVal);
                        aTag.name = scrollvalue;
                        aTag.onclick = function () {
                            var pageviewcontainer = document.getElementById('container_viewerContainer');
                            pageviewcontainer.scrollTop = this.name;
                            return false;
                        }
                    }
                    if (documentlinkpagenumber[l] != null) {
                        var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                        selectioncanvas.appendChild(aTag);
                    }
                }
            }
            //Hyperlink

            if (this._textMarkupAnnotationList[pageindex]) {
                this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageindex], pageindex);
            }
            var index = parseInt(jsondata["currentpage"]);
            var canvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
            var context = canvas.getContext('2d');
            var ratio = this._scalingTextContent(context);
            if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                canvas.height = this._zoomVal * this._pageSize[index - 1].PageHeight;
                canvas.width = this._zoomVal * this._pageSize[index - 1].PageWidth;
                canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
            }
            else {
                canvas.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth * ratio;
                canvas.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight * ratio;
                canvas.style.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight + 'px';
                canvas.style.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth + 'px';
            }
            var context = canvas.getContext('2d');
            var imageObjCollection = new Array();
            var imageTransformCollection = new Array();
            var imageDataCollection = new Array();
            var currentIndexCollection = new Array();
            var pageDataCollection = new Array();
            var zoomFactor;
            var browserUserAgent = navigator.userAgent;
            var offsett;
            var imageIndex = 0;

            var charPath = new Array();
            var shapes = pageimageList["textelements"];
            for (var j = 0; j < shapes.length; j++) {
                var pathdata = shapes[j];
                var color = pathdata["color"];
                var matrix = pathdata["matrix"];
                if (matrix != null)
                    matrix = matrix["Elements"];
                var brushMode = pathdata["brush"];
                var pathValue = pathdata["pathValue"];
                var isClipping = pathdata["iscliping"];
                var restoreCanvas = pathdata["restorecanvas"];
                var imageData = pathdata["imagedata"];
                var fillMode = pathdata["fillrule"];
                var fillStroke = pathdata["isFillandStroke"];
                var fillColor = pathdata["fillcolor"];
                var strokeColor = pathdata["strokecolor"];
                var lineWidth = pathdata["linewidth"];
                var lineCap = pathdata["linecap"];
                var linearGradient = pathdata["linearGradientBrush"];
                var textureBrush = pathdata["textureBrushs"];
                var charID = pathdata["charID"];
                if (pathValue != null) {
                    pathValue = pathValue.split(";");
                    if (charID)
                        charPath[charID] = pathValue;
                }
                else if (pathValue == null && charID) {
                    pathValue = charPath[charID];
                }
                if (restoreCanvas == false) {
                    context.save();
                }
                if (pathValue != undefined) {
                    context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1], matrix[2], matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal* ratio, matrix[5] * this._zoomVal * ratio);
                }

                if (pathValue != null) {
                    context.beginPath();

                    for (var i = 0; i < pathValue.length; i++) {
                        var val = pathValue[i];
                        var pathType = val[0];
                        if (pathType == "M") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.moveTo((val[0]), val[1]);
                        }
                        else if (pathType == "L") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.lineTo((val[0]), val[1]);
                        }
                        else if (pathType == "C") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                        }
                        else if (pathType == "Z") {
                            context.closePath();
                        }
                    }
                    if (isClipping == true) {
                        if (fillMode == "evenodd") {
                            context.msFillRule = "evenodd";
                            context.mozFillRule = "evenodd";
                            context.clip(fillMode);
                        }
                        context.clip();

                    }
                    else {
                        if (fillStroke == undefined) {
                            if (brushMode == "Fill") {
                                if (linearGradient != undefined) {
                                    context.fillStyle = this._getGradientBrush(linearGradient, context);
                                }
                                else if (textureBrush != undefined) {
                                    context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                }
                                else
                                    context.fillStyle = color;
                                if (fillMode == "evenodd") {
                                    context.msFillRule = "evenodd";
                                    context.mozFillRule = "evenodd";
                                    context.fill(fillMode);
                                }
                                context.fill();
                            }
                            else if (brushMode == "FillandStroke") {
                                context.fillStyle = color;
                                context.fill();
                                context.strokeStyle = strokeColor;
                                context.stroke();
                            }
                            else if (brushMode == "Stroke") {
                                context.strokeStyle = strokeColor;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                            }
                            else {
                                context.strokeStyle = color;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                            }
                        }
                        else {
                            context.strokeStyle = strokeColor;
                            context.lineWidth = lineWidth;
                            context.lineCap = lineCap;
                            context.stroke();
                            if (linearGradient != undefined) {
                                context.fillStyle = this._getGradientBrush(linearGradient, context);
                            }
                            else if (textureBrush != undefined) {
                                context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                            }
                            else
                                context.fillStyle = fillColor;
                            if (fillMode == "evenodd") {
                                context.msFillRule = "evenodd";
                                context.mozFillRule = "evenodd";
                                context.fill(fillMode);
                            }
                            context.fill();
                        }
                    }
                }

                if (restoreCanvas)
                    context.restore();
                if (imageData != undefined) {
                    if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                        imageObjCollection.push(imageData);
                        imageTransformCollection.push(matrix);
                        pageDataCollection.push(shapes);
                        currentIndexCollection.push(j);
                        zoomFactor = this._zoomVal;
                        this._isContainImage = true;
                        break;
                    }
                    else {
                        var imageObj = new Image();
                        imageObj.src = imageData;
                        context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1] * this._zoomVal * ratio, matrix[2] * this._zoomVal * ratio, matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                        context.drawImage(imageObj, 0, 0, 1, 1);
                    }
                }
            }

            if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                for (var k = 0; k < imageObjCollection.length; k++) {
                    this._imageRenderingPinch(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, k, pageDataCollection, currentIndexCollection, charPath, canvas, index, imageIndex);
                    imageIndex++;
                }
            }
            var tempcanvas = canvas;
            var proxy = this;
            if (this._pageSize[index - 1].PageRotation != 0) {
                tempcanvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                var canvasUrl = tempcanvas.toDataURL();
                var context = tempcanvas.getContext('2d');
                var image = new Image();
                image.onload = function () {
                    context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                    if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                        tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                        tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                        tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                        tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                    } else {
                        tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                        tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                        tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                        tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';

                    }
                    context.save();
                    context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                    context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                    context.drawImage(image, -image.width / 2, -image.height / 2);
                    context.restore();
                }
                image.src = canvasUrl;
            }

            this._showPageLoadingIndicator(pageindex, false);
            return tempcanvas;
        },
        _regenerateFormFields: function (jsondata, pageindex) {
            var TextBoxField = jsondata["PdfRenderedFields"];
            var backgroundcolor;
            if (TextBoxField != null) {
                for (var l = 0; l < TextBoxField.length; l++) {
                    if ((TextBoxField[l].PageIndex + 1) == pageindex) {
                        var boundingRect = TextBoxField[l].LineBounds;
                        var inputdiv = document.getElementById(this._id + 'input_' + pageindex + '_' + l);
                        if (TextBoxField[l].Name == "Textbox") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].FieldName == name)
                                TextBoxField[l].Text = $(inputdiv).val();
                        }
                        else if (TextBoxField[l].Name == "Password") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].FieldName == name)
                                TextBoxField[l].Text = $(inputdiv).val();
                        }
                        else if (TextBoxField[l].Name == "RadioButton") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].GroupName == name) {
                                if ($(inputdiv).prop("checked") == true)
                                    TextBoxField[l].Selected = true;
                                else
                                    TextBoxField[l].Selected = false;
                            }
                        }
                        else if (TextBoxField[l].Name == "CheckBox") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].GroupName == name) {
                                if ($(inputdiv).prop("checked") == true)
                                    TextBoxField[l].Selected = true;
                                else
                                    TextBoxField[l].Selected = false;
                            }
                        }
                        else if (TextBoxField[l].Name == "DropDown") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].Text == name) {
                                if (TextBoxField[l].SelectedValue == "") {
                                    var option = $(inputdiv).children()[0];
                                    option.id = "dropdownhide";
                                    if ($(option).prop("selected") == true)
                                        TextBoxField[l].SelectedValue = "";
                                }
                                for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                    var option;
                                    if ($(inputdiv).children()[0].id == "dropdownhide")
                                        option = $(inputdiv).children()[j + 1];
                                    else
                                        option = $(inputdiv).children()[j];
                                    if ($(option).prop("selected") == true)
                                        TextBoxField[l].SelectedValue = TextBoxField[l].TextList[j];
                                }
                            }
                        }
                        else if (TextBoxField[l].Name == "ListBox") {
                            var k = 0;
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = $(inputdiv).children()[j];
                                if ($(option).prop("selected") == true) {
                                    TextBoxField[l].SelectedList[k] = j;
                                    k++;
                                }
                            }
                        }
                    }
                }
            }


        },
        _imageRenderingPinch: function (shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, index, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex) {
            var proxy = this;
            var zoomValue = proxy._zoomVal;
            var imageObject = new Image();
            imageObject.onload = function () {
                var isImageContentChanged = false;
                var ratio = proxy._scalingTextContent(context);
                for (var l = 0; l < imageTransformCollection.length; l++) {
                    if (isImageContentChanged == false) {
                        var matrixData = imageTransformCollection[l];
                        context.setTransform(matrixData[0] * zoomValue * ratio, matrixData[1] * zoomValue * ratio, matrixData[2] * zoomValue* ratio, matrixData[3] * zoomValue* ratio, matrixData[4] * zoomValue* ratio, matrixData[5] * zoomValue * ratio);
                        if (imageDataCollection[imageIndex] != undefined) {
                            context.drawImage(imageDataCollection[imageIndex], 0, 0, 1, 1);
                        }
                        var dataIndex = currentIndexCollection[l];
                        dataIndex = dataIndex + 1;
                        var data = pageDataCollection[l];
                        while (dataIndex < data.length) {
                            var pathdata = data[dataIndex];
                            var color = pathdata["color"];
                            var matrix = pathdata["matrix"];
                            if (matrix != null)
                                matrix = matrix["Elements"];
                            var brushMode = pathdata["brush"];
                            var pathValue = pathdata["pathValue"];
                            var isClipping = pathdata["iscliping"];
                            var restoreCanvas = pathdata["restorecanvas"];
                            var imageData = pathdata["imagedata"];
                            var fillMode = pathdata["fillrule"];
                            var fillStroke = pathdata["isFillandStroke"];
                            var fillColor = pathdata["fillcolor"];
                            var strokeColor = pathdata["strokecolor"];
                            var lineWidth = pathdata["linewidth"];
                            var lineCap = pathdata["linecap"];
                            var linearGradient = pathdata["linearGradientBrush"];
                            var textureBrush = pathdata["textureBrushs"];
                            var charID = pathdata["charID"];
                            if (pathValue != null) {
                                pathValue = pathValue.split(";");
                                if (charID)
                                    charPath[charID] = pathValue;
                            }
                            else if (pathValue == null && charID) {
                                pathValue = charPath[charID];
                            }
                            if (restoreCanvas == false) {
                                context.save();
                            }
                            if (pathValue != undefined) {
                                context.setTransform(matrix[0] * zoomValue * ratio, matrix[1], matrix[2], matrix[3] * zoomValue * ratio, matrix[4] * zoomValue * ratio, matrix[5] * zoomValue * ratio);
                            }

                            if (pathValue != null) {
                                context.beginPath();

                                for (var i = 0; i < pathValue.length; i++) {
                                    var val = pathValue[i];
                                    var pathType = val[0];
                                    if (pathType == "M") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.moveTo((val[0]), val[1]);
                                    }
                                    else if (pathType == "L") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.lineTo((val[0]), val[1]);
                                    }
                                    else if (pathType == "C") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                                    }
                                    else if (pathType == "Z") {
                                        context.closePath();
                                    }
                                }
                                if (isClipping == true) {
                                    if (fillMode == "evenodd") {
                                        context.msFillRule = "evenodd";
                                        context.mozFillRule = "evenodd";
                                        context.clip(fillMode);
                                    }
                                    context.clip();

                                }
                                else {
                                    if (fillStroke == undefined) {
                                        if (brushMode == "Fill") {
                                            if (linearGradient != undefined) {
                                                context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                            }
                                            else if (textureBrush != undefined) {
                                                context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                            }
                                            else
                                                context.fillStyle = color;
                                            if (fillMode == "evenodd") {
                                                context.msFillRule = "evenodd";
                                                context.mozFillRule = "evenodd";
                                                context.fill(fillMode);
                                            }
                                            context.fill();
                                        }
                                        else if (brushMode == "FillandStroke") {
                                            context.fillStyle = color;
                                            context.fill();
                                            context.strokeStyle = strokeColor;
                                            context.stroke();
                                        }
                                        else if (brushMode == "Stroke") {
                                            context.strokeStyle = strokeColor;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                        }
                                        else {
                                            context.strokeStyle = color;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                        }
                                    }
                                    else {
                                        context.strokeStyle = strokeColor;
                                        context.lineWidth = lineWidth;
                                        context.lineCap = lineCap;
                                        context.stroke();
                                        if (linearGradient != undefined) {
                                            context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                        }
                                        else if (textureBrush != undefined) {
                                            context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                        }
                                        else
                                            context.fillStyle = fillColor;
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                            context.fill(fillMode);
                                        }
                                        context.fill();
                                    }
                                }
                            }

                            if (restoreCanvas)
                                context.restore();
                            if (imageData != undefined) {
                                isImageContentChanged = true;
                                imageObjCollection.pop();
                                imageTransformCollection.pop();
                                pageDataCollection.pop();
                                currentIndexCollection.pop();
                                imageObjCollection.push(imageData);
                                imageTransformCollection.push(matrix);
                                pageDataCollection.push(shapes);
                                currentIndexCollection.push(dataIndex);
                                l = -1;
                                imageIndex++;
                                break;
                            }
                            dataIndex++;
                        }
                    }
                    else {
                        proxy._imageRenderingPinch(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, l, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex);
                        imageIndex++;
                    }
                }
            }
            imageObject.src = imageObjCollection[index];
            imageDataCollection.push(imageObject);
        },
        //-------------------- Pinch Zoom [Start] -----------------------------//

        _touchStart: function (event) {
            var eventTouch = event.touches;
            if (eventTouch.length > 1) {
                event.preventDefault();
            }
            var ejViewer = $(event.target).parents('.e-pdfviewer.e-js');
            var ejViewerInstance = ejViewer.ejPdfViewer("instance");
            ejViewerInstance._touched = false;
        },
        _touchMove: function (event) {
            var eventTouch = event.touches;
            if (eventTouch.length > 1) {
                var ejViewer = $(event.target).parents('.e-pdfviewer.e-js');
                var ejViewerInstance = ejViewer.ejPdfViewer("instance");
                ejViewerInstance._touched = true;
                if (!ejViewerInstance._isRerenderCanvasCreated) {
                    $('.e-pdfviewer-formFields').hide();
                    var currentDiff = Math.sqrt(Math.pow((eventTouch[0].clientX - eventTouch[1].clientX), 2) + Math.pow((eventTouch[0].clientY - eventTouch[1].clientY), 2));
                    if (ejViewerInstance._prevDiff > -1) {
                        if (currentDiff > ejViewerInstance._prevDiff) {
                            ejViewerInstance._pinchOut(event);
                        } else if (currentDiff < ejViewerInstance._prevDiff) {
                            ejViewerInstance._pinchIn(event);
                        }
                    } else if (ejViewerInstance._zoomVal < 2) {
                        if (ejViewerInstance._prevDiff != -1) {
                            if (currentDiff > ejViewerInstance._prevDiff) {
                                ejViewerInstance._pinchIn(event);
                            }
                        }
                    } else if (ejViewerInstance._prevDiff == -1) {
                        if (ejViewerInstance._zoomVal > 2) {
                            if (currentDiff > ejViewerInstance._prevDiff) {
                                ejViewerInstance._pinchIn(event);
                            }
                        }
                    }
                    ejViewerInstance._prevDiff = currentDiff;
                }
            }
        },

        _touchEnd: function (event) {
            var ejViewer = $(event.target).parents('.e-pdfviewer.e-js');
            var ejViewerInstance = ejViewer.ejPdfViewer("instance");
            ejViewerInstance._prevDiff = -1;
            if (ejViewerInstance._isRenderedByPinch) {
                if (ejViewerInstance._renderedCanvasList.length != 0) {
                    if (!ejViewerInstance._isRerenderCanvasCreated) {
                        ejViewerInstance._designNewCanvas();
                        var renderList = [];
                        var currentPage = ejViewerInstance._currentPage;
                        renderList.push(parseInt(ejViewerInstance._currentPage));
                        var prevPage = parseInt(ejViewerInstance._currentPage) - 1;
                        if (ejViewerInstance._renderedCanvasList.indexOf(prevPage) != -1)
                            renderList.push(prevPage);
                        var nextPage = parseInt(ejViewerInstance._currentPage) + 1;
                        if (ejViewerInstance._renderedCanvasList.indexOf(nextPage) != -1)
                            renderList.push(nextPage);
                        ejViewerInstance._rerenderCanvasList = renderList;
                        var proxy = ejViewerInstance;
                        window.clearInterval(proxy._scrollTimer);
                        proxy._bgRenderTimer = setInterval(function () { proxy._rerenderCanvas(currentPage) }, 10);
                        ejViewerInstance._renderedCanvasList.length = 0;
                    }
                }
                ejViewerInstance._isRenderedByPinch = false;
            }
        },

        _pointerdown: function (event) {
            if (event.originalEvent.pointerType == 'touch') {
                this._pointerCount = this._pointerCount + 1;
                if (this._pointerCount <= 2) {
                    event.preventDefault();
                    this._pointers.push(event.originalEvent);
                    if (this._pointerCount == 2)
                        this._pointerCount = 0;
                }
            }
        },

        _pointermove: function (event) {
            if (event.originalEvent.pointerType == 'touch') {
                if (this._pointers.length == 2) {
                    event.preventDefault();
                    for (var i = 0; i < this._pointers.length; i++) {
                        if (event.originalEvent.pointerId == this._pointers[i].pointerId) {
                            this._pointers[i] = event.originalEvent;
                            break;
                        }
                    }
                    if (!this._isRerenderCanvasCreated) {
                        var currentDiff = Math.sqrt(Math.pow((this._pointers[0].clientX - this._pointers[1].clientX), 2) + Math.pow((this._pointers[0].clientY - this._pointers[1].clientY), 2));
                        if (this._prevDiff > -1) {
                            if (currentDiff > this._prevDiff) {
                                this._pinchOut(event);
                            } else if (currentDiff < this._prevDiff) {
                                this._pinchIn(event);
                            }
                        }
                        var vscrolBar = document.getElementById(this._id + '_viewerContainer');
                        var scroltop = vscrolBar.scrollTop;
                        if (!(scroltop == 0)) {
                            if (currentDiff > this._prevDiff) {
                                this._pinchOut(event);
                            } else if (currentDiff < this._prevDiff) {
                                this._pinchIn(event);
                            }
                        }
                        this._prevDiff = currentDiff;
                    }
                }
            }
        },

        _pointerup: function (event) {
            if (event.originalEvent.pointerType == 'touch') {
                this._pointers = new Array();
                this._pointerCount = 0;
                this._prevDiff = -1;
                if (this._isRenderedByPinch) {
                    event.preventDefault();
                    if (this._renderedCanvasList.length != 0) {
                        if (!this._isRerenderCanvasCreated) {
                            this._designNewCanvas();
                            var renderList = [];
                            var currentPage = this._currentPage;
                            renderList.push(parseInt(this._currentPage));
                            var prevPage = parseInt(this._currentPage) - 1;
                            if (this._renderedCanvasList.indexOf(prevPage) != -1)
                                renderList.push(prevPage);
                            var nextPage = parseInt(this._currentPage) + 1;
                            if (this._renderedCanvasList.indexOf(nextPage) != -1)
                                renderList.push(nextPage);
                            this._rerenderCanvasList = renderList;
                            var proxy = this;
                            window.clearInterval(proxy._scrollTimer);
                            proxy._bgRenderTimer = setInterval(function () { proxy._rerenderCanvas(currentPage) }, 10);
                            this._renderedCanvasList.length = 0;
                        }
                    }
                    this._isRenderedByPinch = false;
                }
            }
        },

        _pinchOut: function (event) {
            this._isAutoZoom = false;
            this._zoomVal = this._zoomVal + 0.05;
            if (this._zoomVal > 2) {
                this._zoomVal = this._zoomVal + 0.05;
            }
            if (this._zoomVal > 4) {
                this._zoomVal = 4;
                this._isPinchLimitReached = true;
            }
            if (this._zoomVal <= 4) {
                if (!this._isPinchLimitReached) {
                    this._fitType = null;
                    this._fitToAutoSize();
                    this._calculateZoomLevel(this._zoomVal);
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((this._zoomVal * 100)) + "%");
                    this._ejDropDownInstance.model.value = (this._zoomVal * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                    this._updateZoomButtons();
                    $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
                    this._isRenderedByPinch = true;
                }
                this._isPinchLimitReached = false;
            } else {
                this._zoomVal = 4;
            }
        },

        _pinchIn: function (event) {
            this._isAutoZoom = false;
            this._zoomVal = this._zoomVal - 0.04;
            if (this._zoomVal < 4 && this._zoomVal > 2) {
                this._zoomVal = this._zoomVal - 0.04;
            }
            if (this._zoomVal < 0.5) {
                this._zoomVal = 0.5;
                this._isPinchLimitReached = true;
            }
            if (this._zoomVal >= 0.5) {
                if (!this._isPinchLimitReached) {
                    this._fitType = null;
                    this._fitToAutoSize();
                    this._calculateZoomLevel(this._zoomVal);
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((this._zoomVal * 100)) + "%");
                    this._ejDropDownInstance.model.value = (this._zoomVal * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                    this._updateZoomButtons();
                    $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
                    this._isRenderedByPinch = true;
                }
                this._isPinchLimitReached = false;
            } else {
                this._zoomVal = 0.5;
            }
        },

        //------------------------------- Pinch Zoom [End] ----------------------------------//
        //-------------------------------Text Select and Search [start] ---------------------------//

        _textSearch: function () {
            this._clearAllOccurrences();
            this._selectedIndex = 0;
            this._isTextSearch = true;
            this._searchedPages = new Array();
            this._searchCollection = new Array();
            var searchText = $('#' + this._id + '_pdfviewer_searchinput').val();
            this._searchText = searchText;
            if (this._searchText && this._searchText != "") {
                this._enableSearchIcons();
            }
            else {
                this._disableSearchIcons();
            }
            if (searchText == '' || searchText == ' ' || !searchText) {
                $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                return true;
            }
            this._searchPageIndex = parseInt(this._currentPage);
            this._initSearch(this._searchPageIndex);
            this._highlightOtherOccurrences();
        },
        _disableSearchIcons: function () {
            $('#' + this._id + '_pdfviewer_previous_search').css({ "pointer-events": "none", "opacity": "0.6" });
            $('#' + this._id + '_pdfviewer_next_search').css({ "pointer-events": "none", "opacity": "0.6" });
            var checkBox = $('#' + this._id + '_search_matchcase').data('ejCheckBox');
            checkBox.disable();
        },
        _enableSearchIcons: function () {
            $('#' + this._id + '_pdfviewer_previous_search').css({ "pointer-events": "", "opacity": "" });
            $('#' + this._id + '_pdfviewer_next_search').css({ "pointer-events": "", "opacity": "" });
            var checkBox = $('#' + this._id + '_search_matchcase').data('ejCheckBox');
            checkBox.enable();
        },
        _prevSearch: function () {
            if (this._searchText) {
                this._clearAllOccurrences();
                this._isPrevSearch = true;
                this._isTextSearch = true;
                this._selectedIndex = this._selectedIndex - 1;
                if (this._selectedIndex < 0) {
                    this._searchPageIndex = this._searchPageIndex - 1;
                    if (this._searchPageIndex < 1) {
                        this._searchPageIndex = parseInt(this._totalPages);
                    }
                    this._initSearch(this._searchPageIndex);
                } else {
                    this._highlightText(this._searchPageIndex, this._selectedIndex);
                }
                this._highlightOtherOccurrences();
            }
        },

        _nextSearch: function () {
            if (this._searchText) {
                this._clearAllOccurrences();
                this._isPrevSearch = false;
                this._isTextSearch = true;
                this._selectedIndex = this._selectedIndex + 1;
                if (this._searchCollection[this._searchPageIndex]) {
                    if (this._selectedIndex >= this._searchCollection[this._searchPageIndex].length) {
                        this._selectedIndex = 0;
                        if (this._searchPageIndex < this._totalPages) {
                            this._searchPageIndex = this._searchPageIndex + 1;
                        } else {
                            this._searchPageIndex = 1;
                        }
                        this._initSearch(this._searchPageIndex);
                    } else {
                        this._highlightText(this._searchPageIndex, this._selectedIndex);
                    }
                } else {
                    this._searchPageIndex = this._currentPage;
                    this._selectedIndex = 0;
                    this._initSearch(this._searchPageIndex);
                }
                this._highlightOtherOccurrences();
            }
        },

        _matchcase: function () {
            var checkBox = $('#' + this._id + '_search_matchcase').data('ejCheckBox');
            if (checkBox.model.checkState == "check") {
                this._isMatchCase = true;
            } else {
                this._isMatchCase = false;
            }
            this._textSearch();
        },

        _searchKeypressHandler: function (event) {
            if (event.which == 13) {
                event.preventDefault();
                this._searchText = $('#' + this._id + '_pdfviewer_searchinput').val();
                if (this._searchMatches[this._searchPageIndex] && this._searchText != "") {
                    if (this._searchMatches[this._searchPageIndex].length == 0) {
                        this._initSearch(this._searchPageIndex);
                    } else {
                        this._nextSearch();
                    }
                } else if (this._searchText != "") {
                    this._searchPageIndex = this._currentPage;
                    this._selectedIndex = 0;
                    this._initSearch(this._searchPageIndex);
                }
            }
        },

        _initSearch: function (pageIndex) {
            var queryLength = this._searchText.length;
            var searchText = this._searchText;
            if (searchText != '' || searchText != ' ' || !searchText)
               this._getPossibleMatches(pageIndex, searchText, queryLength);
        },

        _getPossibleMatches: function (pageIndex, searchText, queryLength) {
            if (!this._pageText[parseInt(pageIndex)] && pageIndex == this._searchPageIndex) {
                this._isRequestFired = true;
                var jsonResult = new Object();
                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                jsonResult["pageindex"] = pageIndex.toString();
                jsonResult["id"] = this._fileId;
                $('#' + this._id + '_pdfviewer_searchinput').addClass('e-pdfviewer-progressloader');
                if (!this._ajaxInProgress)
                   this._doAjaxPostSearch(JSON.stringify(jsonResult), pageIndex);
            }
            this._searchPageText(pageIndex, searchText, queryLength);
        },
        _searchPageText: function (pageIndex, searchText, queryLength) {
            var pageText = this._pageText[pageIndex];
            if (pageText) {
                if (!this._isMatchCase) {
                    pageText = pageText.toLowerCase();
                    searchText = searchText.toLowerCase();
                }
                var matches = [];
                var matchIndex = -queryLength;
                var texts = /[^\u0000-\u00ff]/.test(pageText);
                var x = new RegExp("[\x00-\x80]+"); // is ascii
                var isAscii = x.test(pageText);
                var isRtl = this._isRtl(pageText);
                if (!isAscii && isRtl) {
                    var re = new RegExp(String.fromCharCode(160), "g");
                    pageText = pageText.replace(re, " ");
                    searchText = searchText.split("").reverse().join("");
                    searchText = searchText.replace(/\s/g, '\u00A0');
                }
                if (this._isNonBreackingCharacter && texts) {
                    var re = new RegExp(String.fromCharCode(160), "g");
                    pageText = pageText.replace(re, " ");
                }
                while (true) {
                    if (searchText == '' || searchText == ' ' || !searchText) {
                                                break;
                     }
                    matchIndex = pageText.indexOf(searchText, matchIndex + queryLength);
                    if (matchIndex == -1)
                        break;
                    matches.push(matchIndex);
                }
                this._searchMatches[pageIndex] = matches;
                if (pageIndex == this._searchPageIndex) {
                    if (this._selectedIndex < 0 && this._isPrevSearch) {
                        this._selectedIndex = this._searchMatches[pageIndex].length - 1;
                    }
                    if (this._isRequestFired && this._searchMatches[pageIndex].length != 0 || this._renderedCanvasList.indexOf(pageIndex) == -1 && this._searchMatches[pageIndex].length != 0) {
                        this._gotoPageNo(pageIndex);
                        this._isPageScrolledForSearch = true;
                    }
                    if (this._searchMatches[pageIndex].length == 0) {
                        if (pageIndex != this._totalPages) {
                            if (this._searchedPages.indexOf(parseInt(pageIndex)) == -1) {
                                this._searchedPages.push(pageIndex);
                            }
                            if (this._isPrevSearch) {
                                this._searchPageIndex = this._searchPageIndex - 1;
                                if (this._searchPageIndex <= 0)
                                    this._searchPageIndex = this._totalPages;
                            } else {
                                this._searchPageIndex = this._searchPageIndex + 1;
                            }
                        }
                        else {
                            if (this._searchedPages.indexOf(parseInt(pageIndex)) == -1) {
                                this._searchedPages.push(pageIndex);
                            }
                            if (this._isPrevSearch) {
                                this._searchPageIndex = this._searchPageIndex - 1;
                            } else {
                                this._searchPageIndex = 1;
                            }
                        }
                        if (this._searchedPages.length != this._totalPages || this._searchMatches[pageIndex].length != 0) {
                            this._initSearch(this._searchPageIndex);
                        } else {
                            if (searchText != "") {
                                $('#' + this._id + '_pdfviewer_searchinput').addClass('e-pdfviewer-nooccurrence');
                            }
                            $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                            this._isRequestFired = false;
                        }
                    } else {
                        if (this._isRequestFired) {
                            $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                            var proxy = this;
                            setTimeout(function () {
                                proxy._convertMatches(pageIndex, queryLength);
                                proxy._isRequestFired = false;
                                proxy._isPageScrolledForSearch = false;
                            }, 100);
                        } else {
                            this._convertMatches(pageIndex, queryLength);
                        }
                    }
                } else {
                    if (this._searchMatches[pageIndex].length != 0) {
                        this._convertMatches(pageIndex, queryLength);
                    }
                }
                if (!this._isRequestFired && !this._isPageScrollHighlight) {
                    this._isPageScrolledForSearch = false;
                }
            }
        },

        _convertMatches: function (index, queryLength) {
            var m = 0;
            var matches = this._searchMatches[index];
            var textDiv = this._textDivs[index];
            var divIndex = 0;
            var end = textDiv.length - 1;
            var matchCollection = [];
            for (var i = 0, l = matches.length; i < l; i++) {
                var matchIndex = matches[i];
                if (!this._isPageScrolledForSearch) {
                    while (m != end && matchIndex >= (divIndex + textDiv[m].textContent.length)) {
                        divIndex += textDiv[m].textContent.length;
                        m++;
                    }
                } else {
                    while (m != end && matchIndex >= (divIndex + textDiv[m].textContent.split('\n')[0].length)) {
                        divIndex += textDiv[m].textContent.split('\n')[0].length;
                        m++;
                    }
                }
                var match = {
                    begin: {
                        divId: m,
                        offsetValue: matchIndex - divIndex,
                    }
                };
                matchIndex += queryLength;
                while (m != end && matchIndex > (divIndex + textDiv[m].textContent.length)) {
                    divIndex += textDiv[m].textContent.length;
                    m++;
                }
                match.end = {
                    divId: m,
                    offsetValue: matchIndex - divIndex,
                };
                matchCollection.push(match);
            }
            this._searchCollection[index] = matchCollection;
            this._highlightText(index, this._selectedIndex);
        },

        _highlightText: function (pageIndex, index) {
            var matches = this._searchCollection[pageIndex];
            var textDiv = this._textDivs[pageIndex];
            var prevEnd = null;
            var scrollPoint = { y: -70, x: -400 }
            var startId, className;
            var index0 = 0, index1 = matches.length;
            for (var i = index0; i < index1; i++) {
                var match = matches[i];
                var start = match.begin;
                var end = match.end;
                if (i == this._selectedIndex && pageIndex == this._searchPageIndex) {
                    className = 'e-pdfviewer-texthighlight';
                    startId = start.divId;
                } else {
                    className = 'e-pdfviewer-text-highlightother'
                }
                if (!prevEnd || start.divId !== prevEnd.divId) {
                    if (prevEnd !== null) {
                        this._addSpanForSearch(prevEnd.divId, prevEnd.offsetValue, undefined, pageIndex, textDiv, null);
                    }
                    this._beginText(start, textDiv, pageIndex, null);
                } else {
                    this._addSpanForSearch(prevEnd.divId, prevEnd.offsetValue, start.offsetValue, pageIndex, textDiv, null);
                }
                if (start.divId == end.divId) {
                    this._addSpanForSearch(start.divId, start.offsetValue, end.offsetValue, pageIndex, textDiv, className);
                } else {
                    this._addSpanForSearch(start.divId, start.offsetValue, undefined, pageIndex, textDiv, className);
                    for (var k = start.divId + 1, j = end.divId; k < j; k++) {
                        this._addSpanForSearch(k, 0, undefined, pageIndex, textDiv, className + ' middle');
                    }
                    this._beginText(end, textDiv, pageIndex, className);
                }
                prevEnd = end;
            }
            if (prevEnd) {
                this._addSpanForSearch(prevEnd.divId, prevEnd.offsetValue, undefined, pageIndex, textDiv, null);
            }
            if (pageIndex == this._searchPageIndex)
                this._scrollToSearchStr(textDiv[startId], scrollPoint);
            this._isTextHighlighted = true;
        },

        _beginText: function (span, textDiv, pageIndex, className) {
            var divIndex = span.divId;
            textDiv[divIndex].textContent = '';
            this._addSpanForSearch(divIndex, 0, span.offsetValue, pageIndex, textDiv, className);
        },

        _addSpanForSearch: function (divIndex, fromOffset, toOffset, pageIndex, textDiv, className) {
            var divTextContent;
            var re = new RegExp(String.fromCharCode(160), "g");
            var textContent = this._textContents[pageIndex];
            var totalLength = textContent[divIndex].length;
            var x = new RegExp("[\x00-\x80]+"); // is ascii
            var isRtl = this._isRtl(textContent[divIndex]);
            if (isRtl) {
                divTextContent = textContent[divIndex].substring(totalLength - fromOffset, totalLength - toOffset);
                var node = document.createTextNode(divTextContent);
                if (className) {
                    this._isTextHighlighted = true;
                    var spanElement = document.createElement('span');
                    spanElement.className = className + ' e-pdfviewer-textLayer';
                    if ($(spanElement).hasClass('middle')) {
                        textDiv[divIndex].textContent = '';
                    }
                    node.textContent = node.textContent.replace(re, " ");
                    $(spanElement).prepend(node);
                    $(textDiv[divIndex]).prepend(spanElement);
                    textDiv[divIndex].innerHTML.replace(/&nbsp;/g, ' ');
                    return;
                }
                node.textContent = node.textContent.replace(re, " ");
                $(textDiv[divIndex]).prepend(node);
                textDiv[divIndex].innerHTML = textDiv[divIndex].innerHTML.replace(re, " ");
            }
            else {
                divTextContent = textContent[divIndex].substring(fromOffset, toOffset);
                var node = document.createTextNode(divTextContent);
                if (className) {
                    this._isTextHighlighted = true;
                    var spanElement = document.createElement('span');
                    spanElement.className = className + ' e-pdfviewer-textLayer';
                    if ($(spanElement).hasClass('middle')) {
                        textDiv[divIndex].textContent = '';
                    }
                    node.textContent = node.textContent.replace(re, " ");
                    spanElement.appendChild(node);
                    spanElement.innerHTML = spanElement.innerHTML.replace(re, " ");
                    textDiv[divIndex].appendChild(spanElement);
                    textDiv[divIndex].innerHTML = textDiv[divIndex].innerHTML.replace(re, " ");
                    return;
                }
                node.textContent = node.textContent.replace(re, " ");
                textDiv[divIndex].appendChild(node);
                textDiv[divIndex].innerHTML = textDiv[divIndex].innerHTML.replace(re, " ");
            }
        },
        _isRtl: function (text) {
            var ltrChars = 'A-Za-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02B8\\u0300-\\u0590\\u0800-\\u1FFF' + '\\u2C00-\\uFB1C\\uFDFE-\\uFE6F\\uFEFD-\\uFFFF',
                rtlChars = '\\u0591-\\u07FF\\uFB1D-\\uFDFD\\uFE70-\\uFEFC',
                rtlDirCheck = new RegExp('^[^' + ltrChars + ']*[' + rtlChars + ']');
            return rtlDirCheck.test(text);
        },
        _scrollToSearchStr: function (textDiv, scrollPoint) {
            var parent = textDiv.offsetParent;
            var offsetY = textDiv.offsetTop + textDiv.clientTop;
            var offsetX = textDiv.offsetLeft + textDiv.clientLeft;
            while (parent.id != this._id + '_viewerContainer') {
                offsetY += parent.offsetTop;
                offsetX += parent.offsetLeft;
                parent = parent.offsetParent;
            }
            if (scrollPoint) {
                offsetY += scrollPoint.y;
                offsetX += scrollPoint.x;
                if (this._zoomVal > 1.5) {
                    parent.scrollLeft = offsetX;
                }
            }
            parent.scrollTop = offsetY;
        },

        _highlightOtherOccurrences: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                if (this._renderedCanvasList.indexOf(i) != -1 && i != this._searchPageIndex)
                    this._initSearch(i);
            }
            this._isPageScrollHighlight = false;
        },

        _clearAllOccurrences: function () {
            this._searchedText = "";
            var customMenu = document.getElementById(this._id + "custom-menu");
            $(customMenu).hide();
            this._isTextHighlighted = false;
            this._isTextSearch = false;
            if (this._searchAjaxRequestState != null) {
                this._searchAjaxRequestState.abort();
                this._searchAjaxRequestState = null;
            }
            if (this._ajaxRequestState != null) {
                this._ajaxRequestState.abort();
                this._ajaxRequestState = null;
            }
            $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-nooccurrence');
            for (var i = 1; i <= this._totalPages; i++) {
                if (this._renderedCanvasList.indexOf(parseInt(i)) !== -1) {
                    var textDiv = this._textDivs[i];
                    var textContent = this._textContents[i];
                    if (!textDiv || textDiv == undefined) {
                        break;
                    }
                    for (var j = 0; j < textDiv.length; j++) {
                        textDiv[j].textContent = textContent[j];
                        if (!this._isFindboxPresent) {
                            textDiv[j].textContent = '';
                            textDiv[j].textContent = textContent[j] + '\r\n';
                        }
                    }
                }
            }
        },

        _doAjaxPostSearch: function (jsonResult, pageIndex) {
            var proxy = this;
            this._searchAjaxRequestState = $.ajax({
                type: 'POST',
                url: this.model.serviceUrl + '/' + this.model.serverActionSettings.load,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    if (typeof data === 'object')
                        var backupjson = (JSON.stringify(data));
                    else
                        var backupjson = data;
                    if (typeof data === 'object') {
                        if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                            jsondata = JSON.parse((JSON.stringify(data)));
                        else
                            jsondata = JSON.parse((JSON.stringify(data))["d"]);
                    }
                    else {
                        if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                            jsondata = JSON.parse(data);
                        else
                            jsondata = JSON.parse(data["d"]);
                    }
                    proxy._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
                    proxy._pageText[parseInt(jsondata["currentpage"])] = jsondata["pageContents"];
                    proxy._initSearch(pageIndex);
                },
                error: function (msg, textStatus, errorThrown) {
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            });
        },

        _keyboardShortcutFind: function (event) {
            if (event.ctrlKey && event.which == 70) {
                event.preventDefault();
                if (!this._isTextSearchHidden) {
                    this._displaySearchBox();
                }
            }
        },

        _setSearchToolbarTop: function () {
            var searchToolbar = document.getElementById(this._id + '_pdfviewer_searchbox');
            searchToolbar.style.top = '0px';
        },
        _searchBoxLocalization: function () {
            var findText = $('#' + this._id + '_pdfviewer_searchbox').find('.e-pdfviewer-label')[0];
            var matchCase = $('#' + this._id + '_pdfviewer_searchbox').find('.e-pdfviewer-label')[1];
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var copyText = localeObj['contextMenu']['Find']['contentText'];
            var googleText = localeObj['contextMenu']['matchCase']['contentText'];
            $(findText).text(copyText);
            $(matchCase).text(googleText);
        },
        _displaySearchBox: function () {
            if (!this._isToolbarHidden) {
                if ($('#' + this._id + '_pdfviewer_searchbox').css('display') == 'none') {
                    this._searchBoxLocalization();
                    this._clearSelector();
                    this._displaySearch = true;
                    $('#' + this._id + '_pdfviewer_searchbox').css({ 'position': 'absolute', 'display': 'block' });
                    this._resizeSearchToolbar();
                    $('#' + this._id + '_pdfviewer_searchinput').focus().select();
                    this._isFindboxPresent = true;
                } else {
                    this._displaySearch = false;
                    this._isFindboxPresent = false;
                    this._clearAllOccurrences();
                    $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                    $('#' + this._id + '_pdfviewer_searchbox').css({ 'display': 'none' });
                }
            }
        },

        _showTextSearchButton: function (show) {
            if (show) {
                $('#' + this._id + '_find').parent().parents(".e-pdfviewer-toolbarul").css("display", "block");
                this._isTextSearchHidden = false;
            }
            else {
                $('#' + this._id + '_find').parent().parents(".e-pdfviewer-toolbarul").css("display", "none");
                if (this._isFindboxPresent) {
                    this._displaySearchBox();
                }
                this._isTextSearchHidden = true;
            }
        },

        //-------------------------------Text Select and Search [end] -----------------------------//
        //-------------------------------Text Markup Annotation [Start] ---------------------------//

        _renderTextMarkupAnnotation: function (textMarkupAnnotation, pageIndex) {
            var canvas = document.getElementById(this._id + '_secondarycanvas_' + pageIndex);
            var context = canvas.getContext("2d");
            context.setLineDash([]);
            if (textMarkupAnnotation) {
                for (var i = 0; i < textMarkupAnnotation.length; i++) {
                    var annotation = textMarkupAnnotation[i];
                    if (annotation.TextMarkupAnnotationType == "StrikeOut") {
                        var color = annotation.Color;
                        annotation.isLocked = this.model.strikethroughSettings.isLocked;
                        for (var j = 0; j < annotation.Bounds.length; j++) {
                            var bound = annotation.Bounds[j];
                            context.globalAlpha = annotation.Opacity;
                            context.beginPath();
                            context.moveTo(this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height) / 2) * this._zoomVal);
                            context.lineTo(this._convertPointToPixel(bound.Width + bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height) / 2) * this._zoomVal);
                            context.strokeStyle = "rgb(" + color.R + "," + color.G + "," + color.B + ")";
                            context.closePath();
                            context.msFillRule = "nonzero"
                            context.stroke();
                        }
                        context.lineWidth = annotation.BorderWidth;
                        context.save();
                    }
                    else if (annotation.TextMarkupAnnotationType == "Highlight") {
                        annotation.isLocked = this.model.highlightSettings.isLocked;
                        for (var j = 0; j < annotation.Bounds.length; j++) {
                            var bound = annotation.Bounds[j];
                            context.beginPath();
                            context.rect(this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y) * this._zoomVal, this._convertPointToPixel(bound.Width) * this._zoomVal, this._convertPointToPixel(bound.Height) * this._zoomVal);
                            context.lineWidth = annotation.BorderWidth;
                            var color = annotation.Color;
                            context.globalAlpha = annotation.Opacity * 0.5;
                            context.closePath();
                            context.fillStyle = "rgb(" + color.R + "," + color.G + "," + color.B + ")";
                            context.msFillRule = "nonzero";
                            context.fill();
                        }
                        context.save();
                    }
                    else if (annotation.TextMarkupAnnotationType == "Underline") {
                        annotation.isLocked = this.model.underlineSettings.isLocked;
                        var color = annotation.Color;
                        for (var j = 0; j < annotation.Bounds.length; j++) {
                            var bound = annotation.Bounds[j];
                            context.globalAlpha = annotation.Opacity;
                            context.beginPath();
                            context.moveTo(this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height)) * this._zoomVal);
                            context.lineTo(this._convertPointToPixel(bound.Width + bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height)) * this._zoomVal);
                            context.lineWidth = annotation.BorderWidth;
                            context.closePath();
                            context.strokeStyle = "rgb(" + color.R + "," + color.G + "," + color.B + ")";
                            context.msFillRule = "nonzero"
                            context.stroke();;
                        }
                        context.save();
                    }
                }
            }
            if (this._newAnnotationList[pageIndex - 1]) {
                if (this._newAnnotationList[pageIndex - 1].length != 0) {
                    this._renderNewAnnotations(this._newAnnotationList[pageIndex - 1], context)
                }
            }
        },

        _renderNewAnnotations: function (annotations, context) {
            for (var i = 0; i < annotations.length; i++) {
                var markupAnnotation = annotations[i];
                if (markupAnnotation.type == "StrikeOut") {
                    context.globalAlpha = markupAnnotation.opacity;
                    for (var j = 0; j < markupAnnotation.bounds.length; j++) {
                        var bound = markupAnnotation.bounds[j];
                        context.beginPath();
                        context.moveTo(bound.xPosition * this._zoomVal, (bound.yPosition + (bound.height / 2)) * this._zoomVal);
                        context.lineTo((bound.xPosition + bound.width) * this._zoomVal, (bound.yPosition + (bound.height) / 2) * this._zoomVal);
                        context.strokeStyle = "rgb(" + markupAnnotation.colorR + "," + markupAnnotation.colorG + "," + markupAnnotation.colorB + ")";
                        context.closePath();
                        context.msFillRule = "nonzero"
                        context.stroke();
                    }
                    context.save();
                }
                else if (markupAnnotation.type == "Highlight") {
                    context.globalAlpha = markupAnnotation.opacity * 0.5;
                    for (var j = 0; j < markupAnnotation.bounds.length; j++) {
                        var bound = markupAnnotation.bounds[j];
                        context.beginPath();
                        context.rect(bound.xPosition * this._zoomVal, bound.yPosition * this._zoomVal, bound.width * this._zoomVal, bound.height * this._zoomVal);
                        context.closePath();
                        context.fillStyle = "rgb(" + markupAnnotation.colorR + "," + markupAnnotation.colorG + "," + markupAnnotation.colorB + ")";
                        context.msFillRule = "nonzero";
                        context.fill();
                    }
                    context.save();
                }
                else if (markupAnnotation.type == "Underline") {
                    context.globalAlpha = markupAnnotation.opacity;
                    for (var j = 0; j < markupAnnotation.bounds.length; j++) {
                        var bound = markupAnnotation.bounds[j];
                        context.beginPath();
                        context.moveTo(bound.xPosition * this._zoomVal, (bound.yPosition + bound.height) * this._zoomVal);
                        context.lineTo((bound.xPosition + bound.width) * this._zoomVal, (bound.yPosition + bound.height) * this._zoomVal);
                        context.strokeStyle = "rgb(" + markupAnnotation.colorR + "," + markupAnnotation.colorG + "," + markupAnnotation.colorB + ")";
                        context.closePath();
                        context.msFillRule = "nonzero"
                        context.stroke();
                    }
                    context.save();
                }
            }
        },

        _addAnnotation: function (annotationType) {
            var annotationLayer = document.getElementById(this._id + "_secondarycanvas_" + this._currentPage);
            var context = annotationLayer.getContext("2d");
            annotationLayer.style.zIndex = "2";
            var s = window.getSelection().toString();
            switch (annotationType) {
                case "StrikeOut":
                    if (window.getSelection().toString()) {
                        this._drawStrikeOutAnnotation();
                        this._isHighlight = false;
                        this._annotationActive = true;
                    } else {
                        this._annotationActive = true;
                        this._isHighlight = false;
                        this._isStrikeout = true;
                        this._isUnderline = false;
                    }
                    break;
                case "Underline":
                    if (window.getSelection().toString()) {
                        this._drawUnderlineAnnotation();
                        this._annotationActive = true;
                        this._isHighlight = false;
                    } else {
                        this._annotationActive = true;
                        this._isHighlight = false;
                        this._isUnderline = true;
                        this._isStrikeout = false;
                    }
                    break;
                case "Highlight":
                    if (window.getSelection().toString()) {
                        this._drawHighlightAnnotation();
                        this._annotationActive = true;
                        this._isHighlight = true;
                    } else {
                        this._annotationActive = true;
                        this._isHighlight = true;
                        this._isUnderline = false;
                        this._isStrikeout = false;
                    }
                    break;
                default:
                    break;
            }
        },

        _initHighlight: function () {
            if (!this._isHighlightEnabled) {
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                this._addAnnotation("Highlight");
                this._isHighlightEnabled = true;
                this._isUnderlineEnabled = false;
                this._isStrikeOutEnabled = false;
                this._isHighlight = true;
            } else {
                if (!this._isToolbarColorPicker) {
                    this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                    this._isHighlightEnabled = false;
                    this._annotationActive = false;
                    this._isHighlight = false;
                    this._isUnderline = false;
                    this._isStrikeout = false;
                    this._isUnderlineEnabled = false;
                    this._isStrikeOutEnabled = false;
                    this._drawColor = null;
                    this._isDefaultColorSet = false;
                }
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
            }
        },

        _initStrikeOut: function () {
            if (!this._isStrikeOutEnabled) {
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                this._addAnnotation("StrikeOut");
                this._isStrikeOutEnabled = true;
                this._isUnderlineEnabled = false;
                this._isHighlightEnabled = false;
                this._isStrikeout = true;
            } else {
                if (!this._isToolbarColorPicker) {
                    this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                    this._isHighlightEnabled = false;
                    this._annotationActive = false;
                    this._isHighlight = false;
                    this._isUnderline = false;
                    this._isStrikeout = false;
                    this._isUnderlineEnabled = false;
                    this._isStrikeOutEnabled = false;
                    this._drawColor = null;
                    this._isDefaultColorSet = false;
                }
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
            }
        },

        _initUnderline: function () {
            if (!this._isUnderlineEnabled) {
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_underline');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                this._addAnnotation("Underline");
                this._isUnderlineEnabled = true;
                this._isHighlightEnabled = false;
                this._isStrikeOutEnabled = false;
                this._isUnderline = true;
            } else {
                if (!this._isToolbarColorPicker) {
                    this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
                    this._isHighlightEnabled = false;
                    this._annotationActive = false;
                    this._isHighlight = false;
                    this._isUnderline = false;
                    this._isStrikeout = false;
                    this._isUnderlineEnabled = false;
                    this._isStrikeOutEnabled = false;
                    this._drawColor = null;
                    this._isDefaultColorSet = false;
                }
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
            }
        },

        _getPagePosition: function (id) {
            var pageContainer = document.getElementById(this._id + "selectioncanvas_" + id);
            return pageContainer.getBoundingClientRect();
        },

        _getTextNodes: function (selection, pageIndex) {
            var selectionRects = [];
            var range = document.createRange();
            var selectionRange = selection.getRangeAt(0);
            var annotationRect = selectionRange.getBoundingClientRect();
            if (selection.anchorNode == selection.focusNode) {
                if (this._isBackwardSelection) {
                    range.setStart(selection.focusNode, selection.focusOffset);
                    range.setEnd(selection.anchorNode, selection.anchorOffset);
                } else {
                    if (selection.anchorOffset < selection.focusOffset) {
                        range.setStart(selection.anchorNode, selection.anchorOffset);
                        range.setEnd(selection.focusNode, selection.focusOffset);
                    } else {
                        range.setStart(selection.focusNode, selection.focusOffset);
                        range.setEnd(selection.anchorNode, selection.anchorOffset);
                    }
                }
                var boundingRect = range.getBoundingClientRect();
                selectionRects.push(boundingRect);
            } else {
                if (this._isBackwardSelection) {
                    this._getAnnotationOffsets(selectionRange, selection.focusNode, selection.anchorNode, selection.focusOffset, selection.anchorOffset, selectionRects);
                } else {
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        var isBackwardSelection = false;
                        var anchorIndex, focusIndex;
                        for (var i = 0; i < this._textDivs[pageIndex].length; i++) {
                            var textContent = this._textDivs[pageIndex][i].textContent;
                            if (textContent == selection.anchorNode.data)
                                anchorIndex = i;
                            if (textContent == selection.focusNode.data)
                                focusIndex = i;
                            if (i == this._textDivs[pageIndex].length - 1 && !focusIndex) {
                                focusIndex = this._textDivs[pageIndex].length - 1;
                            }
                        }
                        if (anchorIndex < focusIndex) {
                            this._getAnnotationOffsets(selectionRange, selection.anchorNode, selection.focusNode, selection.anchorOffset, selection.focusOffset, selectionRects);
                        } else 
                            this._getAnnotationOffsets(selectionRange, selection.focusNode, selection.anchorNode, selection.focusOffset, selection.anchorOffset, selectionRects);
                    } else
                        this._getAnnotationOffsets(selectionRange, selection.anchorNode, selection.focusNode, selection.anchorOffset, selection.focusOffset, selectionRects);
                }
            }
            return { rectangleBound : annotationRect, bounds : selectionRects };
        },

        _getAnnotationOffsets: function (selectionRange, startNode, endNode, selectionStartOffset, selectionEndOffset, selectionRects) {
            var anchorPageId = parseInt(startNode.parentNode.id.split("text_")[1]);
            var anchorTextId = parseInt(startNode.parentNode.id.split("text_" + anchorPageId + '_')[1]);
            var focusPageId = parseInt(endNode.parentNode.id.split("text_")[1]);
            var focusTextId = parseInt(endNode.parentNode.id.split("text_" + focusPageId + '_')[1]);
            var startOffset, endOffset, currentId;
            if (this._isFindboxPresent) {
                this._clearAllOccurrences();
            }
            var pageId;
            if (anchorPageId != focusPageId && this._isBackwardSelection)
                pageId = focusPageId;
            else
                pageId = anchorPageId;
            for (var i = pageId; i <= focusPageId; i++) {
                var textDivs = this._textDivs[i];
                if (i == anchorPageId) {
                    currentId = anchorTextId;
                } else {
                    if (this._isBackwardSelection)
                        currentId = 0;
                    else
                        break;
                }
                for (var j = currentId; j < this._textDivs[i].length; j++) {
                    var textElement = textDivs[j];
                    var range = document.createRange();
                    if (j == anchorTextId) {
                        startOffset = selectionStartOffset;
                    } else {
                        startOffset = 0;
                    }
                    if (j == focusTextId) {
                        endOffset = selectionEndOffset;
                    } else {
                        endOffset = textElement.textContent.length;
                    }
                    for (var k = 0; k < textElement.childNodes.length; k++) {
                        var node = textElement.childNodes[k];
                        range.setStart(node, startOffset);
                        range.setEnd(node, endOffset);
                    }
                    var boundingRect = range.getBoundingClientRect();
                    range.detach();
                    selectionRects.push(boundingRect);
                    if (i == focusPageId && j == focusTextId) {
                        break;
                    }
                }
            }
        },

        _drawStrikeOutAnnotation: function () {
            if (this.model.enableTextMarkupAnnotations && this.model.enableStrikethroughAnnotation) {
                if (window.getSelection().toString()) {
                    var selection = window.getSelection();
                    var anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                    var focusId;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                        focusId = parseInt(selection.focusNode.parentNode.id.split("text_")[1]);
                        if (anchorId < focusId) {
                            this._isBackwardSelection = false;
                        } else if (anchorId > focusId) {
                            this._isBackwardSelection = true;
                        }
                    }
                    var prevYPosition = 0;
                    var indexes = [];
                    var selectionRects = this._getTextNodes(selection, anchorId);
                    var drawColor = this._drawColor ? this._drawColor : this.model.strikethroughSettings.color;
                    var tempColorObject;
                    if (typeof drawColor === 'object') {
                        tempColorObject = JSON.parse(JSON.stringify(drawColor));
                        drawColor = 'rgb(' + drawColor.r + ',' + drawColor.g + ',' + drawColor.b + ')';
                    } else if (typeof drawColor === 'string') {
                        tempColorObject = this._toolbarColorpickerObject.hexCodeToRGB(drawColor);
                    }
                    var date = new Date();
                    var modifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    var textMarkupAnnotation = {
                        type: "StrikeOut",
                        bounds: [],
                        author: this.model.strikethroughSettings.author,
                        subject: this.model.strikethroughSettings.subject,
                        modifiedDate: modifiedDate,
                        colorR: tempColorObject.r,
                        colorG: tempColorObject.g,
                        colorB: tempColorObject.b,
                        colorA: 1 * 255,
                        opacity: this.model.strikethroughSettings.opacity,
                        note: "",
                        pageNumber: anchorId,
                        isLocked: this.model.strikethroughSettings.isLocked
                    }
                    for (var i = 0; i < selectionRects.bounds.length; i++) {
                        var pagePosition = this._getPagePosition(anchorId);
                        var bounds = selectionRects.bounds[i];
                        var xPosition = bounds.left - pagePosition.left;
                        var yPosition = bounds.top - pagePosition.top;
                        if (yPosition > this._pageSize[anchorId - 1].PageHeight) {
                            anchorId++;
                            pagePosition = this._getPagePosition(anchorId);
                            var yPosition = bounds.top - pagePosition.top;
                        }
                        var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + anchorId);
                        var secCanvasPosition = secCanvas.getBoundingClientRect();
                        var context = secCanvas.getContext("2d");
                        context.beginPath();
                        yPosition = yPosition - 1.2 * this._zoomVal;
                        context.moveTo(xPosition, (yPosition) + (bounds.height / 2));
                        context.lineTo(xPosition + bounds.width, (yPosition) + (bounds.height / 2));
                        context.closePath();
                        context.strokeStyle = drawColor;
                        context.stroke();
                        var annotationBound = {
                            xPosition: xPosition / this._zoomVal,
                            yPosition: yPosition / this._zoomVal,
                            width: bounds.width / this._zoomVal,
                            height: bounds.height / this._zoomVal
                        };
                        textMarkupAnnotation.bounds.push(annotationBound);
                    }
                    this._newAnnotationList[anchorId - 1].push(textMarkupAnnotation);
                    this._totalAnnotations[anchorId].push(JSON.parse(JSON.stringify(textMarkupAnnotation)));
                    var args = new Object();
                    args.annotationSettings = this.model.strikethroughSettings;
                    args.annotationId = this._totalAnnotations[anchorId].length - 1;
                    args.pageId = anchorId;
                    args.annotationBound = textMarkupAnnotation.bounds;
                    args.annotationType = "StrikeOut"
                    this._raiseClientEvent("annotationAdd", args);
                    var lastIndex = this._newAnnotationList[anchorId - 1].length - 1;
                    indexes.push(lastIndex);
                    var recentOp = {
                        operation: "AddedStrikeOut",
                        pageNumber: anchorId,
                        indexes: indexes
                    }
                    this._recentOperation.push(recentOp);
                    this._redoActions = new Array();
                    for (var i = 0; i < this._totalPages; i++) {
                        var newArray = [];
                        this._redoAnnotationCollection[i] = newArray;
                    }
                    window.getSelection().removeAllRanges();
                    this.isDocumentEdited = true;
                }
                if ($('#' + this._id + 'custom-menu'))
                    $('#' + this._id + 'custom-menu').hide();
                this._waterDropletDivHide();
                $('#' + this._id + 'touchcustom-menu').hide();
            }
        },

        _drawUnderlineAnnotation: function () {
            if (this.model.enableTextMarkupAnnotations && this.model.enableUnderlineAnnotation) {
                if (window.getSelection().toString()) {
                    var selection = window.getSelection();
                    var anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                    var focusId;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                        focusId = parseInt(selection.focusNode.parentNode.id.split("text_")[1]);
                        if (anchorId < focusId) {
                            this._isBackwardSelection = false;
                        } else if (anchorId > focusId) {
                            this._isBackwardSelection = true;
                        }
                    }
                    var prevYPosition = 0;
                    var indexes = [];
                    var drawColor = this._drawColor ? this._drawColor : this.model.underlineSettings.color;
                    var tempColorObject;
                    if (typeof drawColor === 'object') {
                        tempColorObject = JSON.parse(JSON.stringify(drawColor));
                        drawColor = 'rgb(' + drawColor.r + ',' + drawColor.g + ',' + drawColor.b + ')';
                    } else if (typeof drawColor === 'string') {
                        tempColorObject = this._toolbarColorpickerObject.hexCodeToRGB(drawColor);
                    }
                    var selectionRects = this._getTextNodes(selection, anchorId);
                    var date = new Date();
                    var modifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    var textMarkupAnnotation = {
                        type: "Underline",
                        bounds: [],
                        author: this.model.underlineSettings.author,
                        subject: this.model.underlineSettings.subject,
                        modifiedDate: modifiedDate,
                        colorR: tempColorObject.r,
                        colorG: tempColorObject.g,
                        colorB: tempColorObject.b,
                        colorA: 1 * 255,
                        opacity: this.model.underlineSettings.opacity,
                        note: "",
                        pageNumber: anchorId,
                        isLocked: this.model.underlineSettings.isLocked
                    };
                    for (var i = 0; i < selectionRects.bounds.length; i++) {
                        var pagePosition = this._getPagePosition(anchorId);
                        var bounds = selectionRects.bounds[i];
                        var xPosition = bounds.left - pagePosition.left;
                        var yPosition = bounds.top - pagePosition.top;
                        if (yPosition > this._pageSize[anchorId - 1].PageHeight) {
                            anchorId++;
                            pagePosition = this._getPagePosition(anchorId);
                            var yPosition = bounds.top - pagePosition.top;
                        }
                        var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + anchorId);
                        var secCanvasPosition = secCanvas.getBoundingClientRect();
                        var context = secCanvas.getContext("2d");
                        context.beginPath();
                        yPosition = yPosition - 1.2 * this._zoomVal;
                        context.moveTo(xPosition, yPosition + bounds.height);
                        context.lineTo(xPosition + bounds.width, yPosition + bounds.height);
                        context.closePath();
                        context.strokeStyle = drawColor;
                        context.stroke();
                        var annotationBound = {
                            xPosition: xPosition / this._zoomVal,
                            yPosition: yPosition / this._zoomVal,
                            width: bounds.width / this._zoomVal,
                            height: bounds.height / this._zoomVal
                        };
                        textMarkupAnnotation.bounds.push(annotationBound);
                    }
                    this._newAnnotationList[anchorId - 1].push(textMarkupAnnotation);
                    this._totalAnnotations[anchorId].push(JSON.parse(JSON.stringify(textMarkupAnnotation)));
                    var args = new Object();
                    args.annotationSettings = this.model.underlineSettings;
                    args.annotationId = this._totalAnnotations[anchorId].length - 1;
                    args.pageId = anchorId;
                    args.annotationBound = textMarkupAnnotation.bounds;
                    args.annotationType = "Underline";
                    this._raiseClientEvent("annotationAdd", args);
                    var lastIndex = this._newAnnotationList[anchorId - 1].length - 1;
                    indexes.push(lastIndex);
                    var recentOp = {
                        operation: "AddedUnderline",
                        pageNumber: anchorId,
                        indexes: indexes
                    }
                    this._recentOperation.push(recentOp);
                    this._redoActions = new Array();
                    for (var i = 0; i < this._totalPages; i++) {
                        var newArray = [];
                        this._redoAnnotationCollection[i] = newArray;
                    }
                    this.isDocumentEdited = true;
                    window.getSelection().removeAllRanges();
                    this._waterDropletDivHide();
                    $('#' + this._id + 'touchcustom-menu').hide();
                }
            }
        },

        _drawHighlightAnnotation: function () {
            if (this.model.enableTextMarkupAnnotations && this.model.enableHighlightAnnotation) {
                if (window.getSelection().toString()) {
                    var selection = window.getSelection();
                    var anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                    var focusId;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                        focusId = parseInt(selection.focusNode.parentNode.id.split("text_")[1]);
                        if (anchorId < focusId) {
                            this._isBackwardSelection = false;
                        } else if (anchorId > focusId) {
                            this._isBackwardSelection = true;
                        }
                    }
                    var prevYPosition = 0;
                    var indexes = [];
                    var selectionRects = this._getTextNodes(selection, anchorId);
                    var drawColor = this._drawColor ? this._drawColor : this.model.highlightSettings.color;
                    var tempColorObject;
                    if (typeof drawColor === 'object') {
                        tempColorObject = JSON.parse(JSON.stringify(drawColor));
                        drawColor = 'rgb(' + drawColor.r + ',' + drawColor.g + ',' + drawColor.b + ')';
                    } else if (typeof drawColor === 'string') {
                        tempColorObject = this._toolbarColorpickerObject.hexCodeToRGB(drawColor);
                    }
                    var date = new Date();
                    var modifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    var textMarkupAnnotation = {
                        type: "Highlight",
                        bounds: [],
                        author: this.model.highlightSettings.author,
                        subject: this.model.highlightSettings.subject,
                        modifiedDate: modifiedDate,
                        colorR: tempColorObject.r,
                        colorG: tempColorObject.g,
                        colorB: tempColorObject.b,
                        colorA: 1 * 255,
                        opacity: this.model.highlightSettings.opacity,
                        note: "",
                        pageNumber: anchorId,
                        isLocked: this.model.highlightSettings.isLocked
                    };
                    for (var i = 0; i < selectionRects.bounds.length; i++) {
                        var pagePosition = this._getPagePosition(anchorId);
                        var bounds = selectionRects.bounds[i];
                        var xPosition = bounds.left - pagePosition.left;
                        var yPosition = bounds.top - pagePosition.top;
                        if (yPosition > this._pageSize[anchorId - 1].PageHeight) {
                            anchorId++;
                            pagePosition = this._getPagePosition(anchorId);
                            var yPosition = bounds.top - pagePosition.top;
                        }
                        var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + anchorId);
                        var secCanvasPosition = secCanvas.getBoundingClientRect();
                        var context = secCanvas.getContext("2d");
                        context.beginPath();
                        yPosition = yPosition - 1.2 * this._zoomVal;
                        context.rect(xPosition, yPosition, bounds.width, bounds.height);
                        context.closePath();
                        context.globalAlpha = 0.5;
                        context.fillStyle = drawColor;
                        context.fill();
                        var annotationBound = {
                            xPosition: xPosition / this._zoomVal,
                            yPosition: yPosition / this._zoomVal,
                            width: bounds.width / this._zoomVal,
                            height: bounds.height / this._zoomVal
                        };
                        textMarkupAnnotation.bounds.push(annotationBound);
                    }
                    this._newAnnotationList[anchorId - 1].push(textMarkupAnnotation);
                    this._totalAnnotations[anchorId].push(JSON.parse(JSON.stringify(textMarkupAnnotation)));
                    var args = new Object();
                    args.annotationSettings = this.model.highlightSettings;
                    args.annotationId = this._totalAnnotations[anchorId].length - 1;
                    args.pageId = anchorId;
                    args.annotationBound = textMarkupAnnotation.bounds;
                    args.annotationType = "Highlight"
                    this._raiseClientEvent("annotationAdd", args);
                    var lastIndex = this._newAnnotationList[anchorId - 1].length - 1;
                    indexes.push(lastIndex);
                    var recentOp = {
                        operation: "AddedHighlight",
                        pageNumber: anchorId,
                        indexes: indexes
                    }
                    this._recentOperation.push(recentOp);
                    this._redoActions = new Array();
                    for (var i = 0; i < this._totalPages; i++) {
                        var newArray = [];
                        this._redoAnnotationCollection[i] = newArray;
                    }
                    this.isDocumentEdited = true;
                    window.getSelection().removeAllRanges();
                }
                if ($('#' + this._id + 'custom-menu'))
                    $('#' + this._id + 'custom-menu').hide();
                this._waterDropletDivHide();
                $('#' + this._id + 'touchcustom-menu').hide();
            }
        },

        _drawAnnotationRect: function (pageIndex, xPosition, yPosition, width, height) {
            var canvas = document.getElementById(this._id + '_secondarycanvas_' + pageIndex);
            if (canvas) {
                var context = canvas.getContext("2d");
                context.beginPath();
                context.setLineDash([4]);
                context.globalAlpha = 1;
                context.rect(xPosition, yPosition, width, height);
                context.closePath();
                context.strokeStyle = "blue";
                context.stroke();
                context.save();
            }
        },

        _drawAnnotSelectRect: function (pageNumber, currentAnnotationRectangle) {
            var currentAnnotation = currentAnnotationRectangle[currentAnnotationRectangle.length - 1];
            this._selectedAnnotation = currentAnnotation;
            this._selectedAnnotationObject = new Object();
            this._selectedAnnotationObject.annotation = currentAnnotation;
            this._selectedAnnotationObject.pageIndex = pageNumber;
            var annotDetails = this._getAnnotation(currentAnnotationRectangle, pageNumber);
            if (annotDetails.isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[pageNumber][annotDetails.currentAnnotationIndex];
                for (var i = 0; i < annot.Bounds.length; i++) {
                    var bound = annot.Bounds[i];
                    this._drawAnnotationRect(pageNumber, this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y) * this._zoomVal, this._convertPointToPixel(bound.Width) * this._zoomVal, this._convertPointToPixel(bound.Height) * this._zoomVal);
                }
            } else {
                var annotation = currentAnnotationRectangle[0];
                if (annotation.bounds) {
                    for (var i = 0; i < annotation.bounds.length; i++) {
                        var bound = annotation.bounds[i];
                        this._drawAnnotationRect(pageNumber, (bound.xPosition - 0.5) * this._zoomVal, (bound.yPosition - 0.5) * this._zoomVal,
                                    (bound.width + 0.5) * this._zoomVal,
                                    (bound.height + 0.5) * this._zoomVal);
                    }
                }
            }
            this._isAnnotationSelected = true;
        },

        _clearRectOnClick: function (pageIndex) {
            var canvas = document.getElementById(this._id + '_secondarycanvas_' + pageIndex);
            var context = canvas.getContext("2d");
            context.setLineDash([]);
            context.clearRect(0, 0, canvas.width, canvas.height);
            this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageIndex], pageIndex);
            this._isAnnotationSelected = false;
            this._selectedAnnotationObject = null;
        },

        _onCanvasMousedown: function (secanvas, pageX, pageY) {
            var targetContext = secanvas.getContext("2d");
            var x = parseInt(pageX - $(secanvas.parentNode).offset().left);
            var y = parseInt(pageY - $(secanvas.parentNode).offset().top);
            var imagedata = targetContext.getImageData(x, y, 1, 1).data;
            this._annotationColor = this._rgb2Color(imagedata[0], imagedata[1], imagedata[2]);
        },

        _showPopupNote: function (e) {
            var noteContent = document.getElementById(this._id + '_note_content');
            var annotation = this._currentAnnotationRectangle[0];
            if (annotation.note) {
                noteContent.textContent = annotation.note;
                var r = annotation.Color ? annotation.Color.R : annotation.colorR;
                var g = annotation.Color ? annotation.Color.G : annotation.colorG;
                var b = annotation.Color ? annotation.Color.B : annotation.colorB;
                var authorContent = document.getElementById(this._id + '_author_content');
                authorContent.style.borderBottom = "1px solid black";
                authorContent.style.fontWeight = "bold";
                var author = annotation.Author ? annotation.Author : annotation.author;
                if (author);
                authorContent.textContent = author;
                noteContent.style.backgroundColor = 'rgb(' + r + ',' + g + ',' + b + ')';
                var noteElement =$('#' + this._id + '_popup_note');
                var position = this._setPopupMenuPosition(e, noteElement);
                noteElement.css({ 'display': 'block', 'background-color': 'rgb(' + r + ',' + g + ',' + b + ')', 'position': 'absolute' });
                noteElement.show();
                noteElement.offset({ top: position.y + 5, left: position.x + 5 }).show();
                noteElement.show();
                noteElement.offset({ top: position.y + 5, left: position.x + 5 }).show();
                noteElement.show();
            }
        },

        _showPopupMenu: function (e) {
            if (!this._isPropertiesWindowOpen) {
                this._isPopupNoteVisible = true;
                $('#' + this._id + '_popup_note').hide();
                document.getElementById(this._id + '_popupinnercontent').innerText = "";
                var highlight = document.getElementById(this._id + "highlight-menu");
                $(highlight).hide();
                this._isContextMenuPresent = false;
                var notesContent = document.getElementById(this._id + "_popupinnercontent");
                $(notesContent).focus();
                notesContent.contentEditable = true;
                var authorName, modifiedDate, note;
                var currentAnnotation = (this._currentAnnotationRectangle.length > 0) ? this._currentAnnotationRectangle : this._currentAnnotationRectangleBackup;
                this._annotationBackupNoteSave = currentAnnotation;
                var annotDetails = this._getAnnotation(currentAnnotation, this._AnnotationPage);
                if (annotDetails.isExistingAnnotation) {
                    var annot = this._textMarkupAnnotationList[this._AnnotationPage][annotDetails.currentAnnotationIndex];
                    authorName = annot.Author;
                    modifiedDate = annot.ModifiedDate;
                    if (annot.note) {
                        note = annot.note;
                    }
                } else {
                    for (var j = 0; j < this._currentAnnotations.length; j++) {
                        var annotation = this._currentAnnotations[j];
                        authorName = annotation.author;
                        modifiedDate = annotation.modifiedDate;
                        if (annotation.note) {
                            note = annotation.note;
                        }
                        break;
                    }
                }
                document.getElementById(this._id + '_username').innerText = authorName;
                document.getElementById(this._id + '_currentTime').innerText = modifiedDate;
                if (note) {
                    document.getElementById(this._id + '_popupinnercontent').innerText = note;
                }
                var popupmenu = document.getElementById(this._id + "_popupmenu");
                var contextMenu = $(popupmenu);
                var pos = this._setPopupMenuPosition(e, contextMenu);
                $(popupmenu).show();
                $(popupmenu).offset({ top: pos.y, left: pos.x }).show();
                $(popupmenu).show();
                $(popupmenu).offset({ top: pos.y, left: pos.x }).show();
                $(popupmenu).show();
            }
        },

        _saveNote: function () {
            var currentAnnotation;
            if (this._annotationBackupNoteSave) {
                currentAnnotation = this._annotationBackupNoteSave;
            } else {
                currentAnnotation = (this._currentAnnotationRectangle.length > 0) ? this._currentAnnotationRectangle : this._currentAnnotationRectangleBackup;
            }
            var date = new Date();
            var annotDetails = this._getAnnotation(currentAnnotation, this._AnnotationPage);
            var popupContent = document.getElementById(this._id + '_popupinnercontent');
            if (annotDetails.isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[this._AnnotationPage][annotDetails.currentAnnotationIndex];
                if (annot.note != popupContent.textContent) {
                    var annotationType = annot.TextMarkupAnnotationType;
                    if (annotationType == "Highlight") {
                        annot.ModifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "Underline") {
                        annot.ModifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "StrikeOut") {
                        annot.ModifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    }
                    annot.note = popupContent.textContent;
                }
            } else {
                for (var j = 0; j < this._currentAnnotations.length; j++) {
                    var annotation = this._currentAnnotations[j];
                    if (annotation.note != popupContent.textContent) {
                        var annotationType = annotation.type;
                        if (annotationType == "Highlight") {
                            annotation.modifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                        } else if (annotationType == "Underline") {
                            annotation.modifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                        } else if (annotationType == "StrikeOut") {
                            annotation.modifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                        }
                        annotation.note = popupContent.textContent;
                    }
                    break;
                }
            }
            popupContent.innerText = "";
        },

        _setPropertiesWindowLocale: function (localeObj) {
            var appearanceText = localeObj['propertyWindow']['appearance']['contentText'];
            var generalText = localeObj['propertyWindow']['general']['contentText'];
            var colorText = localeObj['propertyWindow']['color']['contentText'];
            var opacityText = localeObj['propertyWindow']['opacity']['contentText'];
            var authorText = localeObj['propertyWindow']['author']['contentText'];
            var subjectText = localeObj['propertyWindow']['subject']['contentText'];
            var modifiedText = localeObj['propertyWindow']['modified']['contentText'];
            var okText = localeObj['propertyWindow']['ok']['contentText'];
            var cancelText = localeObj['propertyWindow']['cancel']['contentText'];
            var lockedText = localeObj['propertyWindow']['locked']['contentText'];
            this._replaceTextLocale($("#" + this._id + "_appearanceli").children("a")[0], appearanceText);
            this._replaceTextLocale($("#" + this._id + "_generalli").children("a")[0], generalText);
            this._replaceTextLocale($("#" + this._id + "_colorspan")[0], colorText);
            this._replaceTextLocale($("#" + this._id + "_opacityspan")[0], opacityText);
            this._replaceTextLocale($("#" + this._id + "_authorspan")[0], authorText);
            this._replaceTextLocale($("#" + this._id + "_subjectspan")[0], subjectText);
            this._replaceTextLocale($("#" + this._id + "_modifiedspan")[0], modifiedText);
            this._replaceTextLocale($("#" + this._id + "_ok")[0], okText);
            this._replaceTextLocale($("#" + this._id + "_cancel")[0], cancelText);
            this._replaceTextLocale($("#" + this._id + "_lockedprop")[0], lockedText);
        },

        _showPropertiesMenu: function (e) {
            this._isPropertiesWindowOpen = true;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            this._setPropertiesWindowLocale(localeObj);
            var highlight = document.getElementById(this._id + "highlight-menu");
            $(highlight).hide();
            this._isContextMenuPresent = false;
            var tabObject = $("#" + this._id + "_PropertiesDialogTab").data("ejTab");
            tabObject.showItem(0);
            var annotColor, annotOpacity, authorName, subjectName, modifiedDate, isLocked;
            var annotDetails = this._getAnnotation(this._currentAnnotationRectangleBackup, this._AnnotationPage);
            var annotationType;
            if (annotDetails.isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[this._AnnotationPage][annotDetails.currentAnnotationIndex];
                annotColor = { r: annot.Color.R, g: annot.Color.G, b: annot.Color.B };
                annotOpacity = annot.Opacity;
                authorName = annot.Author;
                subjectName = annot.Subject;
                modifiedDate = annot.ModifiedDate;
                isLocked = annot.isLocked;
                annotationType = annot.TextMarkupAnnotationType;
            } else {
                for (var j = 0; j < this._currentAnnotations.length; j++) {
                    var annotation = this._currentAnnotations[j];
                    annotColor = { r: annotation.colorR, g: annotation.colorG, b: annotation.colorB };
                    annotOpacity = annotation.opacity;
                    authorName = annotation.author;
                    subjectName = annotation.subject;
                    modifiedDate = annotation.modifiedDate;
                    isLocked = annotation.isLocked;
                    annotationType = annotation.type;
                    break;
                }
            }
            this._colorpickerObject.option("value", this._rgb2Color(annotColor.r, annotColor.g, annotColor.b));
            var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
            var displayOpacity = parseInt(annotOpacity * 100);
            sliderObject.option("value", displayOpacity);
            $("#" + this._id + "_opacity").val(displayOpacity + "%");
            $('#' + this._id + "_author_input").val(authorName);
            $('#' + this._id + "_subject_input").val(subjectName);
            var spanElement = document.getElementById(this._id + "_modifieddate").childNodes[0];
            spanElement.textContent = modifiedDate;
            $('#' + this._id + "_containerDialogTab").ejDialog({ title: annotationType + " Properties" });
            var headerElement = $("#" + this._id + "_containerDialogTab_title").children("span")[0];
            if (annotationType == "Highlight") 
                headerElement.textContent = localeObj['propertyWindow']['highlightProperties']['contentText'];
            else if (annotationType == "StrikeOut")
                headerElement.textContent = localeObj['propertyWindow']['strikeOutProperties']['contentText'];
            else if (annotationType == "Underline")
                headerElement.textContent = localeObj['propertyWindow']['underlineProperties']['contentText'];
            $('#' + this._id + "_containerDialogTab").ejDialog("open");
            $("#" + this.id + "_colorpicker").ejColorPicker("show");
            if (isLocked) {
                this._colorpickerObject.option('enabled', false);
                document.getElementById(this._id + "_opacity").disabled = true;
                $('#' + this._id + "_opacity").addClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.disable();
                document.getElementById(this._id + "_author_input").disabled = true;
                $('#' + this._id + "_author_input").addClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = true;
                $('#' + this._id + "_subject_input").addClass("e-disable");
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                checkboxObject.option("checked", true);
            } else {
                this._colorpickerObject.option('enabled', true);
                document.getElementById(this._id + "_opacity").disabled = false;
                $('#' + this._id + "_opacity").removeClass("e-disable");
                document.getElementById(this._id + "_author_input").disabled = false;
                $('#' + this._id + "_author_input").removeClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = false;
                $('#' + this._id + "_subject_input").removeClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.enable();
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                checkboxObject.option("checked", false);
            }
        },

        _lockProperties: function () {
            var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
            if (checkboxObject.model.checkState == "check") {
                this._colorpickerObject.option('enabled', false);
                document.getElementById(this._id + "_opacity").disabled = true;
                $('#' + this._id + "_opacity").addClass("e-disable");
                document.getElementById(this._id + "_author_input").disabled = true;
                $('#' + this._id + "_author_input").addClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = true;
                $('#' + this._id + "_subject_input").addClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.disable();
            } else {
                this._colorpickerObject.option('enabled', true);
                document.getElementById(this._id + "_opacity").disabled = false;
                $('#' + this._id + "_opacity").removeClass("e-disable");
                document.getElementById(this._id + "_author_input").disabled = false;
                $('#' + this._id + "_author_input").removeClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = false;
                $('#' + this._id + "_subject_input").removeClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.enable();
            }
        },

        _setDrawColor: function (event) {
            if (this._isDefaultColorSet) {
                this._drawColor = this._toolbarColorpickerObject.hexCodeToRGB(event.value);
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
                this._isDefaultColorSet = false;
            }
        },

        _createNote: function () {
            var pageviewcontainer = $('#' + this._id + '_viewerContainer');
            var note = ej.buildTag("div.e-pdfviewer-annotation-note", "", { 'display': 'none' }, { "id": this._id + '_popup_note' });
            var authorcontent = ej.buildTag("div.e-pdfviewer-annotation-authorcontent", "", {}, { "id": this._id + '_author_content' });
            var notecontent = ej.buildTag("div.e-pdfviewer-annotation-notecontent", "", {}, { "id": this._id + '_note_content' });
            note.append(authorcontent);
            note.append(notecontent);
            pageviewcontainer.append(note);
        },

        _createPopupMenu: function () {
            var pageviewcontainer = $('#' + this._id + '_viewerContainer');
            var popupmenu = document.createElement("DIV");
            popupmenu.id = this._id + "_popupmenu";
            popupmenu.className = "e-pdfviewer-popupmenu";
            pageviewcontainer.append(popupmenu);
            var popupHeader = document.createElement("DIV");
            popupHeader.className = "e-pdfviewer-header"
            popupHeader.id = this._id + "_popupheader";
            popupmenu.appendChild(popupHeader);
            var userName = document.createElement("DIV");
            userName.className = "e-pdfviewer-username";
            userName.id = this._id + "_username";
            userName.innerHTML = "Guest";
            popupHeader.appendChild(userName);
            var closeIconContainer = ej.buildTag("div.e-pdfviewer-closepopup", "", {}, { "id": this._id + '_popup_close' });
            var closeIcon = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-closeicon");
            closeIconContainer[0].appendChild(closeIcon[0]);
            popupHeader.appendChild(closeIconContainer[0]);
            var proxy = this;
            $('.e-pdfviewer-closeicon').on("click touchend", function () {
                proxy._saveNote();
                $('.e-pdfviewer-popupmenu').hide();
                proxy._isPopupNoteVisible = false;
            });
            var timeDivContainer = document.createElement("DIV");
            var timeDiv = document.createElement("DIV");
            timeDivContainer.className = "e-pdfviewer-currenttime";
            timeDiv.id = this._id + "_currentTime";
            var d = new Date();
            timeDiv.innerHTML = d.toLocaleString();
            timeDivContainer.appendChild(timeDiv);
            popupmenu.appendChild(timeDivContainer);
            var popupContent = document.createElement("DIV");
            popupContent.className = "e-pdfviewer-content";
            popupContent.id = this._id + "_popupcontent";
            var popupInnerContent = document.createElement("DIV");
            popupInnerContent.className = "e-pdfviewer-innercontent";
            popupInnerContent.id = this._id + "_popupinnercontent";
            popupInnerContent.innerText = " ";
            popupInnerContent.style.width = "366.667px";
            popupInnerContent.style.height = "132.073px";
            popupInnerContent.style.overflow = "hidden";
            popupInnerContent.style.overflowY = "auto";
            popupContent.appendChild(popupInnerContent);
            popupmenu.appendChild(popupContent);
            var popupFooter = document.createElement("DIV");
            popupFooter.className = "e-pdfviewer-footer";
            popupFooter.id = this._id + "_popupfooter";
            popupmenu.appendChild(popupFooter);
            var popupNote = document.getElementById(this._id + "_popupmenu");
            popupInnerContent.addEventListener("paste", function (e) {
                e.preventDefault();
                var text = e.clipboardData.getData("text/plain");
                document.execCommand("insertHTML", false, text);
            });
            this._on($(popupNote), "mousedown touchstart", this._popupNoteMousedown);
            this._on($(popupNote), "mouseup touchend", this._popupNoteMouseup);
            this._on($(window), "touchmove mousemove", this._movePopupNote);
        },
      _popupNoteMousedown: function (e) {
            if (e.type == "touchstart")
                e = e.originalEvent.changedTouches[0];
            if (e.which != 3 || e.type == "touchstart") {
                this._isPopupNoteFocused = true;
                var popupNote = document.getElementById(this._id + "_popupmenu");
                this._xpos = e.clientX - popupNote.offsetLeft;
                this._ypos = e.clientY - popupNote.offsetTop;
            }
        },
        _popupNoteMouseup: function (e) {
            this._enableSelection();
            this._isPopupNoteFocused = false;
        },
        _movePopupNote: function (e) {
            e.preventDefault();
            if (e.type == "touchmove")
                e = e.originalEvent.changedTouches[0];
            if (this._isPopupNoteFocused || e.type == "touchmove") {
                var viewer = document.getElementById(this._id + '_viewerContainer');
                var popupNote = document.getElementById(this._id + "_popupmenu");
                this._isContextMenuPresent = true;
                var leftValue = (e.clientX - this._xpos);
                var topValue = (e.clientY - this._ypos);
                var isInPosition = this._calulateCurrentPosition(topValue, popupNote);
                var width = parseFloat($(popupNote).css("width"));
                var height = parseFloat($(popupNote).css("height"));
                if (leftValue > 0 && (leftValue + width) <= viewer.clientWidth)
                    popupNote.style.left = leftValue + 'px';
                if (isInPosition)
                    popupNote.style.top = (topValue) + 'px';
            }
        },
        _calulateCurrentPosition: function (topVal, popupNote) {
            var cummulativeValue;
            var cummulativePageHeight = 5;
            var height = parseFloat($(popupNote).css("height"));
            for (var i = 1; i <= this._totalPages; i++) {
                var pageBottom = this._pageSize[i - 1].PageHeight * this._zoomVal;
                if (i == this._AnnotationPage) {
                    if (topVal > cummulativePageHeight && (topVal + height) < pageBottom + cummulativePageHeight)
                        cummulativeValue = cummulativePageHeight;
                }
                cummulativePageHeight += pageBottom;
            }
            if (cummulativeValue)
                return true;
        },
        _createPropertiesMenu: function (e) {
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var container = document.createElement("div");
            container.id = this._id + "_containerDialogTab";
            var ejtabContainer = document.createElement("div");
            var ejtab = ej.buildTag("div", "", { "height": "auto" }, { "id": this._id + "_PropertiesDialogTab" });
            var ul = document.createElement("ul");
            ul.innerHTML = "<li id= '" + this._id + "_appearanceli" + "'><a href=" + "#" + this._id + "_apperanceProperties" + ">Appearance</a></li><li id= '" + this._id + "_generalli" + "'><a href=" + "#" + this._id + "_generalProperties" + ">General</a></li>";
            var apperanceProperty = ej.buildTag("div", "", {}, { "id": this._id + "_apperanceProperties" });
            var generalProperty = ej.buildTag("div", "", {}, { "id": this._id + "_generalProperties" });
            ejtabContainer.appendChild(ejtab[0]);
            ejtab[0].appendChild(ul);
            ejtab[0].appendChild(apperanceProperty[0]);
            ejtab[0].appendChild(generalProperty[0]);
            var applyProperties = document.createElement("div");
            applyProperties.style.paddingBottom = "11px";
            var ok = ej.buildTag("button.e-pdfviewer-properties-okbtn", "OK", { "float": "right", "margin-right": "18px" }, { "id": this._id + "_ok", });
            var cancel = ej.buildTag("button.e-pdfviewer-properties-cancelbtn", "Cancel", { "float": "right" }, { "id": this._id + "_cancel", });
            var lockedCheckbox = ej.buildTag("input", "", {}, { 'type': 'checkbox' });
            var lockedContent = document.createElement("label");
            lockedContent.id = this._id + "_lockedprop";
            lockedContent.className = "e-pdfviewer-properties-label";
            lockedContent.style.marginRight = "18px";
            lockedContent.innerHTML = "Locked";
            applyProperties.appendChild(lockedCheckbox[0]);
            applyProperties.appendChild(lockedContent);
            applyProperties.appendChild(cancel[0]);
            applyProperties.appendChild(ok[0]);
            lockedCheckbox.ejCheckBox({ cssClass: 'e-pdfviewer-lockedcheckbox', id: this._id + '_lockedcheckbox', size: ej.CheckboxSize.Small, change: $.proxy(this._lockProperties, this) });
            apperanceProperty[0].style.height = "300px";
            generalProperty[0].style.height = "300px";
            ejtabContainer.appendChild(applyProperties);
            container.appendChild(ejtabContainer);
            pageviewcontainer.append(container);
            ok.ejButton({ showRoundedCorner: true, size: "small" });
            cancel.ejButton({ showRoundedCorner: true, size: "small" });
            $("#" + this._id + "_PropertiesDialogTab").ejTab({});
            var width = this.element.width();
            if (width >= 500)
                $('#' + this._id + "_containerDialogTab").ejDialog({ showOnInit: false, width: "500px", enableResize: false, close: $.proxy(this._closePropertiesWindow, this) });
            else
                $('#' + this._id + "_containerDialogTab").ejDialog({ showOnInit: false, width: "auto", enableResize: false, close: $.proxy(this._closePropertiesWindow, this) });
            var table = document.createElement('div');
            var tableRow1 = document.createElement("div");
            tableRow1.className = "e-pdfviewer-color-container";
            table.appendChild(tableRow1);
            var tableData1 = document.createElement("div");
            tableData1.className = "e-pdfviewer-color-span";
            var tableData2 = document.createElement("div");
            tableData2.className = "e-pdfviewer-color-picker";
            tableRow1.appendChild(tableData1);
            tableRow1.appendChild(tableData2);
            var colorSpan = document.createElement("SPAN");
            colorSpan.id = this._id + "_colorspan";
            colorSpan.innerHTML = "Color:";
            tableData1.appendChild(colorSpan);
            var input = document.createElement("input");
            input.type = "text";
            input.id = this._id + "_colorpicker";
            tableData2.appendChild(input);
            var tableRow2 = document.createElement("div");
            tableRow2.className = "e-pdfviewer-opacity-container";
            table.appendChild(tableRow2);
            var tableData3 = document.createElement("div");
            tableData3.className = "e-pdfviewer-opacity-span";
            var tableData4 = document.createElement("div");
            tableData4.className = "e-pdfviewer-opacity-field";
            tableRow2.appendChild(tableData3);
            tableRow2.appendChild(tableData4);
            var opacity = document.createElement("SPAN");
            opacity.id = this._id + "_opacityspan";
            opacity.innerHTML = "Opacity:";
            tableData3.appendChild(opacity);
            var opacityInput = document.createElement("input");
            opacityInput.type = "text";
            opacityInput.id = this._id + "_opacity";
            opacityInput.className = "e-inputchangeval"
            opacityInput.value = "100%"
            opacityInput.style.width = "50px";
            opacityInput.style.height = "20px";
            tableData4.appendChild(opacityInput);
            var sliderData = document.createElement("div");
            sliderData.className = "e-pdfviewer-slider-control";
            sliderData.style.width = "100px";
            tableRow2.appendChild(sliderData);
            var slider = document.createElement("DIV");
            slider.id = this._id + "_slider";
            sliderData.appendChild(slider);
            apperanceProperty.append(table);
            $("#" + this._id + "_colorpicker").ejColorPicker({ modelType: "palette" });
            $("#" + this._id + "_colorpicker").ejColorPicker("hide");
            this._colorpickerObject = $("#" + this._id + "_colorpicker").data("ejColorPicker");
            $("#" + this._id + "_slider").ejSlider({
                cssClass: 'e-pdfviewer-opacity-slider',
                value: 100,
                minValue: 0,
                maxValue: 100,
                incrementStep: 1,
                showRoundedCorner: true,
                change: this._slidervaluechange,
                slide: this._slidervaluechange,
            });
            var generalTable = document.createElement('div');
            generalTable.style.border = "0px";
            var generalTableRow = document.createElement("div");
            generalTableRow.className = "e-pdfviewer-author-container";
            generalTable.appendChild(generalTableRow);
            var authorData = document.createElement("div");
            authorData.className = "e-pdfviewer-author-span";
            generalTableRow.appendChild(authorData);
            var author = document.createElement("SPAN");
            author.id = this._id + "_authorspan";
            author.innerHTML = "Author:";
            authorData.appendChild(author);
            var authorinput = document.createElement("div");
            authorinput.className = "e-pdfviewer-author-inputdiv";
            generalTableRow.appendChild(authorinput);
            var authorinputValue = document.createElement("input");
            authorinputValue.id = this._id + "_author_input";
            authorinputValue.className = "e-pdfviewer-author-input";
            authorinput.appendChild(authorinputValue);
            var generalTableRow2 = document.createElement("div");
            generalTableRow2.className = "e-pdfviewer-subject-container";
            generalTable.appendChild(generalTableRow2);
            var subjectData = document.createElement("div");
            subjectData.className = "e-pdfviewer-subject-span";
            generalTableRow2.appendChild(subjectData);
            var subject = document.createElement("SPAN");
            subject.id = this._id + "_subjectspan";
            subject.innerHTML = "Subject:";
            subjectData.appendChild(subject);
            var subjectinput = document.createElement("div");
            subjectinput.className = "e-pdfviewer-subject-inputdiv";
            generalTableRow2.appendChild(subjectinput);
            var subjectValue = document.createElement("input");
            subjectValue.id = this._id + "_subject_input";
            subjectValue.className = "e-pdfviewer-subject-input";
            subjectinput.appendChild(subjectValue);
            var generalTableRow3 = document.createElement("div");
            generalTableRow3.className = "e-pdfviewer-modifieddate-container";
            generalTableRow3.style.height = "18.67px";
            generalTable.appendChild(generalTableRow3);
            var modifiedlabeldiv = document.createElement("div");
            modifiedlabeldiv.className = "e-pdfviewer-modified-labeldiv";
            var modifiedlabel = document.createElement("SPAN");
            modifiedlabel.id = this._id + "_modifiedspan";
            modifiedlabel.innerHTML = "Modified:";
            modifiedlabeldiv.appendChild(modifiedlabel);
            generalTableRow3.appendChild(modifiedlabeldiv);
            var datelabeldiv = document.createElement("div");
            datelabeldiv.className = "e-pdfviewer-modifieddate-labeldiv";
            datelabeldiv.id = this._id + "_modifieddate";
            var modifieddatelabel = document.createElement("SPAN");
            modifieddatelabel.innerHTML = "";
            datelabeldiv.appendChild(modifieddatelabel);
            generalTableRow3.appendChild(datelabeldiv);

            generalProperty.append(generalTable);
            $("#" + this._id + "_containerDialogTab_title").addClass("e-pdfviewer-propertiestitle");
            $("#" + this._id + "_containerDialogTab").addClass("e-pdfviewer-propertiestab");
            $("#" + this._id + "_PropertiesDialogTab").addClass("e-pdfviewer-innertab");
            $("#" + this._id + "_apperanceProperties").addClass("e-pdfviewer-appearanceprop");
            $("#" + this._id + "_generalProperties").addClass("e-pdfviewer-generalprop");
            $("#" + this._id + "_appearanceli").addClass("e-pdfviewer-tab-li");
            $("#" + this._id + "_generalli").addClass("e-pdfviewer-tab-li");
            $(opacityInput).addClass("e-pdfviewer-elementalignments");
            $(opacityInput).addClass("ejinputtext");
            $(authorinputValue).addClass("e-pdfviewer-elementalignments");
            $(authorinputValue).addClass("ejinputtext");
            $(subjectValue).addClass("e-pdfviewer-elementalignments");
            $(subjectValue).addClass("ejinputtext");
            this._tabObject = $("#" + this._id + "_PropertiesDialogTab").data("ejTab");
            this._on($('#' + this._id + '_ok'), "click", this._applyAnnotationProperties);
            this._on($('#' + this._id + '_cancel'), "click", this._cancelAnnotationProperties);
        },
        _applyAnnotationProperties: function () {
            var tab = this._tabObject;
            var color = this._colorpickerObject.rgb;
            var opacity = parseInt($("#" + this._id + '_opacity').val().split("%")[0]) / 100;
            var authorName = $("#" + this._id + '_author_input').val();
            var subject = $("#" + this._id + '_subject_input').val();
            var annotDetails = this._getAnnotation(this._currentAnnotationRectangleBackup, this._AnnotationPage);
            this._changeAnnotationProperties(color, opacity, authorName, subject, annotDetails.currentAnnotationIndex, this._AnnotationPage, annotDetails.isExistingAnnotation);
            $('#' + this._id + '_containerDialogTab').ejDialog("close");
        },
        _cancelAnnotationProperties: function () {
            $('#' + this._id + '_containerDialogTab').ejDialog("close");
        },
        _getAnnotation: function (currentAnnotationRect, pageIndex) {
            var annotList = this._textMarkupAnnotationList[pageIndex];
            var currentAnnotations = [];
            var currentAnnotationIndex = null;
            var isExistingAnnotation = false;
            for (var a = 0; a < currentAnnotationRect.length; a++) {
                if (annotList) {
                    for (var i = 0; i < annotList.length; i++) {
                        if (currentAnnotationRect[a] == annotList[i]) {
                            currentAnnotations.push(annotList[i]);
                            currentAnnotationIndex = i;
                            isExistingAnnotation = true;
                        }
                    }
                }
            }
            annotList = this._newAnnotationList[pageIndex - 1];
            var currentAnnot;
            for (var a = 0; a < currentAnnotationRect.length; a++) {
                if (annotList) {
                    for (var j = 0; j < annotList.length; j++) {
                        if (currentAnnotationRect[a] == annotList[j]) {
                            currentAnnotations.push(annotList[j]);
                            currentAnnotationIndex = j;
                            isExistingAnnotation = false;
                            currentAnnot = annotList[j];
                        }
                    }
                }
                if (currentAnnotationRect[a] == currentAnnot)
                    break;
            }
            this._currentAnnotations = currentAnnotations;
            return { currentAnnotationIndex: currentAnnotationIndex, isExistingAnnotation: isExistingAnnotation };
        },
        _changeAnnotationProperties: function (color, opacity, author, subject, currentAnnotationIndex, pageIndex, isExistingAnnotation) {
            var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + pageIndex);
            var context = secCanvas.getContext("2d");
            context.clearRect(0, 0, secCanvas.width, secCanvas.height);
            this._selectedAnnotationObject = null;
            var isColorChanged = false;
            var isOpacityChanged = false;
            var annotationType, annotationId;
            var args = new Object();
            var date = new Date();
            this._drawAnnotSelectRect(pageIndex, this._currentAnnotationRectangleBackup);
            if (isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[pageIndex][currentAnnotationIndex];
                if (annot.Color.R != color.r || annot.Color.G != color.g || annot.Color.B != color.b || annot.Opacity != opacity || annot.Author != author || annot.Subject != subject) {
                    var annotObject = new Object();
                    annotObject = JSON.parse(JSON.stringify(annot));
                    this._colorModifiedAnnotationList[pageIndex - 1].push(annotObject);
                    if (annot.Color.R != color.r || annot.Color.G != color.g || annot.Color.B != color.b) {
                        isColorChanged = true;
                    } else if (annot.Opacity != opacity) {
                        isOpacityChanged = true;
                    }
                    annot.Color.R = color.r;
                    annot.Color.G = color.g;
                    annot.Color.B = color.b;
                    annot.Color.A = color.a;
                    annot.Opacity = opacity;
                    annot.Author = author;
                    annot.Subject = subject;
                    annotationType = annot.TextMarkupAnnotationType;
                    if (annotationType == "Highlight") {
                        annot.ModifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "Underline") {
                        annot.ModifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "StrikeOut") {
                        annot.ModifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    }
                    annotationId = currentAnnotationIndex;
                    this._totalAnnotations[pageIndex][currentAnnotationIndex] = JSON.parse(JSON.stringify(annot));
                    var colorAnnotObj = new Object();
                    colorAnnotObj.index = currentAnnotationIndex;
                    colorAnnotObj.annotation = annot;
                    colorAnnotObj.action = "propertyChanged";
                    this._existingAnnotationsModified[pageIndex - 1].push(colorAnnotObj);
                    var recentOp = {
                        operation: "propertiesModifiedForExistingAnnot",
                        pageNumber: this._AnnotationPage,
                        indexes: currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                }
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                if (checkboxObject.model.checkState == "check") {
                    annot.isLocked = true;
                } else {
                    annot.isLocked = false;
                }
            } else {
                var annot = this._newAnnotationList[pageIndex - 1][currentAnnotationIndex];
                if (annot.colorR != color.r || annot.colorG != color.g || annot.colorB != color.b || annot.opacity != opacity || annot.author != author || annot.subject != subject) {
                    var annotObject = new Object();
                    annotObject = JSON.parse(JSON.stringify(annot));
                    this._colorModifiedAnnotationList[pageIndex - 1].push(annotObject);
                    if (annot.colorR != color.r || annot.colorG != color.g || annot.colorB != color.b) {
                        isColorChanged = true;
                    } else if (annot.opacity != opacity) {
                        isOpacityChanged = true;
                    }
                    annot.colorR = color.r;
                    annot.colorG = color.g;
                    annot.colorB = color.b;
                    annot.opacity = opacity;
                    annot.colorA = annot.opacity * 255;
                    annot.author = author;
                    annot.subject = subject;
                    annotationType = annot.type;
                    if (annotationType == "Highlight") {
                        annot.modifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "Underline") {
                        annot.modifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "StrikeOut") {
                        annot.modifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    }
                    if (this._textMarkupAnnotationList[pageIndex])
                        annotationId = this._textMarkupAnnotationList[pageIndex].length + currentAnnotationIndex;
                    else
                        annotationId = currentAnnotationIndex;
                    this._totalAnnotations[pageIndex][annotationId] = JSON.parse(JSON.stringify(annot));
                    var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                    if (checkboxObject.model.checkState == "check") {
                        annot.isLocked = true;
                    } else {
                        annot.isLocked = false;
                    }
                    var recentOp = {
                        operation: "propertiesModifiedForNewAnnot",
                        pageNumber: this._AnnotationPage,
                        indexes: currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                }
            }
            if (isColorChanged || isOpacityChanged) {
                args.isColorChanged = isColorChanged;
                args.isOpacityChanged = isOpacityChanged;
                args.annotationType = annotationType;
                args.annotationId = annotationId;
                args.pageId = pageIndex;
                this._raiseClientEvent('annotationPropertiesChange', args);
            }
            this._redoActions = new Array();
            for (var i = 0; i < this._totalPages; i++) {
                var newArray = [];
                this._redoAnnotationCollection[i] = newArray;
            }
            this.isDocumentEdited = true;
            this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageIndex], pageIndex);
        },
        _slidervaluechange: function (sender) {
            var values = sender.value;
            var id = this._id.split('_slider')[0];
            $("#" + id + "_opacity").val(values + "%");
        },
        _deleteAnnotation: function () {
            if (this._isAnnotationSelected) {
                var pageAnnotList; var newList = [];
                var args = new Object();
                var annotDetails = this._getAnnotation(this._currentAnnotationRectangleBackup, this._AnnotationPage);
                if (annotDetails.isExistingAnnotation) {
                    pageAnnotList = this._textMarkupAnnotationList[this._AnnotationPage];
                    var annot = pageAnnotList[annotDetails.currentAnnotationIndex];
                    args.annotationType = annot.TextMarkupAnnotationType;
                    this._deletedAnnotationList[this._AnnotationPage - 1].push(annot);
                    var deletedAnnotObj = new Object();
                    deletedAnnotObj.index = annot.Index;
                    args.annotationId = annot.Index;
                    args.pageId = this._AnnotationPage;
                    deletedAnnotObj.annotation = annot;
                    deletedAnnotObj.action = "deleted";
                    this._existingAnnotationsModified[this._AnnotationPage - 1].push(deletedAnnotObj);
                    this._annotationsDeletedNo[this._AnnotationPage - 1] = this._annotationsDeletedNo[this._AnnotationPage - 1] + 1;
                    for (var i = 0; i < pageAnnotList.length; i++) {
                        if (pageAnnotList[i] != annot) {
                            newList.push(pageAnnotList[i]);
                        }
                    }
                    var recentOp = {
                        operation: "existingAnnotationDeleted",
                        pageNumber: this._AnnotationPage,
                        indexes: annotDetails.currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                    this._textMarkupAnnotationList[this._AnnotationPage] = newList;
                    this._totalAnnotations[this._AnnotationPage].splice(annotDetails.currentAnnotationIndex, 1);
                } else {
                    pageAnnotList = this._newAnnotationList[this._AnnotationPage - 1];
                    var annotation = pageAnnotList[annotDetails.currentAnnotationIndex];
                    args.annotationType = annotation.type;
                    this._deletedAnnotationList[this._AnnotationPage - 1].push(annotation);
                    this._newAnnotationList[this._AnnotationPage - 1].splice(annotDetails.currentAnnotationIndex, 1);
                    var index;
                    if (this._textMarkupAnnotationList[this._AnnotationPage])
                        index = this._textMarkupAnnotationList[this._AnnotationPage].length + annotDetails.currentAnnotationIndex;
                    else
                        index = annotDetails.currentAnnotationIndex;
                    args.annotationId = index;
                    args.pageId = this._AnnotationPage;
                    this._totalAnnotations[this._AnnotationPage].splice(index, 1);
                    var recentOp = {
                        operation: "newAnnotationDeleted",
                        pageNumber: this._AnnotationPage,
                        indexes: annotDetails.currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                }
                this._redoActions = new Array();
                for (var i = 0; i < this._totalPages; i++) {
                    var newArray = [];
                    this._redoAnnotationCollection[i] = newArray;
                }
                this._raiseClientEvent("annotationRemove", args);
                this.isDocumentEdited = true;
                this._clearRectOnClick(this._AnnotationPage);
                this._isAnnotationSelected = false;
            }
        },

        _createHighlightContextMenu: function (e) {
            var containerDiv = document.createElement("div");//create a new div
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            containerDiv.id = this._id + "highlight-menu";
            containerDiv.className = "e-pdfviewer-highlight-menu";
            pageviewcontainer.append(containerDiv);
            var orderedList = document.createElement('ol');
            orderedList.className = 'highlightorderedList'
            containerDiv.appendChild(orderedList);
            var searchText = window.getSelection().toString();
            $(orderedList).append("<li class='popupnoteli'><a href='javascript:void(0);' class='popupnote' id = '" + this._id + "_openPopup'>Open Pop-Up Note</a></li>");
            $(orderedList).append("<li class='deleteAnnotationli'><a href='javascript:void(0);' id='" + this._id + "_deleteannot' class='deleteAnnotation'>Delete </a></li>");
            $(orderedList).append("<li class='Propertiesli'><a href='javascript:void(0);' class='Properties' id = '" + this._id + "_propAnnot'>Properties.... </a></li>");
        },

        _setPopupMenuPosition: function (event, element) {
            if (event.type == "touchstart" && element[0].id == this._id + "_popupmenu") {
                event = event.originalEvent.changedTouches[0];
            }
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = element.outerWidth();
            menuDimension.y = element.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            if (element[0].id == this._id + "_popupmenu") {
                var viewer = document.getElementById(this._id + '_viewerContainer');
                if (menuPostion.x + menuDimension.x > viewer.clientWidth) {
                    menuPostion.x = menuPostion.x - menuDimension.x / 4;
                }
            }
            return menuPostion;
        },
        _setHighLightContextMenuPostion: function (event) {
            var contextMenu = $("#" + this._id + "custom-menu");
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            return menuPostion;
        },

        _onViewerKeypress: function (event) {
            if ((event.ctrlKey && event.which == 26) || event.ctrlKey && event.keyCode == 26) {
                if (!this._isPropertiesWindowOpen)
                    this._undo();
            } else if ((event.ctrlKey && event.which == 25) || event.ctrlKey && event.keyCode == 25) {
                if (!this._isPropertiesWindowOpen)
                    this._redo();
            }
        },

        _undo: function () {
            var poppedItem = this._recentOperation.pop();
            if (poppedItem) {
                if (poppedItem.operation == "AddedHighlight" || poppedItem.operation == "AddedUnderline" || poppedItem.operation == "AddedStrikeOut") {
                    for (var i = 0; i < poppedItem.indexes.length; i++) {
                        var poppedAnnotation = this._newAnnotationList[poppedItem.pageNumber - 1].pop();
                        this._redoAnnotationCollection[poppedItem.pageNumber - 1].push(poppedAnnotation);
                    }
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "propertiesModifiedForExistingAnnot" || poppedItem.operation == "propertiesModifiedForNewAnnot") {
                    this._undoModifiedProperty(poppedItem);
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "existingAnnotationDeleted" || poppedItem.operation == "newAnnotationDeleted") {
                    this._undoDeletedItem(poppedItem);
                    this._redoActions.push(poppedItem);
                }
                this._clearRectOnClick(poppedItem.pageNumber);
            }
        },

        _undoModifiedProperty: function (poppedItem) {
            if (poppedItem.operation == "propertiesModifiedForExistingAnnot") {
                var annotation = this._textMarkupAnnotationList[poppedItem.pageNumber][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                this._redoAnnotationCollection[poppedItem.pageNumber - 1].push(annot);
                var originalItem = this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].pop();
                annotation.Color.R = originalItem.Color.R;
                annotation.Color.G = originalItem.Color.G;
                annotation.Color.B = originalItem.Color.B;
                annotation.Opacity = originalItem.Opacity;
                this._existingAnnotationsModified[poppedItem.pageNumber - 1].pop();
            } else {
                var annotation = this._newAnnotationList[poppedItem.pageNumber - 1][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                this._redoAnnotationCollection[poppedItem.pageNumber - 1].push(annot);
                var originalItem = this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].pop();
                annotation.colorR = originalItem.colorR;
                annotation.colorG = originalItem.colorG;
                annotation.colorB = originalItem.colorB;
                annotation.opacity = originalItem.opacity;
                annotation.colorA = originalItem.colorA;
            }
        },

        _undoDeletedItem: function (poppedItem) {
            if (poppedItem.operation == "existingAnnotationDeleted") {
                var annotation = this._deletedAnnotationList[poppedItem.pageNumber - 1].pop();
                this._textMarkupAnnotationList[poppedItem.pageNumber].splice(poppedItem.indexes, 0, annotation);
                this._totalAnnotations[poppedItem.pageNumber].splice(poppedItem.indexes, 0, annotation);
                this._existingAnnotationsModified[poppedItem.pageNumber - 1].pop();
            } else {
                var annotation = this._deletedAnnotationList[poppedItem.pageNumber - 1].pop();
                var newList = this._newAnnotationList[poppedItem.pageNumber - 1].splice(poppedItem.indexes, 0, annotation);
                var index;
                if (this._textMarkupAnnotationList[poppedItem.pageNumber])
                    index = this._textMarkupAnnotationList[poppedItem.pageNumber].length + poppedItem.indexes;
                else
                    index = poppedItem.indexes;
                this._totalAnnotations[poppedItem.pageNumber].splice(index, 0, annotation);
            }
        },

        _redo: function () {
            var poppedItem = this._redoActions.pop();
            if (poppedItem) {
                this._recentOperation.push(poppedItem);
                if (poppedItem.operation == "AddedHighlight" || poppedItem.operation == "AddedUnderline" || poppedItem.operation == "AddedStrikeOut") {
                    for (var i = 0; i < poppedItem.indexes.length; i++) {
                        var poppedAnnotation = this._redoAnnotationCollection[poppedItem.pageNumber - 1].pop();
                        this._newAnnotationList[poppedItem.pageNumber - 1].push(poppedAnnotation);
                    }
                } else if (poppedItem.operation == "propertiesModifiedForExistingAnnot" || poppedItem.operation == "propertiesModifiedForNewAnnot") {
                    this._redoModifiedProperty(poppedItem);
                } else if (poppedItem.operation == "existingAnnotationDeleted" || poppedItem.operation == "newAnnotationDeleted") {
                    this._redoDeletedItem(poppedItem);
                }
                this._clearRectOnClick(poppedItem.pageNumber);
            }
        },

        _redoModifiedProperty: function (poppedItem) {
            if (poppedItem.operation == "propertiesModifiedForExistingAnnot") {
                var annotation = this._textMarkupAnnotationList[poppedItem.pageNumber][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                var originalItem = this._redoAnnotationCollection[poppedItem.pageNumber - 1].pop();
                this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].push(annot);
                annotation.Color.R = originalItem.Color.R;
                annotation.Color.G = originalItem.Color.G;
                annotation.Color.B = originalItem.Color.B;
                annotation.Opacity = originalItem.Opacity;
                var colorAnnotObj = new Object();
                colorAnnotObj.index = poppedItem.indexes;
                colorAnnotObj.annotation = annotation;
                colorAnnotObj.action = "propertyChanged";
                this._existingAnnotationsModified[poppedItem.pageNumber - 1].push(colorAnnotObj);
            } else {
                var annotation = this._newAnnotationList[poppedItem.pageNumber - 1][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                var originalItem = this._redoAnnotationCollection[poppedItem.pageNumber - 1].pop();
                this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].push(annot);
                annotation.colorR = originalItem.colorR;
                annotation.colorG = originalItem.colorG;
                annotation.colorB = originalItem.colorB;
                annotation.opacity = originalItem.opacity;
                annotation.colorA = originalItem.colorA;
            }
        },

        _redoDeletedItem: function (poppedItem) {
            if (poppedItem.operation == "existingAnnotationDeleted") {
                var pageAnnotList = this._textMarkupAnnotationList[poppedItem.pageNumber];
                var annotation = pageAnnotList[poppedItem.indexes];
                this._deletedAnnotationList[poppedItem.pageNumber - 1].push(annotation);
                this._textMarkupAnnotationList[poppedItem.pageNumber].splice(poppedItem.indexes, 1);
                this._totalAnnotations[poppedItem.pageNumber].splice(poppedItem.indexes, 1);
            } else {
                var pageAnnotList = this._newAnnotationList[poppedItem.pageNumber - 1];
                var annotation = pageAnnotList[poppedItem.indexes];
                this._deletedAnnotationList[poppedItem.pageNumber - 1].push(annotation);
                this._newAnnotationList[poppedItem.pageNumber - 1].splice(poppedItem.indexes, 1);
                var index;
                if (this._textMarkupAnnotationList[poppedItem.pageNumber])
                    index = this._textMarkupAnnotationList[poppedItem.pageNumber].length + poppedItem.indexes;
                else
                    index = poppedItem.indexes;
                this._totalAnnotations[poppedItem.pageNumber].splice(index, 1);
            }
        },

        _displayColorPicker: function (type) {
            var colorPicker = document.getElementById(this._id + '_pdfviewer_colorpicker');
            if ($(colorPicker).css('display') == 'none' && !this._isToolbarColorPicker) {
                colorPicker.style.display = 'block';
                this._isToolbarColorPicker = true;
                if (this._colorPickerStatus != type) {
                    this._drawColor = null;
                    if (type == "Highlight")
                        this._toolbarColorpickerObject.option("value", this.model.highlightSettings.color);
                    else if (type == "Underline")
                        this._toolbarColorpickerObject.option("value", this.model.underlineSettings.color);
                    else if (type == "StrikeOut")
                        this._toolbarColorpickerObject.option("value", this.model.strikethroughSettings.color);
                }
                this._colorPickerStatus = type;
                this._isDefaultColorSet = true;
            } else {
                if (this._colorPickerStatus == type) {
                    colorPicker.style.display = 'none';
                    this._isToolbarColorPicker = false;
                } else {
                    if (type == "Highlight")
                        this._toolbarColorpickerObject.option("value", this.model.highlightSettings.color);
                    else if (type == "Underline")
                        this._toolbarColorpickerObject.option("value", this.model.underlineSettings.color);
                    else if (type == "StrikeOut")
                        this._toolbarColorpickerObject.option("value", this.model.strikethroughSettings.color);
                    this._colorPickerStatus = type;
                    this._isDefaultColorSet = true;
                }
            }
        },

        _setPickerPosition: function (liItem) {
            var toolbar = $('#' + this._id + '_toolbarContainer');
            this._toolbarColorpickerObject.refresh();
            var colorPicker = document.getElementById(this._id + '_pdfviewer_colorpicker');
            var pickerPosition = colorPicker.getBoundingClientRect();
            if ($('#' + this._id + '_pdfviewer_textmarkupul').parent()[0] == toolbar[0]) {
                colorPicker.style.top = "0px";
                colorPicker.style.left = (liItem.parentNode.offsetLeft + liItem.offsetLeft - toolbar[0].offsetLeft - pickerPosition.width + liItem.clientWidth) + 'px';
            } else {
                var secondaryToolbar = document.getElementById(this._id + '_toolbarContainer_hiddenlist');
                secondaryToolbarPosition = secondaryToolbar.getBoundingClientRect();
                var btnLiPosition = document.getElementById(this._id + '_pdfviewer_textmarkupul').getBoundingClientRect();
                colorPicker.style.top = secondaryToolbarPosition.bottom - btnLiPosition.bottom + "px";
                colorPicker.style.left = (liItem.parentNode.parentNode.offsetLeft - toolbar[0].offsetLeft + liItem.offsetLeft - pickerPosition.width + liItem.clientWidth) + 'px';
            }
        },

        _showTextMarkupButtons: function (show) {
            if (show) {
                $('#' + this._id + '_pdfviewer_textmarkupul').css("display", "block");
                $('#' + this._id + '_pdfviewer_zoomul').addClass('e-separator');
            }
            else {
                $('#' + this._id + '_pdfviewer_textmarkupul').css("display", "none");
                $('#' + this._id + '_pdfviewer_zoomul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_colorpicker').css("display", "none");
                this._isToolbarColorPicker = false;
            }
        },

        //-------------------------------Text Markup Annotation [end] ---------------------------//
        //-------------------- Toolbar Actions[Start] -------------------------//
        _wireEvents: function () {
            var is_chrome = navigator.userAgent.indexOf('Chrome') != -1;
            var is_firefox = navigator.userAgent.indexOf('Firefox') != -1;
            var is_safari = navigator.userAgent.indexOf("Safari") != -1;
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            var is_edge = navigator.userAgent.indexOf("Edge") != -1;
            var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
            var proxy = this;

            if (!this.model.toolbarSettings.templateId) {
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._allowOnlyNumbers);
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._onkeyPress);
                this._on($('#' + this._id + '_txtpageNo'), "click ", this._onToolbarItemClick);
                this._on($('#' + this._id + '_zoomSelection'), "change", this._zoomValChange);
                this._on($('#' + this._id + '_toolbar_zoomSelection_container'), "click ", this._onToolbarItemClick);
                this._on($('#' + this._id + '_toolbarContainer'), "mousedown", this._onToolBarContainerMouseDown);
                this._on($('.e-pdfviewer-ejdropdownlist'), "mousedown", this._onToolBarContainerMouseDown);
                this._on($('#' + this._id + '_viewerContainer'), "mousewheel", this._onContainerScroll);
                this._on($(window), "keypress", this._onViewerKeypress);
                    if (document.documentMode || is_ie) {
                        this._on($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                        this._on($('#' + this._id + '_viewerContainer'), "dblclick", this._selectingTextOnDblClick);
                        this._on($('#' + this._id + '_viewerContainer'), "click", this._selectingTextOnClick);
                    }
                    else if (!is_edgeNew) {
                        if (is_firefox) {
                            this._on($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                        }
                        else if (is_chrome) {
                            this._on($('#' + this._id + '_viewerContainer'), "touchstart", this._onTextContainerTouch);
                            this._on($('#' + this._id + '_viewerContainer'), "touchmove", this._onTextContainerTouchMove);
                            this._on($('#' + this._id + '_viewerContainer'), "touchend", this._onTextContainerTouchEnd);
                        }
                        this._on($('#' + this._id + '_viewerContainer'), "mousemove", this._onTextContainerMouseMove);
                        this._on($('#' + this._id + '_viewerContainer'), "mousedown", this._onTextContainerMouseDown);
                        this._on($('#' + this._id + '_viewerContainer'), "mouseleave", this._onTextContainerMouseLeave);
                        this._on($('#' + this._id + '_viewerContainer'), "mouseenter", this._onTextContainerMouseEnter);
                        this._on($('#' + this._id + '_viewerContainer'), "mouseover", this._onTextContainerMouseIn);
                        this._on($('#' + this._id + '_viewerContainer'), "dragstart", this._onTextContainerDragStart);
                    }
                    if (is_chrome || is_firefox || is_ie || is_edge || is_edgeNew) {
                        this._on($('#' + this._id + '_viewerContainer'), "mouseup", this._onTextContainerMouseUp);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.copy", this._copySelectedText);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.googleSearch", this._openInNewTab);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.e-highlight-text", this._drawHighlightAnnotation);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.e-strikeout-text", this._drawStrikeOutAnnotation);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.deleteAnnotation", this._deleteAnnotation);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.popupnote", this._showPopupMenu);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.Properties", this._showPropertiesMenu);
                        this._on($('#' + this._id + '_pageviewContainer'), "contextmenu", this._onTextContainerMouseUp);
                        this._on($('#' + this._id + '_viewerContainer'), "click", this._onTextContainerclick);
                    }
                    else if (is_safari)
                        this._on($('#' + this._id + '_viewerContainer'), "mouseup", this._onTextContainerMouseUp);
            }
            $(window).on("keydown", function (e) {
                if (e.ctrlKey && (e.keyCode == 65 || e.keyCode == 97)) {
                    e.preventDefault();
                } else if (e.keyCode == 46) {
                    if (proxy._currentAnnotationRectangleBackup.length != 0 && !proxy._isPropertiesWindowOpen && !proxy._isPopupNoteVisible) {
                        proxy._deleteAnnotation();
                        $("#" + proxy._id + "_popupmenu").hide();
                        proxy._isPopupNoteVisible = false;
                    }
                }
            });
            var viewer = document.getElementById(this._id + '_viewerContainer');
            $('#' + this._id + '_viewerContainer').css({ 'touch-action': 'pan-x pan-y' });
            $('#' + this._id + '_pdfviewerContainer').css({ 'touch-action': 'pan-x pan-y', 'position': 'relative' });
            if (navigator.userAgent.match("Firefox") || navigator.userAgent.match("Chrome")) {
                viewer.addEventListener('touchstart', this._touchStart);
                viewer.addEventListener('touchmove', this._touchMove);
                viewer.addEventListener('touchleave', this._touchEnd);
                viewer.addEventListener('touchend', this._touchEnd);
                viewer.addEventListener('touchcancel', this._touchEnd);
            }
            //Wire search events
            this._on($('#' + this._id + '_pdfviewer_searchinput'), 'input', this._textSearch);
            this._on($('#' + this._id + '_pdfviewer_searchinput'), 'keypress', this._searchKeypressHandler);
            this._on($('#' + this._id + '_pdfviewer_previous_search'), 'click', this._prevSearch);
            this._on($('#' + this._id + '_pdfviewer_next_search'), 'click', this._nextSearch);
            this._on($('#' + this._id + '_pdfviewer_close_search'), "click ", this._displaySearchBox);
            //Wire search events
            this._on($('#' + this._id + '_viewerContainer'), 'pointerdown', this._pointerdown);
            this._on($('#' + this._id + '_viewerContainer'), 'pointermove', this._pointermove);
            this._on($('#' + this._id + '_viewerContainer'), 'pointerup', this._pointerup);
            this._on($('#' + this._id + '_viewerContainer'), 'pointerleave', this._pointerup);
            this._on($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseover", this._showIconToolTip);
            this._on($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseout", this._hideIconToolTip);
        },

        _unwireEvents: function () {
            var is_chrome = navigator.userAgent.indexOf('Chrome') != -1;
            var is_firefox = navigator.userAgent.indexOf('Firefox') != -1;
            var is_safari = navigator.userAgent.indexOf("Safari") != -1;
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            var is_edge = navigator.userAgent.indexOf("Edge") != -1;
            var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
            if (!this.model.toolbarSettings.templateId) {
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._allowOnlyNumbers);
                this._off($('#' + this._id + '_txtpageNo'), "keypress", this._onkeyPress);
                this._off($('#' + this._id + '_txtpageNo'), "click ", this._onToolbarItemClick);
                this._off($('#' + this._id + '_zoomSelection'), "change", this._zoomValChange);
                this._off($('#' + this._id + '_toolbar_zoomSelection_container'), "click ", this._onToolbarItemClick);
                this._off($('#' + this._id + '_viewerContainer'), "mousewheel", this._onContainerScroll);
                this._off($(window), "keypress", this._onViewerKeypress);
            }

            var viewer = document.getElementById(this._id + '_viewerContainer');
            if (document.documentMode || is_edge || is_ie || is_edgeNew) {
                this._off($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                this._off($('#' + this._id + '_viewerContainer'), "dblclick", this._selectingTextOnDblClick);
                this._off($('#' + this._id + '_viewerContainer'), "click", this._selectingTextOnClick);
            }
            else {
                if (is_firefox)
                    this._off($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                this._off($('#' + this._id + '_viewerContainer'), "mousemove", this._onTextContainerMouseMove);
                this._off($('#' + this._id + '_viewerContainer'), "mousedown", this._onTextContainerMouseDown);
                this._off($('#' + this._id + '_viewerContainer'), "mouseleave", this._onTextContainerMouseLeave);
                this._off($('#' + this._id + '_viewerContainer'), "mouseover", this._onTextContainerMouseIn);
                this._off($('#' + this._id + '_viewerContainer'), "touchstart", this._onTextContainerTouch);
                this._off($('#' + this._id + '_viewerContainer'), "touchend", this._onTextContainerTouchEnd);
                this._off($('#' + this._id + '_viewerContainer'), "touchmove", this._onTextContainerTouchMove);
                this._off($('#' + this._id + '_viewerContainer'), "dragstart", this._onTextContainerDragStart);
                this._off($('#' + this._id + '_viewerContainer'), "click", this._onTextContainerclick);
            }
            if (is_chrome || is_firefox || is_ie || is_edgeNew || is_edge) {
                this._off($('#' + this._id + '_viewerContainer'), "mouseup", this._onTextContainerMouseUp);
                this._off($('#' + this._id + '_pageviewContainer'), "click", "a.copy", this._copySelectedText);
                this._off($('#' + this._id + '_pageviewContainer'), "click", "a.googleSearch", this._openInNewTab);
                this._off($('#' + this._id + '_pageviewContainer'), "contextmenu", this._onTextContainerMouseUp);
            }
            if (navigator.userAgent.match("Firefox") || navigator.userAgent.match("Chrome")) {
                viewer.removeEventListener('touchstart', this._touchStart);
                viewer.removeEventListener('touchmove', this._touchMove);
                viewer.removeEventListener('touchleave', this._touchEnd);
                viewer.removeEventListener('touchend', this._touchEnd);
                viewer.removeEventListener('touchcancel', this._touchEnd);
            }
            this._off($('#' + this._id + '_viewerContainer'), 'pointerdown', this._pointerdown);
            this._off($('#' + this._id + '_viewerContainer'), 'pointermove', this._pointermove);
            this._off($('#' + this._id + '_viewerContainer'), 'pointerup', this._pointerup);
            this._off($('#' + this._id + '_viewerContainer'), 'pointerleave', this._pointerup);
            //Unwire search events
            this._off($('#' + this._id + '_pdfviewer_searchinput'), 'input', this._textSearch);
            this._off($('#' + this._id + '_pdfviewer_searchinput'), 'keypress', this._searchKeypressHandler);
            this._off($('#' + this._id + '_pdfviewer_previous_search'), 'click', this._prevSearch);
            this._off($('#' + this._id + '_pdfviewer_next_search'), 'click', this._nextSearch);
            this._off($('#' + this._id + '_pdfviewer_close_search'), "click ", this._displaySearchBox);
            //Unwire search events
            this._off($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseover", this._showIconToolTip);
            this._off($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseout", this._hideIconToolTip);
            this._off($(window), "resize", this._viewerResize);
        },

        _onContainerScroll: function (event) {
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            if (this._isPropertiesWindowOpen) {
                event.preventDefault();
            }
        },

        _closePropertiesWindow: function (event) {
            this._isPropertiesWindowOpen = false;
        },

        _onToolBarContainerMouseDown: function (e) {
            e.preventDefault();
            return false;
        },
        _onToolbarItemClick: function (event) {
            if (event.target.id == this._id + "_txtpageNo") {
                $('#' + this._id + '_txtpageNo').select();
            }
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },
        _selectingTextOnClick: function (e) {
            if (this._timers && this._clientx == e.clientX && this._clienty == e.clientY) {
                clearTimeout(this._timers);
                this._timers = null;
                this._selectingEntireLine(e);
            }
        },
        _selectingEntireLine: function (e) {
            var textNode, range, offset;
            var textIds = [];
            var target = e.target;
            var targetTop = target.getBoundingClientRect();
            var len = $('.e-pdfviewer-textLayer').length;
            if ($(e.target).hasClass('e-pdfviewer-textLayer')) {
                for (var i = 0; i < len; i++) {
                    var rect = $('.e-pdfviewer-textLayer')[i].getBoundingClientRect();
                    var top = parseInt(rect.top);
                    var targetPosition = parseInt(targetTop.top);
                    if (top == targetPosition || (top + 1) == targetPosition || (top - 1) == targetPosition) {
                        var textId = $('.e-pdfviewer-textLayer')[i].id;
                        if (textId != "") {
                            textIds.push(textId);
                        }
                    }
                }
                var selection = window.getSelection();
                selection.removeAllRanges();
                var range = document.createRange();
                var lengths = (textIds.length - 1);
                var d1 = document.getElementById(textIds[0]);
                var d2 = document.getElementById(textIds[lengths]);
                var childNodes = d2.childNodes.length;
                if (childNodes > 0) {
                    var nodes = d2.childNodes[childNodes - 1]
                    range.setStart(d1, 0);
                    range.setEnd(nodes, nodes.length);
                }
                else {
                    range.setStart(d1, 0);
                    range.setEnd(d2, 1);
                }
                selection.addRange(range);
            }
        },
        _selectingTextOnDblClick: function (e) {
            this._clientx = e.clientX;
            this._clienty = e.clientY;
            this._clearAllOccurrences();
            if (this._isAnnotationSelected) {
                this._showPopupMenu(e);
                this._clearSelector(e);
            } else
            this._getElementTouch(e.target, e.clientX, e.clientY);
            this._timers = setTimeout(function () {
                this._timers = null;
            }, 200);
        },
        _onTextContainerMouseIn: function (e) {
            if (this.Clicked) {
                e.preventDefault();
                return false;
            }
        },
        _onTextContainerMouseUp: function (e) {
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            this._isDefaultColorSet = false;
            var annotation, annotationType;
            var target = e.target;
            var popupnoteInnerContent = $("#" + this._id + '_popupinnercontent');
            if (target == popupnoteInnerContent[0]) {
                popupnoteInnerContent.focus();
            } else {
                popupnoteInnerContent.blur();
            }
            this._isPopupNoteFocused = false;
            if (!this._isPropertiesWindowOpen && !(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent")) {
                this._curDown = false;
                var storedSelection = [];
                var target = e.target;
                this._currentAnnotationRectangle = [];
                var customMenu = document.getElementById(this._id + "custom-menu");
                var highlight = document.getElementById(this._id + "highlight-menu");
                if (e.target.className != "popupnoteli" && e.target.className != "deleteAnnotationli" && e.target.className != "Propertiesli" && e.target.className != "e-pdfviewer-highlight-menu")
                $(highlight).hide();
                this._isContextMenuPresent = false;
                var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                if (pageNumber && this.model.enableTextMarkupAnnotations) {
                    for (var i = 1; i <= this._totalPages; i++) {
                        if (this._textMarkupAnnotationList[i] || this._newAnnotationList[i - 1]) {
                            this._clearRectOnClick(i);
                        }
                    }
                    var secanvas = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                    this._onCanvasMousedown(secanvas, e.pageX, e.pageY);
                    this._contextClickPosition(e, pageNumber);
                }
                if (!window.getSelection().toString()) {
                    if (this._currentAnnotationRectangle.length != 0) {
                        annotation = this._currentAnnotationRectangle[0];
                        annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                        if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                            this._AnnotationPage = pageNumber;
                            this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                        } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                            this._AnnotationPage = pageNumber;
                            this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                        } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                            this._AnnotationPage = pageNumber;
                            this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                        }
                    }
                }
                var targetValue, focusNode, anchorNode, focusPage, anchorPage, targetPage;
                var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                var searchText = window.getSelection().toString();
                if (e.type == "contextmenu") {
                    var selection = window.getSelection();
                    if (selection.anchorNode) {
                        var ranges = selection.getRangeAt(0);
                        var cloneRange = ranges.cloneContents();
                        var childNodes = cloneRange.childNodes;
                        var className = ranges.startContainer.parentNode.className;
                        var textHighlight = $(cloneRange).find('span');
                        if (textHighlight.length > 0) {
                            if (textHighlight[0].className == "e-pdfviewer-texthighlight e-pdfviewer-textLayer" || textHighlight[0].className == "e-pdfviewer-text-highlightother e-pdfviewer-textLayer") {
                                if (ranges.startContainer.id)
                                    storedSelection.push(ranges.startContainer.id);
                            }
                        }
                        if (is_ie && $(cloneRange).children().length == 0) {
                            if (className == "e-pdfviewer-textLayer")
                                storedSelection.push(ranges.startContainer.parentElement.id);
                            else
                                storedSelection.push(ranges.startContainer.id);
                        }
                        if (cloneRange.childElementCount == 0) {
                            if (className == "e-pdfviewer-textLayer")
                                storedSelection.push(ranges.startContainer.parentElement.id);
                            else
                                storedSelection.push(ranges.startContainer.id);
                        }
                        else {
                            if (childNodes.length > 0) {
                                if (childNodes[0].className == "e-waitingpopup e-js") {
                                    for (var k = 0; k < childNodes.length; k++) {
                                        var children = $(childNodes[k]).find('.text_container').children();
                                        for (var l = 0; l < children.length; l++)
                                            storedSelection.push(children[l].id);
                                    }
                                }
                                else {
                                    for (var i = 0; i < childNodes.length; i++) {
                                        var element = childNodes[i].id;
                                        storedSelection.push(element);
                                    }
                                }
                            }
                        }
                        for (var j = 0; j < storedSelection.length; j++) {
                            if ($(target).hasClass('e-pdfviewer-text-highlightother') || $(target).hasClass('e-pdfviewer-texthighlight')) {
                                target = target.parentElement;
                            }
                            if (target.id == storedSelection[j]) {
                                this._contextMenu = true;
                                break;
                            }
                            else
                                this._contextMenu = false;
                        }
                    }
                    else
                        this._contextMenu = false;
                }
                if (searchText != "" && e.which == 3 && this._contextMenu && e.type == "contextmenu" && !this._isCopyRestrict) {
                    e.preventDefault();
                    this._searchedText = "";
                    var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                    var copyText = localeObj['contextMenu']['copy']['contentText'];
                    var googleText = localeObj['contextMenu']['googleSearch']['contentText'];
                    var highlightText = localeObj['toolbar']['highlight']['headerText'];
                    var strikeText = localeObj['toolbar']['strikeout']['headerText'];
                    $(customMenu).find('li a.copy').text(copyText);
                    $(customMenu).find('li a.googleSearch').text(googleText);
                    $(customMenu).find('li a.e-highlight-text').text(highlightText);
                    $(customMenu).find('li a.e-strikeout-text').text(strikeText);    
                    if (searchText.length > 20) {
                        var trimmed = searchText.substring(0, 18);
                        var str = trimmed + "...";
                        $(customMenu).find('li a.googleSearch').text(googleText + "'" + str + "'");
                    }
                    else
                        $(customMenu).find('li a.googleSearch').text(googleText + "'" + searchText + "'");
                    var pos = this._setContextMenuPostion(e);
                    if (this.model.enableTextMarkupAnnotations) {
                        if (this.model.enableHighlightAnnotation)
                            $('#' + this._id + "_highlight_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        if (this.model.enableStrikethroughAnnotation)
                            $('#' + this._id + "_strikeout_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    } else {
                        $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    }
                    $(customMenu).show();
                    $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                    $(customMenu).show();
                    $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                    this._contextMenu = false;
                } else if (e.which == 3 && e.type == "contextmenu" && !this._isCopyRestrict
   && ($(e.target).hasClass('e-pdfviewer-text-highlightother e-pdfviewer-textLayer') || $(e.target).hasClass('e-pdfviewer-texthighlight e-pdfviewer-textLayer') || $(e.target).hasClass('e-pdfviewer-texthighlight middle e-pdfviewer-textLayer'))) {
                    e.preventDefault();
                    this._searchedText = "";
                    var childElements = $('.e-pdfviewer-textLayer').find('.e-pdfviewer-texthighlight');
                    if (childElements.length > 1) {
                        childElements = $('.e-pdfviewer-textLayer').find('.e-pdfviewer-texthighlight');
                        for (var m = 0; m < childElements.length; m++) {
                            var texts = childElements[m].innerHTML
                            this._searchedText += texts;
                        }
                    }
                    else
                        this._searchedText = e.target.innerHTML;
                    if (this._searchedText.length > 20) {
                        var trimmed = this._searchedText.substring(0, 18);
                        var str = trimmed + "...";
                        $(customMenu).find('li a.googleSearch').text("Search Google For " + "'" + str + "'");
                    }
                    else
                        $(customMenu).find('li a.googleSearch').text("Search Google For " + "'" + this._searchedText + "'");
                    var pos = this._setContextMenuPostion(e);
                    if (this.model.enableTextMarkupAnnotations) {
                        if (this.model.enableHighlightAnnotation)
                            $('#' + this._id + "_highlight_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        if (this.model.enableStrikethroughAnnotation)
                            $('#' + this._id + "_strikeout_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    } else {
                        $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    }
                    $(customMenu).show();
                    $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                    $(customMenu).show();
                    $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                    this._contextMenu = false;
                }
                else if ($(customMenu).has(e.target).length == 0) {
                    $(customMenu).hide();
                    if (e.type == "contextmenu" && !this._contextMenu)
                        this._clearSelector();
                    else if (this._contextMenu)
                        e.preventDefault();
                    if (e.type == "contextmenu") {
                        if (e.which == 3 &&
                            !this._contextMenu &&
                            e.type == "contextmenu" &&
                            (this._currentAnnotationRectangle.length != 0 || "#000000" != this._annotationColor)) {
                            if (this.model.enableTextMarkupAnnotations) {
                                if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                    this._showAnnotationContextMenu(e, highlight);
                                } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                    this._showAnnotationContextMenu(e, highlight);
                                } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                    this._showAnnotationContextMenu(e, highlight);
                                }
                            }
                            e.preventDefault();
                        } else {
                            $(highlight).hide();
                        }
                    }
                }

                if (this._annotationActive) {
                    if (this._isStrikeout) {
                        this._drawStrikeOutAnnotation();
                    } else if (this._isUnderline) {
                        this._drawUnderlineAnnotation();
                    } else if (this._isHighlight) {
                        this._drawHighlightAnnotation();
                    }
                }
            } else {
                e.preventDefault();
            }
        },
        _replaceTextLocale: function (element, text) {
            element.textContent = text;
        },
        _showAnnotationContextMenu: function (e, highlight) {
            $('#' + this._id + '_popup_note').hide();
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var popupText = localeObj['contextMenu']['openPopup']['contentText'];
            var deleteText = localeObj['contextMenu']['Delete']['contentText'];
            var propertiesText = localeObj['contextMenu']['properties']['contentText'];
            this._replaceTextLocale($("#" + this._id + "_openPopup")[0], popupText);
            this._replaceTextLocale($("#" + this._id + "_deleteannot")[0], deleteText);
            this._replaceTextLocale($("#" + this._id + "_propAnnot")[0], propertiesText);
            var pos = this._setHighLightContextMenuPostion(e);
            this._isContextMenuPresent = true;
            $(highlight).show();
            $(highlight).offset({ top: pos.y, left: pos.x }).show();
            $(highlight).show();
            $(highlight).offset({ top: pos.y, left: pos.x }).show();
        },

        _contextClickPosition: function (event, pageNumber) {
            var pagePosition;
            this._currentAnnotationRectangleBackup = [];
            var currentAnnotations = [];
            var isAnnotationGot = false;
            if (pageNumber) {
                var parent = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                pagePosition = parent.getBoundingClientRect();
            }
            var leftClickPosition = event.clientX - pagePosition.left;
            var topClickPosition = event.clientY - pagePosition.top;
            var annotationList = this._newAnnotationList[pageNumber - 1];
            for (var i = 0; i < annotationList.length; i++) {
                var annotation = annotationList[i];
                for (var k = 0; k < annotation.bounds.length; k++) {
                    var bound = annotation.bounds[k];
                    if (leftClickPosition >= bound.xPosition * this._zoomVal && leftClickPosition <= (bound.xPosition + bound.width) * this._zoomVal && topClickPosition >= bound.yPosition * this._zoomVal && topClickPosition <= (bound.yPosition + bound.height) * this._zoomVal) {
                        this._currentAnnotationRectangle.push(annotationList[i]);
                        this._currentAnnotationRectangleBackup.push(annotationList[i]);
                        isAnnotationGot = true;
                        currentAnnotations.push(annotation);
                    } else {
                        if (isAnnotationGot) {
                            isAnnotationGot = false;
                            break;
                        }
                        if (!this._isPopupNoteVisible) {
                            this._currentAnnotationRectangleBackup = [];
                        }
                        this._currentAnnotationRectangle = [];
                    }
                }
            }
                annotationList = this._textMarkupAnnotationList[pageNumber];
                if (annotationList) {
                    for (var j = 0; j < annotationList.length; j++) {
                        var annotation = annotationList[j];
                        for (var k = 0; k < annotation.Bounds.length; k++) {
                            var bound = annotation.Bounds[k];
                            var xPosition = this._convertPointToPixel(bound.X);
                            var yPosition = this._convertPointToPixel(bound.Y);
                            var width = this._convertPointToPixel(bound.Width);
                            var height = this._convertPointToPixel(bound.Height);
                            if (leftClickPosition >= xPosition * this._zoomVal &&
                                leftClickPosition <= (xPosition + width) * this._zoomVal &&
                                topClickPosition >= yPosition * this._zoomVal &&
                                topClickPosition <= (yPosition + height) * this._zoomVal) {
                                this._currentAnnotationRectangle.push(annotation);
                                this._currentAnnotationRectangleBackup.push(annotation);
                                isAnnotationGot = true;
                                currentAnnotations.push(annotation);
                            } else {
                                if (isAnnotationGot) {
                                    isAnnotationGot = false;
                                    break;
                                }
                                if (!this._isPopupNoteVisible) {
                                    this._currentAnnotationRectangleBackup = [];
                                }
                                this._currentAnnotationRectangle = [];
                            }
                        }
                    }
                }
            if (currentAnnotations.length > 1) {
                currentAnnotations = this._compareAnnotations(currentAnnotations);
            }
            this._currentAnnotationRectangle = currentAnnotations;
            this._currentAnnotationRectangleBackup = currentAnnotations;
        },
        _compareAnnotations: function (currentAnnotations) {
            var prevXposition, currentAnnot;
            for (var i = 0; i < currentAnnotations.length; i++) {
                if (i == currentAnnotations.length - 1) {
                    break;
                }
                var firstAnnotBounds = currentAnnotations[i].bounds ? currentAnnotations[i].bounds : currentAnnotations[i].Bounds;
                var firstXposition = firstAnnotBounds[0].X ? firstAnnotBounds[0].X : firstAnnotBounds[0].xPosition
                var firstYposition = firstAnnotBounds[0].Y ? firstAnnotBounds[0].Y : firstAnnotBounds[0].yPosition;
                var secondAnnotBounds = currentAnnotations[i + 1].bounds ? currentAnnotations[i + 1].bounds : currentAnnotations[i + 1].Bounds;
                var secondXposition = secondAnnotBounds[0].X ? secondAnnotBounds[0].X : secondAnnotBounds[0].xPosition;
                var secondYposition = secondAnnotBounds[0].Y ? secondAnnotBounds[0].Y : secondAnnotBounds[0].yPosition;
                if (firstXposition < secondXposition || firstYposition < secondYposition) {
                    prevXposition = secondXposition;
                    currentAnnot = currentAnnotations[i + 1];
                } else {
                    prevXposition = firstXposition;
                    currentAnnot = currentAnnotations[i];
                }
                if (prevXposition && i == currentAnnotations.length - 2) {
                    if (prevXposition == firstXposition && prevXposition == secondXposition) {
                        prevXposition = secondXposition;
                        currentAnnot = currentAnnotations[i + 1];
                    }
                }
            }
            currentAnnotations = [];
            currentAnnotations.push(currentAnnot);
            return currentAnnotations;
        },
        _setContextMenuPostion: function (event) {
            var contextMenu = $("#" + this._id + "custom-menu");
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            return menuPostion;
        },
        _createWaterDropDiv: function (e) {
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var dropdownX = document.createElement("DIV");
            dropdownX.id = this._id + "droplet1";
            dropdownX.className = "e-pdfviewer-droplet1";
            var dropdownY = document.createElement("DIV");
            dropdownY.id = this._id + "droplet2";
            dropdownY.className = "e-pdfviewer-droplet2";
            pageviewcontainer.append(dropdownX);
            pageviewcontainer.append(dropdownY);
            var vscrolvalue = $('#' + this._id + '_viewerContainer');
            var instance = this;
            $('#' + this._id + 'droplet2').on("touchmove", function (e) {
                if (instance.model.enableTextSelection) {
                    instance._enableSelection();
                    var selectionRange = window.getSelection();
                    var anchorPageId = parseInt(selectionRange.anchorNode.parentNode.id.split("text_")[1]);
                    var focusPageId = parseInt(selectionRange.focusNode.parentNode.id.split("text_")[1]);
                    if (anchorPageId == parseInt(instance._selectionStartPage) && focusPageId == parseInt(instance._selectionStartPage) || !instance._annotationActive) {
                        instance._longTouch = true;
                        var scrollTop = $(vscrolvalue).scrollTop();
                        $('#' + instance._id + 'touchcustom-menu').hide();
                        var touchX, touchY, curX, curY;
                        e.preventDefault();
                        var backwardPos = $('#' + instance._id + 'droplet1').offset();
                        if (e.type == "touchmove") {
                            touchX = e.originalEvent.changedTouches[0].clientX;
                            touchY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 0);
                            curX = e.originalEvent.changedTouches[0].clientX;
                            curY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 1000);
                        }
                        if (curY >= backwardPos.top) {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop + 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop + 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, true);
                        }
                        else {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop - 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop - 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, false);
                        }
                        if ($(parent).hasClass('e-pdfviewer-textLayer')) {
                            var width = $('#' + instance._id + 'droplet2').width();
                            $('#' + instance._id + 'droplet2').offset({ 'top': curY + window.scrollY, 'left': (curX - width) });
                        }
                    }
                }
                else if (!instance.model.enableTextSelection)
                    instance._disableSelection();
            });
            $('#' + this._id + 'droplet1').on("touchmove", function (e) {
                if (instance.model.enableTextSelection) {
                    instance._enableSelection();
                    var selectionRange = window.getSelection();
                    var anchorPageId = parseInt(selectionRange.anchorNode.parentNode.id.split("text_")[1]);
                    var focusPageId = parseInt(selectionRange.focusNode.parentNode.id.split("text_")[1]);
                    if (anchorPageId == parseInt(instance._selectionStartPage) && focusPageId == parseInt(instance._selectionStartPage) || !instance._annotationActive) {
                        var scrollTop = $(vscrolvalue).scrollTop();
                        $('#' + instance._id + 'touchcustom-menu').hide();
                        var touchX, touchY, curX, curY;
                        e.preventDefault();
                        var forwardPos = $('#' + instance._id + 'droplet2').offset();
                        if (e.type == "touchmove") {
                            instance._longTouch = true;
                            touchX = e.originalEvent.changedTouches[0].clientX;
                            touchY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 0);
                            curX = e.originalEvent.changedTouches[0].clientX;
                            curY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 1000);
                        }
                        if (curY <= forwardPos.top) {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop - 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop - 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, false);
                        }
                        else {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop + 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop + 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, true);
                        }
                        $(e.target).css("z-index", 1000);
                        if ($(parent).hasClass('e-pdfviewer-textLayer')) {
                            var width = $('#' + instance._id + 'droplet1').width();
                            $('#' + instance._id + 'droplet1').offset({ 'top': curY + window.scrollY, 'left': (curX - width) });
                        }
                    }
                }
                else if (!instance.model.enableTextSelection)
                    instance._disableSelection();
            });
        },
        _disableSelection:function(){
            if (!this.model.enableTextSelection) {
                $('#' + this._id + '_viewerContainer').attr('unselectable', 'on')
                     .css({
                         '-moz-user-select': 'none',
                         '-o-user-select': 'none',
                         '-khtml-user-select': 'none',
                         '-webkit-user-select': 'none',
                         '-ms-user-select': 'none',
                         'user-select': 'none'
                     }).bind('selectstart', function () { return false; });
            }
        },
        _enableSelection: function () {
            if (this.model.enableTextSelection) {
                $('#' + this._id + '_viewerContainer').removeAttr("unselectable")
                     .css({
                         '-moz-user-select': 'text',
                         '-o-user-select': 'text',
                         '-khtml-user-select': 'text',
                         '-webkit-user-select': 'text',
                         '-ms-user-select': 'text',
                         'user-select': 'text'
                     }).bind('selectstart', function () { return true; });
            }
        },
        _selectingTextByTouch: function (elem, x, y, type) {
            if (elem.nodeType == elem.TEXT_NODE) {
                var range = elem.ownerDocument.createRange();
                var selection = window.getSelection();
                range.selectNodeContents(elem);
                var currentPos = 0;
                var endPos = range.endOffset;
                while (currentPos < endPos) {
                    range.setStart(elem, currentPos);
                    range.setEnd(elem, currentPos + 1);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        var singleWord = range.toString();
                        var rangesPosition = range.getBoundingClientRect();
                        if (selection.anchorNode != null && selection.anchorNode.parentNode.className == "e-pdfviewer-textLayer" && type) {
                            range.setStart(selection.anchorNode, selection.anchorOffset);
                            selection.removeAllRanges();
                            selection.addRange(range);
                            selection.extend(elem, currentPos);
                        }
                        else if (selection.anchorNode != null && !type) {
                            range.setEnd(selection.focusNode, selection.focusOffset);
                            selection.removeAllRanges();
                            selection.addRange(range);
                        }
                        range.detach();
                        return (singleWord);
                    }
                    currentPos += 1;
                }
            } else {
                for (var i = 0; i < elem.childNodes.length; i++) {
                    var range = elem.childNodes[i].ownerDocument.createRange();
                    range.selectNodeContents(elem.childNodes[i]);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        range.detach();
                        return (this._selectingTextByTouch(elem.childNodes[i], x, y, type));
                    } else {
                        range.detach();
                    }
                }
            }
            return (null);
        },
        _onTextContainerTouchMove: function (e) {
            if ($(e.target).hasClass('e-pdfviewer-textLayer') && this._lockTimer) {
                var curX = e.originalEvent.changedTouches[0].clientX;
                var curY = e.originalEvent.changedTouches[0].clientY;
                var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                if (parseInt(curX) != parseInt(this._curPosX) && parseInt(curY) != parseInt(this._curPosY)) {
                    $('.text_container').css("visibility", "hidden");
                    $('.e-pdfviewer-formFields').css("visibility", "visible");
                    $(touchmenu).hide();
                    e.preventDefault();
                }
            }
        },
        _setTouchContextMenu: function (e) {
            var contextMenu = $('#' + this._id + 'touchcustom-menu');
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = e.originalEvent.changedTouches[0].pageX;
            mousePosition.y = e.originalEvent.changedTouches[0].pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x;
            } else {
                menuPostion.x = mousePosition.x - (menuDimension.x / 2);
            }
            if (mousePosition.y) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            }
            return menuPostion;
        },
        _onTextContainerTouch: function (e) {
            var eventTouch = e.originalEvent.touches.length;
            this._curPosX = e.originalEvent.changedTouches[0].clientX;
            this._curPosY = e.originalEvent.changedTouches[0].clientY;
            if (this._lockTimer)
                return;
            var proxy = this;

            this._timer = setTimeout(function () {
                proxy._onlongtouch(e);
            }, 1000);
            this._lockTimer = true;
            if ($(e.target).hasClass('e-pdfviewer-textLayer')) {
                e.preventDefault();
                $('.text_container').css("visibility", "");
                return false;
            }
        },
        _onlongtouch: function (e) {
            if (e.type == "touchstart" && e.target.id != this._id + "droplet2" || e.target.id != this._id + "droplet2" && this.model.enableTextSelection) {
                this._enableSelection();
                this._longTouch = true;
                $('.text_container').css("visibility", "");
                this._curXPos = e.originalEvent.changedTouches[0].clientX;
                this._curYPos = e.originalEvent.changedTouches[0].clientY;
                var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                this._selectionStartPage = pageNumber;
                if (!this._isPropertiesWindowOpen) {
                    if (pageNumber && this.model.enableTextMarkupAnnotations) {
                        this._contextClickPosition(e.originalEvent.changedTouches[0], pageNumber);
                    }
                }
                if (!this._isAnnotationSelected || this._selectedAnnotation != this._currentAnnotationRectangle[0]) {
                    var point = this._getElementTouch(e.target, this._curXPos, this._curYPos, true);
                    if(pageNumber)
                    this._clearRectOnClick(pageNumber);
                }
                e.preventDefault();
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onTextContainerTouchEnd: function (e) {
            e.preventDefault();
            var touchSelection = [];
            var target = e.target;
            var ranges;
            var eventTouch = e.originalEvent.touches.length;
            if (this._timer && this.model.enableTextSelection) {
                this._enableSelection();
            var popupnote = $("a.popupnote");
            var popupnoteInnerContent = $("#" + this._id + '_popupinnercontent');
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            if (target == popupnoteInnerContent[0]) {
                popupnoteInnerContent.focus();
            } else {
                popupnoteInnerContent.blur();
            }
            if (target.id != this._id + "highlight-menu" && target != popupnote[0] && target != popupnoteInnerContent[0]) {
                if (!this._isPropertiesWindowOpen) {
                    var highlight = document.getElementById(this._id + "highlight-menu");
                    $(highlight).hide();
                    this._isContextMenuPresent = false;
                    var annotation, annotationType;
                    var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                    if (pageNumber && this.model.enableTextMarkupAnnotations) {
                        this._contextClickPosition(e.originalEvent.changedTouches[0], pageNumber);
                    }
                    if (this._currentAnnotationRectangleBackup.length != 0 && this._isAnnotationSelected && this._selectedAnnotation == this._currentAnnotationRectangleBackup[0] ) {
                        window.getSelection().removeAllRanges();
                        var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                        $(touchmenu).hide();
                        this._waterDropletDivHide();
                    }
                    if (this._longTouch && this._isAnnotationSelected && this._currentAnnotationRectangleBackup.length != 0 && this._selectedAnnotation == this._currentAnnotationRectangleBackup[0]) {
                        if (this.model.enableTextMarkupAnnotations) {
                            annotation = this._currentAnnotationRectangleBackup[0];
                            annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                            if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                this._showAnnotationContextMenu(e.originalEvent.changedTouches[0], highlight);
                            } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                this._showAnnotationContextMenu(e.originalEvent.changedTouches[0], highlight);
                            } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                this._showAnnotationContextMenu(e.originalEvent.changedTouches[0], highlight);
                            }
                        }
                        this._longTouch = false;
                    }
                    if (!this._isContextMenuPresent) {
                        var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                        if (pageNumber && this.model.enableTextMarkupAnnotations) {
                            this._clearRectOnClick(pageNumber);
                            var secanvas = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                            this._onCanvasMousedown(secanvas, e.originalEvent.changedTouches[0].pageX, e.originalEvent.changedTouches[0].pageY);
                            this._contextClickPosition(e.originalEvent.changedTouches[0], pageNumber);
                        }
                        if (!window.getSelection().toString()) {
                            if (this._currentAnnotationRectangle.length != 0) {
                                annotation = this._currentAnnotationRectangle[0];
                                annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                                if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                    this._AnnotationPage = pageNumber;
                                    this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                                } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                    this._AnnotationPage = pageNumber;
                                    this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                                } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                    this._AnnotationPage = pageNumber;
                                    this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                                }
                            }
                        }
                    }
                }
            }
                clearTimeout(this._timer);
                this._lockTimer = false;
                var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                var curX = e.originalEvent.changedTouches[0].clientX;
                var curY = e.originalEvent.changedTouches[0].clientY;
                var selection = window.getSelection();
                if (selection.anchorNode) {
                    ranges = selection.getRangeAt(0);
                    var cloneRange = ranges.cloneContents();
                    var childNodes = cloneRange.childNodes;
                    var className = ranges.startContainer.parentElement.className;
                    if (cloneRange.childElementCount == 0 && !this._longTouch) {
                        if (className == "e-pdfviewer-textLayer")
                            touchSelection.push(ranges.startContainer.parentElement.id);
                        else
                            touchSelection.push(ranges.startContainer.id);
                    }
                    else {
                        if (childNodes.length > 0) {
                            if (childNodes[0].className == "e-waitingpopup e-js") {
                                for (var k = 0; k < childNodes.length; k++) {
                                    var children = $(childNodes[k]).find('.text_container').children();
                                    for (var l = 0; l < children.length; l++)
                                        touchSelection.push(children[l].id);
                                }
                            }
                            else {
                                for (var i = 0; i < childNodes.length; i++) {
                                    var element = childNodes[i].id;
                                    touchSelection.push(element);
                                }
                            }
                        }
                    }
                    for (var j = 0; j < touchSelection.length; j++) {
                        if (target.id == touchSelection[j]) {
                            this._touchcontextMenu = true;
                            break;
                        }
                        else
                            this._touchcontextMenu = false;
                    }
                }
                else
                    this._touchcontextMenu = false;
                if (this._rangePosition && this._longTouch) {
                    $('.text_container').css("visibility", "");
                    var outerHeight = $(touchmenu).outerHeight();
                    var outerWidth = $(touchmenu).outerWidth();
                    var width = this._rangePosition.width / 2;
                    var searchText = window.getSelection().toString();
                    if (this._ranges || this._touchcontextMenu || e.target.id == this._id + "droplet1" || e.target.id == this._id + "droplet2") {
                        if (e.target.id == this._id + "droplet1" || e.target.id == this._id + "droplet2") {
                            $(touchmenu).show();
                            var context = this._setTouchContextMenu(e);
                            $(touchmenu).show();
                            $(touchmenu).offset({ 'top': context.y, 'left': context.x }).show();

                            if (this._annotationActive) {
                                if (this._isStrikeout) {
                                    this._drawStrikeOutAnnotation();
                                } else if (this._isUnderline) {
                                    this._drawUnderlineAnnotation();
                                } else if (this._isHighlight) {
                                    this._drawHighlightAnnotation();
                                }
                            }
                        }
                        else {
                            if (!this._annotationActive) {
                                $(touchmenu).show();
                                $(touchmenu).offset({ 'top': this._rangePosition.top - outerHeight + window.scrollY, 'left': this._rangePosition.left + width - (outerWidth / 2) });
                            }
                        }
                        this._ranges = false;
                        $('.text_container').css("visibility", "");
                    }
                    else {
                        if ($(e.target).hasClass('copy') || $(e.target).hasClass('googleSearch')) {
                            $(touchmenu).hide();
                        }
                        else {
                            $(touchmenu).hide();
                            this._waterDropletDivHide();
                        }
                    }
                    this._longTouch = false;
                }
                else {
                    $(touchmenu).hide();
                    if (this._annotationActive) {
                        if (this._isStrikeout) {
                            this._drawStrikeOutAnnotation();
                        } else if (this._isUnderline) {
                            this._drawUnderlineAnnotation();
                        } else if (this._isHighlight) {
                            this._drawHighlightAnnotation();
                        }
                    }
                }
                if (!this._annotationActive) {
                    if ($(touchmenu).css('display') == 'none' && e.target.id != this._id + "droplet2"
                        && e.target.id != this._id + "droplet1" && e.target.className != "copy" && e.target.className != "googleSearch"
                                    && $('#' + this._id + 'custom-menu').css('display') == 'none' && !this._touched && !this._touchcontextMenu) {
                        this._clearSelector();
                        this._clearText = true;
                    }
                }
                else if (this._touchcontextMenu) {
                    var selection = window.getSelection();
                    var range = document.createRange();
                    var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                    var backward = false;
                    if (!position && selection.anchorOffset > selection.focusOffset ||
                      position === Node.DOCUMENT_POSITION_PRECEDING)
                        backward = true;
                    if (backward) {
                        range.setStart(selection.focusNode, selection.focusOffset);
                        range.setEnd(selection.anchorNode, selection.anchorOffset);
                    }
                    else {
                        range.setStart(selection.anchorNode, selection.anchorOffset);
                        range.setEnd(selection.focusNode, selection.focusOffset);
                    }
                    var outerHeight = $(touchmenu).outerHeight();
                    var outerWidth = $(touchmenu).outerWidth();
                    var rangesPosition = range.getBoundingClientRect();
                    var boundingClient = range.getClientRects();
                    var length = boundingClient.length - 1;
                    var customMenuWidth = rangesPosition.width / 2;
                    var droplet1 = document.getElementById(this._id + 'droplet1');
                    var droplet2 = document.getElementById(this._id + 'droplet2');
                    var width = $(droplet1).outerWidth();
                    var height = $(droplet1).outerHeight();
                    var searchText = window.getSelection().toString();
                    if (searchText != "") {
                        var context = this._setTouchContextMenu(e);
                        $(droplet1).show();
                        $(droplet1).offset({ "top": boundingClient[0].top + window.scrollY, "left": boundingClient[0].left - width }).show();
                        $(droplet2).show();
                        $(droplet2).offset({ "top": boundingClient[length].top + window.scrollY, "left": boundingClient[length].left + boundingClient[length].width - width }).show();
                        $(touchmenu).show();
                        $(touchmenu).offset({ 'top': context.y, 'left': context.x }).show();
                    }
                    e.preventDefault();
                }
                if (this._clearText) {
                    $(touchmenu).hide();
                    this._waterDropletDivHide();
                    this._clearText = false;
                }
            }
            else if (!this.model.enableTextSelection) {
                var droplet1 = document.getElementById(this._id + 'droplet1');
                var droplet2 = document.getElementById(this._id + 'droplet2');
                $(droplet1).hide();
                $(droplet2).hide();
                this._disableSelection();
            }
        },
        _onTextContainerMouseDown: function (e) {
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection) {
                this._enableSelection();
                $('.text_container').css("visibility", "");
                var target = e.target;
                this._waterDropletDivHide();
                $('#' + this._id + 'touchcustom-menu').hide();
                this._curYPos = e.clientY;
                this._curXPos = e.clientX;
                if ((!$(e.target).hasClass('text_container')) && (!$(e.target).hasClass('e-pdfviewer-viewercontainer')) && e.which != 3) {
                    this._curDown = true;
                    this._removeSearch = true;
                    var splittedText = e.target.id.split('text_')[1];
                    if (splittedText)
                        this._selectedValue = splittedText.split('_')[0];
                    this._selectionStartPage = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("secondarycanvas_")[1]);
                }
                if ($('#' + this._id + 'custom-menu').css('display') == 'none' && e.which != 3 && !$(target).hasClass('e-pdfviewer-secondarycanvas')) {
                    this._clearSelector();
                }
                $('#' + this._id + '_viewerContainer').focus();
                if (!$(target).hasClass('e-pdfviewer-formFields') && !$(target).hasClass('e-pdfviewer-ListBox') && !this._isFormFields && !$(target).hasClass('e-dropdownSelect'))
                    e.preventDefault();
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onTextContainerclick: function (e) {
            this._waterDropletDivHide();
            var target = e.target;
            if (e.originalEvent.detail == 2 && $(target).hasClass('e-pdfviewer-textLayer') &&  this.model.enableTextSelection) {
                e.preventDefault();
                this._clearAllOccurrences();
                this._enableSelection();
                this._getElementTouch(target, e.clientX, e.clientY, false);
                if (this._annotationActive && !this._isAnnotationSelected) {
                    if (this._isStrikeout) {
                        this._drawStrikeOutAnnotation();
                    } else if (this._isUnderline) {
                        this._drawUnderlineAnnotation();
                    } else if (this._isHighlight) {
                        this._drawHighlightAnnotation();
                    }
                }
                if (this._isAnnotationSelected) {
                    this._showPopupMenu(e);
                    this._clearSelector(e);
                }
                e.preventDefault();
            }
            if (e.originalEvent.detail == 3 && $(target).hasClass('e-pdfviewer-textLayer') && this.model.enableTextSelection) {
                this._enableSelection();
                if (!this._annotationActive)
                    this._selectingEntireLine(e);
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onTextContainerMouseMove: function (e) {
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection) {
                e.preventDefault();
                this._enableSelection();
                this._currentAnnotationRectangle = [];
                var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("secondarycanvas_")[1]);
                if (pageNumber && !this._isPropertiesWindowOpen) {
                    var secanvas = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                    this._onCanvasMousedown(secanvas, e.pageX, e.pageY);
                    if (this.model.enableTextMarkupAnnotations) {
                        if (!this._isPopupNoteVisible && !this._isContextMenuPresent) {
                            this._contextClickPosition(e, pageNumber);
                            if (this._currentAnnotationRectangle.length != 0) {
                                var annotation = this._currentAnnotationRectangle[0];
                                var annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                                if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                    this._showPopupNote(e);
                                    e.target.style.cursor = "pointer";
                                } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                    this._showPopupNote(e);
                                    e.target.style.cursor = "pointer";
                                } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                    this._showPopupNote(e);
                                    e.target.style.cursor = "pointer";
                                } 
                            } else {
                                $('#' + this._id + '_popup_note').css({ 'display': 'none' });
                                e.target.style.cursor = "auto";
                            }
                        }
                    }
                }
                $('.text_container').css("visibility", "");
                var curY, curX;
                var target = e.target;
                var splittedText = e.target.id.split('text_')[1];
                if (splittedText) {
                    var currentIndex = splittedText.split('_')[0];
                    if (currentIndex == this._selectedValue) {
                        this._isTextSelection = true;
                    }
                    else {
                        this._isTextSelection = false;
                    }
                }
                if (window.getSelection().toString()) {
                    if (this._selectionPages.indexOf(pageNumber) == -1 && pageNumber && pageNumber != 0) {
                        this._selectionPages.push(pageNumber);
                    }
                } else {
                    this._selectionPages = new Array();
                }
                this.pageY = e.pageY;
                if (this._curDown == true && ($('#' + this._id + 'custom-menu').css('display') == 'none')) {
                    if (this._removeSearch) {
                        this._clearAllOccurrences();
                        this._removeSearch = false;
                    }
                    curY = e.clientY;
                    curX = e.clientX;
                    if (this._currentAnnotationRectangle.length == 0 || (this._annotationActive && this._isTextSelection)) {
                        var point = this._getWordAtPoint(target, curX, curY);
                    }
                    e.preventDefault();
                }
            }
        },
        _onTextContainerMouseLeave: function (e) {
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection) {
                this._enableSelection();
                if (this._curDown == true) {
                    var instance = this;
                    var value;
                    e.preventDefault();
                    var vscrolvalue = $('#' + this._id + '_viewerContainer');
                    var documentHeight = $(vscrolvalue).offset().top;
                    if (e.clientY > documentHeight) {
                        this._scrollMove = setInterval(function () {
                            $(vscrolvalue).animate({ scrollTop: $(vscrolvalue).scrollTop() + (200) }, 'fast');
                        }, 500);
                    }
                    else {
                        this._scrollMove = setInterval(function () {
                            $(vscrolvalue).animate({ scrollTop: $(vscrolvalue).scrollTop() - (200) }, 'fast');
                        }, 500);
                    }
                    $(window).on('mouseup', function (e) {
                        this._curDown = false;
                        instance._onMouseClickedOutside(e);
                        e.preventDefault();
                        e.stopPropagation();
                        return false;
                    });
                }
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onTextContainerMouseEnter: function (e) {
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection) {
                this._enableSelection();
                if (this._scrollMove)
                    clearInterval(this._scrollMove);
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onMouseClickedOutside: function (e) {
            this._curDown = false;
            if (this._scrollMove)
                clearInterval(this._scrollMove);
            e.preventDefault();
            e.stopPropagation();
        },
        _onTextContainerDragStart: function (e) {
            e.preventDefault();// cancel the native drag event chain
        },
        _clearSelector: function (e) {
            if (window.getSelection) {
                if (window.getSelection().removeAllRanges) {  // Firefox
                    window.getSelection().removeAllRanges();
                }
                else if (document.selection) {  // IE?
                    document.selection.empty();
                }
            }
        },
        _createContextMenu: function (e) {
            var containerDiv = document.createElement("div");//create a new div
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            containerDiv.id = this._id + "custom-menu";
            containerDiv.className = "e-pdfviewer-custom-menu";
            pageviewcontainer.append(containerDiv);
            var orderedList = document.createElement('ol');
            orderedList.className = 'orderedList'
            containerDiv.appendChild(orderedList);
            var searchText = window.getSelection().toString();
            $(orderedList).append("<li><a href='javascript:void(0);' class='copy'>Copy</a></li>");
            $(orderedList).append("<li><a href='javascript:void(0);' class='googleSearch'>Search Google For </a></li>");
            $(orderedList).append("<li><a href='javascript:void(0);' id = '" + this._id + "_highlight_contextmenu' class='e-highlight-text'>Highlight Text </a></li>");
            $(orderedList).append("<li><a href='javascript:void(0);' id = '" + this._id + "_strikeout_contextmenu' class='e-strikeout-text'>Strikethrough Text </a></li>");
        },
        _createTouchContextMenu: function (e) {
            var containerDiv = document.createElement("div");//create a new div
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            containerDiv.id = this._id + "touchcustom-menu";
            containerDiv.className = "e-pdfviewer-touchcustom-menu";
            pageviewcontainer.append(containerDiv);
            var searchText = window.getSelection().toString();
            $(containerDiv).append("<div class='e-pdfviewer-touchCopy'><a href='javascript:void(0);' class='copy'>Copy</a></div>");
            $(containerDiv).append("<div class='e-pdfviewer-touchDot'><a href='javascript:void(0);' class='googleSearch'>Search</a></div>");
        },
        _onTextKeyboardCopy: function (e) {
            if (e.ctrlKey && e.keyCode == 67) {
                e.preventDefault();
                if (!this._isCopyRestrict)
                    this._copySelectedText(e);
            }
        },
        _copySelectedText: function (e) {
            if (!this._isCopyRestrict && this._searchedText && this._searchedText.length > 0 && this._searchedText != "" && this.model.enableTextSelection) {
                this._enableSelection();
                if (window.clipboardData && window.clipboardData.setData) {
                    var data = clipboardData.setData("Text", this._searchedText);
                    if ($('#' + this._id + 'custom-menu'))
                        $('#' + this._id + 'custom-menu').hide();
                    return data;
                } else {
                    var textarea = document.createElement("textarea");
                    $(textarea).css("contenteditable", "true");
                    textarea.textContent = this._searchedText
                    textarea.style.position = "fixed";  // Prevent scrolling to bottom of page in MS Edge.
                    document.body.appendChild(textarea);
                    textarea.select();
                }
                try {
                    return document.execCommand("copy");
                } catch (ex) {
                    console.warn("Copy to clipboard failed.", ex);
                } finally {
                    if (textarea)
                        document.body.removeChild(textarea);
                    $('#' + this._id + 'custom-menu').hide();
                }

                e.preventDefault();
            }
            else {
                if (!this._isCopyRestrict && this.model.enableTextSelection) {
                    this._enableSelection();
                    var searchText = window.getSelection().getRangeAt(0).toString();
                    var is_firefox = navigator.userAgent.indexOf('Firefox') > -1;
                    if (window.clipboardData && window.clipboardData.setData) {
                        var data = clipboardData.setData("Text", searchText);
                        if ($('#' + this._id + 'custom-menu'))
                            $('#' + this._id + 'custom-menu').hide();
                        return data;

                    } else if (document.queryCommandSupported && document.queryCommandSupported("copy")) {
                        var selection = window.getSelection();
                        var range = document.createRange();
                        var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                        var backward = false;
                        if (!position && selection.anchorOffset > selection.focusOffset ||
                          position === Node.DOCUMENT_POSITION_PRECEDING)
                            backward = true;
                        if (backward) {
                            range.setStart(selection.focusNode, selection.focusOffset);
                            range.setEnd(selection.anchorNode, selection.anchorOffset);
                        }
                        else {
                            range.setStart(selection.anchorNode, selection.anchorOffset);
                            range.setEnd(selection.focusNode, selection.focusOffset);
                        }
                        var textarea = document.createElement("textarea");
                        $(textarea).css("contenteditable", "true");
                        textarea.textContent = searchText;
                        textarea.style.position = "fixed";  // Prevent scrolling to bottom of page in MS Edge.
                        document.body.appendChild(textarea);
                        textarea.select();
                        selection.removeAllRanges();
                        selection.addRange(range);
                    }
                    try {
                        return document.execCommand("copy");
                    } catch (ex) {
                        console.warn("Copy to clipboard failed.", ex);
                    } finally {
                        document.body.removeChild(textarea);
                        $('#' + this._id + 'custom-menu').hide();
                    }

                    e.preventDefault();
                }
            }
        },
        _openInNewTab: function () {
            var searchText;
            if (this._searchedText && this._searchedText.length > 0 && this._searchedText != "")
                searchText = this._searchedText;
            else
                var searchText = window.getSelection().toString();
            var url = "http://www.google.com/search?q=" + searchText;
            var win = window.open(url, '_blank');
            win.focus();
            $('#' + this._id + 'custom-menu').hide();
        },
        _waterDropletDivHide: function (e) {
            $(document.getElementById(this._id + 'droplet1')).hide();
            $(document.getElementById(this._id + 'droplet2')).hide();
        },
        _getWordAtPoint: function (elem, x, y) {
            if (!this._isPopupNoteFocused) {
                if (elem.nodeType == elem.TEXT_NODE) {
                    var backward = false;
                    this._isBackwardSelection = false;
                    var range = elem.ownerDocument.createRange();
                    var selection = window.getSelection();
                    if (selection.anchorNode != null) {
                        var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                        if (!position && selection.anchorOffset > selection.focusOffset ||
                              position === Node.DOCUMENT_POSITION_PRECEDING) {
                            backward = true;
                            this._isBackwardSelection = true;
                        }
                    }
                    range.selectNodeContents(elem);
                    var currentPos = 0;
                    var endPos = range.endOffset;
                    while (currentPos < endPos) {
                        range.setStart(elem, currentPos);
                        range.setEnd(elem, currentPos + 1);
                        if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                           range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                            var singleWord = range.toString();
                            if (selection.anchorNode != null && selection.anchorNode.parentNode.className == "e-pdfviewer-textLayer")
                                range.setStart(selection.anchorNode, selection.anchorOffset);
                            selection.removeAllRanges();
                            selection.addRange(range);
                            if (backward)
                                selection.extend(elem, currentPos);
                            else
                                selection.extend(elem, currentPos + 1);
                            range.detach();
                            this._isTextSelection = true;
                            return (singleWord);
                        }
                        currentPos += 1;
                    }
                } else {
                    for (var i = 0; i < elem.childNodes.length; i++) {
                        var range = elem.childNodes[i].ownerDocument.createRange();
                        range.selectNodeContents(elem.childNodes[i]);
                        if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                           range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                            range.detach();
                            this._isTextSelection = true;
                            return (this._getWordAtPoint(elem.childNodes[i], x, y));
                        } else {
                            range.detach();
                        }
                    }
                }
                this._isTextSelection = false;
                return (null);
            }
        },
        _getElementTouch: function (elem, x, y, type) {
            if (elem.nodeType == elem.TEXT_NODE) {
                var selection = window.getSelection();
                var range = elem.ownerDocument.createRange();
                range.selectNodeContents(elem);
                var currentPos = 0;
                var endPos = range.endOffset;
                while (currentPos < endPos) {
                    range.setStart(elem, currentPos);
                    range.setEnd(elem, currentPos + 1);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        var singleWord = range.toString();
                        var textContent = elem.textContent;
                        var indices = [];
                        var startPos, endPos;
                        for (var i = 0; i < textContent.length; i++) {
                            if (textContent[i] == " ") indices.push(i);
                        }
                        for (var j = 0; j < indices.length; j++) {
                            if (currentPos == indices[j]) {
                                startPos = indices[j];
                                endPos = indices[j];
                            }
                            if (indices[0] > currentPos) {
                                startPos = 0;
                                endPos = indices[j];
                                break;
                            }
                            if (currentPos > indices[j] && currentPos < indices[j + 1]) {
                                startPos = indices[j];
                                endPos = indices[j + 1];
                            }
                            else if (currentPos > indices[j]) {
                                if (!indices[j + 1])
                                    startPos = indices[j];
                            }
                        }
                        this.startelem = startPos;
                        this.endelem = endPos;
                        if (startPos == 0)
                            range.setStart(elem, startPos);
                        else
                            range.setStart(elem, startPos + 1);
                        range.setEnd(elem, endPos);
                        selection.removeAllRanges();
                        selection.addRange(range);
                        if (type) {
                            var rangesPosition = range.getBoundingClientRect();
                            this._rangePosition = rangesPosition;
                            this._ranges = true;
                            this._selectedRanges = range;
                            var droplet1 = document.getElementById(this._id + 'droplet1');
                            var droplet2 = document.getElementById(this._id + 'droplet2');
                            var width = $(droplet1).width();
                            var height = $(droplet1).height();
                            $(droplet1).show();
                            $(droplet1).offset({ "top": rangesPosition.top + window.scrollY + (height / 2), "left": rangesPosition.left - width }).show();
                            $(droplet2).show();
                            $(droplet2).offset({ "top": rangesPosition.top + window.scrollY + (height / 2), "left": rangesPosition.left + rangesPosition.width - width }).show();
                        }
                        range.detach();
                        return (singleWord);
                    }
                    currentPos += 1;
                }
            } else {
                for (var i = 0; i < elem.childNodes.length; i++) {
                    var range = elem.childNodes[i].ownerDocument.createRange();
                    range.selectNodeContents(elem.childNodes[i]);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        range.detach();
                        return (this._getElementTouch(elem.childNodes[i], x, y, type));
                    } else {
                        range.detach();
                    }
                }
            }
            return (null);
        },

        _toolbarClick: function (event) {
            var targetItem = event.target
            var clickedItem = event.target;
            if (this._isToolbarClick) {
                $('#' + this._id + '_rptTooltip').css('display', 'none');
                if (!($(clickedItem).hasClass("e-pdfviewer-highlight-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-strikeout-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-underline-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-highlight") || $(clickedItem).hasClass("e-pdfviewer-toolbar-underline") || $(clickedItem).hasClass("e-pdfviewer-toolbar-strikeout") || $(clickedItem).hasClass("e-pdfviewer-dropdown-wrapper") || $(clickedItem).hasClass("e-pdfviewer-dropdown-arrow"))) {
                    this._selectionNodes = window.getSelection();
                    this._maintainSelection();
                    document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                    this._isToolbarColorPicker = false;
                }
                if ($(clickedItem).hasClass("e-pdfviewer-highlight-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-strikeout-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-underline-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-highlight") || $(clickedItem).hasClass("e-pdfviewer-toolbar-underline") || $(clickedItem).hasClass("e-pdfviewer-toolbar-strikeout")) {
                    document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                    this._isToolbarColorPicker = false;
                }
                this._displaySearch = false;
                this._isDefaultColorSet = false;
                if ($(clickedItem).hasClass('e-pdfviewer-toolbarli')) {
                    clickedItem = $(clickedItem).find('span');
                }
                if ($(clickedItem).hasClass("e-pdfviewer-print")) {
                    if (!this._isPrintRestrict)
                        this._print();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-download")) {
                    this._isAsynchronousDownload = true;
                    this._saveFormFieldsValue();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotofirst") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoFirstPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotolast") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoLastPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotonext") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoNextPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotoprevious") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoPreviousPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-zoomin")) {
                    this._applyLowerZoomIndex();
                    this._zoomIn();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-zoomout")) {
                    this._applyHigherZoomIndex();
                    this._zoomOut();
                }
                    /*  * The event handler for the click event of the fiWidth and fitPage operations are given below. 
                        * The handler is chosen based on the id name of the target element. 
                    */
                else if ($(clickedItem).hasClass("e-pdfviewer-fitpage") || $(clickedItem).hasClass("e-pdfviewer-fitwidth")) {
                    var clickedSpan = clickedItem;
                    var spanId = $(clickedSpan).attr('id');
                    switch (spanId) {
                        case this._id + "_fitWidth":
                            this._applyFitToWidth();
                            break;
                        case this._id + "_fitPage":
                            this._applyFitToPage();
                            break;
                    }
                }
                else if ($(clickedItem).hasClass('e-pdfviewer-find')) {
                    this._displaySearchBox();
				} else if ($(clickedItem).hasClass("e-pdfviewer-highlight-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-highlight")) {
				    if (this.model.enableTextMarkupAnnotations && this.model.enableHighlightAnnotation) {
				        this._drawColor = null;
				        this._toolbarColorpickerObject.option("value", this.model.highlightSettings.color);
				        this._isDefaultColorSet = true;
				        this._initHighlight();
				    }
				} else if ($(clickedItem).hasClass("e-pdfviewer-underline-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-underline")) {
				    if (this.model.enableTextMarkupAnnotations && this.model.enableUnderlineAnnotation) {
				        this._drawColor = null;
				        this._toolbarColorpickerObject.option("value", this.model.underlineSettings.color);
				        this._isDefaultColorSet = true;
				        this._initUnderline();
				    }
				} else if ($(clickedItem).hasClass("e-pdfviewer-strikeout-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-strikeout")) {
				    if (this.model.enableTextMarkupAnnotations && this.model.enableStrikethroughAnnotation) {
				        this._drawColor = null;
				        this._toolbarColorpickerObject.option("value", this.model.strikethroughSettings.color);
				        this._isDefaultColorSet = true;
				        this._initStrikeOut();
				    }
				} else if ($(clickedItem).hasClass("e-pdfviewer-dropdown-wrapper") || $(clickedItem).hasClass("e-pdfviewer-dropdown-arrow")) {
				    var liItem = $(clickedItem).parents('.e-pdfviewer-toolbarli');
				    if (liItem.hasClass('e-pdfviewer-toolbar-underline')) {
				        if (this.model.enableTextMarkupAnnotations && this.model.enableUnderlineAnnotation) {
				            this._displayColorPicker('Underline');
				            this._setPickerPosition(liItem[0]);
				            this._isUnderlineEnabled = false;
				            this._initUnderline();
				        }
				    } else if (liItem.hasClass('e-pdfviewer-toolbar-highlight')) {
				        if (this.model.enableTextMarkupAnnotations && this.model.enableHighlightAnnotation) {
				            this._displayColorPicker('Highlight');
				            this._setPickerPosition(liItem[0]);
				            this._isHighlightEnabled = false;
				            this._initHighlight();
				        }
				    } else if (liItem.hasClass('e-pdfviewer-toolbar-strikeout')) {
				        if (this.model.enableTextMarkupAnnotations && this.model.enableStrikethroughAnnotation) {
				            this._displayColorPicker('StrikeOut');
				            this._setPickerPosition(liItem[0]);
				            this._isStrikeOutEnabled = false;
				            this._initStrikeOut();
				        }
				    }
				}
            }
        },

        _save: function (data) {
            var filename;
            if (this.fileName.indexOf('\\') == -1) {
                filename = this.fileName;
            } else
                filename = this.fileName.replace(/^.*[\\\/]/, '')
            var browserUserAgent = navigator.userAgent;
            var url = '';
            var blob = this._base64toBlob(data["documentStream"], 'application/pdf', 512);
            if (browserUserAgent.indexOf('Edge') == -1) {
                if ((browserUserAgent.indexOf("Firefox")) != -1 || (browserUserAgent.indexOf("Chrome")) != -1 || (browserUserAgent.indexOf("Safari")) != -1 || (browserUserAgent.indexOf("AppleWebKit")) != -1) {
                    this._download(blob, url, filename);
                }
                else
                    window.navigator.msSaveOrOpenBlob(blob, filename);
            }
            else
                window.navigator.msSaveOrOpenBlob(blob, filename);
        },
        _base64toBlob: function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        },
        _createBlob: function (data, contentType) {
            if (typeof Blob !== 'undefined') {
                return new Blob([data], { type: contentType });
            }
            warn('The "Blob" constructor is not supported.');
        },

        _download: function (blob, url, filename) {
            var blobUrl = URL.createObjectURL(blob);
            var a = document.createElement('a');
            if (a.click) {
                a.href = blobUrl;
                a.target = '_parent';
                if ('download' in a) {
                    a.download = filename;
                }
                (document.body || document.documentElement).appendChild(a);
                a.click();
                a.parentNode.removeChild(a);
            } else {
                if (window.top === window &&
                    blobUrl.split('#')[0] === window.location.href.split('#')[0]) {
                    var padCharacter = blobUrl.indexOf('?') === -1 ? '?' : '&';
                    blobUrl = blobUrl.replace(/#|$/, padCharacter + '$&');
                }
                window.open(blobUrl, '_parent');
            }
        },

        _showToolbar: function (showToolbar) {
            if (showToolbar) {
                $('#' + this._id + '_toolbarContainer').css("display", "block");
                this._setSearchToolbarTop();
                this._isToolbarHidden = false;
            }
            else {
                $('#' + this._id + '_toolbarContainer').css("display", "none");
                if (this._isFindboxPresent) {
                    this._displaySearchBox();
                }
                this._isToolbarHidden = true;
            }
        },

        _initToolbar: function () {
            this._isToolbarClick = false;

            if (!this.model.toolbarSettings.templateId) {
                if (!this._isDevice) {
                    var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                    zoomddl._selectItemByIndex(0);
                    zoomddl.disable();

                    $('#' + this._id + '_txtpageNo').attr('disabled', 'disabled');

                    this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                    this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                    this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                    this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
                }
            }
        },

        _enableToolbarItems: function () {
            this._isToolbarClick = true;
            if (!this.model.toolbarSettings.templateId) {
                if (!this._isDevice) {
                    $('#' + this._id + '_txtpageNo').removeAttr('disabled');
                    $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList').enable();
                }
            }
        },
        //-------------------- Toolbar Actions[End] -------------------------//

        //-------------------- Tooltip Localization Actions[Start]------------------------//
        _showIconToolTip: function (event) {
            if ($('#' + this._id + '_rptTooltip').css('display') == 'none') {
                this._showTooltipContent(event);
            }
        },

        _hideIconToolTip: function () {
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },

        _viewpopupBlockNone: function (jqueryEement) {
            if (jqueryEement.css('display') == 'block') {
                return false;
            } else {
                return true;
            }
        },

        _showTooltipContent: function (event) {
            var currentToolbarItem = event.target;
            if (this.model.toolbarSettings.showTooltip && !this._isDevice) {
                var TagPos;
                var toolTipText;
                var isShowTooltip = true;
                if ($(currentToolbarItem).hasClass('e-pdfviewer-toolbarli')) {
                    currentToolbarItem = $(currentToolbarItem).find('span');
                }
                var disabledItem = $(currentToolbarItem).prev();
                if ($(currentToolbarItem).hasClass("e-pdfviewer-print")) {
                    var printId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-print')[0];
                    if (printId)
                        TagPos = printId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-print')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('print');
                }
                if ($(currentToolbarItem).hasClass("e-pdfviewer-download")) {
                    var printId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-download')[0];
                    if (printId)
                        TagPos = printId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-download')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('download');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotofirst")) || ($(disabledItem).hasClass('e-pdfviewer-gotofirst'))) {
                    var gotoFirstId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotofirst')[0];
                    if (gotoFirstId)
                        TagPos = gotoFirstId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotofirst')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('first');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotolast")) || ($(disabledItem).hasClass('e-pdfviewer-gotolast'))) {
                    var gotoLastId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotolast')[0];
                    if (gotoLastId)
                        TagPos = gotoLastId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotolast')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('last');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotonext")) || ($(disabledItem).hasClass('e-pdfviewer-gotonext'))) {
                    var gotoNextId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotonext')[0];
                    if (gotoNextId)
                        TagPos = gotoNextId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotonext')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('next');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotoprevious")) || ($(disabledItem).hasClass('e-pdfviewer-gotoprevious'))) {
                    var gotoPreviousId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotoprevious')[0];
                    if (gotoPreviousId)
                        TagPos = gotoPreviousId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotoprevious')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('previous');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-zoomin")) || ($(disabledItem).hasClass('e-pdfviewer-zoomin'))) {
                    var zoomInId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-zoomin')[0];
                    if (zoomInId)
                        TagPos = zoomInId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-zoomin')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoomin');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-zoomout")) || ($(disabledItem).hasClass('e-pdfviewer-zoomout'))) {
                    var zoomOutId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-zoomout')[0];
                    if (zoomOutId)
                        TagPos = zoomOutId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-zoomout')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoomout');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-tbpage") || $(currentToolbarItem).hasClass("e-pdfviewer-pagenumber") || $(currentToolbarItem).hasClass("e-pdfviewer-labelpageno")) {
                    var pageNumberId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage')[0];
                    if (pageNumberId)
                        TagPos = pageNumberId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-tbpage')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('pageIndex');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-ejdropdownlist") || $(currentToolbarItem).hasClass("e-dropdownlist") || $(currentToolbarItem).hasClass("e-select") || $(currentToolbarItem).hasClass("e-down-arrow")) {
                    var zoomDropdownId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist')[0];
                    if (zoomDropdownId)
                        TagPos = zoomDropdownId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-ejdropdownlist')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoom');
                    isShowTooltip = this._viewpopupBlockNone($('#' + this._id + '_toolbar_zoomSelection_popup_list_wrapper'));
                }
                    //The below code is used to render the tooltip for fitWidth and fitPage buttons based on the id name of the target element
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-fitwidth") || $(currentToolbarItem).hasClass("e-pdfviewer-fitpage") || ($(disabledItem).hasClass('e-pdfviewer-fitwidth')) || ($(disabledItem).hasClass('e-pdfviewer-fitpage'))) {
                    var hoverSpan = currentToolbarItem;
                    var spanId = $(hoverSpan).attr('id');
                    switch (spanId) {
                        case this._id + "_fitWidth":
                            var fitWidthId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitwidth')[0];
                            if (fitWidthId)
                                TagPos = fitWidthId.getBoundingClientRect();
                            else
                                TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitwidth')[0].getBoundingClientRect();
                            toolTipText = this._getTootipText('fittoWidth');
                            break;
                        case this._id + "_fitPage":
                            var fitPageId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitpage')[0];
                            if (fitPageId)
                                TagPos = fitPageId.getBoundingClientRect();
                            else
                                TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitpage')[0].getBoundingClientRect();
                            toolTipText = this._getTootipText('fittopage');
                            break;
                        default:
                            var prevElement = $(hoverSpan).prev();
                            if ($(prevElement).hasClass('e-pdfviewer-fitwidth')) {
                                fitWidthId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitwidth')[0];
                                if (fitWidthId)
                                    TagPos = fitWidthId.getBoundingClientRect();
                                else
                                    TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitwidth')[0].getBoundingClientRect();
                                toolTipText = this._getTootipText('fittoWidth');
                            } else if ($(prevElement).hasClass('e-pdfviewer-fitpage')) {
                                fitPageId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitpage')[0];
                                if (fitPageId)
                                    TagPos = fitPageId.getBoundingClientRect();
                                else
                                    TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitpage')[0].getBoundingClientRect();
                                toolTipText = this._getTootipText('fittopage');
                            }
                    }
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-find")) {
                    if (!this._isFindboxPresent) {
                        var searchSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-find')[0];
                        if (searchSpanId)
                            TagPos = searchSpanId.getBoundingClientRect();
                        else
                            TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-find')[0].getBoundingClientRect();
                        toolTipText = this._getTootipText('search');
                    }
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-highlight-markup") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-highlight")) {
                    var highlightSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-highlight-markup')[0];
                    if (highlightSpanId)
                        TagPos = highlightSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-highlight-markup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('highlight');
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-strikeout-markup") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-strikeout")) {
                    var strikeoutSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-strikeout-markup')[0];
                    if (strikeoutSpanId)
                        TagPos = strikeoutSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-strikeout-markup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('strikeout');
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-underline-markup") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-underline")) {
                    var underlineSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-underline-markup')[0];
                    if (underlineSpanId)
                        TagPos = underlineSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-underline-markup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('underline');
                }

                if (toolTipText && isShowTooltip) {
                    var maxZindex = this._viewerMaxZindex();
                    $('#' + this._id + '_rptTooltip_Header').html(toolTipText.header);
                    $('#' + this._id + '_rptTooltip_Content').html(toolTipText.content);
                    var toolbarPosition = document.getElementById(this._id + "_toolbarContainer").getBoundingClientRect();
                    var windowWidth = this.element[0].clientWidth;
                    if (windowWidth < TagPos.left + 2 * TagPos.width) {
                        if (toolTipText.header == "Zoom") {
                            $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) - (2 * TagPos.width)), 'display': 'block', 'position': 'absolute' });
                        }
                        else
                            $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) - (3 * TagPos.width)), 'display': 'block', 'position': 'absolute' });
                    }
                    else
                        $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) + (TagPos.width / 2)), 'display': 'block', 'position': 'absolute' });
                }
            }
        },

        _viewerMaxZindex: function () {
            var parents = this.element.parents(), bodyEle, contEle;
            var bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            var contEle = $(this.model.target).children(), cindex = contEle.index(this.popup);
            contEle.splice(cindex, 1);
            $(contEle).each(function (i, ele) { parents.push(ele); });
            var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;
        },

        _getTootipText: function (tipType) {
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var headerTxt = '';
            var contentTxt = '';
            switch (tipType) {
                case 'print':
                    headerTxt = localeObj['toolbar']['print']['headerText'];
                    contentTxt = localeObj['toolbar']['print']['contentText'];
                    break;
                case 'download':
                    headerTxt = localeObj['toolbar']['download']['headerText'];
                    contentTxt = localeObj['toolbar']['download']['contentText'];
                    break;
                case 'first':
                    headerTxt = localeObj['toolbar']['first']['headerText'];
                    contentTxt = localeObj['toolbar']['first']['contentText'];
                    break;
                case 'previous':
                    headerTxt = localeObj['toolbar']['previous']['headerText'];
                    contentTxt = localeObj['toolbar']['previous']['contentText'];
                    break;
                case 'next':
                    headerTxt = localeObj['toolbar']['next']['headerText'];
                    contentTxt = localeObj['toolbar']['next']['contentText'];
                    break;
                case 'last':
                    headerTxt = localeObj['toolbar']['last']['headerText'];
                    contentTxt = localeObj['toolbar']['last']['contentText'];
                    break;
                case 'zoomin':
                    headerTxt = localeObj['toolbar']['zoomIn']['headerText'];
                    contentTxt = localeObj['toolbar']['zoomIn']['contentText'];
                    break;
                case 'zoomout':
                    headerTxt = localeObj['toolbar']['zoomOut']['headerText'];
                    contentTxt = localeObj['toolbar']['zoomOut']['contentText'];
                    break;
                case 'pageIndex':
                    headerTxt = localeObj['toolbar']['pageIndex']['headerText'];
                    contentTxt = localeObj['toolbar']['pageIndex']['contentText'];
                    break;
                case 'zoom':
                    headerTxt = localeObj['toolbar']['zoom']['headerText'];
                    contentTxt = localeObj['toolbar']['zoom']['contentText'];
                    break;
                case 'fittoWidth':
                    headerTxt = localeObj['toolbar']['fitToWidth']['headerText'];
                    contentTxt = localeObj['toolbar']['fitToWidth']['contentText'];
                    break;
                case 'fittopage':
                    headerTxt = localeObj['toolbar']['fitToPage']['headerText'];
                    contentTxt = localeObj['toolbar']['fitToPage']['contentText'];
                    break;
                case 'search':
                    headerTxt = localeObj['toolbar']['search']['headerText'];
                    contentTxt = localeObj['toolbar']['search']['contentText'];
                    break;
                case 'highlight':
                    headerTxt = localeObj['toolbar']['highlight']['headerText'];
                    contentTxt = localeObj['toolbar']['highlight']['contentText'];
                    break;
                case 'strikeout':
                    headerTxt = localeObj['toolbar']['strikeout']['headerText'];
                    contentTxt = localeObj['toolbar']['strikeout']['contentText'];
                    break;
                case 'underline':
                    headerTxt = localeObj['toolbar']['underline']['headerText'];
                    contentTxt = localeObj['toolbar']['underline']['contentText'];
                    break;
            }
            return { header: headerTxt, content: contentTxt };
        },
        //-------------------- Tooltip Localization Actions[End]------------------------//

        //-------------------- DrillThrough Actions[Start]----------------------//

        _setInitialization: function () {
            this._canvascount = 0;
            this._fileName = '';
            this._isToolbarClick = false;
            this._pageModel = null;
            this._currentPage = 1;
            this._zoomLevel = 2;
            this._pageImageStream = null;
            this._pageWidth;
            this._pageHeight;
            this._pageLocation = new Array();
            this._scrollTriggered = false;
            this._previousPage = 1;
            this._totalPages;
            this._previousPosition;
            this._cummulativeHeight;
            this._backgroundPage = 1;
            this._renderedCanvasList = new Array();
            this._pageContents = new Array();
            this._pageText = new Array();
            this._searchMatches = new Array();
            this._pagePrinted = false;
            this._printingPage = 1;
            this._printingTimer;
            this._previousZoom = 1;
            this._renderPreviousPage = false;
            this._pageSize;
            this._eventpreviouszoomvalue;
            this._eventzoomvalue;
            this._pdfFileName;
            this._zoomArray = new Array();
            this._rerenderCanvasList = new Array();
            this._ajaxRequestState = null;
        },

        //-------------------- DrillThrough Actions[End]----------------------//

        //-------------------- Common pdfviewer events & utils[start]----------------------//
        _showViewerBlock: function (showblock) {
            if (showblock) {
                $('#' + this._id + '_viewBlockContainer').css("display", "block");
                var parameterBlock = $('#' + this._id + '_viewBlockContainer .e-pdfviewer-viewerblockcellcontent').find('table');
                this._selectparamToolItem(parameterBlock.is('[isviewclick]'));
            } else {
                $('#' + this._id + '_viewBlockContainer').css("display", "none");
            }
            if (this._isDevice) {
                $('#' + this._id + '_viewBlockContainer.e-pdfviewer-blockstyle').css('z-index', showblock ? '10' : '0');
            }
        },

        _showNavigationIndicator: function (isShow) {
            $('#' + this._id + '_viewerContainer').ejWaitingPopup({ showOnInit: isShow, appendTo: '#' + this._id + '_viewerContainer' });
            $('#' + this._id + '_viewerContainer_WaitingPopup').addClass('e-pdfviewer-waitingpopup');
        },

        _showloadingIndicator: function (isShow) {
            if (isShow) {
                $('#' + this._id + '_loadingIndicator').css('display', 'block');
                $('#' + this._id + '_pageviewOuterContainer').css('display', 'none');
            }
            else {
                $('#' + this._id + '_loadingIndicator').css('display', 'none');
                $('#' + this._id + '_pageviewOuterContainer').css('display', 'block');
            }
            $('#' + this._id + '_loadingIndicator').ejWaitingPopup({ showOnInit: isShow, appendTo: '#' + this._id + '_loadingIndicator' });
            $('#' + this._id + '_loadingIndicator_WaitingPopup').addClass('e-pdfviewer-waitingpopup');
        },

        _showPrintLoadingIndicator: function (isShow) {
            $('#' + this._id + 'e-pdf-viewer').css({ 'position': 'relative' });
            $('#' + this._id + 'e-pdf-viewer').ejWaitingPopup({ showOnInit: isShow, text: "Preparing document for printing...", cssClass: 'e-pdfviewer-waitingpopup-print', appendTo: '#' + this._id + 'e-pdf-viewer' });
        },

        _viewerResize: function (event) {
            var proxy = this;
            var elementWidth = proxy._isWidth ? proxy.element[0].parentElement.style.width : proxy.element[0].style.width;
            var elementHeight = proxy._isHeight ? proxy.element[0].parentElement.style.height : proxy.element[0].style.height;
            var _height = $(proxy.element).height();
            var _width = $(proxy.element).width();
            if (elementHeight.indexOf("%") != -1) {
                proxy._isPercentHeight = parseInt(elementHeight);
                var containerHeight = proxy._isHeight ? $(proxy.element).parent().height() : _height;
                _height = !proxy._isHeight ? ((containerHeight / 100) * proxy._isPercentHeight) : containerHeight;
            } else if (proxy.element[0].parentElement.clientHeight != 0 && proxy._isPercentHeight != -1) {
                _height = !proxy._isHeight ? ((proxy.element[0].parentElement.clientHeight / 100) * proxy._isPercentHeight) : proxy.element[0].parentElement.clientHeight;
            } else if (proxy._isHeight && proxy.element[0].parentElement.clientHeight != 0) {
                _height = proxy.element[0].parentElement.clientHeight;
            }
            proxy.element.height(_height);
            if (elementWidth.indexOf("%") != -1) {
                proxy._isPercentWidth = parseInt(elementWidth);
                var containerWidth = proxy._isWidth ? $(proxy.element).parent().width() : _width;
                _width = !proxy._isWidth ? (containerWidth / 100) * proxy._isPercentWidth : containerWidth;
            } else if (proxy.element[0].parentElement.clientWidth != 0 && proxy._isPercentWidth != -1) {
                _width = !proxy._isWidth ? (proxy.element[0].parentElement.clientWidth / 100) * proxy._isPercentWidth : proxy.element[0].parentElement.clientWidth;
            } else if (proxy._isWidth && proxy.element[0].parentElement.clientWidth != 0) {
                _width = proxy.element[0].parentElement.clientWidth;
            }
            proxy.element.width(_width);
            proxy._toolbar._activeItem = undefined;
            proxy._toolbar._reSizeHandler();
            if (_width <= 500) {
                $('#' + this._id + "_containerDialogTab").ejDialog({ position: { X: ((_width / 2) - (307 / 2)) + "px", Y: (_height / 2) + "px" }, width: "auto" });
            }
            else {
                $('#' + this._id + "_containerDialogTab").ejDialog({ position: { X: ((_width / 2) - (500 / 2)) + "px", Y: (_height / 2) + "px" }, width: "500px" });
            }
            $('#' + proxy._id + '_pdfviewer_searchul').removeClass('e-separator');
            $('#' + proxy._id + '_pdfviewer_downloadul').removeClass('e-separator');
            document.getElementById(proxy._id + '_pdfviewer_colorpicker').style.display = 'none';
            proxy._isToolbarColorPicker = false;
            var toolbar = $('#' + this._id + '_toolbarContainer');
            if ($('#' + this._id + '_pdfviewer_printul').parent()[0] != toolbar[0]) {
                if (!this._isDownloadCntlHidden) {
                    toolbar.append($('#' + this._id + '_pdfviewer_printul')[0]);
                    this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_downloadul')[0]);
                    this._isDownloadCntlHidden = true;
                }
            }
            if ($('#' + this._id + '_pdfviewer_downloadul').parent()[0] != toolbar[0]) {
                if (this._isDownloadCntlHidden) {
                    this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_printul')[0]);
                    this._isDownloadCntlHidden = false;
                }
            }
            proxy._toolbarResizeHandler();
            proxy._resizeSearchToolbar();
            if (proxy.model.isResponsive && proxy._renderedCanvasList.length > 0 && proxy._isAutoZoom) {
                proxy._applyFitToWidthAuto();
            }
            if (proxy._fitType == "fitToWidth" && !proxy.model.isResponsive) {
                proxy._applyFitToWidth();
            }
            proxy._isWindowResizing = true;
            //Function for assigning left style property for page Canvas.
            proxy._applyLeftPosition();
        },

        /*  * _applyLeftPosition() assigns the left style property of the page canvas.
            * The left style property is calculated and added to each page canvas.
            * So the page canvas is centered.
        */
        _applyLeftPosition: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                var leftPosition;
                if ((this._fitType == "fitToWidth") || (this._isAutoZoom && this._zoomVal < 1))
                    leftPosition = 5;
                else {
                    if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270)
                        leftPosition = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                    else
                        leftPosition = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                }
                if (leftPosition < 0)
                    leftPosition = 5;
                var pageDiv = document.getElementById(this._id + 'pageDiv_' + i);
                if (pageDiv) {
                    pageDiv.style.left = leftPosition + "px";
                }
            }
        },

        _toolbarResizeHandler: function () {
            var toolbar = $('#' + this._id + '_toolbarContainer');
            if ($('#' + this._id + '_pdfviewer_searchul').parent()[0] != toolbar[0]) {
                this._isZoomCntlHidden = true;
                toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'left' });
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_downloadul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_printul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_textmarkupul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_zoomul')[0]);
            }
            if (($('#' + this._id + '_pdfviewer_zoomul').parent()[0] == toolbar[0]) && this._isZoomCntlHidden) {
                toolbar.append($('#' + this._id + '_pdfviewer_zoomul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_textmarkupul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'right' });
                $('#' + this._id + '_pdfviewer_textmarkupul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_printul').removeClass('e-separator');
                this._isZoomCntlHidden = false;
            }
        },

        _overflowToolbarClose: function () {
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
        },

        _resizeSearchToolbar: function () {
            var searchToolbar = document.getElementById(this._id + '_pdfviewer_searchbox');
            if (searchToolbar) {
                var searchicon = $('#' + this._id + '_toolbarContainer .e-pdfviewer-find')[0];
                if (!searchicon) {
                    searchicon = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-find')[0];
                }
                var position = searchicon.getBoundingClientRect();
                var style = document.getElementById('e-pdfviewer-arrow-responsive');
                if (style) {
                    document.head.removeChild(style);
                }
                if (!$('#' + this._id + '_toolbarContainer_target').hasClass('e-display-block')) {
                    searchToolbar.style.left = (searchicon.parentNode.parentNode.offsetLeft - searchicon.parentNode.parentNode.parentNode.offsetLeft - 2) + 'px';
                    var searchInput = $('#' + this._id + '_pdfviewer_searchinput')[0];
                    searchInput.style.width = '150px';
                    searchToolbar.style.width = '400px';
                } else {
                    var viewerToolbar = document.getElementById(this._id + '_toolbarContainer');
                    searchToolbar.style.left = '0px';
                    var searchInput = $('#' + this._id + '_pdfviewer_searchinput')[0];
                    searchInput.style.width = '150px';
                    searchToolbar.style.width = '400px';
                }
                var viewer = document.getElementById(this._id + 'e-pdf-viewer');
                if ((viewer.clientWidth) < (searchToolbar.offsetLeft + searchToolbar.clientWidth)) {
                    var searchInput = $('#' + this._id + '_pdfviewer_searchinput')[0];
                    if (this._isZoomCntlHidden) {
                        searchInput.style.width = parseInt(searchInput.style.width) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                        searchToolbar.style.width = parseInt(searchToolbar.style.width) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                    } else {
                        searchToolbar.style.left = parseInt(searchToolbar.style.left) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                    }
                } else {
                    if ($('#' + this._id + '_toolbarContainer_target').hasClass('e-display-block')) {
                        searchToolbar.style.left = parseInt(searchToolbar.style.left) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                    }
                }
                this._responsiveArrow(position, searchToolbar);
            }
        },

        _responsiveArrow: function (position, searchToolbar) {
            var styleSheet = document.createElement("Style");
            styleSheet.id = 'e-pdfviewer-arrow-responsive';
            document.head.appendChild(styleSheet);
            var style = styleSheet.sheet;
            if (!navigator.userAgent.match("Firefox") && style) {
                var searchToolbarPosition = searchToolbar.getBoundingClientRect();
                var left = position.left - searchToolbarPosition.left;
                style.addRule('.e-pdfviewer-arrow::before', 'left:' + left + 'px');
                style.addRule('.e-pdfviewer-arrow::after', 'left:' + left + 'px');
            } else {
                $('#' + this._id + '_pdfviewer_searchbox').removeClass('e-pdfviewer-arrow');
            }
        },

        //-------------------- Common pdfviewer events & utils[End]----------------------//

        /*---------------------client side methods[start]----------------------------------------------------------*/

        goToPage: function (pageNo) {
            this._gotoPageNo(pageNo);
        },

        goToLastPage: function () {
            this._gotoLastPage();
        },

        goToFirstPage: function () {
            this._gotoFirstPage();
        },

        goToNextPage: function () {
            this._gotoNextPage();
        },

        goToPreviousPage: function () {
            this._gotoPreviousPage();
        },

        print: function () {
            this._print();
        },

        abortPrint: function () {
            this._printCancel();
        },

        showPrintTools: function (show) {
            this._showPrintButton(show);
        },

        showDownloadTool: function (show) {
            this._showDownloadButton(show);
        },

        showTextSearchTool: function (show) {
            this._showTextSearchButton(show);
        },

        showPageNavigationTools: function (show) {
            this._showPageNavigationControls(show);
        },

        showMagnificationTools: function (show) {
            this._showZoomControl(show);
            this._showFittoPage(show);
        },

        showTextMarkupAnnotationTools: function (show) {
            this._showTextMarkupButtons(show);
        },

        showToolbar: function (showToolbar) {
            this._showToolbar(showToolbar);
        },

        unload: function () {
            this._unLoad();
        },

        load: function (file) {
            $('#' + this._id + '_viewerContainer').scrollTop(0);
            this._showloadingIndicator(true);
            this.isDocumentEdited = false;
            this._fitType = null;
            this.model.isResponsive = true;
            this._isAutoZoom = true;
            $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_download');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_search');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_highlight');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_strikeout');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_underline');
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
            this._isHighlightEnabled = false;
            this._isUnderlineEnabled = false;
            this._isStrikeOutEnabled = false;
            this._isHighlight = false;
            this._isUnderline = false;
            this._isStrikeout = false;
            this._annotationActive = false;
            this._isFormFieldsDisabled = false;
            this._zoomVal = 1;
            this._zoomLevel = 3;
            this.fileName = null;
            this._fileName = "";
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var text = localeObj['contextMenu']['auto']['contentText'];
            $('#' + this._id + '_toolbar_zoomSelection_hidden').val(text);
            this._ejDropDownInstance.model.value = text;
            this._initToolbar();
            if (file) {
                var count = this._canvascount;
                while (count >= 1) {
                    $('#' + this._id + 'pageDiv_' + count).remove();
                    count--;
                }
            }

            window.clearInterval(this._scrollTimer);
            var jsonResult = new Object();
            jsonResult["viewerAction"] = "GetPageModel";
            jsonResult["controlId"] = this._id;
            jsonResult["pageindex"] = "1";
            jsonResult["isInitialLoading"] = "true";

            var fileUrl = file.split("base64,")[1];
            if (fileUrl == undefined) {
                this._fileName = file;
                jsonResult["newFileName"] = this._fileName;
                this._fileId = this._createGUID();
                jsonResult["id"] = this._fileId;
                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                    this._doAjaxPost("POST", this._actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                else
                    this._doAjaxPost("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
            } else {
                var actionUrl = this.model.serviceUrl;
                jsonResult["uploadedFile"] = fileUrl;
                this._fileId = this._createGUID();
                jsonResult["id"] = this._fileId;
                if (this._pdfService == ej.PdfViewer.PdfService.Local) {
                    actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.fileUpload;
                    this._doAjaxPost("POST", actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                }
                else {
                    actionUrl = actionUrl.replace(this.model.serverActionSettings.load, this.model.serverActionSettings.fileUpload);
                    this._doAjaxPost("POST", actionUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
                }
            }
        },


        fitToPage: function () {
            this._applyFitToPage();
        },

        fitToWidth: function () {
            this._applyFitToWidth();
        },

        download: function (isAsynchronous) {
            if (typeof isAsynchronous === "boolean")
                this._isAsynchronousDownload = isAsynchronous;
            else
                this._isAsynchronousDownload = true;
            this._saveFormFieldsValue();
        },

        zoomIn: function () {
            this._applyLowerZoomIndex();
            this._zoomIn();
        },

        zoomOut: function () {
            this._applyHigherZoomIndex();
            this._zoomOut();
        },

        zoomTo: function (zoomvalue) {
            if (zoomvalue < 50)
                zoomvalue = 50;
            else if (zoomvalue > 400)
                zoomvalue = 400;
            var zoomfactor = parseInt(zoomvalue) / 100;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var text = localeObj['contextMenu']['auto']['contentText'];
            if (zoomvalue == text) {
                zoomfactor = 1;
                this.model.isResponsive = true;
            }
            else {
                zoomvalue = zoomvalue + "%";
                this.model.isResponsive = false;
            }
            this._calculateZoomLevel(zoomfactor);
            this._zoomContainer(zoomfactor, false);
            $('#' + this._id + '_toolbar_zoomSelection_hidden').val(zoomvalue);
            this._ejDropDownInstance.model.selectedIndices[0] = "";
            $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
            this._ejDropDownInstance.model.value = zoomvalue;
        },

        undo: function () {
            if (!this._isPropertiesWindowOpen)
                this._undo();
        },

        redo: function () {
            if (!this._isPropertiesWindowOpen)
                this._redo();
        },

        addAnnotation: function (annotationType) {
            if (annotationType == ej.PdfViewer.AnnotationType.Highlight)
                this._addAnnotation("Highlight");
            else if (annotationType == ej.PdfViewer.AnnotationType.Underline)
                this._addAnnotation("Underline");
            else if (annotationType == ej.PdfViewer.AnnotationType.Strikethrough)
                this._addAnnotation("StrikeOut");
        }
        /*---------------------client side methods[end]----------------------------------------------------------*/
    });

    /**
	* Enum for enable and disable toolbar items.	 
	* @enum {number}
	* @global 
	*/
    ej.PdfViewer.ToolbarItems = {
        /**  Enables zoom toolbar item. */
        MagnificationTools: 1 << 0,
        /**  Enables page navigation toolbar item. */
        PageNavigationTools: 1 << 1,
        /**  Enables print toolbar item. */
        PrintTools: 1 << 2,
        /**  Enables download toolbar item. */
        DownloadTool: 1 << 3,
        /**  Enables Search toolbar item. */
        TextSearchTool: 1 << 4,
        /**  Enables Search toolbar item. */
        TextMarkupAnnotationTools: 1 << 5,
        /**   Enables all the toolbar items. */
        All: 1 << 0 | 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5
    };

    ej.PdfViewer.PdfService = {
        Local: 1 << 0,
        Remote: 1 << 1,
    };
    ej.PdfViewer.LinkTarget = {
        Default: 1 << 0,
        NewTab: 1 << 1,
        NewWindow: 1 << 2,
    };

    ej.PdfViewer.AnnotationType = {
        Underline: 1 << 0,
        Strikethrough: 1 << 1,
        Highlight: 1 << 2
    };

    ej.PdfViewer.Locale = ej.PdfViewer.Locale || {};

    ej.PdfViewer.Locale["default"] = ej.PdfViewer.Locale["en-US"] = {
        toolbar: {
            print: {
                headerText: 'Print',
                contentText: 'Print the PDF document.'
            },
            download: {
                headerText: 'Download',
                contentText: 'Download the PDF document.'
            },
            first: {
                headerText: 'First',
                contentText: 'Go to the first page of the PDF document.'
            },
            previous: {
                headerText: 'Previous',
                contentText: 'Go to the previous page of the PDF document.'
            },
            next: {
                headerText: 'Next',
                contentText: 'Go to the next page of the PDF document.'
            },
            last: {
                headerText: 'Last',
                contentText: 'Go to the last page of the PDF document.'
            },
            zoomIn: {
                headerText: 'Zoom-In',
                contentText: 'Zoom in to the PDF document.'
            },
            zoomOut: {
                headerText: 'Zoom-Out',
                contentText: 'Zoom out of the PDF document.'
            },
            pageIndex: {
                headerText: 'Page Number',
                contentText: 'Current page number to view.'
            },
            zoom: {
                headerText: 'Zoom',
                contentText: 'Zoom in or out on the PDF document.'
            },
            fitToWidth: {
                headerText: 'Fit to Width',
                contentText: 'Fit the PDF page to the width of the container.',
            },
            fitToPage: {
                headerText: 'Fit to Page',
                contentText: 'Fit the PDF page to the container.',
            },
            search: {
                headerText: 'Search Text',
                contentText: 'Search text in the PDF pages.',
            },
            highlight: {
                headerText: 'Highlight Text',
                contentText: 'Highlight text in the PDF pages.',
            },
            strikeout: {
                headerText: 'Strikethrough Text',
                contentText: 'Strikethrough text in the PDF pages.',
            },
            underline: {
                headerText: 'Underline Text',
                contentText: 'Underline text in the PDF pages.',
            },
        },
        contextMenu: {
            copy: {
                contentText: 'Copy',
            },
            googleSearch: {
                contentText: 'Search google',
            },
            openPopup: {
                contentText: 'Open Pop-Up Note',
            },
            Delete: {
                contentText: 'Delete',
            },
            properties: {
                contentText: 'Properties....',
            },
            Find: {
                contentText: 'Find:',
            },
            matchCase: {
                contentText: 'matchCase',
            },
            auto: {
                contentText: 'Auto',
            },
        },
        propertyWindow: {
            underlineProperties: {
                contentText: "Underline Properties"
            },
            strikeOutProperties: {
                contentText: "StrikeOut Properties"
            },
            highlightProperties: {
                contentText: "Highlight Properties"
            },
            appearance: {
                contentText: "Appearance"
            },
            general: {
                contentText: "General"
            },
            color: {
                contentText: "Color:"
            },
            opacity: {
                contentText: "Opacity:"
            },
            author: {
                contentText: "Author:"
            },
            subject: {
                contentText: "Subject:"
            },
            modified: {
                contentText: "Modified:"
            },
            ok: {
                contentText: "OK"
            },
            cancel: {
                contentText: "Cancel"
            },
            locked: {
                contentText: "Locked"
            }
        }
    };
})(jQuery, Syncfusion);
;;
(function ($, ej, undefined) {
    // ejGanttChart is the plugin name 
    // "ej.GanttChart" is "namespace.className" will hold functions and properties
    'use strict';
    ej.widget("ejGanttChart", "ej.GanttChart", {
        // widget element will be automatically set in this
        element: null,

        // user defined model will be automatically set in this
        model: null,
        _rootCSS: "e-ganttchart",

        /* keyConfigurations for keyboard interaction in treegrid */
        keyConfigs: {
            focus: "e",

            //Insert
            insertRecord: "45",

            // delete
            deleteRecord: "46",

            //F2
            editRecord: "113",

            // Enter
            saveRequest: "13",

            //Esc   
            cancelRequest: "27",

            //Home,
            firstRowSelection: "36",

            //End,
            lastRowSelection: "35",

            //Left arrow
            leftArrow: "37",

            //Right arrow
            rightArrow: "39",

            //Up arrow
            upArrow: "38",

            //Down arrow
            downArrow: "40",

            //tab
            moveCellRight: "9",

            //shifttab
            moveCellLeft: "shift+9",

            //AltPlusDownArrow
            selectedRowExpand: "alt+40",

            //CtrlPlusDownArrow
            totalRowExpand: "ctrl+40",

            //AltPlusUpArrow
            selectedRowCollapse: "alt+38",

            //CtrlPlusUpArrow
            totalRowCollapse: "ctrl+38"
        },

        //default model
        defaults: {
            childPropertyName: "",
            taskIdMapping: "",
            taskNameMapping: "",
            startDateMapping: "",
            endDateMapping: "",
            childMapping: "",
            finishDateMapping: "",
            durationMapping: "",
            milestoneMapping: "",
            progressMapping: "",
            predecessorMapping: "",
            resourceInfoMapping: "",
            resourceNameMapping: "",
            resourceCollection: [], /*--------------Array containing the resource names */

            holidays: [
                {
                    day: null,
                    label: null,
                    background: null
                }
            ],

            stripLines: [
                {
                    day: null,
                    label: null,
                    lineStyle: "dotted",
                    lineColor: "#169dd7",
                    lineWidth: 2
                }
            ],

            enableTaskbarTooltip: true, /*------------showing tooltip on taskbar mouse over */
            enableTaskbarDragTooltip: true, /*--------showing taskbar while dragging taskbar */

            highlightWeekends: true, /*-------------Boolean value for highlighting weekends */

            scheduleStartDate: null, /*-------------start date of entire project */
            scheduleEndDate: null, /*---------------end date of entire project */

            enableProgressBarResizing: true, /*----------Boolean value for resizing progress bar */

            rowHeight: 30,
            progressbarHeight: 100,
            connectorlineWidth: 1,
            dateFormat: "MM/dd/yyyy",
            locale: "en-US",

            //background style
            taskbarBackground: "#DE8080", //"#5AC1E0",
            progressbarBackground: "#C44647", //"#169DD7",
            weekendBackground: '#F2F2F2',
            connectorLineBackground: "#383838",
            parentTaskbarBackground: "#383838",
            parentProgressbarBackground: "#1C1C1C",

            selectedItem: null,
            selectedRowIndex: -1,
            perDayWidth: null,

            perMonthWidth: null,//year-month schedule mode
            perWeekWidth: null,//month-week schedule mode
            perHourWidth:null,
            queryTaskbarInfo: null,

            taskbarTemplate: "",
            progressbarTemplate: null,
            parenttaskbarTemplate: "",
            parentprogressbarTemplate: null,
            milestoneTemplate:"",

            //internal collections
            flatRecords: [],
            updatedRecords: [],
            ids: [],
            currentViewData: [],

            scheduleWeeks: [],

            scheduleYears: [],
            scheduleMonths: [], //new property for month schedule
            scheduleDays:[],
            scheduleHours:[],
            projectStartDate: null, //new property instead of scheduleWeeks[0] and scheduleYears[0]
            projectEndDate: null,

           

            //tooltip templates
            tooltipTemplate: "",
            tooltipTemplateId:"",
            progressbarTooltipTemplateId: "",
            taskbarEditingTooltipTemplateId: "",

            taskbarEditingTooltipTemplate: "",
            progressbarTooltipTemplate: "",

            //boolean values
            showTaskNames: true,
            leftTaskLabelMapping: "",
            rightTaskLabelMapping: "",
            LeftTaskLabelTemplate: "",
            rightTaskLabelTemplate: "",
            showProgressStatus: true,
            showResourceNames: true,
            enableRowHover: false,
            includeWeekend: false,
            allowZooming: false,
            readOnly:false,
            allowGanttChartEditing: true,
            allowKeyboardNavigation: true,

            //baselines
            renderBaseline: false,
            baselineColor: '#fba41c ',

            /* editing API's */
            editSettings: {
                allowEditing: false,
                allowAdding: false,
                allowDeleting: false,
                editMode: "normal",
                dialogEditorTemplateId: null
            },

            scheduleHeaderSettings:
            {
                weekHeaderFormat: "MMM dd , yyyy",//for week - Day schedule mode
                dayHeaderFormat: "",
                weekendBackground: '#F2F2F2',

                yearHeaderFormat: "yyyy",
                monthHeaderFormat: "MMM",

                hourHeaderFormat: "HH",
                minuteHeaderFormat:"mm",
                scheduleHeaderType: "week",
                weekStartDay: 0
            },
            workingTimeScale: "TimeScale8Hours",
            roundOffDayworkingTime: true,
            durationUnit: "day",

            localizedDays: null,
            localizedMonths: null,
            //localized string to be displayed in toolTip
            columnHeaderTexts: null,
            predecessorEditingTexts: null,
            enablePredecessorEditing: true,
            taskbarClick: null
        },

        updateHighlightWeekends: function (boolValue) {
            var proxy = this;
            proxy.model.highlightWeekends = boolValue;

            if (proxy.model.highlightWeekends == true)
                proxy._renderWeekends();
            else
                proxy._$weekendsContainer.remove();
        },

        updateWeekendBackground: function (bgcolor) {
            var proxy = this;
            proxy.model.weekendBackground = bgcolor;
            proxy._$weekendsContainer.remove();
            proxy._renderWeekends();
        },

        showTooltip: function (boolValue) {
            var proxy = this;
            proxy.model.enableTaskbarTooltip = boolValue;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        showEditingTooltip: function (boolValue) {
            var proxy = this;
            proxy.model.enableTaskbarDragTooltip = boolValue;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateConnectorLineBackground: function (bgcolor) {
            var proxy = this;
            proxy.model.connectorLineBackground = bgcolor;
            proxy._createConnectorLineTemplate();
        },

        updateConnectorlineWidth: function (lineWidth) {
            var proxy = this;
            proxy.model.connectorlineWidth = parseInt(lineWidth);
            proxy._createConnectorLineTemplate();
        },
        updateEditedRecordEndDate: function (endDate) {
            var proxy = this;
            proxy._currentEditedRecord.endDate = endDate;
        },

        updateEditedRecordDuration: function (duration) {
            var proxy = this;
            proxy._currentEditedRecord.duration = duration;
        },

        updateTaskbarBackground: function (bgcolor) {
            var proxy = this;
            proxy.model.taskbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateProgressbarBackground: function (bgcolor) {
            this.model.progressbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateParentTaskbarBackground: function (bgcolor) {
            this.model.parentTaskbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateParentProgressbarBackground: function (bgcolor) {
            this.model.parentProgressbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateRenderTaskNames: function (bool) {
            var proxy = this;
            proxy.model.showTaskNames = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        refreshLeftTaskLabelMapping: function (leftLabel) {
            var proxy = this;
            proxy.model.leftTaskLabelMapping = leftLabel;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        refreshRightTaskLabelMapping: function (rightLabel) {
            var proxy = this;
            proxy.model.rightTaskLabelMapping = rightLabel;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        refreshLeftTaskLabelTemplate: function (leftLabeltemplate) {
            var proxy = this;
            proxy.model.leftTaskLabelTemplate = leftLabeltemplate;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        refreshRightTaskLabelTemplate: function (rightLabeltemplate) {
            var proxy = this;
            proxy.model.rightTaskLabelTemplate = rightLabeltemplate;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        updateRendeProgressStatus: function (bool) {
            var proxy = this;
            proxy.model.showProgressStatus = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateRenderResourceNames: function (bool) {
            var proxy = this;
            proxy.model.showResourceNames = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        changeMilestoneTemplate : function(value)
        {
            var proxy = this;
            proxy.model.milestoneTemplate = value;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        changeTaskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.taskbarTemplate = value;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        changeParentTaskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.parentTaskbarTemplate = value;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        ganttChartEditing: function (boolValue) {
            var proxy = this;
            proxy.model.allowGanttChartEditing = boolValue;
        },
        updateReadOnly: function (boolValue) {
            var proxy = this;
            proxy.model.readOnly = boolValue;
        },
        resizeProgressbar: function (boolValue) {
            var proxy = this;
            proxy.model.enableProgressBarResizing = boolValue;

        },
        /* udpate value of allowKeyboardNavigation API from Gantt */
        updateAllowKeyboardNavigation: function (bool) {
            this.model.allowKeyboardNavigation = bool;
        },

        updateProgressbarHeight: function (height) {
            var proxy = this;
            this.model.progressbarHeight = height;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateBaselineColor: function (color) {
            var proxy = this;
            this.model.baselineColor = color;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateRenderBaseline: function (bool) {
            var proxy = this;
            this.model.renderBaseline = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
            proxy._createConnectorLineTemplate();
        },

        focusGanttElement: function () {
            if (ej.browserInfo().name == "msie") {
                try { this.element[0].setActive(); } catch (e) { }
            }
            else
                this.element[0].focus();
        },
        
        //returns the schedule year width
        _getYearWidth: function () {
            var proxy = this,count=0,width=0;
            for (count = 0; count < this.model.scheduleYears.length; count++) {
                width += this._getTemplateYearWidth(this.model.scheduleYears[count]);
            }
            return (width);
        },

        //returns the schedule month width
        _getMonthWidth: function () {
            var proxy = this,
                model = proxy.model,
                date, scheduleMonths = model.scheduleMonths,
                    monthWidth = 0;

            for (var i = 0; i < scheduleMonths.length; i++) {
                var startDate = scheduleMonths[i];

                if (typeof startDate === "object") {
                    date = new Date(startDate);
                }
                else {
                    date = ej.parseDate(startDate, this.model.dateFormat, this.model.locale);
                }
                var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);

                var lastDate = monthLastDay.getDate();
                // condition to check if the first month having only few weeks.
                if (date.getTime() === proxy.model.scheduleMonths[0].getTime()) {
                    var datediff = monthLastDay.getDate() - date.getDate();
                    monthWidth += (this.model.perDayWidth * (datediff+1));
                }
                else if (lastDate == 31)
                    monthWidth += (this.model.perDayWidth * 31);
                else if (lastDate == 30)
                    monthWidth += (this.model.perDayWidth * 30);
                else if (lastDate == 28)
                    monthWidth += (this.model.perDayWidth * 28);
            }
            return monthWidth;
        },



        //returns the schedule week width
        _getWeekWidth: function () {
            return (this.model.perDayWidth * 7);
        },

        _getNumberOftWeeks: function (startdate, enddate) {


            //var date1 = new Date(startdate), date2 = new Date(enddate);
            //// The number of milliseconds in one week
            //var ONE_WEEK = 1000 * 60 * 60 * 24 * 7;
            //// Convert both dates to milliseconds
            //var date1_ms = date1.getTime();
            //var date2_ms = date2.getTime();
            //// Calculate the difference in milliseconds
            //var difference_ms = Math.abs(date1_ms - date2_ms);
            //// Convert back to weeks and return hole weeks
            //return Math.floor(difference_ms / ONE_WEEK);
            var startDate = new Date(startdate),
                endDate = new Date(enddate);

            var totalWeeksCollection = [];
            do {
                totalWeeksCollection.push(new Date(startDate));
                startDate.setDate(startDate.getDate() + 7);
            } while (!(startDate > endDate));

            return totalWeeksCollection;
        },

        //returns the ganttchart container height
        _getHeight: function () {
            return this._containerHeight;
        },

        //sets the height of the ganttchart container
        _setHeight: function (value) {
            this._containerHeight = value;
        },

        //returns the rows in the ganttchart
        getGanttChartRows: function () {
            return this._ganttChartRows;
        },

        //returns the gantt record collection
        getUpdatedRecords: function () {
            return this.model.flatRecords;
        },

        //sets value for currentviewdata , ganttrecords and row collections
        setUpdatedRecords: function (currentViewData, updatedRecords, flatRecords,ids) {
            var proxy = this;
            proxy.model.currentViewData = currentViewData;
            proxy.model.updatedRecords = updatedRecords;
            proxy.model.flatRecords = flatRecords;
            proxy.model.ids = ids;
        },

        //returns the string date type 
        _getFormatedDate: function (date, format, locale) {
            return ej.format(date, format, locale);
        },

        //returns the viewport height
        _getViewportHeight: function () {
            var proxy = this,
                headerdiv = proxy._$headerContainer,
                height;

            height = proxy.element.height() - headerdiv.height() -
                    parseFloat(headerdiv.css("border-bottom-width"));
            return height;
        },

        updateViewPortHeight:function(){
            var proxy = this;
            proxy._viewportHeight=proxy._getViewportHeight();
        },

        //constructor function
        _init: function () {

            var proxy = this, model = proxy.model,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;

            proxy.element.addClass("e-ganttchart-core");
            proxy.element.attr("tabindex", "0");
            model.cssClass && proxy.element.addClass(model.cssClass);
            proxy._initPrivateProperties();
            proxy._initialize();
            proxy._renderGanttChart();
            proxy._$bodyContainerParent.append(proxy._$bodyContainer);
            proxy._$bodyContainer.append(proxy._$bodyContent);
            proxy._$ganttChartContainer.append(proxy._$bodyContainerParent);

            $(proxy._$bodyContainer).css({ "height": proxy._viewportHeight + "px" });
            if (proxy.model.enableVirtualization)
                $(proxy._$bodyContent).css({ "height": (model.rowHeight * model.updatedRecords.length) + "px" });

            if (scheduleMode == "week") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleWeeks.length * proxy._scheduleWeekWidth) + "px" });
            }
            else if (scheduleMode == "year") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleYearWidth) + "px" });

            }
            else if (scheduleMode == "month") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleMonthWidth) + "px" });
            }
            else if (scheduleMode == "day") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleDays.length * (model.perHourWidth * 24)) + "px" });
            }
            else if (scheduleMode == "hour") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleHours.length * (model.perMinuteWidth * proxy._totalInterval)) + "px" });
            }
            proxy.createGridLinesTable();
            proxy.renderGanttRecords();
          //  Inner div for scroller
            var scrollerDiv = ej.buildTag('div');
            scrollerDiv.append(proxy._$bodyContent);
            proxy._$bodyContainer.append(scrollerDiv);
            proxy._$bodyContainer.ejScroller({
                width: proxy.element.width() - 1,// additional parent div element added with 1px right border
                enableTouchScroll:false,
                height: proxy._getViewportHeight(), scroll: function (args) {

                    var arg = {},
                        scrollTop = args.scrollTop;

                    args.requestType = "scroll";
                    args.delta = scrollTop;
//                    proxy._completeAction(args);
                    if (scrollTop != undefined) {// && this.isVScroll()
                        if (proxy.onScrollHelper(scrollTop, true) === false) {
                           args.cancel = true;
                        }
                    } else {
                        proxy._handleScroll(args);
                    }
                    
                }
            });
            proxy._$bodyContainer.ejScroller("model.keyConfigs", { up: "", down: "", left: "", right: "" });
            proxy._$bodyContainer.ejScroller("refresh");
            //check if Hscroller is render or not
            var isHorizontalScroll = proxy._$bodyContainer.ejScroller("isHScroll");
                if (!isHorizontalScroll) {
                    proxy._$bodyContainer.find("div.e-content").addClass("e-borderbox");
                }
                else {
                    proxy._$bodyContainer.find("div.e-content").removeClass("e-borderbox");
                }
            proxy._wireEvents();


        },

        //rendering gantt chart again after zoomingvalue changed
        reRenderGanttChart: function (daywidth, flatRecords) {

            var proxy = this, model = proxy.model,
                   scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;

            proxy._wireEvents();
            model.perDayWidth = daywidth;

            // proxy.model.perMonthWidth = monthwidth;

            model.flatRecords = flatRecords;
            proxy._scheduleWeekWidth = proxy._getWeekWidth();
            proxy._scheduleYearWidth = proxy._getYearWidth();
            proxy._scheduleMonthWidth = proxy._getMonthWidth();

            $(proxy._$headerContainer).empty();
            $(proxy._$scheduleDiv).empty();
            proxy._renderGanttChart();
            proxy._$bodyContainerParent.append(proxy._$bodyContainer);
            proxy._$bodyContainer.append(proxy._$bodyContent);
            proxy._$ganttChartContainer.append(proxy._$bodyContainerParent);

            if (scheduleMode == "week") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleWeeks.length * proxy._scheduleWeekWidth) + "px" });
            }
            else if (scheduleMode == "year") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleYearWidth) + "px" });
            }
            else if (scheduleMode == "month") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleMonthWidth) + "px" });
            } 
            else if (scheduleMode == "day") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleDays.length * (model.perHourWidth * 24)) + "px" });
            }
            else if (scheduleMode == "hour") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleHours.length * (model.perMinuteWidth * proxy._totalInterval)) + "px" });
            }
        },

        //declaring private properties
        _initPrivateProperties: function () {
            var proxy = this;
            proxy._viewportHeight = 0,
            proxy._prevScrollTop = 0,
            proxy._scrollTop = 0,
            proxy._vScrollDir = 1,
            proxy._$ganttChartContainer = null,
            proxy._$headerContainer = null,
            proxy._$bodyContainer = null,
            proxy._$bodyContent = null,
            proxy._$dependencyViewContainer = null,
            proxy._$secondaryCanvas = null,
            proxy._$ganttViewTable = null,
            proxy._$ganttViewTablebody = null,
            proxy._weekdays = [],
            proxy._rowMargin = 0,
            proxy._renderedRange = null,
            proxy._visibleRange = null,
            proxy._vTop = null,
            proxy._vBottom = null,
            proxy._rTop = null,
            proxy._rBottom = null,
            proxy._vscrollDist = 0,
            proxy._containerHeight = 0,
            proxy._id = this.element.attr("id"),
            proxy._ganttChartRows = null,
            proxy._filteredRecords = [],
            proxy._sortedRecords = [],
            proxy._tempSortedRecords = [],
            proxy._scheduleHours = [],
            proxy._scheduleMinutes = [],
            proxy._updateScheduleWidth(),
            proxy._totalMonthWidth = 0,
            proxy._tempFilteredRecords = [],
            proxy._prevLeft = 0,
            proxy._allowDragging = false,
            proxy._leftResizing = false,
            proxy._rightResizing = false,
            proxy._progressResizing = false,
            proxy._editingContainer = null,
            proxy._allowExpandCollapse = true,
            proxy._leftResizer = null,
            proxy._taskbarItem = null,
            proxy._progressbarItem = null,
            proxy._progressResizer = null,
            proxy._rightResizer = null,
            proxy._manualRightResizer = null,
            proxy._tasknameContainer = null,
            proxy._mousePosX = 0,
            proxy._currMousePosX = 0,
            proxy._currMousePosY = 0,
            proxy._prevItem = {},
            proxy._parentCollectionPreviousValues = [],
            proxy._mouseTarget = null,
            proxy._mouseDown = false,
            proxy._$scheduleDiv = null,
            proxy._leftResizerGripper = null,
            proxy._rightResizerGripper = null,
            proxy._progressHandle = null,
            proxy._progressHandleChild = null,
            proxy._currentEditedRecord = {
                taskId: null,
                taskName: null,
                startDate: null,
                endDate: null,
                duration: null,
                isMilestone: false,
                status: null,
                predecessor: null,
                resourceInfo: null,
                parentItem: null,
                isSelected: false,
                childRecords: null,
                hasChildRecords: false,
                expanded: false,
                level: 0,
                left: 0,
                width: 0,
                progressWidth: 0,
                item: null,
                baselineLeft: 0,
                baselineWidth: 0,
                baselineStartDate: null,
                baselineEndDate: null,
                isReadOnly: false,
                hasFilteredChildRecords: true,
                serialNumber: null,
                taskbarBackground: null,
                progressbarBackground: null,
                parentProgressbarBackground: null,
                parentTaskbarBackground: null,
                cellBackgroundColor: null,
                rowBackgroundColor: null,
                treeMappingName: [],
                dragState: true,                
                durationUnit: "",
            },
            proxy._mouseHoverTooltip = document.getElementById(this.model.tooltipTemplate),
            proxy._progressBarTooltipID = document.getElementById(this.model.progressbarTooltipTemplateId),
            proxy._taskbarEditingTooltipID = document.getElementById(this.model.taskbarEditingTooltipTemplateId),
            proxy._scrollBarHeight = 18,
            proxy._windowWidth = $(window).width(),
            proxy._windowHeight = $(window).height(),
            proxy._editingItem = null,
            proxy._editingTarget = null,
            proxy.tooltipState = null,
            proxy._visibleRecordsCount = 0,
            proxy._tooltipTimer,
            proxy._$gridLinesTablebody = null,

            //Properties for connector line mouse
            proxy._leftConnectorPoint = null,
            proxy._rightConnectorPoint = null,
            proxy._childLeftConnectorPoint = null,
            proxy._childRightConnectorPoint = null,
            proxy._editPredecessor = false,
            proxy._connectorPointX = null,
            proxy._connectorPointY = null,
            proxy._predecessorTooltip = null,
            proxy._totalCollapsedRecordCount = 0,
            proxy._milesStoneWidth = 0,
            proxy._connectorPointWidth = 0;
            proxy._newXYPos = true;
            proxy._posX1 = null,
            proxy._posY1 = null;
        },
        //Calculate schedulw width for all modes
        _updateScheduleWidth:function(){
            var proxy = this;
            proxy._scheduleWeekWidth = proxy._getWeekWidth();
            proxy._numOfWeeks = proxy._getNumberOftWeeks(this.model.projectStartDate, this.model.projectEndDate);
            proxy._scheduleYearWidth = proxy._getYearWidth();
            proxy._scheduleMonthWidth = proxy._getMonthWidth();
            proxy._totalWeekWidth = proxy._scheduleWeekWidth * proxy._numOfWeeks.length;
            proxy._balanceWidth = proxy._totalWeekWidth - proxy._scheduleMonthWidth;
            proxy._scheduleMonthWidth += proxy._balanceWidth;
        },
        //Initialize ganttchart
        _initialize: function () {
            var proxy = this;
            proxy._$ganttChartContainer = ej.buildTag("div.e-ganttviewercontainer#ganttviewercontainer" + proxy._id, "", { width: "100%" }, {});
            proxy._$headerContainer = ej.buildTag("div.e-ganttviewerheaderContainer#ganttviewerheaderContainer" + proxy._id, "", {
                "border-right-style": "solid",
                "border-right-width": "1px"
            }, {});
            proxy._$bodyContainer = ej.buildTag("div.e-ganttviewerbodyContianer#ganttviewerbodyContianer" + proxy._id, "", {
                '-ms-touch-action': 'none',                
            }, {});

            proxy._$bodyContainerParent = ej.buildTag("div.e-ganttviewerbodyContianerparent#ganttviewerbodyContianerParent" + proxy._id, "", {
                '-ms-touch-action': 'none',                
                "border-right-style": "solid",
                "border-right-width": "1px",
                "box-sizing": "border-box",
                "width": "auto",
                "height": "auto"
            }, {});
            proxy._$bodyContent = ej.buildTag("div.e-ganttviewerbodyContent#ganttviewerbodyContent" + proxy._id, "", {
            }, {});

            proxy._$dependencyViewContainer = ej.buildTag("div.e-ganttviewerbodyContianer-dependencyViewContainer#dependencyViewContainer" + proxy._id,
                "", {
                    'z-index': '4',
                    'position': 'absolute'
                }, {});
            proxy._$secondaryCanvas = ej.buildTag("div.e-ganttviewerbodyContianer-secondaryCanvas", "", {
                'z-index': '3',
                'position': 'absolute'
            }, {});
            //Container for strip lines
            proxy._$stripLineContainer = ej.buildTag("div.e-ganttviewerbodyContianer-stripLines", "", {
                'z-index': '6',
                'position': 'absolute'
            }, {});

            proxy._$weekendsContainer = ej.buildTag("div.e-ganttviewerbodyContianer-weekendsContainer", "", {
                'z-index': '1',
                'position': 'absolute'
            }, {});

            proxy._$ganttViewTable = ej.buildTag("table.e-ganttviewerbodyContianer-ganttViewTable#ganttViewTable" + proxy._id, "", {
                'z-index': '5',
                'position': 'absolute'
            }, { 'cellspacing': '0px' });
            proxy._$scheduleDiv = ej.buildTag("div.e-gantt-schedule-container#gantt-schedule" + proxy._id + "", "", {}, {});
        },

        _getScheduleLength: function (scheduleMode) {
            var proxy = this,
                model = proxy.model;

            switch (scheduleMode) {
                case "week":                    
                    return (model.scheduleWeeks.length * proxy._scheduleWeekWidth);
                case "year":                    
                    return (proxy._scheduleYearWidth);
                case "month":
                    return (proxy._scheduleMonthWidth);
                case "day":
                    return (model.scheduleDays.length * (proxy.model.perHourWidth * 24));
                case "hour":
                    return ((model.scheduleHours.length) * (model.perMinuteWidth * proxy._totalInterval));
                default:
                    return (model.scheduleWeeks.length * proxy._scheduleWeekWidth);
            }
        },

        //Rendering GanttChart
        _renderGanttChart: function () {
            var proxy = this, model = proxy.model,
                scheduleLength, $colsgroup, $column,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;
            
        proxy._createSchedule(proxy._getDateType(model.scheduleStartDate),
            proxy._getDateType(model.scheduleEndDate));

            proxy._viewportHeight = proxy._getViewportHeight();
                       
            proxy._$ganttViewTable.css("width", proxy._getScheduleLength(scheduleMode) + 'px');
            
            $colsgroup = ej.buildTag("colgroup", "", {}, {});
            $column = $(document.createElement("col"));
            $column.css("width", proxy._getScheduleLength(scheduleMode) + 'px');
            
            $colsgroup.append($column);
            proxy._$ganttViewTable.append($colsgroup);

            proxy._createTooltipTemplate();
            proxy._createEditingTooltipTemplate();
            proxy._createProgressbarTooltipTemplate();

            proxy._createTaskbarTemplate();
            proxy._createConnectorLineTemplate();

            proxy._updateCurrentViewData();

            //Display weekends
            if (proxy.model.highlightWeekends == true
                && model.scheduleHeaderSettings.scheduleHeaderType == ej.Gantt.ScheduleHeaderType.Week)
                proxy._renderWeekends();

            proxy._$stripLineContainer.empty();
            //Display striplines
            if (proxy.model.stripLines != null) {
                this._renderStripLines(proxy.model.stripLines);
            }

            proxy._$secondaryCanvas.empty();
            //Display Holidays
            if (proxy.model.holidays != null) {
                var holidayCount = proxy.model.holidays.length;
                for (var i = 0; i < holidayCount; i++) {
                    proxy._renderHoliday(proxy.model.holidays[i]);
                }
            }
        },

        //Rendering connectorlines from Gantt
        renderConnectorLines: function (connectorLinesCollection) {
            var proxy = this,
                connectorLineContainer = $.render[proxy._id + "ConnectorLineTemplate"](connectorLinesCollection);

            $(proxy._$dependencyViewContainer).empty();
            proxy._$dependencyViewContainer.append(connectorLineContainer);
            proxy._$bodyContent.append(proxy._$dependencyViewContainer);
        },

        //Empty the entire connectorline collection
        clearConnectorLines: function () {
            $(this._$dependencyViewContainer).empty();
        },

        clearSelection: function (index) {

            var proxy = this,
                model = proxy.model;

            if (model.selectedRowIndex != -1 || index == -1) {
                //To clear the row selection of previously selected row via set model (selectedRowIndex)
                var $ganttGridRows = proxy.getGanttChartRows();
                $ganttGridRows.removeClass("e-gantt-mouseclick");
            }
        },

        //append single connectorline
        appendConnectorLine: function (connectorLineCollection) {
            var proxy = this,
            connectorLineContainer = $.render[proxy._id + "ConnectorLineTemplate"](connectorLineCollection);
            proxy._$dependencyViewContainer.append(connectorLineContainer);
        },
        //set Collapsed record Count

        setCollapsedRecordCount:function(count)
        {
            this._totalCollapsedRecordCount = count;
        },
        //get collapsed record count
        getCollapsedRecordCount:function()
        {
            return this._totalCollapsedRecordCount;
        },
        //remove a particular connector line
        removeConnectorline: function (lineId) {
            this.element.find("#ConnectorLine" + lineId).remove();
        },

        //Events
        _wireEvents: function () {
            var proxy = this,
                matched = jQuery.uaMatch(navigator.userAgent);

            //$(proxy._$bodyContainer).bind("scroll", $.proxy(proxy._handleScroll, proxy));
            if (ej.isTouchDevice()) {                
                proxy._on(proxy.element, "touchstart", ".e-gantt-milestone-container,.e-childContainer", this._mouseHover);
                proxy._on(proxy.element, "touchstart", ".e-childContainer,.e-gantt-milestone-container,.e-parentContainer", proxy._mousedown);
                $(document.body).bind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
                proxy._on(proxy.element, "touchleave", ".e-gantt-milestone-container,.e-childContainer, .e-parentContainer", this._mouseLeave);
                $(proxy._$bodyContainer).bind("touchend", $.proxy(proxy._handleMouseUp, proxy));
                proxy._on(proxy.element, "tap", proxy._cellClickHandler);
            }
            else {
                proxy._on(proxy.element, "mouseenter", ".e-gantt-milestone-container,.e-childContainer,.e-parentContainer", this._mouseHover);//.gantt-viewer-bodyContianer tr td
                proxy._on(proxy.element, "mouseleave", ".e-gantt-milestone-container,.e-childContainer,.e-parentContainer", this._mouseLeave);//.gantt-viewer-bodyContianer tr td
                proxy._on(proxy.element, "click", proxy._cellClickHandler);
                proxy._on(proxy.element, "mouseenter", ".taskbarresizer-left", proxy._resizerleftOver);
                proxy._on(proxy.element, "mouseenter", ".taskbarresizer-right", proxy._resizerrightOver);
                proxy._on(proxy.element, "mouseenter", ".progressbarresizer-right", proxy._progressresizerOver);
                proxy._on(proxy.element, "mouseenter", ".e-connectorpoint-left", proxy._dragLeftOver);
                proxy._on(proxy.element, "mouseenter", ".e-connectorpoint-right", proxy._dragRightOver);
          

                if (ej.browserInfo().name != "msie") {
                    proxy._on(proxy.element, "mousedown", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                }
                else {
                    proxy._on(proxy.element, "mousedown", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                }


                $(proxy._$bodyContainer).bind("mouseup", $.proxy(proxy._handleMouseUp, proxy));
                $(document).bind("mouseup", $.proxy(proxy._tooltipMouseup, proxy));
                proxy._on(proxy.element, "mouseenter", ".e-stripline", proxy._stripLineMouseOver);
                proxy._on(proxy.element, "mouseleave", ".e-stripline", proxy._stripLineMouseLeave);

                //if (matched.browser.toLowerCase() == "msie") {
                //    proxy._on(proxy.element, "MSPointerDown", ".e-tasklabel,.e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                //    $(document.body).bind("MSPointerMove", function (event) {
                //        event.preventDefault();
                //    });
                //    $(document.body).bind("MSPointerMove", $.proxy(proxy.handleMouseMove, proxy));
                //    $(proxy._$bodyContainer).bind("MSPointerUp", $.proxy(proxy._handleMouseUp, proxy));
                //}


                if (matched.browser.toLowerCase() == "chrome") {
                    proxy._on(proxy.element, "touchstart", ".e-gantt-milestone-container,.e-childContainer, .e-parentContainer", this._mouseHover);
                    proxy._on(proxy.element, "touchstart", ".e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                    proxy._on(proxy.element, "touchleave", ".e-gantt-milestone-container,.e-childContainer, .e-parentContainer", this._mouseLeave);                    
                    $(document.body).bind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
                    //proxy._on(proxy.element, "touchend", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._handleMouseUp);
                    proxy._on(proxy.element, "touchleave", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._handleMouseUp);
                    $(proxy._$bodyContainer).bind("touchend", $.proxy(proxy._handleMouseUp, proxy));
                    $(proxy._$bodyContainer).bind("touchleave", $.proxy(proxy._handleMouseUp, proxy));
                }
            }
                proxy._enableEditingEvents();
        },

        //Event append for editDialogOpen while perform double click action
        _enableEditingEvents: function () {

            var proxy = this,
                model = proxy.model;

            if (model.editSettings.allowEditing && model.editSettings.editMode === "normal") {
                    if (!ej.isTouchDevice)
                        proxy._on(this.element, "dblclick", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
                    else
                        proxy._on(this.element, "doubletap", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
            }else {
                    if (!ej.isTouchDevice)
                        proxy._off(this.element, "dblclick", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
                    else
                        proxy._off(this.element, "doubletap", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
                } 
        },


        //UPDATE Edit Settings
        updateEditSettings: function (edit) {

            var proxy = this;

            if (edit) {
                if (edit.editMode) 
                    proxy.model.editSettings.editMode = edit.editMode;
                if (!ej.isNullOrUndefined(edit.allowAdding))
                    proxy.model.editSettings.allowAdding = edit.allowAdding;
                if (!ej.isNullOrUndefined(edit.allowEditing))
                    proxy.model.editSettings.allowEditing = edit.allowEditing;
                if (!ej.isNullOrUndefined(edit.allowDeleting))
                    proxy.model.editSettings.allowDeleting = edit.allowDeleting;
                if (!ej.isNullOrUndefined(edit.beginEditAction))
                    proxy.model.editSettings.beginEditAction = edit.beginEditAction;
                proxy._enableEditingEvents();
            }
        },

        //Double click event handler for editing with editMode as normal
        _editdblClickHandler: function () {

            var proxy = this,
                model = this.model,
                args = {};

            if (proxy.model.editSettings.editMode === "normal" && !model.readOnly && proxy.model.editSettings.allowEditing) {
                args.requestType = ej.TreeGrid.Actions.BeginEdit;
                proxy._trigger("actionBegin", args);
            }

        },


        //Event to append RowHover effect
        _enableRowHover: function () {
            var proxy = this;
            if (proxy.model.enableRowHover)
                proxy._on(proxy.element, "mouseleave mouseenter",
                    "#ganttviewerbodyContent,.e-ganttviewerbodyContent tr,.e-ganttviewerbodyContent" + proxy._id,
                    proxy._rowHover);
            else
                proxy._on(proxy.element, "mouseleave mouseenter",
                    "#ganttviewerbodyContent,.e-ganttviewerbodyContent tr,.e-ganttviewerbodyContent" + proxy._id);
        },

        //MouseLeave event for striplines to remove tooltip
        _stripLineMouseLeave: function () {
            window.clearTimeout(this._tooltipTimer);
            this._clearTooltip();
        },

        //mouseHover event for stripline to render tooltip
        _stripLineMouseOver: function (e) {

            e.target.style.cursor = "pointer";
            var proxy = this, model = proxy.model,
                $target = $(e.target),
                parentNode, match,
                tooltiptable,
                tooltipbody,
                posx = 0, posy = 0;
            proxy._clearTooltip();
            if ($target.hasClass("e-striplinespan")) {
                parentNode = $target[0].parentNode;
            } else
                parentNode = $target[0];

            match = parentNode.id.match(/(\d+|[A-z]+)/g);

            if (e.type == "mouseenter" || e.type == "mousemove") {
                if (!e) e = window.event;
                if (e.originalEvent.pageX || e.originalEvent.pageY) {
                    posx = e.originalEvent.pageX;
                    posy = e.originalEvent.pageY;
                }
                else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                    posx = e.originalEvent.clientX + document.body.scrollLeft
                        + document.documentElement.scrollLeft;
                    posy = e.originalEvent.clientY + document.body.scrollTop
                        + document.documentElement.scrollTop;
                }

                tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "width": "auto" },
                    { 'cellspacing': '2px', 'cellpadding': '2px' });
                tooltipbody = ej.buildTag("tbody",
                    "<tr><td>" + model.stripLines[match[1]].day + "</td></tr><tr><td>" +
                        model.stripLines[match[1]].label + "</td></tr>", {}, {});

                tooltiptable.append(tooltipbody);
                proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                    { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1 }, {});
                model.cssClass && proxy._mouseHoverTooltip.addClass(model.cssClass);
                setTimeout(function () {
                    $(document.body).append(proxy._mouseHoverTooltip);
                    proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                }, 700);
            }
        },

        //Mouseup over tooltip 
        _tooltipMouseup: function () {
            var proxy = this;
            if (proxy._mouseTarget != null && !ej.isTouchDevice()) {
                proxy._handleMouseUp(proxy._mouseTarget);
            }
        },

        //removes all the tooltip in ganttchart
        _clearTooltip: function () {
            var proxy = this;
            proxy._mouseHoverTooltip && $(proxy._mouseHoverTooltip).remove();
            $('.e-editingtooltip').remove();
            $("#tooltipgantt").remove();
            $(".e-progressbartooltip").remove();
            proxy._mouseHoverTooltip = null;

        },

        //mousewheel action for zooming ganttchart
        _mouseWheel: function (e) {
            if (this.model.allowZooming) {
                var proxy = this, args = {},
                    delta = null;

                e = e.originalEvent;
                e.preventDefault();

                if (e.wheelDelta)
                    delta = -e.wheelDelta / 120;
                else if (e.detail)
                    delta = e.detail / 3;

                if (!delta)
                    return;
                args.requestType = "scroll";
                args.delta = delta;
                proxy._enbleZooming(args);
            }
        },


        //mouseHover event on taskbar right helper element
        _resizerrightOver: function (e) {

            var proxy = this,
                $target = e.target,
                div = $target.parentNode;

            if (proxy.model.allowGanttChartEditing == true&& proxy.model.readOnly == false) {
                if (this._mouseDown == false)
                    e.target.style.cursor = "w-resize";
                proxy._setEditingElements(div);
            }
        },


        //mouseLeave event for taskbar right helper element
        _resizerrightLeave: function () {

            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },


        //mouseHover event on taskbar left helper element
        _resizerleftOver: function (e) {

            var proxy = this,
                $target = e.target,
                div = $target.parentNode;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                if (this._mouseDown == false)
                    e.target.style.cursor = "e-resize";
                proxy._setEditingElements(div);
            }
        },


        //mouseLeave event for taskbar left helper element
        _resizerleftLeave: function () {
            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },


        //mouseHover event on taskbar progressbar helper element
        _progressresizerOver: function (e) {
            var proxy = this,
                $target = e.target,
                div = $target.parentNode;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                if (proxy.model.enableProgressBarResizing){
                    if (proxy._mouseDown == false && $($target).prev(".e-gantt-childtaskbar").has(".e-gantt-childtaskbar-progress").length > 0)
                        $target.style.cursor = "col-resize";
                    proxy._setEditingElements(div);
                }
                else
                    $target.style.cursor = "move";
            }
        },


        //mouseLeave event for progressbar helper element
        _progressresizerLeave: function () {
            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },


        _secondMouseOverConnectorPoint: function (e, mouseUp)
        {
            var proxy = this, row, recordIndexr, item;

            if ((proxy._mouseDown && proxy._falseLine) || (mouseUp && proxy._falseLine)) {

                var $target = $(e.target),
                  $ganttGridRows = proxy.getGanttChartRows(),
                  row = $target.closest('tr.e-ganttrowcell'),
                  recordIndexr = $ganttGridRows.index(row),
                  item = proxy.model.currentViewData[recordIndexr];

                var fromItem = proxy._editingItem;
                var toItem = item, predecessor, fullPredecessor, currentTarget,
                    predecessorText = proxy.model.predecessorText;

                if (proxy._prevItem.predecessorTarget === 'Start') {
                    predecessor = fromItem.taskId + 'S';
                } else if (proxy._prevItem.predecessorTarget === 'Finish') {
                    predecessor = fromItem.taskId + 'F';
                }

                if ($target.hasClass('e-connectortouchpoint')) {
                    if ($target.parent().hasClass('e-connectorpoint-left')) {
                        predecessor += 'S';
                        currentTarget = predecessorText["Start"];
                    }
                    else if ($target.parent().hasClass('e-connectorpoint-right')) {
                        predecessor += 'F';
                        currentTarget = predecessorText["Finish"];
                    }
                } else {
                    if ($target.hasClass('e-connectorpoint-left')) {
                        predecessor += 'S';
                        currentTarget = predecessorText["Start"];
                    }
                    else if ($target.hasClass('e-connectorpoint-right')) {
                        predecessor += 'F';
                        currentTarget = predecessorText["Finish"];
                    }
                }
                var $table, $td;
                //Append second item in predecessor tooltip
                //update tooltip on over of second connector point
                if (proxy._predecessorTooltip) {
                    $table = proxy._predecessorTooltip.find("table");
                    $td = $table.find("tbody").find("tr:eq(1)").find("td:eq(2)").text(toItem.taskName);
                    $td = $table.find("tbody").find("tr:eq(1)").find("td:eq(3)").text(currentTarget);
                }

                var args = {};
                args.requestType = "validatePredecessor";
                args.fromItem = fromItem;
                args.toItem = toItem;
                if (args.toItem.item[proxy.model.predecessorMapping]) {
                    fullPredecessor = args.toItem.item[proxy.model.predecessorMapping] + "," + predecessor;
                }
                else {
                    fullPredecessor = predecessor;
                }
                args.predecessor = predecessor;
                args.currentRecord = toItem;
                args.predecessorString = [];
                args.predecessorString.push(fullPredecessor);
                var validation = proxy._completeAction(args);
                //update tooltip after validation
                if (proxy._predecessorTooltip) {
                    $td = $table.find("tbody").find("tr:eq(0)").find("td:eq(0)");
                    if (validation) {
                        // $td.text("True");
                        $td.removeClass();
                        $td.addClass("e-predecessor-true");
                    } else {
                        //  $td.text("False");
                        $td.removeClass();
                        $td.addClass("e-predecessor-false");
                    }
                }

                //Here also update on moueup//same code is required
                if (mouseUp) {
                    return args;
                }
                
            }
        },
        //mouse enter event for left-connectorpoint-point

        _dragLeftOver:function(e)
        {
            var proxy = this,
              $target = e.target,
              div = $target.parentNode;
            if (e.type == "touchmove" && $(e.target).hasClass('e-connectortouchpoint'))
                div = $target.parentNode.parentNode;
            if (proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                if (this._mouseDown == false ) {
                    $target.style.cursor = "pointer";
                }
                proxy._setEditingElements(div);
            }
            if(!$(div).hasClass('e-parentContainer'))
                proxy._secondMouseOverConnectorPoint(e);

        },
        //mouse leave event for left-connectorpoint-point
        _dragLeftLeave: function (e) {

            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },

        //mouse enter event for right-connectorpoint-point

        _dragRightOver: function (e) {
            var proxy = this,
             $target = e.target,
             div = $target.parentNode;
            if (e.type == "touchmove" && $(e.target).hasClass('e-connectortouchpoint'))
                div = $target.parentNode.parentNode;
            if (proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                if (this._mouseDown == false) {
                    $target.style.cursor = "pointer";
                }
                proxy._setEditingElements(div);
            }
            if (!$(div).hasClass('e-parentContainer'))
                proxy._secondMouseOverConnectorPoint(e);
        },
        //mouse leave event for right-connectorpoint-point
        _dragRightLeave: function (e) {
            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },




        //adding styles for taskbar helper elements
        _setEditingElements: function (div) {
            var proxy = this, progressHandler;

            if (proxy._editingTarget && !proxy._editPredecessor && $(div).find(proxy._editingTarget).length == 0)
                return true;

            if ($(div).hasClass("e-childContainer")) {
                proxy._leftResizerGripper = div.querySelector(".taskbarresizer-left"); 
                proxy._rightResizerGripper = div.querySelector(".taskbarresizer-right"); 
                progressHandler = div.querySelector(".progressbarresizer-right");
                proxy._progressHandle = progressHandler && progressHandler.firstChild;
                proxy._progressHandleChild = progressHandler && progressHandler.childNodes[1];

                $(proxy._leftResizerGripper).addClass("gripper");
                $(proxy._rightResizerGripper).addClass("gripper");

                if (proxy.model.progressMapping && proxy.model.enableProgressBarResizing) {
                    $(proxy._progressHandle).addClass("e-progresshandle");
                    $(proxy._progressHandleChild).addClass("e-progresshandleafter");
                }
            }


            if (proxy.model.enablePredecessorEditing) {
                if ($(div).hasClass("e-childContainer") && proxy.model.predecessorMapping && !proxy._falseLine) {

                    proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-gantt-milestone-container") && proxy.model.predecessorMapping && !proxy._falseLine) {

                    proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-childContainer") && proxy.model.predecessorMapping && proxy._falseLine) {
                    proxy._childLeftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._childRightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._childLeftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._childRightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-gantt-milestone-container") && proxy.model.predecessorMapping && proxy._falseLine) {
                    proxy._childLeftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._childRightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._childLeftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._childRightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-parentContainer") && proxy.model.predecessorMapping && !proxy._falseLine) {

                    proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");

                    if($(div).hasClass("e-manualparenttaskbar"))
                    {
                        $(proxy._leftConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                        $(proxy._rightConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                    }

                }
            }
        },


        //removing styles for taskbar helper elements
        _removeEditingElements: function () {
            var proxy = this;
            $(proxy._leftResizerGripper).removeClass("gripper");
            $(proxy._rightResizerGripper).removeClass("gripper");

            if (proxy.model.progressMapping) {
                $(proxy._progressHandle).removeClass("e-progresshandle");
                $(proxy._progressHandleChild).removeClass("e-progresshandleafter");
            }


            //Remove Connector points in chart
            if (proxy.model.enablePredecessorEditing) {
                if (proxy.model.predecessorMapping && proxy._mouseDown == false) {

                    $(proxy._leftConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');
                    $(proxy._rightConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');
                    proxy._leftConnectorPoint = null;
                    proxy._rightConnectorPoint = null;
                }

                if (proxy.model.predecessorMapping && proxy._leftConnectorPoint !== null && proxy._mouseDown == true || proxy._childLeftConnectorPoint) {
                    $(proxy._childLeftConnectorPoint).removeClass("e-connectorpoint-hover");
                    $(proxy._childRightConnectorPoint).removeClass("e-connectorpoint-hover");
                    //remove curret target predecessor in tooltip    
                    if (proxy._predecessorTooltip) {
                        var $table = proxy._predecessorTooltip.find("table");
                        $table.find("tbody").find("tr:eq(1)").find("td:eq(2)").text("");
                        $table.find("tbody").find("tr:eq(1)").find("td:eq(3)").text("");
                        var $td = $table.find("tbody").find("tr:eq(0)").find("td:eq(0)").removeClass();
                        //$td.text("False");
                        $td.addClass('e-predecessor-false');
                    }
                }
            }
        },


        refreshHeight:function(){

            var proxy = this;
            proxy._$bodyContainer.ejScroller("refresh");
        },

        //mousedown event for ganttchart
        _mousedown: function (e) {
            if (e.which == 2 || e.which == 3) //2 for mouseWheel, 3 for rightClick button
                return false;
            var proxy = this,
                args = {};
            proxy._clearTooltip();
            proxy._mouseDown = true;
            
            //proxy._clearContextMenu();
            var $target = $(e.target),
            $ganttGridRows = proxy.getGanttChartRows(),
            row = $target.closest('tr.e-ganttrowcell'),
            recordIndexr = $ganttGridRows.index(row),
            item = proxy.model.currentViewData[recordIndexr],
            parentItem = item.parentItem,
            div = $target[0].parentNode,
            matched = jQuery.uaMatch(navigator.userAgent),
            model = this.model;

            if (ej.isNullOrUndefined(item)) {
                return;
            }

            if (e.type == "touchstart") {
                e.preventDefault();
                $(".e-connectortouchpoint").addClass("e-enableconnectortouchpoint");
            }

            proxy._editingItem = item;
            proxy._editingTarget = $target;
            proxy._allowExpandCollapse = true;

            if ($(div).hasClass("progressbarresizer-right")) {
                div = div.parentNode;
            }
            else if ($(div).hasClass("e-gantt-childtaskbar-progress")) {
                div = $(div).closest("div.e-childContainer");
            }
            else if ($(div).hasClass("progressbarhandler")) {
                div = $target.closest(".e-childContainer")[0];
            }
            else {
                div = $(div).closest("div.e-childContainer,div.e-parentContainer,.e-gantt-milestone,div.e-gantt-milestone-container");
            }
            if ($(div).hasClass("e-childContainer") ||
                ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass('e-parentContainer') || $(div).hasClass("e-gantt-milestone-container")) {

                $(row).addClass("e-editmode");
                proxy._mouseTarget = e;
            }

            if (proxy.model.allowGanttChartEditing && proxy.model.readOnly == false && ($(div).hasClass("e-childContainer")
                || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container") || $(div).hasClass('e-parentContainer'))) { //mouse down on drag points in child and milestone container and parent container also included 

                if (e.target.style.cursor == "e-resize" && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")))
                    || (e.type == "touchstart" && e.target.className == "taskbarresizer-left")) {
                    proxy._updateEditingType();
                    proxy._leftResizing = true;
                }

                if (e.target.style.cursor == "w-resize" && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-parentContainer"))
                    || (e.type == "touchstart" && e.target.className == "taskbarresizer-right")) {
                        proxy._updateEditingType();
                    proxy._rightResizing = true;

                }
                var prorgressResize = $(e.target).closest(".progressbarresizer-right");
                if ((e.target.style.cursor == "col-resize" || (prorgressResize.length && prorgressResize[0].style.cursor == "col-resize")) && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")))
                    || (e.type == "touchstart" && e.target.className == "progressbarresizer-right")) {
                    proxy._updateEditingType();
                    proxy._progressResizing = true;
                }
                var childTaskbar = $(e.target).closest("[style*='cursor: move']");
                if ((e.target.style.cursor == "move" || (childTaskbar.length && childTaskbar[0].style.cursor == "move")) && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container")) || $($target[0]).hasClass("e-gantt-manualparenttaskbar")) {
                    proxy._updateEditingType();
                    proxy._allowDragging = true;
                }
                if (e.target.style.cursor == "" && ((childTaskbar.length && childTaskbar[0].style.cursor == "") || childTaskbar.length==0) && ($(div).hasClass("e-childContainer")
                  || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container")) || (item.isAutoSchedule && $($target).hasClass("e-gantt-manualparenttaskbar"))) {
                    proxy._updateEditingType();
                    if (e.target.className == "taskbarresizer-left e-icon" || e.target.className == "taskbarresizer-left e-icon gripper")
                        proxy._leftResizing = true;
                    else if (e.target.className == "taskbarresizer-right e-icon" || e.target.className == "taskbarresizer-right e-icon gripper")
                        proxy._rightResizing = true;
                    else if ((e.target.className == "progressbarhandler e-progresshandle") || (e.target.className == "e-progresshandler-element")
                        || (e.target.className == "e-progresshandlerafter-element") || (e.target.className == "progressbarresizer-right"))
                        proxy._progressResizing = true;
                    else if ((e.target.className == "e-gantt-childtaskbar-progress  progressbar") || (e.target.className == "e-tasklabel") || (e.target.className == "e-gantt-childtaskbar") || (e.target.className == "e-gantt-milestone milestone-top") ||
                        (e.target.className == "e-gantt-milestone milestone-bottom") || $(e.target).hasClass("e-gantt-milestone") || $(e.target).closest(".e-gantt-milestone").length > 0 || $(e.target).closest(".e-gantt-childtaskbar").length > 0)
                        proxy._allowDragging = true;
                }

                // ON drag points initiate the false line and edit type for predecessor

                if (proxy.model.enablePredecessorEditing) {
                    if (e.target.style.cursor == "pointer" && ($(div).hasClass("e-childContainer")
                     || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container") || $(div).hasClass('e-parentContainer'))
                         || (e.type == "touchstart" && (e.target.className == "e-connectorpoint-right" || e.target.className == "e-connectorpoint-left"
                         || e.target.className == "e-connectorpoint-right e-connectorpoint-hover" || e.target.className == "e-connectorpoint-left e-connectorpoint-hover"))) {
                        proxy._updateEditingType();
                        proxy._editPredecessor = true;
                        if ($target.hasClass('e-connectorpoint-left') || $target.hasClass('e-connectorpoint-left e-connectorpoint-hover')) {
                            proxy._prevItem.predecessorTarget = 'Start';
                        }
                        else if ($target.hasClass('e-connectorpoint-right') || $target.hasClass('e-connectorpoint-right e-connectorpoint-hover')) {
                            proxy._prevItem.predecessorTarget = 'Finish';
                        }
                    }
                }




                if (!e) e = window.event;
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                    e.originalEvent.pageX = e.originalEvent.clientX;
                    e.originalEvent.pageY = e.originalEvent.clientY;
                }

                if (e.originalEvent.pageX || e.originalEvent.pageY) {
                    proxy._posX1 = proxy._currMousePosX = e.originalEvent.pageX;
                    proxy._posY1 = proxy._currMousePosY = e.originalEvent.pageY;
                    proxy.dragPosX = e.originalEvent.pageX;
                }
                else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                    proxy._posX1 = proxy.dragPosX = e.originalEvent.clientX + document.body.scrollLeft
                        + document.documentElement.scrollLeft;
                    proxy._posY1 = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;
                }
                else if (e.originalEvent && e.originalEvent.changedTouches
                    && e.originalEvent.changedTouches.length > 0) {
                    proxy._posX1 = proxy._currMousePosX = e.originalEvent.changedTouches[0].pageX;
                    proxy._posY1 = proxy._currMousePosY = e.originalEvent.changedTouches[0].pageY;
                    proxy.dragPosX = e.originalEvent.changedTouches[0].pageX;
                }

                proxy._prevItem.left = item.left;
                proxy._prevItem.status = item.status;
                proxy._prevItem.duration = item.duration;
                proxy._prevItem.startDate = item.startDate;
                proxy._prevItem.endDate = item.endDate;
                proxy._prevItem.width = item.width;

                proxy._parentCollectionPreviousValues = proxy._getParentCollectionPreviousValues(item);
                //For false line starting point
                if (proxy.model.enablePredecessorEditing) {
                    proxy._connectorPointX = proxy._currMousePosX - proxy._$bodyContent.offset().left;
                    proxy._connectorPointY = proxy._currMousePosY - proxy._$bodyContent.offset().top;
                }


                $(proxy._$bodyContainer).bind("mousemove", $.proxy(proxy.handleMouseMove, proxy));                
            }
             
                proxy._appendTooltip($target, recordIndexr);

            proxy._trigger("clearColumnMenu");
            //return false;
        },

        //Get previous parent item values
        _getParentCollectionPreviousValues: function (item) {
            var record = item,
                parentPrevItem = {},
                allParentRecords = [];
            do {               
                var parentItem = record.parentItem;
                if (!ej.isNullOrUndefined(parentItem)) {
                    parentPrevItem.left = parentItem.left;
                    parentPrevItem.status = parentItem.status;
                    parentPrevItem.duration = parentItem.duration;
                    parentPrevItem.startDate = parentItem.startDate;
                    parentPrevItem.endDate = parentItem.endDate;
                    parentPrevItem.width = parentItem.width;
                    parentPrevItem.index = parentItem.index;

                    if (!parentPrevItem.isAutoSchedule) {
                        parentPrevItem.manualLeft = parentItem.manualLeft;
                        parentPrevItem.manualStartDate = parentItem.manualStartDate;
                        parentPrevItem.manualEndDate = parentItem.manualEndDate;
                        parentPrevItem.manualDuration = parentItem.manualDuration;
                    }
                    allParentRecords.push(parentPrevItem);
                    record = parentItem;
                    parentPrevItem = {};
                }
            } while (record.parentItem);
            return allParentRecords;
        },

        handleMouseMove: function (e) {
            this._updateOnmouseMove(e);

        },


        //Handler for MouseUp event in ganttchart
        _handleMouseUp: function (e) {

            var proxy = this,
                args = {},
                $ganttGridRows = proxy.getGanttChartRows(),
                $target, row, recordIndexr = 0, item,
                x1 = proxy._posX1,
                y1 = proxy._posY1,
                x2, y2,
                tooltipElement, tooltiptable, tooltipbody;

            if (ej.isNullOrUndefined(e.pageX)) {
                x2 = e.originalEvent.changedTouches[0].pageX;
                y2 = e.originalEvent.changedTouches[0].pageY;
                if (!ej.isNullOrUndefined(proxy._predecessorTooltip))
                e.target = document.elementFromPoint(x2, y2);
            }
            else {
                x2 = e.pageX;
                y2 = e.pageY;
            }

            
            //Calculate and validate predecessor and draw connectorline after second connector point connects
            if (($(e.target).hasClass('e-connectorpoint-left') || $(e.target).hasClass('e-connectorpoint-right') || $(e.target).hasClass('e-connectortouchpoint'))
                && proxy._falseLine && !$(e.target).parent().hasClass('e-parentContainer')) {
                proxy._trigger("cancelEditCell");
                if ($(e.target).hasClass('e-connectortouchpoint'))
                    e.target = $(e.target).parent();
                var newArgs = proxy._secondMouseOverConnectorPoint(e, true);
                args.currentRecord = newArgs.currentRecord;
                args.fromItem = newArgs.fromItem;
                args.toItem = newArgs.toItem;
                args.predecessor = newArgs.predecessor;
                args.predecessorString = newArgs.predecessorString;
                args.requestType = "validatePredecessor";
                if (!proxy._trigger("actionBegin",args)) {
                    if (newArgs.predecessorValidation) {
                        newArgs.requestType = "drawConnectorLine";
                        proxy._completeAction(newArgs);
                    }
                }
            }

            if (proxy._editingTarget != null && proxy._editingItem != null) {
                $target = proxy._editingTarget,
                row = $target.closest('tr.e-ganttrowcell'),
                recordIndexr = $ganttGridRows.index(row),
                item = proxy._editingItem;
                if ($(row).hasClass("e-editmode")) {
                    $(row).removeClass("e-editmode");
                    proxy._mouseTarget = null;
                }
            }

            $("#ganttviewerbodyContianer" + proxy._id).unbind("mousemove");
            proxy._mouseDown = false;
            proxy._clearTooltip();
            if (x1 != x2 || y1 != y2) {
                proxy._editingTarget = null;
                proxy._editingItem = null;
                proxy._$ganttChartContainer[0].style.cursor = "auto";

                if (item != null && (proxy._allowDragging || proxy._leftResizing || proxy._rightResizing || proxy._progressResizing)) {
                    args.editingFields = { startdate: item.startDate, enddate: item.endDate, progress: item.status, duration: item.duration, durationunit: item.durationUnit };
                    args.data = item;
                    args.previousData = proxy._prevItem;
                    args.dragging = proxy._allowDragging;
                    args.leftResizing = proxy._leftResizing;
                    args.rightResizing = proxy._rightResizing;
                    args.progressResizing = proxy._progressResizing;
                    proxy._taskbarEdited(args);
                }

                if (args.cancel) {
                    proxy._getPrevItem(item, recordIndexr);
                    if (item.parentItem)
                        proxy._getParentPreviousValue();
                    if (proxy.model.predecessorMapping && (args.dragging || args.rightResizing || args.leftResizing)) {
                        args.requestType = "updateConnectors";
                        args.ganttRecord = item;
                        proxy._trigger("actionComplete", args);
                    }
                }
                proxy._updateEditingType();

                //Remove drag point and false lines on mouse up
                proxy._falseLine && proxy._falseLine.remove();
                proxy._falseLine = null;
                proxy._predecessorTooltip && proxy._predecessorTooltip.remove();
                proxy._predecessorTooltip = null;
                $(proxy._leftConnectorPoint).removeClass("e-connectorpoint-hover").removeClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                $(proxy._rightConnectorPoint).removeClass("e-connectorpoint-hover").removeClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                $(proxy._childRightConnectorPoint).removeClass("e-connectorpoint-hover");
                $(proxy._childLeftConnectorPoint).removeClass("e-connectorpoint-hover");
                proxy._leftConnectorPoint = null;
                proxy._rightConnectorPoint = null;
                proxy._childRightConnectorPoint = null;
                proxy._childLeftConnectorPoint = null;
                proxy._trigger("clearColumnMenu");
            }
            else {
                proxy._newXYPos = false;
                proxy._$ganttChartContainer[0].style.cursor = "auto";
                proxy._allowDragging = false;
                proxy._falseLine && proxy._falseLine.remove();
                proxy._falseLine = null;
                if (item && proxy.model.enableTaskbarTooltip) {

                    proxy._predecessorTooltip && proxy._predecessorTooltip.remove();
                    proxy._predecessorTooltip = null;

                    tooltipElement = {
                        ttipstartDate: this._getFormatedDate(item.startDate, this.model.dateFormat, this.model.locale),
                        ttipendDate: this._getFormatedDate(item.endDate, this.model.dateFormat, this.model.locale),
                        ttipduration: item.duration,
                        ttipprogress: item.status.toString(),
                        ttiptaskname: item.taskName,
                        ttipdurationunit: item.durationUnit
                    };


                    tooltiptable = ej.buildTag("table.e-tooltiptable", "", {}, { 'cellspacing': '5' });


                    if (!proxy.model.tooltipTemplate && !proxy.model.tooltipTemplateId) {
                        proxy.tooltipState = "";
                        tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](tooltipElement), {}, {});
                        tooltiptable.append(tooltipbody);
                        proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                           { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                        proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                        proxy._mouseHoverTooltip.innerHTML = "<table>" + tooltiptable[0].innerHTML + "</table>";

                        //Providing a time delay to render the tooltip to improve UI
                        proxy._tooltipTimer = setTimeout(function () {
                            $(document.body).append(proxy._mouseHoverTooltip)
                            proxy._updateTooltipPosition(proxy._mouseHoverTooltip, x2, y2 + 20);
                        }, 300);
                    }
                    else if (proxy.model.tooltipTemplate) {
                        proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                            { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                        proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "Template";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                        proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                        //Providing a time delay to render the tooltip to improve UI
                        proxy._tooltipTimer = setTimeout(function () {
                            $(document.body).append(proxy._mouseHoverTooltip)
                            proxy._updateTooltipPosition(proxy._mouseHoverTooltip, x2, y2 + 20);
                        }, 300);
                    }
                    else if (proxy.model.tooltipTemplateId) {
                        proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                               { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                        proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "TemplateID";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                        proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                        //Providing a time delay to render the tooltip to improve UI
                        proxy._tooltipTimer = setTimeout(function () {
                            $(document.body).append(proxy._mouseHoverTooltip);
                            proxy._updateTooltipPosition(proxy._mouseHoverTooltip, x2, y2 + 20);
                        }, 300);
                    }
                    $(proxy._mouseHoverTooltip).addClass("customTooltip");
                    proxy._trigger("clearColumnMenu");
                }
            }
            if (e.type == "touchend") {
                $(".e-connectortouchpoint").removeClass("e-enableconnectortouchpoint");
            }
        },

        getChildCount: function (record, count) {
            var currentRecord, proxy = this;
            if (!record.hasChildRecords)
                return 0;
            for (var i = 0; i < record.childRecords.length; i++) {
                currentRecord = record.childRecords[i];
                count++;
                if (currentRecord.hasChildRecords) {
                    count = proxy.getChildCount(currentRecord, count);
                }
            }
            return count;
        },

        // Mapping the critical path ID's, Index and Collections from gantt to ganttchart
        criticalDataMapping: function (criticalPathIds, condition, collection, collectionTaskId) {
            if (condition == true) {
                this.model.isCriticalPathEnable = true;
                if (!ej.isNullOrUndefined(criticalPathIds)) {
                    this.model.criticalPathCollection = criticalPathIds;
                    this.model.detailPredecessorCollection = collection;
                    this.collectionTaskId = collectionTaskId;
                }
            }
            if (condition == false) {
                this.model.isCriticalPathEnable = false;
            }
        },

        // Render color to the critical task.
        criticalPathColor: function (criticalPathIds, condition, collection, collectionTaskId) {
            if (condition == true) {
                if (!ej.isNullOrUndefined(criticalPathIds)) {
                    this._refresh();
                    if (!ej.isNullOrUndefined(collection))
                        this.criticalConnectorLine(criticalPathIds, collection, true, collectionTaskId);
                }
            }
            if (condition == false) {
                this.criticalConnectorLine(criticalPathIds, collection, false, collectionTaskId);
                this._refresh();
            }
        },

        // Render color to the critical connector lines.
        criticalConnectorLine: function (criticalPathIds, collection, condition, collectionTaskId) {
            if (condition == false) {
                this.element.find(".e-line").removeClass("e-criticalconnectorline");
                this.element.find(".connectorline-rightarrow").removeClass("e-criticalconnectorlinerightarrow");
                this.element.find(".connectorline-leftarrow").removeClass("e-criticalconnectorlineleftarrow");
            } else if (collection.length != 0) {
                var index = 0, currentdata, checking = [], checkint;
                for (var xx = 0; xx < this.model.criticalPathCollection.length; xx++) {
                    index = collectionTaskId.indexOf(this.model.criticalPathCollection[xx]);
                    currentdata = collection[index];
                    if (index != -1 && currentdata.to) {
                        checking = currentdata.to.split(",");
                        for (var m = 0; m < checking.length; m++) {
                            checkint = parseInt(checking[m]);
                            if (criticalPathIds.indexOf(checkint) != -1) {
                                this.element.find("#ConnectorLineparent" + currentdata.taskid + "child" + checkint).find(".e-line").addClass("e-criticalconnectorline");
                                this.element.find("#ConnectorLineparent" + currentdata.taskid + "child" + checkint).find(".connectorline-rightarrow").addClass("e-criticalconnectorlinerightarrow");
                                this.element.find("#ConnectorLineparent" + currentdata.taskid + "child" + checkint).find(".connectorline-leftarrow").addClass("e-criticalconnectorlineleftarrow");
                            }
                        }
                    }
                }
            }
        },

        //get the Expand status of GridRecord
        _getCollapsedParentItem: function (record) {
            var parentRecord = record.parentItem;
            if (parentRecord) {
                if (this._getExpandStatus(parentRecord) === true) {
                    return parentRecord;
                } else {
                    return this._getCollapsedParentItem(parentRecord);
                }
            }
            else
            {
                return null;
            }
        },
        /* scroll to selected record */
        updateScrollBar: function () {
            var proxy = this,
                model = proxy.model, horizontalScrollBarHeight,
                currentUpdatedRecords, recordIndex,
                isInViewPortAbove, isInViewPortBelow;

            currentUpdatedRecords = proxy.getExpandedRecords(model.updatedRecords);
            recordIndex = currentUpdatedRecords.indexOf(model.selectedItem);

            if (!model.selectedItem || recordIndex == -1)
                return;

            var rowTop = recordIndex * model.rowHeight,
                rowBottom = rowTop + model.rowHeight,
                scrollTop,
                containerWidth,
                scrollerExist = proxy._$bodyContainer.children(".e-content").length;

            if (scrollerExist)
                scrollTop = proxy._$bodyContainer.children(".e-content").scrollTop();
            else
                scrollTop = proxy._$bodyContainer.scrollTop();

            if (proxy._$bodyContainer.ejScroller("isHScroll") || proxy.element.find(".e-borderbox").length > 0) {
                horizontalScrollBarHeight = 18; /* default horizontal scrollbar height*/
            }

            isInViewPortAbove = (rowTop < scrollTop);
            isInViewPortBelow = (scrollTop + proxy._viewportHeight - horizontalScrollBarHeight) < rowBottom;

            if (isInViewPortAbove || isInViewPortBelow) {

                if ((rowTop + proxy._viewportHeight) > currentUpdatedRecords.length * model.rowHeight) {
                    rowTop = currentUpdatedRecords.length * model.rowHeight - proxy._viewportHeight;

                    if (isInViewPortBelow)
                        rowTop += horizontalScrollBarHeight;
                }
                proxy._$bodyContainer.ejScroller("scrollY", rowTop, true);

                if (model.enableVirtualization) {
                    proxy.focusGanttElement();
                }
            }
        },

        //In virtualization get expaned records from total record collection only
        getExpandedRecords: function (records) {
            var proxy = this;
            var resultRecord = records.filter(function (record) {
                return proxy._getExpandStatus(record) == true;
            });
            return resultRecord;
        },


        //keyPressed event for perform the keynavigate selection in gantt
        _keyPressed: function (action, target, arg, e) {

            var proxy = this,
                model = this.model,
                selectingRowIndex,
                lastRowIndex,
                updatedRecords = model.updatedRecords,
                expandedRecords = proxy.getExpandedRecords(updatedRecords),
                currentSelectingRecord;

            e.stopImmediatePropagation();
            e.preventDefault();

            if (!model.allowKeyboardNavigation)
                return true;

            switch (action) {

                case "downArrow":
                    if (updatedRecords.length > 0 && model.selectedItem) {
                        //get the last row index of the ganttchart control
                        lastRowIndex = updatedRecords.length - 1;
                        if (model.selectedRowIndex != lastRowIndex) {

                            selectingRowIndex = expandedRecords.indexOf(model.selectedItem);
                            currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                            selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                            if (currentSelectingRecord && selectingRowIndex <= lastRowIndex && !proxy._rowSelectingEventTrigger(model.selectedRowIndex, selectingRowIndex)) {
                                proxy.selectRows(selectingRowIndex);
                                proxy.focusGanttElement();
                                proxy.updateScrollBar();
                                proxy._rowSelectedEventTrigger(model.selectedRowIndex);
                            }
                        }
                    }
                    break;

                    //select the previous row by press down arrow key
                case "upArrow":
                    if (model.selectedRowIndex !== 0 && updatedRecords.length > 0 && model.selectedItem) {

                        selectingRowIndex = expandedRecords.indexOf(model.selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                        selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, selectingRowIndex)) {
                            proxy.selectRows(selectingRowIndex);
                            proxy.focusGanttElement();
                            proxy.updateScrollBar();
                            proxy._rowSelectedEventTrigger(model.selectedRowIndex);
                        }
                    }
                    break;

                    //select the first row while press the Home key
                case "firstRowSelection":
                    if (updatedRecords.length > 0) {
                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, 0)) {
                            proxy.selectRows(0);
                            proxy.focusGanttElement();
                            proxy.updateScrollBar();
                            proxy._rowSelectedEventTrigger(0);
                        }
                    }
                    break;

                case "lastRowSelection":

                    if (updatedRecords.length > 0) {

                        lastRowIndex = expandedRecords.length - 1;
                        currentSelectingRecord = expandedRecords[lastRowIndex];
                        selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, selectingRowIndex)) {
                            proxy.selectRows(selectingRowIndex);
                            proxy.focusGanttElement();
                            proxy.updateScrollBar();
                            proxy._rowSelectedEventTrigger(selectingRowIndex);
                        }
                    }
                    break;

                // expand the child task by press right arrow
                case "rightArrow":
                    var rowIndex = proxy.model.selectedRowIndex,
                    record = proxy.model.updatedRecords[rowIndex],
                    args = {},
                    isExpandCollapseEnabeled;
                    args.data = record;
                    args.recordIndex = rowIndex;
                    args.expanded = true;
                    if (record) {
                        if (!proxy._rowSelectingEventTrigger() && record.hasChildRecords && !record.expanded) {
                            if (rowIndex >= 0)
                                isExpandCollapseEnabeled = proxy._trigger("expanding", args);
                            if (model.enableVirtualization)
                                proxy.focusGanttElement();
                        }
                    }
                    break;
                //collapse the child task by press left arrow 
                case "leftArrow":
                    var rowIndex = proxy.model.selectedRowIndex,
                        record = proxy.model.updatedRecords[rowIndex],
                        args = {},
                        isExpandCollapseEnabeled;   
                        args.data = record;
                        args.recordIndex = rowIndex;
                        args.expanded = false;
                        if (record) {
                            if (!proxy._rowSelectingEventTrigger() && record.hasChildRecords && record.expanded) {
                                if (rowIndex >= 0)
                                    proxy._trigger("collapsing", args);
                                if (model.enableVirtualization)
                                    proxy.focusGanttElement();
                            }
                        }
                    break;
                case "deleteRecord":
                    if (model.editSettings.allowDeleting && model.selectedRowIndex >= 0) {
                        proxy._trigger("deleteRow");
                        proxy.focusGanttElement();
                    }
                    break;
                case "totalRowCollapse":
                    args = {};
                    args.requestType = "collapseAll";
                    proxy._trigger("expandAllCollapseAllRequest", args);
                    break;
                case "totalRowExpand":
                    args = {};
                    args.requestType = "expandAll";
                    proxy._trigger("expandAllCollapseAllRequest", args);
                    break;
            }

            return true;
        },

        _rowSelectingEventTrigger: function (previousIndex, recordIndex) {

            var proxy = this,
                model = proxy.model,
                args = {};
            if (model.selectionMode == "row") {
            args.previousIndex = previousIndex;
            args.recordIndex = recordIndex;
            return proxy._trigger('rowSelecting', args);
            }
        },

        _rowSelectedEventTrigger: function (index) {
            var proxy = this,
                args;
            if (proxy.model.selectionMode == "row") {
            args = {
                data: proxy.model.selectedItem,
                target: "ejGanttChart",
                recordIndex: index
            };
            proxy._trigger("rowSelected", args);
            }
        },

        _updateEditingType: function () {
            var proxy = this;
            proxy._leftResizing = false;
            proxy._allowDragging = false;
            proxy._rightResizing = false;
            proxy._progressResizing = false;
            proxy._editPredecessor = false;
        },
        /*Get Number of holidays in between startdate and enddate*/
        _getHolidaysCount: function (startDate, endDate) {
            var proxy = this,
            holidays = this.model.holidays, holidaysCount = 0;

            for (var count = 0; count < holidays.length; count++) {
                if (proxy._getDateFromFormat(holidays[count].day) >= startDate && proxy._getDateFromFormat(holidays[count].day) <= endDate) {
                    holidaysCount += 1;
                }
            }
            return holidaysCount;
        },

        //update offset values for predecessor
        updateConnectorLineOffset: function (item) {

            var parentGanttRecord,
                model = this.model,
                predecessor = item.predecessor,
                predecessorValue = [],
                parentStartDate,
                parentEndDate,
                childStartDate,
                childEndDate,
                includeWeekend = model.includeWeekend,
                weekendOffset, childGanttRecord, dayOffset;

            if (predecessor) {
                for (var i = 0; i < predecessor.length; i++) {
                    if ((predecessor[i].to === item['taskId'].toString())) {

                        parentGanttRecord = model.flatRecords[model.ids.indexOf(predecessor[i].from)];
                        childGanttRecord = model.flatRecords[model.ids.indexOf(predecessor[i].to)];
                        parentStartDate = new Date(parentGanttRecord.startDate);
                        parentEndDate = new Date(parentGanttRecord.endDate);
                        childStartDate = new Date(childGanttRecord.startDate);
                        childEndDate = new Date(childGanttRecord.endDate);

                        if (predecessor[i].predecessorsType == "FS") {

                            if (childGanttRecord.left < (parentGanttRecord.left + parentGanttRecord.width)) {

                                dayOffset = ((parentGanttRecord.left + parentGanttRecord.width)
                                    - childGanttRecord.left) / this.model.perDayWidth;

                                dayOffset = childGanttRecord.isMilestone == true ? (dayOffset - 1) : dayOffset;
                                predecessor[i].offset = Math.round(-dayOffset);
                            }
                            else if (childGanttRecord.left > (parentGanttRecord.left + parentGanttRecord.width)) {
                                dayOffset = (childGanttRecord.left - (parentGanttRecord.left + parentGanttRecord.width))
                                    / this.model.perDayWidth;

                                if (dayOffset >= 0)
                                    predecessor[i].offset = Math.round(dayOffset);
                            }
                            else {
                                predecessor[i].offset = 0;
                            }
                            /*WeekEnd , Holidays deduction*/
                            if (predecessor[i].offset > 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(parentEndDate, new Date(childStartDate));
                                    predecessor[i].offset -= weekEndDays;
                                }
                                predecessor[i].offset -= this._getHolidaysCount(parentEndDate, childStartDate);
                            } else if (predecessor[i].offset < 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(new Date(childStartDate), parentEndDate);
                                    predecessor[i].offset += weekEndDays;
                                }
                                predecessor[i].offset += this._getHolidaysCount(childStartDate, parentEndDate);
                            }

                        }
                        if (predecessor[i].predecessorsType == "SS") {
                            if (childGanttRecord.left < parentGanttRecord.left) {
                                dayOffset = ((parentGanttRecord.left) - childGanttRecord.left) / this.model.perDayWidth;
                                predecessor[i].offset = Math.round(-dayOffset);
                            }
                            else if (childGanttRecord.left > parentGanttRecord.left) {
                                dayOffset = (childGanttRecord.left - (parentGanttRecord.left)) / this.model.perDayWidth;
                                predecessor[i].offset = Math.round(dayOffset);
                            } else {
                                predecessor[i].offset = 0;
                            }

                            /* holidays and weekend days deduction*/
                            if (predecessor[i].offset > 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(parentStartDate, new Date(childStartDate));
                                    predecessor[i].offset -= weekEndDays;
                                }
                                predecessor[i].offset -= this._getHolidaysCount(parentStartDate, childStartDate);
                            } else if (predecessor[i].offset < 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(new Date(childStartDate), parentStartDate);
                                    predecessor[i].offset += weekEndDays;
                                }
                                predecessor[i].offset += this._getHolidaysCount(childStartDate, parentStartDate);
                            }
                        }
                        if (predecessor[i].predecessorsType == "SF") {
                            if ((childGanttRecord.left + childGanttRecord.width) < parentGanttRecord.left) {
                                dayOffset = ((parentGanttRecord.left) - (childGanttRecord.left + childGanttRecord.width))
                                    / this.model.perDayWidth;
                                predecessor[i].offset = Math.round(-dayOffset);
                            } else if ((childGanttRecord.left + childGanttRecord.width) > parentGanttRecord.left) {

                                dayOffset = ((childGanttRecord.left + childGanttRecord.width) -
                                    (parentGanttRecord.left)) / this.model.perDayWidth;
                                predecessor[i].offset = Math.round(dayOffset);
                            }
                            else {
                                predecessor[i].offset = 0;
                            }
                            /* holidays and weekend days deduction*/
                            if (predecessor[i].offset > 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(parentStartDate, new Date(childEndDate));
                                    predecessor[i].offset -= weekEndDays;
                                }
                                predecessor[i].offset -= this._getHolidaysCount(parentStartDate, childEndDate);
                            } else if (predecessor[i].offset < 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(new Date(childEndDate), parentStartDate);
                                    predecessor[i].offset += weekEndDays;
                                }
                                predecessor[i].offset += this._getHolidaysCount(childEndDate, parentStartDate);
                            }
                        }

                        if (predecessor[i].predecessorsType == "FF") {

                            if ((childGanttRecord.left + childGanttRecord.width) < (parentGanttRecord.left + parentGanttRecord.width)) {
                                dayOffset = ((parentGanttRecord.left + parentGanttRecord.width) -
                                    (childGanttRecord.left + childGanttRecord.width)) / this.model.perDayWidth;
                                predecessor[i].offset = Math.round(-dayOffset);
                            }
                            else if ((childGanttRecord.left + childGanttRecord.width) > (parentGanttRecord.left + parentGanttRecord.width)) {
                                dayOffset = ((childGanttRecord.left + childGanttRecord.width) -
                                    (parentGanttRecord.left + parentGanttRecord.width)) / this.model.perDayWidth;
                                predecessor[i].offset = Math.round(dayOffset);
                            }
                            else {
                                predecessor[i].offset = 0;
                            }

                            /* holidays and weekend days deduction*/
                            if (predecessor[i].offset > 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(parentEndDate, new Date(childEndDate));
                                    predecessor[i].offset -= weekEndDays;
                                }
                                predecessor[i].offset -= this._getHolidaysCount(parentEndDate, childEndDate);
                            } else if (predecessor[i].offset < 0) {
                                if (!includeWeekend) {
                                    var weekEndDays = this._calculateWeekendDays(new Date(childEndDate), parentEndDate);
                                    predecessor[i].offset += weekEndDays;
                                }
                                predecessor[i].offset += this._getHolidaysCount(childEndDate, parentEndDate);
                            }
                        } 
                        

                        if (predecessor[i].offset < 0) {
                            predecessorValue.push(predecessor[i].from + "" + predecessor[i].predecessorsType + ""
                                + predecessor[i].offset + "d");
                        }
                        else if (predecessor[i].offset >= 1) {
                            predecessorValue.push(predecessor[i].from + "" + predecessor[i].predecessorsType + "+"
                                + predecessor[i].offset + "d");
                        }
                        else {
                            predecessorValue.push(predecessor[i].from + "" + predecessor[i].predecessorsType);
                        }
                    }
                }
                if (predecessorValue.length > 0) {
                    item.item[model.predecessorMapping] = predecessorValue.join(',');
                    //this.refreshRow(itemIndex, false);
                }
            }
        },
        _calculateWeekendDays: function (fromDate, toDate)
        {
                var weekendDayCount = 0;
                fromDate = new Date(fromDate);

                while(fromDate < toDate){
                    fromDate.setDate(fromDate.getDate() + 1);
                    if(fromDate.getDay() === 0 || fromDate.getDay() == 6){
                        ++weekendDayCount ;
                    }
                }
                return weekendDayCount ;
        },

        //Returns the previous item properties
        _getPrevItem: function (item, index) {
            var proxy = this;
            item.left = proxy._prevItem.left;
            item.width = proxy._prevItem.width;
            item.startDate = proxy._prevItem.startDate;
            item.endDate = proxy._prevItem.endDate;
            item.duration = proxy._prevItem.duration;
            item.status = proxy._prevItem.status;
            item.progressWidth = this._getProgressWidth(item.width, item.status);
            this.refreshRow(index);
            var tempArgs = {};
            tempArgs.index = index;
            this._refreshRow(tempArgs);
        },

        //Returns the previous parent item properties
        _getParentPreviousValue: function () {
            var proxy = this, prevParent, index,
                model=proxy.model,
                length = proxy._parentCollectionPreviousValues.length;
            for (var i = 0; i < length; i++) {
                prevParent = proxy._parentCollectionPreviousValues[i];
                index = prevParent.index;
                parentItem = model.updatedRecords[index];
                parentItem.left = prevParent.left;
                parentItem.width = prevParent.width;
                parentItem.startDate = prevParent.startDate;
                parentItem.endDate = prevParent.endDate;
                parentItem.duration = prevParent.duration;
                parentItem.status = prevParent.status;
                parentItem.progressWidth = this._getProgressWidth(parentItem.width, parentItem.status);
                this.refreshRow(index);
                var tempArgs = {};
                tempArgs.index = index;
                this._refreshRow(tempArgs);
            }

        },

        //handler for left resizing taskbar item
        _enableLeftResizing: function (e, item) {

            var proxy = this, model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType;
            e.target.style.cursor = "e-resize";
            $(proxy._leftResizer).addClass("gripper");
            $(proxy._rightResizer).addClass("gripper");

            if (proxy.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                        item.left -= proxy._mousePosX;
                        item.width += proxy._mousePosX;
                }
            }
            else {
                proxy._mousePosX -= proxy.dragPosX;
                if ((item.left + 30) < (item.left + item.width) && ((item.left + proxy._mousePosX) <= (this._prevItem.left + this._prevItem.width))) {
                    item.left += proxy._mousePosX;
                    item.width -= proxy._mousePosX;
                }
            }
            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }
            if (scheduleHeaderType == scheduleHeaderValue.Day)
                item.width = item.width < proxy.model.perHourWidth ? proxy.model.perHourWidth : item.width;
            else if (scheduleHeaderType == scheduleHeaderValue.Hour)
                item.width = item.width < proxy.model.perMinuteWidth ? proxy.model.perMinuteWidth : item.width;
            else
                item.width = item.width < proxy.model.perDayWidth ? proxy.model.perDayWidth : item.width;
            item.progressWidth = proxy._getProgressWidth(item.width, item.status);
            /*Adjust left value according to width because of end of taskbar must be in same position while left resizing*/
            item.left = this._prevItem.left + this._prevItem.width - item.width;
            proxy._setItemPosition(item);
        },

        //handler for progressbar resizing
        _enableProgressResizing: function (e, item) {
            var proxy = this,
                diff,
                radius;
            e.target.style.cursor = "col-resize";
            $(proxy._leftResizer).addClass("gripper");
            $(proxy._rightResizer).addClass("gripper");

            if (proxy._progressResizer) {
                proxy._progressHandle = proxy._progressResizer && proxy._progressResizer.firstChild;
                proxy._progressHandleChild = proxy._progressResizer && proxy._progressResizer.childNodes[1];
            }

            if (proxy.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                    item.progressWidth -= proxy._mousePosX;
                }
            }
            else {
                proxy._mousePosX -= proxy.dragPosX;
                item.progressWidth += proxy._mousePosX;
            }
            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }
            item.progressWidth = item.progressWidth > item.width ? item.width : item.progressWidth;
            item.progressWidth = item.progressWidth < 0 ? 0 : item.progressWidth;

            diff = item.width - item.progressWidth;

            if (diff <= 4) {
                radius = 4 - diff;
            }
            else
                radius = 0;

            $(proxy._progressbarItem).css({
                "width": (item.progressWidth) + "px",
                "border-top-right-radius": radius + "px",
                 "border-bottom-right-radius": radius + "px"
            });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });

            $(proxy._progressHandle).addClass("e-progresshandle");
            $(proxy._progressHandleChild).addClass("e-progresshandleafter");
        },


        //handler for right resizing taskbar
        _enableRightResizing: function (e, item) {

            var proxy = this, model = this.model;
            e.target.style.cursor = "w-resize";

            $(proxy._leftResizer).addClass("gripper");
            $(proxy._rightResizer).addClass("gripper");

            if (proxy.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                    item.width -= proxy._mousePosX;
                }
            } else {
                proxy._mousePosX -= proxy.dragPosX;
                item.width += proxy._mousePosX;
            }
            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }

            if (model.scheduleHeaderSettings.scheduleHeaderType == ej.Gantt.ScheduleHeaderType.Day)
                item.width = item.width < proxy.model.perHourWidth ? proxy.model.perHourWidth : item.width;
            else if (model.scheduleHeaderSettings.scheduleHeaderType == ej.Gantt.ScheduleHeaderType.Hour)
                item.width = item.width < proxy.model.perMinuteWidth ? proxy.model.perMinuteWidth : item.width;
            else
                item.width = item.width < proxy.model.perDayWidth ? proxy.model.perDayWidth : item.width;
            if (!item.hasChildRecords) {
                item.progressWidth = proxy._getProgressWidth(item.width, item.status);
                $(proxy._tasknameContainer).css({ "left": (item.left) + "px", "width": (item.width) + "px" });
            }
            else
                $(proxy._manualRightResizer).css({ "left": (item.width - (parseInt(proxy._manualRightResizer.style.borderRightWidth.replace("px", "")))) + "px" });

            $(proxy._taskbarItem).css({ "left": (item.left) + "px", "width": (item.width) + "px" });
            $(proxy._progressbarItem).css({ "width": (item.progressWidth) + "px"});
            $(proxy._rightResizer).css({ "left": (item.left + item.width - proxy._resizerRightAdjust) + "px" });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });
            

            $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
            $(proxy._rightConnectorPoint).css({ "left": (item.left + item.width) + "px" });
        },


        //Handler for dragging taskbar
        _enableDragging: function (e, item) {
            var proxy = this;
            e.target.style.cursor = "move";

            if ($(e.target.parentNode).hasClass("e-parentContainer")) {
                proxy._allowExpandCollapse = false;
            }

            if (this.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                    item.left -= proxy._mousePosX;
                }
            } else {
                proxy._mousePosX -= proxy.dragPosX;
                item.left += proxy._mousePosX;
            }

            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }
            item.left = item.left < 0 ? 0 : item.left;

            $(proxy._taskbarItem).css({ "left": (item.left) + "px" });
            $(proxy._rightResizer).css({ "left": (item.left + item.width - proxy._resizerRightAdjust) + "px" });
            $(proxy._leftResizer).css({ "left": (item.left + 2) + "px" });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });
            $(proxy._tasknameContainer).css({
                "left": (item.left) + "px",
                "width": (item.width) + "px"
            });

            $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
            $(proxy._rightConnectorPoint).css({ "left": (item.left + item.width) + "px" });
        },


        //Append tooltip while editing taskbar
        _appendTooltip: function (target, index) {

            var proxy = this, tooltipElement, tooltiptable, tooltipbody,
                $target = $(target),
                model = this.model,
                item = proxy.model.currentViewData[index],
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                predecessorEditingTexts = proxy.model.predecessorEditingTexts;
            if (item != null) {
               
                var div = $target[0];
                if ($($target[0]).hasClass("progressbarresizer-right")) {
                    div = $target.closest(".e-childContainer")[0];
                }

                if ($(div).hasClass("e-parentContainer") || $(div).hasClass("e-childContainer")) {
                    proxy._editingContainer = div;
                    proxy._leftResizer = (proxy._editingContainer).querySelector(".e-connectorpoint-left");
                    proxy._taskbarItem = (proxy._editingContainer).querySelector(".taskbarresizer-left");
                    proxy._progressbarItem = (proxy._editingContainer).querySelector(".e-gantt-childtaskbar");
                    proxy._progressResizer = (proxy._editingContainer).querySelector(".e-gantt-childtaskbar-progress");
                    proxy._rightResizer = (proxy._editingContainer).querySelector(".progressbarresizer-right");
                }

                //Don't need to display the drag tooltip in Parent Taskbar
                if (this.model.enableTaskbarDragTooltip && (!$target.hasClass('e-parentContainer'))) {

                    if (this._progressResizing == true) {

                        proxy._$ganttChartContainer[0].style.cursor = "col-resize";

                        tooltiptable = ej.buildTag("table.e-tooltiptable", "", {}, { 'cellspacing': '2px', 'cellpadding': '2px' });
                        tooltipbody = ej.buildTag("tbody", "", {}, {});
                        tooltipbody[0].innerHTML = "<tr><td>" + columnHeaderTexts["status"] + " : " + item.status + "%</td></tr>";
                        tooltiptable.append(tooltipbody);
                        if (proxy.model.progressbarTooltipTemplate) {
                            proxy._progressBarTooltipID = ej.buildTag("div.e-progressbartooltip#progressbartooltip" + proxy._id + "", "",
                              {
                                  'position': 'absolute',
                                  'z-index': proxy._getMaxZIndex() + 1
                              }, {});
                            proxy.model.cssClass && proxy._progressBarTooltipID.addClass(proxy.model.cssClass);
                            //proxy.tooltipState = "editingTemplateID";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "progressbarTooltipTemplate"](item), {}, {});
                            proxy._progressBarTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                        }
                        else if (proxy.model.progressbarTooltipTemplateId) {
                            proxy._progressBarTooltipID = ej.buildTag("div.e-progressbartooltip#progressbartooltip" + proxy._id + "", "",
                                    {
                                        'position': 'absolute',
                                        'z-index': proxy._getMaxZIndex() + 1
                                    }, {});
                            proxy.model.cssClass && proxy._progressBarTooltipID.addClass(proxy.model.cssClass);
                            //proxy.tooltipState = "editingTemplate";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "progressbarTooltipTemplate"](item), {}, {});
                            proxy._progressBarTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                        }
                        else {
                            proxy._progressBarTooltipID = ej.buildTag("div.e-progressbartooltip#progressbartooltip" + proxy._id + "",
                                tooltiptable,
                                {
                                    'position': 'absolute',
                                    'z-index': proxy._getMaxZIndex() + 1
                                }, { 'onselectstart': 'return false' });
                            proxy.model.cssClass && proxy._progressBarTooltipID.addClass(proxy.model.cssClass);
                        }
                        if (proxy._progressBarTooltipID) {
                            $(document.body).append(proxy._progressBarTooltipID);
                            proxy._updateTooltipPosition(proxy._progressBarTooltipID, proxy._currMousePosX, proxy._currMousePosY, true);
                        }
                    }
                    // for apend tooltip for connector line
                    else if (this._editPredecessor === true && proxy.model.enablePredecessorEditing) {
                        var predecessorText = model.predecessorText;
                        if (proxy._predecessorTooltip === null) {
                            proxy._predecessorTooltip = ej.buildTag("div.e-tooltipganttpredecessor#predecessortooltip" + proxy._id + "",
                                      "",
                                      {
                                          "top": (proxy._currMousePosY + 10) + "px",
                                          "left": (proxy._currMousePosX + 10) + "px",
                                          'position': 'absolute',
                                          'z-index': proxy._getMaxZIndex() + 1
                                      }, { 'onselectstart': 'return false' });
                            proxy.model.cssClass && proxy._predecessorTooltip.addClass(proxy.model.cssClass);
                            tooltiptable = ej.buildTag("table.e-tooltiptable", "", {}, { 'cellspacing': '2px', 'cellpadding': '2px' });
                            tooltipbody = ej.buildTag("tbody", "", {}, {});
                            var innerHtml = "<tr><td class='e-predecessor-false'></td><td >" + predecessorEditingTexts["fromText"] + ":</td><td class='e-tooltiptaskname'>" + item.taskName + "</td><td>" + predecessorText[proxy._prevItem.predecessorTarget] + "</td> </tr>" +
                                "<tr><td></td><td>" + predecessorEditingTexts["toText"] + ":</td><td class='e-tooltiptaskname'></td><td></td></tr>";
                            $(tooltipbody).html(innerHtml);
                            tooltiptable.append(tooltipbody);
                            proxy._predecessorTooltip.append(tooltiptable);
                            $(document.body).append(proxy._predecessorTooltip);
                            proxy._updateTooltipPosition(proxy._predecessorTooltip, proxy._currMousePosX, proxy._currMousePosY);
                            //   proxy._$bodyContent.append(proxy._predecessorTooltip);
                        }
                    }
                    else if (proxy._leftResizing == true || proxy._rightResizing == true || proxy._allowDragging == true)
                    {
                    if (proxy._leftResizing == true) {
                        proxy._$ganttChartContainer[0].style.cursor = "e-resize";

                        tooltipElement = {
                            ttipstartDate: this._getFormatedDate(item.startDate, model.dateFormat, model.locale),
                            ttipduration: item.duration,
                            ttipdurationunit: item.durationUnit
                        };
                    } else if (proxy._rightResizing == true) {

                        proxy._$ganttChartContainer[0].style.cursor = "w-resize";

                        tooltipElement = {
                            ttipendDate: this._getFormatedDate(item.endDate, model.dateFormat, model.locale),
                            ttipduration: item.duration,
                            ttipdurationunit: item.durationUnit
                        };
                    } else if (proxy._allowDragging == true) {
                        proxy._$ganttChartContainer[0].style.cursor = "move";

                        tooltipElement = {
                            ttipstartDate: this._getFormatedDate(item.startDate, model.dateFormat, model.locale),
                            ttipendDate: this._getFormatedDate(item.endDate, model.dateFormat, model.locale),
                        };
                    }


                    tooltiptable = ej.buildTag("table.e-tooltiptable", "", {}, { 'cellspacing': '2px', 'cellpadding': '2px' });

                    if (proxy.model.taskbarEditingTooltipTemplate) {
                        proxy._taskbarEditingTooltipID = ej.buildTag("div.e-editingtooltip#editingtooltip" + proxy._id + "", "",
                           {
                               'position': 'absolute',
                               'z-index': proxy._getMaxZIndex() + 1
                           }, {});
                        proxy.model.cssClass && proxy._taskbarEditingTooltipID.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "editingTemplateID";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "editingTooltipTemplate"](item), {}, {});
                        proxy._taskbarEditingTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                    }
                    else if (proxy.model.taskbarEditingTooltipTemplateId) {
                        proxy._taskbarEditingTooltipID = ej.buildTag("div.e-editingtooltip#editingtooltip" + proxy._id + "", "",
                                {
                                    'position': 'absolute',
                                    'z-index': proxy._getMaxZIndex() + 1
                                }, {});
                        proxy.model.cssClass && proxy._taskbarEditingTooltipID.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "editingTemplate";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "editingTooltipTemplate"](item), {}, {});
                        proxy._taskbarEditingTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                    }

                    else {
                        proxy.tooltipState = "";
                        if (tooltipElement) {
                            tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "editingTooltipTemplate"](tooltipElement), {}, {});
                            tooltiptable.append(tooltipbody);
                        }

                        proxy._taskbarEditingTooltipID = ej.buildTag("div.e-editingtooltip#editingtooltip" + proxy._id + "", tooltiptable,
                            {
                                'position': 'absolute',
                                'z-index': proxy._getMaxZIndex() + 1
                            }, {});
                        proxy.model.cssClass && proxy._taskbarEditingTooltipID.addClass(proxy.model.cssClass);
                    }
                    if (proxy._taskbarEditingTooltipID) {
                        $(document.body).append(proxy._taskbarEditingTooltipID);
                        proxy._updateTooltipPosition(proxy._taskbarEditingTooltipID, proxy._currMousePosX, proxy._currMousePosY, true);
                    }
                }
                }
            }
        },

        _setItemPosition: function (item) {
            var proxy = this;
            $(proxy._leftResizer).css({ "left": (item.left + 2) + "px" });
            $(proxy._rightResizer).css({ "left": (item.left + item.width - proxy._resizerRightAdjust) + "px" });
            $(proxy._taskbarItem).css({
                "left": (item.left) + "px",
                "width": (item.width) + "px"
            });
            $(proxy._progressbarItem).css({
                "width": (item.progressWidth) + "px"
            });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });
            $(proxy._tasknameContainer).css({
                "left": (item.left) + "px",
                "width": (item.width) + "px"
            });

            $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
            $(proxy._rightConnectorPoint).css({ "left": (item.left + item.width) + "px" });


        },

        //returns the custom template for tooltip
        _getTemplate: function (template) {
            if (typeof (template) != "object") {
                var parser = $.parseHTML(this.model.tooltipTemplate);
                return parser[0];
            } else {
                var markup = $(template)[0].innerHTML;
                parser = $.parseHTML(markup);
                return parser[1];
            }
        },


        //Handles the mousemove after mousedown event
        _updateOnmouseMove: function (e) {

            var proxy = this, args = {}, posy,
                $target = (proxy._editingTarget) ? proxy._editingTarget : null,
                $ganttGridRows = proxy.getGanttChartRows(),
                row = ($target) ? $target.closest('tr.e-ganttrowcell') : null,
                recordIndexr = $ganttGridRows.index(row),
                item = proxy._editingItem,
                div = ($target) ? $target[0].parentNode : null;
            proxy._newXYPos = true;

            if ($(div).hasClass("progressbarresizer-right")) {
                div = div.parentNode;
            }
            else if ($(div).hasClass("e-gantt-childtaskbar-progress")) {
                div = $(div).closest("div.e-childContainer")[0];
            }
            else if ($(div).hasClass("progressbarhandler")) {
                div = $target.closest(".e-childContainer")[0];
            }
            else {
                div = $(div).closest("div.e-childContainer,div.e-parentContainer,.e-gantt-milestone,div.e-gantt-milestone-container")[0];
            }
            if (item != null) {
                proxy._trigger("cancelEditCell");
                args.editingFields = {
                    startdate: item.startDate,
                    enddate: item.endDate,
                    progress: item.status,
                    duration: item.duration,
                    durationunit: item.durationUnit
                };
                args.rowData = { rowData: item };

                proxy._taskbarEditing(args);

                if (!args.cancel) {

                    if (!e) e = window.event;

                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                        e.originalEvent.pageX = e.originalEvent.clientX;
                        e.originalEvent.pageY = e.originalEvent.clientY;
                    }

                    if (e.originalEvent.pageX || e.originalEvent.pageY) {
                        proxy._mousePosX = e.originalEvent.pageX;
                        posy = e.originalEvent.pageY;
                    } else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                        proxy._mousePosX = e.originalEvent.clientX + document.body.scrollLeft
                            + document.documentElement.scrollLeft;
                        posy = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;
                    }
                    else if (e.originalEvent.touches[0].pageX || e.originalEvent.touches[0].pageY) {
                        proxy._mousePosX = e.originalEvent.targetTouches[0].pageX;
                        posy = e.originalEvent.targetTouches[0].pageY;
                    }

                    if ($target.hasClass("e-gantt-milestone") || $(div).hasClass("e-gantt-milestone")) {
                        if ($(row).hasClass("e-editmode")) {
                            this._editMilestone(e);
                        }
                    } else {

                        if ($(div).hasClass("e-childContainer")) {
                            proxy._editingContainer = div;
                            proxy._leftResizer = proxy._editingContainer.querySelector(".taskbarresizer-left");
                            proxy._taskbarItem = proxy._editingContainer.querySelector(".e-gantt-childtaskbar");
                            proxy._progressbarItem = proxy._editingContainer.querySelector(".e-gantt-childtaskbar-progress");
                            proxy._progressResizer = proxy._editingContainer.querySelector(".progressbarresizer-right");
                            proxy._rightResizer = proxy._editingContainer.querySelector(".taskbarresizer-right");
                            if (proxy.model.predecessorMapping && proxy.model.enablePredecessorEditing) {
                                proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left"); 
                                proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                                if (proxy.model.allowGanttChartEditing) {
                                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                                }
                            }

                        }
                        else if (($(div).hasClass("e-parentContainer")) && !item.isAutoSchedule) {
                            proxy._editingContainer = div;
                            proxy._taskbarItem = proxy._editingContainer.querySelector(".e-gantt-manualparenttaskbar");
                            proxy._rightResizer = proxy._editingContainer.querySelector(".taskbarresizer-right");
                            proxy._manualRightResizer = proxy._editingContainer.querySelector(".e-gantt-manualparenttaskbar-right");
                        }

                        if ($(row).hasClass("e-editmode") &&
                            (($($target[0]).closest("e-gantt-manualparenttaskbar")) || $(div).hasClass("e-gantt-milestone-container") || $(div).hasClass("e-childContainer"))) {

                            if (proxy._leftResizing == true) {
                                proxy._enableLeftResizing(e, item);
                                proxy._updateEditedItem(item, "leftResizing");

                            } else if (proxy._progressResizing == true
                                && proxy.model.enableProgressBarResizing
                                && proxy.model.progressMapping) {
                                //Remove the progress bar status while resizing the progress bar status
                                
                                if (proxy._editingTarget.hasClass("e-progresshandlerafter-element") || proxy._editingTarget.hasClass("progressbarhandler e-progresshandle")
                                    || proxy._editingTarget.hasClass("e-progresshandler-element") || proxy._editingTarget.hasClass("progressbarresizer-right")) {
                                    proxy._editingTarget.prev(".e-gantt-childtaskbar").find(".e-tasklabel").text("");
                                }
                                proxy._enableProgressResizing(e, item);
                                proxy._updateEditedItem(item, "progressResizing");

                            } else if (proxy._rightResizing == true) {
                                proxy._enableRightResizing(e, item);
                                proxy._updateEditedItem(item, "rightResizing");

                            } else if (proxy._allowDragging == true) {
                                proxy._enableDragging(e, item);
                                proxy._updateEditedItem(item, "dragging");
                            }

                            //for predecessor , draw false line move the tooltip
                            else if (proxy._editPredecessor == true) {
                                //if ($(e.target).hasClass('e-connectortouchpoint')) {
                                //    e.target = $target.parent();
                                //}
                                proxy._drawFalseLine(e, item);
                            }
                        }
                    }
                    proxy._clearTooltip();
                    proxy._appendTooltip($target, recordIndexr);
                }
            }
            if (ej.isNullOrUndefined(e.pageX) && e.type == "touchmove" && proxy._predecessorTooltip) {
                var x2, y2;
                if (ej.isNullOrUndefined(e.pageX)) {
                    x2 = e.originalEvent.changedTouches[0].pageX;
                    y2 = e.originalEvent.changedTouches[0].pageY;
                    e.target = document.elementFromPoint(x2, y2);
                }
                else {
                    x2 = e.pageX;
                    y2 = e.pageY;
                }
                if ($(e.target).hasClass('e-connectorpoint-left') || $(e.target).hasClass('e-connectortouchpoint')) {
                    proxy._dragLeftOver(e);
                } else if ($(e.target).hasClass('e-connectorpoint-right')) {
                    proxy._dragRightOver(e);
                } else {
                    proxy._mouseLeave();
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                }
            }
        },


        //Handler for milestone editing
        _editMilestone: function (e) {

            var proxy = this,
                $target = proxy._editingTarget,
                div = ($target.hasClass("milestone-top") || $target.hasClass("milestone-bottom")) ? $target[0].parentNode: $target.closest(".e-gantt-milestone"),
                $ganttGridRows = proxy.getGanttChartRows(),
                row = $target.closest('tr.e-ganttrowcell'),
                recordIndexr = $ganttGridRows.index(row),
                item = proxy._editingItem;

            if (item != null) {

                if (!e) e = window.event;
                if (e.originalEvent.pageX || e.originalEvent.pageY) {
                    proxy._mousePosX = e.originalEvent.pageX;
                } else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                    proxy._mousePosX = e.originalEvent.clientX + document.body.scrollLeft
                        + document.documentElement.scrollLeft;
                }
                else if (e.originalEvent.touches[0].pageX || e.originalEvent.touches[0].pageY) {
                    proxy._mousePosX = e.originalEvent.targetTouches[0].pageX;
                }

                e.target.style.cursor = "move";
                if (proxy.dragPosX > proxy._mousePosX) {
                    proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                    if (item.left > 0) {
                        item.left -= proxy._mousePosX;
                    }
                } else {
                    proxy._mousePosX -= proxy.dragPosX;
                    item.left += proxy._mousePosX;
                }
                if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                    this.dragPosX = e.originalEvent.targetTouches[0].pageX;
                }
                else {
                    this.dragPosX = e.originalEvent.pageX;
                }
                item.left = item.left < 0 ? 0 : item.left;

                $(div).css({ "left": (item.left) + "px" });

                $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
                $(proxy._rightConnectorPoint).css({ "left": (item.left + proxy._milesStoneWidth) + "px" });

                proxy._updateEditedItem(item, "dragging");
                proxy._appendTooltip($target, recordIndexr);
            }
        },


        //Updates the edited item's values
        _updateEditedItem: function (ganttRecord, reason) {

            var proxy = this,
                model = proxy.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType,
                durationUnitValue = ej.Gantt.DurationUnit,
                projectStartDate = ganttRecord._getFormatedDate(model.projectStartDate, model.dateFormat, model.locale),
                projectStartDate = ganttRecord._getDateFromFormat(projectStartDate, model.dateFormat, model.locale),
                projectStartDateHours = ganttRecord.startDate.getHours(),
                projectStartDateMinutes = ganttRecord.startDate.getMinutes(),

               remainDays, day, remainDaysInDecimal, perDayHourUnit, offset, rem, startDate, endDate;

            switch (reason) {

                case 'dragging':
                    remainDays = ganttRecord.left % model.perDayWidth;
                    day = (ganttRecord.left - remainDays) / model.perDayWidth;
                    remainDaysInDecimal = remainDays / model.perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (scheduleHeaderType == scheduleHeaderValue.Week || scheduleHeaderType == scheduleHeaderValue.Month || scheduleHeaderType == scheduleHeaderValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                        }
                    }
                    if (scheduleHeaderType == scheduleHeaderValue.Day || scheduleHeaderType == scheduleHeaderValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = model.secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal != 1) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, model.workingTimeRanges, scheduleHeaderType);                                                           
                    ganttRecord.startDate = new Date(projectStartDate);

                    var editArgs = {};
                    editArgs.startDate = ganttRecord.startDate;
                    editArgs.duration = ganttRecord.duration;
                    editArgs.durationUnit = ganttRecord.durationUnit;
                    editArgs.record = ganttRecord;

                    proxy._calculateEndDate(editArgs);
                    ganttRecord.endDate = proxy._currentEditedRecord.endDate;
                    //update on dataSource
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    if (model.endDateMapping)
                        ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;

                    break;

                case 'leftResizing':
                    var editMode = "Resizing";
                    remainDays = ganttRecord.left % model.perDayWidth,                        
                    day = (ganttRecord.left - remainDays) / model.perDayWidth;
                    remainDaysInDecimal = remainDays / model.perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (scheduleHeaderType == scheduleHeaderValue.Week || scheduleHeaderType == scheduleHeaderValue.Month || scheduleHeaderType == scheduleHeaderValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                        }

                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                        }
                    }
                    if (scheduleHeaderType == scheduleHeaderValue.Day || scheduleHeaderType == scheduleHeaderValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = model.secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, model.workingTimeRanges, scheduleHeaderType);
                    ganttRecord.startDate = new Date(projectStartDate);
                    if (ganttRecord.startDate.getTime() == ganttRecord.endDate.getTime()
                        && ej.isNullOrUndefined(ganttRecord.isMilestone) && ganttRecord.isMilestone == false && ganttRecord.duration == 0) {
                        ganttRecord.duration = 1;
                    }
                    var editArgs = {};
                    editArgs.startDate = ganttRecord.startDate;
                    editArgs.endDate = ganttRecord.endDate;
                    editArgs.durationUnit = ganttRecord.durationUnit;
                    editArgs.record = ganttRecord;

                    proxy._calculateDuration(editArgs);
                    ganttRecord.duration = proxy._currentEditedRecord.duration;
                    //update on dataSource
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    if (model.durationMapping)
                        ganttRecord.item[model.durationMapping] = ganttRecord.duration;
                    break;

                case 'rightResizing':
                    var editMode = "Resizing";
                    if (scheduleHeaderType == scheduleHeaderValue.Day || scheduleHeaderType == scheduleHeaderValue.Hour) {
                        var tempStartDate = new Date(ganttRecord.startDate),
                            tempNewStartDate = new Date(ganttRecord.startDate), timeDiff, taskTempWidth;
                        tempNewStartDate.setHours(0, 0, 0, 0);
                        timeDiff = tempStartDate.getTime() - tempNewStartDate.getTime();
                        if (timeDiff > 0)
                            taskTempWidth = ganttRecord.width + ((timeDiff / (1000 * 60 * 60 * 24)) * model.perDayWidth);
                        else
                            taskTempWidth = ganttRecord.width;
                        remainDays = taskTempWidth % model.perDayWidth;
                        day = (taskTempWidth - remainDays) / model.perDayWidth;
                        perDayHourUnit = 24;
                    }
                    else {
                        remainDays = ganttRecord.width % model.perDayWidth;
                        day = (ganttRecord.width - remainDays) / model.perDayWidth;
                        perDayHourUnit = model.secondsPerDay / 3600;
                    }

                    remainDaysInDecimal = remainDays / model.perDayWidth,
                    startDate = new Date(ganttRecord.startDate);
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (scheduleHeaderType == scheduleHeaderValue.Week || scheduleHeaderType == scheduleHeaderValue.Month || scheduleHeaderType == scheduleHeaderValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                        } else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                        }
                    }

                    /*Calculating the remaining day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    endDate = ganttRecord._endDateUpdate(startDate, day - 1, inMinutes, model.workingTimeRanges, scheduleHeaderType);
                    ganttRecord.endDate = new Date(endDate);
                    var editArgs = {};
                        editArgs.startDate = startDate;
                        editArgs.endDate = endDate;
                        editArgs.durationUnit = ganttRecord.durationUnit;
                        editArgs.record = ganttRecord;
 
                        proxy._calculateDuration(editArgs);
                        ganttRecord.duration = proxy._currentEditedRecord.duration;

                    //update on datasource
                    if (model.endDateMapping)
                        ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;
                    if (model.durationMapping)
                        ganttRecord.item[model.durationMapping] = ganttRecord.duration;
                    break;

                case 'progressResizing':
                    ganttRecord.status = proxy._getProgressPercent(ganttRecord.width, ganttRecord.progressWidth);
                    if (model.progressMapping)
                        ganttRecord.item[model.progressMapping] = ganttRecord.status;
                    break;
            }
        },

        _calculateEndDate: function (args) {
            var proxy = this;
            return proxy._trigger("calculateEndDate", args);
        },
        _calculateDuration: function (args) {
            var proxy = this;
            return proxy._trigger("calculateDuration", args);
        },

        //false line implementation 
        _drawFalseLine: function (e, item) {

            var proxy = this,
                pageX = e.pageX,
                pageY = e.pageY,
                x1 = proxy._connectorPointX,
                y1 = proxy._connectorPointY,
                x2, y2;

            if (ej.isNullOrUndefined(e.pageX)) {
                x2 = e.originalEvent.changedTouches[0].pageX - proxy._$bodyContent.offset().left,
                y2 = e.originalEvent.changedTouches[0].pageY - proxy._$bodyContent.offset().top;
                pageX = Math.round(e.originalEvent.changedTouches[0].pageX);
                pageY = Math.round(e.originalEvent.changedTouches[0].pageY);
            }
            else{
                x2 = e.pageX - proxy._$bodyContent.offset().left,
                y2 = e.pageY - proxy._$bodyContent.offset().top;

            }
              
            //var sy=proxy._$bodyContainer.ejScroller("option", "scrollTop");
            //var sx = proxy._$bodyContainer.ejScroller("option", "scrollLeft");

            var length = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
            var angle = Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;
            var transform = 'rotate(' + angle + 'deg)';

            proxy._falseLine && proxy._falseLine.remove();

                proxy._falseLine = ej.buildTag("div.e-gantt-falseLine#ganttfalseline" + proxy._id, "", {}, {});
                proxy._falseLine.css({
                    'transform-origin': '0% 100%',
                    'right':'auto',
                    'position': 'absolute',
                    'transform': transform,
                    '-ms-transform':transform, /* IE 9 */
                    '-moz-transform':transform, /* Firefox */
                    '-webkit-transform':transform, /* Safari and Chrome */
                    '-o-transform':transform, /* Opera */
                    'border-top-width': '2px',
                    'border-top-style': 'dashed',
                    'z-index': '5'
                }).width(length - 3).offset({ left: x1, top: y1 });

                if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)) {
                    proxy._$bodyContent.append(proxy._falseLine);
                }

                //Change the position of predecesspr tooltip
                proxy._updateTooltipPosition(proxy._predecessorTooltip, pageX, pageY);
        },

        _mouseLeave: function () {

            var proxy = this;
            $(".progressbarresizer-right").css({ "background-image": "none" });
            window.clearTimeout(proxy._tooltipTimer);
            proxy._clearTooltip();
            

            if (this._mouseDown == false && proxy._newXYPos) {
                $(proxy._leftResizerGripper).removeClass("gripper");
                $(proxy._rightResizerGripper).removeClass("gripper");

                if (proxy.model.progressMapping) {
                    $(proxy._progressHandle).removeClass("e-progresshandle");
                    $(proxy._progressHandleChild).removeClass("e-progresshandleafter");
                }

                if (proxy.model.predecessorMapping && proxy.model.enablePredecessorEditing) {

                    $(proxy._leftConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');
                    $(proxy._rightConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');

                    
                    proxy._leftConnectorPoint = null;
                    proxy._rightConnectorPoint = null;
                }
            }
            else if (proxy._mouseDown && proxy._falseLine) {
                
                if (proxy.model.allowGanttChartEditing == true && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                    proxy._removeEditingElements();
                }
            }
        },

        _getMaxZIndex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute')
                    return parseInt($(e).css('z-index')) || 1;
            }));
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },

        _getOffsetRect: function (elem) {
            var box = elem.getBoundingClientRect(),
                body = document.body,
                docElem = document.documentElement,
                scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
                scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
                clientTop = docElem.clientTop || body.clientTop || 0,
                clientLeft = docElem.clientLeft || body.clientLeft || 0,
                top = box.top + scrollTop - clientTop,
                left = box.left + scrollLeft - clientLeft;
            return { top: Math.round(top), left: Math.round(left) }
        },
        /* edge detection for tooltip in ganttchart*/
        _updateTooltipPosition: function (tooltip, posx, posy, isEditingTooltip) {
            if (tooltip && tooltip.length > 0) {
                var proxy = this,
                    containerBoundary = proxy._getOffsetRect(proxy._$bodyContainer[0]),
                    topEnd = containerBoundary.top + proxy._$bodyContainer.height(),
                    leftEnd = containerBoundary.left + proxy._$bodyContainer.width(),
                    rowHeight = proxy.model.rowHeight, pos = 0;
                //Left update
                if (((posx + tooltip.width() + 30) > leftEnd)) {
                    pos = posx - tooltip.width() - 30;//while tooltip rendered outdide of Gantt chart
                    tooltip.css('left', ((pos) + 'px'));
                }
                else {
                    if (!isEditingTooltip)
                        tooltip.css('left', (posx + 15) + 'px');
                    else
                        tooltip.css('left', (posx) + 'px');
                }
                //Top update
                if (isEditingTooltip || ((posy + tooltip.height() + 30) > topEnd)) {
                    if (!isEditingTooltip)
                        pos = posy - tooltip.height() - 30;//while tooltip rendered outdide of Gantt chart
                    else
                        pos = posy - tooltip.height() - rowHeight;

                    tooltip.css('top', ((pos) + 'px'));
                } else {
                    tooltip.css('top', (posy + 10) + 'px');
                }
            }
        },

        _mouseHover: function (e) {

            
            var $target = $(e.target), proxy = this,
                posx = 0,
                posy = 0,
                $ganttChartRows = proxy.getGanttChartRows(),
                row = $target.closest('tr.e-ganttrowcell'),
                div = $target[0].parentNode,
                progressHandler,
                recordIndexr = $ganttChartRows.index(row),
                item = proxy.model.currentViewData[recordIndexr],
                tooltipElement, tooltiptable, tooltipbody;
            if (e.target.className == "e-parentContainer" || e.target.className == "e-gantt-milestone-container" || e.target.className == "e-childContainer")
            {
                return true;
            }

            if ($(div).hasClass("e-gantt-childtaskbar-progress")) {
                div = $(div).closest("div.e-childContainer")[0];
            }
            else if ($target.hasClass("e-tasklabel"))
                div = $target.closest(".e-childContainer")[0];
            else {
                div = $(div).closest("div.e-childContainer,div.e-parentContainer,.e-gantt-milestone,div.e-gantt-milestone-container")[0];
            }

          
            //clearing rendered tooltips in Gantt
            proxy._clearTooltip();
            
            if (!proxy._newXYPos) {
                proxy._newXYPos = true;
                proxy._mouseLeave();
            }
            if (proxy._rightResizing == false && proxy._leftResizing == false &&
                proxy._progressResizing == false && proxy._mouseDown == false) {

                if (proxy.model.allowGanttChartEditing && proxy.model.readOnly == false && ($target.is('.e-gantt-childtaskbar,.e-tasklabel, .e-gantt-manualparenttaskbar') || $target.closest(".e-gantt-childtaskbar").length)) {
                    e.target.style.cursor = "move";
                }


                if (e.type == "mouseenter" || e.type == "mousemove" || e.type == "touchstart") {

                    if (!e) e = window.event;
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                        e.originalEvent.pageX = e.originalEvent.clientX;
                        e.originalEvent.pageY = e.originalEvent.clientY;
                    }

                    if (e.originalEvent.pageX || e.originalEvent.pageY) {

                        posx = e.originalEvent.pageX;
                        posy = e.originalEvent.pageY;

                    }
                    else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                        posx = e.originalEvent.clientX + document.body.scrollLeft
                            + document.documentElement.scrollLeft;
                        posy = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;

                    }
                    else if (e.originalEvent && e.originalEvent.changedTouches
                        && e.originalEvent.changedTouches.length > 0) {
                        posx = e.originalEvent.changedTouches[0].pageX;
                        posy = e.originalEvent.changedTouches[0].pageY;
                    }
                    proxy._posX1 = posx;
                    proxy._posY1 = posy;
                  
                    if ($(div).hasClass("e-childContainer") && proxy.model.allowGanttChartEditing && proxy.model.readOnly == false) {
                        proxy._leftResizerGripper = div.querySelector(".taskbarresizer-left"); // New div is added for drag points so other elemnts are changed 
                        proxy._rightResizerGripper = div.querySelector(".taskbarresizer-right");
                        progressHandler = div.querySelector(".progressbarresizer-right");
                        proxy._progressHandle = progressHandler && progressHandler.firstChild;
                        proxy._progressHandleChild = progressHandler && progressHandler.childNodes[1];

                        $(proxy._leftResizerGripper).addClass("gripper");
                        $(proxy._rightResizerGripper).addClass("gripper");

                        if (proxy.model.progressMapping && proxy.model.enableProgressBarResizing) {
                            $(proxy._progressHandle).addClass("e-progresshandle");
                            $(proxy._progressHandleChild).addClass("e-progresshandleafter");
                        }
                    }

                    //Before Mouse Down  , Apply style for drag points in child cotainer and miles stone container
                    if (($(div).hasClass("e-childContainer") || $(div).hasClass("e-parentContainer")) && proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {

                        proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                        proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                        $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                        $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                        if ($(div).hasClass("e-parentContainer") && !item.isAutoSchedule) {                            
                            $(proxy._leftConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                            $(proxy._rightConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                        }
                    }
                    else if (($(div).hasClass("e-gantt-milestone") || $(div).hasClass("e-gantt-milestone-container")) && proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                        var milesStoneContainer = div.parentNode;
                        proxy._leftConnectorPoint = milesStoneContainer.querySelector(".e-connectorpoint-left");
                        proxy._rightConnectorPoint = milesStoneContainer.querySelector(".e-connectorpoint-right");
                        $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                        $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                    }


                    if (item && proxy.model.enableTaskbarTooltip && !ej.isTouchDevice() && !$($target).hasClass("e-connectorpoint-hover")) {
                        proxy._predecessorTooltip && proxy._predecessorTooltip.remove();
                        proxy._predecessorTooltip = null;

                        if (($($target).hasClass("e-gantt-parenttaskbar-innerdiv") || $($target[0].parentNode).hasClass("e-gantt-parenttaskbar-innerdiv")) && !item.isAutoSchedule) {
                            tooltipElement = {
                                ttipscheduleStartDate: this._getFormatedDate(item.manualStartDate, this.model.dateFormat, this.model.locale),
                                ttipscheduleEndDate: this._getFormatedDate(item.manualEndDate, this.model.dateFormat, this.model.locale),
                                ttipduration: item.manualDuration,
                                ttipprogress: item.status.toString(),
                                ttiptaskname: item.taskName,
                                ttipdurationunit: item.durationUnit
                            };
                        }
                        else if ($($target).hasClass("e-gantt-manualparenttaskbar") || $($target).hasClass("e-gantt-manualparenttaskbar-left") || $($target).hasClass("e-gantt-manualparenttaskbar-right") && !item.isAutoSchedule) {
                            tooltipElement = {
                                ttipstartDate: this._getFormatedDate(item.startDate, this.model.dateFormat, this.model.locale),
                                ttipsubtaskStartDate: this._getFormatedDate(item.manualStartDate, this.model.dateFormat, this.model.locale),
                                ttipendDate: this._getFormatedDate(item.endDate, this.model.dateFormat, this.model.locale),
                                ttipsubtaskEndDate: this._getFormatedDate(item.manualEndDate, this.model.dateFormat, this.model.locale),
                                ttipduration: item.duration,
                                ttiptaskname: item.taskName,
                                ttipdurationunit: item.durationUnit

                            };
                        }
                        else {
                            tooltipElement = {
                                ttipstartDate: this._getFormatedDate(item.startDate, this.model.dateFormat, this.model.locale),
                                ttipendDate: this._getFormatedDate(item.endDate, this.model.dateFormat, this.model.locale),
                                ttipduration: item.duration,
                                ttipprogress: item.status.toString(),
                                ttiptaskname: item.taskName,
                                ttipdurationunit: item.durationUnit
                            };
                        }

                        tooltiptable = ej.buildTag("table.e-tooltiptable", "", {}, { 'cellspacing': '5' });
                      

                        if (!proxy.model.tooltipTemplate && !proxy.model.tooltipTemplateId) {
                            proxy.tooltipState = "";
                            tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](tooltipElement), {}, {});
                            tooltiptable.append(tooltipbody);
                            proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                                { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                            proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                            proxy._mouseHoverTooltip.innerHTML = "<table>" + tooltiptable[0].innerHTML + "</table>";

                            //Providing a time delay to render the tooltip to improve UI
                            proxy._tooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._mouseHoverTooltip);
                                proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                            }, 700);
                        }
                        else if (proxy.model.tooltipTemplate) {
                            proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "","",
                                { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                            proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                            proxy.tooltipState = "Template";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                            proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                            //Providing a time delay to render the tooltip to improve UI
                            proxy._tooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._mouseHoverTooltip);
                                proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                            }, 700);
                        }
                        else if (proxy.model.tooltipTemplateId) {
                            proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                                { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                            proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                            proxy.tooltipState = "TemplateID";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                            proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                            //Providing a time delay to render the tooltip to improve UI
                            proxy._tooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._mouseHoverTooltip);
                                proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                            }, 700);
                        }
                        $(proxy._mouseHoverTooltip).addClass("customTooltip");
                    }
                }
            }
        },
        
        _createEditingTooltipTemplate: function () {

            var proxy = this,
                td,
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                durationUnitTexts = proxy.model.durationUnitTexts,
                editingTemplateId = proxy.model.taskbarEditingTooltipTemplateId,
                editingTemplate = proxy.model.taskbarEditingTooltipTemplate,
                helpers = {
                    _getStartDate: proxy._tooltipStartDate,
                    _getEndDate: proxy._tooltipEndDate,
                    _getTaskName: proxy._tooltipTaskName,
                    _getProgress: proxy._tooltipProgress,
                    _checkDuration: proxy._checkDuration
                };                                
            helpers["_" + proxy._id + "getDuration"] = $.proxy(proxy._tooltipDuration, proxy);

            $.views.helpers(helpers);

            
            if (editingTemplateId) {
                var parentTr = $("#" + editingTemplateId)[0].innerHTML;
            }
            else if (editingTemplate) {
                var parentTr = editingTemplate;
            }
            else {
                var parentTr = "<tr class='e-tooltip_rowcell'>";

                td = "{{if ~_getTaskName()}}" +
                    "<td class='e-tooltiptaskname' style='width:40px;text-align:left;' colspan='3';>{{:ttiptaskname}}</td>{{/if}}" +
                    "</tr><tr>" +
                    "{{if ~_getStartDate()}}" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["startDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipstartDate}}</td> {{/if}}" +
                    "</tr><tr>" +
                    "{{if ~_getEndDate()}}" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["endDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipendDate}}</td>{{/if}}" +
                    "</tr><tr>" +
                    "{{if ~_checkDuration()}}" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["duration"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:~_" + proxy._id + "getDuration(#data)}}</td>{{/if}}" +
                    "</tr><tr>" +
                    "{{if ~_getProgress()}}" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["status"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipprogress}}%</td>{{/if}}";

                parentTr += td;
                parentTr += "</tr>";
            }

            var templates = {};
            templates[proxy._id + "editingTooltipTemplate"] = parentTr;
            $.templates(templates);
        },

        _createProgressbarTooltipTemplate: function () {
            var proxy = this,
                  templateId = proxy.model.progressbarTooltipTemplateId,
            template = proxy.model.progressbarTooltipTemplate;

            if (templateId) {
                var parentTr = $("#" + proxy.model.progressbarTooltipTemplateId)[0].innerHTML;
            }
            else if (proxy.model.progressbarTooltipTemplate) {
                var parentTr = proxy.model.progressbarTooltipTemplate;
            }
            var templates = {};
            templates[proxy._id + "progressbarTooltipTemplate"] = parentTr;
            $.templates(templates);
        },


        //Template to create tooltip
        _createTooltipTemplate: function () {

            var proxy = this,
                td,
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                durationUnitTexts = proxy.model.durationUnitTexts,
                templateId = proxy.model.tooltipTemplateId,
                template = proxy.model.tooltipTemplate,
                helpers = {
                    _getStartDate: proxy._tooltipStartDate,
                    _getSubtaskStartDate: proxy._tooltipSubtaskStartDate,
                    _getScheduleStartDate: proxy._tooltipScheduleStartDate,
                    _getEndDate: proxy._tooltipEndDate,
                    _getSubtaskEndDate: proxy._tooltipSubtaskEndDate,
                    _getScheduleEndDate: proxy._tooltipScheduleEndDate,
                    _getTaskName: proxy._tooltipTaskName,
                    _getProgress: proxy._tooltipProgress,
                    _checkDuration: proxy._checkDuration
                };
                              
            helpers["_" + proxy._id + "getDuration"] = $.proxy(proxy._tooltipDuration, proxy);
            $.views.helpers(helpers);

            if (templateId ) {
                var parentTr = $("#" + proxy.model.tooltipTemplateId)[0].innerHTML;
            }
            else if (proxy.model.tooltipTemplate ) {
                var parentTr = proxy.model.tooltipTemplate;
            }
           
            else {
                var parentTr = "<tr class='e-tooltip_rowcell'>";

                td = "{{if ~_getTaskName()}}" +
                    "<td class='e-tooltiptaskname' style='width:40px;text-align:left;' colspan='3';>{{:ttiptaskname}}</td>{{/if}}" +
                    "</tr>" +
                    "{{if ~_getStartDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["startDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipstartDate}}</td> {{/if}}" +
                    "</tr>" +
                    "{{if ~_getSubtaskStartDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["subTasksStartDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipsubtaskStartDate}}</td></tr>{{/if}}" +

                    "{{if ~_getScheduleStartDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["scheduleStartDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipscheduleStartDate}}</td></tr>{{/if}}" +

                    "{{if ~_getEndDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["endDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipendDate}}</td>{{/if}}" +
                    "</tr>" +
                    "{{if ~_getSubtaskEndDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["subTasksEndDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipsubtaskEndDate}}</td></tr>{{/if}}" +

                    "{{if ~_getScheduleEndDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["scheduleEndDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipscheduleEndDate}}</td></tr>{{/if}}" +

                    "{{if ~_checkDuration()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["duration"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:~_" + proxy._id + "getDuration(#data)}}</td>{{/if}}" +
                    "</tr>" +
                    "{{if ~_getProgress()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["status"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipprogress}}%</td>{{/if}}";

                parentTr += td;
                parentTr += "</tr>";
            }

            var templates = {};
            templates[proxy._id + "tooltipTemplate"] = parentTr;
            $.templates(templates);
        },
        /*check duration is available in tooltip item*/
        _checkDuration: function () {
            return this.data.ttipduration;
        },
        _tooltipTaskName: function () {
            return this.data.ttiptaskname;
        },

        _tooltipProgress: function () {
            return this.data.ttipprogress;
        },

        _tooltipStartDate: function () {
            return this.data.ttipstartDate;
        },

        _tooltipSubtaskStartDate: function () {
            return this.data.ttipsubtaskStartDate;
        },
        _tooltipScheduleStartDate: function () {
            return this.data.ttipscheduleStartDate;
        },

        _tooltipEndDate: function () {
            return this.data.ttipendDate;
        },

        _tooltipSubtaskEndDate: function () {
            return this.data.ttipsubtaskEndDate;
        },

        _tooltipScheduleEndDate: function () {
            return this.data.ttipscheduleEndDate;
        },
        /*get localized text of duration value*/
        _tooltipDuration: function (data) {
            var val = "";
            if (data.ttipduration != null && data.ttipduration != undefined)
                val += data.ttipduration + " ";
            if (data.ttipdurationunit != null && data.ttipdurationunit != undefined) {
                var multiple = data.ttipduration != 1;
                if (data.ttipdurationunit == "day")
                    val += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                else if (data.ttipdurationunit == "hour")
                    val += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                else
                    val += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
            }
            return val;
        },

        _getDurationUnits: function (data) {
            var proxy = this;
            if (proxy.model.durationUnit == ej.Gantt.DurationUnit.Hour)
                return "hours";
            else if (proxy.model.durationUnit == ej.Gantt.DurationUnit.Minute)
                return "minutes";
            else
                return "days";

        },

        _cellClickHandler: function (e) {
            var $target = $(e.target),
                $row = $target.closest('tr.e-ganttrowcell'),
                proxy = this,
                model = this.model,
                args = {},
                selectedItem,
                index,
                rowIndex,
                div = $target[0],
                $ganttGridRows = proxy.getGanttChartRows();

            rowIndex = index = $ganttGridRows.index($target.parent());

            if (index == -1) {
                rowIndex = index = $ganttGridRows.index($row);
            }

          
            if (($(div).hasClass("e-parentTask") || $(div).closest(".e-parentTask").length > 0) && !$target.hasClass("e-connectorpoint-left") && !$target.hasClass("e-connectorpoint-right")) { // here check drag point class

                var currentRecordIndex = $ganttGridRows.index($row),
                    selectedItem = model.currentViewData[currentRecordIndex],
                recordIndex = model.updatedRecords.indexOf(selectedItem);
                if (proxy._allowExpandCollapse && selectedItem && selectedItem.hasChildRecords) {
                    /*cancel edited cell in treegrid on mouse down event on parent task bar*/
                    proxy._trigger("cancelEditCell");
                    if (model.selectedRowIndex !== recordIndex && model.allowSelection && recordIndex !== -1) {

                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, recordIndex)) {
                            proxy.selectRows(recordIndex);
                            proxy._rowSelectedEventTrigger(recordIndex);
                        }
                    }
                    proxy._expandCollapse(currentRecordIndex);
                }
            }
            else if (index != -1 && model.allowSelection) {
                selectedItem = model.currentViewData[index];
                index = model.updatedRecords.indexOf(selectedItem);
                if (model.selectionMode == "row") {                    
                if (proxy._rowSelectingEventTrigger(model.selectedRowIndex, index))
                    return;
                proxy.selectRows(index);
                proxy.focusGanttElement();
                proxy._rowSelectedEventTrigger(index);
            }
                if (model.selectionMode == "cell")
                    proxy.model.selectedItem = selectedItem;
            }
            if (model.taskbarClick) {
                if (!$target.is(".e-childContainer,.e-gantt-milestone-container,.e-parentContainer")) {
                    var taskElement = $target.closest(".e-childContainer,.e-gantt-milestone-container,.e-parentContainer");
                    if (taskElement.length) {
                        var args = {}, data;
                        data = model.currentViewData[rowIndex];
                        rowIndex = model.updatedRecords.indexOf(data);
                        args.data = data;
                        args.index = rowIndex;
                        args.taskbarElement = taskElement[0];
                        args.target = $target[0];
                        this._trigger("taskbarClick", args);
                    }
                }
            }
        },

        getRowByIndex: function (from, to) {
            try {
                var proxy = this;

                var gridRows = proxy.getGanttChartRows(),
                    $gridRows = $(gridRows),
                    $row = $();

                if (proxy.model.enableVirtualization) {
                    var recordstart = proxy.model.updatedRecords[from];
                    from = proxy.model.currentViewData.indexOf(recordstart);
                }

                if (ej.isNullOrUndefined(to)) {
                    if (proxy.model.enableVirtualization) {
                        var recordend = proxy.model.updatedRecords[to];
                        to = proxy.model.currentViewData.indexOf(recordend);
                    }
                    return $(gridRows[from]);
                } else {
                    return $($gridRows.slice(from, to));
                }
            } catch (e) {
                return $();
            }
        },

        selectRows: function (index) {
            var proxy = this,
                model = this.model,
                $ganttGridRows = proxy.getGanttChartRows(),
                selectedItem;
            if (!model.allowSelection)
                return;
            if (model.selectionMode == "cell")
                return;
            if (proxy.prevSelectedItem) {
                proxy.prevSelectedItem.isSelected = false;
            }
            $ganttGridRows.removeClass("e-gantt-mouseclick");
            var $row = proxy.getRowByIndex(index);
            if (proxy.model.allowSelection)
                $row.addClass("e-gantt-mouseclick");
            proxy.model.selectedRowIndex = index;
            selectedItem = proxy.model.updatedRecords[index];
            if (selectedItem)
                selectedItem.isSelected = true;
            proxy.model.selectedItem = selectedItem;
            proxy.prevSelectedItem = selectedItem;
        },

        updateSelectedItem: function (recordIndex) {
            var proxy = this,
                $ganttGridRows = $(proxy.getGanttChartRows());

            $ganttGridRows.removeClass("e-gantt-mouseclick");
            proxy.model.updatedRecords[recordIndex].isSelected = true;
            proxy.model.selectedItem = proxy.model.updatedRecords[recordIndex];
            this._refresh();
            proxy._rowSelectedEventTrigger(recordIndex);

        },


        ganttrowHover: function (index) {
            var proxy = this;
            if (!proxy.model.enableRowHover)
                return;
            var $gridRows =proxy.getGanttChartRows();
            $gridRows.removeClass("e-gantt_mousehover").addClass("e-gantt_mouseleave");
            $($gridRows[index]).addClass("e-gantt_mousehover").removeClass("e-gantt_mouseleave");
        },

        _rowHover: function (e) {
            var proxy = this,
                $target = $(e.target),
                $gridRows,
                args = {},
                index,
                row;
            if (!proxy.model.enableRowHover)
                return false;
            $gridRows = $(proxy.getGanttChartRows());
            index = $gridRows.index($target.parent());
            if (index == -1) {
                row = $target.closest('tr.e-ganttrowcell');
                index = $gridRows.index(row);
            }
            args.index = index;

            if (e.type == "mouseenter") {
                args.reason = "mouseenter";
                proxy.addRowHover(index);
            } else {
                args.reason = "mouseleave";
                proxy.removeRowHover();
            }
            proxy._trigger("rowHover", args);
            return false;
        },

        addRowHover: function (index) {
            var $gridRows = this.getGanttChartRows();
            if (index != null)
                index != -1 && $($gridRows[index]).addClass("e-enablerowhover");
        },

        removeRowHover: function () {
            var $gridRows = this.getGanttChartRows();
            $gridRows.removeClass("e-enablerowhover");
        },

        updateHeight: function (height) {
            var proxy = this,
                model = proxy.model;
            proxy._setScrollTop();
            proxy._containerHeight = height;
            $("#ganttviewerbodyContent" + proxy._id + "").css({
                 "height": proxy._containerHeight + "px"
            });

            if (model.stripLines) {
                $(proxy.element).find(".e-stripline,.e-stripLines").css({ height: height + "px" });
            }

            if (model.holidays) {
                $(proxy.element).find(".e-holidays,.e-holiday").css({ height: height + "px" });
            }
            $(".e-secondary_canvas").css({ height: height + "px" });
            $(proxy.element).find(".e-weekends").css({ height: height + "px" });

            var holidayLableSelector = ".e-holiday-label";
            /* for rotate holiday lable in ie8 */
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                holidayLableSelector = ".e-holiday-label-ie8";
            }

            if (height < proxy._viewportHeight) {
                if (height <= model.rowHeight) {
                    $(proxy.element).find(holidayLableSelector).css({ top: -height - 30 });
                }
                else
                    $(proxy.element).find(holidayLableSelector).css({ top: height / 2 });
            }
            else
                $(proxy.element).find(holidayLableSelector).css({ top: proxy._viewportHeight / 2 });
            
            //To enable the Horizontal scroller when all the records were deleted
            if (height == 0) {
                proxy._$bodyContent.css({ "height": "1px" });
            }
            proxy._$bodyContainer.ejScroller("refresh");

            /*While refreshing scroller the gantt chart container height is increased by 16px.
             When horizontal scrollbar not avaiable in gantt chart side.
             So check the chart container height and view port height.
             If it is varies set the view port height to chart container height*/
            if(parseInt(proxy._$bodyContainer.css("height")) != proxy._viewportHeight)
                proxy._$bodyContainer.css("height", proxy._viewportHeight);
        },


        //method to trigger actioncomplete event
        _completeAction: function (args) {
            var proxy = this;
            args.vscrollExsist = proxy._$bodyContainer.ejScroller("isVScroll");
            proxy._trigger("actionComplete", args);
            if (args.requestType === "validatePredecessor") {
                return args.predecessorValidation;
            }
        },


        //method to trigger taskbarediting event
        //to apply changes during taskbar editing
        _taskbarEditing: function (args) {
            var proxy = this;
            proxy._trigger("taskbarEditing", args);
        },


        //method to trigger taskbaredited event
        //to apply changes after taskbar edited
        _taskbarEdited: function (args) {
            var proxy = this;
            proxy._trigger("taskbarEdited", args);
        },


        //method to trigger querytaskbarinfo 
        //to apply changes at load time
        _queryTaskbarinfo: function (args) {
            this._trigger("queryTaskbarInfo", args);
            this._updateTaskbarItems(args);
        },


        //method to trigger refresh row
        _refreshRow: function (args) {
            var proxy = this;
            proxy._trigger("refreshRow", args);
        },

        _enbleZooming: function (args) {
            var proxy = this;
            proxy._trigger("zooming", args);
        },

        _updateManualTaskbarItem: function(args, taskElement){

            var parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv"),
                        parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress"),
                        parentOuterTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar"),
                        parentLeftOuterTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar-left"),
                        parentRightOuterTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar-right"),
                        parentRightResizer = taskElement.querySelector(".taskbarresizer-right"),
                        parentTaskbarStyle = parentTaskbar.style,
                        parentProgressbarStyle = parentProgressbar && parentProgressbar.style,
                        parentOuterTaskbarStyle = parentOuterTaskbar && parentOuterTaskbar.style,
                        parentLeftOuterTaskbarStyle = parentLeftOuterTaskbar && parentLeftOuterTaskbar.style,
                        parentRightOuterTaskbarStyle = parentRightOuterTaskbar && parentRightOuterTaskbar.style,
                        parentRightResizerStyle = parentRightResizer && parentRightResizer.style,
                        model = this.model;

            var taskbarHeight, tHeight;
            if (model.renderBaseline) {
                taskbarHeight = model.taskbarHeight - 9;
            } else {
                taskbarHeight = model.taskbarHeight - 10;
            }
            tHeight = taskbarHeight / 5;                                                          
            
            if (!ej.isNullOrUndefined(args.manualParentTaskbarBackground) && parentOuterTaskbarStyle.backgroundColor != args.manualParentTaskbarBackground) {
                parentOuterTaskbarStyle.backgroundColor = args.manualParentTaskbarBackground;
                parentLeftOuterTaskbarStyle.borderColor = args.manualParentTaskbarBackground;
                parentRightOuterTaskbarStyle.borderColor = args.manualParentTaskbarBackground;
            }
            parentOuterTaskbarStyle.width = args.data.width + "px";
            parentOuterTaskbarStyle.left = args.data.left + "px";
            parentRightOuterTaskbarStyle.left = (args.data.width - parseInt(tHeight)) + "px";
            parentRightResizerStyle.left = (args.data.width - parseInt(tHeight)) + "px";            
                      
            if (args.data.width == args.data.manualWidth && args.data.left == args.data.manualLeft) {
                parentProgressbarStyle.width = args.data.progressWidth - (tHeight * 2) + "px";
                parentTaskbarStyle.width = args.data.manualWidth - (tHeight * 2) + "px";
                parentTaskbarStyle.left = args.data.manualLeft + tHeight + "px";
            }
            else if (args.data.left == args.data.manualLeft) {
                parentTaskbarStyle.left = args.data.manualLeft + tHeight + "px";
                parentProgressbarStyle.width = args.data.progressWidth - (tHeight) + "px";
                parentTaskbarStyle.width = args.data.manualWidth - (tHeight) + "px";
            }
            else {
                parentProgressbarStyle.width = args.data.progressWidth + "px";
                parentTaskbarStyle.width = args.data.manualWidth + "px";
                parentTaskbarStyle.left = args.data.manualLeft + "px";
            }
        },
        //Updates taskbar items styles when chart loads
        _updateTaskbarItems: function (args) {

            var $ganttChartRows = this.getGanttChartRows(),
                index = this.model.currentViewData.indexOf(args.data),
                taskbarContainer = $ganttChartRows[index], taskElement, mileStone, baseline;

            if (taskbarContainer) {
                             
                if ($(taskbarContainer).find(".e-gantt-milestone-container").closest('div').length > 0)
                    mileStone = $(taskbarContainer).find(".e-gantt-milestone-container").closest('div')[0];

                if ($(taskbarContainer).find(".e-baselinebar").closest('div').length > 0)
                    baseline = $(taskbarContainer).find(".e-baselinebar").closest('div')[0];

                if ($(taskbarContainer).find(".e-parentContainer").closest('div').length > 0) {
                    var taskElement = $(taskbarContainer).find(".e-parentContainer").closest('div')[0],
                        parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv"),
                        parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress"),
                        parentTaskbarStyle = parentTaskbar.style,
                        parentProgressbarStyle = parentProgressbar && parentProgressbar.style;

                    if (parentTaskbarStyle.backgroundColor != args.parentTaskbarBackground) {
                        parentTaskbarStyle.backgroundColor = args.parentTaskbarBackground;
                    }
                    if (parentProgressbarStyle && parentProgressbarStyle.backgroundColor != args.parentProgressbarBackground) {
                        parentProgressbarStyle.backgroundColor = args.parentProgressbarBackground;
                    }
                    if (parentTaskbarStyle.borderColor != args.parentTaskbarBorder) {
                        parentTaskbarStyle.borderColor = args.parentTaskbarBorder;
                    }
                    if (parentProgressbarStyle && parentProgressbarStyle.borderColor != args.parentProgressbarBorder) {
                        parentProgressbarStyle.borderColor = args.parentProgressbarBorder;
                    }
                    if (!args.data.isAutoSchedule && args.data.hasChildRecords) {                                                                        
                        this._updateManualTaskbarItem(args, taskElement);                        
                    }
                    if (parentProgressbarStyle && parentProgressbarStyle.borderColor != args.parentProgressbarBorder) {
                        parentProgressbarStyle.borderColor = args.parentProgressbarBorder;
                    }

                } else if ($(taskbarContainer).find(".e-childContainer").closest('div').length > 0) {
                    var taskElement = $(taskbarContainer).find(".e-childContainer").closest('div')[0],
                        taskbar = taskElement.querySelector(".e-gantt-childtaskbar"),
                        progressbar = taskElement.querySelector(".e-gantt-childtaskbar-progress"),
                        taskbarStyle = taskbar.style,
                        progressbarStyle = progressbar && progressbar.style,
                        taskbarLabel = progressbar && progressbar.querySelector(".e-tasklabel"),
                        taskbarText = taskbarLabel && taskbarLabel.style;

                    if (taskbarStyle.backgroundColor != args.taskbarBackground) {
                        taskbarStyle.backgroundColor = args.taskbarBackground;
                    }
                    if (progressbar && progressbarStyle.backgroundColor != args.progressbarBackground) {
                        progressbarStyle.backgroundColor = args.progressbarBackground;
                    }
                    if (taskbarStyle.borderColor != args.taskbarBorder) {
                        taskbarStyle.borderColor = args.taskbarBorder;
                    }
                    if (progressbar && progressbarStyle.borderColor != args.progressbarBorder) {
                        progressbarStyle.borderColor = args.progressbarBorder;
                    }
                    if (taskbarText && taskbarText.color != args.taskbarTextColor) {
                        taskbarText.color = args.taskbarTextColor;
                    }
                }

                if ($(mileStone).length > 0) {
                    var milestoneTop = mileStone.querySelector(".e-gantt-milestone.milestone-top"),
                        milestoneBottom = mileStone.querySelector(".e-gantt-milestone.milestone-bottom");
                    if (milestoneTop && milestoneBottom) {
                        var milestonetopStyle = milestoneTop.style,
                            milestonebottomStyle = milestoneBottom.style;
                        if (milestonebottomStyle.borderBottomColor != args.milestoneBackground && milestonetopStyle.borderTopColor != args.milestoneBackground) {
                            milestonebottomStyle.borderTopColor = args.milestoneBackground;
                            milestonetopStyle.borderBottomColor = args.milestoneBackground;
                        }
                    }
                    else if(this.model.milestoneTemplate)
                    {
                        var milestoneContainer = mileStone.querySelector(".e-gantt-milestone");
                        if (milestoneContainer.style.backgroundColor != args.milestoneBackground)
                            milestoneContainer.style.backgroundColor = args.milestoneBackground;
                    }
                }
                if ($(baseline).hasClass("e-baselinebar")) {
                    var baselineStyle = baseline.style;
                    if (baselineStyle.backgroundColor != args.baselineBackground) {
                        baselineStyle.backgroundColor = args.baselineBackground;
                    }
                }
            }
        },

        //to perform expand collapse operation from ganttchart
        _expandCollapse: function (recordIndex) {

            var proxy = this,
                args = {},
                data = proxy.model.currentViewData[recordIndex];

            args.data = data;
            args.recordIndex = proxy.model.updatedRecords && proxy.model.updatedRecords.indexOf(data);
            args.source = "ganttChart";
            args.expanded = !data.expanded;
            if (data) {
                if (!args.expanded) {
                    proxy._trigger("collapsing", args);
                }
                else {
                    proxy._trigger("expanding", args);
                }
            }
        },


        //get the Expand status of GridRecord
        _getExpandStatus: function (record) {
            var parentRecord = record.parentItem;
            if (parentRecord != null) {
                if (parentRecord.expanded === false)
                    return false;
                else if (parentRecord.parentItem) {
                    if (parentRecord.parentItem.expanded === false)
                        return false;
                    else
                        return this._getExpandStatus(parentRecord.parentItem);
                }
                else
                    return true;
            } else
                return true;
        },



        //method to scroll ganttchart from gridtree scroll event       

        onScrollHelper: function (scrollTop, fromChartScroller) {

            var proxy = this;
			if (!proxy._$bodyContainer.ejScroller("isVScroll"))
			{
                return false;
            }
			proxy._mouseLeave();
			if (!fromChartScroller)
			    proxy._$bodyContainer.ejScroller("option", "scrollTop", scrollTop);
			var rowHeight = proxy.model.rowHeight;
			if ($("#" + this._$ganttViewTablebody[0].id).find("tr:first")[0])
			    rowHeight = $("#" + this._$ganttViewTablebody[0].id).find("tr:first")[0].getBoundingClientRect().height;
			var h = parseInt(proxy.model.updatedRecords.length * rowHeight) - (proxy._viewportHeight - 18); //proxy.model.
            

            if (scrollTop > h) {
                scrollTop = h;
            }

            if (scrollTop < 0) {
                scrollTop = 0;
            }

            var args = { scrollTop: scrollTop };

            proxy._handleScroll(args);
            
            //var div = $("#ganttviewerbodyContianer" + this._id);
            //div.scrollTop(scrollTop);
            if (this.model.isCriticalPathEnable == true && this.model.enableVirtualization == true) {
                this.criticalConnectorLine(this.model.criticalPathCollection, this.model.detailPredecessorCollection, true, this.collectionTaskId);
            }
        },



        //Handler for scroll event from ganttchart
        _handleScroll: function (args) {

            var proxy = this,
                args =args|| {},
                headerdiv = proxy._$headerContainer,
                contentdiv = proxy._$bodyContainer,
                left = proxy._prevLeft;

            
            if (args.scrollTop !== undefined) {
                proxy._scrollTop = args.scrollTop;
            }

            if (args.scrollLeft !== undefined) {
                left = args.scrollLeft;
            }

            var diff = (left - proxy._prevLeft),
                vDiff = proxy._scrollTop - proxy._prevScrollTop;

            if (diff) {
                headerdiv.scrollLeft(left);
            }
            else {
                headerdiv.scrollLeft(proxy._prevLeft);
            }

            if (proxy.model.enableVirtualization) {
                proxy._vscrollDist = Math.abs(proxy._scrollTop - proxy._prevScrollTop);
                if (proxy._vscrollDist) {
                    proxy._vScrollDir = proxy._prevScrollTop <= proxy._scrollTop ? 1 : -1;
                        proxy._updateCurrentViewData();

                    proxy.renderGanttRecords();
                    proxy._prevScrollTop = proxy._scrollTop;
                }
            }
            args.requestType = "scroll";
            args.delta = proxy._scrollTop;
            proxy._prevLeft = left;
            proxy._prevScrollTop = proxy._scrollTop;
            if (diff === 0 && vDiff !== 0) {
                proxy._completeAction(args);
            }
        },


        //helper method to refresh the ganttchart content from gantt
        refreshHelper: function (currentviewdata, records,collapseRecordsCount) {

            var proxy = this;
            proxy.model.currentViewData = currentviewdata;
            proxy.model.updatedRecords = records;
            if (collapseRecordsCount != undefined)
                proxy._totalCollapsedRecordCount = collapseRecordsCount;
            else
                proxy._totalCollapsedRecordCount = 0;

            if (records) {
                proxy._refresh();
                proxy._setHeight(records.length * proxy.model.rowHeight);
                proxy.updateHeight((records.length - proxy._totalCollapsedRecordCount) * proxy.model.rowHeight);
            }
        },
        _setScrollTop: function () {

            var proxy = this,
            model = this.model,
            top = proxy._scrollTop;

            if (model.enableVirtualization && top!==0) {
                if ((proxy.model.currentViewData.length * proxy.model.rowHeight) < proxy._viewportHeight) {
                    var currentPosition = top - (proxy._viewportHeight - proxy.model.currentViewData.length * proxy.model.rowHeight);
                    if (currentPosition < 0)
                        currentPosition = 0;
                    proxy._$bodyContainer.ejScroller("scrollY", currentPosition, true);
                }
            }
        },
  
        refreshGridLinesTable:function(length)
        {
            var proxy = this;
                proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(length));
                proxy._$bodyContainer.ejScroller("refresh");

                /*While refreshing scroller the gantt chart container height is increased by 16px.
                When horizontal scrollbar not avaiable in gantt chart side.
                So check the chart container height and view port height.
                If it is varies set the view port height to chart container height*/
                if (parseInt(proxy._$bodyContainer.css("height")) != proxy._viewportHeight)
                    proxy._$bodyContainer.css("height", proxy._viewportHeight);
        },
        //to refresh the content of the ganttchart
        _refresh: function () {

            var proxy = this, model = proxy.model,
                data = $.render[proxy._id + "_CustomTemplate2"](proxy.model.currentViewData);

            proxy._$ganttViewTablebody = $("#ganttViewTablebody" + proxy._id + "");

            proxy._$ganttViewTablebody.empty().append(data);

            //var $gridLinesTablebody = $("#gridLinesTablebody" + proxy._id + "");
            
            if (model.enableVirtualization) {
                proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(proxy.model.currentViewData.length));
            }
            else {
                proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(proxy.model.currentViewData.length - proxy._totalCollapsedRecordCount));
            }


            if (proxy._$ganttViewTablebody[0] != null) {
                this._ganttChartRows = $(proxy._$ganttViewTablebody[0].childNodes);
            }
            else {
                proxy._$ganttViewTablebody = ej.buildTag("tbody.e-gantt-viewer-ganttViewTablebody#ganttViewTablebody" + proxy._id + "",
                    data, {}, {});
                proxy._ganttChartRows = $(proxy._$ganttViewTablebody[0].childNodes);
            }
            if(model.queryTaskbarInfo)
                proxy._eventBindings();

        },


        //to rerender a particular ganttchart row
        refreshRow: function (index) {

            var proxy = this, model = this.model,
                $tr = $(proxy.getGanttChartRows()[index]),
                selectedItem = proxy.model.currentViewData[index];
            if (!model.allowSelection && selectedItem)
                selectedItem.isSelected = false;
            if (index != -1 && selectedItem) {
                $tr.replaceWith($.render[proxy._id + "_CustomTemplate2"](selectedItem));
                proxy._setGanttChartRows($(proxy._$ganttViewTablebody[0].childNodes));
            }
            if (model.queryTaskbarInfo)
                proxy._refreshedRowEventBinding(index);

        },


        //Trigger queryTaskbarInfo while refresh the row
        _refreshedRowEventBinding: function (index)
        {
            var $ganttChartRows = $(this.getGanttChartRows()),
                    taskbarContainer,
                    args = {}, progressbar, taskbar,
                    parentProgressbar, parentTaskbar, taskElement, mileStone, progressBorder,
                    taskbarBorder,
                    taskbarText,
                    baseline;

                    taskbarContainer = $ganttChartRows[index];

                    if ($(taskbarContainer).hasClass("e-ganttrowcell")) {
                        taskElement = $(taskbarContainer).find("td.e-chartcell").has("div.e-childContainer,div.e-parentContainer,div.e-gantt-milestone")[0].firstChild;
                        if ($(taskbarContainer).find(".e-gantt-milestone-container").closest('div').length > 0)
                            mileStone = $(taskbarContainer).find(".e-gantt-milestone-container").closest('div')[0];

                        if ($(taskbarContainer).find(".e-baselinebar").closest('div').length > 0)
                            baseline = $(taskbarContainer).find(".e-baselinebar").closest('div')[0];

                        if ($(taskElement).hasClass("e-parentContainer")) {
                            parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv");
                            parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress");
                        } else if ($(taskElement).hasClass("e-childContainer")) {

                            taskbar = taskElement.querySelector(".e-gantt-childtaskbar");
                            progressbar = taskElement.querySelector(".e-gantt-childtaskbar-progress");
                            taskbarText = progressbar && progressbar.querySelector(".e-tasklabel");
                        }

                        args.data = this.model.currentViewData[index];
                        args.taskbar = taskbarContainer;

                        args.taskbarBackground = taskbar != null ?
                            taskbar.style.backgroundColor : null;

                        args.progressbarBackground = progressbar != null ?
                            progressbar.style.backgroundColor : null;

                        args.parentTaskbarBackground = parentTaskbar != null ?
                            parentTaskbar.style.backgroundColor : null;

                        args.parentProgressbarBackground = parentProgressbar != null ?
                            parentProgressbar.style.backgroundColor : null;

                        args.parentProgressbarBorder = parentProgressbar != null ?
                            parentProgressbar.style.border : null;

                        args.progressbarBorder = progressbar != null ?
                            progressbar.style.border : null;

                        args.taskbarBorder = taskbar != null ?
                            taskbar.style.border : null;

                        args.parentTaskbarBorder = parentTaskbar != null ?
                            parentTaskbar.style.border : null;

                        args.taskbarTextColor = taskbarText != null ?
                            taskbarText.style.color : null;

                        args.baselineBackground = baseline != null ?
                            baseline.style.backgroundColor : null;

                        args.milestoneBackground = mileStone != null ?
                            mileStone.style.backgroundColor : null;

                        this._queryTaskbarinfo(args);
                    }

        },
        //REFRESH THE SCROLLER FOR TREEGRIDCONTENT
        refreshScroller: function (panSize) {

            var proxy = this,maxScrollWidth;
            //proxy._$gridContent.css({'width':panSize+"px"});
            proxy._$bodyContainer.find("div.e-content").removeClass("e-borderbox");
            var scrollTop = proxy._$bodyContainer.ejScroller("option", "scrollTop");
            var scrollLeft = proxy._$bodyContainer.ejScroller("option", "scrollLeft");
            proxy._$bodyContainer.ejScroller("option", { "width": panSize });
            proxy._$bodyContainer.ejScroller("refresh");
            maxScrollWidth=proxy.getMaxScrollWidth();
            
            if (scrollLeft > maxScrollWidth)
                scrollLeft = maxScrollWidth > 0 ? maxScrollWidth : 0;

            var isHorizontalScroll = proxy._$bodyContainer.ejScroller("isHScroll");
            if (!isHorizontalScroll) {
                proxy._$bodyContainer.find("div.e-content").addClass("e-borderbox");
            }
            else {
                proxy._$bodyContainer.find("div.e-content").removeClass("e-borderbox");
            }
            var isVerticalScroll = proxy._$bodyContainer.ejScroller("isVScroll");
            if (isVerticalScroll)
            {
                proxy._$bodyContainer.ejScroller("scrollY", scrollTop, true);
            }
            proxy._$bodyContainer.ejScroller("option", "scrollLeft", scrollLeft);
            proxy._$headerContainer.scrollLeft(scrollLeft);

        },
        getMaxScrollWidth:function()
        {
            var proxy = this;
            return proxy._$bodyContainer.children(".e-content").children().width() - proxy._$bodyContainer.children(".e-content").width();
        },

        /* refresh stripLines Collection*/
        refreshStripLines:function (stripLines)
        {
            var proxy = this;
            if (stripLines) {
                this.model.stripLines = stripLines;
            }
            proxy._$stripLineContainer.empty();
            this._renderStripLines(this.model.stripLines);

        },
        /* refresh holidays Collection*/
        refreshHolidays: function (holidays) {
            //Display Holidays
            var proxy = this;
            if (holidays) {
                proxy.model.holidays = holidays
            }
            proxy._$secondaryCanvas.empty();
            if (proxy.model.holidays != null) {
                var holidayCount = proxy.model.holidays.length;
                for (var i = 0; i < holidayCount; i++) {
                    proxy._renderHoliday(proxy.model.holidays[i]);
                }
            }
        },

        //insert new record in DOM 
        renderNewAddedRow:function(index, data)
        {
            var proxy = this, model = proxy.model,
            addedchartRow = $.render[this._id + "_CustomTemplate2"](data);
            if (proxy._ganttChartRows.length != 0) {
                if (proxy._ganttChartRows.length == index) {
                    proxy.getGanttChartRows().eq(index - 1).after(addedchartRow);
                } else {
                    proxy.getGanttChartRows().eq(index).before(addedchartRow);
                }
            } else {
                proxy._refresh();
            }
            proxy._setGanttChartRows($(proxy._$ganttViewTablebody[0].childNodes));
            proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(proxy.model.updatedRecords.length - proxy._totalCollapsedRecordCount));
            if (model.enableVirtualization === false) {
                proxy._setHeight((proxy.model.updatedRecords.length - proxy._totalCollapsedRecordCount) * proxy.model.rowHeight);

            } else {
                proxy._setHeight(proxy.model.updatedRecords.length * proxy.model.rowHeight);
            }
            proxy.updateHeight(proxy._containerHeight);

        },

        _setGanttChartRows: function (value) {
            this._ganttChartRows = value;
        },

        refreshChartHeader:function(startdate,enddate)
        {
            var proxy = this,
            model = proxy.model,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
            $colsgroup, $column, $thead,
            $tr, $td, $div, $table;
            proxy._updateScheduleWidth();
            /*Schedule mode - Chart Top header*/
            if (scheduleMode == "hour") {
                proxy._createScheduleTopHourTemplate();
            }
            else if (scheduleMode == "day") {
                proxy._createScheduleTopDayTemplate();
            }
            else if (scheduleMode == "week") {
                proxy._createScheduleWeekTemplate();
            }
            else if (scheduleMode == "month") {
                proxy._createScheduleTopMonthTemplate();
            }
            else if (scheduleMode == "year") {
                proxy._createScheduleYearTemplate();
            }
            
            startdate = startdate == null ? new Date() : startdate;
            enddate = enddate == null ? new Date(null) : enddate;
            proxy._$scheduleDiv.empty();
            $table = ej.buildTag("table.e-schedule-headerrow-week", "",
                { 'display': 'block' },
                { 'cell-spacing': '0' }
            );

            $colsgroup = ej.buildTag("colgroup", "", {}, {});
            $column = $(document.createElement("col"));
            $column.css("width", proxy._getScheduleLength(scheduleMode) + 'px');

            $colsgroup.append($column);

            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});

            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleWeekTemplate"](model.scheduleWeeks), {}, {});
            else if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleYearTemplate"](model.scheduleYears), {}, {});
            else if (scheduleMode == "month")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopMonthTemplate"](model.scheduleMonths), {}, {});
            else if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopDayTemplate"](model.scheduleDays), {}, {});
            else if (scheduleMode == "hour")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopHourTemplate"](model.scheduleHours), {}, {});

            $td = ej.buildTag("th.schedule", "", {}, {});
            $div = ej.buildTag("div.schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);

            $tr = null;
            /*Schedule mode - Chart Bottom header*/
            if (scheduleMode == "hour") {
                proxy._createMinuteTemplate();
            }
            else if (scheduleMode == "day") {
                proxy._createScheduleHourTemplate();
            }
            else if (scheduleMode == "week") {
                proxy._createScheduleDayTemplate();
            }
            else if (scheduleMode == "month") {
                proxy._createScheduleBottomWeekTemplate();
            }
            else if (scheduleMode == "year") {
                proxy._createScheduleMonthTemplate();
            }
            $table = ej.buildTag("table.e-schedule-headerrow-day", "",
                {
                    'display': 'block',
                    'border-collapse': 'collapse'
                }, { 'cell-spacing': '0' });
            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});

            var scheduleMonths = proxy._getScheduleMonth(new Date(model.scheduleYears[0]), enddate);
            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "_CustomTemplate1"](proxy.model.scheduleWeeks), {}, {});
            if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleMonthTemplate"](scheduleMonths), {}, {});
            if (scheduleMode == "month") {
                proxy._numOfWeeks = proxy._getNumberOftWeeks(this.model.projectStartDate, this.model.projectEndDate);
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleBottomWeekTemplate"](proxy._numOfWeeks), {}, {});
            }
            if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "scheduleHourTemplate"](proxy._getScheduleHours()), {}, {});
            if (scheduleMode == "hour")
                $tr = ej.buildTag("tr", $.render[this._id + "scheduleMinuteTemplate"](proxy._getScheduleMinutes()), {}, {});

            $td = ej.buildTag("th.schedule", "", {}, {});
            $div = ej.buildTag("div.schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);
        },


        //update all containers width
        refreshContainersWidth:function()
        {
            var proxy = this,
                width, model = this.model,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;
            width = proxy._getScheduleLength(scheduleMode);
            var $gridLineContainerTable=$("#ganttgridLinesTable" + proxy._id);

            proxy._$bodyContent.width(width);//main body container
            proxy.refreshWeekEndContainer();//weekENd Container
            $gridLineContainerTable.width(width);
            $gridLineContainerTable.children("col").width(width);
            proxy._$ganttViewTable.width(width);
            proxy._$ganttViewTable.children("col").width(width);
            proxy._createTaskbarTemplate();
            proxy._updateCurrentViewData();
            proxy._$secondaryCanvas.empty();
            proxy._$stripLineContainer.empty();
            if (proxy.model.stripLines != null) {
                this._renderStripLines(proxy.model.stripLines);
            }
            if (proxy.model.holidays != null) {
                var holidayCount = proxy.model.holidays.length;
                for (var i = 0; i < holidayCount; i++) {
                    proxy._renderHoliday(proxy.model.holidays[i]);
                }
            }
        },
        //refresh week ends when schedule dates changes
        refreshWeekEndContainer:function()
        {
            var proxy = this,
                model = proxy.model,
                left = 0,
                width = (proxy.model.perDayWidth) + 1,
                height = ((proxy.model.updatedRecords.length) * this.model.rowHeight),
                count = proxy.model.scheduleWeeks.length,
                $sunday, $saturday,
                weekStartDay = model.scheduleHeaderSettings.weekStartDay,
                dayIndex = (weekStartDay >= 0 && weekStartDay < 7) ? weekStartDay : 0,
                saturdayIndex = 6 - dayIndex,
                sundayIndex = (saturdayIndex + 1) == 7 ? 0 : (saturdayIndex + 1),
                $weekendContainer = proxy._$weekendsContainer.children('.e-secondary_canvas');
                $weekendContainer.empty();
                for (var i = 0; i < count; i++) {
                    $sunday = ej.buildTag("div.e-weekends", "", {
                        'left': (left + (proxy.model.perDayWidth * sundayIndex)) + 'px',
                        'width': width + 'px',
                        'height': height + 'px',
                        'background-color': this.model.weekendBackground
                    }, {});
                    $saturday = ej.buildTag("div.e-weekends", "", {
                        'left': (left + (proxy.model.perDayWidth * saturdayIndex)) + 'px',
                        'width': width + 'px',
                        'height': height + 'px',
                        'background-color': this.model.weekendBackground
                    }, {});
                    $weekendContainer.append($sunday);
                    $weekendContainer.append($saturday);
                    left = left + this._scheduleWeekWidth;
                }
                proxy._$weekendsContainer.append($weekendContainer);
        },
        //delete gantt chart rows without rerendering of whole page
        deleteChartRows: function (startIndex, count) {
            var proxy = this;
            var $chartRows = proxy.getGanttChartRows();
            for (var i = startIndex; i < startIndex + count; i++) {
                $chartRows.splice(i, 1);
            }
        },


        //helper method to bind querytaskbarinfo events to ganttchart rows
        _eventBindings: function () {

            var $ganttChartRows = $(this.getGanttChartRows()),
                rowsLength = $ganttChartRows.length,
                taskbarContainer,
                args = {}, progressbar, taskbar,
                parentProgressbar,manualParentTaskbar, parentTaskbar, taskElement, mileStone, taskbarText, baseline;

            if (rowsLength != 0) {

                for (var row = 0; row < rowsLength; row++) {

                    taskbarContainer = $ganttChartRows[row];

                    if ($(taskbarContainer).hasClass("e-ganttrowcell")) {
                        taskElement = $(taskbarContainer).find("td.e-chartcell").has("div.e-childContainer,div.e-parentContainer,div.e-gantt-milestone")[0].firstChild;
                        if ($(taskbarContainer).find(".e-gantt-milestone-container").closest('div').length > 0)
                            mileStone = $(taskbarContainer).find(".e-gantt-milestone-container").closest('div')[0];

                        if ($(taskbarContainer).find(".e-baselinebar").closest('div').length > 0)
                            baseline = $(taskbarContainer).find(".e-baselinebar").closest('div')[0];
                        
                        if ($(taskElement).hasClass("e-parentContainer")) {
                            parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv");
                            parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress");
                            manualParentTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar");
                        } else if ($(taskElement).hasClass("e-childContainer")) {

                            taskbar = taskElement.querySelector(".e-gantt-childtaskbar");
                            progressbar = taskElement.querySelector(".e-gantt-childtaskbar-progress");
                            taskbarText = progressbar && progressbar.querySelector(".e-tasklabel");
                        }

                        args.data = this.model.currentViewData[row];
                        args.taskbar = taskbarContainer;

                        args.taskbarBackground = taskbar != null ?
                            taskbar.style.backgroundColor : null;

                        args.progressbarBackground = progressbar != null ?
                            progressbar.style.backgroundColor : null;

                        args.parentTaskbarBackground = parentTaskbar != null ?
                            parentTaskbar.style.backgroundColor : null;

                        args.parentProgressbarBackground = parentProgressbar != null ?
                            parentProgressbar.style.backgroundColor : null;

                        args.parentProgressbarBorder = parentProgressbar != null ?
                            parentProgressbar.style.border : null;

                        args.progressbarBorder = progressbar != null ?
                            progressbar.style.border : null;

                        args.taskbarBorder = taskbar != null ?
                            taskbar.style.border : null;

                        args.parentTaskbarBorder = parentTaskbar != null ?
                            parentTaskbar.style.border : null;

                        args.taskbarTextColor = taskbarText != null ?
                            taskbarText.style.color : null;

                        args.baselineBackground = baseline != null ?
                            baseline.style.backgroundColor : null;

                        args.milestoneBackground = mileStone != null ?
                            mileStone.style.backgroundColor : null;

                        if (args.data.hasChildRecords && !args.data.isAutoSchedule) {

                            args.manualParentTaskbarBackground = manualParentTaskbar != null ?
                                manualParentTaskbar.style.backgroundColor : null;
                        }

                        this._queryTaskbarinfo(args);
                    }
                }
            }
        },


        //to update the currentviewdata of ganttchart
        _updateCurrentViewData: function () {
            var proxy = this, margin = 0;
            if (!this.model.enableVirtualization) {
                this.model.currentViewData = this.model.updatedRecords;
            }
            else {
                this._getRenderedRowRange();

                //console.log("Gantt Chart Rendered Range Top: " + proxy._renderedRange.top + "Bottom :" + proxy._renderedRange.bottom);

                this.model.currentViewData = this.model.updatedRecords.slice(proxy._renderedRange.top,
                    proxy._renderedRange.bottom);
                if (proxy._vscrollDist !== 0) {
                    margin = proxy._scrollTop;
                    margin -= proxy._rowMargin;
                    $("#ganttViewTable" + proxy._id + "").css({ "top": margin + "px" });
                    $("#ganttgridLinesTable" + proxy._id + "").css({ "top": margin + "px" });
                }
                proxy._vTop = proxy._visibleRange.top;
                proxy._vBottom = proxy._visibleRange.bottom;
                proxy._rTop = proxy._renderedRange.top;
                proxy._rBottom = proxy._renderedRange.bottom;
            }

        },

       
        //to render ganttchart content
        renderGanttRecords: function () {

            var proxy = this;
            proxy._refresh();
            proxy._$ganttViewTable.append(proxy._$ganttViewTablebody);
            proxy._$bodyContent.append(proxy._$ganttViewTable);
        },

        _getRenderedRowRange: function () {

            var proxy = this;
            proxy._getVisibleRowRange();
            var topIndex = proxy._visibleRange.top;
            var bottomIndex = proxy._visibleRange.bottom;
            proxy._renderedRange = { top: topIndex, bottom: bottomIndex };
            return proxy._renderedRange;
        },

        _getVisibleRowRange: function () {

            var proxy = this,
                top = proxy._scrollTop / proxy.model.rowHeight,
                coeff = top - Math.floor(top),
                topIndex,
                bottomIndex, length;

            //console.log("GanttChart ScrollTop :" + proxy._scrollTop);

            proxy._rowMargin = coeff * proxy.model.rowHeight;
            topIndex = Math.floor(top);
            length = proxy.model.updatedRecords.length;
            bottomIndex = proxy._getrowposition(proxy._scrollTop + proxy._viewportHeight);
            topIndex = Math.max(0, topIndex);
            bottomIndex = Math.min(length, bottomIndex);
            proxy._visibleRange = { top: topIndex, bottom: bottomIndex };
        },

        _getrowposition: function (y) {
            return Math.ceil((y) / this.model.rowHeight);
        },


        //returns the date object
        _getDateType: function (date) {

            if (date instanceof Date) {
                return date;
            }
            else if (date != null) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
            return null;
        },

        // Returns the date as per date format
        _getDateFromFormat: function (date) {

            if (typeof date === "object") {
                return new Date(date);
            }
            if (date) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale) == null ?
                    new Date(date) : ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
        },

        _createScheduleTopDayTemplate: function () {
            var proxy = this,
                model = proxy.model,
                dayFormat = model.scheduleHeaderSettings.dayHeaderFormat == "" && model.scheduleHeaderSettings.scheduleHeaderType == "day"
                            ? "ddd" : model.scheduleHeaderSettings.dayHeaderFormat,
                helpers = {
                    renderDayTop: $.proxy(proxy._getDaySplit, proxy),
                };
            $.views.helpers(helpers);

            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:"
                + ((proxy.model.perHourWidth * 24)) + "px;'>";

            var td = "<div class='e-schedule-week-headercell-content'  style='width:"
                + ((proxy.model.perHourWidth*24)-1) + "px;box-sizing:border-box;margin:auto;white-space:nowrap;'>"
                + "{{:~renderDayTop('" + dayFormat + "',#data)}}" + "</div>" +
            "</div>"

            parentTr += td;
            parentTr += "</th>";

            var templates = {};
            templates[proxy._id + "ScheduleTopDayTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper methood for day schedule mode

        _getDaySplit: function (dateformat,data) {
            var date = new Date(data),
               proxy = this,
               model = proxy.model,
               formatedDate;
            switch (dateformat) {
                case "D":
                case "d":
                    return date.getDate();
                case "DD":
                case "dd":
                    return (('0' + date.getDate()).slice(-2));
                case "DDD":
                case "ddd":
                case "DDDD":
                case "dddd":
                    return ej.format(date, dateformat, model.locale);
            }
            formatedDate = ej.format(date, dateformat, model.locale);
            return formatedDate;
        },


        // Month Week Schedule Mode

        _createScheduleTopMonthTemplate: function () {

            var proxy = this, td, i = 0,
                model = proxy.model,
                monthFormat = model.scheduleHeaderSettings.monthHeaderFormat,
                helpers = {
                    renderMonthTop: $.proxy(proxy._getMonthsplit, proxy),
                    setMonthWidth: $.proxy(proxy._setMonthWidth, proxy),
                    isLastMonth: $.proxy(proxy._checkLastMonthWidth, proxy),
                };

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:{{:~setMonthWidth(#data)}}" + "px;'>";

            td = "<div class='e-schedule-week-headercell-content'  style='box-sizing:border-box;-moz-box-sizing:border-box;margin:auto;white-space:nowrap;width:{{:~setMonthWidth(#data)-1}}" + "px;'>"
                + "{{:~renderMonthTop('" + monthFormat + "',#data)}}" + "</div>"
                 +"{{if ~isLastMonth(#data)}}"
                 + "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;'>"
                    + "<div class='e-schedule-week-headercell-content' style='box-sizing:border-box;-moz-box-sizing:border-box;margin:auto;white-space:nowrap;width:" + (proxy._balanceWidth - 1) + "px;'>"
                +"</div></th>{{/if}}"
            
                parentTr += td;
                parentTr += "</th>";
                //if (proxy._balanceWidth) {
                //    parentTr += tdx;
                //    parentTr += "</th>";
                //}

            var templates = {};
            templates[proxy._id + "ScheduleTopMonthTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper method for calculating unique month width
        _setMonthWidth: function (data) {
            var proxy = this;
            var date;
            if (typeof data === "object") {
                date = new Date(data);
            }
            else {
                date = ej.parseDate(data, this.model.dateFormat, this.model.locale);
            }

            var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);

            var lastDate = monthLastDay.getDate();
            // condition to check whether first month having only few weeks.
            if (date.getTime() === proxy.model.scheduleMonths[0].getTime())
            {
                var datediff = monthLastDay.getDate() - date.getDate();
                return (this.model.perDayWidth * (datediff+1));
            }
            else if (lastDate == 31)
                return (this.model.perDayWidth * 31);
            else if (lastDate == 30)
                return (this.model.perDayWidth * 30);
            else if (lastDate == 28)
                return (this.model.perDayWidth * 28);
            else if (lastDate == 29)
                return (this.model.perDayWidth * 29);
        },

        _checkLastMonthWidth: function (data) {
            var proxy = this;
            if (data == proxy.model.scheduleMonths[proxy.model.scheduleMonths.length - 1] && proxy._balanceWidth>0) {
                return true;
            }
            else
            {
                return false;
            }
        },


        //helper method for _createScheduleMonthTemplate
        _getMonthsplit: function (monthFormat, data) {

            var date = new Date(data),
                proxy = this,
                model = proxy.model,
                formatedDate;

            formatedDate = ej.format(date, monthFormat, model.locale);
            return formatedDate;

        },


        _createScheduleYearTemplate: function () {

            var proxy = this, td,
                model = proxy.model,
                yearFormat = model.scheduleHeaderSettings.yearHeaderFormat,
                helpers = {
                    renderYear: $.proxy(proxy._getYearsplit, proxy),
                    getYearWidth: $.proxy(proxy._getTemplateYearWidth, proxy),
                };

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:{{:~getYearWidth(#data)}}px;'>";
            
            td = "<div class='e-schedule-week-headercell-content' style='margin:auto;white-space:nowrap;width:{{:~getYearWidth(#data)-1}}px;box-sizing:border-box;-moz-box-sizing:border-box;'>"
                + "{{:~renderYear('" + yearFormat + "',#data)}}" + "</div>";

            parentTr += td;
            parentTr += "</th>";

            var templates = {};
            templates[proxy._id + "ScheduleYearTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper method for _createScheduleYearTemplate
        _getYearsplit: function (yearFormat, data) {

            var date = new Date(data),
                proxy = this,
                model = proxy.model,
                formatedDate;

            formatedDate = ej.format(date, yearFormat, model.locale);
            return formatedDate;

        },

        _getMonthWidthForYearMode: function (date) {
            var proxy = this,
                model = proxy.model,
                date,
                dayCount = 0;
                // get the number of months the year contains
                // endMonth = new Date(date.getFullYear(), 11, 31) < new Date(model.scheduleEndDate) ? 12 : new Date(model.scheduleEndDate).getMonth() + 1;
                //endMonth = new Date(date.getFullYear(), 11, 31) < new Date(model.scheduleEndDate) ? 12 : new Date(model.scheduleEndDate).getMonth() + 1;
            
            //loop through the each month to get the days count
            for (var i = date.getMonth() ; i < 12; i++) {
                var startDate = date;

                if (typeof startDate === "object") {
                    date = new Date(startDate);
                }
                else {
                    date = ej.parseDate(startDate, model.dateFormat, model.locale);
                }
                var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);
                var beginDate =date.getDate();
                var lastDate = monthLastDay.getDate();
                if (beginDate != 1)
                    dayCount += lastDate - date.getDate();
                else if (lastDate == 31)
                    dayCount += 31;
                else if (lastDate == 30)
                    dayCount += 30;
                else if (lastDate == 28)
                    dayCount += 28;
                else if (lastDate == 29)
                    dayCount += 29;
                date=new Date(date.getFullYear(), i+1, 1);

            }
            return dayCount;
        },

        _getTemplateYearWidth: function (date) {

            var year = date.getFullYear(),
                monthWidth = this._getMonthWidthForYearMode(date);
            return monthWidth * this.model.perDayWidth;
        },
        //Template to render schedule week view
        _createScheduleWeekTemplate: function () {

            var proxy = this, td,
                model = proxy.model,
                dateFormat = model.scheduleHeaderSettings.weekHeaderFormat,
                helpers = {
                    renderWeek: $.proxy(proxy._getWeeksplit, proxy)
                };

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:"+ (proxy._scheduleWeekWidth) + "px;'>";

            td = "<div class='e-schedule-week-headercell-content'  style='width:"
                + (proxy._scheduleWeekWidth - 1) + "px;box-sizing:border-box;margin:auto;white-space:nowrap;'>"
                + "{{:~renderWeek('" + dateFormat + "',#data)}}" + "</div>";

            parentTr += td;
            parentTr += "</th>";

            var templates = {};
            templates[proxy._id + "ScheduleWeekTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper method for _createScheduleWeekTemplate
        _getWeeksplit: function (dateFormat, data) {

            var date = new Date(data),
                proxy = this,
                model = proxy.model,
                formatedDate;
            //var values = dateFormat.split(' '),
            //    scheduleUnits = values[0].match(/(\d+|[A-z]+)/g),
            //    month = date.getMonth(),
            //    day = date.getDay() == 1 ? proxy._days("mon") : "",
            //    weekTemplate = [];

            //switch (month) {
            //    case 0:
            //        month = proxy._getLocalizedLabels("jan");
            //        break;
            //    case 1:
            //        month = proxy._getLocalizedLabels("feb");
            //        break;
            //    case 2:
            //        month = proxy._getLocalizedLabels("mar");
            //        break;
            //    case 3:
            //        month = proxy._getLocalizedLabels("apr");
            //        break;
            //    case 4:
            //        month = proxy._getLocalizedLabels("may");
            //        break;
            //    case 5:
            //        month = proxy._getLocalizedLabels("jun");
            //        break;
            //    case 6:
            //        month = proxy._getLocalizedLabels("jul");
            //        break;
            //    case 7:
            //        month = proxy._getLocalizedLabels("aug");
            //        break;
            //    case 8:
            //        month = proxy._getLocalizedLabels("sep");
            //        break;
            //    case 9:
            //        month = proxy._getLocalizedLabels("oct");
            //        break;
            //    case 10:
            //        month = proxy._getLocalizedLabels("nov");
            //        break;
            //    case 11:
            //        month = proxy._getLocalizedLabels("dec");
            //        break;
            //}

            //for (var i = 0; i < scheduleUnits.length; i++) {
            //    switch (scheduleUnits[i]) {//('0' + currentDate.getHours()).slice(-2)
            //        case "d":
            //        case "D":
            //            weekTemplate.push(('0' + date.getDate()).slice(-2));
            //            break;
            //        case "dd":
            //        case "DD":
            //            weekTemplate.push(date.getDate());
            //            break;
            //        case "ddd":
            //        case "DDD":
            //            weekTemplate.push(day.substring(0, 3));
            //            break;
            //        case "dddd":
            //        case "DDDD":
            //            weekTemplate.push(day);
            //            break;
            //        case "M":
            //        case "m":
            //            weekTemplate.push(('0' + date.getMonth() + 1).slice(-2));
            //            break;
            //        case "MM":
            //        case "mm":
            //            weekTemplate.push(date.getMonth() + 1);
            //            break;
            //        case "MMM":
            //        case "mmm":
            //            weekTemplate.push(month.substring(0, 3));
            //            break;
            //        case "MMMM":
            //        case "mmmm":
            //            weekTemplate.push(month);
            //            break;
            //        case "YY":
            //        case "yy":
            //            weekTemplate.push(('0' + date.getFullYear()).slice(-2));
            //            break;
            //        case "YYYY":
            //        case "yyyy":
            //            weekTemplate.push(date.getFullYear());
            //            break;
            //    }
            //}
            formatedDate = ej.format(date, dateFormat, model.locale);

            return formatedDate.toLowerCase().replace(/(-(\w)|(^| )(\w)|:(\w)|,(\w)|\/(\w)|\.(\w))/g, function (x) {
                return x.toUpperCase();
            });
        },

        _createScheduleHourTemplate: function () {
            var proxy = this, model = proxy.model,td,
                hourHeaderFormat = model.scheduleHeaderSettings.hourHeaderFormat,
                helpers = {
                    renderHour:$.proxy(proxy._getHourTemplate,proxy),
                };
            $.views.helpers(helpers);
            var parentTr = "<th  class='e-schedule-day-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:"
                + (proxy.model.perHourWidth) + "px;'>";
            td = "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perHourWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip'>" +
                "{{:~renderHour('" + hourHeaderFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "scheduleHourTemplate"] = parentTr;
            $.templates(templates);
        },
        //Method to create template for upper part of schedule header in hour-minute schedule mode.
        _createScheduleTopHourTemplate: function () {
            var proxy = this, model = proxy.model, minuteInterval = model.minuteInterval, td, interval,
                hourHeaderFormat = model.scheduleHeaderSettings.hourHeaderFormat,
                helpers = {
                    renderHour: $.proxy(proxy._getHourTemplate, proxy),
                };
            if (minuteInterval == 30)
                interval = 2;
            if (minuteInterval == 15)
                interval = 4;
            if (minuteInterval == 5)
                interval= 12;
            if (minuteInterval == 1)
                interval = 60;
            proxy._totalInterval = interval;//To calculate schedule length
            $.views.helpers(helpers);
            var parentTr = "<th  class='e-schedule-hour-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:"
                + ((proxy.model.perMinuteWidth * interval)) + "px;'>";
            td = "<div class='e-schedule-hour-headercell-content' style='width:"
                + ((proxy.model.perMinuteWidth*interval)-1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip'>" +
                "{{:~renderHour('" + hourHeaderFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "ScheduleTopHourTemplate"] = parentTr;
            $.templates(templates);
        },
        //Method to create template for lower part of schedule header in hour-minute schedule mode.
        _createMinuteTemplate: function () {
            var proxy = this, model = proxy.model, td,
                hourHeaderFormat = model.scheduleHeaderSettings.minuteHeaderFormat,
                helpers = {
                    renderHour: $.proxy(proxy._getHourTemplate, proxy),
                };
            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-hour-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:"
                + (proxy.model.perMinuteWidth) + "px;'>";
            td = "<div class='e-schedule-hour-headercell-content' style='width:"
                + (proxy.model.perMinuteWidth-1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip'>" +
                "{{:~renderHour('" + hourHeaderFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "scheduleMinuteTemplate"] = parentTr;
            $.templates(templates);
        },
        _getHourTemplate: function (format,data) {
            var date = new Date(data),
              proxy = this,
              model = proxy.model,
              formatedDate;

            formatedDate = ej.format(date, format, model.locale);
            return formatedDate;
        },


        //Template to render schedule week view in month-week schedule mode
        _createScheduleBottomWeekTemplate: function () {

            var proxy = this, td, model = proxy.model,
                weekFormat = model.scheduleHeaderSettings.weekHeaderFormat,
                helpers = {
                    renderWeek: $.proxy(proxy._getMonthWeekTemplate, proxy)
                };

            $.views.helpers(helpers);

            var parentTr = "<th  class='e-schedule-day-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perWeekWidth) + "px;'>";
            td = "<div class='e-schedule-day-headercell-content' style='position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;padding-left:2px;width:" + (proxy.model.perWeekWidth-1) + "px;'>" +
                "{{:~renderWeek('" + weekFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "ScheduleBottomWeekTemplate"] = parentTr;
            $.templates(templates);
        },

        _getMonthWeekTemplate: function (weekFormat, data) {

            var date = new Date(data),
                proxy = this, model = proxy.model;

            //date.setDate(date.getDate() + (weekLength * 7));

            switch (weekFormat) {
                case "d":
                case "dd":
                    //return (('0' + date.getDate()).slice(-2));
                case "ddd":

                default: return ej.format(date, weekFormat, model.locale);
            }
        },




        //Template to render schedule day view
        _createScheduleMonthTemplate: function () {

            var proxy = this, td, model = proxy.model,
                monthFormat = model.scheduleHeaderSettings.monthHeaderFormat,
                helpers = {
                    renderMonth: $.proxy(proxy._getMonthTemplate, proxy),
                    getMonthWidth: $.proxy(proxy._setMonthWidthYearMode, proxy)
                };

            $.views.helpers(helpers);

            var parentTr = "<th  class='e-schedule-day-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:{{:~getMonthWidth(#data)}}px;'>" +

                "<div class='e-schedule-day-headercell-content' style='"
                + "position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;width:{{:~getMonthWidth(#data)-1}}px;'>" +
                "{{:~renderMonth('" + monthFormat + "',#data)}}</div></th>";

            
            var templates = {};
            templates[proxy._id + "ScheduleMonthTemplate"] = parentTr;
            $.templates(templates);
        },

        _getMonthTemplate: function (monthFormat, data) {

            var date = new Date(data),
                proxy = this, model = proxy.model;
            switch (monthFormat) {
                case "M":
                case "m":
                    return (('0' + date.getDate()).slice(-2));
                case "MM":
                case "mm":
                    return date.getDate();
                case "MMM":
                case "mmm":
                case "MMMM":
                case "mmmm":
                    return ej.format(date, monthFormat, model.locale);
                default: return ej.format(date, monthFormat, model.locale);
            }
        },

        //For year template set month width accordance with num of days
        _setMonthWidthYearMode: function (data) {

            var proxy = this;
            var date = new Date(data);
            var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);

            var beginDate = date.getDate();
            var lastDate = monthLastDay.getDate();

            if (beginDate != 1)
                return (this.model.perDayWidth * (lastDate - date.getDate()));
            else if (lastDate == 31)
                return (this.model.perDayWidth * 31);
            else if (lastDate == 30)
                return (this.model.perDayWidth * 30);
            else if (lastDate == 28)
                return (this.model.perDayWidth * 28);
            else if (lastDate == 29)
                return (this.model.perDayWidth * 29);

        },      
        _getHeaderWeek: function (length, weekday) {
            var date = new Date(weekday);
            date.setDate(date.getDate() + length);
            var day = date.getDay();
            if (day == 0 || day == 6) {
                return true;
            }         
        },


        //Template to render schedule day view
        _createScheduleDayTemplate: function () {

            var proxy = this, td, model = proxy.model,
                dayFormat = model.scheduleHeaderSettings.dayHeaderFormat == "" && model.scheduleHeaderSettings.scheduleHeaderType == "day"
                            ? "ddd" : model.scheduleHeaderSettings.dayHeaderFormat,
                helpers = {
                    renderDay: $.proxy(proxy._getDayTemplate, proxy),                 
                    _getHeader: $.proxy(proxy._getHeaderWeek, proxy),
                };

            $.views.helpers(helpers);

            var parentTr = "<th  class='e-schedule-day-headercell {{if ~_getHeader(0,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;" +
                "{{if ~_getHeader(0,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>";
            td = "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(0,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',0,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_getHeader(1,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_getHeader(1,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(1,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',1,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_getHeader(2,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_getHeader(2,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(2,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',2,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_getHeader(3,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_getHeader(3,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(3,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',3,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_getHeader(4,#data)}} e-headercell-weekend {{/if}}'" +
                " style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_getHeader(4,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(4,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',4,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_getHeader(5,#data)}} e-headercell-weekend {{/if}}'" +
                " style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_getHeader(5,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(5,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',5,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_getHeader(6,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;" +
                "{{if ~_getHeader(6,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_getHeader(6,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~renderDay('" + dayFormat + "',6,#data)}}</div>";

            parentTr += td;
            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "_CustomTemplate1"] = parentTr;
            $.templates(templates);
        },

        _getDayTemplate: function (dayFormat, dayLength, data) {

            var date = new Date(data),
                proxy = this, model = proxy.model;
            date.setDate(date.getDate() + dayLength);

            switch (dayFormat) {
                case "D":
                case "d":
                    return date.getDate();
                case "DD":
                case "dd":
                    return (('0' + date.getDate()).slice(-2));                    
                case "DDD":
                case "ddd":
                case "DDDD":
                case "dddd":
                    return ej.format(date, dayFormat, model.locale);                                  
                case "":
                    dayFormat = "ddd";
                    return ej.format(date, dayFormat, model.locale)[0].toUpperCase();
                default:                    
                    return ej.format(date, dayFormat, model.locale).toUpperCase();
            }
        },

        // get schedule months for year month schedule mode.
        _getScheduleMonth: function (startdate, enddate) {
            var proxy = this,
                model = proxy.model,
                dates = [],
                count = 0;

            enddate = enddate.getMonth() < 11 ? new Date(enddate.getFullYear(), 11, 31) : enddate;
            var endMonth = new Date(startdate.getFullYear(), 11, 31) < new Date(model.scheduleEndDate) ? 12 : new Date(model.scheduleEndDate).getMonth() + 1;

          
            for (var i = startdate.getMonth() ; startdate < enddate; i++) {
                dates.push(startdate);
                startdate = new Date(startdate.getFullYear(), startdate.getMonth() + 1, 1);
                //startdate.setMonth(i + 1);
            }

            return dates;
        },


        //Method to render schedule header
        _createSchedule: function (startdate, enddate) {

            var proxy = this,
                model=proxy.model,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                $colsgroup, $column, $thead,
                $tr, $td, $div, $table;

            startdate = startdate == null ? new Date() : startdate;
            enddate = enddate == null ? new Date(null) : enddate;

            proxy._createScheduleWeekTemplate();
            proxy._createScheduleYearTemplate();
            proxy._createScheduleTopMonthTemplate();//template for MONTH week schedule mode
            proxy._createScheduleTopDayTemplate();
            proxy._createScheduleTopHourTemplate();
            $table = ej.buildTag("table.e-schedule-headerrow-week", "",
                { 'display': 'block' },
                { 'cell-spacing': '0' }
            );

            $colsgroup = ej.buildTag("colgroup", "", {}, {});
            $column = $(document.createElement("col"));
            $column.css("width", proxy._getScheduleLength(scheduleMode) + 'px');
            
            $colsgroup.append($column);

            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});

            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleWeekTemplate"](proxy.model.scheduleWeeks), {}, {});
            else if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleYearTemplate"](proxy.model.scheduleYears), {}, {});
            else if (scheduleMode == "month")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopMonthTemplate"](proxy.model.scheduleMonths), {}, {});
            else if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopDayTemplate"](proxy.model.scheduleDays), {}, {});
            else if (scheduleMode == "hour")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopHourTemplate"](proxy.model.scheduleHours), {}, {});

            $td = ej.buildTag("th.schedule", "", {}, {});
            $div = ej.buildTag("div.schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);

            $tr = null;

            proxy._createScheduleDayTemplate();
            proxy._createScheduleMonthTemplate();//for year - month schedule mode
            proxy._createScheduleBottomWeekTemplate(); //for month - week schedule mode
            proxy._createMinuteTemplate();
            proxy._createScheduleHourTemplate();

            $table = ej.buildTag("table.e-schedule-headerrow-day", "",
                {
                    'display': 'block',
                    'border-collapse': 'collapse'
                }, { 'cell-spacing': '0' });
            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});
            
            var scheduleMonths = proxy._getScheduleMonth(new Date(model.scheduleYears[0]), enddate);
            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "_CustomTemplate1"](model.scheduleWeeks), {}, {});
            if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleMonthTemplate"](scheduleMonths), {}, {});
            if (scheduleMode == "month")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleBottomWeekTemplate"](proxy._numOfWeeks), {}, {});
            if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "scheduleHourTemplate"](proxy._getScheduleHours()), {}, {});
            if (scheduleMode == "hour")               
                 $tr = ej.buildTag("tr", $.render[this._id + "scheduleMinuteTemplate"](proxy._getScheduleMinutes()), {}, {});

            $td = ej.buildTag("th.schedule", "", {}, {});
            $div = ej.buildTag("div.schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);

            proxy._$headerContainer.append(proxy._$scheduleDiv);
            proxy._$ganttChartContainer.append(proxy._$headerContainer);
            $("#" + proxy._id).append(proxy._$ganttChartContainer);
        },

        _getScheduleHours: function () {
            var proxy = this, model = proxy.model,
                startHour = new Date(proxy.model.projectStartDate),
                endHour = new Date(model.projectEndDate);
                proxy._scheduleHours = [];
                endHour.setHours(24);
            do {
                proxy._scheduleHours.push(new Date(startHour));
                startHour.setHours(startHour.getHours() + 1);
            } while (!(startHour.getTime()>= endHour.getTime()));

            return proxy._scheduleHours;
        },
        //Calculate total number of minutes to render template.
        _getScheduleMinutes: function () {
            var proxy = this, model = proxy.model,                
                startDate = new Date(proxy.model.projectStartDate),
                endDate = new Date(model.projectEndDate);
            endDate.setMinutes(60);
            startDate.setMinutes(0);
            proxy._scheduleMinutes = [];
            do {
                proxy._scheduleMinutes.push(new Date(startDate));
                startDate.setMinutes(startDate.getMinutes() + model.minuteInterval);
            } while (!(startDate.getTime() >= endDate.getTime()));
        
            return proxy._scheduleMinutes;
        },
        createGridLinesTable: function () {
            var proxy=this,
                model = proxy.model,
                $gridLinesTable,
                gridLineTable,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleLength,
                tableRows;

            $gridLinesTable = ej.buildTag("table.e-ganttgridLinesTable#ganttgridLinesTable" + proxy._id, "", {
                'z-index': '2',
                'position': 'absolute',
            }, { 'cellspacing': '0px' });
            var $colsgroup = ej.buildTag("colgroup", "", {}, {});
            var $column = $(document.createElement("col"));

            switch (scheduleMode) {
                case "week":
                    scheduleLength = model.scheduleWeeks.length,
                    $gridLinesTable.css("width",(scheduleLength * proxy._scheduleWeekWidth) + 'px');
                    $column.css("width", (scheduleLength * this._scheduleWeekWidth) + 'px');
                    break;

                case "year":
                    scheduleLength = model.scheduleYears.length,                    
                    $gridLinesTable.css("width", (proxy._scheduleYearWidth) + 'px');
                    $column.css("width", (this._scheduleYearWidth) + 'px');

                    break;
                case "month":
                    scheduleLength = model.scheduleMonths.length,
                    $gridLinesTable.css("width", (proxy._scheduleMonthWidth) + 'px');
                    $column.css("width", (this._scheduleMonthWidth) + 'px');
                    break;
                case "day":
                    scheduleLength = model.scheduleDays.length,
                    $gridLinesTable.css("width", (scheduleLength * (proxy.model.perHourWidth*24)) + 'px');
                    $column.css("width", (scheduleLength * (proxy.model.perHourWidth * 24)) + 'px');
                    break;
                case "hour":
                    scheduleLength = model.scheduleHours.length,
                    $gridLinesTable.css("width", (scheduleLength * (proxy.model.perMinuteWidth * proxy._totalInterval)) + 'px');
                    $column.css("width", (scheduleLength * (proxy.model.perMinuteWidth * proxy._totalInterval)) + 'px');
                    break;
                default:
                    break;

            }

            $colsgroup.append($column);
            $gridLinesTable.append($colsgroup);

            tableRows = proxy._createGridLinesTableRow(model.updatedRecords.length);
            
            var $gridLinesTablebody = ej.buildTag("tbody.e-gantt-viewer-gridLinesTablebody#gridLinesTablebody" + proxy._id + "",
                tableRows, {}, {});
            proxy._$gridLinesTablebody = $gridLinesTablebody;
            $gridLinesTable.append(proxy._$gridLinesTablebody);
            proxy._$bodyContent.append($gridLinesTable);
        },


        _createGridLinesTableRow: function (length) {
            var proxy = this,
                tableRows="";

            for (var i = 0; i < length; i++) {
                tableRows += "<tr style='display:table-row;height:" + this.model.rowHeight + "px'><td class='e-ganttgridlines'></td></tr>";
            }
            return tableRows;
        },

        _SelectState: function (args) {
            var proxy = this,
                model = this.model;
            if (model.allowSelection)
                return true;
            else
                return false;
        },

        _getFontSize: function () {
            var proxy = this,
                model = proxy.model,
                taskbarHeight = model.taskbarHeight, fontSize;
            fontSize = (70 * taskbarHeight) / 100;
            var decimalPoint = fontSize % 1;
            fontSize = decimalPoint == 0.5 ? fontSize : (decimalPoint < 0.5 ? Math.floor(fontSize) : Math.ceil(fontSize));
            return fontSize;
        },
        _getLeftTaskLabel: function () {
            var proxy = this,
                model = proxy.model,
                leftMappingItems = "",
                length = model._columns.length;
         
            if (this.model.leftTaskLabelMapping == this.model.resourceNameMapping)
                leftMappingItems = "{{:~_resources(#data)}}";
            else if (this.model.leftTaskLabelMapping == this.model.predecessorMapping)
                leftMappingItems = "{{:predecessorsName}}";
            else {
                for (var i = 0; i < length; i++) {
                    if (this.model.leftTaskLabelMapping == model._columns[i].mappingName) {
                        leftMappingItems = "{{:" + model._columns[i].field + "}}";
                        break;
                    }
                }
            }
            if (leftMappingItems == "") {
                leftMappingItems = "{{:" + this.model.leftTaskLabelMapping + "}}";
            }
            return leftMappingItems;
        },
        _getRightTaskLabel: function () {
            var proxy = this,
                model = proxy.model,
                rightMappingItems = "",
                length = model._columns.length;
            if (this.model.rightTaskLabelMapping == this.model.resourceNameMapping)
                rightMappingItems = "{{:~_resources(#data)}}";
            else if (this.model.rightTaskLabelMapping == this.model.predecessorMapping)
                rightMappingItems = "{{:predecessorsName}}";
            else {
                for (var i = 0; i < length; i++) {
                    if (this.model.rightTaskLabelMapping == model._columns[i].mappingName) {
                        rightMappingItems = "{{:" + model._columns[i].field + "}}";
                        break;
                    }
                }
            }
            if (rightMappingItems == "") {
                rightMappingItems = "{{:" + this.model.rightTaskLabelMapping + "}}";
            }
            return rightMappingItems;
        },

        _getMargin: function () {
            var proxy = this,
                taskbarHeight = this.model.taskbarHeight, margin;
            margin = (taskbarHeight - proxy._fontSize-3) / 2;                        
            return Math.floor(margin);
        },

        _getResizerLeftAdjust: function () {
            var proxy = this,
                taskbarHeight = this.model.taskbarHeight,
                fontSize = proxy._fontSize,
                margin = proxy._resizerMargin, leftResize;
            leftResize = (2 * taskbarHeight) / 100;
            var decimalPoint = leftResize % 1;
            leftResize = decimalPoint < 0.5 ? Math.floor(leftResize) : Math.ceil(leftResize);
            leftResize = leftResize < 0 ? 0 : leftResize;
            return leftResize;
        },

        //Template to render taskbar and milestone items
        _createTaskbarTemplate: function () {

            var proxy = this,
                model = proxy.model,
                tdWidth,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                tr, baselineHeight = 4, taskbarHeight, baseLineTop,
                shrinkedTaskbarHeight = 0,
                labelHeight,
                milesStoneRadius = 0,
                connectorPointWidth = 0,
                connectorPointRadius = 0,
                connectorPointMargin = 0,
                tHeight = 0,
                leftLabelFlag = false,
                rightLabelFlag = false,
                leftField = "",
                touchLeftConnectorpoint = "",
                touchRightConnectorpoint = "",
                rightField = "", istouchLeftConnectorpoint = false,
                baselineColor = model.baselineColor,
                template = model.taskbarTemplate, taskbarTemplate, isTaskbarTemplate = false, isProgressbarTemplate = false,
                parentTemplate = model.parentTaskbarTemplate, parentTaskbarTemplate, isParentTaskbarTemplate = false, isParentProgressbarTemplate = false,
                milestoneTemplate = model.milestoneTemplate, isMilestoneTemplate = false, milestoneTemplateString = "",
                leftTaskLabelTemplate = model.leftTaskLabelTemplate, isLeftTaskLabelTemplate = false, leftTaskLabelTemplateString = "",
                rightTaskLabelTemplate = model.rightTaskLabelTemplate, isRightTaskLabelTemplate = false, rightTaskLabelTemplateString = "",
                helpers = {
                    _SelectState: $.proxy(proxy._SelectState, proxy),
                    _getType: proxy._getTypedata,
                    _expander: proxy._addRecordExpandCollapse,
                    _milestoneMapping: proxy._isMilestone,
                    _resources: $.proxy(proxy._getResourceInfo, proxy),
                    _rowClassName: ej.TreeGrid._getrowClassName,//proxy._getrowClassName,
                    _expandStatus: $.proxy(proxy._getExpandStatusRecord, proxy),
                    _borderRadius: proxy._getBorderRadius,
                };
            proxy._fontSize = proxy._getFontSize();
            proxy._resizerRightAdjust = proxy._fontSize * 0.8;
            proxy._resizerMargin = proxy._getMargin();
            proxy._resizerLeftAdjust = proxy._getResizerLeftAdjust();

            if (scheduleMode == "week") {
                tdWidth = model.scheduleWeeks.length * proxy._scheduleWeekWidth;
            }
            else if (scheduleMode == "year") {
                tdWidth = proxy._scheduleYearWidth;
            }
            else if (scheduleMode == "month") {
                tdWidth = proxy._scheduleMonthWidth;
            }
            else if (scheduleMode == "day") {
                tdWidth = model.scheduleDays.length * (model.perHourWidth * 24);
            }
            else if (scheduleMode == "hour") {
                tdWidth = model.scheduleHours.length * (model.perMinuteWidth * proxy._totalInterval);
            }
            if (model.renderBaseline) {
                //taskbarHeight = model.rowHeight;
                var height;
                if ((model.taskbarHeight + baselineHeight) <= model.rowHeight) {
                    height = model.taskbarHeight;
                    baseLineTop = 0;
                }
                else {
                    height = model.taskbarHeight - baselineHeight;
                    baseLineTop = -4;
                }
                taskbarHeight = height;
                shrinkedTaskbarHeight = 0;
                labelHeight = model.rowHeight - baselineHeight - 5;
            } else {
                taskbarHeight = model.taskbarHeight;
                labelHeight = model.rowHeight - 10;
            }
            tHeight = taskbarHeight /5;
            milesStoneRadius = Math.floor((model.taskbarHeight) / 2);
            proxy._milesStoneWidth = (milesStoneRadius * 2);
            proxy._connectorPointWidth = connectorPointWidth = taskbarHeight / 2;
            connectorPointRadius = connectorPointWidth / 2;
            connectorPointMargin = connectorPointWidth - (connectorPointWidth / 2);
            $.views.helpers(helpers);

            if (!model.progressMapping) {


                this.model.showProgressStatus = false;
            }

            if (!model.resourceInfoMapping) {
                model.showResourceNames = false;
            }

            //Process child taskbar template
            if (template) {
                var parentDiv = ej.buildTag("div", "", {}, {});
                var templateString = template.charAt(0);
                isTaskbarTemplate = true;
                var taskbarTemplateString = "";
                if (template.charAt(0) == "#") {
                    taskbarTemplate = $(template)[0].innerHTML;
                }
                else
                    taskbarTemplate = template;
                taskbarTemplate = taskbarTemplate.replace(/src/gi, proxy._id + "src");
                $(parentDiv[0]).html(taskbarTemplate);
                $(parentDiv[0].childNodes).each(function () {
                    if ($(this).hasClass("e-gantt-template-taskbar")) {
                        var classes = "e-gantt-childtaskbar " + $(this).attr("class");
                        $(this).css({ "height": (taskbarHeight) + "px"}).attr("class", classes);
                        var innerHtml = "";
                        $(this.childNodes).each(function () {
                            if ($(this).hasClass("e-gantt-template-progressbar")) {
                                isProgressbarTemplate = true;
                                var classes = "e-gantt-childtaskbar-progress " + " " + $(this).attr("class");
                                $(this).css({
                                    "height": (model.progressbarHeight * ((taskbarHeight) / 100)) + "px",
                                    "position": "absolute", "top": "-1px", "left": "-1px",
                                }).attr("class", classes);
                                var outerHtml = this.outerHTML,
                                    index = outerHtml.indexOf("style");
                                outerHtml = outerHtml.substr(0, index + 7) + "border-style:{{if progressWidth}}solid{{else}}none{{/if}};width:{{:progressWidth}}px;" + outerHtml.substr(index + 7);
                                innerHtml += outerHtml;
                            }
                            else
                                innerHtml += (this.nodeName == "#comment" ? "" : (this.nodeName == "#text") ? (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")) : this.outerHTML);
                        });
                        var outerHtml = $(this).clone().empty()[0].outerHTML,
                            index = outerHtml.indexOf("style");
                        outerHtml = outerHtml.substr(0, index + 7) + "left:{{:left}}px;width:{{:width}}px;" + outerHtml.substr(index + 7);
                        var innerIndex = (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) ? outerHtml.indexOf("</" + this.tagName + ">") : outerHtml.indexOf("</" + this.tagName.toLowerCase() + ">");
                        outerHtml = outerHtml.substr(0, innerIndex) + innerHtml + outerHtml.substr(innerIndex);
                        taskbarTemplateString += outerHtml;
                    }
                    else {
                        taskbarTemplateString += (this.nodeName == "#comment" ? "" : (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")));
                    }
                });
                taskbarTemplateString = taskbarTemplateString.replace(RegExp((proxy._id + "src").toLowerCase(), "g"), "src");
            }

            //Process parent taskbar template
            if (parentTemplate) {
                var parentDiv = ej.buildTag("div", "", {}, {});
                var parentTemplateString = parentTemplate.charAt(0);
                isParentTaskbarTemplate = true;
                var parentTaskbarTemplateString = ""
                if (parentTemplateString == "#") {
                    parentTaskbarTemplate = $(parentTemplate)[0].innerHTML;
                }
                else
                    parentTaskbarTemplate = parentTemplate;
                parentTaskbarTemplate = parentTaskbarTemplate.replace(/src/gi, proxy._id + "src");
                $(parentDiv[0]).html(parentTaskbarTemplate);
                $(parentDiv[0].childNodes).each(function () {
                    if ($(this).hasClass("e-gantt-template-taskbar")) {
                        $(this).addClass("e-parentTask");
                        var classes = "e-gantt-parenttaskbar-innerdiv e-parentTask" + $(this).attr("class");
                        $(this).css({ "height": (taskbarHeight) + "px"}).attr("class", classes);
                        var innerHtml = "";
                        $(this.childNodes).each(function () {
                            if ($(this).hasClass("e-gantt-template-progressbar")) {
                                var classes = "e-gantt-parenttaskbar-progress e-parentTask" + " " +$(this).attr("class");
                                $(this).css({
                                    "height": (model.progressbarHeight * ((taskbarHeight) / 100)) + "px", "top": "-1px", "left": "-1px",
                                    "position": "absolute", "z-index": "3",
                                }).attr("class", classes);
                                var outerHtml = this.outerHTML,
                                    index = outerHtml.indexOf("style");
                                outerHtml = outerHtml.substr(0, index + 7) + "border-style:{{if progressWidth}}solid{{else}}none{{/if}};width:{{:progressWidth}}px;" + outerHtml.substr(index + 7);
                                innerHtml += outerHtml;
                            }
                            else {
                                innerHtml += (this.nodeName == "#comment" ? "" : (this.nodeName == "#text") ? (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")) : this.outerHTML);
                            }
                        });
                        var outerHtml = $(this).clone().empty()[0].outerHTML,
                            index = outerHtml.indexOf("style");
                        outerHtml = outerHtml.substr(0, index + 7) + "left:{{:left}}px;width:{{:width}}px;" + outerHtml.substr(index + 7);
                        var innerIndex = (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) ? outerHtml.indexOf("</" + this.tagName + ">") : outerHtml.indexOf("</" + this.tagName.toLowerCase() + ">");
                        outerHtml = outerHtml.substr(0, innerIndex) + innerHtml + outerHtml.substr(innerIndex);
                        parentTaskbarTemplateString += outerHtml;
                    }
                    else {
                        parentTaskbarTemplateString += (this.nodeName == "#comment" ? "" : (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")));
                    }
                });
                parentTaskbarTemplateString = parentTaskbarTemplateString.replace(RegExp((proxy._id + "src").toLowerCase(), "g"), "src");
            }

            // Process milestone template
            if (milestoneTemplate) {
                var parentDiv = ej.buildTag("div", "", {}, {});
                var templateString = milestoneTemplate.charAt(0), template;
                isMilestoneTemplate = true;
                if (templateString == "#") {
                    template = $(milestoneTemplate)[0].innerHTML;
                }
                else
                    template = milestoneTemplate;
                template = template.replace(/src/gi, proxy._id + "src");
                $(parentDiv[0]).html(template);
                $(parentDiv[0].childNodes).each(function () {
                    if ($(this).hasClass("e-gantt-template-milestone")) {
                        var classes = "e-gantt-milestone " + $(this).attr("class");
                        $(this).css({
                            "width": (model.taskbarHeight - 3) + "px", //6 is margin-top and margin-bottom total
                            "position": "absolute", "z-index": "3"
                        }).attr("class", classes);
                        var outerHtml = this.outerHTML,
                            index = outerHtml.indexOf("style");
                        outerHtml = outerHtml.substr(0, index + 7) + "left:{{:left}}px;" + outerHtml.substr(index + 7);
                        milestoneTemplateString += outerHtml;
                    }
                    else {
                        milestoneTemplateString += (this.nodeName == "#comment" ? "" : (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")));
                    }
                });
                milestoneTemplateString = milestoneTemplateString.replace(RegExp((proxy._id + "src").toLowerCase(), "g"), "src");
            }

            //leftTaskLabelTemplate mapping
            if (leftTaskLabelTemplate)
            {

                var templateString = leftTaskLabelTemplate.charAt(0);
                if (templateString == "#") {
                    if ($(leftTaskLabelTemplate)[0]) {
                        leftTaskLabelTemplateString = $(leftTaskLabelTemplate)[0].innerHTML;
                    }
                } else if (document.getElementById(leftTaskLabelTemplate))
                    leftTaskLabelTemplateString = $("#" + leftTaskLabelTemplate)[0].innerHTML;
                else
                    leftTaskLabelTemplateString = leftTaskLabelTemplate;

                isLeftTaskLabelTemplate = true;

            }

            //rightTaskLabelTemplate mapping
            if (rightTaskLabelTemplate)
            {
                
                var templateString = rightTaskLabelTemplate.charAt(0);
                if (templateString == "#") {
                    if ($(rightTaskLabelTemplate)[0])
                        rightTaskLabelTemplateString = $(rightTaskLabelTemplate)[0].innerHTML;
                } else if (document.getElementById(rightTaskLabelTemplate))
                    rightTaskLabelTemplateString = $("#" + rightTaskLabelTemplate)[0].innerHTML;
                else
                    rightTaskLabelTemplateString = rightTaskLabelTemplate;

                isRightTaskLabelTemplate = true;

            }
            if (this.model.leftTaskLabelMapping  && isLeftTaskLabelTemplate == false) {
                leftLabelFlag = true;
                leftField = proxy._getLeftTaskLabel();
            }

            if (this.model.rightTaskLabelMapping && isRightTaskLabelTemplate == false) {
                rightLabelFlag = true;
                rightField = proxy._getRightTaskLabel();
            }
            if (this.model.taskbarHeight < 45) {
                touchLeftConnectorpoint = "<div class='e-connectortouchpoint' style='right:0px;width:20px;margin-top:" + ((connectorPointWidth - 20) / 2) + "px;height:20px;" +
                "border-radius:10px'></div>";
                touchRightConnectorpoint = "<div class='e-connectortouchpoint' style='left:0px;width:20px;margin-top:" + ((connectorPointWidth - 20) / 2) + "px;height:20px;"
                    +"border-radius:10px'></div>";
            } 

            var rightLabelRowHeight = Math.round(-((this.model.rowHeight - 1) / 2));

            var parentTr = "<tr class='{{:~_rowClassName()}}  {{if isSelected && ~_SelectState()}}e-ganttrowcell {{:~_expander()}} e-gantt-mouseclick{{else}}e-ganttrowcell {{:~_expander()}}{{/if}}' id='chartrowcell"
                + proxy._id + "' style='display:{{:~_expandStatus(#data)}};background-color:{{if rowBGColor }}{{:rowBGColor}}{{else}} none{{/if}};height:" + model.rowHeight + "px;'>";
            var radius = "{{:~_borderRadius()}}";

            tr = "{{if ~_getType()}}" +

                //Parent taskbar Item

                "<td class='e-chartcell'>" +
                "<div class='e-tasknameContainer' style='height:" + (this.model.rowHeight - 1) + "px;width:{{if !isAutoSchedule}}{{if left<manualLeft}}{{:left-10}}{{else}}{{:manualLeft-10}}{{/if}}{{else}}{{:left-10}}{{/if}}px;overflow:hidden;text-overflow: ellipsis;'>" +
                "<div class='e-taskbarname'  style='overflow: hidden;text-overflow: ellipsis;margin-top:5px;margin-right:30px;height:" + (labelHeight) + "px;font-weight:bold'>{{if " + isLeftTaskLabelTemplate + "}}" +
                leftTaskLabelTemplateString + "{{else " + this.model.showTaskNames + " && left > 0 && !" + leftLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:taskName}}</span>" +
                "{{else " + leftLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + leftField + "</span>{{/if}}</div></div></td>" +

                "<td  class='e-chartcell' vertical-align='middle' style='width:" + tdWidth + "px;'>" +

               "<div class='e-parentContainer{{if !isAutoSchedule}} e-manualParenttaskbar{{/if}}' style='height:" + (this.model.taskbarHeight-1) + "px;z-index:3;'>" +

                
                //Manual Parent taskbar
                "{{if !isAutoSchedule}}<div class='e-gantt-manualparenttaskbar {{:~_expander()}}' style='left: {{:left}}px;height:" + (tHeight) + "px; width: {{:width}}px;'>" +
                "<div class='e-gantt-manualparenttaskbar-left' style='height:" + (taskbarHeight) + "px;border-left-width:" + tHeight + "px;border-bottom:" + tHeight + "px solid transparent;'></div>" +
                "<div class='e-gantt-manualparenttaskbar-right' style='left:{{:width - " + parseInt(tHeight) + "}}px;height:" + (taskbarHeight) + "px;border-right-width:" + tHeight + "px;border-bottom:" + tHeight + "px solid transparent;'></div>" +
                "<div class='taskbarresizer-right' style='left:{{:width -" + (tHeight) + "}}px;width:" + (tHeight) + "px;" +
                "height:" + (taskbarHeight) + "px;font-size:" + proxy._fontSize + "px;position:absolute;z-index:10;'></div>" +
                "</div>{{/if}}" +

                "{{if " + isParentTaskbarTemplate + "}}" + parentTaskbarTemplateString + "{{else}}" +
                "<div class='e-gantt-parenttaskbar-innerdiv {{:~_expander()}} e-parentTask' style='margin-top:{{if !isAutoSchedule}}" + (tHeight * 2) +
                "{{/if}}px;background-color:{{if parentTaskbarBackground }}{{:parentTaskbarBackground}}{{else}} " + this.model.parentTaskbarBackground +
                "{{/if}}; left:{{if isAutoSchedule}}{{:left}}{{else}}{{:manualLeft}}{{/if}}px;width:{{if isAutoSchedule}}{{:width}}{{else}}{{:manualWidth}}{{/if}}px;height:{{if isAutoSchedule}}" +(taskbarHeight)+ "{{else}}" + (tHeight * 3) + "{{/if}}px;'>" +

                "<div  class='e-gantt-parenttaskbar-progress {{:~_expander()}} e-parentTask progressbar' id='progressbar'  " +
                "style='top:-1px;border-style:{{if progressWidth}}solid{{else}}none{{/if}}; left:-1px;width:{{:progressWidth}}px;position:absolute;background-color:{{if parentProgressbarBackground }}{{:parentProgressbarBackground}}{{else}} "
                + this.model.parentProgressbarBackground + "{{/if}};z-index:3;" +
                "border-top-right-radius:{{if isAutoSchedule}}" + radius + "{{else}}" + tHeight + "{{/if}}px;border-bottom-right-radius:{{if isAutoSchedule}}" + radius + "{{else}}"
                + tHeight + "{{/if}}px;height:{{if isAutoSchedule}}" + (taskbarHeight) + "{{else}}" + (tHeight * 3) + "{{/if}}px;'></div>" + "</div>" + "{{/if}}" +

                  

             "</div>" +

                "{{if " + this.model.renderBaseline + " && baselineStartDate && baselineEndDate }}" +
                "<div  class='e-baselinebar' style='margin-top:" + baseLineTop +"px;left:{{:baselineLeft}}px;" +
                "width:{{:baselineWidth}}px;height:" + baselineHeight + "px;background-color: " + baselineColor + ";" +
                "position:absolute;z-index:3;box-sizing:border-box;-moz-box-sizing:border-box;'></div>{{/if}}" +

                "</td>" +

               "<td class='e-chartcell' >" +
                "<div class='e-resourceinfo' style='left:{{if (left+width)>(manualLeft+manualWidth)}}{{:left+width+30}}{{else}}{{:manualLeft+manualWidth+30}}{{/if}}px;" +
                "margin:0;margin-left:5px;margin-top:" + rightLabelRowHeight + "px;position:absolute;background-color:transparent;font-weight:bold;height:" + (this.model.rowHeight - 1) + "px;'>" +
                "<div class='e-resourcename'  style='overflow-y:hidden;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;outline:none;'>{{if " + isRightTaskLabelTemplate + "}}" + rightTaskLabelTemplateString +
                "{{else " + this.model.showResourceNames + " && left > 0 && !" + rightLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:~_resources(#data)}}</span>" +
                "{{else " + rightLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + rightField + "</span>{{/if}}</div></div></td>" +


               //Milestone Item

                "{{else ~_milestoneMapping()}}" +
                    
                "<td class='e-chartcell'>" +
                "<div class='e-tasknameContainer' style='height:" + (this.model.rowHeight - 1) + "px;width:{{:left-10}}px;overflow:hidden;text-overflow:ellipsis;'>" +
                "<div class='e-taskbarname'  style='overflow: hidden;text-overflow: ellipsis;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isLeftTaskLabelTemplate + "}}" + leftTaskLabelTemplateString +
                "{{else " + this.model.showTaskNames + " && left > 0 && !" + leftLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:taskName}}</span>"
                + "{{else " + leftLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + leftField + "</span>{{/if}}</div></div></td>" +

               "<td class='e-chartcell' style='width:" + tdWidth + "px;'>" +
                "<div class='e-gantt-milestone-container' style=height:" + (this.model.taskbarHeight - 1) + "px;>" +
                "<div class='e-connectorpoint-left' style='left:{{:left-" + connectorPointWidth + "}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;border-radius:" +
                connectorPointRadius + "px;'>" + touchLeftConnectorpoint + "</div>" +
                "{{if " + isMilestoneTemplate + "}}" + milestoneTemplateString + "{{else}}" +
                "<div class='e-gantt-milestone' style='position:absolute;left:{{:left}}px;'>" +
                "<div class='e-gantt-milestone milestone-top'  style='border-right-width:" + milesStoneRadius + "px;border-left-width:" + milesStoneRadius + "px;border-bottom-width:" + milesStoneRadius + "px; border-right-color:transparent;border-left-color:transparent;border-style:none solid solid;border-top: none;'></div>" +
                "<div class='e-gantt-milestone milestone-bottom'  style='top:" + (milesStoneRadius) + "px;border-right-width:" + milesStoneRadius + "px; border-left-width:" + milesStoneRadius + "px; border-top-width:" + milesStoneRadius + "px; border-right-color:transparent;border-left-color:transparent;border-style:solid solid none; border-bottom: none;'></div>" +
                "</div>" + "{{/if}}" +
                 "<div class='e-connectorpoint-right' style='left:{{:(left+" + (milesStoneRadius * 2) + ")}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;border-radius:"
                 + connectorPointRadius + "px;'>" + touchRightConnectorpoint + "</div>" +
                "</div>" +

                "{{if " + this.model.renderBaseline + " && baselineStartDate && baselineEndDate}}" +
                "<div class='e-baseline-gantt-milestone-container' >" +
                "<div class='e-baseline-gantt-milestone' style='position:absolute;left:{{:baselineRight}}px;z-index:2;'>" +
                "<div class='e-baseline-gantt-milestone baseline-milestone-top'  " +
                "style='z-index:2;top:" + (- this.model.taskbarHeight) + "px;border:" + milesStoneRadius + "px solid transparent;border-top: none;border-bottom-color: " + baselineColor + ";'></div>" +
                "<div class='e-baseline-gantt-milestone baseline-milestone-bottom'  " +
                "style='z-index:2;top:" + (milesStoneRadius - this.model.taskbarHeight) + "px;border:" + milesStoneRadius + "px solid transparent;border-bottom: none;border-top-color: " + baselineColor + ";'></div>" +
                "</div></div>" +
                "{{/if}}" +

                "</td>" +

               "<td class='e-chartcell' >" +
                "<div class='e-resourceinfo' style='margin-top:5px;left:{{:left+56}}px;margin:0;margin-left:5px;margin-top:" + rightLabelRowHeight + "px;height:" + (this.model.rowHeight - 1) + "px;" +
                "position:absolute;background-color:transparent;'><div class='e-resourcename'  style='overflow-y:hidden;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isRightTaskLabelTemplate + "}}" +
                rightTaskLabelTemplateString + "{{else " + this.model.showResourceNames + " && left > 0 && !" + rightLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:~_resources(#data)}}</span>" +
                "{{else " + rightLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + rightField + "</span>{{/if}}</div></div></td>" +

                //Child Taskbar Item

                "{{else}}" +

                //left label
               "<td class='e-chartcell'>" +
                "<div class='e-tasknameContainer' style='height:" + (this.model.rowHeight - 1) + "px;width:{{:left-10}}px;overflow:hidden;text-overflow: ellipsis;'>" +
                "<div class='e-taskbarname'  style='overflow: hidden;text-overflow: ellipsis;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isLeftTaskLabelTemplate + "}}" + leftTaskLabelTemplateString +
                "{{else " + this.model.showTaskNames + " && left > 0 && !" + leftLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:taskName}}</span>"
                + "{{else " + leftLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + leftField + "</span>{{/if}}</div></div></td>" +

                //taskbar
               "<td class='e-chartcell' style='width:" + tdWidth + "px;'>" +

               

               "<div  class='e-childContainer' style='height:" + (this.model.taskbarHeight - 1) + "px;'>" +

               "<div class='e-connectorpoint-left' style='left:{{:left-" + connectorPointWidth + "}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;" +
               "border-radius:" + connectorPointRadius + "px'>" + touchLeftConnectorpoint + "</div>" +

               "<div class='taskbarresizer-left e-icon' style='left:{{:left+2-" + proxy._resizerLeftAdjust + "}}px;width:10px;margin-top:" + proxy._resizerMargin + "px;height:" + (taskbarHeight) + "px;font-size:" + proxy._fontSize + "px;'></div>" +
               "{{if " + isTaskbarTemplate + "}}" + taskbarTemplateString + "{{else}}" +
               "<div  class='e-gantt-childtaskbar {{if isCritical}} e-criticaltaskbar{{/if}} {{if !isAutoSchedule}} manualchildtaskbar{{/if}}' style='left:{{:left}}px;width:{{:width}}px;height:"
               + (taskbarHeight) + "px;background-color:{{if taskbarBackground }}{{:taskbarBackground}}{{else}} "
               + this.model.taskbarBackground + "{{/if}};'>" +

               "<div  class='e-gantt-childtaskbar-progress  {{if isAutoSchedule}} progressbar{{else}} manualprogressbar{{/if}} {{if isCritical}} e-criticalprogressbar{{/if}}' id='progressbar' style='border-style:{{if progressWidth}}solid{{else}}none{{/if}};" +
                "width:{{:progressWidth}}px;text-align:right;line-height:" + (taskbarHeight - 1) + "px;" +
                //"margin-top:" + (((taskbarHeight) - (this.model.progressbarHeight * ((taskbarHeight) / 100))) / 2) + "px;" +
                "height:" + (this.model.progressbarHeight * (taskbarHeight / 100)) + "px; top:-1px;left:-1px;" +
                "position:absolute;background-color:{{if progressbarBackground }}{{:progressbarBackground}}{{else}} " + this.model.progressbarBackground + "{{/if}};" +
                "border-top-right-radius:" + radius + "px;border-bottom-right-radius:" + radius + "px;'>" +
                "{{if " + this.model.showProgressStatus + "}}<span class='e-tasklabel' style='line-height:" + (taskbarHeight - 1) + "px'>{{:status}}%</span>{{/if}}</div></div>" + "{{/if}}" +
                "{{if " + (!isTaskbarTemplate || isProgressbarTemplate) + "}}" +
               "<div class='progressbarresizer-right' style='left:{{:left+progressWidth-10}}px;width:20px;margin-top:" + (taskbarHeight-5) + "px;" +
               "height:15px;position:absolute;z-index:5;'>" +
               "<div class='progressbarhandler' style='top:" + (10) + "px;position:absolute;z-index:-1;'><div class='e-progresshandler-element'></div></div>" +//-" + (shrinkedTaskbarHeight/2) + "
               "<div class='progressbarhandler' style='top:" + (5) + "px;position:absolute;z-index:-1;'><div class='e-progresshandlerafter-element'></div></div></div>" + "{{/if}}" +

               "<div class='taskbarresizer-right e-icon' style='left:{{:left+width-" + proxy._resizerRightAdjust + "}}px;width:10px;" +
                "height:" + (taskbarHeight) + "px;font-size:" + proxy._fontSize + "px;position:absolute;z-index:2;margin-top:" + proxy._resizerMargin + "px;'></div>" +

                "<div class='e-connectorpoint-right' style='left:{{:left+width}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;"
                + "border-radius:" + connectorPointRadius + "px'>" + touchRightConnectorpoint + "</div>" +
                //"<div class='e-connectorpoint-right' style='left:{{:left-20}}px;width:20px;margin-top:10px;background-color:black;height:" + (taskbarHeight) + "px;'></div>"+
                 "</div>" +

                "{{if " + this.model.renderBaseline + " && baselineStartDate && baselineEndDate }}" +
                "<div  class='e-baselinebar' style='margin-top:"+ baseLineTop + "px;left:{{:baselineLeft}}px;" +
                "width:{{:baselineWidth}}px;height:" + baselineHeight + "px;background-color: " + baselineColor + ";" +
                "position:absolute;z-index:3;box-sizing:border-box;-moz-box-sizing:border-box;'></div>{{/if}}" +

                "</td>" +

                //right label
               "<td class='e-chartcell' >" +
                "<div class='e-resourceinfo' style='left:{{:left+width+30}}px;margin:0;margin-left:5px;margin-top:" + rightLabelRowHeight + "px;height:" + (this.model.rowHeight - 1) + "px;" +
                "position:absolute;text-align:left;background-color:transparent;'><div class='e-resourcename'  style='overflow-y:hidden;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isRightTaskLabelTemplate + "}}"
                + rightTaskLabelTemplateString + "{{else " + this.model.showResourceNames + " && left > 0 && !" + rightLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:~_resources(#data)}}</span>" +
                "{{else " + rightLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + rightField + "</span>{{/if}}</div></div></td>{{/if}}";

            parentTr += tr;
            parentTr += "</tr>";

            var templates = {};
            templates[this._id + "_CustomTemplate2"] = parentTr;
            $.templates(templates);

        },

        _getResourceInfo: function (data) {
            var resource = null;
            if (data.resourceInfo != null) {
                var resourcelength = data.resourceInfo.length;
                if (resourcelength > 0) {
                    for (var i = 0; i < resourcelength; i++) {
                        var unit = data.resourceInfo[i][this.model.resourceUnitMapping];
                        if (resource == null) {                           
                            resource = data.resourceInfo[i][this.model.resourceNameMapping];
                            if (unit != 100)
                                resource += "[" + unit + "%]";
                        }
                        else {
                            resource += " , " + data.resourceInfo[i][this.model.resourceNameMapping];
                            if (unit != 100)
                                resource += "[" + unit + "%]";
                        }
                    }
                    return resource;
                } else
                    return String.empty;
            }
            return String.empty;
        },

        _getrowClassName: function () {
            var rowClass = "gridrowtaskId",
                proxy = this;
            if (proxy.data.parentItem)
                rowClass += proxy.data.parentItem.taskId.toString();
            rowClass += "level";
            rowClass += proxy.data.level.toString();
            return rowClass;
        },

        _getExpandStatusRecord: function (data) {
            var proxy = this;
            if (proxy._getExpandStatus(data)) {
                return 'table-row';
            }
            return 'none';
        },


        _isMilestone: function () {
            if (this.data.isMilestone)
                return true;
            else
                return false;
        },

        _addRecordExpandCollapse: function () {
            if (this.data.expanded)
                return 'e-chartexpand';
            else if (!this.data.expanded && this.data.hasChildRecords) {
                return 'e-chartcollapse';
            }
            return false;
        },

        _getTypedata: function () {
            return this.data.hasChildRecords;
        },


        _getBorderRadius: function () {

            var proxy = this,
                diff = proxy.data.width - proxy.data.progressWidth;

            if (diff <= 4) {
                return 4 - diff;
            }
            else
                return 0;

        },

        _getHeightValue: function () {
            return (this.data.ParentIndex * this.data.RowHeight) > (this.data.ChildIndex * this.data.RowHeight) ? ((this.data.ParentIndex * this.data.RowHeight) - (this.data.ChildIndex * this.data.RowHeight)) : ((this.data.ChildIndex * this.data.RowHeight) - (this.data.ParentIndex * this.data.RowHeight));
        
        },

        _createConnectorLineTemplate: function () {
            var proxy = this,
                lineStroke = (proxy.model.connectorlineWidth) > 4 ? 4 : proxy.model.connectorlineWidth,
                shrinkedTaskbarHeight = 0,
                deltaTop, taskbarMidpoint,
                lineColor = proxy.model.connectorLineBackground,
                helpers = {
                    _getWidthVal: proxy._getWidth,
                    _getTop: proxy._getPredecessorTop,
                    _getPosition: proxy._getParentPosition,
                    _setContainerWidthSSType2: proxy._getContainerWidthSSType2,
                    _setInnerChildWidthSSType2: proxy._getInnerChildWidthSSType2,
                    _setInnerElementLeftSSType2: proxy._getInnerElementLeftSSType2,
                    _setInnerElementWidthSSType2: proxy._getInnerElementWidthSSType2,
                    _isMilestone: proxy._isTaskMilestone,
                    _isMilestoneParent: proxy._isMilestoneParent,
                    _getHeightValue:proxy._getHeightValue,
                };

            if (proxy.model.renderBaseline) {
                deltaTop = shrinkedTaskbarHeight / 2;
                taskbarMidpoint = ((proxy.model.rowHeight) / 2) - deltaTop;
            } else {
                taskbarMidpoint = ((proxy.model.rowHeight) / 2);
            }

            $.views.helpers(helpers);
            var connectorContainer = "<div  id='ConnectorLine{{:ConnectorLineId}}' style='background-color=black'>";

            var div = "{{if ~_getPosition()=='FSType1'}}"//FS
            + "<div style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:(ChildLeft - (ParentLeft + ParentWidth + 20))}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FSType1'>"
            + "<div class='e-line' style='left:{{if milestoneParent}}-7px{{else}}0px{{/if}};width:{{if milestoneParent}}{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-2}}px{{else}}{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-10}}px{{/if}};" +
                "border-top:" + lineStroke + "px solid " + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-10}}px;" +
                "width:0px;border-right:" + lineStroke + "px solid " + lineColor + ";border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid " + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-10}}px;width:10px;" +
                "border-top:" + lineStroke + "px solid " + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-rightarrow' style='left:{{:(ChildLeft - (ParentLeft + ParentWidth + 10))}}px;" +
                "border-left: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else  ~_getPosition()=='FSType2'}}"//FS
            + "<div style='left:{{:ParentLeft}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:~_getWidthVal()}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FSType2'>"
            + "<div class='e-line' style='left:{{if milestoneParent}}{{:ParentWidth-7}}px{{else}}{{:ParentWidth}}px{{/if}};width:{{if milestoneParent}}17px{{else}}10px{{/if}};border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:ParentWidth+10-" + lineStroke + "}}px;border-left:" + lineStroke + "px solid;width:0px;" +
                "border-top:{{:~_getHeightValue()-14-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div><div class='e-line' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 20))}}px;" +
                "width:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 30 )}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 20))}}px;width:0px;" +
                "border-top:{{:14-" + lineStroke + "}}px solid;border-left:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 20))}}px;width:10px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-rightarrow' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 10))}}px;" +
                "border-left: 10px solid " + lineColor + ";border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;top:{{:-6-" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='FSType3'}}"
            + "<div style='left:{{:ChildLeft-20}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ParentWidth+ChildWidth}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FSType3'>"
            + "<div class='connectorline-rightarrow' style='left:10px;border-left: 10px solid " + lineColor + ";" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;" +
                "top:{{:-5-" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";" +
                "position:relative;top:-13px;'></div>"
            + "<div class='e-line' style='width:" + lineStroke + "px;border-top:{{:~_getHeightValue()-14-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative;top:-13px;'></div>"
            + "<div class='e-line' style='width:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 30)}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative;top:-13px;'></div>"
            + "<div class='e-line' style='left:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 30)}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "height:{{:14-" + lineStroke + "}}px;border-color:" + lineColor + ";position:relative;" +
                "top:-13px;'></div>"
            + "<div class='e-line' style='{{if ~_isMilestoneParent()}}left:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 14)}}px;width:16px;{{else}}left:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 20)}}px;width:10px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative;top:-13px;'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='FSType4'}}"
            + "<div style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:(ChildLeft - (ParentLeft + ParentWidth + 20))}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FSType4'>"
            + "<div class='connectorline-rightarrow' style='left:{{:(ChildLeft - (ParentLeft + ParentWidth + 10))}}px;" +
                "border-left: 10px solid " + lineColor + ";top:{{:-5-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ChildLeft - (ParentLeft + ParentWidth) - 20)}}px;top:-13px;width:10px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;left:{{:(ChildLeft - (ParentLeft + ParentWidth) - 20)}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestoneParent()}}left:-6px;{{/if}}top:-13px;width:{{if ~_isMilestoneParent()}}{{:(ChildLeft-(ParentLeft + ParentWidth+20 )+ 6)+" + lineStroke + "}}px;{{else}}{{:(ChildLeft-(ParentLeft + ParentWidth + 20))+" + lineStroke + "}}px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='SSType4'}}"
            + "<div  style='left:{{:ParentLeft-10}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ChildLeft-ParentLeft}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SSType4'>"
            + "<div class='connectorline-rightarrow' style='left:{{:ChildLeft-ParentLeft}}px;border-left: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:{{:ChildLeft-ParentLeft}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='SSType3'}}"
            + "<div  style='left:{{:ChildLeft-20}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ParentLeft-ChildLeft}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SSType3'>"
            + "<div class='connectorline-rightarrow' style='left:10px;border-left: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:{{:ParentLeft-ChildLeft+20}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='SSType2'}}"
            + "<div  style='left:{{:~_setInnerElementLeftSSType2()}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:~_setContainerWidthSSType2()}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SSType2'>"
            + "<div class='e-line' style='width:{{:~_setInnerChildWidthSSType2()}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:{{:~_setInnerElementWidthSSType2()}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-rightarrow' style='left:{{:~_setInnerElementWidthSSType2()}}px;" +
                "border-left: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;" +
                "height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='SSType1'}}"
            + "<div  style='left:{{:ChildLeft-20}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ParentLeft-ChildLeft}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SSType1'>"
            + "<div class='e-line' style='width:{{:ParentLeft-ChildLeft+20}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='connectorline-rightarrow' style='left:10px;border-left: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='FFType1'}}"
            + "<div class='FFtype1' style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ChildLeft + ChildWidth)-(ParentLeft + ParentWidth))+30}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FFType1'>"
            + "<div class='e-line' style='left:{{if ~_isMilestoneParent()}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))-10}}px;{{else}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))}}px;{{/if}}" +
                "width:{{if ~_isMilestoneParent()}}30px;{{else}}20px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_isMilestoneParent()}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;{{else}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;{{/if}}width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_isMilestone()}}4px;{{else}}10px;{{/if}}width:{{if ~_isMilestone()}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+16}}px;{{else}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+10}}px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-leftarrow' style='{{if ~_isMilestone()}}left:-6px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='FFType2'}}"
            + "<div style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FFType2'>"
            + "<div class='e-line' style='{{if ~_isMilestoneParent()}}left:-6px;{{/if}}width:{{if ~_isMilestoneParent()}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+26}}px;{{else}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_isMilestone()}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+4}}px;{{else}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+10}}px;{{/if}}" +
                "width:{{if ~_isMilestone()}}16px;{{else}}10px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-leftarrow' style='left:{{if ~_isMilestone()}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))-6}}px;{{else}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='FFType3'}}"
            + "<div  style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FFType3'>"
            + "<div class='connectorline-leftarrow' style='{{if ~_isMilestone()}}left:-6px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-5-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestone()}}left:4px;width:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+16}}px;{{else}}left:10px;width:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+10}}px;{{/if}}top:-13px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;top:-13px;" +
                "width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestoneParent()}}left:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))-6}}px;width:26px;{{else}}left:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))}}px;width:20px;{{/if}}top:-13px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='FFType4'}}"
            + "<div  style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='FFType4'>"
            + "<div  class='connectorline-leftarrow' style='{{if ~_isMilestone()}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))-6}}px;{{else}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-5-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;" +
                "position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestone()}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+4}}px;width:16px;{{else}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+10}}px;width:10px;{{/if}}top:-13px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;top:-13px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestoneParent()}}left:-6px;width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+26}}px;{{else}}width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;{{/if}}top:-13px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else  ~_getPosition()=='SFType4'}}"//SF
            + "<div style='left:{{:ParentLeft-10}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;width:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+20}}px;" +
                "height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SFType4'>"
            + "<div class='connectorline-leftarrow' style='left:{{if ~_isMilestone()}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+4}}px;{{else}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+10}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-5-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;" +
                "position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_isMilestone()}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+14}}px;width:16px;{{else}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+20}}px;width:10px;{{/if}}top:-13px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;top:-13px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_getHeightValue()-15-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:15-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-13px;width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='SFType3'}}"//SF
            + "<div style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ParentLeft)-(ChildLeft + ChildWidth))}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SFType3'>"
            + "<div class='connectorline-leftarrow' style='{{if ~_isMilestone()}}left:-6px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-5-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestone()}}left:4px;width:16px;{{else}}left:10px;width:10px;{{/if}}top:-13px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:20px;top:-13px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:20px;top:-13px;width:{{:(ChildLeft-(ParentLeft + ParentWidth + 20))+" + lineStroke + "}}px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else  ~_getPosition()=='SFType1'}}"//SF
            + "<div style='left:{{:ParentLeft-10}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ChildLeft+ChildWidth+20}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SFType1'>"
            + "<div class='e-line' style='width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_getHeightValue()-15-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:15-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestone()}}left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+(15-" + lineStroke +")}}px;width:16px;{{else}}left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+20}}px;width:10px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-leftarrow' style='left:{{if ~_isMilestone()}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+4}}px;{{else}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+10}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;" +
                "width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_getPosition()=='SFType2'}}"//SF
            + "<div  style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ParentLeft) - (ChildLeft + ChildWidth))}}px;height:{{:~_getHeightValue()}}px;position:absolute' connectortype='SFType2'>"
            + "<div class='e-line' style='left:{{:((ParentLeft) - (ChildLeft + ChildWidth))-10}}px;width:10px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ParentLeft) - (ChildLeft + ChildWidth))-10}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='{{if ~_isMilestone()}}left:0px;width:{{:((ParentLeft) - (ChildLeft + ChildWidth))-10}}px;{{else}}left:10px;width:{{:((ParentLeft) - (ChildLeft + ChildWidth))-20}}px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='connectorline-leftarrow' style='left:{{if ~_isMilestone()}}-6px;{{else}}0px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{/if}}";

            connectorContainer += div;
            connectorContainer += "</div>";

            var templates = {};
            templates[this._id + "ConnectorLineTemplate"] = connectorContainer;
            $.templates(templates);
        },

        _isTaskMilestone: function () {
            if (this.data.milestoneChild)
                return true;
            else
                return false;
            
        },

        _isMilestoneParent: function () {
            if (this.data.milestoneParent)
                return true;
            else
                return false;
        },

        _getInnerChildWidthSSType2: function () {
            if ((this.data.ParentLeft + this.data.ParentWidth) < this.data.ChildLeft) {
                return 10;
            }
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return 20;
            }
            if ((this.data.ParentLeft + this.data.ParentWidth) >= this.data.ChildLeft) {
                return 10;
            }
            return (this.data.ChildLeft - this.data.ParentLeft);
        },

        _getInnerElementLeftSSType2: function () {
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return (this.data.ParentLeft - 20);
            }
            return (this.data.ParentLeft - 10);
        },

        _getInnerElementWidthSSType2: function () {
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return 10;
            }
            return (this.data.ChildLeft - this.data.ParentLeft);
        },


        _getContainerWidthSSType2: function () {
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return 20;
            }
            return (this.data.ChildLeft - this.data.ParentLeft);
        },

        _getPredecessorTop: function () {
            if (this.data.ParentIndex > this.data.ChildIndex)
                return true;
            else
                return false;
        },

        _getParentPosition: function () {
            if (this.data.ParentIndex < this.data.ChildIndex) {

                if (this.data.Type == "FF") {
                    if ((this.data.ChildLeft + this.data.ChildWidth) >= (this.data.ParentLeft + this.data.ParentWidth)) {
                        return "FFType2";
                    }
                    else {
                        return "FFType1";
                    }
                }

                else if ((this.data.ParentLeft < this.data.ChildLeft) && (this.data.ChildLeft > (this.data.ParentLeft + this.data.ParentWidth + 25))) {
                    if (this.data.Type == "FS") return "FSType1";
                    if (this.data.Type == "SF") return "SFType1";
                    else if (this.data.Type == "SS") return "SSType2";
                    else if (this.data.Type == "FF") return "FFType2";
                }
                else if ((this.data.ParentLeft < this.data.ChildLeft && (this.data.ChildLeft < (this.data.ParentLeft + this.data.ParentWidth)))
                    || (this.data.ParentLeft == this.data.ChildLeft || this.data.ParentLeft > this.data.ChildLeft)) {

                    if (this.data.ParentLeft > (this.data.ChildLeft + this.data.ChildWidth + 25)) {
                        if (this.data.Type == "SF") return "SFType2";
                    }

                    if (this.data.ParentLeft > this.data.ChildLeft) {
                        if (this.data.Type == "SS") return "SSType1";
                        if (this.data.Type == "SF") return "SFType1";
                        if (this.data.Type == "FF") return "FFType1";
                    }
                    else if ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType2";
                    }
                    if (this.data.Type == "FS") return "FSType2";
                    else if (this.data.Type == "SS") return "SSType2";
                    else if (this.data.Type == "FF") return "FFType1";
                    else if (this.data.Type == "SF") return "SFType1";
                }
                else if ((this.data.ParentLeft) < this.data.ChildLeft) {

                    if (this.data.Type == "FS") return "FSType2";
                    else if (this.data.Type == "FF") return "FFType2";
                    else if (this.data.Type == "SS") return "SSType2";
                    else if (this.data.Type == "SF") return "SFType1";
                }

            }
            else if (this.data.ParentIndex > this.data.ChildIndex) {
                if ((this.data.ParentLeft < this.data.ChildLeft) && (this.data.ChildLeft > (this.data.ParentLeft + this.data.ParentWidth))) {
                    if (this.data.Type == "FS")
                        if (30 >= (this.data.ChildLeft - (this.data.milestoneParent ? (this.data.ParentLeft + this.data.ParentWidth + 4) : (this.data.ParentLeft + this.data.ParentWidth))))
                            return "FSType3";
                        else
                            return "FSType4";
                    if (this.data.ParentLeft < this.data.ChildLeft || ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth))) {
                        if (this.data.Type == "SS") return "SSType4";
                        if (this.data.Type == "FF") return "FFType4";
                        if (this.data.Type == "SF") return "SFType4";
                    }
                    else if ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType4";
                    }
                }
                else if ((this.data.ParentLeft < this.data.ChildLeft && (this.data.ChildLeft < (this.data.ParentLeft + this.data.ParentWidth)))
                    || (this.data.ParentLeft == this.data.ChildLeft || this.data.ParentLeft > this.data.ChildLeft)) {
                    if ((this.data.ChildLeft + this.data.ChildWidth) <= (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType3";
                        if (this.data.Type == "SF") {
                            if ((this.data.ChildLeft + this.data.ChildWidth + 25) < (this.data.ParentLeft)) {
                                return "SFType3";
                            } else {
                                return "SFType4";
                            }
                        }
                        if (this.data.Type == "SS") {
                            if (this.data.ChildLeft <= this.data.ParentLeft)
                                return "SSType3";
                            else
                                 return "SSType4";
                        }
                    }
                    else if ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType4";
                        if (this.data.Type == "SF") return "SFType4";
                        if (this.data.Type == "SS")
                            if (this.data.ChildLeft <= this.data.ParentLeft)
                                return "SSType3";
                            else
                                return "SSType4";
                    }
                    if (this.data.Type == "FS") return "FSType3";
                }
                else if (this.data.ParentLeft < this.data.ChildLeft) {

                    if (this.data.Type == "FS") return "FSType3";
                    if (this.data.Type == "SS") return "SSType4";
                    if (this.data.Type == "FF") return "FFType4";
                    if (this.data.Type == "SF") return "SFType4";
                }
            }
            return false;
        },

        _getWidth: function () {
            return ((this.data.ChildLeft + this.data.ChildWidth) < (this.data.ParentLeft + this.data.ParentWidth)) ?
                this.data.ParentWidth : (this.data.ChildWidth + this.data.ParentWidth);
        },


        //renders Weekends in chart
        _renderWeekends: function () {
            var proxy = this,
                model = proxy.model,
                left = 0,
                width = (proxy.model.perDayWidth) + 1,
                height = ((proxy.model.updatedRecords.length) * this.model.rowHeight),
                count = proxy.model.scheduleWeeks.length,
                $sunday, $saturday, sundayIndex, saturdayIndex,
                $weekendContainer = ej.buildTag("div.e-secondary_canvas", "", { 'height': height + 'px' }, {}),
                weekStartDay = model.scheduleHeaderSettings.weekStartDay,
                dayIndex = (weekStartDay >= 0 && weekStartDay < 7) ? weekStartDay : 0,
                saturdayIndex = 6 - dayIndex,
                sundayIndex = (saturdayIndex + 1) == 7 ? 0 : (saturdayIndex + 1);
            for (var i = 0; i < count; i++) {
                $sunday = ej.buildTag("div.e-weekends", "", {
                    'left': (left + (proxy.model.perDayWidth * sundayIndex)) + 'px',
                    'width': width + 'px',
                    'height': height + 'px',
                    'background-color': this.model.weekendBackground
                }, {});
                $saturday = ej.buildTag("div.e-weekends", "", {
                    'left': (left + (proxy.model.perDayWidth * saturdayIndex)) + 'px',
                    'width': width + 'px',
                    'height': height + 'px',
                    'background-color': this.model.weekendBackground
                }, {});
                $weekendContainer.append($sunday);
                $weekendContainer.append($saturday);
                left = left + this._scheduleWeekWidth;
            }

            proxy._$weekendsContainer.html($weekendContainer);
            proxy._$bodyContent.append(proxy._$weekendsContainer);
        },



        //Renders StripLines for given striplines collection object
        _renderStripLines: function (stripLines) {

            var proxy = this,
                height = ((proxy.model.updatedRecords.length) * this.model.rowHeight),
                stripLineCount = stripLines.length, day, left,
                projectStartDate = proxy.model.projectStartDate,
                dayWidth = this.model.perDayWidth,
                stripLineContainer = ej.buildTag("div.e-stripLines", "", { 'height': height + 'px' }, {});

            for (var i = 0; i < stripLineCount; i++) {

                day = this._getDateFromFormat(stripLines[i].day);
                left = ((day - this._getDateFromFormat(projectStartDate)) / 86400000) * dayWidth;
                stripLines[i].lineWidth = stripLines[i].lineWidth > 30 ? 30 : stripLines[i].lineWidth;

                var stripline = ej.buildTag("div.e-stripline#stripline" + [i] + "", "", {
                    'left': left + 'px',
                    'width': '1px',
                    'height': height + 'px',
                    'border-left-width': stripLines[i].lineWidth + 'px',
                    'border-left-color': stripLines[i].lineColor,
                    'border-left-style': stripLines[i].lineStyle
                }, {});

                var innerspan = ej.buildTag("span.e-striplinespan", stripLines[i].label, {
                    'background-color': stripLines[i].lineColor,
                }, {});

                if (stripLines[i].day && stripLines[i].day.length > 0) {
                    if (stripLines[i].label && stripLines[i].label.length > 0) {
                        stripline.append(innerspan);
                    }
                    stripLineContainer.append(stripline);
                }
            }
            proxy._$stripLineContainer.append(stripLineContainer);
            proxy._$bodyContent.append(proxy._$stripLineContainer);
        },


        //returns progress width for the taskbar
        _getProgressWidth: function (parentwidth, percent) {
            return (parentwidth * percent) / 100;
        },


        //returns progress percentage of the taskbar
        _getProgressPercent: function (parentwidth, progresswidth) {
            return Math.ceil(((progresswidth / parentwidth) * 100).toFixed(2));
        },


        //renders holidays for holiday collection object
        _renderHoliday: function (holiday) {

            var proxy = this, scheduleHeaderType = proxy.model.scheduleHeaderSettings.scheduleHeaderType,
                date = this._getDateFromFormat(holiday.day),
                weekCount = proxy.model.scheduleWeeks.length,
                monthcount = proxy.model.scheduleMonths.length,
                yearcount = proxy.model.scheduleYears.length,
                daycount=proxy.model.scheduleDays.length,
                prevDate = 0,
                left = 0, textLength, text, $holidayContainer, $holidaySpan,
                ganttRecords = proxy.model.updatedRecords.length, height;

            left = ((date - this._getDateFromFormat(proxy.model.projectStartDate)) / 86400000) * this.model.perDayWidth;

            height = (ganttRecords * this.model.rowHeight);
            textLength = holiday.label != null ? holiday.label.length : 0;
            if (holiday.background == null)
                holiday.background = "white";


            var holidayLableSelector = ".e-holiday-label";
            /* for rotate holiday lable in ie8 */
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                holidayLableSelector = ".e-holiday-label-ie8";
            }
            if (proxy.model.scheduleHeaderSettings.scheduleHeaderType != "day") {
                text = ej.buildTag("div" + holidayLableSelector, holiday.label, {
                    'top': (proxy._getHolidayLabelHeight(textLength)) + 'px',
                }, {});
            }
            else
            {
                text = ej.buildTag("div" + holidayLableSelector, holiday.label, {
                    'bottom': (proxy._getHolidayLabelHeight(textLength)) + 'px',
                }, {});
            }
            $holidayContainer = ej.buildTag("div.e-secondary-canvas-holiday");
            $holidaySpan = ej.buildTag("div.e-holidays", "", {
                'left': left + 'px',
                'width': proxy.model.perDayWidth + 'px',
                'height': height + 'px',
                'background-color': holiday.background
            }, {});

            if (holiday.label != null)
                $holidaySpan.append(text);
            $holidayContainer.append($holidaySpan);

            proxy._$secondaryCanvas.append($holidayContainer);
            proxy._$bodyContent.append(proxy._$secondaryCanvas);
        },

        _getHolidayLabelHeight: function (textlength) {
            var proxy = this, model = proxy.model,
                containerHeight = proxy._getHeight(),
                totalHeight = model.updatedRecords.length * proxy.model.rowHeight;
            if (containerHeight > 0)
                return (containerHeight / 2);
            else if (proxy._viewportHeight < totalHeight)
                return (proxy._viewportHeight / 2);
            else
                return totalHeight / 2;

        },

        // all events bound using this._on will be unbind automatically
        _destroy: function () {

            var proxy = this;
            proxy.element.off();
            $(document.body).unbind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
            $(document).unbind("mouseup", $.proxy(proxy._tooltipMouseup, proxy));
            $(document.body).bind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
            proxy.element.empty().removeClass("e-ganttchart-core e-ganttchart" + proxy.model.cssClass);

        },
    });

    ej.GanttChart.contextMenuItem = {
        taskDetails: "Task Details....",
        add: "Add new task",
        indent: "Indent",
        outdent: "Outdent",
        Delete: "Delete",
    };

    jQuery.uaMatch = function (ua) {
        ua = ua.toLowerCase();

        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];

        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Radial Menu elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejRadialMenuBase", "ej.RadialMenuBase", {
        _tags: [{
            tag: "items",
            attr: ["imageName", "imagePath", "imageUrl", "windows.text", "flat.text", "text", "click", "touch", "enabled",
                "badge.enabled", "badge.value", "type", "sliderSettings.ticks", "sliderSettings.strokeWidth", "sliderSettings.labelSpace", [{
                    tag: "items", attr: ["imageName", "imagePath", "imageUrl", "windows.text", "flat.text", "text", "click",
                     "touch", "enabled"]
                }]]
        }],
        defaults: {
            radius: 150,
            cssClass: "",
            enableAnimation: true,
            open: null,
            close: null,
            items: []
        },
        dataTypes: {
            radius: "number",
            enableAnimation: "boolean",
            items: "array"
        },
        _initialization: function () {
            this.element.addClass(this.model.cssClass);
            this._svgLink = "http://www.w3.org/2000/svg";
            if (this.model.items.length < 1) {
                this._radialItems = $(this.element.find(">ul").children());
                for (var i = 0; i < this._radialItems.length ; i++) {
                    this.model.items.push(this._itemsObjectCollection($(this._radialItems[i])));
                    if ($(this._radialItems[i]).find("ul").children().length > 0) {
                        this._nestedRadialItems = $(this._radialItems[i]).find("ul").children();
                        this.model.items[i].items = [];
                        for (var j = 0; j < this._nestedRadialItems.length; j++) {
                            this.model.items[i].items.push(this._itemsObjectCollection($(this._nestedRadialItems[j])));
                        }
                    }
                }
            }
            this._itemCount = this.model.items.length;
            $(this.element.children()).remove();
            this._startXY = this.model.radius;
            this._diameter = 2 * this.model.radius;
        },
        _itemsObjectCollection: function (element) {
            var item = {}, innerItem = {};
            $(this._tags[0].attr).each(function (i, e) {
                if (typeof (e) == "string") {
                    var attr = e.split('.');
                    if (attr.length == 1)
                        item[e] = element.attr("data-ej-" + e);
                    else {
                        var prop1 = attr[0], prop2 = attr[1];
                        if (!item[prop1])
                            innerItem = {};
                        innerItem[prop2] = element.attr("data-ej-" + e.replace(".", "-"));
                        item[prop1] = innerItem;
                    }
                }
            });
            return item;
        },
        _createSVGElement: function () {
            var svgObj = document.createElementNS(this._svgLink, 'svg');
            if (this.model.radius != null) {
                svgObj.setAttribute("width", this._diameter);
                svgObj.setAttribute("height", this._diameter);
            }
            return $(svgObj);
        },
        _createGroupElement: function (id) {
            var group = document.createElementNS(this._svgLink, "g");
            if (id)
                group.setAttribute("id", id);
            return $(group);
        },
        _createImageElement: function (width, height, currentEle, x, y) {
            if (!ej.isNullOrUndefined(currentEle["imageUrl"]) || !ej.isNullOrUndefined(currentEle["imagePath"])) {
                imgLoc = currentEle["imageUrl"] ? currentEle["imageUrl"] : (this.model.renderMode.toLowerCase() != "flat" ? currentEle["imagePath"] + "/"
                    + this.model.renderMode.toLowerCase() + "/" + currentEle["imageName"] : currentEle["imagePath"] + "/" + this.model.renderMode.toLowerCase() + "/" + currentEle["imageName"]),
                image = document.createElementNS(this._svgLink, "image");
                image.setAttribute("width", width);
                image.setAttribute("height", height);
                image.setAttributeNS('http://www.w3.org/1999/xlink', 'href', imgLoc);
                image.setAttribute("x", x);
                image.setAttribute("y", y);
                return image;
            }
        },
        _createTextElement: function (x, y, style, content) {
            var text = document.createElementNS(this._svgLink, "text");
            text.setAttribute("x", x);
            text.setAttribute("y", y);
            text.setAttribute("class", style);
            text.textContent = content;
            return text;
        },
        _createPathElement: function (index, direction, style) {
            var path = document.createElementNS(this._svgLink, "path");
            path.setAttribute("index", index);
            path.setAttribute("d", direction);
            path.setAttribute("class", style);
            return path;
        },
        _createPolygonElement: function (index, transform) {
            var polygon = document.createElementNS(this._svgLink, "polygon");
            polygon.setAttribute("points", "10,10 0,10 5,5");
            polygon.setAttribute("index", index);
            polygon.setAttribute("fill", "#FFFFFF");
            polygon.setAttribute("transform", transform);
            return polygon;
        },
        _createCircleElement: function (x, y, r, style) {
            var circle = document.createElementNS(this._svgLink, "circle");
            circle.setAttribute("cx", x);
            circle.setAttribute("cy", y);
            circle.setAttribute("r", r);
            circle.setAttribute("class", style);
            return circle;
        },
        _calculateRadialArc: function (menuCount, size, mRadius, Arcdradius, polyRadius) {
            var itemCurrentPos = 0,
                startAngle = 2 * Math.PI * itemCurrentPos,
                endAngle = 2 * Math.PI * (itemCurrentPos + (10 / (menuCount * 10))),
                radius = 0.5 * size * Math.min(this._diameter, this._diameter),
                menuItemRadius = mRadius * size * Math.min(this._diameter, this._diameter),
                dradius = Arcdradius * radius,
                polygonRadius = polyRadius * radius,
                degPoint = 360 / menuCount,
                degree = degPoint / 2;
            var x1 = [], y1 = [], x2 = [], y2 = [], midx = [], midy = [], dStartX = [], dStartY = [], dEndX = [], dEndY = [], dmidx = [], dmidy = [], deg = [], longArc = [];
            for (var i = 0; i < menuCount; i++) {
                var pathStartAngle = -.5 * Math.PI;
                startAngle = startAngle + pathStartAngle;
                endAngle = endAngle + pathStartAngle - 0.000001;
                longArc[i] = endAngle - startAngle < Math.PI ? 0 : 1;
                var midAngle = (startAngle + endAngle) / 2;
                x1[i] = this._startXY + radius * Math.cos(startAngle);
                y1[i] = this._startXY + radius * Math.sin(startAngle);
                x2[i] = this._startXY + radius * Math.cos(endAngle);
                y2[i] = this._startXY + radius * Math.sin(endAngle);
                midx[i] = this._startXY + menuItemRadius * Math.cos(midAngle);
                midy[i] = this._startXY + menuItemRadius * Math.sin(midAngle);
                dStartX[i] = this._startXY + dradius * Math.cos(startAngle);
                dStartY[i] = this._startXY + dradius * Math.sin(startAngle);
                dEndX[i] = this._startXY + dradius * Math.cos(endAngle);
                dEndY[i] = this._startXY + dradius * Math.sin(endAngle);
                dmidx[i] = this._startXY + polygonRadius * Math.cos(midAngle);
                dmidy[i] = this._startXY + polygonRadius * Math.sin(midAngle);
                deg[i] = degree;
                itemCurrentPos += 10 / (menuCount * 10);
                startAngle = 2 * Math.PI * itemCurrentPos;
                endAngle = 2 * Math.PI * (itemCurrentPos + (10 / (menuCount * 10)));
                degree += degPoint;
            }
            return ({
                x1: x1, y1: y1, x2: x2, y2: y2, midx: midx, midy: midy, dStartX: dStartX, dStartY: dStartY, dEndX: dEndX, dEndY: dEndY, dmidx: dmidx,
                dmidy: dmidy, deg: deg, longArc: longArc, radius: radius, dradius: dradius
            });
        },
        _renderRadialMenu: function () {
            this._radialSVG = this._createSVGElement();
            this._radialChildSVG = this._createSVGElement();
            this._childArcGroup = this._createGroupElement("childarcgroup");
            this._polygonGroup = this._createGroupElement("polygongroup");
            this._polygonGroup.attr("transform", "translate(-10,-10)");
            this._radialArcGroup = this._createGroupElement("outerarcpathgroup");
            this._menuItemsArcGroup = this._createGroupElement("arcpathgroup");
            this._menuItemsGroup = this._createGroupElement("menuitemsgroup");
            this._menuItemsGroup.attr("transform", "translate(-10,-5)");
            this._menuItemsArcPaths = this._createGroupElement("menuitemsarcpaths");
            this._menuItemsPaths = this._createGroupElement("itemspathgroup");
            this._radialSVGDiv = ej.buildTag("div#" + this._id + "_svgdiv." + this._prefix + "abs").css("height", this._diameter);
            this._radialCircleSVGDiv = ej.buildTag("div#" + this._id + "_circlesvgdiv." + this._prefix + "abs " + this._prefix + "displaynone");
            this._radialChildSVGDiv = ej.buildTag("div#" + this._id + "_childsvgdiv." + this._prefix + "abs " + this._prefix + "displaynone");
            var pointsVal = this._calculateRadialArc(this._itemCount, 1, 0.28, 0.8, 0.95),
                pointsArcVal = this._calculateRadialArc(this._itemCount, 0.79, null, 0.97, null),
                pointsItemVal = this._calculateRadialArc(this._itemCount, 0.8, null, 0.3, null),
                pointsOuterArcVal = this._calculateRadialArc(1, 1, 0.28, 0.8, null),
                outerArcDirection = this._pathDirection(pointsOuterArcVal.x1[0], pointsOuterArcVal.y1[0], pointsOuterArcVal.radius, pointsOuterArcVal.longArc[0], pointsOuterArcVal.x2[0], pointsOuterArcVal.y2[0],
                                    pointsOuterArcVal.dEndX[0], pointsOuterArcVal.dEndY[0], pointsOuterArcVal.dradius, pointsOuterArcVal.dStartX[0], pointsOuterArcVal.dStartY[0]),
                imgDim = 20;
            for (var i = 0; i < this._itemCount; i++) {
                var direction = this._pathDirection(pointsVal.x1[i], pointsVal.y1[i], pointsVal.radius, pointsVal.longArc[i], pointsVal.x2[i], pointsVal.y2[i],
                    pointsVal.dEndX[i], pointsVal.dEndY[i], pointsVal.dradius, pointsVal.dStartX[i], pointsVal.dStartY[i]),
                    arcDirection = this._pathDirection(pointsArcVal.x1[i], pointsArcVal.y1[i], pointsArcVal.radius, pointsArcVal.longArc[i], pointsArcVal.x2[i],
                    pointsArcVal.y2[i], pointsArcVal.dEndX[i], pointsArcVal.dEndY[i], pointsArcVal.dradius, pointsArcVal.dStartX[i], pointsArcVal.dStartY[i]),
                    itemDirection = this._pathDirection(pointsItemVal.x1[i], pointsItemVal.y1[i], pointsItemVal.radius, pointsItemVal.longArc[i], pointsItemVal.x2[i],
                    pointsItemVal.y2[i], pointsItemVal.dEndX[i], pointsItemVal.dEndY[i], pointsItemVal.dradius, pointsItemVal.dStartX[i], pointsItemVal.dStartY[i]),
                    currentEle = this.model.items[i],
                    imgTextGroup = this._createGroupElement(),
                    itemEnable = this._enableItem(currentEle, imgTextGroup);
                this._menuItemsArcPaths.append(this._createPathElement(i, arcDirection, "" + this._prefix + "arcbgcolor"));
                this._menuItemsPaths.append(this._createPathElement(i, itemDirection, itemEnable.itemPathClass));
                this._menuItemsArcGroup.append(this._createPathElement(i, direction, itemEnable.arcPathClass));
                imgTextGroup.attr({ "cursor": "context-menu", "index": i });
                imgTextGroup.append(this._createImageElement(imgDim, imgDim, currentEle, pointsVal.midx[i], pointsVal.midy[i] - imgDim / 2));
                imgTextGroup.append(this._createTextElement(pointsVal.midx[i] + 10, pointsVal.midy[i] + 25, itemEnable.textClass, itemEnable.dataText));
                if (currentEle.badge && (currentEle.badge.enabled == "true" || currentEle.badge.enabled == true))
                    imgTextGroup.append(this._createCircleElement(pointsVal.midx[i] + 25, pointsVal.midy[i] - 10, 10, "" + this._prefix + "badgecircle"))
                                .append(this._createTextElement(pointsVal.midx[i] + 25, pointsVal.midy[i] - 7, "" + this._prefix + "badgetext", currentEle.badge.value));
                this._menuItemsGroup.append(imgTextGroup);
                if (currentEle["items"] || (currentEle.type && currentEle.type.toLowerCase() == (this.model.renderMode ? ej.mobile : ej).RadialMenu.ItemType.Slider)) {
                    var transform = pointsVal.deg[i] > 270 ? "translate(" + (pointsVal.dmidx[i] + 5) + "," + (pointsVal.dmidy[i] + 15) + ")" + "rotate(" + pointsVal.deg[i] + ")"
                        : "translate(" + (pointsVal.dmidx[i] + 10) + "," + (pointsVal.dmidy[i] + 10) + ")" + "rotate(" + pointsVal.deg[i] + ")";
                    this._childArcGroup.append(this._createPathElement(i, direction, "" + this._prefix + "childdefault"));
                    this._polygonGroup.append(this._createPolygonElement(i, transform));
                }
            }
            var circle = this._createCircleElement(this._startXY, this._startXY, this._startXY / 3.5, "" + this._prefix + "circlebgcolor");
            this._radialArcGroup.append(this._createPathElement(1, outerArcDirection, "" + this._prefix + "outerdefault"));
            this._radialChildSVG.append(this._menuItemsPaths).append(this._menuItemsArcGroup).append(this._childArcGroup)
                                .append(this._polygonGroup).append(this._menuItemsArcPaths).append(this._menuItemsGroup).append(circle);
            this._radialContainer.append(this._radialSVGDiv.append(this._radialCircleSVGDiv.append(this._radialSVG.append(this._radialArcGroup)))
                                 .append(this._radialChildSVGDiv.append(this._radialChildSVG)));
        },
        _ejMenuBaseItemsRemove: function () {
            this._menuChildSVGDiv = ej.buildTag("div#" + this._id + "_menuchildsvgdiv." + this._prefix + "abs");
            if (this.model.enableAnimation) {
                this._radialChildSVGDiv.removeClass("" + this._prefix + "radialshow").addClass("" + this._prefix + "scalehide");
                this._radialChildAnimate();
                this._menuChildSVGDiv.addClass("" + this._prefix + "scaleshow");
            }
            else
                this._radialChildSVGDiv.addClass("" + this._prefix + "displaynone");
            this._radial.removeClass(this.model.imageClass).addClass("" + this._prefix + "backarrow " + this.model.backImageClass + "");
        },
        _renderRadialChildMenu: function (currentItem) {
            this._menuChildSVG = this._createSVGElement();
            this._childItemsGroup = this._createGroupElement("childitemsgroup");
            this._childItemsGroup.attr("transform", "translate(-10,-10)");
            this._childItemArcGroup = this._createGroupElement();
            this._childItemsArcPaths = this._createGroupElement("childitemsarcpaths");
            this._childItemsPaths = this._createGroupElement();
            var childCount = currentItem.items.length,
                pointsVal = this._calculateRadialArc(childCount, 1, 0.28, 0.8, null),
                pointsArcVal = this._calculateRadialArc(childCount, 0.79, null, 0.97, null),
                pointsItemVal = this._calculateRadialArc(childCount, 0.8, null, 0.3, null),
                imgDim = 20;
            for (var i = 0; i < childCount; i++) {
                var direction = this._pathDirection(pointsVal.x1[i], pointsVal.y1[i], pointsVal.radius, pointsVal.longArc[i], pointsVal.x2[i], pointsVal.y2[i],
                    pointsVal.dEndX[i], pointsVal.dEndY[i], pointsVal.dradius, pointsVal.dStartX[i], pointsVal.dStartY[i]),
                    arcDirection = this._pathDirection(pointsArcVal.x1[i], pointsArcVal.y1[i], pointsArcVal.radius, pointsArcVal.longArc[i], pointsArcVal.x2[i],
                    pointsArcVal.y2[i], pointsArcVal.dEndX[i], pointsArcVal.dEndY[i], pointsArcVal.dradius, pointsArcVal.dStartX[i], pointsArcVal.dStartY[i]),
                    itemDirection = this._pathDirection(pointsItemVal.x1[i], pointsItemVal.y1[i], pointsItemVal.radius, pointsItemVal.longArc[i], pointsItemVal.x2[i],
                    pointsItemVal.y2[i], pointsItemVal.dEndX[i], pointsItemVal.dEndY[i], pointsItemVal.dradius, pointsItemVal.dStartX[i], pointsItemVal.dStartY[i]),
                    imgTextGroup = this._createGroupElement(),
                    currentEle = currentItem.items[i],
                    itemEnable = this._enableItem(currentEle, imgTextGroup);
                this._childItemArcGroup.append(this._createPathElement(i, direction, itemEnable.arcPathClass));
                this._childItemsArcPaths.append(this._createPathElement(i, arcDirection, "" + this._prefix + "arcbgcolor"));
                this._childItemsPaths.append(this._createPathElement(i, itemDirection, itemEnable.itemPathClass));
                imgTextGroup.attr({ "cursor": "context-menu", "index": i });
                imgTextGroup.append(this._createImageElement(imgDim, imgDim, currentEle, pointsVal.midx[i], pointsVal.midy[i] - imgDim / 2));
                imgTextGroup.append(this._createTextElement(pointsVal.midx[i] + 10, pointsVal.midy[i] + 25, itemEnable.textClass, itemEnable.dataText));
                this._childItemsGroup.append(imgTextGroup);
            }
            var circle = this._createCircleElement(this._startXY, this._startXY, this._startXY / 3.5, "" + this._prefix + "circlebgcolor");
            this._radialSVGDiv.append(this._menuChildSVGDiv.append(this._menuChildSVG.append(this._childItemsPaths)
                              .append(this._childItemArcGroup).append(this._childItemsArcPaths).append(this._childItemsGroup).append(circle)));
        },
        _radialSliderHandler: function (e) {
            this.updateBadgeValue(this._index, e.value);
            this._data = { value: e.value, oldValue: e.oldValue, index: this._index };
            this._eventsTrigger(this._data, this.model.renderMode ? "touch" : "click");
        },
        _isRSText: function (eleClass) {
            return ((eleClass == this._prefix + "ticks-text" || eleClass == this._prefix + "dynamic-text") ? true : false);
        },
        _pathDirection: function (x1, y1, radius, lArc, x2, y2, dEndX, dEndY, dRadius, dStartX, dStartY) {
            return "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + lArc + " " + "1" + " " + x2 + " " + y2 + " " + "L" +
                " " + dEndX + " " + dEndY + " " + "A" + " " + dRadius + " " + dRadius + " " + "1" + " " + lArc + " " + "0" + " " + dStartX + " " + dStartY + " " + "z";
        },
        _enableItem: function (currentObj, ele) {
            var itemPathClass = this._prefix + "itembgcolor", arcPathClass = this._prefix + "default", textClass = "" + this._prefix + "textcolor",
                dataText = this.model.renderMode ? currentObj[this.model.renderMode].text : currentObj.text;
            if (currentObj.enabled == "false" || currentObj.enabled == false) {
                ele.attr("class", this._prefix + "itemdisabled");
                return {
                    itemPathClass: this._prefix + "itembgcolor " + this._prefix + "pathdisabled", arcPathClass: this._prefix + "default " + this._prefix + "pathdisabled",
                    dataText: dataText, textClass: textClass
                };
            }
            else
                return { itemPathClass: itemPathClass, arcPathClass: arcPathClass, dataText: dataText, textClass: textClass };
        },
        _windowsMenuShow: function () {
            if (this.model.enableAnimation) {
                this._radialCircleSVGDiv.removeClass(this._prefix + "displaynone " + this._prefix + "radialhide").addClass(this._prefix + "radialshow");
                this._radialChildSVGDiv.removeClass(this._prefix + "displaynone " + this._prefix + "radialhide").addClass(this._prefix + "radialshow");
            }
            else {
                this._radialCircleSVGDiv.removeClass(this._prefix + "displaynone");
                this._radialChildSVGDiv.removeClass(this._prefix + "displaynone");
            }
            this._openCloseTrigger("open");
        },
        _windowsMenuHide: function (proxy) {
            if (this.model.enableAnimation) {
                this._radialCircleSVGDiv.removeClass(this._prefix + "radialshow").addClass(this._prefix + "radialhide");
                this._radialChildSVGDiv.removeClass(this._prefix + "radialshow " + this._prefix + "scaleshow").addClass(this._prefix + "radialhide");
                setTimeout(function () {
                    proxy._radialCircleSVGDiv.addClass(proxy._prefix + "displaynone");
                    proxy._radialChildSVGDiv.addClass(proxy._prefix + "displaynone");
                }, 160);
            }
            else {
                this._radialCircleSVGDiv.addClass(this._prefix + "displaynone");
                this._radialChildSVGDiv.addClass(this._prefix + "displaynone");
            }
            this._openCloseTrigger("close");
        },
        _windowsInnerMenuHide: function (proxy) {
            this._radial.removeClass(this._prefix + "backarrow " + this.model.backImageClass + "").addClass(this.model.imageClass);
            if (this.model.enableAnimation) {
                this._menuChildSVGDiv.removeClass(this._prefix + "scaleshow").addClass(this._prefix + "scalehide");
                setTimeout(function () { proxy._menuChildSVGDiv.remove(); }, 150);
                setTimeout(function () { proxy._radialChildSVGDiv.removeClass(proxy._prefix + "scalehide " + proxy._prefix + "displaynone").addClass(proxy._prefix + "scaleshow"); }, 200);
            }
            else {
                this._menuChildSVGDiv.remove();
                this._radialChildSVGDiv.removeClass(this._prefix + "displaynone");
            }
        },
        _eventsTrigger: function (data, eventName) {
            var event = this.model[eventName];
            this.model[eventName] = this._childTarget && this.model.items[data.index].items[data.childIndex][eventName] ? this.model.items[data.index].items[data.childIndex][eventName]
                : (!this._childTarget && this.model.items[data.index][eventName] ? this.model.items[data.index][eventName] : this.model[eventName]);
            if (this.model[eventName])
                this._trigger(eventName, data);
            this.model[eventName] = event;
        },
        _openCloseTrigger: function (eventName) {
            if (this.model[eventName])
                this._trigger(eventName);
        },
        _menuEnabledDisabled: function (itemIndices, menuClass) {
            var proxy = this,
                itemIndex;
            if ($.isArray(itemIndices)) {
                $.each(itemIndices, function (i, itemIndex) {
                    if (!$.isArray(itemIndex))
                        proxy._menuItems(proxy, itemIndex, menuClass);
                    else {
                        $.each(itemIndex, function (i, index) {
                            if (!$.isArray(index)) {
                                if (!proxy.model.renderMode || (proxy.model.renderMode && (proxy.model.renderMode == "windows" || proxy.model.renderMode == "flat")))
                                    proxy._menuItems(proxy, index, menuClass);
                                itemIndex = index;
                            }
                            else {
                                $.each(index, function (i, childIndex) {
                                    proxy.model.items[itemIndex].items[childIndex].enabled = (menuClass == "disabled") ? false : true;
                                });
                            }
                        });
                    }
                });
            }
        },
        _ejMenuItem: function (proxy, index, menuClass) {
            var currentGroupEle = $(this._menuItemsGroup.find("g")[index]),
                currentItemPathEle = $(this._menuItemsPaths.find("path")[index]),
                currentArcPathEle = $(this._radialChildSVGDiv.find("#arcpathgroup path")[index]);
            if (menuClass == "disabled") {
                currentItemPathEle.attr("class", "" + this._prefix + "itembgcolor " + this._prefix + "pathdisabled");
                currentArcPathEle.attr("class", "" + this._prefix + "default " + this._prefix + "pathdisabled");
                currentGroupEle.attr("class", "" + this._prefix + "itemdisabled");
				if(!ej.isNullOrUndefined(this._radialChildSVGDiv) && $(this._radialChildSVGDiv.find("#polygongroup polygon[index='"+index+"']")).length > 0) {
					$(this._radialChildSVGDiv.find("#polygongroup polygon[index='"+index+"']")).attr("class",this._prefix + "itemdisabled");
					$(this._radialChildSVGDiv.find("#childarcgroup path[index='"+index+"']")).attr("class",this._prefix + "itemdisabled");
				} 
            }
            else {
                currentItemPathEle.attr("class", "" + this._prefix + "itembgcolor");
                currentArcPathEle.attr("class", "" + this._prefix + "default");
                currentGroupEle.removeAttr("class");
				if(!ej.isNullOrUndefined(this._radialChildSVGDiv) && $(this._radialChildSVGDiv.find("#polygongroup polygon[index='"+index+"']")).length > 0){
					$(this._radialChildSVGDiv.find("#polygongroup polygon[index='"+index+"']")).removeAttr("class");
				}  $(this._radialChildSVGDiv.find("#childarcgroup path[index='"+index+"']")).attr("class",this._prefix + "childdefault");
            }
        },
        _ejMenuHide: function (proxy) {
            if (this.model.enableAnimation) {
                this._radialCircleSVGDiv.removeClass(this._prefix + "radialshow").addClass(this._prefix + "radialhide");
                this._radialChildSVGDiv.removeClass(this._prefix + "radialshow " + this._prefix + "scaleshow").addClass(this._prefix + "radialhide");
                setTimeout(function () {
                    proxy._radialCircleSVGDiv.addClass(proxy._prefix + "displaynone").removeClass(proxy._prefix + "radialshow " + proxy._prefix + "radialhide " + proxy._prefix + "scaleshow " + proxy._prefix + "scalehide");
                    proxy._radialChildSVGDiv.addClass(proxy._prefix + "displaynone").removeClass(proxy._prefix + "radialshow " + proxy._prefix + "radialhide " + proxy._prefix + "scaleshow " + proxy._prefix + "scalehide");
                }, 160);
            }
            else {
                this._radialCircleSVGDiv.addClass(this._prefix + "displaynone");
                this._radialChildSVGDiv.addClass(this._prefix + "displaynone");
            }
            this._openCloseTrigger("close");
        },
        _ejInnerMenuHide: function (proxy) {
            this._radial.removeClass(this._prefix + "backarrow " + this.model.backImageClass + "").addClass(this.model.imageClass);
            if (this.model.enableAnimation) {
                this._radialCircleSVGDiv.removeClass(this._prefix + "radialshow " + this._prefix + "radialhide " + this._prefix + "scaleshow " + this._prefix + "scalehide").addClass(this._prefix + "displaynone");
                this._radialChildSVGDiv.removeClass(this._prefix + "radialshow " + this._prefix + "radialhide " + this._prefix + "scaleshow " + this._prefix + "scalehide").addClass(this._prefix + "displaynone");
                this._menuChildSVGDiv.removeClass(this._prefix + "scaleshow").addClass(this._prefix + "radialhide");
                setTimeout(function () { proxy._menuChildSVGDiv.removeClass(proxy._prefix + "radialhide").remove(); }, 150);
            }
            else {
                this._radialCircleSVGDiv.addClass(this._prefix + "displaynone");
                this._radialChildSVGDiv.addClass(this._prefix + "displaynone");
                this._menuChildSVGDiv.remove();
            }
            this._openCloseTrigger("close");
        },
        _currentBadgeEle: function (index) {
            return this.model.renderMode == "android" ? $(this._imageBadgeGroup.find("g")[index]) : $(this._menuItemsGroup.find("g")[index]);
        },
        _badge: function (index) {
            return this._currentBadgeEle(index).find("." + this._prefix + "badgetext,." + this._prefix + "badgecircle");
        },
        show: function () {
            this.element.removeClass(this._prefix + "displaynone");
        },
        hide: function () {
            this.element.addClass(this._prefix + "displaynone");
        },
        showMenu: function () {
            this._showMenu();
        },
        hideMenu: function () {
            this._hideMenu();
        },
        enableItemByIndex: function (itemIndex) {
            this._menuItems(this, itemIndex, "enabled");
        },
        enableItemsByIndices: function (itemIndices) {
            this._menuEnabledDisabled(itemIndices, "enabled");
        },
        disableItemByIndex: function (itemIndex) {
            this._menuItems(this, itemIndex, "disabled");
        },
        disableItemsByIndices: function (itemIndices) {
            this._menuEnabledDisabled(itemIndices, "disabled");
        },
        updateBadgeValue: function (index, value) {
            this.model.items[index].badge.value = value;
            this._currentBadgeEle(index).children("text." + this._prefix + "badgetext").html(value);
        },
        showBadge: function (index) {
            this._badge(index).show();
        },
        hideBadge: function (index) {
            this._badge(index).hide();
        },
        _setModel: function (options) {
            if (options.items) this.model.items = options.items;
            this._refresh();
        },
        _refresh: function () {
            this._destroy();
            this._init();
        },
        _destroy: function () {
            ej.listenEvents([document, document], [ej.endEvent(), ej.startEvent()], [this._targetClick, this._targetDown], true);
            this.element.removeAttr("class style").children().remove();
        }
    });
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Radial Menu elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRadialMenu", "ej.RadialMenu", {
        _rootCSS: "e-radialmenu",
        element: null,
        model: null,
         validTags: ["div"],
        _setFirst: true,
        defaults: {
            imageClass: "e-radialimage",
            backImageClass: "e-backimage",
            targetElementId: null,
            click: null,
            //Deprecated property
            select: null,
            autoOpen: false,
            position: {
                x: null,
                y: null
            }
        },
        dataTypes: {
            autoOpen: "boolean"
        },
        _init: function () {
            this._id = this.element[0].id;
            if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)) {
                this._initialization();
                this._prefix = "e-";
                this._renderRadial();
                this._wireEvents();
            }
        },
        _renderRadial: function () {
            this._radial = ej.buildTag("div.e-radial e-abs " + this.model.imageClass + "").css({ "left": this._startXY - 22 + "px", "top": this._startXY - 22 + "px" });
            this._radialContainer = ej.buildTag("div.e-rel").css({ "height": this._diameter, "width": this._diameter });
            this.element.append(this._radialContainer.append(this._radial)).addClass("e-radialmenu e-overlow e-user-select e-abs");
            this._radialInitialPosition();
            this._renderRadialMenu();
            var childArc = this._childArcGroup.children(),
                polygonGroup = this._polygonGroup.children();
            this._on(childArc, "mouseenter", this._arcOverHandler);
            this._on(childArc, "mouseleave", this._arcOverHandler);
            this._on(polygonGroup, "mouseenter", this._arcOverHandler);
            this._on(polygonGroup, "mouseleave", this._arcOverHandler);
            this._itemsEvents(this._menuItemsGroup.children(), this._menuItemsPaths.children(), this._menuItemsArcGroup.children());
        },
        _wireEvents: function () {
            var doc = $(document);
            this._radialClick = $.proxy(this._showMenu, this);
            this._targetDown = $.proxy(this._targetDownHandler, this);
            this._targetClick = $.proxy(this._targetClickHandler, this);
            this._itemClick = $.proxy(this._itemClickHandler, this);
            ej.listenEvents([this._radial, this._radialSVGDiv, doc, doc], [ej.endEvent(), ej.endEvent(), ej.endEvent(), ej.startEvent()],
                [this._radialClick, this._itemClick, this._targetClick, this._targetDown], false);
        },
        _itemsEvents: function (group, path, arcPath) {
            this._on(group, "mouseenter", this._itemOverHandler);
            this._on(group, "touchstart", this._itemOverHandler);
            this._on(group, "mouseleave", this._itemOverHandler);
            this._on(group, "touchend", this._itemOverHandler);
            this._on(path, "mouseenter", this._itemOverHandler);
            this._on(path, "touchstart", this._itemOverHandler);
            this._on(path, "mouseleave", this._itemOverHandler);
            this._on(path, "touchend", this._itemOverHandler);
            this._on(arcPath, "mouseenter", this._itemOverHandler);
            this._on(arcPath, "touchstart", this._itemOverHandler);
            this._on(arcPath, "mouseleave", this._itemOverHandler);
            this._on(arcPath, "touchend", this._itemOverHandler);
        },
        _showMenu: function () {
            if (this._radial.hasClass("e-backarrow"))
                this._windowsInnerMenuHide(this);
            else {
                if (this._radialCircleSVGDiv.hasClass("e-displaynone"))
                    this._windowsMenuShow();
                else
                    this._windowsMenuHide(this);
            }
            this._childTarget = false;
        },
        _itemClickHandler: function (e) {
            var targetEle = $(e.target);
            if (targetEle.attr("class") == "e-active" || e.target.tagName == "polygon" || ( !ej.isNullOrUndefined(e.type) && e.type == "touchend" && targetEle.attr("class") == "e-childdefault" )) {
                this._index = parseInt(targetEle.attr("index"));
                this._ejMenuBaseItemsRemove();
                var currentItem = this.model.items[this._index];
                if (currentItem.type && currentItem.type.toLowerCase() == ej.RadialMenu.ItemType.Slider) {
                    var ticks = currentItem.sliderSettings.ticks ? eval(currentItem.sliderSettings.ticks) : [8, 9, 11, 13, 16, 20, 26, 36, 72],
                        value = currentItem.badge.value ? parseInt(currentItem.badge.value) : 10,
                        stroke = currentItem.sliderSettings.strokeWidth ? parseInt(currentItem.sliderSettings.strokeWidth) : 1,
                        labelSpace = currentItem.sliderSettings.labelSpace ? parseInt(currentItem.sliderSettings.labelSpace) : 22;
                    this._menuChildSVGDiv.ejRadialSlider({
                        showInnerCircle: false, enableAnimation: false, radius: this.model.radius - 29, inline: true, strokeWidth: stroke,
                        labelSpace: labelSpace, value: value, ticks: ticks, change: $.proxy(this._radialSliderHandler, this)
                    });
                    this._radialSVGDiv.append(this._menuChildSVGDiv);
                }
                else {
                    this._renderRadialChildMenu(currentItem);
                    this._childTarget = true;
                    this._itemsEvents(this._childItemsGroup.children(), this._childItemsPaths.children(), this._childItemArcGroup.children());
                }
            }
            this._eventAction(e);
            if (this._event) {
                this._eventsTrigger(this._data, "click");
                this._eventsTrigger(this._data, "select");
            }
            this._event = false;
        },
        _eventAction: function (e) {
            var targetEle = $(e.target), eleClass = targetEle.attr("class"), tagName = e.target.tagName, index, text;
            if (eleClass == "e-itembgcolor" || eleClass == "e-default") {
                index = targetEle.index();
                text = !this._childTarget ? $(this._menuItemsGroup.children()[targetEle.index()]).text() : $(this._childItemsGroup.children()[targetEle.index()]).text();
                this._event = true;
                this._data = !this._childTarget ? { index: index, text: text, childIndex: null} : { index: this._index, childIndex: index, text: text };
            }
            else if ((tagName == "text" && !this._isRSText(eleClass)) || tagName == "image") {
                index = targetEle.parent().index();
                text = targetEle.parent().text();
                this._event = true;
                this._data = !this._childTarget ? { index: index, text: text, childIndex: null } : { index: this._index, childIndex: index, text: text };
            }
        },
        _radialInitialPosition: function () {
            this._targetElement = $("#" + this.model.targetElementId + "");
            if (this.model.autoOpen) {
                if (this.model.position.x != null && this.model.position.y != null)
                    this.element.css({ "top": this.model.position.y, "left": this.model.position.x });
                else if (this.model.targetElementId)
                    this.element.css({ "top": this._targetElement.height() / 2 - this.model.radius + "px", "left": this._targetElement.width() / 2 - this.model.radius + "px" });
                this.show();
            }
            else
                this.hide();
        },
        _radialChildAnimate: function () {
            var proxy = this;
            setTimeout(function () {
                proxy._radialChildSVGDiv.removeClass("e-scalehide e-scaleshow").addClass("e-displaynone");
            }, 150);
        },
        _arcOverHandler: function (e) {
            var targetEle = $(e.target),
                index = parseInt(targetEle.attr("index")),
                targetGroupEle = $(this._childArcGroup.find('path[index=' + index + ']')),
                polygonEle = $(this._polygonGroup.find('polygon[index=' + index + ']'));
            if (e.type == "mouseenter") {
                polygonEle.attr('fill', '#808080');
                if (targetEle.attr("class") == "e-childdefault")
                    targetEle.attr("class", "e-active");
                else
                    targetGroupEle.attr("class", "e-active");
            }
            else {
                polygonEle.attr('fill', '#FFFFFF');
                if (targetEle.attr("class") == "e-active")
                    targetEle.attr("class", "e-childdefault");
                else
                    targetGroupEle.attr("class", "e-childdefault");
            }
        },
        _itemOverHandler: function (e) {
            var index = $(e.currentTarget).index();
            var targetEle = !this._childTarget ? $(this._menuItemsArcPaths.children()[index]) : $(this._childItemsArcPaths.children()[index]);
            if ((e.type == "mouseenter") || (e.type == "touchstart"))
                targetEle.attr("class", "e-childdefault");
            else
                targetEle.attr("class", "e-arcbgcolor");
        },
        _targetDownHandler: function (e) {
            var targetEle = $(e.target);
            if (!targetEle.hasClass("e-rel") && $(targetEle.closest(".e-radialmenu")).length) {
                e.preventDefault();
            }
        },
        _targetClickHandler: function (e) {
            var targetEle = $(e.target), x = e.clientX, y = e.clientY, width, height,
                menuTarget = $(targetEle.closest(".e-radialmenu")).length,
                menuState = this._radialCircleSVGDiv.hasClass("e-displaynone");
            if (this.model.targetElementId) {
                width = this._targetElement.width();
                height = this._targetElement.height();
            }
            else {
                width = window.innerWidth;
                height = window.innerHeight;
            }
            if (menuTarget == 0 && $(targetEle.closest(this._targetElement)).length == 0 && this.model.targetElementId) {
                menuState ? this.hide() : this.hideMenu();
            }
			else if( this.model.position.x && this.model.position.y ) {
				this.element.css({ "top": this.model.position.y, "left": this.model.position.x });
			}
            else if ($(targetEle.closest("div.e-radial")).length == 0 && menuState) {
                var left = x > width - this.model.radius ? width - this._diameter : (x > this.model.radius ? x - this.model.radius : 0),
                    top = y > height - this.model.radius ? height - this._diameter : (y > this.model.radius ? y - this.model.radius : 0);
                this.element.css({ "top": top + "px", "left": left + "px" });
            }
            else if (menuTarget == 0)
                this.hideMenu();
        },
        _menuItems: function (proxy, index, menuClass) {
            this._ejMenuItem(proxy, index, menuClass);
        },
        _hideMenu: function () {
            if (this._radial.hasClass("e-backarrow"))
                this._ejInnerMenuHide(this);
            else
                this._ejMenuHide(this);
        },
        setPosition: function (x, y) {
            this.element.css({ "top": y + "px", "left": x + "px" });
            this.show();
        },
        menuHide: function () {
            this._hideMenu();
        },
        enableItem: function (item) {
            this._ejMenuEnabledDisabled(item, "enabled");
        },
        disableItem: function (item) {
            this._ejMenuEnabledDisabled(item, "disabled");
        },
        enableItems: function (items) {
            this._ejMenuEnabledDisabled(items, "enabled");
        },
        disableItems: function (items) {
            this._ejMenuEnabledDisabled(items, "disabled");
        },
        _ejMenuEnabledDisabled: function (items, menuClass) {
            var proxy = this, ItemObj = $.isArray(items) ? items : $.makeArray(items);
            $.each(ItemObj, function (i, curItem) {
                $.each(proxy.model.items, function (j, baseItem) {
                    if (baseItem.text.toLowerCase() == curItem.toLowerCase())
                        proxy._menuItems(this, j, menuClass);
                    if (baseItem.items) {
                        $.each(baseItem.items, function (k, childItem) {
                            if (childItem.text.toLowerCase() == curItem.toLowerCase())
                                childItem.enabled = (menuClass == "disabled") ? false : true;
                        });
                    }
                });
            });
        }
    });
    ej.RadialMenu.ItemType = {
        Default: "default",
        Slider: "slider"
    };
    $.extend(true, ej.RadialMenu.prototype, ej.RadialMenuBase.prototype);
})(jQuery, Syncfusion);;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ejSignature = (function (_super) {
    __extends(ejSignature, _super);
    function ejSignature(element, options) {
        _super.call(this);
        this._rootCSS = "e-signature";
        this.PluginName = "ejSignature";
        this.id = "null";
        this.validTags = ["div"];
        this.model = null;
        this.defaults = {
            strokeColor: "#000000",
            height: "100%",
            width: "100%",
            enabled: true,
            strokeWidth: 2,
            backgroundColor: "#ffffff",
            showRoundedCorner: true,
            saveImageFormat: "png",
            isResponsive: false,
            saveWithBackground: false,
            backgroundImage: null,
            change: null,
            mouseDown: null,
            mouseMove: null,
            mouseUp: null,
        };
        if (element) {
            if (!element["jquery"])
                element = $("#" + element);
            if (element.length) {
                return $(element).ejSignature(options).data(this.PluginName);
            }
        }
    }
    ejSignature.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    ejSignature.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };
    ejSignature.prototype.clear = function () {
        if (this.model.saveWithBackground)
            this._setBackgroundImage(this.model.backgroundImage);
        else
            this._canvasContext.clearRect(0, 0, this._canvasContext.canvas.width, this._canvasContext.canvas.height);
        this._refresh();
    };
    ejSignature.prototype.save = function (filename) {
        var filesave, browserUserAgent = navigator.userAgent;
        var url = this._canvas[0].toDataURL("image/" + this.model.saveImageFormat + "");
        if (ej.isNullOrUndefined(filename))
            filesave = Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 6) + "." + this.model.saveImageFormat;
        else
            filesave = filename + "." + this.model.saveImageFormat;
        var blob = this._dataURLtoBlob(url);
        if (browserUserAgent.indexOf('Edge') == -1) {
            if ((browserUserAgent.indexOf("Firefox")) != -1 || (browserUserAgent.indexOf("Chrome")) != -1 || (browserUserAgent.indexOf("Safari")) != -1 || (browserUserAgent.indexOf("AppleWebKit")) != -1) {
                this._download(blob, filesave);
            }
            else
                window.navigator.msSaveOrOpenBlob(blob, filesave);
        }
        else
            window.navigator.msSaveOrOpenBlob(blob, filesave);
    };
    ejSignature.prototype._dataURLtoBlob = function (dataurl) {
        var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1], bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
        while (n--) {
            u8arr[n] = bstr.charCodeAt(n);
        }
        return new Blob([u8arr], { type: mime });
    };
    ejSignature.prototype._download = function (blob, filesave) {
        var blobUrl = URL.createObjectURL(blob);
        var a = document.createElement('a');
        a.href = blobUrl;
        a.target = '_parent';
        a.download = filesave;
        (document.body || document.documentElement).appendChild(a);
        a.click();
        a.parentNode.removeChild(a);
    };
    ejSignature.prototype.undo = function () {
        var proxy = this;
        if (this.incStep > 0) {
            this.incStep--;
            var undoimg = new Image;
            undoimg.src = this.storeSnap[this.incStep];
            undoimg.onload = function () {
                var canvas = document.getElementById(proxy.element[0].id).children[0];
                var ctx = canvas.getContext("2d");
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                ctx.drawImage(undoimg, 0, 0);
            };
        }
    };
    ejSignature.prototype.redo = function () {
        var proxy = this;
        if (this.incStep < this.storeSnap.length - 1) {
            this.incStep++;
            var redoimg = new Image();
            redoimg.src = this.storeSnap[this.incStep];
            redoimg.onload = function () {
                var canvas = document.getElementById(proxy.element[0].id).children[0];
                var ctx = canvas.getContext("2d");
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                ctx.drawImage(redoimg, 0, 0);
            };
        }
    };
    ejSignature.prototype.show = function () {
        this.element.css("display", "block");
    };
    ejSignature.prototype.hide = function () {
        this.element.css("display", "none");
    };
    ejSignature.prototype.enable = function () {
        this.element.removeClass("e-disable").attr({ "aria-disabled": false });
    };
    ejSignature.prototype.disable = function () {
        this.element.addClass("e-disable").attr({ "aria-disabled": true });
    };
    ejSignature.prototype._init = function () {
        this._initialize();
        this._render();
        this._wireEvents(false);
    };
    ejSignature.prototype._initialize = function () {
        this._canvas = ej.buildTag('canvas', "", {}, {});
        this.element.append(this._canvas);
        if (this._canvas[0].getContext) {
            this._canvasContext = this._canvas[0].getContext('2d');
        }
        this._setProperties(this.model.backgroundColor);
        if (this.model.backgroundImage) {
            this._setBackgroundImage(this.model.backgroundImage);
        }
        if (!this.model.saveWithBackground)
            this._toSaveData();
        this._resizeCanvas();
        this._setRoundedCorner(this.model.showRoundedCorner);
        if (!this.model.enabled)
            this.disable();
        this.strokeMinimumWidth = 1;
    };
    ejSignature.prototype._setBackgroundImage = function (bgImg) {
        if (!this.model.saveWithBackground)
            this._canvasContext.canvas.style.backgroundImage = "url(" + bgImg + ")";
        else {
            var proxy = this;
            var img = new Image();
            img.src = bgImg;
            img.onload = function () {
                var canvas = document.getElementById(proxy.element[0].id).children[0];
                var ctx = canvas.getContext("2d");
                ctx.globalCompositeOperation = "source-over";
                ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
                proxy._toSaveData();
            };
        }
    };
    ejSignature.prototype._setProperties = function (bgVal) {
        if (!ej.isNullOrUndefined(this.model.height && this.model.width)) {
            this.element.css({ "height": this.model.height, "width": this.model.width });
        }
        this._canvasContext.canvas.style.backgroundColor = bgVal;
        this._canvasContext.canvas.style.backgroundSize = "100% 100%";
        this._canvasContext.canvas.style.msTouchAction = 'none';
        this._canvasContext.canvas.style.touchAction = 'none';
    };
    ejSignature.prototype._resizeCanvas = function () {
        this._canvasContext.canvas.width = this.element.innerWidth();
        this._canvasContext.canvas.height = this.element.innerHeight();
        this._canvasContext.scale(1, 1);
        if (this.model.isResponsive)
            this._restore();
    };
    ejSignature.prototype._restore = function () {
        var proxy = this;
        var restoreimg = new Image;
        if (!ej.isNullOrUndefined(this.incStep)) {
            restoreimg.src = this.storeSnap[this.incStep];
            restoreimg.onload = function () {
                var canvas = document.getElementById(proxy.element[0].id).children[0];
                var ctx = canvas.getContext("2d");
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                ctx.drawImage(restoreimg, 0, 0, canvas.width, canvas.height);
            };
        }
    };
    ejSignature.prototype._refresh = function () {
        this._canvasContext.fillStyle = this.model.strokeColor;
        this.points = [];
        this._lastVelocity = 0;
        this._lastWidth = (this.strokeMinimumWidth + this.model.strokeWidth) / 2;
    };
    ejSignature.prototype._setModel = function (options) {
        var option;
        for (option in options) {
            switch (option) {
                case "height":
                    this._changeHeight(options[option]);
                    break;
                case "width":
                    this._changeWidth(options[option]);
                    break;
                case "showRoundedCorner":
                    this._setRoundedCorner(options[option]);
                    break;
                case "backgroundColor":
                    this._setProperties(options[option]);
                    break;
                case "backgroundImage":
                    this._setBackgroundImage(options[option]);
                    break;
                case "enabled":
                    this._disabled(!options[option]);
                    break;
                case "isResponsive":
                    this._resizeCanvas();
                    break;
            }
        }
    };
    ejSignature.prototype._changeHeight = function (height) {
        this.element.css("height", height.toString());
        this._changeHeightWidth();
    };
    ejSignature.prototype._changeWidth = function (width) {
        this.element.css("width", width.toString());
        this._changeHeightWidth();
    };
    ejSignature.prototype._changeHeightWidth = function () {
        this._resizeCanvas();
        if (!this.model.isResponsive)
            this._restore();
    };
    ejSignature.prototype._setRoundedCorner = function (value) {
        value == true ? this.element.addClass("e-corner") : this.element.removeClass("e-corner");
    };
    ejSignature.prototype._disabled = function (boolean) {
        (boolean == true) ? this.disable() : this.enable();
    };
    ejSignature.prototype._render = function () {
        this.element.addClass(" e-signature e-select e-widget").attr("role", "signature");
    };
    ejSignature.prototype._drawStartHandler = function (e) {
        if (e.which === 1 || e.which === 0) {
            ej.blockDefaultActions(e);
            this._mouseButtonDown = true;
            if ((ej.browserInfo().name == "chrome" || "webkit") && e.type == "touchstart") {
                var touch = e.originalEvent.targetTouches[0];
                this._beginStroke(touch);
            }
            else
                this._beginStroke(e);
            this._on(this._canvas, ej.eventType.mouseMove, this._drawMove);
            this._on($(document), ej.eventType.mouseUp, this._drawEnd);
            this._trigger("mouseDown", { value: e });
        }
    };
    ejSignature.prototype._drawMoveHandler = function (e) {
        ej.blockDefaultActions(e);
        if (this._mouseButtonDown) {
            if ((ej.browserInfo().name == "chrome" || "webkit") && e.type == "touchmove") {
                var touch = e.originalEvent.targetTouches[0];
                this._updateStroke(touch);
            }
            else
                this._updateStroke(e);
        }
        this._trigger("mouseMove", { value: e });
    };
    ejSignature.prototype._drawEndHandler = function (e) {
        ej.blockDefaultActions(e);
        if (this._mouseButtonDown) {
            this._mouseButtonDown = false;
            this._endStroke();
        }
        this._off(this._canvas, ej.eventType.mouseMove, this._drawMove);
        this._toSaveData();
        this._off($(document), ej.eventType.mouseUp, this._drawEnd);
        this._trigger("mouseUp", { value: e });
        this._trigger("change", { isInteraction: true, lastImage: this.storeSnap[this.incStep] });
    };
    ejSignature.prototype._toSaveData = function () {
        if (ej.isNullOrUndefined(this.incStep)) {
            this.incStep = -1;
            this.incStep++;
            this.storeSnap = new Array();
        }
        else
            this.incStep++;
        if (this.incStep < this.storeSnap.length) {
            this.storeSnap.length = this.incStep;
        }
        if (this.incStep > 0) {
            var canvasnew = ej.buildTag('canvas', "", {}, {});
            var canvasContextnew = canvasnew[0].getContext('2d');
            canvasnew[0].height = this._canvas.height();
            canvasnew[0].width = this._canvas.width();
            canvasContextnew.drawImage(this._canvas[0], 0, 0, canvasnew[0].width, canvasnew[0].height);
            this.storeSnap.push(canvasnew[0].toDataURL());
        }
        else
            this.storeSnap.push(this._canvas[0].toDataURL());
    };
    ejSignature.prototype._beginStroke = function (event) {
        this._refresh();
        this._updateStroke(event);
    };
    ejSignature.prototype._updateStroke = function (event) {
        var point = this._createPoint(event);
        this._addPoint(point);
    };
    ejSignature.prototype._drawStroke = function (point) {
        var ctx = this._canvasContext, pointSize = (this.strokeMinimumWidth + this.model.strokeWidth) / 2;
        ctx.beginPath();
        this._pointDraw(point.x, point.y, pointSize);
        ctx.closePath();
        ctx.fill();
    };
    ejSignature.prototype._endStroke = function () {
        var canDrawCurve = this.points.length > 2, point = this.points[0];
        if (!canDrawCurve && point)
            this._drawStroke(point);
    };
    ejSignature.prototype._createDelegates = function () {
        this._drawStart = $.proxy(this._drawStartHandler, this);
        this._drawMove = $.proxy(this._drawMoveHandler, this);
        this._drawEnd = $.proxy(this._drawEndHandler, this);
    };
    ejSignature.prototype._wireEvents = function (remove) {
        var eventType = remove ? "off" : "on";
        this._createDelegates();
        this._on(this._canvas, ej.eventType.mouseDown, this._drawStart);
        this._wireResizeEvents();
    };
    ejSignature.prototype._wireResizeEvents = function () {
        $(window).bind("resize", $.proxy(this._resizeCanvas, this));
    };
    ejSignature.prototype._destroy = function () {
        this.element.removeClass("e-signature e-js e-select e-widget").removeAttr("role style signature");
        if (this.model.showRoundedCorner)
            this.element.removeClass("e-corner");
        this._off(this._canvas, (ej.eventType.mouseDown, ej.eventType.mouseMove, ej.eventType.mouseUp));
        $(window).unbind("resize", $.proxy(this._resizeCanvas, this));
        this.element.empty();
    };
    ejSignature.prototype._createPoint = function (event) {
        var rect = this._canvas[0].getBoundingClientRect();
        return this._point(event.clientX - rect.left, event.clientY - rect.top, undefined);
    };
    ejSignature.prototype._addPoint = function (point) {
        var points = this.points, cp2, cp3, curve;
        points.push(point);
        if (points.length > 2) {
            if (points.length === 3)
                points.unshift(points[0]);
            cp2 = (this._calculateCurveControlPoints(points[0], points[1], points[2])).cp2;
            cp3 = (this._calculateCurveControlPoints(points[1], points[2], points[3])).cp1;
            curve = this._bezierCurve(points[1], cp2, cp3, points[2]);
            this._addCurve(curve);
            points.shift();
        }
    };
    ejSignature.prototype._calculateCurveControlPoints = function (p1, p2, p3) {
        var dx1 = p1.x - p2.x, dy1 = p1.y - p2.y, dx2 = p2.x - (p3.x + 1), dy2 = p2.y - (p3.y + 1), m1 = { x: (p1.x + p2.x) / 2.0, y: (p1.y + p2.y) / 2.0 }, m2 = { x: (p2.x + p3.x) / 2.0, y: (p2.y + p3.y) / 2.0 }, l1 = Math.sqrt(dx1 * dx1 + dy1 * dy1), l2 = Math.sqrt(dx2 * dx2 + dy2 * dy2), dxm = (m1.x - m2.x), dym = (m1.y - m2.y), k = l2 / (l1 + l2), cm = { x: m2.x + dxm * k, y: m2.y + dym * k }, tx = p2.x - cm.x, ty = p2.y - cm.y;
        return {
            cp1: this._point(m1.x + tx, m1.y + ty, 0),
            cp2: this._point(m2.x + tx, m2.y + ty, 0)
        };
    };
    ejSignature.prototype._addCurve = function (curve) {
        var startPoint = this.startPoint, velocity, newWidth;
        velocity = this._pointVelocityCalc(startPoint);
        velocity = 0.7 * velocity + (0.7 - 1) * this._lastVelocity;
        newWidth = Math.max(this.model.strokeWidth / (velocity + 1), this.strokeMinimumWidth);
        this._curveDraw(curve, this._lastWidth, newWidth);
        this._lastVelocity = velocity;
        this._lastWidth = newWidth;
    };
    ejSignature.prototype._pointDraw = function (x, y, size) {
        var ctx = this._canvasContext;
        ctx.moveTo(x, y);
        ctx.arc(x, y, size, 0, 2 * Math.PI, false);
    };
    ejSignature.prototype._curveDraw = function (curve, startWidth, endWidth) {
        var ctx = this._canvasContext, drawSteps, width, i, t1, t2, t3, u1, u2, u3, x, y, widthValue = endWidth - startWidth;
        drawSteps = Math.floor(this._bezierLengthCalc());
        ctx.beginPath();
        for (i = 0; i < drawSteps; i++) {
            t1 = i / drawSteps;
            t2 = t1 * t1;
            t3 = t2 * t1;
            u1 = 1 - t1;
            u2 = u1 * u1;
            u3 = u2 * u1;
            x = u3 * this.startPoint.x;
            x += 3 * u2 * t1 * this.control1.x;
            x += 3 * u1 * t2 * this.control2.x;
            x += t3 * this.endPoint.x;
            y = u3 * this.startPoint.y;
            y += 3 * u2 * t1 * this.control1.y;
            y += 3 * u1 * t2 * this.control2.y;
            y += t3 * this.endPoint.y;
            width = startWidth + t3 * widthValue;
            this._pointDraw(x, y, width);
        }
        ctx.closePath();
        ctx.fill();
    };
    ejSignature.prototype._point = function (x, y, time) {
        this.x = x;
        this.y = y;
        this.time = time || new Date().getTime();
        return { x: this.x, y: this.y, time: this.time };
    };
    ejSignature.prototype._pointVelocityCalc = function (start) {
        return (this.time !== start.time) ? Math.sqrt(Math.pow(this.x - start.x, 2) + Math.pow(this.y - start.y, 2)) / (this.time - start.time) : 1;
    };
    ejSignature.prototype._bezierCurve = function (startPoint, control1, control2, endPoint) {
        this.startPoint = startPoint;
        this.control1 = control1;
        this.control2 = control2;
        this.endPoint = endPoint;
    };
    ejSignature.prototype._bezierLengthCalc = function () {
        var steps = 10, length = 0, i, t, pointx1, pointy1, pointx2, pointy2, pointx3, pointy3;
        for (i = 0; i <= steps; i++) {
            t = i / steps;
            pointx1 = this._bezierPoint(t, this.startPoint.x, this.control1.x, this.control2.x, this.endPoint.x);
            pointy1 = this._bezierPoint(t, this.startPoint.y, this.control1.y, this.control2.y, this.endPoint.y);
            if (i > 0) {
                pointx3 = pointx1 - pointx2;
                pointy3 = pointy1 - pointy2;
                length += Math.sqrt(pointx3 * pointx3 + pointy3 * pointy3);
            }
            pointx2 = pointx1;
            pointy2 = pointy1;
        }
        return length;
    };
    ejSignature.prototype._bezierPoint = function (t, startpoint, cp1, cp2, endpoint) {
        return startpoint * (1.0 - t) * (1.0 - t) * (1.0 - t) + 3.0 * cp1 * (1.0 - t) * (1.0 - t) * t + 3.0 * cp2 * (1.0 - t) * t * t + endpoint * t * t * t;
    };
    return ejSignature;
}(ej.WidgetBase));
ej.widget("ejSignature", "ej.Signature", new ejSignature());
window["ejSignature"] = null;
ej.Signature.SaveImageFormat = {
    PNG: "png",
    JPG: "jpg",
    BMP: "bmp",
    TIFF: "tiff"
};
;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SpellCheck = (function (_super) {
    __extends(SpellCheck, _super);
    function SpellCheck() {
        _super.apply(this, arguments);
        this.rootCSS = "e-spellcheck";
        this.PluginName = "ejSpellCheck";
        this._id = "null";
        this.defaults = {
            locale: "en-US",
            misspellWordCss: "e-errorword",
            ignoreSettings: {
                ignoreAlphaNumericWords: true,
                ignoreHtmlTags: true,
                ignoreEmailAddress: true,
                ignoreMixedCaseWords: true,
                ignoreUpperCase: true,
                ignoreUrl: true,
                ignoreFileNames: true
            },
            dictionarySettings: { dictionaryUrl: "", customDictionaryUrl: "" },
            maxSuggestionCount: 6,
            ajaxDataType: "jsonp",
            ignoreWords: [],
            contextMenuSettings: {
                enable: true,
                menuItems: [{ id: "IgnoreAll", text: "Ignore All" },
                    { id: "AddToDictionary", text: "Add to Dictionary" }]
            },
            isResponsive: true,
            enableValidateOnType: false,
            controlsToValidate: null,
            actionSuccess: null,
            actionBegin: null,
            actionFailure: null,
            start: null,
            complete: null,
            contextOpen: null,
            contextClick: null,
            dialogBeforeOpen: null,
            dialogOpen: null,
            dialogClose: null,
            validating: null,
            targetUpdating: null
        };
        this.dataTypes = {
            locale: "string",
            misspellWordCss: "string",
            ignoreSettings: {
                ignoreAlphaNumericWords: "boolean",
                ignoreHtmlTags: "boolean",
                ignoreEmailAddress: "boolean",
                ignoreMixedCaseWords: "boolean",
                ignoreUpperCase: "boolean",
                ignoreUrl: "boolean",
                ignoreFileNames: "boolean"
            },
            dictionarySettings: {
                dictionaryUrl: "string",
                customDictionaryUrl: "string",
                customDictionaryPath: "string"
            },
            maxSuggestionCount: "number",
            ajaxDataType: "string",
            ignoreWords: "array",
            contextMenuSettings: {
                enable: "boolean",
                menuItems: "array"
            }
        };
        this._localizedLabels = null;
        this._statusFlag = true;
        this._words = [];
        this._inputWords = [];
        this._controlIds = [];
        this._control = [];
        this._targetStatus = true;
        this._statusMultiTarget = false;
        this._changeAllWords = [];
        this._subElements = [];
        this._iframeStatus = false;
        this._elementStatus = true;
        this._suggestedWordCollection = [];
        this._ignoreStatus = true;
        this.model = this.defaults;
    }
    SpellCheck.prototype._init = function () {
        if (!ej.isNullOrUndefined(this.element)) {
            this._renderSpellCheck();
        }
    };
    SpellCheck.prototype._renderSpellCheck = function () {
        this._initLocalize();
        this._renderControls();
    };
    SpellCheck.prototype._initLocalize = function () {
        this._localizedLabels = this._getLocalizedLabels();
    };
    SpellCheck.prototype._renderControls = function () {
        if (ej.isNullOrUndefined(this.model.controlsToValidate)) {
            this._addAttributes(this, this.element);
        }
        else {
            $(this.element).attr("style", "display:none");
            this._controlIds = this.model.controlsToValidate.split(",");
            var elementPresent = false;
            for (var i = 0; i < this._controlIds.length; i++) {
                var element = $(this._controlIds[i]);
                if (element.length > 0) {
                    elementPresent = true;
                    if (element.length > 1) {
                        for (var j = 0; j < element.length; j++) {
                            var subElement = $(element[j]);
                            this._addAttributes(this, subElement);
                        }
                    }
                    else {
                        this._addAttributes(this, element);
                    }
                }
            }
            this._elementStatus = this._statusFlag = elementPresent;
        }
        if (this.model.isResponsive) {
            this._on($(window), "resize", $.proxy(this._resizeSpellCheck, this));
        }
    };
    SpellCheck.prototype._addAttributes = function (proxy, element) {
        $(element).addClass("e-spellcheck");
        element[0].spellcheck = false;
        proxy._addEventListeners(proxy, element);
    };
    SpellCheck.prototype._addEventListeners = function (proxy, element) {
        if (proxy._isIframe(element)) {
            $(element)[0].contentWindow.document.addEventListener("input", function () {
                proxy._changeStatus(proxy);
            }, false);
            if (proxy.model.contextMenuSettings.enable) {
                $(element)[0].contentWindow.document.addEventListener("mousedown", function () {
                    proxy._elementRightClick(proxy);
                }, false);
                ($(document)[0]).addEventListener("mousedown", function () {
                    proxy._elementRightClick(proxy);
                }, false);
                $(element)[0].contentWindow.document.addEventListener("keydown", function (e) {
                    proxy._spellValidateOnType(e);
                }, false);
            }
        }
        else {
            element[0].addEventListener("input", function () {
                proxy._changeStatus(proxy);
            }, false);
            if (proxy.model.contextMenuSettings.enable)
                proxy._on($(document), "mousedown", $.proxy(proxy._elementRightClick, proxy));
            proxy._on($(element[0]), "keydown", "", this._spellValidateOnType);
        }
    };
    SpellCheck.prototype._changeStatus = function (proxy) {
        proxy._statusFlag = true;
        if (!ej.isNullOrUndefined(proxy.model.controlsToValidate)) {
            proxy._controlIds = proxy.model.controlsToValidate.split(",");
            proxy._targetStatus = true;
        }
    };
    SpellCheck.prototype._isIframe = function (element) {
        return $(element)[0].tagName === "IFRAME";
    };
    SpellCheck.prototype._resizeSpellCheck = function () {
        var spellWindowParent = !ej.isNullOrUndefined(this._spellCheckWindow) && this._spellCheckWindow.parents().find(".e-spellcheck.e-dialog-wrap");
        var dialogObj = (!ej.isNullOrUndefined(this._spellCheckWindow) &&
            spellWindowParent.length > 0) && this._spellCheckWindow.data("ejDialog");
        if (this.model.isResponsive) {
            if (!ej.isNullOrUndefined(this._spellCheckWindow) && spellWindowParent.length > 0 && this._spellCheckWindow.ejDialog("isOpen")) {
                dialogObj._dialogPosition();
                var listObj = this._spellCheckWindow.find(".e-suggesteditems").data("ejListBox");
                listObj.refresh(true);
                var scrollObj = this._spellCheckWindow.find(".e-sentence .e-sentencescroller").data("ejScroller");
                setTimeout(function () {
                    spellWindowParent.find(".e-dialog-scroller").width(spellWindowParent.width() - 2);
                    spellWindowParent.find(".e-suggestionlist .e-content").width(spellWindowParent.find(".e-suggestionlist .e-content").width() - 2);
                    scrollObj.refresh();
                }, 4);
            }
        }
        else {
            dialogObj._dialogPosition();
        }
        if (!ej.isNullOrUndefined(this._alertWindow) && this._alertWindow.data("ejDialog")) {
            var alertDialogObj = !ej.isNullOrUndefined(this._alertWindow) && this._alertWindow.data("ejDialog");
            alertDialogObj._dialogPosition();
        }
    };
    SpellCheck.prototype.showInDialog = function () {
        if (this._statusFlag) {
            this._renderDialogWindow();
        }
        else {
            this._alertWindowRender("show");
        }
    };
    SpellCheck.prototype.validate = function () {
        if (this._statusFlag) {
            var diffWords = [], event;
            if (this.model.contextMenuSettings.enable &&
                !ej.isNullOrUndefined(this.model.dictionarySettings.dictionaryUrl)) {
                var inputText = "";
                if ((this._controlIds.length > 0 && !this._currentActiveElement && this.model.enableValidateOnType) ||
                    (this._controlIds.length > 0 && (!this.model.enableValidateOnType || !this._statusMultiTarget))) {
                    for (var i = 0; i < this._controlIds.length; i++) {
                        var element = $(this._controlIds[i]);
                        if (element.length > 0) {
                            for (var j = 0; j < element.length; j++) {
                                var subElement = $(element[j]);
                                var elementText = "";
                                elementText = this._elementTextProcess(this, subElement);
                                inputText = inputText === "" ? inputText.concat(elementText) : inputText.concat(" " + elementText);
                            }
                        }
                    }
                }
                else if (this.model.enableValidateOnType && this._currentActiveElement) {
                    inputText = this._elementTextProcess(this, $(this._currentActiveElement));
                }
                else {
                    if (this._isIframe(this.element)) {
                        $(this.element).contents().find("body").addClass("e-spellcheck");
                    }
                    inputText = this._elementTextProcess(this, this.element);
                }
                diffWords = this._filteringDiffWords(this, inputText);
                this._splitWords(inputText, this);
                event = { targetSentence: inputText, requestType: "validate", additionalParams: null };
                if (this._trigger("actionBegin", event)) {
                    return false;
                }
                if (diffWords.length > 0) {
                    this._ajaxRequest(this, diffWords.join(" "), "validateOnType", event);
                }
                else if (diffWords.length === 0 && !this._ignoreStatus) {
                    this._splitInputWords(inputText, this);
                    diffWords = ej.dataUtil.distinct(this._inputWords);
                    this._ajaxRequest(this, diffWords.join(" "), "validateOnType", event);
                }
                else {
                    if (!ej.isNullOrUndefined(this._errorWordDetails)) {
                        var errorWordData = this._filterErrorData(this, this._errorWordDetails);
                        this._validateOnTypeOperations(this, errorWordData, inputText, "validateOnType");
                    }
                    else {
                        if (!this.model.enableValidateOnType) {
                            this._alertWindowRender("show");
                        }
                    }
                }
            }
        }
        else {
            this._alertWindowRender("show");
        }
    };
    SpellCheck.prototype._filteringDiffWords = function (proxy, inputText) {
        var splitWords = proxy._inputWords, diffWords = [];
        proxy._splitInputWords(inputText, proxy);
        var updatedWords = proxy._inputWords;
        var index;
        for (var i = 0; i < updatedWords.length; i++) {
            index = splitWords.indexOf(updatedWords[i]);
            if (index === -1) {
                diffWords.push(updatedWords[i]);
            }
        }
        if (updatedWords.length !== splitWords.length && diffWords.length !== 0) {
            if (updatedWords.length === diffWords.length)
                diffWords = updatedWords;
        }
        return diffWords;
    };
    SpellCheck.prototype._elementTextProcess = function (proxy, element) {
        if (this.model.contextMenuSettings.enable && this.model.enableValidateOnType) {
            if (this._controlIds.length > 0) {
                if (element[0].nodeType == 9 && element[0].nodeName == "#document") {
                    element = $(this._controlIds[0]);
                }
            }
            else {
                element = $(this.element[0]);
            }
        }
        var inputText = "";
        if (proxy._isIframe(element)) {
            inputText = $(element).contents().find("body").text();
        }
        else {
            inputText = ej.isNullOrUndefined($(element)[0].value)
                ? ($(element)[0].innerText || $(element)[0].textContent).trim()
                : $(element)[0].value.trim();
        }
        return inputText;
    };
    SpellCheck.prototype._splitWords = function (inputText, proxy) {
        var splitWords = inputText.split(/[^0-9a-zA-Z\'_]/);
        splitWords = splitWords.filter(function (str) { return /\S/.test(str); });
        proxy._words = splitWords;
    };
    SpellCheck.prototype._splitInputWords = function (inputText, proxy) {
        var splitWords = inputText.split(" ");
        proxy._inputWords = splitWords;
    };
    SpellCheck.prototype.spellCheck = function (targetSentence, misspelledWordCss) {
        var event = { targetSentence: targetSentence, misspelledWordCss: misspelledWordCss, requestType: "spellCheck" };
        if (this._trigger("actionBegin", event)) {
            return false;
        }
        this._misspelledWordCss = misspelledWordCss;
        this._ajaxRequest(this, targetSentence, "spellCheck", event);
    };
    SpellCheck.prototype.ignoreAll = function (word, targetContent) {
        if (!ej.isNullOrUndefined(word) && word !== "" && (!ej.isNullOrUndefined(targetContent) && targetContent !== "")) {
            var event = { ignoreWord: word, targetContent: targetContent, requestType: "ignoreAll" };
            if (this._trigger("validating", event)) {
                return false;
            }
            this.model.ignoreWords.push(word);
            var ignoreResult = this._updateErrorContent(word, targetContent, null, "ignoreAll", null);
            return ignoreResult;
        }
        else {
            return false;
        }
    };
    SpellCheck.prototype.ignore = function (word, targetContent, index) {
        if (!ej.isNullOrUndefined(word) && word !== "" && (!ej.isNullOrUndefined(targetContent) && targetContent !== "")) {
            var event = { ignoreWord: word, targetContent: targetContent, requestType: "ignore" };
            if (this._trigger("validating", event)) {
                return false;
            }
            var ignoreResult = this._updateErrorContent(word, targetContent, null, "ignore", index);
            return ignoreResult;
        }
        else {
            return false;
        }
    };
    SpellCheck.prototype.change = function (word, targetContent, changeWord, index) {
        if (!ej.isNullOrUndefined(word) && word !== "" && (!ej.isNullOrUndefined(targetContent) && targetContent !== "") && (!ej.isNullOrUndefined(changeWord) && changeWord !== "")) {
            var event = { changableWord: word, targetContent: targetContent, changeWord: changeWord, requestType: "changeWord" };
            if (this._trigger("validating", event)) {
                return false;
            }
            var changeResult = this._updateErrorContent(word, targetContent, changeWord, "changeWord", index);
            return changeResult;
        }
        else {
            return false;
        }
    };
    SpellCheck.prototype.changeAll = function (word, targetContent, changeWord) {
        if (!ej.isNullOrUndefined(word) && word !== "" && (!ej.isNullOrUndefined(targetContent) && targetContent !== "") && (!ej.isNullOrUndefined(changeWord) && changeWord !== "")) {
            var event = { changableWord: word, targetContent: targetContent, changeWord: changeWord, requestType: "changeAll" };
            if (this._trigger("validating", event)) {
                return false;
            }
            var obj = {};
            obj["ErrorWord"] = word;
            obj["ReplaceWord"] = changeWord;
            this._changeAllWords.push(obj);
            var changeResult = this._updateErrorContent(word, targetContent, changeWord, "changeAll", null);
            return changeResult;
        }
        else {
            return false;
        }
    };
    SpellCheck.prototype.addToDictionary = function (customWord) {
        if (!ej.isNullOrUndefined(customWord) && customWord !== "") {
            var event = { customWord: customWord, requestType: "addToDictionary", additionalParams: null };
            if (this._trigger("validating", event)) {
                return false;
            }
            this._customWord = customWord;
            this._ajaxRequest(this, null, "addToDictionary", event);
        }
        else {
            return false;
        }
    };
    SpellCheck.prototype._updateErrorContent = function (word, targetContent, changeWord, requestType, index) {
        var updatedResult;
        if (targetContent.indexOf(word) !== -1) {
            var replaceString = "<span class=\"errorspan " + this.model.misspellWordCss + "\">" + word + "</span>";
            var replaceWord = requestType === "ignoreAll" || requestType === "addToDictionary" || requestType === "ignore" ? word : changeWord;
            if (requestType === "ignoreAll" || requestType === "addToDictionary" || requestType === "changeAll") {
                targetContent = targetContent.replace(new RegExp(replaceString, "g"), replaceWord);
            }
            else if (requestType === "ignore" || requestType === "changeWord") {
                if (ej.isNullOrUndefined(index)) {
                    targetContent = targetContent.replace(replaceString, replaceWord);
                }
                else {
                    var indexArray = new Array();
                    var startIndex = targetContent.indexOf(replaceString);
                    while (startIndex !== -1) {
                        indexArray.push(startIndex);
                        startIndex = targetContent.indexOf(replaceString, ++startIndex);
                    }
                    var replaceWordIndex = indexArray[index];
                    targetContent = targetContent.substr(0, replaceWordIndex) + replaceWord + targetContent.substr(replaceWordIndex + replaceString.length);
                }
            }
            updatedResult = { resultHTML: targetContent };
        }
        else {
            updatedResult = false;
        }
        return updatedResult;
    };
    SpellCheck.prototype._renderDialogWindow = function () {
        this._dialogWindowRendering();
        this._showDialog();
    };
    SpellCheck.prototype._dialogWindowRendering = function () {
        var proxy = this;
        this._spellCheckWindow = ej.buildTag("div.e-spellcheckdialog#" + this._id + "ErrorCorrectionWindow");
        var _contentArea = ej.buildTag("div.e-dialogdiv");
        var _contentLabel = ej.buildTag("div.e-row e-labelrow")
            .append(ej.buildTag("div.e-labelcell")
            .append(ej.buildTag("label.e-dictionarylabel", this._localizedLabels.NotInDictionary)));
        var _misspelledContentAreaRow = ej.buildTag("div.e-row e-sentencerow");
        var _misspelledContentCell = ej.buildTag("div.e-cell e-sentencecell")
            .append(ej.buildTag("div.e-sentence", "", {}, {
            id: this._id + "_Sentences",
            name: "sentences",
            contenteditable: "false"
        }));
        _misspelledContentAreaRow.append(_misspelledContentCell);
        var _spellCheckButtons = ej.buildTag("div.e-buttoncell");
        var _ignoreOnceButton = ej.buildTag("button.e-btnignoreonce", this._localizedLabels.IgnoreOnceButtonText, {}, { id: this._id + "_IgnoreOnce" }).attr("type", "button");
        var _ignoreAllButton = ej.buildTag("button.e-btnignoreall", this._localizedLabels.IgnoreAllButtonText, {}, { id: this._id + "_IgnoreAll" }).attr("type", "button");
        var _addToDictionaryButton = ej.buildTag("button.e-btnaddtodictionary", this._localizedLabels.AddToDictionary, {}, { id: this._id + "_AddToDictionary" }).attr("type", "button");
        _misspelledContentAreaRow.append(_spellCheckButtons.append(_ignoreOnceButton).append(_ignoreAllButton).append(_addToDictionaryButton));
        var _suggestionsLabel = ej.buildTag("div.e-row e-labelrow").append(ej.buildTag("div.e-labelcell")
            .append(ej.buildTag("label.e-lablesuggestions", this._localizedLabels.SuggestionLabel)));
        var _suggestionsAreaRow = ej.buildTag("div.e-row e-suggestionsrow");
        var _suggestionContentCell = ej.buildTag("div.e-cell e-suggestioncell").append(ej.buildTag("ul.e-suggesteditems", "", {}, { id: this._id + "_Suggestions" }));
        _suggestionsAreaRow.append(_suggestionContentCell);
        var _spellCheckKeys = ej.buildTag("div.e-buttoncell");
        var _changeButton = ej.buildTag("button.e-btnchange", this._localizedLabels.ChangeButtonText, {}, { id: this._id + "_Change" }).attr("type", "button");
        var _changeAllButton = ej.buildTag("button.e-btnchangeall", this._localizedLabels.ChangeAllButtonText, {}, { id: this._id + "_ChangeAll" }).attr("type", "button");
        var _closeButton = ej.buildTag("button.e-btnclose", this._localizedLabels.CloseButtonText, {}, { id: this._id + "_Close" }).attr("type", "button");
        _suggestionsAreaRow.append(_spellCheckKeys.append(_changeButton).append(_changeAllButton).append(_closeButton));
        _contentArea.append(_contentLabel).append(_misspelledContentAreaRow).append(_suggestionsLabel).append(_suggestionsAreaRow);
        this._spellCheckWindow.append(_contentArea);
        this._spellCheckWindow.ejDialog({
            width: 462,
            minHeight: 305,
            enableModal: true,
            enableResize: false,
            showOnInit: false,
            allowKeyboardNavigation: false,
            target: $("body"),
            title: this._localizedLabels.SpellCheckButtonText,
            close: function () {
                proxy._close();
            },
            cssClass: "e-spellcheck",
            isResponsive: this.model.isResponsive
        });
        var buttonClasses = [".e-btnignoreonce", ".e-btnignoreall", ".e-btnaddtodictionary", ".e-btnchange", ".e-btnchangeall", ".e-btnclose"];
        for (var i = 0; i < buttonClasses.length; i++) {
            this._spellCheckWindow.find(buttonClasses[i])
                .ejButton({
                width: this.model.isResponsive ? "100%" : 140,
                click: function (e) {
                    e.model.text === proxy._localizedLabels.CloseButtonText ? proxy._close() : proxy._changeErrorWord(e);
                },
                cssClass: "e-spellbuttons"
            });
        }
        this._spellCheckWindow.find(".e-sentence").append(ej.buildTag("div.e-sentencescroller").append(ej.buildTag("div").append(ej.buildTag("div.e-sentencecontent", "", {}, { id: this._id + "_SentenceContent" }))));
        this._spellCheckWindow.find(".e-sentence .e-sentencescroller")
            .ejScroller({
            height: "100%",
            scrollerSize: 20
        });
        this._spellCheckWindow.find(".e-suggesteditems").ejListBox({
            width: "100%",
            height: "100%",
            dataSource: null,
            selectedIndex: 0,
            cssClass: "e-suggestionlist"
        });
    };
    SpellCheck.prototype._alertWindowRender = function (requestType) {
        this._renderAlertWindow(requestType);
        if (!this._elementStatus) {
            this._alertWindow.find(".e-alerttext").html(this._localizedLabels.NotValidElement);
        }
        this._alertWindow.ejDialog("open");
    };
    SpellCheck.prototype._renderAlertWindow = function (requestType) {
        var proxy = this;
        this._alertWindow = ej.buildTag("div.e-alertdialog#" + this._id + "alertWindow");
        !this._elementStatus && this._alertWindow.addClass("e-missingalert");
        var _alertOkButton = ej.buildTag("div.e-alertbtn", "", { "text-align": "center" })
            .append(ej.buildTag("button.e-alertbutton e-alertspellok", this._localizedLabels.Ok, {}, { id: this._id + "alertok" }).attr("type", "button"));
        var _alertTextDiv = ej.buildTag("div.e-alerttextdiv");
        var _alertNotification = ej.buildTag("div.e-alertnotifydiv").append(ej.buildTag("div.e-alertnotification e-icon e-notification"));
        var _alertText = ej.buildTag("div.e-alerttext", this._localizedLabels.CompletionPopupMessage, { "text-align": "left", "padding": "5px" });
        _alertTextDiv.append(_alertNotification).append(_alertText);
        this._alertWindow.append(_alertTextDiv).append(_alertOkButton);
        this.element.append(this._alertWindow);
        this._alertWindow.find(".e-alertbutton")
            .ejButton({
            showRoundedCorner: true,
            width: this._elementStatus ? "70px" : "100px",
            click: function () {
                proxy._alertClose();
            },
            cssClass: "e-flat"
        });
        this._alertWindow.ejDialog({
            width: this._elementStatus ? 240 : 420,
            minHeight: 140,
            showOnInit: false,
            enableModal: true,
            title: this._localizedLabels.CompletionPopupTitle,
            enableResize: false,
            allowKeyboardNavigation: false,
            target: requestType === "validating" ? ".e-spellcheckdialog" : $("body"),
            cssClass: !this._elementStatus ? "e-spellalert e-elementmissing" : "e-spellalert",
            close: function () {
                proxy._alertClose();
            },
            isResponsive: this.model.isResponsive
        });
    };
    SpellCheck.prototype._renderContextMenu = function () {
        var proxy = this;
        var _menuTarget;
        this._contextMenu = ej.buildTag("ul#" + proxy._id + "contextMenu");
        if (!ej.isNullOrUndefined(proxy.model.controlsToValidate)) {
            var isIframe = false;
            for (var i = 0; i < proxy._controlIds.length; i++) {
                var flag = proxy._isIframe($(proxy._controlIds[i]));
                flag && (isIframe = true);
            }
            _menuTarget = isIframe ? $(proxy._controlIds[0]).contents()[0] : "." + proxy.model.misspellWordCss;
        }
        else {
            _menuTarget = proxy._isIframe(this.element)
                ? proxy.element.contents()[0]
                : "." + proxy.model.misspellWordCss;
        }
        this._contextMenu.ejMenu({
            fields: { id: "id", text: "text", parentId: "parentId" },
            menuType: ej.MenuType.ContextMenu,
            openOnClick: false,
            width: "auto",
            cssClass: "e-spellmenu",
            click: function (e) {
                proxy._onMenuSelect(e);
            }
        });
    };
    SpellCheck.prototype._contextMenuPosition = function (e, proxy) {
        var posX, posY;
        if (!ej.isNullOrUndefined(proxy._activeElement) && proxy._isIframe($(proxy.element))) {
            var targetElement = !ej.isNullOrUndefined(proxy.model.controlsToValidate)
                ? $(proxy._control[0]["controlId"])
                : $(proxy.element);
            posX = ((e.clientX == undefined) ? 0 : e.clientX) + (targetElement).offset().left,
                posY = ((e.clientY == undefined) ? 0 : e.clientY) + (targetElement).offset().top;
            var menuHeight = $(proxy._contextMenu).attr("style", "visibility: visible;display:block;").height(), menuWidth = $(proxy._contextMenu).width();
            posY = ((posY + menuHeight) < ($(document).scrollTop() + $(window).height()))
                ? posY
                : ((posY - menuHeight) < 0 ? posY : (posY - menuHeight));
            posX = ((posX + menuWidth) < ($(document).scrollLeft() + $(window).width())) ? posX : (posX - menuWidth);
        }
        else {
            posX = (e.clientX + proxy._contextMenu.width() < $(window).width()) ? e.pageX : e.pageX - proxy._contextMenu.width();
            posY = (e.clientY + proxy._contextMenu.height() < $(window).height()) ? e.pageY : (e.clientY > proxy._contextMenu.height()) ? e.pageY - proxy._contextMenu.height() : $(window).height() - proxy._contextMenu.outerHeight();
            var bodyPos = $("body").css("position") !== "static" ? $("body").offset() : { left: 0, top: 0 };
            posX -= bodyPos.left, posY -= bodyPos.top;
        }
        return {
            X: posX,
            Y: posY
        };
    };
    SpellCheck.prototype._showDialog = function () {
        var event = { spellCheckDialog: this._spellCheckWindow, requestType: "dialogBeforeOpen" };
        if (this._trigger("dialogBeforeOpen", event)) {
            return false;
        }
        this._spellCheckWindow.ejDialog("open");
        var inputText = "";
        var element;
        if (this._controlIds.length > 0) {
            for (var i = 0; i < this._controlIds.length; i++) {
                var element_1 = $(this._controlIds[i]);
                if (element_1.length > 0) {
                    for (var j = 0; j < element_1.length; j++) {
                        var subElement = $(element_1[j]);
                        this._activeElement = this._isIframe(subElement) ? $(subElement).contents().find("body")[0] : $(subElement)[0];
                        this._removeSpan(this);
                        this._subElements.push(subElement[0]);
                    }
                }
            }
            inputText = this._inputTextProcess(this, $(this._subElements[0]), inputText);
            this._proElements = this._subElements.length > 0 && $(this._subElements[0]);
            this._currentTargetElement = element = $(this._subElements[0]);
            this._subElements = this._subElements.slice(1);
        }
        else {
            element = this.element;
            this._activeElement = this._isIframe(element) ? this._getIframeElement(element) : $(element)[0];
            this._removeSpan(this);
            inputText = this._inputTextProcess(this, element, inputText);
        }
        var targetHtml = "";
        !ej.isNullOrUndefined(this.model.controlsToValidate) ? this.element = element : this.element = this.element;
        if (this.element.length > 0) {
            if (this._isIframe(this.element)) {
                targetHtml = $(this.element).contents().find("body").html();
            }
            else {
                targetHtml = $(element)[0].tagName === "TEXTAREA" ||
                    $(element)[0].tagName === "INPUT"
                    ? $(element)[0].value
                    : $(element)[0].innerHTML;
            }
        }
        var diffWords = this._filteringDiffWords(this, inputText);
        this._splitWords(inputText, this);
        if (!ej.isNullOrUndefined(this.model.controlsToValidate)) {
            var updateTargetEvent = { previousElement: null, currentElement: element, targetHtml: targetHtml };
            if (this._trigger("targetUpdating", updateTargetEvent)) {
                this._close();
                return false;
            }
        }
        this._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML = targetHtml;
        var dialogEvent = { targetText: inputText, requestType: "dialogOpen" };
        if (this._trigger("dialogOpen", dialogEvent)) {
            return false;
        }
        var beginEvent = { targetSentence: inputText, requestType: "spellCheck", additionalParams: null };
        if (this._trigger("actionBegin", beginEvent)) {
            return false;
        }
        if (diffWords.length > 0) {
            this._ajaxRequest(this, diffWords.join(" "), "spellCheckDialog", beginEvent);
        }
        else if (diffWords.length === 0 && !this._ignoreStatus) {
            this._splitInputWords(inputText, this);
            diffWords = ej.dataUtil.distinct(this._inputWords);
            this._ajaxRequest(this, diffWords.join(" "), "spellCheckDialog", beginEvent);
        }
        else {
            if (!ej.isNullOrUndefined(this._errorWordDetails)) {
                var errorWordData = this._filterErrorData(this, this._errorWordDetails);
                this._dialogModeOperations(this, errorWordData, inputText, "spellCheckDialog");
            }
            else {
                this._alertWindowRender("show");
            }
        }
    };
    SpellCheck.prototype._getIframeElement = function (element) {
        return $(element).contents().find("body")[0];
    };
    SpellCheck.prototype._inputTextProcess = function (proxy, element, inputText) {
        if (proxy._isIframe(element)) {
            var iframeText = $(element).contents().find("body").text();
            inputText = inputText === "" ? iframeText : (inputText + iframeText);
        }
        else {
            var elementText = ej.isNullOrUndefined($(element)[0].value)
                ? ($(element)[0].innerText || $(element)[0].textContent).trim()
                : $(element)[0].value.trim();
            inputText = inputText === "" ? elementText : (inputText + " " + elementText);
        }
        return inputText;
    };
    SpellCheck.prototype._ajaxRequest = function (proxy, text, requestType, events) {
        var value = requestType === "addToDictionary" ? JSON.stringify({ customWord: proxy._customWord, additionalParams: events.additionalParams }) : this._getModelValues(this, text, events);
        $.ajax({
            url: requestType === "addToDictionary" ? this.model.dictionarySettings.customDictionaryUrl : this.model.dictionarySettings.dictionaryUrl,
            data: { data: value },
            contentType: "application/json; charset=utf-8",
            dataType: this.model.ajaxDataType,
            crossDomain: true,
            success: function (result) {
                var data;
                if (requestType === "addToDictionary") {
                    if (!ej.isNullOrUndefined(proxy._errorWordDetails) && !ej.isNullOrUndefined(proxy._currentElement)) {
                        data = proxy._errorWordDetails;
                        if (!ej.isNullOrUndefined(result)) {
                            proxy._filterData(result.toString(), proxy);
                            proxy._errorWordDetails = proxy._errorWordsData;
                        }
                    }
                    else
                        data = [];
                }
                else {
                    data = proxy._updateErrorDetails(proxy, result);
                }
                var word, elementText = text, event;
                if (data.length > 0) {
                    var errorWordData;
                    if (requestType === "spellCheckDialog" ||
                        requestType === "validateOnType" ||
                        requestType === "validateOnRender") {
                        errorWordData = proxy._filterErrorData(proxy, data);
                        if (errorWordData.length > 0) {
                            if (requestType === "spellCheckDialog") {
                                proxy._dialogModeOperations(proxy, errorWordData, elementText, requestType);
                            }
                            else if (requestType === "validateOnType" || requestType === "validateOnRender") {
                                proxy._validateOnTypeOperations(proxy, errorWordData, elementText, requestType);
                            }
                        }
                        else {
                            if (requestType === "spellCheckDialog") {
                                proxy._spellCheckWindow.ejDialog("isOpen") && proxy._spellCheckWindow.ejDialog("close");
                            }
                            proxy._alertWindowRender("validating");
                        }
                    }
                    else if (requestType === "spellCheck") {
                        if (data.length > 0) {
                            var filterData = proxy._getFilterData(data, proxy);
                            errorWordData = ej.dataUtil.distinct(filterData);
                            for (var i = 0; i < errorWordData.length; i++) {
                                var query = new ej.Query()
                                    .where("ErrorWord", ej.FilterOperators.equal, errorWordData[i]);
                                var filterValue = new ej.DataManager(data).executeLocal(query);
                                if (errorWordData.length > 0) {
                                    word = "<span class=\"errorspan " +
                                        ((!ej.isNullOrUndefined(proxy._misspelledWordCss) &&
                                            proxy._misspelledWordCss !== "")
                                            ? proxy._misspelledWordCss
                                            : proxy.model.misspellWordCss) +
                                        "\">" +
                                        errorWordData[i] +
                                        "</span>";
                                    var replaceExpression = new RegExp(errorWordData[i], "gi");
                                    elementText = elementText.replace(replaceExpression, word);
                                }
                            }
                            event = { resultHTML: elementText, errorWordDetails: data, requestType: "spellCheck" };
                            proxy._misspelledWordCss = null;
                        }
                        else {
                            event = { resultHTML: elementText, errorWordDetails: data, requestType: "spellCheck" };
                        }
                        proxy._trigger("actionSuccess", event);
                    }
                    else if (requestType === "addToDictionary") {
                        var errorHtml;
                        if (!ej.isNullOrUndefined(proxy._currentElement)) {
                            if ($(proxy._currentElement)[0].tagName === "IFRAME") {
                                errorHtml = $(proxy._currentElement).contents().find("body").html();
                            }
                            else {
                                errorHtml = $(proxy._currentElement).html().trim();
                            }
                        }
                        var updatedResult = proxy
                            ._updateErrorContent(proxy._customWord, errorHtml, null, "addToDictionary", null);
                        if (!ej.isNullOrUndefined(errorHtml)) {
                            if (!ej.isNullOrUndefined(proxy._spellCheckWindow) &&
                                proxy._spellCheckWindow.find(".e-btnaddtodictionary").hasClass("e-select")) {
                                var listBoxElement = proxy._spellCheckWindow.find(".e-suggesteditems");
                                var contentElement = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent");
                                if (proxy._errorWordsData.length > 0) {
                                    contentElement[0].innerHTML = updatedResult["resultHTML"];
                                    proxy._replaceErrorText(contentElement, proxy._customWord.toString());
                                    proxy._listBoxDataUpdate(proxy);
                                }
                                else {
                                    listBoxElement.ejListBox({ dataSource: null });
                                    proxy._statusFlag = false;
                                    proxy._alertWindowRender("validating");
                                }
                            }
                            else if (!ej.isNullOrUndefined(proxy._contextMenu)) {
                                proxy._isIframe(proxy.element) ? $(proxy.element).contents().find("body").html(updatedResult["resultHTML"]) : $(proxy._currentElement)[0].innerHTML = updatedResult["resultHTML"];
                                if (proxy._controlIds.length > 0) {
                                    for (var i_1 = 0; i_1 < proxy._controlIds.length; i_1++) {
                                        var element = $(proxy._controlIds[i_1]);
                                        for (var j = 0; j < element.length; j++) {
                                            if ($(proxy._currentElement)[0] !== $(element[j])[0]) {
                                                var activeElement = $(element[j]);
                                                proxy._replaceErrorText(activeElement, proxy._customWord.toString());
                                            }
                                        }
                                    }
                                }
                                proxy._renderMenu(proxy);
                            }
                            event = {
                                resultHTML: updatedResult["resultHTML"],
                                errorWordDetails: result,
                                requestType: "addToDictionary"
                            };
                            proxy._trigger("actionSuccess", event);
                        }
                    }
                }
                else {
                    if (proxy._subElements.length > 0) {
                        proxy._updateTargetText(proxy);
                    }
                    else {
                        if (requestType === "spellCheckDialog") {
                            proxy._spellCheckWindow.ejDialog("isOpen") && proxy._spellCheckWindow.ejDialog("close");
                        }
                        if (requestType === "spellCheck") {
                            event = { resultHTML: text, errorWordDetails: data, requestType: "spellCheck" };
                            proxy._trigger("actionSuccess", event);
                        }
                        if (requestType === "validateOnType") {
                            proxy._removeSpan(proxy);
                        }
                        if (requestType !== "spellCheck" && requestType !== "addToDictionary")
                            proxy._alertWindowRender("load");
                    }
                }
            },
            error: function (xmlHttpRequest, textStatus, errorThrown) {
                var errorEvent = { errorMessage: errorThrown, requestType: requestType };
                proxy._trigger("actionFailure", errorEvent);
            }
        });
    };
    SpellCheck.prototype._suggestionsRequest = function (proxy, element, errorWord, requestType) {
        var value;
        if (requestType === "validateByMenu" || requestType === "suggestionsUpdate")
            value = JSON.stringify({ requestType: "getSuggestions", errorWord: errorWord });
        else
            value = proxy._getModelValues(proxy, errorWord, null);
        $.ajax({
            url: proxy.model.dictionarySettings.dictionaryUrl,
            data: { data: value },
            contentType: "application/json; charset=utf-8",
            dataType: proxy.model.ajaxDataType,
            crossDomain: true,
            success: function (result) {
                var obj = {};
                obj["ErrorWord"] = errorWord;
                obj["SuggestedWords"] = result[errorWord];
                proxy._suggestedWordCollection.push(obj);
                if (requestType === "validateByMenu") {
                    var errorWordsData = result[errorWord];
                    var event = { selectedErrorWord: errorWord, requestType: "contextOpen" };
                    if (proxy._trigger("contextOpen", event)) {
                        return false;
                    }
                    proxy._contextMenuDisplay(proxy, errorWordsData);
                }
                else if (requestType === "validateByDialog") {
                    var data = proxy._updateErrorDetails(proxy, result);
                    if (data.length > 0) {
                        var errorWordData = proxy._filterErrorData(proxy, data);
                        proxy._splitWords(element[0].innerText, proxy);
                        proxy._processNode(proxy, element[0], errorWordData, "spellCheckDialog");
                        proxy._activeElement = element[0];
                        proxy._changeAllErrors(proxy);
                        proxy._listBoxDataUpdate(proxy);
                    }
                    else {
                        if (proxy._subElements.length > 0) {
                            proxy._updateTargetText(proxy);
                        }
                        else {
                            proxy._completionCheck(proxy);
                        }
                    }
                }
                else if (requestType === "suggestionsUpdate") {
                    var filterData = result[element[0].innerText];
                    proxy._dialogSuggestionsUpdate(proxy, filterData);
                }
            }
        });
    };
    SpellCheck.prototype._filterErrorData = function (proxy, data) {
        var filteredData = proxy._getFilterData(data, proxy);
        return ej.dataUtil.distinct(filteredData);
    };
    SpellCheck.prototype._updateErrorDetails = function (proxy, result) {
        var data = [];
        if (ej.isNullOrUndefined(proxy._errorWordDetails)) {
            data = proxy._errorWordDetails = ej.isNullOrUndefined(proxy.model)
                ? result
                : (proxy.model.ajaxDataType === "json" ? result.Data : result);
        }
        else {
            if (result.length > 0) {
                if (proxy._ignoreStatus) {
                    for (var k = 0; k < result.length; k++) {
                        proxy._errorWordDetails.push(result[k]);
                        data = proxy._errorWordDetails;
                    }
                }
                else {
                    data = proxy._errorWordDetails = result;
                    proxy._ignoreStatus = true;
                }
            }
            else {
                data = proxy._errorWordDetails;
            }
        }
        return data;
    };
    SpellCheck.prototype._contextMenuDisplay = function (proxy, errorWordsData) {
        ej.isNullOrUndefined(proxy._contextMenu) && proxy._renderContextMenu();
        var menuObj = proxy._contextMenu.data("ejMenu");
        var options = proxy.model.contextMenuSettings.menuItems;
        if (errorWordsData.length > 0) {
            var suggestedWords = [];
            var count = proxy.model.maxSuggestionCount < errorWordsData.length
                ? proxy.model.maxSuggestionCount
                : errorWordsData.length;
            suggestedWords = proxy._convertData(errorWordsData.slice(0, count), "menuData");
            var sugCount = suggestedWords.length;
            var separatorElement = suggestedWords[count - 1]["id"];
            for (var i = 0; i < options.length; i++) {
                suggestedWords.push(options[i]);
            }
            menuObj.option("fields.dataSource", suggestedWords);
            var menuItems = menuObj.element.find(".e-list");
            for (var j = 0; j < sugCount; j++) {
                $(menuItems[j]).addClass("e-errorsuggestions");
            }
            for (var k = 0; k < menuItems.length; k++) {
                if (menuItems[k].attributes["id"].value === separatorElement) {
                    $(menuItems[k]).addClass("e-separator");
                }
            }
        }
        else {
            menuObj.option("fields.dataSource", options);
        }
        var position = proxy._contextMenuPosition(proxy._menuEvents, proxy);
        $(menuObj.element).css({ "left": position.X, "top": position.Y });
        $(menuObj.element).css("display", "block");
    };
    SpellCheck.prototype._dialogSuggestionsUpdate = function (proxy, filterData) {
        var listBoxElement = proxy._spellCheckWindow.find(".e-suggesteditems");
        var listObj = $("#" + proxy._id + "_Suggestions").data("ejListBox");
        var suggestions;
        if (filterData.length > 0) {
            if (proxy._spellCheckWindow.find(".e-btnchange").hasClass("e-disable") &&
                proxy._spellCheckWindow.find(".e-btnchangeall").hasClass("e-disable")) {
                proxy._spellCheckWindow.find(".e-btnchange").removeClass("e-disable");
                proxy._spellCheckWindow.find(".e-btnchangeall").removeClass("e-disable");
            }
            var count = proxy.model.maxSuggestionCount < filterData.length
                ? proxy.model.maxSuggestionCount
                : filterData.length;
            suggestions = filterData.slice(0, count);
        }
        else {
            proxy._spellCheckWindow.find(".e-btnchange").addClass("e-disable");
            proxy._spellCheckWindow.find(".e-btnchangeall").addClass("e-disable");
            suggestions = [proxy._localizedLabels.NoSuggestionMessage];
        }
        listBoxElement.ejListBox({ selectedIndex: null });
        listBoxElement.ejListBox({
            dataSource: proxy._convertData(suggestions, "dictionaryData"),
            selectedIndex: 0
        });
        if (!ej.isNullOrUndefined(listObj))
            listObj.refresh();
        var scrollObj = proxy._spellCheckWindow.find(".e-sentence .e-sentencescroller").data("ejScroller");
        if (!ej.isNullOrUndefined(scrollObj) && scrollObj.isVScroll())
            $(proxy._spellCheckWindow.find("." + proxy.model.misspellWordCss)).get(0).scrollIntoView(false);
    };
    SpellCheck.prototype._replaceErrorText = function (currentElement, result) {
        var spanElement = $(currentElement).find(".errorspan");
        for (var i = 0; i < spanElement.length; i++) {
            var spanText = spanElement[i].innerText || spanElement[i].textContent;
            if (spanText === result) {
                $(spanElement[i]).replaceWith(spanText);
            }
        }
    };
    SpellCheck.prototype._dialogModeOperations = function (proxy, errorWordData, elementText, requestType) {
        var event = { errorWords: proxy._errorWordDetails, targetText: elementText, requestType: requestType };
        var contentElement = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent");
        if (errorWordData.length > 0) {
            proxy._removeSpan(proxy);
            proxy._processNode(proxy, contentElement[0], errorWordData, requestType);
            if (this._trigger("start", event)) {
                return false;
            }
            var scrollObj = proxy._spellCheckWindow.find(".e-sentence .e-sentencescroller").data("ejScroller");
            scrollObj.refresh();
            proxy._listBoxDataUpdate(proxy);
        }
        else {
            var listBoxElement = proxy._spellCheckWindow.find(".e-suggesteditems");
            requestType === "spellCheckDialog" && (contentElement[0].innerHTML = elementText);
            listBoxElement.ejListBox({ dataSource: null });
            proxy._statusFlag = false;
            this._alertWindowRender("load");
        }
    };
    SpellCheck.prototype._validateOnTypeOperations = function (proxy, errorWordData, elementText, requestType) {
        if (errorWordData.length > 0) {
            if ((this._controlIds.length > 0 && !this._currentActiveElement && this.model.enableValidateOnType) ||
                (this._controlIds.length > 0 && (!this.model.enableValidateOnType || !this._statusMultiTarget))) {
                for (var i = 0; i < proxy._controlIds.length; i++) {
                    var element = $(this._controlIds[i]);
                    for (var j = 0; j < element.length; j++) {
                        var subElement = (proxy._isIframe($(element[j]))
                            ? proxy._getIframeElement($(element[j]))
                            : $(element[j])[0]);
                        proxy._activeElement = proxy._currentActiveElement = subElement;
                        proxy._removeSpan(proxy);
                        proxy._processNode(proxy, subElement, errorWordData, requestType);
                        var obj = {};
                        obj["controlId"] = proxy._controlIds[i];
                        obj["errorHtml"] = subElement.innerHTML;
                        proxy._control.push(obj);
                    }
                }
            }
            else if (this.model.enableValidateOnType && this._currentActiveElement) {
                proxy._removeSpan(proxy);
                proxy._processNode(proxy, this._currentActiveElement, errorWordData, requestType);
                this._statusMultiTarget = false;
            }
            else {
                if (proxy._isIframe(proxy.element)) {
                    var elem = proxy._getIframeElement(proxy.element);
                    proxy._activeElement = elem;
                    proxy._removeSpan(proxy);
                    proxy._processNode(proxy, elem, errorWordData, requestType);
                }
                else {
                    proxy._removeSpan(proxy);
                    proxy._processNode(proxy, $(proxy.element)[0], errorWordData, requestType);
                }
            }
            proxy._statusFlag = true;
            var event_1;
            if (this._controlIds.length > 0)
                event_1 = { errorWords: proxy._errorWordDetails, targetControls: this._control, requestType: requestType };
            else
                event_1 = { errorWords: proxy._errorWordDetails, targetText: $(proxy.element)[0].innerText, requestType: requestType };
            if (this._trigger("start", event_1)) {
                return false;
            }
            if (proxy._isIframe(this.element)) {
                proxy._bindBeforeOpen(proxy, $(this.element).contents().find("body"));
            }
            else {
                if (proxy._controlIds.length > 0) {
                    for (var i = 0; i < proxy._controlIds.length; i++) {
                        proxy._bindBeforeOpen(proxy, $(proxy._controlIds[i]));
                    }
                }
                else
                    proxy._bindBeforeOpen(proxy, $(this.element));
            }
        }
        else {
            proxy._removeSpan(proxy);
            proxy._statusFlag = false;
        }
        if (this.model.enableValidateOnType) {
            proxy.setCursorPosition(proxy._currentCursorTarget);
        }
    };
    SpellCheck.prototype._bindBeforeOpen = function (proxy, element) {
        proxy._on($(element).find("." + this.model.misspellWordCss), "contextmenu", $.proxy(proxy._contextOpen, proxy));
    };
    SpellCheck.prototype._contextOpen = function (e) {
        var _targ = $(e.target);
        if (_targ.hasClass("errorspan")) {
            e.preventDefault();
            var proxy = this;
            var selectedWord = proxy._selectedValue = _targ[0].innerText;
            proxy._selectedTarget = _targ[0];
            proxy._menuEvents = e;
            var filterValue = proxy._filterSuggestions(proxy, selectedWord);
            if (filterValue.length > 0) {
                proxy._contextMenuDisplay(proxy, filterValue[0]["SuggestedWords"]);
            }
            else {
                proxy._suggestionsRequest(proxy, null, selectedWord, "validateByMenu");
            }
        }
        else {
            this._elementRightClick(e);
        }
    };
    SpellCheck.prototype._processNode = function (proxy, element, errorWordData, requestType) {
        var elementTextNodes = proxy._filterTextNodes(proxy, element);
        for (var i = 0; i < elementTextNodes.length; i++) {
            var presentNode = elementTextNodes[i];
            var elementNodes = [elementTextNodes[i]];
            var nodeData = elementTextNodes[i].data;
            var isUrl = false, isEmail = false, flag = false;
            if (proxy.model.ignoreSettings.ignoreUrl) {
                var urlRegEx = /^((http|ftp|https)?:\/\/)?(www\.)?[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/.*)?$/;
                isUrl = urlRegEx.test(presentNode.wholeText);
                isUrl && (flag = isUrl);
            }
            if (proxy.model.ignoreSettings.ignoreEmailAddress) {
                var mailAddressValidation = /^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.(aero|arpa|biz|com|coop|edu|gov|info|int|mil|museum|name|net|org|pro|travel|mobi|[a-z][a-z])|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i;
                isEmail = mailAddressValidation.test(presentNode.wholeText);
                isEmail && (flag = isEmail);
            }
            if (!flag) {
                for (var j = 0; j < proxy._words.length; j++) {
                    for (var k = 0; k < errorWordData.length; k++) {
                        if (proxy._words[j] === errorWordData[k] &&
                            !ej.isNullOrUndefined(nodeData.match(new RegExp("\\b" + errorWordData[k] + "\\b", "gi"))) &&
                            nodeData.indexOf(errorWordData[k]) !== -1) {
                            var wordIndex = nodeData.indexOf(errorWordData[k]);
                            var wordLength = errorWordData[k].length;
                            var newNode = presentNode.splitText(wordIndex);
                            var span = document.createElement("span");
                            if (requestType === "validateOnType")
                                span.className = "errorspan " + this.model.misspellWordCss;
                            else
                                span.className = "errorspan";
                            var errorTextNode = document.createTextNode(errorWordData[k]);
                            span.appendChild(errorTextNode);
                            presentNode.parentNode.insertBefore(span, newNode);
                            newNode.data = newNode.data.substr(wordLength);
                            presentNode = newNode;
                            elementNodes.push(errorTextNode);
                            elementNodes.push(newNode);
                            nodeData = newNode.data;
                        }
                    }
                }
            }
        }
    };
    SpellCheck.prototype._spellValidateOnType = function (e) {
        if (this.model.enableValidateOnType && this.model.contextMenuSettings.enable) {
            var event_2 = { events: e, requestType: "validate" };
            this._trigger("validating", event_2);
            this._statusMultiTarget = false;
            this._currentActiveElement = event_2.events.currentTarget;
            if (event_2.events.cancelable === true) {
                var keyCode = e.keyCode;
                if (keyCode >= 16 && keyCode <= 31) {
                    return;
                }
                if (keyCode >= 37 && keyCode <= 40) {
                    return;
                }
                if (keyCode === 32 || keyCode === 13) {
                    this._statusMultiTarget = true;
                    this._triggerSpelling();
                }
            }
        }
    };
    SpellCheck.prototype._triggerSpelling = function () {
        var proxy = this;
        setTimeout(function () {
            proxy.getCursorPosition();
            proxy.validate();
        }, 2);
    };
    SpellCheck.prototype.getCursorPosition = function () {
        if (this.model.enableValidateOnType && this.model.contextMenuSettings.enable) {
            var proxy = this;
            var temp_node = String.fromCharCode(7);
            var getSelection;
            var selection;
            var range;
            if (this._controlIds.length > 0) {
                for (var i = 0; i < this._controlIds.length; i++) {
                    var element = $(this._controlIds[i]);
                    if (this._isIframe(element)) {
                        getSelection = element[0].contentDocument.getSelection();
                        selection = element[0].contentDocument.getSelection();
                        range = element[0].contentDocument.createRange();
                    }
                    else {
                        getSelection = document.getSelection();
                        selection = document.getSelection();
                        range = document.createRange();
                    }
                }
            }
            else {
                if (this._isIframe(this.element)) {
                    getSelection = this.element[0].contentDocument.getSelection();
                    selection = this.element[0].contentDocument.getSelection();
                    range = this.element[0].contentDocument.createRange();
                }
                else {
                    getSelection = document.getSelection();
                    selection = document.getSelection();
                    range = document.createRange();
                }
            }
            var getRange = getSelection.getRangeAt(0);
            getRange.deleteContents();
            getRange.insertNode(document.createTextNode(temp_node));
            if ($(getRange.startContainer.parentElement).hasClass("errorspan")) {
                if (this.model.controlsToValidate) {
                    proxy._normalizeTextNodes(this._currentActiveElement);
                }
                else {
                    proxy._normalizeTextNodes($(proxy.element)[0]);
                }
            }
            proxy._currentCursorTarget = proxy._getActiveTarget(proxy, temp_node);
            range.collapse(true);
            range.setStart(proxy._currentCursorTarget.node, proxy._currentCursorTarget.offset);
            range.setEnd(proxy._currentCursorTarget.node, proxy._currentCursorTarget.offset);
            selection.removeAllRanges();
            selection.addRange(range);
            return proxy._currentCursorTarget;
        }
    };
    SpellCheck.prototype._getActiveTarget = function (proxy, temp_node) {
        var elementTextNodes;
        if (this.model.enableValidateOnType) {
            elementTextNodes = proxy._filterTextNodes(proxy, this._currentActiveElement);
        }
        else {
            elementTextNodes = proxy._filterTextNodes(proxy, $(proxy.element)[0]);
        }
        var currentCursorPosition = null;
        var currentCursorNode = null;
        for (var i = 0; i < elementTextNodes.length; i++) {
            if (elementTextNodes[i].data.indexOf(temp_node) > -1) {
                currentCursorNode = elementTextNodes[i];
                currentCursorPosition = elementTextNodes[i].data.indexOf(temp_node);
                elementTextNodes[i].data = elementTextNodes[i].data.replace(temp_node, "");
                return {
                    node: currentCursorNode,
                    offset: currentCursorPosition
                };
            }
        }
    };
    SpellCheck.prototype.setCursorPosition = function (cursorTarget) {
        var selection;
        var range;
        if (this._controlIds.length > 0) {
            for (var i = 0; i < this._controlIds.length; i++) {
                var element = $(this._controlIds[i]);
                if (this._isIframe(element)) {
                    selection = element[0].contentDocument.getSelection();
                    range = element[0].contentDocument.createRange();
                }
                else {
                    selection = document.getSelection();
                    range = document.createRange();
                }
            }
        }
        else {
            if (this._isIframe(this.element)) {
                selection = this.element[0].contentDocument.getSelection();
                range = this.element[0].contentDocument.createRange();
            }
            else {
                selection = document.getSelection();
                range = document.createRange();
            }
        }
        var elementTextNodes;
        if (selection.getRangeAt && selection.rangeCount) {
            var temp_node = String.fromCharCode(7);
            if (cursorTarget) {
                if (this.model.controlsToValidate) {
                    elementTextNodes = this._filterTextNodes(this, this._currentActiveElement);
                }
                else {
                    elementTextNodes = this._filterTextNodes(this, $(this.element)[0]);
                }
                var currentCursorNode = cursorTarget.node;
                var currentCursorPosition = cursorTarget.offset;
                for (var i = 0; i < elementTextNodes.length; i++) {
                    if (elementTextNodes[i] === currentCursorNode) {
                        var nodeIndex = i;
                    }
                }
                var currentWord = '';
                if (nodeIndex === undefined) {
                    var wordEmptySpace = '';
                    var wordRightSpace = '';
                    var charCodeEmptySpace = '';
                    var currentWord = '';
                    var wordWithoutSpace = '';
                    var isWordRightSpace = false;
                    var isWord = false;
                    for (var cx = 0; cx < currentCursorNode.length; cx++) {
                        var cc = currentCursorNode.data.charAt(cx);
                        if (cc.charCodeAt(0) != 160) {
                            if (cc.charCodeAt(0) != 32) {
                                if (wordEmptySpace === '') {
                                    currentWord = currentWord + cc;
                                }
                                else {
                                    if (cc != temp_node) {
                                        wordRightSpace = wordRightSpace + cc;
                                    }
                                }
                            }
                            else {
                                wordEmptySpace = currentWord + cc;
                                wordRightSpace = cc;
                            }
                        }
                        else {
                            wordEmptySpace = currentWord + cc;
                            charCodeEmptySpace = ' ' + charCodeEmptySpace + cc;
                        }
                    }
                    currentWord = currentWord + wordRightSpace;
                    wordWithoutSpace = wordEmptySpace.trim();
                    for (var i = 0; i < elementTextNodes.length; i++) {
                        if (elementTextNodes[i].data === currentWord) {
                            nodeIndex = i;
                        }
                        if (elementTextNodes[i].data === wordEmptySpace) {
                            nodeIndex = i;
                        }
                        if (elementTextNodes[i].data === wordRightSpace && wordRightSpace != '') {
                            nodeIndex = i;
                            isWordRightSpace = true;
                        }
                        if (elementTextNodes[i].data === currentWord) {
                            nodeIndex = i;
                            isWord = true;
                        }
                        if (elementTextNodes[i].data === wordWithoutSpace) {
                            nodeIndex = i;
                        }
                        if (elementTextNodes[i].data === currentWord && elementTextNodes[i + 1] !== undefined && elementTextNodes[i + 1].data.charCodeAt(0) === 160) {
                            nodeIndex = i;
                            break;
                        }
                        if (elementTextNodes[i].data === currentWord && elementTextNodes[i + 1] !== undefined && elementTextNodes[i + 1].data.charCodeAt(1) === 160 && charCodeEmptySpace.length >= 1) {
                            nodeIndex = i;
                            break;
                        }
                        if ((elementTextNodes[i].data === wordEmptySpace || elementTextNodes[i].data === currentWord) && elementTextNodes[i + 1] == undefined) {
                            var errorTextNode = document.createTextNode("");
                            elementTextNodes.push(errorTextNode);
                            this._currentActiveElement.appendChild(errorTextNode);
                            nodeIndex = i + 1;
                            currentCursorPosition = elementTextNodes[nodeIndex].data.length;
                            currentCursorNode = elementTextNodes[nodeIndex];
                            break;
                        }
                    }
                }
                for (var i = nodeIndex; i < elementTextNodes.length - 1; i++) {
                    if (currentCursorPosition <= elementTextNodes[i].data.length) {
                        currentCursorNode = elementTextNodes[i];
                        break;
                    }
                    if (isWordRightSpace === false || wordRightSpace === undefined || wordRightSpace === '') {
                        currentCursorPosition -= elementTextNodes[i].data.length;
                        currentCursorNode = elementTextNodes[i + 1];
                    }
                    else {
                        currentCursorPosition = 1;
                        currentCursorNode = elementTextNodes[i];
                        break;
                    }
                }
                var textNode = currentCursorNode;
                range.collapse(true);
                range.setStart(textNode, currentCursorPosition);
                range.setEnd(textNode, currentCursorPosition);
                selection.removeAllRanges();
                selection.addRange(range);
            }
        }
    };
    SpellCheck.prototype._normalizeTextNodes = function (element) {
        element.normalize();
        return;
    };
    SpellCheck.prototype._filterTextNodes = function (proxy, elem) {
        var filteredTextNodes = [];
        getTextNodes(elem);
        function getTextNodes(element) {
            for (var i = 0; i < element.childNodes.length; i++) {
                var child = element.childNodes[i];
                if (child.nodeType === 3) {
                    filteredTextNodes.push(child);
                }
                else if (child.childNodes) {
                    getTextNodes(child);
                }
            }
        }
        return filteredTextNodes;
    };
    SpellCheck.prototype._removeSpan = function (proxy) {
        if (!proxy.model.enableValidateOnType) {
            var element = !ej.isNullOrUndefined(proxy.model.controlsToValidate) || proxy._isIframe(proxy.element) ? proxy._activeElement : proxy.element[0];
        }
        else {
            if (proxy._currentActiveElement) {
                var element = proxy._currentActiveElement;
            }
        }
        var spanElement = $(element).find("span.errorspan");
        for (var i = 0; i < spanElement.length; i++) {
            var spanText = spanElement[i].innerText || spanElement[i].textContent;
            $(spanElement[i]).replaceWith(spanText);
        }
    };
    SpellCheck.prototype._getFilterData = function (result, proxy) {
        var errorWordData = [];
        proxy._errorWordsData = proxy._errorWordDetails = result;
        for (var k = 0; k < proxy.model.ignoreWords.length; k++) {
            proxy._filterData(proxy.model.ignoreWords[k], proxy);
        }
        for (var j = 0; j < proxy._errorWordsData.length; j++) {
            errorWordData.push(proxy._errorWordsData[j].ErrorWord);
        }
        return errorWordData;
    };
    SpellCheck.prototype._filterData = function (filterWord, proxy) {
        var query = new ej.Query().where("ErrorWord", ej.FilterOperators.notEqual, filterWord);
        proxy._errorWordsData = new ej.DataManager(proxy._errorWordsData).executeLocal(query);
    };
    SpellCheck.prototype._formHtml = function (errorWordData, elementText) {
        var word, replaceExpression;
        for (var j = 0; j < errorWordData.length; j++) {
            word = "<span class=\"errorspan\">" + errorWordData[j] + "</span>";
            replaceExpression = new RegExp("\\b" + errorWordData[j] + "\\b", "gi");
            elementText = elementText.replace(replaceExpression, word);
        }
        return elementText;
    };
    SpellCheck.prototype._listBoxDataUpdate = function (proxy) {
        var errorWordElement = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent").find(".errorspan");
        $(errorWordElement[0]).addClass(this.model.misspellWordCss);
        if (errorWordElement.length > 0) {
            var filterValue = proxy._filterSuggestions(proxy, errorWordElement[0].innerText);
            if (filterValue.length > 0) {
                proxy._dialogSuggestionsUpdate(proxy, filterValue[0]["SuggestedWords"]);
            }
            else {
                proxy._suggestionsRequest(proxy, errorWordElement, errorWordElement[0].innerText, "suggestionsUpdate");
            }
        }
        else {
            if (!ej.isNullOrUndefined(this.model.controlsToValidate) && proxy._targetStatus) {
                proxy._updateTargetText(proxy);
            }
            else {
                var targetSentence = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML;
                proxy._validationComplete(proxy, targetSentence);
            }
        }
    };
    SpellCheck.prototype._filterSuggestions = function (proxy, errorWord) {
        var filterValue = [];
        if (proxy._suggestedWordCollection.length > 0) {
            var query = new ej.Query().where("ErrorWord", ej.FilterOperators.equal, errorWord);
            var data = new ej.DataManager(proxy._suggestedWordCollection).executeLocal(query);
            filterValue = data;
        }
        return filterValue;
    };
    SpellCheck.prototype._validationComplete = function (proxy, targetSentence) {
        proxy._updateTargetString(proxy);
        var updateEvent = { targetElement: proxy._currentTargetElement, targetText: targetSentence, requestType: "changeErrorWord" };
        if (this._trigger("complete", updateEvent)) {
            return false;
        }
        proxy._statusFlag = false;
        proxy._alertWindowRender("validating");
    };
    SpellCheck.prototype._onMenuSelect = function (args) {
        var id = args.events.ID.split("_");
        var isIframe = false;
        if (!ej.isNullOrUndefined(this.model.controlsToValidate)) {
            for (var i = 0; i < this._controlIds.length; i++) {
                var flag_1 = this._isIframe($(this._controlIds[i]));
                flag_1 && (isIframe = true);
                isIframe && (this.element = $(this._controlIds[0]));
            }
        }
        else {
            isIframe = this._isIframe(this.element);
        }
        var currentElement = isIframe ? this.element : this._selectedTarget.parentElement;
        this._activeElement = (currentElement);
        var htmlContent = "";
        htmlContent = this._isIframe($(currentElement)) ? $(currentElement).contents().find("body").html() : $(currentElement).html().trim();
        var event = { selectedOption: id[0], requestType: "menuSelect", targetContent: htmlContent, selectedValue: this._selectedValue };
        if (this._trigger("contextClick", event)) {
            return false;
        }
        switch (id[0]) {
            case "AddToDictionary":
                var addWord = (this._selectedTarget.innerText || this._selectedTarget.textContent).trim();
                this._currentElement = $(currentElement);
                this.addToDictionary(addWord);
                break;
            case "IgnoreAll":
                var errorWord = (this._selectedTarget.innerText || this._selectedTarget.textContent).trim();
                var result = this.ignoreAll(errorWord, htmlContent);
                htmlContent = result["resultHTML"];
                $(currentElement).html(result["resultHTML"]);
                if (this._controlIds.length > 0) {
                    for (var i = 0; i < this._controlIds.length; i++) {
                        var element = $(this._controlIds[i]);
                        for (var j = 0; j < element.length; j++) {
                            if ($(currentElement)[0] !== $(element[j])[0]) {
                                var activeElement = $(element[j]);
                                this._replaceErrorText(activeElement, errorWord);
                            }
                        }
                    }
                }
                this._renderMenu(this);
                break;
            default:
                var selectedValue = id[0];
                var flag = $(args.element).hasClass("e-errorsuggestions");
                if (flag) {
                    this._selectedTarget.innerHTML = selectedValue;
                    var replaceItem = document.createTextNode(this._selectedTarget.innerText || this._selectedTarget.textContent);
                    this._selectedTarget.parentNode.insertBefore(replaceItem, this._selectedTarget);
                    $(this._selectedTarget).remove();
                    htmlContent = $(currentElement).html();
                }
                this._renderMenu(this);
                break;
        }
    };
    SpellCheck.prototype._renderMenu = function (proxy) {
        var length;
        if (proxy._controlIds.length > 0) {
            for (var i = 0; i < proxy._controlIds.length; i++) {
                length = proxy._getErrorLength(proxy, $(proxy._controlIds[i]));
                if (length > 0)
                    break;
            }
        }
        else {
            length = proxy._getErrorLength(proxy, $(proxy.element));
        }
        if (length === 0) {
            var updateEvent = { targetElement: proxy._currentTargetElement, requestType: "validate" };
            if (proxy._trigger("complete", updateEvent)) {
                return false;
            }
        }
        length > 0 ? proxy._statusFlag = true : proxy._statusFlag = false;
        var menuObj = proxy._contextMenu.data("ejMenu");
        $(menuObj.element).is(":visible") && menuObj.hide();
        var element = !ej.isNullOrUndefined(proxy._activeElement) ? proxy._activeElement : proxy.element;
        if (proxy._isIframe($(element))) {
            proxy._bindBeforeOpen(proxy, $(element).contents().find("body"));
        }
        else {
            proxy._bindBeforeOpen(proxy, $(element));
        }
    };
    SpellCheck.prototype._getErrorLength = function (proxy, element) {
        var targetElement = (proxy._isIframe(element)
            ? $(element).contents().find("body")[0]
            : $(element));
        var length = $(targetElement).find(".errorspan").length;
        return length;
    };
    SpellCheck.prototype._getElement = function () {
        var spanTags = document.getElementsByTagName("span");
        var searchText = this._selectedValue;
        var found = [];
        for (var i = 0; i < spanTags.length; i++) {
            if (spanTags[i].textContent === searchText) {
                found.push(spanTags[i]);
            }
        }
        return found;
    };
    SpellCheck.prototype._alertClose = function () {
        if (!ej.isNullOrUndefined(this._alertWindow) && this._alertWindow.parents().find(".e-alertdialog").length > 0) {
            this._alertWindow.ejDialog("close");
            this._alertWindow.parents().find(".e-alertdialog").remove();
            this._close();
        }
    };
    SpellCheck.prototype._close = function () {
        if (!ej.isNullOrUndefined(this._spellCheckWindow) && this._spellCheckWindow.parents().find(".e-spellcheck.e-dialog-wrap").length > 0) {
            var contentAreaElement = this._spellCheckWindow.find(".e-sentence .e-sentencecontent");
            var spanElement = $(contentAreaElement[0]).find("span.errorspan");
            for (var i = 0; i < spanElement.length; i++) {
                var spanText = spanElement[i].innerText || spanElement[i].textContent;
                $(spanElement[i]).replaceWith(spanText);
            }
            this._updateTargetString(this);
            var updatedString = contentAreaElement.html();
            var event;
            if (!ej.isNullOrUndefined(this.model.controlsToValidate))
                event = { updatedText: contentAreaElement.text(), targetElement: this._currentTargetElement, updatedHtml: updatedString, requestType: "dialogClose" };
            else
                event = { updatedText: contentAreaElement.text(), updatedHtml: updatedString, requestType: "dialogClose" };
            if (this._trigger("dialogClose", event)) {
                return false;
            }
            if (this._spellCheckWindow.ejDialog("isOpen"))
                this._spellCheckWindow.ejDialog("close");
            this._spellCheckWindow.parents().find(".e-spellcheck.e-dialog-wrap").remove();
            this._changeAllWords = [];
            if (!ej.isNullOrUndefined(this.model.controlsToValidate)) {
                this._controlIds = this.model.controlsToValidate.split(",");
                this._subElements = [];
            }
        }
    };
    SpellCheck.prototype._changeErrorWord = function (args) {
        var selectedValue = $("#" + this._id + "_Suggestions").ejListBox("option", "value");
        var divElement = this._spellCheckWindow.find(".e-sentence .e-sentencecontent");
        var targetText = this._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML;
        var errorWord = $(this._spellCheckWindow.find(".e-sentence .e-sentencecontent").find("." + this.model.misspellWordCss)[0]).text().trim();
        var result;
        selectedValue = selectedValue === this._localizedLabels.NoSuggestionMessage ? errorWord : selectedValue;
        if (args.model.text === this._localizedLabels.AddToDictionary) {
            this._currentElement = $(divElement);
            this.addToDictionary(errorWord);
        }
        else {
            if (args.model.text === this._localizedLabels.IgnoreOnceButtonText) {
                result = this.ignore(errorWord, targetText, null);
                if (result !== false)
                    this._updateErrorWord(this, result, args, errorWord, null, "ignore");
            }
            else if (args.model.text === this._localizedLabels.IgnoreAllButtonText) {
                result = this.ignoreAll(errorWord, targetText);
                if (result !== false)
                    this._updateErrorWord(this, result, args, errorWord, null, "ignoreAll");
            }
            else if (args.model.text === this._localizedLabels.ChangeButtonText) {
                result = this.change(errorWord, targetText, selectedValue, null);
                if (result !== false)
                    this._updateErrorWord(this, result, args, errorWord, selectedValue, "change");
            }
            else if (args.model.text === this._localizedLabels.ChangeAllButtonText) {
                result = this.changeAll(errorWord, targetText, selectedValue);
                if (result !== false)
                    this._updateErrorWord(this, result, args, errorWord, selectedValue, "changeAll");
            }
        }
    };
    SpellCheck.prototype._convertData = function (result, type) {
        var data = [];
        for (var i = 0; i < result.length; i++) {
            if (type === "dictionaryData") {
                data.push({ field: result[i] });
            }
            else if (type === "menuData") {
                data.push({ id: result[i], text: result[i] });
            }
        }
        return data;
    };
    SpellCheck.prototype._updateErrorWord = function (proxy, result, event, errorWord, selectedValue, requestType) {
        var listBoxElement = this._spellCheckWindow.find(".e-suggesteditems");
        proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML = result["resultHTML"];
        var errorWordElement = this._spellCheckWindow.find(".e-sentence .e-sentencecontent").find(".errorspan");
        var listObj;
        if (errorWordElement.length > 0) {
            proxy._targetUpdate(proxy, errorWordElement, errorWord, requestType, selectedValue);
        }
        else {
            if (!ej.isNullOrUndefined(this.model.controlsToValidate) && proxy._targetStatus) {
                proxy._updateTargetText(proxy);
            }
            else {
                if (!ej.isNullOrUndefined(this.model.controlsToValidate)) {
                    $(this._proElements)
                        .html(proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML);
                }
                var noSuggestion = [this._localizedLabels.NoSuggestionMessage];
                listBoxElement.ejListBox({ selectedItemIndex: null });
                listBoxElement.ejListBox({
                    dataSource: this._convertData(noSuggestion, "dictionaryData"),
                    selectedItemIndex: 0
                });
                listObj = $("#" + this._id + "_Suggestions").data("ejListBox");
                listObj.refresh();
                proxy._validationComplete(proxy, result["resultHTML"]);
            }
        }
    };
    SpellCheck.prototype._targetUpdate = function (proxy, errorWordElement, errorWord, requestType, selectedValue) {
        if (requestType === "changeAll") {
            for (var i = 0; i < errorWordElement.length; i++) {
                var spanText = errorWordElement[i].innerText || errorWordElement[i].textContent;
                if (spanText === errorWord) {
                    $(errorWordElement[i]).replaceWith(selectedValue);
                }
            }
        }
        for (var j = 0; j < this.model.ignoreWords.length; j++) {
            for (var k = 0; k < errorWordElement.length; k++) {
                var elementText = errorWordElement[k].innerText || errorWordElement[k].textContent;
                if (elementText === proxy.model.ignoreWords[j]) {
                    $(errorWordElement[k]).replaceWith(elementText);
                }
            }
        }
        proxy._listBoxDataUpdate(proxy);
    };
    SpellCheck.prototype._updateTargetText = function (proxy) {
        proxy._updateTargetString(proxy);
        var updateElement = !ej.isNullOrUndefined(proxy.model.controlsToValidate) ? $(proxy._proElements) : $("#" + proxy._id);
        proxy._proElements = $(proxy._subElements[0]);
        if (proxy._proElements.length > 0 || proxy._subElements.length > 0) {
            var element = $(proxy._subElements[0]);
            proxy._currentTargetElement = element;
            var targetHtml = $(element)[0].tagName === "TEXTAREA" || $(element)[0].tagName === "INPUT" ? $(element)[0].value : $(element)[0].innerHTML;
            var event = { previousElement: updateElement, currentElement: element, targetHtml: targetHtml, requestType: "updateText" };
            if (proxy._trigger("targetUpdating", event)) {
                proxy._close();
                return false;
            }
            proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML = targetHtml;
            proxy._subElements = proxy._subElements.slice(1);
            var contentElement = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent");
            var diffWords = proxy._filteringDiffWords(proxy, contentElement[0].innerText);
            proxy._suggestionsRequest(proxy, contentElement, diffWords.toString(), "validateByDialog");
        }
        else {
            var errorWordElement = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent").find(".errorspan");
            if (errorWordElement.length === 0 && proxy._subElements.length > 0) {
                proxy._updateTargetText(proxy);
            }
            else if (errorWordElement.length > 0) {
                var scrollObj = proxy._spellCheckWindow.find(".e-sentence .e-sentencescroller").data("ejScroller");
                scrollObj.refresh();
                proxy._listBoxDataUpdate(proxy);
            }
            else {
                proxy._completionCheck(proxy);
            }
        }
    };
    SpellCheck.prototype._updateTargetString = function (proxy) {
        var updateElement = !ej.isNullOrUndefined(proxy.model.controlsToValidate) ? $(proxy._proElements) : $("#" + proxy._id);
        if (updateElement.length > 0) {
            var updatedString = proxy._spellCheckWindow.find(".e-sentence .e-sentencecontent")[0].innerHTML;
            if (proxy._isIframe(updateElement)) {
                updateElement.contents().find("body").html(updatedString);
            }
            else {
                !ej.isNullOrUndefined($(updateElement)[0].value)
                    ? updateElement.val(updatedString)
                    : updateElement.html(updatedString);
            }
        }
    };
    SpellCheck.prototype._completionCheck = function (proxy) {
        proxy._subElements = proxy._subElements.slice(1);
        proxy._subElements.length === 0 && (proxy._targetStatus = false);
        proxy._validationComplete(proxy, "");
    };
    SpellCheck.prototype._changeAllErrors = function (proxy) {
        var spanElement = $(proxy._activeElement).find(".errorspan");
        for (var i = 0; i < spanElement.length; i++) {
            var spanText = spanElement[i].innerText || spanElement[i].textContent;
            for (var i_2 = 0; i_2 < proxy._changeAllWords.length; i_2++) {
                if (spanText === proxy._changeAllWords[i_2]["ErrorWord"]) {
                    $(spanElement[i_2]).replaceWith(proxy._changeAllWords[i_2]["ReplaceWord"]);
                }
            }
        }
    };
    SpellCheck.prototype._setModel = function (options) {
        var _this = this;
        for (var prop in options) {
            if (options.hasOwnProperty(prop)) {
                switch (prop) {
                    case "locale":
                        this.model.locale = options[prop];
                        this._localizedLabels = ej.getLocalizedConstants("ej.SpellCheck", this.model.locale);
                        break;
                    case "misspellWordCss":
                        this.model.misspellWordCss = options[prop];
                        if (this.model.contextMenuSettings.enable) {
                            var oldMisspellWordCssClass = $(this.element[0]).find("span.errorspan").attr("class").toString().split(" ")[1];
                            $(this.element[0]).find("span.errorspan").removeClass(oldMisspellWordCssClass).addClass(this.model.misspellWordCss);
                        }
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model.contextMenuSettings, options[prop]);
                        if (this.model.contextMenuSettings.enable) {
                            this.validate();
                            this._renderControls();
                        }
                        else {
                            !ej.isNullOrUndefined(this._contextMenu) && this._contextMenu.parent().remove();
                            this._removeSpan(this);
                        }
                        break;
                    case "ignoreSettings":
                        $.extend(this.model.ignoreSettings, options[prop]);
                        this._ignoreStatus = false;
                        this._statusFlag = true;
                        if (this.model.contextMenuSettings.enable) {
                            this.validate();
                            this._renderControls();
                        }
                        break;
                    case "dictionarySettings":
                        $.extend(this.model.dictionarySettings, options[prop]);
                        break;
                    case "maxSuggestionCount":
                        this.model.maxSuggestionCount = options[prop];
                        break;
                    case "ignoreWords":
                        this.model.ignoreWords = options[prop];
                        if (this.model.contextMenuSettings.enable) {
                            this.validate();
                        }
                        break;
                    case "controlsToValidate":
                        this.model.controlsToValidate = options[prop];
                        if (ej.isNullOrUndefined(this.model.controlsToValidate)) {
                            $(this.element).attr("style", "display:block");
                            for (var i = 0; i < this._controlIds.length; i++) {
                                var element = $(this._controlIds[i]);
                                element.removeClass("e-spellcheck");
                                element[0].spellcheck = true;
                                element[0].addEventListener("input", function () { _this._statusFlag = false; }, false);
                            }
                        }
                        this._renderControls();
                        break;
                    case "isResponsive":
                        this.model.isResponsive = options[prop];
                        this._renderControls();
                        break;
                    case "enableValidateOnType":
                        this.model.enableValidateOnType = options[prop];
                        this._renderControls();
                        break;
                }
            }
        }
    };
    SpellCheck.prototype._getModelValues = function (proxy, targetText, events) {
        var spellModel = {
            ignoreAlphaNumericWords: proxy.model.ignoreSettings.ignoreAlphaNumericWords,
            ignoreEmailAddress: proxy.model.ignoreSettings.ignoreEmailAddress,
            ignoreHtmlTags: proxy.model.ignoreSettings.ignoreHtmlTags,
            ignoreMixedCaseWords: proxy.model.ignoreSettings.ignoreMixedCaseWords,
            ignoreUpperCase: proxy.model.ignoreSettings.ignoreUpperCase,
            ignoreUrl: proxy.model.ignoreSettings.ignoreUrl,
            ignoreFileNames: proxy.model.ignoreSettings.ignoreFileNames
        };
        var value = JSON.stringify({ requestType: "checkWords", model: spellModel, text: targetText, additionalParams: !ej.isNullOrUndefined(events) ? events.additionalParams : null });
        return value;
    };
    SpellCheck.prototype._getLocalizedLabels = function () {
        return ej.getLocalizedConstants(this["sfType"], this.model.locale);
    };
    SpellCheck.prototype._elementRightClick = function (e) {
        if (!ej.isNullOrUndefined(this._contextMenu)) {
            if (!$(e.target).hasClass("e-menulink")) {
                var menuObj = this._contextMenu.data("ejMenu");
                if (!ej.isNullOrUndefined(menuObj))
                    $(menuObj.element).is(":visible") && menuObj.hide();
            }
        }
    };
    return SpellCheck;
}(ej.WidgetBase));
ej.widget("ejSpellCheck", "ej.SpellCheck", new SpellCheck());
ej.SpellCheck.Locale = ej.SpellCheck.Locale || {};
ej.SpellCheck.Locale["default"] = ej.SpellCheck.Locale["en-US"] = {
    SpellCheckButtonText: "Spelling:",
    NotInDictionary: "Not in Dictionary:",
    SuggestionLabel: "Suggestions:",
    IgnoreOnceButtonText: "Ignore Once",
    IgnoreAllButtonText: "Ignore All",
    AddToDictionary: "Add to Dictionary",
    ChangeButtonText: "Change",
    ChangeAllButtonText: "Change All",
    CloseButtonText: "Close",
    CompletionPopupMessage: "Spell check is complete",
    CompletionPopupTitle: "Spell check",
    Ok: "OK",
    NoSuggestionMessage: "No suggestions available",
    NotValidElement: "Specify the valid control id or class name to spell check"
};
;

ej.Ej3DRender = function () {

   
};

(function ($) {
    
    ej.Ej3DRender.Polygons = [];

    
    ej.Ej3DRender.prototype = {
        matrix3D: function () {
            
        },

        vector3D: function () {
             
        },
       
        BSPTreeBuilder: function () {

        },

        Graphics3D: function () {

        },

        polygon3D: function () {

        }
    }

    var Ej3DRender = new ej.Ej3DRender();
    
    Ej3DRender.vector3D.prototype = {
        //Members
        x: "",
        y: "",
        z: "",
        Epsilon:0.00001,
        //all coordinates indicate 0
        //  empty: new Vector3D(0, 0, 0),

        //isValid: !isNaN(this.x) && !isNaN(this.y) && !isNaN(this.z),
        isValid: function (point) {
            return !isNaN(point.x) && !isNaN(point.y) && !isNaN(point.z)
        },
        //Constructor
        vector3D: function (points, vz) {
            this.x = points.x;
            this.y = points.y;
            this.z = vz;
        },

        vector3D: function (vx, vy, vz) {
            this.x = vx;
            this.y = vy;
            this.z = vz;
            return {x:vx, y:vy, z:vz}
        },

        //operations
        vector3DMinus: function (v1, v2) {
            return this.vector3D(v1.x - v2.x, v1.y - v2.y, v1.z - v2.z);
        },

        vector3DPlus: function (v1, v2) {
            return this.vector3D(v1.x + v2.x, v1.y + v2.y, v1.z + v2.z);
        },

        vector3DMultiply: function (v1, v2) {
            var _x = v1.y * v2.z - v2.y * v1.z;
            var _y = v1.z * v2.x - v2.z * v1.x;
            var _z = v1.x * v2.y - v2.x * v1.y;

            return this.vector3D(_x, _y, _z);
        },

        vector3dAND: function (v1, v2) {
            return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z);
        },

        vector3DStarMultiply: function (v1, val) {
            var _x = v1.x * val;
            var _y = v1.y * val;
            var _z = v1.z * val;

            return this.vector3D(_x, _y, _z);
        },

        //Methods
        getLength: function (vector) {
            var sqt = this.vector3dAND(vector, vector);
            return Math.sqrt(sqt);
        },

       

        normalize: function () {
            var l = this.getLength();
            x /= l;
            y /= l;
            z /= l;
        },
        getNormal:function(v1, v2, v3)
        {
            var v4 = this.vector3DMinus(v1, v2);
            var v5 = this.vector3DMinus(v3, v2);
            var n = this.vector3DMultiply(v4, v5);
            var l = this.getLength(n);

           if (l < this.Epsilon)
           {
              l = 0;
            }
           return { x: n.x/ l, y: n.y / l, z: n.z / l }
        }
    }

   Ej3DRender.matrix3D.prototype = {
       //Memebr
        MATRIX_SIZE: 4,
       //Constructor
        matrix3D: function (size) {
            var mData = [];
           for (var i = 0; i < size; i++) {
               mData[i] = this.createArray(size);
           }
           return mData;
        },

       //method
        isAffine: function (mData) {

            return (mData[0][3] == 0) && (mData[1][3] == 0)
                    && (mData[2][3] == 0) && (mData[3][3] == 1);
        },
       createArray: function (initialSize) {
           var a = [];
           for (index = 0; index < initialSize; ++index) {
               a[index] = 0;
           }
           return a;
       },

       getIdentity: function () {

           var mData=this.matrix3D(this.MATRIX_SIZE);

           for (var i = 0; i < this.MATRIX_SIZE; i++) {
               mData[i][i] = 1.0;
           }
          
           return mData;
       },

      getInvertal:function(matrix)
      {
         var m = this.getIdentity();

         for (var i = 0; i < this.MATRIX_SIZE; i++)
         {
           for (var j = 0; j < this.MATRIX_SIZE; j++)
           {
               m[i][j] = this.getMinor(matrix, i, j);
            }
         }

         m = this.transposed(m);
         m = this.getMatrixMultiple((1 / this.getDeterminant(matrix)) , m);

      return m;
      },
      getMatrixMultiple: function (factor, matrix) {
          for (var i = 0; i < matrix.length; i++) {
              for (var j = 0; j < matrix[i].length; j++) {
                  matrix[i][j] = matrix[i][j] * factor;
              }
          }
          return matrix;
      },
      getMatrixVectorMutiple:function(m1, point)
      {
            var x = m1[0][0] * point.x + m1[1][0] * point.y + m1[2][0] * point.z + m1[3][0];
            var y = m1[0][1] * point.x + m1[1][1] * point.y + m1[2][1] * point.z + m1[3][1];
            var z = m1[0][2] * point.x + m1[1][2] * point.y + m1[2][2] * point.z + m1[3][2];

      if (!this.isAffine(m1))
      {
         var c = 1 / (m1[0][3] * point.x + m1[1][3] * point.y + m1[2][3] * point.z + m1[3][3]);
         x *= c;
         y *= c;
         z *= c;
      }

       return {x:x, y:y, z:z};
      },
      getMatrixVectorAnd:function(m1, v1)
      {
            var x = m1[0][0] * v1.x + m1[1][0] * v1.y + m1[2][0] * v1.z;
            var y = m1[0][1] * v1.x + m1[1][1] * v1.y + m1[2][1] * v1.z;
            var z = m1[0][2] * v1.x + m1[1][2] * v1.y + m1[2][2] * v1.z;

            return Ej3DRender.vector3D.prototype.vector3D(x, y, z);
         },
      getMatrixAdd:function(m1, m2) 
      {
          var m = this.matrix3D(4);

       for (var i = 0; i < 4; i++)
        {
          for (var j = 0; j < 4; j++)
          {
             m[i][j] = m1[i][j] + m2[i][j];
          }
        }

       return m;
     },
      getMatrixMultiplication:function(m1, m2)
      {
          var res = this.getIdentity();

         for (var i = 0; i < this.MATRIX_SIZE; i++)
         {
             for (var j = 0; j < this.MATRIX_SIZE; j++)
             {
             var v = 0;

             for (var k = 0; k < this.MATRIX_SIZE; k++)
             {
                 v += m1[k][j] * m2[i][k];
                 var t = v;
             }

             res[i][j] = v;
          }
       }

       return res;
      },
      getMatrixEqual:function(m1,m2)
       {
            var res = true;

           for (var i = 0; i < m1.length; i++)
          {
              for (var j = 0; j < m1.length; j++)
              {
                 if (m1[i][j] != m2[i][j])
                 {
                     res = false;
                 }
             }
         }

      return res;
      },
      getMatrixNotEqual:function(m1, m2)
      {
            var res = true; 

         for (var i = 0; i < m1.length; i++)
        {
             for (var j = 0; j < m1.length; j++)
          {
             if (m1[i][j] != m2[i][j])
             {
                res = false;
             }
          }
       }

        return !res;
    },


      getMinor:function(dd, columnIndex, rowIndex)
      {
          return (((columnIndex + rowIndex) % 2 == 0) ? 1 : -1) * this.getDeterminant(this.getMMtr(dd, columnIndex, rowIndex));

      },

     getMMtr:function(dd, columnIndex, rowIndex)
     {
        var count = dd.length - 1;
        var d = this.createArray(count);

        for (var i = 0; i < count; i++)
        {
            var m = (i >= columnIndex) ? i + 1 : i;
            d[i] = this.createArray(count);

            for (var j = 0; j < count; j++)
            {
                var n = (j >= rowIndex) ? j + 1 : j;

                d[i][j] = dd[m][n];
            }
        }
         return d;
     },
    getDeterminant:function(dd)
    {
        var count = dd.length;
        var res = 0;

        if (count < 2)
        {
            res = dd[0][0];
        }
        else
        {
            var k = 1;

            for (var i = 0; i < count; i++)
            {
                var dm = this.getMMtr(dd, i, 0);

                res += k * dd[i][0] * this.getDeterminant(dm);
                k = (k > 0) ? -1 : 1;
            }
        }

        return res;
    },


       transform: function (x, y, z) {
           var res = this.getIdentity();

           res[3][0] = x;
           res[3][1] = y;
           res[3][2] = z;

           return res;
       },


       turn: function (angle) {
           var res = this.getIdentity();

           res[0][0] = Math.cos(angle);
           res[2][0] = -Math.sin(angle);
           res[0][2] = Math.sin(angle);
           res[2][2] = Math.cos(angle);

           return res;
       },

       tilt: function (angle) {
           var res = this.getIdentity();
          
           res[1][1] = Math.cos(angle);
           res[2][1] = Math.sin(angle);
           res[1][2] = -(Math.sin(angle));
           res[2][2] = Math.cos(angle);
          
           return res;          
       },
       transposed:function(matrix3D)
       {
           var m = this.getIdentity();

           for (var i = 0; i < this.MATRIX_SIZE; i++)
            {
                for (var j = 0; j < this.MATRIX_SIZE; j++)
                {
                    m[i][j] = matrix3D[j][i];
                }
           }
          return m;
       },
      shear:function(xy, xz, yx, yz, zx, zy)
        {
          var res = this.getIdentity();

           res[1, 0] = xy;
           res[2, 0] = xz;
           res[0, 1] = yx;
           res[2, 1] = yz;
           res[0, 2] = zx;
           res[1, 2] = zy;

           return res;
        }


   }
   Ej3DRender.Graphics3D.prototype = {
      addVisual:function(polygon)
         {
          if ((polygon == null) || (polygonobj.test(polygon)))
            {
                return -1;
            }
         polygon.Graphics3D = this;
         return bsptreeobj.add(polygon);
      },

       getVisualCount:function()
           {
           return ej.Ej3DRender.Polygons.length();
       },
       remove:function(polygon)
        {
           ej.Ej3DRender.Polygons.Remove(polygon);
       },
 
     clearVisual:function()
       {
         ej.Ej3DRender.Polygons=null;
       },

      getVisual:function()
          {
                return ej.Ej3DRender.Polygons;
         },
      prepareView:function(perspectiveAngle, depth, rotation, tilt, size, sender)
      {
          if (arguments.length==0) {
              bsptreeobj.build();
          }
          else {
              if (ej.Ej3DRender.transform == null)
                  ej.Ej3DRender.transform = ej.EjSvgRender.chartTransform3D.transform3D(size);
              else
                  ej.Ej3DRender.transform.mViewport = size;
              if(!ej.Ej3DRender.tree)
                   ej.Ej3DRender.tree=[];
              ej.Ej3DRender.transform.Rotation = rotation;
              ej.Ej3DRender.transform.Tilt = tilt;
              ej.Ej3DRender.transform.Depth = depth;
              ej.Ej3DRender.transform.PerspectiveAngle = perspectiveAngle;
              ej.EjSvgRender.chartTransform3D.transform(ej.Ej3DRender.transform);
              ej.Ej3DRender.tree[sender._id] = bsptreeobj.build();
             
          } 
      },
      view: function (panel, sender, rotation, tilt, size, perspectiveAngle, depth)
      {
          var MaxValue = 32767;
          if (arguments.length == 2) {
              if (panel == null) return;
              var eye = vector.vector3D(0, 0, MaxValue);
              this.drawBspNode3D(ej.Ej3DRender.tree[sender._id], eye, panel, sender);
          }
          else {
              if (panel == null) return;
            
              if (ej.Ej3DRender.transform == null)
                  ej.Ej3DRender.transform = ej.EjSvgRender.chartTransform3D.transform3D(size);
              else
                  ej.Ej3DRender.transform.mViewport = size;
              ej.Ej3DRender.transform.Rotation = rotation;
              ej.Ej3DRender.transform.Tilt = tilt;
              ej.Ej3DRender.transform.Depth = depth;
              ej.Ej3DRender.transform.PerspectiveAngle = perspectiveAngle;
              ej.EjSvgRender.chartTransform3D.transform(ej.Ej3DRender.transform);
              var eye = vector.vector3D(0, 0, MaxValue);
              this.drawBspNode3D(ej.Ej3DRender.tree[sender._id], eye, panel, sender);
          }
      },

      draw3DElement: function (tr, sender) {
          if (tr.Plane.element){
              if (tr.Plane.element.tag == "text" || tr.Plane.element.tag == "dataLabel")
                  polygonobj.drawText(tr.Plane, sender);
              else if (tr.Plane.element.tag == "polyline")
                  polygonobj.drawPolyLine(tr.Plane, sender);
              else if(tr.Plane.element.tag == "template")
                  polygonobj.drawTemplate(tr.Plane, sender);
              else
                  polygonobj.drawLine(tr.Plane, sender);
            }
              
          else
            polygonobj.draw(tr.Plane, sender);          
      },

    drawBspNode3D:function(tr, eye, panel, sender)
    {
        if (tr == null || ej.Ej3DRender.transform == null) return;
     while (true)
     {
         var r = vector.vector3dAND(polygonobj.getNormal(ej.EjSvgRender.chartTransform3D.result(ej.Ej3DRender.transform), tr.Plane.VectorPoints), eye);
        if (r > tr.Plane.D)
        {
            if (tr.Front != null)
            {
                this.drawBspNode3D(tr.Front, eye, panel, sender);
            }

            this.draw3DElement(tr, sender);

            if (tr.Back != null)
            {
                tr = tr.Back;
                continue;
            }
        }
        else
        {
            if (tr.Back != null)
            {
                this.drawBspNode3D(tr.Back, eye, panel, sender);
            }

            this.draw3DElement(tr, sender);

            if (tr.Front != null)
            {
                tr = tr.Front;
                continue;
            }
        }
        break;
    }

    }

 }


   Ej3DRender.BSPTreeBuilder.prototype = {
       //Members
       EPSILON: 0.0005,
       Polygon:[],
       
       //Methods
       add:function(poly)
       {
           ej.Ej3DRender.Polygons.push(poly);
           return ej.Ej3DRender.Polygons.length - 1;
       },

       remove:function(index)
       {
           ej.Ej3DRender.Polygons.splice(index,1);
       },

       clear:function()
       {
           ej.Ej3DRender.Polygons=[];
       },

       count:function()
       {
           return ej.Ej3DRender.Polygons.length;
       },

       getNext:function(i, count)
        {
            if (i >= count)
            {
             return i - count;
            }
            if (i < 0)
              {
                  return i + count;
              }

             return i;
       },
       getNodeCount:function(el)
        {
            return (el == null) ? 0 : 1 + this.getNodeCount(el.Back) + this.getNodeCount(el.Front);
        },
       vector3DIndexClassification:function(point, ind, res){
           return{
                 index:ind,
                 result: res,
                 vector:point,

                isCuttingBackPoint:false,
                cuttingBackPairIndex:null,
                alreadyCuttedBack:false,

                isCuttingFrontPoint:false,
                cuttingFrontPairIndex:null,
                alreadyCuttedFront:false
         }
       },
       classifyPoint: function(pt, pln)
         {
            var res = "OnPlane";
            var sv = -pln.D - Ej3DRender.vector3D.prototype.vector3dAND(pt , pln.normal);

           if (sv > this.EPSILON)
            {
              res ="OnBack";
            }
          else if (sv < -this.EPSILON)
            {
              res = "OnFront";
            }

            return res;
        },
      
     classifyPolygon:function(pln, plg)
        {
            var res = "Unknown";
            var points = plg.Points;

           if (points == null)
               return res;
               var onBack = 0;
               var onFront = 0;
               var onPlane = 0;
               var normal = pln.normal;// root node normailized value perpendicular direction
               var d = pln.D; // constant of the plan or depth

          for (var i = 0, len = points.length; i < len; i++)
           {
              var r = -d - Ej3DRender.vector3D.prototype.vector3dAND(points[i], normal); // Comparision of Plane point depth with the other nodes
 
              if (r > this.EPSILON)
                {
                  onBack++;
                }
              else if (r < -this.EPSILON)
                {
                   onFront++;
                }
             else
               {
                  onPlane++;
               }

             if ((onBack > 0) && (onFront > 0))
               {
                 break;
               }
          }
         if (onPlane == points.length)
            {
               res = "OnPlane";
            }
          else if (onFront + onPlane == points.length)
           {
              res = "ToRight";
           }
          else if (onBack + onPlane == points.length)
           {
             res = "ToLeft";
           }
          else
          {
                res = "Unknown";
          }
      return res;
     },
   splitPolygon:function(poly, part)
     {
            var backP = [];
            var frontP = [];

    // this code looks for points which lie on the part plane and divide polygon into two parts
    if (poly.Points != null)
    {
        var polyPoints = [];
        var backPartPoints = [];
        var frontPartPoints = [];

        var outpts;
        var inpts;

        var count = poly.Points.length;
        for (var i = 0; i < count;i++)
        {
            var ptB = poly.Points[i];
            var ptC = poly.Points[this.getNext(i + 1, count)];
            var sideB = this.classifyPoint(ptB, part);
            var sideC = this.classifyPoint(ptC, part);

            var vwiwcB = this.vector3DIndexClassification(ptB, polyPoints.length, sideB);
            polyPoints.push(vwiwcB);

            if ((sideB != sideC) && (sideB != "OnPlane") &&
                (sideC !="OnPlane"))
            {
                var v = vector.vector3DMinus(ptB, ptC);
                var dir = vector.vector3DMinus(vector.vector3DStarMultiply(part.normal, (-part.D)), ptC);

                var sv = vector.vector3dAND(dir, part.normal);
                var sect = sv / vector.vector3dAND(part.normal, v);
                var ptP = vector.vector3DPlus(ptC, vector.vector3DStarMultiply(v, sect));
                var vwiwc = this.vector3DIndexClassification(ptP, polyPoints.length, "OnPlane");

                polyPoints.push(vwiwc);
                backPartPoints.push(vwiwc);
                frontPartPoints.push(vwiwc);
            }
            else
                if (sideB == "OnPlane")
                {
                    var ptA = poly.Points[this.getNext(i - 1, count)];
                    var sideA = this.classifyPoint(ptA, part);
                    if ((sideA == sideC)) continue;
                    if ((sideA != "OnPlane") && (sideC != "OnPlane"))
                    {
                        backPartPoints.push(vwiwcB);
                        frontPartPoints.push(vwiwcB);
                    }
                    else
                        if (sideA =="OnPlane")
                        {
                            switch (sideC)
                            {
                                case "OnBack":
                                    backPartPoints.push(vwiwcB);
                                    break;
                                case "OnFront":
                                    frontPartPoints.push(vwiwcB);
                                    break;
                            }
                        }
                        else
                            if (sideC =="OnPlane")
                            {
                                switch (sideA)
                                {
                                    case "OnBack":
                                        backPartPoints.push(vwiwcB);
                                        break;
                                    case "OnFront":
                                        frontPartPoints.push(vwiwcB);
                                        break;
                                }
                            }
                }
        }

        if ((frontPartPoints.length != 0) || (backPartPoints.length != 0))
        {
            for (var i = 0; i < backPartPoints.length - 1; i += 2)
            {
                var vwiwc1 = backPartPoints[i];
                var vwiwc2 = backPartPoints[i + 1];
                vwiwc1.CuttingBackPoint = true;
                vwiwc2.CuttingBackPoint = true;
                vwiwc1.CuttingBackPairIndex = vwiwc2.index;
                vwiwc2.CuttingBackPairIndex = vwiwc1.index;
            }
            for (var i = 0; i < frontPartPoints.length - 1; i += 2)
            {
                var vwiwc1 = frontPartPoints[i];
                var vwiwc2 = frontPartPoints[i + 1];
                vwiwc1.CuttingFrontPoint = true;
                vwiwc2.CuttingFrontPoint = true;
                vwiwc1.CuttingFrontPairIndex = vwiwc2.index;
                vwiwc2.CuttingFrontPairIndex = vwiwc1.index;
            }


            for (var i = 0; i < backPartPoints.length - 1; i++)
            {
                var vwiwc1 = backPartPoints[i];
                if (vwiwc1.alreadyCuttedBack) continue;
                var outpts=this.cutOutBackPolygon(polyPoints, vwiwc1);

                if (outpts.length > 2) {
                    var polygon1 = polygonobj.polygon3D(outpts, poly);
                    backP.push($.extend({}, polygon1));
                }
            }

            for (var i = 0; i < frontPartPoints.length - 1; i++)
            {
                var vwiwc2 = frontPartPoints[i];
                if (vwiwc2.alreadyCuttedFront) continue;
                inpts=this.cutOutFrontPolygon(polyPoints, vwiwc2);
                if (inpts.length > 2) {
                    var polygon2 = polygonobj.polygon3D(inpts, poly);
                    frontP.push($.extend({}, polygon2));
                }
            }
        } 
    }
     else
     {
        backP.push(poly);
        frontP.push(poly); 
     }

    return{BackP:backP, FrontP:frontP}
   },
  cutOutFrontPolygon:function(polyPoints, vwiwc)
   {
      points = [];

    var curVW = vwiwc;

    while (true)
    {
        curVW.alreadyCuttedFront = true;
        points.push(curVW.vector);

        var curVWPair = polyPoints[curVW.CuttingFrontPairIndex];

        if (curVW.CuttingFrontPoint)
        {
            if (!curVWPair.alreadyCuttedFront)
            {
                curVW = curVWPair;
            }
            else
            {
                var curVWPrev = polyPoints[this.getNext(curVW.index - 1, polyPoints.length)];
                var curVWNext = polyPoints[this.getNext(curVW.index + 1, polyPoints.length)];

                if ((curVWPrev.result =="OnFront") && !curVWPrev.alreadyCuttedFront)
                {
                    curVW = curVWPrev;
                }
                else
                    if ((curVWNext.result == "OnFront") && !curVWNext.alreadyCuttedFront)
                    {
                        curVW = curVWNext;
                    }
                    else
                    {
                        return points;
                    }
            }
        }
        else
        {
            var curPrev = polyPoints[this.getNext(curVW.index - 1, polyPoints.length)];
            var curNext = polyPoints[this.getNext(curVW.index + 1, polyPoints.length)];

            if ((curPrev.result != "OnBack") && !curPrev.alreadyCuttedFront)
            {
                curVW = curPrev;
            }
            else
                if ((curNext.result != "OnBack") && !curNext.alreadyCuttedFront)
                {
                    curVW = curNext;
                }
                else
                {
                    return points;
                }
        }
    }
    return points;
 },

   cutOutBackPolygon:function(polyPoints, vwiwc)
   {
       var points = [];
       var curVW = vwiwc;

    while (true)
    {
        curVW.alreadyCuttedBack = true;
        points.push(curVW.vector);

        var curVWPair = polyPoints[curVW.CuttingBackPairIndex];

        if (curVW.CuttingBackPoint)
        {
            if (!curVWPair.alreadyCuttedBack)
            {
                curVW = curVWPair;
            }
            else
            {
                var curVWPrev = polyPoints[this.getNext(curVW.index - 1, polyPoints.length)];
                var curVWNext = polyPoints[this.getNext(curVW.index + 1, polyPoints.length)];

                if ((curVWPrev.result == "OnBack") && !curVWPrev.alreadyCuttedBack)
                {
                    curVW = curVWPrev;
                }
                else
                    if ((curVWNext.result == "OnBack") && !curVWNext.alreadyCuttedBack)
                    {
                        curVW = curVWNext;
                    }
                    else
                    {
                        return points;
                    }
            }
        }
        else
        {
            var curVWPrev = polyPoints[this.getNext(curVW.index - 1, polyPoints.length)];
            var curVWNext = polyPoints[this.getNext(curVW.index + 1, polyPoints.length)];

            if ((curVWPrev.result != "OnFront") && !curVWPrev.alreadyCuttedBack)
            {
                curVW = curVWPrev;
            }
            else
                if ((curVWNext.result != "OnFront") && !curVWNext.alreadyCuttedBack)
                {
                    curVW = curVWNext;
                }
                else
                {
                    return points;
                }
        }
    }
     return points
  },
     build:function()
       {
           if(!arguments[0]){
             return (this.build(ej.Ej3DRender.Polygons));               
           }
           else{
               var arlist=arguments[0];
               if (arlist.length < 1) return null;
               var bspNode = {Back:null, Front:null, Plane:null}
               var plane = arlist[0];
               bspNode.Plane = plane;
               var arleft = [];
               var arright = [];

               for (var i = 1, len = arlist.length; i < len; i++)
               {
                   var pln = arlist[i];

                   if (pln == plane) continue;
                   var r = this.classifyPolygon(plane, pln);

                   switch (r)
                   {
                       case "OnPlane":
                       case "ToRight":
                           arright.push(pln);
                           break;

                       case "ToLeft":
                           arleft.push(pln);
                           break;

                       case "Unknown":
                           //if (pln is Line3D || pln is UIElement3D)
                           if(pln.element && (pln.element.tag == "line" || pln.element.tag == "text"))
                           {
                               arleft.push(pln);
                           }
                         else
                         {
                            
                               var result = this.splitPolygon(pln, plane);                              
                               for (var k = 0; k < result.BackP.length; k++) {
                                   result.BackP[k].Name = result.BackP[k].Name + "back";
                                   arleft.push(result.BackP[k]);
                               }
                               for (var j = 0; j < result.FrontP.length; j++) {
                                   result.FrontP[j].Name = result.FrontP[j].Name + "front";
                                   arright.push(result.FrontP[j]);
                               }
                        }
                   break;
               }
           }

           if (arleft.length > 0)
           {
               bspNode.Back = this.build(arleft);
           }

           if (arright.length > 0)
           {
               bspNode.Front = this.build(arright);
           }

           return bspNode;
         }
    }

   }

   Ej3DRender.polygon3D.prototype = {
       // Member    
       epsilon: 0.00001,
       normal: { x: 0, y: 0, z: 0 },
       a: (this.normal) ? this.normal.x : 0,
       b: (this.normal) ? this.normal.y : 0,
       c: (this.normal) ? this.normal.z : 0,
       vector: new (new ej.Ej3DRender()).vector3D(),

       // Constructor
       polygon3D: function (points, tag, index, stroke, strokeThickness, opacity, fill, name) {

           if (arguments.length == 3) {
               this.calcNormal(arguments[0], arguments[1], arguments[2])
           }
           else if (arguments.length == 2) {
               points = arguments[0];
               this.calcNormal(points[0], points[1], points[2]);
               this.vectorPoints = points;
               this.calcNormal(this.vectorPoints);
               var polygon = arguments[1];
               polygon.Normal = this.normal;
               polygon.normal = this.normal;
               polygon.Points = points;
               polygon.VectorPoints = this.vectorPoints;
               polygon.IsSplitted = true;
               polygon.d = this.d;
               polygon.D = this.d;
               return polygon;
                
           }
           else {
               this.calcNormal(points[0], points[1], points[2]);
               this.vectorPoints = points;
               this.calcNormal(this.vectorPoints);
               var element = { Tag: 'path', Parent: arguments[arguments.length - 1] }
               var polygon= {
                   Normal: this.normal,
                   normal: this.normal,
                   Points: points,
                   VectorPoints: this.vectorPoints,
                   Index: index,
                   Tag: tag,
                   Name: (name) ? name : null,
                   StrokeThickness: strokeThickness,
                   Opacity:opacity,
                   Fill: fill,
                   d: this.d,
                   D: this.d
               }
               if (arguments.length != 1) 
                   polygon.Element = element;

               return polygon;
               
           }
       },

       //Methods
       createLine: function (line, x1, y1, x2, y2, depth) {
           var strokeThickness = line.width;
           var vectorColl = [];
           vectorColl[0] = vector.vector3D(x1, y1, depth);
           vectorColl[1] = vector.vector3D(x1 + strokeThickness, y2 + strokeThickness, depth);
           vectorColl[2] = vector.vector3D(x2, y2, depth);
           return this.line3D(line, vectorColl);
       },
       createPolyline: function (points, element) {
           if (points.length == 2) {
               var prePoint = points[1];
               points.push(vector.vector3D(prePoint.x, prePoint.y, prePoint.z));
           }
            return this.polyLine3D(element, points);
       },
       polyLine3D: function (element, points) {
           var plane = this.polygon3D(points);
           plane.element = element;
           return plane;
       },

       line3D:function(element, points)
       {
           var plane = this.polygon3D(points);
           plane.element = element;
           return plane;
       },
      text3D:function(element,points)
      {
          var plane = this.polygon3D(points);
          plane.element = element;
          return plane;
      },
      createCylinder: function (v1, v2, tag, index, type, stroke, fill, strokeThickness, opacity, inverse, name, parent) {
          var i = 0, ox, oy, oz, pathCount = 24, theta = 360 / pathCount, DtoR = Math.PI / 180, CenterZ = (parseFloat)((v1.z + v2.z) / 2), res = [], oPts = [], tVtxs = [], bVtxs = [], radiusb = (v2.y - v1.y) < (v2.z - v1.z) ? (parseFloat)((v2.y - v1.y) / 2) : (parseFloat)((v2.z - v1.z) / 2), radiusc = (v2.x - v1.x) < (v2.z - v1.z) ? (parseFloat)((v2.x - v1.x) / 2) : (parseFloat)((v2.z - v1.z) / 2), CenterX = (parseFloat)((v1.x + v2.x) / 2), CenterY = (parseFloat)((v1.y + v2.y) / 2);
          switch (type) {
              case "bar":
              case "stackingbar":
              case "stackingbar100":                 
                  pathCount++;
                  while (pathCount--) {
                      oy = (parseFloat)(CenterY + radiusb * Math.cos((i * theta) * DtoR));
                      oz = (parseFloat)(CenterZ + radiusb * Math.sin((i * theta) * DtoR));
                      oPts[i] = { Y: oy, Z: oz };
                      tVtxs.push(vector.vector3D(v1.x, oPts[i].Y, oPts[i].Z));
                      bVtxs.push(vector.vector3D(v2.x, oPts[i].Y, oPts[i].Z));
                      if (i > 0) {
                          vts = new Array(vector.vector3D(v1.x, oPts[i - 1].Y, oPts[i - 1].Z),
                               vector.vector3D(v2.x, oPts[i - 1].Y, oPts[i - 1].Z),
                                vector.vector3D(v2.x, oPts[i].Y, oPts[i].Z),
                                vector.vector3D(v1.x, oPts[i].Y, oPts[i].Z))
                          res[i + 1] = this.polygon3D(vts, tag, index, fill, 0, opacity, fill, "_"+(i + 1).toString()+"_" + name, parent);
                          graphics.addVisual(res[i + 1]);
                      }
                      i++;
                  }
                  break;
              case "column":
              case "stackingcolumn":
              case "stackingcolumn100":
                  pathCount++;             
                  while (pathCount--) {
                      ox = (parseFloat)(CenterX + radiusc * Math.cos((i * theta) * DtoR));
                      oz = (parseFloat)(CenterZ + radiusc * Math.sin((i * theta) * DtoR));
                      oPts[i] = { X: ox, Z: oz };
                      tVtxs.push(vector.vector3D(oPts[i].X, v1.y, oPts[i].Z));
                      bVtxs.push(vector.vector3D(oPts[i].X, v2.y, oPts[i].Z));
                      if (i > 0) {
                          vts = new Array(vector.vector3D(oPts[i-1].X, v1.y, oPts[i-1].Z),
                                vector.vector3D(oPts[i-1].X, v2.y, oPts[i-1].Z),
                                 vector.vector3D(oPts[i].X, v2.y, oPts[i].Z),
                                 vector.vector3D(oPts[i].X, v1.y, oPts[i].Z))
                          res[i+1] = this.polygon3D(vts, tag, index, fill, 0, opacity, fill, "_"+(i+1).toString()+"_" + name, parent);
                          graphics.addVisual(res[i+1]);
                      }
                      i++;
                  }
                  break;
              default:
                  break;
          }
          res[0]=this.polygon3D(bVtxs, tag, index, stroke, 0, opacity, fill, "_0_" + name, parent);          
          res[1]=this.polygon3D(tVtxs, tag, index, stroke, strokeThickness, opacity, fill, "_1_" + name, parent);        
          graphics.addVisual(res[0]);
          graphics.addVisual(res[1]);        
          return res;
      },

       createBox: function (v1, v2, tag, index, graphics3D, stroke, fill, strokeThickness, opacity, inverse, name, parent) {
           var res = [];

           var p1 = new Array(vector.vector3D(v1.x, v1.y, v1.z),
                vector.vector3D(v2.x, v1.y, v1.z),
                vector.vector3D(v2.x, v2.y, v1.z),
                vector.vector3D(v1.x, v2.y, v1.z))

           var p2 = new Array(
               vector.vector3D(v1.x, v1.y, v2.z),
               vector.vector3D(v2.x, v1.y, v2.z),
               vector.vector3D(v2.x, v2.y, v2.z),
               vector.vector3D(v1.x, v2.y, v2.z)
            )

           var p3 = new Array(

               vector.vector3D(v1.x, v1.y, v2.z),
               vector.vector3D(v2.x, v1.y, v2.z),
               vector.vector3D(v2.x, v1.y, v1.z),
               vector.vector3D(v1.x, v1.y, v1.z)
          )

           var p4 = new Array(
               vector.vector3D(v1.x, v2.y, v2.z),
               vector.vector3D(v2.x, v2.y, v2.z),
               vector.vector3D(v2.x, v2.y, v1.z),
               vector.vector3D(v1.x, v2.y, v1.z)
           )

           var p5 = new Array(
               vector.vector3D(v1.x, v1.y, v1.z),
               vector.vector3D(v1.x, v1.y, v2.z),
               vector.vector3D(v1.x, v2.y, v2.z),
               vector.vector3D(v1.x, v2.y, v1.z)
           )

           var p6 = new Array(
               vector.vector3D(v2.x, v1.y, v1.z),
               vector.vector3D(v2.x, v1.y, v2.z),
               vector.vector3D(v2.x, v2.y, v2.z),
               vector.vector3D(v2.x, v2.y, v1.z)
           )
           if (arguments[10]) {

               res[0] = this.polygon3D(p1, tag, index, stroke, strokeThickness, opacity, fill, "_0_"+ name, parent);
               res[1] = this.polygon3D(p2, tag, index, stroke, strokeThickness, opacity, fill, "_1_" + name, parent);
               res[2] = this.polygon3D(p3, tag, index, stroke, strokeThickness, opacity, fill, "_2_" + name, parent);
               res[3] = this.polygon3D(p4, tag, index, stroke, strokeThickness, opacity, fill, "_3_" + name, parent);
               res[4] = this.polygon3D(p5, tag, index, stroke, strokeThickness, opacity, fill, "_4_" + name, parent);
               res[5] = this.polygon3D(p6, tag, index, stroke, strokeThickness, opacity, fill, "_5_" + name, parent);
           }
           else {
               var parent= arguments[arguments.length-1];
               res[0] = this.polygon3D(p1, tag, index, stroke, strokeThickness, opacity, fill, "_0_" + index, parent);
               res[1] = this.polygon3D(p2, tag, index, stroke, strokeThickness, opacity, fill, "_1_" + index, parent);
               res[2] = this.polygon3D(p3, tag, index, stroke, strokeThickness, opacity, fill, "_2_" + index, parent);
               res[3] = this.polygon3D(p4, tag, index, stroke, strokeThickness, opacity, fill, "_3_" + index, parent);
               res[4] = this.polygon3D(p5, tag, index, stroke, strokeThickness, opacity, fill, "_4_" + index, parent);
               res[5] = this.polygon3D(p6, tag, index, stroke, strokeThickness, opacity, fill, "_5_" + index, parent);
           }

           if (inverse) {
               graphics.addVisual(res[0]);
               graphics.addVisual(res[1]);
               graphics.addVisual(res[2]);
               graphics.addVisual(res[3]);
               graphics.addVisual(res[4]);
               graphics.addVisual(res[5]);
           }
           else {
               graphics.addVisual(res[5]);
               graphics.addVisual(res[4]);
               graphics.addVisual(res[0]);
               graphics.addVisual(res[1]);
               graphics.addVisual(res[2]);
               graphics.addVisual(res[3]);
              
           }
           return res;
       },


       calcNormal: function () {
           if (arguments.length >= 3) {
               // Relative information of the points
               var v1 = arguments[0];
               var v2 = arguments[1];
               var v3 = arguments[2];
               var v4 = vector.vector3DMinus(v1, v2);
               var v5 = vector.vector3DMinus(v3, v2);
               var n = vector.vector3DMultiply(v4, v5);

               var l = vector.getLength(n);//Get length of the vector

               if (l < this.epsilon) {
                   l = 1;
               }

               this.normal= vector.vector3D(n.x / l, n.y / l, n.z / l); //Calculate normalization of the vector
               this.d = -(this.normal.x * v1.x + this.normal.y * v1.y + this.normal.z * v1.z);// Normalized values * 1st coordinates Coordinates - Depth of the plan

               if (arguments[3]) {
                   arguments[3].normal = this.normal;
                   arguments.d = this.d;
               }
           }
           else {
               var Points = arguments[0];
               this.calcNormal(Points[0], Points[1], Points[2], arguments[1]);

               for (var i = 3; (i < Points.length) && (this.test()) ; i++) {
                   this.calcNormal(Points[i], Points[0], Points[i / 2]);
               }
           }
       },

       test: function () {
           return !vector.isValid(this.normal);
       },

       transform: function (matrix, plan) {
           if (plan.Points != null) {
               for (var i = 0; i < plan.Points.length; i++) {

                   plan.VectorPoints[i] = plan.Points[i] = matrixobj.getMatrixVectorMutiple(matrix, plan.Points[i]);
               }

               this.calcNormal(plan.VectorPoints, plan);
           }
           else {
               var v = matrix * (plan.normal * -plan.d);
               plan.normal = matrixobj.getMatrixVectorAnd(matrix, plan.normal);
               vector.normalize(normal);
               plan.d = -(plan.normal & v);
           }
       },

       getPoint: function (x, y, normal, d) {
           if (typeof x == double) {
               var z = -(normal.x * x + normal.y * y + d) / normal.z;

               return vector.vector3D(x, y, z);
           }
           else {
               var position = x;
               var ray = y;
               var dir = vector.vector3DMinus(vector.vector3DStarMultiply(normal, (-d)), position);

               var sv = vector.vector3dAND(dir, normal);
               var sect = sv / vector.vector3dAND(normal, ray);

               return vector.vector3DPlus(position, (vector.vector3DStarMultiply(ray * sect)));
           }
       },

       getNormal: function (transform, VectorPoints) {
           var norm;

           if (VectorPoints != null) {
               norm = vector.getNormal(matrixobj.getMatrixVectorMutiple(transform, VectorPoints[0]),
                  matrixobj.getMatrixVectorMutiple(transform, VectorPoints[1]), matrixobj.getMatrixVectorMutiple(transform, VectorPoints[2]))


               for (var i = 3; (i < VectorPoints.length) && !vector.isValid(norm) && VectorPoints[i / 2]; i++) {
                   var v1 = matrixobj.getMatrixVectorMutiple(transform, VectorPoints[i]);
                   var v2 = matrixobj.getMatrixVectorMutiple(transform, VectorPoints[0]);
                   var v3 = matrixobj.getMatrixVectorMutiple(transform, VectorPoints[i / 2]);

                   norm = vector.getNormal(v1, v2, v3);
               }
           }
           else {
               norm = matrixobj.getMatrixVectorAnd(transform, normal);
               vector.normalize();
           }

           return norm;

       },

     createTextElement:function(position,  element, xLen, yLen)
      {
        
       var vectorColl = [];
       var x = position.x;
       var y = position.y;
 
       var desiredWidth = element.Width;
       var desiredHeight = element.Height;

          vectorColl[0] = this.vector.vector3D(x, y, position.z);
          vectorColl[1] = this.vector.vector3D(x + desiredWidth, y + desiredHeight + yLen, position.z);
          vectorColl[2] = this.vector.vector3D(x + desiredWidth + xLen, y + desiredHeight + yLen, position.z);
         return this.text3D(element, vectorColl);
     },

     redraw: function () { },

     drawPolyLine: function (panel, sender) {
         var transform = ej.Ej3DRender.transform;
         var pathDirection = ej.EjSvgRender.utils._getStringBuilder();
         var StartPoint = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[0], transform);
         pathDirection.append("M" + " " + (StartPoint.x) + " " + (StartPoint.y) + " ");
         for(var i=0; i< panel.VectorPoints.length; i++)
         {
            lineSegment = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[i], transform);
            pathDirection.append("L" + " " + (lineSegment.x) + " " + (lineSegment.y) + " ");
                     
         }        
          
         direction = pathDirection.toString();

        
         var optionsLine = {
             'id': panel.element.id,
             'stroke-dasharray': panel.element.dashArray,
             'stroke-width': panel.element.width,
             'stroke': panel.element.stroke,
             'd': direction
         };

         sender.svgRenderer.drawPath(optionsLine, panel.element.child);
     },

       drawLine: function (panel, sender) {
           
           var transform = ej.Ej3DRender.transform;
           if (transform == null) return;
           var actual3DPosition1 = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[0], transform);
           var actual3DPosition2 = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[2], transform);

           var optionsLine = {
               'id': panel.element.id,
               x1: actual3DPosition1.x ,
               y1: actual3DPosition1.y,
               x2: actual3DPosition2.x,
               y2:actual3DPosition2.y,
               'stroke-dasharray': panel.element.dashArray,
               'stroke-width': panel.element.width,
               'stroke': panel.element.stroke,
               'opacity': panel.element.opacity
           };

           sender.svgRenderer.drawLine(optionsLine, panel.element.child);
 

       },
       drawTemplate: function (panel, sender) {
           var element = panel.element;
           var transform = ej.Ej3DRender.transform;
           if (transform == null) return;
           var actual3DPosition = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[0], transform);
           ej.EjSeriesRender.prototype.drawLabelTemplate(element.Label.series, element.Label.series.points[element.Label.pointIndex], element.Label.pointIndex, { X: actual3DPosition.x, Y: actual3DPosition.y }, sender)
       },
       drawText: function (panel, sender) {
           
           var element = panel.element;
           var transform =ej.Ej3DRender.transform;
           if (transform == null) return;
           var actual3DPosition = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[0], transform);
           var x = actual3DPosition.x;
           var y = actual3DPosition.y;
 
           if (element.tag == "text") {
               var options = {
                   'id': element.id,
                   'x': x,
                   'y': y,
                   'fill': element.font.color,
                   'font-size': element.font.size,
                   'font-family': element.font.fontFamily,
                   'font-style': element.font.fontStyle,
                   'font-weight': element.font.fontWeight,
                   'opacity': element.font.opacity,
                   'text-anchor': element.TextAnchor,            
                   "cursor":"default",
                   'transform': element.Angle ? 'rotate(' + element.Angle + ',' + (x) + ',' + y + ')' : null
               };           
              
               sender.svgRenderer.drawText(options, panel.element.Label.Text, panel.element.child, panel.element.Label);			 
           }
           else {
               var series = element.series;           
 
               var labelFormat = (series.yAxis && series.yAxis.labelFormat) ? series.yAxis.labelFormat : "";
               var pointText = (element.point.text) ? element.point.text : element.point.y + labelFormat.substring(labelFormat.indexOf('}') + 1);
               var textOffset = ej.EjSvgRender.utils._measureText(pointText, null, series.marker.dataLabel.font);
               var margin = series.marker.dataLabel.margin;
               var width = textOffset.width + margin.left + margin.right;
               var height = textOffset.height + margin.top + margin.bottom;
               var location = { X: actual3DPosition.x, Y: actual3DPosition.y };

                  
                      if (series.marker.dataLabel.shape)
                          var elementShape = series.marker.dataLabel.shape;
                      else if (series.marker.dataLabel.shape)
                          elementShape = marker.dataLabel.shape;
                      else
                          elementShape = "None";

                      $.each(sender.model.symbolShape, function (name) {
                          if (elementShape.toLowerCase() == name.toLowerCase())
                              symbolName = name;
                      });

                   var xXalue = location.X - (margin.left) / 2 + (margin.right) / 2;
                   var yValue = location.Y - (margin.top) / 2 - (height / margin.top) + (margin.bottom) / 2;

                   var seriesIndex = $.inArray(series, sender.model.series);
                   ej.EjSeriesRender.prototype.dataLabelSymbol(seriesIndex, series, element.pointIndex, xXalue, yValue, width, height, symbolName, sender);
            
           }

       },

       draw: function (panel,sender) {            
           if (panel.VectorPoints == null || panel.VectorPoints.length <= 0) return;
           var transform = ej.Ej3DRender.transform;
           var pathDirection = ej.EjSvgRender.utils._getStringBuilder();
           var color = panel.Fill;
		   var format = sender.svgRenderer.checkColorFormat(color);
		   if (!format)
		      color=sender.colorNameToHex(color);
           var figure={Segments:null, StartPoint:null};
           if (transform != null)
           {
               figure.StartPoint = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[0], transform);
               pathDirection.append("M" + " " + (figure.StartPoint.x) + " " + (figure.StartPoint.y) + " ");
               for(var i=0; i< panel.VectorPoints.length; i++)
                {
                       lineSegment = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[i], transform);
                       pathDirection.append("L" + " " + (lineSegment.x) + " " + (lineSegment.y) + " ");
                     
                }
           }
          
           direction = pathDirection.toString();
          
            var name = "Light";
            var lightCoefZ =(2 * (Math.abs(vector.vector3dAND(panel.normal, vector.vector3D(0, 0, 1))) - 1));
            var lightCoefY =(2 * (Math.abs(vector.vector3dAND(panel.normal, vector.vector3D(0, 1, 0))) - 1));
            var lightCoefX =(2 * (Math.abs(vector.vector3dAND(panel.normal, vector.vector3D(1, 0, 0))) - 1));
           if (lightCoefZ == lightCoefX)
           {               
              name = "ZLight";
              color = this.applyZLight(color, sender);  
           }
          else if (((lightCoefY == lightCoefZ) || (lightCoefZ != 0 && lightCoefY < lightCoefZ)))
          {
              name = "XLight";
              color= this.applyXLight(color, sender);
           }
          else if (lightCoefZ < 0)
          {
              name = "ZLight";
              color = this.applyZLight(color, sender);
          }
          else
          {
              name = "Light";
              color = color;
          }
          if (sender.model.AreaType == "none")
               panel.StrokeThickness = 0;
           var optionsMinorGrid = {
               'id': sender.svgObject.id +"_"+ panel.Name,
               'name':name, 
               'fill': color,
               'stroke': panel.Stroke,
               'stroke-width': panel.StrokeThickness,
               'opacity': panel.Opacity,
               'd': direction
           };
           sender.svgRenderer.drawPath(optionsMinorGrid, panel.Element.Parent);
           if (sender.model.previousID && sender.model.touchCross) 
               $("#" + optionsMinorGrid.id).insertAfter($("#" + sender.model.previousID));
              
           sender.model.previousID = optionsMinorGrid.id;
       },

       applyXLight: function (color, sender)
       { 
           var RGB = sender.svgRenderer.hexToRGB(color);
           RGB.R = (parseInt)(RGB.R * 0.7);
           RGB.G = (parseInt)(RGB.G * 0.7);
           RGB.B = (parseInt)(RGB.B * 0.7);
           return sender.svgRenderer.hexFromRGB(RGB);
       },

       applyZLight:function(color, sender)
         {
           var RGB = sender.svgRenderer.hexToRGB(color);
           RGB.R = (parseInt)(RGB.R * 0.9);
           RGB.G = (parseInt)(RGB.G * 0.9);
           RGB.B = (parseInt)(RGB.B * 0.9);
           return sender.svgRenderer.hexFromRGB(RGB);
        },

       update: function (updatedVectors, panel, sender) {
           if (panel.VectorPoints == null || panel.VectorPoints.length <= 0) return;
           panel.VectorPoints = updatedVectors;
           var transform = ej.Ej3DRender.transform;
           var pathDirection = ej.EjSvgRender.utils._getStringBuilder();
           var color = panel.Fill;
           var figure = { Segments: null, StartPoint: null };
           if (transform != null) {
               figure.StartPoint = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[0], transform);
               pathDirection.append("M" + " " + (figure.StartPoint.x) + " " + (figure.StartPoint.y) + " ");
               for (var i = 0; i < panel.VectorPoints.length; i++) {
                   lineSegment = ej.EjSvgRender.chartTransform3D.toScreen(panel.VectorPoints[i], transform);
                   pathDirection.append("L" + " " + (lineSegment.x) + " " + (lineSegment.y) + " ");

               }
           }

           direction = pathDirection.toString();    

           if ($(sender.chartObj.chart3D).find("#" + sender.chartObj.svgObject.id + "_" + panel.Name).length > 0) {
               var element = $(sender.chartObj.chart3D).find("#" + sender.chartObj.svgObject.id + "_" + panel.Name)[0];
               sender.chartObj.svgRenderer._setAttr($(element), { 'd': direction });
              
           }
         
       }


   }
   var Ej3DRender = new ej.Ej3DRender();
   var vector = new Ej3DRender.vector3D();
   var matrixobj = new Ej3DRender.matrix3D();
   var bsptreeobj = new Ej3DRender.BSPTreeBuilder();
   var polygonobj = new Ej3DRender.polygon3D();
   var graphics = new Ej3DRender.Graphics3D();

  
})(jQuery);;
ej.Ej3DAxisRenderer = function () {
};

ej.Ej3DSeriesRender = function () {
};


ej.Ej3DChart = function () {
};

ej.series3DTypes = {};

(function ($) {

    ej.Ej3DAxisRenderer.prototype = {

        _drawAxes: function (index, axis, params) {
            if (axis.majorGridLines.visible)
                this._drawGridLines3D(axis, params);
            if (axis.visible && axis.majorTickLines.visible)
                this._renderTicks3D(axis, axis.majorTickLines.size, axis.majorTickLines.width, params);

            if (axis.visible) {
                this._drawAxisLabel(axis, params);
				 this._drawMultiLevelLabel(index, axis, params);
                this._drawAxisTitle(axis);
            }
        },

        _drawAxisTitle: function (axis) {
           if(axis.title.visible)
           {
			   var font = axis.title.font;
			   this.gAxisTitleEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + "axisTitle_" + axis.name});
               var opposedPosition = axis._opposed;
			   var size = { Width: $(this.svgObject).width(), Height: $(this.svgObject).height()},
			    padding = 10,
				transform = ej.EjSvgRender.chartTransform3D.transform3D(size);
				transform.mViewport = size;
				transform.Rotation = 0;
				transform.Tilt = 0;
				transform.Depth = 100;
				transform.PerspectiveAngle = 90;
				ej.EjSvgRender.chartTransform3D.transform(transform);
				var result = ej.EjSvgRender.chartTransform3D.result,
				matrix3D = ej.Ej3DRender.prototype.matrix3D.prototype,
				orientation = axis.orientation.toLowerCase(),
				multiLevelLabelsVisible = false;
				
			for (var i=0; i< this.model._axes.length; i++){
				currentAxis = this.model._axes[i];
				if (currentAxis.orientation.toLowerCase() == orientation){
					for (var j=0; j< currentAxis.multiLevelLabels.length; j++){
						if (currentAxis.multiLevelLabels[j].visible){
							multiLevelLabelsVisible = true;
							break;
						}
					}
				}
			}
			
            if (orientation == "horizontal") {
                var xtitleLocation = (this.model.elementSpacing) + axis._LableMaxWidth.height;
                var titlesize = (ej.EjSvgRender.utils._measureText(axis.title.text, (axis.width), axis.title.font).height / 2);
                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = { Text: axis.title.text, location: { x: (axis.width) / 2, y: (xtitleLocation + titlesize + axis.majorTickLines.size + axis.axisLine.width + this.model.wallSize + axis._multiLevelLabelHeight ) }, axes: axis };
                this._trigger("axesTitleRendering", commonEventArgs);

				font = axis.title.font;
                var x1 = commonEventArgs.data.location.x + axis.x;
                var y1 = (opposedPosition) ? (axis.y - commonEventArgs.data.location.y) : (commonEventArgs.data.location.y + axis.y);

                element = { Width: titlesize.width, Height: titlesize.height, Label: commonEventArgs.data, TextAnchor: 'middle', tag: 'text', font: font, id: this.svgObject.id + "axisTitle", child: this.chart3D };
				if (!multiLevelLabelsVisible)
					this.graphics.addVisual(this.polygon.createTextElement(this.vector.vector3D(x1, y1, 0), element, 10, 10));
				else  {
				
						 var options = {
                'id': this.svgObject.id + "axisTitle",
                'x': x1,
                'y': y1,
                'fill': font.color,
                'font-size': font.size,
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'font-weight': font.fontWeight,
                'opacity': font.opacity,
                'text-anchor': "middle"
            };
					    var newOptions = ej.EjSvgRender.chartTransform3D.toScreen({x: x1, y: y1, z:0}, transform, result, matrix3D);
						options.x = newOptions.x; options.y = newOptions.y;
						this.svgRenderer.drawText(options, commonEventArgs.data.Text, this.gAxisTitleEle);
						this.svgRenderer.append(this.gAxisTitleEle, this.svgObject);
				}
            }
            else {
                var titleSize = ej.EjSvgRender.utils._measureText(axis.title.text, (axis.height), axis.title.font);
                var x1 = (opposedPosition) ? axis.x + ((4 * this.model.elementSpacing) + axis._LableMaxWidth.width + axis.majorTickLines.size + axis.axisLine.width + this.model.wallSize + axis._multiLevelLabelHeight) : axis.x - ((3 * this.model.elementSpacing) + axis._LableMaxWidth.width + axis.majorTickLines.size + axis.axisLine.width + this.model.wallSize + axis._multiLevelLabelHeight);

                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = { Text: axis.title.text, location: { x: titleSize.width / 2, y: 0 }, axes: axis };
                this._trigger("axesTitleRendering", commonEventArgs);

				font = axis.title.font;
                var y1 = commonEventArgs.data.location.y + (axis.y + axis.height) + (((axis.height) / 2) * -1);

                var labelRotation = (opposedPosition) ? 90 : -90;
                var value = opposedPosition ? 25 : -25;
                element = { Width: titleSize.width, Height: titleSize.height, Angle: -90 , Label: commonEventArgs.data, TextAnchor: 'middle', tag: 'text', font: font, id: this.svgObject.id + '_YAxisTitle', child: this.chart3D };
				if (!multiLevelLabelsVisible)
					this.graphics.addVisual(this.polygon.createTextElement(this.vector.vector3D(x1, y1, 0), element, 10, 10));
				else  {
				
						 var options = {
                'id': id,
                'x': x1,
                'y': y1,
                'fill': font.color,
                'font-size': font.size,
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'font-weight': font.fontWeight,
                'opacity': font.opacity,
                'text-anchor': "middle",
				'transform': 'rotate(' + -90 + ',' + (x1) + ',' + (opposedPosition ? y1 + padding : y1 - padding) + ')',
            };
					    var newOptions = ej.EjSvgRender.chartTransform3D.toScreen({x: x1, y: y1, z:0}, transform, result, matrix3D);
						options.x = newOptions.x + value; options.y = newOptions.y;
						this.svgRenderer.drawText(options, commonEventArgs.data.Text, this.gAxisTitleEle);
						this.svgRenderer.append(this.gAxisTitleEle, this.svgObject);
				}
            }
           }
        },

		_drawMultiLevelLabel: function (axisIndex, axis, params){    // to render multilevel labels
				// declaration
			this.gMultiLevelEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_axisMultiLevelLabels' + '_' + axisIndex});
			var i, j, x, y, rows, gap, labelSize, grpLabel, font, center, centerX, startX, startY, endX, textOptions, textOverflow, depth = 0,
				textCollection, borderOptions, border, style, alignment, multiLevelLabelsLength = axis.multiLevelLabels.length, model = this.model,
				elementSpacing = model.elementSpacing, padding = 10, x1 = 0, y1 = 0, element, anchor, topValue, bottomValue, leftValue,
				rightValue, lineTop, bottom, right, left, areaBounds = model.m_AreaBounds, textSize, visibleRange = axis.visibleRange, actual3DPosition1,
				wallSize = model.wallSize, opposedPosition = axis._opposed, validCross = params.axes[axis.name]._validCross, actual3DPosition2, 
				orientation = axis.orientation.toLowerCase(), y = validCross ? axis.y : areaBounds.Y + (!opposedPosition && areaBounds.Height), alignment,
				x = validCross ? axis.x : areaBounds.X + (opposedPosition && areaBounds.Width), options, newOptions, vectorColl = [], l, borderWidth;
				
				var size = { Width: $(this.svgObject).width(), Height: $(this.svgObject).height() };
				var transform = ej.EjSvgRender.chartTransform3D.transform3D(size);
				transform.mViewport = size;
				transform.Rotation = 0;
				transform.Tilt = 0;
				transform.Depth = 100;
				transform.PerspectiveAngle = model.perspectiveAngle;
				ej.EjSvgRender.chartTransform3D.transform(transform);
				var result = ej.EjSvgRender.chartTransform3D.result,
				matrix3D = ej.Ej3DRender.prototype.matrix3D.prototype;
			
			for (var i = 0; i < multiLevelLabelsLength; i++){
				grpLabel = axis.multiLevelLabels[i];
				id = this.svgObject.id + "_" + axis.name + "MultiLevelLabels_" + axisIndex + "_" + i;
				if (grpLabel.text != "" && grpLabel.visible){
				level = grpLabel._level;
				anchor = "middle";
				font = grpLabel.font;
				borderWidth = grpLabel.border.width;
				maximumTextWidth = grpLabel.maximumTextWidth;
				alignment = grpLabel.textAlignment.toLowerCase();
				actualText =  text = grpLabel.text;
				textOverflow = grpLabel.textOverflow.toLowerCase();
				textSize = ej.EjSvgRender.utils._measureText(grpLabel.text, areaBounds.Width, grpLabel.font);
				center = (grpLabel.end - grpLabel.start) / 2;
				centerX = (grpLabel.start + center - visibleRange.min) / (visibleRange.delta);
				startX = (grpLabel.start - visibleRange.min) / (visibleRange.delta);
				endX = (grpLabel.end - visibleRange.min) / (visibleRange.delta);
				if (axis.isInversed){
					centerX = isNaN(centerX) ? 0 : 1 - centerX;
					startX = isNaN(startX) ? 0 : 1 - startX;
					endX = isNaN(endX) ? 0 : 1 - endX;
				}
                if (orientation == "horizontal") {    // start, end and gap calculation
                    x1 = (Math.round(axis.width * centerX)) + areaBounds.X + ((axis.plotOffset));
					y1 = (opposedPosition) ? (y - wallSize - (axis.majorTickLines.size) - elementSpacing - padding/2 - axis._LableMaxWidth.height) : y + wallSize + (axis.majorTickLines.size) + elementSpacing + axis._LableMaxWidth.height;
					startX = (Math.round(axis.width * startX)) + areaBounds.X + ((axis.plotOffset));
					endX = (Math.round(axis.width * endX)) + areaBounds.X + ((axis.plotOffset));
					gap = maximumTextWidth ? maximumTextWidth : endX - startX - padding;
				} else {
                    y1 = Math.round(axis.plotOffset + axis.y + (axis.height * (1 - centerX)));
                    x1 = (opposedPosition) ? (axis.x + wallSize + axis.majorTickLines.size + axis.axisLine.width + elementSpacing/2 + axis._LableMaxWidth.width + axis.multiLevelLabelHeight[level]/2) : (x - wallSize - axis.majorTickLines.size - elementSpacing / 2 - axis._LableMaxWidth.width - axis.multiLevelLabelHeight[level]/2);
                    startX = Math.round(axis.plotOffset + axis.y + (axis.height * (1 - startX)));
					endX = Math.round(axis.plotOffset + axis.y + (axis.height * (1 - endX)));
					gap = maximumTextWidth ? maximumTextWidth: axis.multiLevelLabelHeight[level] + padding;
                }
				y1 = opposedPosition ?  y1 - axis.prevHeight[level] : y1 + axis.prevHeight[level];
			     
				if (alignment == "far") {
					x1 = x1 + gap/2 - borderWidth / 2;
					anchor = "end";
				} else if (alignment == "near") {
					anchor = "start";
					x1 = x1 - (gap / 2) + (borderWidth / 2);
				}
				
				// to trigger event
				var data =  ej.EjAxisRenderer.prototype._triggerMultiLevelLabelsRendering(actualText, x1, y1, textOverflow, font, grpLabel.border, this);
				text = actualText = data.text;
				x1 = data.location.x;
				y1 = data.location.y;
				textOverflow = data.textOverflow.toLowerCase();
				font = data.font;
				font.color = font.color ? font.color: axis.multiLevelLabelsFontColor;
				border = data.border;
				style = data.border.type.toLowerCase();
				borderWidth = data.border.width;
			 
			 options = {
                'id': id,
                'x': x1,
                'y': y1,
                'fill': font.color,
                'font-size': font.size,
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'font-weight': font.fontWeight,
                'opacity': font.opacity,
                'text-anchor': anchor
            };
			
				// calculation for wrap and wrapbyword
				if (textOverflow != "none")
					text = ej.EjAxisRenderer.prototype.textOverflowMultiLevelLabels(axis, gap, text, textOverflow, font, textSize, {x: x1, y: y1}, null, this);
				if (textOverflow == "wrap" || textOverflow == "wrapandtrim"){
					newY = y1;
					for (j = 0; j < text.length ; j++) {
					textSize = ej.EjSvgRender.utils._measureText(text[j], null, font);
					if (j!=0) newY = opposedPosition ? newY - textSize.height: newY + textSize.height;
					element = { Width: textSize.width, Height: textSize.height, Label: {"Text" : text[j]}, TextAnchor: anchor, tag: 'text', font: font, id: id + "_" + j, child: this.chart3D };
					options.id = options.id + "_" + j;
					var newOptions = ej.EjSvgRender.chartTransform3D.toScreen({x: x1, y: newY + padding/2, z:0}, transform, result, matrix3D);
				    options.x = newOptions.x; options.y = newOptions.y;
					this.svgRenderer.drawText(options, text[j], this.gMultiLevelEle);
				  }
				}
				x1= orientation == "horizontal" ? x1 : (opposedPosition ? x1 + padding : x1 - padding);
				
				//rendering multi level labels text
				if (textOverflow != "wrap" && textOverflow != "wrapandtrim"){
					element = { Width: textSize.width, Height: textSize.height, Label: {"Text" : text}, TextAnchor: anchor, tag: 'text', font: font, id: id, child: this.chart3D };
					var newOptions = ej.EjSvgRender.chartTransform3D.toScreen({x: x1, y: y1+padding/2, z:0}, transform, result, matrix3D);
					options.x = newOptions.x; options.y = newOptions.y;
					this.svgRenderer.drawText(options, text, this.gMultiLevelEle);
				}
				// storing region for multi level labels click event
				if (orientation == "horizontal")
					var region = {bounds: {x: startX, y: y1 - padding, height: axis.multiLevelLabelHeight[level], width: gap }, axisIndex: axisIndex, multiLevelLabel: grpLabel};
				else 
					var region = {bounds: {x: x1- width/2 - padding/2, y: endX, height: startX - endX, width: width }, axisIndex: axisIndex, multiLevelLabel: grpLabel};
				this.model.multiLevelLabelRegions.push(region);
				
				// to render border
				if (style != "none" && borderWidth > 0){
					id = this.svgObject.id + "_" + axis.name + "MultiLevelLabelsBorder_" + axisIndex + "_" + i;
					var height = y1-padding + axis.multiLevelLabelHeight[level] + padding/2;
					var borderColor = grpLabel.border.color ? grpLabel.border.color : axis.multiLevelLabelsColor
					if (orientation == "horizontal"){
						topValue = {x1: startX, y1: y1 - padding, x2: endX, y2: y1 - padding };
						bottomValue = {x1: startX, y1: height, x2: endX, y2: height };
						leftValue = {x1: startX, y1: y1-padding, x2: startX, y2: height };
						rightValue = {x1: endX, y1: y1-padding, x2: endX, y2: height };
					} else {
						width = axis.multiLevelLabelHeight[level] ;
						topValue = {x1: x1- width/2 - padding/2, y1: endX, x2: x1+ width/2 + padding/2, y2: endX };
						bottomValue = {x1: x1- width/2 - padding/2, y1: startX, x2: x1+ width/2 + padding/2, y2: startX };
						leftValue = {x1: x1- width/2 - padding/2, y1: endX, x2: x1- width/2 - padding/2, y2: startX };
						rightValue = {x1: x1+ width/2 + padding/2, y1: endX, x2: x1+ width/2 + padding/2, y2: startX };
					}
						for (l= 0; l< 4; l++){
							switch (l){
								case 0:
									newId = id + "_top";
									value = topValue;
									break;
								case 1:
									newId = id + "_bottom";
									value = bottomValue;
									break;
								case 2:
									newId = id + "_left";
									value = leftValue;
									break;
								case 3:
									newId = id + "_right";
									value = rightValue;
									break;
							}
							vectorColl[0] = ej.Ej3DRender.prototype.vector3D.prototype.vector3D(value.x1, value.y1, depth);
							vectorColl[1] = ej.Ej3DRender.prototype.vector3D.prototype.vector3D(value.x2, value.y2, depth);
							actual3DPosition1 = ej.EjSvgRender.chartTransform3D.toScreen(vectorColl[0], transform, result, matrix3D);
							actual3DPosition2 = ej.EjSvgRender.chartTransform3D.toScreen(vectorColl[1], transform, result, matrix3D);
							options = {
								'id': newId,
								'x1': actual3DPosition1.x,
								'y1': actual3DPosition1.y,
								'x2': actual3DPosition2.x,
								'y2': actual3DPosition2.y,
								'stroke': borderColor,
								'stroke-width': borderWidth
							};
							this.svgRenderer.drawLine(options, this.gMultiLevelEle);
						}
					   this.svgRenderer.append(this.gMultiLevelEle, this.svgObject);
				}
			  }
			}
		},
		
        _drawAxisLabel: function (axis, params) {
            var labelsCount = axis.visibleLabels.length,
				areaBounds = this.model.m_AreaBounds,
                opposedPosition = axis._opposed,
				validCross = params.axes[axis.name]._validCross,
				y = validCross ? axis.y : areaBounds.Y + (!opposedPosition && areaBounds.Height),
				x = validCross ? axis.x : areaBounds.X + (opposedPosition && areaBounds.Width);
           
            for (var i = 0; i < labelsCount; i++) {
				if (!ej.util.isNullOrUndefined(axis.visibleLabels[i].Text)) {
                var x1 = 0, y1 = 0, x2 = 0, y2 = 0;
                var textAnchor;
                
                var textSize = ej.EjSvgRender.utils._measureText(axis.visibleLabels[i].Text, this.model.m_AreaBounds.Width, axis.font);
				var value = (axis.visibleLabels[i].Value - axis.visibleRange.min) / (axis.visibleRange.delta);
                value = (axis.isInversed) ? 1 - value : value;
                value = isNaN(value) ? 0 : value;

                if (axis.orientation.toLowerCase() == "horizontal") {
                    x2 = x1 = (Math.round(axis.width * value)) + this.model.m_AreaBounds.X + ((axis.plotOffset));
                    y1 = (opposedPosition) ? (y - this.model.wallSize - (axis.majorTickLines.size) - (this.model.elementSpacing/2)) : y + this.model.wallSize + (axis.majorTickLines.size) + this.model.elementSpacing;
                    textAnchor="middle"
                }
                else {
                    y1 = y2 = Math.round(axis.plotOffset + axis.y + (textSize.height / 4) + (axis.height * (1 - value)));
                    x1 = (opposedPosition) ? (axis.x + axis.majorTickLines.size + axis.axisLine.width + this.model.elementSpacing/2 ) : (x - this.model.wallSize - axis.majorTickLines.size - this.model.elementSpacing / 2);
                    textAnchor = (opposedPosition) ?"start" : "end"
                }
 
             
                element = { Width: textSize.width, Height: textSize.height, Label: axis.visibleLabels[i], TextAnchor: textAnchor, tag: 'text', font: axis.font, id: this.svgObject.id + axis.orientation + i, child: this.chart3D };

                this.graphics.addVisual(this.polygon.createTextElement(this.vector.vector3D(x1, y1, 0), element, 10, 10));
				}
            }

        },

        _renderTicks3D: function (axis, size, width, params) {
            var labelsCount = axis.visibleLabels.length,
             parent,
             gEle,
             m_AreaBounds = this.model.m_AreaBounds,
			 y = axis.y;

            for (var i = 0; i < labelsCount; i++)
            {
                var x1 = 0, x2 = 0, y1=0, y2=0;
            
       
                var value = (axis.visibleLabels[i].Value - axis.visibleRange.min) / (axis.visibleRange.delta);
                value = (axis.isInversed) ? 1 - value : value;
                value = isNaN(value) ? 0 : value;
            
                if (axis.orientation.toLowerCase() == "horizontal")
                {
                    x2 = x1 = (Math.round(axis.width * value)) + m_AreaBounds.X + ((axis.plotOffset));
                }
                else
                {
                    y1 = y2 = Math.round(axis.plotOffset + ((axis.height) * (1 - value))+axis.y);
                }

                var position = this._calculatePosition3D(axis, axis.tickLinesPosition, size, width, x1, y1, x2, y2, params);


                var line = { width: axis.majorTickLines.width, stroke: axis.majorTickLines.color, child: this.chart3D,  tag: 'line' };

                line.id = this.svgObject.id + axis.name + "_majorTickLines_" + i;

                this.graphics.addVisual(this.polygon.createLine(line, position.X1, position.Y1, position.X2, position.Y2, 0));

                if (axis.minorGridLines.visible && axis.minorTicksPerInterval > 0 && i < labelsCount - 1) {
                    minorTicks = axis.visibleRange.interval / (axis.minorTicksPerInterval + 1);
                    for (var k = 0; k < axis.minorTicksPerInterval; k++) {
                        value = ej.EjSvgRender.utils._valueToCoefficient(axis, axis.visibleLabels[i].Value + (minorTicks * (k + 1)));

                        value = isNaN(value) ? 0 : value;

                        if (axis.orientation.toLowerCase() == "horizontal") {
                            x1 = x2 = Math.round(axis.plotOffset + (m_AreaBounds.Width * value) + m_AreaBounds.X);
                        }
                        else {
                            y1 = y2 = Math.round(axis.plotOffset + ((m_AreaBounds.Height) * (1 - value))) + axis.y;
                        }

                        var position = this._calculatePosition3D(axis, axis.tickLinesPosition, size, width, x1, y1, x2, y2, params);


                        var line = { width: axis.minorTickLines.width, stroke: axis.minorTickLines.color, child: this.chart3D, tag: 'line' };

                        line.id = this.svgObject.id + axis.name + "_minorTickLines_" + i + k;

                        this.graphics.addVisual(this.polygon.createLine(line, position.X1, position.Y1, position.X2, position.Y2, 0));
                    }
                }
            }
        },

        _calculatePosition3D: function (axis, ticksPosition, tickSize, width, x1, y1, x2, y2, params) {
            var orientation = axis.orientation;
            var isOpposed = axis._opposed,
				ticksPosition = "outside",
				areaBounds = this.model.m_AreaBounds,
				validCross = params.axes[axis.name]._validCross,
				y = validCross ? axis.y : areaBounds.Y + (!isOpposed && areaBounds.Height),
				x = validCross ? axis.x : areaBounds.X + (isOpposed && areaBounds.Width);
            if (axis.orientation.toLowerCase() == "horizontal") {
                switch (ticksPosition) {
                    case "inside":
                        y1 = isOpposed ? width : 0;
                        y2 = isOpposed ? y1 + tickSize : tickSize;
                        break;
                    case "outside":
                        y1 = 0;
                        y2 = isOpposed ? tickSize : y1 + tickSize;
                        break;
                }                
                var screenPositionTop = ((isOpposed) ? y - this.model.wallSize - (tickSize) : y + this.model.wallSize - (tickSize / 2));
                var screenPositionLeft = axis.x;
                y1 += screenPositionTop;
                y2 += screenPositionTop;

                x1 = x2 = x1;
            }
            else {
                switch (ticksPosition) {
                    case "inside":
                        x1 = 0;
                        x2 = isOpposed ? tickSize : x1 + tickSize;
                        break;
                    case "outside":
                        x1 = 0;
                        x2 = isOpposed ? x1 + tickSize : tickSize;
                        break;
                }
                var screenPositionLeft = (isOpposed) ? x + this.model.wallSize  : (x - this.model.wallSize - tickSize);
                var screenPositionTop = this.model.m_AreaBounds.Y;
                x1 += screenPositionLeft;
                x2 += screenPositionLeft;

                y1 = y2 = y1;
            }
            return { X1: x1, Y1: y1, X2: x2, Y2: y2 };
        },

    

        _drawGridLines3D:function(axis, params)
        {          
            if (axis == null)
                return;
        
            var labelsCount = axis.visibleLabels.length,
                minorTicks, opposedPosition = axis._opposed,
                orientation = axis.orientation, validCross = params.axes[axis.name]._validCross,
                x1, x2, y1, y2;
            if (orientation.toLowerCase() == "horizontal")
            {
                 
                var i;
                for (i = 0; i < labelsCount; i++)
                {                
                    var value = ej.EjSvgRender.utils._valueToCoefficient(axis, axis.visibleLabels[i].Value);
                    value = isNaN(value) ? 0 : value;
					 x2 = x1 = (Math.round(axis.width * value)) + this.model.m_AreaBounds.X+axis.plotOffset;
                    y1 = this.model.m_AreaBounds.Y;
                    y2 = this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height;
              
                
                    var depth = this.model.depth > 2 ? this.model.depth - 2 : 1;
                    var bottom = validCross ? axis.y : this.model.m_AreaBounds.Y + (!opposedPosition && this.model.m_AreaBounds.Height);

                    var line = { opacity: axis.majorGridLines.opacity, width: axis.majorGridLines.width, stroke: axis.majorGridLines.color, child: this.chart3D,  tag: 'line' };
                    line.id = this.svgObject.id + axis.name + "_gridlines_" + i;
                    this.graphics.addVisual(this.polygon.createLine(line, x1, y1, x2, y2, depth));
                    var parallelLine = $.extend({}, line);
                    parallelLine.id = this.svgObject.id + axis.name + "_parallelGridlines_" + i;
                  
                    var line3D =   this.polygon.createLine(parallelLine, x2, 0, x2, -depth, bottom);
                    //To fold the gridline alone the wall(bottom)
                    this.polygon.transform(this.matrixobj.tilt((parseFloat)(Math.PI / 2)), line3D);
                        
                    this.graphics.addVisual(line3D);
                    
                    if (axis.minorGridLines.visible && axis.minorTicksPerInterval > 0 && i<labelsCount-1) {
                        minorTicks = axis.visibleRange.interval / (axis.minorTicksPerInterval + 1);
                        for (var k = 0; k < axis.minorTicksPerInterval; k++) {
                            value = ej.EjSvgRender.utils._valueToCoefficient(axis, axis.visibleLabels[i].Value + (minorTicks * (k+1)));
                            value = isNaN(value) ? 0 : value;
                            x2 = x1 = (Math.round(this.model.m_AreaBounds.Width * value) + this.model.m_AreaBounds.X);
                            y1 = this.model.m_AreaBounds.Y;
                            y2 = this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height;

                            var line = { opacity: axis.minorGridLines.opacity, width: axis.minorGridLines.width, stroke: axis.minorGridLines.color, child: this.chart3D, tag: 'line' };
                            line.id = this.svgObject.id + axis.name + "_minorgridlines_" + i + k;
                            this.graphics.addVisual(this.polygon.createLine(line, x1, y1, x2, y2, depth));
                            var parallelLine = $.extend({}, line);
                            parallelLine.id = this.svgObject.id + axis.name + "_parallelMinorGridlines_" + i + k;

                            var line3D = this.polygon.createLine(parallelLine, x2, 0, x2, -depth, bottom);
                            //To fold the gridline alone the wall(bottom)
                            this.polygon.transform(this.matrixobj.tilt((parseFloat)(Math.PI / 2)), line3D);

                            this.graphics.addVisual(line3D);
                        }
                    }
                
                    index++;
                }
            }
            else
            {
                var i;
       
              
                for (i = 0; i < labelsCount; i++)
                {
                    //if (i < linesCount)
                    //{
                    var line;
					var value = (axis.visibleLabels[i].Value - axis.visibleRange.min) / (axis.visibleRange.delta); 
                    value = (axis.isInversed) ? 1 - value : value;
                    value = isNaN(value) ? 0 : value;
                    x1 = this.model.m_AreaBounds.X;
                    y1 = Math.round((axis.height) * (1 - value)) + 0.5;
                    y1 += axis.y;
                    x2 = x1 + this.model.m_AreaBounds.Width;
                    y2 = y1;

                    var depth = this.model.depth > 2 ? this.model.depth - 2 : 1;

                    var line = { opacity: axis.majorGridLines.opacity, width: axis.majorGridLines.width, stroke: axis.majorGridLines.color, axisName: axis.name, child: this.chart3D, tag: 'line' };
                 
                    line.id = this.svgObject.id + axis.name + "_gridlines_" + i;

                    this.graphics.addVisual(this.polygon.createLine(line, x1, y1, x2, y2, depth));

                    var depthD = validCross ? axis.x : this.model.m_AreaBounds.X + (opposedPosition && this.model.m_AreaBounds.Width + 1);

                    var sideLine = $.extend({}, line);
                    sideLine.id = this.svgObject.id + axis.name + "_parallelGridlines_" + i;
              
                    var line3D = this.polygon.createLine(sideLine, -depth, y2, 0, y2, depthD);
                    //To fold the gridline alone the wall(right of vertical)
                    this.polygon.transform(this.matrixobj.turn((parseFloat)(-Math.PI / 2)), line3D);
                    this.graphics.addVisual(line3D);

                    if (axis.minorGridLines.visible && axis.minorTicksPerInterval > 0 && i < labelsCount - 1) {
                        minorTicks = axis.visibleRange.interval / (axis.minorTicksPerInterval + 1);
                        for (var k = 0; k < axis.minorTicksPerInterval; k++) {
                            var value = ej.EjSvgRender.utils._valueToCoefficient(axis, axis.visibleLabels[i].Value + (minorTicks * (k + 1)));
                            value = isNaN(value) ? 0 : value;
                            x1 = this.model.m_AreaBounds.X;
                            y1 = Math.round((axis.height) * (1 - value)) + 0.5;
                            y1 += axis.y;
                            x2 = x1 + this.model.m_AreaBounds.Width;
                            y2 = y1;
                            var line = { opacity: axis.minorGridLines.opacity, width: axis.minorGridLines.width, stroke: axis.minorGridLines.color, axisName: axis.name, child: this.chart3D, tag: 'line' };

                            line.id = this.svgObject.id + axis.name + "_minorgridlines_" + i + k;

                            this.graphics.addVisual(this.polygon.createLine(line, x1, y1, x2, y2, depth));                          

                            var sideLine = $.extend({}, line);
                            sideLine.id = this.svgObject.id + axis.name + "_parallelMinorGridlines_" + i + k;

                            var line3D = this.polygon.createLine(sideLine, -depth, y2, 0, y2, depthD);
                            //To fold the gridline alone the wall(right of vertical)
                            this.polygon.transform(this.matrixobj.turn((parseFloat)(-Math.PI / 2)), line3D);
                            this.graphics.addVisual(line3D);
                        }
                    }

                    ////}
                    index++;
                }

            }
        }

    },

    

    ej.Ej3DSeriesRender.prototype={
        _getSegmentDepth:function(series)
        {
            var actualDepth = this.chartObj.model.depth;
            var start, end;

            if (this.chartObj.model._sideBySideSeriesPlacement)
            {
                var space = actualDepth / 4;
                start = space;
                end = space * 3;
            }
            else
            {
                var index = series.position-1;
                var count = series.all;
                var space = actualDepth / ((count * 2) + count + 1);
                start = space + (space * index * 3);
                end = start + space * 2;
            }
            return {Start:start, End:end, Delta:end-start};
        },

        createSegment: function (center, start, end, height, r, i, y, insideRadius, pointindex) {
         
            return {
                StartValue : start,
                EndValue : end,
                depth : height,
                radius : r,      
                index : i,
                YData : y,
                Center : center,
                inSideRadius : insideRadius,
                ActualEndValue : end,
                ActualStartValue: start,
                pointIndex: pointindex
            }

            return segment;

        },

        calculateSize:function(sender, series){
            var legend = sender.chartObj.model.legend;
   
            var legXSpace = 0;
            var legYSpace = 0,
                title = sender.chartObj.model.title ,
                subTitle =  sender.chartObj.model.title.subTitle ,
                titleLocation = sender.chartObj.model._titleLocation,
                subTitleLocation = sender.chartObj.model._subTitleLocation,
                titleTextOverflow = sender.chartObj.model.title.textOverflow,
                subTitleTextOverflow = sender.chartObj.model.title.subTitle.textOverflow,
                titleEnable=(title.text && title.visible && title.enableTrim && (titleTextOverflow == 'wrap' || titleTextOverflow == 'wrapandtrim'))?true:false;
                subTitleEnable=(subTitle.text && subTitle.visible && subTitle.enableTrim && (subTitleTextOverflow == 'wrap' || subTitleTextOverflow == 'wrapandtrim'))?true:false;
            if (legend.visible && legend.position.toLowerCase() != "custom") {
                if (legend.position.toLowerCase() == "right" || legend.position.toLowerCase() == "left")
                    legXSpace = ((legend.position.toLowerCase() == "right") ? sender.chartObj.model.margin.right : sender.chartObj.model.margin.left) + sender.chartObj.model.LegendViewerBounds.Width;
                else
                    legYSpace = ((legend.position.toLowerCase() == "top") ? sender.chartObj.model.margin.top : sender.chartObj.model.margin.bottom) + sender.chartObj.model.LegendViewerBounds.Height;

            }
            series.actualWidth = $(sender.chartObj.svgObject).width() - legXSpace;
            var centerx = series.actualWidth * 0.5 + ((legend.position.toLowerCase() === "left") ? legXSpace : 0);
            if (titleEnable || subTitleEnable){
                var yOffset = titleLocation.size.height + (subTitleEnable ? subTitleLocation.size.height : 0) + legYSpace;
                series.actualHeight = $(sender.chartObj.svgObject).height() - yOffset;
                var centery = series.actualHeight * 0.5 + ((legend.position.toLowerCase() === "top") ? yOffset : titleLocation.size.height + (subTitleEnable ? subTitleLocation.size.height : 0));
            }
            else {
                var yOffset = ((title.text && title.visible) ? titleLocation.Y : 0) + legYSpace;
                series.actualHeight = $(sender.chartObj.svgObject).height() - yOffset;
                var centery = series.actualHeight * 0.5 + ((legend.position.toLowerCase() === "top") ? yOffset : ((title.text && title.visible) ? (titleLocation.Y ) : 0));
            }
            return { centerX: centerx, centerY: centery };
        },

        createPoints: function (series, sender) {
            series.segments = [];
            var size = this.calculateSize(sender, series),
                all = 0,
                visiblepoints = this._calculateVisiblePoints(series).visiblePoints,
                count = series._visiblePoints.length;
            for (j = 0; j < count; j++)
                all += visiblepoints[j].YValues[0];
            var coef = 360 / all,
                seriesIndex = $.inArray(series, sender.chartObj.model._visibleSeries),
                seriesLength = this.chartObj.model._visibleSeries.length,
                InsideRadius = sender.chartObj.model.innerRadius[seriesIndex],
                YValues = sender.chartObj._getYValues(series._visiblePoints),
                pieHeight = sender.chartObj.model.depth, center,
                arcStartAngle = 0, arcEndAngle = 0,
                current = 0, pointindex, val, rect, offset, segment,
                segindex = 0,
                radius = sender.chartObj.model.circularRadius[seriesIndex];

            for (var i = 0; i < count; i++) {
                if (series._visiblePoints[i].visible || series._visiblePoints[i].gapMode) {
                    pointindex = $.inArray(series._visiblePoints[i], series._visiblePoints);
                val = Math.abs(YValues[i]);
                arcEndAngle = Math.abs(val) * ((Math.PI * 2) / all);
                rect = {};
                rect.x = 0;
                rect.y = 0;

                if (val != 0) {
                    if (series.explodeIndex == series._visiblePoints[i].actualIndex || series.explodeAll) {
                        offset = {X:0, Y:0};
                        offset.X = Math.cos(2 * Math.PI * (current + val / 2) / all),
                        offset.Y = Math.sin(2 * Math.PI * (current + val / 2) / all);
                        rect.x = 0.01 * radius * offset.X * series.explodeOffset;
                        rect.y = 0.01 * radius * offset.Y * series.explodeOffset;
                    }

                    center = sender.chartObj.vector.vector3D(rect.x +  size.centerX, rect.y + size.centerY, 0);
                    {
                            segment = this.createSegment(center, (parseFloat)(coef * current), (parseFloat)(coef * val), pieHeight, radius, i, val, InsideRadius, pointindex, series);
                            if (series._visiblePoints[i].gapMode)
                                segment.visible = false;
                            else
                                segment.visible = true;
                            series.segments.push(segment);
                    }
                }

                if (series.marker.dataLabel.visible)
                    this._addPieDataLabel(segindex, YValues[i], arcStartAngle, arcStartAngle + arcEndAngle, i, radius, this._isChartRotated(sender) ? sender.chartObj.model.depth + 5 : 0, center, series._visiblePoints[i]);

                segindex++;
                arcStartAngle += arcEndAngle;
                current += val;

                }
            }
            return series.segments;
        },

        _addPieDataLabel: function (x, y, startAngle, endAngle, i, radius, startDepth, center, point) {
            var angle = (startAngle + endAngle) / 2;
            point.symbolLocation = { x: 0, y: 0, radius: 0, angle: 0, StartDepth: 0 };
            point.symbolLocation.x = x;
            point.symbolLocation.y = y;
            point.symbolLocation.radius = radius;
            point.symbolLocation.angle = angle;
            point.symbolLocation.center = center;
            point.startDepth = startDepth;
        },

        _isChartRotated:function(sender)
           {
            var actualTiltView = Math.abs(sender.chartObj.model.tilt % 360);
            var actualRotateView = Math.abs(sender.chartObj.model.rotattion % 360);
            if ((actualTiltView > 90 && actualTiltView < 270) ^ (actualRotateView > 90 && actualRotateView < 270))
              {
                return true;
              }
                  return false;
          },

        createSector: function (seg, sender, style, seriesIndex) {
            var count = (parseInt)(Math.ceil(seg.ActualEndValue / 6));
            var DtoR = Math.PI / 180;
            var inc = 0;
            var Points = [];
            var depth = sender.chartObj.model.depth;
            if (count < 1) return null;
            var res = [];
            var f = seg.ActualEndValue / count;

            var oPts = [];
            var iPts = [];

            for (var i = 0; i < count + 1; i++) {
                var ox = (parseFloat)(seg.Center.x + seg.radius * Math.cos((seg.ActualStartValue + i * f) * DtoR));
                var oy = (parseFloat)(seg.Center.y + seg.radius * Math.sin((seg.ActualStartValue + i * f) * DtoR));

                oPts[i] = { X: ox, Y: oy };

                var ix = (parseFloat)(seg.Center.x + seg.inSideRadius * Math.cos((seg.ActualStartValue + i * f) * DtoR));
                var iy = (parseFloat)(seg.Center.y + seg.inSideRadius * Math.sin((seg.ActualStartValue + i * f) * DtoR));

                iPts[i] = { X: ix, Y: iy };
                Points.push({ X: ox, Y: oy });
            }

            var oPlgs = [];

            for (var i = 0; i < count; i++) {
                vts = new Array(sender.chartObj.vector.vector3D(oPts[i].X, oPts[i].Y, 0),
                       sender.chartObj.vector.vector3D(oPts[i].X, oPts[i].Y, depth),
                       sender.chartObj.vector.vector3D(oPts[i + 1].X, oPts[i + 1].Y, depth),
                       sender.chartObj.vector.vector3D(oPts[i + 1].X, oPts[i + 1].Y, 0))


                oPlgs[i] = sender.chartObj.polygon.polygon3D(vts, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString()  + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D);
                inc++;
            }

            res[1] = oPlgs;

            if (seg.inSideRadius > 0) {
                var iPlgs = [];

                for (var i = 0; i < count; i++) {
                    vts = new Array(sender.chartObj.vector.vector3D(iPts[i].X, iPts[i].Y, 0),
                      sender.chartObj.vector.vector3D(iPts[i].X, iPts[i].Y, depth),
                      sender.chartObj.vector.vector3D(iPts[i + 1].X, iPts[i + 1].Y, depth),
                      sender.chartObj.vector.vector3D(iPts[i + 1].X, iPts[i + 1].Y, 0))


                    iPlgs[i] = sender.chartObj.polygon.polygon3D(vts, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D);
                    inc++;
                }

                res[3] = iPlgs;
            }

            var tVtxs = [];
            var bVtxs = [];

            for (var i = 0; i < count + 1; i++) {
                tVtxs.push(sender.chartObj.vector.vector3D(oPts[i].X, oPts[i].Y, 0));
                bVtxs.push(sender.chartObj.vector.vector3D(oPts[i].X, oPts[i].Y, depth));
            }

            if (seg.inSideRadius > 0) {
                for (var i = count; i > -1; i--) {
                    tVtxs.push(sender.chartObj.vector.vector3D(iPts[i].X, iPts[i].Y, 0));
                    bVtxs.push(sender.chartObj.vector.vector3D(iPts[i].X, iPts[i].Y, depth));
                }
            }
            else {
                tVtxs.push(seg.Center);
                bVtxs.push(sender.chartObj.vector.vector3D(seg.Center.x, seg.Center.y, depth));
            }
            res[0] = [];
            res[0].push(sender.chartObj.polygon.polygon3D(tVtxs, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D));
            inc++;
            res[0].push(sender.chartObj.polygon.polygon3D(bVtxs, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D));
            inc++;



            if (seg.inSideRadius > 0) {
                var rvts = new Array(

                      sender.chartObj.vector.vector3D(oPts[0].X, oPts[0].Y, 0),
                      sender.chartObj.vector.vector3D(oPts[0].X, oPts[0].Y, depth),
                      sender.chartObj.vector.vector3D(iPts[0].X, iPts[0].Y, depth),
                      sender.chartObj.vector.vector3D(iPts[0].X, iPts[0].Y, 0)
                 )

                var lvts = new Array
                 (
                     sender.chartObj.vector.vector3D(oPts[count].X, oPts[count].Y, 0),
                     sender.chartObj.vector.vector3D(oPts[count].X, oPts[count].Y, depth),
                     sender.chartObj.vector.vector3D(iPts[count].X, iPts[count].Y, depth),
                     sender.chartObj.vector.vector3D(iPts[count].X, iPts[count].Y, 0)
                 )
                res[2] = [];

                res[2].push(sender.chartObj.polygon.polygon3D(rvts, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D));
                inc++;
                res[2].push(sender.chartObj.polygon.polygon3D(lvts, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D));
                inc++;             

            }
            else {
                var rvts = new Array(
                     sender.chartObj.vector.vector3D(oPts[0].X, oPts[0].Y, 0),
                     sender.chartObj.vector.vector3D(oPts[0].X, oPts[0].Y, depth),
                     sender.chartObj.vector.vector3D(seg.Center.x, seg.Center.y, depth),
                     sender.chartObj.vector.vector3D(seg.Center.x, seg.Center.y, 0)
                )

                var lvts = new Array(
                     sender.chartObj.vector.vector3D(oPts[count].X, oPts[count].Y, 0),
                     sender.chartObj.vector.vector3D(oPts[count].X, oPts[count].Y, depth),
                     sender.chartObj.vector.vector3D(seg.Center.x, seg.Center.y, depth),
                     sender.chartObj.vector.vector3D(seg.Center.x, seg.Center.y, 0)
                )
                res[2] = [];
                res[2].push(sender.chartObj.polygon.polygon3D(rvts, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D));
                inc++;
                res[2].push(sender.chartObj.polygon.polygon3D(lvts, this, seg.index, style.borderColor, style.borderWidth, style.opacity, style.interior, inc.toString() + "_Region" + "_Series_" + seriesIndex + "_Point_" + seg.index, sender.chartObj.chart3D));
                inc++;


            }


            return res;
        },

        createPolygons: function (series, sender, returnPoly) {
            var segments, poligons = [], seg, style,
                pointindex, segmentsLength, plgs,
                seriesIndex = $.inArray(series, sender.chartObj.model._visibleSeries);
            if (!series.segments || !returnPoly)
                segments = this.createPoints(series, sender);
            else
                segments = series.segments;
            segmentsLength = segments.length;
            for (var i = 0; i < segmentsLength; i++) {
                seg = segments[i];
                if (seg.visible) {
                    pointindex = segments[i].pointIndex;
                    style = sender.chartObj.setStyle(sender, series, seriesIndex, pointindex);
                    if (typeof (sender.chartObj.model.pointColors[pointindex]) == "object")
                        style.interior = sender.chartObj.model.pointColors[pointindex][0].color;
                    plgs = this.createSector(seg, sender, style, seriesIndex);
                    if (plgs != null)
                        for (var ai = 0; ai < plgs.length; ai++) {
                            if (!poligons[ai])
                                poligons[ai] = [];
                            if (plgs[ai] != null) {
                                for (var pi = 0; pi < plgs[ai].length; pi++) {
                                    poligons[ai].push(plgs[ai][pi]);

                                }
                            }
                        }
                    }


            }
            if (returnPoly) {
                return poligons;               
            }

            for (var ai = 0; ai < poligons.length; ai++) {
                for (var k = 0; k < poligons[ai].length; k++) {
                    sender.chartObj.graphics.addVisual(poligons[ai][k]);
                }
            }
        },

        draw3DDataLabel: function (series, pointIndex, point, sender) {

            var connectorHeight = series.marker.dataLabel.connectorLine.height;
            var tag;
            if (this.chartObj.model.AreaType == "none") {
                location = { x: 0, y: 0 };
                var pointText = (point.text) ? point.text : point.y;
                var seriesIndex = $.inArray(series, this.chartObj.model.series);
                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = { text: pointText, location: { x: pointX, y: pointY }, series: series, pointIndex: pointIndex ,seriesIndex:seriesIndex};
                this.chartObj._trigger("displayTextRendering", commonEventArgs);
                commonEventArgs.data.Text = commonEventArgs.data.text;
                var size = ej.EjSvgRender.utils._measureText(pointText, null, series.marker.dataLabel.font);

                if (series.type.toLowerCase() == "doughnut"  || series.type.toLowerCase() == "pie")
                {
                   
                    var width = Math.min(series.actualWidth, series.actualHeight) / 2;
                    var center = point.symbolLocation.center;

                    var dradius = point.symbolLocation.radius * series._coefficient;
                    if (ej.util.isNullOrUndefined(connectorHeight))
                         connectorHeight = ej.EjSvgRender.utils._measureText(commonEventArgs.data.text, null, series.marker.dataLabel.font).height;
                    if (series != null &&series.labelPosition != "inside")
                        radius = point.symbolLocation.radius +  connectorHeight;
                    else if (series != null )
                        radius = dradius + (point.symbolLocation.radius-dradius) / 2;
                    pointX=location.X = center.x + radius * Math.cos(point.symbolLocation.angle);
                    pointY=location.Y = center.y + radius * Math.sin(point.symbolLocation.angle);
                }
            }
            else {
                var labelFormat = series.yAxis.labelFormat ? series.yAxis.labelFormat : "";
                var seriesIndex = $.inArray(series, this.chartObj.model.series);
                var pointText = (point.text) ? point.text : point.y + labelFormat.substring(labelFormat.indexOf('}') + 1);
                var pointHeight = 0;
                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = { text: pointText, location: { x: pointX, y: pointY }, series: series, pointIndex: pointIndex };
                this.chartObj._trigger("displayTextRendering", commonEventArgs);
                commonEventArgs.data.Text = commonEventArgs.data.text;
                var size = ej.EjSvgRender.utils._measureText(pointText, null, series.marker.dataLabel.font);

                var location = ej.EjSvgRender.utils.Transform3DToVisible(series, point.symbolLocation.x, point.symbolLocation.y, this.chartObj);
                var connectorHeight = (series.marker.dataLabel.connectorLine.height) ? series.marker.dataLabel.connectorLine.height : 0;
                var angle = (6.28 * (1 - (90 / 360.0)));
                var pointY = location.Y;
                var pointX = location.X;
                if (!this.chartObj.model.requireInvertedAxes) {
                    if (point.y > 0)
                        pointY = location.Y + (Math.sin((angle)) * connectorHeight);
                    else
                        pointY = location.Y + (Math.sin((-angle)) * connectorHeight);
                }
                else {
                    if (point.x > 0)
                        pointX = location.X - (Math.sin((angle)) * connectorHeight);
                    else
                        pointX = location.X + (Math.sin((angle)) * connectorHeight);
                      pointHeight = - size.height / 3;
                }
            }

         
          
            var depthInfo = this._getSegmentDepth(series);

            

            if (series.marker.dataLabel.shape.toLowerCase() != "none" && !point.marker.dataLabel.template && commonEventArgs.data.Text != '') {
              
                var element = { tag: 'dataLabel', series: series, point: point, pointIndex: pointIndex, id: this.chartObj.svgObject.id + seriesIndex + '_DataLabel' + pointIndex, child: this.chartObj.chart3D };

                this.chartObj.graphics.addVisual(this.chartObj.polygon.createTextElement(this.chartObj.vector.vector3D(pointX, pointY, (point.symbolLocation.z) ? point.symbolLocation.z : 0), element, 0, -size.height));
            }

            tag = (!point.marker.dataLabel.template) ? "text" : "template";
             
            var element = { Width: size.width, Height: size.height, Label: commonEventArgs.data, TextAnchor: "middle", tag: tag, font: series.marker.dataLabel.font, Angle: series.marker.dataLabel.angle, id: this.chartObj.svgObject.id + '_SeriesText' + pointIndex + seriesIndex, child: this.chartObj.chart3D };
           

            if (this.chartObj.model.AreaType != "none") {
                if (series.marker.dataLabel.connectorLine.height && series.marker.dataLabel.connectorLine.height > 0) {
                    var drawPoints = [];
                    drawPoints.push({ x: location.X, y: location.Y + pointHeight, z: point.symbolLocation.z });

                    drawPoints.push({ x: pointX, y: pointY + pointHeight, z: point.symbolLocation.z });
                    this.drawLineSegment(drawPoints, pointIndex, series);
                }
                this.chartObj.graphics.addVisual(this.chartObj.polygon.createTextElement(this.chartObj.vector.vector3D(pointX, pointY, point.symbolLocation.z), element, 0, -size.height));
            }
            else {
                  if (series.labelPosition.toLowerCase() != "inside")
                    this.updateConnectorLine(point, pointIndex, series, location, connectorHeight)
                var finalSize = { x: series.actualWidth, y: series.actualHeight };
                this.chartObj.graphics.addVisual(this.chartObj.polygon.createTextElement(this.chartObj.vector.vector3D(location.X, location.Y, -1), element, 0, -size.height));
            }        
        },
        updateConnectorLine: function (point, pointIndex, series, location, connectorHeight) {
            var drawPoints = [];
            var symbolLocation = point.symbolLocation;
            var x = symbolLocation.center.x + Math.cos(symbolLocation.angle) * symbolLocation.radius;
            var y = symbolLocation.center.y + Math.sin(symbolLocation.angle) * symbolLocation.radius;
            drawPoints.push({ x: x, y: y });
            var labelRadiusFromOrigin = symbolLocation.radius + connectorHeight;
            x = symbolLocation.center.x + (Math.cos((symbolLocation.angle)) * (labelRadiusFromOrigin));
            y = symbolLocation.center.y + (Math.sin((symbolLocation.angle)) * (labelRadiusFromOrigin));
           
            drawPoints.push({ x: x, y: y });
            //var hipen = height / 5;
            //x += (x > symbolLocation.center.x) ? hipen : -hipen;
            //drawPoints.push({ x: x, y: y });
            if (series.marker.dataLabel.connectorLine.type =="bezier")
                drawPoints = this.getBezierApproximation(drawPoints, 256, series);
            this.drawLineSegment(drawPoints, pointIndex, series)
        },
        /// <returns></returns>
        getBezierApproximation: function (controlPoints, outputSegmentCount, series)
        {
            var points = [];
             for (var i = 0; i <= outputSegmentCount; i++)
             {
               var t =i / outputSegmentCount;
               points.push(this.GetBezierPoint(t, controlPoints, 0, controlPoints.length, series));
             }
            return points;
         },
        drawLineSegment: function (drawpoints, pointIndex, series) {
            var vectorPoints = [];
            for (var i = 0; i < drawpoints.length; i++) {
                vectorPoints.push(this.chartObj.vector.vector3D(drawpoints[i].x, drawpoints[i].y, drawpoints[i].z ? drawpoints[i].z:0));
            }
            var seriesIndex=$.inArray(series, this.chartObj.model._visibleSeries);
            var color = (this.chartObj.model.AreaType=="none") ? this.chartObj.model.pointColors[pointIndex] : this.chartObj.model.seriesColors[seriesIndex];
            var stroke = (series.marker.dataLabel.connectorLine.stroke)?series.marker.dataLabel.connectorLine.stroke:color;
            var line = { width: series.marker.dataLabel.connectorLine.width, stroke: stroke, child: this.chartObj.chart3D, tag: 'polyline', id:this.chartObj.svgObject.id + "_" + seriesIndex + "_" + pointIndex };
          
            this.chartObj.graphics.addVisual(this.chartObj.polygon.createPolyline(vectorPoints, line));
        }

    },

     ej.ejCircularSeries = {

         draw: function (series, sender, type) {
             var MARGINS_RATIO = 0.03;
             
             seriesLength = sender.chartObj.model._visibleSeries.length,
             seriesIndex = $.inArray(series, sender.chartObj.model._visibleSeries);
             sender._calculateVisiblePoints(series);
              sender.calculateSize(sender, series);
             
             if (type == "pie") {
                 series._size = series.pieCoefficient;
                 series._coefficient = seriesIndex == 0 ? 0 : series._size ;
             }
             else {
                 series._size = series.doughnutSize;
                 series._coefficient =  series.doughnutCoefficient;
             }
            if (sender.chartObj.model.circularRadius.length > 1) {
                 for (i = seriesIndex; i < sender.chartObj.model.circularRadius.length; i++) {
                     if (!ej.util.isNullOrUndefined(sender.chartObj.model.circularRadius[i])) {
                         sender.chartObj.model.circularRadius[seriesIndex] = sender.chartObj.model.circularRadius[i] * series._size;
                         break;
                     }
                 }
             }
             else
                 sender.chartObj.model.circularRadius[seriesIndex] = (((1 - MARGINS_RATIO) * Math.min(series.actualWidth / 2, series.actualHeight / 2)) * series._size);
             sender.chartObj.model.innerRadius[seriesIndex] = series._coefficient * sender.chartObj.model.circularRadius[seriesIndex];
             sender.createPolygons(series, sender);
         },
         doAnimation: function (series, sender) {
             var seriesRendering = this;
             series.count = 0;
             $.each(series.segments, function (pointIndex, point) {

                 var radius = point.radius;
                 var insideRadius = point.inSideRadius;

                 series.animate = true;
                 $(sender.chartObj.element).each(function () { point.radius = 0, point.inSideRadius=0 }).animate(
                     { Radius: radius, InsideRadius: insideRadius },

                     {
                         duration: 1000, queue: false, step: function (now, fx) {


                             if (fx.prop.toString() === "Radius") {
                                 point.radius = now;
                             }
                             else {
                                 point.inSideRadius = now;
                             }


                             var poligons = sender.createPolygons(series, sender, true);

                             for (var ai = 0; ai < poligons.length; ai++) {
                                 for (var k = 0; k < poligons[ai].length; k++) {                                     
                                     sender.chartObj.polygon.update(poligons[ai][k].VectorPoints, poligons[ai][k], sender)
                                 }
                             }
                            
                         },
                         complete: function () {
                             sender.chartObj.model.AnimationComplete = true;
                             var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                             commonEventArgs.data = { series: series };
                             sender.chartObj._trigger("animationComplete", commonEventArgs);

                         }
                     });
             });
         }
     },

      ej.series3DTypes.doughnut = ej.ejCircularSeries;
      ej.series3DTypes.pie = ej.ejCircularSeries;

    

    ej.ej3DStackingColumn = {

        draw: function (series, sender, type, params) {
            var visiblePoints = sender._isVisiblePoints(series);
            this.createSegments(series, sender, params);
            for (var i = 0; i < visiblePoints.length; i++) {
                if (visiblePoints[i].visible) {
                    series._visiblePoints[i].plans = null;
                    ej.ej3DColumnSeries.update(series, series._visiblePoints[i], i, sender)
                }
            }
        },

        createSegments: function (series, sender, params) {
            var xValues = sender.chartObj._getXValues(series._visiblePoints);
          
            var median,
			 cons=0.2;
            if (xValues == null) return;
            
            var sbsInfo = sender.getSideBySideInfo(series, params);
            var depthInfo = sender._getSegmentDepth(series);           
            median = sbsInfo.Delta / 2;
            var visiblePoints = sender._isVisiblePoints(series);
            for (var i = 0; i < visiblePoints.length; i++) {

                var x1 = xValues[i] + sbsInfo.Start;
                var x2 = xValues[i] + sbsInfo.End;
                var y2 = series.stackedValue.StartValues[i];
                var y1 = series.stackedValue.EndValues[i];

                ej.ej3DColumnSeries._setData(x1, y1, x2, y2, depthInfo.Start, depthInfo.End, sender, visiblePoints[i]);

                if (!series.marker.dataLabel.visible) continue;
                visiblePoints[i].symbolLocation = { x: 0, y: 0, z: 0 };
                switch (series.marker.dataLabel.textPosition) {
                    case "top":
                        visiblePoints[i].symbolLocation.x = x1 + median;
                        visiblePoints[i].symbolLocation.y = y1;
                        visiblePoints[i].symbolLocation.z = depthInfo.Start + (depthInfo.Delta / 2);
                        break;
                    case "bottom":
                        visiblePoints[i].symbolLocation.x = x1 + median;
                        visiblePoints[i].symbolLocation.y = y2 - cons;
                        visiblePoints[i].symbolLocation.z = depthInfo.Start + (depthInfo.End - depthInfo.Start) / 2;
                        break;
                    default:
                        visiblePoints[i].symbolLocation.x = x1 + median;
                        visiblePoints[i].symbolLocation.y = y1 + (y2 - y1) / 2;
                        visiblePoints[i].symbolLocation.z = depthInfo.Start;
                        break;
                }

            }

        },

        doAnimation: function (series, sender) {            

                var seriesRender = this;

                $.each(series._visiblePoints, function (pointIndex, point) {

                    var topValue = point.Top;
                    var bottomValue = point.Bottom;

                    $(point).each(function () { point.Top = 0, point.Bottom = 0}).animate(
                    { Top: topValue, Bottom: bottomValue },

                    {
                        duration: 1200, queue: false, step: function (now, fx) {

                            if (fx.prop.toString() === "Top") {
                                point.Top = now;
                            }
                            if (fx.prop.toString() === "Bottom") {
                                point.Bottom = now;
                            }

                            ej.ej3DColumnSeries.update(series, point, pointIndex, sender);

                        },
                        
                         complete: function () {                  
                       
                                sender.chartObj.model.AnimationComplete = true;
                                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                                commonEventArgs.data = { series: series };
                                sender.chartObj._trigger("animationComplete", commonEventArgs);
                  
                            }

                    });

                });

           }

        
        
    },

    ej.series3DTypes.stackingcolumn = ej.ej3DStackingColumn;

    ej.series3DTypes.stackingbar = ej.ej3DStackingColumn;
     
	ej.series3DTypes.stackingbar100 = ej.ej3DStackingColumn;
	 
	ej.series3DTypes.stackingcolumn100 = ej.ej3DStackingColumn;
   
    ej.ej3DColumnSeries = {
        draw: function (series, sender, type, params) {
            var visiblePoints = sender._isVisiblePoints(series);
            this.createSegments(series, sender, params);
            for (var i = 0; i < visiblePoints.length; i++) {
                if (visiblePoints[i].visible) {
                    series._visiblePoints[i].plans = null;
                    this.update(series, series._visiblePoints[i], i, sender);
                }
            }
        },

        update: function (series, point, pointIndex, sender) {
            var plans;
            var valueType = series.xAxis._valueType.toLowerCase();
            var seriesIndex = $.inArray(series, sender.chartObj.model._visibleSeries);    
            var xBase = (valueType == "logarithmic") ? null : 1;
            var xIsLogarithmic = (valueType == "logarithmic") ? true :false;
            var left = xIsLogarithmic ? Math.log(point.Left, xBase) : point.Left;
            var right = xIsLogarithmic ? Math.log(point.Right, xBase) : point.Right;
            var bottom = series.yAxis.visibleRange.min;
            var top = series.yAxis.visibleRange.max;
            var xStart = series.xAxis.visibleRange.min;
            var xEnd = series.xAxis.visibleRange.max;
            if ((!(left >= xStart) || !(left <= xEnd)) && (!(right >= xStart) || !(right <= xEnd))) return;
           
            var topValue;
            if(point.Top<0)
                topValue = point.Top > bottom ? point.Top : bottom;
            else
                topValue = (series.yAxis.valueType && series.yAxis.valueType.toLowerCase() == "logarithmic") ?  point.Top : point.Top < top ? point.Top : top;
            var tlpoint = ej.EjSvgRender.utils.Transform3DToVisible(series, point.Left > xStart ? point.Left : xStart, topValue, sender.chartObj);
            var rbpoint = ej.EjSvgRender.utils.Transform3DToVisible(series, xEnd > point.Right ? point.Right : xEnd, bottom > point.Bottom ? bottom : point.Bottom, sender.chartObj);
            
            var tlfVector = sender.chartObj.vector.vector3D(Math.min(tlpoint.X, rbpoint.X), Math.min(tlpoint.Y, rbpoint.Y), point.StartDepth);
            var brbVector = sender.chartObj.vector.vector3D(Math.max(tlpoint.X, rbpoint.X), Math.max(tlpoint.Y, rbpoint.Y), point.EndDepth);
           
            var styleOptions = sender.chartObj.setStyle(sender, series, seriesIndex, pointIndex);
            if (styleOptions.interior.indexOf("url") >= 0)
                styleOptions.interior = sender.chartObj.model.seriesColors[seriesIndex][0].color;
            var name = "Region" + "_Series_" + seriesIndex + "_Point_" + pointIndex
            if (series.columnFacet == "cylinder")

                sender.chartObj.polygon.createCylinder(tlfVector, brbVector, this, pointIndex, series.type,
                    styleOptions.borderColor, styleOptions.interior, styleOptions.borderWidth, styleOptions.opacity, sender.chartObj.model.requireInvertedAxes, name, sender.chartObj.chart3D);
            else if (series.columnFacet == "rectangle")
    			sender.chartObj.polygon.createBox(tlfVector, brbVector, this, pointIndex, series.type,
                    styleOptions.borderColor, styleOptions.interior, styleOptions.borderWidth, styleOptions.opacity, sender.chartObj.model.requireInvertedAxes, name, sender.chartObj.chart3D);
           
        },

        _setData:function()
        {  
            var values=arguments;
            point = arguments[arguments.length - 1];
            sender = arguments[arguments.length - 2];
        
            point.Left = values[0];
            point.Bottom = values[3];
            point.Top = values[1];
            point.Right = values[2];
            point.StartDepth = values[4];
            point.EndDepth = values[5];
            point.XRange = sender.getDoubleRange(point.Left, point.Right);
            if (!isNaN(point.Top) && !isNaN(point.Bottom))
                point.YRange = sender.getDoubleRange(point.Top, point.Bottom);
        },

        createSegments:function(series, sender, params)
        {
            var xValues = sender.chartObj._getXValues(series._visiblePoints),
                YValues = sender.chartObj._getYValues(series._visiblePoints);            
            if (xValues == null) return;
      
            var sbsInfo = sender.getSideBySideInfo(series, params),
                depthInfo = sender._getSegmentDepth(series);
                crossValue = sender.chartObj._getXCrossValue(series, series.xAxis, params),
                median = sbsInfo.Delta / 2,
            visiblePoints = series._visiblePoints,
			 cons = 0.2;
            for (var i = 0; i < visiblePoints.length; i++)
            {                 
                var x1 = xValues[i] + sbsInfo.Start,
                    x2 = xValues[i] + sbsInfo.End,
                    y1 = YValues[i],
                    y2 = crossValue;
                
                this._setData(x1, y1, x2, y2, depthInfo.Start, depthInfo.End, sender, visiblePoints[i]);

                XData = xValues[i];
                YData = YValues[i];
                //Item = ActualData[i];
              
                if (!series.marker.dataLabel.visible) continue;
                visiblePoints[i].symbolLocation = {x:0, y:0, z:0};
                switch (series.marker.dataLabel.textPosition) {
                    case "top":
                        visiblePoints[i].symbolLocation.x = x1 + median;
                        visiblePoints[i].symbolLocation.y = y1;
                        visiblePoints[i].symbolLocation.z = depthInfo.Start + (depthInfo.Delta / 2);
                        break;
                    case "bottom":
                        visiblePoints[i].symbolLocation.x = x1 + median;
                        visiblePoints[i].symbolLocation.y = y2 - cons;
                        visiblePoints[i].symbolLocation.z = depthInfo.Start + (depthInfo.End - depthInfo.Start) / 2;
                        break;
                    default:
                        visiblePoints[i].symbolLocation.x = x1 + median;
                        visiblePoints[i].symbolLocation.y = Math.abs(y2 - y1) / 2;
                        visiblePoints[i].symbolLocation.z = depthInfo.Start;
                        break;
                }
        
            }

    
        },

        doAnimation: function (series, sender) {

            var seriesRender = this;

            $.each(series._visiblePoints, function (pointIndex, point) {

                var topValue = point.Top;
                $(point).each(function () { point.Top = 0 }).animate(
                { Top: topValue },

                {
                    duration: 1200, queue: false, step: function (now, fx) {

                        if (fx.prop.toString() === "Top") {
                            point.Top = now;
                        }                      

                        seriesRender.update(series, point, pointIndex, sender);

                    },
                    
                     complete: function () {                        
                            sender.chartObj.model.AnimationComplete = true;
                            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                            commonEventArgs.data = { series: series };
                            sender.chartObj._trigger("animationComplete", commonEventArgs);
                  
                        }

                });

            })

        }
     
    }

    ej.series3DTypes.column = ej.ej3DColumnSeries;

    //bar series
    ej.series3DTypes.bar = ej.ej3DColumnSeries;

    ej.Ej3DChart.prototype = {
        renderSeries: function (sender, series, params) {            

            var series;
            ej.Ej3DSeriesRender.prototype.chartObj = sender;
         
            $.extend(ej.Ej3DSeriesRender.prototype, ej.EjSeriesRender.prototype);
            
            var seriesRendering = new ej.Ej3DSeriesRender();
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = {"series":series};
            seriesRendering.chartObj._trigger("seriesRendering", commonEventArgs);
                var type = series.type.toLowerCase();
                var options = ej.series3DTypes[type];                
                if (ej.util.isNullOrUndefined(options)) return;
                options.draw(series, seriesRendering,type, params);
                if (series.marker.dataLabel.visible) {
                    $.each(series._visiblePoints, function (pointIndex, point) {
                        point.marker = $.extend(true, {}, series.marker, point.marker);
                       if (point.visible && (ej.util.isNullOrUndefined(point.marker) || (point.marker.dataLabel && point.marker.dataLabel.visible)))
                            seriesRendering.draw3DDataLabel(series, pointIndex, point, sender);
                    });
                }


               
 
        },
        update3DWall: function (sender, params) {
            if (sender.model.AreaType == "cartesianaxes") {
                $.extend(ej.Ej3DRender.prototype, this);
                this.updateBackWall(sender);                
                for (var i = 0; i < sender.model._axes.length; i++) {
                    var axis = sender.model._axes[i],
                        opposedPosition = axis._opposed;
                    if (axis.orientation.toLowerCase() == "vertical") {
                        if (!opposedPosition)
                            this.updateLeftWall(sender, axis, params);
                        else
                            this.updateRightWall(sender, axis, params);
                    }
                    else {
                        if (!opposedPosition)
                            this.updateBottomWall(sender, axis, params);
                        else
                            this.updateTopWall(sender, axis, params);
                    }
                }
            }                  
        },

      updateTopWall:function(sender, axis, params)
        {
        
            var offset = 0;
            var  areaBounds= sender.model.m_AreaBounds, y = params.axes[axis.name]._validCross ? axis.y : areaBounds.Y;			
            if (sender.model.wallSize < y)
                offset = y - sender.model.wallSize;
           else
                offset = -(sender.model.wallSize - y);
            var tlfVector = sender.vector.vector3D(areaBounds.X + areaBounds.Width, -sender.model.depth, y - 0.1);
            var brbVector = sender.vector.vector3D(areaBounds.X, - 0.1, offset);
            topSideWallPlans = sender.polygon.createBox(tlfVector, brbVector, this, 0, "Graphics3D", "#e2e1e1", "#e2e1e1", 0, 0.15, false, "TopWallBrush", sender.chart3D);
  
          for (var i = 0; i < topSideWallPlans.length; i++)
              sender.polygon.transform(sender.matrixobj.tilt((parseFloat)(Math.PI / 2)), topSideWallPlans[i]);
    
                  
    },

       updateRightWall:function(sender, axis, params)
        {
		   var x = params.axes[axis.name]._validCross ? axis.x : sender.model.m_AreaBounds.X+sender.model.m_AreaBounds.Width;
           var rightRect = { left: -(sender.model.depth), top: sender.model.m_AreaBounds.Y, bottom: sender.model.m_AreaBounds.Height+sender.model.m_AreaBounds.Y, right: 0 };
           var tlfVector = sender.vector.vector3D(rightRect.left, rightRect.top, x + 1.5);
           var brbVector = sender.vector.vector3D(rightRect.right, rightRect.bottom, x + sender.model.wallSize);
           rightSideWallPlans = sender.polygon.createBox(tlfVector, brbVector, sender, 0, "Graphics3D", "#e2e1e1", "#e2e1e1", 0, 0.15, false, "RightWallBrush", sender.chart3D);
           for (var i = 0; i < rightSideWallPlans.length; i++)
             sender.polygon.transform(sender.matrixobj.turn((parseFloat)(-Math.PI / 2)), rightSideWallPlans[i]);           
        },
        updateBackWall: function (sender) {
            var areaBounds = sender.model.m_AreaBounds;           
            var tlfVector = sender.vector.vector3D(areaBounds.X, areaBounds.Y, sender.model.depth == 0 ? 1.5 : sender.model.depth + sender.model.wallSize);
            var brbVector = sender.vector.vector3D((areaBounds.X + areaBounds.Width), areaBounds.Y + areaBounds.Height, sender.model.depth == 0 ? 1.5 : sender.model.depth);

            sender.polygon.createBox(tlfVector, brbVector, sender, 0, "Graphics3D", "#e2e1e1", "#e2e1e1", 0, 0.15, false, "BackWallBrush", sender.chart3D);
        },
        updateLeftWall: function (sender, axis, params) {
            var leftRect = { left: -(sender.model.depth), top: sender.model.m_AreaBounds.Y, bottom: sender.model.m_AreaBounds.Height+sender.model.m_AreaBounds.Y, right: 0 },
				offset = params.axes[axis.name]._validCross ? axis.x : sender.model.m_AreaBounds.X;
            var tlfVector = sender.vector.vector3D(leftRect.left, leftRect.top, offset - 0.1);
            var brbVector = sender.vector.vector3D(leftRect.right, leftRect.bottom, offset - sender.model.wallSize);

            leftSideWallPlans = sender.polygon.createBox(tlfVector, brbVector, this, 0, "Graphics3D", "#e2e1e1", "#e2e1e1", 0, 0.15, false, "LeftWallBrush", sender.chart3D);
            for (var i = 0; i < leftSideWallPlans.length; i++)
                sender.polygon.transform(sender.matrixobj.turn((parseFloat)(-Math.PI / 2)), leftSideWallPlans[i]);
        },
        updateBottomWall: function (sender, axis, params) {
            var areaBounds = sender.model.m_AreaBounds;
			var y = params.axes[axis.name]._validCross ? axis.y : areaBounds.Y + areaBounds.Height;
            var tlfVector = sender.vector.vector3D((areaBounds.X + areaBounds.Width), -(sender.model.depth), sender.model.wallSize + y);
            var brbVector = sender.vector.vector3D(areaBounds.X, -0.1, y + 1);

            bottomSideWallPlans = sender.polygon.createBox(brbVector, tlfVector, this, 0, "Graphics3D", "#D3D3D3", "#D3D3D3", 0, 0.15, false, "BottomWallBrush", sender.chart3D);
            for (var i = 0; i < bottomSideWallPlans.length; i++)
                sender.polygon.transform(sender.matrixobj.tilt((parseFloat)(Math.PI / 2)), bottomSideWallPlans[i]);
        }
    }

})(jQuery);
ej.EjVmlRender = function (element) {
   var doc = document;
    this.vmlNamespace = "urn:schemas-microsoft-com:vml";
    this.vmStyle = "#default#VML";
    doc.namespaces.add('v', 'urn:schemas-microsoft-com:vml');
    this.isdocmode8 = doc.documentMode === 8;
    if (!doc.getElementById("vml_chart")) {
        var cssText
        if (this.isdocmode8) {
            cssText =
                    'v\\:fill, v\\:path, v\\:polyline, v\\:line, v\\:rect,v\\:shape,v\\:oval, v\\:stroke' +
                    '{ behavior:url(#default#VML); display: inline-block; } ';
        }
        else {
            cssText =
               'v\\:*' +
               '{ behavior:url(#default#VML); display: inline-block; } ';
        }
        var vmlStyleSheet = doc.createStyleSheet();
        vmlStyleSheet.owningElement.id = 'vml_chart';
        vmlStyleSheet.cssText = cssText;
    }
    this._rootId = jQuery(element).attr("id");
    this.svgObj = doc.createElement("div");
    this.svgObj.style.position = 'relative';
    this.svgObj.setAttribute('id', this._rootId + '_vml');   
    this.changeOptions = {'id':'id',
        'fill': 'fillcolor', 'stroke': 'strokecolor', 'stroke-width': 'strokeweight', 'd': 'path', 'font-size': 'font-size', 'font-family': 'font-family', 'font-style': 'font-style',
        'font-weight': 'font-weight', 'points':'points'

        };
};
(function($) {
ej.EjVmlRender.prototype = {
  
    drawPath: function (options, element) {
        var darray= options.d.split(" ");
        if($.inArray('A', darray) != -1)
        {
            var w = parseFloat(darray[4]);
            var h = parseFloat(darray[5]);
            options.d=this.drawArc(w, h, options);
        }
        if ($("#" + options.id).length > 0) {
            options.d = this.changePathValue(options.d);
            this.applyVMLStyle($("#" + options.id), options);
        }
        else {
            options.d = this.changePathValue(options.d);
            var shape = document.createElement("v:shape");
            var $shapeEle = $(shape);
            this.applyVMLStyle($shapeEle, options);
            $shapeEle.appendTo(element);
        }
    },
    createLegendSvg:function(element)
    {
        var doc = document;        
        this._rootId = jQuery(element).attr("id");
        this.legendsvgObj = doc.createElement("div");
        this.legendsvgObj.style.position = 'relative';
        this.legendsvgObj.setAttribute('id',"legend_"+ this._rootId + '_vml');       
        return this.legendsvgObj;
    },

    drawPolyline: function (options, element) {
        var darray = options.points.split(" ");
        
        if ($("#" + options.id).length > 0) {
            options.points = this.changePathValue(options.points);
            this.applyVMLStyle($("#" + options.id), options);
        }
        else {
            options.points = this.changePathValue(options.points);
            var shape = document.createElement("v:polyline");
            var $shapeEle = $(shape);
            this.applyVMLStyle($shapeEle, options);
            $shapeEle.appendTo(element);
        }
    },
    setFillAttribute: function (element, options) {
        var fill = document.createElement("v:fill");
        var opacity = options["fill-opacity"] ? options["fill-opacity"] : options["opacity"];
        opacity = (!ej.util.isNullOrUndefined(opacity)) ? opacity : (options["opacity"]) ? options["opacity"] : 1;
        var fillcolor = options["fill"];
        if (fillcolor != "none" && !ej.util.isNullOrUndefined(fillcolor)) {
          
            if (!(fillcolor).match('gradient'))
                $(element).attr("fillcolor", fillcolor);
            else {
                var colorName = ((fillcolor).replace('gradient', ""));
                fill.setAttribute('type', "gradient");
                fill.setAttribute("colors", colorName);
            }
        }
        else if(fillcolor=='none'){
            fill.setAttribute('type',"gradient");
            fill.setAttribute('color',options.color);
            fill.setAttribute('color2',options.color2);
            fill.setAttribute('colors',options.colors);
            fill.setAttribute('angle', options.angle);
            opacity = options.fill_opacity;
        }
        else 
            opacity = 0.1;
        
        
        fill.setAttribute('opacity', opacity);
        $(fill).appendTo(element);
    },
    setStrokeAttribute: function (element, options) {
        var stroke = options['stroke'];
        if (stroke == "transparent") 
            options['opacity'] = 0.1;
        if (options.name) {
            $(element).attr('name', options.name);
        }
         
         
        var opacity = options["opacity"];
        if (opacity) {
            var fill = document.createElement("v:stroke");

           

            fill.setAttribute('opacity', opacity);
            $(fill).appendTo(element);
        }
    },
    changePathValue: function (options) {
        if (!options["d"]) {
            var pathArray = options.split(" ");
            for (var i = 0; i < pathArray.length; i++) {
                var matches = pathArray[i].match(/\d+/g);
                if (matches != null) {
                    pathArray[i] = Math.round(parseFloat(pathArray[i]));
                }
            }
            options = pathArray.join(' ');
            return options;
        }
    },


    drawArc: function ( w, h, options) {
    var x = 0, y = 0;
    var startAngle = options.start,
    endAngle =options.end,
    endAngle = (Number(Math.PI.toFixed(2)) == Number((endAngle + startAngle).toFixed(2))) ? endAngle - 0.01 : endAngle,
    radius = options.r || w || h,
    cosStart = Math.cos(startAngle),
    sinStart = Math.sin(startAngle),
    cosEnd = Math.cos(endAngle),
    sinEnd = Math.sin(endAngle),
    innerRadius = options.innerR,
    circleCorrection = 0.08 / radius, 
    innerCorrection = (innerRadius && 0.1 / innerRadius) || 0,
    path;

    if (endAngle - startAngle === 0) {
            return '';

    } else if (2 * Math.PI - endAngle + startAngle < circleCorrection) {
            cosEnd = -circleCorrection;
    } else if (endAngle - startAngle < innerCorrection) {
            cosEnd = Math.cos(startAngle + innerCorrection);
        }

        path = [
    'wa', // To draw clockwise arc
    x - radius, 
    y - radius, 
    x + radius, 
    y + radius, 
    x + radius * cosStart, 
    y + radius * sinStart, 
    x + radius * cosEnd, 
    y + radius * sinEnd  
        ];

        if (options.open && !innerRadius) {
            path.push(
        'e',
        M,
        x, 
        y
    );
        }

        path.push(
            // To draw anti clockwise arc
    'at', 
    x - innerRadius, 
    y - innerRadius, 
    x + innerRadius, 
    y + innerRadius, 
    x + innerRadius * cosEnd, 
    y + innerRadius * sinEnd, 
    x + innerRadius * cosStart, 
    y + innerRadius * sinStart, 
    'x', 
    'e' 
);
        path=path.join(" ");
        return path;

  },
    changeVMLStyle: function ($element, options) {
        var chart = this;
		var strokeColor = options.stroke;
        $element.css("width", options.width).css("visibility", options.visibility).css("height", options.height).css("position", "absolute").css('left', options.x).css('top', options.y);
        $.each(options, function (index, val) {
            if (chart.changeOptions[index] != null || chart.changeOptions[index] != undefined) {
                if (index == 'd' || index=='points') {
                    val = chart.changePathValue(options[index]).toLowerCase();
                }
                if (val == 'transparent' && !options.fill_opacity) {
                    options[index] = val = 'white';
                     if(index=="fill" && (!options.hasOwnProperty('opacity') ||  !options['opacity'])) 
                       options['opacity'] = 0.1;                  
                }
                if (options.fill_opacity) {
                    options['opacity'] = options.fill_opacity;
                }
                if ($element[0].tagName === "SPAN") {
                    if (index == "fill") $element.css('color', val);
                    else {
                        if (index == "id") $element.attr(chart.changeOptions[index], val);
                        else
                            $element.css(chart.changeOptions[index], val);
                    }
                }else {

                    if (chart.isdocmode8) { // IE8 setAttribute bug
                        $element.get(0)[chart.changeOptions[index]] = val;
                    } else {
                        $element.get(0).setAttribute(chart.changeOptions[index], val);
                    }      
                }
            }
        });
        if (options.hasOwnProperty('fill-opacity') || options.hasOwnProperty('opacity') || options.hasOwnProperty('fill'))
            if (!($element[0].tagName === "SPAN")) {
                chart.setFillAttribute($element, options);
               if (options.hasOwnProperty('stroke')) {
                    options.stroke = strokeColor;
                   if (options.fill_opacity) {
                       options['opacity'] = options.fill_opacity;
                   }
                    chart.setStrokeAttribute($element, options);
                }
            }
    },
    applyVMLStyle: function ($element, options) {
        
        if ($element[0].tagName !== "SPAN") {
            if (ej.util.isNullOrUndefined(options.width)) options.width = "1000px";
            if (ej.util.isNullOrUndefined(options.height)) options.height = "1000px";
        }
        if (ej.util.isNullOrUndefined(options.x)) options.x = "0px";
        if (ej.util.isNullOrUndefined(options.y)) options.y = "0px";

        this.changeVMLStyle($element, options);
    },
    drawLine: function (options, element) {
        if ($("#" + options.id).length > 0) {
            var from = (options.x1) + ',' + (options.y1);
            var to = (options.x2) + ',' + (options.y2);
            $(options).attr("from", from).attr("to", to);
            this.applyVMLStyle($("#" + options.id), options);
        }
        else {
            var line = document.createElement("v:line");
            var $lineEle = $(line);
            var from = (options.x1) + ',' + (options.y1);
            var to = (options.x2) + ',' + (options.y2);
            $lineEle.attr("from", from).attr("to", to);
            this.applyVMLStyle($lineEle, options);
            $lineEle.appendTo(element);
        }
     },
    //drawPolygon: function (options, element) {
     
    //},
     drawCircle: function (options, element) {
         if ($("#" + options.id).length > 0) {
             options.x = options.cx - options.r;
             options.y = options.cy - options.r;
             options.width = options.height = (2 * options.r);
             this.applyVMLStyle($("#" + options.id), options);
         }
         else {
             var circle = document.createElement("v:oval");
             var $circleEle = $(circle);
             options.x = options.cx - options.r;
             options.y = options.cy - options.r;
             options.width = options.height = (2 * options.r);
             this.applyVMLStyle($circleEle, options);
             if ($("#" + options.id).length == 0)
             $circleEle.appendTo(element);
         }
     },
    
   drawEllipse: function (options, element) {
       if ($("#" + options.id).length > 0) {
           options.x = options.cx - options.rx;
           options.y = options.cy - options.ry;
           options.width = (2 * options.rx);
           options.height = (2 * options.ry);
           this.applyVMLStyle($("#" + options.id), options);
       }
       else {
           var ellipse = document.createElement("v:oval");
           var $ellipseEle = $(ellipse);
           options.x = options.cx - options.rx;
           options.y = options.cy - options.ry;
           options.width = (2 * options.rx);
           options.height = (2 * options.ry);
           this.applyVMLStyle($ellipseEle, options);
           $ellipseEle.appendTo(element);
       }
    },
    drawRect: function (options, element) {
        if ($("#" + options.id).length > 0) {
            this.applyVMLStyle($("#" + options.id), options);
        } else {
            var rect = document.createElement("v:rect");
            var $rectEle = $(rect);
            this.applyVMLStyle($rectEle, options);
            $rectEle.appendTo(element);
        }
    },
    drawCylinder: function (options, element, seriesOption) {
        var x = options.x, y = options.y, w = options.width, h = options.height, id = options.id, angle, path, rx, ry, cx2, cx1, cy1, X1, Y1, LX1, LY1, LX2, LY2, cy2, sa, ea, sa2, ea2, X, Y, cx, cy, LX, LY;
        var gradientColor = options.fill;
        var format = ej.EjSvgRender.prototype.checkColorFormat(gradientColor);
        if (!format)
        var gradientColor = ej.datavisualization.Chart.prototype.colorNameToHex(options.fill);
        var opacity = options.opacity, obj = { svgRenderer: ej.EjSvgRender.prototype }, colorz = ej.Ej3DRender.prototype.polygon3D.prototype.applyZLight(gradientColor, obj), colorx = ej.Ej3DRender.prototype.polygon3D.prototype.applyXLight(gradientColor, obj);
        var angleConvertor = 65535; // VML measures angles in degrees/65535
        if (seriesOption.isColumn == true) {
            options.rx =rx= w / 2;
            options.ry =ry= rx / 4;
            cx2 = cx1 = x + rx;
            Y1 = cy1 = (y - ry);
            LY2 = Y = cy2 = y + h - ry;
            LX1 = cx2 + rx;
            X1 = LX2 = X = cx2 - rx;
            sa1 = -Math.round(angleConvertor * 180);
            ea1 = Math.round(angleConvertor *180);
            sa2 = Math.round(angleConvertor * 360);
            ea2 = -Math.round(angleConvertor * 180);
            gradientAngle="90";
            if (seriesOption.stacking == true) {
                if (!seriesOption.isLastSeries) {
                    cy1 = y + ry;
                }
            }
            LY1 = cy1;
        }
        else {
            options.ry = ry = h / 2;
            options.rx = rx = ry / 4;
            LX1 = X1 = cx1 = x + rx;
            X = cx2 = x + w + rx;
            sa1 = Math.round(angleConvertor * 90); ea1 = Math.round(angleConvertor * 180);
            sa2 = Math.round(angleConvertor * 270);
            ea2 = -Math.round(angleConvertor * 180);
            cy2 = cy1 = y + ry;
            Y = LY1 = cy1 + ry;
            Y1 = LY2 = cy2 - ry;
            gradientAngle="0";
            if (seriesOption.stacking == true) {
                if (!seriesOption.isLastSeries) {
                    cx2 = x+w-rx;
                }
            }
            LX2 = cx2;
        }
        delete options.x;
        delete options.y;
        options.width = 1000;
        options.x = 0;
        options.y = 0;
        delete options.stacking;
        options.height = 1000;
        delete options.isColumn;
        options.fill = colorz;
        options.fill_opacity = opacity;
        options.stroke = colorz;
        options['stroke-width'] = 0;
        for (i = 1; i <= 4; i++) {
           
            if (i % 2 == 0) {
                cx = cx1;
                cy = cy1; LX = LX2; LY = LY2; sa = sa2; ea = ea2;

            }
            else {
                cx = cx2; cy = cy2; LX = LX1; LY = LY1; sa = sa1; ea = ea1;
            }
            if (i < 3) {
                sa= angleConvertor;
                ea = 23592600;
            }
            if (i < 4) {
                path = [
  'M',
Math.round(X),
Math.round(Y)
                ];
            }
            path.push(

 'ae',
Math.round(cx),
Math.round(cy),
Math.round(rx),
Math.round(ry),
sa,
ea
);
            if (i > 2) {
                path.push(

   'l',
   Math.round(LX),
   Math.round(LY)
);
                options.fill = "none";
                options.color = gradientColor;
                options.color2 = gradientColor;
                options.colors = ("30% " + colorx + "," + "70% " + colorx);
                options.angle = gradientAngle;
            }
            if (i != 3) {
                path.push(
        'e'
    );
                path = path.join(" ");
                options.d = path;
                options.id = id + "_" + "Region_" + (i - 1).toString();
                if (i == 4)
                options.id = id + "_" + "Region_" + (i - 2).toString();
                var shape = document.createElement("v:shape");
                var $shape = $(shape);
                this.applyVMLStyle($shape, options);
                $shape.appendTo(element);
            }
            X = X1; Y = Y1;
        }    
    },
    _getAttrVal: function (ele, val, option) {
          val = (val == "x") ? "left" : val;
        val = (val == "y") ? "top" : val;
        var value1 = $(ele).attr(val);
        var value = value1 ? value1 : ($(ele).css(val));
        
        if (value != null)
            return value;
        else
            return option;
    },
    _setAttr: function (element, attribute) { 
        if (attribute.transform) {
		  var attrTrans=attribute.transform;
            var trans = attrTrans.slice(attrTrans.indexOf('(') + 1, attrTrans.indexOf(')')).split(',');
            attribute.x = trans[0];
            attribute.y = trans[1];
        }
        var $ele = $(element);
        if($ele.length>0)
            this.changeVMLStyle($ele, attribute);
    },
    createGradientElement: function (name, colors) {
        var colorName;
       
        if (Object.prototype.toString.call(colors) == '[object Array]') {
            colorName = "gradient" + " ";
            var appendString = "";
            for (var j = 0, i=colors.length-1 ; i>=0, j < colors.length ; j++,i--){
                colorName += appendString + colors[j]["colorStop"] + " " + colors[i]["color"];
                appendString = ",";
            }
        }
        else {
            colorName = colors;
        }
        return colorName; 
    },

    setSpanAttr: function (options, label, element) {
	    var fontSize = (options["font-size"] > 0) ? (options["font-size"] + "px") : options["font-size"];
        var font = { size: fontSize, fontStyle: options["font-style"], fontFamily: options["font-family"] };
        var bounds = ej.EjSvgRender.utils._measureText(label, null, font);
        
            $(element).css("white-space", "nowrap");
        
        if (options["text-anchor"] === "middle")
            options.x = Math.round(options.x - bounds.width / 2);
        else if (options["text-anchor"] === "end")
            options.x = Math.round(options.x - bounds.width);
        options.y = Math.round(options.y -( font.size.replace("px","")));
        this.applyVMLStyle(element, options);
        
       
    },
    drawText: function (options, label, groupEle,font) {
        var textDoc = document;
        var $Ele = $("#" + options.id);
        if ($Ele.length > 0) {
            this._textAttrReplace(options, label, font, $Ele);
        }
        else if (options.id.indexOf("YAxisTitle") > 0 && !this.isdocmode8) {
            options.on = true;
            var line = document.createElement("v:line");
            line.style.behavior = "url(#default#VML)";
            line.style.display = "inline-block";
            var bounds = ej.EjSvgRender.utils._measureText(label, null, null);
             
            line.setAttribute("to", (options.x - 1).toString() + "," + (options.y - bounds.width / 2).toString());
            line.setAttribute("from", (options.x).toString() + "," + options.y.toString());
           
            var path =  document.createElement("v:path");
            path.setAttribute("textpathok", true);
            var textpath =  document.createElement("v:textpath");
            textpath.setAttribute("on", true);
            textpath.setAttribute("string", label);
       
          textpath.style["font-style"] = options["font-style"];
          textpath.style["font-size"] = options["font-size"];
          textpath.style["font-family"] = options["font-family"];         
          line.appendChild(path);
          line.appendChild(textpath);           
          $(line).appendTo(groupEle);
        }
        else {
            var span = textDoc.createElement("span");
            var $spanEle = $(span);
            if (jQuery.type(label) == "array") {
                this.setSpanAttr(options, label, $spanEle);
                for (var i = 0; i < label.length; i++) {
                    var textspan = textDoc.createElement("span");
                    $(textspan).html(label[i]);                
                    $(textspan).appendTo(span);
                    var brtag = textDoc.createElement("br");
                    $(brtag).appendTo(span);
                    
                }
            } else {
                this.setSpanAttr(options, label, $spanEle);
                $spanEle.html(label);
            }         
            $spanEle.appendTo(groupEle);          
        }
    },
    //text element attributes values are replaced 
    _textAttrReplace: function (options, label, font, $Ele) {
        if (jQuery.type(label) == "array") {
            var elements = $("#" + options.id).children("span");
            this.setSpanAttr(options, label, $Ele);
            if (elements.length > 0 && elements.length == label.length) {
                for (var i = 0; i < elements.length; i++) {
                    var element = elements[i];
                    $(element).text(label[i]);
                }
            }
            else {
                $("#" + options.id).remove();
                this.drawText(options, label, this.gTransToolEle, font);

            }
        } else {
            this.setSpanAttr(options, label, $Ele);
            $Ele.text(label);
        }

    },

   drawImage: function (options, element) {
        var imgElement = document.createElement("img");
        var $imgElement = $(imgElement);
          $imgElement.css({ 'position': 'absolute' });
          $.each(options, function (index, val) {
              if (index == "href") index = "src";
                $imgElement.attr(index, val);
        });
        $imgElement.appendTo(element);
       
    },

    createDefs: function () {
        
    },

    //createClipPath: function (options) {
        
    //},
    //createForeignObject: function (options) {
      
    //},
    createGroup: function (options) {
        var group = document.createElement("div");
        if (!ej.util.isNullOrUndefined(options.transform)) {
            var trans = options.transform.slice(options.transform.indexOf('(') + 1, options.transform.indexOf(')')).split(',');
            $(group).css({ 'position': 'absolute', 'left': trans[0] + 'px', 'top': trans[1] + 'px' });
        }
		 if (options.cursor) 
            $(group).css({ 'cursor': options.cursor });
        
        $.each(options, function(index, val) {
            if (index !== 'transform' && index !="clip-path")
                $(group).attr(index, val);
        });
      
        return group;
    },

    createText: function (options, label) {
        var text = document.createElement("span");
        $(text).attr(options);
        if (!ej.util.isNullOrUndefined(label))
            text.textContent = label;
        return text;
        
        
    },   
   
    //Draw clip path for each series to avoid series overlap in multiple axes zooming
    drawAxesBoundsClipPath: function (gSeriesGroupEle, options, invertedAxis) {
        var clipOptions;
        var element = $(gSeriesGroupEle);
        element.removeAttr("clip-path");
        var trans = this._getTransform(options.xAxis, options.yAxis, invertedAxis);
        clipOptions = {
            'id': gSeriesGroupEle.id + '_ClipRect',
            'x': 0,
            'y': 0,
            'width': (trans.width),
            'height': (trans.height),
            'fill': 'white',
            'stroke-width': 1,
            'stroke': 'transparent'
        };
        this.drawClipPath(clipOptions, gSeriesGroupEle);
        element.attr('clip-path', 'url(#' + clipOptions.id + ')');

    },
   
    getAttrVal: function (ele, val, option) {
        var value = $(ele).attr(val);
        if (value != null)
            return value;
        else
            return option;
    },
   
    round: function (value, div, up) {

        return div * (up ? Math.ceil(value / div) : Math.floor(value / div));
    },
    
   
   
    
    hexFromRGB: function (color) {
        var r = color.R;
        var g = color.G;
        var b = color.B;
        if (color.A) {
            var returncolor = "rgba(" + r.toString() + "," + g.toString() + "," + b.toString() + "," + color.A + ")";
            return returncolor;
        }
        else {
            var r = color.R;
            var g = color.G;
            var b = color.B;
            var hex = [r.toString(16), g.toString(16), b.toString(16)];
            $.each(hex, function (nr, val) { if (val.length === 1) { hex[nr] = "0" + val; } });
            return "#" + hex.join("").toUpperCase();
        }
    },
    hexToRGB: function (hex) {
        var rgbRegex = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/.test(hex);
        var result;
        if (rgbRegex == true) {
            result = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/.exec(hex);
            return result ? {
                R: parseInt(result[1]),
                G: parseInt(result[2]),
                B: parseInt(result[3]),
                A: result[4],
            } : null;
        }
        else {
            var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                R: parseInt(result[1], 16),
                G: parseInt(result[2], 16),
                B: parseInt(result[3], 16)
            } : null;
        }
    },
    checkColorFormat: function (color) {
        return /(rgba?\((?:\d{1,3}[,\)]){3}(?:\d+\.\d+\))?)|(^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$)/gmi.test(color);
    },
    createDelegate: function (context, handler) {
        return function (e) {
            handler.apply(context, [e, this]);
        };
    },

    drawClipPath: function (options, element) {
        if (options.id.indexOf("ChartAreaClipRect") == -1) {
            var left = Math.round(options.x)+'px';
            var top = Math.round(options.y)+'px';
            var right = Math.round(options.width) + Math.round(options.x) + 'px';
            var bottom = Math.round(options.y)+ Math.round(options.height) + 'px';
            var cssClip = 'rect(' + top + ' ' + right + ' ' + bottom + ' ' +left + ')';
            $(element).css("position", "absolute").css('clip',cssClip);
        }
    },

    drawCircularClipPath: function (options, element) {
        var radius = Math.round(options.r);
        var x = Math.round(options.cx);
        var y = Math.round(options.cy);
        if (options.id.indexOf("_ClipRect") == -1) {
            var left = (x - radius) + 'px';
            var top = (y - radius) + 'px';
            var right = (x + radius) + 'px';
            var bottom = (y + radius) + 'px';
            var cssClip = 'rect(' + top + ' ' + right + ' ' + bottom + ' ' + left + ')';
            $(element).css("position", "absolute").css('clip', cssClip);
        }
    },
   
    append: function (childEle, parentEle) {
        $(childEle).appendTo(parentEle);
    }
};
})(jQuery);;
ej.EjCanvasRender = function (element) {
    this.svgObj = document.createElement('canvas');
    this._rootId = jQuery(element).attr("id");
    this.svgObj.setAttribute('id', this._rootId + '_canvas');
    this.ctx = this.svgObj.getContext("2d");
    
};
(function ($) {
    ej.EjCanvasRender.prototype = {

        drawPath: function (options, element, canvasTranslate) {
            var hasStackingInnerRadius = options.hasStackingInnerRadius ? options.hasStackingInnerRadius : false;
            var path = options.d;
            var dataSplit = path.split(" ");
            var borderWidth = options["stroke-width"];
            if (!options.lgndCtx) {
                var canvasCtx = this.ctx;
                this.ctx = element != undefined ? element : this.ctx;
                this.ctx.save();
                this.ctx.beginPath();
                if (canvasTranslate) this.ctx.translate(canvasTranslate[0], canvasTranslate[1]);
                this.ctx.globalAlpha = options.opacity ? options.opacity : options["fill-opacity"];
                var flag = true;
                this.ctx.lineWidth = borderWidth;
				var dashArray = options["stroke-dasharray"] ? options["stroke-dasharray"].split(",") : false;
                if (dashArray) this.ctx.setLineDash(dashArray);
                this.ctx.strokeStyle = options.stroke;
                for (var i = 0; i < dataSplit.length; i = i + 3) {
                    var x1 = parseFloat(dataSplit[i + 1]);
                    var y1 = parseFloat(dataSplit[i + 2]);
                    switch (dataSplit[i]) {
                        case "M":
                            if ((!options.innerR|| hasStackingInnerRadius) && !options.cx)
                                this.ctx.moveTo(x1, y1);
                            break;
                        case "L":
                            if (!options.innerR || hasStackingInnerRadius)
                                this.ctx.lineTo(x1, y1);
                            break;
                        case "C":
                            this.ctx.bezierCurveTo(x1, y1, parseFloat(dataSplit[i + 3]), parseFloat(dataSplit[i + 4]), parseFloat(dataSplit[i + 5]), parseFloat(dataSplit[i + 6]));
                            i = i + 4;
                            break;
                        case "A":
                            if (!options.innerR) {
							    if (options.cx) {
                                    this.ctx.arc(options.cx, options.cy, options.radius, 0, 2 * Math.PI, options.counterClockWise);
                               }
								else{
                                    this.ctx.moveTo(options.x, options.y);
                                    this.ctx.arc(options.x, options.y, options.radius, options.start, options.end, options.counterClockWise);
                                    this.ctx.lineTo(options.x, options.y);
								}
                            }
                            else if (flag) {
                                this.ctx.arc(options.x, options.y, options.radius, options.start, options.end, options.counterClockWise);
                                this.ctx.arc(options.x, options.y, options.innerR, options.end, options.start, !options.counterClockWise);
                                flag = false; 
                            }
                            i = i + 5;
                            break;
						case "Q":
							this.ctx.bezierCurveTo(x1, y1, parseFloat(dataSplit[i+1]), parseFloat(dataSplit[i + 2]), parseFloat(dataSplit[i + 3]), parseFloat(dataSplit[i + 4]));
							i = i + 2;
							break;
					    case "z":
                            this.ctx.closePath();
                            break;
                    }
                }
                if (options.fill != "none" && options.fill != undefined) {
                    this.ctx.fillStyle = options.fill;
                    this.ctx.fill();
                }
                if (borderWidth > 0)
                    this.ctx.stroke();
                this.ctx.restore();
                this.ctx = canvasCtx;
            } else {
                var legendCtx = this.lgndCtx;
                this.lgndCtx = element != undefined ? element : this.lgndCtx;
                this.lgndCtx.save();
                this.lgndCtx.beginPath();
                if (canvasTranslate) this.lgndCtx.translate(canvasTranslate[0], canvasTranslate[1]);
                this.lgndCtx.globalAlpha = options.opacity ? options.opacity : options["fill-opacity"];

                this.lgndCtx.lineWidth = options["stroke-width"];
                this.lgndCtx.strokeStyle = options.stroke;
                for (var i = 0; i < dataSplit.length; i = i + 3) {
                    var x1 = parseFloat(dataSplit[i + 1]);
                    var y1 = parseFloat(dataSplit[i + 2]);
                    switch (dataSplit[i]) {
                        case "M":
                            this.lgndCtx.moveTo(x1, y1);
                            break;
                        case "L":
                            this.lgndCtx.lineTo(x1, y1);
                            break;
                        case "C":
                            this.lgndCtx.bezierCurveTo(x1, y1, parseFloat(dataSplit[i + 3]), parseFloat(dataSplit[i + 4]), parseFloat(dataSplit[i + 5]), parseFloat(dataSplit[i + 6]));
                            i = i + 4;
                            break;
                        case "A":
                            this.lgndCtx.arc(parseFloat(dataSplit[i - 5]), parseFloat(dataSplit[i - 4]), x1, 0, 2 * Math.PI, false);
                            i = i + 5;
                            break;
							case "a":
                            this.lgndCtx.beginPath();
                            var centerX = parseFloat(dataSplit[i - 2]) + x1;
                            var centerY = dataSplit[i - 1];
                            this.lgndCtx.arc(centerX, centerY, x1, 0, 2 * Math.PI, false);
                            i = i + 5;
                            break;
                        case "Z":
                            this.lgndCtx.fillStyle = options.fill;
                            this.lgndCtx.fill();
                            i = i - 2;
                            break;
					    case "Q":
                            this.lgndCtx.quadraticCurveTo(x1, y1, parseFloat(dataSplit[i + 3]), parseFloat(dataSplit[i + 4]));
                            i = i + 2;
                            break;
                    }
                }
                if (options.fill != "none" && options.fill != undefined) {
                    this.lgndCtx.fillStyle = options.fill;
                    this.lgndCtx.fill();
                }
                this.lgndCtx.stroke();
                this.lgndCtx.restore();
                this.lgndCtx = legendCtx;
            }
        },
        
       
        drawRect: function (options, element) {
            var canvasCtx = this.ctx, cornerRadius = options.rx;
            this.ctx = element ? (element.canvas ? element : this.ctx ) : this.ctx;
            this.ctx.save();
            this.ctx.beginPath();
            this.ctx.globalAlpha = options.opacity;
            this.ctx.lineWidth = options["stroke-width"];
            dashArray = options["stroke-dasharray"] ? options["stroke-dasharray"].split(",") : false;
            if (dashArray) this.ctx.setLineDash(dashArray);
            this.ctx.strokeStyle = options.stroke;
            this.ctx.rect(options.x, options.y, options.width, options.height);
            if (cornerRadius != null && cornerRadius >= 0) {
                this.drawCornerRadius(options);
            }
            else {
                if (options.fill == "none") options.fill = "transparent";
                this.ctx.fillStyle = options.fill;
                this.ctx.fillRect(options.x, options.y, options.width, options.height);
                this.ctx.stroke();
             }
            if(options.id.indexOf("Series") >= 0)
            this.ctx.clip();
	        this.ctx.restore();
            this.ctx = canvasCtx;
        },
        drawCylinder: function (options, element, seriesOption) {
            var canvasCtx = this.ctx;
            this.ctx = element ? (element.canvas ? element : this.ctx) : this.ctx;
            this.ctx.save();
            var grad = ej.datavisualization.Chart.prototype.colorNameToHex(options.fill);
            var obj = { svgRenderer: ej.EjSvgRender.prototype };
            'use strict';
            var i, xPos, yPos, pi = Math.PI, twoPi = 2 * pi + 0.1, rx, ry, cx1, cx2, cy1, cy2, x1, x2, y1, y2, cx, cy, xl, yl, step, ini, gx1, gy2, gx2, gy1,rxt,ryt;
            var x = options.x, y = options.y, w = options.width, h = options.height, a=twoPi;
            this.ctx.fillStyle = ej.Ej3DRender.prototype.polygon3D.prototype.applyZLight(grad, obj)
            this.ctx.lineWidth = 0;
            this.ctx.strokeStyle = ej.Ej3DRender.prototype.polygon3D.prototype.applyZLight(grad, obj);
            this.ctx.globalAlpha = options.opacity;
            if (seriesOption.isColumn == true) {
                gx1 = x;
                gx2 = w + x;
                gy1=gy2 = 0;
                rx = w / 2;
                ry = rx / 4;
                cx2 = cx1 = x + rx;
                y2 = cy1 = y - ry;
                x2 = x;
                    x1 = x + w;
                cy2 = y1 = y + h - ry;
                ini = 0;
                step = pi;
                rxt = -rx;
                ryt = ry;
                if (seriesOption.stacking = true) {
                    if (!seriesOption.isLastSeries) {
                         y2 = cy1 = y + ry;
                        
                    }
                }

            }
            else {
                gx1=gx2 = 0;
                gy2 = h + y;
                gy1 = y;
                ry = h / 2;
                rx = ry / 4;
                x2 = cx1 = x + rx;
                x1= cx2 = x + w + rx;
                y1 = y+h;
                y2 = y;
                cy2 = cy1 = y + ry;
                ini = pi / 2;
                step = pi * 1.5; 
                if (seriesOption.stacking = true) {
                    if (!seriesOption.isLastSeries) {
                        x1 = cx2 = x + w - rx;
                    }
                }
                ry = -ry;
                rx = -rx;
                rxt = rx;
                ryt = -ry;
            }
            var color=ej.Ej3DRender.prototype.polygon3D.prototype.applyXLight(grad, obj);
            var grd = this.ctx.createLinearGradient(gx1, gy1, gx2, gy2);
            grd.addColorStop(0, grad);
            grd.addColorStop(0.3, color);
            grd.addColorStop(0.7,color);
            grd.addColorStop(1, grad);
            
            for (j = 1; j <= 4; j++) {
                var i = 0;
                    j < 4 ? this.ctx.beginPath() : "";
                    if (j % 2 == 0) {
                        cx = cx2; cy = cy2; xl = x2; yl = y2;
                    }
                    else {
                        cx = cx1; cy = cy1; xl = x1; yl = y1;
                    }
                    if (j == 4)
                    {
                        rx = rxt;
                        ry = ryt;
                        this.ctx.fillStyle = grd;
                    }
                    if (j > 2) {
                        i = ini;
                        a = step;
                    }
                    for (; i <= a; i += 0.1) {
                        xPos = cx - (rx * Math.cos(i));
                        yPos = cy + (ry * Math.sin(i));

                        if (i === 0) {
                            this.ctx.moveTo(xPos, yPos);
                        } else {
                            this.ctx.lineTo(xPos, yPos);
                        }
                    }
                    
                    if (j > 2) {
                        
                            this.ctx.lineTo(xl,yl);
                        }
                    if (j != 3) {
                       
                            this.ctx.stroke();
                            this.ctx.fill();
                        }
                }
          
            if (options.id.indexOf("Series") >= 0)
                this.ctx.clip();
            this.ctx.restore();
            this.ctx = canvasCtx;
        },
        drawCornerRadius: function (options) {
            var cornerRadius = options.rx, x = options.x, y = options.y, width = options.width, height = options.height;
            if (options.fill == "none") options.fill = "transparent";
            this.ctx.fillStyle = options.fill;
            if (width < 2 * cornerRadius) cornerRadius = width / 2;
            if (height < 2 * cornerRadius) cornerRadius = height / 2;
            this.ctx.beginPath();
            this.ctx.moveTo(x + width - cornerRadius, y);
            this.ctx.arcTo(x + width, y, x + width, y + height, cornerRadius);
            this.ctx.arcTo(x + width, y + height, x, y + height, cornerRadius);
            this.ctx.arcTo(x, y + height, x, y, cornerRadius);
            this.ctx.arcTo(x, y, x + width, y, cornerRadius);
            this.ctx.closePath();
            this.ctx.fill();
            this.ctx.stroke();
        },

        createGradientElement: function (name, colors) {
            var colorName;
            var ctx = this.ctx;
            if (Object.prototype.toString.call(colors) == '[object Array]') {
                var my_gradient = ctx.createLinearGradient(0, 0, 0, this.svgObj.height);
             
                for (var i = 0; i <= colors.length - 1 ; i++) {
                    var color = colors[i].color;
                    var colorStop = (colors[i].colorStop).slice(0, -1);
                    colorStop = parseInt(colorStop) / 100;
                    my_gradient.addColorStop(colorStop, color);
                    
                }
                colorName = my_gradient;
            }
            else {
                colorName = colors;
            }
            return colorName;
        },
        drawLine: function (options) {
            this.ctx.save();
            this.ctx.beginPath();
			this.ctx.lineWidth = options["stroke-width"];
            this.ctx.strokeStyle = options.stroke;
            this.ctx.moveTo(options.x1, options.y1);
            this.ctx.lineTo(options.x2, options.y2);
            this.ctx.stroke();
            this.ctx.restore();
        },
        drawText: function (options, label) {
            if (!ej.util.isNullOrUndefined(options["font-weight"]) && options["font-weight"].toLowerCase() == "regular")
                options["font-weight"] = "normal";
            var font = (options["font-style"].toLowerCase() + " " + options["font-weight"] + " " + options["font-size"] + " " + options["font-family"]);
            // text-anchor
            var anchor = options["text-anchor"];
            var opacity = options["opacity"] !== undefined ? options["opacity"] : 1;
            if (anchor == "middle")
                anchor = "center";
            if (!options.lgndCtx) {
                this.ctx.save();
                this.ctx.fillStyle = options.fill;                
                this.ctx.font = font;                
                this.ctx.textAlign = anchor;
                this.ctx.globalAlpha = opacity;
                if (options.baseline)
                    this.ctx.textBaseline = options.baseline;
                // dominant-baseline
                //if (options["dominant-baseline"] == "middle")
                    //this.ctx.textBaseline = "center";
                if (!options.labelRotation) {
                    if (typeof label == "object" && options.isTrackball) {
                        var len = label.length;
                        for (var i = 0; i < len; i++) {
                            this.ctx.fillText(label[i], options.x, options.y + (Number(parseInt(options["font-size"])) + options.padding) * i);
                        }
                    }
                    else {
                        this.ctx.fillText(label, options.x, options.y);
                    }
                } else {
                    var txtlngth = 0, rotation = options.labelRotation;
                    if ((rotation) && options.id.indexOf("XLabel") != -1) {
                        var rotate = 'rotate(' + options.labelRotation.toString() + 'deg)';
                        $(options).attr('rotateAngle', rotate);
                        var textElement = this.createText(options, label);
                        $(document.body).append(textElement);
                        var box = textElement.getBoundingClientRect();
                        $(textElement).remove();
                        txtlngth = box.height;
                        if (rotation < 0) {
                            rotation = 360 + rotation;
                        }
                        var str = options.transform.split(',');
                        if (options.labelPosition == "outside")
                            this.ctx.translate(parseFloat(str[1]), parseFloat(str[2]) + (txtlngth / 2));
                        else
                            this.ctx.translate(parseFloat(str[1]), parseFloat(str[2]) - (txtlngth / 2));
                        this.ctx.textAlign = "center";
                        this.ctx.rotate(rotation * (Math.PI / 180));
                        this.ctx.fillText(label, 0, 0);
                    }
                    else {
                        this.ctx.translate(options.x, options.y);
                        this.ctx.rotate(options.labelRotation * Math.PI / 180);
                        this.ctx.fillText(label, 0, 0);
                    }
                }
                this.ctx.restore();
            } else {
                this.lgndCtx.save();
                this.lgndCtx.fillStyle = options.fill;
                this.lgndCtx.font = font;
                this.lgndCtx.textAlign = anchor;
                this.lgndCtx.globalAlpha = opacity;
                // dominant-baseline
                if (options["dominant-baseline"] == "middle")
                    this.lgndCtx.textBaseline = "center";
                if (!options.labelRotation) {
                    this.lgndCtx.fillText(label, options.x, options.y);
                } else {
                    this.lgndCtx.translate(options.x, options.y);
                    this.lgndCtx.rotate(options.labelRotation * Math.PI / 180);
                    this.lgndCtx.fillText(label, 0, 0);
                }
                this.lgndCtx.restore();
            }
        },
        drawZoomRect: function(options, chartObj) {

            var chartPos = { left: 0, top: 0 };
            var zoomRect = $("<div id=" + options.id + "></div>");
            var areaBounds = chartObj.model.m_AreaBounds;
			
			// for drawing zoom area within the chartArea
            if (options.x < areaBounds.X || options.x + chartPos.left + options.width > chartPos.left + $(this.svgObj).width() - 20) {
                width = this.prevWidth;
                x = this.prevX;
            } else {
                width = this.prevWidth = options.width;
                x = this.prevX = options.x + chartPos.left;
            }
            
            if (options.y < areaBounds.Y || options.y + chartPos.top + options.height > chartPos.top + areaBounds.Y + areaBounds.Height) {
                height = this.prevHeight;
                y = this.prevY;
            } else {
                height = this.prevHeight = options.height;
                y = this.prevY = options.y + chartPos.top;
            }
            
            $(zoomRect).css({
                    "width": width,
                    "height": height,
                    "top": y,
                    "left": x,
                    "background-color": options.fill,
                    "border-style": "solid",
                    "position": "absolute",
                    "border-color": options.stroke,
                    "border-width": options["stroke-width"]
                });
                document.getElementById("chartContainer_" + this._rootId).appendChild(zoomRect[0]);
        },
        zoomButton: function (options, currentItem, chart) {
			var svgObj = chart.svgObj ? chart.svgObj : chart.svgObject;
			var id = chart._rootId ? chart._rootId : chart._id;
            if (currentItem == "zoom")
                var currentItemId = "_Zoom";
            else if (currentItem == "zoomIn")
                currentItemId = "_ZoomIn";
            else
                currentItemId = "_ZoomOut";

            var chartPos = { left: 0, top: 0 };
            if ($("#" + options.zoomId).length <= 0) {
                var zoomButton = $("<div id=" + svgObj.id + currentItemId +'Btn' + "></div>");
                $(zoomButton).css({
                    "width": options.width,
                    "height": options.height,
                    "top": options.top + chartPos.top,
                    "left": options.left + chartPos.left,
                    "background-color": options.fill,
                    "border-style": "solid",
                    "position": "absolute",
                    "border-radius": "0.4em",
                    "border-color": options.fill,
                    "box-sizing": "content-box",
					 "z-index" : 2000
                });                
                var svgLink = "http://www.w3.org/2000/svg";
                var svgShape = document.createElementNS(svgLink, "svg");
                svgShape.setAttribute('id', options.zoomId);
                svgShape.setAttribute('width', 25);
                svgShape.setAttribute('height', 25);
               
                if (currentItem == "zoom") {
                    var direction = "M26.101,22.893l-6.605-6.174c1.414-2.781,0.897-6.267-1.496-8.504c-2.901-2.711-7.448-2.56-10.161,0.341    c-2.712,2.9-2.56,7.45,0.341,10.163c2.426,2.266,6,2.523,8.694,0.853l6.579,6.151L26.101,22.893z M10.186,16.571    c-1.715-1.604-1.805-4.293-0.203-6.009c1.605-1.715,4.295-1.805,6.009-0.201c1.715,1.603,1.805,4.293,0.202,6.007    C14.59,18.084,11.901,18.175,10.186,16.571";
                    var transform = "translate(-3,-3)";
                } else if (currentItem == "zoomIn") {
                    direction = "M9.0983096,4.2999878L9.0983096,9.3999634 3.9983783,9.3999634 3.9983783,12.699951 9.0983096,12.699951 9.0983096,17.799988 12.398249,17.799988 12.398249,12.699951 17.49818,12.699951 17.49818,9.5 12.398249,9.5 12.398249,4.2999878z M10.998276,0C14.298215,0 17.49818,1.3999634 19.69813,4.1999512 22.79809,8.0999756 22.79809,13.5 19.998144,17.399963L28.597992,28.299988 23.898081,32 15.398205,21.199951C10.898271,23.099976 5.5983606,21.899963 2.3983956,17.899963 -1.4015366,13.099976 -0.60156059,6.0999756 4.1983567,2.3999634 6.1983276,0.79998779 8.5983163,0 10.998276,0z";
                    transform = "translate(4,4) scale(0.6)";
                } else {
                    direction = "M3.9983433,9.5L3.9983433,12.799988 17.598165,12.799988 17.598165,9.5z M10.998234,0C14.298169,0 17.498131,1.3999634 19.698108,4.1999512 22.798034,8.0999756 22.798034,13.5 19.998092,17.399963L28.597994,28.299988 23.898054,32 15.398188,21.199951C10.898259,23.099976 5.5983546,21.899963 2.398393,17.899963 -1.4015351,13.099976 -0.60155994,6.0999756 4.1983522,2.3999634 6.1983207,0.79998779 8.5983074,0 10.998234,0z";
                    transform = "translate(4,4) scale(0.6)";
                }

                var attrOptions = {
                    'id': currentItemId + 'Path',
                    'fill': options.iconColor,
                    'transform': transform,
                    'd': direction
                };

                var path = document.createElementNS(svgLink, "path");
                $(path).attr(attrOptions).appendTo(svgShape);
                zoomButton[0].appendChild(svgShape);
                document.getElementById("chartContainer_" + id).appendChild(zoomButton[0]);
            } else {
                var zoomButton = document.getElementById(svgObj.id + currentItemId + 'Btn');
                $(zoomButton).css({
                    "top": options.top + chartPos.top,
                    "left": options.left + chartPos.left
                });
            }
        },
        panButton: function (options, chart) {
			var svgObj = chart.svgObj ? chart.svgObj : chart.svgObject;
			var id = chart._rootId ? chart._rootId : chart._id;
            var chartPos = { left: 0, top: 0 };
            if ($("#" + options.panId).length <= 0) {
                var panButton = $("<div id=" + svgObj.id + '_PanBtn' + "></div>");
                $(panButton).css({
                    "width": options.width,
                    "height": options.height,
                    "top": options.top + chartPos.top,
                    "left": options.left + chartPos.left,
                    "background-color": options.fill,
                    "border-style": "solid",
                    "position": "absolute",
                    "border-radius": "0.4em",
                    "border-color": options.fill,
                    "box-sizing": "content-box",
					 "z-index" : 2000
                });                
                var svgLink = "http://www.w3.org/2000/svg";
                var svgShape = document.createElementNS(svgLink, "svg");
                svgShape.setAttribute('id', options.panId);
                svgShape.setAttribute('width', 25);
                svgShape.setAttribute('height', 25);

                var attrOptions = {
                    'id': 'panPath',
                    'fill': options.iconColor,
                    'transform': 'translate(-3,-3)'
                };
                attrOptions.points = "26.105,16 21.053,12.211 21.053,14.737 17.263,14.737 17.263,10.947 19.834,10.947 16.044,5.895 12.255,10.947 14.737,10.947 14.737,14.737 10.947,14.737 10.947,12.211 5.895,16 10.947,19.789 10.947,17.263 14.737,17.263 14.737,21.053 12.255,21.053 16.044,26.105 19.834,21.053 17.263,21.053 17.263,17.263 21.053,17.263 21.053,19.789";

                var path = document.createElementNS(svgLink, "polygon");
                $(path).attr(attrOptions).appendTo(svgShape);
                panButton[0].appendChild(svgShape);
                document.getElementById("chartContainer_" + id).appendChild(panButton[0]);     
            } else {
                var panButton = document.getElementById(svgObj.id + '_PanBtn');
                $(panButton).css({
                    "top": options.top + chartPos.top,
                    "left": options.left + chartPos.left
                });
            }
        },
        resetZoom: function (options, chart) {
			var svgObj = chart.svgObj ? chart.svgObj : chart.svgObject;
			var id = chart._rootId ? chart._rootId : chart._id;
           var chartPos = { left: 0, top: 0 };
            if ($("#" + options.resetZoomId).length <= 0) {
                var resetZoom = $("<div id=" + svgObj.id + '_ResetZoom' + "></div>");
                $(resetZoom).css({
                    "width": options.width,
                    "height": options.height,
                    "top": options.top + chartPos.top,
                    "left": options.left + chartPos.left,
                    "background-color": options.fill,
                    "border-style": "solid",
                    "border-radius": "0.4em",
                    "position": "absolute",
                    "border-color": options.fill,
                    "box-sizing":"content-box",
					 "z-index" : 2000
                });                
                var svgLink = "http://www.w3.org/2000/svg";
                var svgShape = document.createElementNS(svgLink, "svg");
                svgShape.setAttribute('id', options.resetZoomId);
                svgShape.setAttribute('width', 25);
                svgShape.setAttribute('height', 25);

                var points1 = {
                    'id': 'p1',
                    'fill': options.iconColor,
                    'transform': 'translate(-3,-3)'
                };
                points1.points = "11.895,18.398 8.061,22.23 5.796,19.967 5.796,26.283 12.112,26.283 9.848,24.018 13.682,20.186";

                var path1 = document.createElementNS(svgLink, "polygon");
                $(path1).attr(points1).appendTo(svgShape);

                var points2 = {
                    'id': 'p2',
                    'fill': options.iconColor,
                    'transform': 'translate(-3,-3)'
                };
                points2.points = "19.691,6.072 21.955,8.337 18.121,12.172 19.908,13.959 23.742,10.123 26.007,12.389 26.007,6.072";

                var path2 = document.createElementNS(svgLink, "polygon");
                $(path2).attr(points2).appendTo(svgShape);

                var points3 = {
                    'id': 'p3',
                    'fill': options.iconColor,
                    'transform': 'translate(-3,-3)'
                };
                points3.points = "11.895,13.958 13.682,12.172 9.848,8.337 12.112,6.072 5.796,6.072 5.796,12.389 8.061,10.123";

                var path3 = document.createElementNS(svgLink, "polygon");
                $(path3).attr(points3).appendTo(svgShape);

                var points4 = {
                    'id': 'p4',
                    'fill': options.iconColor,
                    'transform': 'translate(-3,-3)'
                };
                points4.points = "19.908,18.396 18.121,20.186 21.955,24.018 19.691,26.283 26.007,26.283 26.007,19.967 23.741,22.23";

                var path4 = document.createElementNS(svgLink, "polygon");
                $(path4).attr(points4).appendTo(svgShape);

                resetZoom[0].appendChild(svgShape);
                document.getElementById("chartContainer_" + id).appendChild(resetZoom[0]);
            } else {
                var resetZoom = document.getElementById(svgObj.id + '_ResetZoom');
                $(resetZoom).css({
                    "top": options.top + chartPos.top,
                    "left": options.left + chartPos.left
                });
            }
        },
        drawCrosshairLine: function (options, element) {
            var line = $("<div id=" + options.id + "></div>");
            $(line).css({
                "width": options.width,
                "height": options.height,
                "left": options.left,
                "top": options.top,
                "border-style": options.style,
                "opacity": options.opacity,
                "visibility": "visible",
                "border-color": options.stroke,
                "border-width": options["stroke-width"],
                "position": options.position                 
            });
            $(element).append(line[0]);
        },
        drawCrosshairlabel: function (rectOptions, textOptions, text) {
		     var chartOffset = $("#"+ this._rootId).offset(),
                chartPos = { left: 0, top: 0 };
            if ($("#" + rectOptions.id).length > 0) {
                var label = document.getElementById(rectOptions.id);                
                $(label).css({
                    "width": rectOptions.width - 5,
                    "height": rectOptions.height - 5,
                    "left": textOptions.x + chartPos.left - 5,
                    "top": textOptions.y + chartPos.top - 15,
                    "visibility": "visible",
                    "display": rectOptions.display
                });
                document.getElementById(rectOptions.id).textContent = text;
            } else {
                var label = $("<div id=" + rectOptions.id + " style='position: absolute; z-index: 13000;'></div>");
                $(label).css({
                    "color": textOptions.fill,
                    "font-family": textOptions["font-family"],
                    "font-size": textOptions["font-size"],
                    "font-weight": textOptions["font-weight"],
                    "font-style": textOptions["font-style"],
                    "background-color": rectOptions.fill,
                    "border-style": "solid",
                    "border-color": rectOptions.stroke,
                    "border-width": rectOptions["stroke-width"],
                    "opacity": rectOptions["fill-opacity"],
                    "text-align" : "center"
                });
                
                document.getElementById(this._rootId).appendChild(label[0]);
            }
        },
        createCrosshairCanvas: function () {
          
            var chartCanvas = document.getElementById(this._rootId + "_canvas"),
             chartOffset = $("#" + this._rootId).offset(), secCanvas,
             chartPos = { left: 0, top: 0 };
           
            if (!$("#secondCanvas").length) {
                 secCanvas = document.createElement('canvas');
                 $(document).find("#" + this.svgObj.id + '_CrosshairGroup').append(secCanvas);
                $(secCanvas).attr({
                    'id': 'secondCanvas',
                    'width': chartCanvas.width,
                    'height': chartCanvas.height,
                    'top': chartPos.top,
                    'left': chartPos.left,
                });
                $(secCanvas).css({
                    'width': chartCanvas.width,
                    'height': chartCanvas.height,
                    'top': chartPos.top,
                    'left': chartPos.left                   
                });
            }
            else {
                 secCanvas = document.getElementById("secondCanvas");
            }
            return secCanvas;
        },      
        drawTrackToolTip: function (rectOptions, textOptions, text, padding) {
            var chartPos = { left: this.svgObj.offsetLeft, top: this.svgObj.offsetTop };
            if ($("#" + rectOptions.id).length > 0) {
                var label = document.getElementById(rectOptions.id);               
                $(label).css({
                    "left": rectOptions.x + chartPos.left,
                    "top": rectOptions.y + chartPos.top,
                    "visibility": "visible",
                    "border-box": "content-box",
					"background-color": rectOptions.fill,
					"color": textOptions.fill, 
					"border-color": rectOptions.stroke,
					"border-width": rectOptions["stroke-width"]
                });
                 if (jQuery.type(text) == "array") {
                    var j = 0;
                    var arrayText = "";
                    for (var i = 0; i < text.length; i++) {
                        arrayText = arrayText + text[i] + '</br>';
                    }
                    $("#" + rectOptions.id).html(arrayText);
                } else
                    $("#" + rectOptions.id).html(text);
            } else {
                var label = $("<div id=" + rectOptions.id + " style='position: absolute; z-index: 13000;'></div>");
                $(label).css({
                    "color": textOptions.fill,
                    "font-family": textOptions["font-family"],
                    "font-size": textOptions["font-size"],
                    "font-weight": textOptions["font-weight"],
                    "font-style": textOptions["font-style"],
                    "width": rectOptions.width,
                    "height": rectOptions.height - padding - 2 * rectOptions["stroke-width"],
                    "background-color": rectOptions.fill,
                    "border-style": "solid",
                    "text-align": "center",
                    "padding" : "0px",
                    "padding-top": (padding/2) + 'px',
                    "padding-bottom": (padding/2) + 'px',
                    "border-color": rectOptions.stroke,
                    "border-width": rectOptions["stroke-width"],
                    "opacity": rectOptions["fill-opacity"]
                });
                document.getElementById(this._rootId).appendChild(label[0]);
            }
        },
        trackSymbol: function (options, evt, symbolName, trackSymbol, chartObj) {
            var chartAreaRect = chartObj.model.m_AreaBounds, chartOffset = $("#" + this._rootId).offset(), parent;
        if (evt.startX >= chartAreaRect.X && evt.startX <= chartAreaRect.X + chartAreaRect.Width && evt.startY >= chartAreaRect.Y && evt.startY <= chartAreaRect.Y + chartAreaRect.Height) {
            var seriesIndex = options.SeriesIndex, radius;
            var pointIndex = options.PointIndex;
            if (chartObj.model.series[seriesIndex].type.toLowerCase() == "bubble") {
                var point = chartObj.model.series[seriesIndex]._visiblePoints[pointIndex];
                radius = (point.radius * 2) + 5;//exploding the bubble
                options.Style.BorderColor = options.Style.Color;
            }
            
            if (chartObj.model.series[seriesIndex].type.toLowerCase() == "scatter" && ej.util.isNullOrUndefined(trackSymbol)) {
                var circleOptions = {
                    "cx": evt.startX -2,
                    "cy": evt.startY -2,
                    "r": options.ShapeSize.width/2,
                    "fill" : options.Style.Color,
                    "opacity": options.Style.Opacity,
                    "stroke" : options.Style.BorderColor
                };
                this.drawCircle(circleOptions, null);
            }
            
        else {
                if ($("#" + "canvas_trackSymbol").length > 0) {
                    var parentDiv = $("#" + "canvas_trackSymbol");
                    $(parentDiv).css({ "visibility": "visible", "display": "block" });
                }
                else
                    parentDiv = $("<div id=" + "canvas_trackSymbol" + "></div>");

                var chartPos = { left: evt.startX, top: evt.startY };
               
                var symbol = $("<div id=" + options.ID + "></div>");
                var left = (chartPos.left - (radius || options.ShapeSize.width));
                var top = (chartPos.top - (radius || options.ShapeSize.height));
                
                    $(symbol).css({
                       
                        "left":  left ,
                        "top": top,
                        "box-sizing": 'content-box',
                        "position": "absolute",
                        "visibility": "visible",                        
                        "opacity": options.Style.Opacity,
                        "z-index" : 200
                    });
                    var style = options.ShapeSize;
                    options.symbol = symbol;
                    var shapeAttr = {};
                    switch (symbolName.toLowerCase()) {
                        case "circle":
                            $(symbol).css({
                                //radius for bubble exploding
                                "width": radius || options.ShapeSize.width + 'px', 
                                "height": radius || options.ShapeSize.height + 'px',
                                "left": radius ? (left + radius / 2) : (left + options.ShapeSize.width / 2 - options.Style.BorderWidth) + 'px',
                                "top": radius ? (top + radius / 2) : (top + options.ShapeSize.height / 2 - options.Style.BorderWidth) + 'px',
                                "border-style": "solid",
                                "background-color": options.Style.Color,
                                "border-color": options.Style.BorderColor,
                                "border-width": options.Style.BorderWidth,
                                "border-radius": "100%"
                            });
                            break;
                        case "rectangle":
                            $(symbol).css({
                                "width": options.ShapeSize.width,
                                "height": options.ShapeSize.height,
                                "left": left + options.ShapeSize.width / 2 - options.Style.BorderWidth / 2,
                                "top": top + options.Style.BorderWidth / 2,
                                "border-style": "solid",
                                "background-color": options.Style.Color,
                                "border-color": options.Style.BorderColor,
                                "border-width": options.Style.BorderWidth
                            });
                            break;
                        case "diamond":

                            var direction  = "M" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY) + " " 
                                             + "L" + " " + (evt.startX) + " " + (evt.startY + (-options.ShapeSize.height / 2)) + " "
                                             + "L" + " " + (evt.startX + (options.ShapeSize.width / 2)) + " " + (evt.startY) + " "
                                             + "L" + " " + (evt.startX) + " " + (evt.startY + ( options.ShapeSize.height/2)) + " " 
                                             + "L" + " " + (evt.startX + (-options.ShapeSize.width / 2)) + " " + (evt.startY) + "z";
                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);
                          
                            break;
                        case "triangle":
                                                     
                            var direction = "M" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX) + " " + (evt.startY + (-style.height / 2))
                                + " " + "L" + " " + (evt.startX + (style.width / 2)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY + (style.height / 2)) + "z";
                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);
                           
                            break;
                        case "invertedtriangle":
                                                     
                            var direction = "M" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX) + " " +
                                (evt.startY + (-style.height / 2)) + " " + "L" + " " + (evt.startX + (style.width / 2)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " +
                                (evt.startX + (-style.width / 2)) + " " + (evt.startY + (style.height / 2)) + "z";
                            var x = evt.startX;
                            var y = evt.startY;
                            var rotate = 'rotate(180,' + x + ',' + y + ')';

                            shapeAttr.direction = direction;
                            shapeAttr.rotate = rotate;
                            this.drawSvgShape(options, shapeAttr);
                            
                            break;
                       
                        case "cross":
                           
                            var direction = "M" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY) + " " + "L" + " " + (evt.startX + (style.width / 2))
                                + " " + (evt.startY) + " " + "M" + " " + (evt.startX) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX) + " " +
                                (evt.startY + (-style.height / 2)) + "z";

                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "star":
                           
                            var direction = "M" + " " + (evt.startX + (style.width / 3)) + " " + (evt.startY + (-style.height / 2)) + " " + "L" + " " + (evt.startX + (-style.width / 2)) + " " +
                                (evt.startY + (style.height / 6)) + " " + "L" + " " + (evt.startX + (style.width / 2)) + " " + (evt.startY + (style.height / 6)) + " " + "L" + " " + (evt.startX + (-style.width / 3)) + " " +
                                (evt.startY + (-style.height / 2)) + " " + "L" + " " + (evt.startX) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX + (style.width / 3)) + " " + (evt.startY + (-style.height / 2)) + "z";

                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "hexagon":
                           
                            var direction = "M" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY) + " " + "L" + " " + (evt.startX + (-style.width / 4)) + " " +
                                (evt.startY + (-style.height / 2)) + " " + "L" + " " + (evt.startX + (style.width / 4)) + " " + (evt.startY + (-style.height / 2)) + " " + "L" + " " +
                                (evt.startX + (style.width / 2)) + " " + (evt.startY) + " " + "L" + " " + (evt.startX + (style.width / 4)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " +
                                (evt.startX + (-style.width / 4)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY) + "z";

                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "wedge":
                           
                            var direction = "M" + " " + (evt.startX -style.width) + " " + (evt.startY) + " " + "L" + " " + (evt.startX + style.width) + " " +
                                (evt.startY + (-style.height / 2)) + " " + "L" + " " + (evt.startX + (3 * (style.width / 4))) + " " + (evt.startY) + " " + "L" + " " +
                                (evt.startX + (style.width)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX - style.width) + " " + (evt.startY) + "z";

                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "trapezoid":
                                                       
                            var direction = "M" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY) + " " + "L" + " " + (evt.startX + (-style.width / 2)) + " " +
                                (evt.startY + (-style.height / 4)) + " " + "L" + " " + (evt.startX + (-style.width / 2) + (style.width)) + " " + (evt.startY + (-style.height / 2)) + " " + "L" + " " +
                                (evt.startX + (-style.width / 2) + (style.width)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY + (style.height / 4)) +
                                " " + "L" + " " + (evt.startX + (-style.width / 2)) + " " + (evt.startY) + "z";

                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "uparrow":
                           
                            var direction = "M" + " " + ((evt.startX - (style.width / 2) + (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height)) + " " + "L" + " " + ((evt.startX - (style.width / 2) + (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX - (style.width / 2))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX)) + " " + (evt.startY - (style.height / 2)) + " " + "L" + " " + ((evt.startX + (style.width / 2))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX + (style.width / 2) - (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX + (style.width / 2) - (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height)) + " " + "L" + " " + ((evt.startX - (style.width / 2) + (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height)) + "z";
                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "downarrow":
                           
                            var direction = "M" + " " + ((evt.startX - (style.width / 2) + (style.width / 4))) + " " + (evt.startY - (style.height / 2)) + " " + "L" + " " + ((evt.startX + (style.width / 2) - (style.width / 4))) + " " + (evt.startY - (style.height / 2)) + " " + "L" + " " + ((evt.startX + (style.width / 2) - (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX + (style.width / 2))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX)) + " " + (evt.startY - (style.height / 2) + (style.height)) + " " + "L" + " " + ((evt.startX - (style.width / 2))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX - (style.width / 2) + (style.width / 4))) + " " + (evt.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((evt.startX - (style.width / 2) + (style.width / 4))) + " " + (evt.startY - (style.height / 2)) + "z";
                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "leftarrow":
                           
                            var direction = "M" + " " + ((evt.startX - (style.width / 2)) + style.width) + " " + (evt.startY + (style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + style.width) + " " + (evt.startY + (-style.height / 4)) + " " + "L" + " " +
                                ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (-style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (-style.height / 2)) + " " + "L" + " " + ((evt.startX -
                                (style.width / 2))) + " " + (evt.startY) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " +
                                (evt.startY + (style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + style.width) + " " + (evt.startY + (style.height / 4)) + "z";

                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "rightarrow":

                            var direction = "M" + " " + ((evt.startX - (style.width / 2))) + " " + (evt.startY + (style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2))) + " " + (evt.startY + (-style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (-style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (-style.height / 2)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + style.width) + " " + (evt.startY) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (style.height / 2)) + " " + "L" + " " + ((evt.startX - (style.width / 2)) + (style.width / 2)) + " " + (evt.startY + (style.height / 4)) + " " + "L" + " " + ((evt.startX - (style.width / 2))) + " " + (evt.startY + (style.height / 4)) + "z";
                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "pentagon":
                           
                            var eq = 72;
                            var radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2;
                            var sb = ej.EjSvgRender.utils._getStringBuilder();
                            for (var i = 0; i <= 5; i++) {
                                var deg = i * eq;
                                var rad = (Math.PI / 180) * deg;
                                var x1 = radius * Math.cos(rad);
                                var y1 = radius * Math.sin(rad);
                                if (i == 0)
                                    sb.append("M" + " " + (evt.startX + x1) + " " + (evt.startY + y1) + " ");
                                else
                                    sb.append("L" + " " + (evt.startX + x1) + " " + (evt.startY + y1) + " ");
                            }
                            sb.append("z");
                            var direction = sb.toString();
                            shapeAttr.direction = direction;
                            this.drawSvgShape(options, shapeAttr);

                            break;
                        case "ellipse":
                            $(symbol).css({
                                "width": options.ShapeSize.width,
                                "height": options.ShapeSize.height / 2,
                                "border-style": "solid",
                                "left": left + options.ShapeSize.height / 2 - options.Style.BorderWidth / 2,
                                "top": (evt.startY + chartPos.top - options.ShapeSize.height + 4),
                                "background-color": options.Style.Color,
                                "border-color": options.Style.BorderColor,
                                "border-width": options.Style.BorderWidth,
                                "-moz-border-radius": "50%",
                                "-webkit-border-radius": "50%",
                                "border-radius": "50%",
                                "border-box": "content-box"
                            });
                            break;
                        case "horizline":
                            $(symbol).css({
                                "width": options.ShapeSize.width,
                                "height": 0,
                                "border-style": "solid",
                                "left": left + options.ShapeSize.width / 2,
                                "top": (evt.startY + chartPos.top - 1),
                                "border-color": options.Style.BorderColor,
                                "border-width": '2px',
                                "border-box": "content-box"
                            });
                            break;
                        case "vertline":
                            $(symbol).css({
                                "width": 0,
                                "height": options.ShapeSize.height,
                                "border-style": "solid",
                                "left": (evt.startX + chartPos.left - 1),
                                "top": top + options.ShapeSize.height / 2 - 2,
                                "border-color": options.Style.BorderColor,
                                "border-width": '2px',
                                "border-box": "content-box"
                            });
                            break;
                        default:
                            $(symbol).css({
                                "width": options.ShapeSize.width,
                                "height": options.ShapeSize.height,
                                "border-style": "solid",
                                "background-color": options.Style.Color,
                                "border-color": options.Style.BorderColor,
                                "border-width": options.Style.BorderWidth,
                                "border-radius": "50px"
                            });
                            break;
                    }
                    parentDiv[0].appendChild(symbol[0]);
                    parent = document.getElementById(this.svgObj.id + '_CrosshairGroup') || document.getElementById("chartContainer_" + this._rootId);
                    parent.appendChild(parentDiv[0]);
            }
		  }
        },
        //draw SVG Marker shape on mouse over the points
        drawSvgShape: function (options, attr) {
            var chartCanvas = document.getElementById(this._rootId + "_canvas");
            var chartPos = { left: 0, top: 0 };
            var svgLink = "http://www.w3.org/2000/svg";
            var svgShape = document.createElementNS(svgLink, "svg");
            svgShape.setAttribute('id', 'mySVG');
            svgShape.setAttribute('width', $(chartCanvas).width());
            svgShape.setAttribute('height', $(chartCanvas).height());
            $(options.symbol).css({
                "left":  chartPos.left + 'px',
                "top": chartPos.top + 'px'
            });
            var attrOptions = {
                'id': 'svgPath',
                'fill-opacity': options.Style.Opacity,
                'stroke-width': options.Style.BorderWidth,
                'fill': options.Style.Color,
                'transform' : attr.rotate,
                'stroke': options.Style.BorderColor
            };
            attrOptions.d = attr.direction;

            var path = document.createElementNS(svgLink, "path");
            $(path).attr(attrOptions).appendTo(svgShape);
            options.symbol[0].appendChild(svgShape);
        },
        drawCircle: function (options, element) {
            if (!options.lgndCtx) {
                var canvasCtx = this.ctx, dashArray;
                this.ctx = element != undefined ? element : this.ctx;
                this.ctx.save();
                this.ctx.beginPath();
                this.ctx.arc(options.cx, options.cy, options.r, 0, 2 * Math.PI);
                this.ctx.fillStyle = options.fill;
                this.ctx.globalAlpha = options.opacity;
                this.ctx.fill();
                this.ctx.lineWidth = options["stroke-width"];
                dashArray = options["stroke-dasharray"] ? options["stroke-dasharray"].split(",") : false;
                if (dashArray) this.ctx.setLineDash(dashArray);
                this.ctx.strokeStyle = options.stroke;
                this.ctx.stroke();
                this.ctx.restore();
                this.ctx = canvasCtx;
            } else {
                var legendCtx = this.lgndCtx;
                this.lgndCtx = element != undefined ? element : this.lgndCtx;
                this.lgndCtx.save();
                this.lgndCtx.beginPath();
                this.lgndCtx.arc(options.cx, options.cy, options.r, 0, 2 * Math.PI);
                this.lgndCtx.fillStyle = options.fill;
                this.lgndCtx.globalAlpha = options.opacity;
                this.lgndCtx.fill();
                this.lgndCtx.lineWidth = options["stroke-width"];
                this.lgndCtx.strokeStyle = options.stroke;
                this.lgndCtx.stroke();
                this.lgndCtx.restore();
                this.lgndCtx = legendCtx;
            }
        },    
        
        drawPolyline: function (options, element) {
            
            this.ctx.save();
            this.ctx.beginPath();
            var points = options.points.split(" ");
            for (var i = 0; i < points.length - 1; i++) {
                var point = points[i].split(",");
                var x = point[0];
                var y = point[1];
                if (i == 0) 
                    this.ctx.moveTo(x,y);
                 else
                    this.ctx.lineTo(x,y);
            }
            this.ctx.lineWidth = options["stroke-width"];
			 this.ctx.strokeStyle = options.stroke;
            this.ctx.stroke();
            this.ctx.restore();            
        },
        drawPolygon: function (options, element) {
           
        },
        setFillAttribute: function (element, options) {
           
        },
        setStrokeAttribute: function (element, options) {
            
        },
        changePathValue: function (options) {
            
        },


        drawArc: function (w, h, options) {
            var x = 0, y = 0;
  
        },
        changeVMLStyle: function($element, options) {
           
        },
        applyVMLStyle: function ($element, options) {

        },
       
        drawEllipse: function (options, element) {
            var canvasCtx = this.ctx;
            this.ctx = element != undefined ? element : this.ctx;
            var circumference = Math.max(options.rx, options.ry);
            var scaleX = options.rx / circumference;
            var scaleY = options.ry / circumference;
            if (!options.lgndCtx) {
                this.ctx.save();
                this.ctx.beginPath();
                this.ctx.translate(options.cx, options.cy);
                this.ctx.save();
                this.ctx.scale(scaleX, scaleY);
                this.ctx.arc(0, 0, circumference, 0, 2 * Math.PI, false);
                this.ctx.fillStyle = options.fill;
                this.ctx.fill();
                this.ctx.restore();
                this.ctx.lineWidth = options["stroke-width"];
                this.ctx.strokeStyle = options.stroke;
                this.ctx.stroke();
                this.ctx.restore();
                this.ctx = canvasCtx;
            } else {
                this.lgndCtx.save();
                this.lgndCtx.beginPath();
                this.lgndCtx.translate(options.rx, options.ry);
                this.lgndCtx.scale(scaleX, scaleY);
                this.lgndCtx.arc(options.cx - options.rx, options.cy * 2 - options.rx, options.rx, 0, 2 * Math.PI, false);
                this.lgndCtx.fillStyle = options.fill;
                this.lgndCtx.fill();
                this.lgndCtx.restore();
                this.lgndCtx.lineWidth = options["stroke-width"];
                this.lgndCtx.strokeStyle = options.stroke;
                this.lgndCtx.stroke();
                this.lgndCtx.restore();
            }
        },
      
        _getAttrVal: function (ele, val, option) {
            var value = $(ele).attr(val);
            if (value != null)
                return value;
            else
                return option;
        },
        _setAttr: function (element, attribute) {
          
        },
       
        setSpanAttr: function (options, label, element) {
           
        },
       
        //text element attributes values are replaced 
        _textAttrReplace: function (options, label, font, $Ele) {
           
        },

        drawImage: function (options, element) {
             this.ctx.save();
             var imageObj = new Image();
             imageObj.src = options.href;
             this.ctx.drawImage(imageObj, options.x, options.y, options.width, options.height);
             this.ctx.restore();
        },

        createDefs: function () {

        },

        createGroup: function (options) {
           
        },

        createText: function (options, label) {
            var text = document.createElement("div");
            var diff= 1.1; // difference between svg and div element rotated text height
            $(text).css({
                "transform": options.rotateAngle,
                "font-family": parseFloat(options["font-family"]),
                "font-size": parseFloat(options["font-size"]) * diff,
                "position": "absolute"}); 
            if (!ej.util.isNullOrUndefined(label))
                text.textContent = label;
            return text;
        },


        //Draw clip path for each series to avoid series overlap in multiple axes zooming
        drawAxesBoundsClipPath: function (gSeriesGroupEle, options, invertedAxis) {
            var clipOptions = options;
           
        },

        getAttrVal: function (ele, val, option) {
       
        },

        hexFromRGB: function (color) {
          
        },

        createDelegate: function (context, handler) {
           
        },

        drawClipPath: function (options, element) {
            
        },

        drawCircularClipPath: function (options, element) {

        },

        append: function (childEle, parentEle) {
            $(childEle).appendTo(parentEle);
			},
			
		createLegendCanvas: function (element) {            
            this.legendsvgObj = document.createElement('canvas');
            this._rootId = jQuery(element).attr("id");
            this.legendsvgObj.setAttribute('id', "legend_" + this._rootId + '_canvas');
            this.lgndCtx = this.legendsvgObj.getContext("2d");
            return this.legendsvgObj;
        }
		
    };
})(jQuery);


;
ej.EjSvgRender = function (element) {

    this.svgLink = "http://www.w3.org/2000/svg";
    this.svgObj = document.createElementNS(this.svgLink, "svg");
    this._rootId = jQuery(element).attr("id");
    var id = this._rootId + '_svg';   
    if ($(document).find("#" + id).length > 0){       
        var count=0
        do {
            count++;
        } while ($(document).find("#" + this._rootId + '_svg' + count).length > 0);
        id = this._rootId + '_svg' + count;
    }    
    this.svgObj.setAttribute('id', id);

};
(function ($) {
ej.EjSvgRender.prototype = {
    drawPath: function (options, element) {
        if ($("#" + options.id).length > 0) { 
            $("#" + options.id).attr(options);
        }
        else {
            var path = document.createElementNS(this.svgLink, "path");
            $(path).attr(options).appendTo(element);
        }

    },
    createLegendSvg:function(element)
    {
        this.svgLink = "http://www.w3.org/2000/svg";
        this.legendsvgObj = document.createElementNS(this.svgLink, "svg");
        this._rootId = jQuery(element).attr("id");
        this.legendsvgObj.setAttribute('id', "legend_" + this._rootId + '_svg');
        return this.legendsvgObj;
    },
    drawPolyline: function (options, element) {
        if ($("#" + options.id).length > 0) {
            $("#" + options.id).attr(options);
        }
        else {
            var polyline = document.createElementNS(this.svgLink, "polyline");
            $(polyline).attr(options).appendTo(element);
        }

    },

    drawLine: function (options, element) {
        if ($("#" + options.id).length > 0) {
            $("#" + options.id).attr(options);
        }
        else {
            var path = document.createElementNS(this.svgLink, "line");
            $(path).attr(options);
            $(path).appendTo(element);
        }
    },
    drawPolygon: function (options, element) {
        if ($("#" + options.id).length > 0) {
            $("#" + options.id).attr(options);
        }
        else {
            var polygon = document.createElementNS(this.svgLink, "polygon");
            $(polygon).attr(options);
            $(polygon).appendTo(element);
        }
    },
    drawCircle: function (options, element) {
        if ($("#" + options.id).length > 0) {
            $("#" + options.id).attr(options);
        }
        else {
            var circle = document.createElementNS(this.svgLink, "circle");
            $(circle).attr(options).appendTo(element);
        }
    },
    drawEllipse: function (options, element) {
        if ($("#" + options.id).length > 0) {
            $("#" + options.id).attr(options);
        }
        else {
            var ellipse = document.createElementNS(this.svgLink, "ellipse");
            $(ellipse).attr(options).appendTo(element);
        }
    },
    
    drawRect: function (options, element) {
            if ($("#" + options.id).length > 0) {
                $("#" + options.id).attr(options);
            }
            else {
                var rect = document.createElementNS(this.svgLink, "rect");
                $(rect).attr(options).appendTo(element);
            }    
    },
    drawCylinder: function (options, element, seriesOption) {
        if ($("#" + options.id).length > 0) {
            $("#" + options.id).attr(options);
        }
        else {
            var x = options.x, y = options.y, id = options.id;
            var gradientColor = options.fill;
            var fillColor = gradientColor;
            var format = this.checkColorFormat(gradientColor);
            if (!format)
                gradientColor = ej.datavisualization.Chart.prototype.colorNameToHex(gradientColor);
            var AEx,AEy, LX, LY, X, Y,X2, Y2,i=2,X1,Y1,GX=0,GY=0;
            var obj = { svgRenderer: this };
            if (seriesOption.isColumn == true) {
                var rx = options.width / 2;
                var length = options.height;
                var ry=rx/4;
                X = X1 = x;
                Y = (y - ry);
                Y1 = Y;
                AEx = 2 * rx;
                AEy = 0;
                LX = 0;
                LY = length;
                X2 = X;
                Y2 = Y + length;
                GX = 100;
                if (seriesOption.stacking = true) {
                    if (!seriesOption.isLastSeries) {
                        Y =Y1= y + ry;
                        LY = length - rx / 2;
                    }
                }
            }
            else{
                var ry = options.height / 2;
                var length = options.width;
                var rx= ry/4;
                Y=Y1=y;
                X=X1=(x+rx);
                AEx = 0;
                AEy = 2 * ry;
                LX = length;
                LY = 0;
                X2 = X + length ;
                Y2 = Y;
                GY = 100;
                if (seriesOption.stacking = true) {
                    if (!seriesOption.isLastSeries) {
                        X2 = (X + length - rx*2);
                        LX =length-rx*2;
                    }
                }
            }
                delete options.x;
                delete options.y;
                delete options.width;
                delete options.height;
                delete options.isColumn;
                //options.stroke = "black";
                while(i--){
                    direction = "M" + X.toString() + "," + Y.toString();
                    direction += "a" + rx.toString() + "," + ry.toString() + " 0 1,0 " + AEx.toString() + "," + AEy.toString();
                    direction += "a" + rx.toString() + "," + ry.toString() + " 0 1,0 " + (-1*AEx).toString() + "," + (-1*AEy).toString();
                    options.d = direction;
                    options.id = id + "_" + "Region_" + i;
                    options.fill = ej.Ej3DRender.prototype.polygon3D.prototype.applyZLight(gradientColor, obj);
                    this.drawPath(options, element);
                    X=X2;
                    Y=Y2;
                }
                direction = "M" + X1.toString() + "," + Y1.toString();
                    direction += "a" + rx.toString() + "," + ry.toString() + " 0 1,0 " + AEx.toString() + "," + AEy.toString();
                    direction += "l" + LX.toString()+ " " + LY.toString();
                    direction += "a" + rx.toString() + "," + ry.toString() + " 0 1,1 " + (-1*AEx).toString() + "," + (-1*AEy).toString() + " z";
              
            options.d = direction;
            options.id = id + "_" + "Region_2";
            if (fillColor.indexOf("url") == -1) {
                var gradientId = id.substring(0, id.indexOf('P'));
                if ($("#" + gradientId).length == 0) {

                    var optiong = { 'id': gradientId, x1: "0%", y1: "0%", x2: GX.toString() + "%", y2: GY.toString() + "%" };
                    var gradientele = [];
                    gradientele[0] = { colorStop: "0%", color: gradientColor };
                    gradientele[1] = { colorStop: "30%", color: ej.Ej3DRender.prototype.polygon3D.prototype.applyXLight(gradientColor, obj) };
                    gradientele[2] = { colorStop: "70%", color: ej.Ej3DRender.prototype.polygon3D.prototype.applyXLight(gradientColor, obj) };
                    gradientele[3] = { colorStop: "100%", color: gradientColor };
                    this.drawGradient(optiong, gradientele, element);
                }
                options.fill = "url(#" + gradientId + ")";
            }
            this.drawPath(options, element);
           
        }
    },
    
    createGradientElement: function (name, colors, x1, y1, x2, y2, element) {
        var colorName;
        if (Object.prototype.toString.call(colors) == '[object Array]') {
            var options = {
                'id': this.svgObj.id + '_' + name + 'Gradient',
                'x1': x1 + '%',
                'y1': y1 + '%',
                'x2': x2 + '%',
                'y2': y2 + '%'
            };
            var cName = '#' + this.svgObj.id + '_' + name + 'Gradient';
                this.drawGradient(options, colors, element);
            colorName = 'url(#' + this.svgObj.id + '_' + name + 'Gradient)';
        }
        else {
            colorName = colors;
        }
        return colorName;
    },

    drawGradient: function (options, gradientEle, element) {

        var defs = this.createDefs();
        var linerGradient = document.createElementNS(this.svgLink, "linearGradient");
	
        $(linerGradient).attr(options);
        for (var i = 0; i < gradientEle.length; i++) {
            var stop = document.createElementNS(this.svgLink, "stop");
            $(stop).attr({
                'offset': gradientEle[i].colorStop,
                'stop-color': gradientEle[i].color,
                'stop-opacity': 1
            });
            $(stop).appendTo(linerGradient);
        }

        $(linerGradient).appendTo(defs);
        $(defs).appendTo(element);
    },

    drawText: function (options, label, groupEle,font) {
        
        if ($("#" + options.id).length > 0) 
            this._textAttrReplace(options, label,font);           
       else{
            var text = document.createElementNS(this.svgLink, "text");
            var $text = $(text);


            if (jQuery.type(label) == "array") {
                var j = 0;
                $text.attr(options);
                for (var i = 0; i < label.length; i++) {
                    var textspan = document.createElementNS(this.svgLink, "tspan");
                    textspan.textContent = label[i];
                    $(textspan).attr({ "x": options.x, "dy": j });
                    $(textspan).appendTo(text);
                    var bounds = ej.EjSvgRender.utils._measureText(label[i],null,font);
                    j = bounds.height+2;
                }
            } else {
                text.textContent = label;
                $text.attr(options);
            }
            $text.appendTo(groupEle);

 
        }
    },
    //text element attributes values are replaced 
    _textAttrReplace: function (options, label, font) {
        $("#" + options.id).attr(options);

        if (jQuery.type(label) == "array") {
            var elements = $("#" + options.id).children("tspan");
            var j = 0;
            if (elements.length > 0 && elements.length == label.length) {
                for (var i = 0; i < elements.length; i++) {
                    var element = elements[i];
                    $(element).attr({ "x": options.x, "dy": j });
                    element.textContent = label[i];
                    var bounds = ej.EjSvgRender.utils._measureText(label[i], null, font);
                    j = bounds.height + 2;
                }
            }
            else {
                $("#" + options.id).remove();
                this.drawText(options, label, this.gTransToolEle,font);

            }
        } else {
            $("#" + options.id).text(label);
        }

    },

    drawImage: function (options, element) {

        var img = document.createElementNS(this.svgLink, 'image');
        img.setAttributeNS(null, 'height', options.height);
        img.setAttributeNS(null, 'width', options.width);
        img.setAttributeNS('http://www.w3.org/1999/xlink', 'href', options.href);
        img.setAttributeNS(null, 'x', options.x);
        img.setAttributeNS(null, 'y', options.y);
        img.setAttributeNS(null, 'id', options.id);
        img.setAttributeNS(null, 'visibility', options.visibility);
        if (!ej.util.isNullOrUndefined(options.clippath) || !ej.util.isNullOrUndefined(options.preserveAspectRatio)) {
            img.setAttributeNS(null, 'clip-path', options.clippath);
            img.setAttributeNS(null, "preserveAspectRatio", options.preserveAspectRatio);
        }
        $(img).appendTo(element);

    },

    createDefs: function () {
        var defs = document.createElementNS(this.svgLink, "defs");
        return defs;
    },

    createClipPath: function (options) {
        var clipPath = document.createElementNS(this.svgLink, "clipPath");
        $(clipPath).attr(options);
        return clipPath;
    },
    createForeignObject: function (options) {
        var object = document.createElementNS(this.svgLink, "foreignObject");
        $(object).attr(options);
        return object;
    },
    createGroup: function (options) {
        var group = document.createElementNS(this.svgLink, "g");
        $(group).attr(options);
        return group;
    },
    createPattern: function (options,element) {
        var pattern = document.createElementNS(this.svgLink, element);
        for (var name in options) {
            if (options.hasOwnProperty(name)) {
                pattern.setAttribute(name, options[name]);
            }
        }
        return pattern;
    },
    createText: function (options, label) {
        var text = document.createElementNS(this.svgLink, "text");
        $(text).attr(options);
        if (!ej.util.isNullOrUndefined(label))
            text.textContent = label;
        return text;
    },

    createPath: function (options) {
        var path = document.createElementNS(this.svgLink, "path");
        $(path).attr(options);
        return path;
    },

    createCircle: function (options) {
        var circle = document.createElementNS(this.svgLink, "circle");
        $(circle).attr(options);
        return circle;
    },

    createLine: function (options) {
        var line = document.createElementNS(this.svgLink, "line");
        $(line).attr(options);
        return line;
    },

   
    _getAttrVal: function (ele, val, option) {
        var value = $(ele).attr(val);
        if (value != null)
            return value;
        else
            return option;
    },
 
    
    hexFromRGB: function (color) {
        var r = color.R;
        var g = color.G;
        var b = color.B;
        if (color.A) {
            var returncolor = "rgba(" + r.toString() + "," + g.toString() + "," + b.toString() + "," + color.A + ")";
            return returncolor;
        }
        else {
            var hex = [r.toString(16), g.toString(16), b.toString(16)];
            $.each(hex, function (nr, val) { if (val.length === 1) { hex[nr] = "0" + val; } });
            return "#" + (hex.join("").toUpperCase());
        }
    },

    checkColorFormat: function (color) {
        return /(rgba?\((?:\d{1,3}[,\)]){3}(?:\d+\.\d+\))?)|(^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$)/gmi.test(color);
    },

    hexToRGB: function (hex) {
        var rgbRegex = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/.test(hex);
        var result;
        if (rgbRegex == true) {
            result = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/.exec(hex);
            return result ? {
                R: parseInt(result[1]),
                G: parseInt(result[2]),
                B: parseInt(result[3]),
                A: result[4],
            } : null;
        }
        else {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                R: parseInt(result[1], 16),
                G: parseInt(result[2], 16),
                B: parseInt(result[3], 16)
            } : null;
        }
    },


    createDelegate: function (context, handler) {
        return function (e) {
            handler.apply(context, [e, this]);
        };
    },

    drawClipPath: function (options, element) {
		//To avoid creating and appending the same element more than once
		if($(element).find('#' + options.id).length > 0)
		{
			$(element).find('#' + options.id).attr(options);
		}
		else
		{
			var defs = this.createDefs();
			var clipPath = this.createClipPath({ 'id': options.id });
			this.drawRect(options, clipPath);
			this.append(clipPath, defs);
			this.append(defs, element);
		}
    },

    drawCircularClipPath: function (options, element) {
        var defs = this.createDefs();
        var clipPath = this.createClipPath({ 'id': options.id });
        this.drawCircle(options, clipPath);
        this.append(clipPath, defs);
        this.append(defs, element);
    },
   
   append: function (childEle, parentEle) {
        $(childEle).appendTo(parentEle);
   },
   _setAttr: function (element, attribute) {
       $(element).attr(attribute);
   }
};

ej.EjSvgRender.commonChartEventArgs = {
    cancel: false,
    data: null
};
ej.EjSvgRender.utils = {

   

    _decimalPlaces: function (num) {
        var match = ('' + num).match(/(?:\.(\d+))?(?:[eE]([+-]?\d+))?$/);
        if (!match) { return 0; }
        return Math.max(
       0,
        // Number of digits right of decimal point.
       (match[1] ? match[1].length : 0)
        // Adjust for scientific notation.
       - (match[2] ? +match[2] : 0));
    },
    _getLabelContent: function (pos, axis, locale) {
        switch (axis._categoryValueType) {
            case 'number':
                var customFormat = (ej.util.isNullOrUndefined(axis.labelFormat)) ? null : axis.labelFormat.match('{value}');
                return (ej.util.isNullOrUndefined(axis.labelFormat)) ? axis.labels[Math.floor(pos)] : (customFormat != null) ? axis.labelFormat.replace('{value}', axis.labels[Math.floor(pos)]) : (ej.format(axis.labels[Math.floor(pos)], axis.labelFormat, locale));
            case 'date':
                return (ej.format(new Date(axis.labels[Math.floor(pos)]), ((ej.util.isNullOrUndefined(axis.labelFormat)) ? "dd/MM/yyyy" : axis.labelFormat), locale));
            case 'string':
                return axis.labels[Math.floor(pos)];
            default:
                return "";
        }
    },
    
    //Calculation for label size in template
    _getSeriesTemplateSize: function (point, pointIndex, series, isLeft, sender) {
        var point;
        var pointIndex;
        var areaType = sender.model.AreaType;
         
        var chartContainer = sender._id;
        var seriesIndex = $.inArray(series, sender.model._visibleSeries);

            if ($('#template_group_' + chartContainer).length != 0)
                var templateContainer = $('#template_group_' + chartContainer);
            else
                templateContainer = $("<div></div>").attr('id', "template_group_" + chartContainer);

            templateContainer.css('position', 'relative').css('z-index', 1000);
            var cloneNode = $("#" + series.marker.dataLabel.template).clone();
            $(cloneNode).attr("id", series.marker.dataLabel.template + '_' + seriesIndex + '_' + pointIndex + '_' + chartContainer);
            var $cloneNode = $(cloneNode);
            $cloneNode.css("position", "absolute");
           
            point.count = 1;
            var data = { series: series, point: point };
            $cloneNode.html($cloneNode.html().parseTemplate(data));

            var display = (areaType == "cartesianaxes" || !series.enableAnimation || (series.type.toLowerCase() == "pyramid" || series.type.toLowerCase() == "funnel")) ? "block" : "none";
            $cloneNode.css("display", display).appendTo($(templateContainer));
            $(templateContainer).appendTo('#' + chartContainer);
            point.size = { height: $cloneNode.height(), width: $cloneNode.width() };
         
            if (isLeft) {
                if (ej.util.isNullOrUndefined(series.LeftLabelMaxHeight) || series.LeftLabelMaxHeight < point.size.height) {
                    series.LeftLabelMaxHeight = point.size.height;
                }
                if (ej.util.isNullOrUndefined(series.LeftLabelMaxWidth) || series.LeftLabelMaxWidth < point.size.width) {
                    series.LeftLabelMaxWidth = point.size.width;
                }
            }
            else {
                if (ej.util.isNullOrUndefined(series.RightLabelMaxHeight) || series.RightLabelMaxHeight < point.size.height) {
                    series.RightLabelMaxHeight = point.size.height;
                }
                if (ej.util.isNullOrUndefined(series.RightLabelMaxWidth) || series.RightLabelMaxWidth < point.size.width) {
                    series.RightLabelMaxWidth = point.size.width;
                }
            }
        
    },
    getMinPointsDelta: function (axis, chartObj, start) {
        var chart = chartObj;
        var m_minPointsDelta = Number.MAX_VALUE;
        $.each(chart.model._visibleSeries, function (index, series) {
            if (series.visibility.toLowerCase() == 'visible' && axis.name == series._xAxisName) {
                var xValues = ej.DataManager(series.points, ej.Query().sortBy("xValue")).executeLocal();
                if ((xValues.length == 1) && (!chart.currentSeries || chart.currentSeries._yAxisName.toLowerCase() == series._yAxisName.toLowerCase())) {
                    var minValue = ej.util.isNullOrUndefined(start) ? series.xAxis.visibleRange.min : start;
                    var delta = xValues[0].xValue - minValue;
                    if (delta != 0)
                        m_minPointsDelta = Math.min(m_minPointsDelta, delta);
                }
                else {
                    $.each(xValues, function (pointIndex, point) {
                        if (pointIndex > 0 && point.xValue) {
                            var deltaValue = point.xValue - xValues[pointIndex - 1].xValue;
                            if (deltaValue != 0) {
                                m_minPointsDelta = Math.min(m_minPointsDelta, deltaValue);
                            }
                        }
                    });
                }
            }
        });

        if (m_minPointsDelta == Number.MAX_VALUE) {
            m_minPointsDelta = 1;
        }
        return m_minPointsDelta;
    },
    //Calculation for label size
    _getSeriesMaxLabel: function (series) {
        var maxTxtDim = { width: 0, height: 0 };
        var width = $(this.svgObject).width();
        var labels=[];
        if (series.labels.length > 0) {
            for (var j = 0; j < series.labels.length; j++) {
                var dim = this._measureText(series.visibleLabels[j], width, series.marker.dataLabel.font);
                if (maxTxtDim.width < dim.width) {
                    maxTxtDim.width = dim.width;
                }
                if (maxTxtDim.height < dim.height) {
                    maxTxtDim.height = dim.height;
                }
            }
            series.LabelMaxHeight = maxTxtDim.height;
            series.LabelMaxWidth = maxTxtDim.width;
        }
        else {
            labels.push(series.rightsidePoints);
            labels.push(series.leftsidePoints);

            for (var k = 0; k < labels.length; k++) {
                for (var j = 0; j < labels[k].length; j++) {
                    var text = (labels[k][j].text) ? labels[k][j].text : labels[k][j].y;
                    var dim = this._measureText(text, width, series.marker.dataLabel.font);
                    if (maxTxtDim.width < dim.width) {
                        maxTxtDim.width = dim.width;
                    }
                    if (maxTxtDim.height < dim.height) {
                        maxTxtDim.height = dim.height;
                    }
                }
                if (k == 0) {
                    series.RightLabelMaxHeight = maxTxtDim.height;
                    series.RightLabelMaxWidth = maxTxtDim.width;
                }
                else {
                    series.LeftLabelMaxHeight = maxTxtDim.height;
                    series.LeftLabelMaxWidth = maxTxtDim.width;
                }
             }
        }
       

    },
    _getMaxLabelWidth: function (axis, sender) {
        this.chartObj = sender;
        var maxTxtDim = { width: 0, height: 0, maxHeight:0, maxWidth:0 };
        var rotateLabel = '';
        var currentRow = 1;
        var vmlrendering = sender.svgRenderer.vmlNamespace;
        var range = axis.visibleRange;
        var intersectAction = (axis.labelIntersectAction && !sender.model.enable3D) ? axis.labelIntersectAction.toLowerCase() : "";
        var labelPlacement = axis.labelPlacement;
        var opposedPosition = axis.opposedPosition;
        var orientation = axis.orientation.toLowerCase();
        var isHorizontal = sender.model.requireInvertedAxes ? (orientation == 'vertical') : orientation == 'horizontal';
        var roundingPlaces = axis.roundingPlaces;
        var labelRotation = axis.labelRotation;
        var orientation = axis.orientation;
        var maxHeight = 0;
        var prevLabels = [];
        var visibleLabels = axis.visibleLabels;
        var visibleLabelsLength =visibleLabels.length;
        if (axis.visible) {
                for (var j = 0; j < visibleLabelsLength ; j++) {
                    axis.visibleLabels[j].y = 0;
                    var dim = this._measureText(axis.visibleLabels[j].Text, $(this.svgObject).width(), axis.font, axis.labelRotation);
                    if (maxTxtDim.width < dim.width) {
                        maxTxtDim.width = dim.width;
                        rotateLabel = axis.visibleLabels[j].Text;
                    }
                    if (maxTxtDim.height < dim.height)
                        maxTxtDim.height = dim.height;
                }
			
			if (axis.enableTrim){   // for enable trim
			  var derivedGap = axis.maximumLabelWidth;
			  maxTxtDim.width = maxTxtDim.width > derivedGap ? derivedGap : maxTxtDim.width;
			}
			
            // initialize rows to 1
            maxTxtDim.rows = 1;
            maxTxtDim.maxWidth = maxTxtDim.width;
            maxTxtDim.maxHeight = maxTxtDim.height;
        
            if (!vmlrendering && (labelRotation ||intersectAction)) {
                var intersectRotation = 0;
                if (intersectAction == 'rotate45')
                    intersectRotation = 45;
                else if (intersectAction == 'rotate90')
                    intersectRotation = 90;
                labelRotation = labelRotation!=null || orientation== "vertical" ? labelRotation : intersectRotation;
                axis.rotationValue = labelRotation;
                if (labelRotation) {                
                    rotateLabel = (!ej.isNullOrUndefined(rotateLabel)) ? rotateLabel : '';
					labeltextWidth = this._measureText(rotateLabel, $(this.svgObject).width(), axis.font, axis.labelRotation);
					if (axis.enableTrim && labeltextWidth.width > derivedGap && rotateLabel != "") { // to find trimmed text
					  var t, textWidth, text = rotateLabel;
                      for (t = 1; t < text.toString().length; t++) {
                        text = text.toString().substring(0, t) + '... ';
                        textWidth = this._measureText(text, $(sender.svgObject).width(), axis.font);
                        if (textWidth.width >= derivedGap) {
                            text = text.toString().substring(0, t - 1) + '... ';
                            rotateLabel = text;
                            break;
                         }
                      }
                    }
					
                    maxSize = this.rotatedLabel(axis, sender, labelRotation, rotateLabel);
                    if (axis.labelIntersectAction && axis.labelIntersectAction.toLowerCase() == 'multiplerows')
                        maxHeight = maxTxtDim.height + maxSize.height;
                    maxTxtDim.height = maxSize.height;
					maxTxtDim.width = maxSize.width;
                }
            }

                if (axis.labelIntersectAction) {
                    if (intersectAction == 'wrap' || intersectAction == 'wrapbyword') {
                        // pointX calculation to find the gap between the ticks
                        var pointX, tempInterval;
                        labelPlacement = (!(labelPlacement)) ? ej.datavisualization.Chart.LabelPlacement.BetweenTicks : labelPlacement;
                        if (labelPlacement.toLowerCase() == "betweenticks") {          
                            tempInterval = 1 + (axis.labels.length > 1 ? -0.5 : 0);
                            tempInterval = (!(roundingPlaces)) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(range.interval) == 0 ?
                                1 : ej.EjSvgRender.utils._decimalPlaces(range.interval)))) : parseFloat(tempInterval.toFixed(roundingPlaces));
                            pointX = Math.ceil(((tempInterval - range.min) / (range.max - range.min)) * (axis.length));
                        }
                        else {
                            pointX = Math.ceil(axis.length / visibleLabels.length);
                        }
                        var row = Math.round(maxTxtDim.width / pointX);
                        maxTxtDim.rows = labelRotation ? row - currentRow : row + currentRow;
                        maxTxtDim.height = (maxTxtDim.height + (row) * maxTxtDim.height);
                    }
                    else if (intersectAction == 'multiplerows') {
                        var spaceValue = sender._getLegendSpace();
                        var chartBorderWidth = sender.model.border.width;
                      
                        var verticalaxis = sender.model._axes[1];
                        var realWidth = $(sender.svgObject).width() - sender.model.margin.left - sender.model.margin.right;
                        var axisTitleHeight = (axis.title.text == "" || !(axis.visible)) ? 0 : (this._measureText(axis.title.text, realWidth, axis.title.font).height + (2 * sender.model.elementSpacing));
                        var vAxesWidth = sender.model.elementSpacing + axisTitleHeight + axis.majorTickLines.size + axis.axisLine.width;
                        var yLabels = sender._getYValues(sender.model._visibleSeries[0].points);
                        var largest = Math.max.apply(Math, yLabels);
                        var vaxis = sender.model._axes[1];
                        var dim = this._measureText(largest, $(this.svgObject).width(), vaxis.font, vaxis.labelRotation);
 
                        var rightSpacing = spaceValue.rightLegendWidth + vAxesWidth + dim.width + sender.model.margin.right + sender.model.margin.left + (2 * chartBorderWidth);
                        var boundsWidth = $(sender.svgObject).width() - (rightSpacing);
                        if (isHorizontal) {
                            var addedMaxHeight = 0;
                            //loop to get current label
                            for (j = 0; j < visibleLabels.length; j++) {
                                //declaration
                                var currentLabel = visibleLabels[j];
                                var flag = false, isMultiRows = false;
                                maxHeight = Math.max(maxHeight, addedMaxHeight)
                                addedMaxHeight = currentLabel.y = maxTxtDim.height;
                                var text = this._measureText(currentLabel.Text, $(this.svgObject).width(), axis.font);
                                var textWidth = text.width;
                                var textHeight = text.height;
                                var currentPoint = Math.abs(Math.floor(((currentLabel.Value - range.min) / (range.delta)) * (boundsWidth)));
                                // loop to get previous labels                         
                                for (var k = 0; k < prevLabels.length && !flag; k++) {
                                    for (var l = 0; prevLabels[k] && l < prevLabels[k].length; l++) {
                                        var prevLabel = prevLabels[k][l];
                                        var prevPoint = Math.abs(Math.floor(((prevLabel.Value - range.min) / (range.delta)) * (boundsWidth)));
                                        var preTextWidth = this._measureText(prevLabel.Text, $(this.svgObject).width(), axis.font).width;
                                        var value = prevPoint + preTextWidth / 2;
                                        if (value > currentPoint - textWidth / 2 && !ej.util.isNullOrUndefined(currentLabel.y)) {
                                            addedMaxHeight = currentLabel.y + textHeight;
                                            currentLabel.y += textHeight;
                                            if (k + 1 == prevLabels.length)
                                            flag = true;
                                        }
                                        else {
                                            if (l + 1 == prevLabels[k].length) {
                                                flag = true;
                                                break;
                                            }
                                        }
                                    }
                                  
                                 }
                                currentLabel.y = addedMaxHeight;
                                row = (addedMaxHeight / textHeight) - 1;
                                if( prevLabels[row]==undefined)
                                prevLabels[row] = [];
                                prevLabels[row].push(currentLabel);
                               
                            }
                            maxHeight = (prevLabels.length * textHeight);
                         //   maxHeight = opposedPosition ? maxHeight + textHeight : maxHeight;
                            maxTxtDim.height = maxTxtDim.height > maxHeight ? maxTxtDim.height : maxHeight;
                            //calculating rows
                            if (opposedPosition)
                                maxTxtDim.rows = Math.round((maxHeight + textHeight) / textHeight);
                            else
                                maxTxtDim.rows = Math.round(maxHeight / textHeight);
                            maxTxtDim.rows = labelRotation ? maxTxtDim.rows - 1 : maxTxtDim.rows ;
                            if (maxTxtDim.rows < 1) maxTxtDim.rows = 1;
                        }
                        if (!isHorizontal) {
                            var addedMaxWidth = 0;
                            //loop to get current label
                            for (j = 0; j < axis.visibleLabels.length; j++) {
                                currentLabel = axis.visibleLabels[j];
                                text = this._measureText(currentLabel.Text, $(this.svgObject).width(), axis.font);
                                textWidth = text.width;
                                textHeight = text.height;
                                currentPoint = Math.abs(Math.floor(((currentLabel.Value - axis.visibleRange.min) / (axis.visibleRange.delta)) * (axis.length)));
                                for (i = 0; i < j; i++) {
                                    // loop to get previous labels
                                    prevLabel = axis.visibleLabels[i];
                                    prevPoint = Math.abs(Math.floor(((prevLabel.Value - axis.visibleRange.min) / (axis.visibleRange.delta)) * (axis.length)));
                                    var prevTextHeight = this._measureText(prevLabel.Text, $(this.svgObject).width(), axis.font).height;
                                    value = prevPoint + prevTextHeight / 2;
                                    if (value > currentPoint - textHeight / 2 && axis.visibleLabels[i].y == currentLabel.y) {
                                        addedMaxWidth = currentLabel.y + textWidth;
                                        currentLabel.y = addedMaxWidth;
                                        isMultiRows = true;
                                    }
                                }
                               var maxheight = addedMaxWidth;
                            }
                            // label width + multiple rows width + gap between the rows added only on text render in multiple rows
                            maxTxtDim.width = maxTxtDim.width + maxheight + (isMultiRows ? 5 : 0);
                        }
                    }
               }
        }
        return maxTxtDim;
    },
	
        rotatedLabel: function (axis, sender, value, rotatedLabel) {
            // to get height of rotated labels
            var rotatedOptions = {
                'font-size': axis.font.size,
                'transform': 'rotate(' + value + ',0,0)',
                'font-family': axis.font.fontFamily,
                'font-style': axis.font.fontStyle,
                'rotateAngle' : 'rotate('+ value +'deg)',
                'text-anchor': 'middle'
            };
            var text = sender.svgRenderer.createText(rotatedOptions, rotatedLabel);
            var height = Math.ceil((this._measureBounds(text, sender).height));
			var width = Math.ceil((this._measureBounds(text, sender).width));
            return {height: height, width: width};
        },
		
    _getTransform: function (xAxis, yAxis, invertedAxis) {
        var x , y , width, height;
        if (invertedAxis) {
            x = yAxis.x;
            y = xAxis.y;
            width = yAxis.width;
            height = xAxis.height;
        } else {
            {
                x = xAxis.x;
                y = yAxis.y;
                width = xAxis.width;
                height = yAxis.height;
            }
        }
        return { x: x, y: y, width: width, height: height };
    },
    //calculate path for roundedCorner of the series column,bar,stacking column,stacking bar,range column
    _calculateroundedCorner: function (options, isArrow, orientation, tipPosition, tracker) {
        var x1 = options.x, y1 = options.y, padding = 5, canvasPadding = (this.chartObj.model.enableCanvasRendering && !tracker) ? padding / 4 : 0,
		width = options.width, height = options.height,
          cornerRadius = options.cornerRadius, topLeft,
        	bottomLeft, topRight, bottomRight, d;
        		
        		if (typeof(cornerRadius) != "object")
        			topLeft = bottomLeft = topRight = bottomRight = cornerRadius;
        		else {
        		    topLeft = cornerRadius.topLeft;
        		    bottomLeft = cornerRadius.bottomLeft;
        		    topRight = cornerRadius.topRight;
        		    bottomRight = cornerRadius.bottomRight;
        		}
        		topLeft = ej.util.isNullOrUndefined(options.rx) ? topLeft : options.rx;
        		bottomLeft =  ej.util.isNullOrUndefined(options.rx) ? bottomLeft : options.rx;
        		topRight = ej.util.isNullOrUndefined(options.ry) ? topRight : options.ry;
        		bottomRight = ej.util.isNullOrUndefined(options.ry) ? bottomRight : options.ry;

		d = "M" + " " + x1 + " " + (topLeft + y1) + " Q " + x1 + " " + y1 + " " + (x1 + topLeft) + " " + y1 + " ";
        if (isArrow && orientation == "top")            
            d += "L " + (x1 + width / 2 - padding / 2 + canvasPadding) + " " + (y1) + " L " + (x1 + width / 2 + canvasPadding - tipPosition) + " " + (y1 - padding) + " L " + (x1 + width / 2 + padding / 2 + canvasPadding) + " " + (y1) + " ";
        d += "L" + " " + (x1 + width - topRight) + " " + y1 + " Q " + (x1 + width) + " " + y1 + " " + (x1 + width) + " " + (y1 + topRight) + " ";
        if (isArrow && orientation == "right")
            d += "L " + (x1 + width) + " " + (y1 + height / 2 - padding / 2 + canvasPadding) + " L " + (x1 + width + padding) + " " + (y1 + height / 2 + canvasPadding - tipPosition) + " L " + (x1 + width) + " " + (y1 + height / 2 + padding / 2 + canvasPadding) + " ";
        d += "L " + (x1 + width) + " " + (y1 + height - bottomRight) + " Q " + (x1 + width) + " " + (y1 + height) + " " + (x1 + width - bottomRight) + " " + (y1 + height) + " ";
        if (isArrow && orientation == "bottom")
            d += "L " + (x1 + width / 2 - padding / 2 + canvasPadding) + " " + (y1 + height) + " L " + (x1 + width / 2 + canvasPadding - tipPosition) + " " + (y1 + height + padding) + " L " + (x1 + width / 2 + padding / 2 + canvasPadding) + " " + (y1 + height) + " ";
        d += "L " + (x1 + bottomLeft) + " " + (y1 + height) + " Q " + x1 + " " + (y1 + height) + " " + x1 + " " + (y1 + height - bottomLeft) + " ";
        if (isArrow && orientation == "left")
            d += "L " + (x1) + " " + (y1 + height / 2 - padding / 2 + canvasPadding) + " L " + (x1 - padding) + " " + (y1 + height / 2 + canvasPadding - tipPosition) + " L " + (x1) + " " + (y1 + height / 2 + padding / 2 + canvasPadding) + " ";
        d += "L" + " " + x1 + " " + (topLeft + y1) + " " + "z";
        return d;
       
    },
    browserInfo: function () {
        var browser = {}, clientInfo = [],
        browserClients = {
            webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
            opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        for (var client in browserClients) {
            if (browserClients.hasOwnProperty(client)) {
                clientInfo = navigator.userAgent.match(browserClients[client]);
                if (clientInfo) {
                    browser.name = clientInfo[1].toLowerCase();
                    browser.version = clientInfo[2];
                    if (!!navigator.userAgent.match(/Trident\/7\./)) {
                        browser.name = "msie";
                    }
                    break;
                }
            }
        }
        browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
        browser.pointerEnabled = window.navigator.pointerEnabled;
        return browser;
    },
    _measureText: function (text, maxwidth, font) {
        var element = $(document).find("#measureTex");
		$("#measureTex").css('display', 'block'); // fixed for scroll issue in sample browser
        if (element.length==0) {
            var textObj = document.createElement('text');
            $(textObj).attr({ 'id': 'measureTex'});
            document.body.appendChild(textObj);
        }
        else
        {
            var textObj = element[0];
        }
       
        var style = null, size = null, family = null, weight = null;
        if (typeof (text) == "string" && ( text.indexOf("<") > -1 || text.indexOf(">") > -1)) {
                var textArray = text.split(" ");
                for (var i = 0; i < textArray.length; i++) {
                    if (textArray[i].indexOf("<br/>") == -1)
                       textArray[i]=textArray[i].replace(/[<>]/g, '&');                
                     }
                    text=textArray.join(' ');           
         }
        textObj.innerHTML = text;
        if (font != undefined && font.size == undefined) {
            var fontarray = font;
            fontarray=fontarray.split(" ");
            style = fontarray[0];
            size = fontarray[1];
            family = fontarray[2];
            weight = fontarray[3];
        }
       
        if (font != null) {
            textObj.style.fontSize = (font.size > 0) ? (font.size + "px") : font.size? font.size : size ;
            if (textObj.style.fontStyle) 
     			textObj.style.fontStyle = (font.fontStyle)? font.fontStyle : style;
            textObj.style.fontFamily = font.fontFamily ? font.fontFamily : family;
            if(window.navigator.userAgent.indexOf('MSIE 8.0')==-1)
                textObj.style.fontWeight = font.fontWeight ? font.fontWeight : weight;
        }
        textObj.style.backgroundColor = 'white';
        textObj.style.position = 'absolute';
        textObj.style.top = -100;
        textObj.style.left = 0;
        textObj.style.visibility = 'hidden';
        textObj.style.whiteSpace = 'nowrap';
        if (maxwidth)
            textObj.style.maxwidth = maxwidth + "px";
         
    
        var bounds = { width: textObj.offsetWidth, height: textObj.offsetHeight };
        $("#measureTex").css('display', 'none'); // fixed for scroll issue in sample browser
        return bounds;
    },
    //to trim legend text
    _trimText: function (legendtext, maxwidth, font) {
        var textWidth, text,textLength;
        text = legendtext.toString();
        textLength=text.length;
        for (var t = 1; t < textLength; t++) {
            text = legendtext.substring(0, t) + '...';
            textWidth = ej.EjSvgRender.utils._measureText(text, null, font).width;
            if (textWidth >= maxwidth) {
                text = text.substring(0, t - 1) + '... ';
                return text;
            }
        }
        return legendtext;
    },
    _measureBounds: function (element, sender) {
        if (sender.model.enableCanvasRendering) 
             $(document.body).append(element);
         else {
            sender.svgRenderer.append(element, sender.svgObject);
            sender.svgRenderer.append(sender.svgObject, sender.element);
        }
        var box = element.getBoundingClientRect();
        var bounds = { left: box.left, right: box.right, top: box.top, bottom: box.bottom, width: (box.right - box.left), height: (box.bottom - box.top) };
        $(element).remove();
        return bounds;
    },
    //Draw clip path for each series to avoid series overlap in multiple axes zooming
    _drawAxesBoundsClipPath: function (gSeriesGroupEle, options, sender) {
        var clipOptions;
        var element = $(gSeriesGroupEle);
        var trans = this._getTransform(options.xAxis, options.yAxis, sender.model.requireInvertedAxes);
        var width = (sender.model.AreaType == "polaraxes") ? $(sender.svgObject).width() : trans.width;
        var height = (sender.model.AreaType == "polaraxes") ? $(sender.svgObject).height() : trans.height;

        var hPlotOffset = sender.model.requireInvertedAxes ? options.yAxis.plotOffset : options.xAxis.plotOffset;
        var vPlotOffset = sender.model.requireInvertedAxes ? options.xAxis.plotOffset : options.yAxis.plotOffset;
        if (sender.model.AreaType == 'polaraxes') {
            clipOptions = {
                'id': gSeriesGroupEle ? gSeriesGroupEle.id + '_ClipRect' : '',
                'cx': sender.model.centerX,
                'cy': sender.model.centerY,
                'r': sender.model.Radius,
                'fill': 'white',
                'stroke-width': 1,
                'stroke': 'transparent'
            };
            sender.svgRenderer.drawCircularClipPath(clipOptions, gSeriesGroupEle);
        }
        else {
            clipOptions = {
                'id': gSeriesGroupEle ? gSeriesGroupEle.id + '_ClipRect' : '',
                'x': (0 - hPlotOffset),
                'y': (0 - vPlotOffset),
                'width': (width + 2 * hPlotOffset),
                'height': (height + 2 * vPlotOffset),
                'fill': 'white',
                'stroke-width': 1,
                'stroke': 'transparent'
            };
            sender.svgRenderer.drawClipPath(clipOptions, gSeriesGroupEle);
        }
                
        element.attr('clip-path', 'url(#' + clipOptions.id + ')');

    },
    _getStringBuilder: function () {

        var data = [];
        var counter = 0;

        return {
            // adds string s to the stringbuilder

            append: function (s) {
                data[counter++] = s;
                return this;
            },

            // removes j elements starting at i, or 1 if j is omitted

            remove: function (i, j) {
                data.splice(i, j || 1);
                return this;
            },

            // inserts string s at i

            insert: function (i, s) {
                data.splice(i, 0, s);
                return this;
            },

            // builds the string

            toString: function (s) { return data.join(s || ""); }
        };


    },
    _addRegion: function (chart, bounds, series, point, pointIndex) {
	    var type = series.type;
        var seriesIndex = $.inArray(series, chart.model._visibleSeries);
        if (seriesIndex >= 0) {
	        var regionItem = { SeriesIndex: seriesIndex, Region: { PointIndex: pointIndex, Bounds: bounds }, type: type };
	        chart.model.chartRegions.push(regionItem);
	    }
    },

    AddRegion: function (chart, bounds, isStripLine) {
       
        if (isStripLine) {
            var regionItem = { isStripLine: isStripLine, Region: { Bounds: bounds } };
            chart.model.chartRegions.push(regionItem);
        }
    },


    _getSvgXY: function (x, y, series, sender) {
        var svgX, svgY;
        if (!(sender.model.requireInvertedAxes)) {
              svgX = x + series.xAxis.x;
              svgY = y + series.yAxis.y;
        } else {
              svgX = x + series.yAxis.x;
              svgY = y + series.xAxis.y;
        }
        return { X: svgX, Y: svgY };
    },
    _getPoint: function (point, series) {
	  
        var x = point.xValue,
         y = series.type == "boxandwhisker" ? point.YValues : point.YValues[0],
         xLength = series._isTransposed ? series.xAxis.height : series.xAxis.width;
        yLength = series._isTransposed ? series.yAxis.width : series.yAxis.height;
        point.location = {};
       
        if (series._hiloTypes) {
            var low = point.YValues[1], low = (series.yAxis._valueType == "logarithmic") ? ej.EjSvgRender.utils._logBase((low == 0 ? 1 : low), series.xAxis.logBase) : low;
            low =  this._getPointXY(low, series.yAxis.visibleRange, series.yAxis.isInversed);        
            point.location.low = (series._isTransposed ?low :(1-low)) * (yLength);                        
        }

        var xvalue = (series.xAxis._valueType == "logarithmic") ? ej.EjSvgRender.utils._logBase((x == 0 ? 1 : x), series.xAxis.logBase) : x;
        var yvalue = (series.yAxis._valueType == "logarithmic") ? ej.EjSvgRender.utils._logBase((y == 0 ? 1 : y), series.xAxis.logBase) : y;
     
       
        xvalue = (this._getPointXY(xvalue, series.xAxis.visibleRange, series.xAxis.isInversed));
        yvalue = this._getPointXY(yvalue, series.yAxis.visibleRange, series.yAxis.isInversed);
        point.location.X = series._isTransposed ? yvalue * (yLength) : xvalue * (xLength);
        point.location.Y = series._isTransposed ? (1 - xvalue) * (xLength) : (1 - yvalue) * (yLength);
        
        return point.location;
        
        
           
       
    },
    _getPointXY: function (value, Range, isInversed) {
         
        var result = 0;
        result = (value - Range.min) / (Range.delta);
		result = isNaN(result) ? 0 : result;
        return (isInversed) ? (1 - result) : result;   
        
    },
    
    _dateTimeLabelFormat: function (intervalType) {
        var format = 'd';
        if (intervalType.toLowerCase() == 'years')
            format = 'MMM, yyyy';
        else if (intervalType.toLowerCase() == 'months')
            format = 'dd, MMM';
        else if (intervalType.toLowerCase() == 'days')
            format = 'MM/dd/yyyy';
        else if (intervalType.toLowerCase() == 'hours')
            format = 'dd, hh:mm';
        else if (intervalType.toLowerCase() == 'seconds' || intervalType.toLowerCase() == 'minutes')
            format = 'hh:mm:ss';
        else if (intervalType.toLowerCase() == 'milliseconds')
            format = 'hh:mm:ss:tt';
        return format;
    },
    _getFontString: function (fontObj) {
        if (fontObj == null)
            fontObj = {};
        if (!fontObj.FontFamily)
            fontObj.FontFamily = "Arial";
        if (!fontObj.FontStyle)
            fontObj.FontStyle = "Normal";
        if (!fontObj.Size)
            fontObj.Size = "12px";

        return fontObj.FontStyle + " " + fontObj.Size + " " + fontObj.FontFamily;
    },

    _valueToVector: function (axis, value) {
        return this._coefficientToVector(this._valueToPolarCoefficient(axis, value));
    },

    TransformToVisible: function (currentseries, x, y, sender) {
        x = (currentseries.xAxis._valueType == "logarithmic") && x > 0 ? Math.log(x, currentseries.xAxis.logBase) : x;
        y = (currentseries.xAxis._valueType == "logarithmic") && y > 0 ? Math.log(y, currentseries.yAxis.logBase) : y;
        var radius = sender.model.Radius * this._valueToCoefficient(currentseries.yAxis, y);
        //var radius = this.chartObj.model.Radius * ej.EjSvgRender.utils._valueToPolarCoefficient(currentseries.yAxis, y);
        var point = this._valueToVector(currentseries.xAxis, x);
        return { X: sender.model.centerX + radius * point.X, Y: sender.model.centerY + radius * point.Y };
    },

    Transform3DToVisible:function(currentseries, x, y, sender)
    {
      if (currentseries.xAxis != null && currentseries.yAxis != null)
       {
          var valueType = currentseries.xAxis._valueType.toLowerCase();
          var xIsLogarithmic = (valueType == "logarithmic") ? true :false;
          x = x = xIsLogarithmic && x > 0 ? math.log(x, xlogarithmicBase) : x;
          y = y;

       if (sender.model.requireInvertedAxes)
        {
           var left = sender.model.m_AreaBounds.X;
           var top = sender.model.m_AreaBounds.Y;
            var pointX = left + currentseries.yAxis.width * ej.EjSvgRender.utils._valueToCoefficient(currentseries.yAxis, y, sender);
            var pointY = top + currentseries.xAxis.height * (1 - ej.EjSvgRender.utils._valueToCoefficient(currentseries.xAxis, x, sender))
           return { X: pointX, Y: pointY }          
        }
        else
        {
            var left = currentseries.xAxis.x;
            var top = currentseries.yAxis.y;
            var x = left + Math.round(currentseries.xAxis.width * ej.EjSvgRender.utils._valueToCoefficient(currentseries.xAxis, x, sender));
            var y= top + Math.round(currentseries.yAxis.height * (1 - ej.EjSvgRender.utils._valueToCoefficient(currentseries.yAxis,y, sender)));
            return {X:x, Y:y}
        }
    }
                
    return new Point(0, 0);
  },

    _valueToPolarCoefficient:function(axis, value)
         {
          var start = axis.visibleRange.min;
          var delta;
          var length;
          if (axis._valueType != "category") {
              delta = (axis.visibleRange.max - axis.visibleRange.interval) - axis.visibleRange.min;
              length = axis.visibleLabels.length - 1;
          }
          else {
              delta = axis.visibleRange.delta;
              length = axis.visibleLabels.length;
          }

            result = (value - start) / delta;
            result *= 1 - 1 / (length);

            return axis.isInversed ?  result : 1 - result;
        },

    _coefficientToVector: function (coefficient)
       {
            var angle = Math.PI * (1.5 - 2 * coefficient);

            return  {X:Math.cos(angle), Y: Math.sin(angle)};
      },


    _valueToCoefficient: function (axis, value, sender) {
        if (sender && sender.model.AreaType=='polaraxes') {
            var yvalue = value;
        }
        else
        var yvalue = (axis._valueType && axis._valueType.toLowerCase() == "logarithmic") ?
          ej.EjSvgRender.utils._logBase((value == 0 ? 1 : value), axis.logBase) : value;

        yvalue = (yvalue - axis.visibleRange.min) / (axis.visibleRange.delta);
        
        return (axis.isInversed) ? 1 - yvalue : yvalue;
    },
    _getBoundingClientRect: function (element, sender,series,invertedAxes) {
        var box = element.getBoundingClientRect();
        var position = $("#" + (sender.svgObject.id))[0].getBoundingClientRect();
        var xSeries, ySeries;
        if (invertedAxes) {
            xSeries = this._getTransform(series.xAxis, series.yAxis, true).x;
            ySeries = this._getTransform(series.xAxis, series.yAxis, true).y;
        } else {
            xSeries = this._getTransform(series.xAxis, series.yAxis, false).x;
            ySeries = this._getTransform(series.xAxis, series.yAxis, false).y;
        }
        var x = box.left - (xSeries + position.left);
        var y = box.top - (ySeries + position.top);
        return { x: x, y: y, width: (box.right - box.left), height: (box.bottom - box.top) };
    },
    _minMax: function (value, min, max) {
        return value > max ? max : (value < min ? min : value);
    },
    _inside: function (value, range) {
        if (value === "")
            return false;
        return (value <= range.max) && (value >= range.min);
    },
    _logBase: function (val, base) {
        return Math.log(val) / Math.log(base);
    },
    _correctRect: function (x1, y1, x2, y2) {
        return { X: Math.min(x1, x2), Y: Math.min(y1, y2), Width: Math.abs(x2 - x1), Height: Math.abs(y2 - y1) };
    },
    _getValuebyPoint: function (x, y, series) {

        var xSize = (this.chartObj.model.requireInvertedAxes) ? series.xAxis.height : series.xAxis.width;
        var ySize = (this.chartObj.model.requireInvertedAxes) ? series.yAxis.width : series.yAxis.height;
      
        var xValue = (series.xAxis.isInversed) ? (1 - (x / xSize)) : (x / xSize);
        var yValue = (series.yAxis.isInversed) ? (1 - (y / ySize)) : (y / ySize);

        xValue = xValue * (series.xAxis.visibleRange.delta) + series.xAxis.visibleRange.min;

        yValue = yValue * (series.yAxis.visibleRange.delta) + series.yAxis.visibleRange.min;

        xValue = (series.xAxis._valueType == "logarithmic") ? Math.pow(series.xAxis.logBase, xValue) : xValue;

        yValue = (series.yAxis._valueType == "logarithmic") ? Math.pow(series.yAxis.logBase, yValue) : yValue;

        return { PointX: xValue, PointY: yValue };

    }
   
};
ej.EjSvgRender.chartTransform3D = {
      ToRadial: Math.PI / 180,

      transform3D: function (size) {
          if (!this.vector){
          this.vector=new (new ej.Ej3DRender()).vector3D();
          this.matrixobj = new (new ej.Ej3DRender()).matrix3D();
          this.bsptreeobj = new (new ej.Ej3DRender()).BSPTreeBuilder();
          this.polygon = new (new ej.Ej3DRender()).polygon3D();
          }
        return {
            mViewport: size,
            Rotation: 0,
            Tilt: 0,
            Depth: 0,
            PerspectiveAngle: 0,
            needUpdate:true,
            centeredMatrix: this.matrixobj.getIdentity(),
            Perspective: this.matrixobj.getIdentity(),
            resultMatrix: this.matrixobj.getIdentity(),
            viewMatrix: this.matrixobj.getIdentity(),
            Depth: 0           
          };
     },

    transform: function (trans) {
        this.setCenter(this.vector.vector3D(trans.mViewport.Width / 2, trans.mViewport.Height / 2, trans.Depth / 2), trans);
        this.setViewMatrix(this.matrixobj.transform(0, 0, trans.Depth), trans)
        this.setViewMatrix(this.matrixobj.getMatrixMultiplication(trans.viewMatrix, this.matrixobj.turn(-this.ToRadial * trans.Rotation)), trans);
        this.setViewMatrix(this.matrixobj.getMatrixMultiplication(trans.viewMatrix, this.matrixobj.tilt(-this.ToRadial * trans.Tilt)), trans);
        this.updatePerspective(trans.PerspectiveAngle, trans);
        trans.needUpdate = true;
        
    },

   updatePerspective:function(angle, trans)
    {
       var width = (((trans.mViewport.Width + trans.mViewport.Height) * Math.tan(this.degreeToRadianConverter((180 - Math.abs(angle % 181)) / 2.0))) + (trans.Depth * 2) / 2);
       trans.Perspective[0][0] = width;
       trans.Perspective[1][1] = width;
       trans.Perspective[2][3] = 1;
       trans.Perspective[3][3] = width;
     
   },

   degreeToRadianConverter:function(degree)
   {
           return degree * Math.PI / 180;
   },
   toScreen:function(vector3D, trans, result, chartObj)
      {
	   var result = result ? result: this.result;
	   if (!chartObj)
		    vector3D = this.matrixobj.getMatrixVectorMutiple(result(trans), vector3D);
		else{
			this.matrixobj = chartObj;
			 vector3D = chartObj.getMatrixVectorMutiple(result(trans, chartObj), vector3D);
		}
       return { x: vector3D.x, y: vector3D.y };
   },

   setViewMatrix: function (value, trans) {
       if (trans.viewMatrix == value) return;
       trans.viewMatrix = value;
       trans.needUpdate = true;
      
   },

   setCenteredMatrix: function (value, trans) {
       if (trans.viewMatrix == value) return;
       trans.centeredMatrix = value;
       trans.needUpdate = true;
       
   },

   result:function(trans, matrixobj) 
     {
	   if (!this.matrixobj) this.matrixobj = matrixobj;
       if (!trans.needUpdate) return trans.resultMatrix;
       trans.resultMatrix = this.matrixobj.getMatrixMultiplication(this.matrixobj.getInvertal(trans.centeredMatrix),
                       trans.Perspective);
       trans.resultMatrix = this.matrixobj.getMatrixMultiplication(trans.resultMatrix, trans.viewMatrix);
       trans.resultMatrix = this.matrixobj.getMatrixMultiplication(trans.resultMatrix, trans.centeredMatrix);
       trans.needUpdate = false;

       return trans.resultMatrix;
    },


   setCenter:function(center, trans)
    {
        trans.centeredMatrix = this.matrixobj.transform(-center.x, -center.y, -center.z);
        trans.needUpdate = true;
   },
   toPlane:function(point, plane, trans)
     {
     var vec1 = this.vector.vector3D(point.x, point.y, 0);
     var vec2 = this.vector.vector3DPlus(vec1, vector.vector3D(0, 0, 1));

     vec1 = this.vector.vector3DMultiply(trans.centeredMatrix , vec1);
     vec2 = this.vector.vector3DMultiply(trans.centeredMatrix , vec2);

     vec1 = this.vector.vector3DMultiply(this.matrixobj.getInvertal(trans.Perspective) , vec1);
     vec2 =  this.vector.vector3DMultiply(this.matrixobj.getInvertal(trans.Perspective) , vec2);

     vec1 = this.polygon.getPoint(vec1, this.vector.vector3DMinus(vec2 - vec1));

     vec1 = this.vector.vector3DMultiply(this.matrixobj.getInvertal(trans.viewMatrix), vec1);
     vec1 =  this.vector.vector3DMultiply(this.matrixobj.getInvertal(trans.centeredMatrix), vec1);

     return vec1;
    }

};
ej.EjSvgRender.chartSymbol =
{
    _drawSeriesType: function (location, symbolStyle, sender) {
        var seriesType = sender.model.series[symbolStyle.SeriesIndex].type.toLowerCase();
        var trendlinetype = sender.legendItem.drawType;
        seriesType = ej.util.isNullOrUndefined(trendlinetype) ? seriesType : trendlinetype;
        switch (seriesType) {
            case ej.datavisualization.Chart.Type.Line: {
                var line;
                if(ej.util.isNullOrUndefined(trendlinetype))
                     line = this._drawLine(location, symbolStyle, sender, sender.gLegendItemEle);
                else
                    line = this._drawStraightLine(location, symbolStyle, sender, sender.gLegendItemEle);
                return line;
            }
                
            case ej.datavisualization.Chart.Type.StepLine:
                return this._drawStepLine(location, symbolStyle, sender, sender.gLegendItemEle);
                 
            case ej.datavisualization.Chart.Type.StackingArea:
            case ej.datavisualization.Chart.Type.StackingArea100:
            case ej.datavisualization.Chart.Type.Area:
            case ej.datavisualization.Chart.Type.RangeArea:
                return this._drawArea(location, symbolStyle, sender, sender.gLegendItemEle);
                 
            case ej.datavisualization.Chart.Type.StepArea:
                return this._drawStepArea(location, symbolStyle, sender, sender.gLegendItemEle);
                 
            case ej.datavisualization.Chart.Type.Bar:
            case ej.datavisualization.Chart.Type.StackingBar100:
            case ej.datavisualization.Chart.Type.StackingBar:
                return this._drawBar(location, symbolStyle, sender, sender.gLegendItemEle);
                
            case ej.datavisualization.Chart.Type.Pie:
                return this._drawPie(location, symbolStyle, sender, sender.gLegendItemEle);
                
            case ej.datavisualization.Chart.Type.Doughnut:
                return this._drawDoughnut(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Hilo:
                return this._drawHilo(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.HiloOpenClose:
                return this._drawHiloOpenClose(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Candle:
                return this._drawCandle(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Pyramid:
                return this._drawPyramid(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Funnel:
                return this._drawFunnel(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Spline:
                return this._drawSpline(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.SplineArea:
                return this._drawSplineArea(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.RangeColumn:
                return this._drawRangeColumn(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Bubble:
            case ej.datavisualization.Chart.Type.Scatter:
                return this._drawCircle(location, symbolStyle, sender, sender.gLegendItemEle);

            case ej.datavisualization.Chart.Type.Column:
            case ej.datavisualization.Chart.Type.StackingColumn:
            case ej.datavisualization.Chart.Type.StackingColumn100:
			case ej.datavisualization.Chart.Type.Waterfall:
                return this._drawColumn(location, symbolStyle, sender, sender.gLegendItemEle);
                
            default:
                return this._drawRectangle(location, symbolStyle, sender, sender.gLegendItemEle);
                 
        }

    },

    _drawCircle: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer, svgObj = sender.svgObject, style = symbolStyle.ShapeSize,
        radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2,
        symbolstyleStyle=symbolStyle.Style;
     		
        var options = {
            'id': symbolStyle.ID,
            'cx': location.startX,
            'cy': location.startY,
            'r': radius,
            'fill': symbolstyleStyle.Color,
            'stroke-width': symbolstyleStyle.BorderWidth,
            'stroke': symbolstyleStyle.BorderColor,
            'opacity': symbolstyleStyle.Opacity,
            'visibility': symbolstyleStyle.Visibility,
            'lgndCtx': symbolStyle.context
        };

        svgRender.drawCircle(options, element);

        return (location.startX - radius);
    },

    _drawLeftArrow: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;
        path = "M" + " " + ((location.startX - (style.width / 2)) + style.width) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + style.width) + " " + (location.startY + (-style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (-style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2))) + " " + (location.startY) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + style.width) + " " + (location.startY + (style.height / 4)) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility':symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);

    },


    _drawRightArrow: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;
        path = "M" + " " + ((location.startX - (style.width / 2))) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2))) + " " + (location.startY + (-style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (-style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + style.width) + " " + (location.startY) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2)) + (style.width / 2)) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + ((location.startX - (style.width / 2))) + " " + (location.startY + (style.height / 4)) + " z";       
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility':symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };


        svgRender.drawPath(options, element);


    },


    _drawUpArrow: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;
        path = "M" + " " + ((location.startX - (style.width / 2) + (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height)) + " " + "L" + " " + ((location.startX - (style.width / 2) + (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX)) + " " + (location.startY - (style.height / 2)) + " " + "L" + " " + ((location.startX + (style.width / 2))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX + (style.width / 2) - (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX + (style.width / 2) - (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height)) + " " + "L" + " " + ((location.startX - (style.width / 2) + (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height)) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };


        svgRender.drawPath(options, element);


    },

    _drawDownArrow: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;
        path = "M" + " " + ((location.startX - (style.width / 2) + (style.width / 4))) + " " + (location.startY - (style.height / 2)) + " " + "L" + " " + ((location.startX + (style.width / 2) - (style.width / 4))) + " " + (location.startY - (style.height / 2)) + " " + "L" + " " + ((location.startX + (style.width / 2) - (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX + (style.width / 2))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX)) + " " + (location.startY - (style.height / 2) + (style.height)) + " " + "L" + " " + ((location.startX - (style.width / 2))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2) + (style.width / 4))) + " " + (location.startY - (style.height / 2) + (style.height / 2)) + " " + "L" + " " + ((location.startX - (style.width / 2) + (style.width / 4))) + " " + (location.startY - (style.height / 2)) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };


        svgRender.drawPath(options, element);

    },

    _drawCross: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " " + "L" + " "+ (location.startX + (style.width / 2)) + " " + (location.startY) + " " +
        "M" + " " + (location.startX) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (-style.height / 2));
        var options = {
            'id': symbolStyle.ID,
            'opacity': symbolStyle.Style.Opacity,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);

    },

    _drawHorizLine: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY);
        var options = {
            'id': symbolStyle.ID,
            'opacity': symbolStyle.Style.Opacity,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);


    },
    _drawVertLine: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;
        path = "M" + " " + (location.startX) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (-style.height / 2));
        var options = {
            'id': symbolStyle.ID,
            'opacity': symbolStyle.Style.Opacity,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };


        svgRender.drawPath(options, element);

    },

    _drawTriangle: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (style.height / 2)) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);

    },

    _drawInvertedTriangle: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
         path = "M" + " " + (location.startX + (style.width / 2)) + " " + (location.startY - (style.height / 2)) + " "
             + "L" + " " + (location.startX) + " " + (location.startY + (style.height / 2)) + " "
             + "L" + " " + (location.startX - (style.width / 2)) + " " + (location.startY - (style.height / 2)) + " "
             + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY - (style.height / 2)) + " z";
        var x = location.startX;
        var y = location.startY;
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);


    },

    _drawHexagon: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (-style.width / 4)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 4)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (style.width / 4)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 4)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);

    },

    _drawWedge: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX - style.width) + " " + (location.startY) + " " + "L" + " " + (location.startX + style.width) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (3 * (style.width / 4))) + " " + (location.startY) + " " + "L" + " " + (location.startX + (style.width)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX - style.width) + " " + (location.startY) + " z";
        var options = {
		    'stroke-linecap': 'miter',
            'stroke-miterlimit':style.width / 4,
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);

    },

    _drawPentagon: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var eq = 72;
        var radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2;
        var sb = ej.EjSvgRender.utils._getStringBuilder();
        for (var i = 0; i <= 5; i++) {
            var deg = i * eq;
            var rad = (Math.PI / 180) * deg;
            var x1 = radius * Math.cos(rad);
            var y1 = radius * Math.sin(rad);
            if (i == 0)
                sb.append("M" + " " + (location.startX + x1) + " " + (location.startY + y1) + " ");

            else
                sb.append("L" + " " + (location.startX + x1) + " " + (location.startY + y1) + " ");


        }
        sb.append("z");
        var path = sb.toString();
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);


    },

    _drawStar: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var style = symbolStyle.ShapeSize;
        var svgObj = sender.svgObject;

        var path;
        path = "M" + " " + (location.startX + (style.width / 3)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (style.height / 6)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 6)) + " " + "L" + " " + (location.startX + (-style.width / 3)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 3)) + " " + (location.startY + (-style.height / 2)) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);


    },

    _drawRectangle: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (-style.height / 2))+ " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);
    },

    _drawTrapezoid: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (-style.height / 4)) + " " + "L" + " " + (location.startX + (-style.width / 2) + (style.width)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2) + (style.width)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);

    },

    _drawDiamond: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var path;
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " " + "L" + " " + (location.startX) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY) + " " + "L" + " " + (location.startX) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY) + " z";

        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'd': path
        };

        svgRender.drawPath(options, element);


    },
    _drawEllipse: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;

        var x = location.startX;
        var y = location.startY;
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'lgndCtx': symbolStyle.context,
            'cx': x,
            'cy': y,
            'rx': style.width,
            'ry': style.height / 2
        };


        svgRender.drawEllipse(options, element);


    },
    _drawImage: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var x = location.startX + (-style.width / 2);
        var y = location.startY + (-style.width / 2);
        var width = style.width;
        var height = style.height;
        var options = { 'id': svgObj.id + '_image' + symbolStyle.PointIndex, 'height': height, 'width': width, 'href': symbolStyle.Imageurl,
            'x': x, 'y': y, 'visibility': 'visible', 'lgndCtx': symbolStyle.context
        };

        svgRender.drawImage(options, element);


    },
	
	 _drawStraightLine: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;

        path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 10)) + " " +
                "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 10));
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth * 2,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };
        svgRender.drawPath(options, element);
        return (location.startX + (-style.width / 2) + (-elementspace / 4));
    },
	
    _drawLine: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;        
       
        if (sender.model.enableCanvasRendering === true) {
            path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 10)) + " " + "L" + " " + (location.startX - Math.floor(style.width / 3)) + " " + (location.startY + (style.height / 10)) + " " + "M" + " " + (location.startX + Math.floor(style.width / 3)) + " " + (location.startY + (style.height / 10)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 10));
            var options = {
                'id': symbolStyle.ID,
                'fill': symbolStyle.Style.Color,
                'stroke-width': symbolStyle.Style.BorderWidth * 2,
                'stroke': symbolStyle.Style.Color,
                'opacity': symbolStyle.Style.Opacity,
                'visibility': symbolStyle.Style.Visibility,
                'd': path,
                'lgndCtx': true
            };
            var circlepath = "M" + " " + (location.startX - Math.floor(style.width / 3)) + " " + (location.startY + (style.height / 10)) + " " + "a " + (Math.floor(style.width / 3)) + " " + (Math.floor(style.width / 3)) + " " + 0 + " " + 1 + " " + 0 + " " + 2 * (Math.floor(style.width / 3)) + " " + 0 + " " + "a" + (Math.floor(style.width / 3)) + " " + (Math.floor(style.width / 3)) + " " + 0 + " " + 1 + " " + 0 + " " + (-2 * (Math.floor(style.width / 3))) + " " + 0;
            var circleoptions = {
                'id': symbolStyle.ID,
                'fill': "transparent",
                'stroke-width': symbolStyle.Style.BorderWidth * 2,
                'stroke': symbolStyle.Style.Color,
                'opacity': symbolStyle.Style.Opacity,
                'visibility': symbolStyle.Style.Visibility,
                'd': circlepath,
                'lgndCtx': true
            };

            svgRender.drawPath(options, element);
            svgRender.drawPath(circleoptions, element);
        }
        else {
            path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 10)) + " " + "L" + " " + (location.startX - Math.floor(style.width / 3)) + " " + (location.startY + (style.height / 10)) + " " + "M" + " " + (location.startX + Math.floor(style.width / 3)) + " " + (location.startY + (style.height / 10)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 10)) + " " + "M" + " " + (location.startX - Math.floor(style.width / 3)) + " " + (location.startY + (style.height / 10)) + " " + "a " + (Math.floor(style.width / 3)) + " " + (Math.floor(style.width / 3)) + " " + 0 + " " + 1 + " " + 0 + " " + 2 * (Math.floor(style.width / 3)) + " " + 0 + " " + "a" + (Math.floor(style.width / 3)) + " " + (Math.floor(style.width / 3)) + " " + 0 + " " + 1 + " " + 0 + " " + (-2 * (Math.floor(style.width / 3))) + " " + 0;
            var options = {
                'id': symbolStyle.ID,
                'fill': "transparent",
                'stroke-width': symbolStyle.Style.BorderWidth * 2,
                'stroke': symbolStyle.Style.Color,
                'opacity': symbolStyle.Style.Opacity,
                'visibility': symbolStyle.Style.Visibility,
                'd': path,
                'lgndCtx': true
            };
            svgRender.drawPath(options, element);
        }
        return (location.startX + (-style.width / 2) + (-elementspace / 4));

    },
    _drawColumn: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;       
         path = "M" + " " + (location.startX - 3 * (style.width / 5)) + " " + (location.startY - (style.height / 5)) + " " + "L" + " " + (location.startX + 3 * (-style.width / 10)) + " " + (location.startY - (style.height / 5)) + " " + "L" + " " + (location.startX + 3 * (-style.width / 10)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX - 3 * (style.height / 5)) + " " + (location.startY + (style.height / 2)) + " " + "Z" + " " + "M" + " " + (location.startX + (-style.width / 10) - (style.width / 20)) + " " + (location.startY - (style.height / 4) - (elementspace / 2)) + " " + "L" + " " + (location.startX + (style.width / 10) + (style.width / 20)) + " " + (location.startY - (style.height / 4) - (elementspace / 2)) + " " + "L" + " " + (location.startX + (style.width / 10) + (style.width / 20)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 10) - (style.width / 20)) + " " + (location.startY + (style.height / 2)) + " " + "Z" + " " + "M" + " " + (location.startX + 3 * (style.width / 10)) + " " + (location.startY) + " " + "L" + " " + (location.startX + 3 * (style.width / 5)) + " " + (location.startY) + " " + "L" + " " + (location.startX + 3 * (style.width / 5)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + 3 * (style.width / 10)) + " " + (location.startY + (style.height / 2)) + " " + "Z";
      
         var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
             'lgndCtx': true
        };

        svgRender.drawPath(options, element);

         return (location.startX - 3 * (style.width / 5));

    },
    _drawRangeColumn: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;       
        path = "M" + " " + (location.startX + (-style.width / 5)) + " " + (location.startY + (style.height / 2) + (elementspace / 4)) + " " + "L" + " " + (location.startX + (-style.width / 5)) + " " + (location.startY - (style.height / 2) - (elementspace / 4)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (-style.height / 2) + (-elementspace / 4)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2) + (elementspace / 4)) + " " + "Z";
       
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 5));

    },

    _drawBar: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;        
       
        path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY - 3 * (style.height / 5)) + " " + "L" + " " + (location.startX + 3 * (style.width / 10)) + " " + (location.startY - 3 * (style.height / 5)) + " " + "L" + " " + (location.startX + 3 * (style.width / 10)) + " " + (location.startY - 3 * (style.height / 10)) + " " + "L" + " " + (location.startX - (style.width / 2) + (-elementspace / 4)) + " " + (location.startY - 3 * (style.height / 10)) + " " + "Z" + " " + "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY - (style.height / 5) + (elementspace / 20)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY - (style.height / 5) + (elementspace / 20)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 10) + (elementspace / 20)) + " " + "L" + " " + (location.startX - (style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 10) + (elementspace / 20)) + " " + "Z" + " " + "M" + " " + (location.startX - (style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height/5) + (elementspace / 10)) + " " + "L" + " " + (location.startX + (-style.width / 4)) + " " + (location.startY + (style.height/5) + (elementspace / 10)) + " " + "L" + " " + (location.startX + (-style.width / 4)) + " " + (location.startY + (style.height / 2)+(elementspace/10)) + " " + "L" + " " + (location.startX - (style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 2)+(elementspace/10)) + " " + "Z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 2) + (-elementspace / 4));

    },
   
    _drawStepLine: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;       
       
        path = "M" + " " + (location.startX + (-style.width / 2) - (elementspace/4)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2) + (style.width / 10)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2) + (style.width / 10)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (-style.width / 10)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (-style.width / 10)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 5)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 5)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (-style.height / 2)) + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + "L" + "" + (location.startX + (style.width/2) + (elementspace/4)) + " " + (location.startY + (style.height / 2));
        var options = {
            'id': symbolStyle.ID,
            'fill': "transparent",
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 2) - (elementspace / 4));

    },
    _drawSpline: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;        
        path = "M" + " " + (location.startX - (style.width / 2)) + " " + (location.startY + (style.height / 5)) + " " + "Q" + " " + location.startX + " " + (location.startY - style.height) + " " + location.startX + " " + (location.startY + (style.height / 5)) + " " + "M" + " " + location.startX + " " + (location.startY + (style.height / 5)) + " " + "Q" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + (location.startX + (style.width / 2)) + " " + (location.startY - (style.height / 2));		
        var options = {
            'id': symbolStyle.ID,
             'fill': "transparent",
            'stroke-width': symbolStyle.Style.BorderWidth*2,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX - (style.width / 2));

    },
    _drawSplineArea: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var path;       
        path = "M" + " " + (location.startX - (style.width / 2)) + " " + (location.startY + (style.height / 5)) + " " + "Q" + " " + location.startX + " " + (location.startY - style.height) + " " + location.startX + " " + (location.startY + (style.height / 5)) + " " +  "Z" +" " + "M" + " " + location.startX + " " + (location.startY + (style.height / 5)) + " " + "Q" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2)) + " " + (location.startX + (style.width / 2)) + " " + (location.startY - (style.height / 2)) +" " +" Z";
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX - (style.width / 2));

    },
    _drawArea: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;
        path = "M" + " " + (location.startX - (style.width / 2) - (elementspace / 4)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 4) + (-elementspace / 8)) + " " + (location.startY - (style.height / 2)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + (location.startX + (style.width / 4) + (elementspace / 8)) + " " + (location.startY + (-style.height / 2) + (style.height / 4)) + " " + "L" + " " + (location.startX + (style.height / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 2)) + " " + "Z";
      
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX - (style.width / 2) - (elementspace / 4));

    },
    _drawStepArea: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;

        path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 2)) + " " + "L" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (-style.height / 2)) + " " + "L" + " " + (location.startX - (style.width / 4)) + " " + (location.startY - (style.height / 2)) + " " + "L" + " " + (location.startX - (style.width / 4)) + " " + (location.startY - (style.height / 4)) + " " + "L" + " " + (location.startX + (style.width / 4)) + " " + (location.startY - (style.height / 4)) + " " + "L" + " " + (location.startX + (style.width / 4)) + " " + (location.startX) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 2)) + " " + "Z";       
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 2) + (-elementspace / 4));

    },
    _drawPyramid: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;        
       path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 4)) + " " + (location.startY + (style.height / 2)+(elementspace/8)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (-style.height / 2) + (-elementspace / 8)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + (style.height / 2)+(elementspace/8)) + " " + "Z";
      
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 2) + (-elementspace / 4));


    },
    _drawFunnel: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;
        path = "M" + " " + (location.startX + (-style.width / 2) + (-elementspace / 5)) + " " + (location.startY + (-style.height / 2) + (-elementspace / 4)) + " " + "L" + " " + (location.startX + (-style.width / 5)) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + (location.startX + (-style.width / 5)) + " " + (location.startY + (style.height / 2) + (elementspace / 4)) + " " + "L" + " " + (location.startX + (style.width / 5)) + " " + (location.startY + (style.height / 2) + (elementspace / 4)) + " " + "L" + " " + (location.startX + (style.width / 5)) + " " + (location.startY + (style.height / 4)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 5)) + " " + (location.startY + (-style.height / 2) + (-elementspace / 4)) + " " + "Z";
      
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 2) + (-elementspace / 5));

    },
    _drawCandle: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;       
       
        path = "M" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (style.height / 4) + (elementspace / 8)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 4) + (elementspace / 8)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (-style.height / 2) + (elementspace / 8)) + " " + "L" + " " + (location.startX + (-style.width / 2)) + " " + (location.startY + (-style.height / 2) + (elementspace / 8)) + " " + "Z" + " " + "M" + " " + (location.startX) + " " + (location.startY + (-style.height / 2) + (elementspace / 8)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (-style.height / 2) + (-elementspace / 4)) + " " + "M" + " " + (location.startX) + " " + (location.startY + (style.height / 4) + (elementspace / 8)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (style.height / 4) + (elementspace / 2));
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (-style.width / 2));

    },
    _drawHilo: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var path;
        path = "M" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (style.height / 2)+(elementspace/4)) + " " + "L" + " " + (location.startX + (style.width / 2)) + " " + (location.startY + (-style.height / 2)+(-elementspace/4));        
        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return (location.startX + (style.width / 2));

    },
    _drawHiloOpenClose: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var cartesian = polarToCartesian(18, 12, 4.0710678118654755, 270);
        var elementspace = symbolStyle.ElementSpace;
        var path;        
        
        path = "M" + " " + (location.startX) + " " + (location.startY - 3 * (style.height / 10)) + " " + "L" + " " + (location.startX - (style.width / 2) - (elementspace / 4)) + " " + (location.startY - 3 * (style.height / 10)) + " " + "M" + " " + (location.startX) + " " + (location.startY - (style.height / 2) - (elementspace / 4)) + " " + "L" + " " + (location.startX) + " " + (location.startY + (style.height / 2) + (elementspace / 4)) + " " + "M" + " " + (location.startX) + " " + (location.startY + 3 * (style.height / 10)) + " " + "L" + " " + (location.startX + (style.width / 2) + (elementspace / 4)) + " " + (location.startY + 3 * (style.height / 10));
        var options = {
            'id': symbolStyle.ID,
            'fill': "transparent",
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.Color,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);

        return ((location.startX) - (style.width / 2));

    },

    _drawDoughnut: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var radius = Math.sqrt(style.height * style.width) / 2;
        radius = radius + (elementspace / 5);
        var cartesianlarge = polarToCartesian(location.startX, location.startY, radius, 270);
        var cartesiansmall = polarToCartesian(location.startX + (style.width / 10), location.startY, radius, 270);
        var elementspace = symbolStyle.ElementSpace;
        path = "M" + " " + location.startX + " " + location.startY + " " + "L" + " " + (location.startX + radius) + " " + (location.startY) + " " + "A" + " " + (radius) + " " + (radius) + " " + 0 + " " + 1 + " " + 1 + " " + cartesianlarge[0] + " " + cartesianlarge[1] + " " + "Z" + " " + "M" + " " + (location.startX + (style.width / 10)) + " " + (location.startY - (style.height / 10)) + " " + "L" + (location.startX + (radius)) + " " + (location.startY - style.height / 10) + " " + "A" + " " + (radius) + " " + (radius) + " " + 0 + " " + 0 + " " + 0 + " " + cartesiansmall[0] + " " + cartesiansmall[1] + " " + "Z";

        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };
        var circle = {
            'id': symbolStyle.ID, 'cx': location.startX, 'cy': location.startY, 'r': (radius/2),'lgndCtx': true,
            'fill': "white", 'stroke-width': symbolStyle.Style.BorderWidth, 'stroke': symbolStyle.Style.BorderColor, 'opacity': symbolStyle.Style.Opacity, 'visibility': symbolStyle.Style.Visibility
        };

        svgRender.drawPath(options, element);
        svgRender.drawCircle(circle, element);

        return (location.startX-radius);
    },

    _drawPie: function (location, symbolStyle, sender, element) {
        var svgRender = sender.svgRenderer;
        var svgObj = sender.svgObject;
        var style = symbolStyle.ShapeSize;
        var elementspace = symbolStyle.ElementSpace;
        var radius = Math.sqrt(style.height * style.width) / 2;
        radius = radius + (elementspace / 5);
        var cartesianlarge = polarToCartesian(location.startX, location.startY, radius, 270);
        var cartesiansmall = polarToCartesian(location.startX + (style.width / 10), location.startY, radius, 270);
        var elementspace = symbolStyle.ElementSpace;
        path = "M" + " " + location.startX + " " + location.startY + " " + "L" + " " + (location.startX + radius) + " " + (location.startY) + " " + "A" + " " + (radius) + " " + (radius) + " " + 0 + " " + 1 + " " + 1 + " " + cartesianlarge[0] + " " + cartesianlarge[1] + " " + "Z" + " " + "M" + " " + (location.startX + (style.width / 10)) + " " + (location.startY - (style.height / 10)) + " " + "L" + (location.startX + (radius)) + " " + (location.startY - style.height / 10) + " " + "A" + " " + (radius) + " " + (radius) + " " + 0 + " " + 0 + " " + 0 + " " + cartesiansmall[0] + " " + cartesiansmall[1] + " " + "Z";

        var options = {
            'id': symbolStyle.ID,
            'fill': symbolStyle.Style.Color,
            'stroke-width': symbolStyle.Style.BorderWidth,
            'stroke': symbolStyle.Style.BorderColor,
            'opacity': symbolStyle.Style.Opacity,
            'visibility': symbolStyle.Style.Visibility,
            'd': path,
            'lgndCtx': true
        };

        svgRender.drawPath(options, element);
        return (location.startX - radius);
    }

};
function polarToCartesian(startX, startY, radius, angleInDegrees) {
    var angleInRadians = angleInDegrees * Math.PI / 180.0;
    var x = startX + radius * Math.cos(angleInRadians);
    var y = startY + radius * Math.sin(angleInRadians);
    return [x, y];
}
ej.EjSvgRender.seriesPalette = {
    defaultMetro: ["#E94649", "#F6B53F", "#6FAAB0", "#C4C24A", "#FB954F", "#005277", "#8BC652", "#69D2E7", "#E27F2D", "#6A4B82"],
    defaultHighContrast: ["#F93A00", "#44E2D6", "#DDD10D", "#0AA368", "#0556CB", "#AB40B2", "#5F930A", "#D12E41", "#E0670E", "#008FFF"],
    defaultOffice: ["#005277", "#8BC652", "#6A4B82", "#E94649", "#6FAAB0", "#F7B74F", "#C4C24A", "#EF863F", "#69D2E7", "#FFD13E"],
    defaultMaterial: ["#663AB6","#EB3F79","#F8AB1D","#B82E3D","#049CB1","#F2424F","#C2C924","#3DA046","#074D67","#02A8F4"],
    defaultGradient:
        {
            borderColors: ["#F34649", "#F6D321", "#6EB9B0", "#CBC26A", "#FBAF4F", "#E2CDB1", "#FFC0B7", "#68E1E6", "#E1A62D", "#9C6EBF"],
            seriesColors: [[{ color: "#F34649", colorStop: "0%" }, { color: "#B74143", colorStop: "100%"}],
     [{ color: "#F6D321", colorStop: "0%" }, { color: "#F6AE26", colorStop: "100%"}],
     [{ color: "#6EB9B0", colorStop: "0%" }, { color: "#3F77BD", colorStop: "100%"}],
     [{ color: "#CBC26A", colorStop: "0%" }, { color: "#9AAD21", colorStop: "100%"}],
     [{ color: "#FBAF4F", colorStop: "0%" }, { color: "#F07542", colorStop: "100%"}],
     [{ color: "#E2CDB1", colorStop: "0%" }, { color: "#AAA089", colorStop: "100%"}],
     [{ color: "#8BC652", colorStop: "0%" }, { color: "#6F9E41", colorStop: "100%"}],
     [{ color: "#68E1E6", colorStop: "0%" }, { color: "#3D9CBE", colorStop: "100%"}],
     [{ color: "#E1A62D", colorStop: "0%" }, { color: "#B66824", colorStop: "100%"}],
     [{ color: "#9C6EBF", colorStop: "0%"}], [{ color: "#593F6D", colorStop: "100%"}]]
        },
    blueMetro: ["#005378", "#006691", "#007EB5", "#0D97D4", "#00AEFF", "#14B9FF", "#54CCFF", "#87DBFF", "#ADE5FF", "#C5EDFF"],
    blueGradient:
     {
         seriesColors: [[{ color: "#005277", colorStop: "0%" }, { color: "#00304F", colorStop: "100%"}],
            [{ color: "#006590", colorStop: "0%" }, { color: "#004068", colorStop: "100%"}],
            [{ color: "#007DB4", colorStop: "0%" }, { color: "#00558B", colorStop: "100%"}],
            [{ color: "#0D97D4", colorStop: "0%" }, { color: "#057FC7", colorStop: "100%"}],
            [{ color: "#00ADFE", colorStop: "0%" }, { color: "#008BE9", colorStop: "100%"}],
            [{ color: "#14B8FE", colorStop: "0%" }, { color: "#0798EB", colorStop: "100%"}],
            [{ color: "#53CBFF", colorStop: "0%" }, { color: "#35AFEB", colorStop: "100%"}],
            [{ color: "#86DAFF", colorStop: "0%" }, { color: "#64C0EC", colorStop: "100%"}],
            [{ color: "#ACE5FF", colorStop: "0%" }, { color: "#8DCEED", colorStop: "100%"}],
            [{ color: "#C4ECFF", colorStop: "0%"}], [{ color: "#A3D1E6", colorStop: "100%"}]],
         borderColors: ["#005277", "#006590", "#007DB4", "#0D97D4", "#00ADFE", "#14B8FE", "#53CBFF", "#86DAFF", "#ACE5FF", "#C4ECFF"]
     },
    greenMetro: ["#496612", "#597B15", "#709A1B", "#87B62A", "#9AD926", "#A6DC37", "#BCE654", "#C8E780", "#D5EFA5", "#E2F3BE"],
    greenGradient:
     {

         seriesColors: [[{ color: "#5C7F16", colorStop: "0%" }, { color: "#384C08", colorStop: "100%"}],
            [{ color: "#6A9319", colorStop: "0%" }, { color: "#486009", colorStop: "100%"}],
            [{ color: "#739D1C", colorStop: "0%" }, { color: "#57760B", colorStop: "100%"}],
            [{ color: "#90B546", colorStop: "0%" }, { color: "#6E9215", colorStop: "100%"}],
            [{ color: "#9AD826", colorStop: "0%" }, { color: "#75A010", colorStop: "100%"}],
            [{ color: "#A5DB36", colorStop: "0%" }, { color: "#8EB91D", colorStop: "100%"}],
            [{ color: "#BBE554", colorStop: "0%" }, { color: "#A4C849", colorStop: "100%"}],
            [{ color: "#C8E780", colorStop: "0%" }, { color: "#B4D072", colorStop: "100%"}],
            [{ color: "#D4EEA5", colorStop: "0%" }, { color: "#BFD593", colorStop: "100%"}],
            [{ color: "#E1F2BD", colorStop: "0%"}], [{ color: "#C8D7A8", colorStop: "100%"}]],
         borderColors: ["#5C7F16", "#6A9319", "#739D1C", "#90B546", "#9AD826", "#A5DB36", "#BBE554", "#C8E780", "#D4EEA5", "#E1F2BD"]
     },

    sandleMetro: ["#6C450C", "#82520D", "#A36812", "#C07F1F", "#E69719", "#E89A2B", "#EEB564", "#F3CB93", "#F7DEB4", "#F9E6CA"],
    sandleGradient:
     {


         seriesColors: [[{ color: "#7F602F", colorStop: "0%" }, { color: "#512D04", colorStop: "100%"}],
            [{ color: "#986827", colorStop: "0%" }, { color: "#673803", colorStop: "100%"}],
            [{ color: "#A16C1F", colorStop: "0%" }, { color: "#8A4B05", colorStop: "100%"}],
            [{ color: "#BF812A", colorStop: "0%" }, { color: "#AD630D", colorStop: "100%"}],
            [{ color: "#E49519", colorStop: "0%" }, { color: "#B86607", colorStop: "100%"}],
            [{ color: "#E7992A", colorStop: "0%" }, { color: "#D7780D", colorStop: "100%"}],
            [{ color: "#EDB463", colorStop: "0%" }, { color: "#D98F31", colorStop: "100%"}],
            [{ color: "#F2CA92", colorStop: "0%" }, { color: "#DAAC6F", colorStop: "100%"}],
            [{ color: "#F6DDB3", colorStop: "0%" }, { color: "#DABE8F", colorStop: "100%"}],
            [{ color: "#F8E5C9", colorStop: "0%"}], [{ color: "#DDBE92", colorStop: "100%"}]],
         borderColors: ["#7F602F", "#986827", "#A16C1F", "#BF812A", "#E49519", "#E7992A", "#EDB463", "#F2CA92", "#F6DDB3", "#F8E5C9"]

     }
};

ej.EjSvgRender.themes = {
    flatlight:
    {
        highlightColor : 'black',

        background: 'transparent',
        legend:
        {
            font: { color: "#282828"},
            title:
            {
               font: { color: "#282828"}
             }
        },
        title:
        {
            font: { color: '#565656'},
            subTitle:
                {
                    font: { color: '#565656'}
                }
        },
        primaryXAxis:
        {
            majorGridLines:
            {
                color: "#DFDFDF"
            },
            majorTickLines:
            {
                color: "#8E8E8E"
            },
            minorGridLines:
            {
                color: "#DFDFDF"
            },
            minorTickLines:
            {
                color: "#8E8E8E"
            },
            labelBorder:
            {
               color: "#8E8E8E"
            },
			multiLevelLabelsColor: "#8E8E8E",
			multiLevelLabelsFontColor: "#282828",
            axisLine: { color: '#8E8E8E' },
            font: { color: '#282828' },
            title:
            {
                font: { color: '#282828' }
            },
            crosshairLabel: { rx: 3, ry: 3, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
        },
        secondaryX:
        {
            majorGridLines:
            {
                color: "#DFDFDF"
            },
            majorTickLines:
            {
                color: "#8E8E8E"
            },
            minorGridLines:
            {
                color: "#DFDFDF"
            },
            minorTickLines:
            {
                color: "#8E8E8E"
            },
            labelBorder:
            {
                color: "#8E8E8E"
            },
			multiLevelLabelsColor: "#8E8E8E",
			multiLevelLabelsFontColor: "#282828",
            axisLine: { color: '#8E8E8E' },
            font: { color: '#282828' },
            title:
            {
                font: { color: '#282828' }
            },
            crosshairLabel: { rx: 3, ry: 3, border: { color: '#3D3D3D' ,width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB'} }
        },

        primaryYAxis:
        {
            majorGridLines:
            {
                color: "#DFDFDF"
            },
            majorTickLines:
            {
                color: "#8E8E8E"
            },
            minorGridLines:
            {
                color: "#DFDFDF"
            },
            minorTickLines:
            {
                color: "#8E8E8E"
            },
            labelBorder:{
                color: "#8E8E8E"
            },
			multiLevelLabelsColor: "#8E8E8E",
			multiLevelLabelsFontColor: "#282828",
            axisLine: { color: '#8E8E8E' },
            font: { color: '#282828' },
            title:
            {
                font: { color: '#282828' }
            },
            crosshairLabel: { rx: 3, ry: 3, border: { color: '#3D3D3D', borderWidth: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
        },
        secondaryY:
        {
            majorGridLines:
            {
                color: "#DFDFDF"
            },
            majorTickLines:
            {
                color: "#8E8E8E"
            },
            minorGridLines:
            {
                color: "#DFDFDF"
            },
            minorTickLines:
            {
                color: "#8E8E8E"
            },
            labelBorder:{
                color: "#8E8E8E"
            },
			multiLevelLabelsColor: "#8E8E8E",
			multiLevelLabelsFontColor: "#282828",
            axisLine: { color: '#8E8E8E' },
            font: { color: '#282828' },
            title:
            {
                font: { color: '#282828' }
            },
            crosshairLabel: { rx: 3, ry: 3, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
        },
     commonSeriesOptions:
           {
marker:{
               dataLabel: { font: { color: '#565656' } }
},
  errorBar:{
        fill:"#000000",
		cap:
		{
			fill:"#000000"
		}
  },
  connectorLine: { color: '#565656' }
	},
        crosshair:
        {
            line:
            {
                width: 1,
                color: 'Black'
            }
        },
        
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultMetro,
        colors: ej.EjSvgRender.seriesPalette.defaultMetro

    },

    flatdark:
        {
            highlightColor : 'white',

            background: '#111111',

            legend:
            {
                font: { color: "#C9C9C9"},
                title:
                {
                  font: { color: "#C9C9C9"}
                }
            },
            title:
            {
                font: { color: '#C9C9C9'},
                subTitle:
                {
                    font: { color: '#C9C9C9'}
                }
            },
            primaryXAxis:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: { rx: 0, ry: 0, fill: '#B5B5B5', border: { color: '#B5B5B5', width: 1 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            secondaryX:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 }, 
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: {   rx: 0, ry: 0, fill: '#B5B5B5', border:{color: '#B5B5B5', width: 1 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            primaryYAxis:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: { rx: 0, ry: 0, fill: '#B5B5B5', border:{color: '#B5B5B5', width: 1 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            secondaryY:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                      color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: { rx: 0, ry: 0, fill: '#B5B5B5', border: { color: '#B5B5B5', width: 1 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444'} }
             },
     commonSeriesOptions:
           {
marker:{
               dataLabel: { font: { color: '#C9C9C9' } }
},
errorBar:{
           fill:"#ffffff",
		   cap:
		   {
			fill:"#ffffff"
		   }
},
connectorLine: { color: '#C9C9C9' }
        },
            crosshair:
             {
                 line:
                 {
                     width: 1,
                     color: 'White'
                 }
             },
            
            seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultMetro,
            colors: ej.EjSvgRender.seriesPalette.defaultMetro

        },


    gradientlight:
        {
            highlightColor : 'black',

            background: 'transparent',
            legend:
            {
                font: { color: "#282828"},
                title:
                {
                    font: { color: "#282828"}
                }
            },
            title:
            {
                font: { color: '#565656'},
                subTitle:
                {
                    font: { color: '#565656'}
                }
            },
            primaryXAxis:
             {
                 majorGridLines:
                 {
                     color: "#DFDFDF"
                 },
                 majorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 minorGridLines:
                  {
                      color: "#DFDFDF"
                  },
                 minorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 labelBorder:{
                     color: "#8E8E8E"
                 },
				 multiLevelLabelsColor: "#8E8E8E",
				 multiLevelLabelsFontColor: "#282828",
                 axisLine: { color: '#8E8E8E' },
                 font: { color: '#282828' },
                 title:
                 {

                     font: { color: '#282828' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#3D3D3D',border:{color: '#3D3D3D',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB'} }
             },
            secondaryX:
             {
                 majorGridLines:
                 {
                     color: "#DFDFDF"
                 },
                 majorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 minorGridLines:
                  {
                      color: "#DFDFDF"
                  },
                 minorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 labelBorder:{
                      color: "#8E8E8E"
                 },
				 multiLevelLabelsColor: "#8E8E8E",
				 multiLevelLabelsFontColor: "#282828",
                 axisLine: { color: '#8E8E8E' },
                 font: { color: '#282828' },
                 title:
                 {

                     font: { color: '#282828' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#3D3D3D',border:{color: '#3D3D3D',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB'} }
             },
            primaryYAxis:
             {
                 majorGridLines:
                 {
                     color: "#DFDFDF"
                 },
                 majorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 minorGridLines:
                  {
                      color: "#DFDFDF"
                  },
                 minorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 labelBorder:{
                      color: "#8E8E8E"
                 },
				 multiLevelLabelsColor: "#8E8E8E",
				 multiLevelLabelsFontColor: "#282828",
                 axisLine: { color: '#8E8E8E' },
                 font: { color: '#282828' },
                 title:
                 {

                     font: { color: '#282828' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#3D3D3D',border:{color: '#3D3D3D',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB'} }
             },
            secondaryY:
             {
                 majorGridLines:
                 {
                     color: "#DFDFDF"
                 },
                 majorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 minorGridLines:
                  {
                      color: "#DFDFDF"
                  },
                 minorTickLines:
                  {
                      color: "#8E8E8E"
                  },
                 labelBorder:{
                      color: "#8E8E8E"
                 },
				 multiLevelLabelsColor: "#8E8E8E",
				 multiLevelLabelsFontColor: "#282828",
                 axisLine: { color: '#8E8E8E' },
                 font: { color: '#282828' },
                 title:
                 {

                     font: { color: '#282828' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#3D3D3D',border:{color: '#3D3D3D',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB'} }
             },
     commonSeriesOptions:
           {
marker:{
               dataLabel: { font: { color: '#565656' } }
},
    errorBar:{
        fill:"#000000",
		cap:
		{
			fill:"#000000"
		}
    },
    connectorLine: { color: '#565656' }
	},
            crosshair:
             {
                 line:
                 {
                     width: 1,
                     color: 'Black'
                 }
             },
            
            seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultGradient.borderColors,
            colors: ej.EjSvgRender.seriesPalette.defaultGradient.seriesColors

        },

    gradientdark:
        {
            highlightColor : 'white',

            background: '#111111',
            legend:
            {
                font: { color: "#C9C9C9"},
                title:
               {
                   font: { color: "#C9C9C9"}
               }
            },
            title:
            {
                font: { color: '#C9C9C9'},
                subTitle:
                {
                    font: { color: '#C9C9C9'}
                }
            },
            primaryXAxis:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#B5B5B5',border:{color: '#B5B5B5',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444'} }
             },
            secondaryX:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                      color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#B5B5B5',border:{color: '#B5B5B5',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444'} }
             },
            primaryYAxis:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder: {
                     color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#B5B5B5',border:{color: '#B5B5B5',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444'} }
             },
            secondaryY:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
				 multiLevelLabelsColor: "#AAAAAA",
				 multiLevelLabelsFontColor: "#C9C9C9",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#C9C9C9' },
                 title:
                 {

                     font: { color: '#C9C9C9' }
                 },
                 crosshairLabel: {rx: 3, ry: 3, fill: '#B5B5B5',border:{color: '#B5B5B5',  width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444'} }
             },
     commonSeriesOptions:
           {
marker:{
               dataLabel: { font: { color: '#C9C9C9' } }
      },
     errorBar:{
              fill:"#ffffff",
		      cap:
		      {
			     fill:"#ffffff"
		      }
     },
     connectorLine: { color: "#C9C9C9" }
        },
       
            crosshair:
             {
                 line:
                 {
                     width: 1,
                     color: 'White'
                 }
             },
             
            seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultGradient.borderColors,
            colors: ej.EjSvgRender.seriesPalette.defaultGradient.seriesColors

        },

    highcontrast01:
        {
            highlightColor : 'white',

            background: '#111111',
            legend:
            {
                font: { color: '#ffffff' },
                title:
               {
                   font: { color: '#ffffff' }
               }
            },
            title:
            {
                font: { color: '#ffffff' },
                subTitle:
                {
                    font: { color: '#ffffff' }
                }
            },
            primaryXAxis:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
	             multiLevelLabelsColor: "#AAAAAA",
                 multiLevelLabelsFontColor: "#ffffff",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#ffffff' },
                 title:
                 {

                     font: { color: '#ffffff' }
                 },
                 crosshairLabel: { rx: 3, ry: 3, fill: '#B5B5B5', border: { color: '#B5B5B5', width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            secondaryX:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#ffffff' },
                 title:
                 {

                     font: { color: '#ffffff' }
                 },
                 crosshairLabel: { rx: 3, ry: 3, fill: '#B5B5B5', border: { color: '#B5B5B5', width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            primaryYAxis:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 labelBorder:{
                     color: "#AAAAAA"
                 },
                 multiLevelLabelsColor: "#AAAAAA",
                 multiLevelLabelsFontColor: "#ffffff",
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#ffffff' },
                 title:
                 {

                     font: { color: '#ffffff' }
                 },
                 crosshairLabel: { rx: 3, ry: 3, fill: '#B5B5B5', border: { color: '#B5B5B5', width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            secondaryY:
             {
                 majorGridLines:
                 {
                     color: "#333333"
                 },
                 majorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 minorGridLines:
                  {
                      color: "#333333"
                  },
                 minorTickLines:
                  {
                      color: "#AAAAAA"
                  },
                 axisLine: { color: '#AAAAAA' },
                 font: { color: '#ffffff' },
                 title:
                 {

                     font: { color: '#ffffff' }
                 },
                 crosshairLabel: { rx: 3, ry: 3, fill: '#B5B5B5', border: { color: '#B5B5B5', width: 2 }, font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#444444' } }
             },
            commonSeriesOptions:
                  {
                      marker: {
                          dataLabel: { font: { color: '#ffffff' } }
                      },
                      errorBar: {
                          fill: "#ffffff",
                          cap:
                          {
                              fill: "#ffffff"
                          }
                      },
                      connectorLine: { color: "#C9C9C9" }
                  },

            crosshair:
             {
                 line:
                 {
                     width: 1,
                     color: 'White'
                 }
             },

            seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultHighContrast,
            colors: ej.EjSvgRender.seriesPalette.defaultHighContrast

        },
    material:
   {
       highlightColor : 'black',

       background: 'transparent',
       legend:
       {
           font: { color: "#333333" },
           title:
           {
               font: { color: "#333333" }
           }
       },
       title:
       {
           font: { color: '#333333' },
           subTitle:
               {
                   font: { color: '#333333' }
               }
       },
       primaryXAxis:
       {
           majorGridLines:
           {
               color: "#DFDFDF"
           },
           majorTickLines:
           {
               color: "#8E8E8E"
           },
           minorGridLines:
           {
               color: "#DFDFDF"
           },
           minorTickLines:
           {
               color: "#8E8E8E"
           },
          labelBorder:
           {
               color: "#8E8E8E"
           },
           multiLevelLabelsColor: "#8E8E8E",
           multiLevelLabelsFontColor: "#333333",
           axisLine: { color: '#8E8E8E' },
           font: { color: '#333333' },
           title:
           {
               font: { color: '#333333' }
           },
           crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
       },
       secondaryX:
       {
           majorGridLines:
           {
               color: "#DFDFDF"
           },
           majorTickLines:
           {
               color: "#8E8E8E"
           },
           minorGridLines:
           {
               color: "#DFDFDF"
           },
           minorTickLines:
           {
               color: "#8E8E8E"
           },
           axisLine: { color: '#8E8E8E' },
           font: { color: '#333333' },
           title:
           {
               font: { color: '#333333' }
           },
           crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
       },

       primaryYAxis:
       {
           majorGridLines:
           {
               color: "#DFDFDF"
           },
           majorTickLines:
           {
               color: "#8E8E8E"
           },
           minorGridLines:
           {
               color: "#DFDFDF"
           },
           minorTickLines:
           {
               color: "#8E8E8E"
           },
           labelBorder:
           {
               color: "#8E8E8E"
           },
           multiLevelLabelsColor: "#8E8E8E",
           multiLevelLabelsFontColor: "#333333",
           axisLine: { color: '#8E8E8E' },
           font: { color: '#333333' },
           title:
           {
               font: { color: '#333333' }
           },
           crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', borderWidth: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
       },
       secondaryY:
       {
           majorGridLines:
           {
               color: "#DFDFDF"
           },
           majorTickLines:
           {
               color: "#8E8E8E"
           },
           minorGridLines:
           {
               color: "#DFDFDF"
           },
           minorTickLines:
           {
               color: "#8E8E8E"
           },
           axisLine: { color: '#8E8E8E' },
           font: { color: '#333333' },
           title:
           {
               font: { color: '#333333' }
           },
           crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
       },
       commonSeriesOptions:
             {
                 marker: {
                     dataLabel: { font: { color: '#333333' } }
                 },
                 errorBar: {
                     fill: "#000000",
                     cap:
                     {
                         fill: "#000000"
                     }
                 },
                 connectorLine: { color: '#565656' }
             },
       crosshair:
       {
           line:
           {
               width: 1,
               color: 'Black'
           }
       },

       seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultMaterial,
       colors: ej.EjSvgRender.seriesPalette.defaultMaterial

   },
    office365:
  {
      highlightColor : 'black',

      background: 'transparent',
      legend:
      {
          font: { color: "#333333" },
          title:
          {
              font: { color: "#333333" }
          }
      },
      title:
      {
          font: { color: '#333333' },
          subTitle:
              {
                  font: { color: '#333333' }
              }
      },
      primaryXAxis:
      {
          majorGridLines:
          {
              color: "#DFDFDF"
          },
          majorTickLines:
          {
              color: "#8E8E8E"
          },
          minorGridLines:
          {
              color: "#DFDFDF"
          },
          minorTickLines:
          {
              color: "#8E8E8E"
          },
         labelBorder:
           {
               color: "#8E8E8E"
           },
           multiLevelLabelsColor: "#8E8E8E",
           multiLevelLabelsFontColor: "#333333",
          axisLine: { color: '#8E8E8E' },
          font: { color: '#333333' },
          title:
          {
              font: { color: '#333333' }
          },
          crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
      },
      secondaryX:
      {
          majorGridLines:
          {
              color: "#DFDFDF"
          },
          majorTickLines:
          {
              color: "#8E8E8E"
          },
          minorGridLines:
          {
              color: "#DFDFDF"
          },
          minorTickLines:
          {
              color: "#8E8E8E"
          },
          axisLine: { color: '#8E8E8E' },
          font: { color: '#333333' },
          title:
          {
              font: { color: '#333333' }
          },
          crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
      },

      primaryYAxis:
      {
          majorGridLines:
          {
              color: "#DFDFDF"
          },
          majorTickLines:
          {
              color: "#8E8E8E"
          },
          minorGridLines:
          {
              color: "#DFDFDF"
          },
          minorTickLines:
          {
              color: "#8E8E8E"
          },
          labelBorder:
           {
               color: "#8E8E8E"
           },
           multiLevelLabelsColor: "#8E8E8E",
           multiLevelLabelsFontColor: "#333333",
          axisLine: { color: '#8E8E8E' },
          font: { color: '#333333' },
          title:
          {
              font: { color: '#333333' }
          },
          crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', borderWidth: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
      },
      secondaryY:
      {
          majorGridLines:
          {
              color: "#DFDFDF"
          },
          majorTickLines:
          {
              color: "#8E8E8E"
          },
          minorGridLines:
          {
              color: "#DFDFDF"
          },
          minorTickLines:
          {
              color: "#8E8E8E"
          },
          axisLine: { color: '#8E8E8E' },
          font: { color: '#333333' },
          title:
          {
              font: { color: '#333333' }
          },
          crosshairLabel: { rx: 0, ry: 0, border: { color: '#3D3D3D', width: 1 }, fill: '#3D3D3D', font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', size: '13px', fontWeight: 'regular', opacity: 1, color: '#DBDBDB' } }
      },
      commonSeriesOptions:
            {
                marker: {
                    dataLabel: { font: { color: '#333333' } }
                },
                errorBar: {
                    fill: "#000000",
                    cap:
                    {
                        fill: "#000000"
                    }
                },
                connectorLine: { color: '#565656' }
            },
      crosshair:
      {
          line:
          {
              width: 1,
              color: 'Black'
          }
      },

      seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.defaultOffice,
      colors: ej.EjSvgRender.seriesPalette.defaultOffice

  }
};
$.extend(ej.EjSvgRender.themes, {

    "azure":
    {

        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.blueMetro,
        colors: ej.EjSvgRender.seriesPalette.blueMetro
    },

    "azuredark":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.blueMetro,
        colors: ej.EjSvgRender.seriesPalette.blueMetro
    },
    "gradient-azure":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.blueGradient.borderColors,
        colors: ej.EjSvgRender.seriesPalette.blueGradient.seriesColors
    },

    "gradient-azuredark":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.blueGradient.borderColors,
        colors: ej.EjSvgRender.seriesPalette.blueGradient.seriesColors
    },

    "lime":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.greenMetro,
        colors: ej.EjSvgRender.seriesPalette.greenMetro
    },

    "limedark":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.greenMetro,
        colors: ej.EjSvgRender.seriesPalette.greenMetro
    },
    "gradient-lime":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.greenGradient.borderColors,
        colors: ej.EjSvgRender.seriesPalette.greenGradient.seriesColors
    },

    "gradient-limedark":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.greenGradient.borderColors,
        colors: ej.EjSvgRender.seriesPalette.greenGradient.seriesColors
    },
    "saffron":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.sandleMetro,
        colors: ej.EjSvgRender.seriesPalette.sandleMetro
    },

    "saffrondark":
    {
        seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.sandleMetro,
        colors: ej.EjSvgRender.seriesPalette.sandleMetro
    },
    "gradient-saffron":
{
    seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.sandleGradient.borderColors,
    colors: ej.EjSvgRender.seriesPalette.sandleGradient.seriesColors
},

    "gradient-saffrondark":
{
    seriesBorderDefaultColors: ej.EjSvgRender.seriesPalette.sandleGradient.borderColors,
    colors: ej.EjSvgRender.seriesPalette.sandleGradient.seriesColors
}
});
})(jQuery);;
ej.axisTypes = {};

ej.EjAxisRenderer = function () {
};
var _sideBySeriesPadding = function (chartObj, start, end, axis) {
    var visibleSeries = ej.DataManager(chartObj.model._visibleSeries, ej.Query().sortBy("_zOrder")).executeLocal();
    var isPadding = false;
    var data, startPadding, endPadding;
    var visibleSeriesLength = visibleSeries.length;
	var axisOrientation = axis.orientation.toLowerCase();
    for (var i = 0; i < visibleSeriesLength; i++) {
        var type = visibleSeries[i].type.toLowerCase();
        if (((type.indexOf("column") != -1 || type.indexOf("bar") != -1 || type.indexOf("waterfall") != -1 || type == "candle" || type.indexOf("hilo") != -1 || type.indexOf("box") != -1)))
        {
            isPadding = true;
            break;
        }

    }
    if (chartObj.model.AreaType != "polaraxes" && isPadding) {
        axis.m_minPointsDelta = undefined;
        var padding = ej.EjSvgRender.utils.getMinPointsDelta(axis, chartObj, start) * 0.5;
        start = start - padding;
        end = (end + padding > Number.MAX_VALUE) ? Number.MAX_VALUE : end + padding;
        axis.padding = padding;
    }
    else
		axis.padding=0;
    return data = { startPadding: start, endPadding: end };
};
ej.EjStripline = function (chartobj) {
    this.chart = chartobj;
};
(function ($) {
    ej.EjAxisRenderer.prototype = {

        //Calculate min/max value for series
        _seriesMinMax: function (chartObj, axis, seriesCollection, type, params) {
     		var orientation = axis.orientation.toLowerCase(), seriesLength = seriesCollection.length;
     		params.seriesCollection = ej.util.isNullOrUndefined(params.seriesCollection) ? {} : params.seriesCollection;
            var count;
            if ((seriesLength > 0 && chartObj.model._hasSeriesPoints && seriesCollection[0].points.length > 0) || this.chartObj.model.indicators[0]._points.length>0) {

                var maxX, minY, minX, maxY;
                var maxMinXValue = { maxX: null, minX: null };
                var maxMinYValue = { maxY: null, minY: null };
                var xMax = maxMinXValue.maxX;
                var xMin = maxMinXValue.minX;
                var yMax = maxMinYValue.maxY;
                var yMin = maxMinYValue.minY;
                var seriesVisibility,pointsLength,visibleLength,seriesType;

                for (var i = 0; i < seriesLength; i++) {
                    seriesVisibility = seriesCollection[i].visibility.toLowerCase();
                    pointsLength = seriesCollection[i].points.length;
                    count = 0;
                    if (seriesVisibility === 'visible') {
                        seriesCollection[i]._visiblePoints = [];
                        for (var j = 0; j < pointsLength; j++) {
                            var point = seriesCollection[i].points[j];
                            if ((point.x != null && point.x != undefined) && ((point.y != null && point.y != undefined) || point.showIntermediateSum || point.showTotalSum || point.isEmpty == false)) {
                                seriesCollection[i]._visiblePoints[count] = point;
								seriesCollection[i]._visiblePoints[count].actualIndex = j;
                                count++;
                            }
                        }
                    }
                    axis.maxPointLength = pointsLength;
                }

                for (var i = 0; i < seriesLength; i++) {
                    visibleLength = seriesCollection[i]._visiblePoints.length;
					var series = seriesCollection[i];
                    if (visibleLength > 0) {
                        seriesVisibility = seriesCollection[i].visibility.toLowerCase();
                        pointsLength = seriesCollection[i].points.length;
                        if (seriesVisibility === 'visible' && pointsLength > 0) {
                            if ((orientation == "horizontal" && !(chartObj.model.requireInvertedAxes)) || (orientation == "vertical" && chartObj.model.requireInvertedAxes) ) {
                                minX = maxX = seriesCollection[i]._visiblePoints[0].xValue;
                                for (var j = 0; j < visibleLength; j++) {
                                    var currentPoint = seriesCollection[i]._visiblePoints[j].xValue;
                                    if (minX > currentPoint)
                                        minX = currentPoint;
                                    if (maxX < currentPoint)
                                        maxX = currentPoint;
                                }
                                seriesCollection[i].minX = minX;
                                seriesCollection[i].maxX = maxX;

                                if ((xMin === null || xMin === undefined) && visibleLength > 0) {
                                    xMax = seriesCollection[i].maxX;
                                    xMin = seriesCollection[i].minX;
                                }
                                if (xMin > seriesCollection[i].minX) {
                                    xMin = seriesCollection[i].minX;
                                }
                                if (xMax < seriesCollection[i].maxX) {
                                    xMax = seriesCollection[i].maxX;
                                }
                            }
                            else {
								var isSpline = (series.type.toLowerCase().indexOf('spline')!=-1), controlPoint, naturalSpline, getBezierControlPoints,
									controlPointsCount = 0, visiblePoints = seriesCollection[i]._visiblePoints;
								if(isSpline){
									var seriesKey = series._name = series.name || 'series' + i;									
									params.seriesCollection[seriesKey] = {};
									visiblePoints = ej.ejSplineSeries.prototype._isVisiblePoints(series),
									naturalSpline = params.seriesCollection[seriesKey].naturalSpline = ej.ejSplineSeries.prototype.naturalSpline(visiblePoints);
									params.seriesCollection[seriesKey].controlPoints = [];
									getBezierControlPoints = ej.ejSplineSeries.prototype.getBezierControlPoints;									
								}
                                maxY = minY = visiblePoints[0].YValues[0];
								 var minval,maxval;
                                for (var j = 0; j < visiblePoints.length; j++) {
                                    var currentPoint = visiblePoints[j];
                                    if (seriesCollection[i]._hiloTypes) {
                                        for (var y = 0; y < 2; y++) {
                                            if (minY > currentPoint.YValues[y])
                                                minY = currentPoint.YValues[y];
                                            if (maxY < currentPoint.YValues[y])
                                                maxY = currentPoint.YValues[y];
                                        }
                                    }
									else if(series.type.toLowerCase() == "boxandwhisker")
									{
									     minval =  visiblePoints[j].YValues[0][0];
										 maxval = visiblePoints[j].YValues[0][0];
										for (var yindex = 0; yindex < currentPoint.YValues[0].length; yindex++) 
										{
											if ( minval > currentPoint.YValues[0][yindex])
                                                minval = currentPoint.YValues[0][yindex];
											if (maxval < currentPoint.YValues[0][yindex])
                                                maxval = currentPoint.YValues[0][yindex];
										}
									    minY = minval > minY  ? minY : minval;
										maxY = maxval < maxY ? maxY : maxval;
									}
									else if(isSpline){
										if(j!=0 && currentPoint.visible && visiblePoints[j-1].visible){											
											params.seriesCollection[seriesKey].controlPoints.push(getBezierControlPoints(visiblePoints[j-1], currentPoint, naturalSpline[j-1], naturalSpline[j], 0)); 
											controlPoint = params.seriesCollection[seriesKey].controlPoints[controlPointsCount++];
											minY = Math.min(minY, currentPoint.YValues[0], controlPoint.controlPoint1.YValues[0], controlPoint.controlPoint2.YValues[0]);
											maxY = Math.max(maxY, currentPoint.YValues[0], controlPoint.controlPoint1.YValues[0], controlPoint.controlPoint2.YValues[0]);
										}
										else{
											minY = Math.min(minY, currentPoint.YValues[0] || null);
											maxY = Math.max(maxY, currentPoint.YValues[0] || null);										
										}
									}
									else {
                                        if (minY > currentPoint.YValues[0])
                                            minY = currentPoint.YValues[0];
                                        if (maxY < currentPoint.YValues[0])
                                            maxY = currentPoint.YValues[0];
                                    }
                                }
                                seriesCollection[i].minY = minY;
                                seriesCollection[i].maxY = maxY;

                                if ((yMin === null || yMin === undefined) && visibleLength > 0) {
                                    yMax = seriesCollection[i].maxY;
                                    yMin = seriesCollection[i].minY;
                                }
                                if (yMin > seriesCollection[i].minY) {
                                    yMin = seriesCollection[i].minY;
                                }
                                if (yMax < seriesCollection[i].maxY) {
                                    yMax = seriesCollection[i].maxY;
                                }

                                // Finding Min and Max for Column and Bar series
                                seriesType = seriesCollection[i].type
                                if ((seriesType == 'column' || seriesType == 'bar') && axis.startFromZero)
                                    yMin = (yMin < 0) ? yMin : 0;
                            }
                        }
                    }
                }
                if ((orientation == "horizontal" && !(chartObj.model.requireInvertedAxes)) || (orientation == "vertical" && chartObj.model.requireInvertedAxes)) {

                    // Find min/max for indicator series
                    if (this.chartObj.model.indicatorRange && this.chartObj.model.indicatorRange[axis.name]) {
                        var value = this.chartObj.model.indicatorRange[axis.name];
                        if (yMin > value.min || yMin == null)
                            yMin = value.min;
                        if (yMax < value.max || yMax == null)
                            yMax = value.max;                       
                    }

                    if (xMax == xMin)
                        xMax += 1;

                    if (type == "double") {
                        var data = _sideBySeriesPadding(chartObj, xMin, xMax, axis);
                        xMin = data.startPadding;
                        xMax = data.endPadding;
                        deltaX = xMax - xMin;
                        axis.range = this._getDoubleAutoRange(axis, xMin, xMax, deltaX);    
                    }                        
                    else
                        axis.range = this._getLogAutoRange(axis, xMin, xMax, xMax - xMin);

                }
                else {

                    // Find min/max for stacked series
                    if (this.chartObj.model.stackedValue[axis.name]) {
                        var value = this.chartObj.model.stackedValue[axis.name],
                            isStacked = true;
                        if (yMin > value.min)                            
                            yMin = value.min;
                        if (yMax < value.max)
                            yMax = value.max;
                    }

                    // Find min/max for indicator series
                    if (this.chartObj.model.indicatorRange && this.chartObj.model.indicatorRange[axis.name]) {
                        var value = this.chartObj.model.indicatorRange[axis.name];                       
                        if (yMin > value.min || yMin == null)
                            yMin = value.min;
                        if (yMax < value.max || yMax == null)
                            yMax = value.max;                        
                    }

                    if (yMax == yMin) {                   // max == min
                        if (yMax < 0)                                  // value less than 0
                            yMax = 0;
                        else if (yMax <= 1 && yMax > 0)   // value between 0 and 1
                            yMin = 0;
                        else {                                                      // value greater than 1
                            yMin = 0;
                            yMax += 1;
                        }
                    }

                    if ((seriesType == 'column' || seriesType == 'bar') && !axis.startFromZero) {
                        var maxLimit = (axis.range && axis.range.max) || yMax;
                        var interval = (axis.range && axis.range.interval) || this.calculateNumericNiceInterval(maxLimit - yMin, axis, null, maxLimit);
                        yMax += interval;
                        if ((yMin - interval < 0 && yMin > 0) || isStacked) {
                            yMin = 0;                           
                        }
                        else
                            yMin -= interval;
                    }

                    var deltaY = yMax - yMin;
                    isStacked = false;

                    if (type == "double")
                        axis.range = this._getDoubleAutoRange(axis, yMin, yMax, deltaY)
                    else
                        axis.range = this._getLogAutoRange(axis, yMin, yMax, deltaY)

                }
            }
            else {
                if (!axis.setRange){
                    axis.range = { min: 0, max: 5, interval: 1, Delta: 4 };
				}
				else {
                    min=( axis.range.min== null || axis.range.min == undefined )?0:axis.range.min;
                    max = (axis.range.max == null || axis.range.max == undefined) ? 5 : axis.range.max;
			        delta=max-min;
			        axis.range=this._getDoubleAutoRange(axis,min,max,delta)
				}
            }
			 var commonAxisEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonAxisEventArgs.data = { range: axis.range, axis: axis };
            this.chartObj._trigger("axesRangeCalculate", commonAxisEventArgs);
            var range = commonAxisEventArgs.data.range;
            axis.range = { min: range.min, max: range.max, interval: range.interval, delta: (range.max - range.min) };

        },

        //Calculate ranges for Trendline series
        _calculateTrendLineRange: function (chart, axis, seriesCollection) {            
            var series, trendlines, trendline, count, serLength, trendLength, trendlineType;
            var serLength = seriesCollection.length;
            for (var m = 0; m < serLength; m++) {
                series = seriesCollection[m];
                trendlines = series.trendlines;
                if (chart.model.AreaType == "cartesianaxes" && (axis.name == series._xAxisName || axis.name == series._yAxisName)) {
                    trendLength = trendlines.length;
                    for (var i = 0; i < trendLength; i++) {
                        trendline = trendlines[i];
                        if (trendline.visibility.toLowerCase() === 'visible') {                            
                            
                            if (axis.name == series._xAxisName) {
                                trendlineType = trendline.type.toLowerCase();
                                options = new ej.trendlineTypes[trendlineType]();
                                options.calculateTrendLineSegment(series, trendline, axis, chart);
                            } else
                                if (axis.name == series._yAxisName && !axis.setRange && trendline.points && trendline.points.length > 1) {
                                    count = trendline.points.length - 1;
                                    axis.range.min = axis.range.min > trendline.minY ? trendline.minY : axis.range.min;
                                    axis.range.max = axis.range.max < trendline.maxY ? trendline.maxY : axis.range.max;
                                }
                        }
                    }
                }
            }
            return false;
        },

        AlignRangeStart: function (sDate, intervalSize, intervalType) {
            var sResult = new Date(sDate);
            if (intervalType.toLowerCase() == "days") {
                var day = Math.floor(Math.floor((sDate.getDate()) / intervalSize) * intervalSize);
                sResult = new Date(sDate.getFullYear(), sDate.getMonth(), day, 0, 0, 0);
            } else if (intervalType.toLowerCase() == "hours") {
                var hour = Math.floor(Math.floor((sDate.getHours()) / intervalSize) * intervalSize);
                sResult = new Date(sDate.getFullYear(), sDate.getMonth(), sDate.getDate(), hour, 0, 0);
            } else if (intervalType.toLowerCase() == "milliseconds") {
                var milliseconds = Math.floor(Math.floor((sDate.getMilliseconds()) / intervalSize) * intervalSize);
                sResult = new Date(sDate.getFullYear(), sDate.getMonth(), sDate.getDate(), sDate.getHours(), sDate.getMinutes(), sDate.getSeconds(), milliseconds);
            } else if (intervalType.toLowerCase() == "seconds") {
                var seconds = Math.floor(Math.floor((sDate.getSeconds()) / intervalSize) * intervalSize);
                sResult = new Date(sDate.getFullYear(), sDate.getMonth(), sDate.getDate(), sDate.getHours(), sDate.getMinutes(), seconds, 0);
            } else if (intervalType.toLowerCase() == "minutes") {
                var minutes = Math.floor(Math.floor((sDate.getMinutes()) / intervalSize) * intervalSize);
                sResult = new Date(sDate.getFullYear(), sDate.getMonth(), sDate.getDate(), sDate.getHours(), minutes, 0, 0);
            } else if (intervalType.toLowerCase() == "months") {
                var month = Math.floor(Math.floor((sDate.getMonth()) / intervalSize) * intervalSize);
                sResult = new Date(sDate.getFullYear(), month, sDate.getDate(), 0, 0, 0);
            } else if (intervalType.toLowerCase() == "years") {
                var year = Math.floor(Math.floor(sDate.getFullYear() / intervalSize) * intervalSize);
                sResult = new Date(year, sDate.getMonth(), sDate.getDate(), 0, 0, 0);
            }
            return sResult;
        },
        _increaseDateTimeInterval: function (date, interval, intervalType) {
            var result = new Date(date);
            if (intervalType.toLowerCase() == "days") {
                result.setDate(date.getDate() + interval);
            } else if (intervalType.toLowerCase() == "hours") {
                result.setHours(date.getHours() + interval);
            } else if (intervalType.toLowerCase() == "milliseconds") {
                result.setMilliseconds(date.getMilliseconds() + interval);
            } else if (intervalType.toLowerCase() == "seconds") {
                result.setSeconds(date.getSeconds() + interval);
            } else if (intervalType.toLowerCase() == "minutes") {
                result.setMinutes(date.getMinutes() + interval);
            } else if (intervalType.toLowerCase() == "months") {
                result.setMonth(date.getMonth() + interval);
            } else if (intervalType.toLowerCase() == "years") {
                result.setYear(date.getFullYear() + interval);
            }

            return result;
        },

        _calculatePadding: function (axis) {

            var start = (typeof axis.range.min == "string" && !isNaN(Date.parse(axis.range.min))) ? Date.parse(axis.range.min) : (axis.range.min).getTime();
            var end = (typeof axis.range.max == "string" && !isNaN(Date.parse(axis.range.max))) ? Date.parse(axis.range.max) : (axis.range.max).getTime();
            var interval = ((this._increaseDateTimeInterval(new Date(start), axis.range.interval, axis._intervalType)).getTime()) - start;
            var rangePadding =axis.rangePadding.toLowerCase();
            if (!this.chartObj.zoomed && !axis.setRange) {
                start = new Date(start);
                end = new Date(end);
                var intervalType = axis._intervalType.toLowerCase();
                if (axis.rangePadding.toLowerCase() == 'none') {
                start =  start.getTime();
                end = end.getTime();
            } else if (rangePadding == 'additional' || rangePadding == 'round') {
                switch (intervalType) {
                    case 'years':
                        var startYear = start.getFullYear();
                        var endYear = end.getFullYear();
                        if (axis.rangePadding.toLowerCase() == 'additional') {
                            start = (new Date(startYear - axis.range.interval, 1, 1, 0, 0, 0)).getTime();
                            end = (new Date(endYear + axis.range.interval, 1, 1, 0, 0, 0)).getTime();
                        } else {
                            start = new Date(startYear, 0, 0, 0, 0, 0).getTime();
                            end=new Date(endYear, 11, 30, 23, 59, 59).getTime();
                        }
                        break;
                    case 'months':                        
                        var month = start.getMonth();
                        var endMonth = end.getMonth();
                        if (rangePadding == 'round') {
                            start = (new Date(start.getFullYear(), month, 0, 0, 0, 0)).getTime();
                            end = (new Date(end.getFullYear(), endMonth, new Date(end.getFullYear(), end.getMonth(), 0).getDate(), 23, 59, 59)).getTime();
                        } else {
                            start = (new Date(start.getFullYear(), month + (-axis.range.interval), 1, 0, 0, 0)).getTime();
                            end = (new Date(end.getFullYear(), endMonth + (axis.range.interval), endMonth == 2 ? 28 : 30, 0, 0, 0)).getTime();
                        }
                        break;
                    case 'days':
                        var day = start.getDate();
                        var endDay = end.getDate();
                        if (rangePadding == 'round') {
                            start = (new Date(start.getFullYear(), start.getMonth(), day, 0, 0, 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), endDay, 23, 59, 59)).getTime();
                        } else {
                            start = (new Date(start.getFullYear(), start.getMonth(), day + (-axis.range.interval), 0, 0, 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), endDay + (axis.range.interval), 0, 0, 0)).getTime();
                        }
                        break;
                    case 'hours':
                        var hour = (start.getHours() / axis.range.interval) * axis.range.interval;
                        var endHour = end.getHours() + (start.getHours() - hour);
                        if (rangePadding == 'round') {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), hour, 0, 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), endHour, 59, 59)).getTime();
                        } else {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), hour + (-axis.range.interval), 0, 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), endHour + (axis.range.interval), 0, 0)).getTime();
                        }
                        break;
                    case 'minutes':
                        var minute = (start.getMinutes() / axis.range.interval) * axis.range.interval;
                        var endMinute = end.getMinutes() + (start.getMinutes() - minute);
                        if (rangePadding == 'round') {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), start.getHour(), minute, 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), end.getHour(), endMinute, 59)).getTime();
                        } else {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), start.getHours(), minute + (-axis.range.interval), 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), end.getHours(), minute + (axis.range.interval), 0)).getTime();
                        }
                        break;
                    case 'seconds':
                        var second = (start.getSeconds() / axis.range.interval) * axis.range.interval;
                        var endSecond = end.getSeconds() + (start.getSeconds() - second);
                        if (rangePadding == 'round') {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), start.getHours(), start.getMinutes(), second, 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), end.getHour(), end.getMinutes(), endSecond, 0)).getTime();
                        } else {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), start.getHours(), start.getMinutes(), second + (-axis.range.interval), 0)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), end.getHours(), end.getMinutes(), endSecond + (axis.range.interval), 0)).getTime();
                        }
                        break;
                    case 'milliseconds':
                        var milliSecond = (start.getMilliseconds() / axis.range.interval) * axis.range.interval;
                        var endMilliSecond = end.getMilliseconds() + (start.getMilliseconds() - milliSecond);
                        if (rangePadding == 'round') {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), start.getHours(), start.getMinutes(), start.getSeconds(), milliSecond)).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), end.getHours(), end.getMinutes(), end.getSeconds(), endMilliSecond)).getTime();
                        } else {
                            start = (new Date(start.getFullYear(), start.getMonth(), start.getDay(), start.getHours(), start.getMinutes(), start.getSeconds(), milliSecond + (-axis.range.interval))).getTime();
                            end = (new Date(end.getFullYear(), end.getMonth(), end.getDay(), end.getHours(), end.getMinutes(), end.getSeconds(), endMilliSecond + (axis.range.interval))).getTime();
                        }
                        break;
                }

            }

        }
        axis.actualRange.interval = interval;
        axis.actualRange.min = start;
        axis.actualRange.max = end;
        axis._interval = axis.range.interval;
        axis.actualRange.delta = (axis.actualRange.max - axis.actualRange.min);
        axis.range.min = new Date(start);
        axis.range.max = new Date(end);
        this._calculateVisibleRange(axis);

    },
    _calculateVisibleRange: function (axis, sender, isScroll) {
        this.chartObj = sender ? sender : this.chartObj;
        axis.visibleRange = (!isScroll) ? $.extend(true, {}, axis.actualRange) : axis.visibleRange;
        if ((axis.zoomFactor < 1 || axis.zoomPosition > 0) && this.chartObj.model.AreaType != "polaraxes" && !this.chartObj.model.disableZoom) {

            axis.zoomFactor = axis.zoomFactor > 1 ? 1 : (axis.zoomFactor < 0 ? 0 : axis.zoomFactor);
            axis.zoomPosition = axis.zoomPosition < 0 ? 0 : (axis.zoomPosition > 1 ? 1 : axis.zoomPosition);
            var baseRange = axis.actualRange;
            if (axis.isInversed) {
                var start = axis.actualRange.max - axis.zoomPosition * axis.actualRange.delta;
                var end = start - axis.zoomFactor * axis.actualRange.delta;
            }
            else {
                var start = axis.actualRange.min + axis.zoomPosition * axis.actualRange.delta;
                var end = start + axis.zoomFactor * axis.actualRange.delta;
            }

            if (start < baseRange.min) {
                end = end + (baseRange.min - start);
                start = baseRange.min;
            }

            if (end > baseRange.max) {
                start = start - (end - baseRange.max);
                end = baseRange.max;
            }

            var startDate = new Date(start);
            var endDate = new Date(end);
			 if (start == end)
            {
                startDate = new Date(Date.parse(startDate) - 2592000000);
                endDate = new Date(Date.parse(endDate) + 2592000000);
            }
            //Use below code to find min,max and interval for visible range
			 var min = Math.min(startDate.getTime(), endDate.getTime());
			 var max = Math.max(startDate.getTime(), endDate.getTime());
			 var intervalX = axis.enableAutoIntervalOnZooming ? this.calculateDateTimeNiceInterval(axis, startDate, endDate) : { 'interval': axis._interval, 'intervalType': axis._intervalType };
			 var interval = ((this._increaseDateTimeInterval(startDate, intervalX.interval, intervalX.intervalType)).getTime()) - min;

			 if (isScroll) {
			     return {min:min, max:max, interval:interval};
			 }
			 else {
			     axis._intervalType = intervalX.intervalType;
			     axis.visibleRange.min = min;
			     axis.visibleRange.max = max;
			     axis.visibleRange.interval = interval;
			     axis.visibleRange.delta = Math.abs(axis.visibleRange.max - axis.visibleRange.min);
			     axis._interval = intervalX.interval;
			 }
        }

    },
    _calculateAxisLabels: function (axis) {
        var position,text;
		var minRange = axis.enableAutoIntervalOnZooming ? axis.visibleRange.min : axis.actualRange.min;
        if (this.chartObj.zoomed || axis.zoomed || !axis.setRange)
            position = (this.AlignRangeStart(new Date(minRange), axis._interval, axis._intervalType)).getTime();

        else
            position = axis.visibleRange.min;
        while (position <= axis.visibleRange.max) {
            if (position >= axis.visibleRange.min && position <= axis.visibleRange.max) {
                text=(ej.format(new Date(position), ((!(axis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(axis._intervalType) : axis.labelFormat), this.chartObj.model.locale));
				 var commonAxesEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
				 commonAxesEventArgs.data = { label: { Text: text, Value: position }, axis: axis };
                this.chartObj._trigger("axesLabelRendering", commonAxesEventArgs);
                axis.visibleLabels.push({ Value: position, Text: commonAxesEventArgs.data.label.Text });
            }
            position = (this._increaseDateTimeInterval(new Date(position), axis._interval, axis._intervalType)).getTime();
            
            axis.visibleLabels[axis.visibleLabels.length - 1] = axis.visibleLabels[axis.visibleLabels.length-1];
        }
        axis._LableMaxWidth = ej.EjSvgRender.utils._getMaxLabelWidth(axis, this.chartObj);
    },
    calculateDateTimeNiceInterval: function (axis, startDate, endDate) { 
        var oneDay = 24 * 60 * 60 * 1000;
        //var axisInterval ;
        var totalDays = (Math.abs((startDate.getTime() - endDate.getTime()) / (oneDay)));
        var interval = this.calculateNumericNiceInterval(totalDays / 365, axis, "years");

        if (interval >= 1) {
            return { interval: interval, intervalType: "Years" };
        }

        interval = this.calculateNumericNiceInterval(totalDays / 30, axis, "months");

        if (interval >= 1) {
            return { interval: interval, intervalType: "Months" };
        }

        interval = this.calculateNumericNiceInterval(totalDays, axis, "days");

        if (interval >= 1) {


            return { interval: interval, intervalType: "Days" };
        }

        var totalHours = totalDays * 24;

        interval = this.calculateNumericNiceInterval(totalHours, axis, "hours");

        if (interval >= 1) {

            return { interval: interval, intervalType: "Hours" };
        }

        var totalMinutes = totalDays * 24 * 60;

        interval = this.calculateNumericNiceInterval(totalMinutes, axis, "minutes");

        if (interval >= 1) {

            return { interval: interval, intervalType: "Minutes" };
        }

        var totalSeconds = totalDays * 24 * 60 * 60;

        interval = this.calculateNumericNiceInterval(totalSeconds, axis, "seconds");

        if (interval >= 1) {

            return { interval: interval, intervalType: "Seconds" };
        }

        var totalMilliseconds = totalDays * 24 * 60 * 60 * 1000;

        interval = this.calculateNumericNiceInterval(totalMilliseconds, axis, "milliseconds");

        if (interval >= 1) {

            return { interval: interval, intervalType: "Milliseconds" };
        }

    },
    calculateNumericNiceInterval: function (delta, axis, setInterval, max) {
        var desiredIntervalsCount = this.GetActualDesiredIntervalsCount(axis, axis.length);
        var niceInterval = delta / desiredIntervalsCount;
        if (axis._valueType=='double'){
            if (axis.desiredIntervals!= null)
                return niceInterval;
        }
        var minInterval = Math.pow(10, Math.floor(ej.EjSvgRender.utils._logBase(niceInterval, 10))),
            intervalDivs = [10, 5, 2, 1],
            maxLimit = max || (axis.range && axis.range.max);


        for (var i = 0; i < intervalDivs.length; i++) {
            var currentInterval = minInterval * intervalDivs[i];
            if (desiredIntervalsCount < (delta / currentInterval)) {
                if (axis._valueType == "datetime") {
                    return niceInterval=(!ej.util.isNullOrUndefined(axis.intervalType) && axis.intervalType.toLowerCase() == setInterval) ? Math.ceil(niceInterval):niceInterval;
                }
				 if (!ej.util.isNullOrUndefined(axis.range) && !ej.util.isNullOrUndefined(axis.range.max))
				     return (niceInterval > maxLimit ? currentInterval : niceInterval);
				 else
					return niceInterval;
            }

            niceInterval = currentInterval;
        }

        return niceInterval;
    },
    GetActualDesiredIntervalsCount: function (axis, size) {
        if (ej.util.isNullOrUndefined(axis.desiredIntervals)) {
            var desiredIntervalsCount = (axis.orientation.toLowerCase() == "horizontal" ? 0.533 : 1) * axis.maximumLabels;
            desiredIntervalsCount = Math.max((size * (desiredIntervalsCount / 100)), 1);
        
                return desiredIntervalsCount;
            } else {
                return axis.desiredIntervals;
            }
        },
        _calculateRange: function (axis, seriesCollection) {
            if (!this.chartObj.zoomed) {
                var defaultDate = new Date();
                if (seriesCollection.length > 0 && this.chartObj.model._hasSeriesPoints && seriesCollection[0].points.length > 0 || this.chartObj.model.indicators[0]._points.length > 0) {
                    var maxX, minY;
                    var maxY, minX;
                    var maxMinXValue = { maxX: null, minX: null };
                    var maxMinYValue = { maxY: null, minY: null };
                    var pointLength;
                    for (var i = 0; i < seriesCollection.length; i++) {
                        pointLength = seriesCollection[i].points.length;
                        if (pointLength > 0) {
                            if (seriesCollection[i].visibility.toLowerCase() === 'visible' && seriesCollection[i].points.length > 0) {
                                minX = maxX = seriesCollection[i].points[0].xValue;
                                maxY = minY = seriesCollection[i].points[0].YValues[0];                                
                                for (var j = 0; j < pointLength; j++) {
                                    if (minX != null && minX != undefined) {
                                        if (minX > seriesCollection[i].points[j].xValue)
                                            minX = seriesCollection[i].points[j].xValue;
                                        if (maxX < seriesCollection[i].points[j].xValue)
                                            maxX = seriesCollection[i].points[j].xValue;
                                    }
                                    else {
                                        minX = maxX = seriesCollection[i].points[j+1].xValue;
                                    }
                                    if (minY > seriesCollection[i].points[j].YValues[0])
                                        minY = seriesCollection[i].points[j].YValues[0];
                                    if (maxY < seriesCollection[i].points[j].YValues[0])
                                        maxY = seriesCollection[i].points[j].YValues[0];
                                }
                                seriesCollection[i].minX = minX;
                                seriesCollection[i].maxX = maxX;
                                seriesCollection[i].minY = minY;
                                seriesCollection[i].maxY = maxY;
                                if (!axis.maxPointLength || axis.maxPointLength < pointLength)
                                    axis.maxPointLength = pointLength;
                            }
                        }
                    
                    if ((maxMinXValue.minX = (maxMinXValue.minX == null  && typeof seriesCollection[i].minX != "number") ? seriesCollection[i].minX : maxMinXValue.minX) > seriesCollection[i].minX) {
                            maxMinXValue.minX = (typeof seriesCollection[i].minX != "number") ? seriesCollection[i].minX : maxMinXValue.minX;
                        }
                        if ((maxMinXValue.maxX = (maxMinXValue.maxX == null && typeof seriesCollection[i].maxX != "number") ? seriesCollection[i].maxX : maxMinXValue.maxX) < seriesCollection[i].maxX) {
                            maxMinXValue.maxX = (typeof seriesCollection[i].maxX != "number") ? seriesCollection[i].maxX : maxMinXValue.maxX;
                        }
                        if (maxMinYValue.minY > seriesCollection[i].minY) {
                            maxMinYValue.minY = seriesCollection[i].minY;
                        }
                        if (maxMinYValue.maxY < seriesCollection[i].maxY) {
                            maxMinYValue.maxY = seriesCollection[i].maxY;
                        }
               
                }
				// Find min/max for indicator series

                  if (this.chartObj.model.indicatorRange && this.chartObj.model.indicatorRange[axis.name]) {
                    var value = this.chartObj.model.indicatorRange[axis.name];
                    if (maxMinXValue.minX > new Date(value.min) || maxMinXValue.minX == null)
                        maxMinXValue.minX = new Date(value.min);
                    if (maxMinXValue.maxX < new Date(value.max) || maxMinXValue.maxX == null)
                        maxMinXValue.maxX = new Date(value.max);
                 }
                maxMinXValue.minX = (maxMinXValue.minX == null) ? defaultDate : maxMinXValue.minX;
                maxMinXValue.maxX = (maxMinXValue.maxX == null) ? new Date(new Date().setMonth(defaultDate.getMonth() + 5)) : maxMinXValue.maxX;
                if (maxMinXValue.minX == maxMinXValue.maxX) {
                    maxMinXValue.minX = new Date(Date.parse(maxMinXValue.minX) - 2592000000);
                    maxMinXValue.maxX = new Date(Date.parse(maxMinXValue.maxX) + 2592000000);
                }

                var data = _sideBySeriesPadding(this.chartObj, Date.parse(maxMinXValue.minX), Date.parse(maxMinXValue.maxX), axis);
                maxMinXValue.minX = new Date(data.startPadding);
                maxMinXValue.maxX = new Date(data.endPadding);

                

                var intervalX = this.calculateDateTimeNiceInterval(axis, maxMinXValue.minX, maxMinXValue.maxX);                
                axis._intervalType = (axis.intervalType) ? axis.intervalType : intervalX.intervalType;
                if (axis.intervalType == "auto")
                    axis._intervalType = axis.intervalType = intervalX.intervalType;
                if (axis.setAxisInterval == null || axis.setAxisInterval==undefined) {
                    axis.setAxisInterval = (axis.range && axis.range.interval) ? true : false;
                }
				
                //condition chechked when changing interval dynamically
                if (axis._setInterval && !this.chartObj._chartResize && axis.range && axis._setInterval != axis.range.interval)
                    axis._setInterval = null;

                if (!axis.setRange){
                    axis.range = { min: maxMinXValue.minX, max: maxMinXValue.maxX, interval: intervalX.interval };
                } else {
                        if (!axis.range.max)
                            axis.range.max = maxMinXValue.maxX;
                        if (!axis.range.min)
                            axis.range.min = maxMinXValue.minX;
                        if (typeof axis.range.min == "string" && axis.range.min.indexOf("/Date(") != -1)
                            axis.range.min = new Date(parseInt(axis.range.min.substr(6)));
                        if (typeof axis.range.max == "string" && axis.range.max.indexOf("/Date(") != -1)
                            axis.range.max = new Date(parseInt(axis.range.max.substr(6)));
                        if ( new Date(axis.range.min).getTime() ==  new Date(axis.range.max).getTime()) {                            
                            axis.range.max = new Date(Date.parse(axis.range.max) + 86400000);
                        }
                        intervalX = this.calculateDateTimeNiceInterval(axis, new Date(axis.range.min), new Date(axis.range.max));
                        axis._intervalType = (axis.intervalType) ? axis.intervalType : intervalX.intervalType;
                        if (!axis.setAxisInterval) {
                            axis.range.interval = intervalX.interval; // set auto interval value
                            axis._setInterval = intervalX.interval;
                        }
                        axis.actual_Range = $.extend(true, {}, axis.range);
                        axis.setRange = true;
                    var interval = axis._setInterval? intervalX.interval : (axis.range.interval || axis.actual_Range.interval);
                    axis.range = { min: axis.actual_Range.min, max: axis.actual_Range.max, interval: interval };
                  }
                } else {
                    if (!axis.setRange) {
                        axis.range = { min: defaultDate, max: new Date(new Date().setMonth(defaultDate.getMonth() + 5)), interval: 1 };
                        axis._intervalType = 'Months';
                    }
					else {
                        axis.range.min=( axis.range.min === null || axis.range.min === undefined) ?defaultDate:axis.range.min;
                        axis.range.max=(axis.range.max === null || axis.range.max=== undefined)?new Date(new Date().setMonth(defaultDate.getMonth() + 5)):axis.range.max;
                        axis.range.interval = (axis.range.interval === null || axis.range.interval === undefined) ? 1 : axis.range.interval;
			            axis._intervalType='Months';
                    }

                }
				 var commonAxisEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonAxisEventArgs.data = { range: axis.range, axis: axis };
                this.chartObj._trigger("axesRangeCalculate", commonAxisEventArgs);
                var range = commonAxisEventArgs.data.range;
                axis.range = { min: range.min, max: range.max, interval: range.interval, delta: (range.max - range.min) };
            }
        },
        _calculateRanges: function (chartObj, axis, seriesCollection) {

            this.chartObj = chartObj;

            this._calculateRange(axis, seriesCollection);

            if (chartObj.model._drawTrendline)
                this._calculateTrendLineRange(chartObj, axis, seriesCollection);

            this._calculatePadding(axis);

        this._calculateAxisLabels(axis);
    }
};

function ejExtendClass(parent, members) {
    var object = function () {
    };
    object.prototype = new parent();
    $.extend(object.prototype, members);
    return object;
}

//DateTime calculation
var ejDateTimeValue = ejExtendClass(ej.EjAxisRenderer);
ej.axisTypes.datetime = ejDateTimeValue;

var ejDoubleValue = ejExtendClass(ej.EjAxisRenderer, {
    
  
    _calculateRange: function (chartObj, axis, seriesCollection, params) {
        if (!chartObj.zoomed) {
            this._seriesMinMax(chartObj,axis, seriesCollection, "double", params);
        }
    },
    
    _getDoubleAutoRange: function (axis, min, max) {
        var delta;
        var interval;
        var intervalstr;
        if (!axis.setRange) {
            axis.range = { min: min, max: max};

        } else {
           
            if (ej.util.isNullOrUndefined(axis.range.max))
                       axis.range.max = max;          
            if (ej.util.isNullOrUndefined(axis.range.min))
                       axis.range.min = min;
     
            axis.actual_Range = $.extend(true, {}, axis.range);
            axis.setRange = true;
        }
        delta = axis.range.max - axis.range.min;
        interval = this.calculateNumericNiceInterval(delta, axis);
        if (ej.EjSvgRender.utils._decimalPlaces(interval) > 20) {
            intervalstr = interval.toString();
            interval = parseFloat((intervalstr.substring(0, intervalstr.indexOf(".")) + intervalstr.substring(intervalstr.indexOf("."), 22)));
        }
        if ((ej.util.isNullOrUndefined(axis.range.interval))||(axis.range.interval<0))
            axis.range.interval = interval;
        axis.range.delta = delta;

        return axis.range;
    },
    _calculatePadding: function (chartObj, axis, baseRange) {
        var start = baseRange.min;
        var end = baseRange.max;
        var rangePadding = axis.rangePadding.toLowerCase();
        var interval= baseRange.interval;
        if ((!axis.setRange) && (!chartObj.zoomed)) {
               
            if (rangePadding == 'normal') {
                var minimum = 0, remaining;
                if (start < 0) {
                    start = 0;
                    minimum = baseRange.min + (baseRange.min / 20);

                    remaining =  interval + (minimum %  interval);

                    if ((0.365 *  interval) >= remaining) {
                        minimum -= interval;
                    }

                    if (minimum %  interval < 0) {
                        minimum = (minimum -  interval) - (minimum % interval);
                    }
                } else {
                    minimum = start < ((5.0 / 6.0) * end)
                        ? 0
                        : (start - (end - start) / 2);
                    if (minimum %  interval > 0) {
                        minimum -= (minimum %  interval);
                    }
                }
                if (end > 0)
                    var maximum = ((end + (end - start) / 20) > Number.MAX_VALUE) ? Number.MAX_VALUE : (end + (end - start) / 20);
                else
                    var maximum = (end - (end - start) / 20);

                remaining = interval - (maximum % interval);

                if ((0.365 *  interval) >= remaining) {
                    maximum = (maximum + interval > Number.MAX_VALUE) ? Number.MAX_VALUE : maximum + interval;
                }

                if (maximum %  interval > 0) {
                    maximum = ((maximum + interval) - (maximum % interval) > Number.MAX_VALUE) ? Number.MAX_VALUE : (maximum + interval) - (maximum % interval);
                }
                 if (minimum <= 0) {
                    interval = this.calculateNumericNiceInterval(maximum - minimum, axis);
                    maximum = (Math.ceil(maximum / interval) * interval > Number.MAX_VALUE) ? Number.MAX_VALUE : Math.ceil(maximum / interval) * interval;
                }
                start = (!(axis.roundingPlaces)) ? parseFloat(minimum.toFixed((ej.EjSvgRender.utils._decimalPlaces(interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(interval)))) : parseFloat(minimum.toFixed(axis.roundingPlaces));
                end = (!(axis.roundingPlaces)) ? parseFloat(maximum.toFixed((ej.EjSvgRender.utils._decimalPlaces(interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(interval)))) : parseFloat(maximum.toFixed(axis.roundingPlaces));

            } else if (rangePadding == 'additional' || rangePadding == 'round') {
                start = Math.floor(start / interval) * interval;
                end = (Math.ceil(end / interval) * interval > Number.MAX_VALUE) ? Number.MAX_VALUE : Math.ceil(end / interval) * interval;
                if (rangePadding == 'additional') {
                    start -= interval;
                    end = end + interval >= Number.MAX_VALUE ? Number.MAX_VALUE : end + interval;
                }
            }


        }
        axis.actualRange.min = start;
        axis.actualRange.max = end;
        axis.actualRange.interval = interval;
        axis.range.min = start;
        axis.range.max = end;
        axis.range.interval =  interval;
        axis.actualRange.delta = end - start >= Number.MAX_VALUE ? end : end - start;
        this._calculateVisibleRange(axis);
    },
    _calculateVisibleRange: function (axis, sender, isScroll) {
        this.chartObj = sender ? sender : this.chartObj;
        axis.visibleRange = (!isScroll) ? $.extend(true, {}, axis.actualRange) : axis.visibleRange;
        if ((axis.zoomFactor < 1 || axis.zoomPosition > 0) && this.chartObj.model.AreaType != "polaraxes" && !this.chartObj.model.disableZoom) {
            var baseRange = axis.actualRange;

            axis.zoomFactor = axis.zoomFactor > 1 ? 1 : (axis.zoomFactor < 0 ? 0 : axis.zoomFactor);
            axis.zoomPosition = axis.zoomPosition < 0 ? 0 : (axis.zoomPosition > 1 ? 1 : axis.zoomPosition);
            if (axis.isInversed) {
                var start=axis.actualRange.max - axis.zoomPosition * axis.actualRange.delta;
                var end = start - axis.zoomFactor * axis.actualRange.delta;
            }
            else {
                var start = axis.actualRange.min + axis.zoomPosition * axis.actualRange.delta;
                var end = start + axis.zoomFactor * axis.actualRange.delta;
            }

            if (start < baseRange.min) {
                end = end + (baseRange.min - start);
                start = baseRange.min;
            }

            if (end > baseRange.max) {
                start = start - (end - baseRange.max);
                end = baseRange.max;
            }
          
            var delta =Math.abs(end-start);
            var interval = axis.enableAutoIntervalOnZooming ? this.calculateNumericNiceInterval(delta, axis) : axis.actualRange.interval;          
            if (isScroll) {
                return { min: Math.min(start, end), max: Math.max(start, end), delta: delta, interval: interval };
            }
            else {                
                axis.visibleRange.min = Math.min(start, end);
                axis.visibleRange.max = Math.max(start, end);
                axis.visibleRange.delta = delta;
                axis.visibleRange.interval = interval;
                axis.zoomed = (this.chartObj.zoomed === null || this.chartObj.zoomed === undefined) ? true : this.chartObj.zoomed;
            }
        }

    },
    _calculateAxisLabels: function (chartObj, currentAxis) {

        var tempInterval,
            customFormat,
             round = currentAxis.roundingPlaces,
             tempPlace, labelValue,
            commonAxesEventArgs,
            labelText, locale = this.chartObj.model.locale,
            labelFormat = currentAxis.labelFormat, labelPrecision, labelPrecisionHighest = 20, labelPrecisionDefault = 6;
        if (chartObj.zoomed || currentAxis.zoomed || currentAxis.padding)
            tempInterval = currentAxis.visibleRange.min - (currentAxis.visibleRange.min % currentAxis.visibleRange.interval);
		else
            tempInterval = currentAxis.visibleRange.min;
        for (; tempInterval <= currentAxis.visibleRange.max; tempInterval += currentAxis.visibleRange.interval) {          

            if (ej.EjSvgRender.utils._inside(tempInterval, currentAxis.visibleRange)) {
                tempPlace = (tempInterval.toString().split(0).length - 1 > 10) ? 10 : 20;
                tempInterval = parseFloat(tempInterval.toFixed((!round && round > tempPlace) ? round : tempPlace));
				//By default axis labels are rounded based on interval. These rounded values are not used to draw labels, so labels are misplaced from ticks
				labelValue = (!round) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(currentAxis.visibleRange.interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(currentAxis.visibleRange.interval)))) : tempInterval;
                labelText = (!(round)) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(currentAxis.visibleRange.interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(currentAxis.visibleRange.interval)))) : parseFloat(tempInterval.toFixed(round));
                
                customFormat = currentAxis.labelFormat;
                if(!(customFormat))
                    labelText = !currentAxis.isStacked100 ? (!locale ? labelText : labelText.toLocaleString(locale)): labelText + "%";
                else if(customFormat.match('{value}') != null )
                    labelText = customFormat.replace('{value}', labelText);
                else if ((customFormat.indexOf('e') == 0 || customFormat.indexOf('E') == 0) && (customFormat.indexOf("ej.format") == -1)) {
                    labelPrecision = customFormat.match(/(\d+)/g);
                    labelPrecision = labelPrecision == null ? labelPrecisionDefault : labelPrecision > labelPrecisionHighest ? labelPrecisionHighest : labelPrecision;
                    labelText = labelText.toExponential(labelPrecision);
                }
                else {
                    if (customFormat.indexOf("ej.format") != -1)
                        customFormat = customFormat.substring(customFormat.indexOf("(") + 1, customFormat.indexOf(")"));
                    labelText = ej.format(labelText, customFormat, locale);
                }

                // customize label by event
                commonAxesEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonAxesEventArgs.data = { label: { Text: labelText, Value: tempInterval }, axis: currentAxis };
                chartObj._trigger("axesLabelRendering", commonAxesEventArgs); 
                currentAxis.visibleLabels.push({ Value: labelValue, Text: commonAxesEventArgs.data.label.Text });
       
            }
        }

        currentAxis._LableMaxWidth = ej.EjSvgRender.utils._getMaxLabelWidth(currentAxis, this.chartObj);

    },

    _calculateRanges: function (chartObj, axis, seriesCollection, params) {
        this.chartObj = chartObj;

        this._calculateRange(chartObj, axis, seriesCollection, params);

        if (chartObj.model._drawTrendline)
            this._calculateTrendLineRange(chartObj, axis, seriesCollection);

        this._calculatePadding(chartObj, axis, axis.range);

        if(axis.maximumLabels > 0)  // to calculate only if labels have to be displayed
        this._calculateAxisLabels(chartObj, axis);

    }
});
ej.axisTypes.double = ejDoubleValue;
//log axis
var ejLogValue = ejExtendClass(ej.EjAxisRenderer, {
    
    // Get value for log min and max
   _getRoundValue:function (x,div,up)
    {
        return (up ? Math.ceil(x / div) : Math.floor(x / div)) * div;
   },
   
   // Caculate log nice interval
  calculateLogNiceInterval: function (delta, axis) {
       var desiredIntervalsCount = this.GetActualDesiredIntervalsCount(axis, axis.length);
       var niceInterval = delta;
       var minInterval = Math.pow(10, Math.floor(ej.EjSvgRender.utils._logBase(niceInterval, 10)));
       var intervalDivs = [10, 5, 2, 1];

       for (var i = 0; i < intervalDivs.length; i++) {
           var currentInterval = minInterval * intervalDivs[i];
           if (desiredIntervalsCount < (delta / currentInterval)) {
               return niceInterval;
           }

           niceInterval = currentInterval;
       }

       return niceInterval;
  },
   
    // Get log value for auto range
    _getLogAutoRange: function (axis, min, max, delta) {
        
        var logStart = ej.EjSvgRender.utils._logBase(min, axis.logBase);
        logStart = $.isNumeric(logStart) ? logStart : min;
        var logEnd = ej.EjSvgRender.utils._logBase(max, axis.logBase);
        logEnd = $.isNumeric(logEnd) ? logEnd : max;
     
        var mulS = this._getRoundValue(logStart, 1, false);
        var mulE = this._getRoundValue(logEnd, 1, true);
        if (mulS == 0 && mulE == 0) {
            mulS = ej.EjSvgRender.utils._logBase((max - max / 2), axis.logBase);
            mulE = ej.EjSvgRender.utils._logBase((max + max / 2), axis.logBase);
        }
        delta = mulE - mulS;
        var interval = this.calculateLogNiceInterval(delta, axis);

        axis.actual_Range = { min: mulS, max: mulE, interval: interval, Delta: delta };

        mulS = Math.pow(axis.logBase, Math.floor(logStart));
        mulE = Math.pow(axis.logBase, Math.ceil(logEnd));

        delta = mulE - mulS;        
      
        if (!axis.setRange) {        
          
            return axis.range = { min: mulS, max: mulE, interval: interval, Delta: delta };

        } else {
            if (ej.util.isNullOrUndefined(axis.range.interval))
                axis.range.interval = interval;
            if (ej.util.isNullOrUndefined(axis.range.max))
                axis.range.max = mulE;
            if (ej.util.isNullOrUndefined(axis.range.min))
                axis.range.min = mulS;

            axis.actual_Range = $.extend(true, {}, axis.range);

            if (!ej.util.isNullOrUndefined(axis.actual_Range.max)) {
                axis.actual_Range.max = ej.EjSvgRender.utils._logBase(axis.actual_Range.max, axis.logBase);
                axis.actual_Range.max = this._getRoundValue(axis.actual_Range.max, 1, true);
            }               
            if (!ej.util.isNullOrUndefined(axis.range.min)) {
                axis.actual_Range.min = ej.EjSvgRender.utils._logBase(axis.actual_Range.min, axis.logBase);
                axis.actual_Range.min = this._getRoundValue(axis.actual_Range.min, 1, false);
            }            
            
            axis.setRange = true;
          
            return axis.range;
        }
    },
   
      //Calcualte auto log range from series
        _calculateLogRange: function (chartObj, axis, seriesCollection, params) {
            if (!chartObj.zoomed) {
                this._seriesMinMax(chartObj,axis, seriesCollection, "logarithmic", params);
            }
        },
   
       //Assign base range values to actual range
        _calculateLogPadding: function (chartObj, axis, baseRange) {
            // No padding support for log axis
            var start = baseRange.min;
            var end = baseRange.max;
            var interval = baseRange.interval;
            axis.actualRange.min = start;
            axis.actualRange.max = end;
            axis.actualRange.interval = interval;         
            axis.actualRange.delta = end - start;
            this._calculateVisibleRange(axis);
        },
   
        // Calculate visible range for zooming
        _calculateVisibleRange: function (axis, sender, isScroll) {
            this.chartObj = sender ? sender : this.chartObj;
            axis.visibleRange = (!isScroll) ? $.extend(true, {}, axis.actualRange) : axis.visibleRange;
            if ((axis.zoomFactor < 1 || axis.zoomPosition > 0) && this.chartObj.model.AreaType != "polaraxes" && !this.chartObj.model.disableZoom) {
			     axis.zoomFactor = axis.zoomFactor > 1 ? 1 : (axis.zoomFactor < 0 ? 0 : axis.zoomFactor);
                axis.zoomPosition = axis.zoomPosition < 0 ? 0 : (axis.zoomPosition > 1 ? 1 : axis.zoomPosition);
                var baseRange = axis.actualRange;
                if (axis.isInversed) {
                    var start = axis.actualRange.max - axis.zoomPosition * axis.actualRange.delta;
                    var end = start - axis.zoomFactor * axis.actualRange.delta;
                }
                else {
                    var start = axis.actualRange.min + axis.zoomPosition * axis.actualRange.delta;
                    var end = start + axis.zoomFactor * axis.actualRange.delta;
                }

                if (start < baseRange.min) {
                    end = end + (baseRange.min - start);
                    start = baseRange.min;
                }

                if (end > baseRange.max) {
                    start = start - (end - baseRange.max);
                    end = baseRange.max;
                }
                var delta = Math.abs(end - start);
                var interval = axis.enableAutoIntervalOnZooming ? (this.calculateLogNiceInterval(delta, axis)) : axis.visibleRange.interval;
                var factor = (ej.util.isNullOrUndefined(axis.roundingPlaces)) ?
                    (ej.EjSvgRender.utils._decimalPlaces(axis.visibleRange.interval) == 0 ? 1
                    : ej.EjSvgRender.utils._decimalPlaces(axis.visibleRange.interval)) : axis.roundingPlaces;
                interval = parseFloat(axis.visibleRange.interval.toFixed(factor));
                if (isScroll)
                    return { min: Math.min(start, end), max: Math.max(start, end), interval: interval };
                else{
                    axis.visibleRange.interval = interval;
                    axis.visibleRange.min = Math.min(start, end);
                    axis.visibleRange.max = Math.max(start, end);
                    axis.visibleRange.delta = delta;
                    axis.zoomed = (this.chartObj.zoomed === null || this.chartObj.zoomed === undefined) ? true : this.chartObj.zoomed;
                }
            }

        },
   
        //Method implementation for Generate Labels in ChartAxis
        _calculateAxisLabels: function (chartObj, currentAxis) {

            var tempInterval, round = currentAxis.roundingPlaces;
            if (chartObj.zoomed || currentAxis.zoomed)
                tempInterval = currentAxis.visibleRange.min - (currentAxis.visibleRange.min % currentAxis.visibleRange.interval);
            else
                tempInterval = currentAxis.visibleRange.min;
            for (; tempInterval <= currentAxis.visibleRange.max; tempInterval += currentAxis.visibleRange.interval) {
                

                if (ej.EjSvgRender.utils._inside(tempInterval, currentAxis.visibleRange)) {      
                    var customFormat = (!(currentAxis.labelFormat)) ? null : currentAxis.labelFormat.match('{value}');
                    var tempIntervaltext = Math.pow(currentAxis.logBase, tempInterval);
                    tempPlace = (tempIntervaltext.toString().split(0).length - 1 > 10) ? 10 : 20;
                    tempIntervaltext = parseFloat(tempIntervaltext.toFixed((!round && round > tempPlace) ? round : tempPlace));
                     
                    var labelText = (!(currentAxis.labelFormat)) ? tempIntervaltext : (customFormat != null) ?
                             currentAxis.labelFormat.replace('{value}', tempIntervaltext) :
                              (ej.format(tempIntervaltext, currentAxis.labelFormat, chartObj.model.locale));
					 // customize label by event
                    var commonAxesEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                    commonAxesEventArgs.data = { label: { Text: labelText, Value: tempInterval }, axis: currentAxis };
                    chartObj._trigger("axesLabelRendering", commonAxesEventArgs);
                    currentAxis.visibleLabels.push({ Value:tempInterval, Text: commonAxesEventArgs.data.label.Text });
                }
            }

            currentAxis._LableMaxWidth = ej.EjSvgRender.utils._getMaxLabelWidth(currentAxis, this.chartObj);

        },


        //Category axis calculation
        _calculateRanges: function (chartObj, axis, seriesCollection, params) {
            this.chartObj = chartObj;
            this._calculateLogRange(chartObj,axis, seriesCollection, params);
            if (chartObj.model._drawTrendline)
                this._calculateTrendLineRange(chartObj, axis, seriesCollection);
            this._calculateLogPadding(chartObj, axis, axis.actual_Range);
            this._calculateAxisLabels(chartObj,axis);
        }

        
    });
    ej.axisTypes.logarithmic = ejLogValue;
    
//Category Axes calculation
    var ejCategoryValue = ejExtendClass(ej.EjAxisRenderer, {
        //axis range calculation and assign indexed value to x value of points
        _calculateCategoryRange: function (axis, seriesCollection) {
            var legendCollapsed = (this.chartObj.model.legendCollapsed == undefined) ? !this.chartObj.zoomed : this.chartObj.model.legendCollapsed;
            if (!this.chartObj.model.excludeDataUpdate || legendCollapsed) {
            var maxXValue = { maxX: null, minX: 0 },
                labels = [],
                pointX,
                intervalX,
                deltaX,
                index,
                isIndex = axis.isIndexed,
                locale = this.chartObj.model.locale;
            if (seriesCollection.length > 0 && this.chartObj.model._hasSeriesPoints && seriesCollection[0].points.length > 0  || this.chartObj.model.indicators[0]._points.length>0) {
                for (var m = 0; m < seriesCollection.length; m++) {
                    pointsLength = seriesCollection[m].points.length;
                    for (var n = 0; n < pointsLength; n++) {
                        if (seriesCollection[m]._xAxisValueType == "date")
                            pointX = ej.format(new Date(seriesCollection[m].points[n].x), (ej.util.isNullOrUndefined(axis.labelFormat) ? "dd/MM/yyyy" : axis.labelFormat), locale);
                        else
                            pointX = seriesCollection[m].points[n].x;
                        if (!isIndex) {
                            index = $.inArray(pointX, labels);
                            if (index < 0)
                                labels.push(pointX);
                        }
                        else {
                            if (m == 0)
                                labels[n] = pointX;
                            else
                                labels[n] = labels[n] + ", " + pointX;
                        }

                    }
                    if (!axis.maxPointLength || axis.maxPointLength < pointsLength)
                        axis.maxPointLength = pointsLength;
                }
                for (var l = 0; l < seriesCollection.length; l++) {
                    seriesCollection[l]._pointCollection = [];
                    for (var k = 0; k < seriesCollection[l].points.length; k++) {
                        seriesCollection[l]._pointCollection.push(seriesCollection[l].points[k].x);
                        if (seriesCollection[l]._xAxisValueType == "date")
                            pointX = ej.format(new Date(seriesCollection[l].points[k].x), (ej.util.isNullOrUndefined(axis.labelFormat) ? "dd/MM/yyyy" : axis.labelFormat), locale);
                        else
                            pointX = seriesCollection[l].points[k].x;
                        if (!isIndex)
                        seriesCollection[l].points[k].xValue = $.inArray(pointX, labels);
                        else
                            seriesCollection[l].points[k].xValue = k;
                       
                    }
                    seriesCollection[l].minX = 0;
                    seriesCollection[l].maxX = (seriesCollection[l]._xAxisValueType == "date") ? seriesCollection[l]._pointCollection.length - 1 : labels.length - 1;
                    // To find maximum x value of axis from series collection
                    if (l == 0) {
                        maxXValue.maxX = seriesCollection[l].maxX;
                        axis.labels = (seriesCollection[l]._xAxisValueType == "date") ? seriesCollection[l]._pointCollection : labels;
                        axis._categoryValueType = seriesCollection[l]._xAxisValueType;
                    }
                    if (maxXValue.maxX < (seriesCollection[l].maxX)) {
                        maxXValue.maxX = seriesCollection[l].maxX;
                        axis.labels = [];
                        axis.labels = labels;
                    }
                }
                if (this.chartObj.model.indicatorRange && this.chartObj.model.indicatorRange[axis.name]) {
                          var value = this.chartObj.model.indicatorRange[axis.name];
                          if (maxXValue.minX > value.min || maxXValue.minX == null)
                              maxXValue.minX = value.min;
                          if (maxXValue.maxX < value.max || maxXValue.maxX == null)
                              maxXValue.maxX = value.max;
                }
                
                deltaX = maxXValue.maxX - maxXValue.minX;
                
                if (axis.setRange && axis.range.interval) {
                    intervalX = Math.ceil(axis.range.interval);
                }
                else {
                    intervalX = this._calculateActualInterval(deltaX, axis);
                }

                axis.range = { min: maxXValue.minX, max: maxXValue.maxX, interval: intervalX, Delta: deltaX };
            }
            else {
                var labelLength = axis.labels.length;
                if (labelLength > 0) {
                    deltaX = labelLength - 1;
                    intervalX = this._calculateActualInterval(deltaX, axis); 
                    axis.range = { min: 0, max: labelLength - 1, interval: intervalX, Delta: deltaX };
                }
                else if (!axis.range) // set default range when no series points added to category axes
                    axis.range = { min: 0, max: 6, interval: 1, Delta: 6 };
            }       
            }

        },

    //Calculates actual interval
    _calculateActualInterval: function (delta, axis) {
        if (axis.categoryInterval == null)
            return Math.max(1, Math.floor(delta / this.GetActualDesiredIntervalsCount(axis, axis.length)));
        else
            return axis.categoryInterval;
    },

    //Apply padding based on labelPlacement
    _applyRangePadding: function (axis) {
        if (!this.chartObj.zoomed && !this.chartObj._scrollBarEnabled) {
            // ticks based on labelplacement and polaraxes
            var ticks = 0;
            if(this.chartObj.model.AreaType !== 'polaraxes')
            ticks = ((axis.labelPlacement === null || axis.labelPlacement === undefined || axis.labelPlacement === "")) ? -0.5 : (axis.labelPlacement.toLowerCase() == "betweenticks") ? (-0.5) : 0;
			 if (ticks < 0) {
                axis.range.min = axis.range.min + ticks;
                axis.range.max = axis.range.max - ticks;
                axis.range.delta = axis.range.max - axis.range.min;
                axis.actualRange = axis.range;
            } else {
                var data = _sideBySeriesPadding(this.chartObj, axis.range.min, axis.range.max, axis);
                axis.range.min = data.startPadding;
                axis.range.max = data.endPadding;
                axis.range.delta = axis.range.max - axis.range.min;
                axis.actualRange = axis.range;
			}
        }
        this._calculateVisibleRange(axis);
    },

    //Calculates the visible range  
    _calculateVisibleRange: function (axis, sender, isScroll) {
        this.chartObj = sender ? sender : this.chartObj;
        axis.visibleRange = (!isScroll) ? $.extend(true, {}, axis.actualRange) : axis.visibleRange;
        if ((axis.zoomFactor < 1 || axis.zoomPosition > 0) && this.chartObj.model.AreaType != "polaraxes" && !this.chartObj.model.disableZoom) {
		     axis.zoomFactor = axis.zoomFactor > 1 ? 1 : (axis.zoomFactor < 0 ? 0 : axis.zoomFactor);
            axis.zoomPosition = axis.zoomPosition < 0 ? 0 : (axis.zoomPosition > 1 ? 1 : axis.zoomPosition);
            var baseRange = axis.actualRange;
            if (axis.isInversed) {
                var start = axis.actualRange.max - axis.zoomPosition * axis.actualRange.delta;
                var end = start - axis.zoomFactor * axis.actualRange.delta;
            }
            else {
                var start = axis.actualRange.min + (axis.zoomPosition * axis.actualRange.delta);
                var end = start + axis.zoomFactor * axis.actualRange.delta;
            }

            if (start < baseRange.min) {
                end = end + (baseRange.min - start);
                start = baseRange.min;
            }

            if (end > baseRange.max) {
                start = start - (end - baseRange.max);
                end = baseRange.max;
            }
            var delta = Math.abs(end - start);
            var interval = this._calculateActualInterval(delta, axis);
            var min = Math.min(start, end);
            var max = Math.max(start, end);
            if (isScroll) {
                return {min:min, max:max, interval:interval};
            }
            else {
                var delta = Math.abs(end - start);
                axis.visibleRange.interval = interval;
                axis.visibleRange.min = min;
                axis.visibleRange.max = max;
                axis.visibleRange.delta = delta;
                axis.zoomed = (this.chartObj.zoomed === null || this.chartObj.zoomed === undefined) ? true : this.chartObj.zoomed;
            }
        }

    },

    //Generate category label for axis
    _calculateAxisLabels: function (axis) {
        var interval = axis.visibleRange.interval;
        var position = axis.visibleRange.min - (axis.visibleRange.min % axis.range.interval);
        for (; position <= axis.visibleRange.max; position += interval) {
            if (ej.EjSvgRender.utils._inside(position, axis.visibleRange)) {
                var pos = Math.round(position);
                axis.visibleLabels.push({ Value: pos, Text: ej.EjSvgRender.utils._getLabelContent(pos, axis, this.chartObj.model.locale) });

                // customize label by event
                var commonAxesEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonAxesEventArgs.data = { label: axis.visibleLabels[axis.visibleLabels.length - 1], axis: axis };
                this.chartObj._trigger("axesLabelRendering", commonAxesEventArgs);
                axis.visibleLabels[axis.visibleLabels.length - 1] = commonAxesEventArgs.data.label;
            }
        }
        axis._LableMaxWidth = ej.EjSvgRender.utils._getMaxLabelWidth(axis, this.chartObj);
    },

    //Category axis calculation
    _calculateRanges: function (chartObj, axis, seriesCollection) {
        this.chartObj = chartObj;

        this._calculateCategoryRange(axis, seriesCollection);
        if (chartObj.model._drawTrendline)
            this._calculateTrendLineRange(chartObj, axis, seriesCollection);
        this._applyRangePadding(axis);

        this._calculateAxisLabels(axis);
    }
});
ej.axisTypes.category = ejCategoryValue;

    // for Datetime category axis calculation

    var ejDateTimeCategory = ejExtendClass(ej.EjAxisRenderer, {
        _calculateDateTimeCategoryRange: function (axis, seriesCollection) {
            ///Variables declaration part here ///
            var xRange = { minX: 0, MaxX: null },xLabels = [],xValue=[], xPoint,index,index1, deltaX,intervalX,
                         prevDateVal, points,xVerfiedPoints=[],
                         xDateVal, xVal, previous, current, pointsLength, point, m, pt, ser;
            for (ser = 0; ser < seriesCollection.length; ser++) {
                seriesCollection[ser]._pointCollection = [], points = [],seriesCollection[ser]._points=[], seriesCollection[ser]._xPoints = [], seriesCollection[ser]._yPoints=[],
                pointsLength = seriesCollection[ser].points.length;
                for (pt = 0; pt < pointsLength; pt++) {
                    points.push(new Date(seriesCollection[ser].points[pt].x).getTime());
                    seriesCollection[ser]._xPoints.push(new Date(seriesCollection[ser].points[pt].x).getTime());
                    seriesCollection[ser]._yPoints.push(seriesCollection[ser].points[pt].y);
                }
                points.sort(function (a, b) { return a - b; }); // date time values sorted
                if(ej.isNullOrUndefined(axis.intervalType)){
                    intervalX = this.calculateDateTimeNiceInterval(axis, new Date(Math.min.apply(null, points)), new Date(Math.max.apply(null, points)))
                    axis.intervalType = intervalX.intervalType.toLowerCase();
                }
                for (point = 0; point < points.length; point++) {
                    xPoint = new Date(points[point]);
                    seriesCollection[ser]._points.push(xPoint.getTime());
                    var ySortPos = $.inArray(points[point], seriesCollection[ser]._xPoints);
                    seriesCollection[ser].points[point].YValues[0] = seriesCollection[ser]._yPoints[ySortPos];
                    seriesCollection[ser]._pointCollection.push(new Date(seriesCollection[ser].points[point].x));
                    if (ser == 0)
                        seriesCollection[ser].points[point].xValue = point;
                    else {
                        for (var i = 0; i <= ser - 1; i++) {
                            index1 = $.inArray(new Date(seriesCollection[ser].points[point].x).getTime(), seriesCollection[i]._points);
                            if (index1 >= 0) {
                                seriesCollection[ser].points[point].xValue = index1;
                            }
                            else if(i = ser) {
                                seriesCollection[ser].points[point].xValue = (axis.maxPointLength - 1) + (point + 1);
                                break;
                            }
                        }                           
                    }
                    index = (ser == 0)? -1 : $.inArray(xPoint.getTime(), xVerfiedPoints);
                    if (index < 0) {
                        switch (axis.intervalType) {
                            case "auto": // for auto calculate
                                xLabels.push(xPoint.getTime());
                                break;
                            case "years":  // for years calculate
                                xVal = xPoint.getFullYear();                              
                                break;
                            case "months":  // for months calculate
                                current = xPoint.getFullYear();
                                xDateVal = xPoint.getMonth();
                                if (point <= 0) xVal = point + 1;
                                else {
                                    previous = new Date(points[point - 1]).getFullYear();
                                    xVal += (current != previous) ? ((12 - prevDateVal) + (xDateVal)) : (xDateVal - prevDateVal);
                                }
                                prevDateVal = xDateVal;
                                break;
                            case "days":  // for days calculate
                                current = xPoint.getMonth();
                                xDateVal = xPoint.getDate();
                                if (point <= 0) xVal = point + 1;
                                else {
                                    previous = new Date(points[point - 1]).getMonth();
                                    xVal += (current != previous) ? (((new Date(xPoint.getFullYear(), previous, 0).getDate() - prevDateVal) + (xDateVal))) : (xDateVal - prevDateVal);
                                    if(current == previous)
                                    {
                                        var diff = this._diffDate(xPoint, new Date(points[point - 1]),1);
                                        var days = (new Date(xPoint.getFullYear(), previous, 0).getDate());
                                        xVal = (diff > days) ? (xValue[xValue.length - 1]) + 1 : xVal;
                                    }
                                }
                                prevDateVal = xDateVal;
                                break;
                            case "hours":  // for hours calculate
                                current = xPoint.getDate();
                                xDateVal = xPoint.getHours();
                                if (point <= 0) xVal = point + 1;
                                else {
                                    previous = new Date(points[point - 1]).getDate();
                                    xVal += (current != previous) ? ((24 - prevDateVal) + (xDateVal)) : (xDateVal - prevDateVal);
                                    if (current == previous) {
                                        var diff = this._diffDate(xPoint, new Date(points[point - 1]),24);
                                        xVal = (diff> 24) ? (xValue[xValue.length - 1]) + 1 : xVal;
                                    }
                                }
                                prevDateVal = xDateVal;
                                break;
                            case "minutes": // for minutes calculate
                                current = xPoint.getHours();
                                xDateVal = xPoint.getMinutes();
                                if (point <= 0) xVal = point + 1;
                                else {
                                    previous = new Date(points[point - 1]).getHours();
                                    xVal += (current != previous) ? ((60 - prevDateVal) + (xDateVal)) : (xDateVal - prevDateVal);
                                    if (current == previous) {
                                        var diff = this._diffDate(xPoint, new Date(points[point - 1]),(24 * 60));
                                        xVal = (diff > 60) ? (xValue[xValue.length - 1]) + 1 : xVal;
                                    }
                                }
                                prevDateVal = xDateVal;
                                break;
                            case "seconds": // for seconds calculate
                                current = xPoint.getMinutes();
                                xDateVal = xPoint.getSeconds();
                                if (point <= 0) xVal = point + 1;
                                else {
                                    previous = new Date(points[point - 1]).getMinutes();
                                    xVal += (current != previous) ? ((60 - prevDateVal) + (xDateVal)) : (xDateVal - prevDateVal);
                                    if (current == previous) {
                                        var diff = this._diffDate(xPoint, new Date(points[point - 1]),( 24 * 60 * 60));
                                        xVal = (diff > 60) ? (xValue[xValue.length - 1]) + 1 : xVal;
                                    }
                                }
                                prevDateVal = xDateVal;
                                break;
                            case "milliseconds": // for milliseconds calculate
                                current = xPoint.getSeconds();
                                xDateVal = xPoint.getMilliseconds();
                                if (point <= 0) xVal = point + 1;
                                else {
                                    previous = new Date(points[point - 1]).getSeconds();
                                    xVal += (current != previous) ? ((1000 - prevDateVal) + (xDateVal)) : (xDateVal - prevDateVal);
                                    if (current == previous) {
                                        var diff = this._diffDate(xPoint, new Date(points[point - 1]), (24 * 60 * 60 * 1000));
                                        xVal = (diff > 1000) ? (xValue[xValue.length - 1]) + 1 : xVal;
                                    }
                                }
                                prevDateVal = xDateVal;
                                break;
                        }
                        if (axis.intervalType != "auto")
                            xLabels.push(xPoint.getTime());  
                        xValue.push(xVal);
                        xVerfiedPoints.push(new Date(points[point]).getTime());                      
                    }
               }           
                   if (!axis.maxPointLength || axis.maxPointLength < pointsLength) axis.maxPointLength = pointsLength;
            }
            for (m = 0; m < seriesCollection.length; m++) { // set the min and max range for axis
                if (!axis.setRange) axis.range = { min: null, max: null, interval: null };
				if(!ej.isNullOrUndefined(axis.m_minPointsDelta)) axis.m_minPointsDelta = undefined;
                seriesCollection[m].minX = (ej.isNullOrUndefined(axis.range.min)) ? 0 : (axis.range.min < xRange.minX) ? 0 : axis.range.min;
                seriesCollection[m].maxX = (ej.isNullOrUndefined(axis.range.max)) ? xLabels.length - 1 : (axis.range.max > xLabels.length - 1) ? xLabels.length-1 : axis.range.max;
                    if (m == 0) {
                        xRange.MaxX = seriesCollection[m].maxX;
                        xRange.minX = seriesCollection[m].minX;
                        axis.labels = xLabels;
                        axis.dateLabels = xValue;
                        axis._categoryValueType = "date";
                    }
                }
            if (xRange.minX == xRange.MaxX && axis.labelPlacement.toLowerCase() == "onticks") xRange.MaxX += 1;
                deltaX = xRange.MaxX - xRange.minX;
                intervalX = ((axis.range.interval == null || axis.range.interval == undefined)) ? 1 : (axis.range.interval < 1) ? 1 : Math.ceil(axis.range.interval);               
                axis.range = { min: xRange.minX, max: xRange.MaxX, interval: intervalX, Delta: deltaX };
        },

        _diffDate:function(currentPoint,previousPoint,mul)
        {
            var oneDay, diff;
             oneDay = 24 * 60 * 60 * 1000;
            diff = (Math.abs((currentPoint.getTime() - previousPoint.getTime()))/ (oneDay));
            return (Math.round(diff*mul));
        },

        _calculateAxisLabels:function(axis) // calculate visible labels for axis
        {
            var interval = axis.visibleRange.interval, currentLabels = [], count = 0,
                           prevLabelVal, pos,arr, currentLabel, expectLabel, index, i, isCurrentLabel, isNextLabel, commonAxesEventArgs;
            var position = axis.visibleRange.min - (axis.visibleRange.min % axis.range.interval);
            for (; position <= axis.visibleRange.max; position += interval) {
                if (ej.EjSvgRender.utils._inside(position, axis.visibleRange)) {
                     pos = Math.round(position);
                     arr = axis.dateLabels;
                     if (axis.intervalType != "auto") {
                         if (count > 0 && interval > 1) {
                             if (pos > arr.length - 1)
                                 pos = arr.length - 1;
                             currentLabel = arr[count];
                             expectLabel = prevLabelVal + interval;
                             isCurrentLabel = $.inArray(currentLabel, arr);
                             isNextLabel = $.inArray(expectLabel, arr);
                             if (isCurrentLabel > 0 && (Math.abs(currentLabel - prevLabelVal) == interval) && currentLabel > prevLabelVal) {
                                 pos = isCurrentLabel;
                                 prevLabelVal = arr[pos];
                             }
                             else {
                                 for (i = 0; i < i + 1; i++) {
                                     expectLabel += (i == 0) ? i : 1;
                                     isNextLabel = $.inArray(expectLabel, arr);
                                     if (isNextLabel > 0) {
                                         pos = isNextLabel;
                                         prevLabelVal = arr[pos];
                                         break;
                                     }
                                 }
                             }
                         }
                     }
                    count++;
                    if(!ej.util.isNullOrUndefined(arr)){
                        if (((arr[arr.length - 1] - arr[pos]) >= interval) && (axis.visibleRange.max < (position + interval))) axis.visibleRange.max += ((position + interval) - axis.visibleRange.max);
                        index = $.inArray(arr[pos], currentLabels);
                     }
                    if((index < 0 || axis.intervalType == "auto") && (pos < axis.labels.length)) {
                        if (axis.intervalType != "auto") {
                            prevLabelVal = arr[pos];
                            currentLabels.push(prevLabelVal);
                        }                    
                        axis.visibleLabels.push({ Value: pos, Text: ej.EjSvgRender.utils._getLabelContent(pos, axis, this.chartObj.model.locale) });
                        commonAxesEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                        commonAxesEventArgs.data = { label: axis.visibleLabels[axis.visibleLabels.length - 1], axis: axis };
                        this.chartObj._trigger("axesLabelRendering", commonAxesEventArgs);
                        axis.visibleLabels[axis.visibleLabels.length - 1] = commonAxesEventArgs.data.label;                    
                    }
                }
            }
            axis._LableMaxWidth = ej.EjSvgRender.utils._getMaxLabelWidth(axis, this.chartObj);
        },

        //Calculates actual interval
        _calculateActualInterval: function (delta, axis) {
            if (axis.categoryInterval == null)
                return Math.max(1, Math.floor(delta / this.GetActualDesiredIntervalsCount(axis, axis.length)));
            else
                return axis.categoryInterval;
        },

        //Apply padding based on labelPlacement
        _applyRangePadding: function (axis) {
            if (!this.chartObj.zoomed && !this.chartObj._scrollBarEnabled) {
                // ticks based on labelplacement and polaraxes
                var ticks = 0;
                if (this.chartObj.model.AreaType !== 'polaraxes')
                    ticks = ((axis.labelPlacement === null || axis.labelPlacement === undefined)) ? -0.5 : (axis.labelPlacement.toLowerCase() == "betweenticks") ? (-0.5) : 0;
                if (ticks < 0) {
                    axis.range.min = axis.range.min + ticks;
                    axis.range.max = axis.range.max - ticks;
                    axis.range.delta = axis.range.max - axis.range.min;
                    axis.actualRange = axis.range;
                } else {
                    var data = _sideBySeriesPadding(this.chartObj, axis.range.min, axis.range.max, axis);
                    axis.range.min = data.startPadding;
                    axis.range.max = data.endPadding;
                    axis.range.delta = axis.range.max - axis.range.min;
                    axis.actualRange = axis.range;
                }
            }
            this._calculateVisibleRange(axis);
        },

        //Calculates the visible range  
        _calculateVisibleRange: function (axis, sender, isScroll) {
            this.chartObj = sender ? sender : this.chartObj;
            axis.visibleRange = (!isScroll) ? $.extend(true, {}, axis.actualRange) : axis.visibleRange;
            if ((axis.zoomFactor < 1 || axis.zoomPosition > 0) && this.chartObj.model.AreaType != "polaraxes" && !this.chartObj.model.disableZoom) {
                axis.zoomFactor = axis.zoomFactor > 1 ? 1 : (axis.zoomFactor < 0 ? 0 : axis.zoomFactor);
                axis.zoomPosition = axis.zoomPosition < 0 ? 0 : (axis.zoomPosition > 1 ? 1 : axis.zoomPosition);
                var baseRange = axis.actualRange;
                if (axis.isInversed) {
                    var start = axis.actualRange.max - axis.zoomPosition * axis.actualRange.delta;
                    var end = start - axis.zoomFactor * axis.actualRange.delta;
                }
                else {
                    var start = axis.actualRange.min + (axis.zoomPosition * axis.actualRange.delta);
                    var end = start + axis.zoomFactor * axis.actualRange.delta;
                }

                if (start < baseRange.min) {
                    end = end + (baseRange.min - start);
                    start = baseRange.min;
                }

                if (end > baseRange.max) {
                    start = start - (end - baseRange.max);
                    end = baseRange.max;
                }
                var delta = Math.abs(end - start);
                var interval = this._calculateActualInterval(delta, axis);
                var min = Math.min(start, end);
                var max = Math.max(start, end);
                if (isScroll) {
                    return { min: min, max: max, interval: interval };
                }
                else {
                    var delta = Math.abs(end - start);
                    axis.visibleRange.interval = interval;
                    axis.visibleRange.min = min;
                    axis.visibleRange.max = max;
                    axis.visibleRange.delta = delta;
                    axis.zoomed = (this.chartObj.zoomed === null || this.chartObj.zoomed === undefined) ? true : this.chartObj.zoomed;
                }
            }

        },

        _calculateRanges: function (chartObj, axis, seriesCollection) {
            this.chartObj = chartObj;
            this._calculateDateTimeCategoryRange(axis, seriesCollection);   
            this._applyRangePadding(axis);
            this._calculateAxisLabels(axis);          
        }
    });

    ej.axisTypes.datetimecategory = ejDateTimeCategory;

ej.EjAxisRenderer.prototype = {
    _drawGridLines: function (axisIndex, axis, params) {
        if (this.model.AreaType == "cartesianaxes") {
            if (axis.orientation.toLowerCase() == "horizontal")
                this._drawXAxisGridLine(axisIndex, axis, params);

            else
                this._drawYAxisGridLine(axisIndex, axis, params);
        }
        else {
            if (axis.orientation.toLowerCase() == "horizontal" && axisIndex == 0) {
                this._drawPolarGridLine(axis);
                this._drawPolarLabels(axis);

            }
            else if (axisIndex == 1)
                this._drawPolarCircle(axis);
        }
    },
    _drawAxes: function (axisIndex, axis) {

        if (this.model.AreaType == "cartesianaxes") {
            if (axis.visible && axis.orientation.toLowerCase() == "horizontal") {
                this._drawXAxisLabels(axisIndex, axis);
                this._drawXTitle(axisIndex, axis);
            }

            if (axis.visible && axis.orientation.toLowerCase() == "vertical") {
                this._drawYAxisLabels(axisIndex, axis);
                this._drawYTitle(axisIndex, axis);
            }
        }
    },
    _getSharpPath:function (width) {
        var value = ((width % 2) == 0) ? 0 : 0.5;
        return value;
    },
    _drawAxisLine: function (axis) {

        // Yaxis MajorGridlines, Ticklines and Labels.
        var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisLine' });
        var sbYMajorTick = ej.EjSvgRender.utils._getStringBuilder();
        var x1 = this.model.centerX;
        var y1 = this.model.centerY;
        var x2 = this.model.centerX;
        var y2 = this.model.centerY - this.model.Radius;
        var axisLine = "M" + " " + x1 + " " + y1 + " " + "L" + " " + x2 + " " + y2;
        if (axis.visible && axis.axisLine.visible) {
            var options = {
                'id': this.svgObject.id + '_YAxisLines',
                'fill': 'none',
                'stroke-width': axis.axisLine.width,
                'stroke': axis.axisLine.color,
                'opacity': axis.axisLine.opacity,
                'stroke-dasharray': axis.axisLine.dashArray,
                'd': axisLine
            };
            this.svgRenderer.drawPath(options, gEle);

            //Drawing Major Grid Lines 
            $(gEle).appendTo(this.gPolarAxisEle);
        }
       

        if (axis.visible && axis.majorTickLines.visible) {
            gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisMajorTicks' });
                for (var j = 0; j < axis.visibleLabels.length; j++) {
                    var label = axis.visibleLabels[j];
                    var radius = this.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(axis, label.Value, this);
                    var line = {};
                    line.X1 = this.model.centerX;
                    line.Y1 = this.model.centerY - radius;
                    line.X2 = line.X1 - axis.majorTickLines.size;
                    line.Y2 = line.Y1;
                    sbYMajorTick.append("M" + " " + line.X1 + " " + line.Y1 + " " + "L" + " " + line.X2 + " " + line.Y2 + " ");
                }
               
                  yMajorTickDir = sbYMajorTick.toString();
                    var options = {
                        'id': this.svgObject.id + '_YAxisMajorTicks',
                        'fill': 'none',
                        'stroke-width': axis.majorTickLines.width,
                        'stroke': axis.majorTickLines.color,
                        'd': yMajorTickDir
                    };
            //Drawing Major Tickline Lines
                    this.svgRenderer.drawPath(options, gEle);
                    $(gEle).appendTo(this.gPolarAxisEle);
                
        }
        if (axis.visible) {
            var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisLabels' }),
                font = axis.font,
                bounds,
                regionX,
                labelsLength = axis.visibleLabels.length;
            for (var j = 0; j < labelsLength; j++) {
                var radius = this.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(axis, axis.visibleLabels[j].Value, this);
                var labelText = axis.visibleLabels[j].Text;

                var size = ej.EjSvgRender.utils._measureText(labelText, null, axis.font);

                var X = this.model.centerX - axis.majorTickLines.size - (this.model.elementSpacing / 3);
                var Y = this.model.centerY - radius + (size.height / 5);


                var options = {
                    'id': this.svgObject.id + '_' + axis.name + '_YLabel_' + j,
                    'x': X,
                    'y': Y,
                    'fill': font.color,
                    'font-size': font.size,
                    'font-family': font.fontFamily,
                    'font-style': font.fontStyle,
                    'font-weight': font.fontWeight,
                    'opacity': font.opacity,
                    'text-anchor': 'end'
                };

                this.svgRenderer.drawText(options, labelText, gEle);
                regionX = options.x - size.width;
                bounds = { x: regionX, y: options.y, width: size.width, height: size.height };
                axis.visibleLabels[j].region = { bounds: bounds, labelText: labelText };
            }
            //Drawing YAxis Labels
            $(gEle).appendTo(this.gPolarAxisEle);
        }
       

    },
    _drawPolarLabels: function (axis) {
	     if (!axis.visible)
			return 0;
        var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisLabels'  }),
            aroundRadius = this.model.Radius + axis.majorTickLines.size,
            font = axis.font,
            length = axis.visibleLabels.length,
            firstLabelX,
            bounds,
            regionX,
            lastLabelX;
        for (var j = 0; j < length; j++) {
            var coef = ej.EjSvgRender.utils._valueToPolarCoefficient(axis, axis.visibleLabels[j].Value);

            var vector = ej.EjSvgRender.utils._valueToVector(axis, axis.visibleLabels[j].Value);
		 if (!isNaN(vector.X) && !isNaN(vector.Y)) {
            var labelText = axis.visibleLabels[j].Text;
            var x = this.model.centerX + aroundRadius * vector.X;
            var y = this.model.centerY + aroundRadius * vector.Y;
            var textAnchor = (x < this.model.centerX) ? 'end' : ((x > this.model.centerX) ? 'start' : 'middle');

            var size= ej.EjSvgRender.utils._measureText(labelText, this.model.m_AreaBounds.Height, axis.font);
            // calculation for positioning the label along the arc
            if (coef == 0.25)
            {
                x -= this.model.elementSpacing / 2;
                y += (size.height) / 4;
            }
           else if (coef == 0.5)
            {
               y += (size.height) ;
            }
           else if (coef == 0.75)
           {
               x += this.model.elementSpacing / 2;
               y += (size.height) / 4;
           }
           else if (coef == 1 || coef==0) {
               y -= (size.height) / 2;
           }
               
           else if (0.25 < coef && coef < 0.5) {
               x -= this.model.elementSpacing / 2;
               y += (size.height) / 2;
           }
           else if (0.5 < coef && coef <= 0.75) {
               x += this.model.elementSpacing / 2;
               y += (size.height) / 2;
           }
           else if (0 < coef && coef < 0.25)
             {
                   x -= this.model.elementSpacing / 2;
           }
           else
               x += this.model.elementSpacing / 2;

            if (j == 0) {
                firstLabelX = x;
            }
            if (j == length - 1 && axis._valueType !="category" ) {
                lastLabelX = ej.EjSvgRender.utils._measureText(labelText, null, font).width;
                lastLabelX += x;
                if (lastLabelX > firstLabelX)
                    labelText = ""; //Hide the last overlapping labels
            }
            var options = {
                'id': this.svgObject.id + '_' + axis.name + '_XLabel_' + j,
                'x': x,
                'y': y,
                'fill': font.color,
                'font-size': font.size,
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'font-weight': font.fontWeight,
                'opacity': font.opacity,
                'text-anchor': textAnchor
            };

            this.svgRenderer.drawText(options, labelText, gEle);
			 if (textAnchor == "middle") 
               regionX = options.x - size.width / 2;
           
            else if (textAnchor == "end") 
               regionX = options.x - size.width;
            else
                regionX = options.x;
				
            bounds = { x: regionX, y: options.y, width: size.width, height: size.height };
            axis.visibleLabels[j].region = { bounds: bounds, labelText: labelText };
          }
        }
		
        $(gEle).appendTo(this.gXaxisEle);

    },
    _drawPolarCircle: function (axis) {
        if (axis.majorGridLines.visible) {
            var sbYMajorGrid = ej.EjSvgRender.utils._getStringBuilder();
            var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisGrid' });
            if (this.model.isPolar) {
                for (var j = 0; j < axis.visibleLabels.length; j++) {
                    var label = axis.visibleLabels[j];
                    var radius = this.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(axis, label.Value, this);

                    var options = {
                        'id': this.svgObject.id + '_YAxisGridLines_' + j,
                        'cx': this.model.centerX,
                        'cy': this.model.centerY,
                        'r': radius,
                        'fill': 'transparent',
                        'stroke-width': axis.majorGridLines.width,
                        'stroke': axis.majorGridLines.color,
                         'opacity': (this.vmlRendering) ? 0.3: axis.majorGridLines.opacity
                    };

                    //Drawing Major Grid Lines for polar
                    this.svgRenderer.drawCircle(options, gEle);
                   
                }
            }
            else {
                for (var j = 0; j < axis.visibleLabels.length; j++) {
                    
                        var label = axis.visibleLabels[j];
                        var radius = this.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(axis, label.Value, this);
                        // calculation for spider web
                        for (var i = 0; i < this.model._axes[0].visibleLabels.length; i++) {
                            var xAxis = this.model._axes[0];
                            var vector = ej.EjSvgRender.utils._valueToVector(xAxis, xAxis.visibleLabels[i].Value);
						    if (!isNaN(vector.X) && !isNaN(vector.Y)){
                              var vector2;
                              if ((i + 1) < xAxis.visibleLabels.length) {
                                vector2 = ej.EjSvgRender.utils._valueToVector(xAxis, xAxis.visibleLabels[i + 1].Value);
                              }
                              else {
                                vector2 = ej.EjSvgRender.utils._valueToVector(xAxis, xAxis.visibleLabels[0].Value);
                              }
                              var connectPoint = { X: this.model.centerX + radius * vector.X, Y: this.model.centerY + radius * vector.Y };
                              var endPoint = { X: this.model.centerX + radius * vector2.X, Y: this.model.centerY + radius * vector2.Y };
                              sbYMajorGrid.append("M" + " " + connectPoint.X + " " + connectPoint.Y + " " + "L" + " " + endPoint.X + " " + endPoint.Y + " ");
						    }
                        }
                }
                if (axis.majorGridLines.visible) {
                    yMajorGridDir = sbYMajorGrid.toString();
                    var options = {
                        'id': this.svgObject.id + '_YAxisGridLines',
                        'fill': 'none',
                        'stroke-width': axis.majorGridLines.width,
                        'stroke': axis.majorGridLines.color,
                        'opacity': axis.majorGridLines.opacity,
                        'stroke-dasharray': axis.majorGridLines.dashArray,
                        'd': yMajorGridDir
                    };
                    //Drawing Major Grid Lines for radar
                    this.svgRenderer.drawPath(options, gEle);
                }
            }
        }
        $(gEle).appendTo(this.gYaxisEle);

    },
    _drawPolarGridLine: function (axis) {

        var chartModel = this.model,
            legend = chartModel.legend,
            legendTitleHeight = ej.EjSvgRender.utils._measureText(legend.title.text, null, legend.title.font).height,
            legendPosition = legend.position.toLowerCase(),
            legXSpace = 0,
            legYSpace = 0,
            sbXMajorGrid = ej.EjSvgRender.utils._getStringBuilder(),
            sbXMajorTick = ej.EjSvgRender.utils._getStringBuilder(),
            borderSize = legend.border.width,
            yOffset, actualWidth, actualHeight,
            isRadar = false, vector, line,
            length = axis.visibleLabels.length,
            chartBorder = chartModel.border.width,
            title=chartModel.title,
            subTitle=chartModel.title.subTitle,
            titleEnable=title.enableTrim && (title.textOverflow == 'wrap' || title.textOverflow == 'wrapandtrim')? true:false,
            subTitleEnable=subTitle.text != "" && subTitle.visible && subTitle.enableTrim && (subTitle.textOverflow == 'wrap' || subTitle.textOverflow == 'wrapandtrim')?true:false; 
        if (legend.visible && legendPosition != "custom") {
            if (legendPosition == "right" || legendPosition == "left")
                legXSpace = ((legendPosition == "right") ? chartModel.margin.right : chartModel.margin.left) + chartModel.LegendActualBounds.Width + (borderSize + chartBorder) * 2;
            else
                legYSpace = ((legendPosition == "top") ? chartModel.margin.top : chartModel.margin.bottom) + chartModel.LegendActualBounds.Height + legendTitleHeight + (borderSize + chartBorder) * 2;

        }
        // calculating the radius of the chart with avaible size
        yOffset = ((chartModel.title.text && chartModel.title.visible) ? chartModel._titleLocation.Y + (titleEnable ? chartModel._titleLocation.size.height : 0) + (subTitleEnable ? chartModel._subTitleLocation.size.height : 0) : 0) + legYSpace;

        actualWidth = chartModel.svgWidth - legXSpace;
        actualHeight = chartModel.svgHeight - yOffset;

        chartModel.centerX = actualWidth * 0.5 + ((legendPosition === "left") ? legXSpace : 0);
        chartModel.centerY = actualHeight * 0.5 + ((legendPosition === "top") ? yOffset : ((title.text && title.visible) ? (chartModel._titleLocation.Y + (titleEnable ? chartModel._titleLocation.size.height : 0) +
            (subTitleEnable ? chartModel._subTitleLocation.size.height : 0)) : 0));

        var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisGrid' });
        chartModel.finalSize = { width: actualWidth, height: actualHeight };

        chartModel.Radius = Math.min(chartModel.finalSize.width, chartModel.finalSize.height) / 2 - (2 * chartModel.elementSpacing) - axis.majorTickLines.size - axis._LableMaxWidth.maxHeight;
       
        var pos = 0;

        if (axis.majorGridLines.visible) {

            for (var j = 0; j < length; j++) {

                vector = ej.EjSvgRender.utils._valueToVector(axis, axis.visibleLabels[j].Value);
                line = {};
                line.X1 = chartModel.centerX;

                line.Y1 = chartModel.centerY;
                line.X2 = chartModel.centerX + chartModel.Radius * vector.X;
                line.Y2 = chartModel.centerY + chartModel.Radius * vector.Y;
                sbXMajorGrid.append("M" + " " + line.X1 + " " + line.Y1 + " " + "L" + " " + line.X2 + " " + line.Y2 + " ");
            }

        }
        if (axis.visible && axis.majorTickLines.visible) {
            var radius = chartModel.Radius;
            for (var j = 0; j < length; j++) {
                vector = ej.EjSvgRender.utils._valueToVector(axis, axis.visibleLabels[j].Value);
                line = {};
                line.X1 = chartModel.centerX + radius * vector.X;
                line.Y1 = chartModel.centerY + radius * vector.Y;
                line.X2 = line.X1 + axis.majorTickLines.size * vector.X;
                line.Y2 = line.Y1 + axis.majorTickLines.size * vector.Y;
                var direction = "M" + " " + line.X1 + " " + line.Y1 + " " + "L" + " " + line.X2 + " " + line.Y2 + " ";
                if (direction.indexOf("NaN") == -1)
                    sbXMajorTick.append(direction);
            }
        }
    

   
        if (axis.majorGridLines.visible) {
            xMajorGridDir = sbXMajorGrid.toString();
            var options = {
                'id': this.svgObject.id + '_XAxisGridLines',
                'fill': 'none',
                'stroke-width': axis.majorGridLines.width,
                'stroke': axis.majorGridLines.color,
                'opacity': axis.majorGridLines.opacity,
                'stroke-dasharray': axis.majorGridLines.dashArray,
                'd': xMajorGridDir
            };
            //Drawing XAxis Major Grid Lines
			if (xMajorGridDir.indexOf("NaN")== -1) {
              this.svgRenderer.drawPath(options, gEle);
              $(gEle).appendTo(this.gXaxisEle);
			}
        }

          if (axis.visible && axis.majorTickLines.visible) {
                xMajorTickDir = sbXMajorTick.toString();
                var options = {
                    'id': this.svgObject.id + '_XAxisMajorTicks',
                    'fill': 'none',
                    'stroke-width': axis.majorTickLines.width,
                    'stroke': axis.majorTickLines.color,
                    'd': xMajorTickDir
                };
                //Drawing XAxis Major Ticks Lines
                this.svgRenderer.drawPath(options, gEle);
                $(gEle).appendTo(this.gXaxisEle);
            }       
    },
    _drawXAxisTickLine:function(axisIndex,xAxis,gEle,params)
    {
        var xMajorTicksDir, xMinorTicksDir;
        var sbXMinorTicks = ej.EjSvgRender.utils._getStringBuilder();       
        var sbXMajorTicks = ej.EjSvgRender.utils._getStringBuilder();       
        var minorPointX;
        var x1 = Math.floor(xAxis.x);
        var x2 = Math.floor(xAxis.x + xAxis.width);
        var opposedPosition = xAxis._opposed;
        var labelValue, xPointValue = [];
        var isScroll = xAxis._isScroll && !(xAxis.scrollbarSettings.pointsLength != null && xAxis.scrollbarSettings.pointsLength < xAxis.maxPointLength);
        var labelBorder = xAxis.labelBorder;
        isCrossesAt= params.axes[xAxis.name]._validCross;
        if (axisIndex != 0 && !isCrossesAt && ((xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition == 'inside') || (xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition != 'inside')) && (!(xAxis.y == (this.model.m_AreaBounds.Height + this.model.m_AreaBounds.Y) || (xAxis.y == this.model.m_AreaBounds.Y))))
        {
            var y1 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis._LableMaxWidth.height) : Math.floor(xAxis.y - xAxis._LableMaxWidth.height);
            var y2 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis._LableMaxWidth.height) : Math.floor(xAxis.y - xAxis._LableMaxWidth.height);
        }
        else if (axisIndex != 0 && !isCrossesAt && (xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition == 'inside') && (!(xAxis.y == (this.model.m_AreaBounds.Height + this.model.m_AreaBounds.Y) || (xAxis.y == this.model.m_AreaBounds.Y)))) {
            var y1 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis.majorTickLines.size) : Math.floor(xAxis.y - xAxis.majorTickLines.size);
            var y2 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis.majorTickLines.size) : Math.floor(xAxis.y - xAxis.majorTickLines.size);
        }

        else
        {
            var y1 = y2 = (xAxis._y)?(!xAxis.showNextToAxisLine) ? xAxis._y : xAxis.y:Math.floor( xAxis.y + xAxis.majorTickLines.size - 5 ) ;
        }
        if (!gEle)
        var gTickEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisTicklines' + '_' + axisIndex });
        xAxis.labelPlacement = (!(xAxis.labelPlacement)) ? ej.datavisualization.Chart.LabelPlacement.BetweenTicks : xAxis.labelPlacement;
        var ticksbwtLabel = ((xAxis.labels.length > 0) && (xAxis.labelPlacement.toLowerCase() == "betweenticks")) ? -0.5 : 0;
        var collectionLength = xAxis.visibleLabels.length;
        //For between ticks and gridlines
        if ((xAxis._valueType.toLowerCase() == ej.datavisualization.Chart.ValueType.Category) && ticksbwtLabel < 0) {
            collectionLength = collectionLength > 0 ? xAxis.visibleLabels.length + 1 : collectionLength;
        }
        for (var i = 0; i < collectionLength; i++) {

            labelValue = (!xAxis.visibleLabels[i]) ? xAxis.visibleLabels[i - 1].Value + xAxis.range.interval : xAxis.visibleLabels[i].Value;
 
            var tempInterval = ((xAxis.labels.length > 0) && (ticksbwtLabel < 0)) ? labelValue + ticksbwtLabel : labelValue;

            tempInterval = (!(xAxis.roundingPlaces)) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(xAxis.visibleRange.interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(xAxis.visibleRange.interval)))) : tempInterval;

            if (ej.EjSvgRender.utils._inside(tempInterval, xAxis.visibleRange)) {

                if ((xAxis.hidePartialLabels) && ((i == 0) || (i == (collectionLength - 1))))
                    continue;
                if (xAxis.minorGridLines.visible || xAxis.minorTickLines.visible) {
                    var ticksVal = this._getSharpPath(xAxis.minorTickLines.width);
                    var linesVal = this._getSharpPath(xAxis.minorGridLines.width);
                    var yTickPosition;
                    if (xAxis._valueType == "logarithmic") {
                        minorTicks = tempInterval;
                        var logmax = xAxis.visibleRange.max;
                        var logmin = xAxis.visibleRange.min;

                        var logtickstart = Math.pow(xAxis.logBase, minorTicks - xAxis.visibleRange.interval);
                        var logtickend = Math.pow(xAxis.logBase, minorTicks);
                        var logtickInterval = (logtickend - logtickstart) / (xAxis.minorTicksPerInterval + 1);
                        var logtickPos = logtickstart + logtickInterval;
                        minorTicks = ej.EjSvgRender.utils._logBase(logtickPos, xAxis.logBase);
                        for (var j = 0; j < xAxis.minorTicksPerInterval; j++) {


                            if (minorTicks < logmax && minorTicks > logmin) {

                                minorPointX = Math.ceil(((minorTicks - logmin) / (logmax - logmin)) * (xAxis.width));

                                //Calculate Minor Ticks
                                if ((xAxis.minorTickLines) && xAxis.minorTickLines.visible) {
                                    var xTickPosition = Math.floor(minorPointX + x1);
                                    if ((xAxis.tickLinesPosition != 'inside' && xAxis.labelPosition != 'inside') || (xAxis.tickLinesPosition != 'inside' && xAxis.labelPosition == 'inside'))
                                        yTickPosition = (opposedPosition) ? Math.floor(y1 - xAxis.minorTickLines.size) : Math.floor(xAxis.minorTickLines.size + y1);
                                    else
                                        yTickPosition = (opposedPosition) ? Math.floor(y1 + xAxis.minorTickLines.size) : y1 - Math.floor(xAxis.minorTickLines.size);
                                    sbXMinorTicks.append("M" + " " + (xTickPosition + ticksVal) + " " + (yTickPosition + ticksVal) + " " + "L" + " " + (xTickPosition + ticksVal) + " " + (y1 + ticksVal) + " ");
                                }
                            }
                        }
                    }
                    else {
                        for (var j = 0, minorTicks = tempInterval ; j < xAxis.minorTicksPerInterval; j++) {
                            minorTicks += xAxis.visibleRange.interval / (xAxis.minorTicksPerInterval + 1);
                            if (minorTicks < xAxis.visibleRange.max && minorTicks > xAxis.visibleRange.min) {
                                minorPointX = Math.ceil(((minorTicks - xAxis.visibleRange.min) / (xAxis.visibleRange.max - xAxis.visibleRange.min)) * (xAxis.width));

                                //Calculate Minor Ticks
                                if ((xAxis.minorTickLines) && xAxis.minorTickLines.visible) {
                                    if ((xAxis.tickLinesPosition != 'inside' && xAxis.labelPosition != 'inside') || (xAxis.tickLinesPosition != 'inside' && xAxis.labelPosition == 'inside'))
                                        yTickPosition = (opposedPosition) ? Math.floor(y1 - xAxis.minorTickLines.size) : Math.floor(xAxis.minorTickLines.size + y1);
                                    else
                                        yTickPosition = (opposedPosition) ? Math.floor(y1 + xAxis.minorTickLines.size) : Math.floor(y1 - xAxis.minorTickLines.size);
                                    var points = Math.floor(minorPointX + x1);
                                    sbXMinorTicks.append("M" + " " + (points + ticksVal) + " " + (yTickPosition + ticksVal) + " " + "L" + " " + (points + ticksVal) + " " + (y1 + ticksVal) + " ");
                                }
                            }
                        }
                    }

                }

                //calculate major ticks
                if (xAxis.majorTickLines.visible || xAxis.majorGridLines.visible || labelBorder.width > 0) {
                    var mtVal = this._getSharpPath(xAxis.majorTickLines.width);
                    var mlVal = this._getSharpPath(xAxis.majorGridLines.width);
                    //Calculate Major Ticks and Grid lines
                    var pointX = xPointValue[i] = this.pointX = Math.ceil(ej.EjSvgRender.utils._getPointXY(tempInterval, xAxis.visibleRange, xAxis.isInversed) * (xAxis.width));
                    //Calculate Major Ticks
                    if (xAxis.majorTickLines.visible) {
                     
                        var lineStart = xAxis.majorTickLines.size + xAxis.axisLine.width / 2;
                        if ((xAxis.tickLinesPosition == 'inside' && xAxis.labelPosition == 'inside') || (xAxis.tickLinesPosition == 'inside' && xAxis.labelPosition != 'inside'))
                            var yPosition = (opposedPosition) ? y1 + lineStart : y1 - lineStart;
                        else
                            var yPosition = ((opposedPosition) ? y1 - lineStart : lineStart + y1) - ((isScroll) ? opposedPosition ? this.model.scrollerSize : -this.model.scrollerSize : 0);
                        sbXMajorTicks.append("M" + " " + (Math.floor(pointX + x1) + mtVal) + " " + (Math.floor(yPosition) + mtVal) + " " + "L" + " " + (Math.floor(pointX + x1) + mtVal) + " " + (Math.floor(y1 + ((opposedPosition) ? (-xAxis.axisLine.width / 2) : (xAxis.axisLine.width / 2))) + mtVal) + " ");
                    }
                }
            }
        }
        // draw xAxis label border
        if (labelBorder.width > 0) {
            var xLabelGrid = ej.EjSvgRender.utils._getStringBuilder(), scrollSize = isScroll ? this.model.scrollerSize: 0,
            lineStart = xAxis.axisLine.width, yPosition, i, gap, labelPosition = xAxis.labelPosition.toLowerCase(), boundsX = this.model.m_AreaBounds.X,
			boundsWidth = this.model.m_AreaBounds.Width, borderSize = labelBorder.width, length = xAxis._LableMaxWidth.height + xAxis.axisLine.width / 2 + 2,
			collectionLength = xAxis.visibleLabels.length;
			
			if (xAxis.tickLinesPosition == labelPosition) length += xAxis.majorTickLines.size;	
            if (labelPosition == 'inside'){
                yPosition = (opposedPosition) ? y1 + lineStart : y1 + lineStart;
				endY = opposedPosition ? y1 + length : y1 - length; 
			}
            else {
                yPosition = (opposedPosition) ? y1 - lineStart : lineStart + y1 + ((xAxis.zoomFactor < 1 && this.model.zooming.enableScrollbar
                    && axisIndex == 0) ? this.model.scrollerSize : 0);
				endY = opposedPosition ? y1 - length - scrollSize : y1 + length + scrollSize;
			}
					
            for (i = 0; i < collectionLength; i++) {
              gap = (xPointValue[xPointValue.length - 1] - xPointValue[xPointValue.length - 2]) / 2;
              if (!ej.util.isNullOrUndefined(xPointValue[i]) && xPointValue.length >= 1 && !isNaN(gap)) {
                if (xAxis._valueType == "category" && xAxis.labelPlacement.toLowerCase() == "betweenticks") {
                    startX = xPointValue[i] + x1;
                    endX = xPointValue[i] + (gap * 2) + x1;
                } else {
                    startX = xPointValue[i] - gap + x1;
                    endX = xPointValue[i] + gap + x1;    
                }
                endX = Math.floor(endX);
                endY = Math.floor(endY);
                startX = Math.floor(startX);
                yPosition = Math.floor(yPosition);
                if (startX < xAxis.x)
                    xLabelGrid.append("M" + " " + Math.floor(x1) + " " + endY + " " +
                      "L" + " " + endX + " " + endY + " ");
                else if (endX > xAxis.width + xAxis.x){
                    xLabelGrid.append("M" + " " + startX + " " + yPosition + " " + "L" + " " + startX + " " + endY + " " +
                      "L" + " " + Math.floor(xAxis.width + x1) + " " + endY + " ");
					  if (endX - borderSize  <= xAxis.width + xAxis.x)
						   xLabelGrid.append("M " + Math.floor(xAxis.width + x1) + " " + endY + " L " + (xAxis.x + xAxis.width) + " " + yPosition);
				}
                else {
                    if (i == 0)
                        xLabelGrid.append("M " + xAxis.x + " " + endY + " L " + startX + " " + endY + " ");
                    xLabelGrid.append("M" + " " + startX + " " + yPosition + " " + "L" + " " + startX + " " + endY + " " +
                       "L" + " " + endX + " " + endY + " ");
                    if (i == collectionLength - 1)
                        xLabelGrid.append("M" + " " + endX + " " + yPosition + " " + "L" + " " + endX + " " + endY + " " +
                            "M " + endX + " " + endY + " L " + (xAxis.x + xAxis.width) + " " + endY);
                }
              }
            }
            var labelGridOptions = {
                'id': this.svgObject.id + '_XAxisLabelBorder_' + axisIndex,
                'fill': 'transparent',
                'stroke-width': labelBorder.width,
                'stroke': labelBorder.color,
                'd': xLabelGrid.toString()
            };
            this.svgRenderer.drawPath(labelGridOptions, gEle);
            $(gEle).appendTo(this.gXaxisEle);
        }

        //draw minor ticks
        if (xAxis.minorTickLines.visible && xAxis.visible && xAxis.minorTicksPerInterval > 0) {
            xMinorTicksDir = sbXMinorTicks.toString();
            var optionsMinorTicks = {
                'id': this.svgObject.id + '_XAxisMinorTicks_' + axisIndex,
                'fill': 'none',
                'stroke-width': xAxis.minorTickLines.width,
                'stroke': xAxis.minorTickLines.color,
                'd': xMinorTicksDir
            };
            if(!gEle)
                this.svgRenderer.drawPath(optionsMinorTicks, gTickEle);
            else
                this.svgRenderer.drawPath(optionsMinorTicks, gEle);

        }
        if (xAxis.majorTickLines.visible && xAxis.visible) {
            xMajorTicksDir = sbXMajorTicks.toString();
            var optionsMajorTicks = {
                'id': this.svgObject.id + '_XAxisMajorTicks_' + axisIndex,
                'fill': 'none',
                'stroke-width': xAxis.majorTickLines.width,
                'stroke': xAxis.majorTickLines.color,
                'd': xMajorTicksDir
            };
            if (!gEle) {
                
                this.svgRenderer.drawPath(optionsMajorTicks, gTickEle);
            }
            else
                this.svgRenderer.drawPath(optionsMajorTicks, gEle);
        }
        if(xAxis.tickLinesPosition=='inside')
            $(gTickEle).appendTo(this.gXaxisEle);

    },
    _drawXAxisGridLine: function (axisIndex, xAxis, params) {
        var xMajorGridDir, xMinorGridDir,
			sbXMinorGrid = ej.EjSvgRender.utils._getStringBuilder(),        
			sbXMajorGrid = ej.EjSvgRender.utils._getStringBuilder(),
			minorPointX,
			xPoint = [], padding = this.model.elementSpacing + 5,
			labelValue,
			opposedPosition = xAxis._opposed,
			x1 = Math.floor(xAxis.x),
			x2 = Math.floor(xAxis.x + xAxis.width),
			gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisGrid' + '_' + axisIndex }),
			gAgb = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisAlternateGridBand' + '_' + axisIndex });
        var isCrossesAt = params.axes[xAxis.name]._validCross;
        if (axisIndex != 0 &&!isCrossesAt && (xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition == 'inside') && (!(xAxis.y == (this.model.m_AreaBounds.Height + this.model.m_AreaBounds.Y) || (xAxis.y == this.model.m_AreaBounds.Y))))
        {
            var y1 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis._LableMaxWidth.height) : Math.floor(xAxis.y - xAxis._LableMaxWidth.height);
            var y2 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis._LableMaxWidth.height) : Math.floor(xAxis.y - xAxis._LableMaxWidth.height);
        }
        else if ((xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition != 'inside') && (!(xAxis.y == (this.model.m_AreaBounds.Height + this.model.m_AreaBounds.Y) || (xAxis.y == this.model.m_AreaBounds.Y))))
        {
            var y1 = y2 = (!opposedPosition) ? (xAxis.showNextToAxisLine) ? Math.floor(xAxis.y + xAxis._LableMaxWidth.height) - padding : Math.floor(xAxis.y + xAxis._LableMaxWidth.height)  : Math.floor(xAxis.y - xAxis._LableMaxWidth.height) + padding;
        }
        else if (axisIndex != 0 &&!isCrossesAt && (xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition == 'inside') && (!(xAxis.y == (this.model.m_AreaBounds.Height + this.model.m_AreaBounds.Y) || (xAxis.y == this.model.m_AreaBounds.Y)))) {
            var y1 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis.majorTickLines.size) : Math.floor(xAxis.y - xAxis.majorTickLines.size);
            var y2 = (!opposedPosition) ? Math.floor(xAxis.y + xAxis.majorTickLines.size) : Math.floor(xAxis.y - xAxis.majorTickLines.size);
        }
        else
        {
            var y1 = Math.floor(xAxis.y);
            var y2 = Math.floor(xAxis.y);
        }
       
        if (xAxis.visible && xAxis.axisLine.visible) {
            var offset = xAxis.axisLine.offset > 0 ? xAxis.axisLine.offset : 0;
            var val=this._getSharpPath(xAxis.axisLine.width);
            var optionsLine = {
                'id': this.svgObject.id + '_XAxisLine_' + axisIndex,
                x1: (x1 - xAxis.plotOffset)+ val + offset ,
                y1: y1+val,
                x2: (x2 + xAxis.plotOffset) -offset+val,
                y2: y2+val,
                'stroke-dasharray': xAxis.axisLine.dashArray,
                'stroke-width': xAxis.axisLine.width,
                'stroke': xAxis.axisLine.color,
                'opacity': xAxis.axisLine.opacity || 1
            };

            params.axes[xAxis.name]._lineOption = [optionsLine, this.gXaxisEle];
        }
		else
			params.axes[xAxis.name]._lineOption = [null, this.gXaxisEle];
        xAxis.labelPlacement = (!(xAxis.labelPlacement)) ? ej.datavisualization.Chart.LabelPlacement.BetweenTicks : xAxis.labelPlacement;
        var ticksbwtLabel = ((xAxis.labels.length > 0) && (xAxis.labelPlacement.toLowerCase() == "betweenticks")) ? -0.5 : 0;
        var collectionLength = xAxis.visibleLabels.length;
		//For between ticks and gridlines
        if ((xAxis._valueType.toLowerCase() == ej.datavisualization.Chart.ValueType.Category) && ticksbwtLabel < 0) {
            collectionLength = collectionLength > 0 ? xAxis.visibleLabels.length + 1 : collectionLength;
        }
        for (var i = 0; i < collectionLength; i++) {
			 labelValue = (!xAxis.visibleLabels[i]) ? xAxis.visibleLabels[i - 1].Value + xAxis.range.interval : xAxis.visibleLabels[i].Value;

            var tempInterval = ((xAxis.labels.length > 0) && (ticksbwtLabel < 0)) ? labelValue + ticksbwtLabel : labelValue;
            
            tempInterval = (!(xAxis.roundingPlaces)) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(xAxis.visibleRange.interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(xAxis.visibleRange.interval)))) : tempInterval;

            if (ej.EjSvgRender.utils._inside(tempInterval, xAxis.visibleRange)) {

                if ((xAxis.hidePartialLabels) && ((i == 0) || (i == (collectionLength - 1))))
                    continue;
            
                //Calculate Minor Ticks and Grid lines
                if (xAxis.minorGridLines.visible || xAxis.minorTickLines.visible) {
                    var ticksVal = this._getSharpPath(xAxis.minorTickLines.width);
                    var linesVal = this._getSharpPath(xAxis.minorGridLines.width);
                    var yTickPosition;
                    if (xAxis._valueType == "logarithmic"){
                    minorTicks = tempInterval;
                    var logmax = xAxis.visibleRange.max;
                    var logmin = xAxis.visibleRange.min;

                    var logtickstart = Math.pow(xAxis.logBase, minorTicks - xAxis.visibleRange.interval);
                    var logtickend = Math.pow(xAxis.logBase, minorTicks);
                    var logtickInterval = (logtickend - logtickstart) / (xAxis.minorTicksPerInterval + 1);
                    var logtickPos = logtickstart + logtickInterval;
                    minorTicks = ej.EjSvgRender.utils._logBase(logtickPos, xAxis.logBase);
                    for (var j = 0; j < xAxis.minorTicksPerInterval; j++) {


                        if (minorTicks < logmax && minorTicks > logmin) {

                            minorPointX = Math.ceil(((minorTicks - logmin) / (logmax - logmin)) * (xAxis.width));

                           

                            //Calculate Minor Gridlines
                            if ((xAxis.minorGridLines) && xAxis.minorGridLines.visible) {
                                var tickPosition = Math.floor(minorPointX + x1) ;
                                sbXMinorGrid.append("M" + " " + (tickPosition + linesVal) + " " + (y1 + linesVal) + " " + "L" + " " + (tickPosition + linesVal) + " " + ( Math.floor(opposedPosition ?  this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height: this.model.m_AreaBounds.Y) + linesVal) + " ");
                            }

                        }
                        logtickPos += logtickInterval;
                        minorTicks = ej.EjSvgRender.utils._logBase(logtickPos, xAxis.logBase);
                    }
                    } else {
                        for (var j = 0, minorTicks = tempInterval ; j < xAxis.minorTicksPerInterval; j++) {
                            minorTicks += xAxis.visibleRange.interval / (xAxis.minorTicksPerInterval + 1);
                            if (minorTicks < xAxis.visibleRange.max && minorTicks > xAxis.visibleRange.min) {
                                minorPointX = Math.ceil(((minorTicks - xAxis.visibleRange.min) / (xAxis.visibleRange.max - xAxis.visibleRange.min)) * (xAxis.width));


                                //Calculate Minor Gridlines
                                if ((xAxis.minorGridLines) && xAxis.minorGridLines.visible)
                                    sbXMinorGrid.append("M" + " " + (Math.floor(minorPointX + x1) + linesVal) + " " + (y1 + linesVal) + " " + "L" + " " + (Math.floor(minorPointX + x1) + linesVal) + " " + ( Math.floor(opposedPosition ?  this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height: this.model.m_AreaBounds.Y) + linesVal) + " ");
                            }
                        }
                    }
            }

                if (xAxis.majorTickLines.visible || xAxis.majorGridLines.visible) {
                    var mtVal = this._getSharpPath(xAxis.majorTickLines.width);
                    var mlVal = this._getSharpPath(xAxis.majorGridLines.width);
                    var pointX = this.pointX = Math.ceil(ej.EjSvgRender.utils._getPointXY(tempInterval, xAxis.visibleRange, xAxis.isInversed) * (xAxis.width));
                    var mX1 = (Math.floor(pointX + x1));
                    if (xAxis.zoomed)
                        xPoint[0] = xAxis.x;
                    if (i == 0) {
                        if (mX1 == Math.floor(this.model.m_AreaBounds.X)) {
                            xPoint.push(mX1 + mlVal);
                            continue;
                            
                        }
                    }
                    if ((i == (collectionLength - 1)) && (this.model.chartArea.border.color != "transparent" && this.model.chartArea.border.width > 0)) {
                         if (mX1 == Math.floor(this.model.m_AreaBounds.X + this.model.m_AreaBounds.Width))
                             continue;
                         if (xAxis.zoomed)
                             xPoint[collectionLength] = mX1 + mlVal;
                       
                    }
                     
                    //Calculate Major Gridlines
                    if (xAxis.majorGridLines.visible)
                        sbXMajorGrid.append("M" + " " + (mX1 + mlVal) + " " + (Math.floor(this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height) + mlVal) + " " + "L" + " " + (mX1 + mlVal) + " " + (Math.floor(this.model.m_AreaBounds.Y) + mlVal) + " ");
                    if ((xAxis._valueType.toLowerCase() != "category") && i == collectionLength - 1)
                        continue;
                    xPoint.push((mX1 + mlVal));
                }

            }

        }

       
        if (xAxis.alternateGridBand.odd.fill != "transparent" || xAxis.alternateGridBand.even.fill != "transparent") {
            var height = this.model.m_AreaBounds.Height, optionsAlternateeven;

            if(xPoint.length === 0){
                optionsAlternateeven = {
                    'id': this.svgObject.id + '_XAxis' + axisIndex + '_Alternateeven' + 0,
                    'x': xAxis.x,
                    'y': Math.floor(this.model.m_AreaBounds.Y),
                    'width': xAxis.width,
                    'height': height,
                    'fill': xAxis.alternateGridBand.even.fill,
                    'opacity': xAxis.alternateGridBand.even.opacity,
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)',
                    'stroke': "transparent"
                };
                this.svgRenderer.drawRect(optionsAlternateeven, gAgb);
            }
            
            for (var i = 1; i < xPoint.length; i += 2) {
                var width = xPoint[i + 1] - xPoint[i];
                width = (width || xAxis.labelPlacement.toLowerCase() == 'onticks') ? width : (xAxis.width+xAxis.x) - xPoint[i];
                if (i == xPoint.length - 1 && xAxis.zoomed)
                    width = this.model.m_AreaBounds.X + this.model.m_AreaBounds.Width - xPoint[xPoint.length - 1] - xAxis.plotOffset;
                var optionsAlternateodd = {
                    'id': this.svgObject.id + '_XAxis' + axisIndex + '_Alternateodd' + [i],
                    'x': xPoint[i],
                    'y': Math.floor(this.model.m_AreaBounds.Y),
                    'width': width,
                    'height': height,
                    'fill': xAxis.alternateGridBand.odd.fill,
                    'opacity': xAxis.alternateGridBand.odd.opacity,
                    'stroke': "transparent",
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)'

                };
                if(width > 0)
                	this.svgRenderer.drawRect(optionsAlternateodd, gAgb);
            }

            for (var i = 0; i < xPoint.length; i += 2) {
                var width = xPoint[i + 1] - xPoint[i];
                width = (width || xAxis.labelPlacement.toLowerCase() == 'onticks') ? width : (xAxis.width + xAxis.x) - xPoint[i];
                if (i == 0 && xAxis.zoomed)
                    width = xPoint[1] - xAxis.x;
                
                if (i == xPoint.length - 1 && xAxis.zoomed)
                    width = this.model.m_AreaBounds.X + this.model.m_AreaBounds.Width - xPoint[xPoint.length - 1]-xAxis.plotOffset;
                    
                optionsAlternateeven = {
                    'id': this.svgObject.id + '_XAxis' + axisIndex + '_Alternateeven' + [i],
                    'x': xPoint[i],
                    'y': Math.floor(this.model.m_AreaBounds.Y),
                    'width': width,
                    'height': height,
                    'fill': xAxis.alternateGridBand.even.fill,
                    'opacity': xAxis.alternateGridBand.even.opacity,
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)',
                    'stroke': "transparent"
                };
                if(width > 0)
                    this.svgRenderer.drawRect(optionsAlternateeven, gAgb);
            }
            $(gAgb).appendTo(gEle);
        }
        if (xAxis.minorGridLines.visible && xAxis.minorTicksPerInterval > 0) {
            xMinorGridDir = sbXMinorGrid.toString();
            //Drawing Minor Grid Lines
            var optionsMinorGrid = {
                'id': this.svgObject.id + '_XAxisMinorGridLines_' + axisIndex,
                'fill': 'none',
                'stroke-width': xAxis.minorGridLines.width,
                'stroke': xAxis.minorGridLines.color,
                'stroke-dasharray': xAxis.minorGridLines.dashArray,
                'd': xMinorGridDir
            };
            this.svgRenderer.drawPath(optionsMinorGrid, gEle);
        }       
        xMajorGridDir = sbXMajorGrid.toString();
        if (xAxis.majorGridLines.visible) {
            var options = {
                'id': this.svgObject.id + '_XAxisMajorGridLines_' + axisIndex,
                'fill': 'none',
                'stroke-width': xAxis.majorGridLines.width,
                'stroke': xAxis.majorGridLines.color,
                'opacity': xAxis.majorGridLines.opacity,
                'stroke-dasharray': xAxis.majorGridLines.dashArray,
                'd': xMajorGridDir
            };

            //Drawing Major Grid Lines
            if(options.d != '')
            this.svgRenderer.drawPath(options, gEle);

        }
        $(gEle).appendTo(this.svgObject);
         
        
    },

    _drawYAxisTickLine:function(axisIndex,yAxis,gEle,isValidCross)
    {
        var yMajorTicksDir = "", yMinorTicksDir = "";
        var pointY = 0;
        var isScroll = yAxis._isScroll && !(yAxis.scrollbarSettings.pointsLength != null && yAxis.scrollbarSettings.pointsLength < yAxis.maxPointLength);
        var opposedPosition = yAxis._opposed;
        var labelValue, yPointValue = [];
		var labelBorder = yAxis.labelBorder;
      
        if (axisIndex != 1  && ((yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition == 'inside') || (yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition != 'inside')) && (!(yAxis.x == (this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) || (yAxis.x == (this.model.m_AreaBounds.X))))) {
            var x1 = (!opposedPosition && !isValidCross) ? Math.floor(yAxis.x - yAxis._LableMaxWidth.width - this.model.elementSpacing) : yAxis.showNextToAxisLine ? yAxis.x :Math.floor(yAxis.x + yAxis._LableMaxWidth.width + this.model.elementSpacing);
            var x2 = (!opposedPosition && !isValidCross ) ? Math.floor(yAxis.x - yAxis._LableMaxWidth.width - this.model.elementSpacing) :  yAxis.showNextToAxisLine ? yAxis.x : Math.floor(yAxis.x + yAxis._LableMaxWidth.width + this.model.elementSpacing);
        }
        else if (axisIndex != 1 && !isValidCross && (yAxis.labelPosition != 'inside' && yAxis.tickLinesPosition == 'inside') && (!(yAxis.x == (this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) || (yAxis.x == (this.model.m_AreaBounds.X))))) {
            var x1 = Math.floor(yAxis.x+yAxis.majorTickLines.size);
            var x2 = Math.floor(yAxis.x+yAxis.majorTickLines.size);
        }
        else            
        {
            var x1 = x2 = (!yAxis.showNextToAxisLine) ? yAxis._x : !yAxis.showNextToAxisLine && yAxis.tickLinesPosition == "inside" ? yAxis.x + yAxis.majorTickLines.size : yAxis.x;
        }   

        var y1 = Math.floor(yAxis.y + yAxis.height);
        var y2 = Math.floor(yAxis.y);       
    

        var sbYMinorTicks = ej.EjSvgRender.utils._getStringBuilder();   
        var sbYMajorTicks = ej.EjSvgRender.utils._getStringBuilder();      
        var gTickEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisTicklines' + '_' + axisIndex });
      
		 yAxis.labelPlacement = (!(yAxis.labelPlacement)) ? ej.datavisualization.Chart.LabelPlacement.BetweenTicks : yAxis.labelPlacement;
        var ticksbwtLabel = ((yAxis.labels.length > 0) && (yAxis.labelPlacement.toLowerCase() == "betweenticks")) ? -0.5 : 0;
        var collectionLength = yAxis.visibleLabels.length;
        //For between ticks and gridlines
        if ((yAxis._valueType.toLowerCase() == ej.datavisualization.Chart.ValueType.Category) && ticksbwtLabel < 0) {
            collectionLength = collectionLength > 0 ? yAxis.visibleLabels.length + 1 : collectionLength;
        }
        for (var i = 0; i < collectionLength; i++)
        {
            labelValue = (!yAxis.visibleLabels[i]) ? yAxis.visibleLabels[i - 1].Value + yAxis.range.interval : yAxis.visibleLabels[i].Value;
            var tempInterval = ((yAxis.labels.length > 0) && (ticksbwtLabel < 0)) ? labelValue + ticksbwtLabel : labelValue;
            tempInterval = (!(yAxis.roundingPlaces)) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(yAxis.visibleRange.interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(yAxis.visibleRange.interval)))) : tempInterval;

            if (ej.EjSvgRender.utils._inside(tempInterval, yAxis.visibleRange))
            {
 
                if ((yAxis.hidePartialLabels) && ((i == 0) || (i == (yAxis.visibleLabels.length - 1))))
                    continue;

                // Calculate Minor Ticks and Grid lines      
                if (yAxis.minorGridLines.visible || yAxis.minorTickLines.visible) {
                    var minorPointY;
                    var tickVal = this._getSharpPath(yAxis.minorTickLines.width);
                    var lineVal = this._getSharpPath(yAxis.minorGridLines.width);
                    if (yAxis._valueType == "logarithmic") {
                        minorTicks = tempInterval;
                        var logmax = yAxis.visibleRange.max;
                        var logmin = yAxis.visibleRange.min;

                        var logtickstart = Math.pow(yAxis.logBase, minorTicks - yAxis.visibleRange.interval);
                        var logtickend = Math.pow(yAxis.logBase, minorTicks);
                        var logtickInterval = (logtickend - logtickstart) / (yAxis.minorTicksPerInterval + 1);
                        var logtickPos = logtickstart + logtickInterval;
                        minorTicks = ej.EjSvgRender.utils._logBase(logtickPos, yAxis.logBase);
                        for (var j = 0; j < yAxis.minorTicksPerInterval; j++) {


                            if (minorTicks < logmax && minorTicks > logmin) {

                                minorPointY = Math.ceil(((minorTicks - logmin) / (logmax - logmin)) * (yAxis.height));

                                //Calculate Minor Ticks
                                if ((yAxis.minorTickLines) && yAxis.minorTickLines.visible) {

                                    if (yAxis.minorTickLines.visible) {
                                        if ((yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition != 'inside') || (yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition == 'inside'))
                                            ytickPosition = (opposedPosition) ? yAxis.minorTickLines.size : -yAxis.minorTickLines.size;
                                        else
                                            var ytickPosition = (opposedPosition) ? -yAxis.minorTickLines.size : yAxis.minorTickLines.size;
                                        sbYMinorTicks.append("M" + " " + (Math.floor(ytickPosition + x1) + tickVal) + " " + (Math.floor((minorPointY * -1) + y1) + tickVal) + " " + "L" + " " + (x1 + tickVal) + " " + (Math.floor((minorPointY * -1) + y1) + tickVal) + " ");
                                    }
                                }                              
                            }
                            logtickPos += logtickInterval;
                            minorTicks = ej.EjSvgRender.utils._logBase(logtickPos, yAxis.logBase);
                        }
                    }
                    else {
                        for (var j = 0, minorTicks = tempInterval; j < yAxis.minorTicksPerInterval; j++) {

                            minorTicks += yAxis.visibleRange.interval / (yAxis.minorTicksPerInterval + 1);
                            if (minorTicks < yAxis.visibleRange.max && minorTicks > yAxis.visibleRange.min) {
                                minorPointY = ((minorTicks - yAxis.visibleRange.min) / (yAxis.visibleRange.delta)) * (yAxis.height);
                                // Calculate Minor Ticks   
                                if (yAxis.minorTickLines.visible) {
                                    if ((yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition != 'inside') || (yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition == 'inside'))
                                        var ytickPosition = (opposedPosition) ? yAxis.minorTickLines.size : -yAxis.minorTickLines.size;
                                    else
                                        var ytickPosition = (opposedPosition) ? -yAxis.minorTickLines.size : yAxis.minorTickLines.size;
                                    sbYMinorTicks.append("M" + " " + (Math.floor(ytickPosition + x1) + tickVal) + " " + (Math.floor((minorPointY * -1) + y1) + tickVal) + " " + "L" + " " + (x1 + tickVal) + " " + (Math.floor((minorPointY * -1) + y1) + tickVal) + " ");
                                }
                               
                            }
                        }
                    }
                }
                // Calculate Major Ticks and Grid lines
                if (yAxis.majorTickLines.visible || yAxis.majorGridLines.visible || labelBorder.width > 0) {
                    var mtVal = this._getSharpPath(yAxis.minorTickLines.width);
                    var mlVal = this._getSharpPath(yAxis.majorGridLines.width);
					pointY = yPointValue[i] = ej.EjSvgRender.utils._getPointXY(tempInterval, yAxis.visibleRange, yAxis.isInversed) * (yAxis.height);
                    // Calculate Major Ticks
                    if (yAxis.majorTickLines.visible)
                    {
                        if ((yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition != 'inside') || (yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition == 'inside'))
                            var xPosition = ((opposedPosition) ? yAxis.majorTickLines.size + yAxis.axisLine.width / 2 : -(yAxis.majorTickLines.size + yAxis.axisLine.width / 2)) + ((isScroll) ? opposedPosition ? this.model.scrollerSize : opposedPosition - this.model.scrollerSize : 0);
                        else if ((yAxis.tickLinesPosition == 'inside' && yAxis.labelPosition != 'inside') || (yAxis.tickLinesPosition == 'inside' && yAxis.labelPosition == 'inside'))
                            var xPosition = (opposedPosition) ? -(yAxis.majorTickLines.size + yAxis.axisLine.width / 2) : (yAxis.majorTickLines.size + yAxis.axisLine.width / 2);

                        sbYMajorTicks.append("M" + " " + (Math.floor(xPosition + x1) + mtVal) + " " + (Math.floor((pointY * -1) + y1) + mtVal) + " " + "L" + " " + (Math.floor(x1 + ((opposedPosition) ? (yAxis.axisLine.width / 2) : (yAxis.axisLine.width / 2))) + mtVal) + " " + (Math.floor((pointY * -1) + y1) + mtVal) + " ");

                    }


                   
                }
            }
        }

        // draw yAxis label border
        if (labelBorder.width > 0) {
            var yLabelGrid = ej.EjSvgRender.utils._getStringBuilder(), xPosition = yAxis.axisLine.width / 2, i, 
			startY, endY, endX, gap, scrollSize = isScroll ? this.model.scrollerSize: 0, length = yAxis._LableMaxWidth.maxWidth + 10 ;
                
				if (yAxis.tickLinesPosition == yAxis.labelPosition) length += yAxis.majorTickLines.size;
				endX = Math.floor(x1 - length);
				if (yAxis.labelPosition == "outside")
                        endX = opposedPosition ? Math.floor(x1 + length) + scrollSize : Math.floor(x1 - length) - scrollSize;
                    else
                        endX = opposedPosition ? Math.floor(x1 - length) : Math.floor(x1 + length);
						
                for (var i = 0; i < collectionLength; i++) {
                  gap = (yPointValue[yPointValue.length - 1] - yPointValue[yPointValue.length - 2]) / 2;
                  if (!ej.util.isNullOrUndefined(yPointValue[i]) && yPointValue.length > 1 && !isNaN(gap)) { 
					if (yAxis._valueType == "category" && yAxis.labelPlacement.toLowerCase() == "betweenticks") {
						startY = Math.floor((yPointValue[i] * -1) + y1);
						endY = Math.floor((yPointValue[i] * -1) - (gap*2) + y1);
					} else{
						startY = Math.floor((yPointValue[i] * -1) + gap + y1);
						endY = Math.floor((yPointValue[i] * -1) - gap + y1);
					}
                    if (startY > y1)
                        yLabelGrid.append("M" + " " + endX + " " + y1 + " " + "L" + " " + endX + " " + endY + " ");
                    else if (endY < this.model.m_AreaBounds.Y)
                        yLabelGrid.append("M" + " " + Math.floor(xPosition + x1) + " " + startY + " " + "L" + " " + endX + " " + startY + " "
                         + "L" + " " + endX + " " + this.model.m_AreaBounds.Y + " ");
                    else {
                        yLabelGrid.append("M" + " " + Math.floor(xPosition + x1) + " " + startY + " " + "L" + " " + endX + " " + startY + " "
                        + "L" + " " + endX + " " + endY + " ");
                        if (i == collectionLength - 1) 
                            yLabelGrid.append("M" + " " + Math.floor(xPosition + x1) + " " + endY + " " + "L" + " " + endX + " " + endY + " ");
                        }
                    }
                }
                var labelGridOptions = {
                    'id': this.svgObject.id + '_YAxisLabelBorder_' + axisIndex,
                    'fill': 'none',
                    'stroke-width': labelBorder.width,
                    'stroke': labelBorder.color,
                    'd': yLabelGrid.toString()
                };
                this.svgRenderer.drawPath(labelGridOptions, gEle);
                $(gEle).appendTo(this.gYaxisEle);
            }

        //Drawning Minor Ticks
        if (yAxis.minorTickLines.visible && yAxis.visible && yAxis.minorTicksPerInterval > 0) {
            yMinorTicksDir = sbYMinorTicks.toString();
            var optionsMinotTick = {
                'id': this.svgObject.id + '_YAxisMinorTicks_' + axisIndex,
                'fill': 'none',
                'stroke-width': yAxis.minorTickLines.width,
                'stroke': yAxis.minorTickLines.color,
                'd': yMinorTicksDir
            };
			this.svgRenderer.drawPath(optionsMinotTick, gEle);
        }
       

        if (yAxis.majorTickLines.visible && yAxis.visible) {
            yMajorTicksDir = sbYMajorTicks.toString();
            //Drawning Major Ticks
            var optionsMajorTick = {
                'id': this.svgObject.id + '_YAxisMajorTicks_' + axisIndex,
                'fill': 'none',
                'stroke-width': yAxis.majorTickLines.width,
                'stroke': yAxis.majorTickLines.color,
                'd': yMajorTicksDir
            };
			this.svgRenderer.drawPath(optionsMajorTick, gEle);
        }
    },

    _drawYAxisGridLine: function (axisIndex, yAxis, params) {

        var yMajorGridDir = "", yMajorTicksDir = "", yMinorTicksDir = "", yMinorGridDir = "";
        var pointY = 0;
        var labelValue;
        var y1 = Math.floor(yAxis.y + yAxis.height);
        var y2 = Math.floor(yAxis.y);
        var opposedPosition = yAxis._opposed;
        var yPoint = [];
        var axisName = (yAxis.name).replace(/[^a-zA-Z0-9]/g, "");
        var isCrossesAt = params.axes[axisName]._validCross;
        if (axisIndex != 1 && !isCrossesAt &&((yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition == 'inside') || (yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition != 'inside')) && (!(yAxis.x == (this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) || (yAxis.x == (this.model.m_AreaBounds.X))))) {
            var x1 = (!opposedPosition) ? Math.floor(yAxis.x - yAxis._LableMaxWidth.width - this.model.elementSpacing) : Math.floor(yAxis.x + yAxis._LableMaxWidth.width + this.model.elementSpacing);
            var x2 = (!opposedPosition) ? Math.floor(yAxis.x - yAxis._LableMaxWidth.width - this.model.elementSpacing) : Math.floor(yAxis.x + yAxis._LableMaxWidth.width + this.model.elementSpacing);
        }
    else if(axisIndex != 1 && !isCrossesAt&& (yAxis.labelPosition != 'inside' && yAxis.tickLinesPosition == 'inside') && (!(yAxis.x == (this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) || (yAxis.x == (this.model.m_AreaBounds.X))))) 
        {
   
            var x1 = (!opposedPosition) ? Math.floor(yAxis.x - yAxis.majorTickLines.size) : Math.floor(yAxis.x + yAxis.majorTickLines.size);
            var x2 = (!opposedPosition) ? Math.floor(yAxis.x - yAxis.majorTickLines.size) : Math.floor(yAxis.x + yAxis.majorTickLines.size);
        }
        else {
            var x1 = Math.floor(yAxis.x);
            var x2 = Math.floor(yAxis.x);
        }             
        var sbYMinorGrid = ej.EjSvgRender.utils._getStringBuilder();        
        var sbYMajorGrid = ej.EjSvgRender.utils._getStringBuilder();
        var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisGrid' + '_' + axisIndex });
        var gAgb = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisAlternateGridBand' + '_' + axisIndex });

        if (yAxis.visible && yAxis.axisLine.visible) {
            var offset = yAxis.axisLine.offset > 0 ? yAxis.axisLine.offset : 0;
            var val = this._getSharpPath(yAxis.axisLine.width);
            
            var optionsLine = {
                'id': this.svgObject.id +axisName + '_YAxisLine_' + axisIndex,
                x1: x1+val,
                y1: (y2 - yAxis.plotOffset) + offset+val,
                x2: x2+val,
                y2: (y1 + yAxis.plotOffset) - offset+val,
                'stroke-width': yAxis.axisLine.width,
                'stroke-dasharray': yAxis.axisLine.dashArray,
                'stroke': yAxis.axisLine.color,
                'opacity': yAxis.axisLine.opacity||1
            };
            params.axes[yAxis.name]._lineOption = [optionsLine, this.gYaxisEle];
        }
		else
			params.axes[yAxis.name]._lineOption = [null, this.gYaxisEle];
     
        if (yAxis.axisBottomLine) {
            if (yAxis.axisBottomLine.visible) {
                var optionsBottomLine = {
                    'id': this.svgObject.id +axisName+ '_YAxisBottomLine_' + axisIndex,
                    x1: this.model.m_AreaBounds.X,
                    y1: y1,
                    x2: this.model.m_AreaBounds.X + this.model.m_AreaBounds.Width,
                    y2: y1,
                    'stroke-width': yAxis.axisBottomLine.width,
                    'stroke': yAxis.axisBottomLine.color
                };
                this.svgRenderer.drawLine(optionsBottomLine, gEle);
            }
        }
        yAxis.labelPlacement = (!(yAxis.labelPlacement)) ? ej.datavisualization.Chart.LabelPlacement.BetweenTicks : yAxis.labelPlacement;
        var ticksbwtLabel = ((yAxis.labels.length > 0) && (yAxis.labelPlacement.toLowerCase() == "betweenticks")) ? -0.5 : 0;
        var collectionLength = yAxis.visibleLabels.length;
        for (var i = 0; i < collectionLength; i++) {
            labelValue = yAxis.visibleLabels[i].Value;
            var tempInterval = ((yAxis.labels.length > 0) && (ticksbwtLabel < 0)) ? labelValue + ticksbwtLabel : labelValue;
            tempInterval = (!(yAxis.roundingPlaces)) ? parseFloat(tempInterval.toFixed((ej.EjSvgRender.utils._decimalPlaces(yAxis.visibleRange.interval) == 0 ? 1 : ej.EjSvgRender.utils._decimalPlaces(yAxis.visibleRange.interval)))) : tempInterval;

            if (ej.EjSvgRender.utils._inside(tempInterval, yAxis.visibleRange)) {

                if ((yAxis.hidePartialLabels) && ((i == 0) || (i == (yAxis.visibleLabels.length - 1))))
                    continue;

                // Calculate Minor Ticks and Grid lines      
                if (yAxis.minorGridLines.visible || yAxis.minorTickLines.visible) {
                    var minorPointY;
                    var tickVal = this._getSharpPath(yAxis.minorTickLines.width);
                    var lineVal = this._getSharpPath(yAxis.minorGridLines.width);
                    if (yAxis._valueType == "logarithmic") {
                        minorTicks = tempInterval;
                        var logmax = yAxis.visibleRange.max;
                        var logmin = yAxis.visibleRange.min;

                        var logtickstart = Math.pow(yAxis.logBase, minorTicks - yAxis.visibleRange.interval);
                        var logtickend = Math.pow(yAxis.logBase, minorTicks);
                        var logtickInterval = (logtickend - logtickstart) / (yAxis.minorTicksPerInterval + 1);
                        var logtickPos = logtickstart + logtickInterval;
                        minorTicks = ej.EjSvgRender.utils._logBase(logtickPos, yAxis.logBase);
                        for (var j = 0; j < yAxis.minorTicksPerInterval; j++) {


                            if (minorTicks < logmax && minorTicks > logmin) {

                                minorPointY = Math.ceil(((minorTicks - logmin) / (logmax - logmin)) * (yAxis.height));

                            
                              
                                //Calculate Minor Gridlines
                                if (yAxis.minorGridLines.visible)
                                    sbYMinorGrid.append("M" + " " + (Math.floor(this.model.m_AreaBounds.X) + lineVal) + " " + (Math.floor((minorPointY * -1) + y1) + lineVal) + " " + "L" + " " + (Math.floor(this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) + lineVal) + " " + (Math.floor((minorPointY * -1) + y1) + lineVal) + " ");

                            }
                            logtickPos += logtickInterval;
                            minorTicks = ej.EjSvgRender.utils._logBase(logtickPos,yAxis.logBase);
                        }
                    } else {
                        for (var j = 0, minorTicks = tempInterval; j < yAxis.minorTicksPerInterval; j++) {

                            minorTicks += yAxis.visibleRange.interval / (yAxis.minorTicksPerInterval + 1);
                            if (minorTicks < yAxis.visibleRange.max && minorTicks > yAxis.visibleRange.min) {
                                  minorPointY = ((minorTicks - yAxis.visibleRange.min) / (yAxis.visibleRange.delta)) * (yAxis.height);
                              
                                // Calculate Minor Grid lines   
                                if (yAxis.minorGridLines.visible)
                                    sbYMinorGrid.append("M" + " " + (Math.floor(this.model.m_AreaBounds.X) + lineVal) + " " + (Math.floor((minorPointY * -1) + y1) + lineVal) + " " + "L" + " " + (Math.floor(this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) + lineVal) + " " + (Math.floor((minorPointY * -1) + y1) + lineVal) + " ");
                            }
                        }
                    }
                } 
                // Calculate Grid lines
                if (yAxis.majorTickLines.visible || yAxis.majorGridLines.visible) {
                    var mtVal = this._getSharpPath(yAxis.minorTickLines.width);
                    var mlVal = this._getSharpPath(yAxis.majorGridLines.width);
                   
                    // Calculate Major Grid lines
                    if (yAxis.majorGridLines.visible) {
                        pointY = ej.EjSvgRender.utils._getPointXY(tempInterval, yAxis.visibleRange, yAxis.isInversed) * (yAxis.height);
                        var mX1 = (Math.floor(this.model.m_AreaBounds.X) + mlVal);
                        var mY1 = (Math.floor((pointY * -1) + y1) );
                        var mX2 = (Math.floor(this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) + mlVal);
                        if (i == 0) {
                            if (mY1==Math.floor(this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height))
                                continue;
                            if (yAxis.zoomed)
                                yPoint[0] = mY1 + mlVal;
                            
                        }
                        if ((i == (yAxis.visibleLabels.length - 1)) && (this.model.chartArea.border.color != "transparent" && this.model.chartArea.border.width > 0)) {
                           
                            if (mY1 == (Math.floor(this.model.m_AreaBounds.Y))) {
                                yPoint.push(mY1 + mlVal);
                                continue;
                            }

                        }
                       
                        

                        sbYMajorGrid.append("M" + " " + mX1 + " " + (mY1 + mlVal) + " " + "L" + " " + mX2 + " " + (mY1 + mlVal) + " ");
                        if (i == 0) 
                            continue;
                        
                        yPoint.push(mY1 + mlVal);
                        
                    }
                }
            }
        }
        
        if (yAxis.alternateGridBand.odd.fill != "transparent" || yAxis.alternateGridBand.even.fill != "transparent") {
           
            var width = this.model.m_AreaBounds.Width;
            if (yAxis.zoomed) {
                yPoint[yPoint.length] = yAxis.y;
                
            }
            for (var i = 1; i < yPoint.length; i += 2) {
                var height = yPoint[0] - yPoint[1];
                if (i == yPoint.length - 1 && yAxis.zoomed) {
                    var zoomHeight = yPoint[yPoint.length - 2] - yAxis.y;
                    height = zoomHeight;
                }
                var yoptionsAlternateodd = {
                    'id': this.svgObject.id + '_YAxisAlternateodd' + [i],
                    'x': Math.floor(this.model.m_AreaBounds.X),
                    'y': yPoint[i],
                    'width': width,
                    'height': height,
                    'fill': yAxis.alternateGridBand.odd.fill,
                    'opacity': yAxis.alternateGridBand.odd.opacity,
                    'stroke' : "transparent",
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)'
                };
                this.svgRenderer.drawRect(yoptionsAlternateodd, gAgb);
            }
            
            for (var i = 0; i < yPoint.length; i += 2) {
                var height = yPoint[0] - yPoint[1];
                if (i == yPoint.length - 1 && yAxis.zoomed) {
                    var zoomHeight = yPoint[yPoint.length - 2] - yAxis.y;
                    height = zoomHeight;
                }
                if (i == 0 && yAxis.zoomed) {
                    var zoomHeight = yAxis.y + yAxis.height - yPoint[0] - yAxis.plotOffset;
                    height = zoomHeight;
                }
                var yoptionsAlternateeven = {
                    'id': this.svgObject.id + '_YAxisAlternateeven' + [i],
                    'x': Math.floor(this.model.m_AreaBounds.X),
                    'y': yPoint[i],
                    'width': width,
                    'height': height,
                    'fill': yAxis.alternateGridBand.even.fill,
                    'opacity': yAxis.alternateGridBand.even.opacity,
                    'stroke': "transparent",
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)'
                };
                this.svgRenderer.drawRect(yoptionsAlternateeven, gAgb);
            }
            $(gAgb).appendTo(gEle);
        }

     
        if (yAxis.minorGridLines.visible && yAxis.minorTicksPerInterval > 0) {
            //Drawning Minor Grid Lines
            yMinorGridDir = sbYMinorGrid.toString();
            var optionsMinorGrid = {
                'id': this.svgObject.id + '_YAxisMinorGridLines_' + axisIndex,
                'fill': 'none',
                'stroke-width': yAxis.minorGridLines.width,
                'stroke': yAxis.minorGridLines.color,
                'stroke-dasharray': yAxis.minorGridLines.dashArray,
                'd': yMinorGridDir
            };
            this.svgRenderer.drawPath(optionsMinorGrid, gEle);

        }

        //Drawing Major Grid Lines
        yMajorGridDir = sbYMajorGrid.toString();
        if (yAxis.majorGridLines.visible) {
            var options = {
                'id': this.svgObject.id + '_YAxisMajorGridLines_' + axisIndex,
                'fill': 'none',
                'stroke-width': yAxis.majorGridLines.width,
                'opacity': yAxis.majorGridLines.opacity,
                'stroke-dasharray': yAxis.majorGridLines.dashArray,
                'stroke': yAxis.majorGridLines.color,
                'd': yMajorGridDir
            };

            if(options.d != '')
                this.svgRenderer.drawPath(options, gEle);

        }
        $(gEle).appendTo(this.svgObject);
    },
	
	textOverflowMultiLevelLabels: function (axis, gap, text, textOverflow, font, labelSize, textOptions, gMultiLevelEle, chartObj) {
		var yVal = textOptions.y, count = 0;
		 if (textOverflow == "wrap" || textOverflow == "wrapandtrim") {
                collection = chartObj._wrap(axis, gap, text, textOverflow, font, labelSize);
                textCollection = collection["text"];
                rows = textCollection.length;
                for (j = 0; j < rows ; j++) {
					textOptions.y += labelSize.height;
					if (!chartObj.model.enable3D) {
						textOptions.id += "_" + j;
						chartObj.svgRenderer.drawText(textOptions, textCollection[j], gMultiLevelEle);
					}
                    if (textOverflow == "wrapandtrim" && textCollection[j].indexOf("...") > -1) {
						if (chartObj.model.enable3D && count == 0) 
							textOptions.y -= labelSize.height;
                        unTrimmedText = collection["unTrimmedText"];
                        labelSize = ej.EjSvgRender.utils._measureText(textCollection[j], null, font);
                        bounds = { X: textOptions.x - labelSize.width / 2, Y: textOptions.y, Width: labelSize.width, Height: labelSize.height };
                        chartObj.model.axisMultiLevelLabelRegions.push({ trimText: textCollection[j], labelText: unTrimmedText[count], Bounds: bounds });
                        count++;
                    }
                }
				return textCollection;
            } else {
                text = (textOverflow == "trim") ? ej.EjSvgRender.utils._trimText(actualText, gap, font) : actualText;
                // to store region
				if (!chartObj.model.enable3D) 
					yVal = textOptions.y +labelSize.height;
				if (axis.orientation.toLowerCase() == "vertical")
					yVal = textOptions.y -labelSize.height/4;
                labelSize = ej.EjSvgRender.utils._measureText(text, null, font);
                bounds = { X: textOptions.x - labelSize.width/2, Y: yVal, Width: labelSize.width, Height: labelSize.height };
                chartObj.model.axisMultiLevelLabelRegions.push({ trimText: text, labelText: actualText, Bounds: bounds });
				return text;
            }
	},
	
	_triggerMultiLevelLabelsRendering: function (text, x, y, textOverflow, font, border, chart){
		var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);          // trigger event
        commonEventArgs.data = {
                text: text, location: { x: x, y: y },
                textOverflow: textOverflow, font: font, border: border
            };
            chart._trigger("multiLevelLabelRendering", commonEventArgs);
			return commonEventArgs.data;
	},
	
    _drawXAxisMultiLevelLabels: function (axisIndex, xAxis) {          // to render x axis multi level labels
        // declaration 
        var i, j, x, y, rows, gap, labelSize, grpLabel, font, startX, startY, endX, textOptions, textOverflow,
            textCollection, borderOptions, border, style, alignment, svgId = this.svgObject.id, range = xAxis.visibleRange,
            gMultiLevelEle = this.svgRenderer.createGroup({ 'id': svgId + '_XAxisMultiLevelLabels' + '_' + axisIndex, 'clip-path': 'url(#' + this.svgObject.id +
			'_XAxis_Clippath_' + axisIndex + ")" }), areaBounds = this.model.m_AreaBounds, opposedPosition = xAxis.opposedPosition, borderWidth,
            labelPosition = xAxis.labelPosition.toLowerCase(), labelBorder = xAxis.labelBorder, padding = 10,
            scrollerSize = xAxis._isScroll ? this.model.scrollerSize :0;
            
        // create clip path
        startY = xAxis.majorTickLines.size + xAxis._LableMaxWidth.height + (labelBorder.width);
        clipX = areaBounds.X;
        clipY = xAxis.y + startY + scrollerSize;
        clipWidth = areaBounds.Width;
        clipHeight = xAxis._multiLevelLabelHeight + padding - 2;

        if (opposedPosition) {
            if (labelPosition == "outside")
                clipY = xAxis.y - startY - xAxis._multiLevelLabelHeight - padding / 2 - scrollerSize;
            else
                clipY = xAxis.y + startY - padding/2;
        } else {
            if (labelPosition == "inside")
                clipY = xAxis.y - startY - xAxis._multiLevelLabelHeight;
        }

        // to clip multi level labels
        var clipRectOptions = {
            'id': this.svgObject.id + '_XAxis_Clippath_' + axisIndex,
            'x': clipX,
            'y': clipY,
            'width': clipWidth,
            'height': clipHeight,
            'fill': 'white',
            'stroke-width': 1,
            'stroke': 'Gray'
        };
        this.svgRenderer.drawClipPath(clipRectOptions, gMultiLevelEle);
        
        for (i = 0; i < xAxis.multiLevelLabels.length; i++) {
          // assignment
          grpLabel = xAxis.multiLevelLabels[i];
          if (grpLabel.visible && ((grpLabel.start >= range.min && grpLabel.start <= range.max)
                || (grpLabel.end >= range.min && grpLabel.end <= range.max) ||
                    (grpLabel.start < range.min && grpLabel.end > range.max))) {
            font = grpLabel.font;
            border = grpLabel.border;
            borderWidth = border.width;
            level = grpLabel._level;
            textOverflow = grpLabel.textOverflow.toLowerCase();
            style = border.type.toLowerCase();
            alignment = grpLabel.textAlignment.toLowerCase();
            startX = Math.ceil(ej.EjSvgRender.utils._getPointXY(grpLabel.start, range, xAxis.isInversed) * (xAxis.width));
            endX = Math.ceil(ej.EjSvgRender.utils._getPointXY(grpLabel.end, range, xAxis.isInversed) * (xAxis.width));
			if (xAxis.isInversed){
				startX = startX - endX;
				endX = startX + endX;
				startX = endX - startX;
			}
            actualText = grpLabel.text;
            labelSize = ej.EjSvgRender.utils._measureText(actualText, null, font);
            gap = ej.util.isNullOrUndefined(grpLabel.maximumTextWidth) ? endX - startX - borderWidth - padding : grpLabel.maximumTextWidth - padding;
            rows = 1;
            count = 0;
            x = startX + xAxis.x + padding/2;
            y = startY + xAxis.y;
           
            // to position text
            if (opposedPosition) {
                if (labelPosition == "outside")
                    y = xAxis.y - startY - xAxis.multiLevelLabelHeight[level] - padding - xAxis.prevHeight[level] - scrollerSize;
                else
                    y = xAxis.y + startY - padding/2 + xAxis.prevHeight[level];
            } else {
                if (labelPosition == "inside")
                    y = xAxis.y - startY - xAxis.multiLevelLabelHeight[level] - xAxis.prevHeight[level];
                else
                    y = startY + xAxis.y + xAxis.prevHeight[level] + scrollerSize;
            }

            // to clip canvas
            if (this.model.enableCanvasRendering) {
                this.svgRenderer.ctx.save();
                this.svgRenderer.ctx.beginPath();
                this.svgRenderer.ctx.rect(clipX, clipY, clipWidth, clipHeight);
                this.svgRenderer.ctx.clip();
            }

            // text alignment calculation
            if (alignment == "center") {
                x += gap / 2;
                anchor = "middle";
            } else if (alignment == "far") {
                x = x + gap - borderWidth / 2;
                anchor = "end";
            } else {
                anchor = "start";
                x += borderWidth / 2;
            }
            
            var data = this._triggerMultiLevelLabelsRendering(actualText, x, y, textOverflow, font, grpLabel.border, this);
			actualText = data.text;
			x = data.location.x;
			y = data.location.y;
			textOverflow = data.textOverflow.toLowerCase();
			font = data.font;
			border = data.border;
			style = data.border.type.toLowerCase();
			borderWidth = data.border.width;
			
            // options required to render text
            textOptions = {
                'id': svgId + '_XAxisMultiLevelLabels_Text_' + axisIndex + '_' + i,
                'x': x,
                'y': style == "curlybrace" ? y + 10 : y,
                'fill': font.color ? font.color : xAxis.multiLevelLabelsFontColor,
                'font-size': font.size,
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'font-weight': font.fontWeight,
                'opacity': font.opacity,
                'text-anchor': anchor
            };
			text = actualText;
			// calculation for wrap and wrapbyword
			if (textOverflow != "none")
				text = this.textOverflowMultiLevelLabels(xAxis, gap, text, textOverflow, font, labelSize, textOptions, gMultiLevelEle, this);
			
			if (textOverflow != "wrap" && textOverflow != "wrapandtrim"){
				textOptions.y += labelSize.height;
				if (labelSize.height < xAxis.multiLevelLabelHeight[level])
					textOptions.y = textOptions.y + xAxis.multiLevelLabelHeight[level] / 2 - labelSize.height/2;
				this.svgRenderer.drawText(textOptions, text, gMultiLevelEle);   // to draw text
			}

            // border calculation
            if (opposedPosition) {
                if(labelPosition == "inside")
                    y = startY + xAxis.y + xAxis.prevHeight[level] - padding/2;
                else
                    y = xAxis.y - startY - xAxis.multiLevelLabelHeight[level] - padding + 2 - xAxis.prevHeight[level] - scrollerSize;
            } else {
                if (labelPosition == "inside")
                    y = xAxis.y - startY - xAxis.multiLevelLabelHeight[level] - 3 - xAxis.prevHeight[level];
                else
                    y = startY + xAxis.y + xAxis.prevHeight[level] + scrollerSize;
            }
            x = startX + xAxis.x;
            y += borderWidth;
            height = xAxis.multiLevelLabelHeight[level] + padding/2;
            width = gap + padding + borderWidth;
			
			// storing region for multi level labels click event
			var region = {bounds: {x: x, y: y, height: height, width: width }, axisIndex: axisIndex, multiLevelLabel: grpLabel};
			this.model.multiLevelLabelRegions.push(region);
			
            path = "";
            braceGap = ((width + borderWidth) - labelSize.width)/2 - 2;
            if (style == "rectangle") {
                borderOptions = {
                    'id': svgId + '_XAxisMultiLevelLabels_Rect_' + axisIndex + '_' + i,
                    'x': x,
                    'y': y,
                    'width': width,
                    'height': height,
                    'fill': "transparent",
                    'stroke': border.color ? border.color : xAxis.multiLevelLabelsColor,
                    'stroke-width': borderWidth,
                };
                this.svgRenderer.drawRect(borderOptions, gMultiLevelEle);
            } else {
                switch (style) {
                    case "withouttopandbottomborder":
                        path = "M " + x + " " + y + " L " + x + " " + (y + height) + 
                            " M " + (x + width) + " " + y + " L " + (x + width) + " " + (y + height);
						break;
					case "withouttopborder":
						if ((!opposedPosition && labelPosition == "outside") || (opposedPosition && labelPosition == "inside"))
							labelHeight = height;
						else
							labelHeight = 0;
						path = "M " + x + " " + (y + labelHeight) + " L " + (x + width) + " " + (y + labelHeight) + " M " + x + " " + y + " L " + x + " " + 
								(y + height) + " M " + (x + width) + " " + y + " L " + (x + width) + " " + (y + height);
                        break;
                    case "brace":
						if (alignment == "near"){
							var value = textOptions.x;
							value2 = textOptions.x + labelSize.width + 2;
						}
						else if (alignment == "center"){
							var value = textOptions.x - labelSize.width / 2 - 2 <= areaBounds.X + startX ? areaBounds.X + startX + padding : 
								textOptions.x - labelSize.width / 2 - 2;
							var value2 = textOptions.x + labelSize.width / 2 + 2 > areaBounds.X + endX ? areaBounds.X + endX - padding :
								textOptions.x + labelSize.width / 2 + 2
						} else{
							var value = textOptions.x - labelSize.width - 2;
							value2 = textOptions.x;
						}
                        if ((!opposedPosition && labelPosition == "outside") || (opposedPosition && labelPosition == "inside"))
                            path = "M " + x + " " + y + " L " + x + " " + (y + height / 2) +
                       " M " + x + " " + (y + height / 2) + " L " + (value - 2) + " " + (y + height / 2) +
                       " M " + (value2) + " " + (y + height / 2) + " L " + (x + width) + " " + (y + height / 2 ) +
                       " M " + (x + width) + " " + (y + height / 2) + " L " + (x + width) + " " + (y);
                        else
                            path = "M " + (x) + " " + (y + height) + " L " + (x) + " " + (y + height / 2) +
                                " M " + x + " " + (y + height / 2) + " L " + (value) + " " + (y + height / 2) +
                                " M " + (value2) + " " + (y + height / 2) + " L " + (x + width) + " " + (y + height / 2) + 
                                 " M " + (x + width) + " " + (y + height) + " L " + (x + width) + " " + (y + height/2);
                        break;
					case "curlybrace":        // using constant values to render a curely brace
						y = xAxis.y + startY + xAxis.prevHeight[level]; 
								if (width< 30){
									path = "M " + (x+width/2 -5) + " " + (y+10) + " L " + (x+width/2) + " " + (y+15) + " L " + (x+width/2 +5) + " " + (y+10);
								}
								else if (!opposedPosition){
									if (alignment == "center") {
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x+5) + " " + (y+10)  + " " + (x+10) + " " + (y+10) + 
										" L " + (x+ width/2 -5) + " " + (y+ 10) + " L " + (x+ width/2) + " " + (y+15)  +
										" L " + (x + width/2 +5) + " " + (y + 10) + " L " + (x + width-10)  + " " + (y +10) + 
										" C " + (x+width-10) + " " + (y + 10) + " " + (x+width) + " " + (y +5) + " " + (x+width) + " " + (y) ;
									} else if (alignment == "near"){
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x+5) + " " + (y+10)  + " " + (x+10) + " " + (y+10) + 
										" L " + (x+ 15) + " " + (y+15)  +
										" L " + (x +15 +5) + " " + (y + 10) + " L " + (x + width-10)  + " " + (y +10) + 
										" C " + (x+width-10) + " " + (y + 10) + " " + (x+width) + " " + (y +5) + " " + (x+width) + " " + (y) ;
									} else {
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x+5) + " " + (y+10)  + " " + (x+10) + " " + (y+10) + 
										" L " + (x+ width-20) + " " + (y+ 10) + " L " + (x+ width-15) + " " + (y+15)  +
										" L " + (x + width -10) + " " + (y + 10) + " L " + (x + width-10)  + " " + (y +10) + 
										" C " + (x+width-10) + " " + (y + 10) + " " + (x+width) + " " + (y +5) + " " + (x+width) + " " + (y);
									}
								}
								 else {
									path = "M " + x + " " + y + " C " + x + " " + y + " " + (x+5) + " " + (y+10)  + " " + (x+10) + " " + (y+10) + 
										" L " + (x+ width/2 -5) + " " + (y+ 10) + " L " + (x+ width/2) + " " + (y+15)  +
										" L " + (x + width/2 +5) + " " + (y + 10) + " L " + (x + width-10)  + " " + (y +10) + 
										" C " + (x+width-10) + " " + (y + 10) + " " + (x+width) + " " + (y +5) + " " + (x+width) + " " + (y) ;
								 }
						break;
                }
                if (path) {
                    borderOptions = {
                        'id': svgId + '_XAxisMultiLevelLabels_Rect_' + axisIndex + '_' + i,
                        'd': path,
                        'stroke': border.color ? border.color : xAxis.multiLevelLabelsColor,
                        'stroke-width': border.width,
						'fill':'none'
                    }
                    this.svgRenderer.drawPath(borderOptions, gMultiLevelEle);
                }
            }
            if (this.model.enableCanvasRendering)
                this.svgRenderer.ctx.restore();
				
            $(gMultiLevelEle).appendTo(this.gXaxisEle);
         }
        }
    },

    _drawYAxisMultiLevelLabels: function (axisIndex, yAxis) {          // to render y axis multi level labels
        // declaration 
        var i, j, x, y, rows, gap, labelSize, grpLabel, font, startX, startY, endX, textOptions, textOverflow, padding = 5,
            textCollection, borderOptions, border, style, alignment, svgId = this.svgObject.id, range = yAxis.visibleRange,
            gMultiLevelEle = this.svgRenderer.createGroup({ 'id': svgId + '_YAxisMultiLevelLabels' + '_' + axisIndex, 'clip-path': 'url(#' + this.svgObject.id +
			'_YAxis_Clippath_' + axisIndex + ")" }), anchor = "middle", areaBounds = this.model.m_AreaBounds, opposedPosition = yAxis.opposedPosition,
            labelPosition = yAxis.labelPosition.toLowerCase(), labelBorder = yAxis.labelBorder, multiLevelLabelWidth = yAxis._multiLevelLabelHeight,
            startX = yAxis.majorTickLines.size + yAxis._LableMaxWidth.width + (labelBorder.width) + 2 * padding,
              scrollerSize = yAxis._isScroll ? this.model.scrollerSize : 0;

	    // to clip the multi level labels
        clipY = yAxis.y;
        clipWidth = multiLevelLabelWidth + padding;
        clipHeight = yAxis.height + padding;
        if (opposedPosition) {
            if(labelPosition == "outside")
                clipX = yAxis.x + startX - padding + scrollerSize;
            else
                clipX = yAxis.x - multiLevelLabelWidth - startX  + padding;
        }
        else{
            if (labelPosition == "outside")
                clipX = yAxis.x - multiLevelLabelWidth - startX - scrollerSize;
            else
                clipX = yAxis.x + startX - padding;
        }
        var clipRectOptions = {
            'id': this.svgObject.id + '_YAxis_Clippath_' + axisIndex,
            'x': clipX,
            'y': yAxis.y,
            'width': clipWidth,
            'height': clipHeight,
            'fill': 'white',
            'stroke-width': 1,
            'stroke': 'Gray'
        };
        this.svgRenderer.drawClipPath(clipRectOptions, gMultiLevelEle);

        for (i = 0; i < yAxis.multiLevelLabels.length; i++) {
            // assignment
            grpLabel = $.extend(true, {}, this.model.multiLevelLabelsDefault, yAxis.multiLevelLabels[i]);
            if (grpLabel.visible && ((grpLabel.start >= range.min && grpLabel.start <= range.max)
                || (grpLabel.end >= range.min && grpLabel.end <= range.max) ||
                    (grpLabel.start < range.min && grpLabel.end > range.max))) {
                font = grpLabel.font;
                border = grpLabel.border;
                level = grpLabel._level;
				maximumTextWidth = grpLabel.maximumTextWidth;
                textOverflow = grpLabel.textOverflow.toLowerCase();
                style = border.type.toLowerCase();
                alignment = grpLabel.textAlignment.toLowerCase();
                startY = Math.ceil(ej.EjSvgRender.utils._getPointXY(grpLabel.start, range, yAxis.isInversed) * (yAxis.height));
                endY = Math.ceil(ej.EjSvgRender.utils._getPointXY(grpLabel.end, range, yAxis.isInversed) * (yAxis.height));
				if (yAxis.isInversed){
					startY = startY - endY;
					endY = startY + endY;
					startY = endY - startY;
				}
                actualText = grpLabel.text;
                labelSize = ej.EjSvgRender.utils._measureText(actualText, null, font);
                gap = endY - startY - border.width;
                space = ej.util.isNullOrUndefined(maximumTextWidth) ? yAxis.multiLevelLabelHeight[level] + padding : maximumTextWidth - padding;
                rows = 1; count = 0; textX = 0;
                x = yAxis.x - startX - yAxis.prevHeight[level] - yAxis.multiLevelLabelHeight[level]/2 + border.width - padding/2;
                y = yAxis.height + yAxis.y - startY - (gap/2);

                // for text position
                   if ((opposedPosition)) {
                    if (labelPosition == "outside")
                        x = yAxis.x + startX + yAxis.multiLevelLabelHeight[level] / 2 + yAxis.prevHeight[level] + border.width + scrollerSize;
                    else
                        x = yAxis.x - startX - yAxis.multiLevelLabelHeight[level] / 2 - yAxis.prevHeight[level] + border.width + padding / 2;
                }
                else {
                    if (labelPosition == "inside")
                        x = yAxis.x + startX + yAxis.multiLevelLabelHeight[level] / 2 + yAxis.prevHeight[level] - padding / 2;
                    else
                        x = x + textX - scrollerSize;
                }
                if (this.model.enableCanvasRendering) {
                    this.svgRenderer.ctx.save();
                    this.svgRenderer.ctx.beginPath();
                    this.svgRenderer.ctx.rect(clipX, clipY, clipWidth, clipHeight);
                    this.svgRenderer.ctx.clip();
                }

                // text alignment calculation
				if (alignment == "far") 
                    y =  y + gap/2 - labelSize.height/2 ;
                else if (alignment == "near")
                    y = y - gap/2 + labelSize.height ;
                else
					y = y + labelSize.height/4;
				data = this._triggerMultiLevelLabelsRendering(actualText, x, y, textOverflow, font, grpLabel.border, this);
				actualText = data.text;
				x = data.location.x;
				y = data.location.y;
				textOverflow = data.textOverflow;
				font = data.font;
				border = data.border;
				style = border.type.toLowerCase();
				borderWidth = border.width;
				
                // options required to render text
                textOptions = {
                    'id': svgId + '_YAxisMultiLevelLabels_Text_' + axisIndex + '_' + i,
                    'x': style == "curlybrace" ? (opposedPosition ? x + textX + 10 :  x + textX - 10) : x + textX ,
                    'y': y,
                    'fill': font.color ? font.color : yAxis.multiLevelLabelsFontColor,
                    'font-size': font.size,
                    'font-family': font.fontFamily,
                    'font-style': font.fontStyle,
                    'font-weight': font.fontWeight,
                    'opacity': font.opacity,
                    'text-anchor': anchor
                };

				text = actualText;
				// calculation for wrap and wrapandtrim
				if (textOverflow != "none")
					text = this.textOverflowMultiLevelLabels(yAxis, space, text, textOverflow, font, labelSize, textOptions, gMultiLevelEle, this);
				if (textOverflow != "wrap" && textOverflow != "wrapandtrim")
					this.svgRenderer.drawText(textOptions, text, gMultiLevelEle);   // to draw text
                x = x - padding / 2 - yAxis.multiLevelLabelHeight[level] / 2;
                y = yAxis.y + yAxis.height - endY + border.width;
                height = endY - startY;
                width = yAxis.multiLevelLabelHeight[level] + padding;
                path = "";
                braceGap = ((width + border.width) - multiLevelLabelWidth) / 2 - 2;

				// storing region for multi level labels click event
				var region = {bounds: {x: x, y: y, height: height, width: width }, axisIndex: axisIndex, multiLevelLabel: grpLabel};
				this.model.multiLevelLabelRegions.push(region);
			
                if (style == "rectangle") {
                    borderOptions = {
                        'id': svgId + '_YAxisMultiLevelLabels_Rect_' + axisIndex + '_' + i,
                        'x': x,
                        'y': y,
                        'width': width,
                        'height': height,
                        'fill': "transparent",
                        'stroke': border.color ? border.color : yAxis.multiLevelLabelsColor,
                        'stroke-width': border.width,
                    };
                    this.svgRenderer.drawRect(borderOptions, gMultiLevelEle);
                } else {
                    switch (style) {
                        case "withouttopandbottomborder":
                            path = "M" + " " + x + " " + (y + height) + " " + "L" + " " + (x + width) + " " + (y + height) + " " +
                                "M" + " " + x + " " + y + " " + "L" + " " + (x + width) + " " + y;
                            break;
						case "withouttopborder":
							if ((!opposedPosition && labelPosition == "outside") || (opposedPosition && labelPosition == "inside"))
								labelWidth = 0;
							else
								labelWidth = width;
							path = "M" + " " + x + " " + (y + height) + " " + "L" + " " + (x + width) + " " + (y + height) + " " +
                                "M" + " " + x + " " + y + " " + "L" + " " + (x + width) + " " + y + 
								" M" + " " + (x + labelWidth) + " " + (y + height) + " " + "L" + " " + (x + labelWidth) + " " + (y);
                            break;
                        case "brace":
						value1 = textOptions.y  - labelSize.height/2 - 4;
						value2 = textOptions.y + labelSize.height/4 + 2;
                            if ((!opposedPosition && labelPosition == "outside") || (opposedPosition && labelPosition == "inside"))
                                path = "M " + (x + width) + " " + y + " L " + (x + width / 2) + " " + y +
                                " M " + (x + width / 2) + " " + y + " L " + (x + width / 2) + " " + value1 +
                                " M " + (x + width / 2) + " " + value2 + " L " + (x + width / 2) + " " + (y + height) +
                                " M " + (x + width / 2) + " " + (y + height) + " L " + (x + width) + " " + (y + height);
                            else
                                path = "M " + (x) + " " + y + " L " + (x + width / 2) + " " + y +
                               " M " + (x + width / 2) + " " + y + " L " + (x + width / 2) + " " + value1 +
                               " M " + (x + width / 2) + " " + value2 + " L " + (x + width / 2) + " " + (y + height) +
                               " M " + (x + width / 2) + " " + (y + height) + " L " + (x) + " " + (y + height);
                            break;
						case "curlybrace":               // using constant values to render a curely brace
								x = yAxis.x - startX - yAxis.prevHeight[level];
						        newHeight = height - 10;
								if (height < 30){
									if (opposedPosition){
										x = yAxis.x + startX + yAxis.prevHeight[level];
									newHeight = height - 10;
										path = 
										" M " + (x+10) + " " + (y+ newHeight/2) + " " + " L " + (x+15) + " " + (y+ newHeight/2 + 5) +
										" L " + (x+10) + " " + (y+newHeight/2 + 10) ;
										}
									else
										path = "M " + (x-10) + " " + (y+height/2 -5) + " L " + (x-15) + " " + (y+height/2 ) + " L " + (x-10) + " " + (y+height/2 +5);
								} 
								else if (!opposedPosition){
									if (alignment == "center") {
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x-10) + " " + y  + " " + (x-10) + " " + (y+10) + 
										" L " + (x-10) + " " + (y+ newHeight/2) + " L " + (x-15) + " " + (y+ newHeight/2 + 5) +
										" L " + (x-10) + " " + (y+newHeight/2 + 10) + " L " + (x-10)  + " " + (y + newHeight) + 
										" C " + (x-10) + " " + (y + newHeight) + " " + (x-5) + " " + (y + newHeight+ 10) + " " + x + " " + (y + newHeight+ 10) ;
									} else if (alignment == "far"){
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x-10) + " " + y  + " " + (x-10) + " " + (y+10) + 
										" L " + (x-10) + " " + (y+ newHeight - 10) + " " + " L " + (x-15) + " " + (y+ newHeight - 10+ 5) +
										" L " + (x-10) + " " + (y+newHeight) + " L " + (x-10)  + " " + (y + newHeight) + 
										" C" + (x-10) + " " + (y + newHeight) + " " + (x -10) + " " + (y + newHeight+ 10) + " " + x + " " + (y + newHeight+ 10) ;
									} else {
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x-10) + " " + y  + " " + (x-10) + " " + (y+10) + 
										" L " + (x-15) + " " + (y +10 + 5) +
										" L " + (x-10) + " " + (y+10 + 10) + " L " + (x-10)  + " " + (y + newHeight) + 
										" C" + (x-10) + " " + (y + newHeight) + " " + (x-5) + " " + (y + newHeight+ 10) + " " + x + " " + (y + newHeight+ 10) ;
									}
								} else {
									x = yAxis.x + startX + yAxis.prevHeight[level];
									newHeight = height - 10;
										path = "M " + x + " " + y + " C " + x + " " + y + " " + (x+10) + " " + y  + " " + (x+10) + " " + (y+10) + 
										" L " + (x+10) + " " + (y+ newHeight/2) + " " + " L " + (x+15) + " " + (y+ newHeight/2 + 5) +
										" L " + (x+10) + " " + (y+newHeight/2 + 10) + " L " + (x+10)  + " " + (y + newHeight) + 
										" C" + (x+10) + " " + (y + newHeight) + " " + (x+5) + " " + (y + newHeight+ 10) + " " + x + " " + (y + newHeight+ 10) ;
								}
                    }
                    if (path) {
                        borderOptions = {
                            'id': svgId + '_YAxisMultiLevelLabels_Rect_' + axisIndex + '_' + i,
                            'd': path,
                            'stroke': border.color ? border.color : yAxis.multiLevelLabelsColor,
                            'stroke-width': border.width,
							'fill': "none"
                        }
                        this.svgRenderer.drawPath(borderOptions, gMultiLevelEle);
                    }
                }
                if (this.model.enableCanvasRendering)
                    this.svgRenderer.ctx.restore();
                $(gMultiLevelEle).appendTo(this.gYaxisEle);
            }
        }
    },

    _drawXAxisLabels: function (axisIndex, xAxis) {
        var gTickEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisLabels' + '_' + axisIndex, 'cursor': 'default' }),
            gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisLabels' + '_' + axisIndex, 'cursor': 'default' }),
            prevLabels = [],
            bounds, areaBounds = this.model.m_AreaBounds,
            labelSize,
            axisName = (xAxis.name).replace(/[^a-zA-Z0-9]/g, ""),
        	isScroll = xAxis._isScroll && !(xAxis.scrollbarSettings.pointsLength != null && xAxis.scrollbarSettings.pointsLength < xAxis.maxPointLength);
        var opposedPosition = xAxis._opposed, valueType = xAxis._valueType, pixel = 3, xAxisAignment = xAxis.alignment.toLowerCase(), x;
        if (axisIndex != 0 && ((xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition == 'inside')||(xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition != 'inside')) && (!(xAxis.y == (areaBounds.Height + areaBounds.Y) || (xAxis.y == areaBounds.Y)))) {

            xAxis.y = (!opposedPosition) ? Math.floor(xAxis.y + xAxis._LableMaxWidth.height) : Math.floor(xAxis.y - xAxis._LableMaxWidth.height);
        }
        else if (axisIndex != 0 && (xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition == 'inside') && (!(xAxis.y == (areaBounds.Height + areaBounds.Y) || (xAxis.y == areaBounds.Y)))) {
            xAxis.y = (!opposedPosition) ? Math.floor(xAxis.y+xAxis.majorTickLines.size) : Math.floor(xAxis.y-xAxis.majorTickLines.size);
        }
        else{
			xAxis._y = Math.floor(xAxis.y);//to store the current positons of the labels,before the property showNextToAxisLine as false.
			xAxis.y = (!xAxis.showNextToAxisLine) ? opposedPosition ? Math.floor(areaBounds.Y) : Math.floor(areaBounds.Height + areaBounds.Y) : Math.floor(xAxis.y);
		}
       
        // loop to draw labels
        for (var i = 0; i < xAxis.visibleLabels.length; i++) {
            var label = xAxis.visibleLabels[i];
            var labelText = label.displayText = ej.util.isNullOrUndefined(label.displayText) ? label.Text : label.displayText;
            if (ej.EjSvgRender.utils._inside(label.Value, xAxis.visibleRange)) {
                //Declaration
                var textanchor = null, newGapVal1, newGapVal2, nextPointX, nextLabel, nextLabelValue;
                var textcollection = [];
                    var gap = xAxis.width / xAxis.visibleLabels.length;       //space between ticks
					 var trimGap = xAxis.maximumLabelWidth // this holds maximumLabelWidth value      
                    var range = xAxis.visibleRange;
                    var areaBoundWidth = areaBounds.Width;
					if(!ej.isNullOrUndefined(xAxis.valueType)){
                    if (i<xAxis.visibleLabels.length-1 && xAxis.valueType.toLowerCase() == "datetimecategory" && xAxis.labelIntersectAction == "wrap" && xAxis.labelPlacement.toLowerCase() == "betweenticks")
                    {
                        nextLabel = xAxis.visibleLabels[i + 1];
                        label.Value -= .5;
                        nextLabelValue = nextLabel.Value - .5;
                    }
					}
                    var pointX = Math.abs(Math.floor(ej.EjSvgRender.utils._getPointXY(label.Value, range, xAxis.isInversed) * (xAxis.width)));
					if(!ej.isNullOrUndefined(xAxis.valueType)){
                    if (i < xAxis.visibleLabels.length - 1 && xAxis.valueType.toLowerCase() == "datetimecategory" && xAxis.labelIntersectAction == "wrap" && xAxis.labelPlacement.toLowerCase() == "betweenticks") {
                        nextPointX = Math.abs(Math.floor(ej.EjSvgRender.utils._getPointXY(nextLabelValue, range, xAxis.isInversed) * (xAxis.width)));
                        newGapVal1 = (i == 0) ? (xAxis.x + pointX) + (xAxis.majorTickLines.width - 0.5) : (xAxis.x + pointX) + (xAxis.majorTickLines.width + 0.5);
                        newGapVal2 = (xAxis.x + nextPointX) + (xAxis.majorTickLines.width + 0.5);
                        gap = newGapVal2 - newGapVal1;
                    }
                    else if (xAxis.valueType.toLowerCase() == "datetimecategory" && xAxis.labelIntersectAction == "wrap" && xAxis.labelPlacement.toLowerCase() == "betweenticks") {
                        gap = (xAxis.width + xAxis.x) - newGapVal2;
                        newGapVal1 = newGapVal2;
                    }
                    else if (xAxis.valueType.toLowerCase() == "datetimecategory" && xAxis.labelIntersectAction == "wrap" && xAxis.labelPlacement.toLowerCase() == "onticks") {
                        gap = xAxis.width / xAxis.labels.length;
                    }
					}					
                    xAxis._gap = newGapVal1;
                    var textSize = ej.EjSvgRender.utils._measureText(labelText, areaBoundWidth, xAxis.font);      
                    var textWidth = textSize.width;
                    var textHeight = textSize.height;
                    var labelMaxWidth = xAxis._LableMaxWidth;
                    var labelMaxHeight = labelMaxWidth.height;
                    var labelMaxRow = labelMaxWidth.rows;
                    var vmlrendering = this.svgRenderer.vmlNamespace;                    
                    var lineWidth = xAxis.axisLine.width;
                    var font = xAxis.font;
					var labelIntersectAction = xAxis.labelIntersectAction;
                    var labelPlacement = xAxis.labelPlacement.toLowerCase();
					var labelRotation = xAxis.rotationValue;
                    var count = 0;
                    var flag = false;
                    this.edgeLabel = false; // flag to find the supprot for edge labels
                    var chartAreaWidth =areaBounds.Width;
                    var chartAreaX = areaBounds.X;
                    var intersectAction = xAxis.labelIntersectAction.toLowerCase();
                    var svgWidth = $(this.svgObject).width(), maxLineWidth;
                    //To Perform trim 
                    if (intersectAction == "trim" || xAxis.enableTrim) {
                        if (labelPlacement == "onticks" && i != xAxis.visibleLabels.length -1) {
                            var nextLabel = xAxis.visibleLabels[i+1];
                            var nextPoint = Math.abs(Math.floor(ej.EjSvgRender.utils._getPointXY(nextLabel.Value, range, xAxis.isInversed) * (xAxis.width)));
                            var nextTextWidth = ej.EjSvgRender.utils._measureText(nextLabel.Text, areaBoundWidth, xAxis.font).width;
                            var value = nextPoint - nextTextWidth / 2;
                            var count = 0, current = false;
                            while (value < pointX + textWidth / 2 &&  count<2) {             // intersect
                                count++; 
                                if (nextTextWidth > textWidth) {                            // getting max label
                                    otherLabel = trimLabel = nextLabel;
                                    current = false;
                                }
                                else {
                                    trimLabel = label;
                                    current = true;
                                }
                                var trimLabelText = trimLabel.displayText = trimLabel.Text.toString();
                                for (var t = 1; t < trimLabelText.length; t++) {
                                    trimLabelText = trimLabel.displayText.substring(0, t) + '... ';
                                    newTextWidth = ej.EjSvgRender.utils._measureText(trimLabelText, areaBoundWidth, font).width;
                                    if (!current) {                                                  // to trim next label
                                        value = nextPoint - newTextWidth / 2;
                                        if (value < pointX + textWidth / 2) {
                                            if (t - 1 != 0) 
                                                trimLabelText = trimLabelText.toString().substring(0, t - 1) + '... ';
                                            nextTextWidth = newTextWidth;
                                            trimLabel.displayText = trimLabelText;
                                            break;
                                        }
                                    }
                                    else {                                                           // to trim current label
                                        value = nextPoint - nextTextWidth / 2;
                                        if (value < pointX + newTextWidth / 2) {
                                            if (t - 1 != 0) 
                                                trimLabelText = trimLabelText.toString().substring(0, t - 1) + '... ';
                                            textWidth = newTextWidth;
                                            labelText = trimLabel.displayText = trimLabelText;
                                            break;
                                        }
                                    }
                                }
                            }
                        } else if (labelPlacement == "betweenticks") {
                            var derivedGap = (xAxis.enableTrim) ? trimGap : gap;
                        if (textWidth > derivedGap && labelText != "") { // check textwidth is greater than gap
                            for (var t = 1; t < labelText.toString().length; t++) {
                                labelText = label.displayText.toString().substring(0, t) + '... ';
                                textWidth = ej.EjSvgRender.utils._measureText(labelText, areaBoundWidth, font).width;                                
                                if (textWidth >= derivedGap) {
                                    labelText = labelText.toString().substring(0, t - 1) + '... ';
                                    label.displayText = labelText;
                                    if (i == xAxis.visibleLabels.length - 1) {
                                        if (((pointX + xAxis.x) + (textWidth / 2) > (svgWidth)) && derivedGap==gap ) {
                                            derivedGap -= (textWidth / 2);
                                            t = 1;
                                            continue;
                                        }
                                    }
                                    break;
                                }
                            }
                            label.displayText = labelText; // trimed text is assigned to displayText
                        }
                      }
                    }
                 var textSize = ej.EjSvgRender.utils._measureText(label.displayText, areaBoundWidth, font);                    
                 var anchor = textSize.width / 2;
                 if (xAxis.majorGridLines.width > xAxis.majorTickLines.width)
                     maxLineWidth = xAxis.majorGridLines.width
                 else  maxLineWidth = xAxis.majorTickLines.width;
                 if (!ej.util.isNullOrUndefined(label.Text)) {
                     if (xAxisAignment == "near")
                         x = pointX + xAxis.x + maxLineWidth + ((valueType == "category" && labelPlacement != "onticks") ? -(xAxis.width / xAxis.actualRange.delta) / 2 + pixel : -textSize.width - pixel);
                     else if (xAxisAignment == "far")
                         x = (pointX + xAxis.x) + ((valueType == "category" && labelPlacement != "onticks") ? +((xAxis.width / xAxis.actualRange.delta) / 2) - textSize.width : +maxLineWidth + pixel);
                     else     
                         x = pointX + xAxis.x - anchor;
                    if ((xAxis.labelPosition == "inside" && xAxis.tickLinesPosition == 'inside') || ((xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition != 'inside') && xAxis.labelIntersectAction == 'multiplerows'))
                    {                        
                        y = (opposedPosition) ? (xAxis.y + xAxis.majorTickLines.size + textHeight / 2 + (lineWidth / 2)
                       + (labelMaxHeight / (2 * labelMaxRow)) - 5) : (xAxis.y - xAxis.majorTickLines.size - (lineWidth / 2)
                      - (labelMaxHeight / (2 * labelMaxRow)) + 5);
                    }                        
                    else if (xAxis.labelPosition == 'inside'&& xAxis.tickLinesPosition!='inside')
                    {                        
                          y = (opposedPosition) ? (xAxis.y + textHeight / 2 + (lineWidth / 2)
                       + (labelMaxHeight / (2 * labelMaxRow)) - 5) : (xAxis.y - (lineWidth / 2)
                      - (labelMaxHeight / (2 * labelMaxRow)) + 5);                    
                    }
                    else if ((xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition != 'inside') || ((xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition == 'inside') && xAxis.labelIntersectAction == 'multiplerows')) {
                        var y = (opposedPosition) ? (xAxis.y - xAxis.majorTickLines.size + textHeight / 2 - (lineWidth / 2)
                            - (labelMaxHeight / (2 * labelMaxRow)) - 5) : (xAxis.y + xAxis.majorTickLines.size + (lineWidth / 2)
                            + (labelMaxHeight / (2 * labelMaxRow)) + 5);
                        y = y + ((isScroll ? (opposedPosition ? -this.model.scrollerSize: this.model.scrollerSize): 0 ));
                    }
                    else if (xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition == 'inside')
                    {                      
                            var y = (opposedPosition) ? (xAxis.y + textHeight / 2 - (lineWidth / 2)
                             - (labelMaxHeight / (2 * labelMaxRow)) - 5) : (xAxis.y + (lineWidth / 2)
                             + (labelMaxHeight / (2 * labelMaxRow)) + 5);                       
                            y = y + ((isScroll ? (opposedPosition ? -this.model.scrollerSize : this.model.scrollerSize) : 0));
                    }
                   
                    
                    if (xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition != 'inside') {
                        if (xAxis.labelRotation == 90 || xAxis.labelIntersectAction == 'rotate90')
                            y = (opposedPosition) ? y  : y - xAxis.majorTickLines.size;
                    }
                    else if (xAxis.labelPosition != 'inside' && xAxis.tickLinesPosition == 'inside') {
                        if (xAxis.labelRotation == 90 || xAxis.labelIntersectAction == 'rotate90')
                            y = (opposedPosition) ? y - xAxis.majorTickLines.size : y - xAxis.majorTickLines.size;
                    }
                    else if (xAxis.labelPosition == 'inside' && xAxis.tickLinesPosition == 'inside') {
                        if (xAxis.labelRotation == 90 || xAxis.labelIntersectAction == 'rotate90')
                            y = (opposedPosition) ? y : y - xAxis.majorTickLines.size;
                    }

                        var options = {
                            'id': this.svgObject.id + '_' + axisName + '_XLabel_' + i,
                            'x': x,
                            'y': y,
                            'fill': font.color,
                            'font-size': font.size,
                            'font-family': font.fontFamily,
                            'font-style': font.fontStyle,
                            'font-weight': font.fontWeight,
                            'opacity': font.opacity
                        };
              
                    // To set position of edge labels
                        if (xAxis.edgeLabelPlacement) {
                            var position = xAxis.edgeLabelPlacement.toLowerCase();
                            var lastLabel = xAxis.visibleLabels.length - 1;
                            switch (position) {
                                case "none":
                                    break;
                                case "shift":
                                    {
                                        if (i == 0) {  // Shift first label
                                            if (options.x < xAxis.x) {
                                                var diff = xAxis.x - options.x;
                                                options.x = x = options.x + diff;
                                                this.diff = diff;
                                                this.edgeLabel = true;
                                            }
                                        } else if (i == lastLabel)  // Shift last label
                                            if (options.x + textSize.width > xAxis.x + xAxis.width) {
                                                diff = (options.x + textSize.width) - (xAxis.x + xAxis.width);
                                                options.x = x = options.x - diff;
                                                this.diff = diff;
                                                this.edgeLabel = true;
                                            }
                                        break;
                                    }
                                  case "hide": // to hide the edge labels
                                    if ((i == 0 && options.x < xAxis.x) || (i == lastLabel && options.x + textWidth >  chartAreaWidth + chartAreaX)) {
                                        labelText = "";
                                    }
                            }
                        }
                    //To perform rotation             
                         if (labelRotation != 0 && !vmlrendering)
                             this.labelRotation(xAxis, x + anchor, y, options, label, labelRotation);                                                     

                    //To perform labelIntersect Actions none , wrap, hide ,multiplerows
                         if (xAxis.labelIntersectAction || xAxis.enableTrim) {
                            this.diff = ej.util.isNullOrUndefined(this.diff) ? 0 : this.diff;
                            var intersectAction = xAxis.labelIntersectAction.toLowerCase();
                            if (intersectAction == 'none' && !xAxis.enableTrim) { 
                               
                                this.svgRenderer.drawText(options, labelText, gTickEle);
								 //create region to chart axis labels
                                xAxis.visibleLabels[i].region = this.calculateRegion(labelText, font, options, label);
                                this.model.xAxisLabelRegions.push(xAxis.visibleLabels[i].region)
                                if(xAxis.labelPosition=='inside')
                                    $(gTickEle).appendTo(this.gXaxisTickEle);
                                else
                                    $(gTickEle).appendTo(this.gXaxisEle);
                                continue;
                            } 
                            else if (intersectAction == 'wrap' || intersectAction == 'wrapbyword') {
                                
                                var line = 0,
                                    textcoll = this.rowscalculation(labelText.toString(), areaBoundWidth, xAxis, gap, options),
                                    count = textcoll.length,
                                    displayText = '';

                                if (xAxis.labelPosition != 'inside')
                                    options.y = opposedPosition ? options.y + textHeight : options.y - textHeight;
                                else
                                    options.y = opposedPosition ? options.y - textHeight : options.y - textHeight * (count);

                                for (k = 0; k < textcoll.length; k++)
                                {
                                    if (xAxis.labelPosition != 'inside')
                                    {
                                        options.y = opposedPosition ? options.y - (textHeight) : options.y + (textHeight);
                                        this.svgRenderer.drawText(options, textcoll[k], gTickEle);
                                    }
                                    else
                                    {                                        
                                        options.y = opposedPosition ? options.y + (textHeight) : options.y + (textHeight);
                                        this.svgRenderer.drawText(options, textcoll[k], gTickEle);
                                        count -= 1;
                                    }

                                    displayText = displayText + textcoll[k];
                                }
                                
                                labelSize = ej.EjSvgRender.utils._measureText(labelText, null, font);
                                var textheight = labelSize.height * count;                        
                                bounds = { x: options.x, y: options.y, width: labelSize.width, height: (count) * textheight };
                                xAxis.visibleLabels[i].region = { bounds: bounds, labelText: label.Text, displayText: displayText };
                                xAxis.visibleLabels[i].displayText = displayText;
                                this.model.xAxisLabelRegions.push(xAxis.visibleLabels[i].region)
                                continue;
                            } 
                            else if (intersectAction == 'hide') {
                                var xAxisLabelLength = xAxis.visibleLabels.length - 1;
                                for (var j = 0; j < i; j++) {
                                    // loop to get previous label
                                    var preLabel = xAxis.visibleLabels[j];
                                    var temp = 0;
                                    areaBoundWidth = areaBounds.Width;
                                   
                                    var prePoint = Math.abs(Math.floor(ej.EjSvgRender.utils._getPointXY(preLabel.Value, range, xAxis.isInversed) * (xAxis.width)));
                                    var preTextWidth = ej.EjSvgRender.utils._measureText(preLabel.displayText, areaBoundWidth, xAxis.font).width;
                                    var value = prePoint + ((xAxis.isInversed) ? -preTextWidth / 2 : preTextWidth / 2);
                                    value = (j == 0) ? value + this.diff : value;
                                    var width = (preTextWidth == 0) ? preTextWidth : textWidth;
                                    if ((i != xAxisLabelLength)|| (i == xAxisLabelLength && textWidth <= preTextWidth))
                                        width = width / 2;
                                    if (intersectAction == 'hide' && ((xAxis.isInversed) ? (value < pointX + width) : (value > pointX - width)))
                                        label.displayText = labelText = '';
                                }
                            }
                            else if(intersectAction == 'multiplerows'){ // to perform multipleRows on intersect
                                for (var k = 0; k < prevLabels.length && !flag; k++) {
                                    var xAxisLabelLength = xAxis.visibleLabels.length - 1;
                                    if (i != xAxisLabelLength)
                                        textWidth = textWidth / 2;
                                    for (var l = 0; prevLabels[k] && l < prevLabels[k].length; l++) {
                                        var preLabel = prevLabels[k][l];
                                        var temp = 0;
                                        areaBoundWidth =areaBounds.Width;

                                        var prePoint = Math.abs(Math.floor(ej.EjSvgRender.utils._getPointXY(preLabel.Value, range, xAxis.isInversed) * (xAxis.width)));
                                        var preTextWidth = ej.EjSvgRender.utils._measureText(preLabel.displayText, areaBoundWidth, xAxis.font).width;
                                        var value = prePoint + ((xAxis.isInversed) ? -preTextWidth / 2 : preTextWidth / 2);
                                        if (this.edgeLabel || prevLabels.length==1) {
                                            value = value + this.diff;
                                        }
                                        if ((xAxis.isInversed) ? (value < pointX + textWidth) : (value > pointX - textWidth)) {
                                            if (opposedPosition) {
                                                if (xAxis.labelPosition != 'inside')
                                                    temp = options.y - textHeight;
                                                else
                                                    temp = options.y + textHeight;
                                                options.y = temp;
                                                if (k + 1 == prevLabels.length)
                                                    flag = true;
                                                count++;
                                                break;
                                            } else {
                                                if (xAxis.labelPosition != 'inside')
                                                    temp = options.y + textHeight;
                                                else
                                                    temp = options.y - textHeight;
                                                options.y = temp;
                                                if (k + 1 == prevLabels.length)
                                                    flag = true;
                                                count++;
                                                break;
                                              
                                            }
                                        }
                                        else {
                                            if (l + 1 == prevLabels[k].length) {
                                                flag = true;
                                                break;
                                            }
                                        }                           
                                    }
                                }
                                if (temp == undefined) {
                                    if (prevLabels[0] == undefined)
                                        prevLabels[0] = [];
                                    prevLabels[0].push(label);
                                }
                                else {                                  
                                    if (prevLabels[count] == undefined)
                                        prevLabels[count] = [];
                                    prevLabels[count].push(label);
                                }
                         }         
                        }                  
                    if ((!this.edgeLabel) && !this.zoomed && !xAxis.zoomed && !(labelRotation) && !(labelIntersectAction == "rotate90") && !(labelIntersectAction == "rotate45") && (((pointX + xAxis.x) + (textWidth/2)) > ($(this.svgObject).width()))) {
                        $(options).attr('x', ($(this.svgObject).width() - 2));
                        $(options).attr('text-anchor', 'end');
                    }
					xAxis.visibleLabels[i].y = options.y;
					
					if(this.model.enableCanvasRendering && xAxis.labelPosition == "inside" && (xAxis.labelIntersectAction == "rotate45" || xAxis.labelIntersectAction == "rotate90")){
					options.y = options.y - textWidth;
					}
					
                    this.svgRenderer.drawText(options, labelText, gTickEle);
					 //create region to chart axis labels
                    
					 xAxis.visibleLabels[i].region = this.calculateRegion(labelText, font,options,label);
                    this.model.xAxisLabelRegions.push( xAxis.visibleLabels[i].region)
                }
            }
        }
        $(gTickEle).appendTo(this.gXaxisEle);

    },
	calculateRegion: function (labelText, font, options, label) {
        var labelSize = ej.EjSvgRender.utils._measureText(labelText, null, font);
        var bounds = { x: options.x, y: options.y, width: labelSize.width, height: labelSize.height };
        var xAxisLabelRegions = { bounds: bounds, trimText: labelText, labelText: label.Text };
        return xAxisLabelRegions;
    },
    rowscalculation: function (labelText, areaBoundWidth,xAxis,gap,options)
    {
        var measureText = ej.EjSvgRender.utils._measureText,
            font = xAxis.font,
            textSize = measureText(labelText, areaBoundWidth, font),
            textWidth = textSize.width,
            anchor = textWidth / 2,
            text = labelText.toString(),
            textLength = text.length,
            textcollection = [],
            i = 0,
            intersectAction = xAxis.labelIntersectAction,
            labelCollection = labelText.split(' '),
            labelCollectionLength = labelCollection.length;

        if (this.edgeLabel) gap = (i == 0) ? gap - this.diff : gap;

        if (textWidth > gap) {
            options.x = options.x + anchor;
            line = 0;
            if (this.edgeLabel) options.x = (i == 0) ? options.x - this.diff : options.x + this.diff;
        }

        if (intersectAction == 'wrap') {
            if (textWidth > gap) {
                for (var w = 1; w <= text.length; w++) {
                    labelText = text.substring(0, w);
                    textWidth = measureText(labelText, areaBoundWidth, font).width;
                    if (textWidth > gap) {
                        line = line + 1; // To find the no of rows splitted
                        labelText = text.substring(0, w - 1);
                        textcollection[i] = labelText;
                        text = text.slice(w - 1, textLength);
                        currentTextCollextion = text.split(' ');
                        text = labelCollection.indexOf(currentTextCollextion[0]) > -1 ? text : '-' + text;
                        var newTextWidth = measureText(labelText, areaBoundWidth, font).width;
                        if (line == 1) options.x = options.x - newTextWidth / 2;
                        i++;
                        w = 0;
                    }
                }
            }
            options.x = (xAxis.valueType == "datetimeCategory" && xAxis.labelPlacement.toLowerCase() == "betweenticks") ? xAxis._gap : options.x;
            textcollection[i] = labelText;
        }
        else {
            var max = 0, word, currentWidth, nextWidth;

            for (var i = 0; i < labelCollectionLength; i++) {
                word = labelCollection[i];
                currentWidth = measureText(word, areaBoundWidth, font).width;
                if (currentWidth < gap && textWidth > gap) {
                    while (i < labelCollectionLength) {
                        currentWidth = measureText(word, areaBoundWidth, font).width;
                        nextWidth = (labelCollection[i + 1]) ? measureText(labelCollection[i + 1], areaBoundWidth, font).width : 0;
                        if ((currentWidth + nextWidth) <= gap && nextWidth > 0) {
                            word = word.concat(' ' + labelCollection[i + 1]);
                            i++;
                        }
                        else {
                            // find the maximum width of the lines
                            max = Math.max(max, currentWidth);
                            break;
                        }
                    }
                    textcollection.push(word);
                }
                else {
                    if (textWidth > gap) {
                        word = ej.EjSvgRender.utils._trimText(word, gap, font);
                        newTextWidth = measureText(word, areaBoundWidth, font).width;
                        max = Math.max(max , newTextWidth)
                        textcollection.push(word);
                    } else {
                        textcollection.push(labelText);
                        break;
                    }
                }
            }
            options.x = options.x - max / 2;
        }
        
        return textcollection;
    },

    labelRotation: function (axis, x, y, options, label, degree, i) {
            var opposedPosition = axis._opposed;
	        // To rotate axis labels
	        var labelText = (label.displayText) ? label.displayText : label.Text;
            var angle = (degree > 360) ? degree - 360 : (degree < -360) ? degree + 360 : degree;
            var rotate = 'rotate(' + angle + ',' + (x) + ',' + y + ')';
            $(options).attr('transform', rotate);
            $(options).attr('labelRotation', angle);
            $(options).attr('labelPosition', axis.labelPosition);
            var textElement = this.svgRenderer.createText(options, labelText);
            var diffHeight = Math.ceil(ej.EjSvgRender.utils._measureBounds(textElement, this).height - ej.EjSvgRender.utils._measureText(labelText, null, axis.font).height);
            diffHeight = axis._LableMaxWidth.height - diffHeight - ej.EjSvgRender.utils._measureText(labelText, null, axis.font).height;
            
        if(axis.labelPosition!='inside')
            var yLocation = (opposedPosition) ? (diffHeight / 2) : (-diffHeight / 2);
        else
            var yLocation = (opposedPosition) ? (-diffHeight / 2) : (diffHeight / 2);

        rotate = 'rotate(' + angle + ',' + (x) + ',' + (y + yLocation) + ')';
        if (this.edgeLabel && degree == 90)               
            y = (i == 0) ? options.y + this.diff : options.y - this.diff;
       
	        $(options).attr({
                'transform' :rotate,
                'y': (y + yLocation)
            });
        },
		
    _drawYAxisLabels: function (axisIndex, yAxis) {
        // method to draw y axis labels
        //if(yAxis.labelPosition=='inside')
        var axisName = (yAxis.name).replace(/[^a-zA-Z0-9]/g, ""),
            gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisLabels' + '_' + axisIndex, 'cursor': 'default' }),
            labelSize,
            yAxisLabelRegions, opposedPosition = yAxis._opposed,
            bounds,
            regionX, areaBounds = this.model.m_AreaBounds,
            requireInvertedAxes = this.model.requireInvertedAxes,
         	isScroll = yAxis._isScroll && !(yAxis.scrollbarSettings.pointsLength != null && yAxis.scrollbarSettings.pointsLength < yAxis.maxPointLength),
            yAxisAlignment = yAxis.alignment.toLowerCase(), pixel = 3, y;
        if (axisIndex != 1 && ((yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition == 'inside') || (yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition != 'inside'))&& !((yAxis.x == (areaBounds.Width + areaBounds.X)) || (yAxis.x == (areaBounds.X))))
        {
            yAxis.x = (!opposedPosition) ? (yAxis.showNextToAxisLine) ? Math.floor(yAxis.x) : Math.floor(yAxis.x - yAxis._LableMaxWidth.width - this.model.elementSpacing) : Math.floor(yAxis.x + yAxis._LableMaxWidth.width + this.model.elementSpacing);
        }
        else if (axisIndex != 1 && (!(yAxis.x == (areaBounds.Width + areaBounds.X)) || (yAxis.x == (areaBounds.X))) && (yAxis.labelPosition!='inside' && yAxis.tickLinesPosition=='inside'))
        {
            yAxis._x = Math.floor(yAxis.x);
            yAxis.x = (!opposedPosition) ? !yAxis.showNextToAxisLine ? Math.floor(areaBounds.X) : Math.floor(yAxis.x - yAxis.majorTickLines.size) : Math.floor(yAxis.x + yAxis.majorTickLines.size);
        }
        else
        {
			yAxis._x = Math.floor(yAxis.x);//to store the current positons of the labels,before the property showNextToAxisLine as false.
			yAxis.x = (!yAxis.showNextToAxisLine) ? opposedPosition ? Math.floor(areaBounds.X + areaBounds.Width) :  Math.floor(areaBounds.X): Math.floor(yAxis.x);
        }   
      
        for (var i = 0; i < yAxis.visibleLabels.length; i++) {
            var label = yAxis.visibleLabels[i];
			var visibleRange = yAxis.visibleRange;
			if (ej.EjSvgRender.utils._inside(label.Value, visibleRange)) {
			    var pointY = Math.abs(ej.EjSvgRender.utils._getPointXY(label.Value, visibleRange, yAxis.isInversed) * (yAxis.height));
			    var text = ej.EjSvgRender.utils._measureText(label.Text, areaBounds.Height, yAxis.font);
			    var textHeight = text.height;			    
			    var font = yAxis.font;
			    var range = yAxis.visibleRange;
			    var lineWidth = yAxis.axisLine.width;
			    var labelMaxWidth = yAxis._LableMaxWidth;
			    var labelMaxHeight = labelMaxWidth.height;
			    var labelMaxRow = labelMaxWidth.rows;
               var areaBoundWidth = areaBounds.Width;
               var gap = yAxis.maximumLabelWidth;  // width for 4 digits
               var labelText = label.displayText = label.Text;
			    var textSize = ej.EjSvgRender.utils._measureText(labelText, areaBoundWidth, yAxis.font);
			    var textWidth = textSize.width;
			    var font = yAxis.font;
			    var degree = yAxis.labelRotation,maxLineWidth;

			    if(yAxis.labelPosition=='inside' && yAxis.tickLinesPosition=='inside')
			    {
			        var x = (opposedPosition) ? (yAxis.x - (yAxis.majorTickLines.size) - (lineWidth / 2) - 5)
               : (yAxis.x + (lineWidth / 2) + 5 + yAxis.majorTickLines.size);
			        var textanchor = (opposedPosition) ? 'end' : 'start';			       
			    }
			    else if (yAxis.labelPosition == 'inside' && yAxis.tickLinesPosition != 'inside')
			    {			        
			        var x = (opposedPosition) ? (yAxis.x - (lineWidth / 2)  - 5)
                : (yAxis.x + (lineWidth / 2) + 5);
			        var textanchor = (opposedPosition) ? 'end' : 'start';			       
			    }
			    else if (yAxis.tickLinesPosition == 'inside' && yAxis.labelPosition != 'inside')
			    {

			        var x = (opposedPosition) ? ((lineWidth / 2) + yAxis.x + 5)
                        : (yAxis.x - (lineWidth / 2) - 5);
			        var textanchor = (opposedPosition) ? 'start' : 'end';
			        x = x - ((isScroll ? (opposedPosition ? -this.model.scrollerSize : this.model.scrollerSize) : 0));
			    }
			    else
			    {
			        var x = (opposedPosition) ? ((yAxis.majorTickLines.size) + (lineWidth / 2) + yAxis.x + 5)
                        : (yAxis.x - (lineWidth / 2) - 5 - yAxis.majorTickLines.size);
			        var textanchor = (opposedPosition) ? 'start' : 'end';			    
			        x = x - ((isScroll ? (opposedPosition ? -this.model.scrollerSize : this.model.scrollerSize) : 0));
			    }
			    if (yAxis.majorGridLines.width > yAxis.majorTickLines.width)
			        maxLineWidth = yAxis.majorGridLines.width;
			    else maxLineWidth = yAxis.majorTickLines.width;
			    if (yAxisAlignment == "far")
			        y = ((-pointY) + (yAxis.y + yAxis.height)) - maxLineWidth - pixel;
			    else if (yAxisAlignment == "near")
			        y = ((-pointY) + (yAxis.y + yAxis.height) + textHeight / 2) + maxLineWidth + pixel;
                else
                    y = ((-pointY) + (yAxis.y + yAxis.height) + textHeight/4);
                    var options = {
                        'id': this.svgObject.id + '_' + axisName + '_YLabel_' + i,
                        'x': x,
                        'y': y,
                        'fill': font.color,
                        'font-size': font.size,
                        'font-family': font.fontFamily,
                        'font-style': font.fontStyle,
                        'font-weight': font.fontWeight,
                        'opacity': font.opacity,
                        'text-anchor': !ej.util.isNullOrUndefined(degree) && degree != 0 ? "middle" : textanchor
                    };
					
                // To set position of edge labels in yAxis
                    if (yAxis.edgeLabelPlacement) {
                        var position = yAxis.edgeLabelPlacement.toLowerCase();
                        var lastLabel = yAxis.visibleLabels.length - 1;

                        switch (position) {
                            case "none":
                                break;
                            case "shift":
                                {
                                    if (i == 0) {  // Shift first label
                                        if (options.y > yAxis.y + yAxis.height) {
                                            var diff = options.y - (yAxis.y + yAxis.height);
                                            options.y = y = options.y - diff;
                                            this.diff = diff;
                                            this.edgeLabel = true;
                                        }
                                    } else if (i == lastLabel) // Shift last label
                                        if (options.y - textHeight/2 < yAxis.y) {
                                            diff = yAxis.y - (options.y - textHeight / 2);
                                            options.y = y = options.y + diff;
                                            this.diff = diff;
                                            this.edgeLabel = true;
                                        }
                                    break;
                                }
                            case "hide": //to hide the edge labels
                                if ((i == 0 && options.y > yAxis.y + yAxis.height) || (i == lastLabel && options.y - textHeight / 2 < areaBounds.Y)) {
                                    labelText = label.Text = "";
                                }
                        }
                    }

			      //To perform rotation         
                        if (!ej.util.isNullOrUndefined(degree) && degree != 0 && !this.svgRenderer.vmlNamespace){
						    if (yAxis.labelPosition!='inside')
                               x = (opposedPosition) ? (x + textWidth/2) : (x - textWidth/2);
                            else
                               x = (opposedPosition) ? (x - textWidth/2) : (x + textWidth/2);
							   
						    var labelText = (label.displayText) ? label.displayText : label.Text;
                            var angle = (degree > 360) ? degree - 360 : (degree < -360) ? degree + 360 : degree;
                            var rotate = 'rotate(' + angle + ',' + (x) + ',' + y + ')';
                            $(options).attr('transform', rotate);
			                $(options).attr('labelRotation', angle);
                            var textElement = this.svgRenderer.createText(options, labelText);
                            var diffHeight = Math.ceil(ej.EjSvgRender.utils._measureBounds(textElement, this).width - 
							                           ej.EjSvgRender.utils._measureText(labelText, null, yAxis.font).width);
            
                            if (yAxis.labelPosition!='inside')
                                var yLocation = (opposedPosition) ? (diffHeight / 2) : (-diffHeight / 2);
                            else
                                var yLocation = (opposedPosition) ? (-diffHeight / 2) : (diffHeight / 2);

                           rotate = 'rotate(' + angle + ',' + (x + yLocation) + ',' + (y) + ')';
       
	                        $(options).attr({
                                'transform' :rotate,
                                'x': (x + yLocation)
                            });
						}
				 //Label intersection
                    if (yAxis.labelIntersectAction || yAxis.enableTrim) {
                        if (intersectAction == 'none' && !(yAxis.enableTrim)) {
                            this.svgRenderer.drawText(options, label.Text, gEle);
						     labelSize = ej.EjSvgRender.utils._measureText(labelText, null, font);
                            if (yAxis.opposedPosition)
                                regionX = options.x;
                            else
                                regionX = options.x - labelSize.width;
                            // yAxis labels region stored 
                            bounds = { x: regionX, y: options.y, width: labelSize.width, height: labelSize.height };
                            yAxisLabelRegions = { bounds: bounds, trimText: labelText, labelText: label.Text };
                            yAxis.visibleLabels[i].region = { bounds: bounds, trimText: labelText, labelText: label.Text };
                            this.model.yAxisLabelRegions.push(yAxisLabelRegions)
                            continue;
                        }
                        else if (yAxis.enableTrim) {
                            if (textWidth > gap && labelText != "") { // check textwidth is greater than gap
                                for (var t = 1; t < labelText.toString().length; t++) {
                                    labelText = label.displayText.toString().substring(0, t - 1) + '...';
                                    textWidth = ej.EjSvgRender.utils._measureText(labelText, areaBoundWidth, font).width;
                                    if (textWidth >= gap) {
                                        labelText = labelText.toString().substring(0, t - 1) + '...';                                      
                                        break;
                                    }
                                }
                                label.displayText = labelText;
                            }
                        }
                        var intersectAction = yAxis.labelIntersectAction.toLowerCase();
                        for (var j = 0; j < i; j++) {                           
                            var prevLabel = yAxis.visibleLabels[j];
                            var temp = 0;
                            var prevPoint = Math.abs((ej.EjSvgRender.utils._getPointXY(prevLabel.Value, range, yAxis.isInversed) * (yAxis.height)));
                                var prevTextHeight = ej.EjSvgRender.utils._measureText(prevLabel.Text, areaBounds.Height, font).height;
                                var value = ((prevPoint * -1) + (yAxis.y + yAxis.height) + prevTextHeight/4);
                                value = value + ((yAxis.isInversed) ? prevTextHeight / 2 : -prevTextHeight / 2);
                            if (this.edgeLabel)
                                value = (j == 0) ? value - prevTextHeight / 4 : value;
                                if (intersectAction == 'hide' && prevLabel.Text.toString()!="" && ((yAxis.isInversed) ? value > options.y - textHeight / 4 : value < options.y + textHeight / 4))
                                    labelText=label.Text = '';
                                else if (intersectAction == 'multiplerows' && ((yAxis.isInversed) ? value > options.y - textHeight / 4 : value < options.y + textHeight / 4) && prevLabel.x == options.x) {
                                    if (opposedPosition) {
                                        if(yAxis.labelPosition !="inside")
                                            temp = prevLabel.x + yAxis._LableMaxWidth.maxWidth + 5;  // gap between the rows
                                        else
                                            temp = prevLabel.x - yAxis._LableMaxWidth.maxWidth - 5;                                            
                                        options.x = temp;
                                    }
                                    else {
                                        if (yAxis.labelPosition != "inside")
                                            temp = prevLabel.x - yAxis._LableMaxWidth.maxWidth - 5; // gap between the rows
                                        else
                                            temp = prevLabel.x + yAxis._LableMaxWidth.maxWidth + 5;
                                        options.x = temp;
                                     }
                                }
                            }
                        }

                    yAxis.visibleLabels[i].x = options.x;	
                    this.svgRenderer.drawText(options, labelText, gEle);
                      //create region to chart axis labels
                    labelSize = ej.EjSvgRender.utils._measureText(labelText, null, font);
                   
                   if (opposedPosition)
                       regionX = options.x;
                    else
                       regionX = options.x - labelSize.width;
                   
          			    // yAxis labels region stored 
                       bounds = { x: regionX, y: options.y, width: labelSize.width, height: labelSize.height };
                       yAxisLabelRegions = { bounds: bounds, trimText: labelText, labelText: label.Text };
					    yAxis.visibleLabels[i].region = { bounds: bounds, trimText: labelText, labelText: label.Text };
                       this.model.yAxisLabelRegions.push(yAxisLabelRegions)
				

            }
        }
		$(gEle).appendTo(this.gYaxisEle);
    },
	//To Trim axis title
	 trimText: function (text, maxLength, ellipsis) {
        maxLength--;
        text = text.substring(0, maxLength - ellipsis.length);
        return text + ellipsis;
    },
	
    _drawXTitle: function (axisIndex, axis) {

        if (axis.title.text != "" && axis.title.text && axis.title.visible) {
            var gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisTitle' + '_' + axisIndex,'cursor': 'default'}),
            xtitleLocation = (this.model.elementSpacing) + axis._LableMaxWidth.height,
            axisTitleSize = ej.EjSvgRender.utils._measureText(axis.title.text, (axis.width), axis.title.font),
            titlesize = axisTitleSize.height / 2,
            opposedPosition = axis._opposed,
			titleText = axis.title.text,
			_LableMaxWidth = axis._LableMaxWidth, 
			textAnchor="middle",
			elementSpacing = this.model.elementSpacing,
            isEnableTrim = axis.title.enableTrim,
            isScroll = (axis._isScroll || (this.model.zooming.enableScrollbar && axis.scrollbarSettings.visible && (axis.zoomFactor < 1 || axis.zoomPosition > 0))),
			axisTitleWidth=axis.title.maximumTitleWidth,
			axisTitlePosition = axis.title.position.toLowerCase(),
		    axisTitleAlignment = axis.title.alignment.toLowerCase(),y,
			tickLinesPosition  = axis.tickLinesPosition.toLowerCase(),
			labelPosition = axis.labelPosition.toLowerCase(),
			m_AreaBounds = this.model.m_AreaBounds,
			axistitleoffset = axis.title.offset,locX,newY,
			scrollerSize = this.model.scrollerSize;
            if(isEnableTrim &&(ej.util.isNullOrUndefined(axisTitleWidth)||axisTitleWidth>0||isNaN(axisTitleWidth))){
                var maxTitleWidth = (!axisTitleWidth) ? axis.width - (elementSpacing * 2) : axisTitleWidth;
			    while (axisTitleSize.width > maxTitleWidth) {
			        titleText = this.trimText(titleText, titleText.length, "...");
			        axisTitleSize = ej.EjSvgRender.utils._measureText(titleText, (axis.width), axis.title.font);
			        if (titleText == "...") {
			            titleText = "";
			            break;
			        }
			    }
			}			  
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);

            var y = elementSpacing + _LableMaxWidth.height + titlesize + axis._multiLevelLabelHeight + axis.majorTickLines.size + axis.axisLine.width;

           if ((tickLinesPosition == 'inside' && labelPosition == 'inside') && (axisIndex == 0 || (axis.y == (m_AreaBounds.Height + m_AreaBounds.Y)) || (axis.y == (m_AreaBounds.Y))))
                 y = (axisTitlePosition == "inside") ? elementSpacing + _LableMaxWidth.height + titlesize + axis._multiLevelLabelHeight + axis.majorTickLines.size + axis.axisLine.width : elementSpacing + titlesize + axis.axisLine.width;
            else if ((axisIndex == 0 || (axis.y == (m_AreaBounds.Width + m_AreaBounds.X)) || (axis.y == (m_AreaBounds.X))) && (tickLinesPosition != 'inside' && labelPosition == 'inside'))
                 y = (axisTitlePosition == "inside") ? elementSpacing + _LableMaxWidth.height+titlesize + axis._multiLevelLabelHeight + axis.axisLine.width : elementSpacing +axis.majorTickLines.size+ axis.axisLine.width;
            else if ((axisIndex == 0 || (axis.y == (m_AreaBounds.Width + m_AreaBounds.X)) || (axis.y == (m_AreaBounds.X))) && (tickLinesPosition == 'inside' && labelPosition != 'inside'))
                y = (axisTitlePosition == "inside") ? elementSpacing + titlesize + axis.majorTickLines.size+ axis.axisLine.width :  elementSpacing + _LableMaxWidth.height + titlesize + axis._multiLevelLabelHeight + axis.axisLine.width;
            else if ((tickLinesPosition != 'inside' && labelPosition != 'inside') || (axisIndex != 1))
                 y = (axisTitlePosition == "inside") ?  elementSpacing  : elementSpacing + _LableMaxWidth.height + titlesize + axis.majorTickLines.size + axis.axisLine.width + axis._multiLevelLabelHeight;
            else if ((tickLinesPosition != 'inside' && labelPosition == 'inside' && !axis.showNextToAxisLine))
                y = (axisTitlePosition == "inside") ? elementSpacing + _LableMaxWidth.height + titlesize + axis._multiLevelLabelHeight + axis.axisLine.width :elementSpacing + titlesize + axis.majorTickLines.size + axis.axisLine.width + elementSpacing + elementSpacing;
            if (axisTitleAlignment == "far") {
                locX = axis.x + axis.width + axistitleoffset;
				textAnchor="end";
            }
            else if (axisTitleAlignment == "near") {
				locX = axis.x + axistitleoffset;
				textAnchor="start";
            }
			else
				locX = (axis.x + axis.width / 2) + axistitleoffset ;
				
            commonEventArgs.data = { title: axis.title.text, location: { x: locX, y: y }, axes: axis };
            this._trigger("axesTitleRendering", commonEventArgs);
			
			if (axisTitlePosition == "inside")
				  newY = ((opposedPosition) ? (tickLinesPosition == "inside" && labelPosition == "outside" ? axis.y + commonEventArgs.data.location.y - (isScroll ? scrollerSize : 0) - axis.majorTickLines.size 
												: (axis.y + commonEventArgs.data.location.y - (isScroll ? scrollerSize : 0)))
											: (tickLinesPosition=="outside" && labelPosition=="inside" ? (isScroll ? scrollerSize : 0) + (axis.y - commonEventArgs.data.location.y)  + axis.majorTickLines.size 
												:(isScroll ? scrollerSize : 0) + (axis.y - commonEventArgs.data.location.y))) + axisTitleSize.height / 3.5;
			else
				 newY = ((opposedPosition) ? (tickLinesPosition == "inside" && labelPosition == "outside" ? axis.y - commonEventArgs.data.location.y - (isScroll ? scrollerSize : 0) - axis.majorTickLines.size 
												: (axis.y - commonEventArgs.data.location.y - (isScroll ? scrollerSize : 0)))
											: (tickLinesPosition == "outside" && labelPosition == "inside" ? (isScroll ? scrollerSize : 0) + (commonEventArgs.data.location.y + axis.y) - axis.majorTickLines.size 
												: (isScroll ? scrollerSize : 0) + (commonEventArgs.data.location.y + axis.y))) + axisTitleSize.height / 3.5;
				 
            var options = {
                'id': this.svgObject.id + '_XAxisTitle' + '_' + axisIndex,
                'x': commonEventArgs.data.location.x,
                'y': newY,
                'fill': axis.title.font.color,
                'font-size': axis.title.font.size,
                'font-family': axis.title.font.fontFamily,
                'font-style': axis.title.font.fontStyle,
                'font-weight': axis.title.font.fontWeight,
                'opacity': axis.title.font.opacity,
                'text-anchor': textAnchor
            };
            if (this.model.enableCanvasRendering) {
                var matched = jQuery.uaMatch(navigator.userAgent);
                var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
                var browser = matched.browser.toLowerCase();
                 if (browser != "msie" && !isIE11)
                     options.y = !opposedPosition ? options.y + (titlesize / 2) + (browser == "mozilla" ? 1 : -2) : options.y + (titlesize / 2) + 1; // text dominant baseline for canvas
            }
            if ($(this.svgObject).find("#" + this.svgObject.id + '_XAxisTitle' + '_' + axisIndex).length > 0)
                $(this.svgObject).find("#" + this.svgObject.id + '_XAxisTitle' + '_' + axisIndex).attr(options);
            else if (!isEnableTrim)
                this.svgRenderer.drawText(options, commonEventArgs.data.title, gEle);
		    else if(isEnableTrim &&(ej.util.isNullOrUndefined(axisTitleWidth)||axisTitleWidth>0||isNaN(axisTitleWidth))){
				var x = (textAnchor == "middle") ? options.x - (axisTitleSize.width) / 2 : (textAnchor == "end" ? options.x - axisTitleSize.width : options.x);
                var bounds = { X: x, Y: options.y, Width: axisTitleSize.width, Height: axisTitleSize.height };
                var xAxisTitleRegion = { Bounds: bounds, trimText: titleText, labelText: axis.title.text };
                this.model.xAxisTitleRegion.push(xAxisTitleRegion)
                this.svgRenderer.drawText(options, titleText, gEle);
            }
			
			if (!this.model.enableCanvasRendering){
				var borderY = (textAnchor == "start" ? 0 : (textAnchor== "end" ? axisTitleSize.width : axisTitleSize.width/2));
				var borderOptions = {
					'id': this.svgObject.id + '_XAxisTitleBorder' + '_' + axisIndex,
					'x': commonEventArgs.data.location.x - borderY - elementSpacing,
					'y': newY - axisTitleSize.height + (axisTitleSize.height/4),
					'width': axisTitleSize.width + (2 * elementSpacing),
					'height': axisTitleSize.height,
					'fill': "transparent",
					'class': "e-xaxistitleborder"
				};
				this.svgRenderer.drawRect(borderOptions, gEle);
			}
            $(gEle).appendTo(this.gXaxisEle);
			}
        },
    _drawYTitle: function (axisIndex, yAxis) {

        if (yAxis.title.text != "" && yAxis.title.text && yAxis.title.visible) {
            var opposedPosition = yAxis._opposed,
			elementSpacing = this.model.elementSpacing,
			textAnchor = "middle",
			isTransposed = this.model.series.isTransposed,
			majorTickLinesize = yAxis.majorTickLines.size,
			axisTitlePosition = yAxis.title.position.toLowerCase(),
			_LableMaxWidth = yAxis._LableMaxWidth,
			m_AreaBounds = this.model.m_AreaBounds,x,
			axisLine = yAxis.axisLine,
			tickLinesPosition = yAxis.tickLinesPosition.toLowerCase(),
			labelPosition = yAxis.labelPosition.toLowerCase(),
			 titleText = yAxis.title.text,
            isEnableTrim = yAxis.title.enableTrim,
            requireInvertedAxes = this.model.requireInvertedAxes,y,
            isScroll = yAxis._isScroll,
            axisTitleWidth = yAxis.title.maximumTitleWidth,
		    axistitleoffset= yAxis.title.offset,
		    axisTitleAlignment = yAxis.title.alignment.toLowerCase(),
            gEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisTitleGroup' + '_' + axisIndex,'cursor': 'default' });//Group id and text element id should not be same
            var titleSize = ej.EjSvgRender.utils._measureText(yAxis.title.text, (yAxis.height), yAxis.title.font);
             if ((tickLinesPosition == 'inside' && labelPosition == 'inside') && (axisIndex == 1 || (yAxis.x == (m_AreaBounds.Width + m_AreaBounds.X)) || (yAxis.x == (m_AreaBounds.X)))) {
                if (axisTitlePosition == "inside")
                    x = (opposedPosition) ? (yAxis.x - ((3 * elementSpacing) + _LableMaxWidth.width +yAxis._multiLevelLabelHeight+ majorTickLinesize + axisLine.width)) : yAxis.x + ((3 * elementSpacing) + _LableMaxWidth.width + yAxis._multiLevelLabelHeight + majorTickLinesize + axisLine.width);
                else
                    x = (opposedPosition) ? yAxis.x + ((3 * elementSpacing) + axisLine.width - 5) : yAxis.x - ((3 * elementSpacing) + axisLine.width);
            } else if ((axisIndex == 1 || (yAxis.x == (m_AreaBounds.Width + m_AreaBounds.X)) || (yAxis.x == (m_AreaBounds.X))) && (tickLinesPosition != 'inside' && labelPosition == 'inside')) {
                if (axisTitlePosition == "inside")
                    x = (opposedPosition) ? (yAxis.x - ((3 * elementSpacing) + _LableMaxWidth.width + axis._multiLevelLabelHeight + axisLine.width)) : yAxis.x + ((3 * elementSpacing) + _LableMaxWidth.width + yAxis._multiLevelLabelHeight + axisLine.width);
                else
                    x = (opposedPosition) ? yAxis.x + ((3 * elementSpacing) + majorTickLinesize + axisLine.width) : yAxis.x - ((3 * elementSpacing) + majorTickLinesize + axisLine.width);
            } else if ((axisIndex == 1 || (yAxis.x == (m_AreaBounds.Width + m_AreaBounds.X)) || (yAxis.x == (m_AreaBounds.X))) && (tickLinesPosition == 'inside' && labelPosition != 'inside')) {
                if (axisTitlePosition == "inside")
                    x = (opposedPosition) ? (yAxis.x - ((3 * elementSpacing) + majorTickLinesize + axisLine.width)) : yAxis.x + ((3 * elementSpacing) + majorTickLinesize + axisLine.width) +
                        (!yAxis.showNextToAxisLine ? -(elementSpacing) : labelPosition == "inside" ? -yAxis._multiLevelLabelHeight : yAxis._multiLevelLabelHeight);
               
                else
                    x = (opposedPosition) ? yAxis.x + ((3 * elementSpacing) + yAxis._multiLevelLabelHeight + _LableMaxWidth.width + axisLine.width) : yAxis.x - ((3 * elementSpacing) + _LableMaxWidth.width + axisLine.width + yAxis._multiLevelLabelHeight);
            } else if ((yAxis.tickLinesPosition != 'inside' && yAxis.labelPosition != 'inside') || (axisIndex != 1)) {
                if (axisTitlePosition == "inside")
                    x = (opposedPosition) ? (yAxis.x - (elementSpacing + axisLine.width + majorTickLinesize)) : yAxis.x + (elementSpacing + (!yAxis.showNextToAxisLine ? _LableMaxWidth.width : 0) + axisLine.width + majorTickLinesize);
                else
                    x = (opposedPosition) ? yAxis.x + ((3 * elementSpacing) + yAxis._multiLevelLabelHeight + _LableMaxWidth.width + majorTickLinesize + axisLine.width) : yAxis.x - ((3 * elementSpacing) + _LableMaxWidth.width + yAxis._multiLevelLabelHeight + majorTickLinesize + axisLine.width);
            }
            var axisTitleSize = ej.EjSvgRender.utils._measureText(titleText, (yAxis.height), yAxis.title.font);
            if (isEnableTrim &&(ej.util.isNullOrUndefined(axisTitleWidth)||axisTitleWidth>0||isNaN(axisTitleWidth))){
                var maxTitleWidth = (!axisTitleWidth)? yAxis.height - (elementSpacing * 2) : axisTitleWidth;                
                while (axisTitleSize.width > maxTitleWidth) {
                    titleText = this.trimText(titleText, titleText.length, "...");
                    axisTitleSize = ej.EjSvgRender.utils._measureText(titleText, (yAxis.height), yAxis.title.font);
                    if (titleText == "..."){
                        titleText = "";
                        break;
                    }
                        
                }
            }
            x = (yAxis.opposedPosition) ? x : x - (isScroll ? this.model.scrollerSize : 0)
            if (document.documentMode === 8)
                x = (!opposedPosition) ? (x - axisTitleSize.width / 2 + elementSpacing) : (x + axisTitleSize.width / 2 - elementSpacing);
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { title: yAxis.title.text, location: { x: titleSize.width / 2, y: 0 }, axes: yAxis };
            this._trigger("axesTitleRendering", commonEventArgs);
			y = commonEventArgs.data.location.y + (yAxis.y + yAxis.height) + (((yAxis.height) / 2) * -1);
			
			if (axisTitleAlignment == "near") {
				y = (yAxis.y + yAxis.height) - axistitleoffset ;
			    textAnchor = opposedPosition||isTransposed ? "end":"start"; 
            }
            else if (axisTitleAlignment == "far") {
				 y = yAxis.y  - axistitleoffset ;
				 textAnchor = opposedPosition||isTransposed  ? "start":"end";
            }
			else if (axisTitleAlignment == "center")
				 y = yAxis.y + (yAxis.height/2) - axistitleoffset ;
	
			var labelRotation = (opposedPosition) ? 90 : -90;

            var options = {
                'id': this.svgObject.id + '_YAxisTitle' + '_' + axisIndex,
                'x': x,
                'y': y,
                'fill': yAxis.title.font.color,
				'labelRotation': labelRotation,
                'transform': 'rotate(' + labelRotation + ',' + (x) + ',' + y + ')',
                'font-size': yAxis.title.font.size,
                'font-family': yAxis.title.font.fontFamily,
                'font-style': yAxis.title.font.fontStyle,
                'font-weight': yAxis.title.font.fontWeight,
                'opacity': yAxis.title.font.opacity,
                'text-anchor': textAnchor,
                'dominant-baseline': 'middle'
            };
             if (this.model.enableCanvasRendering) {
                var matched = jQuery.uaMatch(navigator.userAgent);
                var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
                var browser = matched.browser.toLowerCase();
                 if (browser != "msie" && !isIE11)
                    options.x = !opposedPosition ? options.x + (titleSize.height / 4) + (browser == "mozilla" ? 1 : -2) : options.x - (titleSize.height / 4) + 1; // text dominant baseline for canvas
            }
            if ($(this.svgObject).find("#" + this.svgObject.id + '_YAxisTitle' + '_' + axisIndex).length > 0)
                $(this.svgObject).find("#" + this.svgObject.id + '_YAxisTitle' + '_' + axisIndex).attr(options);
            else if (!isEnableTrim)
                this.svgRenderer.drawText(options, commonEventArgs.data.title, gEle);
			else if(isEnableTrim &&(ej.util.isNullOrUndefined(axisTitleWidth)||axisTitleWidth>0||isNaN(axisTitleWidth))){
                 if (!this.svgRenderer.vmlNamespace)
                    var bounds = { X: options.x - (axisTitleSize.height / 2), Y: options.y + (axisTitleSize.width / 2), Width: (axisTitleSize.height)/2, Height: axisTitleSize.width };
                 else
                    var bounds = { X: options.x - (axisTitleSize.width)/2, Y: options.y + (axisTitleSize.height / 2), Width: (axisTitleSize.width), Height: axisTitleSize.height };
                var yAxisTitleRegion = { Bounds: bounds, trimText: titleText, labelText: yAxis.title.text };
                this.model.yAxisTitleRegion.push(yAxisTitleRegion)
                this.svgRenderer.drawText(options, titleText, gEle);
            }	
			
			if (!this.model.enableCanvasRendering){
				var borderY = (textAnchor == "start" ? (axisTitleSize.width) : (textAnchor== "end" ? 0 : axisTitleSize.width/2));
				var borderOptions = {
					'id': this.svgObject.id + '_YAxisTitleBorder' + '_' + axisIndex,
					'x': options.x - axisTitleSize.height + (axisTitleSize.height/2),
					'y': options.y - borderY - elementSpacing,
					'width': axisTitleSize.height,
					'height': axisTitleSize.width + (2 * elementSpacing),
					'fill': "transparent",
					'class': "e-yaxistitleborder"
				};
				this.svgRenderer.drawRect(borderOptions, gEle);
			}
            $(gEle).appendTo(this.gYaxisEle);
			}
		}
    },
ej.EjStripline.prototype = {
    _drawStripline: function (axis, stripLine,axisIndex, stripLineIndex) {

        var start = (stripLine.start < axis.range.min) ? axis.range.min : stripLine.start;
        var end = (stripLine.end > axis.range.max) ? axis.range.max : stripLine.end;
        var x = 0, height = 0, angle = 0;
        var y = 0, pointYstart = 0, yHeight = 0;
        var width = 0, widthValue = 0, textX = 0, textY = 0;
        if (stripLine.visible) {
		     this.model._stripeline = true;
            var striplineid = (stripLine.zIndex == 'over') ? this.gStriplineOver : this.gStriplineBehind;
            striplineid = ej.util.isNullOrUndefined(striplineid) ? "" : striplineid;
            var isVisible = true;
            if (axis.orientation.toLowerCase() == "horizontal") {
                var pointstart = 0;

                if (stripLine.startFromAxis) {

                    var point = (ej.util.isNullOrUndefined(stripLine.offset)) ? axis.visibleRange.min : axis.visibleRange.min + stripLine.offset;
                    pointstart = (((point - axis.visibleRange.min) / (axis.visibleRange.delta)) * (axis.width)) + axis.x; //($(this.svgObject).width() - this.model.m_Spacing.Left - this.model.m_Spacing.Right);

                    widthValue = (((point + (ej.util.isNullOrUndefined(stripLine.width) ? 0 : stripLine.width) - axis.visibleRange.min) / (axis.visibleRange.delta)) * (axis.width));

                } else {
                    if (ej.util.isNullOrUndefined(start) && (ej.util.isNullOrUndefined(end) || ej.util.isNullOrUndefined(stripLine.width))) {
                        isVisible = false;
                    } else {
                        start = (jQuery.type(start) == "date") ? (start).getTime() : start;
                        if (!ej.util.isNullOrUndefined(end) && (jQuery.type(end) == "date")) {
                            end = (end).getTime();
                        }
                        pointstart = (ej.EjSvgRender.utils._getPointXY(start, axis.visibleRange, axis.isInversed) * (axis.width)) + axis.x; //($(this.svgObject).width() - this.model.m_Spacing.Left - this.model.m_Spacing.Right);
                        var pointend = (ej.EjSvgRender.utils._getPointXY(end, axis.visibleRange, axis.isInversed) * (axis.width)) + axis.x; //($(this.svgObject).width() - this.model.m_Spacing.Left - this.model.m_Spacing.Right);
                        var widthMax = (ej.EjSvgRender.utils._getPointXY((start + (ej.util.isNullOrUndefined(stripLine.width) ? 0 : stripLine.width)), axis.visibleRange, axis.isInversed) * (axis.width)) + axis.x;

                        widthValue = (axis.isInversed ? (pointend < widthMax) : (pointend > widthMax)) ? Math.abs(pointstart - pointend) : Math.abs(pointstart - widthMax);
                        
                    }
                }
                width = widthValue;
                height = this.chart.model.m_AreaBounds.Height;
                x = (axis.isInversed) ? (pointstart - widthValue) : pointstart;
                y = this.chart.model.m_AreaBounds.Y;
                angle = -90;
                var textWidth = ej.EjSvgRender.utils._measureText(stripLine.text, null, stripLine.font).height;
                if (stripLine.textAlignment == 'middletop') {
                    textX = x+textWidth;
                    textY = Math.abs(y + height / 2);
                } else if (stripLine.textAlignment == 'middlecenter') {
                    textX = (Math.floor(x + width / 2) + (textWidth / 3));
                    textY = Math.abs(y + height / 2);
                } else if (stripLine.textAlignment == 'middlebottom') {
                    textX = x + width - (textWidth);
                    textY = Math.abs(y + height / 2);
                }


            } else {
                if (stripLine.startFromAxis) {
                    var pointY = (ej.util.isNullOrUndefined(stripLine.offset)) ? axis.visibleRange.min : axis.visibleRange.min + stripLine.offset;
                    pointYstart = (axis.y + axis.height) - (((pointY - axis.visibleRange.min) / (axis.visibleRange.delta)) * (axis.height));
                    widthValue = (((pointY + (ej.util.isNullOrUndefined(stripLine.width) ? 0 : stripLine.width) - axis.visibleRange.min) / (axis.visibleRange.delta)) * (axis.height));
                    yHeight = widthValue;
                } else {

                    if (ej.util.isNullOrUndefined(start) && (ej.util.isNullOrUndefined(end) || ej.util.isNullOrUndefined(stripLine.width))) {
                        isVisible = false;
                    } else {
                        start = (jQuery.type(start) == "date") ? (start).getTime() : start;
                        if (!ej.util.isNullOrUndefined(end) && (jQuery.type(end) == "date")) {
                            end = (end).getTime();
                        }
                        pointYstart = (axis.y + axis.height) - (ej.EjSvgRender.utils._getPointXY(start, axis.visibleRange, axis.isInversed) * (axis.height));
                        var pointYend = (axis.y + axis.height) - (ej.EjSvgRender.utils._getPointXY((ej.util.isNullOrUndefined(end) ? 0 : end), axis.visibleRange, axis.isInversed) * (axis.height));
                        var widthYValue = (axis.y + axis.height) - (ej.EjSvgRender.utils._getPointXY((start + (ej.util.isNullOrUndefined(stripLine.width) ? 0 : stripLine.width)), axis.visibleRange, axis.isInversed) * (axis.height));
                        yHeight = (axis.isInversed ? (pointYend > widthYValue) : (pointYend < widthYValue)) ? Math.abs(pointYstart - pointYend) : Math.abs(pointYstart - widthYValue);
                    }
                }
                height = yHeight;
                x = this.chart.model.m_AreaBounds.X;
                width = this.chart.model.m_AreaBounds.Width;
                y = pointYstart + ((axis.isInversed) ? 0 : -yHeight);
                var textHeight = ej.EjSvgRender.utils._measureText(stripLine.text, width, stripLine.font).height;

                if (stripLine.textAlignment == 'middletop') {
                    textX = x + width / 2;
                    textY = y + textHeight;
                } else if (stripLine.textAlignment == 'middlecenter') {
                    textX = x + width / 2;
                    textY = (Math.abs(y + (height / 2)) + (textHeight / 3));
                } else if (stripLine.textAlignment == 'middlebottom') {
                    textX = x + width / 2;
                    textY = (y + height) - textHeight;

                }


            }
            if (isVisible) {
                if (!ej.util.isNullOrUndefined(stripLine.imageUrl)) {
                    var imgOptions = {
                        'height': height,
                        'width': width,
                        'href': stripLine.imageUrl,
                        'x': x,
                        'y': y,
                        'id': striplineid.id + '_backImage',
                        'visibility': 'visible',
                        'preserveAspectRatio': 'none'
                    };

                    this.svgRenderer.drawImage(imgOptions, striplineid);
                } else {
                    var options = {
                        'id': striplineid.id + '_striplineRect_'+ axisIndex+ '_'+ stripLineIndex,
                        'x': x,
                        'y': y,
                        'width': width,
                        'height': height,
                        'fill': stripLine.color,
                        'opacity': stripLine.opacity,
                        'stroke-width': stripLine.borderWidth,
                        'stroke':(stripLine.borderWidth==0)?"transparent": stripLine.borderColor
                    };
                    var textOptions = {
                        'id': striplineid.id + '_striplineRectText_'+ axisIndex+ '_'+ stripLineIndex,
                        'x': textX,
                        'y': textY,
                        'fill': stripLine.font.color,
                        'transform': 'rotate(' + angle + ',' + (textX) + ',' + textY + ')',
                        'labelRotation': angle,
                        'font-size': stripLine.font.size,
                        'font-family': stripLine.font.fontFamily,
                        'font-style': stripLine.font.fontStyle,
                        'font-weight': stripLine.font.fontWeight,
						'opacity': stripLine.font.opacity,
                        'text-anchor': 'middle'
                    };

                    var bounds = { X: x, Y: y, Width: width, Height: height };
                    var isStripline = stripLine.zIndex == "over" ? true : false;
                    ej.EjSvgRender.utils.AddRegion(this.chart, bounds, isStripline)

                    if (this.chart.model.enableCanvasRendering) {
                        var ctx = this.chart.svgObject.getContext("2d");
                        var clipBounds = axis.orientation.toLowerCase() == 'horizontal' ? { X: axis.x, Y: y, Width: axis.width, Height: this.chart.model.m_AreaBounds.Height }
                        : { X: x, Y: axis.y, Width: this.chart.model.m_AreaBounds.Width, Height: axis.height };
                        ctx.save();
                        ctx.beginPath();
                        ctx.rect(clipBounds.X, clipBounds.Y, clipBounds.Width, clipBounds.Height);
                        ctx.clip();
                        this.svgRenderer.drawRect(options, striplineid);
                        this.svgRenderer.drawText(textOptions, stripLine.text, striplineid);
                        ctx.closePath();
                        ctx.restore();
                    }
                    else {
                        this.svgRenderer.drawRect(options, striplineid);
                        this.svgRenderer.drawText(textOptions, stripLine.text, striplineid);
                    }
                }
            }

        }
    }
};
})(jQuery);
ej.EjLegendRender = function (chartobj) {

    this.chartObj = chartobj;
};


(function ($) {
ej.EjLegendRender.prototype =
{
		sumofArray: function(array) {
            var sum = 0,
            length = array.length;
            for (var i = 0; i < length; i++)
                sum += array[i];
            return sum;
		},

        legendRectSpace: function(svgBounds,divBounds) {
            var width = svgBounds.Width - 10;
            var height = svgBounds.Height - 10;
            var isVisible = false;
            if (Math.ceil(divBounds.Width) >= width && Math.ceil(divBounds.Height) >= height)
                isVisible = true;
            return isVisible;
        },

		drawLegendTitle: function () {
            //draw legend title

            var chart = this.chartObj,
                chartModel = chart.model,
                legend = chartModel.legend,
                legendBounds = chartModel.LegendBounds,
                elementSpacing = chartModel.elementSpacing,
                legendTitle = legend.title,
                measureText = ej.EjSvgRender.utils._measureText,
                font = legendTitle.font,
                legendBoundsWidth = legendBounds.Width,
                titleSize = measureText(legendTitle.text, null, font),
                titleWidth = titleSize.width,
                titleHeight = titleSize.height,
                textAlignment = legendTitle.textAlignment.toLowerCase(),
                startX = 0,
                startY = elementSpacing + (titleHeight / 2);

            switch (textAlignment) {
                case 'far':
                    startX = legendBoundsWidth - titleWidth - startX;
                    break;
                case 'center':
                    startX = legendBoundsWidth / 2 - (titleWidth) / 2;
                    break;
            }

            if (startX < 0) {
                startX = 0;
                legendBoundsWidth = titleWidth;
            }
            if (legendBoundsWidth < titleWidth + startX)
                legendBoundsWidth = titleWidth + startX;

            var options = {
                'id': chart.svgObject.id + '_LegendTitleText',
                'x': startX,
                'y': startY,
                'fill': font.color,
                'font-size': font.size,
                'font-style': font.fontStyle,
                'font-family': font.fontFamily,
                'font-weight': font.fontWeight,
                'text-anchor': 'start',
                'lgndCtx': true
            };

            chart.svgRenderer.drawText(options, legendTitle.text, this.chartObj.gLegendEle);

        },
    
        drawLegendItem: function (legendItem, x, y) {
            var chart = this.chartObj,
                chartModel = chart.model,
                legend = chartModel.legend,
                textOverflow = legend.textOverflow.toLowerCase(),
                textMaxWidth = legend.textWidth,
                legendBounds = chartModel.LegendBounds,
                elementSpacing = chartModel.elementSpacing,
                legendBorder = legend.border.width,
                measureText = ej.EjSvgRender.utils._measureText,
                svgRender = ej.EjSvgRender,
                chartSvgRender = chart.svgRenderer,
                legendFont = legendItem.Font,
                symbolShape = chartModel.symbolShape,
                isCanvas = chartModel.enableCanvasRendering,
                shapeSize = legend.itemStyle,
                textHeight = measureText(legendItem.Text, legendBounds.Width, legendFont).height,
                location = {
                    startX: x + shapeSize.width / 2,
                    startY: (y + (textHeight > shapeSize.height ? textHeight : shapeSize.height) / 2)
                },
                pointIndex = legendItem.PointIndex,
                seriesIndex = legendItem.SeriesIndex,
                index = pointIndex ? pointIndex : seriesIndex,
                series = chartModel.series[seriesIndex],
                svgObject = chart.svgObject,
                legendStyle = legendItem.LegendStyle,
                matched = jQuery.uaMatch(navigator.userAgent),
                isIE11 = !!navigator.userAgent.match(/Trident\/7\./),
                color,itemInfo, data,style,
                seriesType = series.type.toLowerCase(),
                symbolName, symbol,textinfo,legendTextRegion,textLength;

            for (name in symbolShape) {
                if (legendItem.Shape.toLowerCase() == name.toLowerCase()) {
                    if (name.toLowerCase() == "seriestype")
                        symbolName = "SeriesType";
                    else
                        symbolName = name;
                    break;
                }
            }

            if (symbolName == "SeriesType") {
                if (seriesType == "radar" || seriesType == "polar") {
                    symbol = series.drawType;
                    symbolName = symbol.capitalizeFirstString();
                }
                if (seriesType == "scatter") {
                    symbol = series.marker.shape;
                    symbolName = symbol.capitalizeFirstString();
                }
                if (legendItem.drawType)// // TrendLine drawType assigned to legend shape
                    symbolName = "SeriesType";
                if (chart.vmlRendering && (seriesType == "pie" || seriesType == "doughnut" || seriesType == "pieofpie"))
					symbolName = "Circle";          // VML legend shape for pie & doughnut
            }

            if (symbolName == "None") {
                if (seriesType == "pie" || seriesType == "doughnut" || seriesType == "pieofpie")
                    symbolName = "Circle";
                else
                    symbolName = "Rectangle";
            }

            index = (ej.util.isNullOrUndefined(pointIndex)) ? seriesIndex : pointIndex;
            chart.gLegendItemEle = chartSvgRender.createGroup({ 'id': svgObject.id + '_Legend' + index, 'cursor': 'pointer' });
            legendItem.CommonEventArgs.data.gLegendItemEle = chart.gLegendItemEle;
            data = $.extend(true, {}, legendItem.CommonEventArgs.data);
            data.model = chart.model;
            style = data.style;
            if (!legendItem.CommonEventArgs.cancel) {
                startLocation = svgRender.chartSymbol["_draw" + symbolName](location,style, data, chart.gLegendItemEle);
                if (legendStyle.Color && legendStyle.Color.toString().toLowerCase() !== 'gray' && isCanvas) // for canvas gradient color
                    color = legendFont.color;
                else if (legendStyle.Color && legendStyle.Color.toLowerCase() !== 'gray') // for svg
                    color = legendFont.color;
                else
                    color = 'gray';

                itemInfo = legendItem;
                textLength = itemInfo.Text.length;
                if (legend.shape == "seriestype" || legend.shape == "seriesType")
                    x += elementSpacing / 2;
                var options = {
                    'id': this.chartObj.svgObject.id + '_LegendItemText' + index,
                    'x': shapeSize.width + x + elementSpacing / 2,
                    'y': location.startY,
                    'fill': color,
                    'font-size': legendFont.size,
                    'font-style': legendFont.fontStyle,
                    'font-family': legendFont.fontFamily,
                    'font-weight': legendFont.fontWeight,
                    'text-anchor': 'start',
                    'lgndCtx': true
                };

                options.y = (location.startY + (textHeight / 4));
                
                if (textOverflow == "wrap" || textOverflow == "wrapandtrim") {
                    options.y = options.y - textHeight;
                    for (k = 0; k < textLength; k++) {
                        options.y = options.y + (textHeight);
                        chartSvgRender.drawText(options, itemInfo.Text[k], chart.gLegendItemEle);
                        if (textOverflow == "wrapandtrim") {
                            textinfo = { x: options.x + legendBounds.X, y: options.y + legendBounds.Y, height: textHeight * (textLength), width: textMaxWidth };
                            legendTextRegion = { bounds: textinfo, trimText: itemInfo.Text, labelText: itemInfo.displayText };
                            chartModel.legendTextRegion.push(legendTextRegion);
                        }
                    }
                }
                else {
					if (textOverflow == "trim") {
                        textinfo = { x: options.x + legendBounds.X, y: options.y + legendBounds.Y, height: textHeight + elementSpacing, width: textMaxWidth };
                        legendTextRegion = { bounds: textinfo, trimText: itemInfo.Text, labelText: itemInfo.displayText };
                        chartModel.legendTextRegion.push(legendTextRegion);
                    }
                    chartSvgRender.drawText(options, itemInfo.Text, chart.gLegendItemEle);
                }
                chartSvgRender.append(chart.gLegendItemEle, chart.gLegendEle);
                legendbound = {
                    X: legendBounds.X + legendBorder,
                    Y: legendBounds.Y + legendBorder
                };
                
                x = (startLocation) ? startLocation : x;
                var itembound = { 
                    X: (x), Y: (y), _Width: legendItem.Bounds._Width, Width: legendItem.Bounds.Width, Height: legendItem.Bounds.Height
                };
                var bounds = { LegendBound: legendbound, ItemBound: itembound };
                var legendRegion = {
                    LegendItem: legendItem,
                    Location: location, SymbolShape: symbolName, Style: legendItem.CommonEventArgs.data.style, Bounds: bounds
                };
                chartModel.legendRegion.push(legendRegion);
            }
        },

        drawLegend: function (params) {
            var chart = this.chartObj,
                chartModel = chart.model,
                legend = chartModel.legend,
                legendViewerBounds = chartModel.LegendViewerBounds,
                legendBounds = chartModel.LegendBounds,
                actualBounds = chartModel.LegendActualBounds,
                AreaType = chartModel.AreaType,
                legendPosition = legend.position.toLowerCase(),
                alignment = legend.alignment.toLowerCase(),
                elementSpacing = chartModel.elementSpacing,
                svgObjectWidth = chartModel.svgWidth,
                svgObjectHeight = chartModel.svgHeight,
                title = chartModel.title,
                titleFontHeight = title.font.size,
                subTitle = title.subTitle,
                subTitleFontHeight = title.subTitle.font.size,
                legendTitle = legend.title,
                legendBorder = legend.border.width,
                measureText = ej.EjSvgRender.utils._measureText,
                margin = chartModel.margin,
                borderSize = chartModel.border.width,
                legendCollection = chartModel.legendCollection,
                collectionLength = legendCollection.length,
                svgWidth = svgObjectWidth - ((borderSize * 2)),
                svgHeight = svgObjectHeight - ((borderSize * 2)),
                itemPadding = legend.itemPadding > 0 ? legend.itemPadding : 0,
                padding = 20,
                hPadding = 10,
                vPadding = 10,
                modelsubTitleHeight = subTitle.text == ""|| !subTitle.visible || !title.visible ? 0 : measureText(subTitle.text, svgWidth - margin.left - margin.right, subTitle.font).height + elementSpacing,
                titleLocation = chartModel._titleLocation ? chartModel._titleLocation.Y : 0 + modelsubTitleHeight,
                legendTitleBounds = measureText(legendTitle.text, null, legendTitle.font),
                legendTitleHeight = legendTitleBounds.height,
                legendTitleWidth = legendTitleBounds.width,
                rowDefinitions = chartModel._rowDefinitions,
                maxWidth = 0, startX, startY,
                columnDefinitions = chartModel._columnDefinitions,
                vSizeFar = this.sumofArray(rowDefinitions.farSizes),
                vSizeNear = this.sumofArray(rowDefinitions.nearSizes),
                hSizeFar = this.sumofArray(columnDefinitions.farSizes),
                hSizeNear = this.sumofArray(columnDefinitions.nearSizes),
                isScrolling = false,
                areaBounds = chartModel.m_AreaBounds,
                isScroll = legend.enableScrollbar,
                legendContainer = $(chart.legendContainer),
                leftScroll = $("#ScrollerParent_" + 'vertical' + "_" + chart._id).length > 0 ? 18 : 0,
                bottomScroll = $("#ScrollerParent_" + 'horizontal' + "_" + chart._id).length > 0 ? 18 : 0,
                legendSvgContainer = $(chart.legendSvgContainer);
            var textBorderConstant = 1.2,
                titleBorderSpacing = 10,
                subTitleBorderSpacing = 10,
                title = chartModel.title,
                subTitle = chartModel.title.subTitle,
                titleTextHeight = title.visible ? parseInt(titleFontHeight) * textBorderConstant : 0,
                subTitleTextHeight = subTitle.visible ? parseInt(subTitleFontHeight) * textBorderConstant : 0,
                titleTextHeight = (chartModel.titleWrapTextCollection && chartModel.titleWrapTextCollection.length > 1) ? chartModel._titleLocation._height * chartModel.titleWrapTextCollection.length - 1 : titleTextHeight,
                subTitleTextHeight = (chartModel.subTitleWrapTextCollection && chartModel.subTitleWrapTextCollection.length > 1) ? chartModel._subTitleLocation.size.height : subTitleTextHeight;
                if ((chartModel.legend.border) && (!subTitle.text)) {
                    subTitleTextHeight = 0;
                    subTitleBorderSpacing = 5;
                }
            
            if (legendPosition == 'right' || legendPosition == 'left') {
                hPadding = 10;
            } else {
                vPadding = isScroll ? svgHeight > 200 ? 10 : svgHeight > 100 ? 5 : 0 : 10;
            }
            legendViewerBounds.Height += legendTitleHeight,
            legendBounds.Height += legendTitleHeight;            
            if (legend.visible) {                
                // draw legend.
                if (legendPosition != 'custom') {
                    if (AreaType == "cartesianaxes") {
                        switch (legendPosition) {
                            case "bottom":
                                legendBounds.Y = areaBounds.Y + areaBounds.Height + hSizeNear - (elementSpacing / 2) + bottomScroll;
                                break;
                            case "top":
                                legendBounds.Y = titleLocation == 0 ? borderSize + elementSpacing : (titleTextHeight + titleBorderSpacing + subTitleTextHeight + subTitleBorderSpacing + elementSpacing);
                                break;
                            case "right":
                                legendBounds.X = areaBounds.X + areaBounds.Width + vSizeFar + elementSpacing * 2;
                                break;
                            case "left":
                                legendBounds.X = areaBounds.X - vSizeNear - actualBounds.Width - (elementSpacing / 2) - (legendBorder * 2) - leftScroll;
                                break;
                        }
                    } else {
                        switch (legendPosition) {
                            case "bottom":
                                legendBounds.Y = svgHeight - (actualBounds.Height + (legendBorder)) - (elementSpacing * 2);
                                break;
                            case "top":
                                legendBounds.Y = titleLocation == 0 ? borderSize + elementSpacing : (titleTextHeight + titleBorderSpacing + subTitleTextHeight + subTitleBorderSpacing + elementSpacing);
                                break;
                            case "right":
                                legendBounds.X = svgWidth - actualBounds.Width - (elementSpacing * 2);
                                break;
                            case "left":
                                legendBounds.X = borderSize + (elementSpacing * 2);
                                break;
                        }
                    }                    
                    //Avoid axis and legend overlapping during crossing
                    if (!chartModel.enable3D && AreaType == "cartesianaxes" && params._crossAxisOverlap!=null) {                        						
                        for (var i = 0, len = chartModel._axes.length; i < len; i++) {
                            var axis = chartModel._axes[i], axisBounds = params.axes[axis.name]._bounds;
                                var hor = axis.orientation.toLowerCase() === 'horizontal';
                                if (legendPosition=="top" && hor && axis._opposed && (axis.y - axisBounds < legendBounds.Y + legendBounds.Height))
                                    legendBounds.Y -= legendBounds.Y + legendBounds.Height - axis.y + axisBounds;
                                else if (legendPosition=="bottom" && hor && !axis._opposed && (axis.y + axisBounds > legendBounds.Y))                                    
                                    legendBounds.Y += axis.y + axisBounds - legendBounds.Y;
                                else if (legendPosition=="left" && !hor && axis._opposed && (axis.x - axisBounds < legendBounds.X + legendBounds.Width))
                                    legendBounds.X += axis.x + axisBounds - legendBounds.X;                                    
                                else if (legendPosition=="right" && !hor && !axis._opposed && (axis.x + axisBounds > legendBounds.X))
                                    legendBounds.X -= legendBounds.X + legendBounds.Width - axis.x + axisBounds;                            
                        }
                    }
                    if (legendPosition == 'left' || legendPosition == 'right') {
                        if (isScroll) {
                            switch (alignment) {
                                case "center":
                                    legendBounds.Y = areaBounds.Height / 2 - (actualBounds.Height / 2) + areaBounds.Y - legendBorder;
                                    break;
                                case "near":
                                    legendBounds.Y = areaBounds.Y;
                                    break;
                                case "far":
                                    legendBounds.Y = areaBounds.Y + areaBounds.Height - actualBounds.Height - (legendBorder * 2);
                                    break;
                            }
                        } else {
                            switch (alignment) {
                                case "center":
                                    legendBounds.Y = (svgHeight / 2) - ((actualBounds.Height + legendBorder * 2) / 2) + (elementSpacing / 2);
                                    break;
                                case "near":
                                    legendBounds.Y = borderSize + (elementSpacing * 2);
                                    break;
                                case "far":
                                    legendBounds.Y = svgHeight - (actualBounds.Height + (legendBorder)) - (elementSpacing * 2);
                                    break;
                            }
                        }

                    } else {
                        switch (alignment) {
                            case "center":
                                legendBounds.X = (svgWidth / 2) - ((actualBounds.Width + legendBorder * 2) / 2) + (elementSpacing / 2);
                                break;
                            case "near":
                                legendBounds.X = borderSize + (elementSpacing * 2);
                                break;
                            case "far":
                                legendBounds.X = svgWidth - (actualBounds.Width + (legendBorder)) - (elementSpacing * 2);
                                break;
                        }
                    }
                } else {
                    legendBounds.Y = (legend.location.y < svgHeight) ? legend.location.y : 0;
                    legendBounds.X = (legend.location.x < svgWidth) ? legend.location.x : 0;
                }
                if (isScroll) {
                    if (legendPosition == 'right' || legendPosition == 'left') {
                        if (legendBounds.Y < areaBounds.Y || actualBounds.Height + (legendBorder * 2) >= areaBounds.Height) {
                            var legendHeight = (legendBorder * 2);
                            for (var k = 0; k < collectionLength; k++) {
                                legendHeight += legendCollection[k].Bounds.Height + itemPadding;
                                if (legendHeight > areaBounds.Height) {
                                    actualBounds.Height = areaBounds.Height - (legendBorder * 2);
                                    legendBounds.Y = areaBounds.Y;
                                    break;
                                }
                            }
                        }
                    }
                    else {
                        if ((legendBorder * 2 + actualBounds.Width) >= svgWidth) {
                            var legendWidth = (legendBorder * 2);
                            for (var k = 0; k < collectionLength; k++) {
                                legendWidth += legendCollection[k].Bounds.Width + itemPadding;
                                if (legendWidth > svgWidth) {
                                    actualBounds.Width = svgWidth - (legendBorder * 2) - actualBounds.vScrollSize - (borderSize * 2);
                                    legendBounds.X = (svgWidth / 2) - ((actualBounds.Width + legendBorder * 2) / 2) + (elementSpacing / 2);
                                    break;
                                }

                            }
                        }
                    }
                }
                    
                //Set height and width to legend Canvas element
                chart.legendSvgContainer.height = legendBounds.Height;
                chart.legendSvgContainer.width = Math.max(legendTitleWidth, legendBounds.Width);
                currentX = startX = hPadding;
                currentY = startY = vPadding;
                if (legendTitle.text != "" && legendTitle.text) {
                    this.drawLegendTitle();
                    currentY = startY = vPadding + legendTitleHeight;
                }
                for (var k = 0; k < collectionLength; k++) {
                    if ((legend.rowCount < legend.columnCount || legend.rowCount == legend.columnCount )&& (legendPosition == 'top'|| legendPosition == 'bottom'|| legendPosition == 'custom' )) {
                        if ((currentX + legendCollection[k].Bounds.Width) > legendBounds.Width + startX) {
                            currentX = hPadding;
                            currentY += legendCollection[k].Bounds.Height + itemPadding;
                        }
                        this.drawLegendItem(legendCollection[k], currentX, (currentY));
                        currentX += legendCollection[k].Bounds.Width + itemPadding;
                    }
                    else {
                        if (((currentY + legendCollection[k].Bounds.Height + itemPadding) + legendTitleHeight + borderSize > legendBounds.Height + startY)) {
                            currentY = startY;
                            currentX += maxWidth + (itemPadding);
                        }
                        this.drawLegendItem(legendCollection[k], (currentX), (currentY));
                        currentY += legendCollection[k].Bounds.Height + itemPadding;
                        maxWidth = Math.max(maxWidth, legendCollection[k].Bounds.Width);
                    }
                }
                var legendVal  = chart.legendContainer[0].offsetLeft;
                var chartOffsetVal = $(chart.element).offset();
                var offsetVal = (chart.vmlRendering) ? (legendVal <= 0) ? legendBounds.X : (legendVal  - chartOffsetVal.left) : 
                                ($(chart.svgObject).offset().left - chartOffsetVal.left);
                var legnTx = (chart.vmlRendering) ? offsetVal : legendBounds.X + (offsetVal <= 0 ? 0 : offsetVal);
                legendContainer.attr('style','');
				if (legend._ejScroller)
				    $('#' + legendContainer[0].id).ejScroller("instance").destroy();
                legendContainer.show();
                legendContainer.css({ "position": "absolute", "background": legend.background, "left": legnTx, "top": legendBounds.Y, "width": actualBounds.Width, "height": actualBounds.Height, "border-width": legend.border.width, "border-color": legend.border.color, "border-style": "solid" });
				legendContainer.addClass("e-legendborder");
                legendSvgContainer.css({ "height": legendBounds.Height, "width": legendBounds.Width });
                legendBounds.Height = legendBounds.Height - (padding - (vPadding * 2));
                var isVisible = this.legendRectSpace(legendBounds, actualBounds);
                if (isScroll) {
                    if (legend._ejScroller) {
                        if (!isVisible && (legendBounds.Width > Math.ceil(actualBounds.Width) || legendBounds.Height > Math.ceil(actualBounds.Height))) {
                            $('#' + legendContainer[0].id).ejScroller({ scrollTop: chart.scrolltop, scrollLeft: chart.scrollleft,height: actualBounds.Height, width: actualBounds.Width });
                            isScrolling = true;
                            if (legendBounds.Height > Math.ceil(actualBounds.Height)) {
                                if (actualBounds.vScrollSize == 0) {
                                    vScrollSize = legendContainer[0].offsetWidth + (legendBorder * 5) - legendContainer[0].clientWidth;
                                    legendContainer.css({ "width": actualBounds.Width + vScrollSize });
                                }
                            }
                        } else {
                            legend._ejScroller = false;
                        }
                    }
                    else {
                        if (!isVisible && legendBounds.Width > Math.ceil(actualBounds.Width) && legendBounds.Height > Math.ceil(actualBounds.Height)) {
                            legendContainer.css({ "overflow": "scroll" });
                            isScrolling = true;
                        } else {
                            if (!isVisible && legendBounds.Height > Math.ceil(actualBounds.Height) && actualBounds.vScrollSize >= 0) {
                                legendContainer[0].style.overflowY = "scroll";
                                legendContainer[0].style.overflowX = "hidden";
                                if (actualBounds.vScrollSize == 0) {
                                    vScrollSize = legendContainer[0].offsetWidth - (legendBorder * 2) - legendContainer[0].clientWidth;
                                    legendContainer.css({ "width": actualBounds.Width + vScrollSize });
                                }
                                isScrolling = true;
                            }
                            if (!isVisible && legendBounds.Width > Math.ceil(actualBounds.Width) && actualBounds.hScrollSize >= 0) {
                                legendContainer[0].style.overflowX = "scroll";
                                legendContainer[0].style.overflowY = "hidden";
                                if (actualBounds.hScrollSize == 0) {
                                    hScrollSize = legendContainer[0].offsetHeight - (legendBorder * 2) - legendContainer[0].clientHeight;
                                    legendContainer.css({ "height": actualBounds.Height + hScrollSize });
                                }
                                isScrolling = true;
                            }
                        }
                    }
                }
                
                chart.svgRenderer.append(chart.gLegendEle, chart.legendSvgContainer);
                if (!isScrolling) {
                    legendContainer.css({ "width": actualBounds.Width - actualBounds.vScrollSize, "height": actualBounds.Height - actualBounds.hScrollSize });
                }
				if (!legend._ejScroller) {
					if (chart.scrolltop != undefined)
						legendContainer.scrollTop(chart.scrolltop);
					if (chart.scrollleft != undefined)
						legendContainer.scrollLeft(chart.scrollleft);
				}                

            }
            else
                legendContainer.hide();
        }
    };
})(jQuery);;

ej.seriesTypes = {};

ej.EjSeriesRender = function () {

};
ej.indicatorTypes = {};

ej.EjIndicatorRender = function () {

};
ej.trendlineTypes = {};

ej.EjTrendLineRenderer = function () {

};
(function ($) {
    ej.EjTrendLineRenderer.prototype = {
        draw: function (trendline, series, sender) {
            this.chartObj = sender;
            var trendIndex = $.inArray(trendline, series.trendlines);
			trendline._isTransposed = sender.model.requireInvertedAxes;
            trendline.xAxis = series.xAxis;
            trendline.yAxis = series.yAxis;
            var type = trendline.type.toLowerCase();
            if (type == "linear" || type == "movingaverage")
                this.calculateLineDirection(trendline, series, trendIndex);
            else
                this.calculateSplineDirection(trendline, series, trendIndex);

            return false;
        },        
        calculateSplineDirection: function (trendline, series, trendIndex) {
            //var series = trendline;
            var spDirection = "";
            var splinesb = ej.EjSvgRender.utils._getStringBuilder();
            var startingPoint = true;
            var yIndex = 0;
            var visiblePoints = trendline.points;
            var ySpline = ej.EjSeriesRender.prototype.naturalSpline(visiblePoints);
            var firstPoint = null;
            var secondPoint = null;
            var firstIndex = -1;
            var canvasX = 0;
            var canvasY = 0;
            var point, pointIndex;
            var length = visiblePoints.length;
            for (var i = 0; i < length; i++) {
                pointIndex = i;
                secondPoint = visiblePoints[i];
                    if (firstPoint != null) {
                        var controlPoint1 = null;
                        var controlPoint2 = null;
                        var data = ej.EjSeriesRender.prototype.getBezierControlPoints(firstPoint, secondPoint, ySpline[firstIndex], ySpline[pointIndex], yIndex);
                        controlPoint1 = data["controlPoint1"];
                        controlPoint2 = data["controlPoint2"];
                        var pt1 = ej.EjSvgRender.utils._getPoint(firstPoint, trendline);
                        var pt2 = ej.EjSvgRender.utils._getPoint(secondPoint, trendline);
                        var bpt1 = ej.EjSvgRender.utils._getPoint(controlPoint1, trendline);
                        var bpt2 = ej.EjSvgRender.utils._getPoint(controlPoint2, trendline);
                        var chartObj = this.chartObj;
                        if (startingPoint) {
                            splinesb.append("M" + " " + (pt1.X) + " " + (pt1.Y) + " " + "C" + " " + (bpt1.X) + " " + (bpt1.Y) + " " + (bpt2.X) + " " + (bpt2.Y) + " " + (pt2.X) + " " + (pt2.Y) + " ");
                            startingPoint = false;
                        }
                        else
                            splinesb.append("C" + " " + (bpt1.X) + " " + (bpt1.Y) + " " + (bpt2.X) + " " + (bpt2.Y) + " " + (pt2.X) + " " + (pt2.Y) + " ");
                    }
                    firstPoint = secondPoint;
                    firstIndex = pointIndex;
            }
            spDirection = splinesb.toString();
            this._drawLinePath(trendline, series, spDirection, trendIndex);

            return false;
        },
        calculateLineDirection: function (trendline, series, trendIndex) {
            var canvasX = 0;
            var canvasY = 0;
            var point;           
            var lDirection;
            var sb = ej.EjSvgRender.utils._getStringBuilder();

            var firstPoint = false;
            var secondPoint;
            var length = trendline.points.length;
            for (var i = 0; i < length; i++) {
                secondPoint = trendline.points[i];
                    point = ej.EjSvgRender.utils._getPoint(secondPoint, trendline);
                    if (firstPoint)
                        sb.append("L" + " " + (point.X) + " " + ((point.Y)) + " ");
                    else {
                        sb.append("M" + " " + (point.X) + " " + ((point.Y)) + " ");
                        sb.append("L" + " " + (point.X) + " " + ((point.Y)) + " ");
                        firstPoint = true;
                    }
            }
            lDirection = sb.toString();
            this._drawLinePath(trendline, series, lDirection, trendIndex);
            return false;
        },
        _drawLinePath: function (trendline, series, lDirection, trendIndex) {
            var translate = [];
            translate[0] = trendline.xAxis.x;
            translate[1] = trendline.yAxis.y;

            if (lDirection != "") {
                var options = {
                    'id': this.chartObj.svgObject.id + "_" + trendline.seriesIndex + "_" + trendIndex + "_" + trendline.name.replace(/[^a-zA-Z ]/g, ""),
                    'fill': 'none',
                    'stroke-dasharray': trendline.dashArray,
                    'stroke-width': trendline.width,
                    'stroke': trendline.fill,
                    'opacity': trendline.opacity,
                    'd': lDirection
                };
                trendline.id = options.id;
                this.chartObj.svgRenderer.drawPath(options, series.gTrendGroupEle, translate);
            }
            this.chartObj.svgRenderer.append(series.gTrendGroupEle, this.chartObj.gTrendlinesGroupEle[trendline.seriesIndex]);

            return false;
        },

        calculateTrendLineSegment: function (series, trendline, axis, sender) {
            var chartmodel = sender.model;
            var axis, points = $.extend([], series.points);
            var trendlineType = trendline.type.toLowerCase();
            trendline.backwardForecast = trendline.backwardForecast < 0 ? 0 : trendline.backwardForecast;
            trendline.forwardForecast = trendline.forwardForecast < 0 ? 0 : trendline.forwardForecast;
            points = points.sort(function(a,b) {return (a.xValue> b.xValue) ? 1 : ((b.xValue > a.xValue) ? -1 : 0);});
            switch (trendlineType) {
                case "linear":
                    this.updateTrendSource(points, trendline);
                    this.calculateLinearTrendline(series, trendline, axis);
                    break;
                case "exponential":
                    this.updateExponentialTrendSource(points, trendline);
                    this.calculateExponentialTrendline(series, trendline, axis);
                    break;
                case "logarithmic":
                    this.updateLogarithmicTrendSource(points, trendline);
                    this.calculateLogarithmicTrendline(series, trendline, axis);
                    break;
                case "power":
                    this.updatePowerTrendSource(points, trendline);
                    this.calculatePowerTrendline(series, trendline, axis);
                    break;
                case "polynomial":
				    var length = series.points.length;
				    trendline.polynomialOrder = length <= trendline.polynomialOrder ? length : trendline.polynomialOrder;
                    trendline.polynomialOrder = trendline.polynomialOrder < 2 ? 2 : trendline.polynomialOrder;
                    trendline.polynomialOrder = trendline.polynomialOrder > 6 ? 6 : trendline.polynomialOrder;
                    if (length > 1) {
                        this.updateTrendSource(points, trendline);
                        this.calculatePolynomialTrendline(series, trendline, axis);
                    }
                    break;
                case "movingaverage":
                    this.updateMovingAverageTrendSource(points, trendline);
                    this.calculateMovingAverageTrendline(series, trendline, axis);
                    break;
            }
            if (series.points.length > 1)
                this.calculateTrendLineRange(trendline, axis);
            return false;
        },
        updateTrendSource: function (points, trendline) {
            var len = points.length, point, xValue;

            trendline.xPoints = [];
            trendline.xValues = [];
            trendline.yValues = [];
            for (var i = 0; i < len; i++) {
                point = points[i];
                if (!point.isEmpty) {
                    trendline.xPoints.push(point.xValue);
                    xValue = typeof (point.xValue) === 'number' ? point.xValue : Date.parse(point.xValue);
                    trendline.xValues.push(xValue);
                    trendline.yValues.push(point.y);
                }
            }
            this.calculateSumXAndYValue(trendline);
            return false;
        },
        calculateLinearTrendline: function (series, trendline, axis) {            
            
            var count = trendline.xValues.length;
            var x1, x2;
            trendline.points = [];

            if (count > 1) {
                if (axis._valueType.toLowerCase() == "datetime") {
                    x1 = this._increaseDateTimeInterval(trendline.xPoints[0], -trendline.backwardForecast, axis._intervalType);
                    x2 = this._increaseDateTimeInterval(trendline.xPoints[count - 1], trendline.forwardForecast, axis._intervalType);
                } else {
                     x1 = (trendline.xPoints[0] - trendline.backwardForecast);
                     x2 = (trendline.xPoints[count - 1] + trendline.forwardForecast );
                }

                //trendline linear segment  y = ax + b;
                var y1 = trendline.slope * x1 + trendline._intercept;
                var y2 = trendline.slope * x2 + trendline._intercept;
                trendline.points.push({ x: x1, xValue: x1, y: y1, YValues: [], visible: true });
                trendline.points.push({ x: x2, xValue: x2, y: y2, YValues: [], visible: true });

                trendline.points[0].YValues[0] = trendline.points[0].y;
                trendline.points[1].YValues[0] = trendline.points[1].y;
            }
            return false;
        },
       
        //// Calculate Trendline range
        calculateTrendLineRange: function (trendline, axis) {

            var length = trendline.points.length;
            var y;
            trendline.minY = trendline.points[0].y;
            trendline.maxY = trendline.points[length-1].y;
            if (!axis.setRange) {
                if (trendline.backwardForecast > 0 && axis._valueType != "category" && length > 1) {
                    axis.range.min = axis.range.min > trendline.points[0].x ? trendline.points[0].x : axis.range.min;
                    axis.visibleRange.min = axis.range.min;
                }
                if (trendline.forwardForecast > 0 && length > 1) {
                    axis.range.max = axis.range.max < trendline.points[length - 1].x ? trendline.points[length - 1].x : axis.range.max;
                    axis.visibleRange.max = axis.range.max;
                }
            }
            for (var i = 0; i < length; i++) {
                y = trendline.points[i].y;
                trendline.minY = Math.min(trendline.minY, y);
                trendline.maxY = Math.max(trendline.maxY, y);
            }
            return false;
        },

        /// Calculate Sum of x and y values
        calculateSumXAndYValue: function (trendline) {
            var points = trendline.points,
            N = trendline.xPoints.length,
            type = trendline.type.toLowerCase(),
            Slope, Intercept, SX = 0, SY = 0,
            SXX = 0, SXY = 0, SYY = 0, i,
            SumProduct = 0, X = trendline.xValues, Y = trendline.yValues;

            for (i = 0; i < N; i++) {
                SX = SX + X[i];
                SY = SY + Y[i];
                SumProduct = SumProduct + (X[i] * Y[i]);
                SXY = SXY + X[i] * Y[i];
                SXX = SXX + X[i] * X[i];
                SYY = SYY + Y[i] * Y[i];
            }
            if (!ej.util.isNullOrUndefined(trendline.intercept) && (type == "linear" || type == "exponential" || type == "polynomial")) { //Set intercept value externally
                switch (type) {
                    case "polynomial":
                        Slope = (((SumProduct) - (Math.log(trendline.intercept) * SX)) / SXX) * 3;
                        break;
                    case "linear":
                        Slope = ((SumProduct) - (trendline.intercept * SX)) / SXX;
                        break;
                    case "exponential":
                        Slope = ((SumProduct) - (Math.log(trendline.intercept) * SX)) / SXX;
                        break;

                }
                trendline._intercept = trendline.intercept;
            }
            else {
                Slope = ((N * SXY) - (SX * SY)) / ((N * SXX) - (SX * SX));
                if (type == "exponential" || type == "power")
                    Intercept = Math.exp((SY - (Slope * SX)) / N);
                else
                    Intercept = (SY - (Slope * SX)) / N;

                trendline._intercept = Intercept;
            }
            trendline.slope = Slope;
            return false;
        },

        ////Calculate forward backward Forecast points for dateTime axis
        _increaseDateTimeInterval: function (date, interval, intervalType) {
        var result = new Date(date);
        if (intervalType.toLowerCase() == "days") {
            result.setDate(date.getDate() + interval);
        } else if (intervalType.toLowerCase() == "hours") {
            result.setHours(date.getHours() + interval);
        } else if (intervalType.toLowerCase() == "milliseconds") {
            result.setMilliseconds(date.getMilliseconds() + interval);
        } else if (intervalType.toLowerCase() == "seconds") {
            result.setSeconds(date.getSeconds() + interval);
        } else if (intervalType.toLowerCase() == "minutes") {
            result.setMinutes(date.getMinutes() + interval);
        } else if (intervalType.toLowerCase() == "months") {
            result.setMonth(date.getMonth() + interval);
        } else if (intervalType.toLowerCase() == "years") {
            result.setYear(date.getFullYear() + interval);
        }
        return result;
        }

    },

    ej.ejLinear = ejExtendClass(ej.EjTrendLineRenderer);
    ej.trendlineTypes.linear = ej.ejLinear;

    ej.Exponential = ejExtendClass(ej.EjTrendLineRenderer, {

        updateExponentialTrendSource: function (points, trendline) {
            var len = points.length, point, xValue;
            trendline.xPoints = [];
            trendline.xValues = [];
            trendline.yValues = [];
            for (var i = 0; i < len; i++) {
                point = points[i];
                if (!point.isEmpty) {
                    trendline.xPoints.push(point.xValue);
                    xValue = typeof (point.xValue) === 'number' ? point.xValue : Date.parse(point.xValue);
                    trendline.xValues.push(xValue);
                    trendline.yValues.push(Math.log(point.y));
                }
            }
            this.calculateSumXAndYValue(trendline);
            return false;
        },
        calculateExponentialTrendline: function (series, trendline, axis) {
            var count = trendline.xValues.length;
            var x1, x2, x3;
            var X1, X2, X3;
            
            var midPoint = Math.round((count / 2));
            trendline.points = [];
            
            if (count > 1) {
                if (axis._valueType.toLowerCase() == "datetime") {
                    x1 = this._increaseDateTimeInterval(trendline.xPoints[0], -trendline.backwardForecast, axis._intervalType);
                    X1 = x1.getTime();
                    x2 = (trendline.xPoints[midPoint - 1]);
                    X2 = x2.getTime();
                    x3 = this._increaseDateTimeInterval(trendline.xPoints[count - 1], trendline.forwardForecast, axis._intervalType);
                    X3 = x3.getTime();
                } else {
                    x1 = X1 = (trendline.xPoints[0] - trendline.backwardForecast);
                    x2 = X2 = (trendline.xPoints[midPoint-1]);
                    x3 = X3 =(trendline.xPoints[count - 1] + trendline.forwardForecast);
                }

                //trendline exponential segment  (Intercept * Math.Exp(Slope * xValue));
                var y1 = (trendline._intercept * Math.exp(trendline.slope * x1));
                var y2 = (trendline._intercept * Math.exp(trendline.slope * x2));
                var y3 = (trendline._intercept * Math.exp(trendline.slope * x3));
                trendline.points.push({ x: x1, xValue: X1, y: y1, YValues: [], visible: true });
                trendline.points.push({ x: x2, xValue: X2, y: y2, YValues: [], visible: true });
                trendline.points.push({ x: x3, xValue: X3, y: y3, YValues: [], visible: true });

                trendline.points[0].YValues[0] = trendline.points[0].y;
                trendline.points[1].YValues[0] = trendline.points[1].y;
                trendline.points[2].YValues[0] = trendline.points[2].y;
            }
            return false;
        }
    });
    ej.trendlineTypes.exponential = ej.Exponential;

    ej.Logarithmic = ejExtendClass(ej.EjTrendLineRenderer, {

        updateLogarithmicTrendSource: function (points, trendline) {
            var len = points.length, point, xValue;
            trendline.xPoints = [];
            trendline.xValues = [];
            trendline.yValues = [];
            for (var i = 0; i < len; i++) {
                point = points[i];
                if (!point.isEmpty) {
                    trendline.xPoints.push(point.xValue);
                    xValue = typeof (point.xValue) === 'number' ? point.xValue : Date.parse(point.xValue);
                    trendline.xValues.push(Math.log(xValue));
                    trendline.yValues.push(point.y);
                }
            }
            this.calculateSumXAndYValue(trendline);
            return false;
        },
        calculateLogarithmicTrendline: function (series, trendline, axis) {
            var count = trendline.xValues.length;
            var x1, x2, x3;
            var X1, X2, X3;
            var midPoint = Math.round((count / 2));
            trendline.points = [];

            if (count > 1) {
                if (axis._valueType.toLowerCase() == "datetime") {
                    x1 = this._increaseDateTimeInterval(trendline.xPoints[0], -trendline.backwardForecast, axis._intervalType);
                    X1 = x1.getTime();
                    x2 = (trendline.xPoints[midPoint - 1]);
                    X2 = x2.getTime();
                    x3 = this._increaseDateTimeInterval(trendline.xPoints[count - 1], trendline.forwardForecast, axis._intervalType);
                    X3 = x3.getTime();
                } else {
                    x1 = X1 = (trendline.xPoints[0] - trendline.backwardForecast);
                    x2 = X2 = (trendline.xPoints[midPoint-1]);
                    x3 = X3 = (trendline.xPoints[count - 1] + trendline.forwardForecast);
                }

                //trendline logarithmic segment  Intercept + Slope * Math.Log(xValue);
                var y1 = trendline._intercept + (trendline.slope * Math.log(x1));
                var y2 = trendline._intercept + (trendline.slope * Math.log(x2));
                var y3 = trendline._intercept + (trendline.slope * Math.log(x3));
                trendline.points.push({ x: x1, xValue: X1, y: y1, YValues: [], visible: true });
                trendline.points.push({ x: x2, xValue: X2, y: y2, YValues: [], visible: true });
                trendline.points.push({ x: x3, xValue: X3, y: y3, YValues: [], visible: true });

                trendline.points[0].YValues[0] = trendline.points[0].y;
                trendline.points[1].YValues[0] = trendline.points[1].y;
                trendline.points[2].YValues[0] = trendline.points[2].y;
            }
            return false;
        }
    });
    ej.trendlineTypes.logarithmic = ej.Logarithmic;

    ej.Power = ejExtendClass(ej.EjTrendLineRenderer, {

        updatePowerTrendSource: function (points, trendline) {
            var len = points.length, point, xValue;
            trendline.xPoints = [];
            trendline.xValues = [];
            trendline.yValues = [];
            for (var i = 0; i < len; i++) {
                point = points[i];
                if (!point.isEmpty) {
                    trendline.xPoints.push(point.xValue);
                    xValue = typeof (point.xValue) === 'number' ? point.xValue : Date.parse(point.xValue);
                    trendline.xValues.push(Math.log(xValue));
                    trendline.yValues.push(Math.log(point.y));
                }
            }
            this.calculateSumXAndYValue(trendline);
            return false;
        },
        calculatePowerTrendline: function (series, trendline, axis) {
            var count = trendline.xValues.length;
            var x1, x2, x3;
            var X1, X2, X3;
            var midPoint = Math.round((count / 2));
            trendline.points = [];

            if (count > 1) {
                if (axis._valueType.toLowerCase() == "datetime") {
                    x1 = this._increaseDateTimeInterval(trendline.xPoints[0], -trendline.backwardForecast, axis._intervalType);
                    X1 = x1.getTime();
                    x2 = (trendline.xPoints[midPoint - 1]);
                    X2 = x2.getTime();
                    x3 = this._increaseDateTimeInterval(trendline.xPoints[count - 1], trendline.forwardForecast, axis._intervalType);
                    X3 = x3.getTime();
                } else {
                    var p1 = (trendline.xPoints[0] - trendline.backwardForecast);
                    x1 = X1 = p1 > -1 ? p1 : 0;
                    x2 = X2 = (trendline.xPoints[midPoint - 1]);
                    x3 = X3 = (trendline.xPoints[count - 1] + trendline.forwardForecast);
                }

                //trendline power segment  (Intercept * Math.Pow(xValue, Slope))
                var y1 = trendline._intercept * Math.pow(x1, trendline.slope);
                var y2 = trendline._intercept * Math.pow(x2, trendline.slope);
                var y3 = trendline._intercept * Math.pow(x3, trendline.slope);
                trendline.points.push({ x: x1, xValue: X1, y: y1, YValues: [], visible: true });
                trendline.points.push({ x: x2, xValue: X2, y: y2, YValues: [], visible: true });
                trendline.points.push({ x: x3, xValue: X3, y: y3, YValues: [], visible: true });

                trendline.points[0].YValues[0] = trendline.points[0].y;
                trendline.points[1].YValues[0] = trendline.points[1].y;
                trendline.points[2].YValues[0] = trendline.points[2].y;
            }
            return false;
        }
    });
    ej.trendlineTypes.power = ej.Power;

    ej.Polynomial = ejExtendClass(ej.EjTrendLineRenderer, {

        //// Calculate Polynomial Trendline with order
        calculatePolynomialTrendline: function (series, trendline, axis) {
            var power = trendline.polynomialOrder;

            // Calculate sum of y datapoints 1 X power matrix
            trendline.polynomialSlopes = new Array(power + 1);
            var xLength = trendline.xValues.length;
            for (var index1 = 0; index1 < xLength; index1++)
            {
                var num2 = trendline.xValues[index1];
                var yval = trendline.yValues[index1];
                
                for (var index2 = 0; index2 <= power; ++index2) {
                    if (!trendline.polynomialSlopes[index2]) trendline.polynomialSlopes[index2] = 0;
                    trendline.polynomialSlopes[index2] += Math.pow(num2, index2) * yval;
                }
            }

            // Calculate sum matrix of x datapoints
            var numArray = new Array(1 + 2 * power);
            var matrixOfA = new Array(power + 1);
            for (var i = 0; i < (power + 1); i++)
                matrixOfA[i] = new Array(3);
            var num1 = 0;
            for (var index1 = 0; index1 < xLength; ++index1) {
                var num2 = 1.0;
                var d = trendline.xValues[index1];
                for (var index2 = 0; index2 < numArray.length; ++index2) {
                    if (!numArray[index2]) numArray[index2] = 0;
                    numArray[index2] += num2;
                    num2 *= d;
                    ++num1;
                }   
            }

            for (var index1 = 0; index1 <= power; ++index1) {
                for (var index2 = 0; index2 <= power; ++index2)
                    matrixOfA[index1][index2] = numArray[index1 + index2];
            }

            //Calculation Gauss jordan eliminiation value of a and b matrix
            if (!this.gaussJordanEliminiation(matrixOfA, trendline.polynomialSlopes))
                trendline.polynomialSlopes = null;

            //Create segments methods
            this.createPolynomialSegments(series, axis, trendline);
            return false;
        },
        createPolynomialSegments: function (series, axis, trendline) {
            var polynomialSlopes = trendline.polynomialSlopes;
            if (polynomialSlopes != null) {
                var count = trendline.xValues.length, midPoint = Math.round((count / 2)), x1 = 1, X, length = polynomialSlopes.length;
                var valueType = axis._valueType.toLowerCase();

                trendline.points = [];
                for (var i = 1; i <= length; i++) {                   
                    var x, y;
                    if (i == 1) {
                        if (valueType == "datetime") {
                            x = this._increaseDateTimeInterval(trendline.xPoints[0], -trendline.backwardForecast, axis._intervalType);
                            X = x.getTime();
                        }
                        else
                            x = X = (trendline.xPoints[0] - trendline.backwardForecast);
                        var y = this.getPolynomialYValue(polynomialSlopes, X);
                    }
                    else if (i == polynomialSlopes.length) {
                        if (valueType == "datetime") {
                            x = this._increaseDateTimeInterval(trendline.xPoints[count - 1], trendline.forwardForecast, axis._intervalType);
                            X = x.getTime();
                        }
                        else
                            x = X = (trendline.xPoints[count - 1] + trendline.forwardForecast);

                        var y = this.getPolynomialYValue(polynomialSlopes, X);
                    } else {
                        x1 += (count + trendline.forwardForecast) / polynomialSlopes.length;
                        if (valueType == "category") {
                            x = X = trendline.xPoints[0] + (x1 - 1);

                        }
                        else {
                            x = X = trendline.xPoints[parseInt(x1) - 1];
                            if (valueType == "datetime" && count > x1)
                                X = x.getTime();
                        }                        
                        var y = this.getPolynomialYValue(polynomialSlopes, X);
                    }
                    if (i == 1 || i == polynomialSlopes.length || valueType == "category" || count > x1) {
                        trendline.points.push({ x: x, xValue: X, y: y, YValues: [], visible: true });
                        trendline.points[trendline.points.length - 1].YValues[0] = trendline.points[trendline.points.length - 1].y;
                    }
                }
            }
            return false;
        },

        getPolynomialYValue: function(slopes, x){
            var sum=0;
            for (var i = 0; i < slopes.length; i++) {
                sum += slopes[i] * Math.pow(x, i);
            }
            return sum;
        },        

        gaussJordanEliminiation: function (matrixOfA, polynomialSlopes) {
            var length = matrixOfA.length;
            var numArray1 = new Array(length);
            var numArray2 = new Array(length);
            var numArray3 = new Array(length);
            for (var index = 0; index < length; ++index)
                numArray3[index] = 0;
            for (var index1 = 0; index1 < length; ++index1)
            {
                var num1 = 0.0;
                var index2 = 0;
                var index3 = 0;
                for (var index4 = 0; index4 < length; ++index4)
                {
                    if (numArray3[index4] != 1)
                    {
                        for (var index5 = 0; index5 < length; ++index5)
                        {
                            if (numArray3[index5] == 0 && Math.abs(matrixOfA[index4][index5]) >= num1)
                            {
                                num1 = Math.abs(matrixOfA[index4][index5]);
                                index2 = index4;
                                index3 = index5;
                            }
                        }
                    }
                }
                ++numArray3[index3];
                if (index2 != index3)
                {
                    for (var index4 = 0; index4 < length; ++index4)
                    {
                        var num2 = matrixOfA[index2, index4];
                        matrixOfA[index2][index4] = matrixOfA[index3][index4];
                        matrixOfA[index3][index4] = num2;
                    }
                    var num3 = polynomialSlopes[index2];
                    polynomialSlopes[index2] = polynomialSlopes[index3];
                    polynomialSlopes[index3] = num3;
                }
                numArray2[index1] = index2;
                numArray1[index1] = index3;
                if (matrixOfA[index3][index3] == 0.0)
                    return false;
                var num4 = 1.0 / matrixOfA[index3][index3];
                matrixOfA[index3][index3] = 1.0;
               
                for (var index4 = 0; index4 < length; ++index4)
                    matrixOfA[index3][index4] *= num4;
                
                polynomialSlopes[index3] *= num4;
                
                for (var index4 = 0; index4 < length; ++index4)
                {
                    if (index4 != index3)
                    {
                        var num2 = matrixOfA[index4][index3];
                        matrixOfA[index4][index3] = 0.0;
                        for (var index5 = 0; index5 < length; ++index5)
                            matrixOfA[index4][index5] -= matrixOfA[index3][index5] * num2;
                        polynomialSlopes[index4] -= polynomialSlopes[index3] * num2;
                    }
                }
            }
            for (var index1 = length - 1; index1 >= 0; --index1)
            {
                if (numArray2[index1] != numArray1[index1])
                {
                    for (var index2 = 0; index2 < length; ++index2)
                    {
                        var num = matrixOfA[index2, numArray2[index1]];
                        matrixOfA[index2][numArray2[index1]] = matrixOfA[index2][numArray1[index1]];
                        matrixOfA[index2][numArray1[index1]] = num;
                    }
                }
            }
            return true;
        }
    });
    ej.trendlineTypes.polynomial = ej.Polynomial;

    ej.MovingAverage = ejExtendClass(ej.EjTrendLineRenderer, {

        updateMovingAverageTrendSource: function (points, trendline) {
            var len = points.length, i, yVal;
            trendline.xPoints = [];
            trendline.xValues = [];
            trendline.yValues = [];
            for (i = 0; i < len; i++) {
                trendline.xPoints.push(points[i].xValue);
                trendline.xValues.push(i + 1);
                yVal = !points[i].isEmpty ? points[i].y : null;
                trendline.yValues.push(yVal);
            }
            return false;
        },
        calculateMovingAverageTrendline: function (series, trendline, axis) {
            var pointsLength = trendline.xPoints.length,
            period = trendline.period >= pointsLength ? pointsLength - 1 : trendline.period,
			x1, i, j, yVal, count, nullCount, xVal, length;
            period = period < 2 ? 2 : period;
            trendline.points = [];

            for (i = 0; i < pointsLength-1; i++) {
                yVal = count = nullCount = 0;
                for (j = i; count < period ; j++) {
                    count++;
                    if (ej.util.isNullOrUndefined(trendline.yValues[j])) nullCount++;
                    yVal += trendline.yValues[j];
                }
                yVal = period - nullCount <= 0 ? null : yVal / (period - nullCount);
                if (!ej.util.isNullOrUndefined(yVal) && !isNaN(yVal)) {
				    xVal = trendline.xPoints[period - 1 + i];
                    trendline.points.push({ 
					        x: xVal, xValue: xVal, 
					        y: yVal, YValues: [], visible: true 
					});
                    length = trendline.points.length;
                    trendline.points[length - 1].YValues[0] = trendline.points[length - 1].y;
                }
            }
        }
    });
    ej.trendlineTypes.movingaverage = ej.MovingAverage;

    ej.EjIndicatorRender.prototype = {

        draw: function (indicator, sender) {

            this.chartObj = sender;
            var translate = null;

            if (this.chartObj.model.AreaType == "cartesianaxes") {
                var transX = indicator.xAxis.x;
                var transY = indicator.yAxis.y;
                translate = 'translate(' + transX + ',' + transY + ')';
            }

            var indicatorIndex = $.inArray(indicator, this.chartObj.model.indicators);
            var indicatorOptions = { 'id': this.chartObj.svgObject.id + '_indicatorGroup' + '_' + indicatorIndex, 'transform': translate };
            this.gIndicatorGroupEle = this.chartObj.svgRenderer.createGroup(indicatorOptions);

            
            if (indicator._points.length > 0) {
                for (var i = 0; i < indicator.segment.length; i++) {
                    var segment = indicator.segment[i];
                    var style = { fill: segment.fill, width: segment.width, opacity: indicator.opacity };
                        segment.isIndicator = true;
                        segment.xAxis = indicator.xAxis;
                        segment.yAxis = indicator.yAxis;
                         if (segment.type == "line")
                            this.calculateDirection(segment, style, indicatorIndex);
                        else
                            this.drawColumn(segment, style, indicator);
                    }
                }

        },

        _drawLinePath: function (indicator, style, lDirection, indicatorIndex) {
            
          
          
           
            if (lDirection != "") {
                var options = {
				    'name': 'line',
                    'id': this.chartObj.svgObject.id + "_" + indicatorIndex + "_" + indicator.name,
                    'fill': 'none',
                    'stroke-dasharray': indicator.dashArray,
                    'stroke-width': style.width,
                    'stroke': style.fill,
                    'stroke-linecap': indicator.lineCap,
                    'stroke-linejoin': indicator.lineJoin,
                    'opacity': style.opacity,
                    'd': lDirection
                };

                this.chartObj.svgRenderer.drawPath(options, this.gIndicatorGroupEle);
            }

            this.chartObj.svgRenderer.append(this.gIndicatorGroupEle, this.chartObj.gIndicatorEle);
        },

        calculateDirection: function (currentseries, style, indicatorIndex) {
		    var canvasX = 0;
            var canvasY = 0;
		    var point;
            if (this.chartObj.model.enableCanvasRendering) {
                canvasX = currentseries.xAxis.x;
                canvasY = currentseries.yAxis.y;
            }
            currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();

            var visiblePoints = ej.EjSeriesRender.prototype._isVisiblePoints(currentseries);
            var lDirection;
            var sb = ej.EjSvgRender.utils._getStringBuilder();

            // Dashed Line issue in Indicator is fixed.
            var firstPoint = false;
            var secondPoint;
            
            for (var i = 0; i < visiblePoints.length; i++) {
                secondPoint = visiblePoints[i];
                if (secondPoint.visible) {
                     point = ej.EjSvgRender.utils._getPoint(secondPoint, currentseries);
                    if (firstPoint) {                                             
                        sb.append("L" + " " + (point.X + canvasX) + " " + ((point.Y + canvasY)) + " ");                    
                        }
                    else {                       
                        sb.append("M" + " " + (point.X + canvasX) + " " + ((point.Y + canvasY)) + " ");
                         firstPoint = true;
                       }         

                }
                else {
                    firstPoint = false;
                }

            }

            lDirection = sb.toString();

            this._drawLinePath(currentseries, style, lDirection, indicatorIndex);
        },

        drawColumn: function (option, style, indicator) {
            var series = option;
            var seriesIndex = $.inArray(indicator, this.chartObj.model.indicators);
            series.index = seriesIndex;
            var origin = Math.max(option.yAxis.visibleRange.min, 0);

            var sidebysideinfo = { Start: -0.35, End: 0.35 };
            var visiblePoints = ej.EjSeriesRender.prototype._isVisiblePoints(series);

            var cSer = this;
			 var chart = cSer.chartObj;
            for (var i = 0; i < visiblePoints.length; i++) {
                var pointIndex = i;
                var point = visiblePoints[i];

                var y1 = point.YValues[0];
                var y2 = origin;
                if (point.visible) {
                    //calculate sides
                    var data = ej.EjSeriesRender.prototype.calculateSides(point, sidebysideinfo);
                    var x1 = data.x1;
                    var x2 = data.x2;
                    var rect = ej.EjSeriesRender.prototype.getRectangle(x1, y1, x2, y2, series, chart);
					
                    //drawing part
                    var xr = Math.min(0, rect.Width);
                    var yr = Math.min(0, rect.Height);
                    if (rect.Width < 0.0001)// condition checked for IE width issue
                        rect.Width=0.0001;
                    var bounds;
                    if ((xr == 0 || yr == 0) && rect.Width > 0) {
                        options = {
                            'id': this.chartObj.svgObject.id + "_" + seriesIndex + "_" + series.name,
                            'x': rect.X + cSer.chartObj.canvasX,
                            'y': rect.Y + cSer.chartObj.canvasY,
                            'width': rect.Width,
                            'height': rect.Height,
                            'fill': (!visiblePoints[i].fill ) ? style.fill : visiblePoints[i].fill,
                            'stroke-width': series.border.width,
                            'plot': y1 < 0 ? "negative" : "positive",
                            'opacity': series.histogram.opacity,
                            'stroke': (!visiblePoints[i].fill ) ? series.border.color : visiblePoints[i].fill
                        };

                        this.chartObj.svgRenderer.drawRect(options, this.gIndicatorGroupEle);

                        var svgXy = ej.EjSvgRender.utils._getSvgXY(rect.X, (rect.Y), series, cSer.chartObj);
                        bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };

                        this._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                    }
                }
            }

            this.chartObj.svgRenderer.append(this.gIndicatorGroupEle, this.chartObj.gIndicatorEle);
        },
        _addRegion: function (chart, bounds, series, point, pointIndex) {
            var type = series.type;
            if (series.index >= 0) {
                var regionItem = { SeriesIndex: series.index, Region: { PointIndex: pointIndex, Bounds: bounds }, type: type, isIndicator: true };
                chart.model.chartRegions.push(regionItem);
            }
        },

        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
              indicator.segment = [];
              indicator.xRange = {};
              indicator.yRange = {};
			  indicator.period = parseInt(indicator.period);   // to convert float value to integer
              if (indicator.period < indicator._points.length && indicator.period > 0) {
              //Upperband 
              var upperSeries = $.extend(true, {}, indicator);
              upperSeries.name = "upperseries";
              upperSeries.fill = indicator.upperLine.fill;
              upperSeries.width = indicator.upperLine.width;
              upperSeries.type = "line";

              for (var k = 0; k < indicator._points.length; k++) {
                  indicator._points[k].YValues.length = 1;
                  indicator._points[k].YValues[0] = indicator._points[k].y = 70;
              }
              
              upperSeries.points = $.extend(true, [], indicator._points);
              var xValues = sender._getXValues(upperSeries.points);
              var yValues = sender._getYValues(upperSeries.points);
              
              indicator.xRange.min = Math.min.apply(Math, xValues);
              indicator.xRange.max = Math.max.apply(Math, xValues);
              indicator.yRange.min = Math.min.apply(Math, yValues);
              indicator.yRange.max = Math.max.apply(Math, yValues);

              indicator.segment.push(upperSeries);

              //Lowerband
              var lowerSeries = $.extend(true, {}, indicator);
              lowerSeries.name = "lowerSeries";
              lowerSeries.width = indicator.lowerLine.width;
              lowerSeries.fill = indicator.lowerLine.fill;
              lowerSeries.type = "line";
           

              for (var n = 0; n < indicator._points.length; n++) {
                  indicator._points[n].YValues[0] = indicator._points[n].y = 30;
              }

               lowerSeries.points = $.extend(true, [], indicator._points);

              yValues = sender._getYValues(lowerSeries.points);

              indicator.yRange.min = Math.min(Math.min.apply(Math, yValues), indicator.yRange.min);
              indicator.yRange.max = Math.max(Math.max.apply(Math, yValues), indicator.yRange.max);

              indicator.segment.push(lowerSeries);
              
              // signalLine
              var trendSeries = $.extend(true, {}, indicator); 
              trendSeries.name = "signalSeries";
              trendSeries.width = indicator.width;
              trendSeries.fill = indicator.fill;
              trendSeries.type = "line";
              
              var c = 0, c1 = 0;
              var pmf = 0;
              var nmf = 0;
              var len = indicator.period;
              c1 = indicator._points[0].close;

              for (var i = 1; i <=len; ++i) {
                  c = indicator._points[i].close;
                  if (c > c1)
                      pmf += c - c1;
                  else if (c < c1)
                      nmf += c1 - c;
                  c1 = c;
                  indicator._points[i-1].YValues[0] = indicator._points[i-1].y = null;
              }
              pmf = pmf / len;
              nmf = nmf / len;
              
              indicator._points[len].YValues[0] = indicator._points[len].y = 100 - 100 / (1 + pmf / nmf);

              for (var j = len + 1; j < indicator._points.length; j++) {
                  c = indicator._points[j].close;
                  if (c > c1) {
                      pmf = (pmf * (len - 1) + (c - c1)) / len;
                      nmf = (nmf * (len - 1)) / len;
                  }
                  else if (c < c1) {
                      nmf = (nmf * (len - 1) + (c1 - c)) / len;
                      pmf = (pmf * (len - 1)) / len;
                  }
                  c1 = c;
                  indicator._points[j].YValues[0] = indicator._points[j].y = 100 - (100 / (1 + pmf / nmf));
              }
              trendSeries.points = $.extend(true, [], indicator._points);
              var trendPoints = [];
              for (var i = len, j = 0; i < trendSeries.points.length; i++, j++){
                  trendPoints[j] = trendSeries.points[i].y;
				  }

              indicator.yRange.min = Math.min(Math.min.apply(Math, trendPoints), indicator.yRange.min);
              indicator.yRange.max = Math.max(Math.max.apply(Math, trendPoints), indicator.yRange.max);

              indicator.segment.push(trendSeries);
              this.calculateIndicatorRange(sender, indicator);
           }
        },

        calculateIndicatorRange: function(sender, indicator){
            //Indicator X-Axis Calculation
            if (sender.model.indicatorRange[indicator.xAxisName] == undefined) {
                sender.model.indicatorRange[indicator.xAxisName] = {};
                sender.model.indicatorRange[indicator.xAxisName] = { min: indicator.xRange.min, max: indicator.xRange.max };
            } else {
                if (sender.model.indicatorRange[indicator.xAxisName].min > indicator.xRange.min)
                    sender.model.indicatorRange[indicator.xAxisName].min = indicator.xRange.min;
                if (sender.model.indicatorRange[indicator.xAxisName].max < indicator.xRange.max)
                    sender.model.indicatorRange[indicator.xAxisName].max = indicator.xRange.max;
            }
            //Indicator Y-Axis Calculation
            if (sender.model.indicatorRange[indicator.yAxisName] === undefined) {
                sender.model.indicatorRange[indicator.yAxisName] = {};
                sender.model.indicatorRange[indicator.yAxisName] = { min: indicator.yRange.min, max: indicator.yRange.max };
            } else {
                if (sender.model.indicatorRange[indicator.yAxisName].min > indicator.yRange.min)
                    sender.model.indicatorRange[indicator.yAxisName].min = indicator.yRange.min;
                if (sender.model.indicatorRange[indicator.yAxisName].max < indicator.yRange.max)
                    sender.model.indicatorRange[indicator.yAxisName].max = indicator.yRange.max;
            }
        }
    },
    ej.ejRSI = ejExtendClass(ej.EjIndicatorRender);

    ej.indicatorTypes.rsi = ej.ejRSI;
	ej.ejMACD = ejExtendClass(ej.EjIndicatorRender, {


        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};

            var pointsLength = indicator._points.length;
            var longPeriod = indicator.longPeriod;
            var shortPeriod = indicator.shortPeriod;
            var trigger = indicator.trigger;
            var diff = longPeriod-shortPeriod;
            var shortEMA = [];
            var longEMA = [];
            var macdPoints = [];
            var signalEMA = [];
            var histogramPoints = [];
            var length = longPeriod + trigger;
            if (length <= indicator._points.length && ((length-2) >= 0) && (shortPeriod <= longPeriod) && (shortPeriod > 0)) {
                shortEMA = this.calculateEMA(indicator._points, shortPeriod, true);
                longEMA = this.calculateEMA(indicator._points, longPeriod, true);

                //Calculte MACD Line points: MACD Line: (shortPeriod EMA - longPeriod EMA)  
                for (i = 0; i < longEMA.length; i++)
                    macdPoints.push((shortEMA[i + diff] - longEMA[i]));

                //MACD Line 
                var macdSeries = $.extend(true, {}, indicator);
                macdSeries.name = "macdSeries";
                macdSeries.fill = indicator.macdLine.fill;
                macdSeries.width = indicator.macdLine.width;
                macdSeries.type = "line";
                macdSeries.xAxis = indicator.xAxis;
                macdSeries.yAxis = indicator.yAxis;

                var l = longPeriod - 1;
                for (var t = 0, i = 0; t < pointsLength; t++) {
                    if (t < l)
                        indicator._points[t].YValues[0] = indicator._points[t].y = null;
                    else {
                        indicator._points[t].YValues[0] = indicator._points[t].y = macdPoints[i];
                        i += 1;
                    }
                }
                macdSeries.points = $.extend(true, [], indicator._points);
                //////////////////////////////////////////////

                //Signal Line: Trigger value(9-day default) EMA of MACD Line 
                signalEMA = this.calculateEMA(macdPoints, trigger, false);
                var trendSeries = $.extend(true, {}, indicator);
                trendSeries.name = "signalSeries";
                trendSeries.fill = indicator.fill;
                trendSeries.width = indicator.width;
                trendSeries.type = "line";
                trendSeries.xAxis = indicator.xAxis;
                trendSeries.yAxis = indicator.yAxis;

                var l = longPeriod + trigger - 2;
                for (var t = 0, i = 0; t < pointsLength; t++) {
                    if (t < l)
                        indicator._points[t].YValues[0] = indicator._points[t].y = null;
                    else {
                        indicator._points[t].YValues[0] = indicator._points[t].y = signalEMA[i];
                        i += 1;
                    }
                }
                trendSeries.points = $.extend(true, [], indicator._points);
                /////////////////////////////////////////

                //MACD Histogram: MACD Line - Signal Line
                var histogramSeries = $.extend(true, {}, indicator);
                histogramSeries.border = {};
                histogramSeries.name = "histogramSeries";
                histogramSeries.fill = indicator.histogram.fill;
                histogramSeries.opacity = indicator.histogram.opacity;
                histogramSeries.fill = indicator.histogram.fill;
                histogramSeries.border = indicator.histogram.border;
                histogramSeries.type = "column";
                histogramSeries.xAxis = indicator.xAxis;
                histogramSeries.yAxis = indicator.yAxis;

                for (var j = 0, k = l; k < pointsLength; j++, k++)
                    histogramPoints.push((macdPoints[j + (trigger - 1)]) - (signalEMA[j]));
                for (var j = 0, k = l; k < pointsLength; j++, k++) {
                    indicator._points[k].YValues[0] = indicator._points[k].y = histogramPoints[j];
                }
                histogramSeries.points = $.extend(true, [], indicator._points);
                xValues = sender._getXValues(macdSeries.points);
                indicator.xRange.min = Math.min.apply(Math, xValues);
                indicator.xRange.max = Math.max.apply(Math, xValues);

                switch (indicator.macdType) {
                    case "line":
                        {
                            //Push MACD Line
                            indicator.yRange.min = Math.min.apply(Math, macdPoints);
                            indicator.yRange.max = Math.max.apply(Math, macdPoints);
                            indicator.segment.push(macdSeries);

                            //Push Signal Line
                            var min = Math.min.apply(Math, signalEMA), max = Math.max.apply(Math, signalEMA);
                            indicator.yRange.min = indicator.yRange.min < min ? indicator.yRange.min : min;
                            indicator.yRange.max = indicator.yRange.max > max ? indicator.yRange.max : max;
                            indicator.segment.push(trendSeries);
                        }
                        break;
                    case "histogram":
                        {
                            //Push histogram Series
                            var min1 = Math.min.apply(Math, histogramPoints), max1 = Math.max.apply(Math, histogramPoints);
                            indicator.yRange.min = indicator.yRange.min < min1 ? indicator.yRange.min : min1;
                            indicator.yRange.max = indicator.yRange.max > max1 ? indicator.yRange.max : max1;
                            indicator.segment.push(histogramSeries);
                        }
                        break;
                    case "both":
                        {
                            //Push histogram Series
                            var min1 = Math.min.apply(Math, histogramPoints), max1 = Math.max.apply(Math, histogramPoints);
                            indicator.yRange.min = indicator.yRange.min < min1 ? indicator.yRange.min : min1;
                            indicator.yRange.max = indicator.yRange.max > max1 ? indicator.yRange.max : max1;
                            indicator.segment.push(histogramSeries);

                            //Push MACD Line 
                            indicator.yRange.min = Math.min.apply(Math, macdPoints);
                            indicator.yRange.max = Math.max.apply(Math, macdPoints);
                            indicator.segment.push(macdSeries);

                            //Push Signal Line
                            var min = Math.min.apply(Math, signalEMA), max = Math.max.apply(Math, signalEMA);
                            indicator.yRange.min = indicator.yRange.min < min ? indicator.yRange.min : min;
                            indicator.yRange.max = indicator.yRange.max > max ? indicator.yRange.max : max;
                            indicator.segment.push(trendSeries);
                        }
                        break;
                }
                this.calculateIndicatorRange(sender, indicator);
            }
        },
        calculateEMA: function (points, period, flag) {
            var sma = 0;
            var initialEMA = 0;
            var pointsLength = points.length;
            var getPoints = [];
            var getEma = [];
            var emaPercent = (2 / (period + 1));
            if (flag) { // calculating EMA for Indicators Points
                for (var i = 0; i < period; i++) {
                    getPoints.push(points[i].close);
                    sma = sma + getPoints[i];
                }

                initialEMA = (sma / period);
                getEma.push(initialEMA);
                var emaAvg = initialEMA;
                for (j = period; j < pointsLength; j++) {
                    emaAvg = (points[j].close - emaAvg) * emaPercent + emaAvg;
                    getEma.push(emaAvg);
                }
            } else { //Calculating EMA for Signal Points
                for (var i = 0; i < period; i++) {
                    getPoints.push(points[i]);
                    sma = sma + getPoints[i];
                }

                initialEMA = (sma / period);
                getEma.push(initialEMA);
                var emaAvg = initialEMA;
                for (j = period; j < pointsLength; j++) {
                    emaAvg = (points[j] - emaAvg) * emaPercent + emaAvg;
                    getEma.push(emaAvg);
                }
            }
            return getEma;
        }

    });

    ej.indicatorTypes.macd = ej.ejMACD;
	ej.ejSMA = ejExtendClass(ej.EjIndicatorRender, {

      
        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};


         
            // signalLine
            var trendSeries = $.extend(true, {}, indicator);
            trendSeries.name = "trendSeries";
            trendSeries.width = indicator.width;
            trendSeries.fill = indicator.fill;
            trendSeries.type = "line";

			//variable declaration
            var closevalues = [];
            var smavalues = [];
			var trendPoints = [];
            var sum;
            var length = indicator._points.length;
            var period = indicator.period;
			
			if (period <= 0 || length < period) return;
			
			//Push the Close values
            for (var i = 0; i < length; i++) {
               
                closevalues.push(indicator._points[i].close);

            }

            var close_length =closevalues.length;
			//calculation for SMA values
			
	     
            while (close_length >= period) {
                sum = 0;
                for (var j = 0; j < period; j++) {
                    sum = sum + closevalues[j];

                }
                sum = sum / period;
                smavalues.push(sum);
                closevalues.splice(0, 1);
                close_length = closevalues.length;
            }

	 
           //set the SMA values to Y-Axis
            for (var k = 0; k < length; k++) {
                if (k < period - 1) {
                    indicator._points[k].YValues[0] = indicator._points[k].y = null;

                }
                else {
                    indicator._points[k].YValues[0] = indicator._points[k].y =smavalues[k -(period - 1) ];
                }

            }

            
            trendSeries.points = $.extend(true, [], indicator._points);
            xValues = sender._getXValues(trendSeries.points);
            
            //Assign the Y-Axis values into trendPoints
            for (var i = period-1 , j = 0; i < trendSeries.points.length; i++, j++)
             {
                trendPoints[j] = trendSeries.points[i].y;
             }
                
			//X-Axis and Y-Axis range calculation
            indicator.xRange.min = Math.min.apply(Math, xValues);
            indicator.xRange.max = Math.max.apply(Math, xValues);
            indicator.yRange.min = Math.min.apply(Math, trendPoints);
            indicator.yRange.max = Math.max.apply(Math, trendPoints);
            
			//push trendSeries
            indicator.segment.push(trendSeries);
        	this.calculateIndicatorRange(sender, indicator);
            
          
        }

    });

    ej.indicatorTypes.sma = ej.ejSMA;
	
	 ej.ejEMA = ejExtendClass(ej.EjIndicatorRender, {


        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};



            // signalLine
            
            trendSeries = $.extend(true, {}, indicator);
            trendSeries.name = "trendSeries";
            trendSeries.type = "line";
            trendSeries.xAxis = indicator.xAxis;
            trendSeries.yAxis = indicator.yAxis;


            var getCloseValues = [];       
            var ema = [];
            var pointsLength = indicator._points.length;       
            var period = indicator.period;
            var sma = 0;
            if(pointsLength < period || period <=0) return ;
            // K=Smoothing Factor
            var k = (2 / (period + 1));

            //Get a close Values and push the previous Ema 
            for (var i = 0; i < period; i++) {
                getCloseValues.push(indicator._points[i].close);
                sma = sma + getCloseValues[i];            
            }
            ema.push(sma / period);

            //Find Remaining EMA by Adding smoothing factor K to the close values
            for (j = period; j < pointsLength; j++)
                  {              
                   ema.push((indicator._points[j].close - ema[j - period]) * k + ema[j - period]);                  
                   }        
            
            // Set Ema to the Indicator Points
           
            for (var t = 0; t < pointsLength; t++) {
                if (t < (period - 1)) {
                    indicator._points[t].YValues[0] = indicator._points[t].y = null;
                }
                else if (t >= (period - 1))
                {
                    indicator._points[t].YValues[0] = indicator._points[t].y = ema[t - (period - 1)];
                }
            }
             
            // Send the indicator Points for draw series.
            trendSeries.points = $.extend(true, [], indicator._points);
            xValues = sender._getXValues(trendSeries.points);
            var trendPoints = [];
            for (var i = period, j = 0; i < trendSeries.points.length; i++, j++)
                trendPoints[j] = trendSeries.points[i].y;

            indicator.xRange.min = Math.min.apply(Math, xValues);
            indicator.xRange.max = Math.max.apply(Math, xValues);
            indicator.yRange.min = Math.min.apply(Math, trendPoints);
            indicator.yRange.max = Math.max.apply(Math, trendPoints);

            indicator.segment.push(trendSeries);
        	this.calculateIndicatorRange(sender, indicator);
            
          
        }

    });

    ej.indicatorTypes.ema = ej.ejEMA;


    ej.ejSTOCHASTIC = ejExtendClass(ej.EjIndicatorRender, {

        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};
			var KPeriod = indicator.kPeriod;
            var DPeriod = indicator.dPeriod;
            var Period = indicator.period;
            if (Period < 1 || DPeriod < 1 || KPeriod < 1) return;
            if (Period > indicator._points.length || DPeriod > indicator._points.length || KPeriod > indicator._points.length) return;
			// Upper Line Calculation
            var upperSeries = $.extend(true, {}, indicator);
            upperSeries.name = "upperseries";
            upperSeries.type = "line";
            upperSeries.fill = indicator.upperLine.fill;
            upperSeries.width = indicator.upperLine.width;

            for (var k = 0; k < indicator._points.length; k++) {
                indicator._points[k].YValues.length = 1;
                indicator._points[k].YValues[0] = indicator._points[k].y = 80;
            }

            upperSeries.points = $.extend(true, [], indicator._points);
            var xValues = sender._getXValues(upperSeries.points);
            var yValues = sender._getYValues(upperSeries.points);

            indicator.xRange.min = Math.min.apply(Math, xValues);
            indicator.xRange.max = Math.max.apply(Math, xValues);
            indicator.yRange.min = Math.min.apply(Math, yValues);
            indicator.yRange.max = Math.max.apply(Math, yValues);

            indicator.segment.push(upperSeries);
            // End for Upper Line Calculation

            // Lower Line Calculation
            var lowerSeries = $.extend(true, {}, indicator);
            lowerSeries.name = "lowerSeries";
            lowerSeries.width = indicator.lowerLine.width;
            lowerSeries.fill = indicator.lowerLine.fill;
            lowerSeries.type = "line";


            for (var n = 0; n < indicator._points.length; n++) {
                indicator._points[n].YValues[0] = indicator._points[n].y = 20;
            }

            lowerSeries.points = $.extend(true, [], indicator._points);

            xValues = sender._getXValues(lowerSeries.points);
            yValues = sender._getYValues(lowerSeries.points);

            indicator.xRange.min = Math.min(Math.min.apply(Math, xValues), indicator.xRange.min);
            indicator.xRange.max = Math.max(Math.max.apply(Math, xValues), indicator.xRange.max);
            indicator.yRange.min = Math.min(Math.min.apply(Math, yValues), indicator.yRange.min);
            indicator.yRange.max = Math.max(Math.max.apply(Math, yValues), indicator.yRange.max);

            indicator.segment.push(lowerSeries);
            // End for Lower Line Calculation

            // Signal and Period Line Calculation

            var periodSeries = $.extend(true, {}, indicator);
            periodSeries.name = "periodSeries";
            periodSeries.width = indicator.periodLine.width;
            periodSeries.fill = indicator.periodLine.fill;
            periodSeries.type = "line";

            var HighValues = [];
            var LowValues = [];
            var CloseValues = [];
            var check = [];
            for (var i = 0; i < indicator._points.length; i++) {
                LowValues[i] = indicator._points[i].low;
                HighValues[i] = indicator._points[i].high;
                CloseValues[i] = indicator._points[i].close;
            }


            AddPoints(Period, KPeriod, indicator._points);
            check = indicator._points;
            SMA(Period, KPeriod, indicator._points);
            check = indicator._points;
            periodSeries.points = $.extend(true, [], indicator._points);

            xValues = sender._getXValues(periodSeries.points);
            yValues = sender._getYValues(periodSeries.points);

            indicator.xRange.min = Math.min(Math.min.apply(Math, xValues), indicator.xRange.min);
            indicator.xRange.max = Math.max(Math.max.apply(Math, xValues), indicator.xRange.max);
            indicator.yRange.min = Math.min(Math.min.apply(Math, yValues), indicator.yRange.min);
            indicator.yRange.max = Math.max(Math.max.apply(Math, yValues), indicator.yRange.max);

            indicator.segment.push(periodSeries);


            var trendSeries = $.extend(true, {}, indicator);
            trendSeries.name = "trendSeries";
            trendSeries.width = indicator.width;
            trendSeries.fill = indicator.fill;
            trendSeries.type = "line";

            SMA((Period+KPeriod-1), DPeriod, indicator._points);
            trendSeries.points = $.extend(true, [], indicator._points);

            indicator.segment.push(trendSeries);

            ///SMA Calculation(Signal Line and Period Line)

            function SMA(Period1, Period2, series) {
                if (indicator._points.length >= Period1 + Period2) {
                    SMACal(Period1, Period2, series);
                }
            }

            function SMACal(period1, period2, series) {
                var count = period1 + (period2-1);
                var temp = [];
                var values = [];
                var sum;
                for (var i = 0; i < indicator._points.length; i++) {
                    var val = check[i].y;
                    temp.push(val);
                }
                var length = temp.length;

                while (length >= count) {
                    sum = 0;
                    for (var j = period1-1; j < (period1 + period2-1); j++) {
                        sum = sum + temp[j];

                    }
                    sum = sum / period2;
                    values.push(sum.toFixed(2));
                    temp.splice(0, 1);
                    length = temp.length;
                }
                var len = count - 1;
                for (var k = 0; k < indicator._points.length; k++) {
                    if (k < len) {
                        series[k].YValues[0] = series[k].y = null;

                    }
                    else {
                        series[k].YValues[0] = series[k].y = Number((values[k - len]));
                    }

                }

            }

            // End for SMA Calculation

            // Period Line Calculation

            function AddPoints(Period1, Period2, series) {
                if (indicator._points.length > Period1) {
                    ComputeStochastics(Period1, Period2, series);
                }
            }
            function ComputeStochastics(len1, len2, series) {
                var len = len1 + len2;
                var mins = [];
                var maxs = [];
                var max;
                var min;
                var top = 0;
                var bottom = 0;
                for (var i = 0; i < len1 - 1; ++i) {
                    maxs.push(0);
                    mins.push(0);
                }

                for (var i = len1 - 1; i < indicator._points.length; ++i) {
                    min = Number.MAX_VALUE;
                    max = Number.MIN_VALUE;
                    for (var j = 0; j < len1; ++j) {
                        min = Math.min(min, LowValues[i - j]);
                        max = Math.max(max, HighValues[i - j]);
                    }
                    maxs.push(max);
                    mins.push(min);
                }

                for (var i = 0 ; i < len - 1; ++i) {
                    series[i].YValues.length = 1;
                    series[i].YValues[0] = series[i].y = null;
                }

                for (var i = len1 - 1; i < indicator._points.length; ++i) {
                    top = 0;
                    bottom = 0;
                    top += CloseValues[i] - mins[i];
                    bottom += maxs[i] - mins[i];
                    series[i].YValues.length = 1;
                    series[i].YValues[0] = series[i].y = (((top / bottom) * 100));
                }
            }

            // End for Period Line Calculation

            // Indicator Axis Range Calculation
            this.calculateIndicatorRange(sender, indicator);
        }


    });
    ej.indicatorTypes.stochastic = ej.ejSTOCHASTIC;
ej.ejbollingerBand = ejExtendClass(ej.EjIndicatorRender, {
        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};
            var sum = 0.0;
            var deviationSum = 0.0;
            var limit = indicator._points.length;
            var multiplier =indicator.standardDeviations;
            var movingavg =indicator.period;
            var length = Math.round(movingavg);
            var smaPoints = [];
            var deviations = [];
            var bbiPoints = [];
            //Calculating simple moving average
         if ((length < limit) && (length > 0))
{
            for (var i = 0; i < length; i++) {
                sum += indicator._points[i].close;

            }
            var sma = sum / movingavg;
            //Calculating smapoints using iteration
            for (var i = 0; i < limit; ++i) {
                if (i >= length - 1 && i < limit) {
                    if (i - movingavg >= 0) {
                        var diff = indicator._points[i].close - indicator._points[i - length].close;

                        sum = sum + diff;
                        sma = sum / (movingavg);
                        smaPoints[i] = sma;
                        deviations[i] = Math.pow(indicator._points[i].close - sma, 2);
                        deviationSum += deviations[i] - deviations[i - length];


                    }
                    else {

                        smaPoints[i] = sma;
                        deviations[i] = Math.pow(indicator._points[i].close - sma, 2);
                        deviationSum += deviations[i];
                    }


                    //calculation for standarddeviation for each period

                    var range = Math.sqrt(deviationSum / (movingavg));

                    //lower Band points for bollinger band
                    var lb = smaPoints[i] - (multiplier * range);
                    //upper Band points for bollinger band
                    var ub = smaPoints[i] + (multiplier * range);
                    //Binding the lowerband,upperband and middleband values to bollingerband array if the i value equal to period
                    if (i + 1 == length) {
                        for (var j = 0; j < length - 1; j++)
                            bbiPoints[j] = { "X": indicator._points[j].X, "mb": smaPoints[i], "lb": lb, "ub": ub, visible: true };



                    }
                    //binding the lb,ub,mb values to bollinger band array if i greather than period value.
                    bbiPoints[i] = { "X": indicator._points[i].X, "mb": smaPoints[i], "lb": lb, "ub": ub, visible: true };


                }


                else {
                    if (i < movingavg - 1) {

                        smaPoints[i] = sma;
                        deviations[i] = Math.pow(indicator._points[i].close - sma, 2);
                        deviationSum += deviations[i];
                    }


                }

            }


            var upperSeries = $.extend(true, {}, indicator);
            upperSeries.name = "upperseries";
            upperSeries.fill = indicator.upperLine.fill;
            upperSeries.width = indicator.upperLine.width;
            upperSeries.type = "line";

            //binding bollingerband array values to upper series and assigning null values 
            for (var k = 0; k < indicator._points.length; k++) {
                if (k >= (length - 1)) {
                    indicator._points[k].YValues.length = 1;
                    indicator._points[k].YValues[0] = indicator._points[k].y = bbiPoints[k].ub;
                }
                else {
                    indicator._points[k].YValues[0] = indicator._points[k].y = null;
                }
            }

            upperSeries.points = $.extend(true, [], indicator._points);
            var xValues = sender._getXValues(upperSeries.points);
            var values = [];
            //storing the y values from the period value
            for (var i = length; i < upperSeries.points.length; i++)
                values.push(upperSeries.points[i].y);
            var yValues = values;
            indicator.xRange.min = Math.min.apply(Math, xValues);
            indicator.xRange.max = Math.max.apply(Math, xValues);
            indicator.yRange.min = Math.min.apply(Math, yValues);
            indicator.yRange.max = Math.max.apply(Math, yValues);

            indicator.segment.push(upperSeries);


            var lowerSeries = $.extend(true, {}, indicator);
            lowerSeries.name = "lowerSeries";
            lowerSeries.width = indicator.lowerLine.width;
            lowerSeries.fill = indicator.lowerLine.fill;
            lowerSeries.type = "line";


            for (var n = 0; n < indicator._points.length; n++) {
                if (n >= (length - 1)) {
                    indicator._points[n].YValues.length = 1;
                    indicator._points[n].YValues[0] = indicator._points[n].y = bbiPoints[n].lb;
                }
                else {
                    indicator._points[n].YValues[0] = indicator._points[n].y = null;
                }
            }


            lowerSeries.points = $.extend(true, [], indicator._points);

            xValues = sender._getXValues(lowerSeries.points);

            var lowvalues = [];
            for (var i = length; i < lowerSeries.points.length; i++)
                lowvalues.push(lowerSeries.points[i].y);
            var yValues = lowvalues;

            indicator.xRange.min = Math.min(Math.min.apply(Math, xValues), indicator.xRange.min);
            indicator.xRange.max = Math.max(Math.max.apply(Math, xValues), indicator.xRange.max);
            indicator.yRange.min = Math.min(Math.min.apply(Math, yValues), indicator.yRange.min);
            indicator.yRange.max = Math.max(Math.max.apply(Math, yValues), indicator.yRange.max);

            indicator.segment.push(lowerSeries);



            var trendSeries = $.extend(true, {}, indicator);
            trendSeries.name = "trendSeries";
            trendSeries.width = indicator.width;
            trendSeries.fill = indicator.fill;
            trendSeries.type = "line";

            for (var m = 0; m < indicator._points.length; m++) {
                if (m >= (length - 1)) {
                    indicator._points[m].YValues.length = 1;
                    indicator._points[m].YValues[0] = indicator._points[m].y = bbiPoints[m].mb;
                }
                else {
                    indicator._points[m].YValues[0] = indicator._points[m].y = null;
                }
            }
            trendSeries.points = $.extend(true, [], indicator._points);
            xValues = sender._getXValues(trendSeries.points);
            var trendvalues = [];
            for (var i = length; i < trendSeries.points.length; i++)
                trendvalues.push(trendSeries.points[i].y);
            var yValues = trendvalues;

            indicator.xRange.min = Math.min(Math.min.apply(Math, xValues), indicator.xRange.min);
            indicator.xRange.max = Math.max(Math.max.apply(Math, xValues), indicator.xRange.max);
            indicator.yRange.min = Math.min(Math.min.apply(Math, yValues), indicator.yRange.min);
            indicator.yRange.max = Math.max(Math.max.apply(Math, yValues), indicator.yRange.max);
            indicator.segment.push(trendSeries);
            //calculating indicator range
            this.calculateIndicatorRange(sender, indicator);
           }
        }
     
        });
    ej.indicatorTypes.bollingerband = ej.ejbollingerBand;
  ej.ejATR = ejExtendClass(ej.EjIndicatorRender,{       
        calculateSegment:function(indicator,sender)
        {
            //calculation for atr
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};
            var atrPoints = [];
            var high_Low, high_ClosePrevious, low_ClosePrevious;
            high_Low = high_ClosePrevious = low_ClosePrevious = 0.0;
            var trueRange;
            var sumTruRange = 0.0;
            var firstFlag = false;
            var atr;
            var period =  indicator.period;
            if ((period <= 0) || (period > indicator._points.length))
                return;
            for (var i = 0; i < period; i++) {

                high_Low = indicator._points[i].high - indicator._points[i].low;
                if (i > 0) {
                    high_ClosePrevious = Math.abs(indicator._points[i].high - indicator._points[i - 1].close);
                    low_ClosePrevious = Math.abs(indicator._points[i].low - indicator._points[i - 1].close);
                 }
              
                trueRange = Math.max(high_Low, high_ClosePrevious, low_ClosePrevious);
               
                sumTruRange += trueRange;
                atr = (sumTruRange / period);
          
                    atrPoints[i] = { "X": indicator._points[i].X, "YValues": atr };

            }
       
             for (var i = period; i < indicator._points.length; ++i) {
                high_Low = indicator._points[i].high - indicator._points[i].low;
                high_ClosePrevious = Math.abs(indicator._points[i].high - indicator._points[i - 1].close);
                low_ClosePrevious = Math.abs(indicator._points[i].low - indicator._points[i-1].close);
                trueRange = Math.max(high_Low, high_ClosePrevious, low_ClosePrevious);
               
               atr = (atrPoints[i-1].YValues * (period - 1) + trueRange) / period;
             
                atrPoints[i] = {
                    "X": indicator._points[i].X, "YValues": atr
                };

               }
          


             var trendSeries = $.extend(true, {}, indicator);


            trendSeries.name = "trendSeries";
            trendSeries.width = indicator.width;
            trendSeries.fill = indicator.fill;
            trendSeries.type = "line";

         

            for (var k = 0; k < indicator._points.length; k++) {
                if (k >= (period - 1)) {
                    indicator._points[k].YValues.length = 1;
                    indicator._points[k].YValues[0] = indicator._points[k].y = atrPoints[k].YValues;
                }
                else {
                    indicator._points[k].YValues[0] = indicator._points[k].y = null;
                }
            }

           
       
            trendSeries.points = $.extend(true, [], indicator._points);
           
            var xValues = sender._getXValues(trendSeries.points);
           
            var values = [];
            for (var i = period; i < trendSeries.points.length; i++)
             values.push(trendSeries.points[i].y);
            
            indicator.xRange.min = Math.min.apply(Math, xValues);
            indicator.xRange.max = Math.max.apply(Math, xValues);
            indicator.yRange.min = Math.min.apply(Math, values);
            indicator.yRange.max = Math.max.apply(Math, values);

           indicator.segment.push(trendSeries);
        

            this.calculateIndicatorRange(sender, indicator);


            
        }

    });
    ej.indicatorTypes.atr = ej.ejATR;

 ej.ejaccumulationDistribution = ejExtendClass(ej.EjIndicatorRender, {
        calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
            indicator.segment = [];
            indicator.xRange = {};
            indicator.yRange = {};
            var adlPoints = [];
            var sum = 0;
          //calculating accumulation distribution line points 
            for (var i = 0; i < indicator._points.length;i++) {
                var close = indicator._points[i].close;
                
                    var value=(((close - indicator._points[i].low) - (indicator._points[i].high - close)) / (indicator._points[i].high - indicator._points[i].low));
                    sum += (isNaN(value) ? 0 : value) * indicator._points[i].volume;
                    adlPoints[i] = sum;
                
            }
            var trendSeries = $.extend(true, {}, indicator);
            trendSeries.name = "trendseries";
            trendSeries.fill = indicator.fill;
            trendSeries.width = indicator.width;
            trendSeries.type = "line";

            //Binding the accumulation distribution array values to indicator y values
            for (var k = 0; k < indicator._points.length; k++) {

                   indicator._points[k].YValues[0] = indicator._points[k].y = adlPoints[k];
                  }

            trendSeries.points = $.extend(true, [], indicator._points);
            var xValues = sender._getXValues(trendSeries.points);
           var yValues = sender._getYValues(trendSeries.points);
         
            indicator.xRange.min = Math.min.apply(Math, xValues);
            indicator.xRange.max = Math.max.apply(Math, xValues);
            indicator.yRange.min = Math.min.apply(Math, yValues);
            indicator.yRange.max = Math.max.apply(Math, yValues);

            indicator.segment.push(trendSeries);
            //calculating indicator range
            this.calculateIndicatorRange(sender, indicator);


        }

    });
    ej.indicatorTypes.accumulationdistribution = ej.ejaccumulationDistribution;
ej.ejTMA = ejExtendClass(ej.EjIndicatorRender, {
     calculateSegment: function (indicator, sender) {
         this.chartObj = sender;
         indicator.segment = [];
         indicator.xRange = {};
         indicator.yRange = {};

         // signalLine
         var trendSeries = $.extend(true, {}, indicator);
         trendSeries.name = "trendSeries";
         trendSeries.width = indicator.width;
         trendSeries.fill = indicator.fill;
         trendSeries.type = "line";

         //variable declaration
         var closevalues = [];
         var close_values = [];
         var smavalues = [];
         var tmavalues = [];
         var smaPoints = [];
         var trendPoints = [];
         var sum=0;
         var sum1;
         var length = indicator._points.length;
         var period = indicator.period;
        if (period < 1) return;
        
         if (period < length)
         {
                //Push the values to closevalues array
             for (var i = 0; i < length; i++) {
                 closevalues.push(indicator._points[i].close);
             }
             //find the closevalues length
             var close_length = closevalues.length;
         
             //calculation for SMA values

             while (close_length >= period) {
                 sum = 0;
                 for (var j = 0; j < period; j++) {
                     sum = sum + closevalues[j];

                 }
                 sum = sum / period;
                 smavalues.push( parseFloat(sum.toFixed(2)));
                 closevalues.splice(0, 1);
                 close_length = closevalues.length;
             }
             //calculating sma values depend on period
             for (var k = 0; k < length; k++) {
                 if (k < period - 1) {
                     sum = 0;
                     for (var j = 0; j < k+1; j++) {
                         sum = sum + indicator._points[j].close;

                     }
                     sum = sum / (k+1);
                     smaPoints[k] = parseFloat(sum.toFixed(2));
                 }
                 else {
                     smaPoints[k]= smavalues[k - (period - 1)];
                 }

             }
             //find the smavalues count
             var sma_count = smaPoints.length;
             //calculating TMA values
             while (sma_count >=period) {
                 sum1 = 0;
                 for (var j = 0; j < period; j++) {
                     sum1 = sum1 + smaPoints[j];

                 }
                 sum1 = sum1 / period;
                 tmavalues.push(sum1);
                 smaPoints.splice(0, 1);
                 sma_count = smaPoints.length;
                 }
            //set the TMA values to Y-Axis
             for (var k = 0; k < length; k++) {
                 if (k < period - 1) {
                     indicator._points[k].YValues[0] = indicator._points[k].y = null;

                 }
                 else {
                      indicator._points[k].YValues[0] = indicator._points[k].y = tmavalues[k - (period - 1)];
                    
                 }

             }
             trendSeries.points = $.extend(true, [], indicator._points);
             xValues = sender._getXValues(trendSeries.points);

             //Assign the Y-Axis values into trendPoints
             for (var i = period - 1, j = 0; i < trendSeries.points.length; i++, j++) {
                 trendPoints[j] = trendSeries.points[i].y;
             }

             //X-Axis and Y-Axis range calculation
             indicator.xRange.min = Math.min.apply(Math, xValues);
             indicator.xRange.max = Math.max.apply(Math, xValues);
             indicator.yRange.min = Math.min.apply(Math, trendPoints);
             indicator.yRange.max = Math.max.apply(Math, trendPoints);

             //push trendSeries
             indicator.segment.push(trendSeries);
             this.calculateIndicatorRange(sender, indicator);

            
         }
     }
 });
 ej.indicatorTypes.tma = ej.ejTMA;
	
	ej.ejMomentum = ejExtendClass(ej.EjIndicatorRender, {
	       calculateSegment: function (indicator, sender) {
            this.chartObj = sender;
              indicator.segment = [];
              indicator.xRange = {};
              indicator.yRange = {};

              //Upperband 
              var upperSeries = $.extend(true, {}, indicator);
              upperSeries.name = "upperseries";
              upperSeries.fill = indicator.upperLine.fill;
              upperSeries.width = indicator.upperLine.width;
              upperSeries.type = "line";

			  var period = indicator.period;
			  var pointsLength = indicator._points.length;
			  
          if(period > 0 && period < pointsLength -1){  // to check period value is greater than 0 and it is less than pointslength
              for (var k = 0; k < pointsLength; k++) {
                  indicator._points[k].YValues.length = 1;
                  indicator._points[k].YValues[0] = indicator._points[k].y = 100;
              }
              
              upperSeries.points = $.extend(true, [], indicator._points);
              var xValues = sender._getXValues(upperSeries.points);
              var yValues = sender._getYValues(upperSeries.points);
              
              indicator.xRange.min = Math.min.apply(Math, xValues);
              indicator.xRange.max = Math.max.apply(Math, xValues);
              indicator.yRange.min = Math.min.apply(Math, yValues);
              indicator.yRange.max = Math.max.apply(Math, yValues);

              indicator.segment.push(upperSeries);
              
              // signalLine
              var trendSeries = $.extend(true, {}, indicator); 
              trendSeries.name = "trendSeries";
              trendSeries.width = indicator.width;
              trendSeries.fill = indicator.fill;
              trendSeries.type = "line";
              
               var c = []; 
        var len = indicator.period;      // period value
            
        for (var i = 0; i < indicator._points.length; ++i)
        {
		   var points = indicator._points;
            if (!(i < len))                                       // calculate signal line points
                indicator._points[i].YValues[0] =indicator._points[i].y= (points[i].close / (points[i - len].close) *100);
        }

        for (var k = 0; k < len && k<indicator._points.length; k++) {
            indicator._points[k].YValues[0] = indicator._points[k].y = null;
        }
			  
              trendSeries.points = $.extend(true, [], indicator._points);
              xValues = sender._getXValues(trendSeries.points);
              var trendPoints = [];
              for (var i = len, j = 0; i < trendSeries.points.length; i++, j++){
                  trendPoints[j] = trendSeries.points[i].y;
			  }

              indicator.xRange.min = Math.min(Math.min.apply(Math, xValues), indicator.xRange.min);
              indicator.xRange.max = Math.max(Math.max.apply(Math, xValues), indicator.xRange.max);
              indicator.yRange.min = Math.min(Math.min.apply(Math, trendPoints), indicator.yRange.min);
              indicator.yRange.max = Math.max(Math.max.apply(Math, trendPoints), indicator.yRange.max);

              indicator.segment.push(trendSeries);
              this.calculateIndicatorRange(sender, indicator);
           }
        }
	});
	
	ej.indicatorTypes.momentum = ej.ejMomentum;
	
    ej.EjSeriesRender.prototype = {

	    getOrigin: function (chart, options, params) {
	        if (params.axes[options.xAxis.name]._validCross) {
	            var crossAxis = chart.chartObj._getCrossAxis(chart.chartObj.model._axes, true, options.xAxis.crossesInAxis);
	            if ((chart.chartObj.model.requireInvertedAxes ? options.xAxis.name : options.yAxis.name === crossAxis.name))
	                return options.xAxis._crossValue;
	        }
	        return Math.max(options.yAxis.visibleRange.min, 0);
	    },

    setLineSeriesStyle: function (currentSeries) {

        var seriesIndex = $.inArray(currentSeries, this.chartObj.model._visibleSeries);
        var serColor = this.chartObj.model.seriesColors[seriesIndex];
       
        
        var seriesInterior = this.chartObj.svgRenderer.createGradientElement(this.getSeriesName(currentSeries) + seriesIndex, serColor, 0, 0, 0, $(this.chartObj.svgObject).height(), this.chartObj.gSeriesEle);
        var seriesBorder = this.chartObj.model.seriesBorderColors[seriesIndex];
        return { SeriesInterior: seriesInterior, SeriesBorder: seriesBorder };

    },
    getSeriesName: function(series) {
        var serName;
        if (series.name)
            serName = series.name.replace(/\s/g, '');
        else
            serName = "series";
        
        return serName;
    },
    
    drawAreaPath: function (series, style, direction, canvasTranslate) {
	    var requireInvertedAxes = this.chartObj.model.requireInvertedAxes,
        seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries),
        translate = null, areaType = this.chartObj.model.AreaType, seriesBorder = series.border;
        if (areaType == "cartesianaxes")
        {
            var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);
            translate = 'translate(' + trans.x + ',' + trans.y + ')'
        }
        var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': translate};

        this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
        if (direction != "") {
            var options = {
                'id': this.chartObj.svgObject.id + "_Series" + seriesIndex,
                'fill': style.SeriesInterior,
                'fill-opacity': series.opacity,
                'stroke-width': seriesBorder.width,
                'stroke': seriesBorder.color,
                'stroke-dasharray': seriesBorder.dashArray,
                'stroke-linecap': series.lineCap,
                'stroke-linejoin': series.lineJoin,
                'd': direction
            };
            if (this.chartObj.dragPoint) {
                options.id = this.chartObj.svgObject.id + "_PreviewSeries" + seriesIndex;
                options['fill-opacity'] = 0.6;
                if (this.chartObj.model.enableCanvasRendering) this.chartObj.svgRenderer.drawPath(options, this.chartObj.canvasElement, canvasTranslate);
                else this.chartObj.svgRenderer.drawPath(options, this.chartObj.gPreviewSeriesGroupEle, canvasTranslate);
            }
            else
                this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle, canvasTranslate);
        } 
    },

    setAreaSeriesStyle: function (series) {

        var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
        var maxY = Math.max.apply(0,$.map(series.points, function(v) {return v.YValues[0];
        }));
        var minY = Math.min.apply(0, $.map(series.points, function(v) {
            return v.YValues[0];
        }));
        var minX = Math.min.apply(0, $.map(series.points, function (v) {
            return v.xValue;
        }));

        var point1 = {xValue: minX, YValues : []};
        point1.YValues[0] = minY;
        var point2 = {xValue: minX, YValues : []};
        point2.YValues[0] = maxY;
        var point1Xy = ej.EjSvgRender.utils._getPoint(point1, series);
        var point2Xy = ej.EjSvgRender.utils._getPoint(point2, series);
        var serColor = this.chartObj.model.seriesColors[seriesIndex];

        var seriesInterior = this.chartObj.svgRenderer.createGradientElement(this.getSeriesName(series) + seriesIndex, serColor, point1Xy.X, point1Xy.Y, point2Xy.X, point2Xy.Y, this.chartObj.gSeriesEle);

        return { SeriesInterior: seriesInterior };

    },





    naturalSpline: function (points) {
        var count = points.length;
        //constant
        var yIndex = 0, a = 6;
        var ySpline = [], ySplineDuplicate = [];

        // assigning the first and last value as zero
        ySpline[0] = ySplineDuplicate[0] = 0;
        ySpline[points.length - 1] = 0;

        for (var i = 1; i < count - 1; i++) {
            var d1 = points[i].xValue - points[i - 1].xValue;
            var d2 = points[i + 1].xValue - points[i - 1].xValue;
            var d3 = points[i + 1].xValue - points[i].xValue;
            var dy1 = points[i + 1].YValues[yIndex] - points[i].YValues[yIndex] || null;
            var dy2 = points[i].YValues[yIndex] - points[i - 1].YValues[yIndex];

            if (d1 == 0 || d2 == 0 || d3 == 0) {
                ySpline[i] = 0;
                ySplineDuplicate[i] = 0;
            }
            else {
                var p = 1 / (d1 * ySpline[i - 1] + 2 * d2);

                ySpline[i] = -p * d3;
                ySplineDuplicate[i] = p * (a * (dy1 / d3 - dy2 / d1) - d1 * ySplineDuplicate[i - 1]);
            }
        }

        for (var k = count - 2; k >= 0; k--)
            ySpline[k] = ySpline[k] * ySpline[k + 1] + ySplineDuplicate[k];


        return ySpline;

    },
    getBezierControlPoints: function (point1, point2, ySpline1, ySpline2, yIndex) {
        var controlPoint1;
        var controlPoint2;
        var one3 = 1 / 3.0;
        var deltaX2 = (point2.xValue - point1.xValue);

        deltaX2 = deltaX2 * deltaX2;

        var dx1 = 2 * parseFloat(point1.xValue) + parseFloat(point2.xValue);
        var dx2 = parseFloat(point1.xValue) + 2 * parseFloat(point2.xValue);

        var dy1 = 2 * point1.YValues[yIndex] + point2.YValues[yIndex];
        var dy2 = point1.YValues[yIndex] + 2 * point2.YValues[yIndex];

        var y1 = one3 * (dy1 - one3 * deltaX2 * (ySpline1 + 0.5 * ySpline2));
        var y2 = one3 * (dy2 - one3 * deltaX2 * (0.5 * ySpline1 + ySpline2));

        controlPoint1 = { xValue: dx1 * one3, YValues: [y1] };
        controlPoint2 = { xValue: dx2 * one3, YValues: [y2] };

        return { controlPoint1: controlPoint1, controlPoint2: controlPoint2 };


    },

    improveChartPerformance: function(chartSeries) {
        var tempPoints = [],
            xVisibleRange = chartSeries.xAxis.visibleRange,
            yVisibleRange = chartSeries.yAxis.visibleRange,
            seriesPoints = chartSeries.pointCollection && chartSeries.dragPoint? chartSeries.pointCollection : chartSeries.points,
            AreaBounds = this.chartObj.model.m_AreaBounds,
            emptyPoints,
            xDelta = xVisibleRange.max - xVisibleRange.min,
            yDelta = yVisibleRange.max - yVisibleRange.min,
            xTolerance = Math.abs((xDelta * 1) / AreaBounds.Width),
            yTolerance = Math.abs((yDelta * 1) / AreaBounds.Height),
            prevXValue = (seriesPoints[0] && seriesPoints[0].X > xTolerance) ? 0 : xTolerance,
            prevYValue = (seriesPoints[0] && seriesPoints[0].y > yTolerance) ? 0 : yTolerance,
            xVal = 0, yVal = 0, isEmpty, currentPoint,
            currentPointsLenght = seriesPoints.length,
            count = 0;

        for (var k = 0; k < currentPointsLenght; k++) {
            currentPoint = seriesPoints[k];
            if (currentPoint.fill)
                chartSeries.pointFill = true;
            isEmpty = (currentPoint.isEmpty === null || currentPoint.isEmpty === undefined) ? false : currentPoint.isEmpty;
            currentPoint.visible = (currentPoint.visible === null || currentPoint.visible === undefined) ? true : currentPoint.visible;
            if (currentPoint.xValue === null || currentPoint.xValue === undefined) {
                currentPoint.isEmpty = true;
                currentPoint.visible = false;
                currentPoint.xValue = xVisibleRange.min;
            } else {
                currentPoint.isEmpty = isEmpty;
                if (jQuery.type(currentPoint.xValue) == "date")
                    currentPoint.xValue = currentPoint.xValue.getTime();
            }
            if ((currentPoint.YValues[0] == null) || (currentPoint.YValues[0] == 'undefined') || (currentPoint.YValues[0] === "")) {
                currentPoint.isEmpty = true;
                currentPoint.visible = false;
                currentPoint.YValues[0] = yVisibleRange.min;
            } else {
                currentPoint.isEmpty = currentPoint.isEmpty;
                currentPoint.visible = (currentPoint.isEmpty) ? !currentPoint.isEmpty : currentPoint.visible;
            }

            xVal = currentPoint.xValue;
            yVal = currentPoint.YValues[0];
            if (Math.abs(prevXValue - xVal) >= xTolerance || Math.abs(prevYValue - yVal) >= yTolerance || chartSeries.enableSmartLabels) {

                tempPoints[count]=currentPoint;
                prevXValue = xVal;
                prevYValue = yVal;
                count++;
            }
        }

        emptyPoints = this._calculateEmptyPoints(chartSeries, tempPoints);
        chartSeries._visiblePoints = emptyPoints;
        return emptyPoints;

    },
    _isVisiblePoints: function(chartSeries) {
        var points = chartSeries.pointCollection && chartSeries.dragPoint? chartSeries.pointCollection : chartSeries.points,
            emptyPoints,
            isEmpty,
            checkNull = ej.util.isNullOrUndefined,
            length = points.length;
        for (var k = 0; k < length; k++) {
            isEmpty = (checkNull(points[k].isEmpty)) ? false : points[k].isEmpty;
            points[k].visible = (checkNull(points[k].visible)) ? true : points[k].visible;
            if (checkNull(points[k].xValue)) {
                points[k].isEmpty = true;
                points[k].visible = false;
                points[k].xValue = chartSeries.xAxis ? chartSeries.xAxis.visibleRange.min : null;
            } else
                points[k].isEmpty = isEmpty;

            if ((points[k].YValues[0] == null || points[k].YValues[0] == 'undefined') || (!chartSeries.isIndicator && (chartSeries._hiloTypes && (points[k].YValues[1] == undefined || points[k].YValues[1] == null)))) {
                points[k].isEmpty = true;
                points[k].visible = false;
            } else {
                points[k].isEmpty = points[k].isEmpty;
                points[k].visible = (points[k].isEmpty) ? !points[k].isEmpty : points[k].visible;
            }
            if (!checkNull(points[k].x)) {
                if (jQuery.type(points[k].xValue) == "date")
                    points[k].xValue = (points[k].xValue).getTime();
            }
        }
        if (chartSeries.emptyPointSettings)
            emptyPoints = this._calculateEmptyPoints(chartSeries, points);
        else
            emptyPoints = points;

        if (chartSeries.type.toLowerCase() == "waterfall")
            this.chartObj.calculateWaterfallSeriesPoints(emptyPoints);
		
        chartSeries._visiblePoints = emptyPoints;

        return emptyPoints;

    },

    _calculateEmptyPoints: function (series, points,chartObj) {
        var currentPoints;
        var emptyPoints = series.emptyPointSettings,
            style = emptyPoints.style,
            fill = style.color,
            checkNull = ej.util.isNullOrUndefined,
            borderColor = style.border.color,
            borderWidth = style.border.width,
            mode = emptyPoints.displayMode.toLowerCase(),
            emptyPointsVisible = emptyPoints.visible,
            length = points.length,
            point,
            xPoints =[],
            visiblePoints = [];
            currentPoints = $.extend(true, {}, points, currentPoints);
            seriesType = series.type.toLowerCase(),
            currentPoints.length = points.length;
            mode = ( seriesType == "boxandwhisker" )? "gap" : mode;
            if (emptyPointsVisible) {
             if (mode != 'gap') {                
                for (var i = 0; i < length; i++) {
                    currentPoints[i].actualIndex = checkNull(chartObj) ? i : (chartObj.model._isPieOfPie ? currentPoints[i].actualIndex : i);
                    point = currentPoints[i];
                    if ((point.isEmpty) && (!checkNull(point.x) || series._xAxisValueType == "string")) {
                        if (fill != '')
                            point.fill = fill;
                        if (borderColor != '') {
                            point.border = point.border ? point.border : {};
                            point.border.color = borderColor;
                            point.border.width = borderWidth;
                        }
                        switch (mode) {
                            case 'average':
                                if (series._hiloTypes) {
                                    $.each(point.YValues, function (index, value) {
                                        value = ((currentPoints[i - 1] ? currentPoints[i - 1].YValues[index] : 0) + (currentPoints[i + 1] ? (currentPoints[i + 1].isEmpty ? 0 : currentPoints[i + 1].YValues[index] ) : 0)) / 2
                                            point.YValues[index] = value;
                                            ej.EjSeriesRender.prototype._sethlocPoint(index, point, value);
                                    })
                                } else {
                                    value = ((currentPoints[i - 1] ? currentPoints[i - 1].y : 0) + (currentPoints[i + 1] ? ( currentPoints[i + 1].isEmpty ? 0 : currentPoints[i + 1].y ) : 0)) / 2;
                                    point.YValues[0] = value;
                                    point.y = value;
                                }
                                break;
                            case 'zero':
                                if (series._hiloTypes) {
                                    $.each(point.YValues, function (index, value) {
                                            point.y = 0;
                                            point.YValues[index] = 0;
                                            ej.EjSeriesRender.prototype._sethlocPoint(index, point, 0);
                                    })
                                } else {
                                    point.YValues[0] = 0;
                                    point.y = 0;
                                }
                                break;
                        }
                        point.isEmpty = false;
                        point.visible = true;
                        visiblePoints.push(point);
                    } else {
                        if (!checkNull(currentPoints[i].x) || series._xAxisValueType == "string")
                            visiblePoints.push(point);
                    }   
                }
            } else {
                 for (var i = 0; i < length; i++) {
                     currentPoints[i].actualIndex = checkNull(chartObj) ? i : (chartObj.model._isPieOfPie ? currentPoints[i].actualIndex : i);                  
                    visiblePoints[i]= (currentPoints[i]);
                }
            }
        } else {
            for (var i = 0; i < length; i++) {
                currentPoints[i].actualIndex = i;
                if (currentPoints[i].visible)
                    visiblePoints.push(currentPoints[i]);
            }
        }

        return visiblePoints;

    },
   
    _sethlocPoint: function (index,point,value) {
        switch (index) {
            case 0:
                point.high = value;
                break;
            case 1:
                point.low = value;
                break;
            case 2:
                point.open = value;
                break;
            case 3:
                point.close = value;
                break;
        }
    },

    _calculatePolarAxesSegment: function (currentseries) {

        var points = currentseries._visiblePoints;
        var segment = ej.EjSvgRender.utils._getStringBuilder();
        var SeriesIndex=$.inArray(currentseries, this.chartObj.model._visibleSeries)
        var size;
        var interval;
        var centerX = this.chartObj.model.centerX;
        var centerY = this.chartObj.model.centerY;
        // calculating side by side info.
        var sideInfo = this._getSeriesPosition(currentseries);

        size = $.extend(true, {}, currentseries.marker.size, size);
        if (size.width <= 10) {
            size.width = size.height = (1.5 * this.chartObj.model.elementSpacing);
        }
        if (currentseries.drawType.toLowerCase() == 'column') {
           
            var innerRadius = 0;
            var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + SeriesIndex };
            this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
            var interval = currentseries.xAxis.visibleRange.interval;
            currentseries.xAxis.labelPlacement = !(currentseries.xAxis.labelPlacement) ? "betweenticks" : currentseries.xAxis.labelPlacement;
            var ticks=0;
            if (currentseries.xAxis._valueType != "category" || (currentseries.xAxis._valueType == "category" && currentseries.xAxis.labelPlacement=="onticks"))
              ticks= interval / 2;
            var inversed = (currentseries.xAxis.isInversed) ? 0 : 1;
            interval = interval / sideInfo.all;
            var nextPoint = interval;
            var visiblePoints = currentseries._visiblePoints;
            var length = (currentseries.xAxis._valueType != "category") ? visiblePoints.length - 1 : visiblePoints.length;
            // calculation for start and end angle for each positions.
            for (var l = 0; l < length; l++) {
                var itemCurrentXPos = temp = (visiblePoints[l].xValue - currentseries.xAxis.visibleRange.min) + ((interval) * sideInfo.pos - ticks);
                itemCurrentXPos = (itemCurrentXPos) / this.chartObj.model.sumofYValues;
                point = visiblePoints[l];
               
                var nextPoint = (currentseries.xAxis.visibleRange.interval) / sideInfo.all;
                point.startAngle = 2 * Math.PI * itemCurrentXPos;
                point.endAngle = 2 * Math.PI * (itemCurrentXPos + ((nextPoint) / this.chartObj.model.sumofYValues));
            }
            if (!visiblePoints[visiblePoints.length - 1].startAngle) {
                visiblePoints[visiblePoints.length - 1].startAngle = visiblePoints[0].startAngle;
                visiblePoints[visiblePoints.length - 1].endAngle = visiblePoints[0].endAngle;
            }
        }
        var gap = false;
        for (var i = 0; i < points.length; i++) {
            var point1;
            var point2;
            if (points[i].visible) {

            // drawType 'Line' calculation
            if (currentseries.drawType.toLowerCase() == 'line') {
                point1 = ej.EjSvgRender.utils.TransformToVisible(currentseries, points[i].xValue, points[i].y, this.chartObj);

                if (i < points.length - 1 && points[i + 1].visible) {
                    point2 = ej.EjSvgRender.utils.TransformToVisible(currentseries, points[i + 1].xValue, points[i + 1].y, this.chartObj);
                    segment.append("M" + " " + (point1.X) + " " + (point1.Y) + " " + "L" + " " + (point2.X) + " " + (point2.Y) + " ");
                }
                    // when isClosed is true
                else if(i == points.length - 1){
                    if (currentseries.isClosed) {
                        point2 = ej.EjSvgRender.utils.TransformToVisible(currentseries, points[0].xValue, points[0].y, this.chartObj);
                        segment.append("M" + " " + (point1.X) + " " + (point1.Y) + " " + "L" + " " + (point2.X) + " " + (point2.Y) + " ");
                    }
                }            
            }

            else if (currentseries.drawType.toLowerCase() == 'column') {
                var interval = currentseries.xAxis.visibleRange.interval;
                var inversed= (currentseries.xAxis.isInversed) ? 0 : 1;
                var interval = interval / sideInfo.all;
                // radius for each point based on the y values.
                var radius = this.chartObj.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(currentseries.yAxis, points[i].y);
                
                var chartStartAngle = -.5 * Math.PI;
                var startAngle = points[i].startAngle + chartStartAngle;
                var endAngle = points[i].endAngle + chartStartAngle - 0.000001;

                var x1,y1, x2, y2;
           
                // calculating arc when the Stacking mode is enabled
               
                if (currentseries.isStacking) {
				     var startValue = currentseries.stackedValue.StartValues[i];
                    var endValue = currentseries.stackedValue.EndValues[i];
                    radius = ((startValue==endValue) ? 0 : (this.chartObj.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(currentseries.yAxis, endValue)));

                    x1 = centerX + radius * Math.cos(startAngle);
                    y1 = centerY + radius * Math.sin(startAngle);

                    x2 = centerX + radius * Math.cos(endAngle);
                    y2 = centerY + radius * Math.sin(endAngle);

                    innerRadius = this.chartObj.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(currentseries.yAxis, (startValue == 0 && currentseries.yAxis.visibleRange.min != 0) ? currentseries.yAxis.visibleRange.min : startValue);

                    var dStartX = centerX + innerRadius * Math.cos(startAngle);
                    var dStartY = centerY + innerRadius * Math.sin(startAngle);

                    var dEndX = centerX + innerRadius * Math.cos(endAngle);
                    var dEndY = centerY + innerRadius * Math.sin(endAngle);
                     if (this.chartObj.model.isPolar) 
                            direction = "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + "0" + " " + inversed + " " + x2 + " " + y2 + " " + "L" + " " + dEndX + " " + dEndY + " " + "A" + " " + innerRadius + " " + innerRadius + " " + "1" + " " + "0" + " " + "0" + " " + dStartX + " " + dStartY + " " + "z";
                       else
                            direction = "M" + " " + x1 + " " + y1 + " " + "L" + " " + x2 + " " + y2 + " " + "L" + " " + dEndX + " " + dEndY + " " + "L" + " " + dStartX + " " + dStartY + " " + "z";
                    }
                        // calculating arc for normal mode.
                    else {

                        x1 = centerX + radius * Math.cos(startAngle);
                        y1 = centerY + radius * Math.sin(startAngle);

                        x2 = centerX + radius * Math.cos(endAngle);
                        y2 = centerY + radius * Math.sin(endAngle);
                      if (this.chartObj.model.isPolar)
                            direction = "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + "0" + " " + inversed + " " + x2 + " " + y2 + " " + "L" + " " + centerX + " " + centerY + " " + "z";
                     else
                          direction = "M" + " " + x1 + " " + y1 + " " + "L" + " " + x2 + " " + y2 + " " + "L" + " " + centerX + " " + centerY + " " + "z";
                    }                   
        
                   // gradient creation
                var seriesInterior = this.chartObj.svgRenderer.createGradientElement(this.getSeriesName(currentseries) + "_" + SeriesIndex + i, this.chartObj.model.seriesColors[SeriesIndex], 0, 0, 0, 100, this.chartObj.gSeriesEle),
                    seriesBorder = currentseries.border;
                options = {
                     'id': this.chartObj.svgObject.id + "_Series" + SeriesIndex + "_Point" + i,
                     'fill': seriesInterior,
                     'stroke': seriesBorder.color,
                     'stroke-dasharray': seriesBorder.dashArray,
                     'stroke-width': seriesBorder.width,
                    'seriesIndex': SeriesIndex,
                    'opacity':currentseries.opacity,
                    'pointIndex': i,
                    'd': direction,
                    'start': points[i].startAngle - 1.57,
                    'end': points[i].endAngle - 1.57,
                    'radius': radius,
                    'innerR': innerRadius
                };
                if (this.chartObj.model.isPolar) {
                    options.x = centerX;
                    options.y = centerY;
					bounds = { PointIndex: i, StartAngle: points[i].startAngle, EndAngle: points[i].endAngle, CenterX: centerX, CenterY: centerY, Radius: radius, DRadius: innerRadius };
                }
				if (currentseries.type=="radar") {
                    var line1 = { x: centerX, y: centerY };
                    var line2 = { x: x1, y: y1 };
                    var line3 = { x: x2, y: y2 };
                    bounds = { PointIndex: i, Line1: line1, Line2: line2, Line3: line3 };
                    var hasStackingInnerRadius = innerRadius ? true : false;
                    options.hasStackingInnerRadius = hasStackingInnerRadius;
                }
                point = currentseries._visiblePoints[i];
                if ((!ej.util.isNullOrUndefined(currentseries.marker) && currentseries.marker.visible) || (!ej.util.isNullOrUndefined(currentseries.marker) && currentseries.marker.dataLabel.visible))
                    point.symbolLocation = { X: ((x1 + x2) / 2), Y: ((y1 + y2) / 2) };
                            
                this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle);

            }

                // drawType 'Area' calculation
            else {
                point1 = ej.EjSvgRender.utils.TransformToVisible(currentseries, points[i].xValue, points[i].y, this.chartObj);
                if (i == 0 || gap) {
                    segment.append("M" + " " + (point1.X) + " " + (point1.Y) + " ");
                }
                    // when isClosed is enabled
                else if (i == points.length - 1) {
                    if(!currentseries.isClosed){
                        segment.append("L" + " " + (point1.X) + " " + (point1.Y) + " " + "L" + " " + (centerX) + " " + (centerY)  );
                    }
                    else {
                        point2 = ej.EjSvgRender.utils.TransformToVisible(currentseries, points[0].xValue, points[0].y, this.chartObj);
                        segment.append("L" + " " + (point1.X) + " " + (point1.Y) + " " + "z");
                    }
                }
                    
                else {
                    if (points[i + 1].visible)
                        segment.append("L" + " " + (point1.X) + " " + (point1.Y) + " ");
                    else
                        segment.append("L" + " " + (point1.X) + " " + (point1.Y) + " " + "L" + " " + (centerX) + " " + (centerY) + " " + "z");
                }
                if (points[i + 1] && points[i + 1].visible)
                    gap = false;
                else
                    gap = true;
            }
            if (!currentseries.regionAdded && currentseries.drawType.toLowerCase() != 'column') {
                var bounds = { X: point1.X - size.width / 2, Y: point1.Y - size.height / 2, Width: size.width, Height: size.height };
                ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, currentseries, points[i], i);
            }
			if (!currentseries.regionAdded && currentseries.drawType.toLowerCase() == 'column' && this.chartObj.model.enableCanvasRendering)
                ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, currentseries, null, null); 
            }
        }

        if (!currentseries.regionAdded && currentseries.drawType.toLowerCase() == 'column' && !this.chartObj.model.enableCanvasRendering)
            ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, currentseries, null, null);
        return segment.toString();
    },
    _calculateVisiblePoints: function (currentseries,chartObj) {
        var visiblePoints = [],
            legendPoints = [],
            emptyPointsLength,
            checkNull = ej.util.isNullOrUndefined,
            points = checkNull(chartObj) ? currentseries.points : (chartObj.model._isPieOfPie ? currentseries.pieCollections[currentseries.collectionIndex] : currentseries.points),currentPoints,
            length = points.length,
            point;

        // calculate visible points
        for (var i = 0; i < length; i++) {
            // for legend visibility
            point = points[i];
            if (checkNull(point._visibility))
                point._visibility = 'visible';
            point.actualIndex =  checkNull(chartObj)? i:(chartObj.model._isPieOfPie ? point.actualIndex :i);
			point.visible = (point.isEmpty) ? false : point.visible;
			if (checkNull(point.visible))
                point.visible = true;
            if (point.y < 0) {
                point.YValues[0] = Math.abs(point.YValues[0])
            }
            if (checkNull(point.x) && currentseries._xAxisValueType != "string") {
                point.visible = false;
                point.isEmpty = true;
            }
            if (checkNull(point.y)) {
                point.visible = false;
                point.isEmpty = true;
            }
        }
        currentPoints = $.extend(true, {}, points, currentPoints);
        currentPoints.length = length;
        if (currentseries.emptyPointSettings.visible){
            emptyPoints = this._calculateEmptyPoints(currentseries, currentPoints,chartObj);
            emptyPointsLength = emptyPoints.length;
            for (var j = 0; j < emptyPointsLength; j++) {
                if (emptyPoints[j].visible) {
                    emptyPoints[j].visible = emptyPoints[j]._visibility == 'hidden' ? false : true;
                    legendPoints.push(emptyPoints[j]);
                    if (emptyPoints[j].visible)
                        visiblePoints.push(emptyPoints[j]);
                } else {
                    //calculating gap mode values
                    emptyPoints[j].y = ((emptyPoints[j - 1] ? emptyPoints[j - 1].y : 0) + (emptyPoints[j + 1] ? emptyPoints[j + 1].y : 0)) / 2;
                    if (isNaN(emptyPoints[j].y))
                        emptyPoints[j].y = ((emptyPoints[j - 2] ? emptyPoints[j - 2].y : 0) + (emptyPoints[j + 2] ? emptyPoints[j + 2].y : 0)) / 2;
                   
				   emptyPoints[j].YValues[0] = emptyPoints[j].y;
                    if (!checkNull(emptyPoints[j].x) || currentseries._xAxisValueType == "string") {
                        emptyPoints[j].gapMode = true;
                        visiblePoints.push(emptyPoints[j]);
                    }   
                }
            }
        }            
        else {
            for (var j = 0; j < length; j++) {
				legendPoints.push(currentPoints[j]);
                if (currentPoints[j].visible) {
                    currentPoints[j].visible = currentPoints[j]._visibility == 'hidden' ? false : true;
                    if (currentPoints[j].visible)
                        visiblePoints.push(currentPoints[j]);
                }
            }
        }  
        if (currentseries.visibility == "hidden")
        {
            for(var i=0;i<legendPoints.length;i++)
            {
                legendPoints[i].visible = false;
            }
        }
        currentseries._visiblePoints = visiblePoints;
        currentseries.visiblePoints = legendPoints;

        return {
            'visiblePoints': visiblePoints,
            'legendPoints': legendPoints
        };
    },
    getMinMaxValue: function (point1, point2, degree) {
        var minX = Math.min(point1.x, point2.x);
        var minY = Math.min(point1.y, point2.y);
        var maxX = Math.max(point1.x, point2.x);
        var maxY = Math.max(point1.y, point2.y);
        var pointValue;
        switch (degree) {
            case 0:
            case 360:
                pointValue = maxY;
                break;
            case 90:
                pointValue = minX;
                break;
            case 180:
                pointValue = minY;
                break;
            case 270:
                pointValue = maxX;
                break;
        }
        return pointValue;
    },
    pieDoughnutCenter:function(currentseries)
    {
               var startAngle = currentseries.startAngle;
        var endAngle = currentseries.endAngle;
		 this.chartObj.model.centerCount ++;
		   var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
        var regions = [-630,-540,-450,-360,-270,-180,-90,0, 90, 180, 270,360,450,540,630];
        var region = [];
         var oldCenterX = this.chartObj.model.circleCenterX[seriesIndex];
        var oldCenterY = this.chartObj.model.circleCenterY[seriesIndex];

        if (currentseries.startAngle < currentseries.endAngle) {
            for (i = 0; i < regions.length;i++) {
                if (regions[i] > startAngle && regions[i] < endAngle)
                    region[region.length] = (regions[i] % 360) < 0 ? (regions[i] % 360) + 360 : (regions[i] % 360);
            }
            }
        else {
            for (i = 0; i < regions.length; i++) {
                if (regions[i] < startAngle && regions[i] > endAngle)
                    region[region.length] = (regions[i] % 360) < 0 ? (regions[i] % 360) + 360 : (regions[i] % 360);
            }
        }
		 if (this.chartObj.model.centerCount == 1) {

                var radius = this.chartObj.model.circularRadius[seriesIndex];
                var startRadian = 2 * Math.PI * (startAngle - 90) / 360;
                var endRadian = 2 * Math.PI * (endAngle - 90) / 360;
                var centerPoint = { x: this.chartObj.model.circleCenterX[seriesIndex], y: this.chartObj.model.circleCenterY[seriesIndex] };
                var startPoint = { x: this.chartObj.model.circleCenterX[seriesIndex] + radius * Math.cos(startRadian), y: this.chartObj.model.circleCenterY[seriesIndex] + radius * Math.sin(startRadian) }
                var endPoint = { x: this.chartObj.model.circleCenterX[seriesIndex] + radius * Math.cos(endRadian), y: this.chartObj.model.circleCenterY[seriesIndex] + radius * Math.sin(endRadian) }
                switch (region.length) {
                    case 0:
                        var longX = Math.abs(centerPoint.x - startPoint.x) > Math.abs(centerPoint.x - endPoint.x) ? startPoint.x : endPoint.x;
                        var longY = Math.abs(centerPoint.y - startPoint.y) > Math.abs(centerPoint.y - endPoint.y) ? startPoint.y : endPoint.y;
                        var midPoint = { x: (centerPoint.x + longX) / 2, y: (centerPoint.y + longY) / 2 }
                        this.chartObj.model.circleCenterX[seriesIndex] = this.chartObj.model.circleCenterX[seriesIndex] + (this.chartObj.model.circleCenterX[seriesIndex] - midPoint.x);
                        this.chartObj.model.circleCenterY[seriesIndex] = this.chartObj.model.circleCenterY[seriesIndex] + (this.chartObj.model.circleCenterY[seriesIndex] - midPoint.y);
                        break;
                    case 1:
                        var maxRadian = 2 * Math.PI * (region[0] - 90) / 360;
                        var maxPoint = { x: this.chartObj.model.circleCenterX[seriesIndex] + radius * Math.cos(maxRadian), y: this.chartObj.model.circleCenterY[seriesIndex] + radius * Math.sin(maxRadian) }
                        switch (region[0]) {
                            case 0:
                            case 360:
                                point1 = { x: startPoint.x, y: maxPoint.y };
                                point2 = { x: endPoint.x, y: centerPoint.y };
                                break;
                            case 90:
                                point1 = { x: centerPoint.x, y: endPoint.y };
                                point2 = { x: maxPoint.x, y: startPoint.y };
                                break;
                            case 180:
                                point1 = { x: endPoint.x, y: centerPoint.y };
                                point2 = { x: startPoint.x, y: maxPoint.y };
                                break;
                            case 270:
                                point1 = { x: maxPoint.x, y: startPoint.y };
                                point2 = { x: centerPoint.x, y: endPoint.y };
                                break;
                        }
                        var midPoint = { x: (point1.x + point2.x) / 2, y: (point1.y + point2.y) / 2 }
                        this.chartObj.model.circleCenterX[seriesIndex] = this.chartObj.model.circleCenterX[seriesIndex] + ((this.chartObj.model.circleCenterX[seriesIndex] - midPoint.x) >= radius ? 0 : (this.chartObj.model.circleCenterX[seriesIndex] - midPoint.x));
                        this.chartObj.model.circleCenterY[seriesIndex] = this.chartObj.model.circleCenterY[seriesIndex] + ((this.chartObj.model.circleCenterY[seriesIndex] - midPoint.y) >= radius ? 0 : (this.chartObj.model.circleCenterY[seriesIndex] - midPoint.y));
                        break;
                    case 2:
                        var minRadian = 2 * Math.PI * (region[0] - 90) / 360;
                        var maxRadian = 2 * Math.PI * (region[1] - 90) / 360;
                        var maxPoint = { x: this.chartObj.model.circleCenterX[seriesIndex] + radius * Math.cos(maxRadian), y: this.chartObj.model.circleCenterY[seriesIndex] + radius * Math.sin(maxRadian) }
                        var minPoint = { x: this.chartObj.model.circleCenterX[seriesIndex] + radius * Math.cos(minRadian), y: this.chartObj.model.circleCenterY[seriesIndex] + radius * Math.sin(minRadian) }
                        var point1;
                        var point2
                        if (region[0] == 90 && region[1] == 180 || region[0] == 270 && region[1] == 0)
                            point1 = { x: minPoint.x, y: maxPoint.y }
                        else
                            point1 = { x: maxPoint.x, y: minPoint.y }
                        if (region[0] == 90 || region[0] == 270)
                            point2 = { x: this.getMinMaxValue(startPoint, endPoint, region[0]), y: this.getMinMaxValue(startPoint, endPoint, region[1]) }
                        else
                            point2 = { x: this.getMinMaxValue(startPoint, endPoint, region[1]), y: this.getMinMaxValue(startPoint, endPoint, region[0]) }
                        var midPoint = { x: Math.abs(point1.x - point2.x) / 2 >= radius ? 0 : (point1.x + point2.x) / 2, y: Math.abs(point1.y - point2.y) / 2 >= radius ? 0 : (point1.y + point2.y) / 2 }
                        this.chartObj.model.circleCenterX[seriesIndex] = this.chartObj.model.circleCenterX[seriesIndex] + (midPoint.x == 0 ? 0 : (this.chartObj.model.circleCenterX[seriesIndex] - midPoint.x) >= radius ? 0 : (this.chartObj.model.circleCenterX[seriesIndex] - midPoint.x));
                        this.chartObj.model.circleCenterY[seriesIndex] = this.chartObj.model.circleCenterY[seriesIndex] + (midPoint.y == 0 ? 0 : (this.chartObj.model.circleCenterY[seriesIndex] - midPoint.y) >= radius ? 0 : (this.chartObj.model.circleCenterY[seriesIndex] - midPoint.y));
                        break;
                }
            }
            for (var i = 0; i < currentseries.points.length; i++) {
                if (seriesIndex < this.chartObj.model._visibleSeries.length && this.chartObj.model.centerCount > 1) {
                    if (this.chartObj.model._visibleSeries[seriesIndex + 1].startAngle == startAngle && this.chartObj.model._visibleSeries[seriesIndex + 1].endAngle == endAngle) {
                        this.chartObj.model.circleCenterX[seriesIndex] = this.chartObj.model.circleCenterX[seriesIndex + 1];
                        this.chartObj.model.circleCenterY[seriesIndex] = this.chartObj.model.circleCenterY[seriesIndex + 1];
                    }
                }
                this.chartObj.model.startX[i] = this.chartObj.model.startX[i] - (oldCenterX - this.chartObj.model.circleCenterX[seriesIndex]);
                this.chartObj.model.startY[i] = this.chartObj.model.startY[i] - (oldCenterY - this.chartObj.model.circleCenterY[seriesIndex]);


            }

    },
    _drawEmptyPieOfPie: function(chartObj){
        var startAngle = -.5 * Math.PI,
             endAngle = 360 * (Math.PI / 180) + (-.5 * Math.PI) - 0.000001,
             startX = chartObj.model.circleCenterX[1],
             startY = chartObj.model.circleCenterY[1],
             radius = chartObj.model.circularRadius[1];
        var direction = "M" + " " + (startX + radius * Math.cos(startAngle)) + " " + (startY + radius * Math.sin(startAngle)) + " " + "A" + " " + radius + " " + radius + " " + "0" + " " +
            1 + " " + 1 + " " + (startX + radius * Math.cos(endAngle)) + " " + (startY + radius * Math.sin(endAngle)) + " " + "z";
        var theme = chartObj.model.theme.toLowerCase();
		 var pathOptions = {
            'id': chartObj.svgObject.id + '_Series' + 0 + "_EmptyCircle",
            'fill': 'none',
            'stroke-width': 1.5,
            'stroke': theme.indexOf("dark") >= 0 || theme.indexOf("contrast") >= 0 ? " #FFFFFF" : "#000000",
            'stroke-dasharray': '',
            'd': direction,
            'opacity': 1,
            'radius': radius,
            'start': 0 - 1.57,
            'end': (360 * (Math.PI / 180)) - 1.57,
            'cx': startX,
            'cy': startY
        };
        return pathOptions;
    },
    calculatingSliceAngle: function (currentseries, chartObj) {
        var chart = this.chartObj ? this.chartObj : chartObj,
            chartModel = chart.model,
            legend = chartModel.legend,
			 seriesIndex = $.inArray(currentseries, chartModel._visibleSeries),
            legendPosition = legend.position.toLowerCase(),
            legendActualBounds = chartModel.LegendActualBounds,
            visiblePoints = currentseries._visiblePoints,
			visiblePointslength = visiblePoints.length,
            legXSpace = 0, totalDegree,
            legYSpace = 0,
            legendBorder = legend.border.width,
            border = chartModel.border.width,
            point, margin = chartModel.margin,
            elementSpacing = chartModel.elementSpacing,
            itemCurrentXPos = 0,
            subTitle=chartModel.title.subTitle.text?chartModel.title.subTitle:'';
        chartModel.arcData = [];
        currentseries.rightsidePoints = [];
        currentseries.leftsidePoints = [];
        currentseries.labels = [];
        chartModel.sumofYValues = 0;
        chartModel.midPoint = 0;
        type = currentseries.type.toLowerCase();
		gapWidthValue = currentseries.gapWidth;


        for (j = 0; j < visiblePoints.length; j++) {
            chartModel.sumofYValues += visiblePoints[j].YValues[0];
        }
        if (currentseries.endAngle != null && type!="pieofpie")
            totalDegree = (currentseries.endAngle - currentseries.startAngle);
        else
            totalDegree = 360;
        totalDegree = (totalDegree != 360 && totalDegree != -360) ? totalDegree % 360 : totalDegree;
        if (currentseries.startAngle && type!="pieofpie") {
            currentseries.startAngle = currentseries.startAngle % 360;
            currentseries.endAngle = currentseries.startAngle + totalDegree;
            itemCurrentXPos = (currentseries.startAngle) ? ((chartModel.sumofYValues / 360) * currentseries.startAngle) : 0;
            itemCurrentXPos = itemCurrentXPos / chartModel.sumofYValues;
            chartModel.itemCurrentXPos = itemCurrentXPos;
        }
        else
            currentseries.endAngle = totalDegree;
        if (legend.visible && legendPosition != "custom") {
            if (legendPosition == "right" || legendPosition == "left")
                legXSpace += legendActualBounds.Width + (legendBorder * 2) + elementSpacing;
            else
                legYSpace += legendActualBounds.Height + (legendBorder * 2) + elementSpacing;

        }

        var yOffset = ((chartModel.title.text && chartModel.title.visible) ? chartModel._titleLocation.size.height + chartModel.elementSpacing + (subTitle == '' ? 0 : (subTitle.text && subTitle.visible && subTitle.enableTrim && (subTitle.textOverflow == 'wrap' || subTitle.textOverflow == 'wrapandtrim') ? chartModel._subTitleLocation.size.height : 0)) : 0);
     
          var constantWidth = 0.1* Math.min($(chart.svgObject).width(), $(chart.svgObject).height());
        var actualWidth = $(chart.svgObject).width() - (legXSpace + margin.left + margin.right + border * 2) - (type == "pieofpie" ? gapWidthValue : 0);
        var actualHeight = $(chart.svgObject).height() - (legYSpace + yOffset + margin.top + margin.bottom + border * 2);
        seriesIndex = chart.model._isPieOfPie ? currentseries.collectionIndex : seriesIndex;
      
        if (type == "pieofpie") {
            if (actualWidth < constantWidth) {
                var widthDifference = constantWidth - actualWidth;
                actualWidth = constantWidth;
            }
            gapWidthValue = widthDifference ? gapWidthValue - widthDifference : $(chart.svgObject).width() >= gapWidthValue ? gapWidthValue : 0;
        }
        var value = type == "pieofpie" ? (seriesIndex == 0 ? 0.25 : 0.25 * 3) : 0.5;
        chartModel.circleCenterX[seriesIndex] = (actualWidth * value) + (seriesIndex == 1 && type == "pieofpie" ? gapWidthValue : 0) + margin.left + ((legend.visible && legendPosition === "left") ? legXSpace : 0);
            chartModel.circleCenterY[seriesIndex] = (actualHeight * 0.5) + margin.top + yOffset + ((legend.visible && legendPosition === "top") ? legYSpace : 0);
    
        if (!ej.util.isNullOrUndefined(chart.model.pieGapWidth) && chart.model.pieGapWidth != 0) {
            if (seriesIndex == 0)
                chartModel.circleCenterX[seriesIndex] = chartModel.circleCenterX[seriesIndex] + chart.model.pieGapWidth / 2;
            else
                chartModel.circleCenterX[seriesIndex] = chartModel.circleCenterX[seriesIndex] - chart.model.pieGapWidth / 2;
        }
        var endAngle;
        currentseries.startAngle = (type == "pieofpie") ? 0 : currentseries.startAngle;
        totalDegree = currentseries.endAngle - currentseries.startAngle;
        var pieFactor = totalDegree / 180;
        var circleMidAngle = (totalDegree / 4) * (Math.PI / 180);
        for (var l = 0; l < visiblePointslength; l++) {
            point = currentseries._visiblePoints[l];
            if (point.visible || point.gapMode) {
                var pointIndex = type=="pieofpie"? point.actualIndex : l;
                if (l == 0 && seriesIndex == 0 && type == "pieofpie") {
                    var startAngle = 2 * Math.PI * itemCurrentXPos;
                    var endAngle = pieFactor * Math.PI * (point.YValues[0] / chartModel.sumofYValues) + startAngle;
                    endAngle = (isNaN(endAngle)) ? startAngle : endAngle;
                    midAngle = (endAngle + startAngle) / 2;
                    point.start = point.startAngle = circleMidAngle - midAngle;
                    point.end = point.endAngle = circleMidAngle + midAngle;
                    point.midAngle = circleMidAngle;
                }
                else {
                    if (l == 0)
                        point.startAngle = 2 * Math.PI * itemCurrentXPos;
                    else
                        point.startAngle = (type == "pieofpie") ? currentseries.pieCollections[seriesIndex][l - 1].endAngle : endAngle;
                    endAngle = point.endAngle = pieFactor * Math.PI * (point.YValues[0] / chartModel.sumofYValues) + point.startAngle;
                    endAngle = point.endAngle = (isNaN(endAngle)) ? point.startAngle : endAngle;
                    point.start = point.startAngle;
                    point.end = point.endAngle;
            point.midAngle = (point.endAngle + point.startAngle) / 2;
                }
            point.pointIndex = pointIndex;
            var chartStartingAngle = -.5 * Math.PI;

                point.radian = (point.midAngle) % (2 * Math.PI)

                if (currentseries.labelPosition.toLowerCase() == "outsideextended" && type != "pieofpie") {

                    if (point.radian < Math.PI)
                        currentseries.rightsidePoints.push(point);
                    else
                        currentseries.leftsidePoints.push(point);
                }
                itemCurrentXPos += point.YValues[0] / chartModel.sumofYValues;

                var midAngle = point.midAngle + chartStartingAngle;

                if ((point.actualIndex == currentseries.explodeIndex || currentseries.explodeAll) && !chart.vmlRendering) {

                    chartModel.startX[pointIndex] = chartModel.circleCenterX[seriesIndex] + Math.cos(midAngle) * currentseries.explodeOffset;
                    chartModel.startY[pointIndex] = chartModel.circleCenterY[seriesIndex]+ Math.sin(midAngle) * currentseries.explodeOffset;
                }
                else {
                    chartModel.startX[pointIndex] = chartModel.circleCenterX[seriesIndex];
                    chartModel.startY[pointIndex] = chartModel.circleCenterY[seriesIndex];
                }
            }

        }

        if (currentseries.labelPosition.toLowerCase() == "outsideextended") {
            currentseries.rightsidePoints = ej.DataManager(currentseries.rightsidePoints, ej.Query().sortBy("radian")).executeLocal();
            currentseries.leftsidePoints = ej.DataManager(currentseries.leftsidePoints, ej.Query().sortBy("radian")).executeLocal();
        }
        if (currentseries.marker.dataLabel.template) {
            if (currentseries.labelPosition.toLowerCase() == "outsideextended") {
                for (var i = 0; i < currentseries.rightsidePoints.length; i++) {
                    ej.EjSvgRender.utils._getSeriesTemplateSize(currentseries.rightsidePoints[i], currentseries.rightsidePoints[i].actualIndex, currentseries, false, chart);
                }
                for (var k = 0; k < currentseries.leftsidePoints.length; k++) {
                    ej.EjSvgRender.utils._getSeriesTemplateSize(currentseries.leftsidePoints[k], currentseries.leftsidePoints[k].actualIndex, currentseries, true, chart);
                }

            }
            else {
                for (var j = 0; j < currentseries._visiblePoints.length; j++) {
                    ej.EjSvgRender.utils._getSeriesTemplateSize(currentseries._visiblePoints[j], currentseries._visiblePoints[j].actualIndex, currentseries, true, chart);
                }
            }
            
        }
        else {
            ej.EjSvgRender.utils._getSeriesMaxLabel(currentseries);
        }

      
        currentseries.finalSize= { width: actualWidth, height: actualHeight };
        return currentseries.finalSize;
    },
	 _drawHiloPath: function (series, style, interior, direction, i, pointbounds) {

	     var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);

        var options = {
            'name': series.type,
            'id': this.chartObj.svgObject.id + "_Series" + seriesIndex + "_Point" + i,
            'fill': "none",
            'stroke-dasharray': series.dashArray,
            'stroke-width': style.borderWidth,
            'stroke': interior,
            'stroke-linecap': series.lineCap,
            'stroke-linejoin': series.lineJoin,
            'opacity': series.opacity,
            'd': direction
        };
        this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle);
        var valWidth, valHeight;
        var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, this.chartObj.model.requireInvertedAxes);
        x = (Math.min(pointbounds.point2.X, pointbounds.point1.X) +trans.x) - (style.borderWidth);
        y = (Math.min(pointbounds.point2.Y, pointbounds.point1.Y) +trans.y);
        if (pointbounds.point1.Y != pointbounds.point2.Y) {
            valWidth = style.borderWidth + (style.borderWidth / 2);
              valHeight = Math.abs(pointbounds.point1.Y - pointbounds.point2.Y);
        }
	     else {
            valWidth = Math.abs(pointbounds.point2.X - pointbounds.point1.X);
            valHeight = style.borderWidth + (style.borderWidth / 2); 
        }
        var bounds = { X: x, Y: y, Width: valWidth, Height: valHeight };
        ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, series, null, i);
      
	 },
	 isIntersec: function (other, currBounds) {
	     if (currBounds.Bottom < other.Top || currBounds.Right < other.Left
               || currBounds.Top > other.Bottom || currBounds.Left > other.Right) {
	         return false;
	     }
	      return true;
	 },
	 IntersectWith: function (sender, point, currBounds, labelPosition, seriesIndex) {
	     var chartObj = this,intersect = false,
	      smartIndex;
	     if (ej.util.isNullOrUndefined(sender.model.rightsidebounds[seriesIndex]) || ej.util.isNullOrUndefined(sender.model.leftsidebounds[seriesIndex])) {
	         sender.model.leftsidebounds[seriesIndex] = [];
	         sender.model.rightsidebounds[seriesIndex] = [];
	         sender.model.leftsidebounds[seriesIndex].points = [];
	         sender.model.rightsidebounds[seriesIndex].points = [];
	     }
	     if (labelPosition == "outsideExtended") {
                for (i = seriesIndex; i < sender.model.bounds.length ; i++) {
                    if (sender.model._visibleSeries[i].labelPosition.toLowerCase() == "outsideextended") {
                        if ((!ej.util.isNullOrUndefined(sender.model.bounds[i].points["left"])) && (sender.model.bounds[i].points["left"].length > 0)) {
                            var pointsLength = sender.model.bounds[i].points["left"].length;
                            for (j = pointsLength - 1; j >= 0 && !(ej.util.isNullOrUndefined(sender.model.bounds[i].points["left"][j])) ; j--) {
                                sender.model.leftsidebounds[i].points[j] = sender.model.bounds[i].points["left"][j];

                            }
                        }
                        if ((!ej.util.isNullOrUndefined(sender.model.bounds[i].points["right"])) && (sender.model.bounds[i].points["right"].length > 0)) {
                            var pointsLength = sender.model.bounds[i].points["right"].length;
                            for (k = 0; k < pointsLength && !(ej.util.isNullOrUndefined(sender.model.bounds[i].points["right"][k])) ; k++) {
                                sender.model.rightsidebounds[i].points[k] = sender.model.bounds[i].points["right"][k];
                            }
                        }

                    }
                }
            }
            else {

                if (sender.model.bounds[seriesIndex].points.length > 0 || seriesIndex >= 0) {
                    for (i = seriesIndex; i < sender.model.bounds.length && (!ej.util.isNullOrUndefined(sender.model.bounds[i])) ; i++) {
                        if (sender.model._visibleSeries[i].labelPosition.toLowerCase() != "outsideextended") {
                            var pointsLength = sender.model.bounds[i].points.length;
                            for (j = 0; j < pointsLength && !(ej.util.isNullOrUndefined(sender.model.bounds[i].points[j])) ; j++) {
                                if (sender.model.bounds[i].points[j].X < sender.model.circleCenterX[seriesIndex]) {
                                    if (($.inArray(sender.model.bounds[i].points[j], sender.model.leftsidebounds[i].points)) == -1)
                                        sender.model.leftsidebounds[i].points[j] = sender.model.bounds[i].points[j];
                                }
                                else if (($.inArray(sender.model.bounds[i].points[j], sender.model.rightsidebounds[i].points)) == -1)
                                    sender.model.rightsidebounds[i].points[j] = (sender.model.bounds[i].points[j]);

                            }
                        }
                    }
                }

            }
            for (i = seriesIndex; i < sender.model.bounds.length && (!ej.util.isNullOrUndefined(sender.model.bounds[i])) ; i++) {
                if (sender.model.leftsidebounds[i].points.length > 0) {
                    bounds = sender.model.leftsidebounds[i].points;
                    if (bounds.length > 0) {
                        for (var j = bounds.length - 1  ; j >= 0 ; j--) {
                            var other = bounds[j];
                          
                                if (!(ej.util.isNullOrUndefined(other) && other != currBounds)) {
                                if (other.SeriesIndex == currBounds.SeriesIndex && other.PointIndex == currBounds.PointIndex) {
                                    if (point.smartLabelPosition == "outside")
                                        continue;
                                    else
                                        break;
                                }
                                else if (this.isIntersec(other, currBounds))
                                    return true;
                            }
                        }
                    }

                }
            }
            for (i = seriesIndex; i < sender.model.bounds.length && (!ej.util.isNullOrUndefined(sender.model.bounds[i])) ; i++) {
                bounds = sender.model.rightsidebounds[i].points;
                if (bounds.length > 0) {
                    for (var j = bounds.length - 1 ; j >= 0; j--) {
                        var other = bounds[j];
                        if (!(ej.util.isNullOrUndefined(other) && other != currBounds)) {
                                if (other.SeriesIndex == currBounds.SeriesIndex && other.PointIndex == currBounds.PointIndex) {
                                    if (point.smartLabelPosition == "outside")
                                        continue;
                                    else
                                        break;
                                }
                                else if (this.isIntersec(other, currBounds))
                                    return true;
                            }
                    }

                }
            }
	     return intersect;
	     
	 },
   
   
	 _calculateArcData: function (sender, pointIndex, point, series, seriesIndex, pieSeriesIndex) {
	     var seriesIndex = sender.model._isPieOfPie ? pieSeriesIndex : seriesIndex;
	     var visiblePoints = series._visiblePoints;
	     var index = point.actualIndex;
	     var chartObj = sender;
	     var chartStartAngle = -.5 * Math.PI;
	     var currBounds, startAngle, endAngle;
         // fix for doughnut width is inconsistent when series having single point-EJMVC-6272
	     if (series.type.toLowerCase() == "doughnut" && series._visiblePoints.length == 1 && Math.abs(series.endAngle - series.startAngle) == 360 
		 && series.startAngle % 90 != 0) {
	         startAngle = parseFloat((point.startAngle + chartStartAngle).toFixed(3));
	         endAngle = parseFloat((point.endAngle + chartStartAngle).toFixed(3)) - 0.000001;
	     }
	     else
	     {
	         startAngle = point.startAngle + chartStartAngle;
	         endAngle = point.endAngle + chartStartAngle - 0.000001;
	     }
	     var totalDegree = series.endAngle - series.startAngle;
	     var longArc = endAngle - startAngle < Math.PI ? 0 : 1;
	     var midAngle = (startAngle + endAngle) / 2;
		  if (ej.util.isNullOrUndefined(point.currentMidAngle)) {
	         point.currentMidAngle = (startAngle + endAngle) / 2;
	     }
	     var direction;
	     var startX;
	     var startY
	     var clockWise=totalDegree > 0?1:0;
	     var longArc = clockWise ? endAngle - startAngle < Math.PI ? 0 : 1 : endAngle - startAngle > -1 * Math.PI ? 0 : 1;
	     var radius = chartObj.model.circularRadius[seriesIndex] ;
		 var innerRadius = chartObj.model.innerRadius[seriesIndex] ;
	     if ((index == series.explodeIndex || series.explodeAll) && !chartObj.vmlRendering) {
           
	         startX = chartObj.model.circleCenterX[seriesIndex] + Math.cos(midAngle) * series.explodeOffset;
	         startY = chartObj.model.circleCenterY[seriesIndex] + Math.sin(midAngle) * series.explodeOffset;
	     }
	     else {
	         startX = chartObj.model.circleCenterX[seriesIndex];
	         startY = chartObj.model.circleCenterY[seriesIndex];
	     }


	     var x1 = startX + radius* Math.cos(startAngle);
	     var y1 = startY + radius * Math.sin(startAngle);

	     var x2 = startX + radius * Math.cos(endAngle);
	     var y2 = startY + radius * Math.sin(endAngle);
	    
	     if (series.type.toLowerCase() == "doughnut") {
	         var dStartX = startX + innerRadius * Math.cos(startAngle);
	         var dStartY = startY + innerRadius * Math.sin(startAngle);

	         var dEndX = startX + innerRadius * Math.cos(endAngle);
	         var dEndY = startY + innerRadius * Math.sin(endAngle);
	         var dClockWise = clockWise ? 0 : 1;
	         if ((startAngle < 0) && Math.round(point.endAngle - point.startAngle) == 6)
	         {
	             dEndX = dEndX - 0.01;
	             x2 = x2 - 0.01;
	         }
	         direction = "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + longArc + " " + clockWise + " " + x2 + " " + y2 + " " + "L" + " " + dEndX + " " + dEndY + " " + "A" + " " +innerRadius+ " " + innerRadius + " " + "1" + " " + longArc + " " + dClockWise + " " + dStartX + " " + dStartY + " " + "z";
	     }

	     else{
	         if ((point.endAngle-point.startAngle).toFixed(4) == (2*Math.PI).toFixed(4)){
				 var centerx = startX;
	             var centery = startY;
	             direction = "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + longArc + " " + clockWise + " " + x2 + " " + y2;
            }
			else
	             direction = "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + longArc + " " + clockWise + " " + x2 + " " + y2 + " " + "L" + " " + startX + " " + startY + " " + "z";
	     }

        // display label for pie and doughnut chart
	     

        return { Direction: direction, centerX: centerx, centerY: centery };

    },

    getXCordinate: function (x, radius, angle) {
        var x1 = x + radius * (Math.cos(angle));
        return x1;
    },

    getYCordinate: function (y, radius, angle) {
        var y1 = y + radius * (Math.sin(angle));
        return y1;
    },
 getDoubleRange: function (start, end) {
        var mstart;
        var mend;
        if (start > end) {
            mstart = end;
            mend = start;
        }
        else {
            mstart = start;
            mend = end;
        }

        var mdelta = mend - mstart;
        var mmedian = (mstart + mend) / 2;
        var misEmpty = isNaN(mstart) || isNaN(mend);

        return { Start: mstart, End: mend, Delta: mdelta, Median: mmedian, IsEmpty: misEmpty };

    },
    isDependentSeries: function (series) {
        var type = series.type.toLowerCase();
        var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
       if((!requireInvertedAxes) || (requireInvertedAxes && series.isTransposed))
           return ((type.indexOf("bar") != -1 && !series._isTransposed) || (type.indexOf("column") != -1) || (type.indexOf("waterfall") != -1) || (type.indexOf("hilo") != -1) || (type.indexOf("candle") != -1) || (type.indexOf("boxandwhisker") != -1) ) ? true : false;
        else
            return (type.indexOf("bar") != -1) ? true : false;
    },

    getPointXYOrgin: function (x, y, series, sender) {
	     var requireInvertedAxes = sender.model.requireInvertedAxes;
		 var xvalue;
		 var yvalue;
        if ((series.isTransposed && requireInvertedAxes) || series._isTransposed) {
            xvalue = (1 - ej.EjSvgRender.utils._valueToCoefficient(series.xAxis, x)) * (series.xAxis.height);
            yvalue = (ej.EjSvgRender.utils._valueToCoefficient(series.yAxis, y)) * (series.yAxis.width);
            return { X: yvalue, Y: xvalue };
        }
        else {
             xvalue = ej.EjSvgRender.utils._valueToCoefficient(series.xAxis, x) * (series.xAxis.width);
             yvalue = (1 - ej.EjSvgRender.utils._valueToCoefficient(series.yAxis, y)) * (series.yAxis.height);
            return { X: xvalue, Y: yvalue };
        }
    },
    getRectangle: function (x1, y1, x2, y2, series, sender) {
        var pt1 = this.getPointXYOrgin(x1, y1, series, sender);
        var pt2 = this.getPointXYOrgin(x2, y2, series, sender);
        return ej.EjSvgRender.utils._correctRect(pt1.X, pt1.Y, pt2.X, pt2.Y);
    },
	
	calculateMean: function (values,series,pointIndex){
	
		var q1Arr,q3Arr,q1Arrodd,q1Arreven,q2Arr ,q3Arrodd,q3Arreven,q1half,q3half,midhalf,lowerquartile,upperquartile;
		var wholenumlower,remainderlower,intpartlower,decimalpartlower,wholenumupper,remainderupper,intpartupper,decimalpartupper,
		intpartlowerposition,intpartupperposition,averageValue = 0,boxAverageValue = 0 ,boxWhiskerValues =[],boxWhiskerCount=0,boxes=[],boxArrCount=0;
		if(values.length > 1)
		values.sort( function(a,b) {return a - b;} );
		
		//showMean calculation
		for(var q=0;q<values.length;q++)
		{
			averageValue = averageValue + values[q];
		}
		boxAverageValue = averageValue/values.length ;
		boxAverageValue = parseInt(boxAverageValue.toFixed(2));
		boxes[boxArrCount] =boxAverageValue;
		boxArrCount++;
	
		if(series.boxPlotMode.toLowerCase() == "normal")
		{
			//Lower quartile calculation for normal mode
			q1Arr = (values.length % 2 == 0) ? values.slice(0, (values.length / 2) ) : values.slice(0, Math.floor(values.length / 2) );
			q1half = Math.floor(q1Arr.length/2);			
			lowerquartile = q1Arr.length % 2 == 0 ? (q1Arr[q1half-1] + q1Arr[q1half]) / 2 :  q1Arr[q1half];
			lowerquartile = (values.length <= 3) ? values[0] : lowerquartile;
			boxes[boxArrCount] = lowerquartile;
			boxArrCount++;
			//Upper quartile calculation for normal mode 	 
			q3Arr = (values.length % 2 == 0) ? values.slice( (values.length/2), values.length) : values.slice(Math.ceil(values.length / 2), values.length);
			q3half = Math.floor(q3Arr.length/2);
			upperquartile = q3Arr.length % 2 == 0 ? (q3Arr[q3half-1] + q3Arr[q3half]) / 2 :  q3Arr[q3half];
			upperquartile = (values.length <= 3) ? values[values.length - 1] : upperquartile;
			boxes[boxArrCount] = upperquartile;
			boxArrCount++;
		}
		else if(series.boxPlotMode.toLowerCase() == "exclusive" || series.boxPlotMode.toLowerCase() == "inclusive")
		{
		
			//Lower quartile calculation for exclusive meadian and inclusive median 
			wholenumlower = series.boxPlotMode .toLowerCase() == "exclusive" ? (values.length + 1)/4 : (values.length - 1)/4 ;
			intpartlower = Math.floor(wholenumlower);
			decimalpartlower = wholenumlower - intpartlower ;
			intpartlowerposition = series.boxPlotMode.toLowerCase() == "exclusive" ? intpartlower - 1 : intpartlower ;
			q1Arr = (1 - decimalpartlower) * values[intpartlowerposition] + decimalpartlower * values[intpartlowerposition + 1];
			q1Arr = (values.length <= 3) ? values[0] : q1Arr;
			lowerquartile = q1Arr;
			boxes[boxArrCount] = lowerquartile;
			boxArrCount++;
								
			//Upper quartile calculation for exclusive meadian and inclusive median 
			wholenumupper = series.boxPlotMode.toLowerCase() == "exclusive" ? (3 * (values.length + 1))/4 : (3 * (values.length - 1))/4 ;
			intpartupper = Math.floor(wholenumupper);
			decimalpartupper = wholenumupper - intpartupper;
			intpartupperposition = series.boxPlotMode.toLowerCase() == "exclusive" ? intpartupper - 1 : intpartupper;
			q3Arr = (1 - decimalpartupper) * values[intpartupperposition] + decimalpartupper * values[intpartupperposition + 1];
			q3Arr = (values.length <= 3) ? values[values.length - 1] : q3Arr;
			upperquartile = q3Arr;
			boxes[boxArrCount] = upperquartile;
			boxArrCount++;
		}
				
				
	    //calculate median
		midhalf = Math.floor(values.length/2);
		q2Arr = values.length % 2 == 0 ? (values[midhalf-1] + values[midhalf]) / 2 :  values[midhalf];
		boxes[boxArrCount] = q2Arr;
		boxArrCount++;
		
		//calculate interquartile range
		var iqr = upperquartile - lowerquartile;
		var upperrange = upperquartile + 1.5 * (iqr);
		var lowerrange = lowerquartile - 1.5 * (iqr);
		var maximum = values[values.length-1];
		var minimum = values[0];		
		var outliers =[],maxNumCount=0,index=0;
		
		
		for(var i=0;i<values.length;i++)
		{
		 if(upperrange < values[i])
			{
				maxNumCount++;
			    outliers[index]=values[i];
				index++;
				maximum = values[i-maxNumCount];
				
			}
			if(lowerrange > values[i])
			{
				outliers[index] = values[i];
				index++;
				minimum = values[i+1];
			}
		}
		boxes[boxArrCount] = minimum;
		boxArrCount++;
		boxes[boxArrCount] = maximum;
		boxArrCount++;
				
		var boxPlotValues = {Minimum : minimum, LowerQuartile : lowerquartile , midvalue : q2Arr , UpperQuartile : upperquartile , Maximum : maximum,boxAverage : boxAverageValue,outliers:outliers};
		series._visiblePoints[pointIndex].boxPlotValues = boxPlotValues;
		series._visiblePoints[pointIndex].boxPlotValues.quartileValues = boxes;
		
		
		
		
	  return {Minimum : minimum, LowerQuartile : lowerquartile , midvalue : q2Arr , UpperQuartile : upperquartile , Maximum : maximum,boxAverage : boxAverageValue,outliers:outliers};
},
	calculateBoxAndWhiskerPath : function(options,rect,options1,list2,series,point,pointIndex)	{
	
	    series._visiblePoints[pointIndex].boxPlotLocation = [];
	    series._visiblePoints[pointIndex].dataLabelLocation = [];
		var boxCount=0;			
		var cSer = this,offset=5;
		var isTransposed = series._isTransposed;
		var invertedAxis = this.chartObj.model.requireInvertedAxes,whiskerpath,boxAvg,boxAvgValue,fenceValue,outlierpoint;
		
		
		for(var p=0;p<series._visiblePoints[pointIndex].boxPlotValues.quartileValues.length;p++)
		{
			boxAvg = {"xValue": point.xValue, "YValues":series._visiblePoints[pointIndex].boxPlotValues.quartileValues[p]  };		
			boxAvgValue = ej.EjSvgRender.utils._getPoint(boxAvg, series);
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount] = boxAvgValue;
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount].xValue  = boxAvg.xValue ;
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount].YValues = boxAvg.YValues;
			if(isTransposed)
			    series._visiblePoints[pointIndex].dataLabelLocation[boxCount] = { X: boxAvgValue.X, Y: rect.Y + rect.Height / 2 + offset}
			else
			    series._visiblePoints[pointIndex].dataLabelLocation[boxCount] = { X: rect.X + rect.Width / 2 ,Y: boxAvgValue.Y};
			boxCount++;
		
		}
							
		for(var k=0;k<list2.outliers.length;k++)
		{
			fenceValue = {"xValue": point.xValue, "YValues": list2.outliers[k] };						
			outlierpoint =  ej.EjSvgRender.utils._getPoint(fenceValue, series);												
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount] = outlierpoint ;//to store x and y positions of upper outlier
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount].xValue = fenceValue.xValue;
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount].YValues = fenceValue.YValues;								
			series._visiblePoints[pointIndex].boxPlotLocation[boxCount].outlier = true;
			if(isTransposed)
				outlierpoint.Y = rect.Y + rect.Height / 2;
			else
				outlierpoint.X = rect.X + rect.Width / 2;
			if (isTransposed)
			    series._visiblePoints[pointIndex].dataLabelLocation[boxCount] = { X:outlierpoint.X - series.outlierSettings.size.height ,Y: rect.Y + rect.Height / 2 + series.outlierSettings.size.width   ,outlier:true}
			else
			    series._visiblePoints[pointIndex].dataLabelLocation[boxCount] = { X: rect.X + rect.Width / 2, Y: outlierpoint.Y ,outlier:true};
			boxCount++;	
		}	
		whiskerpath = series._visiblePoints[pointIndex].boxPlotLocation;
		
		if(series._isTransposed)
		{
		    var plotlowerwhisker = "M" + " " + (cSer.chartObj.canvasX + whiskerpath[4].X)   + " " + (cSer.chartObj.canvasY + rect.Y) + " L " + (whiskerpath[4].X + cSer.chartObj.canvasX)  + " " + (rect.Height + rect.Y + cSer.chartObj.canvasY) + " M " + (cSer.chartObj.canvasX + whiskerpath[4].X)  + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height/2)) + " L " + (cSer.chartObj.canvasX + whiskerpath[1].X) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height/2))  + " " + " z"; 			
		    var plotupperwhisker = "M" + " " +  (cSer.chartObj.canvasX + whiskerpath[5].X) + " " + (cSer.chartObj.canvasY + rect.Y) + " L " + (cSer.chartObj.canvasX + whiskerpath[5].X) + " " + (rect.Height + rect.Y + cSer.chartObj.canvasY) + " M " + (cSer.chartObj.canvasX + whiskerpath[5].X) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height/2)) + " L " + (cSer.chartObj.canvasX + whiskerpath[2].X) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height/2))  + " " + " z"; 
 		
		}
		else
		{
		    var plotlowerwhisker = "M" + " " + (cSer.chartObj.canvasX + rect.X) + " " + (cSer.chartObj.canvasY + whiskerpath[4].Y) + " L " + (cSer.chartObj.canvasX + rect.X + rect.Width) + " " + (cSer.chartObj.canvasY + whiskerpath[4].Y) + " M " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2)) + " " + (cSer.chartObj.canvasY + whiskerpath[4].Y) + " L " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2)) + " " + (cSer.chartObj.canvasY + whiskerpath[1].Y) + " " + " z";
		    var plotupperwhisker = "M" + " " + (cSer.chartObj.canvasX + rect.X) + " " + (cSer.chartObj.canvasY + whiskerpath[5].Y) + " L " + (cSer.chartObj.canvasX + rect.X + rect.Width) + " " + (cSer.chartObj.canvasY + whiskerpath[5].Y) + " M " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2)) + " " + (cSer.chartObj.canvasY + whiskerpath[5].Y) + " L " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2)) + " " + (cSer.chartObj.canvasY + whiskerpath[2].Y) + " " + " z";
		}
					
		var meanPath = !series._isTransposed ? "M" + " " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2) - 5) + " " + (cSer.chartObj.canvasY + whiskerpath[0].Y - 5) + " L " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2) + 5) + " " + (cSer.chartObj.canvasY + whiskerpath[0].Y + 5) + " M " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2) - 5) + " " + (cSer.chartObj.canvasY + whiskerpath[0].Y + 5) + " L " + (cSer.chartObj.canvasX + rect.X + (rect.Width / 2) + 5) + " " + (cSer.chartObj.canvasY + whiskerpath[0].Y - 5) + " " + "z" :
			"M" + " " + (cSer.chartObj.canvasX + whiskerpath[0].X - 5) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height / 2) - 5) + " L " + (cSer.chartObj.canvasX + whiskerpath[0].X + 5) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height / 2) + 5) + " M " + (cSer.chartObj.canvasX + whiskerpath[0].X + 5) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height / 2) - 5) + " L " + (cSer.chartObj.canvasX + whiskerpath[0].X - 5) + " " + (cSer.chartObj.canvasY + rect.Y + (rect.Height / 2) + 5) + " " + "z";

							
		return { upperWhisker : plotupperwhisker , lowerWhisker : plotlowerwhisker , mean : meanPath };
},		
    calculateSides: function (point, sidebysideinfo) {
        var x1 = point.xValue + sidebysideinfo.Start;
        var x2 = point.xValue + sidebysideinfo.End;
        return { x1: x1, x2: x2 };
    },
    _getSeriesPosition: function (currentSeries) {
     // calculation for position of series in radar and polar.
        if (ej.util.isNullOrUndefined(currentSeries.position) || this.chartObj.model.legendCollapsed) {
            var stacked;
            var stackingposition
            var all=0;
            var seriesCollection=[];
            for (var i = 0; i < this.chartObj.model._visibleSeries.length; i++) {
                var series=this.chartObj.model._visibleSeries[i];
                if (series.visibility.toLowerCase() === 'visible' && series.drawType.toLowerCase() == 'column') {
                    seriesCollection.push(series);
                }
            }
            for (var j = 0; j < seriesCollection.length; j++) {
                var series = seriesCollection[j];
			    if (series._xAxisName == this.chartObj.model._axes[0].name && series._yAxisName == this.chartObj.model._axes[1].name) {
                    if (series.isStacking) {
                        if (!stacked) {
                            stackingposition = all;
                            all++;
                            stacked = true;
                        }
                        series.position = stackingposition;
                    }
                    else {
                        series.position = all;
                        all++;
                      }
				}	  
            }
            for (var k = 0; k < seriesCollection.length; k++) 
                seriesCollection[k].all = all;
            
        }
        return { all: currentSeries.all, pos: currentSeries.position };
    },
     getSideBySidePositions: function (currentSeries, params) {

         var chart = this, 
            stackingGroup = [],
            model = chart.chartObj.model,
            vAxeseries,
            i = j = k = 0,
            visibleSeriesLength=model._visibleSeries.length;
		 //Spacing not calculated during resize event because position value in series is not null or undefined		 
         if (ej.util.isNullOrUndefined(currentSeries.position) || model.legendCollapsed || !params.spacingCalculated) {
             var hAxes = (model.requireInvertedAxes) ? model.vAxes : model.hAxes;
             var vAxes = (model.requireInvertedAxes) ? model.hAxes : model.vAxes;

             $.each(hAxes, function (index, hAxis) {
                 var all = 0, seriesCollection = [];
				 vAxeseries=[];
                 for (j = 0; j <visibleSeriesLength; j++) {
                     var series = model._visibleSeries[j];
                     if (series.visibility.toLowerCase() === 'visible') {
                         if (chart.isDependentSeries(series)) {
                             if (hAxis.name == series._xAxisName) {
                                 seriesCollection.push(series);
                             }
                         }
                     }
                 }
				  var seriesCollectionLength=seriesCollection.length;                 
                 for (j = 0; j < seriesCollectionLength; j++) {
                     var index = (model.requireInvertedAxes) ? seriesCollection[j].yAxis.columnIndex : seriesCollection[j].yAxis.rowIndex;
                     if (!vAxeseries[index]) {
                         vAxeseries[index] = [];
                         seriesCollection[j].yAxis.position = null;
                     }
                     vAxeseries[index].push(seriesCollection[j]);
                 }

                 for (i = 0; i < vAxeseries.length; i++) {
                     if (!ej.util.isNullOrUndefined(vAxeseries[i])) {
                         vAxeseries[i].all = 0;
                         for (j = 0; j < vAxeseries[i].length; j++) {
                             series = vAxeseries[i][j];
                             if (series.type.toLowerCase().indexOf("stacking") != -1) {
                                 if (series.stackingGroup) {
                                     if (ej.util.isNullOrUndefined(stackingGroup[series.stackingGroup])) {
                                         vAxeseries[i].all++;
                                         series.position = vAxeseries[i].all;
                                         stackingGroup[series.stackingGroup] = vAxeseries[i].all;
                                     }
                                     else
                                         series.position = stackingGroup[series.stackingGroup];
                                 }
                                 else {
                                     if (ej.util.isNullOrUndefined(series.yAxis.position) || model.legendCollapsed) {
                                         vAxeseries[i].all++;
                                         series.position = vAxeseries[i].all;
                                         series.yAxis.position = vAxeseries[i].all;
										 model.legendCollapsed=false;
                                     }
                                     else
                                         series.position = series.yAxis.position;
                                 }
                             }
                             else {
                                 vAxeseries[i].all++;
                                 series.position = vAxeseries[i].all;
                             }
                         }
                     }
                 }
                 var columnWidth = seriesCollectionLength > 0 && seriesCollection[0].columnWidth;
                 for (k = 0; k < seriesCollectionLength; k++) {
                     var index = (model.requireInvertedAxes) ? seriesCollection[k].yAxis.columnIndex : seriesCollection[k].yAxis.rowIndex;
                     seriesCollection[k].all = vAxeseries[index].all;
                     params.needSpace = params.needSpace || columnWidth != seriesCollection[k].columnWidth
                 }

             });
             if (params.needSpace && this.chartObj.model._sideBySideSeriesPlacement)
                 this._getColumnSpacing(vAxeseries, params);
			 params.spacingCalculated = true;
         }
         return { all: currentSeries.all, pos: currentSeries.position };
     },
	
     getSideBySideInfo: function (series, params) {
         if (ej.util.isNullOrUndefined(series.xAxis.m_minPointsDelta))
		    {
			 this.chartObj.currentSeries = series;
             series.xAxis.m_minPointsDelta = ej.EjSvgRender.utils.getMinPointsDelta(series.xAxis, this.chartObj);   
            }			 
         var spacing = series.columnSpacing,
             columnWidth = series.columnWidth,
             data = this.getSideBySidePositions(series, params),
             pos = data.pos,
             all = data.all,
             needSpace = params.needSpace && this.chartObj.model._sideBySideSeriesPlacement,
             width = series.xAxis.m_minPointsDelta * (needSpace ? 1 : columnWidth),
             loc = needSpace ? params[series.name || series._name].loc : (pos - 1) / all - 0.5,
             range = this.getDoubleRange(loc, loc + (needSpace ? columnWidth : 1) / all);        
        if (!this.chartObj.model._sideBySideSeriesPlacement)
            return this.getDoubleRange(-width / 2, width / 2);


         // multiplying with width  and scaling
         if (!range.IsEmpty) {
             range = this.getDoubleRange(range.Start * width, range.End * width);
             var radius = spacing * range.Delta;
             range = this.getDoubleRange(range.Start + radius / 2, range.End - radius / 2);
         }
         return range;
    },

     _getColumnSpacing: function (axesSeries, params) {
         var i = j = 0, length, len, series, name;
         for (len = axesSeries.length; i < len; i++) {
             var width = 0, stackingSeries = [], group = {};
             for (length = axesSeries[i].length; j < length; j++)
                 if ((series = axesSeries[i][j]).type.toLowerCase().indexOf("stacking") == -1)
                     width += series.columnWidth / series.all;
                 else
                     group[name = series.stackingGroup] = { width: Math.max(series.columnWidth, group[name] ? group[name].width : 0), all: series.all }
             for (var key in group)
                 width += group[key].width / group[key].all;

             var start = (1 - width) / 2 - .5;
             for (j = 0, length = axesSeries[i].length; j < length; j++) {
                 if ((series = axesSeries[i][j]).type.toLowerCase().indexOf("stacking") == -1) {
                     params[series.name || (series._name="series"+i+j)] = { loc: start };
                     start += series.columnWidth / series.all;
                 }
                 else {
                     if (group[name = series.stackingGroup].loc == null) {
                         params[series.name || (series._name="series"+i+j)] = { loc: start + (group[name].width - series.columnWidth) / 2 / series.all };
                         group[name].loc = params[series.name || series._name].loc + series.columnWidth / 2 / series.all;
                         start += group[name].width / series.all;
                     }
                     else
                         params[series.name || series._name] = { loc: group[name].loc - series.columnWidth / 2 / series.all };
                 }
             }
         }
     },

    draw: function (chart, options) {

        this.chartObj = chart;
        
        //DrawLineGraph
        var lDirection;
        var sb = ej.EjSvgRender.utils._getStringBuilder();
		options.animationType = "path";
        var currentseries = options;
        var style = this.setLineSeriesStyle(currentseries);
        if (currentseries.sorting)
            currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();
        var visiblePoints = this.improveChartPerformance(currentseries);

        if (!currentseries.pointFill) {

            var firstPoint = null;
            var secondPoint;
            var firstIndex = -1;
            for (var i = 0; i < visiblePoints.length; i++) {
                secondPoint = visiblePoints[i];
                if (secondPoint.visible) {
                    if (firstPoint != null) {
                        if (visiblePoints.length > firstIndex + 1) {
                            var nextpoint = visiblePoints[firstIndex + 1];
                            var point1 = ej.EjSvgRender.utils._getPoint(firstPoint, currentseries);
                            var point2 = ej.EjSvgRender.utils._getPoint(nextpoint, currentseries);
                            var chartObj = this.chartObj;
                            sb.append("M" + " " + (point1.X + chartObj.canvasX) + " " + ((point1.Y + chartObj.canvasY)) + " " + "L" + " " + (point2.X + chartObj.canvasX) + " " + ((point2.Y + chartObj.canvasY)) + " ");

                        }

                    }
                    firstPoint = secondPoint;
                    firstIndex = i;

                }
                else {
                    firstPoint = null;
                }

            }

            lDirection = sb.toString();

            this._drawLinePath(currentseries, style, lDirection);
        }

        else {
            var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries),
            previousStyle, styleOptions, currentPoint,
            nextPoint, point1, point2,
            requireInvertedAxes = this.chartObj.model.requireInvertedAxes,
            count=0,
            chartObj = this.chartObj;

            var visiblePoints = currentseries._visiblePoints,
           length = currentseries._visiblePoints.length - 1;

            var trans = ej.EjSvgRender.utils._getTransform(currentseries.xAxis, currentseries.yAxis, requireInvertedAxes);

            var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };

            this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);

            for (var i = 0; i < length; i++) {
                currentPoint = visiblePoints[i];             
                nextpoint = visiblePoints[i + 1];               
                
                 if (!previousStyle) 
                     previousStyle = this.chartObj.setStyle(this, currentseries, seriesIndex, i);

                 if (nextpoint.visible && currentPoint.visible) {
                     point1 = ej.EjSvgRender.utils._getPoint(currentPoint, currentseries);

                     point2 = ej.EjSvgRender.utils._getPoint(nextpoint, currentseries);

                     sb.append("M" + " " + (point1.X + chartObj.canvasX) + " " + ((point1.Y + chartObj.canvasY)) + " " + "L" + " " + (point2.X + chartObj.canvasX) + " " + ((point2.Y + chartObj.canvasY)) + " ");
                  }
                   
                    styleOptions = this.chartObj.setStyle(this, currentseries, seriesIndex, i + 1);

                    if (styleOptions.interior == previousStyle.interior && (i != length - 1) && nextpoint.visible)
                        continue;                 
                    
                  
                    var options = {
                        'name': currentseries.type,
                        'id': this.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + count,
                        'stroke-dasharray': previousStyle.dashArray,
                        'fill': "none",
                        'stroke-width': previousStyle.width,
                        'stroke-linecap': currentseries.lineCap,
                        'stroke-linejoin': currentseries.lineJoin,
                        'stroke': previousStyle.interior,
                        'opacity': previousStyle.opacity,
                        'd': sb.toString()
                    };

                    this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle);

                    count++;

                    sb = ej.EjSvgRender.utils._getStringBuilder();

                    previousStyle = styleOptions;

                 
                
            }
        }
        if (this.chartObj.dragPoint)
            this.chartObj.svgRenderer.append(this.chartObj.gPreviewSeriesGroupEle, this.chartObj.gSeriesEle);
        else
            this.chartObj.svgRenderer.append(this.gSeriesGroupEle,this.chartObj.gSeriesEle); 
    },
	
	doCircularAnimation: function (chartObj, series, seriesType, seriesIndex) {
	  var type = series.type.toLowerCase();
	  if (type == "pie" || type == "doughnut" || type == "pieofpie"){
         var seriesRender = this, startAngle, endAngle,
         angle = (series.points[0]) ? series.points[0].startAngle : 0;
         var collectionIndex = chartObj.model._isPieOfPie ? series.collectionIndex : 0;
         visiblePoints = series.emptyPointSettings.visible? series.visiblePoints :series._visiblePoints;
         $.each(visiblePoints, function (pointIndex, point) {            
             startAngle = point.startAngle;
             endAngle = point.endAngle;
             chartObj.model._radius = chartObj.model._isPieOfPie? chartObj.model.circularRadius[collectionIndex]:chartObj.model.circularRadius[seriesIndex];
             point.startAngle = 0;
             point.endAngle =point.startAngle;
             chartObj.model.Radius = 0;             
             var piePath = $(chartObj.gSeriesEle).find("#" + chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex)[collectionIndex].childNodes[pointIndex];
			 if (type == "pie" || type=="pieofpie"){
               $(piePath).each(function () { this.StartAngle = angle, this.EndAngle = angle; }).animate(
                 { StartAngle: startAngle, EndAngle: endAngle, pieRadius: chartObj.model._radius },
                 {
                     duration: 1200, queue: false, step: function (now, fx) {
                         if (fx.prop.toString() === "StartAngle") {
                             point.startAngle = now;
                             point.endAngle = point.startAngle;
                         }
                         else if (fx.prop.toString() == "pieRadius" && chartObj.model) 
                             chartObj.model.Radius = now;
                         else  
                             point.endAngle = now;
                         if (chartObj.model) {
                             var result = seriesRender._calculateArcData(chartObj, pointIndex, point, series, seriesIndex, collectionIndex);
                             chartObj.svgRenderer._setAttr($(piePath), { "d": result.Direction });
                             chartObj.model.Radius = chartObj.model._radius;
                         }
                     },
                     complete: function () {
                         seriesRender.circularAnimationComplete(pointIndex, chartObj, series);
                     }
                 });
			   } 
			   else{ 
			      $(piePath).each(function () { this.StartAngle = angle, this.EndAngle = angle; }).animate(
                 { StartAngle: startAngle, EndAngle: endAngle },
                 {
                     duration: 1200, queue: false, step: function (now, fx) {
                         if (fx.prop.toString() === "StartAngle") {
                             point.startAngle = now;
                             point.endAngle = point.startAngle;
                         }
                         else  
                             point.endAngle = now;
                         if (chartObj.model) {
                             var result = seriesRender._calculateArcData(chartObj, pointIndex, point, series, seriesIndex);
                             chartObj.svgRenderer._setAttr($(piePath), { "d": result.Direction });
                             chartObj.model.Radius = chartObj.model._radius;
                         }
                     },
                     complete: function () {
                         seriesRender.circularAnimationComplete(pointIndex, chartObj, series);
                     }
                 });
			   }
           });
	    }
     },
	 circularAnimationComplete: function(pointIndex, chartObj, series){
	     if(!ej.util.isNullOrUndefined(chartObj.model)){
		 var commonEventArgs, i,seriesIndex= $.inArray(series,chartObj.model._visibleSeries), elements;
		     if (chartObj.gSeriesTextEle[seriesIndex])
		         chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gSeriesTextEle[seriesIndex].id), { "visibility": "visible" });
		     if (chartObj.gSymbolGroupEle[seriesIndex])
		         chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gSymbolGroupEle[seriesIndex].id), { "visibility": "visible" });
		     if (chartObj.gDataLabelEle[seriesIndex])
		         chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gDataLabelEle[seriesIndex].id), { "visibility": "visible" });
		     if (series.marker.dataLabel.template) {
		         elements = $(chartObj.element[0].childNodes[0].childNodes);
		         for (i = 0; i < elements.length; i++)
		             $(elements[i]).css('display', 'block');
		     }
		     if (chartObj.gConnectorEle[seriesIndex])
		         chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gConnectorEle[seriesIndex].id), { "visibility": "visible" });
		     if (chartObj.gConnectorLinesGroup)
		         chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gConnectorLinesGroup.id), { "visibility": "visible" });
		     chartObj.model.AnimationComplete = true;
		     series.AnimationComplete = true;
		     commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
		     commonEventArgs.data = { series: series };
		     chartObj._trigger("animationComplete", commonEventArgs);
             }
	 },
	 
    _doLineSymbol: function(element, sec, val, series, invertedAxes, chartobj) {
	  if (element.tagName != "defs") {
        var beginTime = parseInt(val * sec),
        chartObj = (this.chartObj == undefined) ? chartobj : this.chartObj,
        box = ej.EjSvgRender.utils._getBoundingClientRect(element, chartObj, series, invertedAxes),
        centerX = box.x + (box.width / 2),
        centerY = box.y + (box.height / 2),
        scaleVal, $ele = $(element),
        rotate = chartObj.svgRenderer._getAttrVal($ele, "transform");
        rotate = !ej.util.isNullOrUndefined(rotate) ? rotate : " " ;
        chartObj.svgRenderer._setAttr($ele, { "transform": "scale(0)" });
        $ele.delay(beginTime).animate(
            {
                scales: 1
            },
            {
                duration: 200,
                step: function(now) {
                    scaleVal = now;
                    chartObj.svgRenderer._setAttr($ele, { "transform": "translate(" + centerX + " " + centerY + ") scale(" + scaleVal + ") translate(" + (-centerX) + " " + (-centerY) + ")" + rotate });

                }
            }
        );
	  }
    },
    animateSymbol: function(element,delayInterval,series,invertedAxes,chartobj) {
	  if (element.tagName != "defs") {
        var chartObj = (this.chartObj == undefined) ? chartobj : this.chartObj,
        box = ej.EjSvgRender.utils._getBoundingClientRect(element, chartObj, series, invertedAxes),
        centerX = box.x + (box.width / 2),
        centerY = box.y + (box.height / 2),
        scaleVal, $ele = $(element),
        rotate = chartObj.svgRenderer._getAttrVal($ele, "transform");
        rotate = !ej.util.isNullOrUndefined(rotate) ? rotate : " ";
        $ele.delay(delayInterval).each(function () {this.scale = 0.5; }).animate(
            {
                scales: 1
            },
            {
                duration: 500,
                step: function(now) {
                    scaleVal = now;
                    chartObj.svgRenderer._setAttr($ele, { "transform": "translate(" + centerX + " " + centerY + ") scale(" + scaleVal + ") translate(" + (-centerX) + " " + (-centerY) + ")" + (rotate) });
                }
            }
        );
	  }
    },
    animateCylinder: function (chartObj, series,invertedAxes, clipRect) {
        if (series.isTransposed && invertedAxes) {
            var width = clipRect[0].width.animVal.value
            if (chartObj.model.series[0].type.indexOf("bar") > -1) {
                chartObj.svgRenderer._setAttr($(clipRect), { "x": width });
                  $(clipRect).animate({
                      x: 0,
                  }, 2000, function () {
                  });
            }
            else {
                var height = clipRect[0].height.animVal.value;
                chartObj.svgRenderer._setAttr($(clipRect), { "y": 0 });
                $(clipRect).animate(
                    {
                        y: parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "y")),
                        height: parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "height"))
                    },
                    {
                        duration: 2000,
                        step: function (now) {
                            chartObj.svgRenderer._setAttr($(clipRect), { "y": height - now });
                            chartObj.svgRenderer._setAttr($(clipRect), { "height": now });
                        }
                    });
            }
        }
        else {
            if (chartObj.model.series[0].type.indexOf("bar") > -1) {
                $(clipRect).animate(
                  {
                      width: parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "width"))
                  },
                  {
                      duration: 2000,
                      step: function (now) {
                          chartObj.svgRenderer._setAttr($(clipRect), { "width": now });
                      }
                  });
            }
            else {
                var height = clipRect[0].height.animVal.value;
                chartObj.svgRenderer._setAttr($(clipRect), { "y": height });
                $(clipRect).animate({

                    y: 0,
                }, 2000, function () {
                });
            }
        }
    },
    animateRect: function (element,series,invertedAxes, chartObj) {       
        var box = ej.EjSvgRender.utils._getBoundingClientRect(element, chartObj, series, invertedAxes),
        centerX, centerY,scale1, scale2, scaleVal,
        $element = $(element);
        if ((series.isTransposed && invertedAxes) || invertedAxes) {
            if (chartObj.svgRenderer._getAttrVal($element, "plot") === "negative") {
                centerX = box.x + box.width;
                centerY = box.y + box.height;
            } else {               
                centerX = box.x;
                centerY = box.y;
			}
            scale1 = ") scale(";
            scale2 = ",1) translate(";
        }
        else {
            if (chartObj.svgRenderer._getAttrVal($element, "plot") === "negative") {
                centerX = box.x;
                centerY = box.y;
			}
			else {
                 centerX = (box.x +box.width);
                 centerY = (box.y + box.height);
             }
            scale1 = ") scale(1,";
            scale2 = ") translate(";   
        }
        $element.animate(
            {
                scales: 1
            },
            {
                duration: 1000,
                complete: function () {
                    if (series.type.toLowerCase() == "waterfall")
                        $("#" + chartObj.svgObject.id + '_SeriesGroup' + '_waterfallLine_' + series.index).attr("visibility", "visible");
                },
                step: function (now) {
                    scaleVal = now; 
                    chartObj.svgRenderer._setAttr($element, { "transform": "translate(" + centerX + " " + centerY + scale1 + scaleVal + scale2 + (-centerX) + " " + (-centerY) + ")" });
                }
            });
    },
    animateStackingRect: function (element, series, invertedAxes, chartObj) {
       var centerX, centerY, scale1, scale2, $element = $(element), boxX, boxY, scaleVal,
       box = ej.EjSvgRender.utils._getBoundingClientRect(element, chartObj, series, invertedAxes);
        if ((series.isTransposed && invertedAxes) || invertedAxes) {
            boxX = (ej.EjSvgRender.utils._valueToCoefficient(series.yAxis, 0)) * (series.yAxis.width);
            centerX = boxX;
            centerY = box.y;
			scale1 = ") scale(";
            scale2 = ",1) translate(";
        }
        else {
            boxY = (1 - ej.EjSvgRender.utils._valueToCoefficient(series.yAxis, 0)) * (series.yAxis.height);
            centerX = box.x;
            centerY = boxY;
            scale1 = ") scale(1,";
            scale2 = ") translate(";
        }
        $element.animate(
            {
                scales: 1
            },
            {
                duration: 1000,

                step: function (now) {
                    scaleVal = now;
                    chartObj.svgRenderer._setAttr($element, { "transform": "translate(" + centerX + " " + centerY + scale1 + scaleVal + scale2 + (-centerX) + " " + (-centerY) + ")" });
                }
            });
    },
    _doLineAnimation: function (chartObj, clipRect) {
		if (chartObj.model.requireInvertedAxes) {
            var height = parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "height"));
			//Animation for transposed series is working from top to bottom instead of bottom to top
			//In some scenario, series is not appearing because clip rect location gets changed
            //chartObj.svgRenderer._setAttr($(clipRect), { "y": height });
            $(clipRect).animate(
                {
                    //y: parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "y")),
                    clipRectHeight:parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "height")) 
                },
                {
                    duration: 2000,
                    step: function (now) {
                        chartObj.svgRenderer._setAttr($(clipRect), { "y": height - now });
                        chartObj.svgRenderer._setAttr($(clipRect), { "height": now});
                    }
                });
        }
		else
		{
          $(clipRect).animate(
            { 
                clipRectWidth: parseFloat(chartObj.svgRenderer._getAttrVal(clipRect, "width"))
			},
            {
                duration: 2000,
                step: function (now) {
                    chartObj.svgRenderer._setAttr($(clipRect), { "width": now });
                }
            });
		} 
    },
    
    _drawLinePath: function (series, style, direction) {
        var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
		var trans;
        var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
        var translate = null;
        if (this.chartObj.model.AreaType == "cartesianaxes") {
            trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);
            translate = 'translate(' + trans.x + ',' + trans.y + ')'
        }
        
        var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': translate };
        this.chartObj.gSeriesGroupEle =  this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
        if (direction != "" && direction.indexOf("NaN") == -1) {
            var options = {
                'name': series.type,
                'id': this.chartObj.svgObject.id + "_Series" + seriesIndex,
                'fill': 'none',
                'stroke-dasharray': series.dashArray,
                'stroke-width': series.width,
                'stroke': style.SeriesInterior,
                'stroke-linecap': series.lineCap,
                'stroke-linejoin': series.lineJoin,
                'opacity': series.opacity,
                'd': direction
            };
            if (this.chartObj.dragPoint) {               
                    options.id = this.chartObj.svgObject.id + "_PreviewSeries" + seriesIndex;
                    options.opacity = 0.6;
                    if (this.chartObj.model.enableCanvasRendering) this.chartObj.svgRenderer.drawPath(options, this.chartObj.canvasElement, translate);
                    else this.chartObj.svgRenderer.drawPath(options, this.chartObj.gPreviewSeriesGroupEle);               
            }
            else
                this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle);
        }


    },
   
   
    
    

    drawDataLabel: function (series, index, point, x, y, chartRegionIndex, params,outlier) {
	       // method for data label symbols - cartesianaxes
        point.marker = point.marker ? point.marker : {};
        var labelFormat = series.yAxis.labelFormat, labelPrecision, labelPrecisionDefault = 6, labelPrecisionHighest = 20,
            valueType = series.yAxis.valueType, pointText,
            boxPlotLabels = series._visiblePoints[index].boxPlotValues;
            value = (series.type.toLowerCase() == "waterfall" && (point.showIntermediateSum || point.showTotalSum)) ? point.waterfallSum : point.y;
            if (point.text)
                pointText = point.text;
            else if (labelFormat) {
                if (labelFormat.indexOf("{value}") > -1)
                    pointText = labelFormat.replace("{value}", value);
                else if (labelFormat.indexOf('e') == 0 || labelFormat.indexOf('E') == 0) {
                    labelPrecision = labelFormat.match(/(\d+)/g);
                    labelPrecision = labelPrecision == null ? labelPrecisionDefault : labelPrecision > labelPrecisionHighest ? labelPrecisionHighest : labelPrecision;
                    pointText = value.toExponential(labelPrecision);
                }
                else pointText = ej.format(value, labelFormat, this.chartObj.model.locale);
            }
            else pointText = value;
        var chart = this.chartObj,
			chartModel = chart.model,
			seriesIndex = $.inArray(series, chartModel._visibleSeries),
			textAlign, element,
			textBaseline, symbolName,
			marker = $.extend(true, {}, series.marker, point.marker),
			dataLabel = marker.dataLabel,
			dataLabelFont = dataLabel.font,
			textPosition = dataLabel.textPosition.toLowerCase(),
			type = series.type.toLowerCase(),
			size = ej.util.isNullOrUndefined(dataLabelFont.size) ? "11px" : dataLabelFont.size,
			fontStyle = ej.util.isNullOrUndefined(dataLabelFont.fontStyle) ? "Normal" : dataLabelFont.fontStyle,
			fontFamily = ej.util.isNullOrUndefined(dataLabelFont.fontFamily) ? "Segoe UI" : dataLabelFont.fontFamily,
			labelfont = { size: size, fontStyle: fontStyle, fontFamily: fontFamily },
			textOffset = ej.EjSvgRender.utils._measureText(pointText, null, labelfont),
			position = this.textPosition(series, seriesIndex, point, textOffset, type, x, y, chartRegionIndex, index, params),
			commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = { text: pointText, location: { x: position.x + chart.canvasX, y: position.y + chart.canvasY }, seriesIndex: seriesIndex, pointIndex: index };
        chart._trigger("displayTextRendering", commonEventArgs);
        var dataLabelOffset = (marker.dataLabel.offset.y==undefined) ? marker.dataLabel.offset : marker.dataLabel.offset.y;
        var xval = marker.dataLabel.offset.x;
		var textOffset = ej.EjSvgRender.utils._measureText(commonEventArgs.data.text, null, labelfont);
        if (textPosition == 'bottom')
              commonEventArgs.data.location.y = commonEventArgs.data.location.y + dataLabelOffset;
        else
              commonEventArgs.data.location.y = commonEventArgs.data.location.y - dataLabelOffset;
        if (xval)                           
              commonEventArgs.data.location.x = commonEventArgs.data.location.x + xval;
                          
        if (!commonEventArgs.cancel)
        {
            var options = {
                'id': chart.svgObject.id + '_SeriesText' + index + seriesIndex,
                'x': commonEventArgs.data.location.x,
                'y': commonEventArgs.data.location.y,
                'fill': dataLabelFont.color,
                'font-size': dataLabelFont.size,
                'font-family': dataLabelFont.fontFamily,
                'font-style': dataLabelFont.fontStyle,
                'font-weight': dataLabelFont.fontWeight,
                'opacity': dataLabelFont.opacity,
                'type':series.type,
                'text-anchor': 'middle'
            };
            var margin = dataLabel.margin,
                width = textOffset.width + margin.left + margin.right,
                height = textOffset.height + margin.top + margin.bottom,
                location = { X: commonEventArgs.data.location.x, Y: commonEventArgs.data.location.y };

            if (ej.util.isNullOrUndefined(dataLabel.template)) {
				if (dataLabel.shape)
                    element = dataLabel.shape;
                else
                    element = "None";
                $.each(chartModel.symbolShape, function (name) {
                    if (element.toLowerCase() == name.toLowerCase())
                        symbolName = name;
                });
							
				var xXalue = commonEventArgs.data.location.x - (margin.left) / 2 + (margin.right) / 2,
                    yValue = commonEventArgs.data.location.y - (margin.top) / 2 - (height / margin.top) + (margin.bottom) / 2,
                    degree = dataLabel.angle,
                    angle = (degree > 360) ? degree - 360 : (degree < -360) ? degree + 360 : degree;
							
 
							

                //For accurate placement of rotated data labels in canvas
				if (chartModel.enableCanvasRendering && (degree % 360 != 0)) {
				    options.y -= textOffset.height / 4;
				    options.baseline = 'middle';
				}

				if (series._enableSmartLabels) {
				    point.dataLabel = { textX: options.x, textY: options.y, x: xXalue, y: yValue, width: width, height: height }
				    point.margin = {top: margin.top, bottom: margin.bottom}
				}

				if (point.y == point.low && !(point.y === undefined && point.low === undefined)) //undefined condition checked for waterfall series sum value display
							    {
							        point.xPosLow = xXalue;
							        point.yPosLow = yValue;
							        point.widthLow = (symbolName == "None") ? textOffset.width : width;
							        point.heightLow = (symbolName == "None") ? textOffset.height : height;
							        point.textOptionsLow = options;
							        point.textOptionsLow.angle = angle;
							        point.drawTextLow = commonEventArgs.data.text;
							    }
				else if( type.toLowerCase() == "boxandwhisker" && (boxPlotLabels.midvalue != point.y))
				{
					var textOptionsBox = {
					'id': chart.svgObject.id + '_SeriesText' + index + seriesIndex,
					'x':ej.util.isNullOrUndefined(outlier)? commonEventArgs.data.location.x:xXalue,
					'y': ej.util.isNullOrUndefined(outlier)? commonEventArgs.data.location.y:yValue,
					'fill': dataLabelFont.color,
					'font-size': dataLabelFont.size,
					'font-family': dataLabelFont.fontFamily,
					'font-style': dataLabelFont.fontStyle,
					'font-weight': dataLabelFont.fontWeight,
					'opacity': dataLabelFont.opacity,
					'type':series.type,
					'text-anchor': 'middle',
					};
					var boxLabelCount = point.textOptionsBoxValues.length;
                   
					point.textOptionsBoxValues[boxLabelCount] = textOptionsBox;
					point.textOptionsBoxValues[boxLabelCount].angle = angle;
					point.textOptionsBoxValues[boxLabelCount].drawText = commonEventArgs.data.text;
					point.textOptionsBoxValues[boxLabelCount].index = index;
					point.textOptionsBoxValues[boxLabelCount].xPos = ej.util.isNullOrUndefined(outlier)?xXalue:xXalue- (margin.left) / 2 + (margin.right) / 2;
					point.textOptionsBoxValues[boxLabelCount].yPos = ej.util.isNullOrUndefined(outlier) ? yValue :yValue -(margin.top) / 2 - (height / margin.top) + (margin.bottom) / 2;
					point.textOptionsBoxValues[boxLabelCount].seriesIndex = seriesIndex;
					point.textOptionsBoxValues[boxLabelCount].width = (symbolName == "None") ? textOffset.width : width;
					point.textOptionsBoxValues[boxLabelCount].height = (symbolName == "None") ? textOffset.height : height;
					point.textOptionsBoxValues[boxLabelCount].symbolName = symbolName;
                   
				}
							
							    else {
							        // storing the values in point
							    point.textOptions = options;
							    point.textOptions.angle = angle;
							    point.drawText = commonEventArgs.data.text;
							    point.index = index;
							    point.xPos = xXalue;
							    point.yPos = yValue;
							    point.seriesIndex = seriesIndex;
							    point.width = (symbolName == "None") ? textOffset.width : width;
							    point.height = (symbolName == "None") ? textOffset.height : height;
							    if (angle == 90 || angle == -90) //Swapping datalabel text height and width value
							        point.width = [point.height, point.height = point.width][0]; 

							    point.symbolName = symbolName;
							   }
						}
            else {
					location.X -= chart.canvasX;
					location.Y -= chart.canvasY;
					this.drawLabelTemplate(series, point, index, location, chart);
                }                             
        }
    },

    //smart labels for pie and doughnut

    updateSmartLabelPosition: function (currentseries, point, pointIndex, bounds, midAngle, startPoint, textOffset, size, sender, seriesIndex) {
        var renderingPoints = [],
            chartObj = sender,
            chartModel = chartObj.model,
            legend = chartModel.legend,
            legendActualBounds = chartModel.LegendActualBounds,
            legendPosition = legend.position.toLowerCase(),
            seriesType = new ej.seriesTypes[currentseries.type.toLowerCase()](),
            connectorDirection = "",
			bezierPoints="",
            connectorX = bounds.connector.connectorX,
            connectorY = bounds.connector.connectorY,
            midX = bounds.midPoint.midX,
            midY = bounds.midPoint.midY,
            dMidX = bounds.doughnutMidPoint.dMidX,
            dMidY = bounds.doughnutMidPoint.dMidY,
            startX = startPoint.startX,
            startY = startPoint.startY,
            marker = $.extend(true, {}, currentseries.marker, point.marker),
            textGap = (marker.dataLabel.template) ? 0 : 4,
            outerX,
            radius,
            isIntersectedLabel,
            angle = midAngle,
            smartAngle = (currentseries.startAngle > currentseries.endAngle) ? -0.01 : 0.01,
            connectorType = marker.dataLabel.connectorLine.type.toLowerCase(),
            previousLeft, type = currentseries.type.toLowerCase(),
            radius = chartModel._isPieOfPie ? chartModel.circularRadius[currentseries.collectionIndex] : chartModel.circularRadius[seriesIndex],
            labelPosition = type == "pieofpie" ? "inside" :currentseries.labelPosition.toLowerCase();
        if (ej.util.isNullOrUndefined(chartModel.bounds[seriesIndex])){
            chartModel.bounds[seriesIndex] = [];
            chartModel.bounds[seriesIndex].points = [];
            if (labelPosition == 'outsideextended') {
                chartModel.bounds[seriesIndex].points["left"] = [];
                chartModel.bounds[seriesIndex].points["right"] = [];
            }
        }

        //calculation for inside labels
        if (labelPosition == 'inside' && ej.util.isNullOrUndefined(point.smartLabelPosition)) {
            positionX = (midX + startX) / 2;
            positionY = (midY + startY) / 2;

            positionX = (midX + positionX) / 2;
            positionY = (midY + positionY) / 2;

            if (point.isIntersected && chartModel.bounds[seriesIndex].points[pointIndex]) {
                currBounds = chartModel.bounds[seriesIndex].points[pointIndex];
            }
            else {
                if (midX > startX)
                    currBounds = { X: positionX, Y: positionY, Left: positionX, Top: positionY, Right: positionX + size.width, Bottom: positionY + size.height,SeriesIndex:seriesIndex,PointIndex:pointIndex };
                else
                    currBounds = { X: positionX, Y: positionY, Left: positionX - size.width, Top: positionY, Right: positionX, Bottom: positionY + size.height,SeriesIndex:seriesIndex,PointIndex:pointIndex };
             }

            do {
                isIntersectedLabel = false;
                if (!this.IntersectWith(chartObj, point, currBounds, "inside", seriesIndex)) continue;
                previousLeft = currBounds.Left;
				
				//convert radian to degree and break the loop after complete the 360 degree 
                var degree = angle * 180 / Math.PI;
                // chart start the angle from -90. So it will be skip in 270 degree
                if (degree >= 270) continue; 
				
                angle += smartAngle;
                point.isIntersected = true;
                currBounds.Angle = angle;
                if (midX > startX) {
                    currBounds.X = currBounds.Left = seriesType.getXCordinate(startX, (radius) + textOffset, angle);
                    currBounds.Right = currBounds.X + size.width;
                }
                else {
                    currBounds.X = currBounds.Right = seriesType.getXCordinate(startX, (radius) + textOffset, angle);
                    currBounds.Left = currBounds.Right - size.width;
                }
                currBounds.Y = currBounds.Top = seriesType.getYCordinate(startY, (radius) + textOffset, angle);
                currBounds.Bottom = currBounds.Y + size.height;
                isIntersectedLabel = true;
            } while (isIntersectedLabel)
            if (midX > startX && currBounds.X < startX) {
                currBounds.Right = previousLeft;
                currBounds.Left = previousLeft - size.width;
            }
            chartModel.bounds[seriesIndex].points[pointIndex] = currBounds;
       

            if (point.isIntersected && chartModel.bounds[seriesIndex].points[pointIndex].Angle) {

                positionX = seriesType.getXCordinate(startX, (radius) + textOffset, chartModel.bounds[seriesIndex].points[pointIndex].Angle);
                positionY = seriesType.getYCordinate(startY, (radius) + textOffset, chartModel.bounds[seriesIndex].points[pointIndex].Angle);

                var connectorMidX = seriesType.getXCordinate(startX, (radius) + textOffset / 3, midAngle);
                var connectorMidY = seriesType.getYCordinate(startY, (radius) + textOffset / 3, midAngle);
                renderingPoints.push({ X: midX, Y: midY });
                renderingPoints.push({ X: connectorMidX, Y: connectorMidY });
                renderingPoints.push({ X: positionX, Y: positionY });
                if (point.isIntersected && connectorType == 'bezier' && !chartObj.vmlRendering) {
                    bezierPoints = seriesType.drawBezierSegment(renderingPoints, currentseries, pointIndex, chartObj, seriesIndex);
                }
                connectorDirection = "M" + " " + midX + " " + midY + " " + "L" + " " + connectorMidX + " " + connectorMidY + " " + "M" + " " + connectorMidX + " " + connectorMidY + " " + "L" + " " + positionX + " " + positionY;

            }
        }

       //calculation for outside labels
        else if (labelPosition == 'outside' || point.smartLabelPosition == "outside") {
           
            if (midX >= startX) 
                currBounds = { X: connectorX, Y: connectorY, Left: connectorX, Top: connectorY, Right: connectorX + size.width, Bottom: connectorY + size.height, SeriesIndex: seriesIndex, PointIndex: pointIndex };
           else
                currBounds = { X: connectorX, Y: connectorY, Left: connectorX - size.width, Top: connectorY, Right: connectorX, Bottom: connectorY + size.height, SeriesIndex: seriesIndex, PointIndex: pointIndex };
            
            do {
                isIntersectedLabel = false;
               if (!this.IntersectWith(chartObj, point, currBounds, "outside", seriesIndex)) continue;
				 previousLeft = currBounds.Left;
                angle += smartAngle;
                point.isIntersected = true;
                if (midX > startX) {
                    currBounds.X = currBounds.Left = seriesType.getXCordinate(startX, (radius) + textOffset, angle);
                    currBounds.Right = currBounds.X + size.width;
                }
                else {
                    currBounds.X = currBounds.Right = seriesType.getXCordinate(startX, (radius) + textOffset, angle);
                   currBounds.Left = currBounds.Right - size.width;
                }

                currBounds.Y = currBounds.Top = seriesType.getYCordinate(startY, (radius) + textOffset, angle);              
                currBounds.Bottom = currBounds.Y + size.height;
                isIntersectedLabel = true;
            } while (isIntersectedLabel)
			 if (midX > startX && currBounds.X < startX) {
                currBounds.Right = previousLeft;
                currBounds.Left = previousLeft - size.width;
			 }
         	 chartModel.bounds[seriesIndex].points[pointIndex] = currBounds;
            var connectorMidX = seriesType.getXCordinate(startX, (radius) + textOffset / 3, midAngle);
            var connectorMidY = seriesType.getYCordinate(startY, (radius) + textOffset / 3, midAngle);

            renderingPoints.push({ X: midX, Y: midY });
            renderingPoints.push({ X: connectorMidX, Y: connectorMidY });
            renderingPoints.push({ X: currBounds.X, Y: currBounds.Y });
            positionX = currBounds.X;
            positionY = currBounds.Y;
            if (textOffset > 0) {
                if (midX < startX) {
                    outerX = currBounds.X - chartModel.elementSpacing;
                    positionX = outerX - textGap;
                }
                else {
                    outerX = currBounds.X + chartModel.elementSpacing;
                    positionX = outerX + textGap;
                }
                renderingPoints.push({ X: outerX, Y: currBounds.Y });
            }
            if (connectorType == 'bezier' && !chartObj.vmlRendering) {
                bezierPoints = seriesType.drawBezierSegment(renderingPoints, currentseries, pointIndex, chartObj, seriesIndex);
            }
            else {
                connectorDirection = "M" + " " + midX + " " + midY + " " + "L" + " " + connectorMidX + " " + connectorMidY + " "+ "M" + " " + connectorMidX + " " + connectorMidY + " " + "L" + " " + currBounds.X + " " + currBounds.Y + " " + "M" + " " + currBounds.X + " " + currBounds.Y +  " " + "L" + " " + outerX + " " + currBounds.Y;
              }
                      
        }


         //calculation for outsideExtended labels
        else {
            var labelX = midX;
            var labelY = midY;

            midX = midX + (Math.cos((midAngle)) * (-(radius / 10)));
            midY = midY + (Math.sin((midAngle)) * (-(radius / 10)));

            var connectorHeight = radius / 4;

            renderingPoints.push({ X: midX, Y: midY });
            midX = midX + (Math.cos((midAngle)) * connectorHeight);
            midY = midY + (Math.sin((midAngle)) * connectorHeight);

            renderingPoints.push({ X: midX, Y: midY });

            var legendWidth = (legend.visible && legendPosition == "left") ? (chartModel.margin.left + legendActualBounds.Width) : 0;
            var centerX = chartModel.circleCenterX[seriesIndex];
            var labelEdge;

            if (midX < startX) {

                midX = ((centerX - radius - (connectorHeight * 2) - currentseries.LeftLabelMaxWidth > 0)
                                 ? centerX - radius - (connectorHeight * 2) + legendWidth
                                 : (currentseries.LeftLabelMaxWidth > labelX) ? labelX : currentseries.LeftLabelMaxWidth + legendWidth) - size.width / 2;

                labelEdge = renderingPoints[1].X - currentseries.LeftLabelMaxWidth;

                var height = (centerX - radius - (connectorHeight * 2) - currentseries.LeftLabelMaxWidth > 0) ? connectorHeight
                             : (currentseries.LeftLabelMaxWidth > labelX) ? 0
                             : (labelEdge > 3 * (connectorHeight / 2)) ? connectorHeight : labelEdge / 2;

                connectorLineEdge = +size.width / 2;

            }
            else {
                var legendRight = (legend.visible && legendPosition == "right") ? (chartModel.margin.right + legendActualBounds.Width) : 0;
                midX = ((centerX + radius + (connectorHeight * 2) + currentseries.RightLabelMaxWidth < $(chartObj.svgObject).width() - legendRight)
               ? centerX + radius + (connectorHeight * 2) - legendWidth
               : ((centerX + radius + currentseries.RightLabelMaxWidth) > $(chartObj.svgObject).width()) ? labelX : $(chartObj.svgObject).width() - currentseries.RightLabelMaxWidth - legendRight) + size.width / 2;


                labelEdge = ($(chartObj.svgObject).width() - currentseries.RightLabelMaxWidth) - renderingPoints[1].X;

                var height = (centerX + radius + (connectorHeight * 2) + currentseries.RightLabelMaxWidth < $(chartObj.svgObject).width()) ? connectorHeight
                            : ((centerX + radius + currentseries.RightLabelMaxWidth) > $(chartObj.svgObject).width()) ? 0
                            : (labelEdge > 3 * (connectorHeight / 2)) ? connectorHeight : labelEdge / 2;
                connectorLineEdge = -size.width / 2;
            }

            var distanceFromOrigin = (Math.sqrt(Math.pow(labelX - midX, 2) + Math.pow(labelY - midY, 2))) / 10;

            var isLeft = (midX < startX) ? true : false;
            midX = isLeft ? midX + distanceFromOrigin : midX - distanceFromOrigin;
            var index = isLeft ? 1 : -1;

            var bounds = isLeft ? chartModel.bounds[seriesIndex].points["left"] : chartModel.bounds[seriesIndex].points["right"];
            var currBounds = { X: midX, Y: midY, Left: midX, Top: midY, Right: midX + size.width, Bottom: midY + size.height, index: pointIndex, SeriesIndex: seriesIndex, PointIndex: pointIndex };
            var clockwise = currentseries.endAngle > currentseries.startAngle ? true : false;
            if (this.IntersectWith(chartObj, point, currBounds, "outsideExtended", seriesIndex)) {
                renderingPoints.push(midX < startX
                       ? { X: midX + height + connectorLineEdge, Y: midY }
                       : { X: midX - height + connectorLineEdge, Y: midY });
                if (!clockwise && currentseries.startAngle != null) {
                    if (!isLeft)
                        midY = bounds[bounds.length - 1].Y + size.height + 2;
                    else
                        midY = bounds[bounds.length - 1].Y - size.height - 2;
                }
                else {
                    midY = bounds[bounds.length - 1].Y + size.height + 2;
                }
                currBounds.Y = midY;
                currBounds.Top = midY;
                currBounds.Bottom = midY + size.height;
            }
            renderingPoints.push({ X: midX + connectorLineEdge, Y: midY });
            if (centerX < renderingPoints[0].X && (renderingPoints[1].X > renderingPoints[2].X))
                renderingPoints[2].X = renderingPoints[1].X;
            if (centerX > renderingPoints[0].X && (renderingPoints[1].X < renderingPoints[2].X))
                renderingPoints[2].X = renderingPoints[1].X;
            if (!isLeft) {
                chartModel.bounds[seriesIndex].points["right"].push(currBounds);
                if (renderingPoints[renderingPoints.length - 1].X < renderingPoints[renderingPoints.length - 2].X)
                    renderingPoints[renderingPoints.length - 2].X = renderingPoints[renderingPoints.length - 1].X;
               
            }
            else {
                chartModel.bounds[seriesIndex].points["left"].push(currBounds);
                if (renderingPoints[renderingPoints.length - 1].X > renderingPoints[renderingPoints.length - 2].X)
                    renderingPoints[renderingPoints.length - 2].X = renderingPoints[renderingPoints.length - 1].X;
            }


            connectorDirection = ej.EjSvgRender.utils._getStringBuilder();
            if (connectorType == 'bezier' && !chartObj.vmlRendering) {
                bezierPoints=seriesType.drawBezierSegment(renderingPoints, currentseries, pointIndex, chartObj,seriesIndex);
            }
            else {
                for (k = 0; k < renderingPoints.length; k++) {
                    if (k == renderingPoints.length - 1)
                        connectorDirection.append(" ");
                    else
                        connectorDirection.append("M" + " " + (renderingPoints[k].X) + " " + (renderingPoints[k].Y) + " " + "L" + " " + (renderingPoints[k + 1].X) + " " + (renderingPoints[k + 1].Y) + " ");
                }
                connectorDirection = connectorDirection.toString();
            }
            positionX = renderingPoints[renderingPoints.length - 1].X + ((midX < startX) ? -textGap : textGap);
            positionY = renderingPoints[renderingPoints.length - 1].Y;
        }
        return { positionX: positionX, positionY: positionY, connectorDirection: connectorDirection, isInterSected:point.isIntersected,bezierPath:bezierPoints };
    },

    updateLabelPosition: function (currentseries, point, pointIndex, bounds, midAngle, startPoint, textOffset, size, sender, seriesIndex){

        var renderingPoints=[];
        var chartObj=sender; 
        var seriesType = new ej.seriesTypes[currentseries.type.toLowerCase()]();
        var connectorDirection = "";

        var connectorX = bounds.connector.connectorX;
        var connectorY = bounds.connector.connectorY;
        var midX = bounds.midPoint.midX;
        var midY = bounds.midPoint.midY;
        var dMidX = bounds.doughnutMidPoint.dMidX;
        var dMidY = bounds.doughnutMidPoint.dMidY;
        var startX = startPoint.startX;
        var startY = startPoint.startY;
        var marker = $.extend(true, {}, currentseries.marker, point.marker);
        var textGap = (marker.dataLabel.template) ? 0 :4;
       
        var outerX;
        var radius = chartObj.model.circularRadius[seriesIndex];
        var labelPosition = type == "pieofpie" ? "inside" : currentseries.labelPosition.toLowerCase();

        //calculation for outside labels

        renderingPoints.push({ X: midX, Y: midY });
        renderingPoints.push({ X: connectorX, Y: connectorY });
        positionX = connectorX;
        positionY = connectorY;

        if (labelPosition == 'outside') {
            if (textOffset > 0) {
                if (connectorX < startX) {
                    outerX = connectorX - chartObj.model.elementSpacing;
                    positionX = outerX - textGap;
                }
                else {
                    outerX = connectorX + chartObj.model.elementSpacing;
                    positionX = outerX + textGap;
                }
                renderingPoints.push({ X: outerX, Y: connectorY });
            } 
           
            if (marker.dataLabel.connectorLine.type.toLowerCase() == 'bezier' && !chartObj.vmlRendering) {
                seriesType.drawBezierSegment(renderingPoints, currentseries, pointIndex, chartObj,seriesIndex);
            }
            else {
                connectorDirection = "M" + " " + midX + " " + midY + " " + "L" + " " + connectorX + " " + connectorY + " " + "M" + " " + connectorX + " " + connectorY +" "+ "L" + " " + outerX + " " + connectorY;
            }
          
        }


            //calculation for outsideextended labels
        else if (labelPosition == 'outsideextended') {

            labelX=midX;
            labelY=midY;

            midX = midX + (Math.cos((midAngle)) * (-(radius / 10)));
            midY = midY + (Math.sin((midAngle)) * (-(radius / 10)));


            var renderingPoints = [];

            var connectorHeight = radius / 4;

            renderingPoints.push({ X: midX, Y: midY });
            connectorX = midX + (Math.cos((midAngle)) * connectorHeight);
            connectorY = midY + (Math.sin((midAngle)) * connectorHeight);

            renderingPoints.push({ X: connectorX, Y: connectorY });

            var legendWidth = (chartObj.model.legend.visible && (chartObj.model.legend.position.toLowerCase() == "left" || chartObj.model.legend.position.toLowerCase() == "right")) ? (chartObj.model.elementSpacing) : 0;

            if (midX < startX) {
                connectorX = (chartObj.model.centerX - radius - (connectorHeight * 2) - currentseries.LeftLabelMaxWidth > 0)
                                     ? chartObj.model.centerX - radius - (connectorHeight * 2) + legendWidth
                                     : (currentseries.LeftLabelMaxWidth > labelX) ? labelX : currentseries.LeftLabelMaxWidth;
            }
            else {
                connectorX = (chartObj.model.centerX + radius + (connectorHeight * 2) + currentseries.RightLabelMaxWidth < $(chartObj.svgObject).width())
                     ? chartObj.model.centerX + radius + (connectorHeight * 2) - legendWidth
                     : ((chartObj.model.centerX + radius + currentseries.RightLabelMaxWidth) > $(chartObj.svgObject).width()) ? labelX : $(chartObj.svgObject).width() - currentseries.RightLabelMaxWidth;
                      
            }

            renderingPoints.push({ X: connectorX, Y: connectorY });

            connectorDirection = ej.EjSvgRender.utils._getStringBuilder();
            if (marker.dataLabel.connectorLine.type.toLowerCase() == 'bezier' && !chartObj.vmlRendering) {
                seriesType.drawBezierSegment(renderingPoints, currentseries, pointIndex, chartObj, seriesIndex);
            }
            else {
                for (k = 0; k < renderingPoints.length; k++) {
                    if (k == renderingPoints.length - 1)
                        connectorDirection.append(" ");
                    else
                        connectorDirection.append("M" + " " + (renderingPoints[k].X) + " " + (renderingPoints[k].Y) + " " + "L" + " " + (renderingPoints[k + 1].X) + " " + (renderingPoints[k + 1].Y) + " ");
                }
                connectorDirection = connectorDirection.toString();
            }
            positionX = renderingPoints[renderingPoints.length - 1].X + ((midX < startX) ? -textGap : textGap);;
            positionY = renderingPoints[renderingPoints.length - 1].Y;
        }

       //calculation for inside labels

        else {
            if (currentseries.type.toLowerCase() == "doughnut") {
                positionX = (midX + dMidX) / 2;
                positionY = (midY + dMidY) / 2;
            }
            else {
                positionX = (midX + startX) / 2;
                positionY = (midY + startY) / 2;

                positionX = (midX + positionX) / 2;
                positionY = (midY + positionY) / 2;
            }
        }

        return { positionX: positionX, positionY: positionY, connectorDirection: connectorDirection, points:renderingPoints[renderingPoints.length-1]};
    },
    // method to update the position of the data labels in pyramid chart
        updateSmartLabel: function (chartObj, currentseries, pointIndex, point) {
            // declaration
        var datalabelTemplateVisiblity = true,
            connectorDirection = "",
            labelPosition = currentseries.labelPosition.toLowerCase(),
            marker = $.extend(true, {}, currentseries.marker, point.marker),
            dataLabel = marker.dataLabel,
            areaBounds = chartObj.model.m_AreaBounds,
			svgHeight = chartObj.model.svgHeight,
            type = currentseries.type.toLowerCase(),
            pyrX, pyrY, ele, xPos, yPos;
            point._labelPlacement = "";
            if (labelPosition == "inside" || labelPosition == "outsideextended")
                this.calculateInsideConnectorLines(pointIndex, point, currentseries, chartObj);
            else
                this.compareDataLabels(point, pointIndex, chartObj.model.outsideDataRegionPoints, currentseries, chartObj);

            pyrX = (chartObj.model.enableCanvasRendering && !dataLabel.template) ? chartObj.pyrX : 0;
            pyrY = (chartObj.model.enableCanvasRendering && !dataLabel.template) ? chartObj.pyrY : 0;
            if (type == "pyramid") {
                if ((chartObj.model.actualHeight< point.yPos - pyrY) || (point.xPos - pyrX > areaBounds.Width && point._labelPlacement == "insideoverlap") || (chartObj.model.legend.position == "right" && dataLabel.template && (point.xPos + point.width) > areaBounds.Width + chartObj.model.LegendActualBounds.Width)) {
                    datalabelTemplateVisiblity = false;
                    point.drawTextacc = "";
                }
            }
            else {
                if ((point.yPos - pyrY < 0) || (point.xPos - pyrX > areaBounds.Width && point._labelPlacement == "insideoverlap") || (chartObj.model.legend.position == "right" && dataLabel.template && (point.xPos + point.width) > areaBounds.Width + chartObj.model.LegendActualBounds.Width)) {
                    datalabelTemplateVisiblity = false;
                    point.drawTextacc = "";

                }
            }
            if ((labelPosition == "outside" || point._labelPlacement == "insideoverlap") && datalabelTemplateVisiblity)
                connectorDirection = this.drawConnectorLines(pointIndex, point, currentseries, chartObj);

            if (dataLabel.template) {
                ele = $("#" + point.id);
                if (!datalabelTemplateVisiblity) {
                    ele.css("display", "none");
                }
                else {
                    xPos = (point._labelPlacement == "insidenooverlap") ? point.textOptionsacc.x + chartObj.pyrX - point.width / 2 : point.textOptionsacc.x + chartObj.pyrX;
                    yPos = (point._labelPlacement == "insidenooverlap") ? point.textOptionsacc.y + chartObj.pyrY : point.textOptionsacc.y + chartObj.pyrY - chartObj.model.elementSpacing;
                    ele.css("left", xPos).css("top", yPos);
                    ele.css("height", point.height).css("overflow", "hidden");
                }
            }


            return { xPos: point.xPos, yPos: point.yPos, textOptionsacc: point.textOptionsacc, connectorDirection: connectorDirection.connectorDirection,bezierPath:connectorDirection.bezierdir, drawTextacc: point.drawTextacc };
        },
        // method to compare the data labels in chart for intersection
        compareDataLabels: function (point, pointIndex, outsideDataRegionPoints, currentseries, chartObj) {

            var marker = $.extend(true, {}, currentseries.marker, point.marker),
                dataLabel = marker.dataLabel,
                prevLabel, collide, regionPoint, degree, angle, rotate,
                elementSpacing = chartObj.model.elementSpacing,
                margin = marker.dataLabel.margin,
				visiblePointslength = currentseries._visiblePoints.length,
				labelPosition = currentseries.labelPosition.toLowerCase(),
                pyrX = (chartObj.model.enableCanvasRendering) ? chartObj.pyrX : 0,
                pyrY = (chartObj.model.enableCanvasRendering) ? chartObj.pyrY : 0;
            for (var j = 0, length = outsideDataRegionPoints.length; j < length ; j++) {
                prevLabel = outsideDataRegionPoints[j];
                collide = this.isCollide(prevLabel, point, currentseries);
                if (collide.state) {
                    if (labelPosition == "inside" || labelPosition == "outsideextended") {
                        point.textOptionsacc.y = point.yPos = point.textOptionsacc.y + collide.height;
                        positionPoint = (dataLabel.template) ? { x: point.xPos, y: point.yPos } : { x: point.xPos - pyrX, y: point.yPos - pyrY };
                        for (var k = 0, visibleLength = visiblePointslength ; k < visibleLength ; k++) {
                            regionPoint = (chartObj.isPointInPolygon(chartObj.model.chartRegions[0].Region[k].Polygon, positionPoint));
                            if (regionPoint) {
                                point.textOptionsacc.x = point.xPos = point.textOptionsacc.x + point.width;
                                positionPoint = (dataLabel.template) ? { x: point.xPos, y: point.yPos } : { x: point.xPos - pyrX, y: point.yPos - pyrY };
                            }
                        }
                    }
                    else {
                        point._labelPlacement = "outside";
                        point.textOptionsacc.y = point.yPos = (currentseries.type.toLowerCase() == "pyramid") ? point.yPos + collide.height + elementSpacing / 2 : point.yPos + collide.height - elementSpacing / 2;
                        point.textOptionsacc.y = point.textOptionsacc.y + point.height / 4 - elementSpacing / 2 + margin.top / 2 - margin.bottom / 2;
                    }
                }
            }
            degree = dataLabel.angle;
            angle = (degree > 360) ? degree - 360 : (degree < -360) ? degree + 360 : degree;
            rotate = 'rotate(' + angle + ',' + (point.textOptionsacc.x) + ',' + (point.textOptionsacc.y) + ')';
            $(point.textOptionsacc).attr('transform', rotate);
            $(point.textOptionsacc).attr('labelRotation', degree);//for canvas label rotation
            $(point.textOptionsacc).attr({
                'transform': rotate
            });
            if (labelPosition == "inside" || labelPosition == "outsideextended") {
                point.yPos = point.yPos + elementSpacing / 4;
                point.textOptionsacc.y = point.textOptionsacc.y + point.height / 4 + margin.top / 2 - margin.bottom / 2;
            }
            outsideDataRegionPoints[outsideDataRegionPoints.length] = point;
        },

        //Inside region checking and smartlabels
        calculateInsideConnectorLines: function (pointIndex, point, currentseries, chartObj) {

            var polygon = point.Polygon,
                marker = $.extend(true, {}, currentseries.marker, point.marker),
                dataLabel = marker.dataLabel,
                font = dataLabel.font, connectorHeight,
                pyrX = (chartObj.model.enableCanvasRendering) ? chartObj.pyrX : 0,
                pyrY = (chartObj.model.enableCanvasRendering) ? chartObj.pyrY : 0,
                //inside connector line height
                connectorLength = 70,
                datalabelWidth = ej.EjSvgRender.utils._measureText(point.drawTextacc, null, font),
                positionPoint = (dataLabel.template) ? { x: point.xPos, y: point.yPos } : { x: point.xPos + (datalabelWidth.width / 2) - pyrX, y: point.yPos - (point.height / 2) - pyrY },
                regionPoint = chartObj.isPointInPolygon(polygon, positionPoint);
            if (!regionPoint) {
                point._labelPlacement = "insideoverlap";
                point.textOptionsacc['text-anchor'] = 'start';
                if (point.startX + connectorLength < chartObj.model.m_AreaBounds.Width)
                    connectorHeight = connectorLength;
                else
                    connectorHeight = chartObj.model.m_AreaBounds.Width - (point.startX);

                point.textOptionsacc.x = point.xPos = point.startX + connectorHeight;
                point.textOptionsacc.y = point.yPos = point.yLocation;
                if (chartObj.model.enableCanvasRendering && !dataLabel.template) {
                    point.textOptionsacc.x += chartObj.pyrX;
                    point.textOptionsacc.y += chartObj.pyrY;
                    point.xPos += chartObj.pyrX;
                    point.yPos += chartObj.pyrY;
                }
                this.compareDataLabels(point, pointIndex, chartObj.model.outsideDataRegionPoints, currentseries, chartObj);

            }

            else {
                point._labelPlacement = "insidenooverlap";
            }
        },
        //smartLabels connector Lines
        drawConnectorLines: function (index, currentPoint, currentseries, chartObj) {
            var bezierdir = "";
            var seriesType = new ej.seriesTypes[currentseries.type.toLowerCase()](),
                startx = currentseries._visiblePoints[index].startX,
                starty = currentseries._visiblePoints[index].startY,
                connectorDirection = "",
				seriesIndex = $.inArray(currentseries, chartObj.model._visibleSeries),
                marker = $.extend(true, {}, currentseries.marker, currentPoint.marker),
                dataLabel = marker.dataLabel,
                endy = currentPoint.textOptionsacc.y - chartObj.model.elementSpacing / 2,
                pyrX = (chartObj.model.enableCanvasRendering) ? chartObj.pyrX : 0,
                pyrY = (chartObj.model.enableCanvasRendering) ? chartObj.pyrY : 0,
                renderingPoints = [{ X: startx + pyrX, Y: starty + pyrY },//bezier curve control points
                                   { X: currentPoint.textOptionsacc.x, Y: endy }];
            if (dataLabel.connectorLine.type.toLowerCase() == 'bezier' && !chartObj.vmlRendering)
                bezierdir =  seriesType.drawBezierSegment(renderingPoints, currentseries, index, chartObj, seriesIndex);
            else {
                connectorDirection = "M" + " " + (startx) + " " + (starty) + " " + "L" + " " + (currentPoint.textOptionsacc.x) + " " + (endy);
                if (chartObj.model.enableCanvasRendering && !dataLabel.template)
                    connectorDirection = "M" + " " + (startx) + " " + (starty) + " " + "L" + " " + (currentPoint.textOptionsacc.x - pyrX) + " " + (endy - pyrY);
            }
            return { connectorDirection: connectorDirection, bezierdir: bezierdir };
        },

        //method to detect collision between data labels
        isCollide: function (prevlabel, currentlabel, currentseries) {
            var width = 0,
                height = 0,
                type = currentseries.type.toLowerCase(),
                state;
            state = !(
           ((prevlabel.yPos + prevlabel.height) < (currentlabel.yPos)) ||
           (prevlabel.yPos > (currentlabel.yPos + currentlabel.height)) ||
           ((prevlabel.xPos + prevlabel.width / 2) < currentlabel.xPos - currentlabel.width / 2) ||
           ((prevlabel.xPos - prevlabel.width) > (currentlabel.xPos + currentlabel.width)));

            if (state && type == "pyramid") {
                height = ((prevlabel.yPos + prevlabel.height) - (currentlabel.yPos));
                width = (prevlabel.xPos + prevlabel.width) - currentlabel.xPos;
            }
            else if (state && type == "funnel") {
                height = ((prevlabel.yPos) - (currentlabel.yPos + currentlabel.height));
                width = (prevlabel.xPos + prevlabel.width) - currentlabel.xPos;
            }
            return { state: state, height: height, width: width };
        },
        // trimming the text when it exceeds chart area
        trimText: function (text, maxLength, ellipsis) {
            maxLength--;
            var length = maxLength - ellipsis.length;
            trimmedText = text.substr(0, length);
            return trimmedText + ellipsis;
        },

        //calculate a length of a text for datalabel trimming
        trimfunction: function (datalabelText, remainingWidth, datalabelLength, elipsis, axisWidth, font) {
            var datalabelText, datalabelLength;
            while (remainingWidth < datalabelLength) {
                datalabelText = this.trimText(datalabelText, datalabelText.length, elipsis);
                datalabelLength = ej.EjSvgRender.utils._measureText(datalabelText, axisWidth, font).width;
                if (datalabelText == elipsis) {
                    datalabelText = "";
                    break;
                }
            }
            return datalabelText;
        },

        //To calculate start and end point of a text inside a pie and doughnut region
        calculatePosition: function (chartObj, textOptions, datalabelLength, startX, startY) {
            var rightEndX, rightEndY, leftEndX, leftEndY;            
            rightEndX = (textOptions.x + (datalabelLength / 2)) - startX;
            rightEndY = (textOptions.y) - (startY);
            leftEndX = (textOptions.x - (datalabelLength / 2)) - startX;
            leftEndY = textOptions.y - startY;
            return { rightEndX: rightEndX, rightEndY: rightEndY, leftEndX: leftEndX, leftEndY: leftEndY };
                        
        },

        //To caluculate textoptions
        textOption: function (currentseries, chartObj, textsize, pyrX, pyrY, pointIndex, textAnchor, positionX, positionY, seriesIndex,visiblePoint) {
            if (chartObj.model._isPieOfPie) 
                var marker = $.extend(true, {}, currentseries.marker, visiblePoint.marker);            
            else
                var marker = $.extend(true, {}, currentseries.marker, currentseries._visiblePoints[pointIndex].marker);
            if (!marker.dataLabel.template) {
                $("#" + chartObj.svgObject.id +'series' + seriesIndex+ '_PointText' + pointIndex).remove();
                var textOptions = {
                    'id': chartObj.svgObject.id + 'series' + seriesIndex + '_PointText' + pointIndex,
                    'x': positionX + pyrX,
                    'y': positionY + textsize.height / 4 + pyrY,
                    'fill': marker.dataLabel.font.color,
                    'font-size': marker.dataLabel.font.size,
                    'font-family': marker.dataLabel.font.fontFamily,
                    'font-style': marker.dataLabel.font.fontStyle,
                    'font-weight': marker.dataLabel.font.fontWeight,
                    'opacity': marker.dataLabel.font.opacity,
                    'text-anchor': textAnchor,
                    'cursor': 'default',
                    'degree':marker.dataLabel.angle
                };
                //To rotate datalabels
                var degree = marker.dataLabel.angle;
                var angle = (degree > 360) ? degree - 360 : (degree < -360) ? degree + 360 : degree;
                var rotate = 'rotate(' + angle + ',' + (positionX) + ',' + (positionY) + ')';
                $(textOptions).attr('transform', rotate);
                $(textOptions).attr('labelRotation', degree);//for canvas label rotation
                $(textOptions).attr({
                    'transform': rotate
                });
            }
            return textOptions;
        },

        //To trim  datalabel when it exceed a particular pie and doughnut region
        labelTrim: function (chartObj, textOptions, datalabelLength, datalabelText, startX, startY, point, font,seriesIndex, pieSeriesIndex) {
            var chartStartAngle = -.5 * Math.PI;
            var chartEndAngle = .5 * Math.PI;
            var position = this.calculatePosition(chartObj, textOptions, datalabelLength, startX, startY);
            var startAngle = chartObj.model.series[seriesIndex].startAngle;
            var endAngle = chartObj.model.series[seriesIndex].endAngle;
            var regionData = (chartObj.model.chartRegions.length <chartObj.model._visibleSeries.length) ? chartObj.model.chartRegions[0].Region : chartObj.model.chartRegions[seriesIndex].Region;
            var pointStartAngle, pointEndAngle;
            var distanceFromCenter;
            var textinRegion;
            var trimPosition, datalabelWidth;
            var ellipsis = "...";
            var firstStartAngle = [];
            var totalDegree = endAngle - startAngle;
            var seriesIndex = chartObj.model._isPieOfPie ? pieSeriesIndex : seriesIndex;
            if (totalDegree < 0) {
                endAngle = endAngle / 360;
                var arcAngle = (endAngle) ? 2 * Math.PI * (endAngle < 0 ? 1 + endAngle : endAngle) : 0;
            }
            else
                var arcAngle = startAngle ? 2 * Math.PI * (chartObj.model.itemCurrentXPos < 0 ? 1 + chartObj.model.itemCurrentXPos : chartObj.model.itemCurrentXPos) : 0;            
            startAngle = (Math.atan2(position.rightEndY, position.rightEndX) - chartStartAngle - arcAngle) % (2 * Math.PI);
            if (startAngle < 0) startAngle = 2 * Math.PI + startAngle;
            endAngle = (Math.atan2(position.leftEndY, position.leftEndX) - chartStartAngle - arcAngle) % (2 * Math.PI);
            if (endAngle < 0) endAngle = 2 * Math.PI + endAngle;            
            pointStartAngle = parseFloat(point.start.toFixed(14));
            pointEndAngle = parseFloat(point.end.toFixed(14));
            if (totalDegree > 0) {
                if (ej.util.isNullOrUndefined(chartObj.firstStartAngle[0])) {
                    chartObj.firstStartAngle.push(pointStartAngle);
                }
                pointStartAngle = (chartObj.firstStartAngle[0] < 0) ? (chartObj.model._isPieOfPie ? pointStartAngle : 2 * Math.PI + pointStartAngle) : pointStartAngle;
                pointEndAngle = (chartObj.firstStartAngle[0] < 0) ? (chartObj.model._isPieOfPie ? pointEndAngle : 2 * Math.PI + pointEndAngle) : pointEndAngle;             
            }
            else {
                  pointStartAngle = pointStartAngle < 0 ? (chartObj.model._isPieOfPie ? pointStartAngle : 2 * Math.PI + pointStartAngle): pointStartAngle;
                  pointEndAngle = pointEndAngle < 0 ? (chartObj.model._isPieOfPie ? pointEndAngle : 2 * Math.PI + pointEndAngle) : pointEndAngle;
            }
            pointStartAngle -= arcAngle;
            pointEndAngle -= arcAngle;
			// to check start and end angle when greater than 360 in pieofpie
            if (pointStartAngle > 2 * Math.PI && pointEndAngle > 2 * Math.PI) {
                startAngle = startAngle + 2 * Math.PI;
                endAngle = endAngle + 2 * Math.PI;
            }
            else if (pointStartAngle < 2 * Math.PI && pointEndAngle > 2 * Math.PI) {
                if (startAngle < Math.PI / 2)
                    startAngle = startAngle + 2 * Math.PI;
                if (endAngle < Math.PI / 2)
                    endAngle = endAngle + 2 * Math.PI;
            }
            if (startAngle < 0 && (endAngle > 0 || endAngle == null)) {
                pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                pointEndAngle = pointEndAngle <= 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
            }
            if (chartObj.model.circleCenterX[seriesIndex] < textOptions.x) {
                distanceFromCenter = Math.sqrt(Math.pow(Math.abs(position.rightEndX), 2) + Math.pow(Math.abs(position.rightEndY), 2));
            }
            else
                distanceFromCenter = Math.sqrt(Math.pow(Math.abs(position.leftEndX), 2) + Math.pow(Math.abs(position.leftEndY), 2));            
            if (totalDegree < 0) {               
                pointEndAngle = [pointStartAngle, pointStartAngle = pointEndAngle][0];
            }            
            if ((endAngle >= pointStartAngle && endAngle <= pointEndAngle) && (startAngle >= pointStartAngle && startAngle <= pointEndAngle) && (distanceFromCenter <= chartObj.model.circularRadius[seriesIndex] && distanceFromCenter > 0)) {
                textinRegion = true;
            }
            else {
                textinRegion = false;
                while (!textinRegion) {
                   datalabelText = this.trimText(datalabelText, datalabelText.length, ellipsis);
                   if (datalabelText == ellipsis) {
                       datalabelText = "";
                       break;
                   }  
                   datalabeltWidth = ej.EjSvgRender.utils._measureText(datalabelText, null, font);
                   trimPosition = this.calculatePosition(chartObj, textOptions, datalabeltWidth.width, startX, startY);
                   startangle = (Math.atan2(trimPosition.rightEndY, trimPosition.rightEndX) - chartStartAngle - arcAngle) % (2 * Math.PI);
                   if (startangle < 0) startangle = 2 * Math.PI + startangle;
                   var endAngle = (Math.atan2(trimPosition.leftEndY, trimPosition.leftEndX) - chartStartAngle - arcAngle) % (2 * Math.PI);
                   if (endAngle < 0) endAngle = 2 * Math.PI + endAngle;
                   if (chartObj.model.circleCenterX[seriesIndex]< textOptions.x) {
                      distanceFromCenter = Math.sqrt(Math.pow(Math.abs(trimPosition.rightEndX), 2) + Math.pow(Math.abs(trimPosition.rightEndY), 2));
                   }
                   else
                      distanceFromCenter = Math.sqrt(Math.pow(Math.abs(trimPosition.leftEndX), 2) + Math.pow(Math.abs(trimPosition.leftEndY), 2));
                    // to check when startangle and endangle is greater than 360 degree for pieofpie
                   if ((pointStartAngle > 2 * Math.PI && pointEndAngle > 2 * Math.PI) && chartObj.model._isPieOfPie) {
                         var  stAngle = pointStartAngle - 2 * Math.PI;
                           pointStartAngle = stAngle;
                         var  enAngle = pointEndAngle - 2 * Math.PI;
                           pointEndAngle = enAngle;
                   }
                   else if ((pointStartAngle !=0 && pointStartAngle < 2 * Math.PI && pointEndAngle >= 2 * Math.PI) && chartObj.model._isPieOfPie) {
                      var stAngle = pointStartAngle - 2 * Math.PI;
                       pointStartAngle = stAngle;
                   }
                   if ((endAngle >= pointStartAngle && endAngle <= pointEndAngle) &&
                       (startangle >= pointStartAngle && startangle <= pointEndAngle) &&
                       (distanceFromCenter <= chartObj.model.circularRadius[seriesIndex] && distanceFromCenter > 0)) {
                      textinRegion = true;
                   }
                   
                 }
            }
                        
         return datalabelText;
        },
    
    
        drawDataLabelAcc: function (sender, currentseries, pointIndex, point, seriesIndex, pieSeriesIndex) {
            // method for data label symbols - accumulation series	
            var pointMarker = point.marker;
            if (point.visible && ((pointMarker && pointMarker.dataLabel && pointMarker.dataLabel.visible) || (!pointMarker || !pointMarker.dataLabel) && currentseries.marker.dataLabel.visible)) {
                var chartObj = sender,
                    type = currentseries.type.toLowerCase(),
                    seriesType = new ej.seriesTypes[type](),
                    isNull = ej.util.isNullOrUndefined,
                    _labelPosition = type == "pieofpie" ? "inside" : currentseries.labelPosition.toLowerCase(),
                    chartModel = chartObj.model,
					chartTitle = chartModel.title,
                    measureText = ej.EjSvgRender.utils._measureText,
                    elementSpacing = chartModel.elementSpacing,
                    seriesMarker = currentseries.marker,
                    dataLabel = seriesMarker.dataLabel,
                    margin = dataLabel.margin,
                    dataLabelFont = dataLabel.font,
                    connectorLine = dataLabel.connectorLine,
                    connectorType = connectorLine.type.toLowerCase(),
                    legend = chartModel.legend,
                    legendPosition = legend.position.toLowerCase(),
                    legendActualBounds = chartModel.LegendActualBounds,
                    text = isNull(point.text) ? point.y : point.text,
                    enableWrap=dataLabel.enableWrap,
                    wrapConnectorpoints,
                    labelText = text,
                    srIndex = chartModel._isPieOfPie ? pieSeriesIndex : seriesIndex;
              
                var connectorDirection, labelfont,
                    commonEventArgs, textsize,
                    positionX = 0, textWidth, textHeight,
                    positionY = 0,
                    pointColor;

                if ((type == "pyramid" || type == "funnel") && _labelPosition == 'outsideextended')
                    _labelPosition = 'inside';

                commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = { text: text, series: currentseries, pointIndex: pointIndex };
                chartObj._trigger("displayTextRendering", commonEventArgs);

                labelfont = { size: dataLabelFont.size, fontStyle: dataLabelFont.fontStyle, fontFamily: dataLabelFont.fontFamily };
                textsize = measureText(commonEventArgs.data.text, null, labelfont);
                textWidth = textsize.width + margin.left + margin.right;
                textHeight = textsize.height + margin.top + margin.bottom;

                if (type == "pyramid" || type == "funnel") {
                    var measureTitle = (chartModel.title.text) ? measureText(chartModel.title.text, $(this.svgObject).width() - chartModel.margin.left - chartModel.margin.right, chartModel.title.font) : 0;
                    var mesureSubTitle = (chartObj.model.title.subTitle.text) ? ej.EjSvgRender.utils._measureText(chartObj.model.title.subTitle.text, $(this.svgObject).width() - chartObj.model.margin.left - chartObj.model.margin.right, chartObj.model.title.subTitle.font) : 0;
                    var subtitleHeight = (chartObj.model.title.subTitle.text === '') ? 0 : mesureSubTitle.height;
                    var pyrX = elementSpacing + chartModel.margin.left + (legendPosition === "left") ? (legendActualBounds.Width) : 0;
                    var pyrY = ((legendPosition === "top") ? (legendActualBounds.Height) : 0) + ((chartModel.title.text && chartModel.title.visible) ? (chartModel._titleLocation.Y + measureTitle.height + subtitleHeight) : (chartModel.margin.top + elementSpacing));
                    textWidth = textWidth + 10;
                    var Location = { X: point.xLocation + chartObj.pyrX, Y: point.yLocation + chartObj.pyrY };
                    positionX = point.xLocation;
                    positionY = point.yLocation;
                    var marker = point.marker ? point.marker : seriesMarker;
                    marker = $.extend(true, {}, seriesMarker, marker);
                    connectorDirection = point.connectorLine;
                    symbolPos = { positionX: positionX, positionY: positionY };
                }

                if (type != "pyramid" && type != "funnel") {
                    var chartStartingAngle = -.5 * Math.PI,
                        midAngle = point.midAngle + chartStartingAngle,
                        midPoint, doughnutMidPoint, connector, bounds,
                        startPoint,
                        measureTitle = (chartModel.title.text) ? measureText(chartModel.title.text, $(this.svgObject).width() - chartModel.margin.left - chartModel.margin.right, chartModel.title.font) : 0,
                        mesureSubTitle = (chartObj.model.title.subTitle.text) ? ej.EjSvgRender.utils._measureText(chartObj.model.title.subTitle.text, $(this.svgObject).width() - chartObj.model.margin.left - chartObj.model.margin.right, chartObj.model.title.subTitle.font) : 0,
                        subtitleHeight = (chartObj.model.title.subTitle.text === '') ? 0 : mesureSubTitle.height,
                        textOffset, startX, startY, midX, midY, dMidX, dMidY, connectorX, connectorY,
                        renderingPoints = [],
                        radius = chartModel.circularRadius[srIndex];
                    if (isNull(connectorLine.height))
                        textOffset = measureText(commonEventArgs.data.text, null, dataLabelFont).height;
                    else
                        textOffset = connectorLine.height;
                    var actualIndex = chartObj.model._isPieOfPie ? point.actualIndex : currentseries._visiblePoints[pointIndex].actualIndex;
                    if ((actualIndex == currentseries.explodeIndex || currentseries.explodeAll) && !chartObj.vmlRendering) {
                        startX = chartModel.circleCenterX[srIndex] + Math.cos(midAngle) * currentseries.explodeOffset;
                        startY = chartModel.circleCenterY[srIndex] + Math.sin(midAngle) * currentseries.explodeOffset;
                    }
                    else {
                        startX = chartModel.circleCenterX[srIndex];
                        startY = chartModel.circleCenterY[srIndex];
                    }
                    midX = seriesType.getXCordinate(startX, (radius), midAngle);
                    midX = point.y != 0 ? midX : parseFloat(midX.toFixed(12));
                    midY = seriesType.getYCordinate(startY, (radius), midAngle);

                    dMidX = seriesType.getXCordinate(startX, (chartModel.innerRadius[seriesIndex]), midAngle);
                    dMidY = seriesType.getYCordinate(startY, (chartModel.innerRadius[seriesIndex]), midAngle);

                    connectorX = this.getXCordinate(startX, (radius) + textOffset, midAngle);
					connectorX = point.y != 0 ? connectorX : connectorX.toFixed(12);
                    connectorY = this.getYCordinate(startY, (radius) + textOffset, midAngle);

                    if (dataLabel.template)
                        size = point.size;
                    else {
                        var marker = point.marker ? point.marker : seriesMarker,
                            marker = $.extend(true, {}, seriesMarker, marker);
                        shape = marker.dataLabel.shape;
                        size = measureText(commonEventArgs.data.text, $(chartObj.svgObject).width(), dataLabelFont);
                        if (shape.toLowerCase() != "none") {
                            size.height = size.height + margin.top + margin.bottom;
                            size.width = size.width + margin.left + margin.right;
                        }
                    }

                    midPoint = { midX: midX, midY: midY };
                    doughnutMidPoint = { dMidX: dMidX, dMidY: dMidY };
                    connector = { connectorX: connectorX, connectorY: connectorY };
                    bounds = { midPoint: midPoint, doughnutMidPoint: doughnutMidPoint, connector: connector };
                    startPoint = { startX: startX, startY: startY };
                   
                    if (!currentseries._enableSmartLabels) {
                        position = seriesType.updateLabelPosition(currentseries, point, pointIndex, bounds, midAngle, startPoint, textOffset, size, sender, seriesIndex);
                        positionX = position.positionX;
                        positionY = position.positionY;
                        connectorDirection = position.connectorDirection;
                    }
                        // smart labels

                    else {
                        position = seriesType.updateSmartLabelPosition(currentseries, point, pointIndex, bounds, midAngle, startPoint, textOffset, size, sender, seriesIndex);
                        positionX = position.positionX;
                        positionY = position.positionY;
                        symbolPos = { positionX: positionX, positionY: positionY, isInterSected: position.isInterSected };
                        connectorDirection = chartObj.model._isPieOfPie? "" : position.connectorDirection;
                    }
                }
                
                var textAnchor = ((_labelPosition != 'inside' && _labelPosition != 'insidenooverlap') || ((type == "pyramid" || type == "funnel") && _labelPosition == 'outside')) ? (positionX < chartModel.circleCenterX[srIndex] ? 'end' : 'start') : 'middle',
                    width = (_labelPosition == 'inside' || _labelPosition == 'insidenooverlap') ? 0 : (positionX < chartModel.circleCenterX[srIndex]) ? -textsize.width : textsize.width,
                    pyrX = 0, pyrY = 0, textOptions;

                if ((type == "pie" || type == "doughnut" || type == "pieofpie") && _labelPosition == "inside")
                    textAnchor = (connectorDirection != "") ? (positionX < chartModel.circleCenterX[srIndex] ? 'end' : 'start') : 'middle';
                if ((type == "pyramid" || type == "funnel") && _labelPosition == "outside")
                    textAnchor = 'start';

                var subtitleHeight = (chartObj.model.title.subTitle.text === '') ? 0 : mesureSubTitle.height;
                if ((this.chartObj && chartModel.enableCanvasRendering) && (type == "pyramid" || type == "funnel")) {
                    pyrX = ((legendPosition === "left") ? (legendActualBounds.Width) : 0) + elementSpacing + chartModel.margin.left;
                    pyrY = ((legendPosition === "top") ? (legendActualBounds.Height) : 0) + ((chartTitle.text) ? (chartModel._titleLocation.Y + measureTitle.height + subtitleHeight) : (chartModel.margin.top + elementSpacing));
                }
               
                pointIndex = chartObj.model._isPieOfPie? point.actualIndex: pointIndex;
                textOptions = this.textOption(currentseries, chartObj, textsize, pyrX, pyrY, pointIndex, textAnchor, positionX, positionY, seriesIndex, point);
                if (dataLabel.template) {
                    Location = isNull(Location) ? { X: positionX, Y: positionY } : Location;
                    var pointindex = point.actualIndex;
                    seriesType.drawLabelTemplate(currentseries, point, pointindex, Location, sender);
                    if (connectorType == "bezier" && (position.bezierPath) != "")
                        sender.svgRenderer.drawPolyline(position.bezierPath, sender.gConnectorEle[seriesIndex]);
                }
                else {
                    $.each(chartModel.symbolShape, function (name) {
                        marker = point.marker ? point.marker : seriesMarker;
                        marker = $.extend(true, {}, seriesMarker, marker);
                        shape = marker.dataLabel.shape;
                        if (shape.toLowerCase() == name.toLowerCase())
                            symbolName = name;
                    });

                    positionX = pyrX + positionX - (margin.left) / 2 + (margin.right) / 2 + width / 2;
                    positionY = pyrY + positionY - (margin.top) / 2 + (margin.bottom) / 2;
                    //SmartLabels value storing for pyramid and funnel
                    if (type == "pyramid" || type == "funnel") {
                        point.xPos = symbolPos.positionX + pyrX;
                        point.yPos = symbolPos.positionY + pyrY;
                        point.width = (symbolName == "None") ? textsize.width : textWidth;
                        point.height = (symbolName == "None") ? textsize.height : textHeight;
                        point.symbolName = (dataLabel.template) ? "none" : symbolName;
                        point.textOptionsacc = textOptions;
                        point.drawTextacc = commonEventArgs.data.text;
                    }
                    //For accurate placement of rotated data labels in canvas
                    if (chartModel.enableCanvasRendering && (textOptions.degree % 360 != 0)) {
                        textOptions.y -= (textsize.height / 4);
                        textOptions.baseline = 'middle';
                    } if (currentseries._enableSmartLabels) {
                        var axisWidth = chartModel.m_AreaBounds.Width + chartModel.m_AreaBounds.X + chartModel.margin.left,
                            labelPosition = _labelPosition,
                            enableCanvasRendering = chartModel.enableCanvasRendering,
                            datalabelText = (typeof commonEventArgs.data.text == "string") ? commonEventArgs.data.text : commonEventArgs.data.text.toString(),
                            datalabelLength = measureText(datalabelText, datalabelText.length, dataLabelFont).width,
                            legendBounds,
                            remainingWidth,
                            legendWidth = 0, legendHeight = 0;
                        if (legend.visible) {
                            if (legendPosition == "left" || legendPosition == "right")
                                legendBounds = legendActualBounds;
                        }
                        else
                            legendBounds = { Width: 0 };

                        if (type == "pie" || type == "doughnut" || type == "pieofpie") {

                            if (labelPosition == "outside" || labelPosition == "outsideextended" || connectorDirection != "") {
                                if (chartModel.circleCenterX[srIndex] < textOptions.x)
                                    remainingWidth = (axisWidth - textOptions.x);
                                else
                                    remainingWidth = legendPosition == "left" ? (textOptions.x - chartModel.margin.left - (chartModel.elementSpacing * 2) - legendBounds.Width) : (textOptions.x - chartModel.margin.left);
                                datalabelText = this.trimfunction(datalabelText, remainingWidth, datalabelLength, "...", axisWidth, dataLabelFont);

                                if (legend.visible && (legendPosition == 'top' || legendPosition == 'bottom')) {
                                    datalabelText = this._overlapLegend(textOptions, datalabelText, sender,seriesIndex);
                                }
                            }
                            if (labelPosition == "inside" && (connectorDirection == "")) {
                                datalabelText = this.labelTrim(chartObj, textOptions, datalabelLength, datalabelText, startX, startY, point, dataLabelFont, seriesIndex,pieSeriesIndex);
                               
                                if (datalabelText == "" && !chartObj.model._isPieOfPie) {
                                    point.smartLabelPosition = "outside";
                                    position = seriesType.updateSmartLabelPosition(currentseries, point, pointIndex, bounds, midAngle, startPoint, textOffset, size, sender, seriesIndex);
                                    symbolPos = { positionX: position.positionX, positionY: position.positionY, isInterSected: position.isInterSected };
                                    datalabelText = commonEventArgs.data.text;
                                    connectorDirection = position.connectorDirection;
                                    textAnchor = (chartModel.circleCenterX[srIndex] < position.positionX) ? "start" : "end";
                                    textOptions = this.textOption(currentseries, chartObj, textsize, pyrX, pyrY, pointIndex, textAnchor, position.positionX, position.positionY, seriesIndex, point);
                                    if (chartModel.circleCenterX[srIndex] < position.positionX)
                                        remainingWidth = legendPosition == "right" ? (axisWidth - textOptions.x  - legendBounds) : (axisWidth - textOptions.x );
                                    else
                                        remainingWidth = legendPosition == "left" ? (textOptions.x  - legendBounds) : (textOptions.x );
                                    datalabelText = this.trimfunction(datalabelText, remainingWidth, datalabelLength, "...", axisWidth, dataLabelFont);
                                    delete point.smartLabelPosition;
                                }
                            }
                        }
                        else if ((type == "pyramid" || type == "funnel")) {
                            position = seriesType.updateSmartLabel(sender, currentseries, pointIndex, point);
                            positionX = position.xPos;
                            positionY = position.yPos;
                            connectorDirection = position.connectorDirection;
                            textOptions = position.textOptionsacc;
                            datalabelText = point.drawTextacc;

                            if ((connectorDirection != "" || connectorType == "bezier") && datalabelText != "") {
                                datalabelText = datalabelText.toString();
                                if (legendPosition == "right")
                                    remainingWidth = (enableCanvasRendering) ? (axisWidth - textOptions.x) : (axisWidth - textOptions.x - chartObj.pyrX);
                                else if (legendPosition == "left")
                                    remainingWidth = enableCanvasRendering ? (axisWidth - textOptions.x) : (axisWidth - textOptions.x - chartObj.pyrX);
                                else if (legendPosition == "top")
                                    remainingWidth = (enableCanvasRendering) ? (axisWidth - textOptions.x) : axisWidth - textOptions.x - chartObj.pyrX;
                                else
                                    remainingWidth = (enableCanvasRendering) ? (axisWidth - textOptions.x) : axisWidth - textOptions.x - chartObj.pyrX;
                                if (remainingWidth < datalabelLength)
                                    datalabelText = this.trimfunction(datalabelText, remainingWidth, datalabelLength, "...", axisWidth, dataLabelFont);
                            }
                        }

                        var datalabelShape = measureText(datalabelText, null, dataLabelFont);
                        if (type == "pie" || type == "doughnut" || type == "pieofpie")
                            var width = ((_labelPosition == 'inside' || _labelPosition == 'insidenooverlap') && !symbolPos.isInterSected && connectorDirection == "") ? 0 : (positionX < chartModel.circleCenterX[srIndex]) ? -datalabelShape.width : datalabelShape.width;
                        else if (type == "pyramid" || type == "funnel")
                            var width = (point._labelPlacement == "insidenooverlap") ? 0 : datalabelShape.width;
                        if (type == "pie" || type == "doughnut" || type == "pieofpie") {
                            positionX = pyrX + symbolPos.positionX - (margin.left) / 2 + (margin.right) / 2 + (width / 2);
                            positionY = pyrY + symbolPos.positionY - (margin.top) / 2 + (margin.bottom) / 2;
                        }
                        else {
                            positionX = positionX - (margin.left) / 2 + (margin.right) / 2 + (width / 2);
                            positionY = positionY - (margin.top) / 2 + (margin.bottom) / 2;
                        }
                        
                        var dataLabelEle = $('#' + chartObj.svgObject.id + '_dataLabel_series' + seriesIndex + "_point_" + pointIndex);
						var conEle = $('#' + chartObj.svgObject.id + "_connectorLine_series"+ seriesIndex+"_point_" + pointIndex);
						if(datalabelText!= ""){
						dataLabelEle.show();
						conEle.show();
						if (!enableWrap) {
						    seriesType.dataLabelSymbol(seriesIndex, currentseries, pointIndex, positionX, positionY, textWidth, textHeight, symbolName, chartObj);
						}
							if (connectorType == "bezier" && (position.bezierPath) != "" && !(ej.util.isNullOrUndefined(position.bezierPath)))
									sender.svgRenderer.drawPolyline(position.bezierPath, sender.gConnectorEle[seriesIndex]);
						}
						else{
							dataLabelEle.hide();
							conEle.hide();
							connectorDirection = "";
						}
						if (!enableWrap)
						    chartObj.svgRenderer.drawText(textOptions, datalabelText, chartObj.gSeriesTextEle[seriesIndex]);
                        var datalabelSize = measureText(datalabelText, datalabelText.length, dataLabelFont);
                        var untrimmedSize = measureText(commonEventArgs.data.text, null, dataLabelFont);
                        var bounds;
                        var minX, minY, maxX, maxY;
                        if (type == "pie" || type == "doughnut" || type=="pieofpie") {
                            if (labelPosition == "inside" && position.connectorDirection == "") {
                                minX = textOptions.x - datalabelShape.width / 2;
                                maxX = textOptions.x + datalabelShape.width / 2;
                                minY = textOptions.y - datalabelShape.height / 2;
                                maxY = textOptions.y + datalabelShape.height / 2;
                            }
                            else {
                                if (chartModel.circleCenterX[srIndex] < textOptions.x) {
                                    minX = textOptions.x;
                                    maxX = textOptions.x + datalabelShape.width;
                                }
                                else {
                                    minX = textOptions.x - datalabelShape.width;
                                    maxX = textOptions.x;
                                }
                                minY = textOptions.y - datalabelShape.height / 2;
                                maxY = textOptions.y + datalabelShape.height / 3;
                            }
                            bounds = { centerX: chartModel.circleCenterX[srIndex], minX: minX, minY: minY, maxX: maxX, maxY: maxY, width: datalabelSize.width, height: datalabelSize.height, labelPosition: labelPosition };
                        }

                        if ((type == "funnel" || type == "pyramid")) {
                            legendWidth = legendPosition == "left" ? legendWidth : 0;
                            var legendHeight = 0;
                            if (connectorDirection != "" || connectorType == "bezier") {
                                minX = textOptions.x - legendWidth;
                                maxX = textOptions.x + datalabelShape.width - legendWidth;
                                minY = textOptions.y - datalabelShape.height;
                                maxY = textOptions.y;
                            }
                            if (!enableCanvasRendering)
                                bounds = { minX: minX + chartObj.pyrX + legendWidth, maxX: maxX + chartObj.pyrX + legendWidth, minY: minY + chartObj.pyrY + legendHeight, maxY: maxY + chartObj.pyrY + legendHeight, width: datalabelSize.width, height: datalabelSize.height, labelPosition: labelPosition };
                            else
                                bounds = { minX: minX + legendWidth, maxX: maxX + legendWidth, minY: minY + legendHeight, maxY: maxY + legendHeight, width: datalabelSize.width, height: datalabelSize.height, labelPosition: labelPosition };
                        }
                        accDataLabelRegion = { bounds: bounds, trimmedText: datalabelText, text: commonEventArgs.data.text, type: type, font: dataLabelFont };
                        chartObj.accDataLabelRegion.type = type;
                        chartObj.accDataLabelRegion.connectorDirection = connectorDirection;
                        if (ej.util.isNullOrUndefined(chartObj.accDataLabelRegion[srIndex])) {
                            chartObj.accDataLabelRegion[srIndex] = [];
                        }
                       
                        if (chartObj.accDataLabelRegion[srIndex].length < currentseries._visiblePoints.length)
                            chartObj.accDataLabelRegion[srIndex].push(accDataLabelRegion);
                        if (((!isNull(pointIndex) && currentseries.explode) && (!enableCanvasRendering)))
                            chartObj.accDataLabelRegion[srIndex].splice(pointIndex, 1, accDataLabelRegion);
                        if (pieSeriesIndex == 1 && chartObj.accDataLabelRegion[srIndex].length == currentseries._visiblePoints.length) {
                            chartObj.accDataLabelRegion[seriesIndex] = $.merge($.merge([], chartObj.accDataLabelRegion[0]), chartObj.accDataLabelRegion[1]);
                        }
                    }
                   
                    else if(!enableWrap) {
                        seriesType.dataLabelSymbol(seriesIndex, currentseries, pointIndex, positionX, positionY, textWidth, textHeight, symbolName, chartObj);
                        chartObj.svgRenderer.drawText(textOptions, commonEventArgs.data.text, chartObj.gSeriesTextEle[seriesIndex]);
                    }
                   
                    if (enableWrap) {
                        var labelTextSize = measureText(labelText, null, labelfont), maxWidth, collection, padding = 5;
                        collection = this.updateWrappedText(textOptions, labelText, labelTextSize, point, type, startX, startY, radius, chartModel.innerRadius[seriesIndex], _labelPosition, dataLabel, (connectorType == "bezier") ? (currentseries._enableSmartLabels ? (!isNull(position.bezierPath)? position.bezierPath.points:"") : position.points) : connectorDirection);
                        datalabelText = collection.text;
                        textOptions.x = parseFloat(collection.x); textOptions.y = parseFloat(collection.y);
                        if (datalabelText != "") {
                            var x = (textOptions['text-anchor'] == 'start') ? parseFloat(textOptions.x + collection.width / 2) : (isNull(connectorDirection) || connectorDirection == "") ? parseFloat(textOptions.x) : parseFloat(textOptions.x - collection.width / 2);
                            seriesType.dataLabelSymbol(seriesIndex, currentseries, pointIndex, x, textOptions.y + collection.height / 2 - labelTextSize.height / 2 - padding, collection.width, collection.height, symbolName, chartObj);
                        }
                        if (!isNull(connectorDirection) && connectorDirection != "") {
                            var pyrX, pyrY;
                            if (type == "funnel" || type == "pyramid") {
                                pyrX = ((chartModel.enableCanvasRendering) ? this.chartObj.pyrX : 0);
                                pyrY = ((chartModel.enableCanvasRendering) ? this.chartObj.pyrY : 0);
                            }
                            var connectorSegments = connectorDirection.split(" "), connectorLength = (_labelPosition == "outsideextended" && (type == "pie" || type == "doughnut")) ? connectorSegments.length - 2 : connectorSegments.length;
                            connectorSegments[connectorLength - 1] = textOptions.y - pyrY + (collection.height / 2 - labelTextSize.height);//canvas connector line issue fix
                            connectorSegments[connectorLength - 2] = textOptions.x - pyrX;//canvas connector line issue fix
                            connectorDirection = connectorSegments.toString().replace(/,/g, " ");
                        }
                        connectorDirection = (collection.exceed == false) ? "" : connectorDirection;

                        if ((chartModel.enableCanvasRendering || this.chartObj.vmlRendering) && (typeof datalabelText == "object")) {
                            for (var txt = 0, tempY = textOptions.y, tempX = textOptions.x; txt < datalabelText.length; txt++) {
                                textOptions.y = parseFloat(tempY) + ((txt) * textsize.height);
                                textOptions.x = tempX;
                                chartObj.svgRenderer.drawText(textOptions, datalabelText[txt], chartObj.gSeriesTextEle[seriesIndex]);
                            }
                        }
                        else {
                            chartObj.svgRenderer.drawText(textOptions, datalabelText, chartObj.gSeriesTextEle[seriesIndex]);
                        }
                    }
                }
                if ((type == "pyramid" || type == "funnel") && dataLabel.template && currentseries._enableSmartLabels) {
                    position = seriesType.updateSmartLabel(sender, currentseries, pointIndex, point);
                    positionX = position.xPos;
                    positionY = position.yPos;
                    connectorDirection = position.connectorDirection;

                }
                pointColor = jQuery.type(chartModel.pointColors[point.actualIndex]) == "array" ? chartModel.pointColors[point.actualIndex][0].color : chartModel.pointColors[point.actualIndex];
                // To set the point color when set the color in empty point
                pointColor = point.fill ? jQuery.type(point.fill) == "array" ? point.fill[0].color : point.fill : pointColor;

                var translate = [];
                translate[0] = pyrX;
                translate[1] = pyrY;
                if ((connectorType != 'bezier' || chartObj.vmlRendering || (type == "pyramid" || type == "funnel")) && (connectorDirection != '')) {
                    if (connectorDirection) {
                        var connectorOptions = {
                            'id': chartObj.svgObject.id + "_connectorLine_series"+seriesIndex+"_point_" + pointIndex,
                            'stroke': (connectorLine.color) ? connectorLine.color : pointColor,
                            'stroke-width': connectorLine.width,
                            'd': connectorDirection
                        };
                        chartObj.svgRenderer.drawPath(connectorOptions, chartObj.gConnectorEle[seriesIndex], translate);
                    }
                }
            }
        },

	_overlapLegend: function (textOptions, datalabelText, chart,seriesIndex) {

	    var svgHeight = chart.svgHeight,
            svgWidth = chart.svgWidth,
	        legendBounds = chart.model.LegendActualBounds,
	        elementSpacing = chart.model.elementSpacing,
            margin = chart.model.series[seriesIndex].marker.dataLabel.margin,
            shape = chart.model.series[seriesIndex].marker.dataLabel.shape,
            top = shape != 'none' ? margin.top : 0,
            bottom = shape != 'none' ? margin.bottom : 0,
	        textHeight = ej.EjSvgRender.utils._measureText((datalabelText, null, textOptions)).height,
	        dataLabelEndPos = textOptions.y + textHeight + bottom,
	        dataLabelTopPos = textOptions.y - top,
	        legendPosition = chart.model.legend.position.toLowerCase(),
            title = chart.model.title,
            subTitle = title.subTitle,
            margin = chart.model.margin,
            borderSize = chart.model.border.width,
            modelsubTitleHeight = subTitle.text == "" ? 0 : ej.EjSvgRender.utils._measureText(subTitle.text, svgWidth - margin.left - margin.right, subTitle.font).height + elementSpacing,
            titleLocation = chart.model._titleLocation ? chart.model._titleLocation.Y : 0 + modelsubTitleHeight,
	        text = datalabelText, legendPosY;
	        
        
	    if (legendPosition == 'bottom') {
	        legendPosY = svgHeight - chart.model.LegendActualBounds.Height - elementSpacing;
            text = dataLabelEndPos > legendPosY ? '' : text;
	    } else {
	        legendPosY = titleLocation == 0 ? borderSize + elementSpacing : titleLocation + elementSpacing;
            text = dataLabelTopPos < (legendPosY + legendBounds.Height) ? '' : text;
        }
	    if (dataLabelEndPos > svgHeight)
	        text = '';
	    return text;

	},

	updateWrappedText: function (textOptions, labelText, textSize, currentPoint, seriesType, centerX, centerY, radius, innerRadius, labelPlacement, dataLabel,connector) {
	    var chartObj = this.chartObj,
            point = currentPoint,
            previousBoundary = {},
            textWidth = textSize.width,
            textHeight = textSize.height,
            wrapTrim,
            text, arrayText,
            textPosX = textOptions.x,
            textPosY = textOptions.y,
            segmentHeight,
            segmentWidth,
            midX = textPosX,
            exceed = true,
            areaSpace = chartObj.model.m_AreaBounds.X,
	        midY = textPosY,
            connectorPoints,
            txtLength,
            textX, textY;
	    if (!ej.util.isNullOrUndefined(connector) && connector != "") {
	        if (typeof connector == "object") {
	            textX = connector.X;
	            textY = connector.Y;
	        }
	        else {
	            connectorPoints = connector.split(" "),
                txtLength = (labelPlacement == "outsideextended") ? (connectorPoints.length - 2) : (dataLabel.connectorLine.type.toLowerCase() == "bezier") ? connectorPoints.length-2 : connectorPoints.length;
	            if (connectorPoints[txtLength - 1].indexOf(",") > -1) {
	                var tempXY = connectorPoints[txtLength].split(",");
	                textX = tempXY[0];
	                textY = tempXY[1];
	            }
	            else {
	                textX = connectorPoints[txtLength - 2];
	                textY = connectorPoints[txtLength - 1];
	            }
	        }
	    }
	    if (seriesType == 'pie' || seriesType == 'doughnut') {
	        if (labelPlacement == "inside") {
	            var innerRadius = (ej.util.isNullOrUndefined(innerRadius)) ? 0 : innerRadius,
                    chartStartingAngle = -.5 * Math.PI,
                    startAngle = point.startAngle + chartStartingAngle,
                    endAngle = point.endAngle + chartStartingAngle,
                    midAngleRadian = point.midAngle + chartStartingAngle,
                    midAngle = ((180 / Math.PI) * midAngleRadian) % 360,
                    startANG = ((180 / Math.PI) * startAngle) % 360,
                    endANG = ((180 / Math.PI) * endAngle) % 360,
                    radiusTextPosPercentage = (seriesType == "doughnut") ? 0.75 : 0.5;
	            midX = this.getXCordinate(centerX, (radius * radiusTextPosPercentage), midAngleRadian),
                midY = this.getYCordinate(centerY, (radius * radiusTextPosPercentage), midAngleRadian),
                startPointX = this.getXCordinate(centerX, (radius), startAngle),
                startPointY = this.getYCordinate(centerY, (radius), startAngle),
                endPointX = this.getXCordinate(centerX, (radius), endAngle),
                endPointY = this.getYCordinate(centerY, (radius), endAngle),
                midPointX = this.getXCordinate(centerX, (radius), midAngleRadian),
                midPointY = this.getYCordinate(centerY, (radius), midAngleRadian),
                innerCenterX = this.getXCordinate(centerX, innerRadius, midAngleRadian),
                innerCenterY = this.getYCordinate(centerY, innerRadius, midAngleRadian),
	            segmentBounds = this.getSegementMinMax([startPointX, endPointX, (seriesType == "doughnut") ? innerCenterX : centerX, midPointX], [startPointY, endPointY, (seriesType == "doughnut") ? innerCenterY : centerY, midPointY]);
	            segmentBounds.width = (segmentBounds.height > radius) ? segmentBounds.height : segmentBounds.width;
	            segmentWidth = segmentBounds.width * 0.75;
	        }
	        else if (((labelPlacement == "outside" || labelPlacement == "outsideextended") && (seriesType == 'pie' || seriesType == 'doughnut')) && connector != "") {
	            var areabounds = chartObj.model.m_AreaBounds,
                    areaStartX = areaSpace,
	                areaEndX = chartObj.svgWidth - areaSpace;	            
	            segmentWidth = (textX <= centerX) ? (textX - areaStartX) : (areaEndX - textX);
	            midX = textX;
                midY = textY;
	        }
	    }
	    else {
	        var svgWidth = chartObj.svgWidth;
	        if (labelPlacement == "outside") {
	            segmentWidth = svgWidth - (textX);
	        }
	        else {
	            segmentWidth = point.width;
	            var insidenooverap=chartObj.isPointInPolygon(point.Polygon,{x:midX+textWidth,y:midY});
	            if (!insidenooverap) {
	                segmentWidth = ((seriesType == "funnel") ? (point.Polygon[3].x - point.Polygon[4].x) : (point.Polygon[1].x - point.Polygon[0].x));
	                segmentHeight = point.Polygon[3].y - point.Polygon[0].y;
	                var changedHeight = Math.round(textWidth / segmentWidth) * textHeight, padding = 5,
                    exceed = ((changedHeight >= (segmentHeight - (2 * padding))) || (segmentWidth <= 50)) ? true : false;
	                if (!exceed) {
	                    textOptions["text-anchor"]="middle";
	                    midX = ((seriesType == "funnel") ? point.Polygon[4].x : point.Polygon[0].x)+(segmentWidth/2) + ((chartObj.model.enableCanvasRendering) ? chartObj.pyrX : 0);
	                    midY = ((point.Polygon[0].y + point.Polygon[3].y) / 2) - (changedHeight / 2) + ((chartObj.model.enableCanvasRendering) ? chartObj.pyrY : 0);
	                    point._labelPlacement = "insidenooverlap";
	                }
	                else {
	                    segmentWidth = svgWidth - midX - areaSpace;
	                }
	            }
	        }	        
	    }
	    if (labelPlacement == "inside" || (connector != ""|| !ej.util.isNullOrUndefined(connector))) {
	        maxWidth = (dataLabel.maximumLabelWidth != null) ?  dataLabel.maximumLabelWidth : parseFloat(segmentWidth);
	        text = labelText;
	        wrapText = chartObj._rowsCalculation({ text: text.toString(), font: dataLabel.font }, maxWidth, wrapTrim);
	        text = wrapText.textCollection;
	        arrayText = $.extend([], text);
	        for (var i = 0, temp; i < arrayText.length - 1; i++) {
	            arrayText[i + 1] = arrayText[i].concat("<br/>", arrayText[i + 1]);
	        }
	        arrayText = arrayText[arrayText.length - 1];
	    }
	    else {
	        text = "";
	    }
	    var changedText = ej.EjSvgRender.utils._measureText(arrayText, segmentWidth, dataLabel.font);
	    changedText.height += (textHeight / 2);// size differing canvas and svg space between new line text more 
	    if ((seriesType == "pie" || seriesType == "doughnut") && (labelPlacement == "inside")) {
	        midY = midY - (changedText.height / 2) + (textHeight / 2);
	        text = (changedText.height > (segmentBounds.height)) ? "" : text;
	        text = (changedText.width > (segmentBounds.width)) ? "" : text;
	        if (text == "") {
	            changedText.width = 0; changedText.height = 0;
	        }
	    }
	        previousBoundary = (this.currentBoundary == 'undefined') ? "undefined" : this.currentBoundary;
	        this.currentBoundary = ({ X: midX - (changedText.width / 2), Y: parseFloat(midY), Height: changedText.height, Width: changedText.width });
	        if (!!previousBoundary && (point._labelPlacement != "insidenooverlap")) {
	            var overlap = this.checkOverlapping(chartObj,this.currentBoundary, previousBoundary, seriesType, text, firstSegment, midAngle, labelPlacement, {startAngle:startAngle,endAngle:endAngle,radius:radius,centerX:centerX,centerY:centerY});
	            
	            if (overlap[1] && (overlap[2] != "")) {
	                previousBoundary = overlap[0];
	                midX = previousBoundary.X + (previousBoundary.Width / 2);
	                midY = previousBoundary.Y;
	                text = overlap[2];
	                changedText.height = overlap[0].Height;
	                changedText.width = overlap[0].Width;
	            }
	            else {
	                text = overlap[2];
	            }
	        }
	        else{
	            firstSegment = this.currentBoundary;
                
	        }
	        exceed = (text == "") ? false : exceed;
	        this.currentBoundary = (text == "") ? previousBoundary : this.currentBoundary;
	        return { text: text, x: midX, y: midY, exceed: exceed, height: changedText.height, width: changedText.width };
	},
	checkOverlapping: function (chartObj,current, previous, seriesType,text,firstSegment,midAngle,labelPlacement,segmentBounds) {
	    var gap = 10, overlap = false, textOverlap,xOverlap,yOverlap;
	    textOverlap = this.getOverlapArea(current,previous);
	    overlap = textOverlap.overlap;
	    xOverlap = textOverlap.xOverlap;
	    yOverlap = textOverlap.yOverlap;
	        if (overlap) {
	            if (seriesType == "pie" || seriesType == "doughnut") {
	                if (labelPlacement.toLowerCase() == "inside") {
	                    var minDiff = (xOverlap >= yOverlap) ? "Y" : "X",
                            flag;
	                    if (minDiff == "X") {
	                        flag = (midAngle > 0 && midAngle < 180) ? -1 : 1;
	                        current.X += flag * (xOverlap + gap);
	                    }
	                    else {
	                        flag = (midAngle > 90 && midAngle < 270) ? -1 : 1
	                        current.Y += (flag) * (yOverlap + gap);
	                    }
	                        
	                }
	                else {
	                    current.Y -= (yOverlap + gap);
	                }
	            }
	            else if(seriesType=="funnel") {
	                    current.Y = (previous.Y - current.Height - gap);
	            }
	            else {
	                    current.Y = (previous.Y + previous.Height + gap);
	            }
	        }
	        if ((seriesType == "pie" || seriesType == "doughnut" || seriesType == "pieofpie") && labelPlacement.toLowerCase() == "inside") {
	            textOverlap = this.getOverlapArea(current, firstSegment);
	            text = (textOverlap.overlap == true) ? "" : text;
	            overlap = (textOverlap.overlap == true) ? true : overlap;
	            var labelexceeding = this.checkSegmentExceeding(current, segmentBounds);
	            text = (!labelexceeding) ? "" : text;
	        }
	        else if(seriesType=="funnel"){
	            if ((current.Y + current.Height) >= previous.Y) {
	                text = "";
	            }
	        }
	        else if(seriesType=="pyramid"){
	            if ((current.Y + current.Height) <= (previous.Y+previous.Height)) {
	                text = "";
	            }
	        }
	        var areaBounds = chartObj.model.m_AreaBounds;
	    return [{ X: current.X, Y: current.Y, Height: current.Height, Width: current.Width }, overlap,text];
	},
	getOverlapArea: function (firstTextSegment, lastTextSegment) {
	    var xOverlap = Math.max(0, Math.min((firstTextSegment.X + firstTextSegment.Width), (lastTextSegment.X + lastTextSegment.Width)) - Math.max(firstTextSegment.X,lastTextSegment.X)),
            yOverlap = Math.max(0, Math.min((firstTextSegment.Y + firstTextSegment.Height), (lastTextSegment.Y + lastTextSegment.Height)) - Math.max(firstTextSegment.Y,lastTextSegment.Y)),
            overlapArea = xOverlap * yOverlap;
	    overlap = (overlapArea > 0) ? true : false;
	    return { overlap: overlap, xOverlap: xOverlap, yOverlap: yOverlap };
	},
	getSegementMinMax:function(xArray,yArray){
	    var minX, maxX, minY, maxY, width, height;
	    xArray.sort(function (a, b) { return a - b; });
	    yArray.sort(function (a, b) { return a - b; });
	    minX = xArray[0]; maxX = xArray[3]; minY = yArray[0]; maxY = yArray[3];
	    width = maxX - minX;
	    height = maxY - minY;
	    return { minX: minX, maxX: maxX, minY: minY, maxY: maxY, width: width, height: height };
	},
	checkSegmentExceeding:function(textBounds,limits){
	    var inside=false,midPointX = textBounds.X + (textBounds.Width / 2), midPointY = textBounds.Y + (textBounds.Height / 2);
	    var dx = midPointX - limits.centerX, dy = midPointY - limits.centerY, angle = Math.atan2(dy, dx), pointRadius = Math.abs(Math.sqrt(dx * dx + dy * dy));
	    if (pointRadius <= limits.radius) {
	        var PI = 2 * Math.PI;
	        angle = (angle < 0) ? (PI + angle) : angle;
	        limits.startAngle = (limits.startAngle < 0) ? (PI + limits.startAngle) : limits.startAngle;
	        limits.endAngle = (limits.endAngle < 0) ? (PI + limits.endAngle) : limits.endAngle;
	        if (angle <= limits.endAngle && angle >= limits.startAngle) {
	            inside = true;
	        }
	        else if ((angle <= PI && angle >= limits.startAngle && limits.endAngle < limits.startAngle) || (angle > 0 && angle <= limits.endAngle && limits.startAngle > limits.endAngle)) {
	            inside = true;
	        }
	    }
	    return inside;
	},
    drawBezierSegment: function (controlpoints, currentseries, pointIndex, sender, seriesIndex) {
	    //currentseries.points[pointIndex].marker = currentseries.points[pointIndex].marker ? currentseries.points[pointIndex].marker : {};
	    //var marker = $.extend(true, {}, currentseries.marker, currentseries.points[pointIndex].marker);
	    var polyLine = ej.EjSvgRender.utils._getStringBuilder();
	    var seriesType = new ej.seriesTypes[currentseries.type.toLowerCase()]();
	    for (var i = 0; i <= 16; i++) {
	        var t = i / 16;
	        var points = seriesType.GetBezierPoint(t, controlpoints, 0, controlpoints.length, currentseries);
	        polyLine.append(points.X + "," + points.Y + " ");
	    }
	    var connectorOptions = {
	        'id': sender.svgObject.id + "_bezierLine_series"+ seriesIndex + "_point" + pointIndex,
	        'stroke': (currentseries.marker.dataLabel.connectorLine.color) ? currentseries.marker.dataLabel.connectorLine.color : sender.model.pointColors[pointIndex],
	        'stroke-width': currentseries.marker.dataLabel.connectorLine.width,
            'fill':'none',
	        'points': polyLine.toString()
	    };
		if (!currentseries._enableSmartLabels)
	       sender.svgRenderer.drawPolyline(connectorOptions, sender.gConnectorEle);
		else
	       return connectorOptions;
	},
	GetBezierPoint:function(t, controlPoints, index, count, currentseries)
	{
	    var seriesType = new ej.seriesTypes[currentseries.type.toLowerCase()]();
	    if (count == 1)
	        return controlPoints[index];
	    var p0 = seriesType.GetBezierPoint(t, controlPoints, index, count - 1, currentseries);
	    var p1 = seriesType.GetBezierPoint(t, controlPoints, index + 1, count - 1, currentseries);
	    var x = (p0.X) ? p0.X : p0.x;
	    var y = (p0.Y) ? p0.Y : p0.y;
	    var x1 = (p1.X) ? p1.X : p1.x;
	    var y1 = (p1.Y) ? p1.Y : p1.y;
	    var X = (1 - t) * x+ t * x1;
	    var Y = (1 - t) * y + t * y1;
	    if (p0.x)
	        return { x: X, y: Y }
	    else
	        return { X: X, Y: Y };;
	    


       // return new Point((1 - t) * p0.X + t * p1.X, (1 - t) * p0.Y + t * p1.Y);
    },
	
    drawLabelTemplate: function (series, point, pointIndex, location, sender) {
        // method for data label template
        if(sender)
            this.chartObj = sender;
        var areaBoundsX = this.chartObj.model.m_AreaBounds.X;
        var areaBoundsY = this.chartObj.model.m_AreaBounds.Y;
        var areaBoundsWidth = this.chartObj.model.m_AreaBounds.Width;
        var areaBoundsHeight = this.chartObj.model.m_AreaBounds.Height;
	    var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
        var areaType = this.chartObj.model.AreaType;
        var currentSeries = this.chartObj.model.series[seriesIndex];
		var xPosition = 0, yPosition = 0;
        var chartContainer = this.chartObj._id;
        var marker = $.extend(true, {}, series.marker, point.marker);
        var style = { 'interior': marker.dataLabel.fill, 'opacity': marker.dataLabel.opacity, 'borderColor': marker.dataLabel.border.color, 'borderWidth': marker.dataLabel.border.width };
        var color, width, height;
		var type = this.chartObj.model.chartRegions[pointIndex] ? this.chartObj.model.chartRegions[pointIndex].type : "";
		if (areaType != "none" || this.chartObj.model.enable3D) {

            if ($('#template_group_' + chartContainer).length != 0)
                var templateContainer = $('#template_group_' + chartContainer);
            else
                templateContainer = $("<div></div>").attr('id', "template_group_" + chartContainer);

            templateContainer.css('position', 'relative').css('z-index', 1000);
			if ($("#" + marker.dataLabel.template).length == 0) // To check the specified div is in DOM
                return;
            else
            var cloneNode = $("#" + marker.dataLabel.template).clone();
            $(cloneNode).attr("id", marker.dataLabel.template + '_' + seriesIndex + '_' + pointIndex + '_' + chartContainer);
            var $cloneNode = $(cloneNode);
            $cloneNode.css("position", "absolute");

            var pointX = point.x; 
            point.dataLabeltemplate = true;	
            point.id = marker.dataLabel.template + '_' + seriesIndex + '_' + pointIndex + '_' + chartContainer;			
            if (series.xAxis._valueType.toLowerCase() == "datetime")
                point.x = (ej.format(new Date(point.xValue), ((ej.util.isNullOrUndefined(series.xAxis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(series.xAxis._intervalType) : series.xAxis.labelFormat), this.chartObj.model.locale));
            if (series.xAxis._valueType.toLowerCase() == "category")
                point.x = ej.EjSvgRender.utils._getLabelContent(pointIndex, series.xAxis, this.chartObj.model.locale);

            point.count = 1;
            var data = { series: series, point: point };
            $cloneNode.html($cloneNode.html().parseTemplate(data));

            point.x = pointX;
            var display = (areaType == "cartesianaxes" || !series.enableAnimation || (series.type.toLowerCase() == "pyramid" || series.type.toLowerCase() == "funnel")) ? "block" : "none";
            $cloneNode.css("display", display).appendTo($(templateContainer));
			//template_group_container Div appended in chartcontainer_container Div 
            $(templateContainer).appendTo('#' + 'chartContainer_' + chartContainer);
            var areaBound = this.chartObj.model.m_AreaBounds;
            if (areaType == "cartesianaxes" && !this.chartObj.model.enable3D) {
                xPosition = areaBound.X + (this.chartObj.model.requireInvertedAxes ? currentSeries.yAxis.plotOffset : currentSeries.xAxis.plotOffset);
                yPosition = currentSeries.yAxis.y;
            }
            width = $cloneNode.width() / 2;
            height = $cloneNode.height();
            if (ej.util.isNullOrUndefined(style) && style.interior)
                color = style.interior;
            else
                color = (areaType == "none") ? this.chartObj.model.pointColors[pointIndex] : this.chartObj.model.seriesColors[seriesIndex];
        }
        else {
            if (ej.util.isNullOrUndefined(style) && style.interior)
                color = style.interior;
            else
                color = this.chartObj.model.pointColors[pointIndex];
             width = this.chartObj.model.circleCenterX[seriesIndex]> location.X ? point.size.width : 0;
            $cloneNode = $('#template_group_' + chartContainer).find("#" + marker.dataLabel.template + '_' + seriesIndex + '_' + pointIndex + '_' + chartContainer);
            point.id = marker.dataLabel.template + '_' + seriesIndex + '_' + pointIndex + '_' + chartContainer;
            height = (!this.chartObj.model.enable3D) ? point.size.height / 2 : 0;
        }
        
        if (currentSeries.type == 'hilo' || currentSeries.type == 'hiloopenclose' || currentSeries.type == 'candle')
            color = currentSeries._visiblePoints[pointIndex]._hiloFill;
            color = jQuery.type(color) == "array" ? color[0].color : color;
			
           
        if (currentSeries.type.indexOf("bar") != -1) {
            var left = location.X + xPosition - width;
            var top = location.Y + ((!this.chartObj.model.enable3D) ? areaBound.Y : 0) - height + currentSeries.xAxis.plotOffset;
            var right = location.X + xPosition + width;
        } else {
        var left =location.X + xPosition - width;
        var top = yPosition + location.Y - height;
        var right = location.X + xPosition + width;
       }
       var backgroundColor = $cloneNode[0].style.backgroundColor;
       $cloneNode.css("left", left).css("top", top).css("background-color", (backgroundColor != '' ? backgroundColor : color)).css("display", "block").css("cursor", "default");
	    
		if(this.chartObj.model.AreaType !="cartesianaxes"){
          point.xPos = left - this.chartObj.pyrX;
          point.yPos = top - this.chartObj.pyrY;
		  point.textOptionsacc = { x: left - this.chartObj.pyrX, y: top - this.chartObj.pyrY };
		}
		else{
		    if (point.y == point.low) {
		        point.xPosLow = left;
		        point.yPosLow = top;
		        point.textOptionsLow = { x: left, y: top };
		        point.dataLabelLow = { textX: left, textY: top, x: left, y: top };
		    }
		    else {
		        point.xPos = left;
		        point.yPos = top;
		        point.seriesIndex = seriesIndex;
		        point.textOptions = { x: left, y: top };
		        point.dataLabel = { textX: left, textY: top, x: left, y: top };
		        point.margin = { top: 0, bottom: 0, left: 0, right: 0 };
		    }
		}
        point.height = $cloneNode.outerHeight();
        point.width = $cloneNode.outerWidth();
        var topHeight = leftWidth = rightWidth = 0;
        var bottomHeight = 0;
        if (areaType == "cartesianaxes") {
            if ((left > xPosition + areaBound.Width || top + height > areaBound.Y + areaBound.Height) || ((left < xPosition || top < yPosition || left > xPosition + areaBound.Width || top > yPosition + areaBound.Height || right > areaBound.Width + areaBound.X)))
            {
                width = $cloneNode.outerWidth();
                if (left < areaBoundsX) {                                                  
                    leftWidth = areaBoundsX - left;
                }
                if (areaBoundsHeight + areaBoundsY < top + height) {                      
                    var excessHeight = (top + height) - (areaBoundsHeight + areaBoundsY);
                    bottomHeight = height - excessHeight;
                }
                if (top < areaBoundsY) {                                                 
                    topHeight = areaBoundsY - top;
                }
                if (areaBoundsWidth + areaBoundsX < left + width) {                      
                    var excessWidth = (left + width) - (areaBoundsWidth + areaBoundsX);
                    rightWidth = width - excessWidth;
                }
                rightWidth = (rightWidth == 0) ? width : rightWidth;
                bottomHeight = (bottomHeight == 0) ? height : bottomHeight;
                document.getElementById($cloneNode[0].id).style.clip = "rect(" + topHeight + "px," +  
                         rightWidth + "px," +
                         bottomHeight + "px," +
                         leftWidth + "px)";
            }
        }
    },
	
	animateLabelTemplate : function(options) {
	// method to animate data label template
        var seriesIndex = $.inArray(options, this.chartObj.model._visibleSeries);
        var length = options._visiblePoints.length;
        var secondsPerPoint = 1000;
        
        for (var i = 0; i < length; i++) {            
            var ele = options.marker.dataLabel.template + '_' + seriesIndex + '_' + i + '_' + this.chartObj._id;
            ele = $('#' + ele);
            ele.css("display", "none");
            ele.delay(secondsPerPoint).fadeIn(300);
			}
    },
	
	textPosition: function (series, seriesIndex, point, textOffset, type, x, y, chartRegionIndex, index, params) {
	    var marker = $.extend(true, {}, series.marker, point.marker),
            dataLabel = marker.dataLabel,
            horizontalTextAlignment = dataLabel.horizontalTextAlignment.toLowerCase(),
            verticalTextAlignment = dataLabel.verticalTextAlignment.toLowerCase(),
            textPosition = dataLabel.textPosition.toLowerCase(),
            visiblePointLength = series._visiblePoints.length,
            seriesPointIndex = chartRegionIndex,
            lineHeight = 10,
			padding = 3,
            margin = dataLabel.margin,
			isYInversed = series.yAxis.isInversed,
			xOrigin = this.chartObj._getXCrossValue(series, series.xAxis, params);	    
	    var seriesType = (type.indexOf("bar") != -1 || (type.indexOf("column") != -1 && type!="rangecolumn")) ? (this.chartObj.model.requireInvertedAxes) ? "bar" : "column" : type;
	    if (seriesType == 'column' || seriesType == 'stackingcolumn' || seriesType == 'stackingcolumn100') {
			var bounds = this.chartObj.model.chartRegions[seriesPointIndex].Region.Bounds,
				originChanged = params.axes[series.xAxis.name]._validCross||false;
                pointHeight = bounds.Height,
                pointWidth = bounds.Width;

			if(!originChanged){				
				if (textPosition == "bottom") {
					if ((point.y > xOrigin && !series.yAxis.isInversed) || (point.y < xOrigin && series.yAxis.isInversed))
						y = y + pointHeight - margin.bottom;
					else 
						y = textOffset.height + margin.bottom;
				} else if (textPosition == "middle") {
					if ((point.y > xOrigin && !series.yAxis.isInversed) || (point.y < xOrigin && series.yAxis.isInversed))
						y += pointHeight / 2 + (textOffset.height) / 4;
					else  
						y -= pointHeight / 2;
				}
				else {
					if ((point.y > xOrigin && series.yAxis.isInversed) || (point.y < xOrigin && !series.yAxis.isInversed))
                   y += lineHeight;
               else
                   y -= lineHeight;
				}				
           }
			else{
				var origin = Math.abs((isYInversed ? series.yAxis.visibleRange.min : series.yAxis.visibleRange.max) - xOrigin) / series.yAxis.visibleRange.delta * series.yAxis.height;
				if (textPosition == "bottom") {
					if (y <= origin)
						y = y + pointHeight - margin.bottom;
					else 
						y = y - pointHeight + textOffset.height - margin.bottom;
				} else if (textPosition == "middle") {
					if (y < origin)
						y += pointHeight / 2 + (textOffset.height) / 4;
					else  
						y -= pointHeight / 2;
				}
				else {
					if ((y < origin && isYInversed) || (y < origin && !isYInversed))
						y -= (lineHeight + (2 * textOffset.height) / 2);
					else
						y += (lineHeight + (2 * textOffset.height) / 2);
				}			
			}

           if (horizontalTextAlignment && horizontalTextAlignment == "far")
               x += pointWidth / 2;
            else if (horizontalTextAlignment && horizontalTextAlignment == "near")
               x -= pointWidth / 2;

           if (verticalTextAlignment && verticalTextAlignment == "near") {
               if (textPosition == "bottom")
                   y += lineHeight;
               else
                   y += lineHeight - padding;
           }
           else if (verticalTextAlignment && verticalTextAlignment == "far") {
               if (textPosition == "bottom")
                   y -= lineHeight;
               else
                   y -= lineHeight;
           }
        }

	    else if (seriesType.indexOf("bar") != -1) {
	        var bounds = this.chartObj.model.chartRegions[seriesPointIndex].Region.Bounds,
                pointWidth = bounds.Width,
			    originChanged = params.axes[series.xAxis.name]._validCross||false,
	            pointHeight = bounds.Height;
			y = y+ textOffset.height / 4;
			if(!originChanged)
			{				
				if (textPosition == "bottom") {
		  	    if ((point.y > 0 && !series.yAxis.isInversed) || (point.y < 0 && series.yAxis.isInversed))
		  	        x = margin.left + textOffset.width / 4;
		  	    else
		  	        x += (pointWidth - textOffset.height - margin.right);
		  	} else if (textPosition == "middle") {
			      if ((point.y > 0 && !series.yAxis.isInversed) || (point.y < 0 && series.yAxis.isInversed))
			          x -= pointWidth / 2 + textOffset.width / 2;
			      else
			          x += pointWidth / 2;
		  	} else {
					if ((point.y >= 0 && !series.yAxis.isInversed) || (point.y < 0 && series.yAxis.isInversed))
		  	        x  += textOffset.width/4 + lineHeight ;
                else
		  	        x -= textOffset.width/4 + lineHeight;
           }
			}
			else
			{
				var yOrigin = series.xAxis._crossValue||0,
				origin = Math.abs(isYInversed ? series.yAxis.visibleRange.max : series.yAxis.visibleRange.min - yOrigin) / series.yAxis.visibleRange.delta * series.yAxis.width;
				if (textPosition == "bottom") {
				    if ((x < origin && !isYInversed)||(x >= origin && isYInversed))
						x = x + pointWidth - textOffset.width;
					else
						x = x - pointWidth + margin.left;
				} else if (textPosition == "middle") {
				    if ((x < origin && !isYInversed) || (x >= origin && isYInversed))
				        x = x + pointWidth / 2 - textOffset.width / 2;
				    else
				        x = x - pointWidth / 2 - textOffset.width / 2;
				}
				else {
				    if ((x < origin && !isYInversed) || (x >= origin && isYInversed))
				        x -= (lineHeight + (2 * textOffset.width) / 2);
				    else
				        x += (lineHeight + (2 * textOffset.width) / 2);
				}
			}

		  	if (horizontalTextAlignment && horizontalTextAlignment == "far") {
		  	    if (textPosition == "bottom")
		  	        x += textOffset.width - textOffset.width / 4;
		  	    else
		  	        x += textOffset.width/4 + lineHeight;
		  	}
		  	else if (horizontalTextAlignment && horizontalTextAlignment == "near") {
		  	    if (textPosition == "bottom")
		  	        x -= textOffset.width / 4;
		  	    else
		  	        x -= lineHeight - textOffset.width/4 - padding ;
		  	}
		  	else // for center
		  	    x += textOffset.width / 4;
				
            if (verticalTextAlignment && verticalTextAlignment == "near")
                y += pointHeight / 2;
            else if (verticalTextAlignment && verticalTextAlignment == "far")
                y -= pointHeight / 2;
	    }
	    else if (seriesType == "rangecolumn" ) {
	         var bounds = this.chartObj.model.chartRegions[seriesPointIndex].Region.Bounds;
	         var height = 0;
	         var width = 0;
	         if (point.high != point.y) {
	            height = bounds.Height;
	     	 	width = bounds.Width;
	          }
	       	 if (this.chartObj.model.requireInvertedAxes) {
	             if (textPosition == "top")
                     x = x - width + (lineHeight + (2 * textOffset.width) / 2);
                 else if (textPosition == "bottom")
                     x = x - width - (2 * textOffset.width + lineHeight);
	             else if (textPosition == "middle")
                     x = x - width;
             }
	         else{
                 if(textPosition == "top")
                     y += height - lineHeight;
	        
                 else if(textPosition == "bottom")
                     y = y + height + (2 * textOffset.height + lineHeight);
	             else if (textPosition == "middle")
                     y = y + height;
	         }
	         if (horizontalTextAlignment && horizontalTextAlignment.toLowerCase() == "far")
                  x += bounds.Width / 2;
	         else if (horizontalTextAlignment && horizontalTextAlignment.toLowerCase() == "near")
                  x -= bounds.Width / 2;	    
            if (verticalTextAlignment && verticalTextAlignment.toLowerCase() == "near")
                  y += lineHeight - padding;
	         else if (verticalTextAlignment && verticalTextAlignment.toLowerCase() == "far")
                  y -= lineHeight;
	    
        }
		
		else if (seriesType == "boxandwhisker") {
	         var bounds = this.chartObj.model.chartRegions[seriesPointIndex].Region.Bounds;
	         var height = 0;
	         var width = 0;
	         if (this.chartObj.model.requireInvertedAxes) {
	             if (textPosition == "top")
	                 x = x - width + (lineHeight + (2 * textOffset.width) / 2);
	             else if (textPosition == "bottom")
	                 x = x - width - (2 * textOffset.width + lineHeight);
	             else if (textPosition == "middle")
	                 x = x - width;
	         }
	         else {
	             if (textPosition == "top")
	                 y += height - padding;
	             else if (textPosition == "bottom")
	               //  y = y + height + (2 * textOffset.height + lineHeight);
	                 y += height + lineHeight + (textOffset.width / 2);
	             else if (textPosition == "middle")
	                 y += height + lineHeight;
	         }
	         if (horizontalTextAlignment && horizontalTextAlignment.toLowerCase() == "far")
				  x +=  2 * textOffset.width ;
	         else if (horizontalTextAlignment && horizontalTextAlignment.toLowerCase() == "near")
                  x -= 2 * textOffset.width  ;	
				  
            if (verticalTextAlignment && verticalTextAlignment.toLowerCase() == "near")
                  y = (textPosition == "top" ) ? y + lineHeight : y - lineHeight;
	         else if (verticalTextAlignment && verticalTextAlignment.toLowerCase() == "far")
                  y = (textPosition == "top" ) ? y - lineHeight : y + lineHeight;
	    
        }
		
	    else if (type == "waterfall") {
	        var bounds = this.chartObj.model.chartRegions[seriesPointIndex].Region.Bounds,
                pointHeight = bounds.Height,
                pointWidth = bounds.Width;

	        var isNegativePoint = point.waterfallSum < 0 || (!point.showIntermediateSum && !point.showTotalSum && point.y < 0);
	       
	        switch (textPosition) {
	            case "bottom":
	                if (!series.isTransposed) {
	                    if (!series.yAxis.isInversed)
	                        y = y + pointHeight - margin.bottom - (isNegativePoint ? pointHeight : 0);
	                    else
	                        y = y - textOffset.height + margin.bottom + (isNegativePoint ? pointHeight : 0);
	                } else {
	                    if (!series.yAxis.isInversed)
	                        x = x - pointWidth + (lineHeight + (2 * textOffset.height) / 2) + (isNegativePoint ? pointWidth : 0);
	                    else
	                        x = x + pointWidth - (lineHeight + (2 * textOffset.height) / 2) - (isNegativePoint ? pointWidth : 0);
	                }
	                break;

	            case "middle":
	                if (!series.isTransposed) {
	                    if (!series.yAxis.isInversed)
	                        y = y + (pointHeight / 2 + (textOffset.height) / 4) - (isNegativePoint ? pointHeight : 0);
	                    else
	                        y = y - (pointHeight / 2) + (isNegativePoint ? pointHeight : 0);
	                } else {
	                    if (!series.yAxis.isInversed)
	                        x = x - (pointWidth / 2 + (textOffset.width) / 4) + (isNegativePoint ? pointWidth : 0);
	                    else
	                        x = x + (pointWidth / 2) - (isNegativePoint ? pointWidth : 0);
	                }
	                break;

	            default:
	                if (!series.isTransposed) {
	                    if (!series.yAxis.isInversed)
	                        y = y - (lineHeight + (2 * textOffset.height) / 2) - (isNegativePoint ? pointHeight : 0);
	                    else
	                        y = y + (lineHeight + (2 * textOffset.height) / 2) + (isNegativePoint ? pointHeight : 0);
	                } else {
	                    if (!series.yAxis.isInversed)
	                        x = x + (lineHeight + (2 * textOffset.height) / 2) + (isNegativePoint ? pointWidth : 0);
	                    else
	                        x = x - (lineHeight + (2 * textOffset.height) / 2) - (isNegativePoint ? pointWidth : 0);
	                }
	        }

	        if (horizontalTextAlignment && horizontalTextAlignment == "far")
	            x += pointWidth / 2;
	        else if (horizontalTextAlignment && horizontalTextAlignment == "near")
	            x -= pointWidth / 2;

	        if (verticalTextAlignment && verticalTextAlignment == "near") {
	            if (textPosition == "bottom")
	                y += textOffset.height / 3;
	            else
	                y += (textOffset.height + lineHeight);
	        }
	        else if (verticalTextAlignment && verticalTextAlignment == "far") {
	            if (textPosition == "bottom")
	                y -= textOffset.height / 3;
	            else
	                y -= (lineHeight + (textOffset.height) / 2);
	        }

	    }
        else if (type == "polar" || type == "radar") {
                y += textOffset.height / 4;
            if (textPosition == "bottom")
                y += (textOffset.height);
            else if (textPosition == "top")
                y -=  (textOffset.height);

            if (horizontalTextAlignment && horizontalTextAlignment == "far")
                x += textOffset.width;
            else if (horizontalTextAlignment && horizontalTextAlignment == "near")
                x -= (textOffset.width);

            if (verticalTextAlignment && verticalTextAlignment == "near")
                y += (textOffset.height)/2;
            else if (verticalTextAlignment && verticalTextAlignment == "far")
                y -= ((textOffset.height)/2);
        }
        else {
            if ((seriesType == "rangearea") && (point.high != point.y)) {
                if (this.chartObj.model.series.length == 1) {
                    var length = this.chartObj.model.chartRegions[seriesIndex][index].region.length;
                    y = this.chartObj.model.chartRegions[seriesIndex][index].region[length - 1].Y;
                    x = this.chartObj.model.chartRegions[seriesIndex][index].region[length - 1].X;
                }
                else {
                    var precount = 0;
                    for (var a = 0; a < seriesIndex; a++) {
                        var pretype = this.chartObj.model.series[a].type;
                        if (pretype != "rangearea")
                            precount = precount + this.chartObj.model.series[a].points.length;
                        else
                            precount = precount + 1;

                    }
                    var length = this.chartObj.model.chartRegions[precount][index].region.length;
                    y = this.chartObj.model.chartRegions[precount][index].region[length - 1].Y;
                    x = this.chartObj.model.chartRegions[precount][index].region[length - 1].X;
                }

                
            }    
            if (this.chartObj.model.requireInvertedAxes) {
                if (textPosition == "top")
                    x += lineHeight;
                else if (textPosition == "bottom")
                    x -= (lineHeight + (2 * textOffset.width) / 2);
            }
            else {
                if (textPosition == "bottom")
                    y += (2 * textOffset.height + lineHeight);
                else if (textPosition == "top")
                y -= lineHeight;
			else {
				if ((type == "bubble" || type == "scatter") && textPosition == "middle")
					y += textOffset.height/4;   // for placing the data label at the center of bubble
			}
        }
            if (horizontalTextAlignment && horizontalTextAlignment == "far")
                x += textOffset.width + lineHeight;
            else if (horizontalTextAlignment && horizontalTextAlignment == "near")
                x -= ((textOffset.width) + lineHeight);

            if (verticalTextAlignment && verticalTextAlignment == "near")
                y += lineHeight - padding;
            else if (verticalTextAlignment && verticalTextAlignment == "far")
                y -= lineHeight;
			else {
				if ((type == "bubble" || type == "scatter") && textPosition == "middle")
					y += textOffset.height/4;   // for placing the data label at the center of bubble
			}
        }
        var location = { x: x, y: y };
        return location;
    },
	



    changeCrossHairSymbol: function(element, track, ptIndex, serIndex, series) {
        if (!ej.util.isNullOrUndefined(track)) {
            var trackMarker = {};
            element = $.extend(true, {}, series.marker, element);
            trackMarker = $.extend(true, {}, this.chartObj.model.crosshair.marker, trackMarker);
            var point = series.points[ptIndex], seriesType = series.type.toLowerCase();
            if (ej.util.isNullOrUndefined(trackMarker.shape)) {
                trackMarker.shape = element.shape;
                if (seriesType == 'bubble') {
                    trackMarker.border.color = ((point.border) && point.border.color) ? point.border.color : series.border.color;
                    trackMarker.border.width = ((point.border) && point.border.width) ? point.border.width : series.border.width;
                }
            }
            
            if ((!this.chartObj.model.crosshair.visible || ej.util.isNullOrUndefined(trackMarker.fill)) && series.type.toLowerCase() != "bubble" && series.type.toLowerCase() != "scatter") {
                if(trackMarker.shape.toLowerCase()=="cross" ||trackMarker.shape.toLowerCase()=="horizline"||trackMarker.shape.toLowerCase()=="vertline" )   
                    trackMarker.fill = jQuery.type(this.chartObj.model.seriesColors[serIndex]) == "array" ? this.chartObj.model.seriesColors[serIndex][0].color : this.chartObj.model.seriesColors[serIndex];         
                else
                    trackMarker.fill = element.border.color;
            }
            if (series.type.toLowerCase() == "bubble" && !this.chartObj.model.enableCanvasRendering) {
                var box = $(this.chartObj.gSeriesEle).find("#" + this.chartObj.svgObject.id + '_Series' + serIndex + '_Point' + ptIndex)[0].getBoundingClientRect();
                trackMarker.size.width = (box.right - box.left) / 2 + 15;
                trackMarker.size.height = (box.bottom - box.top) / 2 + 15;
            } else {
                if (trackMarker.size.width <= element.size.width)
                    trackMarker.size.width = element.size.width + 2;
                if (trackMarker.size.height <= element.size.height)
                    trackMarker.size.height = element.size.height + 2;
               
                if (ej.util.isNullOrUndefined(trackMarker.border.color) || !this.chartObj.model.crosshair.visible){              
                 if (!ej.util.isNullOrUndefined(element.fill))
                    trackMarker.border.color = jQuery.type(element.fill) == "array" ? element.fill._gradientStop[0].color : element.fill;
                 else if (seriesType == 'scatter') {
                     trackMarker.border.color = ((point.border) && point.border.color) ? point.border.color : series.border.color;
                     trackMarker.border.width = ((point.border) && point.border.width) ? point.border.width : series.border.width;
                 }
                else
                  trackMarker.border.color = (point.fill) ? point.fill : (jQuery.type(this.chartObj.model.seriesColors[serIndex]) == "array" ? this.chartObj.model.seriesColors[serIndex][0].color : this.chartObj.model.seriesColors[serIndex]);
                }
            }
        }
        series._trackMarker = trackMarker;
        return trackMarker;


    },
	
    dataLabelSymbol: function (seriesIndex, series, pointIndex, x, y, width, height, symbolName, sender, group) {
        var chartObj = sender;
        if (symbolName == 'None')
            return;
        var point = chartObj.model._isPieOfPie ? ej.ejChart._getPieOfPiePoint(pointIndex, series) : series._visiblePoints[pointIndex];
            var location = { startX: x, startY: y };
            if(!sender.model.enable3D)
                var symbolEle = group ? group : chartObj.gDataLabelEle[seriesIndex];
				symbolEle = chartObj.model.enableCanvasRendering ? null : symbolEle;
            var element = $.extend(true, {}, series.marker, point.marker);
            var gradientName = "symbol";
            var style = { 'interior': element.dataLabel.fill, 'opacity': element.dataLabel.opacity, 'borderColor': element.dataLabel.border.color, 'borderWidth': element.dataLabel.border.width };
            var options = {
                'style': style,
                'gradientName': gradientName,
                'symbolEle': symbolEle,
                'width': width,
                'height': height,
                'point': point,
                'location': location,
                'seriesIndex': seriesIndex,
                'pointIndex': pointIndex,
                'element': element,
                'symbolName': symbolName,
                'id': chartObj.svgObject.id + '_dataLabel_series'+ seriesIndex + "_" + pointIndex
            };
            this.drawSymbolStyle(options, chartObj);
    },

    drawSymbolStyle: function (options, sender) {
        var chartObj = sender;
        var borderColor, borderWidth, opacity;
        var style = options.style, gradientName = options.gradientName, symbolEle = options.symbolEle,
            width = options.width, dashArray = options.dashArray;
        var height = options.height, point = options.point, location = options.location,
            seriesIndex = options.seriesIndex, visibility = options.visibility;
        var pointIndex = options.pointIndex, element = options.element, symbolName = options.symbolName;
        var trackSymbol = options.trackSymbol;
        var isCanvas = chartObj.model.enableCanvasRendering;
        var isPolar = chartObj.model.AreaType == 'polaraxes';
        var series = chartObj.model.series[seriesIndex];

        if (style != null) {
            if (style.borderColor != "")
                borderColor = style.borderColor ? style.borderColor: "transparent";

            opacity = style.opacity;
            borderWidth = style.borderWidth < 0 ? 0 : style.borderWidth;
        }
        var colors = null;
        if (style.interior) {
            colors = ej.util.isNullOrUndefined(style.interior._gradientStop) ? style.interior : style.interior._gradientStop;
        }
        else {       
            if (point.fill)
                colors = jQuery.type(point.fill) == "array" ? point.fill[0].color : point.fill;
            else {
                var pointColors = chartObj.model.pointColors;
                colors = (chartObj.model.AreaType != "none") ? ((series.type.toLowerCase() == "waterfall" && series.positiveFill && (point.y > 0 || point.waterfallSum > 0)) ? series.positiveFill :
                    chartObj.model.seriesColors[seriesIndex]) : jQuery.type(pointColors[pointIndex]) == "array" ? pointColors[pointIndex][0].color : pointColors[pointIndex];
            }
        }
       chartObj.symbolColorName = chartObj.svgRenderer.createGradientElement(gradientName + seriesIndex, colors, 0, 0, 0, $(chartObj.svgObject).height(), symbolEle);

       var symbolStyle = {
           dashArray: options.dashArray,
           ShapeSize: {
               width: width,
               height: height
           },
           Style: {
               BorderColor: borderColor,
               BorderWidth: borderWidth,
               Opacity: opacity,
               Visibility: visibility,
               Color: chartObj.symbolColorName
           },
           PointIndex: pointIndex,
           SeriesIndex: seriesIndex,
           Imageurl: element.imageUrl,
           Image: element.image,
           ID: options.id
       };

        var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = { location: location, style: symbolStyle };
        chartObj._trigger("symbolRendering", commonEventArgs);
        if (!commonEventArgs.cancel) {
            if (isCanvas){
				//Added for Marker location while setting plotoffset value to axis
                  location.startY = (!chartObj.model.requireInvertedAxes) ? (location.startY + (series.yAxis.y ? (series.yAxis.y - chartObj.canvasY) : 0)) : location.startY;
                  location.startX = (!chartObj.model.requireInvertedAxes) ? (location.startX + (series.xAxis.x ? (series.xAxis.x - chartObj.canvasX) : 0)) : location.startX;
              
                commonEventArgs.data.location.startY = location.startY;
                if (ej.util.isNullOrUndefined(trackSymbol)) { // to draw marker/datalabel
				    if (chartObj.model.AreaType == "cartesianaxes") {
					    symbolEle = chartObj.svgRenderer.ctx;
					    chartObj.svgRenderer.ctx.save();
				        chartObj.svgRenderer.ctx.beginPath();
                        if (!chartObj.model.requireInvertedAxes)
                            chartObj.svgRenderer.ctx.rect(series.xAxis.x, series.yAxis.y, series.xAxis.width, series.yAxis.height);
					    else
                            chartObj.svgRenderer.ctx.rect(series.yAxis.x, series.xAxis.y, series.yAxis.width, series.xAxis.height);
                        chartObj.svgRenderer.ctx.clip();
					    ej.EjSvgRender.chartSymbol["_draw" + symbolName](commonEventArgs.data.location, commonEventArgs.data.style, chartObj, symbolEle);
					    chartObj.svgRenderer.ctx.restore();
				    }
				    else{
				        if (isCanvas && isPolar) {
				            chartObj.svgRenderer.ctx.save();
				            chartObj.svgRenderer.ctx.beginPath();
				            chartObj.svgRenderer.ctx.arc(chartObj.model.centerX, chartObj.model.centerY, chartObj.model.Radius, 0, 2 * Math.PI, false);
				            chartObj.svgRenderer.ctx.clip();
				        }
				        ej.EjSvgRender.chartSymbol["_draw" + symbolName](commonEventArgs.data.location, commonEventArgs.data.style, chartObj, symbolEle);
				        if (isCanvas && isPolar)
				            chartObj.svgRenderer.ctx.restore();
                    }
                   
                }
                else {
                        var ptIndex = commonEventArgs.data.style.PointIndex;
                        var serIndex = commonEventArgs.data.style.SeriesIndex;
                        if (!chartObj.model.series[serIndex].highlightSettings.enable) {
                            if ($('#' +chartObj._id+'_selection_'+serIndex+'_'+ptIndex+'_canvas').length == 0)
                                chartObj.svgRenderer.trackSymbol(commonEventArgs.data.style, commonEventArgs.data.location, symbolName, trackSymbol, chartObj);
                        }
                    }
                }
                else {
                    var ptIndex = commonEventArgs.data.style.PointIndex;
                    var serIndex = commonEventArgs.data.style.SeriesIndex;
                    var type = series.type;
                    var className;
                    if (series.highlightSettings.enable && trackSymbol && !chartObj.model.crosshair.visible) {
                        var style = $.extend(true, commonEventArgs.data.style);
                        var highlight =series.highlightSettings;
                        style.Style.Color = (highlight.pattern.toLowerCase() == "none" || highlight.pattern == "") ? (highlight.color != "" ? highlight.color : style.Style.Color) : "url(#" + highlight.pattern.toLowerCase() + '_Highlight_2D_' + serIndex + ")";
                        style.Style.Opacity = highlight.opacity;
                        style.Style.BorderColor = highlight.border.color;
                        style.Style.BorderWidth = highlight.border.width;
                        // checked condition for is already selected or not
                        if(type == 'bubble')
                            className = $('#' + this.chartObj.svgObject.id + '_Series' + serIndex + '_Point' + ptIndex).attr('class');
                        else
                            className = $('#' + this.chartObj.svgObject.id + '_Series' + serIndex + '_Point' + ptIndex+'_symbol').attr('class');
                        if (className != "SelectionStyleseries" + serIndex)
                            ej.EjSvgRender.chartSymbol["_draw" + symbolName](commonEventArgs.data.location, style, chartObj, (chartObj.model.enable3D) ? sender.chart3D : symbolEle);
                    }
                    else {
                        if (type == 'scatter')
                            className = $('#' + chartObj.svgObject.id + '_Series' + serIndex + '_Point' + ptIndex + '_symbol').attr('class');
                        else
                            className = $('#' + chartObj.svgObject.id + '_Series' + serIndex + '_Point' + ptIndex).attr('class');
                        if (className != "SelectionStyleseries" + serIndex)
                            ej.EjSvgRender.chartSymbol["_draw" + symbolName](commonEventArgs.data.location, commonEventArgs.data.style, chartObj, (chartObj.model.enable3D) ? sender.chart3D : symbolEle);
                    }
                }
            }

        if (!sender.chart3D && type!="pieofpie" && chartObj.model.AreaType == "none" && $(symbolEle).children().not("defs").length > chartObj.model._visibleSeries[seriesIndex]._visiblePoints.length) {
            $(symbolEle.childNodes[options.pointIndex]).replaceWith($(symbolEle.childNodes[$(symbolEle.childNodes).length - 1]));
        }

    },
	
    drawSymbol: function (seriesIndex,series, pointIndex, x, y,chart,trackSymbol,trackcount) {

        if (ej.util.isNullOrUndefined(this.chartObj)) this.chartObj = chart;


        var point = series._visiblePoints[pointIndex], seriesType = series.type.toLowerCase(),
        index = seriesType == "boxandwhisker" ? trackcount : pointIndex,
        dashArray = (seriesType == 'bubble' || seriesType == 'scatter') ? series.border.dashArray : "";
             var symbolName = "None";
             var tracker = this.changeCrossHairSymbol(point.marker ? point.marker : series.marker, trackSymbol, pointIndex, seriesIndex, series);
             if(seriesType.toLowerCase() == 'boxandwhisker')
                var element = tracker ? tracker : $.extend(true, {}, series.outlierSettings, point.outlierSettings,series.border,point.border);				
             else
                var element = tracker ? tracker : $.extend(true, {}, series.marker, point.marker);

             $.each(this.chartObj.model.symbolShape, function(name) {
                 if (element.shape.toLowerCase() == name.toLowerCase())
                     symbolName = name;
             });
                if (symbolName == "None")
                    return;
                var location = this.chartObj.model.AreaType == "cartesianaxes" ? { startX: x + this.chartObj.canvasX, startY: y + this.chartObj.canvasY } : { startX: x, startY: y };
				var borderColor,borderWidth,style;
                if (seriesType == 'scatter') {
                    borderColor = ((point.border) && point.border.color) ? point.border.color : series.border.color;
                    borderWidth = ((point.border) && point.border.width) ? point.border.width : series.border.width;
                    style = { 'interior': element.fill, 'opacity': element.opacity, 'borderColor': borderColor, 'borderWidth': borderWidth };
                }
				else if(seriesType == "boxandwhisker")
				{
                     borderColor = ((point.border) && point.border.color) ? (point.border.color == "transparent" ? this.chartObj._saturationColor(series.fill,-0.6) : point.border.color ) : (series.border.color == "transparent" ? this.chartObj._saturationColor(series.fill,-0.6) : series.border.color ) ;
                     borderWidth = ((point.border) && point.border.width) ? point.border.width : series.border.width;
                     style = { 'interior': series.fill, 'opacity': series.opacity, 'borderColor': borderColor, 'borderWidth': borderWidth };
				}
                else {
                    var style = { 'interior': element.fill, 'opacity': element.opacity, 'borderColor': element.border.color, 'borderWidth': element.border.width };
                }
                var symbolEle = (trackSymbol) ? this.chartObj.gTrackerEle : this.chartObj.gSymbolGroupEle[seriesIndex];
                var id = (trackSymbol) ? (this.chartObj.svgObject.id + '_trackSymbol_' + seriesIndex + "_" + index) : (this.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + index + '_symbol');
                var gradientName = trackSymbol ? "TrackSymbol" : "symbol";
                var width = element.size.width;
                var height = element.size.height;
                var options = {
                    'style': style,
                    'gradientName': gradientName,
                    'symbolEle': symbolEle,
                    'width': width,
                    'height': height,
                    'point': point,
                    'location': location,
                    'seriesIndex': seriesIndex,
                    'pointIndex': pointIndex,
                    'element': element,
                    'visibility': (point.visible) ? 'visible' : 'hidden',
                    'symbolName': symbolName,
                    'trackSymbol' : trackSymbol,
                    'id': id,
                    'dashArray':dashArray
                };
                this.drawSymbolStyle(options, this.chartObj, trackSymbol);

                if (series.type.toLowerCase() == "scatter") {
                    var areaBoundsX = series.xAxis.x;
                    var areaBoundsY = series.yAxis.y;
                    if (this.chartObj.model.enableCanvasRendering) {
                        areaBoundsX = 0;
                        areaBoundsY = 0;
                    }
                    var bounds = { X: areaBoundsX + location.startX - (height / 2), Y: areaBoundsY + location.startY - (width / 2), Height: height, Width: width };
                    ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, series, null, pointIndex);
                }
    },

    chartAreaType: "cartesianAxes",
    requireInvertedAxes: false,
    stackingSeries: false,
    hiloTypes:false
    
};


function ejExtendClass(parent, members) {
    var object = function () { };
    object.prototype = new parent();
    $.extend(object.prototype, members);
    return object;
}

ej.ejLineSeries = ejExtendClass(ej.EjSeriesRender);

ej.seriesTypes.line = ej.ejLineSeries;


ej.ejStepLineSeries = ejExtendClass(ej.EjSeriesRender, {

    draw: function (chart, options) {
        var chartObj = this.chartObj = chart;
        var lDirection;
		options.animationType = "path";
        var sb = ej.EjSvgRender.utils._getStringBuilder();
        var currentseries = options;
        var style = this.setLineSeriesStyle(currentseries);
        if (currentseries.sorting)
            currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();
        var visiblePoints = this.improveChartPerformance(currentseries);
        var firstPoint = null;
        var startPath = "M";
        var secondPoint,nextpoint,point1,point2,point3;
        var firstIndex = -1;
        for (var i = 0; i < visiblePoints.length; i++) {
            secondPoint = visiblePoints[i];
            if (secondPoint.visible) {
                if (firstPoint != null) {
                    if (visiblePoints.length > firstIndex + 1) {
                        nextpoint = { xValue: visiblePoints[firstIndex + 1].xValue, YValues: [firstPoint.YValues[0]] };
                        point1 = ej.EjSvgRender.utils._getPoint(firstPoint, currentseries);
                        point2 = ej.EjSvgRender.utils._getPoint(nextpoint, currentseries);
                        point3 = ej.EjSvgRender.utils._getPoint(visiblePoints[firstIndex + 1], currentseries);
                        chartObj = this.chartObj;
                        sb.append(startPath + " " + (point1.X + chartObj.canvasX) + " " + ((point1.Y + chartObj.canvasY)) + " " +
						"L" + " " + (point2.X + chartObj.canvasX) + " " + ((point2.Y + chartObj.canvasY)) + " " +
						"L" + " " + (point3.X + chartObj.canvasX) + " " + ((point3.Y + chartObj.canvasY)) + " ");
                    }
                    startPath = "L";
                }
                firstPoint = secondPoint;
                firstIndex = i;
            }
            else {
                firstPoint = null;
                startPath = "M";
            }
        }
        lDirection = sb.toString();

        this._drawLinePath(currentseries, style, lDirection);

        if(this.chartObj.dragPoint) 
            this.chartObj.svgRenderer.append(this.chartObj.gPreviewSeriesGroupEle, this.chartObj.gSeriesEle);
        else
            this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle); 
    }

});

ej.ejStepAreaSeries = ejExtendClass(ej.EjSeriesRender, {

    draw: function (chart, options, params) {
        this.chartObj = chart;
		options.animationType = "path";
		var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
        var aDirection;
        var sb = ej.EjSvgRender.utils._getStringBuilder();
        var currentseries = options;
        var style = this.setAreaSeriesStyle(currentseries);
        if (currentseries.sorting)
            currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();
        var visiblePoints = this.improveChartPerformance(currentseries);
        var xOffset = 0;
        var firstPoint = null;
        var secondPoint;
        if (currentseries.xAxis._valueType.toLowerCase() == "category" && currentseries.xAxis.labelPlacement.toLowerCase() != "onticks")
            xOffset = 0.5;
        var origin = ej.EjSeriesRender.prototype.getOrigin(this, currentseries, params);
        var startPoint = null;
        var start = true;
        var chartObj = this.chartObj;
        for (var i = 0; i <= visiblePoints.length; i++) {

            if (i < visiblePoints.length) {
                if (visiblePoints[i].visible) {

                    secondPoint = { xValue: visiblePoints[i].xValue - xOffset, YValues: [visiblePoints[i].y] };
                    point1 = ej.EjSvgRender.utils._getPoint(secondPoint, currentseries);
                    if (!startPoint) {
                        startPoint = { xValue: visiblePoints[i].xValue - xOffset, YValues: [origin] }
                        var startLoc = ej.EjSvgRender.utils._getPoint(startPoint, currentseries);
                        sb.append("M" + " " + (startLoc.X + chartObj.canvasX) + " " + (startLoc.Y + chartObj.canvasY) + " ");
                    }
                    if (firstPoint != null) {
                        var step = { xValue: secondPoint.xValue, YValues: [firstPoint.YValues[0]] };
                        var stepPoint = ej.EjSvgRender.utils._getPoint(step, currentseries);
                        if (start) {
                            sb.append("L" + " " + (point2.X + chartObj.canvasX) + " " + (point2.Y + chartObj.canvasY) + " ");
                            start = false;
                        }
                        sb.append("L" + " " + (stepPoint.X + chartObj.canvasX) + " " + ((stepPoint.Y + chartObj.canvasY)) + " " + "L" + " " + (point1.X + chartObj.canvasX) + " " + (point1.Y + chartObj.canvasY) + " ");
                        if ((xOffset == 0 && i == visiblePoints.length - 1) || (i < (visiblePoints.length - 1) && !visiblePoints[i + 1].visible)) {
                            if (xOffset > 0) {
                                secondPoint = { xValue: visiblePoints[i].xValue + xOffset, YValues: [visiblePoints[i].y] };
                                var point1 = ej.EjSvgRender.utils._getPoint(secondPoint, currentseries);
                                 if (requireInvertedAxes)
                                    sb.append("L" + " " + (point1.X + chartObj.canvasX) + " " + (point1.Y + chartObj.canvasY) + " " + "L" + " " + (point1.Y + chartObj.canvasX) + " " + (startLoc.X + chartObj.canvasY) + " ");
                                 else
                                    sb.append("L" + " " + (point1.X + chartObj.canvasX) + " " + (point1.Y + chartObj.canvasY) + " " + "L" + " " + (point1.X + chartObj.canvasX) + " " + (startLoc.Y + chartObj.canvasY) + " ");
                            }
                            else
                               if (requireInvertedAxes)
                                   sb.append("L" + " " + (startLoc.X + chartObj.canvasY) + " " + (point1.Y + chartObj.canvasX)+  " ");
                                else
                                    sb.append("L" + " " + (point1.X + chartObj.canvasX)+ " " + (startLoc.Y + chartObj.canvasY) + " ");
                            startPoint = null;
                            firstPoint = null;
                            start = true;
                        }
                    }
                    if (startPoint) {
                        point2 = point1;
                        firstPoint = secondPoint;
                    }
                }
                else {
                    startPoint = null;
                    firstPoint = null;
                    start = true;
                }

              }
             else {
                    if  (visiblePoints[i-1].visible && xOffset > 0) {
                                secondPoint = { xValue: visiblePoints[i - 1].xValue + xOffset, YValues: [visiblePoints[i - 1].y] };
                                var point1 = ej.EjSvgRender.utils._getPoint(secondPoint, currentseries);
                               if (requireInvertedAxes)
                                    sb.append("L" + " " + (point1.X + chartObj.canvasX) + " " + (point1.Y + chartObj.canvasY) + " " + "L" + " " + (point1.Y + chartObj.canvasX) + " " + (startLoc.X + chartObj.canvasY) + " ");
                                else
                                    sb.append("L" + " " + (point1.X + chartObj.canvasX) + " " + (point1.Y + chartObj.canvasY) + " " + "L" + " " + (point1.X + chartObj.canvasX) + " " + (startLoc.Y + chartObj.canvasY) + " ");
                       }                           
                }
            
         }
        aDirection = sb.toString();

        this.drawAreaPath(currentseries, style, aDirection);
        if (this.chartObj.dragPoint)
            this.chartObj.svgRenderer.append(this.chartObj.gPreviewSeriesGroupEle, this.chartObj.gSeriesEle);
        else
            this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

    }
});
ej.seriesTypes.steparea = ej.ejStepAreaSeries;


ej.seriesTypes.stepline = ej.ejStepLineSeries;


 ej.ejColumnSeries = ejExtendClass(ej.EjSeriesRender, {
   
  
      
     draw: function (chart,options, params)
      { 
         this.chartObj=chart;
		 var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
		 options.animationType = "rect";
		 if (options.columnFacet == "cylinder")
		     options.animationType = "cylinder";
         var series = options;
		 var cornerRadius = series.cornerRadius;
         var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);         
         var origin = ej.EjSeriesRender.prototype.getOrigin(this, series, params);
        
         var sidebysideinfo = this.getSideBySideInfo(series, params);
		 if(series.dragSettings.enable) series.sidebysideInfo = sidebysideinfo;    
         var visiblePoints = this._isVisiblePoints(series);
              
         var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);

         var pointMarker;
         
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };

         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         
         var cSer = this;
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex=i;
             var point = visiblePoints[i];
             pointMarker = visiblePoints[i].marker;
           
             var y1 = point.YValues[0];
             var y2 = origin;
             if (point.visible) {
             //calculate sides
             var data = cSer.calculateSides(point, sidebysideinfo);
             var x1 = data.x1;
             var x2 = data.x2;
             
			 var styleOptions= this.chartObj.setStyle(cSer, series, seriesIndex, pointIndex);

			 var rect = cSer.getRectangle(x1, y1, x2, y2, series, chart);
			 
             //drawing part
             var xr = Math.min(0, rect.Width);
             var yr = Math.min(0, rect.Height);

             var  bounds;        
             if ((xr == 0 || yr == 0) && rect.Width>0) {                      
                 options = {
                     'id': cSer.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex,
                     'x': rect.X + cSer.chartObj.canvasX,
                     'y': rect.Y + cSer.chartObj.canvasY,
                     'width': rect.Width,
                     'height': rect.Height,
					 'cornerRadius': cornerRadius,
                     'fill': styleOptions.interior,
                     'stroke-width': styleOptions.borderWidth,
                     'plot': y1 < 0 ? "negative" : "positive",
                     'opacity': styleOptions.opacity,
                     'stroke': styleOptions.borderColor,
                     'stroke-dasharray': styleOptions.dashArray,
                 };
                 var cylinderSeriesOption = {
                     'isColumn': true,
                     'stacking': false,
                     'isLastSeries': true,
                 };
                 if(series.columnFacet=="cylinder")               
                         cSer.chartObj.svgRenderer.drawCylinder(options, cSer.gSeriesGroupEle, cylinderSeriesOption);
				//calculate path for rounded corner
				 else if ((typeof(cornerRadius) != "object" && cornerRadius >0) || cornerRadius.topLeft >0 || cornerRadius.bottomLeft >0 || cornerRadius.topRight >0 
				 || cornerRadius.bottomRight >0)
				 {
				     var roundrect = ej.EjSvgRender.utils._calculateroundedCorner(options);
				     options.d = roundrect;
					 series.animationType = "path";
				 	 cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
				 }
                 else if (series.columnFacet == "rectangle")
                     cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle);
                         var svgXy = ej.EjSvgRender.utils._getSvgXY(rect.X, (rect.Y), series, cSer.chartObj);
                        bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };
                        ej.EjSvgRender.utils._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                 }
            
                  if (requireInvertedAxes)
                      point.symbolLocation = { X: ((y1 < (series.xAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.xAxis._crossValue || 0))) ? (rect.X) : (rect.X + rect.Width), Y: ((rect.Y) + (rect.Height / 2)) };
                  else
                      point.symbolLocation = { X: rect.X + (rect.Width / 2), Y: ((y1 < (series.xAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.xAxis._crossValue ||0))) ? ((rect.Y) + (rect.Height)) : (rect.Y) };
                 
             }
         }

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

        
     },
   
   isRegion:true

 });
 ej.seriesTypes.column = ej.ejColumnSeries;

 ej.ejStackingColumnSeries = ejExtendClass(ej.EjSeriesRender, {

     draw: function (chart, options, params) {
         this.chartObj = chart;
		 options.animationType = "rect";
         if (options.columnFacet == "cylinder")
             options.animationType = "cylinder";
		 var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         var series = options;
		 var cornerRadius = series.cornerRadius;
         var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
         //var origin = Math.max(options.yAxis.visibleRange.min, 0);
        
         var sidebysideinfo = this.getSideBySideInfo(series, params);
         var visiblePoints = this._isVisiblePoints(series);

         var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);

         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };

         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         var cSer = this;
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex = i;
             var point = series._visiblePoints[i];

             var y2 = series.stackedValue.StartValues[i];
             var y1= series.stackedValue.EndValues[i];
             if (point.visible) {
                 //calculate sides
                 var data = cSer.calculateSides(point, sidebysideinfo);
                 var x1 = data.x1;
                 var x2 = data.x2;
                 
				 var styleOptions= this.chartObj.setStyle(cSer, series, seriesIndex, pointIndex);

                 var rect = cSer.getRectangle(x1, y1, x2, y2, series, chart);
             
                 //drawing part
                 var xr = Math.min(0, rect.Width);
                 var yr = Math.min(0, rect.Height);

                 var bounds;
                 var isstacking100 = series.type == 'stackingcolumn100' ? true : false;
                 if ((xr == 0 || yr == 0) && rect.Width > 0) {
                     options = {
                     'id': cSer.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex,
                     'x': rect.X + cSer.chartObj.canvasX,
                     'y': rect.Y + cSer.chartObj.canvasY,
                     'width': rect.Width,
                     'height': rect.Height,
                     'fill': styleOptions.interior,
						 'cornerRadius': cornerRadius,
                         'stroke-width': styleOptions.borderWidth,
                         'plot': y1 < 0 ? "negative" : "positive",
                         'opacity': styleOptions.opacity,
                         'stroke': styleOptions.borderColor,
                         'stroke-dasharray': styleOptions.dashArray,
                     };
                     var cylinderSeriesOption = {
                         'isColumn': true,
                         'stacking': isstacking100,
                         'isLastSeries': series.stackedValue.stackedSeries,
                     };
                     if (series.columnFacet == "cylinder")
                         cSer.chartObj.svgRenderer.drawCylinder(options, cSer.gSeriesGroupEle, cylinderSeriesOption);
					 else if ((typeof(cornerRadius) != "object" && cornerRadius >0) || cornerRadius.topLeft >0 || cornerRadius.bottomLeft >0 
					          || cornerRadius.topRight >0 || cornerRadius.bottomRight >0)           //calculate path for rounded corner
					{
					     var roundrect = ej.EjSvgRender.utils._calculateroundedCorner(options);
						options.d = roundrect;
						series.animationType = "path";	
						cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
				    }
                     else if (series.columnFacet == "rectangle")
                         cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle);

                     var svgXy = ej.EjSvgRender.utils._getSvgXY(rect.X, (rect.Y), series, cSer.chartObj);
                     bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };
                     ej.EjSvgRender.utils._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                 }
                
                 if (requireInvertedAxes)
                     point.symbolLocation = { X: ((y1 < (series.xAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.xAxis._crossValue || 0))) ? (rect.X) : (rect.X + rect.Width), Y: ((rect.Y) + (rect.Height / 2)) };
                 else
                     point.symbolLocation = { X: rect.X + (rect.Width / 2), Y: ((y1 < (series.xAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.xAxis._crossValue || 0))) ? ((rect.Y) + (rect.Height)) : (rect.Y) };
                 
             }
         }

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

        

     },

     stackingSeries: true,
	  isRegion:true

 });
 ej.seriesTypes.stackingcolumn = ej.ejStackingColumnSeries;
 
 ej.seriesTypes.stackingcolumn100 = ej.ejStackingColumnSeries;

 ej.seriesTypes.rangecolumn = ej.ejRangeColumnSeries;

 ej.ejRangeColumnSeries = ejExtendClass(ej.EjSeriesRender, {
   
     draw: function (chart, options, params) {
         this.chartObj = chart;
		 options.animationType = "rect";
		 var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         var series = options;
		 var cornerRadius = series.cornerRadius;
         var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
      
         var sidebysideinfo = this.getSideBySideInfo(series, params);
         var visiblePoints = this._isVisiblePoints(series);

         var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);

         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };

         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         var cSer = this;
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex = i;
             var point = visiblePoints[i];

             var y1 = point.YValues[0];
             var y2 = point.YValues[1];
             if (point.visible) {
                 //calculate sides
                 var data = cSer.calculateSides(point, sidebysideinfo);
                 var x1 = data.x1;
                 var x2 = data.x2;
                  
				 var styleOptions = this.chartObj.setStyle(cSer, series, seriesIndex, pointIndex);
				  
                 var rect = cSer.getRectangle(x1, y1, x2, y2, series, chart);
                 var width=cSer.chartObj.model.m_AreaBounds.Width;
                 //drawing part
                 var xr = Math.min(0, rect.Width);
                 var yr = Math.min(0, rect.Height);

                 var bounds;
                 if (xr == 0 || yr == 0) {
                     options = {
                         'id': cSer.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex,
                         'x': rect.X + cSer.chartObj.canvasX,
                         'y': rect.Y + cSer.chartObj.canvasY,
                         'width': rect.Width,
                         'height': rect.Height,
						 'cornerRadius': cornerRadius,
                         'fill': styleOptions.interior,
                         'stroke-width': styleOptions.borderWidth,
                         'opacity': styleOptions.opacity,
                         'stroke': styleOptions.borderColor,
                         'stroke-dasharray': styleOptions.dashArray,
                     };
					 
					 if ((typeof(cornerRadius) != "object" && cornerRadius >0) || cornerRadius.topLeft >0 || cornerRadius.bottomLeft >0 
					    || cornerRadius.topRight >0 || cornerRadius.bottomRight >0)           //calculate path for rounded corner
					 {
					     var roundrect = ej.EjSvgRender.utils._calculateroundedCorner(options);
						options.d = roundrect;
						series.animationType = "path";
						cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
					 }
					 else
						cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle, trans.y);

                     cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle, trans.y);

                     //Add region for each rect
                     var svgXy = ej.EjSvgRender.utils._getSvgXY(rect.X, (rect.Y), series, cSer.chartObj);
                     bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };
                     ej.EjSvgRender.utils._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                 }
                 //Add rect location details for symbol                
                 if (series.type.toLowerCase() == "waterfall")
                     y1 = point.waterfallSum ? point.waterfallSum : point.y;              
                 if (requireInvertedAxes)
                     point.symbolLocation = { X: ((y1 < 0 && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > 0)) ? (rect.X) : (rect.X + rect.Width), Y: ((rect.Y) + (rect.Height / 2)) };
                 else
                     point.symbolLocation = { X: rect.X + (rect.Width / 2), Y: ((y1 < 0 && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > 0)) ? ((rect.Y) + (rect.Height)) : (rect.Y) };
                 
             }
         }

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

      

     },
	 
     hiloTypes: true,
	  isRegion:true

 });
 ej.seriesTypes.rangecolumn = ej.ejRangeColumnSeries;
 
 
  ej.ejBoxandwhiskerSeries = ejExtendClass(ej.EjSeriesRender, {
 
 draw: function (chart,options, params)
      { 
         this.chartObj=chart;
         var requireInvertedAxes = this.chartObj.model.requireInvertedAxes,previousStyle;
         options.animationType = "rect"; 
         var series = options,
         seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries),
         origin = ej.EjSeriesRender.prototype.getOrigin(this, series, params),
         sidebysideinfo = this.getSideBySideInfo(series, params),
         visiblePoints = this._isVisiblePoints(series),
         trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes),
         pointMarker,trackCount=0,
         serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         var cSer = this;
         for (var i = 0; i < visiblePoints.length; i++) {
            var pointIndex=i,list1,list2,count =0,y1,y2,data,x1,x2,styleOptions,rect,xr,yr,seriesIndex,sb,newPoint,boxplotmidpoint,
            bounds,options1,whiskerpath,newPoint1,outlierpoint,svgXyOutlier,boundsOutlier,svgXy,
            point = visiblePoints[i];
            pointMarker = visiblePoints[i].marker;
            list1 = point.YValues[0];
            list2 = cSer.calculateMean(list1,series,pointIndex);
            y1=list2.UpperQuartile;
            y2=list2.LowerQuartile;
            if (point.visible) {
                //calculate sides
                data = cSer.calculateSides(point, sidebysideinfo);
                x1 = data.x1;
                x2 = data.x2;
                styleOptions= this.chartObj.setStyle(cSer, series, seriesIndex, pointIndex); 
                rect=  cSer.getRectangle(x1, y1, x2, y2, series, chart);
                //drawing part
                xr = Math.min(0, rect.Width);
                yr = Math.min(0, rect.Height);
                seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
                previousStyle = this.chartObj.setStyle(this, series, seriesIndex, i);
                sb = ej.EjSvgRender.utils._getStringBuilder();
                newPoint = {"xValue": point.xValue, "YValues": list2.midvalue };
                boxplotmidpoint =  ej.EjSvgRender.utils._getPoint(newPoint, series);
				var boxStrokeColor = styleOptions.borderColor == "transparent" ? this.chartObj._saturationColor(styleOptions.interior,-0.6):styleOptions.borderColor;

             bounds;        
             if ((xr == 0 || yr == 0) && rect.Width>0) {
                 options = {
                     'id': cSer.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex,
                     'x': rect.X + cSer.chartObj.canvasX,
                     'y': rect.Y + cSer.chartObj.canvasY,
                     'width': rect.Width,
                     'height': rect.Height,
                     'fill': styleOptions.interior,
                     'stroke-width': styleOptions.borderWidth,
                     'plot': y1 < 0 ? "negative" : "positive",
                     'opacity': styleOptions.opacity,
                     'stroke': boxStrokeColor,
                     'stroke-dasharray': styleOptions.dashArray,
                 };
				 
				 options1 = {
                     'id': this.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex + '_median',
                     x1: series._isTransposed ? boxplotmidpoint.X + cSer.chartObj.canvasX : rect.X +  cSer.chartObj.canvasX ,
                     y1: series._isTransposed ? rect.Y + cSer.chartObj.canvasY : boxplotmidpoint.Y + cSer.chartObj.canvasY,
                     x2: series._isTransposed ? boxplotmidpoint.X + cSer.chartObj.canvasX : rect.X + rect.Width + cSer.chartObj.canvasX  ,                  
                     y2: series._isTransposed ? rect.Y + rect.Height + cSer.chartObj.canvasY : boxplotmidpoint.Y + cSer.chartObj.canvasY ,
                     'stroke-width': styleOptions.borderWidth,
                     'stroke': boxStrokeColor,
				};
				
                     cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle);
					 					 					 
					 //draw mean line for boxandwhisker
					 cSer.chartObj.svgRenderer.drawLine(options1, cSer.gSeriesGroupEle);
					 //draw lowerwhisker path calculation
					 whiskerpath = cSer.calculateBoxAndWhiskerPath(options,rect,options1,list2,series,point,pointIndex);					
					 options.d = whiskerpath.lowerWhisker;
  				     options.id = options.id + '_whisker';
					 cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
					 //draw upperwhisker path calculation
					 options.d = whiskerpath.upperWhisker;
					 cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
					 
					 if(series.showMedian == true)
					 {
						options.d = whiskerpath.mean;
						cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
					 }
					 
										 
					 //draw outliers
					for(var k=0;k<list2.outliers.length;k++)
					{
					    newPoint1 = {"xValue": point.xValue, "YValues": list2.outliers[k] };
					    outlierpoint = ej.EjSvgRender.utils._getPoint(newPoint1, series);
					   

					    outlierpoint.X = series._isTransposed ?  outlierpoint.X :(rect.X + (rect.Width / 2)) ;
					    outlierpoint.Y = series._isTransposed ? rect.Y + rect.Height / 2 : outlierpoint.Y;
						
						this.drawSymbol(seriesIndex, series, pointIndex, outlierpoint.X, outlierpoint.Y,null,null,trackCount);							
						trackCount++;
						//to store the outlier regions
						svgXyOutlier = ej.EjSvgRender.utils._getSvgXY(outlierpoint.X, outlierpoint.Y, series, cSer.chartObj);
						boundsOutlier = { X: svgXyOutlier.X - (series.outlierSettings.size.width/2 )   , Y: svgXyOutlier.Y - (series.outlierSettings.size.height/2) ,Width: series.outlierSettings.size.width ,Height: series.outlierSettings.size.height};
						ej.EjSvgRender.utils._addRegion(cSer.chartObj,boundsOutlier, series, point, pointIndex);
					
					}
                    svgXy = ej.EjSvgRender.utils._getSvgXY(rect.X, (rect.Y), series, cSer.chartObj);
                    bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };
                    ej.EjSvgRender.utils._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                 }
             }
         }

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

        
     },
   
   isRegion:true
 
 
 
 });
 ej.seriesTypes.boxandwhisker = ej.ejBoxandwhiskerSeries;

 ej.ejWaterfallSeries = ejExtendClass(ej.EjSeriesRender, {

     draw: function (chart, options, params) {

         ej.ejRangeColumnSeries.prototype.draw.call(this, chart, options, params);
         options.animationType = "rect";
         var chartRegions = this.chartObj.model.chartRegions;
         var seriesRegions = [];
         var areaBounds = this.chartObj.model.m_AreaBounds;
         var seriesIndex = $.inArray(options, this.chartObj.model._visibleSeries);
         options.index = seriesIndex;

         for (var j = 0, i = 0; j < chartRegions.length; j++) {
             if (seriesIndex == chartRegions[j].SeriesIndex) {
                 seriesRegions[i] = chartRegions[j];
                 i += 1;
             }
         }
         var serOptions1 = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_waterfallLine_' + seriesIndex };

         this.connectorLineGroup = this.chartObj.svgRenderer.createGroup(serOptions1);

         var sb, point1, point2, y, y1, t1, t2, lineOptions;
         for (var k = 0; k < seriesRegions.length - 1; k++) {
             sb = ej.EjSvgRender.utils._getStringBuilder();
             point1 = seriesRegions[k].Region.Bounds;
             point2 = seriesRegions[k + 1].Region.Bounds;

             if (!options.isTransposed) {
                 y1 = Math.ceil(point1.Y), h1 = Math.ceil(point1.Height), y2 = Math.ceil(point2.Y), h2 = Math.ceil(point2.Height);
                 t1 = Math.ceil(point1.Y + point1.Height);
                 y = ((y1 == y2) ? point1.Y : (t1 == y2 ? point2.Y : (point2.Y + point2.Height)));
                 sb.append("M " + (point1.X) + " " + (y) + " L " + (point2.X + point2.Width )+ " " + y);
             } else {
                 x1 = Math.ceil(point1.X), w1 = Math.ceil(point1.Width), x2 = Math.ceil(point2.X), w2 = Math.ceil(point2.Width);
                 t1 = Math.ceil(point1.X + point1.Width);
                 t2 = Math.ceil(point2.X + point2.Width);
                 x = ((t1 == t2) ? (point1.X + point1.Width) : (x1 == x2 ? point1.X : (x1 == t2 ? point1.X: (point1.X + point1.Width))));
                 sb.append("M " + (x) + " " + (point1.Y + point1.Height) + " L " + x + " " + (point2.Y));
             }

             
             lDirection = sb.toString();
             if (lDirection != "" && point1.Height >= 0) {
                 lineOptions = {
                     'id': this.chartObj.svgObject.id + "_waterFall_" + seriesIndex + "_connectorLine_" + k,
                     'fill': 'none',
                     'stroke-dasharray': options.connectorLine.dashArray,
                     'stroke-width': options.connectorLine.width,
                     'stroke': options.connectorLine.color,
                     'opacity': options.connectorLine.opacity,
                     'd': lDirection
                 };
                 this.chartObj.svgRenderer.drawPath(lineOptions, this.connectorLineGroup);
             }
         }
         this.chartObj.svgRenderer.append(this.connectorLineGroup, this.chartObj.gSeriesEle);

         if (options.enableAnimation && !options._animatedSeries)
             this.chartObj.svgRenderer._setAttr(this.connectorLineGroup, { "visibility": "hidden" });
     },

     hiloTypes: false,
     isRegion: true
 });
 ej.seriesTypes.waterfall = ej.ejWaterfallSeries;

 ej.ejStackingBarSeries = ejExtendClass(ej.EjSeriesRender, {
     
     draw: function (chart, options, params) {
         this.chartObj = chart;
		 options.animationType = "rect";
         if (options.columnFacet == "cylinder")
             options.animationType = "cylinder";
		 var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         var series = options;
		 var cornerRadius = series.cornerRadius;
         var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
         //var origin = Math.max(options.yAxis.visibleRange.min, 0);
         var sidebysideinfo = this.getSideBySideInfo(series, params);
         var visiblePoints = this._isVisiblePoints(series);
         var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);

         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };

         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         var cSer = this;
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex = i;
             var point = visiblePoints[i];
             var y1 = series.stackedValue.EndValues[i];
             var y2 =series.stackedValue.StartValues[i];
             if (point.visible) {
                 //calculate sides
                 var data = cSer.calculateSides(point, sidebysideinfo);
                 var x1 = data.x1;
                 var x2 = data.x2;
                 
				 var styleOptions = this.chartObj.setStyle(cSer, series, seriesIndex, pointIndex);

                 var rect = cSer.getRectangle(x1, y1, x2, y2, series, chart);
                 var xr = Math.min(0, rect.Width);
                 var yr = Math.min(0, rect.Height);
                 var isstacking100 = series.type == 'stackingbar100' ? true : false;
                 if (xr == 0 || yr == 0) {
                     var bounds;
                     options = {
                         'id': cSer.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex,
                         'x': rect.X + cSer.chartObj.canvasX,
                         'y': rect.Y + cSer.chartObj.canvasY,
                         'width': rect.Width,
                         'height': rect.Height,
						 'cornerRadius': cornerRadius,
                         'fill': styleOptions.interior,
                         'stroke-width': styleOptions.borderWidth,
						 'opacity': styleOptions.opacity,
						 'stroke': styleOptions.borderColor,
						 'stroke-dasharray': styleOptions.dashArray,
                     };
                     var cylinderSeriesOption = {
                         'isColumn': false,
                         'stacking': isstacking100,
                         'isLastSeries': series.stackedValue.stackedSeries,
                     };
                     if (series.columnFacet == "cylinder")
                         cSer.chartObj.svgRenderer.drawCylinder(options, cSer.gSeriesGroupEle, cylinderSeriesOption);
					 else if ((typeof(cornerRadius) != "object" && cornerRadius >0) || cornerRadius.topLeft >0 || cornerRadius.bottomLeft >0 
					        || cornerRadius.topRight >0 || cornerRadius.bottomRight >0)           //calculate path for rounded corner
					{
					     var roundrect = ej.EjSvgRender.utils._calculateroundedCorner(options);
						options.d = roundrect;
						series.animationType = "path";
						cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
					}
                     else if (series.columnFacet == "rectangle")
                     cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle);

                     var svgXy = ej.EjSvgRender.utils._getSvgXY((rect.X), (rect.Y), series, cSer.chartObj);
                     bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };

                     ej.EjSvgRender.utils._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                 }

               
                 if (!requireInvertedAxes)
                     point.symbolLocation = { X: rect.X + (rect.Width / 2), Y: ((y1 < (series.yAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.yAxis._crossValue || 0))) ? ((rect.Y) + (rect.Height)) : (rect.Y) };
                 else
                     point.symbolLocation = { X: ((y1 < (series.yAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.yAxis._crossValue || 0))) ? (rect.X) : (rect.X + rect.Width), Y: ((rect.Y) + (rect.Height / 2)) };
               
             }
         }

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);
 

     },
	 
     stackingSeries: true,
     requireInvertedAxes: true,
	  isRegion:true

 });
 ej.seriesTypes.stackingbar = ej.ejStackingBarSeries;

 ej.seriesTypes.stackingbar100 = ej.ejStackingBarSeries;

 ej.ejBarSeries = ejExtendClass(ej.EjSeriesRender, {
    
     draw: function (chart, options, params) {
         this.chartObj = chart;
		 options.animationType = "rect";
         if (options.columnFacet == "cylinder")
             options.animationType = "cylinder";
		 var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         var series = options;
		 var cornerRadius = series.cornerRadius;
         var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries);
         var origin = ej.EjSeriesRender.prototype.getOrigin(this, series, params);
         var style = $.extend(true, {}, this.chartObj.model.seriesStyle, series.style);
         var sidebysideinfo = this.getSideBySideInfo(series, params);
         if (series.dragSettings.enable) series.sidebysideInfo = sidebysideinfo;
         var visiblePoints = this._isVisiblePoints(series);
         var colors;
         var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);
         
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };

         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         var cSer = this;
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex = i;
             var point = visiblePoints[i];           
             var y1 = point.YValues[0];
             var y2 = origin;
             if (point.visible) {
                 //calculate sides
                 var data = cSer.calculateSides(point, sidebysideinfo);
                 var x1 = data.x1;
                 var x2 = data.x2;
                 
				 var styleOptions = this.chartObj.setStyle(cSer, series, seriesIndex, pointIndex);

                 var rect = cSer.getRectangle(x1, y1, x2, y2, series, chart);
                
                 var xr = Math.min(0, rect.Width);
                 var yr = Math.min(0, rect.Height);

                if (xr == 0 || yr == 0) {
                     var bounds;          
                         options = {
                             'id': cSer.chartObj.svgObject.id + '_Series' + seriesIndex+ '_Point' + pointIndex,
                             'x': rect.X + cSer.chartObj.canvasX,
                             'y': rect.Y + cSer.chartObj.canvasY,
                             'width': rect.Width,
                             'height': rect.Height,
							 'cornerRadius': cornerRadius,
                             'fill': styleOptions.interior,
                             'stroke-width': styleOptions.borderWidth,
                             'plot': y1 < 0 ? "negative" : "positive",
                             'opacity': styleOptions.opacity,
                             'stroke': styleOptions.borderColor,
                             'stroke-dasharray': styleOptions.dashArray,
                         };
                         var cylinderSeriesOption = {
                             'isColumn': false,
                             'stacking': false,
                             'isLastSeries': true,
                         };
                         if (series.columnFacet == "cylinder")
                             cSer.chartObj.svgRenderer.drawCylinder(options, cSer.gSeriesGroupEle, cylinderSeriesOption);
						 else if ((typeof(cornerRadius) != "object" && cornerRadius >0) || cornerRadius.topLeft >0 || cornerRadius.bottomLeft >0 
					             || cornerRadius.topRight >0 || cornerRadius.bottomRight >0)           //calculate path for rounded corner
						 {
						     var roundrect = ej.EjSvgRender.utils._calculateroundedCorner(options);
							options.d = roundrect;
							series.animationType = "path";
							cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
						 }
                         else if (series.columnFacet == "rectangle")
                         cSer.chartObj.svgRenderer.drawRect(options, cSer.gSeriesGroupEle);

                         var svgXy = ej.EjSvgRender.utils._getSvgXY((rect.X), (rect.Y), series, cSer.chartObj);
                        bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };
                     
                        ej.EjSvgRender.utils._addRegion(cSer.chartObj, bounds, series, point, pointIndex);
                 }


                 
                  if (!requireInvertedAxes)
                      point.symbolLocation = { X: rect.X + (rect.Width / 2), Y: ((y1 < (series.xAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.xAxis._crossValue || 0))) ? ((rect.Y) + (rect.Height)) : (rect.Y) };
                else
                    point.symbolLocation = { X: ((y1 < (series.xAxis._crossValue || 0) && !series.yAxis.isInversed) || (series.yAxis.isInversed && y1 > (series.xAxis._crossValue || 0))) ? (rect.X) : (rect.X + rect.Width), Y: ((rect.Y) + (rect.Height / 2)) };
                
             }
         }

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

        
     },
	 
     requireInvertedAxes: true,
	  isRegion:true
 });
 ej.seriesTypes.bar = ej.ejBarSeries;


 ej.ejStackingAreaSeries = ejExtendClass(ej.EjSeriesRender, {

     draw: function (chart, options) {
         this.chartObj = chart;
		 options.animationType = "path";
         var aDirection;
         var areasb = ej.EjSvgRender.utils._getStringBuilder();
         var currentSeries = options;
         var style = this.setAreaSeriesStyle(currentSeries);

         



         var visiblePoints = this._isVisiblePoints(currentSeries);
     
         var origin = Math.max(options.yAxis.visibleRange.min, currentSeries.stackedValue.StartValues[0]);
         var canvasX = this.chartObj.canvasX;
         var canvasY = this.chartObj.canvasY;

         var startPoint = { xValue: visiblePoints[0].xValue, YValues: [origin] };
         var startLoc = ej.EjSvgRender.utils._getPoint(startPoint, currentSeries), startValue = 0, endLength = currentSeries.stackedValue.EndValues.length;
         areasb.append("M" + " " + (startLoc.X + canvasX) + " " + (startLoc.Y + canvasY) + " ");
         
         //var index = $.inArray(currentSeries, this.chartObj.model._visibleSeries);
         
         for (j = 0; j <= endLength; j++) {
             if (j != endLength && visiblePoints[j].visible) {                   
                    currentPoint = { xValue: visiblePoints[j].xValue, YValues: [currentSeries.stackedValue.EndValues[j]] };                       
                    if (visiblePoints[j].visible) {
                         point1 = visiblePoints[j].location = ej.EjSvgRender.utils._getPoint(currentPoint, currentSeries);                          
                         areasb.append("L" + " " + (point1.X + canvasX) + " " + ((point1.Y + canvasY)) + " ");
                         visiblePoints[j].YValues[0] = currentPoint.YValues[0];
                     }                    
                
             }
             else {
                 origin = currentSeries.stackedValue.StartValues[j + 1];
                 for (var i = j - 1; i >= startValue; i--) {
                     currentPoint = { xValue: visiblePoints[i].xValue, YValues: [currentSeries.stackedValue.StartValues[i]] };
                     point1 = ej.EjSvgRender.utils._getPoint(currentPoint, currentSeries);
                     areasb.append("L" + " " + (point1.X + canvasX) + " " + ((point1.Y + canvasY)) + " ");
                 }
                 if (visiblePoints[j + 1] && visiblePoints[j + 1].visible) {
                     var startPoint = { xValue: visiblePoints[j + 1].xValue, YValues: [currentSeries.stackedValue.StartValues[j + 1]] };
                     var startLoc = ej.EjSvgRender.utils._getPoint(startPoint, currentSeries);
                     areasb.append("M" + " " + (startLoc.X + canvasX) + " " + (startLoc.Y + canvasY) + " ");                    
                 }
                  startValue = j + 1;
             }
         }            
              
      
                

         aDirection = areasb.toString();

         this.drawAreaPath(currentSeries, style, aDirection);

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

          


     },
	 
     stackingSeries:true

 });
 ej.seriesTypes.stackingarea = ej.ejStackingAreaSeries;

 ej.seriesTypes.stackingarea100 = ej.ejStackingAreaSeries;

 ej.ejAreaSeries = ejExtendClass(ej.EjSeriesRender, {

  
     draw: function (chart,options, params) {
         this.chartObj = chart;
         var aDirection;
		 options.animationType = "path";
         var areasb = ej.EjSvgRender.utils._getStringBuilder();
         var currentSeries = options;
         var style = this.setAreaSeriesStyle(currentSeries);
         var chartObj = this.chartObj;
         if (currentSeries.sorting)
         	currentSeries.points = ej.DataManager(currentSeries.points, ej.Query().sortBy("xValue")).executeLocal();
      
         var visiblePoints = this.chartObj.dragPoint? currentSeries.pointCollection : this._isVisiblePoints(currentSeries);
         var origin = ej.EjSeriesRender.prototype.getOrigin(this, currentSeries, params);
         
         var startPoint;
         var translate = [];
         translate[0] = chartObj.canvasX;
         translate[1] = chartObj.canvasY;
         if(visiblePoints.length>0) { 
         for (var i = 0; i < visiblePoints.length; i++) {
             if (visiblePoints[i].visible) {
                 if (visiblePoints.length > i + 1) {
                     if (!startPoint) {
                         startPoint = { xValue: visiblePoints[i].xValue, YValues: [origin] }
                         var point1 = ej.EjSvgRender.utils._getPoint(startPoint, currentSeries);
                         areasb.append("M" + " " + (point1.X) + " " + ((point1.Y)) + " ");
                     }


                     var point1 = ej.EjSvgRender.utils._getPoint(visiblePoints[i], currentSeries);

                     areasb.append("L" + " " + (point1.X) + " " + ((point1.Y)) + " ");

                     if (!visiblePoints[i + 1].visible) {
                         point = { xValue: visiblePoints[i].xValue, YValues: [origin] }
                         var point2 = ej.EjSvgRender.utils._getPoint(point, currentSeries);
                         var point3 = ej.EjSvgRender.utils._getPoint(startPoint, currentSeries);
                         areasb.append("L" + " " + (point2.X) + " " + ((point2.Y)) + " " + "L" + " " + (point3.X) + " " + ((point3.Y)) + " ");
                         startPoint = null;
                     }
                 }
                 else {
                     if (visiblePoints[i - 1] && visiblePoints[i - 1].visible) {
                         var point1 = ej.EjSvgRender.utils._getPoint(visiblePoints[i], currentSeries);
                         areasb.append("L" + " " + (point1.X) + " " + ((point1.Y)) + " ");
                     }
                 }
             }         
         }

         var endPoint = { xValue: visiblePoints[visiblePoints.length - 1].xValue, YValues: [origin] };
         var endLoc = ej.EjSvgRender.utils._getPoint(endPoint, currentSeries);
         if (visiblePoints.length > 1)
             areasb.append("L" + " " + (endLoc.X) + " " + ((endLoc.Y)) + " ");
         
         aDirection = areasb.toString();

         this.drawAreaPath(currentSeries, style, aDirection, translate);
         }
         if (this.chartObj.dragPoint)
             this.chartObj.svgRenderer.append(this.chartObj.gPreviewSeriesGroupEle, this.chartObj.gSeriesEle);
         else
            this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

     
       

     }

 });

 ej.seriesTypes.area = ej.ejAreaSeries;

 ej.ejRangeAreaSeries = ejExtendClass(ej.EjSeriesRender, {


     draw: function (chart, options) {
         this.chartObj = chart;
         var aDirection;
		 options.animationType = "path";
         var areasb = ej.EjSvgRender.utils._getStringBuilder();
         var currentSeries = options;
         var style = this.setAreaSeriesStyle(currentSeries);
         var seriesIndex = $.inArray(currentSeries, this.chartObj.model._visibleSeries);
         currentSeries.points = ej.DataManager(currentSeries.points, ej.Query().sortBy("xValue")).executeLocal();

         var visiblePoints = this._isVisiblePoints(currentSeries);        
         var translate = [];
         translate[0] = this.chartObj.canvasX;
         translate[1] = this.chartObj.canvasY;
         var startPoint;
         var internalRegion=[]
         for (var i = 0; i < visiblePoints.length; i++) {
             internalRegion[i] = {Region:{PointIndex:i}, SeriesIndex:seriesIndex, region:[]};
             if (visiblePoints[i].visible) {     
                     if (!startPoint) {
                         var origin = visiblePoints[i].low;
                         startPoint = { xValue: visiblePoints[i].xValue, YValues: [origin] }
                         var point1 = ej.EjSvgRender.utils._getPoint(startPoint, currentSeries);
                         areasb.append("M" + " " + (point1.X) + " " + ((point1.Y)) + " ");
                     }
                 var point1 = ej.EjSvgRender.utils._getPoint(visiblePoints[i], currentSeries);
                 areasb.append("L" + " " + (point1.X) + " " + ((point1.Y)) + " ");
                 internalRegion[i].region.push({ X: point1.X, Y: point1.Y });
                 if (i != 0)
                     internalRegion[i - 1].region.push({ X: point1.X, Y: point1.Y });
                 
                 if( (i +1 ) < visiblePoints.length &&  !visiblePoints[i+1].visible)
                 {
                     for (var j = i; j >=0; j--)
                     {
                         if (visiblePoints[j].visible) {
                             origin = visiblePoints[j].low;
                             var point = { xValue: visiblePoints[j].xValue, YValues: [origin] };
                             var point2 = ej.EjSvgRender.utils._getPoint(point, currentSeries);
                             areasb.append("L" + " " + (point2.X) + " " + ((point2.Y)) + " ");
                             internalRegion[j].region.push({ X: point2.X, Y: point2.Y });
                             if(j!=0)
                                 internalRegion[j - 1].region.push({ X: point2.X, Y: point2.Y });
                         }
                         else
                             break;
                     }
                     startPoint = null;
                 }

              
             }
         }
         for (var i = visiblePoints.length-1; i >= 0; i--)
         {
             if (visiblePoints[i].visible)
             {
                 origin = visiblePoints[i].low;
                 var point = { xValue: visiblePoints[i].xValue, YValues: [origin] };
                 var point2 = ej.EjSvgRender.utils._getPoint(point, currentSeries);
                 areasb.append("L" + " " + (point2.X) + " " + ((point2.Y)) + " ");
                 internalRegion[i].region.push({ X: point2.X, Y: point2.Y });
                 if(i!=0)
                     internalRegion[i - 1].region.push({ X: point2.X, Y: point2.Y });

             }
             else if (visiblePoints.length>i && visiblePoints[i].visible)
             {
                 var point2 = ej.EjSvgRender.utils._getPoint(visiblePoints[i], currentSeries);
                 areasb.append("L" + " " + (point2.X) + " " + ((point2.Y)) + " ");
                 break;
             }                       
             else if (i != (visiblePoints.length - 1))
			  {
                 var count=0;
                 for(k=i-1;k>=0;k--)
                 {
                     if (visiblePoints[k].visible)
                        count++;
                     else if (!visiblePoints[k].visible)
                        break;
                 }
                 i = i - count;
             }
         }     
         aDirection = areasb.toString();
         this.chartObj.model.chartRegions.push(internalRegion);

         this.drawAreaPath(currentSeries, style, aDirection, translate);
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);
     },

     hiloTypes:true

 });

 ej.seriesTypes.rangearea = ej.ejRangeAreaSeries;

 ej.ejSplineSeries = ejExtendClass(ej.EjSeriesRender, {
    
     draw: function (chart,options, params) {
		 if(!params.seriesCollection)
		 {			
			params.seriesCollection = {  };
			options._name = ej.util.isNullOrUndefined(options.name) ? "" : options.name.replace(/ /g,'');
         }
		 if(!params.seriesCollection[options._name])
			params.seriesCollection[options._name] = {};
         this.chartObj = chart;
		 options.animationType = "path";
         var series = options,
			spDirection = "",
            splinesb = ej.EjSvgRender.utils._getStringBuilder(),
            style = this.setLineSeriesStyle(series),
            yIndex = 0,
            visiblePoints = this.chartObj.dragPoint? series.pointCollection : this._isVisiblePoints(series),
            ySpline = params.seriesCollection[series._name].naturalSpline || this.naturalSpline(visiblePoints),
            firstPoint = null,
            secondPoint = null,
            firstIndex = -1, controlPointsCount = 0,
			controlPoints = params.seriesCollection[series._name].controlPoints || [];
			
		 //Removed spline sorting behavior based on the 'X' points.
         //series.points = ej.DataManager(series.points, ej.Query().sortBy("X")).executeLocal();
         
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex = i;
             secondPoint = visiblePoints[i];             
             if (secondPoint.visible) {
                 if (firstPoint != null) {
                     var controlPoint1 = null;
                     var controlPoint2 = null;
                     var data = controlPoints[controlPointsCount++] || this.getBezierControlPoints(firstPoint, secondPoint, ySpline[firstIndex], ySpline[pointIndex], yIndex);
                     controlPoint1 = data["controlPoint1"];
                     controlPoint2 = data["controlPoint2"];
                     var pt1 = ej.EjSvgRender.utils._getPoint(firstPoint, series);
                     var pt2 = ej.EjSvgRender.utils._getPoint(secondPoint, series);
                     var bpt1 = ej.EjSvgRender.utils._getPoint(controlPoint1, series);
                     var bpt2 = ej.EjSvgRender.utils._getPoint(controlPoint2, series);
                     var chartObj = this.chartObj;
                     splinesb.append("M" + " " + (pt1.X + chartObj.canvasX) + " " + (pt1.Y + chartObj.canvasY) + " " + "C" + " " + (bpt1.X + chartObj.canvasX) + " " + (bpt1.Y + chartObj.canvasY) + " " + (bpt2.X + chartObj.canvasX) + " " + (bpt2.Y + chartObj.canvasY) + " " + (pt2.X + chartObj.canvasX) + " " + (pt2.Y + chartObj.canvasY) + " ");

                 }
                 firstPoint = secondPoint;
                 firstIndex = pointIndex;
             } else {
                 firstPoint = null;
             }
         }
         
        spDirection = splinesb.toString();
        this._drawLinePath(series, style, spDirection);
        if (this.chartObj.dragPoint)
            this.chartObj.svgRenderer.append(this.chartObj.gPreviewSeriesGroupEle, this.chartObj.gSeriesEle);
         else
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

     }

 });

 ej.seriesTypes.spline = ej.ejSplineSeries;

 ej.ejSplineAreaSeries = ejExtendClass(ej.EjSeriesRender, {


     draw: function (chart, options, params) {
		 if(!params.seriesCollection)
		 {
			params.seriesCollection = {  };
			options._name = ej.util.isNullOrUndefined(options.name) ? "" : options.name.replace(/ /g,'');
         }
		 if(!params.seriesCollection[options._name])
			params.seriesCollection[options._name] = {};
         this.chartObj = chart;
		 options.animationType = "path";
		 var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         var series = options;
         var spDirection = "";
         var splinesb = ej.EjSvgRender.utils._getStringBuilder();
         var style = this.setAreaSeriesStyle(series);
         var yIndex = 0;
         //Removed splineArea sorting behavior based on the 'X' points.
         if (series.sorting)
         	series.points = ej.DataManager(series.points, ej.Query().sortBy("xValue")).executeLocal();
         var visiblePoints = this.chartObj.dragPoint? series.pointCollection : this._isVisiblePoints(series);
         var ySpline = params.seriesCollection[series._name].naturalSpline || this.naturalSpline(visiblePoints);
         var firstPoint = null;
         var secondPoint = null;
         var firstIndex = -1;
		
         var origin = ej.EjSeriesRender.prototype.getOrigin(this, series, params);
         var startPoint = null;
         var start = true;
         var chartObj = this.chartObj;
         var translate = [], controlPointsCount = 0, controlPoints = params.seriesCollection[series._name].controlPoints || [];
         translate[0] = chartObj.canvasX;
         translate[1] = chartObj.canvasY;
         var count = 0;
         for (var i = 0; i < visiblePoints.length; i++) {
             var pointIndex = i;
             secondPoint = visiblePoints[i];
             if (secondPoint.visible) {
                 if (!startPoint) {
                     startPoint = { xValue: visiblePoints[i].xValue, YValues: [origin] };
                     var startLoc = ej.EjSvgRender.utils._getPoint(startPoint, series);
                    }
                 if (firstPoint != null) {
                     var controlPoint1 = null;
                     var controlPoint2 = null;
                     var data = controlPoints[controlPointsCount++] || this.getBezierControlPoints(firstPoint, secondPoint, ySpline[firstIndex], ySpline[pointIndex], yIndex);
                     controlPoint1 = data["controlPoint1"];
                     controlPoint2 = data["controlPoint2"];
                     var pt1 = ej.EjSvgRender.utils._getPoint(firstPoint, series);
                     var pt2 = ej.EjSvgRender.utils._getPoint(secondPoint, series);
                     var bpt1 = ej.EjSvgRender.utils._getPoint(controlPoint1, series);
                     var bpt2 = ej.EjSvgRender.utils._getPoint(controlPoint2, series);
                     if (start) {
                         if (requireInvertedAxes)
                             splinesb.append("M" + " " + (startLoc.X) + " " + (pt1.Y) + " " + "L" + " " + (pt1.X) + " " + ((pt1.Y)) + " ");
                         else
                             splinesb.append("M" + " " + (pt1.X) + " " + (startLoc.Y) + " " + "L" + " " + (pt1.X) + " " + ((pt1.Y)) + " ");
                         start = false;
                     }
                     splinesb.append("C" + " " + (bpt1.X) + " " + (bpt1.Y) + " " + (bpt2.X) + " " + (bpt2.Y) + " " + (pt2.X) + " " + (pt2.Y) + " ");
                     if (pointIndex == visiblePoints.length - 1 || (pointIndex < visiblePoints.length - 1 && !visiblePoints[i + 1].visible)) {
                        if (requireInvertedAxes)
                            splinesb.append("L" + " " + (startLoc.X) + " " + (pt2.Y) + " ");
                         else
                            splinesb.append("L" + " " + (pt2.X) + " " + (startLoc.Y) + " ");
                         startPoint = null;
                         start = true;
                     }
                 }
                 firstPoint = secondPoint;
                 firstIndex = pointIndex;
             } else {
                 firstPoint = null;
             }
         }

         spDirection = splinesb.toString();

         this.drawAreaPath(series, style, spDirection, translate);
         if (this.chartObj.dragPoint)
             this.chartObj.svgRenderer.append(this.chartObj.gPreviewSeriesGroupEle, this.chartObj.gSeriesEle);
         else
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

     }
 });

 ej.seriesTypes.splinearea = ej.ejSplineAreaSeries;



 ej.ejScatterSeries = ejExtendClass(ej.EjSeriesRender, {

        
    
     draw: function (chart,options) {
         this.chartObj = chart;
         var series = options;
		 options.animationType = "scatter";
		 var seriesIndex = $.inArray(options, this.chartObj.model._visibleSeries);
        var visiblePoints = this._isVisiblePoints(series);
		 var visiblePointsLength=visiblePoints.length;
		 var point,point1;
        for (var i = 0; i < visiblePointsLength; i++)
        {
            point = visiblePoints[i];
            var pointIndex = i;
            point1 = ej.EjSvgRender.utils._getPoint(point, options);
            this.drawSymbol(seriesIndex, options, pointIndex, point1.X, point1.Y);
        }

     }
 });

 ej.seriesTypes.scatter = ej.ejScatterSeries;

 
 ej.ejBubbleSeries = ejExtendClass(ej.EjSeriesRender, {

     createBubbleGroup: function(series) {

         var seriesIndex = $.inArray(series, this.chartObj.model.series);
		 var areaBoundsX = this.chartObj.model.m_AreaBounds.X;
		 var areaBoundsY = this.chartObj.model.m_AreaBounds.Y;
	     var isTransposed =  series._isTransposed;
         var transX = isTransposed? areaBoundsX:series.xAxis.x;

         var transY = isTransposed ? areaBoundsY : series.yAxis.y;
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + transX + ',' + transY + ')' };

         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);

     },
     draw: function (chart,options) {
         this.chartObj = chart;
		 options.animationType = "bubble";
         var series = options;    
		 var cornerRadius = series.cornerRadius;
         series.points = ej.DataManager(series.points, ej.Query().sortBy("xValue")).executeLocal();
         var seriesIndex = $.inArray(series, this.chartObj.model._visibleSeries); 
         var visiblePoints = this._isVisiblePoints(series);
         var sizeValueIndex = 1;
		 //bubble responsive
         var bubbleOptions = options.bubbleOptions;
		 var mode = bubbleOptions.radiusMode.toLowerCase();
         var temp = 100, minRadius, maxRadius;
         var areaBounds = chart.model.m_AreaBounds;
		 var visibleSeries = chart.model._visibleSeries, maximumSize = 0;
		 var value = Math.max(areaBounds.Height, areaBounds.Width);
		 var segmentRadius, radius, percentChange;
		 
		if (mode == "minmax"){  // minmax mode radius calculation
			percentChange = value/temp;
			minRadius = bubbleOptions.minRadius * percentChange;
	        maxRadius = bubbleOptions.maxRadius * percentChange;
			radius = maxRadius - minRadius;
			maximumSize = Math.max.apply(0,$.map(visiblePoints,function (v) { return v.YValues[sizeValueIndex]; }));
		} else {    // auto mode radius calculation
			maxValue = (value/5) /2;
			minRadius = maxRadius = 1;
			radius = maxValue * maxRadius;		
			for (m= 0; m < visibleSeries.length; m++){
				if (visibleSeries[m].type.toLowerCase() == "bubble" && visibleSeries[m].visibility == "visible" 
					&& visibleSeries[m].bubbleOptions.radiusMode.toLowerCase() == "auto"){
					points = visibleSeries[m]._visiblePoints;
					for (n= 0; n < points.length; n++)
						maximumSize = maximumSize < points[n].YValues[sizeValueIndex] ? points[n].YValues[sizeValueIndex] : maximumSize;
				}
			}
		}
         this.createBubbleGroup(series);
         for (var i = 0; i < visiblePoints.length; i++) {
             var point = visiblePoints[i];
             var pointIndex= i;
             if (point.visible) {
				 if (series.bubbleOptions.radiusMode.toLowerCase() == "minmax")
					segmentRadius = minRadius + radius * Math.abs(point.YValues[sizeValueIndex] / maximumSize);
				 else
					segmentRadius = radius * Math.abs(point.YValues[sizeValueIndex] / maximumSize);
					
                 var location = ej.EjSvgRender.utils._getPoint(point, series);
                 
				 var styleOptions = this.chartObj.setStyle(this, series, seriesIndex, pointIndex);
				 
                 var options = {
                     'id': this.chartObj.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex,
                     'cx': location.X + this.chartObj.canvasX,
                     'cy': (location.Y) + this.chartObj.canvasY,
                     'r': segmentRadius,
                         'fill': styleOptions.interior,
						 'cornerRadius': cornerRadius,
                         'stroke-width': styleOptions.borderWidth,
                     'stroke-dasharray': styleOptions.dashArray,
                     'opacity': styleOptions.opacity,
                     'stroke': styleOptions.borderColor
                     };
					 if ((typeof(cornerRadius) != "object" && cornerRadius >0) || cornerRadius.topLeft >0 || cornerRadius.bottomLeft >0 
					    || cornerRadius.topRight >0 || cornerRadius.bottomRight >0)           //calculate path for rounded corner
					{
						var roundrect=ej.EjSvgRender.utils.calculateroundedCorner(options);
						options.d = roundrect;
						cSer.chartObj.svgRenderer.drawPath(options,cSer.gSeriesGroupEle);
					}
					else

                 point.radius = segmentRadius; // radius is stored to draw tracksymbol for bubble in canvas
                 
                 this.chartObj.svgRenderer.drawCircle(options, this.gSeriesGroupEle);
				 
			 

                 var cx = location.X;
                 var cy = location.Y;
                 var r = segmentRadius;


                 var valwidth, x, y, valheight;
                 x = ((cx - r) + (series.isTransposed ? this.chartObj.model.m_AreaBounds.X :series.xAxis.x));
                 y = ((cy - r) + (series.isTransposed ? this.chartObj.model.m_AreaBounds.Y : series.yAxis.y));

                 valheight = 2 * r;
                 valwidth = 2 * r;

                 var bounds = { X: x, Y: y, Width: valwidth, Height: valheight };
                 ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, series, null, i);
             }
         }
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

     }
 });

ej.seriesTypes.bubble = ej.ejBubbleSeries;
 ej.ejhiloSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options, params) {

         this.chartObj = chart;
		 options.animationType = "hilo";
         var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         //DrawHiloGraph      
        
         var currentseries = options;
          currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();
         var visiblePoints = this._isVisiblePoints(currentseries);
         var sidebysideinfo = this.getSideBySideInfo(currentseries, params);
         var point = null;
         
         var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
         var trans = ej.EjSvgRender.utils._getTransform(currentseries.xAxis, currentseries.yAxis, requireInvertedAxes);
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
       

         for (var i = 0; i < visiblePoints.length; i++) {
             point = visiblePoints[i];
			 var pointIndex= i;
             if (point.visible) {
                
                 var lDirection = "";
                    if (ej.util.isNullOrUndefined(point.YValues[0]) || ej.util.isNullOrUndefined(point.YValues[1]))
                     continue;
					 
                    var styleOptions = this.chartObj.setStyle(this, currentseries, seriesIndex, pointIndex);

                    var pathInterior = this.chartObj.setHiloStyle(currentseries, pointIndex, seriesIndex);
              
				 
                 var lowvalue = {}, highvalue = {};
                 if (point.YValues[0] < point.YValues[1]) {
                     lowvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[0]] };
                     highvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[1]] };
                 } else {
                     lowvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[1]] };
                     highvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[0]] };
                 }
                 var point1 = ej.EjSvgRender.utils._getPoint(lowvalue   , currentseries);
                 var point2 = ej.EjSvgRender.utils._getPoint(highvalue, currentseries);
                 lDirection = "M" + " " + (point1.X + this.chartObj.canvasX) + " " + ((point1.Y + this.chartObj.canvasY)) + " " + "L" + " " + (point2.X + this.chartObj.canvasX) + " " + ((point2.Y + this.chartObj.canvasY)) + " ";
                 var pointbounds = { point1:point1, point2:point2 };
                 this._drawHiloPath(currentseries, styleOptions, pathInterior, lDirection, i, pointbounds);
             }
         }
        
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);
     },
     
     hiloTypes: true
 });

 ej.seriesTypes.hilo = ej.ejhiloSeries;
 
 //Draw HiloOpenClose
 ej.ejhiloopencloseSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options, params) {

         this.chartObj = chart;
         var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         //DrawHiloGraph      
         options.animationType = "hilo";
         var currentseries = options;
         currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();
         var visiblePoints = this._isVisiblePoints(currentseries);
         var sidebysideinfo = this.getSideBySideInfo(currentseries, params);
         var point = null;
		 var paletteColor = this.chartObj.model.palette;
         var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
         var trans = ej.EjSvgRender.utils._getTransform(currentseries.xAxis, currentseries.yAxis, requireInvertedAxes);
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         
         var interior;

     


         for (var i = 0; i < visiblePoints.length; i++) {
		    var pointIndex = i;
             point = visiblePoints[i];
             if (point.visible) {

                 var lDirection = "";
                 var drawOpenWing = (ej.util.isNullOrUndefined(currentseries.drawMode) ? true : (currentseries.drawMode.toLowerCase() == "both" || currentseries.drawMode.toLowerCase() == "open") ? true : false);
                 var drawCloseWing = (ej.util.isNullOrUndefined(currentseries.drawMode) ? true : (currentseries.drawMode.toLowerCase() == "both" || currentseries.drawMode.toLowerCase() == "close") ? true : false);

                
                 var lowvalue = {}, highvalue = {}, openvalue = {}, closevalue = {};
                  
                    
                 if (point.YValues[0] < point.YValues[1]) {
                     lowvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[0]] };
                     highvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[1]] };
                     openvalue = { xValue: point.xValue, YValues: [point.YValues[2]] };
                     closevalue = { xValue: point.xValue, YValues: [point.YValues[3]] };
                     
                 } else {
                     lowvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[1]] };
                     highvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[0]] };
                     openvalue = { xValue: point.xValue, YValues: [point.YValues[2]] };
                     closevalue = { xValue: point.xValue, YValues: [point.YValues[3]] };
                    
                 }
				 currentseries.fill = currentseries.isFill ? currentseries.fill : null;
                 if (point.YValues[2] < point.YValues[3]) 
                     currentseries.bearFillColor = interior = (ej.util.isNullOrUndefined(currentseries.bearFillColor)) ? ((currentseries.fill) ? currentseries.fill : ((paletteColor && paletteColor.length > 0 )? paletteColor[seriesIndex] : "#339933")) : currentseries.bearFillColor;
                 
                 else 
                     currentseries.bullFillColor = interior = (ej.util.isNullOrUndefined(currentseries.bullFillColor)) ? ((currentseries.fill) ? currentseries.fill : ((paletteColor && paletteColor.length > 0) ? paletteColor[seriesIndex] : "#E51400")) : currentseries.bullFillColor;
                    
				 
                 var styleOptions = this.chartObj.setStyle(this, currentseries, seriesIndex, pointIndex, interior);

                 var pathInterior = this.chartObj.setHiloStyle(currentseries, pointIndex,seriesIndex, interior);
                 

				 if (point.fill) {
                     interior = jQuery.type(point.interior) == "array" ? point.fill[0] : point.fill;
                 }
                 else {
                      point._hiloFill = interior;
                 }
				 var canvasX = this.chartObj.canvasX;
				 var canvasY = this.chartObj.canvasY;
                 
                 //Draw open points
                 if (drawOpenWing) {

                     var startOpenValue = { xValue: openvalue.xValue + sidebysideinfo.Median, YValues: openvalue.YValues };
                     var pto1 = ej.EjSvgRender.utils._getPoint(startOpenValue, currentseries);
                     var endOpenValue = { xValue: openvalue.xValue + sidebysideinfo.Start, YValues: openvalue.YValues };
                     var pto2 = ej.EjSvgRender.utils._getPoint(endOpenValue, currentseries);
                      lDirection = "M" + " " + (pto1.X + canvasX) + " " + ((pto1.Y + canvasY)) + " " + "L" + " " + (pto2.X + canvasX) + " " + ((pto2.Y + canvasY)) + " ";
                     var openbounds = { point1: pto1, point2: pto2 };
                     this._drawHiloPath(currentseries, styleOptions,pathInterior,  lDirection, i, openbounds);
                     lDirection = "";

                 }
                 //Draw close points
                 if (drawCloseWing) {
                     var startCloseValue = { xValue: closevalue.xValue + sidebysideinfo.Median, YValues: closevalue.YValues };
                     var ptc1 = ej.EjSvgRender.utils._getPoint(startCloseValue, currentseries);
                     var endCloseValue = { xValue: closevalue.xValue + sidebysideinfo.End, YValues: closevalue.YValues };
                     var ptc2 = ej.EjSvgRender.utils._getPoint(endCloseValue, currentseries);
                     lDirection = "M" + " " + (ptc1.X + canvasX) + " " + ((ptc1.Y + canvasY)) + " " + "L" + " " + (ptc2.X + canvasX) + " " + ((ptc2.Y + canvasY)) + " ";
                     var pointbounds = { point1: ptc1, point2: ptc2 };
                     this._drawHiloPath(currentseries, styleOptions, pathInterior, lDirection, i, pointbounds);
                     lDirection = "";

                 }
                 // Draw High low points
                 var point1 = ej.EjSvgRender.utils._getPoint(lowvalue, currentseries);
                 var point2 = ej.EjSvgRender.utils._getPoint(highvalue, currentseries);
                 lDirection = "M" + " " + (point1.X + canvasX) + " " + ((point1.Y + canvasY)) + " " + "L" + " " + (point2.X + canvasX) + " " + ((point2.Y + canvasY)) + " ";
                 var bounds = { point1: point1, point2: point2 };
                 this._drawHiloPath(currentseries, styleOptions, pathInterior, lDirection, i, bounds);
             }

         }
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);
     
     },

     hiloTypes: true

 });

 ej.seriesTypes.hiloopenclose = ej.ejhiloopencloseSeries;
 
 //Draw candle
ej.ejCandleSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options, params) {

         this.chartObj = chart;
		 options.animationType = "hilo";
         var requireInvertedAxes = this.chartObj.model.requireInvertedAxes;
         //DrawCandleGraph      

         var currentseries = options;
         currentseries.points = ej.DataManager(currentseries.points, ej.Query().sortBy("xValue")).executeLocal();
         var visiblePoints = this._isVisiblePoints(currentseries);
         var sidebysideinfo = this.getSideBySideInfo(currentseries, params);
         var point = null;
		 var paletteColor = this.chartObj.model.palette;
         var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
         var trans = ej.EjSvgRender.utils._getTransform(currentseries.xAxis, currentseries.yAxis, requireInvertedAxes);
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);
         var interior;

         for (var i = 0; i < visiblePoints.length; i++) {
             point = visiblePoints[i];
			  var pointIndex= i;
             if (point.visible) {

                 var lDirection = "";
               
                 var lowvalue = {}, highvalue = {}, openvalue = {}, closevalue = {};
                 
                
                 if (point.YValues[0] < point.YValues[1]) {
                     lowvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[0]] };
                     highvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[1]] };
                     openvalue = { xValue: point.xValue, YValues: [point.YValues[2]] };
                     closevalue = { xValue: point.xValue, YValues: [point.YValues[3]] };
                     
                 } else {
                     lowvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[1]] };
                     highvalue = { xValue: point.xValue + sidebysideinfo.Median, YValues: [point.YValues[0]] };
                     openvalue = { xValue: point.xValue, YValues: [point.YValues[2]] };
                     closevalue = { xValue: point.xValue, YValues: [point.YValues[3]] };
                     
                 }      
                 if (point.YValues[2] < point.YValues[3]) {
                     
                     openvalue = { xValue: point.xValue, YValues: [point.YValues[2]] };
                     closevalue = { xValue: point.xValue, YValues: [point.YValues[3]] };
                     currentseries.bearFillColor = interior = (ej.util.isNullOrUndefined(currentseries.bearFillColor)) ? ( (paletteColor && paletteColor.length > 0 ) ? paletteColor[seriesIndex] : "#339933") : currentseries.bearFillColor;
                     
                 } else {
                    
                     openvalue = { xValue: point.xValue, YValues: [point.YValues[3]] };
                     closevalue = { xValue: point.xValue, YValues: [point.YValues[2]] };
                     currentseries.bullFillColor = interior = (ej.util.isNullOrUndefined(currentseries.bullFillColor)) ? ( (paletteColor && paletteColor.length > 0) ? paletteColor[seriesIndex]:"#E51400") : currentseries.bullFillColor;
                    
                 }
                 
                 var styleOptions = this.chartObj.setStyle(this, currentseries, seriesIndex, pointIndex, interior);

                 var pathInterior = this.chartObj.setHiloStyle(currentseries, pointIndex,seriesIndex, interior);
				 
				 if (point.style && point.style.interior) {
                     interior = jQuery.type(point.style.interior) == "array" ? point.style.interior[0] : point.style.interior;
                 }
               
                 else {
                     point._hiloFill = pathInterior;
                 }

                 //Draw High low points
				 var point1 = ej.EjSvgRender.utils._getPoint(lowvalue, currentseries);
				 var point2 = ej.EjSvgRender.utils._getPoint({ xValue: openvalue.xValue + sidebysideinfo.Median, YValues: [openvalue.YValues[0]] }, currentseries);
				 var point3 = ej.EjSvgRender.utils._getPoint({ xValue: closevalue.xValue + sidebysideinfo.Median, YValues: [closevalue.YValues[0]] }, currentseries);
                 var point4 = ej.EjSvgRender.utils._getPoint(highvalue, currentseries);
                 var canvasX = this.chartObj.canvasX;
                 var canvasY = this.chartObj.canvasY;
                 lDirection = "M" + " " + (point1.X + canvasX) + " " + ((point1.Y + canvasY)) + " " + "L" + " " + (point2.X + canvasX) + " " + ((point2.Y + canvasY)) + " " + "M" + " " + (point3.X + canvasX) + " " + ((point3.Y + canvasY)) + " " + "L" + " " + (point4.X + canvasX) + " " + ((point4.Y + canvasY)) + " ";
                 var pointbounds = { point1: point1, point2: point2 };
                 this._drawHiloPath(currentseries, styleOptions, pathInterior, lDirection, i, pointbounds);
                 //Draw open and close points
              
                 var startRect = { xValue: closevalue.xValue + sidebysideinfo.Start, YValues: closevalue.YValues };
                     var orginRect = ej.EjSvgRender.utils._getPoint(startRect, currentseries);

                     var rectSize = { xValue: openvalue.xValue + sidebysideinfo.End, YValues: openvalue.YValues },
                      sizeRect = ej.EjSvgRender.utils._getPoint(rectSize, currentseries),
                      rect = ej.EjSvgRender.utils._correctRect(orginRect.X, orginRect.Y, sizeRect.X, sizeRect.Y);
                  
                     var candleOptions = {
                        'id': this.chartObj.svgObject.id + '_Series' + seriesIndex+ '_Point' + i,
                        'x': rect.X + this.chartObj.canvasX,
                        'y': rect.Y + this.chartObj.canvasY,
                         'width': rect.Width,
                         'height': rect.Height,
                         'fill': styleOptions.interior,
                         'stroke-width': styleOptions.borderWidth,
                        'stroke-dasharray': styleOptions.dashArray,
                         'stroke': styleOptions.borderColor
                     };

                    this.chartObj.svgRenderer.drawRect(candleOptions, this.gSeriesGroupEle);

                    var svgXy = ej.EjSvgRender.utils._getSvgXY(rect.X, rect.Y, currentseries, this.chartObj);
                    var bounds = { X: svgXy.X, Y: svgXy.Y, Width: rect.Width, Height: rect.Height };

                    ej.EjSvgRender.utils._addRegion(this.chartObj, bounds, currentseries, point, i);
                                    
             }
             
         }
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);
        

     },
     
     hiloTypes: true
 });
 ej.seriesTypes.candle = ej.ejCandleSeries;

 ej.ejPieOfPieSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options) {
         this.chartObj = chart;
         var series = new ej.seriesTypes["pie"]();
         series.draw(chart, options);
     },
     chartAreaType: "None"
 });
 ej.seriesTypes.pieofpie = ej.ejPieOfPieSeries;

 ej.ejPieSeries = ejExtendClass(ej.EjSeriesRender, {

     draw: function (chart, options) {

         this.chartObj = chart;
         var currentseries = options;
         var internalRegion = [];
         var seriesType = options.type.toLowerCase();
         var pieSeriesIndex = options.collectionIndex;
         var coefficient = pieSeriesIndex == 0 ? currentseries.pieCoefficient : currentseries.pieOfPieCoefficient;
         var visiblePoints = this._calculateVisiblePoints(options,this.chartObj).visiblePoints;
        
         var size = this.calculatingSliceAngle(currentseries);                  
         var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
         var seriesLength = this.chartObj.model._visibleSeries.length;

         var currentSeries = this.chartObj.model._visibleSeries[seriesIndex];
        		currentSeries._pieCoefficient =  currentSeries.pieCoefficient;
        		if(this.chartObj.model.circularRadius.length>1){
        		    for (i = seriesIndex;!ej.util.isNullOrUndefined(currentSeries.zOrder) ? i >= 0 : i < this.chartObj.model.circularRadius.length; !ej.util.isNullOrUndefined(currentSeries.zOrder) ? i-- : i++) {
        		        if (!ej.util.isNullOrUndefined(this.chartObj.model.circularRadius[i])) {
        		            this.chartObj.model.circularRadius[seriesIndex] = this.chartObj.model.circularRadius[i] * currentSeries._pieCoefficient;
        		            break;
        		        }
        		    }
        		}
        		else {
        		    if (seriesType == "pieofpie" && currentSeries.splitMode != "") 
        		        this.chartObj.model.circularRadius[pieSeriesIndex] = 0.25 * coefficient * Math.min(size.width, size.height);       		       
        		    else
        		        this.chartObj.model.circularRadius[seriesIndex] = 0.5 * currentSeries._pieCoefficient * Math.min(size.width, size.height);
        		}
        		
        var min= Math.min(size.width, size.height);
        if (min < 0)
        {
            return min;
        }
        var totalDegree=Math.abs(currentseries.endAngle-currentseries.startAngle);
        if (totalDegree < 270) 
            this.pieDoughnutCenter(currentseries);
         var text;
        
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex };
         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);

         var visibility = (currentseries.enableAnimation && !currentseries._animatedSeries) ? 'hidden' : 'visible';

        
         var txtOptions = { 'id': this.chartObj.svgObject.id + '_TextGroup' + '_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gSeriesTextEle) this.chartObj.gSeriesTextEle = [];
         this.chartObj.gSeriesTextEle[seriesIndex] = pieSeriesIndex == 1 ? this.chartObj.gSeriesTextEle[0] : this.chartObj.svgRenderer.createGroup(txtOptions);
         var symbolOptions = { 'id': this.chartObj.svgObject.id + '_symbolGroup' + '_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gSymbolGroupEle) this.chartObj.gSymbolGroupEle = [];
         this.chartObj.gSymbolGroupEle[seriesIndex] = this.chartObj.svgRenderer.createGroup(symbolOptions);

         var connectorOptions = { 'id': this.chartObj.svgObject.id + '_connectorGroup' + '_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gConnectorEle) this.chartObj.gConnectorEle = [];
         this.chartObj.gConnectorEle[seriesIndex] = this.chartObj.svgRenderer.createGroup(connectorOptions);
         var dataLabelOptions = { 'id': this.chartObj.svgObject.id + '_DataLabel_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gDataLabelEle) this.chartObj.gDataLabelEle = [];
         this.chartObj.gDataLabelEle[seriesIndex] = pieSeriesIndex == 1 ? this.chartObj.gDataLabelEle[0] : this.chartObj.svgRenderer.createGroup(dataLabelOptions);
             
                 
         for (var j = 0; j < visiblePoints.length; j++) {
             pointIndex = this.chartObj.model._isPieOfPie ? visiblePoints[j].actualIndex : j;
             if (isNaN(currentseries._visiblePoints[j].startAngle)) continue;
             var point = currentseries._visiblePoints[j];
                 if (point.visible) {
                     var result = this._calculateArcData(this.chartObj, pointIndex, point, currentseries, seriesIndex, pieSeriesIndex);
                 var sliceXY = result.Direction.split(" "); 
             var styleOptions = this.chartObj.setStyle(this, currentseries, seriesIndex,  j);
			 if (currentseries.startAngle < currentseries.endAngle) // for canvas rendering with modified start and end angle
                     var counterClockWise = false;
                 else
                     counterClockWise = true;
             options = {
                 'id': this.chartObj.svgObject.id + '_Series' + seriesIndex + "_Point" + pointIndex,
                 'fill': styleOptions.interior,
                 'stroke-width': styleOptions.borderWidth,
                 'stroke': styleOptions.borderColor,
                 'stroke-dasharray': styleOptions.dashArray,
                     'stroke-linecap': currentseries.lineCap,
                     'stroke-linejoin': currentseries.lineJoin,
                     'd': result.Direction,
                     'opacity': styleOptions.opacity,
                     'radius': seriesType =="pieofpie"?this.chartObj.model.circularRadius[pieSeriesIndex]: this.chartObj.model.circularRadius[seriesIndex],
                     'start': point.startAngle - 1.57,
                     'end': point.endAngle - 1.57,
                     'pointIndex': pointIndex,
					 'counterClockWise': counterClockWise,
                     'innerR': 0,
					  'cx': result.centerX,
                     'cy':result.centerY,
                     'x': sliceXY[12],
                     'y': sliceXY[13]
                 };
                 this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle);

                 region = { PointIndex: pointIndex, StartAngle: point.startAngle, EndAngle: point.endAngle, StartX: this.chartObj.model.startX[pointIndex], StartY: this.chartObj.model.startY[pointIndex] ,
                     PieSeriesIndex: pieSeriesIndex,SeriesIndex: $.inArray(currentseries, this.chartObj.model._visibleSeries)};
                 internalRegion.push(region);

             }
         }
         var seriesIndex = this.chartObj.model._isPieOfPie ? pieSeriesIndex : seriesIndex;
        
         if (this.chartObj.model._isPieOfPie && pieSeriesIndex == 1
             && currentSeries.pieCollections[0].length > 0 && currentSeries.pieCollections[1].length == 0)
         {
             var emptyCircleOptions = this._drawEmptyPieOfPie(this.chartObj);             
             this.chartObj.svgRenderer.drawPath(emptyCircleOptions, this.gSeriesGroupEle);
         }
        
         var seriesData = { Radius: this.chartObj.model.circularRadius[seriesIndex], CenterX: this.chartObj.model.circleCenterX[seriesIndex], CenterY: this.chartObj.model.circleCenterY[seriesIndex] };
         var region = { Series: currentseries, SeriesData: seriesData, Region: internalRegion, SeriesIndex: $.inArray(currentseries, this.chartObj.model._visibleSeries) };
         this.chartObj.model.chartRegions.push(region);

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);
     },
 
     chartAreaType : "None"

 });

 ej.seriesTypes.pie = ej.ejPieSeries;

 ej.ejDoughnutSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options) {
         this.chartObj = chart;
         var currentseries = options;
         var internalRegion = [];

         var visiblePoints = this._calculateVisiblePoints(options).visiblePoints;
         var size = this.calculatingSliceAngle(currentseries);
		 var visiblePointslength = visiblePoints.length;        
         var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
         var seriesLength = this.chartObj.model._visibleSeries.length;
         var seriesLength = this.chartObj.model._visibleSeries.length;
         var currentSeries = this.chartObj.model._visibleSeries[seriesIndex];
             	currentSeries._doughnutSize = currentSeries.doughnutSize;
             	currentSeries._doughnutCoefficient =  currentSeries.doughnutCoefficient;
             	if (this.chartObj.model.circularRadius.length > 1) {
             	    for (i = seriesIndex; !ej.util.isNullOrUndefined(currentSeries.zOrder) ? i >= 0 : i < this.chartObj.model.circularRadius.length; !ej.util.isNullOrUndefined(currentSeries.zOrder) ? i-- : i++) {
             	        if (!ej.util.isNullOrUndefined(this.chartObj.model.circularRadius[i])) {
             	            this.chartObj.model.circularRadius[seriesIndex] = this.chartObj.model.circularRadius[i] * currentSeries._doughnutSize;
             	            break;
             	        }
             	    }
             	}
             	else
             	    this.chartObj.model.circularRadius[seriesIndex] = 0.5 * currentSeries._doughnutSize * Math.min(size.width, size.height);
         var min = Math.min(size.width, size.height);
         if (min < 0) {
             return min;
         }
         var totalDegree = Math.abs(currentseries.endAngle - currentseries.startAngle);
         if (totalDegree < 270)//for centering the chart
             this.pieDoughnutCenter(currentseries);
         this.chartObj.model.innerRadius[seriesIndex] = currentSeries._doughnutCoefficient * this.chartObj.model.circularRadius[seriesIndex];


         var numberToFixed = ej.util.isNullOrUndefined(this.chartObj.model.roundingPlaces) ? 2 : this.chartObj.model.roundingPlaces;

         var seriesIndex = $.inArray(currentseries, this.chartObj.model._visibleSeries);
         var serOptions = { 'id': this.chartObj.svgObject.id + '_SeriesGroup' + '_' + seriesIndex };
         this.gSeriesGroupEle = this.chartObj.svgRenderer.createGroup(serOptions);

         var visibility = (currentseries.enableAnimation && !currentseries._animatedSeries) ? 'hidden' : 'visible';

          
         var txtOptions = { 'id': this.chartObj.svgObject.id + '_TextGroup' + '_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gSeriesTextEle) this.chartObj.gSeriesTextEle = [];
         this.chartObj.gSeriesTextEle[seriesIndex] = this.chartObj.svgRenderer.createGroup(txtOptions);

         var symbolOptions = { 'id': this.chartObj.svgObject.id + '_symbolGroup' + '_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gSymbolGroupEle) this.chartObj.gSymbolGroupEle = [];
         this.chartObj.gSymbolGroupEle[seriesIndex] = this.chartObj.svgRenderer.createGroup(symbolOptions);

         var connectorOptions = { 'id': this.chartObj.svgObject.id + '_connectorGroup' + '_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gConnectorEle) this.chartObj.gConnectorEle = [];
         this.chartObj.gConnectorEle[seriesIndex] = this.chartObj.svgRenderer.createGroup(connectorOptions);

         var dataLabelOptions = { 'id': this.chartObj.svgObject.id + '_DataLabel_' + seriesIndex, 'visibility': visibility };
         if (!this.chartObj.gDataLabelEle) this.chartObj.gDataLabelEle = [];
         this.chartObj.gDataLabelEle[seriesIndex] = this.chartObj.svgRenderer.createGroup(dataLabelOptions);
		 if ((currentseries._doughnutSize > 0) && (currentSeries._doughnutCoefficient >= 0) && (currentseries._doughnutSize <= 1) && (currentSeries._doughnutCoefficient <= 1)) {
           
             for (var j = 0; j < visiblePointslength; j++) {
             var point = currentseries._visiblePoints[j];
             var pointIndex = j;
             if (point.visible) {
                 var explodeX = 0;
                 var explodeY = 0;
                 var result = this._calculateArcData(this.chartObj, pointIndex, point, currentseries,seriesIndex);
				 //for canvas slice explode
                 if ((point.actualIndex == currentseries.explodeIndex || currentseries.explodeAll) && !this.chartObj.vmlRendering) {
                     var chartStartAngle = -.5 * Math.PI; 
                     var startAngle = point.startAngle + chartStartAngle;
                     var endAngle = point.endAngle + chartStartAngle - 0.000001;
                     var midAngle = (startAngle + endAngle) / 2;
                     explodeX = this.chartObj.model.circleCenterX[seriesIndex] + Math.cos(midAngle) * currentseries.explodeOffset;
                     explodeY = this.chartObj.model.circleCenterY[seriesIndex] + Math.sin(midAngle) * currentseries.explodeOffset;
                 }

             var styleOptions = this.chartObj.setStyle(this, currentseries, seriesIndex, pointIndex);

                 if (currentseries.startAngle < currentseries.endAngle) // for canvas rendering with modified start and end angle
                     var counterClockWise = false;
                 else
                     counterClockWise = true;
                 
             options = {
                 'id': this.chartObj.svgObject.id + '_Series' + seriesIndex + "_Point" + pointIndex,
                 'fill': styleOptions.interior,
                 'stroke-width': styleOptions.borderWidth,
                 'stroke': styleOptions.borderColor,
                 'stroke-dasharray': styleOptions.dashArray,
                     'stroke-linecap': currentseries.lineCap,
                     'opacity': styleOptions.opacity,
                     'stroke-linejoin': currentseries.lineJoin,
                     'd': result.Direction,
                     'start': point.startAngle - 1.57,
                     'end': point.endAngle - 1.57,
                     'pointIndex': pointIndex,
                     'radius': this.chartObj.model.circularRadius[seriesIndex],
                     'innerR': this.chartObj.model.innerRadius[seriesIndex],
                     'counterClockWise': counterClockWise,
                     'x': explodeX !=0 ? explodeX : this.chartObj.model.circleCenterX[seriesIndex],
                     'y': explodeY !=0 ? explodeY : this.chartObj.model.circleCenterY[seriesIndex]
             };
            this.chartObj.svgRenderer.drawPath(options, this.gSeriesGroupEle);


                 region = { PointIndex: j, StartAngle: point.startAngle, EndAngle: point.endAngle, StartX: this.chartObj.model.startX[pointIndex], StartY: this.chartObj.model.startY[pointIndex] ,  SeriesIndex: $.inArray(currentseries, this.chartObj.model._visibleSeries)};
                 internalRegion.push(region);

             }
         }
}
         var seriesData = { Radius: this.chartObj.model.circularRadius[seriesIndex], DRadius: this.chartObj.model.innerRadius[seriesIndex], CenterX: this.chartObj.model.circleCenterX[seriesIndex], CenterY: this.chartObj.model.circleCenterY[seriesIndex] };
         var region = { Series: currentseries, SeriesData: seriesData, Region: internalRegion, SeriesIndex: $.inArray(currentseries, this.chartObj.model._visibleSeries) };
         this.chartObj.model.chartRegions.push(region);

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

     },

     chartAreaType:"None"
 });

 ej.seriesTypes.doughnut = ej.ejDoughnutSeries;

 ej.ejPyramidSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options) {

         this.chartObj = chart;
         var chartModel = chart.model,
             point,
             seriesRender = this,
             legendActualBounds = chartModel.LegendActualBounds,
             currentseries = options,
             visiblePoints = this._calculateVisiblePoints(currentseries).visiblePoints,
             visiblePointslength = visiblePoints.length,
             internalRegion = [],
             translate = [],
             legend = chartModel.legend,
			 dataLabel = currentseries.marker.dataLabel,
             legendPosition = legend.position.toLowerCase(),
             legendWidth = legend.border.width,
             textSize = 0,
             text,
             title = chartModel.title,
             subTitle = chartModel.title.subTitle,
             borderSize = chartModel.border.width,
             titleVisibility = title.text != '' && title.visible && title.enableTrim ? true : false,
             subTitleVisibility = subTitle.text != '' && subTitle.visible && subTitle.enableTrim ? true : false,
             measureTitle = (chartModel.title.text && chartModel.title.visible) ? ej.EjSvgRender.utils._measureText(chartModel.title.text, $(this.svgObject).width() - chartModel.margin.left - chartModel.margin.right, chartModel.title.font) : 0,
             measureSubTitle = (chartModel.title.subTitle.text && chartModel.title.subTitle.visible) ? ej.EjSvgRender.utils._measureText(chartModel.title.subTitle.text, $(this.svgObject).width() - chartModel.margin.left - chartModel.margin.right, chartModel.title.subTitle.font) : 0,
             measureTitleHeight = (chart.model.title.text == '' || !chart.model.title.visible) ? 0 : ((titleVisibility && title.textOverflow == 'wrap') ? measureTitle.height * chart.model.titleWrapTextCollection.length : (titleVisibility && title.textOverflow == 'wrapandtrim') ?
             measureTitle.height * chart.model.titleWrapTextCollection.length : measureTitle.height),
             measureSubTitleHeight = (chart.model.title.subTitle.text == '' || !chart.model.title.subTitle.visible) ? 0 : ((subTitleVisibility && subTitle.textOverflow == 'wrap') ? measureSubTitle.height * chart.model.subTitleWrapTextCollection.length : (subTitleVisibility && subTitle.textOverflow == 'wrapandtrim') ?
             measureSubTitle.height * chart.model.subTitleWrapTextCollection.length : measureSubTitle.height),
             xOffset = (chartModel.margin.left + chartModel.elementSpacing + (borderSize * 2) + chartModel.elementSpacing + chartModel.margin.right + ((legendPosition === "right" || legendPosition === "left") ? legendActualBounds.Width + (2 * legendWidth) : 0)),
             yOffset = (((chartModel.title.text && chartModel.title.visible) ? (chartModel._titleLocation.Y + measureTitleHeight + measureSubTitleHeight) : chartModel.elementSpacing) + (borderSize * 2) + chartModel.margin.top + chartModel.elementSpacing + chartModel.elementSpacing + ((legendPosition === "top" || legendPosition === "bottom") ? legendActualBounds.Height + (2 * legendWidth) + chartModel.elementSpacing : 0));
		if (dataLabel.visible && dataLabel.shape != 'none' && currentseries.labelPosition == 'outside')
			xOffset = xOffset + (dataLabel.margin.left + dataLabel.margin.right);
         chartModel.chartRegions = [];
         chartModel.sumofYValues = 0;

         if (currentseries.labelPosition.toLowerCase() === 'outside') {
             for (var i = 0; i < visiblePointslength; i++) {
                 var textWidth = ej.EjSvgRender.utils._measureText((ej.util.isNullOrUndefined(visiblePoints[i].text) ? visiblePoints[i].y : visiblePoints[i].text), null, currentseries.marker.dataLabel.font).width;
                 if (textSize < textWidth)
                     textSize = textWidth;
             }
             chartModel.textSize = textSize;
         }
         if (currentseries._enableSmartLabels) {
             chartModel.actualWidth = ($(chart.svgObject).width() - xOffset) * 0.8; //calculate a pyramid width when smartlabel is enabled
             chartModel.resWidth = ($(chart.svgObject).width() - xOffset - chartModel.actualWidth) / 2;
         }
         else {
             chartModel.actualWidth = $(chart.svgObject).width() - xOffset - textSize;
             chartModel.resWidth = 0;
         }
         var seriesIndex = $.inArray(currentseries, chartModel._visibleSeries);
         chartModel.actualHeight = $(chart.svgObject).height() - yOffset;
         var subtitleHeight = (chart.model.title.subTitle.text == '') ? 0 : measureSubTitleHeight;
         var pyrX = chart.pyrX = ((legendPosition === "left") ? (legendActualBounds.Width + (2 * legendWidth)) : 0) + chartModel.elementSpacing + chartModel.margin.left;
         var pyrY = chart.pyrY = ((legendPosition === "top") ? (legendActualBounds.Height + (2 * legendWidth)) : 0) + ((title.text && title.visible) ? (chartModel._titleLocation.Y + measureTitleHeight + subtitleHeight) : (chartModel.margin.top + chartModel.elementSpacing));
         translate[0] = pyrX;
         translate[1] = pyrY;
         for (var j = 0; j < visiblePointslength; j++) {
             chartModel.sumofYValues += visiblePoints[j].YValues[0];
         }
         var dataLabelOptions = { 'id': chart.svgObject.id + '_DataLabel_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gDataLabelEle = [];
            chart.gDataLabelEle[seriesIndex] = chart.svgRenderer.createGroup(dataLabelOptions);


         var numberToFixed = ej.util.isNullOrUndefined(chartModel.roundingPlaces) ? 2 : chartModel.roundingPlaces;

         var serOptions = { 'id': chart.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
         this.gSeriesGroupEle = chart.svgRenderer.createGroup(serOptions);


         var txtOptions = { 'id': chart.svgObject.id + '_textGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gSeriesTextEle = [];
            chart.gSeriesTextEle[seriesIndex] = chart.svgRenderer.createGroup(txtOptions);

           var symbolOptions = { 'id': chart.svgObject.id + '_symbolGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gSymbolGroupEle = [];
            chart.gSymbolGroupEle[seriesIndex] = chart.svgRenderer.createGroup(symbolOptions);

            var connectorOptions = { 'id': chart.svgObject.id + '_connectorGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gConnectorEle = [];
            chart.gConnectorEle[seriesIndex] = chart.svgRenderer.createGroup(connectorOptions);


         if (currentseries.pyramidMode.toLowerCase() == "linear")
             this.calculateLinearSegments(currentseries);
         else
             this.calculateSurfaceSegments(currentseries);

         for (j = 0; j < visiblePointslength; j++) {
             var pointIndex = j;
             point = currentseries._visiblePoints[j];
             if (point.visible) {
                 var result = this._getPyramidData(currentseries, pointIndex);

                 var styleOptions = chart.setStyle(this, currentseries, 0, pointIndex);

             options = {
                     'id': chart.svgObject.id + '_Series' + seriesIndex + "_Point" + pointIndex,
                 'fill': styleOptions.interior,
                 'stroke-width': styleOptions.borderWidth,
                 'stroke': styleOptions.borderColor,
                 'stroke-dasharray': styleOptions.dashArray,
                     'stroke-linecap': currentseries.lineCap,
                     'stroke-linejoin': currentseries.lineJoin,
                     'opacity': styleOptions.opacity,
                     'pointIndex': pointIndex,
                     'd': result.Direction
                 };
                 chart.svgRenderer.drawPath(options, this.gSeriesGroupEle, translate);

                 if (currentseries.marker.dataLabel.template) {
                     ej.EjSvgRender.utils._getSeriesTemplateSize(point, pointIndex, currentseries, true, chart);
                 }

                 point.xLocation = result.PositionX;
                 point.yLocation = result.PositionY;
                 point.connectorLine = result.Connector;
                 point.startX = result.startX;
                 point.startY = result.startY;
                 point.Polygon = result.Polygon;
                 region = { PointIndex: pointIndex, Line1: result.Line1, Line2: result.Line2, Line3: result.Line3, Line4: result.Line4, Polygon: result.Polygon };
                 internalRegion.push(region);
             }
         }
         var region = { Series: currentseries, Region: internalRegion, SeriesIndex: $.inArray(currentseries, chartModel._visibleSeries) };
         chartModel.chartRegions.push(region);

         if (this.gSeriesGroupEle) {
             $(this.gSeriesGroupEle.childNodes[pointIndex]).bind('mousemove', function (evt) {
                 evt.target = seriesRender.gSeriesGroupEle.childNodes[pointIndex];
                 seriesRender.chartObj.chartInteractiveBehavior(evt);
             });

             chart.svgRenderer.append(this.gSeriesGroupEle, chart.gSeriesEle);
         }

        

     },

     _getPyramidData: function (series, index) {
        
         var model = this.chartObj.model;
         var pointMarker = series._visiblePoints[index].marker;
         var actualIndex = series._visiblePoints[index].actualIndex;
         var offset = ((series.explodeIndex == actualIndex) || (series.explodeAll) ? series.explodeOffset : 0);
         var resWidth = model.resWidth;
         var top = model.pyramidData[index].CurrY;
         var bottom = model.pyramidData[index].CurrY + model.pyramidData[index].Height;
         var topRadius = 0.5 * (1 - model.pyramidData[index].CurrY);
         var bottomRadius = 0.5 * (1 - bottom);
         var point = series.points[index];

         var line1 = { x: resWidth + offset + topRadius * model.actualWidth, y: top * model.actualHeight };
         var line2 = { x: resWidth + offset + (1 - topRadius) * model.actualWidth, y: top * model.actualHeight };
         var line3 = { x: resWidth + offset + (1 - bottomRadius) * model.actualWidth, y: bottom * model.actualHeight };
         var line4 = { x: resWidth + offset + bottomRadius * model.actualWidth, y: bottom * model.actualHeight };

         var direction = "M" + " " + (line1.x) + " " + (line1.y) + " " + "L" + " " + (line2.x) + " " + (line2.y) + " " + "L" + " " + (line3.x) + " " + (line3.y) + " " + "L" + " " + (line4.x) + " " + (line4.y) + " " + "z";
         var polygon = [
             { x: line1.x, y: line1.y },
             { x: line2.x, y: line2.y },
             { x: line3.x, y: line3.y },
             { x: line4.x, y: line4.y }
            ];
         if ((pointMarker && pointMarker.dataLabel && pointMarker.dataLabel.visible) || (!pointMarker || !pointMarker.dataLabel) && series.marker.dataLabel.visible) {
             var positionX;
             var positionY;
             var startX = (line2.x + line3.x) / 2;
             var startY = (line2.y + line3.y) / 2;
             if (series.labelPosition.toLowerCase() === 'outside' ) {

                 positionX = (line2.x + line3.x) / 2;
                 positionY = (line2.y + line3.y) / 2;

                 var pyrX = ((this.chartObj.model.legend.position.toLowerCase() == "left" || this.chartObj.model.legend.position.toLowerCase() == "right") ? (this.chartObj.model.LegendActualBounds.Width) : 0) + this.chartObj.model.elementSpacing + this.chartObj.model.margin.left;

                 if (ej.util.isNullOrUndefined(series.marker.dataLabel.connectorLine.height)) {
                     if (series._enableSmartLabels)
                         var textOffset = $(this.chartObj.svgObject).width() - (pyrX + positionX + resWidth + (2 * this.chartObj.model.elementSpacing));
                     else
                         var textOffset = $(this.chartObj.svgObject).width() - (pyrX + positionX + this.chartObj.model.textSize + this.chartObj.model.elementSpacing);
                 }
                 else
                     textOffset = series.marker.dataLabel.connectorLine.height;
                                                
                 var connectorX = this.getXCordinate(positionX, textOffset, 0);
                 var connectorY = this.getYCordinate(positionY, textOffset, 0);
                
                 var connectorDirection = "M" + " " + positionX + " " + positionY + " " + "L" + " " + connectorX + " " + connectorY;

                 positionX = connectorX;
                 positionY = connectorY ;

                 
             }
             else {
                 positionX = (line1.x + line2.x) / 2;
                 positionY = (line3.y + line1.y) / 2;
             }
         }
         return { Direction: direction, PositionX: positionX, PositionY: positionY, Connector: connectorDirection, Line1: line1, Line2: line2, Line3: line3, Line4: line4, startX: startX, startY: startY, Polygon: polygon };
     },

     calculateLinearSegments: function (series) {
         var currY = 0;
         var model = this.chartObj.model;
         model.pyramidData = [];
         var gapRatio = series.gapRatio >= 0 ? (series.gapRatio <= 1 ? series.gapRatio : 1) : 0;
         var coef = 1 / (model.sumofYValues * (1 + gapRatio / (1 - gapRatio)));
         var count = series._visiblePoints.length;
         for (var i = 0; i < count; i++) {
             if (series._visiblePoints[i].visible || series._visiblePoints[i].gapMode) {
                 var height = coef * series._visiblePoints[i].YValues[0];
                 model.pyramidData[i] = { CurrY: currY, Height: height };
                 currY += (gapRatio / (count - 1)) + height;
             }
         }
     },

     calculateSurfaceSegments: function (series) {
         var count = series._visiblePoints.length;
         var model = this.chartObj.model;
         model.pyramidData = [];
         var currY = 0;
         var y = [];
         var height = [];
         var gapRatio = series.gapRatio >= 0 ? (series.gapRatio <= 1 ? series.gapRatio : 1) : 0;
         var gapHeight = gapRatio / (count - 1);
         var preSum = this.getSurfaceHeight(0, model.sumofYValues);
         for (i = 0; i < count; i++) {
             if (series._visiblePoints[i].visible || series._visiblePoints[i].gapMode) {
                 y[i] = currY;
                 height[i] = this.getSurfaceHeight(currY, Math.abs(series._visiblePoints[i].YValues[0]));
                 currY += height[i] + gapHeight * preSum;
             }
         }
         var coef = 1 / (currY - gapHeight * preSum);
         for (var i = 0; i < count; i++) {
             if (series._visiblePoints[i].visible || series._visiblePoints[i].gapMode) {
                 var currHeight = coef * y[i];
                 model.pyramidData[i] = { CurrY: currHeight, Height: coef * height[i] };
             }
         }
     },

     getSurfaceHeight: function (y, surface) {
         var result = this.solveQuadraticEquation(1, 2 * y, -surface);
         if (result) {
             return result;
         }
         return 0;
     },
     solveQuadraticEquation: function (a, b, c) {
         var root1;
         var root2;

         if (a != 0) {
             var d = b * b - 4 * a * c;

             if (d >= 0) {
                 var sd = Math.sqrt(d);

                 root1 = (-b - sd) / (2 * a);
                 root2 = (-b + sd) / (2 * a);
                 return Math.max(root1, root2);

             }
         }
         else if (b != 0) {
             root1 = -c / b;
             root2 = -c / b;
             return Math.max(root1, root2);
         }

         return false;
     },

     chartAreaType: "None"
 });

 ej.seriesTypes.pyramid = ej.ejPyramidSeries;
   
 ej.ejFunnelSeries = ejExtendClass(ej.EjSeriesRender, {
     draw: function (chart, options) {        
         this.chartObj = chart;
         var chartModel = chart.model,
             legend = chartModel.legend,
             legendPosition = legend.position.toLowerCase(),
             legendActualBounds = chartModel.LegendActualBounds,
             point,
             seriesRender = this,
             currentseries = options,
             visiblePoints = this._calculateVisiblePoints(currentseries).visiblePoints,
             visiblePointslength = visiblePoints.length,
             internalRegion = [],
			 dataLabel = currentseries.marker,
             legendWidth = legend.border.width,
             translate = [],
             textSize = 0,
             text,
             title = (chart.model.title.text == '') ? '' : chartModel.title,
             subTitle = (chart.model.title.subTitle.text == '') ? '' : chartModel.title.subTitle,
             borderSize = chartModel.border.width,
             titleVisibility = title.text != '' && title.visible && title.enableTrim ? true : false,
             subTitleVisibility = subTitle.text != '' && subTitle.visible && subTitle.enableTrim ? true : false,
             measureTitle = (chartModel.title.text&&chartModel.title.visible) ? ej.EjSvgRender.utils._measureText(chartModel.title.text, $(this.svgObject).width() - chartModel.margin.left - chartModel.margin.right, chartModel.title.font) : 0,
             measureSubTitle = (chartModel.title.subTitle.text&&chartModel.title.subTitle.visible) ? ej.EjSvgRender.utils._measureText(chartModel.title.subTitle.text, $(this.svgObject).width() - chartModel.margin.left - chartModel.margin.right, chartModel.title.subTitle.font) : 0,
             measureTitleHeight = (chart.model.title.text == '' || !chart.model.title.visible) ? 0 : ((titleVisibility && title.textOverflow == 'wrap') ? measureTitle.height * chart.model.titleWrapTextCollection.length : (titleVisibility && title.textOverflow == 'wrapandtrim') ?
             measureTitle.height * chart.model.titleWrapTextCollection.length : measureTitle.height),
             measureSubTitleHeight = (chart.model.title.subTitle.text == '' || !chart.model.title.subTitle.visible) ? 0 : ((subTitleVisibility && subTitle.textOverflow == 'wrap') ? measureSubTitle.height * chart.model.subTitleWrapTextCollection.length : (subTitleVisibility && subTitle.textOverflow == 'wrapandtrim') ?
             measureSubTitle.height * chart.model.subTitleWrapTextCollection.length : measureSubTitle.height),
             xOffset = (chartModel.margin.left + chartModel.elementSpacing + chartModel.elementSpacing + chartModel.margin.right + (borderSize * 2) + ((legendPosition === "right" || legendPosition === "left") ? legendActualBounds.Width + (2 * legendWidth) : 0)),
             yOffset = (((chartModel.title.text&&chartModel.title.visible) ? (chartModel._titleLocation.Y + measureTitleHeight+measureSubTitleHeight) : chartModel.elementSpacing) + chartModel.margin.top + (borderSize * 2) + chartModel.elementSpacing + chartModel.elementSpacing + ((legendPosition === "top" || legendPosition === "bottom") ? legendActualBounds.Height + (2 * legendWidth) + chartModel.elementSpacing : 0));
		if (dataLabel.visible && dataLabel.shape != 'none' && currentseries.labelPosition == 'outside')
			xOffset = xOffset + (dataLabel.margin.left + dataLabel.margin.right);
         chartModel.chartRegions = [];
         chartModel.sumofYValues = 0;
         if (currentseries.labelPosition.toLowerCase() === 'outside') {
             for (var i = 0; i < visiblePointslength; i++) {
                 var textWidth = ej.EjSvgRender.utils._measureText((ej.util.isNullOrUndefined(visiblePoints[i].text) ? visiblePoints[i].y : visiblePoints[i].text), null, currentseries.marker.dataLabel.font).width;
                 if (textSize < textWidth)
                     textSize = textWidth;
             }
             chartModel.textSize = textSize;
         }
         if (currentseries._enableSmartLabels) {
             chartModel.actualWidth = ($(chart.svgObject).width() - xOffset) * 0.8;  //calculate a width of a funnel chart when smartlabel is enabled
             chartModel.resWidth = ($(chart.svgObject).width() - xOffset - chartModel.actualWidth) / 2;
         }
         else {
             chartModel.actualWidth = $(chart.svgObject).width() - xOffset - textSize;
             chartModel.resWidth = 0;
         }
         var subtitleHeight = (chart.model.title.subTitle.text == '') ? 0 : measureSubTitleHeight;
         chartModel.actualHeight = $(chart.svgObject).height() - yOffset;
         var pyrX = chart.pyrX = ((legendPosition === "left") ? (legendActualBounds.Width + (2 * legendWidth)) : 0) + chartModel.elementSpacing + chartModel.margin.left;
         var pyrY = chart.pyrY = ((legendPosition === "top") ? (legendActualBounds.Height + (2 * legendWidth)) : 0) + ((chartModel.title.text&&chartModel.title.visible) ? (chartModel._titleLocation.Y + measureTitleHeight + subtitleHeight) : (chartModel.margin.top + chartModel.elementSpacing));
         translate[0] = pyrX;
         translate[1] = pyrY;
         for (var j = 0; j < visiblePointslength; j++) {
             chartModel.sumofYValues += visiblePoints[j].YValues[0];
         }


         var numberToFixed = ej.util.isNullOrUndefined(chartModel.roundingPlaces) ? 2 : chartModel.roundingPlaces;

         var seriesIndex = $.inArray(currentseries, chartModel._visibleSeries);
         var serOptions = { 'id': chart.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
         this.gSeriesGroupEle = chart.svgRenderer.createGroup(serOptions);
         var dataLabelOptions = { 'id': chart.svgObject.id + '_DataLabel_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gDataLabelEle = [];
            chart.gDataLabelEle[seriesIndex] = chart.svgRenderer.createGroup(dataLabelOptions);


            var txtOptions = { 'id': chart.svgObject.id + '_textGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gSeriesTextEle = [];
            chart.gSeriesTextEle[seriesIndex] = chart.svgRenderer.createGroup(txtOptions);

            var symbolOptions = { 'id': chart.svgObject.id + '_symbolGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gSymbolGroupEle = [];
            chart.gSymbolGroupEle[seriesIndex] = chart.svgRenderer.createGroup(symbolOptions);

            var connectorOptions = { 'id': chart.svgObject.id + '_connectorGroup' + '_' + seriesIndex, 'transform': 'translate(' + pyrX + ',' + pyrY + ')' };
            chart.gConnectorEle = [];
            chart.gConnectorEle[seriesIndex] = chart.svgRenderer.createGroup(connectorOptions);

         var currY = 0;
         var model = chartModel;
         model.funnelData = [];
         var gapRatio = currentseries.gapRatio >= 0 ? (currentseries.gapRatio <= 1 ? currentseries.gapRatio : 1) : 0;
         var coef = 1 / (model.sumofYValues * (1 + gapRatio / (1 - gapRatio)));
          var spacing = gapRatio / visiblePointslength;
         for (var i = visiblePointslength - 1; i >= 0; i--) {
             if (currentseries._visiblePoints[i].visible || currentseries._visiblePoints[i].gapMode) {
                 var height = coef * currentseries._visiblePoints[i].YValues[0];
                 model.funnelData[i] = { CurrY: currY, Height: height };
                 currY += height + spacing;
             }
         }
         for (j = 0; j < visiblePointslength  ; j++) {
             var pointIndex = j;
             point = currentseries._visiblePoints[j];
             if (point.visible) {
                 var result = this._getFunnelData(currentseries, pointIndex, chart);

                 var styleOptions = chart.setStyle(this, currentseries, 0, pointIndex);

                 options = {
                     'id': chart.svgObject.id + '_Series' + seriesIndex + "_Point" + pointIndex,
                     'fill': styleOptions.interior,
                     'stroke-width': styleOptions.borderWidth,
                     'stroke': styleOptions.borderColor,
                     'stroke-dasharray': styleOptions.dashArray,
                     'stroke-linecap': currentseries.lineCap,
                     'stroke-linejoin': currentseries.lineJoin,
                     'opacity': styleOptions.opacity,
                     'pointIndex': pointIndex,
                     'd': result.Direction
                 };
                 chart.svgRenderer.drawPath(options, this.gSeriesGroupEle, translate);

                 if (currentseries.marker.dataLabel.template) {
                     ej.EjSvgRender.utils._getSeriesTemplateSize(point, pointIndex, currentseries, true, chart);
                 }

                 point.xLocation = result.PositionX;
                 point.yLocation = result.PositionY;
                 point.connectorLine = result.Connector;
                 point.startX = result.startX;
                 point.startY = result.startY;
                 point.Polygon = result.Polygon;
                 region = { PointIndex: pointIndex, Line1: result.Line1, Line2: result.Line2, Line3: result.Line3, Line4: result.Line4, Line5: result.Line5, Line6: result.Line6, Polygon: result.Polygon };
                 internalRegion.push(region);
             }
         }
         var region = { Series: currentseries, Region: internalRegion, SeriesIndex: $.inArray(currentseries, chartModel._visibleSeries) };
         chartModel.chartRegions.push(region);

         if(this.gSeriesGroupEle)
         $(this.gSeriesGroupEle.childNodes[pointIndex]).bind('mousemove', function (evt) {
             evt.target = seriesRender.gSeriesGroupEle.childNodes[pointIndex];
             seriesRender.chartObj.chartInteractiveBehavior(evt);
         });

         chart.svgRenderer.append(this.gSeriesGroupEle, chart.gSeriesEle);


     },

     _getFunnelData: function (series, index, chart) {

         var model = this.chartObj.model,
             point = series._visiblePoints[index],
             pointMarker = point.marker,
             seriesMarer = series.marker,
             funnelWidth = series.funnelWidth,
             funnelHeight = series.funnelHeight,
             actualHeight = model.actualHeight,
             actualWidth = model.actualWidth,
             elementSpacing = model.elementSpacing,
             pyrX, legendPosition = model.legend.position.toLowerCase(),
             actualIndex = point.actualIndex,
             direction,
             resWidth = model.resWidth, polygon,
             textOffset, connectorDirection,
             offset = ((series.explodeIndex == actualIndex) || (series.explodeAll) ? series.explodeOffset : 0),
             topRadius, minRadius, bottomRadius, endTop,
             endMin, endBottom, top, bottomY,
             bottom, connectorX, connectorY,
             positionX, positionY, startX, startY,
             line1, line2, line3, line4, line5, line6,
             lineWidth, minimumHeight, minimumWidth;
         if (funnelHeight.indexOf("%") != -1)
             minimumHeight = actualHeight * (parseInt(funnelHeight) / 100);
         else
             minimumHeight = parseInt(funnelHeight);
         if (funnelWidth.indexOf("%") != -1)
             minimumWidth = actualWidth * (parseInt(funnelWidth) / 100);
         else
             minimumWidth = parseInt(funnelWidth);

         top = model.funnelData[index].CurrY * actualHeight;
         bottom = top + model.funnelData[index].Height * actualHeight;
         lineWidth = minimumWidth + (actualWidth - minimumWidth) * ((actualHeight - minimumHeight - top) / (actualHeight - minimumHeight));
         topRadius = (actualWidth / 2) - lineWidth / 2;
         endTop = topRadius + lineWidth;
         if (bottom > actualHeight - minimumHeight || actualHeight == minimumHeight)
             lineWidth= minimumWidth;
         else
             lineWidth = minimumWidth + (actualWidth - minimumWidth) * ((actualHeight - minimumHeight - bottom) / (actualHeight - minimumHeight));
         bottomRadius = (actualWidth / 2) - (lineWidth / 2);
         endBottom = bottomRadius + lineWidth;
         if (top >= actualHeight - minimumHeight) {
             topRadius = bottomRadius = minRadius = (actualWidth / 2) - minimumWidth / 2;
             endTop = endBottom = endMin = (actualWidth / 2) + minimumWidth / 2;

         } else if (bottom > (actualHeight - minimumHeight)) {
             minRadius = bottomRadius = (actualWidth / 2) - lineWidth / 2;
             endMin = endBottom = minRadius + lineWidth;
             bottomY = actualHeight - minimumHeight;
         }

         line1 = { x: resWidth + offset + topRadius, y: top };
         line2 = { x: resWidth + offset + endTop, y: top };
         line4 = { x: resWidth + offset + endBottom, y: bottom };
         line5 = { x: resWidth + offset + bottomRadius, y: bottom };
         line3 = { x: resWidth + offset + endBottom, y: bottom };
         line6 = { x: resWidth + offset + bottomRadius, y: bottom };
         if (bottomY) {
             line3 = { x: resWidth + offset + endMin, y: bottomY };
             line6 = { x: resWidth + offset + minRadius, y: bottomY };
         }
         direction = "M" + " " + (line1.x) + " " + (line1.y) + " " + "L" + " " + (line2.x) + " " + (line2.y) + " " + "L" + " " + (line3.x) + " " + (line3.y) + " " + "L" + " " + (line4.x) + " " + (line4.y) + " " + "L" + " " + (line5.x) + " " + (line5.y) + " " + "L" + " " + (line6.x) + " " + (line6.y) + " " + "z";
         polygon = [
           { x: line1.x, y: line1.y },
           { x: line2.x, y: line2.y },
           { x: line3.x, y: line3.y },
           { x: line4.x, y: line4.y },
           { x: line5.x, y: line5.y },
           { x: line6.x, y: line6.y }
            ];
         if ((pointMarker && pointMarker.dataLabel && pointMarker.dataLabel.visible) || (!pointMarker || !pointMarker.dataLabel) && seriesMarer.dataLabel.visible) {
             positionX;
             positionY;
             startX = (line2.x + line3.x) / 2;
             startY = (line2.y + line3.y) / 2;   
             if (series.labelPosition.toLowerCase() === 'outside' ) {

                 positionX = (line2.x + line3.x) / 2;
                 positionY = (line2.y + line3.y) / 2;

                 pyrX = ((legendPosition == "left" || legendPosition == "right") ? (model.LegendActualBounds.Width) : 0) + elementSpacing + model.margin.left;

                 if (ej.util.isNullOrUndefined(seriesMarer.dataLabel.connectorLine.height)) {
                     if (series._enableSmartLabels)
                         textOffset = $(this.chartObj.svgObject).width() - (pyrX + positionX + resWidth + (2 * elementSpacing));
                     else
                         textOffset = $(this.chartObj.svgObject).width() - (positionX + model.textSize + elementSpacing);
                 }
                 else
                     textOffset = seriesMarer.dataLabel.connectorLine.height;

                 connectorX = this.getXCordinate(positionX, textOffset, 0);
                 connectorY = this.getYCordinate(positionY, textOffset, 0);

                 connectorDirection = "M" + " " + positionX + " " + positionY + " " + "L" + " " + connectorX + " " + connectorY;

                 positionX = connectorX;
                 positionY = connectorY;


             }
             else {
                 positionX = (line1.x + line2.x) / 2;
                 positionY = (line1.y + line4.y) / 2;
             }
         }
         return { Direction: direction, PositionX: positionX, PositionY: positionY, Connector: connectorDirection, Line1: line1, Line2: line2, Line3: line3, Line4: line4, Line5: line5, Line6: line6, startX: startX, startY: startY, Polygon: polygon };
     },

     
     chartAreaType: "None"
 });

 ej.seriesTypes.funnel = ej.ejFunnelSeries;
    /*Funnel series*/

 ej.ejPolarSeries = ejExtendClass(ej.EjSeriesRender, {

     draw: function (chart, options) {

         this.chartObj = chart;
         var point;
         var seriesRender = this;
         var currentseries = options;
         var visiblePoints = this._isVisiblePoints(currentseries);
         var internalRegion = [];
        

         var style = this.setLineSeriesStyle(currentseries);
        
         if (currentseries.drawType.toLowerCase() == "column") {
             var range=currentseries.xAxis.visibleRange;
			 range.interval = 1;
             var length = (currentseries.xAxis._valueType == "category") ? range.max : range.max - 1;
             this.chartObj.model.sumofYValues = 0;
             var count = range.interval;
             var min = range.min;
             do{
                 this.chartObj.model.sumofYValues += range.interval;
                 min += range.interval;
             } while (min <= length)
           //  this.chartObj.model.sumofYValues = visiblePoints.length;
         }

         var direction = this._calculatePolarAxesSegment(currentseries);

         if (currentseries.drawType.toLowerCase() == "area")
             this.drawAreaPath(currentseries, style, direction);
         else if (currentseries.drawType.toLowerCase() == "line")
             this._drawLinePath(currentseries, style, direction);
         
         
         
         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

       
     },
 
     chartAreaType: "PolarAxes"

 });

 ej.seriesTypes.polar = ej.ejPolarSeries;
 ej.ejRadarSeries = ejExtendClass(ej.EjSeriesRender, {

     draw: function (chart, options) {

         this.chartObj = chart;
         var point;
         var seriesRender = this;
         var currentseries = options;
         var visiblePoints = this._isVisiblePoints(currentseries);
         var internalRegion = [];

         var style = this.setLineSeriesStyle(currentseries);

         if (currentseries.drawType.toLowerCase() == "column") {
             var range = currentseries.xAxis.visibleRange;
			 range.interval = 1;
             var length = (currentseries.xAxis._valueType == "category") ? range.max : range.max - 1;
             this.chartObj.model.sumofYValues = 0;
             var count = range.interval;
             var min = range.min;
             do {
                 this.chartObj.model.sumofYValues += range.interval;
                 min += range.interval;
             } while (min <= length)
             //  this.chartObj.model.sumofYValues = visiblePoints.length;
         }

         var direction = this._calculatePolarAxesSegment(currentseries);

          if (currentseries.drawType.toLowerCase() == "area")
             this.drawAreaPath(currentseries, style, direction);
         else if (currentseries.drawType.toLowerCase() == "line")
             this._drawLinePath(currentseries, style, direction);

         this.chartObj.svgRenderer.append(this.gSeriesGroupEle, this.chartObj.gSeriesEle);

         

     },
     doAnimation: function (series, chart) {     // for polar/radar animation
         var chartObj = chart.chartObj;
         series.regionAdded = true;
         chartObj.model._radius = chartObj.model.Radius;
         chartObj.model.Radius = 0;
         var seriesRender = chart;
         var seriesIndex = $.inArray(series, chartObj.model._visibleSeries);
         var Path = $(chartObj.gSeriesEle).find("#" + seriesRender.gSeriesGroupEle.id)[0].childNodes[0];
         $(Path).animate(
             { Radius: chartObj.model._radius },

             {
                 duration: 1200, queue: false, step: function (now, fx) {
                     if(!ej.util.isNullOrUndefined(chartObj.model)){
                     chartObj.model.Radius = now;

                     var direction = seriesRender._calculatePolarAxesSegment(series);
                     if (series.drawType.toLowerCase() != 'column')
                         chartObj.svgRenderer._setAttr($(Path), { "d": direction });
                     chartObj.model.Radius = chartObj.model._radius;
                     }
                     else
                         $(Path).stop(true,true);
                 },
                 complete: function () {
                     if(!ej.util.isNullOrUndefined(chartObj.model)){
                     series.regionAdded = false;                    
                     chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.svgObject.id + '_TextGroup' + '_' + seriesIndex), { "visibility": "visible" });
                   
                     chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.svgObject.id + '_symbolGroup' + '_' + seriesIndex), { "visibility": "visible" });
					chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.svgObject.id + '_DataLabel' + '_' + seriesIndex), { "visibility": "visible" });
                     chartObj.model.AnimationComplete = true;
                     var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                     commonEventArgs.data = { series: series };
                     chartObj._trigger("animationComplete", commonEventArgs);
                     }
                 }

             });
     },
     chartAreaType: "PolarAxes"

 });

 ej.seriesTypes.radar = ej.ejRadarSeries;
})(jQuery);;
ej.ejChart = {};
(function($) {
String.prototype.parseTemplate = function () {
    var str = this;
    $.each(arguments[0], function (dataIndex, dataValue) {
        if (dataValue.count > 0) {
            $.each(dataValue, function (datachildIndex, datachildValue) {
                var val = new RegExp('#' + dataIndex + '.' + datachildIndex + '#', 'gm')
                str = str.replace(val.source, datachildValue);
            });
        } else {
            str = str.replace(new RegExp('\\#' + dataIndex + '\\#', 'gm'), dataValue);
        }

    });
	while (str.indexOf('ej.') >= 0) {
        substr = str.substring(str.indexOf('ej.'), str.indexOf(")") + 1);
        str = str.replace(substr, eval(substr));
    }
    return str;
};

String.prototype.capitalizeFirstString = (function () {
    return this.charAt(0).toUpperCase() + this.slice(1);
});

var Gradient = function (colors) {
    this._gradientStop = [];
    for (var j = 0; j < colors.length; j++) {
        this._gradientStop.push(colors[j]);
    }
};



 ej.ejChart = {

    _renderSfChart: function () {

        var svgSupport = (window.SVGSVGElement) ? true : false;
        var isCanvas = this.model.enableCanvasRendering;
        $("#chartContainer_" + this._id).remove();
        if (svgSupport) {
            this.renderer = new ej.EjSvgRender(this.element);
            if (isCanvas) {
                this.svgRenderer = new ej.EjCanvasRender(this.element);
                this.legendSvgContainer = this.svgRenderer.createLegendCanvas(this.element); //creating new CANVAS element for legend
            } else {
                this.svgRenderer = new ej.EjSvgRender(this.element);
                this.legendSvgContainer = this.svgRenderer.createLegendSvg(this.element); //creating new SVG element for legend
            }
            this._appendChartElements();
            if (!isCanvas)
                this.legendContainer.find("svg").attr("class", "e-designerhide");
            this._createChart();
            $(this.svgObject).appendTo(this.element);
        }
        else {
            isCanvas = false;
            this.svgRenderer = new ej.EjVmlRender(this.element);
            this.legendSvgContainer = this.svgRenderer.createLegendSvg(this.element); //creating new div element for legend
            this.renderer = new ej.EjVmlRender(this.element);
            this._appendChartElements();
            this._createChart();
            $(this.svgObject).appendTo(this.chartContainer);
        }
        return true;
    },

    _appendChartElements: function () {
        this.legendContainer = $("<div></div>").attr('id', "legend_" + this._id).css("height", "0px");
        this.scrollerContainer = $("<div></div>").attr('id', "legend_Scroller" + this._id).css("height", "0px");
        this.chartContainer = $("<div></div>").css("position", "relative").attr('id', "chartContainer_" + this._id);
        this.axisScroll = $("<div></div>").attr('id', "axisScrollbar_" + this._id).css("height", "0px");
        this.svgRenderer.append(this.legendSvgContainer, this.scrollerContainer);
        $(this.scrollerContainer).appendTo(this.legendContainer);
        $(this.axisScroll).appendTo(this.chartContainer);
        $(this.legendContainer).appendTo(this.chartContainer);
        $(this.chartContainer).appendTo(this.element);
    },

 setSvgSize: function (sender) {
            var chartObj = sender;
            var containerHeight = $(chartObj.element).height();
            var height = 450; //set default height if size not specified to chart or container
            var width =(ej.isTouchDevice()) ? 250: 600;
            var containerWidth = $(chartObj.element).width();
            var legendcontainerHeight = $(chartObj.chartContainer).height();
            if (chartObj.model.size.width) {
                var chartWidth = chartObj.model.size.width;
                if (typeof (chartWidth)== "string" && chartWidth.indexOf("%") != -1)
                    width = (containerWidth / 100) * parseInt(chartWidth);
                else
                    width = parseInt(chartWidth);
            }
            else if (containerWidth > 0)
                width = containerWidth;

            $(chartObj.svgObject).width(width);

            if (chartObj.model.size.height) {
                var chartHeight = chartObj.model.size.height;
                if (typeof (chartHeight) == "string" && chartHeight.indexOf("%") != -1)
                    height = (!this.vmlRendering) ? (containerHeight / 100) * parseInt(chartHeight) : height;
                else
                    height = parseInt(chartHeight);
            }
            else if (containerHeight > 0)
                height = containerHeight;
            else
                $(chartObj.svgObject).css("display", "block"); //Added css to chart due to 5px difference for container and svg (http://jsfiddle.net/Me5Zd/)       
            $(chartObj.svgObject).height(height);
			
			$("#"+chartObj._id).css("overflow", "hidden");//Added css to remove scrollbar on zooming the chart
			chartObj.svgObject.width = width;   // assigning width for canvas
			chartObj.svgObject.height = height;  // assigning height for 
},
    setModelProperties: function (excludeDataUpdate) {

        //set size for the svgObject
         if (!excludeDataUpdate)
            this.setSvgSize(this);

        this.svgWidth = $(this.svgObject).width();
        this.svgHeight = $(this.svgObject).height();

        this.chartCross = {
            visible: (excludeDataUpdate) ? this.chartCross.visible : this.model.crosshair.visible,
            mArea: this.model.crosshair.type
        };

        // extend series with commonSeriesOptions
        this.serAnimation = [];
        if (this.model.series && !excludeDataUpdate) {
            var trendlines, len, currentPoint, currentSeries, nullValue = false, trendLineType;
            this.model._drawTrendline = false;
            for (var j = 0; j < this.model.series.length; j++) {
                this.model.series[j] = ej.copyObject({}, this.model.commonSeriesOptions, this.model.series[j]);
				 currentSeries = this.model.series[j];
                this.serAnimation.push((currentSeries.enableAnimation === null || currentSeries.enableAnimation === undefined) ? this.model.commonSeriesOptions.enableAnimation : currentSeries.enableAnimation);
                    trendlines = currentSeries.trendlines;
                    len = trendlines.length;
                    for (var i = 0; i < len; i++) {
                        trendlines[i] = ej.copyObject({}, this.model.trendlineDefaults, trendlines[i]);
						trendlines[i]._visibility = trendlines[i].visibility;
                        if (trendlines[i].visibility.toLowerCase() == "visible"){
						    this.model._drawTrendline = true;
						    trendLineType = trendlines[i].type.toLowerCase();
							if (!ej.util.isNullOrUndefined(currentSeries.points)){
								for (var l= 0; l< currentSeries.points.length; l++){
									currentPoint = currentSeries.points[l];
									if (ej.util.isNullOrUndefined(currentPoint.y) || currentPoint.y == 0){
										nullValue = true; 
										break;
									}
								}
							}
						    trendlines[i].isNull  = nullValue && (trendLineType == "power" || trendLineType == "exponential") ? true: false;
						}
            }
          }
        }
        if (this.model.indicators) {
            for (var k = 0; k < this.model.indicators.length; k++) {
                this.model.indicators[k] = ej.copyObject({}, this.model.indicatorDefaults, this.model.indicators[k]);
            }
        }

    },

    _createChart: function () {
        this.svgObject = this.svgRenderer.svgObj;
        var commonlaodEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        this._trigger("load", commonlaodEventArgs);
        this.setTheme(ej.EjSvgRender.themes, this.model.theme);
        var model = this.model;
  
        if (model.series[0] && model.series[0]._isdesigntime) {
            model.series[0] = {};
            model.series[0].points = [];
            var randomPoints = [];
            for (var i = 1; i <= 10; i++) {
                randomPoints.push({ x: i, y: (Math.floor(Math.random() * (10 - 40)) + 40) });

            }
            model.series[0].points = randomPoints;
        }
		this.vmlRendering = (this.svgRenderer.vmlNamespace) ? true : false;
        if ($(this.element).is(":visible") || $(this.element).css("visibility") != "hidden" || $(this.element).css('display') != 'none') {
            this.bindEvents();
            this.bindTo();
        }
    },
    setTheme: function (jsonObj, themeName) {
        var name = themeName.toLowerCase();
        if ((name.indexOf("azure") >= 0 || name.indexOf("lime") >= 0 || name.indexOf("saffron") >= 0) && (name.indexOf("gradient") == -1) && (name.indexOf("dark") == -1))
            jsonObj[name] = $.extend(true, {}, jsonObj["flatlight"], jsonObj[name]);
        else if ((name.indexOf("azuredark") >= 0 || name.indexOf("limedark") >= 0 || name.indexOf("saffrondark")) >= 0 && (name.indexOf("gradient") == -1))
            jsonObj[name] = $.extend(true, {}, jsonObj["flatdark"], jsonObj[name]);
        else if ((name.indexOf("azure") >= 0 || name.indexOf("lime") >= 0 || name.indexOf("saffron") >= 0) && (name.indexOf("gradient") >= 0) && (name.indexOf("dark") == -1))
            jsonObj[name] = $.extend(true, {}, jsonObj["gradientlight"], jsonObj[name]);
        else if ((name.indexOf("azuredark") >= 0 || name.indexOf("limedark") >= 0 || name.indexOf("saffrondark") >= 0) && (name.indexOf("gradient") >= 0))
            jsonObj[name] = $.extend(true, {}, jsonObj["gradientdark"], jsonObj[name]);
        else if ((name.indexOf("high") >= 0))
            jsonObj[name] = $.extend(true, {}, jsonObj["highcontrast01"], jsonObj[name]);
        else if ((name.indexOf("material") >= 0) || (name.indexOf("office") >= 0))
            jsonObj[name] = $.extend(true, {}, jsonObj["material"], jsonObj[name]);
        else if (!(jsonObj[name])) name = "flatlight";

        if (this.model._themeChanged)
            this.model = ej.copyObject({}, this.model, jsonObj[name]);
        else
            this.model = ej.copyObject({}, jsonObj[name], this.model);
		// added default property background in synchart to work in angular 1
        this.model.background = ej.util.isNullOrUndefined(this.model.background) ? jsonObj[name].background : this.model.background;


    },
    _drawBackInterior: function () {
        if (this.model.backInterior && this.model.backInterior._gradientStop) {
            var options = {
                'id': this.svgObject.id + '_backGradient',
                'x1': '0%',
                'y1': '0%',
                'x2': '0%',
                'y2': $(this.svgObject).height() + '%'
            };
            this.svgRenderer.drawGradient(options, this.model.backInterior._gradientStop);
        }
    },
    


    _drawBackImage: function () {
        var options = {
            'height': $(this.svgObject).height(),
            'width': $(this.svgObject).width(),
            'href': this.model.backGroundImageUrl,
            'x': 0,
            'y': 0,
            'id': this.svgObject.id + '_backImage',
            'visibility': 'visible',
            'preserveAspectRatio': 'none'
        };

        this.svgRenderer.drawImage(options, this.svgObject);

    },
    _getDataType: function (val) {
        var type = typeof (val);
        if (type === "number" || type === "string")
            return type;
        else if (jQuery.type(val) == "date")
            return "date";
        else if (val == null) {
            return null;
        }
        else
            return false;

    },
    addedXYValues: function (excludeDataUpdate) {
        excludeDataUpdate = (excludeDataUpdate) ? excludeDataUpdate : false;
        var type = this.model.series[0].type.toLowerCase(),
            pointLength;
        if (ej.seriesTypes[type].prototype.chartAreaType == "cartesianAxes") {
            this.model.AreaType = "cartesianaxes";
        }
        else if (ej.seriesTypes[type].prototype.chartAreaType == "None")
            this.model.AreaType = "none";
        else {
            if (type == 'polar')
                this.model.isPolar = true;
            else
                this.model.isPolar = false;

            this.model.AreaType = "polaraxes";
        }
        if (!excludeDataUpdate) {
            for (var i = 0; i < this.model.series.length; i++) {
                if (this.model.series[i].visibility == "visible") {
                    var setXValueType = false, isDatetime = false, pointX, currentSeries;

                    if (!this.model.series[i].dataSource || this.model.series[i].dataSource.length == 0) {
                        this.model.series[i] = $.extend(true, {}, this.model.commonSeriesOptions, this.model.series[i]);
                        currentSeries = this.model.series[i];
                        if (this.model.primaryXAxis.valueType == "datetime")
                            isDatetime = true;
                        pointLength = currentSeries.points.length;
                        for (k = 0; k < pointLength; k++) {
                            currentSeries.points[k].YValues = [];
                            if (!isNaN(parseFloat(currentSeries.points[k].x)) && (/^-?[0-9]*\.?[0-9]+$/.test(currentSeries.points[k].x) == true) && (this.model.primaryXAxis.valueType != "category") && (this.model.AreaType != "none")) {
                                if (!isDatetime) {
                                    currentSeries.points[k].xValue = parseFloat(currentSeries.points[k].x);
                                    currentSeries.points[k].x = parseFloat(currentSeries.points[k].x);
                                }
                                else {
                                    currentSeries.points[k].xValue = new Date(currentSeries.points[k].x);
                                    currentSeries.points[k].x = new Date(currentSeries.points[k].x);
                                }
                            }
                            else
                                currentSeries.points[k].xValue = currentSeries.points[k].x;
                            if (!setXValueType) {
                                pointX = currentSeries.points[k].x;
                                if (!ej.util.isNullOrUndefined(pointX)) {
                                    currentSeries._xAxisValueType = this._getDataType(pointX);
                                    setXValueType = true;
                                }
                            }
                            if (!(currentSeries._hiloTypes)) {
                                currentSeries.points[k].YValues[0] = currentSeries.points[k].y;

                                if (!ej.util.isNullOrUndefined(currentSeries.points[k].size))
                                    currentSeries.points[k].YValues[1] = currentSeries.points[k].size;

                            }
                            else {
                                if (!ej.util.isNullOrUndefined(currentSeries.points[k].high)) {
                                    currentSeries.points[k].YValues[0] = currentSeries.points[k].high;
                                    currentSeries.points[k].y = currentSeries.points[k].high;
                                }
                                if (!ej.util.isNullOrUndefined(currentSeries.points[k].low))
                                    currentSeries.points[k].YValues[1] = currentSeries.points[k].low;
                                if (!ej.util.isNullOrUndefined(currentSeries.points[k].open))
                                    currentSeries.points[k].YValues[2] = currentSeries.points[k].open;
                                if (!ej.util.isNullOrUndefined(currentSeries.points[k].close))
                                    currentSeries.points[k].YValues[3] = currentSeries.points[k].close;
                            }
                        }
                    }
                    else {
                        currentSeries = this.model.series[i];
                        currentSeries._xAxisValueType = null;
                        pointLength = currentSeries.points.length;
                        for (var j = 0, length = pointLength; j < length; j++) {
                            pointX = currentSeries.points[j].x;
                            if ((pointX != null && pointX != undefined) && (currentSeries._xAxisValueType === null || currentSeries._xAxisValueType === undefined)) {
                                currentSeries._xAxisValueType = this._getDataType(pointX);
                            }
                            if (currentSeries._xAxisValueType != "string")//skip the category series to avoid series removing on zooming
                                currentSeries.points[j].xValue = currentSeries.points[j].x;
                        }
                    }
                    //Calculate waterfall series points and remove on series changed
                    if (currentSeries.type.toLowerCase() == "waterfall")
                        this.calculateWaterfallSeriesPoints(currentSeries.points);
                    else if (currentSeries._previousType && currentSeries._previousType.toLowerCase() == "waterfall") {
                        var visiblePoints = currentSeries.points;
                        for (var j = 0; j < visiblePoints.length; j++) {
                            visiblePoints[j].waterfallSum = undefined;
                            visiblePoints[j].textOptions = null;
                        }
                    }
                }
            }
           this._setInternalValues();
         }
    },
    calculateWaterfallSeriesPoints: function (visiblePoints) {
        
        var intermediateStartValue = 0;
        var totalSum = 0;
        var previousSum = 0;

        for (var j = 0; j < visiblePoints.length; j++) {
            if (!visiblePoints[j].isEmpty) {
                totalSum += ((visiblePoints[j].showIntermediateSum || visiblePoints[j].showTotalSum) ? 0 : visiblePoints[j].y);

                if (visiblePoints[j].showIntermediateSum) {
                    visiblePoints[j].YValues[1] = intermediateStartValue;
                    visiblePoints[j].YValues[0] = totalSum;
                    visiblePoints[j].waterfallSum = totalSum - intermediateStartValue;
                    intermediateStartValue = totalSum;
                } else if (visiblePoints[j].showTotalSum) {
                    visiblePoints[j].YValues[1] = 0;
                    visiblePoints[j].YValues[0] = totalSum;
                    visiblePoints[j].waterfallSum = totalSum;
                }
                else {
                    visiblePoints[j].YValues[1] = previousSum;
                    visiblePoints[j].YValues[0] = previousSum + visiblePoints[j].y;
                    previousSum = totalSum;
                }
            } else {
                visiblePoints[j].YValues[1] = 0;
                visiblePoints[j].YValues[0] = 0;
            }
        }
    },
    _setInternalValues: function () {
        
        for (var k = 0; k < this.model.series.length; k++) {
            var series = this.model.series[k];
            if (this.model.AreaType == "cartesianaxes" && ej.seriesTypes[series.type.toLowerCase()].prototype.chartAreaType == "cartesianAxes") {
                series._zOrder = (series.zOrder) ? series.zOrder : 0;
                this.model._visibleSeries.push(series);
            }
            else if (this.model.AreaType == "none" && ej.seriesTypes[series.type.toLowerCase()].prototype.chartAreaType == "None") {
                series._zOrder = (series.zOrder) ? series.zOrder : 0;
                this.model._visibleSeries.push(series);
            }
            else if (this.model.AreaType == "polaraxes" && ej.seriesTypes[series.type.toLowerCase()].prototype.chartAreaType == "PolarAxes") {
                series._zOrder = (series.zOrder) ? series.zOrder : 0;
                this.model._visibleSeries.push(series);
            }

            if (series._yAxisName || series._xAxisName) {
                if (this.model._axes) {
                    for (var t = 0; t < this.model._axes.length; t++) {
                        if (series._yAxisName && (series._yAxisName == this.model._axes[t].name)) {
                            this.model._axes[t].orientation = (this.model._axes[t].orientation) ? this.model._axes[t].orientation : (this.model.requireInvertedAxes) ? "horizontal" : "vertical";
                        }
                        if (series._xAxisName && (series._xAxisName == this.model._axes[t].name)) {
                            this.model._axes[t].orientation = (this.model._axes[t].orientation) ? this.model._axes[t].orientation : (this.model.requireInvertedAxes) ? "vertical" : "horizontal";
                        }
                    }
                }
            }
        }
    },
    setHiloStyle: function(series, pointIndex, seriesIndex, interiorColor){
        var point = series.points[pointIndex];
                  
        if (point.fill)
              interior = point.fill;
         else
              interior = series.fill ? series.fill : interiorColor;
				
            // setting default series color		
            var colors = interior ? interior : this.model.seriesColors[seriesIndex];
          
            // applying gradient color		  
         
            seriesInterior = jQuery.type(colors) == "array" ? colors[0].color : colors;

            return seriesInterior;
                       
    },
	setStyle: function (chart, series, seriesIndex, pointIndex, interiorColor) {
    
	    var point = series._visiblePoints[pointIndex], interior, borderColor, borderWidth, dashArray, 
            opacity, seriesFill, pointBorder = point.border, seriesBorder = series.border;
       // var pointStyle = point.style ? point.style : " ";
      
		if (series._hiloTypes)
		   seriesFill = series.isFill ? series.fill : null; 
		   
        // setting interior
        if (chart.chartObj.model.AreaType == "cartesianaxes") {
            if (point.fill)
                interior = point.fill;
            else {
                if (series.type.toLowerCase() == "waterfall") {
                    if (((point.showIntermediateSum || point.showTotalSum) && (point.waterfallSum > 0)) || (point.y > 0) && !point.showIntermediateSum && !point.showTotalSum)
                        interior = series.positiveFill ? series.positiveFill : interiorColor;
                } else
                    interior = seriesFill ? seriesFill : interiorColor;
            }
				
		// setting default series color		
            var colors = interior ? interior : this.model.seriesColors[seriesIndex];
          
        // applying gradient color		  
			if (chart.chartObj.model.requireInvertedAxes) 
                var seriesInterior = this.svgRenderer.createGradientElement(chart.getSeriesName(series) + "_" + seriesIndex + pointIndex, colors, 0, 0, 100, 0, chart.gSeriesGroupEle);
            else                                       
                seriesInterior = this.svgRenderer.createGradientElement(chart.getSeriesName(series) + "_" + seriesIndex + pointIndex, colors, 0, 0, 0, 100, chart.gSeriesGroupEle);
         } 
		 
		// interior for pie type series
        else {
            var pointColors = this.model.pointColors;
            interior = point.fill ? point.fill : jQuery.type(pointColors[pointIndex]) == "array" ? pointColors[pointIndex][0].color : pointColors[pointIndex];
            var pointInterior = this.svgRenderer.createGradientElement(chart.getSeriesName(series) + pointIndex, interior, 0, 0, 0, ($(chart.svgObject).height() || parseFloat(this.model.size.height)), chart.chartObj.gSeriesEle);
        }
        
        // setting borderColor
        borderColor = ((pointBorder) && pointBorder.color) ? pointBorder.color : seriesBorder.color;
        borderWidth = ((pointBorder) && pointBorder.width) ? pointBorder.width : seriesBorder.width;
        opacity = point.opacity ? point.opacity : series.opacity;
        width = (point.width) ? point.width : series.width;
        dashArray = ((pointBorder) && pointBorder.dashArray) ? pointBorder.dashArray : seriesBorder.dashArray;

        var options = {
            'interior': seriesInterior ? seriesInterior: pointInterior,
            'borderColor': borderColor,
            'borderWidth': borderWidth,
            'width': width,
            'opacity': opacity,
            'dashArray': dashArray
        };
        return options;
    },
	
    colorNameToHex: function (colour) {
        var color = colour;
        var colours = {
            "aliceblue": "#f0f8ff", "antiquewhite": "#faebd7", "aqua": "#00ffff", "aquamarine": "#7fffd4", "azure": "#f0ffff",
            "beige": "#f5f5dc", "bisque": "#ffe4c4", "black": "#000000", "blanchedalmond": "#ffebcd", "blue": "#0000ff", "blueviolet": "#8a2be2", "brown": "#a52a2a", "burlywood": "#deb887",
            "cadetblue": "#5f9ea0", "chartreuse": "#7fff00", "chocolate": "#d2691e", "coral": "#ff7f50", "cornflowerblue": "#6495ed", "cornsilk": "#fff8dc", "crimson": "#dc143c", "cyan": "#00ffff",
            "darkblue": "#00008b", "darkcyan": "#008b8b", "darkgoldenrod": "#b8860b", "darkgray": "#a9a9a9", "darkgreen": "#006400", "darkkhaki": "#bdb76b", "darkmagenta": "#8b008b", "darkolivegreen": "#556b2f",
            "darkorange": "#ff8c00", "darkorchid": "#9932cc", "darkred": "#8b0000", "darksalmon": "#e9967a", "darkseagreen": "#8fbc8f", "darkslateblue": "#483d8b", "darkslategray": "#2f4f4f", "darkturquoise": "#00ced1",
            "darkviolet": "#9400d3", "deeppink": "#ff1493", "deepskyblue": "#00bfff", "dimgray": "#696969", "dodgerblue": "#1e90ff",
            "firebrick": "#b22222", "floralwhite": "#fffaf0", "forestgreen": "#228b22", "fuchsia": "#ff00ff",
            "gainsboro": "#dcdcdc", "ghostwhite": "#f8f8ff", "gold": "#ffd700", "goldenrod": "#daa520", "gray": "#808080", "green": "#008000", "greenyellow": "#adff2f",
            "honeydew": "#f0fff0", "hotpink": "#ff69b4",
            "indianred ": "#cd5c5c", "indigo ": "#4b0082", "ivory": "#fffff0", "khaki": "#f0e68c",
            "lavender": "#e6e6fa", "lavenderblush": "#fff0f5", "lawngreen": "#7cfc00", "lemonchiffon": "#fffacd", "lightblue": "#add8e6", "lightcoral": "#f08080", "lightcyan": "#e0ffff", "lightgoldenrodyellow": "#fafad2",
            "lightgrey": "#d3d3d3", "lightgreen": "#90ee90", "lightpink": "#ffb6c1", "lightsalmon": "#ffa07a", "lightseagreen": "#20b2aa", "lightskyblue": "#87cefa", "lightslategray": "#778899", "lightsteelblue": "#b0c4de",
            "lightyellow": "#ffffe0", "lime": "#00ff00", "limegreen": "#32cd32", "linen": "#faf0e6",
            "magenta": "#ff00ff", "maroon": "#800000", "mediumaquamarine": "#66cdaa", "mediumblue": "#0000cd", "mediumorchid": "#ba55d3", "mediumpurple": "#9370d8", "mediumseagreen": "#3cb371", "mediumslateblue": "#7b68ee",
            "mediumspringgreen": "#00fa9a", "mediumturquoise": "#48d1cc", "mediumvioletred": "#c71585", "midnightblue": "#191970", "mintcream": "#f5fffa", "mistyrose": "#ffe4e1", "moccasin": "#ffe4b5",
            "navajowhite": "#ffdead", "navy": "#000080",
            "oldlace": "#fdf5e6", "olive": "#808000", "olivedrab": "#6b8e23", "orange": "#ffa500", "orangered": "#ff4500", "orchid": "#da70d6",
            "palegoldenrod": "#eee8aa", "palegreen": "#98fb98", "paleturquoise": "#afeeee", "palevioletred": "#d87093", "papayawhip": "#ffefd5", "peachpuff": "#ffdab9", "peru": "#cd853f", "pink": "#ffc0cb", "plum": "#dda0dd", "powderblue": "#b0e0e6", "purple": "#800080",
            "red": "#ff0000", "rosybrown": "#bc8f8f", "royalblue": "#4169e1",
            "saddlebrown": "#8b4513", "salmon": "#fa8072", "sandybrown": "#f4a460", "seagreen": "#2e8b57", "seashell": "#fff5ee", "sienna": "#a0522d", "silver": "#c0c0c0", "skyblue": "#87ceeb", "slateblue": "#6a5acd", "slategray": "#708090", "snow": "#fffafa", "springgreen": "#00ff7f", "steelblue": "#4682b4",
            "tan": "#d2b48c", "teal": "#008080", "thistle": "#d8bfd8", "tomato": "#ff6347", "turquoise": "#40e0d0",
            "violet": "#ee82ee",
            "wheat": "#f5deb3", "white": "#ffffff", "whitesmoke": "#f5f5f5",
            "yellow": "#ffff00", "yellowgreen": "#9acd32"
        };

        if (Object.prototype.toString.call(color) == '[object Array]')
            return color;

        if (typeof colours[color.toLowerCase()] != 'undefined')
            return colours[color.toLowerCase()];

        return color;
    },
	
	_getLocalizedLabels: function(){
        return ej.getLocalizedConstants(this.sfType, this.model.locale);
    },
	
	// set culture for chart
     _setCulture: function (culture) {
         this.culture = ej.preferredCulture(culture);
    },
	
	
     draw: function (excludeDataUpdate) {
        this.removeMultiRect();
        var params = {};
		params.axes = {};		
		this._drawBackInterior();
        this.model.chartRegions = [];         
		this.model.outsideDataRegionPoints = [];
		this.model.regionCount = null;
		this.model.circularRadius = [];
       this.model.innerRadius = [];
       this.model.bounds = [];
       this.accDataLabelRegion = [];
       this.model.rightsidebounds = [];
		this.model.leftsidebounds = [];
        this.model.excludeDataUpdate = excludeDataUpdate;
		this.model.yAxisLabelRegions = [];
		this.model.xAxisLabelRegions = [];
		this.model.axisMultiLevelLabelRegions = [];
		this.model.multiLevelLabelRegions = [];
		this.model.minhightwidth = false;
		this.model._isPieOfPie = false;
        if (!excludeDataUpdate)
            this.model._visibleSeries = [];
        this.model.stackedValue = {};
        this.model._locale = this.model.locale || "en-US";      
        this._setCulture(this.model._locale);
		 this._localizedLabels = this._getLocalizedLabels();
		var seriesLength = this.model.series.length;
		 var series, seriesType;
        if (ej.util.isNullOrUndefined(this.model.sideBySideSeriesPlacement))  // for setting sideBySideSeriesPlacement property values
            this.model._sideBySideSeriesPlacement = (this.model.enable3D) ? false : true;
        else
            this.model._sideBySideSeriesPlacement = this.model.sideBySideSeriesPlacement;
        for (var i = 0; i < seriesLength; i++)
        {
            series = this.model.series[i];
            seriesType = series.type.toLowerCase();
            series._isTransposed = (seriesType.indexOf("bar") == -1) ? series.isTransposed : !series.isTransposed;
        }
        if (seriesLength > 0)
            this.addedXYValues(excludeDataUpdate);
        this.model.AreaType = this.model.AreaType || "cartesianaxes";
        
		this._isEjScroller();        

        var commonpreRenderEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonpreRenderEventArgs.data = {};
        this._trigger("preRender", commonpreRenderEventArgs);

        this.gLegendEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_Legend' });

        this.gTitleEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_ChartTitle','cursor':'default' });
        this.gSubTitleEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_ChartsubTitle','cursor':'default' });
        this._createAxisLabelAndRange();
		for(var i=0; i<this.model._axes.length; i++)
			params.axes[this.model._axes[i].name] = {};
        this._initializeSeriesColors();

        this._calculateLegendBounds();

        this.legendRender = new ej.EjLegendRender(this);

        var commonLegendEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonLegendEventArgs.data = { legendBounds: this.model.LegendBounds };
        this._trigger("legendBoundsCalculate", commonLegendEventArgs);

         // Assigning indicator points
        for (var j = 0; j < this.model.indicators.length; j++) {
            var indicator = this.model.indicators[j];
			indicator._points = [];
            indicator.xAxisName = (!(indicator.xAxisName)) ? this.model._axes[0].name : indicator.xAxisName;
            indicator.yAxisName = (!(indicator.yAxisName)) ? this.model._axes[1].name : indicator.yAxisName;
            indicator.isIndicator = true;
            if (indicator.dataSource) {
                indicator._hiloTypes = true;
                this._processJsonData(indicator.dataSource, indicator);
				//Indicator uses _points but ProcessJsonData only populate points collection
                indicator._points = indicator.points;
            } else if (indicator.points.length > 0) {
                for (var i = 0; i < indicator.points.length; i++) {
				     indicator._points = indicator.points;
                    indicator._points[i].xValue = indicator.points[i].x;
                    indicator._points[i].YValues = [];
                    indicator._points[i].YValues[0] = indicator.points[i].close;
                }
            }
            else if (indicator.seriesName != "") {
                for (var index = 0; index < this.model._visibleSeries.length; index++) {
                    var series = this.model._visibleSeries[index];
                    if (indicator.seriesName == series.name)
                        indicator._points = $.extend(true, [], series.points);
                }
            }
        }

         // calculate category points
        for (k = 0; k < this.model._axes.length; k++) {
            if (this.model._axes[k].valueType && this.model._axes[k].valueType.toLowerCase() == "category") {
                for (i = 0; i < this.model.indicators.length; i++) {
                    indicator = this.model.indicators[i];
                    if (this.model._axes[k].name == indicator.xAxisName) {
                        for (j = 0; j < indicator._points.length; j++)
                            indicator._points[j].xValue = j;
                    }
                }
            }
        }

         // calculate ranges for indicator
        this.model.indicatorRange = [];
        for (index = 0; index < this.model.indicators.length; index++) {
            indicator = this.model.indicators[index];
            if (indicator._points.length > 0) {
                type = indicator.type.toLowerCase();
              options = new ej.indicatorTypes[type]();
              options.calculateSegment(indicator, this);
         }
     }


         for (var m = 0; m < this.model._visibleSeries.length; m++) {
            var options = this.model._visibleSeries[m];
            for (i = 0; i < options.points.length; i++) {
                if (typeof options.points[i].xValue == "string" && options.points[i].xValue.indexOf("/Date(") != -1)
                    options.points[i].xValue = new Date(parseInt(options.points[i].xValue.substr(6)));
            }
        }
        this.model.hAxes = [];
        this.model.vAxes = [];
        var chartobj = this;
        var isStriplineOver = false, isStriplineBehind = false;
        this._arrangeAxis();
        var scrollbarSettings;
        this.model.crosshairLabelVisibility = false;
        for (var k = 0; k < this.model._axes.length; k++) {            
            var axis = this.model._axes[k];
            this.model.crosshairLabelVisibility = axis.crosshairLabel.visible || this.model.crosshairLabelVisibility;
            var seriesCollection = [];
            var seriesLength = this.model.series.length;
            var orientation = this.model._axes[k].orientation.toLowerCase();
            var padding = this.model._axes[k].rangePadding.toLowerCase();
            if (padding == "auto") {
                if (orientation == "vertical") {
                    axis.rangePadding = (!this.model.requireInvertedAxes) ? "normal" : "none";
                }
                if (orientation == "horizontal") {
                    axis.rangePadding = (this.model.requireInvertedAxes) ? "normal" : "none";
                }
                for (var j = 0; j < seriesLength; j++) {
                    var type = this.model.series[j].type.toLowerCase();
                    if (type.indexOf("100") != -1) {
                        if (axis.name == this.model.series[j]._yAxisName) {
                            axis.rangePadding = "round"; break;
                        }
                    }
                }
            }          
            for (var slCount = 0; slCount < axis.stripLine.length; slCount++) {
                axis.stripLine[slCount] = $.extend(true, {}, this.model.stripLineDefault, axis.stripLine[slCount]);
                if (axis.stripLine[slCount].zIndex.toLowerCase() == 'over') {
                    isStriplineOver = true;
                } else {
                    isStriplineBehind = true;
                }
            }
            var axisOrientation = axis.orientation.toLowerCase();
            var zOrder = this.model._visibleSeries.length - 1;
            for (j = 0; j < this.model._visibleSeries.length; ++j) {
                zOrder -= 1;
                                      
                    var series = this.model._visibleSeries[j];
                    this.model._hasSeriesPoints = series.points.length > 0 || this.model._hasSeriesPoints;
                    if((!series.xAxisName)){
                    series._xAxisName = chartobj.model._axes[0].name;
					 }
					if(!series.yAxisName){
                    series._yAxisName = chartobj.model._axes[1].name;
                    }
					 series._xAxisName=(!(series._xAxisName))?(!(series.xAxisName)?chartobj.model._axes[0].name:series.xAxisName):series._xAxisName;
                    series._yAxisName = (!(series._yAxisName)) ? (!(series.yAxisName)?chartobj.model._axes[1].name :series.yAxisName):series._yAxisName;
                    var xAxisName = series._xAxisName.toLowerCase();
                    var yAxisName = series._yAxisName.toLowerCase();
                    var name = axis.name.toLowerCase();
                    if (xAxisName || yAxisName) {
                        if (xAxisName == name || yAxisName == name) {
                            if ((axisOrientation == "horizontal" || (series.type.toLowerCase().indexOf("bar") != -1 && axisOrientation == "vertical")) && axis.valueType && axis.valueType.toString() == "datetime") {
                                for (var m = 0; m < series.points.length; m++) {
                                    if (typeof series.points[m].xValue == "string" && !isNaN(Date.parse(series.points[m].xValue)))
                                        series.points[m].xValue = new Date(Date.parse(series.points[m].xValue));
                                }
                            }
                            else {
                                if (series._xAxisValueType == "string" && !(axis.valueType))
                                    axis._valueType = (axisOrientation == 'horizontal' && !this.model.requireInvertedAxes) ? 'category' : (axisOrientation == 'vertical' && this.model.requireInvertedAxes) ? 'category' : 'double';

                                if (series._xAxisValueType == "date" && !(axis.valueType))
                                    axis._valueType = (axisOrientation == 'horizontal' && !this.model.requireInvertedAxes) ? "datetime" : (axisOrientation == 'vertical' && this.model.requireInvertedAxes) ? 'datetime' : 'double';
                            }
							if (this.model._visibleSeries[j].visibility.toLowerCase() == 'visible')
                            seriesCollection.push(series);
                        }
                    
                }
            }
            if (axisOrientation == ((!this.model.requireInvertedAxes) ? "vertical" : "horizontal")) {
                var isStacked100 = false;
                var isStacked = false;               
                var seriesLength = seriesCollection.length;
                axis.isStacked100 = (seriesCollection.length>0) ? true :false;
                for (var i = 0; i < seriesLength; i++) {
                    var type = seriesCollection[i].type.toLowerCase();
                    if (ej.seriesTypes[type].prototype.stackingSeries || (this.model.AreaType == 'polaraxes' && seriesCollection[i].drawType.toLowerCase() == 'column' && seriesCollection[i].isStacking)) {
                        if (type.indexOf("100") != -1 && (!isStacked100)) {
                            this._calculateStackingCumulativeValues(seriesCollection, axis, params);
                            isStacked100 = true;
                        } else if (type.indexOf("100") == -1 && (!isStacked)) {
                            this._calculateStackingValues(seriesCollection, axis, params);
                            isStacked = true;
                            axis.isStacked100 = false;
                        }                     
                    }
                    else {
                        axis.isStacked100 = false;
                    }
                }
            }
            scrollbarSettings = axis.scrollbarSettings;
            if ((scrollbarSettings.visible) && (scrollbarSettings.pointsLength != null || scrollbarSettings.range.min != null || scrollbarSettings.range.max != null)) {
                this.model.isLazyZooming = true;
            }
            axis._valueType = (!(axis._valueType)) ? (!(axis.valueType) ? "double" : axis.valueType) : axis._valueType;
            var axisRange = new ej.axisTypes[axis._valueType.toLowerCase()]();
            for (var ser = 0; ser < seriesCollection.length; ser++) {
                for (var trend = 0; trend < seriesCollection[ser].trendlines.length; trend++) {
                    if (seriesCollection[ser].trendlines[trend].visibility == "visible") {
                        this.model._drawTrendline = true;
                        break;
                    }
                }
            }
            axisRange._calculateRanges(chartobj, axis, seriesCollection, params);             
        }
        chartobj._chartResize = false; 
		
        var commonAxesInitEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonAxesInitEventArgs.data = { axes: this.model._axes };
        this._trigger("axesLabelsInitialize", commonAxesInitEventArgs);

        this.model.isLazyZooming ? 0 : this._updateScroll();
         var prevHeight,
             prevWidth;
         if (this.svgHeight != this.model.svgHeight || this.svgWidth != this.model.svgWidth) {
            // beforeResize event
            prevHeight=ej.util.isNullOrUndefined(this.prevHeight)?this.svgHeight:this.prevHeight;
            prevWidth = ej.util.isNullOrUndefined(this.prevWidth) ? this.svgWidth : this.prevWidth;
            commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { currentHeight: prevHeight, currentWidth: prevWidth, newHeight: this.model.svgHeight, newWidth: this.model.svgWidth };
            this._trigger("beforeResize", commonEventArgs);
            if (!commonEventArgs.cancel) {
                if (this.model.enableCanvasRendering) {
                    this.svgRenderer.svgObj.width = commonEventArgs.data.newWidth;
                    this.svgRenderer.svgObj.height = commonEventArgs.data.newHeight;
                }
                this.model.svgWidth = commonEventArgs.data.newWidth;
                this.model.svgHeight = commonEventArgs.data.newHeight;
                $(this.svgObject).width(commonEventArgs.data.newWidth);
                $(this.svgObject).height(commonEventArgs.data.newHeight);
            }
            else
            { 
                if (this.model.enableCanvasRendering)
                {
                    this.svgRenderer.svgObj.width = commonEventArgs.data.currentWidth;
                    this.svgRenderer.svgObj.height = commonEventArgs.data.currentHeight;
                }
                this.model.svgWidth = commonEventArgs.data.currentWidth;
                this.model.svgHeight = commonEventArgs.data.currentHeight;
                $(this.svgObject).width(commonEventArgs.data.currentWidth);
                $(this.svgObject).height(commonEventArgs.data.currentHeight);
            }
        }
        this._calculateAreaBounds(params);

        if (this.model.enable3D) {

            var Ej3DRender = new ej.Ej3DRender();
            this.vector = new Ej3DRender.vector3D();
            this.matrixobj = new Ej3DRender.matrix3D();
            this.bsptreeobj = new Ej3DRender.BSPTreeBuilder();
            this.polygon = new Ej3DRender.polygon3D();
            this.graphics = new Ej3DRender.Graphics3D();

            this.chart3D = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_Chart3D' });
            ej.Ej3DRender.Polygons = [];
        }


        if (this.model.AreaType != "none") {        

            this._calculateAxisSize(params);

            //AxisCrossing                
            for (var i = 0, len = this.model._axes.length; i < len; i++)
                if (this._validateCrossing(this.model._axes[i]))
                    this._axisCrossing(this.model._axes[i], false, params);
            if (params._crossAxisOverlap)
			{
                for (var i = 0, len = this.model._axes.length; i < len; i++)
                    if (params.axes[this.model._axes[i].name]._validCross)
                        this._axisCrossing(this.model._axes[i], true, params);
                params._crossAxisOverlap = false;
			}

            var commonAreaEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonAreaEventArgs.data = { areaBounds: this.model.m_AreaBounds };
            this._trigger("chartAreaBoundsCalculate", commonAreaEventArgs);

            this._drawChartAreaRect();

            if (this.model.title.text != "" && this.model.title.text && this.model.title.visible)
                this._drawTitle();
            
            this.gXaxisEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxis' });

            this.gYaxisEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxis' });
     
            this.gPolarAxisEle = this.svgRenderer.createGroup( { 'id': this.svgObject.id + '_AxisLine' });
            if (this.model.enable3D) {

                $.extend(ej.Ej3DAxisRenderer.prototype, this);
                this.chartaxis = new ej.Ej3DAxisRenderer(this);
            }
            else {
                $.extend(ej.EjAxisRenderer.prototype, this);
                this.chartaxis = new ej.EjAxisRenderer(this);
            }

            var chartaxis = this.chartaxis;
			this.model.xAxisTitleRegion = [];
            this.model.yAxisTitleRegion = [];
                               
			if (this.model.enable3D) {
			    for (var l = 0; l < this.model._axes.length; l++) {
			        chartaxis._drawAxes(l, this.model._axes[l], params);
			    }
			    ej.Ej3DChart.prototype.update3DWall(this, params);
			}
			else {
			    for (var l = 0; l < this.model._axes.length; l++) {
			        chartaxis._drawGridLines(l, this.model._axes[l], params);
			    }
			}
          

            //Based on the column/bar series, modified primaryAxis append to the SVG Object
            if (!this.model.requireInvertedAxes) { 
                this.svgRenderer.append(this.gXaxisEle, this.svgObject);
                this.svgRenderer.append(this.gYaxisEle, this.svgObject);
            } else {
                this.svgRenderer.append(this.gYaxisEle, this.svgObject);
                this.svgRenderer.append(this.gXaxisEle, this.svgObject);
            }

            var x = (this.model.AreaType == 'polaraxes') ? 0: this.model.m_AreaBounds.X;
            var y = (this.model.AreaType == 'polaraxes') ? 0 : this.model.m_AreaBounds.Y;

            var width = (this.model.AreaType == 'polaraxes') ? $(this.svgObject).width() : this.model.m_AreaBounds.Width;
            var height = (this.model.AreaType == 'polaraxes') ? $(this.svgObject).height() : this.model.m_AreaBounds.Height;

            var clipRectOptions = {
                'id': this.svgObject.id + '_ChartAreaClipRect',
                'x': x,
                'y': y,
                'width': width,
                'height': height,
                'fill': 'white',
                'stroke-width': 1,
                'stroke': 'Gray'
            };

            this.svgRenderer.drawClipPath(clipRectOptions, this.svgObject);
			
			this._setZoomProperties();
        }

        else {
            this._drawChartAreaRect();

            clipRectOptions = {
                'id': this.svgObject.id + '_ChartAreaClipRect',
                'x': 0,
                'y': 0,
                'width': $(this.svgObject).width(),
                'height': $(this.svgObject).height(),
                'fill': 'white',
                'stroke-width': 1,
                'stroke': 'Gray'
            };

            this.svgRenderer.drawClipPath(clipRectOptions, this.svgObject);

            if (this.model.title.text != "" && this.model.title.text && this.model.title.visible)
                this._drawTitle();
        }

        if (isStriplineBehind && this.model.AreaType == "cartesianaxes" && !this.model.enable3D) {
            this.gStriplineBehind = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_StriplineBehind', 'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)' });
            this._renderStripline('behind');
        }
		if (this.model.initSeriesRender) {
            this.seriesRender(params);
            this.indicatorRender();
        }
         
		var annotationsLength = this.model.annotations.length; 
        $('#annotation_group_' + this._id).empty();
		for (var a = 0; a < annotationsLength; a++) {
            var currentAnnotation = this.model.annotations[a];
            if (currentAnnotation.visible) {
                this.annotationRender(currentAnnotation, a);
              }
        }
		
		if (this.model.AreaType == "polaraxes" && this.model._axes[1].visible && !this.model.enable3D) {
            this.chartaxis._drawAxisLine(this.model._axes[1]);
        }
		
		if(this.model.AreaType==="cartesianaxes"){
			if (!this.model.requireInvertedAxes) {
				this.svgRenderer.append(this.gXaxisEle, this.svgObject);
				this.svgRenderer.append(this.gYaxisEle, this.svgObject);
			} else {
				this.svgRenderer.append(this.gYaxisEle, this.svgObject);
				this.svgRenderer.append(this.gXaxisEle, this.svgObject);
			}

			this.gXaxisTickEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_XAxisTick' });

			this.gYaxisTickEle = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_YAxisTick' });
        }      

        $.extend(ej.EjAxisRenderer.prototype, this);
        this.chartaxis = new ej.EjAxisRenderer(this);
        var chartaxis = this.chartaxis;
       
        if (isStriplineOver && this.model.AreaType == "cartesianaxes" && !this.model.enable3D) {
            this.gStriplineOver = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_StriplineOver', 'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)' });
            this._renderStripline('over');
        }

        if(!this.model.enable3D)
        //draw axes, labels and ticks
        for (var l = 0, len = this.model._axes.length; l < len; l++) {
            var axis = this.model._axes[l], lineOption = params.axes[axis.name]._lineOption, isValidCross = params.axes[axis.name]._validCross;
            if (this.model.AreaType.toLowerCase() == "cartesianaxes") {                
                chartaxis._drawAxes(l, axis);
                if (lineOption[0])
                    this.svgRenderer.drawLine(lineOption[0], lineOption[1]);
                if (axis.orientation.toLowerCase() === "horizontal") {
                    chartaxis._drawXAxisTickLine(l, axis, this.model.enableCanvasRendering ? null : params.axes[axis.name]._lineOption[1],params);
                    chartaxis._drawXAxisMultiLevelLabels(l, axis);
                }
                else {
                    chartaxis._drawYAxisTickLine(l, axis, this.model.enableCanvasRendering ? null : lineOption[1],isValidCross);
                    chartaxis._drawYAxisMultiLevelLabels(l, axis);
                }
                axis._crossValue = null;
            }
        }
         if (!this.resetZooming && (this.model._chartAreaZoom || this.panning))
             this._enableZoomingButtons();
         this.resetZooming = false;

         if (this.svgHeight != this.model.svgHeight || this.svgWidth != this.model.svgWidth) {
                      
             this.prevHeight = this.model.svgHeight;
             this.prevWidth = this.model.svgWidth; 
             // afterResize event 
             var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
             commonEventArgs.data = { height: this.prevHeight, width: this.prevWidth, prevHeight: prevHeight, prevWidth: prevWidth, originalHeight: this.svgHeight, originalWidth: this.svgWidth };
             this._trigger("afterResize", commonEventArgs);
         }

         //Checking Selection setting enable 
         var seriesCollection = this.model._visibleSeries, selectionFound;
         selectionFound = $.grep(seriesCollection, function (series) { return series.selectionSettings.enable.toString() == "true"; });
         if (selectionFound.length == 0) {
             this.model.selectionEnable = false;
             this._removeSelection();
         } else
             this.model.selectionEnable = true;

         var selectedData = this.remove_duplicates(this.model.selectedDataPointIndexes);
         //Maintaning the selection state and triggering seleceted data
         if (this.model.selectionEnable) {
             this._removeSelection();
             this.model._isStateChaged = true;
             var data,
                 mode,
             length = selectedData.length;                      
             for (var i = 0; i < length; i++) {
                 data = selectedData[i];
                 series = this.model._visibleSeries[data.seriesIndex];
                 if (series) {
                     mode = series.selectionSettings.mode;
                     if((mode != 'series' && series.points[data.pointIndex]) ||mode == 'series')
                        this.segmentSelection(data.event, data.legendData, data.seriesIndex, data.pointIndex, data.data);
                 }
             }
         }
		this.chartUpdating = false;
        var commonLoadedEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonLoadedEventArgs.data = { model: this.model };
        this._trigger("loaded", commonLoadedEventArgs);


     },
     remove_duplicates: function (arr) {
         var arr1 = [],
             arr2 = [],
             length = arr.length,
             mode,
	     	 currentSeries,
             series = this.model._visibleSeries;
         for (var i = 0; i < length; i++) {
             currentSeries = series[arr[i].seriesIndex];
             mode = currentSeries ? currentSeries.selectionSettings.mode : "";
             if (mode == "series") {
                 if (!(arr1.indexOf(arr[i].seriesIndex) > -1))
                     arr2.push(arr[i]);
                 arr1.push(arr[i].seriesIndex);
             }
             else if (mode == "cluster") {
                 if (!(arr1.indexOf(arr[i].pointIndex) > -1))
                     arr2.push(arr[i]);
                 arr1.push(arr[i].pointIndex);
             } else {
                 if (!(arr[i] in arr1))
                     arr2.push(arr[i]);
                 arr1.push(arr[i]);
             }
         }

         return arr2;

     },
	
	// set value to private variable for two way binding
	_setZoomProperties: function () {

         var axis, _zf, _zp, orientation;
	    for (var l = 0; l < this.model._axes.length; l++) {
	        axis = this.model._axes[l];
	        orientation = axis.orientation.toLowerCase();
	        _zf = axis.zoomFactor.toFixed(3);
	        _zp = axis.zoomPosition.toFixed(3);
	        if (orientation == "horizontal" && (_zf != this._xZoomFactor() || _zp != this._xZoomPosition())) {
	            this._xZoomFactor(axis.zoomFactor.toFixed(3));
	            this._xZoomPosition(axis.zoomPosition.toFixed(3));
	        }
	        if (orientation == "vertical" && (_zf != this._yZoomFactor() || _zp != this._yZoomPosition())) {
	            this._yZoomFactor(axis.zoomFactor.toFixed(3));
	            this._yZoomPosition(axis.zoomPosition.toFixed(3));
	        }
	    }			
	},

	  annotationRender: function (currentAnnotation, a) {                           // method to render annotation
            //declaration and initialization
            var chartContainer = this._id;
            var flag = false;
            var currentSeries = this.model.series[0];
            var seriesType = currentSeries.type.toLowerCase();
            var areaBoundsX = this.model.m_AreaBounds.X;
            var areaBoundsY = this.model.m_AreaBounds.Y;
            var areaBoundsWidth = this.model.m_AreaBounds.Width;
            var areaBoundsHeight = this.model.m_AreaBounds.Height;
            var marginLeft = this.model.margin.left;
            var marginTop = this.model.margin.top;
          
            var seriesIndex = $.inArray(currentSeries, this.model._visibleSeries);
            var radius = this.model.circularRadius[seriesIndex];
			  var centerX = this.model.circleCenterX[seriesIndex];
            var centerY = this.model.circleCenterY[seriesIndex];
			var currentDocument = $(document);

            currentAnnotation = $.extend(true, {}, this.model.annotationsDefault, currentAnnotation);   // extending defaults

            // creating annotation group
            if ($('#annotation_group_' + chartContainer).length != 0)
                var annotationContainer = $('#annotation_group_' + chartContainer);
            else
                annotationContainer = $("<div></div>").attr('id', "annotation_group_" + chartContainer);
            annotationContainer.css({ "position": "absolute", "left": "0px", "top": "0px" });

            var content = currentAnnotation.content;
            element = $("#" + content);
            if (element.get(0).tagName == "SCRIPT")                // for jsrender
                var element = $($("#" + content)[0].innerHTML);
            var cloneNode = element.clone();                        // clone
            var id = 'annotation_' + chartContainer + "_" + content + "_" + a;
            $(cloneNode).attr("id", id);
            var $cloneNode = $(cloneNode);
            $cloneNode.css({
                'position': "absolute",
                'z-index': 2000
            });

            // initialization
            var region = currentAnnotation.region.toLowerCase();
            var coordinateUnit = currentAnnotation.coordinateUnit.toLowerCase();
            var annotationX = (typeof currentAnnotation.x=="string"||typeof currentAnnotation.x=="object") ? Date.parse(currentAnnotation.x) : currentAnnotation.x;
            var annotationY = currentAnnotation.y;
            var horizontalAlignment = currentAnnotation.horizontalAlignment.toLowerCase();
            var verticalAlignment = currentAnnotation.verticalAlignment.toLowerCase();

            if (coordinateUnit == "pixels") {                          //pixels
                if (region == "series") {                             // chart area / series
                    if ((areaBoundsWidth + areaBoundsX + marginLeft > annotationX + areaBoundsX) &&
                        areaBoundsHeight + areaBoundsY + marginTop > annotationY + areaBoundsY) {
                        var left = annotationX + areaBoundsX;
                        var top = annotationY + areaBoundsY;
                    }
                }
                else if (region == "chart") {                         // chart
                    if (($(this.svgObject).width() > annotationX) &&
                         $(this.svgObject).height() > annotationY) {
                        left = annotationX;
                        top = annotationY;
                    }
                }

                $cloneNode.css({
                    "left": left,
                    "top": top
                });
                flag = true;                                // to denote that the annotation should be appended in DOM
            } else if (coordinateUnit == "points") {        //points
                point = {
                    'x': annotationX,
                    'y': annotationY
                };

                if (this.model.AreaType == "polaraxes") {   // polar
                    xAxis = this.model._axes[0];
                    yAxis = this.model._axes[1];
                    if ((annotationX >= xAxis.visibleRange.min && annotationX <= xAxis.visibleRange.max)
                        && (annotationY >= yAxis.visibleRange.min && annotationY <= yAxis.visibleRange.max)) {
                        var location = this.TransformToVisibleAnnotation(xAxis, yAxis, annotationX, annotationY, this);
                        $cloneNode.css({
                            "left": location.X,
                            "top": location.Y
                        });
                        flag = true;
                    }
                } else if (seriesType == "pyramid" || seriesType == "funnel") { // pyramid and funnel
                    var currentPoint = currentSeries.points[annotationX];
                    $cloneNode.css({
                        "left": currentPoint.xLocation + this.pyrX,
                        "top": currentPoint.yLocation + this.pyrY
                    });
                    flag = true;
                } else if (seriesType == "pie" || seriesType == "doughnut" || seriesType == "pieofpie") { // pie, pieofpie and doughnut
                    currentPoint = currentSeries._visiblePoints[annotationX];
                    var pointIndex = annotationX;
                    var startX, startY;
                    var series = new ej.seriesTypes[seriesType]();
                    var midAngle = currentPoint ? currentPoint.currentMidAngle : 0;
                    if ((pointIndex == currentSeries.explodeIndex || currentSeries.explodeAll) && !chartObj.vmlRendering) {
                        startX = centerX + Math.cos(midAngle) * currentSeries.explodeOffset;
                        startY = centerY + Math.sin(midAngle) * currentSeries.explodeOffset;
                    } else {
                        startX = centerX;
                        startY = centerY;
                    }
                    var midX = series.getXCordinate(startX, (radius), midAngle);
                    var midY = series.getYCordinate(startY, (radius), midAngle);

                    positionX = (midX + startX) / 2;
                    positionY = (midY + startY) / 2;

                    positionX = (midX + positionX) / 2;
                    positionY = (midY + positionY) / 2;

                    $cloneNode.css({
                        "left": positionX,
                        "top": positionY
                    });
                    flag = true;
                } else {                                               // cartesianaxes
                    var xAxisName = currentAnnotation.xAxisName;
                    var yAxisName = currentAnnotation.yAxisName;
                    var axesLength = this.model._axes.length;
                    for (var i = 0; i < axesLength; i++) {
                        if (this.model._axes[i].name == xAxisName)
                            var xAxis = this.model._axes[i];
                        if (this.model._axes[i].name == yAxisName)
                            var yAxis = this.model._axes[i];
                    }
                    if (!xAxis) xAxis = this.model._axes[0];           // setting primary axis by default
                    if (!yAxis) yAxis = this.model._axes[1];

                        if (!this.model.requireInvertedAxes) {
						    location = this._getAnnotationPoint(point, xAxis, yAxis);
                            $cloneNode.css({
                                "left": location.X + areaBoundsX,
                                "top": location.Y + yAxis.y
                            });
                        }
                        else {
                            point.x = point.y + (point.y = point.x, 0);// swapping x, y => a = b + (b=a, 0)
                            location = this._getAnnotationPoint(point, yAxis, xAxis);
                            $cloneNode.css({
                                 "left": location.X + areaBoundsX,
                                 "top": location.Y + xAxis.y
                            });
						}
                        flag = true;
                }
            } else {                                                                      //other alignment
                $cloneNode.css("display", "block").appendTo($(annotationContainer));       //append
                $(annotationContainer).appendTo('#' + 'chartContainer_' + chartContainer);
                width = $cloneNode.outerWidth();
                height = $cloneNode.outerHeight();
                if (region == "chart") {
                    switch (horizontalAlignment) {
                        case "middle":
                            left = $(this.svgObject).width() / 2 - width / 2;
                            break;
                        case "left":
                            left = 0;
                            break;
                        case "right":
                            left = $(this.svgObject).width() - width;
                    }
                    switch (verticalAlignment) {
                        case "middle":
                            top = $(this.svgObject).height() / 2 - height / 2;
                            break;
                        case "top":
                            top = 0;
                            break;
                        case "bottom":
                            top = $(this.svgObject).height() - height;
                    }
                } else {
                    if (seriesType == "pie" || seriesType == "doughnut" || seriesType == "pieofpie") {             // for pie, pieofpie and doughnut
                        left = centerX;
                        top = centerY;
                        switch (horizontalAlignment) {
                            case "middle":
                                left = centerX - width / 2;
                                break;
                            case "left":
                                left = centerX - radius;
                                break;
                            case "right":
                                left = centerX + radius - width;
                        }

                        switch (verticalAlignment) {
                            case "middle":
                                top = centerY - height / 2;
                                break;
                            case "top":
                                top = centerY - radius;
                                break;
                            case "bottom":
                                top = centerY + radius;
                        }
                    } else {
                        switch (horizontalAlignment) {
                            case "middle":
                                left = areaBoundsX + (areaBoundsWidth / 2) - width / 2;
                                break;
                            case "left":
                                left = areaBoundsX;
                                break;
                            case "right":
                                left = areaBoundsX + areaBoundsWidth - width;
                        }

                        switch (verticalAlignment) {
                            case "middle":
                                top = areaBoundsY + (areaBoundsHeight / 2) - height / 2;
                                break;
                            case "top":
                                top = areaBoundsY;
                                break;
                            case "bottom":
                                top = areaBoundsY + areaBoundsHeight - height;
                        }
                    }
                }
                if (seriesType == "pyramid" || seriesType == "funnel") {         // to remove margin value
                    left -= marginLeft;
                }
                $cloneNode.css({
                    "left": left,
                    "top": top
                });
            }

            left = parseFloat($cloneNode.css("left"));
            top = parseFloat($cloneNode.css("top"));                              // get left and top value
            if (coordinateUnit != "none" && flag) {
                $cloneNode.css("display", "block").appendTo($(annotationContainer));   //append
                $(annotationContainer).appendTo('#' + 'chartContainer_' + chartContainer);
				width = $cloneNode.outerWidth();
                height = $cloneNode.outerHeight();
                switch (horizontalAlignment) {
                    case "middle":
                        left -= width / 2;
                        break;
                    case "left":
                        left -= width;
                        break;
                }
                switch (verticalAlignment) {
                    case "middle":
                        top -= height / 2;
                        break;
                    case "top":
                        top -= height;
                        break;
                }
            }
            var margin = currentAnnotation.margin;                      // margin values
            left = left + margin.left - margin.right;
            top = top + margin.top - margin.bottom;

            commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);          // trigger event
            commonEventArgs.data = {
                content: $cloneNode.html(), location: { x: left, y: top },
                opacity: currentAnnotation.opacity, angle: currentAnnotation.angle
            };
            this._trigger("annotationRendering", commonEventArgs);

            $cloneNode.html(commonEventArgs.data.content);
            $cloneNode.css({
                "left": commonEventArgs.data.location.x,
                "top": commonEventArgs.data.location.y,
                "opacity": commonEventArgs.data.opacity                  //opacity
            });

            var angle = commonEventArgs.data.angle;                     // angle
            if (angle) {
                $cloneNode.css({
                    '-ms-transform': 'rotate(' + angle + 'deg)',        //IE 10 and 9
                    '-webkit-transform': 'rotate(' + angle + 'deg)',    // chrome
                    '-moz-transform': 'rotate(' + angle + 'deg)',       // firefox
                    '-o-transform': 'rotate(' + angle + 'deg)',         // opera
                    '-transform': 'rotate(' + angle + 'deg)'            // general
                });
            }

            var eleId = $cloneNode.attr("id");                          // id of annotation
            var topHeight = bottomHeight = leftWidth = rightWidth = 0;
            var chartWidth = $("#" + this._id).width();
            var chartHeight = $("#" + this._id).height();
            if (flag && (angle == 0) && (region == "series" || coordinateUnit == "points")) {
                if (areaBoundsWidth + areaBoundsX < left + width) {                       // clip right width
                    var excessWidth = (left + width) - (areaBoundsWidth + areaBoundsX);
                    rightWidth = width - excessWidth;
                }
                if (left < areaBoundsX) {                                                  // clip left width
                    leftWidth = areaBoundsX - left;
                }
                if (areaBoundsHeight + areaBoundsY < top + height) {                      // clip bottom height
                    excessHeight = (top + height) - (areaBoundsHeight + areaBoundsY);
                    bottomHeight = height - excessHeight;
                }
                if (top < areaBoundsY) {                                                 // clip top height
                    topHeight = areaBoundsY - top;
                }
                rightWidth = (rightWidth == 0) ? width : rightWidth;
                bottomHeight = (bottomHeight == 0) ? height : bottomHeight;
                document.getElementById(eleId).style.clip = "rect(" + topHeight.toString() + "px," +  // clipping annotation
                     rightWidth.toString() + "px," +
                     bottomHeight.toString() + "px," +
                     leftWidth + "px)";
            }
            else if (flag && (angle == 0) && region == "chart") {
                if (chartWidth < left + width) {                              // clip right width
                    excessWidth = (left + width) - chartWidth;
                    var rightWidth = width - excessWidth;
                }
                if (left < 0) {                                              // clip left width
                    var leftWidth = width + left;
                    leftWidth = (leftWidth == 0) ? width : leftWidth;
                }
                if (chartHeight < top + height) {                            // clip bottom height
                    var excessHeight = (top + height) - chartHeight;
                    var bottomHeight = height - excessHeight;
                }
                if (top < 0) {                                               // clip top height
                    topHeight = height + top;
                    topHeight = (topHeight == 0) ? height : topHeight;
                }
                rightWidth = (rightWidth == 0) ? width : rightWidth;
                bottomHeight = (bottomHeight == 0) ? height : bottomHeight;
                document.getElementById(eleId).style.clip = "rect(" +
                    topHeight.toString() + "px," +
                    rightWidth.toString() + "px," +
                    bottomHeight.toString() + "px," +
                    leftWidth + "px)";
            }
			else if (flag && (angle == 90) && (region == "series" || coordinateUnit == "points")) {
               
                var clientRect = document.getElementById(eleId).getBoundingClientRect();
                left = clientRect.left - $(this.svgObject).offset().left + currentDocument.scrollLeft();
                top = clientRect.top - $(this.svgObject).offset().top + currentDocument.scrollTop();
                
                if (areaBoundsHeight + areaBoundsY < top + width) {                      // clip right width
                    excessWidth = (top + width) - (areaBoundsHeight + areaBoundsY);
                    rightWidth = width - excessWidth;
                }

                if (left < areaBoundsX) {                                                  // clip bottom height

                    excessHeight = areaBoundsX - left;
                    bottomHeight = height - excessHeight;
                }

                if (top < areaBoundsY) {                                                 // clip left width
                    leftWidth = areaBoundsY - top;
                }

                if (areaBoundsWidth + areaBoundsX < left + height) {                       // clip top height
                    excessHeight = (left + height) - (areaBoundsWidth + areaBoundsX);
                    topHeight = excessHeight;
                }

                rightWidth = (rightWidth == 0) ? width : rightWidth;
                bottomHeight = (bottomHeight == 0) ? height : bottomHeight;
               
                document.getElementById(eleId).style.clip = "rect(" + topHeight.toString() + "px," +         // clipping annotation
                     rightWidth.toString() + "px," +
                     bottomHeight.toString() + "px," +
                     leftWidth + "px)";
            }
            else if (flag && (angle == 90) && region == "chart") {
                var clientRect = document.getElementById(eleId).getBoundingClientRect();
                left = clientRect.left - $(this.svgObject).offset().left ;
                top = clientRect.top - $(this.svgObject).offset().top ;

                if (chartHeight < top + width) {                              // clip right width
                    excessWidth = (top + width) - chartHeight;
                    rightWidth = width - excessWidth;
                }
                if (left < 0) {                                              // clip bottom height
                    excessHeight = 0 - left;
                    bottomHeight = height - excessHeight;
                    bottomHeight = (bottomHeight == 0) ? height : bottomHeight;
                }
                if (top < 0) {                                               // clip left width
                    leftWidth = 0 - top;
                    leftWidth = (leftWidth == 0) ? width : leftWidth ;
                }
                if (chartWidth < left + height) {                            // clip top height
                    excessHeight = (left + height) - chartWidth;
                    topHeight = excessHeight;
                }
               
                rightWidth = (rightWidth == 0) ? width : rightWidth;
                bottomHeight = (bottomHeight == 0) ? height : bottomHeight;
                document.getElementById(eleId).style.clip = "rect(" +
                    topHeight.toString() + "px," +
                    rightWidth.toString() + "px," +
                    bottomHeight.toString() + "px," +
                    leftWidth + "px)";
            }
        },                                                                 // ---------------------------- end of annotation 

        TransformToVisibleAnnotation: function (xAxis, yAxis, x, y, sender) {       // method to get the position of points in polar/ radar
            x = (xAxis._valueType == "logarithmic") && x > 0 ? Math.log(x, xAxis.logBase) : x;
            y = (xAxis._valueType == "logarithmic") && y > 0 ? Math.log(y, yAxis.logBase) : y;
            var radius = sender.model.Radius * ej.EjSvgRender.utils._valueToCoefficient(yAxis, y, this);
            var point = ej.EjSvgRender.utils._valueToVector(xAxis, x);
            return { X: sender.model.centerX + radius * point.X, Y: sender.model.centerY + radius * point.Y };
        },

        _getAnnotationPoint: function (point, xAxis, yAxis) {                     // method to get the position of points (cartesianaxes)
            var requireInvertedAxes = this.model.requireInvertedAxes;
			 var x = point.x;
            var y = point.y;

            var xvalue = (xAxis._valueType == "logarithmic") ? ej.EjSvgRender.utils._logBase((x == 0 ? 1 : x), xAxis.logBase) : x;
            var yvalue = (yAxis._valueType == "logarithmic") ? ej.EjSvgRender.utils._logBase((y == 0 ? 1 : y), xAxis.logBase) : y;
            xvalue = ej.EjSvgRender.utils._getPointXY(xvalue, xAxis.visibleRange, xAxis.isInversed) * (xAxis.width);
            yvalue = (1 - ej.EjSvgRender.utils._getPointXY(yvalue, yAxis.visibleRange, yAxis.isInversed)) * (yAxis.height);

            point.location = { X: xvalue, Y: yvalue };
            return point.location;
        },
		
     indicatorRender: function() {
         if ($(this.svgObject).find("#" + this.svgObject.id + "_IndicatorCollection").length > 0) {
             $(this.svgObject).find("#" + this.svgObject.id + "_IndicatorCollection").remove();
         }

         var indOptions = { 'id': this.svgObject.id + '_IndicatorCollection', 'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)' };

         this.gIndicatorEle = this.svgRenderer.createGroup(indOptions);

         for (var i = 0; i < this.model.indicators.length && this.model.indicators[i].visible && this.model.indicators[i]._points.length>0; i++) {
             var indicator = this.model.indicators[i];
             var options;
             for (var j = 0; j < this.model._axes.length; j++) {
                 var axis = this.model._axes[j];

                 if (axis.name && axis.orientation.toLowerCase() == 'horizontal' && axis.name.toLowerCase() == indicator.xAxisName.toLowerCase()) {
                     indicator.xAxis = axis;
                 } else if (axis.name && axis.orientation.toLowerCase() == 'vertical' && axis.name.toLowerCase() == indicator.yAxisName.toLowerCase()) {
                     indicator.yAxis = axis;
                 }
             }
             var type = indicator.type.toLowerCase();
             options = new ej.indicatorTypes[type]();
             //Clip the canvas Chart indicator series out of chartArea Bounds
             if (this.model.enableCanvasRendering) {
                 this.svgRenderer.ctx.save();
                 this.svgRenderer.ctx.beginPath();
                 this.svgRenderer.ctx.rect(this.model.m_AreaBounds.X, indicator.yAxis.y, indicator.xAxis.width, indicator.yAxis.height);
                 this.svgRenderer.ctx.clip();
                 options.draw(indicator, this);
                 this.svgRenderer.ctx.restore();
             } else
                 options.draw(indicator, this);
             var element = options.gIndicatorGroupEle;
             if (element) ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, indicator, this);

             if (!this.vmlRendering && !this.model.enableCanvasRendering) {
                 if (indicator.enableAnimation && (!indicator._animatedSeries || indicator.type != indicator._previousType)) {
                     this.svgRenderer.append(this.gIndicatorEle, this.svgObject);
                     var clipRect = $(this.gIndicatorEle).find("#" + this.svgObject.id + '_indicatorGroup' + '_' + i + "_ClipRect").children();					 
					 ej.EjSeriesRender.prototype._doLineAnimation(this, clipRect);    // for indicator animation
                     this.model.AnimationComplete = true;
                     indicator._animatedSeries = true;
                     indicator._previousType = indicator.type;

                 }
             }
	   	  this.svgRenderer.append(this.gIndicatorEle, this.svgObject); 
         }
		 
     },
	 
	 doAnimation: function (series) {
	   // Declaration
	   var chartObj = this,	 
	       model = chartObj.model,
	       requireInvertedAxes = model.requireInvertedAxes,
		   type = series.type.toLowerCase(),
	       seriesIndex = $.inArray(series, model._visibleSeries),
	       gSeriesGroupId = this.svgObject.id + "_SeriesGroup_" + seriesIndex,
		   markerElements = $(chartObj.gSymbolGroupEle)[seriesIndex].childNodes,
		   markerLength = markerElements.length,
		   dataLabels = $(chartObj.gDataLabelEle)[seriesIndex].childNodes,
		   dataLabelLength = dataLabels.length,
		   connectorLines = $(chartObj.gConnectorEle)[seriesIndex].childNodes,
		   connectorLineLength = connectorLines.length,
		   errorBarElements = $(chartObj.gErrorBarGroupEle)[seriesIndex] == undefined ? 
		                      undefined :$(chartObj.gErrorBarGroupEle)[seriesIndex].childNodes,
		   errorBarEleLength = ej.util.isNullOrUndefined(errorBarElements) ? 0 : errorBarElements.length,
		   animationType = series.animationType, clipRect, errorBarInterval,boxWhiskerInterval, lineEle, pathEle,
		   markerInterval, dataLabelInterval, index, elements, elementsLength, clipRect,
           ubound = 20, lbound = 0, randomValue, delayInterval, marker, i, j,
		   seriesRender = ej.EjSeriesRender.prototype;
		   chartObj.gSeriesGroupEle = $("#" + gSeriesGroupId)[0];
		   
		   switch (animationType){
			  case "rect":
			        elements = $(this.gSeriesEle).find("#" + gSeriesGroupId).children("rect");
		            elementsLength = elements.length;
					if(type=="boxandwhisker"){
						 lineEle = $(this.gSeriesEle).find("#" + gSeriesGroupId).children("line");
						 pathEle = $(this.gSeriesEle).find("#" + gSeriesGroupId).children("path");
						 boxWhiskerInterval=2000/pathEle.length;
						for (var k = 0; k < lineEle.length; k++) {
							seriesRender._doLineSymbol(lineEle[k],boxWhiskerInterval,k, series, requireInvertedAxes, chartObj);
							seriesRender._doLineSymbol(elements[k],boxWhiskerInterval,k, series, requireInvertedAxes, chartObj);
						 }
						 for (var j = 0; j < pathEle.length; j++)
						 {
						     seriesRender._doLineSymbol(pathEle[j], boxWhiskerInterval, j, series, requireInvertedAxes, chartObj);
						 }
					} 
					else{
                    for (i = 0; i < elementsLength; i++) {
			          if (type.indexOf("stacking") > -1) 
                         seriesRender.animateStackingRect(elements[i], series, requireInvertedAxes, chartObj);
			          else
				         seriesRender.animateRect(elements[i], series, requireInvertedAxes, chartObj);
		             }
					}
                    markerInterval = dataLabelInterval = errorBarInterval = 500;
					break;					
              case "path":
			         clipRect = $(chartObj.gSeriesEle).find("#" + gSeriesGroupId + "_ClipRect").children();
                     seriesRender._doLineAnimation(chartObj, clipRect);
                     markerInterval = 2000 / markerLength;
		             dataLabelInterval = 2000 / dataLabelLength;
		             errorBarInterval = 2000 / errorBarEleLength;
					 break;					 
              case "scatter":
			         for (i = 0; i < markerLength; i++) {
                        randomValue = Math.floor(Math.random() * (ubound - lbound) + lbound);
                        delayInterval = parseInt(randomValue * 50);
                        seriesRender.animateSymbol(markerElements[i], delayInterval, series, requireInvertedAxes, chartObj);  
	                 } 
					 break;				 
              case "bubble":
			          elements = $(this.gSeriesGroupEle).children().not("defs");
                      delayInterval = 0;
                      for (i = 0; i < elements.length; i++) 
                           seriesRender.animateSymbol(elements[i], delayInterval, series, requireInvertedAxes, chartObj);
		              for (i = 0; i < markerLength; i++) 
                           seriesRender.animateSymbol(markerElements[i], delayInterval, series, requireInvertedAxes, chartObj);   
		              for (i = 0; i < dataLabelLength; i++) 
                           seriesRender.animateSymbol(dataLabels[i], delayInterval, series, requireInvertedAxes, chartObj);
		              for (i = 0; i < connectorLineLength; i++)
                           seriesRender.animateSymbol(connectorLines[i], delayInterval, series, requireInvertedAxes, chartObj);
					   break;           
			   case "hilo":		
			          elements = $(this.gSeriesGroupEle).children().not("defs");
		              elementsLength = elements.length;
                      time = 2000 / elementsLength;
                      for (var i = 0; i < elementsLength; i++)
                      seriesRender._doLineSymbol(elements[i], time, i, series, requireInvertedAxes, chartObj);
		              dataLabelInterval = 2000/ dataLabelLength;
                      break;					  
		       case "cylinder":
		           clipRect = $(chartObj.gSeriesEle).find("#" + gSeriesGroupId + "_ClipRect").children();
		           seriesRender.animateCylinder(chartObj, series, requireInvertedAxes, clipRect);
		           markerInterval = dataLabelInterval = errorBarInterval = 500;
		           break;
		   }
	  
	      if (animationType != "bubble") {
	        for (j = 0; j < markerLength; j++) {              // for marker
	           index = animationType == "rect" || animationType == "stackingRect" ? 2 : j;
               seriesRender._doLineSymbol(markerElements[j], markerInterval, index, series, requireInvertedAxes, chartObj);
	         }
		
	        for (j = 0; j< dataLabelLength; j++) {            // for data label
		       index = animationType == "rect" || animationType == "stackingRect"  ? 2 : j;
		       seriesRender._doLineSymbol(dataLabels[j], dataLabelInterval, index, series, requireInvertedAxes, chartObj);
		     }
		
	        time = 2000/ connectorLineLength;
		    for (j = 0; j< connectorLineLength; j++) {        // for connector lines
		       index = animationType == "rect" || animationType == "stackingRect"  ? 2 : j;
		       seriesRender._doLineSymbol(connectorLines[j], time, index, series, requireInvertedAxes, chartObj);
		     }
	      }
		
		  if (series.errorBar.visibility == "visible"){     
		     for (j = 0; j< errorBarEleLength; j++) {      // for error bar
		       index = animationType == "rect" || animationType == "stackingRect"  ? 2 : j;
		       seriesRender._doLineSymbol(errorBarElements[j], errorBarInterval, index, series, requireInvertedAxes, chartObj);
		     }	
		  }
   },
   _animationElements: function (seriesOptions, seriesType, seriesIndex) {
            var chartObj = this;
            seriesOptions._previousType = ej.util.isNullOrUndefined(seriesOptions._previousType) ? seriesOptions.type : seriesOptions._previousType;
            if (seriesOptions.enableAnimation && !this.vmlRendering && !this.model.enableCanvasRendering && (!seriesOptions._animatedSeries || seriesOptions.type != seriesOptions._previousType)) {
                ej.EjSeriesRender.prototype.doCircularAnimation(this, seriesOptions, seriesType, seriesIndex);
                seriesOptions._previousType = seriesOptions.type;
                seriesOptions._animatedSeries = chartObj.isSplitted ? false : true;
            }
            chartObj.isSplitted = false;
            this.drawAccDisplayText(seriesType, seriesOptions, seriesIndex);
            //Show the datalabel text element on redraw when enable animation of series
            if (seriesOptions.enableAnimation && seriesOptions._visiblePoints.length > 0 && seriesOptions.AnimationComplete && !this.vmlRendering && !this.model.enableCanvasRendering) {
                chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gSeriesTextEle[seriesIndex].id), { "visibility": "visible" });
                if (chartObj.gSymbolGroupEle)
                    chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gSymbolGroupEle[seriesIndex].id), { "visibility": "visible" });
                var elements;
                if (seriesOptions.marker.dataLabel.template) {
                    elements = $(chartObj.element[0].childNodes[0].childNodes);
                    for (var i = 0; i < elements.length; i++)
                        $(elements[i]).css('display', 'block');
                }
                if (chartObj.gConnectorEle)
                    chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gConnectorEle[seriesIndex].id), { "visibility": "visible" });
                if (chartObj.gDataLabelEle)
                    chartObj.svgRenderer._setAttr($(chartObj.gSeriesEle).find("#" + chartObj.gDataLabelEle[seriesIndex].id), { "visibility": "visible" });
            }



        },
		  _appendConnectorElements: function (i) {
            var visibleSeries = ej.DataManager(this.model._visibleSeries, ej.Query().sortBy("_zOrder")).executeLocal();
            var currentSeries = visibleSeries[i];
            var type = currentSeries.type.toLowerCase();
            if (currentSeries.visibility == "visible" && !this.model.enable3D && currentSeries.connectorLine && (currentSeries.connectorLines || this.model.AreaType == "none")) {
                this.svgRenderer.append(this.gConnectorEle[i], this.gSeriesEle);
                currentSeries.connectorLines = false;
            }
        },
        _appendDataLabelElement: function (i) {
            var currentSeries, type, index;
            currentSeries = this.model._visibleSeries[i];
            index = !ej.util.isNullOrUndefined(currentSeries.zOrder) ? currentSeries.zOrder : index;
            if (currentSeries.visibility == "visible" && !this.model.enable3D) {
                this.svgRenderer.append(this.gSymbolGroupEle[i], this.gSeriesEle);
                if (!this.model.enable3D && !this.model.enableCanvasRendering) {
                    if (this.gDataLabelEle[i].childNodes.length > 0)
                        this.svgRenderer.append(this.gDataLabelEle[i], this.gSeriesEle);
                    if (this.gSeriesTextEle[i].childNodes.length > 0)
                        this.svgRenderer.append(this.gSeriesTextEle[i], this.gSeriesEle);
                }
            }
            if (!this.vmlRendering && currentSeries.visibility == "visible" && !this.model.enableCanvasRendering && !this.model.enable3D) {
                this.svgRenderer.append(this.gSeriesEle, this.svgObject);
                this.svgRenderer.append(this.svgObject, this.element);
            }

        },
        _accSeriesDraw: function (index, seriesOptions, type) {
            var chartObj = this;
            var visibleSeries = ej.DataManager(this.model._visibleSeries, ej.Query().sortBy("_zOrder")).executeLocal();
            var seriesIndex = $.inArray(visibleSeries[index], this.model._visibleSeries);
            this.model._visibleSeries[seriesIndex] = visibleSeries[index] = $.extend(true, seriesOptions, visibleSeries[index]);
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { series: seriesOptions };
            this._trigger("seriesRendering", commonEventArgs);
            var seriesType = new ej.seriesTypes[type.toLowerCase()]();
            var minhightwidth = seriesType.draw(chartObj, seriesOptions);
            if (!minhightwidth) {
			this.model.minhightwidth = true;
                chartObj._animationElements(seriesOptions, seriesType, seriesIndex);
            }


        },
     // to split the series for pie of pie rendering
        _splitSeries: function (visibleSeries) {
            //declaration of splitseries variables            
            var pieCollections = [];
                pieCollections[0] = $.extend(true, [], visibleSeries._visiblePoints);
                pieCollections[1] = [];               
            var series = visibleSeries,
                splitValue = parseInt(series.splitValue),
                splitMode = series.splitMode.toLowerCase(),
                length = pieCollections[0].length,
                count = 0, j = 0, yValues = [], i = 0, totalValue = 0, yvalue;
            // to calculate sum of y values
            while (i != length) {
               totalValue += pieCollections[0][i].y;
               i++;
            }
            // to split points based on splitmode    
             if (splitMode == "position") {
                 for (var i = length - 1; i >= 0 && j != splitValue; i--) {
                    count = count + pieCollections[0][i].y;
                    pieCollections[1][j] = pieCollections[0][i];
                    j++;
                    pieCollections[0].splice(i, 1);
                 }
                 pieCollections[1].reverse();
             }
             else if (splitMode == "value" || splitMode == "percentage") {
                 for (var k = 0; k < pieCollections[0].length; k++) {
                    yvalue = splitMode == "value" ? pieCollections[0][k].y : Math.round((pieCollections[0][k].y / totalValue) * 100);                    
                    if (yvalue < splitValue) {
                        count = count + pieCollections[0][k].y;
                        pieCollections[1][j] = pieCollections[0][k];
                        j++;
                        pieCollections[0].splice(k, 1);
                        k = -1;
                    }
                   }                  
                }
            else if (splitMode == "indexes") {
                var splitArray = JSON.parse("[" + series.splitValue + "]");              
                // to remove duplicate indices
                splitArray = splitArray.filter(function (item, d, inputArray) {
                    return inputArray.indexOf(item) == d;
                });
                splitArray.sort();
                for (var k = 0; k < pieCollections[0].length; k++) {
                    for (var s = 0; s < splitArray.length; s++) {
                        if (k == splitArray[s]) {
                            count = count + pieCollections[0][k].y;
                            pieCollections[1][j] = pieCollections[0][k];
                            j++;
                        }
                    }
                }
                for (var i = 0; i < splitArray.length; i++) {
                    var index = splitArray[i] - i;
                    pieCollections[0].splice(index, 1);
                }
            }

            // to append the added point in first pie collection
                    if (pieCollections[1].length > 0) {
                        yValues[0] = count,
                               valueType = series._xAxisValueType,
                            pieCollections[0].unshift({
                                _visibility: "visible",
                                visible: true,
                                text:"Others",
                                // dataPoint: undefined,
                                x: valueType == "string" ? "Others" : count,
                                xValue: valueType == "string" ? series.points.length : count,
                                y: count,
                                YValues: yValues,
                                fill: this.model.colors[(series.points.length + 1) % this.model.colors.length],
                                isFill: false,
                                actualIndex: series.points.length
                            });
                    }                 
                    this.isSplitted = true;
                    series.pieCollections = pieCollections;
        },
        _calculateGapWidth:function(currentSeries){
            var circle1end = 0, circle2start = 0, coefficient, centerX, gapWidth;
            var constantWidth = 0.1 * Math.min($(this.svgObject).width(), $(this.svgObject).width());
            ej.EjSeriesRender.prototype._calculateVisiblePoints(currentSeries).visiblePoints;
            this._splitSeries(currentSeries);  // to split the series points for pieofpie seriestype
            this.chartObj = this;
            // gapwidth calculation for pieofpie series type
            for (var j = 0; j < 2; j++) {
                coefficient = (j == 0) ? currentSeries.pieCoefficient : currentSeries.pieOfPieCoefficient;
                currentSeries._visiblePoints = currentSeries.pieCollections[j];
                currentSeries.collectionIndex = j;
                gapWidth = currentSeries.gapWidth;
                var size = ej.EjSeriesRender.prototype.calculatingSliceAngle(currentSeries, this.chartObj);
                var circleradius = size.width < constantWidth ? 0.25 * coefficient * constantWidth : 0.25 * coefficient * Math.min(size.width, size.height);               
                centerX = this.model.circleCenterX[j];
                if (j == 0)
                    circle1end = centerX + circleradius;
                else
                    circle2start = centerX - circleradius;
            }
            var pieGapWidth = (circle2start - circle1end) - gapWidth;
            this.model.pieGapWidth = (pieGapWidth > 0) ? pieGapWidth : 0;
            // to draw connector lines for pieofpie series type
            if (currentSeries.pieCollections[0].length > 0 && currentSeries.pieCollections[1].length > 0 && currentSeries.connectorLine.width > 0)
                this.drawPieofPieConnectors(size, currentSeries); 
            return currentSeries;
        },
    seriesRender: function (params) {
	        this.model.allPoints = [];
           this.model.markerRegion = [];
           this.model.circleCenterX = [];
            this.model.circleCenterY = [];
           this.model.startX = [];
           this.model.startY = [];
           this.model.centerCount = 0;
		    this.gTrendlinesGroupEle = null;
		   if(!params){
				params ={ _crossAxisOverlap : false, axes:{}};
				for(var i=0; i<this.model._axes.length; i++)
					params.axes[this.model._axes[i].name] = {};
		   }
        var chartObj = this;
        if ($(this.svgObject).find("#" + this.svgObject.id + "_SeriesCollection").length > 0) {
            $(this.svgObject).find("#" + this.svgObject.id + "_SeriesCollection").remove();
        }
        var serOptions = { 'id': this.svgObject.id + '_SeriesCollection', 'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)' };
        var enable3D = this.model.enable3D;
        var areaType = this.model.AreaType;
        var enableCanvasRendering = this.model.enableCanvasRendering;
		 var axesLength = this.model._axes.length;
        this.gSeriesEle = this.svgRenderer.createGroup(serOptions);
        var visibleSeries = ej.DataManager(this.model._visibleSeries, ej.Query().sortBy("_zOrder")).executeLocal();
		 var visibleSeriesLength=visibleSeries.length;
        for (var i = 0; i < visibleSeriesLength; i++) {
            if (visibleSeries[i].visibility == "visible") {
			    if(ej.util.isNullOrUndefined(this.model.series[i].enableSmartLabels))  // for setting enablesmartlabels property values
                     this.model.series[i]._enableSmartLabels = (this.model.AreaType) == "none" ? true : false;
			     else 
			         this.model.series[i]._enableSmartLabels = this.model.series[i].enableSmartLabels; 
            if (!ej.util.isNullOrUndefined(visibleSeries[i].xAxis)) {
                visibleSeries[i].xAxis = null;
                visibleSeries[i].yAxis = null;
            }
            for (var j = 0; j < axesLength; j++) {
                var axis = this.model._axes[j];
                var index = i;
				 var axisOrientation = axis.orientation.toLowerCase();
                if (axis.name && axisOrientation == 'horizontal' && axis.name.toLowerCase() == visibleSeries[i]._xAxisName.toLowerCase()) {
                    visibleSeries[i].xAxis = axis;
                }
                else if (axis.name && axisOrientation == 'vertical' && axis.name.toLowerCase() == visibleSeries[i]._yAxisName.toLowerCase()) {
                    visibleSeries[i].yAxis = axis;
                }
                if (this.model.requireInvertedAxes) {
                    if (axis.name && axisOrientation == 'vertical' && axis.name.toLowerCase() == visibleSeries[i]._xAxisName.toLowerCase()) {
                        visibleSeries[i].xAxis = axis;
                    }
                    else if (axis.name && axisOrientation == 'horizontal' && axis.name.toLowerCase() == visibleSeries[i]._yAxisName.toLowerCase()) {
                        visibleSeries[i].yAxis = axis;
                    }
                }

            }
        }
        }
		
        var index, seriesOptions, seriesOptionsVisibility, type, commonEventArgs,
         seriesIndex, seriesType, minhightwidth;
	if (visibleSeriesLength > 0 ) {
        var currentSeries = visibleSeries[0];
        var seriesType = currentSeries.type.toLowerCase(),
        visibility = currentSeries.visibility.toLowerCase();
        if (seriesType == "pieofpie" && visibility == 'visible' && !enable3D) {
            this.model._isPieOfPie = true;
            currentSeries = this._calculateGapWidth(currentSeries); // method to split point, gapwidth calculation and to draw pieofpie connectors
            // pieofpie rendering with splitted points
            for (var k = 0; k < 2; k++) {
                currentSeries.collectionIndex = k;
                currentSeries._visiblePoints = currentSeries.pieCollections[k];
                this._accSeriesDraw(0, currentSeries, seriesType);
            }
            currentSeries._visiblePoints = $.merge(currentSeries.pieCollections[0], currentSeries.pieCollections[1]);
            this.model.pieGapWidth = null;
            currentSeries.collectionIndex = 0;
        }	
        else {
            //pie doughnut rendering from higher order to lower order
            for (var l = visibleSeriesLength; l > 0 && areaType == "none"; l--) {
                index = l - 1;
                seriesOptions = visibleSeries[l - 1];
                seriesOptionsVisibility = seriesOptions.visibility.toLowerCase();
                type = seriesOptions.type.toLowerCase();
                if (seriesOptionsVisibility === 'visible' && !enable3D && (type == "pie" || type == "doughnut")) {

                    this._accSeriesDraw(index, seriesOptions, type);


                }
                else {
                    if ((areaType == "none") && seriesOptionsVisibility === 'visible' && !enableCanvasRendering)
                        ej.Ej3DChart.prototype.renderSeries(this, seriesOptions);
                }
            }
        }
	}
        for (var m = 0; m < visibleSeriesLength; m++) {
            var index = m;
            var seriesOptions = visibleSeries[m];
            var  seriesOptionsVisibility=seriesOptions.visibility.toLowerCase();
            var type = seriesOptions.type.toLowerCase();
            if (areaType == "none" &&  seriesOptionsVisibility === 'visible' && !enable3D && (index === 0) && (type == "pyramid" || type == "funnel")) {
                this._accSeriesDraw(index, seriesOptions, type);


            }
            else {			 
                if (seriesOptionsVisibility === 'visible' && !enable3D && areaType != "none") {
                    this.renderSeries(seriesOptions, params);
                    if (areaType == "cartesianaxes" && this.model.series[m].type != "boxandwhisker" )
                        this._renderTrendline(chartObj, seriesOptions);
                }
                else {
                    if (!enable3D && areaType != "none")
                        this.svgRenderer.append(this.svgObject, this.element);
                    else {
                        if ((areaType == "cartesianaxes" ) && seriesOptionsVisibility === 'visible' && !enableCanvasRendering)
                       ej.Ej3DChart.prototype.renderSeries(this, seriesOptions, params);
					 }
			      }
			  }
        }
		
		if (this.model.AreaType != "none"){
		 // smart labels for cartesian axis
		  var i, currentSeries, currentPoint, points, currentSeriesType, isCanvas = this.model.enableCanvasRendering,
		  areaBounds = this.model.m_AreaBounds, currentPointXPos, currentPointYPos;
		  for (i = 0; i < visibleSeriesLength; i++) {
	        currentSeries = this.model.series[i];
	        points = currentSeries._visiblePoints;
	        if (currentSeries._enableSmartLabels && this.model.AreaType == "cartesianaxes") {
			   currentSeriesType = currentSeries.type.toLowerCase();
	            if (currentSeriesType == "column" || currentSeriesType == "stackingcolumn" ||
                    currentSeriesType == "bar" || currentSeriesType == "stackingbar" || currentSeriesType == "waterfall"
					|| currentSeriesType == "stackingbar100" || currentSeriesType == "stackingcolumn100" || currentSeriesType == "rangecolumn")
	                this.cartesianColumnSmartLabels(currentSeries, points, i)
	            else if (currentSeriesType != "boxandwhisker") {
	                this.cartesianSmartLabels(currentSeries, points, i);
				}
				    for (var j=0; j< points.length; j++){
					    currentPoint = points[j]; // condition to hide partially visible labels
						currentPoint.hide = false;
						currentPointXPos = isCanvas ? currentPoint.xPos- this.canvasX : currentPoint.xPos;
						currentPointYPos = isCanvas ? currentPoint.yPos- this.canvasY : currentPoint.yPos;
					    if ((currentPointXPos - currentPoint.width/2 < 0) || (currentPointXPos + currentPoint.width/2 > areaBounds.Width)||
						     (currentPointYPos + currentPoint.height/2 > areaBounds.Height)||(currentPointYPos - currentPoint.height/2 < 0))
							 currentPoint.hide = true;
		            }
			}
		 }
		
        // to draw connector lines for data label
		  var h, currentPoint, currentPointVisibility, visiblePointsLength;
		  var areaBoundsX = chartObj.model.m_AreaBounds.X;
		  for (i = 0; i < visibleSeriesLength; i++) {
		      currentSeries = visibleSeries[i];
			  if (currentSeries.visibility == "visible"){
			   visiblePointsLength = currentSeries._visiblePoints.length;
		       for (h = 0; h < visiblePointsLength; h++) {
			       currentPoint = currentSeries._visiblePoints[h];
				  currentPointVisibility = currentPoint.marker && currentPoint.marker.dataLabel && currentPoint.marker.dataLabel.visible;
				  if (currentSeries.marker.dataLabel.visible || currentPointVisibility){
		           if ((currentPoint.connectorFlag || currentPoint.newConnectorFlag) && !currentPoint.hide && currentPoint.drawText != "" && currentSeries.visibility == "visible" && !ej.util.isNullOrUndefined(currentPoint.textOptions)) {
					   currentSeries.connectorLine = true; 
		               if (chartObj.model.enableCanvasRendering) {
		                   chartObj.svgRenderer.ctx.save();
                        if (!chartObj.model.requireInvertedAxes)
                            chartObj.svgRenderer.ctx.rect(areaBoundsX, currentSeries.yAxis.y, currentSeries.xAxis.width, currentSeries.yAxis.height);
                        else
                            chartObj.svgRenderer.ctx.rect(areaBoundsX + currentSeries.yAxis.plotOffset, currentSeries.xAxis.y, currentSeries.yAxis.width, currentSeries.xAxis.height);
                        chartObj.svgRenderer.ctx.clip();
                        this.drawConnectorLines(i, h, currentPoint);
                        chartObj.svgRenderer.ctx.restore();
                    } else if (currentSeries._enableSmartLabels)
                        this.drawConnectorLines(i, h, currentPoint);
                }
			  }
            }
		  }
        }

        // to draw data label symbol and text
		  var currentPointLabel;
		  var areaBoundsX = chartObj.model.m_AreaBounds.X;
		  for (i = 0; i < visibleSeriesLength; i++) {
		      currentSeries = visibleSeries[i];
		      var type=currentSeries.type.toLowerCase();
		      if (currentSeries.visibility == "visible" && !this.model.enable3D) {
				  visiblePointsLength = currentSeries._visiblePoints.length;
		          for (h = 0; h < visiblePointsLength; h++) {
		              currentPoint = currentSeries._visiblePoints[h];
					  currentPointLabel = currentPoint.marker && currentPoint.marker.dataLabel && currentPoint.marker.dataLabel.visible;
		              if ((currentSeries.marker.dataLabel.visible || currentPointLabel) && !currentPoint.hide && !currentPoint.dataLabeltemplate && currentSeries.visibility == "visible"  && !ej.util.isNullOrUndefined(currentPoint.textOptions) && !currentPoint.hide) {
                        currentPoint.textOptions.transform = 'rotate(' + currentPoint.textOptions.angle + ',' + (currentPoint.xPos) + ',' + (currentPoint.yPos) + ')';
                        currentPoint.textOptions.labelRotation = currentPoint.textOptions.angle;  //for canvas label rotation
                        if (chartObj.model.enableCanvasRendering) {    // for canvas
                            chartObj.svgRenderer.ctx.save();
                        if (!chartObj.model.requireInvertedAxes)
                            chartObj.svgRenderer.ctx.rect(areaBoundsX, currentSeries.yAxis.y, currentSeries.xAxis.width, currentSeries.yAxis.height);
                        else
                            chartObj.svgRenderer.ctx.rect(areaBoundsX + currentSeries.yAxis.plotOffset, currentSeries.xAxis.y, currentSeries.yAxis.width, currentSeries.xAxis.height);
                        chartObj.svgRenderer.ctx.save();
                        chartObj.svgRenderer.ctx.clip();
                        
                        if (type.toLowerCase() == "boxandwhisker") {
						    if(currentSeries.showMedian == true && currentPoint.textOptionsBoxValues != ""){
								ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.textOptionsBoxValues[0].xPos, currentPoint.textOptionsBoxValues[0].yPos, currentPoint.textOptionsBoxValues[0].width, currentPoint.textOptionsBoxValues[0].height, currentPoint.textOptionsBoxValues[0].symbolName, this)
		                        this.svgRenderer.drawText(currentPoint.textOptionsBoxValues[0], currentPoint.textOptionsBoxValues[0].drawText, this.gSeriesTextEle[i]);									 
							}
                            for (var box = 1; box < currentPoint.textOptionsBoxValues.length; box++) {
                                ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.textOptionsBoxValues[box].xPos, currentPoint.textOptionsBoxValues[box].yPos, currentPoint.textOptionsBoxValues[box].width, currentPoint.textOptionsBoxValues[box].height, currentPoint.textOptionsBoxValues[box].symbolName, this)
                                this.svgRenderer.drawText(currentPoint.textOptionsBoxValues[box], currentPoint.textOptionsBoxValues[box].drawText, this.gSeriesTextEle[i]);
                            }
                        }
                        else {
                            ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.xPos, currentPoint.yPos, currentPoint.width, currentPoint.height, currentPoint.symbolName, this)
                            this.svgRenderer.drawText(currentPoint.textOptions, currentPoint.drawText, this.gSeriesTextEle);
                        }
                        chartObj.svgRenderer.ctx.restore();
                    } else {
                        ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.xPos, currentPoint.yPos, currentPoint.width, currentPoint.height, currentPoint.symbolName, this, this.gDataLabelEle[i])
                        this.svgRenderer.drawText(currentPoint.textOptions, currentPoint.drawText, this.gSeriesTextEle[i]);
                    }
		                  if (type == "rangecolumn" || type == "rangearea") {
		                      
		                      currentPoint.textOptionsLow.transform = 'rotate(' + currentPoint.textOptionsLow.angle + ',' + (currentPoint.xPosLow) + ',' + (currentPoint.yPosLow) + ')';
		                      currentPoint.textOptionsLow.labelRotation = currentPoint.textOptionsLow.angle;  //for canvas label rotation
		                      if (chartObj.model.enableCanvasRendering) {    // for canvas
		                          chartObj.svgRenderer.ctx.save();
		                          if (!chartObj.model.requireInvertedAxes)
		                              chartObj.svgRenderer.ctx.rect(areaBoundsX, currentSeries.yAxis.y, currentSeries.xAxis.width, currentSeries.yAxis.height);
		                          else
		                              chartObj.svgRenderer.ctx.rect(areaBoundsX + currentSeries.yAxis.plotOffset, currentSeries.xAxis.y, currentSeries.yAxis.width, currentSeries.xAxis.height);
		                          chartObj.svgRenderer.ctx.clip();
		                          
		                          ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.xPosLow, currentPoint.yPosLow, currentPoint.widthLow, currentPoint.heightLow, currentPoint.symbolName, this)
		                          
		                          this.svgRenderer.drawText(currentPoint.textOptionsLow, currentPoint.drawTextLow, this.gSeriesTextEle);
		                          chartObj.svgRenderer.ctx.restore();
		                      }
		                      else {
		                          
		                          ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.xPosLow, currentPoint.yPosLow, currentPoint.widthLow, currentPoint.heightLow, currentPoint.symbolName, this, this.gDataLabelEle[i])
		                          this.svgRenderer.drawText(currentPoint.textOptionsLow, currentPoint.drawTextLow, this.gSeriesTextEle[i]);

		                      }
		                  }
		                  else if (type.toLowerCase() == "boxandwhisker") {
								if(currentSeries.showMedian == true && currentPoint.textOptionsBoxValues != ""){
									ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.textOptionsBoxValues[0].xPos, currentPoint.textOptionsBoxValues[0].yPos, currentPoint.textOptionsBoxValues[0].width, currentPoint.textOptionsBoxValues[0].height, currentPoint.textOptionsBoxValues[0].symbolName, this)
		                            this.svgRenderer.drawText(currentPoint.textOptionsBoxValues[0], currentPoint.textOptionsBoxValues[0].drawText, this.gSeriesTextEle[i]);									 
								 }						  
								for (var box = 1; box < currentPoint.textOptionsBoxValues.length; box++) {							      
									 ej.EjSeriesRender.prototype.dataLabelSymbol(i, currentSeries, h, currentPoint.textOptionsBoxValues[box].xPos, currentPoint.textOptionsBoxValues[box].yPos, currentPoint.textOptionsBoxValues[box].width, currentPoint.textOptionsBoxValues[box].height, currentPoint.textOptionsBoxValues[box].symbolName, this)
		                             this.svgRenderer.drawText(currentPoint.textOptionsBoxValues[box], currentPoint.textOptionsBoxValues[box].drawText, this.gSeriesTextEle[i]);								  								  
								}
							}
                }
            }
		  }
        }

        // to append connector lines
		   if (this.model.AreaType != "none") {
                    // to append connector lines
                    var i, currentSeries;
                    for (i = 0; i < visibleSeriesLength; i++) {
                        this._appendConnectorElements(i);

                    }

                    // to append marker, data label symbol and text
                    var index;
                    var length = this.model._visibleSeries.length;
                    for (i = 0; i < length; i++) {
                        this._appendDataLabelElement(i);
                    }
                }
            }  //to append conector lines ,marker,datalabel symbol and text  for pie and doughnut 
            else {
                var p, currentSeries;
                for (p = visibleSeriesLength - 1; p >= 0 ; p--) {
                    currentSeries = this.model._visibleSeries[p];
                    type = currentSeries.type.toLowerCase();
                   if ((type == "pie" || type == "doughnut") && this.model.minhightwidth)
                        this._appendConnectorElements(p);
                }
                var index;
                var length = this.model._visibleSeries.length;
			if (length > 0 && type == "pieofpie") 
                    this._appendDataLabelElement(0);
			else{
                for (p = visibleSeriesLength - 1; p >= 0 ; p--) {
                    currentSeries = this.model._visibleSeries[p];
                    type = currentSeries.type.toLowerCase();
                    if ((type == "pie" || type == "doughnut") && this.model.minhightwidth)
                        this._appendDataLabelElement(p);
                }
            }
			}
		var length = this.model._visibleSeries.length;
		var s, series, templateContainer, dataLabel;
		for (s = 0; s < length; s++){
		 options = this.model._visibleSeries[s];
		    type = options.type.toLowerCase();
       options._previousType = ej.util.isNullOrUndefined(options._previousType) ? options.type : options._previousType;
		 if (!this.vmlRendering && options.visibility =="visible" && !this.model.enableCanvasRendering && !this.model.enable3D && this.model.AreaType != "none") {
            this.svgRenderer.append(this.gSeriesEle, this.svgObject);
            this.svgRenderer.append(this.svgObject, this.element);
			 series = new ej.seriesTypes[options.type.toLowerCase()]();
			 series.chartObj = chartObj;
			 series.gSeriesGroupEle = $("#" + this.svgObject.id + "_SeriesGroup_" + s)[0];
            if (options.enableAnimation && (!options._animatedSeries || options._previousType != options.type)&& this.model.AreaType != "none" ) {
                options._animatedSeries = true;
                options._previousType = options.type;
			    templateContainer = $('#template_group_' + this._id); 
                dataLabel=options.marker.dataLabel;				
               if (templateContainer.children().length != 0 && (dataLabel.visible && dataLabel.template))	 	
                   series.animateLabelTemplate(options);
			      if (type == "polar" || type == "radar")
					  ej.ejRadarSeries.prototype.doAnimation(options, series); // to animate polar/ radar
				  else
                      this.doAnimation(options);   // to animate cartesian series
            }
         }
		}
		
		// to append trend line to DOM and perform animation
		  var visibleSeries = this.model._visibleSeries;
		  var length = visibleSeries.length;
		  if (!this.model.enableCanvasRendering && !this.model.enable3D){
		    for (var k =0; k <length; k++){
		          if (visibleSeries[k].visibility.toLowerCase() == "visible" && this.gTrendlinesGroupEle && 
				      this.gTrendlinesGroupEle[k] && this.gTrendlinesGroupEle[k].childElementCount != 0)
		         this.svgRenderer.append(this.gTrendlinesGroupEle[k], this.svgObject);
			}
		  }
		 
		  var trendlines, trendline, trendlineType, options, i, j, trendLineLength;
		  for (i = 0; i < length; i++){
		    currentSeries = this.model._visibleSeries[i];
			trendlines = currentSeries.trendlines;
			trendLineLength = currentSeries.trendlines.length;
			for (j = 0; j < trendLineLength; j++) {
              trendline = trendlines[j];
                   if (trendline.visibility) {
			        trendlineType = trendline.type.toLowerCase();
			        options = new ej.trendlineTypes[trendlineType]();
			        if (trendline.visibility.toLowerCase() === 'visible' && trendline.points && trendline.points.length > 1 &&
                       currentSeries.enableAnimation && !this.vmlRendering && (!currentSeries._animatedTrendline || trendline._previousType != trendline.type)) {
			            trendline._previousType = trendline.type;
						var clipRect = $(this.svgObject).find("#" + this.svgObject.id + '_TrendGroup' + '_' + i + '_' + j + "_ClipRect").children();
			            ej.EjSeriesRender.prototype._doLineAnimation(this, clipRect); // for trendline animation
			            currentSeries._animatedTrendline = (trendLineLength - 1 == i) ? true : false;
			        }
				}
			}
		  }
	
	      var seriesEle, symbolEle;
		  var length = this.model._visibleSeries.length;
		  var svgObjectId = this.svgObject.id;
		  for (var i =0; i <length; i++){
		      var seriesEle = $("#" + svgObjectId + "_SeriesGroup_" + i);
		      var waterfallLineEle = $("#" + svgObjectId + '_SeriesGroup_waterfallLine_' + i);
			 var symbolEle = $("#" + svgObjectId + "_symbolGroup_" + i);
			 if (seriesEle.length >0 && symbolEle.length >0)
			     symbolEle.insertAfter(seriesEle);
			 if (seriesEle.length > 0 && waterfallLineEle.length > 0)
			     waterfallLineEle.insertAfter(seriesEle);
		  }
		  
	
		  this.model.AnimationComplete = true;
          var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
          commonEventArgs.data = {series : options};
          this._trigger("animationComplete", commonEventArgs);
		
		if (enableCanvasRendering) {
            this.svgRenderer.append(this.svgObject, this.element);
            if (this.panning) $("#" + this._id+ "_canvas").css({ "cursor": "pointer" });
        }       
		if (enable3D && !enableCanvasRendering) {
          this.svgRenderer.append(this.chart3D, this.svgObject);
           
          var size = { Width: $(this.svgObject).width(), Height: $(this.svgObject).height() };
          this.graphics.prepareView(this.model.perspectiveAngle, this.model.depth, this.model.rotation, this.model.tilt, size, this);
          this.graphics.view(this.svgObject, this);
          this.svgRenderer.append(this.svgObject, this.element);
          //for (var i = 0; i < visibleSeries.length; i++) {
          //    if (visibleSeries[i].visibility.toLowerCase() == "visible" && visibleSeries[i].enableAnimation && !(this.model.animated)) {
          //        var seriesRendering = new ej.Ej3DSeriesRender();
          //        var type = visibleSeries[i].type.toLowerCase();
          //        var options = ej.series3DTypes[type];
          //        if (this.model.AreaType == "none" && i > 0)
          //            break;
          //        options.doAnimation(visibleSeries[i], seriesRendering);
          //    }

          //}

        }
      
       if (this.svgRenderer.vmlNamespace)
            this.svgRenderer.append(this.gSeriesEle, this.svgObject);
        if (areaType == 'polaraxes')
            this.svgRenderer.append(this.gPolarAxisEle, this.svgObject);
        if ($(this.svgObject).find("#" + this.svgObject.id + "_StriplineOver").length > 0) {
            var detachEle = $(this.svgObject).find("#" + this.svgObject.id + "_StriplineOver").detach();
            detachEle.appendTo(this.svgObject);
        }

        this._renderScrollbar();      
		
		this.legendRender.drawLegend(params);
		
        chartObj.model.initSeriesRender = true;
    },
     
    _calculateZoomValue: function (startX, endX, axis, scrollObj) {
        var model = this.model,
            delta, zoomPos, zoomFact, start, end,
            scrollRange = axis.scrollbarSettings.range,
            valueType = axis._valueType.toLowerCase();
        if (valueType == "datetime") {
            start = Date.parse(!ej.util.isNullOrUndefined(scrollRange.min) ? new Date(scrollRange.min) : startX);
            end = Date.parse(!ej.util.isNullOrUndefined(scrollRange.max) ? new Date(scrollRange.max) : endX);
        }else{
            start = parseFloat(!ej.util.isNullOrUndefined(scrollRange.min) ? scrollRange.min : startX);
            end = parseFloat(!ej.util.isNullOrUndefined(scrollRange.max) ? scrollRange.max : endX);
        }
        start = Math.min(start, startX);
        end = Math.max(end, endX);
        delta = end - start;
        if (!scrollObj.isRTL) {
            zoomPos = (startX - start) / delta;
            zoomFact = (endX - startX) / delta;
        } else {
            zoomPos = (end - endX) / delta;
            zoomFact = (endX - startX) / delta;
        }
        scrollObj.scrollRange = { min: start, max: end, delta: end - start };
        scrollObj._previousStart = startX;
        scrollObj._previousEnd = endX;            
        scrollObj.zoomPosition = zoomPos;
        scrollObj.zoomFactor = zoomFact;
    },
     
    _renderScrollbar: function () {

        var model = this.model,
            scrollSize = model.scrollerSize,
            scrollObj, index,  
            chartOffsetVal = $('#' + this._id).offset(),
            offsetVal = ($(this.svgObject).offset().left - chartOffsetVal.left),
            scrollerWidth, scrollerHeight, scrollerX,
            scrollerY, scrollerX, axis,
            zoomFac,zoomPos,opposed,
            axesCollections = model._axes,
            axesLength = axesCollections.length,inversed,
            zoomingScroll = model.zooming.enableScrollbar,range,
            areaType = model.AreaType,scrollbarSettings,pointLength,
            scrollEleLength,scrollRange, scrObj,
            orientation;

        model.scrollObj = model.scrollObj ? model.scrollObj : [];

      
        for (var r = 0; r < axesLength; r++) {
            axis = axesCollections[r];
            valueType = axis._valueType;
            scrollbarSettings = axis.scrollbarSettings;
            range = scrollbarSettings.range;
            inversed = axis.isInversed,
            isZoomAble = areaType == "cartesianaxes" && !model.enable3D;
            opposed = axis._opposed;
            pointLength = scrollbarSettings.pointsLength;
            orientation = axis.orientation.toLowerCase();
            zoomFac = axis.zoomFactor;
            scrollEleLength = $("#scrollbar_" + this.axisScroll[0].id + r).length;
            zoomPos = axis.zoomPosition;

            if (isZoomAble && ((axis._isScroll && model.isLazyZooming) || ((zoomFac < 1 || zoomPos > 0) && zoomingScroll))) {

                scrollerX = axis.x + ((orientation == "vertical") ? (-scrollSize + (opposed ? scrollSize : 0)) : 0) + (offsetVal <= 0 ? 0 : offsetVal);
                scrollerY = axis.y + ((orientation == "horizontal") ? (axis.height + (opposed ? -scrollSize : 0)) : 0);
                posY = scrollerY - (orientation == 'horizontal' ? 0 : axis.plotOffset);
                width = axis.plotOffset + (orientation == 'horizontal' ? axis.width : axis.height);
                scrObj = model.scrollObj;
                if (range.min != null || range.max != null)
                    isRedraw = scrObj[r] ? (scrObj[r].actualRange.min != range.min || scrObj[r].actualRange.max != range.max) : false;
                else
                    isRedraw = scrObj[r] ? (scrObj[r].actualRange != scrollbarSettings.pointsLength) : false;
                this.scrollDraw = scrObj[r] ? (scrObj[r].x != scrollerX || scrObj[r].y != scrollerY || scrObj[r].width != width) : this.scrollDraw;
                var options = {
                    'orientation': axis.orientation,
                    'index': r,
                    'width': width,
                    'x': scrollerX,
                    'y': posY,
                    'opposed': opposed,
                    'isRTL': inversed,
                    'parent': this.axisScroll,
                    'enableResize': scrollbarSettings.canResize,
                }
                if (model.isLazyZooming) {
                   
                    if (scrollEleLength == 0 || this.scrollDraw || isRedraw) {
                        $("#scrollbar_" + this.axisScroll[0].id + r).remove();
                        if (range.min != null || range.max != null) {
                            scrollRange = (scrObj[r] && scrObj[r].scrollRange) ? scrObj[r].scrollRange : axis.visibleRange;
                            if (!this.scrollDraw || isRedraw) {
                                scrObj[r] = {
                                    'isVirtual': true,
                                    'valueType': valueType,
                                    'scrollRange': scrollRange
                                };
                                scrObj[r].actualRange = $.extend(scrObj[r].actualRange, scrollbarSettings.range);
                                $.extend(scrObj[r], options);
                                if (valueType == 'datetime') {
                                    scrObj[r].startDateTime = new Date(axis.visibleRange.min);
                                    scrObj[r].endDateTime = new Date(axis.visibleRange.max);
                                } else {
                                    scrObj[r].startValue = axis.visibleRange.min;
                                    scrObj[r].endValue = axis.visibleRange.max;
                                }

                                this._calculateZoomValue(axis.visibleRange.min, axis.visibleRange.max, axis, this.model.scrollObj[r]);
                            } else {
                                scrObj[r].width = width;
                                scrObj[r].x = scrollerX;
                                scrObj[r].y = posY;
                            }
                        } else if (pointLength >= axis.maxPointLength) {
                            zoomFac = axis.maxPointLength / pointLength;
                            zoomPos = (inversed) ? (1 - axis.zoomPosition) : axis.zoomPosition;
                            if (!this.scrollDraw || isRedraw) {
                                scrObj[r] = {
                                    'isVirtual': true,
                                    'zoomPosition': zoomPos,
                                    'zoomFactor': zoomFac,
                                    'scrollRange': {
                                        'min': 0,
                                        'max': pointLength - 1,
                                        'delta': pointLength - 1
                                    },
                                    'valueType': 'double'
                                };
                                scrObj[r].actualRange = scrollbarSettings.pointsLength;
                                $.extend(scrObj[r], options);
                                scrObj[r].startValue = 0;
                                scrObj[r].endValue = axis.maxPointLength;
                            } else {
                                scrObj[r].width = width;
                                scrObj[r].x = scrollerX;
                                scrObj[r].y = posY;
                            }
                          
                        }
                        if (this.model.scrollObj[r]) {
                            this.scrollbarContainer = new ej.EjSvgScrollbarRender(this.axisScroll, this.model.scrollObj[r]);
                            this.scrollbarContainer._initializeScrollbarVariables(this.model.scrollObj[r]);
                            this.scrollbarContainer._renderScrollbar.call(this, this.model.scrollObj[r]);
                        }
                    }
                }
                else if (scrollbarSettings.visible) {

                    //* Started Resizable Scrollbar here *// 
                    scrObj = model.scrollObj;

                    if (scrollEleLength == 0 || this.scrollDraw) {
                        $("#scrollbar_" + this.axisScroll[0].id + r).remove();
                        scrObj[r] = {
                            'zoomPosition': zoomPos,
                            'zoomFactor': zoomFac,
                            'valueType': valueType,
                            'scrollRange': axis.actualRange,
                            'isZooming':true
                        };
                        $.extend(scrObj[r], options);
                        if (scrObj[r].valueType == 'datetime') {
                            scrObj[r].startDateTime = new Date(scrObj[r].scrollRange.min);
                            scrObj[r].endDateTime = new Date(scrObj[r].scrollRange.max);
                        } else {
                            scrObj[r].startValue = scrObj[r].scrollRange.min;
                            scrObj[r].endValue = scrObj[r].scrollRange.max;
                        }
                        this.scrollbarContainer = new ej.EjSvgScrollbarRender(this.axisScroll, this.model.scrollObj[r]);
                        this.scrollbarContainer._initializeScrollbarVariables(this.model.scrollObj[r]);
                        this.scrollbarContainer._renderScrollbar.call(this, this.model.scrollObj[r]);
                    }
                }
                
            } else {
                if (scrollEleLength > 0)
                    $("#scrollbar_" + this.axisScroll[0].id + r).remove();

            }
        }
        this.scrollDraw = false;
    },

     //Draw the trendline series
    _renderTrendline: function (chartObj, seriesOptions) {
		// declaration
        var seriesIndex = $.inArray(seriesOptions, chartObj.model.series),
        transX = chartObj.model.requireInvertedAxes ? seriesOptions.yAxis.x : seriesOptions.xAxis.x,
        transY = chartObj.model.requireInvertedAxes ? seriesOptions.xAxis.y :seriesOptions.yAxis.y,
        translate = 'translate(' + transX + ',' + transY + ')',
        trendlinesOptions = { 'id': chartObj.svgObject.id + '_TrendlinesGroup' + '_' + seriesIndex, 'clip-path': 'url(#' + chartObj.svgObject.id + '_TrendlinesGroup' + '_' + seriesIndex + '_ClipRect)' },
        trendlines = seriesOptions.trendlines, m, element, polynomialSlopes,  slopeLength,
        options, trendline, i, slope, intercept, displayText, text = "",
        length = trendlines.length, trendOptions, trendlineType, commonEventArgs, backwardPoints, forwardPoints;
		
		if (!chartObj.gTrendlinesGroupEle) chartObj.gTrendlinesGroupEle = [];
        chartObj.gTrendlinesGroupEle[seriesIndex] = chartObj.svgRenderer.createGroup(trendlinesOptions);
        for (i = 0; i < length; i++) {
            trendline = trendlines[i];
            trendline.seriesIndex = seriesIndex;
            trendline.isTrendLine = true;
            trendline.trendlineIndex = i;
            if (trendline.visibility.toLowerCase() === 'visible' && !trendline.isNull && trendline.points && trendline.points.length > 1) {
                trendOptions = { 'id': chartObj.svgObject.id + '_TrendGroup' + '_' + seriesIndex + '_' + i, 'transform': translate, 'clip-path': 'url(#' + chartObj.svgObject.id + '_TrendGroup' + '_' + seriesIndex + '_' + i + '_ClipRect)' };
                seriesOptions.gTrendGroupEle = null;
                seriesOptions.gTrendGroupEle = chartObj.svgRenderer.createGroup(trendOptions);
                trendlineType = trendline.type.toLowerCase();
                options = new ej.trendlineTypes[trendlineType]();
                slope = trendline.slope;
                intercept = trendline._intercept;
                switch (trendlineType) {
                    case "linear":
                        text = "y = " + slope.toFixed(4) + "x + " + intercept.toFixed(4);
                        break;
                    case "exponential":
                        text = "y = " + intercept.toFixed(3) + "e" + "^" + slope.toFixed(4) + "x";
                        break;
                    case "logarithmic":
                        text = "y = " + slope.toFixed(3) + "ln(x) + " + intercept.toFixed(4);
                        break;
                    case "power":
                        text = "y = " + intercept.toFixed(3) + "x^" + slope.toFixed(4);
                        break;
                    case "polynomial":
                        polynomialSlopes = trendline.polynomialSlopes;
                        slopeLength = polynomialSlopes.length;
                        text = "y = ";
                        for (m = slopeLength - 1; m >= 0; m--) {
                            displayText = polynomialSlopes[m];
                            text += displayText > 0 ? "+" + displayText : "-" + Math.abs(displayText);
                            if (m != 0)
                                text += "x^" + m + " ";
                        }
                        break;
                }
                trendline.equation = text;   // for equation

                ////Trigger Trendline rendering events
                commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                backwardPoints = trendline.points[0];
                forwardPoints = trendline.points[trendline.points.length - 1];
                commonEventArgs.data = { series: seriesOptions, trendline: trendline, forwardForecastPoints: forwardPoints, backwardForecastPoints: backwardPoints };
                this._trigger("trendlineRendering", commonEventArgs);

                if (chartObj.model.enableCanvasRendering) {
                    this.svgRenderer.ctx.save();
                    this.svgRenderer.ctx.beginPath();
                    this.svgRenderer.ctx.rect(chartObj.model.m_AreaBounds.X, seriesOptions.yAxis.y, seriesOptions.xAxis.width, seriesOptions.yAxis.height);
                    this.svgRenderer.ctx.clip();
                    this.svgRenderer.ctx.beginPath();
                    options.draw(trendline, seriesOptions, chartObj);
                    this.svgRenderer.ctx.restore();
                } else {
                    options.draw(trendline, seriesOptions, chartObj);
                    //Add axes bounds clip path for series
                    element = seriesOptions.gTrendGroupEle;
                    if (element) ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, seriesOptions, this);
                }
            }
        }

    },
    _renderStripline: function (zIndex) {
        $.extend(ej.EjStripline.prototype, this);
        this.chartstripline = new ej.EjStripline(this);
        var stripline = this.chartstripline;
		 this.model._stripeline = false;
        for (var sl = 0; sl < this.model._axes.length; sl++) {
            var slAxis = this.model._axes[sl];
            for (var slCount = 0; slCount < slAxis.stripLine.length; slCount++) {
                if (slAxis.stripLine[slCount].zIndex.toLowerCase() == zIndex)
                    stripline._drawStripline(slAxis, slAxis.stripLine[slCount],sl,slCount);
            }
        }
        if (zIndex == 'over' && this.model._stripeline) {

            this.svgRenderer.append(this.gStriplineOver, this.svgObject);
        } else if(this.model._stripeline){
            this.svgRenderer.append(this.gStriplineBehind, this.svgObject);
        }
    },

    renderSeries: function (options, params) {

        var chart = this;
        var axis;
        var index;
        var seriesIndex = $.inArray(options, this.model._visibleSeries);

        for (var i = 0; i < options.points.length; i++) {
            if (typeof options.points[i].x == "string" && options.points[i].x.indexOf("/Date(") != -1)
                options.points[i].x = new Date(parseInt(options.points[i].x.substr(6)));
        }
        options.xAxis = (options.xAxis === null || options.xAxis === undefined) ? this.model._axes[0] : options.xAxis;
        options.yAxis = (options.yAxis === null || options.yAxis === undefined) ? this.model._axes[1] : options.yAxis;
        var type = options.type.toLowerCase();
		var drawtype = options.drawType.toLowerCase();
        var symbolOptions;
        var translate = null;
        var visibility;

        if (this.model.AreaType == "cartesianaxes") {
            var trans = ej.EjSvgRender.utils._getTransform(options.xAxis, options.yAxis, this.model.requireInvertedAxes);
            var translate = 'translate(' + trans.x + ',' + trans.y + ')';
            visibility = 'visible';
        }
        else {
            visibility = (options.enableAnimation && !options._animatedSeries) ? 'hidden' : 'visible'
        }
        var txtOptions = { 'id': this.svgObject.id + '_TextGroup_' + seriesIndex , 'transform': translate, 'visibility': visibility };
        var dataLabelOptions = { 'id': this.svgObject.id + '_DataLabel_' + seriesIndex , 'transform': translate, 'visibility': visibility };
        if (type != "scatter")
            symbolOptions = { 'id': this.svgObject.id + '_symbolGroup_' + seriesIndex , 'transform': translate, 'visibility': visibility };
        else
            symbolOptions = { 'id': this.svgObject.id + '_SeriesGroup' + '_' + seriesIndex, 'transform': translate };
        var connectorOptions = { 'id': this.svgObject.id + '_ConnectorGroup_' + seriesIndex , 'transform': translate, 'visibility': visibility };
        if (!this.gSymbolGroupEle) this.gSymbolGroupEle = [];
        this.gSymbolGroupEle[seriesIndex] = this.svgRenderer.createGroup(symbolOptions);
	    if (!this.gSeriesTextEle) this.gSeriesTextEle = [];
        this.gSeriesTextEle[seriesIndex] = this.svgRenderer.createGroup(txtOptions);
		if (!this.gConnectorEle) this.gConnectorEle = [];
        this.gConnectorEle[seriesIndex] = this.svgRenderer.createGroup(connectorOptions);
		if (!this.gDataLabelEle) this.gDataLabelEle = [];
        this.gDataLabelEle[seriesIndex] = this.svgRenderer.createGroup(dataLabelOptions);

        var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = { series: options };
        this._trigger("seriesRendering", commonEventArgs);

        var series = new ej.seriesTypes[type]();
        if (this.model.enableCanvasRendering && this.model.AreaType != "none") {
            this.svgRenderer.ctx.save();
            this.svgRenderer.ctx.beginPath();
            if (!this.model.requireInvertedAxes) { //checked for bar and stackingbar series
                this.canvasX = options.xAxis.x;
                this.canvasY = options.yAxis.y;
                this.svgRenderer.ctx.rect(options.xAxis.x, options.yAxis.y, options.xAxis.width, options.yAxis.height);
            } else {
                var translate = ej.EjSvgRender.utils._getTransform(options.xAxis, options.yAxis, this.model.requireInvertedAxes);
                this.canvasX = translate.x;
                this.canvasY = translate.y;
                this.svgRenderer.ctx.rect(options.yAxis.x, options.xAxis.y, options.yAxis.width, options.xAxis.height);
            }
            this.svgRenderer.ctx.clip();
            series.draw(this, options, params);
			this.svgRenderer.ctx.restore();
        }
        else if (this.model.enableCanvasRendering && this.model.AreaType == "polaraxes") {
            this.svgRenderer.ctx.save();
            this.svgRenderer.ctx.beginPath();
            this.svgRenderer.ctx.arc(this.model.centerX, this.model.centerY, this.model.Radius, 0, 2 * Math.PI, false);
            this.svgRenderer.ctx.clip();
            this.canvasX = this.canvasY = 0;
            series.draw(this, options);
            this.svgRenderer.ctx.restore();
        }
        else {
            this.canvasX = this.canvasY = 0;
            if (this.model.AreaType == "cartesianaxes")
                series.draw(this, options, params);
            else if (this.model.AreaType == "polaraxes" && (options._xAxisName == this.model._axes[0].name && options._yAxisName == this.model._axes[1].name))
                series.draw(this, options);
        }
        var errorbar = this.model.series[seriesIndex].errorBar,   
            areaType=this.model.AreaType;
        if (errorbar.visibility == 'visible' && areaType=='cartesianaxes' && (this.model.series[seriesIndex].type != "boxandwhisker"))
        	this.renderErrorBar(errorbar, options);                           // to render error bar
		
        //Add axes bounds clip path for series
        var element = series.gSeriesGroupEle;
        if (element) ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, options, this);

        // Draw Symbols       
            if (!(type == "candle" || type == "hilo" || type == "hiloopenclose" || type == "boxandwhisker")) {
                var chartObj = this;
				var point1;
				var areatype = chartObj.model.AreaType.toLowerCase();
				var regiontype = ej.seriesTypes[type].prototype.isRegion;
				if (!(type == "scatter")){
				    $.each(options._visiblePoints, function (pointIndex, point) {
				        if ((point.visible) && (point.x !== "") && ((point.marker && point.marker.visible) || (options.marker.visible))) {
				            //this condition provide for better Scatter performance
				            if ((areatype == "polaraxes" && drawtype == "column") || regiontype)
				                point1 = point.symbolLocation;
				            else
				                point1 = (areatype != "polaraxes")
                                ? ej.EjSvgRender.utils._getPoint(point, options) : ej.EjSvgRender.utils.TransformToVisible(options, point.xValue, point.y, chartObj)
				            if (areatype == "polaraxes") {
				                var labelFormat = options.yAxis.labelFormat ? options.yAxis.labelFormat : "";
				                var pointText = (point.text) ? point.text : point.y + labelFormat.substring(labelFormat.indexOf('}') + 1);
				                var textOffset = ej.EjSvgRender.utils._measureText(pointText, null, options.marker.dataLabel.font);
				            }
                            if ((areatype == "polaraxes" && (options._xAxisName == chartObj.model._axes[0].name && options._yAxisName == chartObj.model._axes[1].name))|| areatype == "cartesianaxes" )
				                series.drawSymbol(seriesIndex, options, pointIndex, point1.X, point1.Y);
				        }
                });
				}
                if (type != "scatter") {
                    //Add axes bounds clip path for marker
                    if (options.marker.visible) {
                        element = this.gSymbolGroupEle[seriesIndex];
                       ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, options, this);
                    }
                    // Add axes bounds clip path for marker text
                    if (options.marker.dataLabel.visible) {
                        element = this.gSeriesTextEle[seriesIndex];
                        ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, options, this);
						 // for data label shape
						 element = this.gDataLabelEle[seriesIndex];
						 ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, options, this);
                      }
					// Add axes bounds clip path for connector line
					if (!ej.util.isNullOrUndefined(this.gConnectorEle) && this.gConnectorEle.length >0) {
					    element = this.gConnectorEle[seriesIndex];
                        ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, options, this);
					}
                } else {
                    element = this.gSymbolGroupEle[seriesIndex];
                    ej.EjSvgRender.utils._drawAxesBoundsClipPath(element, options, this);
                    this.svgRenderer.append(element, this.gSeriesEle);

                    if (options.tooltip.visible || type == "scatter") {
                        if (!this.model.enableCanvasRendering)
                            var elements = $(this.gSymbolGroupEle).children().not("defs");
                        else
                            elements = this.model.series[seriesIndex].points;
                        if (this.vmlRendering) {
                            this.cloneSeriesEle = $(this.gSeriesEle).clone();
                            this.cloneobj = $(this.element).clone();
                            this.svgclone = $(this.svgObject).clone();
                            $(document.body).append(this.cloneobj);
                            this.svgRenderer.append(this.cloneSeriesEle, this.svgclone);
                            this.svgRenderer.append(this.svgclone, this.cloneobj);
                        }
                        else {
                            this.svgRenderer.append(this.gSeriesEle, this.svgObject);
                            this.svgRenderer.append(this.svgObject, this.element);
                        }

                        if (this.vmlRendering) {
                            $(this.cloneobj).remove();
                            $(this.svgclone).remove();
                        }
                    }
                }
            }

        

        //Draw Series Text

        this.drawDisplayText(series, options, params);

    },
	
	 renderErrorBar:function(errorOptions,seriesOptions)
    {
        // declaration
        var chartobj = this,
        model = chartobj.model,
        currentseries = seriesOptions,
        type,mode,direction,fill,cap,
        capFill,capWidth,capLength,
        visiblePoints = currentseries._visiblePoints,
        len = visiblePoints.length,
        canvasX = chartobj.canvasX, canvasY = chartobj.canvasY,
        seriesIndex = $.inArray(currentseries, model._visibleSeries),
        translate = null,i,
        trans = ej.EjSvgRender.utils._getTransform(currentseries.xAxis, currentseries.yAxis, model.requireInvertedAxes),
        verticalErrorValue,horizontalErrorValue,
        requireInvertedAxes = model.requireInvertedAxes,
        verticalPositive,verticalNegative,
        horizontalPositive,horizontalNegative,
        svgObjectId = chartobj.svgObject.id,
        areaBounds = chartobj.model.m_AreaBounds,
        translate = 'translate(' + trans.x + ',' + trans.y + ')',
        errorBarElement,errorBarGroup,event,errorBarPoint,
        pointIndex,point,yValue,xVal,standY,standX,
        location, verHighvalue, verLowvalue,
        horHighvalue, horLowvalue, mean, verMean, horMean,
        verStandSquareRoot, horStandSquareRoot, centervalueX, centervalueY,
        verStandardDeviationValue, horStandardDeviationValue,
        verCentervalue, horCentervalue,
        verStandardErrorValue, horStandardErrorValue,
        values, values1, verHighCapX1, verHighCapX2,
        verLowCapX1, verLowCapX2, horHighCapY1, horHighCapY2,
        horLowCapY1, horLowCapY2, eDirectionV, cDirectionV,
        eDirectionH, cDirectionH,eDirection,cDirection,
        fixvalue,pervalue,perY,perX,standDeviValue,standError,
        custom,capValues;

        // parent group creation
         errorBarGroup = {
            'id': svgObjectId + '_ErrorBarGroup' + '_' + seriesIndex,
            'transform': translate,
            'clip-path': 'url(#' + svgObjectId + '_ChartAreaClipRect)'
        };

        if (ej.util.isNullOrUndefined(chartobj.gErrorBarGroupEle))
            chartobj.gErrorBarGroupEle = [];
        errorBarElement =  chartobj.gErrorBarGroupEle[seriesIndex] = chartobj.svgRenderer.createGroup(errorBarGroup);

        commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);         
        commonEventArgs.data = {
            errorBar: errorOptions
        };
        this._trigger("errorBarRendering", commonEventArgs);      // trigger event

        event = commonEventArgs.data.errorBar;
        type = event.type;
        mode = event.mode;
        direction = event.direction;
        fill = event.fill;
        cap = event.cap;
        capFill = event.cap.fill;
        capWidth = event.cap.width;
        capLength = event.cap.length;
        verticalErrorValue = event.verticalErrorValue;
        horizontalErrorValue = event.horizontalErrorValue;
        verticalPositive = event.verticalPositiveErrorValue;
        verticalNegative = event.verticalNegativeErrorValue;
        horizontalPositive = event.horizontalPositiveErrorValue;
        horizontalNegative= event.horizontalNegativeErrorValue;
       
         for (i = 0; i < len; i++)
        {
             if (visiblePoints[i].isEmpty == false && visiblePoints[i].visible == true) {
                 // error bar group creation
                 errorBarPoint = {
                     'id': chartobj.svgObject.id + '_ErrorBarGroup' + '_' + seriesIndex + '_Point' + i
                 }
                 errorBarPointGroup = chartobj.svgRenderer.createGroup(errorBarPoint);
                 
                 pointIndex = i;
                 point = visiblePoints[i];
                 yValue = point.YValues[0];
                 xVal = point.xValue;
                 standY = visiblePoints[i].YValues[0];
                 standX = visiblePoints[i].xValue;

                 if (type.indexOf("column") || type.indexOf("bar") > -1)
                     location = point.symbolLocation;
                 else
                     location = point.location;
                 if (ej.util.isNullOrUndefined(location))
                        location = ej.EjSvgRender.utils._getPoint(point, currentseries);
                  centervalueX = location.X;
				  centervalueY = location.Y;
                 //error bar type calculation
                 switch (type) {             
                     case "fixedValue":         
                         fixvalue = point;
                         if (mode == 'vertical'||mode=='both') {          //vertical mode calculation for fixed value point location
                             fixvalue.YValues[0] = yValue + verticalErrorValue;
                              verHighvalue = ej.EjSvgRender.utils._getPoint(fixvalue, currentseries);
                             fixvalue.YValues[0] = yValue - verticalErrorValue;
                             verLowvalue = ej.EjSvgRender.utils._getPoint(fixvalue, currentseries);
                             if (!requireInvertedAxes)
                                 verHighvalue.X = verLowvalue.X = location.X;
                             else
                                 verHighvalue.Y = verLowvalue.Y = location.Y;
                         }
                         if (mode == 'horizontal' || mode == 'both') {
                             fixvalue.YValues[0] = yValue;
                             fixvalue.xValue = xVal;                    //horizontal mode calculation for fixed value point location
                             fixvalue.xValue = xVal + horizontalErrorValue;
                             horHighvalue = ej.EjSvgRender.utils._getPoint(fixvalue, currentseries);
                             fixvalue.xValue = xVal - horizontalErrorValue;
                             horLowvalue = ej.EjSvgRender.utils._getPoint(fixvalue, currentseries);
                         }
                         fixvalue.YValues[0] = yValue;
                         fixvalue.xValue = xVal;
                         break;

                     case "percentage":         
                         pervalue = point;
                         perY = verticalErrorValue / 100 * yValue;
                         perX = horizontalErrorValue / 100 * xVal;
                         if (mode == 'vertical'||mode=='both') {                  //vertical mode calculation for percentage point locaion
                             pervalue.YValues[0] = yValue + perY;
                             verHighvalue = ej.EjSvgRender.utils._getPoint(pervalue, currentseries);
                             pervalue.YValues[0] = yValue - perY;
                             verLowvalue = ej.EjSvgRender.utils._getPoint(pervalue, currentseries);
                             if (!requireInvertedAxes) 
                                 verHighvalue.X =verLowvalue.X= location.X;
                             else 
                                 verHighvalue.Y =verLowvalue.Y = location.Y;
                         }
                         if (mode == 'horizontal' || mode == 'both') {
                             pervalue.YValues[0] = yValue;
                             pervalue.xValue = xVal;                              //horizontal mode calculation for percentage
                             pervalue.xValue = xVal + perX;
                             horHighvalue = ej.EjSvgRender.utils._getPoint(pervalue, currentseries);
                             pervalue.xValue = xVal - perX;
                             horLowvalue = ej.EjSvgRender.utils._getPoint(pervalue, currentseries);
                         }
                         pervalue.YValues[0] = yValue;
                         pervalue.xValue = xVal;
                         break;

                     case "standardDeviation":          
                          standDeviValue = point;
                             mean = chartobj.meanCalculation(mode, visiblePoints);
                             verMean = mean.verMean;
                             horMean = mean.horMean;
                             verStandSquareRoot = mean.verStandSquareRoot;
                             horStandSquareRoot = mean.horStandSquareRoot;
                         if (mode == 'vertical'|| mode=='both') {                 
                             verStandardDeviationValue = verticalErrorValue * verStandSquareRoot;
                             standDeviValue.YValues[0] = verMean;
                             verCentervalue = ej.EjSvgRender.utils._getPoint(standDeviValue, currentseries);
                             yValue = standDeviValue.YValues[0];
                             standDeviValue.YValues[0] = yValue + verStandardDeviationValue;
                             verHighvalue = ej.EjSvgRender.utils._getPoint(standDeviValue, currentseries);
                             standDeviValue.YValues[0] = yValue - verStandardDeviationValue;
                             verLowvalue = ej.EjSvgRender.utils._getPoint(standDeviValue, currentseries);
                             if (!requireInvertedAxes) 
                                 verCentervalue.X = verHighvalue.X = verLowvalue.X = location.X;
                             else
                                 verCentervalue.Y = verHighvalue.Y = verLowvalue.Y = location.Y;
                             verCentervalue.X = verCentervalue.X + canvasX;
							 verCentervalue.Y = verCentervalue.Y + canvasY;
                         }
                         if (mode == 'horizontal' || mode == 'both') {
                             horStandardDeviationValue = horizontalErrorValue * horStandSquareRoot;
                             standDeviValue.xValue = horMean;
                             horCentervalue = ej.EjSvgRender.utils._getPoint(standDeviValue, currentseries);
                             if (!requireInvertedAxes)
                                 horCentervalue.Y = location.Y;
							 else
								 horCentervalue.X = location.X;
                             standDeviValue.YValues[0] = standY;
                             xVal = standDeviValue.xValue;
                             standDeviValue.xValue = xVal + horStandardDeviationValue;
                             horHighvalue = ej.EjSvgRender.utils._getPoint(standDeviValue, currentseries);  
                             standDeviValue.xValue = xVal - horStandardDeviationValue;
                             horLowvalue = ej.EjSvgRender.utils._getPoint(standDeviValue, currentseries);
							 horCentervalue.X = horCentervalue.X + canvasX;
                             horCentervalue.Y = horCentervalue.Y + canvasY;
							 
                         } 
                         standDeviValue.YValues[0] = standY;
                         standDeviValue.xValue = standX;
                        
                         break;
                     case "standardError":           
                         standError = point;
                         mean = chartobj.meanCalculation(mode, visiblePoints);
                         verStandSquareRoot = mean.verStandSquareRoot;
                         horStandSquareRoot = mean.horStandSquareRoot;
                         if (mode == 'vertical'||mode=='both') {                                   //vertical mode standard Error calculation
                             verStandardDeviationValue = verticalErrorValue * verStandSquareRoot;
                             verStandardErrorValue = verStandardDeviationValue / Math.sqrt(len);
                             standError.YValues[0] = yValue + verStandardErrorValue;
                             verHighvalue = ej.EjSvgRender.utils._getPoint(standError, currentseries);
                             standError.YValues[0] = yValue - verStandardErrorValue
                             verLowvalue = ej.EjSvgRender.utils._getPoint(standError, currentseries);
                             if (!requireInvertedAxes)
                                 verHighvalue.X = verLowvalue.X = location.X;
                             else
                                 verHighvalue.Y = verLowvalue.Y = location.Y;
                         }
                         if (mode == 'horizontal'||mode=='both') {                             //horizontal mode standard Error calculation
                             horStandardDeviationValue = horizontalErrorValue *horStandSquareRoot;
                             horStandardErrorValue = horStandardDeviationValue / Math.sqrt(len);
                             standError.YValues[0] = yValue;
                             standError.xValue = xVal;                      //horizontal mode calculation for  point location
                             standError.xValue = xVal + horStandardErrorValue;
                             horHighvalue = ej.EjSvgRender.utils._getPoint(standError, currentseries);
                             standError.xValue = xVal - horStandardErrorValue;
                             horLowvalue = ej.EjSvgRender.utils._getPoint(standError, currentseries);
                         }
                         standError.YValues[0] = yValue;
                         standError.xValue = xVal;
                         i = pointIndex;
                         break;

                     case "custom":
                         custom = point;
                         if (mode == 'vertical'||mode=='both') {                         //calculation for vertical mode point locaton
                             custom.YValues[0] = yValue + verticalPositive;
                             verHighvalue = ej.EjSvgRender.utils._getPoint(custom, currentseries);
                             custom.YValues[0] = yValue - verticalNegative;
                             verLowvalue = ej.EjSvgRender.utils._getPoint(custom, currentseries);
                             if (!requireInvertedAxes) 
                                 verHighvalue.X = verLowvalue.X=location.X;
                             else 
                                 verHighvalue.Y =verLowvalue.Y = location.Y;
                         }
                         if (mode == 'horizontal'||mode=='both') {
                             custom.YValues[0] = yValue;
                             custom.xValue = xVal;                     //calculation for horizontal mode point location
                             custom.xValue = xVal + horizontalPositive;
                             horHighvalue = ej.EjSvgRender.utils._getPoint(custom, currentseries);
                             custom.xValue = xVal - horizontalNegative;
                             horLowvalue = ej.EjSvgRender.utils._getPoint(custom, currentseries);
                         }
                         custom.YValues[0] = yValue;
                         custom.xValue = xVal;
                         break;
                 }
                
                 //to render cap 
                 if (cap.visible == true) {
                     if(mode=='vertical'||mode=='both')
                          values = { verHighvalue: verHighvalue, verLowvalue: verLowvalue }
                     if(mode=='horizontal'||mode=='both')
                          values1={   horHighvalue: horHighvalue,horLowvalue: horLowvalue}
                     capValues = chartobj.renderCap(cap, mode, values,values1, requireInvertedAxes); 
                     verHighCapX1 = capValues.verHighCapX1, verHighCapX2 = capValues.verHighCapX2,
                     verLowCapX1 = capValues.verLowCapX1,verLowCapX2 = capValues.verLowCapX2,
                     horHighCapY1 = capValues.horHighCapY1,horHighCapY2 = capValues.horHighCapY2,
                     horLowCapY1 = capValues.horLowCapY1,horLowCapY2 = capValues.horLowCapY2;
                 }
                 centervalueX = centervalueX + canvasX;
                 centervalueY = centervalueY + canvasY;
                 if (mode == 'vertical' || mode == 'both') {
                     verHighvalue.X = verHighvalue.X + canvasX;
                     verHighvalue.Y = verHighvalue.Y + canvasY;
                     verLowvalue.X = verLowvalue.X + canvasX;
                     verLowvalue.Y = verLowvalue.Y + canvasY;
                 }
                 if (mode == 'horizontal' || mode == 'both') {
                     horHighvalue.X = horHighvalue.X + canvasX;
                     horHighvalue.Y = horHighvalue.Y + canvasY;
                     horLowvalue.X = horLowvalue.X + canvasX;
                     horLowvalue.Y = horLowvalue.Y + canvasY;
                 }
    //drawing error bar and error bar cap  
             //drawing both direction    
             if (direction == 'both') {   
                  if (mode == 'vertical'|| mode =='both') {             //vertical mode for both direction
                       if (type != 'standardDeviation') 
                           eDirectionV = "M" + " " + (centervalueX) + " " + (centervalueY) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "M" + " " + (centervalueX) + " " + (centervalueY) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " ";
                       else if (type == 'standardDeviation') 
                           eDirectionV = "M" + " " + (verCentervalue.X) + " " + (verCentervalue.Y) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "M" + " " + (verCentervalue.X) + " " + (verCentervalue.Y) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " ";
                       if(!requireInvertedAxes)
                           cDirectionV = !cap.visible ? "" : "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighCapX1) + " " + (verHighvalue.Y) + " " + "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighCapX2) + " " + (verHighvalue.Y) + " " + "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowCapX1) + " " + (verLowvalue.Y) + " " + "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowCapX2) + " " + (verLowvalue.Y) + " ";
                       else
                           cDirectionV = !cap.visible ? "" : "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighCapX1) + " " + "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighCapX2) + " " + "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowCapX1) + " " + "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowCapX2) + " ";
                           eDirection = eDirectionV,cDirection = cDirectionV;
                   }
                   if (mode == 'horizontal' || mode == 'both') {
                       if (type != 'standardDeviation')                          //horizontal mode for both direction
                           eDirectionH = "M" + " " + (centervalueX) + " " + (centervalueY ) + " " + "L" + " " + (horHighvalue.X ) + " " + (horHighvalue.Y ) + " " + "M" + " " + (centervalueX ) + " " + (centervalueY ) + " " + "L" + " " + (horLowvalue.X ) + " " + (horLowvalue.Y ) + " ";
                       else if (type == 'standardDeviation')
                           eDirectionH = "M" + " " + (horCentervalue.X) + " " + (horCentervalue.Y ) + " " + "L" + " " + (horHighvalue.X ) + " " + (horHighvalue.Y) + " " + "M" + " " + (horCentervalue.X ) + " " + (horCentervalue.Y ) + " " + "L" + " " + (horLowvalue.X ) + " " + (horLowvalue.Y) + " ";
                       if (!requireInvertedAxes)
                           cDirectionH = !cap.visible ? "" :"M" + " " + (horHighvalue.X) + " " + (horHighvalue.Y ) + " " + "L" + " " + (horHighvalue.X ) + " " + (horHighCapY1) + " " + "M" + " " + (horHighvalue.X ) + " " + (horHighvalue.Y ) + " " + "L" + " " + (horHighvalue.X ) + " " + (horHighCapY2) + " " + "M" + " " + (horLowvalue.X ) + " " + (horLowvalue.Y ) + " " + "L" + " " + (horLowvalue.X ) + " " + (horLowCapY1) + " " + "M" + " " + (horLowvalue.X ) + " " + (horLowvalue.Y ) + " " + "L" + " " + (horLowvalue.X) + " " + (horLowCapY2) + " ";
                       else
                           cDirectionH = !cap.visible ? "" : "M" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " " + "L" + " " + (horHighCapY1) + " " + (horHighvalue.Y) + " " + "M" + " " + (horHighvalue.X ) + " " + (horHighvalue.Y ) + " " + "L" + " " + (horHighCapY2) + " " + (horHighvalue.Y) + " " + "M" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " " + "L" + " " + (horLowCapY1) + " " + (horLowvalue.Y ) + " " + "M" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " " + "L" + " " + (horLowCapY2) + " " + (horLowvalue.Y ) + " ";
                       eDirection = eDirectionH, cDirection = cDirectionH;
                   }
                    if (mode == 'both') {
                        eDirectionH += eDirectionV,cDirectionH += cDirectionV;
                        eDirection = eDirectionH,cDirection = cDirectionH;
                    }
             }
           //drawing plus direction
             else if (direction == 'plus') {  
                    if (mode == 'vertical'|| mode =='both') {        //vertical mode for plus direction
                            if (type != 'standardDeviation') 
                                  eDirectionV = "M" + " " + (centervalueX) + " " + (centervalueY) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " ";
                            else if (type == 'standardDeviation') 
                                eDirectionV = "M" + " " + (verCentervalue.X) + " " + (verCentervalue.Y ) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " ";
                                if (!requireInvertedAxes)
                                    cDirectionV = !cap.visible ? "" : "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighCapX1) + " " + (verHighvalue.Y) + " " + "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighCapX2) + " " + (verHighvalue.Y) + " ";
                                else
                                    cDirectionV = !cap.visible ? "" : "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighCapX1) + " " + "M" + " " + (verHighvalue.X) + " " + (verHighvalue.Y) + " " + "L" + " " + (verHighvalue.X) + " " + (verHighCapX2) + " ";
                            var eDirection = eDirectionV,cDirection = cDirectionV;
                    }
                    if (mode == 'horizontal' || mode == 'both') {
                        if (type != 'standardDeviation')                        //horizontal mode for both direction
                            eDirectionH = "M" + " " + (centervalueX) + " " + (centervalueY) + " " + "L" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " ";
                        else if (type == 'standardDeviation')
                            eDirectionH =  "M" + " " + (horCentervalue.X) + " " + (horCentervalue.Y) + " " + "L" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " " ;
                        if (!requireInvertedAxes)
                            cDirectionH = !cap.visible ? "" : "M" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " " + "L" + " " + (horHighvalue.X) + " " + (horHighCapY1) + " " + "M" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " " + "L" + " " + (horHighvalue.X) + " " + (horHighCapY2) + " " ;
                        else 
                            cDirectionH = !cap.visible ? "" : "M" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " " + "L" + " " + (horHighCapY1) + " " + (horHighvalue.Y) + " " + "M" + " " + (horHighvalue.X) + " " + (horHighvalue.Y) + " " + "L" + " " + (horHighCapY2) + " " + (horHighvalue.Y) + " ";
                        eDirection = eDirectionH,cDirection = cDirectionH;
                    }
                    if (mode == 'both') {
                        eDirectionH += eDirectionV,cDirectionH += cDirectionV;
                        eDirection = eDirectionH,cDirection = cDirectionH;
                    }
                }
          // drawing minus direction
                else
                {
                    if (mode == 'vertical' || mode == 'both') {             //vertical mode for both direction
                        if (type != 'standardDeviation') 
                             eDirectionV =  "M" + " " + (centervalueX) + " " + (centervalueY) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " ";
                        else if (type == 'standardDeviation') 
                            eDirectionV =  "M" + " " + (verCentervalue.X) + " " + (verCentervalue.Y) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " ";
                           if (!requireInvertedAxes)
                                cDirectionV = !cap.visible ? "" : "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowCapX1) + " " + (verLowvalue.Y) + " " + "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowCapX2) + " " + (verLowvalue.Y) + " ";
                            else
                                cDirectionV = !cap.visible ? "" :  "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowCapX1) + " " + "M" + " " + (verLowvalue.X) + " " + (verLowvalue.Y) + " " + "L" + " " + (verLowvalue.X) + " " + (verLowCapX2) + " ";
                        var eDirection = eDirectionV, cDirection = cDirectionV;
                    }
                    if (mode == 'horizontal' || mode == 'both') {
                        if (type != 'standardDeviation')                        //horizontal mode for both direction
                            eDirectionH =  "M" + " " + (centervalueX) + " " + (centervalueY) + " " + "L" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " ";
                        else if (type == 'standardDeviation')
                            eDirectionH =  "M" + " " + (horCentervalue.X) + " " + (horCentervalue.Y) + " " + "L" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " ";
                        if (!requireInvertedAxes)
                            cDirectionH = !cap.visible ? "" : "M" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " " + "L" + " " + (horLowvalue.X) + " " + (horLowCapY1) + " " + "M" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " " + "L" + " " + (horLowvalue.X ) + " " + (horLowCapY2) + " ";
                        else
                            cDirectionH = !cap.visible ? "" : "M" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " " + "L" + " " + (horLowCapY1) + " " + (horLowvalue.Y) + " " + "M" + " " + (horLowvalue.X) + " " + (horLowvalue.Y) + " " + "L" + " " + (horLowCapY2) + " " + (horLowvalue.Y) + " ";
                        eDirection = eDirectionH, cDirection = cDirectionH;
                    }
                    if (mode == 'both') {
                        eDirectionH += eDirectionV,cDirectionH += cDirectionV;
                        eDirection = eDirectionH,cDirection = cDirectionH;
                    }
                }
                                                 
                var errorBarOptions = {             //error bar path creation
                    'id': chartobj.svgObject.id + '_ErrorBar' + '_' + seriesIndex + '_Point' + pointIndex,
                    'd': eDirection,
                    'stroke': fill,
                    'stroke-width': errorOptions.width,
                    'opacity': errorOptions.opacity
                };
                var errorBarCapOptions = {       //error bar cap creation
                    'id': chartobj.svgObject.id + '_ErrorBarCap' + '_' + seriesIndex + '_Point' + pointIndex,
                    'd': cDirection,
                    'stroke':capFill,
                    'stroke-width':capWidth
                }
        //canvas rendering
                if (chartobj.model.enableCanvasRendering) {
                    this.svgRenderer.ctx.rect(areaBounds.X, areaBounds.Y, areaBounds.Width, areaBounds.Height);
                    this.svgRenderer.ctx.clip();
                    chartobj.svgRenderer.drawPath(errorBarOptions, null);              //To draw error bar for canvas
                    chartobj.svgRenderer.drawPath(errorBarCapOptions, null);           //To drae error bar cap for canvas
                }
                else {                                        //svg rendering
                    chartobj.svgRenderer.drawPath(errorBarOptions, errorBarPointGroup);
                    chartobj.svgRenderer.drawPath(errorBarCapOptions, errorBarPointGroup);
                    chartobj.svgRenderer.append(errorBarPointGroup, errorBarElement);
                }
            }
        }
        //append with series group
         chartobj.svgRenderer.append(errorBarElement, chartobj.gSeriesEle);
        //clip-path 
         ej.EjSvgRender.utils._drawAxesBoundsClipPath(errorBarElement,currentseries,chartobj);
    },
     
    meanCalculation:function(mode,visiblePoints)
    {
        var temp = temp1 = 0, total, verTotal, horTotal, verMean, horMean, ded,i,
            eachDev, squareEachDev, squareTotal, verEachDev, horEachDev,
            verSquareEachDev, verSquareTotal, horSquareTotal, horSquareTotal,
            verStandardMean, horStandardMean, verStandSquareRoot,
            horStandSquareRoot, values, len = visiblePoints.length;
        for (i = 0; i < len; i++) {
            if (mode == 'vertical') {             //vertical mode total calculation
                total = temp + visiblePoints[i].y;
                temp = total;
            }
            else if (mode == 'horizontal') {    //horizontal mode total calculation 
                total = temp1 + visiblePoints[i].xValue;
                temp1 = total;
            }
            else {                     //both mode  total calculation
                 verTotal = temp + visiblePoints[i].y;
                 temp = verTotal;
                 horTotal = temp1 + visiblePoints[i].xValue;
                 temp1 = horTotal;
            }
        }
         verMean = temp / len;
         horMean = temp1 / len;
         ded = len - 1;
        for (i = 0; i < len; i++) {
            if (mode == 'vertical') {
                eachDev = visiblePoints[i].y - verMean;
                squareEachDev = Math.pow(eachDev, 2);
                squareTotal = temp + squareEachDev;
                temp = squareTotal;
            }
            else if (mode == 'horizontal') {
                eachDev = visiblePoints[i].xValue - horMean;
                squareEachDev = Math.pow(eachDev, 2);
                squareTotal = temp1 + squareEachDev;
                temp1 = squareTotal;
            }
            else {
                verEachDev = visiblePoints[i].y - verMean;
                verSquareEachDev = Math.pow(verEachDev, 2);
                verSquareTotal = temp + verSquareEachDev;
                temp = verSquareTotal;
                horEachDev = visiblePoints[i].xValue - horMean;
                horSquareEachDiv = Math.pow(horEachDev, 2);
                horSquareTotal = temp1 + horSquareEachDiv;
                temp1 = horSquareTotal;
            }
        }
        verStandardMean = temp / ded;
        verStandSquareRoot = Math.sqrt(verStandardMean);
        horStandardMean = temp1 / ded;
        horStandSquareRoot = Math.sqrt(horStandardMean);
        values = { verStandSquareRoot: verStandSquareRoot, horStandSquareRoot: horStandSquareRoot, verMean: verMean, horMean: horMean }
        return values;
    },
    renderCap:function(cap,mode,values,values1,requireInvertedAxes)
    {
        //declaration
        var canvasX, canvasY, capLen, verHighvalue,
            verLowvalue, horHighvalue, horLowvalue,
            verHighCapX1, verHighCapX2, verLowCapX1,
            verLowCapX2, horHighCapY1, horHighCapY2,
            horLowCapY1, horLowCapY2,capValues;
        canvasX = this.canvasX;
        canvasY = this.canvasY;
        capLen = cap.length / 2;
        if (mode == 'vertical' || mode == 'both') {
            verHighvalue = values.verHighvalue;
            verLowvalue = values.verLowvalue;
        }
        if (mode == 'horizontal' || mode == 'both') {
            horHighvalue = values1.horHighvalue;
            horLowvalue = values1.horLowvalue;
        }
        if (mode == 'vertical' || mode == 'both') {
            if (!requireInvertedAxes) {
                 verHighCapX1 = verHighvalue.X+canvasX - capLen,
                 verHighCapX2 = verHighvalue.X+canvasX + capLen,
                 verLowCapX1 = verLowvalue.X+canvasX- capLen,
                 verLowCapX2 = verLowvalue.X+canvasX + capLen;
            }
            else {
                verHighCapX1 = verHighvalue.Y+canvasY + capLen;
                verHighCapX2 = verHighvalue.Y+canvasY - capLen;
                verLowCapX1 = verLowvalue.Y+canvasY + capLen;
                verLowCapX2 = verLowvalue.Y+canvasY - capLen;
            }
        }
        if (mode == 'horizontal' || mode == 'both') {
            if (!requireInvertedAxes) {
                 horHighCapY1 = horHighvalue.Y+canvasY - capLen,
                 horHighCapY2 = horHighvalue.Y+canvasY + capLen,
                 horLowCapY1 = horLowvalue.Y+canvasY - capLen,
                 horLowCapY2 = horLowvalue.Y+canvasY + capLen;
            }
            else {
                horHighCapY1 = horHighvalue.X+canvasX + capLen;
                horHighCapY2 = horHighvalue.X+canvasX - capLen;
                horLowCapY1 = horLowvalue.X+canvasX + capLen;
                horLowCapY2 = horLowvalue.X+canvasX - capLen;
            }
        }
            capValues = { verHighCapX1: verHighCapX1, verHighCapX2: verHighCapX2, verLowCapX1: verLowCapX1, verLowCapX2: verLowCapX2, horHighCapY1: horHighCapY1, horHighCapY2: horHighCapY2, horLowCapY1: horLowCapY1, horLowCapY2: horLowCapY2 }
        return capValues;
    },
	
	drawDisplayText: function (series, options, params){
	    // method to draw text 
	   
	        var chartObj = this;
			var point1;
			var type = options.type.toLowerCase();
	        var areatype = chartObj.model.AreaType.toLowerCase();
	        var regiontype = ej.seriesTypes[type].prototype.isRegion;
	        var drawtype = options.drawType.toLowerCase();
	        var pointMarker;
			var zoomed = false;
	        var seriesIndex = $.inArray(options, chartObj.model._visibleSeries);
	        if (ej.util.isNullOrUndefined(chartObj.model.regionCount))
                chartObj.model.regionCount = -1;	        
	         
            var isCanvas = chartObj.model.enableCanvasRendering;
            var isPolar = chartObj.model.AreaType.toLowerCase() == 'polaraxes';
            $.each(options._visiblePoints, function (pointIndex, point) {
                var type = chartObj.model.series[seriesIndex].type.toLowerCase();
			     options._visiblePoints[pointIndex].textOptionsBoxValues =[];
                pointMarker = point.marker;
                if ((areatype == "polaraxes" && drawtype == "column") || regiontype)
                    point1 = type.toLowerCase() == "boxandwhisker" ? point.dataLabelLocation : point.symbolLocation;
                else
                    point1 = (areatype != "polaraxes")
                    ? ej.EjSvgRender.utils._getPoint(point, options) : ej.EjSvgRender.utils.TransformToVisible(options, point.xValue, point.y, chartObj)
                if (point.visible && ((pointMarker && pointMarker.dataLabel && pointMarker.dataLabel.visible) || (!pointMarker || !pointMarker.dataLabel) && options.marker.dataLabel.visible)) {
                    if (regiontype)
                        chartObj.model.regionCount++;

                    var type = chartObj.model.series[seriesIndex].type.toLowerCase();
					for (i = 0; i < chartObj.model._axes.length ; i++) {
					    if (chartObj.model._axes[i].zoomFactor < 1 || chartObj.model._axes[i].zoomPosition > 0)
					       { zoomed = true;
						   break;
						   }
					    }
                    //we have reset the chartRegions array based on the zooming points for column and stackingColumn series only
                    if ((chartObj.zoomed || options.xAxis._isScroll || zoomed) && (type == "column" || type == "stackingcolumn" || type == "stackingcolumn100")) {
                        for (var i = 0; i < chartObj.model.chartRegions.length; i++) {
                            if (seriesIndex == chartObj.model.chartRegions[i].SeriesIndex && pointIndex == chartObj.model.chartRegions[i].Region.PointIndex) {
                                if (isCanvas && chartObj.model.AreaType == "cartesianaxes") {
                                    chartObj.svgRenderer.ctx.save();
                                    chartObj.svgRenderer.ctx.beginPath();
                                    if (!chartObj.model.requireInvertedAxes) // checked for bar and stackingbar
                                        chartObj.svgRenderer.ctx.rect(options.xAxis.x, options.yAxis.y, options.xAxis.width, options.yAxis.height);
                                    else
                                        chartObj.svgRenderer.ctx.rect(options.yAxis.x, options.xAxis.y, options.yAxis.width, options.xAxis.height);
                                    chartObj.svgRenderer.ctx.clip();
                                    series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, i, params);
                                    chartObj.svgRenderer.ctx.restore();
                                }
                                else
                                    series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, i, params);
                            }
                        }
                    }
                    else {
                        if (isCanvas && chartObj.model.AreaType == "cartesianaxes") {
                            chartObj.svgRenderer.ctx.save();
                            chartObj.svgRenderer.ctx.beginPath();
                            if (!chartObj.model.requireInvertedAxes) // checked for bar and stackingbar
                                chartObj.svgRenderer.ctx.rect(options.xAxis.x, options.yAxis.y, options.xAxis.width, options.yAxis.height);
	                        else
	                            chartObj.svgRenderer.ctx.rect(options.yAxis.x, options.xAxis.y, options.yAxis.width, options.xAxis.height);
	                        chartObj.svgRenderer.ctx.clip();
							//Check regions for column type, bar type and waterfall series
							if(chartObj.model.chartRegions[chartObj.model.regionCount] || (type.indexOf('column')==-1 && type.indexOf('bar')==-1 && type.indexOf('waterfall')==-1)){
								if(type.toLowerCase() == "boxandwhisker")
								{
									for(var box = 0;box<point1.length;box++)
									{
										point.y = point.boxPlotLocation[box].YValues;
										series.drawDataLabel(options, pointIndex, point, point1[box].X,point1[box].Y, chartObj.model.regionCount, params,point1[box].outlier);
									}
								}
								else
									series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, chartObj.model.regionCount, params);
								if (type == "rangecolumn" || type == "rangearea") {	                           
									point.y = point.low;
                                    series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, chartObj.model.regionCount, params);
                                    point.y = point.high;
                                }
                            }
                            chartObj.svgRenderer.ctx.restore();
                        }
                        else {
                            if (isCanvas && isPolar) {
                                chartObj.svgRenderer.ctx.save();
                                chartObj.svgRenderer.ctx.beginPath();
                                chartObj.svgRenderer.ctx.arc(chartObj.model.centerX, chartObj.model.centerY, chartObj.model.Radius, 0, 2 * Math.PI, false);
                                chartObj.svgRenderer.ctx.clip();
                                point1.X -= chartObj.canvasX;
                                point1.Y -= chartObj.canvasY;
                            }
                            if ((type == "column" || type == "stackingcolumn" || type == "stackingcolumn100")) {
                                if (chartObj.model.chartRegions[chartObj.model.regionCount])
                                    series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, chartObj.model.regionCount, params);
                            }
                            else {
									if(type.toLowerCase() == "boxandwhisker")
									{								
										for(var box = 0;box<point1.length;box++)
										{
										    point.y = point.boxPlotLocation[box].YValues;
										    series.drawDataLabel(options, pointIndex, point, point1[box].X, point1[box].Y, chartObj.model.regionCount, params, point1[box].outlier);
										}								
									}
									else
										series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, chartObj.model.regionCount, params);
								}
                            if (type == "rangecolumn" || type == "rangearea") {
                                point.y = point.low;
                                series.drawDataLabel(options, pointIndex, point, point1.X, point1.Y, chartObj.model.regionCount, params);
                                point.y = point.high;
                            }
                            if (isCanvas && isPolar)
                                chartObj.svgRenderer.ctx.restore();
                        }
                    }
                }
            });
	},
	
	// method to avoid collision between data labels 
	cartesianSmartLabels: function (currentSeries, points, seriesIndex) {
        // declaration
	    var length = points.length;
	    var count = 0;
	    connectorFlag = false;
	    this.processCount = 1;
	    this.posObj = {
	        top: [], rightTop: [],
	        left : [], leftTop : [],
	        right : [], rightTop : [],
	        rightBottom : [], leftBottom : [],
	        bottom: []
	    };
		var markerWidth, markerHeight, i, d, c, currentPoint, location,
		ele, leftValue, topValue;
	    // loop to store marker region
	    for (d = 0; d < this.model.series.length; d++) {
		    markerWidth = this.model.series[d].marker.size.width;
	        markerHeight = this.model.series[d].marker.size.height;
	        if (this.model.series[d].marker.visible) {
	            for (c = 0; c < this.model.series[d]._visiblePoints.length; c++) {
	                currentPoint = this.model.series[d]._visiblePoints[c];
					location = currentPoint.location;
	                this.model.markerRegion[this.model.markerRegion.length] = { seriesIndex: d, xPos: location.X + this.canvasX, yPos: location.Y + this.canvasY, width: markerWidth, height: markerHeight };
	            }
	        }
	    }
		
		var currentPoint, j, padding = 10, diff;
		var areaBounds = this.model.m_AreaBounds;
		var width, height, xPos, yPos;
		for (j=0; j< length; j++){   // to reposition the partially visible data labels
		    currentPoint = points[j];
			currentPoint.hide = false;
			xPos = currentPoint.xPos; yPos = currentPoint.yPos;
			width = currentPoint.width; height = currentPoint.height;
		    if (xPos - width/2 < 0 && xPos > -width/2){
		         diff = xPos - width/2;
		         currentPoint.textOptions.x = currentPoint.xPos = xPos + Math.abs(diff) + 10;
				 currentPoint.newConnectorFlag  = true;
		    }
			if (xPos + width/2 > areaBounds.Width && xPos + width/2 < areaBounds.Width + width/2){
			     diff = xPos - width/2;
		         currentPoint.textOptions.x = currentPoint.xPos = areaBounds.Width - width/2 -10;
				 currentPoint.newConnectorFlag  = true;
			}
		    if (yPos + width/2 > areaBounds.Height && yPos + height/2 < areaBounds.Height + height/2){
			     diff = yPos + height/2 - areaBounds.Height;
		         currentPoint.yPos = yPos - diff - 10 ;
				 currentPoint.textOptions.y = currentPoint.yPos + 5;
				 currentPoint.newConnectorFlag  = true;
			}
			 if (yPos - height/2 < 0 && yPos > -height/2){
		         diff = yPos - height/2;
		         currentPoint.yPos = currentPoint.yPos + Math.abs(diff) + 10;
				 currentPoint.textOptions.y = currentPoint.yPos +5; 
				 currentPoint.newConnectorFlag  = true;
		    }
		}
		
	    // loop to compare the points
	    for (i = 0; i < length; i++) {
	        if (!ej.util.isNullOrUndefined(points[i].yPos))
	          this.model.allPoints[this.model.allPoints.length] = points[i];
		    else
		      continue;
	        connectorFlag = false;
	        this.compareDataLabels(i, points, count, this.processCount); 
	        currentPoint = points[i];
	        currentPoint.connectorFlag = connectorFlag; // flag to draw connector lines
	        if (points[i].dataLabeltemplate) {    // for repositioning data label template
	            ele = $("#" + points[i].id);
	            leftValue = points[i].xPos;
	            topValue = !this.model.enableCanvasRendering ? points[i].yPos : points[i].yPos + this.model.m_AreaBounds.Y;
	            ele.css("left", leftValue).css("top", topValue);
	            if (this.model.AreaType == "cartesianaxes") {   // to avoid template rendering outside area bounds
	                areaBounds = this.model.m_AreaBounds;
	                xPosition = areaBounds.X + (this.model.requireInvertedAxes ? currentSeries.yAxis.plotOffset : currentSeries.xAxis.plotOffset);
	                yPosition = currentSeries.yAxis.y;
	                width = points[i].width;
	                height = points[i].height;
	                if ((leftValue > xPosition + areaBounds.Width || leftValue + width < xPosition || topValue + height < yPosition || topValue + height > areaBounds.Y + areaBounds.Height) ||
                        (this.zoomed && (leftValue < xPosition || topValue < yPosition || leftValue > xPosition + areaBounds.Width || topValue > yPosition + areaBounds.Height)))
	                    ele.remove();
	            }
	        }
	        else {
	            // to store data label position for furture processing
				this.storeDataLabelPositions (currentPoint);
	        }
	    }
	},
	
	storeDataLabelPositions: function (currentPoint){
	  var position = currentPoint.position;
	  var posObj = this.posObj;
	  switch(position){
				case "top":
				    posObj.top[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break;
				case "rightTop":
				    posObj.rightTop[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break;
				case "right":
				    posObj.right[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break;
				case "rightBottom":
				    posObj.rightBottom[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break
				case "bottom":
				    posObj.bottom[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break;
				case "left":
				    posObj.left[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break;
				case "leftBottom":
				    posObj.leftBottom[this.processCount - 1] = currentPoint;
					this.processCount = 1;
					break;
				case "leftTop":
				    posObj.leftTop[this.processCount - 1] = currentPoint;
					break;
				}
	},
	
	// method to avoid collision between data labels  - column series type
	cartesianColumnSmartLabels: function (currentSeries, points, seriesIndex) {
	    var length = points.length;
	    var count = 0;
	    connectorFlag = false;
	    this.processCount = 1;
		var i, currentPoint, ele;
	    // loop to compare the points
	    for (i = 0; i < length; i++) {
	        if(!ej.util.isNullOrUndefined(points[i].yPos))
	            this.model.allPoints[this.model.allPoints.length] = points[i];
	        else
	            continue;
	        if (currentSeries._enableSmartLabels) {
	            connectorFlag = false;
	            this.compareColumnDataLabels(currentSeries, i, points, count, this.processCount);
	        }
	        currentPoint = currentSeries._visiblePoints[i];
	        if (points[i].dataLabeltemplate) {
	            ele = $("#" + points[i].id);
	            ele.css("left", points[i].xPos).css("top", points[i].yPos);
	        }
	    }
	},

	compareColumnDataLabels: function (currentSeries, i, points, count, processCount) {
	    var length = this.model.allPoints.length - 1;
		var prevLabel, currentLabel, padding;
		var type = currentSeries.type.toLowerCase();
	    for (var j = 0; j < length; j++) {
	        prevLabel = this.model.allPoints[j];
	        currentLabel = this.model.allPoints[this.model.allPoints.length - 1];
	        this.currentCollideLabel = prevLabel;
	        padding = 5;
	        collide = this.isCollide(prevLabel, currentLabel);
	        textPosition = currentSeries.marker.dataLabel.textPosition;
	        if (collide.state) {  
			    // for vertical orientation series types
	            if (type == "column" || type == "stackingcolumn" || type == "rangecolumn" || type == "waterfall") {
	                if (textPosition == "top" || textPosition == "middle")
	                    currentLabel.textOptions.y = currentLabel.yPos = currentLabel.yPos + collide.height + padding;
	                else
	                    currentLabel.textOptions.y = currentLabel.yPos = currentLabel.yPos - collide.height - padding;
	                currentLabel.textOptions.y = currentLabel.textOptions.y + padding + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	            } else {
				    // for horizontal orientation series types
	                if (textPosition == "top" || textPosition == "middle")
	                    currentLabel.textOptions.x = currentLabel.xPos = prevLabel.xPos - prevLabel.width/2 -currentLabel.width/2- padding;
	                else
	                    currentLabel.textOptions.x= currentLabel.xPos = prevLabel.xPos + prevLabel.width / 2 + currentLabel.width / 2 + padding;
	            }
	            this.compareColumnDataLabels(currentSeries, i, points, count, this.processCount);  // to call recursive
	        }
	    }
	},

    // method to comapare data labels and place without collision
	compareDataLabels: function (i, points, count, processCount) {
	    var length = this.model.allPoints.length;
		var j, padding, prevLabel, currentLabel;
	    var posObj = this.posObj;
	    for (j = 0; j < length; j++) {
	        prevLabel = this.model.allPoints[j];
	        currentLabel = this.model.allPoints[length - 1];
	        this.currentCollideLabel = prevLabel;
	        padding = 10;
	        collide = this.isCollide(prevLabel, currentLabel, j);
	        if (collide.state || collide.marker) {
	            connectorFlag = true;
	            switch (count) {
	                case 0:                        // top
	                    if (this.processCount > 1) this.resetValues(currentLabel);
	                    if (!collide.marker) {
	                        if (!ej.util.isNullOrUndefined(this.prevLabel)) {
	                            checkCollide = this.isCollide(this.prevLabel, currentLabel);
	                            if (!checkCollide.state) { this.prevLabel = prevLabel; this.processCount = 1; };
	                        } else {
	                            this.prevLabel = prevLabel;
	                            this.processCount = 1;
	                        }
	                    }
	                    else {
	                        this.prevLabel = collide.markerRegion;
	                        this.processCount = 1;
	                    }
	                                            // right
	                    this.resetValues(currentLabel);
	                    if (processCount > 1 && posObj.right[this.processCount - 2]) {
	                        prevLabel = posObj.right[this.processCount - 2];
	                         currentLabel.textOptions.x = currentLabel.xPos = prevLabel.xPos +  (prevLabel.width / 2 + currentLabel.width / 2 + padding);
	                    }
	                    else 
	                    currentLabel.textOptions.x = currentLabel.xPos = this.prevLabel.xPos + (this.prevLabel.width / 2 + currentLabel.width / 2 + padding);
	                    count += 1;
	                    currentLabel.position = "right";
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;

	                case 1:                       
                              // right bottom
	                    this.resetValues(currentLabel);
	                    currentLabel.textOptions.x = currentLabel.xPos = this.prevLabel.xPos + this.prevLabel.width / 2 + currentLabel.width / 2 + padding;
	                    if (processCount > 1 && posObj.rightBottom[this.processCount - 2]) {
	                        prevLabel = posObj.rightBottom[this.processCount - 2];
	                      currentLabel.textOptions.y = currentLabel.yPos = prevLabel.yPos + this.canvasY + prevLabel.height + padding;
	                    }
	                    else 
	                        currentLabel.textOptions.y = currentLabel.yPos = currentLabel.location.Y + this.canvasY + currentLabel.height + padding / 2;
	                    currentLabel.textOptions.y = currentLabel.textOptions.y + padding/2 + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	                    currentLabel.position = "rightBottom";
	                    count += 1; 
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
					

	                case 2:                       

					// bottom
	                    this.resetValues(currentLabel);
	                    currentLabel.textOptions.y = currentLabel.yPos = currentLabel.location.Y + this.canvasY + currentLabel.height + padding / 2;
	                    if (processCount > 1 && posObj.bottom[this.processCount - 2]) {
	                        prevLabel = posObj.bottom[this.processCount - 2];
	                       currentLabel.textOptions.y = currentLabel.yPos = prevLabel.yPos + currentLabel.height + padding;
	                    }
	                    else 
	                        currentLabel.textOptions.y = currentLabel.yPos = currentLabel.location.Y + this.canvasY + currentLabel.height + padding / 2;
	                    currentLabel.textOptions.y = currentLabel.textOptions.y + padding/2 + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	                    currentLabel.position = "bottom";
	                    count += 1;
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
	                case 3:                         
 // left bottom
	                    this.resetValues(currentLabel);
	                    currentLabel.textOptions.x = currentLabel.xPos = this.prevLabel.xPos - this.prevLabel.width / 2 - currentLabel.width / 2 - padding;
	                    if (processCount > 1 && posObj.leftBottom[this.processCount - 2]) {
	                        prevLabel = posObj.leftBottom[this.processCount - 2];
	                        currentLabel.textOptions.y = currentLabel.yPos = prevLabel.yPos + this.canvasY + prevLabel.height + padding;
	                    }
	                       else 
	                        currentLabel.textOptions.y = currentLabel.yPos = currentLabel.location.Y + this.canvasY + currentLabel.height + padding / 2;
	                    currentLabel.textOptions.y = currentLabel.textOptions.y + padding/2 + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	                    currentLabel.position = "leftBottom";
	                    count += 1;
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
	                case 4:                         
// left
	                   this.resetValues(currentLabel);
	                   if (processCount > 1 && posObj.left[this.processCount - 2]) {
	                       prevLabel = posObj.left[this.processCount - 2];
	                        currentLabel.textOptions.x = currentLabel.xPos = (prevLabel.xPos - prevLabel.width / 2 - currentLabel.width / 2 - padding);
	                    }
	                    else
	                        currentLabel.textOptions.x = currentLabel.xPos = (this.prevLabel.xPos - this.prevLabel.width / 2 - currentLabel.width / 2 - padding);
	                    currentLabel.position = "left";
	                    count += 1; 
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
	                case 5:                        
 // left top
	                    this.resetValues(currentLabel);
	                    currentLabel.textOptions.x = currentLabel.xPos = this.prevLabel.xPos - this.prevLabel.width / 2 - currentLabel.width / 2 - padding;
	                    if (processCount > 1 && posObj.leftTop[this.processCount - 2]) {
	                        prevLabel = posObj.leftTop[this.processCount - 2];
	                        currentLabel.textOptions.y = currentLabel.yPos = (prevLabel.yPos) - (currentLabel.height + padding);
	                    }
	                    else 
	                    currentLabel.textOptions.y = currentLabel.yPos = this.prevLabel.yPos - currentLabel.height - padding;
	                    currentLabel.textOptions.y = currentLabel.textOptions.y + padding/2 + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	                    currentLabel.position = "leftTop";
	                    count += 1; 
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
	                case 6:                         
//top

                        this.resetValues(currentLabel);
                        if (processCount > 1 && posObj.top[processCount - 2]) {
                            prevLabel = posObj.top[processCount - 2];
	                        currentLabel.textOptions.y = currentLabel.yPos = (prevLabel.yPos) - (currentLabel.height + padding);
	                    }
	                    else 
	                    currentLabel.textOptions.y = currentLabel.yPos = (this.prevLabel.yPos) - (this.processCount * (currentLabel.height + padding));
	                    currentLabel.textOptions.y = currentLabel.textOptions.y + padding/2 + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	                    count += 1;
	                    currentLabel.position = "top";
	                    this.compareDataLabels(i, points, count, this.processCount);
						break;
	                case 7:                        
// right top
	                    this.resetValues(currentLabel);
	                    currentLabel.textOptions.x = currentLabel.xPos = this.prevLabel.xPos + this.prevLabel.width / 2 + currentLabel.width / 2 + padding;
	                    if (processCount > 1 && posObj.rightTop[this.processCount - 2]) {
	                        prevLabel = posObj.rightTop[this.processCount - 2];
	                        currentLabel.textOptions.y = currentLabel.yPos = prevLabel.yPos - currentLabel.height - padding;     
	                    }
	                    else 
	                        currentLabel.textOptions.y = currentLabel.yPos = this.prevLabel.yPos - currentLabel.height - padding;
	                    currentLabel.textOptions.y = currentLabel.textOptions.y + padding/2 + currentLabel.margin.top / 2 - currentLabel.margin.bottom / 2;
	                    currentLabel.position = "rightTop";
	                    count += 1; 
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
	                case 8:
	                    count = 0; 
	                    this.processCount += 1;
	                    this.compareDataLabels(i, points, count, this.processCount);
	                    break;
	            }
	        }
	    }
	},
     //to draw connector lines for pieofpie series
	drawPieofPieConnectors: function (size, series) {
	    //if (series.connectorLine.width > 0) {
	        var visibility = (series.enableAnimation && !series._animatedSeries) ? 'hidden' : 'visible';
	        if (!this.model.enableCanvasRendering) {
	            if (!this.gConnectorLinesGroup)
	                this.gConnectorLinesGroup = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_connectorLineGroup', 'visibility': visibility });
	            else (this.gConnectorLinesGroup.childNodes.length > 0)
	            	$(this.gConnectorLinesGroup.childNodes).remove();
	        }
	        var radius = [], startX = [], startY = [], loc = [],
	        chartStartAngle = -.5 * Math.PI, coefficient, pieCollections;
	        for (var j = 0; j < 2; j++) {
	            pieCollections = series.pieCollections[j];
	            coefficient = j == 0 ? series.pieCoefficient : series.pieOfPieCoefficient;
	            radius[j] = 0.25 * coefficient * Math.min(size.width, size.height);	           
	            startX[j] = this.model.circleCenterX[j];
	            startX[j] = (j == 0) ? startX[j] + this.model.pieGapWidth / 2 : startX[j] - this.model.pieGapWidth / 2;
	            startY[j] = this.model.circleCenterY[j];	           
	            if (pieCollections[0].start > 0 && pieCollections[0].end < Math.PI && j==0) {
	                var startAngle = pieCollections[0].start + chartStartAngle,
	                    endAngle = pieCollections[0].end + chartStartAngle - 0.000001;
	                var x1 = startX[j] + radius[j] * Math.cos(startAngle),
                        y1 = startY[j] + radius[j] * Math.sin(startAngle),
                        x2 = startX[j] + radius[j] * Math.cos(endAngle),
                        y2 = startY[j] + radius[j] * Math.sin(endAngle);	                   
	                }
	                else {
	                        x1 = startX[j] + radius[j] * Math.cos(chartStartAngle),
                            y1 = startY[j] + radius[j] * Math.sin(chartStartAngle),
                            x2 = x1,
                            y2 = y1 + radius[j] * 2;
	                }
	                loc.push({ X1: x1, Y1: y1, X2: x2, Y2: y2 });
	        }
	            var pieConnectorLines = series.connectorLine;
	            for (var k = 0; k < 2; k++) {
	                var lineOptions = {
	                    'id': this.svgObject.id + '_connectorLine'+k,
	                    'x1': k == 0 ? loc[k].X1: loc[k-1].X2,
	                    'y1': k == 0 ? loc[k].Y1 : loc[k-1].Y2,
	                    'x2': k == 0 ? loc[k + 1].X1 : loc[k].X2,
	                    'y2': k == 0 ? loc[k + 1].Y1 : loc[k].Y2,
	                    'stroke': pieConnectorLines.color,
	                    'stroke-width': pieConnectorLines.width,
	                    'opacity': pieConnectorLines.opacity,
	                    'stroke-dasharray': pieConnectorLines.dashArray
	                };	                
	                this.svgRenderer.drawLine(lineOptions, this.gConnectorLinesGroup);
	            }	                
	            this.svgRenderer.append(this.gConnectorLinesGroup, this.gSeriesEle);
	},
     // method to draw connector lines for data labels in cartesian axis
	drawConnectorLines: function (seriesIndex, index, currentPoint) {
	    var bottom = false;
		var drawConnectorLine = true;
		var xPos = currentPoint.xPos;
		var yPos = currentPoint.yPos;
		var areaBounds = this.model.m_AreaBounds;
	    var location = currentPoint.location ? currentPoint.location : currentPoint.symbolLocation;
	    if (location.Y > currentPoint.textOptions.y)
	        var endY = (currentPoint.textOptions.y);                         // top
	    else {
            bottom = true
	        endY = (currentPoint.textOptions.y - currentPoint.height / 2);  // bottom
	    }
	    if (currentPoint.dataLabeltemplate) {                               // for template
	        endY = currentPoint.yPos - this.model.m_AreaBounds.Y + currentPoint.height ;
	        currentPoint.textOptions.x = currentPoint.textOptions.x - this.model.m_AreaBounds.X + currentPoint.width/4 + this.canvasX;
	    } else if (xPos > areaBounds.Width || (xPos + currentPoint.width) < 0 ||
             		yPos - currentPoint.height > areaBounds.Height || yPos+ currentPoint.height < 0)
		    drawConnectorLine = false;
		if (drawConnectorLine){
	      var connectorDirection = "M" + " " + (location.X + this.canvasX) + " " + (location.Y + this.canvasY) + " " + "L" + " " + (currentPoint.textOptions.x) + " " + (endY);
	      var connectorLineValues = this.model.series[seriesIndex].marker.dataLabel.connectorLine;
	      var stroke = !ej.util.isNullOrUndefined(connectorLineValues.color) ? connectorLineValues.color : this.model.series[seriesIndex].fill;
	      var connectorOptions = {
	        'id': this.svgObject.id +  "_dataLabelConnectorLine_series" + seriesIndex + "_" + index,
	        'stroke': stroke,
	        'stroke-width': connectorLineValues.width,
	        'd': connectorDirection
	      };
	      this.model.series[seriesIndex].connectorLines = true;
	      this.svgRenderer.drawPath(connectorOptions, this.gConnectorEle[seriesIndex]);
		}
	},

    // to reset the data label values back 
	resetValues: function (currentPoint) {
	    currentPoint.textOptions.y = currentPoint.dataLabel.textY;
	    currentPoint.yPos = currentPoint.dataLabel.y;
	    currentPoint.textOptions.x = currentPoint.dataLabel.textX;
	    currentPoint.xPos = currentPoint.dataLabel.x
	},

	// to detect collision
	isCollide: function (a, b, j) {
	    var width = 0;
	    var height = 0;
		var state = false, markerState = false;
		var borderWidth = a.seriesIndex ? this.model.series[a.seriesIndex].marker.dataLabel.border.width : 0;
		borderWidth += b.seriesIndex ? this.model.series[b.seriesIndex].marker.dataLabel.border.width : 0;
		var series = this.model.series;
		var firstSeries = series[a.seriesIndex];
		var secondSeries = series[b.seriesIndex];
		var aXPos = a.xPos , aYPos= a.yPos, bXPos = b.xPos, bYPos = b.yPos;
		a.xPos += firstSeries.xAxis.x, a.yPos += firstSeries.yAxis.y,
        b.xPos += secondSeries.xAxis.x, b.yPos += secondSeries.yAxis.y;		
		
	    if (a != b) {
	        state = !(                    // to compare data labels
            ((a.yPos + a.height) < (b.yPos)) ||
            (a.yPos > (b.yPos + b.height)) ||
            ((a.xPos + a.width / 2 + borderWidth) < b.xPos - b.width / 2) ||
            (a.xPos - a.width/2 > (b.xPos + b.width/2)));
	        if (state) {
	            height = (a.yPos + a.height) - b.yPos;
	            width = (a.xPos + a.width) - b.xPos;
	        }
			a.xPos = aXPos, a.yPos = aYPos;
	    }
	    if (!state) {
	        for (var f = 0; f < this.model.markerRegion.length; f++) {
	            a = this.model.markerRegion[f];
				firstSeries = series[a.seriesIndex];
				aXPos = a.xPos , aYPos = a.yPos;
				a.xPos+= firstSeries.xAxis.x, b.yPos+= firstSeries.yAxis.y;
	            markerState= !(                // to compare data label and marker
                ((a.yPos + a.height) < (b.yPos - b.height/2)) ||
                (a.yPos > (b.yPos + b.height)) ||
                ((a.xPos + a.width) < b.xPos) ||
                (a.xPos > (b.xPos + b.width)));
	            if (markerState)
	                break;
	        }
	    }
		
		a.xPos = aXPos, a.yPos = aYPos;
		b.xPos = bXPos, b.yPos = bYPos;
		// to hide the partially visible data labels
		
	    return { state: state, marker: markerState, markerRegion: a, width: width, height: height };
	},

	drawAccDisplayText: function (series, options, seriesIndex) {
	    // method to draw text 
	    var chartObj = this;
		var pointsLength = options._visiblePoints.length;
		chartObj.firstStartAngle = [];
		type = options.type.toLowerCase();
		if ((type != "pyramid" && type != "funnel" && type != "pieofpie") && (options.leftsidePoints.length > 0 || options.rightsidePoints.length > 0)) {
				var rightsidePointsLength = options.rightsidePoints.length;
	            var leftsidePointsLength = options.leftsidePoints.length;

	            for (var i = 0; i < rightsidePointsLength; i++) {
	                options.rightsidePoints[i].index = i;
	               series.drawDataLabelAcc(chartObj, options, options.rightsidePoints[i].pointIndex, options.rightsidePoints[i], seriesIndex)
	            }
	            for (var j = leftsidePointsLength - 1; j >= 0; j--) {
	                options.leftsidePoints[j].index = j;
	                series.drawDataLabelAcc(chartObj, options, options.leftsidePoints[j].pointIndex, options.leftsidePoints[j],seriesIndex)
	            }
	        }
	        else {
	             for (var i = 0; i < pointsLength; i++) {
	                 options._visiblePoints[i].index = i;
					 var pointIndex = type == "pieofpie" ? options._visiblePoints[i].actualIndex : i;
	                if (isNaN(options._visiblePoints[i].startAngle) && options.type.toLowerCase() == "pie" && options.type.toLowerCase == "pieofpie") continue;
	                series.drawDataLabelAcc(chartObj, options, pointIndex, options._visiblePoints[i],seriesIndex,options.collectionIndex)
	             }
	        }
			 if (options.type.toLowerCase() == "pyramid" || options.type.toLowerCase() == "funnel")
                {
	        this.svgRenderer.append(this.gConnectorEle, this.gSeriesEle);

	        this.svgRenderer.append(this.gSymbolGroupEle, this.gSeriesEle);

	        this.svgRenderer.append(this.gDataLabelEle, this.gSeriesEle);

	        this.svgRenderer.append(this.gSeriesTextEle, this.gSeriesEle);


	        this.svgRenderer.append(this.gSeriesEle, this.svgObject);

	        if (!this.vmlRendering)
               this.svgRenderer.append(this.svgObject, this.element)
	           
	            }
	},

    _processOData: function (series) {
        var chart = this,type = series.type.toLowerCase();
        var queryPromise = series.dataSource.executeQuery(series.query);
        queryPromise.done(function (e) {
            chart._processJsonData(e.result, series);
            series.visibility = 'visible';
            $(chart.svgObject).empty();
            $(chart.legendSvgContainer).empty();
            if (chart.model.enableCanvasRendering) {
                chart.svgRenderer.ctx.clearRect(0, 0, chart.svgObject.width, chart.svgObject.height);
                $("#canvas_trackSymbol").remove();
            }

            var redrawChart=true;
            var dec = (type != "pie" || type != "doughnut") ? 0 : chart.model.series.length - 1
            for (var i = dec, cond ; cond = (type != "pie" || type != "doughnut") ? i < chart.model.series.length : i >= 0; (type != "pie" || type != "doughnut") ? i++ : i--) {
                    if (chart.model.series[i].dataSource) {
                        if (chart.model.series[i].visibility == 'hidden') {
                            redrawChart = false;
                            break;
                        }
                    }
                }
            if (redrawChart) {
                chart.draw();
            }
        });
        queryPromise.fail(function (e) {
            series.visibility = 'visible';
            $(chart.svgObject).empty();
            $(chart.legendSvgContainer).empty();
            var redrawChart=true;
            for (var i = 0; i < chart.model.series.length; i++)
                if (chart.model.series[i].dataSource)
                {
                    if (chart.model.series[i].visibility == 'hidden') {
                        redrawChart = false;
                        break;
                    }
                }
            if (redrawChart) {
                chart.draw();
            }
        });
    },
    _processJsonData: function (jsonObj, series) {
	    if(series.points.length > 0)
           series.points.length = 0;
        var xdata = [];
        var dataSource = series.dataSource;
        var xName = series.xName;
        var yNames = series.yName;
        var pointColorMappingName = series.pointColorMappingName;
        var textMappingName = series.marker && series.marker.dataLabel.textMappingName;
        var pointColorMappingNameValue = [];
        var textMappingNameValue = [];
        var type = series.type.toLowerCase();
        var jsonLength = jsonObj.length, xDataLength, yValuesLength;

        for (var j = 0; j < jsonLength; j++) {
            if (typeof jsonObj[j][xName] == "string" && jsonObj[j][xName].indexOf("/Date(") != -1) {
                jsonObj[j][xName] = new Date(parseInt(jsonObj[j][xName].substr(6)));
                xdata[j] = ((jsonObj[j][xName]) ? jsonObj[j][xName] : j);
            }
            else
                xdata[j]= (jsonObj[j][xName]!=null && jsonObj[j][xName] !=undefined) ? jsonObj[j][xName] : null;
            pointColorMappingNameValue[j] =  (jsonObj[j][pointColorMappingName]!=null && jsonObj[j][pointColorMappingName] !=undefined) ? jsonObj[j][pointColorMappingName] : null;
            textMappingNameValue[j] =  (jsonObj[j][textMappingName]!=null && jsonObj[j][textMappingName] !=undefined) ? jsonObj[j][textMappingName] : null;
        }
        var yValues = [];
        var index = 0;
            if (series._hiloTypes) {
                var yVal = [];
                //For high
                var high = series.high;
                for (var s = 0; s < jsonLength; s++) {
                    yVal[s]=(jsonObj[s][high] === null || jsonObj[s][high] === undefined ? jsonObj[s][high] : parseFloat(jsonObj[s][high]));

                }
                yValues[index] = yVal;
                index = index + 1;
                //For low
                yVal = [];
                var low = series.low;
                for (var l = 0; l < jsonLength; l++) {
                    yVal[l]= (jsonObj[l][low] === null || jsonObj[l][low] === undefined ? jsonObj[l][low] : parseFloat(jsonObj[l][low]));
                }
                yValues[index] = yVal;
                index = index + 1;
                if (series.type.toLowerCase() !== 'hilo') {
                    //For open
                    yVal = [];
                    var open = series.open;
                    for (var h = 0; h < jsonLength; h++) {
                        yVal[h]=(jsonObj[h][open] === null || jsonObj[h][open] === undefined ? jsonObj[h][open] : parseFloat(jsonObj[h][open]));
                    }
                    yValues[index] = yVal;
                    index = index + 1;

                    //For close
                    yVal = [];
                    var close = series.close;
                    for (var mI = 0; mI < jsonLength; mI++) {
                        yVal[mI]=((jsonObj[mI][close] === null || jsonObj[mI][close] === undefined) ? jsonObj[mI][close] : parseFloat(jsonObj[mI][close]));
                    }
                    yValues[index] = yVal;
 index = index + 1;
                    //For volume
                    if (series.volume) {
                        yVal = [];
                        var volume = series.volume;
                        for (var vI = 0; vI < jsonLength; vI++) {
                            yVal[vI]=((jsonObj[vI][volume] === null || jsonObj[vI][volume] === undefined) ? jsonObj[vI][volume] : parseFloat(jsonObj[vI][volume]));
                        }
                        yValues[index] = yVal;
                    }
                }
            }
        if (yNames) {
				var yNVal = new Array();
				if(series.type=='boxandwhisker')
				{
					for (var yI = 0; yI < jsonLength; yI++) {
						yNVal[yI]=new Array();
						for(var yII=0;yII<jsonObj[yI][yNames].length ;yII++)
							yNVal[yI][yII]= ((jsonObj[yI][yNames][yII]) ? parseFloat(jsonObj[yI][yNames][yII]) : jsonObj[yI][yNames][yII]);
						}
				}else
				{
					for (var yI = 0; yI < jsonLength; yI++)
						yNVal[yI] = ((jsonObj[yI][yNames]) ? parseFloat(jsonObj[yI][yNames]) : jsonObj[yI][yNames]);
				}
                yValues[index] = yNVal;
                index = index + 1;
            

            if (series.type.toLowerCase() == 'bubble') {
                yVal = [];
                var size = series.size;
                for (var b = 0; b < jsonLength; b++) {
                    yVal[b]= (jsonObj[b][size] === null || jsonObj[b][size] === undefined ? jsonObj[b][size] : parseFloat(jsonObj[b][size]));
                }
                yValues[index] = yVal;
            }
        }
        xDataLength = xdata.length;
        yValuesLength = yValues.length;
        for (var m = 0; m < xDataLength; m++) {
            series.points[m] = { x: xdata[m], xValue: xdata[m], y: yValues[0][m], YValues: [],_visibility:(m == this.model._hiddenPointIndex[m])?'hidden':null, visible: true, fill: pointColorMappingNameValue[m], text: textMappingNameValue[m] };
            if (type == 'bubble') {
                series.points[m].YValues[0] = (yValues[0][m]);
                series.points[m].size = series.points[m].YValues[1] = yValues[1][m];
            }
            else if (series._hiloTypes && yValuesLength > 1) {
                series.points[m].high = series.points[m].YValues[0] = yValues[0][m];
                series.points[m].low = series.points[m].YValues[1] = yValues[1][m];
                if (type != 'hilo' && type != 'rangecolumn' && type != 'waterfall' && yValuesLength > 3) {
                    series.points[m].open = series.points[m].YValues[2] = yValues[2][m];
                    series.points[m].close = series.points[m].YValues[3] = yValues[3][m];
                if (series.volume)
                    series.points[m].volume = series.points[m].YValues[4] = yValues[4][m];
                }
            }
            else {
                series.points[m].YValues[0]=(yValues[0][m]);
            }
        }
    },
    bindTo: function (excludeDataUpdate) {
          $("#" + this.svgObject.id + '_CrosshairVertical').remove();
          $("#" + this.svgObject.id + '_CrosshairHorizontal').remove();
          if ($.finish) {
              $(".ejTooltip" + this._id).finish();
              $(".tooltipDiv" + this._id).finish();
          }
          else {
              $(".ejTooltip" + this._id).stop(true, true);
              $(".tooltipDiv" + this._id).stop(true, true);
          }
		  $(document).find('[id*="_TrackToolTip"]').remove();// fixed for mobile issue
          $('#template_group_' + this._id).remove();

          //Create id to chart container, if the element don't have id
		  if (!this.element[0].id)
		      this._createChartId();

		  this.model.primaryXAxis._valueType = null;
		  this.model.primaryXAxis.position = null;
		  this.model.primaryYAxis._valueType = null;
		  this.model.primaryYAxis.position = null;
		  this.model.requireInvertedAxes = false;
		  this.model._hiddenPointIndex = [];
		  var seriesLength = this.model.series.length,
		  axesLength = this.model.axes.length,
          axis;
         for (var i = 0; i < axesLength; i++)
		  {
             axis = this.model.axes[i];
             axis._valueType = null;
             axis.position = null;
         }
		  if (this.model._axes)
         {
		       axesLength = this.model._axes.length;
		       for (var j = 0; j < axesLength; j++) {
		           axis = this.model._axes[j];
		           axis._valueType = null;
		           axis.position = null;
		           axis.zoomFactor = (axis._pointsLength && axis._pointsLength != axis.scrollbarSettings.pointsLength) ? 1 : axis.zoomFactor;
		       }
         }
		  for (var i = 0; i < seriesLength; i++) {
		      var series = this.model.series[i];
		      series.position = null;
		      if (series.fill && this.model.seriesColors && series.fill != this.model.seriesColors[i])
		          this.model.series[i].isFill = true;      
		  }
		  if (this.model.AreaType && this.model.AreaType == "none") {
		      var series = this.model.series[0];
			  var point;
		      for (var i = 0; series.points && i < series.points.length; i++) {
		          point = series.points[i]
		          point._visibility = point._visibility ? point._visibility : null;
				  if (point._visibility == "hidden" && this.model.AreaType == "none" && this.model.series.length == 1)
                        this.model._hiddenPointIndex[i] = i;
		          if (point.fill && this.model.pointColors && point.fill != this.model.pointColors[i])
		              point.isFill = true;
		          if (!point.isFill)  
		              point.fill = null;		           
		      }
		  }
          if(this.model.enable3D)
            ej.Ej3DRender.transform = null;
          if (this.model.series) {
            var series = this.model.series;
            this.setModelProperties(excludeDataUpdate);
            if (!excludeDataUpdate) {
                for (var i = 0; i < series.length; i++) {
                    if (series[i].visibility == null || series[i].visibility == undefined) {
                        series[i].visibility = 'visible';
                    }
					 if (series[i].type) series[i]._hiloTypes = ej.seriesTypes[series[i].type.toLowerCase()].prototype.hiloTypes;
                    if (!(series[i].points))
                        series[i].points = [];
                    if (series[i].dataSource) {
                        if (series[i].dataSource instanceof ej.DataManager) {
                            series[i].visibility = 'hidden';
						    if (ej.isNullOrUndefined(series[i].query) || !(series[i].query instanceof ej.Query))
                                series[i].query = ej.Query();
                            this._processOData(series[i]);
                        } else {
                            if (typeof series[i].dataSource === 'string' || series[i].dataSource.toLowerCase)
                                series[i].dataSource = JSON.parse(series[i].dataSource.replace(/'''/g, "\""));
                            this._processJsonData(series[i].dataSource, series[i]);

                        }
                    }
                }
            }
            if($(this.svgObject).width()>0)
            this.draw(excludeDataUpdate);
        }



    },

    _createChartId: function () {
        var exsistId = false, count = 0;
        var className = $(this.element)[0].className.split(" ")[0];
        do {
            if (!$("#" + className + "_" + count).length) {
                $(this).attr("_id", className + "_" + count);
                $(this.element).attr('id', className + "_" + count);
                exsistId = true;               
            }
            count++;
        } while (!exsistId);
    },

	calculateHeight : function(chart){              // height calculation
	     var $svgObj = $(chart.svgObject);
	     var chartHeight = chart.model.size.height;
         var containerHeight= $(chart.element).height();
         var height = (containerHeight / 100) * parseInt(chartHeight);
		 $svgObj.height(height);
		 return height;
	},
	
	calculateWidth : function(chart){               // width calculation
	       var $svgObj = $(chart.svgObject);
	       var chartWidth = chart.model.size.width;
           var containerWidth = $(chart.element).width();
           var width = (containerWidth / 100) * parseInt(chartWidth);
		   $svgObj.width(width);
		   return width;
	},

     // store the element class logic perform here
	selectedStyle: function (chart) {
	    var selected= $('#' + chart._id).find('[class*="Selection"]');
	    var selection = [];
	    for (var i = 0; i < selected.length; i++) {
	        selection[i] = [];
	        selection[i].id = selected[i].id;
	        selection[i].className = $('#' + selection[i].id).attr('class');
	    }
	    if ($('[id $= Def ]').length > 0) {
	        selection.pattern = $('[id $= Def ]');
	    }

	    return selection;
	},
	
	chartResize: function () {
        var chart = this;
        var $svgObj = $(chart.svgObject);
        var selection = this.selectedStyle(chart);
	    this.removeMultiRect();
        this._chartResize = true;
        if (this.model.enableCanvasRendering) {
            $('[id*=' + this._id + '_Selection_' + ']').remove();
            $("#canvas_trackSymbol").remove();
            var ctx = chart.svgObject.getContext("2d");
            ctx.clearRect(0, 0, this.svgRenderer.svgObj.width, this.svgRenderer.svgObj.height);
			
			if (typeof chart.model.size.width=="string" && chart.model.size.width.indexOf("%") != -1) {           // to set width 
                var width = chart.calculateWidth(chart);
				this.svgRenderer.svgObj.width = width;
            }
			else
              this.svgRenderer.svgObj.width = $("#" + this._id).width();
            
			if (typeof chart.model.size.height=="string" && chart.model.size.height.indexOf("%") != -1) {          // to set height
                 var height = chart.calculateHeight(chart);
				  this.svgRenderer.svgObj.height = height;
            }
            else
			 this.svgRenderer.svgObj.height = ej.util.isNullOrUndefined(this.model.size.height) ? "450" : parseInt($(chart.element).height());
			

        }
        if (this.resizeTO) clearTimeout(this.resizeTO);
        this.resizeTO = setTimeout(function () {
          if (!ej.util.isNullOrUndefined(chart.model)) {
            if (typeof chart.model.size.width == "string" && chart.model.size.width.indexOf("%") != -1) {
               chart.calculateWidth(chart);
            }
            else
                $svgObj.width($(chart.element).width());
      
            if (typeof chart.model.size.height == "string" && chart.model.size.height.indexOf("%") != -1) {
                 chart.calculateHeight(chart);
            }
            else
                $svgObj.height($(chart.element).height());
            if ($(chart.svgObject).width() > 0) {
                $(chart.svgObject).empty();
	        $(chart.legendSvgContainer).empty();
                $('#template_group_' + chart._id).remove();
				$("#annotation_group_" + chart._id).remove();       //to remove annotation from DOM on resize
                chart.disableAnimation();
                for (var j = 0; j < chart.model.series.length; j++)
                    chart.model.series[j].regionAdded = false;
                chart.draw();
                for (var i = 0; i < selection.length; i++) {
                    $('#' + selection[i].id).attr('class', selection[i].className);
                }
                if(selection.pattern)
                    chart.svgRenderer.append(selection.pattern, chart.svgObject);
                if (chart.zoomed && !chart.vmlRendering)
                    chart._enableZoomingButtons();
                chart.enableAnimation();
            }
		  }
        }, 500);

    },
    isDevice: function () {
        return (/mobile|tablet|android|kindle/i.test(navigator.userAgent.toLowerCase()));
        // comment above line temporary. Due to the below code event wont bind for tablet device
        //  return (/mobile|android|kindle/i.test(navigator.userAgent.toLowerCase()));
    },

     //To check whether the device is Windows
    isWindows: function () {
        if (!ej.getBooleanVal($('head'), 'data-ej-android') && !ej.getBooleanVal($('head'), 'data-ej-ios') && !ej.getBooleanVal($('head'), 'data-ej-ios7') && !ej.getBooleanVal($('head'), 'data-ej-flat'))
            return this._windows();
    },

    _windows: function () {
        return (/trident|windows phone/i.test(navigator.userAgent.toLowerCase())) || (ej.getBooleanVal($('head'), 'data-ej-windows', false) === true);
    },

    bindResizeEvents: function () {
        if (this.model._resizeEventRegistered)
            return 0;
        if (ej.isTouchDevice() && this._isOrientationSupported())
            this._on($(window), "orientationchange", this.chartResize);
        else
            this._on($(window), "resize", this.chartResize);
        this.model._resizeEventRegistered = true;
    },
    removeResizeEvents: function () {
        if (this.model._resizeEventRegistered) {
            if (ej.isTouchDevice() && this._isOrientationSupported())
                this._off($(window), "orientationchange", this.chartResize);
            else
				this._off($(window), "resize", this.chartResize);
            this.model._resizeEventRegistered = false;
        }
    },
	 _isOrientationSupported: function () {
            return ("orientation" in window && "onorientationchange" in window);
	 },
    _calculatePinchZoomPosition: function (e) {
        var areaBounds = this.model.m_AreaBounds, zoomPosition, axes = this.model._axes, axis,
            event = (e.originalEvent.touches ? e.originalEvent.touches[0] : e.originalEvent),
            pageX = event.pageX, pageY = event.pageY, panTouch = this.previousPanTouch, pinchPan,
            orientation, offset, j = 0, length = axes.length;

        if (pageX > areaBounds.X && pageX < areaBounds.X + areaBounds.Width && pageY > areaBounds.Y && pageY < areaBounds.Y + areaBounds.Height) {
            if (!panTouch)
                panTouch = this.previousPanTouch = { pageX: pageX, pageY: pageY };
				
			if(ej.isTouchDevice() || this.model.zooming.enableDeferredZoom)
			{
				this.oPreviousCoords = { x: this.previousPanTouch.pageX, y: this.previousPanTouch.pageY };
				return this.chartMouseMove(e); //Deferred panning for slow devices
			}
			
            for (; j < length; j++) {
                axis = axes[j];
                orientation = axis.orientation.toLowerCase() == "horizontal";
                offset = orientation ? ((panTouch.pageX - pageX) / axis.width * axis.zoomFactor) : ((panTouch.pageY - pageY) / axis.height * axis.zoomFactor);
                zoomPosition = axis.zoomPosition;
                axis.zoomPosition = this._ensureValueInMinMax(orientation ? zoomPosition + offset : zoomPosition - offset, 0, 1 - axis.zoomFactor);
                pinchPan = pinchPan || (zoomPosition != axis.zoomPosition);
            }
            this.previousPanTouch = { pageX: pageX, pageY: pageY };	
            if (pinchPan && !this.chartUpdating) {
                this.redraw(true, pinchPan, e.target);
                this._enableZoomingButtons();
            }
        }

    },
    _calculateTouchDistance: function (previous, current) {
        var result = [], j = 0, length = current.length;

        for (; j < length; j++) {
            if (previous[j] == null)
                previous[j] = current[j];
            result[j] = {};
            if (j > 0) {
                result[j].scaleX = ((previous[0].pageX != previous[1].pageX) && ((current[0].pageX - current[1].pageX) / (previous[0].pageX - previous[1].pageX)));
                result[j].scaleY = ((previous[0].pageY != previous[1].pageY) && ((current[0].pageY - current[1].pageY) / (previous[0].pageY - previous[1].pageY)));
                result[j].center = { x: (previous[0].pageX + current[0].pageX) / 2, y: (previous[1].pageY + current[1].pageY) / 2 };
            }
        }
        return result;
    },
    _ensureValueInMinMax: function (valueToCheck, minValue, maxValue) {
        return valueToCheck < minValue ? minValue : (valueToCheck > maxValue ? maxValue : valueToCheck);
    },
    _calculatePinchZoomFactor: function (scale, orientation, target) {
        var model = this.model, axes = model._axes, zoomedOut = true, zoomed, currentScale, origin, cumulativeScale,
            axisScale, axis, factor, zoomFactor, zoomPosition, areaBounds = model.m_AreaBounds,
            prevScale, scaleLimit = 10000, i = 0, length = axes.length;

        orientation = (orientation == 'x' ? 'horizontal' : (orientation == 'y' ? 'vertical' : null));

        if (this.previousScale != null) {
            for (; i < length; i++) {
                if (!orientation || axes[i].orientation === orientation) {
                    axis = axes[i];
                    currentScale = axis.orientation == 'horizontal' ? scale[1].scaleX : scale[1].scaleY;
                    if (!currentScale)
                        break;
                    prevScale = axis.orientation == 'horizontal' ? this.previousScale[1].scaleX : this.previousScale[1].scaleY;
                    zoomFactor = axis.zoomFactor;
                    zoomPosition = axis.zoomPosition;
                    axisScale = this._ensureValueInMinMax(1 / axis.zoomFactor, 1, scaleLimit);
                    cumulativeScale = this._ensureValueInMinMax(axisScale + (axisScale * (currentScale - prevScale) / prevScale), 1, scaleLimit);
                    origin = (axis.orientation == 'horizontal' ? (scale[1].center.x / areaBounds.Width) : (1 - scale[1].center.y / areaBounds.Height));
                    axis.zoomFactor = this._ensureValueInMinMax(1 / cumulativeScale, 1 / scaleLimit, 1);
                    axis.zoomPosition = this._ensureValueInMinMax(zoomPosition + (zoomFactor - axis.zoomFactor) * origin, 0, 1-axis.zoomFactor);
                    zoomed = zoomed || (zoomFactor != axis.zoomFactor);
                    zoomedOut = zoomedOut && (axis.zoomFactor == 1);
                }
            }
            if (zoomed && !zoomedOut && !this.chartUpdating) {
                this.zoomed = true;
                this.redraw(true, true, target);
                this._enableZoomingButtons();
            }
            else if (zoomedOut && this.zoomed && !this.chartUpdating) {
                this.redraw(true, true, target);
                this.zoomed = false;
                this._removeZoomkit();
            }
        }
        this.previousScale = scale;
    },
    _addTouchPointer: function (touches, e, overwrite, j) {
        for (j = touches.length; j--;)
            if (e.pointerId == touches[j].pointerId) {
                if (overwrite) touches[j] = e;
                return 0;
            }
        touches.push(e);
    },
    _removeTouchPointer: function (touches, e, j) {
        for (j = touches && touches.length; j--;)
            if (e.pointerId == touches[j].pointerId) {
                touches.splice(j, 1);
                return 0;
            }
    },
    _copyTouches: function (touches) {
        var target = [], i = 0, length = touches.length;
        for (; i < length; i++)
            target[i] = { pageX: touches[i].pageX, pageY: touches[i].pageY };
        return target;
    },
    _initEventParams: function () {
        return { touches: [], movements: [] };
    },
    _pointerPinchStart: function (e) {
        var event = e.originalEvent, targetId, model = this.model, bounds = model.m_AreaBounds, eventObj, elementOffset = $(this.element).offset(),
            params = this.eventParams || (this.eventParams = this._initEventParams()),
            x = (event.pageX || event.changedTouches[0].pageX) - elementOffset.left, y = (event.pageY || event.changedTouches[0].pageY) - elementOffset.top;
			
		if(this.model.selectionEnable){
			this.cancelEvent(e);
			event.preventDefault();
		}

        if (!model.enable3D && model.AreaType == 'cartesianaxes' && event.pointerType != 'mouse' && event.pointerType != 4 && model.zooming.enable && model.zooming.enablePinching && (event.touches || event.pointerId)) {
            targetId = e.target.id;
            if (targetId.indexOf("ResetZoom") != -1)
                this.resetZoom(e);
            else if (targetId.indexOf("panIcon") != -1)
                this.startPan(e);
            else if (targetId.indexOf("ZoomIcon") != -1)
                this.startZoom(e);
            else if (targetId.indexOf("ZoomOut") != -1 || targetId.indexOf("ZoomIn") != -1)
                this.startZoomInOut(e);
            else if (x > bounds.X && x < bounds.X + bounds.Width && y > bounds.Y && y < bounds.Y + bounds.Height) {
                event.touches ? (params.touches = this._copyTouches(event.touches)) : this._addTouchPointer(params.touches, { pageX: x, pageY: y, pointerId: event.pointerId });
                if (params.touches.length < 2)
                    this.chartMouseDown(e);
            }
            else
                this.chartMouseDown(e);
        }
        else
            this.chartMouseDown(e);
    },
    _removeInteractions: function () {
        $("[id*=_TrackSymbol]").remove();
        this._removeTrackBall();
        this._removeHighlight();
        $("#" + this.svgObject.id + "_TrackToolTip").hide();
        $("#" + this._id + "_tooltip").remove();
    },
    _pinchGestureMove: function (e) {
        var event = e.originalEvent.changedTouches[0], touches = e.originalEvent.touches, model = this.model, elementOffset = $(this.element).offset(),
            areaBounds = model.m_AreaBounds, x = event.pageX - elementOffset.left, y = event.pageY - elementOffset.top;

        this.eventParams = this.eventParams || this._initEventParams(model, event);
        if (!model.enable3D && model.AreaType == 'cartesianaxes' && event.pointerType != 'mouse' && event.pointerType != 4 && model.zooming.enable && model.zooming.enablePinching && touches) {
            if (x > areaBounds.X && x < areaBounds.X + areaBounds.Width && y > areaBounds.Y && y < areaBounds.Y + areaBounds.Height) {
                this._removeInteractions();
                if (touches.length > 1)
                    this._calculatePinchZoomFactor(this._calculateTouchDistance(this.eventParams.touches, touches), model.zooming.type, e.target);
                else
	                (this.doPan || this.panning) ? this._calculatePinchZoomPosition(e) : this.chartMouseMove(e);
            }
            else
                this.chartMouseMove(e);
        } else
            this.chartMouseMove(e);
    },
    _pointerPinchMove: function (e) {
        var areaBounds, touches, j = 0, event = e.originalEvent, elementOffset = $(this.element).offset(), x = event.pageX - elementOffset.left, y = event.pageY - elementOffset.top,
            model = this.model, params = this.eventParams || this._initEventParams(model, event), startTouches = params.touches, previous = this.previousPointerMove,
            length = startTouches.length, touches = params.movements;


        if (previous != null && previous.pageX == event.pagex && previous.pageY == event.pageY && previous.pointerId == e.pointerId)
            return false;
        if (!model.enable3D && model.AreaType == 'cartesianaxes' && event.pointerType != 'mouse' && event.pointerType != 4 && model.zooming.enable && model.zooming.enablePinching) {
            areaBounds = model.m_AreaBounds;
            if (x > areaBounds.X && x < areaBounds.X + areaBounds.Width && y > areaBounds.Y && y < areaBounds.Y + areaBounds.Height) {
                this._addTouchPointer(startTouches, { pageX: x, pageY: y, pointerId: event.pointerId });
                if (startTouches && startTouches.length > 1) {
                    for (; j < length; j++)
                        this._addTouchPointer(touches, startTouches[j], false);
                    this._addTouchPointer(touches, { pageX: x, pageY: y, pointerId: event.pointerId }, true);
                    if (!((touches[0].pageX == startTouches[0].pageX) && (touches[1].pageX == startTouches[1].pageX) && (touches[0].pageY == startTouches[0].pageY) && (touches[1].pageY == touches[1].pageY)))
                        this._calculatePinchZoomFactor(this._calculateTouchDistance(startTouches, touches), this.model.zooming.type, e.target);
                }
                else 
	                (this.doPan || this.panning) ? this._calculatePinchZoomPosition(e) : this.chartMouseMove(e);
            }
            else {
                startTouches.length > 0 && this._removeTouchPointer(startTouches, e);
                touches.length > 0 && this._removeTouchPointer(touches, e);
                this.chartMouseMove(e);
            }
            this.previousPointerMove = { pageX: x, pageY: y, pointerId: event.pointerId };
        }
        else
            this.chartMouseMove(e);
    },
    _pointerPinchEnd: function (e) {
        var model = this.model, event = e.originalEvent, params = this.eventParams || (this.eventParams = this._initEventParams(model, event)),
                mouseLeave = (event.type.indexOf("leave")!=-1 || event.type.indexOf("out")!= -1 || event.type.indexOf("Out")!=-1);
        if (!model.enable3D && model.AreaType == 'cartesianaxes' && event.pointerType != 'mouse' && event.pointerType != 4 && model.zooming.enable && model.zooming.enablePinching && (event.touches || event.pointerId)) {
            if (this.continuePinching != null)
                this.svgObject.removeChild(this.svgObject.firstChild);
            this.continuePinching = this.previousPanTouch = this.previousScale = null;
            if (event.touches) {
                this.eventParams = null;
                this.chartMouseUp(e);
                mouseLeave && this.chartMouseLeave(e);
            }
            else {
                this._removeTouchPointer(params.touches, { pointerId: event.pointerId });
                if (params.movements.length > 0)
                    this._removeTouchPointer(params.movements, { pointerId: event.pointerId });
                if (params.touches.length == 0) {
                    this.chartMouseUp(e);
                    mouseLeave && this.chartMouseLeave(e);
                    this.eventParams = null;
                }
            }
        }
        else {
            this.chartMouseUp(e);
            mouseLeave && this.chartMouseLeave(e); //Trigger mouse leave event
        }
    },
    _appendStyle: function (selector) {
        var css = '#' + selector + '.e-canvas * {touch-action:none; -ms-touch-action:none}',
                  head = document.head || document.body,
                  style = document.createElement('style');

        style.type = 'text/css';
        style.appendChild(document.createTextNode(css));
        head.appendChild(style);
    },   
	 bindEvents: function () {

	     var matched = jQuery.uaMatch(navigator.userAgent),
         browserInfo = ej.EjSvgRender.utils.browserInfo(),
         isPointer = browserInfo.isMSPointerEnabled,
	     isIE11Pointer = browserInfo.pointerEnabled,	    
         touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
         touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
         touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
         touchCancelEvent = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchleave mouseleave";
	     this.model.browserInfo = browserInfo;  

	     if ((window.navigator.maxTouchPoints > 1 && window.PointerEvent) || window.PointerEventsPolyfill) { //For IE11 and IE devices that supports pointer events
	         this._on(this.element, "pointerup pointerleave", this._pointerPinchEnd);	        
	         this._on(this.element, "pointerdown", this._pointerPinchStart);
	         this._on(this.element, "pointermove", this._pointerPinchMove);
	         this._appendStyle(this.element[0].id);
	     }
	     else if (window.TouchEvent)//For chrome, safari and android
	     {	         
	         this._on(this.element, "touchstart", this._pointerPinchStart);
	         this._on(this.element, "touchmove", this._pinchGestureMove);
	         this._on(this.element, "touchend", this._pointerPinchEnd);	         
	         this._on($(this.element), "mousedown", this.chartMouseDown);
	         this._on($(this.element), "mousemove", this.chartMouseMove);
	         this._on(this.element, 'mouseleave', this.chartMouseLeave);
	         this._on($(document), "mouseup", this.chartMouseUp);	         
	         this._appendStyle(this.element[0].id);			
	     }        
	     else if (window.navigator.msMaxTouchPoints && window.navigator.msPointerEnabled) { //For IE10
	         this._on(this.element, "MSPointerUp", this._pointerPinchEnd);
	         this._on(this.element, "mouseleave", this.chartMouseLeave);
	         this._on(this.element, "MSPointerDown", this._pointerPinchStart);
	         this._on(this.element, "MSPointerMove", this._pointerPinchMove);
	         this._appendStyle(this.element[0].id);
	     }
	     else {
	         this._on(this.element, touchMoveEvent, this.chartMouseMove);
	         this._on(this.element, touchCancelEvent, this.chartMouseLeave);
	         this._on($(document), touchStopEvent, this.chartMouseUp);
	         this._on($(this.element), touchStartEvent, this.chartMouseDown);
	     }

	     this._on($(this.element), "click", this.chartMouseClick);
	     this._on($(this.element), "contextmenu", this.chartRightClick);	     
	     this._on($(this.element), "dblclick", this.chartMouseDoubleClick);	     


	     if (this.model.canResize || this.model.isResponsive) {
	         this.bindResizeEvents();
	     }
	     var touchAction = this.model.zooming.enable || this.model.commonSeriesOptions.dragSettings.enable ? 'none' : 'pan-y';

	     $(this.element).css({ 'ms-touch-action': touchAction, 'touch-action': touchAction, 'content-zooming': 'none' }); //disable browser touch action   
	   // $(this.svgObject).css({ 'ms-touch-action': 'none', 'touch-action': 'none', 'content-zooming': 'none' });
	     $(this.element).css({
	     "-webkit-touch-callout": "none", /* iOS Safari */
	    "-webkit-user-select": "none",  /* Chrome/Safari/Opera */ 	     
	     "-moz-user-select": "none",     /* Firefox */
	     "-ms-user-select": "none",     /* Internet Explorer/Edge */
	     "user-select": "none"
	     });
	     var eventName = matched.browser.toLowerCase() == "mozilla" ? (isIE11Pointer ? "mousewheel" : "DOMMouseScroll") : "mousewheel";
	     this._on(this.element, eventName, this.chartMouseWheel);

	 },

    calZoomFactors: function (cumulativeScale, origin, currentZoomFactor, currentZoomPos) {
        var calcZoomFactorVal, calcZoomPosition;
        if (cumulativeScale == 1) {
            calcZoomFactorVal = 1;
            calcZoomPosition = 0;
        } else {
            calcZoomFactorVal = ej.EjSvgRender.utils._minMax(1 / cumulativeScale, 0, 1);
            calcZoomPosition = currentZoomPos + ((currentZoomFactor - calcZoomFactorVal) * origin);
        }
        return { zoomMFactor: calcZoomFactorVal, zoomMPosition: calcZoomPosition };
    },
    doMouseWheelZoom: function (cumulativeScale, origin, axis) {
        if (cumulativeScale >= 1) {
            var calZoomVal = this.calZoomFactors(cumulativeScale, origin, axis.zoomFactor, axis.zoomPosition);
            //calcZoomPos = Math.Round(calcZoomPos, 2);
            if (axis.zoomPosition != calZoomVal.zoomMPosition || axis.zoomFactor != calZoomVal.zoomMFactor) {
                this.zoomed = true;
                axis.zoomPosition = calZoomVal.zoomMPosition;
                axis.zoomFactor = (calZoomVal.zoomMPosition + calZoomVal.zoomMFactor) > 1 ? (1 - calZoomVal.zoomMPosition) : calZoomVal.zoomMFactor;
                return true;
            }
        }

        return false;

    },
    enableAnimation: function () {
        for (var m = 0; m < this.model.series.length; m++) {
            var series = this.model.series[m];
            series.enableAnimation = this.serAnimation[m];
        }
    },
    disableAnimation: function () {
        var chart = this;
        for (var m = 0; m < chart.model.series.length; m++) 
            chart.model.series[m].enableAnimation = false;
        for (var k = 0; k < chart.model.indicators.length; k++) 
            chart.model.indicators[k].enableAnimation = false;
    },
    _removeTrackBall: function () {
        var id = "#" + this.svgObject.id;
        $("#" + this.svgObject.id + "_trackSymbol").remove();
		 $(document).find("#measureTex").remove();
		 if (this.chartCross.visible) {
		     // Visibility is set to hidden
		     var element = $(this.svgObject).find(id + "_AxisCrossToolTip");
        this.svgRenderer._setAttr($(element), { "visibility": 'hidden' });
		     element = $(this.svgObject).find(id + "_CrosshairVertical");
        this.svgRenderer._setAttr($(element), { "d": 'M 0 0' });
		     element = $(this.svgObject).find(id + "_CrosshairHorizontal");
        this.svgRenderer._setAttr($(element), { "d": 'M 0 0' });
		     
        element = $(this.svgObject).find(id + "_TrackAxisToolTip");
        this.svgRenderer._setAttr($(element), { "visibility": 'hidden'});
        element = $(this.svgObject).find(id + "_Tracker");
        this.svgRenderer._setAttr($(element), { "d": 'M 0 0'});
        element = $(this.svgObject).find('[id*="_TrackToolTip"]');
        this.svgRenderer._setAttr($(element), { "visibility": 'hidden' });
        element = $(this.svgObject).find('[id*="_TrackToolTip"]').children();
        this.svgRenderer._setAttr($(element), { "visibility": 'hidden' });
        $(element).css('visibility', 'hidden');
        element = $(this.svgObject).find('[id*="_trackSymbol_"]');
        this.svgRenderer._setAttr($(element), { "visibility": 'hidden' });
        $(document).find('[id*="_TrackToolTipTemplate_"]').attr("visibility", "hidden");
        $(document).find('[id*="_TrackToolTipTemplate_"]').css("display", "none");
        $(id + "_CrosshairVertical").css("display", "none");
        $(id + "_CrosshairHorizontal").css("display", "none");
        $("#" + this._id).find('[id*="canvas_AxisToolTipRect"]').css("visibility", "hidden");
		$("#" + this._id).find('[id*="canvas_Tracker"]').remove();
        $("#" + this._id).find('[id*="canvas_trackSymbol"]').css("visibility", "hidden");
		$("#" + this._id).find('[id*="_gTooltip_"]').remove();
		$("#secondCanvas").remove();
		$("#" + this._id).find('[id*="_trackball_grouping_tooltip"]').remove();
		}
		 
    },
    enableTrackBall: function () {
        this.model.crosshair.visible = this.chartCross.visible;
        this.model.crosshair.type = this.chartCross.mArea;
    },
    disableTrackBall: function () {

        this.model.crosshair.visible = false;
        
        this._removeTrackBall();
    },
    _enableZoomingButtons: function () {
		var svgObjectId = this.svgObject.id;
	    if (this.model.AreaType != 'cartesianaxes') {
                $("#" + svgObjectId + "_ResetZoom").remove();
                $("#" + svgObjectId + "_PanBtn").remove();
                $("#" + svgObjectId+ "_ZoomBtn").remove();
                $("#" + svgObjectId + "_ZoomInBtn").remove();
                $("#" + svgObjectId + "_ZoomOutBtn").remove();
        }
        if (this.model.AreaType == 'cartesianaxes') {
            //Remove zoom buttons before adding them
            this._removeZoomkit();
            var toolbar = this.model.zooming.toolbarItems;
            var length = toolbar.length;
			var currentItem, index;
            for (var i= length -1; i>= 0; i--) {
                currentItem = toolbar[i];
                index = length - i;
                switch (currentItem) {
                    case "reset":
                        this.resetZoomButton(index);
                        break;
                    case "pan":
                        this.panButton(index);
                        break;
                    case "zoom":
                    case "zoomIn":
                    case "zoomOut":
                        this.zoomButton(index, currentItem);
                        break;
                    default:
                        length = length - 1;
                        break;
                }
            }
        }
    },
    chartMouseWheel: function (e) {
        $("#" + this.svgObject.id + "_TrackToolTip").hide(); // fixed tooltip mouse wheel issue
        if (this.model.zooming.enableMouseWheel && this.model.AreaType == "cartesianaxes" && !this.model.enable3D && !this.vmlRendering && ej.util.isNullOrUndefined(this.model.isLazyZooming)) {
            var chart = this;       
            var chartZoomed;
            this.zoomed = false;
            var canUpdate = false;
            var id = "#" + chart.svgObject.id;
            var matched = jQuery.uaMatch(navigator.userAgent);
			var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
            var wheelDelta = e.originalEvent.wheelDelta;
			var direction = matched.browser.toLowerCase() == "mozilla" ? ((isIE11 ? ((wheelDelta / 120) > 0 ? 1 : -1) : -(e.originalEvent.detail) / 3 > 0 ? 1 : -1)) : ((wheelDelta / 120) > 0 ? 1 : -1);
            for (var i = 0; i < this.model._axes.length; i++) {
                var axis = this.model._axes[i];
                if ((axis.orientation.toLowerCase() == "vertical" && (chart.model.zooming.type.toLowerCase() == "y" || chart.model.zooming.type.trim().toLowerCase() == "x,y")) || (axis.orientation.toLowerCase() == "horizontal" && (chart.model.zooming.type.toLowerCase() == "x" || chart.model.zooming.type.trim().toLowerCase() == "x,y"))) {

                    var currentScale = Math.max(1 / ej.EjSvgRender.utils._minMax(axis.zoomFactor, 0, 1), 1);
                    var cumulativeScale = Math.max(currentScale + (0.25 * direction), 1);
                    canUpdate = canUpdate | chart.doMouseWheelZoom(cumulativeScale, 0.5, axis);
                }
                if (axis.zoomFactor != 1 && axis.zoomPosition != 0)
                    chartZoomed = true;
            }
            this._updateScroll();
            this.disableAnimation();

            this.disableTrackBall();
            if (canUpdate) {
                this.model.legendCollapsed = false;
                this.zoomed = true;
                chart.redraw(true);
              }
            this.model._chartAreaZoom = true;
            this._enableZoomingButtons();
            this.mouseWheelCoords = { x: e.originalEvent.pageX, y: e.originalEvent.pageY };
            if (!chartZoomed) {
                $(id + '_ResetZoom').remove();
                $(id + '_PanBtn').remove();
                $(id + '_ZoomBtn').remove();
                $(id + '_ZoomInBtn').remove();
                $(id + '_ZoomOutBtn').remove();
                this.enableAnimation();
                this.panning = false;
            }
			var matched = jQuery.uaMatch(navigator.userAgent);
            if (e.preventDefault && matched.browser == 'chrome' && this.model.zooming.enable)
                e.preventDefault();
            e.returnValue = false;
        }

		$(".tooltipDiv" + this._id).remove();
    },
	
	 getAxisMultiLevelLabelsData: function (evt) {
		var mouseMoveCords = this.calMousePosition(evt),
		    grpLabelsLength = this.model.multiLevelLabelRegions.length,
			ele, x, y, height, width, i;
		this.mousemoveX = mouseMoveCords.X;
        this.mousemoveY = mouseMoveCords.Y;
		for (i= 0; i< grpLabelsLength; i++){
		     ele = this.model.multiLevelLabelRegions[i];
			 x = ele.bounds.x;
			 y = ele.bounds.y;
			 height = ele.bounds.height;
			 width = ele.bounds.width;
			 if ((this.mousemoveX >= x) && (this.mousemoveX <= x + width) && (this.mousemoveY <= y + height) && (this.mousemoveY >= y) ) {
                    data = { location: { x: this.mousemoveX, y: this.mousemoveY }, axis: this.model._axes[ele.axisIndex], multiLevelLabel: ele.multiLevelLabel };
                    return data;
             }
		}
	 },
	 
	 getAxisLabelData: function (evt) {
           
        var mouseMoveCords = this.calMousePosition(evt),
            targetid = evt.target.id,
            region,
            x,
            y,
            width,
            height,
            data,
            labelsLength,
            axisVisible,
            axesLength = this.model._axes.length;
        this.mousemoveX = mouseMoveCords.X;
        this.mousemoveY = mouseMoveCords.Y;
        if (this.model.AreaType == 'cartesianaxes' || this.model.AreaType == 'polaraxes') {
            if (!this.model.enable3D ) {
                for (var j = 0; j < axesLength; j++) {
                    labelsLength = this.model._axes[j].visibleLabels.length;
                    axisVisible=this.model._axes[j].visible;
                    if (axisVisible)
                    for (var k = 0; k < labelsLength; k++) {

                        region = this.model._axes[j].visibleLabels[k].region;
                        if (!ej.util.isNullOrUndefined(region)) {
                            x = region.bounds.x;
                            y = region.bounds.y;
                            width = region.bounds.width;
                            height = region.bounds.height;
                            x = (this.vmlRendering && (targetid.indexOf("_YLabel_") >= 0)) ? (this.model._axes[j].opposedPosition) ? x : x + width : x;
                            if ((this.mousemoveX >= x) && (this.mousemoveX <= x + width)) {
                                if ((this.vmlRendering) ? ((this.mousemoveY <= y + height) && (this.mousemoveY >= y)) : (this.mousemoveY >= y - height) && (this.mousemoveY <= y)) {
                                    data = { location: { x: this.mousemoveX, y: this.mousemoveY }, index: k, axis: this.model._axes[j], text: region.labelText };
                                    return data;
                                }
                            }
                        }

                    }
                }
            }
            else {
                if (targetid.indexOf("horizontal") >= 0 || targetid.indexOf("vertical") >= 0 ) {
                    for (var j = 0; j < axesLength; j++) {
                        labelsLength = this.model._axes[j].visibleLabels.length;
                        for (var k = 0; k < labelsLength; k++) {

                            if (targetid == this.svgObject.id + this.model._axes[j].orientation + k) {
                                data = { location: { x: this.mousemoveX, y: this.mousemoveY }, index: k, axis: this.model._axes[j], text: this.model._axes[j].visibleLabels[k].Text};
                                return data;

                            }
                        }
                    }
                } 
            }
    }
    },
    getLegendData: function (evt) {
        var mouseMoveCords = this.calMousePosition(evt);
        mouseMoveCords.X -= parseFloat($(this.element).css("padding-left"));
        mouseMoveCords.Y -= parseFloat($(this.element).css("padding-top"));
        var isEjScroll = this.model.legend._ejScroller;
		 var scrolltop = 0;
        var scrollleft = 0;
        if(ej.util.isNullOrUndefined(this._id)){
          scrolltop = isEjScroll ? $("#legend_" + this._id).ejScroller('instance').model.scrollTop : $("#legend_" + this._id).scrollTop();
          scrollleft = isEjScroll ? $("#legend_" + this._id).ejScroller('instance').model.scrollLeft : $("#legend_" + this._id).scrollLeft();
        }
        this.scrolltop = scrolltop;
        this.scrollleft = scrollleft;
        this.mousemoveX = mouseMoveCords.X+scrollleft;
        this.mousemoveY = mouseMoveCords.Y+scrolltop;
		 var targetId = evt.target.id;

        {
            var currentX = this.mousemoveX;
            var currentY = this.mousemoveY;
            var chartId = this._id;
            var region;
            if ((!ej.util.isNullOrUndefined(targetId) && this.svgRenderer._getAttrVal($(evt.target).parents(':eq(1)'), 'id') == this.svgObject.id + '_Legend') ||(this.model.enableCanvasRendering && targetId == "legend_" + chartId + "_canvas") || (this.vmlRendering)) {
                $.each(this.model.legendRegion, function (index, regionItem) {

                    if ((currentX >= regionItem.Bounds.LegendBound.X + regionItem.Bounds.ItemBound.X) && (currentX <= regionItem.Bounds.LegendBound.X + regionItem.Bounds.ItemBound.X + regionItem.Bounds.ItemBound._Width)) {
                        if ((currentY >= regionItem.Bounds.LegendBound.Y + regionItem.Bounds.ItemBound.Y - (regionItem.Bounds.ItemBound.Height / 4)) && (currentY <= regionItem.Bounds.LegendBound.Y + regionItem.Bounds.ItemBound.Y + regionItem.Bounds.ItemBound.Height)) {
                           region = regionItem;
                           $("#legend_" +chartId + "_canvas").css("cursor", "pointer");
                        }else
                            $("#legend_" + chartId + "_canvas").css("cursor", "default");
                    } 
                });
                if (!ej.util.isNullOrUndefined(region)) {
                    return { legendItem: region, series: this.model._visibleSeries[region.LegendItem.SeriesIndex] };
                }
            }

        }
        return false;
    },

    get3DSeriesPoint: function (evt) {
        var currentX = this.mousemoveX;
        var currentY = this.mousemoveY;
        var x = (this.model.AreaType == 'polaraxes') ? 0 : this.model.m_AreaBounds.X;
        var y = (this.model.AreaType == 'polaraxes') ? 0 : this.model.m_AreaBounds.Y;
        var width = (this.model.AreaType == 'polaraxes') ? $(this.svgObject).width() : this.model.m_AreaBounds.Width;
        var height = (this.model.AreaType == 'polaraxes') ? $(this.svgObject).height() : this.model.m_AreaBounds.Height;

        if (currentX > x && currentX < (x + width) && currentY > y && currentY < (y + height)) {
            var nodeName = $(evt.target)[0].nodeName;
            if ((nodeName == "path" || nodeName == "shape") && $(evt.target)[0].id.indexOf("Region")>1) {
                index = $(evt.target)[0].id.match(/(\d+)/g);
                pointIndex = parseInt(index[index.length - 1]);
                seriesIndex = parseInt(index[index.length - 2]);
                var regionValue = {};
                regionValue.Region = {};
                regionValue.Region.PointIndex = pointIndex;
                regionValue.SeriesIndex = seriesIndex;
                var pointData = {};
                pointData.pointIndex = pointIndex;
                region = { region: regionValue, pointData: pointData, location: { x: currentX, y: currentY} };
                return region;
            }
        }
    },

    GetSeriesPoint: function (evt) {
        var mouseX;
        var mouseY;
        var currentX = this.mousemoveX;
        var currentY = this.mousemoveY;
        var region;
        var chartObj = this;
		 var indicators = chartObj.model.indicators;
        var seriesCollection = chartObj.model._visibleSeries;
        for (var j = 0; j < indicators.length && indicators[j].segment; j++) {
            seriesCollection = seriesCollection.concat(indicators[j].segment);
        }
        if (chartObj.model.enable3D) {
            return this.get3DSeriesPoint(evt);           
        }
        var x = (this.model.AreaType == 'polaraxes') ? 0 : this.model.m_AreaBounds.X;
        var y = (this.model.AreaType == 'polaraxes') ? 0 : this.model.m_AreaBounds.Y;
        var width = (this.model.AreaType == 'polaraxes') ? $(this.svgObject).width() : this.model.m_AreaBounds.Width;
        var height = (this.model.AreaType == 'polaraxes') ? $(this.svgObject).height() : this.model.m_AreaBounds.Height;

        if ((this.model.AreaType == 'cartesianaxes' || this.model.AreaType == 'polaraxes')) {
          
            if (currentX > x && currentX < (x + width) && currentY > y && currentY < (y + height)) {
                $.each(this.model.chartRegions, function (index, regionItem) {
                    if (!ej.util.isNullOrUndefined(regionItem.SeriesIndex)) {
					var currentSer = seriesCollection[regionItem.SeriesIndex];
                    if (chartObj.model.AreaType == "polaraxes" && currentSer.drawType.toLowerCase() == 'column' && evt.target) {
                        if (chartObj.model.enableCanvasRendering) {
                                    if (currentSer.type.toLowerCase() == "polar") {
                                        var bounds = regionItem.Region.Bounds;
                                        var chartStartAngle = -.5 * Math.PI;
                                        var innerRadius = bounds.innerRadius;
                                        var fromCenterX;
                                        var fromCenterY;
                                        fromCenterX = (currentX) - (bounds.CenterX);
                                        fromCenterY = (currentY) - (bounds.CenterY);
                                        var series = chartObj.model._visibleSeries[regionItem.SeriesIndex];
                                        var startAngle = series.startAngle;
                                        var endAngle = series.endAngle;

                                        var arcAngle = (startAngle) ? 2 * Math.PI * (chartObj.model.itemCurrentXPos < 0 ? 1 + chartObj.model.itemCurrentXPos : chartObj.model.itemCurrentXPos) : 0;
                                        var clickAngle = (Math.atan2(fromCenterY, fromCenterX) - chartStartAngle - arcAngle) % (2 * Math.PI);
                                        if (clickAngle < 0 && bounds.PointIndex != 0) clickAngle = 2 * Math.PI + clickAngle;

                                        var pointStartAngle = parseFloat(bounds.StartAngle.toFixed(14));
                                        var pointEndAngle = parseFloat(bounds.EndAngle.toFixed(14));
                                        pointStartAngle -= arcAngle;
                                        pointEndAngle -= arcAngle;

                                        if (clickAngle >= pointStartAngle && clickAngle <= pointEndAngle) {
                                            index = bounds.PointIndex;
                                            distanceFromCenter = Math.sqrt(Math.pow(Math.abs(fromCenterX), 2) + Math.pow(Math.abs(fromCenterY), 2));
                                            if (distanceFromCenter <= bounds.Radius && distanceFromCenter > innerRadius) {
                                                var pointRegion = { Region: { PointIndex: index }, SeriesIndex: regionItem.SeriesIndex, type: regionItem.type };
                                                region = pointRegion;
                                            }
                                        }
                                    } else if (currentSer.type.toLowerCase() == "radar") {
                                        var bounds = regionItem.Region.Bounds;
                                        if (bounds.Line1) {
                                            line1 = bounds.Line1;
                                            line2 = bounds.Line2;
                                            line3 = bounds.Line3;
                                            var polygon = [
                                                            { x: line1.x, y: line1.y },
                                                            { x: line2.x, y: line2.y },
                                                            { x: line3.x, y: line3.y },
                                            ];
                                            var currentPoint = { x: currentX, y: currentY };
                                            var point = false;
                                            for (var p = false, i = -1, l = polygon.length, j = l - 1; ++i < l; j = i)
                                                ((polygon[i].y <= currentPoint.y && currentPoint.y < polygon[j].y) || (polygon[j].y <= currentPoint.y && currentPoint.y < polygon[i].y))
                                                && (currentPoint.x < (polygon[j].x - polygon[i].x) * (currentPoint.y - polygon[i].y) / (polygon[j].y - polygon[i].y) + polygon[i].x)
                                                && (p = !p);
                                            point = p;
                                            if (point) {
                                                index = bounds.PointIndex;
                                                var pointRegion = { Region: { PointIndex: index }, SeriesIndex: regionItem.SeriesIndex, type: regionItem.type };
                                                region = pointRegion;
                                            }
                                        }
                                    }
                                }
                                else {
                                    var nodeName = $(evt.target)[0].nodeName;
                                    if ((nodeName == "path" || nodeName == "shape") && $($(evt.target).parent())[0].id == chartObj.svgObject.id + '_SeriesGroup' + '_' + regionItem.SeriesIndex) {
                                        index = $(evt.target)[0].id.match(/(\d+)/g);
                                        pointIndex = parseInt(index[index.length - 1]);
                                        regionItem = { Region: { PointIndex: pointIndex }, SeriesIndex: regionItem.SeriesIndex, type: regionItem.type };
                                        region = regionItem;
                                        return false;
                                    }
                                }
                    }
                    else {
                        if ((((currentX >= regionItem.Region.Bounds.X) && (currentX <= (regionItem.Region.Bounds.X + (regionItem.Region.Bounds.Width))))) && ((currentY > regionItem.Region.Bounds.Y) && (currentY < (regionItem.Region.Bounds.Y) + (regionItem.Region.Bounds.Height)))) {
                            region = regionItem;
                        }
                    }
                    }
					else {
                        regionValue = chartObj.model.chartRegions;
                        var pointData = {};
						 var areaValue;
					if (!regionItem.isStripLine) {
                        var regionLength = regionItem.length;
						 var requireInvertedAxes = chartObj.model.requireInvertedAxes;
                        var axisName = (!requireInvertedAxes) ? chartObj.model.series[regionItem[regionLength - 1].SeriesIndex]._yAxisName : chartObj.model.series[regionItem[regionLength - 1].SeriesIndex]._xAxisName;
                        for (var k = 0; k < chartObj.model._axes.length; k++)
                        {
                            if (axisName == chartObj.model._axes[k].name)
                            {
                               areaValue = chartObj.model._axes[k];
                               break;
                            }
                        }
                        for (var i = 0; i < regionValue.length; i++) {
							for (var j = 0; j < regionValue[i].length; j++) {
                                var polygon = [];
                                line1 = regionValue[i][j].region;
                                if (line1[0]) polygon.push({ x: line1[0].X + areaValue.x, y: line1[0].Y + areaValue.y });
                                if (line1[1]) polygon.push({ x: line1[1].X + areaValue.x, y: line1[1].Y + areaValue.y });
                                if (line1[2]) polygon.push({ x: line1[2].X + areaValue.x, y: line1[2].Y + areaValue.y });
                                if (line1[3]) polygon.push({ x: line1[3].X + areaValue.x, y: line1[3].Y + areaValue.y });

                                var currentPoint = { x: currentX, y: currentY };
                                var point = chartObj.isPointInPolygon(polygon, currentPoint);
                                if (point)
                                    region = regionValue[i][j];
							}
                                                                         
                        }
                    }
                    }
                });
            }
            if (region) {
                return { region: region, location: { x: currentX, y: currentY} };
            }
        }

        else {
            var chartObj = this;
            var distanceFromCenter;
            var regionValue;
            var chartRegions = chartObj.model.chartRegions;
            if (chartRegions.length > 0 && (chartRegions[0].Series.type.toLowerCase() == "pyramid"|| chartRegions[0].Series.type.toLowerCase() == "funnel")) {
                var nodeName = $(evt.target)[0].nodeName;
                if ((nodeName == "path" || nodeName == "shape") && $($(evt.target).parent())[0].id == chartObj.svgObject.id + '_SeriesGroup' + '_' + chartRegions[0].SeriesIndex) {
                    regionValue = chartObj.model.chartRegions[0];
                    index = $(evt.target)[0].id.match(/(\d+)/g);
                    index = parseInt(index[index.length - 1]);
                    regionValue.Region.PointIndex = index;
                    var pointData = {};
                    pointData.pointIndex = index;
                    region = { region: regionValue, pointData: pointData, location: { x: currentX, y: currentY} };
                    return region;
                }
                else {                    
                    regionValue = chartRegions[0];
                    var pyrX = this.pyrX;
                    var pyrY = this.pyrY;
                    var pointData = {};
                    var polygon;
                        for (var j = 0; j < regionValue.Region.length; j++) {
                            line1 = regionValue.Region[j].Line1;
                            line2 = regionValue.Region[j].Line2;
                            line3 = regionValue.Region[j].Line3;
                            line4 = regionValue.Region[j].Line4;
                            if (chartRegions[0].Series.type.toLowerCase() == "pyramid")
                                polygon = [
                                            { x: line1.x + pyrX, y: line1.y + pyrY },
                                            { x: line2.x + pyrX, y: line2.y + pyrY },
                                            { x: line3.x + pyrX, y: line3.y + pyrY },
                                            { x: line4.x + pyrX, y: line4.y + pyrY }
                                ];
                            else {
                                line5 = regionValue.Region[j].Line5;
                                line6 = regionValue.Region[j].Line6;
                                polygon = [
                                            { x: line1.x + pyrX, y: line1.y + pyrY },
                                            { x: line2.x + pyrX, y: line2.y + pyrY },
                                            { x: line3.x + pyrX, y: line3.y + pyrY },
                                            { x: line4.x + pyrX, y: line4.y + pyrY },
                                            { x: line5.x + pyrX, y: line5.y + pyrY },
                                            { x: line6.x + pyrX, y: line6.y + pyrY }
                                ];
                            }

                            var currentPoint = { x: currentX, y: currentY };
                            var point = this.isPointInPolygon(polygon, currentPoint);
                            if (point) {
                                pointData.pointIndex = regionValue.Region[j].PointIndex;
                                regionValue.Region.PointIndex = pointData.pointIndex;
                                region = { region: regionValue, pointData: pointData, location: { x: currentX, y: currentY } };                                                                
                                return region;
                            }

                        }
                    }                
                }
            
            else {
                // ReSharper disable DuplicatingLocalDeclaration
                $.each(chartObj.model.chartRegions, function (regionIndex, regionValue) {
                    // ReSharper restore DuplicatingLocalDeclaration
                    var chartStartAngle = -.5 * Math.PI;
                    var seriesData = regionValue.SeriesData,
                    regionData = regionValue.Region,
                    innerRadius = (chartObj.model._visibleSeries[regionValue.SeriesIndex].type.toLowerCase() == 'doughnut') ? seriesData.DRadius: 0;
                    var fromCenterX;
                    var fromCenterY;
                    fromCenterX = (currentX) - (seriesData.CenterX);
                    fromCenterY = (currentY) - (seriesData.CenterY);
                    var series = chartObj.model._visibleSeries[regionValue.SeriesIndex];
                    var startAngle = series.startAngle;
                    var endAngle = series.endAngle;
                    startAngle = startAngle < 0 ? startAngle + 360 : startAngle;
                    endAngle = endAngle < 0 ? endAngle + 360 : endAngle;
                    var totalDegree = (series.endAngle - series.startAngle);
                    //Anticlockwise pie and doughnut
                    if (totalDegree < 0) {
                        endAngle = endAngle / 360;
                        var arcAngle = (endAngle) ? 2 * Math.PI * (endAngle < 0 ? 1 + endAngle : endAngle) : 0;
                        var clickAngle = (Math.atan2(fromCenterY, fromCenterX) - chartStartAngle - arcAngle) % (2 * Math.PI);;
                        if (clickAngle < 0) clickAngle = 2 * Math.PI + clickAngle;

                        pointData = [];
                        for (var i = 0; i < regionData.length; i++) {
                            var pointStartAngle = parseFloat(regionData[i].StartAngle.toFixed(14));
                            var pointEndAngle = parseFloat(regionData[i].EndAngle.toFixed(14));
                            pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                            pointEndAngle = pointEndAngle < 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
                            pointStartAngle -= arcAngle;
                            pointEndAngle -= arcAngle;
                            pointStartAngle = parseFloat(pointStartAngle.toFixed(14));
                            pointEndAngle = parseFloat(pointEndAngle.toFixed(14));
                            if (series.startAngle >= 0 && series.endAngle <= 0) {
                                pointStartAngle = pointStartAngle <= 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                                pointEndAngle = pointEndAngle < 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
                            }
                            if (clickAngle <= pointStartAngle && clickAngle >= pointEndAngle) {
                                pointData.push(regionData[i]);
                                break;
                            }
                        }
                    }  //Clockwise pie,pieofpie and doughnut
                    else {
                        var arcAngle = (startAngle) ? 2 * Math.PI * (chartObj.model.itemCurrentXPos < 0 ? 1 + chartObj.model.itemCurrentXPos : chartObj.model.itemCurrentXPos) : 0;
                        var clickAngle = (Math.atan2(fromCenterY, fromCenterX) - chartStartAngle - arcAngle)%(2*Math.PI);
                        if (clickAngle < 0) clickAngle = chartObj.model._isPieOfPie ? clickAngle:2 * Math.PI + clickAngle;
                        pointData = [];
                        for (var i = 0; i < regionData.length; i++) {
                            var pointStartAngle = parseFloat(regionData[i].StartAngle.toFixed(14));
                            var pointEndAngle = parseFloat(regionData[i].EndAngle.toFixed(14));
                            pointStartAngle = pointStartAngle < 0 ? (chartObj.model._isPieOfPie? pointStartAngle:2 * Math.PI + pointStartAngle):pointStartAngle;
                            pointEndAngle = pointEndAngle < 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
                            pointStartAngle -= arcAngle;
                            pointEndAngle -= arcAngle;
                            pointStartAngle = parseFloat(pointStartAngle.toFixed(14));
                            pointEndAngle = parseFloat(pointEndAngle.toFixed(14));
                            if (series.startAngle < 0 && (series.endAngle > -1||series.endAngle==null)) {
                            pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                            pointEndAngle = pointEndAngle <= 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
                            }
                            if (clickAngle + 2 * Math.PI < pointEndAngle && series.type == "pieofpie")
                                clickAngle = clickAngle + 2 * Math.PI;
                            if (clickAngle >= pointStartAngle && clickAngle <= pointEndAngle) {
                                pointData.push(regionData[i]);
                                break;
                            }
                        }
                    }
                    if (pointData.length > 0) {
                        var isExploded = (series.explodeAll || (series.explodeIndex == pointData[0].PointIndex));
                        if (isExploded) {

                            var fromCenterX1 = currentX - pointData[0].StartX;
                            var fromCenterY1 = currentY - pointData[0].StartY;

                            if (pointData.length > 0) {

                                distanceFromCenter = Math.sqrt(Math.pow(Math.abs(fromCenterX1), 2) + Math.pow(Math.abs(fromCenterY1), 2));
                                if (distanceFromCenter <= seriesData.Radius && distanceFromCenter > innerRadius) {
                                    regionData.PointIndex = pointData[0].PointIndex;
                                    regionData.SeriesIndex = pointData[0].SeriesIndex;
                                    region = { region: regionValue, pointData: pointData, location: { x: currentX, y: currentY} };
                                }
                            }
                        }
                        else {
                            distanceFromCenter = Math.sqrt(Math.pow(Math.abs(fromCenterX), 2) + Math.pow(Math.abs(fromCenterY), 2));
                            if (distanceFromCenter <= seriesData.Radius&& distanceFromCenter > innerRadius) {
                                regionData.PointIndex = pointData[0].PointIndex;
                                regionData.SeriesIndex = pointData[0].SeriesIndex;
                                region = { region: regionValue, pointData: pointData, location: { x: currentX, y: currentY} };
                            }
                        }
                    }

                });

                return region;
            }
        }
    },
    isPointInPolygon: function (polygon, point) {
        for (var p = false, i = -1, l = polygon.length, j = l - 1; ++i < l; j = i)
            ((polygon[i].y <= point.y && point.y < polygon[j].y) || (polygon[j].y <= point.y && point.y < polygon[i].y))
            && (point.x < (polygon[j].x - polygon[i].x) * (point.y - polygon[i].y) / (polygon[j].y - polygon[i].y) + polygon[i].x)
            && (p = !p);
        return p;
    },
    mousePosition: function (evt) {
         if (!ej.util.isNullOrUndefined(evt.pageX) && evt.pageX>0)
            return { x: evt.pageX, y: evt.pageY };
         else if (evt.originalEvent && !ej.util.isNullOrUndefined(evt.originalEvent.pageX) && evt.originalEvent.pageX>0)
            return { x: evt.originalEvent.pageX, y: evt.originalEvent.pageY };
         else if (evt.originalEvent && evt.originalEvent.changedTouches != undefined)
         {
             if (!ej.util.isNullOrUndefined(evt.originalEvent.changedTouches[0].pageX) && evt.originalEvent.changedTouches[0].pageX > 0)
                 return { x: evt.originalEvent.changedTouches[0].pageX, y: evt.originalEvent.changedTouches[0].pageY };
         }
         else
             return { x: 0, y: 0 };
         
    },


    calMousePosition: function (e) {
        var matched = jQuery.uaMatch(navigator.userAgent);
        var mouseposition = this.mousePosition(e);
        e.pageX = mouseposition.x;
        e.pageY = mouseposition.y;
        var mouseX, mouseY;
        var browser = matched.browser.toLowerCase();
        mouseX = (e.pageX) - $(this.svgObject).offset().left;
        mouseY = (e.pageY) - $(this.svgObject).offset().top;
       

        return { X: mouseX, Y: mouseY };

    },
    
    calTouchPosition: function (e) {
        var matched = jQuery.uaMatch(navigator.userAgent);
        var mouseX, mouseY;

        if (matched.browser.toLowerCase() == "mozilla" || matched.browser.toLowerCase() == "webkit") {
            var touch = e.originalEvent.touches[0];
            mouseX = (touch.pageX) - $(this.svgObject).parent().offset().left;
            mouseY = (touch.pageY) - $(this.svgObject).parent().offset().top;
            this.leftPadding = $(this.svgObject).offset().left;
            this.grabPadding = 0;
        } else if (matched.browser.toLowerCase() == "msie") {

            mouseX = (e.originalEvent.pageX) - $(this.svgObject).offset().left;
            mouseY = (e.originalEvent.pageY) - $(this.svgObject).offset().top;
            this.leftPadding = $(this.svgObject).offset().left;
        }
        else {
            var touch = e.originalEvent.touches[0];
            mouseX = (touch.pageX) - $(this.svgObject).offset().left;
            mouseY = (touch.pageY) - $(this.svgObject).offset().top;
            this.leftPadding = $(this.svgObject).offset().left;
        }

        return { X: mouseX, Y: mouseY };

    },

    cancelEvent: function (e) {
        e.stopPropagation();
        var matched = jQuery.uaMatch(navigator.userAgent);
        if(matched.browser == 'chrome' && (this.model.zooming.enable||this.model.crosshair.visible) ){
            e.preventDefault();
        }
        if (this.model.enable3D) {
            e.preventDefault();
            e.stopPropagation();
        }
        e.returnValue = false;
        e.cancelBubble = true;
        return false;
    },
    resetZoom: function () {
        var chartobj = this;
        var id = "#" + this.svgObject.id;
        $(".tooltipDiv" + this._id).remove(); //To remove tooltip template
        $(".zoom"+ this._id).remove();
        if (chartobj.zoomed) {
            $.each(this.model._axes, function (index, axis) {
				axis.zoomed = false;
                axis.zoomFactor = 1;
                axis.zoomPosition = 0;
            });
			//Reset primary axis zoomFactor and zoomPosition
			chartobj.model.primaryXAxis.zoomFactor = 1;
            chartobj.model.primaryYAxis.zoomFactor = 1;
            chartobj.model.primaryXAxis.zoomPosition = 0;
            chartobj.model.primaryYAxis.zoomPosition = 0;
			$("#"+chartobj._id + "_canvas").css({ "cursor": "default" });
            $(id + "_ResetZoom").remove();
            $(id + "_PanBtn").remove();
            $(id + "_ZoomBtn").remove();
            $(id + "_ZoomInBtn").remove();
            $(id + "_ZoomOutBtn").remove();            
            chartobj.zoomed = false;
            chartobj.zooming = false;
            chartobj.panning = false;
            chartobj.model._chartAreaZoom = false;
            chartobj.resetZooming = true;
            chartobj.enableTrackBall();
            chartobj.redraw();
            chartobj.enableAnimation();          
            chartobj.svgRenderer._setAttr($(chartobj.svgObject).find(id + "_XAxis," + id + "_ChartArea," + id + "_YAxis," + id + "_SeriesCollection"), { "cursor": "default" });
        }
    },
    startZoomInOut: function (currentEle) {
	    var currentItem = currentEle.target.id.indexOf("ZoomIn") > -1 ? "zoomIn" : "zoomOut";
        this.drag = false;
        this.zoomed = true;
		var type = this.model.zooming.type.toLowerCase();
		var zoomValue = currentItem == "zoomIn" ? 0.2 : -0.2;
		var zoomedOut = true;
		var axis, previousZoomFactor, previousZoomPosition;
        for (var k = 0; k < this.model._axes.length; k++) {
            axis = this.model._axes[k];
            previousZoomFactor = axis.zoomFactor;
            previousZoomPosition = axis.zoomPosition;
            if (axis.orientation.toLowerCase() == "horizontal") {
                axis.zoomFactor = type != "y" ? previousZoomFactor - zoomValue : axis.zoomFactor;
                axis.zoomPosition = type != "y" ? previousZoomPosition + zoomValue : axis.zoomPosition;
            } else {
                axis.zoomFactor = type != "x" ? previousZoomFactor - zoomValue: axis.zoomFactor;
                axis.zoomPosition = type != "x" ? previousZoomPosition + zoomValue : axis.zoomPosition;
            }
			if (parseFloat(axis.zoomFactor.toFixed(3)) <= 0.001) {
                axis.zoomFactor = previousZoomFactor;
                axis.zoomPosition = previousZoomPosition;
             }
			 if (parseFloat(axis.zoomFactor.toFixed(3)) >= 1) {
                axis.zoomFactor = 1;
                axis.zoomPosition = 0;
             }
			 zoomedOut = zoomedOut && (axis.zoomFactor == 1);
        }
        this._updateScroll();
        this.redraw(true);
        if (zoomedOut) {
            this._removeZoomkit();
            this.resetZooming = true;
            this.zoomed = this.panning = false;
            this.model._chartAreaZoom = false
        }
        else
            this._enableZoomingButtons();
    },
    startZoom: function () {
        var chartObj = this;
        var id = "#" + this.svgObject.id;
        $(".tooltipDiv" + this._id).remove(); //To remove tooltip template
        var iconColor = this.model.theme.toLowerCase().indexOf("dark") >= 0 ? "#000000" : " #FFFFFF";
        chartObj.svgRenderer._setAttr($(id + '_ZoomBtn'), { 'selected': 'true' });
        chartObj.svgRenderer._setAttr($(id + '_ZoomPath'), { "fill": "#14B9FF" });
        chartObj.svgRenderer._setAttr($(id + '_ZoomIcon'), { "fill": '#FFFFFF' });
        chartObj.svgRenderer._setAttr($(id + '_PanPath'), { "fill": '#B7B7B7' });
        chartObj.svgRenderer._setAttr($(id + '_panIcon'), { "fill": iconColor });
        $(id + "_ZoomBtn").css({ "border-color": "#14B9FF", "background-color": "#14B9FF" });
        $(id + "_PanBtn").css({ "border-color": "#B7B7B7", "background-color": "#B7B7B7" });
		$("#"+chartObj._id + "_canvas").css({ "cursor": "default" });
        this._cursorToDefault();
        chartObj.panning = false;
        chartObj.enableTrackBall();
    },
    startPan: function () {
        var chartObj = this;
        var id = "#" + this.svgObject.id;
        $(".tooltipDiv" + this._id).remove(); //To remove tooltip template
        var iconColor = this.model.theme.toLowerCase().indexOf("dark") >= 0 ? "#000000" : " #FFFFFF";
        chartObj.svgRenderer._setAttr($(id + '_ZoomBtn'), { 'selected': 'false' });
        chartObj.svgRenderer._setAttr($(id + '_PanBtn'), { 'selected': 'true' });
        chartObj.svgRenderer._setAttr($(id + '_ZoomPath'), { "fill": "#B7B7B7" });
        chartObj.svgRenderer._setAttr($(id + '_ZoomIcon'), { "fill": iconColor });
        chartObj.svgRenderer._setAttr($(id + '_PanPath'), { "fill": '#14B9FF' });
        chartObj.svgRenderer._setAttr($(id + '_panIcon'), { "fill": '#FFFFFF' });
        $(id + "_ZoomBtn").css({ "border-color": "#B7B7B7", "background-color": "#B7B7B7" });
        $(id + "_PanBtn").css({ "border-color": "#14B9FF", "background-color": "#14B9FF" });
		$("#"+chartObj._id + "_canvas").css({ "cursor": "pointer" });
        this._cursorToPointer();
        chartObj.panning = true;
        chartObj.disableTrackBall();

    },
    zoomButton: function (index, currentItem) {
        if (currentItem == "zoom")
            var currentItemId = "_Zoom";
        else if (currentItem == "zoomIn")
            currentItemId = "_ZoomIn";
        else
            currentItemId = "_ZoomOut";

        var padding = index * 5 + 5, chartOffset = { left: 0, top: 0 };
        var transX = this.model.m_AreaBounds.X + (this.model.m_AreaBounds.Width - (index * 32) - padding); //32 path bouding box for pan,reset, zoom button 
        var transY = (this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height) + (this.model.elementSpacing - (this.model.m_AreaBounds.Height));
        var iconColor = this.model.theme.toLowerCase().indexOf("dark") >= 0 ? "#000000" : " #FFFFFF";

        var pathOptions = {
            'id': this.svgObject.id + currentItemId + 'Path',
            'd': "M32,27c0,2.75-2.25,5-5,5H5c-2.75,0-5-2.25-5-5V5c0-2.75,2.25-5,5-5h22c2.75,0,5,2.25,5,5V27z",
            'fill': this.panning || currentItem == "zoomIn" ||  currentItem == "zoomOut"? '#b7b7b7' : '#14B9FF',
            'zoomId': this._id + currentItemId + "Btn",
            'width': 26,
            'height': 26,
            'left': transX + chartOffset.left,
            'top': transY + chartOffset.top,
			 'iconColor': iconColor
        };

            ej.EjCanvasRender.prototype.zoomButton(pathOptions, currentItem, this);
            if (currentItem == "zoom")
                this._on($("#" + this.svgObject.id + currentItemId + "Btn"), "touchstart click", this.startZoom);
            else
                this._on($("#" + this.svgObject.id + currentItemId + "Btn"), "touchstart click", this.startZoomInOut);
    },
    panButton: function (index) {
        var padding = index * 5 + 5, chartOffset = { left: 0, top: 0 };
        var transX = this.model.m_AreaBounds.X + (this.model.m_AreaBounds.Width - (index * 32) - padding); //32 path bounding box for pan and resetzoom button
        var transY = (this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height) + (this.model.elementSpacing - (this.model.m_AreaBounds.Height));
        var iconColor = this.model.theme.toLowerCase().indexOf("dark") >= 0 ? "#000000" : " #FFFFFF";

        var pathOptions = {
            'id': this.svgObject.id + '_PanPath',
            'd': "M 32 27 c 0 2.75 -2.25 5 -5 5 H 5 c -2.75 0 -5 -2.25 -5 -5 V 5 c 0 -2.75 2.25 -5 5 -5 h 22 c 2.75 0 5 2.25 5 5 V 27 Z",
            'fill': !this.panning ? '#b7b7b7' : '#14B9FF',
            'panId': this._id + '_PanBtn',
            'width': 26,
            'height': 26,
            'left': transX + chartOffset.left,
            'top': transY + chartOffset.top,
			 'iconColor': iconColor
        };
        ej.EjCanvasRender.prototype.panButton(pathOptions, this);
        this._on($("#" + this.svgObject.id + '_PanBtn'), "touchstart click", this.startPan);
    },
    resetZoomButton: function (index) {
        var padding = index * 5 + 5, chartOffset = { left: 0, top: 0 };
        var transX = this.model.m_AreaBounds.X + (this.model.m_AreaBounds.Width - (index*32 + padding)); //32 path bouding box
        var transY = (this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height) + (this.model.elementSpacing - (this.model.m_AreaBounds.Height));
        var iconColor = this.model.theme.toLowerCase().indexOf("dark") >= 0 ? "#000000" : " #FFFFFF";
        var options = {
            'id': this.svgObject.id + '_ResetZoomPath',
            'd': "M 32 27 c 0 2.75 -2.25 5 -5 5 H 5 c -2.75 0 -5 -2.25 -5 -5 V 5 c 0 -2.75 2.25 -5 5 -5 h 22 c 2.75 0 5 2.25 5 5 V 27 Z",
            'fill': '#b7b7b7',
            'resetZoomId': this._id + '_ResetZoom',
            'width': 26,
            'height': 26,
            'left': transX + chartOffset.left,
            'top': transY + chartOffset.top,
			 'iconColor': iconColor
        };
		 ej.EjCanvasRender.prototype.resetZoom(options, this);
        var events = (window.TouchEvent ? "touchstart" : (window.PointerEvent ? "pointerdown" : (window.MSPointerEvent ? "MSPointerDown" : "click"))) + " click";
		 this._on($("#" + this.svgObject.id + '_ResetZoom'), events, this.resetZoom);
    },

    doZoom: function (zoomRect, zoomRectWidth, zoomRectHeight) {
        var chart = this;
        this.model._chartAreaZoom = true;
        this.scrollDraw = true;
        $(".tooltipDiv" + this._id).remove(); //To remove tooltip template
        if (chart.model.enableCanvasRendering) {
            var zoomArea = $("#" + this.svgObject.id + "_ZoomArea")[0].getClientRects()[0];
            var chartArea = $("#" + this.svgObject.id)[0].getClientRects()[0];
            var zoomX = zoomArea.left - chartArea.left - $(document).scrollLeft(); 
            var zoomY = zoomArea.top - chartArea.top - $(document).scrollTop(); 
        } else {
            var zoomX = parseFloat(chart.svgRenderer._getAttrVal($(zoomRect), "x"));
            var zoomY = parseFloat(chart.svgRenderer._getAttrVal($(zoomRect), "y"));
        }
        $("#" + this.svgObject.id + "_ZoomArea").remove();
        this.drag = false;
        this.zoomed = true;
        for (var k = 0; k < this.model._axes.length; k++) {
            var axis = this.model._axes[k];
            var previousZoomFactor = axis.zoomFactor;
            var previousZoomPosition = axis.zoomPosition;
            if (axis.orientation.toLowerCase() == "horizontal") {
                axis.zoomFactor = chart.model.zooming.type.toLowerCase() != "y"
                    ? previousZoomFactor * (zoomRectWidth / (chart.model.m_AreaBounds.Width)) : axis.zoomFactor;
                axis.zoomPosition = chart.model.zooming.type.toLowerCase() != "y"
                    ? previousZoomPosition + Math.abs((zoomX - chart.model.m_AreaBounds.X) / (chart.model.m_AreaBounds.Width)) * previousZoomFactor : axis.zoomPosition;
                if (parseFloat(axis.zoomFactor.toFixed(3)) <= 0.001) {
                    axis.zoomFactor = previousZoomFactor;
                    axis.zoomPosition = previousZoomPosition;

                }
            } else {
                axis.zoomFactor = chart.model.zooming.type.toLowerCase() != "x"
                    ? previousZoomFactor * zoomRectHeight / chart.model.m_AreaBounds.Height : axis.zoomFactor;
                axis.zoomPosition = chart.model.zooming.type.toLowerCase() != "x"
                    ? previousZoomPosition + (1 - Math.abs((zoomRectHeight + (zoomY - chart.model.m_AreaBounds.Y)) / (chart.model.m_AreaBounds.Height))) * previousZoomFactor : axis.zoomPosition;
                if (parseFloat(axis.zoomFactor.toFixed(3)) <= 0.001) {
                    axis.zoomFactor = previousZoomFactor;
                    axis.zoomPosition = previousZoomPosition;

                }
            }
        }

        //Getting zoomed region data when zoomedData event fired                    
        var series = this.model._visibleSeries;
        var seriesLength = series.length;
        var zoomedData = [];
        var selectedData = [];
        var points = [];
        var type;
        var axisValueType;
        var xVisibleRange;
        var yVisibleRange;
        var pointsLength;
        for (var j = 0; j < seriesLength; j++) {
            if (series[j].visibility == "visible") {
                points = series[j].points;
                pointsLength = points.length;
                type = series[j].type.toLowerCase();
                axisValueType = new ej.axisTypes[series[j].xAxis._valueType.toLowerCase()]();
                axisValueType._calculateVisibleRange(series[j].xAxis, chart);
                axisValueType = new ej.axisTypes[series[j].yAxis._valueType.toLowerCase()]();
                axisValueType._calculateVisibleRange(series[j].yAxis, chart);
                xVisibleRange = series[j].xAxis.visibleRange;
                yVisibleRange = series[j].yAxis.visibleRange;
                for (var k = 0; k < pointsLength; k++) {
                    if ((xVisibleRange.min <= points[k].xValue && xVisibleRange.max >= points[k].xValue) && (yVisibleRange.min <= points[k].y && yVisibleRange.max >= points[k].y)) {
                        if (series[j]._hiloTypes) {
                            if (type == "rangearea" || type == "rangecolumn" || type == "waterfall" || type == "hilo")
                                zoomedData.push({ XValue: points[k].x, High: points[k].high, Low: points[k].low });
                            else
                                zoomedData.push({ XValue: points[k].x, High: points[k].high, Low: points[k].low, Open: points[k].open, Close: points[k].close });
                        }
                        else
                            zoomedData.push({ XValue: points[k].x, YValue: points[k].y });
                    }
                }
            }
            if (zoomedData.length != 0)
                selectedData.push({ selectedData: zoomedData });
            zoomedData = [];
        }

        var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = {};
        commonEventArgs.data.series = selectedData;
        this._trigger("zoomed", commonEventArgs);

        this.disableAnimation();
        this.model.legendCollapsed = false;
        this.redraw(true);

        this._enableZoomingButtons();
    },
    _cursorToDefault: function () {
        var id = "#" + this.svgObject.id;
        this.svgRenderer._setAttr($(this.svgObject).find(id + "_XAxis," + id + "_ChartArea," + id + "_YAxis," + id + "_SeriesCollection," + id + "_StriplineBehind," + id + '_StriplineOver'), { "cursor": "default" });
    },
    _cursorToPointer: function () {
        var id = "#" + this.svgObject.id;
        this.svgRenderer._setAttr($(this.svgObject).find(id + "_XAxis," + id + "_ChartArea," + id + "_YAxis," + id + "_SeriesCollection," + id + "_StriplineBehind," + id + '_StriplineOver'), { "cursor": "pointer" });
    },
    //to remove the select region on redraw
    removeMultiRect: function () {
        $(this.parentgEle).empty();
        this.model.selectedDataCollection = [];
    },
    multiSelectDataCalculation: function () {
        var chart = this, selectedData = [], selectedRectIndex = this.selectedRectIndex,
         rectX = this.oldRectX[selectedRectIndex],
         rectY = this.oldRectY[selectedRectIndex],
         rectWidth = this.oldRectWidth[selectedRectIndex],
         rectHeight = this.oldRectHeight[selectedRectIndex],
         selectFactor = 1,
         selectPosition = 0,
         seriesCollection = this.model.series,
         seriesCollectionLength = seriesCollection.length,
         axes = this.multiAxis,
         axesLength = axes.length,
         multiSelectType = this.multiSelectType,
         axis, previousSelectFactor, previousSelectPosition,
         xMin, xMax, yMin, yMax,
         visiblePoints, type, baseRange,
         start, end, isEmpty, xOriginalVisibleRange, yOriginalVisibleRange,
         areaType = this.model.AreaType.toLowerCase(),
         xValue, y, isInversed, stackYValue,
         isTransposed, selectionSettings, series;
        for (var i = 0; i < seriesCollectionLength; i++) {
            series = seriesCollection[i];
            xOriginalVisibleRange = series.xAxis.visibleRange;
            yOriginalVisibleRange = series.yAxis.visibleRange;
            var xAxisName = axes.some((function (val) {
                return val.name.toLowerCase() == series._xAxisName.toLowerCase();
            }));
            var yAxisName = axes.some((function (val) {
                return val.name.toLowerCase() == series._yAxisName.toLowerCase();
            }));

            selectionSettings = series.selectionSettings;
            if ((xAxisName && yAxisName) && series.visibility.toLowerCase() == 'visible') {
                for (var k = 0; k < axesLength; k++) {
                    axis = axes[k];
                    previousSelectFactor = selectFactor;
                    previousSelectPosition = selectPosition;
                    if (axis.orientation.toLowerCase() == "horizontal") {
                        this.selectFactor = selectionSettings.rangeType.toLowerCase() != "y"
                            ? previousSelectFactor * (rectWidth / (this.multiAxis[k].width)) : selectFactor;
                        this.selectPosition = selectionSettings.rangeType.toLowerCase() != "y"
                            ? previousSelectPosition + Math.abs((rectX - this.multiAxis[k].x) / (this.multiAxis[k].width)) * previousSelectFactor : selectPosition;
                        if (parseFloat(selectFactor.toFixed(3)) <= 0.001) {
                            this.selectFactor = previousSelectFactor;
                            this.selectPosition = previousSelectPosition;
                        }
                    }
                    else {
                        this.selectFactor = selectionSettings.rangeType.toLowerCase() != "x"
                            ? previousSelectFactor * rectHeight / this.multiAxis[k].height : selectFactor;
                        this.selectPosition = selectionSettings.rangeType.toLowerCase() != "x"
                            ? previousSelectPosition + (1 - Math.abs((rectHeight + (rectY - this.multiAxis[k].y)) / (this.multiAxis[k].height))) * previousSelectFactor : selectPosition;
                        if (parseFloat(selectFactor.toFixed(3)) <= 0.001) {
                            this.selectFactor = previousSelectFactor;
                            this.selectPosition = previousSelectPosition;
                        }
                    }
                    axis.visibleRange = $.extend(true, {}, axis.actualRange);
                    if (this.selectFactor < 1 || this.selectPosition > 0) {
                        if (axis.valueType == "logarithmic") baseRange = axis.visibleRange;
                        else baseRange = axis.actualRange;
                        this.selectFactor = this.selectFactor > 1 ? 1 : (this.selectFactor < 0 ? 0 : this.selectFactor);
                        this.selectPosition = this.selectPosition < 0 ? 0 : (this.selectPosition > 1 ? 1 : this.selectPosition);
                        if (axis.isInversed) {
                            start = axis.actualRange.max - this.selectPosition * axis.actualRange.delta;
                            end = start - this.selectFactor * axis.actualRange.delta;
                            isInversed = true;
                        }
                        else {
                            start = Math.abs(axis.actualRange.min + this.selectPosition * axis.actualRange.delta);
                            end = start + this.selectFactor * axis.actualRange.delta;
                        }
                        if (start < baseRange.min) {
                            end = end + (baseRange.min - start);
                            start = baseRange.min;
                        }
                        if (end > baseRange.max) {
                            start = start - (end - baseRange.max);
                            end = baseRange.max;
                        }
                        if (axis.valueType == "logarithmic") {
                            start = Math.pow(10, start);
                            end = Math.pow(10, end);
                        }
                        axis.visibleRange.min = Math.min(start, end);
                        axis.visibleRange.max = Math.max(start, end);
                    }
                }
                visiblePoints = series._visiblePoints;
                type = series.type.toLowerCase(), isTransposed = series.isTransposed;
                xMin = series.xAxis.visibleRange.min; xMax = series.xAxis.visibleRange.max;
                yMin = series.yAxis.visibleRange.min; yMax = series.yAxis.visibleRange.max;
                if (ej.util.isNullOrUndefined(selectedData)) selectedData = [];
                switch (multiSelectType) {
                    case 'x':
                        for (var k = 0; k < visiblePoints.length; k++) {
                            visiblePoints[k].seriesIndex = i;
                            isEmpty = visiblePoints[k].isEmpty;
                            xValue = visiblePoints[k].xValue;
                            y = visiblePoints[k].y;
                            if (series.xAxis.isInversed || series.yAxis.isInversed) {
                                if (type.indexOf('bar') >= 0) {
                                    if (type.indexOf('stacking') >= 0) {
                                        stackYValue = series.stackedValue.EndValues[k];
                                        if (!isEmpty && yMax >= stackYValue && yMin <= stackYValue)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                    else {
                                        if (type == 'waterfall' && !isEmpty && yMax >= visiblePoints[k].YValues[0] && yMin <= visiblePoints[k].YValues[0])
                                            selectedData.push(visiblePoints[k]);
                                        else if (!isEmpty && yMax >= y && yMin <= y)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                }
                                else {
                                    if (!isEmpty && xMax >= xValue && xMin <= xValue)
                                        selectedData.push(visiblePoints[k]);
                                }
                            }
                            else {
                                if (isTransposed && (type.indexOf('bar') >= 0)) {
                                    if (!isEmpty && xMin <= xValue && xMax >= xValue)
                                        selectedData.push(visiblePoints[k]);
                                }
                                else if ((type.indexOf('bar') >= 0) || ((series.isTransposed) && (!(type.indexOf('bar') >= 0)))) {
                                    if (type.indexOf('stacking') >= 0) {
                                        stackYValue = series.stackedValue.EndValues[k];
                                        if (!isEmpty && yMin <= stackYValue && yMax >= stackYValue)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                    else {
                                        if (type == 'waterfall' && !isEmpty && yMin <= visiblePoints[k].YValues[0] && yMax >= visiblePoints[k].YValues[0])
                                            selectedData.push(visiblePoints[k]);
                                        else if (!isEmpty && yMin <= y && yMax >= y)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                }
                                else {
                                    if (!isEmpty && xMin <= xValue && xMax >= xValue)
                                        selectedData.push(visiblePoints[k]);
                                }
                            }
                        }
                        break;
                    case 'y':
                        for (var k = 0; k < visiblePoints.length; k++) {
                            visiblePoints[k].seriesIndex = i;
                            isEmpty = visiblePoints[k].isEmpty;
                            xValue = visiblePoints[k].xValue;
                            y = visiblePoints[k].y;
                            if (series.xAxis.isInversed || series.yAxis.isInversed) {
                                if (type.indexOf('bar') >= 0) {
                                    if (!isEmpty && xMax >= xValue && xMin <= xValue)
                                        selectedData.push(visiblePoints[k]);
                                }
                                else {
                                    if (type.indexOf('stacking') >= 0) {
                                        stackYValue = series.stackedValue.EndValues[k];
                                        if (!isEmpty && yMin <= stackYValue && yMax >= stackYValue)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                    else {
                                        if (type == 'waterfall' && !isEmpty && yMax >= visiblePoints[k].YValues[0] && yMin <= visiblePoints[k].YValues[0])
                                            selectedData.push(visiblePoints[k]);
                                        else if (!isEmpty && yMax >= y && yMin <= y)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                }
                            }
                            else {
                                if (isTransposed && (type.indexOf('bar') >= 0)) {
                                    if (type.indexOf('stacking') >= 0) {
                                        stackYValue = series.stackedValue.EndValues[k];
                                        if (!isEmpty && yMin <= stackYValue && yMax >= stackYValue)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                    else {
                                        if (type == 'waterfall' && !isEmpty && yMin <= visiblePoints[k].YValues[0] && yMax >= visiblePoints[k].YValues[0])
                                            selectedData.push(visiblePoints[k]);
                                        else if (!isEmpty && yMin <= y && yMax >= y)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                }
                                else if ((type.indexOf('bar') >= 0) || ((series.isTransposed) && (!(type.indexOf('bar') >= 0)))) {
                                    if (!isEmpty && xMin <= xValue && xMax >= xValue)
                                        selectedData.push(visiblePoints[k]);
                                }
                                else {
                                    if (type.indexOf('stacking') >= 0) {
                                        stackYValue = series.stackedValue.EndValues[k];
                                        if (!isEmpty && yMin <= stackYValue && yMax >= stackYValue)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                    else {
                                        if (type == 'waterfall' && !isEmpty && yMin <= visiblePoints[k].YValues[0] && yMax >= visiblePoints[k].YValues[0])
                                            selectedData.push(visiblePoints[k]);
                                        else if (!isEmpty && yMin <= y && yMax >= y)
                                            selectedData.push(visiblePoints[k]);
                                    }
                                }
                            }
                        }
                        break;
                    case 'xy':
                        for (var k = 0; k < visiblePoints.length; k++) {
                            visiblePoints[k].seriesIndex = i;
                            isEmpty = visiblePoints[k].isEmpty;
                            xValue = visiblePoints[k].xValue;
                            y = visiblePoints[k].y;
                            if (type.indexOf('stacking') >= 0) {
                                stackYValue = series.stackedValue.EndValues[k];
                                if (!isEmpty && xMax >= xValue && xMin <= xValue && yMin <= stackYValue && yMax >= stackYValue)
                                    selectedData.push(visiblePoints[k]);
                            }
                            else {
                                if (type == 'waterfall' && !isEmpty && xMax >= xValue && xMin <= xValue && yMin <= visiblePoints[k].YValues[0] && yMax >= visiblePoints[k].YValues[0])
                                    selectedData.push(visiblePoints[k]);
                                else if (!isEmpty && xMax >= xValue && xMin <= xValue && yMin <= y && yMax >= y)
                                    selectedData.push(visiblePoints[k]);
                            }
                        }
                        break;
                }
            }
            series.xAxis.visibleRange = xOriginalVisibleRange;
            series.yAxis.visibleRange = yOriginalVisibleRange;
        }
        var currentIndex = this.currentIndex;
        if (ej.util.isNullOrUndefined(this.model.selectedDataCollection)) this.model.selectedDataCollection = [];
        if (this.removeRect) this.model.selectedDataCollection.splice(currentIndex, 1);
        else if (this.rectPan || this.resize) {
            this.model.selectedDataCollection[currentIndex] = 0;
            this.model.selectedDataCollection[currentIndex] = selectedData;
        }
        else this.model.selectedDataCollection[this.model.selectedDataCollection.length] = selectedData;
        //trigger rangeSelected event to get the selected region's data
        var commonloadEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonloadEventArgs.data = {};
        commonloadEventArgs.data.selectedData = selectedData;
        commonloadEventArgs.data.selectedDataCollection = this.model.selectedDataCollection;
        this._trigger("rangeSelected", commonloadEventArgs);
    },
    multiSelectMouseUp: function (evt) {
        if (this._isMultiSelect && (this.multiSelectMode == 'range')) {
            var selectRectWidth, selectRectHeight, selectRectX, selectRectY, cx, cy, index,
            containerSvg = this.svgObject.id, selectedRectIndex = this.selectedRectIndex,
            selectRectId = "#" + containerSvg + "_selectRect",
            selectRectWidth = parseInt($(selectRectId + selectedRectIndex).attr("width")),
            selectRectHeight = parseInt($(selectRectId + selectedRectIndex).attr("height")),
            selectRectX = parseInt($(selectRectId + selectedRectIndex).attr("x")),
            selectRectY = parseInt($(selectRectId + selectedRectIndex).attr("y"));
            if ((this.multiSelectDraw || !this.removeRect || !this.resize || !this.rectPan) && (selectRectWidth > 0 && selectRectHeight > 0)) {
                var rightRectOptions = {
                    'id': containerSvg + '_resize_rightRect' + selectedRectIndex,
                    'x': selectRectX + selectRectWidth - 5,
                    'y': selectRectY + 10,
                    'width': 10,
                    'height': selectRectHeight - 20 > 0 ? selectRectHeight - 20 : 0,
                    'fill': "transparent",
                    'stroke': "transparent",
                    'stroke-width': 2,
                    'cursor': 'e-resize'
                };
                this.svgRenderer.drawRect(rightRectOptions, this.gEle);
                var bottomRectOptions = {
                    'id': containerSvg + '_resize_bottomRect' + selectedRectIndex,
                    'x': selectRectX,
                    'y': selectRectY + selectRectHeight - 5,
                    'width': selectRectWidth - 10 > 0 ? selectRectWidth - 10 : 0,
                    'height': 10,
                    'fill': "transparent",
                    'stroke': "transparent",
                    'stroke-width': 2,
                    'cursor': 's-resize'
                };
                this.svgRenderer.drawRect(bottomRectOptions, this.gEle);
                var leftRectOptions = {
                    'id': containerSvg + '_resize_leftRect' + selectedRectIndex,
                    'x': selectRectX - 5,
                    'y': selectRectY,
                    'width': 10,
                    'height': selectRectHeight,
                    'fill': "transparent",
                    'stroke': "transparent",
                    'stroke-width': 2,
                    'cursor': 'w-resize'
                };
                this.svgRenderer.drawRect(leftRectOptions, this.gEle);
                var topRectOptions = {
                    'id': containerSvg + '_resize_topRect' + selectedRectIndex,
                    'x': selectRectX,
                    'y': selectRectY - 5,
                    'width': selectRectWidth - 10 > 0 ? selectRectWidth - 10 : 0,
                    'height': 10,
                    'fill': "transparent",
                    'stroke': "transparent",
                    'stroke-width': 2,
                    'cursor': 'n-resize'
                };
                this.svgRenderer.drawRect(topRectOptions, this.gEle);
                var bottomRightCornerCircleOptions = {
                    'id': containerSvg + '_resize_bottomRightCornerCircle' + selectedRectIndex,
                    'cx': selectRectX + selectRectWidth,
                    'cy': selectRectY + selectRectHeight,
                    'r': 10,
                    'fill': "transparent",
                    'stroke': "transparent",
                    'stroke-width': 2,
                    'cursor': 'se-resize'
                };
                this.svgRenderer.drawCircle(bottomRightCornerCircleOptions, this.gEle);
                var topRightCornerCircleOptions = {
                    'id': containerSvg + '_closeTopRightCornerCircle' + selectedRectIndex,
                    'cx': selectRectX + selectRectWidth,
                    'cy': selectRectY,
                    'r': 10,
                    'fill': "white",
                    'stroke': "#2988d6",
                    'stroke-width': 2,
                    'cursor': 'pointer'
                };
                this.svgRenderer.drawCircle(topRightCornerCircleOptions, this.gEle);
                var closingPathOptions = {
                    'id': containerSvg + '_closePath' + selectedRectIndex,
                    'x1': selectRectX + selectRectWidth - 4,
                    'y1': selectRectY - 4,
                    'x2': selectRectX + selectRectWidth + 4,
                    'y2': selectRectY + 4,
                    'stroke': "#2988d6",
                    'stroke-width': 2,
                    'cursor': 'pointer'
                };
                this.svgRenderer.drawLine(closingPathOptions, this.gEle);
                var closingPathOppositeOptions = {
                    'id': containerSvg + '_closePathOpposite' + selectedRectIndex,
                    'x1': selectRectX + selectRectWidth + 4,
                    'y1': selectRectY - 4,
                    'x2': selectRectX + selectRectWidth - 4,
                    'y2': selectRectY + 4,
                    'stroke': "#2988d6",
                    'stroke-width': 2,
                    'cursor': 'pointer'
                };
                this.svgRenderer.drawLine(closingPathOppositeOptions, this.gEle);
                cx = [16, 10, 4, 10, 4, 4];
                cy = [4, 4, 4, 10, 10, 16];
                index = ["a", "b", "c", "d", "e", "f"];
                for (var t = 0; t < 6; t++) {
                    var gripOptions = {
                        'id': containerSvg + '_gripCircle_' + index[t] + selectedRectIndex,
                        'cx': selectRectX + selectRectWidth - cx[t],
                        'cy': selectRectY + selectRectHeight - cy[t],
                        'r': 0.4,
                        'stroke': "#5B5B5B",
                        'stroke-width': 2,
                    }
                    this.svgRenderer.drawCircle(gripOptions, this.gripCollection);
                }
                if ((this.gripCollection != null))
                    $(this.gripCollection).appendTo(this.gEle);
                $("#" + containerSvg + "_gripCollection" + selectedRectIndex).css({ 'visibility': 'hidden' });
            }
            if (ej.util.isNullOrUndefined(this.oldRectX)) {
                this.oldRectX = []; this.oldRectY = []; this.oldRectWidth = []; this.oldRectHeight = [];
                this.oldReRightRectX = []; this.oldReTopRectY = []; this.oldReBottomRectY = [];
            }
            this.oldRectX[selectedRectIndex] = parseInt($(selectRectId + selectedRectIndex).attr('x'));
            this.oldRectY[selectedRectIndex] = parseInt($(selectRectId + selectedRectIndex).attr('y'));
            this.oldRectWidth[selectedRectIndex] = parseInt($(selectRectId + selectedRectIndex).attr('width'));
            this.oldRectHeight[selectedRectIndex] = parseInt($(selectRectId + selectedRectIndex).attr('height'));
            this.oldReRightRectX[selectedRectIndex] = parseInt($("#" + containerSvg + "_resize_rightRect" + selectedRectIndex).attr('x'));
            this.oldReTopRectY[selectedRectIndex] = parseInt($("#" + containerSvg + "_resize_topRect" + selectedRectIndex).attr('y'));
            this.oldReBottomRectY[selectedRectIndex] = parseInt($("#" + containerSvg + "_resize_bottomRect" + selectedRectIndex).attr('y'));
            this.oldMultiSelectType = this.multiSelectType;
            if (this.resize || this.rectPan) {
                //to remove the grip after resizing at the bottom right corner
                if (this.resize)
                    $("#" + this.svgObject.id + "_gripCollection" + selectedRectIndex).attr({ 'transform': "" });
                $("#" + containerSvg + "_closeTopRightCornerCircle" + selectedRectIndex).css({ 'display': 'inline' });
                $("#" + containerSvg + "_closePath" + selectedRectIndex).css({ 'display': 'inline' });
                $("#" + containerSvg + "_closePathOpposite" + selectedRectIndex).css({ 'display': 'inline' });
                $("#" + containerSvg + '_resize_rightRect' + selectedRectIndex).css({ 'cursor': 'e-resize' });
                $("#" + containerSvg + '_resize_leftRect' + selectedRectIndex).css({ 'cursor': 'w-resize' });
                $("#" + containerSvg + '_resize_bottomRect' + selectedRectIndex).css({ 'cursor': 's-resize' });
                $("#" + containerSvg + '_resize_topRect' + selectedRectIndex).css({ 'cursor': 'n-resize' });
            }
            this.drag = false;
            if (this.removeRect) {
                $("#" + containerSvg + "_selectedRectGroup" + selectedRectIndex).remove();
                if (this.parentgEle.childNodes.length <= 0) $(this.parentgEle).remove();
            }
            if ((this.multiSelectDraw || this.removeRect || this.resize || this.rectPan) && (selectRectWidth > 0 && selectRectHeight > 0)) {
                this.multiSelectDraw = false;
                this.multiSelectDataCalculation(evt);
            }
            if (this.resize) this.resize = false;
            if (this.rectPan) this.rectPan = false;
            this.removeRect = false;
            this.enableTrackBall();
        }
    },
    chartMouseUp: function (evt) {
        if (this.isTouch(evt)) {
            this.model.touchCross = false;
            this.chartMouseUpTouch(evt);          
        }
		if (!this.currentPageX && this.panning) {
            var mouseDownCords = this.calMousePosition(evt);
            this.currentPageX = mouseDownCords.X;
            this.currentPageY = mouseDownCords.Y;
		}
		
		var chart = this;		
		var model = this.model;
		this.mousedownPointX = this.mousedownPointY = null;
		$("[id*=" + "_PreviewSeries" + "]").remove();
		$("[id*=" + "_Marker" + "]").remove();
		if (chart.dragPoint) {		  
		    var i = this.dragIndex.seriesIndex,
		        chartSeries = model._visibleSeries[i];
		    if (!this.model.enableCanvasRendering) {
		        if (this.gPreviewSeriesGroupEle) {
		            $(this.svgObject).find("#" + this.svgObject.id + "_PreviewSeriesGroup_" + i).remove();
		            if (this.gPreviewSeriesGroupEle.childNodes.length > 0)
		                this.gPreviewSeriesGroupEle.removeChild(this.gPreviewSeriesGroupEle.childNodes[0]);
		        }
		    }
		    var commonDragEventArgs, valAxis, srIndex, ptIndex;
		    this.dragPoint = chartSeries.dragPoint =false;
		        var draggedPoints = this._getDraggedPoint(chartSeries, this.mousemoveX, this.mousemoveY),
                   xPoint = draggedPoints.X,
                   yPoint = draggedPoints.Y;
		        srIndex = chartSeries.data.seriesIndex,
                ptIndex = chartSeries.data.pointIndex;
		       
		    var oldValue = { X: this.commonDragEventArgs.data.oldValue.X, Y: this.commonDragEventArgs.data.oldValue.Y },
                    newValue = { X: xPoint, Y: yPoint };
		        commonDragEventArgs = $.extend({}, this.commonDragEventArgs);
		        commonDragEventArgs.data = { series: chartSeries, seriesIndex: srIndex, pointIndex: ptIndex, oldValue: oldValue, newValue: newValue };
		        this._trigger("dragEnd", commonDragEventArgs);
		        chart.commonDragEventArgs = commonDragEventArgs;
		        chart._changeDraggingPoints(chartSeries, ptIndex, commonDragEventArgs.data.newValue.X, commonDragEventArgs.data.newValue.Y);
		        chartSeries.region = null;
		        this.redraw();		// to redraw the chart after changing the points  
        }
        if (this.multiSelectAreaType == 'cartesianaxes' && (!model.zooming.enable) && (!model.enableCanvasRendering))
            this.multiSelectMouseUp(evt);
        var chart = this;
        if (model.zooming.enable && model.AreaType == "cartesianaxes") {
            var zoomRect = $("#" + this.svgObject.id + "_ZoomArea");
            if (zoomRect[0]) {
                if (model.enableCanvasRendering) {
                    var zoomArea = zoomRect[0].getClientRects()[0];
                    var zoomRectWidth = zoomArea.width;
                    var zoomRectHeight = zoomArea.height;
                } else {
                    var $zoomRect = $(zoomRect);
                    var zoomRectWidth = parseFloat(this.svgRenderer._getAttrVal($zoomRect, "width"));
                    var zoomRectHeight = parseFloat(this.svgRenderer._getAttrVal($zoomRect, "height"));
                }
            }
            if (zoomRectWidth > 0 && zoomRectHeight > 0) {
                chart.doZoom(zoomRect, zoomRectWidth, zoomRectHeight);
            }
            else
                this.drag = false;
            if (!chart.panning)
                this.enableTrackBall();
        }
       // Panning is done on mouse up for other devices and when deferredZoom is set to true
        var id = this.svgObject.id;
        var parentId = ej.util.isNullOrUndefined(evt.target.parentNode) ? "" : evt.target.parentNode.id;

        //condition to find the buttons
        if (parentId == id + "_ResetZoom" || parentId == id + '_ZoomBtn' || evt.target.id == id + "_ResetZoom" || evt.target.id == id + '_ZoomBtn') {
            this.panning = false;
            this.model._chartAreaZoom = false;
        }

        //Panning for other devices
        if ((ej.isTouchDevice() ||model.zooming.enableDeferredZoom) && this.panning && this.doPan && model.AreaType == "cartesianaxes") {
            var oDelta;
            oDelta = {
                'x': this.oPreviousCoords.x - this.currentPageX,
                'y': this.oPreviousCoords.y - this.currentPageY
            };

            this.oPreviousCoords = {
                'x': this.currentPageX,
                'y': this.currentPageY
            };
            $.each(model._axes, function (index, axis) {
                var currentScale = Math.max(1 / ej.EjSvgRender.utils._minMax(axis.zoomFactor, 0, 1), 1);
                chart.translate(axis, (oDelta.x), (oDelta.y), currentScale);
            });
            this.model.legendCollapsed = false;
            this.redraw(true, true, evt.target); //to avoid touch event termination in mobiles / deferred pan
            this._cursorToPointer();
            this._enableZoomingButtons();
        }
        
        if (this.doPan)
            this.doPan = false;
        
        this.rotateActivate = false;
    },
    multiSelectMouseDown: function (evt) {
        this.multiSelectAreaType = this.model.AreaType.toLowerCase();
        var model = this.model, chartX = model.m_AreaBounds.X, chartWidth = model.m_AreaBounds.Width,
        chartY = model.m_AreaBounds.Y, chartHeight = model.m_AreaBounds.Height, mouseDownCords = this.calMousePosition(evt);
        //to check whether the click is made within the chart area
        if (this.multiSelectAreaType == 'cartesianaxes' && (!model.zooming.enable) && (!model.enableCanvasRendering)
             && mouseDownCords.X >= chartX && mouseDownCords.X < (chartX + chartWidth) && mouseDownCords.Y < (chartY + chartHeight) && mouseDownCords.Y >= chartY) {
            var seriesCollection = this.model.series,
                seriesCollectionLength = seriesCollection.length,
                id, mouseDownCords,
                containerSvg = this.svgObject.id,
             selectMode = seriesCollection.some((function (val) {
                 return val.selectionSettings.mode.toLowerCase() == 'range';
             }));
            this._isMultiSelect = seriesCollection.some((function (val) {
                return val.selectionSettings.enable == true && val.selectionSettings.mode.toLowerCase() == "range";
            }));
            if (selectMode) this.multiSelectMode = 'range';
            for (var i = 0; i < seriesCollectionLength; i++) {
                if ((seriesCollection[i].selectionSettings.enable == true) && (seriesCollection[i].selectionSettings.mode.toLowerCase() == 'range'))
                    this.multiSelectType = seriesCollection[i].selectionSettings.rangeType.toLowerCase();
            }
            if (this._isMultiSelect && this.multiSelectMode == 'range') {
                this.disableTrackBall();
                mouseDownCords = this.calMousePosition(evt);
                this.mouseDownX = mouseDownCords.X;
                this.mouseDownY = mouseDownCords.Y;
                this.drag = true;
                if (($(this.parentgEle).find("g").length < 1))
                    this.selectedRectIndex = 0;
                else {
                    id = $(this.parentgEle).find("g").last().attr("id");
                    matchStr = containerSvg + "_gripCollection";
                    id = parseInt(id.substr(matchStr.length));
                    this.selectedRectIndex = id + 1;
                }
                if ($(this.parentgEle).find("g").length == 0) {
                    this.parentgEle = this.svgRenderer.createGroup({ 'id': containerSvg + '_rectSelectionGroup' });
                }
                this.gEle = this.svgRenderer.createGroup({ 'id': containerSvg + '_selectedRectGroup' + this.selectedRectIndex });
                if ($(this.gripCollection).find("g").length == 0)
                    this.gripCollection = this.svgRenderer.createGroup({ 'id': containerSvg + '_gripCollection' + this.selectedRectIndex });                
                if (evt.target.id.indexOf("resize") >= 0) {
                    id = evt.target.id.split("resize")[1].match(/\d+/)[0];
                    this.selectedRectIndex = eval(id);
                }
                if (evt.target.id.indexOf("close") >= 0) {
                    id = evt.target.id.split("close")[1].match(/\d+/)[0];
                    this.selectedRectIndex = eval(id);
                }
                if ((evt.target.id.indexOf(this.svgObject.id + "_selectRect") >= 0)) {
                    matchStr = this.svgObject.id + "_selectRect";
                    this.selectedRectIndex = parseInt(evt.target.id.substr(matchStr.length));
                }
                this.currentIndex = $(evt.target.parentNode).index();
                var axes = this.model._axes,
                axesLength = axes.length, axis,
                mouseMoveCords = this.calMousePosition(evt),
                mouseMoveX = mouseMoveCords.X,
                mouseMoveY = mouseMoveCords.Y;
                this.multiAxis = []
                for (var k = 0; k < axesLength; k++) {
                    axis = axes[k];
                    if ((mouseMoveX > axis.Location.X1) && (mouseMoveX < axis.Location.X2))
                        this.multiAxis.push(axis);
                    if ((mouseMoveY < axis.Location.Y1) && (mouseMoveY > axis.Location.Y2))
                        this.multiAxis.push(axis);
                }
            }
        }
    },
 //Triggers while start dragging column or bar points
      _grab: function (chartSeries, chartObj, srIndex, ptIndex,point) {		
        commonDragEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonDragEventArgs.data = {seriesIndex: srIndex, pointIndex: ptIndex, currentPoint: point};
        chartObj._trigger("dragStart", commonDragEventArgs);
        chartSeries.data = commonDragEventArgs.data;
        this.commonDragEventArgs = commonDragEventArgs;
        this.mousedownPointX = this.mousedownPointY = null;
      },
 _enableDragging: function(chartSeries,seriesIndex,e){
	 var chartObj = this, closestXyPoint, data,
         type = chartSeries.type.toLowerCase(),
         areaType = chartObj.model.AreaType,      
         visibility = chartSeries.visibility.toLowerCase();	     
            if ( this.mousedownPointX && this.mousedownPointY && areaType == "cartesianaxes" && !this.model.enable3D &&visibility == 'visible' &&(type=="line"|| type=="spline"||type=="area"||
                type=="stepline"|| type=="steparea" || type=="splinearea" || type=="column" || type=="bar" || type=="bubble" || type=="scatter")) {
                var serY = [],  serX = [];                  
				closestXyPoint = this.getClosesPointXY(serX, serY, chartSeries, this.mousedownPointX, this.mousedownPointY, e);
                    this.mousemoveX = this.mousedownPointX;
                    this.mousemoveY = this.mousedownPointY;
                    data = this.GetSeriesPoint(e);
                    if (!ej.util.isNullOrUndefined(closestXyPoint.point)) {                       
                        this.dragPoint = chartSeries.dragPoint = true;
                        closestXyPoint.seriesIndex = seriesIndex;
                        chartSeries.pointData = closestXyPoint;
                       	var point = { xValue: closestXyPoint.point.xValue, yValue: closestXyPoint.point.YValues };
                        chartObj._grab(chartSeries, chartObj, seriesIndex, closestXyPoint.index, point);
                        this.dragIndex = { pointIndex: closestXyPoint.index, seriesIndex: seriesIndex };                      
                    }
                    if (!ej.util.isNullOrUndefined(data)) {
                        var region = data.region;
							if (seriesIndex == region.SeriesIndex) {
							    chartSeries.region = data.region;
							    this.dragPoint = chartSeries.dragPoint = true;
							    var xVal = chartSeries._visiblePoints[region.Region.PointIndex].xValue,
                                    yVal = chartSeries._visiblePoints[region.Region.PointIndex].YValues,
                                    point = { xValue: xVal, yValue: yVal };
							    chartObj._grab(chartSeries, chartObj, region.SeriesIndex, region.Region.PointIndex, point);
							    this.dragIndex = { pointIndex: region.Region.PointIndex, seriesIndex: region.SeriesIndex };                     
                            }
					}               
          }                                  
    },
 chartMouseDown: function (e) {
  
        //this.cancelEvent(e);   
      
        var model = this.model,
            matchStr = this._id + '_scrollbar' + '_',
            parentNodeId = (e.target.parentNode && e.target.parentNode.id) ? e.target.parentNode.id : '',
            selectionIndex = parentNodeId.indexOf(matchStr) > -1 ? parseInt(parentNodeId.substr(matchStr.length)) : NaN,
            isZoom = this.isZoomButtonHovered(e.target);
            axes = model._axes,
            chart = this,            
            mouseDownCords = this.calMousePosition(e),
            browserInfo = this.model.browserInfo;
            this.mousedownPointX = mouseDownCords.X;
            this.mousedownPointY = mouseDownCords.Y;
            if ("which" in e)  // Gecko (Firefox), WebKit (Safari/Chrome) & Opera
                this.chartRightClick = e.which == 3;
            else if ("button" in e)  // IE, Opera 
                this.chartRightClick = e.button == 2;
        if (!isNaN(selectionIndex) && !ej.util.isNullOrUndefined(selectionIndex))
            axes[selectionIndex].previousRange = $.extend(true, {}, model._axes[selectionIndex].visibleRange);       
   
        this.mousemoveX = this.mouseDownX = mouseDownCords.X;
        this.mousemoveY = this.mouseDownY = mouseDownCords.Y;                    
        if (this.isTouch(e)) {            
            this.model.event = e;
            this.model.touchCross = true;
            //this.cancelEvent(e);  
            if ($.finish)
                $(this.model.trackerElement).finish();
            else
                $(this.model.trackerElement).stop(true, true);
            this.model.tapNum = this.model.tapNum || 0;          
            if (!isZoom)
                this.doubleTap(e);           
            if (chart.model.crosshair.visible && !isZoom) {                
                var timer = setTimeout(function () {                   
                    var zoom = $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + '_ZoomArea'),
                        padding = chart.model.elementSpacing / 2,
                        pointer = chart.getEvent(chart.model.event), currX = pointer.pageX,
                        currY = pointer.pageY;                    
                    if (chart.model.touchCross && !chart.panning && Math.abs(currX - chart.model.cachedX) < padding && Math.abs(currY - chart.model.cachedY) < padding && (zoom.length == 0 || (parseFloat($(zoom).attr("width")) == 0 || parseFloat($(zoom).attr("height")) == 0))) {
                        chart.chartInteractiveBehavior(e);
                        chart.model.crosshairMoved = true;
                        chart.drag = false;
                    }
                    

                }, 500);

            }
          
        }

        if (this.model.enable3D && this.model.enableRotation)
            this.rotateActivate = true;

        if (!this.svgRenderer.vmlNamespace) {
            this.oPreviousCoords = {};
            if (e.target.id.indexOf("resize") >= 0) {
                id = e.target.id.split("resize")[1].match(/\d+/)[0];
                this.selectedRectIndex = eval(id);
                this.multiSelectMouseDownId = e.target.id;
                this.resize = true;
            }
            if (e.target.id.indexOf("close") >= 0) {
                id = e.target.id.split("close")[1].match(/\d+/)[0];
                this.selectedRectIndex = eval(id);
                this.removeRect = true;
            }
            if ((e.target.id.indexOf(this.svgObject.id + "_selectRect") >= 0)) {
                matchStr = this.svgObject.id + "_selectRect";
                this.selectedRectIndex = parseInt(e.target.id.substr(matchStr.length));
            }
            if (e.target.id == this.svgObject.id + '_selectRect' + this.selectedRectIndex) {
                this.rectPan = true;
                this.PreviousCoords = {
                    'X': e.pageX, 'Y': e.pageY
                }
            }
            if(!this.isTouch(e))
            this.multiSelectMouseDown(e);
            var parent = this.svgRenderer._getAttrVal($(e.target).parent(), "id");
            var isZoomToolkit = parent != this.svgObject.id + "_ZoomBtn" && parent != this.svgObject.id + "_ZoomInBtn" && parent != this.svgObject.id + "_ZoomOutBtn" && parent != this.svgObject.id + "_ResetZoom" && parent != this.svgObject.id + "_PanBtn"; 
            if (isZoomToolkit && this.model.zooming.enable && !this.model.isLazyZooming && !(this.panning) && this.model.AreaType == "cartesianaxes") {
             
                if (this.mouseDownX >= this.model.m_AreaBounds.X && this.mouseDownX < (model.m_AreaBounds.X + model.m_AreaBounds.Width) && this.mouseDownY < (model.m_AreaBounds.Y + model.m_AreaBounds.Height) && this.mouseDownY >= model.m_AreaBounds.Y && !this.isTouch(e)) {
                    if(isNaN(selectionIndex) || ej.util.isNullOrUndefined(selectionIndex))
                        this.drag = true;
                    this.disableTrackBall();
                }


            }
            else if (isZoomToolkit && this.panning || $(e.target)[0].className == "e-hhandle e-box") {
                var mousePanCords = this.calMousePosition(e);
                this.mousePanX = mousePanCords.X;
                this.mousePanY = mousePanCords.Y;                
                if (this.mousePanX >= model.m_AreaBounds.X && this.mousePanX < (model.m_AreaBounds.X + model.m_AreaBounds.Width) && this.mousePanY < (model.m_AreaBounds.Y + model.m_AreaBounds.Height + 18) && this.mousePanY >= model.m_AreaBounds.Y) {
                    this.doPan = true;
                   
                }
            }
            if(this.rotateActivate ||  this.doPan)
                this.oPreviousCoords = {
                    'x': e.pageX,
                    'y': e.pageY
                };
        }
     
    },
    chartMouseLeave: function (evt) {            
              
        this.cancelEvent(evt);

            if (!this.isTouch(evt)) {
                // Changes the visibility to hidden

                $("[id*=" + "_TrackSymbol" + "]").remove();

                this._removeHighlight();

                this._removeTrackBall();

                $("#" + this.svgObject.id + "_TrackToolTip").hide();

                $("#" + this._id + "_tooltip").remove();
                if (($(".tooltipDiv" + this._id).hasClass(this.svgObject.id)))
                    $(".tooltipDiv" + this._id).remove();
            }



            // chartMouseLeave event           
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY }, size: { height: this.model.svgHeight, width: this.model.svgWidth }, id: evt.target.id, pageX: evt.pageX, pageY: evt.pageY };
            this._trigger("chartMouseLeave", commonEventArgs);         
        
    }, 
  

    _doClick: function (evt) {
		this.drag = false;
        if(!this.model.crosshairMoved)
        this._removeHighlight();
        if (!this.model.selectedDataPointIndexes)
            this.model.selectedDataPointIndexes = [];
        this.model.clusterPoints = [];
        this.model._isStateChaged = false;
        var seriesIndex, pointIndex, seriesLenth, chartSeries, data, pointer = this.getEvent(evt),
        currX = pointer.pageX,	   
        currY = pointer.pageY,
        padding = 10,
		targetId = evt.target.id,
	    svgObjectId = this.svgObject.id,
        seriesCollection = this.model._visibleSeries,
		isZoom = this.isZoomButtonHovered(evt.target),
		targetid = evt.target.id;
			 
           //Set current seriesCollection Selection type for selection state maintains            
			seriesLength = seriesCollection.length;           
           var isMultiSelection, mode, commonEventArgs, text, getIndex;
           data = this.GetSeriesPoint(evt);
           if (data) {
               seriesIndex = data.region.SeriesIndex;
               pointIndex = data.region.Region.PointIndex;
           }else {
               //Getting SeriesIndex and PointIndex for Path element type series when marker and dataLabels visible
               if (this.model.selectionEnable) {
                   if (!this.model.enable3D && !(evt.target.id.indexOf('LegendItem') != -1) && this.model.AreaType != 'none') {
                       text = evt.target.id;
                       getIndex = text.match(/(\d+)/g);
                       if (getIndex && (text.indexOf('symbol') != -1 || text.indexOf('Series') != -1) && !(text.indexOf('Text') != -1)) {
                           seriesIndex = parseInt(getIndex[0]);
                           pointIndex = isNaN(parseInt(getIndex[1])) ? 0 : parseInt(getIndex[1]);
                       } else if (getIndex && (text.indexOf('Text') != -1 || text.indexOf('dataLabel') != -1)) {
                           seriesIndex = parseInt(getIndex[0].charAt(0));
                           pointIndex = isNaN(parseInt(getIndex[0].charAt(1))) ? parseInt(getIndex[1].charAt(0)) : parseInt(getIndex[0].charAt(1));
                       }
                   }
               }
           }
		   if (!isZoom || this.model.enableCanvasRendering) {
				for (var i = 0; i < this.model._visibleSeries.length; i++) {
					chartSeries = this.model._visibleSeries[i];
					var type = chartSeries.type.toLowerCase();
					if (this.model.AreaType == "cartesianaxes" && chartSeries.visibility.toLowerCase() == 'visible' && type !== "scatter" && type !== "bubble" && type !== "column" && type.indexOf("bar") == -1 && type !== "stackingcolumn" && type !== "stackingcolumn100" && !chartSeries._hiloTypes) {
						var serY = [];
						var serX = [];
						var location = null;
						var mouseMoveCords = this.calMousePosition(evt);
						this.mousemoveX = mouseMoveCords.X;
						this.mousemoveY = mouseMoveCords.Y;
						var closestXyPoint = this.getClosesPointXY(serX, serY, chartSeries, this.mousemoveX, this.mousemoveY, evt);
						if (!ej.util.isNullOrUndefined(closestXyPoint.point)) {
						    seriesIndex = i;
						    pointIndex = closestXyPoint.index;
							var commonPointEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
							commonPointEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY }, region: { SeriesIndex: i, Region: { PointIndex: closestXyPoint.index } } };
							this._trigger("pointRegionClick", commonPointEventArgs);
						}
					}
				}			  
				if (data && !isZoom) {				 
					commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
					commonEventArgs.data = data;
					this._trigger("pointRegionClick", commonEventArgs);
				}				
			}
			
        if (this.model.AreaType == "none" && this.model.enable3D && $(evt.target)[0].nodeName == "path" && (!this.isTouch(evt) || (Math.abs(currX - this.model.cachedX) < padding && Math.abs(currY - this.model.cachedY) < padding))){
            index = $(evt.target)[0].id.match(/(\d+)/g);
            seriesIndex = parseInt(index[index.length - 2]);
            pointIndex = parseInt(index[index.length - 1]);
            var currentexplodeindex = this.model._visibleSeries[seriesIndex].explodeIndex;
			 var actualIndex = this.model._visibleSeries[seriesIndex]._visiblePoints[pointIndex].actualIndex;
            if (currentexplodeindex == actualIndex)
                this.model._visibleSeries[seriesIndex].explodeIndex = null;           
            else
                this.model._visibleSeries[seriesIndex].explodeIndex = actualIndex;
            if (!this.vmlRendering && !this.model.enableCanvasRendering)
                var selection = this.selectedStyle(this);
            $(this.svgObject).empty();
			$(this.legendSvgContainer).empty();
            this.draw();
            if (this.model.AreaType == 'none') {
                this.model._isStateChaged = false;
				var className,elementsLenth,
				styleLength=selection.length,
                pathId = "_Region_Series_" + seriesIndex + "_Point_" + pointIndex,
                gElement = $(this.svgObject).find('[id$=' + pathId + '],[id*=' + pathId + 'back],[id*=' + pathId + 'front]');
				 elementsLength=gElement.length;
                for (var k = 0; k < styleLength; k++) {                    
                    for (var i = 0; i < elementsLength; i++) {
                        if (selection[k].id == gElement[i].id) {
                            className = selection[k].className;
                            if (className.indexOf('SelectionStyle') < 0 && (className.indexOf('Selection' + name + 'Style') < 0)) {
                                $("[id=" + gElement[i].id + "]").attr('class', className);
                            }
                        }
                    }              
                }
                if (selection.pattern)
                    this.svgRenderer.append(selection.pattern, this.svgObject);
            }
            else {
                $('[id*=' + this.svgObject.id + '_LegendItemShape],[id*=_Region_Series_]').each(function () {
                    $(this).attr('class', '');
                });
            }
            }  
        var legenddata = this.getLegendData(evt);
        if (legenddata) {
            $('#template_group_' + this._id).remove();
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = legenddata;
            this._trigger("legendItemClick", commonEventArgs);
            var seriesIndex = legenddata.legendItem.LegendItem.SeriesIndex;
            // legend selection logic perform here
            if (!this.model.legend.toggleSeriesVisibility && legenddata.series.selectionSettings.enable) {                 
                this.model._isStateChaged = false;
                this.legendSelection(this, legenddata, evt, data);
            }
            if (!commonEventArgs.cancel && this.model.legend.toggleSeriesVisibility) {
				$('[id*=' + this._id + '_Selection_' + ']').remove();
				var length = this.model._visibleSeries.length;
				if (this.model.AreaType != "none" || this.model.AreaType == "none" && type != 'pieofpie' && type != 'pyramid' && type != 'funnel' && length > 1) {
                    var seriesIndex = legenddata.legendItem.LegendItem.SeriesIndex;
                    var trendlineIndex = legenddata.legendItem.LegendItem.TrendLineIndex;
                    if (ej.util.isNullOrUndefined(trendlineIndex)) {
                    legenddata.series.visibility = legenddata.series.visibility.toLowerCase() === 'visible' ? 'hidden' : 'visible';
                        this.model.series[seriesIndex].visibility = legenddata.series.visibility;
                    if (this._notifyArrayChange)
                            this._notifyArrayChange("series[" + seriesIndex + "]visibility", legenddata.series.visibility);
                    } else {
                        var trendlineVisible = legenddata.series.trendlines[trendlineIndex].visibility.toLowerCase();
                        trendlineVisible = trendlineVisible === 'visible' ? 'hidden' : 'visible';
                        this.model.series[seriesIndex].trendlines[trendlineIndex].visibility = trendlineVisible;
                        if (this._notifyArrayChange)
                            this._notifyArrayChange("series[" + seriesIndex + "].trendlines[" + trendlineIndex + "].visibility", trendlineVisible);
                }
                }
                else {
                    if (this.model._isPieOfPie) {                        
                        var point = this._getPieOfPiePoint(legenddata.legendItem.LegendItem.ActualIndex, legenddata.series,legenddata)._visibility;
                        var pointIndex = legenddata.legendItem.LegendItem.ActualIndex;
                    }
                else{
                    var point = legenddata.series.visiblePoints[legenddata.legendItem.LegendItem.PointIndex]._visibility;
                    var pointIndex = legenddata.series.visiblePoints[legenddata.legendItem.LegendItem.PointIndex].actualIndex;
					}
                    legenddata.series.points[pointIndex]._visibility= point === 'visible' ? 'hidden' : 'visible';
                }
                if (this.model.enableCanvasRendering) {
                    /** Canvas Chart image is cleared when click the legend item to show/hide the series**/
                    var chartRect = document.getElementById(this._id).getClientRects()[0];
                    this.svgRenderer.ctx.clearRect(0, 0, chartRect.width, chartRect.height);
                    //Canvas series marker element removed
					$("#" + this._id).find('[id*="canvas_symbol"]').remove();
                }
                $(this.svgObject).empty();
            	$(this.legendSvgContainer).empty();
                for (var j = 0; j < this.model.series.length; j++)
                    this.model.series[j].regionAdded = false;
                this.model.legendCollapsed = true;                
                this.disableAnimation();
                this.draw();
                this.enableAnimation();
                if (this.model.AreaType != "none" && this.zoomed)
                    this._enableZoomingButtons();
            }
        }

        //axisLabelClick event
        var axisData = this.getAxisLabelData(evt);
        if (axisData) {
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = axisData;
            this._trigger("axisLabelClick", commonEventArgs);

        }
        
		// multi level labels click event
		var labelData = this.getAxisMultiLevelLabelsData(evt);
        if (labelData) {
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = labelData;
            this._trigger("multiLevelLabelClick", commonEventArgs);
        }
		
        //annotationClick event
        if (targetid.indexOf("annotation_") >= 0) {
		     var len = targetid.lastIndexOf("_");
            var str = targetid.substr(len + 1, targetid.length);
            var index = parseInt(str);
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY }, contentData: this.model.annotations[index], pageX: evt.pageX, pageY: evt.pageY };
            this._trigger("annotationClick", commonEventArgs);
  
  
        }

        //Selection started here
        isSelectionSetting = !ej.isNullOrUndefined(seriesIndex) ? this.model._visibleSeries[seriesIndex].selectionSettings.enable : false;
        if (!ej.isNullOrUndefined(seriesIndex) && !legenddata && isSelectionSetting && (!this.isTouch(evt) || (!this.model.crosshairMoved && Math.abs(currX - this.model.cachedX) < padding && Math.abs(currY - this.model.cachedY) < padding))) {
            isMultiSelection = seriesCollection[seriesIndex].selectionSettings.type.toLowerCase() == 'multiple' ? true : false;
            mode = seriesCollection[seriesIndex].selectionSettings.mode;
            if (mode.toLowerCase() != 'range')
            this.segmentSelection(evt, legenddata, seriesIndex, pointIndex, data, seriesCollection);
        }
        this.model.crosshairMoved = false;
		 //chartClick event
        var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY },size:{height:this.model.svgHeight,width:this.model.svgWidth}, id: targetid, pageX: evt.pageX, pageY: evt.pageY };
        this._trigger("chartClick", commonEventArgs);
		
    },

   //Getting targetId when selection state changed by redraw,setmodel
   getTargetId:function(seriesIndex,pointIndex, mode){
      var getSelectionId,
      type = this.model._visibleSeries[seriesIndex].type.toLowerCase(),
      isAreaType = (type.indexOf("area") != -1 || type.indexOf("line") != -1 || type.indexOf("scatter")!=-1 ? true:false) ? true : false;
      if (this.model.enable3D)
          $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + pointIndex + "]").each(function () {
                  getSelectionId = this.id;
              });
      else {
         if (mode != 'series' || this.model.AreaType=='none')
             !isAreaType? $("[id$=" + this.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex ).each(function () {
                    getSelectionId = this.id;
                 }): $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex + '_symbol' + "]").each(function () {
                         getSelectionId = this.id;
                     });
         else 
           $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + "]").each(function () {
                   getSelectionId = this.id;
               });
      }
         return getSelectionId;
   },

  findCanvasSelection: function (seriesIndex, pointIndex, mode) {
      var isSelectionFound;
      if (mode == 'point')
          isSelectionFound = $('#' + this._id + '_Selection_series' + seriesIndex + '_point_' + pointIndex + '_canvas').length;
      else if (mode == 'series')
          isSelectionFound = $('#' + this._id + '_Selection_series' + seriesIndex + '_canvas').length;
      else
          isSelectionFound = $('#' + this._id + '_Selection_Cluster' + '_point_' + pointIndex + '_canvas').length;
      return isSelectionFound==1 ? true : false;
  },

  //Selection logic started here
  segmentSelection: function (evt, legendData, seriesIndex, pointIndex, data) {
      var seriesCollection = this.model._visibleSeries,
          series = seriesCollection[seriesIndex];
          
      if (ej.isNullOrUndefined(series)) return 0;
      var selectionSettings = series.selectionSettings,
        isSelectionSettings = selectionSettings.enable,
        isMultiSelection = selectionSettings.type.toLowerCase() == 'multiple' ? true : false,
        mode = selectionSettings.mode,
        isTrackball = false, chart = this,
        targetId, parentNodeId, isSelectionFound, isElement, sIndex, pIndex, data, dataLength, seriesFlag, accPointFlag, clusterFlag, accSeriesClusterFlag, className;
        this.model.isSelected = true;
       //Calculating cluster points
        if (!ej.isNullOrUndefined(pointIndex) && mode == 'cluster') {
            var clusterPoints = [],
            points, pointsLength,
            xvalue = seriesCollection[seriesIndex]._visiblePoints[pointIndex].xValue;
            for (var i = 0, len = seriesCollection.length; i < len ; i++) {
                points = seriesCollection[i].points;
                pointsLength = points.length;
                for (var j = 0; j < pointsLength; j++)
                    if (xvalue == points[j].xValue)
                        clusterPoints[clusterPoints.length] = { seriesIndex: i, pointIndex: j };
            }
            this.model.clusterPoints = clusterPoints;
        }

        //Get Target and parent node Id's by using seriesIndex and pointIndex
        if (!this.model.enableCanvasRendering) {
            targetId = this.getTargetId(seriesIndex,pointIndex,mode);
            if (targetId) {
                parentNodeId = $('#' + targetId)[0].parentNode.id;
                var parentNode = $('#' + parentNodeId)[0];
                //Checking wether target parent or tracker symbols  present or not
                if (parentNode != null) {
                   if (parentNodeId) {
                           isElement = (parentNodeId.indexOf(this.svgObject.id + "_TextGroup_") >= 0 ||  parentNodeId.indexOf(this.svgObject.id + "_symbolGroup") >= 0) ? true : false;
                           if (parentNodeId.indexOf(this.svgObject.id + "_TrackSymbol_") >= 0) {
                                   isElement = true;
                                   isTrackball = true;
                               }
                       }
                  }
            }
        }        
       
        if (this.model.enableCanvasRendering)
            isSelectionFound = this.findCanvasSelection(seriesIndex, pointIndex, mode);
        else {
            className = $("#" + targetId).attr('class') ? $("#" + targetId).attr('class') : '';
            isSelectionFound = className.indexOf('Selection') != -1 ? true : false;
            if (this.model.enable3D) {
                className = $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + pointIndex + "]").attr('class') ? $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + pointIndex + "]").attr('class') : '';
                isSelectionFound = className.indexOf('Selection') != -1 ? true : false;
            }
        }
      //Selection Removal Logic 
      if ((isSelectionFound || !isMultiSelection) || isMultiSelection) {
          this.removeSelection(seriesIndex, pointIndex, seriesCollection, mode, isMultiSelection, legendData, isSelectionFound);          
          data = this.model.selectedDataPointIndexes;
          dataLength = data.length;         
          if (dataLength > 0 && !this.model._isStateChaged) {
              if (!isMultiSelection) {
                 for (var k = 0; k < dataLength; k++) {
                     sIndex = data[k].seriesIndex;
                     pIndex = data[k].pointIndex;
                     seriesFlag = (mode == 'series' && ((sIndex == seriesIndex && pIndex == pointIndex) || (sIndex != seriesIndex || pIndex != pointIndex)));
                     accPointFlag = ((mode == 'point'|| this.model.AreaType=='none') && (sIndex == seriesIndex && pIndex == pointIndex));
                     clusterFlag = (mode == 'cluster' && (pIndex == pointIndex));
                     if (seriesFlag || accPointFlag || clusterFlag) {
                         data.splice(k, 1); dataLength = data.length; k = -1;
                     }
                 }                    
              } else if (isSelectionFound) {
                      for (var k = 0; k < dataLength; k++) {
                          sIndex = data[k].seriesIndex;
                          pIndex = data[k].pointIndex;
                          seriesFlag = (mode == 'series' && (sIndex == seriesIndex));
                          accPointFlag = ((mode == 'point'||this.model.AreaType=='none') && (sIndex == seriesIndex && pIndex == pointIndex));
                          clusterFlag = (mode == 'cluster' && (pIndex == pointIndex));
                          if (((seriesFlag || clusterFlag) && this.model.AreaType != 'none') || accPointFlag ) {
                              data.splice(k, 1); dataLength = data.length; k = -1;
                          }
                      }
              }
          }
      }
     //Selection Started for 2D,3D,Canvas
      if (!isSelectionFound) {
          this.model.enableCanvasRendering ? this.canvasSelection(this, evt, series, legendData, seriesIndex, pointIndex, data, selectionSettings) : this.selection(chart, evt, series, isTrackball, legendData, seriesIndex, pointIndex, parentNodeId, targetId, data);
          data = this.model.selectedDataPointIndexes;
          dataLength = data.length;
          if (!this.model._isStateChaged) {
              if (dataLength > 0) {
                  if (!isMultiSelection) {
                      for (var k = 0; k < dataLength; k++) {
                          sIndex = data[k].seriesIndex;
                          pIndex = data[k].pointIndex;
                          accSeriesClusterFlag = ((mode == 'series' || mode == 'cluster' || this.model.AreaType == 'none') && (data[k].SeriesIndex != seriesIndex || data[k].PointIndex != pointIndex));
                          pointFlag = (mode == 'point' && (data[k].SeriesIndex == seriesIndex));
                          if (accSeriesClusterFlag || pointFlag) {
                              data.splice(k, 1); dataLength = this.model.selectedDataPointIndexes.length; k = -1;
                          }
                      }
                      data.push({ 'event': evt, 'legendData': legendData, 'seriesIndex': seriesIndex, 'pointIndex': pointIndex, 'data': data });
                  } else {
                      data.push({ 'event': evt, 'legendData': legendData, 'seriesIndex': seriesIndex, 'pointIndex': pointIndex, 'data': data });
                  }
              } else
                  data.push({ 'event': evt, 'legendData': legendData, 'seriesIndex': seriesIndex, 'pointIndex': pointIndex, 'data': data });
          }
      }

      //Getting selected data here
      var selectedData = { selectedData: this.model.selectedDataPointIndexes };
      this._trigger("seriesRegionClick", selectedData);
    },


     //legend Selection logic perform here
  legendSelection: function (chart, legenddata, evt, data) {
      var selectedData = this.model.selectedDataPointIndexes ? this.model.selectedDataPointIndexes : [],
	  length =this.model._visibleSeries.length,
        index = (chart.model.AreaType == 'none' && length == 1) ? legenddata.legendItem.LegendItem.PointIndex : legenddata.legendItem.LegendItem.SeriesIndex;
        seriesIndex = legenddata.legendItem.LegendItem.SeriesIndex;
        pointIndex = index;
        legendItem = chart.svgObject.id + '_LegendItemShape' + index,
        legendClass = $('#' + legendItem).attr('class') ? $('#' + legendItem).attr('class') : '';                  
        if ($('#' + chart._id + '_Selection_Legend' + index + '_canvas').length == 1 || legendClass.indexOf('Selection')!=-1) {
             $('#' + chart._id + '_Selection_Legend' + index + '_canvas').remove();
             $("[id*=" + chart._id + '_Selection_series' + index + "]").remove();
             $('#' + this._id + '_Selection_series' + seriesIndex + '_point_' + pointIndex + '_canvas').remove();
             $('#' + legendItem).attr('class', '');
             $("[id*=" + chart.svgObject.id + '_Series' + seriesIndex + "]").attr('class', '');
             $("[id*=" + '_Region_Series_' + seriesIndex + "]").attr('class', '');
             for (var k = 0; k < selectedData.length; k++) {
                 if (selectedData[k].seriesIndex == index || (this.model.AreaType == 'none' && selectedData[k].pointIndex == index)) {
                     selectedData.splice(k, 1); break;
                 }
             }
         }             
        else                                    
           chart.segmentSelection(evt, legenddata, seriesIndex, pointIndex, data);       
    },

    chartMouseClick: function (evt) {
	
	this.cancelEvent(evt);
        if (window.navigator.msPointerEnabled) {
            evt = evt.originalEvent;
        }
        this._doClick(evt);
    },
    chartMouseDoubleClick: function (evt) {

      
        if (window.navigator.msPointerEnabled) {
            evt = evt.originalEvent;
        }
        //chartDoubleClick event
        var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
        commonEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY },size:{height:this.model.svgHeight,width:this.model.svgWidth}, id: evt.target.id, pageX: evt.pageX, pageY: evt.pageY };
        this._trigger("chartDoubleClick", commonEventArgs);

    },
    drawTrackerSymbol: function (series, seriesIndex, ptIndex, tracker, point, id,trackcount) {

        var type = series.type.toLowerCase(), offsetX, offsetY;
        var chartSeriesObj = new ej.seriesTypes[type]();
		var index = series.type.toLowerCase() =="boxandwhisker" ? trackcount : ptIndex;
        var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, this.model.requireInvertedAxes);
		offsetX = !series.isTransposed ? series.xAxis.plotOffset : series.yAxis.plotOffset;
		offsetY = !series.isTransposed ? series.yAxis.plotOffset : series.xAxis.plotOffset;
		 var clipRectOptions = {
		     'id': this.svgObject.id + '_ClipRectTrack' + '_' + seriesIndex,
            'x': - offsetX,
            'y': - offsetY,
            'width': trans.width + offsetX * 2,
            'height': trans.height + offsetY * 2,
            'fill': 'white',
            'stroke-width': 1,
            'stroke': 'Gray'
        };       
        if (this.model.AreaType != "none") {
            if (this.model.AreaType == 'cartesianaxes' && ((point.X + trans.x) <= (trans.x + trans.width)) && ((point.X + trans.x) >= trans.x || point.X == 0) &&
                 ((point.Y + trans.y) >= (trans.y) || point.Y == 0)) {
                if (this.model.crosshair.visible || type == "bubble" || type == "scatter") {
                    if (!series.trackerRemoved ) {
                        var trackId = this.svgObject.id + '_TrackSymbol' + '_' + seriesIndex;
						trackId = (type == "boxandwhisker") ? trackId + index : trackId ;
                        $("#" + this._id).find('[id*=' + trackId + ']').remove();
                        var trackId = "canvas_trackSymbol_" + seriesIndex;
						trackId = (type == "boxandwhisker") ? trackId + index : trackId ;
                        $("#" + this._id).find('[id*=' + trackId + ']').remove();
                       
                    }					
                    var transSymbolOptions = { 'clip-path': 'url(#' + this.svgObject.id + '_ClipRectTrack' + '_' + seriesIndex + ')', 'class': 'Tracker', 'id': this.svgObject.id + '_TrackSymbol' + '_' + seriesIndex + '_' + index, 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
                    this.gTrackerEle = this.svgRenderer.createGroup(transSymbolOptions);                   
                } else
				    this.gTrackerEle = null; // empty the previously created tracker group if no tracker is drawn now
                }
            else {
					
						$('#' + this.svgObject.id + '_TrackSymbol' + '_' + seriesIndex + '_' + index).remove();
						var transSymbolOptions = { 'id': this.svgObject.id + '_TrackSymbol' + '_' + seriesIndex + '_' + index };				
                this.gTrackerEle = this.svgRenderer.createGroup(transSymbolOptions);
                if(!this.model.enableCanvasRendering) { 
                    if (this.model.AreaType == 'polaraxes')
                        this.gTrackerEle.setAttribute('clip-path', 'url(#' + this.svgObject.id + '_SeriesGroup_' + seriesIndex + '_ClipRect)');
                    else {
                        this.gTrackerEle.setAttribute('clip-path', 'url(#' + this.svgObject.id + '_ClipRectTrack' + '_' + seriesIndex + ')');
                        this.gTrackerEle.setAttribute('transform', 'translate(' + trans.x + ',' + trans.y + ')');
                    }
               }
            }
            if ($("#" + this.svgObject.id + "_CrosshairGroup").length == 0) {
                var gTrackballOptions = { 'id': this.svgObject.id + '_CrosshairGroup', 'visibility': 'visible' };
                this.gTrackball = this.svgRenderer.createGroup(gTrackballOptions);
                this.svgRenderer.append(this.gTrackball, this.svgObject);
            }
            if (this.model.crosshair.marker.visible && !series.isIndicator && series._visiblePoints[ptIndex].visible) {
				chartSeriesObj.drawSymbol(seriesIndex, series, ptIndex, (point.X), (point.Y), this, tracker,trackcount);
                if (point.low)
                    chartSeriesObj.drawSymbol(seriesIndex, series, ptIndex, (this.model.requireInvertedAxes ? point.low : point.X), (this.model.requireInvertedAxes ? point.Y : point.low), this, tracker);                
            }
            if (this.gTrackerEle && $("#" + this.gTrackerEle.id).length < 1)
                this.svgRenderer.append(this.gTrackerEle, this.gTrackball);
        }
        if ($(this.svgObject).find("#" + this.svgObject.id + '_ClipRectTrack' + '_' + seriesIndex).length == 0 && !this.vmlRendering) {
            this.svgRenderer.drawClipPath(clipRectOptions, $("#" + this.svgObject.id + "_CrosshairGroup"));
        }
            
        
    },
    getClosesPointXY: function (serX, serY, series, x, y, evt) {
        var closestPoint,
            valAxis = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, this.model.requireInvertedAxes),outlierPosition,
            ptIndex, chartPoint, location, pointIndex, pointVisible,closestX, padding = 10, isTouch=this.isTouch(evt),
            visiblePointsLength = series._visiblePoints ? series._visiblePoints.length : 0, closestY,
            size = series.marker ? $.extend(true, {}, series.marker.size) : { height: 6, width: 6 };
            size.height = (isTouch && size.height < padding * 2) ? size.height + padding : size.height;
            size.width = (isTouch && size.width < padding * 2) ? size.width + padding : size.width;
        if ((y <= (valAxis.y + valAxis.height) && valAxis.y <= y) && (valAxis.x <= x && x <= (valAxis.x + valAxis.width))) {
            for (var i = 0; i < visiblePointsLength; i++) {
                chartPoint = series._visiblePoints[i];
                location = chartPoint.location;
                pointVisible = false;
                pointIndex = i;
                closestX = null;
                closestY = null;
				
				if(series.type == "boxandwhisker" && (!this.model.enable3D) && !(ej.util.isNullOrUndefined(chartPoint.boxPlotLocation)))
				{ 
				
				for(var k=0;k<chartPoint.boxPlotLocation.length;k++)
				{					
					var symbolOptions ={ X:chartPoint.boxPlotLocation[k].X,Y:chartPoint.boxPlotLocation[k].Y
					};
					if(chartPoint.boxPlotLocation[k].outlier == true){
						if (x > ((symbolOptions.X + valAxis.x )- size.width) && x < (symbolOptions.X + valAxis.x + size.width) ) {
							closestX = chartPoint.x;						
						if (ej.util.isNullOrUndefined(closestX))
                            pointVisible = chartPoint.visible;
						if (y > ((symbolOptions.Y + valAxis.y )- size.height)  &&  y < symbolOptions.Y + valAxis.y + size.height + padding ) {					  
						     closestY = chartPoint.boxPlotValues.outliers[k];
							 outlierPosition = {X:symbolOptions.X,Y:symbolOptions.Y};
						}    
						if(!ej.util.isNullOrUndefined(outlierPosition))
						{
							closestPoint = chartPoint;
							ptIndex = i;                   
						}
					 }
				   }
				
				  }								
				}				
                if (location) {
                    if (x > location.X + valAxis.x - (size.width / 2) && x < location.X + valAxis.x + (size.width / 2)) {
                        closestX = chartPoint.x;
                        if (ej.util.isNullOrUndefined(closestX))
                            pointVisible = chartPoint.visible;
                    }
                    if (y > location.Y + valAxis.y - (size.height / 2) && y < location.Y + valAxis.y + (size.height / 2)) {
                        closestY = chartPoint.YValues[0];
                    }
                    if ((!ej.util.isNullOrUndefined(closestX) || pointVisible) && !ej.util.isNullOrUndefined(closestY)) {
                        closestPoint = chartPoint;
                        ptIndex = i;
                    }
                }
            }         
        }
        return { point: closestPoint, index: ptIndex, outlierPosition: outlierPosition };
    },
    getClosestPointX: function (serX, series, x, y) {
        var closestPoint = [];
        var valAxis = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, this.model.requireInvertedAxes);
        if (this.model.requireInvertedAxes) {
            x = Math.abs(y - (valAxis.y + valAxis.height));
            y = Math.abs(x - valAxis.x);
        }
        else {
            x = Math.abs(x - valAxis.x);
            y = Math.abs(y - (valAxis.y + valAxis.height));
        }
        var mousePoint = ej.EjSvgRender.utils._getValuebyPoint(x, y, series);
        var pointX = (this.model.requireInvertedAxes) ? mousePoint.PointX : mousePoint.PointX;
        var ptIndex = [];
        
        $.each(series.points, function (pointIndex, chartPoint) {
            serX.push(chartPoint.xValue);
        });
        var closest = this.getClosest(serX, pointX);
		if (!ej.util.isNullOrUndefined(closest)) {
            if (typeof closest == 'number') {
                $.each(series._visiblePoints, function (pointIndex, cPoint) {
                    if (cPoint.xValue == closest) {
                        closestPoint.push(cPoint);
                        ptIndex.push(pointIndex);

                    }
                });
            } else {
                closest = closest.getTime();
                $.each(series._visiblePoints, function (pointIndex, cPoint) {
                    if (cPoint.xValue.getTime() == closest) {
                        closestPoint.push(cPoint);
                        ptIndex.push(pointIndex);

                    }
                });
            }
        }
        return { point: closestPoint, index: ptIndex };
    },
    getClosest: function (obj, val) {
        var closest = null;
        this._beforeMin = false;
        this._afterMax = false;

        // Work out min and max
        var min = Math.min.apply(null, obj);
        var max = Math.max.apply(null, obj);

        // Only calculate closest if point is within array
        if (val >= min - 0.5 && val <= max + 0.5) {
            var i;
            for (i = 0; i < obj.length; i++) {
                if (closest == null || Math.abs(obj[i] - val) < Math.abs(closest - val)) {
                    closest = obj[i];
                }
            }
            this._closest = null;
        }
        else {
            if (val > max) {
                closest = obj[obj.length - 1];
                this._closest = ej.util.isNullOrUndefined(this._closest) ? closest : (closest > this._closest ? closest : this._closest);
                this._afterMax = true;
            }
            else {
                closest = obj[0];
                this._closest = ej.util.isNullOrUndefined(this._closest) ? closest : (closest < this._closest ? closest : this._closest);
                this._beforeMin = true;

            }
        }
        return closest;
    },
    createTooltip: function (region, evt, series) {
        if(!series)
          series = this.model._visibleSeries[region.SeriesIndex];
        var seriesPoint = (series.type == "pieofpie") ? this._getPieOfPiePoint(region.Region.PointIndex, series) : series._visiblePoints[region.Region.PointIndex];
        var point = ( this.dragPoint)? series.pointCollection[region.Region.PointIndex] : $.extend(true, {}, seriesPoint);
		var tooltipMargin=10;
        if (point.visible) {
		     var format = series.tooltip.format;
			if(series.type == "boxandwhisker")
			{
				var mouseMoveCords = this.calMousePosition(evt);
				this.mousemoveX = mouseMoveCords.X;
				this.mousemoveY = mouseMoveCords.Y;
				var flag = region.Region.Bounds ? true : false;	
				if(flag){
					if(region.Region.Bounds.Width == series.outlierSettings.size.width){
						for(var s =0;s<point.boxPlotLocation.length;s++){
							if(point.boxPlotLocation[s].outlier == true){
								if((point.boxPlotLocation[s].X + (series.outlierSettings.size.width/2) > (this.mousemoveX - series.xAxis.x ))&& (point.boxPlotLocation[s].X - (series.outlierSettings.size.width/2) < (this.mousemoveX - series.xAxis.x) )){
									if((point.boxPlotLocation[s] .Y + (series.outlierSettings.size.height/2) > (this.mousemoveY - series.yAxis.y)) && (point.boxPlotLocation[s] .Y - (series.outlierSettings.size.height/2) < (this.mousemoveY - series.yAxis.y ))){
										var dataPoints = this.getTooltipFormat(point, series, region.SeriesIndex, region.Region.PointIndex, format,point.boxPlotLocation[s]);
										point.x = dataPoints.data.x;
										point.y = dataPoints.text;
									}
								}
							}
						}
					}
					else
					{
						var dataPoints = this.getTooltipFormat(point, series, region.SeriesIndex, region.Region.PointIndex, format,point.boxPlotLocation[0]);
						point.x = dataPoints.data.x;
						point.y = dataPoints.text;
					}
				}
			}
			else
			{
				var dataPoints = this.getTooltipFormat(point, series, region.SeriesIndex, region.Region.PointIndex, format);
				point.x = dataPoints.data.x;
				point.y = dataPoints.data.y;
			}
		    var tooltip = null;
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { currentText: tooltip, seriesIndex: region.SeriesIndex, pointIndex: region.Region.PointIndex, series: series };
            this._trigger("toolTipInitialize", commonEventArgs);
            var tooltipdiv = $('.tooltipDiv' + this._id);
			$("#" + this.svgObject.id).find("#" + this.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden');
            $("#" + this.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden').hide();
            if ($('.tooltipDiv' + this._id).length == 0) {
                this.tooltipFirst = true;
                tooltipdiv = $("<div></div>").attr('class', 'tooltipDiv' + this._id).css({ 'position': 'absolute', 'z-index': '13000', 'display': 'block' });             
                $(document.body).append(tooltipdiv);
                $('.tooltipDiv' + this._id).addClass(this.svgObject.id);
            } else {
                $(".tooltipDiv" + this._id).css("display", "block");
                this.tooltipFirst = false;
            }
            if (series.tooltip.template != null) {
                var cloneNode = $("#" + series.tooltip.template).clone();
                $('.tooltipDiv' + this._id)[0].innerHTML = "";
                $(cloneNode).css("display", "block").appendTo(tooltipdiv);
                series.count = 1;
                point.count = 1;
                var seriesColor = this.getSeriesColor(point, region.SeriesIndex, series);
				if (seriesColor)
                    $(tooltipdiv).css("background-color", jQuery.type(seriesColor) == "array" ? seriesColor[0].color : seriesColor);
				else
                   $(tooltipdiv).css("background-color", this.model.pointColors[region.Region.PointIndex]);
				var data = { series: series, point: point };
				if (!ej.util.isNullOrUndefined(commonEventArgs.data.currentText))
				    $(tooltipdiv).html($(cloneNode).html(commonEventArgs.data.currentText));
                else
                $(tooltipdiv).html($(tooltipdiv).html().parseTemplate(data));
            } else {
                $(tooltipdiv).html(commonEventArgs.data.ToolTip);
            }
			var areaBounds = this.model.m_AreaBounds;
            var xPos = evt.pageX  + tooltipMargin;
            var yPos = evt.pageY  + tooltipMargin;
            var tooltipWidth = $(tooltipdiv).width();
            var tooltipHeight = $(tooltipdiv).height();
            var position = document.getElementById(this.svgObject.id).getClientRects()[0];
            if (xPos === undefined || xPos === null)
                xPos = evt.pageX  + tooltipMargin;
            if (yPos === undefined || yPos === null)
                yPos = evt.pageY  + tooltipMargin;
            var leftPos = xPos;
			var topPos = yPos;
            //Checking top position whether tooltip display outside of the area bounds
            if ((xPos - $(this.svgObject).offset().left+ tooltipWidth) > (areaBounds.X + areaBounds.Width )) {
                var diff = (xPos - (tooltipWidth + (2* tooltipMargin)));
                leftPos = diff + $(document).scrollLeft();
            }
            if ((yPos - $(this.svgObject).offset().top + tooltipHeight) > areaBounds.Y + areaBounds.Height ) {
                var diff = (yPos + tooltipHeight) - (areaBounds.Y + areaBounds.Height + position.top)
                topPos = yPos - diff + $(document).scrollTop();
            }
			
			$(tooltipdiv).css('left',leftPos);
			$(tooltipdiv).css('top',topPos);
			
			var tooltipOptions = series.tooltip;
            if (tooltipOptions.enableAnimation) {
                $(tooltipdiv).css({
                    'transition-property': 'left,top',
                    '-moz-transition-property': 'left,top', /* Firefox 4 */
                    '-webkit-transition-property': 'left,top', /* Safari and Chrome */
                    '-o-transition-property': 'left,top',
                    'transition-duration': tooltipOptions.duration,
                    '-moz-transition-duration': tooltipOptions.duration, /* Firefox 4 */

                    '-webkit-transition-duration': this.tooltipFirst ? '0s' : tooltipOptions.duration, /* Safari and Chrome */
                    '-o-transition-duration': tooltipOptions.duration /* Opera */
                });
            }
            templateRect = $(tooltipdiv)[0].getBoundingClientRect();
            if(templateRect.top < areaBounds.Y + position.top)
                $(tooltipdiv).css('top', areaBounds.Y + position.top + $(document).scrollTop());
        }
    },

    translate: function (axis, translateX, translateY, currentScale) {
        var offset = axis.orientation.toLowerCase() == "horizontal"
                                              ? translateX / axis.width / currentScale
                                              : translateY / axis.height / currentScale;

        axis.zoomPosition = axis.orientation.toLowerCase() == "horizontal"
            ? ej.EjSvgRender.utils._minMax(axis.zoomPosition + offset, 0, (1 - axis.zoomFactor))
            : ej.EjSvgRender.utils._minMax(axis.zoomPosition - offset, 0, (1 - axis.zoomFactor));
    },
    highlightFill: function (highlight, chart, seriesIndex, pointIndex, legendData) {
        var seriesColors = chart.model.seriesColors;
        var pointColors = chart.model.pointColors;
        var color = highlight.color;
		var length =this.model._visibleSeries.length;
        if (legendData && chart.model.AreaType == 'none') {
            if(length == 1)
            pointIndex = legendData.legendItem.LegendItem.PointIndex;
            else
            seriesIndex = legendData.legendItem.LegendItem.SeriesIndex;
        }
        var pointColor = legendData ? seriesColors[seriesIndex] : pointIndex ? chart.model.series[seriesIndex].points[pointIndex] ? chart.model.series[seriesIndex].points[pointIndex].fill: null : null;
        var fill = (color != "" ? color : chart.model.AreaType == 'none' ? pointColors[pointIndex] : legendData ? seriesColors[seriesIndex] : pointColor ? pointColor : seriesColors[seriesIndex]);
        if (Object.prototype.toString.call(fill) === '[object Array]')
            fill = fill[1].color;
        return fill;
    },
	
	
   
     // Canvas highlight and selection started here
     // Canvas highlight started here
    canvasHighlight: function (chart, evt, series, legendData) {

        var highlight = series.highlightSettings;
        var data = series.data;
        var color = highlight.color;
        var opacity = highlight.opacity;
        var borderColor = highlight.border.color;
        var borderWidth = highlight.border.width;
        var patternName = highlight.pattern.toLowerCase();
        var legendVisible = chart.model.legend.visible;
        var mode = highlight.mode;
        var seriesIndex = series.seriesIndex;
        var pointIndex = series.pointIndex;
        var seriesType = series.type.toLowerCase();
        var containerStyle = document.getElementById(chart._id + '_canvas').getBoundingClientRect();
        var regions = [];
        var points = [];
        var clusterPoints = [];
		var length =this.model._visibleSeries.length;
        var fill = this.highlightFill(highlight, chart, seriesIndex, pointIndex,legendData);
        if (chart.model.AreaType != 'none' || (chart.model.AreaType == 'none' && length > 1 && (mode == 'series' || legendData))) {
            for (var i = 0, len = chart.model.chartRegions.length; i < len ; i++) {
                if ((mode == 'series' || legendData) && (seriesIndex == chart.model.chartRegions[i].SeriesIndex))
                        regions.push(chart.model.chartRegions[i].Region);
                    }
                   
               
        } else {
            for (var i = 0, len = chart.model.chartRegions.length; i < len; i++) {
                if (seriesIndex == chart.model.chartRegions[i].SeriesIndex && pointIndex == chart.model.chartRegions[i].Region.PointIndex)
                    regions.push(chart.model._isPieOfPie ? chart._getPieOfPiePoint(chart.model.chartRegions[i].Region.PointIndex, series) : chart.model.chartRegions[i].Region[pointIndex]);
            }
        }
        if (mode == 'cluster' && chart.model.Areatype != 'none' && typeof pointIndex !== "undefined") {
            var xvalue = chart.model._visibleSeries[seriesIndex]._visiblePoints[pointIndex].xValue;
            for (var i = 0, len = chart.model._visibleSeries.length; i < len ; i++) {
                for (var j = 0; j < chart.model._visibleSeries[i]._visiblePoints.length; j++) {
                    if (xvalue == chart.model._visibleSeries[i]._visiblePoints[j].xValue)
                        clusterPoints[clusterPoints.length] = { seriesIndex: i, pointIndex: j };

                }
            }
        }
        for (var k = 0; k < clusterPoints.length; k++) {
            clusterseriesIndex = clusterPoints[k].seriesIndex;
            clusterpointIndex = clusterPoints[k].pointIndex;
            for (var l = 0; l < chart.model.chartRegions.length; l++) {
                if (clusterseriesIndex == chart.model.chartRegions[l].SeriesIndex && clusterpointIndex == chart.model.chartRegions[l].Region.PointIndex)
                    if (mode != "cluster")
                    regions.push(chart.model.chartRegions[l].Region);
                    else
                        regions.push(chart.model.chartRegions[l]);
            }
        }
      var index = (chart.model.AreaType == 'none' && length == 1) ? pointIndex : seriesIndex;
        if ((mode == 'series' || legendData) && ($('#' + chart._id + '_Selection_series' + index + '_canvas').length == 0) && $('#' + chart._id + '_Selection_' + 'Cluster' + '_point_' + pointIndex + '_canvas').length == 0 && $('#' + chart._id + '_Selection_' + seriesIndex + '_point_' + pointIndex + '_canvas').length == 0) {             
            points = series._visiblePoints
            ctx = this.createCanvasElement(chart._id + '_Highlight_series' + seriesIndex + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
            color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, highlight);
            this.createRect(chart, ctx);
            if (seriesType.indexOf("column") != -1 || seriesType.indexOf("waterfall") != -1 || seriesType.indexOf("bar") != -1) {
                for (i = 0; i < regions.length; i++) {
                    var isUnSelected = $('#' + chart._id + '_Selection_' + seriesIndex + '_point_' + i + '_canvas').length == 0 ? true : false;
                    this.canvasSeriesRect(regions[i], opacity, borderColor, borderWidth, color, isUnSelected, series);
                }
            }
            else if (seriesType == 'pie' || seriesType == 'doughnut' || seriesType == "pieofpie")
			{
               regions = (length == 1) ? regions : regions[0];
                this.canvasHighlightCircle(chart, highlight, pointIndex, opacity, borderColor, borderWidth, color, regions, seriesType, ctx);
				}
            else if (seriesType == 'pyramid' || seriesType == 'funnel')
                this.canvasHighlightPyramid(chart, regions[0], highlight, ctx, opacity, borderColor, borderWidth, color, seriesType);
            else if (seriesType == 'bubble')
                this.canvasBubbleHighlight(highlight, regions, chart, seriesIndex, color, borderWidth, opacity, borderColor);
            else if (seriesType == 'scatter')
                this.canvasScatterHighlight(regions, color, borderWidth, opacity, borderColor);
        }
		else if (mode == 'cluster' && $('#' + chart._id + '_Selection_' + 'Cluster' + '_point_' + pointIndex + '_canvas').length == 0 && this.model.AreaType != 'none' && $('#' + chart._id + '_Selection_' + seriesIndex + '_point_' + pointIndex + '_canvas').length == 0 && $('#' + chart._id + '_Selection_series' + seriesIndex + '_canvas').length == 0) {
                for (var i = 0, len = this.model._visibleSeries.length; i < len; i++) {
                    var series = this.model._visibleSeries[i];
                    series.seriesIndex = i;
                    points.push(series._visiblePoints[pointIndex]);

                }
            var sbRegion = [], colors = [];// scatter & bubble region calculation
                ctx = this.createCanvasElement(chart._id + '_Highlight_' + '_Cluster' + '_point_' + pointIndex + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
                this.createRect(chart, ctx);
                for (var i = 0, len = this.model._visibleSeries.length; i < len; i++) {
                sbRegion = [];
                    highlight = chart.model._visibleSeries[i].highlightSettings;
                    color = highlight.color;
                    opacity = highlight.opacity;
                    borderColor = highlight.border.color;
                    borderWidth = highlight.border.width;
                    patternName = highlight.pattern.toLowerCase();
                    fill = this.highlightFill(highlight, chart, i, pointIndex, index, legendData);
                    color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, highlight);
                colors.push(color);
                for (var r = 0, rlen = regions.length; r < rlen; r++) {
                    if (regions[r].SeriesIndex == i) {
                        sbRegion.push(regions[r].Region);
                    }
                }
                if (seriesType.indexOf("column") != -1 || seriesType.indexOf("waterfall") != -1 || seriesType.indexOf("bar") != -1) {
                        var isUnSelected = $('#' + chart._id + '_Selection_' + i + '_point_' + pointIndex + '_canvas').length == 0 ? true : false;
                    for (var r = 0, rlen = sbRegion.length; r < rlen; r++) {
                        this.canvasSeriesRect(sbRegion[r], opacity, borderColor, borderWidth, color, isUnSelected, series);
                    }
                }
                    else if (seriesType == 'bubble') {
                    this.canvasBubbleHighlight(highlight, sbRegion, chart, i, color, borderWidth, opacity, borderColor);
                    }
                    else if (seriesType == 'scatter') {
                    this.canvasScatterHighlight(sbRegion, color, borderWidth, opacity, borderColor);
                    }

                }
            }
		else if ((mode=="cluster" &&this.model.AreaType == 'none') || mode == 'point' && $('#' + chart._id + '_Selection_' + seriesIndex + '_point_' + pointIndex + '_canvas').length == 0 && $('#' + chart._id + '_Selection_series' + seriesIndex + '_canvas').length == 0 && $('#' + chart._id + '_Selection_' + 'Cluster' + '_point_' + pointIndex + '_canvas').length == 0) {
            points[0] = this.model._isPieOfPie? this._getPieOfPiePoint(pointIndex,series):series._visiblePoints[pointIndex];
            ctx = this.createCanvasElement(chart._id + '_Highlight_' + seriesIndex + '_point_' + pointIndex + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
            this.createRect(chart, ctx);
            color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, highlight);
            if (seriesType.indexOf("column") != -1 || seriesType.indexOf("waterfall") != -1 || seriesType.indexOf("bar") != -1) {
                regions = []; regions[0] = data.region.Region;
                this.canvasSeriesRect(regions[0], opacity, borderColor, borderWidth, color, true, series);
            }
            else if (seriesType == 'pie' || seriesType == 'doughnut' || seriesType == "pieofpie") {
                regions = []; regions[0] = data.pointData[0];
                this.canvasHighlightCircle(chart, highlight, pointIndex, opacity, borderColor, borderWidth, color, regions, seriesType, ctx);
            }
            else if (seriesType == 'pyramid' || seriesType == 'funnel') {
                this.canvasHighlightPyramid(chart, regions[0], highlight, ctx, opacity, borderColor, borderWidth, color, seriesType);
            }
            else if (seriesType == 'bubble') {
                regions = []; regions[0] = data.region.Region;
                this.canvasBubbleHighlight(highlight, regions, chart, seriesIndex, color, borderWidth, opacity, borderColor);
            }
            else if (seriesType == 'scatter') {
                regions = []; regions[0] = data.region.Region;
                this.canvasScatterHighlight(regions, color, borderWidth, opacity, borderColor);
            }
        }
        // legend highlight (legend symbol)
        if (legendVisible && $('#' + chart._id + '_Selection_Legend' + index + '_canvas').length == 0) {
            if (mode == 'cluster' && !legendData && this.model.AreaType != 'none') {
                var serIndex;
                for (var i = 0, len = clusterPoints.length; i < len; i++) {
                    serIndex = clusterPoints[i].seriesIndex;
                    chartSeries = this.model._visibleSeries[serIndex];                   
                    this.canvasHighlightLegend(chart, chartSeries, highlight, 'Highlight', containerStyle, colors[serIndex]);
                }
            }
            else
                this.canvasHighlightLegend(chart, series, highlight, 'Highlight', containerStyle, color);
            
        }
        if (series.visibility === 'visible' && series.marker.visible == true && this.model.AreaType != 'none')
            this.canvasHighlightMarker(chart, series, points, highlight, ctx, evt, colors);
    },

     // canvas rect operations perform here
    canvasSeriesRect: function (regions, opacity, borderColor, borderWidth, color, isUnSelected, series) {
        var options = {
            'opacity': opacity,
            'stroke': borderColor,
            'stroke-width': borderWidth,
            'fill': color
        }
		var cornerRadius = series.cornerRadius;
        if (regions) {
            options.x = regions.Bounds.X;
            options.y = regions.Bounds.Y;
            options.width = regions.Bounds.Width;
            options.height = regions.Bounds.Height;
            if (isUnSelected)
				if ((typeof (cornerRadius) != "object" && cornerRadius > 0) || cornerRadius.topLeft > 0 || cornerRadius.bottomLeft > 0
					          || cornerRadius.topRight > 0 || cornerRadius.bottomRight > 0) {
                    options.cornerRadius = series.cornerRadius;
                    var roundrect = ej.EjSvgRender.utils._calculateroundedCorner(options);
                    options.d = roundrect;
                    ej.EjCanvasRender.prototype.drawPath(options, ctx);
                }
                else
					this.drawRect(options, ctx);
        }
    },

     // // canvas selection logic started here
    canvasSelection: function (chart, evt, series, legendData, seriesIndex, pointIndex, data, selectionSettings) {
        series.seriesIndex = seriesIndex;
        series.pointIndex = pointIndex;
        var seriesCollection = this.model._visibleSeries,
        color = selectionSettings.color,
        opacity = selectionSettings.opacity,
        borderColor = selectionSettings.border.color,
        borderWidth = selectionSettings.border.width,
        patternName = selectionSettings.pattern.toLowerCase(),
        legendVisible = chart.model.legend.visible,
        mode = selectionSettings.mode,
        seriesType = series.type.toLowerCase(),
        containerStyle = document.getElementById(chart._id + '_canvas').getBoundingClientRect(),
        regions = [],
        points = [],
        length = this.model._visibleSeries.length,
        chartRegions = chart.model.chartRegions,
        clusterPoints = this.model.clusterPoints,
        seriesData = { seriesIndex: seriesIndex, series: series },
         index = (chart.model.AreaType == 'none' && length == 1) ? pointIndex : seriesIndex,
        fill = this.highlightFill(selectionSettings, chart, seriesIndex, pointIndex, legendData ,data),regionsLength,cRlength;
		regionsLength = chartRegions.length;
           if (chart.model.AreaType != 'none' || (chart.model.AreaType == 'none' && length > 1)) {        
            for (var i = 0; i < regionsLength; i++) {
                if (((mode == 'series' || legendData) && seriesIndex == chartRegions[i].SeriesIndex) || ((mode == 'point' || legendData) && (seriesIndex == chartRegions[i].SeriesIndex && pointIndex == chartRegions[i].Region.PointIndex))) {
                        if (chart.model.AreaType == 'none' && mode == 'point' && !legendData)
                            regions.push(chartRegions[i].Region[pointIndex])
                        else
                            regions.push(chartRegions[i].Region);
                    }           
                }
           } else if (regionsLength > 0) {
               if (this.model._isPieOfPie) {
                   if (legendData) {
                       for (var p = 0; p < series.pieCollections.length; p++) {
                           var piePoints = series.pieCollections[p];
                           for (var q = 0; q < piePoints.length; q++) {
                               if (piePoints[q].actualIndex == legendData.legendItem.LegendItem.PointIndex) {
                                   var pieColIndex = p;
                                   break;
                               }
                           }
                       }
                   }
                   var pieSrIndex = series.data ? series.data.pointData[0].PieSeriesIndex : pieColIndex;
                   var chartRegion = chartRegions[pieSrIndex];
               }
               else
                   var chartRegion = chartRegions[0];
                   cRlength = chartRegion.Region.length;
            for (var i = 0; i < cRlength; i++) {
                if (pointIndex == chartRegion.Region[i].PointIndex)
                    regions.push(chartRegion.Region[i]);
            }
        }
        if ((mode == 'series' || legendData) && (this.model.AreaType!='none' || this.model.AreaType == 'none' && length >1) ) {
            points = series._visiblePoints;
            ctx = this.createCanvasElement(chart._id + '_Selection_series' + index + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
            color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, selectionSettings);
            this.createRect(chart, ctx);
            if (seriesType.indexOf("column") != -1 || seriesType.indexOf("waterfall") != -1 || seriesType.indexOf("bar") != -1) {
                for (i = 0; i < regions.length; i++)
                    this.canvasSeriesRect(regions[i], opacity, borderColor, borderWidth, color, true, series);
            }
            else if (seriesType == 'pie' || seriesType == 'doughnut' || seriesType == "pieofpie")
                this.canvasHighlightCircle(chart, selectionSettings, pointIndex, opacity, borderColor, borderWidth, color, regions[0], seriesType, ctx);
            else if (seriesType == 'bubble')
                this.canvasBubbleHighlight(selectionSettings, regions, chart, seriesIndex, color, borderWidth, opacity, borderColor);
            else if (seriesType == 'scatter')
                this.canvasScatterHighlight(regions, color, borderWidth, opacity, borderColor);
        }
	    else if (mode == 'cluster' && this.model.AreaType != 'none' && $('#' + chart._id + '_Selection_' + 'Cluster' + '_point_' + pointIndex + '_canvas').length == 0) {
	        var clength = clusterPoints.length, clusterseriesIndex, clusterpointIndex, region, rlength;
	        for (var k = 0; k < clength; k++) {
	                clusterseriesIndex = clusterPoints[k].seriesIndex;
	                clusterpointIndex = clusterPoints[k].pointIndex;
	                region = $.grep(chartRegions, function (x) { return x.SeriesIndex == clusterseriesIndex && x.Region.PointIndex == clusterpointIndex });
	                rlength = region.length;
	                if (rlength > 0) {
	                    regions.push(region[0]);
	                    points.push(seriesCollection[region[0].SeriesIndex]._visiblePoints[pointIndex]);
	                }else
	                    points.push(seriesCollection[k]._visiblePoints[pointIndex]);
	            }
	            this.selectedPoint = pointIndex;
	            var sbRegion=[], colors=[];
	            ctx = this.createCanvasElement(chart._id + '_Selection_' + 'Cluster' + '_point_' + pointIndex + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
	            this.createRect(chart, ctx);
                for (i = 0, len = seriesCollection.length; i < len; i++) {
	                sbRegion=[];// scatter & bubble region calculation
                    highlight = seriesCollection[i].selectionSettings;
                    color = highlight.color;
                    opacity = highlight.opacity;
                    borderColor = highlight.border.color;
                    borderWidth = highlight.border.width;
                    patternName = highlight.pattern.toLowerCase();
                    fill = this.highlightFill(highlight, chart, i, pointIndex,  legendData);
                    color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, highlight);
                    colors.push(color);
                    for (var r = 0, rlen = regions.length; r < rlen; r++) {
                        if (regions[r].SeriesIndex == i) {
                            sbRegion.push(regions[r].Region);
                        }
                    }
                    if (seriesType.indexOf("column") != -1 || seriesType.indexOf("waterfall") != -1 || seriesType.indexOf("bar") != -1){
                        for (var sr = 0, srlen = sbRegion.length; sr < srlen; sr++) {
                            this.canvasSeriesRect(sbRegion[sr], opacity, borderColor, borderWidth, color, true, series);
                        }
                    }
                    else if (seriesType == 'bubble') 
                        this.canvasBubbleHighlight(highlight, sbRegion, chart, i, color, borderWidth, opacity, borderColor);
                    else if (seriesType == 'scatter') 
                        this.canvasScatterHighlight(sbRegion, color, borderWidth, opacity, borderColor);
                    if (!legendData && this.model.AreaType != 'none' && legendVisible) {
                        series = seriesCollection[i];
                        series.seriesIndex = i;
                        this.canvasHighlightLegend(chart, series, selectionSettings, 'SelectionCluster', containerStyle, color);
                    }
                }
            }
	    else if ((mode == 'point' && $('#' + chart._id + '_Selection_' + seriesIndex + '_point_' + pointIndex + '_canvas').length == 0) || this.model.AreaType == 'none') {
            this.selectedPoint = pointIndex;
	        
            points[0] = this.model._isPieOfPie? this._getPieOfPiePoint(pointIndex,series):series._visiblePoints[pointIndex];
            ctx = this.createCanvasElement(chart._id + '_Selection_series' + seriesIndex + '_point_' + pointIndex + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
            this.createRect(chart,ctx);
            color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, selectionSettings);
            if (seriesType.indexOf("column") != -1 || seriesType.indexOf("waterfall") != -1 || seriesType.indexOf("bar") != -1)
                this.canvasSeriesRect(regions[0], opacity, borderColor, borderWidth, color, true, series);
            else if (seriesType == 'pie' || seriesType == 'doughnut' || seriesType == "pieofpie")
                this.canvasHighlightCircle(chart, selectionSettings, pointIndex, opacity, borderColor, borderWidth, color, regions, seriesType, ctx);
            else if (seriesType == 'pyramid' || seriesType == 'funnel') 
                this.canvasHighlightPyramid(chart, regions[0], selectionSettings, ctx, opacity, borderColor, borderWidth, color, seriesType);
            else if (seriesType == 'bubble')  
                this.canvasBubbleHighlight(selectionSettings, regions, chart, seriesIndex, color, borderWidth, opacity, borderColor);
            else if (seriesType == 'scatter') 
                this.canvasScatterHighlight(regions, color, borderWidth, opacity, borderColor);
        }   
        // legend highlight (legend symbol)
        if (legendVisible && (mode != 'cluster' || legendData))
            this.canvasHighlightLegend(chart, series, selectionSettings, 'Selection', containerStyle, color);
        if (series.marker.visible == true && this.model.AreaType != 'none')
            this.canvasHighlightMarker(chart, series, points, selectionSettings, ctx, evt, colors);
    },

     // clip rect logic calculated here
    createRect: function (chart,ctx) {
        if (chart.model.AreaType != 'none') {
            ctx.lineWidth = 0;
            ctx.strokeStyle = 'transparent';
            ctx.rect(chart.model.m_AreaBounds.X, chart.model.m_AreaBounds.Y, chart.model.m_AreaBounds.Width, chart.model.m_AreaBounds.Height);
            ctx.clip();
            ctx.stroke();
            ctx.save();
        }
    },

     //canvas pyramid and funnel draw
    canvasHighlightPyramid: function (chart, regions, highlight, ctx, opacity, borderColor, borderWidth, color, seriesType) {
        var fill = (highlight.color != "" ? highlight.color : chart.model.pointColors[regions.PointIndex]);
        var measureTitle = (chart.model.title.text) ? ej.EjSvgRender.utils._measureText(chart.model.title.text, $(this.svgObject).width() - chart.model.margin.left - chart.model.margin.right, chart.model.title.font) : 0;
        var pyrX = chart.pyrX = ((chart.model.legend.position.toLowerCase() === "left") ? (chart.model.LegendViewerBounds.Width) : 0) + chart.model.elementSpacing + chart.model.margin.left;
        var pyrY = chart.pyrY = ((chart.model.legend.position.toLowerCase() === "top") ? (chart.model.LegendViewerBounds.Height) : 0) + ((chart.model.title.text) ? (chart.model._titleLocation.Y + measureTitle.height) : (chart.model.margin.top + chart.model.elementSpacing));
        var options = {
            'opacity': opacity,
            'stroke': borderColor,
            'stroke-width': borderWidth,
            'fill': color,
            'type': seriesType,
            'd': "M" + " " + (pyrX + regions.Line1.x) + " " + (pyrY + regions.Line1.y) + " " + "L" + " " + (pyrX + regions.Line2.x) + " " + (pyrY + regions.Line2.y) + " " + "L" + " " + (pyrX + regions.Line3.x) + " " + (pyrY + regions.Line3.y) + " " + "L" + " " + (pyrX + regions.Line4.x) + " " + (pyrY + regions.Line4.y) + " " + "z"
        }
        if (seriesType == 'funnel')
            options.d = "M" + " " + (pyrX + regions.Line1.x) + " " + (pyrY + regions.Line1.y) + " " + "L" + " " + (pyrX + regions.Line2.x) + " " + (pyrY + regions.Line2.y) + " " + "L" + " " + (pyrX + regions.Line3.x) + " " + (pyrY + regions.Line3.y) + " " + "L" + " " + (pyrX + regions.Line4.x) + " " + (pyrY + regions.Line4.y) + " " + "L" + " " + (pyrX + regions.Line5.x) + " " + (pyrY + regions.Line5.y) + " " + "L" + " " + (pyrX + regions.Line6.x) + " " + (pyrY + regions.Line6.y) + " " + "z";
        ej.EjCanvasRender.prototype.drawPath(options, ctx);
    },

     // canvas scatter logic
    canvasScatterHighlight: function (regions, color, borderWidth, opacity, borderColor) {
        var location, options = {}, size = {};
        for (var i = 0; i < regions.length; i++) {
            location = { startX: regions[i].Bounds.X + regions[i].Bounds.Height/2, startY: regions[i].Bounds.Y + regions[i].Bounds.Width/2 };
            size.height = regions[i].Bounds.Height;
            size.width = regions[i].Bounds.Width;
            options = {};
            options.ShapeSize = size;
            options.cx = location.startX;
            options.cy = location.startY;
            options.Style = {};
            options.Style.BorderColor = borderColor;
            options.Style.Color = color;
            options.Style.Opacity = opacity;
            options.Style.BorderWidth = borderWidth;
            ej.EjSvgRender.chartSymbol['_drawCircle'](location, options, this, ctx);
        }
    },

     // canvas bubble logic perform here
    canvasBubbleHighlight: function (highlight, regions, chart, seriesIndex, color, borderWidth, opacity, borderColor) {
        var size = 10, radius, fill, bubbleOptions = {};
        for (var i = 0; i < regions.length; i++) {
            radius = regions[i].Bounds.Height / 2;
            fill = (highlight.color != "" ? highlight.color : chart.model.seriesColors[seriesIndex]);
            bubbleOptions = {
                'cx': regions[i].Bounds.X - this.model.series[seriesIndex].xAxis.x + radius + this.canvasX,
                'cy': regions[i].Bounds.Y - this.model.series[seriesIndex].yAxis.y + radius+ this.canvasY,
                'r': radius,
                'fill': color,
                'stroke-width': borderWidth,
                'opacity': opacity,
                'stroke': borderColor
            };
            ej.EjCanvasRender.prototype.drawCircle(bubbleOptions, ctx);
        }
    },

     // canvas circle draw
    canvasHighlightCircle: function (chart, highlight, pointIndex, opacity, borderColor, borderWidth, color, regions, seriesType, ctx) {
        for (var i = 0; i < regions.length; i++) {
            var fill = (highlight.color != "" ? highlight.color : (highlight.mode == "series" && chart.model._visibleSeries.length > 1)?chart.model.pointColors[i]:chart.model.pointColors[pointIndex]);
            var options = {
                'opacity': opacity,
                'stroke': borderColor,
                'lineWidth': borderWidth,
                'color': color,
                'x': regions[i].StartX,
                'y': regions[i].StartY,
                'radius': chart.model._isPieOfPie ? chart.model.circularRadius[regions[i].PieSeriesIndex] : chart.model.circularRadius[regions[i].SeriesIndex],
                'innerRadius': chart.model.innerRadius[regions[i].SeriesIndex],
                'startAngle': regions[i].StartAngle,
                'endAngle': regions[i].EndAngle,
                'type': seriesType
            }
            this.highlightSegment(ctx, options);
        }
    },

     // canvas marker logic
    canvasHighlightMarker: function (chart, series, points, settings, ctx, evt,colors) {
        var highlight = settings;
        var patternName = highlight.pattern.toLowerCase();
        var seriesType = series.type.toLowerCase();
        var options = {};
        var fill = (highlight.color != "" ? highlight.color : chart.model.seriesColors[series.seriesIndex]);
        color = (patternName == "none" || patternName == "") ? fill : this.canvasPattern(ctx, chart, evt, fill, highlight);
        options.Style = {};
        options.Style.BorderColor = highlight.border.color;
        options.Style.Opacity = highlight.opacity;
        options.Style.BorderWidth = highlight.border.width;
        var symbolLocation, location, markerOptions, symbolName;
        for (var i = 0; i < points.length; i++) {
            symbolLocation = points[i].symbolLocation;
            symbolLocation = (seriesType.indexOf("line") != -1 || seriesType.indexOf("area") != -1) ? points[i].location : points[i].symbolLocation;
            if (symbolLocation) {
                location = this.model.AreaType == "cartesianaxes" ? { startX: symbolLocation.X + this.canvasX, startY: symbolLocation.Y + this.canvasY } : { startX: symbolLocation.X, startY: symbolLocation.Y };
                markerOptions = series.marker;
                symbolName;
                $.each(chart.model.symbolShape, function (name) {
                    if (markerOptions.shape.toLowerCase() == name.toLowerCase())
                        symbolName = name;
                });
                options.ShapeSize = markerOptions.size;
                options.r = Math.sqrt(markerOptions.size.height * markerOptions.size.height + markerOptions.size.width * markerOptions.size.width) / 2;
                options.cx = location.startX;
                options.cy = location.startY;
                options.Style.Color = colors?colors[i]:color;
                ej.EjSvgRender.chartSymbol['_draw' + symbolName](location, options, chart, ctx);
            }
        }

    },

     // canvas selction legend logic perform here
    canvasHighlightLegend: function (chart, series, settings, name, containerStyle, color) {
	var length =this.model._visibleSeries.length;
        var index =( chart.model.AreaType == 'none' && length == 1) ? series.pointIndex : series.seriesIndex,
        id = chart._id + '_' + name + '_Legend' + index + '_canvas';
        if ($('#' + id).length == 0 && index < series.points.length) {
            legendCtx = this.createCanvasElement(chart._id + '_' + name + '_Legend' + index + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
            if (chart.model.AreaType != 'none' || (chart.model.AreaType == "none" && length > 1))
                legendRegion = chart.model.legendRegion[series.seriesIndex];
            else
                legendRegion = chart.model.legendRegion[series.pointIndex];
            var legendBounds = { startX: legendRegion.Bounds.LegendBound.X + legendRegion.Location.startX, startY: legendRegion.Bounds.LegendBound.Y + legendRegion.Location.startY },
            svgData = { svgRenderer: chart.svgRenderer, svgObject: chart.svgObject },
            symbolStyle = { 'SeriesIndex': index, 'Style': { 'Color': color, 'Opacity': settings.opacity, 'Visibility': true, 'BorderWidth': 0, BorderColor: color }, 'context': true, 'ShapeSize': legendRegion.Style.ShapeSize }
            if (legendRegion.SymbolShape.toLowerCase() == 'seriestype') {
                chart.legendItem = legendRegion.LegendItem;
                ej.EjSvgRender.chartSymbol["_draw" + legendRegion.SymbolShape](legendBounds, symbolStyle, chart);
            }else                      
              ej.EjSvgRender.chartSymbol["_draw" + legendRegion.SymbolShape](legendBounds, symbolStyle, svgData, legendCtx);
        }
    },

     // canvas create element 
    createCanvasElement: function (id, width, height, style) {
        svgObj = document.createElement('canvas');
        _rootId = jQuery(this.element).attr("id");
        svgObj.setAttribute('id', id);
        svgObj.height = height;
        svgObj.width = width;
        svgObj.style["touch-action"] && (svgObj.style["touch-action"] = "none")
        svgObj.style["-ms-touch-action"] && (svgObj.style["-ms-touch-action"] = "none")
        this.svgRenderer.append(svgObj, this.element);
        var main = document.getElementById(id);
        main.style.left = style.left + $(document).scrollLeft() + 'px';
        main.style.top = style.top + $(document).scrollTop() + 'px';
        main.style.position = "absolute";

        return svgObj.getContext("2d");
    },

     // canvas pie doughnut logic
    highlightSegment: function (ctx, options) {
        ctx.save();
        ctx.beginPath();
        if (options.type == 'pie' || options.type == "pieofpie") {
            ctx.moveTo(options.x, options.y);
            ctx.arc(options.x, options.y, options.radius, options.startAngle - 1.57, options.endAngle - 1.57, false);
        } else {
            ctx.arc(options.x, options.y, options.radius, options.startAngle - 1.57, options.endAngle - 1.57, false);
            ctx.arc(options.x, options.y, options.innerRadius, options.endAngle - 1.57, options.startAngle - 1.57, true);
        }
        ctx.fillStyle = options.color;
        ctx.globalAlpha = options.opacity;
        ctx.fill();
        ctx.lineWidth = options.lineWidth;
        ctx.strokeStyle = options.stroke;
        ctx.clip();
        ctx.stroke();
        ctx.closePath();
        ctx.restore();        
    },

    // Canvas pattern started here
    canvasPattern: function (ctx, chart, evt, fill, settings) {

        var hoverStyle = settings;
        var name = hoverStyle.name;
        var style = hoverStyle.pattern.toLowerCase();
        var color = fill;
        var opacity = hoverStyle.opacity;
        var backgroundColor = "#ffffff";
        var borderColor = hoverStyle.border.color;
        var borderWidth = hoverStyle.border.width;
        var patternStyle = document.createElement('canvas');
        var patternContext = patternStyle.getContext('2d');
        var pathOptions = [], translate = [];
        switch (style) {
            case "chessboard":
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 10, 'height': 10, 'fill': 'white', 'stroke': 'white', 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = { 'x': 0, 'y': 0, 'width': 5, 'height': 5, 'fill': color, 'opacity': opacity, 'name': 'rect' };
                pathOptions[2] = { 'x': 5, 'y': 5, 'width': 5, 'height': 5, 'fill': color, 'opacity': opacity, 'name': 'rect' };
                patternStyle.width = 10;
                patternStyle.height = 10;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "pacman":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 18, 'height': 18, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 9.081 9.194 L 14.887 6.114 C 14.075000000000001 4.618 12.484 3.0620000000000007 10.596 3.0620000000000007 L 8.835 3.0620000000000007 C 6.138 3.063 3 6.151 3 8.723 L 3 10.402000000000001 C 3 12.974 6.138 16.063000000000002 8.835 16.063000000000002 L 10.596 16.063000000000002 C 12.681000000000001 16.063000000000002 14.431000000000001 14.303000000000003 15.131 12.549000000000003 L 9.081 9.194 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                patternStyle.width = 18;
                patternStyle.height = 18;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "crosshatch":
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 8, 'height': 8, 'fill': 'white', 'stroke': fill, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'd': 'M 0 0 L 8 8 Z',
                    'stroke-width': 1,
                    'stroke': color,
                    'name': 'path'
                };
                pathOptions[2] = {
                    'd': 'M 8 0 L 0 8 Z',
                    'stroke-width': 1,
                    'stroke': color,
                    'name': 'path'
                };
                patternStyle.width = 8;
                patternStyle.height = 8;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
             case "dots":
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 7, 'height': 7, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'cx': 3,
                    'cy': 3,
                    'r': 2,
                    'stroke-width': 1,
                    'fill': color,
                    'name': 'circle'
                };
                patternStyle.width = 7;
                patternStyle.height = 7;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "diagonalforward":
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 6, 'height': 6, 'fill': 'white', 'stroke': fill, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'd': 'M 3 -3 L 9 3 M 6 6 L 0 0 M 3 9 L -3 3',
                    'stroke-width': 2,
                    'stroke': color,
                    'name': 'path'
                };
                patternStyle.width = 6;
                patternStyle.height = 6;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "diagonalbackward":
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 6, 'height': 6, 'stroke-width': 2, 'fill': 'white', 'stroke': fill, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'd': 'M 3 -3 L -3 3 M 0 6 L 6 0 M 9 3 L 3 9',
                    'stroke-width': 2,
                    'stroke': color,
                    'name': 'path'
                };
                patternStyle.width = 6;
                patternStyle.height = 6;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "grid":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 6, 'height': 6, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'path',
                    'd': 'M 1 3.5 L 11 3.5 M 0 3.5 L 11 3.5 M 0 7.5 L 11 7.5 M 0 11.5 L 11 11.5 M 5.5 0 L 5.5 12 M 11.5 0 L 11.5 12 Z',
                    'stroke-width': 1,
                    'stroke': color
                };
                patternStyle.width = 6;
                patternStyle.height = 6;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "turquoise":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 17, 'height': 17, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 2.697 0.5319999999999996 C 3.8695005238907747 0.5319999999999996 4.82 1.4771268931071944 4.82 2.643 C 4.82 3.808873106892805 3.8695005238907747 4.754 2.697 4.754 C 1.5244994761092252 4.754 0.5739999999999998 3.808873106892805 0.5739999999999998 2.643 C 0.5739999999999998 1.4771268931071944 1.5244994761092252 0.5319999999999996 2.697 0.5319999999999996 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[2] = { 'name': 'path', 'd': 'M 13.928 0.5319999999999996 C 15.100500523890776 0.5319999999999996 16.051000000000002 1.4771268931071944 16.051000000000002 2.643 C 16.051000000000002 3.808873106892805 15.100500523890776 4.754 13.928 4.754 C 12.755499476109225 4.754 11.805 3.808873106892805 11.805 2.643 C 11.805 1.4771268931071944 12.755499476109225 0.5319999999999996 13.928 0.5319999999999996 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[3] = { 'name': 'path', 'd': 'M 8.313 0.5319999999999996 C 9.485500523890776 0.5319999999999996 10.436 1.4771268931071944 10.436 2.643 C 10.436 3.808873106892805 9.485500523890776 4.754 8.313 4.754 C 7.140499476109226 4.754 6.19 3.808873106892805 6.19 2.643 C 6.19 1.4771268931071944 7.140499476109226 0.5319999999999996 8.313 0.5319999999999996 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[4] = { 'name': 'path', 'd': 'M 13.928 6.16 C 15.100500523890776 6.16 16.051000000000002 7.105126893107196 16.051000000000002 8.271 C 16.051000000000002 9.436873106892806 15.100500523890776 10.382000000000001 13.928 10.382000000000001 C 12.755499476109225 10.382000000000001 11.805 9.436873106892806 11.805 8.271 C 11.805 7.105126893107196 12.755499476109225 6.16 13.928 6.16 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[5] = { 'name': 'path', 'd': 'M 8.313 6.16 C 9.485500523890776 6.16 10.436 7.105126893107196 10.436 8.271 C 10.436 9.436873106892806 9.485500523890776 10.382000000000001 8.313 10.382000000000001 C 7.140499476109226 10.382000000000001 6.19 9.436873106892806 6.19 8.271 C 6.19 7.105126893107196 7.140499476109226 6.16 8.313 6.16 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[6] = { 'name': 'path', 'd': 'M 13.928 11.787999999999998 C 15.100500523890776 11.787999999999998 16.051000000000002 12.733126893107194 16.051000000000002 13.899 C 16.051000000000002 15.064873106892804 15.100500523890776 16.009999999999998 13.928 16.009999999999998 C 12.755499476109225 16.009999999999998 11.805 15.064873106892804 11.805 13.899 C 11.805 12.733126893107194 12.755499476109225 11.787999999999998 13.928 11.787999999999998 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[7] = { 'name': 'path', 'd': 'M 8.313 11.787999999999998 C 9.485500523890776 11.787999999999998 10.436 12.733126893107194 10.436 13.899 C 10.436 15.064873106892804 9.485500523890776 16.009999999999998 8.313 16.009999999999998 C 7.140499476109226 16.009999999999998 6.19 15.064873106892804 6.19 13.899 C 6.19 12.733126893107194 7.140499476109226 11.787999999999998 8.313 11.787999999999998 Z', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                patternStyle.width = 17;
                patternStyle.height = 17;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "star":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 21, 'height': 21, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'path',
                    'd': 'M 15.913 18.59 L 10.762 12.842 L 5.613 18.75 L 8.291 11.422 L 0.325 9.91 L 8.154 8.33 L 5.337 0.91 L 10.488 6.658 L 15.637 0.75 L 12.959 8.078 L 20.925 9.59 L 13.096 11.17 z',
                    'stroke-width': 1,
                    'stroke': color,
                    'fill': color
                };
                patternStyle.width = 21;
                patternStyle.height = 21;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "triangle":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 10, 'height': 10, 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'path',
                    'd': 'M 4.987 0 L 7.48 4.847 L 9.974 9.694 L 4.987 9.694 L 0 9.694 L 2.493 4.847 z',
                    'stroke-width': 1,
                    'stroke': color,
                    'fill': color
                };
                patternStyle.width = 10;
                patternStyle.height = 10;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "circle":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 9, 'height': 9, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'circle',
                    'cx': 5.125,
                    'cy': 3.875,
                    'r': 3.625,
                    'stroke-width': 1,
                    'fill': color
                };
                patternStyle.width = 9;
                patternStyle.height = 9;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "tile":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 18, 'height': 18, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 0 9 L 0 0 L 9 0 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                pathOptions[2] = { 'name': 'path', 'd': 'M 9 9 L 9 0 L 18 0 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                pathOptions[3] = { 'name': 'path', 'd': 'M 0 18 L 0 9 L 9 9 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                pathOptions[4] = { 'name': 'path', 'd': 'M 9 18 L 9 9 L 18 9 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                patternStyle.width = 18;
                patternStyle.height = 18;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "horizontaldash":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 12, 'height': 12, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 0 1.5 L 10 1.5 M 0 5.5 L 10 5.5 M 0 9.5 L 10 9.5 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                patternStyle.width = 12;
                patternStyle.height = 12;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "verticaldash":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 12, 'height': 12, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 1.5 0 L 1.5 10 M 5.5 0 L 5.5 10 M 9.5 0 L 9.5 10 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                patternStyle.width = 12;
                patternStyle.height = 12;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "rectangle":
                pathOptions[0] = { 'x': 0, 'y': 0, 'name': 'rect', 'width': 12, 'height': 12, 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'rect', 'x': 1, 'y': 2, 'width': 4, 'height': 9, 'fill': color, 'opacity': opacity };
                pathOptions[2] = { 'name': 'rect', 'x': 7, 'y': 2, 'width': 4, 'height': 9, 'fill': color, 'opacity': opacity };
                patternStyle.width = 12;
                patternStyle.height = 12;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "box":
                pathOptions[0] = { 'x': 0, 'y': 0, 'name': 'rect', 'width': 13, 'height': 13, 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'rect', 'x': 1.5, 'y': 1.5, 'width': 10, 'height': 9, 'fill': color, 'opacity': opacity };
                patternStyle.width = 10;
                patternStyle.height = 10;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "horizontalstripe":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 10, 'height': 12, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 0 0.5 L 10 0.5 M 0 4.5 L 10 4.5 M 0 8.5 L 10 8.5 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                patternStyle.width = 10;
                patternStyle.height = 12;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "verticalstripe":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 12, 'height': 10, 'transform': "translate(0,0)", 'fill': 'white', 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M 0.5 0 L 0.5 10 M 4.5 0 L 4.5 10 M 8.5 0 L 8.5 10 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                patternStyle.width = 12;
                patternStyle.height = 10;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
            case "bubble":
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 20, 'height': 20, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'circle', 'cx': 5.217, 'cy': 11.325, 'r': 3.429, 'stroke-width': 1, 'fill': '#D0A6D1' };
                pathOptions[2] = { 'name': 'circle', 'cx': 13.328, 'cy': 6.24, 'r': 4.884, 'stroke-width': 1, 'fill': color };
                pathOptions[3] = { 'name': 'circle', 'cx': 13.277, 'cy': 14.66, 'r': 3.018, 'stroke-width': 1, 'fill': '#D0A6D1' };
                patternStyle.width = 20;
                patternStyle.height = 20;
                this.loadPattern(chart, pathOptions, '', patternContext);
                break;
              
           
           
            case "custom":
                patternStyle = document.getElementById(hoverStyle.customPattern);
                break;
        }
        var pattern = ctx.createPattern(patternStyle, 'repeat');
        return pattern;
    },
     // Canvas pattern end
     // Canvas highlight and selection end
    
    //Get selected class for removing lengeds selection in multiselection mode
    foundClasses: function (id) {
        var pointClasses = [];
        $("[id*=" + id + "]").each(function () {
            var pointClass = $(this).attr('class') ? $(this).attr('class') : '';
            if (pointClass.indexOf('Selection') >= 0) {
                pointClasses.push(pointClass);
            }
        });
        return pointClasses;
    },
     // SVG selection started here
    selection: function (chart, evt, series, tracker, legendData, seriesIndex, pointIndex, parentNodeId, targetId, data) {
        var clusterPoints = this.model.clusterPoints,
        clusterPointslength = clusterPoints ? clusterPoints.length : 0,
        seriesCollection = this.model._visibleSeries,
        seriesLenth = seriesCollection.length,
        index = (this.model.AreaType == 'none' && seriesLenth == 1 ) ? pointIndex : seriesIndex,
        highlight = series.selectionSettings,
        isMultiSelection = this.model._visibleSeries[seriesIndex].selectionSettings.type.toLowerCase() == 'multiple' ? true : false,
        name = 'series' + seriesIndex,
        found_class = false,
        pathName = $('#' + targetId).attr('name'),
        patternName = highlight.pattern.toLowerCase(),
        mode = highlight.mode, isElement;
        if (parentNodeId)
             isElement = (parentNodeId.indexOf(this.svgObject.id + "_SeriesGroup_") >= 0 ||parentNodeId.indexOf(this.svgObject.id + "_Chart3D") >= 0) ? true : false;
              
        if (this.model.AreaType != 'none' ||( this.model.AreaType == 'none' && mode == "series" && seriesLenth > 1)) {
            $('style').each(function () {
                if ($(this).html().indexOf('.' + chart._id + 'SelectionStyle' + name) > -1) {
                    found_class = true;
                }
            });
        }    
        if (!chart.vmlRendering && this.model.enable3D) {
            if ((mode == 'series' || legendData) && (this.model.AreaType != 'none'|| (this.model.AreaType == 'none' && seriesLenth != 1))) {
                this.highlightSeries(chart, seriesIndex, pointIndex, 'Selection', name, highlight, evt, legendData,data)
                $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class', 'Selection' + name + 'Style' + name + '1');
            }
            else if (mode == 'cluster' && chart.model.AreaType != 'none') 
                this.highlightCluster(chart, seriesIndex,pointIndex, 'Selection', name, highlight, evt, data)
            else {
                if (this.model.AreaType == 'none') {
                    this.highlightPoint(chart, seriesIndex, pointIndex, 'Selection', name + index, highlight, evt, data);
                    $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class', 'Selection' + name + index + 'Style' + name + index + '1');
                }else
                {
                    this.highlightPoint(chart, seriesIndex, pointIndex, 'Selection', name, highlight, evt,data)
                    $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class', 'Selection' + name + 'Style' + name + '1');
                }                                               
            }
        }
        else {
            if ((mode != 'cluster' || legendData) || chart.model.AreaType == 'none') {
                var colorStyle = {};
                colorStyle.name = "2D",
                colorStyle.index =this.model.AreaType=='none'? index : seriesIndex; colorStyle.api = "Selection",
                colorStyle.color = highlight.color != "" ? highlight.color : legendData ? (this.model.AreaType == 'none' ? this.model.pointColors[index] : this.model.seriesColors[index]) :
                    $('#' + targetId).attr('fill') != 'none' ? $('#' + targetId).attr('fill') : $('#' + targetId).attr('stroke');
                if (Object.prototype.toString.call(colorStyle.color) === '[object Array]')
                    colorStyle.color = colorStyle.color[1].color;
                var fill = ((patternName == "none" || chart.vmlRendering) || patternName == "") ? highlight.color : this.pattern(chart, evt, colorStyle, highlight),
                opacity = highlight.opacity,
                strokeColor = highlight.border.color,
                strokeWidth = highlight.border.width;
                if (!found_class) {
                    if (this.model.AreaType == 'none' &&(((mode == 'series' || legendData) && seriesLenth == 1)||( mode != 'series' && !legendData))) {
                        $('style').each(function () {
                            if ($(this).html().indexOf('.SelectionStyle' + name + 'Point' + index) > -1) {
                                found_class = true;
                            }
                        });
                        if (!found_class) {
                              this.createStyle(chart, chart._id + 'Selection', name + 'Point' + index, opacity, fill, strokeColor, strokeWidth);
                                this.createStyle(chart, chart._id + 'SelectionLegend', name + 'Point' + index, opacity, fill, 'transparent', 0);
                        }
                    } else if (this.model.AreaType == 'none' && seriesLenth > 1 ||this.model.AreaType != 'none') {
                            this.createStyle(chart, chart._id + 'Selection', name, opacity, fill, strokeColor, strokeWidth);
                            this.createStyle(chart, chart._id + 'SelectionLegend', name, opacity, fill, 'transparent', 0);
                    }
                    
                }
            }        
            if ((mode == 'series' || legendData) && ((chart.model.AreaType == 'none' && seriesLenth > 1)||(chart.model.AreaType != 'none'))) {
                if (!isElement) {
                    var otherElements = $('#' +parentNodeId).childNodes?$('#' +parentNodeId).childNodes:[];
                    for (var i = 0; i < otherElements.length; i++)
                     $('#' + otherElements[i].id).attr('class', chart._id + 'SelectionStyle');
                }
                $("[id*=" + this.svgObject.id + '_Series' + index + "]").each(function () {
                    if (this.parentNode.id == chart.svgObject.id + '_SeriesGroup_' + index || this.parentNode.id == chart.svgObject.id + '_symbolGroup_' + index) {
                         var className = $(this).attr("name") ? chart._id + 'SelectionPathStyle' + name : chart._id + 'SelectionStyle' + name;
                        $(this).attr('class', className);
                    }
                });

              //for legend selection sets here              
              $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class', chart._id +'SelectionLegendStyle' + name);

                // removed tracker symbol
                if (tracker) $('#' + parentNodeId).remove();
                 
            }

            else if (mode == "cluster" && (chart.model.AreaType != 'none') && !ej.util.isNullOrUndefined(targetId)) {
                var matchString, clustername, indexVal, text, colorStyle, opacity, strokeColor, fill, strokeWidth;
                matchString = this.svgObject.id + "_Series";
                var clusterPoints = chart.model.clusterPoints;
                index = targetId.match(/(\d+)/g);
                pointIndex = parseInt(index[index.length - 1]);
                if (targetId.indexOf('SeriesText') >= 0) {
                    var datas = this.GetSeriesPoint(evt);
                    pointIndex = datas.region.Region.PointIndex;
                }
                var findClass, seriesSelectionIndex;
                for (k = 0; k < clusterPoints.length; k++) {
                    seriesSelectionIndex = clusterPoints[k].seriesIndex;
                    name = 'ClusterSeries' + k;
                    //creating individual styles for the points in different series
                    colorStyle = {};
                    colorStyle.index = k;
                    colorStyle.name = "2D"; colorStyle.api = "Selection" + name;
                    highlight = seriesCollection[seriesSelectionIndex].selectionSettings;
                    colorStyle.color = highlight.color != "" ? highlight.color : this.model.seriesColors[seriesSelectionIndex];
                    if (Object.prototype.toString.call(colorStyle.color) === '[object Array]')
                        colorStyle.color = colorStyle.color[1].color;
                    opacity = highlight.opacity;
                    var strokeColor = highlight.border.color;
                    var strokeWidth = highlight.border.width;
                    var fill = ((patternName == "none" || chart.vmlRendering) || patternName == "") ? colorStyle.color : this.pattern(chart, evt, colorStyle, highlight);                   
                    $('style').each(function () {
                        if ($(this).html().indexOf('.' + chart._id + 'SelectionStyle' + name) > -1) {
                            findClass = true;
                        }
                    });
                    if (!findClass) {
                        this.createStyle(chart, chart._id+'Selection', name, opacity, fill, strokeColor, strokeWidth);
                        this.createStyle(chart, chart._id +'SelectionLegend', name, opacity, fill, 'transparent', 0);
                    }                    
                    var className = $('#' + matchString + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex).attr("name") ? chart._id +'SelectionPathStyle' + name :chart._id + 'SelectionStyle' + name;
                    $('#' + matchString + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex).attr('class', className);
                    $('#' + matchString + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex + '_symbol').attr('class', className);
                    if (chart.model._visibleSeries[seriesSelectionIndex].visibility != "hidden")
                        $('#' + this.svgObject.id + '_LegendItemShape' + k).not("[class*='Highlight']").attr('class', chart._id+'SelectionLegendStyle' + name);
					// checked condition for financial series
                    var finName = $('#' + targetId).attr("name");
                    if (finName != undefined && (finName == 'candle' || finName.indexOf('hilo') >= 0)) {
                        $('[id$=' + matchString + clusterPoints[k].seriesIndex + '_' + 'Point' + clusterPoints[k].pointIndex + ']').attr('class', 'HighlightStyle' + name);
                    }
                }
                if (tracker) {
                    $('#' + this.svgObject.id + '_Series' + k + '_Point' + pointIndex).attr('class', chart._id +'SelectionStyle' + name);
                    $('#' + this.svgObject.id + '_Series' + k + '_Point' + pointIndex + '_symbol').attr('class', chart._id+'SelectionStyle' + name);
                    $('#' + parentNodeId).remove();
                }
            }


            else {
                // checked condition for whether target id is area related or not
                if ((!$('#' + targetId).attr("name") && targetId != chart.svgObject.id + '_Series' + index) && chart.model.AreaType != 'none') {
                    $('#' + targetId).attr('class',chart._id + 'SelectionStyle' + name);
                    if (this.model.commonSeriesOptions.columnFacet == 'cylinder'|| series.columnFacet=='cylinder') {
                        for (i = 0; i < 2; i++) {
                            $('#' + targetId.replace(/2$/, i)).attr('class', chart._id + 'SelectionStyle' + name);
                        }
                    }
                    $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class', chart._id +'SelectionLegendStyle' + name);
                    $('#' + targetId + '_symbol').attr('class', chart._id +'SelectionStyle' + name);

                    if (tracker) {
                        $('#' + targetId + '_symbol').attr('class', chart._id +'SelectionStyle' + name);
                        $('#' + parentNodeId).remove();
                    }
                } else{             
                     $('#' + targetId).attr('class', chart._id +'SelectionStyle' + name + 'Point' + index);
                     $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class',chart._id + 'SelectionLegendStyle' + name + 'Point' + index);
                    if (tracker) $('#' + parentNodeId).remove();
                }

                // checked condition for financial series
                var finName = $('#' + targetId).attr("name");
                if (finName != undefined && (finName == 'candle' || finName.indexOf('hilo') >= 0)) {
                    $('[id$=' + targetId + ']').attr('class', chart._id +'SelectionStyle' + name);
                    $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class', chart._id +'SelectionLegendStyle' + name);
                }
            }
        }
    },

     //Selection Removing Logic
    removeSelection: function (seriesIndex, pointIndex, seriesCollection, mode, isMultiSelection, legendData, isSelected) {
       var seriesLength = seriesCollection.length,
       clusterPoints=this.model.clusterPoints,
       clusterPointslength = clusterPoints ? clusterPoints.length : 0;       
       //Removing selectiond mode series
       if ((mode == 'series' || legendData) && (this.model.AreaType != 'none' || (this.model.AreaType == 'none' && seriesLength > 1))) {
              for (i = 0; i < seriesLength; i++) {
                  selectionSettings = seriesCollection[i].selectionSettings;
                  if ((selectionSettings.mode != 'point' && selectionSettings.type.toLowerCase() == 'single') || (legendData && selectionSettings.type.toLowerCase() == 'single')) {
                      $(this.svgObject).find('[id*=' + this.svgObject.id + '_SeriesGroup_' + i + '],[id*=' + this.svgObject.id + '_symbolGroup_' + i + '],[id*=_Region_Series_' + i + '_]').each(function () {
                          $(this).find("*").attr('class', '');
                          $(this).attr('class', '');
                      });
                      $('#' + this._id + '_Selection_Legend' + i + '_canvas').remove();
                      $('#' + this._id + '_Selection_series' + i + '_canvas').remove();
                      $("[id*=" + '_Region_Series_' + i + "]").attr('class', '');
                      $('#' + this.svgObject.id + '_LegendItemShape' + i).attr('class', '');
                  } else if (isSelected && selectionSettings.type.toLowerCase() == 'multiple') {
                      $('#' + this._id + '_Selection_series' + seriesIndex + '_canvas').remove();
                      $('#' + this._id + '_Selection_Legend' + seriesIndex + '_canvas').remove();
                      $("[id*=" + '_Region_Series_' + seriesIndex + "]").attr('class', '');
                      $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + "]").attr('class', '');
                      $('#' + this.svgObject.id + '_LegendItemShape' + seriesIndex).attr('class', '');
                  }
              }
       }
       //Removing selection mode Cluster
       if (mode == 'cluster' && this.model.AreaType != 'none' && !legendData) {
           if (!isMultiSelection) {
               if (this.model.enableCanvasRendering) {
                   $('[id*=' + this._id + '_Selection_Cluster' + ']').remove();
                   $('[id*=' + this._id + '_SelectionCluster_Legend' + ']').remove();
                   this.selectedPoint = null;
               }else
                 for (var k = 0; k < clusterPointslength; k++) {
                     $("[id*=" + '_Region_Series_' + clusterPoints[k].seriesIndex + '_Point_' + "]").attr('class', '');
                     $("[id*=" + this.svgObject.id + '_Series' + clusterPoints[k].seriesIndex + '_Point' + "]").attr('class', '');
                     $('#' + this.svgObject.id + '_LegendItemShape' + clusterPoints[k].seriesIndex).attr('class', '');
                 }
           }
           else {
               if (!this.model.enableCanvasRendering) {
                   for (var k = 0; k < clusterPointslength; k++) {
                       $("[id*=" + "_Region_Series_" + clusterPoints[k].seriesIndex + "_Point_" + clusterPoints[k].pointIndex + "]").attr('class', '');
                       $("[id*=" + this.svgObject.id + '_Series' + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex + "]").attr('class', '');
                   }
                   pointClasses = this.model.enable3D ? this.foundClasses('_Region_Series_' + seriesIndex) : this.foundClasses(this.svgObject.id + '_Series' + seriesIndex);
                   (pointClasses.length == 0) ? $("[id*=" + this.svgObject.id + '_LegendItemShape' + "]").attr('class', '') : 0;
               } else {
                   $('[id*=' + this._id + '_Selection_Cluster' + '_point_' + pointIndex + ']').remove();
                   $('[id*=' + this._id + '_Selection_Cluster' + ']').length == 0 ? $('[id*=' + this._id + '_SelectionCluster_Legend' + ']').remove() : 0;
               }
          }
       }

      //Removing selection mode point
       if (mode == 'point' && this.model.AreaType != 'none' && !legendData) {
           if (!isMultiSelection) {
               $('[id*=' + this._id + '_Selection_series' + seriesIndex + '_point_' + ']').remove();
               $('[id*=' + this._id + '_Selection_Legend' + seriesIndex + ']').remove();
               $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + "]").attr('class', '');
               $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + '_Point' + "]").attr('class', '');
               $('#' + this.svgObject.id + '_LegendItemShape' + seriesIndex).attr('class', '');
           }
           else {               
               $('#' + this._id + '_Selection_series' + seriesIndex + '_point_' + pointIndex + '_canvas').remove();               
               $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + pointIndex + "]").attr('class', '');
               $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex + "]").attr('class', '');
               $("[id*=" + this._id + '_Selection_series' + seriesIndex + "]").length == 0 ? $('#' + this._id + '_Selection_Legend' + seriesIndex + '_canvas').remove() : 0;
               pointClasses = this.model.enable3D ? this.foundClasses('_Region_Series_' + seriesIndex) : this.foundClasses(this.svgObject.id + '_Series' + seriesIndex);
               (pointClasses.length == 0) ? $('#' + this.svgObject.id + '_LegendItemShape' + seriesIndex).attr('class', '') : 0;
           }
       }

       //Removing accoumulation series types selections
       if ((mode == 'point' || mode == 'cluster')||(mode == "series" && this.model._visibleSeries.length == 1) && this.model.AreaType == 'none'  && !legendData  ) {
           if (!isMultiSelection) {              
               $("[id*=" + this._id + '_Selection_series' + ']').remove();
               $("[id*=" + this._id + '_Selection_Legend' + ']').remove()
               $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + "]").attr('class', '');
               $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + '_Point' + "]").attr('class', '');
              (this.model._visibleSeries.length > 1)?$("[id*=" + this.svgObject.id + '_LegendItemShape' + seriesIndex + "]").attr('class', ''): $("[id*=" + this.svgObject.id + '_LegendItemShape' + "]").attr('class', '');
           } else {
               $('#' + this._id + '_Selection_series' + seriesIndex + '_point_' + pointIndex + '_canvas').remove();
               $("[id*=" + '_Region_Series_' + seriesIndex + '_Point_' + pointIndex + "]").attr('class', '');               
               $("[id*=" + this.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex + "]").attr('class', '');
               (this.model._visibleSeries.length > 1)? $('#' + this.svgObject.id + '_LegendItemShape' + seriesIndex).attr('class', ''): $('#' + this.svgObject.id + '_LegendItemShape' + pointIndex).attr('class', '');
               (this.model._visibleSeries.length > 1) ? $('#' + this._id + '_Selection_Legend' + seriesIndex + '_canvas').remove() : $('#' + this._id + '_Selection_Legend' + pointIndex + '_canvas').remove();
           }
       }        
    },
     // style append operation perform here
    createStyle: function (chart, api,name, opacity, fill, strokeColor, strokeWidth, strokeOpacity) {
        if (chart.vmlRendering) {
            var style = document.createElement('style');
            style.id = api + "Segment";
            opacity = opacity * 100;
            var text = "." +api+"Style" + name + " {filter: alpha(opacity=" + opacity + ");}."+api+"PathStyle" + name + "  {filter: alpha(opacity=" + opacity + ");}";
            style.setAttribute("type", "text/css");
            if (style.styleSheet) {   // for IE
                style.styleSheet.cssText = text;
            } else {                // others
                var textnode = document.createTextNode(text);
                style.appendChild(textnode);
            }
            var header = document.getElementsByTagName('head')[0];
            header.appendChild(style);
        } else {
            $("<style id="+api+"Segment" + name + " type='text/css'> ."+api+"Style" + name + "{ fill:" + fill + ";opacity:" + opacity + ";stroke:" + strokeColor + ";stroke-width:" + strokeWidth + ";stroke-opacity:" + strokeOpacity + "}</style>").appendTo("body");
            $("<style id=" + api + "Path" + name + " type='text/css'> ." + api + "PathStyle" + name + "{ opacity:" + opacity + ";stroke:" + strokeColor + ";stroke-width:" + strokeWidth + ";stroke-opacity:" + strokeOpacity + "}</style>").appendTo("body");
        }
    },

     // point highlight 3D perform here
    highlightPoint: function (chart, seriesIndex, pointIndex,api,name,highlight,evt ) {
        var pathId = "_Region_Series_" + seriesIndex + "_Point_" + pointIndex,
        gElement = $(this.svgObject).find('[id$=' + pathId + '],[id*=' + pathId + 'back],[id*=' + pathId + 'front]');
        for (var i = 0; i < gElement.length; i++) {
            var style3D = [];
            style3D.api = api+name; style3D.seriesName = name;
            style3D.name = $("[id=" + gElement[i].id + "]").attr('name');
            style3D.index = i;
            var color = this.highlightFill(highlight, chart, seriesIndex, pointIndex);
            var className = ($('#' + gElement[i].id).attr('class'));
            className = className ? className : '';
            if (className.indexOf('Selection') < 0 ) {
                $("[id=" + gElement[i].id + "]").attr('class', this.dStyle(style3D, color, chart, evt, highlight));
            }
        }
    },
       //cluster highlight of 3D is perfomed here
    highlightCluster: function (chart, seriesIndex, pointIndex, api, name, highlight, evt) {
        if (chart.model.AreaType != 'none') {
            var name, pathId, gElement, style3D, color, classname, clusterPoints = [];
            var xvalue = chart.model._visibleSeries[seriesIndex]._visiblePoints[pointIndex].x;
            for (var i = 0, len = chart.model._visibleSeries.length; i < len ; i++) {
                for (var j = 0; j < chart.model._visibleSeries[i]._visiblePoints.length; j++) {
                    if (xvalue == chart.model._visibleSeries[i]._visiblePoints[j].x)
                        clusterPoints[clusterPoints.length] = { seriesIndex: i, pointIndex: j };
                }
            }
            for (k = 0; k < clusterPoints.length; k++) {
                name = 'series' + k;
                pathId = "_Region_Series_" + clusterPoints[k].seriesIndex + "_Point_" + clusterPoints[k].pointIndex;
                 gElement = $(this.svgObject).find('[id$=' + pathId + '],[id*=' + pathId + 'back],[id*=' + pathId + 'front]');
                 for (var j = 0; j < gElement.length; j++) {
                        style3D = [];
                        style3D.api = api + name; style3D.seriesName = 'series' + k;
                        style3D.name = $("[id=" + gElement[j].id + "]").attr('name');
                        style3D.index = j;
                        seriesIndex = k;
                        highlight = (api == 'Highlight') ? chart.model._visibleSeries[k].highlightSettings : chart.model._visibleSeries[k].selectionSettings;
                        color = this.highlightFill(highlight, chart, seriesIndex, pointIndex);
                        className = ($('#' + gElement[j].id).attr('class'));
                        className = className ? className : '';
                        if ((className.indexOf('Selection' + name + 'Style') < 0) && (className.indexOf('SelectionStyle') < 0)) {
                            $("[id=" + gElement[j].id + "]").attr('class', this.dStyle(style3D, color, chart, evt, highlight));
                        }

                    }
                    if (api == 'Highlight')
                        $('#' + this.svgObject.id + '_LegendItemShape' + k).not("[class*='Selection']").attr('class', 'Highlight' + name + 'Style' + name + '1');
                    else
                        $('#' + this.svgObject.id + '_LegendItemShape' +k).attr('class', 'Selection' + name + 'Style' + name + '1');
                }

       }
    },  
     // point series 3D perform here
    highlightSeries: function (chart, seriesIndex, index, api, name, highlight, evt, legendData){      
        var seriesIndex = seriesIndex,
        pointIndex = index,
	   length =chart.model._visibleSeries.length,
        pathId = (chart.model.AreaType == 'none' && length == 1) ? "_Region_Series_" + seriesIndex + "_Point_" + index : "_Region_Series_" + seriesIndex + "_Point_",
        gElement = $(this.svgObject).find('[id*=' + pathId + ']'), style3D,color,
        className = legendData ? $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class') : evt ? ($('#' + evt.target.id).attr('class')) : '';
        className = className ? className : '';
        if (className.indexOf('SelectionStyle') < 0 || legendData) {
            for (var i = 0; i < gElement.length; i++) {
                style3D = [];
                style3D.api = api + name, style3D.seriesName = name,
                style3D.name = $("[id=" + gElement[i].id + "]").attr('name'),
                style3D.index = i;
                color = this.highlightFill(highlight, chart, seriesIndex, pointIndex, legendData);
				className = $('#' + gElement[i].id).attr('class');
                className = className ? className : '';
                if (className.indexOf('SelectionStyle') < 0&& (className.indexOf('Selection' + name + 'Style') < 0)) {
                    $("[id=" + gElement[i].id + "]").attr('class', this.dStyle(style3D, color, chart, evt, highlight));
                }
            }
        }
    },

     //SVG highlight logic started here
    highlight: function (chart, evt, series, legendData, data, parentNodeId, targetID, tracker) {
        var highlight = series.highlightSettings;
        var seriesIndex = $.inArray(series, chart.model._visibleSeries);
        var name = 'series' + seriesIndex;//series.name.replace(/ /g, ''); // removed space for series name
        var found_class = false;
        var index = seriesIndex;
        var targetId = targetID || evt.target.id;
        var matched = jQuery.uaMatch(navigator.userAgent);         
        if (!tracker && this.isTouch(evt) && matched.browser == 'chrome') {
            myLocation = evt.originalEvent.changedTouches[0];
            targetId = document.elementFromPoint(myLocation.clientX, myLocation.clientY).id;
        }
        parentNodeId = parentNodeId || evt.target.parentNode.id;
        var isElement = (parentNodeId.indexOf(this.svgObject.id + "_SeriesGroup_") >= 0 || parentNodeId.indexOf(this.svgObject.id + "_Chart3D") >= 0) ? true : false;
        var pathName = $('#' + targetId).attr('name');
        var patternName = highlight.pattern.toLowerCase();
		var length =chart.model._visibleSeries.length;
        if (chart.model.AreaType == 'none' && length == 1  )
        {
            if (!chart.model.enable3D) {
                var matchStr = legendData ? this.svgObject.id + '_LegendItemShape' : this.svgObject.id + "_Series" + seriesIndex + "_Point";
                var id = legendData ? this.svgObject.id + '_LegendItemShape' + legendData.legendItem.LegendItem.PointIndex : targetId;
                pointIndex = id.substr(matchStr.length);
                index = pointIndex;
            } else {
                index = legendData ? legendData.legendItem.LegendItem.PointIndex:data.region.Region.PointIndex;
            }
        }
        $('style').each(function () {
            if ($(this).html().indexOf('.HighlightStyle'+ name) > -1) {
                found_class = true;
            }
        });
        if (chart.model.enable3D && !chart.vmlRendering) {
            if ((highlight.mode == 'series' || legendData) && ((chart.model.AreaType == 'none' && length != 1) || chart.model.AreaType != 'none')) {
                this.highlightSeries(chart, seriesIndex, index, 'Highlight', name , highlight, evt, legendData)
                $('#' + this.svgObject.id + '_LegendItemShape' + index).not("[class*='Selection']").attr('class', 'Highlight' + name  + 'Style' + name  + '1');
            } else if (highlight.mode == 'cluster' && chart.model.AreaType != 'none') {
                this.highlightCluster(chart, seriesIndex, data.pointData.pointIndex, 'Highlight', name, highlight, evt);
                
            } else {
                pointIndex = data ? data.pointData.pointIndex: index ;
                this.highlightPoint(chart, seriesIndex, pointIndex, 'Highlight', name + pointIndex, highlight, evt)
                $('#' + this.svgObject.id + '_LegendItemShape' + index).not("[class*='Selection']").attr('class', 'Highlight' + name + pointIndex + 'Style' + name + pointIndex + '1');
            }
        } else {
            if (highlight.mode || this.model.AreaType=='none') {
                var colorStyle = {};
                colorStyle.name = "2D";
                colorStyle.index =seriesIndex; colorStyle.api = "Highlight"; colorStyle.color = highlight.color != "" ? highlight.color : legendData ? (this.model.AreaType == 'none' ? this.model.pointColors[index] : this.model.seriesColors[index]) : $('#' + targetId).attr('fill');
                if (Object.prototype.toString.call(colorStyle.color) === '[object Array]')
                    colorStyle.color = colorStyle.color[1].color;
                var fill = ((patternName == "none" || chart.vmlRendering) || patternName == "") ? highlight.color : this.pattern(chart, evt, colorStyle, highlight);
                var opacity = tracker ? 1 : highlight.opacity;
                var strokeColor = (tracker) ? ((series.type.toLowerCase().indexOf("hilo") == -1) ?  chart.model.highlightColor : fill) : highlight.border.color;
                var strokeWidth = tracker ? 3.5 : highlight.border.width;
                var strokeOpacity = (tracker && series.type.toLowerCase().indexOf("hilo")==-1)  ? 0.5 : 1;
                if (!found_class) {
                    this.createStyle(chart, 'Highlight', name, opacity, fill, strokeColor, strokeWidth, strokeOpacity);
                    this.createStyle(chart, 'HighlightLegend', name, opacity, fill, 'transparent', 0, strokeOpacity);
                }
            }

            // sets the style for the segment or path started here
            var className = legendData ? $('#' + this.svgObject.id + '_LegendItemShape' + index).attr('class') : $('#' + targetId).attr('class');
            className = className ? className : '';
            if (className.indexOf("Selection")==-1) {
                // checked mode of the highlight series
                if (((highlight.mode == 'series' && !tracker) || legendData) && ((chart.model.AreaType == 'none' && length != 1) || chart.model.AreaType != 'none')) {
                        $("[id*=" + this.svgObject.id + '_Series' + index + "]").each(function () {
                            if (this.parentNode.id == chart.svgObject.id + '_SeriesGroup_' + index || this.parentNode.id == chart.svgObject.id + '_symbolGroup_' + index) {
                                var selectClass = $(this).attr('class');
                                var className = $(this).attr("name") ? 'HighlightPathStyle' + name : 'HighlightStyle' + name;
                                // this condition is checked for whether already selected and it's symbol
                                if (selectClass != 'SelectionStyle' + name && selectClass != 'SelectionStyleClusterSeries' + seriesIndex && selectClass != 'SelectionPathStyle' + name && parentNodeId.indexOf(chart.svgObject.id + '_symbolGroup_' + index) <= 0) {
                                    $(this).attr('class', className);
                                }
                            }
                        });                    
                    //for legend highlight sets here
                    $('#' + this.svgObject.id + '_LegendItemShape' + index).not("[class*='Selection']").attr('class', 'HighlightLegendStyle' + name);
                }
                else if (highlight.mode == "cluster" && chart.model.AreaType != 'none' && !tracker) {
                    var matchString = this.svgObject.id + "_Series";
                    var clusterPoints = [],seriesHighlightIndex;
                    index = targetId.match(/(\d+)/g);
                    if (index && targetId.toLowerCase().indexOf("point") > 0) {
                        pointIndex = parseInt(index[index.length - 1]);
                        var xvalue = chart.model._visibleSeries[seriesIndex]._visiblePoints[pointIndex].xValue;
                        for (var i = 0, len = chart.model._visibleSeries.length; i < len ; i++) {
                            for (var j = 0; j < chart.model._visibleSeries[i]._visiblePoints.length; j++) {
                                if (xvalue == chart.model._visibleSeries[i]._visiblePoints[j].xValue)
                                    clusterPoints[clusterPoints.length] = { seriesIndex: i, pointIndex: j };
                            }
                        }
                    }
                    for (k = 0; k < clusterPoints.length; k++) {
                        seriesHighlightIndex = clusterPoints[k].seriesIndex;
                        name = 'series' + seriesHighlightIndex;
                        //creating individual styles for the points in different series
                        colorStyle = {};
                        colorStyle.name = "2D"; colorStyle.api = "Highlight" + name;
                        highlight = chart.model._visibleSeries[seriesHighlightIndex].highlightSettings;
                        colorStyle.color = highlight.color != "" ? highlight.color : this.model.seriesColors[seriesHighlightIndex];
                        if (Object.prototype.toString.call(colorStyle.color) === '[object Array]')
                            colorStyle.color = colorStyle.color[1].color;
                        opacity = highlight.opacity;
                        strokeColor = highlight.border.color;
                        strokeWidth = highlight.border.width;
                        fill = ((patternName == "none" || chart.vmlRendering) || patternName == "") ? colorStyle.color : this.pattern(chart, evt, colorStyle, highlight);
                        if (!found_class) {
                            this.createStyle(chart, 'Highlight', name, opacity, fill, strokeColor, strokeWidth);
                            this.createStyle(chart, 'HighlightLegend', name, opacity, fill, 'transparent', 0);
                        }
                        
                        //applying the created style to the selected element 
                        var selectClass = $('#' + matchString + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex).attr('class');
                        var symbol = $('#' + matchString + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex + '_symbol').attr('class');
                        var className = $('#' + matchString + clusterPoints[k].seriesIndex + '_Point' + clusterPoints[k].pointIndex).attr("name") ? 'HighlightPathStyle' + name : 'HighlightStyle' + name;
                        // this condition is checked for whether already selected and it's symbol
                        if (selectClass != 'SelectionStyle' + 'series' + k && selectClass != 'SelectionPathStyle' + name && parentNodeId.indexOf(chart.svgObject.id + '_symbolGroup_' + k) <= 0) {
                            $('#' + matchString + clusterPoints[k].seriesIndex + '_' + 'Point' + clusterPoints[k].pointIndex).attr('class', className);
                            $('#' + matchString + clusterPoints[k].seriesIndex + '_' + 'Point' + clusterPoints[k].pointIndex + '_symbol').attr('class', className);
                        }
                        if (chart.model._visibleSeries[seriesHighlightIndex].visibility != "hidden")
                            $('#' + this.svgObject.id + '_LegendItemShape' + seriesHighlightIndex).not("[class*='Selection']").attr('class', 'HighlightLegendStyle' + name);
                        // checked condition for financial series
                        var finName = $('#' + targetId).attr("name");
                        if (finName != undefined && (finName == 'candle' || finName.indexOf('hilo') >= 0)) {
                            $('[id$=' + matchString + clusterPoints[k].seriesIndex + '_' + 'Point' + clusterPoints[k].pointIndex + ']').attr('class', 'HighlightStyle' + name);
                        }
                    }

                }

				else {
					// checked condition for whether target id is area related or not
					if (!$('#' + targetId).attr("name") && targetId != chart.svgObject.id + '_Series' + index) {
						selectClass = $('#' + targetId).attr('class') ? $('#' + targetId).attr('class') : '';
						if ((selectClass.indexOf('Selection') != 0 && parentNodeId.indexOf(chart.svgObject.id + '_symbolGroup_' + index) <= 0 && (data||legendData))) {
						    if (isElement) {
						        $('#' + targetId).attr('class', 'HighlightStyle' + name);
						        if (this.model.commonSeriesOptions.columnFacet == 'cylinder' || series.columnFacet == 'cylinder') {
						            for (i = 0; i < 2; i++) {
						                $('#' + targetId.replace(/2$/, i)).attr('class', 'HighlightStyle' + name);
						            }
						        }
						    }
                            pointIndex = data ? data.region.Region.PointIndex:legendData.legendItem.LegendItem.PointIndex;
                            $('#' + targetId + '_symbol').attr('class', 'HighlightStyle' + name);
                            $('#' + this.svgObject.id + '_Series' + seriesIndex + '_Point' + pointIndex).not("[class*='Selection']").attr('class', 'HighlightStyle' + name);
                            $('#' + this.svgObject.id + '_LegendItemShape' + index).not("[class*='Selection']").attr('class', 'HighlightLegendStyle' + name);
                        }
						if(targetId.indexOf("symbol") > -1)
						    $('#' + targetId).attr('class', 'HighlightStyle' + name);
                    }
					// checked condition for financial series
                    var finName = $('#' + targetId).attr("name");
                    if (finName != undefined && (finName == 'candle' || finName.indexOf('hilo') >= 0)) {
                        $('[id$=' + targetId + ']').attr('class', 'HighlightStyle' + name);
						$('#' + this.svgObject.id + '_LegendItemShape' + index).not("[class*='Selection']").attr('class', 'HighlightLegendStyle' + name);
					}

				}
			}
        }

    },

     // 3D style class created here
    dStyle: function (style3D, color, chart, evt, settings) {
        var vector = ej.Ej3DRender.prototype.polygon3D.prototype;
        var highlight = settings;
        var name = style3D.api;
        var seriesName = style3D.seriesName;
        var opacity = highlight.opacity;
        color = chart.colorNameToHex(color);
        if (style3D.name == "XLight")
            color = vector.applyXLight(color, chart);
        else if (style3D.name == "ZLight")
            color = vector.applyZLight(color, chart);
        else
            color = color;
        var colorStyle = {};
        colorStyle.name = style3D.name; colorStyle.color = color; colorStyle.api = name;
        color = (highlight.pattern == "none") ? color : this.pattern(chart, evt, colorStyle, highlight);
        if (document.getElementById(name + "Segment" + seriesName)) {
            var style = document.getElementById(name + "Segment" + seriesName);
            style.innerHTML = style.innerHTML + '.' + name + 'Style' + seriesName+ style3D.index + ' { fill:' + color + ";opacity:" + opacity + ' }';
        } else {
            var style = document.createElement('style');
            style.id = name + "Segment" + seriesName;
            style.type = 'text/css';
            style.innerHTML = '.' + name + 'Style' + seriesName + style3D.index + ' { fill:' + color + ";opacity:" + opacity + ' }';
            document.getElementsByTagName('head')[0].appendChild(style);
        }
        return name + "Style" + seriesName + style3D.index;

    },

     // 3D style class end

     // pattern of the SVG started here
    pattern: function (chart, evt, colorStyle, settings) {
        var hoverStyle = settings;
        var name = colorStyle.api;
        var style = hoverStyle.pattern.toLowerCase();
        var color = colorStyle.color;
        var opacity = hoverStyle.opacity != "" ? hoverStyle.opacity : $('#' + evt.target.id).attr('opacity');
        var backgroundColor = "#ffffff";
        if (document.getElementById(name + "Def")) {
            var svg = $("#" + name + "Def")[0];
        } else {
            var svgid = { 'id': name + "Def" }
            var svg = chart.svgRenderer.createPattern(svgid, 'svg');
            chart.svgRenderer.append(svg, chart.svgObject);
        }
        if (chart.model.enable3D) {
            if (colorStyle.name == "XLight")
                backgroundColor = "#595959";
            else if (colorStyle.name == "ZLight")
                backgroundColor = "#737373";
            else
                backgroundColor = "#808080";
        }        
        if (("#" + style + '_' + name + '_' + colorStyle.name + '_' + colorStyle.index))
            $("#" + style + '_' + name + '_' + colorStyle.name + '_' + colorStyle.index).remove();

        var pathOptions = [];
        switch (style) {
            case "chessboard":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'x': 0, 'y': 0, 'width': 10, 'height': 10 }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 10, 'height': 10, 'fill': backgroundColor, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = { 'x': 0, 'y': 0, 'width': 5, 'height': 5, 'fill': color, 'opacity': opacity, 'name': 'rect' };
                pathOptions[2] = { 'x': 5, 'y': 5, 'width': 5, 'height': 5, 'fill': color, 'opacity': opacity, 'name': 'rect' };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "pacman":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '17.917', 'height': '18.384' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 17.917, 'height': 18.384, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M9.081,9.194l5.806-3.08c-0.812-1.496-2.403-3.052-4.291-3.052H8.835C6.138,3.063,3,6.151,3,8.723v1.679   c0,2.572,3.138,5.661,5.835,5.661h1.761c2.085,0,3.835-1.76,4.535-3.514L9.081,9.194z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "crosshatch":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '8', 'height': '8' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 8, 'height': 8, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'd': 'M0 0L8 8ZM8 0L0 8Z',
                    'stroke-width': 1,
                    'stroke': color,
                    'name': 'path'
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "dots":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '6', 'height': '6' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 7, 'height': 7, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'cx': 3,
                    'cy': 3,
                    'r': 2,
                    'stroke-width': 1,
                    'fill': color,
                    'name': 'circle'
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "diagonalforward":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '6', 'height': '6' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 6, 'height': 6, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity, 'name': 'rect' };
                pathOptions[1] = {
                    'd': 'M 3 -3 L 9 3 M 6 6 L 0 0 M 3 9 L -3 3',
                    'stroke-width': 2,
                    'stroke': color,
                    'name': 'path'
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "diagonalbackward":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '6', 'height': '6' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'x': 0, 'y': 0, 'width': 6, 'height': 6, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity, 'name' : 'rect' };
                pathOptions[1]= {
                    'd': 'M 3 -3 L -3 3 M 0 6 L 6 0 M 9 3 L 3 9',
                    'stroke-width': 2,
                    'stroke': color,
                    'name':'path'
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "grid":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '6', 'height': '6' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 6, 'height': 6, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'path',
                    'd': 'M1 3.5L11 3.5 M0 3.5L11 3.5 M0 7.5L11 7.5 M0 11.5L11 11.5 M5.5 0L5.5 12 M11.5 0L11.5 12Z',
                    'stroke-width': 1,
                    'stroke': color
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "turquoise":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '17', 'height': '17' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 17, 'height': 17, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M0.5739999999999998,2.643a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[2] = { 'name': 'path', 'd': 'M11.805,2.643a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[3] = { 'name': 'path', 'd': 'M6.19,2.643a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[4] = { 'name': 'path', 'd': 'M11.805,8.217a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[5] = { 'name': 'path', 'd': 'M6.19,8.217a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[6] = { 'name': 'path', 'd': 'M11.805,13.899a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                pathOptions[7] = { 'name': 'path', 'd': 'M6.19,13.899a2.123,2.111 0 1,0 4.246,0a2.123,2.111 0 1,0 -4.246,0', 'stroke-width': 1, 'stroke-miterlimit': 10, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "star":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '21', 'height': '21' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 21, 'height': 21, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'path',
                    'd': 'M15.913,18.59L10.762 12.842 5.613 18.75 8.291 11.422 0.325 9.91 8.154 8.33 5.337 0.91 10.488 6.658 15.637 0.75 12.959 8.078 20.925 9.59 13.096 11.17 z',
                    'stroke-width': 1,
                    'stroke': color,
                    'fill': color
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "triangle":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '10', 'height': '10' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 10, 'height': 10, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'path',
                    'd': 'M4.987,0L7.48 4.847 9.974 9.694 4.987 9.694 0 9.694 2.493 4.847 z',
                    'stroke-width': 1,
                    'stroke': color,
                    'fill': color
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "circle":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '9', 'height': '9' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 9, 'height': 9, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = {
                    'name': 'circle',
                    'cx': 5.125,
                    'cy': 3.875,
                    'r': 3.625,
                    'stroke-width': 1,
                    'fill': color
                };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "tile":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '18', 'height': '18' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 18, 'height': 18, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M0,9L0 0 9 0 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                pathOptions[2] = { 'name': 'path', 'd': 'M9,9L9 0 18 0 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                pathOptions[3] = { 'name': 'path', 'd': 'M0,18L0 9 9 9 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                pathOptions[4] = { 'name': 'path', 'd': 'M9,18L9 9 18 9 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "horizontaldash":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '12', 'height': '12' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 12, 'height': 12, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M0,1.5 L10 1.5 M0,5.5 L10 5.5 M0,9.5 L10 9.5 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "verticaldash":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '12', 'height': '12' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 12, 'height': 12, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M1.5,0 L1.5 10 M5.5,0 L5.5 10 M9.5,0 L9.5 10 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "rectangle":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'x': 0, 'y': 0, 'width': 12, 'height': 12 }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'width': 12, 'height': 12, 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'rect', 'x': 1, 'y': 2, 'width': 4, 'height': 9, 'fill': color, 'opacity': opacity };
                pathOptions[2] = { 'name': 'rect', 'x': 7, 'y': 2, 'width': 4, 'height': 9, 'fill': color, 'opacity': opacity };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "box":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'x': 0, 'y': 0, 'width': 10, 'height': 10 }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'width': 13, 'height': 13, 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'rect', 'x': 1.5, 'y': 1.5, 'width': 10, 'height': 9, 'fill': color, 'opacity': opacity };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "horizontalstripe":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '10', 'height': '12' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 10, 'height': 12, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M0,0.5 L10 0.5 M0,4.5 L10 4.5 M0,8.5 L10 8.5 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "verticalstripe":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '12', 'height': '10' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = { 'name': 'rect', 'x': 0, 'y': 0, 'width': 12, 'height': 10, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'path', 'd': 'M0.5,0 L0.5 10 M4.5,0 L4.5 10 M8.5,0 L8.5 10 z', 'stroke-width': 1, 'stroke': color, 'fill': color };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
            case "bubble":
                var patternGroup = { 'id': style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index, 'patternUnits': 'userSpaceOnUse', 'width': '20', 'height': '20' }
                var pattern = chart.svgRenderer.createPattern(patternGroup, 'pattern');
                pathOptions[0] = {'name':'rect', 'x': 0, 'y': 0, 'width': 20, 'height': 20, 'transform': "translate(0,0)", 'fill': backgroundColor, 'opacity': opacity };
                pathOptions[1] = { 'name': 'circle', 'cx': 5.217, 'cy': 11.325, 'r': 3.429, 'stroke-width': 1, 'fill': '#D0A6D1' };
                pathOptions[2] = { 'name': 'circle', 'cx': 13.328, 'cy': 6.24, 'r': 4.884, 'stroke-width': 1, 'fill': color };
                pathOptions[3] = { 'name': 'circle', 'cx': 13.277, 'cy': 14.66, 'r': 3.018, 'stroke-width': 1, 'fill': '#D0A6D1' };
                this.loadPattern(chart, pathOptions, pattern);
                svg.appendChild(pattern);
                return "url(#" + style + "_" + name + "_" + colorStyle.name + "_" + colorStyle.index + ")";
                break;
             case "custom":
                return "url(#" + hoverStyle.customPattern + ")"
                break;
        }

    },
	loadPattern: function (chart, options, pattern, ctx) {
        var path;
        for (var i = 0; i < options.length; i++) {
            if (!ctx) {
                path = chart.svgRenderer.createPattern(options[i], options[i].name);
                pattern.appendChild(path);
            } else {
                if (options[i].name == 'rect'){
					options[i].stroke = 'transparent';
					this.drawRect(options[i], ctx);
				}
                else if (options[i].name == 'path')
                    ej.EjCanvasRender.prototype.drawPath(options[i], ctx);
                else if(options[i].name == 'circle'){
					options[i].stroke = 'transparent';
					ej.EjCanvasRender.prototype.drawCircle(options[i], ctx);
				}
            }
        }
    },
	drawRect: function (options, element) {
        element.save();
        element.beginPath();
        element.globalAlpha = options.opacity;
        element.lineWidth = options["stroke-width"];
        element.strokeStyle = options.stroke;
	    element.rect(options.x, options.y, options.width, options.height);
        if (options.fill == "none") options.fill = "transparent";
        element.fillStyle = options.fill;
        if (options.transform) element.translate(options.transform[0], options.transform[1]);
        element.rotate(options.rotate * Math.PI / 180);        
        element.fillRect(options.x, options.y, options.width, options.height);
        element.clip();
        element.stroke();
        element.restore();
    },
     // pattern of the SVG end
     // SVG highlight and selection end

	chartRightClick: function (evt) {   
	    this.chartRightClick = true;
	    if (this.isTouch(evt) && this.model.crosshair.visible) {
	        event.preventDefault();	        
	        event.stopPropagation();
	        return false;
	    }
	},

	chartMouseUpTouch: function (evt) {
	    var chart = this,
	    matched = jQuery.uaMatch(navigator.userAgent),
	    mouseMoveCords = this.calMousePosition(evt),
        browserInfo = this.model.browserInfo,
	    element;
	    this.mousemoveX = mouseMoveCords.X;
	    this.mousemoveY = mouseMoveCords.Y;	     
	    this.enableTrackBall();	  
        
	    clearTimeout(this.model.doubleTapTimer);
	   
	    if (!this.drag)
	        this.model.doubleTapTimer = setTimeout(function () {	            
	        if ((chart.model.tapNum < 2 || chart.model.crosshair.visible))
	             chart.singleTap(evt);
	        chart.model.tapNum = 0;
	        chart.model.cachedX = 0;
	        chart.model.cachedY = 0;
	        
	    }, 200);	     

	    if (chart.model.tapNum == 2)
	     chart.model.doubleTapped = false;  
	        
	    return true;	 
	},
	getEvent : function(event) {
	    return event.targetTouches && event.targetTouches[0]  ? event.targetTouches[0] : event
	},

   // Method to check the double tap in chart.
	doubleTap: function (e) {

	    var pointer = this.getEvent(e),
	       currX = pointer.pageX,	   
	       currY = pointer.pageY,
           model = this.model,
           padding = 200,
           element,
           bounds = model.m_AreaBounds;	 

	    this.model.cachedX = this.model.cachedX || currX;

	    this.model.cachedY = this.model.cachedY || currY;

	    timestamp = new Date().getTime();  
	   
	    
	    if (this.mouseDownX >= bounds.X && this.mouseDownX < (bounds.X + bounds.Width) && this.mouseDownY < (bounds.Y + bounds.Height) && this.mouseDownY >= bounds.Y && Math.abs(currX - this.model.cachedX) < padding && Math.abs(currY - this.model.cachedY) < padding)
	        this.model.tapNum++;


	    if (this.model.tapNum == 2) {
	        this.model.doubleTapped = true;
	        this.multiSelectMouseDown(e);
	        this.drag = this.model.zooming.enable || this._isMultiSelect;	     
	        element = this.model.trackerElement;
	        if (element) {
	            $(element).finish();
	            element = null;
	        }
	    }  
	 
	},
     // Method invoking userinteraction in single Tap.
	singleTap: function (evt) {	    
	    var chart = this,
            targetid = evt.target.id,
	        seriesCollection =this.model._visibleSeries,
            element,
            pointer = this.getEvent(evt),
         currX = pointer.pageX,
         currY = pointer.pageY,
         swipeThreshold = 10;
	   
	    if ((!this.panning && !this.isZoomButtonHovered(evt.target))) {
	        this.cancelEvent(evt);
	        if (chart.model.trackerElement) {
                if($.finish)
                    $(chart.model.trackerElement).finish();
                else
                    $(chart.model.trackerElement).stop(true, true);
	            chart.model.trackerElement = null;
	        }
	        $(".ejTooltip"+ this._id).remove();
	        //if ($(element).find("#" + chart.svgObject.id + "_CrosshairGroup").length==0) {
	        if ((!chart.model.crosshair.visible || chart.model.AreaType != "cartesianaxes") && Math.abs(currX - chart.model.cachedX) < swipeThreshold && Math.abs(currY - chart.model.cachedY) < swipeThreshold) {
	            this.chartInteractiveBehavior(evt);
	        }

	        else {

	            chart.model.element = $(document).find("#" + this.svgObject.id + "_CrosshairGroup");
	            chart.model.trackerElement = $(chart.model.element).children().not('.Tracker').not("defs");
	            if ($(chart.model.trackerElement).length > 0)
	                $(chart.model.trackerElement).fadeOut(1000, function () {
	                    $(chart.model.element).find('[id*="trackSymbol"]').attr("visibility", "hidden");
	                    chart.model.trackerElement = null;
	                    chart._removeHighlight();
	                });
	            var groupElement = $(document).find('[id*="_trackball_grouping_tooltip"]');
	            if ($(groupElement).length > 0)
	                $(groupElement).fadeOut(1000, function () {
	                    $(groupElement).remove();
	                });
	        }

	        this.axisTooltip(evt, targetid);

	        this.showTitleTooltip(evt, targetid);

	        if (this.model.enableCanvasRendering) {
	            this._textTooltip(evt, this.model.xAxisLabelRegions);
	            this._textTooltip(evt, this.model.yAxisLabelRegions);
	        }

	        for (var i = 0, seriesLength = this.model.series.length; i < seriesLength; i++) {
	            var series = this.model.series[i], dataLabel = series.marker.dataLabel;
	            if (series._enableSmartLabels && !this.model.enable3D && !dataLabel.enableWrap) {
	                var template = dataLabel.template;
	                var font = dataLabel.font;
	                if (this.model.AreaType == "none" && ej.util.isNullOrUndefined(template)) {
	                    this.datalabelTooltip(evt, i, font);
	                }
	            }
	        }

	        if ($(".ejTooltip" + this._id).length > 0)
	            element = $(".ejTooltip" + this._id);
	        if ($(".tooltipDiv" + this._id).length > 0)
	            element = $(".tooltipDiv" + this._id);	        
	            window.clearTimeout(chart.model.timer);
	            chart.model.trackerElement = element;	           
	            chart.model.timer = setTimeout(function () {
	                pointData = chart.model.prevPoint;
	                if (chart.model.trackerElement) {
	                    chart.model.trackerElement.fadeOut(500, function () {
	                        if (pointData) {
	                            if (chart.model.AreaType != "polaraxes") {
	                                var prevLocation = ej.EjSvgRender.utils._getPoint(pointData.point, pointData.series);
	                                chart.drawTrackerSymbol(pointData.series, pointData.seriesIndex, pointData.pointIndex, null, prevLocation);
	                            }
	                            $("#" + "canvas" + "_trackSymbol").remove();
	                        }
	                        $("[id*=" + "_TrackSymbol" + "]").remove();
	                    });
	                }
	                else {
	                    if (pointData) {
	                        if (chart.model.AreaType != "polaraxes") {
	                            var prevLocation = ej.EjSvgRender.utils._getPoint(pointData.point, pointData.series);
	                            chart.drawTrackerSymbol(pointData.series, pointData.seriesIndex, pointData.pointIndex, null, prevLocation);
	                        }	                      
	                    }
	                    if (!chart.model.crosshair.visible) {
	                        $("#" + "canvas" + "_trackSymbol").remove();
	                        $("[id*=" + "_TrackSymbol" + "]").remove();
	                    }
	                }

	            }, 1200);
	          
	       
	    }
	    if(!evt.originalEvent.pointerType && !this.panning && this.model.selectionEnable)			
	        this._doClick(evt);
	},
	_getPieOfPiePoint:function(index,series,legenddata)
	{	   
	    var visiblePoints = legenddata? series.points : series._visiblePoints;
	    var length = visiblePoints.length;
	    for (var j = 0; j < length; j++)
	    {
	        if (index == visiblePoints[j].actualIndex)
	            var seriesPoint = visiblePoints[j];
	    }
	    return seriesPoint;
	},
    tooltip: function (chart, evt){
        var tooltipShowing = false;
        var chartSeries;
        var seriesIndex;
        var data = this.GetSeriesPoint(evt);
        $("#" + "canvas" + "_trackSymbol").remove();
		if (ej.util.isNullOrUndefined(data) && !this.dragPoint) // To hide the tooltip when it is moved on chartArea other than series
		    $("#" + chart.svgObject.id + "_TrackToolTip").remove();
		
		if (!this.model.crosshair.visible && this.model.AreaType == "cartesianaxes") {
		    var indicators = this.model.indicators,
		    seriesCollection = this.model._visibleSeries,
		    currentIndicator, l, k, trendLines,
		    length = seriesCollection.length;
			var trackcount=0;	
		    for (k = 0; k < length; k++) {
		        trendLines = seriesCollection[k].trendlines;
		        for (l = 0; l < trendLines.length; l++) {
		            if (trendLines[l].visibility.toLowerCase() == "visible" && !trendLines[l].isNull && this.model.series[0].type != "boxandwhisker") {
						trendLines[l]._visiblePoints = trendLines[l].points;
		                seriesCollection = seriesCollection.concat(trendLines[l]);
		            }
		        }
		    }

		    for (var j = 0; j < indicators.length && indicators[j].segment; j++) {
			    currentIndicator = indicators[j]; 
			    if (currentIndicator.visible)
			        seriesCollection = seriesCollection.concat(currentIndicator.segment);
			    }
		    var seriesCollectionLength = seriesCollection.length;
		    for (var i = 0; i < seriesCollectionLength ; i++) {
		        chartSeries = seriesCollection[i];
                seriesIndex = i;
				
				var type = chartSeries.type.toLowerCase();		
				if (chartSeries.visibility.toLowerCase() == 'visible' && type !== "scatter" && type !== "bubble" && type !== "column" && (type.indexOf("bar")==-1) && type !== "stackingcolumn" && type !== "stackingcolumn100" && !chartSeries._hiloTypes) {
                    $("#" + chart.svgObject.id + "_TrackToolTipTemplate_" + seriesIndex).remove();
                    if (!($(".tooltipDiv" + this._id).hasClass(chart.svgObject.id)))
                        $(".tooltipDiv" + this._id).remove();
                    $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackSymbol" + '_' + seriesIndex).remove();
                    $('#' + chart.svgObject.id + '_TrackSymbol' + '_' + seriesIndex).remove();
                    var serY = [];
                    var serX = [];
                    location = null;
                    var closestXyPoint = chart.getClosesPointXY(serX, serY, chartSeries, chart.mousemoveX, chart.mousemoveY, evt);
					if(ej.util.isNullOrUndefined(closestXyPoint.point) && (!this.model.prevPoint|| (this.model.prevPoint.seriesIndex && !this.model.series[this.model.prevPoint.seriesIndex].tooltip.visible)) && !this.dragPoint && ($(".tooltipDiv" + this._id).hasClass(this.svgObject.id))){
						clearTimeout(this.removeTooltip); 
						chart.removeTooltip = setTimeout(function () {   // To hide the tooltip when it is moved on chartArea other than series
							$(".tooltipDiv" + chart._id).remove();
						}, 1000);
					}
                    if (closestXyPoint.point) {
						if(chartSeries.type.toLowerCase() == "boxandwhisker")
						{							
							trackcount++;
							location = closestXyPoint.outlierPosition;							
						}else
							location = ej.EjSvgRender.utils._getPoint(closestXyPoint.point, chartSeries);
                        var commonPointEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                        commonPointEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveX }, region: { SeriesIndex: i, Region: { PointIndex: closestXyPoint.index } } };
                        chart._trigger("pointRegionMouseMove", commonPointEventArgs);
                    }
                    var pointData = this.model.prevPoint;
                    if (pointData && pointData.seriesIndex == i && !closestXyPoint.point) {
						if(chartSeries.type.toLowerCase() == "boxandwhisker")
						{
							  trackcount++;
							  pointLocation = pointData.outlierPosition;
							
						}
						else
                              var pointLocation = ej.EjSvgRender.utils._getPoint(pointData.point, pointData.series);
                        if (!chart.model.enableCanvasRendering) // No need to draw again in canvas chart after explode marker
                            chart.drawTrackerSymbol(pointData.series, pointData.seriesIndex, pointData.pointIndex, null, pointLocation);
                        this.model.prevPoint = null;
                    }					
                    if (!chartSeries.isIndicator && !chartSeries.isTrendLine && !chartSeries.selectionSettings.enable && !chartSeries.highlightSettings.enable && (chartSeries.marker.visible|| chartSeries.type.toLowerCase() == "boxandwhisker" ) && closestXyPoint.point && !commonPointEventArgs.cancel) {
                        if (ej.util.isNullOrUndefined(closestXyPoint.point.marker) || ej.util.isNullOrUndefined(closestXyPoint.point.marker.visible) || (closestXyPoint.point.marker && closestXyPoint.point.marker.visible))
							chart.drawTrackerSymbol(chartSeries, seriesIndex, closestXyPoint.index, false, location);						
						else if(chartSeries.type == "boxandwhisker" && !closestXyPoint.point.marker)	
							chart.drawTrackerSymbol(chartSeries, seriesIndex, closestXyPoint.index, false, location);						
                        if (pointData && closestXyPoint.point != pointData.point){
							if(chartSeries.type.toLowerCase() == "boxandwhisker")
							{
								trackcount++;
								prevLocation = pointData.outlierPosition;							
							}
							else						
								var prevLocation = ej.EjSvgRender.utils._getPoint(pointData.point, pointData.series);
                            chart.drawTrackerSymbol(pointData.series, pointData.seriesIndex, pointData.pointIndex, null, prevLocation, id,trackcount);
						}
                        if (ej.util.isNullOrUndefined(closestXyPoint.point.marker) || ej.util.isNullOrUndefined(closestXyPoint.point.marker.visible) || (closestXyPoint.point.marker && closestXyPoint.point.marker.visible))
                        this.model.prevPoint = { point: closestXyPoint.point, pointIndex: closestXyPoint.index, series: chartSeries, seriesIndex: seriesIndex,outlierPosition:closestXyPoint.outlierPosition };
                    }


                    if (chartSeries.tooltip.visible && closestXyPoint.point && (!data || (i > data.region.SeriesIndex && !(chartSeries._zOrder < this.model._visibleSeries[data.region.SeriesIndex]._zOrder)))) {
                        trans = ej.EjSvgRender.utils._getTransform(chartSeries.xAxis, chartSeries.yAxis, chart.model.requireInvertedAxes);
                        if ((location.X + trans.x) <= (trans.x + trans.width) && ((location.X + trans.x) >= trans.x || location.X == 0) && (Math.abs(location.Y - (trans.y + trans.height)) <= (trans.y + trans.height))
                                     && (Math.abs(location.Y - (trans.y + trans.height)) >= trans.y || location.Y == 0)) {                         
                            if (!commonPointEventArgs.cancel) {
                                if ($(chart.svgObject).find("#" + chart.svgObject.id + "_TrackToolTip").length == 0) {
                                    var transOptions = { 'id': chart.svgObject.id + '_TrackToolTip', 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
                                    chart.gTransToolEle = chart.svgRenderer.createGroup(transOptions);
                                }
                                chart.svgRenderer._setAttr($(chart.svgObject).find("#" + chart.svgObject.id + "_TrackToolTip"), { 'transform': 'translate(' + trans.x + ',' + trans.y + ')', 'visibility': 'visible' });
                                if (ej.util.isNullOrUndefined(chartSeries.tooltip.template)) {
                                    tooltipShowing = true;
                                    $(".tooltipDiv" + this._id).remove();
                                    chart.displayShowTooltip(location, closestXyPoint.point, chartSeries, closestXyPoint.index);
                                }
                                else {
                                    tooltipShowing = true;
                                    $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden');
                                    var region = { SeriesIndex: seriesIndex, Region: { PointIndex: closestXyPoint.index } };
                                    chart.createTooltip(region, evt, chartSeries);
                                }

                                //Comment the below code for VML -The line series tooltip color not displayed due to attach and detach the element to DOM
                                // var detachEle = $(chart.svgObject).find("#" + chart.svgObject.id + "_TrackToolTip").detach();
                                //detachEle.appendTo(chart.svgObject);
                            }
                           
                        }
                    }
                } 
				else if (ej.util.isNullOrUndefined(data) && !this.dragPoint && ($(".tooltipDiv" + this._id).hasClass(this.svgObject.id))){ 
						clearTimeout(this.removeTooltip); 
						chart.removeTooltip = setTimeout(function () {   // To hide the tooltip when it is moved on chartArea other than series
							$(".tooltipDiv" + chart._id).remove();
						}, 1000);
				}
            }
        }
	   else {
            $("#" + this.svgObject.id).find("#" + this.svgObject.id + "_TrackToolTip").hide();
			if (ej.util.isNullOrUndefined(data)){
				clearTimeout(this.removeTooltip); 
				chart.removeTooltip = setTimeout(function () {   // To hide the tooltip when it is moved on chartArea other than series
					$(".tooltipDiv" + chart._id).remove();
				}, 1000);
			}
        }
       
		if (!($(".tooltipDiv" + this._id).hasClass(this.svgObject.id)))
		    $(".tooltipDiv" + this._id).remove();
        if (data && ej.util.isNullOrUndefined(data.region.isStripLine)) {
            if (this.model.AreaType == "none" && this.model._visibleSeries[data.region.SeriesIndex].explode) {
                if (this.model._visibleSeries[data.region.SeriesIndex].enableAnimation) {
                    if (this.model.AnimationComplete || this.model.enableCanvasRendering)
                        this.pieExplosion(data, evt);
                }
                else if(!this.model.enable3D)
                    this.pieExplosion(data, evt);
            }
            if (data.region.isIndicator) {
                series = this.model.indicators[data.region.SeriesIndex];
                var seriesPoint = series.segment[0]._visiblePoints[data.region.Region.PointIndex];
                series.fill = series.segment[0].fill;
            } else {
                series = this.model._visibleSeries[data.region.SeriesIndex];               
                var seriesPoint = (series.type == "pieofpie")? this._getPieOfPiePoint(data.region.Region.PointIndex, series):this.model._visibleSeries[data.region.SeriesIndex]._visiblePoints[data.region.Region.PointIndex];
            }

            if (seriesPoint && this.model.AreaType=='polaraxes') {
                for (var i = 0; i < this.model._visibleSeries.length; i++) {
                    $("[id*=" + "_TrackSymbol" + "]").remove();
                    var trackId = "canvas_trackSymbol_" + i;
                    $("#" + this._id).find('[id*=' + trackId + ']').remove();
                }
                var pointlocation = (this.model.AreaType != "polaraxes")
                    ? ej.EjSvgRender.utils._getPoint(seriesPoint, series)
                    : (ej.EjSvgRender.utils.TransformToVisible(series, seriesPoint.xValue, seriesPoint.y, this))
                    var prevPoint = this.model.prevPoint;
                    if (!ej.util.isNullOrUndefined(prevPoint) && prevPoint!= data && series.marker.visible)
                    {
                        var series = this.model._visibleSeries[prevPoint.region.SeriesIndex],
                        prevSeriesPoint = this.model._visibleSeries[prevPoint.region.SeriesIndex]._visiblePoints[prevPoint.region.Region.PointIndex],
                        prevlocation = ej.EjSvgRender.utils.TransformToVisible(series, prevSeriesPoint.xValue, prevSeriesPoint.y, this);
                        this.drawTrackerSymbol(series, prevPoint.region.SeriesIndex, prevPoint.region.Region.PointIndex, null, prevlocation);
                        this.model.prevPoint = null;
                    }
                    if (series.marker.visible && series.drawType != "column") {
                        this.drawTrackerSymbol(series, data.region.SeriesIndex, data.region.Region.PointIndex, true, pointlocation);
                        this.model.prevPoint = data;                        
                    }
            }

            if (series.tooltip.visible && !tooltipShowing) {

                if (series.visibility.toLowerCase() == 'visible') {
                    if (ej.util.isNullOrUndefined(series.tooltip.template)) {
                        var location;
                        if (this.model.AreaType == "cartesianaxes") {

                            var trans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, this.model.requireInvertedAxes);
                            if ($(this.svgObject).find("#" + this.svgObject.id + "_TrackToolTip").length == 0) {
                                var transToolOptions = { 'id': this.svgObject.id + '_TrackToolTip', 'transform': 'translate(' + trans.x + ',' + trans.y + ')' };
                                this.gTransToolEle = this.svgRenderer.createGroup(transToolOptions);
                            }
                            this.svgRenderer._setAttr($(this.svgObject).find("#" + this.svgObject.id + "_TrackToolTip"), { 'transform': 'translate(' + trans.x + ',' + trans.y + ')' });
                            $('#' + this.svgObject.id + "_TrackToolTip").attr("visibility", "visible");
                            location = { X: (data.location.x - this.model.m_AreaBounds.X), Y: Math.abs(data.location.y - (this.model.m_AreaBounds.Y)) };
                        } else {
                            if ($(this.svgObject).find("#" + this.svgObject.id + "_TrackToolTip").length == 0) {
                                var transToolTipOptions = { 'id': this.svgObject.id + '_TrackToolTip' };
                                this.gTransToolEle = this.svgRenderer.createGroup(transToolTipOptions);
                            }
                            location = { X: (data.location.x), Y: Math.abs(data.location.y) };
                        }


                        $(".tooltipDiv" + this._id).remove();
                        this.displayShowTooltip(location, seriesPoint, series, data.region.Region.PointIndex);
                            
                        //Comment the below code for VML -The line series tooltip color not displayed due to attach and detach the element to DOM
                        // if (series.type.toLowerCase() == "bubble" || series.type.toLowerCase() == "scatter") {
                        //     var detachEle = $(this.svgObject).find("#" + this.svgObject.id + "_TrackToolTip").detach();
                        //    detachEle.appendTo(this.svgObject);
                        // }
                    } else {
                        $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden');
                        this.createTooltip(data.region, evt);
                    }
                }
            }
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = data;
            this._trigger("pointRegionMouseMove", commonEventArgs);
        }
		else if (!ej.util.isNullOrUndefined(this.model.prevPoint)&& this.model.AreaType == "polaraxes") {
            var prevPoint = this.model.prevPoint;
            series = this.model._visibleSeries[prevPoint.region.SeriesIndex];
            seriesPoint = this.model._visibleSeries[prevPoint.region.SeriesIndex]._visiblePoints[prevPoint.region.Region.PointIndex];
            pointlocation = ej.EjSvgRender.utils.TransformToVisible(series, seriesPoint.xValue, seriesPoint.y, this);
            this.drawTrackerSymbol(series, prevPoint.region.SeriesIndex, prevPoint.region.Region.PointIndex, null, pointlocation);
            this.model.prevPoint = null;
        }
        else {
            if (!ej.util.isNullOrUndefined(this.model.explodeValue)) {
                var type = this.model.series[this.model.explodeValue.SeriesIndex].type.toLowerCase();
                var series = this.model._visibleSeries[this.model.explodeValue.SeriesIndex];
                    var seriesType = new ej.seriesTypes[type]();
                    var targetElement;
                    var id;
                    var _labelPosition = series.labelPosition.toLowerCase();
                    var seriesIndex = this.model.explodeValue.SeriesIndex;
                    var visiblePoint = (this.model._isPieOfPie) ? this._getPieOfPiePoint(this.model.explodeValue.PointIndex, series) : series._visiblePoints[this.model.explodeValue.PointIndex];
                    var result = seriesType._calculateArcData(this, this.model.explodeValue.PointIndex, visiblePoint, series, seriesIndex, this.model.explodeValue.PieSeriesIndex);
                    if (this.model.enableCanvasRendering) {
                        this.model.series[seriesIndex].explodeIndex = null;
                        var chartRect = document.getElementById(this.svgObject.id).getClientRects()[0];
                        this.svgRenderer.ctx.clearRect(chartRect.left, chartRect.top, chartRect.width, chartRect.height);
                        $("#" + this._id).ejChart("redraw");
                    }
                    id = this.svgObject.id + '_SeriesGroup' + '_'+seriesIndex;
                    targetElement = this.model.explodeValue.PieSeriesIndex ==1 ? $(this.gSeriesEle).children('#' + id)[1] : $(this.gSeriesEle).children('#' + id)[0];
                    var elements = $(targetElement).children();
                    for (var i = 0; i < elements.length; i++) {
                        var element = elements[i];
                        var index = this.svgRenderer._getAttrVal($(element)[0], "pointIndex");
                        if (parseInt(index) == this.model.explodeValue.PointIndex) {
                            this.svgRenderer._setAttr($(element), { 'd': result.Direction });
                            break;
                        }
                    }
                    seriesType.drawDataLabelAcc(this, series, this.model.explodeValue.PointIndex, visiblePoint, seriesIndex, this.model.explodeValue.PieSeriesIndex);
                    this.model.explodeValue = null;
					this.model.explode= false;
            }
        }
    },

    chartTrackball: function (chart, mouseLocation, evt) {
        var requireInvertedAxes = chart.model.requireInvertedAxes, point, seriesIndex, series, dir, indicators = this.model.indicators, seriesCollection = this.model._visibleSeries,
            showTrackLine = false, seriesIndex, serX, insideBounds, closestPoint, visibleRange, chartPos, pathOptions, leftPos, topPos, chartAreaStartPos, chartAreaEndPos, pointPos,
            crossHairTrans, tToolOptions, prePoint, initialPoint, rectxt, tooltipfont, textarea, tgap = 0, currentLength, tX, tY, chartLocation, element, visiblepts = [], tooltipRanges = [],
            DisplayTooltipOptions = [], enableCanvas = this.model.enableCanvasRendering, totalVisible = 0, maxWidth = 0, heightwidth = 0, chartOffset = $("#" + this._id).offset(),
            textCollection = [], textOptionsCollection = [], groupingTextId = [], trackballDisplayMode = this.model.crosshair.trackballTooltipSettings.mode.toLowerCase(), groupTooltipId = chart._id + "_trackball_grouping_tooltip",
            locale = this.model.locale,boxSeriesCount = 0,trackOutlier = 0;
       if ((!this.model.enable3D) && this.model.crosshair.visible && this.model.crosshair.type.toLowerCase() == "trackball") {

           if ($("#" + this.svgObject.id + "_CrosshairGroup").length == 0) {     // condition to check track axis tooltip is existing in DOM
               var gTrackballOptions = { 'id': chart.svgObject.id + '_CrosshairGroup', 'visibility': 'visible' };
               if (enableCanvas) {
                   gTrackballOptions.position = "absolute";
                   chart.svgRenderer.drawCrosshairLine(gTrackballOptions, '#chartContainer_' + this._id);
               }
               else{
                   chart.gTrackball = chart.svgRenderer.createGroup(gTrackballOptions);
                   chart.svgRenderer.append(chart.gTrackball, chart.svgObject);
               }               
           }
           else {             
               if (chart.model.trackerElement) {
                   if ($.finish)
                       $(chart.model.trackerElement).finish();
                   else
                       $(chart.model.trackerElement).stop(true, true);
                   chart.model.trackerElement = null;                 
               }
           }
           if (!this.model.enableCanvasRendering) {
               // removed highlight style
               $("[class*=" + "HighlightStyle" + "]").attr('class', '');
               $("[class*=" + "HighlightLegendStyle" + "]").attr('class', '');
               $("[class*=" + "HighlightLegendPathStyle" + "]").attr('class', '');
               $("[class*=" + "HighlightPathStyle" + "]").attr('class', '');
               $("[class*=" + "Highlightseries" + "]").attr('class', '');
               $("[id*=" + this._id + "_Highlight_" + "]").remove();// removed canvas highlight           
           }
            //Hiding previous trackball and tooltip when moving from one column to another
           $("#secondCanvas").remove(), $("#" + this._id).find('[id*="_gTooltip_"]').remove(), $("#" + groupTooltipId).children().remove();
            if (enableCanvas) {
                $("#" + this._id).find('[id*="canvas_trackSymbol"]').css("visibility", "hidden");
            }
            var seriesLenIndicator = seriesCollection.length;
            for (var j = 0; j < indicators.length && indicators[j].segment; j++) {
                seriesCollection = seriesCollection.concat(indicators[j].segment);
            }
            seriesLength = seriesCollection.length;
            for (var i = 0; i < seriesLength; i++) {
                if (seriesCollection[i].visibility == "visible") {
                    seriesIndex = i;
                     serX = [];
            
                    if (!requireInvertedAxes)
                        insideBounds = chart.mousemoveX + seriesCollection[i].xAxis.plotOffset > seriesCollection[i].xAxis.x && chart.mousemoveX < seriesCollection[i].xAxis.x + seriesCollection[i].xAxis.width + seriesCollection[i].xAxis.plotOffset;
                    else
                        insideBounds = chart.mousemoveY + seriesCollection[i].xAxis.plotOffset > seriesCollection[i].xAxis.y && chart.mousemoveY < seriesCollection[i].xAxis.y + seriesCollection[i].xAxis.height + seriesCollection[i].xAxis.plotOffset;
                    if (enableCanvas)
                        this.canvasX = seriesCollection[i].xAxis.x;
                     closestPoint = chart.getClosestPointX(serX, seriesCollection[i], chart.mousemoveX, chart.mousemoveY);
                     visibleRange = seriesCollection[i].xAxis.visibleRange;   // condition to check the closestPoint is inside the visible range
					 if(closestPoint.point != "" ){
						var closestPointValues = seriesCollection[i].type.toLowerCase() == "boxandwhisker" ? closestPoint.point[0].boxPlotLocation[0].YValues :   closestPoint.point[0].YValues[0];
						if (closestPoint.point != "" && (closestPointValues >= seriesCollection[i].yAxis.visibleRange.min || trackballDisplayMode == "grouping") && (closestPoint.point[0].xValue >= visibleRange.min) && (closestPoint.point[0].xValue <= visibleRange.max)) {
							if (insideBounds) {
								for (var t = 0; t < closestPoint.point.length; t++) {
									if (closestPoint.point[t].visible) {
										if (!seriesCollection[i].isIndicator) {
											totalVisible++;
										}
									}
								}
							}
						}
					}
                } 

           }
            for (var i = 0; i < seriesLength; i++) {
			 //   if(seriesCollection[0].xAxis.name == seriesCollection[i].xAxis.name)
                seriesIndex = i, series = seriesCollection[i]; 
                var trackPoints =[];
                if (series.visibility.toLowerCase() == 'visible') {
                    serX = [];
                    if (!requireInvertedAxes)
                        insideBounds = chart.mousemoveX + seriesCollection[i].xAxis.plotOffset > series.xAxis.x && chart.mousemoveX < series.xAxis.x + series.xAxis.width + seriesCollection[i].xAxis.plotOffset;
                    else
                        insideBounds = chart.mousemoveY + seriesCollection[i].xAxis.plotOffset > series.xAxis.y && chart.mousemoveY < series.xAxis.y + series.xAxis.height + seriesCollection[i].xAxis.plotOffset;
                    if (enableCanvas)
                        this.canvasX = series.xAxis.x;
                    closestPoint = chart.getClosestPointX(serX, series, chart.mousemoveX, chart.mousemoveY);
				    visibleRange = series.xAxis.visibleRange;   // condition to check the closestPoint is inside the visible range
					var point1;
					if(closestPoint.point != ""){
					var closestPointValues = seriesCollection[i].type.toLowerCase() == "boxandwhisker" ? closestPoint.point[0].boxPlotValues.midvalue :  closestPoint.point[0].YValues[0];
					if ((closestPointValues >= seriesCollection[i].yAxis.visibleRange.min || trackballDisplayMode == "grouping") && (closestPoint.point[0].xValue >= visibleRange.min) && (closestPoint.point[0].xValue <= visibleRange.max)) {					
				        if (insideBounds) {	        
				            var closePointLength = closestPoint.point.length;
				            for (var t = 0; t <closePointLength; t++) {
                              if (closestPoint.point[t].visible) {                                 
                                  if (!series.isIndicator) {
								     if(series.type=="boxandwhisker")
									 {
									    boxSeriesCount++;
										var boxvalue =  {"xValue": closestPoint.point[t].xValue, "YValues": closestPoint.point[t].boxPlotLocation[0].YValues };
										point = ej.EjSvgRender.utils._getPoint(boxvalue, series);
										point.YValues = boxvalue.YValues; 
										trackPoints.push(point);									 
										for(var q=0;q<closestPoint.point[t].boxPlotLocation.length;q++)
										{
											if(closestPoint.point[t].boxPlotLocation[q].outlier == true)
											{
												point1 ={X:closestPoint.point[t].boxPlotLocation[q].X,Y:closestPoint.point[t].boxPlotLocation[q].Y,YValues:closestPoint.point[t].boxPlotLocation[q].YValues,outlier:closestPoint.point[t].boxPlotLocation[q].outlier};
												trackPoints.push(point1);									 
											}
										}									 
									 }else
                                      point = ej.EjSvgRender.utils._getPoint(closestPoint.point[t], series);
                                      this.model.financial = seriesLenIndicator == 1 && closePointLength == 1 && series._hiloTypes || false;
                                      if (requireInvertedAxes) {
                                          if (this.model.financial) {
                                              var high = point.X > point.low ? point.X : point.low;
                                              var low = point.X < point.low ? point.X : point.low;
                                              dir = "M" + " " + (series.yAxis.x) + " " + (point.Y + series.xAxis.y) + " " + "L" + " " + (low + series.yAxis.x) + " " + (point.Y + series.xAxis.y) + " " + "M" + " " + (series.yAxis.x + high) + " " + (point.Y + series.xAxis.y) + " " + "L" + " " + (series.yAxis.x + series.yAxis.width) + " " + (point.Y + series.xAxis.y);
                                          }
                                          else
                                              dir = "M" + " " + (series.yAxis.x) + " " + (point.Y + series.xAxis.y) + " " + "L" + " " + (series.yAxis.x + series.yAxis.width) + " " + (point.Y + series.xAxis.y);
										  if(series.type == "boxandwhisker")
										  {
											  for(var p=0;p<trackPoints.length;p++)
											  {												  
													  visiblepts.push({ X: (trackPoints[p].X ), Y: (trackPoints[p].Y ) , YValues:trackPoints[p].YValues ,outlier:trackPoints[p].outlier});												 
											  }
										   }else  
												visiblepts.push({ X: (closestPoint.point[t].location.X + series.yAxis.x), Y: (closestPoint.point[t].location.Y + series.xAxis.y) });
										  }
									else {                                      
                                          if (this.model.financial) {
                                              var high = point.Y < point.low ? point.Y : point.low;
                                              var low = point.Y > point.low ? point.Y : point.low;
                                              dir = "M" + " " + (point.X + series.xAxis.x) + " " + (chart.model.m_AreaBounds.Y) + " " + "L" + " " + (point.X + series.xAxis.x) + " " + (high + series.yAxis.y) + " " + "M" + " " + (point.X + series.xAxis.x) + " " + (low + series.yAxis.y) + " " + "L" + " " + (point.X + series.xAxis.x) + " " + (chart.model.m_AreaBounds.Y + chart.model.m_AreaBounds.Height);
                                          }
                                          else
                                              dir = "M" + " " + (point.X + series.xAxis.x) + " " + (chart.model.m_AreaBounds.Y) + " " + "L" + " " + (point.X + series.xAxis.x) + " " + (chart.model.m_AreaBounds.Y + chart.model.m_AreaBounds.Height);
										  if(series.type == "boxandwhisker")
										  {
											   for(var p=0;p<trackPoints.length;p++)
											  {													
														visiblepts.push({ X: (trackPoints[p].X ), Y: (trackPoints[p].Y ) , YValues:trackPoints[p].YValues ,outlier:trackPoints[p].outlier });
											  }
										  }else   
												visiblepts.push({ X: (closestPoint.point[t].location.X + series.xAxis.x), Y: (closestPoint.point[t].location.Y + series.yAxis.y) });
										  }
                                
                                      chartPos = { left: chartOffset.left, top: chartOffset.top };

                                      pathOptions = {
                                    'id': chart.svgObject.id + "_Tracker",
                                    'fill': 'none',
                                    'stroke-width': chart.model.crosshair.line.width,
                                    'clip-path': 'url(#' + chart.svgObject.id + '_ChartAreaClipRect)',
                                    'stroke': chart.model.crosshair.line.color,
                                    'd': dir
                                };
                                      if ($("#" + chart.svgObject.id + "_Tracker").length == 0) {
                                          if (enableCanvas) {
                                              var obj = this.svgRenderer.createCrosshairCanvas();
                                              obj.ctx = obj.getContext('2d');
                                          }
                                          else {
                                              var obj = this.svgRenderer;
                                              var parentElement = chart.gTrackball;
                                          }
                                                                         
                                          chart.svgRenderer.drawPath.call(obj, pathOptions, parentElement);
                                        showTrackLine = true;
                                   
                                }
                                else {
								    showTrackLine = true;
                                    if (!ej.util.isNullOrUndefined(this._closest)) {
                                        if (this._beforeMin) {
                                            if (this._closest >= closestPoint.point[t].xValue)
                                                chart.svgRenderer._setAttr($(chart.svgObject).find("#" + chart.svgObject.id + "_Tracker"), { "d": dir, "visibility": "visible" });

                                        }
                                        else if (this._afterMax) {
                                            if (this._closest <= closestPoint.point[t].xValue)
                                                chart.svgRenderer._setAttr($(chart.svgObject).find("#" + chart.svgObject.id + "_Tracker"), { "d": dir, "visibility": "visible" });
                                        }
                                    }
                                    else {
                                        chart.svgRenderer._setAttr($(chart.svgObject).find("#" + chart.svgObject.id + "_Tracker"), { "d": dir, "visibility": "visible" });
                                    }
								    $("#" + chart.svgObject.id + "_Tracker").css({"display": "block" });
								    if (enableCanvas) {								      
								        var obj = this.svgRenderer.createCrosshairCanvas();
								            obj.ctx = obj.getContext('2d');
								            chart.svgRenderer.drawPath.call(obj, pathOptions, chart.gTrackball);
								       
                                    }
                                    $("#" + this._id).find('[id*="canvas_Tracker"]').css("visibility", "visible");
                                }

                                      crossHairTrans = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, requireInvertedAxes);
                                      tToolOptions = { 'transform': 'translate(' + crossHairTrans.x + ',' + crossHairTrans.y + ')', 'id': chart.svgObject.id + '_TrackToolTip' + '_' + seriesIndex };
                                chart.gTransToolEle = chart.svgRenderer.createGroup(tToolOptions);
                                      prePoint = this.model.prePoint;

                                //To check the current closestPoint and previous point is same
                                if (ej.util.isNullOrUndefined(prePoint) || prePoint.pointIndex[0] != closestPoint.index[0] || !$('#' + chart.svgObject.id + "_trackSymbol_" + seriesIndex + '_' + closestPoint.index)) {

                                    //Remove the track elements only once on point change
                                    if (ej.util.isNullOrUndefined(initialPoint)) {
                                        if (this.model.crosshair.tooltipTemplate != null) {
                                            $(document).find('[id*="_TrackToolTipTemplate_"]').attr("visibility", "hidden");
                                        }
                                        if (chart.gTransToolEle && chart.gTrackerEle) {
                                            $(this.svgObject).find('[id*="_TrackSymbol_"],[id*="_TrackToolTip"]').attr("visibility", "hidden");
                                            $("#" + this._id).find('[id*="canvas_trackSymbol"]').css("visibility", "hidden");
                                        }
                                              initialPoint = closestPoint;
                                    }
                                    var type = series.type.toLowerCase(),trackcount = 0;
                                    if (!series._hiloTypes || type.indexOf("rangearea") > -1)
                                        if(trackballDisplayMode != "grouping" || (trackballDisplayMode == "grouping" && type.indexOf("column") < 0 && type.indexOf("bar") < 0))
											if(series.type == "boxandwhisker")
											{
												for(var z=0;z<trackPoints.length;z++)
												{
													chart.drawTrackerSymbol(series, seriesIndex, closestPoint.index[t], true, trackPoints[z],null,trackcount);
													trackcount++;
												}
											}
											else
										       chart.drawTrackerSymbol(series, seriesIndex, closestPoint.index[t], true, point);
                                    series.trackerRemoved = true;
                                     
                                    // Condition to find the crosshair is specified with tooltip template
                                    if (!chart.model.crosshair.tooltipTemplate) {
                                        var currentLength = visiblepts.length - 1,trackOutlier = trackPoints.length;                                             
                                        if (trackballDisplayMode == "grouping" || (!this.model.financial && series._hiloTypes && type!="rangearea")) {
                                            var seriesColor = this.getSeriesColor(closestPoint.point[t], seriesIndex, series),
                                            textOptions, tooltipFormat = series.tooltip.format, currentText,boxgroupingtext,boxtext =[];
											if(series.type == "boxandwhisker"){
												for(var p=0;p<trackOutlier;p++){
													boxgroupingtext = this.getTooltipFormat(closestPoint.point[t], series, seriesIndex, closestPoint.index[t], tooltipFormat,trackPoints[p]);
													boxtext.push(boxgroupingtext);
													currentText = null;
												}
											}
											else
												currentText = this.getTooltipFormat(closestPoint.point[t], series, seriesIndex, closestPoint.index[t], tooltipFormat);
												
											var textColor = series.tooltip.font ? ((series.tooltip.font.color ? series.tooltip.font.color : seriesColor)) : seriesColor,
                                            font = series.tooltip.font ? $.extend(false, series.font, {}, series.tooltip.font) : series.font;
                                            if (typeof (textColor) == "object") {
                                                textColor = seriesColor[1].color;
                                            }                                          
											if(series.type == "boxandwhisker"){
												for(var b=0;b<boxtext.length;b++)
													textCollection.push({ text: boxtext[b].text, seriesIndex: seriesIndex, pointIndex: closestPoint.index[t] });
											}
											else{
												currentText.text = "&nbsp" + currentText.text + "&nbsp";
												textCollection.push({ text: currentText.text, seriesIndex: seriesIndex, pointIndex: closestPoint.index[t] });
											}
                                            if ((series._hiloTypes && type != "rangearea") || type.indexOf("column") > -1 || type.indexOf("bar") > -1) {
                                                data = { region: { Region: { PointIndex: closestPoint.index[t] }, SeriesIndex: seriesIndex } };
                                                this.highlightStart(evt, data, this._id + "_svg_SeriesGroup_" + seriesIndex, this._id + "_svg_Series" + seriesIndex + "_Point" + closestPoint.index[t], true);
                                            }
											if(series.type == "boxandwhisker"){
												for(var b=0;b<boxtext.length;b++){
													groupingTextId.push(chart._id + "_grouping_text_" + seriesIndex + "_" + closestPoint.index[t] + b);
												}
											}
											else
												groupingTextId.push(chart._id + "_grouping_text_" + seriesIndex + "_" + closestPoint.index[t]);												
                                            textOptions = {
                                                "color": textColor,
                                                'font-size': font.size,
                                                'font-family': font.fontFamily,
                                                'font-style': font.fontStyle,
                                                'font-weight': font.fontWeight,
                                            };
											if(series.type == "boxandwhisker"){
												for(var b=0;b<boxtext.length;b++){
													textOptionsCollection.push(textOptions);
												}
											}
											else
												textOptionsCollection.push(textOptions);											
											if(boxSeriesCount == totalVisible && series.type == "boxandwhisker")											
												chart.displayTooltip(true, { point:closestPoint.point[t], series:series, textCollection:textCollection, textOptionsCollection:textOptionsCollection, groupingTextId:groupingTextId});											
                                            else if (totalVisible == textCollection.length && series.type != "boxandwhisker" ) {
                                                chart.displayTooltip(true, { point:closestPoint.point[t], series:series, textCollection:textCollection, textOptionsCollection:textOptionsCollection, groupingTextId:groupingTextId});
                                            }
                                        }
                                        else {										   
												var rectxt = this.getTooltipFormat(closestPoint.point[t], series, seriesIndex, i, series.tooltip.format, i),
												tooltip = series.tooltip, font = tooltip.font ? $.extend(false, series.font, {}, tooltip.font) : series.font, textarea = ej.EjSvgRender.utils._measureText(rectxt.text, null, font), padding, heightwidth = (requireInvertedAxes) ? textarea.height : textarea.width, maxWidth = (maxWidth > heightwidth) ? maxWidth : heightwidth, newLines = Math.ceil(rectxt.text.toString().split("<br/>").length / 2);										
												this.model.tooltipPadding = Number(font.size.toString().replace(/px/i, '')) / 3;
												padding = this.model.tooltipPadding + series.tooltip.border.width * 2;
												if (!requireInvertedAxes) {
													if(series.type == "boxandwhisker")
													{
														for(var p=0;p<trackOutlier;p++)
														{
															tooltipRanges.push({ Start: trackPoints[p].Y - padding * newLines - textarea.height / 2, End: trackPoints[p].Y + padding * newLines + textarea.height / 2 });
															DisplayTooltipOptions.push({ Point: trackPoints[p], ClosestPoint: closestPoint.point[t], Series: series, ClosestPointIndex: closestPoint.index[t], Tgap: tgap, StEnd: tooltipRanges[p], TextArea: textarea, ReqInvertAxis: requireInvertedAxes });
														}	
													}
												else
												{
													tooltipRanges.push({ Start: visiblepts[currentLength].Y - padding * newLines - textarea.height / 2, End: visiblepts[currentLength].Y + padding * newLines + textarea.height / 2 });
													DisplayTooltipOptions.push({ Point: visiblepts[currentLength], ClosestPoint: closestPoint.point[t], Series: series, ClosestPointIndex: closestPoint.index[t], Tgap: tgap, StEnd: tooltipRanges[currentLength], TextArea: textarea, ReqInvertAxis: requireInvertedAxes });
												}
                                            }
                                            else {
                                                tooltipRanges.push({ Start: visiblepts[currentLength].X - padding - (textarea.width / 2), End: visiblepts[currentLength].X + padding + (textarea.width / 2) });
												DisplayTooltipOptions.push({ Point: visiblepts[currentLength], ClosestPoint: closestPoint.point[t], Series: series, ClosestPointIndex: closestPoint.index[t], Tgap: tgap, StEnd: tooltipRanges[currentLength], TextArea: textarea, ReqInvertAxis: requireInvertedAxes });
                                            }																																	
											if(series.type == "boxandwhisker" && boxSeriesCount == totalVisible)
											{
												maxWidth += (2 * padding);
                                                if (requireInvertedAxes) {
                                                    DisplayTooltipOptions = DisplayTooltipOptions.sort(function (a, b) { return a.Point.X - b.Point.X });
                                                }
                                                else {
                                                    DisplayTooltipOptions = DisplayTooltipOptions.sort(function (a, b) { return a.Point.Y - b.Point.Y });
                                                }
                                                this.SmartTooltipPosition(DisplayTooltipOptions);
                                                var displayLength = DisplayTooltipOptions.length;
                                                chart.displayTooltip(false, DisplayTooltipOptions, maxWidth);
                                                for (var i = 0; i < displayLength; i++) {                                                    
                                                    var seriesIndex = $.inArray(DisplayTooltipOptions[i].Series, this.model._visibleSeries);
                                                    if (DisplayTooltipOptions[i].Series._hiloTypes) {
                                                        data = { region: { Region: { PointIndex: DisplayTooltipOptions[i].ClosestPointIndex }, SeriesIndex: seriesIndex } };
                                                        this.highlightStart(evt, data, this._id + "_svg_SeriesGroup_" + seriesIndex, this._id + "_svg_Series" + seriesIndex + "_Point" + DisplayTooltipOptions[i].ClosestPointIndex, true);
                                                    }
                                                }
											}
                                            else if (DisplayTooltipOptions.length == totalVisible && series.type != "boxandwhisker") {											
                                                maxWidth += (2 * padding);
                                                if (requireInvertedAxes) {
                                                    DisplayTooltipOptions = DisplayTooltipOptions.sort(function (a, b) { return a.Point.X - b.Point.X });
                                                }
                                                else {
                                                    DisplayTooltipOptions = DisplayTooltipOptions.sort(function (a, b) { return a.Point.Y - b.Point.Y });
                                                }
                                                this.SmartTooltipPosition(DisplayTooltipOptions);
                                                var displayLength = DisplayTooltipOptions.length;
                                                chart.displayTooltip(false, DisplayTooltipOptions, maxWidth);
                                                for (var i = 0; i < displayLength; i++) {                                                    
                                                    var seriesIndex = $.inArray(DisplayTooltipOptions[i].Series, this.model._visibleSeries);
                                                    if (DisplayTooltipOptions[i].Series._hiloTypes) {
                                                        data = { region: { Region: { PointIndex: DisplayTooltipOptions[i].ClosestPointIndex }, SeriesIndex: seriesIndex } };
                                                        this.highlightStart(evt, data, this._id + "_svg_SeriesGroup_" + seriesIndex, this._id + "_svg_Series" + seriesIndex + "_Point" + DisplayTooltipOptions[i].ClosestPointIndex, true);
                                                    }
                                                }

                                            }
                                        }
                                    }
                                    else {
                                              tX, tY;
                                              chartLocation = document.getElementById(this.svgRenderer.svgObj.id).getClientRects()[0];
                                        chart.displayTemplateTooltip(tX, tY, point, closestPoint.point[t], series, seriesIndex, closestPoint.index[t], chartLocation);
                                    }
                                } else {
                                    // If both are same points, then viibility is set to visible
                                          element = $(this.svgObject).find('[id*="_TrackSymbol_"],[id*="_TrackToolTip"]');
                                    this.svgRenderer._setAttr($(element), { "visibility": 'visible' });
                                    $("#" + this._id).find('[id*="canvas_trackSymbol"]').css("visibility", "visible");
                                    element = $(this.svgObject).find('[id*="_TrackToolTip"]').children();
                                    this.svgRenderer._setAttr($(element), { "visibility": 'visible' });
                                    
                                    element = $(this.svgObject).find('[id*="_trackSymbol_"]');
                                    this.svgRenderer._setAttr($(element), { "visibility": 'visible' });

                                    $(chart.svgObject).find('[id*="_TrackAxisToolTip"]').attr("visibility", "visible");
                                    
                                    // Sets the tooltip template visibility to visible
                                    if (this.model.crosshair.tooltipTemplate != null) {
                                        element = $(document).find('[id*="_TrackToolTipTemplate_"]');
                                        this.svgRenderer._setAttr($(element), { "visibility": 'visible' });
                                    }
                                }
                                  }
                            } else {
                                
                                $('#' + this.svgObject.id + '_TrackSymbol_' + seriesIndex).remove();
                            }
                         }
						}
						else{						 
				            this._removeTrackBall();
						}
                    } 
				}else {
                        if (!showTrackLine) // //condition checked to display Track line for single series when chart have more than one series. 
                            $(chart.svgObject).find('[id*="_Tracker"]').remove();
                        var elem = $("#" + chart.svgObject.id + "_TrackSymbol_" + i);
                        var trackId = this.svgObject.id + '_TrackSymbol' + '_' + seriesIndex;
                        $("#" + this._id).find('[id*=' + trackId + ']').remove();					 
                        $("#" + chart._id).find('[id*=' + "_canvas_trackSymbol_" + i + ']').css("visibility", "hidden");
                        if (!this.model.enableCanvasRendering) {
                            // removed highlight style
                            $("[class*=" + "HighlightStyle" + "]").attr('class', '');
                            $("[class*=" + "HighlightLegendStyle" + "]").attr('class', '');
                            $("[class*=" + "HighlightLegendPathStyle" + "]").attr('class', '');
                            $("[class*=" + "HighlightPathStyle" + "]").attr('class', '');
                            $("[class*=" + "Highlightseries" + "]").attr('class', '');
                            $("[id*=" + this._id + "_Highlight_" + "]").remove();// removed canvas highlight           
                        }
                    }
                }
                series.trackerRemoved = false;
            }

           
           // To get the previous point values
            if (this.model.closestPoint != null)
            {
                this.model.prePoint = { point: closestPoint.point, pointIndex: closestPoint.index, series: series, seriesIndex: seriesIndex };
            }
            if ($("#" + this.svgObject.id + "_TrackAxisToolTip").length == 0 && this.model.crosshairLabelVisibility) {     // condition to check track axis tooltip is existing in DOM
                var gTrackAxisOptions = { 'id': chart.svgObject.id + '_TrackAxisToolTip', 'visibility': 'visible' };
                chart.gTrackAxisEle = chart.svgRenderer.createGroup(gTrackAxisOptions);
                chart.svgRenderer.append(chart.gTrackAxisEle, chart.gTrackball);
            }
            else {
                $("#" + this.svgObject.id + "_TrackAxisToolTip").css("display", "block");
            }
           
             if (point) {
                 var pointValue = closestPoint.point[0];
				 //Hide unnecessary crosshair labels. SVG and Canvas renders crosshair labels differently
                 if (enableCanvas)
					$(chart.svgObject.parentElement).find('[id*="AxisToolTipRect"]').css({"visibility": "hidden", "display":"none"});
				else
					$(chart.svgObject).find('[id*="_TrackAxisToolTip"]').attr("visibility", "visible").children().attr({"display": "none"});
                $.each(chart.model._axes, function (axisIndex, axis) {					
                    var areaX = axis.x;
                    var opposedPosition = axis._opposed;
                    if (!requireInvertedAxes) {
                        if (axis.orientation.toLowerCase() == "horizontal" && axis.crosshairLabel.visible) {
                            if ((point.X + areaX) <= (axis.x + axis.width) && axis.x <= (visiblepts[visiblepts.length - 1].X)) {
                                var valueType = axis._valueType.toLowerCase(), xVal, pointLocation;
                                xVal = ((point.X / (axis.width)) * (axis.visibleRange.delta) + axis.visibleRange.min).toFixed(2).replace(new RegExp("\\.0{" + 2 + "}"), "");
                                if (valueType == "logarithmic") xVal = Math.pow(axis.logBase, xVal);
                                if (valueType == "datetime") xVal = (ej.format(new Date(Math.floor(xVal)), ((ej.util.isNullOrUndefined(axis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(axis._intervalType) : axis.labelFormat), locale));
                                if (valueType == "category" || valueType == "datetimecategory") {
									if (typeof(pointValue.x) !== "object")
										xVal = pointValue.xValue;
                                    xVal = ej.EjSvgRender.utils._getLabelContent(Math.floor(xVal), axis, locale); xVal = xVal ? xVal : "undefined";
                                }
                                pointLocation = { X: (visiblepts[visiblepts.length-1].X), Y: (opposedPosition) ? (axis.y + axis.height - axis.majorTickLines.size) : (axis.y + axis.height + axis.majorTickLines.size + 10) };
                                chart.displayAxisTooltip(pointLocation, xVal, axis, axisIndex, mouseLocation, true);
                            }
                        }
                    }
                    else {
                        if (axis.orientation.toLowerCase() == "vertical" && axis.crosshairLabel.visible) {
                            if ((chart.mousemoveY) <= (axis.y + axis.height) && axis.y <= (chart.mousemoveY)) {
                                var valueType = axis._valueType.toLowerCase(), yVal = pointValue.xValue, ypointLocation=[];
                                if (valueType == "logarithmic") yVal = Math.pow(axis.logBase, yVal).toFixed(2).replace(new RegExp("\\.0{" + 2 + "}"), "");
                                if (valueType == "datetime") yVal = (ej.format(new Date(Math.floor(yVal)), ((ej.util.isNullOrUndefined(axis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(axis._intervalType) : axis.labelFormat), locale));
                                if (valueType == "category") yVal = ej.EjSvgRender.utils._getLabelContent(yVal, axis, locale);
                                ypointLocation = { X: axis.x, Y: (point.Y + axis.y) };
                                chart.displayAxisTooltip(ypointLocation, yVal, axis, axisIndex, mouseLocation);                                
                            }
                        }
                    }

                });
             }
            
            

        }
    },
    chartCrossHair: function (chart, mouseLocation) {
        var round = ((ej.util.isNullOrUndefined(this.model.primaryYAxis.roundingPlaces)) ? 2 : this.model.primaryYAxis.roundingPlaces),
            enableCanvas = chart.model.enableCanvasRendering, locale = this.model.locale;
        if ((!this.model.enable3D) && this.model.crosshair.visible && this.model.crosshair.type.toLowerCase() == "crosshair") {
            if ($("#" + this.svgObject.id + "_CrosshairGroup").length == 0) {     
                var gTrackballOptions = { 'id': this.svgObject.id + '_CrosshairGroup', 'visibility': 'visible' };
                if (enableCanvas) {
                    gTrackballOptions.position = "absolute";
                    chart.svgRenderer.drawCrosshairLine(gTrackballOptions, '#chartContainer_' + this._id);
                }
                else{
                    this.gCrosshair = this.svgRenderer.createGroup(gTrackballOptions);
                    this.svgRenderer.append(this.gCrosshair, this.svgObject);
                }
            }
            else
                $("#" + this.svgObject.id + "_CrosshairGroup").css("display", "block");
            if (chart.model.trackerElement) {
                if ($.finish)
                    $(this.model.trackerElement).finish();
                else
                    $(this.model.trackerElement).stop(true, true);
                this.model.trackerElement = null;               
            }

            
            var minX, maxX, minY, maxY;
            for (var i = 0; i < this.model._axes.length; i++) {
                var axis = this.model._axes[i];
                if (axis.orientation.toLowerCase() == 'vertical') {
                    if (mouseLocation.y >= axis.y && mouseLocation.y <= axis.y + axis.height)
                        if (axis.x < mouseLocation.x)
                            minX = Math.min(minX || axis.x, axis.x);
                        else
                            maxX = Math.max(maxX || axis.x, axis.x);
                }
                else
                    if (mouseLocation.x >= axis.x && mouseLocation.x <= axis.x + axis.width)
                        if (axis.y < mouseLocation.y)
                            minY = Math.min(minY || axis.y, axis.y);
                        else
                            maxY = Math.max(maxY || axis.y, axis.y);
            }
            var left = minX || this.model.m_AreaBounds.X,
            width = maxX ? maxX - left : this.model.m_AreaBounds.X + this.model.m_AreaBounds.Width - left,
            top = minY || this.model.m_AreaBounds.Y,
            height = maxY ? maxY - top : this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height - top;
			
            var d = "M" + " " + (this.mousemoveX) + " " + (top) + " " + "L" + " " + (this.mousemoveX) + " " + (top + height),
            dhor = "M" + " " + (left) + " " + (this.mousemoveY) + " " + "L" + " " + (left + width) + " " + (this.mousemoveY),
            chartOffset = $("#" + this._id).offset(),
            svgObject = chart.svgObject, options, optionsHor,
            chartPos = { left: svgObject.offsetLeft > chartOffset.left ? svgObject.offsetLeft : chartOffset.left,
                   		      top: svgObject.offsetTop > chartOffset.top ? svgObject.offsetTop : chartOffset.top};
            if ($("#" + chart.svgObject.id + "_CrosshairVertical").length == 0) {
                options = {
                    'id': chart.svgObject.id + "_CrosshairVertical",
                    'fill': 'none',
                    'stroke-width': chart.model.crosshair.line.width,
                    'stroke': chart.model.crosshair.line.color,
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)',
                    'd': d
                };
                if (enableCanvas) {
                    options.width = 0,
                    options.height = height,
                    options.top = top,
                    options.left = left,
                    options.position = "absolute", options.style = "solid", options.opacity = 0.5,                    
                    chart.svgRenderer.drawCrosshairLine(options, '#' + this.svgObject.id + '_CrosshairGroup');
                }
                else
                    chart.svgRenderer.drawPath(options, chart.gCrosshair);
            } else {
                chart.svgRenderer._setAttr($(chart.svgObject).find("#" + chart.svgObject.id + "_CrosshairVertical"), { "d": d });
                if (enableCanvas) {
                    $("#secondCanvas").remove();
                    $("#" + chart.svgObject.id + "_CrosshairVertical").css("left", this.mousemoveX).css({"top": top, "height" : height, "display" : "block"});
                }
                $("#" + chart.svgObject.id + "_CrosshairVertical").attr("visibility", "visible").css("display", "block");
            }
            
            if ($("#" + chart.svgObject.id + "_CrosshairHorizontal").length == 0) {
                optionsHor = {
                    'id': chart.svgObject.id + "_CrosshairHorizontal",
                    'fill': 'none',
                    'stroke-width': chart.model.crosshair.line.width,
                    'stroke': chart.model.crosshair.line.color,
                    'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)',
                    'd': dhor
                };
                if (enableCanvas) {
                    optionsHor.top = top + chartPos.top,
                    optionsHor.left = left + chartPos.left,
                    optionsHor.width = width,
                    optionsHor.height = 0,
                    optionsHor.position = "absolute", optionsHor.style = "solid", optionsHor.opacity = 0.5,                    
                    chart.svgRenderer.drawCrosshairLine(optionsHor, '#' + this.svgObject.id + '_CrosshairGroup');
                }
                else
                    chart.svgRenderer.drawPath(optionsHor, chart.gCrosshair);
            } else {
                chart.svgRenderer._setAttr($(chart.svgObject).find("#" + chart.svgObject.id + "_CrosshairHorizontal"), { "d": dhor });
                $("#" + chart.svgObject.id + "_CrosshairHorizontal").attr("visibility", "visible").css("display", "block");
                if (enableCanvas) {
                    $("#" + chart.svgObject.id + "_CrosshairHorizontal").css("top", this.mousemoveY).css({"left" : left, "width" : width, "display" : "block"});                    
                }
            }
            if ( $('#' + chart.svgObject.id + '_AxisCrossToolTip').length ==0) {
                var gAxisCrossOptions = { 'id': chart.svgObject.id + '_AxisCrossToolTip', 'visibility': 'visible' };
                chart.gTrackAxisEle = chart.svgRenderer.createGroup(gAxisCrossOptions);
                chart.svgRenderer.append(chart.gTrackAxisEle, chart.gCrosshair);
            }
            else {
                this.svgRenderer._setAttr($(chart.gTrackAxisEle), { "visibility": 'visible' });
                $(chart.gTrackAxisEle).css('display', 'block');
            }

            $.each(chart.model._axes, function (axisIndex, axis) {
                var valueType = axis._valueType.toLowerCase();
                if (axis.orientation.toLowerCase() == "horizontal" && axis.crosshairLabel.visible) {
                    if ((chart.mousemoveX) <= (axis.x + axis.width) && axis.x <= (chart.mousemoveX)) {
                        var labelplacement = (axis._valueType == "category" && axis.labelPlacement.toLowerCase()=='betweenticks') ? 0.5 : 0;
                        var xVal = ((Math.abs(chart.mousemoveX - (axis.isInversed ? axis.x + axis.width : axis.x)) / (axis.width)) * (axis.visibleRange.delta) + axis.visibleRange.min + labelplacement).toFixed(2).replace(new RegExp("\\.0{" + 2 + "}"), "");
                        if (valueType == "logarithmic") xVal = Math.pow(axis.logBase, xVal).toFixed(2).replace(new RegExp("\\.0{" + 2 + "}"), "");
                        if (valueType == "datetime") xVal = (ej.format(new Date(Math.floor(xVal)), ((ej.util.isNullOrUndefined(axis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(axis._intervalType) : axis.labelFormat), locale));
                        if (valueType == "category" || valueType == "datetimecategory") xVal = ej.EjSvgRender.utils._getLabelContent(xVal, axis, locale);
                        var xPointLocation = { X: (chart.mousemoveX), Y: (axis.y) };
                        chart.displayAxisTooltip(xPointLocation, xVal, axis, axisIndex, mouseLocation);
						 $("#" + chart.svgObject.id + '_AxisToolTipText' + '_' + axisIndex).show();
                        $("#" + chart.svgObject.id + '_AxisToolTipRect' + '_' + axisIndex).show();
                    }
					 else
					 {
                        $("#" + chart.svgObject.id + '_AxisToolTipText' + '_' + axisIndex).hide();
                        $("#" + chart.svgObject.id + '_AxisToolTipRect' + '_' + axisIndex).hide();
                    }
                } else if (axis.orientation.toLowerCase() == "vertical" && axis.crosshairLabel.visible) {
                    if ((chart.mousemoveY) <= (axis.y + axis.height) && axis.y <= (chart.mousemoveY)) {
                        var yVal = ((Math.abs(1 - (Math.abs(chart.mousemoveY - (axis.isInversed ? axis.y + axis.height : axis.y)) / (axis.width)) / (axis.height)) * (axis.visibleRange.delta) + axis.visibleRange.min).toFixed(round).replace(new RegExp("\\.0{" + round + "}"), ""));
                        if (valueType == "logarithmic") yVal = Math.pow(axis.logBase, yVal).toFixed(2).replace(new RegExp("\\.0{" + 2 + "}"), "");
                        if (valueType == "datetime") yVal = (ej.format(new Date(Math.floor(yVal)), ((ej.util.isNullOrUndefined(axis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(axis._intervalType) : axis.labelFormat), locale));
                        if (valueType == "category" || valueType == "datetimecategory") yVal = ej.EjSvgRender.utils._getLabelContent(yVal, axis, locale);
                        var ypointLocation = { X: axis.x, Y: (chart.mousemoveY) };
                        chart.displayAxisTooltip(ypointLocation, yVal, axis, axisIndex, mouseLocation);
						 $("#" + chart.svgObject.id + '_AxisToolTipText' + '_' + axisIndex).show();
                        $("#" + chart.svgObject.id + '_AxisToolTipRect' + '_' + axisIndex).show();
                    }
					 else
				     {
                        $("#" + chart.svgObject.id + '_AxisToolTipText' + '_' + axisIndex).hide();
                        $("#" + chart.svgObject.id + '_AxisToolTipRect' + '_' + axisIndex).hide();
                    }
                }
            });

        }
    },
    chartTouchMove: function (evt) {
	   this.cancelEvent(evt);
        evt = evt.originalEvent.touches[0];
        this.chartInteractiveBehavior(evt);

    },

    isZoomButtonHovered: function (target) {
        if (target.parentNode != null) {
            var parentId = target.parentNode.id;
            var id = target.id;
            if (id.indexOf('_ZoomInBtn ')==-1 && id.indexOf('ZoomOutBtn')==-1 && id.indexOf('_ZoomBtn') == -1 && id.indexOf('_ResetZoom') == -1 && id.indexOf('_PanBtn') == -1 && parentId && parentId.indexOf('_ZoomInBtn')==-1 && parentId.indexOf('_ZoomOutBtn')==-1&&parentId.indexOf('_ZoomBtn') == -1 && parentId.indexOf('_ResetZoom') == -1 && parentId.indexOf('_PanBtn') == -1)
                return false;
        }
        return true;
    },
 showTooltipOnDrag: function(chart,evt){
        $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackToolTip").attr('visibility', 'visible');
        $("#" + chart.svgObject.id + "_TrackToolTip").show();
        $(".tooltipDiv").css("display", "block");
    },
    chartInteractiveBehavior: function (evt) {
        var mouseMoveCords = this.calMousePosition(evt);
        this.mousemoveX = mouseMoveCords.X;
        this.mousemoveY = mouseMoveCords.Y;

        var id = "#" + this.svgObject.id;
        if (this.mouseWheelCoords) {
            var changeX = Math.abs(this.mouseWheelCoords.x - evt.pageX);
            var changeY = Math.abs(this.mouseWheelCoords.y - evt.pageY);
            if ((changeX > 0 || changeY > 0) && !(this.panning)) {
                this.enableTrackBall();
            } else {
                this.disableTrackBall();
            }
        }

        var chart = this,
        targetId = evt.target.id;        
        if (chart.model.AreaType == "cartesianaxes"  && this.mousemoveX >= this.model.m_AreaBounds.X && this.mousemoveX < (this.model.m_AreaBounds.X + this.model.m_AreaBounds.Width) && this.mousemoveY < (this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height) && this.mousemoveY >= this.model.m_AreaBounds.Y && this.model.initSeriesRender) {
            var mouseLocation = { x: chart.mousemoveX, y: chart.mousemoveY };
            var targetId = chart.svgRenderer._getAttrVal($(evt.target).parent(), "id");
            if ((targetId != undefined) && (targetId == chart.svgRenderer._getAttrVal($(this.svgObject).find(id + '_ZoomBtn'), "id") || targetId == chart.svgRenderer._getAttrVal($(this.svgObject).find(id + '_ResetZoom'), "id") || targetId == chart.svgRenderer._getAttrVal($(this.svgObject).find(id + '_PanBtn'), "id"))) {
                this.disableTrackBall();
            }
            else {
                this.enableTrackBall();
            }

            //show tooltip and track ball
            if (!this.model.crosshair.visible && !this.isZoomButtonHovered(evt.target))
                this.tooltip(chart, evt);
            else {
               if (this.dragPoint) 
                    this.showTooltipOnDrag(chart,evt)
              else if (!this.closestXyPoint) {
                $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackToolTip").attr('visibility','hidden');
                $("#" + chart.svgObject.id + "_TrackToolTip").hide();
                $(".tooltipDiv" + this._id).css("display", "none");
            }
}
            if (!this.model.enable3D) {
			    //crossHair of chart
                this.chartTrackball(chart, mouseLocation, evt);

			    //crossHair for chart area
                this.chartCrossHair(chart, mouseLocation);
			}

        } else {
            if ((chart.model.AreaType == "none" || chart.model.AreaType == 'polaraxes') && !this.isZoomButtonHovered(evt.target))
                this.tooltip(chart, evt);
            else {
			  if (this.dragPoint) 
                    this.showTooltipOnDrag(chart,evt)
              else if (!this.closestXyPoint) {	
                $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden');
                $("#" + chart.svgObject.id + "_TrackToolTip").hide();
                $(".tooltipDiv" + this._id).css("display", "none");
                this._removeTrackBall();
                this._removeHighlight();
            }
}
             //Removing exploded marker symbol when placing mouse outside chart area
                var pointData = this.model.prevPoint;
                if (pointData && pointData.point) {
                    if (this.model.enableCanvasRendering)
                        $("#canvas_trackSymbol").remove();
                    else {
					    if(pointData.series.type == "boxandwhisker")
							var pointLocation = pointData.outlierPosition;
						else						
							var pointLocation = ej.EjSvgRender.utils._getPoint(pointData.point, pointData.series);
                        chart.drawTrackerSymbol(pointData.series, pointData.seriesIndex, pointData.pointIndex, null, pointLocation);
                    }
                    this.model.prevPoint = null;
                }
        }      
      
    },

    // highlight SVG logic started here
    highlightSvg: function (chart, parentNodeId, isElement, evt, data, targetID, tracker) {
        if (parentNodeId != undefined) {
            var matchStr = this.svgObject.id + "_SeriesGroup_";
            var serIndex = parentNodeId.substr(matchStr.length);
            if (parentNodeId.indexOf(this.svgObject.id + "_symbolGroup_") >= 0) {
                matchStr = this.svgObject.id + "_symbolGroup_";
                serIndex = parentNodeId.substr(matchStr.length);
            }
        }
      
        serIndex = data != undefined ? data.region.SeriesIndex : serIndex
        var series = this.model.series[serIndex];
        if (isElement && series) {           
            if (series.highlightSettings.enable || tracker)
                this.highlight(chart, evt, series, null, data, parentNodeId, targetID, tracker);
        }

    },

     // canvas highlight logic started here
    highlightCanvas: function (chart, evt, data) {
        for (var i = 0; i < this.model._visibleSeries.length; i++) {
            var seriesIndex;
            var chartSeries;
            seriesIndex = i;
            chartSeries = this.model._visibleSeries[i];
            var type = chartSeries.type.toLowerCase();
            if (this.model.AreaType == "cartesianaxes" && chartSeries.visibility.toLowerCase() == 'visible' && type !== "scatter" && type !== "bubble" && type !== "column" && type.indexOf("bar") == -1 && type !== "stackingcolumn" && type !== "stackingcolumn100" && !chartSeries._hiloTypes) {
                var serY = [];
                var serX = [];
                var location = null;
                var mouseMoveCords = this.calMousePosition(evt);
                this.mousemoveX = mouseMoveCords.X;
                this.mousemoveY = mouseMoveCords.Y;
                var closestXyPoint = this.getClosesPointXY(serX, serY, chartSeries, this.mousemoveX, this.mousemoveY, evt);
                if (!ej.util.isNullOrUndefined(closestXyPoint.point)) {
                    var commonPointEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                    commonPointEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY }, region: { SeriesIndex: i, Region: { PointIndex: closestXyPoint.index } } };
                }
            }
        }
        var data = commonPointEventArgs ? commonPointEventArgs.data : data;
        if (data && this.model.series[data.region.SeriesIndex].highlightSettings.enable) {
            var series = $.extend({}, this.model.series[data.region.SeriesIndex]);
            series.pointIndex = data.region.Region.PointIndex;
            series.seriesIndex = data.region.SeriesIndex;
            series.data = data;
            if ($('#' + this._id + '_Selection_series' + series.seriesIndex + '_canvas').length == 0) {              
                // removed canvas highlight
                $("[id*=" + this._id + "_Highlight_" + "]").remove();
                if(!this.findCanvasSelection(series.seriesIndex,series.pointIndex,series.selectionSettings.mode.toLowerCase()))
                this.canvasHighlight(this, evt, series);
            }
        }
    },
    //change cursor symbols after resizing
    resizeCursor: function (containerSvg, mousemoveX, mousemoveY, chartAreaX, chartAreaY, chartAreaWidth, chartAreaHeight) {
        var selectedRectIndex = this.selectedRectIndex;
        if ((mousemoveX <= chartAreaX) || (mousemoveY <= chartAreaY) || (mousemoveX >= (chartAreaWidth + chartAreaX)) || (mousemoveY >= (chartAreaHeight + chartAreaY))) {
            $("#" + containerSvg + '_resize_rightRect' + selectedRectIndex).css({ 'cursor': 'default' });
            $("#" + containerSvg + '_resize_leftRect' + selectedRectIndex).css({ 'cursor': 'default' });
            $("#" + containerSvg + '_resize_bottomRect' + selectedRectIndex).css({ 'cursor': 'default' });
            $("#" + containerSvg + '_resize_topRect' + selectedRectIndex).css({ 'cursor': 'default' });
            $("#" + containerSvg + '_resize_bottomRightCornerCircle' + selectedRectIndex).css({ 'cursor': 'default' });
        }
        else if ((mousemoveX >= chartAreaX) || (mousemoveY >= chartAreaY) || (mousemoveX <= (chartAreaWidth + chartAreaX)) || (mousemoveY <= (chartAreaHeight + chartAreaY))) {
            $("#" + containerSvg + '_resize_rightRect' + selectedRectIndex).css({ 'cursor': 'e-resize' });
            $("#" + containerSvg + '_resize_leftRect' + selectedRectIndex).css({ 'cursor': 'w-resize' });
            $("#" + containerSvg + '_resize_bottomRect' + selectedRectIndex).css({ 'cursor': 's-resize' });
            $("#" + containerSvg + '_resize_topRect' + selectedRectIndex).css({ 'cursor': 'n-resize' });
            $("#" + containerSvg + '_resize_bottomRightCornerCircle' + selectedRectIndex).css({ 'cursor': 'se-resize' });
        }
    },
    multiSelectMouseMove: function (evt) {
        if (this._isMultiSelect && (this.multiSelectMode == 'range') && !this.dragPoint) {
            var mouseMoveCords = this.calMousePosition(evt),
            mouseMoveX = mouseMoveCords.X,
            mouseMoveY = mouseMoveCords.Y,
            gripMouseMoveX, gripMouseMoveY, translate,
            selectionSettingsType = this.multiSelectType,
            width, height, x, y,
            rectX, rectY, rectWidth, rectHeight,
            x1, x2, y1, y2, xPlotOffset, yPlotOffset,
            modifiedX, modifiedY,
            mouseDownX = this.mouseDownX,
            mouseDownY = this.mouseDownY,
            selectedRectIndex = this.selectedRectIndex,
            containerSvg = this.svgObject.id,
            chartArea = '#' + containerSvg + '_ChartArea'
            chartAreaX = parseInt($(chartArea).attr('x')),
            chartAreaY = parseInt($(chartArea).attr('y')),
            chartAreaWidth = parseInt($(chartArea).attr('width')),
            chartAreaHeight = parseInt($(chartArea).attr('height')),
            multiSelectMouseDownId = this.multiSelectMouseDownId,
            selctRectId = '#' + containerSvg + '_selectRect';
            multiAxis = this.multiAxis; 
            for (var q = 0; q < multiAxis.length; q++) {
                if (multiAxis[q].orientation.toLowerCase() == 'horizontal') {
                    x1 = multiAxis[q].Location.X1; x2 = multiAxis[q].Location.X2;
                    xPlotOffset = multiAxis[q].plotOffset;
                }
                else {
                    y1 = multiAxis[q].Location.Y1; y2 = multiAxis[q].Location.Y2;
                    yPlotOffset = multiAxis[q].plotOffset;
                }
            }
            if ((this.drag) && (!this.resize) && (!this.rectPan) && (!this.removeRect)) {
                var currentX = mouseMoveX,
                currentY = mouseMoveY,
                areaBounds = this.model.m_AreaBounds;
                this.multiSelectDraw = true;
                if (mouseMoveX < areaBounds.X) {
                    currentX = areaBounds.X;
                }
                else if (mouseMoveX > (areaBounds.X + areaBounds.Width)) {
                    currentX = areaBounds.X + areaBounds.Width;
                }
                if (mouseMoveY < areaBounds.Y) {
                    currentY = areaBounds.Y;
                } else if (mouseMoveY > (areaBounds.Y + areaBounds.Height)) {
                    currentY = areaBounds.Y + areaBounds.Height;
                }
                else {
                    currentY = mouseMoveY;
                }
                switch (selectionSettingsType) {
                    case 'x':
                        width = Math.abs(currentX - mouseDownX);
                        height = y1 - y2 + yPlotOffset + yPlotOffset;
                        x = currentX > mouseDownX ? mouseDownX : currentX;
                        y = y2 - yPlotOffset;
                        break;
                    case 'y':
                        width = x2 - x1 + xPlotOffset + xPlotOffset;
                        height = Math.abs(currentY - mouseDownY);
                        x = x1 - xPlotOffset;
                        y = currentY > mouseDownY ? mouseDownY : currentY;
                        break;
                    case 'xy':
                        width = Math.abs(currentX - mouseDownX);
                        height = Math.abs(currentY - mouseDownY);
                        x = currentX > mouseDownX ? mouseDownX : currentX;
                        y = currentY > mouseDownY ? mouseDownY : currentY;
                        break;
                }
                if (width > 0 && height > 0) {
                    var rectOptions = {
                        'id': this.svgObject.id + '_selectRect' + this.selectedRectIndex,
                        'x': x,
                        'y': y,
                        'width': width,
                        'height': height,
                        'fill': 'rgba(41,136,214,0.2)',
                        'stroke-width': 2,
                        'stroke': 'rgba(41,136,214,0.5)',
                        'cursor': 'pointer',
                        'clip-path': 'url(#' + this.svgObject.id + '_ChartAreaClipRect)'
                    };
                if ((x >= x1 + xPlotOffset) && (mouseMoveX <= x2 - xPlotOffset) && (mouseMoveY <= y1 + yPlotOffset) && (y >= y2 - yPlotOffset))
                    this.svgRenderer.drawRect(rectOptions, this.gEle);
                if ((this.gEle != null)) {
                    $(this.gEle).appendTo(this.parentgEle);
                    if (this.selectedRectIndex == 0) {
                        this.model.gCurrentEle = this.gEle;
                        }
                        $(this.parentgEle).appendTo(this.svgObject);
                    }
                }
            }
            rectX = parseInt($(selctRectId + selectedRectIndex).attr('x'));
            rectY = parseInt($(selctRectId + selectedRectIndex).attr('y'));
            rectWidth = parseInt($(selctRectId + selectedRectIndex).attr('width'));
            rectHeight = parseInt($(selctRectId + selectedRectIndex).attr('height'));
            if (!this.drag && (evt.target.id.indexOf("selectRect") >= 0 || evt.target.id.indexOf("resize") >= 0)) {
                if (evt.target.parentNode.id.indexOf("selectedRect") >= 0) {
                    id = evt.target.parentNode.id.split("selectedRect")[1].match(/\d+/)[0];
                    this.gripIndex = eval(id);
                }
                var selectRectId = '#' + containerSvg + '_selectRect',
                selectRectWidth = parseInt($(selectRectId + this.gripIndex).attr("width")),
                selectRectHeight = parseInt($(selectRectId + this.gripIndex).attr("height")),
                selectRectX = parseInt($(selectRectId + this.gripIndex).attr("x")),
                selectRectY = parseInt($(selectRectId + this.gripIndex).attr("y"));
                $("#" + containerSvg + "_gripCollection" + selectedRectIndex).css({ 'visibility': 'hidden' });
                if (selectRectX + selectRectWidth - 16 >= selectRectX || selectRectY + selectRectHeight - 16 >= selectRectY)
                    $("#" + this.svgObject.id + "_gripCollection" + this.gripIndex).attr({ 'transform': "" });
                if (selectRectX + selectRectWidth - 16 < selectRectX || selectRectY + selectRectHeight - 16 < selectRectY) {
                    var translate = 'translate(' + 15 + ',' + 15 + ')';
                    $("#" + this.svgObject.id + "_gripCollection" + this.gripIndex).attr({ 'transform': translate });
                }
                if (this.oldId != evt.target.id)
                    $("#" + containerSvg + "_gripCollection" + this.oldGripIndex).css({ 'visibility': 'hidden' });
                $("#" + containerSvg + "_gripCollection" + this.gripIndex).css({ 'visibility': 'visible' });
                this.oldId = evt.target.id;
                this.oldGripIndex = this.gripIndex;
            }
            if ((evt.target.id.indexOf("selectRect") < 0) && (evt.target.id.indexOf("resize") < 0 ))
                $("#" + containerSvg + "_gripCollection" + this.gripIndex).css({ 'visibility': 'hidden' });
            if (this.resize) {
                $("#" + containerSvg + "_closeTopRightCornerCircle" + selectedRectIndex).hide();
                $("#" + containerSvg + "_closePath" + selectedRectIndex).hide();
                $("#" + containerSvg + "_closePathOpposite" + selectedRectIndex).hide();
                $("#" + containerSvg + "_gripCollection" + selectedRectIndex).css({ 'visibility': 'hidden' });
                var oldRectX = this.oldRectX[selectedRectIndex], oldRectY = this.oldRectY[selectedRectIndex],
                oldRectHeight = this.oldRectHeight[selectedRectIndex], oldRectWidth = this.oldRectWidth[selectedRectIndex],
                oldReBottomRectY = this.oldReBottomRectY[selectedRectIndex],
                oldReRightRectX = this.oldReRightRectX[selectedRectIndex];
                switch (selectionSettingsType) {
                    case 'x':
                        if (multiSelectMouseDownId == containerSvg + '_resize_rightRect' + selectedRectIndex) {
                            rectWidth = mouseMoveX - oldRectX;
                            $("#" + containerSvg + "_resize_rightRect" + selectedRectIndex).attr('x', mouseMoveX - 5);
                            if (mouseMoveX < oldRectX) {
                                rectX = mouseMoveX;
                                rectWidth = oldRectX - mouseMoveX;
                            }
                            else if (mouseMoveX >= oldRectX) rectX = oldRectX;
                        }
                        else if (multiSelectMouseDownId == containerSvg + '_resize_leftRect' + selectedRectIndex) {
                            rectX = mouseMoveX;
                            rectWidth = oldRectWidth + oldRectX - mouseMoveX;
                            $("#" + containerSvg + "_resize_leftRect" + selectedRectIndex).attr('x', mouseMoveX - 5);
                            if (mouseMoveX > (oldReRightRectX + 5)) {
                                rectX = oldReRightRectX + 5;
                                rectWidth = mouseMoveX - oldRectX - oldRectWidth;
                            }
                        }
                        this.resizeCursor(containerSvg, mouseMoveX, mouseMoveY, chartAreaX, chartAreaY, chartAreaWidth, chartAreaHeight);
                        break;
                    case 'y':
                        if (multiSelectMouseDownId == containerSvg + '_resize_topRect' + selectedRectIndex) {
                            rectHeight = oldRectHeight + oldRectY - mouseMoveY;
                            rectY = mouseMoveY;
                            $("#" + containerSvg + "_resize_topRect" + selectedRectIndex).attr('y', mouseMoveY - 5);
                            if (mouseMoveY > (oldReBottomRectY + 5)) {
                                rectY = oldReBottomRectY + 5;
                                rectHeight = mouseMoveY - oldRectY - oldRectHeight;
                            }
                        }
                        else if (multiSelectMouseDownId == (containerSvg + '_resize_bottomRect' + selectedRectIndex)) {
                            rectHeight = mouseMoveY - oldRectY;
                            $("#" + containerSvg + "_resize_bottomRect" + selectedRectIndex).attr('y', mouseMoveY - 5);
                            if (mouseMoveY < oldRectY) {
                                rectY = mouseMoveY;
                                rectHeight = oldRectY - mouseMoveY;
                            }
                            else if (mouseMoveY >= oldRectY) rectY = oldRectY;
                        }
                        this.resizeCursor(containerSvg, mouseMoveX, mouseMoveY, chartAreaX, chartAreaY, chartAreaWidth, chartAreaHeight);
                        break;
                    case 'xy':
                        if (multiSelectMouseDownId == containerSvg + '_resize_rightRect' + selectedRectIndex) {
                            rectWidth = mouseMoveX - oldRectX;
                            $("#" + containerSvg + "_resize_rightRect" + selectedRectIndex).attr('x', mouseMoveX - 5);
                            if (mouseMoveX < oldRectX) {
                                rectX = mouseMoveX;
                                rectWidth = oldRectX - mouseMoveX;
                            }
                            else if (mouseMoveX >= oldRectX)
                                rectX = oldRectX;
                        }
                        else if (multiSelectMouseDownId == containerSvg + '_resize_leftRect' + selectedRectIndex) {
                            rectX = mouseMoveX;
                            rectWidth = oldRectWidth + oldRectX - mouseMoveX;
                            $("#" + containerSvg + "_resize_leftRect" + selectedRectIndex).attr('x', mouseMoveX - 5);
                            if (mouseMoveX > (oldReRightRectX + 5)) {
                                rectX = oldReRightRectX + 5;
                                rectWidth = mouseMoveX - oldRectX - oldRectWidth;
                            }
                        }
                        else if (multiSelectMouseDownId == containerSvg + '_resize_topRect' + selectedRectIndex) {
                            rectHeight = oldRectHeight + oldRectY - mouseMoveY;
                            rectY = mouseMoveY;
                            $("#" + containerSvg + "_resize_topRect" + selectedRectIndex).attr('y', mouseMoveY - 5);
                            if (mouseMoveY > (oldReBottomRectY + 5)) {
                                rectY = oldReBottomRectY + 5;
                                rectHeight = mouseMoveY - oldRectY - oldRectHeight;
                            }
                        }
                        else if (multiSelectMouseDownId == (containerSvg + '_resize_bottomRect' + selectedRectIndex)) {
                            rectHeight = mouseMoveY - oldRectY;
                            $("#" + containerSvg + "_resize_bottomRect" + selectedRectIndex).attr('y', mouseMoveY - 5);
                            if (mouseMoveY < oldRectY) {
                                rectY = mouseMoveY;
                                rectHeight = oldRectY - mouseMoveY;
                            }
                            else if (mouseMoveY >= oldRectY)
                                rectY = oldRectY;
                        }
                        else if (multiSelectMouseDownId == containerSvg + '_resize_bottomRightCornerCircle' + selectedRectIndex) {
                            rectWidth = mouseMoveX - oldRectX;
                            rectHeight = mouseMoveY - oldRectY;
                            $("#" + containerSvg + "_resize_bottomRightCornerCircle" + selectedRectIndex).attr({ 'cx': mouseMoveX, 'cy': mouseMoveY });
                            if ((mouseMoveX < oldRectX) && (mouseMoveY < oldRectY)) {
                                rectX = mouseMoveX;
                                rectY = mouseMoveY;
                                rectWidth = oldRectX - mouseMoveX;
                                rectHeight = oldRectY - mouseMoveY;
                            }
                            else if (mouseMoveX < oldRectX) {
                                rectX = mouseMoveX;
                                rectWidth = oldRectX - mouseMoveX;
                            }
                            else if (mouseMoveY < oldRectY) {
                                rectY = mouseMoveY;
                                rectHeight = oldRectY - mouseMoveY;
                            }
                            else if ((mouseMoveX >= oldRectX) && (mouseMoveY >= oldRectY)) {
                                rectX = oldRectX;
                                rectY = oldRectY;
                            }
                        }
                        this.resizeCursor(containerSvg, mouseMoveX, mouseMoveY, chartAreaX, chartAreaY, chartAreaWidth, chartAreaHeight);
                        break;
                }
                switch (selectionSettingsType) {
                    case 'x':
                        if (rectX >= x1 - xPlotOffset && (rectWidth + rectX - x1 <= x2 - x1 - xPlotOffset))
                            $(selctRectId + selectedRectIndex).attr({ 'x': rectX, 'width': rectWidth });
                        break;
                    case 'y':
                        if (((rectHeight + rectY - y2) <= y1 - y2 + yPlotOffset) && (rectY >= y2 - yPlotOffset))
                            $(selctRectId + selectedRectIndex).attr({ 'y': rectY, 'height': rectHeight });
                        break;
                    case 'xy':
                        if (rectX >= x1 - xPlotOffset && (rectWidth + rectX - x1 <= x2 - x1 - xPlotOffset) && (rectHeight + rectY - y2 <= y1 - y2 + yPlotOffset) && rectY >= y2 - yPlotOffset)
                            $(selctRectId + selectedRectIndex).attr({ 'x': rectX, 'y': rectY, 'width': rectWidth, 'height': rectHeight });;
                        break;
                }
            }
            if ((this.rectPan)) {
                $("#" + containerSvg + "_closeTopRightCornerCircle" + selectedRectIndex).hide();
                $("#" + containerSvg + "_closePath" + selectedRectIndex).hide();
                $("#" + containerSvg + "_closePathOpposite" + selectedRectIndex).hide();
                $("#" + containerSvg + "_gripCollection" + selectedRectIndex).css({ 'visibility': 'hidden' });
                if ((mouseMoveX <= chartAreaX || mouseMoveY <= chartAreaY || (mouseMoveX >= chartAreaX + chartAreaWidth) || (mouseMoveY >= chartAreaY + chartAreaHeight)))
                    this.multiSelectMouseUp(evt);
                modifiedX = this.PreviousCoords.X - evt.pageX;
                modifiedY = this.PreviousCoords.Y - evt.pageY;
                rectX = rectX - modifiedX;
                rectY = rectY - modifiedY;
                this.PreviousCoords.X = evt.pageX;
                this.PreviousCoords.Y = evt.pageY;
                switch (selectionSettingsType) {
                    case 'x':
                        if (rectX >= x1 - xPlotOffset && (rectWidth + rectX - x1 <= x2 - x1 - xPlotOffset))
                            $(selctRectId + selectedRectIndex).attr({ 'x': rectX });
                        break;
                    case 'y':
                        if ((rectHeight + rectY - y2 <= y1 - y2 + yPlotOffset) && rectY >= y2 - yPlotOffset)
                            $(selctRectId + selectedRectIndex).attr({ 'y': rectY });
                        break;
                    case 'xy':
                        if (rectX >= x1 - xPlotOffset && (rectWidth + rectX - x1 <= x2 - x1 - xPlotOffset) && (rectHeight + rectY - y2 <= y1 - y2 + yPlotOffset) && rectY >= y2 - yPlotOffset)
                            $(selctRectId + selectedRectIndex).attr({ 'x': rectX, 'y': rectY });
                        break;
                }
            }
        }
    },
    isTouch: function (evt) {
        var browserInfo = this.model.browserInfo,
            event = evt.originalEvent ? evt.originalEvent : evt;             
        if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
            return true;
        return false;
        
    },
    highlightStart: function (evt, data, parentNodeId, targetID, tracker) {
        if (evt.target.parentNode != null) {
            var parentNodeId = parentNodeId || evt.target.parentNode.id;
            var isElement = (parentNodeId.indexOf(this.svgObject.id + "_SeriesGroup_") >= 0 || parentNodeId.indexOf(this.svgObject.id + "_symbolGroup_") >= 0 || parentNodeId.indexOf(this.svgObject.id + "_TrackSymbol_") >= 0 || parentNodeId.indexOf(this.svgObject.id + "_Chart3D") >= 0) ? true : false;
        }
      
        if (this.model.enableCanvasRendering)
            this.highlightCanvas(this, evt, data);
        else
            this.highlightSvg(this, parentNodeId, isElement, evt, data, targetID, tracker)
    },
    
    _changeDraggingPoints: function (chartSeries, index, X, Y) {       
		X = chartSeries.xAxis._valueType == "datetime" ? new Date(X) : X;
        Y = chartSeries.yAxis._valueType == "datetime" ? new Date(Y) : Y;
        dragType = chartSeries.dragSettings.type.toLowerCase();
		if ((dragType == "x" || dragType == "xy") && chartSeries.xAxis._valueType != "category") {
            if (this.dragPoint) {
                chartSeries.pointCollection[index].x = X;
                chartSeries.pointCollection[index].xValue = (chartSeries.xAxis._valueType == "datetime" && typeof X != "object") ? new Date(X) : X;
            }
            else {
                chartSeries._visiblePoints[index].x = chartSeries.points[index].x = X;
                chartSeries._visiblePoints[index].xValue = chartSeries.points[index].xValue = (chartSeries.xAxis._valueType == "datetime" && typeof X == "object") ? Date.parse(X) : X;
            }
            if (!ej.util.isNullOrUndefined(chartSeries.dataSource))
                chartSeries.dataSource[index][chartSeries.xName] = X;
        }
		if (dragType == "y" || dragType == "xy") {
            if (this.dragPoint) {
                chartSeries.pointCollection[index].y = Y
                chartSeries.pointCollection[index].YValues[0] = (chartSeries.yAxis._valueType == "datetime" && typeof Y != "object") ? new Date(Y) : Y;
            }     
            else {
                chartSeries._visiblePoints[index].y = chartSeries.points[index].y = Y;
                chartSeries._visiblePoints[index].YValues[0] = chartSeries.points[index].YValues[0] = (chartSeries.yAxis._valueType == "datetime" && typeof Y == "object") ? Date.parse(Y) : Y;
            }
            if (!ej.util.isNullOrUndefined(chartSeries.dataSource))
                chartSeries.dataSource[index][chartSeries.yName] = Y;
        }
 },

     // Triggers while dragging the point
 _dragDelta: function (newXval,newYval,oldXval,oldYval,srIndex,ptIndex) {
     var chart = this,
        oldValue = { X: oldXval, Y: oldYval },
        newValue = { X: newXval, Y: newYval },
        commonDragEventArgs = $.extend({}, this.commonDragEventArgs);
        commonDragEventArgs.data = { seriesIndex: srIndex, pointIndex: ptIndex, oldValue: oldValue, newValue: newValue };
        this._trigger("dragging", commonDragEventArgs);
        this.commonDragEventArgs = commonDragEventArgs;
 },
 _getDraggedPoint:function(chartSeries,currentX,currentY){
     var mousePoint, PointX, PointY,x,y;
     var valAxis = ej.EjSvgRender.utils._getTransform(chartSeries.xAxis, chartSeries.yAxis, this.model.requireInvertedAxes);
     if (this.model.requireInvertedAxes) {
         x = (valAxis.y + valAxis.height) - currentY;
         y = (currentX - valAxis.x);
     }
     else {
         x = (currentX - valAxis.x);
         y = (valAxis.y + valAxis.height) - currentY;
     }
     mousePoint = ej.EjSvgRender.utils._getValuebyPoint(x, y, chartSeries);
     PointX = parseFloat(mousePoint.PointX.toFixed(2));
     PointY = parseFloat(mousePoint.PointY.toFixed(2));
     return { X: PointX, Y: PointY };
 },

_pointDragandDrop: function (chartSeries, evt, chart) {
    var i = chartSeries.data.seriesIndex,
        pointCollection = [], translate = null,
        chartType = chartSeries.type.toLowerCase();       
    var params = {};
        params.axes = {};    
        for (var k = 0; k < this.model._axes.length; k++)
            params.axes[this.model._axes[k].name] = {};           
       
        
            $("[id*=" + "_Marker" + "]").remove();
            var draggedPoints = this._getDraggedPoint(chartSeries, this.mousemoveX,this.mousemoveY),
                xPoint = draggedPoints.X,
                yPoint = draggedPoints.Y,
                xVal = this.commonDragEventArgs.data.currentPoint ? this.commonDragEventArgs.data.currentPoint.xValue : this.commonDragEventArgs.data.oldValue.X,
                yVal = this.commonDragEventArgs.data.currentPoint ? this.commonDragEventArgs.data.currentPoint.yValue[0] : this.commonDragEventArgs.data.oldValue.Y;
            if (chartSeries.region) {
                var region = chartSeries.region;                
                chart._dragDelta(xPoint, yPoint, xVal,yVal, region.SeriesIndex, region.Region.PointIndex);
            }
            else {
                var closestPoint = chartSeries.pointData;              
                chart._dragDelta(xPoint, yPoint, xVal, yVal,closestPoint.seriesIndex, closestPoint.index);
            }
            if (this.model.enableCanvasRendering) {
                if (this.canvasElement) this.canvasElement.clearRect(0, 0, chart.svgWidth, chart.svgHeight);
                if ($('#' + chart._id + '_PreviewSeries' + i + '_canvas').length == 0) {
                    var containerStyle = document.getElementById(chart._id + '_canvas').getBoundingClientRect();
                    canvasElement = this.createCanvasElement(chart._id + '_PreviewSeries' + i + '_canvas', chart.svgWidth, chart.svgHeight, containerStyle);
                    this.createRect(chart, canvasElement);
                    this.canvasElement = canvasElement;
                }
            }
            else {
                chartSeries.xAxis = (chartSeries.xAxis === null || chartSeries.xAxis === undefined) ? this.model._axes[0] : chartSeries.xAxis;
                chartSeries.yAxis = (chartSeries.yAxis === null || chartSeries.yAxis === undefined) ? this.model._axes[1] : chartSeries.yAxis;
                var trans = ej.EjSvgRender.utils._getTransform(chartSeries.xAxis, chartSeries.yAxis, this.model.requireInvertedAxes);
                var translate = 'translate(' + trans.x + ',' + trans.y + ')';
                var serOptions = { 'id': this.svgObject.id + '_PreviewSeriesGroup', 'transform': translate, 'cursor': 'default', 'visibility': 'visible' };
                $("#" + this.svgObject.id + "_PreviewSeriesGroup").attr("transform", translate);
                if (!this.gPreviewSeriesGroupEle) {
                    this.chartObj = chart;
                    this.chartObj.gPreviewSeriesGroupEle = this.gPreviewSeriesGroupEle = this.svgRenderer.createGroup(serOptions);
                }              
                if (this.gPreviewSeriesGroupEle.childNodes.length > 0)
                    this.gPreviewSeriesGroupEle.removeChild(this.gPreviewSeriesGroupEle.childNodes[0]);
            }
                pointCollection = $.extend(true, {}, chartSeries._visiblePoints);         
                chartSeries.pointCollection = pointCollection;
                pointCollection.length = chartSeries._visiblePoints.length;
                var dragEventArgs = chart.commonDragEventArgs.data;
                var ptindex = dragEventArgs.pointIndex,
                    srindex = dragEventArgs.seriesIndex;
                chart._changeDraggingPoints(chartSeries, ptindex, dragEventArgs.newValue.X, dragEventArgs.newValue.Y);
               
                var series = new ej.seriesTypes[chartType](),
                    point = chartSeries.pointCollection[ptindex];              
                if (chartType == "bubble") {
                    var location = ej.EjSvgRender.utils._getPoint(point, chartSeries);
                    var options = {
                        'id': this.svgObject.id + '_PreviewSeries' + srindex + '_Point' + ptindex,
                        'cx': location.X + this.canvasX,
                        'cy': (location.Y) + this.canvasY,
                        'r': point.radius,
                        'fill': chartSeries.fill,
                        'stroke-width': 2,
                        'visibility': 'visible',
                        'stroke-dasharray': "",
                        'opacity': 0.6,
                        'stroke': 'transparent'
                    };
                    if (this.model.enableCanvasRendering)
                        ej.EjCanvasRender.prototype.drawCircle(options, canvasElement);
                    else
                        this.svgRenderer.drawCircle(options, this.gPreviewSeriesGroupEle);
                    this.svgRenderer.append(this.gPreviewSeriesGroupEle, this.gSeriesEle);
                }
                else if(chartType=="scatter"){
                    var location = ej.EjSvgRender.utils._getPoint(point, chartSeries);
                    var symbolName = (chartSeries.marker.shape).capitalizeFirstString();
                    var location = { startX: location.X + this.canvasX, startY: location.Y +this.canvasY };
                    var style = {
                        ShapeSize: { width: chartSeries.marker.size.width, height: chartSeries.marker.size.height },
                        ID: this.svgObject.id + '_PreviewSeries' + srindex + '_Point' + ptindex,
                        Style: {Color:chartSeries.fill,
                            BorderWidth: chartSeries.marker.border.width,
                            BorderColor: 'transparent',
                            Opacity: 0.6,
                            Visibility:'visible'
                        }
                    };
                    if (this.model.enableCanvasRendering)
                        ej.EjSvgRender.chartSymbol["_draw" + symbolName](location, style, this, canvasElement);
                    else
                        ej.EjSvgRender.chartSymbol["_draw" + symbolName](location, style, this,this.gPreviewSeriesGroupEle);
                    this.svgRenderer.append(this.gPreviewSeriesGroupEle, this.gSeriesEle);
                }                      
                            
                    else if (chartType == "column" || chartType == "bar") {
                        point.xValue = (typeof point.xValue=="object")?Date.parse(point.xValue):point.xValue;
                        var origin = ej.EjSeriesRender.prototype.getOrigin(chart, chartSeries, params);
                        var sidebysideinfo = chartSeries.sidebysideInfo;
                        var y1 = point.YValues[0];
                        var y2 = origin;
                        //calculate sides
                        var data = ej.EjSeriesRender.prototype.calculateSides(point, sidebysideinfo);
                        var x1 = data.x1;
                        var x2 = data.x2;
                        var rect = ej.EjSeriesRender.prototype.getRectangle(x1, y1, x2, y2, chartSeries, chart);
                        options = {
                            'id': this.svgObject.id + '_PreviewSeries' + srindex + '_Point' + ptindex,
                            'x': rect.X + this.canvasX,
                            'y': rect.Y + this.canvasY,
                            'width': rect.Width,
                            'height': rect.Height,
                            'cornerRadius': chartSeries.cornerRadius,
                            'fill': chartSeries.fill,
                            'stroke-width': 2,
                            'plot': y1 < 0 ? "negative" : "positive",
                            'opacity': 0.6,
                            'stroke': 'transparent',
                            'stroke-dasharray': "",
                        };
                        if (this.model.enableCanvasRendering)
                            ej.EjCanvasRender.prototype.drawRect(options, canvasElement);
                        else {
                            this.svgRenderer.drawRect(options, this.gPreviewSeriesGroupEle);
                            this.svgRenderer.append(this.gPreviewSeriesGroupEle, this.gSeriesEle);
                        }
                    }
                    else
						{
						if(chartType=="spline" || chartType=="splinearea") 
							point.xValue = (typeof point.xValue == "object") ? Date.parse(point.xValue) : point.xValue;
                        series.draw(this, chartSeries, params);
						}
                var location = ej.EjSvgRender.utils._getPoint(point, chartSeries);
                if (chartSeries.tooltip.visible) {
                    if (ej.util.isNullOrUndefined(chartSeries.tooltip.template)) {                      
                        $(".tooltipDiv" + this._id).remove();
                        chart.displayShowTooltip(location, point, chartSeries, point.actualIndex);
                    }
                    else {                      
                        $("#" + chart.svgObject.id).find("#" + chart.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden');
                        var region = { SeriesIndex: srindex, Region: { PointIndex: point.actualIndex } };
                        chart.createTooltip(region, evt, chartSeries);
                    }
                }           
    
},
     // to show marker symbol for line type charts in dragdrop
_dragPointMarker: function (chartSeries, currentX, currentY, evt, closestXyPoint) {   
             var location = null,            
             srIndex = chartSeries.seriesIndex;
             location = ej.EjSvgRender.utils._getPoint(closestXyPoint.point, chartSeries);
             if (this.model.enableCanvasRendering) {
                 if ($('#' + this.svgObject.id + '_Marker').length == 0) {
                     var containerStyle = document.getElementById(this.svgObject.id).getBoundingClientRect();
                     ctx = this.createCanvasElement(this.svgObject.id + '_Marker', this.svgWidth, this.svgHeight, containerStyle);
                 }
             }
             else {
                 var markerOptions = { 'id': this.svgObject.id + '_markerGroup' + '_' + srIndex };
                 if (!this.gMarkerGroupEle)
                     this.gMarkerGroupEle = this.svgRenderer.createGroup(markerOptions);
             }
             var options = {
                'id': this.svgObject.id + '_Series' + srIndex + '_Point' + closestXyPoint.index + '_Marker',
                'cx': location.X + this.model.m_AreaBounds.X,
                'cy': location.Y + this.model.m_AreaBounds.Y,
                'r': 7,            
                'fill': chartSeries.fill,           
                'stroke-width': 3,
                'opacity': 1,
                'stroke': 'white',
                'visibility':'visible'
            };
            if (this.model.enableCanvasRendering)
                ej.EjCanvasRender.prototype.drawCircle(options, ctx);
            else {
                this.svgRenderer.drawCircle(options, this.gMarkerGroupEle);
                this.svgRenderer.append(this.gMarkerGroupEle, this.gSeriesEle);
            }
    },
     // to show 3 circles for column and bar while hovering rect in dragdrop
    _dragPointGripper:function(data){
        var type = data.region.type.toLowerCase(),
	                 chartSeries = this.model._visibleSeries[data.region.SeriesIndex],
                     point = chartSeries._visiblePoints[data.region.Region.PointIndex];
            transposed = chartSeries.isTransposed,
            inversed = chartSeries.yAxis.isInversed;
        if (type == "column" || type == "bar") {
            if (this.model.enableCanvasRendering) {
                var containerStyle = document.getElementById(this.svgObject.id).getBoundingClientRect();               
                canvasGripper = this.createCanvasElement(this.svgObject.id + '_Marker', this.svgWidth, this.svgHeight, containerStyle);
                document.getElementById(canvasGripper.canvas.id).style.zIndex = 1;
            }
            else {
                var markerOptions = { 'id': this.svgObject.id + '_markerGroup' + '_' + data.region.SeriesIndex };
                if (!this.gMarkerGroupEle)
                    this.gMarkerGroupEle = this.svgRenderer.createGroup(markerOptions);
            }
            var circleLength = 3,
                bounds = data.region.Region.Bounds;
                if ((transposed && type == "bar") || (type == "column" && !transposed)) {
                    value = bounds.Width;
                    boundValue = bounds.X;
                }
                if ((!transposed && type == "bar") || (type == "column" && transposed)) {
                    value = bounds.Height;
                    boundValue = bounds.Y;
                }
                loc = value < 75 ? value - value / 3 : 75 - 25;
                diff = value > 75 ? value - 75 : 0;
                radius = (loc - 6) / 6;
                cxy = diff / 2 + boundValue + loc / 6 + radius / 2;
            for (var k = 1; k <= circleLength; k++) {
                var options = {
                    'id': this.svgObject.id + '_Series' + data.region.SeriesIndex + '_Point' + data.region.Region.PointIndex + '_Marker' + k,
                    'fill': 'white',
                    'opacity': 1,
                    'stroke': 'white',
                    'visibility': 'visible'
                };
                if (k == 1)
                    cxy += radius;
                else
                    cxy += 2 * radius + 3;
                options.r = Math.abs(radius);
                if ((transposed && type == "bar") || (type == "column" && !transposed)) {                                                        
                    options.cx = cxy;
                    options.cy = inversed ? bounds.Y + bounds.Height - radius - 5 : bounds.Y + radius + 5;
                 }                
                if ((!transposed && type == "bar") || (type == "column" && transposed)) {
                   options.cx = inversed? bounds.X + radius + 5: bounds.X + bounds.Width - radius - 5;
                   options.cy = cxy;
                }             
                if (this.model.enableCanvasRendering)
                    ej.EjCanvasRender.prototype.drawCircle(options, canvasGripper);
                else
                    this.svgRenderer.drawCircle(options, this.gMarkerGroupEle);
            }
            this.svgRenderer.append(this.gMarkerGroupEle, this.gSeriesEle);
        }
    },
chartMouseMove: function (evt) {    

    var data = this.GetSeriesPoint(evt),
        svgObject = this.svgObject,
        model = this.model, zooming = model.zooming.enable,
        enableCanvas = model.enableCanvasRendering;
        model.event = evt;    
		clearTimeout(this.removeTooltip); // to clear the set timeout used to remove the tooltip template
        if (this.doPan && evt.target.id.indexOf(this._id + '_scrollbar') > -1)
            this.doPan = false;
        var classList = evt.target.classList,
		    chartOffset = { left: 0, top: 0 };
        if (this.multiSelectAreaType == 'cartesianaxes' && (!zooming) && (!enableCanvas))
            this.multiSelectMouseMove(evt);         
        if (this.rotateActivate && this.oPreviousCoords) {
            var difY = (this.oPreviousCoords.Y - this.mousemoveY);
            var difX = (this.oPreviousCoords.X - this.mousemoveX);          
            if (difX||difY) {
                model.tilt -= difY;
                model.rotation += difX;     
                // store the class name 
                if(this.model.isSelected)
                  var selection = this.selectedStyle(this);
                if(!this.isTouch(evt))
                   $(this.chart3D).empty();
                $('#template_group_' + this._id).empty();                
                var size = { Width: $(svgObject).width(), Height: $(svgObject).height() };
                this.graphics.view(svgObject, this, model.rotation, model.tilt, size, model.perspectiveAngle, model.depth);
                this.svgRenderer.append(this.chart3D, svgObject);               
                // Apply the class
                if (this.model.isSelected)
                for (var i = 0; i < selection.length; i++) {
                    $('#' + selection[i].id).attr('class', selection[i].className);
                }
            }
            this.oPreviousCoords.Y = this.mousemoveY;
            this.oPreviousCoords.X = this.mousemoveX;
        }
		
		 var targetId = evt.target.id;
            svgObjectId = svgObject.id,
            isZoom = this.isZoomButtonHovered(evt.target),
            visibleSeries = model._visibleSeries,
            seriesLength = visibleSeries.length;
	     $("[id*=" + "_Marker" + "]").remove();
	     for (var i = seriesLength - 1; i >= 0; i--) {
	         chartSeries = visibleSeries[i];
	         type = chartSeries.type.toLowerCase();
	         if (chartSeries.dragSettings.enable && !model.enable3D) {	             
	             this._enableDragging(chartSeries, i, evt);
	             if (this.dragPoint)	              
	                 break;
	             mouseMoveCords = this.calMousePosition(evt);
	             this.mousemoveX = mouseMoveCords.X;
	             this.mousemoveY = mouseMoveCords.Y;
	             var regionData = this.GetSeriesPoint(evt);
	             if (!chartSeries.marker.visible && type != "bubble" && type != "scatter" && type != "column" && type != "bar") {
	                 var closestXyPoint = this.getClosesPointXY(serX, serY, chartSeries, this.mousemoveX, this.mousemoveY, evt);
	                 if (closestXyPoint.point) {
	                     chartSeries.seriesIndex = i;
	                     this._dragPointMarker(chartSeries, this.mousemoveX, this.mousemoveY, evt, closestXyPoint);
	                     this.closestXyPoint = closestXyPoint;
	                     break;
	                 }
	             }
	             if (regionData && regionData.region.SeriesIndex == i) {
	                 this._dragPointGripper(regionData);
	                 break;
	             }
	         }
	      }
	     
	     var chart = this;	  
	     if (this.dragPoint) {
	         var serX = [], serY = [], type;
			$(document).keyup(function (evt) {
	             if (evt.keyCode == 27) {	                 
	                 $(".tooltipDiv" + this._id).remove();
	                 $("#" + svgObjectId + "_TrackToolTip").remove();
	                 chart.dragPoint = false;
	                 visibleSeries[chart.commonDragEventArgs.data.seriesIndex].pointCollection = null;
	                 chart.chartMouseUp(evt);
	             }
	         });	        
	         var index = this.dragIndex.seriesIndex;
	         chart._pointDragandDrop(visibleSeries[index], evt, chart);
	         }	 
        
        this.calMousePosition(evt)
        $("#" + this._id + "_tooltip").remove();
         
        if (this.dragPoint ||( !this.drag && !isZoom && ((!this.isTouch(evt) && !model.doubleTapped) || model.crosshairMoved))) {
            this.chartInteractiveBehavior(evt);            
        }
        // Checked condition for series highlighting
        if ((!model.crosshair.visible || model.AreaType != "cartesianaxes")) {
            if (!enableCanvas || !data) {
                // removed highlight style
                $("[class*=" + "HighlightStyle" + "]").attr('class', '');
                $("[class*=" + "HighlightLegendStyle" + "]").attr('class', '');
                $("[class*=" + "HighlightLegendPathStyle" + "]").attr('class', '');
                $("[class*=" + "HighlightPathStyle" + "]").attr('class', '');
                $("[class*=" + "Highlightseries" + "]").attr('class', '');
                $("[id*=" + this._id + "_Highlight_" + "]").remove();// removed canvas highlight           
            }
            this.highlightStart(evt, data);
        }
        if (!this.panning) {     
            var id = "#" + svgObjectId;
            if (zooming && model.AreaType == "cartesianaxes" && !model.enable3D) {
                if (this.drag && !this.dragPoint && !this.chartRightClick) {
                    this.disableTrackBall();
                    $('#' + svgObjectId + '_ZoomArea').remove();
                    var width, height, x, y;
                    var currentX = this.mousemoveX,
                        currentY = this.mousemoveY,
                        areaBounds = model.m_AreaBounds;
                    if (this.mousemoveX < areaBounds.X) {
                        currentX = areaBounds.X;
                    } else if (this.mousemoveX > (areaBounds.X + areaBounds.Width)) {
                        currentX = areaBounds.X + areaBounds.Width;
                    } 
                    if (this.mousemoveY < areaBounds.Y) {                     
                        currentY = areaBounds.Y;
                    } else if (this.mousemoveY > (areaBounds.Y + areaBounds.Height)) {
                        currentY = areaBounds.Y + areaBounds.Height;
                    }
                    else {
                        currentY = this.mousemoveY;
                    }
                   var zoomingType = model.zooming.type.toLowerCase();
                   if (zoomingType == "x") {
                        width = Math.abs(currentX - this.mouseDownX);
                        height = areaBounds.Height;
                        x = currentX > this.mouseDownX ? this.mouseDownX : currentX;
                        y = areaBounds.Y;
                   } else if (zoomingType == "y") {
                        width = areaBounds.Width;                      
                        height = Math.abs(currentY - this.mouseDownY);
                        x = areaBounds.X;
                        y = currentY > this.mouseDownY ? this.mouseDownY : currentY;

                    } else {                        
                        width = Math.abs(currentX - this.mouseDownX);
                        height = Math.abs(currentY - this.mouseDownY);
                        x = currentX > this.mouseDownX ? this.mouseDownX : currentX;
                        y = currentY > this.mouseDownY ? this.mouseDownY : currentY;

                    }                 
                    $(svgObject).css({
                        '-moz-user-select': '-moz-none',
                        '-khtml-user-select': 'none',
                        '-webkit-user-select': 'none',
                        '-ms-user-select': 'none',
                        'user-select': 'none'
                    });

                    this.zooming = true;

                    var rectOptions = {
                        'id': svgObjectId + '_ZoomArea',
                        'x': x + chartOffset.left,
                        'y': y + chartOffset.top,
                        'width': width,
                        'height': height,
                        'fill': 'rgba(69,114,167,0.25)',
                        'stroke-width': 1,
                        'stroke': 'rgba(69,114,167,0.25)',
                        'clip-path': 'url(#' + svgObjectId + '_ChartAreaClipRect)'
                    };
                    if (enableCanvas)
                        this.svgRenderer.drawZoomRect(rectOptions, this);
                    else
                        this.svgRenderer.drawRect(rectOptions, svgObject);
                }

            }
        }
		var deferredZoom = model.zooming.enableDeferredZoom;
        // Panning
		if (this.panning && this.doPan && model.AreaType == "cartesianaxes" && !this.dragPoint) {
            this.currentPageX = evt.pageX;
            this.currentPageY = evt.pageY;
            $("#" + this._id + "_canvas").css({ "cursor": "pointer" });
            if (!ej.isTouchDevice() && !deferredZoom) {
                var oDelta;
                oDelta = {
                    'x': this.oPreviousCoords.x - evt.pageX,
                    'y': this.oPreviousCoords.y - evt.pageY
                };

                this.oPreviousCoords = {
                    'x': evt.pageX,
                    'y': evt.pageY
                };
                $.each(model._axes, function(index, axis) {
                    var currentScale = Math.max(1 / ej.EjSvgRender.utils._minMax(axis.zoomFactor, 0, 1), 1);
                    chart.translate(axis, (oDelta.x), (oDelta.y), currentScale);
                });
                this._updateScroll();
                this.redraw(true, null, evt.target, this.isTouch(evt));
                this._cursorToPointer();
                this._enableZoomingButtons();
            }
            // Translate the series for other devices
            else if (ej.isTouchDevice() || deferredZoom) {
                for (var k = 0; k <visibleSeries.length; k++) {
                    var series = model.series[k],
                    transform = ej.EjSvgRender.utils._getTransform(series.xAxis, series.yAxis, model.requireInvertedAxes),
                    transX = (evt.pageX - this.oPreviousCoords.x) + transform.x,
                    transY = (evt.pageY - this.oPreviousCoords.y) + transform.y,
                    translate = 'translate(' + transX + ',' + transY + ')';
                   
                    $("#" + svgObjectId + "_SeriesGroup_" + k).attr("transform", translate);
                    $("#" + svgObjectId + "_symbolGroup_" + k).attr("transform", translate);
                    $("#" + svgObjectId + "_TextGroup_" + k).attr("transform", translate);
                    
                }
                for (var index = 0; index < model.indicators.length && model.indicators[index]._points.length>0; index++) {
                    var indicator = model.indicators[index];
                    transform = ej.EjSvgRender.utils._getTransform(indicator.xAxis, indicator.yAxis, model.requireInvertedAxes);
                    transX = (evt.pageX - this.oPreviousCoords.x) + transform.x;
                    transY = (evt.pageY - this.oPreviousCoords.y) + transform.y;
                    translate = 'translate(' + transX + ',' + transY + ')';
                    $("#" + svgObjectId + "_indicatorGroup_" + index).attr("transform", translate);
                }
            }
        }
		
		//Declaration
            var targetid = evt.target.id;
            var id = this._id;
            var parentId = ej.util.isNullOrUndefined(evt.target.parentNode) ? "" : evt.target.parentNode.id;
			
	//condition to find the buttons and display tooltip on hover
		if (zooming) {
            if (parentId == id + '_svg_ResetZoom')
                createBtnTooltip(this._localizedLabels.reset);
            else if (parentId == id + '_svg_PanBtn')
                createBtnTooltip(this._localizedLabels.pan);
            else if (parentId == id + '_svg_ZoomBtn')
                createBtnTooltip(this._localizedLabels.zoom);
            else if (parentId == id + '_svg_ZoomInBtn')
                createBtnTooltip(this._localizedLabels.zoomIn);
            else if (parentId == id + '_svg_ZoomOutBtn')
                createBtnTooltip(this._localizedLabels.zoomOut);
		}
	// method to create tooltip for zooming and panning buttons
        function createBtnTooltip(text) {
            var id = chart._id;
            if ($("#" + id + "_tooltip").length <= 0) {
                var tooltipdiv = $("<div></div>").attr({ 'id': id + "_tooltip", "class": "zoom" + id});
                $(tooltipdiv).html("&nbsp" + text + "&nbsp");
                $(document.body).append(tooltipdiv);
                // adding css prop to the div
                $(tooltipdiv).css({
                    "left": evt.pageX + 10,
                    "top": evt.pageY + 10,
                    "display": "block",
                    "position": "absolute",
                    "z-index": "13000",
                    "cursor": "default",
                    "font-family": "Segoe UI",
                    "color": "#707070",
                    "font-size": "12px",
                    "background-color": "#FFFFFF",
                    "border": "1px solid #707070"
                });
            } else {
                $("#" + id + "_tooltip").css({
                    "left": evt.pageX + 10,
                    "top": evt.pageY + 10
                });
            }

        }
        // axisLabelMouseMove event
        var axisData = this.getAxisLabelData(evt);
        if (axisData) {
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = axisData;
            this._trigger("axisLabelMouseMove", commonEventArgs);
        }
          
        if (!this.isTouch(evt)) {
            this.axisTooltip(evt, targetid);
              if (model.title.enableTrim)
					this.showTitleTooltip(evt, targetid);
            for (var i = 0, seriesLength = model.series.length; i < seriesLength; i++) {
                var series = model.series[i], dataLabel = series.marker.dataLabel;
                if (series._enableSmartLabels && !this.model.enable3D && !dataLabel.enableWrap) {
                    var template = dataLabel.template;
                    var font = dataLabel.font;
                    if (model.AreaType == "none" && ej.util.isNullOrUndefined(template)) {
                        this.datalabelTooltip(evt, i, font);
                    }
                }
            }
        }
      
            
        
        if ($(svgObject).find(id + '_ResetZoom,' + id + '_PanBtn,' + id + '_ZoomBtn').length > 0) {
            $(svgObject).find(id + '_ResetZoom,' + id + '_PanBtn,' + id + '_ZoomBtn').appendTo(svgObject);
        }

        var legenddata = this.getLegendData(evt);
        if (legenddata) {
            var commonLegendMoveEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonLegendMoveEventArgs.data = legenddata;
            if (legenddata.series.highlightSettings.enable) {
                if (enableCanvas) {
                    var series = $.extend({}, legenddata.series);
                    series.seriesIndex = legenddata.legendItem.LegendItem.SeriesIndex;
                    series.pointIndex = legenddata.legendItem.LegendItem.PointIndex;
                    var index = this.model.AreaType == 'none' ? series.pointIndex : series.seriesIndex;
                    if ($('#' + chart._id + '_Selection_Legend' + index + '_canvas').length == 0) {
                        //remove canvas legend highlight 
                        $("[id*=" + this._id + "_Highlight_" + "]").remove();
                        this.canvasHighlight(chart, evt, series, legenddata);                
                    }
                }
                else
                    this.highlight(chart, evt, legenddata.series, legenddata);
            }
            this._trigger("legendItemMouseMove", commonLegendMoveEventArgs);
            if (enableCanvas) {
                var mouseMoveCords = this.calMousePosition(evt),
                    mousemoveX = mouseMoveCords.X,
                    mousemoveY = mouseMoveCords.Y,
                    legendBounds = model.LegendBounds;
                    $(this.legendContainer).children().css({ "cursor": "pointer" });
                    if ((mousemoveX >= legendBounds.X) && (mousemoveX <= legendBounds.X + model.LegendViewerBounds.Width)) {
                        if ((mousemoveY <= legendBounds.Y + (model.LegendViewerBounds.Height)) && (mousemoveY >= legendBounds.Y)) {
                             this._textTooltip(evt, model.legendTextRegion);
                        }
                    }
            }
            else
                this._textTooltip(evt, model.legendTextRegion);
        }
        else if (enableCanvas)
            $(this.legendContainer).children().css('cursor', 'default');
        if (enableCanvas) {

            //condition to find the buttons and display tooltip on hover for Canvas
            if (targetid.indexOf("_ResetZoom") != -1 || parentId.indexOf("_ResetZoom") != -1)
                createBtnTooltip(this._localizedLabels.reset);
            else if (targetid.indexOf("_PanBtn") != -1 || parentId.indexOf("_PanBtn") != -1)
                createBtnTooltip(this._localizedLabels.pan);
            else if (targetid.indexOf("_ZoomBtn") != -1 || parentId.indexOf("_ZoomBtn") != -1)
                createBtnTooltip(this._localizedLabels.zoom);
            else if (targetid.indexOf("_ZoomInBtn") != -1 || parentId.indexOf("_ZoomInBtn") != -1)
                createBtnTooltip(this._localizedLabels.zoomIn);
            else if (targetid.indexOf("_ZoomOutBtn") != -1 || parentId.indexOf("_ZoomOutBtn") != -1)
                createBtnTooltip(this._localizedLabels.zoomOut);
            if (!this.isTouch(evt)) {
                this._textTooltip(evt, model.xAxisLabelRegions);
                this._textTooltip(evt, model.yAxisLabelRegions);
            }
        }
        
        var proxy = this;
        if (model.xAxisTitleRegion) {
            var currentX = this.mousemoveX,
                currentY = this.mousemoveY;
            $.each(model.xAxisTitleRegion, function (index, regionItem) {
                if ((currentX >= regionItem.Bounds.X) && (currentX <= regionItem.Bounds.X + regionItem.Bounds.Width)) {
                    if ((currentY >= regionItem.Bounds.Y - (regionItem.Bounds.Height)) && (currentY <= regionItem.Bounds.Y)) {
					    if (regionItem.trimText != regionItem.labelText) {
                        proxy.showAxisTooltip(evt.pageX, evt.pageY, regionItem.labelText);
					   }
                    }
                }
            });
        }
        if (model.yAxisTitleRegion) {
            var currentX = this.mousemoveX,
                currentY = this.mousemoveY;
            $.each(model.yAxisTitleRegion, function (index, regionItem) {
                 if ((currentX >= regionItem.Bounds.X) && (currentX <= regionItem.Bounds.X + regionItem.Bounds.Width)) {
                    if ((currentY >= regionItem.Bounds.Y - (regionItem.Bounds.Height)) && (currentY <= regionItem.Bounds.Y)) {
					    if (regionItem.trimText != regionItem.labelText) {
                        proxy.showAxisTooltip(evt.pageX, evt.pageY, regionItem.labelText);
						}
                    }
                }
            });
        }
        if (model.axisMultiLevelLabelRegions) {
            var currentX = this.mousemoveX,
                currentY = this.mousemoveY;
            $.each(model.axisMultiLevelLabelRegions, function (index, regionItem) {
                if ((currentX >= regionItem.Bounds.X) && (currentX <= regionItem.Bounds.X + regionItem.Bounds.Width)) {
                    if ((currentY >= regionItem.Bounds.Y - (regionItem.Bounds.Height)) && (currentY <= regionItem.Bounds.Y)) {
                        if (regionItem.trimText != regionItem.labelText) {
                            proxy.showAxisTooltip(evt.pageX, evt.pageY, regionItem.labelText);
                        }
                    }
                }
            });
        }

	   //chartMouseMove event
	   var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
	   commonEventArgs.data = { location: { x: this.mousemoveX, y: this.mousemoveY },size:{height:model.svgHeight,width:model.svgWidth}, id: evt.target.id, pageX: evt.pageX, pageY: evt.pageY };
	   this._trigger("chartMouseMove", commonEventArgs);
    },

    axisTooltip: function (evt, targetid) {
        var svgId = this.svgObject.id,
          hAxes = this.model.hAxes,
         vAxes = this.model.vAxes;

        if (targetid.indexOf("_YLabel_") >= 0) {
            var axis;
            // Loop to find the axis
            for (var j = 0; j < vAxes.length; j++) {
                if (targetid.indexOf(svgId + '_' + vAxes[j].name + '_YLabel_') >= 0) {
                    axis = vAxes[j];
                    break;
                }
            }
            if (axis && axis.enableTrim) {
                // Loop to find the labels in the axis
                visibleLabelsLength = axis.visibleLabels.length;
                for (var i = 0; i < visibleLabelsLength && this.model.AreaType == 'cartesianaxes'; i++) {
                    if (targetid == svgId + '_' + vAxes[j].name + '_YLabel_' + i) {
                        var ele = axis.visibleLabels[i];
                        var str = ele.Text == ele.displayText ? "" : ((axis.labelFormat) ? axis.labelFormat.replace("{value}", ele.Text) : ele.Text);
                        if (str == "") break;
                        if (axis.labelPosition.toLowerCase() == 'inside') {
                            this._hideTooltip();
                            this._removeTrackBall();
                        }
                        this.showAxisTooltip(evt.pageX, evt.pageY, str);
                    }
                }
            }
        }

        if (targetid.indexOf("_XLabel_") >= 0) {
            var axis;
            // Loop to find the axis
            for (var j = 0; j < hAxes.length; j++) {
                if (targetid.indexOf(svgId + '_' + hAxes[j].name + '_XLabel_') >= 0) {
                    axis = hAxes[j];
                    break;
                }
            }
            if (axis && (axis.enableTrim || axis.labelIntersectAction.toLowerCase() == "trim" || axis.labelIntersectAction.toLowerCase() == "wrap" || axis.labelIntersectAction.toLowerCase() == "wrapbyword")) {
                // Loop to find the labels in the axis
                visibleLabelsLength = axis.visibleLabels.length;
                for (var i = 0; i < visibleLabelsLength && this.model.AreaType == 'cartesianaxes'; i++) {
                    if (targetid == svgId + '_' + hAxes[j].name + '_XLabel_' + i) {
                        var ele = axis.visibleLabels[i];
                        var str = ele.Text == ele.displayText ? "" : ele.Text;
                        if (str == "") break;
                        if (axis.labelPosition.toLowerCase() == 'inside') {
                            this._hideTooltip();
                            this._removeTrackBall();
                        }
                        this.showAxisTooltip(evt.pageX, evt.pageY, str);
                    }
                }
            }
        }
    },

    showTitleTooltip: function (evt, targetid) {
        var measureTitle = ej.EjSvgRender.utils._measureText(this.model.title.text, $(this.svgObject).width() - this.model.margin.left - this.model.margin.right, this.model.title.font), model=this.model,
         titleLocation = model._titleLocation,
         subTitleLocation = model._subTitleLocation,
         titleEnableTrim = model.title.enableTrim,
         elementSpacing = model.elementSpacing,
         currentX = this.mousemoveX, currentY = this.mousemoveY,
         titleTextOverflow = model.title.textOverflow.toLowerCase(),
         subTitleEnableTrim = model.title.subTitle.enableTrim,
         subTitleTextOverflow = model.title.subTitle.textOverflow.toLowerCase(),
         titleText = model.title.text, subTitleText = model.title.subTitle.text;
        if (titleEnableTrim && this.model.trimTooltip) {
            if (targetid.indexOf("ChartTitleText") >= 0)
                this.showAxisTooltip(evt.pageX, evt.pageY, titleText);
            else if (this.model.enableCanvasRendering && currentX >= titleLocation.X - elementSpacing && currentX <= titleLocation.X - elementSpacing + titleLocation.size.width &&
               currentY >= (titleLocation.Y - (titleLocation._height)) && currentY <= titleLocation.Y + titleLocation.size.height)
                this.showAxisTooltip(evt.pageX, evt.pageY, titleText);
        }

        if (subTitleEnableTrim && model.subTitleTooltip) {
            if (targetid.indexOf("ChartSubTitleText") >= 0)
                this.showAxisTooltip(evt.pageX, evt.pageY, subTitleText);
            else if (model.enableCanvasRendering && currentX >= subTitleLocation.X && currentX <= subTitleLocation.X + subTitleLocation.size.width &&
                   currentY >= (subTitleLocation.Y) && currentY <= (subTitleLocation.Y) + subTitleLocation.size.height)
                this.showAxisTooltip(evt.pageX, evt.pageY, subTitleText);
        }
    },
     
    _updateScroll: function () {

        var scrollObj = this.model.scrollObj,
            scrollLength = scrollObj ? scrollObj.length : 0,
            axes = this.model._axes,
            scroll = this.scrollbarContainer, obj;
        for (var i = 0; i < scrollLength; i++) {
            if (scrollObj[i]) {
                obj = scrollObj[i];
               if (obj.zoomPosition != axes[i].zoomPosition || obj.zoomFactor != axes[i].zoomFactor) {
                    obj.zoomPosition = axes[i].zoomPosition;
                    obj.zoomFactor = axes[i].zoomFactor;
                    scroll._initializeScrollbarVariables(obj);
                    scroll._scrollbarUpdate.call(this, obj);
                    scroll._setScrollPosition.call(this, obj.startX, obj.startX + obj.rectWidth, obj);
                }
            }
        }
    },

    _hideTooltip: function () {
        $("#" + this.svgObject.id).find("#" + this.svgObject.id + "_TrackToolTip").attr('visibility','hidden');
        $("#" + this.svgObject.id + "_TrackToolTip").attr('visibility', 'hidden').hide();
        $('.tooltipDiv' + this._id).css("display", "none");
    },
    _removeHighlight: function () {
        $("[id*=" + "HighlightSegment" + "]").remove();
        $("[id*=" + "HighlightPath" + "]").remove();
        $("[id*=" + "HighlightLegendSegment" + "]").remove();
        $("[id*=" + "HighlightLegendPath" + "]").remove();
        $("[id*=" + "HighlightDef" + "]").remove();
	     $("[id*=" + "Highlightseries" + "]").remove();
	     $("[id*=" + this._id + "_Highlight_" + "]").remove();
	     if (!this.model.enableCanvasRendering && !this.vmlRendering) {
	         var highlightedElement = this.svgObject.querySelector("[class^='Highlight']");
	         if (highlightedElement !== null && highlightedElement.length == null)
	             highlightedElement.removeAttribute("class");
	         else
	             for (var j = highlightedElement && highlightedElement.length; j--;)
	                 highlightedElement.removeAttribute("class");
	     }
    },
    _removeSelection: function () {
        $("[id*=" + this._id + '_SelectionCluster_Legend' + "]").remove();
        $("[id*=" + this._id + '_Selection_series' + "]").remove();
        $("[id*=" + this._id + '_Selection_Cluster' + "]").remove();
        $("[id*=" +this._id + "SelectionSegment" + "]").remove();
        $("[id*=" +this._id + "SelectionPath" + "]").remove();
        $("[id*=" +this._id + "SelectionLegend" + "]").remove();
        $("[id*=" +this._id + "SelectionDef" + "]").remove();
	     $("[id*=" + this._id +"Selectionseries" + "]").remove();
        $('[id*=' + this._id + '_Selection_' + ']').remove();
    },

     
     //tooltip for trimmed datalabel
    datalabelTooltip:function(evt, i, font){
        var mouseMoveCords = this.calMousePosition(evt);
        this.mousemoveX = mouseMoveCords.X;
        this.mousemoveY = mouseMoveCords.Y;
		var containerId = this._id;
        var currentX = this.mousemoveX;
        var currentY = this.mousemoveY;
        var vmlRendering = this.vmlRendering;
        var space = this.model.elementSpacing;
        var chart = this;
        var minX, minY, maxX, maxY;
        var tooltipdiv, tooltipLength;
        var remaining
		  if(!ej.util.isNullOrUndefined(this.accDataLabelRegion[i]))
        {
      $.each(this.accDataLabelRegion[i], function (index, regionItem) {
            minX = regionItem.bounds.minX;
            minY = regionItem.bounds.minY;
            maxX = regionItem.bounds.maxX;
            maxY = regionItem.bounds.maxY;            
            if (vmlRendering) {
                minX = regionItem.bounds.minX + (regionItem.bounds.width / 2);
                maxX = regionItem.bounds.maxX + (regionItem.bounds.width / 2);
                minY = regionItem.bounds.minY;
                maxY = regionItem.bounds.maxY;
            }
            if (currentX >= minX && currentX <= maxX) {
                if (currentY >= minY && currentY <= maxY) {
                    $("#" + containerId + "_tooltip").remove();
                    tooltipdiv = $("<div></div>").attr({ 'id': containerId + "_tooltip", 'class': 'ejTooltip' + containerId });                   
                    if (regionItem.trimmedText != regionItem.text) {
                     $("#"+chart.svgObject.id+"_TrackToolTip").hide();
                        $(tooltipdiv).html(regionItem.text);
                        $(document.body).append(tooltipdiv);
                        tooltipLength = ej.EjSvgRender.utils._measureText(regionItem.text, regionItem.text.length, regionItem.font).width;
                        $(tooltipdiv).css({
                            "top": evt.pageY + space,
                            "display": "block",
                            "position": "absolute",
                            "z-index": "13000",
                            "cursor": "default",
                            "color": "#000000",
                            "font-size": font.size,
                            "background-color": "#FFFFFF",
                            "border": "1px solid #707070",
                            "white-space": "nowrap",
                            "padding": "5px"
                        });
                        if (regionItem.type == "pyramid" || regionItem.type == "funnel") {
                            remaining = chart.model.m_AreaBounds.Width + chart.model.m_AreaBounds.X - evt.pageX;
                            if (remaining > tooltipLength)
                                $(tooltipdiv).css({ "left": evt.pageX + space });
                            else {
                                left = evt.pageX - tooltipLength+(2*space);
                                $(tooltipdiv).css({ "left": left  });

                            }
                        }
                        if (regionItem.type == "pie" || regionItem.type == "doughnut" || regionItem.type == "pieofpie") {
                            if (minX > regionItem.bounds.centerX) {
                                remaining = chart.svgWidth - chart.model.margin.left - chart.model.margin.right - currentX;
                                if (remaining < tooltipLength) {
                                    left = evt.pageX - tooltipLength;
                                    $(tooltipdiv).css({ "left": left + space });
                                }
                                else
                                    $(tooltipdiv).css({ "left": evt.pageX + space });
                            }
                            else {
                                remaining = currentX;
                                if (remaining < tooltipLength) {
                                    $(tooltipdiv).css({ "left": evt.pageX + space });
                                }
                                else {
                                    left = evt.pageX - tooltipLength;
                                    $(tooltipdiv).css({ "left": left - (2 * space)});
                                }
                            }
                        }                       

                    }
                }
            }
        });
		}
    },
    // Tooltip in svg 
      showAxisTooltip: function (pageX, pageY, str) {
	        var id = this._id;
	        var tooltipdiv = $("<div></div>").attr({ 'id': id + "_tooltip", 'class': 'ejTooltip' + id });
            $(tooltipdiv).html("&nbsp" + str + "&nbsp");
            $(document.body).append(tooltipdiv);
            // adding css prop to the div
            $(tooltipdiv).css({
                "left": pageX + 10,
                "top": pageY + 10,
                "display": "block",
                "position": "absolute",
                "z-index": "13000",
                "cursor": "default",
                "font-family": "Segoe UI",
                "color": "#707070",
                "font-size": "12px",
                "background-color": "#FFFFFF",
                "border": "1px solid #707070"
            });
        },
    _textTooltip: function(evt,region){
		var chart = this,
            mouseMoveCords = this.calMousePosition(evt),
            isEjScroll = this.model.legend._ejScroller,
            scrolltop = isEjScroll ? $("#legend_" + this._id).ejScroller('instance').model.scrollTop : $("#legend_" + this._id).scrollTop(),
            scrollleft = isEjScroll ? $("#legend_" + this._id).ejScroller('instance').model.scrollLeft : $("#legend_" + this._id).scrollLeft(),    
            mousemoveX = mouseMoveCords.X,
            mousemoveY = mouseMoveCords.Y,
            currentX = mousemoveX,
            currentY = mousemoveY,
            containerId = this._id,
            chartModel = chart.model,
            legend = chartModel.legend,
            isScroll = legend.enableScrollbar,
            textOverflow = legend.textOverflow.toLowerCase(),
            displayText, tooltipdiv;
        
            if (isScroll || isEjScroll) {
                currentX = mousemoveX + scrollleft;
                currentY = mousemoveY + scrolltop;
            }
           
        $.each(region, function (index, regionItem) {             
            
            if ((currentX >= regionItem.bounds.x) && (currentX <= regionItem.bounds.x + regionItem.bounds.width)) {
                if ((currentY >= regionItem.bounds.y - (regionItem.bounds.height/3)) && (currentY <= regionItem.bounds.y)) {                    
                   
                    $("#" + containerId + "_tooltip").remove();
                    tooltipdiv = $("<div></div>").attr({ 'id': containerId + "_tooltip", 'class': 'ejTooltip' + containerId });
                    displayText = jQuery.type(regionItem.trimText) == "array" ? regionItem.trimText.join(" ") : regionItem.trimText;
                    if (displayText != regionItem.labelText) {
                            $(tooltipdiv).html("&nbsp" + regionItem.labelText + "&nbsp");
                            $(document.body).append(tooltipdiv);
                            // adding css prop to the div
                            $(tooltipdiv).css({
                                "left": evt.pageX + 10,
                                "top": evt.pageY + 10,
                                "display": "block",
                                "position": "absolute",
                                "z-index": "13000",
                                "cursor": "default",
                                "font-family": "Segoe UI",
                                "color": "#707070",
                                "font-size": "12px",
                                "background-color": "#FFFFFF",
                                "border": "1px solid #707070"
                            });
                    }       
                }
            }
        });
    },
    pieExplosion: function (data) {
	  this.model.explode = true;
        var region = data;
        var id;
        var targetElement;
        var symbolName;
        var series = region.region.Series;
        var seriesIndex = region.region.SeriesIndex;
        var seriesType = new ej.seriesTypes[series.type.toLowerCase()]();
        var explodePoint = series.explodeIndex;
        var _labelPosition = series.labelPosition.toLowerCase();
        currentExplodePoint = { SeriesIndex: region.pointData[0].SeriesIndex, PointIndex: region.pointData[0].PointIndex };
        var pieActualIndex = this.model._isPieOfPie ? region.pointData[0].PointIndex : region.region.Series._visiblePoints[region.pointData[0].PointIndex].actualIndex;
        if (explodePoint != pieActualIndex && !region.region.Series.explodeAll) {           
            series.explodeIndex = pieActualIndex;
            pieSeriesIndex = region.pointData[0].PieSeriesIndex;
            if (!ej.util.isNullOrUndefined(this.model.explodeValue)&& this.model.explodeValue != currentExplodePoint) {
                if (this.model.explodeValue.SeriesIndex != region.region.SeriesIndex)
                    series = this.model._visibleSeries[this.model.explodeValue.SeriesIndex];
                var visiblePoint = this.model._isPieOfPie? this._getPieOfPiePoint(this.model.explodeValue.PointIndex, series):series._visiblePoints[this.model.explodeValue.PointIndex];
                var result = seriesType._calculateArcData(this, this.model.explodeValue.PointIndex, visiblePoint, series, this.model.explodeValue.SeriesIndex,this.model.explodeValue.PieSeriesIndex);
                id = this.svgObject.id + '_SeriesGroup' + '_' + this.model.explodeValue.SeriesIndex;
                
                targetElement = (this.model.explodeValue.PieSeriesIndex == 1) ? $(this.gSeriesEle).children('#' + id)[1] : $(this.gSeriesEle).children('#' + id)[0];
                var elements = $(targetElement).children();
                for (var i = 0; i < elements.length; i++) {
                    var element = elements[i];
                    var index = this.svgRenderer._getAttrVal($(element)[0], "pointIndex");
                    if (parseInt(index) == this.model.explodeValue.PointIndex) {
                        this.svgRenderer._setAttr($(element), { 'd': result.Direction });
                        break;
                    }
                }

                seriesType.drawDataLabelAcc(this, series, this.model.explodeValue.PointIndex, visiblePoint, this.model.explodeValue.SeriesIndex, this.model.explodeValue.PieSeriesIndex)
                
            }
           
            var seriesPoint = this.model._isPieOfPie ? this._getPieOfPiePoint(data.region.Region.PointIndex, series) : series._visiblePoints[region.pointData[0].PointIndex];
            
            result = seriesType._calculateArcData(this, region.pointData[0].PointIndex, seriesPoint, region.region.Series, seriesIndex, pieSeriesIndex);
           
            id = this.svgObject.id + '_SeriesGroup' + '_' + region.region.SeriesIndex;
            targetElement = pieSeriesIndex == 1? $(this.gSeriesEle).children('#' + id)[1]:$(this.gSeriesEle).children('#' + id)[0];
          
          
            var elements = $(targetElement).children();

            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];
                var index = this.svgRenderer._getAttrVal($(element)[0], "pointIndex");
                if (parseInt(index) == region.pointData[0].PointIndex) {
                    this.svgRenderer._setAttr($(element), { 'd': result.Direction });
                    break;
                }
            }
            if (this.model.enableCanvasRendering) {
                var chartRect = document.getElementById(this.svgObject.id).getClientRects()[0];
                this.svgRenderer.ctx.clearRect(chartRect.left, chartRect.top, chartRect.width, chartRect.height);
                $("#" + this._id).ejChart("redraw");
            }
            
            
            seriesType.drawDataLabelAcc(this, series, region.pointData[0].PointIndex, seriesPoint, seriesIndex,pieSeriesIndex)
         
           
            this.model.explodeValue = { SeriesIndex: region.pointData[0].SeriesIndex, PointIndex: region.pointData[0].PointIndex, PieSeriesIndex:region.pointData[0].PieSeriesIndex };
        }
        region.region.Series.explodeIndex = explodePoint;
    },
    displayTemplateTooltip: function (x, y, location, seriesPoint, series, serIndex, ptIndex, chartLoc) {
        var point = $.extend(true, {}, seriesPoint);
        var padding = 5;
        var locale = this.model.locale;
        point.x = point.X;
        if (series.xAxis._valueType.toLowerCase() == "datetime")
            point.x = (ej.format(new Date(point.X), ((ej.util.isNullOrUndefined(series.xAxis.labelFormat)) ? ej.EjSvgRender.utils._dateTimeLabelFormat(series.xAxis.intervalType) : series.xAxis.labelFormat), locale));
        if (series.xAxis._valueType.toLowerCase() == "category") point.x = ej.EjSvgRender.utils._getLabelContent(ptIndex, series.xAxis, locale);
        // x and y is set to 0, if undefined
        x = ej.util.isNullOrUndefined(x) ? 0 : x;
        y = ej.util.isNullOrUndefined(y) ? 0 : y;
        var templateLocX = this.model.m_AreaBounds.X + chartLoc.left;
        var xLoc = location.X + x + templateLocX + this.model.crosshair.marker.size.width + padding;
        var yLoc = location.Y + y + this.model.m_AreaBounds.Y + chartLoc.top;
        var tooltipdiv;
        if ($("#" + this.svgObject.id + "_TrackToolTipTemplate_" + serIndex).length == 0) {
            tooltipdiv = $("<div class='TrackToolTipTemplate' style='position: absolute; z-index: 13000; display: block;'></div>");            
            $(document.body).append(tooltipdiv);
        }
        else {
            $(document).find('[id*="_TrackToolTipTemplate_"]').css("display", "block");
            tooltipdiv = $("#" + this.svgObject.id + "_TrackToolTipTemplate_" + serIndex)
            tooltipdiv.empty();
        }
        
        this.svgRenderer._setAttr($(tooltipdiv), { "id": this.svgObject.id + "_TrackToolTipTemplate_" + serIndex });
        if (this.model.crosshair.tooltipTemplate != null) {            
            var cloneNode = $("#" + this.model.crosshair.tooltipTemplate).clone();
            $(cloneNode).css("display", "block").appendTo(tooltipdiv);
            series.count = 1;
            point.count = 1;
            var seriesColor = this.getSeriesColor(point, serIndex, series);
            $(tooltipdiv).css("background-color", jQuery.type(seriesColor) == "array" ? seriesColor[0].color : seriesColor);
            var data = { series: series, point: point };
            $(tooltipdiv).html($(tooltipdiv).html().parseTemplate(data));
        }
        yLoc -= parseFloat($(tooltipdiv).css('height')) / 2;
        var templateWidth = parseFloat($(tooltipdiv).css('width'));
        if (xLoc + templateWidth > templateLocX + this.model.m_AreaBounds.Width)
            xLoc = location.X + x + templateLocX - this.model.crosshair.marker.size.width - padding - templateWidth;
        $(tooltipdiv).css("left", xLoc);
        $(tooltipdiv).css("top", yLoc);
    },

    displayAxisTooltip: function (location, text, axis, index, mouseLoc, tracker) {

        if (axis._valueType.toLowerCase() == "double") {
            var customFormat = (!(axis.labelFormat)) ? null : axis.labelFormat.match('{value}');
            text = (!(axis.labelFormat)) ? text : (customFormat != null) ? (axis.labelFormat == "${value}") ? axis.labelFormat.replace('{value}', '$' + Number(text)) : axis.labelFormat.replace('{value}', Number(text)) : (ej.format(Number(text), axis.labelFormat, this.model.locale));
        }
        var maxTickSize = 0,
            orientation = axis.orientation.toLowerCase(), position,
            hPadding = 0,
            vPadding = 0,
            opposedPosition = axis._opposed,
            enableCanvas = this.model.enableCanvasRendering,
            maxLocation = opposedPosition ? ((maxTickSize + 10) + (axis.x + axis.width)) : (axis.x + axis.width);
        for (var i = 0; i < this.model._axes.length; i++) {
            if (this.model._axes[i].majorTickLines.size > maxTickSize) {
                maxTickSize = this.model._axes[i].majorTickLines.size;
            }
        }
        
        if (location.X >= 0 && location.X <= maxLocation) {
            var x = (location.X);
            var y = location.Y;
            var padding = 5;
            var commonTrackTextArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonTrackTextArgs.data = { axisIndex: index, chartAxis: axis, currentTrackText: text, location: mouseLoc };
            this._trigger("trackAxisToolTip", commonTrackTextArgs);

            var trackAxisText = commonTrackTextArgs.data.currentTrackText;

            var textOffset = ej.EjSvgRender.utils._measureText(trackAxisText, null, axis.crosshairLabel.font);
            if (orientation == 'horizontal') {
                x = x - textOffset.width / 2;
                if (axis.labelPosition == 'inside' || (opposedPosition ? mouseLoc.y < axis.y : mouseLoc.y > axis.y)) {
                    if (opposedPosition == false) {
                        y = axis.y - textOffset.height + maxTickSize - (axis._isScroll ? this.model.scrollerSize : 0);
                        position = "top";
                    }
                    if (opposedPosition == true) {
                        y = axis.y + textOffset.height - maxTickSize;
                        position = "bottom";
                    }
                }
                else{                   
                    if (opposedPosition == true) {
                        y = axis.y - textOffset.height / 2 - padding - maxTickSize;
                        position = "bottom";
                    }
                    if (opposedPosition == false) {
                        y = axis.y + textOffset.height - padding + maxTickSize;
                        position = "top";
                    }
                }
                hPadding = padding;
                y = y + (axis._isScroll ? (axis.opposedPosition ? -this.model.scrollerSize : this.model.scrollerSize) : 0);
            }
            if (!(opposedPosition) && (x + textOffset.width) > (this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X)) {
                x = ((this.model.m_AreaBounds.Width + this.model.m_AreaBounds.X) - textOffset.width) + padding + this.model.elementSpacing;
            }
            if (orientation == 'vertical') {
			     y = location.Y + textOffset.height / 4;
			     if (axis.labelPosition == 'inside' || (!opposedPosition && mouseLoc.x < axis.x)) {
                    if (opposedPosition == true) {
                        x = axis.x - textOffset.width +  padding - maxTickSize;
                        position = "left";
                    }
                    if (opposedPosition == false) {
                        // Space between the marker and the trackball
                        x = axis.x + 2 * padding + (axis._isScroll ? this.model.scrollerSize : 0);
                        position = "right";
                    }
                } else {
			         if (opposedPosition == true) {
			             // Space between the marker and the trackball
                        x = axis.x + 3 * padding;
                        position = "left";
                    }
                    if (opposedPosition == false) {
                        x = axis.x - textOffset.width - maxTickSize;
                        position = "right";
                    }
                }                
			     x = x + (axis._isScroll ? (axis.opposedPosition ? this.model.scrollerSize : -this.model.scrollerSize) : 0);
			     vPadding = padding;
            }
           
            var textAxisOptions = {
                'id': this.svgObject.id + '_AxisToolTipText' + '_' + index,
                'x': x - vPadding,
                'y': y + hPadding,
                'fill': axis.crosshairLabel.font.color,
                'font-size': axis.crosshairLabel.font.size,
                'font-family': axis.crosshairLabel.font.fontFamily,
                'font-style': axis.crosshairLabel.font.fontStyle,
                'font-weight': axis.crosshairLabel.font.fontWeight,
                'text-anchor': 'start',
                'opacity': axis.crosshairLabel.font.opacity
              
            };
            var canvasPadding = (enableCanvas) ? padding / 4 : 0,
                 fontSize = ej.EjSvgRender.utils._measureText(commonTrackTextArgs.data.currentTrackText, this.model.m_AreaBounds.Width, axis.crosshairLabel.font),
                 crosshairLabel = axis.crosshairLabel,			    
                 x = (x - padding),
                 y = (y - (fontSize.height)),
                 width = (fontSize.width) + (2 * padding),
                 height = (2 * fontSize.height) - (2 * padding);
            var toolAxisRectOptions = {
                'x': x - vPadding,
                'y': y + hPadding,
                'width': width,
                'height': height,
                'rx': crosshairLabel.rx * ((enableCanvas) ? 2 : 1),
                'ry': crosshairLabel.ry * ((enableCanvas) ? 2 : 1)
            };
            var direction = ej.EjSvgRender.utils._calculateroundedCorner(toolAxisRectOptions, true, position, 0, tracker);
            toolAxisRectOptions = {
                'id': this.svgObject.id + '_AxisToolTipRect' + '_' + index,
                'd': direction,
                'fill': crosshairLabel.fill,
                'stroke-width': crosshairLabel.border.width,
                'stroke': crosshairLabel.border.color
            };          
           
             var axes = this.model._axes[index];
            if ((mouseLoc.y < (axes.y +axes.height) && mouseLoc.y > axes.y)||(mouseLoc.x < (axes.x + axes.width) && mouseLoc.x > axes.x)) {
                     this.svgRenderer._setAttr($('#' + this.svgObject.id + '_AxisToolTipRect' + '_' + index), { "display": 'block' });
                     this.svgRenderer._setAttr($('#' + this.svgObject.id + '_AxisToolTipText' + '_' + index), { "display": 'block' });                   
                     toolAxisRectOptions.display = 'block';
                 }
            else {
                     this.svgRenderer._setAttr($('#' + this.svgObject.id + '_AxisToolTipRect' + '_' + index), { "display": 'none' });
                     this.svgRenderer._setAttr($('#' + this.svgObject.id + '_AxisToolTipText' + '_' + index), { "display": 'none' });                    
                     toolAxisRectOptions.display = 'none';
                 }
            if (enableCanvas) {
                var obj = this.svgRenderer.createCrosshairCanvas();
                obj.ctx = obj.getContext('2d');                  
            }
            else
                var obj = this.svgRenderer;
            this.svgRenderer.drawPath.call(obj, toolAxisRectOptions, this.gTrackAxisEle);        
            this.svgRenderer.drawText.call(obj, textAxisOptions, commonTrackTextArgs.data.currentTrackText, this.gTrackAxisEle);           
        }
    },
    maxWdithArrayCollection: function (arrayCollection, font) {
        var maxTextWidth = 0,size, width = 0,height=0,
            measureText = ej.EjSvgRender.utils._measureText;
        for (var txt = 0, txtlength = arrayCollection.length; txt < txtlength; txt++) {
            size = measureText(arrayCollection[txt], 0, font);
            width = size.width;
            height += size.height;
            maxTextWidth = (maxTextWidth == 0) ? width : (maxTextWidth < width) ? width : maxTextWidth;
        }
        return { maxTextWidth: maxTextWidth, totalHeight: height };
    },
    displayTooltip: function (grouping, tooltipCollections, maxWidth) {
        // common variables for both grouping and float
        var crosshair = this.model.crosshair, trackball = crosshair.trackballTooltipSettings, rx = trackball.rx, ry = trackball.ry, trackballBorder = trackball.border,
            m_AreaBounds = this.model.m_AreaBounds;
        if(grouping){
            var series = tooltipCollections.series, groupSize, groupHeight, container = document.getElementById(this._id),
                offset = $(container).offset(),
                rectOptions = series.tooltip, font = rectOptions.font ? $.extend(false, series.font, {}, rectOptions.font) : series.font,
                point = series.type == "boxandwhisker" ? tooltipCollections.point.boxPlotLocation[3] : tooltipCollections.point.location,
                m_width =((series.marker.size.width/2 + series.marker.border.width+trackballBorder.width))+5,// 5 for space between group element and tracker
                yAxisY = ((series._isTransposed) ? (series.xAxis.y + m_width) : series.yAxis.y),
                xAxisX = ((series._isTransposed) ? series.yAxis.x : (series.xAxis.x + m_width)),
                location = { X: xAxisX + point.X, Y: yAxisY + point.Y },
                textCollection=tooltipCollections.textCollection,textOptionsCollection=tooltipCollections.textOptionsCollection,
                groupingTextId = tooltipCollections.groupingTextId,
                options,
                groupLocation = { X: (location.X), Y: location.Y },
                groupElement = document.getElementById(this._id + "_trackball_grouping_tooltip");
            this._trigger("trackToolTip", { data: { currentText: textCollection, location: groupLocation } });
            if (!ej.util.isNullOrUndefined(this.model.trackToolTip) && this.model.trackToolTip != "") {
                for (var tx = 0, len = textCollection.length; tx < len - 1; tx++) {
                    if (textCollection[tx].text == "") {
                        textCollection.splice(tx, 1);
                        textOptionsCollection.splice(tx, 1);
                        groupingTextId.splice(tx, 1);
                    }
                }
            }
            if (ej.util.isNullOrUndefined(groupElement)) {
                    groupElement = document.createElement("div");
                    options = {
                        'left': groupLocation.X,
                        'top': groupLocation.Y,
                        'border': parseInt((trackballBorder.width) ? trackballBorder.width : 1) + "px solid " + ((trackballBorder.color) ? trackballBorder.color : "#000000"),
                        'background': (trackball.fill) ? trackball.fill : "#ffffff",
                        'opacity': trackball.opacity,
                        'position': 'absolute',
                        'height': 'auto',
                        'width': 'auto',
                        'border-radius': rx + "px " + ry + "px",
                        'pointer-events': 'none'
                        };
                    groupElement.setAttribute('id', this._id + "_trackball_grouping_tooltip");
            }
            else {
                options = {
                    'left': groupLocation.X,
                    'top': groupLocation.Y,
                }
            }
                for (var tx = 0, len = textCollection.length; tx < len; tx++) {
                    span = document.createElement("span");
                    span.setAttribute("id", groupingTextId[tx]);
                    span.innerHTML = textCollection[tx].text + "</br>";
                    $(span).css(textOptionsCollection[tx]);
                    groupElement.appendChild(span);
                }
                var arrayCollection = textCollection.map(function (a) { return a.text; });
                groupSize = this.maxWdithArrayCollection(arrayCollection, font);
                maxWidth = groupSize.maxTextWidth;
                groupHeight = groupSize.totalHeight;
                options.top = (series._isTransposed) ? options.top : (options.top - (groupHeight * 0.5));
                options.left = (series._isTransposed) ? (options.left - (maxWidth * 0.5)) : options.left;
                if (textCollection.length > 1) {
                    options.top = (series._isTransposed) ? options.top : (yAxisY + (m_AreaBounds.Height * 0.5 - (0.5 * groupHeight)));
                    options.left = (series._isTransposed) ? (((m_AreaBounds.Width / 2) + m_AreaBounds.X) - (maxWidth * 0.5)) : options.left;
                }
                if (!series._isTransposed) {
                    if (options.left + maxWidth >= (m_AreaBounds.X + m_AreaBounds.Width))
                        options.left -= (maxWidth + (m_width+trackballBorder.width)*2);// extra space on edge group element swifting for already added need to remove 
                }
                else {

                    if ((groupHeight + options.top) > (m_AreaBounds.Y + m_AreaBounds.Height))
                        options.top -= (groupHeight + (m_width*2));// extra space on edge group element swifting
                }
                options.left = (groupLocation.X == location.X) ? options.left : groupLocation.X;
                options.top = (groupLocation.Y == location.Y) ? options.top : groupLocation.Y;
                $(groupElement).css(options);
				$(groupElement).appendTo(this.chartContainer);
                
        }
        else{
            for(var init=0,tlength=tooltipCollections.length;init<tlength;init++){	
				
                var location=tooltipCollections[init].Point,point= tooltipCollections[init].ClosestPoint, series=tooltipCollections[init].Series, pointIndex=tooltipCollections[init].ClosestPointIndex, tgap=tooltipCollections[init].Tgap,
                    seriesIndex = $.inArray(series, this.model._visibleSeries),   
                    Axis = { X1: m_AreaBounds.X, Y1: (m_AreaBounds.Y + m_AreaBounds.Height), X2: (m_AreaBounds.X + m_AreaBounds.Width), Y2: m_AreaBounds.Y },                    
                    axes = this.model._axes, pointXAxis = series._xAxisName, pointYAxis = series._yAxisName;
        
                for (var j = 0, len = axes.length; j < len; j++) {
                    if (pointXAxis == axes[j].name) {
                        if(!series._isTransposed)
                            Axis.X1 = axes[j].Location.X1, Axis.X2 = axes[j].Location.X2;
                        else
                            Axis.Y1 = axes[j].Location.Y1, Axis.Y2 = axes[j].Location.Y2;
                    }
                    else if (pointYAxis == axes[j].name) {
                        if (!series._isTransposed)
                            Axis.Y1 = axes[j].Location.Y1, Axis.Y2 = axes[j].Location.Y2;
                        else
                            Axis.X1 = axes[j].Location.X1, Axis.X2 = axes[j].Location.X2;
                    }
                }
				location.X = (series.type == "boxandwhisker") ? location.X + Axis.X1 : location.X;
                location.Y = (series.type == "boxandwhisker") ? location.Y + Axis.Y2 : location.Y;
                if((location.X>=Axis.X1 && location.X <=Axis.X2 && location.Y>= Axis.Y2 && location.Y<=Axis.Y1)||(grouping) ){
                    var requireInvertedAxes = this.model.requireInvertedAxes, tx, ty,
                        x = location.X + (!series.isIndicator ? ((ej.util.isNullOrUndefined(series._trackMarker)) ? series.marker.size.width : (series._trackMarker.size.width)) : 0) + padding + 1,
                        y = (location.Y), format = series.tooltip.format, numberToFixed = ((ej.util.isNullOrUndefined(series.yAxis.roundingPlaces)) ? 2 : series.yAxis.roundingPlaces);
						if(tooltipCollections[init].Series.type == "boxandwhisker" && location.outlier)
							var trackTooltipText = this.getTooltipFormat(point, series, seriesIndex, pointIndex, format, location);
						else
							var trackTooltipText = this.getTooltipFormat(point, series, seriesIndex, pointIndex, format, numberToFixed);
						var seriesName = (series.name) ? (series.name).replace(' ', '') : "series" + seriesIndex, commonTrackTextArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs),
                        toolRectOptions, direction;
                        commonTrackTextArgs.data = { Location: { X: x, Y: y }, Series: series, serIndex: seriesIndex, pointIndex: pointIndex, currentText: trackTooltipText.text };
                    this._trigger("trackToolTip", commonTrackTextArgs);
                    if (!commonTrackTextArgs.cancel) {
                        x = commonTrackTextArgs.data.Location.X;
                        y = commonTrackTextArgs.data.Location.Y;
                        var padding = this.model.tooltipPadding, tip_pos = tgap, rectOptions = series.tooltip, font = rectOptions.font ? $.extend(false, series.font, {}, rectOptions.font) : series.font, textOffset = ej.EjSvgRender.utils._measureText(commonTrackTextArgs.data.currentText, series.xAxis.width, font), seriesColor = this.getSeriesColor(point, seriesIndex, series), toolTipOptions = this.getTooltipOptions(seriesColor, series), rectBorderColor = toolTipOptions.rectBColor, rectFillColor = toolTipOptions.rectFColor, textColor = toolTipOptions.rectTextColor, rectWidth = textOffset.width + (2 * padding), rectHeight = textOffset.height + (2 * padding), poly, tipOpen = (requireInvertedAxes) ? ((rectWidth * 10) / 100) : ((rectHeight * 30) / 100),
                            axisWidth = (requireInvertedAxes) ? series.yAxis.width : series.xAxis.width, tooltipStartPosition = (requireInvertedAxes) ? (tgap + location.X - rectWidth / 2) : (tgap + location.Y - rectHeight / 2), tooltipEndPosition = (requireInvertedAxes) ? (tgap + location.X + rectWidth / 2) : (tgap + location.Y + rectHeight / 2), boundryStart = (requireInvertedAxes) ? (m_AreaBounds.X) : (m_AreaBounds.Y), boundryEnd = (requireInvertedAxes) ? (m_AreaBounds.X + m_AreaBounds.Width) : (m_AreaBounds.Y + m_AreaBounds.Height), text_pos = [],
                            marker_width = 3 + crosshair.marker.border.width + ((!requireInvertedAxes) ? crosshair.marker.size.width : crosshair.marker.size.height) / 2,
                            swp = (!this.model.financial) ? marker_width + 5 : 0, type = series.type.toLowerCase(),                           
                            position, hsize = type.indexOf("rangearea") == 0 ? this.model.crosshair.marker.size.height / 2 : 0;
                        if ((tooltipStartPosition >= boundryStart && tooltipEndPosition <= (boundryEnd)) || this.model.financial) {
                            if (requireInvertedAxes) {
                                if (location.Y - swp - maxWidth < m_AreaBounds.Y) {                         
                                    toolRectOptions = {
                                        'x': location.X - rectWidth / 2 + tip_pos,
                                        'y': location.Y + swp,
                                        'width': rectWidth,
                                        'height': rectHeight,
                                        'rx': rx,
                                        'ry': ry
                                    };
                                    text_pos.push({ X: location.X - rectWidth / 2 + padding + tip_pos, Y: location.Y + swp + rectHeight / 2 - padding });
                                    position = "top";
                                  
                                } else {
                                    if (this.model.financial) {
                                        x = location.X - rectWidth / 2 + tip_pos; y = location.Y + padding + hsize; tx = x + padding; ty = y + 2*padding;
                                        position = "top";
                                    }
                                    else {
                                        x = location.X - rectWidth / 2 + tip_pos; y = location.Y - swp - rectHeight; tx = location.X - rectWidth / 2 + padding + tip_pos; ty = location.Y - swp - rectHeight / 2 - padding;
                                        position = "bottom";
                                    }
                                    toolRectOptions = {
                                        'x': x,
                                        'y': y,
                                        'width': rectWidth,
                                        'height': rectHeight,
                                        'rx': rx,
                                        'ry': ry
                                    };
                                    text_pos.push({ X: tx, Y: ty });
                                 
                                }
                            }
                            else {
                               
                                if (location.X + swp + maxWidth - m_AreaBounds.X >= axisWidth) {
                                    if (this.model.financial) {
                                        x = location.X - rectWidth / 2; y = location.Y - rectHeight - padding - hsize; tx = x + padding; ty = y + tip_pos + rectHeight;
                                        position = "bottom";
                                    }
                                    else {
                                        x = location.X - swp - rectWidth; y = location.Y - rectHeight / 2 + tip_pos; tx = x + padding; ty = location.Y + tip_pos + rectHeight / 2;
                                        position = "right";
                                    }
                                    toolRectOptions = {
                                        'x': x,
                                        'y': y,
                                        'width': rectWidth,
                                        'height': rectHeight,
                                        'rx': rx,
                                        'ry': ry
                                    };
                           
                                    text_pos.push({ X: tx, Y:ty });
                                    
                                }
                                else {
                                    if (this.model.financial) {                                       
                                        x = location.X - rectWidth / 2; y = location.Y - hsize - rectHeight - 2 * padding; tx = x + padding; ty = y + tip_pos + rectHeight;
                                        position = "bottom";
                                    }
                                    else {
                                        x = location.X + swp; y = location.Y - rectHeight / 2 + tip_pos; tx = x + padding; ty = location.Y + tip_pos + rectHeight / 2;
                                        position = "left";
                                    }
                               
                                    toolRectOptions = {
                                        'x': x,
                                        'y': y,
                                        'width': rectWidth,
                                        'height': rectHeight,
                                        'rx': rx,
                                        'ry': ry
                                    };
                           
                                    text_pos.push({ X: tx, Y: ty });
                         
                                    
                                }
                            }                
                     
                                 
                   
                  
                            var tooltipfill = seriesColor;
                            if (typeof (tooltipfill) == "object") {
                                tooltipfill = seriesColor[1].color;
                            }
                           
                  
            
                            var text = commonTrackTextArgs.data.currentText,fontText = text,fontSize = ej.EjSvgRender.utils._measureText(text, series.xAxis.width, font).height,len;
                            if (commonTrackTextArgs.data.currentText.indexOf("<br/>") >= 0) {
                                text = commonTrackTextArgs.data.currentText.split("<br/>");
                                fontText = text[0];
                                if (!requireInvertedAxes) {
                                    var isCandle = (type.indexOf("candle") >= 0 || type.indexOf("hiloopenclose") >= 0) || false;
                                    if (location.X + swp + maxWidth - m_AreaBounds.X >= axisWidth) {
                                        if (!this.model.financial) {
                                            tx = location.X - rectWidth - swp + padding;
                                            ty = ((location.Y + tip_pos) - (rectHeight / 2) + fontSize / text.length);
                                        }
                                        else {
                                            tx = location.X - rectWidth / 2 + padding;
                                            ty = ((location.Y + tip_pos) - (rectHeight)) - hsize + ((isCandle) ? 0 : 2*padding);
                                            toolRectOptions.y -= (isCandle) ? padding * 3 : padding;
                                            toolRectOptions.height += (isCandle) ? padding * 2 : padding;
                                        }

                                          
                                        text_pos.push({ X: tx, Y: ty });
                                    }
                                    else {
                                        if (!this.model.financial) {
                                            tx = location.X + swp + padding;
                                            ty = ((location.Y + tip_pos) - (rectHeight / 2) + fontSize / text.length);
                                        }
                                        else {
                                            
                                            tx = location.X - rectWidth/2 + padding;
                                            ty = ((location.Y + tip_pos) - (rectHeight)) - hsize + ((isCandle) ? 0 : padding);
                                            toolRectOptions.y -= (isCandle) ? padding * 2 : padding;
                                            toolRectOptions.height += (isCandle) ? padding * 2 : padding;
                                        }
                                        text_pos.push({ X: tx, Y: ty });
                                    }
                                }
                                else {
                                    if (location.Y - swp - maxWidth < m_AreaBounds.Y) {
                                        text_pos.push({ X: location.X - rectWidth / 2 + padding + tip_pos, Y: location.Y + swp + (fontSize / text.length) });
                                    }
                                    else {
                                        if (!this.model.financial) {
                                            tx = location.X - rectWidth / 2 + padding + tip_pos;
                                            ty = location.Y - swp - rectHeight + (fontSize / text.length);
                                        }
                                        else {
                                            tx = location.X - rectWidth / 2 + padding + tip_pos;
                                            ty = (location.Y + 4 * padding) + hsize;
                                        }
                                        text_pos.push({ X: tx, Y: ty});
                                    }
                                }
                                fontSize = 0;
                            }
                            len = text_pos.length - 1;
                            fontSize = (requireInvertedAxes) ? fontSize : -fontSize;
							var index = series.type == "boxandwhisker" ? init : pointIndex ;
                            var textOptions = {
                                'id': this.svgObject.id + '_ToolTipText' + '_' + seriesIndex + "_" + index,
                                'x': text_pos[len].X,
                                'y': text_pos[len].Y+fontSize/2,
                                'fill': rectOptions.font ? (rectOptions.font.color ? rectOptions.font.color : "#ffffff") : "#ffffff",
                                'font-size': font.size,
                                'font-family': font.fontFamily,
                                'font-style': font.fontStyle,
                                'font-weight': font.fontWeight,
                                'text-anchor': 'start',
								'isTrackball': true,
                                'padding': this.model.tooltipPadding
                            };

                            direction = ej.EjSvgRender.utils._calculateroundedCorner(toolRectOptions, true, position, tip_pos);

                            var arrowPath = {
                                'id': this.svgObject.id + '_gTooltip_' + seriesIndex + '_' + index,
                                'd': direction,
                                'fill': ((trackball.fill) ? trackball.fill : tooltipfill),
                                "stroke-width": parseInt(trackball.border.width ? trackball.border.width : 0) + "px",
                                "stroke": trackball.border.color ? trackball.border.color : 'transparent',
                                'fill-opacity': trackball.opacity
                            };
                            
                            if (this.model.enableCanvasRendering) {
                                var obj = this.svgRenderer.createCrosshairCanvas();
                                obj.ctx = obj.getContext('2d');
                            }

                            else
                                var obj = this.svgRenderer;


                            var gTooltip = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_gTooltip_' + seriesIndex + "_" + index, });

                            this.svgRenderer.drawPath.call(obj, arrowPath, gTooltip);
                            this.svgRenderer.drawText.call(obj, textOptions, text, gTooltip, font);
                     
                        }
                    }

                    if ($('#' + this.svgObject.id + "_TrackToolTip_" + seriesIndex).length == 0)
                        this.svgRenderer.append($(gTooltip), this.gTrackball);
                }  
            }
        }
    },
    SmartTooltipPosition: function (SmartTooltipOptions) {
        var InitialRanges = [[], []], exceed, length_SmartTooltips = SmartTooltipOptions.length, visibleLocation = [], totalSapce = (SmartTooltipOptions[0].Series._isTransposed) ? this.model.m_AreaBounds.Width : this.model.m_AreaBounds.Height, tooltipPadding = this.model.tooltipPadding, tooltipWidth = -tooltipPadding;
        for (var a = 0; a < length_SmartTooltips; a++) {
            InitialRanges[0][a] = $.extend({}, SmartTooltipOptions[a].StEnd);
            InitialRanges[1][a] = { yAxis: SmartTooltipOptions[a].Series._yAxisName, xAxis: SmartTooltipOptions[a].Series._xAxisName, isTransposed: SmartTooltipOptions[a].Series._isTransposed };
            if (SmartTooltipOptions[a].ReqInvertAxis) {
                visibleLocation[a] = SmartTooltipOptions[a].Point.X;
            }
            else {
                visibleLocation[a] = SmartTooltipOptions[a].Point.Y;
            }
            tooltipWidth += SmartTooltipOptions[a].StEnd.End - SmartTooltipOptions[a].StEnd.Start + tooltipPadding;
        }
        this.ContinousOverlappingPoints(InitialRanges[0], visibleLocation);
        if (tooltipWidth < totalSapce)
            this.verticalArrangeMents(InitialRanges);
        for (var a = 0; a < length_SmartTooltips; a++) {
            SmartTooltipOptions[a].Tgap = (!this.model.financial) ? InitialRanges[0][a].Start - SmartTooltipOptions[a].StEnd.Start : 0;
        }
    },
    verticalArrangeMents: function (startEndRanges) {
        var pointsRanges = startEndRanges[0],
            axisNames = startEndRanges[1], //axis names contains isTransposed also
            obj = this.model.m_AreaBounds,
            padding = this.model.tooltipPadding,
            isTransposed,
            chartHeight,
            startPos,
            yAxisName,
            axes = this.model._axes,
            temp,//current trackabll tooltip start end
            secTemp,//vertical arrangements
            secWidth,//vertical arrange width
            condition,
            width, length = pointsRanges.length, i = length - 1, j = 0,k=0,axisLength=axes.length;
        for (; i >= 0; i--) {
            isTransposed = axisNames[i].isTransposed;
            yAxisName =axisNames[i].yAxis;
            for (k = 0; k < axisLength; k++) {
                if (yAxisName == axes[k].name) {
                    if (isTransposed) {
                        chartHeight = axes[k].Location.X2;
                        startPos = axes[k].Location.X1;
                    }
                    else {
                        chartHeight = axes[k].Location.Y1;
                        startPos = axes[k].Location.Y2;
                    }
                }
            }
            temp = pointsRanges[i];
            width = temp.End - temp.Start;
            if (chartHeight < temp.End) {
                temp.End = chartHeight - 2;
                temp.Start = temp.End - width;
                for(j=i-1;j>=0;j--)
                {
                    secTemp = pointsRanges[j];
                    secWidth = secTemp.End - secTemp.Start;
                    if (secTemp.End > pointsRanges[j + 1].Start && (pointsRanges[j + 1].Start > startPos && pointsRanges[j + 1].End<chartHeight)) {
                        secTemp.End = pointsRanges[j + 1].Start - padding;
                        secTemp.Start = secTemp.End - secWidth;
                    }
                }
            }
        }
        for (i = 0; i < length; i++) {
            isTransposed = axisNames[i].isTransposed;
            yAxisName = axisNames[i].yAxis;
            for (k=0; k < axisLength; k++) {
                if (yAxisName == axes[k].name) {
                    if (isTransposed) {
                        chartHeight = axes[k].Location.X2;
                        startPos = axes[k].Location.X1;
                    }
                    else {
                        chartHeight = axes[k].Location.Y1;
                        startPos = axes[k].Location.Y2;
                    }
                }
            }
            temp = pointsRanges[i];
            width = temp.End - temp.Start;
            if (temp.Start < startPos) {
                temp.Start = startPos + 1;
                temp.End = temp.Start + width;
                for (j = i + 1; j <= (length - 1) ; j++) {
                    secTemp = pointsRanges[j];
                    secWidth = secTemp.End - secTemp.Start;
                    if (secTemp.Start < pointsRanges[j - 1].End && (pointsRanges[j - 1].Start > startPos && pointsRanges[j - 1].End < chartHeight)) {
                        secTemp.Start = pointsRanges[j - 1].End + padding;
                        secTemp.End = secTemp.Start + secWidth;
                    }
                }
            }
        }
    },
    ContinousOverlappingPoints: function (TooltipRanges, visibleLocation) {
        var padding = this.model.tooltipPadding, temp = 0, Count = 0, Start = 0, StartPoint = 0, endPoint = TooltipRanges.length - 1, Range = (TooltipRanges[0].End - TooltipRanges[0].Start) + padding, halfHeight, midPos, tRange, kRange;
        temp = TooltipRanges[0].Start + Range;
        Start = TooltipRanges[0].Start;
        for (var i = 0; i < endPoint; i++) {
            if (temp >= TooltipRanges[i + 1].Start) {
                Range = TooltipRanges[i + 1].End - TooltipRanges[i + 1].Start + padding;
                temp += Range;
                Count++;
                if (Count - 1 == endPoint - 1 || i == endPoint - 1) {
                     halfHeight = (temp - Start) / 2;
                     midPos = (visibleLocation[StartPoint] + visibleLocation[i + 1]) / 2;
                     tRange = TooltipRanges[StartPoint].End - TooltipRanges[StartPoint].Start;
                    TooltipRanges[StartPoint].Start = midPos - halfHeight;
                    TooltipRanges[StartPoint].End = TooltipRanges[StartPoint].Start + tRange;
                    for (var k = StartPoint; k > 0; k--) {
                        if (TooltipRanges[k].Start <= TooltipRanges[k - 1].End + padding) {
                            kRange = TooltipRanges[k - 1].End - TooltipRanges[k - 1].Start;
                            TooltipRanges[k - 1].Start = TooltipRanges[k].Start - kRange - padding;
                            TooltipRanges[k - 1].End = TooltipRanges[k - 1].Start + kRange;
                        }
                        else {
                            break;
                        }
                    }
                    for (var j = StartPoint + 1; j <= StartPoint + Count; j++) {
                        tRange = TooltipRanges[j].End - TooltipRanges[j].Start;
                        TooltipRanges[j].Start = TooltipRanges[j - 1].End + padding;
                        TooltipRanges[j].End = TooltipRanges[j].Start + tRange;

                    }
                }

            }
            else {
                Count = i > 0 ? Count : 0;
                if (Count > 0) {
                     halfHeight = (temp - Start) / 2;
                     midPos = (visibleLocation[StartPoint] + visibleLocation[i]) / 2;
                     tRange = TooltipRanges[StartPoint].End - TooltipRanges[StartPoint].Start;
                    TooltipRanges[StartPoint].Start = midPos - halfHeight;
                    TooltipRanges[StartPoint].End = TooltipRanges[StartPoint].Start + tRange;
                    for (var k = StartPoint; k > 0; k--) {
                        if (TooltipRanges[k].Start <= TooltipRanges[k - 1].End + padding) {
                            kRange = TooltipRanges[k - 1].End - TooltipRanges[k - 1].Start;
                            TooltipRanges[k - 1].Start = TooltipRanges[k].Start - kRange - padding;
                            TooltipRanges[k - 1].End = TooltipRanges[k - 1].Start + kRange;
                        }
                        else {
                            break;
                        }
                    }
                    for (var j = StartPoint + 1; j <= StartPoint + Count; j++) {
                        tRange = TooltipRanges[j].End - TooltipRanges[j].Start;
                        TooltipRanges[j].Start = TooltipRanges[j - 1].End + padding;
                        TooltipRanges[j].End = TooltipRanges[j].Start + tRange;
                    }
                    Count = 0;
                }
                Range = (TooltipRanges[i + 1].End - TooltipRanges[i + 1].Start + padding);
                temp = TooltipRanges[i + 1].Start + Range;
                Start = TooltipRanges[i + 1].Start;
                StartPoint = i + 1;
            }

        }
    },
    getTooltipOptions: function (seriesColor, series) {
        var rectBorderColor, rectFillColor, rX, rY, textColor;
        if (this.model.theme.indexOf("gradient") >= 0) {
            rectBorderColor = jQuery.type(seriesColor) == "array" ? seriesColor[0].color : seriesColor;
            rectFillColor = 'white';
            textColor = "#333333";
            rX = 5;
            rY = 5;

        } else {
            var type = series.type.toLowerCase();
            if (type.indexOf("column") == -1 && type.indexOf("waterfall") == -1 && type.indexOf("bar") == -1 && type.indexOf("box") == -1  && type != "rangearea" && this.model.AreaType != "none") {
                rectFillColor = jQuery.type(seriesColor) == "array" ? seriesColor[0].color : seriesColor;
                rectBorderColor = 'transparent';
                textColor = "white";
            } else {
                rectBorderColor = "#333333";
                rectFillColor = 'white';
                textColor = "#333333";
            }
            rX = 0;
            rY = 0;
        }
        return { rectBColor: rectBorderColor, rectFColor: rectFillColor, rectTextColor: textColor, rectX: rX, rectY: rY };
    },
    getSeriesColor: function (point, seriesIndex, series) {
        var seriesColor;
        if (series && !series.isIndicator && !series.isTrendLine) {
            if (point._hiloFill) {
                if (!point._hiloFill._gradientStop)
                    seriesColor = point._hiloFill;
                else {
                    seriesColor = point._hiloFill._gradientStop[0].color;
                }
            }
            else if (point.fill) {
                if (!point.fill._gradientStop)
                    seriesColor = point.fill;
                else {
                    seriesColor = point.fill._gradientStop[0].color;
                }
            }
            else {
                if (series.type.toLowerCase() == "waterfall" && series.positiveFill &&
                    ((point.y > 0 && !point.showIntermediateSum && !point.showTotalSum) || point.waterfallSum > 0))
                    seriesColor = series.positiveFill;
                else
                    seriesColor = this.model.seriesColors[seriesIndex];
                
            }
        } else {
            seriesColor = series.fill;
        }
        return seriesColor;
    },
    getFormat: function (series,boxLocation) {

        if (!series.tooltip.format) {
            var type =series.type.toLowerCase();
			var outlierVisible = series.type != "boxandwhisker" ? 'null' : boxLocation.outlier;
            if (type.indexOf("range") > -1 || (type.indexOf("hilo") > -1 && type.indexOf("open") == -1))
                return "#point.x# <br/> High : #point.high# <br/> Low : #point.low#";
            else if (type.indexOf("candle") > -1 || type.indexOf("open") > -1)
                return "#point.x# <br/> High : #point.high# <br/> Low : #point.low# <br/> Open : #point.open# <br/> Close : #point.close#";
            else if (type.indexOf("bubble") >-1)
                return "#point.x# : #point.y# : #point.size#"
			else if(type.indexOf("box") > -1 && outlierVisible )
				return "X : #boxPlotPoints.xValue#  Y : #boxPlotPoints.YValues#";
			else if(type.indexOf("box") > -1 )
				return "Minimum : #boxPlotPoints.Minimum# <br/> Upper Quartile : #boxPlotPoints.UpperQuartile# <br/> Median : #boxPlotPoints.midvalue# <br/> Lower Quartile : #boxPlotPoints.LowerQuartile# <br/> Maximum : #boxPlotPoints.Maximum#  ";			 
			else	
             return "#point.x# : #point.y#"
        }
        return series.tooltip.format;
    },
    getTooltipFormat: function (seriesPoint, series, serIndex, ptIndex, format,boxLocation) {
         var point = $.extend(true, {}, seriesPoint),
            areaType = this.model.AreaType,
            locale = this.model.locale,
            xAxis = series.xAxis,
            yAxis = series.yAxis,
            xAxisValueType = xAxis._valueType.toLowerCase(),
            nullorundefined = ej.util.isNullOrUndefined,
            xAxisLabelFormat = xAxis.labelFormat,
            yAxisLabelFormat = yAxis.labelFormat,
            dateTimeFormat = ej.EjSvgRender.utils._dateTimeLabelFormat,
            decimalPlaces = ej.EjSvgRender.utils._decimalPlaces,
            xGlobalize = false, yGlobalize = false,
            xFormat,yFormat,
           customFormat, data,
           xPrecision, yPrecision, precisionDefault = 6, precisionHighest = 20;
        series.count = 1;
        point.count = 1;
        format = this.getFormat(series,boxLocation);
		while (format.indexOf('ej.format(') >= 0) {
            substr = format.substring(format.indexOf('ej.format('), format.indexOf(")") + 1);
            var calculate = substr.substring(substr.indexOf('(') + 1, substr.indexOf(","));
            if (calculate == "#point.x#") {
                xGlobalize = true,
                xFormat = substr.substring(substr.indexOf(',') + 1, substr.indexOf(")"));
            }
            else if (calculate == "#point.y#") {
                yGlobalize = true,
                yFormat = substr.substring(substr.indexOf(',') + 1, substr.indexOf(")"));
            } else {
                globalizeformat = substr.substring(substr.indexOf(',') + 1, substr.indexOf(")"));
                subStr1 = calculate.substring(calculate.indexOf('#') + 1);
                val = subStr1.substring(subStr1.indexOf('.') + 1, subStr1.indexOf('#'));
                if (point.hasOwnProperty(val) && point[val])
                    point[val] = ej.format(point[val], globalizeformat, locale);
            }
            format = format.replace(substr, calculate)
        }
		if (areaType == "cartesianaxes") {
            if (xAxisValueType.toLowerCase() == "datetime"){
                point.x = ej.format(new Date(point.xValue), ((nullorundefined(xAxisLabelFormat)) ? dateTimeFormat(series.xAxis._intervalType) : series.xAxis.labelFormat), locale);
                point.x = xGlobalize ? (ej.format(new Date(point.xValue), xFormat, locale)) : point.x;
		    }
            else if (xAxisValueType.toLowerCase() == "datetimecategory") {
                series.xAxis.intervalType = (ej.util.isNullOrUndefined(series.xAxis.intervalType) || series.xAxis.intervalType == "auto") ? "years" : series.xAxis.intervalType;
		        point.x = ej.format(new Date(point.x), ((nullorundefined(xAxisLabelFormat)) ? dateTimeFormat(series.xAxis.intervalType) : series.xAxis.labelFormat), locale);
		        point.x = xGlobalize ? (ej.format(new Date(point.x), xFormat, locale)) : point.x;
		    }
            else if (xAxisValueType.toLowerCase() == "category") {
                if (this.model.primaryXAxis.isIndexed)
                    point.x = (point.x) ? point.x : "undefined";
		        else
                point.x = ej.EjSvgRender.utils._getLabelContent(point.xValue, series.xAxis, locale);
            }
		    else
            {
                if ((xGlobalize && (xFormat.indexOf('e') == 0 || xFormat.indexOf('E') == 0)) ) {
                    point.x = this.convertExponential(xPrecision, precisionDefault, precisionHighest, point.x, xFormat);
                }
                else
                point.x = xGlobalize ? ej.format(point.x, xFormat, locale) : point.x;
                customFormat = (!(xAxisLabelFormat)) ? null : xAxisLabelFormat.match('{value}');
                point.x = (!(xAxisLabelFormat)) ? point.x : (customFormat != null) ? (xAxisLabelFormat == "${value}") ? xAxisLabelFormat.replace('{value}', '$' + point.x) : xAxisLabelFormat.replace('{value}', point.x) : (xGlobalize || (xAxisLabelFormat.indexOf('e') == 0 || xAxisLabelFormat.indexOf('E') == 0)) ? point.x : (ej.format(Number(point.x), xAxisLabelFormat, locale));

            }		
        }
        else {
            if (xAxisValueType == "date") {
                point.x = (ej.format(new Date(point.xValue), (dateTimeFormat('days')), locale));
                point.x = xGlobalize ? (ej.format(new Date(point.xValue), xFormat, locale)) : point.x;
            }                
		}
		if ((yGlobalize && (yFormat.indexOf('e') == 0 || yFormat.indexOf('E') == 0))) {
		    point.y = this.convertExponential(yPrecision, precisionDefault, precisionHighest, point.y, yFormat);
		}
		else {
		    point.y = point.waterfallSum ? point.waterfallSum : point.y;
		    point.y = yGlobalize ? ej.format(point.y, yFormat, locale) : point.y;
		}
        customFormat = (!(yAxisLabelFormat)) ? null : yAxisLabelFormat.match('{value}');
        point.y = (!(yAxisLabelFormat)) ? point.y : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + point.y) : yAxisLabelFormat.replace('{value}', point.y) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? point.y : (ej.format(Number(point.y), yAxisLabelFormat, locale));
        if ((areaType == 'none' || areaType == 'polaraxes') && xGlobalize && (xFormat.indexOf('e') == 0 || xFormat.indexOf('E') == 0)) {
            point.x = this.convertExponential(xPrecision, precisionDefault, precisionHighest, point.x, xFormat);
        }
		if(series.type.toLowerCase()=="boxandwhisker"){
		   var boxPlotLabels;
		   boxPlotLabels = series._visiblePoints[ptIndex].boxPlotValues;
			  if(boxLocation.outlier == true) { 
				for(var z=0;z<boxPlotLabels.outliers.length;z++)
				{
					if(boxLocation.YValues == boxPlotLabels.outliers[z] )
						boxLocation.YValues = (!(yAxisLabelFormat)) ? boxLocation.YValues : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + boxLocation.YValues) : yAxisLabelFormat.replace('{value}', boxLocation.YValues) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? boxLocation.YValues : (ej.format(Number(boxLocation.YValues), yAxisLabelFormat, locale));			
				}
			}
			else{			
				if(boxLocation.YValues == boxPlotLabels.Minimum )
					boxPlotLabels.Minimum = (!(yAxisLabelFormat)) ? boxPlotLabels.Minimum : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + boxPlotLabels.Minimum) : yAxisLabelFormat.replace('{value}', boxPlotLabels.Minimum) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? boxPlotLabels.Minimum: (ej.format(Number(boxPlotLabels.Minimum), yAxisLabelFormat, locale));
				else if(boxLocation.YValues == boxPlotLabels.Maximum )	
					boxPlotLabels.Maximum = (!(yAxisLabelFormat)) ? boxPlotLabels.Maximum : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + boxPlotLabels.Maximum) : yAxisLabelFormat.replace('{value}', boxPlotLabels.Maximum) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? boxPlotLabels.Maximum : (ej.format(Number(boxPlotLabels.Maximum), yAxisLabelFormat, locale));
				else if(boxLocation.YValues == boxPlotLabels.UpperQuartile)	
					boxPlotLabels.UpperQuartile = (!(yAxisLabelFormat)) ? boxPlotLabels.UpperQuartile : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + boxPlotLabels.UpperQuartile) : yAxisLabelFormat.replace('{value}', boxPlotLabels.UpperQuartile) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? boxPlotLabels.UpperQuartile : (ej.format(Number(boxPlotLabels.UpperQuartile), yAxisLabelFormat, locale));
				else if(boxLocation.YValues == boxPlotLabels.LowerQuartile)		
					boxPlotLabels.LowerQuartile = (!(yAxisLabelFormat)) ? boxPlotLabels.LowerQuartile : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + boxPlotLabels.LowerQuartile) : yAxisLabelFormat.replace('{value}', boxPlotLabels.LowerQuartile) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? boxPlotLabels.LowerQuartile : (ej.format(Number(boxPlotLabels.LowerQuartile), yAxisLabelFormat, locale));
				else if(boxLocation.YValues == boxPlotLabels.midvalue)		
					boxPlotLabels.midvalue = (!(yAxisLabelFormat)) ? boxPlotLabels.midvalue : (customFormat != null) ? (yAxisLabelFormat == "${value}") ? yAxisLabelFormat.replace('{value}', '$' + boxPlotLabels.midvalue) : yAxisLabelFormat.replace('{value}', boxPlotLabels.midvalue) : (yGlobalize || (yAxisLabelFormat.indexOf('e') == 0 || yAxisLabelFormat.indexOf('E') == 0)) ? boxPlotLabels.midvalue : (ej.format(Number(boxPlotLabels.midvalue), yAxisLabelFormat, locale));						
			}
			boxPlotLabels.count = series.count;
			boxPlotLabels.xValue = point.x;
			boxPlotLabels.YValues = boxLocation.YValues;		
			data = {boxPlotPoints : boxPlotLabels };	   
		 }
		else
			data = {series:series,point:point};
        format = format.parseTemplate(data);
        return {data: point,text:format};
    },
    convertExponential: function (precision, precisionDefault, precisionHighest, point, format) {
        precision = format.match(/(\d+)/g);
        precision = precision == null ? precisionDefault : precision > precisionHighest ? precisionHighest : precision;
        point = point.toExponential(precision);
        return point;
    },
    displayShowTooltip: function (location, point, series, pointIndex) {
	     var requireInvertedAxes = this.model.requireInvertedAxes;
       if (point.visible) {
            // fixed multiple tooltip issue in mobile
           $(".ejTooltip" + this._id).not("#" + this.svgObject.id + "_TrackToolTip").remove();
           if ($.finish)
               $(".ejTooltip" + this._id).finish();
           else
               $(".ejTooltip" + this._id).stop(true, true);
            var measureText, parentZindex, seriesIndex = (!series.isIndicator && !series.isTrendLine) ? $.inArray(series, this.model._visibleSeries) : 0,
            seriesColor,
            textOffset,
            padding = 7, bubbleSpacing = 15,
            x,
            y,
            trackTooltipText,
            format = series.tooltip.format;
            var position = document.getElementById(this.svgObject.id).getClientRects()[0];
            var chartPos = this.model.m_AreaBounds;
            var type = series.type.toLowerCase();
            //Set tooltip position ,text and color
            switch (this.model.AreaType) {
               
                case "cartesianaxes":
                    x = location.X + ((!series.isIndicator && !series.isTrendLine) ? ((ej.util.isNullOrUndefined(series._trackMarker)) ? 
                    (type == "bubble" ? (point.radius + bubbleSpacing): series.marker.size.width) : (series._trackMarker.size.width)) : 0) + (type == "column" || type == "bar" || type == "stackingbar" || type == "stackingcolumn" || type == "waterfall" || type == "rangecolumn" ? chartPos.X : (requireInvertedAxes) ? series.yAxis.x : series.xAxis.x);
                    //condition checked for multipleaxis line tooltip position changed
                    y = (location.Y) + (type.indexOf("column") != -1 || type.indexOf("waterfall") != -1 || type.indexOf("bar") != -1 || type.indexOf("rangearea") != -1 || type == "scatter" || type == "bubble" ? 
						(this.dragPoint ? (requireInvertedAxes ? series.xAxis.y : series.yAxis.y) : chartPos.Y) : (requireInvertedAxes) ? series.xAxis.y : series.yAxis.y);
                    if (this.dragPoint) {
                        x = x > series.xAxis.x ? x : series.xAxis.x;
                        y = y < series.yAxis.height + series.yAxis.y ? y : series.yAxis.height + series.yAxis.y;
                    }
                    seriesColor = this.getSeriesColor(point, seriesIndex, series);
                    break;

                case "polaraxes":
                    x = location.X + padding + ((ej.util.isNullOrUndefined(series._trackMarker)) ? series.marker.size.width : (series._trackMarker.size.width));
                    y = location.Y; 
                    seriesColor = this.getSeriesColor(point, seriesIndex, series);
                    break;

                case "none":
                    x = location.X + series.marker.size.width + padding;
                    y = (location.Y);
                    seriesColor = this.model.pointColors[pointIndex];
                    break;
            }
			
			
			if(series.type.toLowerCase() == "boxandwhisker")
			{
				for (var p=0; p< series._visiblePoints[pointIndex].boxPlotLocation.length; p++){
					var boxLocation = series._visiblePoints[pointIndex].boxPlotLocation[p];
					var outlierVisible = boxLocation.outlier;
					if(outlierVisible)
					{
						if(boxLocation .X + (series.outlierSettings.size.width/2) > location.X && boxLocation .X - (series.outlierSettings.size.width/2) < location.X ){
							if(boxLocation .Y + (series.outlierSettings.size.height/2) > location.Y && boxLocation .Y - (series.outlierSettings.size.height/2) < location.Y ){						
								trackTooltipText = this.getTooltipFormat(point, series, seriesIndex, pointIndex, format,boxLocation);
								textOffset = ej.EjSvgRender.utils._measureText(trackTooltipText.text);																
							}
						}					
					}					
					else
					{
						trackTooltipText = this.getTooltipFormat(point, series, seriesIndex, pointIndex, format,boxLocation);
						textOffset = ej.EjSvgRender.utils._measureText(trackTooltipText.text);	
					}						
			  }			  
			}
			else
			{			
				trackTooltipText = this.getTooltipFormat(point, series, seriesIndex, pointIndex, format);
				textOffset = ej.EjSvgRender.utils._measureText(trackTooltipText.text);
			}
            var toolTipOptions = this.getTooltipOptions(seriesColor, series);
            var rectBorderColor = toolTipOptions.rectBColor;
            var rectFillColor = toolTipOptions.rectFColor;
            var textColor = toolTipOptions.rectTextColor;
            var rX = toolTipOptions.rectX;
            var rY = toolTipOptions.rectY;
            var rectOptions = series.tooltip;
            //draw tooltip rectangle
            var tooltipdivRect;
            var padding = 5;

            if (document.getElementById(this.svgObject.id + "_TrackToolTip") == null)
                tooltipdivRect = $("<div></div>").attr({ 'id': this.svgObject.id + "_TrackToolTip", 'class': 'ejTooltip' + this._id });               
            else
                tooltipdivRect = $("#" + this.svgObject.id + "_TrackToolTip");
			var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
            if (ej.isTouchDevice() && !isIE11 && !this.vmlRendering) {
                if (window.navigator.msPointerEnabled)
                    this._on(tooltipdivRect, 'MSPointerMove', this.chartTooltipHover);
                else
                    this._on(tooltipdivRect, 'touchmove', this.chartTooltipHover);
            }
            else {
                this._on(tooltipdivRect, 'mousemove', this.chartTooltipHover);
            }
            $("#" + this.svgObject.id + "_TrackToolTip").show();
			parentZindex = $('#' + this._id).parent()[0].style.zIndex;
            var rectOptions = {
                'top': y + $(document).scrollTop(),
                'left': x + $(document).scrollLeft(),
                "background-color": (rectOptions.fill) ? rectOptions.fill : rectFillColor,
                "border-style": "solid",
                "position": "absolute",
                "border-color": (rectOptions.border.color) ? rectOptions.border.color : rectBorderColor,
                "border-width": (rectOptions.border.width || rectOptions.border.width==0) ? rectOptions.border.width : 1,
                "opacity": rectOptions.opacity,
				 'z-index': parentZindex + 1000000,
                'border-radius': ((rectOptions.rx) ? rectOptions.rx : rX).toString() + "px " + ((rectOptions.ry) ? rectOptions.ry : rY).toString() + "px",               
                "padding-left": '5px',
				 "padding-right": '5px',
                "padding-top": '2px',
                "padding-bottom": '2px'
            };
            $(tooltipdivRect).css(rectOptions);

            //event for tooltip text
            var commonTrackTextArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonTrackTextArgs.data = { seriesIndex: seriesIndex, pointIndex: pointIndex, currentText: trackTooltipText.text, isTrendLine: series.isTrendLine, trendlineIndex: series.trendlineIndex };
            this._trigger("toolTipInitialize", commonTrackTextArgs);
 	        if (!commonTrackTextArgs.cancel) {
            //draw tooltip text
            var fontSize = 0;
            var tooltip = series.tooltip;
            var font = (tooltip.font) ? $.extend(false, series.font, {}, tooltip.font) : series.font;
            
            // draw tooltip text styles
            var textOptions = {
                'top': y + $(document).scrollTop(),
                'left': x + $(document).scrollLeft(),
                "color": (tooltip.font && tooltip.font.color) ? font.color : textColor,
                'font-size': font.size,
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'font-weight': font.fontWeight,
                "align-self": "baseline"
            };
            $(tooltipdivRect).css(textOptions);

            // append the tooltip Div (condition for performance without remove div)
            if (document.getElementById(this.svgObject.id + "_TrackToolTip") == null)
                $(document.body).append(tooltipdivRect[0]);

            // Add string in text array for tooltip format
            var text = measureText = commonTrackTextArgs.data.currentText;
            $("#" + this.svgObject.id + "_TrackToolTip").html(text);

            // div size calculation perform here
            var textHeight = 0;
            var textWidth = 0;
            text = text.replace(/<br >/g, "<br/>")
                       .replace(/<br \/>/g, "<br/>")
                       .replace(/<br>/g, "<br/>");
            text = text.split("<br/>");
            for (var i = 0; i < text.length; i++) {
                text[i] = text[i];
                textHeight += ej.EjSvgRender.utils._measureText(text[i], null, font).height;
                var width = ej.EjSvgRender.utils._measureText(text[i], null, font).width;
                if (textWidth < width)
                    textWidth = width;
            }

            fontSize = (this.model.AreaType == "cartesianaxes") ? ej.EjSvgRender.utils._measureText(measureText, series.xAxis.width, font).height : ej.EjSvgRender.utils._measureText(text, null, font).height;
            var maxWidth = (this.model.AreaType == "cartesianaxes") ? (this.model.requireInvertedAxes) ? series.yAxis.width : series.xAxis.width : $(this.svgObject).width() - (this.model.legend.position.toLowerCase() == "right" ? (this.model.LegendViewerBounds.Width + 2 * this.model.elementSpacing) : 0);
            var maxHeight = (this.model.AreaType == "cartesianaxes") ? (this.model.requireInvertedAxes) ? series.xAxis.height : series.yAxis.height : $(this.svgObject).height() - (this.model.legend.position.toLowerCase() == "bottom" ? (this.model.LegendViewerBounds.Height + this.model.elementSpacing) : 0);

            //Adjust x-position to display tooltip within chart area 
            var box = $("#" + this.svgObject.id + "_TrackToolTip")[0].getBoundingClientRect();

            $("#" + this.svgObject.id + "_TrackToolTip").css("top", ($(document).scrollTop() + box.top + position.top - ((textHeight + 4) / 2)));
			$("#" + this.svgObject.id + "_TrackToolTip").css("left",($(document).scrollLeft() + box.left + position.left + (box.left - x))); 
            if ((x + (textWidth + padding)) >= maxWidth +  series.xAxis.x ) {
                var areaPos = document.getElementById(this.svgObject.id).getClientRects()[0];
                var diff = x - ((textWidth + padding * 2) + ((!series.isIndicator && !series.isTrendLine) ? ((ej.util.isNullOrUndefined(series._trackMarker)) ? ((series.marker.visible) ?
                series.marker.size.width : (type == "bubble" ? (point.radius + bubbleSpacing) : 0)) : series._trackMarker.size.width) : 0) + (2 * padding));
                $("#" + this.svgObject.id + "_TrackToolTip").css("left", diff + areaPos.left - (padding) + $(document).scrollLeft());
            }
            box = $("#" + this.svgObject.id + "_TrackToolTip")[0].getBoundingClientRect();
            if (box.bottom >= (series.yAxis.y + maxHeight + position.top) || box.bottom >= (series.xAxis.y + maxHeight + position.top)) {
                var diffY = y - (((box.bottom - box.top) + ((!series.isIndicator && !series.isTrendLine) ? ((ej.util.isNullOrUndefined(series._trackMarker)) ? ((series.marker.visible) ? series.marker.size.height : 0) : series._trackMarker.size.height) : 0))) + padding + position.top;
                $("#" + this.svgObject.id + "_TrackToolTip").css("top", diffY + $(document).scrollTop());
             }
            //adjust rectangle size based on text length  
            box = $("#" + this.svgObject.id + "_TrackToolTip")[0].getBoundingClientRect();
			if (box.left < 0) {
			// checked condition for whether left position display outsude of the chart area
                $("#" + this.svgObject.id + "_TrackToolTip").css("left", x);
            }
			if (box.top < position.top || box.top < 0)
			    $("#" + this.svgObject.id + "_TrackToolTip").css("top", (position.top < 0 ? $(document).scrollTop() : position.top) + 'px');
            $("#" + this.svgObject.id + "_TrackToolTip").show();
        }
        }
    },
	chartTooltipHover: function (evt) {
        var box = $("#" + evt.target.id)[0].getBoundingClientRect();
		var diff = evt.clientX - box.left;
		var padding = 5;
		$("#" + evt.target.id).css("left", box.left + diff + padding);
		box = $("#" + evt.target.id)[0].getBoundingClientRect();
		var areaPos = document.getElementById(this.svgObject.id).getClientRects()[0];
		if (box.right > areaPos.right + padding)
				$("#" + evt.target.id).css("left", evt.clientX - (box.right - box.left) - padding);
    },
    _initializeSeriesColors: function () {
        var chartObj = this;
        var modelColor = (chartObj.model.palette) ? chartObj.model.palette : chartObj.model.colors;
        var count = modelColor.length;
        var areaType = chartObj.model.AreaType;
        chartObj.model.seriesColors = [];
        chartObj.model.seriesBorderColors = [];
        chartObj.model.pointColors = [];
        chartObj.model.pointBorderColors = [];
        var elementCollection, color, borderColor, element, tlines,visibleSeriesLength =chartObj.model._visibleSeries.length,visibleSeries = chartObj.model._visibleSeries
        if (areaType != "none" ) {
            elementCollection = chartObj.model._visibleSeries;
            color = chartObj.model.seriesColors;
            borderColor = chartObj.model.seriesBorderColors;
        }
        else {
            var lgth = 0;
            var longest;
            for (var i = 0; i < visibleSeriesLength; i++) {
                var type = chartObj.model._visibleSeries[i].type.toLowerCase();
                if (chartObj.model._visibleSeries[i].points.length > lgth) {
                    var lgth = chartObj.model._visibleSeries[i].points.length;
                    longest = chartObj.model._visibleSeries[i].points;
                }
                else if (chartObj.model._visibleSeries[i].points.length == lgth && type != "funnel" && type != "pieofpie" && type != "pyramid")
                    longest = chartObj.model._visibleSeries[i].points;
				}
           elementCollection = longest;
            color = chartObj.model.pointColors;
            borderColor = chartObj.model.pointBorderColors;
        }
        if (areaType == "none" && visibleSeriesLength > 1)
        {
            for (var k = 0; k < visibleSeriesLength; k++)
            {
                chartObj.model.seriesColors[k] = modelColor[k % count];
            }
        }
        for (var i = 0; i < elementCollection.length; i++) {
            element = elementCollection[i];
            tlines = element.trendlines;
                element.isFill = (element.isFill == undefined) ? ((element.fill && element.fill != "") ? true : false) : element.isFill;
                if (element.isFill) {
                    color[i] = element.fill;
                } else {
                    color[i] = modelColor[i % count];
                    if (!element._hiloTypes)
                        element.fill = color[i];
                }
                if (areaType != "none" && tlines.length > 0)
                    this._initializeTrendlinesColors(tlines, color[i]);
                if (!ej.util.isNullOrUndefined(element.border) && !ej.util.isNullOrUndefined(element.border.color) && element.border.color != "") {
                    borderColor[i] = element.border.color;
                } else {
                    borderColor[i] = chartObj.model.seriesBorderDefaultColors[i % 10];
                    if (areaType != "none")
                        element.border.color = borderColor[i];
                }
                element.dataPoint = element.points;
            } 
    },

    _initializeTrendlinesColors: function(tlines, color) {
        for (var k in tlines) {
            if (ej.util.isNullOrUndefined(tlines[k].fill) || tlines[k].fill == "")
                tlines[k].fill = color;
        }
    },

    _createAxisLabelAndRange: function () {
        var count = 0,
            model = this.model,
            seriesCollection = model.series,
            seriesLength = seriesCollection.length,
            indicatorSeries,
            series,
            axisScroll,
            scrollRange,
            axis,
            primaryX = model.primaryXAxis,
            primaryY = model.primaryYAxis,
            axesLength;

        for (var i = 0; i < seriesLength; i++) {
            series = seriesCollection[i];
            if (series._isTransposed)
                count++;
        }

        if (seriesLength) {
            if (count == seriesLength)
                model.requireInvertedAxes = true;
            else {
                series = seriesCollection[0];
                if (series._isTransposed)
                    model.requireInvertedAxes = true;
            }
        }        
        if (model.requireInvertedAxes) {
            primaryY.orientation = "horizontal";
            primaryX.orientation = "vertical";
            primaryY.labelPlacement = (!(primaryY.labelPlacement)) ? ej.datavisualization.Chart.LabelPlacement.OnTicks : primaryY.labelPlacement;
        }
        else {
            primaryY.orientation = "vertical";
            primaryX.orientation = "horizontal";
        }
		 
        primaryY.name = ej.util.isNullOrUndefined(primaryY.name) ? "SecondaryAxis" : primaryY.name;
        primaryX.name = ej.util.isNullOrUndefined(primaryX.name) ? "PrimaryAxis" : primaryX.name;

        model._axes = [];
        model._axes[0] = primaryX;
        model._axes[1] = primaryY;
       
        axesLength = model.axes.length;
        indicatorSeries = model.indicators;

		for (var i = 0; i < axesLength; i++) {
            axis = model.axes[i];
			if (axis.name) {
			//Sets orientation for axes collections
            for (var j = 0; j < seriesLength; j++) {
                var type = seriesCollection[j].type.toLowerCase();
                if (seriesCollection[j].xAxisName == axis.name) {
                    axis.orientation = (type.indexOf("bar") != -1) ? seriesCollection[j].isTransposed ? "horizontal" : "vertical" : seriesCollection[j].isTransposed ? "vertical" : "horizontal";
                        break;
                    }
                else if (seriesCollection[j].yAxisName == axis.name) {
                    axis.orientation = (type.indexOf("bar") != -1) ? seriesCollection[j].isTransposed ? "vertical" : "horizontal" : seriesCollection[j].isTransposed ? "horizontal" : "vertical";
                            break;
                        }
                 }
				  for (var k = 0; k < indicatorSeries.length; k++) {
                    if (indicatorSeries[k].xAxisName == axis.name) {
                        axis.orientation ="horizontal";
                        break;
                    }
                    else if (indicatorSeries[k].yAxisName == axis.name) {
                        axis.orientation ="vertical";
                        break;
                    }
                 }
		    if (!axis.orientation) continue;
            if (axis.orientation.toLowerCase() == "horizontal")
                model.axes[i] = $.extend(true, {}, model.secondaryX, axis);
            else
                model.axes[i] = $.extend(true, {}, model.secondaryY, axis);
            model._axes.push(model.axes[i]);
		  }
        }
        for (var k = 0; k < model._axes.length; k++) {
             var axis = this.model._axes[k],
                axisScrollSetings = axis.scrollbarSettings,
                scrollRange = axisScrollSetings.range,
                orientation = axis.orientation.toLowerCase();
            axis.visibleLabels = [];
            axis.range = (axis.range.min == null && axis.range.max == null && axis.range.interval == null) ? null : axis.range;            
            axis.setRange = (!(axis.range)) ? false : (ej.util.isNullOrUndefined(axis.setRange)) ? true : axis.setRange;
            axis.setRange = ((axis.actual_Range) || (axis.setRange != false)) ? true : false;
            axis.actualRange = (!(axis.actualRange)) ? (axis.range == null) ? {} : $.extend(true, {}, axis.range) : axis.actualRange;
            axis.visibleRange = (!(axis.visibleRange)) ? (axis.range == null) ? {} : axis.range : axis.visibleRange;
            axis.name = !(axis.name) ? k.toString() : axis.name;
            axis._isScroll = ((axisScrollSetings.visible && (axisScrollSetings.pointsLength != null || scrollRange.min != null || scrollRange.max != null)) || ((model.zooming.enableScrollbar && axisScrollSetings.visible) && (axis.zoomFactor < 1 || axis.zoomPosition > 0)))
            axis._pointsLength = axisScrollSetings.pointsLength;
            if (typeof scrollRange.min == "string" && scrollRange.min.indexOf("/Date(") != -1)
                scrollRange.min = new Date(parseInt(scrollRange.min.substr(6)));
            if (typeof scrollRange.max == "string" && scrollRange.max.indexOf("/Date(") != -1)
                scrollRange.max = new Date(parseInt(scrollRange.max.substr(6)));
        }
    },






    _drawTitle: function () {
        var title = this.model.title;
        var margin = this.model.margin;
        var svgWidth = $(this.svgObject).width();
        var measureTitle = ej.EjSvgRender.utils._measureText(title.text, svgWidth - margin.left - margin.right, title.font);
        var elementSpacing = this.model.elementSpacing;
        var modelTitleHeight = (title.text == "" || !title.visible) ? 0 : (measureTitle.height + elementSpacing);
        var margin = margin;
        var areaBounds = this.model.m_AreaBounds;
        var areaType = this.model.AreaType;
        var legendSpace = (this.model.legend.position.toLowerCase() == "left") ? this.model.LegendViewerBounds.Width / 2 : ((this.model.legend.position.toLowerCase() == "right" ? (-this.model.LegendViewerBounds.Width / 2) : 0));
        // Drawing the chart title
        var leftSpace = margin.left + elementSpacing + this.model.border.width;
        var rightSpace = margin.right + elementSpacing + this.model.border.width;
        var collection = this.model.titleWrapTextCollection;

        var titleLocation, textBorderConstant = 1.2,
            titleFontSize = parseInt(title.font.size),
            titleTextHeight = parseInt(title.font.size) * textBorderConstant,
            enableTrim = title.enableTrim, textAnchor,
            maxTitleWidth = title.maximumWidth,
            textAlignment = title.textAlignment.toLowerCase(),
            textOverflow = title.textOverflow.toLowerCase(),
            titleText = title.text,
            titleEnable = enableTrim && (textOverflow == "wrap" || textOverflow == "wrapandtrim") && (collection.length > 1) ? true : false;
            if (maxTitleWidth.toString() == 'auto' || maxTitleWidth.toString() == '') {
                maxTitleWidth = (areaBounds.Width * 0.75);
                this.model.titleMaxWidth = maxTitleWidth;
              }
            else
                 maxTitleWidth = parseInt(maxTitleWidth);
       
        var titleWidthEnable = measureTitle.width > maxTitleWidth ? true : false;
        //title trim
        if (enableTrim && titleWidthEnable && textOverflow == "trim") {
            titleText = ej.EjSvgRender.utils._trimText(titleText, maxTitleWidth, title.font);
            this.model.titleTrim = measureTitle = ej.EjSvgRender.utils._measureText(titleText, svgWidth - margin.left - margin.right, title.font);
            this.model.trimTooltip = true;
        }

        if (this.model.trimTooltip && textOverflow == "wrap")
            this.model.trimTooltip = false;

        var textSize = { width: ((this.model.trimTooltip && titleEnable) || collection.length > 1) ? this.model.titleMaxWidth : measureTitle.width, height: (measureTitle.height * (collection.length > 0 ? collection.length - 1 : 1)) };
        if (title.text != "" && title.text != null) {
            if ((title.border.color == 'transparent') && (title.background == 'transparent')) {
                titleLocation = margin.top + (modelTitleHeight / 2) + (elementSpacing);
            } else {
                titleLocation = margin.top + (titleTextHeight / 2) + (elementSpacing) + (titleFontSize / 4);
            }
            var locX = ((areaType != "cartesianaxes") ? (svgWidth - margin.left - margin.right) / 2 + (margin.left + legendSpace) : (leftSpace + (svgWidth - rightSpace) / 2)) - textSize.width / 2;

            if (this.model.title.textAlignment.toLowerCase() == "near") {
                locX = leftSpace;
            }
            else if (this.model.title.textAlignment.toLowerCase() == "far") {
                locX = (svgWidth - rightSpace - textSize.width);
            }
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { title: titleText, location: { x: locX, y: titleLocation }, size: measureTitle };
            this._trigger("titleRendering", commonEventArgs);
            var options = {
                'id': this.svgObject.id + '_ChartTitleText',
                'x': commonEventArgs.data.location.x,
                'y': commonEventArgs.data.location.y,
                'fill': title.font.color,
                'font-size': title.font.size,
                'font-family': title.font.fontFamily,
                'font-style': title.font.fontStyle,
                'font-weight': title.font.fontWeight,
                'opacity': title.font.opacity,
                'text-anchor': 'start'
            };
            var borderOptions = {
                'id': this.svgObject.id + '_ChartTitleBorder',
                'x': commonEventArgs.data.location.x - elementSpacing,
                'y': commonEventArgs.data.location.y - titleTextHeight + (titleTextHeight / 4),
                'rx': title.border.cornerRadius,
                'ry': title.border.cornerRadius,
                'width': titleEnable && titleWidthEnable ? this.model.titleMaxWidth + (2 * elementSpacing) : measureTitle.width + (2 * elementSpacing),
                'height': titleEnable && titleWidthEnable ? measureTitle.height * collection.length : titleTextHeight,
                'fill': title.background,
                'stroke-width': title.border.width,
                'stroke': title.border.color,
                'opacity': title.border.opacity,
				'class': "e-titleborder"
            };
            this.svgRenderer.drawRect(borderOptions, this.gTitleEle);

            if (titleEnable && titleWidthEnable) {
                for (var k = 0; k < collection.length; k++) {
                    options.id = this.svgObject.id + '_ChartTitleText_' + k;
                    if (k != 0) options.y = options.y + measureTitle.height;
                    this.svgRenderer.drawText(options, collection[k], this.gTitleEle);
                }
            }
            else this.svgRenderer.drawText(options, commonEventArgs.data.title, this.gTitleEle);           

            this.model._titleLocation = { X: commonEventArgs.data.location.x, Y: commonEventArgs.data.location.y, size: textSize, _height: measureTitle.height };

            this.svgRenderer.append(this.gTitleEle, this.svgObject);
            if (title.subTitle.text != "" && title.subTitle.text && title.subTitle.visible)
                this._drawSubTitle();
        }
    },



    _getLegendSize: function (series) {

        var legend = this.model.legend,
            symbolSize = legend.itemStyle,
            textSize = ej.EjSvgRender.utils._measureText(series.Text, null, series.Font),
            padding = 10,
            width = symbolSize.width + padding + textSize.width,
            height = Math.max(symbolSize.height, textSize.height);

        return { Width: width, Height: height };

    },

    _getYValues: function (points) {
        var values = [],
			length = points.length;
        for (var i = 0; i < length; i++)
            values.push(points[i].y);
        return values;
    },
    _getXValues: function (points) {
         var values = [],
			length = points.length;
        for (var i = 0; i < length; i++)
            values.push(points[i].xValue);
        return values;
    },




    _drawSubTitle: function () {

        var title = this.model.title;
        var subTitle = title.subTitle;
        var svgWidth = $(this.svgObject).width();
        var measureTitle = ej.EjSvgRender.utils._measureText(title.text, svgWidth - this.model.margin.left - this.model.margin.right, title.font);
        var measuresubTitle = ej.EjSvgRender.utils._measureText(subTitle.text, svgWidth - this.model.margin.left - this.model.margin.right, subTitle.font);

        var textanchor = "middle";
        var subTitleLocation, textBorderConstant = 1.2, titleBorderSpacing = 10, subTitleBorderSpacing = 10, elementSpacing = this.model.elementSpacing,
           subTitleFontSize = parseInt(subTitle.font.size),
           areaBounds = this.model.m_AreaBounds.Width,
           titleTextHeight = parseInt(title.font.size) * textBorderConstant,
           subTitleTextHeight = parseInt(subTitle.font.size) * textBorderConstant,
           modelsubTitleHeight = (subTitle.text == "" || !subTitle.visible) ? 0 : (measuresubTitle.height + elementSpacing),
           enableTrim = subTitle.enableTrim,
           maxSubTitleWidth = subTitle.maximumWidth,
           maxTitleWidth = title.maximumWidth,
           textOverflow = subTitle.textOverflow.toLowerCase(),
           titleTextAlignment = title.textAlignment.toLowerCase(),
           subTitleTextAlignment = subTitle.textAlignment.toLowerCase(),
           titleText = title.text,
           titleEnableTrim = title.enableTrim,
           titleTextOverflow = title.textOverflow.toLowerCase(),
           subTitleText = subTitle.text, locX,
           regionX,
           titleVisibility = titleEnableTrim && (titleTextOverflow == "wrap" || titleTextOverflow == "wrapandtrim") ? true : false,
           titleWidthVisibility,
           subTitleVisibility = enableTrim && (textOverflow == 'wrap' || textOverflow == 'wrapandtrim') ? true : false;

        maxTitleWidth = (maxTitleWidth.toString() == 'auto' || maxTitleWidth.toString() == '') ? (areaBounds * 0.75) : parseInt(maxTitleWidth);
        maxSubTitleWidth = (maxSubTitleWidth.toString() == 'auto' || maxSubTitleWidth.toString() == '') ? (areaBounds * 0.75) : parseInt(maxSubTitleWidth);
        var measureTitle = ej.EjSvgRender.utils._measureText(title.text, svgWidth - this.model.margin.left - this.model.margin.right, title.font);
        var titleWidthEnable = measureTitle.width > maxTitleWidth ? true : false;

        //subtitle trim
        if (enableTrim && measuresubTitle.width > maxSubTitleWidth && textOverflow == "trim") {
            titleText = titleEnableTrim && titleTextOverflow == 'trim' ? ej.EjSvgRender.utils._trimText(titleText, maxTitleWidth, title.font) : titleText;
            subTitleText = ej.EjSvgRender.utils._trimText(subTitleText, maxSubTitleWidth, subTitle.font);
            measureTitle = ej.EjSvgRender.utils._measureText(titleText, $(this.svgObject).width() - this.model.margin.left - this.model.margin.right, title.font);
            measuresubTitle = ej.EjSvgRender.utils._measureText(subTitleText, $(this.svgObject).width() - this.model.margin.left - this.model.margin.right, subTitle.font);
            this.model.subTitleTooltip = true;
        }
        titleWidthVisibility = measureTitle.width > maxTitleWidth;
        // Drawing the chart subtitle

        if (subTitleText != "" && subTitleText != null) {
            if (((this.model.title.border.color == 'transparent') && (this.model.title.background == 'transparent')) || ((this.model.title.subTitle.border.color == 'transparent') && (this.model.title.subTitle.background == 'transparent'))) {
                subTitleLocation = (modelsubTitleHeight) / 2 + elementSpacing + this.model._titleLocation.Y + this.model._titleLocation._height * (this.model.titleWrapTextCollection ? (this.model.titleWrapTextCollection.length - 1) : 0 );
            } else {
                subTitleLocation = (subTitleTextHeight / 2) + subTitleBorderSpacing + elementSpacing + ((titleVisibility && titleWidthVisibility)?(measureTitle.height * this.model.titleWrapTextCollection.length) : titleTextHeight) + titleBorderSpacing + (subTitleFontSize / 3);
            }
            var locX = this.model._titleLocation.X + (this.model._titleLocation.size.width / 2);
           
            if (subTitleTextAlignment == "near") {                
                   locX = regionX= this.model._titleLocation.X;
                   textanchor = "start";
            }
            else if (subTitleTextAlignment == "far") {
                locX = this.model._titleLocation.X + this.model._titleLocation.size.width;
                textanchor = "end";
               
            }
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = { subTitle: subTitleText, location: { x: locX, y: subTitleLocation }, size: measuresubTitle };
            this._trigger("subTitleRendering", commonEventArgs);
            var subTitleYposition = (((title.border.color == 'transparent') && (title.background == 'transparent')) || ((title.subTitle.border.color == 'transparent') && (title.subTitle.background == 'transparent'))) ? commonEventArgs.data.location.y : commonEventArgs.data.location.y - (elementSpacing / 2);

            var options = {
                'id': this.svgObject.id + '_ChartSubTitleText',

                'x': commonEventArgs.data.location.x,
                'y': subTitleYposition,
                'fill': subTitle.font.color,
                'font-size': subTitle.font.size,
                'font-family': subTitle.font.fontFamily,
                'font-style': subTitle.font.fontStyle,
                'font-weight': subTitle.font.fontWeight,
				'opacity': subTitle.font.opacity,
                'text-anchor': textanchor
            };

            var x, y, subTitleXLocation = commonEventArgs.data.location.x;
            if (textanchor == "start") x = subTitleXLocation - elementSpacing;
            else if (textanchor == "end") 
                x = subTitleVisibility ? subTitleXLocation - elementSpacing - this.model.subTitleMaxWidth : subTitleXLocation - elementSpacing - (measuresubTitle.width);
            else 
                x = subTitleVisibility ? subTitleXLocation - elementSpacing - (this.model.subTitleMaxWidth / 2) : subTitleXLocation - elementSpacing - (measuresubTitle.width / 2);
            y = (((title.border.color == 'transparent') && (title.background == 'transparent')) || ((subTitle.border.color == 'transparent') && (subTitle.background == 'transparent'))) ? commonEventArgs.data.location.y - subTitleTextHeight + (subTitleTextHeight / 4)  : commonEventArgs.data.location.y - subTitleTextHeight + (subTitleTextHeight / 4) - (elementSpacing / 2);
            var borderOptions = {
                'id': this.svgObject.id + '_ChartSubTitleBorder',
                'x': x,
                'y': y,
                'rx': subTitle.border.cornerRadius,
                'ry': subTitle.border.cornerRadius,
                'width': subTitleVisibility ? this.model.subTitleMaxWidth + (2 * elementSpacing) : measuresubTitle.width + (2 * elementSpacing),
                'height': subTitleVisibility ? measuresubTitle.height * this.model.subTitleWrapTextCollection.length : subTitleTextHeight,
                'fill': subTitle.background,
                'stroke-width': subTitle.border.width,
                'stroke': subTitle.border.color,
                'opacity': subTitle.border.opacity,
				'class': "e-subtitleborder"
            };

            this.svgRenderer.drawRect(borderOptions, this.gSubTitleEle);
            
            if (subTitleVisibility && measuresubTitle.width > maxSubTitleWidth) {
                for (var k = 0; k < this.model.subTitleWrapTextCollection.length; k++) {
                    options.id = this.svgObject.id + '_ChartSubTitleText_' + k;
                    if (k != 0) options.y = options.y + measuresubTitle.height;
                    this.svgRenderer.drawText(options, this.model.subTitleWrapTextCollection[k], this.gSubTitleEle);
                }
                
            }
            else this.svgRenderer.drawText(options, commonEventArgs.data.subTitle, this.gSubTitleEle);          

            var subSize = { width: (this.model.subTitleTooltip) ? maxSubTitleWidth : measuresubTitle.width, height: (measuresubTitle.height * (this.model.subTitleWrapTextCollection.length)) };
            if (textanchor == "middle")
                regionX = locX - subSize.width / 2;
            else if (textanchor == "end")
                regionX = locX - subSize.width;
            this.model._subTitleLocation = { X: regionX, Y: (commonEventArgs.data.location.y - measuresubTitle.height/2), size: subSize };

            this.svgRenderer.append(this.gSubTitleEle, this.gTitleEle);
        }
    },


    _calculateStackingValues: function (seriesCollection, axis, params) {

        var chartModel = this.model;
        chartModel.stackedValue[axis.name] = [];
        var stackedValue = chartModel.stackedValue[axis.name];
        stackedValue.min = 0;
        stackedValue.max = 0;
        var stackAxes = (!chartModel.requireInvertedAxes) ? chartModel.hAxes : chartModel.vAxes,
            stackAxesLength = stackAxes.length,visiblePointsLength, yValues,stackingGroup,
            seriesLength = seriesCollection.length, visiblePoints,
            lastPosValue, lastNegValue, values, lastValue, currentValue,
            isNul = ej.util.isNullOrUndefined;

        for (var k = 0; k < stackAxesLength; k++) {
            j = 0;
            var lastPosValue = [], lastNegValue = [], firstPositive = [], firstNegative = [],
            crossing = 0;
            for (var i = 0; i < seriesCollection.length; i++) {
                if (seriesCollection[i]._xAxisName == stackAxes[k].name) {
                    if (seriesCollection[i].type.toLowerCase().indexOf("stacking") != -1 || seriesCollection[i].isStacking) {
                        values = {};
                        values.StartValues = [];
                        values.EndValues = [];
                        stackingGroup = seriesCollection[i].stackingGroup;
                        if (stackingGroup && seriesCollection[i].type.toLowerCase() != "stackingarea") {
                            if (isNul(lastPosValue[stackingGroup])) {
                                lastPosValue[stackingGroup] = [];
                                lastNegValue[stackingGroup] = [];
                                firstPositive[stackingGroup] = [];
                                firstNegative[stackingGroup] = [];
                            }
                        }

                        else {
                            stackingGroup = "";
                            if (isNul(lastPosValue[stackingGroup])) {
                                lastPosValue[stackingGroup] = [];
                                lastNegValue[stackingGroup] = [];
                                firstPositive[stackingGroup] = [];
                                firstNegative[stackingGroup] = [];
                            }
                        }
                        series = seriesCollection[i];
						crossing = this._getXCrossValue(series, stackAxes[k], params);
						if(typeof(crossing) !== 'number')
							crossing = 0;
                        visiblePoints = ej.EjSeriesRender.prototype._isVisiblePoints(series);
                        yValues = this._getYValues(series._visiblePoints);
                        visiblePointsLength = visiblePoints.length;
                        for (var j = 0; j < visiblePointsLength; j++) {
                            var lastValue = 0, correction=0, currentValue = yValues[j];
							if (isNul(lastPosValue[stackingGroup][series._visiblePoints[j].xValue])) {
                                lastPosValue[stackingGroup][series._visiblePoints[j].xValue] = crossing;
                            }
                            if (isNul(lastNegValue[stackingGroup][series._visiblePoints[j].xValue])) {
                                lastNegValue[stackingGroup][series._visiblePoints[j].xValue] = crossing;
                            }
                            if (values.StartValues.length <= j) {
                                values.StartValues.push(0);
                                values.EndValues.push(0);
                            }
                            if (currentValue >= 0) {
                                firstPositive[stackingGroup][j] = firstPositive[stackingGroup][j] == null;
                                currentValue -= firstPositive[stackingGroup][j] && crossing;
                                lastValue = lastPosValue[stackingGroup][series._visiblePoints[j].xValue];
                                lastPosValue[stackingGroup][series._visiblePoints[j].xValue] += currentValue;
                                correction = lastValue < crossing ? crossing - lastValue : 0;
                                values.StartValues[j] = lastValue + correction;
                                values.EndValues[j] = currentValue + lastValue;
                            }
                            else {
                                firstNegative[stackingGroup][j] = firstNegative[stackingGroup][j] == null;
                                currentValue -= firstNegative[stackingGroup][j] && crossing;
                                lastValue = lastNegValue[stackingGroup][series._visiblePoints[j].xValue];
                                lastNegValue[stackingGroup][series._visiblePoints[j].xValue] += currentValue;
                                values.StartValues[j] = lastValue;
                                values.EndValues[j] = currentValue + lastValue;
                                if (crossing < values.EndValues[j]) {
                                    lastNegValue[stackingGroup][series._visiblePoints[j].xValue] = values.StartValues[j];
                                    lastPosValue[stackingGroup][series._visiblePoints[j].xValue] = values.EndValues[j];
                                    firstPositive[stackingGroup][j] = firstPositive[stackingGroup][j] == null;
                                }
                            }
                            
                            visiblePointIndex = visiblePoints[j].actualIndex;
                            series.points[visiblePointIndex].YValues = [values.EndValues[j]];
                        }
                        values.stackedSeries = true;
                        stackedValue.push(values);
                        if (stackedValue.min > Math.min.apply(0, values.StartValues))
                            stackedValue.min = Math.min.apply(0, values.StartValues);
                        if (stackedValue.max < Math.max.apply(0, values.EndValues))
                            stackedValue.max = Math.max.apply(0, values.EndValues);
                        series.stackedValue = values;
                    }
                }
            }
        }
    },
    _calculateStackingCumulativeValues: function (seriesCollection, axis, params) {
        this.model.stackedValue[axis.name] = [];
        this.model.stackedValue[axis.name].min = 0;
        this.model.stackedValue[axis.name].max = 0;
        var stackAxes = (!this.model.requireInvertedAxes) ? this.model.hAxes : this.model.vAxes;
        var seriesLength = seriesCollection.length;
        var axesLength = stackAxes.length;
        var percent;
        for (var k = 0; k < axesLength ; k++) {
            var posValues = [], negValues = [], frequencies = [], stackingName = " ", firstPositive = [], firstNegative = [], crossing = 0, seriesGroupCount=[];

            //calculate the cumulative frequencies from the collection of series  
            for (var i = 0; i < seriesLength; i++) {
                var visiblePoints = ej.EjSeriesRender.prototype._isVisiblePoints(seriesCollection[i]);
                stackingName = seriesCollection[i].stackingGroup;
                if (seriesCollection[i].type.toLowerCase().indexOf("100") != -1) {
                    if (seriesCollection[i]._xAxisName == stackAxes[k].name) {
                        if (seriesCollection[i].stackingGroup && seriesCollection[i].type.toLowerCase() != " stackingarea100 ") {
                            if (!posValues[stackingName]) {
                                frequencies[stackingName] = [];
                                posValues[stackingName] = [];
                                negValues[stackingName] = [];
                                firstPositive[stackingName] = [];
                                firstNegative[stackingName] = [];
                            }
                        }
                        else {
                            seriesCollection[i].stackingGroup = "";
                            stackingName = seriesCollection[i].stackingGroup;
                            if (!posValues[stackingName]) {
                                frequencies[stackingName] = [];
                                posValues[stackingName] = [];
                                negValues[stackingName] = [];
                                firstPositive[stackingName] = [];
                                firstNegative[stackingName] = [];
                            }
                        }
                        seriesGroupCount[stackingName] = i;
                        var yValues = this._getYValues(seriesCollection[i]._visiblePoints);
                        var yValuesLength = yValues.length;
                        for (var j = 0; j < yValuesLength; j++) {
                            var getYValue = yValues[j];
                            if (!frequencies[stackingName][seriesCollection[i].points[j].xValue]) {
                                frequencies[stackingName][seriesCollection[i].points[j].xValue] = 0;
                            }
                            frequencies[stackingName][seriesCollection[i].points[j].xValue] += Math.abs(getYValue);
                        }
                    }
                }
              
            }

            //calculate the cumulative percentage for each series points
            for (var i = 0; i < seriesLength; i++) {
                stackingName = seriesCollection[i].stackingGroup;
                if (seriesCollection[i].type.toLowerCase().indexOf("100") != -1) {
                    var stackedSeries = false;
                    if (seriesCollection[i]._xAxisName == stackAxes[k].name) {
                        var values = {};
                        values.StartValues = [];
                        values.EndValues = [];
                        series = seriesCollection[i];
                        crossing = this._getXCrossValue(series, stackAxes[k], params);
						if(typeof(crossing) !== 'number')
							crossing = 0;
                        var yValues = this._getYValues(series._visiblePoints);
                        var yValuesLength = yValues.length;
                        for (var j = 0; j < yValuesLength; j++) {
                            var lastValue, correction = 0;
                            var currentValue = yValues[j];

                            //Pecentage calculation for point 
                            percent = (currentValue / frequencies[stackingName][series.points[j].xValue]) * 100
                            currentValue = !isNaN(percent) ? percent :0;
                            series.points[j].percentage = currentValue.toFixed(2);
                            if (!posValues[stackingName][series.points[j].xValue]) {
                                posValues[stackingName][series.points[j].xValue] = crossing;
                            }
                            if (!negValues[stackingName][series.points[j].xValue]) {
                                negValues[stackingName][series.points[j].xValue] = crossing;
                            }
                            if (values.StartValues.length <= j) {
                                values.StartValues.push(0);
                                values.EndValues.push(0);
                            }
                            if (currentValue >= 0) {
                                var posValue = posValues[stackingName][series.points[j].xValue];
                                firstPositive[stackingName][j] = firstPositive[stackingName][j] == null;
                                currentValue -= firstPositive[stackingName][j] && crossing;
                                correction = posValue < crossing ? crossing - posValue : 0;
                                lastValue = posValue;
                                posValues[stackingName][series.points[j].xValue] += currentValue;
                            }
                            else {
                                var negValue = negValues[stackingName][series.points[j].xValue];
                                firstNegative[stackingName][j] = firstNegative[stackingName][j] == null;
                                currentValue -= firstNegative[stackingName][j] && crossing;
                                correction = negValue > crossing ? crossing - negValue : 0;
                                lastValue = negValue;
                                negValues[stackingName][series.points[j].xValue] += currentValue;
                            }
                            values.StartValues[j] = lastValue + correction;
                            values.EndValues[j] = lastValue + currentValue;
                            if (values.EndValues[j] > 100) values.EndValues[j] = 100;
                            series.points[j].YValues = [values.EndValues[j]];
                            stackedSeries =  seriesGroupCount[stackingName] == i ? false || (stackedSeries): true;
                        }
                        values.stackedSeries = stackedSeries;
                        this.model.stackedValue[axis.name].push(values);
                        if (this.model.stackedValue[axis.name].min > Math.min.apply(0, values.StartValues))
                            this.model.stackedValue[axis.name].min = Math.min.apply(0, values.StartValues);
                        if (this.model.stackedValue[axis.name].max < Math.max.apply(0, values.EndValues))
                            this.model.stackedValue[axis.name].max = Math.max.apply(0, values.EndValues);
                        if (this.model.stackedValue[axis.name].min > Math.min.apply(0, values.EndValues))
                            this.model.stackedValue[axis.name].min = -100;

                        series.stackedValue = values;
                    }
                }
            }
        }
    },
    _legendItemBounds: function (itemCount, legendItemWidth, legendItemHeight) {
         var legend = this.model.legend, legVal,
            position = legend.position.toLowerCase(),
            itemPadding = legend.itemPadding,
            legnedHeightIncr, column, legendWidth = 0, legendHeight = 0;
        if (ej.util.isNullOrUndefined(legend.columnCount) && legend.rowCount) {
            legnedHeightIncr = legend.rowCount;
            column = Math.ceil(itemCount / legnedHeightIncr);
            legendWidth = legendItemWidth * column;
            legendHeight = legendItemHeight * legnedHeightIncr;
        }
        else if (ej.util.isNullOrUndefined(legend.rowCount) && legend.columnCount) {
            legnedHeightIncr = Math.ceil(itemCount / legend.columnCount);
            legVal = legend.columnCount;
            legendWidth = legendItemWidth * legVal;
            legendHeight = legendItemHeight * legnedHeightIncr;
        }
        else if ((legend.rowCount) && (legend.columnCount)) {
            if (legend.columnCount < legend.rowCount) {
                legnedHeightIncr = legend.rowCount;
                column = Math.ceil(itemCount / legnedHeightIncr);
                legendWidth = legendItemWidth * column;
                legendHeight = legendItemHeight * legnedHeightIncr;
            }
			else if(legend.columnCount > legend.rowCount){
                  if (position === 'top' || position === 'bottom' || position === 'custom') {
                    legnedHeightIncr = Math.ceil(itemCount / legend.columnCount);
                    legVal = legend.columnCount;
                    legendWidth = legendItemWidth * legVal;
                    legendHeight = legendItemHeight * legnedHeightIncr;
                } else {
                    legnedHeightIncr = Math.ceil(itemCount / legend.columnCount);
                    column = Math.ceil(itemCount / legnedHeightIncr);
                    legendWidth = legendItemWidth * column;
                    legendHeight = legendItemHeight * legnedHeightIncr;
                }
			 }
            else {
                if (position === 'top' || position === 'bottom' || position === 'custom') {
                    legnedHeightIncr = Math.ceil(itemCount / legend.columnCount);
                    legVal = Math.ceil(itemCount / legend.rowCount); 
                    legendWidth = legendItemWidth * legend.columnCount;
                    legendHeight = legendItemHeight *legVal;
                } else {
                    legnedHeightIncr = legend.rowCount;
                    column = Math.ceil(itemCount / legnedHeightIncr);
                    legendWidth = legendItemWidth * column;
                    legendHeight = legendItemHeight * legnedHeightIncr;
                }
                
            }
			
        }
        legendHeight += this.model.elementSpacing;
        return { LegendWidth: legendWidth, LegendHeight: legendHeight };
    },
	
	_isEjScroller: function () {
        var chart = this,
           chartModel = chart.model,
            legendContainer = $(chart.legendContainer),
            legend = chartModel.legend;
        if (ej.util.isNullOrUndefined($('#' + legendContainer[0].id).ejScroller)) 
            legend._ejScroller = false;
        else
            legend._ejScroller = legend.enableScrollbar;
    },

    //legend text wrapping
	_rowsCalculation: function (data, textmaxwidth, textOverflow)
    {
        var chart = this,
            chartModel = chart.model,
            legend = chartModel.legend,
            word, textCollection = [], currentWidth,nextWidth,
            text = data.legendItem ? data.legendItem.Text.toString() : data.text,
            legendTextCollection = text.split(' '),
            textMaxWidth=textmaxwidth,
            font = data.legendItem ? data.legendItem.LegendStyle.Font : data.font,
            legendTextLength = legendTextCollection.length,
            wordMax = 0;
      
        for (var i = 0; i < legendTextLength; i++) {
            word = legendTextCollection[i];
            currentWidth = ej.EjSvgRender.utils._measureText(word, null, font).width;
            if (currentWidth <= textMaxWidth) {
                while (i < legendTextLength) {
                    currentWidth = ej.EjSvgRender.utils._measureText(word, null, font).width;
                    nextWidth = (legendTextCollection[i + 1]) ? ej.EjSvgRender.utils._measureText(legendTextCollection[i + 1], null, font).width : 0;
                    if ((currentWidth + nextWidth) <= textMaxWidth && nextWidth>0) {
                        word = word.concat(' ' + legendTextCollection[i + 1]);
                        i++;
                    }
                    else {
                        wordMax = Math.max(wordMax, currentWidth);
                        break;
                    }
                }
                textCollection.push(word);
            }
            else{
                if (textOverflow == "wrapandtrim") {
                    word = ej.EjSvgRender.utils._trimText(word, textMaxWidth, font);
                    textCollection.push(word);
                    this.model._legendMaxWidth = textMaxWidth;
                    wordMax = Math.max(wordMax, textMaxWidth);
                    if (!data.legendItem) this.model.trimTooltip = true;
                }
                else {
                    textCollection.push(word);
                    if (data.legendItem)
                        this.model._legendMaxWidth = Math.max(this.model._legendMaxWidth, currentWidth);
                    else wordMax = Math.max(wordMax, currentWidth);
                }                
            }
        }        
        this.model._legendMaxHeight = Math.max(this.model._legendMaxHeight, textCollection.length);
        return { textCollection: textCollection, wordMax: wordMax };
    },

    _triggerLegendEvent:function(name,color,index)
    {
        var chart = this,
            chartModel = chart.model,
            legend = chartModel.legend,
			areaType = chartModel.AreaType,
            itemStyle = legend.itemStyle,
            border = itemStyle.border,
            elementSpacing = chartModel.elementSpacing,
            textMaxWidth = legend.textWidth,
            svgRender = ej.EjSvgRender,
            chartSvgRender = chart.svgRenderer,
            seriesLength = chartModel._visibleSeries.length,
            svgObject = chart.svgObject,
            elementSpacing = chartModel.elementSpacing,
            textOverflow = legend.textOverflow.toLowerCase(),
            legendItem, legendFont,textWidth,
            style= {
                BorderColor:border.color,
                BorderWidth: border.width,
                Opacity: legend.opacity,
                Color: color,
                Font: legend.font
            };
            
        commonEventArgs = $.extend({}, svgRender.commonChartEventArgs);
        commonEventArgs.data = {
            svgRenderer: chartSvgRender,
            svgObject: svgObject,
            symbolShape: legend.shape,
            legendItem: {
                Text: name,
                Shape: legend.shape,
                LegendStyle: style,
                SeriesIndex: (areaType == "none" && seriesLength == 1) ? 0 : index,
            },            
            style: {
                ShapeSize: itemStyle,
                ElementSpace: elementSpacing,
                Style: style,
                ID: chart.svgObject.id + '_LegendItemShape' + index,
                SeriesIndex: (areaType == "none" && seriesLength == 1) ? 0 : index,
                context: true
            },
            gLegendItemEle: chart.gLegendItemEle
       };
           
       chart._trigger("legendItemRendering", commonEventArgs);
       legendItem = commonEventArgs.data.legendItem.Text;
       legendFont = commonEventArgs.data.legendItem.LegendStyle.Font;
       textWidth = ej.EjSvgRender.utils._measureText(legendItem, null, legendFont).width;
       if (textOverflow == "trim") {
           if (textWidth > textMaxWidth) {
               legendItem = ej.EjSvgRender.utils._trimText(legendItem, textMaxWidth, legendFont);
               this.model._legendMaxWidth = textMaxWidth;
           }
       }
       else if (textOverflow == "wrap" || textOverflow == "wrapandtrim") {
           legendItem = this._rowsCalculation(commonEventArgs.data, textMaxWidth, this.model.legend.textOverflow.toLowerCase()).textCollection;
       }
       return { commonEventArgs: commonEventArgs, legendItem: legendItem };  
    },

    _calculateLegendBounds: function () {
        // intialize
        this.model.legendCollection = [];
        this.model.legendTextRegion = [];
        this.model.legendRegion = [];
        this.model.svgHeight = $(this.svgObject).height();
        this.model.svgWidth = $(this.svgObject).width();
        this.model._legendMaxWidth = 0;
        this.model._legendMaxHeight = 0;

        var chart = this,
            chartModel = chart.model,
            math = Math,
            max = math.max,
            min = math.min,
            abs = math.abs,
            legend = chartModel.legend,
            padding = 10,
            legendSizeHeight = legend.size.height,
            legendSizeWidth = legend.size.width,
            itemPadding = legend.itemPadding > 0 ? legend.itemPadding : 0,
            position = legend.position.toLowerCase(),
            width = 0, height = 0,
            svgHeight = chartModel.svgHeight,
            svgWidth = chartModel.svgWidth,
            legendItemWidth = 0,
            legendItemHeight = 0,
            legendWidth = 0,
            legendHeight = 0,
            legnedHeightIncr = 1,
            currentLegend,
            index,
            bounds,
            legendviewerHeight = 0, legendviewerWidth = 0,
            legendHeightTemp, legendWidthTemp,
            tempSeries = {},
            legendSeries = [], trendLineLength, trendLines,
            trendLine,
			trendlineType,
            areaType = chartModel.AreaType,
            visibleSeries = chartModel._visibleSeries,
            rowCount = legend.rowCount, point,
            columnCount = legend.columnCount,
            elementSpacing = chartModel.elementSpacing,
            visiblePoints, series,
            length, legendColor, legendName,legendStyleColor,
            titleSize = ej.EjSvgRender.utils._measureText(legend.title.text, null, legend.title.font),
            legendsize, colorGradName,
            vScrollSize = 0, hScrollSize = 0,
            borderSize = chartModel.border.width,
            legendBorder = legend.border.width,type,
            legendInfo, legendStyle, legendFont, shapeWidth,
            textOverflow = legend.textOverflow.toLowerCase(),
            svgObjectHeight = svgHeight - ((elementSpacing * 4) + (borderSize * 2) + (legend.border.width * 2)),
            svgObjectWidth = svgWidth - ((elementSpacing * 4) + (borderSize * 2) + (legendBorder * 2));

            if (visibleSeries && legend.visible && visibleSeries.length != 0) {  
            type = visibleSeries[0].type.toLowerCase();			
            if (areaType == "none" && visibleSeries.length == 1 || type == 'pieofpie' || type == 'pyramid' || type == 'funnel') {
                  
                series = visibleSeries[0];
                visiblePoints = ej.EjSeriesRender.prototype._calculateVisiblePoints(series).legendPoints;
                length = visiblePoints.length;
                for (var j = 0; j < length; j++) {
                    legendColor = legend.fill ? (!(legend.fill._gradientStop) ? legend.fill : legend.fill._gradientStop) : chartModel.pointColors[visiblePoints[j].actualIndex];
                    point = visiblePoints[j];
                    legendName = !ej.util.isNullOrUndefined(point.x) ? point.x : 'series' + j;
					visibleOnLegend = !(point.visibleOnLegend) ? 'visible' : point.visibleOnLegend;
                    if (!point.isEmpty && visibleOnLegend.toLowerCase() == 'visible' && series.visibleOnLegend.toLowerCase() == "visible") {
                        legendInfo=this._triggerLegendEvent(legendName, legendColor, j);
                        legendStyle = legendInfo.commonEventArgs.data.legendItem.LegendStyle;
                        tempSeries = {
                            Text: legendInfo.legendItem,
                            displayText: legendInfo.commonEventArgs.data.legendItem.Text,
                            Font: legendStyle.Font,
                            SeriesIndex: 0,
                            PointIndex: j,
                            ActualIndex:point.actualIndex,
                            fill: legendStyle.Color,
                            visibility: point.visible ? 'visible' : 'hidden',
                            Shape: legendInfo.commonEventArgs.data.legendItem.Shape,
                            LegendStyle: legendStyle,
                            CommonEventArgs: { cancel: legendInfo.commonEventArgs.cancel, data: legendInfo.commonEventArgs.data }
                        };
                        legendSeries.push(tempSeries);
                    }
                }
            }
            else {
                length = visibleSeries.length;
                for (var j = 0; j < length; j++) {
                    legendColor = legend.fill ? (!(legend.fill._gradientStop) ? legend.fill : legend.fill._gradientStop) : ej.util.isNullOrUndefined(chartModel.seriesColors[j]) ? chartModel.pointColors[j] : chartModel.seriesColors[j];
                    series = visibleSeries[j];
                    legendName = series.name ? series.name : 'series' + j;
					if (series.visibleOnLegend.toLowerCase() == "visible") { 
                    legendInfo=this._triggerLegendEvent(legendName, legendColor, j);
                    legendStyle = legendInfo.commonEventArgs.data.legendItem.LegendStyle;
                    tempSeries = {
                        Text: legendInfo.legendItem,
                        displayText: legendInfo.commonEventArgs.data.legendItem.Text,
                        Font: legendStyle.Font,
                        SeriesIndex: j,
                        fill: legendStyle.Color,
                        visibility: series.visibility,
                        Shape: legendInfo.commonEventArgs.data.legendItem.Shape,
                        LegendStyle: legendStyle,
                        CommonEventArgs: { cancel: legendInfo.commonEventArgs.cancel, data: legendInfo.commonEventArgs.data }
                    };
                    legendSeries.push(tempSeries);
					}
                    trendLines = series.trendlines;
                    trendLineLength = trendLines.length;
                    for (var i = 0; i < trendLineLength; i++) {
                        trendLine = trendLines[i];
                        legendColor = legend.fill ? (!(legend.fill._gradientStop) ? legend.fill : legend.fill._gradientStop) : trendLine.fill;
                        legendName = trendLine.name ? trendLine.name : 'series' + j;                                        
                        if (trendLine.visibility != '' && trendLine.visibleOnLegend.toLowerCase() == "visible") {
                            legendInfo = this._triggerLegendEvent(legendName, legendColor, j);
                            legendStyle = legendInfo.commonEventArgs.data.legendItem.LegendStyle;
                            tempSeries = {
                                Text: legendInfo.legendItem,
                                displayText: legendInfo.commonEventArgs.data.legendItem.Text,
                                Font: legendStyle.Font,
                                SeriesIndex: j,
                                trendLineIndex: i,
                                fill: legendStyle.Color,
                                isTrendLine: true,
                                visibility: series.visibility.toLowerCase() == "visible" ? trendLine.visibility : "hidden",
                                Shape: legendInfo.commonEventArgs.data.legendItem.Shape,
                                LegendStyle: legendStyle,
                                CommonEventArgs: { cancel: legendInfo.commonEventArgs.cancel, data: legendInfo.commonEventArgs.data }
                            };
                            legendSeries.push(tempSeries);
                        }
                    }
                }
            }
            
            legendSeriesLength = legendSeries.length;
            for (var j = 0; j < legendSeriesLength; j++) {
                currentLegend = legendSeries[j];
                shapeWidth = currentLegend.CommonEventArgs.data.style.ShapeSize.width;
                legendsize = chart._getLegendSize(currentLegend);
                legendItemWidth = max(this.model._legendMaxWidth > 0 ? (this.model._legendMaxWidth + itemPadding + shapeWidth) : legendsize.Width, legendItemWidth);
                legendItemHeight = max((textOverflow == "wrap" || textOverflow == "wrapandtrim") ? legendsize.Height * this.model._legendMaxHeight : legendsize.Height, legendItemHeight);
            }
            legendHeight = legendItemHeight + elementSpacing * 2;
            legendWidth = legendItemWidth;
           
            if (columnCount || rowCount) {
                legendBounds = chart._legendItemBounds(legendSeries.length, legendItemWidth + (itemPadding), legendItemHeight + (itemPadding));
                legendWidth = legendBounds.LegendWidth;
                legendHeight = legendBounds.LegendHeight;
                if (position === 'top' || position === 'bottom' || position === 'custom')
                    legendHeight = legendHeight - itemPadding + elementSpacing;
                else
                    legendWidth = legendWidth - itemPadding;
            }
            for (var k = 0; k < legendSeriesLength; k++) {
                currentLegend = legendSeries[k];
                index = currentLegend.SeriesIndex;
                series = chartModel.series[index];
                legendsize = chart._getLegendSize(currentLegend);
                if (textOverflow == "wrap"||textOverflow=="wrapandtrim") {
                    legendsize.Width = legendItemWidth;
                    legendsize.Height = legendItemHeight;
                }
                if (!(rowCount) && !(columnCount)) {
                    
                    if ((position == 'top' || position == 'bottom' || position == 'custom')) {
                        width += legendsize.Width + itemPadding;
                        if (width > svgObjectWidth && k !=0) {
                            width -= legendsize.Width + itemPadding;
                            legendWidth = max(legendWidth, width);
                            width = legendsize.Width + itemPadding;
                            legnedHeightIncr++;
                            legendHeight += legendItemHeight + itemPadding;
                        }
                        else
                            legendWidth = max(legendWidth, width);

                        height = max(height, legendItemHeight);
                    }
                    else {
                        height += legendsize.Height + itemPadding;
                        if (height > svgObjectHeight) {
                            height -= legendsize.Height + itemPadding;
                            legendHeight = max(legendHeight, height);
                            height = legendsize.Height + itemPadding;
                            legendWidth += legendItemWidth + itemPadding;
                        }
                        else
                            legendHeight = max(legendHeight, height);

                        width = max(width, legendItemWidth);
                    }
                }
                if (currentLegend.visibility.toLowerCase() == "visible")
                    colorGradName = chart.svgRenderer.createGradientElement('legend' + k, legendSeries[k].fill, 0, 0, 0, svgObjectHeight, chart.gLegendEle);
                else
                    colorGradName = 'gray';
                currentLegend.CommonEventArgs.data.legendItem.LegendStyle.Color = colorGradName;
                bounds = (rowCount || columnCount) ? { Width: legendItemWidth, Height: legendItemHeight } : legendsize;
				 bounds._Width = legendsize.Width;

                if (currentLegend.isTrendLine) {
                    currentLegend.TrendLineIndex = currentLegend.trendLineIndex;
					trendlineType = series.trendlines[currentLegend.trendLineIndex].type.toLowerCase();
                    currentLegend.CommonEventArgs.data.legendItem.drawType = currentLegend.drawType= trendlineType == 'linear' || trendlineType == "movingaverage" ? 'line' : 'spline';
                }
                legendSeries[k].Bounds = bounds;
                chartModel.legendCollection.push(currentLegend);
            }

            //LegendBounds calculation Perform here..
            if (position === 'top' || position === 'bottom' || position === 'custom') {
                legendWidth = titleSize.width > legendWidth - itemPadding ? (titleSize.width + padding * 2 + itemPadding) : legendWidth + padding * 2;
                width += padding ;
                height += padding * 2;
                chartModel.LegendBounds = { Width: max(legendWidth, width) - itemPadding, Height: max(legendHeight, height), Rows: legnedHeightIncr };
            }
            else {
                legendWidth = titleSize.width > legendWidth ? (titleSize.width + padding * 2) : legendWidth + padding * 2;
                width += padding;
                height += padding;
                chartModel.LegendBounds = { Width: max(legendWidth, width), Height: max(legendHeight, height) + padding - itemPadding, Columns: legnedHeightIncr };
            }
            //Calculating legend viewer bounds or calculate user specified legend bounds
            chartModel.LegendViewerBounds = { Width: "0", Height: "0" };

            if (legendSizeHeight == "" || legendSizeHeight == null) {
                if (position == 'left' || position == 'right' || position == 'custom')
                    legendHeightTemp = abs(svgHeight);
                else
                    legendHeightTemp = abs((svgHeight / 100) * parseInt('20%'));
                chartModel.LegendViewerBounds.Height = min(legendHeightTemp, chartModel.LegendBounds.Height);
            }
            else{
				if (legendSizeHeight.indexOf("%") != -1)
                    chartModel.LegendViewerBounds.Height = abs((svgHeight / 100) * parseInt(legendSizeHeight));
                else
                    chartModel.LegendViewerBounds.Height = parseInt(legendSizeHeight);
			}                

            if (legendSizeWidth == "" || legendSizeWidth == null) {
                if (position == 'top' || position == 'bottom' || position == 'custom')
                    legendWidthTemp = abs(svgWidth);
                else
                    legendWidthTemp = abs((svgWidth / 100) * parseInt('20%'));
                chartModel.LegendViewerBounds.Width = min(legendWidthTemp, chartModel.LegendBounds.Width);
            }
            else{
				 if (legendSizeWidth.indexOf("%") != -1)
                    chartModel.LegendViewerBounds.Width = abs((svgWidth / 100) * parseInt(legendSizeWidth));
                else
                    chartModel.LegendViewerBounds.Width = parseInt(legendSizeWidth);
			}                
        }
        else {
            chartModel.LegendBounds = { Width: 0, Height: 0 };
            chartModel.LegendViewerBounds = { Width: 0, Height: 0 };
        }
        legendContainer = $(chart.legendContainer);
        legendSvgContainer = $(chart.legendSvgContainer);
        if (legend.enableScrollbar) {
            chartModel.LegendActualBounds = chartModel.LegendViewerBounds;
            legendContainer.removeAttr("style");
            legendContainer.css({ "visibility":'hidden',"width": chartModel.LegendViewerBounds.Width, "height": chartModel.LegendViewerBounds.Height });
            legendSvgContainer.css({ "height": chartModel.LegendBounds.Height, "width": chartModel.LegendBounds.Width });
			
			if (legend._ejScroller)
                $('#' + legendContainer[0].id).ejScroller({width: chartModel.LegendViewerBounds.Width, height: chartModel.LegendViewerBounds.Height })
            else
                legendContainer.css({ "overflow": "scroll" });
			
            if (chartModel.LegendBounds.Width > chartModel.LegendViewerBounds.Width && chartModel.LegendBounds.Height > chartModel.LegendViewerBounds.Height) {
                if (legend._ejScroller) {
                    hScrollSize = $('.e-hscrollbar').height() || 0;
                    vScrollSize = $('.e-vscrollbar').width() || 0;
                } else {
                    legendContainer.css({ "overflow": "scroll" });
                    hScrollSize = legendContainer[0].offsetHeight - (legendBorder * 2) - legendContainer[0].clientHeight;
                    vScrollSize = legendContainer[0].offsetWidth - (legendBorder * 2) - legendContainer[0].clientWidth;
                }
            } else if (chartModel.LegendBounds.Width > chartModel.LegendViewerBounds.Width) {
				if (legend._ejScroller) {
                    hScrollSize = $('.e-hscrollbar').height() || 0;
                    vScrollSize = 0;
                }
                else {
                    legendContainer[0].style.overflowX = "scroll";
                    legendContainer[0].style.overflowY = "hidden";
                    hScrollSize = legendContainer[0].offsetHeight - (legendBorder * 2) - legendContainer[0].clientHeight;
                    vScrollSize = 0;
                }
            } else if (chartModel.LegendBounds.Height > chartModel.LegendViewerBounds.Height) {
				if (legend._ejScroller) {
                    hScrollSize = 0;
                    vScrollSize = $('.e-vscrollbar').width();
                }
                else {
                    legendContainer[0].style.overflowY = "scroll";
                    legendContainer[0].style.overflowX = "hidden";
                    hScrollSize = 0;
                    vScrollSize = legendContainer[0].offsetWidth - (legendBorder * 2) - legendContainer[0].clientWidth;
                } 
            }
            
        }
        else {
            chartModel.LegendActualBounds = chartModel.LegendBounds;
            if (legendSizeWidth != "" && legendSizeWidth != null)
                chartModel.LegendActualBounds.Width = parseInt(legendSizeWidth);
            if (legendSizeHeight != "" && legendSizeHeight != null)
                chartModel.LegendActualBounds.Height = parseInt(legendSizeHeight);
        }
        chartModel.LegendActualBounds.Height += Math.abs(hScrollSize);
        chartModel.LegendActualBounds.Width += Math.abs(vScrollSize);
        chartModel.LegendActualBounds.hScrollSize = hScrollSize;
        chartModel.LegendActualBounds.vScrollSize = vScrollSize;
    },

    GetPointXYOrgin: function (x, y, orginX, orginY) {

        var xvalue = ((x - orginX) / (this.model.axes.PrimaryXaxis.visibleRange.max - orginX)) * (this.model.m_AreaBounds.Width);
        var yvalue = ((y - orginY) / (this.model.axes.PrimaryYaxis.visibleRange.max - orginY)) * (this.model.m_AreaBounds.Height - this.GetPointXY(this.model.axes.PrimaryXaxis.visibleRange.min, Math.max(this.model.axes.PrimaryYaxis.visibleRange.min, 0)).Y);

        return { X: xvalue, Y: yvalue };
    },

    _wrap: function (axis, gap, labelText, textOverflow, font, textSize) {
        var text = labelText, textWidth = textSize.width, textCollection = [], unTrimmedText = [], textLength = text.length, 
		line = 0, i = 0, labelCollection = labelText.split(' '), labelCollectionLength = labelCollection.length;
        if (textOverflow == 'wrap') {
            if (textWidth > gap) {
                for (var w = 1; w <= text.length; w++) {
                    labelText = text.substring(0, w);
                    textWidth = ej.EjSvgRender.utils._measureText(labelText, null, font).width;
                    if (textWidth > gap) {
                        line = line + 1; // To find the no of rows splitted
                        labelText = text.substring(0, w - 1);
                        textCollection[i] = labelText;
                        text = text.slice(w - 1, textLength);
                        currentTextCollextion = text.split(' ');
                        text = labelCollection.indexOf(currentTextCollextion[0]) > -1 ? text : '-' + text;
                        var newTextWidth = ej.EjSvgRender.utils._measureText(labelText, null, font).width;
                        i++;
                        w = 0;
                    }
                }
            }
            textCollection[i] = labelText;
        }
        else if (textOverflow == "wrapandtrim") {
            var max = 0, word, currentWidth, nextWidth;
            for (var i = 0; i < labelCollectionLength; i++) {
                word = labelCollection[i];
                currentWidth = ej.EjSvgRender.utils._measureText(word, null, font).width;
                if (currentWidth < gap && textWidth > gap) {
                    while (i < labelCollectionLength) {
                        currentWidth = ej.EjSvgRender.utils._measureText(word, null, font).width;
                        nextWidth = (labelCollection[i + 1]) ? ej.EjSvgRender.utils._measureText(labelCollection[i + 1], null, font).width : 0;
                        if ((currentWidth + nextWidth) <= gap && nextWidth > 0) {
                            word = word.concat(' ' + labelCollection[i + 1]);
                            i++;
                        }
                        else {
                            // find the maximum width of the lines
                            max = Math.max(max, currentWidth);
                            break;
                        }
                    }
                    textCollection.push(word);
                }
                else {
                    if (textWidth > gap) {
                        unTrimmedText.push(word);
                        word = ej.EjSvgRender.utils._trimText(word, gap, font);
                        newTextWidth = ej.EjSvgRender.utils._measureText(word, null, font).width;
                        max = Math.max(max, newTextWidth)
                        textCollection.push(word);
                    } else {
                        textCollection.push(labelText);
                        break;
                    }
                }
            }
        }
        return {text: textCollection, unTrimmedText : unTrimmedText};
    },

    // to get the size of multi level labels
    getMultiLevelLabelSize: function (axis) {
		var value = 0;
        axis._multiLevelLabelHeight = 0;
       
            // declaration
            var grpLabelArr = [] ,multiLevelLabelHeight = [], prevHeight = [], grpLabelLength = axis.multiLevelLabels.length,
            range = axis.visibleRange, grpLabel, level, i, startX, endX, labelSize, gap, height, padding = 10, textCollection,
            orientation = axis.orientation.toLowerCase(), braceFlag = [];
			if (orientation == "vertical")
				axisValue = axis.length;
			else 
				axisValue = axis.width ? axis.width : (this.model.primaryYAxis.AxisMaxWidth ? axis.length - this.model.primaryYAxis.AxisMaxWidth: axis.length);
            for (i = 0; i < grpLabelLength; i++) {
                grpLabel = axis.multiLevelLabels[i] = grpLabelArr[i] = $.extend(true, {}, this.model.multiLevelLabelsDefault, axis.multiLevelLabels[i]);
				borderStyle = grpLabel.border.type.toLowerCase();
                level = grpLabel.level;
                if (grpLabel.visible && grpLabel.text != "" && !ej.util.isNullOrUndefined(grpLabel.start) && !ej.util.isNullOrUndefined(grpLabel.end)) {
                    startX = Math.ceil(ej.EjSvgRender.utils._getPointXY(grpLabel.start, range, axis.isInversed) * (axisValue));
                    endX = Math.ceil(ej.EjSvgRender.utils._getPointXY(grpLabel.end, range, axis.isInversed) * (axisValue));
                    labelSize = ej.EjSvgRender.utils._measureText(grpLabel.text, null, grpLabel.font);
                    textOverflow = grpLabel.textOverflow.toLowerCase();
                    gap = ej.util.isNullOrUndefined(grpLabel.maximumTextWidth) ? endX - startX : grpLabel.maximumTextWidth;
                    height = orientation == "vertical" ? (grpLabel.maximumTextWidth ? grpLabel.maximumTextWidth : labelSize.width): labelSize.height;
                    height += 2 * grpLabel.border.width;
                    if (labelSize.width > gap - padding && (textOverflow == "wrap" || textOverflow == "wrapandtrim")) {   // for wrap
                        textCollection = this._wrap(axis, gap - padding, grpLabel.text, textOverflow, grpLabel.font, labelSize);
                        textCollection = textCollection["text"];
                        height = orientation == "vertical" ? gap-padding : (height * (textCollection.length));
                    }
                    if (ej.util.isNullOrUndefined(multiLevelLabelHeight[level]))
                        multiLevelLabelHeight[level] = height;
                    else
                        multiLevelLabelHeight[level] = multiLevelLabelHeight[level] < height ? height : multiLevelLabelHeight[level];
                }
            }
            // to sort based on level
                grpLabelArr.sort(function (a, b) {
                    return parseFloat(a.level) - parseFloat(b.level);
                });
                axis.multiLevelLabels.sort(function (a, b) {
                    return parseFloat(a.level) - parseFloat(b.level);
                });
            // to modify the level
            for (var j = 0; j < grpLabelArr.length; j++){
                if (j == 0) {
                    axis.multiLevelLabels[j]._level = grpLabelArr[j]._level = 0;
                    greaterIndex = 0;
                }
                else if (grpLabelArr[j].level > greaterIndex + 1) {
                    axis.multiLevelLabels[j]._level = grpLabelArr[j]._level = greaterIndex + 1;
                    greaterIndex = grpLabelArr[j]._level;
                } 
                else {
                    axis.multiLevelLabels[j]._level = grpLabelArr[j]._level = grpLabelArr[j].level;
                    greaterIndex = grpLabelArr[j].level > greaterIndex ? grpLabelArr[j].level : greaterIndex;
                }
				if (borderStyle == "curlybrace")
					braceFlag[axis.multiLevelLabels[j]._level] =  true;
            }
            // to find the sum
            for (var i = 0; i < multiLevelLabelHeight.length ; i++) {
                prevHeight[i] = value;
                if (!ej.util.isNullOrUndefined(multiLevelLabelHeight[i])){
                    value = borderStyle == "brace" ? value + multiLevelLabelHeight[i] : value + multiLevelLabelHeight[i] + padding/2;
					if (braceFlag[i]) {
						value += padding;
						multiLevelLabelHeight[i]+= padding;
					}
				}
                else {
                    multiLevelLabelHeight.splice(i, 1);
                    i--;
                }
            }
            axis._multiLevelLabelHeight = value;
            axis.multiLevelLabelHeight = multiLevelLabelHeight;
            axis.prevHeight = prevHeight;
        
        return value;
    },
	
	_saturationColor: function (color, lum) {

	// validate hex string
	color = this.colorNameToHex(color);
	color = String(color).replace(/[^0-9a-f]/gi, '');
	if (color.length < 6) {
		color = color[0]+color[0]+color[1]+color[1]+color[2]+color[2];
	}
	lum = lum || 0;

	// convert to decimal and change luminosity
	var rgb = "#", c, i;
	for (i = 0; i < 3; i++) {
		c = parseInt(color.substr(i*2,2), 16);
		c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
		rgb += ("00"+c).substr(c.length);
	}

	return rgb;
},
	
    _drawChartAreaRect: function () {

        var fillColor = !(this.model.background && this.model.background._gradientStop) ? this.model.background : 'url(#' + this.svgObject.id + '_backGradient)';

        if (this.model.backGroundImageUrl)
            fillColor = 'transparent';
        
        var chartBorder = this.model.border;
        var options = {
            'id': this.svgObject.id + '_SvgRect',
            'x': chartBorder.width / 2,
            'y': chartBorder.width / 2,
            'width': $(this.svgObject).width() - (2 * chartBorder.width),
            'height': $(this.svgObject).height() - (2 * chartBorder.width),
            'fill': fillColor,
            'opacity': chartBorder.opacity,
            'stroke-width': chartBorder.width,
            'stroke': chartBorder.color,
			'class': "e-chartborder"
        };
        this.svgRenderer.drawRect(options, this.svgObject);
        


        if (this.model.backGroundImageUrl)
            this._drawBackImage();

        if (this.model.AreaType == 'cartesianaxes' && !this.model.enable3D) {
            var borderOptions = {
                'id': this.svgObject.id + '_ChartArea',
                'x': this.model.m_AreaBounds.X,
                'y': this.model.m_AreaBounds.Y,
                'width': this.model.m_AreaBounds.Width,
                'height': this.model.m_AreaBounds.Height,
                'fill': this.model.chartArea.background,
                'stroke-width': this.model.chartArea.border.width,
                'opacity': this.model.chartArea.border.opacity,
                'stroke': this.model.chartArea.border.color,
				'class': "e-chartareaborder"
            };
            this.svgRenderer.drawRect(borderOptions, this.svgObject);


        }

    },
    axesIndexCount: function (axis,index) {
        var vRowcount = [];
        for (var k = 0; k < axis.length; k++) {
            var currentAxis = axis[k];
            if (currentAxis.orientation.toLowerCase() == "vertical") {
                if (currentAxis.rowIndex == index)
                    vRowcount.push(currentAxis);
            }
            else {
                if (currentAxis.columnIndex == index)
                    vRowcount.push(currentAxis);
            }
        }
        return vRowcount ;
    },
    axesCount: function (axis) {
        var vRowcount = [], indexValue=[], definitionsLength=0;
        var chartModel = this.model;
        $.each(axis, function (index, currentAxis) {
            if (currentAxis.orientation.toLowerCase() == "vertical") {
                definitionsLength =(chartModel.rowDefinitions)?chartModel.rowDefinitions.length:0;
                if (index == 0) vRowcount.push({ axis: currentAxis, index: currentAxis.rowIndex });
                else if (currentAxis.rowIndex != vRowcount[vRowcount.length - 1].axis.rowIndex)
                    vRowcount.push({ axis: currentAxis, index: currentAxis.rowIndex});
            }
            else {
                definitionsLength =(chartModel.columnDefinitions)? chartModel.columnDefinitions.length:0;
                if (index == 0) vRowcount.push({ axis: currentAxis, index: currentAxis.columnIndex });
                else if (currentAxis.columnIndex != vRowcount[vRowcount.length - 1].axis.columnIndex)
                    vRowcount.push({ axis: currentAxis, index: currentAxis.columnIndex });
            }
        });
        var length = vRowcount.length;
        if (definitionsLength > length) {
            length = definitionsLength;
            for (var l = 0; l < definitionsLength; l++)
                indexValue.push(l);
        } else {
            for (var i = 0; i < length; i++)
                indexValue.push(vRowcount[i].index);
        }
        
        return { length: length, indexValue: indexValue };

    },
   
     //Calculate position for each vertical axis
    _calRowSize: function () {
        var start = 0;
        var yaxisOrign = [];
        var totalRealLength = 0;
        var orginY = this.model.m_AreaBounds.Y + this.model.m_AreaBounds.Height;
        //Caluculate size for rowdefinitions values
        if (this.model._rowDefinitions[0].rowDefinitions != null) {
            for (var i = 0, rowMax = this.model._rowDefinitions.length; i < rowMax; i++) {
                var rowDef = this.model._rowDefinitions[i].rowDefinitions;
                rowDef.rowHeight = Math.abs(rowDef.rowHeight);
                var realLength = 0;
                if (rowDef.unit.toLowerCase() == "percentage"){
                    var length = this._axisRowDefinitionSize(this.model.rowDefinitions);
                    realLength = Math.floor((this.model.m_AreaBounds.Height) * (rowDef.rowHeight / length));
                }  
                else
                    realLength = rowDef.rowHeight;
                if (i == 0) yaxisOrign.push(orginY);
                   
                      yaxisOrign.push( (orginY - realLength - totalRealLength ));
                    totalRealLength += realLength;
                

            }
            
        }
        //Calculate size based on chart area size
        else {
            var height = Math.floor((this.model.m_AreaBounds.Height) / this.model._rowDefinitions.length);

            for (start = (orginY) ; start >= this.model.m_AreaBounds.Y; start = start - height) {
                yaxisOrign.push(start);
            }
        }
        return yaxisOrign;
    },
    
     //Calculate position for each horizontal axis
    _calColumnSize: function () {
        var xaxisOrign = [];
        var orginX = this.model.m_AreaBounds.X;
        var areaWidth = this.model.m_AreaBounds.Width;
        var totalRealLength = 0;
        var columnDef = this.model._columnDefinitions;
        //Caluculate size for columndefinitions values
        if (columnDef[0].columnDefinitions != null) {
            for (var i = 0, max = columnDef.length; i < max; i++) {
                var rowDef = columnDef[i].columnDefinitions;
				rowDef.columnWidth = Math.abs(rowDef.columnWidth);
                var realLength;
                if (rowDef.unit.toLowerCase() == "percentage"){
				    var length = this._axisColumnDefinitionSize(this.model.columnDefinitions);
				    realLength = Math.floor((areaWidth) * (rowDef.columnWidth / length));
                } 
                else
                    realLength = rowDef.columnWidth;
                if (i == 0) xaxisOrign.push(orginX);

                xaxisOrign.push((orginX + realLength + totalRealLength));
                totalRealLength += realLength;
            }
        }
        //Caluculate size based on chart area size
        else {
            var width = Math.floor((areaWidth) / columnDef.length);
            for (var start = orginX, maxStart = orginX + areaWidth; start <= maxStart; start = start + width) {
                xaxisOrign.push(start);

            }
        }
        return xaxisOrign;
    },
    
     //Calculate position and size for each axis
    _calculateAxisSize: function (params) {

        //For Horizontal
        var isInitAxes = true, isOppInitAxes = true;
        var xaxisOrign = this._calColumnSize();
        var columnDefinition = this.model._columnDefinitions;		
        for (var i = 0, maxLength = columnDefinition.length; i < maxLength; i++) {
            var x1 = xaxisOrign[i];
            var x2 = xaxisOrign[i + 1];
            var nearIndexVal = 0;
            var farIndexVal = 0;;
            var isColFirstAxes = true, isColOppFirstAxes = true;
            var oppY = this.model.m_AreaBounds.Y;
            var norY = oppY + this.model.m_AreaBounds.Height;
            for (var j = 0, maxCol = columnDefinition[i].axis.length; j < maxCol; j++) {
                var currentColAxis = columnDefinition[i].axis[j];
                var realY = 0, axisColumnSpace = 0;
                var opposedPosition = currentColAxis._opposed;
                if (!params.axes[currentColAxis.name]._validCross) {
                    if (!opposedPosition) {
                        if (!(isColFirstAxes && (isInitAxes || nearIndexVal == 0))) {
                            axisColumnSpace = columnDefinition.nearSizes[nearIndexVal];
                            realY = norY = (norY + axisColumnSpace);
                            nearIndexVal++;
                        }
                        else {
                            realY = norY;
                            isColFirstAxes = false;
                        }

                    } else {
                        if (!(isColOppFirstAxes && (isOppInitAxes || farIndexVal == 0))) {
                            axisColumnSpace = columnDefinition.farSizes[farIndexVal];
                            realY = oppY = (oppY - axisColumnSpace);
                            farIndexVal++;
                        }
                        else {
                            realY = oppY;
                            isColOppFirstAxes = false;
                        }
                    }
                }
                if (currentColAxis.columnSpan) {
                    //Skip the axis size calculation for duplicate span axis
                    if (!(columnDefinition[i].index == currentColAxis.columnIndex))
                        continue;
                    var axisSize = (maxLength >= (i + currentColAxis.columnSpan)) ? i + currentColAxis.columnSpan : i+1;
                    x2 = xaxisOrign[axisSize];
                    if (!opposedPosition && nearIndexVal==0)isInitAxes = isColFirstAxes;
                    if (opposedPosition && farIndexVal == 0) isOppInitAxes = isColOppFirstAxes;
                } else {
                    x2 = xaxisOrign[i + 1];
                    isInitAxes = true;
                    isOppInitAxes = true;
                }
                
               currentColAxis.Location = { };
                currentColAxis.Location.X1 = x1 + currentColAxis.plotOffset;
                currentColAxis.Location.Y1 = realY;
                currentColAxis.Location.X2 = x2 - currentColAxis.plotOffset;
                currentColAxis.Location.Y2 = realY;
                currentColAxis.x = currentColAxis.Location.X1;
                currentColAxis.y = currentColAxis.Location.Y1;
                currentColAxis.width = (currentColAxis.Location.X2 - currentColAxis.Location.X1);
                currentColAxis.height = currentColAxis.Location.Y2 - currentColAxis.Location.Y1;

            }
        }
        
        //For Vertical
        isInitAxes = true, isOppInitAxes = true;
        var yaxisOrign = this._calRowSize();
        var rowDefinition = this.model._rowDefinitions;
        for (var i = 0, rowLength = rowDefinition.length; i < rowLength; i++) {
            var y1 = yaxisOrign[i];
            var y2 = yaxisOrign[i + 1];
            var nearIndex = 0;
            var farIndex = 0;
            var isFirstAxes = true, isOppFirstAxes = true;
           var x = this.model.m_AreaBounds.X;
           var norX = x, oppX = x + this.model.m_AreaBounds.Width;
           for (var j = 0, maxRow = rowDefinition[i].axis.length; j < maxRow; j++) {
                var axisSpace = 0;
                var realX = 0;
               
                var currentAxis = rowDefinition[i].axis[j];
                var opposedPosition = currentAxis._opposed;
                if (!params.axes[currentAxis.name]._validCross) {
                    if (!opposedPosition) {
                        if (!(isFirstAxes && (isInitAxes || nearIndex == 0))) {
                            axisSpace = rowDefinition.nearSizes[nearIndex];
                            realX = norX = (norX - axisSpace);
                            nearIndex++;
                        } else {
                            realX = x;
                            isFirstAxes = false;
                        }

                    } else {
                        if (!(isOppFirstAxes && (isOppInitAxes || isOppInitAxes == 0))) {
                            axisSpace = rowDefinition.farSizes[farIndex];
                            realX = oppX = (oppX + axisSpace);
                            farIndex++;
                        } else {
                            realX = oppX;
                            isOppFirstAxes = false;
                        }
                    }
                }
                if (currentAxis.rowSpan) {
                    //Skip the axis size calculation for duplicate span axis
                    if (!(rowDefinition[i].index == currentAxis.rowIndex))
                        continue;
                    var axisRowSize = (rowLength >= (i + currentAxis.rowSpan)) ? i + currentAxis.rowSpan : i + 1;
                    y2 = yaxisOrign[axisRowSize];
                    if (!opposedPosition && nearIndex==0) isInitAxes = isFirstAxes;
                    if (opposedPosition && farIndex==0) isOppInitAxes = isOppFirstAxes;
                } else {
                    y2 = yaxisOrign[i + 1];
                    isInitAxes = true;
                    isOppInitAxes = true;
                }
                currentAxis.Location = { };
                currentAxis.Location.X1 = realX;
                currentAxis.Location.Y1 = y1 - currentAxis.plotOffset;
                currentAxis.Location.X2 = realX;
                currentAxis.Location.Y2 = y2 + currentAxis.plotOffset;
                currentAxis.x = currentAxis.Location.X1;
                currentAxis.y = currentAxis.Location.Y2;
                currentAxis.height = (currentAxis.Location.Y1 - currentAxis.Location.Y2);
                currentAxis.width = currentAxis.axisLine.width;

            }
        }
    },

     //Validates whether provided crossing value is valid or not
    _validateCrossing: function (axis) {
        axis._opposedPosition = false;
        if (axis.crossesAt != null) {
            var crossAxis = this._getCrossAxis(this.model._axes, axis.orientation.toLowerCase() == 'horizontal', axis.crossesInAxis);
            axis._crossValue = this._getCrossValue(axis, crossAxis, crossAxis._valueType);
            if ((crossAxis.isInversed ? !axis.opposedPosition : axis.opposedPosition) ? axis._crossValue <= crossAxis.visibleRange.min : axis._crossValue >= crossAxis.visibleRange.max)
                axis._opposedPosition = true;
            return (crossAxis.visibleRange.min < axis._crossValue && crossAxis.visibleRange.max > axis._crossValue);
        }
        return false;
    },

     //Method to place axis at crossed location
    _axisCrossing: function (axis, locateAxis, params) {
        var hor = axis.orientation.toLowerCase() == 'horizontal';
        var crossAxis = this._getCrossAxis(this.model._axes, hor, axis.crossesInAxis);
        var crossValue = axis._crossValue;
        var delta = Math.abs((crossAxis.isInversed ? crossAxis.visibleRange.max : crossAxis.visibleRange.min) - crossValue);
        this._locateAxis(axis, crossAxis, hor, delta);
        if (!locateAxis)
            params._crossAxisOverlap = this._avoidOverlapping(axis, this.model.m_AreaBounds, hor, axis.opposedPosition, params) || params._crossAxisOverlap;
    },

    _locateAxis: function (axis, crossAxis, hor, delta) {
        var loc = (hor ? crossAxis.height : crossAxis.width) * delta / crossAxis.visibleRange.delta;
        if (hor)
            axis.y = crossAxis.y + crossAxis.height - loc;
        else
            axis.x = crossAxis.x + loc;
    },

    _avoidOverlapping: function (axis, bounds, hor, opposed, params) {
        var diff = 0;
		var axisbounds = axis.showNextToAxisLine ?params.axes[axis.name]._bounds: 0;
        if (hor) {
            if (!opposed && axis.y + axisbounds > bounds.Y + bounds.Height) {
                bounds.Height -= diff = axis.y + axisbounds - bounds.Y - bounds.Height;
                this._recalculateSpace(axis, hor, opposed, diff);
                return true;
            }
            else if (opposed && axis.y - axisbounds < bounds.Y) {
                bounds.Y += diff = axisbounds - (axis.y - bounds.Y);
                bounds.Height -= diff;
                this._recalculateSpace(axis, hor, opposed, diff);
                return true;
            }
        }
        else {
            if (!opposed && axis.x - axisbounds < bounds.X) {
                bounds.X += diff = axisbounds - (axis.x - bounds.X);
                bounds.Width -= diff;
                this._recalculateSpace(axis, hor, opposed, diff);
                return true;
            }
            else if (opposed && axis.x + axisbounds > bounds.X + bounds.Width) {
                bounds.Width -= diff = axis.x + axisbounds - bounds.X - bounds.Width;
                this._recalculateSpace(axis, hor, opposed, diff);
                return true;
            }
            else if (axis.labelPosition == "inside" && axis.x + axisbounds > bounds.X + bounds.Width)
            {
                bounds.Width -= diff = axis.x + axisbounds - bounds.X - bounds.Width;
                this._recalculateSpace(axis, hor, opposed, diff, axis.showNextToAxisLine);
                return true;
            }
        }
    },

    _recalculateSpace: function (axis, isHor, opposed, diff,isCrossing) {
        if (isHor) {
            var def = this.model._rowDefinitions;
            var index = opposed ? def.length - 1 : 0;
            for (var i = 0, len = def[index].axis.length; i < len; i++) {
                def[index].axis[i].height -= diff;
                def[index].axis[i].Location.Y2 -= diff;
                if (opposed)
                    def[index].axis[i].Location.Y1 = def[index].axis[i].y += diff;
            }
            var colIndex = axis.columnIndex;
            def = this.model._columnDefinitions
            for (var i = 0, len = def.length; i < len; i++)
                if (i !== colIndex)
                    for (var j = 0, length = def[i].axis.length; j < length; j++)
                        if (def[i].axis[j]._opposed === opposed)
                            def[i].axis[j].Location.Y1 = def[i].axis[j].Location.Y2 = def[i].axis[j].y += (opposed ? 1 : -1) * diff;
        }
        else {
            var def = this.model._columnDefinitions;
            var index = opposed ? def.length - 1 : 0;
            for (var i = 0, len = def[index].axis.length; i < len; i++) {
                def[index].axis[i].width -= diff;
                if (!isCrossing) {
                    if (opposed)
                        def[index].axis[i].Location.X2 -= diff;
                    else
                        def[index].axis[i].Location.X1 = def[index].axis[i].x += diff;
                }

            }
            var rowIndex = axis.rowIndex;
            def = this.model._rowDefinitions
            for (var i = 0, len = def.length; i < len; i++)
                if (i !== rowIndex)
                    for (var j = 0, length = def[i].axis.length; j < length; j++)
                        if (def[i].axis[j]._opposed === opposed)
                            def[i].axis[j].Location.X1 = def[i].axis[j].Location.X2 = def[i].axis[j].x += (opposed ? -1 : 1) * diff;
        }
    },

    _getCrossValue: function (axis, crossAxis, type) {
        switch (type.toLowerCase()) {
            case 'category':
                return crossAxis.labels.indexOf(axis.crossesAt) != -1 ? crossAxis.labels.indexOf(axis.crossesAt) : axis.crossesAt;
            case 'datetime':
                return isNaN(Date.parse(axis.crossesAt)) ? null : Date.parse(axis.crossesAt);
            case 'logarithmic':
                return Math.log(axis.crossesAt) / Math.log(crossAxis.logBase);
        }
        return axis.crossesAt;
    },

    _getXCrossValue: function (series, axis, params) {
        var crossesInAxis = axis.crossesInAxis, yAxisName = series._yAxisName, validCross = params.axes[axis.name]._validCross || params.axes[axis.name]._validCross == null;
        //Checks whether origin should be changed for current series or not.
        return validCross && axis.crossesAt && ((!crossesInAxis && yAxisName === this.model.primaryYAxis.name) || (crossesInAxis && this._getCrossAxis(this.model._axes, true, crossesInAxis).name === yAxisName)) ? axis.crossesAt : 0;
    },

    _getAxisByName: function (axes, hor, name) {
        if (name) {
            for (var i = 0, count = axes.length; i < count; i++)
                if (axes[i].name === name && (hor ? axes[i].orientation=='vertical' : axes[i].orientation=='horizontal'))
                    return axes[i];
        }
    },

    _getCrossAxis: function (axes, hor, value) {
        return this._getAxisByName(axes, hor, value) || (this.model.requireInvertedAxes ? hor ? this.model.primaryXAxis : this.model.primaryYAxis : hor ? this.model.primaryYAxis : this.model.primaryXAxis);
    },

    _arrangeAxis: function () {
        var chartobj = this;
        var axis;
        var customRow;
        //Generate columnIndex/RowIndex value if it is not specify in sample  
        for (var i = 0; i < this.model._axes.length; i++) {
            axis = this.model._axes[i];
            if (axis.orientation.toLowerCase() == "horizontal") {
                chartobj.model.hAxes.push(axis);
                axis.columnIndex = (ej.util.isNullOrUndefined(axis.columnIndex)) ? 0 : (axis.columnIndex);
                chartobj.model.hAxes[chartobj.model.hAxes.length - 1].columnIndex = axis.columnIndex;
            } else if (axis.orientation.toLowerCase() == "vertical") {

                chartobj.model.vAxes.push(axis);
                axis.rowIndex = (ej.util.isNullOrUndefined(axis.rowIndex)) ? 0 : (axis.rowIndex);
                chartobj.model.vAxes[chartobj.model.vAxes.length - 1].rowIndex = axis.rowIndex;
                customRow = (!ej.util.isNullOrUndefined(chartobj.model.rowDefinitions)) ? chartobj.model.rowDefinitions[axis.rowIndex] : null;
                if (customRow) {
                    axis.axisBottomLine = {};
                    axis.axisBottomLine.visible = true;
                    axis.axisBottomLine.lineWidth = customRow.lineWidth;
                    axis.axisBottomLine.color = customRow.lineColor;
                }
            }
        }

        this.model.hAxes = ej.DataManager(this.model.hAxes, ej.Query().sortBy("columnIndex")).executeLocal();

        this.model.vAxes = ej.DataManager(this.model.vAxes, ej.Query().sortBy("rowIndex")).executeLocal();
        
        //column axis information push into _rowDefinitions
        var rowCount = this.axesCount(chartobj.model.vAxes);
         chartobj.model._rowDefinitions = [];
        if (chartobj.model.vAxes.length>0) {
            for (var j = 0; j < rowCount.length; j++) {
                var rowCollection = chartobj.model.rowDefinitions;
                var rowDefinitions = ((rowCollection)) ? (rowCollection[j] ? rowCollection[j] : rowCollection[0]) : null;
                chartobj.model._rowDefinitions.push({axis: this.axesIndexCount(chartobj.model.vAxes, rowCount.indexValue[j])
                                , index: rowCount.indexValue[j], rowDefinitions: rowDefinitions });
            }
        }

        var rowDefinition = chartobj.model._rowDefinitions;
        //Using filter to get spanning row axis collection
        var spanningRow = this._axisFilter(rowDefinition, "rowSpan");
        //Arrange the entire axis for row span
        this._SpanningAxes(rowDefinition, spanningRow, true);

        //column axis information push into _columnDefinitions
        var columnCount = this.axesCount(chartobj.model.hAxes);
        chartobj.model._columnDefinitions = [];
        if (chartobj.model.hAxes.length > 0) {
            for (var k = 0; k < columnCount.length; k++) {
                var columnCollection = chartobj.model.columnDefinitions;
                var columnDefinitions = (columnCollection) ? (columnCollection[k] ? columnCollection[k] : columnCollection[0]) : null;
                chartobj.model._columnDefinitions.push({
                    axis: this.axesIndexCount(chartobj.model.hAxes, columnCount.indexValue[k])
                    , index: columnCount.indexValue[k], columnDefinitions: columnDefinitions });
            }
        }
        
        var columnDefinition = chartobj.model._columnDefinitions;
        //Using filter to get spanning column axis collection
        var spanningColumn = this._axisFilter(columnDefinition, "columnSpan");
        //Arrange the entire axis for column span
        this._SpanningAxes(columnDefinition, spanningColumn, false);
       
        this._axisSize();
        
        
    },
    
     //Arrange the entire axis for spanning
    _SpanningAxes: function (definition,spanningCollection, isRow) {
        for (var spanIndex = 0, spanMax = spanningCollection.length; spanIndex < spanMax; spanIndex++) {
            var currentAxis = spanningCollection[spanIndex];
             if (currentAxis == null) break;
             var span = isRow ? currentAxis.rowSpan : currentAxis.columnSpan;
             var index = isRow ? currentAxis.rowIndex : currentAxis.columnIndex;
            if(definition[index]!=undefined){
             var axisIndex = definition[index].axis.indexOf(currentAxis);
             for (var k = 1, m = index + 1; k < span && m < definition.length; k++, m++) {
                 if (definition[m].axis.length >= axisIndex) {
                     //Insert duplicate span row to appropriate rowdefinition
                     definition[m].axis.splice(axisIndex, 0, currentAxis);
                 }
             }
             }
         }
     },
    
     //Filter span axis from axes
    _axisFilter: function (definition, fieldName) {
        var axisResult = [];
        definition.filter(function (axes) {
             //Execute query to get spanning axis from axis array
              var axisCollection = ej.DataManager(axes["axis"], ej.Query().where(fieldName, ">", 1)).executeLocal();
              for (var i = 0, max = axisCollection.length; i < max; i++)
                  axisResult.push(axisCollection[i]);
        });
        return axisResult;
    },
    
    _axisSize: function () {
        //The below calcultion to get approximate length of axis
         var spaceValue = this._getLegendSpace();
         var hSpace = $(this.svgObject).width() - this.model.margin.left - this.model.margin.right - (this.model.elementSpacing * 2) - spaceValue.leftLegendWidth - spaceValue.rightLegendWidth;
        var hWidth = Math.floor(hSpace / this.axesCount(this.model.hAxes).length);

        var vSpace = $(this.svgObject).height() - this.model.margin.top - this.model.margin.bottom - (this.model.elementSpacing * 2) - spaceValue.topLegendHeight - spaceValue.bottomLegendHeight - spaceValue.modelTitleHeight-spaceValue.modelsubTitleHeight;
        var vWidth = Math.floor(vSpace / this.axesCount(this.model.vAxes).length);

       

        for (var j = 0; j < this.model._axes.length; j++) {
            axis = this.model._axes[j];
            if (axis.orientation.toLowerCase() == "horizontal") {
                if (this.model.AreaType != "polaraxes") {
                    var customColumn = (!ej.util.isNullOrUndefined(this.model.columnDefinitions)) ? this.model.columnDefinitions[axis.columnIndex] : [];
                    var columnLength = hWidth;
                    if (customColumn) {
                        customColumn.unit = (customColumn.unit == undefined) ? "percentage" : customColumn.unit;
                        customColumn.columnWidth = (customColumn.columnWidth == undefined) ? 100 : customColumn.columnWidth;
                        if (customColumn.unit.toLowerCase() == "percentage") {
                            var length = this._axisColumnDefinitionSize(this.model.columnDefinitions);
                            columnLength = Math.floor((hWidth) * (customColumn.columnWidth / length));
                        }
                        else
                            columnLength = customColumn.columnWidth;

                    }
                    axis.length = axis.columnSpan ? axis.columnSpan * columnLength : columnLength;
                }
                else {
                    if (hSpace > vSpace*2)
                        axis.length = hSpace - vSpace;
                    else
                        axis.length = hSpace;
                }
            } else if (axis.orientation.toLowerCase() == "vertical") {
                if (this.model.AreaType != "polaraxes") {
                    var customRow = (!ej.util.isNullOrUndefined(this.model.rowDefinitions)) ? this.model.rowDefinitions[axis.rowIndex] : [];
                    var realLength = vWidth;
                    if (customRow) {
                        customRow.unit = (customRow.unit == undefined) ? "percentage" : customRow.unit;
                        customRow.rowHeight = (customRow.rowHeight == undefined) ? 100 : customRow.rowHeight;
                        if (customRow.unit.toLowerCase() == "percentage") {
                            var length = this._axisRowDefinitionSize(this.model.rowDefinitions);
                            realLength = Math.floor((vWidth) * (customRow.rowHeight / length));
                        }
                        else
                            realLength = customRow.rowHeight;

                    }
                    axis.length = axis.rowSpan ? (axis.rowSpan * realLength) : realLength;
                }
                else {
                    axis.length = vSpace / 2;
                }
            }
        }
    },
	_axisRowDefinitionSize: function (array) {
        var length = 0;
        if (array) {
            for (var i = 0; i < array.length; i++) {
                length = length + array[i].rowHeight;
            }
        }
        length = length > 100 ? length : 100;
        return length;
    },
    _axisColumnDefinitionSize: function (array) {
        var length = 0;
        if (array) {
            for (var i = 0; i < array.length; i++) {
                length = length + array[i].columnWidth;
            }
        }
        length = length > 100 ? length : 100;
        return length;
    },
   _axisMeasure: function (axis, realWidth, orientation,j) {
       var axisTitleHeight = 0, labelSize = 0, multiLevelLabelSize = 0;
        axis.axisLine.width = axis.axisLine.width < 0 ? 0 : axis.axisLine.width;
		  axis.majorTickLines.size = axis.majorTickLines.size < 0 ? 0 : axis.majorTickLines.size;
		var axisLineWidth = !this.model.enable3D && axis.axisLine.visible && axis.axisLine.width;
		var size = ej.EjSvgRender.utils._measureText(axis.title.text, realWidth, axis.title.font);
		if(orientation == "vertical")
		{
		 labelSize= axis._LableMaxWidth.width;
		 axisTitleHeight = (axis.title.text == "" || !(axis.title.visible) || !(axis.visible)) ? 0 : ((document.documentMode === 8) ? size.width : size.height + (2 * this.model.elementSpacing));
		}
		else
		{
		labelSize=(axis._LableMaxWidth.height);
		axisTitleHeight = (axis.title.text == "" || !(axis.title.visible) || !(axis.visible)) ? 0 : (size.height + (this.model.elementSpacing));
		}
		axisTitleHeight = axis.title.position.toLowerCase() == "inside" ? 0: axisTitleHeight;
		multiLevelLabelSize = this.getMultiLevelLabelSize(axis);
		var width;		
		if ((j == 0) && (axis.tickLinesPosition == 'inside' && axis.labelPosition == 'inside'))
		    axis.AxisMaxWidth = axisTitleHeight + multiLevelLabelSize + axisLineWidth + (this.model.elementSpacing);
		else if ((j == 0) && (axis.tickLinesPosition == 'inside' && axis.labelPosition != 'inside'))
		    axis.AxisMaxWidth = axisTitleHeight + multiLevelLabelSize + axisLineWidth + (this.model.elementSpacing) + labelSize;
		else if ((j == 0) && (axis.tickLinesPosition != 'inside' && axis.labelPosition == 'inside'))
		    axis.AxisMaxWidth = axisTitleHeight + multiLevelLabelSize + axisLineWidth + (this.model.elementSpacing) + axis.majorTickLines.size;
		else
		    axis.AxisMaxWidth = axisTitleHeight + multiLevelLabelSize + axisLineWidth + this.model.elementSpacing + axis.majorTickLines.size + labelSize;
		axis.AxisMaxWidth += axis._isScroll ? 18 : 0;
        return axis.AxisMaxWidth;
    },
     
    _arraySum: function (val) {
        var total = 0;
        for (var i = 0; i < val.length; i++) {
            total +=  parseFloat(val[i]) || 0;
        }
        return total;
    },
    _calSpace: function (realWidth, definitions,orientation, params) {
        var nearSizes = [];
        var farSizes = [];
        for (var i = 0; i < definitions.length; i++) {
            var nearIndex = 0, farIndex = 0;
            for (var j = 0; j < definitions[i].axis.length; j++) {
                var currentaxis = definitions[i].axis[j];                
                    bounds = params.axes[currentaxis.name]._bounds = this._axisMeasure(currentaxis, realWidth, orientation, j);
                    validCross = params.axes[currentaxis.name]._validCross = this._validateCrossing(currentaxis);
                    measureValue = validCross ? 0 : bounds;
                currentaxis._opposed = currentaxis.opposedPosition ? !currentaxis._opposedPosition : currentaxis._opposedPosition || currentaxis.opposedPosiiton||false;
                if (validCross && definitions[i].axis[j].showNextToAxisLine)
                    continue;
                if (!currentaxis.showNextToAxisLine)
                { measureValue = (currentaxis.labelPosition=="inside")? bounds-currentaxis._multiLevelLabelHeight : bounds ; }
                if (!currentaxis._opposed) {
                    if (nearSizes.length <= nearIndex) {
                        nearSizes.push(measureValue);
                    } else if (nearSizes[nearIndex] < (measureValue)) {
                        nearSizes[nearIndex] = measureValue;
                    }
                    nearIndex++;
                }
                else {
                    if (farSizes.length <= farIndex) {
                        farSizes.push(measureValue);
                    } else if (farSizes[farIndex] < (measureValue)) {
                        farSizes[farIndex] = measureValue;
                    }
                    farIndex++;
                }                

            }
        }        
        return { nearSizes: nearSizes, farSizes: farSizes };
    },
    
    _getLegendSpace: function () {
        var chart = this.model,
            legend = chart.legend,
            position = legend.position.toLowerCase(),
            bounds = chart.LegendActualBounds,
            measureText = ej.EjSvgRender.utils._measureText,
            title = chart.title,
            subTitle = title.subTitle,
            elementSpacing = chart.elementSpacing,
            margin = chart.margin,
            svgWidth = chart.svgWidth,
            legendBorder = legend.border.width,
            ltheight = 0, space = 0,
            itemPadding = 10,
            leftLegendWidth = 0, rightLegendWidth = 0,
            topLegendHeight = 0, bottomLegendHeight = 0,
           labelCollection = title.text.split(' '),
           text, line = 0, enableTrim = title.enableTrim,
           maxTitleWidth = title.maximumWidth,
           maxTitleWidth = (maxTitleWidth.toString() == 'auto' || maxTitleWidth.toString() == '') ? (svgWidth * 0.75) : parseInt(maxTitleWidth),
           textOverflow = title.textOverflow.toLowerCase(),
           titleText = title.text,
           titleVisible = title.visible, titleCollection, subTitleCollection, data,
           measureTitle = ej.EjSvgRender.utils._measureText(title.text, $(this.svgObject).width() - this.model.margin.left - this.model.margin.right, title.font),
           subTitleLabelCollection = subTitle.text.split(' '),
           subTitleEnableTrim = subTitle.enableTrim,
           maxSubTitleWidth = subTitle.maximumWidth,
           maxSubTitleWidth = (maxSubTitleWidth.toString() == 'auto' || maxSubTitleWidth.toString() == '') ? (svgWidth * 0.75) : parseInt(maxSubTitleWidth),
           subTitleTextOverflow = subTitle.textOverflow.toLowerCase(),
           subTitleText = subTitle.text,
           subTitleVisible = subTitle.visible,
           measureSubTitle = ej.EjSvgRender.utils._measureText(subTitle.text, $(this.svgObject).width() - this.model.margin.left - this.model.margin.right, subTitle.font),
           titleVisibility = titleVisible && enableTrim && measureTitle.width > maxTitleWidth ? true : false,
           subTitleVisibility = subTitleVisible && subTitleEnableTrim && measureSubTitle.width > maxSubTitleWidth ? true : false,
           textOverflowVisibility = textOverflow == "wrap" || textOverflow == "wrapandtrim" ? true : false,
           subTitleTextOverflowVisibility = subTitleTextOverflow == "wrap" || subTitleTextOverflow == "wrapandtrim" ? true : false;
           this.model.titleWrapTextCollection = [];
           this.model.subTitleWrapTextCollection = [];
           this.model.trimTooltip = false;
           this.model.subTitleTooltip = false;
        if (legend.visible) {
            space = (bounds.Width + (itemPadding / 2) + elementSpacing + (2 * legendBorder));
            leftLegendWidth = position == 'left' ? space : 0;
            rightLegendWidth = position == 'right' ? space : 0;
            if (legend.title.text)
                ltheight = measureText(legend.title, null, legend.title.font).height;
            topLegendHeight = position == 'top' ? (bounds.Height + ltheight + (2 * legendBorder)) : 0;
            bottomLegendHeight = position == 'bottom' ? (bounds.Height + ltheight + (2 * legendBorder)) : 0;
        }
        if (titleVisibility && textOverflow == "wrap") {
            data = { text: titleText, font: title.font };
            titleCollection = this._rowsCalculation(data, maxTitleWidth, textOverflow);
        }
        else if (titleVisibility && textOverflow == "wrapandtrim") {
            data = { text: titleText, font: title.font };
            titleCollection = this._rowsCalculation(data, maxTitleWidth, textOverflow);
        }
        else if (textOverflow == "wrapandtrim" || textOverflow == "wrap") {
            data = { text: titleText, font: title.font };
            titleCollection = this._rowsCalculation(data, ej.EjSvgRender.utils._measureText(titleText, null, title.font).width, textOverflow);
        }
        this.model.titleWrapTextCollection = titleCollection ? titleCollection.textCollection : "";
        this.model.titleMaxWidth = titleCollection ? titleCollection.wordMax : maxTitleWidth;
        if (subTitleVisibility && subTitleTextOverflow == "wrap" ) {
            data = { text: subTitleText, font: subTitle.font };
            subTitleCollection = this._rowsCalculation(data, maxSubTitleWidth, subTitleTextOverflow);
        }
        else if (subTitleVisibility && subTitleTextOverflow == "wrapandtrim" ) {
            data = { text: subTitleText, font: subTitle.font };
            subTitleCollection = this._rowsCalculation(data, maxSubTitleWidth, subTitleTextOverflow);
            this.model.subTitleTooltip = this.model.trimTooltip;
        }
        else if (subTitleTextOverflow == "wrapandtrim" || subTitleTextOverflow == "wrap") {
            data = { text: subTitleText, font: subTitle.font };
            subTitleCollection = this._rowsCalculation(data, maxSubTitleWidth, subTitleTextOverflow);
        }
        this.model.subTitleWrapTextCollection = subTitleCollection ? subTitleCollection.textCollection : "";
        this.model.subTitleMaxWidth = subTitleCollection ? subTitleCollection.wordMax : maxSubTitleWidth;
        var titleHeight = measureText(title.text, svgWidth - margin.left - margin.right, title.font).height,
             subTitleHeight = measureText(subTitle.text, svgWidth - margin.left - margin.right, subTitle.font).height;
        modelTitleHeight = (title.text == "" || !title.visible) ? 0 : (enableTrim && (textOverflowVisibility) && measureTitle.width > maxTitleWidth) ?
            ((titleHeight * this.model.titleWrapTextCollection.length) + elementSpacing) : (titleHeight + elementSpacing);
        modelsubTitleHeight = (subTitle.text == "" || !subTitle.visible || !title.visible) ? 0 : (subTitleEnableTrim && (subTitleTextOverflowVisibility) && measureSubTitle.width > maxSubTitleWidth) ?
            ((subTitleHeight * this.model.subTitleWrapTextCollection.length) + elementSpacing) : (subTitleHeight + elementSpacing);

        return {
            leftLegendWidth: leftLegendWidth, rightLegendWidth: rightLegendWidth, topLegendHeight: topLegendHeight, bottomLegendHeight: bottomLegendHeight, modelTitleHeight: modelTitleHeight, modelsubTitleHeight: modelsubTitleHeight
        };
    },


    _arraySome: function (axes,orientation) {
        var scroll = false,
            isZoomScroll = this.model.zooming.enableScrollbar,
            count = axes.length,
            scrollbar,
            pointLength;

        for (var i = 0; i < count; i++) {
            scrollbar = axes[i].scrollbarSettings.enableScrollbar;
            pointLength = axes[i].scrollbarSettings.pointsLength;
            scroll = (scroll || (((axes[i]._isScroll && axes[i].maxPointLength < pointLength) || (axes[i].zoomFactor < 1 && scrollbar && isZoomScroll)) && axes[i].orientation.toLowerCase() == orientation));
        }

        return scroll;
    },

    _calculateAreaBounds: function (params) {
        var chartobj = this,
        realWidth = $(this.svgObject).width() - this.model.margin.left - this.model.margin.right,
        // Calculate area bounds X and width
        chartBorderWidth = chartobj.model.border.width,
        axis = this.model._axes[0],
        zomming = this.model.zooming.enableScrollbar,
        type = this.model.zooming.type.toLowerCase();
        chartobj.model.scrollerSize = 18;
        this.model._yScroll = this._arraySome(this.model._axes, 'vertical');
        this.model._xScroll = this._arraySome(this.model._axes, 'horizontal');

        //Calcultion for multiple axes(vertical)
        var sizes = this._calSpace(realWidth, chartobj.model._rowDefinitions,"vertical", params);
        chartobj.model._rowDefinitions.nearSizes = sizes.nearSizes;
        chartobj.model._rowDefinitions.farSizes = sizes.farSizes;
        var vAxesWidth = this._arraySum(sizes.nearSizes);
        var vAxesOppWidth = this._arraySum(sizes.farSizes);

        var spaceValue=this._getLegendSpace();
       
        var x = vAxesWidth + spaceValue.leftLegendWidth + chartobj.model.margin.left + chartBorderWidth;
        var rightSpacing = vAxesOppWidth + spaceValue.rightLegendWidth + chartobj.model.margin.right + chartobj.model.margin.left + (2 * chartBorderWidth);
        var width = $(this.svgObject).width();
        var boundsWidth =  width - (x + rightSpacing);
        if (boundsWidth < 0 && this.model.AreaType == "cartesianaxes") {
            $(this.svgObject).width(width - boundsWidth + 1);
            this._calculateAreaBounds(params);
        }
        else {
        // Calculate area bounds Y and Height   
        
        //Calcultion for multiple axes(Horizontal)
        var columnSizes = this._calSpace(realWidth, chartobj.model._columnDefinitions,"horizontal", params);
        chartobj.model._columnDefinitions.nearSizes = columnSizes.nearSizes;
            chartobj.model._columnDefinitions.farSizes = columnSizes.farSizes;
            var hAxesWidth = this._arraySum(columnSizes.nearSizes);
            var hAxesOppWidth = this._arraySum(columnSizes.farSizes);

            var y = hAxesOppWidth + this.model.margin.top + (this.model.elementSpacing) + spaceValue.modelTitleHeight + (spaceValue.modelsubTitleHeight) + spaceValue.topLegendHeight + chartBorderWidth;
            var bottomSpacing = hAxesWidth + this.model.margin.bottom + spaceValue.bottomLegendHeight + (2 * chartBorderWidth);
            var boundsHeight = Math.abs($(this.svgObject).height() - (y + bottomSpacing));

            this.model.m_AreaBounds = { X: x, Y: y, Width: boundsWidth, Height: boundsHeight };
            this.model.m_Spacing = { Left: x, Top: y, Right: rightSpacing, Bottom: bottomSpacing };

            if (this.model.enableCanvasRendering) {  // for adding bounds in canvas rendering
                this.canvasX = x;
                this.canvasY = y;
                this.canvasWidth = boundsWidth;
                this.canvasHeight = boundsHeight;
            } else 
                this.canvasX = this.canvasY = this.canvasHeight = this.canvasWidth = 0;
        }
      }
};

jQuery.uaMatch = function (ua) {
    ua = ua.toLowerCase();

    var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
        /(webkit)[ \/]([\w.]+)/.exec(ua) ||
        /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
        /(msie) ([\w.]+)/.exec(ua) ||
        ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
        [];

    return {
        browser: match[1] || "",
        version: match[2] || "0"
    };
};


 
})(jQuery);;
/**
* @fileOverview Plugin to style the Html Chart elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej) {

    ej.widget("ejChart", "ej.datavisualization.Chart", {
 
        element: null,
 
        model: null,

        validTags: ["div"],
 
        defaults: {

            border: {

                color: 'transparent',

                width: 0,

                opacity: 0.3
            },

            chartArea:
            {

                border: {

                    color: 'Gray',

                    width: 0.5,

                    opacity: 0.3
                },

                background: 'transparent'

            },

            primaryXAxis:
            {
	            crossesAt: null,

         		crossesInAxis: null,

         		isIndexed: false,

         		alignment: "center",

                labelPlacement: "",

                scrollbarSettings: {

         		    visible: true,
                    
         		    canResize: true,

         		    range: {

         		        min: null,

                        max: null,
         		    },

                    pointsLength : null

         		},

         		range: {

                    min: null,

                    max: null,

                    interval: null
                },

                labelPosition: 'outside',

                tickLinesPosition: 'outside',

                alternateGridBand:
                        {

                            odd: {

                                fill: "transparent",

                                opacity: 1
                            },

                            even: {

                                fill: "transparent",

                                opacity: 1
                            }
                        },

                enableAutoIntervalOnZooming : true,
                         

                majorGridLines:
                {

                    width: 1,

                    dashArray: "",

                    visible: true,

                    opacity: 1

                },

                majorTickLines:
               {

                   width: 1,

                   size: 5,

                   visible: true
               },

                minorGridLines:
               {

                   width: 1,

                   dashArray: "",

                   visible: true

               },

                minorTickLines:
                {

                    width: 1,

                    size: 5,

                    visible: true
                },

                labelBorder:
               {	
                    width: 0
               },

                multiLevelLabels: [{
                    visible: false,
                    text: "",
                    textAlignment: "center",
                    start: null,
                    end: null,
                    level: 0,
                    maximumTextWidth: null,
                    textOverflow: "trim",
                    font: {
                        fontFamily: 'Segoe UI',
                        fontStyle: 'Normal',
                        size: '12px',
                        fontWeight: 'Regular',
                        opacity: 1
                    },
                    border: {
                        type: 'rectangle',
                        width: 1
                    }
                }],

                minorTicksPerInterval: null,

                columnIndex: null,

                columnSpan: null,

                labelRotation: null,

                valueType: null,

                name: null,

                labelFormat: null,

                desiredIntervals: null,

                intervalType: null,

                roundingPlaces: null,

                logBase: 10,

                plotOffset: 0,
                labels: [],

                stripLine: [
                       {

                           visible: false,

                           startFromAxis: false,

                           text: "",

                           width: 0,

                           textAlignment: "middlecenter",

                           font: {

                               fontFamily: 'Segoe UI',

                               fontStyle: 'Normal',

                               size: '12px',

                               fontWeight: 'Regular',

                               color: 'black',

                               opacity: 1
                           },

                           start: null,

                           end: null,

                           color: 'gray',

                           borderColor: 'black',

                           zIndex: 'over'
                       }
                ],

                title:
               {


                   text: "",

				    visible:true,

                   enableTrim: false,
				   
				   offset:0,
				
				   alignment:'center',
				
				   position:'outside',

                   maximumTitleWidth: null,

                   font:
                   {

                       fontFamily: 'Segoe UI',

                       fontStyle: 'Normal',

                       size: '14px',

                       opacity: 1,

                       fontWeight: 'regular'
                   }
               },
                rangePadding: 'Auto',
                additionalPadding: [1, 1],
                orientation: 'Horizontal',

                maximumLabels: 3,

                opposedPosition: false,

                showNextToAxisLine: true,

                axisLine:
                {

                    visible: true,

                    width: 1,

                    dashArray: "",

                    offset: 0
                },

                labelIntersectAction: "none",

                maximumLabelWidth: 34,

                enableTrim: false,


                edgeLabelPlacement: "none",



                isInversed: false,



                font:
                {

                    fontFamily: 'Segoe UI',

                    fontStyle: 'Normal',

                    size: '11px',

                    fontWeight: 'regular',

                    opacity: 1
					
                },

                visible: true,

                crosshairLabel:
                {

                    visible: false
                },

                zoomFactor: 1,

                zoomPosition: 0
            },


            primaryYAxis:
              {
                  crossesAt: null,
                  crossesInAxis: null,
                  showNextToAxisLine: true,

                  alignment: "center",

                  startFromZero: true,

                  range: {

                      min: null,

                      max: null,

                      interval: null
                  },

                  scrollbarSettings: {

                      visible: true,

                      canResize: true,

                      range: {

                          min: null,

                          max: null,
                      },

                      pointsLength: null

                  },

                  labelPlacement: "",

                  labelPosition: 'outside',

                  tickLinesPosition: 'outside',

                  alternateGridBand:
                             {

                                 odd: {

                                     fill: "transparent",

                                     opacity: 1
                                 },

                                 even: {


                                     fill: "transparent",

                                     opacity: 1
                                 }
                             },

                  enableAutoIntervalOnZooming: true,                                

                  majorGridLines:
                 {

                     width: 1,

                     dashArray: "",

                     visible: true,

                     opacity: 1

                 },

                  majorTickLines:
                {

                    width: 1,

                    size: 5,

                    visible: true
                },

                  minorGridLines:
                 {

                     width: 1,

                     dashArray: "",

                     visible: true

                 },

                  minorTickLines:
                {

                    width: 1,

                    size: 5,

                    visible: true
                },

                  labelBorder:
               {	
                    width: 0
               },

                multiLevelLabels: [{
                    visible: false,
                    text: "",
                    textAlignment: "center",
                    start: null,
                    end: null,
                    level: 0,
                    maximumTextWidth: null,
                    textOverflow: "trim",
                    font: {
                        fontFamily: 'Segoe UI',
                        fontStyle: 'Normal',
                        size: '12px',
                        fontWeight: 'Regular',
                        opacity: 1
                    },
                    border: {
                        type: 'rectangle',
                        width: 1
                    }
                }],

                  minorTicksPerInterval: null,

                  rowIndex: null,

                  rowSpan: null,

                  valueType: null,

                  name: null,

                  labelFormat: null,

                  desiredIntervals: null,

                  intervalType: null,

                  roundingPlaces: null,
                  labels: [],

                  title:
                  {

                      text: "",

					   visible:true,

                      enableTrim: false,
					  
					  offset:0,
				
					  alignment:'center',
				
				      position:'outside',
					  
                      maximumTitleWidth: null,

                      font:
                     {

                         fontFamily: 'Segoe UI',

                         fontStyle: 'Normal',

                         opacity: 1,

                         size: '14px',

                         fontWeight: 'regular'
                     }
                  },

                  rangePadding: 'Auto',


                  stripLine: [
                       {

                           visible: false,

                           startFromAxis: false,

                           width: 0,

                           text: "",

                           textAlignment: "middlecenter",

                           font: {

                               fontFamily: 'Segoe UI',

                               fontWeight: 'Regular',

                               fontStyle: 'Normal',

                               size: '12px',

                               color: 'black',

                               opacity: 1
                           },

                           start: null,

                           end: null,

                           color: 'gray',

                           borderColor: 'black',

                           zIndex: 'over'
                       }
                  ],

                  logBase: 10,

                  plotOffset: 0,

                  orientation: 'Vertical',

                  maximumLabels: 3,

                  labelIntersectAction: "none",


                  maximumLabelWidth: 34,

                  enableTrim: false,

                  edgeLabelPlacement: "none",


                  isInversed: false,


                  crosshairLabel:
                 {

                     visible: false
                 },

                  visible: true,

                  opposedPosition: false,

                  font:
               {

                   fontFamily: 'Segoe UI',

                   fontStyle: 'Normal',

                   size: '11px',

                   opacity: 1,

                   fontWeight: 'regular'
				   
               },

                  axisLine:
              {

                  visible: true,

                  width: 1,

                  dashArray: "",

                  offset: 0
              },


                  zoomFactor: 1,

                  zoomPosition: 0
              },
            axes: [],

            secondaryX:
             {
                 crossesAt: null,
                 crossesInAxis: null,
				 showNextToAxisLine: true,
                 alignment: "center",
                 range: {
                     min: null,
                     max: null,
                     interval: null
                 },

                 scrollbarSettings: {

                     visible: true,

                     canResize: true,

                     range: {

                         min: null,

                         max: null,
                     },

                     pointsLength: null

                 },

                 tickLinesPosition: "outside",
                 labelPosition: "outside",

                 majorGridLines:
        {

            width: 1,

            dashArray: "",

            visible: true
        },
                 alternateGridBand:
           {
               odd: {
                   fill: "transparent",
                   opacity: 1
               },
               even: {
                   fill: "transparent",
                   opacity: 1
               }
           },

                 enableAutoIntervalOnZooming: true,                                

                 majorTickLines:
         {

             width: 1,

             size: 5,

             visible: true
         },

                 minorGridLines:
         {

             width: 1,

             dashArray: "",

             visible: true

         },

                 minorTickLines:
        {

            width: 1,

            size: 5,

            visible: true
        },

				   labelBorder:
               {	
                    width: 0
               },

                multiLevelLabels: [{
                    visible: false,
                    text: "",
                    textAlignment: "center",
                    start: null,
                    end: null,
                    level: 0,
                    maximumTextWidth: null,
                    textOverflow: "trim",
                    font: {
                        fontFamily: 'Segoe UI',
                        fontStyle: 'Normal',
                        size: '12px',
                        fontWeight: 'Regular',
                        opacity: 1
                    },
                    border: {
                        type: 'rectangle',
                        width: 1
                    }
                }],

                 minorTicksPerInterval: null,

                 columnIndex: null,

                 columnSpan: null,

                 labelRotation: null,

                 valueType: null,

                 name: null,

                 labelFormat: null,

                 labelPlacement: "",

                 desiredIntervals: null,

                 intervalType: null,

                 roundingPlaces: null,

                 logBase: 10,

                 plotOffset: 0,
                 labels: [],
                 stripLine: [
              {
                  visible: false,
                  startFromAxis: false,
                  text: "",
                  textAlignment: "middlecenter",
                  font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', fontWeight: 'regular', size: '12px', color: 'black', opacity: 1 },
                  start: null,
                  end: null,
                  color: 'gray',
                  borderColor: 'black',
                  zIndex: 'over'
              }
                 ],

                 title:
         {


             text: "",
             visible:true,
             enableTrim: false,
			 offset:0,
			 alignment:'center',	
			 position:'outside',
             maximumTitleWidth: null,
             font:
        {

            fontFamily: 'Segoe UI',

            fontStyle: 'Normal',

            size: '14px',

            opacity: 1,

            fontWeight: 'regular'
			
        }

         },

                 rangePadding: 'Auto',
                 additionalPadding: [1, 1],

                 orientation: 'Horizontal',

                 maximumLabels: 3,

                 opposedPosition: false,

                 axisLine:
          {

              visible: true,

              width: 1,

              dashArray: "",

              offset: 0
          },

                 labelIntersectAction: "none",

                 edgeLabelPlacement: "none",

                 font:
          {

              fontFamily: 'Segoe UI',

              fontStyle: 'Normal',

              size: '11px',

              fontWeight: 'regular',

              opacity: 1
          },

                 visible: true,

                 crosshairLabel:
           {

               visible: false
           },

                 zoomFactor: 1,

                 zoomPosition: 0
             },

            secondaryY:
                {
                    crossesAt: null,
                    crossesInAxis: null,
					showNextToAxisLine: true,
                    alignment: "center",
                    startFromZero: true,
                    range: {
                        min: null,
                        max: null,
                        interval: null
                    },

                    scrollbarSettings: {

                        visible: true,

                        canResize: true,

                        range: {

                            min: null,

                            max: null,
                        },

                        pointsLength: null

                    },

                    tickLinesPosition: "outside",
                    labelPosition: "outside",

                    majorGridLines:
       {

           width: 1,

           dashArray: "",

           visible: true

       },
                    alternateGridBand:
           {
               odd: {
                   fill: "transparent",
                   opacity: 1
               },
               even: {
                   fill: "transparent",
                   opacity: 1
               }
           },

                    enableAutoIntervalOnZooming: true,                                   

                    majorTickLines:
                        {

                            width: 1,

                            size: 5,

                            visible: true
                        },

                    minorGridLines:
                        {

                            width: 1,

                            dashArray: "",

                            visible: true

                        },

                    minorTickLines:
                        {

                            width: 1,

                            size: 5,

                            visible: true
                        },

                    labelBorder:
               {	
                    width: 0
               },

                multiLevelLabels: [{
                    visible: false,
                    text: "",
                    textAlignment: "center",
                    start: null,
                    end: null,
                    level: 0,
                    maximumTextWidth: null,
                    textOverflow: "trim",
                    font: {
                        fontFamily: 'Segoe UI',
                        fontStyle: 'Normal',
                        size: '12px',
                        fontWeight: 'Regular',
                        opacity: 1
                    },
                    border: {
                        type: 'rectangle',
                        width: 1
                    }
                }],

                    minorTicksPerInterval: null,

                    rowIndex: null,

                    rowSpan: null,

                    valueType: null,

                    name: null,

                    labelFormat: null,

                    desiredIntervals: null,

                    intervalType: null,

                    roundingPlaces: null,
                    labels: [],

                    title:
                    {

                        text: "",
                        visible:true,
                        enableTrim: false,
						offset:0,			
						alignment:'center',
						position:'outside',
                        maximumTitleWidth: null,
                        font:
                        {
                            fontFamily: 'Segoe UI',

                            fontStyle: 'Normal',

                            opacity: 1,

                            size: '14px',

                            fontWeight: 'regular'
                        }
                    },

                    rangePadding: 'Auto',

                    stripLine: [
                         {
                             visible: false,
                             startFromAxis: false,
                             text: "",
                             textAlignment: "middlecenter",
                             font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', fontWeight: 'regular', size: '12px', color: 'black', opacity: 1 },
                             start: null,
                             end: null,
                             color: 'gray',
                             borderColor: 'black',
                             zIndex: 'over'
                         }
                    ],

                    logBase: 10,

                    plotOffset: 0,

                    orientation: 'Vertical',

                    maximumLabels: 3,

                    labelIntersectAction: "none",

                    labelPlacement: "",

                    edgeLabelPlacement: "none",

                    crosshairLabel:
                    {

                        visible: false
                    },

                    visible: true,

                    opposedPosition: false,

                    font:
                    {
                        fontFamily: 'Segoe UI',

                        fontStyle: 'Normal',

                        size: '11px',

                        opacity: 1,

                        fontWeight: 'regular'
						
                    },

                    axisLine:
                        {

                            visible: true,

                            width: 1,

                            dashArray: "",

                            offset: 0
                        },


                    zoomFactor: 1,

                    zoomPosition: 0
                },
            trendlineDefaults: {
                type: "linear",
                visibility: "",
				visibleOnLegend:"visible",
                name: "Trendline",
                fill: "",
                width: 1,
                opacity: 1,
                dashArray: "",
                forwardForecast: 0,
                backwardForecast: 0,
                polynomialOrder: 2,
                period: 2,
				intercept: null,
                tooltip: {
                    visible: false, format: null, fill: null, border: { width: 1, color: null }, duration: '500ms', enableAnimation: true, opacity: 0.95, font: {fontFamily: 'Segoe UI', fontStyle: 'Normal', fontWeight: 'Regular', size: '12px', opacity: 1}
                }
            },
            indicatorDefaults: {
                visible: true,
                points: [],
                tooltip: { visible: false, format: null, fill: null, border: { width: 1, color: null }, duration: '500ms', enableAnimation: true, opacity: 0.95 },
                seriesName: "",
                font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', fontWeight: 'Regular', size: '12px', color: '#707070', opacity: 1 },
                type: "SMA",
                period: 14,
                standardDeviations: 2,
                kPeriod: 3,
                dPeriod: 3,
                periodLine: { fill: "blue", width: 2 },
                lowerLine: { fill: "#008000", width: 2 },
                upperLine: { fill: "#ff0000", width: 2 },
                macdLine: { fill: "#ff9933", width: 2 },
                histogram: { fill: "#ccccff", opacity: 1, border: { color: "#9999ff", width: 1 } },
                fill: "#00008B",
                width: 2,
                xAxisName: "",
                yAxisName: "",
                visibility: "visible",
                macdType: "line",
                shortPeriod: 12,
                longPeriod: 26,
                trigger: 9,
                enableAnimation: false
            },
            annotationsDefault: {
                visible: false,
                content: "",
                coordinateUnit: "none",
                verticalAlignment: "middle",
                horizontalAlignment: "middle",
                region: "chart",
                x: 0,
                y: 0,
                opacity: 1,
                angle: 0,
                xAxisName: "",
                yAxisName: "",
                margin: {
                    left: 0,
                    right: 0,
                    bottom: 0,
                    top: 0
                }
            },
            multiLevelLabelsDefault: {
                  visible: false,
                    text: "",
                    textAlignment: "center",
                    start: null,
                    end: null,
                    level: 0,
                    maximumTextWidth: null,
                    textOverflow: "trim",
                    font: {
                        fontFamily: 'Segoe UI',
                        fontStyle: 'Normal',
                        size: '12px',
                        fontWeight: 'Regular',
                        opacity: 1
                    },
                    border: {
                        type: 'rectangle',
                        width: 1
                    }
            },
            stripLineDefault: {

                visible: false,

                startFromAxis: false,

                width: 0,

                text: "",

                textAlignment: 'middlecenter',

                font:
                {

                    fontFamily: 'Segoe UI',

                    fontStyle: 'Normal',

                    fontWeight: 'Regular',

                    size: '12px',

                    color: 'black',

                    opacity: 1
                },

                start: null,

                end: null,

                color: 'gray',

                borderColor: 'black',

                zIndex: 'over',

                borderWidth: 1
            },

            rowDefinitions: null,

            columnDefinitions: null,

            title:
				{

				    text: "",

				    enableTrim: false,
                    
                    visible: true,

				    maximumWidth: 'auto',

                    textOverflow: "trim",

				    textAlignment: "center",

				    background: 'transparent',

				    border: {

				        color: 'transparent',

				        width: 1,

				        opacity: 0.8,

				        cornerRadius: 0.8

				    },

				    font: {

				        fontFamily: 'Segoe UI',

				        fontStyle: 'Normal',

				        size: '16px',

				        opacity: 1,

				        fontWeight: 'regular'
				    },


				    subTitle:
                           {

                               text: "",

                               enableTrim: false,

                               visible: true,

                               maximumWidth: 'auto',

                               textOverflow: "trim",

                               textAlignment: 'far',

                               background: 'transparent',

                               border: {

                                   color: 'transparent',

                                   width: 1,

                                   opacity: 0.8,

                                   cornerRadius: 0.8

                               },


                               font:
                               {

                                   fontFamily: 'Segoe UI',

                                   fontStyle: 'Normal',

                                   size: '12px',

                                   opacity: 1,

                                   fontWeight: 'regular'
                               }
                           }

				},





            lineCap: { butt: 'butt', round: 'round', square: 'square' },
            lineJoin: { round: 'round', bevel: 'bevel', miter: 'miter' },
            legendAlignment: { near: 'near', center: 'center', far: 'far' },
            legendPosition: { top: 'top', bottom: 'bottom', right: 'right', left: 'left', custom: 'custom' },

            enableAnimation: true,

            legend:
            {

                title:
                      {
                          text: "",

                          textAlignment: 'center',

                          font:
                              {

                                  size: '12px',

                                  fontFamily: "Segoe UI",

                                  fontStyle: 'normal',

                                  fontWeight: 'regular'
                              }
                      },

                border:
                {

                    color: 'transparent',


                    width: 1
                },

                visible: true,

                textOverflow: 'none',

                textWidth:34,

                toggleSeriesVisibility: true,
				
				enableScrollbar: true,

                itemPadding: 10,

                shape: 'None',

                alignment: 'Center',

                position: 'Bottom',

                location:
                {

                    x: 0,

                    y: 0
                },

                itemStyle:
                {
                    height: 9,

                    width: 9,

                    border:
                    {

                        color: 'transparent',

                        width: 1
                    }
                },

                rowCount: null,

                columnCount: null,

                opacity: 1,

                fill: null,

                background: null,

                font:
                {

                    fontFamily: 'Segoe UI',

                    fontStyle: 'Normal',

                    fontWeight: 'Regular',

                    size: '12px'
                },

                size:
                    {

                        height: null,

                        width: null
                    }
            },

            indicators: [
              {
                  points: [],

                  tooltip:
				  {

				      visible: false,

				      format: null,

				      fill: null,

				      border: {

				          width: 1,

				          color: null
				      },

				      duration: '500ms',

				      enableAnimation: true,

				      opacity: 0.95
				  },

                  seriesName: "",

                  type: "SMA",

                  period: 14,

                  standardDeviations: 2,

                  kPeriod: 3,

                  dPeriod: 3,

                  periodLine: {

                      fill: "blue",

                      width: 2
                  },

                  lowerLine: {


                      fill: "#008000",

                      width: 2
                  },

                  upperLine: {

                      fill: "#ff0000",

                      width: 2
                  },

                  macdLine: {

                      fill: "#ff9933",

                      width: 2
                  },

                  histogram: {

                      fill: "#ccccff",

                      opacity: 1,

                      border: {

                          color: "#9999ff",

                          width: 1
                      }
                  },

                  fill: "#00008B",

                  visible: true,

                  font: {

                      fontFamily: 'Segoe UI',

                      fontStyle: 'Normal',

                      fontWeight: 'Regular',

                      size: '12px',

                      color: '#707070',

                      opacity: 1
                  },

                  width: 2,

                  xAxisName: "",

                  yAxisName: "",

                  macdType: "line",

                  shortPeriod: 12,

                  longPeriod: 26,

                  trigger: 9,

                  visibility: "visible",

                  enableAnimation: false
              }
            ],

            background: null,
			
            backGroundImageUrl: null,

            annotations: [{

                visible: false,

                content: "",

                coordinateUnit: "none",

                verticalAlignment: "middle",

                horizontalAlignment: "middle",

                region: "chart",

                x: 0,

                y: 0,

                opacity: 1,

                angle: 0,

                xAxisName: "",

                yAxisName: "",

                margin: {

                    left: 0,

                    right: 0,

                    bottom: 0,

                    top: 0
                }
            }],

            series: [
                {
                dragSettings: {
                       enable: false,
                       type: 'xy'                      
                   },

                    type: 'column',

					splitMode: 'value',

					splitValue: null,

					gapWidth: 50,

					pieOfPieCoefficient: 0.6,
					
					visibleOnLegend:"visible",

                    enableAnimation: false,

                    isClosed: true,

					 isTransposed:false,

                    isStacking: true,

					columnSpacing: 0,

                    columnWidth: 0.7,

                    columnFacet:'rectangle',
                    drawType: 'line',

                    doughnutCoefficient: 0.4,

                    explodeOffset: 25,

                    pyramidMode: 'linear',
					
					boxPlotMode : 'exclusive',
										
                    funnelWidth: '11.6%',

                    funnelHeight: '32.7%',

                    positiveFill: null,
					
					showMedian:true,
					
					outlierSettings:{
						
						shape : 'circle',
						
						size:
						{
							width:6,
							
							height:6
						
						},
				},
					
					cornerRadius: {
					
						topLeft: 0,
					
						topRight: 0,
					
						bottomLeft: 0,
					
						bottomRight: 0
					},

                    connectorLine: {

                        width: 1,

                        opacity: 1,

                        dashArray: null
                    },
					
					 errorBar: {

                        visibility: "hidden",

                        mode: "vertical",

                        type:"fixedValue",
                        
                        horizontalErrorValue: 1,

                        verticalErrorValue: 3,

                        horizontalPositiveErrorValue: 1,

                        horizontalNegativeErrorValue: 1,

                        verticalPositiveErrorValue: 5,

                        verticalNegativeErrorValue: 5,

                        direction: "both",

                        cap:{
                            
                            visible:true,
                            
                            width: 1,

                            length: 20,

                        },


                        width: 1,

                        opacity: 1,

                    },

                    highlightSettings: {

                        enable: false,

                        mode: 'series',

                        color: "",

                        opacity: 0.6,

                        border: {

                            color: "",

                            width: 2
                        },

                        pattern: 'none',

                        customPattern: ""
                    },

                    selectionSettings: {

                        type:'Single',

                        enable: false,

                        mode: 'series',

                        rangeType: 'xy',

                        color: "",

                        opacity: 0.6,

                        border: {

                            color: "",

                            width: 2
                        },

                        pattern: 'none',

                        customPattern: ""
                    },
					
					emptyPointSettings: {

                        visible: true,

                        style: {

                            color: '',

                            border: {

                                color: '',

                                width: 1

                            }
                        
                        },

                        displayMode: 'gap'
                    },
					
                    labelPosition: 'inside',

                    gapRatio: 0,

                    points: null,

                    pieCoefficient: 0.8,

                    doughnutSize: 0.8,

                    dataSource: null,

                    high: '',

                    low: '',

                    open: '',

                    close: '',

                    bullFillColor: null,

                    bearFillColor: null,

                    query: null,

                    xName: '',

                    yName: '',

                    pointColorMappingName: '',



                    visibility: "visible",
					
                    startAngle: null,

                    endAngle: null,

                    xAxisName: null,

                    yAxisName: null,

                    explodeAll: null,

                    explode: false,

                    explodeIndex: null,

                    enableSmartLabels: null,

                    tooltip: {

                        visible: false,

                        format: null,

                        template: null,


                        fill: null,

                        border: {

                            width: 1,

                            color: null
                        },

                        enableAnimation: true,

                        duration: '500ms',

                        opacity: 0.95
                    },

                    fill: null,

                    opacity: 1,

                    lineCap: 'butt',

                    lineJoin: 'round',

                    dashArray: "",

                    border: {

                        width: 1,

                        color: 'transparent',

                        dashArray:""
                    },
                    width: 2,

                    marker: {

                        shape: 'circle',

                        imageUrl: "",

                        size: {

                            width: 6,

                            height: 6
                        },

                        visible: false,

                        opacity: 1,

                        fill: null,

                        border: {

                            color: 'white',

                            width: 3
                        },

                        dataLabel: {

                            visible: false,

                            angle: 0,

                            textMappingName:'',

                            verticalTextAlignment: 'center',

                            horizontalTextAlignment: 'center',

                            textPosition: 'top',

                            shape: 'none',

                            opacity: 1,

                            fill: null,

                            border: {

                                color: 'white',

                                width: 0.1
                            },

                            maximumLabelWidth: null,

                            enableWrap:false,

                            connectorLine: {

                                width: 0.5,

                                type: 'line',

                                color: null
                            },

                            offset: {

                                x: 0,

                                y:0
                            },

                            font: {

                                fontFamily: 'Segoe UI',

                                fontStyle: 'Normal',

                                fontWeight: 'Regular',

                                size: '11px',

                                opacity: 1
                            },

                            margin: {

                                left: 5,

                                top: 5,

                                bottom: 5,

                                right: 5
                            }

                        }
                    },

					bubbleOptions: {
					
						radiusMode: "minmax",
					
						minRadius: 1,
						
						maxRadius: 3
						
					},
					
                    trendlines: [{

                        visibility: "",
						
						visibleOnLegend: "visible",

                        type: "linear",

                        name: "Trendline",

                        fill: "",

                        width: 1,

                        opacity: 1,

                        dashArray: "",

                        forwardForecast: 0,

                        backwardForecast: 0,

                        polynomialOrder: 2,

                        period: 2,
						
						intercept: null,

                        tooltip:
                 {

                     visible: false,

                     format: null,

                     fill: null,

                     border: {

                         width: 1,

                         color: null
                     },

                     duration: '500ms',

                     enableAnimation: true,

                     opacity: 0.95,

                     font: {

                         fontFamily: 'Segoe UI',

                         fontStyle: 'Normal',

                         fontWeight: 'Regular',

                         size: '12px',

                         opacity: 1
                     }
                 }
                    }],


                    font: {

                        fontFamily: 'Segoe UI',

                        fontStyle: 'Normal',

                        fontWeight: 'Regular',

                        size: '12px',

                        color: '#707070',

                        opacity: 1
                    },
                    _isdesigntime: true

                }
            ],

            commonSeriesOptions: {
                dragSettings: {
                           enable: false,
                           type: 'xy'                      
                       },

                type: 'column',

                splitMode: 'value',

                splitValue: null,

                gapWidth: 50,

                pieOfPieCoefficient: 0.6,
				
				visibleOnLegend: "visible",

                enableAnimation: false,

                isClosed: true,

				 isTransposed:false,

                isStacking: false,

				columnWidth: 0.7,

                columnSpacing: 0,

                columnFacet: 'rectangle',

                drawType: 'line',

                doughnutCoefficient: 0.4,

                explodeOffset: 25,

                pyramidMode: 'linear',
				
				boxPlotMode : 'exclusive',
								
                funnelWidth: '11.6%',

                funnelHeight: '32.7%',

                positiveFill: null,
				
				showMedian:true,
				
				outlierSettings:{
						
						shape : 'circle',
						
						size:
						{
							width:6,
							
							height:6
						
						},
				},
				
				cornerRadius: {
					
					topLeft: 0,
					
					topRight: 0,
					
					bottomLeft: 0,
					
					bottomRight: 0
				},

                connectorLine: {

                    width: 1,

                    opacity: 1,

                    dashArray: null
                },

				 errorBar: {

                        visibility: "hidden",

                        mode: "vertical",

                        type:"fixedValue",
                        
                        horizontalErrorValue: 1,

                        verticalErrorValue: 3,

                        horizontalPositiveErrorValue: 1,

                        horizontalNegativeErrorValue: 1,

                        verticalPositiveErrorValue: 5,

                        verticalNegativeErrorValue: 5,

                        direction: "both",

                        cap:{
                            
                            visible:true,
                            
                            width: 1,

                            length: 20,

                        },


                        width: 1,

                        opacity: 1,

                    },
				
                highlightSettings: {

                    enable: false,

                    mode: 'series',

                    color: "",

                    opacity: 0.6,

                    border: {

                        color: "",

                        width: 2
                    },

                    pattern: 'none',

                    customPattern: ""
                },

                selectionSettings: {

                    type:'Single',

                    enable: false,

                    mode: 'series',

                    rangeType: 'xy',

                    color: "",

                    opacity: 0.6,

                    border: {

                        color: "",

                        width: 2
                    },

                    pattern: 'none',

                    customPattern: ""
                },
				
				emptyPointSettings: {

                        visible: true,

                        style: {

                            color: '',

                            border: {

                                color: '',

                                width: 1

                            }
                        
                        },

                        displayMode: 'gap'
                },

                labelPosition: 'inside',

                gapRatio: 0,

                pieCoefficient: 0.8,

                doughnutSize: 0.8,

                dataSource: null,

                xName: '',

                yName: '',

                pointColorMappingName:'',

                high: '',

                low: '',

                open: '',

                close: '',

                startAngle: null,

                endAngle: null,

                xAxisName: null,

                yAxisName: null,

                explodeAll: false,

                explode: false,

                explodeIndex: null,

                enableSmartLabels: null,

                tooltip: {

                    visible: false,

                    format: null,

                    template: null,

                    fill: null,

                    border: {

                        color: null,

                        width: 1
                    },

                    enableAnimation: true,

                    duration: '500ms',

                    opacity: 0.95
                },

                fill: null,

                opacity: 1,

                lineCap: 'butt',

                lineJoin: 'round',

                dashArray: "",

                border: {

                    color: 'transparent',

                    width: 1,

                    dashArray: ""
                },
                width: 2,

                marker:
                {

                    shape: 'circle',

                    imageUrl: "",

                    size: {

                        width: 6,

                        height: 6
                    },

                    visible: false,

                    opacity: 1,

                    fill: null,

                    border: {

                        color: 'white',

                        width: 3
                    },

                    dataLabel:
                    {

                        visible: false,

                        angle: 0,

                        textMappingName:'',

                        verticalTextAlignment: 'center',

                        horizontalTextAlignment: 'center',

                        textPosition: 'top',

                        shape: 'none',

                        maximumLabelWidth: null,

                        enableWrap:false,

                        opacity: 1,

                        fill: null,

                        border: {

                            color: 'white',

                            width: 0.1
                        },

                        offset: {

                            x: 0,

                            y: 0
                        },

                        connectorLine:
                        {

                            width: 0.5,

                            type: 'line'
                        },

                        font:
                        {

                            fontFamily: 'Segoe UI',

                            fontStyle: 'Normal',

                            fontWeight: 'Regular',

                            size: '11px',

                            opacity: 1
                        },

                        margin:
                        {

                            left: 5,

                            top: 5,

                            bottom: 5,

                            right: 5
                        }
                    }
                },
				
				bubbleOptions: {
				
					radiusMode: "minmax",
					
					minRadius: 1,
						
					maxRadius: 3
						
				},
					
                trendlines: [{

                    visibility: "",
					
					visibleOnLegend: "visible",

                    type: "linear",

                    name: "Trendline",

                    fill: "",

                    width: 1,

                    opacity: 1,

                    dashArray: "",

                    forwardForecast: 0,

                    backwardForecast: 0,

                    polynomialOrder: 2,

                    period: 2,
					
					intercept: null,

                    tooltip:
                 {

                     visible: false,

                     format: null,

                     fill: null,

                     border: {

                         width: 1,

                         color: null
                     },

                     duration: '500ms',

                     enableAnimation: true,

                     opacity: 0.95,

                     font: {

                         fontFamily: 'Segoe UI',

                         fontStyle: 'Normal',

                         fontWeight: 'Regular',

                         size: '12px',

                         opacity: 1
                     }
                 }
                }],

                font: {

                    fontFamily: 'Segoe UI',

                    fontStyle: 'Normal',

                    fontWeight: 'Regular',

                    size: '12px',

                    color: '#707070',

                    opacity: 1
                }
            },

            crosshair:
            {
				line:{
					
					color: 'black',
					
					width: 1
				},
                marker:
                {

                    visible: true,

                    size:
                    {

                        width: 10,

                        height: 10
                    },

                    opacity: 1,

                    border:
                    {

                        width: 3
                    }
                },

                visible: false,

                type: "crosshair",

                trackballTooltipSettings: {

                    fill: null,

                    mode:"float",

                    border: {

                        width: null,

                        color: null,

                    },

                    rx: 3,

                    ry: 3,

                    opacity:1,
                }
            },


            pointStyle:
            {
                lineCap: 'butt', lineJoin: 'round', opacity: 1, interior: null, borderColor: null, borderWidth: 1
            },
            textStyle:
            {
                marker: { textAlignment: 'center', textPosition: 'top' },
                font: { fontFamily: 'Segoe UI', fontStyle: 'Normal', fontWeight: 'Regular', size: '12px', color: '#707070', opacity: 1 }
            },
            symbolShape: {
                None: 0,
                LeftArrow: 1,
                RightArrow: 2,
                Circle: 3,
                Cross: 4,
                HorizLine: 5,
                VertLine: 6,
                Diamond: 7,
                Rectangle: 8,
                Triangle: 9,
                InvertedTriangle: 10,
                Hexagon: 11,
                Pentagon: 12,
                Star: 13,
                Ellipse: 14,
                Wedge: 15,
                Trapezoid: 16,
                UpArrow: 17,
                DownArrow: 18,
                Image: 19,
                SeriesType: 20

            },
            initSeriesRender: true,

            theme: "flatlight",

            canResize: false,

            isResponsive: false,

            enable3D: false,

            enableRotation: false,

            sideBySideSeriesPlacement: null,

            perspectiveAngle: 90,

            rotation: 0,

            tilt: 0,

            wallSize: 2,

            depth: 100,

            enableCanvasRendering: false,
			
			selectedDataPointIndexes: [],

			exportSettings: {

                type: "png",

                fileName: "Chart",

                orientation: "portrait",

                angle: 0,

                mode: "client",

                action: "",
				
				multipleExport: false
            },
			
            zooming:
            {

                enable: false,

                enableScrollbar : false,

                type: 'x,y',

                enablePinching: true,

                enableMouseWheel: false,

                enableDeferredZoom: false,

                toolbarItems: ["zoomIn", "zoomOut", "zoom", "pan", "reset"]
            },
            type: 'x,y',

            locale: null,

            xZoomFactor: 1,

            yZoomFactor: 1,

            xZoomPosition: 0,

            yZoomPosition: 0,

            load: "",

            axesLabelRendering: "",

            axesRangeCalculate: "",

            axesTitleRendering: "",

            dragStart: "",
            
            dragging: "",
            
            dragEnd:"",

            chartAreaBoundsCalculate: "",

            legendItemRendering: "",

            legendBoundsCalculate: "",

            preRender: "",

            seriesRendering: "",


            trendlineRendering: "",

            symbolRendering: "",

            titleRendering: "",
            subtitleRendering: "",

            axesLabelsInitialize: "",

            pointRegionClick: "",

            seriesRegionClick: "",

            annotationClick:"",
 
			 axisLabelClick:"",

			 chartClick: "",

			 scrollStart: "",

			 scrollEnd: "",

            scrollChanged: "",

            chartDoubleClick:"",

            pointRegionMouseMove: "",

            legendItemClick: "",

            axisLabelMouseMove: "",

            chartMouseMove: "",

            legendItemMouseMove: "",

            chartMouseLeave: "",

            displayTextRendering: "",

            toolTipInitialize: "",

            trackAxisToolTip: "",

            trackToolTip: "",

            animationComplete: "",

            zoomed:"",

            destroy: "",

            create: "",

            beforeResize: "",

            afterResize: "",

            rangeSelected: "",
			
			multiLevelLabelClick: "",
			
			multiLevelLabelRendering: "",

            margin: { left: 10, right: 10, top: 10, bottom: 10 },
            size: { width: null, height: null },
            elementSpacing: 10,

            dateStart: 25568.791666666668

        },

        dataTypes: {
            commonSeriesOptions: { dataSource: "data" },
            axes: "array",
            series: "array",
            annotations: "array",
            indicators: "array",
            seriesColors: "array",
            palette: "array",
            rowDefinitions: "array",
            columnDefinitions: "array",
            seriesBorderColors: "array",
            pointColors: "array",
            pointBorderColors: "array",
            initSeriesRender: "boolean",
            theme: "enum",
            canResize: "boolean",
            isResponsive:"boolean",
            elementSpacing: "number",
            primaryXAxis: {
                labels: "array",
                multiLevelLabels: "array",
                stripLine: "array",
                orientation: "enum",
                rangePadding: "enum",
                labelPlacement: "enum",
                tickLinesPosition: "enum",
                labelPosition: "enum",
                opposedPosition: "boolean",
                zoomFactor: "number",
                zoomPosition: "number",                 
                showNextToAxisLine: "boolean"
            },
            primaryYAxis: {
                labels: "array",
                multiLevelLabels: "array",
                stripLine: "array",
                orientation: "enum",
                rangePadding: "enum",
                labelPlacement: "enum",
                opposedPosition: "boolean",
                zoomFactor: "number",
                zoomPosition: "number"               
            },
            legend: {
                textOverflow:"enum",
                shape: "enum",
                alignment: "enum",
                position: "enum",
                itemPadding: "number"
            },
			exportSettings: {
                type: "string",
                fileName: "string",
                orientation: "enum",
                angle: "number",
                mode: "enum",
                action: "string",
				multipleExport: "boolean"
            },
            zooming: {
                enable: "boolean",
                type: "string",
                enableMouseWheel: "boolean",
                toolbarItems: "array",
                enableScrollbar: "boolean"
            },
            size: {
                width: "string",
                height: "string"
            }

        },

        observables: ["xZoomFactor", "yZoomFactor", "xZoomPosition", "yZoomPosition"],

        _tags: [{
            tag: "series",
            attr: ["xAxisName", "yAxisName", "zOrder", "endAngle", "startAngle", "explodeIndex", "labelPosition", "xName", "yName","pointColorMappingName", "pyramidMode","boxPlotMode","showMedian",
                   "pieCoefficient", "explodeAll", "explodeOffset", "funnelWidth","columnFacet", "funnelHeight", "gapRatio", "isClosed","isTransposed", 
                   "isStacking", "bearFillColor", "bullFillColor", "dataSource", "enableAnimation", "doughnutCoefficient", "doughnutSize",
                   "enableSmartLabels", "drawType", "dashArray", "visibleOnLegend", "columnSpacing", "columnWidth", "drawType", "positiveFill", "explodeIndex", "cornerRadius",
                   "lineCap", "lineJoin", "highlightSettings.enable", "highlightSettings.mode", "highlightSettings.pattern", "highlightSettings.color", "highlightSettings.opacity",
                   "highlightSettings.customPattern", "highlightSettings.border.color", "highlightSettings.border.width", "selectionSettings.enable", "selectionSettings.mode", "selectionSettings.pattern",
                   "selectionSettings.color", "selectionSettings.opacity", "selectionSettings.customPattern", "selectionSettings.type", "selectionSettings.rangeType",
                   "selectionSettings.border.width", "selectionSettings.border.color", "dragSettings.enable", "dragSettings.type",
                   "connectorLine.width", "connectorLine.opacity", "connectorLine.dashArray", "cornerRadius.topLeft", "cornerRadius.topRight", "cornerRadius.bottomLeft", "cornerRadius.bottomRight",
                   "errorBar.visibility", "errorBar.mode", "errorBar.type", "errorBar.horizontalErrorValue", "errorBar.verticalErrorValue", "errorBar.horizontalPositiveErrorValue",
                   "errorBar.horizontalNegativeErrorValue", "errorBar.verticalPositiveErrorValue", "errorBar.verticalNegativeErrorValue", "errorBar.direction",
                   "errorBar.cap.visible", "errorBar.cap.width", "errorBar.cap.length", "errorBar.width", "errorBar.opacity", "emptyPointSettings.visible",
                   "emptyPointSettings.style.color", "emptyPointSettings.style.border.color", "emptyPointSettings.style.border.width", "emptyPointSettings.displayMode",
				   "bubbleOptions.minRadius", "bubbleOptions.maxRadius", "bubbleOptions.radiusMode",
                   "tooltip.visible", "tooltip.format", "tooltip.template", "tooltip.fill", "tooltip.border.width", "tooltip.border.color", "tooltip.enableAnimation", "tooltip.duration",
                   "tooltip.opacity", "tooltip.font.size", "tooltip.font.opacity", "tooltip.font.fontFamily", "tooltip.font.fontStyle", "tooltip.font.fontWeight", "tooltip.font.color", "border.width", "border.color", "border.dashArray", "marker.shape", "marker.imageUrl", "marker.size.width", "marker.size.height",
                   "marker.visible", "marker.opacity", "marker.fill", "marker.border.color", "marker.border.width", "marker.dataLabel.visible", "marker.dataLabel.angle",
                   "marker.dataLabel.template", "marker.dataLabel.textMappingName", "marker.dataLabel.verticalTextAlignment", "marker.dataLabel.horizontalTextAlignment", "marker.dataLabel.textPosition", "marker.dataLabel.shape",
                   "marker.dataLabel.opacity", "marker.dataLabel.fill", "marker.dataLabel.border.color", "marker.dataLabel.border.width", "marker.dataLabel.maximumLabelWidth", "marker.dataLabel.enableWrap",
                   "marker.dataLabel.connectorLine.width", "marker.dataLabel.connectorLine.type", "marker.dataLabel.connectorLine.color", "marker.dataLabel.offset", "marker.dataLabel.offset.x", "marker.dataLabel.offset.y",
                   "marker.dataLabel.font.size", "marker.dataLabel.font.color", "marker.dataLabel.font.opacity", "marker.dataLabel.font.fontFamily", "marker.dataLabel.font.fontStyle", "marker.dataLabel.font.fontWeight",
                   "marker.dataLabel.margin", "marker.dataLabel.margin.left", "marker.dataLabel.margin.top", "marker.dataLabel.margin.bottom", "marker.dataLabel.margin.right",
                   "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "font.color",
                   [
				     {
				         tag: "trendlines", attr: ["visibility", "visibilityOnLegend", "dashArray", "forewardForecast", "backwardForecast", "polynomialOrder",
                         "tooltip.visible", "tooltip.format", "tooltip.fill", "tooltip.border.width", "tooltip.border.color", "tooltip.enableAnimation", "tooltip.duration",
                        "tooltip.opacity", "tooltip.font.size", "tooltip.font.opacity", "tooltip.font.fontFamily", "tooltip.font.fontStyle", "tooltip.font.fontWeight", "tooltip.font.color",
				         ], singular: "trendline"
				     }
                   ],
			       [
				     {
				         tag: "points", attr: ["x", "y", "text", "textMappingName", "isEmpty", "fill", "visible"], singular: "points"
				     }
			       ]

            ],
            singular: "series"
        }, {
            tag: "axes",
            attr: ["columnIndex", "rowIndex", "desiredIntervals", "isIndexed", "labelPlacement", "edgeLabelPlacement", "intervalType", "labelFormat", "labelPosition", "labelRotation", "logBase",
                "labelIntersectAction", "opposedPosition", "plotOffset", "rangePadding", "roundingPlaces", "valueType", "zoomFactor", "zoomPosition", "orientation",
                "crossesAt", "crossesInAxis", "scrollbarSettings.visible", "scrollbarSettings.canResize", "scrollbarSettings.range.min", "scrollbarSettings.range.max", "scrollbarSettings.pointsLength",
                "range.min", "range.max", "range.interval", "tickLinesPosition", "alternateGridBand.odd.fill", "alternateGridBand.odd.opacity", "alternateGridBand.even.fill", "alternateGridBand.even.opacity",
                "enableAutoIntervalOnZooming", "majorGridLines.width", "majorGridLines.dashArray", "majorGridLines.visible", "majorGridLines.opacity", "majorTickLines.width", "majorTickLines.size", "majorTickLines.visible",
                "minorGridLines.width", "minorGridLines.dashArray", "minorGridLines.visible", "minorTickLines.width", "minorTickLines.size", "minorTickLines.visible", "labelBorder.width", "minorTicksPerInterval",
                "columnSpan", "crosshairLabel.visible", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "isInversed", "enableTrim", "maximumLabelWidth",
                "axisLine.visible", "axisLine.width", "axisLine.dashArray", "axisLine.offset", "maximumLabels", "title.text", "title.visible", "title.enableTrim", "title.offset",
                "title.alignment", "title.position", "title.maximumTitleWidth", "title.font.size", "title.font.opacity", "title.font.fontFamily", "title.font.fontStyle", "title.font.fontWeight",
                "additionalPadding", "showNextToAxisLine",
              [
                {
                    tag: "stripLine", attr: ["borderColor", "startFromAxis", "zIndex", "textAlignment", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "font.color"],
                    singular: "stripLine"
                }
              ],
               [
                {
                    tag: "multiLevelLabels", attr: ["textOverflow", "maximumTextWidth", "textAlignment", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "border.type", "border.width"],
                    singular: "multiLevelLabel"
                }
               ],
            ],
            singular: "axis"
        },
              {
                  tag: "primaryXAxis.stripLine",
                  attr: ["borderColor", "startFromAxis", "zIndex", "textAlignment", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "font.color"],
                  singular: "primaryXAxis.stripLine"
              },
            {
                tag: "primaryYAxis.stripLine",
                attr: ["borderColor", "startFromAxis", "zIndex", "textAlignment", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "font.color"],
                singular: "primaryYAxis.stripLine"
            },
             {
                 tag: "primaryXAxis.multiLevelLabels",
                 attr: ["textOverflow", "maximumTextWidth", "textAlignment", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "border.type", "border.width"],
                 singular: "primaryXAxis.multiLevelLabel"
             },
              {
                  tag: "primaryYAxis.multiLevelLabels",
                  attr: ["textOverflow", "maximumTextWidth", "textAlignment", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "border.type", "border.width"],
                  singular: "primaryYAxis.multiLevelLabel"
              },
           {
               tag: "indicators",
               attr: ["seriesName", "xName", "xAxisName", "macdType", "shortPeriod", "longPeriod", "enableAnimation",
                   "yAxisName", "standardDeviations", "kPeriod", "dPeriod", "periodLine.fill", "periodLine.width", "lowerLine.fill",
                   "lowerLine.width", "upperLine.fill", "upperLine.width", "macdLine.fill", "macdLine.width", "histogram.fill", "histogram.opacity",
                   "histogram.border.color", "histogram.border.width", "font.size", "font.opacity", "font.fontFamily", "font.fontStyle", "font.fontWeight", "font.color",
                   "tooltip.visible", "tooltip.format", "tooltip.fill", "tooltip.border.width", "tooltip.border.color", "tooltip.enableAnimation", "tooltip.duration",
                   "tooltip.opacity",
                  [
                    {
                        tag: "points", attr: []
                    }
                  ]
               ],
               singular: "indicator"
           },
          {
              tag: "annotations",
              attr: ["coordinateUnit", "verticalAlignment", "horizontalAlignment", "xAxisName", "yAxisName", "margin.left", "margin.right", "margin.top", "margin.bottom"],
              singular: "annotation"
          },
          {
              tag: "rowDefinitions",
              attr: ["rowHeight", "lineColor", "lineWidth"],
              singular: "rowDefinition"
          },
          {
              tag: "columnDefinitions",
              attr: ["columnWidth", "lineColor", "lineWidth"],
              singular: "columnDefinition"
          },
        ],
        _xZoomFactor: ej.util.valueFunction("xZoomFactor"),
        _yZoomFactor: ej.util.valueFunction("yZoomFactor"),
        _xZoomPosition: ej.util.valueFunction("xZoomPosition"),
        _yZoomPosition: ej.util.valueFunction("yZoomPosition"),


        _init: function () {

            this._renderSfChart();

        },
        _destroy: function () {
            $('#template_group_' + this._id).remove();
            $("#annotation_group_" + this._id).remove();
            $(this.element).removeClass("e-chart e-js").find("#" + this.svgObject.id).remove();
            $(this.element).removeClass("e-chart e-js").find("#legend_" + this.svgObject.id).remove();
        },

        _series: function (index, property, value, old) {
            this.redraw();
            this._trigger("refresh");
        },
        _series_points: function (index, property, value, old) {
            this.redraw();
            this._trigger("refresh");
        },
        _primaryXAxis_stripLine: function (index, property, value, old) {
            this.redraw();
            this._trigger("refresh");
        },
        _primaryYAxis_stripLine: function (index, property, value, old) {
            this.redraw();
            this._trigger("refresh");
        },
        _axes: function (index, property, value, old) {
            this.redraw();
            this._trigger("refresh");
        },
        _axes_stripLine: function (index, property, value, old) {
            this.redraw();
            this._trigger("refresh");
        },

        _ignoreOnExport: ["dataSource"],


        _removeZoomkit: function () {
            if (this.model.zooming.enable) {
                $("[id^=" + this._id + "_][id$=" + "_ResetZoom" + "]").remove();
                $("[id^=" + this._id + "_][id$=" + "_PanBtn" + "]").remove();
                $("[id^=" + this._id + "_][id$=" + "_ZoomBtn" + "]").remove();
                $("[id^=" + this._id + "_][id$=" + "_ZoomInBtn" + "]").remove();
                $("[id^=" + this._id + "_][id$=" + "_ZoomOutBtn" + "]").remove();
            }
        },
		
		//to create a new canvas element to export and print
		getCanvasElement: function(id){
			 var chart,
			 printId = $("#" + id),
			 exportPrintCanvas = document.createElement('canvas'),
			 expCtx = exportPrintCanvas.getContext("2d"), 
			 chartWidth = $("#" + id + "_canvas").width(),
             chartHeight = $("#" +id + "_canvas").height();
			 exportPrintCanvas.setAttribute('width', chartWidth);
             exportPrintCanvas.setAttribute('height', chartHeight);
			 chart = $("#" + id + '_canvas')[0]; 
			 expCtx.drawImage(chart,0,0,chartWidth,chartHeight); 
				
			return { canvasContainer : exportPrintCanvas , canvasArea : expCtx ,width : chartWidth ,height : chartHeight  }; 
			
		},
		// export and print the svg element
		getSVGElement: function(id){
		    var chartWidthSVG = $("#" + id + "_svg").width(),
			chartHeightSVG = $("#" + id + "_svg").height(),
			svgChart = document.getElementById( id + "_svg"),
			containerSVG =  $('<div>').append($(svgChart).clone()).html(),
			legendChart = document.getElementById("legend_" + id + "_svg"),	
			position = $("#legend_" + id).position(),
			element = $("#" + id + "_svg_Legend").attr('transform', "translate(" + position.left + "," + position.top + ")"),
			containerLegendSVG =  $('<div>').append($(legendChart).clone()).html();
		
			return{chartSVG : containerSVG ,legendChartSVG : containerLegendSVG ,width : chartWidthSVG ,height : chartHeightSVG };
		},
		
		print: function () {		    
			//declaration
		    var contentSVG, Id, svgID, canvasElement, chartObj, printId, printCtxAnnot, legend, selectionChart, selectionLegendChart,
			selectionChartSVG, legendChartSVG, annotationChartCanvas, canvasChart = [], writeCode = [], containerselectionChartSVG,
			containerSelectionLegendSVG, legendPos, annotationChartSVG, containerAnnotationChartSVG,
			serIndex = this.model.series.length, scrollbar, TDStyle = "", oImg = "", chartHeight = 0, chartDistance = 50;
			for(var i=0;i<arguments.length;i++) {
			
				printId = $("#" + arguments[i]);
				Id = arguments[i];

				//to check whether the div contains chart element
				if (printId.hasClass("e-datavisualization-chart")) {
				    chartObj = printId.ejChart("instance");
				    contentSVG = "<html> <div style='position:relative; left:0px; top:" + chartHeight + "px'>";
				    scrollbar = "";
				    svgID = chartObj.svgObject.id;
				    
				    chartHeight = $("#" + svgID).height() + chartDistance;

				    if ($("#axisScrollbar_" + Id)[0])
				        scrollbar = $("#axisScrollbar_" + Id)[0].innerHTML;

				    var zoomButton = ["ResetZoom", "PanBtn", "ZoomBtn", "ZoomOutBtn", "ZoomInBtn"], zoomBtnObj = [], zoomToolbarID, btnCount = 5;
				    for (var l = 0; l < btnCount; l++) {
				        zoomToolbarID = "#" + svgID + "_" + zoomButton[l];
				        if ($(zoomToolbarID)[0]) {
				            zoomBtnObj.push($(zoomToolbarID));
				            //Remove zoomButtons on printing
				            $(zoomToolbarID).remove();
				        }
				    }

				    if (chartObj.model.enableCanvasRendering == true) { //to check the chart to render in canvas
				        canvasElement = this.getCanvasElement(Id);
				        
				        //to find the lengend position  
				        legendPos = chartObj.model.LegendBounds;

				        oImg = document.createElement("img");
				        oImg.setAttribute('src', $('#legend_' + Id + '_canvas')[0].toDataURL());
				        $("#legend_Scroller" + Id).prepend(oImg);
				        contentSVG += document.getElementById('chartContainer_' + Id).outerHTML;
				        $(oImg).remove();
				        oImg = "";

				        var mode;
				        //selection chart to print in canvas
				        for (var index = 0; index < serIndex; index++) {
				            mode = chartObj.model.series[index].selectionSettings.mode.toLowerCase();
				            if (chartObj.model.AreaType != "none") {
				                if (mode == "series") {
				                    if ($(printId).find("#" + Id + "_Selection_series" + index + "_canvas").length > 0) {
				                        selectionChart = $("#" + Id + "_Selection_series" + index + "_canvas")[0];
				                        canvasElement.canvasArea.drawImage(selectionChart, 0, 0, canvasElement.width, canvasElement.height);
				                    }
				                    if ($(printId).find("#" + Id + "_Selection_Legend" + index + "_canvas").length > 0) {
				                        selectionLegendChart = $("#" + Id + "_Selection_Legend" + index + "_canvas")[0];
				                        oImg = "<img style='position:absolute;left:0px;' src='" + selectionLegendChart.toDataURL() + "'/>";
				                    }
				                } else if (mode == "point") {
				                    var selectedPoints = chartObj.model.selectedDataPointIndexes;
				                    for (var l = 0; l < selectedPoints.length; l++) {
				                        if (selectedPoints[l].seriesIndex == index) {
				                            if ($(printId).find("#" + Id + "_Selection_series" + index + "_point_" + selectedPoints[l].pointIndex + "_canvas").length > 0) {
				                                selectionChart = $("#" + Id + "_Selection_series" + index + "_point_" + selectedPoints[l].pointIndex + "_canvas")[0];
				                                canvasElement.canvasArea.drawImage(selectionChart, 0, 0, canvasElement.width, canvasElement.height);
				                            }
				                        }
				                    }
				                    if ($(printId).find("#" + Id + "_Selection_Legend" + index + "_canvas").length > 0) {
				                        selectionLegendChart = $("#" + Id + "_Selection_Legend" + index + "_canvas")[0];
				                        oImg = "<img style='position:absolute;left:0px;' src='" + selectionLegendChart.toDataURL() + "'/>";
				                    }
				                } else {
				                    var selectedPoints = chartObj.model.selectedDataPointIndexes;
				                    for (var l = 0; l < selectedPoints.length; l++) {
				                        if (selectedPoints[l].seriesIndex == index) {
				                            if ($(printId).find("#" + Id + "_Selection_Cluster_point_" + selectedPoints[l].pointIndex + "_canvas").length > 0) {
				                                selectionChart = $("#" + Id + "_Selection_Cluster_point_" + selectedPoints[l].pointIndex + "_canvas")[0];
				                                canvasElement.canvasArea.drawImage(selectionChart, 0, 0, canvasElement.width, canvasElement.height);
				                            }
				                        }
				                    }
				                    if ($(printId).find("#" + Id + "_SelectionCluster_Legend" + index + "_canvas").length > 0) {
				                        selectionLegendChart = $("#" + Id + "_SelectionCluster_Legend" + index + "_canvas")[0];
				                        oImg = "<img style='position:absolute;left:0px;' src='" + selectionLegendChart.toDataURL() + "'/>";
				                    }
				                }
				            } else {
				                var selectedPoints = chartObj.model.selectedDataPointIndexes;
				                for (var l = 0; l < selectedPoints.length; l++) {
				                    if (selectedPoints[l].seriesIndex == index) {
				                        if ($('#' + Id + '_Selection_series' + index + "_point_" + selectedPoints[l].pointIndex + "_canvas").length > 0) {
				                            selectionChart = document.getElementById(Id + '_Selection_series' + index + "_point_" + selectedPoints[l].pointIndex + "_canvas");
				                            canvasElement.canvasArea.drawImage(selectionChart, 0, 0, canvasElement.width, canvasElement.height);
				                            if ($('#' +Id + "_Selection_Legend" + selectedPoints[l].pointIndex + "_canvas").length > 0) {
				                                selectionLegendChart = document.getElementById(Id + "_Selection_Legend" + selectedPoints[l].pointIndex + "_canvas");
				                                oImg = "<img style='position:absolute;left:0px;' src='" + selectionLegendChart.toDataURL() + "'/>";
				                            }
				                        }
				                    }
				                }
				            }
				        }
				        canvasElement.canvasArea.save();
				        //to store the chart canvas element
				        canvasChart.push(canvasElement.canvasContainer);
				    }
				        //to check the chart to render in svg
				    else {
				        var printSvgElement = this.getSVGElement(Id);

				        $("#" + Id + "_svg_Legend").removeAttr("transform");
				        contentSVG += $("#chartContainer_" + Id)[0].outerHTML;

				        //selection chart to print in svg
				        if (!chartObj.model.enable3D) {
				            var mode;
				            for (var index = 0; index < serIndex; index++) {
				                mode = chartObj.model.series[index].selectionSettings.mode.toLowerCase();
				                if (chartObj.model.AreaType != "none") {
				                    if (mode != "cluster") {
				                        if ($('#' + Id + 'SelectionSegmentseries' + index).length > 0) {
				                            selectionChartSVG = document.getElementById(Id + "SelectionSegmentseries" + index);
				                            containerselectionChartSVG = $('<div>').append($(selectionChartSVG).clone()).html();
				                            legendChartSVG = document.getElementById(Id + "SelectionLegendSegmentseries" + index);
				                            containerSelectionLegendSVG = $('<div>').append($(legendChartSVG).clone()).html();
				                            contentSVG += containerselectionChartSVG.toString() + containerSelectionLegendSVG.toString();
				                        }
				                    } else {
				                        if ($('#' + Id + 'SelectionSegmentClusterSeries' + index).length > 0) {
				                            selectionChartSVG = document.getElementById(Id + "SelectionSegmentClusterSeries" + index);
				                            containerselectionChartSVG = $('<div>').append($(selectionChartSVG).clone()).html();
				                            legendChartSVG = document.getElementById(Id + "SelectionLegendSegmentClusterSeries" + index);
				                            containerSelectionLegendSVG = $('<div>').append($(legendChartSVG).clone()).html();
				                            contentSVG += containerselectionChartSVG.toString() + containerSelectionLegendSVG.toString();
				                        }
				                    }
				                } else {
				                    var selectedPoints = chartObj.model.selectedDataPointIndexes;
				                    for (var l = 0; l < selectedPoints.length; l++) {
				                        if (selectedPoints[l].seriesIndex == index) {
				                            if ($('#' + Id + 'SelectionSegmentseries' + index + "Point" + selectedPoints[l].pointIndex).length > 0) {
				                                selectionChartSVG = document.getElementById(Id + 'SelectionSegmentseries' + index + "Point" + selectedPoints[l].pointIndex);
				                                containerselectionChartSVG = $('<div>').append($(selectionChartSVG).clone()).html();
				                                legendChartSVG = document.getElementById(Id + "SelectionLegendSegmentseries" + index + "Point" + selectedPoints[l].pointIndex);
				                                containerSelectionLegendSVG = $('<div>').append($(legendChartSVG).clone()).html();
				                                contentSVG += containerselectionChartSVG.toString() + containerSelectionLegendSVG.toString();
				                            }
				                        }
				                    }
				                }
				            }
				        } else {
				            TDStyle = "";
				            for (var index = 0; index < serIndex; index++) {
				                if ($("#Selectionseries" + index + "Segmentseries" + index).length > 0) {
				                    TDStyle += $("#Selectionseries" + index + "Segmentseries" + index)[0].outerHTML;
				                }
				            }
				            contentSVG += TDStyle;
				        }

				        //draw background image for chart
				        if (chartObj.model.backGroundImageUrl != null) {
				            var img = new Image();
				            img.src = chartObj.model.backGroundImageUrl;
				            var canvasObj = document.createElement('canvas');
				            var ctx = canvasObj.getContext("2d");
				            canvasObj.setAttribute('width', printSvgElement.width);
				            canvasObj.setAttribute('height', printSvgElement.height);
				            ctx.drawImage(img, 0, 0, printSvgElement.width, printSvgElement.height);
				            contentSVG += "<img src='" + canvasObj.toDataURL() + "'/>";
				        }
				        contentSVG += '<svg xmlns="http://www.w3.org/2000/svg" style="left:0px; top:0px; position:absolute;" width="' + printSvgElement.width + '" height="' + printSvgElement.height + '" >';
				        contentSVG += printSvgElement.chartSVG.toString() + " </svg>";

				        //Add zooming scrollbar with chart
				        contentSVG += scrollbar + "</div></html>";

				        //to store the chart svg element
				        writeCode.push(contentSVG);
				    }

				    for (var l = 0; l < zoomBtnObj.length; l++) {
				        //push zoomButtons again
				        $("#chartContainer_" + Id).append(zoomBtnObj[l]);
				    }
				}
				//the div does not contains the chart element
				else {
				    contentSVG = "<html>";
				    contentSVG += document.getElementById(arguments[i]).innerHTML;
				    contentSVG += "</html>";
				    //to store the div id elements
				    writeCode.push(contentSVG);
				}
			}
			//to print the chart in a new window
			var win = window.open();
			for (var s = 0; s < writeCode.length; s++)
			    win.document.write(writeCode[s]);
			//to open a print window for canvas element
			if (canvasChart.length > 0) {
			    var img = new Image();
			    for (var y = 0 ; y < canvasChart.length; y++) {
			        contentSVG += "<img src='" + canvasChart[y].toDataURL() + "'/>";
			        img.src = canvasChart[y].toDataURL();
			    }
			    contentSVG += oImg;
			    //Add zooming scrollbar with chart
			    contentSVG += scrollbar + "</div></html>";
			    img.onload = function () {
			        win.document.write(contentSVG);
			        contentSVG = "";
			        win.document.close();
			        win.focus();
			        win.print();
			        win.close();
			    }
			}
			    //to open a print window for svg element
			else if (writeCode.length > 0) {
			    contentSVG = "";
			    win.document.close();
			    win.focus();
			    win.print();
			    win.close();			    
			}
										
		},


        redraw: function (excludeDataUpdate, pinchPanning, target, isTouch) {
            if (this.model.enableCanvasRendering) {
                if (this.model.zooming.enable && this.svgRenderer.ctx)
                    this.svgRenderer.ctx.clearRect(0, 0, $("#" + this._id).width(), $("#" + this._id).height());
                else {
                    $(this.svgObject).remove();
                    var width = this.svgWidth;
                    $("#canvas_trackSymbol").remove();
                    $("#"+this._id+"_canvas_Tracker").remove();
                    $("#secondCanvas").remove();
                    this.svgRenderer = new ej.EjCanvasRender(this.element); // to create canvas container
                    this.svgRenderer.svgObj.height = ej.util.isNullOrUndefined(this.model.size.height) ? "450" : this.model.size.height;
                    this.svgRenderer.svgObj.width = ej.util.isNullOrUndefined(this.model.size.width) ? width : this.model.size.width;
                    this.svgObject = this.svgRenderer.svgObj;
                    var ctx = this.svgRenderer.svgObj.getContext("2d");

					$(this.scrollerContainer).remove();
                    $(this.legendSvgContainer).remove();
                    $(this.legendContainer).remove();
                    this.legendContainer = $("<div></div>").attr('id', "legend_" + this._id).css("height", "0px");
					this.scrollerContainer = $("<div></div>").attr('id', "legend_Scroller" + this._id).css("height", "0px");
                    this.legendSvgContainer = this.svgRenderer.createLegendCanvas(this.element); //creating new CANVAS element for legend
                    this.svgRenderer.append(this.legendSvgContainer, this.scrollerContainer);
					$(this.scrollerContainer).appendTo(this.legendContainer);
                    $(this.legendContainer).appendTo(this.chartContainer);
                }
            }
            else if ((this.svgObject.id).indexOf("_canvas") != -1) {
                this._removeZoomkit();
                $(this.svgObject).remove();
                this.svgRenderer = new ej.EjSvgRender(this.element);  // to create svg container
                this.svgObject = this.svgRenderer.svgObj;
                this.canvasX = this.canvasY = 0;

                $(this.scrollerContainer).remove();
                $(this.legendSvgContainer).remove();
                $(this.legendContainer).remove();
                this.legendContainer = $("<div></div>").attr('id', "legend_" + this._id).css("height", "0px");
                this.scrollerContainer = $("<div></div>").attr('id', "legend_Scroller" + this._id).css("height", "0px");
                this.legendSvgContainer = this.svgRenderer.createLegendSvg(this.element); //creating new SVG element for legend
                this.svgRenderer.append(this.legendSvgContainer, this.scrollerContainer);
                $(this.scrollerContainer).appendTo(this.legendContainer);
                $(this.legendContainer).appendTo(this.chartContainer);
            } else {
                if (!this.dragPoint || (!pinchPanning && (!this.panning || !target || this.scrollbarUpdate || (isTouch ||this.panning && this.model.browserInfo.name != "chrome")) || this.model.enable3D)) {
					$(this.svgObject).empty();  // using existing svg container
					$(this.legendSvgContainer).empty();
				}
				else
				{
				    var svg = this.svgObject;
				    this.chartUpdating = true;
				    if (!this.continuePinching && target) {
				        target.id = "";
				        target.setAttribute("opacity", 0);
				        svg.appendChild(target);
				        this.continuePinching = false;
				    }
				    while (svg.childNodes.length > 1)
				        svg.removeChild(svg.firstChild);

				    $(this.legendSvgContainer).empty();
				}
            }
            $("#annotation_group_" + this._id).remove();   // to remove annotation on redraw
            if (!excludeDataUpdate) {

                if (this.model.canResize || this.model.isResponsive)
                    this.bindResizeEvents();
                else
                    this.removeResizeEvents();
            }
            this.bindTo(excludeDataUpdate);
        },

          "export": function (type, action, multipleExport) {       // method to export chart
            var data,
            exporting = this.model.exportSettings,
            type = ej.util.isNullOrUndefined(type) ? exporting.type : type.toLowerCase(),
            action = ej.util.isNullOrUndefined(action) ? exporting.action : action.toLowerCase();

            if (type == "xlsx")
                this.excelExport(type, action, multipleExport);
            else if (type == "svg" || !this.model.enableCanvasRendering)
                data = this.svgExport();
            else
                data = this.imageExport();

            return data;
        },

         excelExport: function (type, action, multipleExport) {           // to export chart as excel
            var modelClone = $.extend(true, {}, this.model),
            exporting = this.model.exportSettings,
            multipleExport = ej.util.isNullOrUndefined(type) ? exporting.multipleExport : multipleExport,
            attr = { action: action, method: 'post' },
            form = ej.buildTag('form', "", null, attr),
            series, chartobj = this;
            modelClone.event = null; // event is not API and having circular structure object type

            if (this._ignoreOnExport) {
                series = modelClone.series;
                for (var j = 0; j < series.length; j++) {
                    delete series[j].dataSource;
                    delete series[j].query;
                    series[j].fill = jQuery.type(series[j].fill) == "array" ? series[j].fill[0].color : series[j].fill;
                }
            }
            if (ej.raiseWebFormsServerEvents){
                this.raiseWebServerEvents(JSON.stringify(modelClone), "excelExporting");
                this.raiseWebServerEvents(JSON.stringify(modelClone));
             }
            else {
                if (multipleExport) {
                    var chartObjectArray = {};
                    $('body').find('.e-datavisualization-chart').each(function (index, object) {
                        var chartObject = $(object).data('ejChart');
                        if (!ej.isNullOrUndefined(chartObject)) {
						    chartObject.model.event=null;
                            var modelClone = JSON.parse(JSON.stringify(chartObject.model));							
                            if (chartobj._ignoreOnExport) {
                                series = modelClone.series;
                                for (var j = 0; j < series.length; j++) {
                                    delete series[j].dataSource;
                                    delete series[j].query;
                                    series[j].fill = jQuery.type(series[j].fill) == "array" ? series[j].fill[0].color : series[j].fill;
                                }
                                chartObjectArray[index] = JSON.stringify(modelClone);
                                var inputAttr = { name: 'ChartModel', type: 'hidden', value: JSON.stringify(modelClone) }
                                var input = ej.buildTag('input', "", null, inputAttr);
                                form.append(input);
                            }
                        }
                    });
                }
                else {
                    var inputAttr = { name: 'ChartModel', type: 'hidden', value: JSON.stringify(modelClone) }
                    var input = ej.buildTag('input', "", null, inputAttr);
                    form.append(input);
                    form.append(this);
                }
                $('body').append(form);
                form.submit();
            }
            return true;
        },

        imageExport: function () {       // to export chart as image
            var modelClone = $.extend(true, {}, this.model);
			modelClone.event = null; // event is not API and having circular structure object type
            var Id = this._id,
            selectionChart = $('[id*=' + Id + '_Selection_' + ']'),
                legend = $('#legend_' + Id + '_canvas')[0],
            exporting = this.model.exportSettings,
            angle = exporting.angle,exportChart,exprtCtx,chartWidth,chartHeight,chart,
            legendPos = this.model.LegendBounds, containerStyle, i, dataURL,
			exportCanvas = this.getCanvasElement(Id);
            exportChart = exportCanvas.canvasContainer;
			exprtCtx = exportCanvas.canvasArea;
			chartWidth = exportCanvas.width;
			chartHeight = exportCanvas.height;
			chart = $("#" + Id + '_canvas')[0]; 
            exportChart.setAttribute('id', 'Export_' + Id);
            if (angle==0){
                legendPos = this.model.LegendBounds;
			if (legendPos.X && (legendPos.Width != 0 && legendPos.Height != 0))
                   exprtCtx.drawImage(legend, legendPos.X, legendPos.Y);
            } else if (angle == 90 || angle == -90) {
                 exportChart.setAttribute('width', chartHeight);
            exportChart.setAttribute('height', chartWidth);
            exprtCtx.save();
            exprtCtx.translate(chartHeight/2, chartWidth/2);
            exprtCtx.rotate(angle*Math.PI/180);
            exprtCtx.drawImage(chart,-chartWidth/2,- chartHeight/2);
            exprtCtx.restore();
            if (legendPos.X){
              exprtCtx.save();
              if (angle==90)
                exprtCtx.translate(chartHeight - legendPos.Y - legendPos.Height/2, chartWidth- legendPos.X - legendPos.Width/2); 
              else
                exprtCtx.translate(legendPos.Y + legendPos.Height/2, legendPos.X + legendPos.Width/2);
              exprtCtx.rotate(angle*Math.PI/180);
              exprtCtx.drawImage(legend, -legendPos.Width/2 , -legendPos.Height/2);
              exprtCtx.restore();
             }
            } else {
                exportChart.setAttribute('width', chartWidth);
                exportChart.setAttribute('height', chartHeight);
                exprtCtx.save();
                exprtCtx.translate(chartWidth, chartHeight);
                exprtCtx.rotate(180*Math.PI/180);
                exprtCtx.drawImage(chart,0,0);
                exprtCtx.restore();
                if (legendPos.X){
                  exprtCtx.save();
                  exprtCtx.translate(legendPos.X + legendPos.Width/2, chartHeight -legendPos.Y - legendPos.Height/2);
                  exprtCtx.rotate(angle*Math.PI/180);
                  exprtCtx.drawImage(legend, -legendPos.Width/2 , -legendPos.Height/2);
                  exprtCtx.restore();
                }
              }

             for (i = 0; i < selectionChart.length; i++) {       // export for selection
                containerStyle = document.getElementById(selectionChart[i].id).getBoundingClientRect();
                exprtCtx.drawImage(selectionChart[i], 0, 0);
            }
            dataURL = exporting.type == "jpg" ? exportChart.toDataURL("image/jpeg") : exportChart.toDataURL();
			if (exporting.mode == "client")                    // for client side
			    return exportChart;
            else if (ej.raiseWebFormsServerEvents)                            // for web forms
                this.raiseWebServerEvents(dataURL);
            else if (exporting.mode == "server") {                       // server side
                var attr, form, chartModel, input1, data, input2;
                attr = { action: exporting.action, method: 'post' };
                form = ej.buildTag('form', "", null, attr);
                chartModel = { name: 'ChartModel', type: 'hidden', value: JSON.stringify(modelClone) };
                input1 = ej.buildTag('input', "", null, chartModel);
				data = { name: 'Data', type: 'hidden', value: dataURL};
				input2 = ej.buildTag('input', "", null, data);
                form.append(input1).append(input2).append(this);
                $('body').append(form);
                form.submit();
            }
        },

        svgExport: function () {                   // to export chart as SVG
            var svgObj = this.svgObject.id,
            modelClone = $.extend(true, {}, this.model);
			modelClone.event = null; // event is not API and having circular structure object type
			var Id = this._id,
			exportChartSVG = this.getSVGElement(Id),
            exporting = this.model.exportSettings, angle = exporting.angle,chartHeight = exportChartSVG.height,
			svg = exportChartSVG.chartSVG,legend = exportChartSVG.legendChartSVG,chartWidth = exportChartSVG.width, 
            content= '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">';
            if (angle ==0)
                content = content + svg.toString() + legend.toString() + "</svg>";
            else if (angle == 90)
                content = content + '<g transform="translate('+ chartHeight + ',0) rotate(90 0 0)">' + svg.toString() + legend.toString() + "</g></svg>";
            else if (angle == -90)
                content = content + '<g transform="translate(0,'+ chartWidth + ') rotate(-90 0 0)">' + svg.toString() + legend.toString() + "</g></svg>";
            else
                content = content + '<g transform="translate('+ chartWidth + ',' + chartHeight + ') rotate(180 0 0)">' + svg.toString() + legend.toString() + "</g></svg>";
            content = encodeURIComponent(content);
            $("#" + svgObj + "_Legend").removeAttr("transform");
			if (exporting.mode == "client")            // for client side
			    return content;
            else if (ej.raiseWebFormsServerEvents)                               // for web forms
                this.raiseWebServerEvents(content);
            else if (exporting.mode == "server") {                         // server side
                var attr, form, inputAttr, input;
                attr = { action: exporting.action, method: 'post' };
                form = ej.buildTag('form', "", null, attr);
                chartModel = { name: 'ChartModel', type: 'hidden', value: JSON.stringify(modelClone) };
                input1 = ej.buildTag('input', "", null, chartModel);
                inputAttr = { name: 'Data', type: 'hidden', value: content };
                input = ej.buildTag('input', "", null, inputAttr);
                form.append(input).append(input1).append(this);
                $('body').append(form);
                form.submit();
            }
        },
        
		 raiseWebServerEvents: function (content, event) {             // to trigger server events in web forms
            var modelClone = $.extend(true, {}, this.model),
            exporting = this.model.exportSettings,
            event = ej.util.isNullOrUndefined(event) ? "exporting" : event;
            args = { model: modelClone, originalEventType: event },
            clientArgs = { Data: content, Format: exporting.type, Orientation: exporting.orientation, FileName: exporting.fileName };
            ej.raiseWebFormsServerEvents(event, args, clientArgs);
        },
		
        animate: function (options) {
            if (!options) { // Animate the entire series and indicators "previous behavior"
                var series = this.model.series;
                for (var i = 0; i < series.length; i++) {
                    series[i]._animatedSeries = false;
                    series[i]._animatedTrendline = false;
                    series[i].AnimationComplete = false; //pie doughnut animation with datalabel
                }
                var indicators = this.model.indicators;
                for (var j = 0; j < indicators.length; j++) {
                    indicators[j]._animatedSeries = false;
                    indicators[j]._animatedTrendline = false;
                }
            } else if (options.constructor === Array) { // Animate array of series
                for (var i = 0; i < options.length; i++) {
                    options[i]._animatedSeries = false;
                    options[i]._animatedTrendline = false;
                    options[i].AnimationComplete = false; //pie doughnut animation with datalabel
                }
            } else {   // Animate the specific series
                options._animatedSeries = false;
                options._animatedTrendline = false;
                options.AnimationComplete = false;  //pie doughnut animation with datalabel
            }
            this.redraw();
        },


        _setModel: function (options) {
            var series, axes;
            for (var prop in options) {
                this.disableAnimation();
                switch (prop) {
                    case "theme":
                        this.model._themeChanged = true;
                        this.model.theme = options[prop];
                        this.setTheme(ej.EjSvgRender.themes, this.model.theme);
                        $.extend(true, this.model.primaryXAxis, ej.EjSvgRender.themes[this.model.theme].primaryXAxis);
                        $.extend(true, this.model.primaryYAxis, ej.EjSvgRender.themes[this.model.theme].primaryYAxis);
                        for (var k = 0; k < this.model.axes.length; k++) {
                            if (this.model.axes[k].orientation && this.model.axes[k].orientation.toLowerCase() == "horizontal")
                                $.extend(true, this.model.axes[k], ej.EjSvgRender.themes[this.model.theme].secondaryX);
                            else
                                $.extend(true, this.model.axes[k], ej.EjSvgRender.themes[this.model.theme].secondaryY);
                        }
                        for (var l = 0; l < this.model.series.length; l++) {
                            $.extend(true, this.model.series[l], ej.EjSvgRender.themes[this.model.theme].commonSeriesOptions);
                        }
                        break;
                    case "commonSeriesOptions":
                        for (var i = 0; i < this.model.series.length; i++)
						{
							if (options[prop].dataSource)
								this.model.series[i].dataSource = null;
							$.extend(true, this.model.series[i], {}, options[prop]);
						}
                        break;
                    case "series":
                        series = this.model.series;
						 for (var i = 0; i < series.length; i++) {
                            if (options[prop][i].dataSource) {
                                series[i].dataSource = null;
                            }
                         }
                        $.extend(true, series, {}, options[prop]);
                        for (var i = 0, len = series.length; i < len; i++) {
                            if (series[i].enableAnimation)
                                series[i]._animatedSeries = false;
							if(options[prop][i] && options[prop][i].dataSource instanceof ej.DataManager)
								//jQuery extends data manager as object.
								series[i].dataSource = options[prop][i].dataSource;
							if(options[prop][i] && options[prop][i].query instanceof ej.Query)
								//jQuery.extend does not update the existing query with new one.
								series[i].query = options[prop][i].query;
                        }
                        break;
                    case "legend":
                        $.extend(true, this.model.legend, {}, options[prop]);
                        break;
                    case "axes":
                        $.extend(true, this.model.axes, {}, options[prop]);
                        break;
                    case "primaryXAxis":
                        this.model.primaryXAxis.setRange = (options[prop].range) ? true : false;
                        this.model.primaryXAxis.setAxisInterval = (options[prop].range && options[prop].range.interval) ? true : this.model.primaryXAxis.setAxisInterval;
                        this.model.primaryXAxis.actual_Range = (this.model._axes[0].setRange) ? null : this.model._axes[0].actual_Range;
                        $.extend(true, this.model.primaryXAxis, {}, options[prop]);
                        break;
                    case "primaryYAxis":
                        this.model.primaryYAxis.setRange = (options[prop].range) ? true : false;
                        this.model.primaryYAxis.log_Range = options[prop].range ? options[prop].range : this.model.primaryYAxis.log_Range;
                        this.model.primaryYAxis.actual_Range = (this.model._axes[1].setRange) ? null : this.model._axes[1].actual_Range;
                        $.extend(true, this.model.primaryYAxis, {}, options[prop]);
                        break;
                    case "xZoomFactor":
                        this.model.primaryXAxis.zoomFactor = this._xZoomFactor();
                        axes = this.model.axes;
                        for (var i = 0; i < axes.length; i++) {
                            if(axes[i].orientation.toLowerCase() == "horizontal")
                            axes[i].zoomFactor = this._xZoomFactor();
                        }
                        break;
                    case "yZoomFactor":
                        this.model.primaryYAxis.zoomFactor = this._yZoomFactor();
                        axes = this.model.axes;
                        for (var i = 0; i < axes.length; i++) {
                            if (axes[i].orientation.toLowerCase() == "vertical")
                                axes[i].zoomFactor = this._yZoomFactor();
                        }
                        break;
                    case "xZoomPosition":
                        this.model.primaryXAxis.zoomPosition = this._xZoomPosition();
                        axes = this.model.axes;
                        for (var i = 0; i < axes.length; i++) {
                            if (axes[i].orientation.toLowerCase() == "horizontal")
                                axes[i].zoomPosition = this._xZoomPosition();
                        }
                        break;
                    case "yZoomPosition":
                        this.model.primaryYAxis.zoomPosition = this._yZoomPosition();
                        axes = this.model.axes;
                        for (var i = 0; i < axes.length; i++) {
                            if (axes[i].orientation.toLowerCase() == "vertical")
                                axes[i].zoomPosition = this._yZoomPosition();
                        }
                        break;
                    case "drilldown":
                        this.model.series = [];
                        this.model.explodeValue = null;
                        $.extend(true, this.model, {}, options[prop]);
                        break;
                    case "datasource":
                        for (var i = 0; i < this.model.series.length; i++) {
                            this.model.series[i].dataSource = null;
                            this.model.series[i].points = null;
                        }
                        $.extend(true, this.model, {}, options[prop]);
                        break;
                    case "chartArea":
                        $.extend(true, this.model.chartArea, {}, options[prop]);
                        break;

                    default:
                        $.extend(true, this.model, {}, options[prop]);
                        series = this.model.series;
                        for (var i = 0, len = series.length; i < len; i++) {
                            if (series[i].enableAnimation)
                                series[i]._animatedSeries = false;
                        }
                }
            }
            if (this.model.canResize ||this.model.isResponsive)
                this.bindResizeEvents();
            else
                this.removeResizeEvents();
            $("#annotation_group_" + this._id).remove(); // to remove annotation on set model
            if (this.model.enableCanvasRendering) {
                $(this.svgObject).remove();
                $("#canvas_trackSymbol").remove();
                $("#" + this._id + "_canvas_Tracker").remove();
                $("#secondCanvas").remove();
                this.svgRenderer = new ej.EjCanvasRender(this.element); // to create canvas container
                this.svgRenderer.svgObj.height = ej.util.isNullOrUndefined(this.model.size.height) ? "450" : this.model.size.height;
                this.svgRenderer.svgObj.width = ej.util.isNullOrUndefined(this.model.size.width) ? $("#" + this._id).width() : this.model.size.width;
                this.svgObject = this.svgRenderer.svgObj;

                $(this.legendSvgContainer).remove();
                this.legendSvgContainer = this.svgRenderer.createLegendCanvas(this.element); //creating new CANVAS element for legend
                this.svgRenderer.append(this.legendSvgContainer, this.legendContainer);
            }
            else if ((this.svgObject.id).indexOf("_canvas") != -1) {
                this._removeZoomkit();
                $(this.svgObject).remove();
                this.svgRenderer = new ej.EjSvgRender(this.element);  // to create svg container
                this.svgObject = this.svgRenderer.svgObj;
                this.canvasX = this.canvasY = 0;

                $(this.legendSvgContainer).remove();
                this.legendSvgContainer = this.svgRenderer.createLegendSvg(this.element); //creating new SVG element for legend
                this.svgRenderer.append(this.legendSvgContainer, this.legendContainer);
            }
            else if(!this.chartUpdating){ // Condition checked to avoid knockout removing event.target
                $(this.svgObject).empty();              // using existing svg container
                $(this.legendSvgContainer).empty();
            }

            this.bindTo();
        }
    });
	
	ej.datavisualization.Chart.Locale = ej.datavisualization.Chart.Locale || {};
    ej.datavisualization.Chart.Locale['default'] = ej.datavisualization.Chart.Locale['en-US'] = {
        zoomIn: "Zoom In",
        zoomOut: "Zoom Out",
        zoom: "Zoom",
        pan: "Pan",
        reset: "Reset"
    };
    ej.datavisualization.Chart.CrosshairType = {

        Crosshair: 'crosshair',

        TrackBall: 'trackBall'
    };
    ej.datavisualization.Chart.TrackballDisplayMode = {

        Float: 'float',

        Grouping: 'grouping'
    };
	
	ej.datavisualization.Chart.VisibleOnLegend={
		
		Visible:'visible',
		
		Hidden:'hidden'
	};
	
    ej.datavisualization.Chart.ExportingType = {

        PNG: 'png',

        JPG: 'jpg',

        PDF: 'pdf',

        SVG: 'svg',

        DOCX: 'docx',

        XLSX: 'xlsx'
    };

    ej.datavisualization.Chart.ExportingMode = {
       
        Client: 'client',

        Server: 'server'
    };

     ej.datavisualization.Chart.ExportingOrientation = {
       
        Portrait: 'portrait',

        Landscape: 'landscape'
    };

    ej.datavisualization.Chart.ValueType = {

        Double: 'double',

        DateTime: 'datetime',

        Category: 'category',

        Logarithmic: 'logarithmic',

        DateTimeCategory:'datetimecategory'
    };

    ej.datavisualization.Chart.TextOverflow = {

        None: 'none',

        Wrap: 'wrap',

        Trim: 'trim',

        WrapAndTrim:'wrapandtrim'
    };

    ej.datavisualization.Chart.Type = {

        Line: 'line',

        Spline: 'spline',

        Column: 'column',

        Doughnut: 'doughnut',

        Area: 'area',

        SplineArea: 'splinearea',

        StepLine: 'stepline',

        StepArea: 'steparea',

        Pie: 'pie',

        PieOfPie: 'pieofpie',

        Hilo: 'hilo',

        HiloOpenClose: 'hiloopenclose',

        Candle: 'candle',

        Bubble: 'bubble',

        Scatter: 'scatter',

        Bar: 'bar',

        StackingArea: 'stackingarea',

        StackingArea100: 'stackingarea100',

        RangeColumn: 'rangecolumn',

        StackingColumn: 'stackingcolumn',

        StackingColumn100: 'stackingcolumn100',

        StackingBar: 'stackingbar',

        StackingBar100: 'stackingbar100',

        Pyramid: 'pyramid',

        Funnel: 'funnel',

        Polar: 'polar',

        Radar: 'radar',

        RangeArea: 'rangearea',

        Waterfall: 'waterfall',
		
		 BoxAndWhishker:'boxandwhisker'

    };
    ej.datavisualization.Chart.SplitMode = {

        Position: 'position',

        Value: 'value',

        Percentage: 'percentage',

        Indexes: 'indexes'

    };
	ej.datavisualization.Chart.DragType = {
	
		XY:"xy",
		
		X:"x",
		
		Y:"y"
	};
    ej.datavisualization.Chart.LabelPlacement = {

        BetweenTicks: "betweenTicks",

        OnTicks: "onTicks"
    };

    ej.datavisualization.Chart.TrendlinesType = {

        Linear: "linear",

        Exponential: "exponential",

        Logarithmic: "logarithmic",

        Power: "power",

        Polynomial: "polynomial"
    };

    ej.datavisualization.Chart.ErrorBarType = {

        FixedValue: "fixedValue",

        Percentage: "percentage",

        StandardDeviation: "standardDeviation",

        StandardError: "standardError",

        Custom: "custom"
    };

    ej.datavisualization.Chart.ErrorBarMode = {

        Both: "both",

        Vertical: "vertical",

        Horizontal: "horizontal"
    };
    
    ej.datavisualization.Chart.ErrorBarDirection = {

        Both: "both",

        Plus: "plus",

        Minus:"minus"
    };

    ej.datavisualization.Chart.LabelIntersectAction = {

        None: "none",

        Rotate90: "rotate90",

        Rotate45: "rotate45",

        Wrap: "wrap",

        WrapByword : "wrapByWord",

        Trim: "trim",

        Hide: "hide",

        MultipleRows: "multipleRows"
    };

    ej.datavisualization.Chart.EdgeLabelPlacement = {

        None: "none",

        Shift: "shift",

        Hide: "hide"
    };
	
	 ej.datavisualization.Chart.roundedCorner={
	 
		Both:"both",
		
		Start:"start",
		
		End:"end"
	 
	 };

    ej.datavisualization.Chart.Theme = {

        Azure: 'azure',

        FlatLight: 'flatlight',

        Azuredark: 'azuredark',

        Lime: 'lime',

        LimeDark: 'limedark',

        Saffron: 'saffron',

        SaffronDark: 'saffrondark',

        GradientLight: 'gradientlight',

       GradientDark: 'gradientdark',
		
		HighContrast01: 'highcontrast01',
		
		HighContrast02 : 'highcontrast02',
		
		Material : 'material',
		
		Office365: 'office365',
		
		Bootstrap: 'bootstrap'
    };

    ej.datavisualization.Chart.FontStyle = {

        Normal: 'normal',

        Italic: 'italic'
    };

    ej.datavisualization.Chart.FontWeight = {

        Regular: 'regular',

        Bold: 'bold',

        Lighter: 'lighter'
    };

    ej.datavisualization.Chart.IntervalType = {

        Auto : 'auto',

        Days: 'days',

        Hours: 'hours',

        Seconds: 'seconds',

        Milliseconds: 'milliseconds',

        Minutes: 'minutes',

        Months: 'months',

        Years: 'years'
    };

    ej.datavisualization.Chart.RangePadding = {

        Additional: 'additional',

        Normal: 'normal',

        None: 'none',

        Round: 'round',

        Auto: 'auto'
    };

    ej.datavisualization.Chart.TextAlignment = {

        MiddleTop: 'middletop',

        MiddleCenter: 'middlecenter',

        MiddleBottom: 'middlebottom'
    };

    ej.datavisualization.Chart.LabelPosition = {

        Inside: 'inside',

        Outside: 'outside'
    };

    ej.datavisualization.Chart.ZIndex = {

        Over: 'over',

        Behind: 'behind'
    };

    ej.datavisualization.Chart.Unit = {

        percentage: 'percentage',

        pixel: 'pixel'
    };

    ej.datavisualization.Chart.PyramidMode = {

        Linear: 'linear',

        Surface: 'Surface'
    };

    ej.datavisualization.Chart.DrawType = {

        Line: 'line',

        Column: 'column',

        Area: 'area'
    };
    ej.datavisualization.Chart.columnFacet = {

        Rectangle: 'rectangle',

        Cylinder: 'cylinder'
    };

	ej.datavisualization.Chart.EmptyPointMode = {

        Gap: 'gap',

        Zero: 'zero',

        Average: 'average'

    };

    ej.datavisualization.Chart.Pattern = {

        None: 'none',

        Chessboard: 'chessboard',

        Crosshatch: 'crosshatch',

        Dots: 'dots',

        Pacman: 'pacman',

        DiagonalBackward: 'diagonalBackward',

        DiagonalForward: 'diagonalForward',

        Grid: 'grid',

        Turquoise: 'turquoise',

        Star: 'star',

        Triangle: 'triangle',

        Circle: 'circle',

        Tile: 'tile',

        HorizontalDash: 'horizontalDash',

        VerticalDash: 'verticalDash',

        Rectangle: 'rectangle',

        Box: 'box',

        VerticalStripe: 'verticalStripe',

        HorizontalStripe: 'horizontalStripe',

        Bubble: 'bubble',

        Custom: 'custom'
    };

    ej.datavisualization.Chart.Mode = {

        Series: 'series',

        Point: 'point',
		
        Cluster: 'cluster',

        Range: 'range'
    };

    ej.datavisualization.Chart.SelectionType = {

        Single: 'single',

        Multiple:'multiple'
    };
    ej.datavisualization.Chart.Shape = {

        None: 'none',

        LeftArrow: 'leftarrow',

        RightArrow: 'rightarrow',

        Circle: 'circle',

        Cross: 'cross',

        HorizLine: 'horizline',

        VertLine: 'vertLine',

        Diamond: 'diamond',

        Rectangle: 'rectangle',

        Triangle: 'triangle',

        InvertedTriangle: 'invertedtriangle',

        Hexagon: 'hexagon',

        Pentagon: 'pentagon',

        Star: 'star',

        Ellipse: 'ellipse',

        Wedge: 'wedge',

        Trapezoid: 'trapezoid',

        UpArrow: 'uparrow',

        DownArrow: 'downarrow',

        Image: 'image'
    };

    ej.datavisualization.Chart.DrawMode = {

        Both: 'both',

        Open: 'open',

        Close: 'close'
    };

    ej.datavisualization.Chart.LineCap = {

        Butt: 'butt',

        Round: 'round',

        Square: 'square'
    };

    ej.datavisualization.Chart.LineJoin = {

        Round: 'round',

        Bevel: 'bevel',

        Miter: 'miter'
    };

    ej.datavisualization.Chart.Position = {

        Top: 'top',

        Middle: 'middle',

        Bottom: 'bottom'
    };

    ej.datavisualization.Chart.Alignment = {

        Center: 'center',

        Near: 'near',

        Far: 'far'
    };
	
	ej.datavisualization.Chart.TickLinesPosition = {

        Inside: 'inside',

        Outside: 'outside'
    };
	
	ej.datavisualization.Chart.CoordinateUnit = {

        None: 'none',

        Pixels: 'pixels',
		
		Points: 'points'
    };
	
	ej.datavisualization.Chart.HorizontalAlignment = {

        Left: 'left',

        Right: 'right',
		
		Middle: 'middle'
    };
	
	ej.datavisualization.Chart.VerticalAlignment = {

        Top: 'top',

        Bottom: 'bottom',
		
		Middle: 'middle'
    };
	
	ej.datavisualization.Chart.Region = {

        Chart: 'chart',

        Series: 'series'
    };
	
	ej.datavisualization.Chart.ConnectorLineType = {

        Line: 'line',

        Bezier: 'bezier'
    };
	
	ej.datavisualization.Chart.HorizontalTextAlignment = {

        Near: 'near',

        Far: 'far',
		
		Center: 'center'
    };
	
	ej.datavisualization.Chart.VerticalTextAlignment = {

        Near: 'near',

        Far: 'far',
		
		Center: 'center'
    };
	
	ej.datavisualization.Chart.multiLevelLabelsBorderType = {

        None: 'none',

        Rectangle: 'rectangle',
		
		WithoutTopAndBottom: 'withouttopandbottom',
		
		Brace: 'brace',
		
		CurlyBrace: 'curlybrace'
    };
	
	ej.datavisualization.Chart.MACDType = {

        Line: 'line',

        Histogram: 'histogram',
		
		Both: 'both'
    };
	
	ej.datavisualization.Chart.IndicatorsType = {

        RSI: 'rsi',

        Momentum: 'momentum',
		
		Bollingerband: 'bollingerband',
		
		Accumulationdistribution : 'accumulationdistribution',
		
		EMA: 'ema',
		
		SMA: 'sma',
		
		Stochastic: 'stochastic',
		
		ATR: 'atr',
		
		MACD: 'macd',
		
		TMA: 'tma'
    };
	
	ej.datavisualization.Chart.BoxPlotMode = {
	
		  Normal: 'normal',

         Exclusive: 'exclusive',

         Inclusive: 'inclusive',
		
		
    };
	
	ej.datavisualization.Chart.BubbleRadiusMode = {
	
		 MinMax: 'minmax',

         Auto: 'auto'
		
    };
	
    $.extend(ej.datavisualization.Chart.prototype, ej.ejChart);
})(jQuery, Syncfusion);;
ej.EjSvgScrollbarRender = function (element,scrollObj) {
    this.svgSupport = (window.SVGSVGElement) ? true : false;
    var id = jQuery(element).attr("id");
    this.scrollsvgObj = this.scrollsvgObj ? this.scrollsvgObj : [];
    if (this.svgSupport) {
        this.svgLink = "http://www.w3.org/2000/svg";
        this.scrollsvgObj[scrollObj.index] = document.createElementNS(this.svgLink, "svg");
        this.scrollsvgObj[scrollObj.index].setAttribute('id', "scrollbar_" + id + scrollObj.index);
    } else {
        var doc = document;
        this.scrollsvgObj[scrollObj.index] = doc.createElement("div");
        this.scrollsvgObj[scrollObj.index].style.position = 'relative';
        this.scrollsvgObj[scrollObj.index].setAttribute('id', "scrollbar_" + id + scrollObj.index);
    }
};

(function ($) {
    ej.EjSvgScrollbarRender.prototype = {

        _initializeScrollbarVariables: function (scrollObj) {
            scrollObj.offsetLeftX = 0
            scrollObj.rectWidth = scrollObj.offsetRightX = scrollObj.oldWidth = scrollObj.width;
            scrollObj.startX = 0, scrollObj.endX = 0;
            scrollObj.scrollbarLoaded = false;
            
            if (scrollObj.zoomPosition || scrollObj.zoomFactor) {
                scrollObj.offsetLeftX = (scrollObj.zoomPosition * scrollObj.width);
                scrollObj.rectWidth = (scrollObj.zoomFactor) * scrollObj.width;
            }
        },

        _scrollbarUpdate: function (scrollObj) {

            var width = parseFloat(scrollObj.width),
                arrowsize = 15,
                minimumRect = 44,
                panningRect = width - 30;// arrowSize * 2 
            scrollObj.offsetLeftX = !scrollObj.scrollbarLoaded ? scrollObj.offsetLeftX : (scrollObj.offsetLeftX - arrowsize);
            scrollObj.offsetLeftX = scrollObj.offsetLeftX < arrowsize ? 0 : scrollObj.offsetLeftX;
            var offsetLeftX = ((scrollObj.offsetLeftX / scrollObj.oldWidth) * panningRect) + arrowsize;
            var rectWidth = ((scrollObj.rectWidth / scrollObj.oldWidth) * panningRect);
            isMinWidth = rectWidth < minimumRect;
            scrollObj._diff = isMinWidth ? minimumRect - rectWidth : 0;
            rectWidth = rectWidth > minimumRect ? rectWidth : minimumRect;
            scrollObj.oldWidth = panningRect;
            var offsetRightX = offsetLeftX + rectWidth;
            scrollObj.rectWidth = rectWidth;
            scrollObj.offsetLeftX = scrollObj.startX = offsetLeftX;
            scrollObj.offsetRightX = (offsetRightX - arrowsize) <= offsetLeftX ? (offsetRightX + arrowsize) : offsetRightX;
            scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            scrollObj.startX = offsetLeftX < arrowsize ? arrowsize : offsetLeftX;
            if ((offsetLeftX + rectWidth) > (scrollObj.width - arrowsize)) {
                scrollObj.offsetLeftX = scrollObj.startX = scrollObj.width - arrowsize - rectWidth;
                scrollObj.offsetRightX = scrollObj.width - arrowsize;
                scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            }
            scrollObj.scrollbarLoaded = true;

        },

        _renderScrollbar: function (scrollObj) {

            this.scrollsvgObj = this.scrollsvgObj ? this.scrollsvgObj : [];
            $(this.scrollsvgObj[scrollObj.index]).empty();
			if(this.scrollsvgObj[scrollObj.index])
				$(document).find('[id*= '+this.scrollsvgObj[scrollObj.index].id +']').attr('height','0px');
            var id = this._id;
            var arrowSize = 15;
            var scrollHeight = 18;
            var minimumScrollSize = 44;
            this.scrollsvgObj[scrollObj.index] = this.scrollbarContainer.scrollsvgObj[scrollObj.index];
            var height = 17, width = parseFloat(scrollObj.width), padding = 8, centerY = (height/2), panningRect = width - (arrowSize * 2);
            scrollObj.offsetLeftX = !scrollObj.scrollbarLoaded ? scrollObj.offsetLeftX : (scrollObj.offsetLeftX - arrowSize);
            scrollObj.offsetLeftX = scrollObj.offsetLeftX < arrowSize ? 0 : scrollObj.offsetLeftX;
            var offsetLeftX = ((scrollObj.offsetLeftX / scrollObj.oldWidth) * panningRect) + arrowSize;
            var rectWidth = ((scrollObj.rectWidth / scrollObj.oldWidth) * panningRect);
            isMinWidth = rectWidth < minimumScrollSize;
            scrollObj._diff = isMinWidth ? minimumScrollSize - rectWidth : 0;
            rectWidth = rectWidth > minimumScrollSize ? rectWidth : minimumScrollSize;
            scrollObj.oldWidth = panningRect;
            offsetLeftX = ((offsetLeftX + rectWidth) > panningRect) ? (panningRect - (rectWidth - arrowSize)) : offsetLeftX;
            var offsetRightX = offsetLeftX + rectWidth;
            scrollObj.rectWidth = rectWidth;
            scrollObj.offsetLeftX = scrollObj.startX = offsetLeftX;
            scrollObj.offsetRightX = offsetLeftX + rectWidth;
            scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            scrollObj.scrollbarLoaded = true;
            offsetRightX = (offsetRightX - arrowSize) <= offsetLeftX ? (offsetRightX + arrowSize) : offsetRightX;
            var xPadding = this.padding || 0;
            var yPadding = !this.vmlRendering ? 0 : -5;
            if (scrollObj.orientation == 'horizontal')
                this.scrollbar = this.renderer.createGroup({ 'id': id + '_scrollbar' + '_' + scrollObj.index, transform: "translate(" + xPadding + "," + yPadding + ")" });
            else
                this.scrollbar = this.renderer.createGroup({ 'id': id + '_scrollbar' + '_' + scrollObj.index, transform: "translate(" + 0 + "," + scrollObj.width + ") rotate(270)" });
            //Draw a rounded corner path direction
            var makeShape = function (x, y, width, height, r, scrollObj) {
                var
                  spc = " ", // path drawing instruction letters with readable names
                  moveTo = "M",
                  horizLineTo = "h",
                  vertLineTo = "v",
                  arcTo = "a",
                  closePath = "z",
                  ori = scrollObj.orientation,
                  opp = scrollObj.opposed,
                  dStr;
                if ((ori == 'vertical' && !opp) || (opp && ori != 'vertical')) {
                    dStr = // the "d" path for the svg path
                    moveTo + spc + x + spc + r + spc +
                    vertLineTo + spc + (height - r) + spc +
                    horizLineTo + spc + (width) + spc +
                    vertLineTo + spc + (r - height) + spc +
                    arcTo + spc + r + spc + r + spc + 0 + spc + 0 + spc + 0 + spc + (-r) + spc + (-r) + spc +
                    horizLineTo + spc + -(width - 2 * r) + spc +
                    arcTo + spc + r + spc + r + spc + 0 + spc + 0 + spc + 0 + spc + (-4) + spc + (r) + spc +
                    closePath;

                } else {
                    dStr = // the "d" path for the svg path
                    moveTo + spc + x + spc + y + spc +
                    vertLineTo + spc + (height - r) + spc +
                    arcTo + spc + r + spc + r + spc + 0 + spc + 0 + spc + 0 + spc + r + spc + r + spc +
                    horizLineTo + spc + (width - 2 * r) + spc +
                    arcTo + spc + r + spc + r + spc + 0 + spc + 0 + spc + 0 + spc + r + spc + (-r) + spc +
                    vertLineTo + spc + (r - height) + spc +
                    closePath;
                }
                
                return dStr; 
            };
            var direction = makeShape(0, 0, width, scrollHeight, 4, scrollObj);

            //Create a scrollbar background rectangle
            var rectBorder = {
                'id': id + '_scrollbarBackRect_' + scrollObj.index,
                'stroke-width': 1,
                'height': scrollHeight,
                'width': width,
                'stroke-linejoin' :"round",
                'stroke': "#B4B4B4",               
                'fill': "#F7F7F7",
                'class':'e-rangeScroll-backRect'
            };

            if (!this.vmlRendering) {
                rectBorder.d = direction;
                this.renderer.drawPath(rectBorder, this.scrollbar);
            } else
                this.renderer.drawRect(rectBorder, this.scrollbar);

            var rightRectBorder = {
                'id': id + '_scrollbarRightRect_' + scrollObj.index,
                'stroke-width': 1,
                'x':(width - 5),
                'height': scrollHeight,
                'width': 5,
                'stroke-linejoin': "round",
                'stroke': "transparent",
                'fill': "transparent"
            };
            this.renderer.drawRect(rightRectBorder, this.scrollbar);

            var leftRectBorder = {
                'id': id + '_scrollbarLeftRect_' + scrollObj.index,
                'stroke-width': 1,
                'x': 0,
                'height': scrollHeight,
                'width': 5,
                'stroke-linejoin': "round",
                'stroke': "transparent",
                'fill': "transparent"
            };
            this.renderer.drawRect(leftRectBorder, this.scrollbar);

            //Create a left Arrow
            var leftArrow = {
                'id': id + '_scrollbarLeftArrow_' + scrollObj.index,
                'stroke-width': 1,
                'stroke': "#999999",
                'd': "M " + 5 + " " + 9 + " " + "L " + 10 + " " + 14 + " " + "L " + 10 + " " + 3.5 + " Z",
                'fill': "#999999",
                'class': "e-rangeScroll-arrow"
            };
            this.renderer.drawPath(leftArrow, this.scrollbar);          

            ////Create a right Arrow
            var rightArrow = {
                'id': id + '_scrollbarRightArrow_' + scrollObj.index,
                'stroke-width': 1,
                'stroke': "#999999",
                'd': "M " + (width - 5) + " " + 9 + " " + "L " + (width - 10) + " " + 14 + " " + "L " + (width - 10) + " " + 3.5 + " Z",
                'fill': "#999999",
                'class': "e-rangeScroll-arrow"
            };
            this.renderer.drawPath(rightArrow, this.scrollbar);

            var options = {
                'id': id + '_scrollbarSelect_' + scrollObj.index,
                x: offsetLeftX,
                y: 0,
                'width': rectWidth,
                'rx': 4,
                'ry': 4,
                'height': height,
                'stroke': "#999999",
                'stroke-width': 1,
                'fill': "#CECECE",
                'class':'e-rangeScroll-select'
            };
            this.renderer.drawRect(options, this.scrollbar);
            this.centerLine = this.renderer.createGroup({ 'id': id + '_scrollbarCenterLine_' + scrollObj.index, transform: "translate(" + (offsetLeftX + (rectWidth / 2) - 7.5) + ")" });

            //Create a center shape
            var shape = {
                'id': id + '_scrollbarCenterShape_' + scrollObj.index,
                'stroke-width': 1,
                'stroke': "#999999",
                'd': "M " + 0 + " " + 3.5 + " " + "L " + 0 + " " + 13.5 + " Z" + "M " + 5 + " " + 3.5 + " " + "L " + 5 + " " + 13.5 + " Z" + "M " + 10 + " " + 3.5 + " " + "L " + 10 + " " + 13.5 + " Z" + "M " + 15 + " " + 3.5 + " " + "L " + 15 + " " + 13.5 + " Z",
                'fill': "#999999",
                'class': 'e-rangeScroll-centerShape'
            };
            this.renderer.drawPath(shape, this.centerLine);
            this.renderer.append(this.centerLine, this.scrollbar);
            var leftHeaderHideRectOptions = {
                'id': id + '_leftHeaderHideRect_' + scrollObj.index,
                'x': offsetLeftX,
                'y': 0,
                'width': 11,
                'height': 17,
                'fill': 'transparent',
                'opacity': 0,
                'stroke-width': 1,
                'class': 'e-rangeScroll-leftRect'
            }
            this.renderer.drawRect(leftHeaderHideRectOptions, this.scrollbar);
            var leftHeaderOptions = {
                'id': id + '_scrollbarLeftHeader_' + scrollObj.index,
                'cx': offsetLeftX + padding,
                'cy': centerY,
                'r': 3,
                "fill": "#999999",
                'stroke': "#999999",
                'stroke-width': 1,
                'class': 'e-rangeScroll-leftCircle'
            };
            this.renderer.drawCircle(leftHeaderOptions, this.scrollbar);         
            var rightHeaderHideRectOptions = {
                'id': id + '_rightHeaderHideRect_' + scrollObj.index,
                'x': offsetRightX - 11,
                'y': 0,
                'width': 11,
                'height': height,
                'fill': 'transparent',
                'opacity': 0,
                'stroke-width': 1,
                'class': 'e-rangeScroll-rightRect'
            };
            this.renderer.drawRect(rightHeaderHideRectOptions, this.scrollbar);
            var rightHeaderOptions = {
                'id': id + '_scrollbarRightHeader_' + scrollObj.index,
                "fill": "#999999",
                'cx': offsetRightX - padding,
                'cy': centerY,
                'r': 3,
                'stroke': "#999999",
                'stroke-width': 1,
                'class': 'e-rangeScroll-rightCircle'
            };
            this.renderer.drawCircle(rightHeaderOptions, this.scrollbar);
           
            this.renderer.append(this.scrollbar, this.scrollsvgObj[scrollObj.index]);
            if (scrollObj.orientation == 'horizontal') {
                this.scrollsvgObj[scrollObj.index].setAttribute("height", scrollHeight);
                this.scrollsvgObj[scrollObj.index].setAttribute("width", width);
            } else {
                this.scrollsvgObj[scrollObj.index].setAttribute("height", width);
                this.scrollsvgObj[scrollObj.index].setAttribute("width", scrollHeight);
            }
            this.renderer.append(this.scrollsvgObj[scrollObj.index], scrollObj.parent);

            //Apply CSS styles to scrollbar controls          
            var vmlPadding = !this.vmlRendering ? scrollObj.y : scrollObj.y + 5;
            if (this.pluginName == "ejRangeNavigator")
                this.scrollsvgObj[scrollObj.index].setAttribute('style', 'overflow:visible;position:relative;display:block; top:' + (vmlPadding - scrollObj.y) + 'px;' + 'left:' + scrollObj.x + 'px');
            else
                this.scrollsvgObj[scrollObj.index].setAttribute('style', 'overflow:visible;position:absolute;display:block; top:' + vmlPadding + 'px;' + 'left:' + scrollObj.x + 'px');
            $("#" + id + "_scrollbarSelect_" + scrollObj.index).css({ "cursor": "pointer" });
            if (scrollObj.enableResize) {
                $("#" + id + "_leftHeaderHideRect_" + scrollObj.index).css({ "cursor": scrollObj.orientation == 'horizontal' ? "w-resize" : "n-resize" });
                $("#" + id + "_rightHeaderHideRect_" + scrollObj.index).css({ "cursor": scrollObj.orientation == 'horizontal' ? "w-resize" : "n-resize" });
                $("#" + id + "_scrollbarRightHeader_" + scrollObj.index).css({ "cursor": scrollObj.orientation == 'horizontal' ? "w-resize" : "n-resize" });
                $("#" + id + "_scrollbarLeftHeader_" + scrollObj.index).css({ "cursor": scrollObj.orientation == 'horizontal' ? "w-resize" : "n-resize" });
            } else {
                $("#" + id + "_leftHeaderHideRect_" + scrollObj.index).hide();
                $("#" + id + "_rightHeaderHideRect_" + scrollObj.index).hide();
                $("#" + id + '_scrollbarLeftHeader_' + scrollObj.index).hide();
                $("#" + id + '_scrollbarRightHeader_' + scrollObj.index).hide();
            }

            if (this.vmlRendering) {
                $('#' + id + '_leftHeaderHideRect_' + scrollObj.index).css("visibility", 'hidden');
                $('#' + id + '_rightHeaderHideRect_' + scrollObj.index).css("visibility", 'hidden');
            }
            
            this.scrollbarContainer._bindScrollEvents.call(this, scrollObj);
        },

        _bindScrollEvents: function (scrollObj) {
            //Binding Mouse Events to scrollbar
            var rootId = this._id;
            var matched = jQuery.uaMatch(navigator.userAgent);
            var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);           
            bindDesktopEvents.call(this, scrollObj);
            if (window.PointerEvent) { //Added pointer event for IE11

                this._on($('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index), "pointerdown", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index), "pointerdown", this.scrollbarContainer._rightScrollbarDown);

                this._on($('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index), "pointerdown", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index), "pointerdown", this.scrollbarContainer._rightScrollbarDown);
                
                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "pointerdown", this.scrollbarContainer._leftArrowDown);
                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "pointerup", this.scrollbarContainer._leftArrowUp);

                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "pointerdown", this.scrollbarContainer._rightArrowDown);
                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "pointerup", this.scrollbarContainer._rightArrowUp);

                this._on($('#' + rootId + '_scrollbarSelect_' + scrollObj.index), "pointerdown", this.scrollbarContainer._scrollSelectRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "pointerdown", this.scrollbarContainer._scrollBackRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "pointerup", this.scrollbarContainer._scrollBackRectUp);

                this._on($(window), "pointermove", this.scrollbarContainer._scrollbarMove);
                this._on($(window), "pointerup", this.scrollbarContainer._scrollbarUp);
                this._on($(this.scrollsvgObj[scrollObj.index]), "pointermove", this.scrollbarContainer._scrollbarMove);
                this._on($(this.scrollsvgObj[scrollObj.index]), "pointerup", this.scrollbarContainer._scrollbarUp);

                $(this.scrollsvgObj[scrollObj.index]).css('touch-action', 'none');
            }
            else if (window.navigator.msPointerEnabled && !isIE11) {

                this._on($('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._rightScrollbarDown);

                this._on($('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._rightScrollbarDown);
                
                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._leftArrowDown);
                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "MSPointerUp", this.scrollbarContainer._leftArrowUp);

                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._rightArrowDown);
                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "MSPointerUp", this.scrollbarContainer._rightArrowUp);

                this._on($('#' + rootId + '_scrollbarSelect_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._scrollSelectRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "MSPointerDown", this.scrollbarContainer._scrollBackRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "MSPointerUp", this.scrollbarContainer._scrollBackRectUp);

                this._on($(window), "MSPointerMove", this.scrollbarContainer._scrollbarMove);
                this._on($(window), "MSPointerUp", this.scrollbarContainer._scrollbarUp);
                this._on($(this.scrollsvgObj[scrollObj.index]), "MSPointerMove", this.scrollbarContainer._scrollbarMove);
                this._on($(this.scrollsvgObj[scrollObj.index]), "MSPointerUp", this.scrollbarContainer._scrollbarUp);

                $(this.scrollsvgObj[scrollObj.index]).css('-ms-touch-action', 'none');

            } else if (matched.browser.toLowerCase() == "chrome") {
                bindTouchEvents.call(this, scrollObj);
            } else if (this.isDevice()) {
                
                var isSafari = (navigator.userAgent.indexOf('Safari') != -1 && navigator.userAgent.indexOf('Chrome') == -1);
                var isInIframe = (window.location != window.parent.location) ? true : false;
                var userAgent = isInIframe ? window.parent.navigator.userAgent.toLowerCase() : window.navigator.userAgent.toLowerCase();
                var device = /mobile|tablet|android|kindle/i.test(userAgent);
                if ((ej.isMobile() && this.isWindows()) || (!device && ej.isMobile() && isSafari)) { // for safari mobile browser and windows phone                    
                    bindDesktopEvents.call(this);
                    $(this.scrollsvgObj[scrollObj.index]).css('-ms-touch-action', 'none');
                } else
                    bindTouchEvents.call(this, scrollObj);
            }
            var eventName = matched.browser.toLowerCase() == "mozilla" ? (isIE11 ? "mousewheel" : "DOMMouseScroll") : "mousewheel";
            this._on($(this.scrollsvgObj[scrollObj.index]), eventName, this.scrollbarContainer._scrollMouseWheel);

            if (isIE11)
                $(this.scrollsvgObj[scrollObj.index]).css('touch-action', 'none');

            function bindDesktopEvents(scrollObj) {
                this._on($('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index), "mousedown", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index), "mousedown", this.scrollbarContainer._rightScrollbarDown);

                this._on($('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index), "mousedown", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index), "mousedown", this.scrollbarContainer._rightScrollbarDown);

                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "mousedown", this.scrollbarContainer._leftArrowDown);
                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "mouseup", this.scrollbarContainer._leftArrowUp);

                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "mousedown", this.scrollbarContainer._rightArrowDown);
                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "mouseup", this.scrollbarContainer._rightArrowUp);

                this._on($('#' + rootId + '_scrollbarSelect_' + scrollObj.index), "mousedown", this.scrollbarContainer._scrollSelectRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "mousedown", this.scrollbarContainer._scrollBackRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "mouseup", this.scrollbarContainer._scrollBackRectUp);

                this._on($(window), "mousemove", this.scrollbarContainer._scrollbarMove);
                this._on($(window), "mouseup", this.scrollbarContainer._scrollbarUp);
                this._on($(this.svgObject), "mousemove", this.scrollbarContainer._scrollbarMove);
                this._on($(this.scrollsvgObj[scrollObj.index]), "mousemove", this.scrollbarContainer._scrollbarMove);
                this._on($(this.scrollsvgObj[scrollObj.index]), "mouseup", this.scrollbarContainer._scrollbarUp);
            }

            function bindTouchEvents(scrollObj) {
                this._on($('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index), "touchstart", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index), "touchstart", this.scrollbarContainer._rightScrollbarDown);

                this._on($('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index), "touchstart", this.scrollbarContainer._leftScrollbarDown);
                this._on($('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index), "touchstart", this.scrollbarContainer._rightScrollbarDown);

                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "touchstart", this.scrollbarContainer._leftArrowDown);
                this._on($('#' + rootId + '_scrollbarLeftArrow_' + scrollObj.index), "touchend", this.scrollbarContainer._leftArrowUp);

                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "touchstart", this.scrollbarContainer._rightArrowDown);
                this._on($('#' + rootId + '_scrollbarRightArrow_' + scrollObj.index), "touchend", this.scrollbarContainer._rightArrowUp);

                this._on($('#' + rootId + '_scrollbarSelect_' + scrollObj.index), "touchstart", this.scrollbarContainer._scrollSelectRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "touchstart", this.scrollbarContainer._scrollBackRectDown);
                this._on($('#' + rootId + '_scrollbarBackRect_' + scrollObj.index), "touchend", this.scrollbarContainer._scrollBackRectUp);

                this._on($(window), "touchmove", this.scrollbarContainer._scrollbarMove);
                this._on($(window), "touchend", this.scrollbarContainer._scrollbarUp);
                this._on($(this.scrollsvgObj[scrollObj.index]), "touchmove", this.scrollbarContainer._scrollbarMove);
                this._on($(this.scrollsvgObj[scrollObj.index]), "touchend", this.scrollbarContainer._scrollbarUp);

            }
        },

        _setScrollPosition: function (startX, offsetRightX, scrollObj) {
            var padding = 8;
            var rootId = this._id;
            var centerLine = (startX + (scrollObj.rectWidth / 2) - 7.5);
            $('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index).attr("cx", startX + padding);
            $('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index).attr("x", startX);
            
            $('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index).attr("cx", offsetRightX - padding);
            $('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index).attr("x", offsetRightX - 5);
            $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).attr("x", startX);
            $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).attr("width", scrollObj.rectWidth);
            $('#' + rootId + '_scrollbarCenterLine_' + scrollObj.index).attr('transform', 'translate(' + centerLine + ')');
            //Apply styles for VML support
            if (this.pluginName == "ejRangeNavigator") {
                $('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index).css("left", startX);
                $('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index).css("left", startX);
                $('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index).css("left", offsetRightX - padding);
                $('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index).css("left", offsetRightX - 5);
                $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).css("left", startX);
                $('#' + rootId + '_scrollbarCenterLine_' + scrollObj.index).css('left', centerLine);
            }
        },
        _calculateScrollLeftMove: function (moveLength, scrollObj) {

            if (scrollObj._startX - moveLength > 15) {
                scrollObj.startX = scrollObj._startX - moveLength;
                scrollObj.offsetLeftX = scrollObj.startX;
                scrollObj._offsetRightX = scrollObj.startX + scrollObj.rectWidth;
                scrollObj.offsetRightX = scrollObj._offsetRightX;
                scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            } else {
                scrollObj.startX = 15;
                scrollObj._offsetLeftX = scrollObj.offsetLeftX;
                scrollObj.offsetLeftX = scrollObj.startX;
                scrollObj._offsetRightX = scrollObj.startX + scrollObj.rectWidth;
                scrollObj.offsetRightX = scrollObj._offsetRightX;
                scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            }
        },
        _calculateScrollRightMove: function (moveLength, scrollObj) {
            if (scrollObj && (scrollObj._offsetRightX + (Math.abs(moveLength))) < scrollObj.width - 15) {
                scrollObj._startX = scrollObj.startX + Math.abs(moveLength);
                scrollObj.offsetLeftX = scrollObj._startX;
                scrollObj.offsetRightX = scrollObj._offsetRightX + Math.abs(moveLength);
                scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            } else {
                scrollObj._ofsetRightX = scrollObj.offsetRightX;
                scrollObj.offsetRightX = scrollObj.width - 15;
                scrollObj._startX = scrollObj.offsetRightX - scrollObj.rectWidth;
                scrollObj.offsetLeftX = scrollObj._startX;
                scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
            }
        },
        _calculateRange: function (startX, endX, scrollObj) {
            
            var zoomPos, zoomFactor, scrollRange, start, end, padding = 30,startArgs,endArgs;

            //Modify scrollbar center rectangle position on mouse move
            zoomPos = (startX - 15) / (scrollObj.width - padding - scrollObj._diff);
            scrollRange = scrollObj.scrollRange;
            zoomFactor = ((scrollObj.rectWidth - scrollObj._diff) / (scrollObj.width - padding - scrollObj._diff));
            if (!scrollObj.isRTL) {
                start = scrollRange.min + zoomPos * scrollRange.delta;
                end = start + zoomFactor * scrollRange.delta;
            } else {
                end = scrollRange.max - zoomPos * scrollRange.delta;
                start = end - zoomFactor * scrollRange.delta;
            }
            if (scrollObj.valueType == "datetime") {
                startArgs = scrollObj.startDateTime;
                endArgs = scrollObj.endDateTime;
                scrollObj.startDateTime = this.startDateTime = start = new Date(start);
                scrollObj.endDateTime = this.endDateTime = end = new Date(end);
            } else {
                startArgs = parseInt(scrollObj.startValue);
                endArgs = parseInt(scrollObj.endValue);
                scrollObj.startValue = this.startValue = start = Math.ceil(start);
                scrollObj.endValue = this.endValue = end = Math.ceil(end);
            }

            //Bind event on changing scrollbar position 
                scrollObj._scrollChanged = true;
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = {
                zoomPosition: zoomPos, zoomFactor: zoomFactor,
                oldRange: {
                    start: startArgs,
                    end: endArgs
                },
                newRange: {
                    start: start,
                    end: end
                }
            };
            
            scrollObj.zoomPosition = zoomPos;
            scrollObj.zoomFactor = zoomFactor;

            return commonEventArgs;
        },
        _calculateScrollPosition: function (mouseX, scrollObj) {
            var zoomPos, zoomFact, scrollRange, start, end, startArgs, endArgs, width,
                padding = 30, offset = 15, valueType, startRange, minScrollWidth = 36;

            if (this.leftScrollbarClicked && scrollObj.enableResize) {
                mouseX = mouseX >= offset ? mouseX : offset;
                mouseX = (mouseX >= offset && mouseX < scrollObj.offsetRightX - offset) ? mouseX : scrollObj.offsetRightX - offset;
                zoomPos = (mouseX - minScrollWidth) / (scrollObj.width - padding);
                zoomFact = scrollObj.rectWidth / (scrollObj.width - padding);
                
                    valueType = scrollObj.valueType.toLowerCase();
                    scrollRange = scrollObj.scrollRange;
                    if (!scrollObj.isRTL) {
                        start = scrollRange.min + zoomPos * scrollRange.delta;
                        start = start > scrollRange.min ? start : scrollRange.min;
                        if (valueType == "datetime"){
                            startArgs = scrollObj.startDateTime;
                            endArgs = scrollObj.endDateTime;
                            scrollObj.startDateTime = this.startDateTime = start = new Date(start), end = scrollObj.endDateTime;
                        }
                        else {
                            startArgs =  parseInt(scrollObj.startValue);
                            endArgs = parseInt(scrollObj.endValue);
                            scrollObj.startValue = this.startValue = start = Math.ceil(start), end = Math.ceil(scrollObj.endValue);
                        }
                    } else {
                        end = scrollRange.max - zoomPos * scrollRange.delta;
                        end = end < scrollRange.max ? end : scrollRange.max;
                        if (valueType == "datetime") {
                            startArgs = scrollObj.startDateTime;
                            endArgs = scrollObj.endDateTime;
                            scrollObj.endDateTime = this.endDateTime = end = new Date(end), start = scrollObj.startDateTime;
                        }
                        else {
                            startArgs = parseInt(scrollObj.startValue);
                            endArgs = parseInt(scrollObj.endValue);
                            scrollObj.endValue = this.endValue = end = Math.ceil(end), start = Math.ceil(scrollObj.startValue);
                        }
                    }
                //Bind event on changing scrollbar position 
                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = {
                    zoomPosition:zoomPos, zoomFactor: zoomFact,
                    oldRange: {
                        start: startArgs,
                        end: endArgs
                    },
                    newRange: {
                        start: start,
                        end: end
                    }
                };
                scrollObj._scrollChanged = true;
                scrollObj.zoomPosition = zoomPos;
                scrollObj.zoomFactor = zoomFact;

                return commonEventArgs;                
            }
            if (this.rightScrollbarClicked && scrollObj.enableResize) {
                scrollRange = scrollObj.scrollRange;
                zoomFact = scrollObj.rectWidth / (scrollObj.width - padding);
                zoomPos = scrollObj.zoomPosition;
                valueType = scrollObj.valueType.toLowerCase();
                if (!scrollObj.isRTL) {
                    startRange = scrollRange.min + zoomPos * scrollRange.delta;
                    end = startRange + zoomFact * scrollRange.delta;
                    if (valueType == "datetime") {
                        startArgs = scrollObj.startDateTime;
                        endArgs = scrollObj.endDateTime;
                        scrollObj.endDateTime = this.endDateTime = end = new Date(end), start = scrollObj.startDateTime;
                    }
                    else {
                        startArgs = parseInt(scrollObj.startValue);
                        endArgs = parseInt(scrollObj.endValue);
                        scrollObj.endValue = this.endValue = end = Math.floor(end), start = Math.ceil(scrollObj.startValue);
                    }
                } else {
                    zoomPos = (mouseX - minScrollWidth) / (scrollObj.width - padding);
                    start = scrollRange.max - zoomPos * scrollRange.delta;
                    if (valueType == "datetime") {
                        startArgs = scrollObj.startDateTime;
                        endArgs = scrollObj.endDateTime;
                        scrollObj.startDateTime = this.startDateTime = start = new Date(start), end = scrollObj.endDateTime;
                    }
                    else {
                        startArgs = parseInt(scrollObj.startValue);
                        endArgs = parseInt(scrollObj.endValue);
                        scrollObj.startValue = this.startValue = start = Math.floor(start), end = Math.ceil(scrollObj.endValue);
                    }
                }

                //Bind event on changing scrollbar position 
                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                commonEventArgs.data = {
                    zoomPosition: scrollObj.zoomPosition ? scrollObj.zoomPosition : 0, zoomFactor: zoomFact,
                    oldRange: {
                        start: startArgs,
                        end: endArgs
                    },
                    newRange: {
                        start: start,
                        end: end
                    }
                };
                scrollObj._scrollChanged = true;
                scrollObj.zoomFactor = zoomFact;

                return commonEventArgs;
            }
            if (scrollObj && this.scrollRectClicked) {
                var moveLength = this.mouseDownPos - mouseX;
                if (moveLength > 0 && scrollObj.offsetLeftX >= 0) {
                    this.scrollbarContainer._calculateScrollLeftMove.call(this, moveLength, scrollObj);
                    return this.scrollbarContainer._calculateRange.call(this, scrollObj.startX, scrollObj.offsetRightX, scrollObj);
                }
                if (moveLength < 0) {
                    this.scrollbarContainer._calculateScrollRightMove.call(this, moveLength, scrollObj);
                    return this.scrollbarContainer._calculateRange.call(this, scrollObj._startX, scrollObj.offsetRightX, scrollObj);
                }
            }
        },

        _scrollbarMove: function (evt) {
          
            this.moveClientX = !ej.isNullOrUndefined(evt.clientX) ? evt.clientX : (evt.originalEvent.clientX == null ? evt.originalEvent.touches[0].clientX : evt.originalEvent.clientX);
            if (this.moveClientX != this.downClientX) {//update scrollbar only on mouse move
                var zoomPos, axis, start, end, width, padding = 8, minScrollWidth = 34, mouseX, centerLine;
                var rangePadding = this.model.padding || 0;
                var matched = jQuery.uaMatch(navigator.userAgent);
                var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
                if (!scrollObj) return 0;

                this.lastIndex = scrollObj.index;
                if (((!this.vmlRendering && evt.originalEvent.toString() !== "[object TouchEvent]") && matched.browser.toLowerCase() != "msie") || (this.vmlRendering))
                    mouseX = (scrollObj.orientation == 'horizontal' ? this.calMousePosition(evt).X - scrollObj.x : scrollObj.width - (this.calMousePosition(evt).Y - scrollObj.y)) - rangePadding;
                else
                    mouseX = (scrollObj.orientation == 'horizontal' ? this.calTouchPosition(evt).X - scrollObj.x : scrollObj.width - (this.calTouchPosition(evt).Y - scrollObj.y)) - rangePadding;

                this.mouseX = mouseX;
                var rootId = this._id;
                if (this.leftScrollbarClicked && scrollObj.enableResize) {
                  

                    if (scrollObj && (mouseX > minScrollWidth || mouseX > 23) && mouseX < scrollObj.offsetRightX - minScrollWidth) {
                        scrollObj.rectWidth = scrollObj.width - (scrollObj.endX + mouseX - padding);
                        centerLine = ((mouseX - padding) + (scrollObj.rectWidth / 2) - 7.5);
                        $('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index).attr("cx", mouseX);
                        $('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index).attr("x", mouseX - 7.5);
                        $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).attr('x', mouseX - padding);
                        $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).attr("width", scrollObj.rectWidth);
                        $('#' + rootId + '_scrollbarCenterLine_' + scrollObj.index).attr('transform', 'translate(' + centerLine + ')');
                        //Apply styles for VML support
                        if (this.pluginName == "ejRangeNavigator") {
                            $('#' + rootId + '_scrollbarLeftHeader_' + scrollObj.index).css("left", mouseX);
                            $('#' + rootId + '_leftHeaderHideRect_' + scrollObj.index).css("left", mouseX - 7.5);
                            $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).css('left', mouseX);
                            $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).css("width", scrollObj.rectWidth);
                            $('#' + rootId + '_scrollbarCenterLine_' + scrollObj.index).css('left', centerLine);
                        }
                        scrollObj.offsetLeftX = scrollObj.startX = mouseX - 8;
                        this.scrollbarContainer._scrollStartArgs.call(this, scrollObj);
                        this.scrollbarContainer._scrollChangeArgs.call(this, scrollObj);
                        scrollObj._diff = 0;
                    } else if (mouseX > scrollObj.offsetRightX - minScrollWidth)
                        this.rectWidth = 42.89984101748814;
                }
                if (this.rightScrollbarClicked && scrollObj.enableResize) {
                    if (scrollObj && (mouseX <= scrollObj.width - minScrollWidth || mouseX <= scrollObj.width - 23) && mouseX > scrollObj.offsetLeftX + minScrollWidth) {
                        scrollObj.rectWidth = mouseX - scrollObj.offsetLeftX + padding;
                        centerLine = (scrollObj.offsetLeftX + (scrollObj.rectWidth / 2) - 7.5);
                        $('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index).attr("cx", mouseX);
                        $('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index).attr("x", mouseX - 2.5);
                        $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).attr("width", scrollObj.rectWidth);
                        $('#' + rootId + '_scrollbarCenterLine_' + scrollObj.index).attr('transform', 'translate(' + centerLine + ')');
                        //Apply styles for VML support
                        if (this.pluginName == "ejRangeNavigator") {
                            $('#' + rootId + '_scrollbarRightHeader_' + scrollObj.index).css("left", mouseX);
                            $('#' + rootId + '_rightHeaderHideRect_' + scrollObj.index).css("left", mouseX - 2.5);
                            $('#' + rootId + '_scrollbarSelect_' + scrollObj.index).css("width", scrollObj.rectWidth);
                            $('#' + rootId + '_scrollbarCenterLine_' + scrollObj.index).css('left', centerLine);
                        }
                        scrollObj.offsetRightX = mouseX + padding;
                        scrollObj.endX = scrollObj.width - mouseX - padding;
                       // this.scrollbarContainer._calculateScrollPosition.call(this, mouseX, scrollObj);
                        this.scrollbarContainer._scrollStartArgs.call(this, scrollObj);
                        this.scrollbarContainer._scrollChangeArgs.call(this, scrollObj);
                        scrollObj._diff = 0;
                    }

                }
                if (this.scrollRectClicked) {
                    var moveLength = this.mouseDownPos - mouseX;
                    scrollObj._startX =  ej.isNullOrUndefined(scrollObj._startX) ? scrollObj.startX : scrollObj._startX;
                    if (scrollObj && moveLength > 0 && scrollObj.offsetLeftX >= 0) {
                        this.scrollbarContainer._calculateScrollLeftMove.call(this, moveLength, scrollObj);
                        this.scrollbarContainer._setScrollPosition.call(this, scrollObj.startX, scrollObj.offsetRightX, scrollObj);
                        if (scrollObj.offsetLeftX > 15 || scrollObj.offsetLeftX != scrollObj._offsetLeftX) {
                            this.scrollbarContainer._scrollStartArgs.call(this, scrollObj);
                            this.scrollbarContainer._scrollChangeArgs.call(this, scrollObj);
                        }
                    }

                    if (scrollObj && moveLength < 0) {
                        if (ej.isNullOrUndefined(scrollObj._offsetRightX)) {
                            this.scrollbarContainer._scrollSelectRectDown.call(this, evt);
                            this.scrollbarContainer._scrollbarMove.call(this, evt);
                        }
                        this.scrollbarContainer._calculateScrollRightMove.call(this, moveLength, scrollObj);
                        this.scrollbarContainer._setScrollPosition.call(this, scrollObj._startX, (scrollObj._startX + scrollObj.rectWidth), scrollObj);
                        if (scrollObj.offsetRightX < scrollObj.width - 15 || scrollObj.offsetRightX != scrollObj._ofsetRightX) {
                            this.scrollbarContainer._scrollStartArgs.call(this, scrollObj);
                            if (this.model.enableDeferredUpdate === false || scrollObj.isZooming || this.model.scrollChanged != '') {
                                var commonEventArgs = this.scrollbarContainer._calculateRange.call(this, scrollObj._startX, (scrollObj._startX + scrollObj.rectWidth), scrollObj);
                                var oldRange = commonEventArgs.data.oldRange,
                                     newRange = commonEventArgs.data.newRange, oldStart, oldEnd, newStart, newEnd;
                                if (scrollObj.valueType.toLowerCase() == 'datetime') {
                                    oldStart = Date.parse(oldRange.start), newStart = Date.parse(newRange.start),
                                    oldEnd = Date.parse(oldRange.end), newEnd = Date.parse(newRange.end);
                                } else {
                                    oldStart = oldRange.start, newStart = newRange.start,
                                    oldEnd = oldRange.end, newEnd = newRange.end;
                                }
                                if (this.model.scrollChanged != ''  && ((oldStart != newStart) || (oldEnd != newEnd))) {
                                    commonEventArgs = this.scrollbarContainer._args.call(this, scrollObj, commonEventArgs);
                                    this._trigger("scrollChanged", commonEventArgs);
                                }
                                if(!this.model.enableDeferredUpdate)
                                    this.scrollUpdate ? this.scrollUpdate = false : this.scrollbarContainer._appendScrollRange.call(this,scrollObj);
                            }
                        }
                    }
                }
            }
            this.offsetX = mouseX;
        },
        _scrollbarUp: function (evt) {
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            $("[id^=" + this._id + '_scrollbarSelect_' + "]").attr('class', 'e-rangeScroll-select');
            this.lastIndex = null;
            var args = this.scrollbarContainer._calculateScrollPosition.call(this, this.mouseX, scrollObj),
                deferred = this.model.enableDeferredUpdate;
            if (args) {
                var oldRange = args.data.oldRange,
                    newRange = args.data.newRange,oldStart, oldEnd, newStart, newEnd;
                if (scrollObj.valueType.toLowerCase() == 'datetime') {
                    oldStart = Date.parse(oldRange.start), newStart = Date.parse(newRange.start),
                    oldEnd = Date.parse(oldRange.end), newEnd = Date.parse(newRange.end);
                } else {
                    oldStart = oldRange.start, newStart = newRange.start,
                    oldEnd = oldRange.end,newEnd = newRange.end;
                }

                if (((oldStart != newStart) || (oldEnd != newEnd)) || (this.scrollRectClicked && !deferred) || (deferred) || (this.leftScrollbarClicked || this.rightScrollbarClicked)) {
                    //Checked condition for chrome browser mouse click issue.. on mouseClick in chrome move event also triggered
                    var is_chrome = ((navigator.userAgent.toLowerCase().indexOf('chrome') > -1) && (navigator.vendor.toLowerCase().indexOf("google") > -1));
                    if (!is_chrome || (is_chrome && ((this.leftScrollbarClicked || this.rightScrollbarClicked) && this.downClientX != this.moveClientX)
                        || this.scrollRectClicked || this.leftArrowClicked || this.rightArrowClicked)) {
                        //event will no trigger when rect value is not changed on left and right header moved
                        if ((!this.leftScrollbarClicked && !this.rightScrollbarClicked) ||
                            ((this.leftScrollbarClicked || this.rightScrollbarClicked) && Math.ceil(scrollObj.rectWidth) != Math.ceil(this.rectOldWidth) && (Math.abs(scrollObj.rectWidth - scrollObj.rectOldWidth) > 4 || !scrollObj.rectOldWidth))) {
                            if (ej.isNullOrUndefined(scrollObj._previousStart) || ((scrollObj._previousStart != newStart) || (scrollObj._previousEnd != newEnd))) {
                                args = this.scrollbarContainer._args.call(this, scrollObj, args);
                                this._trigger("scrollEnd", args);
                                scrollObj._scrollStarted = false;
                                scrollObj._previousStart = newStart;
                                scrollObj._previousEnd = newEnd;
                                scrollObj.rectOldWidth = scrollObj.rectWidth;
                                this.scrollUpdate ? this.scrollUpdate = false : this.scrollbarContainer._appendScrollRange.call(this, scrollObj);
                            }
                        }
                    }
                }
                scrollObj.release = true;
                scrollObj.clicked = false;
            }
            this._scrollEnd = false;
            this.leftScrollbarClicked = false;
            this.rightScrollbarClicked = false;
            this.scrollRectClicked = false;
            this.leftArrowClicked = false;
            this.rightArrowClicked = false;
            this.scrollbarBackRectClicked = false;
        },
        _leftScrollbarDown: function (evt) {
            evt.preventDefault();
            this.leftScrollbarClicked = true;
            this.downClientX = !ej.isNullOrUndefined(evt.clientX) ? evt.clientX : evt.originalEvent.touches[0].clientX;
        },       

        _rightScrollbarDown: function (evt) {
            evt.preventDefault();
            this.rightScrollbarClicked = true;
            this.downClientX = !ej.isNullOrUndefined(evt.clientX) ? evt.clientX : evt.originalEvent.touches[0].clientX;
        },

        _scrollSelectRectDown: function (evt) {
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            $('#' + this._id + '_scrollbarSelect_' + scrollObj.index).attr('class', 'e-rangeScroll-select e-rangeScroll-select-hover');
            evt.preventDefault();
            var matched = jQuery.uaMatch(navigator.userAgent);
            var rangePadding = this.model.padding || 0;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            if (((!this.vmlRendering && evt.originalEvent.toString() !== "[object TouchEvent]") && matched.browser.toLowerCase() != "msie") || (this.vmlRendering))
                var mouseX = (scrollObj.orientation == 'horizontal' ? this.calMousePosition(evt).X - scrollObj.x : scrollObj.width - (this.calMousePosition(evt).Y - scrollObj.y)) - rangePadding;
            else
                var mouseX = (scrollObj.orientation == 'horizontal' ? this.calTouchPosition(evt).X - scrollObj.x : scrollObj.width - (this.calTouchPosition(evt).Y - scrollObj.y)) - rangePadding;
            this.mouseDownPos = mouseX;
            scrollObj._startX = scrollObj.startX = scrollObj.offsetLeftX;
            scrollObj._offsetRightX = scrollObj.offsetRightX;
            scrollObj.clicked = true;
            scrollObj.release = false;
            this.scrollRectClicked = true;
        },

        //MouseWheel Scrolling event for scrollbarControl
        _scrollMouseWheel: function (e) {
            e.preventDefault();
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, e);
            var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
            var wheelDelta = e.originalEvent.wheelDelta;
            var matched = jQuery.uaMatch(navigator.userAgent);
            var direction = matched.browser.toLowerCase() == "mozilla" ? ((isIE11 ? ((wheelDelta / 120) > 0 ? 1 : -1) : -(e.originalEvent.detail) / 3 > 0 ? 1 : -1)) : ((wheelDelta / 120) > 0 ? 1 : -1);
            var currentScale = Math.max(1 / ej.EjSvgRender.utils._minMax(scrollObj.zoomFactor, 0, 1), 1);
            var cumulativeScale = Math.max(currentScale + (0.25 * direction), 1);
            this.scrollbarContainer.doMouseWheelZoom.call(this, cumulativeScale, 0.5, scrollObj);
            
        },

        _scrollStartArgs: function (scrollObj) {
            scrollObj._scrollStarted = true;
            if (this.model.scrollStart != '' && !this._scrollEnd) {
                var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
                if (!scrollObj.isZooming) {
                    commonEventArgs.data = {
                        startRange: scrollObj.valueType == "datetime" ? scrollObj.startDateTime : scrollObj.startValue,
                        endRange: scrollObj.valueType == "datetime" ? scrollObj.endDateTime : scrollObj.endValue
                    };
                } else {
                    commonEventArgs.data = {
                        axis :this.model._axes[scrollObj.index],
                        currentRange: this.model._axes[scrollObj.index].visibleRange
                    };
                }
                this._trigger("scrollStart", commonEventArgs);
                this._scrollEnd = true;
            }
        },

        _scrollChangeArgs: function (scrollObj) {
            if (this.model.enableDeferredUpdate === false || scrollObj.isZooming || this.model.scrollChanged != '') {
                var commonEventArgs = this.scrollbarContainer._calculateRange.call(this, scrollObj.offsetLeftX, scrollObj.offsetRightX, scrollObj);
                var oldRange = commonEventArgs.data.oldRange,
                    newRange = commonEventArgs.data.newRange, oldStart, oldEnd, newStart, newEnd;
                if (scrollObj.valueType.toLowerCase() == 'datetime') {
                    oldStart = Date.parse(oldRange.start), newStart = Date.parse(newRange.start),
                    oldEnd = Date.parse(oldRange.end), newEnd = Date.parse(newRange.end);
                } else {
                    oldStart = oldRange.start, newStart = newRange.start,
                    oldEnd = oldRange.end, newEnd = newRange.end;
                }
                
                if (this.model.scrollChanged != '' && ((oldStart != newStart) || (oldEnd != newEnd))) {
                    commonEventArgs = this.scrollbarContainer._args.call(this, scrollObj, commonEventArgs);
                    this._trigger("scrollChanged", commonEventArgs);
                }
                if (!this.model.enableDeferredUpdate)
                    this.scrollUpdate ? this.scrollUpdate = false : this.scrollbarContainer._appendScrollRange.call(this, scrollObj);
            }
        },

        _scrollEndArgs: function (startX, scrollObj) {
            var args = this.scrollbarContainer._calculateRange.call(this, startX, scrollObj.offsetRightX, scrollObj);
            if (args && scrollObj._scrollStarted) {
                var oldRange = args.data.oldRange,
                    newRange = args.data.newRange, oldStart, oldEnd, newStart, newEnd;
                if (scrollObj.valueType.toLowerCase() == 'datetime') {
                    oldStart = Date.parse(oldRange.start), newStart = Date.parse(newRange.start),
                    oldEnd = Date.parse(oldRange.end), newEnd = Date.parse(newRange.end);
                } else {
                    oldStart = oldRange.start, newStart = newRange.start,
                    oldEnd = oldRange.end, newEnd = newRange.end;
                }

                if (((oldStart != newStart) || (oldEnd != newEnd)) || (this.leftScrollbarClicked || this.rightScrollbarClicked)) {
                    args = this.scrollbarContainer._args.call(this, scrollObj,args);
                    this._trigger("scrollEnd", args);
                }
                scrollObj._scrollStarted = false;
                this.scrollUpdate ? this.scrollUpdate = false : this.scrollbarContainer._appendScrollRange.call(this, scrollObj);
            }
        },

        _args: function (scrollObj, args) {
            if (scrollObj.isZooming) {
                var axis = this.model._axes[scrollObj.index],
                    data = args.data;
                data.axis = axis;
                data.newRange = axis.visibleRange;
                data.oldRange = axis.previousRange;
            }

            if (scrollObj.isVirtual) {
                args.data.axis = this.model._axes[scrollObj.index];
                delete args.data.zoomFactor;
                delete args.data.zoomPosition;
            }
            return args;
        },

        doMouseWheelZoom: function (cumulativeScale, origin, scrollObj) {
            if (cumulativeScale >= 1) {
                var calZoomVal = this.scrollbarContainer.calZoomFactors(cumulativeScale, origin, scrollObj.zoomFactor, scrollObj.zoomPosition);
                
                if (scrollObj.zoomPosition != calZoomVal.zoomMPosition && calZoomVal.zoomMPosition + scrollObj.zoomFactor <= 1 && scrollObj.zoomPosition >= 0) {
                    if (calZoomVal.zoomMPosition + scrollObj.zoomFactor >= 1) {
                        calZoomVal.zoomMPosition = 1 - scrollObj.zoomFactor
                    }
                    if (calZoomVal.zoomMPosition < 0) {
                        calZoomVal.zoomMPosition = 0;
                    }
                    scrollObj.zoomPosition = calZoomVal.zoomMPosition;
                    scrollObj.startX = ((scrollObj.zoomPosition) * (scrollObj.width - 30 - scrollObj._diff) + 15);
                    scrollObj.startX = (scrollObj.startX + scrollObj.rectWidth + 5) > scrollObj.width ? (scrollObj.width - scrollObj.rectWidth - 15) : scrollObj.startX;
                    scrollObj.offsetLeftX = scrollObj.startX;
                    
                    scrollObj._offsetRightX = scrollObj.startX + scrollObj.rectWidth;
                    if (scrollObj._offsetRightX > scrollObj.width - 15) {
                        scrollObj.offsetRightX = scrollObj.width - 15;
                        scrollObj.startX = scrollObj.offsetRightX - scrollObj.rectWidth;
                        scrollObj.offsetLeftX = scrollObj.startX;
                    } else {
                        scrollObj.offsetRightX = scrollObj._offsetRightX;
                    }
                    scrollObj.endX = scrollObj.width - scrollObj.offsetRightX;
                    this.scrollbarContainer._setScrollPosition.call(this, scrollObj.startX, scrollObj.offsetRightX, scrollObj);
                    this.scrollbarContainer._calculateMouseWheelRange.call(this, scrollObj.startX, scrollObj.offsetRightX, scrollObj);
                }
            }
            return false;
        },
        _calculateMouseWheelRange: function (startX, endX, scrollObj) {

            var scrollRange, start, end, padding = 30,startArgs,endArgs;
            scrollObj.zoomFactor = (scrollObj.rectWidth / (scrollObj.width - padding));
            scrollObj.zoomPosition = (startX - 15) / (scrollObj.width - padding - scrollObj._diff);
            scrollRange = scrollObj.scrollRange;

            if (!scrollObj.isRTL) {
                start = scrollRange.min + scrollObj.zoomPosition * scrollRange.delta;
                end = start + scrollObj.zoomFactor * scrollRange.delta;
            } else {
                end = scrollRange.max - scrollObj.zoomPosition * scrollRange.delta;
                start = end - scrollObj.zoomFactor * scrollRange.delta;
            }

            if (scrollObj.valueType == "datetime") {
                startArgs = scrollObj.startDateTime;
                endArgs = scrollObj.endDateTime;
                scrollObj.startDateTime = this.startDateTime = start = new Date(start);
                scrollObj.endDateTime = this.endDateTime = end = new Date(end);
            } else {
                startArgs = parseInt(scrollObj.startValue);
                endArgs = parseInt(scrollObj.endValue);
                scrollObj.startValue = this.startValue = start = Math.ceil(start);
                scrollObj.endValue = this.endValue = end = Math.ceil(end);
            }

            //Bind event on changing scrollbar position 
            var commonEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonEventArgs.data = {
                zoomPosition: scrollObj.zoomPosition, zoomFactor: scrollObj.zoomFactor,
                oldRange: {
                    start: startArgs,
                    end: endArgs
                },
                newRange: {
                    start: start,
                    end: end
                }
            };
            scrollObj._scrollChanged = true;
            scrollObj._scrollStarted = false;
            var oldRange = commonEventArgs.data.oldRange,
                    newRange = commonEventArgs.data.newRange, oldStart, oldEnd, newStart, newEnd;
            if (scrollObj.valueType.toLowerCase() == 'datetime') {
                oldStart = Date.parse(oldRange.start), newStart = Date.parse(newRange.start),
                oldEnd = Date.parse(oldRange.end), newEnd = Date.parse(newRange.end);
            } else {
                oldStart = oldRange.start, newStart = newRange.start,
                oldEnd = oldRange.end, newEnd = newRange.end;
            }
            if (oldStart != newStart || oldEnd != newEnd || scrollObj.isZooming) {
                this.scrollbarContainer._scrollStartArgs.call(this, scrollObj);
                commonEventArgs = this.scrollbarContainer._args.call(this, scrollObj, commonEventArgs);
                this._trigger("scrollEnd", commonEventArgs);
                this.scrollUpdate ? this.scrollUpdate = false : this.scrollbarContainer._appendScrollRange.call(this, scrollObj);
                this._scrollEnd = false;
            }
        },
        calZoomFactors: function (cumulativeScale, origin, currentZoomFactor, currentZoomPos) {
            var calcZoomFactorVal, calcZoomPosition;
            if (cumulativeScale == 1) {
                calcZoomFactorVal = 1;
                calcZoomPosition = 0;
            } else {
                calcZoomFactorVal = ej.EjSvgRender.utils._minMax(1 / cumulativeScale, 0, 1);
                calcZoomPosition = currentZoomPos + ((currentZoomFactor - calcZoomFactorVal) * origin);
            }
            return { zoomMFactor: calcZoomFactorVal, zoomMPosition: calcZoomPosition };
        },
        _leftArrowDown: function (evt) {
            this.leftArrowClicked = true;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            scrollObj._startX = scrollObj.startX = scrollObj.offsetLeftX;
            scrollObj._offsetRightX = scrollObj.offsetRightX;
            scrollObj.leftIncrement = 5;
            var range=this;
            scrollObj.interval = setInterval(function () {
                range.scrollbarContainer.leftArrowRecursive.call(range, scrollObj)
            }, 50);
        },

        _leftArrowUp: function (evt) {
            this.leftArrowClicked = false;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            this.scrollbarContainer.leftArrowRecursive.call(this, scrollObj);
        },
      
        leftArrowRecursive: function (scrollObj) {
            if (this.leftArrowClicked) {
                var rootId = this._id;
                this.scrollbarContainer._calculateScrollLeftMove.call(this, scrollObj.leftIncrement, scrollObj);
                scrollObj._scrollStarted = true;
                if (scrollObj.startX > 15)
                    this.scrollbarContainer._scrollEndArgs.call(this, scrollObj.startX, scrollObj);
                this.scrollbarContainer._setScrollPosition.call(this, scrollObj.startX, scrollObj.offsetRightX, scrollObj);
                scrollObj.leftIncrement += 5;
            } else {
                clearInterval(scrollObj.interval);
                scrollObj.leftIncrement = 0;
            }
        },

        _rightArrowDown: function (evt) {
            this.rightArrowClicked = true;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            scrollObj._startX = scrollObj.startX = scrollObj.offsetLeftX;
            scrollObj._offsetRightX = scrollObj.offsetRightX;
            scrollObj.rightIncrement = -5;
            var range = this;
            scrollObj.interval = setInterval(function () { range.scrollbarContainer.rightArrowRecursive.call(range, scrollObj) }, 50);
        },

        _rightArrowUp: function (evt) {
            this.rightArrowClicked = false;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            this.scrollbarContainer.rightArrowRecursive.call(this, scrollObj);
        },

        rightArrowRecursive: function (scrollObj) {
            if (this.rightArrowClicked) {
                var rootId = this._id;
                this.scrollbarContainer._calculateScrollRightMove.call(this, scrollObj.rightIncrement, scrollObj);
                scrollObj._scrollStarted = true;
                if (scrollObj.offsetRightX < scrollObj.width - 15)
                    this.scrollbarContainer._scrollEndArgs.call(this, scrollObj._startX, scrollObj);
                this.scrollbarContainer._setScrollPosition.call(this, scrollObj._startX, scrollObj.offsetRightX, scrollObj);
                scrollObj.rightIncrement -= 5;
            } else {
                clearInterval(scrollObj.interval);
                scrollObj.rightIncrement = 0;
            }
        },

        _scrollBackRectDown: function (evt) {

            var matched = jQuery.uaMatch(navigator.userAgent);
            var rangePadding = this.model.padding || 0;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            if (((!this.vmlRendering && evt.originalEvent.toString() !== "[object TouchEvent]") && matched.browser.toLowerCase() != "msie") || (this.vmlRendering))
                var mouseX = (scrollObj.orientation == 'horizontal' ? this.calMousePosition(evt).X - scrollObj.x : scrollObj.width - (this.calMousePosition(evt).Y - scrollObj.y)) - rangePadding;
            else
                var mouseX = (scrollObj.orientation == 'horizontal' ? this.calTouchPosition(evt).X - scrollObj.x : scrollObj.width - (this.calTouchPosition(evt).Y - scrollObj.y)) - rangePadding;
            this.mouseDownPos = mouseX;
            this.scrollbarBackRectClicked = true;
            
            var range = this;
            this.scrollbarContainer._scrollStartArgs.call(this, scrollObj);
            var interval = setInterval(function () {
                range.scrollbarContainer.scrollBackRectRecursive.call(range, scrollObj)
                if (!this.scrollbarBackRectClicked)
                    clearInterval(interval);
            }, 50);
        },
        _scrollBackRectUp: function (evt) {
            this.scrollbarBackRectClicked = false;
            var scrollObj = this.scrollbarContainer._doScrollIndex.call(this, evt);
            this.scrollbarContainer.scrollBackRectRecursive.call(this, scrollObj);
        },

        _doScrollIndex: function(evt){
            var matchStr = this._id + '_scrollbar' + '_';
            var parentNodeId = (evt.target.parentNode && evt.target.parentNode.id) ? evt.target.parentNode.id : '';
            var selectionIndex = parentNodeId.indexOf(matchStr) > -1 ? parseInt(parentNodeId.substr(matchStr.length)) : NaN;
            if (!ej.isNullOrUndefined(this.lastIndex) && !isNaN(this.lastIndex)) {
                if (!this.model.scrollObj[this.lastIndex].release && this.model.scrollObj[this.lastIndex].clicked)
                    selectionIndex = this.lastIndex;
            }
            this.lastIndex = ej.isNullOrUndefined(this.lastIndex) ? selectionIndex : this.lastIndex;
            var scrollObj = ej.isNullOrUndefined(this.model.scrollObj[selectionIndex]) ? this.model.scrollObj[this.lastIndex] : this.model.scrollObj[selectionIndex];

            return scrollObj;
        },

        scrollBackRectRecursive: function (scrollObj) {
            if (this.scrollbarBackRectClicked) {
                var moveLength = (10 / 100) * (scrollObj.width - 30);
                scrollObj._startX = scrollObj.startX = scrollObj.offsetLeftX;
                scrollObj._offsetRightX = scrollObj.offsetRightX;
                if (this.mouseDownPos < scrollObj.startX) {
                    moveLength = moveLength < scrollObj.startX ? moveLength : (scrollObj.startX - 16);
                    this.scrollbarContainer._calculateScrollLeftMove.call(this, moveLength, scrollObj);
                    scrollObj._scrollStarted = true;
                    this.scrollbarContainer._scrollEndArgs.call(this, scrollObj.startX, scrollObj);
                    this.scrollbarContainer._setScrollPosition.call(this, scrollObj.startX, scrollObj.offsetRightX, scrollObj);
                } else if (this.mouseDownPos > scrollObj.offsetRightX) {
                    moveLength = (moveLength < scrollObj.endX ? moveLength : (scrollObj.endX - 16)) * -1;
                    this.scrollbarContainer._calculateScrollRightMove.call(this, moveLength, scrollObj);
                    scrollObj._scrollStarted = true;
                    this.scrollbarContainer._scrollEndArgs.call(this, scrollObj._startX, scrollObj);
                    this.scrollbarContainer._setScrollPosition.call(this, scrollObj._startX, scrollObj.offsetRightX, scrollObj);
                } else {
                    scrollObj._scrollStarted = false;
                }
            } else {
                scrollObj._scrollStarted = false;
            }
        },

        //Redraw the RangeNavigator and Chart
        _appendScrollRange: function (scrollObj) {
            this.scrollbarUpdate = true;
            if (this.pluginName == "ejRangeNavigator")
                this.renderNavigator();
            else {
                var index = scrollObj.index,
                    axes = this.model._axes[index];
                if (scrollObj.isZooming && (axes.zoomFactor != scrollObj.zoomFactor || axes.zoomPosition != scrollObj.zoomPosition)) {
                    axes.zoomFactor = scrollObj.zoomFactor;
                    axes.zoomPosition = scrollObj.zoomPosition;
                    this.redraw(true);
                }
            }
            this.scrollbarUpdate = false;
        }

    };
})(jQuery);;
/**
* @fileOverview Plugin for Circular Gauge
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 11.2 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget({ "ejCircularGauge": "ej.datavisualization.CircularGauge"    }, {
        _rootCSS: "e-circulargauge",
        validTags: ["div", "span"],
        _savedPoints: [],
        _labelRadius:0,
        _customLblMaxSize: 0,
      
        defaults:   {
		
			locale: null,
			
			enableGroupSeparator: false,
              
            value: 0,
              
            minimum: 0,
              
            maximum: 100,
              
            radius: 180,
              
            width: 360,   
              
            height: 360,   
              
            frame: {
                  
                frameType: "fullcircle",   
                  
                backgroundImageUrl: null,
                  
                halfCircleFrameStartAngle: 180,
                  
                halfCircleFrameEndAngle: 360
            },
              
            backgroundColor: null,
              
            interiorGradient: null,   
              
            readOnly: true,
              
            enableAnimation: true,
              
            animationSpeed: 500,
              
            theme: "flatlight",
              
            isRadialGradient: false,
              
            enableResize: false,
              
            isResponsive: false,
              
            tooltip: {
                  
                showLabelTooltip: false,
                  
                showCustomLabelTooltip: false,
                  
                templateID: null,
            },
              
            outerCustomLabelPosition: "bottom",
              
            gaugePosition: "center",  
              
            distanceFromCorner: 20,  
              
            rangeZOrder :"rear",            
               
            drawTicks: null,
              
            drawLabels: null,
              
            drawPointers: null,
              
            drawRange: null,
              
            drawCustomLabel: null,
              
            drawIndicators: null,
              
            drawPointerCap: null,
              
            load: null,
              
            renderComplete: null,
              
            mouseClick: null,
              
            mouseClickMove: null,
              
            mouseClickUp: null,

            legendItemRender: null,

            legendItemClick: null,

            rangeMouseMove:null,

            scales: null,

            legend:{

                visible: false,

                toggleVisibility: true,

                border:
                {

                    color: 'transparent',


                    width: 1
                },


                itemPadding: 20,

                shape: 'circle',

                alignment: 'center',

                position: 'bottom',

                itemStyle:
               {
                   height: 9,

                   width: 9,

                   border:
                   {

                       color: 'transparent',

                       width: 1
                   }
               },

                opacity: 1,

                fill: null,


                font:
                {
                    color: null,

                    fontFamily: 'Segoe UI',

                    fontStyle: 'Normal',

                    fontWeight: 'Regular',

                    size: '12px'
                },

                size:
                    {

                        height: null,

                        width: null
                    }

            },

			 themeProperties: {
                flatlight: {
                    backgroundColor: "#FFFFFF",
                    scales: {
                        pointerCap: {
                            borderColor: "#424242",
                            backgroundColor: "#424242"
                        },
                        backgroundColor: "#777777",
                        border: {
                            color: "#777777"
                        },
                        pointers: {
                            backgroundColor: "#424242",
                            border: {
                                color: "#424242"
                            },
                        },
                        ticks: {
                            color: "#777777"
                        },
                        labels: {
                            color: "#282828"
                        }
                    }
                },

                flatdark: {
                    backgroundColor: "#1F1F1F",
                    scales: {
                        pointerCap: {
                            borderColor: "#686868",
                            backgroundColor: "#686868"
                        },
                        backgroundColor: "#7a7a7a",
                        border: {
                            color: "#7a7a7a"
                        },
                        pointers: {
                            backgroundColor: "#686868",
                            border: {
                                color: "#686868"
                            },
                        },
                        ticks: {
                            color: "#7a7a7a"
                        },
                        labels: {
                            color: "#d3d3d3"
                        }
                    }
                }

            }
        },
          

        _defaultScaleValues: function () {
            return {
                  
                size: 6,
                  
                pointerCap: {
                      
                    radius: 7,
                      
                    borderWidth: 3,
                      
                    interiorGradient: null,   
                      
                    borderColor: null,
                      
                    backgroundColor:null
                },
                  
                showScaleBar: false,
                  
                sweepAngle: 310,
                  
                radius: 170,
                  
                startAngle: 115,
                  
                majorIntervalValue: 10,
                  
                minorIntervalValue: 2,
                  
                maximum: null,
                  
                minimum: null,
                  
                border: {
                      
                    color: null,
                      
                    width:1.5
                },
                  
                backgroundColor: null,
                  
                direction: "clockwise",   
                  
                showPointers: true,
                  
                showRanges: false,
                  
                showTicks: true,
                  
                showLabels: true,
                  
                showIndicators: false,
				  
                opacity:1,
				  
				shadowOffset:0,                  

				customLabels:[{ 
				
					value: null,
					
					color: null,
					
					textAngle: 0,
					
					positionType: "inner",
					
					position: {
					
						x: 0,
						
						y: 0
					},
					
					font: {
						
						size: "11px",
						
						fontFamily: "arial",
						
						fontStyle: "bold"
					}
				}],
                  
                pointers: [{
                      
                    distanceFromScale: 0,
                      
                    showBackNeedle: false,
                      
                    backNeedleLength: 10,
                      
                    length: 150,
                      
                    placement: "near",   
                      
                    width: 7,
                      
                    opacity: 1,
                    
                      
                    value: null,
                      
                    border: {
                          
                        color: null,
                          
                        width: 1.5
                    },
                      
                    backgroundColor: null,
                      
                    gradients: null,   
                      
                    type: "needle",   
                      
                    needleType: "triangle",   
                      
                    markerType: "rectangle",  
                      
                    imageUrl: "",
                      
                    pointerValueText: {
                          
                        showValue: false,
                          
                        distance: 20,
                          
                        font: {
                              
                            size: "11px",
                              
                            fontFamily: "Arial",
                              
                            fontStyle: "Bold"
                        },
                          
                        color: "#8c8c8c",
                          
                        opacity: 1,
                          
                        autoAngle: false,
                          
                        angle: 0,
                    }
                }],
                  
                ranges: [{

                    legendText: null,
                      
                    distanceFromScale: 25,
                      
                    size: 5,
                      
                    placement: "near",   
                      
                    startValue: null,
                      
                    endValue: null,
                      
                    startWidth: null,
                      
                    endWidth: null,
                      
                    gradients: null,   
                    
                      
                    opacity: null,
                      
                    backgroundColor: "#32b3c6",
                      
                    border: {
                          
                        color: "#32b3c6",
                          
                        width:1.5
                    }
                }],
                  
                ticks: [{
                      
                    angle: 0,
                      
                    distanceFromScale: 0,
                      
                    color:null,
                      
                    type: "major",   
                      
                    placement: "near",   
                      
                    height: 16,
                      
                    width: 3
                }, {
                    angle: 0,
                    distanceFromScale: 0,
                    color:null,
                    type: "minor",   
                    placement: "near",   
                    height: 7,
                    width: 1
                }],
                  
                labels: [{
                      
                    angle: 0,
                      
                    autoAngle:false,
                      
                    opacity: null,
                      
                    font: {
                     
                        size: "11px",
                    
                        fontFamily: "Arial",
                    
                        fontStyle: "Bold"
                    },
                      
                    color: null,
                      
                    distanceFromScale: 0,
                      
                    includeFirstValue: true,
                      
                    placement: "near",   
                      
                    type: "major",  
                      
                    unitText: "",
                      
                    unitTextPosition: "back",  

                }],
                  
                indicators: [{
                      
                    height: 15,
                      
                    width: 15,
                      
                    type: "circle",   
                      
                    imageUrl: null,
                      
                    position: {
                          
                        x: 0,
                          
                        y: 0
                    },
                      
                    stateRanges: [{
                          
                        endValue: 0,
                          
                        startValue: 0,
                          
                        backgroundColor: null,
                          
                        borderColor: null,
                          
                        text: "",
                          
                        textColor: null,
                          
                        font: null
                    }]
                }],                  
                  
                subGauges: [{
                      
                    height: 150,
                      
                    width: 150,
                      
                    position: {
                          
                        x: 0,
                          
                        y: 0
                    }
                }],
                //textAngle ,value:"CustomText", position:{X:5,Y:10}, color, font: { size: "11px", fontFamily: "Arial", fontStyle: "Bold" },
            };
        },
        dataTypes: {
            scales: "data",
            isResponsive: "boolean",
        },
        observables: ["value", "minimum", "maximum"],
        _tags: [{
            tag: "scales",
            attr: ["showScaleBar", "pointerCap.radius", "pointerCap.borderWidth", "pointerCap.interiorGradient", "pointerCap.borderColor", "pointerCap.backgroundColor", "sweepAngle", "startAngle", "showPointers", "showTicks", "backgroundColor", "scaleRadius", "majorIntervalValue", "minorIntervalValue", "shadowOffset", "showRanges", "showLabels", "showCustomLabels", "showIndicators", "border.width", "border.color",
                [{
                    tag: "pointers", attr: ["distanceFromScale", "showBackNeedle", "backNeedleLength", "backgroundColor", "needleType", "markerType", "border.width", "border.color", "imageUrl", "pointerValueText.showValue", "pointerValueText.distance", "pointerValueText.font.size", "pointerValueText.font.fontFamily", "pointerValueText.font.fontStyle", "pointerValueText.angle", "pointerValueText.autoAngle", "pointerValueText.color", "pointerValueText.opacity"]
                }, {
                    tag: "labels", attr: ["autoAngle", "distanceFromScale", "includeFirstValue", "unitText", "unitTextPosition", "font.size", "font.fontFamily", "font.fontStyle"]
                }, {
                    tag: "ticks", attr: ["distanceFromScale"]
                }, {
                    tag: "ranges", attr: ["legendText", "distanceFromScale", "startValue", "endValue", "startWidth", "endWidth", "backgroundColor", "border.color", "border.width"]
                }, {
                    tag: "indicators", attr: ["imageUrl", "position.x", "position.y",
                        [{
                            tag: "stateRanges", attr: ["endValue", "startValue", "backgroundColor", "borderColor", "textColor"]
                        }]
                    ]
                }, {
                    tag: "subGauges", attr: ["controlID", "position.x", "position.y"]
                }, {
                    tag: "customLabels", attr: ["positionType", "textAngle", "position.x", "position.y", "font.size", "font.fontFamily", "font.fontStyle"]
                }]
            ]
        }],
        value: ej.util.valueFunction("value"),
        minimum: ej.util.valueFunction("minimum"),
        maximum: ej.util.valueFunction("maximum"),
 
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "height": this.model.height = options[option]; break;
                    case "width": this.model.width = options[option]; break;
                    case "radius": this.model.radius = options[option]; break;
                    case "frame": $.extend(this.model.frame, options[option]); break;
                    case "tooltip": $.extend(this.model.tooltip, options[option]); break;
                    case "backgroundColor": this.model.backgroundColor = options[option]; break;
                    case "interiorGradient": this.model.interiorGradient = options[option]; break;
                    case "readOnly": this.model.readOnly = options[option]; break;
                    case "theme": this.model.theme = options[option]; break;
                    case "isRadialGradient": this.model.isRadialGradient = options[option]; break;
                    case "outerCustomLabelPosition": this.model.outerCustomLabelPosition = options[option]; break;
                    case "gaugePosition": this.model.gaugePosition = options[option]; break;
                    case "distanceFromCorner": this.model.distanceFromCorner = options[option]; break;
                    case "rangeZOrder ": this.model.rangeZOrder  = options[option]; break;
                    case "value":
                        (this.value() == "") && this.value(0);
                        for (var i = 0; this.model.scales[i] != null; i++) {
                            for (var j = 0; this.model.scales[i].pointers[j] != null; j++) {
                                this.model.scales[i].pointers[j].value = parseFloat(this.value());
                            }
                        }
                        break;
                    case "minimum":
                        (this.minimum() == "") && this.minimum(0);
                        for (var k = 0; this.model.scales[k] != null; k++) {
                            this.model.scales[k].minimum = parseInt(this.minimum());
                        }
                        break;
                    case "maximum":
                        (this.maximum() == "") && this.maximum(100);
                        for (var l = 0; this.model.scales[l] != null; l++) {
                            this.model.scales[l].maximum = parseInt(this.maximum());
                        }
                        break;
                    case "scales":
                        $.extend(true, this.model.scales, options[option]);
                        break;
                }
            }
            this._init();
        },

      
        _destroy: function () {
            this._unWireEvents();
            this.element.empty().removeClass("e-widget");
        },


        // constructor function
		  
        _init: function () {
            _gaugeCount = $(".e-circulargauge").length;
            initialGaugeCount = _gaugeCount;
            //this._isHalfCircle = false;
            this._scaleRedrawn = false;
            this._scalesInitialize();
            this._trigger("load");
            this._setTheme();
            this._initialize();
            this._wireEvents();
            this._onWindowResize();
        },
	 
        _onWindowResize: function () {
            if (this.model.enableResize || this.model.isResponsive) {
                if (!ej.isTouchDevice())
                    this._on($(window), "resize", this.resizeCanvas);
                else
                    this._on($(window), "orientationchange", this.resizeCanvas);
            }
        },
		 
        _initialize: function () {
			//Checks whether canvas animation is supported if the device is android
			this._androidAnimation = this.isAndroid() && ej.datavisualization.CircularGauge.animationPolyfill;			
            this._initObject(this);
            this._drawOuterLayer();
            if (this.model.legend.visible && this.model.legend._legendItemHeight > 0 && this.model.legend._legendItemWidth > 0) {
                this._drawLegend();
                this._legendDrawn = true;
            }
            this._drawScales();         
            if (this.model.renderComplete)
                this._onRenderComplete();
        },

        _drawLegend:function(){
            var legendObj = this.model.legend, legendActualBounds, element = this.GaugeEl, padding = 10, legendSpacing = 20,
                position = this.model.legend.position.toLowerCase(), alignment = this.model.legend.alignment.toLowerCase(),
                legendOptions, borderWidth = this.model.legend.border.width, width = this.model.width, height = this.model.height;
            legendActualBounds = this.model.legendActualBounds;
            if(position == "top" || position == "bottom"){
                legendActualBounds.y = (position == "top") ? borderWidth + legendSpacing : (height - legendActualBounds.Height) - legendSpacing;
                if (alignment == "center")
                    legendActualBounds.x = (width / 2) - (legendActualBounds.Width / 2);
                else if (alignment == "near")
                    legendActualBounds.x = borderWidth + legendSpacing;
                else
                    legendActualBounds.x = (width - legendActualBounds.Width) - legendSpacing;
                legendActualBounds.x = ((legendActualBounds.x + legendActualBounds.Width) > width) ? (legendActualBounds.x - Math.abs((legendActualBounds.x + legendActualBounds.Width) - width)) : legendActualBounds.x;
            }
            else{
                legendActualBounds.x = (position == "left") ? borderWidth + legendSpacing : (width - legendActualBounds.Width) - legendSpacing;
                 if (alignment == "center")
                     legendActualBounds.y = (height / 2) - (legendActualBounds.Height / 2);
                 else if (alignment == "near")
                     legendActualBounds.y = borderWidth + legendSpacing;
                 else
                     legendActualBounds.y = (height - legendActualBounds.Height) - legendSpacing;
                 legendActualBounds.y = ((legendActualBounds.y + legendActualBounds.Height) > height) ? (legendActualBounds.y - Math.abs((legendActualBounds.y + legendActualBounds.Height) - height)) : legendActualBounds.y;
            }
            this._legendBounds = legendActualBounds;
            this.contextEl.lineWidth = borderWidth;
            this.contextEl.save();
            this.contextEl.strokeStyle = this.model.legend.border.color;
            this.contextEl.strokeRect(legendActualBounds.x, legendActualBounds.y, legendActualBounds.Width, legendActualBounds.Height);
            this.contextEl.restore();
            this.model._legendCollection = [];
            for (var i = 0; i < this.model.scales.length; i++) {
                var scale = this.model.scales[i];
                for (var j = 0; j < scale.ranges.length; j++) {
                    var range = scale.ranges[j], currentLegend = {}, itemPadding = 10, legendItemSize;
                    range._visible = (ej.util.isNullOrUndefined(range._visible)) ? true : range._visible;
                    if (!(ej.util.isNullOrUndefined(range.legendText))) {
                        legendItemSize = this._getLegendSize(range, itemPadding);
                        legendOptions = {
                            "Bounds": { Height: legendItemSize.Height, Width: legendItemSize.Width },
                            "legendStyle": { font: legendObj.font, opacity: legendObj.opacity, BorderColor: legendObj.itemStyle.border.color, BorderWidth: legendObj.itemStyle.border.width },
                            "displayText": range.legendText,
                            "fill": (ej.util.isNullOrUndefined(legendObj.fill)) ? range.backgroundColor : legendObj.fill,
                            "ScaleIndex": i,
                            "RangeIndex": j,
                            "visible": range._visible
                        };
                        this.model._legendCollection.push(legendOptions);
                    }
                }
            }
            this._drawLegendItem(legendActualBounds);   
        },

        legendMouseClick: function (evt) {
            var parentLeft, parentTop, element, canvasLeft, canvasTop, offsetLeft, offsetTop, i,
                region, legendX, legendWidth, legendY, legendHeight, args, visible;
            var mouseMoveCords = this.calMousePosition(evt);
            if (this.model.legend.toggleVisibility) {
                for (i = 0; i < this.legendRegion.length; i++) {
                    region = this.legendRegion[i];
                    legendX = region.X
                    legendWidth = region.X + region.Width;
                    legendY = region.Y;
                    legendHeight = region.Y + region.Height;
                    if ((mouseMoveCords.X >= legendX && mouseMoveCords.X <= legendWidth) && (mouseMoveCords.Y >= legendY && mouseMoveCords.Y <= legendHeight)) {
                        args = { type: "legendItemClick", cancel: false, data: region, model: this.model };
                        this._trigger("legendItemClick", args);
                        visible = (this.model.scales[region.item.ScaleIndex].ranges[region.item.RangeIndex]._visible) ? false : true;
                        this.setRangeVisible(region.item.ScaleIndex, region.item.RangeIndex, visible);
                    }
                }
            }
                
        },

        calMousePosition: function (e) {
            var matched = jQuery.uaMatch(navigator.userAgent), element, mouseX, mouseY, browser, node, i;
            element = this.GaugeEl[0];
            node = element.querySelector("canvas");
            browser = matched.browser.toLowerCase();
            mouseX = (e.pageX) - $(node).offset().left;
            mouseY = (e.pageY) - $(node).offset().top;
            return { X: mouseX, Y:mouseY };
        },

        rangesMouseMove: function (evt) {
              var gauge = this, args,element, parentLeft, parentTop, canvasLeft, canvasTop, offsetLeft, offsetTop, i, region, legendX,
                        legendWidth, legendY, legendHeight, element, rectBounds, xOffset, yOffset, mouseX, mouseY, pointData,
                        startAngle, endAngle, gaugeStartAngle, j, distanceFromCenter, rangeRegion;
               var mouseMoveCords = this.calMousePosition(evt);
               if (this.model.legend.toggleVisibility && this._legendDrawn) {
                    for (i = 0; i < this.legendRegion.length; i++) {
                       region = this.legendRegion[i];
                       legendX = region.X;
                       legendWidth = region.X + region.Width;
                       legendY = region.Y;
                       legendHeight = region.Y + region.Height;
                       if ((mouseMoveCords.X >= legendX && mouseMoveCords.X <= legendWidth) && (mouseMoveCords.Y >= legendY && mouseMoveCords.Y <= legendHeight)) {
                           $(this.GaugeEl[0]).css("cursor", "pointer");
                           break;
                       }
                       else
                           $(this.GaugeEl[0]).css("cursor", "default");
                }
             }
             mouseX = mouseMoveCords.X;
             mouseY = mouseMoveCords.Y;
             pointData = [];
             startAngle = this.model.scales[0].startAngle;
             endAngle = this.model.scales[0].sweepAngle;
             gaugeStartAngle = startAngle * (Math.PI / 180);
             for (j = 0; j < this._rangeCollectionRegions.length; j++) {
                 var region = this._rangeCollectionRegions[j], fromCenterX, fromCenterY, innerRadius, totalDegree, circularStartAngle, arcAngle, clickAngle, pointStartAngle, pointEndAngle;
                 fromCenterX = mouseX - region.centerRadius.centerX;
                 fromCenterY = mouseY - region.centerRadius.centerY;
                 innerRadius = region.Radius.endRadius ? region.Radius.endRadius : 0;
                 startAngle = startAngle < 0 ? startAngle + 360 : startAngle;
                 endAngle = endAngle < 0 ? endAngle + 360 : endAngle;
                 totalDegree = endAngle - startAngle;
                 circularStartAngle = (-.5 * Math.PI) + gaugeStartAngle;
                 if (totalDegree < 0) {
                     endAngle = endAngle / 360;
                    arcAngle = (endAngle) ? 2 * Math.PI * (endAngle < 0 ? 1 + endAngle : endAngle) : 0;
                    clickAngle = (Math.atan2(fromCenterY, fromCenterX) - circularStartAngle - arcAngle) % (2 * Math.PI);
                     if (clickAngle < 0)
                         clickAngle = 2 * Math.PI + clickAngle;
                     pointStartAngle = Math.PI * (region.Region.startAngle / 180);
                     pointEndAngle = Math.PI * (region.Region.endAngle / 180);

                     if (clickAngle <= pointStartAngle && clickAngle >= pointEndAngle) {
                         distanceFromCenter = Math.sqrt(Math.pow(Math.abs(fromCenterX), 2) + Math.pow(Math.abs(fromCenterY), 2));
                         if (distanceFromCenter <= region.Radius.startRadius && distanceFromCenter > region.Radius.endRadius) {
                             args = { type: "rangeMouseMove", cancel: false, data: region, model: this.model };
                             this._trigger("rangeMouseMove", args);
                             break;
                         }
                     }
                 }
                 else {
                     clickAngle = (Math.atan2(fromCenterY, fromCenterX)) % (2 * Math.PI);
                     if (clickAngle < 0)
                         clickAngle = 2 * Math.PI + clickAngle;
                     if (region.Region.endAngle < region.Region.startAngle) {
                         pointStartAngle = (fromCenterX > 0 && fromCenterY > 0) ? 0 : Math.PI * ((region.Region.startAngle) / 180);
                         pointEndAngle = (fromCenterX > 0 && fromCenterY > 0) ? Math.PI * ((region.Region.endAngle) / 180) : Math.PI * ((360 + region.Region.endAngle) / 180);
                     }
                     else {
                         pointStartAngle = Math.PI * ((region.Region.startAngle) / 180);
                         pointEndAngle = Math.PI * ((region.Region.endAngle) / 180);
                     }
                     if (clickAngle >= pointStartAngle && clickAngle <= pointEndAngle) {
                             distanceFromCenter = Math.sqrt(Math.pow(Math.abs(fromCenterX), 2) + Math.pow(Math.abs(fromCenterY), 2));
                             if (distanceFromCenter <= region.Radius.startRadius && distanceFromCenter > region.Radius.endRadius) {
                                 rangeRegion = region;
                                 args = { type: "rangeMouseMove", cancel: false, data: region, model: this.model };
                                 this._trigger("rangeMouseMove", args);
                                 break;
                             }                       
                     }
                 }
             }
             return rangeRegion;
    },

        _drawLegendItem: function (legendBounds) {
            var legendItemCollections = [], legendTextCollection = [], args;
            this.legendRegion = [];
            this.model.legend._legendTextMaxHeight = 0; this.model.legend._legendTextMaxWidth = 0;
            var position = this.model.legend.position.toLowerCase();
            for (var i = 0; i < this.model._legendCollection.length; i++) {
                var shape = this.model.legend.shape.toLowerCase(), verPadding = 10, horPadding = 10, txtPadding = 3, itemX, itemY, textX, textY;
                var legendItem, rangeVisible, textStyle, fill, x, y, width, height, fontColor, font, textSize, shapeHeight, shapeWidth, shapeStyle, itemStyle,
                    shapeLocation, itemLocation, space= 10;
                legendItem = this.model._legendCollection[i];
                if (!(ej.util.isNullOrUndefined(legendItem.displayText))) {
                    args = { type: "legendItemRender", cancel: false, data: legendItem, model: this.model };
                    this._trigger("legendItemRender", args);
                    this.model.scales[legendItem.ScaleIndex].ranges[legendItem.RangeIndex]._visible = (ej.util.isNullOrUndefined(this.model.scales[legendItem.ScaleIndex].ranges[legendItem.RangeIndex]._visible)) ? true : this.model.scales[legendItem.ScaleIndex].ranges[legendItem.RangeIndex]._visible;
                    fill = (this.model.scales[legendItem.ScaleIndex].ranges[legendItem.RangeIndex]._visible) ? legendItem.fill : "#808080";
                    fontColor = (this.model.scales[legendItem.ScaleIndex].ranges[legendItem.RangeIndex]._visible) ? legendItem.legendStyle.font.color : "#808080";
                    font = this._getFontString(this, legendItem.legendStyle.font);
                    textSize = this.calcText(legendItem.displayText, legendBounds.Width, legendItem.legendStyle.font);
                    this.model.legend._legendTextMaxHeight = Math.max(textSize.height, this.model.legend._legendTextMaxHeight);
                    this.model.legend._legendTextMaxWidth = Math.max(textSize.width, this.model.legend._legendTextMaxWidth);
                    shapeHeight = this.model.legend.itemStyle.height;
                    shapeWidth = this.model.legend.itemStyle.width;
                    shapeStyle = (shapeHeight + shapeWidth) / 2;
                    itemStyle = {
                        "angle": 0,
                        "width": shapeStyle,
                        "isFill": true,
                        "isStroke": true,
                        "height": shapeStyle,
                        "lineWidth": this.model.legend.itemStyle.border.width,
                        "opacity": legendItem.legendStyle.opacity,
                        "strokeStyle": legendItem.legendStyle.BorderColor,
                        "fillStyle": fill,
                    };
                    verPadding = (shapeStyle > (textSize.height / 2)) ? verPadding + (shapeStyle / 2) : verPadding + textSize.height / 4;
                    horPadding = (shape == "circle") ? (horPadding + (shapeStyle / 2)) : horPadding;                  
                    if (i == 0) {
                       itemX = (horPadding + legendBounds.x);
                       itemY = (legendBounds.y + verPadding);
                    }
                    else {
                        if (position == "top" || position == "bottom") {
                            var xPos = (legendTextCollection[i - 1].x + legendTextCollection[i - 1].width) + (this.model.legend.itemPadding);
                            if ((xPos + shapeStyle + txtPadding + textSize.width) >= (legendBounds.x + legendBounds.Width)) {
                                itemX = (horPadding + legendBounds.x);
                                itemY = ((this.model.legend._legendTextMaxHeight / 2) > shapeStyle) ? (legendTextCollection[i - 1].y + (legendItemCollections[i - 1].actualBounds.height / 2) + shapeStyle / 2) + space : 
								space + legendItemCollections[i - 1].actualBounds.y + (legendItemCollections[i - 1].actualBounds.height / 2) + shapeStyle / 2;
                            }
                            else {
                                itemX = (shape.toLowerCase() == "circle") ? xPos + shapeStyle / 2 : xPos;
                                itemY = (legendItemCollections[i - 1].actualBounds.y);
                            }
                        }
                        else {
                            yPos = (legendTextCollection[i - 1].height > shapeStyle) ? (legendTextCollection[i - 1].y + this.model.legend.itemPadding) : (legendItemCollections[i - 1].actualBounds.y + shapeStyle) + this.model.legend.itemPadding;
                            var temp = (legendTextCollection[i - 1].height > shapeStyle) ? textSize.height : shapeStyle;
                            if ((yPos + temp - 2) > legendBounds.y + legendBounds.Height + 2) {
                                itemY = (legendBounds.y + verPadding);
                                itemX = (legendItemCollections[i - 1].actualBounds.x + legendItemCollections[i - 1].actualBounds.width) + (this.model.legend._legendTextMaxWidth + txtPadding) + 10;
                            }
                            else {
                                itemX = (legendItemCollections[i - 1].actualBounds.x);
                                itemY = yPos;
                            }
                        }
                    }
                    shapeLocation = { startX: itemX, startY: itemY };
                    shape = shape.charAt(0).toUpperCase() + shape.slice(1);
                    itemLocation = $.extend({}, shapeLocation, true);
                    itemLocation.startX = (shape.toLowerCase() == "circle") ? itemLocation.startX - (shapeStyle / 2) : itemLocation.startX;
                    itemLocation.startY = itemLocation.startY - (shapeStyle / 2);
                    legendItemCollections.push({ actualBounds: { x: shapeLocation.startX, y: shapeLocation.startY, height: shapeStyle, width: shapeStyle }, item: legendItem });
                    textStyle = {
                        "angle": 0,
                        "width": textSize.width,
                        "isFill": true,
                        "isStroke": true,
                        "height": textSize.height,
                        "textValue": legendItem.displayText,
                        "font": font,
                        "fillStyle": fontColor,
                        "opacity": legendItem.legendStyle.opacity,
                        "strokeStyle": legendItem.legendStyle.BorderColor,
                    };
                    textX = (shape.toLowerCase() == "circle") ? (shapeLocation.startX + (shapeWidth / 2) + txtPadding) : (shapeLocation.startX + itemStyle.width + txtPadding);
                    textY = shapeLocation.startY + (textSize.height / 4);
                    legendTextCollection.push({ x: textX, y: textY, height: textSize.height / 2, width: textSize.width });
                    x = itemLocation.startX;
                    width = (Math.abs((x + legendItemCollections[i].actualBounds.width) - x) + txtPadding) + (Math.abs((legendTextCollection[i].x + legendTextCollection[i].width) - legendTextCollection[i].x));
                    if ((shapeStyle) > (legendTextCollection[i].height)) {
                        y = itemLocation.startY;
                        height = shapeStyle;
                    }
                    else {
                        y = legendTextCollection[i].y - legendTextCollection[i].height;
                        height = legendTextCollection[i].height;
                    }   
                    if (shape.toLowerCase() == "circle") {
                        style = this._setPointerDimension(itemStyle, this);
                        this._contextOpenPath(style, this);
                        this._setContextRotation(style, this);
                        this.contextEl.arc(shapeLocation.startX, shapeLocation.startY, shapeStyle / 2, 0, 2 * Math.PI);
                        this._contextClosePath(style, this);
                    }
                    else
                        this["_draw" + shape](shapeLocation, itemStyle, this);
                    this._contextOpenPath(textStyle, this);
                    this.contextEl.font = textStyle.font;
                    this.contextEl.translate(textX, textY);
                    this.contextEl.fillText(textStyle.textValue, 0, 0);
                    this._contextClosePath(textStyle, this);
                    this.legendRegion.push({ X: x, Y: y, Width: width, Height: height, item: legendItem });
                }
            }
        },

        calcText: function (text, maxwidth, font) {
            var element = $(document).find("#measureTex");
            var textObj, style = null, size = null, family = null, weight = null, textArray, i, fontarray, bounds;
            $("#measureTex").css('display', 'block'); 
            if (element.length == 0) {
                textObj = document.createElement('text');
                $(textObj).attr({ 'id': 'measureTex' });
                document.body.appendChild(textObj);
            }
            else {
                textObj = element[0];
            }
            if (typeof (text) == "string" && (text.indexOf("<") > -1 || text.indexOf(">") > -1)) {
                textArray = text.split(" ");
                for (i = 0; i < textArray.length; i++) {
                    if (textArray[i].indexOf("<br/>") == -1)
                        textArray[i] = textArray[i].replace(/[<>]/g, '&');
                }
                text = textArray.join(' ');
            }
            textObj.innerHTML = text;
            if (font != undefined && font.size == undefined) {
                fontarray = font;
                fontarray = fontarray.split(" ");
                style = fontarray[0];
                size = fontarray[1];
                family = fontarray[2];
                weight = fontarray[3];
            }
            if (font != null) {
                textObj.style.fontSize = (font.size > 0) ? (font.size + "px") : font.size ? font.size : size;
                if (textObj.style.fontStyle)
                    textObj.style.fontStyle = (font.fontStyle) ? font.fontStyle : style;
                textObj.style.fontFamily = font.fontFamily ? font.fontFamily : family;
                if (window.navigator.userAgent.indexOf('MSIE 8.0') == -1)
                    textObj.style.fontWeight = font.fontWeight ? font.fontWeight : weight;
            }
            textObj.style.backgroundColor = 'white';
            textObj.style.position = 'absolute';
            textObj.style.top = -100;
            textObj.style.left = 0;
            textObj.style.visibility = 'hidden';
            textObj.style.whiteSpace = 'nowrap';
            if (maxwidth)
                textObj.style.maxwidth = maxwidth + "px";
            bounds = { width: textObj.offsetWidth, height: textObj.offsetHeight };
            $("#measureTex").css('display', 'none');
            return bounds;
        },

         _calculateLegendBounds:function(){
            var self = this, legendObj;
            var legendObj = self.model.legend, rangeCount = 0, i, add, position = self.model.legend.position.toLowerCase(), legendSize,
            vericalPadding, horizontalPadding, additionalPadding = 20, space = 10, padd,
            borderWidth = self.model.legend.border.width, itemPadding = self.model.legend.itemPadding, overallMax, bounds, currentWidth, legendMax;
            overallMax = self.findMaxHeightWidth();
            if (this._gaugeResizeState || (ej.util.isNullOrUndefined(self.model.legend.size.height) && ej.util.isNullOrUndefined(self.model.legend.size.width))) {               
                legendMax = self.findLegendMax();
                bounds = { Height: legendMax.Height, Width: legendMax.Width };
                self.model.legend.size._height = self.model.legend.size._width = null;
            }
            else if ((parseInt(self.model.legend.size.width) < overallMax.width && !ej.util.isNullOrUndefined(self.model.legend.size.width)) 
			    || (parseInt(self.model.legend.size.height) < overallMax.height && !ej.util.isNullOrUndefined(self.model.legend.size.height))) {
                legendMax = self.findLegendMax();
                bounds = { Height: legendMax.Height, Width: legendMax.Width };
               self.model.legend.size._height = self.model.legend.size._width = null;
            }
        else {
            self.model.legend._legendItemHeight = 0; self.model.legend._columnWidth= 0, self.model.legend._legendItemWidth = 0, self.model.legend._rowCount = 1,
            self.model.legend._columnCount = 1, self.model.legend._maxWidth = 0, self.model.legend._maxHeight = 0, self._columnIncreasing = 0, self._columnDecreasing= 0;
                $.each(self.model.scales, function (index, element) {
                    if (element.showRanges) {
                        self.scaleIndex = index;
                        if (element.ranges != null) {
                            self.rangeEl = element.ranges;
                            self.index = 0;
                            for (i = 0; i < self.model.scales[self.scaleIndex].ranges.length ; i++) {
                                if (!(ej.util.isNullOrUndefined(self.model.scales[self.scaleIndex].ranges[i].legendText))) {
                                    rangeCount++;
                                }
                            }
                            $.each(element.ranges, function (rangeIndex, rangeElement) {
                                self.rangeIndex = rangeIndex;
                                if (!(ej.util.isNullOrUndefined(rangeElement.legendText)) && (rangeElement.legendText.replace(/\s/g,"").length > 0) && self.index < rangeCount) {
                                    legendSize = self._getLegendSize(rangeElement);
                                    if (parseInt(self.model.legend.size.width)) {
                                            horizontalPadding = (self.index == 0) ? (space + borderWidth) : (position == "top" || position == "bottom") ? itemPadding : space;
                                            vericalPadding = (self.index == 0) ? (space + borderWidth) : 0;
                                            legendObj._legendItemWidth =  (position == "top" || position == "bottom") ? (horizontalPadding + legendSize.Width + legendObj._legendItemWidth) : 
											                              (horizontalPadding + overallMax.width + legendObj._legendItemWidth);
                                            legendObj._legendItemHeight = vericalPadding + Math.max(legendSize.Height, legendObj._legendItemHeight);
                                            self._columnIncreasing++;
                                            self._columnDecreasing = Math.max(self._columnDecreasing, self._columnIncreasing);
                                            if (parseInt(self.model.legend.size.width) <= legendObj._legendItemWidth) {
                                                self.model.legend._rowCount++;
                                                self._columnIncreasing = 0;
                                                legendObj._legendItemHeight += (position == "top" || position == "bottom") ? (self.index == rangeCount - 1) ? (legendSize.Height + space * 2) : legendSize.Height + space :
                                                                               (self.index == rangeCount - 1) ? (legendSize.Height + space + itemPadding) : (legendSize.Height + itemPadding);
                                                 legendObj._legendItemWidth = (position == "top" || position == "bottom") ? (self.index == rangeCount - 1) ? parseInt(self.model.legend.size.width) : 
												                               legendSize.Width + space : overallMax.width + space;
                                            } else if (self.index == rangeCount - 1 && self.model.legend._rowCount > 1) {
                                                legendObj._legendItemHeight += space;
                                                self.model.legend.size._width = self.model.legend.size.width;
                                                if (parseInt(self.model.legend.size.width) > (overallMax.width * (self._columnDecreasing - 1)) + ((self._columnDecreasing - 1) * space) + space) {
                                                    legendObj._legendItemWidth = (overallMax.width * (self._columnDecreasing - 1)) + ((self._columnDecreasing - 1) * space) + space;
                                                    self.model.legend.size._width = null;
                                                } 
                                            }
                                    }
                                    else {
                                        if (position == "left" || position == "right") {
                                            horizontalPadding = (self.index == 0) ? (space + borderWidth) : (self.index == rangeCount - 1) ? space : 0;
                                            vericalPadding = (self.index == 0) ? (space + borderWidth) : itemPadding;
                                            legendObj._legendItemWidth = horizontalPadding + Math.max(overallMax.width, legendObj._legendItemWidth);
                                            legendObj._legendItemHeight = (vericalPadding + legendSize.Height + legendObj._legendItemHeight);
											self.model.legend.size._height = parseInt(self.model.legend.size.height);
                                            if (parseInt(self.model.legend.size.height) < legendObj._legendItemHeight) {
                                                self.model.legend._rowCount++;
                                                legendObj._legendItemWidth += (self.index == rangeCount - 1) ? (overallMax.width + space * 2) : overallMax.width + space;
                                                legendObj._legendItemHeight = legendSize.Height + space;
                                            }
                                            else if (rangeCount == 1 && parseInt(self.model.legend.size.height) > legendObj._legendItemHeight){
                                                self.model.legend.size._height = null;
                                                legendObj._legendItemWidth += space;
                                                legendObj._legendItemHeight += space;
                                            }
                                        }
                                        else {
                                            legendMax = self.findLegendMax();
                                            bounds = { Height: legendMax.Height, Width: legendMax.Width };
                                            self.index = rangeCount - 1;
                                        }
                                    }
                                }
                                self.index++;
                            });
                        }
                    }
                });
                bounds = { Height: legendObj._legendItemHeight, Width: legendObj._legendItemWidth };
            }
            return bounds;
        },

       findLegendMax:function(){
            var self = this, legendObj;
            self.model.legend._legendItemHeight = 0; self.model.legend._rowWidth = 0; self.model.legend._legendItemWidth = 0, self.model.legend._rowCount = 1,
            self.model.legend._columnCount = 1, self.model.legend._maxWidth = 0, self.model.legend._maxHeight = 0;
            var legendObj = self.model.legend, rangeCount = 0, i, add, position = self.model.legend.position.toLowerCase(), legendSize,
            vericalPadding, horizontalPadding, additionalPadding = 20, space = 10, padd,
            borderWidth = self.model.legend.border.width, itemPadding = self.model.legend.itemPadding, currentWidth;
            self.model.legend.size._height = self.model.legend.size._width = null;
            $.each(self.model.scales, function (index, element) {
                if (element.showRanges) {
                    self.scaleIndex = index;
                    if (element.ranges != null) {
                        self.rangeEl = element.ranges;
                        self.index = 0;
                        for (i = 0; i < self.model.scales[self.scaleIndex].ranges.length ; i++) {
                            if (!(ej.util.isNullOrUndefined(self.model.scales[self.scaleIndex].ranges[i].legendText))) {
                                rangeCount++;
                            }
                        }
                        $.each(element.ranges, function (rangeIndex, rangeElement) {
                            self.rangeIndex = rangeIndex;
                            if (!(ej.util.isNullOrUndefined(rangeElement.legendText))) {  
                                legendSize = self._getLegendSize(rangeElement);
                                    if (position == "top" || position == "bottom") {
                                        if (rangeCount != 1) {
                                            horizontalPadding = (self.index == 0) ? (space * 2) + (borderWidth) : (self.index == rangeCount - 1) ? (space + itemPadding) : itemPadding;
                                            vericalPadding = (self.index == 0) ? space : (self.index == rangeCount - 1) ? space : 0;
                                        }
                                        else
                                            vericalPadding = horizontalPadding = (space * 2);
                                        legendObj._legendItemHeight = vericalPadding + Math.max(legendSize.Height, legendObj._legendItemHeight);
                                        legendObj._maxHeight = Math.max(legendSize.Height, legendObj._maxHeight);
                                        legendObj._legendItemWidth = (horizontalPadding + legendSize.Width + legendObj._legendItemWidth);
                                        padd = (self.model.legend._rowCount > 1 && self.index == rangeCount - 1) ? space : 0;
                                        if ((self.model.width - (additionalPadding - borderWidth)) <= legendObj._legendItemWidth - padd) {
                                            self.model.legend._rowCount++;
                                            legendObj._rowWidth = Math.max( legendObj._rowWidth,(legendObj._legendItemWidth - itemPadding - legendSize.Width));
                                            legendObj._legendItemWidth = (self.index == rangeCount - 1) ? (legendObj._rowWidth < (self.model.width - (additionalPadding * 2))) ? legendObj._rowWidth : (self.model.width - (additionalPadding * 2))   : 
											                             (self.index == 0) ? additionalPadding + space + (borderWidth) : legendSize.Width + additionalPadding + space + (borderWidth);
                                            legendObj._legendItemHeight += legendObj._maxHeight + (space + borderWidth);
                                        }
                                        else if ((self.index == rangeCount - 1) && self.model.legend._rowCount > 1)
                                            legendObj._legendItemWidth = (legendObj._rowWidth < (self.model.width - (additionalPadding * 2))) ? legendObj._rowWidth : (self.model.width - (additionalPadding * 2));
                                    }
                                    else {
                                        if (rangeCount != 1) {
                                            vericalPadding = (self.index == 0) ? (space + borderWidth) : (self.index == rangeCount - 1) ? (space + itemPadding) : itemPadding;
                                            horizontalPadding = (self.index == 0) ? space : (self.index == rangeCount - 1) ? space * 2 : 0;
                                        }
                                        else
                                            vericalPadding = horizontalPadding = (space * 2);

                                        legendObj._legendItemHeight = legendSize.Height + vericalPadding + legendObj._legendItemHeight;
                                        legendObj._legendItemWidth = horizontalPadding + Math.max(legendSize.Width, legendObj._legendItemWidth);
                                        legendObj._maxWidth = Math.max(legendSize.Width, legendObj._maxWidth);

                                        if ((self.model.height - additionalPadding) < legendObj._legendItemHeight) {
                                            self.model.legend._columnCount++;
                                            add = (self.model.legend._columnCount == 2) ? additionalPadding : 0;
                                            legendObj._legendItemHeight = (self.index == rangeCount - 1) ? (self.model.height - (additionalPadding * 2)) : legendSize.Height + additionalPadding + space + borderWidth + add;
                                            legendObj._legendItemWidth += legendObj._maxWidth + space;
                                        }
                                        else if ((self.index == rangeCount - 1) && self.model.legend._columnCount > 1) {
                                            legendObj._legendItemHeight = self.model.height - (additionalPadding * 2);
                                        }

                                    }
                                    self.index++;
							}
						});
					}
                 }
            });
            return { Height: legendObj._legendItemHeight, Width: legendObj._legendItemWidth };
	   },
	   
        findMaxHeightWidth: function () {
            var self = this, overallHeight = 0, overallWidth = 0, size;
            $.each(self.model.scales, function (index, element) {
                $.each(element.ranges, function (rangeIndex, rangeElement) {
                    size = self._getLegendSize(rangeElement);
                    overallHeight = Math.max(size.Height, overallHeight);
                    overallWidth = Math.max(size.Width, overallWidth);
                });
            });
            return { height: overallHeight, width: overallWidth };
        },

        _getLegendSize: function (range) {
            var eqaualPadding = 3, shapeStyle, textSize, itemHeight, itemWidth, font = this.model.legend.font;
            shapeStyle = (this.model.legend.itemStyle.width + this.model.legend.itemStyle.height) / 2;
            textSize = this.calcText(range.legendText, null, font);
            itemHeight = Math.max(shapeStyle, (textSize.height / 2));
            itemWidth = shapeStyle + eqaualPadding + textSize.width;
            return {Height:itemHeight,Width:itemWidth};
        },

        _scalesInitialize: function () {
            var proxy = this;
            if (this.model.scales != null) {
                $.each(this.model.scales, function (index, element) {
                    element = proxy._checkArrayObject(element, index);
                    var obj = proxy._defaultScaleValues();
                    $.extend(obj, element);
                    $.extend(element, obj);
                });
            }
            else {
                this.model.scales = [this._defaultScaleValues()];
            }
        },
		 
        _checkArrayObject: function (element, initialName) {
            var proxy = this;            
            var type;
            $.each(element, function (name, innerElement) {
                type = typeof name;
                if ((type != "string" || (type == "string" && name.indexOf('_') == -1 && name.indexOf('__') == -1)) && typeof innerElement != "function") {
                    if (innerElement instanceof Array) {
                        proxy._checkArrayObject(innerElement, name);
                    }
                    else if (innerElement != null && typeof innerElement == "object" && !innerElement.setter && !innerElement.factory && !innerElement.key) {
                        var allObjects = proxy._defaultScaleValues();
                        proxy._LoadIndividualDefaultValues(innerElement, allObjects, (typeof name === "number") ? initialName : name);
                    }
                }
            });
            return element;
        },
	 	
        _LoadIndividualDefaultValues: function (obj, allObjects, name) {
            var defaultObj = null;
            var proxy = this;
            var type;
            $.each(allObjects, function (n, element) {
                if (name == n) {
                    defaultObj = element;
                    return;
                }
            });
            if (defaultObj instanceof Array) defaultObj = defaultObj[0];
            type = typeof name;
            $.each(obj, function (objName, ele) {
                if (ele instanceof Array) {
                    proxy._checkArrayObject(ele, name);
                }
                else if (ele != null && typeof ele == "object" && (type != "string" || (type == "string" && name.indexOf('_') == -1 && name.indexOf('__') == -1))) {
                    proxy._LoadIndividualDefaultValues(ele, ele, (typeof objName === "number") ? name : objName);
                }
            });

            $.extend(defaultObj, obj);
            $.extend(obj, defaultObj);
            return obj;
        },
	 	
        _initObject: function (element) {
            this._savedPoints=[];
            this.element.addClass("e-widget");
            element.GaugeEl = this.element;
            if (element.canvasEl) {
                element.canvasEl.remove();
                element.GaugeEl.empty();
            }
            else
                element.canvasEl = $("<canvas></canvas>");
                var outerLabelCount=0;
            for (var i = 0; this.model.scales[i] != null; i++) {
                if (this.model.scales[i].minimum == null)
                    this.model.scales[i].minimum = this.minimum();
                if (this.model.scales[i].maximum == null)
                    this.model.scales[i].maximum = this.maximum();
                for (var j = 0; this.model.scales[i].pointers[j] != null; j++) {
                    if (this.model.scales[i].pointers[j].value == null)
                        this.model.scales[i].pointers[j].value = this.value();
                }
                for (var k = 0; this.model.scales[i].customLabels[k] != null; k++) {
                    if (this.model.scales[i].customLabels[k].value != null) {
					  outerLabelCount++;
					  if (element.GaugeEl.find('div').length == 0) {
                        if (this.model.scales[i].customLabels[k] != null && this.model.scales[i].customLabels[k].positionType !=null && this.model.scales[i].customLabels[k].positionType == "outer") {
                            element.outerDiv = ej.buildTag("div");
                            if (element.model.outerCustomLabelPosition == "bottom") {
                                element.GaugeEl.append(element.canvasEl);
                                element.GaugeEl.append(element.outerDiv);
                                element.outerDiv.css('text-align', 'center');
                            }
                            else {
                                if (element.model.outerCustomLabelPosition != "top") {
                                    var table = ej.buildTag("TABLE");
                                    table.css('width', '100%');
                                    var tr = ej.buildTag("TR");
                                    var td1 = ej.buildTag("TD");
                                    var td2 = ej.buildTag("td");
                                    if (element.model.outerCustomLabelPosition == "left") {
                                        td1.append(element.outerDiv);
                                        td2.append(element.canvasEl);
                                    }
                                    else {
                                        td1.append(element.canvasEl);
                                        td2.append(element.outerDiv);
                                    }
                                    tr.append(td1);
                                    tr.append(td2);
                                    table.append(tr);
                                    element.GaugeEl.append(table);
                                    element.outerDiv.css({
                                        'width': this.element.width() - element.model.width
                                    });
                                }
                                else {
                                    element.GaugeEl.append(element.outerDiv);
                                    element.GaugeEl.append(element.canvasEl);
                                    element.outerDiv.css('text-align', 'center');
                                }
                            }
                        }
                        else
                            element.GaugeEl.append(element.canvasEl);
                    }
                  }
				}
                if (outerLabelCount==0)
                    element.GaugeEl.append(element.canvasEl);
            }
            element.canvasEl.attr("role", "presentation");
            if (_gaugeCount == initialGaugeCount)
            {
                initialDivWidth = window.innerWidth;
            }
            element.canvasEl[0].setAttribute("width", element.model.width);
            element.canvasEl[0].setAttribute("height", element.model.height);
            element.centerX = element.canvasEl[0].width / 2;
            element.centerY = element.canvasEl[0].height / 2;
            var padding = 20, maxRadius, legendActualBounds, position, height, width;
            if (this.model.legend.visible) {
			    if (this.model.theme == "flatdark") this.model.legend.font.color = (ej.util.isNullOrUndefined(this.model.legend.font.color)) ? "#8c8c8c" : this.model.legend.font.color;
                else this.model.legend.font.color = (ej.util.isNullOrUndefined(this.model.legend.font.color)) ? "#282828" : this.model.legend.font.color;
                position = this.model.legend.position.toLowerCase();
                legendActualBounds = this._calculateLegendBounds();
                legendActualBounds.Height = (ej.util.isNullOrUndefined(this.model.legend.size._height)) ? legendActualBounds.Height : parseInt(this.model.legend.size.height);
                legendActualBounds.Width = (ej.util.isNullOrUndefined(this.model.legend.size._width)) ? legendActualBounds.Width : parseInt(this.model.legend.size.width);
                this.model.legendActualBounds = legendActualBounds;
                if (legendActualBounds.Height > 0 && legendActualBounds.Width > 0) {
                    switch (position) {
                        case "top":
                            height = (element.model.height - (legendActualBounds.Height + padding));
                            element.centerY = (legendActualBounds.Height + padding) + height / 2;
                            maxRadius = (height / 2) - padding;
                            break;
                        case "bottom":
                            element.centerY = (element.model.height - (legendActualBounds.Height + padding)) / 2;
                            maxRadius = element.centerY - padding;
                            break;
                        case "left":
                            width = (element.model.width - (legendActualBounds.Width + padding));
                            element.centerX = (legendActualBounds.Width + padding) + (width / 2);
                            maxRadius = (width / 2) - (padding * 2);
                            break;
                        case "right":
                            element.centerX = (element.model.width - (legendActualBounds.Width + padding)) / 2;
                            maxRadius = element.centerX - (padding * 2);
                            break;
                    }

                    for (var i = 0; i < this.model.scales.length; i++) {
                        var scale = this.model.scales[i], totalSize = 0, rangeSize;
                        if (!this._scaleRedrawn)
                            scale._radius = scale.radius;
                        $.each(scale.ranges, function (rangeIndex, rangeElement) { totalSize += rangeElement.size; });
                        rangeSize = totalSize / scale.ranges.length;
                        maxRadius = Math.abs((maxRadius - rangeSize) / (i + 1));
                        maxRadius = scale.radius = (scale._radius < maxRadius) ? scale._radius : maxRadius;
                    }
                }
            }
            else
                $.each(this.model.scales, function (scaleIndex, scaleElement) {
                    scaleElement.radius = (!ej.util.isNullOrUndefined(scaleElement._radius)) ? scaleElement._radius : scaleElement.radius;
                });
            
            if (this._isHalfCircle && this._isHalfCircle()) {
                if ((element.model.frame.halfCircleFrameEndAngle - element.model.frame.halfCircleFrameStartAngle) >= 180) {
                    if (element.model.frame.halfCircleFrameStartAngle == 0) {
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = element.model.width / 2;
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.width - (element.model.radius + element.model.distanceFromCorner);
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.width / 2;
                                break;
                            case "middleleft":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "middleright":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = element.model.width - (element.model.radius + element.model.distanceFromCorner);
                                break;
                            case "bottomleft":
                                element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                                element.centerX = element.model.width - (element.model.radius + element.model.distanceFromCorner);
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                                element.centerX = element.model.width / 2;
                                break;
                        }
                    }
                    else if(element.model.frame.halfCircleFrameStartAngle == 90){
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = element.model.height / 2;
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.distanceFromCorner + element.model.radius;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                            case "middleleft":
                                element.centerY = element.model.height / 2;
                                element.centerX = element.model.distanceFromCorner + element.model.radius;
                                break;
                            case "middleright":
                                element.centerY = element.model.height / 2;
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "bottomleft":
                                element.centerY = element.model.height - (element.model.distanceFromCorner + element.model.radius);
                                element.centerX = element.model.distanceFromCorner + element.model.radius;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - (element.model.distanceFromCorner + element.model.radius);;
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height - (element.model.distanceFromCorner + element.model.radius);;
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                        }
                    }
                    else if (element.model.frame.halfCircleFrameStartAngle == 180) {
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = (element.model.height / 2) + (element.model.radius / 2);
                                element.centerX = element.model.width / 2;
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.distanceFromCorner + element.model.radius;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.width / 2;
                                break;
                            case "middleleft":
                                element.centerY = element.model.height / 2 + element.model.radius / 2;
                                element.centerX = element.model.distanceFromCorner + element.model.radius;
                                break;
                            case "middleright":
                                element.centerY = element.model.height / 2 + element.model.radius / 2;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "bottomleft":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = element.model.distanceFromCorner + element.model.radius;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = element.model.width / 2;
                                break;
                        }
                    }
                }
                else if (element.model.frame.halfCircleFrameStartAngle == 270 && element.model.frame.halfCircleFrameEndAngle == 90) {
                    switch (element.model.gaugePosition) {
                        case "center":
                            element.centerY = element.model.height / 2;
                            element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                            break;
                        case "topleft":
                            element.centerY = element.model.radius + element.model.distanceFromCorner;
                            element.centerX = element.model.distanceFromCorner;
                            break;
                        case "topright":
                            element.centerY = element.model.radius + element.model.distanceFromCorner;
                            element.centerX = element.model.width - (element.model.radius + element.model.distanceFromCorner);
                            break;
                        case "topcenter":
                            element.centerY = element.model.radius + element.model.distanceFromCorner;
                            element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                            break;
                        case "middleleft":
                            element.centerY = element.model.height / 2;
                            element.centerX = element.model.distanceFromCorner;
                            break;
                        case "middleright":
                            element.centerY = element.model.height / 2;
                            element.centerX = element.model.width - (element.model.radius + element.model.distanceFromCorner);
                            break;
                        case "bottomleft":
                            element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                            element.centerX = element.model.distanceFromCorner;
                            break;
                        case "bottomright":
                            element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                            element.centerX = element.model.width - (element.model.radius + element.model.distanceFromCorner);
                            break;
                        case "bottomcenter":
                            element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                            element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                            break;
                    }
                }
                else if ((element.model.frame.halfCircleFrameEndAngle - element.model.frame.halfCircleFrameStartAngle) <= 90) {
                    if (element.model.frame.halfCircleFrameStartAngle == 0) {
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.distanceFromCorner;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                                break;
                            case "middleleft":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);;
                                element.centerX = element.model.distanceFromCorner;
                                break;
                            case "middleright":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "bottomleft":
                                element.centerY = element.model.height - (element.model.distanceFromCorner + element.model.radius);
                                element.centerX = element.model.distanceFromCorner;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - (element.model.distanceFromCorner + element.model.radius);
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height - (element.model.distanceFromCorner + element.model.radius);
                                element.centerX = (element.model.width / 2) - (element.model.radius/2);
                                break;
                        }
                    }
                    else if (element.model.frame.halfCircleFrameStartAngle == 90) {
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = (element.model.width/2) + (element.model.radius/2);
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner;
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                            case "middleleft":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "middleright":
                                element.centerY = (element.model.height / 2) - (element.model.radius / 2);
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "bottomleft":
                                element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height - (element.model.radius + element.model.distanceFromCorner);
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                        }
                    }
                    else if (element.model.frame.halfCircleFrameStartAngle == 180) {
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = (element.model.height / 2) + (element.model.radius / 2);
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                            case "middleleft":
                                element.centerY = (element.model.height / 2) + (element.model.radius / 2);
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "middleright":
                                element.centerY = (element.model.height / 2) + (element.model.radius / 2);
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "bottomleft":
                                element.centerY=element.model.height-element.model.distanceFromCorner;
                                element.centerX = element.model.radius + element.model.distanceFromCorner;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = element.model.width - element.model.distanceFromCorner;
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = (element.model.width / 2) + (element.model.radius / 2);
                                break;
                        }
                    }
                    else if (element.model.frame.halfCircleFrameStartAngle == 270) {
                        switch (element.model.gaugePosition) {
                            case "center":
                                element.centerY = (element.model.radius / 2) + (element.model.height / 2);
                                element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                                break;
                            case "topleft":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.distanceFromCorner;
                                break;
                            case "topright":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "topcenter":
                                element.centerY = element.model.distanceFromCorner + element.model.radius;
                                element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                                break;
                            case "middleleft":
                                element.centerY = (element.model.height / 2) + (element.model.radius / 2);
                                element.centerX = element.model.distanceFromCorner;
                                break;
                            case "middleright":
                                element.centerY = (element.model.radius / 2) + (element.model.height / 2);;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "bottomleft":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = element.model.distanceFromCorner;
                                break;
                            case "bottomright":
                                element.centerY = element.model.height - element.model.distanceFromCorner;
                                element.centerX = element.model.width - (element.model.distanceFromCorner + element.model.radius);
                                break;
                            case "bottomcenter":
                                element.centerY = element.model.height-element.model.distanceFromCorner;
                                element.centerX = (element.model.width / 2) - (element.model.radius / 2);
                                break;
                        }
                    }
                }
            }
            var elem = element.canvasEl[0];
            if (typeof window.G_vmlCanvasManager != "undefined") {
                elem = window.G_vmlCanvasManager.initElement(elem);
            }
            if (!elem || !elem.getContext) {
                return;
            }
            element.contextEl = element.canvasEl[0].getContext("2d");
        },
        _browserInfo: function () {
            var browser = {}, clientInfo = [],
            browserClients = {
                webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
                opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
            };
            for (var client in browserClients) {
                if (browserClients.hasOwnProperty(client)) {
                    clientInfo = navigator.userAgent.match(browserClients[client]);
                    if (clientInfo) {
                        browser.name = clientInfo[1].toLowerCase();
                        browser.version = clientInfo[2];
                        if (!!navigator.userAgent.match(/Trident\/7\./)) {
                            browser.name = "msie";
                        }
                        break;
                    }
                }
            }
            browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
            browser.pointerEnabled = window.navigator.pointerEnabled;
            return browser;
        },
		 	
        _wireEvents: function () {
            var matched = jQuery.uaMatch(navigator.userAgent),
                browserInfo = this._browserInfo(),
                isPointer = browserInfo.isMSPointerEnabled,
	            isIE11Pointer = browserInfo.pointerEnabled;
            this.startEv = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
            this.endEv = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
            this.moveEv = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
            this.leaveEv = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchleave mouseleave",
            this.scrollEv = matched.browser.toLowerCase() == "mozilla" ? (isIE11Pointer ? "mousewheel" : "DOMMouseScroll") : "mousewheel";
            this.model.browserInfo = browserInfo;
            
            var action= this.model.readOnly? 'pan-y pan-x' : 'none';
            $(this.element).css('touch-action', action);
            
            this.onMouseMoveHandler = $.proxy(this._onMouseMove, this);
            this.onMouseUpHandler = $.proxy(this._onMouseUp, this);
            this.onMouseDownHandler = $.proxy(this._onMouseDown, this);
            this.onHoverOCustomLabel = $.proxy(this._onHoverOCustomLabel, this);
            this.onLeaveOCustomLabel = $.proxy(this._onLeaveOCustomLabel, this);
            if (this.model.legend.visible){
                this._on($(this.canvasEl), "click", this.legendMouseClick);
            }
            this._on($(this.canvasEl), "mousemove", this.rangesMouseMove);
            if (this.model.tooltip.showCustomLabelTooltip || this.model.tooltip.showLabelTooltip) {
                $(this.canvasEl).bind(this.moveEv, this.onMouseMoveHandler);
                $(this.canvasEl).bind(this.scrollEv, this.onMouseMoveHandler);
                $(this.canvasEl).bind(this.startEv, this.onMouseDownHandler);
                $(this.canvasEl).bind(this.endEv, this.onLeaveOCustomLabel);
                $(this.canvasEl).bind(this.leaveEv, this.onLeaveOCustomLabel);
            }
            if (!this.model.readOnly) {
                $(this.canvasEl).bind(this.startEv, this.onMouseDownHandler);
            }
            if (this.model.tooltip.showCustomLabelTooltip){
                $('.'+this._id + 'outercustomlbl').bind("mouseenter", this.onHoverOCustomLabel);
                $('.' + this._id + 'outercustomlbl').bind("this.leaveEv", this.onLeaveOCustomLabel);
            }
        },
		 
        _unWireEvents: function () {
            $(this.canvasEl).unbind(this.startEv, this.onMouseDownHandler);
        },
       
        _onHoverOCustomLabel: function(e) {
            if (e.currentTarget.innerHTML!=null || e.currentTarget.innerHTML!="")
                this._showTooltip(e, e.currentTarget.innerHTML);
        },
      
        _onLeaveOCustomLabel: function (evt) {
            if (this.isTouch(evt)) {
                this._performTooltip(evt);
                window.clearTimeout(this.model.timer);
				this.model.timer = setTimeout(function () {
					$('.tooltipDiv').fadeOut(500);
	            }, 1200);
            }
            else {
                this._hideTooltip();
            }
        },
     
        isTouch: function (evt) {
            var event = evt.originalEvent ? evt.originalEvent : evt;
            if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        },

        _showTooltip: function (event, val) {
			var locale = this.model.locale;
            var tooltipText = (locale && this.model.enableGroupSeparator) ? val.toLocaleString(locale) : val.toString();
            var tooltipdiv = $('.tooltipDiv');
            if (tooltipdiv.length == 0) {
                tooltipdiv = $("<div class='tooltipDiv' style='pointer-events:none; position: absolute; z-index: 105; display: block;'></div>");
                $(document.body).append(tooltipdiv);
            }
            if (this.model.tooltip.templateID != "" && this.model.tooltip.templateID != null) {
                var cloneNode = $("#" + this.model.tooltip.templateID).clone();
                $('.tooltipDiv')[0].innerHTML = "";
                $(cloneNode).css("display", "block").appendTo(tooltipdiv);
                $(tooltipdiv).css({
                    'pointer-events': 'none',
                    'background-color': this.model.backgroundColor,
                    'border': '1px solid #bbbcbb',
                    'border-radius': '3px',
                    'color': '#565656'
                });
                tooltipdiv.html(tooltipdiv.html().replace('#label#', tooltipText));
            } else {
                $(tooltipdiv).html(tooltipText);
                $(tooltipdiv).css({
                'pointer-events':'none',
                'background-color': 'white',
                'border': '2px solid #bbbcbb',
                'position': 'absolute',
                'padding': '10px 20px',
                'margin-top': '5px',
                'text-align': 'left',
                'font': '12px Segoe UI',
                'font-stretch': 'condensed',
                'display': 'inline-block',
                'border-radius': '3px',
                'color': '#565656',
                'width': 'auto'
                });
            }
            var tooltipMargin = 10;
            var xPos = event.pageX + tooltipMargin;
            var yPos = event.pageY + tooltipMargin;
            xPos = (((xPos + $(tooltipdiv).width())  < this.model.width)) ? (xPos) : (xPos - $(tooltipdiv).width());
            yPos = ((yPos + $(tooltipdiv).height()) < this.model.height) ? (yPos) : (yPos - $(tooltipdiv).height());
            $(tooltipdiv).css("left", xPos);
            $(tooltipdiv).css("top", yPos);
            $('.tooltipDiv').show();
        },
       
        _hideTooltip: function () {
            $('.tooltipDiv').remove();//.fadeOut(0, "linear");
        },
	 
        _onMouseDown: function (e) {
            this._blockDefaultActions(e);
            this._mouseDown = true;
            var padding = this.isTouch(e) ? 10 : 0;
            var touch = e.originalEvent.touches ? e.originalEvent.touches[0] : e;
            var startPoint = { "x": this.centerX, "y": this.centerY };
            var endPoint = { "x": touch.pageX - $(this.canvasEl).offset().left, "y": touch.pageY - $(this.canvasEl).offset().top };
            var indegree = 180 * this._getCirucumferenceAngle(startPoint, endPoint) / Math.PI;
            var scaleRadius, majorTickHeight, self = this;
            if (!this.model.readOnly) {
                $.each(this.model.scales, function (index, element) {
                    self.scaleIndex = index;
                    if (element.pointers != null) {
                        self.pointerEl = element.pointers;
                        scaleRadius = element.radius;
                        majorTickHeight = element.ticks[0].height;
                        $.each(element.pointers, function (pointerIndex, pointerElement) {
                            if (self._isHalfCircle())
                                element.showBackNeedle = false;
                            var angle = self._getAngle(pointerElement.value);
                            if (angle > 360)
                                angle = angle - 360;
                            var greatervalue = angle + pointerElement.width;
                            var lesservalue = angle - pointerElement.width;
                            var radius = Math.sqrt((endPoint.x - startPoint.x) * (endPoint.x - startPoint.x) + (endPoint.y - startPoint.y) * (endPoint.y - startPoint.y));
                            //condition added for the markerpointer whether the user mousedown is made on marker pointer location or not.
                            var cond = radius < ((pointerElement.placement == "far") ? scaleRadius + pointerElement.width + pointerElement.distanceFromScale : (pointerElement.placement == "center") ? scaleRadius - pointerElement.distanceFromScale : scaleRadius - 15 - majorTickHeight - pointerElement.distanceFromScale) && radius > ((pointerElement.placement == "far") ? scaleRadius + pointerElement.distanceFromScale : (pointerElement.placement == "center") ? scaleRadius - pointerElement.width - pointerElement.distanceFromScale : scaleRadius - pointerElement.width - 15 - majorTickHeight - pointerElement.distanceFromScale);
                            var chkPointerType = (pointerElement.type == "needle") ? radius <= pointerElement.length : cond;
                            if (self._isBetween(lesservalue, greatervalue, indegree, padding) && chkPointerType) {
                                self._onMouseClick(angle, element.value);
                                self.activeElement = pointerElement;
                                $(document).bind(self.moveEv, self.onMouseMoveHandler);
                                $(document).bind(self.endEv, self.onMouseUpHandler);
                            }
                        });
                    }
                });
            }
        },
	 
        _onMouseUp: function () {
            this._mouseDown=false;
            $(document).unbind(self.moveEv, self.onMouseMoveHandler);
            $(document).unbind(self.endEv, self.onMouseUpHandler);
            if (this.activeElement)
                this._onMouseClickUp(this._getAngle(this.activeElement.value), this.activeElement.value);
            this.activeElement = null;
        },
        _mousePosition: function (evt) {
            if (!ej.util.isNullOrUndefined(evt.pageX) && evt.pageX > 0)
                return { x: evt.pageX, y: evt.pageY };
            else if (evt.originalEvent && !ej.util.isNullOrUndefined(evt.originalEvent.pageX) && evt.originalEvent.pageX > 0)
                return { x: evt.originalEvent.pageX, y: evt.originalEvent.pageY };
            else if (evt.originalEvent && evt.originalEvent.changedTouches != undefined) {
                if (!ej.util.isNullOrUndefined(evt.originalEvent.changedTouches[0].pageX) && evt.originalEvent.changedTouches[0].pageX > 0)
                    return { x: evt.originalEvent.changedTouches[0].pageX, y: evt.originalEvent.changedTouches[0].pageY };
            }
            else
                return { x: 0, y: 0 };

        },
        _calTouchPosition: function (e) {
            var matched = jQuery.uaMatch(navigator.userAgent);
            var mouseposition = this._mousePosition(e);
            e.pageX = mouseposition.x;
            e.pageY = mouseposition.y;
        },
        getEvent: function (event) {
            return (event.targetTouches && event.targetTouches[0]) ? event.targetTouches[0] : event
        },
        _onMouseMove: function (e) {
            if (this._mouseDown && !ej.isNullOrUndefined(this.activeElement)) {
                this._blockDefaultActions(e);
                var startPoint = { "x": this.centerX, "y": this.centerY };
                var touch = e.originalEvent.touches ? e.originalEvent.touches[0] : e;
                var endPoint = { "x": touch.pageX - $(this.canvasEl).offset().left, "y": touch.pageY - $(this.canvasEl).offset().top };
                var indegree = 180 * this._getCirucumferenceAngle(startPoint, endPoint) / Math.PI;
                if (indegree < this.scaleEl[this.scaleIndex].startAngle && !this._isHalfCircle())
                    indegree = indegree + 360;
                this._onMouseClickMove(this._getAngle(this.activeElement.value), this.activeElement.value);
                if (this._getValue(indegree) <= this.scaleEl[this.scaleIndex].maximum) {
                    if (this.scaleEl[this.scaleIndex].direction == "clockwise")
                        this.activeElement.value = this._getValue(indegree);
                    else
                        this.activeElement.value = this.scaleEl[this.scaleIndex].maximum - this._getValue(indegree);
                }
                if (this.contextEl.putImageData)
                    this._reDrawPointer();
                else
                    this._init();
            }
            else
            {
                if ((this.model.tooltip.showCustomLabelTooltip || this.model.tooltip.showLabelTooltip) && (!this.isTouch(e)))
                {

                    this._performTooltip(e);
                    
                }
            }
        },

        _performTooltip: function (e) {
            var hit = false;
            var padding = 10;
            var isTouch = this.isTouch(e);
            for (var i = 0; this._savedPoints[i] != null; i++) {
                if (isTouch) {
                    var mousedownCords = this._calTouchPosition(e),
                        pointer = this.getEvent(e),
                        currX = pointer.pageX,
                        currY = pointer.pageY;
                    var current = { "X": currX - $(this.canvasEl).offset().left, "Y": currY - $(this.canvasEl).offset().top };
                    if (current.X > this._savedPoints[i].startX - padding && current.X < (this._savedPoints[i].startX + this._savedPoints[i].width + padding) && current.Y > this._savedPoints[i].startY - padding && current.Y < (this._savedPoints[i].startY + this._savedPoints[i].height + padding)) {
                        this._showTooltip(e, this._savedPoints[i].value);
                        hit = true;

                    }
                    else if (hit == false) {
                        this._hideTooltip();
                    }
                } else {
                    var current = { "X": e.pageX - $(this.canvasEl).offset().left, "Y": e.pageY - $(this.canvasEl).offset().top };
                    if (current.X > this._savedPoints[i].startX && current.X < (this._savedPoints[i].startX + this._savedPoints[i].width) && current.Y > this._savedPoints[i].startY  && current.Y < (this._savedPoints[i].startY + this._savedPoints[i].height)) {
                        this._showTooltip(e, this._savedPoints[i].value);
                        hit = true;
                    }
                    else if (hit == false)
                        this._hideTooltip();
                }
            }
        },

		 	
        _isHalfCircle: function () {
            if (this.model.frame.frameType == "halfcircle")
                return true;
            else
                return false;
        },
        
        _calFontLength: function (font) {
            var minText = this.model.scales[0].minimum + this.model.scales[0].labels[0].unitText;
            var maxText = this.model.scales[0].maximum + this.model.scales[0].labels[0].unitText;
            var text = maxText.length > minText.length ? maxText : minText;
            var length = $('<span id="test"></span>').css({ font: font, display: 'none', whiteSpace: 'nowrap' }).appendTo($('body')).text(text).width();
            $("#test").remove();
            return length/2;
        },
		 
        _getHalfCircleYPosition: function () {
            return this._getYCordinate(this.centerY, 0, (this.model.frame.halfCircleFrameStartAngle + this.model.frame.halfCircleFrameEndAngle) / 2);
        },
		 
        _getHalfCircleXPosition: function () {
            return this._getXCordinate(this.centerX, 0, (this.model.frame.halfCircleFrameStartAngle + this.model.frame.halfCircleFrameEndAngle) / 2);
        },
		 
        _getXCordinate: function (x, radius, angle) {
            var x1 = x + radius * (Math.cos(Math.PI * (angle / 180)));
            return x1;
        },
		 	
        _getYCordinate: function (y, radius, angle) {
            var y1 = y + radius * (Math.sin(Math.PI * (angle / 180)));
            return y1;
        },
		 
        _getAngle: function (value) {
            var tempValue, angle;
            if (value >= this.scaleEl[this.scaleIndex].minimum && value <= this.scaleEl[this.scaleIndex].maximum)
                tempValue = this.scaleEl[this.scaleIndex].direction == "clockwise" ? value - this.scaleEl[this.scaleIndex].minimum : this.scaleEl[this.scaleIndex].maximum - value;
            else {
                if (this.scaleEl[this.scaleIndex].direction == "clockwise") {
                    if (value <= this.scaleEl[this.scaleIndex].minimum)
                        tempValue = this.scaleEl[this.scaleIndex].minimum;
                    else
                        tempValue = this.scaleEl[this.scaleIndex].maximum;
                }
                else {
                    if (value <= this.scaleEl[this.scaleIndex].minimum)
                        tempValue = this.scaleEl[this.scaleIndex].maximum;
                    else
                        tempValue = this.scaleEl[this.scaleIndex].minimum;
                }
            }
            angle = (tempValue * ((this.scaleEl[this.scaleIndex].sweepAngle) / (this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum))) + (this.scaleEl[this.scaleIndex].startAngle);
            return angle;
        },
		 
        _subtractDecimal: function (value, interval) {
            var strValue = value.toString();
            var strInterval = interval.toString();
            var vDecimal;
            var iDecimal;
            if (strValue.indexOf('.') > -1)
                vDecimal = strValue.length - strValue.indexOf('.') - 1;
            else
                vDecimal = 0;
            if (strInterval.indexOf('.') > -1)
                iDecimal = strInterval.length - strInterval.indexOf('.') - 1;
            else
                iDecimal = 0;
            var decimal = vDecimal > iDecimal ? vDecimal : iDecimal;
            var correctValue = (value * Math.pow(10, decimal) - interval * Math.pow(10, decimal)) / Math.pow(10, decimal);
            return correctValue;
        },
		 	
        _getCirucumferenceAngle: function (startPoint, endPoint) {
            if (endPoint.x > startPoint.x) {
                if (endPoint.y > startPoint.y)
                    return this._tangent(startPoint, endPoint); //quadrant2
                else {
                    if (endPoint.y == startPoint.y)
                        return 0;
                    else
                        return 2 * Math.PI + this._tangent(startPoint, endPoint); //quadrant1
                }
            }
            else {
                if (endPoint.x == startPoint.x) {
                    if (endPoint.y == startPoint.y)
                        return 0;   //0 degree
                    else {
                        if (endPoint.y > startPoint.y)
                            return Math.PI / 2;  // 90 degree
                        else
                            return 1.5 * Math.PI; // 270 degree
                    }
                }
                else {
                    if (endPoint.y == startPoint.y)
                        return Math.PI; // 180 degree
                    else {
                        if (endPoint.y > startPoint.y)
                            return Math.PI + this._tangent(startPoint, endPoint);  // quadrant3
                        else
                            return Math.PI + this._tangent(startPoint, endPoint); //quadrant4
                    }
                }
            }
        },
       
        _calcDistanceFactor: function (angle, placement, labelLength) {
            var distanceFactor;
            if ((angle > 240 && angle <= 300) || (angle > 60 && angle <= 120))
                distanceFactor = 0;
            else if ((angle > 330 && angle <= 360) || (angle >= 0 && angle <= 30))
                distanceFactor = -labelLength * 0.5;
            else if ((angle > 30 && angle <= 60) || (angle > 300 && angle <= 330))
                distanceFactor = -labelLength / 2;
            else if ((angle > 150 && angle <= 210))
                distanceFactor = labelLength * 0.5;
            else
                distanceFactor = labelLength / 2;
            return placement == "far" ? -distanceFactor : distanceFactor;
        },
		 
        _tangent: function (startPoint, endPoint) {
            var distance = (endPoint.y - startPoint.y) / (endPoint.x - startPoint.x);
            var inradians = Math.atan(distance);
            //indegrees=180*inradians/Math.PI
            return inradians;
        },
		 
        _getValue: function (angle) {
            if (this.scaleEl[this.scaleIndex].direction == "counterclockwise")
                return ((angle - this.scaleEl[this.scaleIndex].startAngle) / this.scaleEl[this.scaleIndex].sweepAngle) * (this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum);
            else
                return ((angle - this.scaleEl[this.scaleIndex].startAngle) / this.scaleEl[this.scaleIndex].sweepAngle) * (this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum) + this.scaleEl[this.scaleIndex].minimum;
        },
		 
        _drawScales: function () {
            var self = this;
            this.scaleEl = this.model.scales;
            $.each(this.model.scales, function (index, element) {
                self.scaleIndex = index;
                if (element.showScaleBar)
                    self._setScaleCordinates(element);
            });
            if (this.model.rangeZOrder  == "rear") {
                this._setRanges();
                this._setTicks();
            }
            else {
                this._setTicks();
                this._setRanges();
            }
            this._setLabels();
            this._subGauge();
            this._setCustomLabel();
            this._setPointers();
            if (!this.contextEl.putImageData)
                this.model.enableAnimation = false;
            if (this.model.animationSpeed != null && this.model.animationSpeed > 0) {
                var delay = this.model.animationSpeed / 25;
                if (delay >= 0) {
                    var myNav = navigator.userAgent.toLowerCase();
					var IEVersion = (myNav.indexOf('msie') != -1) ? parseInt(myNav.split('msie')[1]) : 0;
                    if (this.model.enableAnimation && IEVersion != 9) {
						for (var i=0; i< this.model.scales[0].pointers.length; i++){
							this.pointerValue = [];
							this.currentValue = [];
							this.pointerValue[i] = null;
							this.currentValue[i] = null;
							this.updatePointerOnAnimation = false;
						}
						this.dt = new Date().getTime();
                        this._onAnimate(this);
                    }
                }
            }
            this._setIndicators();
        },
		 
        _setTicks: function () {
            var self = this;
            $.each(this.model.scales, function (index, element) {
                if (element.showTicks) {
                    self.scaleIndex = index;
                    if (element.ticks != null) {
                        self.tickEl = element.ticks;
                        $.each(element.ticks, function (tickIndex, tickElement) {
                            self.tickIndex = tickIndex;
                            self._setTicksCordinates(tickIndex, tickElement);
                        });
                    }
                }
            });
        },
	 
        _setLabels: function () {
            var self = this;
            $.each(this.model.scales, function (index, element) {
                if (element.showLabels) {
                    self.scaleIndex = index;
                    if (element.labels != null) {
                        self.labelEl = element.labels;
                        $.each(element.labels, function (labelIndex, labelElement) {
                            self.labelIndex = labelIndex;
                            self._setLabelCoridnates(labelIndex, labelElement);
                        });
                    }
                }
            });
        },
		 
        _setIndicators: function () {
            var self = this;
            $.each(this.model.scales, function (index, element) {
                if (element.showIndicators) {
                    self.scaleIndex = index;
                    if (element.indicators != null) {
                        self.indicatorEl = element.indicators;
                        $.each(element.indicators, function (indIndex, indElement) {
                            self.indicatorIndex = indIndex;
                            self._drawIndicator(indIndex, indElement);
                        });
                    }
                }
            });
        },
		 
        _setPointers: function () {
            var self = this;
            $.each(this.model.scales, function (index, element) {
                if (element.showPointers) {
                    self.scaleIndex = index;
                    if (element.pointers != null) {
                        self.pointerEl = element.pointers;
                        $.each(element.pointers, function (pointerIndex, pointerElement) {
                            if (self._isHalfCircle())
                                element.showBackNeedle = false;
                            self.pointerIndex = pointerIndex;
                            self._drawPointers(pointerIndex, pointerElement);
                            //  setInterval( function(){ self._drawPointers(pointerIndex,pointerElement);}, 30 ); 
                        });
                    }
                }

            });
        },
		 
        _onAnimate: function (obj) {
		if(!this._androidAnimation){
		  var circularGaugeObject = obj, self = circularGaugeObject,
			  delay = self.model.animationSpeed / 25, pointerValue,i ,j,
		      pointersLength = obj.model.scales[0].pointers.length, flag = [];
		  for (i= 0; i< pointersLength; i++) {
			flag[i] = true;
			 if (!self.model.scales[0].pointers[i]._value) 
				self.model.scales[0].pointers[i]._value = self.model.scales[0].pointers[i].value;
			 self.pointerValue[i] = ej.util.isNullOrUndefined(self.pointerValue[i]) ? self.model.scales[0].pointers[i]._value : self.pointerValue[i];
            self.currentValue[i] = !self.currentValue[i] ? self.model.scales[0].minimum : self.currentValue[i];
            pointerValue = self.pointerValue[i];
			now = new Date().getTime();
	        delta = now - self.dt;
                if ((delta > delay) && (pointerValue > self.currentValue[i])) {
                    self.currentValue[i] = self.currentValue[i] + ((self.model.scales[0].maximum-self.model.scales[0].minimum)/100);
					self.updatePointerOnAnimation = true;
                    pointerValue > self.currentValue[i] ? self.setPointerValue(0, i, self.currentValue[i]) : self.setPointerValue(0, i, pointerValue);
					self.dt = now - (delta % delay);
                }
                else if (self.currentValue >= pointerValue)
                    flag[i] = false;
		    }
		  for (j=0; j< flag.length; j++){
				animationFlag = flag[j];
				if (animationFlag) break;
			}	
		  if (animationFlag) {
	            requestAnimationFrame(function () {
	            circularGaugeObject._onAnimate(circularGaugeObject);
	            });
	        }
		}
        },
		
		_pointInterval: function (currentValue, pointerValue, delay, self) {
			 this.timer = setTimeout(function pointerchan() {
                if (pointerValue > currentValue) {
                    currentValue = currentValue + ((self.model.scales[0].maximum-self.model.scales[0].minimum)/100);
                    pointerValue > currentValue ? self.setPointerValue(0, 0, currentValue) : self.setPointerValue(0, 0, pointerValue);
                }
                else if (currentValue >= pointerValue) {
                    window.clearInterval(self.timer);
                }
				self._pointInterval(currentValue, pointerValue, delay, self);
               }, delay); 
		},
		 
        _setRanges: function () {
            var self = this;
            this._rangeCollectionRegions = [];
            $.each(this.model.scales, function (index, element) {
                if (element.showRanges) {
                    self.scaleIndex = index;
                    if (element.ranges != null) {
                        self.rangeEl = element.ranges;
                        $.each(element.ranges, function (rangeIndex, rangeElement) {
                            self.rangeIndex = rangeIndex;
                            if (rangeElement._visible || !self.model.legend.visible)
                               self._setRangeCordinates(rangeIndex, rangeElement);
                        });
                    }
                }
            });
        },
		 
        _setCustomLabel: function () {
            var self = this, currentCustomLabel;
            $.each(this.model.scales, function (index, element) {
                self.scaleIndex = index;
                if (element.customLabels !=null) {
                    self.customLabelEl = element.customLabels;
                    $.each(element.customLabels, function (labelIndex, labelElement) {
                        self.customLabelIndex = labelIndex;
						currentCustomLabel = self.model.scales[self.scaleIndex].customLabels[self.customLabelIndex];
						if (currentCustomLabel.value != null ) {
							if (currentCustomLabel.positionType == "outer")
								self._setOuterCustomLabels(labelIndex, labelElement);
							else
								self._setCustomLabelCordinates(labelIndex, labelElement);
						}
                    });
                }
            });
        },
	 
        _subGauge: function () {
            var self = this;
            $.each(this.model.scales, function (index, element) {
                self.scaleIndex = index;
                if (element.subGauges != null) {
                    self.subGaugeEl = element.subGauges;
                    $.each(element.subGauges, function (subGaugeIndex, subGaugeElement) {
                        self.subGaugeIndex = index;
                        self._setSubGauge(subGaugeIndex, subGaugeElement);
                    });
                }
            });
        },
        
        _setOuterCustomLabels: function (index, element) {
            this._customLblMaxSize = this._customLblMaxSize < parseFloat(element.font.size.match(/\d+/)[0]) ? parseFloat(element.font.size.match(/\d+/)[0]) : this._customLblMaxSize;
            var div = ej.buildTag("div."+this._id+"outercustomlbl");
            div.text(this.model.scales[this.scaleIndex].customLabels[index].value);
            var position=(this.model.outerCustomLabelPosition=="right" || this.model.outerCustomLabelPosition=="left")?"left":"center";
            this.outerDiv.append(div);
            this.outerDiv.append('</br>');
            if (position == "center")
                div.css({ 'display': 'inline-block', 'margin': '0 auto', 'max-width': this.model.width });
            else
                div.css({ 'display': 'inline-block', 'max-width': this.element.width() - this.model.width > 10 ? this.element.width() - this.model.width : 10 });
            div.css({
                "color": element.color,
                'overflow': 'hidden',
                'text-overflow': 'ellipsis',
                'white-space': 'nowrap',
                'font-size': (element.font != null && element.font.size != null) ? element.font.size : "12px",
                'font-family': (element.font != null && element.font.fontFamily != null) ? element.font.fontFamily : "Arial",
                'font-weight': (element.font != null && element.font.fontStyle != null) ? element.font.fontStyle : "Normal",
                'text-align': position
            });

        },
	 	
        _setScaleCordinates: function (element) {
            this.region = {
                "centerX": this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, "centerY": this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY,
                "startAngle": element.startAngle, "endAngle": (element.startAngle + element.sweepAngle),
                "startRadius": this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2, "endRadius": this.scaleEl[this.scaleIndex].radius + this.scaleEl[this.scaleIndex].size / 2
            };
            this.style = {
                "radius": element.radius - element.size / 2,
                "strokeStyle": (element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color), // this._getColor(element, element.borderColor),
                "lineWidth": element.border.width,
                "size": element.size,
                "isFill": true,
                "opacity": isNaN(element.opacity) ? 1 : element.opacity,
                "isStroke": true,
                "shadowOffset": element.shadowOffset,
                "fillStyle": (element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor), //this._getColor(element, element.backgroundColor),
                "counterClockwise": element.direction == "clockwise" ? false : true
            };
            if (element.maximum < element.minimum) {
                var tempValue = element.maximum;
                element.maximum = element.minimum;
                element.minimum=tempValue;
            }
			 if (element.maximum == element.minimum)
                element.maximum = element.maximum + 1;
            this.maximum(element.maximum);
            this.minimum(element.minimum);
            if (this._notifyArrayChange) {
                this._notifyArrayChange("scales[" + this.scaleIndex + "]maximum", element.maximum);
                this._notifyArrayChange("scales[" + this.scaleIndex + "]minimum", element.minimum);
            }
            this._drawScaleBar(this.region, this.style);
            if (this.contextEl.getImageData)
                this.scaleImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
        },
		 	
        _drawOuterLayer: function () {
            var interiorGradient, startPoint, endPoint;
            if (this._isHalfCircle()) {
                startPoint = { "x": this.centerX, "y": this.centerY };
                endPoint = { "x": this.centerX + this.model.radius, "y": this.centerY / 2 };
            }
            if (!this.model.isRadialGradient) {
                interiorGradient = this.contextEl.createLinearGradient(0, 0, 0, this.canvasEl[0].height);
            }
            else {
                interiorGradient = this.contextEl.createRadialGradient(this.canvasEl[0].width / 2, this.canvasEl[0].height / 2, 0, this.canvasEl[0].width / 2, this.canvasEl[0].height / 2, this.model.radius);
            }
            if (!ej.isNullOrUndefined(this.model.interiorGradient))
                this._setGradientColor(this, interiorGradient, this.model.interiorGradient.colorInfo);

            this.frameOuterLocation = { "centerX": this.centerX, "hcCenterX": this.centerX, "hcCenterY": this.centerY, "centerY": this.centerY, "startAngle": this._isHalfCircle() ? Math.PI * ((this.model.frame.halfCircleFrameStartAngle) / 180) : 0, "endAngle": this._isHalfCircle() ? Math.PI * ((this.model.frame.halfCircleFrameEndAngle) / 180) : 2 * Math.PI };
            if (this._isHalfCircle())
                this.frameInnerLocation = { "centerX": this.centerX, "hcCenterX": this._getXCordinate(this.centerX, 0, (this.model.frame.halfCircleFrameStartAngle + this.model.frame.halfCircleFrameEndAngle) / 2), "hcCenterY": this._getYCordinate(this.centerX, 0, (this.model.frame.halfCircleFrameStartAngle + this.model.frame.halfCircleFrameEndAngle) / 2), "centerY": this.centerY, "startAngle": Math.PI * ((this.model.frame.halfCircleFrameStartAngle) / 180), "endAngle": Math.PI * ((this.model.frame.halfCircleFrameEndAngle) / 180) };
            this.frameInnerStyle = {
                "radius": this.model.radius,
                "isStroke": false, "isFill": true,
                "fillStyle": (this.model.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(null, this.model.backgroundColor),
                "counterClockwise": false
            };
            if (this.model.frame.frameType == "fullcircle") {
                this._drawCircleFrame(this.frameOuterLocation, this.frameInnerStyle);
            }
            else if (this.model.frame.frameType == "halfcircle") {
                this._drawHalfCircle(this.frameInnerLocation, this.frameInnerStyle);
            }
            if (this.contextEl.getImageData)
                this.outerImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
        },
		 
        _setTicksCordinates: function (index, element) {
            var startX, startY, lineHeight, minimumMeet, interval, radius, angle;
            if (element.type == "major") {
                interval = this.scaleEl[this.scaleIndex].majorIntervalValue;
                this.majorTickHeight = element.height;
            }
            else {
                interval = this.scaleEl[this.scaleIndex].minorIntervalValue;
            }
            if (element.placement == "far")
                radius = this.scaleEl[this.scaleIndex].radius + this.scaleEl[this.scaleIndex].size / 2 + this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
            if (element.placement == "center")
                radius = this.scaleEl[this.scaleIndex].radius - element.height / 2 - this.scaleEl[this.scaleIndex].border.width / 2 - element.distanceFromScale;
            if (element.placement == "near")
                radius = this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2 - this.scaleEl[this.scaleIndex].border.width / 2 - element.distanceFromScale;
            lineHeight = element.placement == "near" ? -element.height : element.height;
            for (var value = this.scaleEl[this.scaleIndex].maximum; value >= this.scaleEl[this.scaleIndex].minimum; value -= interval) {
                if (interval == this.scaleEl[this.scaleIndex].minorIntervalValue && value % this.scaleEl[this.scaleIndex].majorIntervalValue != 0 || interval == this.scaleEl[this.scaleIndex].majorIntervalValue) {
                    if (value == this.scaleEl[this.scaleIndex].minimum)
                        minimumMeet = true;
                    angle = this._getAngle(value);
                    angle = angle > 360 ? angle - 360 : angle;
                    startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, radius, angle);
                    startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, radius, angle);
                    this.region = { "startX": startX, "startY": startY };
                    this.style = { "angle": element.angle + angle, "isStroke": true, "isFill": false, "lineHeight": lineHeight, "lineWidth": element.width, "strokeStyle": (element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color) };
                    if (this.model.drawTicks)
                        this._onDrawTicks(angle, value);
                    this._drawTickMark(this.region, this.style);
                }
            }
            if (!minimumMeet) {
                angle = this._getAngle(this.scaleEl[this.scaleIndex].minimum);
                angle = angle > 360 ? angle - 360 : angle;
                startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, radius, angle);
                startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, radius, angle);
                this.region = { "startX": startX, "startY": startY };
                this.style = { "angle": element.angle + angle, "isStroke": true, "isFill": false, "lineHeight": lineHeight, "lineWidth": element.width, "strokeStyle": (element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color) };
                //if (this.model.drawTicks)
                //    this._onDrawTicks(angle, value);
                //this._drawTickMark(this.region, this.style);
            }

            if (this.contextEl.getImageData)
                this.tickImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
        },
		 
        _setLabelCoridnates: function (index, element) {
            var minimumMeet;
            var startX, startY, lineHeight, incrementAngle, interval, radius;
            interval = element.type == "major" ? this.scaleEl[this.scaleIndex].majorIntervalValue : this.scaleEl[this.scaleIndex].minorIntervalValue;
            incrementAngle = element.type == "major" ? (this.majorIntervalAngle = this.scaleEl[this.scaleIndex].sweepAngle / ((this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum) / interval)) : this.scaleEl[this.scaleIndex].sweepAngle / ((this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum) / interval);
            if (element.placement == "far")
                radius = this.scaleEl[this.scaleIndex].radius + this.scaleEl[this.scaleIndex].size / 2 + this.majorTickHeight + element.distanceFromScale;
            if (element.placement == "center")
                radius = this.scaleEl[this.scaleIndex].radius - 10 - element.distanceFromScale;
            if (element.placement == "near")
                radius = this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2 - 10 - this.majorTickHeight - element.distanceFromScale;
            this._labelRadius = radius;
            for (var value = this.scaleEl[this.scaleIndex].maximum; value >= this.scaleEl[this.scaleIndex].minimum; value = this._subtractDecimal(value, interval)) {
                if (value == this.scaleEl[this.scaleIndex].minimum)
                    minimumMeet = true;
                if (interval == this.scaleEl[this.scaleIndex].minorIntervalValue && value % this.scaleEl[this.scaleIndex].majorIntervalValue != 0 || interval == this.scaleEl[this.scaleIndex].majorIntervalValue) {
                    if (value == this.scaleEl[this.scaleIndex].minimum && !element.includeFirstValue) {
                        continue;
                    }
                    var angle = this._getAngle(value);
                    angle = angle > 360 ? angle - 360 : angle;
                    startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, radius, angle);
                    startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, radius, angle);
                    this.region = { "startX": startX, "startY": startY };
                    this.style = { "placement": element.placement, "textPositionAngle": angle, "angle": this.scaleEl[this.scaleIndex].labels[this.labelIndex].autoAngle ? angle + element.angle : element.angle, "isStroke": false, "isFill": true, "textValue": value, "opacity": !(element.opacity) ? 1 : element.opacity, "font": this._getFontString(element, element.font), "fillStyle": (element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color) };
                    if (this.model.drawLabels)
                        this._onDrawLabels(this.scaleEl[this.scaleIndex].labels[this.labelIndex].autoAngle ? angle + element.angle : element.angle, value);
                    this._drawLabel(this.region, this.style, false);
                    if (this.model.tooltip.showLabelTooltip)
                        this._savedPoints.push({ "startX": startX - 10, "startY": startY-5, "width": 20, "height": parseInt(element.font.size.replace(/\D/g, '')), "value": value });
                }
            }
            if (!minimumMeet) {
                angle = this._getAngle(this.scaleEl[this.scaleIndex].minimum);
                angle = angle > 360 ? angle - 360 : angle;
                startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, radius, angle);
                startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, radius, angle);
                this.region = { "startX": startX, "startY": startY };
                this.style = { "angle": this.scaleEl[this.scaleIndex].labels[this.labelIndex].autoAngle ? angle + element.angle : element.angle, "isStroke": false, "isFill": true, "textValue": this.scaleEl[this.scaleIndex].minimum, "opacity": !(element.opacity) ? 1 : element.opacity, "font": this._getFontString(element, element.font), "lineHeight": lineHeight, "lineWidth": element.width, "fillStyle": (element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color) };
                if (this.model.drawLabels)
                    this._onDrawLabels(angle, value);
                this._drawLabel(this.region, this.style, false);
                if (this.model.tooltip.showLabelTooltip)
                     this._savedPoints.push({ "startX": startX - 10, "startY": startY-5, "width": 20, "height": parseInt(element.font.size.replace(/\D/g, '')), "value": value });
                angle = this._getAngle(value);
                angle = angle > 360 ? angle - 360 : angle;
            }
            if (this.contextEl.getImageData)
                this.labelImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
        },
		 
        _setRangeCordinates: function (index, element) {
                if (element.startValue < this.scaleEl[this.scaleIndex].maximum&& element.endValue <= this.scaleEl[this.scaleIndex].maximum) {
                    var tempRangeStart = element.startValue >= this.scaleEl[this.scaleIndex].minimum ? element.startValue : this.scaleEl[this.scaleIndex].minimum;
                    var tempRangeEnd = element.endValue > this.scaleEl[this.scaleIndex].maximum ? this.scaleEl[this.scaleIndex].maximum : element.endValue;
                var startX, startY, endX, endY, startAngle, radius, endAngle, startRadius, endRadius, grd, controlAngle;
                controlAngle = this._getAngle((tempRangeStart + tempRangeEnd) / 2);
                startAngle = this._getAngle(tempRangeStart);
                endAngle = this._getAngle(tempRangeEnd);
                radius = this.scaleEl[this.scaleIndex].radius - element.distanceFromScale - this.scaleEl[this.scaleIndex].size / 2 - element.size - (ej.isNullOrUndefined(this.scaleEl[this.scaleIndex].ticks[0]) ? 16 : this.scaleEl[this.scaleIndex].ticks[0].height);
                startRadius = this.scaleEl[this.scaleIndex].radius - element.distanceFromScale - this.scaleEl[this.scaleIndex].size / 2 - (ej.isNullOrUndefined(this.scaleEl[this.scaleIndex].ticks[0]) ? 16 : this.scaleEl[this.scaleIndex].ticks[0].height);
                endRadius = this.scaleEl[this.scaleIndex].radius - element.distanceFromScale - element.size - this.scaleEl[this.scaleIndex].size / 2 - (ej.isNullOrUndefined(this.scaleEl[this.scaleIndex].ticks[0]) ? 16 : this.scaleEl[this.scaleIndex].ticks[0].height);
                startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, radius, startAngle);
                startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, radius, startAngle);
                endX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, radius, endAngle);
                endY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, radius, endAngle);
                startAngle = (180 * this._getCirucumferenceAngle({ "x": this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, "y": this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY }, { "x": startX, "y": startY })) / Math.PI;
                endAngle = (180 * this._getCirucumferenceAngle({ "x": this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, "y": this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY }, { "x": endX, "y": endY })) / Math.PI;

                if (!ej.isNullOrUndefined(element.gradients) && element.gradients.colorInfo.length > 0) {
                    grd = this.contextEl.createRadialGradient(this.centerX, this.centerY, endRadius, this.centerX, this.centerY, startRadius);
                    this._setGradientColor(this, grd, element.gradients.colorInfo);
                } else
                    grd = (element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor); // this._getColor(element, element.backgroundColor);
                this.region = { "startX": startX, "startY": startY, "endX": endX, "endY": endY, "startAngle": startAngle, "endAngle": endAngle };
                this.style = {
                    "placement":element.placement,
                    "radius": element.placement=="near"?this.scaleEl[this.scaleIndex].radius - element.distanceFromScale:this.scaleEl[this.scaleIndex].radius + element.distanceFromScale,
                    "rangeStart": tempRangeStart,
                    "rangeEnd": tempRangeEnd,
                    "startWidth": element.startWidth,
                    "isFill": true,
                    "fillStyle": grd,
                    "strokeStyle": (element.border.color == "transparent") ? "rgba(0,0,0,0)" : element.border.color, // element.borderColor,
                    "opacity": isNaN(element.opacity) ? 1 : element.opacity,
                    "counterClockwise": this.scaleEl[this.scaleIndex].direction == "clockwise" ? false : true,
                    "startRadius": startRadius, "endRadius": endRadius, "endWidth": element.endWidth, "lineWidth": element.border.width, "isStroke": true
                };
                if (this.model.drawRange)
                    this._onDrawRange(this.region, this.style);
                this._rangeCollectionRegions.push({ Range:element, Region: this.region, scaleIndex: this.scaleIndex, rangeIndex: this.rangeIndex, Radius: { startRadius: this.style.startRadius, endRadius: this.style.endRadius }, centerRadius: { centerX: this.centerX, centerY: this.centerY, radius: this.style.radius } });
                this._drawRange(this.region, this.style);
                if (this.contextEl.getImageData)
                this.rangeImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
                }
        },
		 
        _setSubGauge: function (index, element) {
            var subGaugeDiv = $('div[id=' + element.controlID + ']');
            if (subGaugeDiv.length > 0 && subGaugeDiv.find('canvas').length) {
                var sourceCanvas = subGaugeDiv.find('canvas')[0].getContext('2d');
                this.contextEl.drawImage(sourceCanvas.canvas, element.position.x, element.position.y, element.width, element.height);
                subGaugeDiv.css('display', 'none');
                if (this.contextEl.getImageData)
                    this.subGaugeImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
            }
        },
		 
        _setCustomLabelCordinates: function (index, element) {
            this._customLblMaxSize = this._customLblMaxSize < parseFloat(element.font.size.match(/\d+/)[0]) ? parseFloat(element.font.size.match(/\d+/)[0]) : this._customLblMaxSize;
            element.color = element.color ? (element.color) : "#282828";
            this.region = element.position ? ({ "startX": element.position.x, "startY": element.position.y }) : { "startX": 0, "startY": 0 };
            this.style = { "angle": element.textAngle, "textValue": element.value, "fillStyle": (element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color), "font": this._getFontString(element, element.font) };
            if (this.model.drawCustomLabel)
                this._onDrawCustomLabel(this.region, this.style);
            this._drawLabel(this.region, this.style, true);
            if (this.model.tooltip.showCustomLabelTooltip)
                this._savedPoints.push({ "startX": this.region.startX-30, "startY": this.region.startY-5, "width": 60, "height": !ej.isNullOrUndefined(element.font) ? parseInt(element.font.size.replace(/\D/g, '')) : 10, "value": this.style.textValue });
            if (this.contextEl.getImageData)
                this.customLabelImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
        },
	 
        _drawIndicator: function (index, element) {
            var self = this, isInStateRange = false;
            this.region = { "centerX": element.position.x - element.width / 2, "textLocation": element.position, "centerY": element.position.y - element.height / 2, "startAngle": 0, "endAngle": 2 * Math.PI };
            this.style = {
                "radius": (element.height + element.width) / 2,
                "strokeStyle": "#2BA104",
                "cornerRadius": element.type == "roundedrectangle" ? 2 : 0,
                "height": element.height,
                "width": element.width,
                "lineWidth": element.indicatorBorderWidth,
                "fillStyle": "#2BA104",
                "isStroke": true,
                "isFill": true,
                "indicatorText": element.indicatorText,
                "textColor": null,
                "font": null,
                "counterClockwise": false
            };
            if (this.model.drawIndicators)
                this._onDrawIndicators(this.style, this.region);
            if (element.type == ej.datavisualization.CircularGauge.IndicatorType.Image) {
                var image = new Image();
                image.onload = function () {
                    self.contextEl.drawImage(this, element.position.x, element.position.y);
                };
                image.src = element.imageUrl;
            }
            else if (element.stateRanges != null) {
                $.each(element.stateRanges, function (stateRangeIndex, srEl) {//srEl = StateRange Element
                    if (self.pointerEl[self.pointerIndex].value >= srEl.startValue && self.pointerEl[self.pointerIndex].value <= srEl.endValue) {
                        isInStateRange = true;
                        if (!ej.isNullOrUndefined(srEl.text) && srEl.text.length > 0) {
                            self.style.indicatorText = srEl.text;
                            self.style.textColor = (srEl.textColor == "transparent") ? "rgba(0,0,0,0)" : srEl.textColor; // srEl.textColor;
                            self.style.font = element.font;
                        }
                        self.style.strokeStyle = (srEl.borderColor == "transparent") ? "rgba(0,0,0,0)" : srEl.borderColor;
                        self.style.fillStyle = (srEl.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : srEl.backgroundColor;
                        self._drawIndicatorFrame(element.type, self.region, self.style);
                    }
                });
            }
            if (!isInStateRange && element.type != ej.datavisualization.CircularGauge.IndicatorType.Image) {
                self._drawIndicatorFrame(element.type, self.region, self.style);
            }
            if (this.contextEl.getImageData && element.type != ej.datavisualization.CircularGauge.IndicatorType.Image)
                this.indicatorImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
        },

        _drawIndicatorFrame: function(type, location,style) {
            switch (type) {
                case "circle":
                    this._drawCircleFrame(location, style);
                    break;
                case "roundedrectangle":
                case "rectangle":
                    this._drawRectangleFrame(location, style);
                    break;
                case "text":
                    this._drawText(location, style);
                    break;
            }
        },
		 	
        _drawScaleBar: function (location, style) {
            this.contextEl.shadowColor = (style.strokeStyle == "transparent") ? "rgba(0,0,0,0)" : style.strokeStyle;
            if (style.shadowOffset)
                this.contextEl.shadowBlur = style.shadowOffset;
            this._contextOpenPath(style, this);
            if ((location.endAngle - location.startAngle) == 0)
                this.contextEl.arc(location.centerX, location.centerY, location.startRadius, Math.PI * (0 / 180), Math.PI * (0 / 180), false);
            else if ((location.endAngle - location.startAngle) % 360 == 0) {
                this.contextEl.arc(location.centerX, location.centerY, location.startRadius, Math.PI * (0 / 180), Math.PI * (360 / 180), false);
                this.contextEl.arc(location.centerX, location.centerY, location.endRadius, Math.PI * (360 / 180), Math.PI * (0 / 180), true);
            }
            else {
                this.contextEl.arc(location.centerX, location.centerY, location.startRadius, Math.PI * (location.startAngle / 180), Math.PI * (location.endAngle / 180), false);
                this.contextEl.arc(location.centerX, location.centerY, location.endRadius, Math.PI * (location.endAngle / 180), Math.PI * (location.startAngle / 180), true);
            }
            this._contextClosePath(style, this);
        },
		 
        _drawTickMark: function (location, style) {
            this._contextOpenPath(style, this);
            this.contextEl.translate(location.startX, location.startY);
            this.contextEl.lineTo(0, 0);
            this.contextEl.rotate((Math.PI * (style.angle / 180)));
            this.contextEl.lineTo(style.lineHeight, 0);
            this._contextClosePath(style, this);
        },
	 
        _drawLabel: function (location, style, isCustomLabel) {
            var distanceFactor = 0, locale = this.model.locale;
            if (!ej.isNullOrUndefined(isCustomLabel) && !isCustomLabel) {
                var textPostion = this.model.scales[this.scaleIndex].labels[this.labelIndex].unitTextPosition;
               style.textValue = ((style.textValue % 1 != 0) ? + parseFloat(style.textValue.toFixed(3)) : style.textValue); 
			    style.textValue = ((locale && this.model.enableGroupSeparator) ? style.textValue.toLocaleString(locale) : style.textValue);
				if (!ej.isNullOrUndefined(textPostion) && textPostion.toString() == "back")
					style.textValue += this.model.scales[this.scaleIndex].labels[this.labelIndex].unitText;
                else if (!ej.isNullOrUndefined(textPostion) && textPostion.toString() == "front")
                    style.textValue = this.model.scales[this.scaleIndex].labels[this.labelIndex].unitText + style.textValue;
                distanceFactor = this._calcDistanceFactor(style.textPositionAngle, style.placement, this._calFontLength(style.font));
            }
            this._contextOpenPath(style, this);
            this.contextEl.textAlign = "center";
            this.contextEl.textBaseline = "middle";
            this.contextEl.font = style.font;
            this.contextEl.translate(location.startX + distanceFactor, location.startY);
            this.contextEl.lineTo(0, 0);
			if(!isCustomLabel)
			    this.scaleEl[this.scaleIndex].labels[this.labelIndex].autoAngle ? this.contextEl.rotate((Math.PI * ((style.angle - 270) / 180))) : this.contextEl.rotate((Math.PI * (style.angle / 180)));
			else if (isCustomLabel && style.angle != 0)
			    this.contextEl.rotate((Math.PI * (style.angle / 180)));
            this.contextEl.fillText(style.textValue, 0, 0);
            this._contextClosePath(style, this);
        },
		 
        _drawCircleFrame: function (location, style) {
            this._contextOpenPath(style, this);
            this.contextEl.arc(location.centerX, location.centerY, style.radius, location.startAngle, location.endAngle, style.counterClockwise);
            this._contextClosePath(style, this);
            if (style.indicatorText)
                this._drawText(location, style);
        },
		 
        _drawHalfCircle: function (location, style) {
            this._contextOpenPath(style, this);
            this.contextEl.lineJoin = "round";
            this.contextEl.arc(location.centerX, location.centerY, style.radius, location.startAngle, location.endAngle, false);
            this.contextEl.lineTo(location.centerX, location.centerY);
            this._contextClosePath(style, this);
        },
		 
        _drawRectangleFrame: function (location, style) {
            this._contextOpenPath(style, this);
            this.contextEl.translate(location.centerX, location.centerY - style.height / 2);
            this.contextEl.lineTo(style.cornerRadius, 0);
            this.contextEl.lineTo(style.width - style.cornerRadius, 0);
            this.contextEl.quadraticCurveTo(style.width, 0, style.width, style.cornerRadius);
            this.contextEl.lineTo(style.width, style.height - style.cornerRadius);
            this.contextEl.quadraticCurveTo(style.width, style.height, style.width - style.cornerRadius, style.height);
            this.contextEl.lineTo(style.cornerRadius, style.height);
            this.contextEl.quadraticCurveTo(0, style.height, 0, style.height - style.cornerRadius);
            this.contextEl.lineTo(0, style.cornerRadius);
            this.contextEl.quadraticCurveTo(0, 0, style.cornerRadius, 0);
            this._contextClosePath(style, this);
            if (style.indicatorText)
                this._drawText(location, style);
        },
	 
        _drawText: function (location, style) {
            this.contextEl.beginPath();
            this.contextEl.textAlign = "center";
            this.contextEl.fillStyle = (style.textColor == "transparent") ? "rgba(0,0,0,0)" : style.textColor;
            this.contextEl.font = style.font;
            this.contextEl.fillText(style.indicatorText, location.textLocation.x, location.textLocation.y);
            this.contextEl.closePath();
        },
		 	
        _drawRange: function (location, style) {
            if(style.startWidth == null && style.endWidth == null){
            this._contextOpenPath(style, this);
            this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.startRadius, Math.PI * (location.startAngle / 180), Math.PI * (location.endAngle / 180), style.counterClockwise);
            this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.endRadius, Math.PI * (location.endAngle / 180), Math.PI * (location.startAngle / 180), !style.counterClockwise);
            this._contextClosePath(style, this);
            }
            else {
                var widthDifference = style.startWidth > style.endWidth ? style.startWidth - style.endWidth : style.endWidth - style.startWidth;
                var angleDifference = this.scaleEl[this.scaleIndex].direction == "clockwise" ? location.startAngle < location.endAngle ? location.endAngle - location.startAngle : 360 - (location.startAngle - location.endAngle) : location.endAngle < location.startAngle ? location.startAngle - location.endAngle : location.startAngle + (360 - location.endAngle);
                var degreeDifference = angleDifference / (widthDifference * 2);
                if (style.startWidth < style.endWidth) {
                    if (style.startWidth != 0) {
                        this._contextOpenPath(style, this);
                        this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.radius, Math.PI * (location.startAngle / 180), Math.PI * (location.endAngle / 180), style.counterClockwise);
                        this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.placement == "near" ? style.radius - style.startWidth : style.radius + style.startWidth, Math.PI * (location.endAngle / 180), Math.PI * (location.startAngle / 180), !style.counterClockwise);
                        this._contextClosePath(style, this);
                    }
                    style.radius = style.placement == "near" ? style.radius - style.startWidth : style.radius + style.startWidth;
                    style.endWidth -= style.startWidth;
                    style.startWidth = 0;
                    for (var i = style.startWidth; i < style.endWidth; i += 0.5) {
                        this.contextEl.beginPath();
                        this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.radius, Math.PI * (location.endAngle / 180) , Math.PI * (location.startAngle / 180) , !style.counterClockwise);
                        this.contextEl.lineWidth = 2;
                        this.contextEl.strokeStyle = style.fillStyle;
                        this.contextEl.stroke();
                        this.contextEl.restore();
                        location.startAngle = this.scaleEl[this.scaleIndex].direction == "clockwise" ? location.startAngle + degreeDifference : location.startAngle - degreeDifference;;
                        style.radius = style.placement == "near" ? style.radius - 0.5 : style.radius + 0.5;
                    }
                }
                else {
                    if (style.endWidth != 0) {
                        this._contextOpenPath(style, this);
                        this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.radius, Math.PI * (location.startAngle / 180), Math.PI * (location.endAngle / 180), style.counterClockwise);
                        this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.placement == "near" ? style.radius - style.endWidth : style.radius + style.endWidth, Math.PI * (location.endAngle / 180), Math.PI * (location.startAngle / 180), !style.counterClockwise);
                        this._contextClosePath(style, this);
                    }
                    style.radius = style.placement == "near" ? style.radius - style.endWidth : style.radius + style.endWidth;
                    style.startWidth -= style.endWidth;
                    style.endWidth = 0;
                    for (i = style.endWidth; i < style.startWidth; i += 0.5) {
                        this.contextEl.beginPath();
                        this.contextEl.arc(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, style.radius,Math.PI * (location.startAngle / 180), Math.PI * (location.endAngle / 180),  style.counterClockwise);
                        this.contextEl.lineWidth = 2;
                        this.contextEl.strokeStyle = style.fillStyle;
                        this.contextEl.stroke();
                        this.contextEl.restore();
                        location.endAngle = this.scaleEl[this.scaleIndex].direction == "clockwise" ? location.endAngle - degreeDifference : location.endAngle + degreeDifference;
                        style.radius = style.placement == "near" ? style.radius - 0.5 : style.radius + 0.5;
                    }
                }
            }
        },
		 
        _drawPointers: function (index, element) {
            element.value = element.value > this.scaleEl[this.scaleIndex].maximum ? this.scaleEl[this.scaleIndex].maximum : element.value;
            element.value = element.value < this.scaleEl[this.scaleIndex].minimum ? this.scaleEl[this.scaleIndex].minimum : element.value;
            var startX, startY, angle, height, grd, locale = this.model.locale;
            angle = this._getAngle(element.value);
            angle = angle > 360 ? angle - 360 : angle;
            if (element.type == "needle") {
                if (element.placement == "far")
                    height = element.length + this.scaleEl[this.scaleIndex].size / 2;
                if (element.placement == "center")
                    height = element.length;
                if (element.placement == "near")
                    height = element.length - this.scaleEl[this.scaleIndex].size / 2;
            }
            else {
                height = element.length;
                if (element.placement == "far") {
                    startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this.scaleEl[this.scaleIndex].radius + this.scaleEl[this.scaleIndex].size / 2 + element.distanceFromScale, angle);
                    startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerX, this.scaleEl[this.scaleIndex].radius + this.scaleEl[this.scaleIndex].size / 2 + element.distanceFromScale, angle);
                }
                if (element.placement == "center") {
                    startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2 - element.distanceFromScale, angle);
                    startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerX, this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2 - element.distanceFromScale, angle);
                }
                if (element.placement == "near") {
                    startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2 - element.distanceFromScale - this.majorTickHeight - 15, angle);
                    startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerX, this.scaleEl[this.scaleIndex].radius - this.scaleEl[this.scaleIndex].size / 2 - element.distanceFromScale - this.majorTickHeight - 15, angle);
                }
                if (!(this._isHalfCircle && this._isHalfCircle())) {
                    if (this.model.height > this.model.width)
                        startY += (this.model.height - this.model.width) / 2;
                    else if (this.model.height < this.model.width)
                        startY -= (this.model.width - this.model.height) / 2;
                }
            }
            if (height > this.model.radius)
                height = this.model.radius;

            this.region = { "startX": element.type == "needle" ? this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX : startX, "startY": element.type == "needle" ? this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY : startY };
            if (!ej.isNullOrUndefined(element.gradients) && element.gradients.colorInfo.length > 0) {
                grd = this.contextEl.createLinearGradient(0, 0, 0, element.width);
                this._setGradientColor(this, grd, element.gradients.colorInfo);
            } else
                grd = (element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor);
            this.style = {
                "width": element.width,
                "isFill": true,
                "isStroke": true,
                "radius": 0,
                "showBackNeedle": element.showBackNeedle,
                "backNeedleLength": element.backNeedleLength,
                "angle": element.type == "needle" ? angle : element.placement == "far" ? angle : angle + 180,
                "height": height, "lineWidth": element.border.width, "opacity": isNaN(element.opacity) ? 1 : element.opacity,
                "strokeStyle": (element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color),
                "fillStyle": grd,
                "imageUrl": element.imageUrl,
                "type":element.type,
            };
            if (this.model.drawPointers)
                this._onDrawPointers(angle, element.value);
            if (element.type == "needle") {
                this._drawNeedlePointer(this.region, this.style, element);
                this._setPointerCap(element);
            }
            else {
                if (element.markerType == "roundedrectangle")
                    this.style.radius = 5;
                this._drawMarkerType(element.markerType, this.region, this.style);
            }
            if (element.pointerValueText.showValue) {
                startX = this._getXCordinate(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._labelRadius + element.pointerValueText.distance, angle);
                startY = this._getYCordinate(this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, this._labelRadius + element.pointerValueText.distance, angle);
                this.region = { "startX": startX, "startY": startY };
                this.style = { "angle": element.pointerValueText.autoAngle ? element.pointerValueText.angle + angle : element.pointerValueText.angle, "textValue": (locale && this.model.enableGroupSeparator) ? element.value.toLocaleString(locale) : element.value, "fillStyle": (element.pointerValueText.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.pointerValueText.color), "font": this._getFontString(element, element.pointerValueText.font), "opacity": element.pointerValueText.opacity };
                this._drawPointerValueText(this.region, this.style);
            }
            if (this.contextEl.getImageData)
                this.pointerImage = this.contextEl.getImageData(0, 0, this.model.width, this.model.height);
            if (this._notifyArrayChange)
                this._notifyArrayChange("scales[" + this.scaleIndex + "]pointers[" + index + "]value", element.value);
            this.value(element.value);
        },
        _drawPointerValueText: function (location, style) {
            this._contextOpenPath(style, this);
            this.contextEl.textAlign = "center";
            this.contextEl.textBaseline = "middle";
            this.contextEl.font = style.font;
            this.contextEl.translate(location.startX , location.startY);
            this.contextEl.lineTo(0, 0);
            this.scaleEl[this.scaleIndex].pointers[this.pointerIndex].pointerValueText.autoAngle ? this.contextEl.rotate((Math.PI * ((style.angle - 270) / 180))) : this.contextEl.rotate((Math.PI * (style.angle / 180)));
            this.contextEl.fillText(style.textValue, 0, 0);
            this._contextClosePath(style, this);
        },
        
        _drawMarkerType: function (type, location, style) {
            switch (type) {
                case "rectangle":
                    this._drawRectangle(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "triangle":
                    this._drawTriangle(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "ellipse":
                    this._drawEllipse(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "diamond":
                    this._drawDiamond(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "pentagon":
                    this._drawPentagon(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "circle":
                    this._drawCircle(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "slider":
                    this._drawSlider(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "pointer":
                    this._drawPointer(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "wedge":
                    this._drawWedge(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "trapezoid":
                    this._drawTrapezoid(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "roundedrectangle":
                    this._drawRoundedRectangle(location, style, this);
                    if ((!ej.isNullOrUndefined(style.imageUrl)) || style.imageUrl != "")
                        this._drawImagePointer(location, style, this);
                    break;
                case "image":
                    this._drawImagePointer(location, style, this);
                    break;
            }
        },

	 
        _drawNeedlePointer: function (location, style, element) {
            if (this.pointerEl[this.pointerIndex].needleType == "image") {
                this._drawImagePointer(location, style, element);
            }
            else{
            this._contextOpenPath(style, this);
            this.contextEl.translate(location.startX, location.startY);
            this.contextEl.rotate(Math.PI * ((style.angle) / 180));
            this.contextEl.lineTo(0, -style.width / 2);
            if (this.pointerEl[this.pointerIndex].needleType == "triangle") {
                this.contextEl.lineTo(style.height, 0);
            }
            else if (this.pointerEl[this.pointerIndex].needleType == "rectangle") {
                this.contextEl.lineTo(style.height, -style.width / 2);
                this.contextEl.lineTo(style.height, style.width / 2);
            }
            else if (this.pointerEl[this.pointerIndex].needleType == "trapezoid") {
                this.contextEl.lineTo(style.height, -style.width / 4);
                this.contextEl.lineTo(style.height, style.width / 4);
            }
            else if (this.pointerEl[this.pointerIndex].needleType == "arrow") {
                this.contextEl.lineTo(style.height - style.height / 4, -style.width / 6);
                this.contextEl.lineTo(style.height - style.height / 4, -style.width / 2);
                this.contextEl.lineTo(style.height, 0);
                this.contextEl.lineTo(style.height - style.height / 4, style.width / 2);
                this.contextEl.lineTo(style.height - style.height / 4, style.width / 6);
            }
            this.contextEl.lineTo(0, style.width / 2);
            if (style.showBackNeedle) {
                this.contextEl.lineTo(-(style.backNeedleLength + this.scaleEl[this.scaleIndex].pointerCap.radius / 2), style.width / 2);
                this.contextEl.lineTo(-(style.backNeedleLength + this.scaleEl[this.scaleIndex].pointerCap.radius / 2), -style.width / 2);
            }
            this._contextClosePath(style, this);
            }
            this.canvasEl.attr("aria-label", this.model.scales[this.scaleIndex].pointers[this.pointerIndex].value);
        },
        
        _drawImagePointer: function (location, style, element) {
            var self = this;
            var image = new Image();
            var angle = style.angle;
            var xPos = location.startX;
            var yPos = location.startY;
            var elemWidth = style.width;
            var elemHeight = style.height;
            var type = style.type;
            image.onload = function () {
                self.contextEl.save();
                self.contextEl.translate(xPos, yPos);
                self.contextEl.rotate(Math.PI * (angle / 180));
                self.contextEl.drawImage(this, 0, -elemHeight / 2, elemWidth, elemHeight);
                self.contextEl.restore();
            };
            image.src = style.imageUrl;
        },
	 
        _setPointerCap: function (element) {
            var grd;
            //var gradients = [{ "ColorStop": 0.19, "Color": "#F2DFDF" }, { "ColorStop": 0.71, "Color": "#FFFFFF" }, { "ColorStop": 0.77, "Color": "#836B33" }];
            grd = this.contextEl.createRadialGradient(this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.canvasEl[0].height / 2, 0, this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, this._isHalfCircle() ? this._getHalfCircleYPosition() : this.canvasEl[0].height / 2, this.scaleEl[this.scaleIndex].pointerCap.radius);
            if (!ej.isNullOrUndefined(this.scaleEl[this.scaleIndex].pointerCap.interiorGradient))
                this._setGradientColor(this, grd, this.scaleEl[this.scaleIndex].pointerCap.interiorGradient.colorInfo);
            else
                grd = (this.scaleEl[this.scaleIndex].pointerCap.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(this, this._getColor(element, this.scaleEl[this.scaleIndex].pointerCap.backgroundColor)); // this._getColor(this, this._getColor(element, this.scaleEl[this.scaleIndex].pointerCap.backgroundColor));
            this.region = { "centerX": this._isHalfCircle() ? this._getHalfCircleXPosition() : this.centerX, "centerY": this._isHalfCircle() ? this._getHalfCircleYPosition() : this.centerY, "startAngle": 0, "endAngle": 2 * Math.PI };
            this.style = { "isStroke": true, "isFill": true, "strokeStyle": (this.scaleEl[this.scaleIndex].pointerCap.borderColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(this, this._getColor(element, this.scaleEl[this.scaleIndex].pointerCap.borderColor)), "radius": this.scaleEl[this.scaleIndex].pointerCap.radius, "lineWidth": this.scaleEl[this.scaleIndex].pointerCap.borderWidth, "fillStyle": grd };
            if (this.model.drawPointerCap)
                this._onDrawPointerCap();
            this._drawCircleFrame(this.region, this.style);
        },

        
        isAndroid: function () {
            return (/android/i.test(navigator.userAgent.toLowerCase()));
        },
        
        redraw: function (value) {
            switch (value) {
                case "scale":
                    this._reDrawScale(); break;
                case "pointer":
                    this._reDrawPointer(); break;
                case "range":
                    this._reDrawRange(); break;
                case "label":
                    this._reDrawLabel(); break;
                case "tickMark":
                    this._reDrawTickMark();
                    break;
                case "subGauges":
                    this._reDrawSubGauge();
                    break;
                case "CustomLabel":
                    this._reDrawCustomLabel();
                    break;
                default:
                    this._init();
            }
        },
       
        _getIndicatorImage: function () {
            if (this.pointerImage)
                return this.pointerImage;
            else
                return this._getPointerImage();
        },
      
        _getPointerImage: function () {
            if (this.customLabelImage)
                return this.customLabelImage;
            else
                return this._getCustomLabelImage();
        },
      
        _getSubGaugeImage: function () {
            if (this.labelImage)
                return this.labelImage;
            else
                return this._getLabelImage();
        },
      
        _getCustomLabelImage: function () {
            if (this.subGaugeImage)
                return this.subGaugeImage;
            else
                return this._getSubGaugeImage();
        },
       
        _getRangeImage: function () {
            if (this.model.rangeZOrder  == "rear") {
                if (this.scaleImage)
                    return this.scaleImage;
                else
                    return this.outerImage;
            }
            else {
                if (this.tickImage)
                    return this.tickImage;
                else
                    return this._getTickImage();
            }
        },
       
        _getLabelImage: function () {
            if (this.model.rangeZOrder  == "rear") {
                if (this.tickImage)
                    return this.tickImage;
                else
                    return this._getTickImage();
            }
            else {
                if (this.tickImage)
                    return this.rangeImage;
                else
                    return this._getRangeImage();
            }
        },
      
        _getTickImage: function () {
            if (this.model.rangeZOrder  == "rear") {
                if (this.rangeImage)
                    return this.rangeImage;
                else
                    return this._getRangeImage();
            }
            else {
                if (this.scaleImage)
                    return this.scaleImage;
                else
                    return this.outerImage;
            }
        },
     
        getPointerValue: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].value;
            else
                return null;
        },
       
        setMarkerDistanceFromScale: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].distanceFromScale = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawPointer();
                else
                    this._initialize();
            }
        },
        
        getMarkerDistanceFromScale: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].distanceFromScale;
            else
                return null;
        },
        
        setPointerLength: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].length = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawPointer();
                else
                    this._initialize();
            }
        },
       
        getPointerLength: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].length;
            else
                return null;
        },
        
        setPointerWidth: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].width = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawPointer();
                else this._initialize();
            }
        },
       
        getPointerWidth: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].width;
            else
                return null;
        },

        
        setBackNeedleLength: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].backNeedleLength = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawPointer();
                else this._initialize();
            }
        },
        
        getBackNeedleLength: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].backNeedleLength;
            else
                return null;
        },
        
        setNeedleStyle: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].needleType = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawPointer();
                else this._initialize();
            }
        },
        
        getNeedleStyle: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].needleType;
            else
                return null;
        },
       
        setPointerPlacement: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].placement = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawPointer();
                else this._initialize();
            }
        },
		 
        getPointerPlacement: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].placement;
            else
                return null;
        },
      
        setPointerNeedleType: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                this.scaleEl[scaleIndex].pointers[pointerIndex].type = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawCustomLabel();
                else this._initialize();
            }
        },
          
        getPointerNeedleType: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].type;
            else
                return null;
        },
          
        setMarkerStyle: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
                if (value == "roundedrectangle" || !ej.isNullOrUndefined(ej.datavisualization.CircularGauge.MarkerType[value.replace(/\w\S*/g, function (txt) { return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase(); })])) {
                    this.scaleEl[scaleIndex].pointers[pointerIndex].markerType = value;
                    if (this.contextEl.putImageData && !this.isAndroid())
                        this._reDrawCustomLabel();
                    else this._initialize();
                }
            }
        },
          
        getMarkerStyle: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length)
                return this.scaleEl[scaleIndex].pointers[pointerIndex].markerType;
            else
                return null;
        },
          
        setCustomLabelValue: function (scaleIndex, customLabelIndex, value) {
            if (scaleIndex < this.model.scales.length && customLabelIndex < this.model.scales[scaleIndex].customLabels.length && value != null) {
                this.scaleEl[scaleIndex].customLabels[customLabelIndex].value = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawCustomLabel();
                else
                    this._initialize();
            }
        },
          
        getCustomLabelValue: function (scaleIndex, customLabelIndex) {
            if (scaleIndex < this.model.scales.length && customLabelIndex < this.model.scales[scaleIndex].customLabels.length)
                return this.scaleEl[scaleIndex].customLabels[customLabelIndex].value;
            else
                return null;
        },

          
        setSubGaugeLocation: function (scaleIndex, gaugeIndex, value) {
            if (scaleIndex < this.model.scales.length && gaugeIndex < this.model.scales[scaleIndex].subGauges.length && value != null) {
                this.scaleEl[scaleIndex].subGauges[gaugeIndex].position.x = value.x;
                this.scaleEl[scaleIndex].subGauges[gaugeIndex].position.y = value.y;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawSubGauge();
                else
                    this._initialize();
            }
        },
          
        getSubGaugeLocation: function (scaleIndex, gaugeIndex) {
            if (scaleIndex < this.model.scales.length && gaugeIndex < this.model.scales[scaleIndex].subGauges.length)
                return this.scaleEl[scaleIndex].subGauges[gaugeIndex].position;
            else
                return null;
        },
          
        setCustomLabelAngle: function (scaleIndex, customLabelIndex, value) {
            if (scaleIndex < this.model.scales.length && customLabelIndex < this.model.scales[scaleIndex].customLabels.length && value != null) {
                this.scaleEl[scaleIndex].customLabels[customLabelIndex].textAngle = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawCustomLabel();
                else
                    this._initialize();
            }
        },
          
        getCustomLabelAngle: function (scaleIndex, customLabelIndex) {
            if (scaleIndex < this.model.scales.length && customLabelIndex < this.model.scales[scaleIndex].customLabels.length)
                return this.scaleEl[scaleIndex].customLabels[customLabelIndex].textAngle;
            else
                return null;
        },
          
        setRangeStartValue: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].startValue = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawRange();
                else
                    this._initialize();
            }
        },
          
        getRangeStartValue: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].startValue;
            else
                return null;
        },
          
        setRangeEndValue: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].endValue = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawRange();
                else
                    this._initialize();
            }
        },
          
        getRangeEndValue: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].endValue;
            else
                return null;
        },
          
        setRangeSize: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].size = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawRange();
                else
                    this._initialize();
            }
        },

        setRangeVisible: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex]._visible = value;
                if (this.contextEl.putImageData && !this.isAndroid()) {
                    this._initialize();
                    this._wireEvents();
                }
                else
                    this._initialize();
            }
        },
          
        getRangeSize: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].size;
            else
                return null;
        },
          
        setRangeDistanceFromScale: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].distanceFromScale = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawRange();
                else
                    this._initialize();
            }
        },
          
        getRangeDistanceFromScale: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].distanceFromScale;
            else
                return null;
        },
          
        setRangePosition: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].placement = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawRange();
                else
                    this._initialize();
            }
        },
          
        getRangePosition: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].placement;
            else
                return null;
        },
          
        setRangeBorderWidth: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].border.width = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawRange();
                else
                    this._initialize();
            }
        },
          
        getRangeBorderWidth: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.model.scales.length && rangeIndex < this.model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].border.width;
            else
                return null;
        },
          
        setPointerValue: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.model.scales.length && pointerIndex < this.model.scales[scaleIndex].pointers.length && value != null) {
            if(value >= this.scaleEl[scaleIndex].minimum && value <= this.scaleEl[scaleIndex].maximum)
                this.scaleEl[scaleIndex].pointers[pointerIndex].value = value;
			    if (!this.updatePointerOnAnimation && this.model.enableAnimation)
                    this.pointerValue[pointerIndex] = value;
                if (this.contextEl.putImageData && !this._androidAnimation)
                   {
                    this._reDrawPointer();
                    this.updatePointerOnAnimation = false;
                   }  
                else
                    this._initialize();
            }
        },
          
        setLabelAngle: function (scaleIndex, labelIndex, angle) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length && angle != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].angle = angle;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawLabel();
                else this._initialize();
            }
        },
          
        getLabelAngle: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].angle;
            else
                return null;
        },
          
        setLabelDistanceFromScale: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].distanceFromScale = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawLabel();
                else this._initialize();
            }
        },
          
        getLabelDistanceFromScale: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].distanceFromScale;
            else
                return null;
        },
          
        setLabelStyle: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].type = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawLabel();
                else this._initialize();
            }
        },
          
        getLabelStyle: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].type;
            else
                return null;
        },
          
        setLabelPlacement: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].placement = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawLabel();
                else this._initialize();
            }
        },
          
        getLabelPlacement: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].placement;
            else
                return null;
        },
          
        setTickAngle: function (scaleIndex, tickIndex, angle) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length && angle != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].angle = angle;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawTickMark();
                else
                    this._initialize();
            }
        },
          
        getTickAngle: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].angle;
            else
                return null;
        },
          
        setTickStyle: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].type = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawTickMark();
                else this._initialize();
            }
        },
          
        getTickStyle: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].type;
            else
                return null;
        },
          
        setTickPlacement: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].placement = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawTickMark();
                else this._initialize();
            }
        },
          
        getTickPlacement: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].placement;
            else
                return null;
        },
          
        setTickWidth: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].width = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawTickMark();
                else this._initialize();
            }
        },
          
        getTickWidth: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].width;
            else
                return null;
        },
          
        setTickHeight: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].height = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawTickMark();
                else this._initialize();
            }
        },
          
        getTickHeight: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].height;
            else
                return null;
        },
          
        setTickDistanceFromScale: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].distanceFromScale = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawTickMark();
                else this._initialize();
            }
        },
          
        getTickDistanceFromScale: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.model.scales.length && tickIndex < this.model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].distanceFromScale;
            else
                return null;
        },
          
        setStartAngle: function (scaleIndex, angle) {
            if (scaleIndex < this.model.scales.length && angle != null) {
                this.scaleEl[scaleIndex].startAngle = angle;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getStartAngle: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].startAngle;
            else
                return null;
        },
          
        setSweepAngle: function (scaleIndex, angle) {
            if (scaleIndex < this.model.scales.length && angle != null) {
                this.scaleEl[scaleIndex].sweepAngle = angle;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getSweepAngle: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].sweepAngle;
            else
                return null;
        },
          
        setMinimumValue: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                if(value < this.scaleEl[scaleIndex].maximum)
                this.scaleEl[scaleIndex].minimum = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getMinimumValue: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].minimum;
            else
                return null;
        },
          
        setMaximumValue: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                if(value > this.scaleEl[scaleIndex].minimum)
                this.scaleEl[scaleIndex].maximum = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getMaximumValue: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].maximum;
            else
                return null;
        },
          
        setScaleBarSize: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].size = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getScaleBarSize: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].size;
            else
                return null;
        },
          
        setScaleRadius: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].radius = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getScaleRadius: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].radius;
            else
                return null;
        },
          
        setMajorIntervalValue: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].majorIntervalValue = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getMajorIntervalValue: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].majorIntervalValue;
            else
                return null;
        },
          
        setMinorIntervalValue: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].minorIntervalValue = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getMinorIntervalValue: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].minorIntervalValue;
            else
                return null;
        },
          
        setPointerCapRadius: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].pointerCap.radius = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getPointerCapRadius: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].pointerCap.radius;
            else
                return null;
        },
          
        setScaleBorderWidth: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].border.width = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getScaleBorderWidth: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].border.width;
            else
                return null;
        },
          
        setPointerCapBorderWidth: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].pointerCap.borderWidth = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getPointerCapBorderWidth: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].pointerCap.borderWidth;
            else
                return null;
        },
          
        setScaleDirection: function (scaleIndex, value) {
            if (scaleIndex < this.model.scales.length && value != null) {
                this.scaleEl[scaleIndex].direction = value;
                if (this.contextEl.putImageData && !this.isAndroid())
                    this._reDrawScale();
                else this._initialize();
            }
        },
          
        getScaleDirection: function (scaleIndex) {
            if (scaleIndex < this.model.scales.length)
                return this.scaleEl[scaleIndex].direction;
            else
                return null;
        },
          
        includeFirstValue: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.model.scales.length && labelIndex < this.model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].includeFirstValue = value;
                if (this.contextEl.putImageData)
                    this._reDrawLabel();
                else this.initialize();
            }
        },
          
        _reDrawScale: function () {
            if (this.model.frame.backgroundImageUrl)
                this.initialize();
            else {
                this.contextEl.putImageData(this.outerImage, 0, 0);
                this._drawScales();

            }
        },
          
        _reDrawPointer: function () {
            if (this.model.frame.backgroundImageUrl)
                this.initialize();
            else {
                this.contextEl.putImageData(this._getPointerImage(), 0, 0);
                this._setPointers();
                this._setIndicators();
            }
        },
          
        _reDrawCustomLabel: function () {
            if (this.model.frame.backgroundImageUrl)
                this.initialize();
            else {
                this.contextEl.putImageData(this._getCustomLabelImage(), 0, 0);
                this._setCustomLabel();
                this._setPointers();
                this._setIndicators();

            }
        },
          
        _reDrawRange: function () {
            if (this.model.frame.backgroundImageUrl)
                this._initialize();
            else {
                this.contextEl.putImageData(this._getRangeImage(), 0, 0);
                if (this.model.rangeZOrder  == "rear") {
                    this._setRanges();
                    this._setTicks();
                }
                else {
                    this._setRanges();
                }
                this._setLabels();
                this._subGauge();
                this._setCustomLabel();
                this._setPointers();
                this._setIndicators();

            }
        },
          
        _reDrawLabel: function () {
            if (this.model.frame.backgroundImageUrl)
                this._initialize();
            else {
                this.contextEl.putImageData(this._getLabelImage(), 0, 0);
                this._setLabels();
                this._subGauge();
                this._setCustomLabel();
                this._setPointers();
                this._setIndicators();

            }
        },
          
        _reDrawTickMark: function () {
            if (this.model.frame.backgroundImageUrl)
                this._initialize();
            else {
                this.contextEl.putImageData(this._getTickImage(), 0, 0);
                if (this.model.rangeZOrder  == "rear")
                    this._setTicks();
                else {
                    this._setTicks();
                    this._setRanges();
                }
                this._setLabels();
                this._subGauge();
                this._setCustomLabel();
                this._setPointers();
                this._setIndicators();

            }
        },
          
        _reDrawSubGauge: function () {
            if (this.model.frame.backgroundImageUrl)
                this._initialize();
            else {
                this.contextEl.putImageData(this._getSubGaugeImage(), 0, 0);
                this._subGauge();
                this._setCustomLabel();
                this._setPointers();
                this._setIndicators();

            }
        },
          
        refreshSubGauge: function () {
            if (this.contextEl.putImageData)
                this._reDrawSubGauge();
            else
                this._initialize();
        },
		  
        refresh: function () {
            this._scaleRedrawn = true;
            this._initialize();
            this._wireEvents();
        },
          
        exportImage: function (fileName, fileType) {
            /// <summary>This function save the rendered canvas image</summary>
            /// <param name="fileName" type="String">fileName to which the image has been saved</param>
            /// <param name="fileType" type="String">fileType to which the image has been saved</param>
            if (ej.browserInfo().name === "msie" && parseFloat(ej.browserInfo().version) < 10) {
                return false;
            }
            else {
                var image = this.canvasEl[0].toDataURL();
                image = image.replace(/^data:[a-z]*;,/, '');
                var image1 = image.split(',');
                var byteString = atob(image1[1]);
                var buffer = new ArrayBuffer(byteString.length);
                var intArray = new Uint8Array(buffer);
                for (var i = 0; i < byteString.length; i++) {
                    intArray[i] = byteString.charCodeAt(i);
                }
                var blob = new Blob([buffer], { type: "image/png" });
                if (ej.browserInfo().name === "msie")
                    window.navigator.msSaveOrOpenBlob(blob, fileName + '.' + fileType);
                else {
                    var pom = document.createElement('a');
                    var url = URL.createObjectURL(blob);
                    pom.href = url;
                    pom.setAttribute('download', fileName + '.' + fileType);
                    if (document.createEvent) {
                        var e = document.createEvent("MouseEvents");
                        e.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
                        pom.dispatchEvent(e);
                    }
                    else if (pom.fireEvent) {
                        pom.fireEvent("onclick");
                    }
                }
                return true;
            }
        },
		  
        resizeCanvas: function () {
            if (_gaugeCount!=0)
                _gaugeCount = _gaugeCount - 1;
            else
                _gaugeCount = $(".e-circulargauge").length - 1;
            var state, chk=true;
            if (!ej.isNullOrUndefined(this.GaugeEl.parent().attr("style")))
                state = this.GaugeEl.parent().attr("style").split(";");
            if (!ej.isNullOrUndefined(state)){
            $.each(state, function (key, val) {
                while (val.indexOf("width")!=-1){
                    chk = val.indexOf("px") == -1 ? true : false;
                    break;
                }
            });
            }
            if (chk) {
            var ratio = window.innerWidth / initialDivWidth;
			var oldWidth = this.model.width;
			var oldHeight = this.model.height;
				if ((oldWidth *ratio > window.innerWidth) || (oldHeight *ratio > window.innerHeight))
					ratio = 1;
                this.model.width *= ratio;
                this.model.height *= ratio;
                this.model.radius *= ratio;
				this._gaugeResizeState = true;
                for (var i = 0; this.model.scales[i] != null; i++) {
                    this.model.scales[i].radius *= ratio;
                    this.model.scales[i].pointerCap.radius *= ratio;
					 for (var k = 0 ; k < this.model.scales[i].customLabels.length; k++)
                    {
                            if (!ej.isNullOrUndefined(this.model.scales[i].customLabels[k])) {
                            if (this.model.scales[i].customLabels[k].positionType != "outer")
                                this.model.scales[i].customLabels[k].position.x *= ratio;
                                this.model.scales[i].customLabels[k].position.y *= ratio;
                            this.model.scales[i].customLabels[k].font.size = (parseFloat(this.model.scales[i].customLabels[k].font.size.match(/\d+/)[0]) * ratio < 10) ? "10px" : ((parseFloat(this.model.scales[i].customLabels[k].font.size.match(/\d+/)[0]) * ratio) > this._customLblMaxSize) ? this._customLblMaxSize.toString() + 'px' : ((parseFloat(this.model.scales[i].customLabels[k].font.size.match(/\d+/)[0])) * ratio).toString() + 'px';
                        }
                    }
                    for (var j = 0; this.model.scales[i].labels[j] != null || this.model.scales[i].pointers[j] != null || this.model.scales[i].ranges[j] != null || this.model.scales[i].indicators[j] != null || this.model.scales[i].subGauges[j] != null || this.model.scales[i].ticks[j] != null; j++) {
                        if (!ej.isNullOrUndefined(this.model.scales[i].ticks[j])) this.model.scales[i].ticks[j].height *= ratio;
                        if (!ej.isNullOrUndefined(this.model.scales[i].pointers[j])) {
                            this.model.scales[i].pointers[j].length *= ratio;
                            this.model.scales[i].pointers[j].width *= ratio;
                            this.model.scales[i].pointers[j].backNeedleLength *= ratio;
                        }
                        if (!ej.isNullOrUndefined(this.model.scales[i].ranges[j])) {
                            this.model.scales[i].ranges[j].distanceFromScale *= ratio;
                            this.model.scales[i].ranges[j].size *= ratio;
                        }
                        if (!ej.isNullOrUndefined(this.model.scales[i].indicators[j]) && this.model.scales[i].showIndicators) {
                            this.model.scales[i].indicators[j].height *= ratio;
                            this.model.scales[i].indicators[j].width *= ratio;
                            this.model.scales[i].indicators[j].position.x *= ratio;
							this.model.scales[i].indicators[j].position.y *= ratio;
                        }
                        if (!(ej.isNullOrUndefined(this.model.scales[i].subGauges[j])) && (ej.isNullOrUndefined(this.model.scales[i].subGauges[j].controlID))) {
                            this.model.scales[i].subGauges[j].height *= ratio;
                            this.model.scales[i].subGauges[j].width *= ratio;
                            this.model.scales[i].subGauges[j].position.x *= ratio;
                        }
                    }
                }
                this.refresh();
                if (_gaugeCount == 0) {
                    initialDivWidth = window.innerWidth;
                }
            }
        },

          
		  
        _onDrawTicks: function (tickAngle, pointerValue) {
            var tick = { index: this.tickIndex, element: this.tickEl[this.tickIndex], angle: parseInt(tickAngle) };
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, pointerValue: pointerValue, style: this.style, position: this.region,tick:tick };
            this._trigger("drawTicks", data);
        },
		  
        _onDrawLabels: function (labelAngle, pointerValue) {
            var label = { index: this.labelIndex, element: this.labelEl[this.labelIndex], angle: parseInt(labelAngle) };
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, pointerValue: pointerValue, style: this.style, position: this.region,label:label };
            this._trigger("drawLabels", data);
        },
		  
        _onDrawPointers: function (pointerAngle, pointerValue) {
            var pointer = { index: this.pointerIndex, element: this.pointerEl[this.pointerIndex], angle: parseInt(pointerAngle), pointerValue: pointerValue};
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, pointer: pointer };
            this._trigger("drawPointers", data);
        },
		  
        _onDrawRange: function () {
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, rangeIndex: this.rangeIndex, rangeElement: this.rangeEl[this.rangeEl], context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawRange", data);
        },
		  
        _onDrawCustomLabel: function () {
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, customLabelIndex: this.customLabelIndex, customLabelElement: this.customLabelEl[this.customLabelIndex], context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawCustomLabel", data);
        },
		  
        _onDrawIndicators: function () {
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, indicatorIndex: this.indicatorIndex, indicatorEl: this.indicatorEl[this.indicatorIndex], context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawIndicators", data);
        },
		  
        _onDrawPointerCap: function () {
            var data = { object: this, scaleElement: this.model.scales, position: this.region, style: this.style, context: this.contextEl };
            this._trigger("drawPointerCap", data);
        },
		  
        _onRenderComplete: function () {
            var data = { object: this, scaleElement: this.model.scales, context: this.contextEl };
            this._trigger("renderComplete", data);
        },
		  
        _onMouseClick: function (pointerAngle, pointerValue) {
            var pointer = { index: this.pointerIndex, element: this.pointerEl[this.pointerIndex], value: pointerValue, angle: parseInt(pointerAngle) }
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.position, pointers: pointer };
            this._trigger("mouseClick", data);
        },
		  
        _onMouseClickMove: function (pointerAngle, pointerValue) {
            var pointer = { index: this.pointerIndex, element: this.pointerEl[this.pointerIndex], value: pointerValue, angle: parseInt(pointerAngle) }
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, pointers: pointer };
            this._trigger("mouseClickMove", data);
        },
		  
        _onMouseClickUp: function (pointerAngle, pointerValue) {
            var pointer = { index: this.pointerIndex, element: this.pointerEl[this.pointerIndex], value: pointerValue, angle: parseInt(pointerAngle) }
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, pointers: pointer };
            this._trigger("mouseClickUp", data);
        },

          
		  
        _setTheme: function () {
            var selectedTheme =this.model.themeProperties[this.model.theme];
            this._setThemeColors(selectedTheme);
        },
		  
        _setThemeColors: function (selectedTheme) {
            var result = [], jsonObj = this.model.themeProperties;
            for (var name in jsonObj) {
                result.push(name);
            }
            for (var th = 0; th < result.length; th++) {
                this.model.backgroundColor = ((!this.model.backgroundColor || this.model.backgroundColor == jsonObj[result[th]].backgroundColor) ? selectedTheme.backgroundColor : this.model.backgroundColor);
                for (var i = 0; i < this.model.scales.length; i++) {
                    this.model.scales[i].backgroundColor = (!this.model.scales[i].backgroundColor || this.model.scales[i].backgroundColor == jsonObj[result[th]].scales.backgroundColor) ? selectedTheme.scales.backgroundColor : this.model.scales[i].backgroundColor;
                    this.model.scales[i].border.color = (!this.model.scales[i].border.color || this.model.scales[i].border.color == jsonObj[result[th]].scales.border.color) ? selectedTheme.scales.border.color : this.model.scales[i].border.color;
                    for (var j = 0; j < this.model.scales[i].pointers.length; j++) {
                        this.model.scales[i].pointers[j].backgroundColor = (!this.model.scales[i].pointers[j].backgroundColor || this.model.scales[i].pointers[j].backgroundColor == jsonObj[result[th]].scales.pointers.backgroundColor) ? selectedTheme.scales.pointers.backgroundColor : this.model.scales[i].pointers[j].backgroundColor;
                        this.model.scales[i].pointers[j].border.color = (!this.model.scales[i].pointers[j].border.color || this.model.scales[i].pointers[j].border.color == jsonObj[result[th]].scales.pointers.border.color) ? selectedTheme.scales.pointers.border.color : this.model.scales[i].pointers[j].border.color;
                        this.model.scales[i].pointerCap.backgroundColor = (!this.model.scales[i].pointerCap.backgroundColor || this.model.scales[i].pointerCap.backgroundColor == jsonObj[result[th]].scales.pointerCap.backgroundColor) ? selectedTheme.scales.pointerCap.backgroundColor : this.model.scales[i].pointerCap.backgroundColor;
                        this.model.scales[i].pointerCap.borderColor = (!this.model.scales[i].pointerCap.borderColor || this.model.scales[i].pointerCap.borderColor == jsonObj[result[th]].scales.pointerCap.borderColor) ? selectedTheme.scales.pointerCap.borderColor : this.model.scales[i].pointerCap.borderColor;
                    }
                    for (var k = 0; k < this.model.scales[i].ticks.length; k++) {
                        this.model.scales[i].ticks[k].color = (!this.model.scales[i].ticks[k].color || this.model.scales[i].ticks[k].color == jsonObj[result[th]].scales.ticks.color) ? selectedTheme.scales.ticks.color : this.model.scales[i].ticks[k].color;
                    }
                    for (var l = 0; l < this.model.scales[i].labels.length; l++) {
                        this.model.scales[i].labels[l].color = (!this.model.scales[i].labels[l].color || this.model.scales[i].labels[l].color == jsonObj[result[th]].scales.labels.color) ? selectedTheme.scales.labels.color : this.model.scales[i].labels[l].color;
                    }
                }
            }
        },
		  
        _getFontString: function (element, font) {
            return (font ? (font.fontStyle ? font.fontStyle : "") + " " + ((font.size == null) ? "11px" : font.size) + " " + font.fontFamily : "");
        },
		  
        _drawTriangle: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawPointer: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(style.width, style.height / 4);
            element.contextEl.lineTo(style.width, -style.height / 4);
            element.contextEl.lineTo(style.width / 2, -style.height / 4);
            element.contextEl.lineTo(style.width / 2, -style.height / 2);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 2, style.height / 2);
            element.contextEl.lineTo(style.width / 2, style.height / 4);
            this._contextClosePath(style, element);
        },
		  
        _drawWedge: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(3 * style.width / 4, 0);
            element.contextEl.lineTo(style.width, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawSlider: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 4, -style.height / 2);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            element.contextEl.lineTo(style.width / 4, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawStar: function (location, style, element) {
            this._contextOpenPath(style, element);
            if (element.model.Orientation == "Horizontal" && element.markerPlacement == "near") {
                element.contextEl.lineTo(location.startX + style.width - (style.width / 6), location.startY);   
                element.contextEl.lineTo(location.startX, location.startY + style.height - style.height / 3);
                element.contextEl.lineTo(location.startX + style.width, location.startY + style.height - style.height / 3);
                element.contextEl.lineTo(location.startX + style.width / 6, location.startY);
                element.contextEl.lineTo(location.startX + style.width / 2, location.startY + style.height);
            }
            else {
                element.contextEl.lineTo(location.startX + (style.width / 6), location.startY + style.height);   
                element.contextEl.lineTo(location.startX + style.width, location.startY + (style.height / 3));   
                element.contextEl.lineTo(location.startX, location.startY + (style.height / 3));   
                element.contextEl.lineTo(location.startX + style.width - (style.width / 6), location.startY + style.height);   
                element.contextEl.lineTo(location.startX + style.width / 2, location.startY);   
            }
            this._contextClosePath(style, element);
        },
		  
        _drawPentagon: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 3, -style.height / 2);
            element.contextEl.lineTo(style.width, -style.height / 4);
            element.contextEl.lineTo(style.width, style.height / 4);
            element.contextEl.lineTo(style.width / 3, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawDiamond: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 2, -style.height / 2);
            element.contextEl.lineTo(style.width, 0);
            element.contextEl.lineTo(style.width / 2, style.height / 2);
            element.contextEl.lineTo(0, 0);
            this._contextClosePath(style, element);
        },
		  
        _drawCircle: function (location, style, element) {
            var radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2;
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.arc(radius / 2, 0, radius / 2, 0, Math.PI * 2, true);
            this._contextClosePath(style, element);
        },

        _drawLine: function (location, style, element) {
            element.contextEl.beginPath();
            element.contextEl.strokeStyle = style.fillStyle;
            element.contextEl.globalAlpha = style.opacity;
            element.contextEl.lineWidth = style.lineWidth;
            element.contextEl.moveTo(location.startX, location.startY);
            element.contextEl.lineTo((location.startX + style.width), location.startY);
            element.contextEl.closePath();
            element.contextEl.stroke();
        },
		  
        _drawTrapezoid: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(0, -style.height / 4);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            element.contextEl.lineTo(0, style.height / 4);
            this._contextClosePath(style, element);
        },
		  
        _drawRectangle: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(0, -style.height / 2);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            element.contextEl.lineTo(0, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawRoundedRectangle: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(style.radius, -style.height / 2);
            element.contextEl.lineTo(style.width - style.radius, -style.height / 2);
            element.contextEl.quadraticCurveTo(style.width, -style.height / 2, style.width, (-style.height / 2) + style.radius);
            element.contextEl.lineTo(style.width, (style.height / 2) - style.radius);
            element.contextEl.quadraticCurveTo(style.width, style.height / 2, style.width - style.radius, style.height / 2);
            element.contextEl.lineTo(style.radius, style.height / 2);
            element.contextEl.quadraticCurveTo(0, style.height / 2, 0, style.height / 2 - style.radius);
            element.contextEl.lineTo(0, -style.height / 2 + style.radius);
            element.contextEl.quadraticCurveTo(0, -style.height / 2, style.radius, -style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawCustomImage: function (element, imageUrl) {
            var image = new Image();
            $(image).on('load', function () {
                element.contextEl.drawImage(this, 0, 0, element.model.Width, element.model.Height);
                if (element.model.scales != null)
                    element._drawScales();
                if (element.model.items != null)
                    element._renderItems();
            }).attr('src', imageUrl);
        },
		  
        _drawEllipse: function (location, style, element) {
            var radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2;
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.scale(2, 1);
            element.contextEl.arc(radius / 2, 0, radius / 2, 0, Math.PI * 2, true);
            this._contextClosePath(style, element);
        },
		  
        _setPointerDimension: function (style, element) {
            if (!ej.isNullOrUndefined(element.model.Orientation)) {
                if (element.model.Orientation == "Horizontal") {
                    var tempWidth = style.width;
                    var tempHeight = style.height;
                    style.height = tempWidth;
                    style.width = tempHeight;
                }
            }
            return style;
        },
		  
        _setContextRotation: function (style, element) {
            element.contextEl.rotate(Math.PI * (style.angle / 180));
        },
		  
        _contextOpenPath: function (style, element) {
            element.contextEl.save();
            element.contextEl.beginPath();
            if (style.strokeStyle)
                element.contextEl.strokeStyle = style.strokeStyle;
            if (style.opacity != undefined)
                element.contextEl.globalAlpha = style.opacity;
            if (style.lineWidth)
                element.contextEl.lineWidth = style.lineWidth;
            if (style.fillStyle)
                element.contextEl.fillStyle = style.fillStyle;
        },
		  
        _contextClosePath: function (style, element) {
            element.contextEl.closePath();
            if (style.isFill)
                element.contextEl.fill();
            if (style.isStroke)
                element.contextEl.stroke();
            element.contextEl.restore();
        },
		  
        _blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },
		  
        _isBetween: function (first, last, number, padding) {
            return (first < last ? number >= first - padding && number <= last + padding : number >= last - padding && number <= first + padding);
        },
		  
        _getColor: function (element, option) {
            if (typeof (option) === "string") {
                return option;
            }
            else {
                return ("rgba(" + option.r + ", " + option.g + "," + option.b + ", " + option.a / 255 + ")");
            }
        },
		  
        _setGradientColor: function (element, gradients, options) {
            var self = element;
            if (options.Name || typeof (options) === "string") {
                gradients.addColorStop(0, this._getColor(element, options));
                gradients.addColorStop(1, this._getColor(element, options));
            }
            else
                $.each(options, function (index, colorElement) {
                    gradients.addColorStop(colorElement.colorStop != NaN ? colorElement.colorStop : 0, typeof (colorElement.color) === "string" ? colorElement.color : self._getColor(element, colorElement.color));
                });
        }
    });
      
  (function() {      // for requestAnimationFrame
    var now = 0, items = ['ms', 'moz', 'webkit', 'o'], i, prevTime, element, callNow;
    for (i = 0; i < items.length && !window.requestAnimationFrame; ++i) 
        window.requestAnimationFrame = window[items[i]+'RequestAnimationFrame'];
    if (!window.requestAnimationFrame) {
		ej.datavisualization.CircularGauge.animationPolyfill = true;
        window.requestAnimationFrame = function(callback, element) {						
            prevTime = new Date().getTime();
            callNow = Math.max(0, 16 - (prevTime - now));
            element = window.setTimeout(function() { callback(prevTime + callNow); }, callNow);
            now = prevTime + callNow;
            return element;
        };
	}
  })();

    ej.datavisualization.CircularGauge.Frame = {
          
        FullCircle: "fullcircle",
          
        HalfCircle: "halfcircle"
    };
      
    ej.datavisualization.CircularGauge.Directions = {
          
        Clockwise: "clockwise",
          
        CounterClockwise: "counterclockwise"
    };
      
    ej.datavisualization.CircularGauge.PointerPlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.CircularGauge.PointerType = {
          
        Needle: "needle",
          
        Marker: "marker"
    };
      
    ej.datavisualization.CircularGauge.NeedleType = {
          
        Triangle: "triangle",
          
        Rectangle: "rectangle",
          
        Trapezoid: "trapezoid",
          
        Arrow: "arrow",
          
        Image: "image",
    };
      
    ej.datavisualization.CircularGauge.MarkerType = {
          
        Rectangle: "rectangle",
          
        Triangle: "triangle",
          
        Ellipse: "ellipse",
          
        Diamond: "diamond",
          
        Pentagon: "pentagon",
          
        Circle: "circle",
          
        Slider: "slider",
          
        Pointer: "pointer",
          
        Wedge: "wedge",
          
        Trapezoid: "trapezoid",
          
        RoundedRectangle: "roundedrectangle",
          
        Image: "image"
    };
      
    ej.datavisualization.CircularGauge.RangePlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.CircularGauge.TickType = {
          
        Major: "major",
          
        Minor: "minor"
    };
      
    ej.datavisualization.CircularGauge.gaugePosition = {
          
        TopLeft: "topleft",
          
        TopRight: "topright",
          
        TopCenter: "topcenter",
          
        MiddleLeft: "middleleft",
          
        MiddleRight: "middleright",
          
        Center: "center",
          
        BottomLeft: "bottomleft",
          
        BottomRight: "bottomright",
          
        BottomCenter: "bottomcenter",
    };
      
    ej.datavisualization.CircularGauge.TickPlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.CircularGauge.CustomLabelPositionType = {
          
        Inner: "inner",
          
        Outer: "outer"
    };
      
    ej.datavisualization.CircularGauge.OuterCustomLabelPosition = {
          
        Left: "left",
          
        Right: "right",
          
        Top: "top",
          
        Bottom: "bottom",
    };
      
    ej.datavisualization.CircularGauge.LabelPlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.CircularGauge.LabelType = {
          
        Major: "major",
          
        Minor: "minor"
    };
      
    ej.datavisualization.CircularGauge.UnitTextPlacement = {
          
        Back: "back",
          
        Front: "front"
    };
      
    ej.datavisualization.CircularGauge.RangeZOrderPosition = {
          
        Rear: "rear",
          
        Front: "front"
    };
      
    ej.datavisualization.CircularGauge.IndicatorType = {
          
        Rectangle: "rectangle",
          
        Circle: "circle",
          
        RoundedRectangle: "roundedrectangle",
          
        Text: "text",
          
        Image:"image"
    };
	  
 	ej.datavisualization.CircularGauge.Themes= {
		
		FlatLight: 'flatlight',

		FlatDark: 'flatdark'
 	};

 	ej.datavisualization.CircularGauge.LegendPosition = {

 	    Top: "top",

 	    Bottom: "bottom",

 	    Left: "left",

        Right: "right"
 	};

 	ej.datavisualization.CircularGauge.LegendAlignment = {

 	    Near: "near",

 	    Center: "center",

        Far: "far"
 	};

 	ej.datavisualization.CircularGauge.LegendShape = {

 	    Rectangle: "rectangle",

 	    Triangle: "triangle",

 	    Diamond: "diamond",

 	    Pentagon: "pentagon",

 	    Circle: "circle",

 	    Slider: "slider",

 	    Wedge: "wedge",

 	    Trapezoid: "trapezoid",

        Line: "line"

 	};
	
      

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
	 

    ej.widget({ "ejLinearGauge": "ej.datavisualization.LinearGauge"}, {
       
        element: null,
        _rootCSS: "e-lineargauge",
        _animationFlag: true,
        
        model: null,
        _customLblMaxSize: 0,
        _savedPoints: [],
        validTags: ["div", "span"],

       
        defaults:  {
		
			locale: null,
			
			enableGroupSeparator: false,
			  	
            value: 0,
			  
            minimum: 0,
			  
            maximum: 100,
			  
            width: 150,
			  
            height: 400,
			  
            theme: "flatlight",
			  
            orientation: "Vertical",
			  
            pointerGradient1: null,
			  
            pointerGradient2: null,
			  
            backgroundColor: null,
			  
            borderColor: null,
			  
            labelColor: null,
			  
            tickColor: null,
			  
            readOnly: true,
			  
            enableResize: false,
              
            isResponsive: false,
              
            tooltip: {
                  
                showLabelTooltip: false,
                  
                showCustomLabelTooltip: false,
                  
                    templateID: null,
            },
              
            outerCustomLabelPosition: "bottom",
              
			frame: {
			      
			    backgroundImageUrl: null,
			      
			    outerWidth: 12,
			      
                innerWidth:8
			},
			  
            scales: null,
			  
            enableAnimation: true,
              
            enableMarkerPointerAnimation: true,
			  
            animationSpeed: 500,
			  
            drawTicks: null,
			  
            drawLabels: null,
			  
            drawBarPointers: null,
			  
            drawMarkerPointers: null,
			  
            drawRange: null,
			  
            drawCustomLabel: null,
			  
            drawIndicators: null,
			  
            load: null,
			  
            init: null,
			  
            renderComplete: null,
              
            mouseClick: null,
              
            mouseClickMove: null,
              
            mouseClickUp: null,
			themeProperties:{
			flatlight: {
            scales: {
                backgroundColor: "#FFFFFF",
                border: { color: "#1d1e1e" },
                barPointers: {
                    backgroundColor: "#8abc3b",
                    border: { color: "#8abc3b" }
                },
                markerPointers: {
                    backgroundColor: "#212121",
                    border: { color: "#212121" }
                },
                ticks: {
                    color: "#1d1e1e"
                },
                labels: {
                    labelColor: "#222222"
                }
            }
        },
		  
        flatdark: {
            scales: {
                backgroundColor: "#808080",
                border: { color: "#808080" },
                barPointers: {
                    backgroundColor: "#8abc3b",
                    border: { color: "#8abc3b" }
                },
                markerPointers: {
                    backgroundColor: "#CCCCCC",
                    border: { color: "#CCCCCC" }
                },
                ticks: {
                    color: "#808080"
                },
                labels: {
                    labelColor: "#CCCCCC"
                }
            }
        }
			
			}
        },
				  	
        _defaultScaleValues: function () {
            return {
				  	
                minimum: null,
				  	
                maximum: null,
				  	
                majorIntervalValue: 10,
				  	
                minorIntervalValue: 2,
				  	
                direction: "counterclockwise",
				  	
                backgroundColor: null,
				  	
                border: {
                      
                    color: null,
                      
                    width:1.5
                },
				  	
                opacity: NaN,
				  	
                width: 30,
				  	
                shadowOffset: 0,
				  	
                length: 290,
				  	
                type: "rectangle",
				  	
                position: { 
				  	
				x: 50, 
				  	
				y: 50 },
				  	
                showRanges: false,
				  	
                showIndicators: false,
				  	
                showCustomLabels: false,
				  	
                showLabels: true,
				  	
                showTicks: true,
				  	
                showBarPointers: true,
				  	
                showMarkerPointers: true,
				  	
                ticks: [{
                                          
                    distanceFromScale: {
                          
                        x: 0,
                          
                        y:0
                    },
					  	
                    angle: 0,
					  	
                    color: null,
					  	
                    type: "majorinterval",
					  	
                    placement: "near",
					  	
                    opacity: 0,
					  	
                    height: 10,
					  	
                    width: 3
                },
                {              
                    distanceFromScale: {
                        x: 0,
                        y:0
                    },
                    angle: 0,
                    color: null,
                    type: "minorinterval",
                    placement: "near",
                    opacity: 0,
                    height: 5,
                    width: 2
                }],
                  
                ranges: [{
                      
                    endWidth: 10,
                      
                    placement: "center",
					  
                    startWidth: 10,
					  
                    distanceFromScale: 0,
					  
                    endValue: 60,
					  
                    startValue: 20,
					  
                    gradients: null,
					  
                    backgroundColor: null,
					  
                    border: {
                          
                        color: null,
                          
                        width:1.5
                    },
					  
                    opacity: null
                }],
					  
                labels: [{
                      
                    distanceFromScale: {
                            
                        x: -10,
                            
                        y:0
                    },
                      
                    angle: 0,
					  
                    font: { 
					  
					size: "11px", 
					  
					fontFamily: "Arial", 
					  
					fontStyle: "bold" },
					  
                    textColor: null,
					  
                    opacity: 0,
					  
                    type: "major",
					  
                    placement: "near",
					  
                    includeFirstValue: true,
					  
					unitText: "",
					  
					unitTextPlacement: "back"  
                }],
				      
                markerPointers: [{
					  
                    type: "triangle",
					  
                    length: 30,
					  
                    placement: "far",
					  
                    gradients: null,
					  
                    distanceFromScale: 0,
					  
                    width: 30,
					  
                    value: null,
					  
                    backgroundColor: null,
					  
                    border: {
                          
                        color: null,
                          
                        width:1.5
                    },
					  
                    opacity: 1
                }],
					  
                barPointers: [{
				      
                    gradients: null,
					  
                    distanceFromScale: 0,
					  
                    width: 30,
					  
                    value: null,
					  
                    backgroundColor: null,
                      
                    border: {
                          
                        color: null,
                          
                        width:1.5
                    },
					  
                    opacity: 1
                }],
					  	
                indicators: [{
					  
                    font: { 
					  
					size: "11px", 
					  
					fontFamily: "Arial",
					  					
					fontStyle: "bold" },
					  					
                    height: 30,
					  	
                    type: "rectangle",
					  	
                    width: 30,
						  	
                    position: { 
					  	
					x: 0, 
					  	
					y: 0 },
					  	
                    textLocation: { 
					  	
					x: 0, 
					  	
					y: 0 },
					  
                    stateRanges: [{
					  
                    endValue: 60,
					  
                    startValue: 50,
					  
                    backgroundColor: null,
					  
                    borderColor: null,
					  
                    text: "",
					  
                        textColor: null
                    }],
					  
                    backgroundColor: null,
                                          
                    border: {
                          
                        color: null,
                          
                        width:1.5
                    },
					  
                    opacity: NaN
                }],
					  
                customLabels: [{
					  
                    font: { 
					  
					size: "11px", 
					  
					fontFamily: "Arial", 
					  
					fontStyle: "bold" },
					  
                    color: null,
					  
                    opacity: 0,
					  
                    value: "",
					  
                    textAngle: 0,
					  
                    position: { 
					  
					x: 0, 
					  
					y: 0 },
                      
                    positionType:"inner"
                }]
            };
        },

        dataTypes: {
            scales: "data",
            isResponsive: "boolean",
        },
        observables: ["value", "minimum", "maximum"],
        _tags: [{
            tag: "scales",
            attr: ["majorIntervalValue", "minorIntervalValue", "backgroundColor", "shadowOffset", "showRanges", "showIndicators", "showCustomLabels", "showLabels", "showTicks", "showBarPointers", "showMarkerPointers", "border.color", "border.width", "position.x", "position.y",
                [{
                    tag: "markerPointers", attr: ["distanceFromScale", "backgroundColor", "border.width", "border.color"]
                }, {
                    tag: "barPointers", attr: ["distanceFromScale", "backgroundColor", "border.width", "border.color"]
                }, {
                    tag: "ranges", attr: ["distanceFromScale", "startValue", "endValue", "startWidth", "endWidth", "backgroundColor", "border.color", "border.width"]
                }, {
                    tag: "ticks", attr: ["distanceFromScale.x", "distanceFromScale.y"]
                }, {
                    tag: "indicators", attr: ["backgroundColor", "textLocation", "font.size", "font.fontFamily", "font.fontStyle", "position.x", "position.y", "textLocation.x", "textLocation.y", "borderColor", "textColor",
                        [{
                            tag: "stateRanges", attr: ["endValue", "startValue", "backgroundColor", "borderColor", "textColor"]
                        }]
                    ]
                }, {
                    tag: "labels", attr: ["distanceFromScale.x", "distanceFromScale.y", "textColor", "includeFirstValue", "unitText", "unitTextPlacement", "font.size", "font.fontFamily", "font.fontStyle"]
                }, {
                    tag: "customLabels", attr: ["textAngle", "font.size", "font.fontFamily", "font.fontStyle", "position.x", "position.y"]
                }]
            ]
        }],
        value: ej.util.valueFunction("value"),
        minimum: ej.util.valueFunction("minimum"),
        maximum: ej.util.valueFunction("maximum"),

          
		  	 
        _init: function () {
            _linearGaugeCount = $(".e-lineargauge").length;
            initialGaugeCount = _linearGaugeCount;
            this._initialize();
            this._trigger("load");
            this._setTheme();
            this._render();
            this.wireEvents();
			this._onWindowResize();
        },
		  	
		_onWindowResize:function()
        {
            if (this.model.enableResize || this.model.isResponsive) {
                if (!ej.isTouchDevice())
                    this._on($(window), "resize", this.resizeCanvas);
                else
                    this._on($(window), "orientationchange", this.resizeCanvas);
            }
        },
		  	 
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "theme": this.model.theme = options[option]; this._init(); break;
                    case "height": this.model.height = options[option]; break;
                    case "width": this.model.width = options[option]; break;
                    case "orientation": this.model.orientation = options[option]; break;
                    case "pointerGradient1": this.model.pointerGradient1 = options[option]; break;
                    case "pointerGradient2": this.model.pointerGradient2 = options[option]; break;
                    case "labelColor": this.model.labelColor = options[option]; break;
                    case "tick": $.extend(this.model.tick,options[option]); break;
                    case "backgroundColor": this.model.backgroundColor = options[option]; break;
                    case "borderColor": this.model.borderColor = options[option]; break;
                    case "frame": $.extend(this.model.frame, options[option]);
                    case "outerCustomLabelPosition": this.model.outerCustomLabelPosition = options[option]; break;
                    case "tooltip": $.extend(this.model.tooltip, options[option]); break;
                    case "readOnly": this.model.readOnly = options[option]; break;
                    case "value":
                        (this.value() == "") && this.value(0);
                        for (var i = 0; this.model.scales[i] != null; i++) {
                            for (var j = 0; this.model.scales[i].markerPointers[j] != null; j++) {
                                this.model.scales[i].markerPointers[j].value = parseFloat(this.value());
                            }
                        }
                        for (var k = 0; this.model.scales[k] != null; k++) {
                            for (var l = 0; this.model.scales[k].barPointers[l] != null; l++) {
                                this.model.scales[k].barPointers[l].value = parseFloat(this.value());
                            }
                        }
                        break;
                    case "minimum":
                        (this.minimum() == "") && this.minimum(0);
                        for (var m = 0; this.model.scales[m] != null; m++) {
                            this.model.scales[m].minimum = parseInt(this.minimum());
                        }
                        break;
                    case "maximum":
                        (this.maximum() == "") && this.maximum(0);
                        for (var n = 0; this.model.scales[n] != null; n++) {
                            this.model.scales[n].maximum = parseInt(this.maximum());
                        }
                        break;
                    case "scales":
                        this.model.scales = options[option];
                        this._itemInitialize();
                        break;
                }
            }
            this._render();
            this.wireEvents();
        },
          	       	 
        _destroy: function () {
            this.activeElement = null;
            this.canvasEl = null;
            this.contextEl = null;
            this.unWireEvents();
            this.element.empty().removeClass("e-widget");
        },
		  	
        _initialize: function () {
            this.GaugeEl = this.element;
            this.scaleStartX = [];
            this.scaleStartY = [];
            this.isScaleModified = false;
            this.target = this.element[0];
            this._itemInitialize();
            this.Model = this.model;
        },
		  
        _render: function () {
            this.initialize();
            this.wireEvents();
        },
		  
        _itemInitialize: function () {
            var proxy = this;
            if (this.model.scales != null) {
                $.each(this.model.scales, function (index, element) {
                    element = proxy._checkArrayObject(element, index);
                    var obj = proxy._defaultScaleValues();
                    $.extend(obj, element);
                    $.extend(element, obj);
                });
            }
            else {
                this.model.scales = [this._defaultScaleValues()];
            }
        },
		  	
         _checkArrayObject: function (element, initialName) {
            var proxy = this;
			var type;
            $.each(element, function (name, innerElement) {
			 type = typeof name;	 
			if((type!="string" ||( type=="string" && name.indexOf('_') == -1 && name.indexOf('__') == -1)) && typeof innerElement !="function"){
                if (innerElement instanceof Array  ) {
                    proxy._checkArrayObject(innerElement, name);
                }			 
                else if (innerElement != null && typeof innerElement == "object" && !innerElement.setter && !innerElement.factory && !innerElement.key) {
                    var allObjects = proxy._defaultScaleValues();
                    proxy._LoadIndividualDefaultValues(innerElement, allObjects, (typeof name === "number") ? initialName : name);
                }
				}	
               				
            });
            return element;
        },
	 	
        _LoadIndividualDefaultValues: function (obj, allObjects, name) {		    
            var defaultObj = null;
            var proxy = this;
            var type;
            $.each(allObjects, function (n, element) {
                if (name == n) {
                    defaultObj = element;
                    return;
                }
            });
            if (defaultObj instanceof Array) defaultObj = defaultObj[0];
               type = typeof name;	
            $.each(obj, function (objName, ele) {
                if (ele instanceof Array) {
                    proxy._checkArrayObject(ele, name);
                }
                else if (ele != null && typeof ele == "object" && (type!="string" ||( type=="string" && name.indexOf('_') == -1 && name.indexOf('__') == -1)) ) {
                    proxy._LoadIndividualDefaultValues(ele, defaultObj, (typeof objName === "number") ? name : objName);
                }
            });

            $.extend(defaultObj, obj);
            $.extend(obj, defaultObj);
            return obj;
			 
        },
		  
        initialize: function () {
            this._initObject(this);

            if (this.Model.frame.backgroundImageUrl)
                this._drawCustomImage(this, this.Model.frame.backgroundImageUrl);
            else {
                if (this.Model.scales != null)
                    this._drawScales();
            }
        },
		  
        _initObject: function (element) {
            this._savedPoints = [];
            this.element.addClass("e-widget");
            element.GaugeEl = element.element;
            if (element.canvasEl) {
                element.canvasEl.parent().empty();
                element.GaugeEl.empty();
            }
            element.canvasEl = $("<canvas></canvas>");
            var outerLabelCount = 0;
            for (var i = 0; this.model.scales[i] != null; i++) {
                if (this.model.scales[i].minimum == null)
                    this.model.scales[i].minimum = this.minimum();
                if (this.model.scales[i].maximum == null)
                    this.model.scales[i].maximum = this.maximum();
                for (var j = 0; this.model.scales[i].markerPointers[j] != null; j++) {
                    if (this.model.scales[i].markerPointers[j].value == null)
                        this.model.scales[i].markerPointers[j].value = this.value();
                }
                for (var l = 0; this.model.scales[i].barPointers[l] != null; l++) {
                    if (this.model.scales[i].barPointers[l].value == null)
                        this.model.scales[i].barPointers[l].value = this.value();
                }
                for (var k = 0; this.model.scales[i].customLabels[k] != null && this.model.scales[i].showCustomLabels == true; k++) {
                    outerLabelCount++;
                    if (this.model.scales[i].customLabels[k].value != null && element.GaugeEl.find('div').length == 0) {
                        if (this.model.scales[i].customLabels[k] != null && this.model.scales[i].customLabels[k].positionType != null && this.model.scales[i].customLabels[k].positionType == "outer") {
                            element.outerDiv = ej.buildTag("div");
                            if (element.model.outerCustomLabelPosition == "bottom") {
                                element.GaugeEl.append(element.canvasEl);
                                element.GaugeEl.append(element.outerDiv);
                                element.outerDiv.css('text-align', 'center');
                                element.GaugeEl.css({ 'width': element.model.width });
                            }
                            else {
                                if (element.model.outerCustomLabelPosition != "top") {
                                    var table = ej.buildTag("TABLE");
                                    table.css('width', '100%');
                                    var tr = ej.buildTag("TR");
                                    var td1 = ej.buildTag("TD");
                                    var td2 = ej.buildTag("td");
                                    if (element.model.outerCustomLabelPosition == "left") {
                                        td1.append(element.outerDiv);
                                        td2.append(element.canvasEl);
                                    }
                                    else {
                                        td1.append(element.canvasEl);
                                        td2.append(element.outerDiv);
                                    }
                                    tr.append(td1);
                                    tr.append(td2);
                                    table.append(tr);
                                    element.GaugeEl.append(table);
                                    element.outerDiv.css({
                                        'width': this.element.width() - element.model.width
                                    });
                                }
                                else {
                                    element.GaugeEl.append(element.outerDiv);
                                    element.GaugeEl.append(element.canvasEl);
                                    element.GaugeEl.css({ 'width': element.model.width });
                                    element.outerDiv.css('text-align', 'center');
                                }
                            }
                        }
                        else
                            element.GaugeEl.append(element.canvasEl);
                    }
                }
                if (outerLabelCount == 0)
                    element.GaugeEl.append(element.canvasEl);
            }
            element.canvasEl.attr("role", "presentation");
            if (_linearGaugeCount == initialGaugeCount) {
                initialLinearDivWidth = window.innerWidth;
            }
            element.canvasEl[0].setAttribute("width", element.model.width);
            element.canvasEl[0].setAttribute("height", element.model.height);
            element.centerX = element.canvasEl[0].width / 2;
            element.centerY = element.canvasEl[0].height / 2;
            var elem = element.canvasEl[0];
            if (typeof window.G_vmlCanvasManager != "undefined") {
                elem = window.G_vmlCanvasManager.initElement(elem);
            }
            if (!elem || !elem.getContext) {
                return;
            }
            element.contextEl = element.canvasEl[0].getContext("2d");
        },
		  
        _drawFrameCircle: function (location, style, element) {
            this._contextOpenPath(style, element);
            element.contextEl.arc(location.startX, location.startY, style.circleRadius, 0, 2 * Math.PI, true);
            this._contextClosePath(style, element);
            if (style.indicatorText)
                element._drawText(location, style);
        },
		  
        _drawFrameRectangle: function (location, style, element) {
            this._contextOpenPath(style, element);
            element.contextEl.lineTo(location.startX + style.radius, location.startY);
            element.contextEl.lineTo(location.startX + style.width - style.radius, location.startY);
            element.contextEl.lineTo(location.startX + style.width, location.startY + style.height - style.radius);
            element.contextEl.lineTo(location.startX + style.radius, location.startY + style.height);
            this._contextClosePath(style, element);
            if (style.indicatorText)
                element._drawText(location, style);
        },
		  
        _drawFrameThermometer: function (location, style, element) {
            var radius = element.Model.orientation == "Vertical" ? Math.sqrt(style.width * style.width + style.width * style.width) / 2 : Math.sqrt(style.height * style.height + style.height * style.height) / 2;   
            this._contextOpenPath(style, element);
            if (element.Model.orientation == "Vertical") {
                if (element.scaleEl[element.scaleIndex].direction == "counterclockwise") {
                    element.contextEl.arc(location.startX + Math.cos(Math.PI * (45 / 180)) * radius,
                                       location.startY + style.height - Math.sin(Math.PI * (45 / 180)) * radius,
                                       radius, Math.PI * (-45 / 180), Math.PI * (225 / 180), false);
                    element.contextEl.lineTo(location.startX, location.startY + style.calDistance + style.width / 2);
                    if (style.topRounded)
                        element.contextEl.arc(location.startX + style.width / 2, location.startY + style.width / 2, style.width / 2, -Math.PI, 0, false);
                    else
                        element.contextEl.lineTo(location.startX + style.width, location.startY + style.calDistance + style.width / 2);
                }
                else {
                    element.contextEl.arc(location.startX + Math.cos(Math.PI * (45 / 180)) * radius,
                                       location.startY + Math.sin(Math.PI * (45 / 180)) * radius,
                                       radius, Math.PI * (45 / 180), Math.PI * (-225 / 180), true);
                    element.contextEl.lineTo(location.startX, location.startY + style.height - style.width / 2);
                    if (style.topRounded)
                        element.contextEl.arc(location.startX + style.width / 2, location.startY + style.height - style.width / 2, style.width / 2, -Math.PI, 0, true);
                    else
                        element.contextEl.lineTo(location.startX + style.width, location.startY + style.height - style.width / 2);
                }
            }
            else {
                if (element.scaleEl[element.scaleIndex].direction == "counterclockwise") {
                    element.contextEl.arc(location.startX + style.width - radius / 4 - Math.cos(Math.PI * (45 / 180)) * radius,
                               location.startY + Math.sin(Math.PI * (45 / 180)) * radius,
                               radius, Math.PI * (135 / 180), Math.PI * (225 / 180), true);
                    element.contextEl.lineTo(location.startX + style.height / 2, location.startY);
                    if (style.topRounded)
                        element.contextEl.arc(location.startX + style.height / 2, location.startY + style.height / 2, style.height / 2, Math.PI * (270 / 180), Math.PI * (90 / 180), true);
                    else
                        element.contextEl.lineTo(location.startX + style.height / 2, location.startY + style.height);

                }
                else {
                    element.contextEl.arc(location.startX + radius / 4 + Math.cos(Math.PI * (45 / 180)) * radius,
                               location.startY + Math.sin(Math.PI * (45 / 180)) * radius,
                               radius, Math.PI * (45 / 180), Math.PI * (315 / 180), false);
                    element.contextEl.lineTo(location.startX + style.width - style.height / 2, location.startY);
                    if (style.topRounded)
                        element.contextEl.arc(location.startX + style.width - style.height / 2, location.startY + style.height / 2, style.height / 2, Math.PI * (270 / 180), Math.PI * (90 / 180), false);
                    else
                        element.contextEl.lineTo(location.startX + style.width - style.height / 2, location.startY + style.height);
                }
            }
            this._contextClosePath(style, element);
        },
		  
        _drawFrameRoundedRectangle: function (location, style, element) {
            this._contextOpenPath(style, element);
            element.contextEl.lineTo(location.startX + style.radius, location.startY);
            element.contextEl.lineTo(location.startX + style.width - style.radius, location.startY);
            element.contextEl.quadraticCurveTo(location.startX + style.width, location.startY, location.startX + style.width, location.startY + style.radius);
            element.contextEl.lineTo(location.startX + style.width, location.startY + style.height - style.radius);
            element.contextEl.quadraticCurveTo(location.startX + style.width, location.startY + style.height, location.startX + style.width - style.radius, location.startY + style.height);
            element.contextEl.lineTo(location.startX + style.radius, location.startY + style.height);
            element.contextEl.quadraticCurveTo(location.startX, location.startY + style.height, location.startX, location.startY + style.height - style.radius);
            element.contextEl.lineTo(location.startX, location.startY + style.radius);
            element.contextEl.quadraticCurveTo(location.startX, location.startY, location.startX + style.radius, location.startY);
            this._contextClosePath(style, element);
            if (style.indicatorText)
                this._drawText(location, style);
        },
		  
        _contextOpenPath: function (style, element) {
            element.contextEl.save();
            element.contextEl.beginPath();
            if (style.strokeStyle)
                element.contextEl.strokeStyle = style.strokeStyle;
            if (style.opacity != undefined)
                element.contextEl.globalAlpha = style.opacity;
            if (style.lineWidth)
                element.contextEl.lineWidth = style.lineWidth;
            if (style.fillStyle)
                element.contextEl.fillStyle = style.fillStyle;
        },
		  
        _contextClosePath: function (style, element) {
            element.contextEl.closePath();
            if (style.isFill)
                element.contextEl.fill();
            if (style.isStroke)
                element.contextEl.stroke();
            element.contextEl.restore();
        },
		  
        _drawScales: function () {
            var self = this;
            this.scaleEl = this.Model.scales;
            this.contextEl.save();
            this.contextEl.translate(this.Model.frame.outerWidth + this.Model.frame.innerWidth, this.Model.frame.outerWidth + this.Model.frame.innerWidth);
            $.each(this.Model.scales, function (index, element) {
                self.scaleIndex = index;
                self._setScaleCordinates(element, element.type);
            });
            this._setTicks();
            this._setLabels();
            this._setRange();
            this._setCustomLabel();
            this._flagPointer = false;
            this._tempOpacity=this.model.scales[0].barPointers[0].opacity;
            this._setBarPointers();
            this._setMarkerPointers();
            this._setIndicators();
            $.each(this.Model.scales, function (ind, elemt) {
                if (elemt.showBarPointers) {
                    if (elemt.barPointers.length > 1)
                        self.model.enableAnimation = false;
                }
                if (elemt.showMarkerPointers) {
                    if (elemt.markerPointers.length > 1)
                        self.model.enableAnimation = false;
                }
            });
            if (!this.contextEl.putImageData)
                this.model.enableAnimation = false;
            if (this.model.animationSpeed != null && this.model.animationSpeed > 0) {
                var delay = this.model.animationSpeed / 25;
                if (delay >= 0) {
                    if (this.model.enableAnimation && this._animationFlag) {
                        this._onAnimate(delay);
                    }
                }
            }
        },
		  
        _setTicks: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                if (element.showTicks) {
                    self.scaleIndex = index;
                    if (element.ticks != null) {
                        self.tickEl = element.ticks;
                        $.each(element.ticks, function (tickIndex, tickElement) {
                            self.tickIndex = tickIndex;
                            self._setTicksCordinates(tickElement, tickIndex);
                        });
                    }
                }
            });
        },
		  
        _setLabels: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                if (element.showLabels) {
                    self.scaleIndex = index;
                    if (element.labels != null) {
                        self.labelEl = element.labels;
                        $.each(element.labels, function (labelIndex, labelElement) {
                            self.labelIndex = labelIndex;
                            self._setLabelCordinates(labelElement, labelIndex);
                        });
                    }
                }
            });
        },
		  
        _setIndicators: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                self.scaleIndex = index;
                if (element.indicators != null && element.showIndicators) {
                    self.indicatorEl = element.indicators;
                    $.each(element.indicators, function (indicatorIndex, indicatorElement) {
                        self.indicatorIndex = indicatorIndex;
                        self._drawIndicator(indicatorIndex, indicatorElement);
                    });
                }
            });
        },
		  
        _setBarPointers: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                if (element.showBarPointers) {
                    self.scaleIndex = index;
                    if (element.barPointers != null) {
                        self.barPointerEl = element.barPointers;
                        $.each(element.barPointers, function (barPointerIndex, barPointerElement) {
                            self.barPointerIndex = barPointerIndex;
                            element.opacity = (self.scaleIndex == 0 && self.barPointerIndex == 0 && self.model.enableAnimation == true && (self._flagPointer == false && self._animationFlag == true) && self.model.scales[0].type == "thermometer") ? 0 : self._tempOpacity;
                            self._drawScaleBarPointer(barPointerElement, barPointerIndex);
                            self._flagPointer=true;
                        });
                    }
                }
            });
        },
		  
        _setMarkerPointers: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                if (element.showMarkerPointers) {
                    self.scaleIndex = index;
                    if (element.markerPointers != null) {
                        self.markerPointerEl = element.markerPointers;
                        $.each(element.markerPointers, function (markerPointerIndex, markerPointerElement) {
                            self.markerPointerIndex = markerPointerIndex;
                            self._drawMarkerPointer(markerPointerElement, markerPointerIndex);
							self.canvasEl.attr("aria-label", self.model.scales[self.scaleIndex].markerPointers[self.markerPointerIndex].value);
                        });
                    }
                }
            });
        },
		  
        _onAnimate: function (delay) {
            var self = this, timer, timer1;
            var currentValue = self.model.scales[0].minimum;
            var barPointerValue = self.model.scales[0].barPointers[0].value;
            var markerPointerValue = self.model.scales[0].markerPointers[0].value;
            timer = setInterval(function pointerchan() {
                if (barPointerValue > currentValue || currentValue == self.model.scales[0].minimum) {
                    currentValue = currentValue + ((self.model.scales[0].maximum-self.model.scales[0].minimum)/100);
                    if (self.scaleEl[0].type == "thermometer") {
                        self.model.scales[0].barPointers[0].value = (barPointerValue > currentValue) ? currentValue: barPointerValue;
                        if (self.contextEl.putImageData != "undefined") {
                            self._setBarPointers();
                        }
                        else {
                            barPointerValue > currentValue ? self.setBarPointerValue(0, 0, currentValue) : self.setBarPointerValue(0, 0, barPointerValue);
                        }
                    }
                    else
                        barPointerValue > currentValue ? self.setBarPointerValue(0, 0, currentValue) : self.setBarPointerValue(0, 0, barPointerValue);
                }
                else {
                    self._animationFlag = false;
                    self.setBarPointerValue(0, 0, barPointerValue);
                    window.clearInterval(timer);
                }
            }, delay);
            timer1 = setInterval(function pointerchan() {
            if(self.model.enableMarkerPointerAnimation){
                if (markerPointerValue > currentValue || currentValue == self.model.scales[0].minimum) {
                    currentValue = currentValue + ((self.model.scales[0].maximum-self.model.scales[0].minimum)/100);
                    if (self.scaleEl[0].type == "thermometer") {
                        self.model.scales[0].markerPointers[0].value = (markerPointerValue > currentValue) ? currentValue : markerPointerValue;
                        if (self.contextEl.putImageData != "undefined") {
                            self._setMarkerPointers();
                            }
                            else {
                                markerPointerValue > currentValue ? self.setPointerValue(0, 0, currentValue) : self.setPointerValue(0, 0, markerPointerValue);
                            }
                        }
                        else
                            markerPointerValue > currentValue ? self.setPointerValue(0, 0, currentValue) : self.setPointerValue(0, 0, markerPointerValue);
                    }
                    else {
                        self._animationFlag = false;
                        self.setPointerValue(0, 0, markerPointerValue);
                        window.clearInterval(timer1);
                }}
            }, delay);
        },
		  
        _setRange: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                self.scaleIndex = index;
                if (element.ranges != null && element.showRanges) {
                    self.rangeEl = element.ranges;
                    $.each(element.ranges, function (rangeIndex, rangeElement) {
                        self.rangeIndex = rangeIndex;
                        self._drawRange(rangeElement);
                    });
                }
            });
        },
		  
        _setCustomLabel: function () {
            var self = this;
            $.each(this.Model.scales, function (index, element) {
                self.scaleIndex = index;
                if (element.customLabels != null && element.showCustomLabels) {
                    self.customLabelEl = element.customLabels;
                    $.each(element.customLabels, function (cusLblIndex, cusLblElement) {
                        self.customLabelIndex = cusLblIndex;
                        if (self.model.scales[self.scaleIndex].customLabels[self.customLabelIndex] != null && self.model.scales[self.scaleIndex].customLabels[self.customLabelIndex].positionType != null && self.model.scales[self.scaleIndex].customLabels[self.customLabelIndex].positionType == "outer")
                            self._setOuterCustomLabelCordinates(cusLblIndex, cusLblElement);
                        else
                            self._setCustomLabelCordinates(cusLblIndex, cusLblElement);
                    });
                }
            });
        },
          
        _setOuterCustomLabelCordinates: function (index, element) {
            this._customLblMaxSize = this._customLblMaxSize < parseFloat(element.font.size.match(/\d+/)[0]) ? parseFloat(element.font.size.match(/\d+/)[0]) : this._customLblMaxSize;
            var div = ej.buildTag("div." + this._id + "outercustomlbl");
            div.text(this.model.scales[this.scaleIndex].customLabels[index].value);
            var position = (this.model.outerCustomLabelPosition == "right" || this.model.outerCustomLabelPosition == "left") ? "left" : "center";
            this.outerDiv.append(div);
            this.outerDiv.append('</br>');
            if (position == "center")
                div.css({ 'display': 'inline-block', 'margin': '0 auto', 'max-width': this.model.width });
            else
                div.css({ 'display': 'inline-block', 'max-width': this.element.width() - this.model.width > 10 ? this.element.width() - this.model.width : 10 });
            div.css({
                "color": element.color,
                'overflow': 'hidden',
                'text-overflow': 'ellipsis',
                'white-space': 'nowrap',
                'font-size': (element.font != null && element.font.size != null) ? element.font.size : "12px",
                'font-family': (element.font != null && element.font.fontFamily != null) ? element.font.fontFamily : "Arial",
                'font-weight': (element.font != null && element.font.fontStyle != null) ? element.font.fontStyle : "Normal",
                'text-align': position
            });

        },
		  
        _setScaleCordinates: function (element, scaleStyle) {
            var location, style, radius;
            this.opacity = 1;
            this.bottomRadius = Math.sqrt(element.width * element.width + element.width * element.width) / 2;

            this.bounds = {
                height: this.canvasEl[0].height - 2 * (this.Model.frame.outerWidth + this.Model.frame.innerWidth),
                width: this.canvasEl[0].width - 2 * (this.Model.frame.outerWidth + this.Model.frame.innerWidth)
            };
            if (this.Model.orientation == "Vertical") {
                this.scaleStartX[this.scaleIndex] = (this.bounds.width - element.width) * ((element.position.x) / 100);
                this.scaleStartY[this.scaleIndex] = (this.bounds.height - element.length) * ((element.position.y) / 100);
            }
            else {
                this.scaleStartX[this.scaleIndex] = (this.bounds.width - element.length) * ((element.position.x) / 100);
                this.scaleStartY[this.scaleIndex] = (this.bounds.height - element.width) * ((element.position.y) / 100);
            }
            radius = scaleStyle == "roundedrectangle" ? 5 : 0;
            location = { "startX": this.scaleStartX[this.scaleIndex], "startY": this.scaleStartY[this.scaleIndex] };
            style = {
                "width": this.Model.orientation == "Vertical" ? element.width : element.length, "isStroke": true,
                "topRounded": true,
                "fillStyle": element.backgroundColor ? ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor)) : ((this.Model.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.backgroundColor)),
                "lineWidth": element.border.width,
                "radius": radius,
                "height": this.Model.orientation == "Vertical" ? element.length : element.width,
                "isFill": true,
                "strokeStyle": element.border.color ? ((element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color)) : ((this.Model.borderColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.borderColor))
            };
	    if (element.maximum < element.minimum) {
                var tempValue = element.maximum;
                element.maximum = element.minimum;
                element.minimum=tempValue;
            }
			 if (element.maximum == element.minimum)
	            element.maximum = element.maximum + 1;
            this.minimum(element.minimum);
            this.maximum(element.maximum);
            if (this._notifyArrayChange) {
                this._notifyArrayChange("scales[" + this.scaleIndex + "]maximum", element.maximum);
                this._notifyArrayChange("scales[" + this.scaleIndex + "]minimum", element.minimum);
            }
            if (element.shadowOffset) {
                this.contextEl.shadowBlur = element.shadowOffset;
                this.contextEl.shadowColor = (style.fillStyle == "transparent") ? "rgba(0,0,0,0)" : style.fillStyle;
            }
            this._drawFrame(scaleStyle, location, style);
            if (this.scaleEl[this.scaleIndex].type == "thermometer" && !this.isScaleModified) {
                this._modifyWidth();
                this.isScaleModified = true;
            }
            if (this.contextEl.getImageData)
                this.scaleImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
        },
		  
        _setTicksCordinates: function (element, index) {
            var staticPosition, height, lineChangePosition, interval;
            if (this.scaleEl[this.scaleIndex].majorIntervalValue > this.scaleEl[this.scaleIndex].minorIntervalValue) {
                interval = element.type == "majorinterval" ? this.scaleEl[this.scaleIndex].majorIntervalValue : this.scaleEl[this.scaleIndex].minorIntervalValue;
                if (element.placement == "near") {
                    staticPosition = this.Model.orientation == "Vertical" ? this.scaleStartX[this.scaleIndex] : this.scaleStartY[this.scaleIndex];
                }
                else if (element.placement == "far") {
                    staticPosition = this.Model.orientation == "Vertical" ? this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width : this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width;
                }
                else if (element.placement == "center") {
                    staticPosition = this.Model.orientation == "Vertical" ? this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 : this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2;
                }
                height = element.placement == "near" ? -element.height : element.height;
                for (var value = this.scaleEl[this.scaleIndex].maximum; value >= this.scaleEl[this.scaleIndex].minimum; value -= interval) {
                    if (interval == this.scaleEl[this.scaleIndex].minorIntervalValue && value % this.scaleEl[this.scaleIndex].majorIntervalValue != 0 || interval == this.scaleEl[this.scaleIndex].majorIntervalValue) {
                        lineChangePosition = this._getClockwiseLinePosition(value);
                        this.region = {
                            "lineChangePosition": lineChangePosition + (this.Model.orientation == "horizontal" ? element.distanceFromScale.x : (element.distanceFromScale.y)),
                            "lineStaticPosition": staticPosition + (this.Model.orientation == "horizontal" ? element.distanceFromScale.y : (element.distanceFromScale.x))
                        };
                        this.style = {
                            "lineHeight": height,
                            "angle": this.Model.orientation == "Vertical" ? element.angle : element.angle + 270,
                            "tickShape": element.TickShape,
                            "strokeStyle": element.color ? ((element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color)) : ((this.Model.tickColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.tickColor)),
                            "lineWidth": element.width
                        }
                        if (this.Model.drawTicks)
                            this._onDrawTicks(this.Model.orientation == "Vertical" ? element.angle : element.angle + 270, value);
                        this._drawTickMark(this.region, this.style);
                    }
                }

                if (this.contextEl.getImageData)
                    this.tickImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
            }
        },
		  
        _drawTickMark: function (location, style) {
            this.contextEl.beginPath();
            this.contextEl.save();
            this.contextEl.lineWidth = style.lineWidth;
            this.contextEl.strokeStyle = style.strokeStyle;
            if (this.Model.orientation == "Vertical")
                this.contextEl.translate(location.lineStaticPosition, location.lineChangePosition);
            else
                this.contextEl.translate(location.lineChangePosition, location.lineStaticPosition);
            this.contextEl.lineTo(0, 0);
            if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise")
                this.contextEl.rotate((Math.PI * (style.angle / 180)));
            else
                this.contextEl.rotate(-(Math.PI * (style.angle / 180)));
            this.contextEl.lineTo(style.lineHeight, 0);
            this.contextEl.stroke();
            this.contextEl.restore();
            this.contextEl.closePath();
        },
		  
        _addDecimal: function (lblValue, lblInterval) {
            var value = lblValue.toString();
            var interval = lblInterval.toString();
            var vDecimal;
            var iDecimal;
            if (value.indexOf('.') > -1)
                vDecimal = value.length - value.indexOf('.') - 1;
            else
                vDecimal = 0;
            if (interval.indexOf('.') > -1)
                iDecimal = interval.length - interval.indexOf('.') - 1;
            else
                iDecimal = 0;
            var decimal = vDecimal > iDecimal ? vDecimal : iDecimal;
            var correctValue = (lblValue * Math.pow(10, decimal) + lblInterval * Math.pow(10, decimal)) / Math.pow(10, decimal);
            return correctValue;
        },
		  
        _setLabelCordinates: function (element, index) {

            var xDistanceFromScale, yDistanceFromScale, staticPosition, lineChangePosition, interval, locale = this.model.locale;
            if (this.scaleEl[this.scaleIndex].majorIntervalValue > this.scaleEl[this.scaleIndex].minorIntervalValue) {

                if (this.Model.orientation == "Vertical") {
                    xDistanceFromScale = element.distanceFromScale.x;
                    yDistanceFromScale = element.distanceFromScale.y;
                }
                else {
                    xDistanceFromScale = element.distanceFromScale.y;
                    yDistanceFromScale = element.distanceFromScale.x;
                }
                interval = element.type == "major" ? this.scaleEl[this.scaleIndex].majorIntervalValue : this.scaleEl[this.scaleIndex].minorIntervalValue;
                if (element.placement == "near") {
                    staticPosition = this.Model.orientation == "Vertical" ? this.scaleStartX[this.scaleIndex] - this.scaleEl[this.scaleIndex].border.width / 2 : this.scaleStartY[this.scaleIndex] - this.scaleEl[this.scaleIndex].border.width - 5;
                    this.contextEl.textAlign = this.Model.orientation == "Vertical" ? "right" : "center";
                }
                else if (element.placement == "far") {
                    staticPosition = this.Model.orientation == "Vertical" ? this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width / 2 : this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width + 5;
                    this.contextEl.textAlign = this.Model.orientation == "Vertical" ? "left" : "center";
                }
                else {
                    this.contextEl.textAlign = "center";
                    staticPosition = this.Model.orientation == "Vertical" ? this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 + this.scaleEl[this.scaleIndex].border.width / 2 : this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 + this.scaleEl[this.scaleIndex].border.width / 2;
                }
                for (var value = this.scaleEl[this.scaleIndex].minimum; value <= this.scaleEl[this.scaleIndex].maximum; value = this._addDecimal(value, interval)) {
                    if (interval == this.scaleEl[this.scaleIndex].minorIntervalValue && value % this.scaleEl[this.scaleIndex].majorIntervalValue != 0 || interval == this.scaleEl[this.scaleIndex].majorIntervalValue) {
                        lineChangePosition = this.scaleEl[this.scaleIndex].direction == "counterclockwise" ? this._getCounterClockwiseLinePosition(value) : this._getClockwiseLinePosition(value);
                        this.labelValue = value;
                        this.region = {
                            "lineChangePosition": lineChangePosition + (yDistanceFromScale),
                            "lineStaticPosition": staticPosition + (xDistanceFromScale)
                        };
                        this.style = {
                            "angle": this.Model.orientation == "Vertical" ? element.angle : element.angle + 270,
                            "fillStyle": element.textColor ? ((element.textColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.textColor)) : ((this.Model.labelColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.labelColor)), "opacity": isNaN(element.opacity) ? 1 : element.opacity,
                            "font": this._getFontString(this, element.font),
                            "textValue": this.labelValue
                        };
						
						this.style.textValue  = this.labelValue = (locale && this.model.enableGroupSeparator) ? this.labelValue.toLocaleString(locale) : this.labelValue;
                        if (this.Model.drawLabels)
                            this._onDrawLabels(this.Model.orientation == "Vertical" ? element.angle : element.angle + 270);
                        this._drawLabel(this.region, this.style,false);
                    }
                }
            }

            if (this.contextEl.getImageData)
                this.labelImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);

        },
		  
        _drawLabel: function (location, style, isCustomLabel) {
            this.contextEl.beginPath();
            this.contextEl.save();
            this.contextEl.textBaseline = "middle";
            this.contextEl.fillStyle = style.fillStyle;
            this.contextEl.font = style.font;
            if (style.opacity)
                this.contextEl.globalAlpha = style.opacity;
            if (this.Model.orientation == "Vertical") {
                this.contextEl.translate(location.lineStaticPosition, location.lineChangePosition);
                if (this.model.tooltip.showLabelTooltip && !isCustomLabel)
                    this._savedPoints.push({ "startX": location.lineStaticPosition + 5, "startY": location.lineChangePosition + 10, "width": 15, "height": 15, "value": style.textValue });
                if (this.model.tooltip.showCustomLabelTooltip && isCustomLabel)
                    this._savedPoints.push({ "startX": location.lineStaticPosition - 35, "startY": location.lineChangePosition + 10, "width": 110, "height": 15, "value": style.textValue });
            }
            else {
                this.contextEl.translate(location.lineChangePosition, location.lineStaticPosition);
                if (this.model.tooltip.showLabelTooltip && !isCustomLabel)
                    this._savedPoints.push({ "startX": location.lineChangePosition + 10, "startY": location.lineStaticPosition + 10, "width": 15, "height": 15, "value": style.textValue });
                if (this.model.tooltip.showCustomLabelTooltip && isCustomLabel)
                    this._savedPoints.push({ "startX": location.lineChangePosition - 35, "startY": location.lineStaticPosition + 10, "width": 110, "height": 15, "value": style.textValue });
            }
            this.contextEl.lineTo(0, 0);
            if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise")
                this.contextEl.rotate((Math.PI * (style.angle / 180)));
            else
                this.contextEl.rotate(-(Math.PI * (style.angle / 180)));
			if(!ej.isNullOrUndefined(isCustomLabel) && !isCustomLabel){
			    var textPostion = this.model.scales[this.scaleIndex].labels[this.labelIndex].unitTextPlacement;
            if (!ej.isNullOrUndefined(textPostion) && textPostion.toString() == "back")
                style.textValue = style.textValue + this.model.scales[this.scaleIndex].labels[this.labelIndex].unitText;
            else if (!ej.isNullOrUndefined(textPostion) && textPostion.toString() == "front")
                style.textValue = this.model.scales[this.scaleIndex].labels[this.labelIndex].unitText + style.textValue;
            }
            this.contextEl.fillText(style.textValue, 0, 0);
            this.contextEl.fill();
            this.contextEl.restore();

        },
		  
        _drawScaleBarPointer: function (element, index) {
            element.value = element.value > this.scaleEl[this.scaleIndex].maximum ? this.scaleEl[this.scaleIndex].maximum : element.value;
            element.value = element.value < this.scaleEl[this.scaleIndex].minimum ? this.scaleEl[this.scaleIndex].minimum : element.value;
            var grd, lineYPosition, radius, height, width, startY, backgroundColor, startX, gradients;
            gradients = [{ "ColorStop": 0, "Color": (this.Model.pointerGradient1 == "transparent") ? "rgba(0,0,0,0)" : this.Model.pointerGradient1 }, { "ColorStop": 1, "Color": (this.Model.pointerGradient2 == "transparent") ? "rgba(0,0,0,0)" : this.Model.pointerGradient2}];
            radius = this.scaleEl[this.scaleIndex].type == "roundedrectangle" ? 5 : 0;
            if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise") {
                lineYPosition = this._getClockwiseLinePosition(element.value);
                if (this.scaleEl[this.scaleIndex].type == "thermometer" && this.isScaleModified) {
                    this._restoreWidth();
                    this.isModify = true;
                }
                if (this.Model.orientation == "Vertical") {
                    startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2 + element.distanceFromScale;
                    grd = this.contextEl.createLinearGradient(startX, this.scaleStartY[this.scaleIndex], startX + element.width, this.scaleStartY[this.scaleIndex]);
                }
                else {
                    startX = this.scaleStartX[this.scaleIndex];
                    grd = this.contextEl.createLinearGradient(startX, this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2, startX, this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 + element.width / 2);
                }
            }
            else {
                lineYPosition = this._getCounterClockwiseLinePosition(element.value);
                if (this.scaleEl[this.scaleIndex].type == "thermometer" && this.isScaleModified) {
                    this._restoreWidth();
                    this.isModify = true;
                }
                if (this.Model.orientation == "Vertical") {
                    startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2 + element.distanceFromScale;
                    grd = this.contextEl.createLinearGradient(startX, this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].length - lineYPosition, startX + element.width, this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].length - lineYPosition);
                }
                else {
                    startX = this.scaleEl[this.scaleIndex].type == "thermometer" ? lineYPosition - this.scaleEl[this.scaleIndex].width / 2 - this.scaleEl[this.scaleIndex].border.width / 2 : lineYPosition - this.scaleEl[this.scaleIndex].border.width / 2;
                    grd = this.contextEl.createLinearGradient(startX, this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2, startX, this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 + element.width / 2);
                }
            }
            if (element.backgroundColor)
                backgroundColor = ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor));
            else if (element.gradients)
                this._setGradientColor(this, grd, element.gradients.colorInfo);
            else if (this.Model.ScaleInterior)
                this._setGradientColor(this, grd, this.Model.ScaleInterior.colorInfo);
            else
                this._setGradientColor(this, grd, gradients);
            if (this.Model.orientation == "Vertical") {
                startY = this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise" ? this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].border.width / 2 : lineYPosition;
                if (this.scaleEl[this.scaleIndex].direction == "counterclockwise" && this.scaleEl[this.scaleIndex].type == "thermometer")
                    startY = startY - this.scaleEl[this.scaleIndex].width / 2;
                height = this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise" ? lineYPosition - this.scaleStartY[this.scaleIndex] : this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].length - lineYPosition - this.scaleEl[this.scaleIndex].border.width / 2;
                width = element.width;
            }
            else {
                startY = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2 + this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                height = element.width;
                width = this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise" ? lineYPosition - this.scaleStartX : this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].length - lineYPosition;
            }
            this.region = { "startX": startX + this.scaleEl[this.scaleIndex].border.width / 2, "startY": startY };
            this.style = {
                "width": (this.scaleEl[this.scaleIndex].type == "thermometer" && this.Model.orientation == "horizontal") ? width + height / 2 - this.scaleEl[this.scaleIndex].border.width / 2 : width,
                "lineWidth": element.border.width,
                "radius": radius,
                "topRounded": false,
                "isStroke": false,
                "isFill": true,
                "height": (this.scaleEl[this.scaleIndex].type == "thermometer" && this.Model.orientation == "Vertical") ? height + width / 2 : height,
                "strokeStyle": element.border.color == null ? ((this.Model.borderColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.borderColor)) : ((element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color)),
                "fillStyle": element.backgroundColor ? ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor)) : ((grd == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, grd)),
                "opacity": isNaN(element.opacity) ? 0.4 : element.opacity,
                "calDistance": (this.scaleEl[this.scaleIndex].type == "thermometer" && this.Model.orientation == "Vertical") ? (this.scaleEl[this.scaleIndex].width - this.barPointerEl[this.barPointerIndex].width) / 2 : 0
            };
            this.value(element.value);
            if (this._notifyArrayChange)
                this._notifyArrayChange("scales[" + this.scaleIndex + "]barpointers[" + index + "]value", element.value);
            if (this.Model.drawBarPointers)
                this._onDrawBarPointers(element.value);
            this._drawFrame(this.scaleEl[this.scaleIndex].type, this.region, this.style);
            if (this.contextEl.getImageData)
                this.barPointerImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
        },
		  
        _drawMarkerPointer: function (element, index) {
            element.value = element.value > this.scaleEl[this.scaleIndex].maximum ? this.scaleEl[this.scaleIndex].maximum : element.value;
            element.value = element.value < this.scaleEl[this.scaleIndex].minimum ? this.scaleEl[this.scaleIndex].minimum : element.value;
            var startX, startY, radius, linePosition, angle, grd, backgroundColor;
            var gradients = [{ "ColorStop": 0, "Color": (this.Model.pointerGradient1 == "transparent") ? "rgba(0,0,0,0)" : this.Model.pointerGradient1 }, { "ColorStop": 1, "Color": (this.Model.pointerGradient2 == "transparent") ? "rgba(0,0,0,0)" : this.Model.pointerGradient2}];
            this.markerPlacement = element.placement;
            radius = Math.sqrt(element.width * element.width + element.length * element.length) / 2;
            if (this.scaleEl[this.scaleIndex].type == "thermometer" && this.isModify)
                this._modifyWidth();
            if (this.Model.orientation == "Vertical") {
                if (this.markerPlacement == "far") {
                    startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                    angle = 0;
                }
                if (this.markerPlacement == "near") {
                    if (element.type == "star")
                        startX = this.scaleStartX[this.scaleIndex] + element.distanceFromScale - element.width;
                    else
                        startX = this.scaleStartX[this.scaleIndex] + element.distanceFromScale;
                    angle = 180;
                }
                if (this.markerPlacement == "center") {
                    if (element.type == "circle")
                        startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2 + element.distanceFromScale + (element.border.width);
                    else
                        startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2 + element.distanceFromScale;
                    angle = 0;
                }
            }
            else {
                if (this.markerPlacement == "far") {
                    startX = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                    angle = 90;
                }
                if (this.markerPlacement == "near") {
                    if (element.type == "star")
                        startX = this.scaleStartY[this.scaleIndex] - this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale - element.length;
                    else
                        startX = this.scaleStartY[this.scaleIndex] - this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                    angle = 270;
                }
                if (this.markerPlacement == "center") {
                    if (element.type == "circle")
                        startX = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.length / 2 + element.distanceFromScale + (element.border.width);
                    else
                        startX = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.length / 2 + element.distanceFromScale;
                    angle = 90;
                }
            }
            linePosition = this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise" ? this._getClockwiseLinePosition(element.value) : this._getCounterClockwiseLinePosition(element.value);
            if (element.type == "star") {
                if (this.Model.orientation == "Vertical") {
                    grd = this.contextEl.createLinearGradient(startX, this.scaleStartY[this.scaleIndex], startX + element.width, this.scaleStartY[this.scaleIndex]);
                    startY = linePosition - element.length / 3;
                }
                else {
                    grd = this.contextEl.createLinearGradient(linePosition, startX, linePosition, startX + element.length);
                    startY = linePosition - element.width / 2;
                }
            }
            else {
                grd = this.contextEl.createLinearGradient(0, 0, element.width, 0);
                startY = linePosition;
            }
            if (element.type == "roundedrectangle") {
                if (this.Model.orientation == "Vertical" && this.markerPlacement == "near")
                    startY += element.length;
                else if (this.Model.orientation == "horizontal") {
                    if (this.markerPlacement == "near")
                        startY -= (element.width);
                    startX += element.width / 2;
                }
            }
            if (element.backgroundColor)
                backgroundColor = ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor));
            else if (element.gradients)
                this._setGradientColor(this, grd, element.gradients.colorInfo);
            else if (this.Model.PointerInterior)
                this._setGradientColor(this, grd, this.Model.PointerInterior.colorInfo);
            else
                this._setGradientColor(this, grd, gradients);

            this.region = { "startX": this.Model.orientation == "Vertical" ? startX : startY, "startY": this.Model.orientation == "Vertical" ? startY : startX };
            this.style = {
                "width": element.width,
                "radius": element.type == "rectangle" ? 0 : radius,
                "height": element.length,
                "lineWidth": element.border.width,
                "isFill": true,
                "isStroke": true,
                "angle": angle,
                "strokeStyle": ((element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color)),
                "markerPlacement": this.markerPlacement,
                "opacity": isNaN(element.opacity) ? 0.4 : element.opacity,
                "fillStyle": element.backgroundColor ? ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor)) : ((grd == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, grd))
            };
            this.value(element.value);
            if (this._notifyArrayChange)
                this._notifyArrayChange("scales[" + this.scaleIndex + "]markerpointers[" + index + "]value", element.value);
            if (this.Model.drawMarkerPointers)
                this._onDrawMarkerPointers(angle, element.value);
            if (element.type == "roundedrectangle")
                this.style.radius = 5;
            this._drawMarkerType(element.type, this.region, this.style);
            if (this.scaleEl[this.scaleIndex].type == "thermometer" && this.isModify) {
                this._restoreWidth();
                this.isScaleModified = false;
            }
            if (this.contextEl.getImageData)
                this.markerPointerImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
        },

        _drawMarkerType: function (type, location, style) {
            switch (type) {
                case "rectangle":
                    this._drawRectangle(location, style, this);
                    break;
                case "triangle":
                    this._drawTriangle(location, style, this);
                    break;
                case "ellipse":
                    this._drawEllipse(location, style, this);
                    break;
                case "diamond":
                    this._drawDiamond(location, style, this);
                    break;
                case "pentagon":
                    this._drawPentagon(location, style, this);
                    break;
                case "circle":
                    this._drawCircle(location, style, this);
                    break;
                case "slider":
                    this._drawSlider(location, style, this);
                    break;
                case "star":
                    this._drawStar(location, style, this);
                    break;
                case "pointer":
                    this._drawPointer(location, style, this);
                    break;
                case "wedge":
                    this._drawWedge(location, style, this);
                    break;
                case "trapezoid":
                    this._drawTrapezoid(location, style, this);
                    break;
                case "roundedrectangle":
                    this._drawRoundedRectangle(location, style, this);
                    break;
            }
        },

		  
        _drawRange: function (element) {
            if (element.startValue < this.scaleEl[this.scaleIndex].maximum && element.endValue > this.scaleEl[this.scaleIndex].minimum && this.scaleEl[this.scaleIndex].minimum < this.scaleEl[this.scaleIndex].maximum && element.endValue <= this.scaleEl[this.scaleIndex].maximum) {
                var tempStartValue = element.startValue < this.scaleEl[this.scaleIndex].minimum ? this.scaleEl[this.scaleIndex].minimum : element.startValue;
                var tempEndValue = element.endValue > this.scaleEl[this.scaleIndex].maximum ? this.scaleEl[this.scaleIndex].maximum : element.endValue;
                this.rangePosition = element.placement;
                var startLinePosition, endLinePosition, startX, startY, grd, backgroundColor;
                var gradients = [{ "ColorStop": 0, "Color": (this.Model.pointerGradient1 == "transparent") ? "rgba(0,0,0,0)" : this.Model.pointerGradient1 }, { "ColorStop": 1, "Color": (this.Model.pointerGradient2 == "transparent") ? "rgba(0,0,0,0)" : this.Model.pointerGradient2 }];
                startLinePosition = (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise") ? this._getClockwiseLinePosition(tempStartValue) : this._getCounterClockwiseLinePosition(tempStartValue);
                endLinePosition = (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise") ? this._getClockwiseLinePosition(tempEndValue) : this._getCounterClockwiseLinePosition(tempEndValue);
                if (this.Model.orientation == "Vertical") {
                    if (element.placement == "far")
                        startX = this.scaleStartX[this.scaleIndex] + element.distanceFromScale + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width;
                    if (element.placement == "near")
                        startX = this.scaleStartX[this.scaleIndex] + element.distanceFromScale;
                    if (element.placement == "center")
                        startX = (element.startWidth > element.endWidth) ? this.scaleStartX[this.scaleIndex] + element.distanceFromScale + this.scaleEl[this.scaleIndex].width / 2 - element.startWidth / 2 : this.scaleStartX[this.scaleIndex] + element.distanceFromScale + this.scaleEl[this.scaleIndex].width / 2 - element.endWidth / 2;
                    grd = this.contextEl.createLinearGradient(endLinePosition, endLinePosition, endLinePosition, startLinePosition);
                    this.region = { "startX": startX, "startY": startLinePosition, "endY": endLinePosition };
                }
                else {
                    if (element.placement == "far")
                        startY = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + element.distanceFromScale + this.scaleEl[this.scaleIndex].border.width;
                    if (element.placement == "near")
                        startY = this.scaleStartY[this.scaleIndex] + element.distanceFromScale;
                    if (element.placement == "center")
                        startY = (element.startWidth > element.endWidth) ? this.scaleStartY[this.scaleIndex] + element.distanceFromScale + this.scaleEl[this.scaleIndex].width / 2 - element.startWidth / 2 : this.scaleStartY[this.scaleIndex] + element.distanceFromScale + this.scaleEl[this.scaleIndex].width / 2 - element.endWidth / 2;
                    grd = this.contextEl.createLinearGradient(endLinePosition, startY, startLinePosition, startY);
                    this.region = { "startX": startLinePosition, "startY": startY, "endX": endLinePosition };
                }

                if (element.backgroundColor)
                    backgroundColor = ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor));
                else if (element.gradients)
                    this._setGradientColor(this, grd, element.gradients.colorInfo);
                else if (this.Model.RangeInterior)
                    this._setGradientColor(this, grd, this.Model.RangeInterior.colorInfo);
                else
                    this._setGradientColor(this, grd, gradients);

                this.style = {
                    "startWidth": element.startWidth, "lineWidth": element.border.width,
                    "isStroke": true, "isFill": true, "opacity": isNaN(element.opacity) ? 0.4 : element.opacity,
                    "endWidth": element.endWidth,
                    "fillStyle": element.backgroundColor ? ((backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, backgroundColor)) : ((grd == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, grd)),
                    "strokeStyle": element.border.color ? ((element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color)) : ((this.Model.borderColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.borderColor))
                };
                if (this.Model.drawRange)
                    this._onDrawRange();
                this._drawRangeBar(this.region, this.style);
                if (this.contextEl.getImageData)
                    this.rangeImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
            }
        },
		  
        _drawRangeBar: function (location, style) {
            this._contextOpenPath(style, this);
            if (this.Model.orientation == "Vertical") {
                this.contextEl.lineTo(location.startX, location.startY);
                this.contextEl.lineTo(location.startX, location.endY);
                if (this.rangePosition == "near") {
                    this.contextEl.lineTo(location.startX - style.endWidth, location.endY);
                    this.contextEl.lineTo(location.startX - style.startWidth, location.startY);
                }
                else {
                    this.contextEl.lineTo(location.startX + style.endWidth, location.endY);
                    this.contextEl.lineTo(location.startX + style.startWidth, location.startY);
                }
            }
            else {
                this.contextEl.lineTo(location.startX, location.startY);
                this.contextEl.lineTo(location.endX, location.startY);
                if (this.rangePosition == "near") {
                    this.contextEl.lineTo(location.endX, location.startY - style.endWidth);
                    this.contextEl.lineTo(location.startX, location.startY - style.startWidth);
                }
                else {
                    this.contextEl.lineTo(location.endX, location.startY + style.endWidth);
                    this.contextEl.lineTo(location.startX, location.startY + style.startWidth);
                }
            }
            this._contextClosePath(style, this);
        },
		  
        _setCustomLabelCordinates: function (index, element) {
            this._customLblMaxSize = this._customLblMaxSize < parseFloat(element.font.size.match(/\d+/)[0]) ? parseFloat(element.font.size.match(/\d+/)[0]) : this._customLblMaxSize;
            var startX, startY;
            this.contextEl.textAlign = "center";
            if (this.Model.orientation == "Vertical") {
                startX = (this.bounds.width) * ((element.position.x) / 100);
                startY = (this.bounds.height) * ((element.position.y) / 100);
            }
            else {
                startX = (this.bounds.width) * ((element.position.x) / 100);
                startY = (this.bounds.height) * ((element.position.y) / 100);
            }
            this.region = { "lineStaticPosition": this.Model.orientation == "Vertical" ? startX : startY, "lineChangePosition": this.Model.orientation == "Vertical" ? startY : startX }
            this.style = { "angle": element.textAngle, "textValue": element.value, "fillStyle": element.color ? ((element.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.color)) : ((this.Model.labelColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, this.Model.labelColor)), "font": this._getFontString(this, element.font) };
            if (this.Model.drawCustomLabel)
                this._onDrawCustomLabel();
            this._drawLabel(this.region, this.style,true);

            if (this.contextEl.getImageData)
                this.customLabelImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
        },
		  
        _drawIndicator: function (index, element) {
            var self = this, xlocation, ylocation, txtLocation, isInStateRange = false;
            xlocation = (this.bounds.width - 2 * element.width) * ((element.position.x) / 100);
            ylocation = (this.bounds.height - 2 * element.height) * ((element.position.y) / 100);
            txtLocation = { "x": (this.bounds.width) * ((element.textLocation.x) / 100), "y": (this.bounds.height) * ((element.textLocation.y) / 100) };
            self.region = { "startX": element.type == "circle" ? xlocation + element.width : xlocation, "textLocation": txtLocation, "startY": element.type == "circle" ? ylocation + element.height : ylocation, "startAngle": 0, "endAngle": 2 * Math.PI };
            self.style = {
                "radius": element.type == "roundedrectangle" ? 2 : 0,
                "strokeStyle": element.border.color ? ((element.border.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.border.color)) : this._getColor(element, "#FFFFFF"),
                "angle": 0,
                "circleRadius": (element.height + element.width) / 2,
                "height": element.height,
                "width": element.width,
                "lineWidth": element.border.width,
                "fillStyle": element.backgroundColor ? ((element.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(element, element.backgroundColor)) : this._getColor(element, "#FFFFFF"),
                "isStroke": true,
                "isFill": true,
                "indicatorText": null,
                "textColor": null,
                "font": null,
                "counterClockwise": false
            };
            if (this.Model.drawIndicators)
                this._onDrawIndicators(self.style, self.region);
            if (element.stateRanges != null) {
                $.each(element.stateRanges, function (sRIndex, srEl) {  
                    if (self.markerPointerEl[self.markerPointerIndex].value >= srEl.startValue && self.markerPointerEl[self.markerPointerIndex].value <= srEl.endValue) {
                        isInStateRange = true;
                        if (!ej.isNullOrUndefined(srEl.text) && srEl.text.length > 0) {
                            self.style.indicatorText = srEl.text;
                            self.style.textColor = ((srEl.textColor == "transparent") ? "rgba(0,0,0,0)" : self._getColor(element, srEl.textColor));
                            self.style.font = self._getFontString(self, element.font);
                        }
                        if (element.type != "text") {
                            self.style.strokeStyle = ((srEl.borderColor == "transparent") ? "rgba(0,0,0,0)" : self._getColor(element, srEl.borderColor));
                            self.style.fillStyle = ((srEl.backgroundColor == "transparent") ? "rgba(0,0,0,0)" : self._getColor(element, srEl.backgroundColor));
                            self._drawFrame(element.type, self.region, self.style, self);
                        }
                        else if (element.type == "text")
                            self._drawText(self.region, self.style);
                    }
                });
                }
            if (!isInStateRange && element.type != "text")
                this._drawFrame(element.type, self.region, self.style, self);
            if (this.contextEl.getImageData)
                this.indicatorImage = this.contextEl.getImageData(0, 0, this.Model.width, this.Model.height);
        },

        _drawFrame: function (type, location, style) {
            switch (type) {
                case "circle":
                    this._drawFrameCircle(location, style, this);
                    break;
                case "rectangle":
                    this._drawFrameRectangle(location, style, this);
                    break;
                case "roundedrectangle":
                    this._drawFrameRoundedRectangle(location, style, this);
                    break;
                case "thermometer":
                    this._drawFrameThermometer(location,style,this) ;
                    break;
            }
        },
		  
        _drawText: function (location, style) {
            this.contextEl.beginPath();
            this.contextEl.textAlign = "center";
            this.contextEl.fillStyle = ((style.textColor == "transparent") ? "rgba(0,0,0,0)" : style.textColor);
            this.contextEl.font = style.font;
            this.contextEl.fillText(style.indicatorText, location.textLocation.x, location.textLocation.y);
            this.contextEl.closePath();
        },
		  
        _drawTriangle: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawPointer: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(style.width, style.height / 4);
            element.contextEl.lineTo(style.width, -style.height / 4);
            element.contextEl.lineTo(style.width / 2, -style.height / 4);
            element.contextEl.lineTo(style.width / 2, -style.height / 2);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 2, style.height / 2);
            element.contextEl.lineTo(style.width / 2, style.height / 4);
            this._contextClosePath(style, element);
        },
		  
        _drawWedge: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(3 * style.width / 4, 0);
            element.contextEl.lineTo(style.width, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawSlider: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 4, -style.height / 2);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            element.contextEl.lineTo(style.width / 4, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawStar: function (location, style, element) {
            this._contextOpenPath(style, element);
            if (element.Model.orientation == "horizontal" && element.markerPlacement == "near") {
                element.contextEl.lineTo(location.startX + style.width - (style.width / 6), location.startY);   
                element.contextEl.lineTo(location.startX, location.startY + style.height - style.height / 3);
                element.contextEl.lineTo(location.startX + style.width, location.startY + style.height - style.height / 3);
                element.contextEl.lineTo(location.startX + style.width / 6, location.startY);
                element.contextEl.lineTo(location.startX + style.width / 2, location.startY + style.height);
            }
            else {
                element.contextEl.lineTo(location.startX + (style.width / 6), location.startY + style.height);   
                element.contextEl.lineTo(location.startX + style.width, location.startY + (style.height / 3));   
                element.contextEl.lineTo(location.startX, location.startY + (style.height / 3));   
                element.contextEl.lineTo(location.startX + style.width - (style.width / 6), location.startY + style.height);   
                element.contextEl.lineTo(location.startX + style.width / 2, location.startY);   
            }
            this._contextClosePath(style, element);
        },
		  
        _drawPentagon: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 3, -style.height / 2);
            element.contextEl.lineTo(style.width, -style.height / 4);
            element.contextEl.lineTo(style.width, style.height / 4);
            element.contextEl.lineTo(style.width / 3, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawDiamond: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(style.width / 2, -style.height / 2);
            element.contextEl.lineTo(style.width, 0);
            element.contextEl.lineTo(style.width / 2, style.height / 2);
            element.contextEl.lineTo(0, 0);
            this._contextClosePath(style, element);
        },
		  
        _drawCircle: function (location, style, element) {
            var radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2;
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.arc(radius / 2, 0, radius / 2, 0, Math.PI * 2, true);
            this._contextClosePath(style, element);
        },
		  
        _drawTrapezoid: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(0, -style.height / 4);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            element.contextEl.lineTo(0, style.height / 4);
            this._contextClosePath(style, element);
        },
		  
        _drawRectangle: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(0, 0);
            element.contextEl.lineTo(0, -style.height / 2);
            element.contextEl.lineTo(style.width, -style.height / 2);
            element.contextEl.lineTo(style.width, style.height / 2);
            element.contextEl.lineTo(0, style.height / 2);
            this._contextClosePath(style, element);
        },
		  
        _drawRoundedRectangle: function (location, style, element) {
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY - style.height / 2);
            this._setContextRotation(style, element);
            element.contextEl.lineTo(style.radius, 0);
            element.contextEl.lineTo(style.width - style.radius, 0);
            element.contextEl.quadraticCurveTo(style.width, 0, style.width, style.radius);
            element.contextEl.lineTo(style.width, style.height - style.radius);
            element.contextEl.quadraticCurveTo(style.width, style.height, style.width - style.radius, style.height);
            element.contextEl.lineTo(style.radius, style.height);
            element.contextEl.quadraticCurveTo(0, style.height, 0, style.height - style.radius);
            element.contextEl.lineTo(0, style.radius);
            element.contextEl.quadraticCurveTo(0, 0, style.radius, 0);
            this._contextClosePath(style, element);
        },
		  
        _drawCustomImage: function (element, imageUrl) {
            var image = new Image();
            $(image).on('load', function () {
                element.contextEl.drawImage(this, 0, 0, element.Model.width, element.Model.height);
                if (element.Model.scales != null)
                    element._drawScales();
                if (element.Model.Items != null)
                    element._renderItems();
            }).attr('src', imageUrl);
        },
		  
        _drawEllipse: function (location, style, element) {
            var radius = Math.sqrt(style.height * style.height + style.width * style.width) / 2;
            style = this._setPointerDimension(style, element);
            this._contextOpenPath(style, element);
            element.contextEl.translate(location.startX, location.startY);
            this._setContextRotation(style, element);
            element.contextEl.scale(2, 1);
            element.contextEl.arc(radius / 2, 0, radius / 2, 0, Math.PI * 2, true);
            this._contextClosePath(style, element);
        },
          
		  	
        _getIndicatorImage: function () {
            if (this.pointerImage)
                return this.pointerImage;
            else
                return this._getMarkerPointerImage();
        },
		  	
        _getBarPointerImage: function () {
            if (this.customLabelImage)
                return this.customLabelImage;
            else
                return this._getCustomLabelImage();
        },
		  	
        _getMarkerPointerImage: function () {
            if (this.barPointerImage)
                return this.barPointerImage;
            else
                return this._getCustomLabelImage();
        },
		  	
        _getCustomLabelImage: function () {
            if (this.rangeImage)
                return this.rangeImage;
            else
                return this._getRangeImage();
        },
		  	
        _getRangeImage: function () {
            if (this.labelImage)
                return this.labelImage;
            else
                return this._getLabelImage();
        },
		  	
        _getLabelImage: function () {

            if (this.tickImage)
                return this.tickImage;
            else
                return this._getTickImage();
        },
		  	
        _getTickImage: function () {
            if (this.scaleImage)
                return this.scaleImage;
            else
                return this.outerImage;
        },
		  
        setPointerValue: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length && value != null) {
            if(value <= this.scaleEl[scaleIndex].maximum && value >= this.scaleEl[scaleIndex].minimum)
                this.scaleEl[scaleIndex].markerPointers[pointerIndex].value = value;
                if (this.contextEl.putImageData) {
                    this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                    if (!ej.isNullOrUndefined(this.outerDiv) && this.model.scale[scaleIndex].showCustomLabels)
                        this.outerDiv.empty();
                        this._setCustomLabel();
                        this._setMarkerPointers();
                        this._setIndicators();
                }
                else
                    this.initialize();
            }
        },
		  
        getPointerValue: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length)
                return this.scaleEl[scaleIndex].markerPointers[pointerIndex].value;
            else
                return null;
        },
		  
        setPointerWidth: function (scaleIndex, pointerIndex, width) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length && width != null) {
                this.scaleEl[scaleIndex].markerPointers[pointerIndex].width = width;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else {
                        this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                        this._setMarkerPointers();
                    }
                }
                else
                    this.initialize();
            }
        },
		  
        getPointerWidth: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length)
                return this.scaleEl[scaleIndex].markerPointers[pointerIndex].width;
            else
                return null;
        },
		  
        setPointerHeight: function (scaleIndex, pointerIndex, height) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length && height != null) {
                this.scaleEl[scaleIndex].markerPointers[pointerIndex].length = height;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else {
                        this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                        this._setMarkerPointers();
                    }
                }
                else
                    this.initialize();
            }
        },
		  
        getPointerHeight: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length)
                return this.scaleEl[scaleIndex].markerPointers[pointerIndex].length;
            else
                return null;
        },
		  
        _getColor: function (element, option) {
            if (typeof (option) === "string") {
                return option;
            }
            else {
                return ("rgba(" + option.r + ", " + option.g + "," + option.b + ", " + option.a / 255 + ")");
            }
        },
		  
        setPointerDistanceFromScale: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length && value != null) {
                this.scaleEl[scaleIndex].markerPointers[pointerIndex].distanceFromScale = value;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else {
                        this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                        this._setMarkerPointers();
                    }
                }
                else
                    this.initialize();
            }
        },
		  
        getPointerDistanceFromScale: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length)
                return this.scaleEl[scaleIndex].markerPointers[pointerIndex].distanceFromScale;
            else
                return null;
        },
		  
        setPointerPlacement: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length && value != null) {
                this.scaleEl[scaleIndex].markerPointers[pointerIndex].placement = value;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else {
                        this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                        this._setMarkerPointers();
                    }
                }
                else
                    this.initialize();
            }
        },
		  
        getPointerPlacement: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length)
                return this.scaleEl[scaleIndex].markerPointers[pointerIndex].placement;
            else
                return null;
        },
		  
        setMarkerStyle: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length && value != null) {
                this.scaleEl[scaleIndex].markerPointers[pointerIndex].type = value;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else {
                        this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                        this._setMarkerPointers();
                    }
                }
                else
                    this.initialize();
            }
        },
		  
        getMarkerStyle: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].markerPointers.length)
                return this.scaleEl[scaleIndex].markerPointers[pointerIndex].type;
            else
                return null;
        },
		  
        setBarPointerValue: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].barPointers.length && value != null) {
            if(value <= this.scaleEl[scaleIndex].maximum && value >= this.scaleEl[scaleIndex].minimum)
                this.scaleEl[scaleIndex].barPointers[pointerIndex].value = value;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else
                        this._reDrawBarPointer();
                }
                else
                    this.initialize();
            }
        },
		  
        getBarPointerValue: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].barPointers.length)
                return this.scaleEl[scaleIndex].barPointers[pointerIndex].value;
            else
                return null;
        },
		  
        setBarWidth: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].barPointers.length && value != null) {
                this.scaleEl[scaleIndex].barPointers[pointerIndex].width = value;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else
                        this._reDrawBarPointer();
                }
                else
                    this.initialize();
            }
        },
		  
        getBarWidth: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].barPointers.length)
                return this.scaleEl[scaleIndex].barPointers[pointerIndex].width;
            else
                return null;
        },
		  
        setBarDistanceFromScale: function (scaleIndex, pointerIndex, value) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].barPointers.length && value != null) {
                this.scaleEl[scaleIndex].barPointers[pointerIndex].distanceFromScale = value;
                if (this.contextEl.putImageData) {
                    if (this.scaleEl[this.scaleIndex].type == "thermometer")
                        this.initialize();
                    else
                        this._reDrawBarPointer();
                }
                else
                    this.initialize();
            }
        },
		  
        getBarDistanceFromScale: function (scaleIndex, pointerIndex) {
            if (scaleIndex < this.Model.scales.length && pointerIndex < this.Model.scales[scaleIndex].barPointers.length)
                return this.scaleEl[scaleIndex].barPointers[pointerIndex].distanceFromScale;
            else
                return null;
        },
		  
        setCustomLabelValue: function (scaleIndex, customLabelIndex, value) {
            if (scaleIndex < this.Model.scales.length && customLabelIndex < this.Model.scales[scaleIndex].customLabels.length && value != null) {
                this.scaleEl[scaleIndex].customLabels[customLabelIndex].value = value;
                if (this.contextEl.putImageData)
                    this._reDrawCustomLabel();
                else
                    this.initialize();
            }
        },
		  
        getCustomLabelValue: function (scaleIndex, customLabelIndex) {
            if (scaleIndex < this.Model.scales.length && customLabelIndex < this.Model.scales[scaleIndex].customLabels.length)
                return this.scaleEl[scaleIndex].customLabels[customLabelIndex].value;
            else
                return null;
        },
		  
        setCustomLabelAngle: function (scaleIndex, customLabelIndex, value) {
            if (scaleIndex < this.Model.scales.length && customLabelIndex < this.Model.scales[scaleIndex].customLabels.length && value != null) {
                this.scaleEl[scaleIndex].customLabels[customLabelIndex].textAngle = value;
                if (this.contextEl.putImageData)
                    this._reDrawCustomLabel();
                else
                    this.initialize();
            }
        },
		  
        getCustomLabelAngle: function (scaleIndex, customLabelIndex) {
            if (scaleIndex < this.Model.scales.length && customLabelIndex < this.Model.scales[scaleIndex].customLabels.length)
                return this.scaleEl[scaleIndex].customLabels[customLabelIndex].textAngle;
            else
                return null;
        },
		  
        setRangeStartValue: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].startValue = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangeStartValue: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].startValue;
            else
                return null;
        },
		  
        setRangeEndValue: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].endValue = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangeEndValue: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].endValue;
            else
                return null;
        },
		  
        setRangeStartWidth: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].startWidth = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangeStartWidth: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].startWidth;
            else
                return null;
        },
		  
        setRangeEndWidth: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].endWidth = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangeEndWidth: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].endWidth;
            else
                return null;
        },
		  
        setRangeDistanceFromScale: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].distanceFromScale = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangeDistanceFromScale: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].distanceFromScale;
            else
                return null;
        },
		  
        setRangePosition: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].placement = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangePosition: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].placement;
            else
                return null;
        },
		  
        setRangeBorderWidth: function (scaleIndex, rangeIndex, value) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length && value != null) {
                this.scaleEl[scaleIndex].ranges[rangeIndex].border.width = value;
                if (this.contextEl.putImageData)
                    this._reDrawRange();
                else
                    this.initialize();
            }
        },
		  
        getRangeBorderWidth: function (scaleIndex, rangeIndex) {
            if (scaleIndex < this.Model.scales.length && rangeIndex < this.Model.scales[scaleIndex].ranges.length)
                return this.scaleEl[scaleIndex].ranges[rangeIndex].border.width;
            else
                return null;
        },
		  
        setLabelAngle: function (scaleIndex, labelIndex, angle) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length && angle != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].angle = angle;
                if (this.contextEl.putImageData) this._reDrawLabel();
                else
                    this.initialize();
            }
        },
		  
        getLabelAngle: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].angle;
            else
                return null;
        },
		  
        setLabelStyle: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].type = value;
                if (this.contextEl.putImageData) this._reDrawLabel();
                else
                    this.initialize();
            }
        },
		  
        getLabelStyle: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].type;
            else
                return null;
        },
		  
        setLabelPlacement: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].placement = value;
                if (this.contextEl.putImageData) this._reDrawLabel();
                else
                    this.initialize();
            }
        },
		  
        getLabelPlacement: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].placement;
            else
                return null;
        },
		  
        setLabelXDistanceFromScale: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].distanceFromScale.x = value;
                if (this.contextEl.putImageData) this._reDrawLabel();
                else
                    this.initialize();
            }
        },
		  
        getLabelXDistanceFromScale: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].distanceFromScale.x;
            else
                return null;
        },
		  
        setLabelYDistanceFromScale: function (scaleIndex, labelIndex, value) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length && value != null) {
                this.scaleEl[scaleIndex].labels[labelIndex].distanceFromScale.y = value;
                if (this.contextEl.putImageData)
                    this._reDrawLabel();
                else
                    this.initialize();
            }
        },
		  
        getLabelYDistanceFromScale: function (scaleIndex, labelIndex) {
            if (scaleIndex < this.Model.scales.length && labelIndex < this.Model.scales[scaleIndex].labels.length)
                return this.scaleEl[scaleIndex].labels[labelIndex].distanceFromScale.y;
            else
                return null;
        },
		  
        setTickAngle: function (scaleIndex, tickIndex, angle) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && angle != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].angle = angle;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickAngle: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].angle;
            else
                return null;
        },
		  
        setTickWidth: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].width = value;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickWidth: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].width;
            else
                return null;
        },
		  
        setTickHeight: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].height = value;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickHeight: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].height;
            else
                return null;
        },
		  
        setTickStyle: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].type = value;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickStyle: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].type;
            else
                return null;
        },
		  
        setTickPlacement: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].placement = value;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickPlacement: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].placement;
            else
                return null;
        },
		  
        setTickXDistanceFromScale: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].distanceFromScale.x = value;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickXDistanceFromScale: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].distanceFromScale.x;
            else
                return null;
        },
		  
        setTickYDistanceFromScale: function (scaleIndex, tickIndex, value) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length && value != null) {
                this.scaleEl[scaleIndex].ticks[tickIndex].distanceFromScale.y = value;
                if (this.contextEl.putImageData) {
                    this._reDrawTickMark();
                }
                else
                    this.initialize();
            }
        },
		  
        getTickYDistanceFromScale: function (scaleIndex, tickIndex) {
            if (scaleIndex < this.Model.scales.length && tickIndex < this.Model.scales[scaleIndex].ticks.length)
                return this.scaleEl[scaleIndex].ticks[tickIndex].distanceFromScale.y;
            else
                return null;
        },
		  
        setScaleLocation: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].position.x = value.x;
                this.scaleEl[scaleIndex].position.y = value.y;
                this.initialize();
            }
        },
		  
        getScaleLocation: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return { "x": this.scaleEl[scaleIndex].position.x, "y": this.scaleEl[scaleIndex].position.y };
            else
                return null;
        },
		  
        setMaximumValue: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
            if(value > this.scaleEl[scaleIndex].minimum)
                this.scaleEl[scaleIndex].maximum = value;
                this.initialize();
            }
        },
		  
        getMaximumValue: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[this.scaleIndex].maximum;
            else
                return null;
        },
		  
        setMinimumValue: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
            if(value < this.scaleEl[scaleIndex].maximum)
                this.scaleEl[scaleIndex].minimum = value;
                this.initialize();
            }
        },
		  
        getMinimumValue: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[this.scaleIndex].minimum;
            else
                return null;
        },
		  
        setScaleBarSize: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].width = value;
                this.initialize();
            }
        },
		  
        getScaleBarSize: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].width;
            else
                return null;
        },
		  
        setScaleBarLength: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].length = value;
                this.initialize();
            }
        },
		  
        setScaleStyle: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].type = value;
                this.initialize();
            }
        },
		  
        getScaleStyle: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].type;
            else
                return null;
        },
		  
        getScaleBarLength: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].length;
            else
                return null;
        },
		  
        setScaleBorderWidth: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].border.width = value;
                this.initialize();
            }
        },
		  
        setScaleDirection: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].direction = value;
                this.initialize();
            }
        },
		  
        getScaleDirection: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].direction;
            else
                return null;
        },
		  
        getScaleBorderWidth: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].border.width;
            else
                return null;
        },
		  
        setMajorIntervalValue: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].majorIntervalValue = value;
                this.initialize();
            }
        },
		  
        getMajorIntervalValue: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].majorIntervalValue;
            else
                return null;
        },
		  
        setMinorIntervalValue: function (scaleIndex, value) {
            if (scaleIndex < this.Model.scales.length && value != null) {
                this.scaleEl[scaleIndex].minorIntervalValue = value;
                this.initialize();
            }
        },
		  
        getMinorIntervalValue: function (scaleIndex) {
            if (scaleIndex < this.Model.scales.length)
                return this.scaleEl[scaleIndex].minorIntervalValue;
            else
                return null;
        },
		  
        _reDrawBarPointer: function () {
            if (this.Model.frame.backgroundImageUrl) {
                var tmpData = !ej.isNullOrUndefined(this.customLabelImage) ? this.customLabelImage() : !ej.isNullOrUndefined(this.rangeImage) ? this.rangeImage : !ej.isNullOrUndefined(this.labelImage) ? this.labelImage : !ej.isNullOrUndefined(this.tickImage) ? this.tickImage : !ej.isNullOrUndefined(this.scaleImage) ? this.scaleImage : null;
                this.contextEl.putImageData(tmpData, 0, 0);
                this._setBarPointers();
                this._setMarkerPointers();
                this._setIndicators();
            }
            else {
                if (this.contextEl.putImageData != "undefined") {
                    this.contextEl.putImageData(this._getBarPointerImage(), 0, 0);
                    this._setBarPointers();
                    this._setMarkerPointers();
                    this._setIndicators();
                }

            }
        },
		  
        _reDrawMarkerPointer: function () {
            if (this.Model.frame.backgroundImageUrl) {
                var tmpData = !ej.isNullOrUndefined(this.customLabelImage) ? this.customLabelImage() : !ej.isNullOrUndefined(this.rangeImage) ? this.rangeImage : !ej.isNullOrUndefined(this.labelImage) ? this.labelImage : !ej.isNullOrUndefined(this.tickImage) ? this.tickImage : !ej.isNullOrUndefined(this.scaleImage) ? this.scaleImage : null;
                this.contextEl.putImageData(tmpData, 0, 0);
                this._setMarkerPointers();
            }
            else {
                if (this.contextEl.putImageData != "undefined") {
                    this.contextEl.putImageData(this._getMarkerPointerImage(), 0, 0);
                    this._setMarkerPointers();
                }

            }
        },
		  
        _reDrawCustomLabel: function () {
            if (this.Model.frame.backgroundImageUrl) {
                var tmpData = !ej.isNullOrUndefined(this.rangeImage) ? this.rangeImage : !ej.isNullOrUndefined(this.labelImage) ? this.labelImage : !ej.isNullOrUndefined(this.tickImage) ? this.tickImage : !ej.isNullOrUndefined(this.scaleImage) ? this.scaleImage : null;
                this.contextEl.putImageData(tmpData, 0, 0);
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();
            }
            else {
                this.contextEl.putImageData(this._getCustomLabelImage(), 0, 0);
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();

            }
        },
		  
        _reDrawRange: function () {
            if (this.Model.frame.backgroundImageUrl) {
                var tmpData = !ej.isNullOrUndefined(this.labelImage) ? this.labelImage : !ej.isNullOrUndefined(this.tickImage) ? this.tickImage : !ej.isNullOrUndefined(this.scaleImage) ? this.scaleImage : null;
                this.contextEl.putImageData(tmpData, 0, 0);
                this._setRange();
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();
            }
            else {
                this.contextEl.putImageData(this._getRangeImage(), 0, 0);
                this._setRange();
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();

            }
        },
		  
        _reDrawLabel: function () {
            if (this.Model.frame.backgroundImageUrl){
                var tmpData = !ej.isNullOrUndefined(this.tickImage) ? this.tickImage : !ej.isNullOrUndefined(this.scaleImage) ? this.scaleImage : null;
                this.contextEl.putImageData(tmpData, 0, 0);
                this._setLabels();
                this._setRange();
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();
            }
            else {
                this.contextEl.putImageData(this._getLabelImage(), 0, 0);
                this._setLabels();
                this._setRange();
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();

            }
        },
		  
        _reDrawTickMark: function () {
            if (this.Model.frame.backgroundImageUrl) {
                var tmpData = !ej.isNullOrUndefined(this.scaleImage) ? this.scaleImage : null;
                this.contextEl.putImageData(tmpData, 0, 0);
                this._setTicks();
                this._setLabels();
                this._setRange();
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();
            }
            else {
                this.contextEl.putImageData(this._getTickImage(), 0, 0);
                this._setTicks();
                this._setLabels();
                this._setRange();
                this._setCustomLabel();
                this._setIndicators();
                this._setBarPointers();
                this._setMarkerPointers();

            }
        },
		  
        refresh: function () {
            this._init();
        },
		  
		exportImage: function(fileName, fileType) {
			/// <summary>This function save the rendered canvas image</summary>
            /// <param name="fileName" type="String">fileName to which the image has been saved</param>
		    /// <param name="fileType" type="String">fileType to which the image has been saved</param>
		    if (ej.browserInfo().name === "msie" && parseFloat(ej.browserInfo().version) < 10) {
		        return false;
		    }
		    else {
		        var image = this.canvasEl[0].toDataURL();
		        image = image.replace(/^data:[a-z]*;,/, '');
		        var image1 = image.split(',');
		        var byteString = atob(image1[1]);
		        var buffer = new ArrayBuffer(byteString.length);
		        var intArray = new Uint8Array(buffer);
		        for (var i = 0; i < byteString.length; i++) {
		            intArray[i] = byteString.charCodeAt(i);
		        }
		        var blob = new Blob([buffer], { type: "image/png" });
		        if (ej.browserInfo().name === "msie")
		            window.navigator.msSaveOrOpenBlob(blob, fileName + '.' + fileType);
		        else {
		            var pom = document.createElement('a');
		            var url = URL.createObjectURL(blob);
		            pom.href = url;
		            pom.setAttribute('download', fileName + '.' + fileType);
		            if (document.createEvent) {
		                var e = document.createEvent("MouseEvents");
		                e.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
		                pom.dispatchEvent(e);
		            }
		            else if (pom.fireEvent) {
		                pom.fireEvent("onclick");
		            }
		        }
		        return true;
		    }
        },
		 
		resizeCanvas: function () {
		    if (_linearGaugeCount != 0)
		        _linearGaugeCount = _linearGaugeCount - 1;
		    else
		        _linearGaugeCount = $(".e-lineargauge").length - 1;
		    var state, chk = true;
		    if (!ej.isNullOrUndefined(this.GaugeEl.parent().attr("style")))
		        state = this.GaugeEl.parent().attr("style").split(";");
		    if (!ej.isNullOrUndefined(state)) {
		        $.each(state, function (key, val) {
		            while (val.indexOf("width") != -1) {
		                chk = val.indexOf("px") == -1 ? true : false;
		                break;
		            }
		        });
		    }
            if (chk) {
                var ratio = window.innerWidth / initialLinearDivWidth;
                this.model.width *=ratio;
				for(var i=0;this.model.scales[i]!=null;i++){
                this.model.scales[i].length *= ratio;
                for (var j = 0; this.model.scales[i].markerPointers[j] != null || this.model.scales[i].barPointers[j] != null || this.model.scales[i].indicators[j] != null || this.model.scales[i].customLabels[j] != null || this.model.scales[i].ranges[j] != null || this.model.scales[i].labels[j] != null || this.model.scales[i].ticks[j] != null; j++) {
                    if (!ej.isNullOrUndefined(this.model.scales[i].markerPointers[j])) {
                        this.model.scales[i].markerPointers[j].length *= ratio;
                        this.model.scales[i].markerPointers[j].width *= ratio;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[i].barPointers[j])) {
                        this.model.scales[i].barPointers[j].distanceFromScale *= ratio;
                        this.model.scales[i].barPointers[j].width *= ratio;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[i].indicators[j]) && this.model.scales[i].showIndicators) {
                        this.model.scales[i].indicators[j].height *= ratio;
                        this.model.scales[i].indicators[j].width *= ratio;
                        this.model.scales[i].indicators[j].position.x *= ratio;
                        this.model.scales[i].indicators[j].textLocation.x *= ratio;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[i].ticks[j])) {
                        this.model.scales[i].ticks[j].length *= ratio;
                        this.model.scales[i].ticks[j].width *= ratio;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[i].ranges[j])) {
                        this.model.scales[i].ranges[j].startWidth *= ratio;
                        this.model.scales[i].ranges[j].endWidth *= ratio;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[i].customLabels[j])) {
                        if (this.model.scales[i].customLabels[j].positionType != "outer")
                            this.model.scales[i].customLabels[j].position.x *= ratio;
                        this.model.scales[i].customLabels[j].font.size = (parseFloat(this.model.scales[i].customLabels[j].font.size.match(/\d+/)[0]) * ratio < 10) ? "10px" : ((parseFloat(this.model.scales[i].customLabels[j].font.size.match(/\d+/)[0]) * ratio) > this._customLblMaxSize) ? this._customLblMaxSize.toString() + 'px' : ((parseFloat(this.model.scales[i].customLabels[j].font.size.match(/\d+/)[0])) * ratio).toString() + 'px';
                    }
				}
				}
				//this._initialize();
				this._render();
				if (_linearGaugeCount == 0) {
				    initialLinearDivWidth = window.innerWidth;
				}
            }
        },
        //Client-Side Events
	 
		_onDrawTicks: function (tickAngle, tickValue) {
		    var tick = { index: this.tickIndex, element: this.tickEl[this.tickIndex], angle: parseInt(tickAngle), value: tickValue }
            var data = { Object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawTicks", data);
        },
		 
		_onDrawLabels: function (labelAngle) {
		    var label = { index: this.labelIndex, element: this.labelEl[this.labelIndex], angle: parseInt(labelAngle), value: this.labelValue }
		    var data = { object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, label: label };
		    this._trigger("drawLabels", data);
		},
		 
        _onDrawBarPointers: function (pointerValue) {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, barPointerIndex: this.barPointerIndex, barElement: this.barPointerEl[this.barPointerIndex], context: this.contextEl, style: this.style, position: this.region, pointerValue: pointerValue };
            this._trigger("drawBarPointers", data);
        },
		 
        _onDrawMarkerPointers: function (pointerAngle, pointerValue) {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, markerPointerIndex: this.markerPointerIndex, markerElement: this.markerPointerEl[this.markerPointerIndex], context: this.contextEl, style: this.style, position: this.region, pointerValue: pointerValue, pointerAngle: parseInt(pointerAngle) };
            this._trigger("drawMarkerPointers", data);
        },
		 
        _onDrawRange: function () {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, rangeIndex: this.rangeIndex, rangeElement: this.rangeEl[this.rangeIndex], context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawRange", data);
        },
	 
        _onDrawCustomLabel: function () {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, customLabelIndex: this.customLabelIndex, customLabelElement: this.customLabelEl[this.customLabelIndex], context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawCustomLabel", data);
        },
		 
        _onDrawIndicators: function (location, style) {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, indicatorIndex: this.indicatorIndex, indicatorEl: this.indicatorEl[this.indicatorIndex], context: this.contextEl, style: this.style, position: this.region };
            this._trigger("drawIndicators", data);
        },
		 
        onLoad: function () {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales, context: this.contextEl };
            this._trigger("load", data);
        },
	 
        _onInit: function () {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales, context: this.contextEl };
            this._trigger("init", data);
        },
		 
        _onRenderComplete: function () {
            var data = { object: this, Model: this.Model, scaleElement: this.Model.scales, context: this.contextEl };
            this._trigger("renderComplete", data);
        },
        
        _onMouseClick: function (pointerValue) {
            var markerpointer = { index: this.markerPointerIndex, element: this.markerPointerEl[this.markerPointerIndex], value: pointerValue };
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, markerPointer: markerpointer };
            this._trigger("mouseClick", data);
        },
        
        _onMouseClickMove: function (pointerValue) {
            var markerpointer = { index: this.markerPointerIndex, element: this.markerPointerEl[this.markerPointerIndex], value: pointerValue };
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, markerPointer: markerpointer };
            this._trigger("mouseClickMove", data);
        },
        
        _onMouseClickUp: function (pointerValue) {
            var markerpointer = { index: this.markerPointerIndex, element: this.markerPointerEl[this.markerPointerIndex], value: pointerValue };
            var data = { object: this, scaleElement: this.model.scales[this.scaleIndex], scaleIndex: this.scaleIndex, context: this.contextEl, style: this.style, position: this.region, markerPointer: markerpointer };
            this._trigger("mouseClickUp", data);
        },
        //_trigger: function (type, event, data) {
        //    var fn = this.Model[type];
        //    event = $.Event(event);
        //    event.type = type;
        //    $(this.GaugeEl).trigger(event, data);
        //    return !($.isFunction(fn) &&
        //        fn(this, data) === false ||
        //        event.isDefaultPrevented());
        //},

        //trigger: function (element, eventName, e) {
        //    e = $.extend(e || {}, new $.Event(eventName));
        //    e.stopPropagation();
        //    $(element).trigger(e);
        //    return e.isDefaultPrevented();
        //},
		 
        _restoreWidth: function () {
            this.scaleEl[this.scaleIndex].length = this.scaleEl[this.scaleIndex].length + this.bottomRadius + this.scaleEl[this.scaleIndex].width;
            if (this.Model.orientation == "Vertical") {
                if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise")
                    this.scaleStartY[this.scaleIndex] = this.scaleStartY[this.scaleIndex] - this.bottomRadius - this.scaleEl[this.scaleIndex].width / 2;
                else
                    this.scaleStartY[this.scaleIndex] = this.scaleStartY[this.scaleIndex] - this.scaleEl[this.scaleIndex].width / 2;
            }
            else {
                if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise")
                    this.scaleStartX[this.scaleIndex] = this.scaleStartX[this.scaleIndex] - this.bottomRadius - this.scaleEl[this.scaleIndex].width / 2;
                else
                    this.scaleStartX[this.scaleIndex] = this.scaleStartX[this.scaleIndex] - this.scaleEl[this.scaleIndex].width / 2;
            }
        },
		 
        _modifyWidth: function () {
            this.scaleEl[this.scaleIndex].length = this.scaleEl[this.scaleIndex].length - this.bottomRadius - this.scaleEl[this.scaleIndex].width;
            if (this.Model.orientation == "Vertical") {
                if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise")
                    this.scaleStartY[this.scaleIndex] = this.scaleStartY[this.scaleIndex] + this.bottomRadius + this.scaleEl[this.scaleIndex].width / 2;
                else
                    this.scaleStartY[this.scaleIndex] = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2;
            }
            else {
                if (this.scaleEl[this.scaleIndex].direction.toLowerCase() == "clockwise")
                    this.scaleStartX[this.scaleIndex] = this.scaleStartX[this.scaleIndex] + this.bottomRadius + this.scaleEl[this.scaleIndex].width / 2;
                else
                    this.scaleStartX[this.scaleIndex] = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2;
            }
        },
        // return y positions for vertical gauge
	 
        _getClockwiseLinePosition: function (value) {
            var tempVal, linePosition;
            tempVal = (value - this.scaleEl[this.scaleIndex].minimum) / (this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum) * 100;
            linePosition = this.Model.orientation == "Vertical" ? this.scaleStartY[this.scaleIndex] + parseInt((tempVal * this.scaleEl[this.scaleIndex].length) / 100) : this.scaleStartX[this.scaleIndex] + parseInt((tempVal * this.scaleEl[this.scaleIndex].length) / 100);
            return linePosition;
        },
		 
        _getCounterClockwiseLinePosition: function (value) {
            var tempVal, linePosition;
            tempVal = this.scaleEl[this.scaleIndex].maximum - value + this.scaleEl[this.scaleIndex].minimum;
            tempVal = (tempVal - this.scaleEl[this.scaleIndex].minimum) / (this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum) * 100;
            linePosition = this.Model.orientation == "Vertical" ? this.scaleStartY[this.scaleIndex] + parseInt((tempVal * this.scaleEl[this.scaleIndex].length) / 100) : this.scaleStartX[this.scaleIndex] + parseInt((tempVal * this.scaleEl[this.scaleIndex].length) / 100);
            return linePosition;
        },
		 
        _getValue: function (position) {
            var tempVal;
            if (this.Model.orientation == "Vertical")
                tempVal = ((position.y - this.scaleStartY[this.scaleIndex]) / this.scaleEl[this.scaleIndex].length) * 100;
            else
                tempVal = (((position.x - this.scaleStartX[this.scaleIndex])) / this.scaleEl[this.scaleIndex].length) * 100;
            var value = ((tempVal * (this.scaleEl[this.scaleIndex].maximum - this.scaleEl[this.scaleIndex].minimum)) + this.scaleEl[this.scaleIndex].minimum) / 100;
            if (this.scaleEl[this.scaleIndex].direction == "counterclockwise")
                value = this.scaleEl[this.scaleIndex].maximum - value;
            else
                value = this.scaleEl[this.scaleIndex].minimum + value;
            return value;
        },
		 
        _getPointerXPosition: function (element) {
            var startX, angle;
            if (this.Model.orientation == "Vertical") {
                if (this.markerPlacement == "far") {
                    startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                    angle = 0;
                }
                if (this.markerPlacement == "near") {
                    startX = this.scaleStartX[this.scaleIndex] + element.distanceFromScale;
                    angle = 180;
                }
                if (this.markerPlacement == "center") {
                    if (element.type == "circle")
                        startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - (Math.sqrt(element.length * element.length + element.width * element.width) / 2) + element.distanceFromScale;
                    else
                        startX = this.scaleStartX[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.width / 2 + element.distanceFromScale;
                    angle = 0;
                }
            }
            else {
                if (this.markerPlacement == "far") {
                    startX = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width + this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                    angle = 90;
                }
                if (this.markerPlacement == "near") {
                    startX = this.scaleStartY[this.scaleIndex] - this.scaleEl[this.scaleIndex].border.width / 2 + element.distanceFromScale;
                    angle = 270;
                }
                if (this.markerPlacement == "center") {
                    if (element.type == "circle")
                        startX = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - (Math.sqrt(element.length * element.length + element.width * element.width) / 2) + element.distanceFromScale;
                    else
                        startX = this.scaleStartY[this.scaleIndex] + this.scaleEl[this.scaleIndex].width / 2 - element.length / 2 + element.distanceFromScale;
                    angle = 90;
                }
            }
            return { "startx": startX, "angle": angle };
        },
		 
        _hexFromRGB: function (r, g, b) {
            var hex = [r.toString(16), g.toString(16), b.toString(16)];
            $.each(hex, function (nr, val) { if (val.length === 1) { hex[nr] = "0" + val; } });
            return hex.join("").toUpperCase();
        },
	 
        _setGradientColor: function (element, gradients, options) {
            if (options.Name || typeof (options) === "string") {
                gradients.addColorStop(0, options);
                gradients.addColorStop(1, options);
            }
            else
                $.each(options, function (index, colorElement) {
                    gradients.addColorStop(colorElement.colorStop != NaN ? colorElement.colorStop : 0, typeof (colorElement.color) === "string" ? colorElement.color : colorElement.color);
                });
        },
		 
        _getFontString: function (element, font) {
            return font.fontStyle + " " + ((font.size == null) ? "11px" : font.size) + " " + font.fontFamily;
        },
	 
        _setPointerDimension: function (style, element) {
            if (element.Model.orientation) {
                if (element.Model.orientation == "horizontal") {
                    var tempWidth = style.width;
                    var tempHeight = style.height;
                    style.height = tempWidth;
                    style.width = tempHeight;
                }
            }
            return style;
        },
		 
        _setContextRotation: function (style, element) {
            element.contextEl.rotate(Math.PI * (style.angle / 180));
        },
        _browserInfo: function () {
            var browser = {}, clientInfo = [],
            browserClients = {
                webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
                opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
            };
            for (var client in browserClients) {
                if (browserClients.hasOwnProperty(client)) {
                    clientInfo = navigator.userAgent.match(browserClients[client]);
                    if (clientInfo) {
                        browser.name = clientInfo[1].toLowerCase();
                        browser.version = clientInfo[2];
                        if (!!navigator.userAgent.match(/Trident\/7\./)) {
                            browser.name = "msie";
                        }
                        break;
                    }
                }
            }
            browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
            browser.pointerEnabled = window.navigator.pointerEnabled;
            return browser;
        },
        wireEvents: function () {
            var matched = jQuery.uaMatch(navigator.userAgent),
               browserInfo = this._browserInfo(),
               isPointer = browserInfo.isMSPointerEnabled,
               isIE11Pointer = browserInfo.pointerEnabled;
            this.startEv = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
            this.endEv = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
            this.moveEv = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
            this.leaveEv = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchleave mouseleave",
            this.scrollEv = matched.browser.toLowerCase() == "mozilla" ? (isIE11Pointer ? "mousewheel" : "DOMMouseScroll") : "mousewheel";
            this.model.browserInfo = browserInfo;

            var action= this.model.readOnly? 'pan-y pan-x' : 'none';
            $(this.element).css('touch-action', action);

            this.onMouseMoveHandler = $.proxy(this._onMouseMove, this);
            this.onMouseUpHandler = $.proxy(this._onMouseUp, this);
            this.onHoverOCustomLabel = $.proxy(this._onHoverOCustomLabel, this);
            this.onLeaveOCustomLabel = $.proxy(this._onLeaveOCustomLabel, this);
            if (!this.model.readOnly) {
                this.onMouseDownHandler = $.proxy(this._onMouseDown, this);
                this._on($(this.element), this.startEv, this._onMouseDown);
            }

            if (this.model.tooltip.showCustomLabelTooltip || this.model.tooltip.showLabelTooltip) {
                $(this.canvasEl).bind(this.moveEv, this.onMouseMoveHandler);
                $(this.canvasEl).bind(this.scrollEv, this.onMouseMoveHandler);
                $(this.canvasEl).bind(this.startEv, this.onMouseDownHandler);
                $(this.canvasEl).bind(this.endEv, this.onLeaveOCustomLabel);
                $(this.canvasEl).bind(this.leaveEv, this.onLeaveOCustomLabel);
            }
            this.element.bind(this.startEv, this.onMouseDownHandler);
            if (this.model.tooltip.showCustomLabelTooltip) {
                $('.' + this._id + 'outercustomlbl').bind("mouseenter", this.onHoverOCustomLabel);
                $('.' + this._id + 'outercustomlbl').bind(this.leaveEv, this.onLeaveOCustomLabel);
            }
        },
		 
        unWireEvents: function () {
            this.element.unbind(this.startEv, this.onMouseDownHandler);
        },
       
        _onHoverOCustomLabel: function (e) {
            if (e.currentTarget.innerHTML != null || e.currentTarget.innerHTML != "")
                this._showTooltip(e, e.currentTarget.innerHTML);
        },
        
        _onLeaveOCustomLabel: function (evt) {
            if (this.isTouch(evt)) {
                this._performTooltip(evt);
				window.clearTimeout(this.model.timer);
				this.model.timer = setTimeout(function () {
					$('.tooltipDiv').fadeOut(500);
	            }, 1200);
            }
            else {
                this._hideTooltip();
            }
        },
		 
        isTouch: function (evt) {
            var event = evt.originalEvent ? evt.originalEvent : evt;
            if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        },

        _blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },
		 
        _onMouseDown: function (e) {
            var endPoint, position, greaterValue, lesserValue, startX;
            this._blockDefaultActions(e);
            this._mouseDown = true;
            var padding = this.isTouch(e) ? 10 : 0;
            var touch = e.originalEvent.touches ? e.originalEvent.touches[0] : e;
            endPoint = { "x": touch.pageX - $(this.canvasEl).offset().left - (this.Model.frame.outerWidth + this.Model.frame.innerWidth), "y": touch.pageY - $(this.canvasEl).offset().top - (this.Model.frame.outerWidth + this.Model.frame.innerWidth) };
            var self = this;
            if (!this.model.readOnly) {
                $.each(this.Model.scales, function (index, element) {
                    self.scaleIndex = index;
                    if (element.markerPointers != null) {
                        self.markerPointerEl = element.markerPointers;
                        $.each(element.markerPointers, function (mpIndex, mpElement) {
                            if (self.scaleEl[self.scaleIndex].direction.toLowerCase() == "clockwise")
                                position = self._getClockwiseLinePosition(mpElement.value);
                            else
                                position = self._getCounterClockwiseLinePosition(mpElement.value);
                            greaterValue = position + mpElement.width;
                            lesserValue = position - mpElement.width;
                            startX = self._getPointerXPosition(mpElement).startx;
                            var isOffset = self._isBetween(((self.Model.orientation == "horizontal" ? endPoint.y : endPoint.x) - mpElement.width), ((self.Model.orientation == "horizontal" ? endPoint.y : endPoint.x) + mpElement.width), startX, padding);
                            if ((self.Model.orientation == "horizontal" ? self._isBetween(lesserValue, greaterValue, endPoint.x, padding) : self._isBetween(lesserValue, greaterValue, endPoint.y, padding)) && isOffset)
                                self.activeElement = mpElement;
                            if (self.Model.scales[self.scaleIndex].barPointers[mpIndex] != null)
                                self.activeBarElement = self.Model.scales[self.scaleIndex].barPointers[mpIndex];
                            if (self.model.mouseClick)
                                self._onMouseClick(mpElement.value);
                            self.onMouseMoveHandler = $.proxy(self._onMouseMove, self);
                            self.onMouseUpHandler = $.proxy(self._onMouseUp, self);
                            $(document).bind(self.moveEv, self.onMouseMoveHandler);
                            $(document).bind(self.endEv, self.onMouseUpHandler);
                        });
                    }
                });
            }
        },
		 
        _isBetween: function (first, last, number, padding) {
            return (first < last ? number >= first - padding && number <= last + padding : number >= last - padding && number <= first + padding);
        },
		 
        _onMouseUp: function () {
            this._mouseDown = false;
            this.mouseMove = false;
            $(document).unbind(self.moveEv, self.onMouseMoveHandler);
            $(document).unbind(self.endEv, self.onMouseUpHandler);
            if (this.model.mouseClickUp && this.activeElement)
                this._onMouseClickUp(this.activeElement.value);
            this.activeElement = null;
        },
        _mousePosition: function (evt) {
            if (!ej.util.isNullOrUndefined(evt.pageX) && evt.pageX > 0)
                return { x: evt.pageX, y: evt.pageY };
            else if (evt.originalEvent && !ej.util.isNullOrUndefined(evt.originalEvent.pageX) && evt.originalEvent.pageX > 0)
                return { x: evt.originalEvent.pageX, y: evt.originalEvent.pageY };
            else if (evt.originalEvent && evt.originalEvent.changedTouches != undefined) {
                if (!ej.util.isNullOrUndefined(evt.originalEvent.changedTouches[0].pageX) && evt.originalEvent.changedTouches[0].pageX > 0)
                    return { x: evt.originalEvent.changedTouches[0].pageX, y: evt.originalEvent.changedTouches[0].pageY };
            }
            else
                return { x: 0, y: 0 };

        },
        _calTouchPosition: function (e) {
            var matched = jQuery.uaMatch(navigator.userAgent);
            var mouseposition = this._mousePosition(e);
            e.pageX = mouseposition.x;
            e.pageY = mouseposition.y;
        },
        getEvent: function (event) {
            return (event.targetTouches && event.targetTouches[0]) ? event.targetTouches[0] : event
        },
        _onMouseMove: function (e) {
            if (this._mouseDown && !ej.isNullOrUndefined(this.activeElement)) {
                this._blockDefaultActions(e);
                var touch = e.originalEvent.touches ? e.originalEvent.touches[0] : e;
                var endPoint = { "x": touch.pageX - $(this.canvasEl).offset().left - (this.Model.frame.outerWidth + this.Model.frame.innerWidth), "y": touch.pageY - $(this.canvasEl).offset().top - (this.Model.frame.outerWidth + this.Model.frame.innerWidth) };
                this.activeElement.value = this._getValue(endPoint);
                this.value(this.activeElement.value);
                if (this.model.mouseClickMove)
                    this._onMouseClickMove(this.activeElement.value);
                if (this.activeBarElement)
                    this.activeBarElement.value = this._getValue(endPoint);
                if (this.contextEl.putImageData)
                    this._reDrawBarPointer();
                else
                    this._init();
            }
            else {
                if ((this.model.tooltip.showCustomLabelTooltip || this.model.tooltip.showLabelTooltip) && (!this.isTouch(e))) {
                    this._performTooltip(e);
                    
                    
                }
            }
        },

        _performTooltip: function (e) {
            var hit = false;
            var padding = 10;
            var isTouch = this.isTouch(e);
            for (var i = 0; this._savedPoints[i] != null; i++) {
                if (isTouch) {
                    var mousedownCords = this._calTouchPosition(e),
                        pointer = this.getEvent(e),
                        currX = pointer.pageX,
                        currY = pointer.pageY;
                    var current = { "X": currX - $(this.canvasEl).offset().left, "Y": currY - $(this.canvasEl).offset().top };
                    if (current.X > this._savedPoints[i].startX - padding && current.X < (this._savedPoints[i].startX + this._savedPoints[i].width + padding) && current.Y > this._savedPoints[i].startY - padding && current.Y < (this._savedPoints[i].startY + this._savedPoints[i].height + padding)) {
                        this._showTooltip(e, this._savedPoints[i].value);
                        hit = true;
                    }
                    else if (hit == false)
                        this._hideTooltip();
                } else {
                    var current = { "X": e.pageX - $(this.canvasEl).offset().left, "Y": e.pageY - $(this.canvasEl).offset().top };

                    if (current.X > this._savedPoints[i].startX && current.X < (this._savedPoints[i].startX + this._savedPoints[i].width) && current.Y > this._savedPoints[i].startY && current.Y < (this._savedPoints[i].startY + this._savedPoints[i].height)) {
                        this._showTooltip(e, this._savedPoints[i].value);
                        hit = true;
                    }
                    else if (hit == false)
                        this._hideTooltip();
                }
            }
        },
     
        _showTooltip: function (event, val) {
            var tooltipText = val + "";
            var tooltipdiv = $('.tooltipDiv');
            if (tooltipdiv.length == 0) {
                tooltipdiv = $("<div class='tooltipDiv' style='position: absolute; z-index: 105; display: block;'></div>");
                $(document.body).append(tooltipdiv);
            }
            if (this.model.tooltip.templateID != "" && this.model.tooltip.templateID != null) {
                var cloneNode = $("#" + this.model.tooltip.templateID).clone();
                $('.tooltipDiv')[0].innerHTML = "";
                $(cloneNode).css("display", "block").appendTo(tooltipdiv);
                $(tooltipdiv).css({
                    'background-color': this.model.backgroundColor,
                    'border': '1px solid #bbbcbb',
                    'border-radius': '3px',
                    'color': '#565656'
                });
                tooltipdiv.html(tooltipdiv.html().replace('#label#', tooltipText));
            } else {
                $(tooltipdiv).html(tooltipText);
                $(tooltipdiv).css({
                    'background-color': 'white',
                    'border': '2px solid #bbbcbb',
                    'position': 'absolute',
                    'padding': '10px 20px',
                    'margin-top': '5px',
                    'text-align': 'left',
                    'font': '12px Segoe UI',
                    'font-stretch': 'condensed',
                    'display': 'inline-block',
                    'border-radius': '3px',
                    'color': '#565656',
                    'width': 'auto'
                });
            }
            var tooltipMargin = 10;
            var xPos = event.pageX + tooltipMargin;
            var yPos = event.pageY + tooltipMargin;
            xPos = ((xPos + $(tooltipdiv).width()) < $(window).width()) ? (xPos) : (xPos - $(tooltipdiv).width());
            yPos = ((yPos + $(tooltipdiv).height()) < $(window).height()) ? (yPos) : (yPos - $(tooltipdiv).height());
            $(tooltipdiv).css("left", xPos);
            $(tooltipdiv).css("top", yPos);
            $('.tooltipDiv').show();
        },
        
        _hideTooltip: function () {
            $('.tooltipDiv').remove();//.fadeOut(0, "linear");
        },
       
        _setTheme: function () {
            var selectedTheme = this.model.themeProperties[this.model.theme];
            this._setThemeColors(selectedTheme);
        },
		 
        _setThemeColors: function (selectedTheme) {
            var result = [], jsonObj = this.model.themeProperties;
            for (var name in jsonObj) {
                result.push(name);
            }
            for (var th = 0; th < result.length; th++) {
                this.model.backgroundColor = ((!this.model.backgroundColor || this.model.backgroundColor == jsonObj[result[th]].scales.backgroundColor) ? selectedTheme.scales.backgroundColor : this.model.backgroundColor);
                this.model.borderColor = ((!this.model.borderColor || this.model.borderColor == jsonObj[result[th]].scales.border.color) ? selectedTheme.scales.border.color : this.model.borderColor);
                this.model.labelColor = ((!this.model.labelColor || this.model.labelColor == jsonObj[result[th]].scales.labels.labelColor) ? selectedTheme.scales.labels.labelColor : this.model.labelColor);
                this.model.tickColor = ((!this.model.tickColor || this.model.tickColor == jsonObj[result[th]].scales.ticks.color) ? selectedTheme.scales.ticks.color : this.model.tickColor);

                for (var i = 0; i < this.model.scales.length; i++) {
                    for (var m = 0; m < this.model.scales[i].markerPointers.length; m++) {
                        this.model.scales[i].markerPointers[m].backgroundColor = (!this.model.scales[i].markerPointers[m].backgroundColor || this.model.scales[i].markerPointers[m].backgroundColor == jsonObj[result[th]].scales.markerPointers.backgroundColor) ? selectedTheme.scales.markerPointers.backgroundColor : this.model.scales[i].markerPointers[m].backgroundColor;
                        this.model.scales[i].markerPointers[m].border.color = (!this.model.scales[i].markerPointers[m].border.color || this.model.scales[i].markerPointers[m].border.color == jsonObj[result[th]].scales.markerPointers.border.color) ? selectedTheme.scales.markerPointers.border.color : this.model.scales[i].markerPointers[m].border.color;
                    }
                    for (var b = 0; b < this.model.scales[i].barPointers.length; b++) {
                        this.model.scales[i].barPointers[b].backgroundColor = (!this.model.scales[i].barPointers[b].backgroundColor || this.model.scales[i].barPointers[b].backgroundColor == jsonObj[result[th]].scales.barPointers.backgroundColor) ? selectedTheme.scales.barPointers.backgroundColor : this.model.scales[i].barPointers[b].backgroundColor;
                        this.model.scales[i].barPointers[b].border.color = (!this.model.scales[i].barPointers[b].border.color || this.model.scales[i].barPointers[b].border.color == jsonObj[result[th]].scales.barPointers.border.color) ? selectedTheme.scales.barPointers.border.color : this.model.scales[i].barPointers[b].border.color;
                    }
                }
            }
        }
    });
    
    ej.datavisualization.LinearGauge.TickType = {
          
        MajorInterval: "majorinterval",
          
        MinorInterval: "minorinterval"
    };
      
    ej.datavisualization.LinearGauge.LabelType = {
          
        Major: "major",
          
        Minor: "minor"
    };
      
    ej.datavisualization.LinearGauge.FontStyle = {
          
        Bold: "bold",
          
        Italic: "italic",
          
        Regular: "regular",
          
        Strikeout: "strikeout",
          
        Underline: "underline"
    };


      
    ej.datavisualization.LinearGauge.PointerPlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.LinearGauge.TickPlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.LinearGauge.LabelPlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      
    ej.datavisualization.LinearGauge.RangePlacement = {
          
        Near: "near",
          
        Far: "far",
          
        Center: "center"
    };
      

    ej.datavisualization.LinearGauge.UnitTextPlacement = {
          
        Front: "front",
          
        Back: "back"
    };
      

    ej.datavisualization.LinearGauge.Directions = {
          
        Clockwise: "clockwise",
          
        CounterClockwise: "counterclockwise"
    };
      
    ej.datavisualization.LinearGauge.ScaleType = {
          
        Rectangle: "rectangle",
          
        RoundedRectangle: "roundedrectangle",
          
        Thermometer: "thermometer"
    };
      
    ej.datavisualization.LinearGauge.IndicatorType = {
          
        Rectangle: "rectangle",
          
        Circle: "circle",
          
        RoundedRectangle: "roundedrectangle",
          
        Text: "text"
    };
      
    ej.datavisualization.LinearGauge.MarkerType = {
          
        Rectangle: "rectangle",
          
        Triangle: "triangle",
          
        Ellipse: "ellipse",
          
        Diamond: "diamond",
          
        Pentagon: "pentagon",
          
        Circle: "circle",
          
        Star: "star",
          
        Slider: "slider",
          
        Pointer: "pointer",
          
        Wedge: "wedge",
          
        Trapezoid: "trapezoid",
          
        RoundedRectangle: "roundedrectangle"
    };
      
    ej.datavisualization.LinearGauge.CustomLabelPositionType = {
          
        Inner: "inner",
          
        Outer: "outer"
    };
      
    ej.datavisualization.LinearGauge.OuterCustomLabelPosition = {
          
        Left: "left",
          
        Right: "right",
          
        Top: "top",
          
        Bottom: "bottom",
    };
	  
    ej.datavisualization.LinearGauge.Themes = {
	  
        FlatLight: 'flatlight',

		FlatDark: 'flatdark'
    };

})(jQuery, Syncfusion);
;;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/


(function ($, ej, undefined) {

    ej.widget({ "ejDigitalGauge": "ej.datavisualization.DigitalGauge" }, {
     
        element: null,
     
        model: null,
        validTags: ["div", "span"],
        _rootCSS: "e-digitalgauge",
        
        defaults:   {
              

            segmentData: {
                "0": [0, 1, 2, 3, 4, 5, 14, 15], "1": [1, 2], "2": [0, 14, 1, 6, 8, 4, 3, 15], "3": [0, 1, 2, 3, 6, 8, 14, 15], "4": [1, 2, 5, 6, 8], "5": [0, 2, 3, 5, 6, 8, 14, 15], "6": [0, 2, 3, 4, 5, 6, 8, 14, 15],
                "7": [0, 1, 2, 14], "8": [0, 1, 2, 3, 4, 5, 6, 8, 14, 15], "9": [0, 1, 2, 3, 5, 6, 8, 14, 15], "A": [0, 1, 2, 4, 5, 6, 8, 14], "B": [0, 1, 2, 3, 7, 9, 8, 14, 15], "C": [0, 3, 4, 5, 14, 15],
                "D": [0, 1, 2, 3, 7, 9, 14, 15], "E": [0, 3, 4, 5, 6, 8, 14, 15], "F": [0, 4, 5, 6, 8, 14], "G": [0, 2, 3, 4, 5, 8, 14, 15], "H": [1, 2, 4, 5, 6, 8], "I": [0, 3, 7, 9, 14, 15],
                "J": [1, 2, 3, 4, 15], "K": [4, 5, 6, 10, 11], "L": [3, 4, 5, 15], "M": [1, 2, 4, 5, 10, 13], "N": [1, 2, 4, 5, 11, 13], "O": [0, 1, 2, 3, 4, 5, 14, 15], "P": [0, 1, 4, 5, 6, 8, 14],
                "Q": [0, 1, 2, 3, 4, 5, 11, 14, 15], "R": [0, 1, 4, 5, 6, 8, 11, 14], "S": [0, 2, 3, 5, 6, 8, 14, 15], "T": [0, 7, 9, 14], "U": [1, 2, 3, 4, 5, 15], "V": [4, 5, 10, 12], "W": [1, 2, 4, 5, 11, 12],
                "X": [10, 11, 12, 13], "Y": [1, 5, 6, 7, 8], "Z": [0, 3, 10, 12, 14, 15]
            },
              
            matrixSegmentData: {
                "1": [0, 3, 0, 4, 1, 1, 1, 2, 1, 3, 1, 4, 2, 3, 2, 4, 3, 3, 3, 4, 4, 3, 4, 4, 5, 3, 5, 4, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "2": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 1, 5, 1, 6, 2, 5, 2, 6, 3, 4, 3, 5, 4, 3, 4, 2, 5, 2, 5, 1, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "3": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 1, 5, 1, 6, 2, 5, 2, 6, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 5, 4, 6, 5, 5, 5, 6, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5],
                "4": [0, 3, 0, 4, 0, 5, 1, 2, 1, 3, 1, 4, 1, 5, 2, 1, 2, 2, 2, 4, 2, 5, 3, 0, 3, 1, 3, 4, 3, 5, 4, 0, 4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 5, 4, 5, 5, 6, 4, 6, 5],
                "5": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 5, 4, 6, 5, 5, 5, 6, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "6": [0, 3, 0, 4, 0, 5, 0, 6, 1, 2, 1, 3, 2, 1, 2, 2, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 4, 3, 4, 6, 4, 7, 5, 2, 5, 3, 5, 6, 5, 7, 6, 3, 6, 4, 6, 5, 6, 6],
                "7": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 1, 6, 1, 7, 2, 5, 2, 6, 3, 4, 3, 5, 4, 3, 4, 4, 5, 2, 5, 3, 6, 1, 6, 2],
                "8": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "9": [0, 2, 0, 3, 0, 4, 0, 5, 1, 1, 1, 2, 1, 5, 1, 6, 2, 1, 2, 2, 2, 4, 2, 5, 2, 6, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 5, 4, 6, 5, 5, 5, 6, 6, 2, 6, 3, 6, 4, 6, 4, 6, 5],
                "0": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "a": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 6, 1, 7, 2, 6, 2, 7, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "b": [0, 1, 0, 2, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 4, 3, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "c": [1, 3, 1, 4, 1, 5, 1, 6, 2, 2, 2, 3, 3, 1, 3, 2, 4, 1, 4, 2, 5, 2, 5, 3, 6, 3, 6, 4, 6, 5, 6, 6],
                "d": [0, 6, 0, 7, 1, 6, 1, 7, 2, 6, 2, 7, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 3, 7, 4, 1, 4, 2, 4, 5, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "e": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 5, 1, 5, 2, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "f": [0, 4, 0, 5, 0, 6, 0, 7, 1, 3, 1, 4, 2, 3, 2, 4, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 3, 7, 4, 3, 4, 4, 5, 3, 5, 4, 6, 3, 6, 4],
                "g": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 3, 7, 4, 6, 4, 7, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "h": [0, 1, 0, 2, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 4, 3, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 6, 6, 7],
                "i": [0, 3, 0, 4, 2, 1, 2, 2, 2, 3, 2, 4, 3, 3, 3, 4, 4, 3, 4, 4, 5, 3, 5, 4, 6, 3, 6, 4],
                "j": [1, 5, 1, 6, 2, 5, 2, 6, 3, 5, 3, 6, 4, 1, 4, 2, 4, 5, 4, 6, 5, 1, 5, 2, 5, 5, 5, 6, 6, 2, 6, 3, 6, 4, 6, 5],
                "k": [0, 1, 0, 2, 1, 1, 1, 2, 1, 4, 1, 5, 2, 1, 2, 2, 2, 3, 2, 4, 3, 1, 3, 2, 3, 3, 4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 5, 1, 5, 2, 5, 5, 5, 6, 6, 1, 6, 2, 6, 6, 6, 7],
                "l": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 5, 1, 6, 2, 5, 2, 6, 3, 5, 3, 6, 4, 5, 4, 6, 5, 5, 5, 6, 6, 5, 6, 6],
                "m": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 0, 1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 2, 0, 2, 1, 2, 3, 2, 4, 2, 6, 2, 7, 3, 0, 3, 1, 3, 3, 3, 4, 3, 6, 3, 7, 4, 0, 4, 1, 4, 3, 4, 4, 4, 6, 4, 7, 5, 0, 5, 1, 5, 3, 5, 4, 5, 6, 5, 7, 6, 0, 6, 1, 6, 3, 6, 4, 6, 6, 6, 7],
                "n": [1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 2, 0, 2, 1, 2, 2, 2, 6, 2, 7, 3, 0, 3, 1, 3, 6, 3, 7, 4, 0, 4, 1, 4, 6, 4, 7, 5, 0, 5, 1, 5, 6, 5, 7, 6, 0, 6, 1, 6, 6, 6, 7],
                "o": [1, 2, 1, 3, 1, 4, 1, 5, 2, 1, 2, 2, 2, 5, 2, 6, 3, 1, 3, 2, 3, 5, 3, 6, 4, 1, 4, 2, 4, 5, 4, 6, 5, 1, 5, 2, 5, 5, 5, 6, 6, 2, 6, 3, 6, 4, 6, 5],
                "p": [1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 2, 1, 2, 2, 2, 3, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 5, 1, 5, 2, 6, 1, 6, 2],
                "q": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 1, 1, 1, 2, 1, 5, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 5, 3, 6, 3, 7, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 4, 7, 5, 6, 5, 7, 6, 6, 6, 7],
                "r": [0, 1, 0, 3, 0, 4, 0, 5, 1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 2, 1, 2, 2, 2, 6, 3, 1, 3, 2, 4, 1, 4, 2, 5, 1, 5, 2, 6, 1, 6, 2],
                "s": [1, 2, 1, 3, 1, 4, 1, 5, 2, 1, 2, 2, 3, 1, 3, 2, 4, 3, 4, 4, 5, 4, 5, 5, 6, 1, 6, 2, 6, 3, 6, 4],
                "t": [0, 3, 0, 4, 1, 3, 1, 4, 2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 3, 3, 3, 4, 4, 3, 4, 4, 5, 3, 5, 4, 6, 4, 6, 5, 6, 6, 6, 7],
                "u": [1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 5, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "v": [1, 1, 1, 2, 1, 6, 1, 7, 2, 2, 2, 3, 2, 5, 2, 6, 3, 2, 3, 3, 3, 5, 3, 6, 4, 3, 4, 4, 4, 5, 5, 4, 5, 5, 6, 4],
                "w": [0, 0, 0, 1, 0, 6, 0, 7, 1, 0, 1, 1, 1, 6, 1, 7, 2, 0, 2, 1, 2, 3, 2, 4, 2, 6, 2, 7, 3, 0, 3, 1, 3, 3, 3, 4, 3, 6, 3, 7, 4, 0, 4, 1, 4, 3, 4, 4, 4, 6, 4, 7, 5, 0, 5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "x": [1, 1, 1, 2, 1, 6, 1, 7, 2, 2, 2, 3, 2, 5, 2, 6, 3, 3, 3, 4, 3, 5, 4, 3, 4, 4, 4, 5, 5, 2, 5, 3, 5, 5, 5, 6, 6, 1, 6, 2, 6, 6, 6, 7],
                "y": [1, 1, 1, 2, 1, 5, 1, 6, 2, 1, 2, 2, 2, 5, 2, 6, 3, 2, 3, 3, 3, 4, 3, 5, 4, 3, 4, 4, 5, 2, 5, 3, 6, 1, 6, 2],
                "z": [1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 2, 6, 2, 7, 3, 5, 3, 6, 4, 4, 4, 5, 5, 3, 5, 4, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "A": [0, 3, 0, 4, 1, 2, 1, 3, 1, 4, 1, 5, 2, 2, 2, 3, 2, 4, 2, 5, 3, 1, 3, 2, 3, 5, 3, 6, 4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 5, 1, 5, 2, 5, 5, 5, 6, 6, 0, 6, 1, 6, 6, 6, 7],
                "B": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 3, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 4, 3, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "C": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 2, 0, 2, 1, 3, 0, 3, 1, 4, 0, 4, 1, 5, 1, 5, 2, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "D": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "E": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 5, 1, 5, 2, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "F": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 5, 1, 5, 2, 6, 1, 6, 2],
                "G": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 2, 0, 2, 1, 3, 0, 3, 1, 3, 4, 3, 5, 3, 6, 4, 0, 4, 1, 4, 6, 5, 1, 5, 2, 5, 6, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "H": [0, 1, 0, 2, 0, 6, 0, 7, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 6, 6, 7],
                "I": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "J": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 5, 1, 6, 2, 5, 2, 6, 3, 5, 3, 6, 4, 1, 4, 2, 4, 5, 4, 6, 5, 1, 5, 2, 5, 5, 5, 6, 6, 2, 6, 3, 6, 4, 6, 5],
                "K": [0, 1, 0, 2, 0, 5, 0, 6, 1, 1, 1, 2, 1, 4, 1, 5, 2, 1, 2, 2, 2, 3, 2, 4, 3, 1, 3, 2, 3, 3, 4, 1, 4, 2, 4, 3, 4, 4, 5, 1, 5, 2, 5, 4, 5, 5, 6, 1, 6, 2, 6, 5, 6, 6],
                "L": [0, 1, 0, 2, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 4, 1, 4, 2, 5, 1, 5, 2, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "M": [0, 1, 0, 2, 0, 6, 0, 7, 1, 1, 1, 2, 1, 3, 1, 5, 1, 6, 1, 7, 2, 1, 2, 2, 2, 4, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 6, 6, 7],
                "N": [0, 1, 0, 2, 0, 6, 0, 7, 1, 1, 1, 2, 1, 3, 1, 6, 1, 7, 2, 1, 2, 2, 2, 4, 2, 6, 2, 7, 3, 1, 3, 2, 3, 5, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 1, 6, 2, 6, 6, 6, 7],
                "O": [0, 2, 0, 3, 0, 4, 0, 5, 1, 1, 1, 2, 1, 5, 1, 6, 2, 0, 2, 1, 2, 6, 2, 7, 3, 0, 3, 1, 3, 6, 3, 7, 4, 0, 4, 1, 4, 6, 4, 7, 5, 1, 5, 2, 5, 5, 5, 6, 6, 2, 6, 3, 6, 4, 6, 5],
                "P": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 3, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 5, 1, 5, 2, 6, 1, 6, 2],
                "Q": [0, 2, 0, 3, 0, 4, 0, 5, 1, 1, 1, 2, 1, 5, 1, 6, 2, 0, 2, 1, 2, 6, 2, 7, 3, 0, 3, 1, 3, 6, 3, 7, 4, 0, 4, 1, 4, 4, 4, 6, 4, 7, 5, 1, 5, 2, 5, 5, 5, 6, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                "R": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 1, 3, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 4, 1, 4, 2, 4, 5, 5, 1, 5, 5, 6, 2, 6, 1, 6, 2, 6, 6],
                "S": [0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 1, 1, 1, 2, 2, 1, 2, 2, 3, 2, 3, 3, 3, 4, 3, 5, 4, 5, 4, 6, 5, 5, 5, 6, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "T": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4],
                "U": [0, 1, 0, 2, 0, 6, 0, 7, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 6, 4, 7, 5, 1, 5, 2, 5, 6, 5, 7, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6],
                "V": [0, 0, 0, 1, 0, 6, 0, 7, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 2, 3, 3, 3, 5, 3, 6, 4, 3, 4, 4, 4, 5, 4, 6, 5, 4, 5, 5, 6, 4],
                "W": [0, 1, 0, 2, 0, 6, 0, 7, 1, 1, 1, 2, 1, 6, 1, 7, 2, 1, 2, 2, 2, 6, 2, 7, 3, 1, 3, 2, 3, 6, 3, 7, 4, 1, 4, 2, 4, 4, 4, 6, 4, 7, 5, 1, 5, 2, 5, 3, 5, 5, 5, 6, 5, 7, 6, 1, 6, 2, 6, 6, 6, 7],
                "X": [0, 0, 0, 1, 0, 6, 0, 7, 1, 1, 1, 2, 1, 5, 1, 6, 2, 1, 2, 2, 2, 5, 2, 6, 3, 2, 3, 3, 3, 4, 3, 5, 4, 2, 4, 3, 4, 4, 4, 5, 5, 1, 5, 2, 5, 5, 5, 6, 6, 0, 6, 1, 6, 6, 6, 7],
                "Y": [0, 0, 0, 1, 0, 6, 0, 7, 1, 0, 1, 1, 1, 6, 1, 7, 2, 1, 2, 2, 2, 5, 2, 6, 3, 2, 3, 3, 3, 4, 3, 5, 4, 3, 4, 4, 5, 3, 5, 4, 6, 3, 6, 4],
                "Z": [0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 1, 6, 1, 7, 2, 5, 2, 6, 3, 4, 3, 5, 4, 2, 4, 3, 5, 1, 5, 2, 6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7],
                ",": [5, 3, 5, 4, 5, 5, 6, 4, 6, 5, 7, 3, 7, 4],
                ":": [1, 3, 1, 4, 1, 5, 2, 3, 2, 4, 2, 5, 4, 3, 4, 4, 4, 5, 5, 3, 5, 4, 5, 5],
                "%": [0, 6, 0, 7, 1, 1, 1, 2, 1, 5, 1, 6, 2, 1, 2, 2, 2, 4, 2, 5, 3, 3, 3, 4, 4, 2, 4, 3, 5, 1, 5, 2, 5, 4, 5, 5, 6, 0, 6, 1, 6, 4, 6, 5],
                "!": [0, 3, 0, 4, 0, 5, 1, 3, 1, 4, 1, 5, 2, 3, 2, 4, 2, 5, 3, 3, 3, 4, 3, 5, 4, 3, 4, 4, 4, 5, 5, 3, 5, 4, 5, 5, 7, 4],
                "(": [0, 2, 0, 3, 1, 1, 1, 2, 2, 1, 2, 2, 3, 1, 3, 2, 4, 1, 4, 2, 5, 1, 5, 2, 6, 1, 6, 2, 7, 2, 7, 3],
                ")": [0, 5, 0, 6, 1, 6, 1, 7, 2, 6, 2, 7, 3, 6, 3, 7, 4, 6, 4, 7, 5, 6, 5, 7, 6, 6, 6, 7, 7, 5, 7, 6],
                ".": [5, 3, 5, 4, 5, 5, 6, 3, 6, 4, 6, 5, 7, 3, 7, 4, 7, 5]
            },
              
            frame: {
                  
                backgroundImageUrl: null,
                  
                innerWidth: 6,
                  
                outerWidth: 10,
            },
              
            height: 150,
              
            width: 400,
              
            enableResize: false,
              
            isResponsive: false,
              
            themes: "flatlight",
              
            items: null,
              
            init: null,
              
            load: null,
              
            renderComplete: null,
              
            itemRendering: null,
              
            value: "text",
			themeProperties:{
			 flatlight: {
            items: {
                segmentSettings: {
                    color: "#232323",
                },
                shadowColor: "#232323",
                textColor: "#232323"
            }
        },
          
        flatdark: {
            items: {
                segmentSettings: {
                    color: "#b1b0b0",
                },
                shadowColor: "#b1b0b0",
                textColor: "#b1b0b0"
            }
        }
			}
        },

          
        dataTypes: {
            segmentData: "data",
            matrixSegmentData: "data",
            items: "array",
            isResponsive: "boolean",
        },

          
        _setValues: function () {
            this.gaugeEl = this.element;
            this.segmentCount = null;
            this.contextEl = null;
            this.style = null;
            this._value = null;
            this.region = null;
            this.canvasEl = null;
            this.segement16X = null;
            this.segment16Y = null;
            this.segmentHeight = null;
            this.segmentAngle = null;
            this.startX = 5;
            this.startY = 5;
            this.gradient = null;
            this.itemIndex = null;
            this.characterSpace = null;
            this.outerImage = null;
            this.radius = null;
            this.frameOuterLocation = null;
            this.frameInnerLocation = null;
            this.glassFrameLocation = null;
            this.glassFrameStyle = null;
            this.frameOuterStyle = null;
            this.character = null;
            this.frameInnerStyle = null;
            this._itemInitialize();
        },
        observables: ["value"],
        _tags: [{
            tag: "items",
            attr: ["characterSettings.count", "characterSettings.opacity", "characterSettings.spacing", "characterSettings.type", "enableCustomFont", "segmentSettings.color", "segmentSettings.gradient", "segmentSettings.length", "segmentSettings.opacity", "segmentSettings.spacing", "segmentSettings.width", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textAlign", "shadowColor", "textColor", "font.size", "font.fontFamily", "font.fontStyle", "position.x", "position.y"]
        }],
        value: ej.util.valueFunction("value"),


          
        _destroy: function () {
            this.element.empty().removeClass("e-widget");
        },
          
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "height":
                        this.model.height = options[option];
                        break;
                    case "width":
                        this.model.width = options[option];
                        break;
                    case "items":
                        this.model.items = options[option];
                        this._itemInitialize();
                        break;
                    case "frame":
                        $.extend(this.model.frame, options[option]); break;
                    case "themes": this.model.themes = options[option]; break;
                    case "value":
                        for (var i = 0; this.model.items[i] != null; i++)
                            this.model.items[i].value = this.value();
                        break;
                }
            }
            this.refresh();
        },
          
        _init: function () {
            _digitalGaugeCount = $(".e-digitalgauge").length;
            initialGaugeCount = _digitalGaugeCount;
            this._setValues();
            this._trigger("load");
            this._setTheme();
            this._initialize();
            this._onWindowResize();
        },
          
        _onWindowResize: function () {
            if (this.model.enableResize || this.model.isResponsive) {
                if (!ej.isTouchDevice())
                    this._on($(window), "resize", this.resizeCanvas);
                else
                    this._on($(window), "orientationchange", this.resizeCanvas);
            }
        },
          
        _setTheme: function () {
            var selectedThem = this.model.themeProperties[this.model.themes];
            this._setThemeColors(selectedThem);
        },
          
        _setThemeColors: function (selectedThem) {
            var result = [], jsonObj = this.model.themeProperties;
            for (var name in jsonObj) {
                result.push(name);
            }
            for (var th = 0; th < result.length; th++) {
                for (var i = 0; i < this.model.items.length; i++) {
                    this.model.items[i].segmentSettings.color = (ej.isNullOrUndefined(this.model.items[i].segmentSettings.color) || this.model.items[i].segmentSettings.color == jsonObj[result[th]].items.segmentSettings.color) ? selectedThem.items.segmentSettings.color : this.model.items[i].segmentSettings.color;
                    this.model.items[i].shadowColor = (!this.model.items[i].shadowColor || this.model.items[i].shadowColor == jsonObj[result[th]].items.shadowColor) ? selectedThem.items.shadowColor : this.model.items[i].shadowColor;
                    this.model.items[i].textColor = (!this.model.items[i].textColor || this.model.items[i].textColor == jsonObj[result[th]].items.textColor) ? selectedThem.items.textColor : this.model.items[i].textColor;
                }
            }
        },
          
        _initialize: function () {
            if (this.model.init)
                this._clientSideOnInit();
            this._initObject(this);
            if (this.model.load)
                this._clientSideOnLoad();
            if (this.model.frame.backgroundImageUrl != null)
                this._drawCustomImage(this, this.model.frame.backgroundImageUrl);
            else
                this._renderItems();
            if (this.model.renderComplete)
                this._clientSideOnRenderComplete();
        },
          
        _itemInitialize: function () {
            var proxy = this;
            if (this.model.items != null) {
                $.each(this.model.items, function (index, element) {
                    var obj = proxy._sendDefaultItem();
                    $.extend(true, obj, element);
                    $.extend(true, element, obj);
                });
            }
            else {
                this.model.items = [this._sendDefaultItem()];
            }
        },
          
        _sendDefaultItem: function () {
            var defaultItems;
            return defaultItems = {
                  
                characterSettings: {
                      
                    count: 4,
                       
                    opacity: 1,
                      
                    spacing: 2,
                      
                    type:ej.datavisualization.DigitalGauge.CharacterType.EightCrossEightDotMatrix,
                },
                  
                enableCustomFont: false,
                  
                segmentSettings: {
                      
                    color: null,
                      
                    gradient:null,
                       
                    length: 2,
                      
                    opacity: 0,
                      
                    spacing: 1,
                      
                    width: 1,
                },
                  
                shadowBlur: 0,
                  
                shadowOffsetX: 1,
                  
                shadowOffsetY: 1,
                  
                textAlign: "left",
                  
                font:   {
                      
                    size: "11px",
                      
                    fontFamily: "Arial",
                      
                    fontStyle: "italic"
                },
                  
                position: {
                      
                    x: 0,
                      
                    y: 0
                },
                  
                shadowColor: null,
                  
                textColor: null,
                  
                value: null
            };
        },
          
        _initObject: function (element) {
            this.element.addClass("e-widget");
            element.gaugeEl = this.element;
            for (var i = 0; this.model.items[i] != null; i++) {
                if (this.model.items[i].value == null)
                    this.model.items[i].value = this.value();
            }
            if (element.canvasEl)
                element.canvasEl.parent().empty();
            element.canvasEl = $("<canvas></canvas>");
            element.gaugeEl.append(element.canvasEl);
            element.canvasEl.attr("role", "presentation");
            if (_digitalGaugeCount == initialGaugeCount) {
                initialDigitalDivWidth = window.innerWidth;
            }
            element.canvasEl[0].setAttribute("width", element.model.width);
            element.canvasEl[0].setAttribute("height", element.model.height);
            element.centerX = element.canvasEl[0].width / 2;
            element.centerY = element.canvasEl[0].height / 2;
            var elem = element.canvasEl[0];
            if (typeof window.G_vmlCanvasManager != "undefined") {
                elem = window.G_vmlCanvasManager.initElement(elem);
            }
            if (!elem || !elem.getContext) {
                return;
            }
            element.contextEl = element.canvasEl[0].getContext("2d");
        },
          
        _drawCustomImage: function (element, imageUrl) {
            var image = new Image();
            $(image).on('load', function () {
                element.contextEl.drawImage(this, 0, 0, element.model.width, element.model.height);
                if (element.model.Scales != null)
                    element._drawScales();
                if (element.model.items != null)
                    element._renderItems();
            }).attr('src', imageUrl);
        },
          
        _setSegmentCount: function (element) {
            switch (element) {
                case "sevensegment": this._SegmentCount = 7; break;
                case "fourteensegment": this._SegmentCount = 14; break;
                case "sixteensegment": this._SegmentCount = 16; break;
                case "eightcrosseightdotmatrix": this._SegmentCount = [8, 8]; break;
                case "eightcrosseightsquarematrix": this._SegmentCount = [8, 8]; break;
                default:
                    this._SegmentCount = 7;
            }

        },
          
        _setInnerPosition: function () {
            this.contextEl.save();
            this.contextEl.translate(this.model.frame.outerWidth + this.model.frame.innerWidth, this.model.frame.outerWidth + this.model.frame.innerWidth);
            this.bounds = {
                height: this.canvasEl[0].height - 2 * (this.model.frame.outerWidth + this.model.frame.innerWidth),
                width: this.canvasEl[0].width - 2 * (this.model.frame.outerWidth + this.model.frame.innerWidth)
            };
        },
          
        _setWidth: function () {
            var characterCount = [];
            if (this.model.items != null) {
                $.each(this.model.items, function (index, element) {
                    characterCount.push(element.characterSettings.count);
                });
            }
        },

          
        _renderItems: function () {
            if (this.model.items != null) {
                this._setInnerPosition();
                var self = this;
                $.each(this.model.items, function (index, element) {
                    self._setSegmentCount(element.characterSettings.type);
                    self.itemIndex = index;
                    self.canvasEl.attr("aria-label", element.value);
                    self._setShadow(index, element);
                    if (element.enableCustomFont)
                        self._setCustomFont(index, element);
                    else if (element.characterSettings.type.indexOf("matrix") != -1)
                        self._drawMatrixSegments(index, element);
                    else
                        self._drawSegments(index, element);
                });
            }
        },

          
        _setGradientColor: function (element, gradient, options) {
            if (options.Name || typeof (options) === "string") {
                gradient.addColorStop(0, this._getColor(element, options));
                gradient.addColorStop(1, this._getColor(element, options));
            }
            else
                $.each(options, function (index, colorElement) {
                    gradient.addColorStop(colorElement.colorStop != NaN ? colorElement.colorStop : 0, typeof (colorElement.color) === "string" ? colorElement.color : this._getColor(element, colorElement.color));
                });
        },

          
        _getColor: function (element, option) {
            if (typeof (option) === "string") {
                return option;
            }
            else {
                return ("rgba(" + option.R + ", " + option.G + "," + option.B + ", " + option.A / 255 + ")");
            }
        },

          
        _drawMatrixSegments: function (index, element) {
            var segmentXCollection = [], segmentCollection = [];
            if (element.value) {
                this._value = element.value.toString().split('');
                  
                element.characterSettings.count = (this._value.length > 4)?this._value.length:4;
            }
            else
                this._value = "";
            this.radius = (element.characterSettings.type.indexOf("dot") != -1) ? (element.segmentSettings.length + element.segmentSettings.width) / 2 : element.segmentSettings.width / 2;
            var controlStartX = this.startX = (this.bounds.width - element.characterSettings.count * (this._SegmentCount[0] * (2 * this.radius) + element.characterSettings.spacing + this._SegmentCount[0] * element.segmentSettings.spacing)) * (element.position.x / 100);
            var controlStartY = this.startY = (this.bounds.height - (this._SegmentCount[1] * ((element.characterSettings.type.indexOf("dot") != -1) ? 2 * this.radius : element.segmentSettings.length) + this._SegmentCount[1] * element.segmentSettings.spacing)) * (element.position.y / 100);
            for (var character = 0; character < element.characterSettings.count; character++) {
                if (this._value) {
                    this.character = element.textAlign == "right" ? this._value[this._value.length - element.characterSettings.count + character] : this._value[character];
                    segmentCollection = this.model.matrixSegmentData[this.character];
                }
                if (character != 0) {
                    controlStartX = this.startX = this.startX + element.characterSettings.spacing + element.segmentSettings.spacing + (2 * this.radius);
                    this.startY = controlStartY;
                }
                for (var dotY = 0; dotY < this._SegmentCount[1]; dotY++) {
                    if (dotY != 0) {
                        this.startY = ((element.characterSettings.type.indexOf("dot") != -1) ? (2 * this.radius) : element.segmentSettings.length) + this.startY + element.segmentSettings.spacing;
                        this.startX = controlStartX;
                    }
                    if (segmentCollection) {
                        $.each(segmentCollection, function (segIndex) {
                            if (segIndex % 2 == 0) {
                                if (segmentCollection[segIndex] > dotY)
                                    return false;
                                if (segmentCollection[segIndex] == dotY)
                                    segmentXCollection.push(parseInt(segmentCollection[segIndex + 1]));
                            }
                        });
                    }
                    for (var dotX = 0; dotX < this._SegmentCount[0]; dotX++) {
                        if (dotX != 0)
                            this.startX = this.startX + 2 * this.radius + element.segmentSettings.spacing;
                        if (element.characterSettings.type.indexOf("dot") != -1)
                            this.gradient = this.contextEl.createRadialGradient(0, 0, 0, 0, 0, this.radius);
                        else
                            this.gradient = this.contextEl.createLinearGradient(0, 0, element.segmentSettings.width, 0);
                        if (element.segmentSettings.gradient)
                            this._setGradientColor(this, this.gradient, element.segmentSettings.gradient.colorInfo);
                        this.region = { "startX": this.startX, "startY": this.startY };
                        this.style = {
                            "opacity": (segmentXCollection && ($.inArray(dotX, segmentXCollection)) != -1) ? element.characterSettings.opacity : element.segmentSettings.opacity,
                            "height": element.segmentSettings.length,
                            "width": element.segmentSettings.width,
                            "fillStyle": ((element.segmentSettings.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(this, element.segmentSettings.color)),
                            "skewX": element.SkewAngleX,
                            "skewY": element.SkewAngleX
                        };
                        if (this.model.itemRendering)
                            this._clientSideOnItemRendering(true, dotX, dotY);
                        if (element.characterSettings.type.indexOf("dot") != -1)
                            this._drawDot(this.region, this.style);
                        else
                            this._drawSquare(this.region, this.style);
                    }
                    segmentXCollection = [];
                }
            }
        },

          
        _drawSegments: function (index, element) {
            var segmentCollection = [];
            if (element.value) {
                this._value = element.value.toUpperCase().toString().split('');
                //beyond the four character it align in center. else it align left
                element.characterSettings.count = (this._value.length > 4) ? this._value.length : 4;
            }
            this.characterSpace = element.characterSettings.type == "sevensegment" ? 2 * element.segmentSettings.width : 4 * element.segmentSettings.width;
            this._renderSegmentCalculation(element);
            this.gradient = this.contextEl.createLinearGradient(0, 0, 0, element.segmentSettings.width);
            if (element.segmentSettings.color)
                this._setGradientColor(this, this.gradient, element.segmentSettings.color);
            else if (element.segmentSettings.gradient)
                this._setGradientColor(this, this.gradient, element.segmentSettings.gradient.colorInfo);
            //else
            //    this._setGradientColor(this, this.gradient, this.model.segmentColor);
            for (var character = 0; character < element.characterSettings.count; character++) {
                if (element.value)
                    segmentCollection = this.model.segmentData[element.textAlign == "right" ? this._value[this._value.length - element.characterSettings.count + character] : this._value[character]];
                for (var segment = 0; segment < this._SegmentCount; segment++) {
                    if (character != 0)
                        this.segment16X[segment] = this.segment16X[segment] + element.segmentSettings.length + this.characterSpace + element.characterSettings.spacing;
                    if (this._value)
                        this.character = element.textAlign == "right" ? this._value[this._value.length - element.characterSettings.count + character] : this._value[character];
                    this.region = { "startX": this.segment16X[segment], "startY": this.segment16Y[segment] };
                    this.style = {
                        "angle": this.angle[segment],
                        "fillStyle": this.gradient,
                        "isStroke": false,
                        "isFill": true,
                        "characterHeight": element.characterSettings.type == "sevensegment" ? element.segmentSettings.length : this.segmentHeight[segment],
                        "segmentWidth": element.segmentSettings.width,
                        "opacity": (segmentCollection && ($.inArray(segment, segmentCollection) != -1)) ? element.characterSettings.opacity : element.segmentSettings.opacity
                    };
                    if (this.model.itemRendering)
                        this._clientSideOnItemRendering(false, segment);
                    this._drawSegmentLayers(this.region, this.style);
                }
                if (this._notifyArrayChange)
                    this._notifyArrayChange("items[" + index + "]value", element.value);
                this.value(element.value);
                segmentCollection = [];
            }
        },

        
        _setCustomFont: function (index, element) {
            this.startX = (this.bounds.width - this._measureText(element.value, 0, this._getFontString(this, element.font)).width) * (element.position.x / 100);
            this.startY = (this.bounds.height - this._measureText(element.value, 0, this._getFontString(this, element.font)).height) * (element.position.y / 100);
            this.region = { "startX": this.startX, "startY": this.startY };
            this.style = { "font": this._getFontString(this, element.font), "text": element.value, "textColor": element.textColor ? ((element.textColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(this, element.textColor)) : ((element.segmentSettings.color == "transparent") ? "rgba(0,0,0,0)" : this._getColor(this, element.segmentSettings.color)) };
            if (this.model.itemRendering)
                this._clientSideOnItemRendering(false, segment);
            this._drawText(this.region, this.style);
        },

          
        _getFontString: function (element, font) {
            return ((font.size == null) ? "11px" : font.size) + " " + font.fontFamily + " " + (font.fontStyle ? font.fontStyle : "");
        },

          
        _renderSegmentCalculation: function (element) {
            var length = element.segmentSettings.length, width = element.segmentSettings.width;
            this.startX = (this.bounds.width - element.characterSettings.count * (length + this.characterSpace + element.characterSettings.spacing)) * (element.position.x / 100);
            this.startY = (this.bounds.height - 2 * length - width) * (element.position.y / 100);
            var tempLength = element.characterSettings.type == "sevensegment" ? length : length / 2;
            this.segment16X = [
                  this.startX + width / 2,
                  this.startX + length + 4 * width,
                  this.startX + length + 4 * width,
                  this.startX + width / 2,
                  this.startX,
                  this.startX,
                  this.startX + width / 2,
                  this.startX + tempLength + 2 * width,
                  this.startX + 2.5 * width + tempLength,
                  this.startX + tempLength + 2 * width,
                  this.startX + length + 2.5 * width,
                  this.startX + tempLength + 2.5 * width,
                  this.startX + tempLength + 1.5 * width,
                  this.startX + 1.5 * width,
                  this.startX + 5 * width / 2 + tempLength,
                  this.startX + 2.5 * width + tempLength
            ];
            this.segment16Y = [
                  this.startY,
                  this.startY,
                  this.startY + length + width,
                  this.startY + 2 * length + 2 * width,
                  this.startY + length + width,
                  this.startY,
                  this.startY + length + width,
                  this.startY + length + width,
                  this.startY + length + width,
                  this.startY,
                  this.startY + width,
                  this.startY + length + width,
                  this.startY + length + width,
                  this.startY + width,
                  this.startY,
                  this.startY + 2 * length + 2 * width
            ];
            this.segmentHeight = [
                  length / 2,
                  length,
                  length,
                  length / 2,
                  length,
                  length,
                  length / 2,
                  length,
                  length / 2,
                  length,
                  length,
                  length,
                  length,
                  length,
                  length / 2,
                  length / 2
            ];
            this.angle = [-90, 0, 0, -90, 0, 0, -90, 0, -90, 0, 27, -27, 27, -27, -90, -90];
            if (element.characterSettings.type == "sevensegment")
                this.segment16X[2] = this.segment16X[1] = this.startX + length + 2 * width;
            if (element.characterSettings.type == "fourteensegment")
                this.segmentHeight[3] = this.segmentHeight[0] = length + 2 * width;
        },

          
        _drawSegmentLayers: function (location, style) {
            this._contextOpenPath(style, this);
            this.contextEl.translate(location.startX, location.startY);
            this.contextEl.rotate(Math.PI * (style.angle / 180));
            this.contextEl.lineTo(0, 0);
            this.contextEl.lineTo(-style.segmentWidth, style.segmentWidth);
            this.contextEl.lineTo(-style.segmentWidth, style.characterHeight);
            this.contextEl.lineTo(0, style.characterHeight + style.segmentWidth);
            this.contextEl.lineTo(style.segmentWidth, style.characterHeight);
            this.contextEl.lineTo(style.segmentWidth, style.segmentWidth);
            this._contextClosePath(style, this);
        },

          
        _drawDot: function (location, style) {
            this.contextEl.beginPath();
            this.contextEl.save();
            this.contextEl.translate(location.startX, location.startY);
            this.contextEl.fillStyle = style.fillStyle;
            this.contextEl.globalAlpha = style.opacity;
            this.contextEl.arc(0, 0, this.radius, 0, 2 * Math.PI, true);
            this.contextEl.fill();
            this.contextEl.closePath();
            this.contextEl.restore();
        },

          
        _setShadow: function (index, element) {
            this.contextEl.save();
            this.contextEl.shadowColor = ((element.shadowColor == "transparent") ? "rgba(0,0,0,0)" : this._getColor(this, element.shadowColor));
            this.contextEl.shadowOffsetY = element.shadowOffsetY;
            this.contextEl.shadowOffsetX = element.shadowOffsetX;
            this.contextEl.shadowBlur = element.shadowBlur;
        },

          
        _drawSquare: function (location, style) {
            this.contextEl.beginPath();
            this.contextEl.save();
            this.contextEl.translate(location.startX, location.startY);
              
            this.contextEl.fillStyle = style.fillStyle;
            this.contextEl.globalAlpha = style.opacity;
            this.contextEl.rect(0, 0, style.width, style.height);
            this.contextEl.fill();
            this.contextEl.closePath();
            this.contextEl.restore();
        },

          

        _drawText: function (location, style) {
            this.contextEl.beginPath();
            this.contextEl.save();
            this.contextEl.font = style.font;
            this.contextEl.textBaseline = "hanging";
            this.contextEl.fillStyle = ((style.textColor == "transparent") ? "rgba(0,0,0,0)" : style.textColor);
            this.contextEl.fillText(style.text, location.startX, location.startY);
            this.contextEl.closePath();
            this.contextEl.restore();
        },

          

        setValue: function (itemIndex, value) {
            if (itemIndex < this.model.items.length && value != null) {
                this.model.items[itemIndex].value = value;
                this._initialize();
            }
        },

          
        getValue: function (itemIndex) {
            return this.model.items[itemIndex].value;
        },

          

        setPosition: function (itemIndex, value) {
            if (itemIndex < this.model.items.length && value != null) {
                this.model.items[itemIndex].position.x = value.x;
                this.model.items[itemIndex].position.y = value.y;
                this._initialize();
            }
        },


          

        getPosition: function (itemIndex) {
            if (itemIndex < this.model.items.length)
                return { "x": this.model.items[itemIndex].position.x, "y": this.model.items[itemIndex].position.y };
            else
                return null;
        },

          
        refresh: function () {
            this._setTheme();
            this._initialize();
        },

          
        exportImage: function (fileName, fileType) {
            /// <summary>This function save the rendered canvas image</summary>
            /// <param name="fileName" type="String">fileName to which the image has been saved</param>
            /// <param name="fileType" type="String">fileType to which the image has been saved</param>
            if (ej.browserInfo().name === "msie" && parseFloat(ej.browserInfo().version) < 10) {
                return false;
            }
            else {
                var image = this.canvasEl[0].toDataURL();
                image = image.replace(/^data:[a-z]*;,/, '');
                var image1 = image.split(',');
                var byteString = atob(image1[1]);
                var buffer = new ArrayBuffer(byteString.length);
                var intArray = new Uint8Array(buffer);
                for (var i = 0; i < byteString.length; i++) {
                    intArray[i] = byteString.charCodeAt(i);
                }
                var blob = new Blob([buffer], { type: "image/png" });
                if (ej.browserInfo().name === "msie")
                    window.navigator.msSaveOrOpenBlob(blob, fileName + '.' + fileType);
                else {
                    var pom = document.createElement('a');
                    var url = URL.createObjectURL(blob);
                    pom.href = url;
                    pom.setAttribute('download', fileName + '.' + fileType);
                    if (document.createEvent) {
                        var e = document.createEvent("MouseEvents");
                        e.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
                        pom.dispatchEvent(e);
                    }
                    else if (pom.fireEvent) {
                        pom.fireEvent("onclick");
                    }
                }
                return true;
            }
        },

      
        resizeCanvas: function () {
            if (_digitalGaugeCount != 0)
                _digitalGaugeCount = _digitalGaugeCount - 1;
            else
                _digitalGaugeCount = $(".e-digitalgauge").length - 1; var state, chk = true;
            if (!ej.isNullOrUndefined(this.canvasEl.parent().attr("style")))
                state = this.GaugeEl.parent().attr("style").split(";");
            if (!ej.isNullOrUndefined(state)) {
                $.each(state, function (key, val) {
                    while (val.indexOf("width") != -1) {
                        chk = val.indexOf("px") == -1 ? true : false;
                        break;
                    }
                });
            }
            if (chk) {
                var ratio = window.innerWidth / initialDigitalDivWidth;
                this.model.width *= ratio;
                for (var i = 0; this.model.items[i] != null; i++) {
                    this.model.items[i].segmentSettings.width *= ratio;
                    this.model.items[i].segmentSettings.length *= ratio;
                    this.model.items[i].segmentSettings.spacing *= ratio;
                    this.model.items[i].characterSettings.spacing *= ratio;
                }
                this.refresh();
                if (_digitalGaugeCount == 0) {
                    initialDigitalDivWidth = window.innerWidth;
                }
            }
        },

          
          
        _clientSideOnLoad: function () {
            var data = { object: this, items: this.model.items, context: this.contextEl };
            this._trigger("load", data);
        },

          
        _clientSideOnItemRendering: function (isMatrix, row, column) {
            var data;
            if (isMatrix)
                data = { object: this, items: this.model.items, character: this.character, context: this.contextEl, position: this.region, style: this.style, row: row, column: column };
            else
                data = { object: this, model: this.model, id: this.model.ClientId, items: this.model.items, character: this.character, context: this.contextEl, position: this.region, style: this.style, segment: row };
            this._trigger("itemRendering", data);
        },

          
        _clientSideOnInit: function () {
            var data = { object: this, items: this.model.items, context: this.contextEl };
            this._trigger("init", data);
        },

          
        _clientSideOnRenderComplete: function () {
            var data = { object: this, items: this.model.items, context: this.contextEl };
            this._trigger("renderComplete", data);
        },


          
          
        _contextOpenPath: function (style, element) {
            element.contextEl.save();
            element.contextEl.beginPath();
            if (style.strokeStyle)
                element.contextEl.strokeStyle = style.strokeStyle;
            if (style.opacity != undefined)
                element.contextEl.globalAlpha = style.opacity;
            if (style.lineWidth)
                element.contextEl.lineWidth = style.lineWidth;
            if (style.fillStyle)
                element.contextEl.fillStyle = style.fillStyle;
        },

          
        _contextClosePath: function (style, element) {
            element.contextEl.closePath();
            if (style.isFill)
                element.contextEl.fill();
            if (style.isStroke)
                element.contextEl.stroke();
            element.contextEl.restore();
        },

          
        _measureText: function (text, maxwidth, font) {
            var textObj = document.createElement('DIV');
            textObj.innerHTML = text;
            if (font != null)
                textObj.style.font = font;
            textObj.style.backgroundColor = 'white';
            textObj.style.position = 'absolute';
            textObj.style.top = -100;
            textObj.style.left = 0;
            if (maxwidth)
                textObj.style.maxwidth = maxwidth + "px";
            document.body.appendChild(textObj);
            var bounds = { width: textObj.offsetWidth, height: textObj.offsetHeight };
            $(textObj).remove();
            return bounds;
        }

    });

      
    ej.datavisualization.DigitalGauge.CharacterType = {
          
        SevenSegment: "sevensegment",
          
        FourteenSegment: "fourteensegment",
          
        SixteenSegment: "sixteensegment",
          
        EightCrossEightDotMatrix: "eightcrosseightdotmatrix",
          
        EightCrossEightSquareMatrix: "eightcrosseightsquarematrix"
    };
      
    ej.datavisualization.DigitalGauge.TextAlign = {
          
        Left: "left",
          
        Right: "right"
    };

      
    ej.datavisualization.DigitalGauge.FontStyle = {
          
        Normal: "normal",
          
        Bold: "bold",
          
        Italic: "italic",
          
        Underline: "underline",
          
        Strikeout: "strikeout"
    };

      
    ej.datavisualization.DigitalGauge.Themes = {
         FlatLight: 'flatlight',

		FlatDark: 'flatdark'
    };		
       
  

})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.s
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
  
    ej.widget("ejBulletGraph", "ej.datavisualization.BulletGraph",    {
    
        element: null,

        model: null,
        validTags: ["div"],
    
        _tags: [{
            tag: 'qualitativeRanges',
            attr: ['rangeEnd', 'rangeStroke', 'rangeOpacity']
        },
        {
            tag: 'quantitativeScaleSettings.featureMeasures',
            attr: ['value', 'comparativeMeasureValue']
        }],
    
        defaults:   {
              
            locale: null,
			
			enableGroupSeparator: false,
			
			value: 0,
              
            comparativeMeasureValue: 0,
              
            width: null,
              
            height: null,
              
            theme: "flatlight",
              
            orientation: "horizontal",
              
            flowDirection: "forward",
              
            qualitativeRangeSize: 32,
              
            quantitativeScaleLength: 475,
              
            tooltipSettings:   {
                  
                  
                enableCaptionTooltip: false,
                  
                captionTemplate: null,
                  
                visible: true,
                  
                template: null
            },
              
            quantitativeScaleSettings:    {
                  
                location: {
                      
                    x: 10,
                      
                    y: 10
                },
                  
                minimum: 0,
                  
                maximum: 10,
                  
                interval: 1,
                  
                minorTicksPerInterval: 4,
                  
                majorTickSettings: {
                      
                    size: 13,
                      
                    stroke: null,
                      
                    width: 2
                },
                  
                minorTickSettings: {
                      
					size: 7,
                 
                    stroke: null,
                      
                    width: 2
                },
                  
                tickPosition: "far",
                  
                tickPlacement: "outside",
                  
                labelSettings: {
                      
                    labelPlacement: "outside",
                      
                    labelPrefix: "",
                      
                    labelSuffix: "",
                      
                    stroke: null,
                      
                    size: 12,
                      
                    offset: 15,
                      
                    font: {
                          
                        fontFamily: 'Segoe UI',
                          
                        fontStyle: 'Normal ',
                          
                        fontWeight: 'regular',
                          
                        opacity: 1
                    },
                      
                    position: "below"
                },
                  
                featuredMeasureSettings: {
                      

                    stroke: null,
                      
                    width: 6
                },
                  
                comparativeMeasureSettings: {
                      
                    stroke: null,
                      
                    width: 5
                },
                  
                featureMeasures: [{
                      
                    value: null,
                      
                    comparativeMeasureValue: null,
                      
                    category: null
                }]
            },
              
            fields: {
                  
                dataSource: null,
                  
                query: null,
                  
                tableName: null,
                  
                category: null,
                  
                featureMeasures: null,
                  
                comparativeMeasure: null
            },
              
            enableAnimation: true,
              
            enableResizing: true,
              
            isResponsive: true,
              
            applyRangeStrokeToTicks: false,
              
            applyRangeStrokeToLabels: false,
              
            qualitativeRanges: [{
                  
                rangeEnd: 4.3,
                  
                rangeStroke: null,
                  
                rangeOpacity: 1
            }, {
                  
                rangeEnd: 7.3,
                  
                rangeStroke: null,
                  
                rangeOpacity: 1
            }, {
                  
                rangeEnd: 10,
                  
                rangeStroke: null,
                  
                rangeOpacity: 1
            }],
              
            captionSettings: {
                  
                enableTrim: true,
                  
                textPosition: 'float',
                  
                textAlignment: 'Near',
                  
                textAnchor: 'start',
                  
                padding: 5,
                  
                textAngle: 0,
                  
                location: {
                      
                    x: 17,
                      
                    y: 30
                },
                  
                text: "",
                  
                font: {
                      
                    color: null,
                      
                    fontFamily: 'Segoe UI',
                      
                    fontStyle: 'Normal',
                      
                    size: '12px',
                      
                    fontWeight: 'regular',
                      
                    opacity: 1
                },
                  
                subTitle: {
                      
               textPosition: 'float',
                 
               textAlignment: 'Near',
                 
               textAnchor: 'start',
                 
                    padding: 5,
                      
                    textAngle: 0,
                      
                    text: "",
                      
                    location: {
                          
                        x: 10,
                          
                        y: 45
                    },
                      
                    font: {
                          
                        color: null,                          
                        
                        fontFamily: 'Segoe UI',
                          
                        
                        fontStyle: 'Normal ',                          
                        
                        size: '12px',
                          
                        fontWeight: 'regular',
                          
                        opacity: 1
                    }
                },

                  
                indicator: {
                      
                    textPosition: 'float',
                      
                    textAlignment: 'Near',
                      
                    textAnchor: 'start',
                      
                    padding:5,
                      
                    visible: false,
                      
                    textAngle: 0,
                      
                    textSpacing: 3,
                      
                    text: "",                    
                      
                    symbol: {
                          
                        border: {
                              
                            color: null,
                              
                            width: 1,
                        },
                          
                        color: null,
                          
                        shape: "",
                          
                        imageURL: "",
                          
                        size: {
                              
                            width: 10,
                              
                            height: 10
                        },
                          
                        opacity: 1
                    },
                      
                    location: {
                          
                        x: 10,
                          
                        y: 60
                    },
                      
                    font: {
                          
                        color: null,
                          

                        fontFamily: 'Segoe UI',
                          

                        fontStyle: 'Normal ',
                          

                        size: '12px',
                          
                        fontWeight: 'regular',
                          
                        opacity: 1
                    }
                }
            },

              
              
            load: '',
              
            drawTicks: null,
              
            drawLabels: null,
              
            drawCaption: null,
              
            drawIndicator: null,
              
            drawQualitativeRanges: null,
              
            drawFeatureMeasureBar: null,
              
            drawCategory: null,
              
            drawComparativeMeasureSymbol: null
        },

        observables: ["value", "comparativeMeasureValue"],
        value: ej.util.valueFunction("value"),
        comparativeMeasureValue: ej.util.valueFunction("comparativeMeasureValue"),
          
        dataTypes: {
            quantitativeScaleSettings: {
                labelSettings: "data",
                featureMeasures: "array"
            },
            fields: { dataSource: "data", query: "data" },
            qualitativeRanges: "array",
            captionSettings: "data",
            isResponsive: "boolean",
        },

        // constructor function
          
        _init: function () {
            this._renderBulletGraph();
        },
          
        _isSVG: function () {
            if (window.SVGSVGElement)
                return true;
            else
                return false;
        },
          
        _value: ej.util.valueFunction("value"),
        _comparativeMeasureValue: ej.util.valueFunction("comparativeMeasureValue"),
          
        _qualitativeRanges: function (index, property, value, old) {
            this.redraw();
            this._trigger('refresh');
        },
          
        _quantitativeScaleSettings_featureMeasures: function (index, property, value, old) {
            this.redraw();
            this._trigger('refresh');
        },
          
        _renderBulletGraph: function () {
            if (this._isSVG()) {
                this.svgRenderer = new ej.EjSvgRender(this.element);
                this.svgObject = this.svgRenderer.svgObj;
                this._trigger("load");
                this._setSvgSize(this);
                this._setTheme(ej.datavisualization.BulletGraph.Themes, this.model.theme);
                this.bindEvents();
                this._renderBulletElements();               
                if (this.model.enableAnimation)
                    this._animateMeasures();
            }
        },
          
        _animateMeasures: function () {
            this._doAnimation();
            this._doLineAnimation();
        },

        _setSvgSize: function (sender) {
            var chartObj = sender;
            var containerHeight = $(chartObj.element).height();
            var height = 90; //set default height if size not specified to chart or container
            var width = (ej.isTouchDevice()) ? 250 : 595;
            var containerWidth = $(chartObj.element).width();
            if (chartObj.model.width)
                width = parseInt(chartObj.model.width);
            else if (containerWidth > 0 && containerWidth < 595)
                width = containerWidth;
            else if(containerWidth > 595)
                width = 595;

            $(chartObj.svgObject).width(width);

            if (chartObj.model.height)
                height = parseInt(chartObj.model.height);
            else if (containerHeight > 0)
                height = containerHeight;
            else
                $(chartObj.svgObject).css("display", "block");
            $(chartObj.svgObject).height(height);

            chartObj.svgObject.width = width;   
            chartObj.svgObject.height = height;
        },
        _renderBulletElements: function () {
            var width = this.model.width ? this.model.width : 595;
            var height = this.model.height ? this.model.height : 90;
            this.svgObject.setAttribute('viewBox', "0 0 " + width + " " + height);
            this.svgObject.setAttribute('preserveAspectRatio', "xMinYMin");
            this.svgWidth = $(this.svgObject).width();
            this.svgHeight = $(this.svgObject).height();
            var captionGroup = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_captionGroup' });
            var scaleGroup = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_scaleGroup' });
            var bulletGroup = this.svgRenderer.createGroup({ 'id': this.svgObject.id + '_outerWrap' });

            this._initializeValues();
            var intervalValue = ((this.model.quantitativeScaleLength) / ((this._scale.maximum - this._scale.minimum) / this._scale.interval));

            //render captionSettings
            this._drawCaption();

            //render indicator
            this._drawIndicator();

            //render caption group
            this._drawCaptionGroup(captionGroup);

            //render scale
            this._scaleGroup = scaleGroup;
            this._drawScale(captionGroup, scaleGroup);

            //draw ranges
            this._drawQualitativeRanges(scaleGroup);

            //render ticks
            this._drawMajorTicks(intervalValue, scaleGroup);
            this._drawMinorTicks(intervalValue, scaleGroup);

            //render labels
            this._drawLabels(intervalValue, scaleGroup);

            // data binding
            this._bindData();
                        
            $(scaleGroup).appendTo(bulletGroup);
            $(captionGroup).appendTo(bulletGroup);

            this._changeOrientation(scaleGroup);

            $(bulletGroup).appendTo(this.svgObject);
            $(this.svgObject).appendTo(this.element);

            this._bindHighlightRemoving(); // binding highlight style removing function for feature measure bars
            
        },

        _bindHighlightRemoving:function(){
            var isPointer = this.model.browserInfo.isMSPointerEnabled,
            isIE11Pointer = this.model.browserInfo.pointerEnabled;
            touchStartOut = isPointer ? (isIE11Pointer ? "pointerout" : "MSPointerOut") : "touchout mouseout",
            this._on($("[id*=" + this.svgObject.id + "_FeatureMeasure_" + "]"), touchStartOut, function (evt) {
                if (!this.isTouch(evt))
                    $(evt.target).attr("opacity", 1);
            });
        },
      
        _drawCaptionGroup: function (captionGroup) {
            var caption = this.model.captionSettings;
            var subTitle = caption.subTitle;
            var indicator = (this._indicator ? this._indicator.settings : caption.indicator);
            var location;

            caption._location = subTitle._location = indicator._location = location;

            var smartCaptionPlacement = (caption.textPosition.toLowerCase()!='float' && caption.text!="");
            var smartSubTitlePlacement = (subTitle.textPosition.toLowerCase() != 'float' && subTitle.text != "");
            var smartIndicatorPlacement = indicator.visible && (indicator.textPosition.toLowerCase() != 'float');

            if (smartCaptionPlacement || smartSubTitlePlacement || smartIndicatorPlacement) {                

                var captionSize = ej.EjSvgRender.utils._measureText(caption.text, null, caption.font);
                var subTitleSize = ej.EjSvgRender.utils._measureText(subTitle.text, null, subTitle.font);
                var indicatorTextSize;
                var indicatorRegion;
                if (indicator.visible) {                    
                    indicatorTextSize = this._indicator.bounds;
                    var indicatorSize = {
                        width: indicator.symbol.size.width + indicatorTextSize.width + indicator.textSpacing,
                        height: Math.max(indicator.symbol.size.height, indicatorTextSize.height)
                    }
                    indicatorRegion = {
                        x: 0,
                        y: 0,
                        width: indicatorSize.width,
                        height: indicatorSize.height,
                        padding: indicator.padding,
                        anchor: indicator.textAnchor.toLowerCase(),
                        alignment: indicator.textAlignment.toLowerCase()
                    };
                }

                var captionRegion = { 
                    x: 0, 
                    y: 0, 
                    width: captionSize.width,                    
                    height: parseFloat(caption.font.size),
                    padding: caption.padding,
                    anchor: caption.textAnchor.toLowerCase(),
                    alignment: caption.textAlignment.toLowerCase()
                };
                var subTitleRegion = {
                    x: 0,
                    y: 0,
                    width: subTitleSize.width,
                    height: parseFloat(subTitle.font.size),
                    padding: subTitle.padding,
                    anchor: subTitle.textAnchor.toLowerCase(),
                    alignment: subTitle.textAlignment.toLowerCase()
                };
                
                var scaleRegion = { x: this._scale.location.x, y: this._scale.location.y, width: this.model.quantitativeScaleLength, height: this.model.qualitativeRangeSize };
                var elements= [ smartCaptionPlacement ?caption : null, smartSubTitlePlacement ? subTitle : null, smartIndicatorPlacement ? indicator : null];

                this._positionTextGroup(elements, [captionRegion, subTitleRegion, indicatorRegion], scaleRegion);
                this._locateTextGroup(elements, [captionRegion, subTitleRegion, indicatorRegion]);
            }
            var captionLocation = caption._location == undefined ? caption.location : caption._location;
            var subTitleLocation = subTitle._location == undefined ? subTitle.location : subTitle._location;
            var indicatorLocation = indicator._location == undefined ? indicator.location : indicator._location;

            caption.displayText = caption.text;
            if (caption.enableTrim == true) {
                captionLocation.x = captionLocation.x < 0 ? 0 : captionLocation.x;
                captionLocation.y = captionLocation.y < 0 ? 0 : captionLocation.y;
                caption.displayText = this._displayText(caption, captionLocation);
            }
            if (subTitle.text != "") {
                subTitle.displayText = subTitle.text;
                if (caption.enableTrim == true) {
                    subTitleLocation.x = subTitleLocation.x < 0 ? 0 : subTitleLocation.x;
                    subTitleLocation.y = subTitleLocation.y < 0 ? 0 : subTitleLocation.y;
                    subTitle.displayText = this._displayText(subTitle, subTitleLocation);
                }
            }
            if (indicator.visible) {
                indicator.displayText = indicator.text;
                if (this.model.captionSettings.enableTrim == true) {
                    indicatorLocation.x = indicatorLocation.x < 0 ? 0 : indicatorLocation.x;
                    indicatorLocation.y = indicatorLocation.y < 0 ? 0 : indicatorLocation.y;
                }
                var location = (indicator._location ? indicator._location : indicator.location);
                var symbolRect = {
                    'x': location.x + indicator.symbol.size.width / 2,
                    'y': location.y - indicator.symbol.size.height / 2,
                    'width': indicator.symbol.size.width,
                    'height': indicator.symbol.size.height,
                };
                var textOptions = this._indicatorTextOptions(indicator, symbolRect, this._indicator.bounds, this.svgObject.id + '_Indicator');
                var symbolOptions = this._indicatorSymbolOptions(captionGroup, indicator);
                this._drawBulletSymbol(this._indicator.settings.symbol.shape, symbolRect, symbolOptions, captionGroup);
                if (this.model.captionSettings.enableTrim == true)
                    indicator.displayText = this._displayText(indicator, symbolRect);
            }
            caption.displayText = caption.textPosition.toLowerCase() != "float" ? this._captionOverlap(this.model.captionSettings) : caption.displayText;
            this.svgRenderer.drawText(this._textOptions(caption, this.svgObject.id + '_Caption'), caption.displayText, captionGroup);
            if (subTitle.text != ""){
                subTitle.displayText = subTitle.textPosition.toLowerCase() != "float" ? this._subOverlap(this.model.captionSettings.subTitle) : subTitle.displayText;
                this.svgRenderer.drawText(this._textOptions(subTitle, this.svgObject.id + '_SubTitle'), subTitle.displayText, captionGroup);
            }   
            if (indicator.visible) {
                indicator.displayText = indicator.textPosition.toLowerCase() != "float" ? this._indOverlap(indicator,symbolRect) : indicator.displayText;
                this.svgRenderer.drawText(textOptions, indicator.displayText, captionGroup);
            }
        },
        // text overlap method is perform herer for caption , subtitle and indicator when position is except float
       _captionOverlap: function (settings) {
                var gap;
                if ((settings.textPosition == settings.subTitle.textPosition) && (settings.textAlignment == settings.subTitle.textAlignment) && settings.textAngle > 0 && settings.textAngle < 120 ) {
                    gap = settings.subTitle._location.y - settings._location.y;
                }
                else if ((settings.textPosition == settings.indicator.textPosition) && (settings.textAlignment == settings.indicator.textAlignment) && settings.textAngle > 0 && settings.textAngle < 120 ){
                    gap = settings.indicator._location.y - settings._location.y;
                }
                else{
                   if ((settings.textPosition == settings.subTitle.textPosition) && (settings._location.y < settings.subTitle._location.y) && settings.textAngle > 0 && settings.textAngle < 180 ){
                       gap = settings.subTitle._location.y - settings._location.y;
                   }
                   else if ((settings.textPosition == settings.subTitle.textPosition) && (settings._location.y > settings.subTitle._location.y) && settings.textAngle > 190 && settings.textAngle < 360     ){
                        gap = settings._location.y - settings.subTitle._location.y;
                   }
                   else if ((settings.textPosition == settings.indicator.textPosition) && (settings._location.y < settings.indicator._location.y) && settings.textAngle > 0 && settings.textAngle < 180 ){
                       gap = settings.indicator._location.y - settings._location.y;
                   }
                   else if ((settings.textPosition == settings.indicator.textPosition) && (settings._location.y > settings.indicator._location.y) && settings.textAngle > 190 && settings.textAngle < 360    ){
                        gap = settings._location.y - settings.indicator._location.y;
                   }
                }
                 var text = this._trim(settings.displayText,settings,gap,isRotate = true);           
            return text;             
        },
        _indOverlap: function (settings,loc) {
            var gap;
            var subTitle = this.model.captionSettings.subTitle;
            var title = this.model.captionSettings;
             if ((settings.textPosition == subTitle.textPosition) && (settings.textAlignment == subTitle.textAlignment) && settings.textAngle > 190 && settings.textAngle < 360 ) {
                    gap = loc.y - subTitle._location.y;
                }
                else if ((settings.textPosition == title.textPosition) && (settings.textAlignment ==title.textAlignment) && settings.textAngle > 190 && settings.textAngle < 360 ){
                    gap = loc.y - title._location.y;
                }
                else{
                   if ((settings.textPosition == subTitle.textPosition) && (settings._location.y < subTitle._location.y) && settings.textAngle > 0 && settings.textAngle < 180 ){
                       gap = subTitle._location.y - settings._location.y;
                   }
                   else if ((settings.textPosition == subTitle.textPosition) && (settings._location.y > subTitle._location.y) && settings.textAngle > 190 && settings.textAngle < 360     ){
                        gap = settings._location.y - subTitle._location.y;
                   }
                   else if ((settings.textPosition == title.textPosition) && (settings._location.y < title._location.y) && settings.textAngle > 0 && settings.textAngle < 180 ){
                       gap = title._location.y - settings._location.y;
                   }
                   else if ((settings.textPosition == title.textPosition) && (settings._location.y > title._location.y) && settings.textAngle > 190 && settings.textAngle < 360    ){
                        gap = settings._location.y - title._location.y;
                   }
                }
                 var text = this._trim(settings.displayText,settings,gap,isRotate = true);           
            return text;             
        },
        _subOverlap: function (settings) {
            var gap;
            var indicator = this.model.captionSettings.indicator;
            var title = this.model.captionSettings;
             if ((settings.textPosition == indicator.textPosition) && (settings.textAlignment == indicator.textAlignment) && settings.textAngle > 0 && settings.textAngle < 180 ) {
                    gap = indicator._location.y - settings._location.y;
                }
                else if ((settings.textPosition == title.textPosition) && (settings.textAlignment ==title.textAlignment) && settings.textAngle > 190 && settings.textAngle < 360 ){
                    gap = settings._location.y - title._location.y;
                }
                else{
                   if ((settings.textPosition == indicator.textPosition) && (settings._location.y < indicator._location.y) && settings.textAngle > 0 && settings.textAngle < 180 ){
                       gap = indicator._location.y - settings._location.y;
                   }
                   else if ((settings.textPosition == indicator.textPosition) && (settings._location.y > indicator._location.y) && settings.textAngle > 190 && settings.textAngle < 360     ){
                        gap = settings._location.y - indicator._location.y;
                   }
                   else if ((settings.textPosition == title.textPosition) && (settings._location.y < title._location.y) && settings.textAngle > 0 && settings.textAngle < 180 ){
                       gap = title._location.y - settings._location.y;
                   }
                   else if ((settings.textPosition == title.textPosition) && (settings._location.y > title._location.y) && settings.textAngle > 190 && settings.textAngle < 360    ){
                        gap = settings._location.y - title._location.y;
                   }
                }
                 var text = this._trim(settings.displayText,settings,gap,isRotate = true);           
            return text;             
        },
        // rotated label width calculated here
        rotatedLabel: function (font, sender, value, rotatedLabel) {
            var rotatedOptions = {
                'font-size': font.size,
                'transform': 'rotate(' + value + ',0,0)',
                'font-family': font.fontFamily,
                'font-style': font.fontStyle,
                'rotateAngle': 'rotate(' + value + 'deg)',
                'text-anchor': 'middle'
            };
            var text = sender.svgRenderer.createText(rotatedOptions, rotatedLabel);
            var width = Math.ceil((ej.EjSvgRender.utils._measureBounds(text, sender).width));
            return width;
        },
        // Trim size calculated here
        calcGap: function (angle, location, maxWidth, maxHeight, isRotate, Width, Height) {
            var trimSize, space, rotate;
            if (angle >= 0 && angle <= 90) {

                if (((maxHeight + location.y) >= Height)&& angle > 0) {
                    space = Height - location.y;
                    isRotate = true;
                }
                else if (((maxHeight + location.y) <= Height) && ((maxWidth + location.x) >= Width) && angle > 0) {
                    space = Width - location.x;
                }
                else {
                    if (((maxHeight + location.y) <= Height) && (angle > 0)) {
                        space = Height - location.y;
                        isRotate = true;
                    }
                    else
                        space = Width - location.x;
                }
            }
            else if (angle > 90 && angle < 180) {

                if (((maxHeight + location.y) >= Height)) {
                    space = Height - location.y;
                    isRotate = true;
                }
                else if (((maxHeight + location.y) <= Height) && ((maxWidth + location.x) >= Width)) {
                    space = location.x;
                }
                else {
                    if ((maxWidth + location.x) <= Width) {
                        space = location.x;
                    }
                    else {
                        space = Height - location.y;
                        isRotate = true;
                    }

                }
            }
            else if (angle >= 180 && angle < 270) {

                if ((location.x - maxWidth) >= 0) {
                    space = location.y;
                    isRotate = true;
                }
                else if (((location.y - maxHeight) <= 0) && ((location.x - maxWidth) <= 0)) {
                    space = location.x;
                }
                else {
                    if ((location.y - maxHeight) <= 0) {
                        space = Height - location.y;
                        isRotate = true;
                    }
                    else {
                        space = location.x;
                    }
                }

            }
            else {
                if ((maxWidth + location.x) <= Width) {
                    space = location.y;
                    isRotate = true;
                }
                else if (((location.y - maxHeight) >= 0) && ((maxWidth + location.x) >= Width)) {
                    space = Width - location.x;
                }
                else {
                    if ((maxWidth + location.x) >= Width) {
                        space = Width - location.x;
                    }
                    else {
                        space = location.y;
                        isRotate = true;
                    }
                }
            }

            return { trimSize: space, rotate: isRotate };
        },
        // Scale Location calculated here
        _scaleLoc: function () {
            var scale = this._scale;
            var offset = scale.labelSettings.offset;
            var tickSize = scale.majorTickSettings.size;
            var pointY, pointHeight;
            var label = this._scale.labelSettings;
            var labelBounds = ej.EjSvgRender.utils._measureText(label.labelPrefix + scale.maximum + label.labelSuffix, null, label);
            var labelSize = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal) ? labelBounds.height : labelBounds.width;            
            pointY = scale.location.y;
            var qualitativeRangeSize = this.model.qualitativeRangeSize;
            var placement = this._tickPosition + this._tickPlacement + this._labelPosition + this._labelPlacement;
            if (this._tickPosition == "center")
                tickSize = (tickSize > qualitativeRangeSize) && ((tickSize - qualitativeRangeSize) / 2);
            switch (placement) {
                case 'faroutsidebelowoutside':
                    pointHeight = pointY + labelSize + qualitativeRangeSize + offset + ((tickSize > offset) && (tickSize - offset));
                    break;
                case 'faroutsidebelowinside':
                    pointHeight = pointY + tickSize + qualitativeRangeSize 
                    pointY = pointY - (((offset + labelSize) > qualitativeRangeSize) && ((offset + labelSize) - qualitativeRangeSize));
                    break;
                case 'faroutsideaboveoutside':
                    pointHeight = pointY + tickSize + qualitativeRangeSize;
                    pointY = pointY - (offset + labelSize)
                    break;
                case 'faroutsideaboveinside':
                    pointHeight = pointY + tickSize + qualitativeRangeSize + (((offset + labelSize) > (qualitativeRangeSize + tickSize)) ? ((offset + labelSize) - (qualitativeRangeSize + tickSize)) : 0 );
                    break;
                case 'farinsidebelowoutside':
                    pointHeight = pointY + labelSize + qualitativeRangeSize + offset;
                    pointY = pointY - ((tickSize > qualitativeRangeSize) && (tickSize - qualitativeRangeSize));
                    break;
                case 'farinsidebelowinside':
                    pointHeight = pointY + qualitativeRangeSize;
                    pointY = pointY - ((tickSize > qualitativeRangeSize) && (tickSize -qualitativeRangeSize)) - (((offset + labelSize) > (qualitativeRangeSize + tickSize)) && (offset + labelSize - tickSize)) 
                    break;
                case 'farinsideaboveoutside':
                    pointHeight = pointY + qualitativeRangeSize;
                    pointY = pointY - (offset + labelSize) - ((tickSize > (offset + labelSize + qualitativeRangeSize)) && (tickSize - (offset + labelSize + qualitativeRangeSize)));
                    break;
                case 'farinsideaboveinside':
                    pointHeight = pointY + qualitativeRangeSize + (((offset + labelSize) > qualitativeRangeSize) && (labelSize + offset - qualitativeRangeSize));
                    pointY = pointY - ((tickSize > qualitativeRangeSize) && (tickSize - qualitativeRangeSize));
                    break;
                case 'nearoutsidebelowoutside':
                    pointHeight = pointY + qualitativeRangeSize + offset + labelSize;
                    pointY = pointY - tickSize;
                    break;
                case 'nearoutsidebelowinside':
                    pointHeight = pointY + qualitativeRangeSize;
                    pointY = pointY - tickSize - (((offset + labelSize) > (qualitativeRangeSize + tickSize)) && ((offset + labelSize) - (qualitativeRangeSize + tickSize)));
                    break;
                case 'nearoutsideaboveoutside':
                    pointHeight = pointY + qualitativeRangeSize;
                    pointY = pointY - tickSize - ((tickSize < (offset + labelSize)) && (offset + labelSize - tickSize));
                    break;
                case 'nearoutsideaboveinside':
                    pointHeight = pointY + qualitativeRangeSize + (((offset + labelSize) > qualitativeRangeSize) && (offset + labelSize - qualitativeRangeSize));
                    pointY = pointY - tickSize;
                    break;
                case 'nearinsidebelowoutside':
                    pointHeight = pointY + qualitativeRangeSize + ((tickSize > (offset + labelSize + qualitativeRangeSize)) ? (tickSize - (qualitativeRangeSize)) : (offset + labelSize));
                    break;
                case 'nearinsidebelowinside':
                    pointHeight = pointY + qualitativeRangeSize + ((tickSize > qualitativeRangeSize) && (tickSize - qualitativeRangeSize));
                    pointY = pointY - (((offset + labelSize) > qualitativeRangeSize) && (offset + labelSize - qualitativeRangeSize));
                    break;
                case 'nearinsideaboveoutside':
                    pointHeight = pointY + ((tickSize > qualitativeRangeSize) ? tickSize : qualitativeRangeSize);
                    pointY = pointY - offset - labelSize;
                    break;
                case 'nearinsideaboveinside':
                    pointHeight = pointY + qualitativeRangeSize + ((tickSize > (labelSize + offset)) ? (tickSize - qualitativeRangeSize) : (labelSize + offset - qualitativeRangeSize));
                    break;
                case 'centeroutsidebelowoutside':
                    pointHeight = pointY + qualitativeRangeSize + ((tickSize > offset + labelSize) ? tickSize : offset + labelSize);
                    pointY = pointY - tickSize;
                    break;
                case 'centeroutsidebelowinside':
                    pointHeight = pointY + qualitativeRangeSize + tickSize;
                    pointY = pointY - tickSize - (((offset + labelSize) > (qualitativeRangeSize + tickSize)) && ((offset + labelSize) - (qualitativeRangeSize + tickSize)));
                    break;
                case 'centeroutsideaboveoutside':
                    pointHeight = pointY + qualitativeRangeSize + tickSize;
                    pointY = pointY - tickSize - ((tickSize < (offset + labelSize)) && (offset + labelSize - tickSize));
                    break;
                case 'centeroutsideaboveinside':
                    pointHeight = pointY + qualitativeRangeSize + (((offset + labelSize) > (qualitativeRangeSize + tickSize)) ? (offset + labelSize - qualitativeRangeSize - tickSize) : tickSize);
                    pointY = pointY - tickSize;
                    break;
                case 'centerinsidebelowoutside':
                    pointHeight = pointY + qualitativeRangeSize + ((tickSize > (offset + labelSize)) ? tickSize : (offset + labelSize));
                    pointY = pointY - tickSize;
                    break;
                case 'centerinsidebelowinside':
                    pointHeight = pointY + qualitativeRangeSize + tickSize;
                    pointY = pointY -  (((offset + labelSize - qualitativeRangeSize) > tickSize ) ? (offset + labelSize - qualitativeRangeSize) : tickSize);
                    break;
                case 'centerinsideaboveoutside':
                    pointHeight = pointY + qualitativeRangeSize + tickSize;
                    pointY = pointY - tickSize - ((tickSize < (offset + labelSize)) && (offset + labelSize - tickSize));
                    break;
                case 'centerinsideaboveinside':
                    pointHeight = pointY + qualitativeRangeSize + ((tickSize > (labelSize + offset)) ? tickSize : (labelSize + offset - qualitativeRangeSize));
                    pointY = pointY - tickSize;
                    break;
            }
            return {x: scale.location.x, y: pointY, height:pointHeight };

        },
        // display text method for trimming
        _displayText: function (settings, loc) {
             var location = $.extend(true, loc);
            var angle = settings.textAngle % 360;
            var text = settings.text;
            var font = settings.font;
            var scale = this._scale;
            var label = this._scale.labelSettings;
            var labelWidth = ej.EjSvgRender.utils._measureText(label.labelPrefix + scale.minimum + label.labelSuffix, null, label).width;
            var textWidth = ej.EjSvgRender.utils._measureText(text, null, font).width;
            var maxHeight = ej.EjSvgRender.utils.rotatedLabel(settings, this, angle, settings.text);
            var maxWidth = this.rotatedLabel(font, this, angle, settings.text);
            var gap, padding = 5;
            var height =this.svgHeight;
            var width = this.svgWidth;
            var isRotate = false;
            var scaleLocation = this._scaleLoc();
            if (settings.textSpacing) {
                textWidth = textWidth + settings.textSpacing;
                maxWidth = maxWidth + settings.textSpacing;
            }

            if (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal) {

               if ((location.x <= scaleLocation.x) && (scaleLocation.y <= location.y) && (location.y <= scaleLocation.height)) {
                    width = (scale.location.x - labelWidth / 2);
               }
               else if ((location.x <= scaleLocation.x) && (location.y <= scaleLocation.y) && (angle < 90)) {
                    height = scaleLocation.y;
               }
               else if ((location.x >= scaleLocation.x) && (location.x <= (scaleLocation.x + this.model.quantitativeScaleLength)) && (location.y <= scaleLocation.y)) {
                    height = scaleLocation.y;
               }
               else if ((location.y <= scaleLocation.y) && (location.x >= (scaleLocation.x + this.model.quantitativeScaleLength)) && (angle >= 90)) {
                    height = scaleLocation.y;
               }

               else if ((location.x >= (scaleLocation.x + this.model.quantitativeScaleLength)) && (scaleLocation.y <= location.y) && (location.y <= scaleLocation.height) && (angle < 270)) {
                    width = width - (scaleLocation.x + this.model.quantitativeScaleLength);
                    location.x = location.x - (scaleLocation.x + this.model.quantitativeScaleLength);
               }
               else if ((location.x <= scaleLocation.x) && (location.y >= scaleLocation.height) && (angle > 270)) {
                    location.y = location.y - scaleLocation.height;
               }
               else if ((location.x >= scaleLocation.x) && (location.x <= (scaleLocation.x + this.model.quantitativeScaleLength)) && (location.y >= scaleLocation.height)) {
                    location.y = location.y - scaleLocation.height;
               }
               else if ((location.x >= (scaleLocation.x + this.model.quantitativeScaleLength)) && (location.y >= scaleLocation.height) && (angle >= 180) && (angle < 270)) {
                    location.y = location.y - scaleLocation.height;
               }

               gap = this.calcGap(angle, location, maxWidth, maxHeight, isRotate, width, height);
               isRotate = gap.rotate;
               gap = gap.trimSize;
            }
            else {
                var scaleWidth = scaleLocation.height - scaleLocation.y;
                scaleLocation.y =this.svgHeight - scale.location.y - this.model.quantitativeScaleLength;
                scaleLocation.height = scaleLocation.y + this.model.quantitativeScaleLength;

                if ((location.x <= scaleLocation.x) && (scaleLocation.y <= location.y) && (location.y <= scaleLocation.height)) {
                    width = (scale.location.x - labelWidth / 2);
                }
                else if ((location.x <= scaleLocation.x) && (location.y <= scaleLocation.y) && (angle < 90)) {
                    height = scaleLocation.y;
                }
                else if ((location.x >= scaleLocation.x) && (location.x <= (scaleLocation.x + scaleWidth)) && (location.y <= scaleLocation.y)) {
                    height = scaleLocation.y;
                }
                else if ((location.y <= scaleLocation.y) && (location.x >= (scaleLocation.x + scaleWidth)) && (angle >= 90)) {
                    height = scaleLocation.y;
                }

                else if ((location.x >= (scaleLocation.x + scaleWidth)) && (scaleLocation.y <= location.y) && (location.y <= scaleLocation.height) && (angle <= 260)) {
                    width = width - (scaleLocation.x + scaleWidth);
                    location.x = location.x - (scaleLocation.x + scaleWidth);
                }
                else if ((location.x <= scaleLocation.x) && (location.y >= scaleLocation.height) && (angle >= 280)) {
                    location.y = location.y - scaleLocation.height;
                }
                else if ((location.x >= scaleLocation.x) && (location.x <= (scaleLocation.x + scaleWidth)) && (location.y >= scaleLocation.height)) {
                    location.y = location.y - scaleLocation.height;
                }
                else if ((location.x >= (scaleLocation.x + scaleWidth)) && (location.y >= scaleLocation.height) && (angle >= 180) && (angle <= 260)) {
                    location.y = location.y - scaleLocation.height;
                }

                gap = this.calcGap(angle, location, maxWidth, maxHeight, isRotate, width, height);
                isRotate = gap.rotate;
                gap = gap.trimSize;
            }
            // Trimming opetation called here
            var displayText = text;
            displayText = this._trim(text,settings,gap,isRotate);
            return displayText;
        },

        // trim calculation perform here
        _trim: function (text, settings, gap, isRotate) {
            var displayText = text;
            var maxWidth = this.rotatedLabel(settings.font, this, settings.textAngle, text);
            var textWidth = ej.EjSvgRender.utils._measureText(text, null, settings.font).width;
            if (settings.textSpacing) {
                textWidth = textWidth + settings.textSpacing;
                maxWidth = maxWidth + settings.textSpacing;
            }
            if (textWidth > gap && text != "") {
                var space;
                for (var t = 1; t <= text.toString().length; t++) {
                    text = displayText.toString().substring(0, t) + '... ';
                    if (isRotate == true)
                        space = ej.EjSvgRender.utils.rotatedLabel(settings, this, settings.textAngle, text);
                    else
                        space = ej.EjSvgRender.utils._measureText(text, null, settings.font).width;

                    if (settings.textSpacing) {
                        space = space + settings.textSpacing;
                    }
                    if (space >= gap) {
                        text = text.toString().substring(0, t - 1) + '... ';
                        displayText = text;
                        break;
                    }
                }
                var temp = displayText.toString(0, text.toString.lenght - 4);
                if (temp != displayText)
                    displayText = text;
            }
            return displayText;
        },
       
        _getVerticalScaleLocation: function(scaleWidth){
            return { x: this._scale.location.y, y:this.svgHeight - this._scale.location.x - scaleWidth };

        },
      
        _horizontalTextPositioning: function (element, region, scaleLocation, scaleRegion, regions) {
            var position = element.textPosition.toLowerCase();
            var alignment = region.alignment;
            var scaleLocation = this._scaleLoc();
            var label = this._scale.labelSettings;
            var maxLabelWidth = ej.EjSvgRender.utils._measureText(label.labelPrefix + this._scale.maximum + label.labelSuffix, null, label).width;            
            switch (position) {
                case 'left':
                    region.x = scaleLocation.x - region.width - region.padding - maxLabelWidth/2;
                    region.y = scaleLocation.y + ((alignment == 'center') ? scaleRegion.height / 2 + region.height/3: (alignment == 'far' ? scaleRegion.height : region.height));
                    regions[0].push(region);
                    break;
                case 'right':
                    region.x = scaleLocation.x + scaleRegion.width + region.padding + maxLabelWidth/2;
                    region.y = scaleLocation.y + ((alignment == 'center') ? scaleRegion.height / 2 + region.height / 3 : (alignment == 'far' ? scaleRegion.height : region.height));
                    regions[1].push(region);
                    break;
                case 'top':
                    region.x = (alignment == 'center') ? scaleRegion.x + scaleRegion.width / 2 - region.width / 2 : (alignment == 'near' ? scaleRegion.x : scaleRegion.x + scaleRegion.width - region.width);
                    region.y = scaleLocation.y - region.padding;
                    regions[2].push(region);
                    break;
                case 'bottom':                    
                    region.x = (alignment == 'center') ? scaleRegion.x + scaleRegion.width / 2 - region.width / 2 : (alignment == 'near' ? scaleRegion.x : scaleRegion.x + scaleRegion.width - region.width);
                    region.y = scaleLocation.height + region.height / 2 + region.padding;
                    regions[3].push(region);
                    break;
            }
        },
       
        _VerticalTextPositioning: function (element, region, scaleLocation, scaleRegion, regions) {
            var position = element.textPosition.toLowerCase();
            var alignment = region.alignment;
            var scaleBounds = this._scaleLoc();
            switch (position) {
                case 'left':
                    region.x = scaleBounds.y - region.width - region.padding;
                    region.y = scaleLocation.y + ((alignment == 'center') ? scaleRegion.height / 2 + region.height / 3 : (alignment == 'far' ? scaleRegion.height : region.height));
                    if (this._tickPosition == 'near' && this._tickPlacement == 'inside' && (this._labelPosition=='above' && this._labelPlacement=='inside'))
                        region.x += this._scale.majorTickSettings.size;
                    regions[0].push(region);
                    break;
                case 'right':
                    region.x = scaleBounds.height + region.padding;
                    region.y = scaleLocation.y + ((alignment == 'center') ? scaleRegion.height / 2 + region.height / 3 : (alignment == 'far' ? scaleRegion.height : region.height));
                    regions[1].push(region);
                    break;
                case 'top':
                    region.x = scaleRegion.x - region.width / 2 + (alignment == 'center' ? scaleRegion.width / 2 : (alignment == 'far' && scaleRegion.width));
                    region.y = scaleRegion.y - region.padding;                   
                    regions[2].push(region);
                    break;
                case 'bottom':
                    region.x = scaleRegion.x - region.width / 2 + (alignment=='center' ? scaleRegion.width / 2 : (alignment == 'far' && scaleRegion.width));
                    region.y = scaleRegion.y + scaleRegion.height + region.height + region.padding - region.height / 3 + this._scale.labelSettings.size / 2;
                    regions[3].push(region);
                    break;
            }
        },
    
        _positionTextGroup: function (elements, regions, horScaleRegion) {
            var elementRegions=[[], [], [], []];
            var isHorizontal = (this._orientation == 'horizontal');            
            var scaleLocation = isHorizontal ? this._scaleLocation : this._getVerticalScaleLocation(horScaleRegion.width);
            var scaleRegion = isHorizontal ? horScaleRegion : { x: scaleLocation.x, y: scaleLocation.y, width: horScaleRegion.height, height: horScaleRegion.width };
            for (var i = 0; i < elements.length; i++) {
                if (elements[i]) {
                    if (isHorizontal)
                        this._horizontalTextPositioning(elements[i], regions[i], scaleLocation, scaleRegion, elementRegions);
                    else
                        this._VerticalTextPositioning(elements[i], regions[i], scaleLocation, scaleRegion, elementRegions);
                }                
            }
            this._avoidElementsOverlapping(elementRegions);
        },
       
        _avoidElementsOverlapping: function (regions) {
            for (var j = 0; j < regions.length; j++) {
                var region = regions[j];
                var isOverlap = false;
                do {
                    for (var i = 0; i < region.length; i++) {
                        for (var k = i - 1; k >= 0; k--) {
                            if (this._isOverlapping(region[i], region[k])) {
                                switch (j) {
                                    //Placing overlapped text for left and right positioned text elements
                                    case 0:
                                    case 1:
                                        if (region[k].y > region[i].y)
                                            region[k].y = region[i].y + region[k].height + (region[k].padding > 1 ? region[k].padding : 1);
                                        else
                                            region[i].y = region[k].y + region[i].height + (region[i].padding > 1 ? region[i].padding : 1);
                                        break;
                                        //Placing overlapped text at top position
                                    case 2:
                                        region[k].y = region[i].y - region[i].height - (region[k].padding > 1 ? region[k].padding : 1);
                                        break;
                                        //Placing overlapped text at bottom position
                                    default:
                                        region[i].y = region[k].y + region[k].height + (region[k].padding > 1 ? region[k].padding : 1);
                                        break;
                                }
                                isOverlap = true;
                                break;
                            }
                            else
                                isOverlap = false;
                        }
                    }
                } while (isOverlap);
            }
            this._applyLeftRightAnchor([regions[0], regions[1]]);
            this._applyTopBottomAnchor([regions[2], regions[3]]);
        },
      
        _locateTextGroup: function (elements, regions) {            
            for (var i = 0; i < elements.length; i++) {
                if (elements[i]) {
                    elements[i]._location = { x: 0, y: 0 };
                    elements[i]._location.x = regions[i].x;
                    elements[i]._location.y = regions[i].y;
                }
            }
        },
     
        _applyLeftRightAnchor: function (regions) {
            var anchor;
            for (var i = 0; i < regions.length; i++) {
                var region = regions[i];
                var maxSize = 0;
                for (var j = 0; j < region.length; j++)
                    maxSize = Math.max(maxSize, region[j].width);
                for (var j = 0; j < region.length; j++) {
                    anchor = region[j].anchor;
                    if (anchor == 'start')
                        region[j].x += (i == 0) && (region[j].width - maxSize);
                    else if (anchor == 'middle')
                        region[j].x += (i == 0) ? (region[j].width - maxSize) / 2 : (maxSize - region[j].width) / 2;
                    else
                        region[j].x += (i != 0) && (maxSize - region[j].width);
                }
            }
        },
     
        _applyTopBottomAnchor: function (regions) {            
            for (var i = 0; i < regions.length; i++) {
                var nearAlignment = [], farAlignment = [], centerAlignment = [];
                var region = regions[i];
                for (var j = 0; j < region.length; j++)
                    if (region[j].alignment == 'near')
                        nearAlignment.push(region[j])
                    else if (region[j].alignment == 'far')
                        farAlignment.push(region[j]);
                    else
                        centerAlignment.push(region[j]);

                this._applyNearAnchor(nearAlignment);
                this._applyCenterAnchor(centerAlignment);
                this._applyFarAnchor(farAlignment);
            }
        },
       
        _applyNearAnchor: function (regions) {
            if (regions.length > 1) {
                var maxSize = 0;
                for (var i = 0; i < regions.length; i++)
                    maxSize = Math.max(maxSize, regions[i].width);
                for (var i = 0; i < regions.length; i++)
                    if (regions[i].anchor == 'start')
                        regions[i].x += (this._orientation == 'vertical') && (regions[i].width - maxSize) / 2;
                    else if (regions[i].anchor == 'middle')
                        regions[i].x += (this._orientation == 'horizontal') && (maxSize - regions[i].width) / 2;
                    else
                        regions[i].x += (this._orientation == 'horizontal') ? (maxSize - regions[i].width) : (maxSize - regions[i].width) / 2;
            }
        },
      
        _applyCenterAnchor: function (regions) {
            if (regions.length > 1) {
                var maxSize = 0;
                for (var i = 0; i < regions.length; i++)
                    maxSize = Math.max(maxSize, regions[i].width);
                for (var i = 0; i < regions.length; i++)
                    if (regions[i].anchor == 'start')
                        regions[i].x += (regions[i].width - maxSize) / 2;
                    else if (regions[i].anchor == 'end')
                        regions[i].x += (maxSize - regions[i].width) / 2;
            }
        },
     
        _applyFarAnchor: function (regions) {
            if (regions.length > 1) {
                var maxSize = 0;
                for (var i = 0; i < regions.length; i++)
                    maxSize = Math.max(maxSize, regions[i].width);
                for (var i = 0; i < regions.length; i++)
                    if (regions[i].anchor == 'start')
                        regions[i].x += (this._orientation == 'horizontal') ? regions[i].width - maxSize : (regions[i].width - maxSize) / 2;
                    else if (regions[i].anchor == 'middle')
                        regions[i].x += (this._orientation == 'horizontal') && (regions[i].width - maxSize) / 2;
                    else if (regions[i].anchor == 'end')
                        regions[i].x += (this._orientation == 'vertical') && (maxSize - regions[i].width) / 2;
            }
        },
       
        _isOverlapping: function (reg1, reg2) {
            return !(reg1.x + reg1.width < reg2.x || reg1.x > reg2.x + reg2.width || reg1.y - reg1.height > reg2.y || reg1.y < reg2.y - reg2.height);
        },
        
        _initializeValues: function () {
            this._scale = this.model.quantitativeScaleSettings;
            this._labelPosition = this._scale.labelSettings.position.toLowerCase();
            this._tickPosition = this._scale.tickPosition.toLowerCase();
            this._flowDirection = this.model.flowDirection.toLowerCase();
            this._orientation = this.model.orientation.toLowerCase();
            this._tickPlacement = this._scale.tickPlacement.toLowerCase();
            this._labelPlacement = this._scale.labelSettings.labelPlacement.toLowerCase();
        },
      
        _changeOrientation: function (bulletGroup) {
            if (this._orientation == ej.datavisualization.BulletGraph.Orientation.Vertical) {               
                bulletGroup.setAttribute("transform", "translate(0," +this.svgHeight +")rotate(-90)");
            }
        },
       
        _setModel: function (options) {
            var isFlag = true;
            for (var key in options) {
                this.model.enableAnimation = false;
                switch (key) {
                    case "height":
                        this.model.height = options[key];
                        break;
                    case "width":
                        this.model.width = options[key];
                        break;
                    case "theme":
                        this.model.theme = options[key];
                        this._setTheme(ej.datavisualization.BulletGraph.Themes, this.model.theme);
                        break;
                    case "orientation":
                        this.model.orientation = options[key];
                        break;
                    case "flowDirection":
                        this.model.flowDirection = options[key];
                        break;
                    case "qualitativeRangeSize":
                        this.model.qualitativeRangeSize = options[key];
                        break;
                    case "quantitativeScaleLength":
                        this.model.quantitativeScaleLength = options[key];
                        break;
                    case "quantitativeScaleSettings":
                        $.extend(true, this.model.quantitativeScaleSettings, {}, options[key]);
                        break;
                    case "applyRangeStrokeToTicks":
                        this.model.applyRangeStrokeToTicks = options[key];
                        break;
                    case "applyRangeStrokeToLabels":
                        this.model.applyRangeStrokeToLabels = options[key];
                        break;
                    case "qualitativeRanges":
                        $.extend(true, this.model.qualitativeRanges, {}, options[key]);
                        break;
                    case "captionSettings":
                        $.extend(true, this.model.captionSettings, {}, options[key]);
                        break;
                    case "dataSource":
                        $.extend(true, this.model.fields, {}, options[key]);
                        break;
                    case "value":
                        for (var i = 0; this.model.quantitativeScaleSettings.featureMeasures[i] != null; i++) {
                            this.model.quantitativeScaleSettings.featureMeasures[i].value = parseFloat(this.value());
                        }
                        break;
                    case "comparativeMeasureValue":
                        for (var i = 0; this.model.quantitativeScaleSettings.featureMeasures[i] != null; i++) {
                            this.model.quantitativeScaleSettings.featureMeasures[i].comparativeMeasureValue = parseFloat(this.comparativeMeasureValue());
                        }
                        break;
                    case "enableAnimation":
                        this.model.enableAnimation = options[key];
                        if (this.model.enableAnimation) {
                            $(this.svgObject).empty();
                            this._renderBulletElements();
                            this._animateMeasures();
                        }
                        isFlag = false;
                        break;
                }
            }
            if (isFlag) {
                $(this.svgObject).empty();
                this._renderBulletElements();
            }
        },
      
        _bindData: function () {

            if (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) {
                if (this.model.fields["dataSource"] instanceof ej.DataManager) {
                    this._initDataSource();
                }
                else {
                    this._dataCount = this.model.fields["dataSource"].length;
                    this._drawMeasures();
                }
            }
            else {      //this.model.quantitativeScaleSettings.featureMeasures != null
                this._dataCount = this._scale.featureMeasures.length;
                this._drawMeasures();
            }
        },
      
        _drawMeasures: function () {
            this._drawFeatureMeasureBar();
            this._drawComparativeMeasureSymbol();
        },
      
        _initDataSource: function () {
            var query = this._columnToSelect(this.model.fields);
            var proxy = this;
            var queryPromise = this.model.fields["dataSource"].executeQuery(query);
            queryPromise.done(function (e) {
                proxy.model.fields["dataSource"] = e.result;
                proxy._dataCount = e.result.length;
                proxy._drawFeatureMeasureBar();
                proxy._drawComparativeMeasureSymbol();
                proxy._bindHighlightRemoving();
            });
        },
      
        _columnToSelect: function (mapper) {
            var column = [], queryManager = ej.Query();
            if (ej.isNullOrUndefined(mapper.query)) {
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "query" && col !== "dataSource")
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.fields["dataSource"].dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else
                queryManager = mapper.query;
            return queryManager;
        },
             
        _drawCaption: function () {
            if (this.model.drawCaption) {
                var data = { font: this.model.captionSettings.font, location: this.model.captionSettings.location, subTitle: this.model.captionSettings.subTitle, text: this.model.captionSettings.text, textAngle: this.model.captionSettings.textAngle };
                this._trigger("drawCaption", data);
                this.model.captionSettings = $.extend(this.model.captionSettings, data);
            }
        },
      
        _drawBulletSymbol: function(shape, symbolRect, symbolOptions, captionGroup){
            var arrowPath = "M" + " " + ((symbolRect.x - (symbolRect.width / 2)) + symbolRect.width) + " " + (symbolRect.y + (symbolRect.height / 4)) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2)) + symbolRect.width) + " " + (symbolRect.y + (-symbolRect.height / 4)) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2)) + (symbolRect.width / 2)) + " " + (symbolRect.y + (-symbolRect.height / 4)) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2)) + (symbolRect.width / 2)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2))) + " " + (symbolRect.y) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2)) + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2)) + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 4)) + " "
                    + "L" + " " + ((symbolRect.x - (symbolRect.width / 2)) + symbolRect.width) + " " + (symbolRect.y + (symbolRect.height / 4));

            switch (shape.toLowerCase()) {
                case 'circle':
                    var radius = Math.min(symbolRect.height, symbolRect.width) / 2;
                    symbolOptions.cx = symbolRect.x;
                    symbolOptions.cy = symbolRect.y,
                    symbolOptions.r = radius,
                    this.svgRenderer.drawCircle(symbolOptions, captionGroup);
                    break;

                case 'leftarrow':                        
                    symbolOptions.d = arrowPath;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'rightarrow':
                    symbolOptions.d = arrowPath;
                    symbolOptions.transform = 'rotate(180,' + (symbolRect.x) + ',' + symbolRect.y + ')';
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'uparrow':
                    symbolOptions.d = arrowPath;
                    symbolOptions.transform = 'rotate(90,' + (symbolRect.x) + ',' + symbolRect.y + ')';
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'downarrow':
                    symbolOptions.d = arrowPath;
                    symbolOptions.transform = 'rotate(-90,' + (symbolRect.x) + ',' + symbolRect.y + ')';
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'cross':
                    var crossPath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y) + " " +
                        "M" + " " + (symbolRect.x) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (-symbolRect.height / 2));
                    symbolOptions.d = crossPath;
                    symbolOptions.stroke = (symbolOptions.stroke) ? symbolOptions.stroke : symbolOptions.fill;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'horizontalline':
                    var horizPath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y) + " " + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y);
                    symbolOptions.d = horizPath;
                    symbolOptions.stroke = (symbolOptions.stroke) ? symbolOptions.stroke : symbolOptions.fill;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'verticalline':
                    var verPath = "M" + " " + (symbolRect.x) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (-symbolRect.height / 2));
                    symbolOptions.d = verPath;
                    symbolOptions.stroke = (symbolOptions.stroke) ? symbolOptions.stroke : symbolOptions.fill;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'triangle':
                    var triPath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " Z";
                    symbolOptions.d = triPath;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'invertedtriangle':
                    var triPath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " Z";
                    symbolOptions.d = triPath;
                    symbolOptions.transform = 'rotate(180,' + (symbolRect.x) + ',' + symbolRect.y + ')';
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'hexagon':
                    var hexPath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 4)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 4)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 4)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 4)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y);
                    symbolOptions.d = hexPath;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'wedge':
                    var wedgePath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x + symbolRect.width / 2) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 4)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y);
                    symbolOptions.d = wedgePath;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'pentagon':
                    var eq = 72;
                    var radius = Math.sqrt(symbolRect.height * symbolRect.height + symbolRect.width * symbolRect.width) / 2;
                    var sb = ej.EjSvgRender.utils._getStringBuilder();
                    for (var i = 0; i <= 5; i++) {
                        var deg = i * eq;
                        var rad = (Math.PI / 180) * deg;
                        var x1 = radius * Math.cos(rad);
                        var y1 = radius * Math.sin(rad);
                        if (i == 0)
                            sb.append("M" + " " + (symbolRect.x + x1) + " " + (symbolRect.y + y1) + " ");

                        else
                            sb.append("L" + " " + (symbolRect.x + x1) + " " + (symbolRect.y + y1) + " ");

                    }                        
                    symbolOptions.d = sb.toString();
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'star':
                    var starPath = "M" + " " + (symbolRect.x + (symbolRect.width / 3)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 6)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 6)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 3)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 3)) + " " + (symbolRect.y + (-symbolRect.height / 2));
                    symbolOptions.d = starPath;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'rectangle':
                    var rectPath = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (-symbolRect.height / 2));
                    symbolOptions.d = rectPath;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'trapezoid':
                    var path = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (-symbolRect.height / 4)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2) + (symbolRect.width)) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2) + (symbolRect.width)) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y + (symbolRect.height / 4)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y);
                    symbolOptions.d = path;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'diamond':
                    var path = "M" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (-symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (symbolRect.width / 2)) + " " + (symbolRect.y) + " "
                        + "L" + " " + (symbolRect.x) + " " + (symbolRect.y + (symbolRect.height / 2)) + " "
                        + "L" + " " + (symbolRect.x + (-symbolRect.width / 2)) + " " + (symbolRect.y);
                    symbolOptions.d = path;
                    this.svgRenderer.drawPath(symbolOptions, captionGroup);
                    break;
                case 'ellipse':                        
                    symbolOptions.cx = symbolRect.x;
                    symbolOptions.cy = symbolRect.y;
                    symbolOptions.rx = symbolRect.width/2;
                    symbolOptions.ry = symbolRect.height/2;
                    this.svgRenderer.drawEllipse(symbolOptions, captionGroup);
                    break;
                case 'image':
                    symbolOptions.x = symbolRect.x - symbolRect.width / 2;
                    symbolOptions.y = symbolRect.y - symbolRect.height / 2;
                    symbolOptions.width = symbolRect.width;
                    symbolOptions.height = symbolRect.height;
                    symbolOptions.href = this.model.captionSettings.indicator.symbol.imageURL;
                    symbolOptions.visibility = 'visible';
                    this.svgRenderer.drawImage(symbolOptions, captionGroup);
                    break;
                default:
                    break;
            }                
        },
       
        _drawIndicator: function () {
            if (this.model.captionSettings.indicator.visible) {
                var indicatorSettings = this.model.captionSettings.indicator;
                var indicatorEventArgs = $.extend({}, { indicatorSettings: this.model.captionSettings.indicator });
                if (this.model.drawIndicator) {
                    this._trigger("drawIndicator", indicatorEventArgs);
                    if (indicatorEventArgs.cancel == false) {
                        indicatorSettings = indicatorEventArgs.indicatorSettings;
                        this.model.captionSettings.indicator = indicatorSettings;
                    }
                }
                var textBounds = ej.EjSvgRender.utils._measureText(indicatorSettings.text, null, indicatorSettings.font);
                this._indicator = { 'bounds': textBounds, 'settings': indicatorSettings };
            }
        },
      
        _indicatorTextOptions: function (settings, rect, bounds, id) {
            var location = settings._location ? settings._location : settings.location;
            return {
                'class' : id,
                'x': location.x + rect.width + settings.textSpacing,
                'y': location.y - rect.height / 2 + parseFloat(settings.font.size) / 3,
                'fill': settings.font.color,
                'font-size': settings.font.size,
                'font-family': settings.font.fontFamily,
                'font-style': settings.font.fontStyle,
                'font-weight': settings.font.fontWeight,
                'text-anchor': 'start',
                'opacity': settings.font.opacity,
                'transform': 'rotate(' + settings.textAngle + ',' + rect.x  + ',' + rect.y + ')'
            };
        },
      
        _indicatorSymbolOptions: function (group, settings) {
            return {
                'id': group.id + '_indicatorSymbol',
                'stroke': settings.symbol.border.color,
                'fill': settings.symbol.color,
                'stroke-width': settings.symbol.border.width,
                'opacity': settings.symbol.opacity
            };
        },
       
        _textOptions: function (text, id) {
            var location = (text._location ? text._location : text.location);
            var textOptions = {
                'class': id,
                'x': location.x,
                'y': location.y,
                'fill': text.font.color,
                'font-size': text.font.size,
                'font-family': text.font.fontFamily,
                'font-style': text.font.fontStyle,
                'font-weight': text.font.fontWeight,
                'text-anchor': 'start',
                'opacity': text.font.opacity,
				'cursor':'default',
                'transform': 'rotate(' + text.textAngle + ',' + (location.x) + ',' + (location.y) + ')'
            };
            return textOptions;
        },
       
        _drawScale: function (captionGroup, scaleGroup) {
            var scaleLocation = this._scale._location ? this._scale._location : this._scale.location;
            var pointY, pointX;
            if (this._tickPosition == ej.datavisualization.BulletGraph.TickPosition.Far || this._tickPosition == ej.datavisualization.BulletGraph.TickPosition.Center)
                pointY = (this._labelPosition == ej.datavisualization.BulletGraph.LabelPosition.Below) ? scaleLocation.y : scaleLocation.y + this._scale.labelSettings.offset + this._scale.labelSettings.size;
            else
                pointY = (this._labelPosition == ej.datavisualization.BulletGraph.LabelPosition.Below) ? scaleLocation.y + this._scale.majorTickSettings.size : scaleLocation.y + this._scale.labelSettings.offset + this._scale.labelSettings.size + this._scale.majorTickSettings.size;

            if (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward)
                pointX = scaleLocation.x;
            else
                pointX = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal) ? scaleLocation.x - this._scale.labelSettings.offset : scaleLocation.x;

            var scaleOptions = {
                'id': this.svgObject.id + '_SvgScale',
                'x': pointX,
                'y': pointY,
                'width': this.model.quantitativeScaleLength,
                'height': this.model.qualitativeRangeSize,
                'fill': "transparent",
                'stroke-width': 0
            };
            this.svgRenderer.drawRect(scaleOptions, scaleGroup);
        },
     
        _drawMajorTicks: function (intervalValue, scaleGroup) {
            var majorPointX, y1, tickIndex = 0;
            var scaleLocation = this._scale.location;
            var isTicksInside = (this._tickPlacement == 'inside');
            var locX = this._scale.location.x;
            var scaleLength = this.model.quantitativeScaleLength;
            var labelOffset = this._scale.labelSettings.offset;

            var rangeSize = this.model.qualitativeRangeSize;
            var majorTickWidth = this._scale.majorTickSettings.width;
            var majorTickSize = this._scale.majorTickSettings.size;

            var isHorizontal = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal);
            var isForward = (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward);
            var isBelow = (this._labelPosition == ej.datavisualization.BulletGraph.LabelPosition.Below);

            if (isForward)
                majorPointX = isHorizontal ? locX + (majorTickWidth / 2) : locX + scaleLength + (majorTickWidth / 2);
            else
                majorPointX = isHorizontal ? locX + scaleLength - (majorTickWidth / 2) : locX + (majorTickWidth / 2);
            
            if(this._tickPosition == 'far')
                y1 = scaleLocation.y + rangeSize + (isTicksInside ? -majorTickSize : 0);
            else if(this._tickPosition == 'near')
                y1 = scaleLocation.y + (isTicksInside ? 0 : -majorTickSize);
            else
                y1 = scaleLocation.y + (rangeSize / 2) - (majorTickSize / 2);
            
            var min = this._scale.minimum;
            var max = this._scale.maximum;
            var interval = this._scale.interval;
            
            for (var i = min; i <= max; i += interval) {
                tickIndex++;
                if (i >= max)
                    if (isHorizontal && !isForward)
                        majorPointX += majorTickWidth;
                    else
                        majorPointX -= majorTickWidth;
                if (!isHorizontal && isForward)
                    majorPointX = (i >= max) ? majorPointX + (majorTickWidth) : (i == min) ? majorPointX - (majorTickWidth) : majorPointX;

                if (this.model.applyRangeStrokeToTicks)
                    strokeColor = this._bindingRangeStrokes(majorPointX - (majorTickWidth / 2));

                var options = this._majorTickLines(this._scale, majorPointX, y1);

                if (!isHorizontal && isForward && i == min)
                    majorPointX = majorPointX + majorTickWidth;
                
                if (this.model.drawTicks) {
                    data = { majorTickSettings: this._scale.majorTickSettings, minorTickSettings: this._scale.minorTickSettings, minorTicksPerInterval: this._scale.minorTicksPerInterval, maximum: max, minimum: min, interval: interval };
                    this._trigger("drawTicks", data);                    
                    options = this._majorTickLines(data, majorPointX, y1);
                }
                var majorTicks = this.svgRenderer.createLine(options);
                majorPointX = ((!isForward && isHorizontal) || (isForward && !isHorizontal)) ? majorPointX - intervalValue : majorPointX + intervalValue;
                scaleGroup.appendChild(majorTicks);
            }
        },
        _majorTickLines: function (data, majorPointX, y1) {
            var options = {
                'x1': majorPointX,
                'y1': y1,
                'x2': majorPointX,
                'y2': y1 + data.majorTickSettings.size,
                'stroke-width': data.majorTickSettings.width,
                'stroke': (this.model.applyRangeStrokeToTicks && strokeColor) ? strokeColor : data.majorTickSettings.stroke
            };
            return options;
        },
       
        _forwardStrokeBinding: function (majorPointX) {
            if (majorPointX >= this._scale.location.x && majorPointX <= (this._rangeCollection[0] + this._scale.location.x)) {
                return this.model.qualitativeRanges[0].rangeStroke;
            }
            for (var k = 0; k <= this._rangeCollection.length - 1; k++) {
                if (majorPointX >= (this._rangeCollection[k] + this._scale.location.x) && majorPointX <= (this._rangeCollection[k + 1] + this._scale.location.x))
                    return this.model.qualitativeRanges[k + 1].rangeStroke;
            }
        },
       
        _backwardStrokeBinding: function (majorPointX) {
            if (majorPointX >= this._rangeCollection[this._rangeCollection.length - 1]) {
                return this.model.qualitativeRanges[0].rangeStroke;
            }
            for (k = 0; k <= this._rangeCollection.length - 1; k++) {
                if (majorPointX >= this._rangeCollection[k] && majorPointX < this._rangeCollection[k + 1]) {
                    var index = $.inArray(this._rangeCollection[k], this._rangeCollection)
                    return this.model.qualitativeRanges[(this._rangeCollection.length - 1) - index].rangeStroke;
                }
            }
        },
      
        _bindingRangeStrokes: function (majorPointX) {
            if (this._rangeCollection.length == 1) {
                if (majorPointX >= this._scale.location.x && majorPointX <= (this._rangeCollection[0] + this._scale.location.x))
                    return this.model.qualitativeRanges[0].rangeStroke;
            }
            else {
                if ((this.model.orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal && this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward) || (this.model.orientation == ej.datavisualization.BulletGraph.Orientation.Vertical && this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Backward)) {
                    return this._forwardStrokeBinding(majorPointX);
                }
                else {
                    return this._backwardStrokeBinding(majorPointX);
                }
            }
        },
       
        _drawMinorTicks: function (intervalValue, scaleGroup) {
            var majorPointX, minorPointX, y1, y2, x, tickIndex = 0;

            var isForward = (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward);
            var isHorizontal = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal);

            var isTicksInside = (this._tickPlacement == 'inside');
            var locX = this._scale.location.x;
            var rangeSize = this.model.qualitativeRangeSize;
            var labelOffset = this._scale.labelSettings.offset;

            var majorTickSize = this._scale.majorTickSettings.size;
            var minorTickSize = this._scale.minorTickSettings.size;
            var minorTickWidth = this._scale.minorTickSettings.width;
            var scaleLength = this.model.quantitativeScaleLength;

            if (isForward)
                majorPointX = isHorizontal ? locX : locX + scaleLength;
            else
                majorPointX = isHorizontal ? locX + scaleLength - (minorTickWidth / 2) : locX;

            switch (this._tickPosition) {
                case 'far':
                    y1 = this._scale.location.y + rangeSize;
                    y2 = y1 + (isTicksInside ? -minorTickSize : minorTickSize);
                    break;
                case 'near':
                    y1 = this._scale.location.y + (isTicksInside ? minorTickSize : -minorTickSize);
                    y2 = this._scale.location.y;
                    break;                
                default:
                    y1 = this._scale.location.y + (rangeSize / 2) - (minorTickSize / 2);
                    y2 = y1 + minorTickSize;
                    break;
            }
            var maxLimit = this._scale.maximum;
            var min = this._scale.minimum;
            var interval = this._scale.interval;
            var minorTicksPerInterval = this._scale.minorTicksPerInterval;
           
            for (var i = min; i <= maxLimit; i += interval) {
                minorPointX = intervalValue / minorTicksPerInterval;

                for (var j = 1; j <= minorTicksPerInterval; j++) {
                    tickIndex++;
                    x = ((!isHorizontal && isForward) || (isHorizontal && !isForward))
                        ? majorPointX - minorPointX + (minorPointX / (minorTicksPerInterval + 1))
                        : majorPointX + minorPointX - (minorPointX / (minorTicksPerInterval + 1));

                    if (!isForward && isHorizontal) {
                        if (tickIndex >= ((maxLimit - min) * minorTicksPerInterval))
                            x += (minorTickWidth / 2);
                    }

                    if (this.model.applyRangeStrokeToTicks)
                        strokeColor = this._bindingRangeStrokes(x);
                   
                    var options = this._minorTickLines(this._scale, x, y1, y2);
                    if (this.model.drawTicks) {
                        data = { majorTickSettings: this._scale.majorTickSettings, minorTickSettings: this._scale.minorTickSettings, minorTicksPerInterval: this._scale.minorTicksPerInterval, maximum: this._scale.maximum, minimum: this._scale.minimum, interval: this._scale.interval };
                        this._trigger("drawTicks", data);
                        this._scale = $.extend(this._scale, data);
                        options = this._minorTickLines(data, x, y1, y2);
                    }
                   
                    var chkMax;
                    if (!isForward && isHorizontal) {
                        chkMax = (scaleLength + locX + 1);
                        if (x <= chkMax && x >= locX + 1) {
                            var minorTicks = this.svgRenderer.createLine(options);
                            scaleGroup.appendChild(minorTicks);
                        }
                    }
                    else if (isForward && !isHorizontal) {
                        chkMax = (locX + 1);
                        if (x >= chkMax) {
                            var minorTicks = this.svgRenderer.createLine(options);
                            scaleGroup.appendChild(minorTicks);
                        }
                    }
                    else {
                        chkMax = scaleLength + locX + 1;
                        if (x <= chkMax) {
                            var minorTicks = this.svgRenderer.createLine(options);
                            scaleGroup.appendChild(minorTicks);
                        }
                    }
                    
                    minorPointX = (intervalValue / minorTicksPerInterval) * (j + 1);
                }
                majorPointX = ((!isForward && isHorizontal) || (isForward && !isHorizontal)) ? majorPointX - intervalValue : majorPointX + intervalValue;
            }
        },
        _minorTickLines: function (data, x, y1, y2) {
            var options = {
                'x1': x,
                'y1': y1,
                'x2': x,
                'y2': y2,
                'stroke-width': data.minorTickSettings.width,
                'stroke': (this.model.applyRangeStrokeToTicks && strokeColor) ? strokeColor : data.minorTickSettings.stroke
            };
            return options;
        },
       
        _drawLabels: function (intervalValue, scaleGroup) {
            var labelX, pointY, locale = this.model.locale, localizedText = locale && this.model.enableGroupSeparator, text;
            var isForward = (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward);
            var isHorizontal = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal);

            var locX = this._scale.location.x;
            var offset = this._scale.labelSettings.offset;
            var scaleLength = this.model.quantitativeScaleLength;

            var majorTickWidth = this._scale.majorTickSettings.width;

            if (isForward)
                labelX = isHorizontal ? locX : locX + scaleLength;
            else
                labelX = isHorizontal ? locX + scaleLength : locX;
            
            var placement = this._tickPosition + this._labelPlacement;
            var isLabelsBelow = (this._labelPosition == ej.datavisualization.BulletGraph.LabelPosition.Below);

            var locY = this._scale.location.y;
            var rangeSize = this.model.qualitativeRangeSize;
            var labelSize = this._scale.labelSettings.size;
            var majorTickSize = this._scale.majorTickSettings.size;

            switch (placement) {
                case 'faroutside':
                case 'centeroutside':                    
                    pointY = isLabelsBelow ? this._scale.location.y + rangeSize + offset + labelSize : this._scale.location.y - offset;
                    break;
                case 'farinside':
                case 'centerinside':
                    pointY = isLabelsBelow ? this._scale.location.y + rangeSize - offset : this._scale.location.y + offset + (isHorizontal ? labelSize : 0);
                    break;
                case 'nearoutside':
                    pointY = isLabelsBelow ? this._scale.location.y + rangeSize + offset + labelSize : this._scale.location.y - offset;
                    break;
                case 'nearinside':
                    pointY = isLabelsBelow ? this._scale.location.y + rangeSize - offset : this._scale.location.y + offset + labelSize;
                    break;
            }
            var min = this._scale.minimum;
            var max = this._scale.maximum;
            var interval = this._scale.interval;
            var isLabelsInside = (this._labelPlacement == "inside");

            for (var i = min; i <= max; i += interval) {               
                var y = pointY;
                var x = labelX;
                var font = this._scale.labelSettings.font;
                font.size = labelSize;
                var labelWidth = {width: 0, height: 0};
                if (!isHorizontal) {
                    var label = this._scale.labelSettings.labelPrefix + i + this._scale.labelSettings.labelSuffix;
                    switch (placement) {
                        case 'faroutside':
                        case 'centeroutside':
                            if (isLabelsBelow)
                                y -= labelSize;
                            else {
                                labelWidth = ej.EjSvgRender.utils._measureText(label, null, font);
                                y -= labelWidth.width;
                            }
                            break;
                        case 'farinside':
                        case 'centerinside':
                            if (isLabelsBelow) {                                
                                labelWidth = ej.EjSvgRender.utils._measureText(label, null, font);
                                y -= labelWidth.width;
                            }
                            break;
                        case 'nearoutside':
                            if (!isLabelsBelow) {
                                labelWidth = ej.EjSvgRender.utils._measureText(label, null, font);
                                y -= labelWidth.width;
                            }
                            else
                                y -= labelSize;
                            break;
                        case 'nearinside':
                            if (isLabelsBelow) {
                                labelWidth = ej.EjSvgRender.utils._measureText(label, null, font);
                                y -= labelWidth.width;
                            }
                            else
                                y -= labelSize;
                            break;
                    }                    
                    x -= labelSize/3;
                    transformText = 'rotate(' + 90 + ',' + (x) + ',' + (y) + ')';
                }
                else
                    transformText = 'rotate(' + 0 + ',' + (x) + ',' + (y) + ')';

                if (this.model.applyRangeStrokeToLabels)
                    strokeColor = this._bindingRangeStrokes(labelX);
                var labelOptions = this._labelOptions(this.model.quantitativeScaleSettings.labelSettings, x, y);
                if (this.model.drawLabels) {
                    var data = { font: this._scale.labelSettings.font, labelPrefix: this._scale.labelSettings.labelPrefix, labelSuffix: this._scale.labelSettings.labelSuffix, offset: offset, size: labelSize, stroke: this._scale.labelSettings.stroke };
                    this._trigger("drawLabels", data);
                    labelOptions = this._labelOptions(data, x, y);
                }

                if (isForward)
                    labelX = isHorizontal ? labelX + intervalValue : labelX - intervalValue;
                else
                    labelX = isHorizontal ? labelX - intervalValue : labelX + intervalValue;
                
				 text = localizedText ? i.toLocaleString(locale) : i;
                this.svgRenderer.drawText(labelOptions, labelOptions.labelPrefix + text + labelOptions.labelSuffix, scaleGroup);
            }
        },

        _labelOptions: function (data, labelX, pointY) {
            var labelOptions = {
                'x': labelX,
                'y': pointY,
                'text-anchor': (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal) ? 'middle' : 'start',
                'fill': (this.model.applyRangeStrokeToLabels && strokeColor) ? strokeColor : data.stroke,
                'font-size': data.size + "px",
                'font-family': data.font.fontFamily,
                'font-style': data.font.fontStyle,
                'font-weight': data.font.fontWeight,
                'opacity': data.font.opacity,
                'transform': transformText,
                'labelPrefix': data.labelPrefix,
                'labelSuffix': data.labelSuffix,
            };
            return labelOptions;
        },
      
        _drawQualitativeRanges: function (scaleGroup) {
            var pointX = this._scale.location.x, pointY = this._scale.location.y, width;
            var isForward = (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward);
            var isHorizontal = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal);
            var labelOffset = this._scale.labelSettings.offset;

            this._rangeCollection = [];

            var placement = this._tickPosition + this._labelPlacement;
            var isLabelBelow = (this._labelPosition == ej.datavisualization.BulletGraph.LabelPosition.Below);

            var scaleHeight = this.model.qualitativeRangeSize;
            
            var locX = this._scale.location.x;
            var min = this._scale.minimum;
            var max = this._scale.maximum;
            var scaleLength = this.model.quantitativeScaleLength;            

            for (var i = this.model.qualitativeRanges.length - 1; i >= 0; i--) {
                var data = { object: this, rangeIndex: i, rangeOptions: this.model.qualitativeRanges[i], rangeEndValue: this.model.qualitativeRanges[i].rangeEnd };
                if (this.model.drawQualitativeRanges)
                    this._trigger("drawQualitativeRanges", data);
                var rangeEnd = data.rangeEndValue;
                rangeEnd = (rangeEnd > max) ? max : rangeEnd;
                if (isForward) {
                    pointX = isHorizontal ? locX : locX + (scaleLength - scaleLength / ((max - min) / ((max - min) - (max - rangeEnd))));
                    width = isHorizontal ? scaleLength / ((max - min) / ((max - min) - (max - rangeEnd))) : scaleLength / ((max - min) / ((max - min) - (max - rangeEnd)));
                }
                else {
                    pointX = isHorizontal ? locX + (scaleLength - scaleLength / ((max - min) / ((max - min) - (max - rangeEnd)))) : locX;
                    width = isHorizontal ? scaleLength / ((max - min) / ((max - min) - (max - rangeEnd))) : scaleLength / ((max - min) / ((max - min) - (max - rangeEnd)));
                }
                var rangeOptions = {
                    'x': pointX,
                    'y': pointY,
                    'height': this.model.qualitativeRangeSize,
                    'width': (width > 0) ? (width < scaleLength ? width : scaleLength) : 0,
                    'fill': data.rangeOptions.rangeStroke,
                    'opacity': data.rangeOptions.rangeOpacity
                };
                ((isHorizontal && isForward) || (!isHorizontal && !isForward)) ? this._rangeCollection.push(width) : this._rangeCollection.push(pointX);                
                this.svgRenderer.drawRect(rangeOptions, scaleGroup);
            }
            this._rangeCollection.sort(this._sortRangeCollection);
        },
      
        _sortRangeCollection: function (a, b) {
            return (a - b);
        },
      
        _calculateFeatureMeasureBounds: function (value, categoryValue) {
            var min = this._scale.minimum;
            value = (value < min && min < 0) ? min : value;                
            if (value >= min) {
                var x, lx, width;
                var locX = this._scale.location.x;
                var scaleLength = this.model.quantitativeScaleLength;
                var diff = this._scale.maximum - this._scale.minimum;
                var valueDiff = this._scale.maximum - value;
                var orientation = this._flowDirection.toLowerCase() + this._orientation.toLowerCase();
                categoryValue = (categoryValue == null) ? "" : categoryValue;
                var font = this._scale.labelSettings.font;
                font.size = this._scale.labelSettings.size;
                var stringLength = ej.EjSvgRender.utils._measureText(categoryValue.toString(), null, font).width;

                switch (orientation) {
                    case 'forwardhorizontal':
                    case 'backwardvertical':                        
                            x = locX + ((min > 0) ? 0 : scaleLength / diff * Math.abs(min));
                            width = scaleLength / (diff / ( (min > 0) ? diff - valueDiff : value));                            
                            if (value < 0) {
                                width = Math.abs(width);
                                x -= width;
                            }
                            width = (x + width < locX + scaleLength) ? width : locX + scaleLength - x;
                            lx = locX - ((orientation == 'forwardhorizontal') ? (stringLength / 2 + this._scale.labelSettings.offset) : this._scale.labelSettings.offset);
                            break;
                    default:
                        x = locX + (scaleLength - scaleLength / (diff / (diff - valueDiff)));
                        width = (min > 0) ? scaleLength / (diff / (diff - valueDiff)) : scaleLength / (diff / (value));
                        if (value < 0) {
                            width = Math.abs(width);
                            x -= width;
                        }
                        if (x < locX ) {
                            width = x + width - locX;
                            x = locX;
                        }                        
                        lx = locX + scaleLength + ((orientation == 'backwardhorizontal') ? (stringLength / 2 + this._scale.labelSettings.offset) : this._scale.labelSettings.offset);
                        break;
                }
                return { pointX: x, Width: width, lPointX: lx };
            }
            return false;
        },
      
        _drawFeatureMeasureBar: function () {
            var j = 1, count, value, categoryValue;
            var pointY, lPointY, locale = this.model.locale, localizedText = locale && this.model.enableGroupSeparator;
            var isDataFields = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null);
            var isVertical = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Vertical);
            var bulletValue = (typeof (this.model.value) == 'function') ? this._value() : this.model.value;
            if (this._dataCount > 0) {
                for (var i = this._dataCount - 1; i >= 0; i--) {
                    value = isDataFields ? this.model.fields["dataSource"][i][this.model.fields.featureMeasures] : (ej.isNullOrUndefined(this._scale.featureMeasures[i].value) ? bulletValue : this._scale.featureMeasures[i].value);
                    categoryValue = isDataFields ? this.model.fields["dataSource"][i][this.model.fields.category] : this._scale.featureMeasures[i].category;

                    pointY = this._scale.location.y + (((this.model.qualitativeRangeSize / this._dataCount) * j) / 2) - (this._scale.featuredMeasureSettings.width / 2);
                    lPointY = this._scale.location.y + (((this.model.qualitativeRangeSize / this._dataCount) * j) / 2) + (this._scale.featuredMeasureSettings.width / 2) - 1;

                    var bounds = this._calculateFeatureMeasureBounds(value, categoryValue);
                    if (bounds) {

                        var featureBarOptions = this._featureBar(this._scale, bounds.pointX, pointY, bounds.Width, i);
                        if (this.model.drawFeatureMeasureBar) {
                            var data = { featuredMeasureSettings: this._scale.featuredMeasureSettings };
                            this._trigger("drawFeatureMeasureBar", data);
                            featureBarOptions = this._featureBar(data, bounds.pointX, pointY, bounds.Width, i);
                        }
                        this.svgRenderer.drawRect(featureBarOptions, this._scaleGroup);

                        if (isVertical)
                            transformText = 'rotate(' + 90 + ',' + bounds.lPointX + ',' + (lPointY - 4) + ')';
                        else
                            transformText = 'rotate(' + 0 + ',' + bounds.lPointX + ',' + lPointY + ')';


                        var categoryOptions = this._drawcategory(this.model.quantitativeScaleSettings.labelSettings, bounds.lPointX, lPointY);
                        if (this.model.drawCategory) {
                            var data = { size: this.model.quantitativeScaleSettings.labelSettings.size, stroke: this.model.quantitativeScaleSettings.labelSettings.stroke, font: this.model.quantitativeScaleSettings.labelSettings.font, categoryValue: categoryValue };
                            this._trigger("drawCategory", data);
                            categoryOptions = this._drawcategory(data, bounds.lPointX, lPointY);
                            categoryValue = data.categoryValue;
                        }
                        if (!ej.isNullOrUndefined(categoryValue))
                            this.svgRenderer.drawText(categoryOptions, localizedText ? categoryValue.toLocaleString(locale) : categoryValue, this._scaleGroup);
                        j += 2;
                        this.value(value);
                    }
                }

            }
        },
        _drawcategory: function (category, lPointX, lPointY) {
            var categoryOptions = {
                'x': lPointX,
                'y': lPointY + (this._scale.featuredMeasureSettings.width / 2),
                'text-anchor': 'middle',
                'fill': category.stroke,
                'font-size': category.size + "px",
                'font-family': category.font.fontFamily,
                'font-style': category.font.fontStyle,
                'font-weight': category.font.fontWeight,
                'opacity': category.font.opacity,
                'transform': transformText
            };
            return categoryOptions;
        },
        _featureBar: function (data, pointX, pointY, width, i) {
            var featureBarOptions = {
                'class': this.svgObject.id + "_FeatureMeasure",
                'id': this.svgObject.id + "_FeatureMeasure_" + i,
                'x': pointX,
                'y': pointY,
                'height': data.featuredMeasureSettings.width,
                'width': width,
                'fill': data.featuredMeasureSettings.stroke            
            };           
            return featureBarOptions;
        },
       
        _drawComparativeMeasureSymbol: function () {
            var j = 1, value;
            var y1, y2, x1;

            var isForward = (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward);
            var isHorizontal = (this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal);
            var bulletCMValue = (typeof (this.model.comparativeMeasureValue) == 'function') ? this._comparativeMeasureValue() : this.model.comparativeMeasureValue;
            if (this._dataCount > 0) {
                for (var i = this._dataCount - 1; i >= 0; i--) {
                    value = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) ? this.model.fields["dataSource"][i][this.model.fields.comparativeMeasure] : (ej.isNullOrUndefined(this._scale.featureMeasures[i].comparativeMeasureValue) ? bulletCMValue : this._scale.featureMeasures[i].comparativeMeasureValue);
                    if (value >= this._scale.minimum && value <= this._scale.maximum) {
                        y1 = this._scale.location.y + (((this.model.qualitativeRangeSize / this._dataCount) * j) / 2) - (this._scale.featuredMeasureSettings.width / 2) - this._scale.featuredMeasureSettings.width;
                        y2 = this._scale.location.y + (((this.model.qualitativeRangeSize / this._dataCount) * j) / 2) - (this._scale.featuredMeasureSettings.width / 2) + (2 * this._scale.featuredMeasureSettings.width);
                        
                        if (isForward)
                            x1 = isHorizontal ? this._scale.location.x + (this.model.quantitativeScaleLength / ((this._scale.maximum - this._scale.minimum) / ((this._scale.maximum - this._scale.minimum) - (this._scale.maximum - value)))) : this._scale.location.x + (this.model.quantitativeScaleLength - (this.model.quantitativeScaleLength / ((this._scale.maximum - this._scale.minimum) / ((this._scale.maximum - this._scale.minimum) - (this._scale.maximum - value)))));
                        else
                            x1 = isHorizontal ? this._scale.location.x + (this.model.quantitativeScaleLength - (this.model.quantitativeScaleLength / ((this._scale.maximum - this._scale.minimum) / ((this._scale.maximum - this._scale.minimum) - (this._scale.maximum - value))))) : this._scale.location.x + (this.model.quantitativeScaleLength / ((this._scale.maximum - this._scale.minimum) / ((this._scale.maximum - this._scale.minimum) - (this._scale.maximum - value))));

                        var compareMeasureOptions = this._compareMeasure(this._scale, x1, y1, y2, i, value);
                        if (this.model.drawComparativeMeasureSymbol) {
                            var data = { comparativeMeasureSettings: this._scale.comparativeMeasureSettings };
                            this._trigger("drawComparativeMeasureSymbol", data);
                            compareMeasureOptions = this._compareMeasure(data, x1, y1, y2, i, value);
                        }
                       
                        this.svgRenderer.drawLine(compareMeasureOptions, this._scaleGroup);
                        j += 2;
                        this.comparativeMeasureValue(value);
                    }
                }
            }
        },
        _compareMeasure: function(data, x1, y1, y2, i, value){
            var compareMeasureOptions = {
                'class': this.svgObject.id + "_ComparativeMeasure",
                'id': this.svgObject.id + "_ComparativeMeasure_" + i,
                'x1': (value == this._scale.maximum) ? x1 - (data.comparativeMeasureSettings.width / 2) : (value == this._scale.minimum) ? x1 + (data.comparativeMeasureSettings.width / 2) : x1,
                'y1': y1,
                'x2': (value == this._scale.maximum) ? x1 - (data.comparativeMeasureSettings.width / 2) : (value == this._scale.minimum) ? x1 + (data.comparativeMeasureSettings.width / 2) : x1,
                'y2': y2,
                'stroke-width': data.comparativeMeasureSettings.width,
                'stroke': data.comparativeMeasureSettings.stroke
            };
            return compareMeasureOptions;
        },
       
        _setTheme: function (jsonObj, themeName) {
            var result = [];
            this._scale = this.model.quantitativeScaleSettings;
            for (var name in jsonObj) {
                result.push(name);
            }
            for (var i = 0; i < result.length; i++) {
                this._scale.majorTickSettings.stroke = ((!this._scale.majorTickSettings.stroke || this._scale.majorTickSettings.stroke == jsonObj[result[i]].quantitativeScaleSettings.majorTickSettings.stroke) ? jsonObj[themeName].quantitativeScaleSettings.majorTickSettings.stroke : this._scale.majorTickSettings.stroke);
                this._scale.minorTickSettings.stroke = ((!this._scale.minorTickSettings.stroke || this._scale.minorTickSettings.stroke == jsonObj[result[i]].quantitativeScaleSettings.minorTickSettings.stroke) ? jsonObj[themeName].quantitativeScaleSettings.minorTickSettings.stroke : this._scale.minorTickSettings.stroke);
                this._scale.labelSettings.stroke = ((!this._scale.labelSettings.stroke || this._scale.labelSettings.stroke == jsonObj[result[i]].quantitativeScaleSettings.labelSettings.stroke) ? jsonObj[themeName].quantitativeScaleSettings.labelSettings.stroke : this._scale.labelSettings.stroke);
                this._scale.featuredMeasureSettings.stroke = ((!this._scale.featuredMeasureSettings.stroke || this._scale.featuredMeasureSettings.stroke == jsonObj[result[i]].quantitativeScaleSettings.featuredMeasureSettings.stroke) ? jsonObj[themeName].quantitativeScaleSettings.featuredMeasureSettings.stroke : this._scale.featuredMeasureSettings.stroke);
                this._scale.comparativeMeasureSettings.stroke = ((!this._scale.comparativeMeasureSettings.stroke || this._scale.comparativeMeasureSettings.stroke == jsonObj[result[i]].quantitativeScaleSettings.comparativeMeasureSettings.stroke) ? jsonObj[themeName].quantitativeScaleSettings.comparativeMeasureSettings.stroke : this._scale.comparativeMeasureSettings.stroke);
                this.model.captionSettings.font.color = ((!this.model.captionSettings.font.color || this.model.captionSettings.font.color == jsonObj[result[i]].captionSettings.font.color) ? jsonObj[themeName].captionSettings.font.color : this.model.captionSettings.font.color);
                this.model.captionSettings.subTitle.font.color = ((!this.model.captionSettings.subTitle.font.color || this.model.captionSettings.subTitle.font.color == jsonObj[result[i]].captionSettings.subTitle.font.color) ? jsonObj[themeName].captionSettings.subTitle.font.color : this.model.captionSettings.subTitle.font.color);
                this.model.captionSettings.indicator.font.color = ((!this.model.captionSettings.indicator.font.color || this.model.captionSettings.indicator.font.color == jsonObj[result[i]].captionSettings.indicator.font.color) ? jsonObj[themeName].captionSettings.indicator.font.color : this.model.captionSettings.indicator.font.color);
                this.model.captionSettings.indicator.symbol.color = ((!this.model.captionSettings.indicator.symbol.color || this.model.captionSettings.indicator.symbol.color == jsonObj[result[i]].captionSettings.indicator.symbol.color) ? jsonObj[themeName].captionSettings.indicator.symbol.color : this.model.captionSettings.indicator.symbol.color);
                for (var j = 0; j < this.model.qualitativeRanges.length; j++)
                    this.model.qualitativeRanges[j].rangeStroke = ((!this.model.qualitativeRanges[j].rangeStroke) ? (ej.isNullOrUndefined(jsonObj[themeName].qualitativeRanges[j]) ? jsonObj[themeName].qualitativeRanges[0].rangeStroke : jsonObj[themeName].qualitativeRanges[j].rangeStroke) : this.model.qualitativeRanges[j].rangeStroke);
            }
            //            this.model = $.extend(true, this.model, jsonObj[themeName], this.model);
        },

      
       
        _onDrawQualitativeRanges: function (rangeOptions, rangeEnd, rangeIndex) {
            var data = { object: this, scaleElement: this.model.quantitativeScaleSettings, rangeIndex: rangeIndex, rangeElement: rangeOptions, rangeEndValue: rangeEnd };
            this._trigger("drawQualitativeRanges", data);
        },
        
       
        _doAnimation: function () {
            var elements = $("." + this.svgObject.id + "_FeatureMeasure");
            for (var i = elements.length - 1; i >= 0; i--) {
                var element = elements[i];
                this._animateFeatureBar(element);
            }
        },
      
        _doLineAnimation: function () {
            var compareElements = $("." + this.svgObject.id + "_ComparativeMeasure");
            var secondsPerPoint = 2000 / compareElements.length;
            for (var i = compareElements.length - 1; i >= 0; i--) {
                var element = compareElements[i];
                $(element).attr("transform", "scale(0)");
                this._doLineSymbol(element, secondsPerPoint, i);
            }
        },
       
        _animateFeatureBar: function (element) {
            var box = element.getBBox();
            var left, top;
            if (((this._orientation == ej.datavisualization.BulletGraph.Orientation.Horizontal) && (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Backward)) || ((this._orientation == ej.datavisualization.BulletGraph.Orientation.Vertical) && (this._flowDirection == ej.datavisualization.BulletGraph.FlowDirection.Forward))) {
                left = box.x + box.width;
                top = box.y + box.height;
            }
            else {
                left = box.x;
                top = box.y;
            }
            $(element).animate(
            {
                scale: 1
            },
            {
                duration: 1000,

                step: function (now) {
                    scaleVal = now;
                    $(element).attr("transform", "translate(" + left + " " + top + ") scale(" + now + ",1) translate(" + (-left) + " " + (-top) + ")");
                }
            });
        },
      
        _doLineSymbol: function (element, sec, val) {
            var beginTime = parseInt(val * sec);
            var box = element.getBBox();
            var centerX = box.x + (box.width / 2);
            var centerY = box.y + (box.height / 2);
            $(element).delay(beginTime).animate(
                {
                    scale: 1
                },
                {
                    duration: 200,
                    step: function (now) {
                        $(element).attr("transform", "translate(" + centerX + " " + centerY + ") scale(" + now + ") translate(" + (-centerX) + " " + (-centerY) + ")");
                    }
                });
        },
      
        bindEvents: function () {
            var browserInfo = ej.EjSvgRender.utils.browserInfo(),
            isPointer = browserInfo.isMSPointerEnabled,
            isIE11Pointer = browserInfo.pointerEnabled,
            touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
            touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
            touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
            touchCancelEvent = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchleave mouseleave";
            this.model.browserInfo = browserInfo;

            this._on($(this.svgObject), touchMoveEvent, this._bulletMouseMove);
            this._on($(this.svgObject), touchCancelEvent, this._bulletMouseLeave);
            this._on($(this.svgObject), touchStartEvent, this._bulletMouseDown);
            this._on($(this.svgObject), touchStopEvent, this._bulletMouseUp);
			 
            if (this.model.enableResizing || this.model.isResponsive) {
                if (!ej.isTouchDevice())
                    this._on($(window), "resize", this._bulletResize);
                else
                    this._on($(window), "orientationchange", this._bulletResize);
            }
        },
       
        isDevice: function () {
            // return (/mobile|tablet|android|kindle/i.test(navigator.userAgent.toLowerCase()));
            // comment above line temporary. Due to the below code event wont bind for tablet device
            return (/mobile|tablet|android|kindle/i.test(navigator.userAgent.toLowerCase()));
        },
       
        _bulletResize: function () {
            var bullet = this,
				height = this.model.height,
				width = this.model.width;
            var $svgObj = $(bullet.svgObject);
            var height = 90;
            var width = (ej.isTouchDevice()) ? 250 : 595;
            var containerWidth = $(bullet.element).width();
            if (bullet.model.width)
                width = parseInt(bullet.model.width);
            else if (containerWidth > 0 && containerWidth < 595)
                width = containerWidth;
            else if(containerWidth > 595)
                width = 595;
            if (bullet.model.height)
                height = parseInt(bullet.model.height);
            var containerHeight = $(bullet.element).height() > height ? height : $(bullet.element).height();
            if (this.resizeTO) clearTimeout(this.resizeTO);
            this.resizeTO = setTimeout(function () {
				if(width < $(bullet.element).width())
					$svgObj.width(width);
				else
					$svgObj.width($(bullet.element).width());
                $svgObj.height(containerHeight);
                bullet.redraw();
            }, 500);
        },
		
        _bulletMouseLeave: function (evt) {
            if (!this.isTouch(evt)) {
                $('#tooltip').remove();
                $(".tooltipDiv" + this._id).remove();            
            }
		},
		isTouch: function (evt) {
		    var event = evt.originalEvent ? evt.originalEvent : evt;
		    if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
		        return true;
		    return false;
		},
       
        _bulletMouseMove: function (evt) {
            var currentVal, targetVal, categoryVal, measureId, targetId, targetClass;        
            targetId = $(evt.target).attr("id"),
            targetClass = $(evt.target).attr("class");           
            if (!this.isTouch(evt)) {
                $('#tooltip').remove();
                $(".tooltipDiv" + this._id).remove();
                this._elementTooltip(evt, targetClass, targetId);
                this._displayTooltip(evt, targetClass, targetId);
            }
         
        },

        _bulletMouseDown: function (evt) {
            if (this.isTouch(evt)) {
                evt.preventDefault();                 
                $('#tooltip').remove();
                $(".tooltipDiv" + this._id).remove();
                var targetId = $(evt.target).attr("id"),
                    targetClass = $(evt.target).attr("class");
                this._elementTooltip(evt, targetClass, targetId);
                this._displayTooltip(evt, targetClass, targetId);
            }
        },
        _bulletMouseUp: function (evt) {
            if (this.isTouch(evt)) {
                var bullet = this, element;
                window.clearTimeout(bullet.model.timer);
                if ($(".tooltipDiv" + this._id).length == 1)
                    element = $(".tooltipDiv" + this._id);
                if (element) {                   
                    bullet.model.trackerElement = element;
                    bullet.model.timer = setTimeout(function () {
                        if (bullet.model.trackerElement)
                            $(".tooltipDiv" + bullet._id).fadeOut(500, function () {
                                $(".tooltipDiv" + bullet._id).remove();
                                $("[id*=" + bullet.svgObject.id + "_FeatureMeasure_" + "]").attr("opacity", "1");
                            });
                    }, 1200);
                }
            }
        },

        _elementTooltip: function (evt,targetClass, targetId) {             
            var captionSettings = this.model.captionSettings,
             tooltipdiv = $("<div></div>").attr({ 'id': 'tooltip', "class": "tooltipDiv" + this._id }),
             pointer = this.mousePosition(evt);
             str = "";
            // adding css prop to the div
            $(tooltipdiv).css({
                "left": pointer.pageX + 10,
                "top": pointer.pageY + 10,
                "display": "block",
                "position": "absolute",
                "z-index": "13000",
                "cursor": "default",
                "font-family": "Segoe UI",
                "color": "#707070",
                "font-size": "12px",
                "background-color": "#FFFFFF",
                "border": "1px solid #707070"
            });
            if (targetClass == this.svgObject.id + "_Caption")
                str = evt.target.textContent == captionSettings.text ? "" : captionSettings.text;
            else if (targetClass == this.svgObject.id + "_SubTitle")
                str = evt.target.textContent == captionSettings.subTitle.text ? "" : captionSettings.subTitle.text;
            else if (targetClass == this.svgObject.id + "_Indicator")
                str = evt.target.textContent == captionSettings.indicator.text ? "" : captionSettings.indicator.text;
            if (str != "") {
                $(tooltipdiv).html("&nbsp" + str + "&nbsp");
                $(document.body).append(tooltipdiv);
            }
            else if (this.model.tooltipSettings.enableCaptionTooltip && (targetClass == this.svgObject.id + '_Caption' || targetClass == this.svgObject.id + '_SubTitle' || targetClass == this.svgObject.id + '_Indicator')) {
                var text = $('.' + targetClass).text();
                var data = { Text: text };
                var template = this.model.tooltipSettings.captionTemplate;
                if ($('.tooltipDiv' + this._id).length == 0) {
                    tooltipdiv = $("<div></div>").attr('class', 'tooltipDiv' + this._id).css({ 'position': 'absolute', 'z-index': '13000', 'display': 'block' });                   
                    $(document.body).append(tooltipdiv);
                    
                }
                if (template != "" && template != null) {
                    var cloneNode = document.getElementById(template);
                    cloneNode = (cloneNode ? $(cloneNode).clone() : $(template));
                    $(cloneNode).css("display", "block").appendTo(tooltipdiv);
                    $(tooltipdiv).html($(cloneNode).render(data));
                } else {
                    $(tooltipdiv).html(text);
                }
                $(tooltipdiv).css('font-size', '12px');
                var xPos = pointer.clientX + $(document).scrollLeft() + 10;
                var yPos = pointer.clientY + $(document).scrollTop() + 10;
                xPos = ((xPos + $(tooltipdiv).width()) < $(window).width()) ? (xPos) : (xPos - $(tooltipdiv).width());
                yPos = ((yPos + $(tooltipdiv).height()) < $(window).height()) ? (yPos) : (yPos - $(tooltipdiv).height());

                if (xPos === undefined || xPos === null)
                    xPos = pointer.clientX + $(document).scrollLeft() + 10;
                if (yPos === undefined || yPos === null)
                    yPos = pointer.clientY + $(document).scrollTop() + 10;
                $(tooltipdiv).css({
                    'left': xPos,
                    'top': yPos,
                    '-webkit-border-radius': "5px 5px 5px 5px",
                    '-moz-border-radius': "5px 5px 5px 5px",
                    '-o-border-radius': "5px 5px 5px 5px",
                    'border-radius': "5px 5px 5px 5px",
                    'background-color': "White",
                    'border': "1px Solid Black",
                    'padding-bottom': "5px",
                    'padding-left': "5px",
                    'padding-right': "5px",
                    'padding-top': "5px"
                });

            }
        },
        mousePosition: function (evt) {
            if (!ej.util.isNullOrUndefined(evt.pageX) && evt.pageX > 0)
                return evt;
            else if (evt.originalEvent && !ej.util.isNullOrUndefined(evt.originalEvent.pageX) && evt.originalEvent.pageX > 0)
                return evt.originalEvent;
            else if (evt.originalEvent && evt.originalEvent.changedTouches != undefined) {
                if (!ej.util.isNullOrUndefined(evt.originalEvent.changedTouches[0].pageX) && evt.originalEvent.changedTouches[0].pageX > 0)
                    return evt.originalEvent.changedTouches[0];
            }
            return evt;

        },
        _displayTooltip: function (evt, targetClass, targetId) {
            if (targetClass != "undefined" && (targetClass == this.svgObject.id + '_FeatureMeasure' || targetClass == this.svgObject.id + '_ComparativeMeasure')) {
				var locale = this.model.locale, localizedText = locale && this.model.enableGroupSeparator, data;
                var bulletValue = (typeof (this.model.value) == 'function') ? this._value() : this.model.value,
                 bulletCMValue = (typeof (this.model.comparativeMeasureValue) == 'function') ? this._comparativeMeasureValue() : this.model.comparativeMeasureValue,
                 pointer = this.mousePosition(evt);
                measureId = targetId.substring(targetId.lastIndexOf("_") + 1);
                currentVal = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) ? this.model.fields["dataSource"][measureId][this.model.fields.featureMeasures] : (ej.isNullOrUndefined(this._scale.featureMeasures[measureId].value) ? bulletValue : this._scale.featureMeasures[measureId].value);
                targetVal = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) ? this.model.fields["dataSource"][measureId][this.model.fields.comparativeMeasure] : (ej.isNullOrUndefined(this._scale.featureMeasures[measureId].comparativeMeasureValue) ? bulletCMValue : this._scale.featureMeasures[measureId].comparativeMeasureValue);
                categoryVal = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) ? (ej.isNullOrUndefined(this.model.fields["dataSource"][measureId][this.model.fields.category])) ? null : this.model.fields["dataSource"][measureId][this.model.fields.category] : (ej.isNullOrUndefined(this._scale.featureMeasures[measureId].category)) ? null : this._scale.featureMeasures[measureId].category;
				if (localizedText)
					data = {currentValue: currentVal.toLocaleString(locale), targetValue: targetVal.toLocaleString(locale), 
							category: (!ej.util.isNullOrUndefined(categoryVal) ? categoryVal.toLocaleString(locale) : categoryVal)};
				else
					data = {currentValue: currentVal, targetValue: targetVal, category: categoryVal};
                if ($('.tooltipDiv' + this._id).length == 0) {
                    tooltipdiv = $("<div></div>").attr('class', 'tooltipDiv' + this._id).css({ 'position': 'absolute', 'z-index': '13000', 'display': 'block' });                  
                    $(document.body).append(tooltipdiv);                   
                }
                if (this.model.tooltipSettings.template != "" && this.model.tooltipSettings.template != null) {
                    var cloneNode = $("#" + this.model.tooltipSettings.template).clone();
                    $(cloneNode).css("display", "block").appendTo(tooltipdiv);
                    $(tooltipdiv).html($(cloneNode).render(data));
                } else {
                    var category = (!ej.isNullOrUndefined(data.category)) ? ("<br/> Category : " + data.category) : "";
                    $(tooltipdiv).html("Current : " + data.currentValue + "<br/> Target : " + data.targetValue + category);
                }
                $(tooltipdiv).css("font-size", "12px");
                var xPos = pointer.clientX + $(document).scrollLeft() + 10;
                var yPos = pointer.clientY + $(document).scrollTop() + 10;
                xPos = ((xPos + $(tooltipdiv).width()) < $(window).width()) ? (xPos) : (xPos - $(tooltipdiv).width());
                yPos = ((yPos + $(tooltipdiv).height()) < $(window).height()) ? (yPos) : (yPos - $(tooltipdiv).height());

                if (xPos === undefined || xPos === null)
                    xPos = pointer.clientX + $(document).scrollLeft() + 10;
                if (yPos === undefined || yPos === null)
                    yPos = pointer.clientY + $(document).scrollTop() + 10;
                $(tooltipdiv).css({
                    'left': xPos,
                    'top': yPos,
                    '-webkit-border-radius': "5px 5px 5px 5px",
                    '-moz-border-radius': "5px 5px 5px 5px",
                    '-o-border-radius': "5px 5px 5px 5px",
                    'border-radius': "5px 5px 5px 5px",
                    'background-color': "White",
					'color':"black",
                    'border': "1px Solid Black",
                    'padding-bottom': "5px",
                    'padding-left': "5px",
                    'padding-right': "5px",
                    'padding-top': "5px"
                });
                if (targetClass == this.svgObject.id + '_FeatureMeasure')
                    $("#" + targetId).attr("opacity", "0.7");
            }          
            
        },

       
        redraw: function () {
            $(this.svgObject).empty();
            this._renderBulletElements();
        },
        
        destroy: function () {
            $(this.element).removeClass("e-bulletgraph e-js").find("#" + this.svgObject.id).remove();
        },
          
        setFeatureMeasureBarValue: function (index, measureValue) {
            this._scale = this.model.quantitativeScaleSettings;
            var length = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) ? this.model.fields["dataSource"].length : this._scale.featureMeasures.length;   
            if (index < length && measureValue != null) {
                if (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null)
                    this.model.fields["dataSource"][index][this.model.fields.featureMeasures] = measureValue;
                else
                    this._scale.featureMeasures[index].value = measureValue;
                this.redraw();
                if (this.model.enableAnimation)
                    this._doAnimation();
            }
        },
          
        setComparativeMeasureSymbol: function (index, measureValue) {
            this._scale = this.model.quantitativeScaleSettings;
            var length = (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) ? this.model.fields["dataSource"].length : this._scale.featureMeasures.length;   
            if (index < length && measureValue != null) {
                if (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null)
                    this.model.fields["dataSource"][index][this.model.fields.comparativeMeasure] = measureValue;
                else
                    this._scale.featureMeasures[index].comparativeMeasureValue = measureValue;
                this.redraw();
                if (this.model.enableAnimation)
                    this._doLineAnimation();
            }
        }

    });
      
    ej.datavisualization.BulletGraph.Orientation = {
          
        Horizontal: "horizontal",
          
        Vertical: "vertical"
    };
      
    ej.datavisualization.BulletGraph.TickPlacement = {
          
        Inside: "inside",
          
        Outside: "outside"
    };
      
    ej.datavisualization.BulletGraph.LabelPlacement = {
          
        Inside: "inside",
          
        Outside: "outside"
    };
      
    ej.datavisualization.BulletGraph.Shape = {
          
        Circle: "circle",
          
        Cross: "cross",
          
        Diamond: "diamond",
          
        DownArrow: "downarrow",
          
        Ellipse: "ellipse",
          
        HorizontalLine: "horizontalLine",
          
        Image: "image",
          
        InvertedTriangle: "invertedtriangle",
          
        LeftArrow: "leftarrow",
          
        Pentagon: "pentagon",
          
        Rectangle: "Rectangle",
          
        RightArrow: "rightarrow",
          
        Star: "star",
          
        Trapezoid: "trapezoid",
          
        Triangle: "triangle",
          
        UpArrow: "uparrow",
          
        VerticalLine: "verticalline",
          
        Wedge: "wedge",
    };
      
    ej.datavisualization.BulletGraph.TickPosition = {
          
        Far: "far",
          
        Near: "near",
          
        Center: "center"
    };
      
    ej.datavisualization.BulletGraph.LabelPosition = {
          
        Below: "below",
          
        Above: "above"
    };
      
    ej.datavisualization.BulletGraph.FlowDirection = {
          
        Forward: "forward",
          
        Backward: "backward"
    };
      
    ej.datavisualization.BulletGraph.FontStyle = {
          
        Normal: "Normal",
          
        Italic: "Italic",
          
        Oblique: "Oblique"
    };
      
    ej.datavisualization.BulletGraph.FontWeight = {
          
        Normal: "Normal",
          
        Bold: "Bold",
          
        Bolder: "Bolder",
          
        Lighter: "Lighter"
    };
      
    ej.datavisualization.BulletGraph.Themes = {
          
        flatlight: {
            quantitativeScaleSettings: {
                majorTickSettings: { stroke: "#191919" },
                minorTickSettings: { stroke: "#191919" },
                labelSettings: {
                    stroke: "#191919"
                },
                featuredMeasureSettings: { stroke: "#191919" },
                comparativeMeasureSettings: { stroke: "#191919" }
            },
            qualitativeRanges: [{
                rangeStroke: "#ebebeb"
            }, {
                rangeStroke: "#d8d8d8"
            }, {
                rangeStroke: "#7f7f7f"
            }],
            captionSettings: {
                font: { color: "#191919" },
                subTitle: {
                    font: { color: "#191919" }
                },
                indicator: {
                    font: { color: "#191919" },
                    symbol: { color: "#191919" }
                }
            }
        },
        material: {
            quantitativeScaleSettings: {
                majorTickSettings: { stroke: "#333333" },
                minorTickSettings: { stroke: "#191919" },
                labelSettings: {
                    stroke: "#333333"
                },
                featuredMeasureSettings: { stroke: "#333333" },
                comparativeMeasureSettings: { stroke: "#333333" }
            },
            qualitativeRanges: [{
                rangeStroke: "#ebebeb"
            }, {
                rangeStroke: "#d8d8d8"
            }, {
                rangeStroke: "#7f7f7f"
            }],
            captionSettings: {
                font: { color: "#333333" },
                subTitle: {
                    font: { color: "#333333" }
                },
                indicator: {
                    font: { color: "#333333" },
                    symbol: { color: "#333333" }
                }
            }
        },
          
        flatdark: {
              
            quantitativeScaleSettings: {
                majorTickSettings: { stroke: "#ffffff" },
                minorTickSettings: { stroke: "#ffffff" },
                labelSettings: {
                    stroke: "#ffffff"
                },
                featuredMeasureSettings: { stroke: "#ffffff" },
                comparativeMeasureSettings: { stroke: "#ffffff" }
            },
            qualitativeRanges: [{
                rangeStroke: "#b3b3b3"
            }, {
                rangeStroke: "#999999"
            }, {
                rangeStroke: "#4d4d4d"
            }],
            captionSettings: {
                font: { color: "#ffffff" },
                subTitle: {
                    font: { color: "#ffffff" }
                },
                indicator: {
                    font: { color: "#ffffff" },
                    symbol: { color: "#ffffff" }
                }
            }
        }
    };

})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html RangeNavigator elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    
    ej.widget("ejRangeNavigator", "ej.datavisualization.RangeNavigator", {

        ejChart: "",

        validTags: ["div"],
       
        defaults: {

            theme: "",

            padding: "0",

            enableAutoResizing: false,

            isResponsive: false,

            allowSnapping: false,


            sizeSettings: {

                width: "",

                height: ""
            },
            _size: {

            },

            locale: "en-US",

            valueType: "datetime",

            valueAxisSettings: {

                rangePadding: 'none',

                range: {

                    min: null,

                    max: null,

                    interval: null
                },

                axisLine:
                    {

                        visible: false
                    },

                font: {

                    size: '0px',
                },

                majorTickLines:
                {

                    width: 0,

                    size: 0,

                    visible: true
                },

                majorGridLines: {

                    visible: false
                },

                visible: false
            },

            rangePadding: "none",

            enableRTL: false,

            enableScrollbar: false,

            dataSource: "",

            xName: "x",

            yName: "y",

            tooltipSettings: {

                visible: true,

                labelFormat: "MM/dd/yyyy",

                tooltipDisplayMode: "always",

                backgroundColor: "#303030",

                font:
                {

                    color: '#FFFFFF',

                    family: 'Segoe UI',

                    fontStyle: 'Normal',

                    size: '10px',
                    opacity: 1,

                    weight: 'regular'
                }
            },

            zoomPosition: "0",

            zoomFactor: "1",

            selectedRangeSettings: {

                start: "",

                end: ""
            },

            selectedData: "",

            rangeSettings: {

                start: "",

                end: ""
            },

            border: {

                width: 1,

                color: null,

                opacity: 1
            },

            scrollRangeSettings: {

                start: "",

                end: ""
            },

            enableDeferredUpdate: true,

            series: "",

            seriesSettings: "",

            labelSettings: {

                style: {

                    font: {

                        color: '#333333',

                        family: 'Segoe UI',

                        style: 'Normal',

                        size: '10px',

                        opacity: 1,

                        weight: 'regular'
                    },

                    horizontalAlignment: "middle"
                },


                higherLevel: {

                    intervalType: null,

                    style: {

                        font: {

                            color: "black",

                            fontFamily: "Segoe UI",

                            fontStyle: "Normal",

                            size: "12px",

                            opacity: 1,

                            fontWeight: "regular"
                        },

                        horizontalAlignment: "middle"
                    },

                    gridLineStyle: {

                        color: "#B5B5B5",

                        width: 1,

                        dashArray: "20 5 0"
                    },


                    border:
                    {

                        color: "transparent",

                        width: 0.5
                    },

                    fill: "transparent",

                    position: "top",

                    visible: true,

                    labelPlacement: "outside"
                },

                lowerLevel: {

                    intervalType: null,

                    style: {

                        font: {

                            color: "black",

                            fontFamily: "Segoe UI",

                            fontStyle: "Normal",

                            size: "12px",

                            opacity: 1,

                            fontWeight: "regular"
                        },

                        horizontalAlignment: "middle"
                    },

                    gridLineStyle:
                    {
                        color: "#B5B5B5",

                        width: 1,

                        dashArray: ""
                    },

                    border:
                    {

                        color: "transparent",

                        width: 0.5
                    },

                    fill: "transparent",

                    position: "bottom",

                    visible: true,

                    labelPlacement: "outside"
                }
            },

            navigatorStyleSettings: {

                selectedRegionColor: "#EFEFEF",

                unselectedRegionColor: "#5EABDE",

                thumbColor: "#2382C3",

                thumbRadius: 10,

                leftThumbTemplate: null,

                rightThumbTemplate: null,

                thumbStroke: "#303030",

                background: "#dddddd",

                border:
                {

                    color: "transparent",

                    width: 0.5,

                    dashArray: ""
                },

                opacity: 1,

                selectedRegionOpacity: 0,

                unselectedRegionOpacity: 0.3,

                highlightSettings: {

                    enable: false,

                    opacity: 0.5,

                    color: '#006fa0',

                    border: {

                        color: '',

                        width: 1
                    }

                },

                selectionSettings: {

                    enable: false,

                    opacity: 0.5,

                    color: '#0e4a7c',

                    border: {

                        color: '',

                        width: 1
                    }

                },

                majorGridLineStyle:
                {

                    color: "#B5B5B5",

                    visible: true
                },

                minorGridLineStyle:
                {

                    color: "#B5B5B5",

                    visible: true
                },
            },


            loaded: "",

            load: "",

            rangeChanged: "",

            scrollEnd: "",

            scrollStart: "",

            scrollChanged: "",

            selectedRangeStart: "",
            selectedRangeEnd: ""
        },

        dataTypes: {
        
            enableAutoResizing:"boolean",
            isResponsive: "boolean",
            allowSnapping:"boolean",
         
            dataSource: "data",
            tooltipSettings: {
                visible:"boolean",
                labelFormat:"string",
                tooltipDisplayMode:"string",
            },
            
            zoomPosition: "string",
            zoomFactor: "string",
           
            selectedData: "string",
            enableDeferredUpdate: "boolean",
            series: "array",
           
            labelSettings: {
                higherLevel: {
                    intervalType: 'string',
                    position: "string",
                    visible: "boolean",
                    labelPlacement: "string"
                },
                lowerLevel: {
                    intervalType: 'string',
                    position: "string",
                    visible: "boolean",
                    labelPlacement:"string"
                }
            },
            navigatorStyleSettings: {
                thumbRadius:"number",
            },
       
        },

        observables: ["selectedRangeStart", "selectedRangeEnd"],

         _tags: [{
                tag: "series", 
                attr: ["xName", "yName", "dataSource", "enableAnimation",
				[
				     {
				       tag: "points", attr:["x", "y", "text", "isEmpty", "fill", "visible"]
				     }
				 ]				
				],
				 singular:"series"
				                
            } 
         ],

          _selectedRangeStart: ej.util.valueFunction("selectedRangeStart"),
          _selectedRangeEnd: ej.util.valueFunction("selectedRangeEnd"),

		 _series: function (index, property, value, old) {		   
		  this.renderNavigator();
		  this._trigger("refresh");           
        },
		_series_points:function(index, property, value, old){		   
		  this.renderNavigator();
		  this._trigger("refresh");    
		},


        _themes: {
            flatlight: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1 ,weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {                        
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0},
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width:1, dashArray:"15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width:0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#e5e5e5",
                    unselectedRegionColor: "#5EABDE",
                    thumbColor: "#2382C3",
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity:1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity:0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            azurelight: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1,dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#e5e5e5",
                    unselectedRegionColor: "#5EABDE",
                    thumbColor: "#2382C3",
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            limelight: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#e5e5e5",
                    unselectedRegionColor: "#A9CA44 ",
                    thumbColor: "#AECF49",
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            saffronlight: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#e5e5e5",
                    unselectedRegionColor: "#FAA113",
                    thumbColor: "#F9920B",
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            gradientlight: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#bbbbbb", colorStop: "0%" }, { color: "#efefef", colorStop: "15%" }, { color: "#bbbbbb", colorStop: "85%" }, { color: "#efefef", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            gradientazure: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#bbbbbb", colorStop: "0%" }, { color: "#efefef", colorStop: "15%" }, { color: "#bbbbbb", colorStop: "85%" }, { color: "#efefef", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            gradientlime: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI',style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#bbbbbb", colorStop: "0%" }, { color: "#efefef", colorStop: "15%" }, { color: "#bbbbbb", colorStop: "85%" }, { color: "#efefef", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#A5C14A", colorStop: "50%" }, { color: "#738B1F", colorStop: "100%" }],
                    thumbColor: [{ color: "#A5C14A", colorStop: "50%" }, { color: "#738B1F", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            gradientsaffron: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#bbbbbb", colorStop: "0%" }, { color: "#efefef", colorStop: "15%" }, { color: "#bbbbbb", colorStop: "85%" }, { color: "#efefef", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#FEB75B", colorStop: "50%" }, { color: "#ED7E16", colorStop: "100%" }],
                    thumbColor: [{ color: "#FEB75B", colorStop: "50%" }, { color: "#ED7E16", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#303030",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            flatdark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {                        
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#353635",
                    unselectedRegionColor: "#5EABDE",
                    thumbColor: "#2382C3",
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width:0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            material: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#333333', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#333333', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1 },
                    },
                    lowerLevel: {
                        style: { font: { color: '#333333', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#f5f5f5",
                    unselectedRegionColor: "#8d8afd",
                    thumbColor: "#8d8afd",
                    thumbRadius: 10,
                    thumbStroke: "#000000",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },
            office: {
                tooltipSettings: {
                    backgroundColor: "#303030",
                    font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#333333', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#333333', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#B5B5B5", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#333333', family: 'Segoe UI', style: 'Normal', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#eaeaea",
                    unselectedRegionColor: "#0078d7",
                    thumbColor: "#0078d7",
                    thumbRadius: 10,
                    thumbStroke: "#000000",
                    background: "#EFEFEF",
                    border: { color: "#606262", width: 0 },
                    opacity: 1,
                    unselectedRegionOpacity: 0.6,
                    selectedRegionOpacity: 0,
                    majorGridLineStyle: { color: "#8c8c8c", visible: true },
                    minorGridLineStyle: { color: "#8c8c8c", visible: true },
                },
            },

            highcontrast01: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#353635",
                    unselectedRegionColor: "#008000",
                    thumbColor: "#008000",
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.6,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },
            highcontrast02: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#353635",
                    unselectedRegionColor: "#0000ff",
                    thumbColor: "#0000ff",
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.6,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            azuredark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#353635",
                    unselectedRegionColor: "#5EABDE",
                    thumbColor: "#2382C3",
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            limedark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#353635",
                    unselectedRegionColor: "#A9CA44",
                    thumbColor: "#AECF49",
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },
            
            saffrondark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI',style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: "#353635",
                    unselectedRegionColor: "#FAA113",
                    thumbColor: "#F9920B",
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            gradientdark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI',style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#0a0a0a", colorStop: "0%" }, { color: "#282828", colorStop: "15%" }, { color: "#282828", colorStop: "85%" }, { color: "#0a0a0a", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            gradientazuredark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#0a0a0a", colorStop: "0%" }, { color: "#282828", colorStop: "15%" }, { color: "#282828", colorStop: "85%" }, { color: "#0a0a0a", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbColor: [{ color: "#67C1DC", colorStop: "50%" }, { color: "#3D93AA", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            gradientlimedark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI', style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', fontStyle: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1,weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#0a0a0a", colorStop: "0%" }, { color: "#282828", colorStop: "15%" }, { color: "#282828", colorStop: "85%" }, { color: "#0a0a0a", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#A5C14A", colorStop: "50%" }, { color: "#738B1F", colorStop: "100%" }],
                    thumbColor: [{ color: "#A5C14A", colorStop: "50%" }, { color: "#738B1F", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

            gradientsaffrondark: {
                tooltipSettings: {
                    backgroundColor: "#FFFFFF",
                    font: { color: '#1E1E1E', family: 'Segoe UI',style: 'Normal', size: '10px', opacity: 1, weight: 'regular' },
                },
                labelSettings: {
                    style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                    higherLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' }, horizontalAlignment: "left" },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "#FFFFFF", width: 1, dashArray: "15 5 0" },
                    },
                    lowerLevel: {
                        style: { font: { color: '#FFFFFF', family: 'Segoe UI', style: 'Regular', size: '13px', opacity: 1, weight: 'regular' } },
                        border: { color: "transparent", width: 0 },
                        fill: "transparent",
                        gridLineStyle: { color: "transparent", width: 0 },
                    },
                },
                navigatorStyleSettings: {
                    selectedRegionColor: [{ color: "#0a0a0a", colorStop: "0%" }, { color: "#282828", colorStop: "15%" }, { color: "#282828", colorStop: "85%" }, { color: "#0a0a0a", colorStop: "100%" }],
                    unselectedRegionColor: [{ color: "#FEB75B", colorStop: "50%" }, { color: "#ED7E16", colorStop: "100%" }],
                    thumbColor: [{ color: "#FEB75B", colorStop: "50%" }, { color: "#ED7E16", colorStop: "100%" }],
                    thumbRadius: 10,
                    thumbStroke: "#FFFFFF",
                    background: "#FFFFFF",
                    opacity: 0.08,
                    unselectedRegionOpacity: 0.3,
                    selectedRegionOpacity: 0,
                    border: { color: "#FFFFFF", width: 0 },
                    majorGridLineStyle: { color: "#FFFFFF", visible: true },
                    minorGridLineStyle: { color: "#FFFFFF", visible: true },
                },
            },

        },
        /**
                * To configure the properties at runtime using SetModel		
                * @private
                */
        _setModel: function (options) {
            for (var prop in options) {
              //  this.disableAnimation();
                switch (prop) {                   
                    case "theme":
                        this.model._themeChanged = true;
                        this.model.theme = options[prop];
                        this._setTheme(this._themes, this.model.theme);
						break;
                    case "selectedRangeStart":
                        this.model.selectedRangeSettings.start = this._selectedRangeStart();
                        break;
                    case "selectedRangeEnd":
                        this.model.selectedRangeSettings.end = this._selectedRangeEnd();
                        break;
                    default:
                        $.extend(true, this.model, {}, options[prop]);
                }
            }
          //  $(this.svgDocument).empty();		  
            this.bindTo();
			this.renderNavigator(this);
			this._bindevents();
        },
     
        _destroy: function () {
            this.element.empty().removeClass(this.model.cssClass);
        },


        _createSvg: function (element) {

            this.svgSupport = (window.SVGSVGElement) ? true : false;
            this.vmlRendering = !this.svgSupport;
            var bwr = jQuery.uaMatch(navigator.userAgent);
            this.brow = bwr.browser.toLowerCase();
            if (this.svgSupport) {
                //rendering object created
                this.renderer = new ej.EjSvgRender(this.element);
                //Creating svg document
                this.svgns = this.renderer.svgLink;
                this.svgDocument = this.renderer.svgObj;
            }
            else {
                //rendering object created
                this.renderer = new ej.EjVmlRender(this.element);
                //Creating VML document
                this.svgDocument = this.renderer.svgObj;
            }

        },
        _setSVGSize: function () {

            //initializing minimum height and width for the control
            var type = this.model.valueType, height, rangeModel = this.model, size = rangeModel.sizeSettings,
                fontsize = parseFloat(rangeModel.labelSettings.higherLevel.style.font.size);
            if (type == "datetime") {
                this.minHighHeight = fontsize < 20 ?
                    20 :
                    fontsize + 2;
                fontsize = parseFloat(this.model.labelSettings.lowerLevel.style.font.size);
            }
            else
                this.minHighHeight = 0;
            this.minLowHeight = fontsize < 20 ?
                20 :
                fontsize + 2;
            this.scrollbarLoaded = (this.model.scrollObj && this.model.scrollObj[0].scrollbarLoaded) ? true : false;
            //Scrollbar height included on calculating rangenavigator height on update scrollbar with dynamically
            var scrollHeight = this.model.enableScrollbar && this.scrollbarLoaded && this.svgSupport ? 18 : 0;
            height = ($(this.element).height()) ? ($(this.element).height() > this.newHeight ? $(this.element).height() - scrollHeight : $(this.element).height()) :
                      this.newHeight == undefined ? (type == "datetime" ? 120 : 100) : this.newHeight;
            this.minCenterHeight = parseFloat(height) - parseFloat(this.minLowHeight) - parseFloat(this.minHighHeight);

            height = (height <= 0) ? 120 : height;
            this.minHeight = height;
            this.padding = parseFloat(rangeModel.padding);

            //calculating the height and width of the control
            this.newWidth = size.width ? size.width : $(this.element).width();
            this.newHeight = size.height ? size.height :
                ($(this.element).height() && this.newHeight == undefined) > this.minHeight ? $(this.element).height() - scrollHeight : this.minHeight;

            //allocate space for display scrollbar in range control
            this.scrollWidth = this.newWidth - this.padding * 2;
        },
        _setTheme: function (jsonObj, themeName) {
            var name = themeName.toLowerCase();
            if ((name.indexOf("high") >= 0) && (name.indexOf("01") >= 0))
                jsonObj[name] = $.extend(true, {}, jsonObj["highcontrast01"], jsonObj[name]);
            else if ((name.indexOf("high") >= 0) && (name.indexOf("02") >= 0))
                jsonObj[name] = $.extend(true, {}, jsonObj["highcontrast02"], jsonObj[name]);
            else if ((name.indexOf("material") >= 0))
                jsonObj[name] = $.extend(true, {}, jsonObj["material"], jsonObj[name]);
            else if ((name.indexOf("office") >= 0))
                jsonObj[name] = $.extend(true, {}, jsonObj["office"], jsonObj[name]);

            this.model = ej.copyObject({}, this.model, jsonObj[name]);
        },

        _setPositions: function () {
            
            var higherLevel = this.model.labelSettings.higherLevel,
                lowerLevel = this.model.labelSettings.lowerLevel,
                higherposition = higherLevel.position,
                lowerposition = lowerLevel.position,
                highervisible = higherLevel.visible,
                lowervisible = lowerLevel.visible,
                higherlabelplace = higherLevel.labelPlacement,
                lowerlabelplace = lowerLevel.labelPlacement;
            //to initialize the positions of the sliders, labelbars and chart
            if (higherposition === "top" && lowerposition === "bottom") {
                this.centerPosition = this.minHighHeight + 1;
                this.centerHeight = this.newHeight - this.minHighHeight - this.minLowHeight;
                this.bottomPosition = this.minHighHeight + this.centerHeight + 1;                    
            }
            else if ((higherposition === "bottom" && lowerposition === "bottom")) {
                this.centerPosition = 0;
                this.centerHeight = this.newHeight - this.minHighHeight - this.minLowHeight;
                this.bottomPosition = this.minLowHeight + this.centerHeight + 1;

            }
            else if (higherposition === "bottom" && lowerposition === "top") {
                this.centerPosition = this.minLowHeight + 1;
                topPosition = 0;
                this.centerHeight = this.newHeight - this.minHighHeight - this.minLowHeight;
                this.bottomPosition = this.minLowHeight + this.centerHeight + 1;
            }
            else if (higherposition === "top" && lowerposition === "top") {
                this.centerPosition = this.minLowHeight + this.minHighHeight + 1;
                this.centerHeight = this.newHeight - this.minHighHeight - this.minLowHeight;
                this.bottomPosition = this.newHeight;
            }

            if (highervisible === false && lowervisible === false) {
                this.centerPosition = 0;
                this.centerHeight = this.newHeight;
                this.bottomPostion = this.newHeight;
            }
            else if (highervisible === false) {
                this.centerPosition = 0;
                this.centerHeight = this.newHeight - this.minLowHeight;
                this.bottomPosition = this.newHeight;
            }
            else if (lowervisible === false) {
                this.centerPosition = this.minHighHeight + 1;
                this.centerHeight = this.newHeight - this.minHighHeight;
                this.bottomPosition = this.minHighHeight + this.centerHeight + 1;
            }

            if (higherlabelplace === "outside" && lowerlabelplace === "outside") {
                this.sliderPosition = this.centerPosition;
                this.sliderHeight = this.centerHeight;
            }
            else if (higherlabelplace === "outside") {
                this.sliderPosition = this.centerPosition;
                this.sliderHeight = this.newHeight;
            }
            else if (lowerlabelplace === "outside") {
                this.sliderPosition = 0;
                this.sliderHeight = this.centerHeight + this.minHighHeight;
            }
            else {
                this.sliderPosition = 0;
                this.sliderHeight = this.newHeight;
            }
            
        },

        //adding redraw method

        redraw: function (evt) {

            //Set virtual range and enable scrollbar on redraw
            var virtualRange = this.model.scrollRangeSettings,rangeSettings = this.model.rangeSettings, scrollRange, start = virtualRange.start,
                end = virtualRange.end;//,actualScrollRange = this._scrollRangeSettings;
            this.loadScrollbar = false
            if (this.model.enableScrollbar) {
                this.scrollUpdate = true;
                scrollRange = this._scrollRange;
                if (this.model.valueType.toLowerCase() == "datetime") {
                    start = Date.parse(virtualRange.start);
                    end = Date.parse(virtualRange.end);
                    rangeStart = Date.parse(rangeSettings.start);
                    rangeEnd = Date.parse(rangeSettings.end);
                    //actualStart = Date.parse(actualScrollRange.start);
                    //actualEnd = Date.parse(actualScrollRange.end);
                }
                if (!scrollRange || rangeStart < scrollRange.min || scrollRange.max < rangeEnd || scrollRange.min != start || scrollRange.max != end || ej.isNullOrUndefined(this.scrollsvgObj)) {
                    //Load new scrollbar or update for the dynamic virtualRange changes
                    this.loadScrollbar = true;
                    this.scrollbarLoaded = false;
                    $(this.scrollsvgObj).remove();
                }
            }

            this.renderNavigator(this);

        },

        renderNavigator: function (evt) {
            $(this.svgDocument).empty();
            var locale = this.model.locale;
            this.culture = ej.preferredCulture(locale);
            this._localizedLabels = this._getLocalizedLabels();
            this._initializeVariables.call(this, this.model, this.model.series, this.model.seriesSettings);

            this._rootId = $(this.element).attr("id");
            this.leftPadding =parseFloat($("#"+this._rootId).css('padding-left'));

            this._setSVGSize.call(this);
            var type = this.model.valueType;
            //initializing the higherlevel and lowerlevel collections
            this._higherTextNode = [];
            this._higherTotalValues = [];
            this._higherLineLeft = [];
            this._higherTextLeft = [];
            this._lowerTextNode = [];
            this._lowerTotalValues = [];
            this._lowerLineLeft = [];
            this._lowerTextLeft = [];

            //inizialize the higher level and lower level labels regions
            this.labelRegions =[];
            
            //Checking selection and highlight enable
            var labelSettings = this.model.labelSettings,
                higherLevel = labelSettings.higherLevel,
                lowerLevel = labelSettings.lowerLevel,
                valueType = this.model.valueType;

            //calculating positions
            this.centerPosition=0;
            this.bottomPosition = 0;
            this.centerHeight = 0;
            this.sliderPosition = 0;
            this.sliderHeight = 0;
            
            //set positions
            this._setPositions();

            //set initial width and height for the svg document
            this.svgDocument.setAttribute('style', 'overflow:visible;position:relative;display:block');
            if (this.svgSupport) {
                this.svgDocument.setAttribute("height", this.newHeight);
                this.svgDocument.setAttribute("width", this.newWidth);
            }
            else {
                $(this.svgDocument).width(this.newWidth);
                $(this.svgDocument).height(this.newHeight);
            }
            this.model._size.width = this.newWidth;
            this.model._size.height = this.newHeight;
            var commonLoadedEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs);
            commonLoadedEventArgs.data = { model: this.model };
            this._trigger("loaded", commonLoadedEventArgs);
            if (this.model.theme != "")
                this._setTheme(this._themes, this.model.theme);
            //create gradient
            var navigatorStyleSettings = this.model.navigatorStyleSettings;
            var uncolor = navigatorStyleSettings.unselectedRegionColor;
            this.unselectgrad = this.renderer.createGradientElement('unselected', uncolor, 150, 0, 150, 100, this.svgDocument);
            var navibackcolor = navigatorStyleSettings.background;
            this.naviback = this.renderer.createGradientElement('naviback', navibackcolor, 150, 0, 150, 100, this.svgDocument);
            var selcolor = navigatorStyleSettings.selectedRegionColor;
            this.selectedgrad = this.renderer.createGradientElement('selected', selcolor, 150, 0, 150, 100, this.svgDocument);
            var tbColor = navigatorStyleSettings.thumbColor;
            this.tbClr = this.renderer.createGradientElement('thumbClr', tbColor, 150, 0, 150, 100, this.svgDocument);
            
            var border = this.model.border;
            var borderColor = border.color ? border.color :(this.model.enableScrollbar? "#B4B4B4": "transparent");
            //Creating layout for navigator
            var naviLayoutOptions = {
                'id': this._rootId + '_Layout',
                'x': this.padding,
                'width': this.newWidth > 0 ? this.newWidth - this.padding * 2 : 0,
                'height': this.newHeight,
                'fill': 'transparent',
                'stroke-width': border.width,
                'stroke': borderColor,
                'opacity': border.opacity
            };

            this.renderer.drawRect(naviLayoutOptions, this.svgDocument);
            var areaHeight;
            if (type == "numeric")
                areaHeight = this.newHeight - navigatorStyleSettings.border.width - this.minLowHeight;
            else
                areaHeight = this.newHeight - navigatorStyleSettings.border.width - this.minLowHeight - this.minHighHeight;
            //Creating border for navigator
            var naviBorderOptions = {
                'id':this._rootId+'_Border',
                'x':this.padding,
                'y': this.sliderPosition,
                'width': this.newWidth >0 ? this.newWidth-this.padding * 2: 0,
                'height': this.sliderHeight,
                'fill': this.naviback,
                'stroke-width': navigatorStyleSettings.border.width,
                'stroke': navigatorStyleSettings.border.color,
                'opacity': navigatorStyleSettings.opacity,
                'stroke-dasharray': navigatorStyleSettings.border.dashArray,
                
            }

            this.renderer.drawRect(naviBorderOptions, this.svgDocument);

            //creating g tags to group higherlevel and lowerlevel elements(txt,line).
            if ($("#" + this._rootId + 'higherLevel').length == 0)
                this.higherLevel = this.renderer.createGroup({ 'id': this._rootId + 'higherLevel' });
            if ($("#" + this._rootId + 'lowerLevel').length == 0)
                this.lowerLevel = this.renderer.createGroup({ 'id': this._rootId + 'lowerLevel' });
            this.centerLevel = this.renderer.createGroup({ 'id': this._rootId + 'centerLelvel' });
            this.higherLevel.height = this.minHighHeight;
            this.lowerLevel.height = this.minLowHeight;

            //creating g tags to group tooltipSettings
            if (this.model.tooltipSettings.visible && this.svgSupport) {
                this.leftTooltip = this.renderer.createGroup({ 'id': this._rootId + 'leftTooltip' });
                this.rightTooltip = this.renderer.createGroup({ 'id': this._rootId + 'rightTooltip' });

                var leftToolOptions = {
                    'fill': this.model.tooltipSettings.backgroundColor,
                    'd': 'M 0 0 L 0 21 L 64 21 L 64 6 L 70 0 Z'
                };
                this.renderer.drawPath(leftToolOptions, this.leftTooltip);
                var tooltipoptions = this.model.tooltipSettings.font;
                

                var textOptions = {
                    'id': this._rootId + '_LeftToolText',
                    'x': 5,
                    'fill': tooltipoptions.color,
                    'font-size': tooltipoptions.size,
                    'font-family': tooltipoptions.family,
                    'font-style': tooltipoptions.style,
                    'font-weight': tooltipoptions.weight,
                    'text-anchor': 'start',
                    'opacity': tooltipoptions.opacity,
                    'dominant-baseline': 'middle',
                    
                    
                };
                this.renderer.drawText(textOptions, ej.format(new Date(1 / 1 / 2000), "MMMM, yyyy", locale), this.leftTooltip);
                this.leftTxt = this.leftTooltip.childNodes[1];
                var rightToolOptions = {
                    'fill': this.model.tooltipSettings.backgroundColor,
                    'd': 'M 0 0 L 70 0 L 70 21 L 6 21 L 6 6 Z',
                    'horizontal-alignment': 'stretch'
                };
                this.renderer.drawPath(rightToolOptions, this.rightTooltip);
                this.renderer.drawText(textOptions, ej.format(new Date(1 / 1 / 2000), "MMMM, yyyy", locale), this.rightTooltip);
                this.rightTxt = this.rightTooltip.childNodes[1];

             
            }
            //creating g tag for holding chart
            this.chartGView = this.renderer.createGroup({ 'id': this._rootId + 'charView' });
            
            this.renderer.append(this.chartGView, this.svgDocument);
            if (this.model.navigatorStyleSettings.highlightSettings.enable || this.model.navigatorStyleSettings.selectionSettings.enable) {
                this.styleRect = this.renderer.createGroup({ 'id': this._rootId + 'highlightRect' });
                this.renderer.append(this.styleRect, this.svgDocument);
            }
            if(this.model.valueType=="datetime")
            this.renderer.append(this.higherLevel, this.svgDocument);
            this.renderer.append(this.lowerLevel, this.svgDocument);
            this.renderer.append(this.centerLevel, this.svgDocument);
            
            //creating g tag for sliders
            this.leftUnSelected=this.renderer.createGroup({'id':'unselectleft'});
            this.gLeftSlider = this.renderer.createGroup({ 'id': 'leftslider' });
            this.gRightSlider = this.renderer.createGroup({ 'id': 'rightslider' });
            this.gCenterSlider = this.renderer.createGroup({ 'id': 'centerslider' });
            this.rightUnSelected = this.renderer.createGroup({ 'id': 'unselectright' });

            var unLeftSliderOptions = {
                'width': this.newWidth > 0 ? this.newWidth - this.padding * 2 : 0,
                'height': this.sliderHeight,
                'fill':this.unselectgrad,
                'opacity': navigatorStyleSettings.unselectedRegionOpacity,
                'transform': 'translate('+this.padding+',' + this.sliderPosition + ')'
            };
            this.renderer.drawRect(unLeftSliderOptions, this.leftUnSelected);
            this.leftUnArea = this.leftUnSelected.firstChild;
            this.renderer.append(this.leftUnSelected, this.svgDocument);

            var centerSliderOptions = {
                'width': this.newWidth > 0 ? this.newWidth - 4 - this.padding * 2 : 0,
                'height': this.sliderHeight,
                'fill': this.selectedgrad,
                'opacity': navigatorStyleSettings.selectedRegionOpacity,
                'transform': 'translate('+this.padding+','+this.sliderPosition+')'
            };

            this.renderer.drawRect(centerSliderOptions, this.gCenterSlider);
            this.centerSlider = this.gCenterSlider.firstChild;
            $(this.centerSlider).css('cursor', 'pointer');

            this.renderer.append(this.gCenterSlider, this.svgDocument);
            var leftSliderOptions = {                 
                'width': '2',
                'height': this.sliderHeight,
                'fill': navigatorStyleSettings.thumbStroke,
                'opacity': '1',
                'y': this.sliderPosition,
                'transform': 'translate(' + this.padding + ')'
               
                
            };
            var lcircleOptions = {
                'id': 'leftCircle' + this._id,
                'cx': this.padding,
                'cy': this.sliderPosition + (this.sliderHeight / 2),
                'r': navigatorStyleSettings.thumbRadius,
                'stroke-width': 2,
                'stroke': navigatorStyleSettings.thumbStroke,
                'fill': this.tbClr
            };

                
            this.renderer.drawRect(leftSliderOptions, this.gLeftSlider);
			// checking condition for whether using thumb
            if (this.model.navigatorStyleSettings.leftThumbTemplate == null) {
                this.renderer.drawCircle(lcircleOptions, this.gLeftSlider);
                this.leftCircle = this.gLeftSlider.lastChild;
                $(this.leftCircle).css('cursor', 'pointer');
            }

            // Adding left Thumb  

            else {
                var isID = document.getElementById(this.model.navigatorStyleSettings.leftThumbTemplate) ? true : false;
                if ($('#' + this._id + "thumbleft").length > 0)
                    $('#' + this._id + "thumbleft").remove();
                var container = this._id;
				if (($("#" + container).css('transform')) == 'none')
                    $("#" + container).css('transform', 'translate(0, 0)');
                if ($("#" + container+"template_group_").length != 0)
                    var templateContainer = $("#" + container + "template_group_");
				else
				{
                   var templateContainer = $("<div></div>").attr('id',container+"template_group_");
				    $(templateContainer).css("position", "relative");
				}
                var temp = $("<div></div>").attr("id", this._id + "thumbleft");
                var cloneNode;
                if (isID == true)
                    cloneNode = $("#" + this.model.navigatorStyleSettings.leftThumbTemplate)[0].innerHTML;
                else
                    cloneNode = this.model.navigatorStyleSettings.leftThumbTemplate;
                var $cloneNode = $(cloneNode);
                $(temp).css("position", "absolute");
                $cloneNode.appendTo($(temp));
                $(temp).appendTo(templateContainer);
                if (this.svgSupport) 
					$(templateContainer).appendTo('#' + container);
                else
                    $(templateContainer).appendTo(this.svgDocument);
            	var top = this.sliderPosition + (this.sliderHeight / 2) - (($cloneNode.height()) / 2);
				$(temp).css("top", top).css('cursor', 'pointer').css('z-index','1');
			}
            this.leftSlider = this.gLeftSlider.firstChild;
            $(this.leftSlider).css('cursor', 'w-resize');

            this.renderer.append(this.gLeftSlider, this.svgDocument);

			var width = parseFloat(this.newWidth - this.padding*2); // To check width on initialize the range navigator.
			width = width < 0 ? 0 : width;
			
            var unRightSliderOptions = {
                'width': width,
                'height': this.sliderHeight,
                'fill': this.unselectgrad,
                'opacity': navigatorStyleSettings.unselectedRegionOpacity,
                'transform': 'translate('+this.padding+',' + this.sliderPosition + ')'
            };
            this.renderer.drawRect(unRightSliderOptions, this.rightUnSelected);
            this.rightUnArea = this.rightUnSelected.firstChild;
            this.renderer.append(this.rightUnSelected, this.svgDocument);
            var rightSliderOptions = {               
                'width': '2',
                'height': this.sliderHeight,
                'fill': this.model.navigatorStyleSettings.thumbStroke,
                'opacity': '1',
                'transform': 'translate(' + parseFloat(this.newWidth - 4-this.padding) + ', ' + this.sliderPosition + ' )'
            };
            var rcircleOptions = {
                'id': "rightCircle" + this._id,
                'cx': this.newWidth - 4 - this.padding,
                'cy': this.sliderPosition + (this.sliderHeight / 2),
                'r': this.model.navigatorStyleSettings.thumbRadius,
                'stroke-width': 2,
                'stroke': this.model.navigatorStyleSettings.thumbStroke,
                'fill': this.tbClr
            };
            this.renderer.drawRect(rightSliderOptions, this.gRightSlider);
            if (this.model.navigatorStyleSettings.rightThumbTemplate == null)
            {
                this.renderer.drawCircle(rcircleOptions, this.gRightSlider);
                this.rightCircle = this.gRightSlider.lastChild;
                $(this.rightCircle).css('cursor', 'pointer');
            }

            // append right thumb   

            else {
                var isID = document.getElementById(this.model.navigatorStyleSettings.rightThumbTemplate) ? true : false;
                if ($('#' + this._id + "thumbright").length > 0)
                    $('#' + this._id + "thumbright").remove();
                var container = this._id;
                if ($("#" + container + "template_group_").length != 0)
                    var templateContainer = $("#" + container + "template_group_");
                else
				 {
                    var templateContainer = $("<div></div>").attr('id',container+ "template_group_");
					 $(templateContainer).css("position", "absolute");
				 }
                var temp = $("<div></div>").attr("id", this._id + "thumbright");
                var cloneNode;
                if (isID == true)
                    cloneNode = $("#" + this.model.navigatorStyleSettings.rightThumbTemplate)[0].innerHTML;
                else
                    cloneNode = this.model.navigatorStyleSettings.rightThumbTemplate;
                var $cloneNode = $(cloneNode);
                $(temp).css("position", "absolute");
                $cloneNode.appendTo($(temp));
                $(temp).appendTo(templateContainer);
                if (this.svgSupport) 
					$(templateContainer).appendTo('#' + container);
                else
                    $(templateContainer).appendTo(this.svgDocument);
                var top = this.sliderPosition + (this.sliderHeight / 2) - (($cloneNode.height()) / 2);
                $(temp).css("top", top).css('cursor', 'pointer').css('z-index', '1');
             }

            this.rightSlider = this.gRightSlider.firstChild;
            $(this.rightSlider).css('cursor', 'w-resize');

            this.renderer.append(this.gRightSlider, this.svgDocument);
            if (this.model.tooltipSettings.visible && this.svgSupport) {
                this.renderer.append(this.leftTooltip, this.svgDocument);
                this.renderer.append(this.rightTooltip, this.svgDocument);
            }
            
            this.element.append(this.svgDocument);
            if (this.svgSupport) {
                this.trueCoords = this.svgDocument.createSVGPoint();

                this.grabPoint = this.svgDocument.createSVGPoint();
            }

            this.backDrop = this.element;
            this.dragTarget = null;            
            if(this.sliderHeight > 0)
                 this._renderChart.call(this, this.model);
            if (evt != undefined && evt.target != undefined)
                this.resize = true;
            
            if ((this.startDateTime != undefined && this.endDateTime != undefined) || (this.startValue != undefined && this.endValue != undefined)) {
                this.calculateInterval.call(this, this.model.labelSettings.higherLevel, this.model.labelSettings.lowerLevel);

                this.setSliders();
            } else {
                if (!this.svgSupport)
                    this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + this.padding + ',' + this.sliderPosition + ')' });
                else
                    this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + this.padding + ',' + 0 + ')' });

                this.leftTooltip.setAttribute('opacity', 0);
                this.rightTooltip.setAttribute('opacity', 0);
            }
            if (this.model.tooltipSettings.visible && this.svgSupport && this.model.tooltipSettings.tooltipDisplayMode == "ondemand") {
                this.rightTooltip.setAttribute('opacity', 0);
                this.leftTooltip.setAttribute('opacity', 0);
            }
            this._scrollChanged = this._scrollChanged ? false : this._scrollChanged;
            //this._trigger("loaded", this.model);

            //Add or remove scrollbar dynamically
            if (!this.model.enableScrollbar) {
                $(this.scrollsvgObj).remove();
                this.scrollsvgObj = null;
                this.scrollZoomPos = null;
                this.scrollZoomFact = null;
            } else {
                if ((this.loadScrollbar && !this.scrollbarUpdate) || (this.model.scrollObj && this.model.scrollObj[0].width != this.scrollWidth)) {
                    this.model.scrollObj[0].width = this.scrollWidth;
                    this.scrollbarContainer = new ej.EjSvgScrollbarRender(this.element, this.model.scrollObj[0]);
                    this.scrollbarContainer._initializeScrollbarVariables.call(this, this.model.scrollObj[0]);
                    this.scrollbarContainer._renderScrollbar.call(this, this.model.scrollObj[0]);

                } else
                    this.renderer.append(this.scrollsvgObj, this.element);
                this._bindevents();
            }
        },

        eachInterval:"",

        //Rendering chart
        _renderChart: function (model) {
            var valueType = model.valueType.toLowerCase();
            var range, rangeSettings = model.rangeSettings;
            if (model.enableScrollbar || (rangeSettings.start != "" && rangeSettings.end != "")) {
                if (valueType == "datetime")
                    range = { min: this.startDateTime, max: this.endDateTime };
                else
                    range = { min: this.startValue, max: this.endValue };
            }
            if (model.dataSource != "" && model.series == "" && model.seriesSettings == "") {
                $(this.chartGView).ejChart(
                {
				    locale : this.model.locale,
                    border: { width: 0, color: "transparent" },
                    margin: { left: 0, right: 0, top: 0, bottom: 0 },
                    elementSpacing: 0,
                    chartArea:
                    {
                        background: "transparent",
                        border: { width: 0 }
                    },
                    primaryXAxis: {
                        axisLine: { visible: false },
                        font: { size: '0px' },
                        range:range,
                        majorTickLines:
                        {
                            lineWidth: 0,
                            size: 0,
                            visible: true
                        },
                        majorGridLines: { visible: false },
                        rangePadding: this.model.rangePadding,
                        visible: false,
                        isInversed: this.model.enableRTL

                    },
                    primaryYAxis: this.model.valueAxisSettings,
                 series: [{
                     dataSource: model.dataSource, xName: model.xName, yName: model.yName,
                     type: 'line',
                     width:1.5,
                     enableAnimation:false

                 },
                 ],
                 size: { height: parseFloat(this.sliderHeight).toString(), width: parseFloat(this.newWidth - (2 * this.padding)).toString(), padding: -10 },
                 legend: {
                     visible: false,
                     itemSize: { height: 0, width: 0, borderColor: 'transparent', borderWidth: 0 },
                 }
             });
            }
            else if (model.dataSource != "" && model.series != "" && model.series[0].dataSource == undefined || model.seriesSettings != "" && model.seriesSettings.dataSource == undefined && model.dataSource!="") {
                model.seriesSettings.dataSource = model.dataSource;
                model.seriesSettings.xName = model.seriesSettings.xName ? model.seriesSettings.xName : model.xName;
                model.seriesSettings.yName = model.seriesSettings.yName ? model.seriesSettings.yName : model.yName;
                var series = model.series;
                if (series == "") {
                    series = [{
                        dataSource: model.dataSource, xName: model.seriesSettings.xName, yName: model.seriesSettings.yName,
                        type: 'line',
                        width: 1.5,
                        enableAnimation: false

                    }];
                }
               
                $(this.chartGView).ejChart(
            {
			    locale : this.model.locale,
                border: { width: 0, color: "transparent" },
                margin: { left: 0, right: 0, top: 0, bottom: 0 },
                elementSpacing: 0,
                chartArea:
                {
                    background: "transparent",
                    border: { width: 0 }
                },
                primaryXAxis: {

                    axisLine: { visible: false },
                    font: { size: '0px' },
                    range:range,
                    majorTickLines:
                    {
                        lineWidth: 0, size: 0, visible: true
                    },
                    majorGridLines: { visible: false },
                    rangePadding: this.model.rangePadding,
                    visible: false,
                    isInversed: this.model.enableRTL

                },
                primaryYAxis: this.model.valueAxisSettings,
                series: series,
                commonSeriesOptions: model.seriesSettings,
                size: { height: parseFloat(this.sliderHeight).toString(), width: parseFloat(this.newWidth - (2 * this.padding)).toString(), padding: -10 },
                legend: {
                    visible: false,
                    itemSize: { height: 0, width: 0, borderColor: 'transparent', borderWidth: 0 },
                }
            });
            }
            else if (model.series != "" && model.series[0].dataSource != undefined || model.seriesSettings != "" && model.seriesSettings.dataSource != undefined) {
                if (model.seriesSettings == "") {
                    model.seriesSettings = {
                        type: 'line'
                    };
                }
                var series = model.series;
                var length = series.length;
                if (series == "") {
                    series = [{
                        dataSource: model.seriesSettings.dataSource, xName: model.seriesSettings.xName, yName: model.seriesSettings.yName,
                        type: 'line',
                        width: 1.5,
                        enableAnimation: false

                    }];
                }
                
                $(this.chartGView).ejChart(
            {
			    locale : this.model.locale,
                border: { width: 0, color: "transparent" },
                margin: { left: 0, right: 0, top: 0, bottom: 0 },
                elementSpacing: 0,
                chartArea:
                {
                    background: "transparent",
                    border: { width: 0 }
                },
                primaryXAxis: {

                    axisLine: { visible: false },
                    range:range,
                    font: { size: '0px' },
                    majorTickLines:
                    {
                        lineWidth: 0, size: 0, visible: true
                    },
                    majorGridLines: { visible: false },
                    rangePadding: this.model.rangePadding,
                    visible: false,
                    isInversed: this.model.enableRTL

                },
                primaryYAxis: this.model.valueAxisSettings,
                series: series,
                commonSeriesOptions: model.seriesSettings,
                size: { height: parseFloat(this.sliderHeight).toString(), width: parseFloat(this.newWidth - (2 * this.padding)).toString(), padding: -10 },
                legend: {
                    visible: false,
                    itemSize: { height: 0, width: 0, borderColor: 'transparent', borderWidth: 0 },
                }
            });
            }

            this.ejChart = $(this.chartGView).data("ejChart");
            this.renderer._setAttr($(this.chartGView), { 'transform': 'translate(' + this.padding + ',' + this.sliderPosition + ')','height': this.sliderHeight });
           
        },

        _init: function () {
            this._createSvg(this);
            var commonLoadedEventArgs = $.extend({}, ej.EjSvgRender.commonChartEventArgs), virtualRange;
            commonLoadedEventArgs.data = { model: this.model };
            this._trigger("load", commonLoadedEventArgs);
            virtualRange = this.model.scrollRangeSettings;

            this.renderNavigator(this);
            if (this.model.enableScrollbar) {
                this.model.scrollObj = [];
                var scrollObj = this.model.scrollObj;
                scrollObj[0] = {
                   'orientation': 'horizontal',
                   'index': 0,
                   'width': this.scrollWidth,
                   'x':0,
                   'y': this.newHeight,
                   'isRTL': this.model.enableRTL,
                   'zoomPosition':this.scrollZoomPos,
                   'zoomFactor': this.scrollZoomFact,
                   'scrollRange': this._scrollRange,
                   'valueType': this.model.valueType,
                   'parent': this.element,
                   'enableResize': true
               };
               if (scrollObj[0].valueType == 'datetime') {
                    scrollObj[0].startDateTime = this.startDateTime;
                    scrollObj[0].endDateTime = this.endDateTime;
               } else {
                    scrollObj[0].startValue = this.startValue;
                    scrollObj[0].endValue = this.endValue;
               }
               this.scrollbarContainer = new ej.EjSvgScrollbarRender(this.element, this.model.scrollObj[0]);
               this.scrollbarContainer._initializeScrollbarVariables.call(this, this.model.scrollObj[0]);
               this.scrollbarContainer._renderScrollbar.call(this, this.model.scrollObj[0]);
            }
            if (this.model.enableAutoResizing || this.model.isResponsive)
                this.bindResizeEvents();
            else
               this.removeResizeEvents();
            this._bindevents();
        },
        bindResizeEvents: function () {
            if (this.model._rangeResizeEventRegistered)
                return 0;
            if (!this.model.enableScrollbar || (this.model.enableScrollbar && this.svgSupport))
                this._on($(window), "resize", this.rangeChange);
            this.model._rangeResizeEventRegistered = true;
        },

        removeResizeEvents: function () {
            if (this.model._rangeResizeEventRegistered) {
                this._off($(window), "resize", this.rangeChange);
                this.model._rangeResizeEventRegistered = false;
            }
        },
             
         
		 rangeChange:function(evt){
             var id, _this = this;
			 this.rangeResize = true;
			 clearTimeout(id);
			 
			 if (!ej.isNullOrUndefined(window.orientation))			     
			     id = setTimeout(function(){_this.renderNavigator();}, 500);
			 else 
			     this.renderNavigator();
			 if (this.model.enableScrollbar) {
			     this.model.scrollObj[0].width = this.scrollWidth;
			     this.scrollbarContainer._renderScrollbar.call(this, this.model.scrollObj[0]);
			 }
          },

        isDevice: function () {
            // return (/mobile|tablet|android|kindle/i.test(navigator.userAgent.toLowerCase()));
            // comment above line temporary. Due to the below code event wont bind for tablet device
            return (/mobile|android|kindle/i.test(navigator.userAgent.toLowerCase()));
        },

		//To check whether the device is Windows
        isWindows: function () {
          if (!ej.getBooleanVal($('head'), 'data-ej-android') && !ej.getBooleanVal($('head'), 'data-ej-ios') && !ej.getBooleanVal($('head'), 'data-ej-ios7') && !ej.getBooleanVal($('head'), 'data-ej-flat'))
            return this._windows();
        },
		
		 _windows: function () {
          return (/trident|windows phone/i.test(navigator.userAgent.toLowerCase())) || (ej.getBooleanVal($('head'), 'data-ej-windows', false) === true);
        },
		
        _bindevents: function () {
            var matched = jQuery.uaMatch(navigator.userAgent),
                browserInfo = ej.EjSvgRender.utils.browserInfo(),
                isPointer = browserInfo.isMSPointerEnabled,
	            isIE11Pointer = browserInfo.pointerEnabled,
                touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
                touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
                touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
                touchCancelEvent = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchleave mouseleave";
            this.model.browserInfo = browserInfo;


            this._on(this.element, touchMoveEvent, this._drag);
            this._on(this.element, touchCancelEvent, this._leave);
            this._on($(document), touchStopEvent, this._drop);
            this._on($(this.element), touchStartEvent, this._grab);
            this._on($(this.element), "contextmenu", this._rightClick);


            this._on($("#" + this._id + "template_group_"), touchStartEvent, this._grab);
            this._on($("#" + this._id + "template_group_"), touchMoveEvent, this._drag);
            this._on($("#" + this._id + "template_group_"), touchStopEvent, this._drop);
            this._on($(window), touchStopEvent, this.mouseup);

            $(this.element).css('touch-action', 'none');

        },

        _initializeVariables: function (model, series, sSettings) {
            //intializing ismouseup flag
            this.ismouseup = false;
            var rangeSettings= this.model.rangeSettings,
                labelStyle = this.model.labelSettings.style,
                lowLabelStyle = this.model.labelSettings.lowerLevel.style,
                highLabelStyle = this.model.labelSettings.higherLevel.style,
                scrollRangeSettings = this.model.scrollRangeSettings;
            //checking labelstyle
            if (highLabelStyle == "")
                this.model.labelSettings.higherLevel.style = labelStyle;
            if (lowLabelStyle == "") {
                this.model.labelSettings.lowerLevel.style = labelStyle;
            }
            else if (lowLabelStyle != undefined && lowLabelStyle.horizontalAlignment == undefined) {
                this.model.labelSettings.lowerLevel.style.horizontalAlignment = "middle";
            }
            if (this.model.valueType == "numeric" && this.model.tooltipSettings.labelFormat=="MM/dd/yyyy") {
                this.model.tooltipSettings.labelFormat = "d";
            }
            //checking for datasource and finding start and end values
            if (model.dataSource != "" && model.xName != "" && model.yName != "") {
                var length = series.length;
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        series[i].dataSource = model.dataSource;
                        series[i].type = series[i].type ? series[i].type : (sSettings.type ? model.type : "line");
                        series[i].xName = series[i].xName ? series[i].xName : model.xName;
                        series[i].yName = series[i].yName ? series[i].yName : model.yName;
                        this._processJsonData(series[i].dataSource, series[i]);
                    }
                } else
                    this._processJsonData(model.dataSource, this.model);
            }
            else if (series!="" && series != undefined && series[0].dataSource != undefined && series[0].xName != undefined && series[0].yName != undefined) {
                this._processJsonData(series[0].dataSource, series[0]);
            }
            else if (sSettings.dataSource != undefined) {
                var length = series.length;
                if (length > 0) {
                    for (var i = 0; i < length; i++) {
                        series[i].dataSource = sSettings.dataSource;
                        series[i].type = series[i].type ? series[i].type : (sSettings.type ? sSettings.type : "line");
                        series[i].xName = series[i].xName ? series[i].xName : sSettings.xName;
                        series[i].yName = series[i].yName ? series[i].yName : sSettings.yName;
                        this._processJsonData(series[i].dataSource, series[i]);
                    }
                } else
                    this._processJsonData(sSettings.dataSource, sSettings);
            }
            else if (rangeSettings.start != "" && rangeSettings.end != "") {
                var minX = startDateTime = rangeSettings.start, maxX = endDateTime = rangeSettings.end;
                if (this.model.enableScrollbar) {
                    var args = [minX, maxX, new Date(minX), new Date(maxX)];
                    this.calculateZoomingRange.apply(this, args);

                } else
                    this.setRange.call(this, minX, maxX, startDateTime, endDateTime);               
            }
            // initializing start year and end year
            if (this.startDateTime != undefined && this.endDateTime != undefined) {
                if (this.model.valueType == "datetime" && this.model.rangePadding == "round") {
                    var start = new Date(this.startValue);
                    var end = new Date(this.endValue);
                    this.startDateTime = new Date(start.getFullYear(), start.getMonth(), start.getDate(), 0, 0, 0);
                    this.endDateTime = new Date(end.getFullYear(), end.getMonth(), end.getDate(), 23, 59, 59);
                }
                this.startYear = this.startDateTime.getFullYear();
                this.startMonth = this.startDateTime.getMonth(); 
                this.endYear = this.endDateTime.getFullYear();
                this.endMonth = this.endDateTime.getMonth();
            }           
        },

        setSliders: function () {
            var wholeSize = this.newWidth - this.padding * 2,
                type = this.model.valueType,
                selectedRangeStart = this.model.selectedRangeSettings.start,
                selectedRangeEnd = this.model.selectedRangeSettings.end,
                padding = this.padding, startRange = this.startDateTime.getTime(), endRange = this.endDateTime.getTime(),
                interval, startValue = this.startValue, endValue = this.endValue;
            if (type == "datetime")
                this.eachInterval = wholeSize / parseFloat(endRange - startRange);
            else
                this.eachInterval = wholeSize / parseFloat(endValue - startValue);

            interval = this.eachInterval;
            if (!this.model.enableScrollbar) {
                if (type == "datetime") {
                    if (selectedRangeStart == "" || new Date(selectedRangeStart).getTime() < startRange)
                        selectedRangeStart = this.startDateTime;
                    if (selectedRangeEnd == "" || new Date(selectedRangeEnd).getTime() > endRange || new Date(selectedRangeEnd).getTime() < startRange)
                        selectedRangeEnd = this.endDateTime;
                }
                else {
                    if (selectedRangeStart == "" || selectedRangeStart < startValue)
                        selectedRangeStart = startValue;
                    if (selectedRangeEnd == "" || selectedRangeEnd > endValue)
                        selectedRangeEnd = endValue;
                }
            }
            
            if (!this.model.enableRTL) {
                if (type == "datetime") {
                    this.leftSliderPosition = (new Date(selectedRangeStart).getTime() - startRange) * interval + padding;
                    this.rightSliderPosition = (new Date(selectedRangeEnd).getTime() - startRange) * interval + padding;
                    selectedRangeStart = new Date(selectedRangeStart);
                    selectedRangeEnd = new Date(selectedRangeEnd)
                }
                else {
                    this.leftSliderPosition = (selectedRangeStart - startValue) * interval + padding;
                    this.rightSliderPosition = (selectedRangeEnd - startValue) * interval + padding;
                }
            } else {
                if (type == "datetime") {
                    this.leftSliderPosition = (endRange - new Date(selectedRangeEnd).getTime()) * interval + padding;
                    this.rightSliderPosition = (endRange - new Date(selectedRangeStart).getTime()) * interval + padding;
                    selectedRangeStart = new Date(selectedRangeStart);
                    selectedRangeEnd = new Date(selectedRangeEnd);
                }
                else {
                    this.leftSliderPosition = (endValue - selectedRangeEnd) * interval + padding;
                    this.rightSliderPosition = (endValue - selectedRangeStart) * interval + padding;
                }               
            }

            if (this.model.tooltipSettings.tooltipDisplayMode == "always")
                this.setopacity = 1;
            else
                this.setopacity = 0;

            if (!this.model.enableScrollbar)
                this.setSliderPositions(this.leftSliderPosition, null, null);
            else {
                if ((this.leftSliderPosition >= padding && this.leftSliderPosition < this.newWidth - padding))
                    this.setSliderPositions(this.leftSliderPosition, null, null);
                else {
                    if (this.leftSliderPosition > this.newWidth) {
                        $(this.leftTooltip).hide();
                        $(this.gLeftSlider).hide();
                    } else {
                        $(this.leftTooltip).hide();
                        $(this.gLeftSlider).hide();
                        $(this.leftUnSelected).hide();
                    }
                }
            }
            if (!this.model.enableScrollbar)
                this.setSliderPositions(null, null, this.rightSliderPosition);
            else {
                if ((this.rightSliderPosition <= (this.newWidth - padding) && this.rightSliderPosition > padding))
                    this.setSliderPositions(null, null, this.rightSliderPosition);
                else {
                    if (this.rightSliderPosition < 0) {
                        $(this.rightTooltip).hide();
                        $(this.gRightSlider).hide();
                    } else {
                        $(this.rightTooltip).hide();
                        $(this.gRightSlider).hide();
                        $(this.rightUnSelected).hide();
                    }
                }
            }
                
           this.setopacity = 1;
           if (this.model.enableDeferredUpdate) {
               this._calculateSelectedData();
               this._calculateSliderZoomFactPosition();
               // checking condition for range event fire
               if (!this._scrollChanged) {
                   if (type == "datetime") {
                       if (this.startDateTime.getTime() !== selectedRangeStart.getTime() || this.endDateTime.getTime() !== selectedRangeEnd.getTime() && !this.rangeResize) {
                           this._trigger("rangeChanged", this.model);
                       }
                   }
                   else {
                       if (this.startValue !== selectedRangeStart || this.endValue !== selectedRangeEnd && !this.rangeResize) {
                           this._trigger("rangeChanged", this.model);
                       }
                   }
               }
				this.rangeResize=false;
            }
        },

        centerSliderWidth: "",
        zoomp: 0,
        zoomf:1,

        setSliderPositions: function (leftValue, centerValue, rightValue) {
            var doubledate, locale = this.model.locale;
            var type = this.model.valueType;
            var cPosition;
            var labelPlacement = this.model.labelSettings.higherLevel.labelPlacement;
            cPosition = labelPlacement == "inside" ? 0 : this.centerPosition;
            var rtlValue, tooltipPrecision, defaultPrecision=6, highestPrecision=20,
                tooltipFormat = this.model.tooltipSettings.labelFormat;
            if (type == 'numeric' && (tooltipFormat.indexOf('e') == 0 || tooltipFormat.indexOf('E') == 0)) {
                tooltipPrecision = tooltipFormat.match(/(\d+)/g);
                tooltipPrecision = tooltipPrecision == null ? defaultPrecision : tooltipPrecision > highestPrecision ? highestPrecision : tooltipPrecision;
            }
            if (leftValue != null && leftValue >= this.padding && leftValue < this.newWidth - this.padding) {
                this.leftSliderPosition = leftValue;
                rtlValue = this.model.enableRTL ? (this.newWidth - leftValue) : leftValue;
                if(type=="datetime")
                    doubledate = (rtlValue / this.eachInterval) + this.startDateTime.getTime() - (this.padding / this.eachInterval);
                else
                    doubledate = (rtlValue / this.eachInterval) + this.startValue - (this.padding / this.eachInterval);
                if (this.model.tooltipSettings.visible && this.svgSupport && this.leftTxt) {
                    this.leftTooltip.setAttribute('opacity', this.setopacity);
                    if(type=="datetime")
                        this.leftTxt.textContent = ej.format(new Date(doubledate), this.model.tooltipSettings.labelFormat, locale);
                    else {
                        if (tooltipFormat.indexOf('e') == 0 || tooltipFormat.indexOf('E') == 0)
                            this.leftTxt.textContent = doubledate.toExponential(tooltipPrecision);
                        else this.leftTxt.textContent = ej.format(doubledate, this.model.tooltipSettings.labelFormat, locale);
                    }
                    var textOffset = ej.EjSvgRender.utils._measureText(this.leftTxt.textContent, null, this.model.tooltipSettings.font);
                    var txtwidth = textOffset.width + 15;
                    var txtheight = textOffset.height;
                    var txty = this.brow!="msie" ? (txtheight + 6) / 2 : (txtheight / 2) + 6;
                    this.leftTxt.setAttribute('y', txty);
                    this.leftd = "M 0 0 L 0 " + (txtheight + 6) + " L " + (txtwidth - 6) + " " + (txtheight + 6) + " L " + (txtwidth - 6) + " 6 L " + txtwidth + " 0 Z";
                    this.rightd = "M 0 0 L " + txtwidth + " 0 L " + txtwidth + " " + (txtheight + 6) + " L 6 " + (txtheight + 6) + " L 6 6 Z";

                    if (leftValue - txtwidth >= 0) {
                        this.leftTooltip.firstChild.setAttribute('d', this.leftd);
                        this.renderer._setAttr($(this.leftTooltip), { 'transform': 'translate(' + (leftValue - txtwidth) + ',' + cPosition + ')' });
                        this.leftTxt.setAttribute('x', 5);
                    }
                    else if (leftValue + txtwidth < this.rightTooltip.getCTM().e) {
                        this.renderer._setAttr($(this.leftTooltip), { 'transform': 'translate(' + (leftValue) + ',' + cPosition + ')' });
                        this.leftTooltip.firstChild.setAttribute('d', this.rightd);
                        this.leftTxt.setAttribute('x', 10);
                    }
                    else if (this.rightTooltip.getCTM().f < 30) {
                        this.renderer._setAttr($(this.leftTooltip), {'transform': 'translate(' + (leftValue) + ',' + (cPosition + 30) + ')'});
                        this.leftTooltip.firstChild.setAttribute('d', this.rightd);
                    }
                    else {
                        this.renderer._setAttr($(this.leftTooltip), {'transform': 'translate(' + (leftValue) + ',' + (cPosition) + ')'});
                        this.leftTooltip.firstChild.setAttribute('d', this.rightd);
                    }
                    if (leftValue > this.newWidth - this.rightTooltip.lastChild.getBBox().width - 15 && this.rightTooltip.getCTM().f < 30) {
                        this.renderer._setAttr($(this.leftTooltip), {'transform': 'translate(' + (leftValue - txtwidth) + ',' + (cPosition + 30) + ')'});
                    }
                    if (this.rightTooltip.getCTM().f >= 30 && leftValue < this.rightTooltip.getCTM().e) {
                        this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + this.rightTooltip.getCTM().e + ',' + (cPosition) + ')'});
                    }
                }
                if (this.ismouseup == false) {
                    // this.renderer._setAttr($(this.leftUnArea), { 'width': leftValue - this.padding});
                    this.renderer._setAttr($(this.leftUnArea), { 'width': leftValue - this.padding, 'transform': 'translate(' + this.padding + ',' + this.sliderPosition + ')' });
                    if (!this.svgSupport)
                        this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + leftValue + ',' + this.sliderPosition + ')' });
                    else
                        this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + leftValue + ',' + 0 + ')' });
                    if (this.leftCircle != undefined) {
                        if(this.svgSupport)
                            this.renderer._setAttr($(this.leftCircle), { 'cx': leftValue });
                        else
                            this.renderer._setAttr($(this.leftCircle), { 'transform': 'translate(' + parseFloat(leftValue-10) + ',' + parseFloat(this.sliderPosition + (this.sliderHeight / 2)) + ')' }); //this.sliderPosition + (this.sliderHeight / 2)
                        this._leftValue = {
                            'left': leftValue - this.model.navigatorStyleSettings.thumbRadius,
                            'right': leftValue + this.model.navigatorStyleSettings.thumbRadius
                        }
                    }// adding the left position for thumbleft
                    else {
                        var left = leftValue - ($("#" + this._id + "thumbleft").width() / 2);
                        $("#" + this._id + "thumbleft").css("left", left);
                        this._leftValue = {
                            'left': left,
                            'right': left + $("#" + this._id + "thumbleft").width()
                        }
                    }
                    this.renderer._setAttr($(this.centerSlider), {'transform': 'translate(' + parseFloat(leftValue) + ',' + this.sliderPosition + ')'});                   
                    var width = parseFloat(this.rightSlider.getBoundingClientRect().left) - parseFloat(this.leftSlider.getBoundingClientRect().left);
					if(width > 0) this.renderer._setAttr($(this.centerSlider), { 'width': width});
                }
                else {
                    this.ismouseup = false;
                    this.renderer._setAttr($(this.leftUnArea), { 'width': leftValue - this.padding, 'transform': 'translate(' + this.padding + ',' + this.sliderPosition + ')' });
                    if (!this.svgSupport)
                        this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + leftValue + ',' + this.sliderPosition + ')' });
                    else
                        this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + leftValue + ',' + 0 + ')' });
                    if (this.leftCircle != undefined) {
                        if (this.svgSupport)
                            this.renderer._setAttr($(this.leftCircle), { 'cx': leftValue });
                        else
                            this.renderer._setAttr($(this.leftCircle), { 'transform': 'translate(' + parseFloat(leftValue - 10) + ',' + parseFloat(this.sliderPosition + (this.sliderHeight / 2)) + ')' }); //this.sliderPosition + (this.sliderHeight / 2)
                        this._leftValue = {
                            'left': leftValue - this.model.navigatorStyleSettings.thumbRadius,
                            'right': leftValue + this.model.navigatorStyleSettings.thumbRadius
                        }
                    }   // adding the left position for thumbleft
                    else {
                        var left = leftValue - ($("#" + this._id + "thumbleft").width() / 2);
                        $("#" + this._id + "thumbleft").css("left", left);
                        this._leftValue = {
                            'left': left,
                            'right': left + $("#" + this._id + "thumbleft").width()
                        }
                    }
                    this.renderer._setAttr($(this.centerSlider), {'transform': 'translate(' + parseFloat(leftValue) + ',' + this.sliderPosition + ')'});
                    var width = parseFloat(this.rightSlider.getBoundingClientRect().left) - parseFloat(this.leftSlider.getBoundingClientRect().left);
                    if(width > 0) this.renderer._setAttr($(this.centerSlider), { 'width': width});
                }
                this.model.zoomPosition = (leftValue-this.padding) / (this.newWidth-this.padding*2);
                this.model.zoomFactor = (this.rightSlider.getBoundingClientRect().left + parseFloat(this.renderer._getAttrVal($(this.rightSlider), 'width')) - this.leftSlider.getBoundingClientRect().left) / (this.newWidth - this.padding * 2);
               
                if (!this.model.enableRTL) {
                    if (type == "datetime")
                        this.model.selectedRangeSettings.start = new Date(doubledate);
                    else
                        this.model.selectedRangeSettings.start = doubledate;
                } else {
                    if (type == "datetime")
                        this.model.selectedRangeSettings.end = new Date(doubledate);
                    else
                        this.model.selectedRangeSettings.end = doubledate;
                }
				
                $(this.leftTooltip).show();
                $(this.gLeftSlider).show();
                $(this.leftUnSelected).show();
            }
            else if (rightValue != null && rightValue > this.padding) {
                if (rightValue > this.newWidth - this.padding + 1)
                    rightValue = this.newWidth - this.padding;
                this.rightSliderPosition = rightValue;
                var startDateTime = new Date(this.model.rangeSettings.start);
                rtlValue = this.model.enableRTL ? (this.newWidth - rightValue) : rightValue;
                doubledate = (rtlValue / this.eachInterval) + this.startDateTime.getTime() - (this.padding / this.eachInterval);
                if(type=="datetime")
                    doubledate = new Date(doubledate);
                    //fixed issue for end value change
                else
                    doubledate = (rtlValue / this.eachInterval) + this.startValue - (this.padding / this.eachInterval);
                if (!this.model.enableRTL)
                    this.model.selectedRangeSettings.end = doubledate;
                else
                    this.model.selectedRangeSettings.start = doubledate;
                if (this.model.tooltipSettings.visible && this.svgSupport && this.rightTxt) {
                    this.rightTooltip.setAttribute('opacity', this.setopacity);
                    if(type=="datetime")
                        this.rightTxt.textContent = ej.format(new Date(doubledate), this.model.tooltipSettings.labelFormat, locale);
                    else {
                        if (tooltipFormat.indexOf('e') == 0 || tooltipFormat.indexOf('E') == 0)
                            this.rightTxt.textContent = doubledate.toExponential(tooltipPrecision);
                        else this.rightTxt.textContent = ej.format(doubledate, this.model.tooltipSettings.labelFormat, locale);
                    }
                    var textOffset = ej.EjSvgRender.utils._measureText(this.rightTxt.textContent, null, this.model.tooltipSettings.font);
                    var txtwidth = textOffset.width + 15;
                    var txtheight = textOffset.height;
                    var txty = this.brow != "msie" ? (txtheight + 6) / 2 : (txtheight / 2) + 6;
                    this.rightTxt.setAttribute('y', txty);
                    this.rightTxt.setAttribute('x', 10);
                    this.leftd = "M 0 0 L 0 " + (txtheight + 6) + " L " + (txtwidth - 6) + " " + (txtheight + 6) + " L " + (txtwidth - 6) + " 6 L " + txtwidth + " 0 Z";
                    this.rightd = "M 0 0 L " + txtwidth + " 0 L " + txtwidth + " " + (txtheight + 6) + " L 6 " + (txtheight + 6) + " L 6 6 Z";
                    if (rightValue + txtwidth <= this.newWidth) {
                        this.rightTooltip.firstChild.setAttribute('d', this.rightd);
                        this.renderer._setAttr($(this.rightTooltip), {'transform': 'translate(' + (rightValue) + ',' + cPosition + ')'});
                    }
                    else if (rightValue + txtwidth >= this.newWidth && rightValue - txtwidth > this.centerSlider.getCTM().e) {
                        this.renderer._setAttr($(this.rightTooltip), {'transform': 'translate(' + (rightValue - txtwidth) + ',' + cPosition + ')'});
                        this.rightTooltip.firstChild.setAttribute('d', this.leftd);
                        this.rightTxt.setAttribute('x', 5);
                    }
                    else if (this.leftTooltip.getCTM().f < 30) {
                        this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + (rightValue - txtwidth) + ',' + (cPosition + 30) + ')'});
                        this.rightTooltip.firstChild.setAttribute('d', this.leftd);
                    }
                    else {
                        this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + (rightValue - txtwidth) + ',' + cPosition + ')'});
                        this.rightTooltip.firstChild.setAttribute('d', this.leftd);
                    }
                    if (rightValue < this.leftTooltip.getCTM().e + txtwidth && this.leftTooltip.getCTM().f < 30 && this.leftSliderPosition >= this.padding) {
                        this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + (rightValue) + ',' + (cPosition + 30) + ')'});
                    }
                    if (this.leftTooltip.getCTM().f >= 30 && rightValue > this.leftTooltip.getCTM().e + txtwidth && this.rightTooltip.getCTM().e > this.leftTooltip.getCTM().e + txtwidth) {
                        this.renderer._setAttr($(this.leftTooltip), { 'transform': 'translate(' + this.leftTooltip.getCTM().e + ',' + (cPosition) + ')' });
                        this.rightTxt.setAttribute('x', 5);
                    }
                }
                    var rightUnAreawidth =  this.newWidth - rightValue-this.padding-2; // To check width on slider change
					rightUnAreawidth = rightUnAreawidth < 0 ? 0 : rightUnAreawidth;
					
                this.renderer._setAttr($(this.rightUnArea), {'width': rightUnAreawidth, 'transform': 'translate(' + parseFloat(rightValue + 2) + ',' + this.sliderPosition + ')' });
                this.renderer._setAttr($(this.rightSlider), { 'transform': 'translate(' + rightValue + ',' + this.sliderPosition + ')'});
                if (this.rightCircle != undefined) {
                    if (this.svgSupport)
                        this.renderer._setAttr($(this.rightCircle), { 'cx': rightValue });
                    else
                        this.renderer._setAttr($(this.rightCircle), { 'transform': 'translate(' + parseFloat(rightValue-10) + ',' + parseFloat(this.sliderPosition + (this.sliderHeight / 2)) + ')' }); //this.sliderPosition + (this.sliderHeight / 2)
                    this._rightValue = {
                        'left': rightValue - this.model.navigatorStyleSettings.thumbRadius,
                        'right': rightValue + this.model.navigatorStyleSettings.thumbRadius
                    }
                }// adding the left position for thumbright
                else {
                    var left = rightValue - ($("#" + this._id + "thumbright").width() / 2);
                    $("#" + this._id + "thumbright").css("left", left);
                    this._rightValue = {
                        'left': left,
                        'right': left + $("#" + this._id + "thumbright").width()
                    }
                }
                this.centerSliderWidth = parseFloat(this.rightSlider.getBoundingClientRect().left) - parseFloat(this.leftSlider.getBoundingClientRect().left);
                this.renderer._setAttr($(this.centerSlider), { 'width': Math.abs(this.centerSliderWidth)});
                
                this.model.zoomFactor = (this.rightSlider.getBoundingClientRect().left + parseFloat(this.renderer._getAttrVal($(this.rightSlider), 'width')) - this.leftSlider.getBoundingClientRect().left) / (this.newWidth - this.padding * 2);
					
                $(this.rightTooltip).show();
                $(this.gRightSlider).show();
                $(this.rightUnSelected).show();
            }
            else if (centerValue != null) {
                var rectwidth = this.renderer._getAttrVal($(this.leftSlider),'width');
				var rangeNavigatorWidth = this.newWidth - this.padding -2;
                var rightPosX = centerValue + parseFloat(this.renderer._getAttrVal($(this.centerSlider),'width'));
				if (rightPosX > rangeNavigatorWidth){
					leftPosX = centerValue = rangeNavigatorWidth - parseFloat(this.renderer._getAttrVal($(this.centerSlider),'width'));
					rightPosX = rangeNavigatorWidth;
				} else
					leftPosX = centerValue;		
                var startDateTime = new Date(this.model.rangeSettings.start);
                rtlValue = this.model.enableRTL ? (this.newWidth - leftPosX) : leftPosX;
                if (leftPosX >= this.padding && rightPosX <= this.newWidth - this.padding - 2) {
                    doubledate = (rtlValue / this.eachInterval) + this.startDateTime.getTime() - (this.padding / this.eachInterval);
                if(type=="datetime")
                    doubledate = new Date(doubledate);
                if (!this.model.enableRTL) 
                    this.model.selectedRangeSettings.start = doubledate;
                else
                    this.model.selectedRangeSettings.end = doubledate;

                    if(this.svgSupport)
                        this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + leftPosX + ',' + 0 + ')' });
                    else
                        this.renderer._setAttr($(this.leftSlider), { 'transform': 'translate(' + leftPosX + ',' + parseFloat(this.sliderPosition) + ')' });
                    this.leftSliderPosition = leftPosX;
                    if (this.leftCircle != undefined) {
                        if (this.svgSupport)
                            this.renderer._setAttr($(this.leftCircle), { 'cx': leftPosX });
                        else
                            this.renderer._setAttr($(this.leftCircle), { 'transform': 'translate(' + parseFloat(leftPosX - 10) + ',' + parseFloat(this.sliderPosition + (this.sliderHeight / 2)) + ')' });                        
                        this._leftValue = {
                            'left': leftPosX - this.model.navigatorStyleSettings.thumbRadius,
                            'right': leftPosX + this.model.navigatorStyleSettings.thumbRadius
                        }
                    }
                    else {
                        var left = leftPosX - ($("#" + this._id + "thumbleft").width() / 2);
                        $("#" + this._id + "thumbleft").css("left", left);
                        this._leftValue = {
                            'left': left,
                            'right': left + $("#" + this._id + "thumbleft").width()
                        }
                    }
                    if (this.model.tooltipSettings.visible && this.svgSupport && this.leftTxt) {
                        this.leftTooltip.setAttribute('opacity', this.setopacity);
                        if(type=="datetime")
                            this.leftTxt.textContent = ej.format(new Date(doubledate), this.model.tooltipSettings.labelFormat, locale);
                        else {
                            if (tooltipFormat.indexOf('e') == 0 || tooltipFormat.indexOf('E') == 0)
                                this.leftTxt.textContent = doubledate.toExponential(tooltipPrecision);
                            else this.leftTxt.textContent = ej.format(doubledate, this.model.tooltipSettings.labelFormat, locale);
                        }
                        var txtwidth = this.leftTooltip.lastChild.getBBox().width + 15;
                        var txtheight = this.leftTooltip.lastChild.getBBox().height;
                        var txty = this.brow != "msie" ? (txtheight + 6) / 2 : (txtheight / 2) + 6;
                        this.leftTxt.setAttribute('y', txty);
                        this.rightTxt.setAttribute('y', txty);
                        this.leftd = "M 0 0 L 0 " + (txtheight + 6) + " L " + (txtwidth - 6) + " " + (txtheight + 6) + " L " + (txtwidth - 6) + " 6 L " + txtwidth + " 0 Z";
                        this.rightd = "M 0 0 L " + txtwidth + " 0 L " + txtwidth + " " + (txtheight + 6) + " L 6 " + (txtheight + 6) + " L 6 6 Z";
                        if (leftPosX - txtwidth >= 0) {
                            this.leftTooltip.firstChild.setAttribute('d', this.leftd);
                            this.renderer._setAttr($(this.leftTooltip), { 'transform': 'translate(' + (leftPosX - txtwidth) + ',' + cPosition + ')' });
                            this.leftTxt.setAttribute('x', 5);
                        }
                        else {
                            this.renderer._setAttr($(this.leftTooltip), { 'transform': 'translate(' + (leftPosX) + ',' + cPosition + ')'});
                            this.leftTooltip.firstChild.setAttribute('d', this.rightd);
                            this.leftTxt.setAttribute('x', 10);
                            if (this.leftSliderPosition + txtwidth > this.rightSlider.getCTM().e) {
                                this.renderer._setAttr($(this.leftTooltip), { 'transform': 'translate(' + (leftPosX) + ',' + (cPosition + 30) + ')'});
                            }

                        }
                    }
                    rtlValue = this.model.enableRTL ? (this.newWidth - rightPosX) : rightPosX;
                    var doubledate = (rtlValue / this.eachInterval) + this.startDateTime.getTime() - (this.padding / this.eachInterval);
                    if (type == "datetime")
                        doubledate = new Date(doubledate);
					// fixing issue for end value when using numeric valutype
                    else
                        doubledate = (rtlValue / this.eachInterval) + this.startValue - (this.padding / this.eachInterval);
                    if (!this.model.enableRTL)
                        this.model.selectedRangeSettings.end = doubledate;
                    else
                        this.model.selectedRangeSettings.start = doubledate;
                    this.renderer._setAttr($(this.rightSlider), { 'transform': 'translate(' + rightPosX + ',' + this.sliderPosition + ')' });
                    this.rightSliderPosition = rightPosX;
                    if (this.rightCircle != undefined) {
                        if (this.svgSupport)
                            this.renderer._setAttr($(this.rightCircle), { 'cx': rightPosX });
                        else
                            this.renderer._setAttr($(this.rightCircle), { 'transform': 'translate(' + parseFloat(rightPosX - 10) + ',' + parseFloat(this.sliderPosition + (this.sliderHeight / 2)) + ')' });                        
                        this._rightValue = {
                            'left': rightPosX - this.model.navigatorStyleSettings.thumbRadius,
                            'right': rightPosX + this.model.navigatorStyleSettings.thumbRadius
                        }
                    }
                    else {
                        var left = rightPosX - ($("#" + this._id + "thumbright").width() / 2);
                        $("#" + this._id + "thumbright").css("left", left);
                        this._rightValue = {
                            'left': left,
                            'right': left + $("#" + this._id + "thumbright").width()
                        }
                    }
                    if (this.model.tooltipSettings.visible && this.svgSupport) {
                        this.rightTooltip.setAttribute('opacity', this.setopacity);
                        if(type=="datetime")
                            this.rightTxt.textContent = ej.format(new Date(doubledate), this.model.tooltipSettings.labelFormat, locale);
                        else {
                            if (tooltipFormat.indexOf('e') == 0 || tooltipFormat.indexOf('E') == 0)
                                this.rightTxt.textContent = doubledate.toExponential(tooltipPrecision);
                            else this.rightTxt.textContent = ej.format(doubledate, this.model.tooltipSettings.labelFormat, locale);
                        }
                        var txtwidth = this.rightTooltip.lastChild.getBBox().width + 15;
                        var txtheight = this.rightTooltip.lastChild.getBBox().height;
                        this.leftd = "M 0 0 L 0 " + (txtheight + 6) + " L " + (txtwidth - 6) + " " + (txtheight + 6) + " L " + (txtwidth - 6) + " 6 L " + txtwidth + " 0 Z";
                        this.rightd = "M 0 0 L " + txtwidth + " 0 L " + txtwidth + " " + (txtheight + 6) + " L 6 " + (txtheight + 6) + " L 6 6 Z";
                        if (rightPosX + txtwidth <= this.newWidth) {
                            this.rightTooltip.firstChild.setAttribute('d', this.rightd);
                            this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + (rightPosX) + ',' + cPosition + ')' });
                            this.rightTxt.setAttribute('x', 10);
                        }
                        else {
                            this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + (rightPosX - txtwidth) + ',' + cPosition + ')'});
                            this.rightTooltip.firstChild.setAttribute('d', this.leftd);
                            this.rightTxt.setAttribute('x', 5);
                            if (this.rightTooltip.getBoundingClientRect().left < this.leftSlider.getBoundingClientRect().left) {
                                this.renderer._setAttr($(this.rightTooltip), { 'transform': 'translate(' + (rightPosX - txtwidth) + ',' + (cPosition + 30) + ')' });
                            }
                        }
                    }
                    this.renderer._setAttr($(this.leftUnArea), { 'width': leftPosX - this.padding,'transform': 'translate(' + this.padding + ',' + this.sliderPosition + ')'});
                    this.renderer._setAttr($(this.rightUnArea), { 'transform': 'translate(' + parseFloat(rightPosX + 2) + ',' + this.sliderPosition + ')','width': this.newWidth - rightPosX-this.padding-2});

                    this.model.zoomPosition = (this.leftSlider.getBoundingClientRect().left - this.padding) / (this.newWidth - this.padding * 2);

                    this.renderer._setAttr($(this.centerSlider), { 'transform': 'translate(' + centerValue + ',' + this.sliderPosition + ')' });
                    this.model.zoomFactor = (this.rightSlider.getBoundingClientRect().left + parseFloat(this.renderer._getAttrVal($(this.rightSlider), 'width')) - this.leftSlider.getBoundingClientRect().left) / (this.newWidth - this.padding * 2);
                    $(this.leftTooltip).show();
                    $(this.rightTooltip).show();
                }
               
            }
            if (!this._scrollChanged && !this.isSelection) {
                if ((!this.model.enableDeferredUpdate) && this.leftSlider.getBoundingClientRect().left < this.rightSlider.getBoundingClientRect().left) {
                    this._calculateSelectedData();
                    if (this.zoomp != this.model.zoomPosition || this.zoomf != this.model.zoomFactor) {
                        this._calculateSliderZoomFactPosition();
                        this._trigger("rangeChanged", this.model);
                        this.zoomp = this.model.zoomPosition;
                        this.zoomf = this.model.zoomFactor;
                    }
                }
            }
          
        },
        _calculateSliderZoomFactPosition: function () {
            var model = this.model,
                delta, zoomPos, zoomFact, start, end,
                selectedRange = model.selectedRangeSettings,
                virtualRange = model.scrollRangeSettings;
            if (model.valueType.toLowerCase() == "datetime") {
                start = virtualRange.start ? new Date(virtualRange.start) : this.startDateTime;
                start = start < this.startDateTime ? start: this.startDateTime;
                end = virtualRange.end ? new Date(virtualRange.end) : this.endDateTime;
                end = end > this.endDateTime ? end : this.endDateTime;
                delta = end - start;
                zoomPos = (new Date(selectedRange.start) - start) / delta;
                zoomFact = (new Date(selectedRange.end) - new Date(selectedRange.start)) / delta;
            } else {
                start = virtualRange.start != "" ? parseFloat(virtualRange.start) : this.startValue;
                start = start < this.startValue ? start : this.startValue;
                end = virtualRange.end != "" ? parseFloat(virtualRange.end) : this.endValue;
                end = end > this.endValue ? end : this.endValue;
                delta = end - start;
                zoomPos = (parseFloat(selectedRange.start) - start) / delta;
                zoomFact = (parseFloat(selectedRange.end) - parseFloat(selectedRange.start)) / delta;
            }
             model.zoomPosition = zoomPos;
             model.zoomFactor = zoomFact;            
        },

        _calculateSelectedData: function () {
            var j = [], count=0, isDate = this.model.valueType == "datetime", startValue = this.model.selectedRangeSettings.start, endValue = this.model.selectedRangeSettings.end;
            if (isDate) {
                startValue = Date.parse(startValue); endValue = Date.parse(endValue);
            }
            var dataSource = (this.model.dataSource != "") ? this.model.dataSource : ((this.model.series != "" && this.model.series[0].dataSource != "") ? this.model.series[0].dataSource : null);
            if (dataSource != null) {
                for (var i = 0; i < dataSource.length - 1; i++) {
                    currentValue = isDate ? Date.parse(dataSource[i][Object.keys(dataSource[i])[0]]) : dataSource[i][Object.keys(dataSource[i])[0]];
                    if ((startValue <= currentValue) && (currentValue <= endValue)) {
                        j[count] = dataSource[i];
                        count++;
                    }
                }
            }
            this.model.selectedData = j;
        },

        calculateInterval: function (higherLevel, lowerLevel) {
            lowerLevel._intervalType = lowerLevel.intervalType ? lowerLevel.intervalType : "auto";

            if (lowerLevel.visible === true && this.model.valueType == "datetime")
               this.calculateVisibleLabels(lowerLevel, "lower", 0);

            if (higherLevel.visible === true && this.model.valueType == "datetime") {
                if (higherLevel.intervalType && higherLevel.intervalType.toLowerCase() != "auto")
                    higherLevel._intervalType = higherLevel.intervalType;
                else {
                    switch (lowerLevel._intervalType) {
                        case "years":
                            higherLevel._intervalType = "years";
                            break;
                        case "quarters":
                            higherLevel._intervalType = "years";
                            break;
                        case "months":
                            higherLevel._intervalType = "quarters";
                            break;
                        case "weeks":
                            higherLevel._intervalType = "months";
                            break;
                        case "days":
                            higherLevel._intervalType = "weeks";
                            break;
                        case "hours":
                            higherLevel._intervalType = "days";
                            break;
                        case "minutes":
                            higherLevel._intervalType = "hours";
                            break;
                    }
                }

                if (higherLevel.autoInterval == false)
                    this.calculateVisibleLabels(higherLevel, "higher", 0);
                else
                    this.calculateVisibleLabels(higherLevel, "higher", 0);
                
            }

            if (lowerLevel.visible === true && this.model.valueType == "numeric")
                this.setInterval(this);
        },

        calculateVisibleLabels: function (label, labelType, level) {

            var type = label._intervalType;

            switch (type) {
                case "auto":
                    var intervalX = this.calculateDateTimeNiceInterval(this, this.startDateTime, this.endDateTime);
                    var intrvlType = intervalX.intervalType.toLowerCase();                    
                    label._intervalType = intrvlType;
                    label._interval = intervalX.interval;

                    this.calculateVisibleLabels(label, labelType, level)
                    break;
                case "years":
                    this.setYearInterval(this, labelType);
                    break;
                case "quarters":
                    this.setQuarterInterval(this, labelType, level);
                    break;
                case "months":
                    this.setMonthInterval(this, labelType, level);
                    break;
                case "weeks":
                    this.setWeekInterval(this, labelType, level);
                    break;
                case "days":
                    this.setDayInterval(this, labelType, level);
                    break;
                case "hours":
                    this.setHourInterval(this, labelType, level);
                    break;
                case "minutes":
                    this.setMinuteInterval(this, labelType, level);
                    break;
                default:
                    break;
            }
        },

        setInterval: function (naviobj) {
            var currentValue, lastValue;
            var delta = this.endValue - this.startValue;
            var rangePadding = naviobj.model.rangePadding;
            var start = this.startValue;
            var numericInterval = this.calculateNumericInterval(naviobj, delta);
            if (rangePadding == "additional") {
                this.endValue = this.endValue + numericInterval;
                this.startValue = this.startValue - numericInterval;
                delta = this.endValue - this.startValue;
              //  numericInterval = this.calculateNumericInterval(naviobj, delta);
            } else if (rangePadding == "normal") {
                var minimum = 0, remaining;
                if (start < 0) {
                    start = 0;
                    minimum = this.startValue + (this.startValue / 20);

                    remaining = numericInterval + (minimum % numericInterval);

                    if ((0.365 * numericInterval) >= remaining) {
                        minimum -= numericInterval;
                    }

                    if (minimum % numericInterval < 0) {
                        minimum = (minimum - numericInterval) - (minimum % numericInterval);
                    }
                } else {
                    minimum = start < ((5.0 / 6.0) * this.endValue)
                        ? 0
                        : (start - (this.endValue - start) / 2);
                    if (minimum % numericInterval > 0) {
                        minimum -= (minimum % numericInterval);
                    }
                }
                var maximum = (this.endValue + (this.endValue - start) / 20);

                remaining = numericInterval - (maximum % numericInterval);

                if ((0.365 * numericInterval) >= remaining) {
                    maximum += numericInterval;
                }

                if (maximum % numericInterval > 0) {
                    maximum = (maximum + numericInterval) - (maximum % numericInterval);
                }
                numericInterval = this.calculateNumericInterval(naviobj, maximum - minimum);
                this.startValue = minimum;
                this.endValue = maximum;

            } else if (rangePadding == "round") {
                this.startValue = Math.floor((this.startValue / numericInterval) * numericInterval);
                this.endValue = Math.ceil((this.endValue / numericInterval) * numericInterval);
            }

            currentValue = naviobj.startValue;
            count = 0;
            while (currentValue <= naviobj.endValue) {
                this._insertNumericText(naviobj,currentValue);
                count++;
                currentValue = currentValue + numericInterval;
            }
            this.insertLabels(naviobj, "lower");

        },
        
        calculateDateTimeNiceInterval: function (naviObj, startDate, endDate) {

            var oneDay = 24 * 60 * 60 * 1000;            
            var totalDays = (Math.abs((startDate.getTime() - endDate.getTime()) / (oneDay)));
            var interval = this.calculateNumericInterval(naviObj, totalDays / 365);

            if (interval >= 1) {
                return { interval: interval, intervalType: "Years" };
            }

            interval = this.calculateNumericInterval(naviObj, totalDays / 90);

            if (interval >= 1) {
                return { interval: interval, intervalType: "Quarters" };
            }

            interval = this.calculateNumericInterval(naviObj, totalDays / 30);

            if (interval >= 1) {
                return { interval: interval, interval1: interval, intervalType: "Months" };
            }

            interval = this.calculateNumericInterval(naviObj, totalDays / 7);

            if (interval >= 1) {
                return { interval: interval, intervalType: "Weeks", intervalType1: "Weeks" };
            }

            interval = this.calculateNumericInterval(naviObj, totalDays);

            if (interval >= 1) {
                return { interval: interval, intervalType: "Days" };
            }

            var totalHours = totalDays * 24;
            interval = this.calculateNumericInterval(naviObj, totalHours);

            if (interval >= 1) {
                return { interval: interval, intervalType: "Hours" };
            }

            var totalMinutes = totalDays * 24 * 60;

            interval = this.calculateNumericInterval(naviObj, totalMinutes);

            return { interval: interval, intervalType: "Minutes" };
        },

        calculateNumericInterval: function (naviobj,delta) {
            var desiredIntervalsCount = this.GetDesiredIntervalsCount(naviobj.newWidth);
            var niceInterval = delta / desiredIntervalsCount;
            var minInterval = Math.pow(10, Math.floor(ej.EjSvgRender.utils._logBase(niceInterval, 10)));
            var intervalDivs = [10, 5, 2, 1];

            for (var i = 0; i < intervalDivs.length; i++) {
                var currentInterval = minInterval * intervalDivs[i];
                if (desiredIntervalsCount < (delta / currentInterval)) {
                    return niceInterval;
                }

                niceInterval = currentInterval;
            }

            return niceInterval;
        },

        GetDesiredIntervalsCount: function (size) {
                var desiredIntervalsCount = 0.8* 2;
                desiredIntervalsCount = Math.max((size * (desiredIntervalsCount / 100)), 1);
                return desiredIntervalsCount;
        },

        setHourInterval: function (naviobj, position, level) {

            naviobj._higherTextNode = [];
            naviobj._higherTotalValues = [];
            naviobj._lowerTextNode = [];
            naviobj._lowerTotalValues = [];
            if (position === "higher")
                $("#higherLevel").children().empty();
            else
                $("#lowerLevel").children().empty();

            Date.prototype.addHours = function (hours) {
                var dat = new Date(this.valueOf())
                if (dat.getMilliseconds() !== 0) {
                    dat.setMilliseconds(dat.getMilliseconds() + (1000 - dat.getMilliseconds()));
                }
                if (dat.getSeconds() !== 0) {
                    dat.setSeconds(dat.getSeconds() + (60 - dat.getSeconds()));
                }
                if (dat.getMinutes() !== 0) {                    
                    dat.setMinutes(dat.getMinutes() + (60 - dat.getMinutes()));
                }
                else
                    dat.setHours(dat.getHours() + hours);
                return dat;
            }

            var hourArray = [];
            var currentDate = naviobj.startDateTime;
            var count = 0;
            var txtBlockWidth = 0;
            var bwidth = 0;
            switch (level) {
                case 0:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "hhtt", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addHours(1);
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setHourInterval(naviobj, position, 1);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 1:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "hht", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;                        
                        currentDate = currentDate.addHours(1);
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setHourInterval(naviobj, position, 2);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 2:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "hh", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addHours(1);
                    }
                    if (txtBlockWidth >= naviobj.newWidth) {
                        //Remove already inserted hours text value from DOM and calculate days interval
                        $(naviobj.lowerLevel).empty();
                        naviobj.model.labelSettings.lowerLevel._intervalType = "days";
                        naviobj.setDayInterval(naviobj, position, 0);
                    }
                    else
                        this.insertLabels(naviobj, position);
                    break;
            }
        },

        setMinuteInterval: function (naviobj, position, level) {

            naviobj._higherTextNode = [];
            naviobj._higherTotalValues = [];
            naviobj._lowerTextNode = [];
            naviobj._lowerTotalValues = [];
            if (position === "higher")
                $("#higherLevel").children().empty();
            else
                $("#lowerLevel").children().empty();

            Date.prototype.addMinutes = function (minutes) {
                var dat = new Date(this.valueOf())
                if (dat.getMilliseconds() !== 0) {
                    dat.setMilliseconds(dat.getMilliseconds() + (1000 - dat.getMilliseconds()));
                }
                if (dat.getSeconds() !== 0) {
                    dat.setSeconds(dat.getSeconds() + (60 - dat.getSeconds()));
                }
                else
                    dat.setMinutes(dat.getMinutes() + minutes);
                return dat;
            }

            var hourArray = [];
            var currentDate = naviobj.startDateTime;
            var count = 0;
            var txtBlockWidth = 0;
            var bwidth = 0;
            switch (level) {
                case 0:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "mm", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addMinutes(1);
                    }
                    if (txtBlockWidth >= naviobj.newWidth) {
                        //Remove already inserted minutes text value from DOM and calculate hours interval
                        $(naviobj.lowerLevel).empty();
                        naviobj.model.labelSettings.lowerLevel._intervalType = "hours";
                        naviobj.setHourInterval(naviobj, position, 0);
                    } else
                        this.insertLabels(naviobj, position);
                    break;                
            }
        },
        // Empty the labelbars
        _emptyLabelBars: function (naviobj, position) {
            naviobj._higherTextNode = [];
            naviobj._higherTotalValues = [];
            naviobj._lowerTextNode = [];
            naviobj._lowerTotalValues = [];
            if (position === "higher")
                $("#higherLevel").children().empty();
            else
                $("#lowerLevel").children().empty();
        },

        //to insert week text as there is no globalized format for week
        _insertWeekText: function (naviobj, position, textValue, currentDate, count, bwidth) {
            var hiLabelFont = naviobj.model.labelSettings.higherLevel.style.font;
            var loLabelFont = naviobj.model.labelSettings.lowerLevel.style.font;
            if (position === "higher") {
                if (count == 0)
                    naviobj._higherTotalValues[count] = 0;
                else
                    naviobj._higherTotalValues[count] = currentDate.getTime() - naviobj.startDateTime.getTime();
                var textOptions = {
                    'id': this._rootId + '_higLabelBarText' + '_' + count,
                    'x': 0,
                    'y': 0,
                    'text-anchor': 'start',
                    'dominant-baseline': 'middle',
                    "font-size": hiLabelFont.size,
                    "font-family": hiLabelFont.family,
                    "font-style": hiLabelFont.style,
                    "font-weight": hiLabelFont.weight,
                    "fill": hiLabelFont.color
                };
                naviobj.renderer.drawText(textOptions, textValue, naviobj.higherLevel);
                naviobj._higherTextNode[count] = naviobj.higherLevel.childNodes[count];
                var labelfont = { size: naviobj.model.labelSettings.higherLevel.style.font.size, fontStyle: naviobj.model.labelSettings.higherLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.higherLevel.style.font.fontFamily };
                if (this.svgSupport)
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].textContent, null, labelfont);
                else
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].innerHTML, null, labelfont);
                bwidth = Math.max(bwidth, textOffset.width);
            }
            else {
                if (count == 0)
                    naviobj._lowerTotalValues[count] = 0;
                else
                    naviobj._lowerTotalValues[count] = currentDate.getTime() - naviobj.startDateTime.getTime();
                var textOptions = {
                    'id': this._rootId + '_LabelBarText' + '_' + count,
                    'x': 0,
                    'y': 0,
                    'text-anchor': 'start',
                    'dominant-baseline': 'middle',
                    "font-size": loLabelFont.size,
                    "font-family": loLabelFont.family,
                    "font-style": loLabelFont.style,
                    "font-weight": loLabelFont.weight,
                    "fill": loLabelFont.color
                };

                naviobj.renderer.drawText(textOptions, textValue, naviobj.lowerLevel);
                naviobj._lowerTextNode[count] = naviobj.lowerLevel.childNodes[count];
                var labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
                if (this.svgSupport)
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont);
                else
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].innerHTML, null, labelfont);
                bwidth = Math.max(bwidth, textOffset.width);
            }

            return bwidth;
        },

        //To calculate Week Interval
        setWeekInterval: function (naviobj, position, level) {

            this._emptyLabelBars(naviobj, position);
            //get week number of a year
            Date.prototype.getWeek = function () {
                var date = new Date(this.getTime());
                date.setHours(0, 0, 0, 0);
                // Thursday in current week decides the year.
                date.setDate(date.getDate() + 3 - (date.getDay() + 6) % 7);
                // January 4 is always in week 1.
                var week1 = new Date(date.getFullYear(), 0, 4);
                // Adjust to Thursday in week 1 and count number of weeks from date to week1.
                return 1 + Math.round(((date.getTime() - week1.getTime()) / 86400000
                                      - 3 + (week1.getDay() + 6) % 7) / 7);
            }

            Date.prototype.dayOfWeek = function () {
                var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
                return days[this.getDay()];
            }

            Date.prototype.addDays = function (noOfDays) {
                var dat = new Date(this.valueOf());
                dat = new Date(dat.getFullYear(), dat.getMonth(), dat.getDate() + noOfDays);
                return dat;
            }

            Date.prototype.subDays = function (noOfDays) {
                var dat = new Date(this.valueOf());
                dat = new Date(dat.getFullYear(), dat.getMonth(), dat.getDate() - noOfDays);
                return dat;
            }

            var currentDate = naviobj.startDateTime;
            var count = 0;
            var txtBlockWidth = 0;
            var bwidth = 0;
			var culture = this.model.locale;
			var locale = ej.datavisualization.RangeNavigator.Locale[culture] ? ej.datavisualization.RangeNavigator.Locale[culture] : ej.datavisualization.RangeNavigator.Locale["en-US"];

			
			    while (currentDate.dayOfWeek() != "Monday") {
			        currentDate = currentDate.subDays(1);
			    }
            switch (level) {
                case 0:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertWeekText(naviobj, position, this._localizedLabels.intervals.week.longWeeks + currentDate.getWeek() + ej.format(currentDate, " MMMM, yyyy", culture), currentDate, count, bwidth);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays(7);
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setWeekInterval(naviobj, position, 1);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 1:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertWeekText(naviobj, position, this._localizedLabels.intervals.week.longWeeks + currentDate.getWeek() + ej.format(currentDate, " MMM, yy", culture), currentDate, count, bwidth);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays(7);
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setWeekInterval(naviobj, position, 2);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 2:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertWeekText(naviobj, position, this._localizedLabels.intervals.week.longWeeks + currentDate.getWeek(), currentDate, count, bwidth);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays(7);
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setWeekInterval(naviobj, position, 3);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 3:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertWeekText(naviobj, position, this._localizedLabels.intervals.week.shortWeeks + currentDate.getWeek(), currentDate, count, bwidth);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays(7);
                    }
                        this.insertLabels(naviobj, position);
                    break;
            }
        },
       
        setDayInterval: function (naviobj, position, level) {
            naviobj._higherTextNode = [];
            naviobj._higherTotalValues = [];
            naviobj._lowerTextNode = [];
            naviobj._lowerTotalValues = []; 
            if (position === "higher")
                $("#higherLevel").children().empty();
            else
                $("#lowerLevel").children().empty();

            Date.prototype.addDays = function () {
                var dat = new Date(this.valueOf());
                dat = new Date(dat.getFullYear(), dat.getMonth(), dat.getDate() + 1);
                return dat;
            }

            var hourArray = [], currentDate = naviobj.startDateTime, count = 0, txtBlockWidth = 0, bwidth = 0, bBox;
            switch (level) {
                case 0:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "dddd, MMMM d, yyyy", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;                       
                        currentDate = currentDate.addDays();
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setDayInterval(naviobj, position, 1);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 1:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "ddd, MMM d, yy", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays();                        
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setDayInterval(naviobj, position, 2);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 2:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "dddd, d", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays();                        
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setDayInterval(naviobj, position, 3);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 3:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "MMM, d", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays();
                    }
                    if (txtBlockWidth >= naviobj.newWidth)
                        naviobj.setDayInterval(naviobj, position, 4);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 4:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "dd", currentDate, count, bwidth, false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addDays();                       
                    }
                    this.insertLabels(naviobj, position);
                    break;
                default:
                    break;

            }

        },

        setMonthInterval: function (naviobj, position, level) {
            naviobj._higherTextNode = [];
            naviobj._higherTotalValues = [];
            naviobj._lowerTextNode = [];
            naviobj._lowerTotalValues = [];
            if (position === "higher")
                $("#higherLevel").children().empty();
            else
                $("#lowerLevel").children().empty();           

            var currentDate = naviobj.startDateTime;            
			var textPadding =5;
            var count = 0;
            var date = new Date(naviobj.startDateTime);
            var txtBlockWidth = 0;
            var bwidth = 0;
            var bBox;

            switch (level) {
                case 0:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "MMMM, yyyy", currentDate, count, bwidth,false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addMonths();
                    }
                    if (txtBlockWidth + textPadding >= naviobj.newWidth)
                        naviobj.setMonthInterval(naviobj, position, 1);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 1:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "MMMM", currentDate, count, bwidth,false);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addMonths();
                    }
                    if (txtBlockWidth + textPadding >= naviobj.newWidth)
                        naviobj.setMonthInterval(naviobj, position, 2);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 2:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "MMM", currentDate, count, bwidth,false);
                        txtBlockWidth += bwidth;                        
                        count++;
                        currentDate = currentDate.addMonths();
                    }
                    if (txtBlockWidth + textPadding >= naviobj.newWidth)
                        naviobj.setMonthInterval(naviobj, position, 3);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 3:
                    while (currentDate <= naviobj.endDateTime) {
                        bwidth = this._insertText(naviobj, position, "MMM", currentDate, count, bwidth, true);
                        txtBlockWidth += bwidth;
                        count++;
                        currentDate = currentDate.addMonths();
                    }
                    this.insertLabels(naviobj, position);
                    break;
                default:
                    break;

            }

        },

        _quarter: function (naviobj, position, quarterValue, yearString, date, txtBlockWidth, count) {
            
            for (var i = naviobj.startYear; i <= naviobj.endYear; i++) {
                var stringDate = yearString != null ? ej.format(date, yearString, naviobj.model.locale) : "";
                if (i === naviobj.startYear) {
                    for (var j = naviobj.startMonth; j <= 11 && (date <= this.endDateTime); j++) {
                        if (position == "higher") {
                            var textOptions = {
                                'id': this._rootId + '_higLabelBarText' + '_' + count,
                                'x': 0,
                                'y': 0,
                                'text-anchor': 'start',
                                'dominant-baseline': 'middle',
                                "font-size": naviobj.model.labelSettings.higherLevel.style.font.size,
                                "font-family": naviobj.model.labelSettings.higherLevel.style.font.fontFamily,
                                "font-style": naviobj.model.labelSettings.higherLevel.style.font.fontStyle,
                                "font-weight": naviobj.model.labelSettings.higherLevel.style.font.fontWeight,
                                "fill":naviobj.model.labelSettings.higherLevel.style.font.color
                            };
                        }
                        else {
                            var textOptions = {
                                'id': this._rootId + '_LabelBarText' + '_' + count,
                                'x': 0,
                                'y': 0,
                                'text-anchor': 'start',
                                'dominant-baseline': 'middle',
                                "font-size": naviobj.model.labelSettings.lowerLevel.style.font.size,
                                "font-family": naviobj.model.labelSettings.lowerLevel.style.font.fontFamily,
                                "font-style": naviobj.model.labelSettings.lowerLevel.style.font.fontStyle,
                                "font-weight": naviobj.model.labelSettings.lowerLevel.style.font.fontWeight,
                                "fill":naviobj.model.labelSettings.lowerLevel.style.font.color
                            };
                        }
                        if (j >= 0 && j <= 2) {
                            if(position=="higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "1 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "1 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(3));
                            k = 2;
                        }
                        else if (j >= 3 && j <= 5) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "2 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "2 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(6));
                            k = 5;

                        }
                        else if (j >= 6 && j <= 8) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "3 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "3 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(9));
                            k = 8;

                        }
                        else if (j >= 9 && j <= 11) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "4 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "4 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(12));
                            k = 11;

                        }


                        if (position === "lower") {
                            if (j === naviobj.startMonth)
                                naviobj._lowerTotalValues[count] = naviobj.startDateTime.getTime() - naviobj.startDateTime.getTime();
                            else
                                naviobj._lowerTotalValues[count] = new Date(naviobj.startYear + "/" + parseInt(j + 1) + "/1").getTime() - naviobj.startDateTime.getTime();
                            j = k;
                            naviobj._lowerTextNode[count] = naviobj.lowerLevel.childNodes[count];
                            var labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
                            var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont);
                            txtBlockWidth += textOffset.width;
                        }
                        else {
                            if (j === naviobj.startMonth)
                                naviobj._higherTotalValues[count] = naviobj.startDateTime.getTime() - naviobj.startDateTime.getTime();
                            else
                                naviobj._higherTotalValues[count] = new Date(naviobj.startYear + "/" + parseInt(j + 1) + "/1").getTime() - naviobj.startDateTime.getTime();
                            j = k;
                            naviobj._higherTextNode[count] = naviobj.higherLevel.childNodes[count];
                            var labelfont = { size: naviobj.model.labelSettings.higherLevel.style.font.size, fontStyle: naviobj.model.labelSettings.higherLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.higherLevel.style.font.fontFamily };
                            var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].textContent, null, labelfont);
                            txtBlockWidth += textOffset.width;
                        }
                        count++;
                    }
                }
                else if (i === naviobj.endYear) {
                    for (var j = 0; j <= naviobj.endMonth; j++) {
                        if (position == "higher") {
                            var textOptions = {
                                'id': this._rootId + '_higLabelBarText' + '_' + count,
                                'x': 0,
                                'y': 0,
                                'text-anchor': 'start',
                                'dominant-baseline': 'middle',
                                "font-size": naviobj.model.labelSettings.higherLevel.style.font.size,
                                "font-family": naviobj.model.labelSettings.higherLevel.style.font.fontFamily,
                                "font-style": naviobj.model.labelSettings.higherLevel.style.font.fontStyle,
                                "font-weight": naviobj.model.labelSettings.higherLevel.style.font.fontWeight
                            };
                        }
                        else {
                            var textOptions = {
                                'id': this._rootId + '_LabelBarText' + '_' + count,
                                'x': 0,
                                'y': 0,
                                'text-anchor': 'start',
                                'dominant-baseline': 'middle',
                                "font-size": naviobj.model.labelSettings.lowerLevel.style.font.size,
                                "font-family": naviobj.model.labelSettings.lowerLevel.style.font.fontFamily,
                                "font-style": naviobj.model.labelSettings.lowerLevel.style.font.fontStyle,
                                "font-weight": naviobj.model.labelSettings.lowerLevel.style.font.fontWeight
                            };
                        }
                        if (j >= 0 && j <= 2) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "1 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "1 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(3));
                            k = 2;
                        }
                        else if (j >= 3 && j <= 5) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "2 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "2 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(6));
                            k = 5;

                        }
                        else if (j >= 6 && j <= 8) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "3 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "3 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(9));
                            k = 8;

                        }
                        else if (j >= 9 && j <= 11) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "4 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "4 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(12));
                            k = 11;
                        }


                        if (position === "lower") {
                            naviobj._lowerTotalValues[count] = new Date(naviobj.endYear + "/" + parseInt(j + 1) + "/1").getTime() - naviobj.startDateTime.getTime();                            
                            j = k;
                            naviobj._lowerTextNode[count] = naviobj.lowerLevel.childNodes[count];
                            var labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
                            var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont);
                            txtBlockWidth += textOffset.width;
                        }
                        else {
                            naviobj._higherTotalValues[count] = new Date(naviobj.endYear + "/" + parseInt(j + 1) + "/1").getTime() - naviobj.startDateTime.getTime();
                            j = k;
                            naviobj._higherTextNode[count] = naviobj.higherLevel.childNodes[count];
                            var labelfont = { size: naviobj.model.labelSettings.higherLevel.style.font.size, fontStyle: naviobj.model.labelSettings.higherLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.higherLevel.style.font.fontFamily };
                            var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].textContent, null, labelfont);
                            txtBlockWidth += textOffset.width;
                        }
                        count++;
                    }
                }
                else {
                    for (var j = 0; j <= 11; j++) {
                        if (position == "higher") {
                            var textOptions = {
                                'id': this._rootId + '_higLabelBarText' + '_' + count,
                                'x': 0,
                                'y': 0,
                                'text-anchor': 'start',
                                'dominant-baseline': 'middle',
                                "font-size": naviobj.model.labelSettings.higherLevel.style.font.size,
                                "font-family": naviobj.model.labelSettings.higherLevel.style.font.fontFamily,
                                "font-style": naviobj.model.labelSettings.higherLevel.style.font.fontStyle,
                                "font-weight": naviobj.model.labelSettings.higherLevel.style.font.fontWeight
                            };
                        }
                        else {
                            var textOptions = {
                                'id': this._rootId + '_LabelBarText' + '_' + count,
                                'x': 0,
                                'y': 0,
                                'text-anchor': 'start',
                                'dominant-baseline': 'middle',
                                "font-size": naviobj.model.labelSettings.lowerLevel.style.font.size,
                                "font-family": naviobj.model.labelSettings.lowerLevel.style.font.fontFamily,
                                "font-style": naviobj.model.labelSettings.lowerLevel.style.font.fontStyle,
                                "font-weight": naviobj.model.labelSettings.lowerLevel.style.font.fontWeight
                            };
                        }
                        if (j >= 0 && j <= 2) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "1 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "1 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(3));
                            k = 2;
                        }
                        else if (j >= 3 && j <= 5) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "2 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "2 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(6));
                            k = 5;

                        }
                        else if (j >= 6 && j <= 8) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "3 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "3 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(9));
                            k = 8;

                        }
                        else if (j >= 9 && j <= 11) {
                            if (position == "higher")
                                naviobj.renderer.drawText(textOptions, quarterValue + "4 " + stringDate, naviobj.higherLevel);
                            else
                                naviobj.renderer.drawText(textOptions, quarterValue + "4 " + stringDate, naviobj.lowerLevel);
                            date = new Date(date.setMonth(12));
                            k = 11;

                        }


                        if (position === "lower") {
                            naviobj._lowerTotalValues[count] = new Date(i + "/" + parseInt(j + 1) + "/1").getTime() - naviobj.startDateTime.getTime();
                            j = k;
                            naviobj._lowerTextNode[count] = naviobj.lowerLevel.childNodes[count];
                            var labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
                            var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont);
                            txtBlockWidth += textOffset.width;
                        }
                        else {
                            naviobj._higherTotalValues[count] = new Date(i + "/" + parseInt(j + 1) + "/1").getTime() - naviobj.startDateTime.getTime();
                            j = k;
                            naviobj._higherTextNode[count] = naviobj.higherLevel.childNodes[count];
                            var labelfont = { size: naviobj.model.labelSettings.higherLevel.style.font.size, fontStyle: naviobj.model.labelSettings.higherLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.higherLevel.style.font.fontFamily };
                            var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].textContent, null, labelfont);
                            txtBlockWidth += textOffset.width;
                        }
                        count++;
                    }
                }

            }
            return txtBlockWidth;
        },

        setQuarterInterval: function (naviobj, position, level) {
            naviobj._higherTextNode = [];
            naviobj._higherTotalValues = [];
            naviobj._lowerTextNode = [];
            naviobj._lowerTotalValues = [];
            if (position === "higher")
                $("#higherLevel").children().empty();
            else
                $("#lowerLevel").children().empty();
            var date = new Date(naviobj.startDateTime);
            var count = 0;
            var k = 0;
            var txtBlockWidth = 0;
			var culture = this.model.locale;
			var locale = ej.datavisualization.RangeNavigator.Locale[culture] ? ej.datavisualization.RangeNavigator.Locale[culture]:
                                                                               ej.datavisualization.RangeNavigator.Locale["en-US"];
            switch (level) {
                case 0:
                    txtBlockWidth = this._quarter(naviobj, position, this._localizedLabels.intervals.quarter.longQuarters, "yyyy", date, txtBlockWidth, count);
                    if (txtBlockWidth >= (naviobj.newWidth - this.padding))
                        naviobj.setQuarterInterval(naviobj, position, 1);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 1:
                    txtBlockWidth = this._quarter(naviobj, position, this._localizedLabels.intervals.quarter.longQuarters, "yy", date, txtBlockWidth, count);
                    if (txtBlockWidth >= (naviobj.newWidth - this.padding))
                        naviobj.setQuarterInterval(naviobj, position, 2);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 2:
                    txtBlockWidth = this._quarter(naviobj, position, this._localizedLabels.intervals.quarter.shortQuarters, "yyyy", date, txtBlockWidth, count);
                    if (txtBlockWidth >= (naviobj.newWidth - this.padding))
                        naviobj.setQuarterInterval(naviobj, position, 3);
                    else
                        this.insertLabels(naviobj, position);
                    break;
                case 3:
                    txtBlockWidth = this._quarter(naviobj, position, this._localizedLabels.intervals.quarter.shortQuarters, null, date, txtBlockWidth, count);
                    this.insertLabels(naviobj, position);
                    break;
                default:
                    break;
            }
        },

        _insertText: function (naviobj, position, txtValue, currentDate, count, bwidth, setsubstring) {
            var locale = naviobj.model.locale;
            Date.prototype.addYears = function (years) {
                var dat = new Date(this.valueOf())
                if (dat.getMilliseconds() !== 0 || dat.getSeconds() !== 0
                 || dat.getMinutes() !== 0 || dat.getHours() !== 0 || dat.getDate() !== 0
                 || dat.getMonth() !== 0) {
                    dat = new Date(dat.getFullYear() + 1, 0, 1);
                }
                else
                    dat.setYear(dat.getFullYear() + years);
                return dat;
            }

            Date.prototype.addMonths = function () {
                var dat = new Date(this.valueOf())
                dat = new Date(dat.getFullYear(), dat.getMonth() + 1, 1);
                return dat;
            }

            if (position === "higher") {
                naviobj._higherTotalValues[count] = currentDate.getTime() - naviobj.startDateTime.getTime();
                var textOptions = {
                    'id': this._rootId + '_higLabelBarText' + '_' + count,
                    'x': 0,
                    'y': 0,
                    'text-anchor': 'start',
                    'dominant-baseline': 'middle',
                    "font-size": naviobj.model.labelSettings.higherLevel.style.font.size,
                    "font-family": naviobj.model.labelSettings.higherLevel.style.font.fontFamily,
                    "font-style": naviobj.model.labelSettings.higherLevel.style.font.fontStyle,
                    "font-weight": naviobj.model.labelSettings.higherLevel.style.font.fontWeight,
                    "fill":naviobj.model.labelSettings.higherLevel.style.font.color
                };
                if(setsubstring==false)
                    naviobj.renderer.drawText(textOptions, ej.format(currentDate, txtValue, locale), naviobj.higherLevel);
                else
                    naviobj.renderer.drawText(textOptions, ej.format(currentDate, txtValue, locale).toString().substring(0, 1), naviobj.higherLevel);
                naviobj._higherTextNode[count] = naviobj.higherLevel.childNodes[count];
                var labelfont = { size: naviobj.model.labelSettings.higherLevel.style.font.size, fontStyle: naviobj.model.labelSettings.higherLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.higherLevel.style.font.fontFamily };
                if(this.svgSupport)
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].textContent, null, labelfont);
                else
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].innerHTML, null, labelfont);
                bwidth = Math.max(bwidth, textOffset.width);
            }
            else {
                naviobj._lowerTotalValues[count] = currentDate.getTime() - naviobj.startDateTime.getTime();
                var textOptions = {
                    'id': this._rootId + '_LabelBarText' + '_' + count,
                    'x': 0,
                    'y': 0,
                    'text-anchor': 'start',
                    'dominant-baseline': 'middle',
                    "font-size": naviobj.model.labelSettings.lowerLevel.style.font.size,
                    "font-family": naviobj.model.labelSettings.lowerLevel.style.font.fontFamily,
                    "font-style": naviobj.model.labelSettings.lowerLevel.style.font.fontStyle,
                    "font-weight": naviobj.model.labelSettings.lowerLevel.style.font.fontWeight,
                    "fill":naviobj.model.labelSettings.lowerLevel.style.font.color
                };
                if(setsubstring==false)
                    naviobj.renderer.drawText(textOptions, ej.format(currentDate, txtValue, locale), naviobj.lowerLevel);
                else
                    naviobj.renderer.drawText(textOptions, ej.format(currentDate, txtValue, locale).substring(0, 1), naviobj.lowerLevel);
                naviobj._lowerTextNode[count] = naviobj.lowerLevel.childNodes[count];
                var labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
                if(this.svgSupport)
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont);
                else
                    var textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].innerHTML, null, labelfont);
                bwidth = Math.max(bwidth, textOffset.width);
            }
            return bwidth;
        },

        _insertNumericText: function (naviobj,currentValue) {
            naviobj._lowerTotalValues[count] = currentValue - naviobj.startValue;
            var font = naviobj.model.labelSettings.style.font;
            var textOptions = {
                'id': this._rootId + '_LabelBarText' + '_' + count,
                'x': 0,
                'y': 0,
                'text-anchor': 'start',
                'dominant-baseline': 'middle',
                "font-size": font.size,
                "font-family": font.family,
                "font-style": font.style,
                "font-weight": font.weight,
                "fill": font.color
            };
                naviobj.renderer.drawText(textOptions, currentValue, naviobj.lowerLevel);
            naviobj._lowerTextNode[count] = naviobj.lowerLevel.childNodes[count];
            var labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
            var textOffset;
            if(this.svgSupport) {
                textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont);
            } else {
                textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].innerHTML, null, labelfont);
            } 
        },

        setYearInterval: function (naviobj, position) {
            var currentDate = naviobj.startDateTime;
            count=0;
            while (currentDate <= naviobj.endDateTime) {
                this._insertText(naviobj, position, "yyyy", currentDate,count,0,false);                   
                count++;
                currentDate = currentDate.addYears(1);
            }            
            this.insertLabels(naviobj, position);
        },

        _applyPadding:function(){
            var i;
            for (i = 0; i < this._higherTotalValues.length; i++) {
                this._higherTotalValues[i] += this.padding;
            }
            for (i = 0; i < this._lowerTotalValues.length; i++) {
                this._lowerTotalValues[i] += this.padding;
            }
        },

        insertLabels: function (naviobj, level) {
            // this._applyPadding();
            var matched = jQuery.uaMatch(navigator.userAgent);
            var lowgridColor = this.model.labelSettings.lowerLevel.gridLineStyle.color;
            this.lgClr = this.renderer.createGradientElement('lgColor', lowgridColor, 150, 0, 150, 100, this.svgDocument);
            var type = this.model.valueType;
            var wholeSize = parseFloat(this.renderer._getAttrVal($(naviobj.svgDocument), 'width'));
            if (type == "datetime")
                this.eachInterval = (wholeSize - this.padding * 2) / parseFloat(this.endDateTime.getTime() - this.startDateTime.getTime());
            else
                this.eachInterval = (wholeSize - this.padding * 2) / parseFloat(this.endValue - this.startValue);
            var count = 0, labelcount = 0, txtwidth = 0, rectoptions, lineleft, newleft,
                textOffset, labelfont, i, highLength = naviobj._higherTextNode.length;
                lowerLevelLabels = [],
            higherLevelLabels = [];
                var offset = 0;
            if (level === "higher" && naviobj.model.labelSettings.higherLevel.visible===true) {

                if (naviobj.model.labelSettings.higherLevel.position == "top" && naviobj.model.labelSettings.lowerLevel.position == "top") {
                    rectoptions = {
                        x: this.padding,
                        y: 1,
                        width: naviobj.newWidth > 0 ? (naviobj.newWidth - naviobj.padding * 2) : 0,
                        height: naviobj.minHighHeight,
                        'stroke': naviobj.model.labelSettings.higherLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.higherLevel.border.width,
                        fill: 'transparent'

                    };
                    naviobj.renderer.drawRect(rectoptions, naviobj.higherLevel);
                }
                else if (naviobj.model.labelSettings.higherLevel.position == "top") {
                    rectoptions = {
                        x: this.padding,
                        y: 1,
                        width: naviobj.newWidth - naviobj.padding * 2,
                        height: naviobj.minHighHeight,
                        'stroke': naviobj.model.labelSettings.higherLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.higherLevel.border.width,
                        fill: 'transparent'

                    };
                    naviobj.renderer.drawRect(rectoptions, naviobj.higherLevel);
                }
                else {
                    rectoptions = {
                        x: this.padding,
                        y: naviobj.bottomPosition,
                        width: naviobj.newWidth > 0 ? (naviobj.newWidth - naviobj.padding * 2) : 0,
                        height: naviobj.minHighHeight,
                        'stroke': naviobj.model.labelSettings.higherLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.higherLevel.border.width,
                        fill: 'transparent'

                    };
                    naviobj.renderer.drawRect(rectoptions, naviobj.higherLevel);
                }

                naviobj._higherLineLeft = [];

                if (!naviobj.model.enableRTL) {
                    lineleft = (naviobj._higherTotalValues[count] * this.eachInterval) + this.padding;
                } else {
                    lineleft = naviobj.newWidth - ((naviobj._higherTotalValues[naviobj._higherTextNode.length - 1] * this.eachInterval) + this.padding);
                }
                var isrtl;
                if (naviobj.model.enableRTL) {
                    i = naviobj._higherTextNode.length - 1;
                    isrtl = true;
                }
                else {
                    i = 0;
                    isrtl = false;
                }
                var setLeft = 0;

                for (; isrtl ? i >= 0 : i < naviobj._higherTextNode.length; isrtl?i--:i++) {
                    naviobj._higherLineLeft[i] = lineleft;
                    //  var txt =  naviobj._higherTextNode[i].getBBox();
                    labelfont = { size: naviobj.model.labelSettings.higherLevel.style.font.size, fontStyle: naviobj.model.labelSettings.higherLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.higherLevel.style.font.fontFamily };
                    textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[count].textContent, null, labelfont);
                    txtwidth = textOffset.width;
                    newleft = naviobj._higherTotalValues[i + 1] === undefined
                        ? isrtl ? 0 : naviobj.newWidth :
                        isrtl?naviobj.newWidth-((naviobj._higherTotalValues[i + 1] * this.eachInterval + this.padding)):
                        (naviobj._higherTotalValues[i + 1] * this.eachInterval + this.padding);
                    if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "middle") {
                        setleft = isrtl ? newleft - (newleft - lineleft) / 2 - txtwidth / 2: (newleft - lineleft) / 2 + lineleft - txtwidth / 2;
                    }
                    else if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "left") {
                        setleft = isrtl ? newleft + 10 : lineleft + 10;
                    }
                    else
                        setleft = isrtl ? lineleft - txtwidth - 2 : newleft - txtwidth - 2;
                    if (this.model.enableScrollbar) {
                        //rmove overlapped labels on higherlevel text
                        if ((!isrtl && i == 0) || (isrtl && highLength == i))
                            this.firstLabelPosition = setleft + txtwidth;
                        if (((!isrtl && i == 1) || (isrtl && highLength - 1 == i)) && this.firstLabelPosition > lineleft)
                            naviobj._higherTextNode[isrtl ? i + 1 : i - 1].textContent = "";
                    }
                    naviobj.renderer._setAttr($(naviobj._higherTextNode[i]), { 'x': setleft });
                    naviobj.renderer._setAttr($(naviobj._higherTextNode[i]), { 'fill': naviobj.model.labelSettings.higherLevel.style.font.color });
                    naviobj._higherTextLeft[i] = setleft;
                    
                    if (naviobj.model.labelSettings.higherLevel.position == "top" && naviobj.model.labelSettings.lowerLevel.position == "top") {
                        naviobj._higherTextNode[i].setAttribute("y", naviobj.minHighHeight - 5);
                        rectoptions = {
                            x1: lineleft,
                            y1: '0',
                            x2: lineleft,
                            y2: naviobj.centerPosition,
                            'stroke': naviobj.model.labelSettings.higherLevel.gridLineStyle.color,
                            'stroke-width': naviobj.model.labelSettings.higherLevel.gridLineStyle.width,
                            'stroke-dasharray': naviobj.model.labelSettings.higherLevel.gridLineStyle.dashArray,

                        };
                        if (i != 0)
                        naviobj.renderer.drawLine(rectoptions, naviobj.higherLevel);
                    }
                    else if (naviobj.model.labelSettings.higherLevel.position == "top") {
                        if (this.svgSupport) {
                            if(matched.browser.toLowerCase() == "msie")
                                naviobj._higherTextNode[i].setAttribute("y", naviobj.centerPosition - 5);
                            else
                                naviobj._higherTextNode[i].setAttribute("y", naviobj.centerPosition - 9);
                        }
                        else
                            naviobj.renderer._setAttr($(naviobj._higherTextNode[i]), { 'y': (naviobj.centerPosition / 2) - 5 });
                        rectoptions = {
                            x1: lineleft,
                            y1: '0',
                            x2: lineleft,
                            y2: naviobj.centerPosition,
                            'stroke': naviobj.model.labelSettings.higherLevel.gridLineStyle.color,
                            'stroke-width': naviobj.model.labelSettings.higherLevel.gridLineStyle.width,
                            'stroke-dasharray':naviobj.model.labelSettings.higherLevel.gridLineStyle.dashArray,

                        };
                        if (i != 0)
                        naviobj.renderer.drawLine(rectoptions, naviobj.higherLevel);
                    }
                    else {
                        naviobj._higherTextNode[i].setAttribute("y", naviobj.newHeight - 5);
                        rectoptions = {
                            x1: lineleft,
                            y1: this.bottomPosition,
                            x2: lineleft,
                            y2: naviobj.newHeight,
                            'stroke': naviobj.model.labelSettings.higherLevel.gridLineStyle.color,
                            'stroke-width': naviobj.model.labelSettings.higherLevel.gridLineStyle.width,
                            'stroke-dasharray': naviobj.model.labelSettings.higherLevel.gridLineStyle.dashArray,

                        };
                        if (i != 0)
                        naviobj.renderer.drawLine(rectoptions, naviobj.higherLevel);
                    }
                    if ((setleft < this.padding || naviobj.newWidth - lineleft - this.padding < txtwidth) && type == "datetime") {
                        if (isrtl) {
                            if (setleft < this.padding && lineleft - this.padding > txtwidth) {
                                if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "middle")
                                    naviobj._higherTextNode[i].setAttribute("x", this.padding + (lineleft - this.padding) / 2 - txtwidth / 2);
                                else if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "left")
                                    naviobj._higherTextNode[i].setAttribute("x", this.padding + 10);
                                else
                                    naviobj._higherTextNode[i].setAttribute("x", lineleft - txtwidth - 2);
                            }
                            else if (naviobj.newWidth - lineleft < txtwidth && naviobj.newWidth - newleft - this.padding > txtwidth) {
                                if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "middle")
                                    naviobj._higherTextNode[i].setAttribute("x", newleft + (naviobj.newWidth - newleft - this.padding) / 2 - txtwidth / 2);
                                else if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "left")
                                    naviobj._higherTextNode[i].setAttribute("x", newleft + 10);
                                else
                                    naviobj._higherTextNode[i].setAttribute("x", naviobj.newWidth - txtwidth - 2 - this.padding);
                            }
                            else
                                naviobj.higherLevel.removeChild(naviobj._higherTextNode[i]);
                        }
                        else {
                            naviobj.higherLevel.removeChild(naviobj._higherTextNode[i]);
                            continue;
                        }
                    }
                    else if (setleft + txtwidth > naviobj.newWidth - this.padding && type == "datetime") {
                        if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "middle")
                            setleft = lineleft + (naviobj.newWidth - lineleft - this.padding) / 2 - txtwidth / 2;
                        else if (naviobj.model.labelSettings.higherLevel.style.horizontalAlignment === "left")
                            setleft = lineleft;
                        else
                            setleft = naviobj.newWidth - txtwidth * 3/2;
                        naviobj._higherTextNode[i].setAttribute("x", setleft);
                        continue;
                    }
                    if (!this.model.enableRTL) {
                        lineleft = naviobj._higherTotalValues[i + 1] * this.eachInterval + this.padding;
                    } else {
                        lineleft= naviobj.newWidth - (naviobj._higherTotalValues[i -1] * this.eachInterval + this.padding);
                    }
                    count++;
                }
               
                //Calculate hihger level label regions
               for (var k = 0, len=naviobj._higherLineLeft.length; k < len; k++) {
                   textOffset = ej.EjSvgRender.utils._measureText(naviobj.higherLevel.childNodes[k].textContent, null, labelfont);
                   if (this.svgSupport)
                       higherLevelLabels.push({ size: textOffset, x: naviobj._higherLineLeft[k], y: naviobj._higherTextNode[k].getAttribute("y") - textOffset.height / 2 + offset, lableType: "higherLevel" });
                   else
                       higherLevelLabels.push({ size: textOffset, x: naviobj._higherLineLeft[k], y: naviobj._higherTextNode[k].offsetTop - textOffset.height / 2 + offset, lableType: "higherLevel" });

               }
               this._addLabelsRegion(naviobj, higherLevelLabels);
                 
            }
            else if (naviobj.model.labelSettings.lowerLevel.visible === true) {

                naviobj._lowerLineLeft = [];
                if (!naviobj.model.enableRTL) {
                    lineleft = (naviobj._lowerTotalValues[count] * this.eachInterval) + this.padding;
                } else {
                    lineleft = naviobj.newWidth - ((naviobj._lowerTotalValues[naviobj._lowerTextNode.length - 1] * this.eachInterval) + this.padding);
                }
                var hy = naviobj.model.labelSettings.higherLevel.visible ? naviobj.bottomPosition : naviobj.centerHeight;

                if (naviobj.model.labelSettings.lowerLevel.position === "bottom" && naviobj.model.labelSettings.higherLevel.position === "top") {
                    rectoptions = {
                        x: this.padding,
                        y: hy,
                        width: this.newWidth - naviobj.padding * 2,
                        height: naviobj.minLowHeight - 1,
                        'stroke': naviobj.model.labelSettings.lowerLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.lowerLevel.border.width,
                        fill: 'transparent'
                    };
                    if (type != "numeric")
                        naviobj.renderer.drawRect(rectoptions, naviobj.lowerLevel);
                }
                else if (naviobj.model.labelSettings.lowerLevel.position === "bottom" && naviobj.model.labelSettings.higherLevel.position === "bottom") {
                    rectoptions = {
                        x: this.padding,
                        y: naviobj.centerHeight,
                        width: this.newWidth > 0 ? (this.newWidth - naviobj.padding * 2) : 0,
                        height: naviobj.minLowHeight - 1,
                        'stroke': naviobj.model.labelSettings.lowerLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.lowerLevel.border.width,
                        fill: 'transparent'
                    };
                    naviobj.renderer.drawRect(rectoptions, naviobj.lowerLevel);
                }
                else if (naviobj.model.labelSettings.lowerLevel.position === "top" && naviobj.model.labelSettings.higherLevel.position === "bottom") {
                    rectoptions = {
                        x: this.padding,
                        y: 0,
                        width: this.newWidth > 0 ? (this.newWidth - naviobj.padding * 2) : 0,
                        height: naviobj.minLowHeight - 1,
                        'stroke': naviobj.model.labelSettings.lowerLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.lowerLevel.border.width,
                        fill: 'transparent'
                    };
                    naviobj.renderer.drawRect(rectoptions, naviobj.lowerLevel);
                }
                else if (naviobj.model.labelSettings.higherLevel.position === "top" && naviobj.model.labelSettings.lowerLevel.position === "top") {
                    rectoptions = {
                        x: this.padding,
                        y: naviobj.minHighHeight - 1,
                        width: this.newWidth > 0 ? (this.newWidth - naviobj.padding * 2) : 0,
                        height: naviobj.minLowHeight,
                        'stroke': naviobj.model.labelSettings.lowerLevel.border.color,
                        'stroke-width': naviobj.model.labelSettings.lowerLevel.border.width,
                        fill: 'transparent'
                    };
                    naviobj.renderer.drawRect(rectoptions, naviobj.lowerLevel);
                }

                if (naviobj.model.enableRTL) {
                    i = naviobj._lowerTextNode.length - 1;
                    isrtl = true;
                }
                else {
                    i = 0;
                    isrtl = false;
                }


                for (; isrtl ? i >= 0 : i < naviobj._lowerTextNode.length; isrtl?i--:i++) {
                    naviobj._lowerLineLeft[i] = lineleft;
                    labelfont = { size: naviobj.model.labelSettings.lowerLevel.style.font.size, fontStyle: naviobj.model.labelSettings.lowerLevel.style.font.fontStyle, fontFamily: naviobj.model.labelSettings.lowerLevel.style.font.fontFamily };
                    textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[count].textContent, null, labelfont); // var txt = naviobj._lowerTextNode[i].getBBox();
                    txtwidth = textOffset.width;// txt.width;
                    var setleft = 0;
                    newleft = naviobj._lowerTotalValues[i + 1] === undefined
                        ? isrtl ? 0 : naviobj.newWidth :
                        isrtl ? naviobj.newWidth - ((naviobj._lowerTotalValues[i + 1] * this.eachInterval + this.padding)) :
                        (naviobj._lowerTotalValues[i + 1] * this.eachInterval + this.padding);
                    if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "middle") {
                        setleft = isrtl ? (lineleft - newleft) / 2 + newleft - txtwidth / 2 : (newleft - lineleft) / 2 + lineleft - txtwidth / 2;
                    }
                    else if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "left") {
                        setleft = isrtl? newleft + 2 : lineleft + 2;
                    }
                    else
                        setleft = isrtl ? lineleft - txtwidth - 2 : newleft - txtwidth - 2;
                    if (type == "numeric")
                        setleft = lineleft - txtwidth / 2;
                    naviobj.renderer._setAttr($(naviobj._lowerTextNode[i]), { 'x': setleft });
                    naviobj.renderer._setAttr($(naviobj._lowerTextNode[i]), { 'fill': naviobj.model.labelSettings.lowerLevel.style.font.color });

                    naviobj._lowerTextLeft[i] = setleft;

                    if (naviobj.model.labelSettings.lowerLevel.position === "bottom" && naviobj.model.labelSettings.higherLevel.position === "top") {
                        if (!this.svgSupport)
                            naviobj.renderer._setAttr($(naviobj._lowerTextNode[i]), { 'y': naviobj.newHeight - textOffset.height });
                        else {
                            if (matched.browser.toLowerCase() == "msie")
                                naviobj._lowerTextNode[i].setAttribute("y", naviobj.newHeight - 5);
                            else
                                naviobj._lowerTextNode[i].setAttribute("y", naviobj.newHeight - 9);

                        }
                        var ht = naviobj.model.labelSettings.higherLevel.visible ? parseFloat(naviobj.minHighHeight + naviobj.centerHeight) : naviobj.minHighHeight;
                        rectoptions = {
                            x1: lineleft,
                            y1: ht,
                            x2: lineleft,
                            y2: naviobj.newHeight,
                            'stroke': this.lgClr,
                            'stroke-width': naviobj.model.labelSettings.lowerLevel.gridLineStyle.width,
                            'stroke-dasharray': naviobj.model.labelSettings.lowerLevel.gridLineStyle.dashArray,
                        };
                        if (i != 0 && type != "numeric")
                            naviobj.renderer.drawLine(rectoptions, naviobj.lowerLevel);
                    }
                    else if (naviobj.model.labelSettings.lowerLevel.position === "bottom" && naviobj.model.labelSettings.higherLevel.position === "bottom") {
                        naviobj._lowerTextNode[i].setAttribute("y", naviobj.bottomPosition - 5);
                        rectoptions = {
                            x1: lineleft,
                            y1: naviobj.centerHeight,
                            x2: lineleft,
                            y2: naviobj.bottomPosition,
                            'stroke': naviobj.model.labelSettings.lowerLevel.gridLineStyle.color,
                            'stroke-width': naviobj.model.labelSettings.lowerLevel.gridLineStyle.width,
                            'stroke-dasharray':naviobj.model.labelSettings.lowerLevel.gridLineStyle.dashArray,
                        };
                        if (i != 0)
                            naviobj.renderer.drawLine(rectoptions, naviobj.lowerLevel);
                    }
                    else if (naviobj.model.labelSettings.lowerLevel.position === "top" && naviobj.model.labelSettings.higherLevel.position === "bottom") {
                        naviobj._lowerTextNode[i].setAttribute("y", naviobj.centerPosition - 5);
                        rectoptions = {
                            x1: lineleft,
                            y1: 0,
                            x2: lineleft,
                            y2: naviobj.centerPosition,
                            'stroke': naviobj.model.labelSettings.lowerLevel.gridLineStyle.color,
                            'stroke-width': naviobj.model.labelSettings.lowerLevel.gridLineStyle.width,
                            'stroke-dasharray': naviobj.model.labelSettings.lowerLevel.gridLineStyle.dashArray,
                        };
                        if (i != 0)
                            naviobj.renderer.drawLine(rectoptions, naviobj.lowerLevel);
                    }
                    else if (naviobj.model.labelSettings.higherLevel.position === "top" && naviobj.model.labelSettings.lowerLevel.position === "top") {
                        naviobj._lowerTextNode[i].setAttribute("y", naviobj.centerPosition - 5);
                        rectoptions = {
                            x1: lineleft,
                            y1: naviobj.minHighHeight,
                            x2: lineleft,
                            y2: naviobj.centerPosition,
                            'stroke': naviobj.model.labelSettings.lowerLevel.gridLineStyle.color,
                            'stroke-width': naviobj.model.labelSettings.lowerLevel.gridLineStyle.width,
                            'stroke-dasharray': naviobj.model.labelSettings.lowerLevel.gridLineStyle.dashArray,
                        };
                        if (i != 0)
                            naviobj.renderer.drawLine(rectoptions, naviobj.lowerLevel);
                    }
                    if ((setleft < this.padding || naviobj.newWidth - lineleft - this.padding < txtwidth) && type == "datetime") {
                        if (isrtl) {
                            if (setleft < this.padding && lineleft - this.padding > txtwidth) {
                                if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "middle")
                                    naviobj._lowerTextNode[i].setAttribute("x", this.padding + (lineleft - this.padding) / 2 - txtwidth / 2);
                                else if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "left")
                                    naviobj._lowerTextNode[i].setAttribute("x", this.padding + 10);
                                else
                                    naviobj._lowerTextNode[i].setAttribute("x", lineleft - txtwidth - 2);
                            }
                            else if (naviobj.newWidth - lineleft < txtwidth && naviobj.newWidth -this.padding - newleft > txtwidth) {
                                if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "middle")
                                    naviobj._lowerTextNode[i].setAttribute("x", newleft + (naviobj.newWidth - newleft - this.padding) / 2 - txtwidth / 2);
                                else if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "left")
                                    naviobj._lowerTextNode[i].setAttribute("x", newleft + 10);
                                else
                                    naviobj._lowerTextNode[i].setAttribute("x", naviobj.newWidth - txtwidth - 2 - this.padding);
                            }
                            else
                                naviobj.lowerLevel.removeChild(naviobj._lowerTextNode[i]);
                            count--;
                        }
                        else {
                            naviobj.lowerLevel.removeChild(naviobj._lowerTextNode[i]);
                            count--;
                        }
                    }
                    else if (setleft + txtwidth > naviobj.newWidth - this.padding && type == "datetime") {
                        if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "middle")
                            setleft = lineleft + (naviobj.newWidth - lineleft - this.padding) / 2 - txtwidth / 2;
                        else if (naviobj.model.labelSettings.lowerLevel.style.horizontalAlignment === "left")
                            setleft = lineleft;
                        else
                            setleft = naviobj.newWidth - txtwidth * 3 / 2;
                        naviobj._lowerTextNode[i].setAttribute("x", setleft);                        
                    }
                    if (!this.model.enableRTL)
                        lineleft = naviobj._lowerTotalValues[i + 1] * this.eachInterval + this.padding;
                    else
                        lineleft = naviobj.newWidth - (naviobj._lowerTotalValues[i - 1] * this.eachInterval + this.padding);
                    count++;
                }
                
                //Calculate lower lavel label regions
                for (var k = 0, len=naviobj._lowerLineLeft.length;  k < len; k++) {
                    textOffset = ej.EjSvgRender.utils._measureText(naviobj.lowerLevel.childNodes[k].textContent, null, labelfont);
                    if (this.svgSupport)
                        lowerLevelLabels.push({ size: textOffset, x: naviobj._lowerLineLeft[k], y: naviobj._lowerTextNode[k].getAttribute("y") - textOffset.height / 2 + offset, lableType: "lowerLevel" });
                    else
                        lowerLevelLabels.push({ size: textOffset, x: naviobj._lowerLineLeft[k], y: naviobj._lowerTextNode[k].offsetTop + offset, lableType: "lowerLevel" });
                }
                this._addLabelsRegion(naviobj, lowerLevelLabels);
                
            }
            if (!naviobj.model.enableRTL) {
                naviobj._lowerLineLeft.push(this.newWidth - this.padding);
            } else {
                naviobj._lowerLineLeft.push(this.padding);
            }            
            naviobj._setGridlines(naviobj);
            $(this.higherLevel).css('cursor', 'pointer');
            $(this.lowerLevel).css('cursor', 'pointer');
            //this.higherLevel.setAttributeNS(null, 'transform', 'translate(' + 20 + ',' + 0 + ')');
            //this.lowerLevel.setAttributeNS(null, 'transform', 'translate(' + 20 + ',' + 0 + ')');

        },

        //Add higher level and lowe level labels regions
        _addLabelsRegion: function (naviObj,labels) {
            var width, height,startX, len = labels.length;
            if (len == 1)
            naviObj.labelRegions.push({ X: labels[0].x, Y: labels[0].y, Height: labels[0].size.height, Width: naviObj.newWidth-labels[0].x, LabelType: labels[0].lableType });
            else {
                for (var k = 0; k < len; k++) {
                    if (!naviObj.model.enableRTL) {
                        width = labels[k + 1] ? labels[k + 1].x - labels[k].x : naviObj.newWidth - labels[k].x - parseInt(naviObj.model.padding);
                        startX = labels[k].x;
                    }                                                
                    else {                        
                        width = labels[k + 1] ? labels[k].x - labels[k + 1].x : labels[k].x - parseInt(naviObj.model.padding);
                            startX = labels[k + 1] ? labels[k + 1].x : parseInt(naviObj.model.padding);
                    }                       
                    height = labels[k + 1] ? labels[k].size.height : labels[k - 1].size.height;
                    naviObj.labelRegions.push({ X: startX, Y: labels[k].y, Height: height, Width: width, LabelType: labels[k].lableType });
                }
            }
        },
        _setGridlines: function (naviobj) {

            if (naviobj.model.navigatorStyleSettings.minorGridLineStyle.visible === true) {

                for (var i = 1; i < naviobj._lowerTextNode.length; i++) {
                    if (naviobj.model.labelSettings.higherLevel.position == "top" && naviobj.model.labelSettings.lowerLevel.position == "top") {
                        var rectoptions = {
                            x1: naviobj._lowerLineLeft[i],
                            y1: naviobj.centerHeight + naviobj.minLowHeight+naviobj.minHighHeight,
                            x2: naviobj._lowerLineLeft[i],
                            y2: naviobj.centerPosition,
                            'stroke': naviobj.model.navigatorStyleSettings.minorGridLineStyle.color,
                            'stroke-width': '1'
                        };
                        naviobj.renderer.drawLine(rectoptions, naviobj.centerLevel);
                    }
                    else {
                        var rectoptions = {
                            x1: naviobj._lowerLineLeft[i],
                            y1: naviobj.centerPosition,
                            x2: naviobj._lowerLineLeft[i],
                            y2: naviobj.centerPosition+naviobj.centerHeight,
                            'stroke': naviobj.model.navigatorStyleSettings.minorGridLineStyle.color,
                            'stroke-width': '1'
                        };
                        naviobj.renderer.drawLine(rectoptions, naviobj.centerLevel);
                    }
                    
                }
            }
            else {
                for (var i = 0; i < naviobj._higherTextNode.length; i++) {
                    // var lineLeft = naviobj._lowerLineLeft[i];
                    var rectoptions = {
                        x1: naviobj._higherLineLeft[i],
                        y1: naviobj.centerHeight + naviobj.minLowHeight,
                        x2: naviobj._higherLineLeft[i],
                        y2: naviobj.centerPosition,
                        'stroke': naviobj.model.navigatorStyleSettings.majorGridLineStyle.color,
                        'stroke-width': '1'
                    };
                    naviobj.renderer.drawLine(rectoptions, naviobj.centerLevel);
                }
            }

        },

        bindTo: function () {
            if (!ej.util.isNullOrUndefined(this.model.dataSource)) {
                if (this.model.dataSource != null && this.model.dataSource.length > 0) {

                    this._processJsonData(this.model.dataSource, this.model);
                }
            }

        },

        _processJsonData: function (jsonObj, newmodel) {

            var xdata = [], yValues = [], index = 0;

            for (var j = 0; j < jsonObj.length; j++) {
                if (typeof jsonObj[j][newmodel.xName] == "string" && jsonObj[j][newmodel.xName].indexOf("/Date(") != -1)
                    jsonObj[j][newmodel.xName] = new Date(parseInt(jsonObj[j][newmodel.xName].substr(6)));
                if (jQuery.type(jsonObj[j][newmodel.xName]) != "string" && jQuery.type(jsonObj[j][newmodel.xName]) != "date")
                    xdata.push(parseFloat(!ej.util.isNullOrUndefined(jsonObj[j][newmodel.xName]) ? jsonObj[j][newmodel.xName] : j));
                else {
                    xdata.push(!ej.util.isNullOrUndefined(jsonObj[j][newmodel.xName]) ? jsonObj[j][newmodel.xName] : j);
                }
            }

            if (!ej.util.isNullOrUndefined(newmodel.yName)) {
                for (var k = 0; k < newmodel.yName.length; k++) {
                    var yNVal = [];
                    for (var yI = 0; yI < jsonObj.length; yI++) {
                        yNVal.push(jsonObj[yI][newmodel.yName[k]] === null || jsonObj[yI][newmodel.yName[k]] === undefined ? jsonObj[yI][newmodel.yName[k]] : parseFloat(jsonObj[yI][newmodel.yName[k]]));
                    }
                    yValues[k] = yNVal;
                    index = k + 1;
                }
            }

            var endDateTime = new Date(Math.max.apply(null, xdata)),
                startDateTime = new Date(Math.min.apply(null, xdata));
            if (endDateTime.getTime() == startDateTime.getTime()) {
                startDateTime.setHours(0);
                endDateTime.setHours(23);
            }
            var minX = startDateTime.getTime(), maxX = endDateTime.getTime(), scrollRangeSettings = this.model.scrollRangeSettings;
            
            if (this.model.enableScrollbar) {
                if ((!this._scrollRange && !this.scrollbarUpdate) || !this.scrollbarUpdate) {
                    var args = [minX, maxX, startDateTime, endDateTime]
                    this.calculateZoomingRange.apply(this, args);
                } else {
                    this._scrollRange = {
                        min: Math.min(this._scrollRange.min, minX),
                        max: Math.max(this._scrollRange.max, maxX),
                        delta: maxX - minX
                    };
                }
               
            } else
                this.setRange.call(this, minX, maxX, startDateTime, endDateTime);
        },        

        calculateZoomingRange: function (minX, maxX, startDateTime, endDateTime) {
            this.calculateZoomFactorPosition.call(this, minX, maxX, startDateTime, endDateTime);
            this.setRange.call(this, minX, maxX, startDateTime, endDateTime);
            return 0;
        },

        setRange: function (start, end, startDate, endDate) {
            var rangeSettings = this.model.rangeSettings;
            if (rangeSettings.start != "" && rangeSettings.end != "") {
                this.startDateTime = new Date(rangeSettings.start);
                this.endDateTime = new Date(rangeSettings.end);
                this.startValue = rangeSettings.start;
                this.endValue = rangeSettings.end;
            } else {
                this.startDateTime = new Date(startDate);
                this.startValue = start;
                this.endDateTime = new Date(endDate);
                this.endValue = end;
            }
            return 0;
        },

        calculateZoomFactorPosition: function (startX, endX, startDateTime, endDateTime) {
            var model = this.model,
                rangeSettings = model.rangeSettings;
            var delta, zoomPos, zoomFact, start = startDateTime, end = endDateTime,
                min = startX, max = endX;
            var scrollRangeSettings = model.scrollRangeSettings;
            if (model.valueType.toLowerCase() == "datetime") {
                //VirtualRange start value is not given, it takes dataSource start value
                start = Date.parse(scrollRangeSettings.start ? new Date(scrollRangeSettings.start) : startDateTime);
                //If the given virtual range start value is greater than datasource value, it takes the minimum vallue from datasource
                start = Math.min(start, Date.parse(startDateTime));
                start = rangeSettings.start != "" ? Math.min(start,Date.parse(new Date(rangeSettings.start))) : start;
                //VirtualRange end value is not given, it takes dataSource end value
                end = Date.parse(scrollRangeSettings.end ? new Date(scrollRangeSettings.end) : endDateTime);
                //If the given virtual range end value is less than datasource value, it takes the maximum vallue from datasource
                end = Math.max(end, Date.parse(endDateTime));
                end = rangeSettings.end != "" ? Math.max(end, Date.parse(new Date(rangeSettings.end))) : end;
                delta = end - start;
                if (!model.enableRTL) {
                    zoomPos = (startDateTime - start) / delta;
                    zoomFact = (endDateTime - startDateTime) / delta;
                } else {
                    zoomPos = (end - endDateTime) / delta;
                    zoomFact = (endDateTime - startDateTime) / delta;
                }
                this._scrollRange = { min: start, max: end, delta: end - start };
            } else {
                //VirtualRange Start value is not given, it takes dataSource start value
                min = scrollRangeSettings.start != "" ? parseFloat(scrollRangeSettings.start) : startX;
                //If the given virtual range start value is greater than datasource value, it takes the minimum vallue from datasource
                min = Math.min(min, startX);
                min = rangeSettings.start != "" ? Math.min(min, parseFloat(rangeSettings.start)) : min;
                //VirtualRange end value is not given, it takes dataSource end value
                max = scrollRangeSettings.end != "" ? parseFloat(scrollRangeSettings.end) : endX;
                //If the given virtual range end value is less than datasource value, it takes the maximum vallue from datasource
                max = Math.max(max, endX);
                max = rangeSettings.end != "" ? Math.max(max, parseFloat(rangeSettings.end)) : max;
                delta = max - min;
                if (!model.enableRTL) {
                    zoomPos = (startX - min) / delta;
                    zoomFact = (endX - startX) / delta;
                } else {
                    zoomPos = (max - endX) / delta;
                    zoomFact = (endX - startX) / delta;
                }
                this._scrollRange = { min: min, max: max, delta: max - min };
            }
            this.scrollZoomPos = zoomPos;
            this.scrollZoomFact = zoomFact;

            return 0;
        },
        mousePosition: function (evt) {
            if (!ej.util.isNullOrUndefined(evt.pageX) && evt.pageX > 0)
                return { x: evt.pageX, y: evt.pageY };
            else if (evt.originalEvent && !ej.util.isNullOrUndefined(evt.originalEvent.pageX) && evt.originalEvent.pageX > 0)
                return { x: evt.originalEvent.pageX, y: evt.originalEvent.pageY };
            else if (evt.originalEvent && evt.originalEvent.changedTouches != undefined) {
                if (!ej.util.isNullOrUndefined(evt.originalEvent.changedTouches[0].pageX) && evt.originalEvent.changedTouches[0].pageX > 0)
                    return { x: evt.originalEvent.changedTouches[0].pageX, y: evt.originalEvent.changedTouches[0].pageY };
            }
            else
                return { x: 0, y: 0 };
        },
        calTouchPosition: function (e) {
            var matched = jQuery.uaMatch(navigator.userAgent);
            var mouseposition = this.mousePosition(e);
            e.pageX = mouseposition.x;
            e.pageY = mouseposition.y;
            var mouseX, mouseY;
            var browser = matched.browser.toLowerCase();
            mouseX = (e.pageX) - $(this.svgDocument).offset().left;
            mouseY = (e.pageY) - $(this.svgDocument).offset().top;
			this.leftPadding = $(this.svgDocument).offset().left;


            return { X: mouseX, Y: mouseY };

        },

        calMousePosition: function (e) {
            var matched = jQuery.uaMatch(navigator.userAgent);
            var mouseX, mouseY;
            if (matched.browser.toLowerCase() == "mozilla" || matched.browser.toLowerCase() == "webkit") {
                mouseX = (e.pageX) - $(this.svgDocument).parent().offset().left;
                mouseY = (e.pageY) - $(this.svgDocument).parent().offset().top;
                this.leftPadding = 0;//$(this.svgDocument).offset().left;
                this.grabPadding = 0;
            } else {
                mouseX = (e.originalEvent?e.originalEvent.pageX:e.pageX) - $(this.svgDocument).offset().left;
                mouseY = (e.originalEvent?e.originalEvent.pageY:e.pageY) - $(this.svgDocument).offset().top;
                this.leftPadding = $(this.svgDocument).offset().left;
            }

            return { X: mouseX, Y: mouseY };

        },

        _performSelection: function (evt){

            var naviobj = this,
                model = naviobj.model,
                selectionOptions = model.navigatorStyleSettings.selectionSettings,
                uncolor = selectionOptions.color,
                targetParentId = evt.target.parentNode.id,
                isUnhighlight = (targetParentId == "leftslider" || targetParentId == "rightslider" || targetParentId == naviobj._id + "thumbleft" || targetParentId == naviobj._id + "thumbright"),
                valueType = naviobj.model.valueType;

            naviobj._sliderHover = isUnhighlight || naviobj.switched;
            naviobj.selectionGrad = naviobj.renderer.createGradientElement('selectionGrad', uncolor, 150, 0, 150, 100, naviobj.svgDocument);
            naviobj.isNumericType = targetParentId != naviobj._id;
            if (((naviobj.isNumericType && valueType == 'numeric') || valueType != 'numeric') && (!isUnhighlight) && !naviobj.switched) {
                $("#highlightRect" + naviobj._id).hide();
                if ($("#selectionRect" + naviobj._id).length == 0) {
                    naviobj.gselection = naviobj.renderer.createGroup({ 'id': 'selectionRect' + naviobj._id });
                    var selectionRectOptions = {
                        'height': naviobj.sliderHeight,
                        'opacity': selectionOptions.opacity,
                        'stroke': selectionOptions.border.color,
                        'stroke-width': selectionOptions.border.width
                    };
                    naviobj.renderer.drawRect(selectionRectOptions, naviobj.gselection);
                    naviobj.selectionRect = naviobj.gselection.firstChild;
                    naviobj.renderer.append(naviobj.gselection, naviobj.styleRect);
                }
                naviobj.rect = naviobj.selectionRect;
                naviobj.startX = naviobj.mouseDownX;
                naviobj.renderer._setAttr($(naviobj.selectionRect), { 'fill': naviobj.selectionGrad });
                naviobj.renderer._setAttr($(naviobj.selectionRect), { 'stroke': selectionOptions.border.color });
                naviobj._highlight.call(naviobj, naviobj, evt);
            }

        },


        _performHighlight: function (evt) {

            var naviobj = this,
               model = naviobj.model,
               targetId = evt.target.parentNode.id,
               highlightOptions = model.navigatorStyleSettings.highlightSettings,
               uncolor = highlightOptions.color,
               isUnhighlight = (targetId == "leftslider" || targetId == "rightslider" || targetId == this._id + "thumbleft" || targetId == this._id + "thumbright");

            this.highlightGrad = this.renderer.createGradientElement('highlightGrad', uncolor, 150, 0, 150, 100, this.svgDocument);

            $("#highlightRect" + this._id).hide();
            if (!isUnhighlight && !this.isSelection && !this._sliderHover && !naviobj.switched) {
                if ($("#highlightRect" + this._id).length == 0) {
                    this.gHighlight = this.renderer.createGroup({ 'id': 'highlightRect' + this._id });
                    var highlightRectOptions = {
                        'height': this.sliderHeight,
                        'fill': this.highlightGrad,
                        'opacity': highlightOptions.opacity,
                        'stroke': highlightOptions.border.color,
                        'stroke-width': highlightOptions.border.width
                    };
                    this.renderer.drawRect(highlightRectOptions, this.gHighlight);
                    this.highlightRect = this.gHighlight.firstChild;
                    this.renderer.append(this.gHighlight, this.styleRect);
                }
                this.rect = this.highlightRect;
                naviobj.startX = naviobj.mouseDownX;
                this._highlight.call(this, naviobj, evt);
            }

        },

        isTouch: function (evt) {
            var event = evt.originalEvent ? evt.originalEvent : evt;
            if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        },

        _rightClick: function (evt){
            var browserInfo = this.model.browserInfo;
            if (this.isTouch(evt) && this.model.navigatorStyleSettings.selectionSettings.enable) {
                event.preventDefault();
                event.stopPropagation();
                return false;
            }
        },
        _grab: function (evt) {
            evt.preventDefault();
            var naviobj = this,
                model = naviobj.model,
                browserInfo = model.browserInfo,
                mousedownCords,
                istouch = this.isTouch(evt),
                selectionOptions = model.navigatorStyleSettings.selectionSettings,
                mousedownCords = istouch ? naviobj.calTouchPosition(evt) : naviobj.calMousePosition(evt);
            naviobj.mouseDownX = mousedownCords.X;
            naviobj.mouseDownY = mousedownCords.Y;
            if (selectionOptions.enable) this._performSelection(evt);
            // find out which element we moused down on
            
            var targetElement;
            if (naviobj.edge == true) {
                targetElement = naviobj.target;
            }
            else {
                targetElement = evt.target;
            }
            // used to find a thumb id
            var current = targetElement;
            var targetId;
            while (current.parentNode) {
				current = current.parentNode
				if (current.id == this._id + "thumbleft")
                {
                    targetId = this._id + "thumbleft";
                }
                else if (current.id == this._id + "thumbright")
                {
                    targetId = this._id + "thumbright";
                }
            }
            var isLower,
            isHigher,
            labelRegion,labelRegionX,labelRegionY,labelType,
            regionLength = naviobj.labelRegions.length,
            mouseX = naviobj.mouseDownX,
            mouseY = naviobj.mouseDownY;
            for (var k = 0; k < regionLength; k++) {
                labelRegion = naviobj.labelRegions[k];
                labelRegionX = labelRegion.X;
                labelRegionY = labelRegion.Y;
                labelType = labelRegion.LabelType;
                if ((labelRegionX <= mouseX && (labelRegionX + labelRegion.Width >= mouseX)) && (labelRegionY <= mouseY && ((labelRegionY + labelRegion.Height) >= mouseY))) {
                       isLower = labelType == "lowerLevel" ? true : false;
                       isHigher= labelType == "higherLevel" ? true : false;
                        break;
                    }                
            }

            var isDraggable = false;
            naviobj.isSelection = false;
            if (naviobj.highlightRect) {
                var highlightCord = naviobj.highlightRect.getBoundingClientRect();
                var centerCord = naviobj.centerSlider.getBoundingClientRect();
                if (highlightCord.left >= centerCord.left && highlightCord.right <= centerCord.right)
                    isDraggable = true;
            }
            
            if (selectionOptions.enable && naviobj.selectionRect && !(targetElement.parentNode.id === "leftslider" || targetElement.parentNode.id === "rightslider" || targetId == this._id + "thumbleft" || targetId == this._id + "thumbright")) {
                naviobj.isSelection = true;
                naviobj.startX = naviobj.mouseDownX;
            }
            if (istouch && !naviobj.switched) {
                var leftValue = this._leftValue,
                    rightValue = this._rightValue,
                    padding = 10,
                    leftThumb = $("#" + this._id + "thumbleft"),
                    rightThumb = $("#" + this._id + "thumbright");
                if (mouseX >= (leftValue.left - padding) && mouseX <= (leftValue.right + padding)) {
                    targetElement = this.leftCircle ? this.leftCircle : leftThumb[0].firstChild;
                    targetId = this.leftCircle ? targetId : this._id + "thumbleft";
                    this._sliderMove = true;
                }
                if (mouseX >= (rightValue.left - padding) && mouseX <= (rightValue.right + padding)) {
                    targetElement = this.rightCircle ? this.rightCircle : rightThumb[0].firstChild;
                    targetId = this.rightCircle ? targetId : this._id + "thumbright";
                    this._sliderMove = true;
                }

            }
            if ((targetElement.parentNode.id === "leftslider" || targetElement.parentNode.id === "rightslider" || targetId == this._id + "thumbleft" || targetId == this._id + "thumbright" || (targetElement.parentNode.id === "highlightRect" + this._id && isDraggable) || targetElement.parentNode.id === "centerslider") || (isLower || isHigher) || naviobj.isSelection) {
                //set the item moused down on as the element to be dragged
                if (targetElement.parentNode.id === "highlightRect" + this._id)
                    naviobj.dragTarget = $("#centerslider").children()[0];
                else
                    naviobj.dragTarget = targetElement;
                naviobj.grabbed = true;
                naviobj.edge = false;
                var dragParentId = naviobj.dragTarget.parentNode.id;
                if (this.svgSupport) {
                    if (targetId == this._id + "thumbleft" || targetId == this._id + "thumbright")
                        var transMatrix = {e:evt.clientX,f:evt.clientY};
                    else
                        var transMatrix = naviobj.dragTarget.getCTM();
                    naviobj.grabPoint.x = naviobj.mouseDownX + this.leftPadding - Number(transMatrix.e);
                    naviobj.grabPoint.y = naviobj.trueCoords.y - Number(transMatrix.f);
                }
                var txtPosition;
                var i;
                var flag = false;
                var isrtl = naviobj.model.enableRTL;
                if (isrtl) {
                    naviobj._higherLineLeft.sort(function (a, b) { return a - b });
                    naviobj._lowerLineLeft.sort(function (a, b) { return a - b });
                }
                if (dragParentId != 'leftslider' && dragParentId != 'rightslider' && naviobj.model.valueType == "datetime" && isHigher) {
                    if (naviobj.dragTarget.parentNode.id == "centerslider")
                        naviobj.grabbed = true;
                    else
                        naviobj.grabbed = false;
                    txtPosition = naviobj.mouseDownX;
                    for (i=0;i< naviobj._higherLineLeft.length;i++) {
                        if (i + 1 < naviobj._higherLineLeft.length && txtPosition > naviobj._higherLineLeft[i] && txtPosition < naviobj._higherLineLeft[i + 1]) {
                            naviobj.setSliderPositions(naviobj._higherLineLeft[i], null, null);
                            naviobj.setSliderPositions(null, null, naviobj._higherLineLeft[i + 1]);
                            flag = true;
                        }
                        else if (i + 1 === naviobj._higherLineLeft.length && txtPosition > naviobj._higherLineLeft[i]) {
                            naviobj.setSliderPositions(naviobj._higherLineLeft[i], null, null);
                            naviobj.setSliderPositions(null, null, naviobj.newWidth - naviobj.padding);
                            flag = true;
                        }
                    }
                    if (isrtl && !flag) {
                        naviobj.setSliderPositions(0 + naviobj.padding, null, null);
                        naviobj.setSliderPositions(null, null, naviobj._higherLineLeft[0]);
                        flag = false;
                    }
                }
                else if (dragParentId != 'leftslider' && dragParentId != 'rightslider' && naviobj.model.valueType == "datetime" && isLower) {
                    naviobj.center = naviobj.mouseDownX
                    if (naviobj.dragTarget.parentNode.id == "centerslider")
                        naviobj.grabbed = true;
                    else
                        naviobj.grabbed = false;
                    txtPosition = naviobj.mouseDownX;
                    for (i = 0; i < naviobj._lowerLineLeft.length; i++) {
                        if (i + 1 < naviobj._lowerLineLeft.length && txtPosition > naviobj._lowerLineLeft[i] && txtPosition < naviobj._lowerLineLeft[i + 1]) {
                            naviobj.setSliderPositions(naviobj._lowerLineLeft[i], null, null);
                            naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[i + 1]);
                            flag = true;
                        }
                        else if (i + 1 === naviobj._lowerLineLeft.length && txtPosition > naviobj._lowerLineLeft[i]) {
                            naviobj.setSliderPositions(naviobj._lowerLineLeft[i], null, null);
                            naviobj.setSliderPositions(null, null, naviobj.newWidth - naviobj.padding);
                            flag = true;
                        }
                    }
                    if (isrtl && !flag) {
                        naviobj.setSliderPositions(0 + naviobj.padding, null, null);
                        naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[0]);
                        flag = false;
                    }
                }
                else if (naviobj.isSelection) {
                    naviobj.grabbed = true;
                }

            }
        },

        _leave: function (evt) {
            $("#highlightRect" + this._id).hide();
        },
        _drag: function (evt) {

            evt.preventDefault();
            var matched = jQuery.uaMatch(navigator.userAgent);

            var naviobj = this;//evt.data.Param1;
            if ((this.svgSupport && evt.originalEvent.toString() !== "[object TouchEvent]") && matched.browser.toLowerCase() != "msie") {
                var mousedownCords = naviobj.calMousePosition(evt);
            }
            else if (!this.svgSupport)
                var mousedownCords = naviobj.calMousePosition(evt);
            else
                var mousedownCords = naviobj.calTouchPosition(evt);//naviobj.calMousePosition(evt);
            mouseX = naviobj.mouseDownX = mousedownCords.X;
            mouseY = naviobj.mouseDownY = mousedownCords.Y;
            var labelRegion, labelregionX, labelregionY, xLeft, newX;;
            var highlightOptions = naviobj.model.navigatorStyleSettings.highlightSettings;
            if (highlightOptions.enable && !this._sliderMove && !this.isTouch(evt))
                this._performHighlight(evt);
            if(this.svgSupport)
            naviobj.GetTrueCoords(evt);
            //Apply css cursor as pointer to lower and higher level labels
            if (naviobj.model.labelSettings.higherLevel.visible || naviobj.model.labelSettings.lowerLevel.visible) {
                var regionLength = naviobj.labelRegions.length;
                for (var k = 0; k < regionLength; k++) {
                    labelRegion = naviobj.labelRegions[k];
                    labelregionX = labelRegion.X; labelregionY = labelRegion.Y;
                    if ((labelregionX <= mouseX && (labelregionX + labelRegion.Width >= mouseX)) && (labelRegion.Y <= mouseY && ((labelRegion.Y + labelRegion.Height) >= mouseY))) {
                        $(naviobj.rightUnSelected).css('cursor', 'pointer');
                        $(naviobj.leftUnSelected).css('cursor', 'pointer');
                        break;
                    }
                    else {
                        $(naviobj.rightUnSelected).css('cursor', 'default');
                        $(naviobj.leftUnSelected).css('cursor', 'default');
                    }
                }
            }
            // if we don't currently have an element in tow, don't do anything
            if (naviobj.dragTarget) {
                // account for the offset between the element's origin and the
                //    exact place we grabbed it... this way, the drag will look more natural
                if (!naviobj.edge && naviobj.dragTarget === naviobj.leftSlider || naviobj.dragTarget === naviobj.rightSlider || naviobj.dragTarget === naviobj.highlightRect || naviobj.dragTarget === naviobj.centerSlider) {
                    if (this.svgSupport) {
					if(matched.browser.toLowerCase() == "webkit"||matched.browser.toLowerCase() == "mozilla")
					{
                        var newX = naviobj.mouseDownX - naviobj.grabPoint.x;
						 if (newX < this.padding) newX = this.padding;
                        var newY = naviobj.mouseDownY - naviobj.grabPoint.y;
						}
						else
						{
						var newX = naviobj.trueCoords.x - naviobj.grabPoint.x;
						if (newX < this.padding) newX = this.padding;
                        var newY = naviobj.trueCoords.y - naviobj.grabPoint.y;
						}
                    }
                    else {
                        var newX = naviobj.mouseDownX;
                        var newY = naviobj.mouseDownY;
                    }
                }
                else {
                    var newX = naviobj.mouseDownX;// naviobj.trueCoords.x - naviobj.leftPadding;
                    //  var newX = naviobj.mouseDownX;// naviobj.trueCoords.x - naviobj.leftPadding;
                    var newY = naviobj.mouseDownY;// naviobj.trueCoords.y;
                } // used to find a id of the thumb
                var current = naviobj.dragTarget;
                var targetId;
                while (current.parentNode) {
                    current = current.parentNode
                    if (current.id == this._id + "thumbleft") {
                        targetId = this._id + "thumbleft";
                    }
                    else if (current.id == this._id + "thumbright") {
                        targetId = this._id + "thumbright";
                    }
                }
                naviobj.diff = naviobj.leftSlider.getBoundingClientRect().left - naviobj.rightSlider.getBoundingClientRect().left;
                naviobj.leftdiff = naviobj.rightSlider.getBoundingClientRect().left - this.padding - $(this.svgDocument).offset().left;
                naviobj.rightdiff = naviobj.leftSlider.getBoundingClientRect().left - this.padding - $(this.svgDocument).offset().left;
                if (naviobj.dragTarget.parentNode.id === "leftslider" || targetId == this._id + "thumbleft") {
                    naviobj.grabbed = false;
                    if (naviobj.diff >= -1 && naviobj.diff <= 1 && naviobj.switched == false && naviobj.rightdiff<naviobj.newWidth-(2*this.padding)) {
                        naviobj.target = naviobj.rightSlider;
                        naviobj.switched = true;
                        naviobj.edge = true;
                        naviobj._grab(evt);
                        naviobj._drag(evt);
                    }
                    else {
                        if (newX <= this.rightSliderPosition) {
                            naviobj.setSliderPositions(newX, null, null);
                            this.leftSliderPosition = newX;
                            this.leftset = false;
                        }
                        else {
                            naviobj.setSliderPositions(this.rightSliderPosition, null, null);
                            this.leftset = true;
                            this.leftSliderPosition = this.rightSliderPosition;
                        }
                        if (naviobj.diff >= 1 || naviobj.diff <= -1)
                            naviobj.switched = false;
                    }
                    naviobj.left = newX;
                    if (naviobj.isSelection) {
                        naviobj.isSelection = false;
                        this.renderer._setAttr($(this.selectionRect), { 'fill': 'transparent' });
                        this.renderer._setAttr($(this.selectionRect), { 'stroke': 'transparent' });
                    }
                }
                else if (naviobj.dragTarget.parentNode.id === "rightslider" || targetId == this._id + "thumbright") {
                    naviobj.grabbed = false;
                    // if (((this.svgSupport) && naviobj.leftSlider.getCTM().e == naviobj.rightSlider.getCTM().e && newX < naviobj.newWidth-15 && naviobj.rightSlider.getCTM().e == (naviobj.newWidth - naviobj.padding)) || (naviobj.leftSlider.getBoundingClientRect().left == naviobj.rightSlider.getBoundingClientRect().left && newX < naviobj.newWidth - 15 && naviobj.rightSlider.getBoundingClientRect().left == (naviobj.newWidth - naviobj.padding))) {                                                                
                    if (naviobj.diff >= 0 && naviobj.diff <= 1 && naviobj.switched == false && naviobj.leftdiff >0) {
                        naviobj.target = naviobj.leftSlider;
                        naviobj.switched = true;
                        naviobj.edge = true;
                        naviobj._grab(evt);
                        naviobj._drag(evt);
                    }
                    else {
                        //if (newX >= naviobj.leftSlider.getCTM().e)
                        if (newX >= this.leftSliderPosition) { // naviobj.leftSlider.getBoundingClientRect().left - this.leftPadding)
                            naviobj.setSliderPositions(null, null, newX);
                            this.rightSliderPosition = newX;
                        } else {
                            naviobj.setSliderPositions(null, null, this.leftSliderPosition);
                            this.rightSliderPosition = this.leftSliderPosition;
                        }
                        //naviobj.setSliderPositions(null, null, naviobj.leftSlider.getCTM().e);
                        if (naviobj.diff >= 1 || naviobj.diff <= -1)
                            naviobj.switched = false;
                    }
                    naviobj.right = newX;
                    if (naviobj.isSelection) {
                        naviobj.isSelection = false;
                        this.renderer._setAttr($(this.selectionRect), { 'fill': 'transparent' });
                        this.renderer._setAttr($(this.selectionRect), { 'stroke': 'transparent' });
                    }
                }
                else if ((naviobj.dragTarget.parentNode.id === "centerslider" || naviobj.dragTarget.parentNode.id === "highlightRect" + this._id) && !naviobj.isSelection) {
                    $('#highlightRect'+this._id).hide();
                    if (newX < this.padding) newX =parseFloat(this.padding);
                        if (!naviobj.grabbed) {
                        naviobj.setSliderPositions(null, newX, null);
                        naviobj.center = newX;
                    }
                    else  
                        naviobj.grabbed = false;                     
                    if (newX > newX + this.renderer._getAttrVal($(naviobj.dragTarget), 'width'))
                        naviobj.setSliderPositions(null, newX, null);                    
                }
                else if (naviobj.isSelection) {
                    this.rect = this.selectionRect;
                    this._highlight.call(this, naviobj, evt)
                    naviobj.grabbed = false;
                }
            }
        },

        //Highlight and Selection logic perform here 
        _highlight: function (naviobj, evt) {
            var lowerRegion = [],
                higherRegion = [],
                sliderHeight = this.sliderHeight,
                startX = naviobj.startX > naviobj.mouseDownX ? naviobj.mouseDownX : naviobj.startX,
                endX = naviobj.startX == startX ? naviobj.mouseDownX : naviobj.startX,
                clientY = naviobj.mouseDownY,
                x, y, width, isHigherLevel, height,
                labelPlacement = this.model.labelSettings.higherLevel.labelPlacement,
                lowerLevelLabel = this.model.labelSettings.lowerLevel.visible;
                targetId = evt.target.parentNode.id;

            $.each(naviobj.labelRegions, function (index, region) {
                x = region.X;
                y = region.Y;
                width = region.Width;
                isHigherLevel = region.LabelType == "higherLevel";
                if (isHigherLevel)
                    height = (targetId.indexOf('higherLevel') < 0 && lowerLevelLabel ) ? region.Height : sliderHeight;
                else
                   height = region.Height;
                if (startX <= x + width && x <= endX && (y + height) >= clientY) {
                    if (isHigherLevel) {
                        if (!(higherRegion.indexOf(region) > -1))
                            higherRegion.push(region);
                    } else {
                        if (!(lowerRegion.indexOf(region) > -1))
                            lowerRegion.push(region);
                    }

                }
            });
            var minimumRegion;
            var currentRegion = function (regions) {
                if (regions.length > 0) {
                    min = regions[0].X; max = regions[0].X;
                    minimumRegion = regions[0];
                    maximumRegion = regions[0];
                    for (var i = 0; i < regions.length; i++) {
                        if (regions[i].X < min) {
                            min = regions[i].X;
                            minimumRegion = regions[i];
                        }
                        else if (regions[i].X > max) {
                            max = regions[i].X;
                            maximumRegion = regions[i];
                        }
                    }
                }                

            }

            higherRegion.length > 0 ? currentRegion(higherRegion) : currentRegion(lowerRegion);
            if (!ej.isNullOrUndefined(minimumRegion)) {
                $("#" + this.rect.parentNode.id).show();
                this.renderer._setAttr($(this.rect), {
                    'transform': 'translate(' + minimumRegion.X + ',' + this.sliderPosition + ')',
                    'width': maximumRegion.Width + maximumRegion.X - minimumRegion.X
                });
            }
        },


        _drop: function (evt) {
            // if we aren't currently dragging an element, don't do anything
            $("#highlightRect" + this._id).hide();
            this._sliderMove = false;
            if (this.dragTarget) {
                // since the element currently being dragged has its pointer-events turned off,
                //    we are afforded the opportunity to find out the element it's being dropped on
                var targetElement = evt.target;
                this._sliderHover = false;
                var naviobj = this;
                // set the global variable to null, so nothing will be dragged until we
                //    grab the next element
                if ((naviobj.model.allowSnapping && parseInt(naviobj.leftSlider.getBoundingClientRect().left + 2) < parseInt(naviobj.rightSlider.getBoundingClientRect().left)) || naviobj.isSelection) {
                    var padding = parseInt(naviobj.model.padding),
                        rect = naviobj.isSelection ? naviobj.rect.getBoundingClientRect() : 0;
                    naviobj.ismouseup = true;
                    if (naviobj.dragTarget.parentNode.id === "leftslider")
                        var txtPosition = naviobj.left;
                    else if (naviobj.dragTarget.parentNode.id === "rightslider")
                        var txtPosition = naviobj.right;
                    else if (naviobj.isSelection)
                        var txtPosition = Math.abs(parseFloat(rect.left - $("#" + this._id)[0].getBoundingClientRect().left + padding));
                    else if (naviobj.dragTarget.parentNode.id === "centerslider") {
                        var txtPosition = naviobj.leftSliderPosition;
                        var txtPosition1 = naviobj.rightSliderPosition;
                    }
                    var pos = 0,
                        pos1 = 0,
                        lineLength = naviobj._lowerLineLeft.length,
                        currentLine,
                        nextLine;

                    for (var i = 0; i < naviobj._lowerLineLeft.length; i++) {
                        if (i + 1 < naviobj._lowerLineLeft.length && txtPosition >= naviobj._lowerLineLeft[i] && txtPosition < naviobj._lowerLineLeft[i + 1]) {
                            naviobj.snapValue = naviobj._lowerLineLeft[i];
                            pos = (naviobj._lowerLineLeft[i + 1] - naviobj.snapValue);
                            if (naviobj.dragTarget.parentNode.id === "centerslider") {
                                for (var j = i + 1; j < naviobj._lowerLineLeft.length; j++) {
                                    if (j + 1 < naviobj._lowerLineLeft.length && txtPosition1 >= naviobj._lowerLineLeft[j] && txtPosition1 < naviobj._lowerLineLeft[j + 1]) {
                                        currentLine = naviobj._lowerLineLeft[j];
                                        nextLine = naviobj._lowerLineLeft[j + 1];
                                        pos1 = (nextLine - currentLine);
                                    }
                                }
                                txtPosition1 = (txtPosition1 >= (currentLine + (pos1 / 2))) ? nextLine : currentLine;
                            }
                            if (txtPosition >= (naviobj.snapValue + (pos / 2))) {
                                naviobj.snapValue = naviobj._lowerLineLeft[i + 1];
                                if (naviobj.dragTarget.parentNode.id === "leftslider")
                                    naviobj.setSliderPositions(naviobj._lowerLineLeft[i + 1], null, null);
                                else if (naviobj.dragTarget.parentNode.id === "rightslider")
                                    naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[i + 1]);
                                else if (naviobj.isSelection) {
                                    naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[i + 1] + parseFloat(rect.right - rect.left));
                                    naviobj.setSliderPositions(naviobj._lowerLineLeft[i + 1], null, null);
                                }
                                else if (naviobj.dragTarget.parentNode.id === "centerslider" && !naviobj.grabbed) {
                                    naviobj.setSliderPositions(null, null, txtPosition1);
                                    naviobj.setSliderPositions(naviobj._lowerLineLeft[i + 1], null, null);
                                }

                            }
                            else {
                                naviobj.snapValue = naviobj._lowerLineLeft[i];
                                if (naviobj.dragTarget.parentNode.id === "leftslider")
                                    naviobj.setSliderPositions(naviobj._lowerLineLeft[i], null, null);
                                else if (naviobj.dragTarget.parentNode.id === "rightslider")
                                    naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[i]);
                                else if (naviobj.isSelection) {
                                    naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[i] + parseFloat(rect.right - rect.left));
                                    naviobj.setSliderPositions(naviobj._lowerLineLeft[i], null, null);
                                }
                                else if (naviobj.dragTarget.parentNode.id === "centerslider" && !naviobj.grabbed) {
                                    naviobj.setSliderPositions(null, null, txtPosition1);
                                    naviobj.setSliderPositions(naviobj._lowerLineLeft[i], null, null);
                                }

                            }
                        }
                        else if (i + 1 === naviobj._lowerLineLeft.length && txtPosition >= naviobj._lowerLineLeft[i]) {
                            if (naviobj.isSelection) {
                                naviobj.setSliderPositions(null, null, naviobj._lowerLineLeft[i] + parseFloat(naviobj.rect.getBoundingClientRect().width));
                                naviobj.setSliderPositions(naviobj._lowerLineLeft[i], null, null);
                            } else
                                naviobj.setSliderPositions(null, null, naviobj.newWidth - naviobj.padding);
                        }
                    }
                }
                this.dragTarget = null;
               
                if (this.leftTooltip != undefined && this.model.tooltipSettings.tooltipDisplayMode=="always") {
                    this.leftTooltip.setAttribute('opacity', 1);
                    this.rightTooltip.setAttribute('opacity', 1);
                }
                else if (this.leftTooltip != undefined && this.model.tooltipSettings.tooltipDisplayMode == "ondemand") {
                    if (this.isTouch(evt)) {
                        var tooltip = [this.leftTooltip, this.rightTooltip]
							window.clearTimeout(this.model.timer);
							this.model.timer = setTimeout(function () {
								$(tooltip).fadeOut(500);
							}, 1200);
                    } else {
                        this.leftTooltip.setAttribute('opacity', 0);
                        this.rightTooltip.setAttribute('opacity', 0);
                    }
                }
                if (this.model.enableDeferredUpdate) {
                    this._calculateSelectedData();
                    if (!naviobj.grabbed || naviobj.isSelection) {
                        this._calculateSliderZoomFactPosition();
                        if (this.model.valueType == "datetime") {
                            if (this.startDateTime.getTime() !== new Date(this.model.selectedRangeSettings.start).getTime() || this.endDateTime.getTime() !== new Date(this.model.selectedRangeSettings.end).getTime()) 
                                this._trigger("rangeChanged", this.model);
                        }
                        else {
                            if (this.startValue !== this.model.selectedRangeSettings.start || this.endValue !== this.model.selectedRangeSettings.end)
                                this._trigger("rangeChanged", this.model);
                        }
                    }
                }
                if(naviobj.isSelection){
                    naviobj.isSelection = false;
                    this.renderer._setAttr($(this.selectionRect), { 'fill': 'transparent' });
                    this.renderer._setAttr($(this.selectionRect), { 'stroke': 'transparent' });
                }
            }
            this._setSelectedRange();
        },

        mouseup: function (evt) {
            if (this.dragTarget != null) {
                this._drop(evt);
                if (this.dragTarget != null) {
                    this.dragTarget.setAttributeNS(null, 'pointer-events', 'all');
                    this.dragTarget = null;
                }
                if (this.model.enableDeferredUpdate) {
                    this._calculateSelectedData();
                    this._calculateSliderZoomFactPosition();
                    this._trigger("rangeChanged", this.model);
                  
                }
            }
        },

        _setSelectedRange: function () {           
             
           this._selectedRangeStart(this.model.selectedRangeSettings.start);
           this._selectedRangeEnd(this.model.selectedRangeSettings.end);
          
        },

        GetTrueCoords: function (evt) {
            // find the current zoom level and pan setting, and adjust the reported
            //    mouse position accordingly
            var newScale = this.svgDocument.currentScale;
            var translation = this.svgDocument.currentTranslate;
            var matched = jQuery.uaMatch(navigator.userAgent);
            if (evt.originalEvent.toString() !== "[object TouchEvent]" && matched.browser.toLowerCase() != "msie") {
                this.trueCoords.x = (evt.clientX - translation.x) / newScale;
                this.trueCoords.y = (evt.clientY - translation.y) / newScale;
            }
            else if (matched.browser.toLowerCase() == "msie") {
                this.trueCoords.x = (evt.originalEvent.clientX - translation.x) / newScale;
                this.trueCoords.y = (evt.originalEvent.clientY - translation.y) / newScale;
            }
            else {
                this.trueCoords.x = (evt.originalEvent.touches[0].clientX - translation.x) / newScale;
                this.trueCoords.y = (evt.originalEvent.touches[0].clientY - translation.y) / newScale;
            }
        },

        _getLocalizedLabels: function(){
           return ej.getLocalizedConstants(this.sfType, this.model.locale);
       }
    });
    ej.datavisualization.RangeNavigator.Locale = ej.datavisualization.RangeNavigator.Locale || {};

    ej.datavisualization.RangeNavigator.Locale['default'] = ej.datavisualization.RangeNavigator.Locale['en-US'] = {
        intervals: {
            quarter: { longQuarters: "Quarter", shortQuarters: "Q" },
            week: { longWeeks: "Week", shortWeeks: "W" }
        }
     };
	  ej.datavisualization.RangeNavigator.Locale['fr-FR'] = {
        intervals: {
            quarter: { longQuarters: "Trimestre", shortQuarters: "T" },
            week: { longWeeks: "Semaine", shortWeeks: "S" }
        }
	 };
     ej.datavisualization.RangeNavigator.IntervalType = {

         Auto: 'auto', 

         Years: 'years',

         Quarters: 'quarters',

         Months: 'months',

         Weeks: 'weeks',

         Days: 'days',

         Hours: 'hours',

         Minutes: 'minutes'
     };

     ej.datavisualization.RangeNavigator.Position = {

         Top: 'top',        

         Bottom: 'bottom'      

         
     };

     ej.datavisualization.RangeNavigator.FontStyle = {

         Normal: 'normal',

         Italic: 'italic',

         Bold: 'bold'
     };

     ej.datavisualization.RangeNavigator.FontWeight = {

         Regular: 'regular',

         Bold: 'bold',

         Lighter: 'lighter'
     };

     ej.datavisualization.RangeNavigator.HorizontalAlignment = {

         Left: 'left',

         Right: 'right',

         Middle: 'middle'
     };
     ej.datavisualization.RangeNavigator.LabelPlacement = {

         Inside: 'inside',

         Outside: 'outside'
      
     };    

     ej.datavisualization.RangeNavigator.ValueType = {

         Numeric: 'numeric',

         Datetime: 'datetime'

     };

     ej.datavisualization.RangeNavigator.RangePadding = {

         Additional: 'additional',

         Normal: 'normal',

         None: 'none',

         Round: 'round'        

     };
	 
	  ej.datavisualization.RangeNavigator.Theme = {

        Azure: 'azure',

        FlatLight: 'flatlight',

        Azuredark: 'azuredark',

        Lime: 'lime',

        LimeDark: 'limedark',

        Saffron: 'saffron',

        SaffronDark: 'saffrondark',

        GradientLight: 'gradientlight',

        GradientDark: 'gradientdark'
    };



})(jQuery, Syncfusion);

jQuery.uaMatch = function (ua) {
    ua = ua.toLowerCase();

    var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
        /(webkit)[ \/]([\w.]+)/.exec(ua) ||
        /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
        /(msie) ([\w.]+)/.exec(ua) ||
        ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
        [];

    return {
        browser: match[1] || "",
        version: match[2] || "0"
    };
};;
/**
* @fileOverview Plugin to style the Html Map elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author &lt;a href="mailto:licensing@syncfusion.com"&gt;Syncfusion Inc&lt;/a&gt;
*/

(function ($, ej, undefined) {
    
    ej.widget({ "ejMap": "ej.datavisualization.Map" }, {

        validTags: ["div"],
        _initPrivateProperties: function () {
            this._rootgroup = null;
            this._bubblegroup = null;           
            this._scale = 1;
            this._prevDistance = 0;
            this._tileTranslatePoint = { x: 0, y: 0 };
            this._translatePoint = { x: 0, y: 0 };
            this._prevPoint = null;
            this._Tiles = [];
            this._prevScale = 0;
            this._tileDiv = null;
            this._containerWidth = 500;
            this._containerHeight = 400;
            this._baseTranslatePoint = { x: 0, y: 0 };
            this._isDragging = false;           
            this._prevLevel = 1;
            this._startPoint = { x: 0, y: 0 };
            this._stopPoint = { x: 0, y: 0 };
            this.mouseClickable = false;
            this._browser = null;
            this._baseScale = 0;
            this._mapBounds = null;
            this._svgns = "http://www.w3.org/2000/svg";
            this._ispanning = false;
            this._dragStartX = 0;
            this._isNavigationPressed = false;
			this._iskeyboardKeysPressed = false;
            this._isPolygonSelected = false;
            this._dragStartY = 0;
            this._width = 350;
            this._height = 350;
            this._isMapCoordinates = true;
            this._margintop = 0;
            this._marginleft = 0;
            this._svgDocument = null;
            this._tooltipElement = null;
            this._templateDiv = null;
            this._scrollLegendDiv = null;
            this._legendContainer = null;
            this._legendDiv = null;
            this._legendDivHeight = 0;
            this._legendDivWidth = 0;
            this._mapContainer = null;
            this._isSVG = true;
            this._VMLPathFractionCount = 0;
            this._sliderControl = null; 
            this._isTileMap=false;
            this._isRendered = false;
            this._urlTemplate = null;
            this._polylineCount = 0;
            this._pointscount = 0;
            this._isPinching = false;
            this._groupSize = null;			
			this._groupBorder = { x: 0, y: 0 };
        },


        defaults: {
			locale: null,
			enableGroupSeparator: false,
            background: "transparent",			
            zoomSettings:{              
                minValue: 1,
                maxValue: 100,
                factor: 1,
                level: 1,
                enableZoomOnSelection: false,
                enableZoom: true,
            },          
            centerPosition: null,           
            enableResize: true,
            isResponsive: true,
            enableAnimation: false,           
            draggingOnSelection: false,
            navigationControl:{			
				enableNavigation:false,						
				content:null,
				orientation:'vertical',			
				absolutePosition:{x:0,y:0},								
				dockPosition:'centerleft',
			},           
            enableLayerChangeAnimation: false,
            enablePan: true,
            zoomLevel: 1,
            minZoom: 1,
            maxZoom: 100,
            zoomFactor : 1,
            baseMapIndex: 0,
            shapeSelected: "",
            markerSelected: "",
            zoomedIn: "",
            onRenderComplete: "",
			refreshed:"",
            panned: "",            
            zoomedOut: "",           
            mouseover : "",
            mouseleave : "",                                  
            layers: []
        },

        observables: [            
            "baseMapIndex",
            "enablePan",
            "enableResize",
            "enableAnimation",
            "zoomLevel",
			"minZoom",
            "maxZoom",
            "zoomFactor",
        ],

        _zoomLevel: ej.util.valueFunction("zoomLevel"),
        _minZoom: ej.util.valueFunction("minZoom"),
        _maxZoom: ej.util.valueFunction("maxZoom"),
        _zoomFactor: ej.util.valueFunction("zoomFactor"),
        baseMapIndex: ej.util.valueFunction("baseMapIndex"),
        enablePan: ej.util.valueFunction("enablePan"),
        enableResize: ej.util.valueFunction("enableResize"),
        enableAnimation: ej.util.valueFunction("enableAnimation"),

		_tags: [{
            tag: "layers",
            attr: ["legendSettings.showLegend", "legendSettings.positionX", "legendSettings.positionY", "legendSettings.type", "legendSettings.labelOrientation",
                    "legendSettings.title", "legendSettings.mode", "legendSettings.position", "legendSettings.dockOnMap", "legendSettings.dockPosition",
                    "labelSettings.showLabels", "labelSettings.labelPath", "labelSettings.enableSmartLabel",
                    "legendSettings.leftLabel", "legendSettings.rightLabel", "bubbleSettings.showBubble", "bubbleSettings.valuePath", "bubbleSettings.minValue",
                    "bubbleSettings.maxValue", "bubbleSettings.color", "enableSelection", "enableMouseHover", "showTooltip", "showMapItems", "mapItemsTemplate", "shapeData",
                    "dataSource", "shapePropertyPath", "shapeDataPath", "layerType", "bingMapType", "urltemplate", "shapeSettings.highlightColor",
                    "shapeSettings.highlightBorderWidth", "shapeSettings.selectionColor", "shapeSettings.fill", "shapeSettings.strokeThickness", "shapeSettings.selectionStrokeWidth",
                    "shapeSettings.stroke", "shapeSettings.selectionStroke", "shapeSettings.highlightStroke", "shapeSettings.colorValuePath", "shapeSettings.valuePath",
                    "shapeSettings.autoFill", "shapeSettings.enableGradient", "shapeSettings.colorPalette", "shapeSettings.customPalette",
                   
			        [{
	                    tag: "markers",
	                    attr: ["label", "latitude", "longitude"],
	                    singular: "marker",
			        },
                    {
                        tag: "bubbleSettings.colorMappings.rangeColorMapping",
                        attr: ["from", "to", "color"],
                        singular: "bubblerangeColorMap",
                    },
                    {
                        tag: "bubbleSettings.colorMappings.equalColorMapping",
                        attr: ["value", "color"],
                        singular: "bubbleequalColorMap",
                    },
                    {
                        tag: "shapeSettings.colorMappings.rangeColorMapping",
                        attr: ["from", "to", "color", "gradientColors"],
                        singular: "shaperangeColorMap",
                    },
                    {
                        tag: "shapeSettings.colorMappings.equalColorMapping",
                        attr: ["value", "color"],
                        singular: "shapeequalColorMap",
                    },

			        {
	                    tag: "subLayers",
	                    attr: ["legendSettings.showLegend", "legendSettings.positionX", "legendSettings.positionY", "legendSettings.type", "legendSettings.labelOrientation",
                                "legendSettings.title", "legendSettings.mode", "legendSettings.position", "legendSettings.dockOnMap", "legendSettings.dockPosition",
                                "legendSettings.leftLabel", "legendSettings.rightLabel", "bubbleSettings.showBubble", "bubbleSettings.valuePath", "bubbleSettings.minValue",								
                                "bubbleSettings.maxValue", "bubbleSettings.color", "enableSelection", "enableMouseHover", "showTooltip", "showMapItems", "mapItemsTemplate", "shapeData",
								"dataSource", "shapePropertyPath", "shapeDataPath","layerType", "bingMapType", "key", "urltemplate", "shapeSettings.highlightColor",
								"shapeSettings.highlightBorderWidth", "shapeSettings.selectionColor","shapeSettings.fill", "shapeSettings.strokeThickness", "shapeSettings.selectionStrokeWidth",
								"shapeSettings.stroke", "shapeSettings.selectionStroke","shapeSettings.highlightStroke", "shapeSettings.colorValuePath", "shapeSettings.valuePath", 
								"shapeSettings.autoFill", "shapeSettings.enableGradient",
                                [{
                                    tag: "markers",
                                	attr: ["label", "latitude", "longitude"],
                                	    singular: "marker",
                                },
                                {
                                    tag: "bubbleSettings.colorMappings.rangeColorMapping",
                                    attr: ["from", "to", "color"],
                                    singular: "bubblerangeColorMap",
                                },
                                {
                                    tag: "bubbleSettings.colorMappings.equalColorMapping",
                                    attr: ["value", "color"],
                                    singular: "bubbleequalColorMap",
                                },
                                {
                                    tag: "shapeSettings.colorMappings.rangeColorMapping",
                                    attr: ["from", "to", "color","highlightcolor"],
                                    singular: "shaperangeColorMap",
                                },
                                {
                                    tag: "shapeSettings.colorMappings.equalColorMapping",
                                    attr: ["value", "color"],
                                    singular: "shapeequalColorMap",
                                }
                               ],
	                    ],
	                    singular: "subLayer",
			        }]
                ],
                singular: "layer",
		}],


		
       
        dataTypes: {
            layers: "array"
        },       

        _destroy: function () {            
            this._unWireEvents();
            if (_isSVG) {
                $(this.element).removeClass("e-datavisualization-map e-js").find("#svgDocument").remove();
            }
            else {
                $(this.element).removeClass("e-datavisualization-map e-js").find("#rootGroup").remove();
            }
        },
       
        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "zoomSettings":
                        if (this.model.zoomSettings.enableZoom) {
                            this._zoomLevel(this.model.zoomSettings.level);
                            this._zoomFactor(this.model.zoomSettings.factor);
                            this._maxZoom(this.model.zoomSettings.maxValue);
                            this._minZoom(this.model.zoomSettings.minValue);
                            this.zoom(this._zoomLevel());                            
                        }
                        break;
                    case "zoomLevel":
                        this.model.zoomSettings.level = this._zoomLevel();
                        this.zoom(this._zoomLevel());
                        break;
                    case "zoomFactor":
                        this.model.zoomSettings.factor = this._zoomFactor();
                        this.zoom(this._zoomLevel());
                        break;
                    case "minZoom":
                        this.model.zoomSettings.minValue = this._minZoom();
                        this.zoom(this._zoomLevel());
                        break;
                    case "maxZoom":
                        this.model.zoomSettings.maxValue = this._maxZoom();
                        this.zoom(this._zoomLevel());
                        break;
                    case "baseMapIndex":
                        this.baseMapIndex(options[prop]);
                        var map = this;
						this._groupSize = null;
                        if (this.enableAnimation()) {
                            this.model.enableLayerChangeAnimation = true;
                            $(this._mapContainer).animate({ opacity: 0 }, 500, function () {
                                map.refresh(true);
                            });

                        } else {
                            this.refresh(true);
                        }

                        break;                    
                    case "background":                        
                     if ((baseLayer.layerType == "geometry")) {					
                        $(this._svgDocument).css("background", this.model.background);
						}
                }
            }
        },
		
	_layers: function(index, property, value, old){
	 if (property == "shapeSettings.fill" || property == "shapeSettings.strokeThickness" ||property =="shapeSettings.selectionColor" || property =="shapeSettings.highlightColor") {
                this.clearShapeSelection();
            }
		else if(property=="showMapItems" || property=="dataSource")
		 {
			this.refreshLayers();
		 }
		 else 
		 {
		   this.refresh(true);
		 }
    },

    _layers_markers: function(index, property, value, old){
    	   this.refreshMarkers();
    },

    _layers_subLayers: function(index, property, value, old){
    	  if(property=="showMapItems" || property=="dataSource")
		 {
			this.refreshLayers();
		 }
		 else 
		 {
		   this.refresh(true);
		 }
    },
       
        _init: function () {
            var proxy = this;
			this._navigationStyle = null;
            this.navigationControlData = null;
            this._initPrivateProperties();
            this._setZoomProperties();
			this._localizedLabels = this._getLocalizedLabels();
            $.each(this.model.layers, function (index) {
                proxy._layerInitialize(index);
            });
            this._mapContainer = this.element;
            $(this._mapContainer).css({ "overflow": "hidden" });
			  if (document.documentMode == 8) {
                $(this._mapContainer).css({ "overflow": "hidden" , "position" :"relative" });
            }
			  this._wireEvents();
            this.refresh();
            this._trigger("onRenderComplete");
            this._isRendered = true;
            if (_isSVG && this.model.enablePan) {
                $(this._svgDocument).pinchZoom(this._rootgroup, this);
            }
        },
        _setZoomProperties : function() {
		   if (typeof this.model.zoomSettings.factor != "function") {
            this._zoomFactor(this.model.zoomSettings.factor);
            this._zoomLevel(this.model.zoomSettings.level);
            this._minZoom(this.model.zoomSettings.minValue);
            this._maxZoom(this.model.zoomSettings.maxValue);
			}
        },
		
		_getLocalizedLabels: function(){
			return ej.getLocalizedConstants(this.sfType, this.model.locale);
		},
		
        _layerInitialize: function (layerindex) {
            var proxy = this;
            if (this.model.layers[layerindex] != null) {
                $.each(this.model.layers, function (index, element) {
                    element = proxy._checkArrayObject(element, index);
                    var obj = new shapeLayer();
                    $.extend(obj, element);
                    $.extend(element, obj);
                    $.each(element.subLayers, function (subindex, subelement) {
                        subelement = proxy._checkArrayObject(subelement, subindex);
                        var subobj = new shapeLayer();
                        $.extend(subobj, subelement);
                        $.extend(subelement, subobj);
                    });
                });
            }
            else {

                this.layers[0] = new shapeLayer();

            }
        },
       
        _checkArrayObject: function (element, initialName) {

            var publicProperties = ["background", "zoomSettings","bubbleSettings", "minValue", "maxValue", "factor", "level", "enableZoomOnSelection", "enableZoom", "centerPosition", "enableResize", "isResponsive", "enableAnimation", "draggingOnSelection", "navigationControl", "enableNavigation", "orientation", "absolutePosition", "dockPosition", "enablePan", "baseMapIndex", "enableSelection", "selectionMode", "enableMouseHover", "shapeData", "dataSource", "showTooltip", "legendSettings", "showLegend", "showLabels", "position", "height", "width", "type", "mode", "dockOnMap", "dockPosition", "labelSettings", "labelPath", "enableSmartLabel", "smartLabelSize", "layerType", "showMapItems", "shapeSettings", "highlightColor", "highlightBorderWidth", "selectionColor", "fill", "strokeThickness", "stroke", "highlightStroke", "selectionStroke", "selectionStrokeWidth", "colorValuePath", "valuePath", "enableGradient", "autoFill", ""];

            var proxy = this;
            $.each(element, function (name, innerElement) {
                if (publicProperties.indexOf(name) > -1) {
                    if (innerElement instanceof Array) {
                        proxy._checkArrayObject(innerElement, name);
                    }
                    else if (innerElement != null && typeof innerElement == "object") {
                        var allObjects = new shapeLayer();
                        proxy._loadIndividualDefaultValues(innerElement, allObjects, (typeof name === "number") ? initialName : name);
                    }
                }
            });
            return element;
        },
       
        _loadIndividualDefaultValues: function (obj, allObjects, name) {
            var defaultObj = null;
            var proxy = this;
            $.each(allObjects, function (n, element) {
                if (name == n) {
                    defaultObj = element;
                    return;
                }
            });
            if (defaultObj instanceof Array) defaultObj = defaultObj[0];

            $.each(obj, function (objName, ele) {
                if (ele instanceof Array) {
                    proxy._checkArrayObject(ele, name);
                }
                else if (ele != null && typeof ele == "object") {
                    proxy._loadIndividualDefaultValues(ele, ele, (typeof objName === "number") ? name : objName);
                }
            });

            $.extend(defaultObj, obj);
            $.extend(obj, defaultObj);
            return obj;
        },
     
        _refreshWithAnimation: function () {
            this.model.layers[this.baseMapIndex()]._setMapItemsPositionWithAnimation(this);
            for (var key = 0; key < this.model.layers[this.baseMapIndex()].subLayers.length; key++) {
                this.model.layers[this.baseMapIndex()].subLayers[key]._setMapItemsPositionWithAnimation(this);
            }
        },
       
        _resizeShape: function () {
            this.model.layers[this.baseMapIndex()]._resizeShapes(this);
            for (var key = 0; key < this.model.layers[this.baseMapIndex()].subLayers.length; key++) {
                this.model.layers[this.baseMapIndex()].subLayers[key]._resizeShapes(this);
            }

        },
        
        _refrshLayers: function () {
            this.model.layers[this.baseMapIndex()]._setMapItemsPosition(this);
            for (var key = 0; key < this.model.layers[this.baseMapIndex()].subLayers.length; key++) {
                this.model.layers[this.baseMapIndex()].subLayers[key]._setMapItemsPosition(this);
            }

        },
       
        _panTileMap: function (factorX, factorY, centerPosition) {
            
            var totalSize = Math.pow(2, this._zoomLevel()) * 256;
            this._tileTranslatePoint.x = (factorX / 2) - (totalSize / 2);
            this._tileTranslatePoint.y = (factorY / 2) - (totalSize / 2);
            var position = this._convertTileLatLongtoPoint(centerPosition[0],centerPosition[1]);
            this._tileTranslatePoint.x -= position.x - (factorX / 2);
            this._tileTranslatePoint.y -= position.y - (factorY / 2);

        },
       
        _generateTiles: function (zoomLevel) {
            var userLang = navigator.language || navigator.userLanguage;
            this.Tiles = [];
            var xcount, ycount;
            xcount = ycount = Math.pow(2, zoomLevel);
            var baseLayer = this.model.layers[this.baseMapIndex()];
            var endY = Math.min(ycount, ((-this._tileTranslatePoint.y + this._height) / 256) + 1);
            var endX = Math.min(xcount, ((-this._tileTranslatePoint.x + this._width) / 256) + 1);
            var startX = (-(this._tileTranslatePoint.x + 256) / 256);
            var startY = (-(this._tileTranslatePoint.y + 256) / 256);
            for (var i = Math.round(startX) ; i < Math.round(endX) ; i++) {
                for (var j = Math.round(startY) ; j < Math.round(endY) ; j++) {
                    var x = 256 * i + this._tileTranslatePoint.x;
                    var y = 256 * j + this._tileTranslatePoint.y;
                    if (x > -256 && x <= this._width && y > -256 && y < this._height) {
                        if (i >= 0 && j >= 0) {
                            var tile = new Tile(i, j);
                            tile.left = x;
                            tile.top = y;
                            if (baseLayer.layerType == ej.datavisualization.Map.LayerType.Bing) {
                                tile.src = this._getBingMap(tile, baseLayer.key, baseLayer.bingMapType, userLang);
                            } else {
                                tile.src = this._urlTemplate.replace("level", this._zoomLevel()).replace('tileX', tile.X).replace('tileY', tile.Y);
                            }
                            this.Tiles.push(tile);
                        }
                    }
                }
            }
            var proxTiles = $.extend(true, [], this.Tiles);
            for (var layerIndex = 0; layerIndex < this.model.layers[this.baseMapIndex()].subLayers.length;layerIndex++) {
                var layer = this.model.layers[this.baseMapIndex()].subLayers[layerIndex];
                if (layer.layerType == ej.datavisualization.Map.LayerType.OSM || layer.layerType == ej.datavisualization.Map.LayerType.Bing) {
                    for (var tileIndex = 0; tileIndex < proxTiles.length; tileIndex++) {
                        var baseTile = proxTiles[tileIndex];
                        var subtile = $.extend(true, {}, baseTile);
                        if (layer.layerType == ej.datavisualization.Map.LayerType.Bing) {
                            subtile.src = this._getBingMap(subtile, layer.key, layer.bingMapType, userLang);
                        } else {
                            subtile.src = layer.urlTemplate.replace("level", this._zoomLevel()).replace('tileX', baseTile.X).replace('tileY', baseTile.Y);
                        }
                        this.Tiles.push(subtile);
                    }

                }
            }
            this._arrangeTiles();
        },
       
        _getBingMap:function(tile,key,type,lang) {
            var quadKey = "";
            for (var i = this._zoomLevel() ; i > 0; i--)
            {
                var digit = 0;
                var mask = 1 << (i - 1);
                if ((tile.X & mask) != 0)
                {
                    digit++;
                }
                if ((tile.Y & mask) != 0)
                {
                    digit+=2;
                }
                quadKey = quadKey+""+digit;
            }
            var layerType;
            if (type == ej.datavisualization.Map.BingMapType.Aerial) {
                layerType = "A,G";
            }
            else if (type == ej.datavisualization.Map.BingMapType.AerialWithLabel) {
                layerType = "A,G,L";
            } else {
                layerType = "G,VE,BX,L,LA";
            }
            var imageUrl = "http://ak.dynamic.t2.tiles.virtualearth.net/comp/ch/" + quadKey + "?mkt=" + lang + "&ur=IN&it=" + layerType + "&shading=hill&og=45&n=z&Key=" + key;
            return imageUrl;
        },
               
        _arrangeTiles: function (){        
            var pathTemplate = "<div><div style='position:absolute;left:{{:left}}px;top:{{:top}}px;height:{{:height}}px;width:{{:width}}px;'><img src={{:src}}></img></div></div>";
            var tmpl2 = $.templates(pathTemplate);
            var htmlString = tmpl2.render(this.Tiles);
            var first = this._mapContainer[0].children[0];            
            this._tileDiv.html(htmlString);            
        },

        _generatePath: function () {
           
            var baseLayer = this.model.layers[this.baseMapIndex()];            
            var pathCollection = '';
            this._polylineCount = 0;
            this._pointscount = 0;
            _isSVG = (window.SVGSVGElement) ? true : false;

            
            if (baseLayer.layerType == ej.datavisualization.Map.LayerType.Geometry) {
                if (baseLayer != undefined && baseLayer.shapeData != null) {
                    baseLayer._isBaseLayer = true;
                    this._isTileMap = false;
                    this._scale = this._zoomLevel();
                    pathCollection = this._readShapeData(baseLayer);
                }
            }
            else {                
                this._isTileMap = true;
                this._scale = Math.pow(2, this._zoomLevel() - this._zoomFactor());
            }
            for (var key = 0; key < baseLayer.subLayers.length; key++) {
                if (baseLayer.subLayers[key].layerType == ej.datavisualization.Map.LayerType.Geometry && baseLayer.subLayers[key].shapeData != null) {
                    baseLayer.subLayers[key]._isBaseLayer = false;
                    pathCollection += this._readShapeData(baseLayer.subLayers[key]);
                }
            }
            if (_isSVG) {
                var htmlstring = '<div style="position:relative;" id="tileDiv"/><svg xmlns="http://www.w3.org/2000/svg" style= "overflow:hidden;z-index:0;float:left;left:0,top:0"' +
                             'id="svgDocument"> <g id="rootGroup">' + pathCollection + '</g></svg>';
                this._mapContainer.html(htmlstring);               
                this._svgDocument = this.element.find("#svgDocument")[0];
                this._tileDiv = this.element.find("#tileDiv");
                
            }
            else {
                document.createStyleSheet().addRule(".vml", "behavior:url(#default#VML);display:inline-block");
                document.namespaces.add('v', 'urn:schemas-microsoft-com:vml', "#default#VML");
                var vmlGroup = '<div id="tileDiv"/><v:group   id = "rootGroup" style="position:absolute; width:' + this._width + 'px;height:' + this._height + 'px;" coordorigin = "0 0" coordsize="' + this._width + ' ' + this._height + '">' + pathCollection + '</v:group>';
                this._mapContainer.html(vmlGroup);                
                this._tileDiv = this.element.find("#tileDiv");
                this._bubblegroup = this._createGroup(false,"bubbleGroup");               
                this._bubblegroup.style.position = "absolute";
                this.element.append(this._bubblegroup);
            }
            if (baseLayer.layerType == ej.datavisualization.Map.LayerType.OSM || baseLayer.layerType == ej.datavisualization.Map.LayerType.Bing) {
                this._urlTemplate = baseLayer.urlTemplate;
                if (this.model.centerPosition != null) {
                    this._panTileMap(this._width, this._height, this.model.centerPosition);
                }
                else {
                    this._panTileMap(this._width, this._height, [0, 0]);
                }
                this._generateTiles(this._zoomLevel());
				if(_isSVG)
				{
				  $(this._svgDocument).css("position","relative");
				}
            }
            if(_isSVG)
			{			
                $(this._mapContainer).css("position", "relative");
			}			
            this._rootgroup = this.element.find("#rootGroup")[0];

            this._on($(this.element), ej.eventType.mouseDown, { map: this }, this.dragDown);
            this._on($(this.element), ej.eventType.mouseMove, { map: this }, this.dragMove);
            this._on($(this.element), ej.eventType.mouseUp, { map: this }, this.dragUp);

        },

        _calculateBBox: function (polygonDatas, polylineDatas,pointData)
        {
            var minLatitude = maxLatitude = minLongitude = maxLongitude = 0;
            var isEntered = false;
            if (polygonDatas != null && polygonDatas.length > 0) {
                for (var i = 0; i < polygonDatas.length; i++) {
                    var currentData = polygonDatas[i];
                    if (currentData.geometry != null) {
                        coords = currentData.geometry.coordinates;
                    } else {
                        coords = currentData.coordinates;
                    }
                    var currentDataLength = coords.length;
                    for (var j = 0; j < currentDataLength; j++) {
                        var subData = '';
                        if (currentDataLength > 1) {
                            subData = coords[j][0];
                            if (subData.length <= 2) {
                                subData = coords[j];
                            }
                        } else {
                            subData = coords[j];
                        }
                        if (subData.length > 2) {
                            for (var k = 0; k < subData.length; k++) {
                              if(subData[k][1]!=null && subData[k][0]!=null){
                                if (!isEntered) {
                                    minLatitude = maxLatitude = subData[k][1];
                                    minLongitude = maxLongitude = subData[k][0];
                                    isEntered = true;

                                } else {
                                    minLatitude = Math.min(minLatitude, subData[k][1]);
                                    maxLatitude = Math.max(maxLatitude, subData[k][1]);
                                    minLongitude = Math.min(minLongitude, subData[k][0]);
                                    maxLongitude = Math.max(maxLongitude, subData[k][0]);
                                }
                                }
                            }
                        } else {
                          if(subData[k][1]!=null && subData[k][0]!=null){
                            if (!isEntered) {
                                minLatitude = maxLatitude = subData[1];
                                minLongitude = maxLongitude = subData[0];
                                isEntered = true;
                            } else {
                                minLatitude = Math.min(minLatitude, subData[1]);
                                maxLatitude = Math.max(maxLatitude, subData[1]);
                                minLongitude = Math.min(minLongitude, subData[0]);
                                maxLongitude = Math.max(maxLongitude, subData[0]);
                            }
                           }
                        }
                    }
                }
            }
            if (pointData!=null && pointData.length > 0) {
                for (var i = 0; i < pointData.length; i++) {
                    var currentData = pointData[i];
                    subData = currentData.geometry.coordinates;
                    if (!isEntered) {
                        minLatitude = maxLatitude = subData[1]; // (φ)
                        minLongitude = maxLongitude = subData[0];
                        isEntered = true;
                    } else {
                        minLatitude = Math.min(minLatitude, subData[1]);
                        maxLatitude = Math.max(maxLatitude, subData[1]);
                        minLongitude = Math.min(minLongitude, subData[0]);
                        maxLongitude = Math.max(maxLongitude, subData[0]);
                    }
                }
            }
            if (polylineDatas!=null && polylineDatas.length > 0) {
                for (var i = 0; i < polylineDatas.length; i++) {
                    var coordinates;
                    if (polylineDatas[i].geometry == null) {
                        coordinates = polylineDatas[i].coordinates;
                    }
                    else {
                        coordinates = polylineDatas[i].geometry.coordinates;
                    }
                    for (var k = 0; k < coordinates.length; k++) {
                        if (!isEntered) {
                            minLatitude = maxLatitude = coordinates[k][1]; // (φ)
                            minLongitude = maxLongitude = coordinates[k][0];
                            isEntered = true;
                        } else {
                            minLatitude = Math.min(minLatitude, coordinates[k][1]);
                            maxLatitude = Math.max(maxLatitude, coordinates[k][1]);
                            minLongitude = Math.min(minLongitude, coordinates[k][0]);
                            maxLongitude = Math.max(maxLongitude, coordinates[k][0]);
                        }
                    }
                }
            }
            
			if (this._groupSize == null && !this._isMapCoordinates) {
            this._groupSize = { minX: minLongitude, maxX: maxLongitude, minY: minLatitude, maxY: maxLatitude };
             }
            return [[minLongitude, minLatitude], [maxLongitude, maxLatitude]];        
        },
        		
        _readShapeData: function (layer) {
            var map = this;
            if (layer.shapeData != null) {
                if (typeof layer.shapeData == 'string') {
                    var dataManger =new ej.DataManager(layer.shapeData);
                    var query = ej.Query().from(layer);
                    dataManger.executeQuery(query).done(function (e) {
                        if (e.result != null) {
                            return map._getPathCollection(e.result, layer);
                        }
                    });

                } else {
                 return this._getPathCollection(layer.shapeData, layer);
                }
                
            }
        },
       
        _getFactor:function()
        {
            var contHeight;
            var contWidth;
            var heightfactor;
            var widthfactor
            if (this._mapBounds != null) {
                var startpoint = this._convertTileLatLongtoPointForShapes(this._mapBounds[0][1], this._mapBounds[0][0], this._mapBounds);
                var endpoint = this._convertTileLatLongtoPointForShapes(this._mapBounds[1][1], this._mapBounds[1][0], this._mapBounds);
                var minDiff = 0;
                var widthfactor = heightfactor = 1;
                contHeight = endpoint.y - startpoint.y;
                contWidth = endpoint.x - startpoint.x;
            }
            else {
                contHeight = 500;
                contWidth = 500;
            }
            if (contHeight < this._height) {
                heightfactor = parseFloat(Math.abs(this._height / contHeight + "e+1").toString().split('.')[0] / 10);
            }
			else{
                heightfactor = (this._height / contHeight);
            }
            if (contWidth < this._width) {
                widthfactor = parseFloat(Math.abs(this._width / contWidth + "e+1").toString().split('.')[0] / 10);
            }
			else {
                widthfactor = (this._width / contWidth);
            }

            return Math.min(widthfactor, heightfactor);
        },

        _getPathCollection:function(data,layer)
        {
            var shapePath = "";
            var type = "";
            var dataManager="";
            if (data.features != null) {
                dataManager = new ej.DataManager(data.features);
                type = "geometry.type";
                if (layer._isBaseLayer) {
                    this._mapBounds = data.bbox;
                }
            }
            else if (data.geometries != null) {
                dataManager = new ej.DataManager(data.geometries);
                type = "type";
                if (layer._isBaseLayer) {
                    if (data.bbox != null)
                        this._mapBounds = [[data.bbox[0], data.bbox[1]], [data.bbox[2], data.bbox[3]]];
                    }                
            }
			if(data.geometries!=null || data.features != null){
            var queryPolyLine = ej.Query().from(layer).where(type, ej.FilterOperators.equal, 'LineString');
            var queryPolygon = ej.Query().from(layer).where(type, ej.FilterOperators.equal, 'Polygon');
            var queryMulitiPolygon = ej.Query().from(layer).where(type, ej.FilterOperators.equal, 'MultiPolygon');
            var polylineDatas = dataManager.executeLocal(queryPolyLine);           
            var polygonDatas = dataManager.executeLocal(queryPolygon);
            var queryPoint = ej.Query().from(layer).where(type, ej.FilterOperators.equal, 'Point');
            var pointData = dataManager.executeLocal(queryPoint);
            var multiPolygonDatas = dataManager.executeLocal(queryMulitiPolygon);
            this._polylineCount = this._polylineCount + polylineDatas.length;
            this._pointscount = this._pointscount + pointData.length;
            $.merge(polygonDatas, multiPolygonDatas);
            if (layer._isBaseLayer && layer.geometryType == ej.datavisualization.Map.GeometryType.Normal) {
                this._isMapCoordinates = false;
            }
            if (this._mapBounds == null && layer._isBaseLayer) {
                this._mapBounds = this._calculateBBox(polygonDatas, polylineDatas, pointData);
            }
			else if (this._mapBounds == null)
                   this._mapBounds = [[-180, -85], [180, 85]] ;

            var factor = this._getFactor();

			layer._newBounds = [];                 
            var pointHtml = "";
            if(this._groupSize != null)
			{
			
			minX = this._groupSize.minX;
			maxX = this._groupSize.maxX;
			minY = this._groupSize.minY;
			maxY = this._groupSize.maxY;
			}
            var minX, maxX, minY, maxY, flag = true;
            if (pointData.length > 0) {
                for (var i = 0; i < pointData.length; i++) {
                    var currentData = pointData[i];                   
                    var check = '';
                    subData = currentData.geometry.coordinates;
                    var data = [];
                    var data_clean = [];                   
                    data.push({
                        lat: parseFloat(subData[1]),
                        lng: parseFloat(subData[0])                        
                    });                    
                    var l = 0;

                    var point = data[0];
                    latitude = point.lat; // (φ)
                    longitude = point.lng;   // (λ)                   
                    var p = this._convertTileLatLongtoPointForShapes(latitude, longitude, this._mapBounds,factor);
                    var boundingBox = this._mapBounds;
                    if ((longitude >= boundingBox[0][0] && longitude <= boundingBox[1][0] && latitude >= boundingBox[0][1] && latitude <= boundingBox[1][1])) {

                    if (flag && this._groupSize == null) {
                        minX = maxX = p.x;
                        minY = maxY = p.y;
                        flag = false;
                    }
                    else {
                        minX = Math.min(minX, p.x);
                        maxX = Math.max(maxX, p.x);
                        minY = Math.min(minY, p.y);
                        maxY = Math.max(maxY, p.y);
                    }

                    if (_isSVG) {
                        data_clean.push({ x: p.x, y: p.y, lat: point.lat, lng: point.lng });
                    }
                    else {
                        data_clean.push({ x: p.x - ((10 / this._scale)/2), y: p.y-((10 / this._scale) / 2), lat: point.lat, lng: point.lng });
                    }

                    if (_isSVG) {
                        pointHtml += '<circle cx="' + data_clean[0].x + '" cy="' + data_clean[0].y + '" r="' + layer.shapeSettings.radius / this._scale + '" stroke="' + layer.shapeSettings.stroke + '" stroke-width="' + layer.shapeSettings.strokeThickness + '" fill="' + layer.shapeSettings.fill + '" />';
                    }
                    else {
                        var pointHtmlString = '<v:oval display="block" fill="' + layer.shapeSettings.fill + '" style="position:absolute;top: ' + data_clean[0].y + 'px;left:' + data_clean[0].x + 'px;width:' + 10 / this._scale + 'px;height:' + 10 / this._scale + 'px;stroke-width:' + layer.shapeSettings.strokeThickness + 'px;"></v:oval>';
                        pointHtml += pointHtmlString;
                    }
                  }  else {
                        pointData.splice(i, 1);
                        i--;
                    }
                }

            }            
            if (polygonDatas.length > 0)
            {
                
                for (var i = 0; i < polygonDatas.length; i++) {
                    var currentData = polygonDatas[i];
                    var midCoordinate = 0;
                    var midCoordinateLength;
                    var coords;
                    if (currentData.geometry != null) {
                        coords = currentData.geometry.coordinates;
                    }
                    else {
                        coords = currentData.coordinates;
                    }                    
                    midCoordinateLength = coords[0][0].length;
                    var currentDataLength = coords.length;
                    if (currentDataLength > 1) {
                        var lst = coords;
                        for (var index = 0; index < lst.length; index++) {
                            if (midCoordinateLength < lst[index][0].length) {
                                midCoordinateLength = lst[index][0].length;
                                midCoordinate = index;
                            }
                        }
                    }
                    var path_code = '';
                    for (var j = 0; j < currentDataLength; j++) {
                        var subData = '';                       
                        if (currentDataLength > 1) {
                            subData = coords[j][0];
                            if (subData.length <=2) {
                                subData = coords[j];
                            }
                        }
                        else {
                            subData = coords[j];
                        }
                        var data = [];
                        var data_clean = [];
                        if (subData.length > 2) {
                            for (var k = 0; k < subData.length; k++) {
                                data.push({
                                    lat: parseFloat(subData[k][1]),
                                    lng: parseFloat(subData[k][0])
                                });
                            }
                        }
                        else {
                            data.push({
                                lat: parseFloat(subData[1]),
                                lng: parseFloat(subData[0])
                            });
                        }                       
                        for (var l = 0; l < data.length - 1|| (data.length==1 && l==0); l++) {
                            var point = data[l];
                            latitude = point.lat; // (φ)
                            longitude = point.lng;   // (λ                           
                            var boundingBox = this._mapBounds;
                            if (this._isTileMap||(longitude >= boundingBox[0][0] && longitude <= boundingBox[1][0] && latitude >= boundingBox[0][1] && latitude <= boundingBox[1][1])) {
                               
                                var p = this._convertTileLatLongtoPointForShapes(latitude, longitude, boundingBox, factor);
                                if (flag && this._groupSize == null) {
                                    minX = maxX = p.x;
                                    minY = maxY = p.y;
                                    flag = false;
                                }
                                else {
                                    minX = Math.min(minX, p.x);
                                    maxX = Math.max(maxX, p.x);
                                    minY = Math.min(minY, p.y);
                                    maxY = Math.max(maxY, p.y);
                                }                                
                                if (_isSVG) {
                                    data_clean.push({ x: p.x, y: p.y, lat: point.lat, lng: point.lng });
                                }
                                else {
                                    data_clean.push({ x: p.x, y: p.y, lat: point.lat, lng: point.lng });
                                }
                            }
                            
                        }
                        if (j == midCoordinate) {
                            layer._newBounds.push(this._findMidPointofPoylgon(data_clean));
                        }
                        
                        if (data_clean.length > 0) {
                            if (_isSVG) {
                                path_code += "M" + (data_clean[0].x) + "," + (data_clean[0].y);
                                for (m = 1; m < data_clean.length; m++) {
                                    path_code += "," + (data_clean[m].x) + "," + (data_clean[m].y);
                                }
                                path_code += "Z";
                            }
                            else {
                                path_code += "m" + parseInt(data_clean[0].x) + "," + parseInt(data_clean[0].y);
                                path_code += " l" + parseInt(data_clean[0].x) + "," + parseInt(data_clean[0].y);
                                for (m = 1; m < data_clean.length; m++) {
                                    path_code += "," + parseInt(data_clean[m].x) + "," + parseInt(data_clean[m].y);
                                }
                                path_code += " e";
                            }
                        }

                    }
                    if (path_code != "") {
                        if (_isSVG) {
                            shapePath += '<path class="mapShape" stroke=' + layer.shapeSettings.stroke +
                                        ' stroke-width=' + (layer.shapeSettings.strokeThickness / this._scale) +
                                         ' fill= ' + layer.shapeSettings.fill + ' d="' + path_code + '"  stroke-linejoin= round stroke-linecap= square></path>';
                        }
                        else {
                            shapePath += '<v:shape  style="width:' + this._width + 'px;height:' + this._height + 'px;"  coordsize="'
                                + this._width + ' ' + this._height + '" coordorigin="0 0" strokecolor=' + layer.shapeSettings.stroke +
                                           ' stroke-width=' + (layer.shapeSettings.strokeThickness / this._scale) + 'px"' +
                                            ' fillcolor= ' + layer.shapeSettings.fill + ' path="' + path_code + '"></v:shape>';
                        }
                    }
                    else {
                        polygonDatas.splice(i, 1);
                        i--;
                    }
                    
                }
                
            }
            
            if (polylineDatas.length > 0) {

                for (var i = 0; i < polylineDatas.length; i++) {
                    var coordinates;
                    if (polylineDatas[i].geometry == null) {
                        coordinates = polylineDatas[i].coordinates;
                    }
                    else {
                        coordinates = polylineDatas[i].geometry.coordinates;
                    }
                    var linedata = '';
                    for (var k = 0; k < coordinates.length; k++) {
                        var factor = this._getFactor();
                        var points = this._convertTileLatLongtoPointForShapes(coordinates[k][1], coordinates[k][0], this._mapBounds,factor);
						
						 if (flag && this._groupSize == null) {
                        minX = maxX = points.x;
                        minY = maxY = points.y;
                        flag = false;
                    }
                    else {
                        minX = Math.min(minX, points.x);
                        maxX = Math.max(maxX, points.x);
                        minY = Math.min(minY, points.y);
                        maxY = Math.max(maxY, points.y);
                    }
                        linedata += points.x + "," + points.y;
                        if (k != coordinates.length - 1)
                            linedata += ",";
                    }

                    if (_isSVG) {
                        shapePath += '<polyline stroke=' + layer.shapeSettings.stroke +
                                    ' stroke-width=' + (layer.shapeSettings.strokeThickness / this._scale) + ' fill="transparent" stroke-width="1" points="' + linedata + '" ></polyline>';

                    }
                    else {
                        shapePath += '<v:polyline coordsize="'+ this._width + ',' + this._height + '" coordorigin="0 0" strokecolor=' + layer.shapeSettings.stroke +
                                                               ' strokeweight=' + (layer.shapeSettings.strokeThickness / this._scale) + 'px"' +
                                                                ' fillcolor=' + layer.shapeSettings.fill + '  points="' + linedata + '"/>';


                    }
                }

            }           
            if(this._isMapCoordinates)
            {
                this._groupSize = { minX: minX, maxX: maxX, minY: minY, maxY: maxY };
            }
            var lines = [].concat(polygonDatas, polylineDatas);
            layer._polygonData = $.merge(lines, pointData);
            return shapePath + pointHtml;
			}
			else{
			  layer._polygonData=[];
			    return null;
		   }
        },
             
        _createGroup: function (isRoot,name) {
            
            var vmlGroup;
            vmlGroup = document.createElement('<v:group class='+name+'>');
            vmlGroup.style.width = this._width + 'px';
            vmlGroup.style.height = this._height + 'px';            
            vmlGroup.coordorigin = "0 0";
            vmlGroup.coordsize = this._width + ' ' + this._height;
            if (isRoot) {
                this._rootgroup = vmlGroup;
                vmlGroup.style.left = '20px';
                vmlGroup.style.top = '20px';
            }
            return vmlGroup;
        },

        _generatePaletteColorsForShape: function (shape, shapelayer, palette, palettesettings) {

            if (palettesettings != null) {
                shapelayer.shapeSettings.highlightColor = palettesettings.highlightColor;
                shapelayer.shapeSettings.highlightStroke = palettesettings.highlightStroke;
                shapelayer.shapeSettings.selectionColor = palettesettings.SelectionColor;
                shapelayer.shapeSettings.selectionStroke = palettesettings.SelectionStroke;
                
            }

            if (_isSVG) {
                shape.setAttribute("fill", palette[shapelayer._prevPaletteIndex]);
            }
            else {
                shape.fillcolor = palette[shapelayer._prevPaletteIndex];
            }
            shapelayer._prevPaletteIndex = shapelayer._prevPaletteIndex + 1;
            if (shapelayer._prevPaletteIndex > palette.length - 1)
                shapelayer._prevPaletteIndex = 0;
        },

        _renderLayers: function (layer, pathCount) {

            layer._prevPaletteIndex = 0;
            layer._initializeLocalValues();   
            if (layer.selectedItems == null) {
                layer.selectedItems = [];
            }       
            var proxyrootGroup = this._rootgroup;
            var proxySVG = this._svgDocument;
            var proxyControl = this;
            var shapelayer = layer;
            if (shapelayer.legendSettings != null && shapelayer.shapeSettings.colorMappings != null && (shapelayer.legendSettings.type == undefined || shapelayer.legendSettings.type == ej.datavisualization.Map.LegendType.Layers))
                 shapelayer._generateLegends(this);
            if (shapelayer.legendSettings != null && shapelayer.bubbleSettings.colorMappings != null && (shapelayer.legendSettings.type == ej.datavisualization.Map.LegendType.Bubbles))
				 shapelayer._generateBubbleLegends(this);
            if (shapelayer.shapeSettings.colorMappings != null && shapelayer.shapeSettings.colorMappings.rangeColorMapping != null) {

                shapelayer.shapeSettings.colorMappings.rangeColorMapping.sort(this._orderByNameAscending);
            }
            if (shapelayer.bubbleSettings.colorMappings != null && shapelayer.bubbleSettings.colorMappings.rangeColorMapping != null) {
                shapelayer.bubbleSettings.colorMappings.rangeColorMapping.sort(this._orderByNameAscending);
            }
            var minValue = 0;
            var maxValue = 0;
            var sum = 0;
            if (shapelayer.dataSource != null && shapelayer.bubbleSettings != null) {
                if (shapelayer.bubbleSettings.colorValuePath  == null) {
                    shapelayer.bubbleSettings.colorValuePath  = shapelayer.bubbleSettings.valuePath;
                }
                for (var i = 0; i < shapelayer.dataSource.length; i++) {
                    var bubbledata = parseFloat(this._reflection(shapelayer.dataSource[i], shapelayer.bubbleSettings.valuePath));
                    if (i != 0) {
                        if (bubbledata > maxValue) {
                            maxValue = bubbledata;
                        } else if (bubbledata < minValue) {
                            minValue = bubbledata;
                        }
                    } else {
                        minValue = maxValue = bubbledata;
                    }
                }
            }

            this._generateTooltipForLayers(shapelayer);
            if (shapelayer.shapeData != null) {
                var shapesource = [];
                if (shapelayer.dataSource != null) {
                    for (var key = 0; key < shapelayer.dataSource.length; key++) {
                        var shapeitem = shapelayer.dataSource[key];
                        var shapeItemValue = proxyControl._reflection(shapeitem, shapelayer.shapeDataPath);
                        if (shapeItemValue != null) {
                            shapeItemValue = shapeItemValue.toLowerCase();
                        }
                        shapesource.push(shapeItemValue);
                    }
                }
                // touchevent changing
                var browserInfo = ej.browserInfo(),
                    temp = this.model,
                    isPointer = browserInfo.isMSPointerEnabled,
                    isIE11Pointer = browserInfo.pointerEnabled,
                    touchEndEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
                    touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
                    touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
                    touchCancelEvent = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchend mouseleave";
                for (var dataIndex = 0; dataIndex < shapelayer._polygonData.length; dataIndex++) {
                    var ValueObject = shapelayer._polygonData[dataIndex].properties;
                    var DBFValue = proxyControl._reflection(ValueObject, shapelayer.shapePropertyPath);
                    var dbfCondition;
                    if (DBFValue != null && (typeof DBFValue) == "string") {
                        dbfCondition = DBFValue.toLowerCase();
                    }
                    var shape = this._rootgroup.childNodes[dataIndex + pathCount];
					 if (_isSVG) {
                        shape.setAttribute("fill", shapelayer.shapeSettings.fill);
                    }
                    else {
                        shape.fillcolor = shapelayer.shapeSettings.fill;
                        shape.strokecolor = shapelayer.shapeSettings.stroke;
                    }
                    var obj = {};
                    var bounds = shapelayer._newBounds[dataIndex];

                    if (shapelayer.shapeSettings.autoFill) {
                        switch (shapelayer.shapeSettings.colorPalette) {
                            case ej.datavisualization.Map.ColorPalette.Palette1:
                                this._generatePaletteColorsForShape(shape, shapelayer, shapelayer.colorPalettes.Palette1, shapelayer._colorPaletteSettings.Palette1);
                                break;
                            case ej.datavisualization.Map.ColorPalette.Palette2:
                                this._generatePaletteColorsForShape(shape, shapelayer, shapelayer.colorPalettes.Palette2, shapelayer._colorPaletteSettings.Palette2);
                                break;
                            case ej.datavisualization.Map.ColorPalette.Palette3:
                                this._generatePaletteColorsForShape(shape, shapelayer, shapelayer.colorPalettes.Palette3, shapelayer._colorPaletteSettings.Palette3);
                                break;
                            case ej.datavisualization.Map.ColorPalette.CustomPalette:
                                this._generatePaletteColorsForShape(shape, shapelayer, shapelayer.shapeSettings.customPalette, null);
                                break;
                        }
                    }

                 if (shapesource.indexOf(dbfCondition) != -1) {
                        var item = shapelayer.dataSource[shapesource.indexOf(dbfCondition)];
                        var ItemValue = DBFValue;
                        if (item != null) {
                            if (shape != null) {                              
                               
                                var id = ItemValue;
                            }
                                layer._bounds.push(bounds);
                                if (shapelayer.showMapItems) {
                                    var itemTemplateDiv = $("<div class='mapItems' style='display:block;position:absolute;pointer-events: none;'></div>");
                                    itemTemplateDiv[0].className = ItemValue;
                                    proxyControl._templateDiv.append(itemTemplateDiv);
                                    $(itemTemplateDiv).css({ "left": bounds.x, "top": bounds.y });
                                    var htmlString;
									 var locale = this.model.locale;
									 var obj = $.extend({}, item);
									 if (locale && this.model.enableGroupSeparator){
										for (var key in obj)
											obj[key] = isNaN(parseFloat(obj[key])) ? obj[key] : parseFloat(obj[key]).toLocaleString(locale);
									 }
                                    if (shapelayer.mapItemsTemplate == null) {
                                        htmlString= $(' <div><label>{{:' + shapelayer.shapeSettings.valuePath + '}}</label></div>').render(obj);
                                    }
                                    else {
                                        htmlString = $("#" + shapelayer.mapItemsTemplate).render(obj);
                                    }
                                    $(itemTemplateDiv).html(htmlString);
                                    layer._mapItems.push(itemTemplateDiv);
                                }                                   
                                                             
                                if (shapelayer.shapeSettings.colorMappings != null) {
                                    if (shapelayer.shapeSettings.colorValuePath  == null) {
                                        shapelayer.shapeSettings.colorValuePath  = shapelayer.shapeSettings.valuePath;
                                    }
                                    var shapeValue = proxyControl._reflection(item, shapelayer.shapeSettings.colorValuePath );
                                    if (shapeValue != null && !shapelayer.shapeSettings.autoFill) {
                                        if (((shapelayer.legendSettings != null && shapelayer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive) || shapelayer.shapeSettings.enableGradient) && shapelayer.shapeSettings.colorMappings.rangeColorMapping != null) {
                                            obj["legendrect"] = shapelayer._updateLegendRange(shapeValue, shapelayer, shape);
                                            var shapeColor = shapelayer.shapeSettings.fill;
                                            if (obj["legendrect"] != undefined) {
                                                shapeColor = obj["legendrect"].color;
                                            }
                                            if (_isSVG) {
                                                shape.setAttribute("fill", shapeColor);
                                            }
                                            else {
                                                shape.fillcolor = shapeColor;
                                            }
                                        } else {
                                            shapelayer._fillColors(shapeValue, shapelayer.shapeSettings.colorMappings, shape);
                                        }
                                    }
                                }
                                else if (!shapelayer.shapeSettings.autoFill) {
                                    if (_isSVG) {
                                        shape.setAttribute("fill", shapelayer.shapeSettings.fill);
                                    }
                                    else {
                                        shape.fillcolor = shapelayer.shapeSettings.fill;
                                        shape.strokecolor = shapelayer.shapeSettings.stroke;
                                    }
                                }
                                if (shapelayer.bubbleSettings.showBubble) {
                                    if (shapelayer.bubbleSettings != null && shapelayer.bubbleSettings.valuePath != null) {
                                        if (_isSVG) {
                                            var circle = document.createElementNS(proxyControl._svgns, "circle");
                                        }
                                        else {
                                            var bubbleID = "bubble_" + id;
                                            var bubbleHtmlString = '<v:oval class="mapBubble" id=' + bubbleID + ' display="block" style="position:absolute;top: ' + 0 + 'px;left:' + 0 + 'px;width:100px;height:100px;stroke-width:' + 0 + 'px;"><v:fill opacity="0.9"/></v:oval>';
                                            this._bubblegroup.innerHTML = this._bubblegroup.innerHTML + bubbleHtmlString;
                                            var circle = document.getElementById("bubble_" + id);
                                        }

                                        var bubbleValue = proxyControl._reflection(item, shapelayer.bubbleSettings.valuePath);
                                        var bubblecolorValue = proxyControl._reflection(item, shapelayer.bubbleSettings.colorValuePath);
                                        if (shapelayer.bubbleSettings.colorMappings != null) {
                                            shapelayer._fillColors(bubblecolorValue, shapelayer.bubbleSettings.colorMappings, circle);
                                        }
                                        else {
                                            if (_isSVG) {
                                                circle.setAttribute("fill", shapelayer.bubbleSettings.color);
                                            }
                                            else {
                                                circle.strokecolor = shapelayer.bubbleSettings.color;
                                                circle.fillcolor = shapelayer.bubbleSettings.color;
                                            }
                                        }
                                        var radius = proxyControl._getRatioOfBubble(shapelayer.bubbleSettings.minValue, shapelayer.bubbleSettings.maxValue, bubbleValue, minValue, maxValue);
                                        if (_isSVG) {
                                            $(circle).attr({
                                                "cx": bounds.x, "cy": bounds.y,
                                                "fill-opacity": shapelayer.bubbleSettings.bubbleOpacity, "r": radius, "class": "mapBubble",
                                            });
                                            if (proxyControl.enableAnimation()&& !this._isTileMap) {
                                                $(circle).css("display", "none");
                                            }
                                        }
                                        else {
                                            $(circle).css({
                                                "height": +2 * radius + "px",
                                                "width": +2 * radius + "px"
                                            });
                                        }
                                        if (shapelayer.bubbleSettings.showTooltip == true) {
                                            var tooltipTemplateDiv = $("<div class='bubbleToolTip'  style='position:absolute;display:none;z-index:9999'/>");
                                            var template_ID = null;
                                            if (shapelayer.bubbleSettings.tooltipTemplate != null) {
                                                template_ID = shapelayer.bubbleSettings.tooltipTemplate;
                                            } else {
                                                $(tooltipTemplateDiv).append('<div class="bubbleToolTip"  style="margin-left:10px;margin-top:-25px;"><div class="defaultToolTip"><p style="margin-top:-4px"><label  style="color:rgb(27, 20, 20);font-size:14px;font-weight:normal;font-family:Segoe UI">' + bubbleValue + '</label></p></div></div>');
                                            }
                                            $(circle).mouseenter({ htmlobj: tooltipTemplateDiv, templateID: template_ID, itemsrc: item }, proxyControl._bubbleEnterFunction);
                                            $(circle).mousemove({ htmlobj: tooltipTemplateDiv }, proxyControl._bubbleOverFunction);
                                            $(circle).mouseleave({ htmlobj: tooltipTemplateDiv }, proxyControl._bubbleleaveFunction);
                                        } else {
                                            $(circle).css("pointer-events", "none");
                                        }
                                        if (_isSVG) {
                                            proxySVG.appendChild(circle);
                                            layer._bubbles.push(circle);
                                        }
                                        else {
                                            layer._bubbles.push(circle);
                                        }
                                    }
                                }
                                obj["data"] = item;
                        }
                    }
                   var labelElement;
                   if (layer.labelSettings != null && layer.labelSettings.showLabels && layer.labelSettings.labelPath != null && shapelayer.geometryType != ej.datavisualization.Map.GeometryType.Normal) {
                        var labelValue = proxyControl._reflection(ValueObject, layer.labelSettings.labelPath);
                        if (labelValue != null) {
                            if (bounds == null) {
                               //bounds = (shape);
                            }
                            labelElement = $("<div class='labelStyle'></div>");                            
                            $(labelElement).css({ "pointer-events": "none", "position": "absolute" });
                            labelElement[0].innerHTML = labelValue;
                            this._templateDiv.append(labelElement);
                            if (layer.legendSettings.showLegend && layer.legendSettings.dockOnMap && layer.legendSettings.dockPosition == "top") {
                                $(this._templateDiv).css({ "margin-top": layer.legendSettings.height });
                            }
                            else if (layer.legendSettings.showLegend && layer.legendSettings.dockOnMap && layer.legendSettings.dockPosition == "left")
                            {
                                $(this._templateDiv).css({ "margin-left": layer.legendSettings.width });
                            }
                            $(labelElement).css({ "left": bounds.x, "top": bounds.y});
                            proxyControl._off($(labelElement), ej.eventType.mouseUp, proxyControl._polyClickFunction);
                            proxyControl._on($(labelElement), ej.eventType.mouseUp, { Param1: null, Param2: layer, Param3: shape }, proxyControl._polyClickFunction);
							proxyControl._off($(labelElement), ej.eventType.mouseLeave, proxyControl._polyLeaveFunction);
                            proxyControl._on($(labelElement), ej.eventType.mouseLeave, { Param1: layer, Param2: obj,map:this }, proxyControl._polyLeaveFunction);
							labelElement[0].setAttribute("nodeValue", shape.getAttribute("fill"));
                            layer._labelCollection.push(labelElement);
                            layer._labelBounds.push(bounds);
                            layer._labelData.push(labelValue);

                        }
                    }
					obj["shapeIndex"]=dataIndex;
                    obj["shape"] = shape;
                    obj["shapeData"] = layer._polygonData[dataIndex];
                    proxyControl._off($(labelElement), ej.eventType.mouseMove, proxyControl._polyMoveFunction);
                    proxyControl._on($(labelElement), ej.eventType.mouseMove, { Param1: shapelayer, Param2: obj }, proxyControl._polyMoveFunction);
                    if (shape != null) {
                        var shapefill = null; 
                        if (_isSVG) {
                            shapefill = shape.getAttribute("fill");
                            if (shapefill == "undefined")
                                shapefill = layer.shapeSettings.fill;
                            shape.setAttribute("nodeValue", shapefill);
                        }
                        else {
                            shapefill = shape.fillcolor.value;
                            if (shapefill == "undefined")
                                shapefill = layer.shapeSettings.fill;
                            shape.style.behavior = shapefill;
                        }
                    }
                    if (proxyControl.model.zoomSettings.enableZoomOnSelection) {
                        $(shape).hover(function() {
                            $(this).css('cursor', 'pointer');
                        }, function() {
                            $(this).css('cursor', 'auto');
                        });
					}
                    // bindtouches
					layer._mapShapes.push(obj);
					this._off($(shape), "mouseenter touchmove", proxyControl._polyEnterFunction);
					this._on($(shape), "mouseenter touchmove", { Param1: shapelayer, Param2: obj, map: proxyControl }, proxyControl._polyEnterFunction);
					this._off($(shape), touchStartEvent, proxyControl._polyMouseDown);
					this._on($(shape), touchStartEvent, { Param1: obj, Param2: shapelayer }, proxyControl._polyMouseDown);
					this._off($(shape), touchEndEvent, proxyControl._polyClickFunction);
					this._on($(shape), touchEndEvent, { Param1: obj, Param2: shapelayer, Param3: shape }, proxyControl._polyClickFunction);
					this._off($(shape), touchMoveEvent, proxyControl._polyMoveFunction);
					this._on($(shape), touchMoveEvent, { Param1: shapelayer, Param2: obj, Param3: shape }, proxyControl._polyMoveFunction);
					this._off($(shape), touchCancelEvent, proxyControl._polyLeaveFunction);
					this._on($(shape), touchCancelEvent, { Param1: shapelayer, Param2: obj, map: this }, proxyControl._polyLeaveFunction);
					this._off($(shape), touchEndEvent, proxyControl._polyUpFunction);
					this._on($(shape), touchEndEvent, { Param1: obj, Param2: shapelayer, Param3: shape }, proxyControl._polyUpFunction);
                }
            }

            if (shapelayer._isBaseLayer && shapelayer.geometryType == ej.datavisualization.Map.GeometryType.Normal && shapelayer.labelSettings.showLabels) {

                shapelayer._generateLabels(this);
                shapelayer._labelSizeCalculation(this);
                this._applyTransform(this._scale, this._translatePoint);
            }           

        },


        isTouch: function (evt) {
            var event = evt.originalEvent ? evt.originalEvent : evt;
            if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        },

        validateBubblePosition: function (polygon, midpoint, bubblerad) {
            var leftPoints = [], rightPoints = [];
			 if (polygon == null)
            {
                polygon = [];
                polygon.push(midpoint);
            }
            if (!this.isPointInPolygon(polygon, midpoint, true)) {
                var previouspoint = 0;
                for (var j = 0; j < polygon.length; j++) {
                    var point = { x: (polygon[j].x + this._translatePoint.x) * this._scale, y: (polygon[j].y + this._translatePoint.y) * this._scale };
                    if ((point.y < midpoint.y && previouspoint.y >= midpoint.y) || (previouspoint.y < midpoint.y && point.y >= midpoint.y)) {
                        if (point.x < midpoint.x)
                            leftPoints.push(point.x);
                        else
                            rightPoints.push(point.x);
                    }
                    previouspoint = point;
                }

                if (!leftPoints.length > 0 || !rightPoints.length > 0) {
                    if (leftPoints.length > 0) {
                        var j = midpoint.x + bubblerad;
                        while (!this.isPointInPolygon(polygon, { x: j - 2, y: midpoint.y }, true)) {
                            j = j - 2;
                        }
                        midpoint.x = parseFloat(j - 2 - bubblerad);
                    }
                    if (rightPoints.length > 0) {
                        var j = midpoint.x - bubblerad;
                        while (!this.isPointInPolygon(polygon, { x: j + 2, y: midpoint.y }, true)) {
                            j = j + 2;
                        }
                        midpoint.x = parseFloat(j + 2 + bubblerad);
                    }
                }
            }
            return midpoint;
        },

        isPointInPolygon: function (polygon, point, needTranslate) {
            var insidePolygon = false;
            var j = 0;
            for (var i = 0; i < polygon.length; i++) {
                var currentPoint = { x: polygon[i].x, y: polygon[i].y };
                var previousPoint = { x: polygon[j].x, y: polygon[j].y };

                if (needTranslate) {
                    currentPoint = { x: (polygon[i].x + this._translatePoint.x) * this._scale, y: (polygon[i].y + this._translatePoint.y) * this._scale };
                    previousPoint = { x: (polygon[j].x + this._translatePoint.x) * this._scale, y: (polygon[j].y + this._translatePoint.y) * this._scale };
                }

                var pointYDiff = point.y - currentPoint.y;
                var previousPointYDiff = previousPoint.y - currentPoint.y;
                var previousPointXDiff = previousPoint.x - currentPoint.x;

                if ((currentPoint.y < point.y && previousPoint.y >= point.y) || (previousPoint.y < point.y && currentPoint.y >= point.y)) {
                    if ((currentPoint.x + (pointYDiff / previousPointYDiff) * previousPointXDiff) < point.x) {
                        insidePolygon = true;
                    }
                }
                j = i;
            }
            return insidePolygon;
        },

        dragDown: function (event) {
                                  
            var map = event.data.map;
            var layer = map.model.layers[0];

            var mapArea = this._mapContainer;

            if (event.type == "mousedown")
            {
                map._startPoint = { x: event.pageX - mapArea[0].offsetLeft, y: event.pageY - mapArea[0].offsetTop };
                map._stopPoint = { x: event.pageX - mapArea[0].offsetLeft, y: event.pageY - mapArea[0].offsetTop };
            }
            else if (event.type == "touchstart") {
                map._startPoint = { x: event.originalEvent.changedTouches[0].pageX - mapArea[0].offsetLeft, y: event.originalEvent.changedTouches[0].pageY - mapArea[0].offsetTop };
                map._stopPoint = { x: event.originalEvent.changedTouches[0].pageX - mapArea[0].offsetLeft, y: event.originalEvent.changedTouches[0].pageY - mapArea[0].offsetTop };
            }
            else if (event.type == "MSPointerDown") {
                map._startPoint = { x: event.originalEvent.pageX - mapArea[0].offsetLeft, y: event.originalEvent.pageY - mapArea[0].offsetTop };
                map._stopPoint = { x: event.originalEvent.pageX - mapArea[0].offsetLeft, y: event.originalEvent.pageY - mapArea[0].offsetTop };
            }
            map.mouseClickable = true;

            if (map.model.draggingOnSelection) {

                if (layer._prevSelectedShapes.length > 0) {

                    for (var i = 0; i < layer._prevSelectedShapes.length; i++) {                                               
                        layer._prevSelectedShapes[i].setAttribute("class", "mapShape");
                        if (_isSVG) {                            
                            layer._prevSelectedShapes[i].setAttribute("fill", layer._prevSelectedShapes[i].getAttribute("nodeValue"));
                            layer._prevSelectedShapes[i].setAttribute("stroke", layer.shapeSettings.stroke);
                            layer._prevSelectedShapes[i].setAttribute("stroke-width", layer.shapeSettings.strokeThickness / this._scale);
                        }
                        else {
                            layer.fillcolor = layer._prevSelectedShapes[i].getAttribute("nodeValue");
                            layer.strokecolor = layer.shapeSettings.stroke
                            layer.strokeweight = layer.shapeSettings.strokeThickness / this._scale;
                        }
                    }
                    layer._prevSelectedShapes = [];
                }
            }
        },

        dragMove: function (event) {
            
            var map = event.data.map;
            var layer = map.model.layers[0];
            var width; var height;

            var mapArea = this._mapContainer;

            if (map.model.draggingOnSelection) {

                if (map.mouseClickable) {                    
                    map.ispanning = false;


                    if (event.type == "mousemove")
                        map._stopPoint = { x: event.pageX - mapArea[0].offsetLeft, y: event.pageY - mapArea[0].offsetTop };
                    else if (event.type == "touchmove")
                        map._stopPoint = { x: event.originalEvent.changedTouches[0].pageX - mapArea[0].offsetLeft, y: event.originalEvent.changedTouches[0].pageY - mapArea[0].offsetTop };
                    else if (event.type == "MSPointerMove")
                        map._stopPoint = { x: event.originalEvent.pageX - mapArea[0].offsetLeft, y: event.originalEvent.pageY - mapArea[0].offsetTop };
                    
                    $('.e-mapDragSelection').remove();
                    var div = $('<div class = "e-mapDragSelection"></div>');
                    
                    width = Math.abs(map._stopPoint.x - map._startPoint.x),
                    height = Math.abs(map._stopPoint.y - map._startPoint.y);

                    $(div).css({ "top": Math.min(map._startPoint.y, map._stopPoint.y), "left": Math.min(map._startPoint.x, map._stopPoint.x), width: width, height: height,  position: "absolute", "z-index": 100 });
                    $(div).appendTo("#maps");
                }
            }
        },

        dragUp: function (event) {        
            var map = event.data.map;
            var width = Math.abs(map._stopPoint.x - map._startPoint.x);
            var height = Math.abs(map._stopPoint.y - map._startPoint.y);
            var layer = map.model.layers[0];
            var mapArea = this._mapContainer;
        
            if (map.model.draggingOnSelection) {
        
                $('.e-mapDragSelection').remove();
                $(".e-mapDragSelection").css({
                    "display": "none"
                });
                map.mouseClickable = false;

                for (var i = 0; i < map.model.layers[0]._mapShapes.length; i++) {
                    var shape = map.model.layers[0]._mapShapes[i].shape;
                    var rect = shape.getBoundingClientRect();
                    if (!(rect.left - mapArea[0].offsetLeft + rect.width < Math.min(map._startPoint.x, map._stopPoint.x) || Math.min(map._startPoint.x, map._stopPoint.x) + width < rect.left - mapArea[0].offsetLeft ||
                           rect.top - mapArea[0].offsetTop + rect.height < Math.min(map._startPoint.y, map._stopPoint.y) || Math.min(map._startPoint.y, map._stopPoint.y) + height < rect.top - mapArea[0].offsetTop)) {

                        if (!map.model.layers[0]._contains(layer._prevSelectedShapes, shape))

                            layer._prevSelectedShapes.push(shape);
                    }
                }


                for (var i = 0; i < layer._prevSelectedShapes.length; i++) {
                    var shape = layer._prevSelectedShapes[i];
                    var rect = shape.getBoundingClientRect();
                    shape.setAttribute("class", "e-mapSelectedShape mapShape");
                    if (_isSVG) {
                        shape.setAttribute("fill", layer.shapeSettings.selectionColor);
                        shape.setAttribute("stroke", layer.shapeSettings.selectionStroke);
                        shape.setAttribute("stroke-width", (layer.shapeSettings.selectionStrokeWidth / map._scale));
                    }
                }                
            }           
        },

        isIntersectBubbles: function () {
            var listofBounds = [];
            for (var k = 0; k < this.model.layers.length; k++) {
                var layer = this.model.layers[k];
                Array.prototype.push.apply(listofBounds, layer._bubbleCollection);
                for (var i = 0; i < layer.subLayers.length; i++) {
                    Array.prototype.push.apply(listofBounds, layer.subLayers[i]._bubbleCollection);
                }
            }

            for (var i = 0; i < listofBounds.length; i++) {
                var x = listofBounds[i].getAttribute('cx');
                var y = listofBounds[i].getAttribute('cy');
                var r = listofBounds[i].getAttribute('r');
                for (var j = i + 1; j < listofBounds.length; j++) {

                    var x1 = listofBounds[j].getAttribute('cx');
                    var y1 = listofBounds[j].getAttribute('cy');
                    var r1 = listofBounds[j].getAttribute('r');
                    var distBubble = Math.sqrt(((x - x1) * (x - x1)) + ((y - y1) * (y - y1)));
                    var rad = parseFloat(r) + parseFloat(r1);
                   
                    if (distBubble <= rad) {
                        return true;
                    }
                }
            }
            return false;
        },
       
        _zooming: function (delta, e) {
            var position = this._getCurrentPoint(e);
            if (delta >= 120) {
                this._zoomingIn(position.x, position.y, e);
            }
            else {
                this._zoomingOut(position.x, position.y, e);
            }
        },

        _zoomingIn: function (x, y, event, isAnimate) {
            var map = this;
            if (map.model.zoomSettings.enableZoom && map._zoomLevel() >= map._minZoom() && map._zoomLevel() <= map._maxZoom()) {
                var scal = map._scale;
                var position = { x: x, y: y };
                map._prevScale = scal;
                if (!this._isTileMap) {
                    map._prevPoint = { x: map._translatePoint.x, y: map._translatePoint.y };
                    map._translatePoint.x -= (map._width / map._scale - map._width / (map._scale + map._zoomFactor())) / (map._width / x);
                    map._translatePoint.y -= (map._height / map._scale - map._height / (map._scale + map._zoomFactor())) / (map._height / y);
                    map._scale = scal + map._zoomFactor();
                    map.model.zoomSettings.level = map._zoomLevel() + map._zoomFactor();
                    map._zoomLevel(map._zoomLevel() + map._zoomFactor());
                }
                else {
                    this._tileZoom(map._zoomLevel() - map._zoomFactor(), map._zoomLevel(), position);
                    var prevLevel = map._zoomLevel();
                    map.model.zoomSettings.level = map._zoomLevel() + map._zoomFactor();
                    map._zoomLevel(map._zoomLevel() + map._zoomFactor());
                    this._generateTiles(this._zoomLevel());
                    map._translatePoint.x = (map._tileTranslatePoint.x - (0.5 * Math.pow(2, prevLevel))) / (Math.pow(2, prevLevel));
                    map._translatePoint.y = (map._tileTranslatePoint.y - (0.5 * Math.pow(2, prevLevel))) / (Math.pow(2, prevLevel));
                    map._scale = (Math.pow(2, prevLevel));
                }
                
                map._trigger("zoomedIn", { originalEvent: event, zoomLevel: map._zoomLevel() });
                map._applyTransform(map._scale, map._translatePoint);
                map._refrshLayers();
                map._resizeShape();               
            
                map._updateSliderValue();
            }
        },

        _zoomingOut: function (x, y, event, isAnimate) {
            var map = this;
            if (map.model.zoomSettings.enableZoom) {
                if (map._zoomLevel() > this._minZoom()) {

                    var scal = map._scale;
                    var position = { x: x, y: y };
                    map._prevScale = scal;
                    if (!map._isTileMap) {                       
                       if (map._scale > 1) {		
                        map._prevPoint = { x: map._translatePoint.x, y: map._translatePoint.y };
                        map._translatePoint.x -= (map._width / map._scale - map._width / (map._scale - map._zoomFactor())) / (map._width / x);
                        map._translatePoint.y -= (map._height / map._scale - map._height / (map._scale - map._zoomFactor())) / (map._height / y);
                        map._scale = map._scale - map._zoomFactor();
                        map.model.zoomSettings.level = map._zoomLevel() - map._zoomFactor();
                        map._zoomLevel(map._zoomLevel() - map._zoomFactor());
                        map._scale = map._zoomLevel();
                        }
				    }
                    else {
                        map._tileZoom(map._zoomLevel() + map._zoomFactor(), map._zoomLevel(), position);
                        var prevLevel = map._zoomLevel();
                        map.model.zoomSettings.level = map._zoomLevel() - map._zoomFactor();
                        map._zoomLevel(map._zoomLevel() - map._zoomFactor());
                       
                        map._generateTiles(map._zoomLevel());
                        map._translatePoint.x = (map._tileTranslatePoint.x - (0.5 * Math.pow(2, map._zoomLevel() - map._zoomFactor()))) / (Math.pow(2, map._zoomLevel() - map._zoomFactor()));
                        map._translatePoint.y = (map._tileTranslatePoint.y - (0.5 * Math.pow(2, map._zoomLevel() - map._zoomFactor()))) / (Math.pow(2, map._zoomLevel() - map._zoomFactor()));
                        map._scale = (Math.pow(2, map._zoomLevel() - map._zoomFactor()));
                    }                    
                    if (map._zoomLevel() < map._minZoom()) {
                        map.model.zoomSettings.level = map._minZoom();
                        map._zoomLevel(map._minZoom());
                        map.zoom(map._zoomLevel());
                    }
                   
                    map._applyTransform(map._scale, map._translatePoint);
                    map._refrshLayers();
                    map._resizeShape();                                  

                    map._updateSliderValue();
                }
                else {                   
                    map.zoom(map._minZoom(), false);
                }
                map._trigger("zoomedOut", { originalEvent: event, zoomLevel: map._zoomLevel() });
            }
        },

        _getRatioOfBubble: function (min, max, value, minValue, maxValue) {
            var percent = (100 / (maxValue - minValue)) * (value - minValue);
            var bubbleRadius = (((parseFloat(max) - parseFloat(min)) / 100) * percent) + parseFloat(min);
			if(maxValue == minValue)
				bubbleRadius = (((parseFloat(max) - parseFloat(min)) / 100)) + parseFloat(min);
			
            return bubbleRadius;
        },

        _reflection: function (Source, path) {
            var ShapeValues = Source;
            if (path != null && Source != null) {
                var parts = path.split(".");
                var i = 0;
                parts.push(path);
                for (; i < parts.length; i++) {                    
                    if (Source != undefined && ShapeValues != null) {
                        var hasProperty = ShapeValues.hasOwnProperty(parts[i]);
                        if (hasProperty) {
                            $.each(ShapeValues, function (prop, propval) {
                                if (prop == parts[i]) {
                                    ShapeValues = propval;
                                    return false;
                                }

                            });
                        }
                    }
                }
                return ShapeValues;
            }
            else {
                return null;
            }

        },
		
		clearShapeSelection:function(){		
		 var index = this.baseMapIndex();
            this.model.layers[index]._clearShapeWidth(this._scale);
            for (var key = 0; key < this.model.layers[index].subLayers.length; key++) {
                (this.model.layers[index].subLayers[key])._clearShapeWidth(this._scale);
            }
		},
        shapeSelectionOnResize: function () {
        var index = this.baseMapIndex();
          this.model.layers[index]._shapeSelection();
            for (var key = 0; key < this.model.layers[index].subLayers.length; key++) {
                (this.model.layers[index].subLayers[key])._shapeSelection();
            }
        },

       refreshMarkers: function () {
          var markerElements = document.getElementsByClassName("mapMarker");
        
         for(var index = markerElements.length-1; index >= 0; index--)
         {
          markerElements[index].parentNode.removeChild(markerElements[index]);
         }
         
            var index = this.baseMapIndex();
            this.model.layers[index]._generateMarkerForLayers(this);
            for (var key = 0; key < this.model.layers[index].subLayers.length; key++) {
                (this.model.layers[index].subLayers[key])._generateMarkerForLayers(this);
            }
            this._refrshLayers();
        },

        _generateTooltipForLayers: function (layer) {
             if (layer.showTooltip) {
			   if (document.documentMode == 8){
					var tooltip = document.querySelectorAll("shapeToolTip");
				}
				else{
					var tooltip = document.getElementsByClassName("shapeToolTip");
				}
                if (tooltip != null && tooltip.length == 0) {
                    var tooltip_templateDiv = $("<div class='shapeToolTip' style='display:none;position:absolute;z-index:1000;pointer-events:none;'></div>");
                    $(document.body).append(tooltip_templateDiv);
                    layer._tooltipElement = tooltip_templateDiv;
                }
                else
                {
                    layer._tooltipElement = tooltip[0];
                }
                if (layer.tooltipTemplate == null) {
                    var path = layer.shapeSettings.valuePath;
                    if (path != null) {
                        layer.tooltipTemplate = 'defaultTooltip';                      
                        this._mapContainer.append($('<div  id="defaultTooltip" style="display:none;"><div style="margin-left:10px;margin-top:-25px;"><div class="defaultToolTip"><p style="margin-top:-4px"><label  style="color:rgb(27, 20, 20);font-size:14px;font-weight:normal;font-family:Segoe UI">{{:#data["' + path + '"]}}</label></p></div></div></div>'));
                    }
                }
            }                
        },
       
        _orderByNameAscending: function (a, b) {
            if (a.Range == b.Range) {
                return 0;
            } else if (a.Range > b.Range) {
                return 1;
            }
            return -1;
        },

        _resizingContainer: function () {            
            this._scale = this._isTileMap ? Math.pow(2, this._zoomLevel() - 1) : 1;
            if (this._isTileMap) {
                this._translatePoint.x = (this._tileTranslatePoint.x - (0.5 * Math.pow(2, this._zoomLevel() - this._zoomFactor()))) / (Math.pow(2, this._zoomLevel() - this._zoomFactor()));
                this._translatePoint.y = (this._tileTranslatePoint.y - (0.5 * Math.pow(2, this._zoomLevel() - this._zoomFactor()))) / (Math.pow(2, this._zoomLevel() - this._zoomFactor()));
            }
            else {                     
                this._translatePoint.x = this._tileTranslatePoint.x / this._scale;
                this._translatePoint.y = this._tileTranslatePoint.y / this._scale;
            }           
            this._applyTransform(this._scale, this._translatePoint);
            if (this._zoomLevel() > 1) {
                this._scale = this._isTileMap ? Math.pow(2, this._zoomLevel() - this._zoomFactor()) : this._zoomLevel();
                this._applyTransform(this._scale, this._translatePoint);
            }
            this._baseScale = 1;
            this._baseTranslatePoint = { x: (this._translatePoint.x * 2), y: (this._translatePoint.y * 2) };
           
        },

        _calculateMarginConditions: function () {
            var trans = this._calculateMinMax();
            if (this._translatePoint.y> trans.maxY) {
                this._translatePoint.y = trans.maxY;
            }
            else if (this._translatePoint.y < trans.minY) {
                this._translatePoint.y = trans.minY;
            }
            if (this._translatePoint.x > trans.maxX) {
                this._translatePoint.x = trans.maxX;
            }
            else if (this._translatePoint.x < trans.minX) {
                this._translatePoint.x = trans.minX;
            }
        },

        _calculateMinMax: function () {           
            var bounds= this._groupBorder;            
            var maximumTransX, maximumTransY, minimumTransX, minimumTransY;
            if (this._containerHeight * this._scale <= this._height) {
                maximumTransY = (this._height - this._containerHeight * this._scale) / (2 * this._scale) - bounds.y;
                minimumTransY = (this._height - this._containerHeight * this._scale) / (2 * this._scale) - bounds.y;
            } else {
                maximumTransY = -bounds.y + 1;
                minimumTransY = (this._height - this._containerHeight * this._scale) / (this._scale) - bounds.y - 1;
            }
            if (this._containerWidth * this._scale <= this._width) {
                maximumTransX = (this._width - this._containerWidth * this._scale) / (2 * this._scale)- bounds.x;
                minimumTransX = (this._width - this._containerWidth * this._scale) / (2 * this._scale) - bounds.x;
            } else {
                maximumTransX = -bounds.x + 1;
                minimumTransX = (this._width - this._containerWidth * this._scale) / (this._scale) - bounds.x - 1;
            }
            return { minX: minimumTransX, maxX: maximumTransX, minY: minimumTransY, maxY: maximumTransY };
        },
      
        _findMidPointofPoylgon: function (points) {
          if(points.length>0){
            var min = 0;           
            var max = points.length;
            var initialPoint = points[0];
            var minX=initialPoint.x,maxX = initialPoint.x;
            var minY = initialPoint.y, maxY = initialPoint.y;
            var startX,startY,startX1,startY1,sum=0,xSum=0,ySum=0;
           
            for (var i = min; i <= max - 1; i++) {
                var prevPoint = points[i];
                startX = prevPoint.x;
                startY = prevPoint.y;
                if (i == max - 1) {
                    startX1 = initialPoint.x;
                    startY1 = initialPoint.y;
                }
                else {
                    var nextPoint = points[i + 1];
                    startX1 = nextPoint.x;
                    startY1 = nextPoint.y;
                }
                sum = sum + Math.abs(((startX * startY1)) - (startX1 * startY));
                xSum = xSum + Math.abs(((startX + startX1) * (((startX * startY1) - (startX1 * startY)))));
                ySum = ySum + Math.abs(((startY + startY1) * (((startX * startY1) - (startX1 * startY)))));

            }
            sum = 0.5 * sum;
            xSum = (1 / (4 * sum)) * xSum;
            ySum = (1 / (4 * sum)) * ySum;

            /* Code for finding nearest points in polygon related to midPoint*/
            var _rightMinPoint = { x: 0, y: 0 };
            var _rightMaxPoint = { x: 0, y: 0 };
            var _leftMinPoint = { x: 0, y: 0 };
            var _leftMaxPoint = { x: 0, y: 0 };

            for (var i = min; i <= max - 1; i++) {
                var point = points[i];
                if (point.x > xSum) {
                    if (point.y < ySum && ySum - point.y < ySum - _rightMinPoint.y)
                        _rightMinPoint = { x: point.x, y: point.y };
                    else if (point.y > ySum && (_rightMaxPoint.y == 0 || point.y - ySum < _rightMaxPoint.y - ySum))
                        _rightMaxPoint = { x: point.x, y: point.y };
                }
                else {
                    if (point.y < ySum && ySum - point.y < ySum - _leftMinPoint.y)
                        _leftMinPoint = { x: point.x, y: point.y };
                    else if (point.y > ySum && (_leftMaxPoint.y == 0 || point.y - ySum < _leftMaxPoint.y - ySum))
                        _leftMaxPoint = { x: point.x, y: point.y };
                }
            }

            return { x: xSum, y: ySum, rightMin: _rightMinPoint, rightMax: _rightMaxPoint, leftMin: _leftMinPoint, leftMax: _leftMaxPoint, points:points };             
}        
        },
        _convertPointToLatLong: function (pixelX, pixelY, bounds, factor){
        
            var Size;
            if (bounds == null) { bounds=[[-180,-85],[180,85]] }
            if (this._isTileMap) {
                Size = Math.pow(2, 1) * 256;
            }
            else {
                if(factor == null)
                    Size = Math.min(this._height, this._width);
                else
                    Size = Math.min(this._height, this._width)*factor;
            }

            var x=(Math.min(pixelX,0,Size-1)/Size)-0.5;
            var y=0.5-(Math.min(pixelY,0,Size-1)/Size);
            latitude = 90 - 360 * Math.atan(Math.exp(-y * 2 * Math.PI)) / Math.PI;
            longitude = 360 * x;
            return {x:latitude,y:longitude};
                        

        },
        _convertTileLatLongtoPointForShapes: function (lat, lng, bounds,factor) {
            var Size;
            if (bounds == null) { bounds=[[-180,-85],[180,85]] }
            if (this._isTileMap) {
                Size = Math.pow(2, 1) * 256;
            }
            else {
                if(factor == null)
                    Size = Math.min(this._height, this._width);
                else
                    Size = Math.min(this._height, this._width)*factor;
            }
           
            var x = (lng + 180) / 360;
            var sinLatitude = Math.sin(lat * Math.PI / 180);
            if (sinLatitude == -1)
                sinLatitude = -0.5;
            var y = 0.5 - Math.log((1 + sinLatitude) / (1 - sinLatitude)) / (4 * Math.PI);
            if (this._isMapCoordinates) {
                var pixelX = (Math.min(Math.max(x * Size + 0.5, 0), Size - 1));
                var pixelY = (Math.min(Math.max(y * Size + 0.5, 0), Size - 1));
            }
            else if (factor != null) {

                var pixelX = Math.abs((lng - this._mapBounds[0][0]) * factor);
                var pixelY = Math.abs((this._mapBounds[1][1] - lat ) * factor);
            }
            else {

                var pixelX = lng;
                var pixelY = lat;
            }

            
           
            return { x: pixelX, y: pixelY };
           
            
        },
     
        _convertTileLatLongtoPoint: function (lat, lng) {
            var Size = Math.pow(2, this._zoomLevel()) * 256;
            var x = (lng + 180) / 360; 
            var sinLatitude = Math.sin(lat * Math.PI / 180);
            var y = 0.5 - Math.log((1 + sinLatitude) / (1 - sinLatitude)) / (4 * Math.PI);
			if (this._isMapCoordinates) {
            var pixelX = (x * Size + 0.5) + this._tileTranslatePoint.x;
            var pixelY = (y * Size + 0.5) + this._tileTranslatePoint.y; 
              }
            else if (factor != null){

                var pixelX = Math.abs((lng - this._mapBounds[0][0])*factor);
                var pixelY = Math.abs((this._mapBounds[1][1] - lat)*factor);
            }
            else {

                var pixelX = lng;
                var pixelY = lat;
            }			
            return { x: pixelX, y: pixelY };
        },
      
        _convertLatLongtoPointforMarker: function (lat, lng) {
            var factor = this._getFactor();
            var point = this._convertTileLatLongtoPointForShapes(lat, lng, this._mapBounds,factor);
            return { x: (point.x + this._translatePoint.x) * this._scale, y: (point.y + this._translatePoint.y) * this._scale };

        },
     
        _animate: function (animateduration) {
            this._calculateMarginConditions();
            $(this._rootgroup).stop(true, false);
            if (this._sliderControl != null) {
                $(this._sliderControl).stop(true, false);
            }
            var map = this;
            var currentTranformation = { x: this._translatePoint.x, y: this._translatePoint .y};
            var startPoint = [this._prevPoint.x, this._prevPoint.y];
            var endPoint = [this._translatePoint.x, this._translatePoint.y];

            function slope(horizontal, vertical) {
                
                if (horizontal[0] == vertical[0]) {
                    return null;
                }
                return (vertical[1] - horizontal[1]) / (vertical[0] - horizontal[0]);
            }

            function intercept(point, slopeValue) {
                if (slopeValue === null) {
                    return point[0];
                }
                return point[1] - slopeValue * point[0];
            }

            var slopeFactor = slope(startPoint, endPoint);
            var slopeIntersection = intercept(startPoint, slopeFactor);
            var horizontalDifference= endPoint[0] - startPoint[0];
            var verticalDifference=endPoint[1] - startPoint[1];
            var scaleDifference= this._scale-this._prevScale;
            var currentScale = this._scale;
            this._updateSliderValue();
            $(this._rootgroup).animate(
                {
                    count: 10
                },
                {
                    duration: animateduration,
                    step: function(now, fx) {
                        var scaleX = map._prevScale + ((now * (scaleDifference / fx.end)));
                        var transX = startPoint[0] + (now * (horizontalDifference / fx.end)) / (scaleX / currentScale);
                        var transY;
                        if (slopeFactor == null) {
                            transY = startPoint[1] + (now * (verticalDifference / fx.end));
                        } else {
                            transY = ((slopeFactor * transX) + slopeIntersection);
                        }
                        if (_isSVG) {
                            map._rootgroup.setAttribute('transform', 'scale(' + scaleX + ') translate(' + transX + ', ' + transY + ')');
                        }
                        else {
                            map._rootgroup.coordorigin = -transX + ',' + -transY;
                            map._rootgroup.coordsize = (map._width / scaleX) + ',' + (map._height / scaleX);
                        }
                        map._translatePoint.x = transX;
                        map._translatePoint.y = transY;
                        map._scale = scaleX;
                        map._refrshLayers();
                        map._resizeShape();
                    },
                    complete: function() {
                        map._translatePoint.x = currentTranformation.x;
                        map._translatePoint.y = currentTranformation.y;
                        map._scale = currentScale;
                        this.count = 0;
                    }
                }
            );

        },

        _applyTransform: function (scale, translatePoint) {
            this._scale = scale;
            this._translatePoint = translatePoint;
           if(!this._isTileMap)
            this._calculateMarginConditions();  
             if((this._translatePoint.x !=Number.POSITIVE_INFINITY) &&(this._translatePoint.y !=Number.POSITIVE_INFINITY))
            {
            if (_isSVG) {
                this._rootgroup.setAttribute('transform', 'scale(' + this._scale + ') translate(' + this._translatePoint.x + ', ' + this._translatePoint.y + ')');
            }
            else {
                this._rootgroup.coordorigin = (-this._translatePoint.x) + ','  + (-this._translatePoint.y);
                this._rootgroup.coordsize = (this._width / scale)  + ',' + (this._height / scale);
            }
            }
        },
       
        _mouseMove: function (event) {
            if (event.type == "touchmove" && event.originalEvent.touches.length > 1) {
                this._isPinching = true;
            }
            else {
                var map = this;
                if (map.ispanning && map.enablePan()) {
                    event.preventDefault();
                    var position;
                    if (event.type == "mousemove" || event.type == "pointermove")
                        position = { x: event.pageX, y: event.pageY };
                    else if (event.type == "touchmove")
                        position = { x: event.originalEvent.changedTouches[0].pageX, y: event.originalEvent.changedTouches[0].pageY };
                    else if (event.type == "MSPointerMove")
                        position = { x: event.originalEvent.pageX, y: event.originalEvent.pageY };
                    if (this._isTileMap) {
                        var curtileX = this._tileTranslatePoint.x - (this._dragStartX - position.x);
                        var curtileY = this._tileTranslatePoint.y - (this._dragStartY - position.y);
                        this._tileTranslatePoint.x = curtileX;
                        this._tileTranslatePoint.y = curtileY;                        
                        this._generateTiles(this._zoomLevel());
                    }                    
                    var curX = map._translatePoint.x - (map._dragStartX - position.x) / map._scale;
                    var curY = map._translatePoint.y - (map._dragStartY - position.y) / map._scale;
                    if (curX != map._translatePoint.x || curY != map._translatePoint.y) {
                        map._isDragging = true;
                    }
                    this._translatePoint.x = curX;
                    this._translatePoint.y = curY;
                    map._applyTransform(map._scale, map._translatePoint);
                    map._dragStartX = position.x;
                    map._dragStartY = position.y;
                    map._refrshLayers();
                }
            }
        },
       
        _svgMouseLeave: function (event) {
            var map = this;
            map.ispanning = false;
        },
        
        _mouseWheel: function (event) {
            if (this.model.zoomSettings.enableZoom) {
                if (this.enableAnimation()) {
                    $(this._rootgroup).stop(true, false);
                }
                var e = event.originalEvent;
                var original = event;
                if (!_isSVG) {
                    e = event;
                }
                if (event.target.className != "LegendDiv" && event.target.className != "e-defaultLegendLabel") {
                    e.preventDefault ? e.preventDefault() : original.preventDefault();
                    if (_isSVG) {
                        this._zooming(event.originalEvent.wheelDelta, event.originalEvent);
                    }
                    else {
                        this._zooming(event.originalEvent.wheelDelta, e);
                    }
                }
            }
        },

        _mouseButtonUp: function (event) {

            var map = this;
            if (map.ispanning) {
                map._trigger("panned", { originalEvent: event });
            }
            map.ispanning = false;
        },
        
        _mouseUp: function (event) {
            this.ispanning = false;
            this._isDragging = false;
        },

        _mouseButtonDown: function (event) {
            this._isPinching = false;
           if (event.target.className != "e-vhandle") {         
            this._isNavigationPressed = false;
            if(this.enableAnimation()){
                $(this._rootgroup).stop(true, false);
                if (this._sliderControl != null) {
                    $(this._sliderControl).stop(true, false);
                }
			}
            if (event.type == "touchstart" && event.originalEvent.touches.length > 1)
            { }
            else {
                var position;
                if (event.type == "mousedown" || event.type == "pointerdown")
                    position = { x: event.pageX, y: event.pageY };
                else if (event.type == "touchstart")
                    position = { x: event.originalEvent.changedTouches[0].pageX, y: event.originalEvent.changedTouches[0].pageY };
                else if (event.type == "MSPointerDown")
                    position = { x: event.originalEvent.pageX, y: event.originalEvent.pageY };
                var map = this;
                if (map._scale > 1 && map.model.enablePan) {
                    event.preventDefault();
                    map.ispanning = true;
                }
                map._dragStartX = position.x;
                map._dragStartY = position.y;
            }
		}
        },

        _getCurrentPoint: function (event) {
            var map = this._mapContainer;
             var xPos = event.pageX - map.offset().left;
            var yPos = event.pageY - map.offset().top; 
            return { x: xPos, y: yPos };
        },

        _legendDoubleClick: function (event) {
           
            var node= event.target;
            while (node.parentNode != null && node.parentNode.className != "ScrollLegendDiv e-scroller e-js e-widget") {
                node = node.parentNode;
            }
            if (node.parentNode != null && node.parentNode.className == "ScrollLegendDiv e-scroller e-js e-widget") {               
                this._isNavigationPressed = true;               
            }           
        },
        
        _doubleClick: function (event) {            
            var map = this;
            var prevLevel1 = map._zoomLevel();
             map._legendDoubleClick(event);
			if (!this._isNavigationPressed && event.target.className.toString().indexOf("e-icon1") == -1) {
                var position = this._getCurrentPoint(event);               
                if (map.model.zoomSettings.enableZoom && map._zoomLevel() + map._zoomFactor() >= map._minZoom() && map._zoomLevel() + map._zoomFactor() <= map._maxZoom()) {
                    var scal = map._scale;
                    map._prevScale = scal;
                    if (!this._isTileMap) {
                        map._prevPoint = { x: map._translatePoint.x, y: map._translatePoint.y };
                        map._translatePoint.x -= (map._width / map._scale - map._width / (map._scale + map._zoomFactor())) / (map._width / position.x);
                        map._translatePoint.y -= (map._height / map._scale - map._height / (map._scale + map._zoomFactor())) / (map._height / position.y);
                        map._scale = scal + map._zoomFactor();
                        map.model.zoomSettings.level = map._zoomLevel() + map._zoomFactor();
                        map._zoomLevel(map._zoomLevel() + map._zoomFactor());
                    }
                    else {
                        this._tileZoom(map._zoomLevel() - map._zoomFactor(), map._zoomLevel(), position);
                        var prevLevel = map._zoomLevel();
                        map.model.zoomSettings.level = map._zoomLevel() + map._zoomFactor();
                        map._zoomLevel(map._zoomLevel() + map._zoomFactor());
                        this._generateTiles(this._zoomLevel());
                        map._translatePoint.x = (map._tileTranslatePoint.x - (0.5 * Math.pow(2, prevLevel))) / (Math.pow(2, prevLevel));
                        map._translatePoint.y = (map._tileTranslatePoint.y - (0.5 * Math.pow(2, prevLevel))) / (Math.pow(2, prevLevel));
                        map._scale = (Math.pow(2, prevLevel));                        
                    }
                    if (prevLevel1 < map._zoomLevel())
                    {
					     map._trigger("zoomedIn", { originalEvent: null, zoomLevel: map._zoomLevel() });
                    }
                    if (map.enableAnimation() && !this._isTileMap) {
                        map._animate(600);
                    }
                    else {
                        map._applyTransform(map._scale, map._translatePoint);
                        map._refrshLayers();
                        map._resizeShape();
                    }                 
                    map._updateSliderValue();
                }
            }
        },
       
        _tileZoom: function (prevlevel,level, position) {
            
            var map = this;
            if (level > 0 && level < 20) {
                this._tileDiv.html("");
                var prevSize = Math.pow(2, prevlevel) * 256;
                if (position == undefined) {
                    position = { x: this._width / 2, y: this._height / 2 };
                }
                var totalSize = Math.pow(2, level) * 256;
                var percentX = ((position.x - this._tileTranslatePoint.x) / prevSize) * 100;
                var percentY = ((position.y - this._tileTranslatePoint.y) / prevSize) * 100;
                var pointX = (percentX * totalSize) / 100;
                var pointY = (percentY * totalSize) / 100;
                this._tileTranslatePoint.x = position.x - pointX;
                this._tileTranslatePoint.y = position.y - pointY;
                
            }
        },          
        
        _bubbleEnterFunction: function (event) {
            if (event.data.templateID != null) {
                var tooltiphtmlString = $("#" + event.data.templateID).render(event.data.itemsrc);
                $(event.data.htmlobj).html(tooltiphtmlString);
            }
            $(document.body).append(event.data.htmlobj);
            return $(event.data.htmlobj).css("display", "block").css({ "left": (event.pageX + 8) + "px", "top": (event.pageY + 6) + "px" });
        },
        
        _bubbleleaveFunction: function (event) {
            $(event.data.htmlobj).remove();
            return $(event.data.htmlobj).css("display", "none");
        },
        
        _bubbleOverFunction: function (event) {
            return $(event.data.htmlobj).css("display", "block").css({ "left": (event.pageX + 8) + "px", "top": (event.pageY + 6) + "px" });
        },
       
        _polyEnterFunction: function (event) {
            var matched = jQuery.uaMatch(navigator.userAgent),
                layer = event.data.Param1, shape,
                isTouch = this.isTouch ? this.isTouch(event) : false;
            if (isTouch && matched.browser == 'chrome') {
                var myLocation = event.originalEvent.changedTouches[0];
                shape = document.elementFromPoint(myLocation.clientX, myLocation.clientY);
            }
            else
                shape = event.data.Param2["shape"];
            var map = event.data.map;
            var legend = jQuery.grep(layer._smartLabels, function (obj) { return obj.shape == shape });
            if (layer.enableMouseHover) {
                layer._clearShapeWidth(map._scale);
                if (layer._prevHoverdLegend != null && !layer._contains(layer._prevSelectedLegends, layer._prevHoverdLegend)) {
                    layer._prevHoverdLegend.css("background-color", _isSVG ? layer._prevHoveredShape.getAttribute("fill") : layer._prevHoveredShape.fillcolor.value);
                }
                if (_isSVG) {
                    shape.setAttribute("stroke-width", (layer.shapeSettings.highlightBorderWidth/map._scale));
                    shape.setAttribute('stroke', layer.shapeSettings.highlightStroke);
                } else {
                    shape.strokeweight = layer.shapeSettings.highlightBorderWidth;
                    shape.strokecolor = layer.shapeSettings.highlightStroke/map._scale;
                }

                 if (layer.shapeSettings.highlightColor != null) {
                    if (layer.shapeSettings.highlightColor != "transparent" && !layer._contains(layer._prevSelectedShapes, shape)) {
                        shape.setAttribute("class", "e-mapHighlightedShape mapShape");
                        if (_isSVG) {
                            if (layer.shapeSettings.highlightColor != 'none' && shape.highlightcolor==null) {
                                shape.setAttribute('fill', layer.shapeSettings.highlightColor);
                            }
                            else {
                                shape.setAttribute('fill', shape.highlightcolor);
                            }
							shape.setAttribute("stroke-width", (layer.shapeSettings.highlightBorderWidth/map._scale));
							shape.setAttribute('stroke', layer.shapeSettings.highlightStroke);
                        } else {
                            shape.fillcolor = layer.shapeSettings.highlightColor;
                        }
                    }
                    if (legend.length > 0 && !layer._contains(layer._prevSelectedLegends,legend[0].legend)) {
                        legend[0].legend[0].setAttribute("class", "e-mapHighlightedShape mapShape");
                        legend[0].legend.css("background-color", layer.shapeSettings.highlightColor);
                        layer._prevHoverdLegend = legend[0].legend;
                    }

                    layer._prevHoveredShape = shape;
                }

                if (layer.legendSettings!= null && layer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive && layer.shapeSettings.colorMappings!=null && layer.shapeSettings.colorMappings.rangeColorMapping != null
                     && !layer.shapeSettings.autoFill && (layer.legendSettings.showLegend == undefined || layer.legendSettings.showLegend)) {
                    for (var i = 0; i < layer._mapShapes.length; i++) {
                        var mapshape = layer._mapShapes[i].shape;
                        if (mapshape == shape) {
                            var mappings = null;
                            if (layer.shapeSettings.colorMappings.rangeColorMapping != undefined) {
                                mappings = layer.shapeSettings.colorMappings.rangeColorMapping;
                            }
                            var _legendwidth = layer.legendSettings.width;
                            if (layer.legendSettings.width == undefined)
                                _legendwidth = 150;

                            var rectwidth = (_legendwidth / mappings.length) / 10;
                            if (layer._mapShapes[i].legendrect != null) {
                                var rectPosition = layer._mapShapes[i].legendrect.marginLeft;
                                $(layer._interactiveArrow).css({ "margin-left": rectPosition + Math.ceil(rectwidth) - layer._interactiveArrow.width() / 2, "display": "block" });
                                break;
                            }
                        }
                    }
                }
                map._trigger("mouseover", { originalEvent: event.data.Param2 });
            }
                                    
        },

        _updateShapeRect:function(layer) {

            for (var index = 0; index < layer._mapShapes.length; index++) {
                var obj = layer._mapShapes[index];
                if (obj.left == null) {
                    obj["left"] = layer._mapShapes[index].shape.getBoundingClientRect().left;
                    obj["right"] = layer._mapShapes[index].shape.getBoundingClientRect().right;
                    obj["top"] = layer._mapShapes[index].shape.getBoundingClientRect().top;
                    obj["bottom"] = layer._mapShapes[index].shape.getBoundingClientRect().bottom;
                    layer._mapShapes[index] = obj;
                }
            }
        },
        
        _polyUpFunction: function (event) {
            var layer = event.data.Param2,
                shape = event.data.Param3,
                isTouch = this.isTouch(event);
            if (isTouch)
                event.stopImmediatePropagation();
            if (this.model.zoomSettings.enableZoomOnSelection && !this._isDragging && !this._isTileMap && !this._isPinching) {
                    if (_isSVG) {
                        var bounds = shape.getBBox();
                        this._zoomOnSelection(bounds);
                    } else {                        
                            this._updateShapeRect(layer);

                        for (var index = 0; index < layer._mapShapes.length; index++) {
                            if (shape == layer._mapShapes[index].shape) {
                                var left = layer._mapShapes[index].left;
                                var top = layer._mapShapes[index].top;
                                var right = layer._mapShapes[index].right;
                                var bottom = layer._mapShapes[index].bottom;
                                var bound = { x: left, y: top, width: right - left, height: bottom - top };
                                this._zoomOnSelection(bound);
                                break;
                            }
                        }
                    }
                    this.ispanning = false;
            }
            var element = layer._tooltipElement;
            if (element != null) {
                $(element).delay(200).queue( function(next){ 
						$(this).css('display','none'); 
						next();
						
				});
            }
            if (isTouch && layer.showTooltip) {
                var currentXY = this.getEventXY(event),
                 map = this, cachedXY = map.model.cachedXY,
                 swipediffer = 10, differX, differY;
                differX = Math.abs(cachedXY.x - currentXY.X);
                differY = Math.abs(cachedXY.y - currentXY.Y);
                if (differX < swipediffer && differY < swipediffer) {
                    this.touchEnd = true;
                    var dataParam1 = event.data.Param1;
                    event.data.Param1 = layer;
                    event.data.Param2 = dataParam1;
                    map._polyMoveFunction(event);
                    event.data.Param1 = dataParam1;
                    event.data.Param2 = layer;
                    map.tooltipElement = layer._tooltipElement[0];
                    $(map.tooltipElement).stop(true, true);
                    map._timeOut = map._timeOut.bind(map);
                    map.touchTimeOut = window.setTimeout(map._timeOut, 1000);
                }
            }
        },

        _timeOut: function () {
            $(this.tooltipElement).fadeOut();
        },

        _markerPressed: function (event) {
            this._trigger("markerSelected", { originalEvent: event.data });
        },
			
        _polyMouseDown:function(event)
        {
           
            var layer = event.data.Param2;
            var position;
            if (event.type == "mousedown" || event.type == "pointerdown")
                position = { x: event.pageX || event.originalEvent.pageX, y: event.pageY || event.originalEvent.pageY };
            else if (event.type == "touchstart")
                position = { x: event.originalEvent.changedTouches[0].pageX, y: event.originalEvent.changedTouches[0].pageY };
            else if (event.type == "MSPointerDown")
                position = { x: event.originalEvent.pageX, y: event.originalEvent.pageY };

            this.model.cachedXY = position;
            if (!this.isTouch(event)) {

            if (event.data.Param1.hasOwnProperty("data") && layer.showTooltip) {
                var element = layer._tooltipElement;
                var template = layer.tooltipTemplate;
                var parentSize = $(this._mapContainer).offset();
                if (parentSize == null)
                    parentSize = { left: 0, width: 0, height: 0 };
                var tooltipSize = layer._tooltipSize;
                var tooltipdisplayheight = this._height;
                var tooltipdisplaywidth = this._width;
				
                if (element != null && template != null) {
                    $(element).css({ "display": "block" });
                    var htmlString = $("#" + template).render(event.data.Param1["data"]);
                    $(element).html(htmlString);
                     var height= element[0]!=null ? element[0].clientHeight : element.clientHeight;
					 var width= element[0]!=null ? element[0].clientWidth : element.clientWidth;
					 tooltipSize = { height: height, width: width };

					

					var xPos = position.x - $(this._mapContainer).offset().left;
			        var yPos = position.y - $(this._mapContainer).offset().top;

                    var xnewPos = position.x;
                    var ynewPos = position.y;

			       if (tooltipSize.width + xPos >= tooltipdisplaywidth) {
                         if(xnewPos - tooltipSize.width > parentSize.left)
			                xnewPos = ((parentSize.left + tooltipdisplaywidth) - (tooltipdisplaywidth - xPos)) - tooltipSize.width;
                         else
                            xnewPos -= (tooltipSize.width + xPos - tooltipdisplaywidth);  
			            }
			            if (tooltipSize.height > tooltipdisplayheight) {
			                if (tooltipdisplayheight + tooltipSize.height > this._height + yPos) 
			                    ynewPos -= parentSize.top + 10;
			            }
                        else if (tooltipSize.height + yPos >= tooltipdisplayheight) {
			                ynewPos -= (tooltipSize.height + yPos - tooltipdisplayheight);
			            }   

                    $(element).css({ "left": xnewPos + 10, "top": ynewPos + 10 });
                }
            }
            }
        },
      
        getEventXY: function (event) {
            var X, Y;
            X = event.pageX || event.originalEvent.pageX || event.originalEvent.changedTouches[0].pageX;
            Y = event.pageY || event.originalEvent.pageY || event.originalEvent.changedTouches[0].pageY;
            return { X: X, Y: Y };
        },

       _polyClickFunction: function (event) {

           var ctrlkey = event.ctrlKey,
               layer = event.data.Param2,
               map = this, swipeDiffer = 10, cachedXY = map.model.cachedXY,// avoid tiny mouse movement changes
            differX, differY, currentXY = map.getEventXY(event);
            differX = Math.abs(cachedXY.x - currentXY.X);
            differY = Math.abs(cachedXY.y - currentXY.Y);
            if (differX < swipeDiffer && differY < swipeDiffer) {

            var shape = event.data.Param3;
            if (event.data.param4 != undefined)
            {                
                var temp = event.data.param4;
            }            
            
            var legend = jQuery.grep(layer._smartLabels, function (obj) { return obj.shape == shape });
            map._isPolygonSelected = true;

            if (layer.enableSelection) {

                if (ctrlkey && layer.selectionMode == ej.datavisualization.Map.SelectionMode.Multiple) {
				 if (legend != null && legend.length > 0) {
                        if ($.inArray(legend[0].legend, layer._prevSelectedLegends) == -1) {
				            legend[0].legend[0].setAttribute("class", "e-mapSelectedShape mapShape");
                            legend[0].legend.css("background-color", layer.shapeSettings.selectionColor);
                            layer._prevSelectedLegends.push(legend[0].legend);
                        }
                        else {
                            var index = layer._prevSelectedLegends.indexOf(legend[0].legend);
				            legend[0].legend[0].setAttribute("class", "mapShape");
                            legend[0].legend.css("background-color", legend[0].legend[0].getAttribute("nodeValue"));
                            layer._prevSelectedLegends.splice(index, 1);
                        }
                    }

				 if (temp != null) {                     

				     var element = document.getElementsByClassName("e-map-labelContainer")
				     if ($.inArray(temp, layer._prevSelectedTemp) == -1) {				         
				         $(temp).css("background-color", layer.shapeSettings.selectionColor);
				         $(temp).css("width", element[0].clientWidth);
				         layer._prevSelectedTemp.push(temp);
				     }
				     else {
				         $(temp).css("background-color", "");				         				         			         
				         var pos = layer._prevSelectedTemp.indexOf(temp);
				         layer._prevSelectedTemp.splice(pos, 1);
				     }

				 }

                    if ($.inArray(shape, layer._prevSelectedShapes) == -1) {
				        shape.setAttribute("class", "e-mapSelectedShape mapShape");
                        if (_isSVG) {
                            shape.setAttribute("fill", layer.shapeSettings.selectionColor);
                            shape.setAttribute("stroke", layer.shapeSettings.selectionStroke);
                            shape.setAttribute("stroke-width", (layer.shapeSettings.selectionStrokeWidth / map._scale));                            
                        }
                        else {
                            shape.fillcolor = layer.shapeSettings.selectionColor;
                            shape.strokecolor = layer.shapeSettings.selectionStroke
                            shape.strokeweight = layer.shapeSettings.selectionStrokeWidth / map._scale;
                        }
                        layer._prevSelectedShapes.push(shape);
                        layer.selectedItems.push(event.data.Param1);
                    }
                    else {
				        shape.setAttribute("class", "mapShape");
                        shape.setAttribute("fill", shape.getAttribute("nodeValue"));
                        shape.setAttribute("stroke", layer.shapeSettings.stroke);
                        shape.setAttribute("stroke-width", layer.shapeSettings.strokeThickness / this._scale);
                        var index = layer._prevSelectedShapes.indexOf(shape);
                        layer._prevSelectedShapes.splice(index, 1);
                        layer.selectedItems.splice(index, 1);
                    }
                }

                else {
                     for (var i = 0; i < layer._prevSelectedLegends.length; i++) {
                        layer._prevSelectedLegends[i][0].setAttribute("class", "mapShape");
                        layer._prevSelectedLegends[i].css("background-color", layer._prevSelectedLegends[i][0].getAttribute("nodeValue"));
                    }
                    if ((legend != null && legend.length > 0)) {
                         legend[0].legend[0].setAttribute("class", "e-mapSelectedShape mapShape");
                         legend[0].legend.css("background-color", layer.shapeSettings.selectionColor);
                         layer._prevSelectedLegends.push(legend[0].legend);
                     }
                   
                    for (var i = 0; i < layer._prevSelectedShapes.length; i++) {
                        layer._prevSelectedShapes[i].setAttribute("class", "mapShape");                        
                            if (_isSVG) {
                                layer._prevSelectedShapes[i].setAttribute("fill", layer._prevSelectedShapes[i].getAttribute("nodeValue"));
                                layer._prevSelectedShapes[i].setAttribute("stroke", layer.shapeSettings.stroke);
                                layer._prevSelectedShapes[i].setAttribute("stroke-width", layer.shapeSettings.strokeThickness / this._scale);
                            }
                            else {
                                layer.fillcolor = layer._prevSelectedShapes[i].getAttribute("nodeValue");
                                layer.strokecolor = layer.shapeSettings.stroke
                                layer.strokeweight = layer.shapeSettings.strokeThickness / this._scale;
                            }                            
                    }

                    if (temp != null)
                    {
                        var element = document.getElementsByClassName("e-map-labelContainer")
                        if ($.inArray(temp, layer._prevSelectedTemp) == -1)
                        {                           

                            for (var i = 0; i < layer._prevSelectedTemp.length; i++)
                            {
                                $(layer._prevSelectedTemp[i]).css("background-color", "");                                
                            }
                            layer._prevSelectedTemp = [];
                            $(temp).css("background-color", layer.shapeSettings.selectionColor);
                            $(temp).css("width", element[0].clientWidth);
                            layer._prevSelectedTemp.push(temp);
                        }
                        else
                        {                            
                            for (var i = 0; i < layer._prevSelectedTemp.length; i++) {
                                $(layer._prevSelectedTemp[i]).css("background-color", "");                                
                            }
                            layer._prevSelectedTemp = [];
                        }
                        
                    }

                        if (!this._isPinching && ($.inArray(shape, layer._prevSelectedShapes) == -1)) {
                        shape.setAttribute("class", "e-mapSelectedShape mapShape");                      
                            layer._prevSelectedShapes = [];
                            layer.selectedItems = [];
                            if (_isSVG) {
                                shape.setAttribute("fill", layer.shapeSettings.selectionColor);
                                shape.setAttribute("stroke", layer.shapeSettings.selectionStroke);
                                shape.setAttribute("stroke-width", (layer.shapeSettings.selectionStrokeWidth / map._scale));
                            }
                            else {
                                shape.fillcolor = layer.shapeSettings.selectionColor;
                                shape.strokecolor = layer.shapeSettings.selectionStroke;
                                shape.strokeweight = layer.shapeSettings.selectionStrokeWidth / map._scale;
                            }
                            
                            layer._prevSelectedShapes.push(shape);
                            layer.selectedItems.push(event.data.Param1);
                        }
                        else {
                            layer._prevSelectedShapes=[];
                            layer.selectedItems = [];
                        }
                        
                    

                    
                }
            }
            map._trigger("shapeSelected", { originalEvent: layer.selectedItems });
          }
        },

        _updateSelection: function (layer, shape, data) {
            if (layer.enableSelection) {
                if (layer.selectionMode != ej.datavisualization.Map.SelectionMode.Multiple) {
                    layer._prevSelectedShapes.pop();
                    layer.selectedItems.pop();
                }
                layer._prevSelectedShapes.push(shape);
                layer.selectedItems.push(data);
            }
        },

	   _zoomOnSelection: function (bounds) {            
	       var layerScale;
	       if (!_isSVG) {
	           bounds.x = (bounds.x - (this._baseTranslatePoint.x/2)) - (bounds.width/2);
	           bounds.y = (bounds.y - (this._baseTranslatePoint.y/2)) - (bounds.height / 2);
	       }
	       var boundwidth = bounds.width;
	       var boundHeight =bounds.height;
	       if ((this._width - 100) / (this._height - 100) > boundwidth / boundHeight) {
	           layerScale = (this._height - 100) / boundHeight;
	       } else {
	           layerScale = (this._width - 100) / boundwidth;
	       }
	       this._prevScale = this._scale;
	       this._scale = layerScale;
	       this._prevPoint = { x: this._translatePoint.x, y: this._translatePoint.y };
	       this.model.zoomSettings.level = this._scale - this._baseScale + 1;
	       this._zoomLevel(this._scale - this._baseScale + 1);
	       var level = this._zoomLevel();
	       if (!(level > this._minZoom() && level < this._maxZoom())) {
	           this.model.zoomSettings.level = level > (((this._maxZoom() - this._minZoom()) / 2) + this._minZoom()) ? this._maxZoom() : this._minZoom();
	           this._zoomLevel(this.model.zoomSettings.level);
	           this._scale = this._zoomLevel() + this._baseScale - 1;
	       }
	       var leftMargin = (this._width / 2) - ((boundwidth * this._scale) / 2);
	       var leftPos = leftMargin / this._scale;
	       var topMargin = (this._height / 2) - ((boundHeight * this._scale) / 2);
	       var topPos = topMargin / this._scale;
	       this._translatePoint.x = -bounds.x + leftPos;
	       this._translatePoint.y = -bounds.y + topPos;
	       if (this.enableAnimation() && !this._isTileMap) {
	           this._animate(1200);
	       }
	       else {
	           this._applyTransform(this._scale, this._translatePoint);
	           this._updateSliderValue();
	       }	                  
        },
       
          _polyMoveFunction: function (event) {
              var map = event.data.Param1,
                  isTouch = this.isTouch?this.isTouch(event):false;
           if ((!isTouch && event.type.toString().indexOf('move') > -1) || this.touchEnd) {
               this.touchEnd = false;
		   if(this.model!=null){
            var baseLayer = this.model.layers[this.baseMapIndex()];
	        var element = map._tooltipElement;
            var template = map.tooltipTemplate;
            var tooltipObject = event.data.Param2;
            var tooltipSize = map._tooltipSize;
			var parentSize=$(this._mapContainer).offset();
			 if (parentSize == null)
                parentSize = { left: 0, top:0, width: 0, height: 0 };

			if (baseLayer.legendSettings.dockOnMap && baseLayer.legendSettings.dockPosition == "right") {
			    width = this._width + baseLayer.legendSettings.width + 20 + (baseLayer.legendSettings.leftLabel.length * 10) + (baseLayer.legendSettings.rightLabel.length * 10);
			}
			else {
                width = this._width;
			}
			var tooltipdisplayheight = this._height;
			var tooltipdisplaywidth = width;

			var pageXY = this.getEventXY(event);

			var xPos = pageXY.X - parentSize.left;
			var yPos = pageXY.Y - parentSize.top;

			var xnewPos = pageXY.X;
			var ynewPos = pageXY.Y;

             if (element != null && template != null && tooltipObject.hasOwnProperty("data") && event.data.Param1.showTooltip) {
                    $(element).css({ "display": "block" });
					 var locale = this.model.locale;
					 var obj = $.extend({}, tooltipObject.data);
					 if (locale && this.model.enableGroupSeparator){
						for (var key in obj)
							obj[key] = isNaN(parseFloat(obj[key])) ? obj[key] : parseFloat(obj[key]).toLocaleString(locale);
					 }	
                    var htmlString = $("#" + template).render(obj);
                    $(element).html(htmlString);
                     var height= element[0]!=null ? element[0].clientHeight : element.clientHeight;
					 var width= element[0]!=null ? element[0].clientWidth : element.clientWidth;
					 tooltipSize = { height: height, width: width };

					 if (!ej.util.isNullOrUndefined(this.touchTimeOut))
					     window.clearTimeout(this.touchTimeOut);

            if (tooltipSize.width + xPos >= tooltipdisplaywidth) {
             if(xnewPos - tooltipSize.width > parentSize.left)
			    xnewPos = ((parentSize.left + tooltipdisplaywidth) - (tooltipdisplaywidth - xPos)) - tooltipSize.width;
             else
                xnewPos -= (tooltipSize.width + xPos - tooltipdisplaywidth);  
			}
			if (tooltipSize.height > tooltipdisplayheight) {
			    if (tooltipdisplayheight + tooltipSize.height > this._height + yPos) 
			        ynewPos -= parentSize.top + 10;
			}
            else if (tooltipSize.height + yPos >= tooltipdisplayheight) {
			    ynewPos -= (tooltipSize.height + yPos - tooltipdisplayheight);
			}  
                $(element).css({ "left": xnewPos + 10, "top": ynewPos + 10});
			}
            }
          }
          },

        _polyLeaveFunction: function (event) {
            var layer = event.data.Param1,
                isTouch = this.isTouch(event),
                map = event.data.map,
                shape = event.data.Param2.shape,
                element = layer._tooltipElement,
                selectedshape = layer._prevSelectedShapes;
            if (selectedshape.length > 0)
            {
                shape.setAttribute("class", "mapShape");
                for (i = 0; i < selectedshape.length; i++)
                {
                    selectedshape[i].setAttribute("class", "e-mapSelectedShape mapShape");                    
                }                
            }
            else
            {
                shape.setAttribute("class", "mapShape");
            }            
            if (element != null && !isTouch) {
                $(element).css("display", "none");
            }
            if (layer.legendSettings!=null && layer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive && layer._interactiveArrow != null)
                $(layer._interactiveArrow).css("display", "none");
            layer._clearShapeWidth(map._scale);
            map._trigger("mouseleave", { originalEvent: event.data.Param2 });
        },

        _wireEvents: function () {
            var matched = jQuery.uaMatch(navigator.userAgent);
            var browser = matched.browser.toLowerCase();
            this._on($(this._mapContainer), ej.eventType.mouseDown, this._mouseButtonDown);
			$(document).keydown({ className: "home", map: this }, this._keyboardKeysPressed);
            this._on($(this._mapContainer), ej.eventType.mouseMove, this._mouseMove);
            this._on($(document), ej.eventType.mouseUp, this._mouseUp);
            var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
            if (isIE11)
                browser = "msie";
            if (window.navigator.msPointerEnabled) {
                this._on($(this._mapContainer), "MSPointerUp", this._mouseButtonUp);
                if (this.model.zoomSettings.enableZoom)
                    $(this._mapContainer).css('-ms-touch-action', 'none');
            }
            else {
                this._on($(this._mapContainer), "mouseup", this._mouseButtonUp);
            }
            var map = this;
            this._browser = browser;
            if (browser != "mozilla") {
                this._on($(this._mapContainer), "mousewheel", this._mouseWheel);
            }
            else {
                var elem = this._svgDocument || this._mapContainer[0];
                if (elem.addEventListener) {
                    // Mouse Scrolling event for firefox
                    elem.addEventListener("DOMMouseScroll", MouseWheel, false);
                }

            }
            function MouseWheel(event) {
			if(map.enableAnimation()){
				$(map._rootgroup).stop(true, false);
			}
			  event.preventDefault(event);
                map._zooming(-40 * event.detail, event);
            }
            this._on($(this._mapContainer), "dblclick", this._doubleClick);
            if (this.model.enableResize || this.model.isResponsive) {
                if (!ej.isTouchDevice())
                    this._on($(window), "resize", this._mapResize);
                else
                    this._on($(window), "orientationchange", this._mapResize);
            }
        },

       clip:function(n,minValue,maxValue){
        return Math.min(Math.max(n, minValue), maxValue);
        },

        pointToLatLong:function(pointX,pointY)
        {
            var map = this;
            var factor = map._getFactor();
            var translateX = (pointX / map._scale) - (map._translatePoint.x);
            var translateY = (pointY / map._scale) - (map._translatePoint.y);
            var mapSize = Math.min(map._height, map._width) * factor;
            var transformX = (map.clip(translateX, 0, mapSize - 1) / mapSize) - 0.5;
            var transformy = 0.5 - (map.clip(translateY, 0, mapSize - 1) / mapSize);

            latitude = 90 - 360 * Math.atan(Math.exp(-transformy * 2 * Math.PI)) / Math.PI;
            longitude = 360 * transformX;
            return {latitude:latitude,longitude:longitude};
        
        },
   
        _mapResize: function (event) {
            event.preventDefault();
            event.stopPropagation();
            var oldSize = { width: this._width, height: this._height };
            var oldTranslatePoint = this._translatePoint;
            var map = this;
            if (this.resizeTO) clearTimeout(this.resizeTO);
            this.resizeTO = setTimeout(function () {
                if (map.model != null) {
                    var latlon = map.pointToLatLong(map._width / 2, map._height / 2);
                    map.refresh(true);
                    if (!map._isTileMap)
                        map.navigateTo(latlon.latitude, latlon.longitude, map._zoomLevel(), false);                    
                }
            }, 500);
        },


        _isDevice: function () {
            return (/mobile|tablet|android|kindle/i.test(navigator.userAgent.toLowerCase()));
        },
        
        _unWireEvents: function () {
            var matched = jQuery.uaMatch(navigator.userAgent);
            var browser = matched.browser.toLowerCase();
            this._off($(document), 'keydown', this._keyboardKeysPressed);
            this._off($(document), ej.eventType.mouseUp, this._mouseUp);
            var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
            if (isIE11)
                browser = "msie";
			if (browser != "mozilla") {
                this._off($(this._mapContainer), "mousewheel", this._mouseWheel);
            }
            if (window.navigator.msPointerEnabled) {
                this._off($(this._mapContainer), "MSPointerDown", this._mouseButtonDown);
                this._off($(this._mapContainer), "MSPointerMove", this._mouseMove);
                this._off($(this._mapContainer), "MSPointerUp", this._mouseButtonUp);
            }
            else if (browser == "webkit" || browser == "chrome" || browser == "mozilla") {
                this._off($(this._mapContainer), "mousedown", this._mouseButtonDown);
                this._off($(this._mapContainer), "mousemove", this._mouseMove);
                this._off($(this._mapContainer), "mouseup", this._mouseButtonUp);

            }
            else {
                this._off($(this._mapContainer), "mousedown", this._mouseButtonDown);
                this._off($(this._mapContainer), "mousemove", this._mouseMove);
                this._off($(this._mapContainer), "mouseup", this._mouseButtonUp);

            }
            this._off($(this._mapContainer), "dblclick", this._doubleClick);

        },

        navigateTo: function (latitude, longitude, level,isAnimate) {
		     if (isAnimate == undefined) {
                isAnimate = this.enableAnimation();
            }
		    level=parseFloat(level);
		    if (level == undefined) level = this._zoomLevel();
            if (level > this._minZoom() && level < this._maxZoom()) {
                this.model.zoomSettings.level = level;
                this._zoomLevel(level);
            }
            else {
                this.model.zoomSettings.level = level > (((this._maxZoom() - this._minZoom()) / 2) + this._minZoom()) ? this._maxZoom() : this._minZoom();
                this._zoomLevel(this.model.zoomSettings.level);

            }
            var factor = this._getFactor();
            var translatePoint = this._convertTileLatLongtoPointForShapes(latitude, longitude, this._mapBounds,factor);
            this._prevPoint = { x: this._translatePoint.x, y: this._translatePoint.y };
            this._prevScale = this._scale;
            this._scale = this._baseScale + ((level - 1) * this._zoomFactor());
            var leftPosition = ((this._containerWidth + this._baseTranslatePoint.x) / 2) / this._scale;
            var topPosition = ((this._containerHeight + this._baseTranslatePoint.y) / 2) / this._scale;
            this._translatePoint.x = -translatePoint.x+ leftPosition;
            this._translatePoint.y = -translatePoint.y+ topPosition;
            if (isAnimate && !this._isTileMap ){
                this._animate(1200);
            }
            else {
                this._applyTransform(this._scale, this._translatePoint);
            }
            this._updateSliderValue();
            this._refrshLayers();
        },

        selectShape: function (obj, layer,isZoom) {
            if (obj != null) {
                if (layer == null) {
                    layer = this.model.layers[this.baseMapIndex()];
                }
                for (var i = 0; i < layer._mapShapes.length; i++) {
                    var data = layer._mapShapes[i].data;
                    var shape = layer._mapShapes[i].shape;
                    if (data != null && obj == this._reflection(data, layer.shapeSettings.valuePath)) {

                        if (layer._prevSelectedShapes.length != 0 && layer.selectionMode != ej.datavisualization.Map.SelectionMode.Multiple) {
                            for (var i = 0; i < layer._prevSelectedShapes.length; i++) {
                                if (_isSVG) {
                                    layer._prevSelectedShapes[i].setAttribute("fill", layer._prevSelectedShapes[i].getAttribute("nodeValue"));
                                    layer._prevSelectedShapes[i].setAttribute("stroke", layer.shapeSettings.stroke);
                                    layer._prevSelectedShapes[i].setAttribute("stroke-width", layer.shapeSettings.strokeThickness / this._scale);
                                } else {
                                    layer._prevSelectedShapes[i].fillcolor = layer._prevSelectedShapes[i].style.behavior;
                                    layer._prevSelectedShapes[i].strokecolor = layer.shapeSettings.stroke;
                                    layer._prevSelectedShapes[i].strokeweight = layer.shapeSettings.strokeThickness / this._scale;
                                }
                            }
                        }
                        if (layer.enableSelection) {
                            if (_isSVG) {
							    if(layer.shapeSettings.selectionColor!="none"){
                                    shape.setAttribute("fill", layer.shapeSettings.selectionColor);
							    }
                                shape.setAttribute("stroke", layer.shapeSettings.selectionStroke);
                                shape.setAttribute("stroke-width", (layer.shapeSettings.selectionStrokeWidth / this._scale));
                            } else {
							     if(layer.shapeSettings.selectionColor!="none"){
                                      shape.fillcolor = layer.shapeSettings.selectionColor;
								}
                                shape.strokecolor = layer.shapeSettings.selectionStroke;
                                shape.strokeweight = layer.shapeSettings.selectionStrokeWidth / this._scale;
                            }
                            this._updateSelection(layer, shape, obj);
						if (!layer._contains(layer.selectedItems, layer._mapShapes[i]))
                            layer.selectedItems.push(layer._mapShapes[i]);
                            this._trigger("shapeSelected", { originalEvent: layer.selectedItems });
                        }
                        if (isZoom && this.model.zoomSettings.enableZoomOnSelection) {
                            this._zoomOnSelection(shape.getBBox());
                        }
                        i = layer._mapShapes.length;
                    }
                }
            }

        },

        _getIntersectedElements: function (evt, shapes) {
            evt.width += 5;
            evt.height += 5;
            if (_isSVG && this._browser!='mozilla' && this._browser!='webkit') {
                var rpos = this._svgDocument.createSVGRect();
                rpos.x = evt.left;
                rpos.y = evt.top;
                rpos.width = evt.width;
                rpos.height = evt.height;
                return this._svgDocument.getIntersectionList(rpos, null);
            }
            else {
                var elements = []; 
				var parentSize=$(this._mapContainer).offset();
                var  parentLeft=parentSize.left;
                var parentTop= parentSize.top;			
                for (var i = 0; i < shapes.length; i++) {
                    var shape = shapes[i].shape;
                    var bounds = shape.getBoundingClientRect();					
					var leftPos= $(shape).offset().left- parentLeft;
					var topPos= $(shape).offset().top- parentTop;					
                    if (this._isIntersect(evt, { left: leftPos, top: topPos, height: (bounds.bottom  - bounds.top ), width: (bounds.right -bounds.left) })) {
                        elements.push(shape);
                        return elements;
                    }
                }
                return elements;
            }
                
                
        },

        _isIntersect: function (rect1, rect2) {           
            
            if (rect1.left >= (rect2.left + rect2.width) || rect1.left + rect1.width <= rect2.left ||
                rect1.top >= rect2.top + rect2.height || rect1.top + rect1.height <= rect2.top) {
                    return false;
                }
                return true;
            
        },

        pan: function (direction) {
            var map = this;
            var Xdiff = 0;
            var Ydiff = 0;
            if (this._zoomLevel() != 1) {
                switch (direction) {

                    case 'right':
                        {
                            Xdiff = this._width / 7;
                            Ydiff = 0;
                            break;
                        }
                    case 'top':
                        {
                            Xdiff = 0;
                            Ydiff = -(this._height / 7);
                            break;
                        }n
                    case 'left':
                        {
                            Xdiff = -(this._width / 7);
                            Ydiff = 0;
                            break;
                        }
                    case 'bottom':
                        {
                            Xdiff = 0;
                            Ydiff = this._height / 7;
                            break;
                        }
                }
                if (map.enablePan()) {
                    if (this._isTileMap) {
                        var curtileX = this._tileTranslatePoint.x - Xdiff / map._scale;
                        var curtileY = this._tileTranslatePoint.y - Ydiff / map._scale;
                        this._tileTranslatePoint.x = curtileX;
                        this._tileTranslatePoint.y = curtileY;
                        this._generateTiles(this._zoomLevel());
                    }                    
                    var curX = map._translatePoint.x - Xdiff / map._scale;
                    map._prevScale = map._scale;
                    var curY = map._translatePoint.y - Ydiff / map._scale;
                    map._prevPoint = { x: this._translatePoint.x, y: this._translatePoint.y };
                    this._translatePoint.x = curX;
                    this._translatePoint.y = curY;
                    if (map.enableAnimation() && !this._isTileMap) {                       
                        map._animate(600);
                    }
                    else {
                        map._applyTransform(map._scale, map._translatePoint);
                    }
                    map._refrshLayers();
                }
            }
			
        },      

        zoom: function (level,isAnimate) {
           var map = this;
           var prevLevel = map._zoomLevel();
		    if (level <= this._maxZoom() && level >= this._minZoom()) {
                if (this._isTileMap) {
                    this._tileZoom(map._zoomLevel(), level, { x: this._width / 2, y: this._height / 2 });
                    var prevLevel = map._zoomLevel();
                    map.model.zoomSettings.level = level;
                    map._zoomLevel(level);
                    this._generateTiles(this._zoomLevel());
                    map._translatePoint.x = (map._tileTranslatePoint.x - (0.5 * Math.pow(2, prevLevel))) / (Math.pow(2, prevLevel));
                    map._translatePoint.y = (map._tileTranslatePoint.y - (0.5 * Math.pow(2, prevLevel))) / (Math.pow(2, prevLevel));
                    map._scale = (Math.pow(2, prevLevel));					
                }
                else {                    
                    var fac = (map._baseScale + ((level - 1) * map._zoomFactor()));
                    map._prevPoint = { x: map._translatePoint.x, y: map._translatePoint.y };
                    map._prevScale = map._scale;
                    map._translatePoint.x -= (map._width / map._scale - map._width / fac) / 2;
                    map._translatePoint.y -= (map._height / map._scale - map._height / fac) / 2;
                    map._scale = fac;
                    map.model.zoomSettings.level = level;
                    map._zoomLevel(level);

                    if (map.enableAnimation() && isAnimate || isAnimate == undefined) {
                        map._animate(600);
                    }                  
                }
				if(!map.enableAnimation() || !isAnimate)
				{
				     map._applyTransform(map._scale, map._translatePoint);
                     map._refrshLayers();
                     map._resizeShape();       
				}
				 map._updateSliderValue();                  
                
            }
		    else if (level <= this._minZoom()) {
		        this.model.zoomSettings.level = this._minZoom();
		        this._zoomLevel(this._minZoom());
		        this.zoom(this._zoomLevel());
            }
            else if (level >= this._maxZoom()) {
                this.model.zoomSettings.level = this._maxZoom();
                this._zoomLevel(this._maxZoom());
                this.zoom(this._zoomLevel());
            }
			  if (prevLevel < level) {
			      map._trigger("zoomedIn", { originalEvent: null, zoomLevel: map._zoomLevel() });
            }
            else  if (prevLevel > level) {
                map._trigger("zoomedOut", { originalEvent: null, zoomLevel: map._zoomLevel() });
            }
			
        },

       refresh: function (isResize) {
            
           $(this._svgDocument).children().remove();
           $(this._svgDocument).empty();
           $(this._mapContainer).empty();
           
           (this.baseMapIndex() >= this.model.layers.length) && this.baseMapIndex(0);
           this.model.layers[this.baseMapIndex()]._mapItems && (this.model.layers[this.baseMapIndex()]._mapItems = null);
           if (this._svgDocument != null) {
               this._svgDocument = null;
           }
            this._scale = 1;
            this._margintop = 0;
            this._marginleft = 0;
            this._translatePoint = { x: 0, y: 0 };            
            this._height = this._mapContainer.height();
            this._width = this._mapContainer.width();
             if (this._height == 0) {
                 this._height = this._mapContainer[0].parentElement.clientHeight != 0 ? this._mapContainer[0].parentElement.clientHeight : $(document).height();
            }
            if (this._width == 0) {
                this._width = this._mapContainer[0].parentElement.clientWidth != 0 ? this._mapContainer[0].parentElement.clientWidth : $(document).width();
            }
			 var baseLayer = this.model.layers[this.baseMapIndex()];
			 if (baseLayer.legendSettings != null && baseLayer.legendSettings.showLegend && baseLayer.shapeSettings.colorMappings != null) {
                baseLayer._sizeCalculation(this);
            }
            this._generatePath();           
            if (this._groupSize != null) {
               
                if (this._isMapCoordinates) {
                    this._containerHeight = this._groupSize.maxY - this._groupSize.minY;
                    this._containerWidth = this._groupSize.maxX - this._groupSize.minX;
                    this._groupBorder = { x: this._groupSize.minX, y: this._groupSize.minY };
                }
                else
                {
                    var factor = this._getFactor();
                    this._containerHeight = Math.abs((this._groupSize.maxY - this._groupSize.minY)* factor);
                    this._containerWidth = Math.abs((this._groupSize.maxX - this._groupSize.minX)*factor);
                }
            }
			
			if ((baseLayer.layerType == "geometry")) {
                $(this._svgDocument).css("background", this.model.background);
            }
            this._resizingContainer();
            this._renderMapElements();
            
            if ((baseLayer.legendSettings != null && baseLayer.legendSettings.showLegend) &&(baseLayer.shapeSettings.colorMappings!=null)) {
                
                    this._renderLegend();
                
            } 
           if (_isSVG) {
               $(this._svgDocument).css({ height: this._height, width: this._width, "margin-top": this._margintop, "margin-left": this._marginleft });
               
            }			
            if (this.model.enableLayerChangeAnimation) {
                $(this._mapContainer).animate({ opacity: 1 }, 500);
            }
            if(this.model.centerPosition!=null && !this._isTileMap){
                this.navigateTo(this.model.centerPosition[0], this.model.centerPosition[1], this._zoomLevel(), false);
            }
             if (this._legendContainer != null) {
                this._legendContainer.css({

                    "height": this._legendSize.height


                })
            }
			 this._trigger("refreshed");
             if (!isResize) {
                 this._events = null;
                 $(this._mapContainer).removeData();
                 $(this._mapContainer).data("ejMap", this);
             }
        },

        _updateSliderValue: function (isAnimate) {
            var slider = this._sliderControl;
            if (isAnimate == undefined) isAnimate = this.enableAnimation();
            if (slider != null) {
                var obj = slider.data("ejSlider");               
                obj.option("value", this._zoomLevel());
            }
        },

        _createDivElement: function (parent, child,base,classname) {
            var parentElement = parent;
            var childElement = child;           
            childElement.appendTo(parentElement);           
            parentElement.appendTo(base);            
            this._on(childElement,ej.eventType.mouseDown,{ className: classname, map: this }, this._navigationControlPressed);
            
        },

        _navigationControlPressed: function (event) {
            
            event.stopPropagation();
            this._isNavigationPressed = true;
            var map = event.data.map;
            var isAnimate = map.enableAnimation();            
            if (event.data.className == "zoomIn") {               
                map.zoom(map._zoomLevel() + 1, true);
                if (!isAnimate) {
                    map._updateSliderValue();
                }
				 map._refrshLayers();
            }
            else if (event.data.className == "zoomOut") {               
                map.zoom(map._zoomLevel() - 1, true);
                if (!isAnimate) {
                    map._updateSliderValue();
                }
            }
            else if (event.data.className == "panLeft") {
                map.pan("left");                
            }
            else if (event.data.className == "panRight") {
                map.pan("right");
            }
            else if (event.data.className == "panTop") {
                map.pan("top");
            }
            else if (event.data.className == "panBottom") {
                map.pan("bottom");
            }
            else if (event.data.className == "home") {                
                map.zoom(1,true);
                if (!isAnimate) {
                    map._updateSliderValue();
                }
            }            
           
        },
	
		 _keyboardKeysPressed: function (event) {
            this._iskeyboardKeysPressed = true;
            var map = event.data.map;
            var isAnimate = map.enableAnimation();
            if (event.ctrlKey && event.keyCode==38) {    			
                map._zoomingIn(map._width / 2, map._height / 2, event, isAnimate);
            }
            else if (event.ctrlKey && event.keyCode==40) {    
                map._zoomingOut(map._width / 2, map._height / 2, event, isAnimate);
            }
            else if (event.keyCode==37) {
                map.pan("left");                
            }
            else if (event.keyCode==39) {
                map.pan("right");
            }
            else if (event.keyCode==38) {
                map.pan("top");
            }
            else if (event.keyCode==40) {
                map.pan("bottom");
            }
		},
				
        refreshNavigationControl: function (navigation) {
            
            var baseLayer = this.model.layers[this.baseMapIndex()];
            var prevNav = this._mapContainer.find("#ejNavigation");
            if (prevNav.length > 0) {
                this._mapContainer[0].removeChild(prevNav[0]);
            }
            if (this.model.navigationControl != null && this.model.navigationControl.enableNavigation) {
                if (navigation == undefined) {
                    navigation = this.model.navigationControl;
                }
                var navigationOrientation = ej.datavisualization.Map.LabelOrientation.Vertical;
                var controlSize;
                var navigationHeight = 120;
                var navigationWidth = 12;
                controlSize = { width: 90, height: 320 };
                var navigationControl = $("<div id='ejNavigation' class='e-map-navigation e-orientation-vert'/>");
				if (this.model.navigationControl.content == null || this.model.navigationControl.content == "") {
                    var sliderDiv = $("<div style='height:120px;width:10px;margin-top:-197px;margin-left: 34px;' />");
                }
                if (navigation.orientation == 'horizontal') {
                    navigationOrientation = ej.datavisualization.Map.LabelOrientation.Horizontal;
                    navigationHeight = 12;
                    navigationWidth = 120;
                    controlSize = { width: 320, height: 90 };
                    navigationControl = $("<div id='ejNavigation' class='e-map-navigation e-orientation-horz' />");
                    if (this.model.navigationControl.content == null || this.model.navigationControl.content == "") {
                        sliderDiv = $("<div style='height:10px;width:120px;margin-top:-18px' />");
                    }
                }
				if (this.model.navigationControl.content == null || this.model.navigationControl.content == "") {
                    var baseDiv = $("<div class='e-panContainer'/>");
                    var isHor = navigationOrientation == 'horizontal' ? 'Horz' : 'Vert';
                    if (navigation.orientation == 'horizontal') {
                        var zoominOutDiv = $("<div style='margin-left: 94px;' />");
                        var slidercontrol = $("<div style='margin-left: 137px;'/>");
                    }
                    else {
                        var zoominOutDiv = $("<div />");
                        var slidercontrol = $("<div style='margin-top: 34px;'/>");
                    }
                    baseDiv.appendTo(navigationControl);
                    zoominOutDiv.appendTo(navigationControl);
                    sliderDiv.appendTo(slidercontrol);
                    slidercontrol.appendTo(navigationControl);
                    this._sliderControl = sliderDiv;
                    var navPos = { x: 0, y: 0 };
                    if (navigation.dockPosition == null || navigation.dockPosition == ej.datavisualization.Map.Position.None) {
                        navPos.x = (this._width * navigation.absolutePosition.x) / 100;
                        navPos.y = (this._height * navigation.absolutePosition.y) / 100;
                    } else {
                        navPos = this._getPosition(navigation.dockPosition, controlSize);
                    }
                    navigationControl.css({ "margin-left": navPos.x + "px", "margin-top": navPos.y + "px" });
                }
                var map = this;
				var changeZoom = this._height * 0.0025;
				if (this.model.navigationControl.content == null || this.model.navigationControl.content == "") {
                    if (this._browser != 'chrome' && this._browser != 'msie') {
                        navigationStyle = $('<style> .e-map-navigation {width: 90px;height: 320px;position:absolute;z-index:2;zoom:' + changeZoom + ';}</style>');
                    }
                    else {
                        navigationStyle = $('<style> .e-map-navigation {width: 90px;height: 320px;position:absolute;z-index:2;-moz-transform: scale(' + changeZoom + ');}</style>');
                    }
                }
                else {
					var contentHeight = $("#"+this.model.navigationControl.content).height() || $(this.navigationControlData[0]).height();
					var contentWidth = $("#"+this.model.navigationControl.content).width() || $(this.navigationControlData[0]).width();
					
                    if (this._browser != 'mozilla' && this._browser != 'chrome') {
                        navigationStyle = $('<style> .e-map-navigation {width: '+contentWidth+'px;height: '+contentHeight+'px;position:absolute;z-index:2;}</style>');
                    }
                    else {
                        navigationStyle = $('<style> .e-map-navigation {width: '+contentWidth+'px;height: '+contentHeight+'px;position:absolute;z-index:2;}</style>');
                    }
                }
				if (this._browser!='mozilla' && this._browser!='chrome'){
				navigationStyle.remove();
				$('html > head').append(navigationStyle);
				}
				else{
				$('html > head').append(navigationStyle);
				}
				if (this.model.navigationControl.content == null || this.model.navigationControl.content == "") {
				    $(sliderDiv).ejSlider({
				        orientation: navigationOrientation,
				        sliderType: ej.SliderType.MinRange,
				        value: 1,
				        animationSpeed: 1200,
				        minValue: this._minZoom(),
				        showTooltip: true,
				        enableAnimation: false,
				        maxValue: this._maxZoom(),
				        incrementStep: this._zoomFactor(),
				        slide: onslide,
				        change: onchange,
				        height: navigationHeight,
				        width: navigationWidth
				    });
				    navigationControl.appendTo(this._mapContainer);
				    if (navigation.orientation == 'horizontal') {
				        this._createDivElement($("<div title='" + this._localizedLabels.zoomIn + "' class='e-icon1 e-incrementButton  icon_margin1' />"), $("<div class='e-icon1 nav-inc-" + isHor + "  e-innerIncrement'/>"), zoominOutDiv, "zoomIn");
				        this._createDivElement($("<div title='" + this._localizedLabels.zoomOut + "' class='e-icon1 e-incrementButton icon_margin2'/>"), $("<div class='e-icon1 nav-dec-" + isHor + " e-innerDecrement'/>"), zoominOutDiv, "zoomOut");
				    }
				    else {
				        this._createDivElement($("<div title='" + this._localizedLabels.zoomIn + "' class='e-icon1 e-incrementButton  icon_margin1' />"), $("<div class='e-icon1 nav-inc-" + isHor + "  e-innerIncrement'/>"), zoominOutDiv, "zoomIn");
				        this._createDivElement($("<div title='" + this._localizedLabels.zoomOut + "' class='e-icon1 e-incrementButton icon_margin2'/>"), $("<div class='e-icon1 nav-dec-" + isHor + " e-innerDecrement'/>"), zoominOutDiv, "zoomOut");
				    }
				    this._createDivElement($("<div title='" + this._localizedLabels.panTop + "' class='e-icon1 e-radialTop'/>"), $("<div class='e-icon1 e-arrowUp'/>"), baseDiv, "panTop");
                    this._createDivElement($("<div title='" + this._localizedLabels.panLeft + "' class='e-icon1 e-radialLeft'/>"), $("<div class='e-icon1 e-arrowLeft'/>"), baseDiv, "panLeft");
				    this._createDivElement($("<div title='" + this._localizedLabels.panRight + "' class='e-icon1 e-radialRight'/>"), $("<div class='e-icon1 e-arrowRight'/>"), baseDiv, "panRight");
                    this._createDivElement($("<div title='" + this._localizedLabels.panBottom + "' class='e-icon1 e-radialBottom'/>"), $("<div class='e-icon1 e-arrowDown'/>"), baseDiv, "panBottom");
                    var homeDiv = $("<div title='" + this._localizedLabels.home + "' class='e-icon1 e-home-bg'><div class='e-icon1 e-map-home'></div>");
				    homeDiv.appendTo(baseDiv);
				    homeDiv.mousedown({ className: "home", map: this }, this._navigationControlPressed);
				}
				else {
                    if (this.navigationControlData == null) {
                        this.navigationControlData = $("#" + this.model.navigationControl.content);
                        this.navigationControlData.css({ 'display': 'block' });                            
                        this.navigationControlData.appendTo(navigationControl);
                    }
                    else {                            
                        this.navigationControlData.appendTo(navigationControl);
                    }                                                
                    navigationControl.appendTo(this._mapContainer);
                                       
				    controlSize = { width: this.navigationControlData[0].getBoundingClientRect().right - this.navigationControlData[0].getBoundingClientRect().left, height: this.navigationControlData[0].getBoundingClientRect().bottom - this.navigationControlData[0].getBoundingClientRect().top };                    
                    var navPos = { x: 0, y: 0 };
                    if (navigation.dockPosition == null || navigation.dockPosition == ej.datavisualization.Map.Position.None) {
                        navPos.x = (this._width * navigation.absolutePosition.x) / 100;
                        navPos.y = (this._height * navigation.absolutePosition.y) / 100;
                    } else {
                        navPos = this._getPosition(navigation.dockPosition, controlSize);
                    }

                    if (baseLayer.legendSettings.dockOnMap && baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top && baseLayer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive) {
                        navigationControl.css({ "margin-left": navPos.x + "px", "margin-top": navPos.y + baseLayer.legendSettings.height  + "px" });
                    }
                    else if (baseLayer.legendSettings.dockOnMap && baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Left && baseLayer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive) {
                            navigationControl.css({ "margin-left": navPos.x + baseLayer.legendSettings.width + 20 + (baseLayer.legendSettings.leftLabel.length * 10) + (baseLayer.legendSettings.rightLabel.length * 10)+ "px", "margin-top": navPos.y + "px" });
                    }
                    else if (baseLayer.legendSettings.dockOnMap && baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top && baseLayer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Default) {
                        navigationControl.css({ "margin-left": navPos.x + "px", "margin-top": navPos.y + baseLayer.legendSettings.height + "px" });
                    }
                    else if (baseLayer.legendSettings.dockOnMap && baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Left && baseLayer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Default) {
                        navigationControl.css({ "margin-left": navPos.x + baseLayer.legendSettings.width + "px", "margin-top": navPos.y + "px" });
                    }
                    else {
                        navigationControl.css({ "margin-left": navPos.x + "px", "margin-top": navPos.y + "px" });
                    }
                }
            }                     

			function onchange(args) {
			    if (map != null && map._isRendered && map._zoomLevel() != args.value) {
                    map.zoom(args.value, false);
                }
            
            }

            function onslide(args) {
                if (map != null && map._isRendered && map._zoomLevel() != args.value) {
                    map.zoom(args.value, false);
                }
            }
        },

        _getPosition: function (position,size) {
            var Position = { x: 0, y: 0 };
            switch (position) {
                case ej.datavisualization.Map.Position.TopLeft:                   
                    break;
                case ej.datavisualization.Map.Position.TopCenter:
                    Position.x = (this._width / 2) - (size.width / 2);
                    break;
                case ej.datavisualization.Map.Position.TopRight:
                    Position.x = this._width - size.width;
                    break;
                case ej.datavisualization.Map.Position.CenterLeft:
                    Position.y = (this._height / 2) - (size.height / 2);
                    break;
                case ej.datavisualization.Map.Position.Center:
                    Position.x = (this._width / 2) - (size.width / 2);
                    Position.y = (this._height / 2) - (size.height / 2);
                    break;
                case ej.datavisualization.Map.Position.CenterRight:
                    Position.x = this._width - size.width;
                    Position.y = (this._height / 2) - (size.height / 2);
                    break;
                case ej.datavisualization.Map.Position.BottomLeft:
                    Position.y = this._height - size.height;
                    break;
                case ej.datavisualization.Map.Position.BottomCenter:
                    Position.x = (this._width / 2) - (size.width / 2);
                    Position.y = this._height - size.height;
                    break;
                case ej.datavisualization.Map.Position.BottomRight:
                    Position.x = this._width - size.width;
                    Position.y = this._height - size.height;
                    break;

            }
            return Position;
        },

        _renderMapElements: function () {           
            this._templateDiv = $("<div class='TemplateDiv'/>");
            this._templateDiv.appendTo(this._mapContainer);
            this._templateDiv.css({
                'pointer-events': 'none', 'overflow': 'hidden', "position":"absolute",
                'z-index': '1', 'height': this._height, 'width': this._width
            });			

            this.refreshLayers();       
            this.refreshNavigationControl(this.model.navigationControl);
        },
		
        _renderLegend: function () {

            var baseLayer = this.model.layers[this.baseMapIndex()];
            
            this._scrollLegendDiv = $("<div class='ScrollLegendDiv'/>");
            
            this._scrollLegendDiv.appendTo(this._mapContainer);

            this._legendContainer = $("<div id='LegendcontainerDiv'/>");
            this._legendContainer.appendTo(this._scrollLegendDiv);

            this._legendDiv = $("<div class='LegendDiv'/>");

            this._legendDiv.css({
                'height': this._legendDivHeight + "px", 'width': this._legendDivWidth + "px"
            })
            this._isNavigationPressed = true;
            this._legendDiv.appendTo(this._legendContainer);
            this._legendDiv[0].getBoundingClientRect();
            this._legendContainer.css({
                "position": "relative"
            })

            this._scrollLegendDiv.ejScroller({ height: Math.round(this._legendSize.height), width: Math.round(this._legendSize.width) });

            if (baseLayer.legendSettings.labelOrientation == undefined)
                baseLayer.legendSettings.labelOrientation == ej.datavisualization.Map.LabelOrientation.Vertical;
            if (!baseLayer.legendSettings.dockOnMap) {
                if (baseLayer.legendSettings.labelOrientation == ej.datavisualization.Map.LabelOrientation.Horizontal || baseLayer.legendSettings.labelOrientation == ej.datavisualization.Map.LabelOrientation.Vertical) {

                    var position = (baseLayer.legendSettings.position == undefined) ? "topleft" : baseLayer.legendSettings.position;
                    var legendPos = this._getPosition(position, this._legendSize);
                    this._scrollLegendDiv.css({
                         "position": "absolute",
                         'z-index': '2', "margin-left": legendPos.x + "px", "margin-top": legendPos.y
                    });
                }
            }
            else {

                if (baseLayer.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive) {
                    pos = "none";
                    height = baseLayer.legendSettings.height + 50;
                    width = baseLayer.legendSettings.width + 20 + (baseLayer.legendSettings.leftLabel.length * 10) + (baseLayer.legendSettings.rightLabel.length * 10);
                }
                else {
                    pos = "auto";
                    height = baseLayer.legendSettings.height;
                    width = baseLayer.legendSettings.width;
                }
                this._scrollLegendDiv.css({
                    "position": "absolute",
                    'z-index': '2', 'height': this._legendSize.height, 'width': this._legendSize.width
                });

                if ((baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top || baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom) && baseLayer.legendSettings.alignment == ej.datavisualization.Map.Alignment.Center) {
                    this._scrollLegendDiv.css({
                        "margin-left": (this._width / 2) - (this._legendSize.width / 2)
                    });
                }
                else if ((baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top || baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom) && baseLayer.legendSettings.alignment == ej.datavisualization.Map.Alignment.Far) {
                    this._scrollLegendDiv.css({
                        "margin-left": this._width - this._legendSize.width
                    });
                }
                else if ((baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Left || baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Right) && baseLayer.legendSettings.alignment == ej.datavisualization.Map.Alignment.Center) {
                    this._scrollLegendDiv.css({
                        "margin-top": (this._height / 2) - (this._legendSize.height / 2)
                    });
                }
                else if ((baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Left || baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Right) && baseLayer.legendSettings.alignment == ej.datavisualization.Map.Alignment.Far) {
                    this._scrollLegendDiv.css({
                        "margin-top": this._height - this._legendSize.height
                    });
                }

                if (baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom) {
                    this._scrollLegendDiv.css({
                        "margin-top": this._height
                    });
                }
                else if (baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Right) {

                    this._scrollLegendDiv.css({

                        "margin-left": this._width

                    });
                }
            }

           
            this.refreshLayers();
            this.refreshNavigationControl(this.model.navigationControl);
        },
       
		_renderMapLayers:function(){
		
		 $(this._templateDiv).empty();
            var prevPathCount = 0;
            var baseLayer = this.model.layers[this.baseMapIndex()];
            if (baseLayer.layerType == ej.datavisualization.Map.LayerType.Geometry) {
                this._renderLayers(baseLayer, prevPathCount);
                if (baseLayer.shapeData != null)
                    prevPathCount = baseLayer._polygonData.length;
            }
            else {
                baseLayer._initializeLocalValues();
                var contribution = $("<div class='map-contribution'>");
                contribution[0].innerHTML = baseLayer.contribution;
                this._mapContainer.append(contribution);
            }
            for (var key = 0; key < this.model.layers[this.baseMapIndex()].subLayers.length; key++) {
                var sublayer = this.model.layers[this.baseMapIndex()].subLayers[key];
                sublayer._isBaseLayer = false;
                if (sublayer.layerType == ej.datavisualization.Map.LayerType.Geometry && sublayer.shapeData!=null) {
                    if (ej.util.isNullOrUndefined(sublayer._initializeLocalValues)) {
                        var subobj = new shapeLayer();
                        $.extend(subobj, sublayer);
                        $.extend(sublayer, subobj);
                    }
                    this._renderLayers(sublayer, prevPathCount);
                    prevPathCount += sublayer._polygonData.length;
                }
                else {
                    sublayer._initializeLocalValues();
                }
            }
            this.refreshMarkers();
            if (_isSVG && this.enableAnimation() && !this._isTileMap) {
                this._refreshWithAnimation();
            }
            else {
                this._refrshLayers();
            }

		},

        refreshLayers: function () {          
		   var baseLayer = this.model.layers[this.baseMapIndex()];
		   this._processOData(baseLayer,this);          
		   this.shapeSelectionOnResize();
        },
		
		_processOData:function(layer,map){		    
		    if(layer.dataSource!=null){
                      if (layer.dataSource instanceof ej.DataManager) {
				          var queryPromise = layer.dataSource.executeQuery(layer.query);
			             queryPromise.done(function (e) {
			             if(e.result!=null)
				         {
                            layer.dataSource=e.result;
						    map._renderMapLayers();
				         }
			           });        
				  }
				 else
				 {
				    map._renderMapLayers();
				 }
            }
			else
			{
			  map._renderMapLayers();
			}
		}
		
		

    });

 

    var Tile = function (x, y) {
        this.X = x;
        this.Y = y;
        this.left = 0;
        this.top = 0;       
        this.height = 256;
        this.width = 256;
        this.src = null;
    };
   
    var shapeLayer = function () {
                
        this.enableSelection = true;
        this.selectionMode = "default";		
		this.bingMapType = "aerial";	
        this.key = "";   
        this.selectedItems = [];        
        this.enableMouseHover = false;
        this.shapeData = null;
        this.markers = [];
        this.dataSource = null;
        this.urlTemplate = 'http://a.tile.openstreetmap.org/level/tileX/tileY.png';
        this.showTooltip = false;
        this.tooltipTemplate = null;
        this.mapItemsTemplate = null;
        this.enableAnimation = false;

        this.legendSettings = {		
			showLegend:false,		
			showLabels:false,	
            rowSpacing: 10,
            columnSpacing:10,
			position: "topleft",			
			positionX: 0,		
			positionY:0,				
			height:0, 		
			width:0,
			iconHeight: 20,
			iconWidth: 20,		
			type:"layers", 		
			mode:"default", 					
			title: null, 			
			leftLabel:null, 						
			rightLabel:null,			
			icon:"rectangle",						
			dockOnMap:false,					
			dockPosition: "top",					
            labelOrientation: "vertical",
			alignment: "bottom",
            columnCount:0
        };

        this.labelSettings = {			
			showLabels: false, 						
			labelPath: "",			
			enableSmartLabel: false,			
			smartLabelSize:"fixed",			
			labelLength:2
		};        
        this.markerTemplate = null;       
		this.showMapItems = false;      
        this.layerType = 'geometry';
        this.geometryType = "geographic";
        this._colorPaletteSettings = {
            'Palette1':
            {
                'highlightColor': '#F7CD1C',
                'highlightStroke': 'white',
                'SelectionColor': '#F96C0D',
                'SelectionStroke': 'white'
                
            },
            'Palette2':
            {
                'highlightColor': '#68A3EA',
                'highlightStroke': 'White',
                'SelectionColor': '#116EF4',
                'SelectionStroke': 'White'
               
            },
            'Palette3':
            {
                'highlightColor': '#CCCCCC',
                'highlightStroke': 'white',
                'SelectionColor': '#4D4D4D',
                'SelectionStroke': 'white'
                
            }
        };
        this.colorPalettes = {
            'Palette1': ['#4A3825', '#736F3D','#F2DABD','#BF9D7E','#7F6039','#7F715F','#70845D','#CC995C','#736F3D','#89541B'],
            'Palette2': ['#E51400', '#730202','#EF6535','#C63477','#BF004D','#F0A30B','#CE1B1B','#97993D','#D6BF38','#835A2C'],
            'Palette3': ['#A4C400', '#008B00','#1BA0E2','#0050EF','#AA00FF','#D90073','#E51400','#F96800','#E3C800','#A20026']
        };
        
        this._prevPaletteIndex = 0;        
        this._newBounds = [];      
        this.subLayers = [];

        this.shapeSettings = {           
            highlightColor: "gray",          
            highlightBorderWidth: 1,            
            selectionColor: "gray",
            fill: "#E5E5E5",          
            radius: 5,
            strokeThickness: "0.2",            
            stroke: "#C1C1C1",
            colorPalette: 'palette1',
            highlightStroke: "#C1C1C1",
            selectionStroke: "#C1C1C1",           
            selectionStrokeWidth: 1,
            colorValuePath : null,
            valuePath: null,
            enableGradient: false,        
            colorMappings: null,
            autoFill: false
        };

       
        this.bubbleSettings = {            
            showBubble: true,          
            bubbleOpacity: "0.9",         
            minValue: 10,
            maxValue: 20,
            color: "gray",
            colorValuePath : null,
            valuePath: null,
            colorMappings: null,
            showTooltip: false,
            tooltipTemplate: null
        };
    };

    shapeLayer.prototype =
    {        
        dataTypes: {
            dataSource: "data",
            markers: "array",
            subLayers: "array",
            shapeSettings: {
                colorMappings: "array"
            },
            bubbleSettings: {
                colorMappings: "array"
            }

        },
       
        _initializeLocalValues:function()
        {
            this._svgns = "http://www.w3.org/2000/svg";
            this._bounds = [];
            this._bubbleCollection = [];
            this._prevSelectedShapes = [];
            this._prevSelectedTemp = [];
            this._prevSelectedLegends = [];
            this._isBaseLayer = true;
            this._prevHoverdLegend = null;
            this._prevHoveredShape = null;
            this._labelCollection = [];
            this._scrollBar = null;
            this._mapShapes = [];
            this._bubbles = [];
            this._labelBounds = [];            
            this._bubbleCount = 0;
            this._mapItems = [];           
            this._mapMarkers = [];
            this.selectedItems;
			this._tooltipSize = { height: 0, width: 0 };
            this._smartLabels = [];
            this._labelData = [];
            this._interactiveArrow = null;
            this._legendRects = [];

        },
     
        _generateMarkerForLayers: function (map) {
            this._mapMarkers = [];
            var rootTop = map._rootgroup.getBoundingClientRect().top;
            var rootLeft = map._rootgroup.getBoundingClientRect().left;
            for (var key = 0; key < this.markers.length; key++) {
                var markerObeject = this.markers[key];               
                if (this.markerTemplate != null) {
                    var markerTemplateDiv = $('.markerTemplateDiv');
                    markerTemplateDiv = $("<div class='mapMarker' style='display:block;position:absolute;pointer-events: stroke;'></div>");                   
                    map._templateDiv.append(markerTemplateDiv);
                    $(markerTemplateDiv).css({ height: this._height, width: this._width, "margin-top": this._margintop, "margin-left": this._marginleft });
                    var htmlString = $("#" + this.markerTemplate).render(markerObeject);
					if(map.model.markerSelected==null)
					{
						
						$(markerTemplateDiv).css({  "pointer-events": "none"});
					}
                    $(markerTemplateDiv).html(htmlString);
                    map._on($(markerTemplateDiv), ej.eventType.mouseDown, { marker: $(markerTemplateDiv), data: markerObeject }, map._markerPressed);
                    this._mapMarkers.push(markerTemplateDiv);
                }
                else {                    
                    var markerItem = $(' <div class="mapMarker" style="display:block;position:absolute;pointer-events: stroke;"><label>' + markerObeject.label + '</label></div>');// document.createElementNS(this._svgns, "text");
                    if (_isSVG) {
                        map._templateDiv.append(markerItem);
                    }
                    else {
                        markerItem.appendTo(map._templateDiv);
                    }
					if(map.model.markerSelected==null)
					{
						
						$(markerItem).css({  "pointer-events": "none"});
					}
                    map._on($(markerItem), ej.eventType.mouseDown, { marker: $(markerItem), data: markerObeject }, map._markerPressed);
                    this._mapMarkers.push(markerItem);

                }
                  var baseLayer = this;
                if (baseLayer.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Left) {
                    this._height = this._height;
                    this._width = this._width - parseFloat(width);
                    this._marginleft = parseFloat(width);
             }            
            }            
        },

        _contains : function(array,actualobj) {
            var length = array.length;
            if (length > 0) {
                while (length--) {
                    if (array[length] === actualobj) {
                        return true;
                    }
                }
            }
            return false;
        },
       
          _shapeContains: function (array, actualobj) {
            var length = array.length;
            if (length > 0) {
                while (length--) {
                    if (array[length].shapeIndex === actualobj) {
                        return { isContains: true, index: array.length - length };
                    }
                }
            }
            return { isContains: false };

        },  

          _labelSizeCalculation: function (map) {

              var size = document.getElementsByClassName("e-map-labelContainer");
              var totalHeight = size[0].offsetHeight;
              var totalWidth = size[0].offsetWidth;
              
              map._width = map._width - totalWidth;
              map._marginleft = totalWidth;
              
          },
		
		 _sizeCalculation: function (map) {

            var colorMappings = this.shapeSettings.colorMappings;
            var isRange = false;
            if (this.shapeSettings.colorMappings != null) {

                if (colorMappings.rangeColorMapping != null)
                {
                    colorMappings = colorMappings.rangeColorMapping;
                    isRange = true;
                }
                if (colorMappings.equalColorMapping != null)
                {
                    colorMappings = colorMappings.equalColorMapping;
                }
                        
                var width = 0;
                var height = 0;
                var rowSpacing = this.legendSettings.rowSpacing;
                var columnSpacing = this.legendSettings.columnSpacing;
                var iconWidth = this.legendSettings.iconWidth + 5;
                var iconHeight = this.legendSettings.iconHeight + 5;
                var legendHeight = iconHeight + rowSpacing;
                var totalHeight = this.legendSettings.iconHeight + rowSpacing;
                var totalWidth = 0;
                var yPos = 10;
                var xPos = 10;
                var legendSettings = this.legendSettings;
                var columnCount = this.legendSettings.columnCount;
                if (legendSettings.height == 0 && legendSettings.width == 0  && columnCount == 0) {
                    for (var i = 0; i < colorMappings.length; i++) {
                        var label = colorMappings[i].legendLabel != null ? colorMappings[i].legendLabel : (isRange ? colorMappings[i].from : colorMappings[i].value);
                        var labelwidth = this._calcWidth(label);
                        var legendWidth = iconWidth + labelwidth + columnSpacing ;

                        if ((legendSettings.dockOnMap && (legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top || legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom))||!legendSettings.dockOnMap) {
                            if (map._width < (width + legendWidth)) {
                                totalHeight = ((iconHeight) + rowSpacing) + totalHeight;
                                totalWidth = Math.max(totalWidth, width);
                                width = legendWidth;
                            }
                            else {
                                width += (legendWidth + 5);
                            }
                        }
                        else {

                            if (map._height < (height + iconHeight + rowSpacing)) {
                                totalWidth += width;
                                totalHeight = Math.max(totalHeight, height);
                                width = legendWidth;
                                height = 0;
                            }
                            else {
                                height += (iconHeight + rowSpacing);
                                width = Math.max(legendWidth, width);
                            }
                        }


                    }
                    if ((legendSettings.dockOnMap && (legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top || legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom)) || !legendSettings.dockOnMap) {
                        totalWidth = Math.max(totalWidth, width);
                        totalHeight += 5;
                    }
                    else {
                        totalWidth += (width + columnSpacing);
                        totalHeight = Math.max(totalHeight, height);
                    }

                }
                else if (columnCount == 0) {
                    if ((legendSettings.height.toString().indexOf("%")) != -1) {

                        totalHeight = (map._height / 100) * parseInt(legendSettings.height.toString().replace('%', ''))
                    }
                    else {

                        totalHeight = legendSettings.height;
                    }
                    if ((legendSettings.width.toString().indexOf("%")) != -1) {

                        totalWidth = (map._width / 100) * parseInt(legendSettings.width.replace('%', ''))
                    }
                    else {

                        totalWidth = legendSettings.width;
                    }

                }

                if (legendSettings.height == 0 && legendSettings.width == 0 && columnCount != 0) {

                    for (var i = 0; i < colorMappings.length; i++) {
                        var label = colorMappings[i].legendLabel != null ? colorMappings[i].legendLabel : (isRange ? colorMappings[i].from : colorMappings[i].value);
                        var labelwidth = this._calcWidth(label);

                        var legendWidth = iconWidth + labelwidth + columnSpacing ;

                        if (i % columnCount != 0) {
                            width += legendWidth;
                            if (i == columnCount - 1) {
                                totalWidth = Math.max(totalWidth, width);
                            }

                        }
                        else {
                            if (i != 0)
                                totalHeight = (iconWidth + rowSpacing) + totalHeight;
                            totalWidth = Math.max(totalWidth, width);
                            width = legendWidth;
                        }
                    }
                }
            }
        
        
            if (legendSettings.height != 0 && legendSettings.width != 0)
			{
				 totalHeight = legendSettings.height;
				 totalWidth = legendSettings.width;
            }

			map._legendSize = { height: totalHeight, width: totalWidth };
			if (legendSettings.dockOnMap) {
			    if (legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive) {
			        totalHeight = 55;
			    }
			    if (this.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom) {
			        map._height = map._height - parseFloat(totalHeight);
			        this.legendSettings.tempWidth = width;
			    }

			    else if (this.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top) {
			        map._height = map._height - parseFloat(totalHeight);
			        map._margintop = parseFloat(totalHeight);
			    }
			    else if (this.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Left) {

			        map._width = map._width - totalWidth;
			        map._marginleft = totalWidth;
			    }
			    else if (this.legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Right) {
			        map._height = map._height;
			        map._width = map._width - totalWidth;
			    }
			}



        },

        
        _clearShapeWidth: function (scale) {
            if (scale == null) scale = 1;
            for (var index = 0; index < this._mapShapes.length; index++) {
                var mapshape = this._mapShapes[index];
                if (!this._contains(this._prevSelectedShapes,mapshape.shape)) {
                    if (_isSVG) {
                        if (this.shapeSettings.colorMappings != null || this.shapeSettings.autoFill) {
                            mapshape.shape.setAttribute("fill", mapshape.shape.getAttribute("nodeValue"));                            
                            
                        }
                        else
                        {  
						    mapshape.shape.setAttribute("nodeValue", this.shapeSettings.fill);
                            mapshape.shape.setAttribute("fill", this.shapeSettings.fill);
                        }                        

                        mapshape.shape.setAttribute("stroke-width", (this.shapeSettings.strokeThickness / scale));
                        mapshape.shape.setAttribute("stroke", this.shapeSettings.stroke);
                    }
                    else {
                        mapshape.shape.fillcolor = mapshape.shape.style.behavior;
                        mapshape.shape.strokeweight = this.shapeSettings.strokeThickness;
                        mapshape.shape.strokecolor = this.shapeSettings.stroke;
                    }
                }
            }
            


        },
			
       _shapeSelection: function () {
            for (var index = 0; index < this._mapShapes.length; index++) {
                var mapshape = this._mapShapes[index];
                var check = this._shapeContains(this.selectedItems, mapshape.shapeIndex);
                if (check.isContains) {
                     if (!this._contains(this._prevSelectedShapes, mapshape.shape))
                     this._prevSelectedShapes.push(mapshape.shape);
                     if (_isSVG) {
                        mapshape.shape.setAttribute("fill", this.shapeSettings.selectionColor);
                        mapshape.shape.setAttribute("stroke-width", this.shapeSettings.selectionStrokeWidth);
                        mapshape.shape.setAttribute("stroke", this.shapeSettings.selectionStroke);
                    }
                    else {
                        mapshape.shape.fillcolor = this.shapeSettings.selectionColor;
                        mapshape.shape.strokeweight = this.shapeSettings.selectionStrokeWidth;
                        mapshape.shape.strokecolor = this.shapeSettings.selectionStroke;
                    }
                }
            }
        },
                
        _rgbToHex: function(R, G, B) {
             return "#" + this._toHex(R) + this._toHex(G) + this._toHex(B);
        },
                
        _toHex: function (n) {
            var charstr = "0123456789ABCDEF";
            n = parseInt(n, 10);
            if (isNaN(n)) return "00";
            n = Math.max(0, Math.min(n, 255));
            return charstr.charAt((n - n % 16) / 16)
                + charstr.charAt(n % 16);
        },
                
        _hexToR: function(h) {
             return parseInt((this._cropHex(h)).substring(0, 2), 16);
        },
               
        _hexToG: function(h) {
             return parseInt((this._cropHex(h)).substring(2, 4), 16);
        },
       
        _hexToB: function(h) {
             return parseInt((this._cropHex(h)).substring(4, 6), 16);
        },
      
        _cropHex: function(h) {
             return (h.charAt(0) == "#") ? h.substring(1, 7) : h;
        },
                
        _getRangeColorValues: function(range, start, end) {
            var rangeColorValues = [];
            rangeColorValues.push(start);
            if (start > end) {
                var rangeValue = (start - end) / (range-1);
                for (var i = range; i > 2; i--) {
                    start = start - rangeValue;
                    rangeColorValues.push(start);
                }
            }
            else {
                var rangeValue = (end - start) / (range-1);
                for (var i = 2; i < range; i++) {
                    start = start + rangeValue;
                    rangeColorValues.push(start + rangeValue);
                }
            }
            rangeColorValues.push(end);
            return rangeColorValues;
        },
       
        _generateGradientCollection: function(gradientColors) {
            var gradientCollection = [];
            var startRangeColor = gradientColors[0];
            var endRangeColor = gradientColors[gradientColors.length - 1];
            var startR = this._hexToR(startRangeColor);
            var startG = this._hexToG(startRangeColor);
            var startB = this._hexToB(startRangeColor);
            var endR = this._hexToR(endRangeColor);
            var endG = this._hexToG(endRangeColor);
            var endB = this._hexToB(endRangeColor);
            var range = 10;
            var rRange = this._getRangeColorValues(range, startR, endR);
            var gRange = this._getRangeColorValues(range, startG, endG);
            var bRange = this._getRangeColorValues(range, startB, endB);
            for (var i = 0; i < range; i++) {
                gradientCollection.push(this._rgbToHex(rRange[i], gRange[i], bRange[i]));
            }
            return gradientCollection;
        },
		
        _calculateTextWidth: function (text) {
            var span = $('<span>' + text + '</span>');
            $('body').append(span);
            var width = span.width();
            span.remove();    
            return width;
        },
        
        _trimFunction: function (str, width) {
      
            var span = $("#spantag").text(str);
            var text = str;
            while (span.width() > width)
            {    
                text = text.slice(0, -2);
                span.text(text + "...");   
            }

            return text;
    
        },
               
        _createLabel:function(content, xpos, ypos,className) {
            var label = $("<div class="+className+"></div>"); // document.createElementNS(this._svgns, "text");
			label[0].innerHTML = content;
			label.css({
                "margin-left": xpos + "px",
                "margin-top": ypos + "px",
                "position": "absolute"
			});
            return label;
        },
                
        _createInteractiveArrow: function (xpos, ypos) {
            
            var interactiveElement = $("<div class='e-icon1 e-interactiveArrow'></div>");            
            interactiveElement[0].innerHTML = "&#9650";
            
            interactiveElement.css({
                "margin-left": xpos + "px",
                "margin-top": ypos + "px",
                "position": "absolute",                
                
            });
            return interactiveElement;
        },
         _getEllipseLegend: function (xPos, yPos) {

            var rect = $("<div class='e-mapLegend'/>");
            rect.css({
                "height": this.legendSettings.iconHeight + "px",
                "width": this.legendSettings.iconWidth + "px",
                "border-radius": this.legendSettings.iconHeight / 2 + "px",
                "left": xPos + "px",
                "top": yPos + "px",
                "position": "absolute"
            });
            return rect;

        },

        _getRectLegend: function (xPos, yPos) {
            var rect = $("<div />");
            rect.css({
                "height": this.legendSettings.iconHeight + "px",
                "width": this.legendSettings.iconWidth + "px",
                "left": xPos + "px",
                "top": yPos + "px",
                "position": "absolute"
            });
            return rect;
        },
		
		_generateLegend: function (map) {

            var isRange = true;
            var colormapping = null;
            if (this.shapeSettings.colorMappings.rangeColorMapping != undefined) {
                colormapping = this.shapeSettings.colorMappings.rangeColorMapping;
            } else if (this.shapeSettings.colorMappings.equalColorMapping != undefined) {
                colormapping = this.shapeSettings.colorMappings.equalColorMapping;
                isRange = false;
            }
                var xPos = 0;
                var yPos = 0;
                var legendSettings = this.legendSettings;
                var columnWidth = 0;
                var height1;
                var width1;                
           
            var rowSpacing = legendSettings.rowSpacing;
            var columnSpacing = legendSettings.columnSpacing;
            var iconwidth = legendSettings.iconWidth + 5;
            var totalHeight = legendSettings.iconHeight + rowSpacing;
            var totalWidth = 0;
            var columnCount = legendSettings.columnCount;
            for (var i = 0; i < colormapping.length; i++) {
                var label = colormapping[i].legendLabel = colormapping[i].legendLabel != null ? colormapping[i].legendLabel : (isRange ? colormapping[i].from : colormapping[i].value);
                var labelwidth = this._calcWidth(label);

                var legendWidth = legendSettings.iconWidth + columnSpacing + labelwidth;
                var legendHight = legendSettings.iconHeight;


                    if (columnCount != 0) {
                        if (i % columnCount != 0) {

                            this._drawLegend(colormapping[i], xPos, yPos,map);
                            xPos += (legendWidth + 5);

                        }
                    else {
                        if (i != 0)
                            yPos += (legendSettings.iconHeight + rowSpacing);
                        xPos = 0;
                        this._drawLegend(colormapping[i], xPos, yPos, map);
                        xPos += (legendWidth + 5);
                    }
                }
                else {
                    if (legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Top || legendSettings.dockPosition == ej.datavisualization.Map.DockPosition.Bottom) {

                        if (map._legendSize.width < xPos + legendWidth) {

                            yPos += (legendSettings.iconHeight + rowSpacing);
                            xPos = 0;
                            this._drawLegend(colormapping[i], xPos, yPos, map);
                            xPos += legendWidth;
                        }
                        else {
                            this._drawLegend(colormapping[i], xPos, yPos, map);
                            xPos += legendWidth;
                        }
                    }
                    else {

                        if (map._legendSize.height < yPos + legendSettings.iconHeight) {

                            yPos = 0;
                            xPos += (columnWidth + (columnSpacing ));
                            this._drawLegend(colormapping[i], xPos, yPos, map);
                            columnWidth = 0;
                            yPos += (legendSettings.iconHeight + rowSpacing);
                        }
                        else {
                            this._drawLegend(colormapping[i], xPos, yPos, map);
                            columnWidth = Math.max(columnWidth, legendWidth);
                            yPos += (legendSettings.iconHeight + rowSpacing);
                        }
                    }

                }

                    if (map._legendDivHeight > yPos) {
                        height1 = map._legendDivHeight;
                    }
                    else {
                        height1 = yPos + legendHight;
                    }

                    if (map._legendDivWidth > xPos + legendWidth) {
                        width1 = map._legendDivWidth;
                    }
                    else {
                        width1 = xPos + legendWidth;
                    }

                    map._legendDivWidth = width1;
                    map._legendDivHeight = height1;                    
                    
            }
        },
        _drawLegend: function (colormapping, xPos, yPos,map) {
            var legendItem;
            if (this.legendSettings.icon == ej.datavisualization.Map.LegendIcons.Circle) {
                legendItem = this._getEllipseLegend(xPos, yPos);
            }
            else {
                legendItem = this._getRectLegend( xPos, yPos);
            }
            xPos += (this.legendSettings.iconWidth + 5);
            $(legendItem).css("background-color", colormapping.color);
            legendItem.appendTo(map._legendDiv);
            var legendText = $("<div class='e-defaultLegendLabel'/>");
            legendText.css({
                "left": xPos + "px",
                "top": yPos + "px",
                "position": "absolute",
                "text-overflow": "ellipsis",
                "white-space": "nowrap",
                "overflow":"hidden"
            });
            legendText[0].title = colormapping.legendLabel;
            legendText[0].innerHTML = colormapping.legendLabel;
            legendText.appendTo(map._legendDiv);
        },



      _generateLegends: function (map) {
            var colorMappings = this.shapeSettings.colorMappings;
            if ((colorMappings.rangeColorMapping != null) || (colorMappings.equalColorMapping != null)) {
                var xPos = 0;
                var yPos = 0;
                var legendSettings = this.legendSettings;
                var columnWidth = 0;
                var width = 0;
                var height = 0;
                var iconWidth = this.legendSettings.iconWidth + 5;
                var iconHeight = this.legendSettings.iconHeight + 5;
                var rowSpacing = this.legendSettings.rowSpacing;
                var columnSpacing = this.legendSettings.columnSpacing;
                var legendHeight = this.legendSettings.iconHeight + this.legendSettings.rowSpacing;
                var totalHeight = iconHeight + this.legendSettings.rowSpacing;
                var totalWidth = 0;
                if ((this.legendSettings.showLegend == undefined || this.legendSettings.showLegend) && !this.shapeSettings.autoFill) {
                    $(map._mapContainer).append($('<div  id="labelTooltip" style="display:none;background-color:grey;padding-left:5px; padding-right:5px;position:absolute;z-index:1000;pointer-events:none;"/>'));
                    var baseLayer = this;
                    var xpos = 10;
                    var ypos = 0;

                    var totalHeight = this.iconHeight + this.legendSettings.rowSpacing;
                    var _legendheight = this.legendSettings.height;
                    var _legendwidth = this.legendSettings.width;
                    var legenddiv = $("<div/>");
                    if (baseLayer.legendSettings.dockOnMap) {
                        legenddiv = $(map._legendDiv);
                    }
                    else if (!baseLayer.legendSettings.dockOnMap && (baseLayer.legendSettings.mode != ej.datavisualization.Map.LegendMode.Interactive)) {
                        legenddiv = $(map._legendDiv);
                    }
                    else {
                        if (_isSVG) {
                            legenddiv.appendTo(map._templateDiv);
                        }
                        else {
                            map._templateDiv.append(legenddiv);
                        }
                    }


                    if ((this.legendSettings.type == undefined || this.legendSettings.type == ej.datavisualization.Map.LegendType.Layers) && this.shapeSettings.colorMappings != null
                       && (this.legendSettings.mode == undefined || this.legendSettings.mode == ej.datavisualization.Map.LegendMode.Default || (this.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive
                       && this.shapeSettings.colorMappings.equalColorMapping != null))) {

                        this._generateLegend(map);


                    } else if ((this.legendSettings.type == undefined || this.legendSettings.type == ej.datavisualization.Map.LegendType.Layers) && this.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive && this.shapeSettings.colorMappings != null) {
                        var textcon = '';

                        if (this.legendSettings.height == 0)
                            _legendheight = 18;
                        if (this.legendSettings.width == 0)
                            _legendwidth = 150;

                        if (this.legendSettings.leftLabel == null)
                            this.legendSettings.leftLabel = '';
						if (this.legendSettings.rightLabel == null)
							this.legendSettings.rightLabel = '';
                        if (this.legendSettings.title != null) {
                            var newxpos = xpos;
                            if (!this.legendSettings.showLabels)
                                newxpos = xpos + this.legendSettings.leftLabel.length * 10;

                            var _legendtitlewidth = this.legendSettings.title.length * 10;
                            var text = titleText = this.legendSettings.title;;

                            if (_legendtitlewidth > _legendwidth) {
                                for (var i = 1; i < titleText.toString().length; i++) {
                                    text = titleText.toString().substring(0, i - 1) + '...';
                                }
                            }
                            var textcon = this._createLabel(text, newxpos, ypos, 'e-interactivelegend-title');
                            textcon[0].title = titleText;
                            textcon.css({
                                "width": _legendwidth + "px"
                            });
                            if (_isSVG)
                                textcon.appendTo(legenddiv);
                            else
                                legenddiv.append(textcon);
                            ypos += 25;
                        }

                        if (this.legendSettings.showLabels)
                            ypos += 25;

                        if (this.legendSettings.leftLabel != null && !this.legendSettings.showLabels) {
                            var textcon = this._createLabel(this.legendSettings.leftLabel, xpos, ypos - 3, 'e-interactivelegend-leftlabel');

                            if (_isSVG)
                                textcon.appendTo(legenddiv);
                            else
                                legenddiv.append(textcon);
                            xpos = xpos + this.legendSettings.leftLabel.length * 10;
                        }

                        var interactiveElement = this._createInteractiveArrow(xpos, ypos + _legendheight);
                        interactiveElement.appendTo(legenddiv);
                        this._interactiveArrow = interactiveElement;

                        var _legendgroup = null;
                        if (!_isSVG && this.shapeSettings.enableGradient) {
                            _legendgroup = map._createGroup(false, "legendGroup");
                            _legendgroup.style.left = 0 + 'px';
                            _legendgroup.style.top = 0 + 'px';
                            _legendgroup.style.position = "relative";
                            legenddiv.append(_legendgroup);
                        }
						
                        var mappings= colorMappings.rangeColorMapping;
                        for (var key = 0; key < mappings.length; key++) {
                            var colorMapping = mappings[key];
                            if (!colorMapping.hideLegend) {
                                var gradientCollection = [];
                                if (this.shapeSettings.enableGradient) {
                                    gradientCollection = this._generateGradientCollection(colorMapping.gradientColors);
                                }

                                var obj = {};
                                if (this.shapeSettings.enableGradient) {
                                    if (_isSVG) {
                                        var canvas = $("<canvas/>");
                                        var ctx = canvas[0].getContext("2d");
                                        var grd = ctx.createLinearGradient(0, 0, 300, 0);

                                        var temp = 0;
                                        for (var i = 0; i < 10; i++) {
                                            temp = temp + (1 / 10);
                                            if (i == 0) {
                                                grd.addColorStop(0, colorMapping.gradientColors[0]);
                                                grd.addColorStop(temp, gradientCollection[i]);
                                            } else if (i == gradientCollection.length - 1) {
                                                grd.addColorStop(temp - (1 / 10), gradientCollection[i]);
                                                grd.addColorStop(temp, colorMapping.gradientColors[1]);
                                            } else {
                                                grd.addColorStop(temp - (1 / 10), gradientCollection[i]);
                                                grd.addColorStop(temp, gradientCollection[i + 1]);
                                            }
                                        }
                                        ctx.fillStyle = grd;
                                        ctx.fillRect(0, 0, 300, 300);
                                        canvas.css({
                                            "height": _legendheight + "px",
                                            "width": (_legendwidth / mappings.length) + "px",
                                            "margin-left": xpos + "px",
                                            "margin-top": ypos + "px",
                                            "opacity": "0.9",
                                            "filter": "alpha(opacity=90)", /* For IE8 and earlier */
                                            "position": "absolute"
                                        });
                                        canvas.appendTo(legenddiv);
                                    } else {
                                        var legendID = "legend" + key;
                                        var legendHtmlString = '<v:rect id=' + legendID + ' display="block" style="position:absolute;top: ' + (ypos - 2) + 'px;left:' + xpos + 'px;width:' + (_legendwidth / mappings.length) + 'px;height:' + _legendheight + 'px;"><v:fill opacity="0.9px" type="gradient" method="linear sigma" angle="270"/><v:stroke opacity="0px"/></v:rect>';
                                        _legendgroup.innerHTML = _legendgroup.innerHTML + legendHtmlString;
                                        var legendelement = document.getElementById(legendID);
                                        legendelement.fillcolor = colorMapping.gradientColors[0];
                                        legendelement.fill.color2 = colorMapping.gradientColors[1];
                                    }
                                }
                                else {
                                    var rect = $("<div/>");
                                    rect.css({
                                        "height": _legendheight + "px",
                                        "width": _legendwidth / this.shapeSettings.colorMappings.rangeColorMapping.length + "px",
                                        "background-color": colorMapping.color,
                                        "margin-left": xpos + "px",
                                        "margin-top": ypos + "px",
                                        "opacity": "0.9",
                                        "filter": "alpha(opacity=90)",/* For IE8 and earlier */
                                        "position": "absolute"
                                    });

                                    if (_isSVG)
                                        rect.appendTo(legenddiv);
                                    else
                                        legenddiv.append(rect);
                                }

                                for (var i = 0; i < 10; i++) {
                                    obj = {};
                                    obj["marginLeft"] = xpos;
                                    this._legendRects.push(obj);
                                    xpos = xpos + (_legendwidth / mappings.length) / 10;
                                }

                                if (this.legendSettings.showLabels) {
                                    var labelxpos = xpos - (_legendwidth / mappings.length);
                                    var labelypos = ypos - 25;
                                    var startlabel = this._createLabel((colorMapping.from), labelxpos, labelypos, 'e-legend-rangestartlabel');
                                    labelxpos = xpos;
                                    var endlabel = this._createLabel((colorMapping.to), labelxpos, labelypos);
                                    if (colorMapping.legendLabel != undefined)
                                        endlabel = this._createLabel((colorMapping.legendLabel), labelxpos - (colorMapping.legendLabel.length * 10) / 2, labelypos, 'e-legend-rangeendlabel');
                                    if (_isSVG) {
                                        if (colorMapping == mappings[0])
                                            startlabel.appendTo(legenddiv);
                                        endlabel.appendTo(legenddiv);
                                    }
                                    else {
                                        if (colorMapping == mappings[0])
                                            legenddiv.append(startlabel);
                                        legenddiv.append(endlabel);
                                    }
                                }
                            }
                        }

                        if (this.legendSettings.rightLabel != null && !this.legendSettings.showLabels) {
                            var textcon = this._createLabel(this.legendSettings.rightLabel, xpos + 10, ypos - 3, 'e-interactivelegend-rightlabel');
                            if (_isSVG)
                                textcon.appendTo(legenddiv);
                            else
                                legenddiv.append(textcon);
                            xpos = xpos + this.legendSettings.rightLabel.length * 10;
                        }

                        totalwidth = xpos + 10;
                        totalheight = ypos + _legendheight  + 10;
						map._legendSize = { width: totalwidth, height: totalheight };
						if (baseLayer.legendSettings.dockOnMap) {
						    if (this.legendSettings.dockPosition == 'left')
						        map._marginleft = totalwidth;
						    else if (this.legendSettings.dockPosition == 'top')
						        map._margintop = totalheight;
						    
						}
                    }

                    if (!baseLayer.legendSettings.dockOnMap && this.legendSettings.position == 'none') {
                        var posx = (map._width * this.legendSettings.positionX) / 100;
                        var posy = (map._height * this.legendSettings.positionY) / 100;
                        legenddiv.css({ "margin-left": posx + "px", "margin-top": posy + "px" });
                        
                    }
                    else if (!baseLayer.legendSettings.dockOnMap && (this.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive)) {
                        var position = (this.legendSettings.position == undefined) ? "topleft" : this.legendSettings.position;
                        var controlSize = { width: totalwidth, height: totalheight };
                        var navPos = map._getPosition(position, controlSize);
                        legenddiv.css({ "margin-left": navPos.x + "px", "margin-top": navPos.y });

                    }
                }
                    

                   
                
            }
        },

      _generateLabels: function (map) {          
          
          var labeldiv = $("<div class='e-map-labelContainer'></div>");

          $(labeldiv).css({ "position": "absolute", "overflow": "scroll" });
                 
          for (var dataIndex = 0; dataIndex < this._polygonData.length; dataIndex++) {

              var ValueObject = this._polygonData[dataIndex].properties;
              var labelValue = map._reflection(ValueObject, this.labelSettings.labelPath);                          
              var labelElement = $("<div class='e-map-label'></div>");
              $(labelElement).css({ "margin-top":dataIndex*20, "position": "absolute" });
              labelElement[0].innerHTML = labelValue;
              labeldiv.append(labelElement);              
              map._mapContainer.append(labeldiv);              
              labelElement.mouseenter({ Param1: this, Param2: this._mapShapes[dataIndex], map: map }, map._polyEnterFunction);

              map._off($(labelElement), ej.eventType.mouseUp, map._polyClickFunction);              
              map._on($(labelElement), ej.eventType.mouseUp, { Param1: this._mapShapes[dataIndex], Param2: this, Param3: this._mapShapes[dataIndex].shape, param4: labelElement }, map._polyClickFunction);              

          }         

      },

        _calcWidth: function (text) {
            var span = $('<span  class="e-defaultLegendLabel">' + text + '</span>');
            $('body').append(span);
            var width = span.width()+5;
            span.remove();
            return width;
        },
       

		_generateBubbleLegends: function (map) {
		    if (this.legendSettings.showLegend == undefined || this.legendSettings.showLegend) {
			    var xpos = 10;
                var ypos = 10;
                var _bubblelegendheight = this.legendSettings.iconHeight;
                var _bubblelegendwidth = this.legendSettings.iconWidth;
                var bubblelegenddiv = $("<div/>");
                if (_isSVG) {
                    bubblelegenddiv.appendTo(map._templateDiv);
                }
                else {
                    map._templateDiv.append(bubblelegenddiv);
                }
				var totalwidth = 0;
                var totalheight = 0;
                var isRange = true;
                var mappings = null;
                if (this.bubbleSettings.colorMappings.rangeColorMapping != undefined) {
                    mappings = this.bubbleSettings.colorMappings.rangeColorMapping;
                } else if (this.bubbleSettings.colorMappings.equalColorMapping != undefined) {
                    mappings = this.bubbleSettings.colorMappings.equalColorMapping;
                    isRange = false;
                }
                if ((this.legendSettings.type == ej.datavisualization.Map.LegendType.Bubbles) && this.bubbleSettings.colorMappings != null
                   && (this.legendSettings.mode == undefined || this.legendSettings.mode == ej.datavisualization.Map.LegendMode.Default || (this.legendSettings.mode == ej.datavisualization.Map.LegendMode.Interactive
                   && this.bubbleSettings.colorMappings.equalColorMapping != null))) {                    
				    if (this.legendSettings.iconHeight == undefined)				      
				    this.legendSettings.iconHeight = 20;
				    if (this.legendSettings.iconWidth == undefined)                    
				    this.legendSettings.iconWidth = 20;
                    for (var key = 0; key < mappings.length; key++) {
                        var colorMapping = mappings[key];
                        if (!colorMapping.hideLegend) {
                            var rect = $("<div class='e-mapBubbleLegend'/>");

                            if (this.legendSettings.icon == ej.datavisualization.Map.LegendIcons.Circle) {
                                rect.css({
                                    "height": this.legendSettings.iconHeight + "px",
                                    "width": this.legendSettings.iconWidth + "px",
                                    "border-radius": this.legendSettings.iconHeight / 2 + "px",
                                    "background-color": colorMapping.color,
                                    "margin-left": xpos + "px",
                                    "margin-top": ypos + "px",
                                    "position": "absolute"
                                });
                            }
                            else {
                                rect.css({
                                    "height": this.legendSettings.iconHeight + "px",
                                    "width": this.legendSettings.iconWidth + "px",
                                    "background-color": colorMapping.color,
                                    "margin-left": xpos + "px",
                                    "margin-top": ypos + "px",
                                    "position": "absolute"
                                });
                            }
							var textcon = this._createLabel(colorMapping.legendLabel, xpos + _bubblelegendwidth + 5, ypos, 'e-legendlabeltext');
							if (colorMapping.legendLabel != null) {
                                textcon[0].innerText= colorMapping.legendLabel;

                            } else {
                                colorMapping.legendLabel = textcon[0].innerText = isRange ? colorMapping.from : colorMapping.value;
                            }
							if (_isSVG) {
                                rect.appendTo(bubblelegenddiv);
                                textcon.appendTo(bubblelegenddiv);
                             }
                             else {
                                 bubblelegenddiv.append(rect);
                                 bubblelegenddiv.append(textcon);
							}
							if (totalwidth < (textcon[0].innerText.length * 10) + _bubblelegendwidth)
							    totalwidth = (textcon[0].innerText.length * 10) + _bubblelegendwidth;
                            var textHeight = textcon.height();
                            var rectHeight = rect.height();
                            if (textHeight > rectHeight) {
                                ypos += (textHeight + 5);
                            } else {
                                ypos += (rectHeight + 5);
                            }
						}
                    }
                    totalheight = ypos;
                }                
				if (this.legendSettings.position == 'none') {
				    var posx = (map._width * this.legendSettings.positionX) / 100;
				    var posy = (map._height * this.legendSettings.positionY) / 100;
                    bubblelegenddiv.css({ "margin-left": posx + "px", "margin-top": posy + "px" });
                } else {
				    var position = (this.legendSettings.position == undefined) ? "topleft" : this.legendSettings.position;
                    var controlSize = { width: totalwidth, height: totalheight };
                    var navPos = map._getPosition(position, controlSize);
                    bubblelegenddiv.css({ "margin-left": navPos.x + "px", "margin-top": navPos.y + "px" });
                }
            }
				
		},
		
        _animateBubble: function (element, delayInterval) {
            var radius = { "fx": element.getAttribute("r") /2 },
                to = radius.fx * 2,
                scaleVal,
                $ele = $(element),
                layer = this;
            $(radius).delay(delayInterval).each(function () { }).animate(
                {
                    fx: to
                },
                {
                    duration: 700,

                    step: function (now) {
                        if (_isSVG) {
                            $ele.attr("style", "display:block;pointer-events:stroke;");
                            $ele.attr("r", now);
                        }
                        else {
                        }
                    },
                    complete: function () {
                        layer._bubbleCount++;
                        if (layer._bubbleCount == layer._bubbles.length) {
                            layer._setMapElements();
                        }
                    }
                }

            );
        },
        
        _setMapElements: function () {
            for (var key = 0; key < this._mapItems.length; key++) {
                var item = this._mapItems[key];                
                $(item).css({ "display": "block" });
            }
        },

        _setMapItemsPositionWithAnimation: function (map) {
            this._bubbleCollection = [];
            for (var key = 0; key < this._bubbles.length; key++) {
                var bubble = this._bubbles[key];
                var bubblerad = this._bubbles[key].getAttribute('r');
                var position = this._bounds[key];               
                var xpos = ((position.x + map._translatePoint.x) * map._scale);
                var ypos = ((position.y + map._translatePoint.y) * map._scale);

                var finalPosition = map.validateBubblePosition(position.points, { x: xpos, y: ypos }, bubblerad);

                var ubound = 20;
                var lbound = 0;
                var randomValue = Math.floor(Math.random() * (ubound - lbound) + lbound);
                var delayInterval = parseInt(randomValue * 50);
                if (_isSVG) {
                    $(bubble).attr({ "cx": finalPosition.x, "cy": finalPosition.y });
                }
                this._animateBubble(bubble, delayInterval);
                this._bubbleCollection.push(bubble);
            }
            for (var key = 0; key < this._mapMarkers.length; key++) {
                var item = this._mapMarkers[key];
                var marker;
                if (this.markers.length > 0) {
                    marker = this.markers[key];
                }                
                var position;
                if (map._isTileMap) {
                    position = map._convertTileLatLongtoPoint(marker.latitude, marker.longitude);
                }
                else {
                    position = map._convertLatLongtoPointforMarker(marker.latitude, marker.longitude);
                }

                if (_isSVG) {
                    var xpos = position.x;
                }
                else {
                    var xpos = ((position.x + map._transformX) * map._scale);
                }
                var ypos = position.y;
                $(item).css({ "display":"block","left": xpos, "top": ypos - 100 });
                $(item).delay(500).each(function () { }).animate({ "top": ypos }, 500);
               
            }
            for (var key = 0; key < this._mapItems.length; key++) {
                var item = this._mapItems[key];
                var position = this._bounds[key];
                var box = item[0].getBoundingClientRect();               
                var cx = this._bubbleCollection[key] ?parseFloat(this._bubbleCollection[key].getAttribute("cx")) :0;
			    var cy =this._bubbleCollection[key] ? parseFloat(this._bubbleCollection[key].getAttribute("cy")):0;
			    var xpos = this._bubbleCollection[key] ? (cx - box.width / 2) : ((position.x + map._translatePoint.x) * map._scale) - (box.width / 2);
			    var ypos = this._bubbleCollection[key] ? (cy - box.height / 4) : ((position.y + map._translatePoint.y) * map._scale) - (box.height / 4);
                if(this._bubbles.length > 0)
				    $(item).css({ "left": xpos, "top": ypos, "display": "none" });
				else
                   $(item).css({ "left": xpos, "top": ypos, "display": "block" });
               
            }
            for (var key = 0; key < this._labelCollection.length; key++) {
                var item = this._labelCollection[key];
                var position = this._labelBounds[key];
                $(item).css("display", "block");
                var box = item[0].getBoundingClientRect();
                var boxwidth =_isSVG?box.width: box.right - box.left;
                var boxheight=_isSVG?box.height: box.bottom - box.top;
                var xpos = ((position.x + map._translatePoint.x) * map._scale) - (boxwidth / 2);
                var ypos = ((position.y + map._translatePoint.y) * map._scale) - (boxheight / 2);
                if (item[0].className = "smartLabelStyle") {                    
                    item[0].className = "labelStyle"; 
                     $(item[0]).css({ "pointer-events": "none", "position": "absolute" });                   
                }
                item[0].innerHTML = this._labelData[key];
                $(item).css({ "left": xpos, "top": ypos });

            }
            if (this.labelSettings!=null && this.labelSettings.showLabels) {
                this._validateSmartLabel(map);
            }
        },

        _resizeShapes: function (map) {
            var thickness = this.shapeSettings.strokeThickness / map._scale;
            if (this._mapShapes != undefined) {
            for (var i = 0; i < this._mapShapes.length; i++) {
                var element = this._mapShapes[i].shape;
                if (_isSVG) {
                    if (element.localName == 'circle') {
                        element.setAttribute("r", this.shapeSettings.radius / map._scale);
                    } else {
                        if (this._contains(this._prevSelectedShapes,element)) {
                            element.setAttribute("stroke-width", this.shapeSettings.selectionStrokeWidth / map._scale);
                        } else {
                            element.setAttribute("stroke-width", thickness);
                        }
                    }
                } else {
                    if (element.nodeName == 'oval') {

                    } else {
                        if (this._contains(this._prevSelectedShapes,element)) {
                            element.strokeweight = this.shapeSettings.selectionStrokeWidth / map._scale;
                        } else {
                            element.strokeweight = thickness;
                        }
                    }
                }
            }
          }
        },
       
       _setMapItemsPosition: function(map) {
            this._bubbleCollection = [];
			
			if(this._bubbles!=undefined)
			{
            for (var key = 0; key < this._bubbles.length; key++) {
                var bubble = this._bubbles[key];
                var bubblerad = this._bubbles[key].getAttribute('r');
                var position = this._bounds[key];
                if (_isSVG) {
                    var xpos = ((position.x + map._translatePoint.x) * map._scale);
                    var ypos = ((position.y + map._translatePoint.y) * map._scale);

                    var finalPosition = map.validateBubblePosition(position.points, { x: xpos, y: ypos }, bubblerad);

                    $(bubble).attr({ "cx": finalPosition.x, "cy": finalPosition.y });
                }
                else {
                    bubble = document.getElementById(bubble.id);
                    var xpos = ((position.x + map._translatePoint.x) * map._scale);
                    var ypos = ((position.y + map._translatePoint.y) * map._scale);

                    var finalPosition = map.validateBubblePosition(position.points, { x: xpos, y: ypos }, bubblerad);

                    var bubbleTop = finalPosition.y - (bubble.getBoundingClientRect().bottom - bubble.getBoundingClientRect().top) / 2;
                    var bubbleLeft = finalPosition.x - (bubble.getBoundingClientRect().right - bubble.getBoundingClientRect().left) / 2;
                    
                    $(bubble).css({
                        "left": bubbleLeft,
                        "top": bubbleTop
                    });
                }
                this._bubbleCollection.push(bubble);
            }
			}
			if(this._mapItems!=undefined)
			{
            for (var key = 0; key < this._mapItems.length; key++) {
                var item = this._mapItems[key];
                var position = this._bounds[key];
                $(item).css({"display":"block"});
                var box = item[0].getBoundingClientRect();
                var boxwidth = _isSVG ? box.width : box.right - box.left;
                var boxheight = _isSVG ? box.height : box.bottom - box.top;
			    var cx = this._bubbleCollection[key] ?parseFloat(this._bubbleCollection[key].getAttribute("cx")) :0;
			    var cy =this._bubbleCollection[key] ? parseFloat(this._bubbleCollection[key].getAttribute("cy")):0;
			    var xpos = this._bubbleCollection[key] ? (cx - box.width / 2) : ((position.x + map._translatePoint.x) * map._scale) - (box.width / 2);
			    var ypos = this._bubbleCollection[key] ? (cy - box.height / 4) : ((position.y + map._translatePoint.y) * map._scale) - (box.height / 4);
                $(item).css({ "left": xpos, "top": ypos });               
            }
			}
            if(this._mapMarkers!=undefined){
            for (var key = 0; key < this._mapMarkers.length; key++) {
                var item = this._mapMarkers[key];

                var marker;
                if (this.markers.length > 0) {
                    marker = this.markers[key];
                }               
                var position;
                if (map._isTileMap) {
                    position = map._convertTileLatLongtoPoint(marker.latitude, marker.longitude);
                }
                else {
                    position = map._convertLatLongtoPointforMarker(marker.latitude, marker.longitude);
                }            
                var xpos = position.x;               
                var ypos = position.y;            
                $(item).css({ "left": xpos, "top": ypos });                
            }
			}
			if(this._labelCollection!=undefined){
            for (var key = 0; key < this._labelCollection.length; key++) {
                var item = this._labelCollection[key];
                var position = this._labelBounds[key];
                $(item).css("display", "block");
                var box = item[0].getBoundingClientRect();
                var boxwidth = _isSVG ? box.width : box.right - box.left;
                var boxheight = _isSVG ? box.height : box.bottom - box.top;
                var xpos = ((position.x + map._translatePoint.x) * map._scale) - (boxwidth / 2);
                var ypos = ((position.y + map._translatePoint.y) * map._scale) - (boxheight / 2);
                if (item[0].className = "smartLabelStyle") {                    
                    item[0].className = "labelStyle";
                    $(item[0]).css("background-color", "transparent");
                    $(item[0]).css({ "pointer-events": "none", "position": "absolute" });
                }
                item[0].innerHTML = this._labelData[key];
                $(item).css({ "left": xpos, "top": ypos});
               
            }
			}
            if (this.labelSettings != null && this.labelSettings.showLabels) {
                this._validateSmartLabel(map);
            }
        },
       
        _validateSmartLabel: function (map) {
            this._smartLabels = [];
            var filledRects = [];
            if (this._labelCollection.length > 0) {
                for (var index = 0; index < this._mapShapes.length; index++) {
                    var shapemidPoint = this._labelBounds[index];
                    var midPoint = { x: (shapemidPoint.x + map._translatePoint.x) * map._scale, y: (shapemidPoint.y + map._translatePoint.y) * map._scale };

                    var rightMinPoint = { x: (shapemidPoint.rightMin.x + map._translatePoint.x) * map._scale, y: (shapemidPoint.rightMin.y + map._translatePoint.y) * map._scale };
                    var rightMaxPoint = { x: (shapemidPoint.rightMax.x + map._translatePoint.x) * map._scale, y: (shapemidPoint.rightMax.y + map._translatePoint.y) * map._scale };
                    var leftMinPoint = { x: (shapemidPoint.leftMin.x + map._translatePoint.x) * map._scale, y: (shapemidPoint.leftMin.y + map._translatePoint.y) * map._scale };
                    var leftMaxPoint = { x: (shapemidPoint.leftMax.x + map._translatePoint.x) * map._scale, y: (shapemidPoint.leftMax.y + map._translatePoint.y) * map._scale };

                    var labelElement = this._labelCollection[index];
                    if (midPoint.x > 0 && midPoint.x < map._width && midPoint.y > 0 && midPoint.y < map._height) {
                        var shape = this._mapShapes[index].shape;
                        var bounds = shape.getBoundingClientRect();                        
                        var flag = false;
                        var labelSize = labelElement[0].getBoundingClientRect();
                        var labelHeight = labelSize.height;
                        var labelWidth = labelSize.width;
                        if (!_isSVG) {
                            bounds = { width: (bounds.right*map._scale) - (bounds.left*map._scale), height: (bounds.bottom *map._scale)- (bounds.top*map._scale) };
                            labelHeight = labelSize.bottom - labelSize.top;
                            labelWidth = labelSize.right - labelSize.left;
                        }

                        var rightIntersect = false, leftIntersect = false;
                        if ((labelWidth / 2 > rightMinPoint.x - midPoint.x || labelWidth / 2 > rightMaxPoint.x - midPoint.x)
                            && (labelHeight / 2 > midPoint.y - rightMinPoint.y || labelHeight / 2 > rightMaxPoint.y - midPoint.y)) {
                            rightIntersect = true;
                        }
                        else if ((labelWidth / 2 > midPoint.x - leftMinPoint.x || labelWidth / 2 > midPoint.x - leftMaxPoint.x)
                            && (labelHeight / 2 > midPoint.y - leftMinPoint.y || labelHeight / 2 > leftMaxPoint.y - midPoint.y)) {
                            leftIntersect = true;
                        }
                        
                        var leftPosition = 0;
                        var topPosition = 0;
                        var factor = 20;
                        var xArray = [];
                        var yArray = [];
                        if (labelHeight > bounds.height || labelWidth > bounds.width || (rightIntersect || leftIntersect)) {
                            
                            if (this.labelSettings.enableSmartLabel) {
                                if (this.labelSettings.smartLabelSize == ej.datavisualization.Map.LabelSize.Fixed) {
                                    labelHeight = 25;
                                    labelWidth = 15 * this.labelSettings.labelLength;
                                }
                                else {                                    
                                    labelWidth *= 1.3;
                                    labelHeight = 25;
                                }
                                while (!flag) {
                                    if (factor > 400) {
                                        flag = true;
                                    }
                                    xArray = pushToArray(factor);
                                    yArray = xArray;
                                    for (var xIndex = 0; xIndex < xArray.length; xIndex++) {
                                        for (var yIndex = 0; yIndex < xArray.length; yIndex++) {
                                            leftPosition = yArray[yIndex];
                                            topPosition = xArray[xIndex];                                           
                                            if (midPoint.x + leftPosition + labelWidth > map._width && midPoint.x < map._width) {
                                                leftPosition -=(midPoint.x + leftPosition + labelWidth)- map._width;
                                            }
                                            if (midPoint.x + leftPosition <0) {
                                                leftPosition =0;
                                            }
                                            if (midPoint.y + topPosition  <0) {
                                                topPosition=0;
                                            }
                                            if (midPoint.y + topPosition + labelHeight > map._height && midPoint.y < map._height) {
                                                topPosition -= (midPoint.y + topPosition + labelHeight) - map._height;
                                            }
                                            var rect = { left: midPoint.x + leftPosition, top: midPoint.y + topPosition, height: labelHeight, width: labelWidth };
                                            if (isEmpty(rect)) {
                                                var ele = map._getIntersectedElements(rect, this._mapShapes);
                                                if (ele != null && ele.length == 0) {
                                                    flag = true;                                                   
                                                    xIndex = xArray.length;
                                                    yIndex = xArray.length;
                                                    labelElement[0].className = 'smartLabelStyle';
                                                    $(labelElement).css({ "pointer-events": "stroke", "position": "absolute" });

                                                    if (this.labelSettings.smartLabelSize == ej.datavisualization.Map.LabelSize.Fixed) {
                                                        labelElement[0].innerHTML = labelElement[0].innerHTML.substring(0, this.labelSettings.labelLength);
                                                    }
                                                    labelElement.mouseenter({ Param1: this, Param2: this._mapShapes[index],map:map }, map._polyEnterFunction);
                                                    labelElement.mousemove({ Param1: this, Param2: this._mapShapes[index] }, map._polyMoveFunction);
                                                    $(labelElement).css({ left: midPoint.x + leftPosition, top: midPoint.y + topPosition, "background-color": _isSVG ? shape.getAttribute("fill") : shape.fillcolor.value});
                                                    filledRects.push(rect);
                                                    var labelObj = {};
                                                    labelObj["shape"] = shape;
                                                    labelObj["legend"] = labelElement;
                                                    this._smartLabels.push(labelObj);
                                                }
                                            }
                                        }
                                    }
                                    factor += 10;
                                }
                            } else {
                                var canExecute = true;
                                var minY = 0;
                                var maxY = 0;
                                var flag = true;

                                // Finding Minimum and Maximum Y position point calculation
                                for (var j = 0; j < shapemidPoint.points.length; j++) {
                                    var point = { x: (shapemidPoint.points[j].x + map._translatePoint.x) * map._scale, y: (shapemidPoint.points[j].y + map._translatePoint.y) * map._scale };
                                    if (flag) {
                                        minY = point.y;
                                        maxY = point.y;
                                        flag = false;
                                    }
                                    else {
                                        minY = Math.min(minY, point.y);
                                        maxY = Math.max(maxY, point.y);
                                    }
                                }

                                var heightfactor = Math.floor((maxY - minY) / labelHeight);
                                var shapePoints = [];

                                // Grouping points based on label height
                                for (var k = 0; k < heightfactor; k++) {
                                    var groupPoints = [];
                                    shapePoints.push(groupPoints);
                                }

                                for (var j = 0; j < shapemidPoint.points.length; j++) {
                                    var point = { x: (shapemidPoint.points[j].x + map._translatePoint.x) * map._scale, y: (shapemidPoint.points[j].y + map._translatePoint.y) * map._scale };
                                    var positionfactor = Math.floor((point.y - minY) / labelHeight);
                                    if (positionfactor > 0)
                                        positionfactor -= 1;
                                    var groupPoints = shapePoints[positionfactor];
                                    if (groupPoints == undefined)
                                        groupPoints = [];
                                    groupPoints.push({ x: point.x, y: point.y });
                                    shapePoints[positionfactor] = groupPoints;
                                }

                                // Finding minimum and maximum x point calculation 
                                for (var j = 0; j < shapePoints.length; j++) {
                                    var groupPoints = shapePoints[j];
                                    flag = true;
                                    var minX =0, maxX =0, top = 0;
                                    var leftPoints = [], rightPoints = [];
                                    
                                    for (var k = 0; k < groupPoints.length; k++) {
                                        if (flag) {
                                            minX = groupPoints[k].x;
                                            maxX = groupPoints[k].x;
                                            top = groupPoints[k].y;
                                            flag = false;
                                        }
                                        else {
                                            minX = Math.min(minX, groupPoints[k].x);
                                            maxX = Math.max(maxX, groupPoints[k].x);
                                            if (groupPoints[k].x == maxX)
                                                top = groupPoints[k].y;
                                        }
                                        if (groupPoints[k].x < midPoint.x)
                                            leftPoints.push(groupPoints[k].x);
                                        if (groupPoints[k].x > midPoint.x)
                                            rightPoints.push(groupPoints[k].x);
                                    }

                                    if (bounds.left < map._mapContainer[0].getBoundingClientRect().left + 1) {
                                        minX = map._mapContainer[0].getBoundingClientRect().left + 1 - bounds.left;
                                        leftPoints.push(minX);
                                    }

                                    //  Checking intersection of points with label.
                                    var intersect = false;
                                    for (var k = 0; k < leftPoints.length; k++) {
                                        if (maxX - leftPoints[k] < labelWidth + 1) {
                                            intersect = true;
                                            break;
                                        }
                                    }
                                    if (!intersect) {
                                        for (var k = 0; k < rightPoints.length; k++) {
                                            if (rightPoints[k] - minX < labelWidth + 1) {
                                                intersect = true;
                                                break;
                                            }
                                        }
                                    }
                                    if (maxX - minX > labelWidth + 1 && !intersect) {
                                        labelElement.css("left", bounds.left * map._scale + (minX - bounds.left * map._scale) + (maxX - minX) / 2 - labelWidth / 2 + "px");
                                        labelElement.css("top", top + "px");
                                        if (maxY - top < labelHeight)
                                            labelElement.css("top", top - labelHeight + "px");
                                        canExecute = false;
                                        break;
                                    }
                                }
                                if(canExecute)
                                    labelElement.css("display", "none");
                            }
                        }
                    } 
                }
            }

            function pushToArray(value) {
                var array = [];
                array.push(0);
                for (var j = 10; j <= value; j += 20) {
                    array.push(-j);
                    array.push(j);
                }

                return array;
            }

            function isEmpty(rect) {
                for (var i = 0; i < filledRects.length; i++) {
                    if (isIntersect(rect, filledRects[i]))
                        return false;
                }
                return true;
            }
           
            function isIntersect(rect1, rect2) {
                
                if (rect1.left - 2 >= (rect2.left + rect2.width) || rect1.left - 2 + rect1.width <= rect2.left - 2 ||
                    rect1.top - 2 >= rect2.top + rect2.height || rect1.top+rect1.height <= rect2.top-2) {
                    return false;
                }
                return true;
            }


        },
              
        _fillColors: function (value, colorMapping, shape) {

            if (colorMapping.rangeColorMapping != null) {
               
                this._fillRangeColors(value, colorMapping.rangeColorMapping, shape);
            }
            else if (colorMapping.equalColorMapping != null) {
                this._fillEqualColors(value, colorMapping, shape);
            }
        },

        _fillEqualColors: function (value, colorMapping, shape) {
            $.each(colorMapping.equalColorMapping, function (index, gValue) {
                if (gValue.value == value) {
                    if (_isSVG) {
                        shape.setAttribute("fill", gValue.color);
                    }
                    else {
                        shape.fillcolor = gValue.color;
                    }
					 shape.highlightcolor = gValue.highlightcolor;
                }
            });
        },
       
        _updateLegendRange: function (value, shapelayer, shape) {
            var colormapping = shapelayer.shapeSettings.colorMappings.rangeColorMapping;
            for (var index = 0; index < colormapping.length; index++) {
                var gradientCollection = null;
                var mapping = colormapping[index];
                if (shapelayer.shapeSettings.enableGradient) {
                    gradientCollection = this._generateGradientCollection(mapping.gradientColors);
                }
                if (value >= mapping.from && value <= mapping.to) {
                    var minValue = index;
                    if (index != 0)
                        minValue = index * 10;
                    var minRange = mapping.from;
                    var maxRange = mapping.from + ((mapping.to - mapping.from) / 10);
                    for (var i = minValue; i < minValue + 10; i++) {
                        if (value >= minRange && value <= maxRange) {
                            var obj = {};
                            var shapeOpacity = this._getColorRatio(0.7, 1, value, mapping.from, mapping.to);
                            if (shapelayer._legendRects[i] != undefined)
                                obj = shapelayer._legendRects[i];
                            if (shapelayer.shapeSettings.enableGradient) {
                                if (index != 0) {
                                    obj["color"] = gradientCollection[i - index * 10];
                                } else {
                                    obj["color"] = gradientCollection[i];
                                }
                            } else
                                obj["color"] = mapping.color;
                                $(shape).css({ "opacity": shapeOpacity });
                            return obj;
                        }
                        minRange = maxRange;
                        maxRange = maxRange + ((mapping.to - mapping.from) / 10);
                    }
                }
            }
        },

        _fillRangeColors: function (value, colormapping, shape) {
            
            for (var index = 0; index < colormapping.length; index++) {
                var mapping = colormapping[index];
                if (value >= mapping.from && value <= mapping.to) {
                    var shapeOpacity = this._getColorRatio(0.7, 1, value, mapping.from, mapping.to);
                    if (_isSVG) {
                        shape.setAttribute("fill", mapping.color);
                    }
                    else {
                        shape.fillcolor = mapping.color;
                    }
					shape.highlightcolor = mapping.highlightcolor;
                    $(shape).css({ "opacity": shapeOpacity });
                }
            }
        },
       
        _getColorRatio: function (min, max, value, minValue, maxValue) {
            var percent = (100 / (maxValue - minValue)) * (value - minValue);
            var colorCode = (((parseFloat(max) - parseFloat(min)) / 100) * percent) + parseFloat(min);
            return colorCode;
        }

    };

    $.fn.pinchZoom = function (rootgroup, map) {

        var stateOrigin,
                    stateTf,
                    root = this[0],
                    startTouches = [],

           getTouchEventPoint = function (evt) {

               var p = root.createSVGPoint(),
                   targetTouches = evt.targetTouches,
                   offsetX,
                   offsetY;

               if (targetTouches.length) {
                   var touch = targetTouches[0];
                   offsetX = touch.pageX;
                   offsetY = touch.pageY;
               }

               p.x = offsetX;
               p.y = offsetY;

               return p;
           },

        handleTouchStart = function (evt) {
            var g = rootgroup;
            stateTf = g.getCTM().inverse();
            stateOrigin = getTouchEventPoint(evt).matrixTransform(stateTf);
            var touches = evt.touches;
            if (touches.length >= 2) {
                evt.preventDefault();
                for (var i = 0; i < touches.length; i++) {
                    var touch = touches[i]
                      , found = false;
                    for (var j = 0; j < startTouches.length; j++) {
                        var startTouch = startTouches[j];
                        if (touch.identifier === startTouch.identifier) {
                            found = true;
                            break;
                        }
                    }
                    if (!found) {
                        var touchCopy = $.extend({}, touch);
                        startTouches.push(touchCopy);
                    }
                }
            }
        },

        getDistance = function (touch1, touch2) {
            var x = touch2.pageX - touch1.pageX,
                y = touch2.pageY - touch1.pageY;
            return Math.sqrt((x * x) + (y * y));
        },

        setCTM = function (element, matrix) {
		    var isZoomIn=null;
            var s = "matrix(" + matrix.a + "," + matrix.b + "," + matrix.c + "," + matrix.d + "," + matrix.e + "," + matrix.f + ")";
            if (matrix.a > map._baseScale && map.model.zoomSettings.enableZoom && map.enablePan()) {
			if(matrix.a > map._scale)
			{
			     isZoomIn=true;
			}
			else if(matrix.a < map._scale)
			{
			isZoomIn=false;
			}
			    map._scale = matrix.a;
			    map._translatePoint.x = matrix.e / matrix.a;
			    map._translatePoint.y = matrix.f / matrix.a;
			    map._applyTransform(map._scale, map._translatePoint);
			    map.model.zoomSettings.level = map._scale - map._baseScale + 1;
			    map._zoomLevel(map._scale - map._baseScale + 1);
	    		if (isZoomIn != null && isZoomIn) {
	    		    map._trigger("zoomedIn", { originalEvent: null, zoomLevel: map._zoomLevel() });
				    map._updateSliderValue(false);
					map._resizeShape();
				}
				else if(isZoomIn!=null)
				{
				    map._trigger("zoomedOut", { originalEvent: null, zoomLevel: map._zoomLevel() });
				    map._updateSliderValue(false);
					map._resizeShape();
				}
	    		map._isDragging = true;
                map._refrshLayers();
            }

        },

        handleTouchEnd = function (evt) {
            var changedTouches = evt.changedTouches;
            for (var i = 0; i < changedTouches.length; i++) {
                var changedTouch = changedTouches[i];
                for (var j = 0; j < startTouches.length; j++) {
                    var startTouch = startTouches[j];
                    if (startTouch.identifier === changedTouch.identifier) {
                        var idx = startTouches.indexOf(startTouch);
                        startTouches.splice(idx, 1);
                    }
                }
            }
            evt.preventDefault();
        },

        updateTouch = function (dstTouch, srcTouch) {
            dstTouch.pageX = srcTouch.pageX;
            dstTouch.pageY = srcTouch.pageY;
        },

        handleTouchMove = function (evt) {
            var g = rootgroup,
                touches = evt.touches,
                z,
                p,
                k;

            if (touches.length >= 2) {
                evt.preventDefault();
                var touch0 = touches[0]
                  , touch1 = touches[1]
                  , startTouch0 = startTouches[0]
                  , startTouch1 = startTouches[1];
                z = getDistance(touch0, touch1) / getDistance(startTouch0, startTouch1);
                p = root.createSVGPoint();
                p.x = (touch0.pageX + touch1.pageX) / 2;
                p.y = (touch0.pageY + touch1.pageY) / 2;
                p = p.matrixTransform(g.getCTM().inverse());
                k = root.createSVGMatrix().translate(p.x, p.y).scale(z).translate(-p.x, -p.y);
                setCTM(g, g.getCTM().multiply(k));
                if (typeof stateTf === "undefined") {
                    stateTf = g.getCTM().inverse();
                }
                stateTf = stateTf.multiply(k.inverse());
                updateTouch(startTouch0, touch0);
                updateTouch(startTouch1, touch1);
            } else if (!startTouches.length) {
                p = getTouchEventPoint(evt).matrixTransform(stateTf);
                setCTM(g, stateTf.inverse().translate(p.x - stateOrigin.x, p.y - stateOrigin.y));
            }
        };
        this[0].addEventListener('touchstart', handleTouchStart, false);
        this[0].addEventListener('touchend', handleTouchEnd, false);
        this[0].addEventListener('touchmove', handleTouchMove, false);


    };

    jQuery.uaMatch = function (ua) {
        ua = ua.toLowerCase();

        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];

        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };
    
	ej.datavisualization.Map.Locale = ej.datavisualization.Map.Locale || {};
    ej.datavisualization.Map.Locale['default'] = ej.datavisualization.Map.Locale['en-US'] = {
        zoomIn: "Zoom In",
        zoomOut: "Zoom Out",
        panTop: "Pan Top",
        panBottom: "Pan Bottom",
        panLeft: "Pan Left",
		panRight: "Pan Right",
		home: "Home"
    };
	
    ej.datavisualization.Map.LayerType = {
        Geometry: "geometry",
        OSM: "osm",
        Bing: "bing"
    };
   
    ej.datavisualization.Map.LegendIcons = {       
        Rectangle: "rectangle",      
        Circle: "circle"
    };
   
    ej.datavisualization.Map.LabelSize = {       
        Fixed: "fixed",        
        Default: "default"
    };

    ej.datavisualization.Map.LegendMode = {       
        Default: "default",       
        Interactive: "interactive"		
    };

    ej.datavisualization.Map.BingMapType = {    
        Aerial: "aerial",    
        AerialWithLabel: "aerialwithlabel",    
        Road: "road",
    };

    ej.datavisualization.Map.GeometryType = {
        Normal: "normal",    
        Geographic: "geographic"
        
    };

    ej.datavisualization.Map.SelectionMode = {       
        Default: "default",       
        Multiple: "multiple"
    };

    ej.datavisualization.Map.ColorPalette = {        
        Palette1: "palette1", 
        Palette2: "palette2", 
        Palette3: "palette3", 
        CustomPalette: "custompalette"
    };
   
    ej.datavisualization.Map.LegendType = {
        Layers: "layers",
        Bubbles: "bubbles"
    }
 
    ej.datavisualization.Map.Position = {
        None: "none",
        TopLeft: "topleft",
        TopCenter: "topcenter",
        TopRight: "topright",
        CenterLeft: "centerleft",
        Center: "center",
        CenterRight: "centerright",
        BottomLeft: "bottomleft",
        BottomCenter: "bottomcenter",
        BottomRight: "bottomright"
    }
    
    ej.datavisualization.Map.DockPosition = {    
        Top: "top",	
        Bottom: "bottom",    
        Right: "right",    
        Left: "left"
    };
	 ej.datavisualization.Map.Alignment = {
        
        Near: "near",       
        Center: "center",       
        Far: "far"
    };
    
    ej.datavisualization.Map.LabelOrientation = {	
        Horizontal: "horizontal",	
        Vertical: "vertical"
    };
    
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html TreeMap elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author &lt;a href="mailto:licensing@syncfusion.com"&gt;Syncfusion Inc&lt;/a&gt;
*/
(function ($, ej, undefined) {
   
    ej.widget({ "ejTreeMap": "ej.datavisualization.TreeMap" }, {

        validTags: ["div"],

        defaults: {           
			locale : null,    
			enableGroupSeparator: false,
            leafItemSettings: {               
                borderThickness: 1,               
                borderBrush: "white",
                showLabels: false,
                labelPath: null,
                gap:0,
                itemTemplate: null,
                labelPosition: "topleft",
                labelVisibilityMode: "visible"
            },
            header: null,
            isHierarchicalDatasource: false,
            dataSource: null,
            groupColorMapping:[],			
            enableDrillDown: false,
            drillDownHeaderColor: null,
            drillDownSelectionColor: '#000000',          			
            colorValuePath: null,
            weightValuePath: null,			
            treeMapItems: [],
            showLegend: false,
            borderBrush: "white",
            borderThickness: 1,
            enableResize: true,
			enableGradient: false,
            isResponsive: true,
            itemsLayoutMode: "squarified",						
            levels: [],
                       
           legendSettings: {
                template: "",
                iconHeight: 15,
                iconWidth: 15,
                title:'',
                height: 0,
                width: 0,
                mode: "default",
                leftLabel: "",
                rightLabel: "",
                dockPosition: "top",
                alignment: "near",
                columnCount: 0
            },         			         
            rangeColorMapping: [],

            uniColorMapping: { 			
                color: null 
            },
			            
            desaturationColorMapping: { 				            
                from:0, 				               
                to:0,				              
                color: "",								
                rangeMinimum:0,				
                rangeMaximum:0
            },

            paletteColorMapping: {                
                colors:[], 
            },            
            highlightOnSelection: false,			           
			selectionMode: "default",		
            highlightGroupOnSelection: false,
			groupSelectionMode: "default",
			draggingOnSelection: false,
			draggingGroupOnSelection: false,
            showTooltip: false,
            tooltipTemplate: null,
            highlightBorderThickness: 5,
            highlightGroupBorderThickness: 4,
            highlightBorderBrush: "gray",
            highlightGroupBorderBrush: "gray"

        },
        
        dataTypes: {
            dataSource: "data",
            treeMapItems: "array",
            levels: "array",
            rangeColorMapping: "array",
            paletteColorMapping: "object",
            groupColorMapping: "array"
        },
		
        observables: ["dataSource",
              "colorValuePath",
              "weightValuePath",
              "showLegend",
              "enableResize",
              "highlightOnSelection",
			  "selectionMode",
			  "groupSelectionMode",
             "highlightGroupOnSelection",
             "enableDrillDown",
              "drillDownHeaderColor",
             "drillDownSelectionColor",
             "showTooltip",
             "highlightBorderThickness",
             "highlightBorderBrush",
               "itemsLayoutMode",
              "leafItemSettings.borderThickness",
              "leafItemSettings.borderBrush",
              "leafItemSettings.showLabels",
              "leafItemSettings.labelPath",
              "legendSettings.iconWidth",
              "legendSettings.iconHeight",
              "legendSettings.dockPosition",
              "legendSettings.height",
              "legendSettings.width",
              "uniColorMapping.color",
              "desaturationColorMapping.from",
              "desaturationColorMapping.to",
              "desaturationColorMapping.color",
              "desaturationColorMapping.rangeMinimum",
              "desaturationColorMapping.rangeMaximum"              
        ],
        _tags: [
            {
                tag: "levels",
                attr: ["groupPath", "groupGap", "headerHeight", "showHeader", "groupPadding", "groupBackground", "groupBorderColor", "groupBorderThickness"],
                singular: "level"
            },
            {
                tag: "rangeColorMapping",
                attr: ["color", "legendLabel", "from", "to"],
                singular: "rangeColor"
            },           
            {
                tag: "groupColorMapping",
                attr: ["groupID",
            {
                tag: "groupColorMapping.rangeColorMapping",
                attr: ["color", "legendLabel", "from", "to"],
                singular: "groupRangeColor"
            },            

              "uniColorMapping.color",
              "desaturationColorMapping.from",
              "desaturationColorMapping.to",
              "desaturationColorMapping.color",
              "desaturationColorMapping.rangeMinimum",
              "desaturationColorMapping.rangeMaximum"
                ],
                singular: "groupColor"
            }

        ],

        dataSource: ej.util.valueFunction("dataSource"),
        colorValuePath: ej.util.valueFunction("colorValuePath"),
        weightValuePath: ej.util.valueFunction("weightValuePath"),
        showLegend: ej.util.valueFunction("showLegend"),
        enableResize: ej.util.valueFunction("enableResize"),
        highlightOnSelection: ej.util.valueFunction("highlightOnSelection"),
		selectionMode:ej.util.valueFunction("selectionMode"),
        highlightGroupOnSelection: ej.util.valueFunction("highlightGroupOnSelection"),
		groupSelectionMode:ej.util.valueFunction("groupSelectionMode"),
        enableDrillDown: ej.util.valueFunction("enableDrillDown"),
        drillDownHeaderColor: ej.util.valueFunction("drillDownHeaderColor"),
        drillDownSelectionColor: ej.util.valueFunction("drillDownSelectionColor"),
        showTooltip: ej.util.valueFunction("showTooltip"),
        highlightBorderThickness: ej.util.valueFunction("highlightBorderThickness"),
        itemsLayoutMode: ej.util.valueFunction("itemsLayoutMode"),
        highlightBorderBrush: ej.util.valueFunction("highlightBorderBrush"),
        borderThickness: ej.util.valueFunction("leafItemSettings.borderThickness"),
        borderBrush: ej.util.valueFunction("leafItemSettings.borderBrush"),
        showLabels: ej.util.valueFunction("leafItemSettings.showLabels"),
        labelPath: ej.util.valueFunction("leafItemSettings.labelPath"),
        iconWidth: ej.util.valueFunction("legendSettings.iconWidth"),
        iconHeight: ej.util.valueFunction("legendSettings.iconHeight"),
        dockPosition: ej.util.valueFunction("legendSettings.dockPosition"),
        legendheight: ej.util.valueFunction("legendSettings.height"),
        legendwidth: ej.util.valueFunction("legendSettings.width"),
        itemTemplate: ej.util.valueFunction("leafItemSettings.itemTemplate"),
        uniColor: ej.util.valueFunction("uniColorMapping.color"),
        _color: ej.util.valueFunction("desaturationColorMapping.color"),
        _from: ej.util.valueFunction("desaturationColorMapping.from"),
        _to: ej.util.valueFunction("desaturationColorMapping.to"),
        _rangeMinimum: ej.util.valueFunction("desaturationColorMapping.rangeMinimum"),
        _rangeMaximum: ej.util.valueFunction("desaturationColorMapping.rangeMaximum"),

        _initPrivateProperties: function () {
            this._svgDocument = null;
            this._templateDiv = null;
            this._legenddiv = null;
            this._drillHeaderDiv = null;
            this._drillHoverDiv = null;
            this._legendHeight = 0;
            this._backgroundTile = null;
            this._tooltipSize = { height: 0, width: 0 };
            this._height = 500;
            this._margintop = null;
            this._marginleft = null;
            this._startPoint = { x: 0, y: 0 };
            this._stopPoint = { x: 0, y: 0 };
            this.mouseClickable = false;
            this.dragDiv = null;
            this._initDiv = null;
            this._width = 500;
            this._svgns = "http://www.w3.org/2000/svg";
            this._prevSelectedItems=[];
            this._prevSelectedHeaders = [];
            this._isLevelColors;
			 if (this.selectedItems == null)
                this.selectedItems = [];
            this.treeMapItemSelected = null;
            this.treeMapGroupSelected = null;
            this._browser = null;
            this._toolTipElement = null;
            this._rootTreeMapItems = [];
            this.treemapgroups = [];
            this._drillHeader = null;
            this._drilldownItem = null;
            this._drilldownItems = [];
            this._treeMapHeaders = [];
            this._drilldownHeaders = [];
            this.drillStarted = null;
            this.drillDownItemSelected = null;
            this._treeMapLabels = [];
            this._labelTemplateElements = [];
            this._itemGroups = [];
            this._prevSelectedGroupDatas = [];
            this._interactiveArrow = null;
            this._legendRects = [];
        },

        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "itemsLayoutMode":
                        this.itemsLayoutMode(options[prop]);
                        this.refresh();
                        break;
                }
            }
        },
		
		
		
        _levels: function(index, property, value, old){
            this.refresh();
        },
        _rangeColorMapping: function(index, property, value, old){
            this._setColorMappings(this._rootTreeMapItems, this.model);
        },
        _groupColorMapping: function(index, property, value, old){
            this._setColorMappings(this._rootTreeMapItems, this.model);
        },
        _groupColorMapping_rangeColorMapping: function(index, property, value, old){
            this._setColorMappings(this._rootTreeMapItems, this.model);
        },
      
        _init: function () {

            this._initPrivateProperties();
            var style = $('<style>.drillGroupRect:hover{ background-color:' + this.drillDownSelectionColor() + ';}</style>');
            $('html > head').append(style);
            this._levelInitialize();
            if (!this._isSVG())
            {
                document.createStyleSheet().addRule(".vml", "behavior:url(#default#VML);display:inline-block");
                document.namespaces.add('v', 'urn:schemas-microsoft-com:vml', "#default#VML");
            }
            this.refresh();           

        },

        _destroy: function() {
            this._unWireEvents();
            $(this.element).removeClass("e-treemap e-js").find().remove(".tooltipelement");
            $(this.element).empty();
        },
       
        _levelInitialize: function () {
            var proxy = this;
            if (this.model.levels != null) {
                $.each(this.model.levels, function (index, element) {                    
                    element = proxy._checkArrayObject(element, index);
                    var obj = new treeMapLevel();                    
                    $.extend(obj, element);
                    $.extend(element, obj);                    
                });
            }
            else {
                this.levels.treeMapLevel = new treeMapLevel();

            }			
          
        },

        _checkArrayObject: function (element, initialName) {

            var publicProperties = ["borderBrush", "dataSource", "groupColorMapping", "enableDrillDown", "drillDownHeaderColor", "drillDownSelectionColor", "colorValuePath", "weightValuePath", "treeMapItems", "showLegend", "borderBrush", "borderThickness", "enableResize", "enableGradient", "isResponsive", "itemsLayoutMode", "levels", "groupBackground", "groupBorderColor", "groupBorderThickness", "groupPadding", "groupPath", "groupGap", "headerHeight", "showHeader", "showLabels", "headerTemplate", "labelTemplate", "labelPosition", "headerVisibilityMode", "labelVisibilityMode", "color", "leafItemSettings", "showLabels", "labelPath", "gap", "itemTemplate", "legendSettings", "template", "iconHeight", "iconWidth", "height", "width", "mode", "leftLabel", "rightLabel", "dockPosition", "alignment", "highlightOnSelection", "selectionMode", "highlightGroupOnSelection", "groupSelectionMode", "draggingOnSelection", "draggingGroupOnSelection", "showTooltip", "tooltipTemplate", "highlightBorderThickness", "highlightGroupBorderThickness", "highlightBorderBrush", "highlightGroupBorderBrush"];

            var proxy = this;
            $.each(element, function (name, innerElement) {
                if (publicProperties.indexOf(name) > -1) {
                    if (innerElement instanceof Array) {
                        proxy._checkArrayObject(innerElement, name);
                    }
                    else if (innerElement != null && typeof innerElement == "object") {
                        var allObjects = new treeMapLevel();
                        proxy._loadIndividualDefaultValues(innerElement, allObjects, (typeof name === "number") ? initialName : name);
                    }
                }
            });
            return element;
        },

        _loadIndividualDefaultValues: function (obj, allObjects, name) {
            var defaultObj = null;
            var proxy = this;
            $.each(allObjects, function (n, element) {
                if (name == n) {
                    defaultObj = element;
                    return;
                }
            });
            if (defaultObj instanceof Array) defaultObj = defaultObj[0];

            $.each(obj, function (objName, ele) {
                if (ele instanceof Array) {
                    proxy._checkArrayObject(ele, name);
                }
                else if (ele != null && typeof ele == "object") {
                    proxy._loadIndividualDefaultValues(ele, ele, (typeof objName === "number") ? name : objName);
                }
            });

            $.extend(defaultObj, obj);
            $.extend(obj, defaultObj);
            return obj;
        },

        refresh: function (isClear) {
            if(document.getElementById(this._id) != null || document.getElementById(this._id) != undefined){
                this._unWireEvents();
            if (!isClear) {
                this._drilldownItems = [];
            }
            if (this.model.enableResize || this.model.isResponsive) {
                if (this._drilldownItems.length == 0) {
                    this._initPrivateProperties();
                }
            }
            else {
                this._initPrivateProperties();
            }

            $(this.element).empty();
            if (this._svgDocument != null) {
                $(this._svgDocument).empty();
            }
            this._height = this.element.height();
            this._width = this.element.width();
            if (this._height == 0) {
                this._height = this.element[0].parentElement.clientHeight != 0 ? this.element[0].parentElement.clientHeight : $(document).height();
            }
            if (this._width == 0) {
                this._width = this.element[0].parentElement.clientWidth != 0 ? this.element[0].parentElement.clientWidth : $(document).width();
            }
            if (this.showLegend()) {
                this._sizeCalculation();
            }            
            var matched = jQuery.uaMatch(navigator.userAgent);
            var browser = matched.browser.toLowerCase();
            var isIE11 = !!navigator.userAgent.match(/Trident\/7\./);
            this._browser = browser;
            $(this.element).css({ 'position': 'relative' });			
           
            if (this._height != 0 && this._width != 0) {                
                this._templateDiv = $("<div class='_templateDiv'></div>");
                this._templateDiv.css({
                    'pointer-events': 'none', 'overflow': 'hidden', 'float': 'left',
                    'z-index': '2', 'height': this._height, 'width': this._width, "margin-top": this._margintop,  "margin-left": this._marginleft, "position": "absolute", "left": "0", "top": "0"
                });
                if (this.enableDrillDown() && this._drilldownItems.length == 0) {
                    this._drillHeaderDiv = $("<div class='_drillHeaderDiv'></div>");
                    this._drillHeaderDiv.css({
                        'overflow': 'hidden', 'float': 'left',
                        'z-index': '3', "position": "absolute", "left": "0", "top": "0"
                    });
                    this._drillHoverDiv = $("<div class='_drillHoverDiv'></div>");
                    this._drillHoverDiv.css({
                        'overflow': 'hidden', 'float': 'left',
                        'z-index': '3', 'height': this._height - 30, 'width': this._width, "position": "absolute", "left": "0", "top": "30px"
                    });
                }
                this._backgroundTile = $('<div id="backgroundTile" style="overflow:hidden;z-index:0;"></div>');
                if(this.showLegend()) {
                    if (this.model.legendSettings != null) {
                        this._renderLegend();                       
                    }
                }
                if(this.dataSource()!=null){
                    if (this._drilldownItems.length > 0) {
                        if (this.enableDrillDown() && this.model.levels.length >= 1 && ((this._drilldownItem != null) || this._drilldownItem == null)) {
                            for (var i = 0; i < this._drillHeaderDiv[0].children[0].children.length; i++) {
                                if (this._drillHeaderDiv[0].children[0].children[i].className == "e-drilldownlabel")
                                    header = this._drillHeaderDiv[0].children[0].children[i].innerHTML;
                            }
                            this._backgroundTile[0].innerHTML = "";
                            this._drillHeaderDiv[0].innerHTML = "";
                            this._templateDiv[0].innerHTML = "";
                            this._drillHoverDiv[0].innerHTML = "";
                            this._drillDownHeader(header, true);
                            this._groupdrillDownLevels(this._drilldownItems[this._drilldownItems.length - 1], this._drilldownItems.length);
                        }
                        if (this.showLegend()) {
                            this._generateLegend();
                        }
                        this._generateToolTip();
                    }
                    else {
                        if (this.model.dataSource instanceof ej.DataManager) {
                            this._processOData(this);
                        }
                        else {
                            this._renderTreeMap(this.dataSource());
                        }
                    }
                }
                if (this.enableResize() || this.model.isResponsive) {
                    this._on($(window), "resize", this._treeMapResize);
                }
            }
			this._selectItemResize();
            this._trigger("refreshed", "");
            }
            
        },
		
       _renderTreeMap: function (data) {
            this.model.browserInfo = this.browserInfo();
            if (this.showLegend()) {
                this._generateLegend();
            }
            this._groupLevels(data);

            this._generateToolTip();
            this._renderLabels();
        },
		
   _renderLegend: function () {
            this._legenddiv = $("<div class='LegendDiv'/>");
            this._legenddiv.appendTo(this.element);

            this._legenddiv.css({
                'pointer-events': 'none', 'overflow': 'hidden', "position": "absolute",
                'z-index': '2', 'height': this._legendSize.height, 'width': this._legendSize.width
            });
        },

        _processOData: function (treemap) {  
            var treeMap= this;		 
            var queryPromise = treemap.model.dataSource.executeQuery(treemap.model.query);
            queryPromise.done(function (e) {
                if(e.result!=null)
                {
                    treeMap._renderTreeMap(e.result);
                }
            });        
        },

        _treeMapResize: function (event) {
            event.preventDefault();
            event.stopPropagation();
            var treemap = this;
            if (this.resizeTO) clearTimeout(this.resizeTO);
            this.resizeTO = setTimeout(function () {
                treemap.refresh(true);
            }, 500);
        },
              
        _unWireEvents: function(){
            var matched = jQuery.uaMatch(navigator.userAgent);
            var browser = matched.browser.toLowerCase();                      
            

        },

        _groupLevels: function (data) {
           
            var subItems = null, isHierarchical = this.model.isHierarchicalDatasource;
            if (this.enableDrillDown()) {                
                this._drilldownHeaders.push(this.model.header || this.model.levels[0].groupPath);
                this._drillDownHeader(false);
            }
            var rootItems = this._getTopGroupitem(this.labelPath(), data, 0);
            subItems = rootItems;
            if (this.model.levels.length == 0) {
                var levelItem = this.model.leafItemSettings;
                this._rootTreeMapItems = rootItems;
                this._getTopLevels(rootItems[0].innerItems, levelItem);
                this._generateTreeMapItems(rootItems[0].innerItems, "gray", this.colorValuePath());
                if(this.showLabels())
                    this._generateLabels(rootItems[0].innerItems, levelItem);
            }
            if(this.model.levels.length>0){
                for (var i = 0; i <= this.model.levels.length; i++) {
                    var levelItem = this.model.levels[i];
                  if (levelItem != null) {
                        if (!$.isNumeric(levelItem.groupGap)) levelItem.groupGap = 0;
                        if (!$.isNumeric(levelItem.groupPadding)) levelItem.groupPadding = 0;
                        if (!$.isNumeric(levelItem.groupBorderThickness)) levelItem.groupBorderThickness = 0;
                    }
                    if (i != 0) {
                        var cloneItems = subItems;
                        var PrevItem = this.model.levels[i - 1];
                        subItems = [];
                        if (levelItem == null) levelItem = this.model.leafItemSettings;
                        this._generateSubItems(cloneItems, levelItem, subItems, PrevItem);
                        
                        this._rootTreeMapItems = subItems;                        
                        if (this.enableDrillDown())
                        {
                            if (i == 1) {
                                this._generateTreeMapItems(subItems, "gray", PrevItem.DisplayPath);                                
                                return false;                          
                            }
                        }
                        else if (i == this.model.levels.length) {
                            this._generateTreeMapItems(subItems, "gray", PrevItem.DisplayPath);
                        }                                                  
                        if (this.showLabels() && i == this.model.levels.length) {
                            this._generateLabels(subItems, levelItem);
                        }
                      
                    }
                    else {
                        var rootItems1 = this._getGroupitem(isHierarchical ? this.labelPath() : levelItem.groupPath, rootItems[0].Data, levelItem.headerHeight);
                        this._rootTreeMapItems = rootItems1;
                        this._getTopLevels(rootItems1, levelItem);
                        subItems = rootItems1;                        
                    }
                }
                
            }
        },
        
        _groupdrillDownLevels: function (data, actualindex) {       
          
            var subItems = null, isHierarchical = this.model.isHierarchicalDatasource;
            if (actualindex == this.model.levels.length-1)
            {
                this._drillHoverDiv.css("pointer-events", "none");
            }
            else
            {
                this._drillHoverDiv.css("pointer-events", "auto");
            }
            if (this.model.levels.length > 0) {
                var canExecute = false;
                for (var i = isHierarchical ? actualindex - 1 : 0; i < this.model.levels.length; i++) {                   
                    var levelItem = this.model.levels[i];
                  if (levelItem != null) {
                        if (!$.isNumeric(levelItem.groupGap)) levelItem.groupGap = 0;
                        if (!$.isNumeric(levelItem.groupPadding)) levelItem.groupPadding = 0;
                        if (!$.isNumeric(levelItem.groupBorderThickness)) levelItem.groupBorderThickness = 0;
                    }
                    if (i != (isHierarchical ? actualindex - 1 : 0)) {
                        var cloneItems = subItems;
                        var PrevItem = this.model.levels[i - 1];
                        subItems = [];
                        if (levelItem == null) {
                            levelItem = this.model.leafItemSettings;
                        }
                        if (i == actualindex + 1) {
                            this._generateSubItems(cloneItems, levelItem, subItems, PrevItem, null, (actualindex + 1 != i));

                        }
                        else {
                            this._generateSubItems(cloneItems, levelItem, subItems, PrevItem, true, (actualindex + 1 != i));

                        }
                        this._rootTreeMapItems = subItems;
                        if ((i == actualindex + 1 || i == this.model.levels.length - 1) && !canExecute) {
                            this._generateTreeMapItems(subItems, "gray", PrevItem.DisplayPath);                                                       
                            canExecute = true;
                        }                        
                        
                        if (actualindex == this.model.levels.length - 1 && i == actualindex && levelItem.showLabels) {
                            this._generateLabels(subItems, levelItem);
                        }
                           
                    }
                    else {

                        var rootItems1 = this._getGroupitem(this.model.isHierarchicalDatasource ? null : levelItem.groupPath, data.Data, levelItem.headerHeight);
                        this._rootTreeMapItems = rootItems1;
                        this._getTopLevels(rootItems1, levelItem);
                        subItems = rootItems1;
                    }
                }
            }
            
            if (this.showLegend()) {
                this._generateLegend();
            }
            this._renderLabels();
            this._trigger("drillDownItemSelected", { level: actualindex, header: this.getDrillDownHeader(this._drilldownHeaders), prevLevel: actualindex - 1 });
        },

        _getTopLevels: function (rootItems, level) {
            var gap = (level.groupGap != null) ? level.groupGap : (level.gap!=null?level.gap:0);
            var layout = this.itemsLayoutMode();
            var legendHeight = 0;
            var defaultspacing = 0;
            if (this.enableDrillDown()) {
                defaultspacing = 30;
            }
            if (this.showLegend() && this.model.legendSettings != null) {
                legendHeight = legendHeight;                    
            }
                
            this._legendHeight = legendHeight;
            if (this.enableDrillDown()) {
                this._drillHeaderDiv.css({
                    "top": legendHeight
                });

                this._drillHoverDiv.css({
                    "top": 30 + legendHeight
                })
            }               
                
            if (layout == ej.datavisualization.TreeMap.ItemsLayoutMode.SliceAndDiceHorizontal) {
                this._calculateSliceAndDiceItemSize(rootItems, 0, legendHeight, this._width, this._height, gap, defaultspacing, true, legendHeight);
            }
            else if (layout == ej.datavisualization.TreeMap.ItemsLayoutMode.SliceAndDiceVertical) {
                this._calculateSliceAndDiceItemSize(rootItems, 0, legendHeight, this._width, this._height, gap, defaultspacing, false, legendHeight);
            }
            else if (layout == ej.datavisualization.TreeMap.ItemsLayoutMode.SliceAndDiceAuto) {
                this._calculateSliceAndDiceItemSize(rootItems, 0, legendHeight, this._width, this._height, gap, defaultspacing, null, legendHeight);
            }
            else {
                this._calculateSquarifiedItemSize(rootItems, 0, legendHeight, this._width, this._height, gap, defaultspacing, legendHeight);
            }
            
        },
      
        _generateSubItems: function (cloneItems, levelItem, subItems, PrevItem, disablelabels, disablebackground) {
            var grouppading = PrevItem.groupPadding;
            if (grouppading == "") { grouppading = 0; }
            var layout = this.itemsLayoutMode();
            var cloneItemsCount = cloneItems.length;
            var path = this.model.isHierarchicalDatasource ? null : levelItem.groupPath;
            if (path == null) path = this.labelPath();
            if (path == null) path = this.weightValuePath();
            var gap = (levelItem.groupGap != null) ? levelItem.groupGap : (levelItem.gap != null) ? levelItem.gap:0;
            var headerHeight = ((PrevItem.showHeader || PrevItem.showHeader == null) && !this.enableDrillDown()) ? PrevItem.headerHeight : 0;
            var totalItemsCount = 0;
            for (var j = 0; j < cloneItemsCount; j++) {
                var treeItems = this._getGroupitem(path, cloneItems[j].Data, levelItem.headerHeight, this.model.isHierarchicalDatasource ? PrevItem.groupPath:null);
                if (layout == ej.datavisualization.TreeMap.ItemsLayoutMode.SliceAndDiceHorizontal) {
                    this._calculateSliceAndDiceItemSize(treeItems, cloneItems[j].LeftPosition + parseFloat(grouppading), cloneItems[j].TopPosition + parseFloat(grouppading), cloneItems[j].ItemWidth - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), cloneItems[j].ItemHeight - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), parseFloat(gap), headerHeight, true, 0);
                }
                else if (layout == ej.datavisualization.TreeMap.ItemsLayoutMode.SliceAndDiceVertical) {
                    this._calculateSliceAndDiceItemSize(treeItems, cloneItems[j].LeftPosition + parseFloat(grouppading), cloneItems[j].TopPosition + parseFloat(grouppading), cloneItems[j].ItemWidth - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), cloneItems[j].ItemHeight - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), parseFloat(gap), headerHeight, false, 0);
                }
                else if (layout == ej.datavisualization.TreeMap.ItemsLayoutMode.SliceAndDiceAuto) {
                    this._calculateSliceAndDiceItemSize(treeItems, cloneItems[j].LeftPosition + parseFloat(grouppading), cloneItems[j].TopPosition + parseFloat(grouppading), cloneItems[j].ItemWidth - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), cloneItems[j].ItemHeight - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), parseFloat(gap), headerHeight, null, 0);
                }
                else {
                    this._calculateSquarifiedItemSize(treeItems, cloneItems[j].LeftPosition + parseFloat(grouppading), cloneItems[j].TopPosition + parseFloat(grouppading), cloneItems[j].ItemWidth - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), cloneItems[j].ItemHeight - (PrevItem.groupBorderThickness + (2 * parseFloat(grouppading))), parseFloat(gap), headerHeight, 0);
                }                
                var headerItem = this._rootTreeMapItems[j];                
                headerItem.headerHeight = PrevItem.headerHeight;
                headerItem.showHeader = PrevItem.showHeader;
                headerItem.headerWidth = cloneItems[j].ItemWidth;
                headerItem.headerTemplate = PrevItem.headerTemplate;
                headerItem.headerLeftPosition = cloneItems[j].LeftPosition;
                headerItem.headerTopPosition = cloneItems[j].TopPosition;

                if (this.enableDrillDown())
                    this._createBackGround(headerItem, PrevItem, cloneItems[j], disablebackground);                

                if (PrevItem.showHeader || PrevItem.showHeader == null) {
                   
                    if(!this.enableDrillDown()){
                        this._createBackGround(headerItem, PrevItem, cloneItems[j]);
                        this._generateHeaders(headerItem, PrevItem);
                    }
                    
                }
               
                cloneItems[j].ChildtreeMapItems = treeItems;
                cloneItems[j].GroupingLevel = this.model.levels.indexOf(PrevItem) + 1;
				
                if (this.model.levels.indexOf(PrevItem) == 0){
                    if (this.model.groupColorMapping != null && this.model.groupColorMapping.length > 0){
                        this._isLevelColors= true;
                        for (var a = 0; a < this.model.groupColorMapping.length; a++){
                            var colormapping = this.model.groupColorMapping[a];
                            if (colormapping.groupID == headerItem.header){
                                this._setColorMappings(treeItems, colormapping,true);
                            }
                        }
                    }
                }
                else if( this.model.levels.indexOf(PrevItem) > 0 )
                {				
                    if (this.model.groupColorMapping != null  && this.model.groupColorMapping.length > 0){
                        for (var a = 0; a < this.model.groupColorMapping.length; a++){				
                            var colormapping = this.model.groupColorMapping[a];
                            if (colormapping.groupID == cloneItems[j].ParentHeader){
                                this._setColorMappings(treeItems, colormapping,true);
                            }
                        }
                    }
                }
				
                for (var k = 0; k < treeItems.length; k++) {
                    subItems[totalItemsCount] = treeItems[k];
                    if (treeItems[k].backgroundColor == null)
                        treeItems[k].backgroundColor = cloneItems[j].backgroundColor;
                    if (treeItems[k].backgroundOpacity == null)
                        treeItems[k].backgroundOpacity = cloneItems[j].backgroundOpacity;                   
                    if ((this.enableDrillDown()) || (subItems[totalItemsCount].ItemHeight < headerItem.ItemHeight - headerItem.headerHeight)) {
                        subItems[totalItemsCount].ParentHeader = headerItem.header;
                        subItems[totalItemsCount].ItemHeight -= grouppading;
                        subItems[totalItemsCount].ItemWidth -= grouppading;
                        subItems[totalItemsCount].LeftPosition += PrevItem.groupBorderThickness;
                        subItems[totalItemsCount].TopPosition += PrevItem.groupBorderThickness;
                       
                    }
                    totalItemsCount++;
                }              
            }
            if (disablelabels == undefined &&  PrevItem.showLabels) {
                this._generateLabels(cloneItems, PrevItem);
            }
        },
       
        _createBackGround: function (header, level,parentitem, disablebackground) {            
            var rect = $("<div />");
            var height = (header.showHeader || header.showHeader == null || this.enableDrillDown()) ? header.ItemHeight - (2 * level.groupBorderThickness) : 0;
            var top = (header.showHeader || header.showHeader == null || this.enableDrillDown()) ? header.TopPosition : 0;
            rect.css({
                "height": height + "px",
                "width": header.ItemWidth - (2 * level.groupBorderThickness) + "px",
                "left": header.LeftPosition + "px",
                "top": top + "px",
                "border-style": "solid",
                "border-width": level.groupBorderThickness+"px",
                "position": "absolute"               
            });

            if(level.groupBorderColor!=null)
            {
                rect.css("border-color",level.groupBorderColor);
            }
            if(level.groupBackground!=null)
            {
                rect.css("background-color",level.groupBackground);
            }
            this.treemapgroups.push({header:header.header,element:rect});
            rect.appendTo(this._backgroundTile);
            var height = parseFloat(rect[0].style.top) - 30 - this._legendHeight + "px";            
            if (this.enableDrillDown() && !disablebackground) {
                var hoverrect = $("<div class='drillGroupRect'/>");
                hoverrect.css({
                    "height": rect[0].style.height,
                    "width": rect[0].style.width,
                    "left": rect[0].style.left,
                    "top": height,
                    "position": "absolute",
                    "opacity": 0.2,
                    "display": "block"
                });
                this._drillHoverDiv.append(hoverrect);
                $(hoverrect).mousedown({ treemap: this, level: level, param1: parentitem }, this._headerClickFunction);
                $(hoverrect).mouseleave({ treemap: this, param1: header.header }, this._mouseLeaveFunction);
                var hoverData = { data: header.Data, label:header.header, header: header.header };
                $(hoverrect).mousemove({ treemap: this, hoverItem: hoverData }, this._mouseRectHoverFunction);
            }
            $(rect).mousedown({ treemap: this, level: level, param1: parentitem }, this._headerClickFunction);
            $(rect).mousemove({ treemap: this, hoverItem: header.Data }, this._mouseRectHoverFunction);
        },

        _mouseRectHoverFunction: function (event) {
          
            var treeMap = event.data.treemap;
            var item = event.data.hoverItem;
            if (treeMap.showTooltip()) {
                var element = treeMap._toolTipElement;
                var template = treeMap.model.tooltipTemplate;
                if (element != null && template != null) {
                    $(element).css({ "left": event.pageX + 10, "top": event.pageY + 10, "display": "block" });
                    var htmlString = $("#" + template).render(item);
                    $(element).html(htmlString);
                    var height = element[0] != null ? element[0].clientHeight : element.clientHeight;
                    var width = element[0] != null ? element[0].clientWidth : element.clientWidth;
                    treeMap._tooltipSize = { height: height, width: width };
                }

                var tooltipSize = treeMap._tooltipSize;
                if (tooltipSize.width + event.pageX >= treeMap._width) {
                    event.pageX -= tooltipSize.width;
                    if (event.pageX < 0) {
                        event.pageX = 10;
                    }
                }
                if (tooltipSize.height + event.pageY >= treeMap._height) {
                    event.pageY -= tooltipSize.height;
                    if (event.pageY < 0) {
                        event.pageY = 10;
                    }
                }               
                if (element != null) {

                    if (treeMap.enableDrillDown()) {
                        $(element).css({ "left": event.pageX + 10, "top": event.pageY + 10, "display": "block" });

                    }
                    else {
                        $(element).css({ "left": event.pageX + 10, "top": event.pageY + 10, "display": "none" });

                    }

                }

            }
        },		        
               
        _mouseLeaveFunction: function (event) {
            var treeMap = event.data.treemap;
            if (treeMap.showTooltip())
            {
                if (treeMap._toolTipElement != null) {
                    $(treeMap._toolTipElement).css("display", "none");
                }
            }
        },
		       
        _headerClickFunction: function (event) {
            var level = event.data.level;
            var data = event.data.param1;
            var ctrlkey = event.ctrlKey;
            var treeMap = event.data.treemap;
            if (treeMap.highlightGroupOnSelection()) {
                if (treeMap._browser != "msie") {
                    var lastItem = treeMap._backgroundTile[0].children[treeMap._backgroundTile[0].children.length - 0];
                    treeMap._backgroundTile[0].insertBefore(this, lastItem);
                }
                if (treeMap.groupSelectionMode() == "multiple" &&  ctrlkey) {

                    if ($.inArray(this,treeMap._prevSelectedHeaders)==-1) {
                        $(this).css({ "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.highlightBorderBrush() });
                        treeMap._prevSelectedHeaders.push(this);
                        treeMap._prevSelectedGroupDatas.push(event.data.Param1);
                    }
                    else {
                        
                        $(this).css({ "border-width": level.groupBorderThickness, "border-color": level.groupBorderColor });
                        var index = treeMap._prevSelectedHeaders.indexOf(this);
                        treeMap._prevSelectedHeaders.splice(index, 1);
                        treeMap._prevSelectedGroupDatas.splice(index, 1);
                    }
                }
                else {
                    for (var k = 0; k < treeMap._prevSelectedHeaders.length; k++) {
		               
                        $(treeMap._prevSelectedHeaders[k]).css({ "border-width": level.groupBorderThickness, "border-color": level.groupBorderColor });
                    }

                    if ($.inArray(this, treeMap._prevSelectedHeaders) == -1) {
                        $(this).css({ "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.highlightBorderBrush() });
                        treeMap._prevSelectedHeaders = [];
                        treeMap._prevSelectedHeaders.push(this);
                    }
                    else {
                        treeMap._prevSelectedHeaders = [];
                    }
		            
                    treeMap._prevSelectedGroupDatas.push(event.data.Param1);
                }
            }
            if (treeMap.enableDrillDown())
            {
                treeMap._trigger("drillStarted", event);
            }
			if (treeMap.enableDrillDown() && treeMap.model.levels.length > 1 && ((treeMap._drilldownItem != null && treeMap._drilldownItem.header != data.header) || treeMap._drilldownItem == null)) {
                    var header = "";
                    for(var i=0;i< treeMap._drillHeaderDiv[0].children[0].children.length;i++)
                    {
                        if (treeMap._drillHeaderDiv[0].children[0].children[i].className == "e-drilldownlabel")
                            header = treeMap._drillHeaderDiv[0].children[0].children[i].innerHTML;
                    }
                    treeMap._backgroundTile[0].innerHTML = "";
                    treeMap._labelTemplateElements = [];
                    treeMap._drillHeaderDiv[0].innerHTML = "";
                    treeMap._templateDiv[0].innerHTML = "";
                    treeMap._drillHoverDiv[0].innerHTML = "";
                    treeMap._drilldownHeaders.push(data.header);
                    treeMap._drillDownHeader(true);
                     treeMap._drilldownItem = data;
                    treeMap._drilldownItems.push(data);
                    treeMap._groupdrillDownLevels(data, treeMap._drilldownItems.length);
                    return false;
		       		        
                }
            },
            
       _rectMouseDown: function (event) {
            if (event.data.treeMap.isTouch(event))
                event.preventDefault();

        },
        _docClickFunction: function (event) {
            var treeMap = event.data.treemap;
            var element = this._toolTipElement, treemap = this;
            clearTimeout(treemap.model.timer);
            if (element) {
                treemap.model.trackerElement = element;
                treemap.model.timer = setTimeout(function () {
                    if (treemap.model.trackerElement)
                        $(treemap.model.trackerElement).fadeOut(500, function () {
                            treemap.model.trackerElement = null;
                        });

                }, 1200);

            }
        },
        mousePosition: function (evt) {
            if (!ej.util.isNullOrUndefined(evt.pageX) && evt.pageX > 0)
                return evt;
            else if (evt.originalEvent && !ej.util.isNullOrUndefined(evt.originalEvent.pageX) && evt.originalEvent.pageX > 0)
                return evt.originalEvent;
            else if (evt.originalEvent && evt.originalEvent.changedTouches != undefined) {
                if (!ej.util.isNullOrUndefined(evt.originalEvent.changedTouches[0].pageX) && evt.originalEvent.changedTouches[0].pageX > 0)
                    return evt.originalEvent.changedTouches[0];
            }
            return evt;

        },
        _highlightTreemap: function (event) {
            var treeMap = event.data.treemap,
                itemCollection = event.data.Param1,
                level = treeMap.model.levels[0], tooltipObject, isContain, tooltipContain, ctrlkey = event.ctrlKey,
                selectedGroup, item, rect,
                pointer = treeMap.mousePosition(event);
            if (treeMap.highlightGroupOnSelection()) {
                for (var i = 0; i < treeMap.treemapgroups.length; i++) {
                    selectedGroup = treeMap.treemapgroups[i];
                    item = treeMap.treemapgroups[i].element;
                    rect = item[0].getBoundingClientRect();

                    if (rect.left < pointer.clientX && rect.left + rect.width > pointer.clientX
                   && rect.top < pointer.clientY && rect.top + rect.height > pointer.clientY) {
                        $(item).css({
                            "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.highlightBorderBrush(),
                            "box-sizing": "border-box",
                            "-moz-box-sizing": "border-box",
                            "-webkit-box-sizing": "border-box",
                        });
                        isContain = true;
                        break;
                    }
                }
                if (isContain) {
                    if (treeMap.groupSelectionMode() == "multiple" && ctrlkey) {

                        if ($.inArray(item, treeMap._prevSelectedHeaders) == -1) {
                            $(item).css({ "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.highlightBorderBrush() });
                            treeMap._prevSelectedHeaders.push(selectedGroup);
                            treeMap._prevSelectedGroupDatas.push(event.data.Param1);
                        }
                        else {

                            $(item).css({ "border-width": level.groupBorderThickness, "border-color": level.groupBorderColor, });
                            var index = treeMap._prevSelectedHeaders.indexOf(selectedGroup);
                            treeMap._prevSelectedHeaders.splice(index, 1);
                            treeMap._prevSelectedGroupDatas.splice(index, 1);
                        }
                    }
                    else {
                        for (var k = 0; k < treeMap._prevSelectedHeaders.length; k++) {

                            $(treeMap._prevSelectedHeaders[k].element).css({ "border-width": level.groupBorderThickness, "border-color": level.groupBorderColor });
                        }

                        if ($.inArray(item, treeMap._prevSelectedHeaders) == -1) {
                            $(item).css({ "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.highlightBorderBrush() });
                            treeMap._prevSelectedHeaders = [];
                            treeMap._prevSelectedHeaders.push(selectedGroup);
                        }
                        else {
                            treeMap._prevSelectedHeaders = [];
                        }

                        treeMap._prevSelectedGroupDatas.push(event.data.Param1);
                    }
                }
                treeMap._trigger("treeMapGroupSelected", { selectedGroups: treeMap._prevSelectedHeaders, orginalEvent: event });
            }

            if (treeMap.highlightOnSelection()) {

                for (var i = 0; i < treeMap._rootTreeMapItems.length; i++) {
                    var item = treeMap._rootTreeMapItems[i];
                    var rect = item.Rectangle.getBoundingClientRect();
                    if (rect.left < pointer.clientX && rect.left + rect.width > pointer.clientX
                        && rect.top < pointer.clientY && rect.top + rect.height > pointer.clientY) {
                        $(item.Rectangle).css({
                            "border-width": treeMap.highlightBorderThickness(), "border-color": treeMap.highlightBorderBrush(),
                            "box-sizing": "border-box",
                            "-moz-box-sizing": "border-box",
                            "-webkit-box-sizing": "border-box",
                        });
                        isContain = true;
                        break;
                    }
                }

                if (isContain) {
                    if (treeMap.selectionMode() == "multiple" && ctrlkey) {
                        if ($.inArray(item.Rectangle, treeMap._prevSelectedItems) == -1) {
                            $(item.Rectangle).css({
                                "border-width": treeMap.highlightBorderThickness(), "border-color": treeMap.highlightBorderBrush(),
                                "box-sizing": "border-box",
                                "-moz-box-sizing": "border-box",
                                "-webkit-box-sizing": "border-box",
                            });
                            treeMap._prevSelectedItems.push(item.Rectangle);
                            treeMap.selectedItems.push(item.Data);
                        }
                        else {
                            $(item.Rectangle).css({ "border-width": treeMap.borderThickness(), "border-color": treeMap.borderBrush() });
                            var index = treeMap._prevSelectedItems.indexOf(item.Rectangle);
                            treeMap._prevSelectedItems.splice(index, 1);
                            treeMap.selectedItems.splice(index, 1);
                        }
                    }
                    else {
                        for (var k = 0; k < treeMap._prevSelectedItems.length; k++) {
                            $(treeMap._prevSelectedItems[k]).css({ "border-width": treeMap.borderThickness(), "border-color": treeMap.borderBrush() });
                        }

                        if ($.inArray(item.Rectangle, treeMap._prevSelectedItems) == -1) {
                            $(item.Rectangle).css({ "border-width": treeMap.highlightBorderThickness(), "border-color": treeMap.highlightBorderBrush() });
                            treeMap._prevSelectedItems = [];
                            treeMap.selectedItems = [];
                            treeMap._prevSelectedItems.push(item.Rectangle);
                            treeMap.selectedItems.push(item.Data);
                        }
                        else {
                            treeMap._prevSelectedItems = [];
                            treeMap.selectedItems = [];
                        }
                    }
                    treeMap._trigger("treeMapItemSelected", { selectedItems: treeMap.selectedItems, originalEvent: event });
                }

            }
          
        },
        doubleTap: function (event) {

            var pointer = event.targetTouches ? event.targetTouches[0] : event,
               currX = pointer.pageX,
               currY = pointer.pageY,
               model = this.model,
               padding = 200,
               element,

               treeMap = event.data.treemap;

            treeMap.model.cachedX = treeMap.model.cachedX || currX;

            treeMap.model.cachedY = treeMap.model.cachedY || currY;

            timestamp = new Date().getTime();


            if (Math.abs(currX - treeMap.model.cachedX) < padding && Math.abs(currY - treeMap.model.cachedY) < padding)
                treeMap.model.tapNum++;

        },

        rectClick: function (event) {

            var treeMap = event.data.treemap;
            treeMap.doubleTap(event);
            if (!treeMap.isTouch(event)) {
                treeMap._highlightTreemap(event);
            }
        },        
            dragDown: function (event) {

                var treeMap = event.data.treemap;
                var level = treeMap.model.levels[0];

                var treeMapArea = treeMap._svgDocument;
                if (event.type == "mousedown") {
                    treeMap._startPoint = { x: event.pageX - treeMapArea[0].offsetLeft, y: event.pageY - treeMapArea[0].offsetTop };
                    treeMap._stopPoint = { x: event.pageX - treeMapArea[0].offsetLeft, y: event.pageY - treeMapArea[0].offsetTop };
                }
                else if (event.type == "touchstart") {
                    treeMap._startPoint = { x: event.originalEvent.changedTouches[0].pageX - treeMapArea[0].offsetLeft, y: event.originalEvent.changedTouches[0].pageY - treeMapArea[0].offsetTop };
                    treeMap._stopPoint = { x: event.originalEvent.changedTouches[0].pageX - treeMapArea[0].offsetLeft, y: event.originalEvent.changedTouches[0].pageY - treeMapArea[0].offsetTop };
                }
                else if (event.type == "MSPointerDown") {
                    treeMap._startPoint = { x: event.originalEvent.pageX - treeMapArea[0].offsetLeft, y: event.originalEvent.pageY - treeMapArea[0].offsetTop };
                    treeMap._stopPoint = { x: event.originalEvent.pageX - treeMapArea[0].offsetLeft, y: event.originalEvent.pageY - treeMapArea[0].offsetTop };
                }

                treeMap.mouseClickable = true;

                if (treeMap.model.draggingGroupOnSelection) {

                    if (treeMap._prevSelectedGroupDatas.length > 0) {
                        for (var i = 0; i < treeMap._prevSelectedGroupDatas.length; i++) {
                            var item = treeMap._prevSelectedGroupDatas[i][0];
                            var rect = item.getBoundingClientRect();
                            if ($.inArray(item, treeMap._prevSelectedGroupDatas[i][0]) == -1) {
                                $(treeMap._prevSelectedGroupDatas[i]).css({ "border-width": level.groupBorderThickness, "border-color": treeMap.model.highlightGroupBorderBrush });
                            }
                        }
                        treeMap._prevSelectedGroupDatas = [];
                    }
                }

                if (treeMap.model.draggingOnSelection) {

                    if (treeMap._prevSelectedItems.length > 0) {
                        for (var i = 0; i < treeMap._prevSelectedItems.length; i++) {
                            var item = treeMap._prevSelectedItems[i].rectangle;
                            var rect = item.getBoundingClientRect();
                            if ($.inArray(item, treeMap._prevSelectedItems[i].rectangle) == -1) {
                                $(treeMap._prevSelectedItems[i].rectangle).css({ "border-width": level.groupBorderThickness, "border-color": treeMap.model.highlightGroupBorderBrush });
                            }
                        }
                        treeMap._prevSelectedItems = [];
                    }
                }
            },

            dragMove: function (event) {

                var width; var height;
                var treeMap = event.data.treemap;
                var treeMapArea = treeMap._svgDocument;

                if (treeMap.model.draggingGroupOnSelection || treeMap.model.draggingOnSelection) {

                    if (treeMap.mouseClickable) {

                        if (event.type == "mousemove")
                            treeMap._stopPoint = { x: event.pageX - treeMapArea[0].offsetLeft, y: event.pageY - treeMapArea[0].offsetTop };
                        else if (event.type == "touchmove")
                            treeMap._stopPoint = { x: event.originalEvent.changedTouches[0].pageX - treeMapArea[0].offsetLeft, y: event.originalEvent.changedTouches[0].pageY - treeMapArea[0].offsetTop };
                        else if (event.type == "MSPointerMove")
                            treeMap._stopPoint = { x: event.originalEvent.pageX - treeMapArea[0].offsetLeft, y: event.originalEvent.pageY - treeMapArea[0].offsetTop };


                        $('#dragDiv').remove();
                        var div = $('<div id = "dragDiv"></div>');

                        width = Math.abs(treeMap._stopPoint.x - treeMap._startPoint.x),
                        height = Math.abs(treeMap._stopPoint.y - treeMap._startPoint.y);
                        $(div).css({ "top": Math.min(treeMap._startPoint.y, treeMap._stopPoint.y), "left": Math.min(treeMap._startPoint.x, treeMap._stopPoint.x), width: width, height: height, border: "1px solid green", position: "absolute", "z-index": 100 });
                        $(div).appendTo("#svgDocument");
                    }
                }
            },

            dragUp: function (event) {

                var treeMap = event.data.treemap;
                var width = Math.abs(treeMap._stopPoint.x - treeMap._startPoint.x);
                var height = Math.abs(treeMap._stopPoint.y - treeMap._startPoint.y);
                var treeMapArea = treeMap._svgDocument;

                if (treeMap.model.draggingGroupOnSelection || treeMap.model.draggingOnSelection) {

                    $('#dragDiv').remove();
                    $("#dragDiv").css({
                        "display": "none"
                    });
                    treeMap.mouseClickable = false;
                }

                if (treeMap.model.draggingGroupOnSelection) {

                    for (var i = 0; i < treeMap.treemapgroups.length; i++) {
                        var item = treeMap.treemapgroups[i].element;
                        var rect = item[0].getBoundingClientRect();

                        if (!(rect.left - treeMapArea[0].offsetLeft + rect.width < Math.min(treeMap._startPoint.x, treeMap._stopPoint.x) || Math.min(treeMap._startPoint.x, treeMap._stopPoint.x) + width < rect.left - treeMapArea[0].offsetLeft ||
                            rect.top - treeMapArea[0].offsetTop + rect.height < Math.min(treeMap._startPoint.y, treeMap._stopPoint.y) || Math.min(treeMap._startPoint.y, treeMap._stopPoint.y) + height < rect.top - treeMapArea[0].offsetTop)) {
                            if (!treeMap._contains(treeMap._prevSelectedGroupDatas, item))
                                treeMap._prevSelectedGroupDatas.push(item);
                        }
                    }

                    for (var i = 0; i < treeMap._prevSelectedGroupDatas.length; i++) {
                        var item = treeMap._prevSelectedGroupDatas[i][0];
                        var rect = item.getBoundingClientRect();

                        $(item).css({
                            "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.model.highlightGroupBorderBrush,
                            "box-sizing": "border-box",
                            "-moz-box-sizing": "border-box",
                            "-webkit-box-sizing": "border-box",
                        });
                    }
                    treeMap.selectedItems.push(treeMap._prevSelectedGroupDatas);
                }

                if (treeMap.model.draggingOnSelection) {

                    for (var i = 0; i < treeMap._rootTreeMapItems.length; i++) {
                        var item = treeMap._rootTreeMapItems[i];
                        var rect = item.rectangle.getBoundingClientRect();

                        if (!(rect.left - treeMapArea[0].offsetLeft + rect.width < Math.min(treeMap._startPoint.x, treeMap._stopPoint.x) || Math.min(treeMap._startPoint.x, treeMap._stopPoint.x) + width < rect.left - treeMapArea[0].offsetLeft ||
                             rect.top - treeMapArea[0].offsetTop + rect.height < Math.min(treeMap._startPoint.y, treeMap._stopPoint.y) || Math.min(treeMap._startPoint.y, treeMap._stopPoint.y) + height < rect.top - treeMapArea[0].offsetTop)) {
                            if (!treeMap._contains(treeMap._prevSelectedItems, item))
                                treeMap._prevSelectedItems.push(item);
                        }
                    }

                    for (var i = 0; i < treeMap._prevSelectedItems.length; i++) {
                        var item = treeMap._prevSelectedItems[i].rectangle;
                        var rect = item.getBoundingClientRect();
                        $(item).css({
                            "border-width": treeMap.model.highlightGroupBorderThickness, "border-color": treeMap.model.highlightGroupBorderBrush,
                            "box-sizing": "border-box",
                            "-moz-box-sizing": "border-box",
                            "-webkit-box-sizing": "border-box",
                        });
                    }
                    treeMap.selectedItems.push(treeMap._prevSelectedItems);
                }
            },

        _generateLabels: function (Items,level) {            
            for (var i = 0; i < Items.length; i++) {
                var item = Items[i];
                if (level.labelTemplate == null) {                    
                    var leftpaddingsize = 8;
                    var toppaddingsize = 5;
                    var textcon = $('<label class="e-treemap-label" >' + item.label + '</label>');
                    if (this.enableDrillDown())
                    {
                        $(textcon).css({
                            "position": "absolute","color":"black",
                            "overflow": "hidden",  "left": item.LeftPosition + leftpaddingsize + "px",
                            "top": item.TopPosition + toppaddingsize + "px", "font-weight":"normal","pointer-events":"none"
                        });
                    }
                    else
                    {
                        $(textcon).css({
                            "position": "absolute", "color": "white",
                            "overflow": "hidden", "left": item.LeftPosition + leftpaddingsize + "px",
                            "top": item.TopPosition + toppaddingsize + "px", "font-weight": "normal", "pointer-events": "none"
                        });
                    }
                    this._treeMapLabels.push(textcon);
                    this._templateDiv.append(textcon);
                    var padding = 0, borderthickness = 0;
                    if (level.groupPadding != undefined)
                        padding = level.groupPadding;
                    if (level.groupBorderThickness != undefined)
                        borderthickness = level.groupBorderThickness;
                    var labelWidth = (textcon[0].getBoundingClientRect().width > 0) ? textcon[0].getBoundingClientRect().width + padding + borderthickness + 2 : item.label.length * 8;
                    var labelHeight = textcon[0].getBoundingClientRect().height;
                    if (labelHeight == 0 && item.ItemHeight > 18)
                        labelHeight = 18;
                    else if (labelHeight > 0 && labelHeight > item.ItemHeight)
                        labelHeight = item.ItemHeight - toppaddingsize;
                    $(textcon).css({ "width": labelWidth + "px", "height": labelHeight + "px" });
                    item.labelPosition = level.labelPosition;
                    item.labelVisibilityMode = borderthickness;
                    item.groupPadding = level.groupPadding;
                    item.groupBorderThickness = level.groupBorderThickness;
                    textcon[0].data = item;
                    this._labelTemplateElements.push(textcon);
					if ( level.labelVisibilityMode== ej.datavisualization.TreeMap.VisibilityMode.HideOnExceededLength) {
						if (labelWidth > item.ItemWidth) {
                        $(textcon).css({
                            "display": "none",


                        });
                        if(item.Rectangle!=null)
                        item.Rectangle.title =item.label;

                        }
						var textMode = level.labelVisibilityMode;
                  }				  				    

				  else {
					    if (labelWidth < item.ItemWidth) {
					        $(textcon).css({
					            "width": labelWidth
					        });
					    }
					    else {
					        $(textcon).css({
					            "width": item.ItemWidth
					        });
					    }                           
				  }				  				  			
                }
                if(level.labelTemplate != null) {
                    var OriginalNode = $("#" + level.labelTemplate);
                    var item_templateDiv = $("<div style='overflow:hidden;display:block;position:absolute;pointer-events: none;'></div>");
                    item_templateDiv[0].data = item;
                    item.labelPosition = level.labelPosition;
                    item.labelVisibilityMode = level.labelVisibilityMode;
                    var tmpl2 = $.templates(OriginalNode.html());
                    var htmlString = "";
                    if (item.Data instanceof Array) {
                        htmlString = tmpl2.render({ data: item.Data });
                    }
                    else
                        htmlString = tmpl2.render(item.Data);
                    $(item_templateDiv).html(htmlString);
                    this._templateDiv.append(item_templateDiv);
                    this._labelTemplateElements.push(item_templateDiv);
                }
				}
				           
        },

        _generateToolTip: function () {

            if (this.showTooltip()) {
                if (document.documentMode == 8){
                    var tooltip = document.querySelectorAll("tooltipelement");
                }
                else{
                    var tooltip = document.getElementsByClassName("tooltipelement" + this._id);
                }
                if (tooltip != null && tooltip.length == 0) {
                    var tooltip_templateDiv = $("<div></div>").attr('class', 'tooltipelement' + this._id).css({ 'position': 'absolute', 'z-index': '1000', 'display': 'none', 'pointer-events': 'none' });

                    $(document.body).append(tooltip_templateDiv);
                    this._toolTipElement = tooltip_templateDiv;
                }
                else
                {
                    this._toolTipElement = tooltip[0];
                }
                if (this.model.tooltipTemplate == null) {

                    var path;
                    if (this.labelPath()!=null)
                        path = this.labelPath();
                    else 
                        path = this.weightValuePath();
                    if (path != null) {
                        this.model.tooltipTemplate = 'defaultTooltip';

                        this.element.append($('<div id="defaultTooltip" style="display:none;"><div style="margin-left:10px;margin-top:-25px;"><div class="defaultToolTip"><p style="margin-top:-4px"><label  style="color:rgb(27, 20, 20);font-size:14px;font-weight:normal;font-family:Segoe UI">{{:#data["' + path + '"]}}</label></p></div></div></div>'));
                    }
                }
            }           
        },

        _generateLegend: function () {
            if (this.model.rangeColorMapping != null) {
                var colormapping = this.model.rangeColorMapping;
                var legendSettings = this.model.legendSettings;
                if (legendSettings.mode != ej.datavisualization.TreeMap.LegendMode.Interactive) {

                var xPos = 0;
                var yPos = 0;

                var columnWidth = 0;
                var width = 0;
                var height = 0;
                var iconwidth = this.iconWidth() + 5;
                var totalHeight = this.iconHeight() + 15;
                var totalWidth = 0;
                var columnCount = this.model.legendSettings.columnCount;
                for (var i = 0; i < colormapping.length; i++) {

                    var labelwidth = this._calcWidth(colormapping[i].legendLabel);
                    var legendWidth = this.iconWidth() + 10 + labelwidth;


                    if (columnCount != 0) {
                        if (i % columnCount != 0) {
                           
                            this._drawLegend(colormapping[i], xPos, yPos);
                            xPos += (legendWidth+5);

                        }
                        else {
                            if (i != 0)
                            yPos += (this.iconHeight() + 18);
                            xPos = 0;
                            this._drawLegend(colormapping[i], xPos, yPos);
                            xPos += (legendWidth + 5);
                        }
                        }
                    else {
                        if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Top || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) {

                            if (this._legendSize.width < xPos + legendWidth) {

                                yPos += (this.iconHeight() + 18);
                                xPos = 0;
                                this._drawLegend(colormapping[i], xPos, yPos);
                                xPos += legendWidth;
                            }
                            else {
                                this._drawLegend(colormapping[i], xPos, yPos);
                                xPos += legendWidth;
                            }
                            }
                        else {

                            if (this._legendSize.height < yPos + this.iconHeight()) {

                                yPos = 0;
                                xPos += (columnWidth + 10);
                                this._drawLegend(colormapping[i], xPos, yPos);
                                columnWidth = 0;
                                yPos += (this.iconHeight() + 18);
                            }
                            else {
                                this._drawLegend(colormapping[i], xPos, yPos);
                                columnWidth = Math.max(columnWidth, legendWidth);
                                yPos += (this.iconHeight() + 18);
                                }
                            }

                        }
                    }

                }
                else {
                    this._drawInteractiveLegend();
                }
                if ((this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Top || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) && legendSettings.alignment == ej.datavisualization.TreeMap.Alignment.Center) {
                    this._legenddiv.css({
                        "margin-left": (this._width / 2) - (this._legendSize.width / 2)
                    });
                }
                else if ((this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Top || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) && legendSettings.alignment == ej.datavisualization.TreeMap.Alignment.Far) {
                    this._legenddiv.css({
                        "margin-left": this._width - this._legendSize.width
                    });
                }
                else if ((this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Left || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Right) && legendSettings.alignment == ej.datavisualization.TreeMap.Alignment.Center) {
                    this._legenddiv.css({
                        "margin-top": (this._height / 2) - (this._legendSize.height / 2)
                    });
                }
                else if ((this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Left || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Right) && legendSettings.alignment == ej.datavisualization.TreeMap.Alignment.Far) {
                    this._legenddiv.css({
                        "margin-top": this._height - this._legendSize.height
                    });
                }

                if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) {
                    this._legenddiv.css({
                        "margin-top": this._height + 5
                    });
                }
                else if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Right) {

                    this._legenddiv.css({

                        "margin-left": this._width + 5

                    });
                }
            }
        },
		 _drawLegend: function (colormapping, xPos, yPos) {
            var legendItem;
            if (this.model.legendSettings.template == "Ellipse") {
                legendItem = this._getEllipseLegend(this.model.legendSettings, xPos, yPos);
            }
            else {
                legendItem = this._getRectLegend(this.model.legendSettings, xPos, yPos);
            }
            xPos += (this.iconWidth() + 5);
            $(legendItem).css("background-color", colormapping.color);
            legendItem.appendTo(this._legenddiv);
            var legendText = $("<div class='e-treemap-legendLabel'/>");
            legendText.css({
                "left": xPos + "px",
                "top": yPos + "px",
                        "position": "absolute"
                    });
                   
            legendText[0].innerHTML = colormapping.legendLabel;
            legendText.appendTo(this._legenddiv);
        },
       
        _calcWidth: function (text) {
            var span = $('<span class ="e-treemap-legendLabel" >' + text + '</span>');
            $('body').append(span);
            var width = span.width();
            span.remove();
            return width;
        },
        
        _getEllipseLegend: function (legengItem, xPos, yPos) {

            var rect = $("<div class='e-mapLegend'/>");
            rect.css({
                "height": this.iconHeight()+ "px",
                "width": this.iconWidth() + "px",
                "border-radius":this.iconHeight()/2+"px",
                "left": xPos + "px",
                "top": yPos + "px",
                "position": "absolute"
            });
            return rect;

        },
       
        _getRectLegend: function (legengItem, xPos, yPos) {
            var rect = $("<div />");
            rect.css({
                "height": this.iconHeight()+ "px",
                "width": this.iconWidth() + "px",                
                "left": xPos + "px",
                "top": yPos + "px",
                "position": "absolute"
            });
            return rect;
        },
        
        _getPositionFromParent: function (element, parentelement) {
            var child = element.getBoundingClientRect();
            var parent = parentelement.getBoundingClientRect();
            var width = window.SVGSVGElement ? child.width: child.right-child.left;
            var height = window.SVGSVGElement ? child.height : child.bottom - child.top;            
            return { left: child.left - parent.left, top: child.top - parent.top, height: height, width: width };
        },
        
        _renderLabels: function () {
           
            for (var j = 0; j < this._labelTemplateElements.length; j++) {
                var label = this._labelTemplateElements[j];
                var bounds = this._getPositionFromParent(label[0], this._templateDiv[0]);
                var item = label[0].data;
                var pos = this._getDockPositionPoint({left:item.LeftPosition,top:item.TopPosition, width: item.ItemWidth, height: item.ItemHeight }, bounds, item);
                
                $(label).css({
                    "left": pos.x,
                    "top": pos.y,
                    "pointer-events": "none",
                    "overflow":"hidden"
                });
                if (item.labelVisibilityMode == ej.datavisualization.TreeMap.VisibilityMode.HideOnExceededLength) {
                    if (bounds.height > item.ItemHeight || bounds.width > item.ItemWidth) {
                        $(label).css("display", "none");
                    }
                }
            }
        },
       
        _generateHeaders: function (headerValue,level) {           
            var textMode = level.headerVisibilityMode;
            var generateHeader = false;
            var leftpadding = 2;
            var toppadding = 2;
            if (textMode == ej.datavisualization.TreeMap.VisibilityMode.HideOnExceededLength) {
                var textelement = $('<span>'+headerValue.header+'</span>');
                $(document.body).append(textelement);
                var width = textelement.outerWidth();
                textelement.remove();
                if (headerValue.headerHeight < (headerValue.ItemHeight- (2 * leftpadding)) && width < (headerValue.ItemWidth-(2 * toppadding))){
                    generateHeader = true;
                }					
            }
            else {
                if (headerValue.headerHeight < headerValue.ItemHeight){
                    generateHeader = true;
                }
            }
            if(generateHeader) {
                if (headerValue.headerTemplate == null) {
                    var headerItem = $('<div style="display:block;position:absolute;pointer-events: stroke;overflow: hidden;"><label class="e-treemap-header">' + headerValue.header + '</label></div>');
                    $(headerItem).css({
                        "left": headerValue.headerLeftPosition+leftpadding,
                        "top": headerValue.headerTopPosition+toppadding,
                        "width": headerValue.headerWidth - level.groupPadding,
                        "height": headerValue.headerHeight,
                        "margin-left": level.groupPadding                    
                    });
                    this._templateDiv.append(headerItem);
                }
                else {
                    var item_templateDiv = $("<div style='display:block;position:absolute;pointer-events: none;overflow: hidden;'></div>");
                    this._templateDiv.append(item_templateDiv);
                    $(item_templateDiv).css({
                        "left": headerValue.headerLeftPosition,
                        "width": headerValue.headerWidth, "top": headerValue.headerTopPosition,
                        "height": headerValue.headerHeight
                    });
                    var arguments = { header: headerValue.header, data: headerValue.Data };
                    var htmlString = $("#" + headerValue.headerTemplate).render(arguments);
                    $(item_templateDiv).html(htmlString);
                }
            }
        },

        getDrillDownHeader:function(header)
        {
            var headerString = "";
            if(header.length==1)
            {
                return header[0];
            }
            else{
                for (var index = 0; index < header.length; index++)
                {
                    headerString += header[index];
                    if(index!=header.length-1)
                    {
                        headerString += ".";
                    }
                }
            }
            return headerString;
            
        },
	
        _drillDownHeader: function (enableNavigation) {

            var labelValue = [];
            var label = [];            
            for (i = 0; i < this._drilldownHeaders.length;i++)
            {                
                labelValue += "<label class='e-drilldownlabel' style='margin-left:-8px'>" + this._drilldownHeaders[i] + "</label>";
                if (this._drilldownHeaders.length > 1 && i < this._drilldownHeaders.length-1)
                {                    
                    labelValue = labelValue + "."                    
                }                  
            }                       

            var item_templateDiv = $("<div class='e-drilldownHeader' style='display:block;overflow: hidden;'><label class='e-drilldownlabel'  style='position:absolute;height:30px;position:absolute;margin-top: 5px;top: 0px;'>" + labelValue + "</label></div>");
            if (enableNavigation)
                item_templateDiv = $("<div class='e-drilldownHeader' style='display:block;overflow: hidden;'><svg class='e-drilldownarrow' style='width:15px;height:15px;margin-top: 10px;'><polyline points='8,0 8,10 0,5 8,0'/></svg><label class='e-drilldownlabel'  style='left:17px;position:absolute;height:30px;position:absolute;margin-top: 5px;top: 0px;'>" + labelValue + "</label></div>");
            
            $(item_templateDiv).css({
                "left": "0px",
                "width": this._width+"px","top": 0,
                "height": "30px","cursor":"pointer"
            });    
            if(this.drillDownHeaderColor()!=null)
            {
                $(item_templateDiv).css("background-color",this.drillDownHeaderColor());
            }			
            this._drillHeaderDiv.append(item_templateDiv);
            $(item_templateDiv).mousedown({ treemap: this }, this._drilldownfunction);
            $(".e-drilldownlabel").mousedown({ treemap: this }, this._drilldownLabel);
            
        },


        _drilldownLabel: function (event) {
            var label = this.innerHTML;
            var treeMap = event.data.treemap;
            var pos;
            if (treeMap._drilldownHeaders[0] == label)
            {                
                treeMap._drilldownItems = [];
                treeMap.refresh();
            }
            else
            {                
                var header = "";
                
                treeMap._drillHeaderDiv[0].innerHTML = "";
                treeMap._backgroundTile[0].innerHTML = "";
                var drillHeader = "";               

                for (i = 0; i < treeMap._drilldownHeaders.length; i++) {
                    if (label == treeMap._drilldownHeaders[i]) {                        
                        pos = i + 1;                        
                        treeMap._drilldownHeaders.splice(i+1);
                    }
                }
                
                treeMap._labelTemplateElements = [];
                treeMap._drillDownHeader(true);
                               
                treeMap._drilldownItem = treeMap._drilldownItems[pos - 2];
                treeMap._drilldownItems.splice(pos - 1);
                
                treeMap._templateDiv[0].innerHTML = "";
                treeMap._groupdrillDownLevels(treeMap._drilldownItem, treeMap._drilldownItems.length);                                
                return false;
            }
        },


		
        _drilldownfunction: function (event) {
            var treeMap = event.data.treemap;                       
            treeMap._trigger("drillStarted", event);
            if (treeMap._drilldownItems.length > 0) {                
                if (treeMap._drilldownItems.length == 1) {
                    treeMap._drilldownItems = [];
                    treeMap.refresh();
                }
                else {
                    var header = "";
                    for (var i = 0; i < treeMap._drillHeaderDiv[0].children[0].children.length; i++) {
                        if (treeMap._drillHeaderDiv[0].children[0].children[i].className == "e-drilldownlabel")
                            header = treeMap._drillHeaderDiv[0].children[0].children[i].innerHTML;
                    }
                    var headers = header.split(".");
                    treeMap._drillHeaderDiv[0].innerHTML = "";
                    treeMap._backgroundTile[0].innerHTML = "";
                    var drillHeader = "";
                    if (treeMap._drilldownHeaders.length > 1)
                    {
                        treeMap._drilldownHeaders.pop(treeMap._drilldownHeaders.length - 1);
                    }                    
                    treeMap._labelTemplateElements = [];
                    treeMap._drillDownHeader(true);
                    treeMap._drilldownItem = treeMap._drilldownItems[treeMap._drilldownItems.length - 2];
                    treeMap._drilldownItems.pop(treeMap._drilldownItems[treeMap._drilldownItems.length - 1]);
                    treeMap._templateDiv[0].innerHTML = "";
                    treeMap._groupdrillDownLevels(treeMap._drilldownItem, treeMap._drilldownItems.length);
                }
                treeMap._trigger("drillDownItemSelected", { level: treeMap._drilldownItems.length, header: treeMap.getDrillDownHeader(treeMap._drilldownHeaders), prevLevel: treeMap._drilldownItems.length - 1 });
            }            
        },
       
      _sizeCalculation: function () {

            if (this.model.rangeColorMapping != null) {
                var colormapping = this.model.rangeColorMapping;
                var width = 0;
                var height = 0;
                var iconwidth = this.iconWidth() + 5;
                var totalHeight = this.iconHeight() + 15;
                var totalWidth = 0;
                var columnCount = this.model.legendSettings.columnCount;


                var legendSettings = this.model.legendSettings;
                if (this.model.legendSettings.mode != ej.datavisualization.TreeMap.LegendMode.Interactive) {
                if ((this.legendheight() == 0 && this.legendwidth() == 0) && (columnCount == 0)) {
                    for (var i = 0; i < colormapping.length; i++) {
                        if((colormapping[i].legendLabel) == undefined){
                            colormapping[i].legendLabel =  (colormapping[i].from) + "-" + (colormapping[i].to) ;
                        }
                        var labelwidth = this._calcWidth(colormapping[i].legendLabel);
                        var legendWidth = iconwidth + labelwidth + 10;
                        if (this.legendheight() == 0 && this.legendwidth() == 0) {
                            if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Top || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) {
                                if (this._width < (width + legendWidth)) {
                                    totalHeight = (this.iconHeight() + 15) + totalHeight;
                                    totalWidth = Math.max(totalWidth, width);
                                    width = legendWidth;
                                }
                                else {
                                    width += legendWidth;
                                }
                            }
                            else {

                                    if (this._height < (height + this.iconHeight() + 15)) {
                                    totalWidth += width;
                                    totalHeight = Math.max(totalHeight, height);
                                    width = legendWidth;
                                    height = 0;
                                }
                                else {
                                    height += (this.iconHeight() + 18);
                                    width = Math.max(legendWidth, width);
                                }
                            }
                        }
                        else {

                            xPos += _legendlabelwidth + 18;
                            if (xPos + 150 >= this.legendwidth()) {
                                xPos = 10;
                                yPos += 40;
                            }
                        }
                    }

                    if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Top || this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) {
                        totalWidth = Math.max(totalWidth, width);
                        totalHeight += 5;
                    }
                    else {
                        totalWidth += (width + 15);
                        totalHeight = Math.max(totalHeight, height);
                    }
                }
               else if (columnCount == 0) {

                        for (var i = 0; i < colormapping.length; i++) {
                            if ((colormapping[i].legendLabel) == undefined) {
                                colormapping[i].legendLabel = (colormapping[i].from) + "-" + (colormapping[i].to);
                            }
                        }
                    if ((this.legendheight().toString().indexOf("%")) != -1) {

                        totalHeight = (this._height / 100) * parseInt(this.legendheight().replace('%', ''))
                    }
                    else {

                        totalHeight = this.legendheight();
                    }
                    if ((this.legendwidth().toString().indexOf("%")) != -1) {

                        totalWidth = (this._width / 100) * parseInt(this.legendwidth().replace('%', ''))
                    }
                    else {

                        totalWidth = this.legendwidth();
                    }

                }

                if (columnCount != 0) {

                    for (var i = 0; i < colormapping.length; i++) {
                            if ((colormapping[i].legendLabel) == undefined) {
                                colormapping[i].legendLabel = (colormapping[i].from) + "-" + (colormapping[i].to) ;
                            }
                             var labelwidth = this._calcWidth(colormapping[i].legendLabel);
                            
                            legendWidth = iconwidth + labelwidth + 10;

                        if (i % columnCount != 0) {
                            width += legendWidth;
                            if (i == columnCount - 1) {
                                totalWidth = Math.max(totalWidth, width);
                            }

                        }
                        else {
                            if (i != 0)
                                totalHeight = (this.iconHeight() + 15) + totalHeight;
                            totalWidth = Math.max(totalWidth, width);
                            width = legendWidth;
                        }
                    }
                }
                }
                else {
                    totalHeight = (legendSettings.height != 0 ? legendSettings.height : 30) + 18;
                    if (legendSettings.title != null && legendSettings.title != "") {
                        totalHeight += 25;
                    }
                    totalWidth = (legendSettings.width != 0 ? legendSettings.width : 100) + 20 + (legendSettings.leftLabel.length * 10) + (legendSettings.rightLabel.length * 10);

                }
                this._legendSize = { height: totalHeight, width: totalWidth };
                if (this.model.legendSettings != null) {

                    if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Bottom) {
                        this._height = this._height - parseFloat(totalHeight);
                        this.model.legendSettings.tempWidth = width;
                    }

                    else if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Top) {
                        this._height = this._height - parseFloat(totalHeight);

                        this._margintop = parseFloat(totalHeight);
                    }
                    else if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Left) {
                        this._width = this._width - totalWidth;
                        this._marginleft = totalWidth;

                    }
                    else if (this.dockPosition() == ej.datavisualization.TreeMap.DockPosition.Right) {
                        this._height = this._height;
                        this._width = this._width - totalWidth;
                    }
                }
            }
        },

        _getDockPositionPoint:function(size,bounds,item)
        {
            var position = item.labelPosition;
            var x = 2, y = 2;
            if (item.groupPadding != undefined && item.groupBorderThickness != undefined) {
                x = item.groupPadding + item.groupBorderThickness + x;
                y = item.groupPadding + item.groupBorderThickness + y;
            }
            if (item.showHeader && !this.enableDrillDown())
                y = y + item.headerHeight;
            if (position == ej.datavisualization.TreeMap.Position.TopCenter) {
                x = (size.width/2)-(bounds.width/2);
            }
            else if (position == ej.datavisualization.TreeMap.Position.TopRight) {
                x = size.width - bounds.width - x;
            }
            else if (position == ej.datavisualization.TreeMap.Position.CenterLeft) {
                y = (size.height / 2) - (bounds.height / 2);
            }
            else if (position == ej.datavisualization.TreeMap.Position.Center || position==null) {
                x = (size.width / 2) - (bounds.width / 2);
                y = (size.height / 2) - (bounds.height / 2);
            }
            else if (position == ej.datavisualization.TreeMap.Position.CenterRight) {
                x = size.width - bounds.width -x;
                y = (size.height / 2) - (bounds.height / 2);
            }
            else if (position == ej.datavisualization.TreeMap.Position.BottomLeft) {
                y = size.height - bounds.height - y;
            }
            else if (position == ej.datavisualization.TreeMap.Position.BottomCenter) {
                x = (size.width / 2) - (bounds.width / 2);
                y = size.height - bounds.height-y;
            }
            else if (position == ej.datavisualization.TreeMap.Position.BottomRight) {
                x = size.width - bounds.width-x;
                y = size.height - bounds.height-y;
            }
            return {x:size.left+x,y:size.top+y};
        },
       
        _generateTreeMapItems: function (Items, fill, path) {
            this._rootTreeMapItems= Items;
            this._getTreeMapItemTemplate(Items);
            if (Items != null) {
                if (!this._isLevelColors){
                    this._setColorMappings(Items, this.model);
                }
                for (var i = 0; i < Items.length; i++) {
                    var item = Items[i];                    
                                      
                    var rect = item.rectangle;
                    if (item.Data != null && item.Data.length>0) {
                        item.Data = item.Data[0];
                    }
                    item.Rectangle = rect;
					 $(rect).css({
                        "box-sizing": "border-box",
                        "-moz-box-sizing": "border-box",
                        "-webkit-box-sizing": "border-box",
                    });
                    if(item.backgroundColor!=null)
                        $(rect).css("background-color",item.backgroundColor);
                    else
                        $(rect).css("background-color","#E5E5E5");
                    if(item.backgroundOpacity !=null)
                    {
                        $(rect).css("opacity",item.backgroundOpacity);
                    }
                    this._wireEventForTreeMapItem(item, rect);
                 
                }
                if (this.model.rangeColorMapping.length == 0 && this.uniColor() == null && this._color() != "") {
                    this._setDesaturationColor(Items, this.model.desaturationColorMapping);
                }
                else if (this.model.PaletteColorMapping != null) {
                    this._setPaletteColor(Items, this.model.PaletteColorMapping);
                }
            }
        },

        browserInfo: function () {
            var browser = {}, clientInfo = [],
            browserClients = {
                webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
                opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
            };
            for (var client in browserClients) {
                if (browserClients.hasOwnProperty(client)) {
                    clientInfo = navigator.userAgent.match(browserClients[client]);
                    if (clientInfo) {
                        browser.name = clientInfo[1].toLowerCase();
                        browser.version = clientInfo[2];
                        if (!!navigator.userAgent.match(/Trident\/7\./)) {
                            browser.name = "msie";
                        }
                        break;
                    }
                }
            }
            browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
            browser.pointerEnabled = window.navigator.pointerEnabled;
            return browser;
        },

        isTouch: function (evt) {
            
                var event = evt.originalEvent ? evt.originalEvent : evt;
            if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        },

        _wireEventForTreeMapItem: function (item, rect) {
            browserInfo = this.model.browserInfo,
            isPointer = browserInfo.isMSPointerEnabled,
            isIE11Pointer = browserInfo.pointerEnabled,
            touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
            touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup",
            touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove",
            touchEnterEvent = isPointer ? (isIE11Pointer ? "pointerenter" : "MSPointerEnter") : "touchenter mouseenter",
            touchCancelEvent = isPointer ? (isIE11Pointer ? "pointerleave" : "MSPointerOut") : "touchleave mouseleave";        

            this._on($(rect), touchMoveEvent, { Param1: item, Param2: this }, this._rectMouseMove);
            this._on($(rect), touchCancelEvent, { treeMap: this }, this._rectMouseLeave);

            this._on($(rect), touchStopEvent, { Param1: item, Param2: this }, this._rectMouseUp);
            this._on($(rect), touchStartEvent, { treeMap: this }, this._rectMouseDown);
            this._on($(rect), touchEnterEvent, { Param1: item, Param2: this }, this._rectMouseEnter);

           
        },

        _getTreeMapItemTemplate: function (Items) {            
            
            var rects ="";
            for (var i = 0; i < Items.length; i++) {
                var item = Items[i];
                if (this.model.leafItemSettings.itemTemplate == null)
                    rects += '<div style="border-style:solid;position:absolute;left:' + item.LeftPosition + 'px;top:' + item.TopPosition + 'px;height:' + item.ItemHeight + 'px;width:' + item.ItemWidth + 'px;border-width:' + this.borderThickness() + 'px;border-color:' + this.borderBrush() + '"></div>';
                else {
                    var OriginalNode = $("#" + this.model.leafItemSettings.itemTemplate);
                    if (item.Data != null && item.Data.length == 1) {
                        item.Data = item.Data[0];
                    }
                    var tmpl2 = $.templates(OriginalNode.html());
                    var htmlString = "<div style='overflow:hidden;position:absolute;left:" + item.LeftPosition + "px;top:" + item.TopPosition + "px;height:" + item.ItemHeight + "px;width:" + item.ItemWidth + "px'>" + tmpl2.render(item) + "</div>";
                    rects += htmlString;
                }
            }
            if (this._svgDocument != null && this.enableDrillDown()) {
                this._svgDocument[0].innerHTML = "";
            }
            this._svgDocument = $('<div style= "overflow:hidden;' +
                              'z-index:1;"' +
                             'id="svgDocument">' + rects + '</div>');
            this._backgroundTile.appendTo(this.element);
            this._svgDocument.appendTo(this.element);           
            this._svgDocument.css({
                "height": this._height + "px", "width": this._width + "px", "margin-top": this._margintop + "px", "margin-left": this._marginleft, "overflow": "hidden",
                "z-index": 1, "position": "absolute", "left": "0", "top": "0"
            });
            $(this._backgroundTile).css({
                "height": this._height + "px", "width": this._width + "px", "margin-top": this._margintop + "px", "margin-left": this._marginleft, "overflow": "hidden",
                "z-index": 0, "position": "absolute", "left": "0", "top": "0"
            });
            this._templateDiv.appendTo(this.element);
            /* Below event hook added for IE10 tooltip issue*/
            $(this._templateDiv).mousemove({ Param2: this }, this._rectMouseMove);
            var browserInfo = this.model.browserInfo,
            isPointer = browserInfo.isMSPointerEnabled,
            isIE11Pointer = browserInfo.pointerEnabled,
            touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : "touchstart mousedown",
             touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup";
			
			this._off($(this.element), touchStartEvent, this.rectClick);
            this._off($(this.element), touchStopEvent, this._docClickFunction);
            this._off($(this.element), ej.eventType.mouseDown, this.dragDown);
            this._off($(this.element), ej.eventType.mouseMove, this.dragMove);
            this._off($(this.element), ej.eventType.mouseUp, this.dragUp);
			
            this._on($(this.element), touchStartEvent, { treemap: this, Param1: Items }, this.rectClick);
            this._on($(this.element), touchStopEvent, { treemap: this, Param1: Items }, this._docClickFunction);            
            this._on($(this.element), ej.eventType.mouseDown, { treemap: this }, this.dragDown);
            this._on($(this.element), ej.eventType.mouseMove, { treemap: this }, this.dragMove);
            this._on($(this.element), ej.eventType.mouseUp, { treemap: this }, this.dragUp);

            if (this.enableDrillDown()) {
                this._drillHeaderDiv.appendTo(this.element);
                this._drillHoverDiv.appendTo(this.element);
            }
            for (var i = 0; i<Items.length; i++) {
                Items[i].rectangle = this._svgDocument[0].childNodes[i];
            }
        },	       

        selectItem: function (obj) {
            if (this._rootTreeMapItems != null) {
                for (var i = 0; i < this._rootTreeMapItems.length; i++) {
                    var item = this._rootTreeMapItems[i];
                    var rect = item.rectangle;
                    if (item.Data != null && item.Data.length > 0) {
                        item.Data = item.Data[0];
                    }
                   
                    if (obj == item.Data) {
                        if (this.highlightOnSelection()) {

                            $(rect).css({ "border-width": this.highlightBorderThickness(), "border-color": this.highlightBorderBrush() });
                            if (this._browser != "msie") {
                                var lastItem = this._svgDocument[0].children[this._svgDocument[0].children.length - 1];
                                this._svgDocument[0].insertBefore(rect, lastItem);
                            }
							this._prevSelectedItems.push(rect);
							this._trigger("treeMapItemSelected", { selectedItems: obj, originalEvent: event });                              
                        }
					}
                    
                }
            }

        },
      
        _selectTreemapItem: function (obj) {

            if (this._rootTreeMapItems != null) {
                for (var i = 0; i < this._rootTreeMapItems.length; i++) {
                    var item = this._rootTreeMapItems[i];
                    var rect = item.rectangle;
                    if (item.Data != null && item.Data.length > 0) {
                        item.Data = item.Data[0];
                    }
                    if (obj == item.Data && !this._contains(this.selectedItems, obj)) {

                        if (this.highlightOnSelection()) {
                            $(rect).css({ "border-width": this.highlightBorderThickness(), "border-color": this.highlightBorderBrush() });
                            if (this._browser != "msie") {
                                var lastItem = this._svgDocument[0].children[this._svgDocument[0].children.length - 1];
                                this._svgDocument[0].insertBefore(rect, lastItem);
                            }
                            this._prevSelectedItems = [];
                            this.selectedItems = [];
                            this._prevSelectedItems.push(rect);
                            this.selectedItems.push(obj);
                        }
                    }

                }
            }
        },
        
        _selectItemResize: function () {

            for (var i = 0; i < this._rootTreeMapItems.length; i++) {
                var item = this._rootTreeMapItems[i];
                var rect = item.rectangle;
                if (item.Data != null && item.Data.length > 0) {
                    item.Data = item.Data[0];
                }
                if (this._contains(this.selectedItems, item.Data)) {
                    this.selectItem(item.Data);
                }
                
            }
        },
		    _updateLegendRange: function (value, treemapitem) {
            var colormapping = this.model.rangeColorMapping;
            for (var index = 0; index < colormapping.length; index++) {
                var gradientCollection = null;
                var mapping = colormapping[index];
                if (this.model.enableGradient) {
                    gradientCollection = this._generateGradientCollection(mapping.gradientColors);
                }
                if (value >= mapping.from && value <= mapping.to) {
                    var minValue = index;
                    if (index != 0)
                        minValue = index * 10;
                    var minRange = mapping.from;
                    var maxRange = mapping.from + ((mapping.to - mapping.from) / 10);
                    for (var i = minValue; i < minValue + 10; i++) {
                        if (value >= minRange && value <= maxRange) {
                            var obj = {};
                            var shapeOpacity = this._getColorRatio(0.7, 1, value, mapping.from, mapping.to);
                            if (this._legendRects[i] != undefined)
                                obj = this._legendRects[i];
                            if (this.model.enableGradient) {
                                if (index != 0) {
                                    treemapitem.backgroundColor = gradientCollection[i - index * 10];
                                } else {
                                    treemapitem.backgroundColor = gradientCollection[i];
                                }
                            } else
                                treemapitem.backgroundColor = mapping.color;
                            treemapitem.backgroundOpacity = shapeOpacity;
                            obj["color"] = treemapitem.backgroundColor;
                            return obj;
                        }
                        minRange = maxRange;
                        maxRange = maxRange + ((mapping.to - mapping.from) / 10);
                    }
                }
            }
        },
		
        selectItemByPath: function (path, value, seperator) {
            var propertyPath = path.split(seperator);
            var propertyValue = value.split(seperator);
            var path, value;
            var treemapItems = this._rootTreeMapItems;
            for (var i = 0; i < propertyPath.length; i++)
            {
                var path = propertyPath[i];
                var value = propertyValue[i];
                var itemsCollection = [];
                for (var k = 0; k < treemapItems.length; k++) {
                    var item = treemapItems[k];
                    var dataObj = item.Data;
                    var objValue;
                    for (var j = 0; j < propertyPath.length; j++) {
                        objValue = this._reflection(dataObj, path);
                    }

                    if (value == objValue) {
                        itemsCollection.push(item);
                    }
                }
                treemapItems = itemsCollection;
            }
            for (var i = 0; i < treemapItems.length; i++)
            {
                var item = treemapItems[i];
                this.selectItem(item.Data);
            }
        },
          _getColorRatio: function (min, max, value, minValue, maxValue) {
            var percent = (100 / (maxValue - minValue)) * (value - minValue);
            var colorCode = (((parseFloat(max) - parseFloat(min)) / 100) * percent) + parseFloat(min);
            return colorCode;
        },
        _contains: function (array, actualobj) {
            var length = array.length;
            if (length > 0) {
                while (length--) {
                    if (array[length] === actualobj) {
                        return true;
                    }
                }
            }
            return false;
        },

        _rectMouseEnter: function(event) {
		    var treemap = event.data.Param2;
            var legendSettings = treemap.model.legendSettings;
            var tooltipObject = event.data.Param1.Data;
            if (tooltipObject != null) {
                var element = event.data.Param2._toolTipElement;
                var template = event.data.Param2.model.tooltipTemplate;
                if (element != null && template != null) {
                    if(!treemap.isTouch(event))
                       $(element).css({ "left": event.pageX+10, "top": event.pageY+10, "display": "block" });
					var locale = this.model.locale;
					var obj = $.extend({}, tooltipObject);
					if (locale && this.model.enableGroupSeparator){
						for (var key in obj)
							obj[key] = isNaN(parseFloat(obj[key])) ? obj[key] : parseFloat(obj[key]).toLocaleString(locale);
					}	
                    var htmlString = $("#" + template).render(obj);
                    $(element).html(htmlString);
                    var height= element[0]!=null ? element[0].clientHeight : element.clientHeight;
                    var width= element[0]!=null ? element[0].clientWidth : element.clientWidth;
                    event.data.Param2._tooltipSize = { height: height, width: width };
                    
                }
            }
			
			 if (legendSettings != null && legendSettings.mode == ej.datavisualization.TreeMap.LegendMode.Interactive && treemap.model.rangeColorMapping != null
                   && (treemap.showLegend() == undefined || treemap.showLegend())) {
                for (var i = 0; i < treemap._rootTreeMapItems.length; i++) {
                    var item = treemap._rootTreeMapItems[i].Rectangle;

                    if (item == event.target) {
                        var mappings = null;
                        if (treemap.model.rangeColorMapping != undefined) {
                            mappings = treemap.model.rangeColorMapping;
                        }
                        var _legendwidth = legendSettings.width;
                        if (legendSettings.width == undefined)
                            _legendwidth = 150;

                        var rectwidth = (_legendwidth / mappings.length) / 10;
                        if (treemap._rootTreeMapItems[i].legendrect != null) {
                            var rectPosition = treemap._rootTreeMapItems[i].legendrect.marginLeft;
                            var position = rectPosition + Math.ceil(rectwidth) - treemap._interactiveArrow.width() / 2;
                            $(treemap._interactiveArrow).css({ "margin-left": position, "display": "block" });
                            break;
                        }
                    }
                }
            }
        },

        displayTooltip: function (event) {
            var treeMap = event.data.Param2,
                element = treeMap._toolTipElement,
                pointer = treeMap.mousePosition(event),
                canExecute = true;           
            if (treeMap.model.trackerElement) {
                clearTimeout(treeMap.model.timer);
                $(".tooltipelement" + this._id).finish();              
            }
            if (event.data.Param1 == undefined) {
                if (element != null) {
                    var tooltipObject;
                    for (var i = 0; i < treeMap._rootTreeMapItems.length; i++) {
                        var item = treeMap._rootTreeMapItems[i];
                        if (item.rectangle.offsetLeft < pointer.offsetX && item.rectangle.offsetLeft + item.rectangle.offsetWidth > pointer.offsetX
                            && item.rectangle.offsetTop < pointer.offsetY && item.rectangle.offsetTop + item.rectangle.offsetHeight > pointer.offsetY) {
                            tooltipObject = item.Data;
                            break;
                        }
                    }
                    if (tooltipObject != null) {
                        var template = event.data.Param2.model.tooltipTemplate;
                        if (element != null && template != null) {
                            $(element).css({ "left": pointer.pageX + 10, "top": pointer.pageY + 10, "display": "block" });
                            var htmlString = $("#" + template).render(tooltipObject);
                            $(element).html(htmlString);
                            var height = element[0] != null ? element[0].clientHeight : element.clientHeight;
                            var width = element[0] != null ? element[0].clientWidth : element.clientWidth;
                            treeMap._tooltipSize = { height: height, width: width };

                        }
                    }
                    else {
                        if (element != null) {
                            canExecute = false;
                            $(element).css("display", "none");
                        }
                    }
                }
            }

            if (canExecute) {
                var tooltipSize = treeMap._tooltipSize;
                if (tooltipSize.width + pointer.pageX >= treeMap._width) {
                    pointer.pageX -= tooltipSize.width;
                    if (pointer.pageX < 0) {
                        pointer.pageX = 10;
                    }
                }
                if (tooltipSize.height + pointer.pageY >= treeMap._height) {
                    pointer.pageY -= tooltipSize.height;
                    if (pointer.pageY < 0) {
                        pointer.pageY = 10;
                    }
                }
                if (treeMap.enableDrillDown() && treeMap._browser != 'msie') {
                    for (var i = 0; i < treeMap._drillHoverDiv[0].children.length; i++) {
                        var child = treeMap._drillHoverDiv[0].children[i];
                        if (child.className == event.data.Param1.ParentHeader) {
                            $(child).css({ "display": "block" });
                        }
                    }
                }
                if (element != null) {
                    $(element).css({ "left": pointer.pageX + 10, "top": pointer.pageY + 10, "display": "block" });
                }
            }
        },

       

        _rectMouseUp: function (event) {
            
            if (this.isTouch(event))
                this.displayTooltip(event);          
        },
       
        _rectMouseMove: function (event) {
          
            /* Below If condition code was added for IE10 Tooltip issue*/
            if (!event.data.Param2.isTouch(event))
                event.data.Param2.displayTooltip(event);
        },

        _rectMouseLeave: function (event) {            
            var element = event.data.treeMap._toolTipElement;
            if (element != null && !event.data.treeMap.isTouch(event)) {
                $(element).css("display", "none");
            }
        },
		
     
       
        _setColorMappings: function(Items, colorMappings,groupmapping){
		    var obj = {};
            var proxyControl = this;
            var legendSettings = this.model.legendSettings;
            for (var i = 0; i < Items.length; i++) {
                if (!groupmapping) {
                    if (Items[i].Data instanceof Array) {
                       
                            var shapeValue = proxyControl._reflection(Items[i].Data[0], this.colorValuePath());
                    }
                    else {
                        var shapeValue = proxyControl._reflection(Items[i].Data, this.colorValuePath());
                    }
                }
                if ((colorMappings.rangeColorMapping != null && colorMappings.rangeColorMapping.length > 0) || (colorMappings.uniColorMapping != null && (colorMappings.uniColorMapping.color != null || this.uniColor() != null))) {

                    if ((legendSettings.mode == ej.datavisualization.TreeMap.LegendMode.Interactive) || this.model.enableGradient) {
                        Items[i].legendrect = this._updateLegendRange(shapeValue, Items[i]);
                    }
                    else {
                        var ColorValue = Items[i]._generateColorMappings(colorMappings, this);
                        Items[i].backgroundColor = ColorValue;
                    }
                }
                else if (colorMappings.desaturationColorMapping != null && (colorMappings.desaturationColorMapping.color != "" || this._color() != "")) {
                    this._setDesaturationColor(Items, colorMappings.desaturationColorMapping);
                }
                else if (colorMappings.paletteColorMapping != null) {
                    this._setPaletteColor(Items, colorMappings.paletteColorMapping);
                }
            }
        },
     
        _setDesaturationColor: function (Items, desaturationColorMapping) {
            Items = Items.sort(this._orderBycolorWeight);

            var from = (typeof desaturationColorMapping.from == "number") ? desaturationColorMapping.from : this._from();
            var to = (typeof desaturationColorMapping.to == "number") ? desaturationColorMapping.to : this._to();
            var rangeMin = (typeof desaturationColorMapping.rangeMinimum == "number") ? desaturationColorMapping.rangeMinimum : this._rangeMinimum();
            var rangeMax = (typeof desaturationColorMapping.rangeMaximum == "number") ? desaturationColorMapping.rangeMaximum : this._rangeMaximum();
          
            var values = [];
            for (var j = 0; j < Items.length; j++)
            {
                var item = Items[j].Data[0];
                var colorWeightValue = this._reflection(item, this.colorValuePath());
                if (colorWeightValue!=null && (typeof colorWeightValue != "number")) {

                    colorWeightValue = Number(colorWeightValue.replace(/[^0-9\.]+/g, ""));
                }               
                values.push(colorWeightValue);                
            }

            if (this._rangeMinimum() == 0)
            {
                rangeMin = Math.min.apply(Math, values);
            }            
            
            if (this._rangeMaximum() == 0)
            {
                rangeMax = Math.max.apply(Math, values);
            }            

            if (from < 0 || from > 1)
                from = 1;
            if (to > 1 || to < 0)
                to = 0;

            var interval = (from - to) / Items.length;
            for (var i = 0; i < Items.length; i++) {
                Items[i].backgroundColor = (typeof desaturationColorMapping.color == "string") ? desaturationColorMapping.color : this._color();              
                if (Items[i].colorWeight >= rangeMin && Items[i].colorWeight <= rangeMax) {
                    Items[i].backgroundOpacity= from;
                    from = from - interval;
                }
            }
        },
        
		
		  _generateGradientCollection: function (gradientColors) {
            var gradientCollection = [];
            var startRangeColor = gradientColors[0];
            var endRangeColor = gradientColors[gradientColors.length - 1];
            var startR = this._hexToR(startRangeColor);
            var startG = this._hexToG(startRangeColor);
            var startB = this._hexToB(startRangeColor);
            var endR = this._hexToR(endRangeColor);
            var endG = this._hexToG(endRangeColor);
            var endB = this._hexToB(endRangeColor);
            var range = 10;
            var rRange = this._getRangeColorValues(range, startR, endR);
            var gRange = this._getRangeColorValues(range, startG, endG);
            var bRange = this._getRangeColorValues(range, startB, endB);
            for (var i = 0; i < range; i++) {
                gradientCollection.push(this._rgbToHex(rRange[i], gRange[i], bRange[i]));
            }
            return gradientCollection;
        },


        _hexToR: function (h) {
            return parseInt((this._cropHex(h)).substring(0, 2), 16);
        },

        _hexToG: function (h) {
            return parseInt((this._cropHex(h)).substring(2, 4), 16);
        },

        _hexToB: function (h) {
            return parseInt((this._cropHex(h)).substring(4, 6), 16);
        },
        _cropHex: function (h) {
            return (h.charAt(0) == "#") ? h.substring(1, 7) : h;
        },

        _rgbToHex: function (R, G, B) {
            return "#" + this._toHex(R) + this._toHex(G) + this._toHex(B);
        },

        _toHex: function (n) {
            var charstr = "0123456789ABCDEF";
            n = parseInt(n, 10);
            if (isNaN(n)) return "00";
            n = Math.max(0, Math.min(n, 255));
            return charstr.charAt((n - n % 16) / 16)
                + charstr.charAt(n % 16);
        },
        _getRangeColorValues: function (range, start, end) {
            var rangeColorValues = [];
            rangeColorValues.push(start);
            if (start > end) {
                var rangeValue = (start - end) / (range - 1);
                for (var i = range; i > 2; i--) {
                    start = start - rangeValue;
                    rangeColorValues.push(start);
                }
            }
            else {
                var rangeValue = (end - start) / (range - 1);
                for (var i = 2; i < range; i++) {
                    start = start + rangeValue;
                    rangeColorValues.push(start + rangeValue);
                }
            }
            rangeColorValues.push(end);
            return rangeColorValues;
        },


        _isSVG: function () {
            if (window.SVGSVGElement)
                return true;
            else
                return false;
        },

        _drawInteractiveLegend: function () {
            var legendSettings = this.model.legendSettings;
            var xPos = 0;
            var yPos = 0;

            //var _isSVG = (window.SVGSVGElement) ? true : false;

            var legenddiv = this._legenddiv;
            var _legendheight = this.model.legendSettings.height != 0 ? this.model.legendSettings.height : 30;
            var _legendwidth = this.model.legendSettings.width != 0 ? this.model.legendSettings.width : 100;
            if (legendSettings.mode == ej.datavisualization.TreeMap.LegendMode.Interactive || this.model.rangeColorMapping != null) {
                var textcon = '';

                if (legendSettings.height == 0)
                    _legendheight = 30;
                if (legendSettings.width == 0)
                    _legendwidth = 100;

                if (legendSettings.leftLabel == null)
                    legendSettings.leftLabel = '';
                if (legendSettings.title != null) {
                    var newxpos = xPos;
                    if (!legendSettings.showLabels)
                        newxpos = xPos + legendSettings.leftLabel.length * 10;

                    var _legendtitlewidth = legendSettings.title.length * 10;
                    var text = titleText = legendSettings.title;;

                    if (_legendtitlewidth > _legendwidth) { 
                      
                      text=  this._trimFunction(text, _legendwidth);
                    }

                    var textcon = this._createLabel(text, newxpos, yPos, 'e-interactivelegend-title');
                    textcon[0].title = titleText;
                    textcon.css({
                        "width": _legendwidth + "px"
                    });
                    if (this._isSVG())
                        textcon.appendTo(legenddiv);
                    else
                        legenddiv.append(textcon);
                    yPos += 25;
                }

                if (legendSettings.showLabels)
                    yPos += 25;

                if (legendSettings.leftLabel != null && !legendSettings.showLabels) {
                    var textcon = this._createLabel(legendSettings.leftLabel, xPos, yPos - 3, 'e-interactivelegend-leftlabel');

                    if (this._isSVG())
                        textcon.appendTo(legenddiv);
                    else

                        legenddiv.append(textcon);
                    xPos = xPos + legendSettings.leftLabel.length * 10;
                }

                var interactiveElement = this._createInteractiveArrow(xPos, yPos + _legendheight);
                interactiveElement.appendTo(legenddiv);
                this._interactiveArrow = interactiveElement;

                var _legendgroup = null;
                if (!this._isSVG() && this.model.enableGradient) {
                    _legendgroup = this._createGroup(false, "legendGroup");
                    _legendgroup.style.left = 0 + 'px';
                    _legendgroup.style.top = 0 + 'px';
                    _legendgroup.style.position = "relative";
                    legenddiv.append(_legendgroup);
                }

                var mappings = this.model.rangeColorMapping;
                for (var key = 0; key < mappings.length; key++) {
                    var colorMapping = mappings[key];
                    if (!colorMapping.hideLegend) {
                        var gradientCollection = [];
                        if (this.model.enableGradient) {
                            gradientCollection = this._generateGradientCollection(colorMapping.gradientColors);
                        }

                        var obj = {};
                        if (this.model.enableGradient) {
                            if (this._isSVG()) {
                                var canvas = $("<canvas/>");
                                var ctx = canvas[0].getContext("2d");
                                var grd = ctx.createLinearGradient(0, 0, 300, 0);

                                var temp = 0;
                                for (var i = 0; i < 10; i++) {
                                    temp = temp + (1 / 10);
                                    if (i == 0) {
                                        grd.addColorStop(0, colorMapping.gradientColors[0]);
                                        grd.addColorStop(temp, gradientCollection[i]);
                                    } else if (i == gradientCollection.length - 1) {
                                        grd.addColorStop(temp - (1 / 10), gradientCollection[i]);
                                        grd.addColorStop(temp, colorMapping.gradientColors[1]);
                                    } else {
                                        grd.addColorStop(temp - (1 / 10), gradientCollection[i]);
                                        grd.addColorStop(temp, gradientCollection[i + 1]);
                                    }
                                }
                                ctx.fillStyle = grd;
                                ctx.fillRect(0, 0, 300, 300);

                                canvas.css({
                                    "height": _legendheight + "px",
                                    "width": (_legendwidth / mappings.length) + "px",
                                    "margin-left": xPos + "px",
                                    "margin-top": yPos + "px",
                                    "opacity": "0.9",
                                    "filter": "alpha(opacity=90)", /* For IE8 and earlier */
                                    "position": "absolute"
                                });
                                canvas.appendTo(legenddiv);
                            } else {
                                var legendID = "legend" + key;
                                var legendHtmlString = '<v:rect id=' + legendID + ' display="block" style="position:absolute;top: ' + (yPos - 2) + 'px;left:' + xPos + 'px;width:' + (_legendwidth / mappings.length) + 'px;height:' + _legendheight + 'px;"><v:fill opacity="0.9px" type="gradient" method="linear sigma" angle="270"/><v:stroke opacity="0px"/></v:rect>';
                                _legendgroup.innerHTML = _legendgroup.innerHTML + legendHtmlString;
                                var legendelement = document.getElementById(legendID);
                                legendelement.fillcolor = colorMapping.gradientColors[0];
                                legendelement.fill.color2 = colorMapping.gradientColors[1];
                            }
                        }
                        else {
                            var rect = $("<div/>");
                             rect.css({
                                "height": _legendheight + "px",
                                "width": _legendwidth / this.model.rangeColorMapping.length + "px",
                                "background-color": colorMapping.color,
                                "margin-left": xPos + "px",
                                "margin-top": yPos + "px",
                                "opacity": "0.9",
                                "filter": "alpha(opacity=90)",/* For IE8 and earlier */
                                "position": "absolute"
                            });

                            if (this._isSVG())
                                rect.appendTo(legenddiv);
                            else
                                legenddiv.append(rect);
                        }

                        for (var i = 0; i < 10; i++) {
                            obj = {};
                            obj["marginLeft"] = xPos;
                            this._legendRects.push(obj);
                            xPos = xPos + (_legendwidth / mappings.length) / 10;
                        }

                        if (this.model.legendSettings.showLabels) {
                            var labelxpos = xPos - (_legendwidth / mappings.length);
                            var labelypos = yPos - 25;
                            var startlabel = this._createLabel((colorMapping.from), labelxpos, labelypos, 'e-legend-rangestartlabel');
                            labelxpos = xpos;
                            var endlabel = this._createLabel((colorMapping.to), labelxpos, labelypos);
                            if (colorMapping.legendLabel != undefined)
                                endlabel = this._createLabel((colorMapping.legendLabel), labelxpos - (colorMapping.legendLabel.length * 10) / 2, labelypos, 'e-legend-rangeendlabel');
                            if (this._isSVG()) {
                                if (colorMapping == mappings[0])
                                    startlabel.appendTo(legenddiv);
                                endlabel.appendTo(legenddiv);
                            }
                            else {
                                if (colorMapping == mappings[0])
                                    legenddiv.append(startlabel);
                                legenddiv.append(endlabel);
                            }
                        }
                    }
                }

                if (legendSettings.rightLabel != null && !legendSettings.showLabels) {
                    var textcon = this._createLabel(legendSettings.rightLabel, xPos + 10, yPos - 3, 'e-interactivelegend-rightlabel');
                    if (this._isSVG())
                        textcon.appendTo(legenddiv);
                    else
                        legenddiv.append(textcon);
                    xPos = xPos + legendSettings.rightLabel.length * 10;
                }

                totalwidth = xPos + 10;
                totalheight = yPos + _legendheight + this._interactiveArrow.height();
                this._legendSize = { width: totalwidth, height: totalheight };

                if (legendSettings.dockPosition == 'left')
                    this._marginleft = totalwidth;
                else if (legendSettings.dockPosition == 'top')
                    this._margintop = totalheight;


            }






        },
		   _trimFunction: function (str, width) {
          
       
            var span = $('<div style="width:auto;position:absolute;" class= "e-interactivelegend-title">' + str + '</div>');
             $(document.body).append(span);
             var text = str;
            while (span.width() > width) {

                text = text.slice(0, -2);
                span.text(text + "...");
                
            }
            document.body.removeChild(span[0]);
            return span.text();
                  
        


        },
        _createLabel: function (content, xpos, ypos, className) {
            var label = $("<div class=" + className + "></div>");
            label[0].innerHTML = content;
            label.css({
                "margin-left": xpos + "px",
                "margin-top": ypos + "px",
                "position": "absolute"
            });
            return label;
        },
        _createInteractiveArrow: function (xpos, ypos) {

            var interactiveElement = $("<div class='e-icon1 e-interactiveArrow'></div>");
            interactiveElement[0].innerHTML = "&#9650";

            interactiveElement.css({
                "margin-left": xpos + "px",
                "margin-top": ypos + "px",
                "position": "absolute",

            });
            return interactiveElement;
        },

        _createGroup: function (isRoot, name) {

            var vmlGroup;
            vmlGroup = document.createElement('<v:group class=' + name + '>');
            vmlGroup.style.width = this._width + 'px';
            vmlGroup.style.height = this._height + 'px';
            vmlGroup.coordorigin = "0 0";
            vmlGroup.coordsize = this._width + ' ' + this._height;
            if (isRoot) {
                this._rootgroup = vmlGroup;
                vmlGroup.style.left = '20px';
                vmlGroup.style.top = '20px';
            }
            return vmlGroup;
        },
		
        _setPaletteColor: function (Items, PaletteColors) {
            Items = Items.sort(this._orderBycolorWeight);
            for (var i = 0; i < Items.length; i++) {
                if (PaletteColors.colors != null && PaletteColors.colors.length > 0) {
                    Items[i].backgroundColor= PaletteColors.colors[i % (PaletteColors.colors.length)];
                } 
            }
        },

        _orderBycolorWeight: function (a, b) {
            if (a.colorWeight == b.colorWeight) {
                return 0;
            } else if (a.colorWeight < b.colorWeight) {
                return 1;
            }
            return -1;
        },
       
        _orderByAreaWight: function (a, b) {
            if (a.AreaByWeight == b.AreaByWeight) {
                return 0;
            } else if (a.AreaByWeight < b.AreaByWeight) {
                return 1;
            }
            return -1;
        },

        _calculateSliceAndDiceItemSize: function (Items, xPos, yPos, width, height, gap, headerHeight, isHorizontal,legendHeight) {

            if (gap == "") { gap = 0;}
            var Gap = gap;
            var totalWeight = this._getTotalWeight(Items);
            if (isHorizontal == undefined) {
                isHorizontal = width > height ? true : false;
            }
            var AvailableSize = { "Width": width, "Height": height-legendHeight };
            var headerSize = headerHeight < AvailableSize.Height ? headerHeight : 0;
            AvailableSize.Height = AvailableSize.Height - headerSize;
            var AvailableArea = { "X": xPos, "Y": yPos + headerSize, "Width": AvailableSize.Width, "Height": AvailableSize.Height };
            var parentArea = AvailableSize.Height * AvailableSize.Width;
            var itemsCount = Items.length;
            if (isHorizontal) {
                var parentHeight = AvailableSize.Height;
                var allottedWidth = 0;
                for (var i = 0; i < itemsCount; i++) {
                    var childarea = (parentArea / totalWeight) * Items[i].weight;
                    var childWidth = childarea / parentHeight;
                    gap = (childWidth > Gap) ? Gap : 0;

                    if (allottedWidth <= AvailableSize.Width) {
                        Items[i].ItemWidth = (i != itemsCount - 1) ? childWidth - parseFloat(gap) : childWidth;
                        Items[i].ItemHeight = parentHeight;
                        Items[i].LeftPosition = allottedWidth + xPos;
                        Items[i].TopPosition = yPos + headerHeight;
                        allottedWidth += childWidth;
                    }
                }
            }
            else {
                var parentWidth = AvailableSize.Width;
                var allottedHeight = 0;
                for (var i = 0; i < itemsCount; i++) {
                    var childarea = (parentArea / totalWeight) * Items[i].weight;
                    var childHeight = childarea / parentWidth;
                    gap = (childHeight > Gap) ? Gap : 0;
                    if (allottedHeight <= AvailableSize.Height) {
                        Items[i].ItemWidth = parentWidth;
                        Items[i].ItemHeight = (i != itemsCount - 1) ? childHeight - parseFloat(gap) : childHeight;
                        Items[i].LeftPosition = xPos;
                        Items[i].TopPosition = allottedHeight + yPos + headerSize;
                        allottedHeight += childHeight;
                    }
                }
            }
        },

        _calculateSquarifiedItemSize: function (Items, xPos, yPos, width, height, Gap, headerHeight, legendHeight) {

            if (Gap == "") { Gap = 0; }            
            var totalweight = this._getTotalWeight(Items);
            var AvailableSize = { "Width": width, "Height": height-legendHeight };
            var headerSize = headerHeight < AvailableSize.Height ? headerHeight : 0;
            AvailableSize.Height = AvailableSize.Height - headerSize;
            for (var i = Items.length - 1; i >= 0; i--) {
                var item = Items[i];
                item["AreaByWeight"] = (AvailableSize.Height * AvailableSize.Width) * item.weight / totalweight;
                item.headerTopPosition = yPos;
            }
            var AvailableArea = { "X": xPos, "Y": yPos + headerSize, "Width": AvailableSize.Width, "Height": AvailableSize.Height };
            var OrderedItems = Items.sort(this._orderByAreaWight);
            var curX = 0, curY = 0;
            var j = 0;
            for (var i = 0; i < Items.length; i = j) {
                var firstTreemapItem = OrderedItems[i];
                weightObject = this._getGroupTotalWeight(firstTreemapItem, OrderedItems, AvailableArea, i);
                var GroupTotalWeight = weightObject.totalWeight;
                j = weightObject.index;
                var currentRect = {};
                var isHorizontal = (AvailableArea.Width > AvailableArea.Height) ? true : false;
                for (var k = i; k < j; k++) {
                    var item = OrderedItems[k];
                    var areaSum = GroupTotalWeight;
                    if (k == i) {
                        currentRect.X = AvailableArea.X;
                        currentRect.Y = AvailableArea.Y;
                        if (isHorizontal) {
                            currentRect.Width = areaSum / AvailableArea.Height;
                            currentRect.Height = AvailableArea.Height;
                            AvailableArea.X += currentRect.Width;
                            AvailableArea.Width = Math.max(0, AvailableArea.Width - currentRect.Width);
                        }
                        else {
                            currentRect.Width = AvailableArea.Width;
                            currentRect.Height = areaSum / AvailableArea.Width;
                            AvailableArea.Y += currentRect.Height;
                            AvailableArea.Height = Math.max(0, AvailableArea.Height - currentRect.Height);
                        }
                        curX = currentRect.X;
                        curY = currentRect.Y;
                    }
                    var rect = {};
                    if (OrderedItems.indexOf(item) != OrderedItems.length - 1) {
                        rect.X = 0;
                        rect.Y = 0;
                        rect.Width = (isHorizontal) ? currentRect.Width - parseFloat(Gap) : item.AreaByWeight / currentRect.Height;
                        rect.Height = (isHorizontal) ? item.AreaByWeight / currentRect.Width : currentRect.Height - parseFloat(Gap);
                        if (j - k != 1) {
                            if (isHorizontal) {
                                rect.Height -= parseFloat(Gap);
                            }
                            else {
                                rect.Width -= parseFloat(Gap);
                            }
                        }
                    }
                    else {
                        rect.Width = (isHorizontal) ? currentRect.Width : item.AreaByWeight / currentRect.Height;
                        rect.Height = (isHorizontal) ? item.AreaByWeight / currentRect.Width : currentRect.Height;
                    }
                    item.ItemWidth = rect.Width;
                    item.ItemHeight = rect.Height;
                    item.LeftPosition = curX;
                    item.TopPosition = curY;
                    if (isHorizontal) {
                        curY += (j - k != 1) ? rect.Height + parseFloat(Gap) : rect.Height;
                    }
                    else {
                        curX += (j - k != 1) ? rect.Width + parseFloat(Gap) : rect.Width;
                    }
                }
            }
        },
        
        _getGroupTotalWeight: function (firstTreemapItem, OrderedItems, AvailableArea, j) {
            var GroupTotalWeight = 0;
            var GroupMaxAspectRatio = 0;
            for (; j < OrderedItems.length; j++) {
                var ShorterSideLength = this._getShortersideLength(AvailableArea.Width, AvailableArea.Height);
                var lastTreemapItem = OrderedItems[j];
                GroupTotalWeight += lastTreemapItem.AreaByWeight;
                var GroupWidth = GroupTotalWeight / ShorterSideLength;
                var firstitemheight = firstTreemapItem.AreaByWeight / GroupWidth;
                var lastitemheight = lastTreemapItem.AreaByWeight / GroupWidth;
                if (j == 0)
                    GroupMaxAspectRatio = this._aspectRatio(GroupWidth, ShorterSideLength);
                var TempAspectRatio = Math.max(this._aspectRatio(firstitemheight, GroupWidth), this._aspectRatio(lastitemheight, GroupWidth));
                if (GroupTotalWeight == lastTreemapItem.AreaByWeight || TempAspectRatio < GroupMaxAspectRatio) {
                    GroupMaxAspectRatio = TempAspectRatio;
                }
                else {
                    GroupTotalWeight -= lastTreemapItem.AreaByWeight;
                    GroupWidth = GroupTotalWeight / ShorterSideLength;
                    GroupMaxAspectRatio = Math.max(this._aspectRatio(firstitemheight, GroupWidth), this._aspectRatio(lastitemheight, GroupWidth));
                    break;
                }
            }
            return { totalWeight: GroupTotalWeight, index: j };
        },
       
        _aspectRatio: function (x, y) {
            return (x > y) ? (x / y) : (y / x);
        },

        _getShortersideLength: function (width, height) {
            return width > height ? height : width;
        },

        _getTotalWeight: function (Items) {
            var total = 0;
            for (var i = 0; i < Items.length; i++) {
                total += parseFloat(Items[i].weight);
            }
            return total;

        },

        _getGroupitem: function (path, dataSource, headerHeight, labelPath) {
            var obj = [];            
			if(labelPath)
					dataSource = dataSource[0][labelPath];
			if(path == null)
				path = this.labelPath() || this.weightValuePath() ;
            if (dataSource != null && this.weightValuePath() != null) {                
                for (var i in dataSource) {
                    var item = dataSource[i];
                    if (item != null && item.hasOwnProperty(path) ? true : this._containsProperty(item,path)) {
                        var itemValue = this._reflection(item, path);
                        if ($.inArray(itemValue, obj) == -1) {
                            obj.push(itemValue);
                        }
                    }
                }                
                var objCollection = [];
                for (var i = 0; i < obj.length; i++) {
                    var Coll = {};
                    var groupObj = [];
                    var groupId = obj[i];
                    var colorWeight = 0;
                    var weight = 0;
                    var count = 0;
                    for (var j = 0; j < dataSource.length;j++) {
                        var item = dataSource[j];
                        var itemValue = this._reflection(item, path);
                        if (itemValue == groupId) {
                            var weightValue = this._reflection(item, this.weightValuePath());
                       
                            if (weightValue!=null && (typeof weightValue != "number")) {
                                weightValue = Number(weightValue.replace(/[^0-9\.]+/g, ""));
                            }
                            if (weightValue < 0) {
                                weightValue = -1 * weightValue;
                            }
                            var colorWeightValue = this._reflection(item, this.colorValuePath());
                            if (colorWeightValue!=null && (typeof colorWeightValue != "number")) {

                                colorWeightValue = Number(colorWeightValue.replace(/[^0-9\.]+/g, ""));
                            }
                            groupObj.push(item);
                            count++;
                            if (weightValue != null) {
                                weight += parseFloat(weightValue);
                            }
                            if (colorWeightValue != null) {
                                colorWeight += parseFloat(colorWeightValue);
                            }
                        }
                    }
                    
                    Coll["header"] = groupId;
                    Coll["data"] = groupObj;
                    Coll["weight"] = weight;
                    Coll["colorWeight"] = colorWeight;
                    Coll["headerHeight"] = headerHeight;
                    if (weight > 0) {
                        var newTreemapItem = new treeMapItem(Coll);
                        objCollection.push(newTreemapItem);
                    }
                }
                return objCollection;
            }
            else { return null; }
        },
      
        _getTopGroupitem: function (path, dataSource) {            
            if (path == null) path = this.labelPath();
            if (path == null) path = this.weightValuePath();
            var obj = [];
            var Coll = {};
            var weight = 0, colorWeight = 0;
            var groupId="";
            var innerobjCollection = [];
            var itemColl = [];
            for (var j = 0; j < dataSource.length; j++) {
                var item = dataSource[j];
                var itemValue = this._reflection(item, path);
                var innerColl={};
                var weightValue = this._reflection(item, this.weightValuePath());
                if (weightValue != null && (typeof weightValue != "number")) {
                    weightValue = Number(weightValue.replace(/[^0-9\.]+/g, ""));
                }
                if (weightValue < 0) {
                    weightValue = -1 * weightValue;
                }
                var colorWeightValue = this._reflection(item, this.colorValuePath());
                if (colorWeightValue!=null && (typeof colorWeightValue != "number")) {

                    colorWeightValue = Number(colorWeightValue.replace(/[^0-9\.]+/g, ""));
                }  
                if (weightValue != null) {
                    weight += parseFloat(weightValue);
                }
                if (colorWeightValue != null) {
                    colorWeight += parseFloat(colorWeightValue);
                }
                itemColl.push(item);
                innerColl["weight"] = weightValue;
                innerColl["data"] = item;                
                innerColl["header"] = itemValue;
                innerColl["colorWeight"] = colorWeightValue;                                       
                var newinnerTreemapItem = new treeMapItem(innerColl);
                innerobjCollection.push(newinnerTreemapItem);
            }        
            Coll["header"] = groupId;
            Coll["data"] = itemColl;
            Coll["weight"] = weight;
            Coll["innerItem"] = innerobjCollection;
            Coll["colorWeight"] = colorWeight;                                   
            var treemapColl = [];
            var treeitem = new treeMapItem(Coll);
            treemapColl.push(treeitem);
            return  treemapColl;
        },         
       
        _containsProperty: function (object, propertyName) {
            for (var key in object)
            {
                if(key == propertyName)
                {
                    return true;
                }
            }
            return false;
        },

        _reflection: function (Source, Path) {
            var ShapeValues = Source;
            if (Path != null && Source != null) {
                var parts = Path.split(".");
                parts.push(Path);
                var i = 0;
                for (; i < parts.length; i++) {
                    if (ShapeValues != null) {
                        var hasProperty = ShapeValues.hasOwnProperty(parts[i]) ? true : this._containsProperty(ShapeValues, parts[i]);
                        if (hasProperty) {
                            $.each(ShapeValues, function (prop, propval) {
                                if (prop == parts[i]) {
                                    ShapeValues = propval;
                                    return false;
                                }
                            });
                        }
                    }
                }
                return ShapeValues;
            }
            else {
                return null;
            }

        }

    });

    var treeMapLevel = function () {        
        this.groupBackground = null;       
        this.groupBorderColor = null;
        this.groupBorderThickness = 1;       
        this.groupPadding = 4;
        this.groupPath = null;
        this.groupGap = 1;       
        this.headerHeight = 20;
        this.showHeader = true;       
        this.showLabels = false;
        this.headerTemplate = null;       
        this.labelTemplate = null;
        this.labelPosition = "center";
        labelVisibilityMode = "visible";      
        headerVisibilityMode = "visible";

        this.treeMapItems = [];
    };

    treeMapLevel.prototype = {

    };
	
    var TreeMapGroupColorMapping = function () {	
        this.groupID = null;		       
        this.rangeColorMapping = [];

        this.desaturationColorMapping = { 				            
            from:0, 				            
            to:0,			
            color: "",								            
            rangeMinimum:0,		
            rangeMaximum:0
        };  
       
        this.uniColorMapping = {             
            color: null 
        };
     
        this.paletteColorMapping = {           
            colors: [],
        };
    };		
	
    var TreeMapRangeColorMapping = function () {
        
        this.from = -1;		
        this.to = -1;		    
        this.legendlabel = null;		      
        this.color = null;
    };
	
    var treeMapItem = function (params) {
        this.weight = params.weight;
        this.colorWeight = params.colorWeight;
        this.Data = params.data;
        this.headerHeight = params.headerHeight;
        this.header = params.header;
        this.label = params.header;
        this.headerLeftPosition = 0;
        this.headerTopPosition = 0;
        this.innerItems = params.innerItem;
        this.headerWidth = 0;
        this.headerTemplate = null;
    };

    treeMapItem.prototype = {

        _generateColorMappings: function (colorMappings,treeMap) {
            if (colorMappings.rangeColorMapping != null && colorMappings.rangeColorMapping.length > 0) {
                return this._getRangeBrushColor(colorMappings.rangeColorMapping);
            }
            if (treeMap.uniColor() != null && colorMappings.uniColorMapping!=null) {
                return treeMap.uniColor();
            }
            else if (colorMappings.uniColorMapping.color != null && colorMappings.uniColorMapping != null) {
                return this._getUniColor(colorMappings.uniColorMapping);
            }
            
        },

        _getUniColor: function (uniColorMapping) {
            return uniColorMapping.color;
        },
      
        _getRangeBrushColor: function (rangeColorMapping) {
            for (var j = 0; j < rangeColorMapping.length; j++) {
                var rangeBrush = rangeColorMapping[j];
                if (this.colorWeight >= rangeBrush.from && this.colorWeight <= rangeBrush.to) {
                    return rangeBrush.color;
                }
            }
        }
    };
	
	ej.datavisualization.TreeMap.selectionMode = {
		Default: "default",
		Multiple: "multiple"
	};
	
	ej.datavisualization.TreeMap.groupSelectionMode = {
		Default: "default",
		Multiple: "multiple"
	};
	
    ej.datavisualization.TreeMap.ItemsLayoutMode = {        
        Squarified: "squarified",        
        SliceAndDiceHorizontal: "sliceanddicehorizontal",        
        SliceAndDiceVertical: "sliceanddicevertical",        
        SliceAndDiceAuto: "sliceanddiceauto"
    };  

    ej.datavisualization.TreeMap.DockPosition = {        
        Top: "top",        
        Bottom: "bottom",        
        Right: "right",        
        Left: "left"
    };
	ej.datavisualization.TreeMap.LegendMode = {
      Default: "default",
      Interactive: "interactive"
    };
    ej.datavisualization.TreeMap.Position = {        
        TopLeft: "topleft",        
        TopCenter: "topcenter",        
        TopRight: "topright",        
        CenterLeft: "centerleft",        
        Center: "center",        
        CenterRight: "centerright",        
        BottomLeft: "bottomleft",        
        BottomCenter: "bottomcenter",        
        BottomRight:"bottomright"
    };
    ej.datavisualization.TreeMap.Alignment = {       
        Near: "near",        
        Center: "center",        
        Far: "far"
    }
    ej.datavisualization.TreeMap.VisibilityMode = {        
        Visible:"visible",        
        HideOnExceededLength:"hideonexceededlength"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Barcode elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
* Use of this code is subject to the terms of our license.
* A copy of the current license can be obtained at any time by e-mailing
* licensing@syncfusion.com. Any infringement will be prosecuted under
* applicable laws.
* @version 12.1
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    /** ejBarcode is the plugin name.*/
    /** "ej.datavisualization.Barcode" is "namespace.className" will hold functions and properties.*/
   
    ej.widget("ejBarcode", "ej.datavisualization.Barcode", {
        /** Widget element will be automatically set in this*/
        element: {
            target: null
        },

        /** User defined model will be automatically set in this*/
        model: null,
        validTags: ["div", "span"],
        _rootCSS: "e-barcode",

        defaults: {
            displayText: true,
            text: "",
            height: "",
            width: "",
            symbologyType: "qrbarcode",
            textColor: 'black',
            lightBarColor: 'white',
            darkBarColor: 'black',
            quietZone: {
                left: 1,
                top: 1,
                right: 1,
                bottom: 1,
                all: 1
            },
            narrowBarWidth: 1,
            wideBarWidth: 3,
            barHeight: 150,
            barcodeToTextGapHeight: 10,
            xDimension: 4,
            encodeStartStopSymbol: true,
            load: null,
            enabled: true,
        },

        /**
         * Specify the data types for default properties 
         * @private
         */
        dataTypes: {
            displayText: "boolean",
            text: "string",
            enabled: "boolean",
            symbologyType: "enum",
            narrowBarWidth: "number",
            wideBarWidth: "number",
            barHeight: "number",
            encodeStartStopSymbol: "boolean"
        },

        /**
         * @private
         */
        _defaultScaleValues: function () {
            return {
                enabled: true,
                displayText: true,
                text: "",
                symbologyType: "qrbarcode",
                textColor: 'black',
                lightBarColor: 'white',
                darkBarColor: 'black',
                quietZone: { left: 1, top: 1, right: 1, bottom: 1 },
                narrowBarWidth: 1,
                wideBarWidth: 3,
                barHeight: 150,
                barcodeToTextGapHeight: 10,
                xDimension: 4,
                encodeStartStopSymbol: true
            };
        },

        /**
         * @constructor
         * @private
         */
        _init: function () {
            this._initialize();
            this._renderBarcode();
        },

        /**
         * @private
         */
        _destroy: function () {
            this.element.empty();
        },

        /**
        * To configure the properties at runtime using SetModel		
        * @private
        */
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "enabled": this._disabled(!options[option]); break;
                    case "height": this.model.height = options[option]; break;
                    case "width": this.model.width = options[option]; break;
                    case "lightBarColor": this.model.lightBarColor = options[option]; break;
                    case "darkBarColor": this.model.darkBarColor = options[option]; break;
                    case "textColor": this.model.textColor = options[option]; break;
                    case "displayText": this.model.displayText = options[option]; break;
                    case "quietZone": this.model.quietZone = options[option]; break;
                    case "narrowBarWidth": this.model.narrowBarWidth = options[option]; break;
                    case "wideBarWidth": this.model.wideBarWidth = options[option]; break;
                    case "barHeight": this.model.barHeight = options[option]; break;
                    case "xDimension": this.model.xDimension = options[option]; break;
                    case "encodeStartStopSymbol": this.model.encodeStartStopSymbol = options[option]; break;
                    case "symbologyType":
                        this.model.symbologyType = options[option];
                        this._itemInitialize();
                        break;
                    case "text":
                        this.model.text = options[option];
                        this._itemInitialize();
                        break;
                }
            }
            this._renderBarcode();
        },

        /**
         * Initializes control.
         * @private
         */
        _initialize: function () {
            this.BarcodeEl = this.element;
            this.target = this.element[0];
            this._itemInitialize();
            this.Model = this.model;
        },

        /**
         * Renders barcode.
         * @private
         */
        _renderBarcode: function () {
            this.initialize();
        },

        /**
         * @private
         */
        _itemInitialize: function () {
            var proxy = this;
            if (this.model.scales != null) {
                $.each(this.model.scales, function (index, element) {
                    element = proxy._checkArrayObject(element, index);
                    var obj = proxy._defaultScaleValues();
                    $.extend(obj, element);
                    $.extend(element, obj);
                });
            }
            else {
                this.model.scales = [this._defaultScaleValues()];
            }
        },

        /**
         * @private
         */
        _checkArrayObject: function (element, initialName) {
            var proxy = this;
            $.each(element, function (name, innerElement) {
                if (innerElement instanceof Array) {
                    innerElement = proxy._checkArrayObject(innerElement, name);
                }
                else if (innerElement != null && typeof innerElement == "object") {
                    var allObjects = proxy._defaultScaleValues();
                    innerElement = proxy._LoadIndividualDefaultValues(innerElement, allObjects, (typeof name === "number") ? initialName : name);
                }
            });
            return element;
        },

        /**
         * @private
         */
        _LoadIndividualDefaultValues: function (obj, allObjects, name) {
            var defaultObj = null;
            var proxy = this;
            $.each(allObjects, function (n, element) {
                if (name == n) {
                    defaultObj = element;
                    return;
                }
            });
            if (defaultObj instanceof Array) defaultObj = defaultObj[0];

            $.each(obj, function (objName, Ele) {
                if (Ele instanceof Array) {
                    Ele = proxy._checkArrayObject(Ele, name);
                }
                else if (Ele != null && typeof Ele == "object") {
                    Ele = proxy._LoadIndividualDefaultValues(Ele, defaultObj, (typeof objName === "number") ? name : objName);
                }
            });

            $.extend(defaultObj, obj);
            $.extend(obj, defaultObj);
            return obj;
        },

        /**
         * Initializes the control.
         * @private
         */
        initialize: function () {
            if (!this.model.enabled)
                return;

            this._initObject(this);

            if (this.Model.text != null)
                this._findBarcodeType();
        },

        /**
        * To enable the barcode 
        */
        enable: function () {
            if (!this.model.enabled) {
                this.element.removeClass("e-disable");
                this.model.enabled = true;
            }
        },
        
        /**
        * To change the height of Barcode
        */
        height: function (value) {
            this.Model.height = value;
        },
        
        /**
        * To change the width of Barcode
        */
        width: function (value) {
            this.Model.width = value;
        },
        
        /**
        * To resize the barcode 
        */
        resize: function () {
            if (this.Model.text != null)
                this._findBarcodeType();
        },

        /**
        * To disable the barcode  
        */
        disable: function () {
            if (this.model.enabled) {
                this.element.addClass("e-disable");
                this.model.enabled = false;
            }
        },

        /**
         * @private
         */
        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        /**
         * Initializes rendering canvas.
         * @private
         */
        _initObject: function (element) {
            element.BarcodeEl = $("#" + element.target.id);
            if (element.canvasEl)
                element.canvasEl.remove();
            else
                element.canvasEl = $("<canvas></canvas>");
            element.BarcodeEl.append(element.canvasEl);
            element.BarcodeEl.css("width", element.model.width);
            element.BarcodeEl.css("height", element.model.height);
            element.canvasEl[0].setAttribute("width", element.BarcodeEl.width());
            element.canvasEl[0].setAttribute("height", element.BarcodeEl.height());
            element.centerX = element.canvasEl[0].width / 2;
            element.centerY = element.canvasEl[0].height / 2;
            var elem = element.canvasEl[0];
            if (typeof window.G_vmlCanvasManager != "undefined") {
                elem = window.G_vmlCanvasManager.initElement(elem);
            }
            if (!elem || !elem.getContext) {
                return;
            }
            element.contextEl = element.canvasEl[0].getContext("2d");

            if (element.contextEl == undefined) //IE 8
                return;
        },

        /**
         * Finds the barcode type and encodes text.
         * @private
         */
        _findBarcodeType: function () {
            if (this.contextEl == undefined) //IE 8
                return;

            if (this.Model.text == "")
                return;

            this.textFont = { size: "12px", fontFamily: "Segoe UI", fontStyle: "Regular" };

            if (this.model.quietZone.all > 1)
                this.model.quietZone.left = this.model.quietZone.right = this.model.quietZone.top = this.model.quietZone.bottom = this.model.quietZone.all;

            var intercharacterGap = 1;
            var extendedText = "";
            var continuous = false;
            var validatorExp = "";
            var encodedText = this.Model.text;
            var startSymbol, stopSymbol, symbolTable, extendedCodes;

            var type = this.Model.symbologyType;
            var oneD = true;

            /** Apply symbology setting.*/
            if (ej.datavisualization.Barcode.SymbologyType.dataMatrix == type || ej.datavisualization.Barcode.SymbologyType.qrBarcode == type) {
                oneD = false;
            }
            else {
                startSymbol = ej.datavisualization.Barcode.symbologySettings[type].startSymbol;
                stopSymbol = ej.datavisualization.Barcode.symbologySettings[type].stopSymbol;
                validatorExp = ej.datavisualization.Barcode.symbologySettings[type].validatorExp;
                symbolTable = ej.datavisualization.Barcode.symbologySettings[type].symbolTable;
                extendedCodes = ej.datavisualization.Barcode.symbologySettings[type].extendedCodes;

                encodedText = this._calculateCheckDigit(encodedText, symbolTable, type);

                if (ej.datavisualization.Barcode.SymbologyType.code39Extended == type) {
                    var cArray = encodedText.split("");
                    var builder = "";
                    for (var j = 0; j < cArray.length; j++) {
                        var item = cArray[j];
                        for (var k = 0; k < extendedCodes.length; k++) {
                            if (extendedCodes[k][0] == item) {
                                var chArray = extendedCodes[k][1];
                                if (!(chArray == undefined)) {
                                    for (var i = 0; i < chArray.length; i++) {
                                        builder += chArray[i];
                                    }
                                }
                            }
                        }
                    }
                    extendedText = builder;
                }
                else if (ej.datavisualization.Barcode.SymbologyType.code93Extended == type) {
                    var cArray = encodedText.split("");
                    var builder = "";
                    for (var j = 0; j < cArray.length; j++) {
                        var item = cArray[j];
                        for (var k = 0; k < extendedCodes.length; k++) {
                            if (extendedCodes[k][0] == item) {
                                var chArray = extendedCodes[k][1];
                                if (!(chArray == undefined)) {
                                    for (var i = 0; i < chArray.length; i++) {
                                        builder += chArray[i];
                                    }
                                }
                            }
                        }
                    }
                    extendedText = builder;
                }
            }

            /** Process one dimensional barcode.*/
            if (oneD) {
                if (!this._validateText(this.Model.text, validatorExp)) {
                    console.log("Barcode Text contains characters that are not accepted by this barcode specification.");
                    return;
                }

                if (this.model.symbologyType == "code32" && this.model.text.length != 8) {
                    console.log("Barcode Text Length that are not accepted by this barcode specification.");
                    return;
                }

                if (extendedText.length > 0)
                    encodedText = extendedText;

                if (this.Model.encodeStartStopSymbol)
                    encodedText = startSymbol.toString() + encodedText + stopSymbol.toString();

                var w = this._getCharWidth(encodedText, symbolTable);

                if (continuous == false)
                    w -= (intercharacterGap * encodedText.length);
                else {
                    w -= (extendedText.length > 0) ?
                        intercharacterGap * (extendedText.length - this.Model.text.length) :
                        intercharacterGap;
                }

                var textHeight = parseInt(this.Model.displayText ? this.textFont.size.replace('px', '') : 0);
                var h = this.Model.quietZone.top + this.Model.quietZone.bottom + this.Model.barHeight + intercharacterGap + (this.Model.displayText ? (textHeight + this.Model.barcodeToTextGapHeight) : 0);
                w += this.Model.quietZone.left + this.Model.quietZone.right;

                

                /** Draw one dimensional barcode.*/
                this._draw1DBarcode(encodedText, symbolTable, w);
            }
                /** Process two dimensional barcode.*/
            else {
                if (ej.datavisualization.Barcode.SymbologyType.dataMatrix == type)
                    this._buildDataMatrix();
                else if (ej.datavisualization.Barcode.SymbologyType.qrBarcode == type)
                    this._buildQRBarcode();
            }

            /** Raise load event*/
            this._raiseEvent("load");
        },

        /**
         * Calculate the checkdigit value.
         * @private
         */
        _calculateCheckDigit: function (encodedText, symbolTable, type) {
            if (type == "code128b") {
                var checkValue = 0;
                var char = [encodedText.split("")];
                for (var m = 0; m < encodedText.split("").length; m++) {
                    var item = char[0][m];
                    var checkdigit = this._findCheckDigit(item, symbolTable)[1];
                    checkValue += (checkdigit * (m + 1));

                }
                //The start character value for the code128B is 104.
                checkValue += 104;
                //To claculate the checksum value.
                checkValue = checkValue % 0x67;
                var ch = [1];
                for (var e = 0; e < symbolTable.length; e++) {
                    if (e == checkValue) {
                        ch[0] = symbolTable[e][0];
                    }
                }
                encodedText += ch.toString();
            }
            else {
                if(type=="upcbarcode")
                {
                    var char = [encodedText.split("")];
                    var iSum = 0;
                    var iDigit = 0;
                    for (var m = 0; m < encodedText.split("").length; m++) {
                        if (m < 11) {
                            iDigit = encodedText[m];
                            if (m % 2 == 0) {    // odd
                                iSum += iDigit * 3;
                            }
                            else {    // even
                                iSum += iDigit * 1;
                            }
                        }

                    }
                    var iCheckSum = (10 - (iSum % 10)) % 10;
                    var data = encodedText.split("");
                    // Add the leading digit pattern for the text.
                    var str =6;
                    for (var k = 0; k < data.length; k++)
                    {
                        if (k == 6)
                        {
                            // Add the separator digit to middle of the text.
                            str += "B" + data[k];

                        }
                        else
                        {
                            if (k != 11 )
                                str += data[k];
                        }

                    }
                    encodedText = str;

                    //Add the checkdigit value. 
                    encodedText += iCheckSum;

                    //Add the ending digit pattern for the text.
                    encodedText += 6;
                   
                }
            }
            return encodedText;

        },

        /**
       * Finds the checkdigit value from symboltable.
       * @private
       */
        _findCheckDigit: function (encodedText, symbolTable) {
            for (var i = 0; i < symbolTable.length; i++) {
                if (symbolTable[i][0] == encodedText) {
                    return symbolTable[i];
                }
            }
        },

        /**
         * Load event.
         * @private
         * @event
         */
        _raiseEvent: function (event) {
            if (this.model[event])
                this._trigger(event);
        },

        /**
         * Generates QR barcode.
         * @private
         */
        _buildQRBarcode: function () {
            var txt = this.Model.text;
            this.m_EciAssignmentNumber = 3;
            this.mode = "numeric";
            this.isEci = false;
            this.m_Version = 1;
            var dataCapacityOfVersions = new Array(14, 26, 42, 62, 84, 106, 122, 152, 180, 213, 251, 287, 331, 362, 412, 450, 504, 560, 624, 666, 711, 779, 857, 911, 997, 1059, 1125, 1190, 1264, 1370, 1452, 1538, 1628, 1722, 1809, 1911, 1989, 2099, 2213, 2331);
            for (var i = 0; i < txt.length; i++) {
                var cCode = txt.charCodeAt(i);
                if (cCode < 58 && cCode > 47) {
                    /** numeric only*/
                }
                else if ((cCode < 91 && cCode > 64) || txt[i] == '$' || txt[i] == '%' || txt[i] == '*' || txt[i] == '+' || txt[i] == '-' || txt[i] == '.' || txt[i] == '/' || txt[i] == ':' || txt[i] == ' ') {
                    this.mode = "alphanumeric";
                }
                else if ((cCode >= 65377 && cCode <= 65439) || (cCode >= 97 && cCode <= 122)) {
                    this.mode = "binary";
                    break;
                }
                else {
                    this.mode = "binary";
                    this.isEci = true;
                    break;
                }
            }
            if (this.mode == "numeric")
                dataCapacityOfVersions = new Array(34, 63, 101, 149, 202, 255, 293, 365, 432, 513, 604, 691, 796, 871, 991, 1082, 1212, 1346, 1500, 1600, 1708, 1872, 2059, 2188, 2395, 2544, 2701, 2857, 3035, 3289, 3486, 3693, 3909, 4134, 4343, 4588, 4775, 5039, 5313, 5596);
            else if (this.mode == "alphanumeric")
                dataCapacityOfVersions = new Array(20, 38, 61, 90, 122, 154, 178, 221, 262, 311, 366, 419, 483, 528, 600, 656, 734, 816, 909, 970, 1035, 1134, 1248, 1326, 1451, 1542, 1637, 1732, 1839, 1994, 2113, 2238, 2369, 2506, 2632, 2780, 2894, 3054, 3220, 3391);

            if (this.isEci == true) {
                this.m_EciAssignmentNumber = this._findECINumber(txt);
            }
            for (var i = 0; i < dataCapacityOfVersions.length; i++) {
                if (dataCapacityOfVersions[i] > txt.length) {
                    this.m_Version = i + 1;
                    break;
                }
            }

            this.qrbarcodeValues = { Version: this.m_Version, ErrorCorrectionLevel: 1, NumberOfDataCodeWord: this._getNumberOfDataCodeWord(), NumberOfErrorCorrectingCodeWords: this._getNumberOfErrorCorrectingCodeWords(), NumberOfErrorCorrectionBlocks: this._getNumberOfErrorCorrectionBlocks(), End: this._getEnd(), DataCapacity: this._getDataCapacity(), FormatInformation: this._getFormatInformation(), VersionInformation: this._getVersionInformation() };
            this.noOfModules = (this.m_Version - 1) * 4 + 21;

            this.moduleValue = this._create2DArray(this.noOfModules, this.noOfModules);

            for (var i = 0; i < this.noOfModules; i++) {
                for (var j = 0; j < this.noOfModules; j++) {
                    this.moduleValue[i][j] = { IsBlack: false, IsFilled: false, IsPDP: false };
                }
            }

            this._drawPDP(0, 0);
            this._drawPDP(this.noOfModules - 7, 0);
            this._drawPDP(0, this.noOfModules - 7);
            this._drawTimingPattern();

            if (this.m_Version != 1) {
                var allignCoOrdinates = this._getAlignmentPatternCoOrdinates();

                for (var i = 0; i < allignCoOrdinates.length; i++) {
                    for (var j = 0; j < allignCoOrdinates.length; j++) {
                        var x = allignCoOrdinates[i];
                        var y = allignCoOrdinates[j];
                        if (this.moduleValue[x][y].IsPDP != true)
                            this._drawAlignmentPattern(x, y);
                    }
                }
            }

            this._allocateFormatVersionInfo();
            this._encodeData();
            this._drawFormatInformation();
            this._addQuietZone();

            var w = this.moduleValue.length * this.Model.xDimension;
            var h = this.moduleValue[0].length * this.Model.xDimension;

            

            this.contextEl.beginPath();
            this.contextEl.fillStyle = 'white';
            this.contextEl.fillRect(0, 0, w, h);
            this.contextEl.closePath();

            /** Draw QR barcode in canvas.*/
            this._drawQRBarcode(h, w);
        },

        /** 
         * Allocate format and version information.
         * @private
         */
        _allocateFormatVersionInfo: function () {
            for (var i = 0; i < 9; i++) {
                this.moduleValue[8][i].IsFilled = true;
                this.moduleValue[i][8].IsFilled = true;
            }
            for (var i = this.noOfModules - 8; i < this.noOfModules; i++) {
                this.moduleValue[8][i].IsFilled = true;
                this.moduleValue[i][8].IsFilled = true;
            }
            if (this.m_Version > 6) {
                var versionInformation = this.qrbarcodeValues.VersionInformation;
                var count = 0;
                for (var i = 0; i < 6; i++) {
                    for (var j = 2; j >= 0; j--) {
                        this.moduleValue[i][this.noOfModules - 9 - j].IsBlack = versionInformation[count] == 1 ? true : false;
                        this.moduleValue[i][this.noOfModules - 9 - j].IsFilled = true;

                        this.moduleValue[this.noOfModules - 9 - j][i].IsBlack = versionInformation[count++] == 1 ? true : false;
                        this.moduleValue[this.noOfModules - 9 - j][i].IsFilled = true;
                    }
                }
            }
        },

        /**
         * @private
         */
        _drawTimingPattern: function () {
            for (var i = 8; i < this.noOfModules - 8; i += 2) {
                this.moduleValue[i][6].IsBlack = true;
                this.moduleValue[i][6].IsFilled = true;

                this.moduleValue[i + 1][6].IsBlack = false;
                this.moduleValue[i + 1][6].IsFilled = true;

                this.moduleValue[6][i].IsBlack = true;
                this.moduleValue[6][i].IsFilled = true;

                this.moduleValue[6][i + 1].IsBlack = false;
                this.moduleValue[6][i + 1].IsFilled = true;
            }
            this.moduleValue[this.noOfModules - 8][8].IsBlack = true;
            this.moduleValue[this.noOfModules - 8][8].IsFilled = true;
        },

        /** 
         * Draws QR barcode.
         * @private
         */
        _drawQRBarcode: function (ht, w) {
            var quietZone = this.Model.quietZone.all;
            if (quietZone < 2)
                quietZone = 2;

            var whiteBrush = 'white';
            var blackBrush = 'black';
            
            var dim = parseInt(this.Model.xDimension);
            if(this.Model.height != "" && this.Model.width != "")
			{
            this.Model.height = this._getProperValue(this.Model.height);
            this.Model.width = this._getProperValue(this.Model.width);
            }
			else
			{ 
			this.Model.height = ht;
			this.Model.width = w;
			this.canvasEl[0].setAttribute("width", this.Model.width);
            this.BarcodeEl.css("width", this.Model.width);
			this.canvasEl[0].setAttribute("height", this.Model.height);
            this.BarcodeEl.css("height", this.Model.height);
			}			
            var dimension = Math.min(this.Model.width, this.Model.height);
            
            if(dimension != 0)
                dim = dimension / (this.noOfModules + (2 * quietZone));

            var y = 0;

            var w = this.noOfModules + 2 * quietZone, h = this.noOfModules + 2 * quietZone;

            this.contextEl.beginPath();

            for (var i = 0; i < w; i++) {
                var x = 0;

                for (var j = 0; j < h; j++) {
                    var colorBrush = null;
                    if (this.moduleValue[i][j].IsBlack)
                       colorBrush = this.model.darkBarColor;
						
					else
				
                      colorBrush = this.model.lightBarColor;

                    if (this.dataAllocationValues[j][i].IsFilled)
                        if (this.dataAllocationValues[j][i].IsBlack)
                            colorBrush = 'black';

                    this.contextEl.fillStyle = colorBrush;
                    this.contextEl.fillRect(x, y, dim, dim)

                    x += dim;
                }

                y += dim;
            }

            this.contextEl.closePath();
            this.contextEl.stroke();
        },


         _getProperValue: function (value) {
             if(value == "")
                return "";
             if(typeof(value) == "string")
             {
                value = value.replace("px","");
                return parseInt(value);
             }
             else if(typeof(value) == "number")
                return value;
             return 0;
         },
         
        /** 
         * Adds quiet zone to the barcode.
         * @private
         */
        _addQuietZone: function () {
            var quietZone = this.Model.quietZone.all;
            if (quietZone < 2)
                quietZone = 2;
            var w = this.noOfModules + 2 * quietZone;
            var h = this.noOfModules + 2 * quietZone;
            var tempValue1 = this._create2DArray(w, h);
            var tempValue2 = this._create2DArray(w, h);

            /** Initialize array.*/
            for (var i = 0; i < w; i++) {
                for (var j = 0; j < h; j++) {
                    tempValue1[i][j] = { IsBlack: false, IsFilled: false, IsPDP: false };
                    tempValue2[i][j] = { IsBlack: false, IsFilled: false, IsPDP: false };
                }
            }

            for (var i = quietZone; i < w - quietZone; i++) {
                for (var j = quietZone; j < h - quietZone; j++) {
                    tempValue1[i][j] = this.moduleValue[i - quietZone][j - quietZone];
                    tempValue2[i][j] = this.dataAllocationValues[i - quietZone][j - quietZone];
                }
            }

            this.moduleValue = tempValue1;
            this.dataAllocationValues = tempValue2;
        },

        /** 
         * Adds format information to the barcode.
         * @private
         */
        _drawFormatInformation: function () {
            var formatInformation = this.qrbarcodeValues.FormatInformation;

            var count = 0;
            for (var i = 0; i < 7; i++) {
                /** Draw from 14 to 8.*/
                if (i == 6)
                    this.moduleValue[i + 1][8].IsBlack = formatInformation[count] == 1 ? true : false;
                else
                    this.moduleValue[i][8].IsBlack = formatInformation[count] == 1 ? true : false;

                this.moduleValue[8][this.noOfModules - i - 1].IsBlack = formatInformation[count++] == 1 ? true : false;
            }
            count = 14;
            for (var i = 0; i < 7; i++) {
                /** Draw from 0 to 6.*/
                if (i == 6)
                    this.moduleValue[8][i + 1].IsBlack = formatInformation[count] == 1 ? true : false;
                else
                    this.moduleValue[8][i].IsBlack = formatInformation[count] == 1 ? true : false;
                this.moduleValue[this.noOfModules - i - 1][8].IsBlack = formatInformation[count--] == 1 ? true : false;
            }

            /** Draw 7.*/
            this.moduleValue[8][8].IsBlack = formatInformation[7] == 1 ? true : false;
            this.moduleValue[8][this.noOfModules - 8].IsBlack = formatInformation[7] == 1 ? true : false;
        },

        /** 
         * @private
         */
        _dataAllocationAndMasking: function (Data) {
            var num = this.noOfModules;
            this.dataAllocationValues = this._create2DArray(num, num);
            var point = 0;

            for (var i = 0; i < num; i++) 
                for (var j = 0; j < num; j++) 
                    this.dataAllocationValues[i][j] = { IsBlack: false, IsFilled: false, IsPDP: false };

            for (var i = num - 1; i >= 0; i -= 2) {
                for (var j = num - 1; j >= 0; j--)
                    point = this._allocateValues(Data, i, j, point);

                i -= 2;
                if (i == 6)
                    i--;

                for (var j = 0; j < num; j++)
                    point = this._allocateValues(Data, i, j, point);
            }
            for (var i = 0; i < num; i++)
                for (var j = 0; j < num; j++)
                    if (!this.moduleValue[i][j].IsFilled) {
                        var flag = this.dataAllocationValues[i][j].IsBlack;
                        if (flag)
                            this.dataAllocationValues[i][j].IsBlack = false;
                        else
                            this.dataAllocationValues[i][j].IsBlack = true;
                    }


        },

        /** 
         * @private
         */
        _allocateValues: function (Data, i, j, point) {
            if (!(this.moduleValue[i][j].IsFilled && this.moduleValue[i - 1][j].IsFilled)) {
                if (!this.moduleValue[i][j].IsFilled) {
                    if (point + 1 < Data.length)
                        this.dataAllocationValues[i][j].IsBlack = Data[point++];
                    if ((i + j) % 3 == 0) {
                        if (this.dataAllocationValues[i][j].IsBlack)
                            this.dataAllocationValues[i][j].IsBlack = true;
                        else
                            this.dataAllocationValues[i][j].IsBlack = false;
                    }
                    else {
                        if (this.dataAllocationValues[i][j].IsBlack)
                            this.dataAllocationValues[i][j].IsBlack = false;
                        else
                            this.dataAllocationValues[i][j].IsBlack = true;
                    }

                    this.dataAllocationValues[i][j].IsFilled = true;
                }

                if (!this.moduleValue[i - 1][j].IsFilled) {
                    if (point + 1 < Data.length)
                        this.dataAllocationValues[i - 1][j].IsBlack = Data[point++];
                    if ((i - 1 + j) % 3 == 0) {
                        if (this.dataAllocationValues[i - 1][j].IsBlack)
                            this.dataAllocationValues[i - 1][j].IsBlack = true;
                        else
                            this.dataAllocationValues[i - 1][j].IsBlack = false;
                    }
                    else {
                        if (this.dataAllocationValues[i - 1][j].IsBlack)
                            this.dataAllocationValues[i - 1][j].IsBlack = false;
                        else
                            this.dataAllocationValues[i - 1][j].IsBlack = true;
                    }
                    this.dataAllocationValues[i - 1][j].IsFilled = true;
                }
            }

            return point;
        },

        /** 
         * Encodes data.
         * @private
         */
        _encodeData: function () {
            var eData = new Array();
            var c = -1;

            switch (this.mode) {
                case "numeric":
                    eData[++c] = false;
                    eData[++c] = false;
                    eData[++c] = false;
                    eData[++c] = true;
                    break;

                case "alphanumeric":
                    eData[++c] = false;
                    eData[++c] = false;
                    eData[++c] = true;
                    eData[++c] = false;
                    break;

                case "binary":
                    if (this.isEci) {
                        /** Add ECI Mode Indicator.*/
                        eData[++c] = false;
                        eData[++c] = true;
                        eData[++c] = true;
                        eData[++c] = true;

                        /** Add ECI assignment number.*/
                        var numberInBool = this._stringToBoolArray(this.m_EciAssignmentNumber.toString(), 8);
                        for (var e = 0; e < numberInBool.length; e++)
                            eData[++c] = numberInBool[e];
                    }
                    eData[++c] = false;
                    eData[++c] = true;
                    eData[++c] = false;
                    eData[++c] = false;
                    break;
            }

            var numberOfBitsInCharacterCountIndicator = 0;
            if (this.m_Version < 10) {
                switch (this.mode) {
                    case "numeric":
                        numberOfBitsInCharacterCountIndicator = 10;
                        break;
                    case "alphanumeric":
                        numberOfBitsInCharacterCountIndicator = 9;
                        break;
                    case "binary":
                        numberOfBitsInCharacterCountIndicator = 8;
                        break;
                }
            }
            else if (this.m_Version < 27) {
                switch (this.mode) {
                    case "numeric":
                        numberOfBitsInCharacterCountIndicator = 12;
                        break;
                    case "alphanumeric":
                        numberOfBitsInCharacterCountIndicator = 11;
                        break;
                    case "binary":
                        numberOfBitsInCharacterCountIndicator = 16;
                        break;
                }
            }
            else {
                switch (this.mode) {
                    case "numeric":
                        numberOfBitsInCharacterCountIndicator = 14;
                        break;
                    case "alphanumeric":
                        numberOfBitsInCharacterCountIndicator = 13;
                        break;
                    case "binary":
                        numberOfBitsInCharacterCountIndicator = 16;
                        break;
                }
            }

            var dataStringArray = this.Model.text;
            var numberOfBitsInCharacterCountIndicatorInBool = this._intToBoolArray(dataStringArray.length, numberOfBitsInCharacterCountIndicator);

            for (var i = 0; i < numberOfBitsInCharacterCountIndicator; i++)
                eData[++c] = numberOfBitsInCharacterCountIndicatorInBool[i];

            if (this.mode == "numeric") {
                var number = "";
                for (var i = 0; i < dataStringArray.length; i++) {
                    var numberInBool = new Array();
                    number += dataStringArray[i];

                    if (i % 3 == 2 && i != 0 || i == dataStringArray.length - 1) {
                        if (number.length == 3)
                            numberInBool = this._stringToBoolArray(number, 10);
                        else if (number.length == 2)
                            numberInBool = this._stringToBoolArray(number, 7);
                        else
                            numberInBool = this._stringToBoolArray(number, 4);
                        number = "";
                        for (var j = 0; j < numberInBool.length; j++)
                            eData[++c] = numberInBool[j];
                    }
                }
            }
            else if (this.mode == "alphanumeric") {
                var numberInString = "";
                var number = 0;
                for (var i = 0; i < dataStringArray.length; i++) {
                    var numberInBool = new Array();
                    numberInString += dataStringArray[i];

                    if (i % 2 == 0 && i + 1 != dataStringArray.length)
                        number = 45 * this._getAlphanumericvalues(dataStringArray[i]);

                    if (i % 2 == 1 && i != 0) {
                        number += this._getAlphanumericvalues(dataStringArray[i]);
                        numberInBool = this._intToBoolArray(number, 11);
                        number = 0;
                        for (var n = 0; n < numberInBool.length; n++)
                            eData[++c] = numberInBool[n];
                        numberInString = "";
                    }
                    if (i != 1 && numberInString != null)
                        if (i + 1 == dataStringArray.length && numberInString.length == 1) {
                            number = this._getAlphanumericvalues(dataStringArray[i]);
                            numberInBool = this._intToBoolArray(number, 6);
                            number = 0;
                            for (var j = 0; j < numberInBool.length; j++)
                                eData[++c] = numberInBool[j];
                        }
                }
            }
            else if (this.mode = "binary") {
                {
                    for (var i = 0; i < dataStringArray.length; i++) {
                        var number = 0;
                        if ((dataStringArray.charCodeAt(i) >= 32 && dataStringArray.charCodeAt(i) <= 126) || (dataStringArray.charCodeAt(i) >= 161 && dataStringArray.charCodeAt(i) <= 255))
                            number = dataStringArray.charCodeAt(i);
                        else if (dataStringArray.charCodeAt(i) >= 65377 && dataStringArray.charCodeAt(i) <= 65439)
                            number = dataStringArray.charCodeAt(i) - 65216;
                        else {
                            console.log("Input text contains non-convertable characters");
                            return;
                        }
                        var numberInBool = this._intToBoolArray(number, 8);
                        for (var j = 0; j < numberInBool.length; j++)
                            eData[++c] = numberInBool[j];
                    }
                }
            }

            /** Terminator.*/
            for (var i = 0; i < 4; i++)
                if (eData.length / 8 == this.qrbarcodeValues.NumberOfDataCodeWord)
                    break;
                else
                    eData[++c] = false;

            /** Encode to code words.*/
            for (; ;)              /** Add Padding Bits.*/
            {
                if (eData.length % 8 == 0)
                    break;
                else
                    eData[++c] = false;
            }

            for (; ;) {
                if (eData.length / 8 == this.qrbarcodeValues.NumberOfDataCodeWord)
                    break;
                else {
                    eData[++c] = false;       //11101100
                    eData[++c] = true;
                    eData[++c] = true;
                    eData[++c] = false;
                    eData[++c] = true;
                    eData[++c] = true;
                    eData[++c] = false;
                    eData[++c] = false;
                }
                if (eData.length / 8 == this.qrbarcodeValues.NumberOfDataCodeWord)
                    break;
                else {
                    eData[++c] = false;       //00010001
                    eData[++c] = false;
                    eData[++c] = false;
                    eData[++c] = true;
                    eData[++c] = false;
                    eData[++c] = false;
                    eData[++c] = false;
                    eData[++c] = true;
                }
            }

            var dataBits = this.qrbarcodeValues.NumberOfDataCodeWord;
            var blocks = this.qrbarcodeValues.NumberOfErrorCorrectionBlocks;

            var totalBlockSize = blocks[0];
            if (blocks.length == 6)
                totalBlockSize = blocks[0] + blocks[3];

            var ds1 = new Array(totalBlockSize);

            var testEncodeData = eData;
            var n = -1;
            if (blocks.length == 6)     /** If seperated into two seperate blocks.*/
            {
                var dataCodeWordLength = blocks[0] * blocks[2] * 8;
                testEncodeData = new Array(dataCodeWordLength);
                for (var i = 0; i < dataCodeWordLength; i++)
                    testEncodeData[++n] = eData[i];
            }
            var dsOne = this._create2DArray(blocks[0], testEncodeData.length / 8 / blocks[0]);
            dsOne = this._createBlocks(testEncodeData, blocks[0]);

            for (var i = 0; i < blocks[0]; i++) {
                ds1[i] = this._splitCodeWord(dsOne, i, testEncodeData.length / 8 / blocks[0]);
            }

            n = -1;
            if (blocks.length == 6) {
                testEncodeData = new Array();
                for (var i = parseInt(blocks[0] * blocks[2] * 8) ; i < eData.length; i++)
                    testEncodeData[++n] = eData[i];

                var dsTwo = this._create2DArray(blocks[0], testEncodeData.length / 8 / blocks[3]);
                dsTwo = this._createBlocks(testEncodeData, blocks[3]);

                for (var i = blocks[0], count = 0; i < totalBlockSize; i++)
                    ds1[i] = this._splitCodeWord(dsTwo, count++, testEncodeData.length / 8 / blocks[3]);
            }
            eData = new Array();
            c = -1;
            for (var i = 0; i < 125; i++) {
                for (var k = 0; k < totalBlockSize; k++)
                    for (var j = 0; j < 8; j++)
                        if (i < ds1[k].length) {
                            var temp = ds1[k][i][j];
                            eData[++c] = (temp == '1' ? true : false);
                        }
            }

            this.corCodeWords = { DataBits: this.qrbarcodeValues.NumberOfDataCodeWord, ECCW: this.qrbarcodeValues.NumberOfErrorCorrectingCodeWords, DC: 0 };

            var dataBits = this.corCodeWords.DataBits;
            var eccw = this.corCodeWords.ECCW;
            blocks = this.qrbarcodeValues.NumberOfErrorCorrectionBlocks;

            if (blocks.length == 6)
                this.corCodeWords.DataBits = (dataBits - blocks[3] * blocks[5]) / blocks[0];
            else
                this.corCodeWords.DataBits = dataBits / blocks[0];

            this.corCodeWords.ECCW = eccw / totalBlockSize;
            var polynomial = new Array(totalBlockSize);
            var count = 0;

            for (var i = 0; i < blocks[0]; i++) {
                this.corCodeWords.DC = ds1[count];
                polynomial[count++] = this._getERCW();
            }
            if (blocks.length == 6) {
                this.corCodeWords.DataBits = (dataBits - blocks[0] * blocks[2]) / blocks[3];

                for (var i = 0; i < blocks[3]; i++) {
                    this.corCodeWords.DC = ds1[count];
                    polynomial[count++] = this._getERCW();
                }
            }
            var polyLength = polynomial[0].slice(-1)[polynomial.length - 1];
            if (typeof polyLength == 'undefined')
                polynomial[0].length = polynomial[0].length - 1;
            if (blocks.length != 6) {
                for (var i = 0; i < polynomial[0].length; i++) {
                    for (var k = 0; k < blocks[0]; k++)
                        for (var j = 0; j < 8; j++)
                            if (i < polynomial[k].length)
                                eData[++c] = (polynomial[k][i][j] == '1' ? true : false);
                }
            }
            else {
                for (var i = 0; i < polynomial[0].length; i++) {
                    for (var k = 0; k < totalBlockSize; k++)
                        for (var j = 0; j < 8; j++)
                            if (i < polynomial[k].length)
                                eData[++c] = (polynomial[k][i][j] == '1' ? true : false);
                }
            }


            this._dataAllocationAndMasking(eData);
        },

        /** 
         * @private
         */
        _getERCW: function () {
            var decimalRepresentation;
            var ecw;
            var decimalValue = new Array(this.corCodeWords.DataBits);
            var gx = new Array();

            switch (this.corCodeWords.ECCW) {
                case 7:
                    gx = new Array(0, 87, 229, 146, 149, 238, 102, 21);
                    gx = this._getElement(gx);
                    break;
                case 10:
                    gx = new Array(0, 251, 67, 46, 61, 118, 70, 64, 94, 32, 45);
                    gx = this._getElement(gx);
                    break;
                case 13:
                    gx = new Array(0, 74, 152, 176, 100, 86, 100, 106, 104, 130, 218, 206, 140, 78);
                    gx = this._getElement(gx);
                    break;
                case 15:
                    gx = new Array(0, 8, 183, 61, 91, 202, 37, 51, 58, 58, 237, 140, 124, 5, 99, 105);
                    gx = this._getElement(gx);
                    break;
                case 16:
                    gx = new Array(0, 120, 104, 107, 109, 102, 161, 76, 3, 91, 191, 147, 169, 182, 194, 225, 120);
                    gx = this._getElement(gx);
                    break;
                case 17:
                    gx = new Array(0, 43, 139, 206, 78, 43, 239, 123, 206, 214, 147, 24, 99, 150, 39, 243, 163, 136);
                    gx = this._getElement(gx);
                    break;
                case 18:
                    gx = new Array(0, 215, 234, 158, 94, 184, 97, 118, 170, 79, 187, 152, 148, 252, 179, 5, 98, 96, 153);
                    gx = this._getElement(gx);
                    break;
                case 20:
                    gx = new Array(0, 17, 60, 79, 50, 61, 163, 26, 187, 202, 180, 221, 225, 83, 239, 156, 164, 212, 212, 188, 190);
                    gx = this._getElement(gx);
                    break;
                case 22:
                    gx = new Array(0, 210, 171, 247, 242, 93, 230, 14, 109, 221, 53, 200, 74, 8, 172, 98, 80, 219, 134, 160, 105, 165, 231);
                    gx = this._getElement(gx);
                    break;
                case 24:
                    gx = new Array(0, 229, 121, 135, 48, 211, 117, 251, 126, 159, 180, 169, 152, 192, 226, 228, 218, 111, 0, 117, 232, 87, 96, 227, 21);
                    gx = this._getElement(gx);
                    break;
                case 26:
                    gx = new Array(0, 173, 125, 158, 2, 103, 182, 118, 17, 145, 201, 111, 28, 165, 53, 161, 21, 245, 142, 13, 102, 48, 227, 153, 145, 218, 70);
                    gx = this._getElement(gx);
                    break;
                case 28:
                    gx = new Array(0, 168, 223, 200, 104, 224, 234, 108, 180, 110, 190, 195, 147, 205, 27, 232, 201, 21, 43, 245, 87, 42, 195, 212, 119, 242, 37, 9, 123);
                    gx = this._getElement(gx);
                    break;
                case 30:
                    gx = new Array(0, 41, 173, 145, 152, 216, 31, 179, 182, 50, 48, 110, 86, 239, 96, 222, 125, 42, 173, 226, 193, 224, 130, 156, 37, 251, 216, 238, 40, 192, 180);
                    gx = this._getElement(gx);
                    break;
                case 32:
                    gx = new Array(0, 10, 6, 106, 190, 249, 167, 4, 67, 209, 138, 138, 32, 242, 123, 89, 27, 120, 185, 80, 156, 38, 69, 171, 60, 28, 222, 80, 52, 254, 185, 220, 241);
                    gx = this._getElement(gx);
                    break;
                case 34:
                    gx = new Array(0, 111, 77, 146, 94, 26, 21, 108, 19, 105, 94, 113, 193, 86, 140, 163, 125, 58, 158, 229, 239, 218, 103, 56, 70, 114, 61, 183, 129, 167, 13, 98, 62, 129, 51);
                    gx = this._getElement(gx);
                    break;
                case 36:
                    gx = new Array(0, 200, 183, 98, 16, 172, 31, 246, 234, 60, 152, 115, 0, 167, 152, 113, 248, 238, 107, 18, 63, 218, 37, 87, 210, 105, 177, 120, 74, 121, 196, 117, 251, 113, 233, 30, 120);
                    gx = this._getElement(gx);
                    break;
                case 40:
                    gx = new Array(0, 59, 116, 79, 161, 252, 98, 128, 205, 128, 161, 247, 57, 163, 56, 235, 106, 53, 26, 187, 174, 226, 104, 170, 7, 175, 35, 181, 114, 88, 41, 47, 163, 125, 134, 72, 20, 232, 53, 35, 15);
                    gx = this._getElement(gx);
                    break;
                case 42:
                    gx = new Array(0, 250, 103, 221, 230, 25, 18, 137, 231, 0, 3, 58, 242, 221, 191, 110, 84, 230, 8, 188, 106, 96, 147, 15, 131, 139, 34, 101, 223, 39, 101, 213, 199, 237, 254, 201, 123, 171, 162, 194, 117, 50, 96);
                    gx = this._getElement(gx);
                    break;
                case 44:
                    gx = new Array(0, 190, 7, 61, 121, 71, 246, 69, 55, 168, 188, 89, 243, 191, 25, 72, 123, 9, 145, 14, 247, 1, 238, 44, 78, 143, 62, 224, 126, 118, 114, 68, 163, 52, 194, 217, 147, 204, 169, 37, 130, 113, 102, 73, 181);
                    gx = this._getElement(gx);
                    break;
                case 46:
                    gx = new Array(0, 112, 94, 88, 112, 253, 224, 202, 115, 187, 99, 89, 5, 54, 113, 129, 44, 58, 16, 135, 216, 169, 211, 36, 1, 4, 96, 60, 241, 73, 104, 234, 8, 249, 245, 119, 174, 52, 25, 157, 224, 43, 202, 223, 19, 82, 15);
                    gx = this._getElement(gx);
                    break;
                case 48:
                    gx = new Array(0, 228, 25, 196, 130, 211, 146, 60, 24, 251, 90, 39, 102, 240, 61, 178, 63, 46, 123, 115, 18, 221, 111, 135, 160, 182, 205, 107, 206, 95, 150, 120, 184, 91, 21, 247, 156, 140, 238, 191, 11, 94, 227, 84, 50, 163, 39, 34, 108);
                    gx = this._getElement(gx);
                    break;
                case 50:
                    gx = new Array(0, 232, 125, 157, 161, 164, 9, 118, 46, 209, 99, 203, 193, 35, 3, 209, 111, 195, 242, 203, 225, 46, 13, 32, 160, 126, 209, 130, 160, 242, 215, 242, 75, 77, 42, 189, 32, 113, 65, 124, 69, 228, 114, 235, 175, 124, 170, 215, 232, 133, 205);
                    gx = this._getElement(gx);
                    break;
                case 52:
                    gx = new Array(0, 116, 50, 86, 186, 50, 220, 251, 89, 192, 46, 86, 127, 124, 19, 184, 233, 151, 215, 22, 14, 59, 145, 37, 242, 203, 134, 254, 89, 190, 94, 59, 65, 124, 113, 100, 233, 235, 121, 22, 76, 86, 97, 39, 242, 200, 220, 101, 33, 239, 254, 116, 51);
                    gx = this._getElement(gx);
                    break;
                case 54:
                    gx = new Array(0, 183, 26, 201, 87, 210, 221, 113, 21, 46, 65, 45, 50, 238, 184, 249, 225, 102, 58, 209, 218, 109, 165, 26, 95, 184, 192, 52, 245, 35, 254, 238, 175, 172, 79, 123, 25, 122, 43, 120, 108, 215, 80, 128, 201, 235, 8, 153, 59, 101, 31, 198, 76, 31, 156);
                    gx = this._getElement(gx);
                    break;
                case 56:
                    gx = new Array(0, 106, 120, 107, 157, 164, 216, 112, 116, 2, 91, 248, 163, 36, 201, 202, 229, 6, 144, 254, 155, 135, 208, 170, 209, 12, 139, 127, 142, 182, 249, 177, 174, 190, 28, 10, 85, 239, 184, 101, 124, 152, 206, 96, 23, 163, 61, 27, 196, 247, 151, 154, 202, 207, 20, 61, 10);
                    gx = this._getElement(gx);
                    break;
                case 58:
                    gx = new Array(0, 82, 116, 26, 247, 66, 27, 62, 107, 252, 182, 200, 185, 235, 55, 251, 242, 210, 144, 154, 237, 176, 141, 192, 248, 152, 249, 206, 85, 253, 142, 65, 165, 125, 23, 24, 30, 122, 240, 214, 6, 129, 218, 29, 145, 127, 134, 206, 245, 117, 29, 41, 63, 159, 142, 233, 125, 148, 123);
                    gx = this._getElement(gx);
                    break;
                case 60:
                    gx = new Array(0, 107, 140, 26, 12, 9, 141, 243, 197, 226, 197, 219, 45, 211, 101, 219, 120, 28, 181, 127, 6, 100, 247, 2, 205, 198, 57, 115, 219, 101, 109, 160, 82, 37, 38, 238, 49, 160, 209, 121, 86, 11, 124, 30, 181, 84, 25, 194, 87, 65, 102, 190, 220, 70, 27, 209, 16, 89, 7, 33, 240);
                    gx = this._getElement(gx);
                    break;
                case 62:
                    gx = new Array(0, 65, 202, 113, 98, 71, 223, 248, 118, 214, 94, 0, 122, 37, 23, 2, 228, 58, 121, 7, 105, 135, 78, 243, 118, 70, 76, 223, 89, 72, 50, 70, 111, 194, 17, 212, 126, 181, 35, 221, 117, 235, 11, 229, 149, 147, 123, 213, 40, 115, 6, 200, 100, 26, 246, 182, 218, 127, 215, 36, 186, 110, 106);
                    gx = this._getElement(gx);
                    break;
                case 64:
                    gx = new Array(0, 45, 51, 175, 9, 7, 158, 159, 49, 68, 119, 92, 123, 177, 204, 187, 254, 200, 78, 141, 149, 119, 26, 127, 53, 160, 93, 199, 212, 29, 24, 145, 156, 208, 150, 218, 209, 4, 216, 91, 47, 184, 146, 47, 140, 195, 195, 125, 242, 238, 63, 99, 108, 140, 230, 242, 31, 204, 11, 178, 243, 217, 156, 213, 231);
                    gx = this._getElement(gx);
                    break;
                case 66:
                    gx = new Array(0, 5, 118, 222, 180, 136, 136, 162, 51, 46, 117, 13, 215, 81, 17, 139, 247, 197, 171, 95, 173, 65, 137, 178, 68, 111, 95, 101, 41, 72, 214, 169, 197, 95, 7, 44, 154, 77, 111, 236, 40, 121, 143, 63, 87, 80, 253, 240, 126, 217, 77, 34, 232, 106, 50, 168, 82, 76, 146, 67, 106, 171, 25, 132, 93, 45, 105);
                    gx = this._getElement(gx);
                    break;
                case 68:
                    gx = new Array(0, 247, 159, 223, 33, 224, 93, 77, 70, 90, 160, 32, 254, 43, 150, 84, 101, 190, 205, 133, 52, 60, 202, 165, 220, 203, 151, 93, 84, 15, 84, 253, 173, 160, 89, 227, 52, 199, 97, 95, 231, 52, 177, 41, 125, 137, 241, 166, 225, 118, 2, 54, 32, 82, 215, 175, 198, 43, 238, 235, 27, 101, 184, 127, 3, 5, 8, 163, 238);
                    gx = this._getElement(gx);
                    break;
            }

            decimalValue = this._toDecimal(this.corCodeWords.DC, decimalValue);
            decimalRepresentation = this._divide(gx, decimalValue);
            ecw = this._toBinary(decimalRepresentation);
            return ecw;
        },

        /** 
         * Convert to binary.
         * @private
         */
        _toBinary: function (decimalRepresentation) {
            var toBinary = new Array(this.corCodeWords.ECCW);
            for (var i = 0; i < decimalRepresentation.length; i++) {
                var temp = decimalRepresentation[i].toString(2);
                var str = new String();
                for (var j = 0; j < (8 - temp.length) ; j++)
                    str += "0";
                toBinary[i] = str + temp;
            }
            return toBinary;
        },

        /** 
         * @private
         */
        _divide: function (gx, decimalValue) {
            var alpha = new Array(1, 2, 4, 8, 16, 32, 64, 128, 29, 58, 116, 232, 205, 135, 19, 38, 76, 152, 45, 90, 180, 117, 234, 201, 143, 3, 6, 12, 24, 48, 96, 192, 157, 39, 78, 156, 37, 74, 148, 53, 106, 212, 181, 119, 238, 193, 159, 35, 70, 140, 5, 10, 20, 40, 80, 160, 93, 186, 105, 210, 185, 111, 222, 161, 95, 190, 97, 194, 153, 47, 94, 188, 101, 202, 137, 15, 30, 60, 120, 240, 253, 231, 211, 187, 107, 214, 177, 127, 254, 225, 223, 163, 91, 182, 113, 226, 217, 175, 67, 134, 17, 34, 68, 136, 13, 26, 52, 104, 208, 189, 103, 206, 129, 31, 62, 124, 248, 237, 199, 147, 59, 118, 236, 197, 151, 51, 102, 204, 133, 23, 46, 92, 184, 109, 218, 169, 79, 158, 33, 66, 132, 21, 42, 84, 168, 77, 154, 41, 82, 164, 85, 170, 73, 146, 57, 114, 228, 213, 183, 115, 230, 209, 191, 99, 198, 145, 63, 126, 252, 229, 215, 179, 123, 246, 241, 255, 227, 219, 171, 75, 150, 49, 98, 196, 149, 55, 110, 220, 165, 87, 174, 65, 130, 25, 50, 100, 200, 141, 7, 14, 28, 56, 112, 224, 221, 167, 83, 166, 81, 162, 89, 178, 121, 242, 249, 239, 195, 155, 43, 86, 172, 69, 138, 9, 18, 36, 72, 144, 61, 122, 244, 245, 247, 243, 251, 235, 203, 139, 11, 22, 44, 88, 176, 125, 250, 233, 207, 131, 27, 54, 108, 216, 173, 71, 142);
            var eccWords = this.corCodeWords.ECCW;
            var messagePolynom = [];
            for (var i = 0; i < decimalValue.length; i++) {
                messagePolynom.push({
                Exponent: decimalValue.length - 1 - i,
                Coefficient: decimalValue[i]
            })
            }

            var generatorPolynom = [];
            for (var i = 0; i < gx.length; i++)
            {
                generatorPolynom.push({
                Exponent: gx.length - 1 - i,
                Coefficient: this._findElement(gx[i], alpha)
            })
            }

            for (var i = 0; i < messagePolynom.length; i++)
            {
                messagePolynom[i].Exponent = messagePolynom[i].Exponent + eccWords;
            }

            var genLeadtermFactor = messagePolynom[0].Exponent - generatorPolynom[0].Exponent;
            for (var i = 0; i < generatorPolynom.length; i++) {
                generatorPolynom[i].Coefficient = generatorPolynom[i].Coefficient;
                generatorPolynom[i].Exponent = generatorPolynom[i].Exponent + genLeadtermFactor;
            }

            var leadTermSource = messagePolynom;
            for (var i = 0; i < messagePolynom.length; i++)
            {
                if (leadTermSource[0].Coefficient == 0) {
                    leadTermSource.splice(0, 1);
                }
                else {
                    var alphaNotation = this._convertToAlphaNotation(leadTermSource, alpha);
                    var resPoly = this._multiplyGeneratorPolynomByLeadterm(generatorPolynom, alphaNotation[0], i);
                    resPoly = this._convertToDecNotation(resPoly,alpha);
                    resPoly = this._XORPolynoms(leadTermSource, resPoly);
                    leadTermSource = resPoly;
                }

            }
            var returnArray = [];
            for (var i = 0; i < leadTermSource.length; i++) {
                returnArray.push(leadTermSource[i].Coefficient);
            }
            return returnArray;
        },

        /** 
         * @private
         */
         _convertToAlphaNotation: function(poly, alpha) {
             var newPoly = [];
             for (var i = 0; i < poly.length; i++) {
                 if (poly[i].Coefficient != 0) {
                     newPoly.push({
                         Exponent: poly[i].Exponent,
                         Coefficient: this._findElement(poly[i].Coefficient, alpha)
                     })
                 }
             }
             return newPoly;
         },

         /** 
         * @private
         */
         _multiplyGeneratorPolynomByLeadterm: function(genPolynom, leadTerm, lowerExponentBy) {
             var tempPolynom = [];
             for (var i = 0; i < genPolynom.length; i++) {
                 tempPolynom.push({
                     Exponent: genPolynom[i].Exponent - lowerExponentBy,
                     Coefficient: (genPolynom[i].Coefficient + leadTerm.Coefficient) % 255
             })
             }
             return tempPolynom;
         },

         /** 
         * @private
         */
         _convertToDecNotation: function(poly, alpha) {
             var tempPolynom = [];
             for (var i = 0; i < poly.length; i++) {
             tempPolynom.push({
                     Exponent: poly[i].Exponent,
                     Coefficient:  this._getIntValFromAlphaExp(poly[i].Coefficient, alpha)
             })
             }
             return tempPolynom;
         },

         /** 
         * @private
         */
         _getIntValFromAlphaExp: function(element, alpha) {
             if (element > 255)
            {
                element = element - 255;
            }
            return alpha[element];
         },
         
         
         /** 
         * @private
         */
         _XORPolynoms: function(messagePolynom, resPolynom) {
              var resultPolynom = [];
              var longPoly = [];
              var shortPoly = [];
            if (messagePolynom.length >= resPolynom.length)
            {
                longPoly = messagePolynom;
                shortPoly = resPolynom;
            }
            else
            {
                longPoly = resPolynom;
                shortPoly = messagePolynom;
            }
            
            for (var i = 0; i < longPoly.length; i++)
            {
            resultPolynom.push({
                     Exponent: messagePolynom[0].Exponent - i,
                     Coefficient:  longPoly[i].Coefficient ^ (shortPoly.length > i ? shortPoly[i].Coefficient : 0)
             })
            }
            resultPolynom.splice(0, 1);
            return resultPolynom;
         },

        /** 
         * @private
         */
        _findElement: function (element, alpha) {
            var j = 0;
            for (; j < alpha.length; j++) {
                if (element == alpha[j])
                    break;
            }
            return j;
        },

        /** 
         * @private
         */
        _getElement: function (element) {
            var gx = new Array(element.length);
            var alpha = new Array(1, 2, 4, 8, 16, 32, 64, 128, 29, 58, 116, 232, 205, 135, 19, 38, 76, 152, 45, 90, 180, 117, 234, 201, 143, 3, 6, 12, 24, 48, 96, 192, 157, 39, 78, 156, 37, 74, 148, 53, 106, 212, 181, 119, 238, 193, 159, 35, 70, 140, 5, 10, 20, 40, 80, 160, 93, 186, 105, 210, 185, 111, 222, 161, 95, 190, 97, 194, 153, 47, 94, 188, 101, 202, 137, 15, 30, 60, 120, 240, 253, 231, 211, 187, 107, 214, 177, 127, 254, 225, 223, 163, 91, 182, 113, 226, 217, 175, 67, 134, 17, 34, 68, 136, 13, 26, 52, 104, 208, 189, 103, 206, 129, 31, 62, 124, 248, 237, 199, 147, 59, 118, 236, 197, 151, 51, 102, 204, 133, 23, 46, 92, 184, 109, 218, 169, 79, 158, 33, 66, 132, 21, 42, 84, 168, 77, 154, 41, 82, 164, 85, 170, 73, 146, 57, 114, 228, 213, 183, 115, 230, 209, 191, 99, 198, 145, 63, 126, 252, 229, 215, 179, 123, 246, 241, 255, 227, 219, 171, 75, 150, 49, 98, 196, 149, 55, 110, 220, 165, 87, 174, 65, 130, 25, 50, 100, 200, 141, 7, 14, 28, 56, 112, 224, 221, 167, 83, 166, 81, 162, 89, 178, 121, 242, 249, 239, 195, 155, 43, 86, 172, 69, 138, 9, 18, 36, 72, 144, 61, 122, 244, 245, 247, 243, 251, 235, 203, 139, 11, 22, 44, 88, 176, 125, 250, 233, 207, 131, 27, 54, 108, 216, 173, 71, 142);
            for (var i = 0; i < element.length; i++) {
                if (element[i] > 255)
                    element[i] = element[i] - 255;
                gx[i] = alpha[element[i]];
            }
            return gx;
        },

        /** 
         * @private
         */
        _toDecimal: function (inString) {
            var decimalValue = new Array(inString.length);
            for (var i = 0; i < inString.length; i++)
                decimalValue[i] = parseInt(inString[i], 2);

            return decimalValue;
        },

        /** 
         * @private
         */
        _splitCodeWord: function (ds, blk, count) {
            count = parseInt(count);
            var ds1 = new Array(count);
            for (var i = 0; i < count; i++)
                ds1[i] = ds[blk][i];
            return ds1;
        },

        /** 
         * Create blocks for datamatrix barcode.
         * @private
         */
        _createBlocks: function (data, noOfBlocks) {
            var ret = this._create2DArray(noOfBlocks, data.length / 8 / noOfBlocks);
            var stringValue = "";
            var j = 0, i = 0, blockNumber = 0;

            for (; j < data.length; j++) {
                if (j % 8 == 0 && j != 0) {
                    ret[blockNumber][i] = stringValue;
                    stringValue = "";
                    i++;

                    if (i == (data.length / noOfBlocks / 8)) {
                        blockNumber++;
                        i = 0;
                    }
                }

                stringValue += data[j] ? 1 : 0;
            }
            ret[blockNumber][i] = stringValue;
            return ret;
        },

        /** 
         * Returns alphanumeric values for the character.
         * @private
         */
        _getAlphanumericvalues: function (charValue) {
            var valueInInt = -1;
            var alphaNumArray = new Array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', ' ', '$', '%', '*', '+', '-', '.', '/', ':');
            valueInInt = alphaNumArray.indexOf(charValue);
            return valueInInt;
        },

        /** 
         * @private
         */
        _stringToBoolArray: function (numberInString, noOfBits) {
            var numberInBool = new Array(noOfBits);

            var number = 0;
            for (var i = 0; i < numberInString.length; i++)
                number = number * 10 + numberInString.charCodeAt(i) - 48;

            for (var i = 0; i < noOfBits; i++)
                numberInBool[noOfBits - i - 1] = ((number >> i) & 1) == 1;

            return numberInBool;
        },

        /** 
         * @private
         */
        _intToBoolArray: function (number, noOfBits) {
            var numberInBool = new Array(noOfBits);
            for (var i = 0; i < noOfBits; i++)
                numberInBool[noOfBits - i - 1] = ((number >> i) & 1) == 1;
            return numberInBool;
        },

        /** 
         * @private
         */
        _drawPDP: function (x, y) {
            var i, j;
            for (i = x, j = y; i < x + 7; i++, j++) {
                this.moduleValue[i][y].IsBlack = true;
                this.moduleValue[i][y].IsFilled = true;
                this.moduleValue[i][y].IsPDP = true;

                this.moduleValue[i][y + 6].IsBlack = true;
                this.moduleValue[i][y + 6].IsFilled = true;
                this.moduleValue[i][y + 6].IsPDP = true;

                if (y + 7 < this.noOfModules) {
                    this.moduleValue[i][y + 7].IsBlack = false;
                    this.moduleValue[i][y + 7].IsFilled = true;
                    this.moduleValue[i][y + 7].IsPDP = true;
                }
                else if (y - 1 >= 0) {
                    this.moduleValue[i][y - 1].IsBlack = false;
                    this.moduleValue[i][y - 1].IsFilled = true;
                    this.moduleValue[i][y - 1].IsPDP = true;
                }

                this.moduleValue[x][j].IsBlack = true;
                this.moduleValue[x][j].IsFilled = true;
                this.moduleValue[x][j].IsPDP = true;

                this.moduleValue[x + 6][j].IsBlack = true;
                this.moduleValue[x + 6][j].IsFilled = true;
                this.moduleValue[x + 6][j].IsPDP = true;

                if (x + 7 < this.noOfModules) {
                    this.moduleValue[x + 7][j].IsBlack = false;
                    this.moduleValue[x + 7][j].IsFilled = true;
                    this.moduleValue[x + 7][j].IsPDP = true;
                }
                else if (x - 1 >= 0) {
                    this.moduleValue[x - 1][j].IsBlack = false;
                    this.moduleValue[x - 1][j].IsFilled = true;
                    this.moduleValue[x - 1][j].IsPDP = true;
                }
            }

            if (x + 7 < this.noOfModules && y + 7 < this.noOfModules) {
                this.moduleValue[x + 7][y + 7].IsBlack = false;
                this.moduleValue[x + 7][y + 7].IsFilled = true;
                this.moduleValue[x + 7][y + 7].IsPDP = true;
            }
            else if (x + 7 < this.noOfModules && y + 7 >= this.noOfModules) {
                this.moduleValue[x + 7][y - 1].IsBlack = false;
                this.moduleValue[x + 7][y - 1].IsFilled = true;
                this.moduleValue[x + 7][y - 1].IsPDP = true;
            }
            else if (x + 7 >= this.noOfModules && y + 7 < this.noOfModules) {
                this.moduleValue[x - 1][y + 7].IsBlack = false;
                this.moduleValue[x - 1][y + 7].IsFilled = true;
                this.moduleValue[x - 1][y + 7].IsPDP = true;
            }

            x++;
            y++;
            for (i = x, j = y; i < x + 5; i++, j++) {
                this.moduleValue[i][y].IsBlack = false;
                this.moduleValue[i][y].IsFilled = true;
                this.moduleValue[i][y].IsPDP = true;

                this.moduleValue[i][y + 4].IsBlack = false;
                this.moduleValue[i][y + 4].IsFilled = true;
                this.moduleValue[i][y + 4].IsPDP = true;

                this.moduleValue[x][j].IsBlack = false;
                this.moduleValue[x][j].IsFilled = true;
                this.moduleValue[x][j].IsPDP = true;

                this.moduleValue[x + 4][j].IsBlack = false;
                this.moduleValue[x + 4][j].IsFilled = true;
                this.moduleValue[x + 4][j].IsPDP = true;
            }

            x++;
            y++;
            for (i = x, j = y; i < x + 3; i++, j++) {
                this.moduleValue[i][y].IsBlack = true;
                this.moduleValue[i][y].IsFilled = true;
                this.moduleValue[i][y].IsPDP = true;

                this.moduleValue[i][y + 2].IsBlack = true;
                this.moduleValue[i][y + 2].IsFilled = true;
                this.moduleValue[i][y + 2].IsPDP = true;

                this.moduleValue[x][j].IsBlack = true;
                this.moduleValue[x][j].IsFilled = true;
                this.moduleValue[x][j].IsPDP = true;

                this.moduleValue[x + 2][j].IsBlack = true;
                this.moduleValue[x + 2][j].IsFilled = true;
                this.moduleValue[x + 2][j].IsPDP = true;
            }
            this.moduleValue[x + 1][y + 1].IsBlack = true;
            this.moduleValue[x + 1][y + 1].IsFilled = true;
            this.moduleValue[x + 1][y + 1].IsPDP = true;
        },

        /** 
         * @private
         */
        _drawAlignmentPattern: function (x, y) {
            var i, j;
            for (i = x - 2, j = y - 2; i < x + 3; i++, j++) {
                this.moduleValue[i][y - 2].IsBlack = true;
                this.moduleValue[i][y - 2].IsFilled = true;

                this.moduleValue[i][y + 2].IsBlack = true;
                this.moduleValue[i][y + 2].IsFilled = true;

                this.moduleValue[x - 2][j].IsBlack = true;
                this.moduleValue[x - 2][j].IsFilled = true;

                this.moduleValue[x + 2][j].IsBlack = true;
                this.moduleValue[x + 2][j].IsFilled = true;
            }

            for (i = x - 1, j = y - 1; i < x + 2; i++, j++) {
                this.moduleValue[i][y - 1].IsBlack = false;
                this.moduleValue[i][y - 1].IsFilled = true;

                this.moduleValue[i][y + 1].IsBlack = false;
                this.moduleValue[i][y + 1].IsFilled = true;

                this.moduleValue[x - 1][j].IsBlack = false;
                this.moduleValue[x - 1][j].IsFilled = true;

                this.moduleValue[x + 1][j].IsBlack = false;
                this.moduleValue[x + 1][j].IsFilled = true;
            }
            this.moduleValue[x][y].IsBlack = true;
            this.moduleValue[x][y].IsFilled = true;
        },

        /** 
         * @private
         */
        _getAlignmentPatternCoOrdinates: function () {
            var allign = new Array();
            switch (this.m_Version) {
                case 2:
                    allign = new Array(6, 18);
                    break;
                case 3:
                    allign = new Array(6, 22);
                    break;
                case 4:
                    allign = new Array(6, 26);
                    break;
                case 5:
                    allign = new Array(6, 30);
                    break;
                case 6:
                    allign = new Array(6, 34);
                    break;
                case 7:
                    allign = new Array(6, 22, 38);
                    break;
                case 8:
                    allign = new Array(6, 24, 42);
                    break;
                case 9:
                    allign = new Array(6, 26, 46);
                    break;
                case 10:
                    allign = new Array(6, 28, 50);
                    break;
                case 11:
                    allign = new Array(6, 30, 54);
                    break;
                case 12:
                    allign = new Array(6, 32, 58);
                    break;
                case 13:
                    allign = new Array(6, 34, 62);
                    break;
                case 14:
                    allign = new Array(6, 26, 46, 66);
                    break;
                case 15:
                    allign = new Array(6, 26, 48, 70);
                    break;
                case 16:
                    allign = new Array(6, 26, 50, 74);
                    break;
                case 17:
                    allign = new Array(6, 30, 54, 78);
                    break;
                case 18:
                    allign = new Array(6, 30, 56, 82);
                    break;
                case 19:
                    allign = new Array(6, 30, 58, 86);
                    break;
                case 20:
                    allign = new Array(6, 34, 62, 90);
                    break;
                case 21:
                    allign = new Array(6, 28, 50, 72, 94);
                    break;
                case 22:
                    allign = new Array(6, 26, 50, 74, 98);
                    break;
                case 23:
                    allign = new Array(6, 30, 54, 78, 102);
                    break;
                case 24:
                    allign = new Array(6, 28, 54, 80, 106);
                    break;
                case 25:
                    allign = new Array(6, 32, 58, 84, 110);
                    break;
                case 26:
                    allign = new Array(6, 30, 58, 86, 114);
                    break;
                case 27:
                    allign = new Array(6, 34, 62, 90, 118);
                    break;
                case 28:
                    allign = new Array(6, 26, 50, 74, 98, 122);
                    break;
                case 29:
                    allign = new Array(6, 30, 54, 78, 102, 126);
                    break;
                case 30:
                    allign = new Array(6, 26, 52, 78, 104, 130);
                    break;
                case 31:
                    allign = new Array(6, 30, 56, 82, 108, 134);
                    break;
                case 32:
                    allign = new Array(6, 34, 60, 86, 112, 138);
                    break;
                case 33:
                    allign = new Array(6, 30, 58, 86, 114, 142);
                    break;
                case 34:
                    allign = new Array(6, 34, 62, 90, 118, 146);
                    break;
                case 35:
                    allign = new Array(6, 30, 54, 78, 102, 126, 150);
                    break;
                case 36:
                    allign = new Array(6, 24, 50, 76, 102, 128, 154);
                    break;
                case 37:
                    allign = new Array(6, 28, 54, 80, 106, 132, 158);
                    break;
                case 38:
                    allign = new Array(6, 32, 58, 84, 110, 136, 162);
                    break;
                case 39:
                    allign = new Array(6, 26, 54, 82, 110, 138, 166);
                    break;
                case 40:
                    allign = new Array(6, 30, 58, 86, 114, 142, 170);
                    break;
            }
            return allign;
        },

        /** 
         * @private
         */
        _findECINumber: function (text) {
            var num = 3;
            for (var i = 0; i < text.length; i++) {
                var cCode = text.charCodeAt(i);
                if (cCode >= 32 && cCode <= 255) {
                    continue;
                }

                var check = cCode.toString(16);
                var CP437CharSet = new Array("2591", "2592", "2593", "2502", "2524", "2561", "2562", "2556", "2555", "2563", "2551", "2557", "255D", "255C", "255B", "2510", "2514", "2534", "252C", "251C", "2500", "253C", "255E", "255F", "255A", "2554", "2569", "2566", "2560", "2550", "256C", "2567", "2568", "2564", "2565", "2559", "2558", "2552", "2553", "256B", "256A", "2518", "250C", "2588", "2584", "258C", "2590", "2580", "25A0");
                var latin2CharSet = new Array("104", "2D8", "141", "13D", "15A", "160", "15E", "164", "179", "17D", "17B", "105", "2DB", "142", "13E", "15B", "2C7", "161", "15F", "165", "17A", "2DD", "17E", "17C", "154", "102", "139", "106", "10C", "118", "11A", "10E", "110", "143", "147", "150", "158", "16E", "170", "162", "155", "103", "13A", "107", "10D", "119", "11B", "10F", "111", "144", "148", "151", "159", "16F", "171", "163", "2D9");
                var latin3CharSet = new Array("126", "124", "130", "15E", "11E", "134", "17B", "127", "125", "131", "15F", "11F", "135", "17C", "10A", "108", "120", "11C", "16C", "15C", "10B", "109", "121", "11D", "16D", "15D");
                var latin4CharSet = new Array("104", "138", "156", "128", "13B", "160", "112", "122", "166", "17D", "105", "2DB", "157", "129", "13C", "2C7", "161", "113", "123", "167", "14A", "17E", "14B", "100", "12E", "10C", "118", "116", "12A", "110", "145", "14C", "136", "172", "168", "16A", "101", "12F", "10D", "119", "117", "12B", "111", "146", "14D", "137", "173", "169", "16B");
                var windows1250CharSet = new Array("141", "104", "15E", "17B", "142", "105", "15F", "13D", "13E", "17C");
                var windows1251CharSet = new Array("402", "403", "453", "409", "40A", "40C", "40B", "40F", "452", "459", "45A", "45C", "45B", "45F", "40E", "45E", "408", "490", "401", "404", "407", "406", "456", "491", "451", "454", "458", "405", "455", "457");
                var windows1252CharSet = new Array("20AC", "201A", "192", "201E", "2026", "2020", "2021", "2C6", "2030", "160", "2039", "152", "17D", "2018", "2019", "201C", "201D", "2022", "2013", "2014", "2DC", "2122", "161", "203A", "153", "17E", "178");
                var windows1256CharSet = new Array("67E", "679", "152", "686", "698", "688", "6AF", "6A9", "691", "153", "6BA", "6BE", "6C1");

                /** Check for CP437*/
                if (CP437CharSet.indexOf(check) != -1) {
                    num = 2;
                    break;
                }
                    /** Check for ISO/IEC 8859-2*/
                else if (latin2CharSet.indexOf(check) != -1) {
                    num = 4;
                    break;
                }
                    /** Check for ISO/IEC 8859-3*/
                else if (latin3CharSet.indexOf(check) != -1) {
                    num = 5;
                    break;
                }
                    /** Check for ISO/IEC 8859-4*/
                else if (latin4CharSet.indexOf(check) != -1) {
                    num = 6;
                    break;
                }
                    /** Check for ISO/IEC 8859-5*/
                else if (check >= 1025 && check <= 1119 && check != 1037 && check != 1104 && check != 1117) {
                    num = 7;
                    break;
                }
                    /** Check for ISO/IEC 8859-6*/
                else if ((check >= 1569 && check <= 1594) || (check >= 1600 && check <= 1618) || check == 1567 || check == 1563 || check == 1548) {
                    num = 8;
                    break;
                }
                    /** Check for ISO/IEC 8859-7*/
                else if ((check >= 900 && check <= 974) || check == 890) {
                    num = 9;
                    break;
                }
                    /** Check for ISO/IEC 8859-8*/
                else if (check >= 1488 && check <= 1514) {
                    num = 10;
                    break;
                }
                    /** Check for ISO/IEC 8859-8*/
                else if (check >= 3585 && check <= 3675) {
                    num = 13;
                    break;
                }
                    /** Check for Windows1250*/
                else if ((windows1250CharSet.indexOf(check) != 1) || (check >= 1569 && check <= 1610)) {
                    num = 21;
                    break;
                }
                    /** Check for Windows1251*/
                else if ((windows1251CharSet.indexOf(check) != 1) || (check >= 1040 && check <= 1103)) {
                    num = 22;
                    break;
                }
                    /** Check for Windows1252*/
                else if (windows1252CharSet.indexOf(check) != -1) {
                    num = 23;
                    break;
                }
                    /** Check for Windows1256*/
                else if (windows1256CharSet.indexOf(check) != -1) {
                    num = 24;
                    break;
                }
            }
            return num;
        },

        /** 
         * @private
         */
        _getNumberOfDataCodeWord: function () {
            var countOfDataCodeWord = 0;

            switch (this.m_Version) {
                case 1:
                    countOfDataCodeWord = 16;
                    break;
                case 2:
                    countOfDataCodeWord = 28;
                    break;
                case 3:
                    countOfDataCodeWord = 44;
                    break;
                case 4:
                    countOfDataCodeWord = 64;
                    break;
                case 5:
                    countOfDataCodeWord = 86;
                    break;
                case 6:
                    countOfDataCodeWord = 108;
                    break;
                case 7:
                    countOfDataCodeWord = 124;
                    break;
                case 8:
                    countOfDataCodeWord = 154;
                    break;
                case 9:
                    countOfDataCodeWord = 182;
                    break;
                case 10:
                    countOfDataCodeWord = 216;
                    break;
                case 11:
                    countOfDataCodeWord = 254;
                    break;
                case 12:
                    countOfDataCodeWord = 290;
                    break;
                case 13:
                    countOfDataCodeWord = 334;
                    break;
                case 14:
                    countOfDataCodeWord = 365;
                    break;
                case 15:
                    countOfDataCodeWord = 415;
                    break;
                case 16:
                    countOfDataCodeWord = 453;
                    break;
                case 17:
                    countOfDataCodeWord = 507;
                    break;
                case 18:
                    countOfDataCodeWord = 563;
                    break;
                case 19:
                    countOfDataCodeWord = 627;
                    break;
                case 20:
                    countOfDataCodeWord = 669;
                    break;
                case 21:
                    countOfDataCodeWord = 714;
                    break;
                case 22:
                    countOfDataCodeWord = 782;
                    break;
                case 23:
                    countOfDataCodeWord = 860;
                    break;
                case 24:
                    countOfDataCodeWord = 914;
                    break;
                case 25:
                    countOfDataCodeWord = 1000;
                    break;
                case 26:
                    countOfDataCodeWord = 1062;
                    break;
                case 27:
                    countOfDataCodeWord = 1128;
                    break;
                case 28:
                    countOfDataCodeWord = 1193;
                    break;
                case 29:
                    countOfDataCodeWord = 1267;
                    break;
                case 30:
                    countOfDataCodeWord = 1373;
                    break;
                case 31:
                    countOfDataCodeWord = 1455;
                    break;
                case 32:
                    countOfDataCodeWord = 1541;
                    break;
                case 33:
                    countOfDataCodeWord = 1631;
                    break;
                case 34:
                    countOfDataCodeWord = 1725;
                    break;
                case 35:
                    countOfDataCodeWord = 1812;
                    break;
                case 36:
                    countOfDataCodeWord = 1914;
                    break;
                case 37:
                    countOfDataCodeWord = 1992;
                    break;
                case 38:
                    countOfDataCodeWord = 2102;
                    break;
                case 39:
                    countOfDataCodeWord = 2216;
                    break;
                case 40:
                    countOfDataCodeWord = 2334;
                    break;
            }

            return countOfDataCodeWord;
        },

        /** 
         * Returns the number of error correcting codewords based on QR version.
         * @private
         */
        _getNumberOfErrorCorrectingCodeWords: function () {
            var index = (this.m_Version - 1) * 4;
            index += 1;
            var numberOfErrorCorrectingCodeWords = new Array(7, 10, 13, 17, 10, 16, 22, 28, 15, 26, 36, 44, 20, 36, 52, 64, 26, 48, 72, 88, 36, 64, 96, 112, 40, 72, 108, 130, 48, 88, 132, 156, 60, 110, 160, 192, 72, 130, 192, 224, 80, 150, 224, 264, 96, 176, 260, 308, 104, 198, 288, 352, 120, 216, 320, 384, 132, 240, 360, 432, 144, 280, 408, 480, 168, 308, 448, 532, 180, 338, 504, 588, 196, 364, 546, 650, 224, 416, 600, 700, 224, 442, 644, 750, 252, 476, 690, 816, 270, 504, 750, 900, 300, 560, 810, 960, 312, 588, 870, 1050, 336, 644, 952, 1110, 360, 700, 1020, 1200, 390, 728, 1050, 1260, 420, 784, 1140, 1350, 450, 812, 1200, 1440, 480, 868, 1290, 1530, 510, 924, 1350, 1620, 540, 980, 1440, 1710, 570, 1036, 1530, 1800, 570, 1064, 1590, 1890, 600, 1120, 1680, 1980, 630, 1204, 1770, 2100, 660, 1260, 1860, 2220, 720, 1316, 1950, 2310, 750, 1372, 2040, 2430);
            return numberOfErrorCorrectingCodeWords[index];
        },

        /** 
         * Returns the number of error correction blocks based on QR version.
         * @private
         */
        _getNumberOfErrorCorrectionBlocks: function () {
            var numberOfErrorCorrectionBlocks = new Array();
            switch (this.m_Version) {
                case 1:
                case 2:
                case 3:
                    numberOfErrorCorrectionBlocks[0] = 1;
                    break;
                case 4:
                case 5:
                    numberOfErrorCorrectionBlocks[0] = 2;
                    break;
                case 6:
                case 7:
                    numberOfErrorCorrectionBlocks[0] = 4;
                    break;
                case 8:
                    numberOfErrorCorrectionBlocks = new Array(2, 60, 38, 2, 61, 39);
                    break;
                case 9:
                    numberOfErrorCorrectionBlocks = new Array(3, 58, 36, 2, 59, 37);
                    break;
                case 10:
                    numberOfErrorCorrectionBlocks = new Array(4, 69, 43, 1, 70, 44);
                    break;
                case 11:
                    numberOfErrorCorrectionBlocks = new Array(1, 80, 50, 4, 81, 51);
                    break;
                case 12:
                    numberOfErrorCorrectionBlocks = new Array(6, 58, 36, 2, 59, 37);
                    break;
                case 13:
                    numberOfErrorCorrectionBlocks = new Array(8, 59, 37, 1, 60, 38);
                    break;
                case 14:
                    numberOfErrorCorrectionBlocks = new Array(4, 64, 40, 5, 65, 41);
                    break;
                case 15:
                    numberOfErrorCorrectionBlocks = new Array(5, 65, 41, 5, 66, 42);
                    break;
                case 16:
                    numberOfErrorCorrectionBlocks = new Array(7, 73, 45, 3, 74, 46);
                    break;
                case 17:
                    numberOfErrorCorrectionBlocks = new Array(10, 74, 46, 1, 75, 47);
                    break;
                case 18:
                    numberOfErrorCorrectionBlocks = new Array(9, 69, 43, 4, 70, 44);
                    break;
                case 19:
                    numberOfErrorCorrectionBlocks = new Array(3, 70, 44, 11, 71, 45);
                    break;
                case 20:
                    numberOfErrorCorrectionBlocks = new Array(3, 67, 41, 13, 68, 42);
                    break;
                case 21:
                case 22:
                    numberOfErrorCorrectionBlocks[0] = 17;
                    break;
                case 23:
                    numberOfErrorCorrectionBlocks = new Array(4, 75, 47, 14, 76, 48);
                    break;
                case 24:
                    numberOfErrorCorrectionBlocks = new Array(6, 73, 45, 14, 74, 46);
                    break;
                case 25:
                    numberOfErrorCorrectionBlocks = new Array(8, 75, 47, 13, 76, 48);
                    break;
                case 26:
                    numberOfErrorCorrectionBlocks = new Array(19, 74, 46, 4, 75, 47);
                    break;
                case 27:
                    numberOfErrorCorrectionBlocks = new Array(22, 73, 45, 3, 74, 46);
                    break;
                case 28:
                    numberOfErrorCorrectionBlocks = new Array(3, 73, 45, 23, 74, 46);
                    break;
                case 29:
                    numberOfErrorCorrectionBlocks = new Array(21, 73, 45, 7, 74, 46);
                    break;
                case 30:
                    numberOfErrorCorrectionBlocks = new Array(19, 75, 47, 10, 76, 48);
                    break;
                case 31:
                    numberOfErrorCorrectionBlocks = new Array(2, 74, 46, 29, 75, 47);
                    break;
                case 32:
                    numberOfErrorCorrectionBlocks = new Array(10, 74, 46, 23, 75, 47);
                    break;
                case 33:
                    numberOfErrorCorrectionBlocks = new Array(14, 74, 46, 21, 75, 47);
                    break;
                case 34:
                    numberOfErrorCorrectionBlocks = new Array(14, 74, 46, 23, 75, 47);
                    break;
                case 35:
                    numberOfErrorCorrectionBlocks = new Array(12, 75, 47, 26, 76, 48);
                    break;
                case 36:
                    numberOfErrorCorrectionBlocks = new Array(6, 75, 47, 34, 76, 48);
                    break;
                case 37:
                    numberOfErrorCorrectionBlocks = new Array(29, 74, 46, 14, 75, 47);
                    break;
                case 38:
                    numberOfErrorCorrectionBlocks = new Array(13, 74, 46, 32, 75, 47);
                    break;
                case 39:
                    numberOfErrorCorrectionBlocks = new Array(40, 75, 47, 7, 76, 48);
                    break;
                case 40:
                    numberOfErrorCorrectionBlocks = new Array(18, 75, 47, 31, 76, 48);
                    break;
            }

            return numberOfErrorCorrectionBlocks;
        },

        /** 
         * Returns the end values based on qr version
         * @private
         */
        _getEnd: function () {
            var endValues = new Array(208, 359, 567, 807, 1079, 1383, 1568, 1936, 2336, 2768, 3232, 3728, 4256, 4651, 5243, 5867, 6523, 7211, 7931, 8683, 9252, 10068, 10916, 11796, 12708, 13652, 14628, 15371, 16411, 17483, 18587, 19723, 20891, 22091, 23008, 24272, 25568, 26896, 28256, 29648);
            return endValues[this.m_Version - 1];
        },

        /** 
         * Returns the data capacity based on QR version
         * @private
         */
        _getDataCapacity: function () {
            var dataCapacityValues = new Array(26, 44, 70, 100, 134, 172, 196, 242, 292, 346, 404, 466, 532, 581, 655, 733, 815, 901, 991, 1085, 1156, 1258, 1364, 1474, 1588, 1706, 1828, 1921, 2051, 2185, 2323, 2465, 2611, 2761, 2876, 3034, 3196, 3362, 3532, 3706);
            return dataCapacityValues[this.m_Version - 1];
        },

        /** 
         * @private
         */
        _getFormatInformation: function () {
            var formatInformation = new Array(1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1);
            return formatInformation;
        },

        /** 
         * Returns the QR version
         * @private
         */
        _getVersionInformation: function () {
            var versionInformation = new Array();
            switch (this.m_Version) {
                case 7:
                    versionInformation = new Array(0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0);
                    break;
                case 8:
                    versionInformation = new Array(0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0);
                    break;
                case 9:
                    versionInformation = new Array(1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0);
                    break;
                case 10:
                    versionInformation = new Array(1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0);
                    break;
                case 11:
                    versionInformation = new Array(0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0);
                    break;
                case 12:
                    versionInformation = new Array(0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0);
                    break;
                case 13:
                    versionInformation = new Array(1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0);
                    break;
                case 14:
                    versionInformation = new Array(1, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0);
                    break;
                case 15:
                    versionInformation = new Array(0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0);
                    break;
                case 16:
                    versionInformation = new Array(0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0);
                    break;
                case 17:
                    versionInformation = new Array(1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0);
                    break;
                case 18:
                    versionInformation = new Array(1, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0);
                    break;
                case 19:
                    versionInformation = new Array(0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 1, 0);
                    break;
                case 20:
                    versionInformation = new Array(0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0);
                    break;
                case 21:
                    versionInformation = new Array(1, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0);
                    break;
                case 22:
                    versionInformation = new Array(1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 1, 0);
                    break;
                case 23:
                    versionInformation = new Array(0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0);
                    break;
                case 24:
                    versionInformation = new Array(0, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0);
                    break;
                case 25:
                    versionInformation = new Array(1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0);
                    break;
                case 26:
                    versionInformation = new Array(1, 1, 0, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 0);
                    break;
                case 27:
                    versionInformation = new Array(0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0);
                    break;
                case 28:
                    versionInformation = new Array(0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0);
                    break;
                case 29:
                    versionInformation = new Array(1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0);
                    break;
                case 30:
                    versionInformation = new Array(1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 1, 1, 0);
                    break;
                case 31:
                    versionInformation = new Array(0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0);
                    break;
                case 32:
                    versionInformation = new Array(1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1);
                    break;
                case 33:
                    versionInformation = new Array(0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1);
                    break;
                case 34:
                    versionInformation = new Array(0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1);
                    break;
                case 35:
                    versionInformation = new Array(1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 1);
                    break;
                case 36:
                    versionInformation = new Array(1, 1, 0, 1, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1);
                    break;
                case 37:
                    versionInformation = new Array(0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1);
                    break;
                case 38:
                    versionInformation = new Array(0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 1);
                    break;
                case 39:
                    versionInformation = new Array(1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1);
                    break;
                case 40:
                    versionInformation = new Array(1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1);
                    break;
            }

            return versionInformation;
        },

        /** 
         * Returns the code points of the text
         * @private
         */
        _getStringCodePoints: (function () {
            function surrogatePairToCodePoint(charCode1, charCode2) {
                return ((charCode1 & 0x3FF) << 10) + (charCode2 & 0x3FF) + 0x10000;
            }

            /** Read string in character by character and create an array of code points.*/
            return function (str) {
                var codePoints = [], i = 0, charCode;
                while (i < str.length) {
                    charCode = str.charCodeAt(i);
                    if ((charCode & 0xF800) == 0xD800)
                        codePoints.push(surrogatePairToCodePoint(charCode, str.charCodeAt(++i)));
                    else
                        codePoints.push(charCode);
                    ++i;
                }
                return codePoints;
            }
        })(),

        /** 
         * Creates 2 dimensional array.
         * @private
         */
        _create2DArray: function (rows, columns) {
            rows = parseInt(rows);
            columns = parseInt(columns);
            var twoDArray = new Array(rows);

            for (var i = 0; i < rows; i++)
                twoDArray[i] = new Array(columns);

            return twoDArray;
        },

        /** 
         * Builds datamatrix barcode.
         * @private
         */
        _buildDataMatrix: function () {
            var symbolAttributes = [[10, 10, 1, 1, 3, 5, 1, 3], [12, 12, 1, 1, 5, 7, 1, 5], [14, 14, 1, 1, 8, 10, 1, 8], [16, 16, 1, 1, 12, 12, 1, 12], [18, 18, 1, 1, 18, 14, 1, 18], [20, 20, 1, 1, 22, 18, 1, 22], [22, 22, 1, 1, 30, 20, 1, 30], [24, 24, 1, 1, 36, 24, 1, 36], [26, 26, 1, 1, 44, 28, 1, 44], [32, 32, 2, 2, 62, 36, 1, 62], [36, 36, 2, 2, 86, 42, 1, 86], [40, 40, 2, 2, 114, 48, 1, 114], [44, 44, 2, 2, 144, 56, 1, 144], [48, 48, 2, 2, 174, 68, 1, 174], [52, 52, 2, 2, 204, 84, 2, 102], [64, 64, 4, 4, 280, 112, 2, 140], [72, 72, 4, 4, 368, 144, 4, 92], [80, 80, 4, 4, 456, 192, 4, 114], [88, 88, 4, 4, 576, 224, 4, 144], [96, 96, 4, 4, 696, 272, 4, 174], [104, 104, 4, 4, 816, 336, 6, 136], [120, 120, 6, 6, 1050, 408, 6, 175], [132, 132, 6, 6, 1304, 496, 8, 163], [144, 144, 6, 6, 1558, 620, 10, 156], [8, 18, 1, 1, 5, 7, 1, 5], [8, 32, 2, 1, 10, 11, 1, 10], [12, 26, 1, 1, 16, 14, 1, 16], [12, 36, 2, 1, 22, 18, 1, 22], [16, 36, 2, 1, 32, 24, 1, 32], [16, 48, 2, 1, 49, 28, 1, 49]];
            var codeWords = this._getStringCodePoints(this.Model.text);
            var correctionCodewords;
            var symAttr;

            /** ASCII Encoder.*/
            var encodedPoints = new Array(); var n = 0;
            for (var e = 0; e < codeWords.length; e++) {
                if (codeWords[e] < 127)
                    encodedPoints[n] = codeWords[e] + 1;
                else {
                    encodedPoints[n++] = 235;
                    encodedPoints[n] = codeWords[e] - 127;
                }
                n++;
            }

            /** Find symbol attribute.*/
            for (var e = 0; e < symbolAttributes.length; e++) {
                if (symbolAttributes[e][4] >= codeWords.length) {
                    symAttr = symbolAttributes[e];
                    break;
                }
            }

            if (symAttr[4] > encodedPoints.length) { //pad codewords
                var l = encodedPoints.length;
                var temp = new Array(symAttr[4]);
                var t = 0;

                for (var i = 0; i < l; i++)
                    temp[i] = encodedPoints[i];

                if (l < (symAttr[4] + 1))
                    temp[l] = 129; // denotes padding.

                l++;
                while (l < symAttr[4]) {	// more padding
                    var v = 129 + (((l + 1) * 149) % 253) + 1;
                    if (v > 254)
                        v -= 254;
                    temp[l++] = v;
                }

                encodedPoints = temp;
            }

            correctionCodewords = symAttr[5];
            var errCorrArray = this._errorCorrection(correctionCodewords, encodedPoints);

            var finalCodeWord = encodedPoints.concat(errCorrArray);
            var dataMatrixArray = this._createMatrix(finalCodeWord, symAttr);

            var w = dataMatrixArray.length * this.Model.xDimension;
            var h = dataMatrixArray[0].length * this.Model.xDimension;         

            this.contextEl.beginPath();
            this.contextEl.fillStyle = 'white';
            this.contextEl.fillRect(0, 0, w, h);
            this.contextEl.closePath();

            /** Draw DataMatrix.*/
            this._drawDataMatrix(dataMatrixArray, w, h);
        },

        /** 
         * Draws datamatrix barcode.
         * @private
         */
        _drawDataMatrix: function (dmArray, w, h) {
            
            var dim = parseInt(this.Model.xDimension);
            
            if(dmArray.length == dmArray[0].length && this.Model.height != "" && this.Model.width != "")
            {
                this.Model.height = this._getProperValue(this.Model.height);
                this.Model.width = this._getProperValue(this.Model.width);
            
                var dimension = Math.min(this.Model.width, this.Model.height);
            
                dim = dimension / dmArray.length;
            }
			else
			{
			this.Model.height = h;
			this.Model.width = w;
		    this.canvasEl[0].setAttribute("width", this.Model.width);
           this.BarcodeEl.css("width", this.Model.width);
			this.canvasEl[0].setAttribute("height", this.Model.height);
           this.BarcodeEl.css("height", this.Model.height);
			}
			
            var y = 0;

            this.contextEl.beginPath();

            for (var i = 0; i < dmArray.length; i++) {
                var x = 0;
                for (var j = 0; j < dmArray[i].length; j++) {
                    var colorBrush = null;
                    if (dmArray[i][j] == 1)
                        colorBrush = this.model.darkBarColor;
						else
						colorBrush = this.model.lightBarColor;
                    this.contextEl.fillStyle = colorBrush;
                    this.contextEl.fillRect(x, y, dim, dim)
                    x += dim;
                }
                y += dim;
            }

            this.contextEl.closePath();
            this.contextEl.stroke();
        },

        /** 
         * Creates matrix.
         * @private
         */
        _createMatrix: function (codeWord, symAttr) {
            var x, y, NC, NR;
            var places = new Array();

            var W = symAttr[1], H = symAttr[0];
            var FW = W / symAttr[2], FH = H / symAttr[3];

            NC = W - 2 * (W / FW);
            NR = H - 2 * (H / FH);

            var places = new Array(NC * NR);
            this._ecc200placement(places, NR, NC);
            var matrix = new Array(W * H);

            for (var i = 0; i < matrix.length; i++)
                matrix[i] = 0;

            for (y = 0; y < H; y += FH) {
                for (x = 0; x < W; x++)
                    matrix[parseInt(y * W) + x] = 1;
                for (x = 0; x < W; x += 2)
                    matrix[parseInt((y + FH - 1) * W) + x] = 1;
            }
            for (x = 0; x < W; x += FW) {
                for (y = 0; y < H; y++)
                    matrix[parseInt(y * W) + x] = 1;
                for (y = 0; y < H; y += 2)
                    matrix[parseInt(y * W) + x + FW - 1] = 1;
            }
            for (y = 0; y < NR; y++) {
                for (x = 0; x < NC; x++) {
                    var v = places[((NR - y - 1) * NC) + x];
                    if (v == 1 || v > 7 && (codeWord[(v >> 3) - 1] & (1 << (v & 7))) != 0) {
                        var inde = parseInt((parseInt(1 + y + (2 * parseInt(y / (FH - 2)))) * W) + 1 + x + +(2 * parseInt(x / (FW - 2))));
                        matrix[inde] = 1;
                    }
                }
            }

            var _w = symAttr[1], _h = symAttr[0];

            var tempArray = this._create2DArray(_w, _h);

            for (var x1 = 0; x1 < _w; x1++) {
                for (var y1 = 0; y1 < _h; y1++) {
                    tempArray[x1][y1] = matrix[(_w * y1) + x1];
                }
            }

            /** Rotate the array left.*/
            var tempArray2 = this._create2DArray(_h, _w);

            for (var i = 0; i < _h; i++) {
                for (var j = 0; j < _w; j++) {
                    tempArray2[_h - 1 - i][j] = tempArray[j][i];
                }
            }

            var w = symAttr[0] + (this.Model.quietZone.top + this.Model.quietZone.bottom);
            var h = symAttr[1] + (this.Model.quietZone.left + this.Model.quietZone.right);
            var quietZone = this.Model.quietZone.all;

            var dataMatrixArray = this._create2DArray(w, h);

            for (var i = 0; i < w; i++)
                for (var j = 0; j < h; j++)
                    dataMatrixArray[i][j] = 0;

            for (var i = quietZone; i < w - quietZone; i++) {
                for (var j = quietZone; j < h - quietZone; j++) {
                    dataMatrixArray[i][j] = tempArray2[i - quietZone][j - quietZone];
                }
            }

            return dataMatrixArray;
        },

        /** 
         * @private
         */
        _ecc200placement: function (array, NR, NC) {
            var r, c, p;
            // invalidate
            for (r = 0; r < NR; r++)
                for (c = 0; c < NC; c++)
                    array[r * NC + c] = 0;
            // start
            p = 1;
            r = 4;
            c = 0;
            do {
                // check corner
                if (r == NR && !(c != 0))
                    this._ecc200placementcornerA(array, NR, NC, p++);
                if ((r == NR - 2) && !(c != 0) && ((NC % 4) != 0))
                    this._ecc200placementcornerB(array, NR, NC, p++);
                if (r == NR - 2 && !(c != 0) && (NC % 8) == 4)
                    this._ecc200placementcornerC(array, NR, NC, p++);
                if (r == NR + 4 && c == 2 && !((NC % 8) != 0))
                    this._ecc200placementcornerD(array, NR, NC, p++);
                // up/right
                do {
                    if (r < NR && c >= 0 && !(array[r * NC + c] != 0)) {
                        this._ecc200placementblock(array, NR, NC, r, c, p++);
                    }
                    r -= 2;
                    c += 2;
                }
                while (r >= 0 && c < NC);
                r++;
                c += 3;
                // down/left
                do {
                    if (r > -1) {
                        if (c < NC && !(array[r * NC + c] != 0)) {
                            this._ecc200placementblock(array, NR, NC, r, c, p++);
                        }
                    }
                    r += 2;
                    c -= 2;
                }
                while (r < NR && c >= 0);
                r += 3;
                c++;
            }
            while (r < NR || c < NC);
            // unfilled corner
            if (!(array[NR * NC - 1] != 0))
                array[NR * NC - 1] = array[NR * NC - NC - 2] = 1;
        },

        /** 
         * @private
         */
        _ecc200placementcornerA: function (array, NR, NC, p) {
            this._ecc200placementbit(array, NR, NC, NR - 1, 0, p, 7);
            this._ecc200placementbit(array, NR, NC, NR - 1, 1, p, 6);
            this._ecc200placementbit(array, NR, NC, NR - 1, 2, p, 5);
            this._ecc200placementbit(array, NR, NC, 0, NC - 2, p, 4);
            this._ecc200placementbit(array, NR, NC, 0, NC - 1, p, 3);
            this._ecc200placementbit(array, NR, NC, 1, NC - 1, p, 2);
            this._ecc200placementbit(array, NR, NC, 2, NC - 1, p, 1);
            this._ecc200placementbit(array, NR, NC, 3, NC - 1, p, 0);
        },

        /** 
         * @private
         */
        _ecc200placementcornerB: function (array, NR, NC, p) {
            this._ecc200placementbit(array, NR, NC, NR - 3, 0, p, 7);
            this._ecc200placementbit(array, NR, NC, NR - 2, 0, p, 6);
            this._ecc200placementbit(array, NR, NC, NR - 1, 0, p, 5);
            this._ecc200placementbit(array, NR, NC, 0, NC - 4, p, 4);
            this._ecc200placementbit(array, NR, NC, 0, NC - 3, p, 3);
            this._ecc200placementbit(array, NR, NC, 0, NC - 2, p, 2);
            this._ecc200placementbit(array, NR, NC, 0, NC - 1, p, 1);
            this._ecc200placementbit(array, NR, NC, 1, NC - 1, p, 0);
        },

        /** 
         * @private
         */
        _ecc200placementcornerC: function (array, NR, NC, p) {
            this._ecc200placementbit(array, NR, NC, NR - 3, 0, p, 7);
            this._ecc200placementbit(array, NR, NC, NR - 2, 0, p, 6);
            this._ecc200placementbit(array, NR, NC, NR - 1, 0, p, 5);
            this._ecc200placementbit(array, NR, NC, 0, NC - 2, p, 4);
            this._ecc200placementbit(array, NR, NC, 0, NC - 1, p, 3);
            this._ecc200placementbit(array, NR, NC, 1, NC - 1, p, 2);
            this._ecc200placementbit(array, NR, NC, 2, NC - 1, p, 1);
            this._ecc200placementbit(array, NR, NC, 3, NC - 1, p, 0);
        },

        /** 
         * @private
         */
        _ecc200placementcornerD: function (array, NR, NC, p) {
            this._ecc200placementbit(array, NR, NC, NR - 1, 0, p, 7);
            this._ecc200placementbit(array, NR, NC, NR - 1, NC - 1, p, 6);
            this._ecc200placementbit(array, NR, NC, 0, NC - 3, p, 5);
            this._ecc200placementbit(array, NR, NC, 0, NC - 2, p, 4);
            this._ecc200placementbit(array, NR, NC, 0, NC - 1, p, 3);
            this._ecc200placementbit(array, NR, NC, 1, NC - 3, p, 2);
            this._ecc200placementbit(array, NR, NC, 1, NC - 2, p, 1);
            this._ecc200placementbit(array, NR, NC, 1, NC - 1, p, 0);
        },

        /** 
         * @private
         */
        _ecc200placementblock: function (array, NR, NC, r, c, p) {
            this._ecc200placementbit(array, NR, NC, r - 2, c - 2, p, 7);
            this._ecc200placementbit(array, NR, NC, r - 2, c - 1, p, 6);
            this._ecc200placementbit(array, NR, NC, r - 1, c - 2, p, 5);
            this._ecc200placementbit(array, NR, NC, r - 1, c - 1, p, 4);
            this._ecc200placementbit(array, NR, NC, r - 1, c - 0, p, 3);
            this._ecc200placementbit(array, NR, NC, r - 0, c - 2, p, 2);
            this._ecc200placementbit(array, NR, NC, r - 0, c - 1, p, 1);
            this._ecc200placementbit(array, NR, NC, r - 0, c - 0, p, 0);
        },

        /** 
         * @private
         */
        _ecc200placementbit: function (array, NR, NC, r, c, p, b) {
            if (r < 0) {
                r += NR;
                c += 4 - ((NR + 4) % 8);
            }
            if (c < 0) {
                c += NC;
                r += 4 - ((NC + 4) % 8);
            }
            array[r * NC + c] = (p << 3) + b;
        },

        /** 
         * Adds error correction codeword.
         * @private
         */
        _errorCorrection: function (num, codeWords) {
            var i, k, index = 1;
            var rsPolynomial;
            var temp = new Array(num + 1);

            /** Create log array.*/
            {
                var m_log = new Array(256);
                var m_aLog = new Array(256);

                m_log[0] = -255;
                m_aLog[0] = 1;

                for (var i = 1; i <= 255; i++) {
                    m_aLog[i] = m_aLog[i - 1] * 2;

                    if (m_aLog[i] >= 256)
                        m_aLog[i] = m_aLog[i] ^ 301;

                    m_log[m_aLog[i]] = i;
                }
            }

            /** CreateRSPolynomial.*/
            temp[0] = 1;
            for (i = 1; i <= num; i++) {
                temp[i] = 1;
                for (k = i - 1; k > 0; k--) {
                    if (temp[k] != 0)
                        temp[k] = m_aLog[(m_log[temp[k]] + index) % 255];
                    temp[k] ^= temp[k - 1];
                }
                temp[0] = m_aLog[(m_log[temp[0]] + index) % 255];
                index++;
            }

            rsPolynomial = new Array(num);
            for (var e = 0; e < rsPolynomial.length; e++)
                rsPolynomial[e] = temp[e];

            var t = 0;

            /** Create error correction array.*/
            var errCorrArray = new Array(num);

            for (var i = 0; i < num; i++)
                errCorrArray[i] = 0;

            for (var i = 0; i < codeWords.length; i++) {
                t = errCorrArray[num - 1] ^ codeWords[i];
                for (var j = num - 1; j > 0; j--) {
                    if (t != 0 && rsPolynomial[j] != 0)
                        errCorrArray[j] = (errCorrArray[j - 1] ^ m_aLog[(m_log[t] + m_log[rsPolynomial[j]]) % 255]);
                    else
                        errCorrArray[j] = errCorrArray[j - 1];
                }
                if (t != 0 && rsPolynomial[0] != 0)
                    errCorrArray[0] = (m_aLog[(m_log[t] + m_log[rsPolynomial[0]]) % 255]);
                else
                    errCorrArray[0] = 0;
            }

            errCorrArray = errCorrArray.reverse();
            return errCorrArray;
        },

        /** 
         * Validates the text against the barcode type.
         * @private
         */
        _validateText: function (str, exp) {
            var patt = new RegExp(exp);
            return patt.test(str);
        },

        /** 
         * @private
         */
        _getCharWidth: function (encodedText, symbolTable) {
            var charW = 0;
            var intercharacterGap = this.Model.narrowBarWidth;
            var charArray = encodedText.split("");
            for (var e = 0; e < charArray.length; e++)
                charW = charW + intercharacterGap + this._getWidth(symbolTable, charArray[e]);

            return charW;
        },

        /** 
         * @private
         */
        _getWidth: function (symbolTable, c) {
            var check = false;
            var wid = 0;
            var continuous;
            for (var e = 0; e < symbolTable.length; e++) {
                if (symbolTable[e][0] == c) {
                    var bars = symbolTable[e][2];
                    for (var i = 0; i < bars.length; i++) {
                        if (check == false) {
                            if (bars.length % 2 != 0)
                                continuous = true;
                        }

                        wid = wid + (bars[i] * this.Model.narrowBarWidth);
                        check = true;
                    }
                    return wid;
                }
            }
            return wid;
        },

        /** 
         * Draws 1 dimensional barcode.
         * @private
         */
        _draw1DBarcode: function (encodedText, symbolTable, w) {
            if (symbolTable.length > 0) {
                var charArray = encodedText.split("");
                var left = this.Model.quietZone.left;
                var top = this.Model.quietZone.top;

                var textSize = parseInt(this.textFont.size.replace('px', ''));
				if(this.Model.height == "" && this.Model.width == "")
				{
				this.Model.height = top + this.Model.barHeight + this.Model.quietZone.bottom;
				this.Model.width = w;
                if (this.Model.displayText) {
                    this.Model.height += (textSize + this.Model.barcodeToTextGapHeight);
                }
				 this.canvasEl[0].setAttribute("width", this.Model.width);
                this.BarcodeEl.css("width", this.Model.width);
                this.canvasEl[0].setAttribute("height", this.Model.height);
                this.BarcodeEl.css("height", this.Model.height);
				}
				
                var wid = this.Model.width;
                var hei = this.Model.height;

                //find number of bars here
                var totalBars = 0;
                for (var e = 0; e < charArray.length; e++) {
                    for (var h = 0; h < symbolTable.length; h++) {
                        if (symbolTable[h][0] == charArray[e]) {
                            var bars = symbolTable[h][2];
                            for (var i = 0; i < bars.length; i++) {
                                var barWidth = bars[i] * this.Model.narrowBarWidth;
                                totalBars += bars[i];
                                
                            }
                            if (bars.length % 2 != 0)
                              totalBars++;
                        }
                    }
                }
                
                var narrowBarWid = (this._getProperValue(this.Model.width) - this.Model.quietZone.right - this.Model.quietZone.left) / (totalBars);
                if (narrowBarWid < 1) {
                    narrowBarWid = 1;
                }
                this.Model.narrowBarWidth = Math.floor(narrowBarWid);
                // return the decimal value of narrobarwidth.
                var decimalValue = (narrowBarWid % 1).toFixed(3);
                var totalBarsWidth = totalBars * decimalValue;
                left = parseInt(this.model.quietZone.left) + Math.round(totalBarsWidth / 2);
          
                this.model.barHeight = this._getProperValue(this.Model.height) - this.Model.quietZone.top - this.Model.quietZone.bottom -(textSize + this.Model.barcodeToTextGapHeight);
                if (this.model.barHeight < 0) this.model.barHeight = 0;
                var intercharacterGap = this.Model.narrowBarWidth;
                this.contextEl.fillStyle = 'white';
                this.contextEl.fillRect(0, 0, wid, hei);

                for (var e = 0; e < charArray.length; e++) {
                    for (var h = 0; h < symbolTable.length; h++) {
                        if (symbolTable[h][0] == charArray[e]) {
                            var bars = symbolTable[h][2];
                            if (this.model.symbologyType == "upcbarcode") {
                                for (var i = 0; i < bars.length; i++) {
                                    var barWidth = bars[i] * this.Model.narrowBarWidth;
                                    if (e > 1 && e <= 7) {
                                       
                                        if (i % 2 != 0) {

                                            this.contextEl.beginPath();
                                            this.contextEl.fillStyle = this.Model.darkBarColor;
                                            this.contextEl.fillRect(left, top, barWidth, this.Model.barHeight)
                                            this.contextEl.closePath();
                                        }                                      
                                    }
                                    else 
                                    {
                                        if(i % 2 == 0)
                                        {
                                            this.contextEl.beginPath();
                                            this.contextEl.fillStyle = this.Model.darkBarColor;
                                            this.contextEl.fillRect(left, top, barWidth, this.Model.barHeight)
                                            this.contextEl.closePath();
                                        }
                                        else {
                                           
                                                this.contextEl.beginPath();
                                                this.contextEl.fillStyle = this.model.lightBarColor;
                                                this.contextEl.fillRect(left, top, barWidth, this.model.barHeight);
                                          
                                        }
                                    }                                  
                                    left += barWidth;
                                    if(e == 1&& i==bars.length-1)
                                    {
                                        left -= barWidth;
                                    }
                                   
                                }
                            }
                            else {
                                for (var i = 0; i < bars.length; i++) {
                                    var barWidth = bars[i] * this.Model.narrowBarWidth;
                                    if (i % 2 == 0) {
                                        this.contextEl.beginPath();
                                        this.contextEl.fillStyle = this.Model.darkBarColor;
                                        this.contextEl.fillRect(left, top, barWidth, this.Model.barHeight)
                                        this.contextEl.closePath();
                                    }
                                    else {
                                        this.contextEl.beginPath();
                                        this.contextEl.fillStyle = this.model.lightBarColor;
                                        this.contextEl.fillRect(left, top, barWidth, this.model.barHeight);
                                        this.contextEl.closePath();
                                    }
                                    left += barWidth;                  
                                }
                            }
                            if (bars.length % 2 != 0 || this.model.symbologyType=="upcbarcode" && e==7)
                                left += intercharacterGap;
                        }
                    }
                }

                

                //this.Model.width = left += (this.Model.quietZone.right);

                /** Draws text for 1D barcodes.*/
                if (this.Model.displayText) {
                    var txtF = (this.textFont.fontStyle.toLowerCase() == "regular") ? "" : +this.textFont.fontStyle.toLowerCase() + " ";
                    txtF += this.textFont.size + " " + this.textFont.fontFamily.toLowerCase() + ",sans-serif";
                    this.contextEl.font = txtF;

                    var textWidth = 0;
                    textWidth = this.contextEl.measureText(this.Model.text).width;
                    if (this.Model.width < textWidth) {
                        //this.Model.width = textWidth;
                        this.canvasEl[0].setAttribute("width", this.Model.width);
                        this.BarcodeEl.css("width", this.Model.width);
                    }

                    this.contextEl.beginPath();
                    this.contextEl.fillStyle = this.Model.textColor;
                    this.contextEl.textAlign = "center";
                    hei = hei - textSize + textSize / 2;
                    if (this.model.symbologyType == "upcbarcode")
                    {
                        var data = encodedText.split("");
                        var txt = '';
                        for (var k = 0; k < data.length; k++)
                        {
                            if (k > 1 && k <= 7 || (k > 8 && k <= 14))
                                txt += data[k];
                        }
                        this.contextEl.fillText(txt, (this.Model.width / 2), hei);
                    }
                    else
                    this.contextEl.fillText(this.Model.text, (this.Model.width / 2), hei);
                    this.contextEl.closePath();
                    this.contextEl.stroke();
                }
            }
        }
    });

    /**
     * Enum for Symbol type.
	 * @enum {string}
     * @global
     */
    ej.datavisualization.Barcode.SymbologyType = {
        /** Specifies Code 39 Barcode. */
        code39: "code39",
        /** Specifies Code 39 Extended Barcode. */
        code39Extended: "code39extended",
        /** Specifies Code 11 Barcode. */
        code11: "code11",
        /** Specifies Codabar Barcode. */
        codabar: "codabar",
        /** Specifies Code 32 Barcode. */
        code32: "code32",
        /** Specifies Code 93 Barcode. */
        code93: "code93",
        /** Specifies Code 93 Extended Barcode. */
        code93Extended: "code93extended",
        /** Specifies Code 128 A Barcode. */
        code128A: "code128a",
        /** Specifies Code 128 B Barcode. */
        code128B: "code128b",
        /** Specifies Code 128 C Barcode. */
        code128C: "code128c",
        /** Specifies DataMatrix Barcode. */
        dataMatrix: "datamatrix",
        /** Specifies QR Barcode. */
        qrBarcode: "qrbarcode",
        /** Specifies UPC-A Barcode. */
        upca:"upcbarcode"
    };

    /**
     * Enum for Symbol type.
     * @readonly
     * @private
     */
    ej.datavisualization.Barcode.symbologySettings = {
        /** Specifies symbology settinngs for the Code 39 Barcode. */
        code39: {
            startSymbol: '*',
            stopSymbol: '*',
            validatorExp: "^[\x41-\x5A\x30-\x39\-\.\$\/\+\%\ ]+$",
            symbolTable: [["0", 0, [1, 1, 1, 3, 3, 1, 3, 1, 1]], ["1", 1, [3, 1, 1, 3, 1, 1, 1, 1, 3]], ["2", 2, [1, 1, 3, 3, 1, 1, 1, 1, 3]], ["3", 3, [3, 1, 3, 3, 1, 1, 1, 1, 1]], ["4", 4, [1, 1, 1, 3, 3, 1, 1, 1, 3]], ["5", 5, [3, 1, 1, 3, 3, 1, 1, 1, 1]], ["6", 6, [1, 1, 3, 3, 3, 1, 1, 1, 1]], ["7", 7, [1, 1, 1, 3, 1, 1, 3, 1, 3]], ["8", 8, [3, 1, 1, 3, 1, 1, 3, 1, 1]], ["9", 9, [1, 1, 3, 3, 1, 1, 3, 1, 1]], ["A", 10, [3, 1, 1, 1, 1, 3, 1, 1, 3]], ["B", 11, [1, 1, 3, 1, 1, 3, 1, 1, 3]], ["C", 12, [3, 1, 3, 1, 1, 3, 1, 1, 1]], ["D", 13, [1, 1, 1, 1, 3, 3, 1, 1, 3]], ["E", 14, [3, 1, 1, 1, 3, 3, 1, 1, 1]], ["F", 15, [1, 1, 3, 1, 3, 3, 1, 1, 1]], ["G", 16, [1, 1, 1, 1, 1, 3, 3, 1, 3]], ["H", 17, [3, 1, 1, 1, 1, 3, 3, 1, 1]], ["I", 18, [1, 1, 3, 1, 1, 3, 3, 1, 1]], ["J", 19, [1, 1, 1, 1, 3, 3, 3, 1, 1]], ["K", 20, [3, 1, 1, 1, 1, 1, 1, 3, 3]], ["L", 21, [1, 1, 3, 1, 1, 1, 1, 3, 3]], ["M", 22, [3, 1, 3, 1, 1, 1, 1, 3, 1]], ["N", 23, [1, 1, 1, 1, 3, 1, 1, 3, 3]], ["O", 24, [3, 1, 1, 1, 3, 1, 1, 3, 1]], ["P", 25, [1, 1, 3, 1, 3, 1, 1, 3, 1]], ["Q", 26, [1, 1, 1, 1, 1, 1, 3, 3, 3]], ["R", 27, [3, 1, 1, 1, 1, 1, 3, 3, 1]], ["S", 28, [1, 1, 3, 1, 1, 1, 3, 3, 1]], ["T", 29, [1, 1, 1, 1, 3, 1, 3, 3, 1]], ["U", 30, [3, 3, 1, 1, 1, 1, 1, 1, 3]], ["V", 31, [1, 3, 3, 1, 1, 1, 1, 1, 3]], ["W", 32, [3, 3, 3, 1, 1, 1, 1, 1, 1]], ["X", 33, [1, 3, 1, 1, 3, 1, 1, 1, 3]], ["Y", 34, [3, 3, 1, 1, 3, 1, 1, 1, 1]], ["Z", 35, [1, 3, 3, 1, 3, 1, 1, 1, 1]], ["-", 36, [1, 3, 1, 1, 1, 1, 3, 1, 3]], [".", 37, [3, 3, 1, 1, 1, 1, 3, 1, 1]], [" ", 38, [1, 3, 3, 1, 1, 1, 3, 1, 1]], ["$", 39, [1, 3, 1, 3, 1, 3, 1, 1, 1]], ["/", 40, [1, 3, 1, 3, 1, 1, 1, 3, 1]], ["+", 41, [1, 3, 1, 1, 1, 3, 1, 3, 1]], ["%", 42, [1, 1, 1, 3, 1, 3, 1, 3, 1]], ["*", 0, [1, 3, 1, 1, 3, 1, 3, 1, 1]]]
        },
        /** Specifies symbology settings for the Code 39 Extended Barcode. */
        code39extended: {
            startSymbol: '*',
            stopSymbol: '*',
            validatorExp: "^[\x00-\x7F]+$",
            symbolTable: [["0", 0, [1, 1, 1, 3, 3, 1, 3, 1, 1]], ["1", 1, [3, 1, 1, 3, 1, 1, 1, 1, 3]], ["2", 2, [1, 1, 3, 3, 1, 1, 1, 1, 3]], ["3", 3, [3, 1, 3, 3, 1, 1, 1, 1, 1]], ["4", 4, [1, 1, 1, 3, 3, 1, 1, 1, 3]], ["5", 5, [3, 1, 1, 3, 3, 1, 1, 1, 1]], ["6", 6, [1, 1, 3, 3, 3, 1, 1, 1, 1]], ["7", 7, [1, 1, 1, 3, 1, 1, 3, 1, 3]], ["8", 8, [3, 1, 1, 3, 1, 1, 3, 1, 1]], ["9", 9, [1, 1, 3, 3, 1, 1, 3, 1, 1]], ["A", 10, [3, 1, 1, 1, 1, 3, 1, 1, 3]], ["B", 11, [1, 1, 3, 1, 1, 3, 1, 1, 3]], ["C", 12, [3, 1, 3, 1, 1, 3, 1, 1, 1]], ["D", 13, [1, 1, 1, 1, 3, 3, 1, 1, 3]], ["E", 14, [3, 1, 1, 1, 3, 3, 1, 1, 1]], ["F", 15, [1, 1, 3, 1, 3, 3, 1, 1, 1]], ["G", 16, [1, 1, 1, 1, 1, 3, 3, 1, 3]], ["H", 17, [3, 1, 1, 1, 1, 3, 3, 1, 1]], ["I", 18, [1, 1, 3, 1, 1, 3, 3, 1, 1]], ["J", 19, [1, 1, 1, 1, 3, 3, 3, 1, 1]], ["K", 20, [3, 1, 1, 1, 1, 1, 1, 3, 3]], ["L", 21, [1, 1, 3, 1, 1, 1, 1, 3, 3]], ["M", 22, [3, 1, 3, 1, 1, 1, 1, 3, 1]], ["N", 23, [1, 1, 1, 1, 3, 1, 1, 3, 3]], ["O", 24, [3, 1, 1, 1, 3, 1, 1, 3, 1]], ["P", 25, [1, 1, 3, 1, 3, 1, 1, 3, 1]], ["Q", 26, [1, 1, 1, 1, 1, 1, 3, 3, 3]], ["R", 27, [3, 1, 1, 1, 1, 1, 3, 3, 1]], ["S", 28, [1, 1, 3, 1, 1, 1, 3, 3, 1]], ["T", 29, [1, 1, 1, 1, 3, 1, 3, 3, 1]], ["U", 30, [3, 3, 1, 1, 1, 1, 1, 1, 3]], ["V", 31, [1, 3, 3, 1, 1, 1, 1, 1, 3]], ["W", 32, [3, 3, 3, 1, 1, 1, 1, 1, 1]], ["X", 33, [1, 3, 1, 1, 3, 1, 1, 1, 3]], ["Y", 34, [3, 3, 1, 1, 3, 1, 1, 1, 1]], ["Z", 35, [1, 3, 3, 1, 3, 1, 1, 1, 1]], ["-", 36, [1, 3, 1, 1, 1, 1, 3, 1, 3]], [".", 37, [3, 3, 1, 1, 1, 1, 3, 1, 1]], [" ", 38, [1, 3, 3, 1, 1, 1, 3, 1, 1]], ["$", 39, [1, 3, 1, 3, 1, 3, 1, 1, 1]], ["/", 40, [1, 3, 1, 3, 1, 1, 1, 3, 1]], ["+", 41, [1, 3, 1, 1, 1, 3, 1, 3, 1]], ["%", 42, [1, 1, 1, 3, 1, 3, 1, 3, 1]], ["*", 0, [1, 3, 1, 1, 3, 1, 3, 1, 1]]],
            extendedCodes: [['\0', ['%', 'U']], [String.fromCharCode(parseInt('0001', 16)), ['$', 'A']], [String.fromCharCode(parseInt('0002', 16)), ['$', 'B']], [String.fromCharCode(parseInt('0003', 16)), ['$', 'C']], [String.fromCharCode(parseInt('0004', 16)), ['$', 'D']], [String.fromCharCode(parseInt('0005', 16)), ['$', 'E']], [String.fromCharCode(parseInt('0006', 16)), ['$', 'F']], ['\a', ['$', 'G']], ['\b', ['$', 'H']], ['\t', ['$', 'I']], ['\n', ['$', 'J']], ['\v', ['$', 'K']], ['\f', ['$', 'L']], ['\r', ['$', 'M']], [String.fromCharCode(parseInt('000e', 16)), ['$', 'N']], [String.fromCharCode(parseInt('000f', 16)), ['$', 'O']], [String.fromCharCode(parseInt('0010', 16)), ['$', 'P']], [String.fromCharCode(parseInt('0011', 16)), ['$', 'Q']], [String.fromCharCode(parseInt('0012', 16)), ['$', 'R']], [String.fromCharCode(parseInt('0013', 16)), ['$', 'S']], [String.fromCharCode(parseInt('0014', 16)), ['$', 'T']], [String.fromCharCode(parseInt('0015', 16)), ['$', 'U']], [String.fromCharCode(parseInt('0016', 16)), ['$', 'V']], [String.fromCharCode(parseInt('0017', 16)), ['$', 'W']], [String.fromCharCode(parseInt('0018', 16)), ['$', 'X']], [String.fromCharCode(parseInt('0019', 16)), ['$', 'Y']], [String.fromCharCode(parseInt('001a', 16)), ['$', 'Z']], [String.fromCharCode(parseInt('001b', 16)), ['%', 'A']], [String.fromCharCode(parseInt('001c', 16)), ['%', 'B']], [String.fromCharCode(parseInt('001d', 16)), ['%', 'C']], [String.fromCharCode(parseInt('001e', 16)), ['%', 'D']], [String.fromCharCode(parseInt('001f', 16)), ['%', 'E']], [' ', [' ']], ['!', ['/', 'A']], ['"', ['/', 'B']], ['#', ['/', 'C']], ['$', ['/', 'D']], ['%', ['/', 'E']], ['&', ['/', 'F']], ['\'', ['/', 'G']], ['(', ['/', 'H']], [')', ['/', 'I']], ['*', ['/', 'J']], ['+', ['/', 'K']], [',', ['/', 'L']], ['-', ['/', 'M']], ['.', ['/', 'N']], ['/', ['/', 'O']], ['0', ['0']], ['1', ['1']], ['2', ['2']], ['3', ['3']], ['4', ['4']], ['5', ['5']], ['6', ['6']], ['7', ['7']], ['8', ['8']], ['9', ['9']], [':', ['/', 'Z']], [';', ['%', 'F']], ['<', ['%', 'G']], ['=', ['%', 'H']], ['>', ['%', 'I']], ['?', ['%', 'J']], ['@', ['%', 'V']], ['A', ['A']], ['B', ['B']], ['C', ['C']], ['D', ['D']], ['E', ['E']], ['F', ['F']], ['G', ['G']], ['H', ['H']], ['I', ['I']], ['J', ['J']], ['K', ['K']], ['L', ['L']], ['M', ['M']], ['N', ['N']], ['O', ['O']], ['P', ['P']], ['Q', ['Q']], ['R', ['R']], ['S', ['S']], ['T', ['T']], ['U', ['U']], ['V', ['V']], ['W', ['W']], ['X', ['X']], ['Y', ['Y']], ['Z', ['Z']], ['[', ['%', 'K']], ['\\', ['%', 'L']], [']', ['%', 'M']], ['^', ['%', 'N']], ['_', ['%', 'O']], ['`', ['%', 'W']], ['a', ['+', 'A']], ['b', ['+', 'B']], ['c', ['+', 'C']], ['d', ['+', 'D']], ['e', ['+', 'E']], ['f', ['+', 'F']], ['g', ['+', 'G']], ['h', ['+', 'H']], ['i', ['+', 'I']], ['j', ['+', 'J']], ['k', ['+', 'K']], ['l', ['+', 'L']], ['m', ['+', 'M']], ['n', ['+', 'N']], ['o', ['+', 'O']], ['p', ['+', 'P']], ['q', ['+', 'Q']], ['r', ['+', 'R']], ['s', ['+', 'S']], ['t', ['+', 'T']], ['u', ['+', 'U']], ['v', ['+', 'V']], ['w', ['+', 'W']], ['x', ['+', 'X']], ['y', ['+', 'Y']], ['z', ['+', 'Z']], ['{', ['%', 'P']], ['|', ['%', 'Q']], ['}', ['%', 'R']], ['~', ['%', 'S']], [String.fromCharCode(parseInt('007f', 16)), ['%', 'T']]]
        },
        /** Specifies symbology settings for the Code 11 Barcode. */
        code11: {
            startSymbol: '*',
            stopSymbol: '*',
            validatorExp: "^[0-9\-]*$",
            symbolTable: [["0", 0, [1, 1, 1, 1, 2]], ["1", 1, [2, 1, 1, 1, 2]], ["2", 2, [1, 2, 1, 1, 2]], ["3", 3, [2, 2, 1, 1, 1]], ["4", 4, [1, 1, 2, 1, 2]], ["5", 5, [2, 1, 2, 1, 1]], ["6", 6, [1, 2, 2, 1, 1]], ["7", 7, [1, 1, 1, 2, 2]], ["8", 8, [2, 1, 1, 2, 1]], ["9", 9, [2, 1, 1, 1, 1]], ["-", 10, [1, 1, 2, 1, 1]], ["*", 0, [1, 1, 2, 2, 1]]]
        },
        /** Specifies symbology settings for the Codabar Barcode. */
        codabar: {
            startSymbol: 'A',
            stopSymbol: 'B',
            validatorExp: "^[0-9\-\.\$\/\:\+]*$",
            symbolTable: [["0", 0, [1, 1, 1, 1, 1, 2, 2]], ["1", 0, [1, 1, 1, 1, 2, 2, 1]], ["2", 0, [1, 1, 1, 2, 1, 1, 2]], ["3", 0, [2, 2, 1, 1, 1, 1, 1]], ["4", 0, [1, 1, 2, 1, 1, 2, 1]], ["5", 0, [2, 1, 1, 1, 1, 2, 1]], ["6", 0, [1, 2, 1, 1, 1, 1, 2]], ["7", 0, [1, 2, 1, 1, 2, 1, 1]], ["8", 0, [1, 2, 2, 1, 1, 1, 1]], ["9", 0, [2, 1, 1, 2, 1, 1, 1]], ["-", 0, [1, 1, 1, 2, 2, 1, 1]], ["$", 0, [1, 1, 2, 2, 1, 1, 1]], [":", 0, [2, 1, 1, 1, 2, 1, 2]], ["/", 0, [2, 1, 2, 1, 1, 1, 2]], [".", 0, [2, 1, 2, 1, 2, 1, 1]], ["+", 0, [1, 1, 2, 1, 2, 1, 2]], ["A", 0, [1, 1, 2, 2, 1, 2, 1]], ["B", 0, [1, 1, 1, 2, 1, 2, 2]]]
        },
        /** Specifies symbology settings for the Code 32 Barcode. */
        code32: {
            startSymbol: '*',
            stopSymbol: '*',
            validatorExp: "^[\x41-\x5A\x30-\x39\x20\-\*\.\$\/\+\%]+$",
            symbolTable: [["0", 0, [1, 1, 1, 3, 3, 1, 3, 1, 1]], ["1", 1, [3, 1, 1, 3, 1, 1, 1, 1, 3]], ["2", 2, [1, 1, 3, 3, 1, 1, 1, 1, 3]], ["3", 3, [3, 1, 3, 3, 1, 1, 1, 1, 1]], ["4", 4, [1, 1, 1, 3, 3, 1, 1, 1, 3]], ["5", 5, [3, 1, 1, 3, 3, 1, 1, 1, 1]], ["6", 6, [1, 1, 3, 3, 3, 1, 1, 1, 1]], ["7", 7, [1, 1, 1, 3, 1, 1, 3, 1, 3]], ["8", 8, [3, 1, 1, 3, 1, 1, 3, 1, 1]], ["9", 9, [1, 1, 3, 3, 1, 1, 3, 1, 1]], ["B", 10, [1, 1, 3, 1, 1, 3, 1, 1, 3]], ["C", 11, [3, 1, 3, 1, 1, 3, 1, 1, 1]], ["D", 12, [1, 1, 1, 1, 3, 3, 1, 1, 3]], ["F", 13, [1, 1, 3, 1, 3, 3, 1, 1, 1]], ["G", 14, [1, 1, 1, 1, 1, 3, 3, 1, 3]], ["H", 15, [3, 1, 1, 1, 1, 3, 3, 1, 1]], ["J", 0x10, [1, 1, 1, 1, 3, 3, 3, 1, 1]], ["K", 0x11, [3, 1, 1, 1, 1, 1, 1, 3, 3]], ["L", 0x12, [1, 1, 3, 1, 1, 1, 1, 3, 3]], ["M", 0x13, [3, 1, 3, 1, 1, 1, 1, 3, 1]], ["N", 20, [1, 1, 1, 1, 3, 1, 1, 3, 3]], ["P", 0x15, [1, 1, 3, 1, 3, 1, 1, 3, 1]], ["Q", 0x16, [1, 1, 1, 1, 1, 1, 3, 3, 3]], ["R", 0x17, [3, 1, 1, 1, 1, 1, 3, 3, 1]], ["S", 0x18, [1, 1, 3, 1, 1, 1, 3, 3, 1]], ["T", 0x19, [1, 1, 1, 1, 3, 1, 3, 3, 1]], ["U", 0x1a, [3, 3, 1, 1, 1, 1, 1, 1, 3]], ["V", 0x1b, [1, 3, 3, 1, 1, 1, 1, 1, 3]], ["W", 0x1c, [3, 3, 3, 1, 1, 1, 1, 1, 1]], ["X", 0x1d, [1, 3, 1, 1, 3, 1, 1, 1, 3]], ["Y", 30, [3, 3, 1, 1, 3, 1, 1, 1, 1]], ["Z", 0x1f, [1, 3, 3, 1, 3, 1, 1, 1, 1]], ["*", 0, [1, 3, 1, 1, 3, 1, 3, 1, 1]]]
        },
        /** Specifies symbology settings for the Code 93 Barcode. */
        code93: {
            startSymbol: '*',
            stopSymbol: String.fromCharCode(parseInt('00ff', 16)),
            validatorExp: "^[\x41-\x5A\x30-\x39\-\.\$\/\+\%\ ]+$",
            symbolTable: [["0", 0, [1, 3, 1, 1, 1, 2]], ["1", 1, [1, 1, 1, 2, 1, 3]], ["2", 2, [1, 1, 1, 3, 1, 2]], ["3", 3, [1, 1, 1, 4, 1, 1]], ["4", 4, [1, 2, 1, 1, 1, 2]], ["5", 5, [1, 2, 1, 2, 1, 2]], ["6", 6, [1, 2, 1, 3, 1, 1]], ["7", 7, [1, 1, 1, 1, 1, 4]], ["8", 8, [1, 3, 1, 2, 1, 1]], ["9", 9, [1, 4, 1, 1, 1, 1]], ["A", 10, [2, 1, 1, 1, 1, 3]], ["B", 11, [2, 1, 1, 2, 1, 2]], ["C", 12, [2, 1, 1, 3, 1, 1]], ["D", 13, [2, 2, 1, 1, 1, 2]], ["E", 14, [2, 2, 1, 2, 1, 1]], ["F", 15, [2, 3, 1, 1, 1, 1]], ["G", 0x10, [1, 1, 2, 1, 1, 3]], ["H", 0x11, [1, 1, 2, 2, 1, 2]], ["I", 0x12, [1, 1, 2, 3, 1, 1]], ["J", 0x13, [1, 2, 2, 1, 1, 2]], ["K", 20, [1, 3, 2, 1, 1, 1]], ["L", 0x15, [1, 1, 1, 1, 2, 3]], ["M", 0x16, [1, 1, 1, 2, 2, 2]], ["N", 0x17, [1, 1, 1, 3, 2, 1]], ["O", 0x18, [1, 2, 1, 1, 2, 2]], ["P", 0x19, [1, 3, 1, 1, 2, 1]], ["Q", 0x1a, [2, 1, 2, 1, 1, 2]], ["R", 0x1b, [2, 1, 2, 2, 1, 1]], ["S", 0x1c, [2, 1, 1, 1, 2, 2]], ["T", 0x1d, [2, 1, 1, 2, 2, 1]], ["U", 30, [2, 2, 1, 1, 2, 1]], ["V", 0x1f, [2, 2, 2, 1, 1, 1]], ["W", 0x20, [1, 1, 2, 1, 2, 2]], ["X", 0x21, [1, 1, 2, 2, 2, 1]], ["Y", 0x22, [1, 2, 2, 1, 2, 1]], ["Z", 0x23, [1, 2, 3, 1, 1, 1]], ["-", 0x24, [1, 2, 1, 1, 3, 1]], [".", 0x25, [3, 1, 1, 1, 1, 2]], [" ", 0x26, [3, 1, 1, 2, 1, 1]], ["$", 0x27, [3, 2, 1, 1, 1, 1]], ["/", 40, [1, 1, 2, 1, 3, 1]], ["+", 0x29, [1, 1, 3, 1, 2, 1]], ["%", 0x2a, [2, 1, 1, 1, 3, 1]], ["*", 0, [1, 1, 1, 1, 4, 1]], [String.fromCharCode(parseInt('00ff', 16)), 0, [1, 1, 1, 1, 4, 1, 1]], [String.fromCharCode(parseInt('00fb', 16)), 0x2b, [1, 2, 1, 2, 2, 0]], [String.fromCharCode(parseInt('00fc', 16)), 0x2c, [3, 1, 2, 1, 1, 1]], [String.fromCharCode(parseInt('00fd', 16)), 0x2d, [3, 1, 1, 1, 2, 1]], [String.fromCharCode(parseInt('00fe', 16)), 0x2e, [1, 2, 2, 2, 1, 1]]]
        },
        /** Specifies symbology settings for the Code 93 Extended Barcode. */
        code93extended: {
            startSymbol: '*',
            stopSymbol: String.fromCharCode(parseInt('00ff', 16)),
            validatorExp: "^[\x00-\x7F\x00fb\x00fd\x00fe\'þ'\'ü'\'ý']+$",
            symbolTable: [["0", 0, [1, 3, 1, 1, 1, 2]], ["1", 1, [1, 1, 1, 2, 1, 3]], ["2", 2, [1, 1, 1, 3, 1, 2]], ["3", 3, [1, 1, 1, 4, 1, 1]], ["4", 4, [1, 2, 1, 1, 1, 2]], ["5", 5, [1, 2, 1, 2, 1, 2]], ["6", 6, [1, 2, 1, 3, 1, 1]], ["7", 7, [1, 1, 1, 1, 1, 4]], ["8", 8, [1, 3, 1, 2, 1, 1]], ["9", 9, [1, 4, 1, 1, 1, 1]], ["A", 10, [2, 1, 1, 1, 1, 3]], ["B", 11, [2, 1, 1, 2, 1, 2]], ["C", 12, [2, 1, 1, 3, 1, 1]], ["D", 13, [2, 2, 1, 1, 1, 2]], ["E", 14, [2, 2, 1, 2, 1, 1]], ["F", 15, [2, 3, 1, 1, 1, 1]], ["G", 0x10, [1, 1, 2, 1, 1, 3]], ["H", 0x11, [1, 1, 2, 2, 1, 2]], ["I", 0x12, [1, 1, 2, 3, 1, 1]], ["J", 0x13, [1, 2, 2, 1, 1, 2]], ["K", 20, [1, 3, 2, 1, 1, 1]], ["L", 0x15, [1, 1, 1, 1, 2, 3]], ["M", 0x16, [1, 1, 1, 2, 2, 2]], ["N", 0x17, [1, 1, 1, 3, 2, 1]], ["O", 0x18, [1, 2, 1, 1, 2, 2]], ["P", 0x19, [1, 3, 1, 1, 2, 1]], ["Q", 0x1a, [2, 1, 2, 1, 1, 2]], ["R", 0x1b, [2, 1, 2, 2, 1, 1]], ["S", 0x1c, [2, 1, 1, 1, 2, 2]], ["T", 0x1d, [2, 1, 1, 2, 2, 1]], ["U", 30, [2, 2, 1, 1, 2, 1]], ["V", 0x1f, [2, 2, 2, 1, 1, 1]], ["W", 0x20, [1, 1, 2, 1, 2, 2]], ["X", 0x21, [1, 1, 2, 2, 2, 1]], ["Y", 0x22, [1, 2, 2, 1, 2, 1]], ["Z", 0x23, [1, 2, 3, 1, 1, 1]], ["-", 0x24, [1, 2, 1, 1, 3, 1]], [".", 0x25, [3, 1, 1, 1, 1, 2]], [" ", 0x26, [3, 1, 1, 2, 1, 1]], ["$", 0x27, [3, 2, 1, 1, 1, 1]], ["/", 40, [1, 1, 2, 1, 3, 1]], ["+", 0x29, [1, 1, 3, 1, 2, 1]], ["%", 0x2a, [2, 1, 1, 1, 3, 1]], ["*", 0, [1, 1, 1, 1, 4, 1]], [String.fromCharCode(parseInt('00ff', 16)), 0, [1, 1, 1, 1, 4, 1, 1]], [String.fromCharCode(parseInt('00fb', 16)), 0x2b, [1, 2, 1, 2, 2, 0]], [String.fromCharCode(parseInt('00fc', 16)), 0x2c, [3, 1, 2, 1, 1, 1]], [String.fromCharCode(parseInt('00fd', 16)), 0x2d, [3, 1, 1, 1, 2, 1]], [String.fromCharCode(parseInt('00fe', 16)), 0x2e, [1, 2, 2, 2, 1, 1]]],
            extendedCodes: [['\0', [String.fromCharCode(parseInt('00fc', 16)), 'U']], [String.fromCharCode(parseInt('0001', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'A']], [String.fromCharCode(parseInt('0002', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'B']], [String.fromCharCode(parseInt('0003', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'C']], [String.fromCharCode(parseInt('0004', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'D']], [String.fromCharCode(parseInt('0005', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'E']], [String.fromCharCode(parseInt('0006', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'F']], ['\a', [String.fromCharCode(parseInt('00fb', 16)), 'G']], ['\b', [String.fromCharCode(parseInt('00fb', 16)), 'H']], ['\t', [String.fromCharCode(parseInt('00fb', 16)), 'I']], ['\n', [String.fromCharCode(parseInt('00fb', 16)), 'J']], ['\v', [String.fromCharCode(parseInt('00fb', 16)), 'K']], ['\f', [String.fromCharCode(parseInt('00fb', 16)), 'L']], ['\r', [String.fromCharCode(parseInt('00fb', 16)), 'M']], [String.fromCharCode(parseInt('000e', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'N']], [String.fromCharCode(parseInt('000f', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'O']], [String.fromCharCode(parseInt('0010', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'P']], [String.fromCharCode(parseInt('0011', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'Q']], [String.fromCharCode(parseInt('0012', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'R']], [String.fromCharCode(parseInt('0013', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'S']], [String.fromCharCode(parseInt('0014', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'T']], [String.fromCharCode(parseInt('0015', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'U']], [String.fromCharCode(parseInt('0016', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'V']], [String.fromCharCode(parseInt('0017', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'W']], [String.fromCharCode(parseInt('0018', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'X']], [String.fromCharCode(parseInt('0019', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'Y']], [String.fromCharCode(parseInt('001a', 16)), [String.fromCharCode(parseInt('00fb', 16)), 'Z']], [String.fromCharCode(parseInt('001b', 16)), [String.fromCharCode(parseInt('00fc', 16)), 'A']], [String.fromCharCode(parseInt('001c', 16)), [String.fromCharCode(parseInt('00fc', 16)), 'B']], [String.fromCharCode(parseInt('001d', 16)), [String.fromCharCode(parseInt('00fc', 16)), 'C']], [String.fromCharCode(parseInt('001e', 16)), [String.fromCharCode(parseInt('00fc', 16)), 'D']], [String.fromCharCode(parseInt('001f', 16)), [String.fromCharCode(parseInt('00fc', 16)), 'E']], [' ', [' ']], ['!', [String.fromCharCode(parseInt('00fd', 16)), 'A']], ['"', [String.fromCharCode(parseInt('00fd', 16)), 'B']], ['#', [String.fromCharCode(parseInt('00fd', 16)), 'C']], ['$', [String.fromCharCode(parseInt('00fd', 16)), 'D']], ['%', [String.fromCharCode(parseInt('00fd', 16)), 'E']], ['&', [String.fromCharCode(parseInt('00fd', 16)), 'F']], ['\'', [String.fromCharCode(parseInt('00fd', 16)), 'G']], ['(', [String.fromCharCode(parseInt('00fd', 16)), 'H']], [')', [String.fromCharCode(parseInt('00fd', 16)), 'I']], ['*', [String.fromCharCode(parseInt('00fd', 16)), 'J']], ['+', [String.fromCharCode(parseInt('00fd', 16)), 'K']], [',', [String.fromCharCode(parseInt('00fd', 16)), 'L']], ['-', [String.fromCharCode(parseInt('00fd', 16)), 'M']], ['.', [String.fromCharCode(parseInt('00fd', 16)), 'N']], ['/', [String.fromCharCode(parseInt('00fd', 16)), 'O']], ['0', ['0']], ['1', ['1']], ['2', ['2']], ['3', ['3']], ['4', ['4']], ['5', ['5']], ['6', ['6']], ['7', ['7']], ['8', ['8']], ['9', ['9']], [':', [String.fromCharCode(parseInt('00fd', 16)), 'Z']], [';', [String.fromCharCode(parseInt('00fc', 16)), 'F']], ['<', [String.fromCharCode(parseInt('00fc', 16)), 'G']], ['=', [String.fromCharCode(parseInt('00fc', 16)), 'H']], ['>', [String.fromCharCode(parseInt('00fc', 16)), 'I']], ['?', [String.fromCharCode(parseInt('00fc', 16)), 'J']], ['@', [String.fromCharCode(parseInt('00fc', 16)), 'V']], ['A', ['A']], ['B', ['B']], ['C', ['C']], ['D', ['D']], ['E', ['E']], ['F', ['F']], ['G', ['G']], ['H', ['H']], ['I', ['I']], ['J', ['J']], ['K', ['K']], ['L', ['L']], ['M', ['M']], ['N', ['N']], ['O', ['O']], ['P', ['P']], ['Q', ['Q']], ['R', ['R']], ['S', ['S']], ['T', ['T']], ['U', ['U']], ['V', ['V']], ['W', ['W']], ['X', ['X']], ['Y', ['Y']], ['Z', ['Z']], ['[', [String.fromCharCode(parseInt('00fc', 16)), 'K']], ['\\', [String.fromCharCode(parseInt('00fc', 16)), 'L']], [']', [String.fromCharCode(parseInt('00fc', 16)), 'M']], ['^', [String.fromCharCode(parseInt('00fc', 16)), 'N']], ['_', [String.fromCharCode(parseInt('00fc', 16)), 'O']], ['`', [String.fromCharCode(parseInt('00fc', 16)), 'W']], ['a', [String.fromCharCode(parseInt('00fe', 16)), 'A']], ['b', [String.fromCharCode(parseInt('00fe', 16)), 'B']], ['c', [String.fromCharCode(parseInt('00fe', 16)), 'C']], ['d', [String.fromCharCode(parseInt('00fe', 16)), 'D']], ['e', [String.fromCharCode(parseInt('00fe', 16)), 'E']], ['f', [String.fromCharCode(parseInt('00fe', 16)), 'F']], ['g', [String.fromCharCode(parseInt('00fe', 16)), 'G']], ['h', [String.fromCharCode(parseInt('00fe', 16)), 'H']], ['i', [String.fromCharCode(parseInt('00fe', 16)), 'I']], ['j', [String.fromCharCode(parseInt('00fe', 16)), 'J']], ['k', [String.fromCharCode(parseInt('00fe', 16)), 'K']], ['l', [String.fromCharCode(parseInt('00fe', 16)), 'L']], ['m', [String.fromCharCode(parseInt('00fe', 16)), 'M']], ['n', [String.fromCharCode(parseInt('00fe', 16)), 'N']], ['o', [String.fromCharCode(parseInt('00fe', 16)), 'O']], ['p', [String.fromCharCode(parseInt('00fe', 16)), 'P']], ['q', [String.fromCharCode(parseInt('00fe', 16)), 'Q']], ['r', [String.fromCharCode(parseInt('00fe', 16)), 'R']], ['s', [String.fromCharCode(parseInt('00fe', 16)), 'S']], ['t', [String.fromCharCode(parseInt('00fe', 16)), 'T']], ['u', [String.fromCharCode(parseInt('00fe', 16)), 'U']], ['v', [String.fromCharCode(parseInt('00fe', 16)), 'V']], ['w', [String.fromCharCode(parseInt('00fe', 16)), 'W']], ['x', [String.fromCharCode(parseInt('00fe', 16)), 'X']], ['y', [String.fromCharCode(parseInt('00fe', 16)), 'Y']], ['z', [String.fromCharCode(parseInt('00fe', 16)), 'Z']], ['{', [String.fromCharCode(parseInt('00fc', 16)), 'P']], ['|', [String.fromCharCode(parseInt('00fc', 16)), 'Q']], ['}', [String.fromCharCode(parseInt('00fc', 16)), 'R']], ['~', [String.fromCharCode(parseInt('00fc', 16)), 'S']], [String.fromCharCode(parseInt('007f', 16)), [String.fromCharCode(parseInt('00fc', 16)), 'T']]],
        },
        /** Specifies symbology settings for the Code 128 A Barcode. */
        code128a: {
            startSymbol: String.fromCharCode(parseInt('00f9', 16)),
            stopSymbol: String.fromCharCode(parseInt('00ff', 16)),
            validatorExp: "[\0\x0001\x0002\x0003\x0004\x0005\x0006\a\b\t\n\v\f\r\x000e\x000f\x0010\x0011\x0012\x0013\x0014\x0015\x0016\x0017\x0018\x0019\x001a\x001b\x001c\x001d\x001e\x001f !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\x00f0\x00f1\x00f2\x00f3\x00f4]",
            symbolTable: [["\0", 0x40, [1, 1, 1, 4, 2, 2]], [String.fromCharCode(parseInt('0001', 16)), 0x41, [1, 2, 1, 1, 2, 4]], [String.fromCharCode(parseInt('0002', 16)), 0x42, [1, 2, 1, 4, 2, 1]], [String.fromCharCode(parseInt('0003', 16)), 0x43, [1, 4, 1, 1, 2, 2]], [String.fromCharCode(parseInt('0004', 16)), 0x44, [1, 4, 1, 2, 2, 1]], [String.fromCharCode(parseInt('0005', 16)), 0x45, [1, 1, 2, 2, 1, 4]], [String.fromCharCode(parseInt('0006', 16)), 70, [1, 1, 2, 4, 1, 2]], ["\a", 0x47, [1, 2, 2, 1, 1, 4]], ["\b", 0x48, [1, 2, 2, 4, 1, 1]], ["\t", 0x49, [1, 4, 2, 1, 1, 2]], ["\n", 0x4a, [1, 4, 2, 2, 1, 1]], ["\v", 0x4b, [2, 4, 1, 2, 1, 1]], ["\f", 0x4c, [2, 2, 1, 1, 1, 4]], ["\r", 0x4d, [4, 1, 3, 1, 1, 1]], [String.fromCharCode(parseInt('000e', 16)), 0x4e, [2, 4, 1, 1, 1, 2]], [String.fromCharCode(parseInt('000f', 16)), 0x4f, [1, 3, 4, 1, 1, 1]], [String.fromCharCode(parseInt('0010', 16)), 80, [1, 1, 1, 2, 4, 2]], [String.fromCharCode(parseInt('0011', 16)), 0x51, [1, 2, 1, 1, 4, 2]], [String.fromCharCode(parseInt('0012', 16)), 0x52, [1, 2, 1, 2, 4, 1]], [String.fromCharCode(parseInt('0013', 16)), 0x53, [1, 1, 4, 2, 1, 2]], [String.fromCharCode(parseInt('0014', 16)), 0x54, [1, 2, 4, 1, 1, 2]], [String.fromCharCode(parseInt('0015', 16)), 0x55, [1, 2, 4, 2, 1, 1]], [String.fromCharCode(parseInt('0016', 16)), 0x56, [4, 1, 1, 2, 1, 2]], [String.fromCharCode(parseInt('0017', 16)), 0x57, [4, 2, 1, 1, 1, 2]], [String.fromCharCode(parseInt('0018', 16)), 0x58, [4, 2, 1, 2, 1, 1]], [String.fromCharCode(parseInt('0019', 16)), 0x59, [2, 1, 2, 1, 4, 1]], [String.fromCharCode(parseInt('001a', 16)), 90, [2, 1, 4, 1, 2, 1]], [String.fromCharCode(parseInt('001b', 16)), 0x5b, [4, 1, 2, 1, 2, 1]], [String.fromCharCode(parseInt('001c', 16)), 0x5c, [1, 1, 1, 1, 4, 3]], [String.fromCharCode(parseInt('001d', 16)), 0x5d, [1, 1, 1, 3, 4, 1]], [String.fromCharCode(parseInt('001e', 16)), 0x5e, [1, 3, 1, 1, 4, 1]], [String.fromCharCode(parseInt('001f', 16)), 0x5f, [1, 1, 4, 1, 1, 3]], [" ", 0, [2, 1, 2, 2, 2, 2]], ["!", 1, [2, 2, 2, 1, 2, 2]], ["\"", 2, [2, 2, 2, 2, 2, 1]], ["#", 3, [1, 2, 1, 2, 2, 3]], ["$", 4, [1, 2, 1, 3, 2, 2]], ["%", 5, [1, 3, 1, 2, 2, 2]], ["&", 6, [1, 2, 2, 2, 1, 3]], ["\'", 7, [1, 2, 2, 3, 1, 2]], ["(", 8, [1, 3, 2, 2, 1, 2]], [")", 9, [2, 2, 1, 2, 1, 3]], ["*", 10, [2, 2, 1, 3, 1, 2]], ["+", 11, [2, 3, 1, 2, 1, 2]], [",", 12, [1, 1, 2, 2, 3, 2]], ["-", 13, [1, 2, 2, 1, 3, 2]], [".", 14, [1, 2, 2, 2, 3, 1]], ["/", 15, [1, 1, 3, 2, 2, 2]], ["0", 0x10, [1, 2, 3, 1, 2, 2]], ["1", 0x11, [1, 2, 3, 2, 2, 1]], ["2", 0x12, [2, 2, 3, 2, 1, 1]], ["3", 0x13, [2, 2, 1, 1, 3, 2]], ["4", 20, [2, 2, 1, 2, 3, 1]], ["5", 0x15, [2, 1, 3, 2, 1, 2]], ["6", 0x16, [2, 2, 3, 1, 1, 2]], ["7", 0x17, [3, 1, 2, 1, 3, 1]], ["8", 0x18, [3, 1, 1, 2, 2, 2]], ["9", 0x19, [3, 2, 1, 1, 2, 2]], [":", 0x1a, [3, 2, 1, 2, 2, 1]], [";", 0x1b, [3, 1, 2, 2, 1, 2]], ["<", 0x1c, [3, 2, 2, 1, 1, 2]], ["=", 0x1d, [3, 2, 2, 2, 1, 1]], [">", 30, [2, 1, 2, 1, 2, 3]], ["?", 0x1f, [2, 1, 2, 3, 2, 1]], ["@", 0x20, [2, 3, 2, 1, 2, 1]], ["A", 0x21, [1, 1, 1, 3, 2, 3]], ["B", 0x22, [1, 3, 1, 1, 2, 3]], ["C", 0x23, [1, 3, 1, 3, 2, 1]], ["D", 0x24, [1, 1, 2, 3, 1, 3]], ["E", 0x25, [1, 3, 2, 1, 1, 3]], ["F", 0x26, [1, 3, 2, 3, 1, 1]], ["G", 0x27, [2, 1, 1, 3, 1, 3]], ["H", 40, [2, 3, 1, 1, 1, 3]], ["I", 0x29, [2, 3, 1, 3, 1, 1]], ["J", 0x2a, [1, 1, 2, 1, 3, 3]], ["K", 0x2b, [1, 1, 2, 3, 3, 1]], ["L", 0x2c, [1, 3, 2, 1, 3, 1]], ["M", 0x2d, [1, 1, 3, 1, 2, 3]], ["N", 0x2e, [1, 1, 3, 3, 2, 1]], ["O", 0x2f, [1, 3, 3, 1, 2, 1]], ["P", 0x30, [3, 1, 3, 1, 2, 1]], ["Q", 0x31, [2, 1, 1, 3, 3, 1]], ["R", 50, [2, 3, 1, 1, 3, 1]], ["S", 0x33, [2, 1, 3, 1, 1, 3]], ["T", 0x34, [2, 1, 3, 3, 1, 1]], ["U", 0x35, [2, 1, 3, 1, 3, 1]], ["V", 0x36, [3, 1, 1, 1, 2, 3]], ["W", 0x37, [3, 1, 1, 3, 2, 1]], ["X", 0x38, [3, 3, 1, 1, 2, 1]], ["Y", 0x39, [3, 1, 2, 1, 1, 3]], ["Z", 0x3a, [3, 1, 2, 3, 1, 1]], ["[", 0x3b, [3, 3, 2, 1, 1, 1]], ["\\", 60, [3, 1, 4, 1, 1, 1]], ["]", 0x3d, [2, 2, 1, 4, 1, 1]], ["^", 0x3e, [4, 3, 1, 1, 1, 1]], ["_", 0x3f, [1, 1, 1, 2, 2, 4]], [String.fromCharCode(parseInt('00f0', 16)), 0x66, [4, 1, 1, 1, 3, 1]], [String.fromCharCode(parseInt('00f1', 16)), 0x61, [4, 1, 1, 1, 1, 3]], [String.fromCharCode(parseInt('00f2', 16)), 0x60, [1, 1, 4, 3, 1, 1]], [String.fromCharCode(parseInt('00f3', 16)), 0x65, [3, 1, 1, 1, 4, 1]], [String.fromCharCode(parseInt('00f4', 16)), 0x62, [4, 1, 1, 3, 1, 1]], [String.fromCharCode(parseInt('00fc', 16)), 0x63, [1, 1, 3, 1, 4, 1]], [String.fromCharCode(parseInt('00fb', 16)), 100, [1, 1, 4, 1, 3, 1]], [String.fromCharCode(parseInt('00f9', 16)), 0x67, [2, 1, 1, 4, 1, 2]], [String.fromCharCode(parseInt('00ff', 16)), -1, [2, 3, 3, 1, 1, 1, 2]]],
        },
        /** Specifies symbology settings for the Code 128 B Barcode. */
        code128b: {
            startSymbol: String.fromCharCode(parseInt('00fd', 16)),
            stopSymbol: String.fromCharCode(parseInt('00ff', 16)),
            validatorExp: "^[\x00-\x7F]",
            symbolTable: [[" ", 0, [2, 1, 2, 2, 2, 2]], ["!", 1, [2, 2, 2, 1, 2, 2]], ["\"", 2, [2, 2, 2, 2, 2, 1]], ["#", 3, [1, 2, 1, 2, 2, 3]], ["$", 4, [1, 2, 1, 3, 2, 2]], ["%", 5, [1, 3, 1, 2, 2, 2]], ["&", 6, [1, 2, 2, 2, 1, 3]], ["\'", 7, [1, 2, 2, 3, 1, 2]], ["(", 8, [1, 3, 2, 2, 1, 2]], [")", 9, [2, 2, 1, 2, 1, 3]], ["*", 10, [2, 2, 1, 3, 1, 2]], ["+", 11, [2, 3, 1, 2, 1, 2]], [",", 12, [1, 1, 2, 2, 3, 2]], ["-", 13, [1, 2, 2, 1, 3, 2]], [".", 14, [1, 2, 2, 2, 3, 1]], ["/", 15, [1, 1, 3, 2, 2, 2]], ["0", 0x10, [1, 2, 3, 1, 2, 2]], ["1", 0x11, [1, 2, 3, 2, 2, 1]], ["2", 0x12, [2, 2, 3, 2, 1, 1]], ["3", 0x13, [2, 2, 1, 1, 3, 2]], ["4", 20, [2, 2, 1, 2, 3, 1]], ["5", 0x15, [2, 1, 3, 2, 1, 2]], ["6", 0x16, [2, 2, 3, 1, 1, 2]], ["7", 0x17, [3, 1, 2, 1, 3, 1]], ["8", 0x18, [3, 1, 1, 2, 2, 2]], ["9", 0x19, [3, 2, 1, 1, 2, 2]], [":", 0x1a, [3, 2, 1, 2, 2, 1]], [";", 0x1b, [3, 1, 2, 2, 1, 2]], ["<", 0x1c, [3, 2, 2, 1, 1, 2]], ["=", 0x1d, [3, 2, 2, 2, 1, 1]], [">", 30, [2, 1, 2, 1, 2, 3]], ["?", 0x1f, [2, 1, 2, 3, 2, 1]], ["@", 0x20, [2, 3, 2, 1, 2, 1]], ["A", 0x21, [1, 1, 1, 3, 2, 3]], ["B", 0x22, [1, 3, 1, 1, 2, 3]], ["C", 0x23, [1, 3, 1, 3, 2, 1]], ["D", 0x24, [1, 1, 2, 3, 1, 3]], ["E", 0x25, [1, 3, 2, 1, 1, 3]], ["F", 0x26, [1, 3, 2, 3, 1, 1]], ["G", 0x27, [2, 1, 1, 3, 1, 3]], ["H", 40, [2, 3, 1, 1, 1, 3]], ["I", 0x29, [2, 3, 1, 3, 1, 1]], ["J", 0x2a, [1, 1, 2, 1, 3, 3]], ["K", 0x2b, [1, 1, 2, 3, 3, 1]], ["L", 0x2c, [1, 3, 2, 1, 3, 1]], ["M", 0x2d, [1, 1, 3, 1, 2, 3]], ["N", 0x2e, [1, 1, 3, 3, 2, 1]], ["O", 0x2f, [1, 3, 3, 1, 2, 1]], ["P", 0x30, [3, 1, 3, 1, 2, 1]], ["Q", 0x31, [2, 1, 1, 3, 3, 1]], ["R", 50, [2, 3, 1, 1, 3, 1]], ["S", 0x33, [2, 1, 3, 1, 1, 3]], ["T", 0x34, [2, 1, 3, 3, 1, 1]], ["U", 0x35, [2, 1, 3, 1, 3, 1]], ["V", 0x36, [3, 1, 1, 1, 2, 3]], ["W", 0x37, [3, 1, 1, 3, 2, 1]], ["X", 0x38, [3, 3, 1, 1, 2, 1]], ["Y", 0x39, [3, 1, 2, 1, 1, 3]], ["Z", 0x3a, [3, 1, 2, 3, 1, 1]], ["[", 0x3b, [3, 3, 2, 1, 1, 1]], ["\\", 60, [3, 1, 4, 1, 1, 1]], ["]", 0x3d, [2, 2, 1, 4, 1, 1]], ["^", 0x3e, [4, 3, 1, 1, 1, 1]], ["_", 0x3f, [1, 1, 1, 2, 2, 4]], ["`", 0x40, [1, 1, 1, 4, 2, 2]], ["a", 0x41, [1, 2, 1, 1, 2, 4]], ["b", 0x42, [1, 2, 1, 4, 2, 1]], ["c", 0x43, [1, 4, 1, 1, 2, 2]], ["d", 0x44, [1, 4, 1, 2, 2, 1]], ["e", 0x45, [1, 1, 2, 2, 1, 4]], ["f", 70, [1, 1, 2, 4, 1, 2]], ["g", 0x47, [1, 2, 2, 1, 1, 4]], ["h", 0x48, [1, 2, 2, 4, 1, 1]], ["i", 0x49, [1, 4, 2, 1, 1, 2]], ["j", 0x4a, [1, 4, 2, 2, 1, 1]], ["k", 0x4b, [2, 4, 1, 2, 1, 1]], ["l", 0x4c, [2, 2, 1, 1, 1, 4]], ["m", 0x4d, [4, 1, 3, 1, 1, 1]], ["n", 0x4e, [2, 4, 1, 1, 1, 2]], ["o", 0x4f, [1, 3, 4, 1, 1, 1]], ["p", 80, [1, 1, 1, 2, 4, 2]], ["q", 0x51, [1, 2, 1, 1, 4, 2]], ["r", 0x52, [1, 2, 1, 2, 4, 1]], ["s", 0x53, [1, 1, 4, 2, 1, 2]], ["t", 0x54, [1, 2, 4, 1, 1, 2]], ["u", 0x55, [1, 2, 4, 2, 1, 1]], ["v", 0x56, [4, 1, 1, 2, 1, 2]], ["w", 0x57, [4, 2, 1, 1, 1, 2]], ["x", 0x58, [4, 2, 1, 2, 1, 1]], ["y", 0x59, [2, 1, 2, 1, 4, 1]], ["z", 90, [2, 1, 4, 1, 2, 1]], ["{", 0x5b, [4, 1, 2, 1, 2, 1]], ["|", 0x5c, [1, 1, 1, 1, 4, 3]], ["}", 0x5d, [1, 1, 1, 3, 4, 1]], ["~", 0x5e, [1, 3, 1, 1, 4, 1]], [String.fromCharCode(parseInt('007f', 16)), 0x5f, [1, 1, 4, 1, 1, 3]], [String.fromCharCode(parseInt('00f0', 16)), 0x66, [4, 1, 1, 1, 3, 1]], [String.fromCharCode(parseInt('00f1', 16)), 0x61, [4, 1, 1, 1, 1, 3]], [String.fromCharCode(parseInt('00f2', 16)), 0x60, [1, 1, 4, 3, 1, 1]], [String.fromCharCode(parseInt('00f3', 16)), 100, [1, 1, 4, 1, 3, 1]], [String.fromCharCode(parseInt('00f4', 16)), 0x62, [4, 1, 1, 3, 1, 1]], [String.fromCharCode(parseInt('00fc', 16)), 0x63, [1, 1, 3, 1, 4, 1]], [String.fromCharCode(parseInt('00fa', 16)), 0x65, [3, 1, 1, 1, 4, 1]], [String.fromCharCode(parseInt('00fd', 16)), 0x68, [2, 1, 1, 2, 1, 4]], [String.fromCharCode(parseInt('00ff', 16)), -1, [2, 3, 3, 1, 1, 1, 2]]],
        },
        /** Specifies symbology settings for the Code 128 C Barcode. */
        code128c: {
            startSymbol: String.fromCharCode(parseInt('00fe', 16)),
            stopSymbol: String.fromCharCode(parseInt('00ff', 16)),
            validatorExp: "[0-9]",
            symbolTable: [["\0", 0, [2, 1, 2, 2, 2, 2]], [String.fromCharCode(parseInt('0001', 16)), 1, [2, 2, 2, 1, 2, 2]], [String.fromCharCode(parseInt('0002', 16)), 2, [2, 2, 2, 2, 2, 1]], [String.fromCharCode(parseInt('0003', 16)), 3, [1, 2, 1, 2, 2, 3]], [String.fromCharCode(parseInt('0004', 16)), 4, [1, 2, 1, 3, 2, 2]], [String.fromCharCode(parseInt('0005', 16)), 5, [1, 3, 1, 2, 2, 2]], [String.fromCharCode(parseInt('0006', 16)), 6, [1, 2, 2, 2, 1, 3]], ["\a", 7, [1, 2, 2, 3, 1, 2]], ["\b", 8, [1, 3, 2, 2, 1, 2]], ["\t", 9, [2, 2, 1, 2, 1, 3]], ["\n", 10, [2, 2, 1, 3, 1, 2]], ["\v", 11, [2, 3, 1, 2, 1, 2]], ["\f", 12, [1, 1, 2, 2, 3, 2]], ["\r", 13, [1, 2, 2, 1, 3, 2]], [String.fromCharCode(parseInt('000e', 16)), 14, [1, 2, 2, 2, 3, 1]], [String.fromCharCode(parseInt('000f', 16)), 15, [1, 1, 3, 2, 2, 2]], [String.fromCharCode(parseInt('0010', 16)), 0x10, [1, 2, 3, 1, 2, 2]], [String.fromCharCode(parseInt('0011', 16)), 0x11, [1, 2, 3, 2, 2, 1]], [String.fromCharCode(parseInt('0012', 16)), 0x12, [2, 2, 3, 2, 1, 1]], [String.fromCharCode(parseInt('0013', 16)), 0x13, [2, 2, 1, 1, 3, 2]], [String.fromCharCode(parseInt('0014', 16)), 20, [2, 2, 1, 2, 3, 1]], [String.fromCharCode(parseInt('0015', 16)), 0x15, [2, 1, 3, 2, 1, 2]], [String.fromCharCode(parseInt('0016', 16)), 0x16, [2, 2, 3, 1, 1, 2]], [String.fromCharCode(parseInt('0017', 16)), 0x17, [3, 1, 2, 1, 3, 1]], [String.fromCharCode(parseInt('0018', 16)), 0x18, [3, 1, 1, 2, 2, 2]], [String.fromCharCode(parseInt('0019', 16)), 0x19, [3, 2, 1, 1, 2, 2]], [String.fromCharCode(parseInt('001a', 16)), 0x1a, [3, 2, 1, 2, 2, 1]], [String.fromCharCode(parseInt('001b', 16)), 0x1b, [3, 1, 2, 2, 1, 2]], [String.fromCharCode(parseInt('001c', 16)), 0x1c, [3, 2, 2, 1, 1, 2]], [String.fromCharCode(parseInt('001d', 16)), 0x1d, [3, 2, 2, 2, 1, 1]], [String.fromCharCode(parseInt('001e', 16)), 30, [2, 1, 2, 1, 2, 3]], [String.fromCharCode(parseInt('001f', 16)), 0x1f, [2, 1, 2, 3, 2, 1]], [" ", 0x20, [2, 3, 2, 1, 2, 1]], ["!", 0x21, [1, 1, 1, 3, 2, 3]], ["\"", 0x22, [1, 3, 1, 1, 2, 3]], ["#", 0x23, [1, 3, 1, 3, 2, 1]], ["$", 0x24, [1, 1, 2, 3, 1, 3]], ["%", 0x25, [1, 3, 2, 1, 1, 3]], ["&", 0x26, [1, 3, 2, 3, 1, 1]], ["\'", 0x27, [2, 1, 1, 3, 1, 3]], ["[", 40, [2, 3, 1, 1, 1, 3]], [")", 0x29, [2, 3, 1, 3, 1, 1]], ["*", 0x2a, [1, 1, 2, 1, 3, 3]], ["+", 0x2b, [1, 1, 2, 3, 3, 1]], [",", 0x2c, [1, 3, 2, 1, 3, 1]], ["-", 0x2d, [1, 1, 3, 1, 2, 3]], [".", 0x2e, [1, 1, 3, 3, 2, 1]], ["/", 0x2f, [1, 3, 3, 1, 2, 1]], ["0", 0x30, [3, 1, 3, 1, 2, 1]], ["1", 0x31, [2, 1, 1, 3, 3, 1]], ["2", 50, [2, 3, 1, 1, 3, 1]], ["3", 0x33, [2, 1, 3, 1, 1, 3]], ["4", 0x34, [2, 1, 3, 3, 1, 1]], ["5", 0x35, [2, 1, 3, 1, 3, 1]], ["6", 0x36, [3, 1, 1, 1, 2, 3]], ["7", 0x37, [3, 1, 1, 3, 2, 1]], ["8", 0x38, [3, 3, 1, 1, 2, 1]], ["9", 0x39, [3, 1, 2, 1, 1, 3]], [":", 0x3a, [3, 1, 2, 3, 1, 1]], [";", 0x3b, [3, 3, 2, 1, 1, 1]], ["<", 60, [3, 1, 4, 1, 1, 1]], ["=", 0x3d, [2, 2, 1, 4, 1, 1]], [">", 0x3e, [4, 3, 1, 1, 1, 1]], ["?", 0x3f, [1, 1, 1, 2, 2, 4]], ["@", 0x40, [1, 1, 1, 4, 2, 2]], ["A", 0x41, [1, 2, 1, 1, 2, 4]], ["B", 0x42, [1, 2, 1, 4, 2, 1]], ["C", 0x43, [1, 4, 1, 1, 2, 2]], ["D", 0x44, [1, 4, 1, 2, 2, 1]], ["E", 0x45, [1, 1, 2, 2, 1, 4]], ["F", 70, [1, 1, 2, 4, 1, 2]], ["G", 0x47, [1, 2, 2, 1, 1, 4]], ["H", 0x48, [1, 2, 2, 4, 1, 1]], ["I", 0x49, [1, 4, 2, 1, 1, 2]], ["J", 0x4a, [1, 4, 2, 2, 1, 1]], ["K", 0x4b, [2, 4, 1, 2, 1, 1]], ["L", 0x4c, [2, 2, 1, 1, 1, 4]], ["M", 0x4d, [4, 1, 3, 1, 1, 1]], ["N", 0x4e, [2, 4, 1, 1, 1, 2]], ["O", 0x4f, [1, 3, 4, 1, 1, 1]], ["P", 80, [1, 1, 1, 2, 4, 2]], ["Q", 0x51, [1, 2, 1, 1, 4, 2]], ["R", 0x52, [1, 2, 1, 2, 4, 1]], ["S", 0x53, [1, 1, 4, 2, 1, 2]], ["T", 0x54, [1, 2, 4, 1, 1, 2]], ["U", 0x55, [1, 2, 4, 2, 1, 1]], ["V", 0x56, [4, 1, 1, 2, 1, 2]], ["W", 0x57, [4, 2, 1, 1, 1, 2]], ["X", 0x58, [4, 2, 1, 2, 1, 1]], ["Y", 0x59, [2, 1, 2, 1, 4, 1]], ["Z", 90, [2, 1, 4, 1, 2, 1]], ["[", 0x5b, [4, 1, 2, 1, 2, 1]], ["\\", 0x5c, [1, 1, 1, 1, 4, 3]], ["]", 0x5d, [1, 1, 1, 3, 4, 1]], ["^", 0x5e, [1, 3, 1, 1, 4, 1]], ["_", 0x5f, [1, 1, 4, 1, 1, 3]], ["`", 0x60, [1, 1, 4, 3, 1, 1]], ["a", 0x61, [4, 1, 1, 1, 1, 3]], ["b", 0x62, [4, 1, 1, 3, 1, 1]], ["c", 0x63, [1, 1, 3, 1, 4, 1]], [String.fromCharCode(parseInt('00f0', 16)), 0x66, [4, 1, 1, 1, 3, 1]], [String.fromCharCode(parseInt('00fa', 16)), 0x65, [3, 1, 1, 1, 4, 1]], [String.fromCharCode(parseInt('00fb', 16)), 100, [1, 1, 4, 1, 3, 1]], [String.fromCharCode(parseInt('00fe', 16)), 0x69, [2, 1, 1, 2, 3, 2]], [String.fromCharCode(parseInt('00ff', 16)), -1, [2, 3, 3, 1, 1, 1, 2]]],
        },
        /** Specifies symbology settings for the UPC-A Barcode. */
        upcbarcode: {
            startSymbol: String.fromCharCode(parseInt('00fd', 16)),
            stopSymbol: String.fromCharCode(parseInt('00ff', 16)),
            validatorExp: "[0-9]",
            symbolTable: [["0", 0, [3, 2, 1, 1]], ["1", 1, [2, 2, 2, 1]], ["2", 2, [2, 1, 2, 2]], ["3", 3, [1, 4, 1, 1]], ["4", 4, [1, 1, 3, 2]], ["5", 5, [1, 2, 3, 1]], ["6", 6, [1, 1, 1, 4]], ["7", 7, [1, 3, 1, 2]], ["8", 8, [1, 2, 1, 3]], ["9", 9, [3, 1, 1, 2]], ["B", 0 , [1, 1, 1, 1]]],
        },
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Diagram elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
* Use of this code is subject to the terms of our license.
* A copy of the current license can be obtained at any time by e-mailing
* licensing@syncfusion.com. Any infringement will be prosecuted under
* applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    "use strict";
    //#region ej.Diagram widget
    ej.widget("ejDiagram", "ej.datavisualization.Diagram", {
        element: null,
        model: null,
        _requiresID: true,
        validTags: ["div"],
        //#region defaults
        defaults: {
            width: "",
            height: "",
            nodes: [],
            connectors: [],
            labelRenderingMode: "html",
            defaultSettings: {
                connector: null,
                node: null,
                group: null
            },
            nodeTemplate: null,
            connectorTemplate: null,
            dataSourceSettings: {
                dataSource: null,
                query: null,
                tableName: null,
                id: "",
                parent: "",
                nodes: null,
                connectors: null,
                root: "",
                crudAction: {
                    create: "",
                    update: "",
                    destroy: "",
                    read: ""
                },
                customFields: [],
                connectionDataSource: {
                    dataSource: null,
                    id: "",
                    sourceNode: "",
                    targetNode: "",
                    sourcePointX: "",
                    sourcePointY: "",
                    targetPointX: "",
                    targetPointY: "",
                    crudAction: {
                        create: "",
                        update: "",
                        destroy: "",
                        read: ""
                    },
                    customFields: []
                }
            },
            snapSettings: {
                horizontalGridLines: {
                    linesInterval: [1.25, 18.75, 0.25, 19.75, 0.25, 19.75, 0.25, 19.75, 0.25, 19.75],
                    snapInterval: [20],
                    lineDashArray: "",
                    lineColor: "lightgray"
                },
                verticalGridLines: {
                    linesInterval: [1.25, 18.75, 0.25, 19.75, 0.25, 19.75, 0.25, 19.75, 0.25, 19.75],
                    snapInterval: [20],
                    lineDashArray: "",
                    lineColor: "lightgray"
                },
                snapConstraints: 1 | 2 | 4 | 8,
                enableSnapToObject: true,
                snapAngle: 5,
                snapObjectDistance: 5
            },
            scrollSettings: {
                horizontalOffset: 0,
                verticalOffset: 0,
                currentZoom: 1,
                viewPortHeight: 0,
                viewPortWidth: 0,
                zoomFactor: 0.2,
                padding: {
                    left: 0,
                    right: 0,
                    top: 0,
                    bottom: 0
                }
            },
            pageSettings: {
                pageWidth: null,
                pageHeight: null,
                multiplePage: false,
                pageBorderWidth: 0,
                pageBackgroundColor: "#ffffff",
                pageBorderColor: "#565656",
                pageMargin: 24,
                showPageBreak: false,
                pageOrientation: "portrait",
                scrollLimit: "infinity",
                scrollableArea: { x: Number.POSITIVE_INFINITY, y: Number.POSITIVE_INFINITY, width: Number.POSITIVE_INFINITY, height: Number.POSITIVE_INFINITY },
                autoScrollBorder: { left: 15, top: 15, right: 15, bottom: 15 },
                boundaryConstraints: "infinity"
            },
            locale: "en-US",
            contextMenu: {
                items: [],
                showCustomMenuItemsOnly: false
            },
            enableContextMenu: true,
            enableAutoScroll: true,
            tooltip: {
                templateId: "",
                relativeMode: "object",
                alignment: {
                    horizontal: "center",
                    vertical: "bottom",
                },
                margin: { left: 5, right: 5, top: 5, bottom: 5 }
            },
            showTooltip: true,
            layout: {
                bounds: null,
                type: "none",
                horizontalAlignment: "center",
                verticalAlignment: "top",
                orientation: "toptobottom",
                horizontalSpacing: 30,
                verticalSpacing: 30,
                margin: { left: 0, right: 0, top: 0, bottom: 0 },
                marginX: 0,
                marginY: 0,
                fixedNode: "",
                getLayoutInfo: null,
                getConnectorSegments: null
            },
            drawingTools: {},
            backgroundImage: {
                source: "",
                scale: "meet",
                alignment: "xmidymid"
            },
            backgroundColor: "transparent",
            bridgeDirection: "top",
            version: "13.1",
            constraints: 1 << 1 | 1 << 2 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7 | 1 << 8,
            tool: null,
            drawType: {},
            selectedItems: {
                offsetX: 0,
                offsetY: 0,
                width: 0,
                height: 0,
                rotateAngle: 0,
                children: [],
                constraints: 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4,
                userHandles: [],
                tooltip: {
                    templateId: "",
                    alignment: { horizontal: "center", vertical: "bottom" },
                    margin: { top: 10 }
                },
                getConstraints: null
            },
            commandManager: {
                commands: {}
            },
            historyManager: {
                push: null,
                pop: null,
                canPop: null,
                canLog: null,
                undo: null,
                redo: null,
                startGroupAction: null,
                closeGroupAction: null,
                stackLimit: null,
                undoStack: [],
                redoStack: []
            },
            connectorType: "straightLine",
            editorFocusChange: null,
            nodeCollectionChange: null,
            templateNodeRendering: null,
            historyChange: null,
            autoScrollChange: null,
            itemClick: null,
            connectorCollectionChange: null,
            selectionChange: null,
            mouseLeave: null,
            mouseEnter: null,
            mouseOver: null,
            click: null,
            doubleClick: null,
            dragEnter: null,
            dragOver: null,
            dragLeave: null,
            drop: null,
            drag: null,
            textChange: null,
            sizeChange: null,
            connectionChange: null,
            rotationChange: null,
            contextMenuClick: null,
            contextMenuBeforeOpen: null,
            connectorSourceChange: null,
            connectorTargetChange: null,
            scrollChange: null,
            segmentChange: null,
            propertyChange: null,
            groupChange: null,
            create: null,
            destroy: null
        },
        observables: [
            "nodes",
            "connectors",
            "locale",
            "enableContextMenu",
            "backgroundColor",
            "backgroundImage",
            "enableAutoScroll",
            "showTooltip",
            "bridgeDirection",
            "tool",
            "pageSettings.pageHeight",
            "pageSettings.pageWidth",
            "pageSettings.multiplePage",
            "pageSettings.pageBorderWidth",
            "pageSettings.pageBackgroundColor",
            "pageSettings.pageBorderColor",
            "pageSettings.pageMargin",
            "pageSettings.showPageBreak",
            "pageSettings.pageOrientation",
            "pageSettings.scrollLimit",
            "snapSettings.enableSnapToObject",
            "snapSettings.snapAngle",
            "snapSettings.snapObjectDistance",
            "snapSettings.snapConstraints",
            "dataSourceSettings.id",
            "dataSourceSettings.parent",
            "dataSourceSettings.root",
            "dataSourceSettings.dataSource",
            "dataSourceSettings.tableName",
            "dataSourceSettings.query",
            "layout.type",
            "layout.orientation",
            "layout.horizontalSpacing",
            "layout.verticalSpacing",
            "layout.marginX",
            "layout.marginY",
            "layout.fixedNode",
            "selectedItems.offsetX",
            "selectedItems.offsetY",
            "selectedItems.width",
            "selectedItems.height",
            "selectedItems.rotateAngle",
            "scrollSettings.horizontalOffset",
            "scrollSettings.verticalOffset",
            "scrollSettings.zoomFactor",
            "tooltip.templateId",
            "tooltip.relativeMode",
            "tooltip.alignment.horizontal",
            "tooltip.alignment.vertical",
            "contextMenu.items",
            "contextMenu.showCustomMenuItemsOnly"
        ],
        nodes: ej.util.valueFunction("nodes"),
        connectors: ej.util.valueFunction("connectors"),
        locale: ej.util.valueFunction("locale"),
        enableContextMenu: ej.util.valueFunction("enableContextMenu"),
        enableAutoScroll: ej.util.valueFunction("enableAutoScroll"),
        showTooltip: ej.util.valueFunction("showTooltip"),
        bridgeDirection: ej.util.valueFunction("bridgeDirection"),
        tool: ej.util.valueFunction("tool"),
        _backgroundColor: ej.util.valueFunction("backgroundColor"),
        _backgroundImage: ej.util.valueFunction("backgroundImage"),
        _pageHeight: ej.util.valueFunction("pageSettings.pageHeight"),
        _pageWidth: ej.util.valueFunction("pageSettings.pageWidth"),
        _multiplePage: ej.util.valueFunction("pageSettings.multiplePage"),
        _pageBorderWidth: ej.util.valueFunction("pageSettings.pageBorderWidth"),
        _pageBackgroundColor: ej.util.valueFunction("pageSettings.pageBackgroundColor"),
        _pageBorderColor: ej.util.valueFunction("pageSettings.pageBorderColor"),
        _pageMargin: ej.util.valueFunction("pageSettings.pageMargin"),
        _showPageBreak: ej.util.valueFunction("pageSettings.showPageBreak"),
        _pageOrientation: ej.util.valueFunction("pageSettings.pageOrientation"),
        _scrollLimit: ej.util.valueFunction("pageSettings.scrollLimit"),
        _enableSnapToObject: ej.util.valueFunction("snapSettings.enableSnapToObject"),
        _snapConstraints: ej.util.valueFunction("snapSettings.snapConstraints"),
        _snapAngle: ej.util.valueFunction("snapSettings.snapAngle"),
        _snapObjectDistance: ej.util.valueFunction("snapSettings.snapObjectDistance"),
        _selectorOffsetX: ej.util.valueFunction("selectedItems.offsetX"),
        _selectorOffsetY: ej.util.valueFunction("selectedItems.offsetY"),
        _selectorWidth: ej.util.valueFunction("selectedItems.width"),
        _selectorHeight: ej.util.valueFunction("selectedItems.height"),
        _selectorRotateAngle: ej.util.valueFunction("selectedItems.rotateAngle"),
        _horizontalOffset: ej.util.valueFunction("scrollSettings.horizontalOffset"),
        _verticalOffset: ej.util.valueFunction("scrollSettings.verticalOffset"),
        zoomFactor: ej.util.valueFunction("scrollSettings.zoomFactor"),
        _layoutType: ej.util.valueFunction("layout.type"),
        _layoutOrientation: ej.util.valueFunction("layout.orientation"),
        _horizontalSpacing: ej.util.valueFunction("layout.horizontalSpacing"),
        _verticalSpacing: ej.util.valueFunction("layout.verticalSpacing"),
        _layoutMarginX: ej.util.valueFunction("layout.marginX"),
        _layoutMarginY: ej.util.valueFunction("layout.marginY"),
        _fixedNode: ej.util.valueFunction("layout.fixedNode"),
        _dataSourceUniqueId: ej.util.valueFunction("dataSourceSettings.id"),
        _dataSourceParentId: ej.util.valueFunction("dataSourceSettings.parent"),
        _dataSource: ej.util.valueFunction("dataSourceSettings.dataSource"),
        _dataSourceTableName: ej.util.valueFunction("dataSourceSettings.tableName"),
        _dataSourceQueryString: ej.util.valueFunction("dataSourceSettings.query"),
        _dataSourceRoot: ej.util.valueFunction("dataSourceSettings.root"),
        _tooltipTemplateId: ej.util.valueFunction("tooltip.templateId"),
        _horizontalTooltipAlignment: ej.util.valueFunction("tooltip.alignment.horizontal"),
        _verticalTooltipAlignment: ej.util.valueFunction("tooltip.alignment.vertical"),
        _tooltipMode: ej.util.valueFunction("tooltip.relativeMode"),
        _showCustomContextMenuItems: ej.util.valueFunction("contextMenu.showCustomMenuItemsOnly"),
        _contextMenuItems: ej.util.valueFunction("contextMenu.items"),
        dataTypes: {
            nodes: "data",
            connectors: "data",
            contextMenu: {
                items: "array"
            },
            dataSourceSettings: {
                dataSource: "data"
            },
            defaultSettings: {
                connector: {
                    segments: "data",
                    labels: "data"
                },
                node: {
                    children: "data",
                    gradient: {
                        stops: "data"
                    },
                    labels: "data",
                    lanes: "data",
                    phases: "data",
                    points: "data",
                    ports: "data",
                },
                group: {
                    children: "data",
                    gradient: {
                        stops: "data"
                    },
                    labels: "data",
                    lanes: "data",
                    phases: "data",
                    points: "data",
                    ports: "data",
                }
            },
            snapSettings: {
                horizontalGridLines: {
                    linesInterval: "data",
                    snapInterval: "data",
                },
                verticalGridLines: {
                    linesInterval: "data",
                    snapInterval: "data",
                }
            },
            selectedItems: {
                children: "data",
                userHandles: "data"
            }
        },
        //#endregion
        //#region Local members
        _doubleClickEvent: false,
        _nodes: [],
        _connectors: [],
        _canvas: null,
        _svg: null,
        _toolToActivate: null,
        _inAction: false,
        _isPinching: false,
        _isEditing: false,
        _nodeToHit: null,
        _enableAPIMethods: true,
        _currentCursor: null,
        _pasteIndex: null,
        _page: null,
        _view: null,
        _currentLabel: null,
        _zOrder: 0,
        _clipboardData: null,
        _currZoom: 1,
        _UndoRedo: true,
        _mouseEventTriggered: false,
        _selectedItem: "",
        _historyList: {
            currentEntry: {
                next: null,
                previous: null
            },
            canUndo: false,
            canRedo: false
        },
        _historyCount: 0,
        _lastbefore: null,
        _defaultContextMenuItems: [
            { name: "cut", text: "Cut" },
            { name: "copy", text: "Copy" },
            { name: "paste", text: "Paste" },
            { name: "undo", text: "Undo" },
            { name: "redo", text: "Redo" },
            { name: "selectAll", text: "Select All" },
            {
                name: "grouping",
                text: "Grouping",
                subItems: [
                    { name: "group", text: "Group" },
                    { name: "ungroup", text: "Ungroup" }
                ]
            },
            {
                name: "order",
                text: "Order",
                subItems: [
                    { name: "bringToFront", text: "Bring To Front" },
                    { name: "moveForward", text: "Move Forward" },
                    { name: "sendToBack", text: "Send To Back" },
                    { name: "sendBackward", text: "Send Backward" }
                ]
            }
        ],
        _hScrollOffset: 0,
        _vScrollOffset: 0,
        _hScrollbar: null,
        _vScrollbar: null,
        _scrollPixel: 30,
        _previousSelectedItems: [],
        _eventCause: {},
        _crudDeleteNodes: [],
        _isMobile: false,
        _labelHashTable: {},
        //#endregion
        //#region public members
        activeTool: null,
        selectionList: [],
        tools: null,
        nameTable: {},
        boundaryTable: {},
        //#endregion
        //#region Initialization
        _init: function () {
            this.boundaryTable = {};
            this.nameTable = {};
            this.selectionList = [];
            this._isInit = true;
            this.nameTable = {};
            this.boundaryTable = {};
            var svgSupport = (window.SVGSVGElement) ? true : false;
            if (svgSupport) {
                if (ej.widget.unobtrusive !== undefined) {
                    if (this.model.snapSettings.horizontalGridLines && this.model.snapSettings.horizontalGridLines.linesInterval && typeof (this.model.snapSettings.horizontalGridLines.linesInterval) === "string")
                        this.model.snapSettings.horizontalGridLines.linesInterval = JSON.parse(this.model.snapSettings.horizontalGridLines.linesInterval);
                    if (this.model.snapSettings.verticalGridLines && this.model.snapSettings.verticalGridLines.linesInterval && typeof (this.model.snapSettings.verticalGridLines.linesInterval) === "string")
                        this.model.snapSettings.verticalGridLines.linesInterval = JSON.parse(this.model.snapSettings.verticalGridLines.linesInterval);
                    if (this.model.defaultSettings.connector) {
                        var connector = ej.datavisualization.Diagram.Connector({});
                        this.model.defaultSettings.connector = this._equivalentPropMap(connector, this.model.defaultSettings.connector);
                    }
                    if (this.model.defaultSettings.node) {
                        var node = ej.datavisualization.Diagram.Node({});
                        this.model.defaultSettings.node = this._equivalentPropMap(node, this.model.defaultSettings.node);
                    }
                }
                var tempObj = this;
                if (tempObj.model.dataSourceSettings.crudAction.read) {
                    var callback = $.ajax({
                        type: 'GET',
                        url: tempObj.model.dataSourceSettings.crudAction.read,
                        async: false,
                        success: function (data, textStatus, xhr) {
                            tempObj.model.dataSourceSettings.dataSource = data;
                        },
                        error: function (xhr, textStatus, errorThrown) {
                        }
                    });
                    this._isWebAPI = true;
                }
                if (tempObj.model.dataSourceSettings.connectionDataSource.crudAction.read) {
                    var callback = $.ajax({
                        type: 'GET',
                        url: tempObj.model.dataSourceSettings.connectionDataSource.crudAction.read,
                        async: false,
                        success: function (data) {
                            tempObj.model.dataSourceSettings.connectionDataSource.dataSource = data;
                        },
                        error: function (errData) {

                        }
                    });
                    this._isWebAPI = true;
                }
                if (this.model.backgroundImage) {
                    var imagePath;
                    if (typeof this.model.backgroundImage === "string")
                        imagePath = this.model.backgroundImage;
                    if (typeof this.model.backgroundImage === "function")
                        imagePath = this.model.backgroundImage();
                    if (imagePath)
                        this.model.backgroundImage = ej.datavisualization.Diagram.BackgroundImage({ source: imagePath });
                }
                if (this._layoutMarginX()) {
                    this.model.layout.margin.left = this.model.layout.margin.right = this._layoutMarginX();
                }
                if (this._layoutMarginY()) {
                    this.model.layout.margin.top = this.model.layout.margin.bottom = this._layoutMarginY();
                }
                this._cloneGlobalVariables();
                this._spatialSearch = ej.datavisualization.Diagram.SpatialSearch();
                this._initDefaults();
                this._initViews();
                this._initData();
                this._initCanvas();
                this._initDiagramTool();
                this._initVisualGuide();
                this._wireEvents();
                this._initHandles();
                this._initContextMenu();
                this._drawingTool = false;
                this._isDropped = false;
                this._initCommands();
                this._initHistoryManager();
                if (this.model.zoomFactor && this.model.zoomFactor !== .2)
                    this.model.scrollSettings.zoomFactor = this.model.zoomFactor;
                this._updateScrollSettings(this.model.scrollSettings);
                delete this._viewPort;
                this._cloneModel = $.extend(true, {}, this.model);
            }
            delete this._isInit;
        },

        _equivalentPropMap: function (obj, sourceObj) {
            var obj1 = {}, field;
            for (var prop in obj) {
                field = prop.toLowerCase();
                if (ej.isPlainObject(sourceObj[field]) || ej.isPlainObject(sourceObj[prop])) {
                    obj1[prop] = this._equivalentPropMap(obj[prop], sourceObj[field] ? sourceObj[field] : sourceObj[prop]);
                }
                else if (sourceObj[field] || sourceObj[prop])
                    obj1[prop] = sourceObj[field] ? sourceObj[field] : sourceObj[prop];
            }
            return obj1;
        },

        refresh: function () {
            this._updateTableNodes();
            this._updateGroupChildren(this.model);
            if (this._isSwimlaneExist) {
                var connectors = this.connectors();
                for (var i = 0; i < connectors.length; i++) {
                    connectors[i].zOrder = -1;
                }
                delete this._isSwimlaneExist;
            }
            this._updateScrollOffset(0, 0);
            this._destroy();
            this.element.addClass("e-datavisualization-diagram");
            this._currZoom = 1;
            this._hScrollbar = null;
            this._vScrollbar = null;
            this._view = null;
            this._svg = null;
            this._page = null;
            this._pageBackgroundLayer = null;
            this._diagramLayer = null;
            this._htmlLayer = null;
            this.clearHistory();
            this._spatialSearch = ej.datavisualization.Diagram.SpatialSearch();
            if ((this.model.dataSourceSettings && this.model.dataSourceSettings.dataSource)) {
                this.nodes([]);
                this.connectors([]);
                this._nodes = [];
                this._connectors = [];
            }
            this._init();
        },

        _initCommands: function (newCommands) {
            var modifiers = ej.datavisualization.Diagram.KeyModifiers;
            var keys = ej.datavisualization.Diagram.Keys;
            var commands;
            if (newCommands) {
                commands = this.model.commandManager.commands;
            } else {
                newCommands = this.model.commandManager.commands;
                commands = {
                    "copy":
                        {
                            gesture: { key: keys.C, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "paste":
                        {
                            gesture: { key: keys.V, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "cut":
                        {
                            gesture: { key: keys.X, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "delete":
                        {
                            gesture: { key: keys.Delete },
                            _isDefault: true
                        },
                    "undo":
                        {
                            gesture: { key: keys.Z, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "redo":
                        {
                            gesture: { key: keys.Y, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "selectAll":
                        {
                            gesture: { key: keys.A, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "nudgeUp":
                        {
                            parameter: "up",
                            gesture: { key: keys.Up },
                            _isDefault: true
                        },
                    "nudgeRight":
                        {
                            parameter: "right",
                            gesture: { key: keys.Right },
                            _isDefault: true
                        },
                    "nudgeDown":
                        {
                            parameter: "down",
                            gesture: { key: keys.Down },
                            _isDefault: true
                        },
                    "nudgeLeft":
                        {
                            parameter: "left",
                            gesture: { key: keys.Left },
                            _isDefault: true
                        },
                    "startEdit":
                        {
                            gesture: { key: 113 },
                            _isDefault: true
                        },
                    "endEdit":
                        {
                            gesture: { key: keys.Escape }
                        },
                    "focusToNextItem":
                        {
                            gesture: { key: keys.Tab },
                            _isDefault: true
                        },
                    "focusToPreviousItem":
                        {
                            gesture: { key: keys.Tab, keyModifiers: modifiers.Control },
                            _isDefault: true
                        },
                    "selectFocusedItem":
                        {
                            gesture: { key: keys.Enter },
                            _isDefault: true
                        },
                };
                for (var j in commands)
                    this._initCommandValues(j, commands[j]);

            }
            var i;
            for (i in newCommands) {
                if (commands[i]) {
                    if (newCommands[i]) {
                        if (newCommands[i] && commands[i].gesture && newCommands[i].gesture) {
                            if (!this._isLoad) {
                                if (commands[i]._isDefault)
                                    delete commands[i]._isDefault;
                            }
                            newCommands[i].gesture = ej.datavisualization.Diagram.Gesture($.extend({}, true, commands[i].gesture, newCommands[i].gesture));
                            if (this._tempCommandManager && this._tempCommandManager.commands && this._tempCommandManager.commands[i]._isDefault) {
                                this._initCommandValues(i, newCommands[i]);
                            }
                        }
                        $.extend(commands[i], true, newCommands[i]);
                    } else commands[i] = null;
                } else {
                    if (newCommands[i]) {
                        var cmd = ej.datavisualization.Diagram.Command(newCommands[i]);
                        commands[i] = cmd;
                    }
                }
            }
            this.model.commandManager.commands = commands;
        },
        _initCommandValues: function (command, newCommands) {
            switch (command) {
                case "copy":
                    newCommands.execute = $.proxy(this.copy, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "paste":
                    newCommands.execute = $.proxy(this._commandPaste, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "cut":
                    newCommands.execute = $.proxy(this.cut, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "delete":
                    newCommands.execute = $.proxy(this.remove, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "undo":
                    newCommands.execute = $.proxy(this.undo, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "redo":
                    newCommands.execute = $.proxy(this.redo, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "selectAll":
                    newCommands.execute = $.proxy(this._selectCommand, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "nudgeUp":
                case "nudgeRight":
                case "nudgeDown":
                case "nudgeLeft":
                    newCommands.execute = $.proxy(this._nudgeCommand, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "startEdit":
                    newCommands.execute = $.proxy(this._startEditCommand, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "endEdit":
                    newCommands.execute = $.proxy(this._endEdit, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "focusToNextItem":
                case "focusToPreviousItem":
                    newCommands.execute = $.proxy(this._focusToItem, this);
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
                case "selectFocusedItem":
                    newCommands.execute = $.proxy(this._selectFocusedItem, this),
                    newCommands.canExecute = $.proxy(this._canExecute, this);
                    break;
            }
        },
        _initViews: function (isLoad) {
            if (!isLoad) {
                this._views = [];
                this._views.push(this._id);
            }
            this._views[this._id] = {
                "type": "mainview",
                "context": ej.datavisualization.Diagram.SvgContext,
                "style": "position:relative; height:" + this.model.height + "; width:" + this.model.width + ";"
            };
        },
        _initDefaults: function () {
            if (!(this.tool())) {
                if (ej.isMobile()) {
                    this.tool(ej.datavisualization.Diagram.Tool.ZoomPan);
                    this._isMobile = true;
                }
                else {
                    this.tool(ej.datavisualization.Diagram.Tool.SingleSelect | ej.datavisualization.Diagram.Tool.MultipleSelect);
                }
            }
            this._initTools();
        },
        _initCanvas: function (isload) {
            this._renderCanvas(isload);
        },
        _initVisualGuide: function () {
            if (this.model.tooltip) {
                this.model.tooltip = ej.datavisualization.Diagram.Tooltip(this.model.tooltip);
            }
            if (this.model.selectedItems) {
                if (this.model.selectorConstraints) {
                    this.model.selectedItems.constraints = this.model.selectorConstraints;
                }
                if (!ej.datavisualization.Diagram.Util.canEnableTooltip(this) || !this.showTooltip()) {
                    this.model.selectedItems.tooltip = null;
                }
                else {
                    if (this.model.selectedItems.tooltip) {
                        this.model.selectedItems.tooltip = ej.datavisualization.Diagram.Tooltip(this.model.selectedItems.tooltip);
                    }
                    else {
                        this.model.selectedItems.tooltip = ej.datavisualization.Diagram.Tooltip({ margin: { top: 10 } });
                    }

                }
                if (this.model.selectedItems.tooltip && this.model.tooltipTemplateId) {
                    this.model.selectedItems.tooltip.templateId = this.model.selectedItems.tooltip.templateId || this.model.tooltipTemplateId;
                }
            }
        },
        _initTools: function () {
            this.tools = {
                "select": new ej.datavisualization.Diagram.SelectTool(this),
                "move": new ej.datavisualization.Diagram.MoveTool(this),
                "resize": new ej.datavisualization.Diagram.ResizeTool(this),
                "rotate": new ej.datavisualization.Diagram.RotateTool(this),
                //"pivot": new ej.datavisualization.Diagram.PivotTool(this),
                "endPoint": new ej.datavisualization.Diagram.ConnectionEditTool(this),
                "panTool": new ej.datavisualization.Diagram.PanTool(this),
                "straightLine": new ej.datavisualization.Diagram.StraightLineTool(this),
                "orthogonalLine": new ej.datavisualization.Diagram.OrthogonalLineTool(this),
                "bezierLine": new ej.datavisualization.Diagram.BezierLineTool(this),
                "phase": new ej.datavisualization.Diagram.PhaseTool(this),
                "shapeTool": new ej.datavisualization.Diagram.ShapeTool(this),
                "text": new ej.datavisualization.Diagram.TextTool(this),
            };
            this._toolToActivate = "select";
            this.activeTool = this.tools[this._toolToActivate];
            this._registerDrawingTools();
        },
        _initDiagramTool: function () {
            var tool = this.tool();
            var shape;
            if (tool & ej.datavisualization.Diagram.Tool.ContinuesDraw) {
                if (this.model.drawType) {
                    shape = this.model.drawType.shape ? this.model.drawType.shape : this.model.drawType.type;
                    this._drawToolShape(shape, false);
                }
            } else if (tool & ej.datavisualization.Diagram.Tool.DrawOnce) {
                if (this.model.drawType) {
                    shape = this.model.drawType.shape ? this.model.drawType.shape : this.model.drawType.type;
                    this._drawToolShape(shape, true);
                }
            } else if (tool & ej.datavisualization.Diagram.Tool.ZoomPan) {
                if (ej.datavisualization.Diagram.Util.canPanning(this)) {
                    this._toolToActivate = "panTool";
                    this.activeTool = this.tools[this._toolToActivate];
                    this.activeTool._isMouseDown = false;
                    this._currentCursor = "pointer";
                }
            } else if (tool & ej.datavisualization.Diagram.Tool.MultipleSelect) {
                this.activateTool("select");
                this.activeTool.singleAction = false;
            }
        },
        _initHandles: function () {
            var userHandles = this.model.selectedItems.userHandles;
            if (userHandles) {
                for (var i = 0; i < userHandles.length; i++) {
                    userHandles[i] = ej.datavisualization.Diagram.UserHandle(userHandles[i]);
                    if (userHandles[i].tool) {
                        userHandles[i].tool.diagram = this;
                        this.tools[userHandles[i].name] = userHandles[i].tool;
                    }
                }
            }
        },
        _initHistoryManager: function () {
            this.model.historyManager.push = $.proxy(this.addHistoryEntry, this);
            this.model.historyManager.pop = $.proxy(this.removeHistoryEntry, this);
            this.model.historyManager.canPop = $.proxy(this.canRemoveHistoryEntry, this);
            this.model.historyManager.startGroupAction = $.proxy(this._startGroupAction, this);
            this.model.historyManager.closeGroupAction = $.proxy(this._closeGroupAction, this);
        },

        _cloneGlobalVariables: function () {
            this._historyList = $.extend(true, {}, this._historyList);
        },
        _setNodesConnectors: function (options, isLoad) {
            var nodes = [], sNodes = false, sConnectors = false;
            var nLength = options.nodes ? (typeof options.nodes === 'function' ? options.nodes().length : options.nodes.length) : 0;
            var cLength = options.connectors ? (options.connectors && typeof options.connectors === 'function' ? options.connectors().length : options.connectors.length) : 0;
            if (options.nodes && nLength != this._nodes.length) {
                for (var i = 0; i < this.nodes().length; i++)
                    this._removeElementFromCollection(this.nameTable[this.nodes()[i].name]);
                this._isPreventModelChange = true;
                this.nodes(typeof options.nodes === 'function' ? options.nodes() : options['nodes']);
                this._isPreventModelChange = false;
                this._initNodeCollection(isLoad);
                sNodes = true;
            }
            if (options.connectors && cLength != this._connectors.length) {
                for (var i = 0; i < this.connectors().length; i++)
                    this._removeElementFromCollection(this.nameTable[this.connectors()[i].name]);
                this._isPreventModelChange = true;
                this.connectors(typeof options.connectors === 'function' ? options.connectors() : options['connectors']);
                this._isPreventModelChange = false;
                this._initConnectorCollection(); sConnectors = true;
            }
            nodes = this.nodes();
            nodes = nodes.length > 0 ? this.nodes().concat(this.connectors()) : this.connectors();
            if (nodes.length > 0 || options.nodes.length == 0 || options.connectors.length == 0) {
                this._resetObjectCollection(nodes, isLoad, sNodes, sConnectors);
            }
            return true;
        },
        _removeElementFromCollection: function (item) {
            if (item) {
                if (item.children) {
                    for (var i = 0; i < item.children.length; i++)
                        this._removeElementFromCollection(this.nameTable[item.children[i]]);
                }
                if (item.segments)
                    this._removeEdges(item);
                else {
                    this._disConnect(item, {});
                    item.inEdges = item.outEdges = [];
                }
                ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[item.name], item);
                ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, item);
                this._removeElement(item);
                delete this.nameTable[item.name];
            }
        },
        _updateCloneModel: function (arg) {
            if (arg) {
                this._cloneModel[arg] = typeof (this.model[arg]) === "string" ? this.model[arg] : $.extend(true, {}, this.model[arg]);
            }
        },
        _compareModelProperty: function (arg, interaction, root) {
            if (arg) {
                if (this._cloneModel[arg] !== this.model[arg]) {
                    var args = {};
                    args[arg] = this.model[arg];
                    this._comparePropertyValues(this._cloneModel, arg, args, interaction, root);
                    this._updateCloneModel(arg);
                }
            }
        },

        _setModel: function (options) {
            var initObject = false;
            var diagram, object;
            for (var option in options) {
                switch (option) {
                    case "height":
                    case "width":
                        this._initViews(true);
                        this._initCanvas(true);
                        break;
                    case "nodes":
                    case "connectors":
                        if (!initObject && !this._isPreventModelChange && (!(this._isRefreshTriggered && typeof this.model.nodes==="function"))) {
                            initObject = this._setNodesConnectors(options, this._isLoad);
                            this._trigger("refresh");
                        }
                        delete this._isRefreshTriggered;
                        break;
                    case "enableContextMenu":
                        this.model.enableContextMenu = options[option];
                        this._initContextMenu(this._isLoad);
                        break;
                    case "contextMenu":
                        this.model.contextMenu = $.extend({}, this.model.contextMenu, options[option]);
                        this._initContextMenu(this._isLoad);
                        break;
                    case "snapSettings":
                        object = options[option];
                        if (object && Object.keys(object).length > 0) {
                            this._updateSnapSettings(options[option]);
                            ej.datavisualization.Diagram.SvgContext._renderGrid(this._canvas, this._svg, this._page, this);
                        }
                        break;
                    case "selectorConstraints":
                        this._setSelectorConstraints(options[option]);
                        break;
                    case "constraints":
                        this.model.constraints = options[option];
                        if (this._hasSelection() && !ej.datavisualization.Diagram.Util.isPageEditable(this))
                            this._clearSelection();
                        var totalConnectors = this._getConnectors();
                        if (totalConnectors.length > 0) {
                            for (var i = 0; i < totalConnectors.length; i++) {
                                ej.datavisualization.Diagram.Util.updateBridging(this.model.connectors[i], this);
                                ej.datavisualization.Diagram.DiagramContext.update(this.model.connectors[i], this);
                            }
                        }

                        break;
                    case "drawingTools":
                        this.model.drawingTools = options[option];
                        this._registerDrawingTools();
                        break;
                    case "backgroundImage":
                        if (this.model.backgroundImage && typeof this.model.backgroundImage == "string") {
                            this.model.backgroundImage = ej.datavisualization.Diagram.BackgroundImage({ source: this.model.backgroundImage });
                        }
                        else
                            this.model.backgroundImage = $.extend(true, {}, this.model.backgroundImage, options[option]);
                        ej.datavisualization.Diagram.SvgContext._renderBackground(this, this._canvas, this._svg, this._page, this.model);
                        break;
                    case "backgroundColor":
                        this.model.backgroundColor = options[option];
                        ej.datavisualization.Diagram.SvgContext._renderBackground(this, this._canvas, this._svg, this._page, this.model);
                        break;
                    case "enableAutoScroll":
                        this.enableAutoScroll(options[option]);
                        break;
                    case "autoScrollMargin":
                        this.model.autoScrollMargin = options[option];
                        break;
                    case "layout":
                        if (options[option].marginX)
                            this.model.layout.margin.left = this.model.layout.margin.right = Number(typeof options[option].marginX === 'function' ? this._layoutMarginX() : options[option].marginX);
                        if (options[option].marginY)
                            this.model.layout.margin.top = this.model.layout.margin.bottom = Number(typeof options[option].marginY === 'function' ? this._layoutMarginY() : options[option].marginY);
                        this.model.layout = $.extend(true, {}, this.model.layout, options[option]);
                        this._setLayout(options[option]);
                        break;
                    case "selectedItems":
                        this.updateSelector(options[option]);
                        break;
                    case "pageSettings":
                        this.updatePageSettings(options[option]);
                        break;
                    case "scrollSettings":
                        this._updateScrollSettings(options[option]);
                        break;
                    case "locale":
                        this.locale(options[option]);
                        var contextmenu = document.getElementById(this.element[0].id + "_contextMenu");
                        contextmenu.parentNode.removeChild(contextmenu);
                        if (this.model.contextMenu && this.model.contextMenu.items && this.model.contextMenu.items.length > 0)
                            this.model.contextMenu.items = [];
                        this._renderContextMenu();
                        break;
                    case "nodeTemplate":
                        this.clear();
                        this._initData();
                        diagram = this;
                        this._views.forEach(function (viewid) {
                            var view = diagram._views[viewid];
                            var nodes = diagram._setNodeZOrder(view);
                            diagram._renderDiagramObjects(nodes, view);
                        });
                        this.layout();
                        break;
                    case "bridgeDirection":
                    case "tool":
                        this.update(options);
                        break;
                    case "connectorTemplate":
                        this._updateConnectors();
                        break;
                    case "commandManager":
                        var commands = options[option] && options[option]["commands"] ? options[option]["commands"] : undefined;
                        this._initCommands(commands);
                        break;
                    case "historyManager":
                        this.model.historyManager = $.extend(true, this.model.historyManager, {}, options[option]);
                        var stackLimit = this.model.historyManager.stackLimit;
                        var rLength = this.model.historyManager.redoStack.length
                        var uLength = this.model.historyManager.undoStack.length
                        if (rLength > 0) {
                            if (rLength > stackLimit) {
                                var sliceEnd = rLength - stackLimit;
                                this.model.historyManager.redoStack.splice(0, sliceEnd);
                                this.model.historyManager.undoStack = [];
                            }
                            else {
                                var remaiRemove = stackLimit - rLength;
                                var sliceEnd = uLength - remaiRemove;
                                this.model.historyManager.undoStack.splice(0, sliceEnd);
                            }
                        }
                        if (uLength > 0) {
                            var sliceEnd = uLength - stackLimit;
                            if (sliceEnd > 0) {
                                this.model.historyManager.undoStack.splice(0, sliceEnd);
                            }
                        }
                        this._initHistoryManager();
                        break;
                    case "showTooltip":
                        this.model.showTooltip = options[option];
                        if (this.showTooltip())
                            this.model.selectedItems.tooltip = ej.datavisualization.Diagram.Tooltip({ margin: { top: 10 } });
                        else
                            this.model.selectedItems.tooltip = null;
                        break;
                    case "toolTipTemplateId":
                        if (!this.model.selectedItems.tooltip)
                            this.model.selectedItems.tooltip = ej.datavisualization.Diagram.Tooltip({ margin: { top: 10 } });
                        this.model.selectedItems.tooltip.templateId = options[option];
                        break;
                    case "tooltip":
                        if (options[option] === null) this.model.tooltip = null;
                        else
                            this.model.tooltip = ej.datavisualization.Diagram.Tooltip($.extend(true, this.model.tooltip, {}, options[option]));
                        break;
                    case "dataSourceSettings":
                        object = options[option];
                        if (object && Object.keys(object).length > 0) {
                            this.clear();
                            $.extend(this.model.dataSourceSettings, options[option]);
                            this._initData();
                            diagram = this;
                            this._views.forEach(function (viewid) {
                                var view = diagram._views[viewid];
                                var nodes = diagram._setNodeZOrder(view);
                                diagram._renderDiagramObjects(nodes, view);
                            });
                            this.layout();
                        }
                        break;
                }
                if (!(option === "nodes" || option === "connectors" || option === "selectorConstraints" || option === "selectedItems" || option === "bridgeDirection" || option === "tool" || option === "dataSourceSettings"))
                    this._compareModelProperty(option);
            }
        },
        _resetObjectCollection: function (nodes, isLoad, sNode, sConnectors) {
            if (sNode) {
                $(this.element).find(".ej-d-node").remove();
                $(this.element).find(".ej-d-group").remove();
                $(this.element).find(".ej-d-seperator").remove();
            }
            if (sConnectors) {
                var children = $(this.element).find(".ej-d-connector");
                for (var i = children.length - 1; i >= 0; i--) {
                    var child = this.nameTable[children[i].id];
                    if (child && child.parent == "")
                        $(children[i]).remove();
                }
            }
            if (this._hasSelection())
                this._clearSelection();
            var diagram = this;
            this._views.forEach(function (viewid) {
                var view = diagram._views[viewid];
                var nodes = diagram._setNodeZOrder(view);
                diagram._renderDiagramObjects(nodes, view);
            });

        },
        _getConnectors: function () {
            var connectors = [];
            for (var prop in this.nameTable) {
                var connector = this.nameTable[prop];
                if (connector._type === "connector" || connector.segments)
                    connectors.push(connector);
            }
            return connectors;
        },

        _generateNodes: function (dataSource) {
            var nodes = [];
            for (var i = 0; i < dataSource.length; i++) {
                var row = dataSource[i];
                var node = this._makeNode(row);
                if (node != null && node.name && !this._findNodeByName(nodes, node.name)) {
                    nodes.push(node);
                }
            }
            return nodes;
        },

        _generateConnectors: function (dataSource) {
            var connectors = [];
            for (var i = 0; i < dataSource.length; i++) {
                var row = dataSource[i];
                var conn = this._makeLine(row);
                if (conn && conn.name && !this._findNodeByName(connectors, conn.name))
                    connectors.push(conn);
            }
            return connectors;
        },

        _findNodeByName: function (nodes, name) {
            for (var i = 0; i < nodes.length; i++) {
                if (nodes[i].name === name)
                    return true;
            }
            return false;
        },

        _makeNode: function (row) {
            var fields = this.model.dataSourceSettings;
            var node = {};
            var nodeName = row[fields.id];
            if (nodeName) {
                node.name = nodeName;
                if (fields.customFields && fields.customFields.length > 0) {
                    for (var i = 0; i < fields.customFields.length; i++)
                        node[fields.customFields[i]] = row[fields.customFields[i]];
                }
                return node;
            }
            else
                return null;
        },

        _makeLine: function (row) {
            var fields = this.model.dataSourceSettings.connectionDataSource;
            var conn = {};
            conn.name = row[fields.id] ? row[fields.id] : "connector_" + ej.datavisualization.Diagram.Util.randomId();
            conn.sourceNode = row[fields.sourceNode];
            conn.targetNode = row[fields.targetNode];
            if (row[fields.sourcePointX] && row[fields.sourcePointY])
                conn.sourcePoint = { "x": Number(row[fields.sourcePointX]), "y": Number(row[fields.sourcePointY]) };
            if (row[fields.targetPointX] && row[fields.targetPointY])
                conn.targetPoint = { "x": Number(row[fields.targetPointX]), "y": Number(row[fields.targetPointY]) };
            if (fields.customFields && fields.customFields.length > 0) {
                for (var i = 0; i < fields.customFields.length; i++)
                    conn[fields.customFields[i]] = row[fields.customFields[i]];
            }
            return conn;
        },

        insertData: function (node) {
            var mappingData;
            if (node) {
                var data, url;
                data = this._parameterMap(node);
                if (node.type === "connector")
                    url = this.model.dataSourceSettings.connectionDataSource.crudAction.create;
                else
                    url = this.model.dataSourceSettings.crudAction.create;
                if (data) {
                    this._raiseAjaxPost(JSON.stringify({ "data": [data] }), url);
                }
            }
            else {
                var newObjects = this._getNewNodes();
                if (newObjects.nodes) {
                    var mappingData, data = [];
                    for (var i = 0; i < newObjects.nodes.length; i++) {
                        data.push(this._parameterMap(newObjects.nodes[i]));
                    }
                    if (data && data.length > 0)
                        this._raiseAjaxPost(JSON.stringify({ "data": data }), this.model.dataSourceSettings.crudAction.create);
                }
                if (newObjects.connectors) {
                    var mappingData, data = [];
                    for (var i = 0; i < newObjects.connectors.length; i++) {
                        data.push(this._parameterMap(newObjects.connectors[i]));
                    }
                    if (data && data.length > 0)
                        this._raiseAjaxPost(JSON.stringify({ "data": data }), this.model.dataSourceSettings.connectionDataSource.crudAction.create);
                }
            }

        },

        updateData: function (node) {
            var mappingData;
            if (node) {
                var data, url;
                data = this._parameterMap(node);
                if (node.type === "connector")
                    url = this.model.dataSourceSettings.connectionDataSource.crudAction.update;
                else
                    url = this.model.dataSourceSettings.crudAction.update;
                if (data) {
                    this._raiseAjaxPost(JSON.stringify({ "data": [data] }), url);
                }
            }
            else {
                var newObjects = this._getUpdatedNodes();
                if (newObjects.nodes) {
                    var mappingData, data = [];
                    for (var i = 0; i < newObjects.nodes.length; i++) {
                        data.push(this._parameterMap(newObjects.nodes[i]));
                    }
                    if (data && data.length > 0)
                        this._raiseAjaxPost(JSON.stringify({ "data": data }), this.model.dataSourceSettings.crudAction.update);
                }
                if (newObjects.connectors) {
                    var mappingData, data = [];
                    for (var i = 0; i < newObjects.connectors.length; i++) {
                        data.push(this._parameterMap(newObjects.connectors[i]));
                    }
                    if (data && data.length > 0)
                        this._raiseAjaxPost(JSON.stringify({ "data": data }), this.model.dataSourceSettings.connectionDataSource.crudAction.update);
                }
            }
        },

        removeData: function (node) {
            var mappingData;
            if (node) {
                var data, url;
                data = this._parameterMap(node);
                if (node.type === "connector")
                    url = this.model.dataSourceSettings.connectionDataSource.crudAction.destroy;
                else
                    url = this.model.dataSourceSettings.crudAction.destroy;
                if (data) {
                    this._raiseAjaxPost(JSON.stringify({ "data": [data] }), url);
                }
            }
            else {
                var newObjects = this._getDeletedNodes();
                if (newObjects.nodes) {
                    var mappingData, data = [];
                    for (var i = 0; i < newObjects.nodes.length; i++) {
                        data.push(this._parameterMap(newObjects.nodes[i]));
                    }
                    if (data && data.length > 0)
                        this._raiseAjaxPost(JSON.stringify({ "data": data }), this.model.dataSourceSettings.crudAction.destroy);
                }
                if (newObjects.connectors) {
                    var mappingData, data = [];
                    for (var i = 0; i < newObjects.connectors.length; i++) {
                        data.push(this._parameterMap(newObjects.connectors[i]));
                    }
                    if (data && data.length > 0)
                        this._raiseAjaxPost(JSON.stringify({ "data": data }), this.model.dataSourceSettings.connectionDataSource.crudAction.destroy);
                }
            }
        },

        _parameterMap: function (object, url) {
            var mappingObj = {};
            if (object.type === "connector") {
                var fields = this.model.dataSourceSettings.connectionDataSource;
                if (fields.id)
                    mappingObj[fields.id] = object.name;
                if (fields.sourcePointX && fields.sourcePointY) {
                    mappingObj[fields.sourcePointX] = object.sourcePoint.X;
                    mappingObj[fields.sourcePointY] = object.sourcePoint.Y;
                }
                if (fields.targetPointX && fields.targetPointY) {
                    mappingObj[fields.targetPointX] = object.targetPoint.X;
                    mappingObj[fields.targetPointY] = object.targetPoint.Y;
                }
                if (fields.sourceNode)
                    mappingObj[fields.sourceNode] = object.sourceNode;
                if (fields.targetNode)
                    mappingObj[fields.targetNode] = object.targetNode;
                if (fields.customFields && fields.customFields.length > 0) {
                    for (var i = 0; i < fields.customFields.length; i++)
                        mappingObj[fields.customFields[i]] = object[fields.customFields[i]];
                }
            }
            else {
                var fields = this.model.dataSourceSettings;
                if (fields.id)
                    mappingObj[fields.id] = object.name;
                if (fields.width)
                    mappingObj[fields.width] = object.width;
                if (fields.height)
                    mappingObj[fields.height] = object.height;
                if (fields.offsetX)
                    mappingObj[fields.offsetX] = object.offsetX;
                if (fields.offsetY)
                    mappingObj[fields.offsetY] = object.offsetY;
                if (fields.customFields && fields.customFields.length > 0) {
                    for (var i = 0; i < fields.customFields.length; i++)
                        mappingObj[fields.customFields[i]] = object[fields.customFields[i]];
                }
            }
            return mappingObj;
        },

        _raiseAjaxPost: function (data, url) {
            var tempObj = this;
            var callback = $.ajax({
                contentType: 'application/json',
                type: 'POST',
                url: url,
                data: this._isWebAPI ? JSON.stringify(JSON.parse(data).data) : JSON.stringify(JSON.parse(data)),
                dataType: "json",
                error: function (errData) {
                    if (errData.status === 404) {
                        console.log("Method not found");
                    }
                }
            });
        },

        _initData: function () {
            if (this.model.dataSourceSettings) {
                var dataSourceSettings = {};
                if (this.model.dataSourceSettings.dataSource && this.model.dataSourceSettings.connectionDataSource.dataSource) {
                    dataSourceSettings.dataSource = this.model.dataSourceSettings.dataSource;
                    dataSourceSettings.isBinding = true;
                    dataSourceSettings.nodes = this._generateNodes(this.model.dataSourceSettings.dataSource);
                    dataSourceSettings.connectors = this._generateConnectors(this.model.dataSourceSettings.connectionDataSource.dataSource);
                }
                else if (this.model.dataSourceSettings.dataSource) {
                    dataSourceSettings.id = this._dataSourceUniqueId();
                    dataSourceSettings.parent = this._dataSourceParentId();
                    dataSourceSettings.root = this._dataSourceRoot();
                    dataSourceSettings.dataSource = this._dataSource();
                    dataSourceSettings.tableName = this._dataSourceTableName();
                    dataSourceSettings.query = this._dataSourceQueryString();
                }
                var dataSource = dataSourceSettings.dataSource || this.model.dataSourceSettings.nodes || this.model.dataSourceSettings.connectors;
            }
            if (dataSource) {
                var nodes = [];
                var connectors = [];
                var dataSourceApplied;
                if (dataSourceSettings && dataSourceSettings.isBinding) {
                    if (dataSourceSettings.nodes && dataSourceSettings.nodes.length > 0) {
                        this._applyTemplate(this.model.dataSourceSettings, dataSourceSettings.nodes, nodes, "nodes");
                    }
                    if (dataSourceSettings.connectors && dataSourceSettings.connectors.length > 0) {
                        this._applyTemplate(this.model.dataSourceSettings, dataSourceSettings.connectors, connectors, "connectors");
                    }
                    //dataSourceApplied = true;
                }
                else if (this.model.dataSourceSettings.nodes || this.model.dataSourceSettings.connectors) {
                    if (this.model.dataSourceSettings.nodes) {
                        dataSource = this.model.dataSourceSettings.nodes || this.model.dataSourceSettings.dataSource;
                        if (dataSource) {
                            if (dataSource instanceof ej.DataManager) {
                                $.ajaxSetup({
                                    async: false
                                });
                                var query = this._findQuery(this.model.dataSourceSettings.nodes, this.model.dataSourceSettings.nodeBinding);
                                var queryPromise = dataSource.executeQuery(eval(query));
                                var diagram = this;
                                queryPromise.done(function (e) {
                                    diagram.retriveData = e.result;
                                    diagram._applyTemplate(diagram.model.dataSourceSettings, e.result, nodes, "nodes");
                                });
                            } else
                                this._applyTemplate(this.model.dataSourceSettings, dataSource, nodes, "nodes");
                        }
                        if (this.model.dataSourceSettings.connectors) {
                            dataSource = this.model.dataSourceSettings.connectors || this.model.dataSourceSettings.dataSource;
                            if (dataSource) {
                                if (dataSource instanceof ej.DataManager) {
                                    $.ajaxSetup({
                                        async: false
                                    });
                                    query = this._findQuery(this.model.dataSourceSettings.connectors, this.model.dataSourceSettings.connectorBinding);
                                    queryPromise = dataSource.executeQuery(eval(query));
                                    queryPromise.done(function (e) {
                                        diagram.retriveData = e.result;
                                        diagram._applyTemplate(diagram.model.dataSourceSettings, e.result, connectors, "connectors");
                                    });
                                } else {
                                    this._applyTemplate(this.model.dataSourceSettings, dataSource, connectors, "connectors");
                                }
                            }
                        }
                    }
                } else if (dataSource instanceof ej.DataManager) {
                    this._initDataSource(dataSourceSettings, nodes, connectors);
                    if (dataSourceSettings.parent)
                        dataSourceApplied = true;
                }
                else if (typeof dataSource != "string" && dataSource.length) {
                    this._applyDataSource(dataSourceSettings, dataSource, nodes, connectors);
                    if (this.model.dataSourceSettings.parent)
                        dataSourceApplied = true;
                }
                var tempNodes = [], tempconnectors = [];
                if (this.nodes().length > 0)
                    tempNodes = this.nodes();
                if (this.connectors().length > 0)
                    tempconnectors = this.connectors();
                this.nodes(nodes);
                this.connectors(connectors);
                var i;
                for (i = 0; i < tempNodes.length; i++) {
                    this.nodes().push(tempNodes[i]);
                    this._nodes = $.extend(true, [], this.nodes());
                }
                for (i = 0; i < tempconnectors.length; i++) {
                    this.connectors().push(tempconnectors[i]);
                    this._connectors = $.extend(true, [], this.connectors());
                }
            }
            var collapsedNodes = this._initNodeCollection(false, dataSourceApplied);
            this._initConnectorCollection(dataSourceApplied);
            if (collapsedNodes.length > 0) {
                this._collapseNodes(collapsedNodes);
            }
            this._cloneModel = $.extend(true, {}, this.model);
        },

        _getNodeTemplate: function () {
            var nodeTemplate;
            if (this.model.nodeTemplate) {
                if (typeof this.model.nodeTemplate === "string") {
                    nodeTemplate = ej.util.getObject(this.model.nodeTemplate, window);
                }
                if ($.isFunction(this.model.nodeTemplate)) {
                    nodeTemplate = this.model.nodeTemplate;
                }
            }
            return nodeTemplate;
        },

        _getConnectorTemplate: function () {
            var connectorTemplate;
            if (this.model.connectorTemplate) {
                if (typeof this.model.connectorTemplate === "string") {
                    this.model.connectorTemplate = ej.util.getObject(this.model.connectorTemplate, window);
                }
                if ($.isFunction(this.model.connectorTemplate)) {
                    connectorTemplate = this.model.connectorTemplate;
                }
            }
            return connectorTemplate;
        },

        _initNodeCollection: function (isLoad, dataSourceApplied) {
            var collapsedNodes = [];
            var nodes = this.nodes();
            var length = this.nodes().length;
            var nodeTemplate;
            if (!this.model.dataSourceSettings.dataSource)
                nodeTemplate = this._getNodeTemplate();
            this._isNodeInitializing = true;
            for (var i = 0; i < length; i++) {
                if ((nodes[i].container && !$.isEmptyObject(nodes[i].container)) || nodes[i].isSwimlane || nodes[i].type === "swimlane") {
                    nodes[i] = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, nodes[i]);
                }
                else if (typeof nodes[i].shape !== "object") {
                    nodes[i] = ej.datavisualization.Diagram.NodeType(nodes[i], this);
                }
                if (nodes[i].name == "") {
                    nodes[i].name = "node_" + ej.datavisualization.Diagram.Util.randomId();
                }
                if (nodes[i].type === "swimlane" || nodes[i].isSwimlane) {
                    this.nameTable[nodes[i].name] = ej.datavisualization.Diagram.Group(nodes[i]);

                } else if (nodes[i]._type === "group" || (nodes[i].children && nodes[i].children.length > 0)) {
                    if (nodes[i].type == "bpmn" && nodes[i].container)
                        nodes[i] = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, nodes[i]);
                    else
                        nodes[i] = this._getNewGroup(nodes[i]);
                    nodes[i]._type = "group";
                    this.nameTable[nodes[i].name] = nodes[i];
                    this._initGroupNode(nodes[i]);
                    if (!isLoad && nodes[i].type !== "bpmn")
                        this._udpateChildRotateAngle(nodes[i]);
                } else {
                    if (!dataSourceApplied) {
                        nodes[i] = this._getNewNode(nodes[i]); //ej.datavisualization.Diagram.Node(nodes[i]);
                        this.nameTable[nodes[i].name] = nodes[i];
                    } else if (nodes[i].shape && typeof nodes[i].shape === "object")
                        ej.datavisualization.Diagram.Util._updateShapeProperties(nodes[i]);
                }
                if (!dataSourceApplied && nodeTemplate) {
                    nodeTemplate(this, nodes[i]);
                    if (typeof nodes[i].shape !== "object") {
                        nodes[i] = ej.datavisualization.Diagram.NodeType(nodes[i], this);
                    }
                    if (nodes[i]._type === "group" || (nodes[i].children && nodes[i].children.length > 0)) {
                        if (nodes[i].type == "bpmn" && nodes[i].container)
                            nodes[i] = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, nodes[i]);
                        else
                            nodes[i] = this._getNewGroup(nodes[i]);
                        this._initGroupNode(nodes[i]);
                    }
                }
                if (nodes[i]._type === "node" && nodes[i].labels.length && (nodes[i].width == 0 || nodes[i].height == 0))
                    this._getNodeDimension(nodes[i]);
                this.nameTable[nodes[i].name] = nodes[i];
                this._updateQuad(nodes[i]);
                if (!nodes[i].isExpanded) {
                    collapsedNodes.push(nodes[i]);
                }
            }
            delete this._isNodeInitializing;
            this._nodes = $.extend(true, [], nodes);
            return collapsedNodes;
        },
        _initConnectorCollection: function (dataSourceApplied) {
            var connectors = this.connectors();
            var connector;
            var connectorTemplate = this._getConnectorTemplate();
            for (var i = 0, len = connectors.length; i < len; i++) {
                connector = dataSourceApplied ? connectors[i] : this._getNewConnector(connectors[i]);
                this.nameTable[connector.name] = connector;
                if (!dataSourceApplied) {
                    if (this.model.layout && this._layoutType() === ej.datavisualization.Diagram.LayoutTypes.None)
                        this._dock(connector, this.nameTable);
                }
                this._updateEdges(connector);
                if (connectorTemplate && !dataSourceApplied) connectorTemplate(this, connector);
                connectors[i] = connector;
            }
            this._connectors = $.extend(true, [], connectors);
        },

        //#region Data Source
        _initDataSource: function (dataSourceSettings, nodes, connectors) {
            var dataSource = dataSourceSettings.dataSource;
            var diagram = this;
            if (dataSource.dataSource.json && dataSource.dataSource.json.length > 0) {
                diagram._applyDataSource(dataSourceSettings, dataSource.dataSource.json, nodes, connectors);
            }
            else if (!dataSource.dataSource.table) {
                var mapper = dataSourceSettings;
                if (dataSource instanceof ej.DataManager) {
                    $.ajaxSetup({
                        async: false
                    });
                    var query = this._findQuery(mapper, dataSourceSettings.nodeBinding);
                    var queryPromise = dataSourceSettings["dataSource"].executeQuery(eval(query));
                    queryPromise.done(function (e) {
                        diagram.retriveData = e.result;
                        diagram._applyDataSource(dataSourceSettings, e.result, nodes, connectors);
                    });
                }
            }
        },
        _findQuery: function (mapper, binding) {
            var column = [], queryManager = ej.Query();
            var query = mapper.query || this.model.dataSourceSettings.query;

            if (ej.isNullOrUndefined(query)) {
                var dataSource = mapper.dataSource || this.model.dataSourceSettings.dataSource;
                var tableName = mapper.tableName || this.model.dataSourceSettings.tableName;;
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "dataSource" && col !== "designTemplate" && !col.match("Binding"))
                        if (mapper[col]) column.push(mapper[col]);
                }
                for (var tempcol in binding) {
                    if (tempcol === "labels") {
                        var labels = binding[tempcol];
                        for (var i = 0; i < labels.length; i++) {
                            if (labels[i].text) column.push(labels[i].text);
                        }
                    } else if (tempcol == "shape" || tempcol == "line") {
                        if (binding[tempcol][type]) col.push(binding[tempcol][type]);
                    } else
                        if (binding[tempcol]) column.push(binding[tempcol]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!dataSource["dataSource"].url.match(tableName + "$"))
                    !ej.isNullOrUndefined(tableName) && queryManager.from(tableName);
            } else
                queryManager = query;
            return queryManager;
        },
        _updateMultipleRootNodes: function (obj, rootNodes, mapper, data) {
            var parents = obj[mapper.parent], parent;
            if (parents && parents.length > 0) {
                for (var i = 0; i < parents.length; i++) {
                    parent = parents[i];
                    if (rootNodes[parent])
                        rootNodes[parent].items.push(obj);
                    else
                        rootNodes[parent] = { items: [obj] };
                }
            }
            return rootNodes;
        },

        _applyDataSource: function (mapper, data, nodes, connectors) {
            var rootNodes = [];
            var firstNode, r, i, j, item, node, n, obj, firstLvel, nextLevel, nodeTemplate, connectorTemplate;
            for (r = 0; r < data.length; r++) {
                obj = data[r];
                if (!($.isArray(obj[mapper.parent]))) {
                    if (rootNodes[obj[mapper.parent]])
                        rootNodes[obj[mapper.parent]].items.push(obj);
                    else
                        rootNodes[obj[mapper.parent]] = { items: [obj] };
                }
                else
                    rootNodes = this._updateMultipleRootNodes(obj, rootNodes, mapper, data);
                if (mapper.root === obj[mapper.id])
                    firstNode = { items: [obj] };
            }
            firstLvel = [];
            if (mapper.parent) {
                if (firstNode)
                    firstLvel.push(firstNode);
                else {
                    for (n in rootNodes) {
                        if ((!n && n !== 0) || n == "undefined" || n == "\"\"" || n == "null") {
                            firstLvel.push(rootNodes[n]);
                        }
                    }
                }
            }
            else firstLvel.push(rootNodes[undefined]);
            if (this.model.nodeTemplate)
                nodeTemplate = this._getNodeTemplate();
            if (this.model.connectorTemplate)
                connectorTemplate = this._getConnectorTemplate();
            for (i = 0; i < firstLvel.length; i++) {
                for (j = 0; j < firstLvel[i].items.length; j++) {
                    item = firstLvel[i].items[j];
                    node = this._applyNodeTemplate(mapper, item, nodeTemplate);
                    nodes.push(node);
                    if (mapper.parent) {
                        nextLevel = rootNodes[node[mapper.id]];
                        if (nextLevel && nextLevel.items)
                            this._renderChildNodes(mapper, nextLevel, node.name, nodes, connectors, rootNodes, nodeTemplate, connectorTemplate);
                    }
                }
            }
        },

        _getNewNodes: function () {
            var nodes = [], connectors = [];
            for (var name in this.nameTable) {
                var node = this.nameTable[name];
                if (node && node.type === "connector" && node._status === "new") {
                    node._status = "";
                    connectors.push(node);
                }
                else if (node && node._status === "new") {
                    node._status = "";
                    nodes.push(node);
                }
            }
            return { nodes: nodes, connectors: connectors };
        },

        _getUpdatedNodes: function () {
            var nodes = [], connectors = [];
            for (var name in this.nameTable) {
                var node = this.nameTable[name];
                if (node && node.type === "connector" && node._status === "update") {
                    node._status = "";
                    connectors.push(node);
                }
                else if (node && node._status === "update") {
                    node._status = "";
                    nodes.push(node);
                }
            }
            return { nodes: nodes, connectors: connectors };
        },

        _getDeletedNodes: function () {
            var nodes = [], connectors = [];
            for (var i = 0; i < this._crudDeleteNodes.length; i++) {
                var node = this._crudDeleteNodes[i];
                if (node && node.type === "connector")
                    connectors.push(node);
                else if (node) {
                    nodes.push(node);
                }
            }
            this._crudDeleteNodes = [];
            return { nodes: nodes, connectors: connectors };
        },

        _isContainsSameConnector: function (connectors, sourceNode, targetNode) {
            if (sourceNode && targetNode) {
                for (var i = 0; i < connectors.length; i++) {
                    var connector = connectors[i];
                    if (connector && (connector.sourceNode === sourceNode && connector.targetNode === targetNode)) {
                        return true;
                    }
                }
            }
            return false;
        },
        _renderChildNodes: function (mapper, parent, ancestor, nodes, connectors, rootNodes, nodeTemplate, connectorTemplate) {
            var j, child, node, nextLevel;
            for (j = 0; j < parent.items.length; j++) {
                child = parent.items[j];
                node = this._applyNodeTemplate(mapper, child, nodeTemplate);
                if (!this._collectionContains(node.name, nodes))
                    nodes.push(node);
                if (!this._isContainsSameConnector(connectors, ancestor, node.name))
                    connectors.push(this._applyConnectorTemplate(mapper, null, ancestor, node.name, connectorTemplate));
                nextLevel = rootNodes[child[mapper.id]]
                if (nextLevel)
                    this._renderChildNodes(mapper, nextLevel, node.name, nodes, connectors, rootNodes, nodeTemplate, connectorTemplate);
            }
        },
        _applyTemplate: function (mapper, data, collection, collname) {
            var nodeTemplate, i, node, conn, connectorTemplate;
            if (this.model.nodeTemplate)
                nodeTemplate = this._getNodeTemplate();
            if (this.model.connectorTemplate)
                connectorTemplate = this._getConnectorTemplate();
            if (collname == "nodes") {
                for (i = 0; i < data.length; i++) {
                    node = this._applyNodeTemplate(mapper, data[i], nodeTemplate);
                    collection.push(node);
                }
            }
            if (collname == "connectors") {
                for (i = 0; i < data.length; i++) {
                    conn = this._applyConnectorTemplate(mapper, data[i], data[i].sourceNode, data[i].targetNode, connectorTemplate);
                    collection.push(conn);
                }
            }
        },

        _applyNodeTemplate: function (mapper, item, nodeTemplate) {
            var root = item;
            if (root.name === "" || !root.name)
                root.name = ej.datavisualization.Diagram.Util.randomId();
            if (root.type != "group")
                root = this._getNewNode(root);
            else
                root = this._getNewGroup(root);
            if (nodeTemplate) {
                nodeTemplate(this, root);
            }
            if (root._type === "group") {
                //root = this._getNewGroup(root);
                this._initGroupNode(root);
            }
            return root;
        },
        _applyConnectorTemplate: function (mapper, item, sourceNode, targetNode, connectorTemplate) {
            var connector = {};
            connector.name = item && item.name ? item.name : ej.datavisualization.Diagram.Util.randomId();
            connector.sourceNode = sourceNode;
            connector.targetNode = targetNode;
            connector = this._getNewConnector(connector);
            if (connectorTemplate) {
                connectorTemplate(this, connector);
            }
            return connector;
        },
        _collapseNodes: function (nodes) {
            var node;
            for (var i = 0; i < nodes.length; i++) {
                node = nodes[i];
                this._collapseChildren(node);
            }
        },
        //#endregion
        //#region Get elements
        _getNewNode: function (options) {
            if (options.shape && typeof options.shape === "object")
                ej.datavisualization.Diagram.Util._updateShapeProperties(options);
            return ej.datavisualization.Diagram.Node($.extend(true, {}, this.model.defaultSettings.node, options));
        },
        _getNewGroup: function (options) {
            var child = null, index = 0;
            if (options.type == "bpmn") options = ej.datavisualization.Diagram.Util._updateBpmnChild(ej.datavisualization.Diagram.Node(options), this);
            if (options.children && options.children.length > 0) {
                for (var i in options.children) {
                    child = this.nameTable[this._getChild(options.children[i])];
                    if (child) {
                        ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[child.name], child);
                        ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, child);
                        if (child.segments) {
                            index = this.connectors().indexOf(child);
                            delete this.nameTable[child.name];
                            this.nameTable[child.name] = this._getNewConnector(child);
                            if (index >= 0) this.connectors()[index] = this.nameTable[child.name];
                            this._dock(this.nameTable[child.name], this.nameTable);
                            ej.datavisualization.Diagram.Util.updateBridging(this.nameTable[child.name], this);
                        } else if (child._type === "node") {
                            index = this.nodes().indexOf(child);
                            delete this.nameTable[child.name];
                            this.nameTable[child.name] = this._getNewNode(child);
                            if (index >= 0) this.nodes()[index] = this.nameTable[child.name];
                        } else if (child._type === "group") {
                            index = this.nodes().indexOf(child);
                            delete this.nameTable[child.name];
                            this.nameTable[child.name] = this._getNewGroup(child);
                            if (index >= 0) this.nodes()[index] = this.nameTable[child.name];
                        }
                    }
                }
            }
            return ej.datavisualization.Diagram.Group($.extend(true, {}, this.model.defaultSettings.group, options));
        },
        _isEmptyDiagramObject: function (obj) {
            if ($.isEmptyObject(obj))
                return true;
            else {
                for (var prop in obj) {
                    if (typeof obj[prop] === "object")
                        return this._isEmptyDiagramObject(obj[prop]);
                }
            }
            return false;

        },
        _getNewConnector: function (options) {
            var obj = $.extend(true, {}, this.model.defaultSettings.connector, options);
            if (this.model.layout && this.model.layout.type == "organizationalchart")
                obj = $.extend(true, {}, { segments: [{ type: "orthogonal" }] }, obj);
            if (this.model.defaultSettings.connector && (this.model.defaultSettings.connector.segments && this.model.defaultSettings.connector.segments[0])) {
                obj.defaultType = this.model.defaultSettings.connector.segments[0].type;
            }
            if (obj.shape && !this._isEmptyDiagramObject(obj.shape)) {
                if (obj.shape.type == "umlactivity") {
                    obj = ej.datavisualization.Diagram.UMLConnectorShape(obj);
                    if (obj.sourceNode)
                        var sourceNode = this.nameTable[obj.sourceNode];
                    if (obj.targetNode)
                        var targetNode = this.nameTable[obj.targetNode];
                    var node = ej.datavisualization.Diagram.ClassifierHelper.EnableorDisableConnection(targetNode, sourceNode, obj, this);
                    if (node)
                        obj.targetNode = node.name;
                    else
                        obj.targetNode = null;
                }
                if (obj.shape.type == "umlclassifier") {
                    obj = ej.datavisualization.Diagram.UMLConnectorShape(obj);
                    if (obj.sourceNode)
                        var sourceNode = this.nameTable[obj.sourceNode];
                    if (obj.targetNode)
                        var targetNode = this.nameTable[obj.targetNode];
                    var node = ej.datavisualization.Diagram.ClassifierHelper.EnableorDisableConnection(targetNode, sourceNode, obj, this);
                    if (node)
                        obj.targetNode = node.name;
                    else
                        obj.targetNode = null;
                }
                else {
                    obj.shape = $.extend(true, {}, ej.datavisualization.Diagram.ConnectorShapeDefaults, obj.shape);
                    if (obj.shape.flow == "sequence") {
                        if (obj.shape.sequence == "normal")
                            obj = $.extend(true, {}, { segments: [{ type: "straight" }], targetDecorator: { shape: "arrow" }, lineWidth: 2 }, obj);
                        if (obj.shape.sequence == "conditional") {
                            obj = $.extend(true, {}, { segments: [{ type: "straight" }], targetDecorator: { shape: "arrow" }, lineWidth: 2 }, obj);
                            obj.sourceDecorator = { shape: "diamond", fillColor: "white", width: 20, height: 10 };
                        }
                        if (obj.shape.sequence == "default")
                            obj = $.extend(true, { segments: [{ type: "straight" }], targetDecorator: { shape: "arrow" }, lineWidth: 2 }, obj);
                    }
                    if (obj.shape.flow == "association") {
                        if (obj.shape.association == "directional")
                            obj = $.extend(true, {}, { segments: [{ type: "straight" }], lineWidth: 2, lineDashArray: "2 2", targetDecorator: { shape: "openarrow", width: 5, height: 10 } }, obj);
                        if (obj.shape.association == "nondirectional")
                            obj = $.extend(true, {}, { segments: [{ type: "straight" }], lineWidth: 2, lineDashArray: "2 2", targetDecorator: { shape: "none" } }, obj);
                        if (obj.shape.association == "bidirectional") {
                            obj = $.extend(true, {}, { segments: [{ type: "straight" }], lineWidth: 2, lineDashArray: "2 2", targetDecorator: { shape: "openarrow", width: 5, height: 10 } }, obj);
                            obj.sourceDecorator = { shape: "openarrow", width: 5, height: 10 };
                        }
                    }
                    if (obj.shape.flow == "message") {
                        obj = $.extend(true, {}, { segments: [{ type: "straight" }], sourceDecorator: { shape: "circle", fillColor: "white" }, targetDecorator: { shape: "arrow", fillColor: "white" }, lineWidth: 2, lineDashArray: "4 4" }, obj);
                    }
                }

            }

            ej.datavisualization.Diagram.Util._initConnectionEnds(obj, this);
            return ej.datavisualization.Diagram.Connector(obj);
        },
        //#endregion
        _setOverview: function (overview, id) {
            if (overview) {
                this._overview = overview;
                this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
                if (!this._views[overview._id]) {
                    this._views.push(overview._id);
                    this._views[overview._id] = { "context": ej.datavisualization.Diagram.SvgContext, "type": "overview" };
                    overview._renderDocument(this._views[overview._id]);
                    var view = this._views[overview._id];
                    var nodes = this._setNodeZOrder(view);
                    this._renderDiagramObjects(nodes, view, null, true);
                    overview._updateOverview(view);
                }
                delete this._viewPort;
            } else {
                overview = $("#" + id).ejOverview("instance");
                overview._removeDocument(this._views[id]);
                this._views[id] = undefined;
                var index = this._views.indexOf(id);
                this._views.splice(index, 1);
                //this._overview = null;
            }
        },
        _updateScrollOffset: function (hScrollOffset, vScrollOffset, canScale) {
            this._hScrollOffset = Number(hScrollOffset);
            this._vScrollOffset = Number(vScrollOffset);
            this._verticalOffset(Number(vScrollOffset));
            this._horizontalOffset(Number(hScrollOffset));
            this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            ej.datavisualization.Diagram.ScrollUtil._transform(this, hScrollOffset, vScrollOffset, canScale);
            var diagram = this;
            this._views.forEach(function (viewid) {
                var view = diagram._views[viewid];
                if (view.type == "overview") {
                    var ovw = $("#" + viewid).ejOverview("instance");
                    if (ovw)
                        ovw._scrollOverviewRect(hScrollOffset, vScrollOffset, diagram._currZoom);
                }
            });
            this.model.scrollSettings.viewPortHeight = this._viewPort.height;
            this.model.scrollSettings.viewPortWidth = this._viewPort.width;
            this.model.scrollSettings.currentZoom = this._currZoom;
        },
        _getChild: function (child) {
            return ej.datavisualization.Diagram.Util.getChild(child);
        },
        _getChildren: function (children) {
            if (children) {
                var children1 = [];
                for (var i = 0; i < children.length; i++) {
                    var child = children[i];
                    if (child) {
                        if (typeof (child) == "object") {
                            children1.push(child.name);
                        } else {
                            children1.push(child);
                        }
                    }
                }
                return children1;
            }
        },
        _initGroupNode: function (group, childTable) {
            var child = null, childNode;
            for (var i = 0; group.children && i < group.children.length; i++) {
                childNode = childTable ? $.extend(true, {}, childTable[this._getChild(group.children[i])]) : group.children[i];
                child = typeof childNode == "string" ? this.nameTable[childNode] : childNode;
                if (child) {
                    if (!child._type && child.type == "umlclassifier")
                        child._type = "group";
                    if (child.container) {
                        child._type = "group"
                        child.labels = [];
                    }
                    if (childNode && typeof (childNode) == "object") {
                        if (typeof child.shape !== "object" && group.type != "bpmn")
                            child = ej.datavisualization.Diagram.NodeType(child, this);
                        if (child._type != "group" && !child.children && !child.segments && child.type != "connector") {
                            if (group.type != "bpmn" && group.type != "umlclassifier") child = this._getNewNode(child);
                            if (child.name == "")
                                child.name = ej.datavisualization.Diagram.Util.randomId();
                            if (child._type == "node" && child.labels.length && (child.width == 0 || child.height == 0))
                                this._getNodeDimension(child);
                        }
                        else if (child.segments || child.type == "connector") {
                            child = this._getNewConnector(child);
                            if (child.name == "") {
                                child.name = ej.datavisualization.Diagram.Util.randomId();
                            }
                        }
                        else {
                            child = this._getNewGroup(child);
                            if (child.name == "") {
                                child.name = ej.datavisualization.Diagram.Util.randomId();
                            }
                            this._initGroupNode(child);
                        }
                        group.children[i] = child;
                        child.parent = group.name;
                        this.nameTable[child.name] = child;
                        if (child.segments)
                            this._dock(child, this.nameTable);
                    }
                    this._updateQuad(this.nameTable[this._getChild(group.children[i])]);
                }
            }
            if (!this._isLoad)
                ej.datavisualization.Diagram.Util._updateGroupBounds(group, this);
        },
        _udpateChildRotateAngle: function (group) {
            var pinx, piny, child;
            if (group.rotateAngle) {
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, group.rotateAngle, group.offsetX, group.offsetY);
                for (var i = 0; i < group.children.length; i++) {
                    child = this.nameTable[this._getChild(group.children[i])];
                    child.rotateAngle = child.rotateAngle ? child.rotateAngle + group.rotateAngle : group.rotateAngle;
                    child.rotateAngle %= 360;
                    if (child.rotateAngle < 0) child.rotateAngle += 360;
                    if (!(child.segments)) {
                        if (child.type == "group") this._udpateChildRotateAngle(child);
                        var pinx = child.offsetX;
                        piny = child.offsetY;
                        var actualpt = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(pinx, piny));
                        this._translate(child, actualpt.x - pinx, actualpt.y - piny, this.nameTable);
                        this._updateAssociatedConnectorEnds(child, this.nameTable);
                    } else {
                        if (!child.sourceNode)
                            this._setEndPoint(child, ej.Matrix.transform(matrix, child.sourcePoint), false);
                        if (!child.targetNode)
                            this._setEndPoint(child, ej.Matrix.transform(matrix, child.targetPoint), true);
                    }
                }
            }
        },
        _getNodeDimension: function (node) {
            var prevWidth = node._width, prevHeight = node._height;
            var width = node.width ? node.width : (node.maxWidth ? node.maxWidth : node.minWidth);
            var text = document.createElement("span");
            var w = 0, h = 0, label, i;
            if (node.labels.length) {
                ej.datavisualization.Diagram.Util.attr(text, { "id": node.name + "_label", "class": "ej-d-label", "style": "display: inline-block; position: absolute; pointer-events: all; line-height: normal;" });
                this.element[0].appendChild(text);
                for (i = 0; i < node.labels.length; i++) {
                    label = node.labels[i];
                    if (label.bold) text.style.fontWeight = "bold";
                    if (label.italic) text.style.fontStyle = "italic";
                    text.style.textDecoration = label.textDecoration;
                    text.style.fontFamily = label.fontFamily;
                    text.style.fontSize = label.fontSize + "px";
                    text.style.color = label.fontColor;
                    text.style.backgroundColor = label.fillColor;
                    text.style.borderColor = label.borderColor;
                    text.style.borderWidth = label.borderWidth + "px";
                    text.textContent = label.text;
                    if (label.wrapping == "nowrap") {
                        text.style.whiteSpace = "nowrap";
                        text.style.wordWrap = "normal";
                    } else {
                        if (label.wrapping == "wrap") {
                            text.style.wordBreak = "break-all";
                        }
                        text.style.wordWrap = "break-word";
                        text.style.whiteSpace = "pre";

                    }
                    if (node.maxWidth) text.style.maxWidth = width - (label.margin.left + label.margin.right) - label.fontSize + "px";
                    if (node.minWidth) text.style.minWidth = width - (label.margin.left + label.margin.right) - label.fontSize + "px";
                    w += text.offsetWidth + label.margin.left + label.margin.right + 5;
                    h += text.offsetHeight + label.margin.top + label.margin.bottom;
                }
                var type = node.name.match("_attribute") ? "attribute" : (node.name.match("_method") ? "method" : (node.name.match("_member") ? "member" : "header"));
                node._width = Math.max(node.minWidth || 0, w || 0);
                if (node.maxWidth) node._width = Math.min(node.maxWidth, node._width);
                node._height = Math.max(node.minHeight || 0, h || 0);
                if (node.maxHeight) node._height = Math.min(node.maxHeight, node._height);
                if (!node.width && node.labels[0].horizontalAlignment == "left" && type != "attribute" && type != "method" && type != "member") node.offsetX += (node._width - prevWidth) / 2;
                if (!node.width && node.labels[0].horizontalAlignment == "right") node.offsetX -= (node._width - prevWidth) / 2;
                if (!node.height && node.labels[0].verticalAlignment == "top") node.offsetY += (node._height - prevHeight) / 2;
                if (!node.height && node.labels[0].verticalAlignment == "bottom") node.offsetY -= (node._height - prevHeight) / 2;
                if (node.parent) var parent = this.nameTable[node.parent];
                this.element[0].removeChild(text);
            }
        },
        _getMinMaxSize: function (node, width, height, stretch, isExeed) {
            var nw = null, nh = null;
            if (width >= node.minWidth && width <= node.maxWidth) {
                nw = width;
            } else {
                if (node.horizontalAlign == "stretch" && node.parent && !stretch && !isExeed) {
                    var group = this.nameTable[node.parent];
                    if (group) {
                        var rSize = ej.datavisualization.Diagram.Util.bounds(group); // ej.datavisualization.Diagram.SvgContext._measureCanvasSize(group, this);
                        if (rSize.width == 0 && rSize.height == 0) {
                            rSize.width = width;
                            rSize.height = height;
                        }
                        var newSize = this._getMinMaxSize(group, rSize.width, rSize.height);
                        if (group.isSwimlane && group.orientation == "vertical") {
                            var head = this.nameTable[group.children[0]];
                            if (head)
                                newSize.height -= head.height;
                        }
                        newSize.width -= (group.paddingLeft + group.paddingRight + group.marginLeft + group.marginRight);
                        newSize.height -= (group.paddingTop + group.paddingBottom + group.marginTop + group.marginBottom);
                        nw = newSize.width ? newSize.width : width;
                    }
                }
                else if (isExeed) {
                    var group = this.nameTable[node.parent];
                    if (group) {
                        var rSize = ej.datavisualization.Diagram.Util.bounds(group); // ej.datavisualization.Diagram.SvgContext._measureCanvasSize(group, this);
                        var newSize = this._getMinMaxSize(group, rSize.width, rSize.height);
                        nw = newSize.width ? newSize.width : width;
                    }
                }
                else if (width < node.minWidth && node.minWidth != 0)
                    nw = node.minWidth;
                else if (width > node.maxWidth && node.maxWidth != 0 && !node.isSwimlane)
                    nw = node.maxWidth;
                else
                    nw = width;
            }
            if (height >= node.minHeight && height <= node.maxHeight) {
                nh = height;
            } else {
                var group = this.nameTable[node.parent];
                if (node.verticalAlign == "stretch" && node.parent && !stretch && !node.isLane) {
                    var rSize = ej.datavisualization.Diagram.Util.bounds(group);
                    if (rSize.width == 0 && rSize.height == 0) {
                        //rSize.width = width;
                        //rSize.height = height;
                        var status = null;
                        var state = false;
                        rSize.width = node.minWidth;
                        rSize.height = node.minHeight;
                        if (node.minWidth == 0 || node.minHeight == 0) {
                            rSize.width = width;
                            rSize.height = height;
                            status = false;
                            state = true;
                        }
                        if (!state)
                            status = true;
                    }
                    var newSize = this._getMinMaxSize(group, rSize.width, rSize.height);
                    newSize.width -= (group.paddingLeft + group.paddingRight + group.marginLeft + group.marginRight);
                    newSize.height -= (group.paddingTop + group.paddingBottom + group.marginTop + group.marginBottom);
                    if (status) {
                        newSize.height -= node.marginTop;

                    }
                    nh = newSize.height ? newSize.height : height;
                } else if (height < node.minHeight && node.minHeight != 0)
                    nh = node.minHeight;
                else if (height > node.maxHeight && node.maxHeight != 0)
                    nh = node.maxHeight;
                else
                    nh = height;
            }
            return { width: nw, height: nh };
        },
        _updateConnectorBridging: function (baseConnector) {
            var intersectingConnectors = [];
            this.boundaryTable[baseConnector.name] = ej.datavisualization.Diagram.Util.bounds(baseConnector);
            if (baseConnector._intersects && baseConnector._intersects.length)
                intersectingConnectors = baseConnector._intersects;
            for (var q = 0; q < intersectingConnectors.length; q++) {
                var connector = this.nameTable[intersectingConnectors[q]];
                if (connector && connector.visible) {
                    if (connector.segments) {
                        if (connector != baseConnector && ej.datavisualization.Diagram.Util.canBridge(connector, this)) {
                            ej.datavisualization.Diagram.Util.updateBridging(connector, this, [baseConnector]);
                            if (!this._disableSegmentChange)
                                ej.datavisualization.Diagram.DiagramContext._refreshOnlySegments(connector, this);
                        }
                    }
                }
            }
        },
        _drawToolShape: function (type, args) {
            if (type == "image" || type == "native" || type == "html" || type === "text" || type === "basic" || type === "flow" || type === "arrow" || type === "bpmn" || this.activeTool._isPolyline()) {
                this.activateTool("shapeTool", args);
            }
            else if (type == "straightLine") {
                this.activateTool("straightLine", args);
            }
            else if (type == "orthogonalLine") {
                this.activateTool("orthogonalLine", args);
            }
            else if (type == "bezierLine") {
                this.activateTool("bezierLine", args);
            }
        },
        _destroy: function () {
            this.element.empty().removeClass("e-datavisualization-diagram");
            if (this.enableContextMenu()) {
                var menuObj = $("#" + this.element[0].id + "_contextMenu").data("ejMenu");
                menuObj.destroy();
            }
            $("#" + this.element[0].id + "_contextMenu").remove();
        },
        //#endregion       
        _updateScrollSettings: function (option) {
            var isLimited = this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Limited ? true : false;
            var scrollableArea = this.model.pageSettings.scrollableArea;
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            if (option.horizontalOffset !== undefined || option.verticalOffset !== undefined) {
                var oVal = {
                    zoom: this._getCurrentZoom(), horizontalOffset: this._hScrollOffset,
                    verticalOffset: this._vScrollOffset, viewPort: viewPort
                };
                if ((option.horizontalOffset !== undefined)) {
                    var hValue = Number((typeof option.horizontalOffset === 'function' ? option.horizontalOffset() : option.horizontalOffset));
                    if (!isLimited || (hValue >= scrollableArea.x && hValue <= scrollableArea.x + scrollableArea.width)) {
                        if (this._scrollLimit() == "diagram") {
                            hValue = Math.max(this._hScrollbar.model.minimum, hValue);
                            hValue = Math.min(this._hScrollbar.model.maximum, hValue);
                        }
                        this._updateScrollOffset(hValue, this._verticalOffset());
                    }
                }
                if ((option.verticalOffset !== undefined)) {
                    var vValue = Number((typeof option.verticalOffset === 'function' ? option.verticalOffset() : option.verticalOffset));
                    if (!isLimited || (vValue >= scrollableArea.y && vValue <= scrollableArea.y + scrollableArea.height)) {
                        if (this._scrollLimit() == "diagram") {
                            vValue = Math.max(this._vScrollbar.model.minimum, vValue);
                            vValue = Math.min(this._vScrollbar.model.maximum, vValue);
                        }
                        this._updateScrollOffset(this._horizontalOffset(), vValue);
                    }
                }
                var nVal = {
                    zoom: this._getCurrentZoom(), horizontalOffset: this._hScrollOffset,
                    verticalOffset: this._vScrollOffset, viewPort: viewPort
                };
                this._raiseEvent("scrollChange", { newValues: nVal, oldValues: oVal });
            }
            if (option.zoomFactor)
                this.zoomFactor((typeof option.zoomFactor === 'function' ? option.zoomFactor() : option.zoomFactor));
            if (option.padding) {
                $.extend(this.model.scrollSettings.padding, option.padding);
                this._updateScrollOffset(this._horizontalOffset(), this._verticalOffset());
            }

        },
        updatePageSettings: function (option) {
            if (option) {
                var oldValue = $.extend(true, {}, this.model.pageSettings);
                if (option.pageHeight) {
                    this._pageHeight(Number(typeof option.pageHeight === 'function' ? option.pageHeight() : option.pageHeight));
                }
                if (option.pageWidth) {
                    this._pageWidth(Number(typeof option.pageWidth === 'function' ? option.pageWidth() : option.pageWidth));
                }
                if (typeof option.multiplePage === 'function' || typeof option.multiplePage === "boolean") {
                    this._multiplePage(typeof option.multiplePage === 'function' ? option.multiplePage() : option.multiplePage);
                }
                if (typeof option.showPageBreak === 'function' || typeof option.showPageBreak === "boolean") {
                    this._showPageBreak(typeof option.showPageBreak === 'function' ? option.showPageBreak() : option.showPageBreak);
                }
                if (option.pageBorderColor || option.pageBorderColor === "") {
                    this._pageOrientation(typeof option.pageOrientation === 'function' ? option.pageOrientation() : option.pageOrientation);
                }
                if (option.pageBorderWidth || option.pageBorderWidth === 0) {
                    this._pageBorderWidth(Number(typeof option.pageBorderWidth === 'function' ? option.pageBorderWidth() : option.pageBorderWidth));
                }
                if (option.pageMargin || option.pageMargin === 0) {
                    this._pageMargin(Number(typeof option.pageMargin === 'function' ? option.pageMargin() : option.pageMargin));
                }
                if (option.pageBackgroundColor || option.pageBackgroundColor === "") {
                    this._pageBackgroundColor(typeof option.pageBackgroundColor === 'function' ? option.pageBackgroundColor() : option.pageBackgroundColor);
                }
                if (option.scrollLimit) {
                    this._scrollLimit(typeof option.scrollLimit === 'function' ? option.scrollLimit() : option.scrollLimit);
                }
                if (option.scrollableArea) {
                    this.model.pageSettings.scrollableArea = option.scrollableArea;
                }
                if (option.pageBorderColor || option.pageBorderColor === "") {
                    this._pageBorderColor(typeof option.pageBorderColor === 'function' ? option.pageBorderColor() : option.pageBorderColor);
                }
                this._compareModelProperty("pageSettings");
                if (!this._isUndo)
                    this.addHistoryEntry({ type: "pagesettingschanged", undoObject: oldValue, category: "internal", redoObject: $.extend(true, {}, this.model.pageSettings) });
                ej.datavisualization.Diagram.PageUtil._updatePageSize(this);
                ej.datavisualization.Diagram.SvgContext._updateBackground(this._hScrollOffset, this._vScrollOffset, this._currZoom, this);
                ej.datavisualization.Diagram.SvgContext._updateGrid(this._hScrollOffset, this._vScrollOffset, this._currZoom, this);
            }
        },
        _updateSnapSettings: function (option) {
            if (option) {
                if (option.horizontalGridLines && option.horizontalGridLines.linesInterval)
                    this.model.snapSettings.horizontalGridLines.linesInterval = option.horizontalGridLines.linesInterval;
                if (option.verticalGridLines && option.verticalGridLines.linesInterval)
                    this.model.snapSettings.verticalGridLines.linesInterval = option.verticalGridLines.linesInterval;
                if (option.snapAngle) {
                    this._snapAngle(Number(typeof option.snapAngle === 'function' ? option.snapAngle() : option.snapAngle));
                }
                if (option.snapObjectDistance) {
                    this._snapObjectDistance(Number(typeof option.snapObjectDistance === 'function' ? option.snapObjectDistance() : option.snapObjectDistance));
                }
            }
        },
        //#region Public methods
        _cloneObject: function (node) {
            if ((this.getObjectType(node) === "node" || this.getObjectType(node) === "connector") && node.type != "bpmn") {
                node = $.extend(true, {}, node);
                return node;
            }
            else if ((this.getObjectType(node) === "group" || node.type === "bpmn") && !node.isSwimlane) {
                var group = ($.extend(true, {}, node));
                for (var i = 0; group.children && group.children.length > 0 && i < group.children.length; i++) {
                    group.children[i] = this._cloneObject(this.nameTable[this._getChild(group.children[i])]);
                    group.children[i].parent = group.name;
                }
                return group;
            }
            else if (this.getObjectType(node) === "group" && node.isSwimlane) {
                var swmlnObj = this.getNode(node);
                return swmlnObj;
            }
        },
        _cloneSelectionList: function () {
            var obj = [];
            for (var i = 0 && this.selectionList && this.selectionList.length > 0; i < this.selectionList.length; i++) {
                if (this.getObjectType(this.selectionList[i]) === "pseudoGroup") {
                    var pGroup = this.selectionList[0];
                    for (var j = 0 ; pGroup.children && pGroup.children.length > 0 && j < pGroup.children.length; j++) {
                        obj.push(this._cloneObject(this.nameTable[this._getChild(pGroup.children[j])]));
                    }
                }
                else {
                    obj.push(this._cloneObject(this.selectionList[i]));
                }
            }
            return obj;
        },
        getNode: function (name, childTable) {
            if (name) {
                return this._getNode(name, childTable);
            }
        },
        addPhase: function (name, options) {
            this._addPhase(name, options);
        },
        stopEvents: function (evt) {
            if (this.activeTool.inAction) {
                if (!evt.originalEvent.target && evt.target) {
                    evt.originalEvent.target = evt.target;
                    this._mouseup(evt);
                }
            }
        },
        _updateSwimlanePhase: function (phase, options, selupdate, updateChildren) {
            if (phase && options) {
                if (options.label) {
                    var psStkNode = this.nameTable[phase.name];
                    if (psStkNode) {
                        this._comparePropertyValues(phase, "label", options);
                        options.label = $.extend(true, {}, options.label);
                        options.label.rotateAngle = (options.orientation === "vertical") ? 270 : 0;
                        options.label.name = psStkNode.labels[0].name;
                        options.label.mode = ej.datavisualization.Diagram.LabelEditMode.View
                        phase.label = options.label;
                        this.updateLabel(psStkNode.name, psStkNode.labels[0], phase.label);
                    }
                }
                if (options.lineColor || options.lineDashArray || options.lineWidth) {
                    var attr = {}
                    if (options.lineColor) {
                        this._comparePropertyValues(phase, "lineColor", options);
                        phase.lineColor = options.lineColor;
                        attr["stroke"] = options.lineColor;
                    }
                    if (options.lineDashArray) {
                        this._comparePropertyValues(phase, "lineDashArray", options);
                        phase.lineDashArray = options.lineDashArray;
                        attr["stroke-dasharray"] = options.lineDashArray;
                    }
                    if (options.lineWidth) {
                        this._comparePropertyValues(phase, "lineWidth", options);
                        phase.lineWidth = options.lineWidth;
                        attr["stroke-width"] = options.lineWidth;
                    }

                    ej.datavisualization.Diagram.SvgContext._updatePhaseStyle(phase, attr, this);
                }
                if (options.fillColor) {
                    this._comparePropertyValues(phase, "fillColor", options);
                    phase.fillColor = options.fillColor;
                    ej.datavisualization.Diagram.DiagramContext.updateNodeStyle(phase, this);
                }
            }
        },
        _updateNodeVisibility: function (node, options) {
            if (node) {
                if (node.type === "group") {
                    for (var i = 0; i < node.children.length; i++) {
                        var child = this.nameTable[node.children[i]];
                        if (child)
                            this._updateNodeVisibility(child, options);
                    }
                }
                if (node.isSwimlane) {
                    var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this, node);
                    if (phases) {
                        for (var i = 0; i < phases.length; i++) {
                            var phase = this.nameTable[phases[i]];
                            phase.visible = options.visible;
                            ej.datavisualization.Diagram.SvgContext._updatePhaseStyle(phase, options, this);
                        }
                    }
                }
                node.visible = options.visible;
            }
        },

        _compareInnerProperties: function (sElement, tElement) {
            var state = true;
            if (sElement && tElement)
                for (var k in tElement) {
                    if (typeof (sElement[k]) === "object") {
                        state = this._compareInnerProperties(sElement[k], tElement[k]);
                        if (!state)
                            return false;
                    }
                    else if (sElement[k] !== tElement[k])
                        return false
                }
            return true;
        },
        _comparePropertyValues: function (element, property, options, interaction, root) {
            if (element) {
                var resource = null;
                var srobject = element;
                var trobject = options;
                var prCol = property.split(".");
                var prlength = prCol.length;
                if (prlength > 1) {
                    var i = 0;
                    while (prlength > i) {
                        srobject = srobject[prCol[i]]
                        trobject = trobject[prCol[i]]
                        i++;
                        if (srobject && trobject) {
                            if (i == (prlength - 1)) {
                                if (srobject[prCol[i]] != trobject[prCol[i]]) {
                                    resource = {
                                        element: element,
                                        cause: root ? root : (interaction ? ej.datavisualization.Diagram.ActionType.Mouse : ej.datavisualization.Diagram.ActionType.Unknown),
                                        propertyName: prCol[0],
                                        oldValue: srobject,
                                        newValue: trobject
                                    };
                                    this._raisePropertyChange(resource);
                                }
                            }
                        }
                        else
                            break;
                    }
                }
                else {
                    resource = {
                        cause: root ? root : (interaction ? ej.datavisualization.Diagram.ActionType.Mouse : ej.datavisualization.Diagram.ActionType.Unknown),
                        propertyName: property,
                        oldValue: element[property],
                        newValue: options[property]
                    };
                    if ((property !== "labels" && property !== "ports" && property !== "segments") && ((typeof (element[property]) === "object" && !this._compareInnerProperties(element[property], options[property])) || !element[property] || (typeof (element[property]) !== "object" && element[property] != options[property]))) {
                        resource.element = element;
                    }
                    else if (property === "segments") {
                        if (element[property] != options[property]) {
                            resource.element = element;
                        }
                    }
                    else if (property === "labels" || property === "ports") {
                        if (element[property].length > 0) {
                            if (property === "ports")
                                var obj = this._findPort(element, options.name);
                            else
                                obj = this._findLabel(element, options.name);
                            if (!this._compareInnerProperties(obj, options)) {
                                resource.element = obj;
                                resource.oldValue = obj,
                                resource.newValue = options

                            }
                        }
                    }
                    if (resource.element)
                        this._raisePropertyChange(resource);
                }
            }
        },
        updateNode: function (name, options) {
            if (name) {
                var node = this._findNode(name);
                var matrix = ej.Matrix.identity();
                var bounds, dx, dy, pt;
                var nodeConstraints = ej.datavisualization.Diagram.NodeConstraints;
                var cont = (node && (node.isSwimlane || node.isLane || node.isPhase || node.type === "phase"));
                if ((cont) || !cont) { // if ((cont && this._needUpdate) || !cont) {
                    this._needUpdate = false;
                    var resource = null;
                    if (node) {
                        if (!this._isUndo && !this._isSizingCommand)
                            this._recordPropertiesChanged(node, options, "node");
                        if (options.pivot != undefined) {
                            bounds = ej.datavisualization.Diagram.Util.bounds(node, true);
                            ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                            if (options.pivot.x !== undefined) {
                                this._comparePropertyValues(node, "pivot.x", options);
                                var difx = options.pivot.x - node.pivot.x;
                                node.pivot.x = options.pivot.x;
                                node.offsetX += difx * (node.width || node._width || 0);
                            }
                            if (options.pivot.y !== undefined) {
                                this._comparePropertyValues(node, "pivot.y", options);
                                var dify = options.pivot.y - node.pivot.y;
                                node.pivot.y = options.pivot.y;
                                node.offsetY += dify * (node.height || node._height || 0);
                            }
                            pt = ej.Matrix.transform(matrix, { x: node.offsetX, y: node.offsetY });
                            node.offsetX = pt.x;
                            node.offsetY = pt.y;
                        }
                        if (options.offsetX != undefined) {
                            dx = options.offsetX - node.offsetX;
                            if (this._outOfBoundsOnNudge(node, dx, 0)) {
                                resource = { element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "offsetX", oldValue: node.offsetX, newValue: node.offsetX + dx };
                                this._raisePropertyChange(resource);
                                this._translate(node, dx, 0, this.nameTable);
                                if (node.marginLeft != 0) node.marginLeft += dx;
                            }
                        }
                        if (options.offsetY != undefined) {
                            dy = options.offsetY - node.offsetY;
                            if (this._outOfBoundsOnNudge(node, 0, dy)) {
                                resource = { element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "offsetY", oldValue: node.offsetY, newValue: node.offsetY + dy }
                                this._raisePropertyChange(resource);
                                this._translate(node, 0, dy, this.nameTable);
                                if (node.marginTop != 0) node.marginTop += dy;
                            }
                        }
                        if (options.rotateAngle != undefined) {
                            this._comparePropertyValues(node, "rotateAngle", options);
                            this._rotate(node, options.rotateAngle - node.rotateAngle, this.nameTable);
                        }
                        if (!node.isSwimlane && !node.isLane) {
                            var tool = this.tools["resize"];

                            if (options.width != undefined) {
                                node.width = node.width ? node.width : 1;
                                resource = { element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "width", oldValue: node.width, newValue: options.width };
                                this._raisePropertyChange(resource);
                                var swimchild = false;
                                var parsemin = !node.isLane ? false : true;
                                if (tool._outOfBoundsDrag(node, options.width / node.width, 1, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY))) {
                                    this.scale(node, options.width / node.width, 1, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), this.nameTable, swimchild, parsemin);
                                    if (node.type === "bpmn" && node._type === "group")
                                        ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                                }
                            }
                            if (options.height != undefined) {
                                node.height = node.height ? node.height : 1;
                                resource = { element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "height", oldValue: node.height, newValue: options.height };
                                this._raisePropertyChange(resource);
                                var swimchild = false;
                                var parsemin = !node.isLane ? false : true;
                                if (tool._outOfBoundsDrag(node, 1, options.height / node.height, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY))) {
                                    this.scale(node, 1, options.height / node.height, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), this.nameTable, swimchild, parsemin);
                                    if (node.type === "bpmn" && node._type === "group")
                                        ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                                }
                            }
                        }
                        else
                            this._updateSwimlaneSize(node, options);
                        if (options.connectorPadding != undefined) {
                            this._comparePropertyValues(node, "connectorPadding", options);
                            node.connectorPadding = options.connectorPadding;
                            this.scale(node, 1, 1, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), this.nameTable);
                        }
                        if (options.visible != undefined) {
                            this._comparePropertyValues(node, "visible", options);
                            this._updateNodeVisibility(node, options);
                            if (!options.visible)
                                this._clearSelection();
                        }
                        if (options.constraints != undefined) {
                            this._comparePropertyValues(node, "constraints", options);
                            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                                if (node._type != "group" || node.type === "bpmn") {
                                    if (node.constraints & nodeConstraints.Shadow || options.constraints & nodeConstraints.Shadow) {
                                        if (!(node.constraints & nodeConstraints.Shadow) && (options.constraints & nodeConstraints.Shadow)) {
                                            node.constraints = options.constraints;
                                            if (node.type === "bpmn" && node.children && (node.shape != "group")) {
                                                ej.datavisualization.Diagram.DiagramContext.updateBPMNNodeStyle(node, this);
                                                ej.datavisualization.Diagram.DiagramContext.renderShadow(this.nameTable[this._getChild(node.children[0])], this);
                                            }
                                            else
                                                ej.datavisualization.Diagram.DiagramContext.renderShadow(node, this);
                                        }
                                        else if ((node.constraints & nodeConstraints.Shadow) && !(options.constraints & nodeConstraints.Shadow)) {
                                            node.constraints = options.constraints;
                                            ej.datavisualization.Diagram.DiagramContext.removeShadow(node, this);
                                        }
                                    }
                                }
                                node.constraints = options.constraints;
                                if (this.selectionList[0] && this.selectionList[0].name === node.name) {
                                    if (ej.datavisualization.Diagram.Util.canSelect(this.selectionList[0])) {
                                        ej.datavisualization.Diagram.SvgContext.clearSelector(this._adornerSvg, this._adornerLayer);

                                        ej.datavisualization.Diagram.SvgContext.renderSelector(this.selectionList[0], this._adornerSvg, this._adornerLayer, this._currZoom, this.model.selectedItems.constraints);
                                        if (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                                            ej.datavisualization.Diagram.SvgContext.renderUserHandles(this.model.selectedItems.userHandles, this.selectionList[0], this._adornerSvg, this.selectionList[0].type === "pseudoGroup",
                                                this._currZoom, this._adornerLayer, this);
                                    }
                                    else this._clearSelection(true);
                                }
                            }
                        }
                        if (options.fillColor != undefined) {
                            this._comparePropertyValues(node, "fillColor", options);
                            node.fillColor = options.fillColor;
                        }
                        if (options.cssClass != undefined) {
                            this._comparePropertyValues(node, "cssClass", options);
                            node.cssClass = options.cssClass;
                        }
                        if (options.opacity != undefined) {
                            this._comparePropertyValues(node, "opacity", options);
                            node.opacity = options.opacity;
                        }
                        if (options.borderColor != undefined) {
                            this._comparePropertyValues(node, "borderColor", options);
                            node.borderColor = options.borderColor;
                        }
                        if (options.borderWidth != undefined) {
                            this._comparePropertyValues(node, "borderWidth", options);
                            node.borderWidth = options.borderWidth;
                        }
                        if (options.borderDashArray != undefined) {
                            this._comparePropertyValues(node, "borderDashArray", options);
                            node.borderDashArray = options.borderDashArray;
                        }
                        if (options.shadow != undefined) {
                            this._comparePropertyValues(node, "shadow", options);
                            if (node.type === "bpmn" && node.children && (node.shape != "group")) {
                                node.children[0].shadow = ej.datavisualization.Diagram.Shadow($.extend(true, node.children[0].shadow, {}, options.shadow));
                                ej.datavisualization.Diagram.DiagramContext.updateShadow(node.children[0], this);
                            }
                            else {
                                node.shadow = ej.datavisualization.Diagram.Shadow($.extend(true, node.shadow, {}, options.shadow));
                                ej.datavisualization.Diagram.DiagramContext.updateShadow(node, this);
                            }
                        }
                        if (options.gradient !== undefined) {
                            this._comparePropertyValues(node, "gradient", options);
                            if (options.gradient === null)
                                node.gradient = options.gradient;
                            else if (options.gradient && options.gradient.type === "radial")
                                node.gradient = ej.datavisualization.Diagram.RadialGradient(options.gradient);
                            else
                                node.gradient = ej.datavisualization.Diagram.LinearGradient(options.gradient);
                        }
                        if (options.isExpanded !== undefined) {
                            this._comparePropertyValues(node, "isExpanded", options);
                            node._updateExpander = true;
                            if (options.isExpanded) {
                                node.isExpanded = true;
                                this._expandChildren(node);
                            }
                            else {
                                node.isExpanded = false;
                                this._collapseChildren(node);
                            }
                            var select;
                            if (this._selectionContains(node)) {
                                select = true;
                                this._clearSelection(true);
                            }
                            this.layout();
                            if (select)
                                this._addSelection(node, true);
                        }
                        if (options.tooltip !== undefined) {
                            this._comparePropertyValues(node, "tooltip", options);
                            node.tooltip = ej.datavisualization.Diagram.Tooltip($.extend(true, node.tooltip, {}, options.tooltip));
                        }
                        if (options.excludeFromLayout != undefined) {
                            this._comparePropertyValues(node, "excludeFromLayout", options);
                            node.excludeFromLayout = options.excludeFromLayout;
                            this.layout();
                        }
                        if (options.addInfo != undefined) {
                            this._comparePropertyValues(node, "addInfo", options);
                            node.addInfo = options.addInfo;
                        }
                        if (options.maxWidth != undefined) {
                            this._comparePropertyValues(node, "maxWidth", options);
                            node.maxWidth = options.maxWidth;
                        }
                        if (options.maxHeight != undefined) {
                            this._comparePropertyValues(node, "maxHeight", options);
                            node.maxHeight = options.maxHeight;
                        }
                        node = this._findNode(name);
                        if (options.shape) {
                            if (typeof options.shape == "object") {
                                this._comparePropertyValues(node, "shape", options);
                                ej.datavisualization.Diagram.Util._updateShapeProperties(options);
                                if (node.type == "html") {
                                    var htmlelement = document.getElementById(node.name + "_parentdiv");
                                    htmlelement.parentNode.removeChild(htmlelement);
                                }
                                ej.datavisualization.Diagram.DiagramContext.setNodeShape(node, this);
                            }

                        }
                        if (this.getObjectType(node) == "node")
                            node = this._updateShape(node, options);

                        if (node && node.type != "phase") {
                            ej.datavisualization.Diagram.DiagramContext.update(node, this);
                            if (node.type == "bpmn")
                                ej.datavisualization.Diagram.DiagramContext.updateBPMNNodeStyle(node, this);
                            else
                                ej.datavisualization.Diagram.DiagramContext.updateNodeStyle(node, this);
                        }
                        if (this.selectionList[0] && this.selectionList[0].name === node.name)
                            ej.datavisualization.Diagram.SvgContext.updateSelector(node, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                    }
                }
                if (name) {
                    var oldabsolutepath;
                    if (options && options.pathData) {
                        oldabsolutepath = node._absolutePath;
                    }
                    var node = this._findNode(name);
                    if (oldabsolutepath) {
                        node._absolutePath = oldabsolutepath;
                        node._absoluteBounds = null;
                    }
                    if (node && node._type === "node" && options && options.type === "group" && options.children && options.children.length > 0) {
                        var isRendered = false;
                        if (this._svg.document.getElementById(node.name))
                            isRendered = true;
                        this.remove(node);
                        node.borderColor = "transparent";
                        node.borderDashArray = "";
                        node.borderWidth = 1;
                        node.fillColor = "#1BA0E2";
                        node.labels = [];
                        node.fillColor = "";
                        node.type = options.type;
                        node.children = options.children;
                        node = ej.datavisualization.Diagram.Group(node);
                        this._initGroupNode(node);
                        if (isRendered) {
                            ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                            this.add(node);
                        }
                    }
                }
                if (node && (node.isLane || node.isSwimlane || node.type === "phase" || node.isPhase)) {
                    this._needUpdate = true;
                    if (node.isLane)
                        this._updateLane(node, options);
                    else if (node.isSwimlane) {
                        this._needUpdate = false;
                        this._updateSwimlane(node, options, true);
                    }
                    else if (node.type === "phase" || node.phase) {
                        this._needUpdate = false;
                        this._updateSwimlanePhase(node, options);
                    }
                }
            }
        },
        _updateSwimlaneSize: function (object, options) {
            if (object) {
                if (options.height) {
                    this._comparePropertyValues(object, "height", options);
                    var dif = options.height - object.height;
                    this._comparePropertyValues(object, "offsetY", { offsetY: object.offsetY + (dif / 2) });
                }
                if (options.width) {
                    this._comparePropertyValues(object, "width", options);
                    var dif = options.width - object.width;
                    this._comparePropertyValues(object, "offsetX", { offsetX: object.offsetX + (dif / 2) });
                }
                if (object.isSwimlane && (options.height || options.width)) {
                    var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(this, object);
                    if (lanes.length > 0) {
                        var lastLane = this.nameTable[lanes[lanes.length - 1]];
                        if (lastLane) {
                            if (object.orientation === "vertical") {
                                if (options.width) {
                                    if (options.width > object.width) {
                                        lastLane.minWidth = lastLane.width + options.width - object.width;
                                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, lastLane, true);
                                    }
                                }
                                if (options.height) {
                                    for (var i = 0; i < lanes.length; i++) {
                                        var lane = this.nameTable[lanes[i]];
                                        if (options.height >= object.height)
                                            lane.minHeight = options.height;
                                    }
                                }
                            }
                            else {
                                if (options.width) {
                                    for (var i = 0; i < lanes.length; i++) {
                                        var lane = this.nameTable[lanes[i]];
                                        if (options.width >= object.width)
                                            lane.minWidth = options.width;
                                    }
                                }
                                if (options.height) {
                                    if (options.height > object.height) {
                                        lastLane.minHeight = lastLane.height + options.height - object.height;
                                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, lastLane, true);
                                    }
                                }
                            }
                            ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, object, true);
                            ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, object);

                        }
                    }
                }
                else if (object.isLane && (options.height || options.width)) {
                    var swimlane = this.nameTable[object.parent.split("laneStack")[0]];
                    var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(this, swimlane);
                    ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                    if (swimlane && swimlane.orientation === "vertical") {
                        if (options.width) {
                            options.minWidth = options.width;
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, object, true);
                        }
                        if (options.height) {
                            for (var i = 0; i < lanes.length; i++) {
                                var lane = this.nameTable[lanes[i]];
                                if (options.height >= lane.height) {
                                    lane.minHeight = options.height;
                                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, lane, true);
                                }
                            }
                        }
                    }
                    else {
                        if (options.width) {
                            for (var i = 0; i < lanes.length; i++) {
                                var lane = this.nameTable[lanes[i]];
                                if (options.width >= lane.width) {
                                    lane.minWidth = options.width;
                                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, lane, true);
                                }
                            }
                        }
                        if (options.height) {
                            options.minHeight = options.height;
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, object, true);
                        }
                    }
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, swimlane, true);
                    ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, swimlane);
                }
            }
        },

        _updateShape: function (node, options) {
            var isShapeModified = false;
            if (options.type) {
                this._comparePropertyValues(node, "type", options);
                node.type = node._shape = options.type;
                isShapeModified = true;
            }
            if (options.shape) {
                this._comparePropertyValues(node, "shape", options);
                node.shape = node._shape = options.shape;
                isShapeModified = true;
            }
            if (node.type != "bpmn") {
                if (options.cornerRadius != undefined) {
                    this._comparePropertyValues(node, "cornerRadius", options);
                    node.cornerRadius = options.cornerRadius;
                    isShapeModified = true;
                }
                if (options.pathData) {
                    this._comparePropertyValues(node, "pathData", options);
                    node.pathData = options.pathData;
                    isShapeModified = true;
                }
                if (options.templateId !== undefined) {
                    node.templateId = options.templateId;
                    isShapeModified = true;
                }
                if (options.html !== undefined) {
                    this._comparePropertyValues(node, "html", options);
                    node.html = options.html;
                    isShapeModified = true;
                }
                if (options.contentId !== undefined) {
                    this._comparePropertyValues(node, "contentId", options);
                    node.contentId = options.contentId;
                    isShapeModified = true;
                }
                if (options.source) {
                    this._comparePropertyValues(node, "source", options);
                    node.source = options.source;
                    isShapeModified = true;
                }
                if (options.textBlock) {
                    this._comparePropertyValues(node, "textBlock", options);
                    node.textBlock = options.textBlock;
                    isShapeModified = true;
                }
                if (options.points) {
                    this._comparePropertyValues(node, "points", options);
                    node.points = options.points;
                    isShapeModified = true;
                }
                if (isShapeModified) {
                    if (node.children) delete node.children;
                    node = ej.datavisualization.Diagram.NodeType(node, this);
                    var htmlelement = document.getElementById(node.name + "_parentdiv");
                    if (htmlelement)
                        htmlelement.parentNode.removeChild(htmlelement);
                    ej.datavisualization.Diagram.DiagramContext.setNodeShape(node, this);
                    this._clearSelection(true);
                    this._addSelection(node, true);
                }
            }
            else {
                var shape = $.extend(true, {}, this.nameTable[node.name]);
                if (options.event) {
                    this._comparePropertyValues(node, "event", options);
                    shape.event = options.event;
                    isShapeModified = true;
                }
                if (options.trigger) {
                    this._comparePropertyValues(node, "trigger", options);
                    shape.trigger = options.trigger;
                    isShapeModified = true;
                }
                if (options.gateway) {
                    this._comparePropertyValues(node, "gateway", options);
                    shape.gateway = options.gateway;
                    isShapeModified = true;
                }
                if (options.data) {
                    this._comparePropertyValues(node, "data", options);
                    shape.data = $.extend(shape.data, options.data);;
                    isShapeModified = true;
                }
                if (options.activity) {
                    this._comparePropertyValues(node, "activity", options);
                    shape.activity = options.activity;
                    isShapeModified = true;
                }
                if (options.task !== undefined) {
                    this._comparePropertyValues(node, "task", options);
                    shape.task = $.extend(shape.task, options.task);
                    isShapeModified = true;
                }
                if (options.annotation !== undefined) {
                    this._comparePropertyValues(node, "annotation", options);
                    shape.annotation = $.extend(shape.annotation, options.annotation);
                    isShapeModified = true;
                }
                if (options.subProcess !== undefined) {
                    this._comparePropertyValues(node, "subProcess", options);
                    shape.subProcess = $.extend(shape.subProcess, options.subProcess);
                    isShapeModified = true;
                }
                if (options.direction) {
                    this._comparePropertyValues(node, "direction", options);
                    shape.direction = options.direction;
                    isShapeModified = true;
                }
                if (isShapeModified) {
                    var nextNode = this._svg.getElementById(node.name).nextSibling;
                    this._removeElement(node);
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[node.name], node);
                    ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this.nameTable[node.name]);
                    this._nodes = $.extend(true, [], this.nodes());
                    node = ej.datavisualization.Diagram.NodeType(shape, this);
                    if (node.type == "bpmn" && node.container)
                        node = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, node);
                    else
                        node = this._getNewGroup(node);
                    this._initGroupNode(node);
                    this.nameTable[node.name] = node;
                    this.nodes().push(node);
                    this._nodes = $.extend(true, [], this.nodes());
                    this._updateQuad(node);
                    ej.datavisualization.Diagram.DiagramContext.renderGroup(node, this);
                    if (nextNode) this._svg.getElementById(node.name).parentNode.insertBefore(this._svg.getElementById(node.name), this._svg.getElementById(nextNode.id));
                    this._clearSelection(true);
                    this._addSelection(node, true);
                }
            }
            return node;
        },
        _updateObject: function (node) {
            if (node) {
                if (node.type == "pseudoGroup") {
                    var child;
                    var children = this._getChildren(node.children);
                    for (var i = 0, len = children.length; i < len; i++) {
                        child = this.nameTable[children[i]];
                        ej.datavisualization.Diagram.DiagramContext.update(child, this);
                    }
                }
                else {
                    if (node.parent) {
                        ej.datavisualization.Diagram.Util._updateGroupBounds(this.nameTable[node.parent], this);
                    }
                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                }
            }
        },
        _udatePhaseSize: function (node, options) {
            var phsStack = this.nameTable[this._getChild(node.children[1])];
            if (node.orientation === "vertical") {
                if (phsStack.minWidth != options.phaseSize) {
                    phsStack.width = phsStack.maxWidth;
                    phsStack.minWidth = options.phaseSize;
                    var xdif = phsStack.maxWidth - options.phaseSize;
                    var xVar = (options.phaseSize / phsStack.maxWidth)
                    phsStack.maxWidth = options.phaseSize;
                    this.scale(phsStack, xVar, .0001, ej.datavisualization.Diagram.Point(phsStack.offsetX, phsStack.offsetY), this.nameTable);
                    if (phsStack.children && phsStack.children.length > 0) {
                        for (var i = 0; i < phsStack.children.length; i++) {
                            var child = this.nameTable[this._getChild(phsStack.children[i])];
                            if (child) {
                                this.scale(child, xVar, .0001, ej.datavisualization.Diagram.Point(child.offsetX, child.offsetY), this.nameTable);
                            }
                        }
                    }
                    var laneStack = this.nameTable[this._getChild(node.children[2])];
                    laneStack.marginLeft -= xdif;
                }
            }
            else if (node.orientation === "horizontal") {
                if (phsStack.minHeight != options.phaseSize) {
                    phsStack.height = phsStack.maxHeight;
                    phsStack.minHeight = options.phaseSize;
                    var ydif = phsStack.maxHeight - options.phaseSize;
                    var yVar = (options.phaseSize / phsStack.maxHeight)
                    yVar = (yVar === Infinity) ? 0 : yVar;
                    phsStack.maxHeight = options.phaseSize;
                    this.scale(phsStack, .0001, yVar, ej.datavisualization.Diagram.Point(phsStack.offsetX, phsStack.offsetY), this.nameTable);
                    if (phsStack.children && phsStack.children.length > 0) {
                        for (var i = 0; i < phsStack.children.length; i++) {
                            var child = this.nameTable[this._getChild(phsStack.children[i])];
                            if (child) {
                                this.scale(child, .0001, yVar, ej.datavisualization.Diagram.Point(child.offsetX, child.offsetY), this.nameTable);
                            }
                        }
                    }
                    var laneStack = this.nameTable[this._getChild(node.children[2])];
                    laneStack.marginTop -= ydif;
                }
            }
        },

        _updateLane: function (node, options) {
            if (node && options) {
                //#region updateHeader 
                if (options.header) {
                    this._comparePropertyValues(this.getNode(node.name), "header", options);
                    if (node.children && node.children.length > 0) {
                        var hdname, head;
                        hdname = this._getChild(node.children[0]);
                        if (hdname) {
                            head = this.nameTable[hdname];
                        }
                        if (head) {
                            var _undo = this._isUndo;
                            this._isUndo = true;
                            this.updateLabel(head.name, head.labels[0], options.header);
                            this._isUndo = _undo;
                            if (options.header.fillColor && options.header.fillColor != head.fillColor) {
                                this.updateNode(head.name, { fillColor: options.header.fillColor })
                            }
                        }
                    }
                }
                //#endregion
                if (options.fillColor && options.fillColor != node.fillColor) {
                    this._comparePropertyValues(node, "fillColor", options);
                    this.updateNode(node.name, { fillColor: options.fillColor })
                }
                if ((options.minHeight && options.minHeight != node.minHeight) || (options.minWidth && options.minWidth != node.minWidth)) {
                    if (options.minHeight) {
                        this._comparePropertyValues(node, "minHeight", options);
                        node.minHeight = options.minHeight;
                    }
                    if (options.minWidth) {
                        this._comparePropertyValues(node, "minWidth", options);
                        node.minWidth = options.minWidth;
                    }
                    var laneStack = this.nameTable[node.parent];
                    if (laneStack) {
                        var swimlane = this.nameTable[laneStack.parent];
                        if (swimlane)
                            ej.datavisualization.Diagram.SwimLaneContainerHelper._updateSwimlane(this, swimlane);
                    }
                    ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, swimlane);
                    ej.datavisualization.Diagram.SvgContext.updateSelector(swimlane, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                }

                if (options.constraints && options.constraints != node.constraints) {
                    this._comparePropertyValues(node, "constraints", options);
                    node.constraints = options.constraints;
                }
            }
        },
        _updateLastPhase: function (node, options, needUpdate) {
            if (node.isSwimlane) {
                if (node.phases && node.phases.length == 1) {
                    var df = 0;
                    var phase = this.nameTable[node.phases[0]];
                    if (node.orientation === "horizontal") {
                        phase.offset = node.minWidth - df;
                        this.updateNode(this.nameTable["phaseStack" + node.phases[0]].name, { width: node.minWidth - df });
                        if (needUpdate) {
                            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                            this.updateNode(this.nameTable["phaseStack" + node.phases[0]].name, { offsetX: bounds.x + node.width / 2 });
                        }
                    } else if (node.orientation === "vertical") {
                        phase.offset = node.minHeight - df
                        var height = phase.offset - df;
                        height = height - (options.header ? options.header.height : 50);
                        this.updateNode(this.nameTable["phaseStack" + node.phases[0]].name, { height: height });

                        if (needUpdate) {
                            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                            this.updateNode(this.nameTable["phaseStack" + node.phases[0]].name, { offsetY: (options.header ? options.header.height : 50) / 2 + bounds.y + node.height / 2 });
                        }
                    }
                }
            }
        },
        _updateSwimlane: function (node, options, update) {
            //#region updateHeader 
            if (options.header) {
                if (node.children && node.children.length > 0) {
                    var hdname, head;
                    hdname = this._getChild(node.children[0]);
                    if (hdname) {
                        head = this.nameTable[hdname];
                    }
                    if (head) {
                        var _isUndo = this._isUndo; this._isUndo = true;
                        this._comparePropertyValues(this.getNode(node.name), "header", options);
                        this.updateLabel(head.name, head.labels[0], $.extend({}, options.header, { width: 50 }));
                        if (options.header.fillColor && options.header.fillColor != head.fillColor) {
                            this.updateNode(head.name, { fillColor: options.header.fillColor })
                        }
                        this._isUndo = _isUndo;
                    }
                }
            }
            for (var item in options) {
                if (node[item]) {
                    if (options[item] !== node[item]) {
                        if (item === "offsetX") {
                            this._comparePropertyValues(this.getNode(node.name), "offsetX", options);
                            var dx = options.offsetX - node.offsetX;
                            if (this._outOfBoundsOnNudge(node, dx, 0))
                                this._translate(node, dx, 0, this.nameTable);
                        }
                        else if (item === "offsetY") {
                            this._comparePropertyValues(this.getNode(node.name), "offsetY", options);
                            var dy = options.offsetY - node.offsetY;
                            if (this._outOfBoundsOnNudge(node, 0, dy))
                                this._translate(node, 0, dy, this.nameTable);
                        }
                        else if (item !== "minWidth" && item !== "minHeight" && item !== "maxwidth" && item !== "maxHeight" && item != "width" && item != "height" && item != "phaseSize")
                            node[item] = options[item];
                    }
                }
            }
            //#region phases
            if (options.phases && options.phases.length > 0) {
                var phase;
                for (var i = 0; i < options.phases.length; i++) {
                    phase = this.nameTable[this._getChild(options.phases[i])];
                    if (phase)
                        this._updateSwimlanePhase(phase, options.phases[i], true);
                }
            }
            if (update) {
                if ((options.phaseSize || options.phaseSize === 0) && (options.phaseSize !== node.phaseSize)) {
                    this._comparePropertyValues(this.getNode(node.name), "phaseSize", options);
                    if (options.phaseSize != node.phaseSize)
                        var lastPhase = true;
                    var phaseStack = this.nameTable[node.name + "phaseStack"];
                    var laneStack = this.nameTable[node.name + "laneStack"];
                    var phase;
                    var d = options.phaseSize - node.phaseSize;
                    for (var i = 0; i < phaseStack.children.length; i++) {
                        phase = this.nameTable[this._getChild(phaseStack.children[i])];
                        if (phase) {
                            options.phaseSize = options.phaseSize === 0 ? .0001 : options.phaseSize;
                            node.orientation === "horizontal" ? phase.height = options.phaseSize : phase.width = options.phaseSize;
                        }
                    }
                    node.phaseSize += d;
                    node.orientation === "horizontal" ? laneStack.marginTop += d : laneStack.marginLeft += d;
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, phaseStack, null, node);
                }
            }
            //#endregion
            //#region lanes
            if (options.lanes && options.lanes.length > 0) {
                var lane;
                for (var i = 0; i < options.lanes.length; i++) {
                    lane = this.nameTable[this._getChild(options.lanes[i])];
                    if (lane) {
                        this._updateLane(lane, options.lanes[i]);
                    }
                }
            }
            //#endregion
            if (!update) {
                if (options && options.phaseSize)
                    var isPhaseUpdate = false;

                if (options.minHeight && options.minHeight != node.minHeight) {
                    this._comparePropertyValues(this.getNode(node.name), "minHeight", options);
                    node.minHeight = options.minHeight;
                    isPhaseUpdate = true;
                }
                if (options.minWidth && options.minWidth != node.minWidth) {
                    this._comparePropertyValues(this.getNode(node.name), "minWidth", options);
                    node.minWidth = options.minWidth;
                    isPhaseUpdate = true;
                }
                if (options.maxHeight && options.maxHeight != node.maxHeight) {
                    this._comparePropertyValues(this.getNode(node.name), "maxHeight", options);
                    node.minHeight = options.maxHeight;
                    isPhaseUpdate = true;
                }
                if (options.maxWidth && options.maxWidth != node.maxWidth) {
                    this._comparePropertyValues(this.getNode(node.name), "maxWidth", options);
                    node.minWidth = options.maxWidth;
                    isPhaseUpdate = true;
                }
                if (isPhaseUpdate && !this._isUndo) {
                    this._updateLastPhase(node, options);
                };
                if ((options.phaseSize || (options.phaseSize === 0)) && options.phaseSize != node.phaseSize) {
                    this._comparePropertyValues(this.getNode(node.name), "phaseSize", options);
                    this._udatePhaseSize(node, options);
                    if (options.phaseSize === 0)
                        node.phaseSize = 0;
                }
            }
            ej.datavisualization.Diagram.DiagramContext.update(node, this);
            if (this.selectionList[0] && this.selectionList[0].name === node.name)
                ej.datavisualization.Diagram.SvgContext.updateSelector(node, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
        },

        updateConnector: function (name, options) {
            if (name) {
                var connector = this._findConnector(name);
                if (connector) {
                    if (!this._isUndo)
                        this._recordPropertiesChanged(connector, options, "connector");
                    if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                        if (options.constraints !== undefined) {
                            this._comparePropertyValues(connector, "constraints", options);
                            connector.constraints = options.constraints;
                            if (!ej.datavisualization.Diagram.Util.canSelect(connector))
                                this._clearSelection(true);
                        }
                    }
                    if (options.lineColor) {
                        this._comparePropertyValues(connector, "lineColor", options);
                        connector.lineColor = options.lineColor;
                    }
                    if (options.cssClass || options.cssClass === "") {
                        this._comparePropertyValues(connector, "cssClass", options);
                        connector.cssClass = options.cssClass;
                    }
                    if (options.lineWidth || options.lineWidth === 0) {
                        this._comparePropertyValues(connector, "lineWidth", options);
                        connector.lineWidth = options.lineWidth;
                    }
                    if (options.lineDashArray !== undefined) {
                        this._comparePropertyValues(connector, "lineDashArray", options);
                        connector.lineDashArray = options.lineDashArray;
                    }
                    if (connector.shape && connector.shape.type == "umlclassifier") {
                        if (options.shape && options.shape.multiplicity != undefined) {
                            connector.shape.multiplicity = options.shape.multiplicity;
                            connector.shape.multiplicity = ej.datavisualization.Diagram.UMLConnectorMultiplicity(connector.shape.multiplicity);
                            var labels = ej.datavisualization.Diagram.ClassifierHelper.umlConnectorMultiplicity(connector)
                            for (var i = 0; i < connector.labels.length; i++) {
                                if (connector.labels[i].name == connector.name + "_sourcelabel")
                                    connector.labels[i].text = labels[0].text;
                                else if (connector.labels[i].name == connector.name + "_targetlabel")
                                    connector.labels[i].text = labels[1].text;
                            }
                        }
                    }
                    if (options.opacity !== undefined) {
                        this._comparePropertyValues(connector, "opacity", options);
                        connector.opacity = options.opacity;
                    }
                    if (options.cornerRadius !== undefined) {
                        this._comparePropertyValues(connector, "cornerRadius", options);
                        connector.cornerRadius = options.cornerRadius;
                    }
                    if (options.lineHitPadding !== undefined) {
                        this._comparePropertyValues(connector, "lineHitPadding", options);
                        connector.lineHitPadding = options.lineHitPadding;
                    }
                    if (options.sourcePadding != undefined) {
                        this._comparePropertyValues(connector, "sourcePadding", options);
                        connector.sourcePadding = options.sourcePadding;
                        this._dock(connector, this.nameTable);
                    }
                    if (options.targetPadding != undefined) {
                        this._comparePropertyValues(connector, "targetPadding", options);
                        connector.targetPadding = options.targetPadding;
                        this._dock(connector, this.nameTable);
                    }
                    if (options.visible != undefined) {
                        this._comparePropertyValues(connector, "visible", options);
                        connector.visible = options.visible;
                        if (!options.visible)
                            this._clearSelection();
                    }
                    if (options.bridgeSpace != undefined) {
                        this._comparePropertyValues(connector, "bridgeSpace", options);
                        connector.bridgeSpace = options.bridgeSpace;
                    }
                    if (options.tooltip !== undefined) {
                        this._comparePropertyValues(connector, "tooltip", options);
                        connector.tooltip = ej.datavisualization.Diagram.Tooltip($.extend(true, connector.tooltip, {}, options.tooltip));
                    }
                    if (options.segments) {
                        this._comparePropertyValues(connector, "segments", options);
                        if (options.segments.length > 1) {
                            var newarray = $.extend(true, [], options.segments);
                            connector.segments = newarray;
                        }
                        else {
                            connector.segments = options.segments;
                        }
                        ej.datavisualization.Diagram.Util._initConnectionEnds(connector, this);
                        if (this.model.defaultSettings.connector && this.model.defaultSettings.connector.segments && this.model.defaultSettings.connector.segments.length) {
                            var defaultType = this.model.defaultSettings.connector.segments[0].type;
                        }
                        ej.datavisualization.Diagram.Util._initializeSegments(connector, defaultType);
                        this._dock(connector, this.nameTable);
                        ej.datavisualization.Diagram.Util.updateBridging(connector, this);
                        //this._updateQuad(this, connector);
                        if (connector == this.selectionList[0]) {
                            ej.datavisualization.Diagram.SvgContext.clearSegments(this._adornerSvg);
                            ej.datavisualization.Diagram.SvgContext.addSegments(this._adornerSvg, this.selectionList[0], this._currZoom);

                        }
                    }
                    var decorator;
                    if (options.targetDecorator) {
                        this._comparePropertyValues(connector, "targetDecorator", options);
                        if (connector.targetDecorator) {
                            decorator = $.extend(true, {}, connector.targetDecorator, options.targetDecorator);
                        } else {
                            decorator = ej.datavisualization.Diagram.Decorator(options.targetDecorator);
                        }

                        connector.targetDecorator = decorator;
                    }
                    if (options.sourceDecorator) {
                        this._comparePropertyValues(connector, "sourceDecorator", options);
                        if (connector.sourceDecorator) {
                            decorator = $.extend(true, {}, connector.sourceDecorator, options.sourceDecorator);
                        } else {
                            decorator = ej.datavisualization.Diagram.Decorator(options.sourceDecorator);
                        }
                        connector.sourceDecorator = decorator;
                    }
                    if (options.sourceDecorator || options.targetDecorator) {
                        ej.datavisualization.Diagram.DiagramContext.clearDecorators(connector, this);
                        ej.datavisualization.Diagram.DiagramContext.renderDecorators(connector, this);
                    }
                    if (options.hasOwnProperty("sourceNode") || options.hasOwnProperty("targetNode") || options.hasOwnProperty("targetPort") || options.hasOwnProperty("sourcePort") || options.hasOwnProperty("targetPoint") || options.hasOwnProperty("sourcePoint")) {
                        if (options.sourceNode !== undefined) {
                            this._comparePropertyValues(connector, "sourceNode", options);
                            var node = this.nameTable[connector.sourceNode];
                            var sourceNode = this.nameTable[options.sourceNode];
                            var targetNode = this.nameTable[connector.targetNode];
                            var node1 = ej.datavisualization.Diagram.ClassifierHelper.EnableorDisableConnection(sourceNode, targetNode, connector, this);
                            if (node1)
                                options.sourceNode = node1.name;
                            else
                                options.sourceNode = null;
                            if (node && node.outEdges.indexOf(connector.name) != -1)
                                ej.datavisualization.Diagram.Util.removeItem(node.outEdges, connector.name);
                            connector.sourceNode = options.sourceNode;
                        }
                        if (options.targetNode !== undefined) {
                            this._comparePropertyValues(connector, "targetNode", options);
                            var sourceNode = this.nameTable[connector.sourceNode];
                            var targetNode = this.nameTable[options.targetNode];
                            var node = this.nameTable[connector.targetNode];
                            var node1 = ej.datavisualization.Diagram.ClassifierHelper.EnableorDisableConnection(targetNode, sourceNode, connector, this);
                            if (node1)
                                options.targetNode = node1.name;
                            else
                                options.targetNode = null;
                            if (node && node.inEdges.indexOf(connector.name) != -1)
                                ej.datavisualization.Diagram.Util.removeItem(node.inEdges, connector.name);
                            connector.targetNode = options.targetNode;
                        }
                        if (options.targetPort !== undefined) {
                            this._comparePropertyValues(connector, "targetPort", options);
                            connector.targetPort = options.targetPort;
                        }
                        if (options.sourcePort !== undefined) {
                            this._comparePropertyValues(connector, "sourcePort", options);
                            connector.sourcePort = options.sourcePort;
                        }
                        if (options.targetPoint !== undefined) {
                            this._comparePropertyValues(connector, "targetPoint", options);
                            ej.datavisualization.Diagram.Util._setLineEndPoint(connector, options.targetPoint, true);
                        }
                        if (options.sourcePoint !== undefined) {
                            this._comparePropertyValues(connector, "sourcePoint", options);
                            ej.datavisualization.Diagram.Util._setLineEndPoint(connector, options.sourcePoint, false);
                        }
                        this._updateEdges(connector);
                        this._dock(connector, this.nameTable);
                    }
                    ej.datavisualization.Diagram.Util.updateBridging(connector, this);
                    if (this._svg) {
                        this._updateConnectorBridging(connector);
                        ej.datavisualization.Diagram.DiagramContext.update(connector, this);
                        ej.datavisualization.Diagram.DiagramContext.updateConnectorStyle(connector, this);
                    }
                    if (this.selectionList[0] && this.selectionList[0].name === connector.name)
                        ej.datavisualization.Diagram.SvgContext.updateSelector(connector, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                }
            }
        },
        _updateDrawType: function (option) {
            var shape, singleAction = false, shapes;
            var tool = option.tool;
            if (tool & ej.datavisualization.Diagram.Tool.ContinuesDraw)
                singleAction = false;
            else if (tool & ej.datavisualization.Diagram.Tool.DrawOnce)
                singleAction = true;
            var drawType = option.drawType ? option.drawType : this.model.drawType;
            if (drawType) {
                if (drawType.type === "connector" && !this.activeTool._isPolyline()) {
                    var defaultconnectorsettings = this.model.defaultSettings.connector;
                    var defaultType = defaultconnectorsettings && defaultconnectorsettings.segments && defaultconnectorsettings.segments.length ? defaultconnectorsettings.segments[0].type : "";
                    var type = drawType.segments && drawType.segments.length && drawType.segments[0].type ? drawType.segments[0].type : defaultType;
                    if (type === "bezier" || this.model.connectorType === "bezierLine")
                        this.activateTool("bezierLine", singleAction);
                    else if (type === "orthogonal" || this.model.connectorType === "orthogonalLine")
                        this.activateTool("orthogonalLine", singleAction);
                    else if (type === "straight" || this.model.connectorType === "straightLine")
                        this.activateTool("straightLine", singleAction);
                }
                else if (drawType.type === "text")
                    this.activateTool("text", singleAction);
                else if (drawType.type || drawType.shape) {
                    shape = drawType.shape ? drawType.shape : drawType.type;
                    if (drawType.type == "basic")
                        shapes = ej.datavisualization.Diagram.BasicShapes;
                    else if (drawType.type == "flow")
                        shapes = ej.datavisualization.Diagram.FlowShapes;
                    else if (drawType.type == "arrow")
                        shapes = ej.datavisualization.Diagram.ArrowShapes;
                    else if (drawType.type == "bpmn")
                        shapes = ej.datavisualization.Diagram.BPMNShapes;
                    for (var key in shapes) {
                        if (shapes[key] == drawType.shape) {
                            shape = drawType.type;
                            break;
                        }
                    }
                    if (shape)
                        this._drawToolShape(shape, singleAction);
                }
            }
        },
        update: function (option) {
            if (option.scrollSettings) {
                this._eventCause["scrollChange"] = ej.datavisualization.Diagram.ScrollChangeCause.Unknown;
                this._setModel({ scrollSettings: option.scrollSettings });
            }
            if (option.backgroundColor) {
                this._setModel({ backgroundColor: option.backgroundColor });
            }
            if (option.tool) {
                this.activeTool._showAllPorts(true);
                var tool = option.tool;
                this.tool(tool);
                this._compareModelProperty("tool");
                if (tool & ej.datavisualization.Diagram.Tool.ContinuesDraw || tool & ej.datavisualization.Diagram.Tool.DrawOnce) {
                    this._updateDrawType(option);
                }
                else if (tool & ej.datavisualization.Diagram.Tool.ZoomPan) {
                    if (ej.datavisualization.Diagram.Util.canPanning(this)) {
                        this._toolToActivate = "panTool";
                        this.activeTool = this.tools[this._toolToActivate];
                        this.activeTool._isMouseDown = false;
                        this._currentCursor = "pointer";
                    }
                }
                else if (tool & ej.datavisualization.Diagram.Tool.MultipleSelect) {
                    this.activateTool("select", false);
                }
            }
            if (option.bridgeDirection) {
                this.bridgeDirection(typeof option.bridgeDirection === 'function' ? option.bridgeDirection() : option.bridgeDirection);
                this._compareModelProperty("bridgeDirection");
                var connectors = this.connectors();
                for (var i = 0, len = connectors.length; i < len; i++) {
                    var connector = connectors[i];
                    if (connector && ej.datavisualization.Diagram.Util.canBridge(connector, this)) {
                        ej.datavisualization.Diagram.Util.updateBridging(connector, this);
                        ej.datavisualization.Diagram.DiagramContext.update(connector, this);
                    }
                }
            }
        },
        bringToCenter: function (rect) {
            var scale = this._currZoom;
            var viewPort = this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            var actualbounds = { x: rect.x * scale, y: rect.y * scale, width: rect.width * scale, height: rect.height * scale };
            var hoffset = actualbounds.x + actualbounds.width / 2 - viewPort.width / 2;
            var voffset = actualbounds.y + actualbounds.height / 2 - viewPort.height / 2;
            ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, 1, this._hScrollOffset - hoffset, this._vScrollOffset - voffset, null, false);
        },
        bringIntoView: function (bounds) {
            var x = 0, y = 0;
            var scale = this._currZoom;
            bounds.right = bounds.right ? bounds.right : bounds.x + bounds.width;
            bounds.bottom = bounds.bottom ? bounds.bottom : bounds.y + bounds.height;
            var hoffset = this._hScrollOffset;
            var voffset = this._vScrollOffset;
            var viewPort = this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            bounds = { x: bounds.x * scale, y: bounds.y * scale, width: bounds.width * scale, height: bounds.height * scale, right: bounds.right * scale, bottom: bounds.bottom * scale };
            var view = { x: this._hScrollOffset, y: this._vScrollOffset, width: viewPort.width, height: viewPort.height };
            if (!(ej.datavisualization.Diagram.Geometry.containsRect(view, bounds))) {
                if (bounds.right > (-hoffset + viewPort.width)) {
                    x = bounds.right - viewPort.width;
                }
                if (bounds.x < -hoffset) {
                    x = bounds.x;
                }
                if (bounds.bottom > (-voffset + viewPort.height)) {
                    y = bounds.bottom - viewPort.height;
                }
                if (bounds.y < -voffset) {
                    y = bounds.y;
                }
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, 1, this._hScrollOffset - x, this._vScrollOffset - y, null, false);
            }
        },
        getBridgeSegment: function (startPt, endPt, angle, bridgeSpace, sweep) {
            var path = "A " + bridgeSpace / 2 + " " + bridgeSpace / 2 + "  " + angle + " , 1 " + sweep + " " + endPt.x + "," + endPt.y;
            return path;
        },
        fitToPage: function (mode, region, margin) {
            var zoomFactor, factor, scale = {}, bounds;
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            //margin
            margin = margin || {};
            margin = {
                top: !isNaN(margin.top) ? margin.top : 25,
                bottom: !isNaN(margin.bottom) ? margin.bottom : 25,
                left: !isNaN(margin.left) ? margin.left : 25,
                right: !isNaN(margin.right) ? margin.right : 25
            };
            //region
            region = region ? region : "pageSettings";
            //fit mode
            if ((region == "pageSettings" && this.model.pageSettings.pageWidth && this.model.pageSettings.pageHeight) || (this.nodes().length > 0 || this.connectors().length > 0)) {
                mode = mode ? mode : "page";
                if (region != "custom") {
                    bounds = this._getDigramBounds(region);
                    bounds.x -= this.model.scrollSettings.padding.left;
                    bounds.y -= this.model.scrollSettings.padding.top;
                    bounds.width += (this.model.scrollSettings.padding.left + this.model.scrollSettings.padding.right);
                    bounds.height += (this.model.scrollSettings.padding.top + this.model.scrollSettings.padding.bottom);
                }
                var width = bounds.width;
                var height = bounds.height;
                scale.x = (viewPort.width - (margin.left + margin.right)) / width;
                scale.y = (viewPort.height - (margin.top + margin.bottom)) / height;
                var deltaX = this._hScrollOffset;
                var deltaY = this._vScrollOffset;
                var centerX, centerY;
                switch (mode) {
                    case "width":
                        zoomFactor = scale.x;
                        factor = zoomFactor / this._getCurrentZoom();
                        centerX = (viewPort.width - (region != "content" ? bounds.width : width) * zoomFactor) / 2 - bounds.x * zoomFactor;
                        deltaX += centerX + (margin.left - margin.right) / 2 * zoomFactor;
                        //deltaX -= bounds.x * zoomFactor;
                        deltaY -= this._vScrollOffset * factor;
                        deltaY = region != "custom" ? deltaY : deltaY + this._vScrollOffset * factor;
                        break;
                    case "height":
                        zoomFactor = scale.y;
                        factor = zoomFactor / this._getCurrentZoom();
                        //var centerX = (viewPort.width - (bounds.x > 0 ? bounds.width : width) * zoomFactor - bounds.x * zoomFactor) / 2;
                        //deltaX += centerX - (bounds.x * zoomFactor) / 4 + margin.left;
                        //deltaY -= bounds.y * zoomFactor - margin.top;
                        centerX = (viewPort.width - (region != "content" ? bounds.width : width) * zoomFactor) / 2 - bounds.x * zoomFactor;
                        centerY = (viewPort.height - (region != "content" ? bounds.height : height) * zoomFactor) / 2 - bounds.y * zoomFactor;
                        deltaX += centerX + (margin.left - margin.right) / 2 * zoomFactor;
                        deltaY += centerY + (margin.top - margin.bottom) / 2 * zoomFactor;
                        break;
                    case "page":
                        zoomFactor = Math.min(scale.x, scale.y);
                        factor = zoomFactor / this._getCurrentZoom();
                        centerX = (viewPort.width - (region != "content" ? bounds.width : width) * zoomFactor) / 2 - bounds.x * zoomFactor;
                        centerY = (viewPort.height - (region != "content" ? bounds.height : height) * zoomFactor) / 2 - bounds.y * zoomFactor;
                        deltaX += centerX + (margin.left - margin.right) / 2 * zoomFactor;
                        deltaY += centerY + (margin.top - margin.bottom) / 2 * zoomFactor;
                        break;
                }
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, factor, deltaX, deltaY, new ej.datavisualization.Diagram.Point(0, 0), true);
            } else {
                factor = 1 / this._getCurrentZoom();
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, factor, this._hScrollOffset, this._vScrollOffset, new ej.datavisualization.Diagram.Point(0, 0), true);
            }
        },
        exportDiagram: function (options) {
            options = ej.datavisualization.Diagram.ExportSettings(options);
            var fileType, customBounds, content;
            if (!options) options = {};
            //region
            var region = options && options.region ? options.region : "content";
            //mode
            var mode = options && options.mode ? options.mode : "download";
            //margin
            var margin = options.margin || {};
            margin = {
                top: !isNaN(margin.top) ? margin.top : 25,
                bottom: !isNaN(margin.bottom) ? margin.bottom : 25,
                left: !isNaN(margin.left) ? margin.left : 25,
                right: !isNaN(margin.right) ? margin.right : 25
            };
            //region
            var bounds = this._getDigramBounds(region);
            if (options.bounds) {
                customBounds = true;
                bounds = {
                    x: (!isNaN(options.bounds.x) ? options.bounds.x : bounds.x),
                    y: (!isNaN(options.bounds.y) ? options.bounds.y : bounds.y),
                    width: (options.bounds.width || bounds.width),
                    height: (options.bounds.height || bounds.height)
                };
            }
            var nodes = this.nodes();
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                var labels = node.labels;
                for (var j = 0; j < labels.length; j++) {
                    var label = labels[j];
                    if (label.visible)
                        var labelbounds = ej.datavisualization.Diagram.Util.getLabelbounds(this, node, label);
                    if (labelbounds)
                        bounds = this._union(labelbounds, bounds);
                }

            }
            bounds.x -= margin.left;
            bounds.y -= margin.top;
            bounds.width += margin.left + margin.right;
            bounds.height += margin.top + margin.bottom;
            //Target file name
            var fileName = options.fileName || "diagram";
            if (options.format != "svg") {
                this._setScaleValueforCanvas(options, bounds);
                var canvas = this._diagramAsCanvas({ bounds: bounds, margin: margin, region: region, scaleX: options._scaleX, scaleY: options._scaleY }, customBounds);
                fileType = options.format || "jpg";
                var image = content = canvas.toDataURL();
                if (mode == "data") return content;
                if (!(ej.browserInfo().name === "msie" && parseFloat(ej.browserInfo().version) < 10)) {
                    if (options.multiplePage) {

                        options.pageHeight = options.pageHeight ? options.pageHeight : this.model.pageSettings.pageHeight;
                        options.pageWidth = options.pageWidth ? options.pageWidth : this.model.pageSettings.pageWidth;
                        options.pageHeight = options.pageHeight ? options.pageHeight : canvas.width;
                        options.pageWidth = options.pageWidth ? options.pageWidth : canvas.height;
                        margin = options.margin || {};
                        var swap = false;
                        if (options.pageOrientation == ej.datavisualization.Diagram.PageOrientations.Landscape) {
                            if (options.pageHeight > options.pageWidth) {
                                swap = true;
                            }
                        }
                        else {
                            if (options.pageWidth > options.pageHeight) {
                                swap = true;
                            }
                        }
                        if (swap) {
                            var temp = options.pageWidth;
                            options.pageWidth = options.pageHeight;
                            options.pageHeight = temp;
                        }

                        options.margin = {
                            top: !isNaN(margin.top) ? margin.top : 0,
                            bottom: !isNaN(margin.bottom) ? margin.bottom : 0,
                            left: !isNaN(margin.left) ? margin.left : 0,
                            right: !isNaN(margin.right) ? margin.right : 0
                        }
                        var img = document.createElement('img');
                        var attr = {
                            "id": this.element[0].id + "_printImage",
                            "src": image,
                        };
                        ej.datavisualization.Diagram.Util.attr(img, attr);
                        var images = this._getMultipleImage(img, options, true);
                    }
                    else {
                        images = [image];
                    }
                    var buffers = [];
                    for (var g = 0; g < images.length; g++) {
                        image = images[g];
                        image = image.replace(/^data:[a-z]*;,/, '');
                        var image1 = image.split(',');
                        var byteString = atob(image1[1]);
                        var buffer = new ArrayBuffer(byteString.length);
                        var intArray = new Uint8Array(buffer);
                        for (var i = 0; i < byteString.length; i++) {
                            intArray[i] = byteString.charCodeAt(i);
                        }
                        buffers.push(buffer);
                    }
                }

            } else {
                var buffers = [];
                fileType = options.format || "svg";
                var svg = content = this._diagramAsSvg({ bounds: bounds, margin: margin });
                if (mode == "data") return content;
                if (!(ej.browserInfo().name === "msie" && parseFloat(ej.browserInfo().version) < 10)) {
                    buffer = new XMLSerializer().serializeToString(svg);
                    buffers.push(buffer);
                }

            }
            if (mode == "download") {
                var browserInfo = ej.browserInfo();
                if (browserInfo.name === "msie" && parseFloat(browserInfo.version) < 10 || browserInfo.name == "webkit") {
                    var info = browserInfo.name == "webkit" ? "Safari" : "IE-9";
                    alert("Downloading option is not supported in " + info + ", Please use the returned data");
                    return content;
                }
                else {
                    for (var b = 0; b < buffers.length; b++) {
                        var blob = new Blob([buffers[b]], { type: 'application/octet-stream' });
                        if (browserInfo.name === "msie")
                            window.navigator.msSaveOrOpenBlob(blob, fileName + '.' + fileType);
                        else {
                            var pom = document.createElement('a');
                            var url = URL.createObjectURL(blob);
                            pom.href = url;
                            pom.setAttribute('download', fileName + '.' + fileType);
                            if (document.createEvent) {
                                var e = document.createEvent("MouseEvents");
                                e.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
                                pom.dispatchEvent(e);
                            } else if (pom.fireEvent) {
                                pom.fireEvent("onclick");
                            }
                        }
                    }
                }
            }
        },
        _diagramAsSvg: function (options) {
            var svg = new ej.datavisualization.Diagram.Svg({ "id": "diagram_svg", "width": options.bounds.width, "height": options.bounds.height });
            document.body.appendChild(svg.document);
            var g = this._svg.document.getElementById(this._canvas.id + "_pageBackground");
            g = $(g).find("#pageback")[0];
            g = g.cloneNode(true);
            var bounds = this._getDigramBounds();
            var left = bounds.x;
            var top = bounds.y;
            var width = bounds.width;
            var height = bounds.height;
            svg.appendChild(g);
            g.setAttribute("transform", "translate(" + (-options.bounds.x) + ", " + (-options.bounds.y) + ")");
            g.setAttribute("x", left);
            g.setAttribute("y", top);
            g.setAttribute("width", width);
            g.setAttribute("height", height);
            g = this._svg.document.getElementById(this._canvas.id + "_diagramLayer");
            g = g.cloneNode(true);
            svg.appendChild(g);
            g.setAttribute("transform", "translate(" + (-options.bounds.x) + ", " + (-options.bounds.y) + ")");

            var nodes = this.nodes();
            //renderLabels
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                if (node._type == "group")
                    ej.datavisualization.Diagram.SvgContext._renderLabelGroup(node, svg, this);
                else
                    ej.datavisualization.Diagram.SvgContext._renderLabelsAsSvg(node, svg, this);
                if (node.annotation) {
                    if (node._annotation && node._annotation.length) {
                        for (var n = 0; n < node._annotation.length; n++) {
                            if (diagram.nameTable[node._annotation[n]]) {
                                var element = diagram.nameTable[node._annotation[n]];
                                ej.datavisualization.Diagram.SvgContext._renderLabelsAsSvg(element, svg, this);
                            }
                        }
                    }
                }
            }
            var connectors = this.connectors();
            for (var i = 0; i < connectors.length; i++) {
                var connector = connectors[i];
                ej.datavisualization.Diagram.SvgContext._renderLabelsAsSvg(connector, svg, this);
            }
            document.body.removeChild(svg.document);
            svg.appendChild(this._svg.document.getElementById(this._canvas.id + "patterndefinition").cloneNode(true));
            return svg.document;
        },

        _setScaleValueforCanvas: function (options, bounds) {
            options._scaleX = 1;
            options._scaleY = 1;
            options.pageHeight = options.pageHeight ? options.pageHeight : this.model.pageSettings.pageHeight;
            options.pageWidth = options.pageWidth ? options.pageWidth : this.model.pageSettings.pageWidth;
            var height = options.pageHeight ? options.pageHeight : bounds.height;
            var width = options.pageWidth ? options.pageWidth : bounds.width;
            if (options.stretch === "fill" || options.stretch === "uniform" || options.stretch === "uniformtofill") {
                options._scaleX = width / bounds.width;
                options._scaleY = height / bounds.height;
                if (options.stretch === "uniform")
                    options._scaleX = options._scaleY = Math.min(options._scaleX, options._scaleY);
                else if (options.stretch === "uniformtofill")
                    options._scaleX = options._scaleY = Math.max(options._scaleX, options._scaleY);
                bounds.width = width;
                bounds.height = height;
            }
            bounds.x *= options._scaleX;
            bounds.y *= options._scaleY;
        },

        _diagramAsCanvas: function (options, customBounds) {
            var elements, element;
            var region = options.bounds;
            var margin = options.margin;
            var pageBounds = this._getDigramBounds();
            var bgColor = this._pageBackgroundColor();
            var canvas = new ej.datavisualization.Diagram.Canvas({ "id": "mycanvas", "width": region.width, "height": region.height });
            canvas._diagram = this;
            canvas._scaleX = options.scaleX;
            canvas._scaleY = options.scaleY;
            var context = canvas.document.getContext("2d");
            context.fillStyle = this._backgroundColor();
            context.translate(-region.x, -region.y);
            context.fillRect(region.x, region.y, region.width, region.height);
            var bgImg = this._backgroundImage();
            if (bgImg && bgImg.source) {
                var pageBounds = this._getDigramBounds();
                var image = new Image();
                image.src = bgImg.source;
                var proportionX = pageBounds.width / image.width;
                var proportionY = pageBounds.height / image.height;
                var x = pageBounds.x;
                var y = pageBounds.y;
                var width = pageBounds.width;
                var height = pageBounds.height;
                var exportable = ej.datavisualization.Diagram.CanvasContext._isImageExportable(bgImg);
                if (bgImg.scale != "none" && bgImg.alignment != "none") {
                    var proportion = bgImg.scale == "meet" ? Math.min(proportionX, proportionY) : Math.max(proportionX, proportionY);
                    width = proportion * image.width;
                    height = proportion * image.height;
                    if (bgImg.alignment.indexOf("xmid") > -1) {
                        x += (pageBounds.width - width) / 2;
                    }
                    else if (bgImg.alignment.indexOf("xmax") > -1) {
                        x = x + pageBounds.width - width;
                    }
                    if (bgImg.alignment.indexOf("ymid") > -1) {
                        y += (pageBounds.height - height) / 2;
                    }
                    else if (bgImg.alignment.indexOf("ymax") > -1) {
                        y = y + pageBounds.height - height;
                    }
                    if (this._backgroundColor() == "none" || this._backgroundColor() == "transparent") {
                        context.fillStyle = "white";
                        context.fillRect(pageBounds.x * options.scaleX, pageBounds.y * options.scaleY, pageBounds.width * options.scaleX, pageBounds.height * options.scaleY);
                    }
                    if (exportable)
                        context.drawImage(image, x, y, proportion * image.width, proportion * image.height);
                }
                else if (exportable) context.drawImage(image, x, y, pageBounds.width, pageBounds.height);
            }
            else {
                context.fillStyle = bgColor;
                context.fillRect((pageBounds.x * options.scaleX) - margin.left, (pageBounds.y * options.scaleY) - margin.top, (pageBounds.width * options.scaleX) + margin.left + margin.right, (options.scaleY * pageBounds.height) + margin.top + margin.bottom);
            }
            var brColor = this._pageBorderColor();
            var brWidth = this._pageBorderWidth();
            if (brWidth) {
                context.strokeStyle = brColor == "none" ? "transparent" : brColor;
                context.lineWidth = brWidth;
                context.strokeRect(pageBounds.x * options.scaleX, pageBounds.y * options.scaleY, pageBounds.width * options.scaleX, pageBounds.height * options.scaleY);
            }
            elements = this.nodes().concat(this.connectors());
            elements = this._sortByZIndex(elements, true);
            this._sortByGroupChildrenZIndex(true);
            for (var i = 0; i < elements.length; i++) {
                element = elements[i];
                if (element.segments)
                    ej.datavisualization.Diagram.CanvasContext.renderConnector(element, canvas);
                else if (element._type === "group" && !element.parent) {
                    ej.datavisualization.Diagram.CanvasContext.renderGroup(element, canvas, this);
                }
                else if (element._type === "node" && !element.isPhase && !element.parent)
                    ej.datavisualization.Diagram.CanvasContext.renderNode(element, canvas);
            }

            /*canvas.line({ x: region.x + margin.left / 2, y: region.y }, { x: region.x + margin.left / 2, y: region.y + region.height }, { lineWidth: margin.left, stroke: bgColor });
        var y = region.y + region.height - margin.bottom / 2;
        canvas.line({ x: region.x, y: y }, { x: region.x + region.width, y: y }, { lineWidth: margin.bottom, stroke: bgColor });
        var x = region.x + region.width - margin.right / 2;
        canvas.line({ x: x, y: region.y + region.height }, { x: x, y: region.y }, { lineWidth: margin.right, stroke: bgColor });
        y = region.y + margin.top / 2;
        canvas.line({ x: region.x + region.width, y: y }, { x: region.x, y: y }, { lineWidth: margin.top, stroke: bgColor });*/
            return canvas.document;
        },
        _renderCanvasPhase: function (element, canvas) {

            var tx = 0, ty = 0;
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this, element), phase;
            if (phases) {
                for (var i = 0; i < phases.length; i++) {
                    phase = this.nameTable[phases[i]];
                    var parNode = this.nameTable[element.name];
                    if (parNode) {
                        var children = this._getChildren(parNode.children);
                        if (children.length > 1)
                            var header = this.nameTable[children[0]];
                        var bounds = ej.datavisualization.Diagram.Util.bounds(parNode);
                        var points = [], nPoint;
                        var top = bounds.top + 50;
                        var left = bounds.left + 50;
                        if (phase.orientation == "vertical") {
                            points.push({ x: 0, y: 0 });
                            points.push({ x: bounds.width, y: 0 });
                            nPoint = ej.datavisualization.Diagram.SvgContext._convertToSVGPoints(points);
                            tx = bounds.x;
                            ty = bounds.y + phase.offset;
                            if (header)
                                ty += header.height;
                            for (var j = 0, len = points.length; j < len; ++j) {
                                var point = ej.datavisualization.Diagram.Geometry.translate(points[j], tx, ty);
                                points[j] = point;
                            }
                        } else {
                            points.push({ x: 0, y: header.height ? header.height : 0 });
                            points.push({ x: 0, y: bounds.height });
                            tx = bounds.x + phase.offset;
                            ty = bounds.y;
                            for (var j = 0, len = points.length; j < len; ++j) {
                                var point = ej.datavisualization.Diagram.Geometry.translate(points[j], tx, ty);
                                points[j] = point;
                            }
                        }
                    }
                    for (var k = 0; k < points.length; k++) {
                        var point = points[k];
                        point.x *= canvas._scaleX;
                        point.y *= canvas._scaleY;
                    }
                    ej.datavisualization.Diagram.CanvasContext.renderPhases(phase, canvas, points);
                }
            }
        },

        _getPrintCanvasStyle: function (img, options) {
            var width = 0, height = 0;
            if (img) {
                width = img.width;
                height = img.height;
            }
            if (options) {
                if (options.pageHeight || options.pageWidth) {
                    height = options.pageHeight ? options.pageHeight : height;
                    width = options.pageWidth ? options.pageWidth : width;
                }
                if (options.pageOrientation) {
                    var temp;
                    if (options.pageOrientation === "landscape" && height > width) {
                        temp = width;
                    }
                    else if (options.pageOrientation === "portrait" && width > height) {
                        temp = width;
                    }
                    if (temp) {
                        width = height;
                        height = temp;
                    }
                }
            }
            return { height: height, width: width };
        },

        _getMultipleImage: function (img, printSettings, isExport) {
            var imageArray = [];
            var div = document.createElement("div");
            var pageSize = this._getPrintCanvasStyle(img, printSettings), pageWidth, pageHeight;
            var margin = printSettings.margin;
            var mLeft = margin.left;
            var mTop = margin.top;
            var mRight = margin.right;
            var mBottom = margin.bottom;
            var x = 0, y = 0;
            pageWidth = pageSize.width + x;
            pageHeight = pageSize.height + y;
            var drawnX = 0;
            var drawnY = 0;
            if (printSettings && printSettings.multiplePage) {
                div.style.height = "auto";
                div.style.width = "auto";
                var imgHeight = img.height;
                var imgWidth = img.width;
                if (img) {
                    var i = 0, j = 0, url, ctx, canvas, clipWidth = 0, clipHeight = 0;
                    do {
                        do {
                            clipWidth = pageSize.width;
                            clipHeight = pageSize.height;
                            if ((drawnX + pageSize.width) >= imgWidth)
                                clipWidth = (imgWidth - drawnX);
                            if ((drawnY + pageSize.height) >= imgHeight)
                                clipHeight = (imgHeight - drawnY);
                            canvas = new ej.datavisualization.Diagram.Canvas({ "id": "multiplePrint" + i + "" + j, "width": pageSize.width, "height": pageSize.height });
                            ctx = canvas.document.getContext("2d");
                            ctx.drawImage(img, x + drawnX + mLeft,
                                               y + drawnY + mTop,
                                               clipWidth - mRight - mLeft,
                                               clipHeight - mBottom - mTop,
                                               0 + mLeft,
                                               0 + mTop,
                                               clipWidth - mRight - mLeft,
                                               clipHeight - mBottom - mTop);

                            if ((drawnX + pageSize.width) >= imgWidth)
                                drawnX -= (drawnX - imgWidth);
                            url = canvas.document.toDataURL();
                            ctx.restore();
                            drawnX += pageWidth;
                            if (isExport)
                                imageArray.push(url);
                            else
                                this._printImage(div, url, i + "" + j); i++;
                        } while (drawnX < imgWidth)
                        j++;
                        i = x = drawnX = 0;
                        if ((drawnY + pageSize.height) >= imgHeight)
                            drawnY -= (drawnY - imgHeight);
                        drawnY += pageHeight;
                    } while (drawnY < imgHeight)
                }
            }
            else {
                var x = 0, y = 0;
                var pageSize = this._getPrintCanvasStyle(img, printSettings), pageWidth, pageHeight;
                pageWidth = pageSize.width;
                pageHeight = pageSize.height;
                canvas = new ej.datavisualization.Diagram.Canvas({ "id": "multiplePrint0", "width": pageWidth, "height": pageHeight });
                ctx = canvas.document.getContext("2d");
                ctx.drawImage(img, x + mLeft, y + mTop, img.width - (mRight + mLeft), img.height - (mTop + mBottom), 0 + mLeft, 0 + mTop, pageWidth - (mRight + mLeft), pageHeight - (mTop + mBottom));
                url = canvas.document.toDataURL();
                ctx.restore();
                this._printImage(div, url, 0)
            }
            if (isExport)
                return imageArray;
            else
                return div;
        },

        _printImage: function (div, url, i) {
            var img1, innerDiv, attr;
            img1 = document.createElement('img');
            innerDiv = document.createElement('div');
            attr = { "class": "e-diagram-print-page", };
            ej.datavisualization.Diagram.Util.attr(innerDiv, attr);
            attr = { "id": this.element[0].id + "_multiplePrint_img" + i, "style": "float:left", "src": url };
            ej.datavisualization.Diagram.Util.attr(img1, attr);
            innerDiv.appendChild(img1);
            div.appendChild(innerDiv);
        },

        print: function (options) {
            options = ej.datavisualization.Diagram.PrintSettings(options);
            var url = this.exportDiagram({ mode: "data", region: options.region, margin: { top: 0, bottom: 0, left: 0, right: 0, }, stretch: options.stretch });
            var img = document.createElement('img');
            var attr = {
                "id": this.element[0].id + "_printImage",
                "src": url,
            };
            ej.datavisualization.Diagram.Util.attr(img, attr);
            var tempObj = this;
            img.onload = function () {
                var div = tempObj._getMultipleImage(img, options);
                // specify window parameters
                var PrintWind = window.open('');
                if (PrintWind != null) {
                    PrintWind.document.write('<html><head><style> body{margin:0px;}  @media print { .e-diagram-print-page {page-break-after: left; }.e-diagram-print-page:last-child {page-break-after: avoid;}}  </style><title></title></head>');
                    PrintWind.document.write('<BODY onload="setTimeout(function(){window.print();}, 100)">');
                    PrintWind.document.write("<center>" + div.innerHTML + "</center>");
                    PrintWind.document.close();
                }
            }
        },
        save: function () {
            var drawingTools = this.model.drawingTools;
            var userHandles = this.model.selectedItems.userHandles;
            this.model.drawingTools = null;
            this.model.selectedItems.userHandles = null;
            if (this.nameTable["multipleSelection"]) {
                ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this.nameTable["multipleSelection"]);
                this._nodes = $.extend(true, [], this.nodes());
            }
            this._updateTableNodes();
            var model = jQuery.extend(true, {}, this.model);
            if (ej.version)
                model.version = ej.version;
            this._updateGroupChildren(model);
            this.model.drawingTools = drawingTools;
            this.model.selectedItems.userHandles = userHandles;
            this._checkForNullValues(model);
            return model;
        },
        _checkForNullValues: function (model) {
            this._checkTargetNull(model.pageSettings);

        },
        _checkTargetNull: function (target) {
            for (var member in target) {
                if (target[member] == null || target[member] == Infinity) {
                    target[member] = 0;
                }
                else if (typeof (target[member]) === "object" && target[member])
                    this._checkTargetNull(target[member]);
            }
        },
        _updateGroupChildren: function (model) {
            var nodes = [], connectors = [], swimlane;
            var tempNodes = typeof model.nodes === 'function' ? model.nodes() : model.nodes;
            if (tempNodes && tempNodes.length > 0) {
                for (var i = 0; i < tempNodes.length; i++) {
                    if (tempNodes[i].parent === "" && !tempNodes[i].isSwimlane) {
                        this._updateChildren(tempNodes[i]);
                        nodes.push(jQuery.extend(true, {}, tempNodes[i]))
                    }
                    else if (tempNodes[i].isSwimlane) {
                        swimlane = this._getNode(tempNodes[i].name);
                        this._isSwimlaneExist = true;
                        if (swimlane)
                            nodes.push(jQuery.extend(true, {}, swimlane))
                    }
                }
            }
            var tempConnectors = typeof model.connectors === 'function' ? model.connectors() : model.connectors;
            if (tempConnectors && tempConnectors.length > 0) {
                for (var i = 0; i < tempConnectors.length; i++) {
                    connectors.push(tempConnectors[i]);
                }
            }
            model.connectors = connectors;
            model.nodes = nodes;
        },
        _updateChildren: function (node) {
            var children = [];
            if (node && node.children && node.children.length > 0) {
                var child, childName;
                for (var i = 0; i < node.children.length; i++) {
                    childName = this._getChild(node.children[i]);
                    if (childName)
                        child = this.nameTable[childName];
                    if (child)
                        children.push(jQuery.extend(true, {}, child));
                }
            }
            node.children = children;
        },
        _containsNode: function (node) {
            node = this._getChild(node);
            var chnode = null;
            for (var i = 0; i < this.nodes().length; i++) {
                chnode = this.nodes()[i];
                if (chnode) {
                    if (chnode.name === node)
                        return true;
                }
            }
            return null;
        },

        _updateTableNodes: function () {
            var i = 0, node, connector, cphase;
            for (i; i < this.nodes().length; i++) {
                node = this.nameTable[this.nodes()[i].name];
                if (node) {
                    this.nodes()[i] = node;
                    if (node._type === "group") {
                        this._updateTableGroup(node);
                    }
                }
            }
            for (i; i < this.connectors().length; i++) {
                connector = this.nameTable[this.connectors()[i].name];
                if (connector) {
                    this.connectors()[i] = connector;
                }
            }
        },
        _updateTableGroup: function (group) {
            var children = group.children;
            for (var i = 0; i < group.children.length; i++) {
                group.children[i] = this.nameTable[this._getChild(group.children[i])];
                if (group.children[i] && group.children[i]._type === "group") {
                    this._updateTableGroup(group.children[i]);
                }
            }
        },
        upgrade: function (data) {
            //Support to upgrade diagram JSON data from 12.1
            var version = Number(data.version);
            if (isNaN(version)) {
                version = data.version.split(".");
                data.version = version = Number(version[0] + "." + version[1]);
            }
            if (!data.version) {
                //CommonAPIChanges
                this.commonAPIChanges(data);
                //Node and Connector constraints set to default
                if (data.nodes) {
                    for (var i = 0 ; i < data.nodes.length; i++) {
                        if (!data.nodes[i].inEdges) {
                            data.nodes[i].inEdges = [];
                            data.nodes[i].outEdges = [];
                        }
                        data.nodes[i].constraints = ej.datavisualization.Diagram.NodeConstraints.Default;
                    }
                }
            }
            else if (version < 14.2) {
                if (data.nodes) {
                    if (version < 14.1) {
                    for (var i = 0 ; i < data.nodes.length; i++) {
                        var node = data.nodes[i];
                        this.setConstraints(node);
                    }
                }
                }
                if (data.connectors) {
                    for (var j = 0; j < data.connectors.length ; j++) {
                        var connector = data.connectors[j];
                        if (version < 14.1) {
                        connector.constraints |= ej.datavisualization.Diagram.ConnectorConstraints.PointerEvents;
                        if (connector.labels && connector.labels.length > 0) {
                            for (var label, m = 0; m < connector.labels.length ; m++) {
                                label = connector.labels[m];
                                label.relativeMode = ej.datavisualization.Diagram.LabelRelativeMode.SegmentBounds;
                            }
                        }
                        }
                        if (version < 14.2) {
                            if (connector && connector.segments && connector.segments.length === 1 && connector.segments[0].type === "orthogonal") {
                                connector.segments[0].length = 13;
                            }
                        }
                    }
                }
            }
            else if (data.version == "13.1") {
                //No Code Changes
            }
        },
        setConstraints: function (node) {
            if (node && node.type == "group" && !node.isSwimlane) {
                node.constraints |= ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                for (var i = 0; i < node.children.length; i++) {
                    var child = node.children[i];
                    if (child.type == "group") {
                        this.setConstraints(child);
                    }
                    else {
                        child.constraints |= ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                    }
                }
            }
            else if (node && node.type == "group" && node.isSwimlane) {
                node.constraints |= ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                for (var j = 0; j < node.lanes.length; j++) {
                    var lane = node.lanes[j];
                    lane.constraints |= ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                    for (var k = 0; k < lane.children.length; k++) {
                        var child = lane.children[k];
                        if (child.type == "group") {
                            this.setConstraints(child);
                        }
                        else {
                            child.constraints |= ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                        }
                    }
                }
            }
            else {
                node.constraints |= ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
            }
        },
        commonAPIChanges: function (data) {
            // defaultSettings API Added
            data.defaultSettings = { node: data.nodeDefaults, connectors: data.connectorDefaults };
            // line is changed to segments; Inserting segments
            if (data.connectors) {
                for (var i = 0 ; i < data.connectors.length; i++) {
                    //Setting the Connector's constraints to Default
                    data.connectors[i].constraints = ej.datavisualization.Diagram.ConnectorConstraints.Default;
                    if (data.connectors[i].line) {
                        if (data.connectors[i].line.type == "straight") {
                            var segments = [{
                                type: "straight",
                                startPoint: data.connectors[i].line.startPoint,
                                endPoint: data.connectors[i].line.endPoint
                            }];
                            this.commonSourceTargetChanges(data.connectors[i]);
                        }
                        else if (data.connectors[i].line.type == "orthogonal") {
                            var segments = [{
                                type: "orthogonal",
                                startPoint: data.connectors[i].line.startPoint,
                                endPoint: data.connectors[i].line.endPoint,
                            }];
                            this.commonSourceTargetChanges(data.connectors[i]);
                        }
                        else if (data.connectors[i].line.type == "bezier") {
                            var segments = [{
                                type: "bezier",
                                startPoint: data.connectors[i].line.startPoint,
                                endPoint: data.connectors[i].line.endPoint,
                                point1: data.connectors[i].line.point1,
                                point2: data.connectors[i].line.point2
                            }];
                            this.commonSourceTargetChanges(data.connectors[i]);
                        }
                        data.connectors[i].sourcePoint = data.connectors[i].line.startPoint;
                        data.connectors[i].targetPoint = data.connectors[i].line.endPoint;
                        data.connectors[i].segments = segments;
                    }
                }
            }
        },
        commonSourceTargetChanges: function (data) {
            if (data.sourceNodeName)
                data.sourceNode = data.sourceNodeName;
            if (data.sourceNodePort)
                data.sourcePort = data.sourceNodePort;
            if (data.targetNodeName)
                data.targetNode = data.targetNodeName;
            if (data.targetPortName)
                data.targetPort = data.targetPortName;
        },
        load: function (data) {
            this._isLoad = true;
            this._spatialSearch = ej.datavisualization.Diagram.SpatialSearch();
            this.clear();
            this._zOrder = 0;
            if (this.enableContextMenu()) {
                var menuObj = $("#" + this.element[0].id + "_contextMenu").data("ejMenu");
                menuObj.destroy();
                $("#" + this.element[0].id + "_contextMenu").remove();
            }

            if (data && data.nodes && data.nodes.length > 0) {
                for (var i = data.nodes.length - 1; i >= 0; i--) {
                    var node = data.nodes[i];
                    if (node && (node.type === "connector" || node.segments)) {
                        data.connectors.push(node);
                        data.nodes.splice(i, 1);
                    }
                }
            }
            if (data && data.connectors && data.connectors.length > 0) {
                for (var i = data.connectors.length - 1; i >= 0; i--) {
                    var connector = data.connectors[i];
                    var isConnectorRemoved = false;
                    if (connector.targetNode) {
                        if (!this._isExist(data, connector.targetNode)) {
                            isConnectorRemoved = true;
                            data.connectors.splice(i, 1);
                        }
                    }
                    if (connector.sourceNode) {
                        if (!this._isExist(data, connector.sourceNode) && !isConnectorRemoved) {
                            data.connectors.splice(i, 1);
                        }
                    }
                }
            }
            this.upgrade(data);
            var load = {
                nodes: data.nodes ? data.nodes : [],
                connectors: data.connectors ? data.connectors : [],
                commandManager: data.commandManager ? data.commandManager : {},
                contextMenu: data.contextMenu ? data.contextMenu : {},
                snapSettings: data.snapSettings ? data.snapSettings : {},
                historyManager: data.historyManager ? data.historyManager : this._initHistoryManager(),
                backgroundImage: data.backgroundImage ? data.backgroundImage : ej.datavisualization.Diagram.BackgroundImage({ source: "" }),
                enableAutoScroll: data.enableAutoScroll ? data.enableAutoScroll : true,
                autoScrollMargin: data.autoScrollMargin ? data.autoScrollMargin : 20,
                layout: data.layout ? data.layout : {},
                pageSettings: data.pageSettings ? data.pageSettings : {},
                click: data.click ? data.click : null,
                connectionChange: data.connectionChange ? data.connectionChange : null,
                defaultSettings: data.defaultSettings ? data.defaultSettings : { node: null, connector: null },
                dataSource: data.dataSource ? data.dataSource : null,
                dataSourceSchema: data.dataSourceSettings ? data.dataSourceSettings : {},
                doubleClick: data.doubleClick ? data.doubleClick : null,
                enableContextMenu: data.enableContextMenu ? data.enableContextMenu : true,
                tooltip: data.tooltip ? data.tooltip : null,
                height: data.height ? data.height : null,
                mouseEnter: data.mouseEnter ? data.mouseEnter : null,
                mouseOver: data.mouseOver ? data.mouseOver : null,
                mouseLeave: data.mouseLeave ? data.mouseLeave : null,
                nodeTemplate: data.nodeTemplate ? data.nodeTemplate : null,
                rotationChange: data.rotationChange ? data.rotationChange : null,
                selectorConstraints: data.selectorConstraints ? data.selectorConstraints : ej.datavisualization.Diagram.SelectorConstraints.All,
                width: data.width ? data.width : null,
                constraints: data.constraints,
                phases: data.phases ? data.phases : [],
                scrollSettings: data.scrollSettings ? data.scrollSettings : {
                    horizontalOffset: 0,
                    verticalOffset: 0,
                    currentZoom: 1,
                    viewPortHeight: 0,
                    viewPortWidth: 0,
                    zoomFactor: data.zoomFactor ? data.zoomFactor : 0.2,
                    padding:{ left: 0, right: 0, top: 0, bottom: 0 }
                },
            };
            this._tempCommandManager = data.commandManager;
            if (data.showTooltip !== undefined) {
                load.showTooltip = data.showTooltip;
            }
            if (data.tooltipTemplateId !== undefined) {
                load.tooltipTemplateId = data.tooltipTemplateId;
            }
            $("#" + this._id).ejDiagram(load);
            this._isLoad = false;
            delete this._tempCommandManager;
        },

        _isExist: function (data, name) {
            var isExist = false;
            for (var i = 0; data.nodes && i < data.nodes.length; i++) {
                if (!isExist) {
                    var node = data.nodes[i];
                    if (node) {
                        if (node.isSwimlane) {
                            if (node.lanes) {
                                var lanes = node.lanes;
                                for (var j = 0; j < lanes.length; j++) {
                                    isExist = this._checkNodeExist(lanes[j], name);
                                    if (isExist)
                                        break;
                                }
                            }
                        }
                        else {
                            isExist = this._checkNodeExist(node, name);
                            if (isExist)
                                break;
                        }
                    }
                }
            }
            return isExist;
        },

        _checkNodeExist: function (node, name) {
            if (node.children) {
                for (var i = 0; i < node.children.length; i++) {
                    var child = node.children[i];
                    if (child) {
                        var state = this._checkNodeExist(child, name)
                        if (state) return true;
                    }
                }
            }
            if (node.name === name)
                return true;
            return false;
        },
        layout: function () {
            this._setLayout();
        },
        _setLayout: function () {
            //this.model.layout = new ej.datavisualization.Diagram.HierarchicalLayout(this.model.layout);
            this._doLayout();
            ej.datavisualization.Diagram.PageUtil._updatePageSize(this);
            this._clearSelection();
            //this._updateNodes();
            //this._updateConnectors();
        },
        addSelection: function (node, clearSelection) {
            var selectedItem, pseudoGroup;
            if (node && !this._selectionContains(node)) {
                if (this.model.selectedItems.children.length > 0 && !clearSelection) {
                    pseudoGroup = this.nameTable["multipleSelection"];
                    if (!pseudoGroup) {
                        pseudoGroup = ej.datavisualization.Diagram.Group({ type: "pseudoGroup", "name": "multipleSelection" });
                        this.nodes().push(pseudoGroup);
                        this.nameTable[pseudoGroup.name] = pseudoGroup;
                    }
                    if (this.model.selectedItems.children.length > 1)
                        pseudoGroup.children = this.selectionList[0].children;
                    else
                        pseudoGroup.children.push(this.selectionList[0].name)
                    pseudoGroup.children.push(node.name);
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, this, null, true);
                    selectedItem = pseudoGroup;
                }
                else {
                    selectedItem = node;
                }
                if (this._hasSelection())
                    this._clearSelection(true);
                if (pseudoGroup && this.nameTable["multipleSelection"] === undefined && clearSelection === false) {
                    this.nodes().push(pseudoGroup);
                    this.nameTable[pseudoGroup.name] = pseudoGroup;
                }
                this._addSelection(selectedItem);
            }
        },

        clearSelection: function () {
            this._clearSelection();
        },
        removeSelection: function (node) {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                if (node) {
                    var node = this.nameTable[node.name];
                    if (this.selectionList[0] == node || this.selectionList[0].type == "pseudoGroup" && this.selectionList[0].children.length == 1) { this._clearSelection(); }
                    else if (this.selectionList[0].type == "pseudoGroup" && this._collectionContains(node.name, this.selectionList[0].children)) {
                        var index = this.selectionList[0].children.indexOf(node.name);
                        if (index != -1)
                            ej.datavisualization.Diagram.Util.removeItem(this.selectionList[0].children, node.name);
                        else
                            ej.datavisualization.Diagram.Util.removeItem(this.selectionList[0].children, node);
                        ej.datavisualization.Diagram.Util.removeItem(this.model.selectedItems.children, node);
                        ej.datavisualization.Diagram.Util._updateGroupBounds(this.selectionList[0], this);
                        this._updateSelectionHandle();
                    }
                }
            }
        },
        updateSelectedObject: function (nodeName, parent) {
            var node = this.nameTable[nodeName];
            if (node && (ej.datavisualization.Diagram.Util.canSelect(node) || node._isHeader)) {
                this.activeTool.selectedObject = node;
            }
            if (parent && parent.isSwimlane)
                this.activeTool.selectedObject = parent
        },
        updateSelection: function (isDragging) {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                this._updateSelectionHandle(isDragging);
            }
        },
        activateTool: function (toolName, singleAction) {
            if (this.tools[toolName]) {
                if (this.activeTool instanceof ej.datavisualization.Diagram.LineTool) {
                    this.activeTool._showAllPorts(true);
                }
                this._toolToActivate = toolName;
                this.activeTool = this.tools[this._toolToActivate];
                this.activeTool.singleAction = true;
                if (singleAction === false || toolName === "panTool")
                    this.activeTool.singleAction = false;
            }
            if (this.activeTool instanceof ej.datavisualization.Diagram.PanTool) {
                this._currentCursor = "pointer";
                this.activeTool.startPoint = ej.datavisualization.Diagram.Point(0, 0);
                this.activeTool._isMouseDown = false;
            }
            if (this.activeTool instanceof ej.datavisualization.Diagram.LineTool) {
                if (this.activeTool.singleAction)
                    this.tool(this.tool() | ej.datavisualization.Diagram.Tool.DrawOnce);
                else
                    this.tool(this.tool() | ej.datavisualization.Diagram.Tool.ContinuesDraw);
                this.activeTool._showAllPorts();
            }
            this._drawingTool = true;
        },
        deactivateTool: function () {
            if (this.activeTool instanceof ej.datavisualization.Diagram.LineTool) {
                this.activeTool._showAllPorts(true);
            }
            if (this.tool() & ej.datavisualization.Diagram.Tool.DrawOnce)
                this.tool(this.tool() ^ ej.datavisualization.Diagram.Tool.DrawOnce);
            if (this.tool() & ej.datavisualization.Diagram.Tool.ContinuesDraw)
                this.tool(this.tool() ^ ej.datavisualization.Diagram.Tool.ContinuesDraw);
            if (this.tool() & ej.datavisualization.Diagram.Tool.ZoomPan) {
                this._toolToActivate = "panTool";
                this.activeTool = this.tools[this._toolToActivate];
                this.activeTool._mousedown = false;
                this._currentCursor = "pointer";
            } else {
                this._toolToActivate = "select";
                this.activeTool = this.tools[this._toolToActivate];
                this.tool(ej.datavisualization.Diagram.Tool.SingleSelect | ej.datavisualization.Diagram.Tool.MultipleSelect);
            }
        },
        updateLabel: function (nodeName, label, obj) {
            if (nodeName && (ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                var mNode = this._findNode(nodeName);
                if (!mNode)
                    mNode = this._findConnector(nodeName);
                if (obj && label && !obj.name || label.name == obj.name) {
                    if (mNode) {
                        if (!this._isUndo)
                            this._recordPropertiesChanged(mNode, obj, "label", label);
                        if (mNode.type !== "text") {
                            label = this._findLabel(mNode, label.name);
                        }
                        obj.name = label.name;
                        this._comparePropertyValues(mNode, "labels", obj);
                        for (var prop in obj)
                            if (label.hasOwnProperty(prop)) {
                                if (typeof obj[prop] == "object")
                                    label[prop] = $.extend(true, {}, label[prop], obj[prop]);
                                else
                                    label[prop] = obj[prop];
                            }
                        if (obj["wrapText"] !== undefined) label["wrapping"] = obj["wrapText"] ? "wrapwithoverflow" : "nowrap";
                        if (mNode.segments || mNode.type !== "text") {
                            ej.datavisualization.Diagram.DiagramContext.updateLabelStyle(mNode, label, this);
                            ej.datavisualization.Diagram.DiagramContext.updateLabel(mNode, label, this);
                        } else if (mNode.type === "text") {
                            ej.datavisualization.Diagram.DiagramContext.updateTextBlock(mNode, label, this);
                        }
                    }
                    if (obj.mode === ej.datavisualization.Diagram.LabelEditMode.Edit) {
                        this.startLabelEdit(mNode, label);
                    }
                }
            }
            return label;
        },
        startLabelEdit: function (node, label) {
            if (node) {
                //Disables the edit mode of labels in the selectionList
                for (var i = 0; i < this.selectionList.length; i++) {
                    var mNode = this.selectionList[i];
                    if (mNode !== node && typeof mNode.labels.length != "undefined") {
                        for (var j = 0; j < mNode.labels.length; j++)
                            mNode.labels[j].mode = ej.datavisualization.Diagram.LabelEditMode.View;
                    }
                }
                if (!label && node.type === "text")
                    label = node.textBlock;
                if (this._setLabelEditing(label))
                    this._startEdit(node);
                else {
                    this._endEdit();
                }
            }
        },
        _setSelectorConstraints: function (constraints) {
            this.model.selectedItems.constraints = constraints;
            if (this.selectionList[0]) {
                ej.datavisualization.Diagram.SvgContext.clearSelector(this._adornerSvg, this._adornerLayer);
                ej.datavisualization.Diagram.SvgContext.renderSelector(this.selectionList[0], this._adornerSvg, this._adornerLayer, this._currZoom, constraints);
                if (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                    ej.datavisualization.Diagram.SvgContext.renderUserHandles(this.model.selectedItems.userHandles, this.selectionList[0], this._adornerSvg, this.selectionList[0].type == "pseudoGroup",
                        this._currZoom, this._adornerLayer, this);
            }
        },
        _raiseGroupChangeEvent: function (element, oldParent, newParent, cause) {
            var args = {};
            args.element = element ? element : null;
            args.oldParent = oldParent ? oldParent : null;
            args.newParent = newParent ? newParent : null;
            args.cause = cause ? cause : null;
            if (oldParent != newParent)
                this._raiseEvent("groupChange", args);
        },
        group: function () {
            if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup") {
                var selectionList = [];
                var i;
                for (i = 0; i < this.selectionList[0].children.length; i++)
                    selectionList.push(this.nameTable[this.selectionList[0].children[i]]);
                this._sortByZIndex(selectionList, true);
                var element;
                var groupName = ej.datavisualization.Diagram.Util.randomId();
                var group = new ej.datavisualization.Diagram.Group({ name: groupName, rotateAngle: this.selectionList[0].rotateAngle });
                var oldParent, newParent;
                this._clearSelection(true);
                for (i = 0; i < selectionList.length; i++) {
                    this._isUndo = true;
                    group.children.push(selectionList[i].name);
                    if (selectionList[i].parent) {
                        oldParent = this.nameTable[selectionList[i].parent];
                        if (oldParent) {
                            ej.datavisualization.Diagram.Util.removeChildFromGroup(oldParent.children, selectionList[i].name);
                        }
                    }
                    selectionList[i].parent = groupName;
                    ej.datavisualization.Diagram.Util.removeItem(this.selectionList, selectionList[i].name);
                    if (!selectionList[i].segments) {
                        ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this.nameTable[selectionList[i].name]);
                        this._nodes = $.extend(true, [], this.nodes());
                    }
                    else {
                        ej.datavisualization.Diagram.Util.removeItem(this.connectors(), this.nameTable[selectionList[i].name]);
                        this._connectors = $.extend(true, [], this.connectors());
                    }
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[selectionList[i].name], selectionList[i]);
                    if (selectionList[i].type == "html") {
                        element = document.getElementById(selectionList[i].name + "_parentdiv");
                        element.parentNode.removeChild(element);
                    } else {
                        if (selectionList[i]._type === "group")
                            this._checkForHtmlNode(selectionList[i]);
                    }
                    // $("#" + selectionList[i].name)[0].parentNode.removeChild($("#" + selectionList[i].name)[0]);
                    element = this._svg.document.getElementById(selectionList[i].name);
                    if (element)
                        element.parentNode.removeChild(element);
                    this._removeElement(selectionList[i]);
                    this._raiseGroupChangeEvent(selectionList[i], oldParent, group, "group");
                }
                ej.datavisualization.Diagram.Util.clear(this.selectionList);
                group = this._getNewGroup(group);
                this._eventCause["nodeCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.Unknown;
                this._isGroupNode = true;
                this.add(group);
                //this._addSelection(group);
                var entry = { type: "groupchanged", object: group, actionType: "group", category: "internal" };
                this.addHistoryEntry(entry);
                //var entry = new ej.datavisualization.Diagram.HistoryEntry(new ej.datavisualization.Diagram.GroupHandleCmd(group, "group"));
                //this.historyManager.addHistoryEntry(entry);
                this._isUndo = false;
                delete this._isGroupNode;
            }
        },
        _checkForHtmlNode: function (group) {
            var children = this._getChildren(group.children);
            for (var i = 0; i < children.length; i++) {
                var child = this.nameTable[children[i]];
                if (child) {
                    if (child._type === "group") {
                        this._checkForHtmlNode(child);
                    } else {
                        if (child.type == "html") {
                            var element = document.getElementById(child.name + "_parentdiv");
                            element.parentNode.removeChild(element);
                        }
                    }
                }
            }
        },
        _removeChildren: function (group, args) {
            var children = this._getChildren(group.children);
            for (var i = 0; i < children.length; i++) {
                var child = this.nameTable[children[i]];
                if (child) {
                    if (group.isLane) {
                        this._disConnect(child, args);
                        this._removeConnector(child, args);
                    }
                    else {
                        if (child.segments) {
                            this._removeEdges(child);
                            child.sourceNode = child.sourcePort = child.targetNode = child.targetPort = null;
                        }
                        else
                            this._disConnect(child, args, true);
                    }
                    ej.datavisualization.Diagram.Util.removeItem(this.nodes(), child);
                    this._nodes = $.extend(true, [], this.nodes());
                    if (child._type === "group") {
                        this._removeChildren(child, args);
                        ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[child.name], child);
                        ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, child);
                        delete this.nameTable[child.name];
                    } else {
                        ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[child.name], child);
                        ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, child);
                        delete this.nameTable[child.name];
                    }
                    this._removeElement(child);
                }
            }
        },
        ungroup: function () {
            if (this.selectionList[0] && this.selectionList[0]._type === "group" && this.selectionList[0].canUngroup && !(this.selectionList[0].isSwimlane || this.selectionList[0].isLane)) {
                this._isUndo = true;
                var selectionList = this.selectionList[0].children;
                var i, node;
                var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                node = this.selectionList[0];
                $("#" + this.selectionList[0].name)[0].parentNode.removeChild($("#" + this.selectionList[0].name)[0]);
                this._removeElement(this.selectionList[0]);
                this._checkForHtmlNode(this.selectionList[0]);
                this._clearSelection();
                var object;
                ej.datavisualization.Diagram.Util.clear(this.selectionList);
                var newParent, oldParent;
                for (i = 0; i < selectionList.length; i++) {
                    var item = this.nameTable[this._getChild(selectionList[i])];
                    if (item.parent)
                        oldParent = this.nameTable[item.parent];
                    if ($(htmlLayer).children("#" + item.name)[0])
                        htmlLayer.removeChild($(htmlLayer).children("#" + item.name)[0]);
                    if (item) {
                        if (item.parent)
                            item.parent = null;
                        if (item.segments) {
                            object = item;
                            object.parent = "";
                            this._updateEdges(object);
                            this._dock(object, this.nameTable);
                            ej.datavisualization.Diagram.DiagramContext.renderConnector(object, this);
                            if (this.connectors().indexOf(object) === -1) {
                                this.connectors().push(object);
                                this._connectors = $.extend(true, [], this.connectors());
                            }
                        }
                        else {
                            object = item;
                            object.parent = "";
                            if (object._type === "group") {
                                this._updateChildrenEdges(object);
                                if (object.isLane || object.isSwimlane) {
                                    object.width = 0;
                                    object.height = 0;
                                }
                                ej.datavisualization.Diagram.DiagramContext.renderGroup(object, this);
                            }
                            else
                                ej.datavisualization.Diagram.DiagramContext.renderNode(object, this);
                            if (this.nodes().indexOf(object) === -1) {
                                this.nodes().push(object);
                                this._nodes = $.extend(true, [], this.nodes());
                            }
                        }
                        if (item.parent)
                            newParent = this.nameTable[item.parent];
                        this._raiseGroupChangeEvent(item, oldParent, newParent, "unGroup");
                    }
                }
                //this._clearSelection();
                ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this._findNode(node.name));
                ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[node.name], node);
                ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, node);
                var entry = { type: "groupchanged", object: node, actionType: "ungroup", category: "internal" };
                this.addHistoryEntry(entry);

                //var entry = new ej.datavisualization.Diagram.HistoryEntry(new ej.datavisualization.Diagram.GroupHandleCmd(node, "ungroup"));
                //this.historyManager.addHistoryEntry(entry);
                this._isUndo = false;
            }
        },
        nudge: function (direction, delta) {
            delta = !delta ? 1 : delta;
            var dir = { up: { x: 0, y: -delta }, down: { x: 0, y: delta }, left: { x: -delta, y: 0 }, right: { x: delta, y: 0 } };
            var nudge = dir[direction];
            var undoDirection;
            if (direction === "up")
                undoDirection = "down";
            else if (direction === "down")
                undoDirection = "up";
            else if (direction === "left")
                undoDirection = "right";
            else if (direction === "right")
                undoDirection = "left";

            if (nudge && this.selectionList[0] && !this.selectionList[0].isLane && !this.selectionList[0].isPhase) {
                if (!this._isUndo) {
                    this.addHistoryEntry({
                        type: "nudge", object: this.selectionList[0], undoDirection: undoDirection, redoDirection: direction, values: delta,
                        category: "internal"
                    });
                }
                this._nudge(this.selectionList[0], nudge.x, nudge.y, direction);
            }
        },
        selectAll: function () {
            var collection, nodes, i, len, item = null;
            this._clearSelection(true);
            collection = ej.datavisualization.Diagram.Group({ type: "pseudoGroup", name: "multipleSelection" });
            nodes = this.nodes();
            for (i = 0, len = nodes.length; i < len; i++) {
                if (ej.datavisualization.Diagram.Util.canSelect(nodes[i])) {
                    item = this.nameTable[nodes[i].name];
                    if (item && item.parent == "" && item.type != "pseudoGroup" && item.visible) {
                        collection.children.push(item.name);
                    }
                }
            }
            var connectors = this.connectors();
            for (i = 0, len = connectors.length; i < len; i++) {
                if (ej.datavisualization.Diagram.Util.canSelect(connectors[i])) {
                    if (connectors[i].parent == "" && connectors[i].visible) {
                        collection.children.push(connectors[i].name);
                    }
                }
            }
            ej.datavisualization.Diagram.Util._updateGroupBounds(collection, this);
            //ej.datavisualization.Diagram.Util.clear(this.selectionList);
            this.nodes().push(collection);
            this._nodes = $.extend(true, [], this.nodes());
            this.nameTable[collection.name] = collection;
            if (collection.children.length > 0)
                this._addSelection(collection);
        },
        align: function (direction) {
            if (this.selectionList[0] && (this.selectionList[0].type === "group" || this.selectionList[0].type == "pseudoGroup") && this.selectionList[0].children && this.selectionList[0].children.length > 0) {
                var list = this.nameTable[this.selectionList[0].name].children;
                var history = [];
                var cNode;
                var cornerNodes = this._findCornerNodes();
                if (direction === "left")
                    cNode = cornerNodes.left;
                else if (direction === "right")
                    cNode = cornerNodes.right;
                else if (direction === "top")
                    cNode = cornerNodes.top;
                else if (direction === "bottom")
                    cNode = cornerNodes.bottom;
                var cNodeBounds;
                if (cNode)
                    cNodeBounds = ej.datavisualization.Diagram.Util.bounds(cNode);
                else if (direction === "center" || direction === "middle") {
                    cNodeBounds = ej.datavisualization.Diagram.Util.bounds(this.selectionList[0]);
                }
                if (cNodeBounds) {
                    var i, bounds, node, x = 0, y = 0;
                    for (i = 0; i < list.length; i++) {
                        node = this.nameTable[list[i]];
                        bounds = ej.datavisualization.Diagram.Util.bounds(node);
                        if (direction === "left")
                            x = -(bounds.x - cNodeBounds.x);
                        else if (direction === "right")
                            x = -((bounds.x + bounds.width) - (cNodeBounds.x + cNodeBounds.width));
                        else if (direction === "top")
                            y = -(bounds.y - cNodeBounds.y);
                        else if (direction === "bottom")
                            y = -((bounds.y + bounds.height) - (cNodeBounds.y + cNodeBounds.height));
                        else if (direction === "center")
                            x = -((bounds.x + bounds.width / 2) - (cNodeBounds.x + cNodeBounds.width / 2));
                        else if (direction === "middle")
                            y = -((bounds.y + bounds.height / 2) - (cNodeBounds.y + cNodeBounds.height / 2));
                        this._moveNode(x, y, node);
                        this._updateContainerOnNudge(node);
                        history.push({ object: node, delta: { x: x, y: y } });
                    }
                    ej.datavisualization.Diagram.Util._updateGroupBounds(this.selectionList[0], this);
                    ej.datavisualization.Diagram.SvgContext.updateSelector(this.selectionList[0], this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                }
                this.addHistoryEntry({ type: "alignCommand", values: history, category: "internal", object: this.selectionList[0] });
            }
        },
        sameSize: function () {
            if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup" && this.selectionList[0].children && this.selectionList[0].children.length > 0) {
                var list = this.nameTable[this.selectionList[0].name].children;
                var fNode = this.nameTable[this.selectionList[0].children[0]];
                var fNodeBounds = ej.datavisualization.Diagram.Util.bounds(fNode);
                var history = [];
                this._isSizingCommand = true;
                for (var i = 0; i < list.length; i++) {
                    var element = this.nameTable[list[i]];
                    if (!(element.segments)) {
                        //if ((element._shape === "path") && ((element.height !== fNodeBounds.height) || (element.width !== fNodeBounds.width)))
                        //    element._scaled = true;
                        history.push({ object: element, values: { width: element.width || element._width || 0, height: element.height || element._height || 0 } });
                        this.updateNode(element.name, { width: fNodeBounds.width, height: fNodeBounds.height });
                    }
                }
                delete this._isSizingCommand;
                this.addHistoryEntry({ type: "sizeCommand", category: "internal", object: this.selectionList[0], values: history });
                ej.datavisualization.Diagram.Util._updateGroupBounds(this.selectionList[0], this);
                ej.datavisualization.Diagram.SvgContext.updateSelector(this.selectionList[0], this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
            }
        },
        sameHeight: function () {
            if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup" && this.selectionList[0].children && this.selectionList[0].children.length > 0) {
                var list = this.nameTable[this.selectionList[0].name].children;
                var fNode = this.nameTable[this.selectionList[0].children[0]];
                var history = [];
                var fNodeBounds = ej.datavisualization.Diagram.Util.bounds(fNode);
                this._isSizingCommand = true;
                for (var i = 0; i < list.length; i++) {
                    var element = this.nameTable[list[i]];
                    if (!(element.segments)) {
                        //if ((element._shape === "path") && ((element.height !== fNodeBounds.height)))
                        //    element._scaled = true;
                        history.push({ object: element, values: { width: element.width || element._width || 0, height: element.height || element._height || 0 } });
                        this.updateNode(element.name, { height: fNodeBounds.height });
                    }
                }
                delete this._isSizingCommand;
                this.addHistoryEntry({ type: "sizeCommand", category: "internal", object: this.selectionList[0], values: history });
                ej.datavisualization.Diagram.Util._updateGroupBounds(this.selectionList[0], this);
                ej.datavisualization.Diagram.SvgContext.updateSelector(this.selectionList[0], this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
            }
        },
        sameWidth: function () {
            if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup" && this.selectionList[0].children && this.selectionList[0].children.length > 0) {
                var list = this.nameTable[this.selectionList[0].name].children;
                var fNode = this.nameTable[this.selectionList[0].children[0]];
                var fNodeBounds = ej.datavisualization.Diagram.Util.bounds(fNode);
                var history = [];
                this._isSizingCommand = true;
                for (var i = 0; i < list.length; i++) {
                    var element = this.nameTable[list[i]];
                    if (!(element.segments)) {
                        //if ((element._shape === "path") && (element.width !== fNodeBounds.width))
                        //    element._scaled = true;
                        history.push({ object: element, values: { width: element.width || element._width || 0, height: element.height || element._height || 0 } });
                        this.updateNode(element.name, { width: fNodeBounds.width });
                    }
                }
                delete this._isSizingCommand;
                this.addHistoryEntry({ type: "sizeCommand", category: "internal", object: this.selectionList[0], values: history });
                ej.datavisualization.Diagram.Util._updateGroupBounds(this.selectionList[0], this);
                ej.datavisualization.Diagram.SvgContext.updateSelector(this.selectionList[0], this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
            }
        },
        spaceDown: function () {
            if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup") {
                var lstSelections = this.selectionList[0].children;
                this._sliceDockLines(lstSelections);
                this._sortByYvalue(this.selectionList[0].children);
                var selectionCount = lstSelections.length, fSpacing;
                var history = [];
                if (lstSelections && selectionCount > 2) {
                    var cornerNodes = this._findCornerNodes();
                    var firstNode = cornerNodes.top;
                    var dHei = 0;
                    var pre = null, nxt = null;
                    for (var i in lstSelections) {
                        var pre = null, nxt = null;
                        pre = this.nameTable[this._getChild(lstSelections[i])];
                        nxt = this.nameTable[this._getChild(lstSelections[Number(i) + 1])];
                        if (pre && nxt) {
                            var preBounds = ej.datavisualization.Diagram.Util.bounds(pre);
                            var nxtBounds = ej.datavisualization.Diagram.Util.bounds(nxt);
                            dHei += nxtBounds.y - (preBounds.y + preBounds.height);
                        }
                    }
                    var space = dHei / (selectionCount - 1);
                    for (var i in lstSelections) {
                        pre = this.nameTable[this._getChild(lstSelections[i])];
                        nxt = this.nameTable[this._getChild(lstSelections[Number(i) + 1])];
                        if (pre && nxt) {
                            var preBounds = ej.datavisualization.Diagram.Util.bounds(pre);
                            var nxtBounds = ej.datavisualization.Diagram.Util.bounds(nxt);
                            this._comparePropertyOnAlign(nxt, 0, (preBounds.bottom - (nxtBounds.top)) + space);
                            this._translate(nxt, 0, (preBounds.bottom - (nxtBounds.top)) + space, this.nameTable);
                            history.push({ object: nxt, delta: { x: 0, y: (preBounds.bottom - (nxtBounds.top)) + space } });
                            this._updateQuad(this, nxt);
                            this._updateNodeMargin(nxt);
                            ej.datavisualization.Diagram.DiagramContext.update(nxt, this);
                        }
                    }
                    this.addHistoryEntry({ type: "spacingCommand", values: history, category: "internal", object: this.selectionList[0] });
                }
            }
        },
        spaceAcross: function () {
            if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup") {
                var lstSelections = this.selectionList[0].children;
                this._sliceDockLines(lstSelections);
                this._sortByXvalue(this.selectionList[0].children);
                var selectionCount = lstSelections.length, fSpacing;
                var history = [];
                if (lstSelections && selectionCount > 2) {
                    var cornerNodes = this._findCornerNodes();
                    var firstNode = cornerNodes.left;
                    var dWid = 0;
                    var pre = null, nxt = null;
                    for (var i in lstSelections) {

                        var pre = null, nxt = null;
                        pre = this.nameTable[this._getChild(lstSelections[i])];
                        nxt = this.nameTable[this._getChild(lstSelections[Number(i) + 1])];
                        if (pre && nxt) {
                            var preBounds = ej.datavisualization.Diagram.Util.bounds(pre);
                            var nxtBounds = ej.datavisualization.Diagram.Util.bounds(nxt);
                            dWid += nxtBounds.x - (preBounds.x + preBounds.width);
                        }
                    }
                    var space = dWid / (selectionCount - 1);
                    var sdx = 0;
                    for (var i in lstSelections) {
                        pre = this.nameTable[this._getChild(lstSelections[i])];
                        nxt = this.nameTable[this._getChild(lstSelections[Number(i) + 1])];
                        if (pre && nxt) {
                            var preBounds = ej.datavisualization.Diagram.Util.bounds(pre);
                            var nxtBounds = ej.datavisualization.Diagram.Util.bounds(nxt);
                            this._comparePropertyOnAlign(nxt, (preBounds.right - (nxtBounds.left)) + space, 0);
                            this._translate(nxt, (preBounds.right - (nxtBounds.left)) + space, 0, this.nameTable);
                            history.push({ object: nxt, delta: { x: (preBounds.right - (nxtBounds.left)) + space, y: 0 } });
                            this._updateQuad(this, nxt);
                            this._updateNodeMargin(nxt);
                            ej.datavisualization.Diagram.DiagramContext.update(nxt, this);
                        }
                    }
                    this.addHistoryEntry({ type: "spacingCommand", values: history, category: "internal", object: this.selectionList[0] });
                }
            }
        },
        sendBackward: function () {
            var ovarLapNodes, i;
            var prevNode;
            if (this.selectionList[0] && this.selectionList[0].type != "pseudoGroup") {
                var node = this.selectionList[0];
                if (node) {
                    ovarLapNodes = this._findOverlapNode(node);
                    this._sortByZIndex(ovarLapNodes);
                    for (var k = 0; k < ovarLapNodes.length; k++)
                        if (node.zOrder > ovarLapNodes[k].zOrder) {
                            prevNode = ovarLapNodes[k];
                            break;
                        }
                    var start = node.zOrder;
                    if (prevNode) {
                        var end = prevNode.zOrder;
                        this._comparePropertyValues(node, "zOrder", { zOrder: end }, null, ej.datavisualization.Diagram.ActionType.Order);
                        this._sendElementsToBack(start, end, node, prevNode);
                        this.addHistoryEntry({ type: "zOrder", command: "back", start: end, end: start, nearestNode: prevNode, object: node, category: "internal" });
                    }
                }
            }
        },
        _sendElementsToBack: function (start, end, node, prevNode) {
            var i;
            for (i = end; i < start; i++) {
                if (node.parent != "")
                    this._findObjectByIndex(i, true).zOrder += 1;
                else
                    this._findObjectByIndex(i).zOrder += 1;
            }
            for (var i in this.nodes()) {
                if (this.nodes()[i]._isProcessed) delete this.nodes()[i]._isProcessed;
            }
            for (var i in this.connectors()) {
                if (this.connectors()[i]._isProcessed) delete this.connectors()[i]._isProcessed;
            }
            if (node.parent != "") {
                if (node.parent) {
                    var parent = this.nameTable[node.parent];
                    this._findChildren(parent, node.name).zOrder = end;
                }
            } else
                this._findObjectByName(node.name).zOrder = end;
            var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var textElement = $(htmlLayer).find("#" + node.name)[0];
            var htmlElement = $(htmlLayer).find("#" + node.name + "_parentdiv")[0];
            var element = $(htmlLayer).find("#" + prevNode.name + "_parentdiv")[0];
            if (!element)
                element = $(htmlLayer).find("#" + prevNode.name)[0];
            if (element && htmlElement)
                element.parentNode.insertBefore(htmlElement, element);
            if (element && textElement)
                element.parentNode.insertBefore(textElement, element);
            this._svg.getElementById(prevNode.name).parentNode.insertBefore(this._svg.getElementById(node.name), this._svg.getElementById(prevNode.name));
            this._updateSelectionHandle();
        },
        _bringElementsToFront: function (start, end, node, prevNode) {
            var i;
            for (i = end; i > start; i--) {
                if (node.parent != "") {
                    var obj = this._findObjectByIndex(i, true)
                    if (obj)
                        obj.zOrder -= 1;
                }
                else {
                    obj = this._findObjectByIndex(i);
                    if (obj)
                        obj.zOrder -= 1;
                }
            }
            for (var i in this.nodes()) {
                if (this.nodes()[i]._isProcessed) delete this.nodes()[i]._isProcessed;
            }
            for (var i in this.connectors()) {
                if (this.connectors()[i]._isProcessed) delete this.connectors()[i]._isProcessed;
            }
            if (node.parent) {
                var parent = this.nameTable[node.parent];
                this._findChildren(parent, node.name).zOrder = end;
            } else
                this._findObjectByName(node.name).zOrder = end;
            var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var textElement = $(htmlLayer).find("#" + node.name)[0];
            var textElement1 = $(htmlLayer).find("#" + prevNode.name)[0];
            var htmlElement = $(htmlLayer).find("#" + node.name + "_parentdiv")[0];
            var element = $(htmlLayer).find("#" + prevNode.name + "_parentdiv")[0];
            if (!element)
                element = $(htmlLayer).find("#" + prevNode.name)[0];
            if (textElement1 && htmlElement)
                textElement1.parentNode.insertBefore(htmlElement, textElement1.nextSibling);
            if (htmlElement && textElement)
                htmlElement.parentNode.insertBefore(textElement, htmlElement.nextSibling);
            if (element && htmlElement)
                element.parentNode.insertBefore(htmlElement, element.nextSibling);
            this._svg.getElementById(prevNode.name).parentNode.insertBefore(this._svg.getElementById(node.name), this._svg.getElementById(prevNode.name).nextSibling);
            this._updateSelectionHandle();
        },
        moveForward: function () {
            var ovarLapNodes, i;
            var prevNode;
            if (this.selectionList[0] && this.selectionList[0].type != "pseudoGroup") {
                var node = this.selectionList[0];
                if (node) {
                    ovarLapNodes = this._findOverlapNode(node);
                    this._sortByZIndex(ovarLapNodes);
                    for (var k = ovarLapNodes.length - 1; k >= 0; k--)
                        if (node.zOrder < ovarLapNodes[k].zOrder) {
                            prevNode = ovarLapNodes[k];
                            break;
                        }

                    var start = node.zOrder;
                    if (prevNode) {
                        var end = prevNode.zOrder;
                        this._comparePropertyValues(node, "zOrder", { zOrder: end }, null, ej.datavisualization.Diagram.ActionType.Order);
                        this._bringElementsToFront(start, end, node, prevNode);
                        this.addHistoryEntry({ type: "zOrder", command: "front", start: end, end: start, nearestNode: prevNode, object: node, category: "internal" });
                    }
                }
            }
        },
        sendToBack: function () {
            var node = this.selectionList[0];
            var prevNode;
            if (node && node.type != "pseudoGroup") {
                var ovarLapNodes = this._findOverlapNode(node);
                var nodes = this._sortByZIndex(ovarLapNodes);
                var start = node.zOrder;
                var end = node.zOrder;
                var firstNode;
                for (var i = 0; i < nodes.length; i++) {
                    if (nodes[i].zOrder < end) {
                        if (i == 0) firstNode = nodes[i];
                        end = nodes[i].zOrder;
                        prevNode = nodes[i];
                    }
                }
                if (prevNode) {
                    this._comparePropertyValues(node, "zOrder", { zOrder: end }, null, ej.datavisualization.Diagram.ActionType.Order);
                    this._sendElementsToBack(start, end, node, prevNode);
                    this.addHistoryEntry({ type: "zOrder", command: "back", start: end, end: start, nearestNode: firstNode, object: node, category: "internal" });
                }
            }
        },
        bringToFront: function () {
            var node = this.selectionList[0];
            var prevNode;
            if (node && node.type != "pseudoGroup") {
                var ovarLapNodes = this._findOverlapNode(node);
                var nodes = this._sortByZIndex(ovarLapNodes);
                var start = node.zOrder;
                var end = node.zOrder;
                for (var i = 0; i < nodes.length; i++) {
                    if (nodes[i].zOrder > end) {
                        end = nodes[i].zOrder;
                        prevNode = nodes[i];
                    }
                }
                if (prevNode) {
                    this._comparePropertyValues(node, "zOrder", { zOrder: end }, null, ej.datavisualization.Diagram.ActionType.Order);
                    this._bringElementsToFront(start, end, node, prevNode);
                    this.addHistoryEntry({ type: "zOrder", command: "front", start: end, end: start, nearestNode: nodes[i - 1], object: node, category: "internal" });
                }
            }
        },
        _getChildFromCollection: function (collection, name) {
            if (collection && collection.length > 0 && name) {
                for (var i = 0; i < collection.length; i++) {
                    if (collection[i].name === name)
                        return collection[i];
                }
            }
        },

        _updateNameTable: function (node) {
            if (node.children && node.children.length > 0) {
                for (var i = 0; i < node.children.length; i++) {
                    var child = typeof node.children[i] == "object" ? node.children[i] : null;
                    if (child) {
                        this.nameTable[child.name] = child;
                        if (child.children && child.children.length > 0)
                            this._updateNameTable(child);
                    }
                }
            }
        },
        _recordPageSettingsChanged: function (args) {
            var value = args.redoObject;
            if (args.isUndo)
                value = args.undoObject;
            if (value)
                this.updatePageSettings(value);
        },
        _recordMultiRotationChanged: function (args) {
            ej.datavisualization.Diagram.canvasHelper._undoMultiRotateNode(this, args);
        },
        _recordMultiPinPointChanged: function (args) {
            ej.datavisualization.Diagram.canvasHelper._undoMultiDragNode(this, args);
        },
        _recordMultiSizeChanged: function (args) {
            ej.datavisualization.Diagram.canvasHelper._undoMultiResizeNode(this, args);
        },
        undo: function () {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this)) && ej.datavisualization.Diagram.Util.canUndo(this)) {
                var args;
                this._getHistoryList();
                this._isUndo = true;
                var entryItem = this.getUndoEntry();
                if (entryItem) {
                    if (entryItem.type == "closeGroup") {
                        this._groupUndo = true;
                    }
                    else this._undo(entryItem);
                    if (this._groupUndo) {
                        entryItem = this.getUndoEntry();
                        while (entryItem && entryItem.type != "startGroup") {
                            this._undo(entryItem);
                            entryItem = this.getUndoEntry();
                        }
                        delete this._groupUndo;
                    }
                }
                this._isUndo = false;
            }
        },
        redo: function () {
            this._isUndo = true;
            //this.historyManager.redo();
            var entryItem = this.getRedoEntry();
            if (entryItem) {
                if (entryItem.type == "startGroup") {
                    this._groupRedo = true;
                }
                else this._redo(entryItem);
                if (this._groupRedo) {
                    entryItem = this.getRedoEntry();
                    while (entryItem && entryItem.type != "closeGroup") {
                        this._isUndo = true;
                        this._redo(entryItem);
                        entryItem = this.getRedoEntry();
                    }
                    delete this._groupRedo;
                }
            }
            this._isUndo = false;
        },


        _ComparehistoryChangeEvent: function (object, entryItem) {
            var item, i, objNode, argument;
            var changes = { source: [], changes: [] };
            switch (entryItem.type) {
                case "positionchanged":
                case "rotationchanged":
                case "sizechanged":
                    changes = this._getPseudoGroupElements(object, entryItem);
                    break;
                case "endpointchanged":
                    var args;
                    if (this._UndoRedo) {
                        args = this._historyChangeEvent(entryItem.undoObject, entryItem.redoObject, entryItem);
                        argument = { type: entryItem.type, oldValues: args.oldValues, newValues: args.newValues, cancel: false };
                        changes.source.push(entryItem.undoObject);
                    }
                    else {
                        args = this._historyChangeEvent(entryItem.redoObject, entryItem.undoObject, entryItem);
                        argument = { type: entryItem.type, oldValues: args.oldValues, newValues: args.newValues, cancel: false };
                        changes.source.push(entryItem.redoObject);
                    }
                    changes.changes.push(argument);
                    break;
                case "collectionchanged":
                    if (entryItem.changeType == "remove")
                        argument = { type: entryItem.type, addedItems: [], deletedItems: [object] };
                    if (entryItem.changeType == "insert")
                        argument = { type: entryItem.type, addedItems: [object], deletedItems: [] };
                    changes.changes.push(argument);
                    changes.source.push(object);
                    break;
                case "labelchanged":
                    if (this._UndoRedo)
                        argument = { type: entryItem.type, newValues: { text: entryItem.previousLabelValue }, oldValues: { text: entryItem.updatedLabelValue } };
                    else
                        argument = { type: entryItem.type, newValues: { text: entryItem.updatedLabelValue }, oldValues: { text: entryItem.previousLabelValue } };
                    changes.changes.push(argument);
                    changes.source.push(entryItem.shape);
                    break;
                case "labelcollectionchanged":
                    argument = { type: entryItem.type, source: entryItem.shape, addedItems: [entryItem.label], deletedItems: [] };
                    changes.changes.push(argument);
                    changes.source.push(entryItem.shape);
                case "groupchanged":
                    if (entryItem.actionType == "group")
                        argument = { type: entryItem.type, source: entryItem.object, addedItems: [entryItem.object], deletedItems: [] };
                    else
                        argument = { type: entryItem.type, source: entryItem.object, addedItems: [], deletedItems: [entryItem.object] }
                    changes.changes.push(argument);
                    changes.source.push(entryItem.object);
                    break;
                case "phasepositionchanged":
                    if (this._UndoRedo) {
                        argument = { type: entryItem.type, newValues: { offset: entryItem.undoObject.offset }, oldValues: { offset: entryItem.redoObject.offset } };
                        changes.source.push(entryItem.undoObject);
                    }
                    else {
                        argument = { type: entryItem.type, newValues: { offset: entryItem.redoObject.offset }, oldValues: { offset: entryItem.undoObject.offset } };
                        changes.source.push(entryItem.redoObject);
                    }
                    changes.changes.push(argument);
                    break;
                case "phasecollectionchanged":
                    if (entryItem.isAdded)
                        argument = { type: entryItem.type, addedItems: [entryItem.phase], deletedItems: [] };
                    else
                        argument = { type: entryItem.type, addedItems: [], deletedItems: [entryItem.phase] };
                    changes.source.push(entryItem.phase);
                    changes.changes.push(argument);
                    break;
                case "propertiesChanged":
                    argument = this._propertyChangeEventValues(entryItem);
                    changes.source.push(argument.source);
                    changes.changes.push(argument.changes);
                    break;
                case "portscollectionchanged":
                    if (entryItem.changeType == "insert")
                        argument = { type: entryItem.type, addedItems: [entryItem.collection], deletedItems: [] };
                    if (entryItem.changeType == "remove")
                        argument = { type: entryItem.type, addedItems: [], deletedItems: [entryItem.collection] };
                    changes.source.push(entryItem.object);
                    changes.changes.push(argument);
                    break;
                case "nudge":
                    var newValues = {}, oldValues = {};
                    if (this._UndoRedo) {
                        if (entryItem.undoDirection == "left") {
                            newValues.offsetX = entryItem.object.offsetX - entryItem.values;
                            oldValues.offsetX = entryItem.object.offsetX;
                        }
                        if (entryItem.undoDirection == "right") {
                            newValues.offsetX = entryItem.object.offsetX + entryItem.values;
                            oldValues.offsetX = entryItem.object.offsetX;
                        }
                        if (entryItem.undoDirection == "up") {
                            newValues.offsetY = entryItem.object.offsetY - entryItem.values;
                            oldValues.offsetY = entryItem.object.offsetY;
                        }
                        if (entryItem.undoDirection == "down") {
                            newValues.offsetY = entryItem.object.offsetY + entryItem.values;
                            oldValues.offsetY = entryItem.object.offsetY;
                        }
                        argument = { type: entryItem.type, newValues: newValues, oldValues: oldValues };
                    }
                    else {
                        if (entryItem.redoDirection == "left") {
                            newValues.offsetX = entryItem.object.offsetX - entryItem.values;
                            oldValues.offsetX = entryItem.object.offsetX;
                        }
                        if (entryItem.redoDirection == "right") {
                            newValues.offsetX = entryItem.object.offsetX + entryItem.values;
                            oldValues.offsetX = entryItem.object.offsetX;
                        }
                        if (entryItem.redoDirection == "up") {
                            newValues.offsetY = entryItem.object.offsetY - entryItem.values;
                            oldValues.offsetY = entryItem.object.offsetY;
                        }
                        if (entryItem.redoDirection == "down") {
                            newValues.offsetY = entryItem.object.offsetY + entryItem.values;
                            oldValues.offsetY = entryItem.object.offsetY;
                        }
                        argument = { type: entryItem.type, newValues: newValues, oldValues: oldValues };
                    }
                    changes.source.push(entryItem.object);
                    changes.changes.push(argument);
                    break;
                case "spacingCommand":
                case "alignCommand":
                    var newValues = {}, oldValues = {}, newVal = [], oldVal = [];
                    for (var i = 0; i < entryItem.values.length; i++) {
                        var node = entryItem.values[i];
                        if (!node.object.segments) {
                            newValues = { offsetX: node.object.offsetX - node.delta.x, offsetY: node.object.offsetY - node.delta.y };
                            newVal.push(newValues);
                            oldValues = { offsetX: node.object.offsetX, offsetY: node.object.offsetY };
                            oldVal.push(oldValues);
                        }
                        else {
                            var connector = $.extend(true, {}, node.object);
                            oldValues = { sourcePoint: connector.sourcePoint, targetPoint: connector.targetPoint };
                            oldVal.push(oldValues);
                            ej.datavisualization.Diagram.Util._translateLine(connector, node.delta.x, node.delta.y);
                            newValues = { sourcePoint: connector.sourcePoint, targetPoint: connector.targetPoint };
                            newVal.push(newValues);
                        }
                    }
                    argument = { type: entryItem.type, newValues: newVal, oldValues: oldVal };
                    changes.source.push(entryItem.object);
                    changes.changes.push(argument);
                    break;
                case "sizeCommand":
                    var newValues = {}, oldValues = {}, newVal = [], oldVal = [];
                    for (var i = 0; i < entryItem.values.length; i++) {
                        var node = entryItem.values[i];
                        newValues = { width: node.values.width, height: node.values.height };
                        newVal.push(newValues);
                        oldValues = { width: node.object.width, height: node.object.height };
                        oldVal.push(oldValues);
                    }
                    argument = { type: entryItem.type, newValues: newVal, oldValues: oldVal };
                    changes.source.push(entryItem.object);
                    changes.changes.push(argument);
                    break;
                case "zOrder":
                    argument = { type: entryItem.type, source: entryItem.object, newValues: { zOrder: entryItem.end }, oldValues: { zOrder: entryItem.object.zOrder } };
                    changes.source.push(entryItem.object);
                    changes.changes.push(argument);
                    break;
            }
            return changes;
        },

        _getPseudoGroupElements: function (object, entryItem) {
            var item, i, objNode, argument;
            var changes;
            var originalObject = this._UndoRedo ? this.nameTable[entryItem.undoObject.node.name] : entryItem.redoObject.node;
            argument = { source: [], changes: [] };
            if (object && object.type == "pseudoGroup") {
                var children = this._getChildren(object.children);
                for (i = 0; i < children.length; i++) {
                    item = this.nameTable[children[i]];
                    var objNode = this._UndoRedo ? entryItem.undoObject.childTable[children[i]] : entryItem.redoObject.childTable[children[i]];
                    changes = this._historyChangeEvent(objNode, item, entryItem);
                    if (changes.source)
                        argument.source.push(changes.source);
                    if (changes.changes)
                        argument.changes.push(changes.changes);
                }
            }
            else {
                if (this._UndoRedo) {
                    changes = this._historyChangeEvent(object, originalObject, entryItem);
                }
                else {
                    changes = this._historyChangeEvent(originalObject, object, entryItem);
                }
                if (changes.source)
                    argument.source.push(changes.source);
                if (changes.changes)
                    argument.changes.push(changes.changes);
            }
            return argument;
        },

        _propertyChangeEventValues: function (entryItem) {
            var args;
            var changes = [];
            if (entryItem.elementType == "label") {
                var node = entryItem.label;
            }
            else if (entryItem.elementType == "port") {
                var node = entryItem.port;
            }
            else {
                var node = entryItem.object;
            }
            var oldValues = {}, newValues = {};
            for (var property in entryItem.values) {
                if (node[property] != entryItem.values[property]) {
                    oldValues[property] = node[property];
                    newValues[property] = entryItem.values[property];
                }
            }
            args = { type: entryItem.type, newValues: newValues, oldValues: oldValues, deletedItems: [], addedItems: [] };
            changes.push(args);
            return { changes: changes, source: node };
        },

        _historyChangeEvent: function (object, originalObject, entryItem) {
            var args = { type: entryItem.type, deletedItems: [], addedItems: [], oldValues: {}, newValues: {} };
            if (object.offsetX != originalObject.offsetX) {
                args.oldValues.offsetX = originalObject.offsetX;
                args.newValues.offsetX = object.offsetX;
            }
            if (object.offsetY != originalObject.offsetY) {
                args.oldValues.offsetY = originalObject.offsetY;
                args.newValues.offsetY = object.offsetY;
            }
            if (object.width != originalObject.width) {
                args.oldValues.width = originalObject.width;
                args.newValues.width = object.width;
            }
            if (object.height != originalObject.height) {
                args.oldValues.height = originalObject.height;
                args.newValues.height = object.height;
            }
            if (object.rotateAngle != originalObject.rotateAngle) {
                args.oldValues.rotateAngle = originalObject.rotateAngle;
                args.newValues.rotateAngle = object.rotateAngle;
            }
            if (object.sourcePoint != originalObject.sourcePoint) {
                args.oldValues.sourcePoint = originalObject.sourcePoint;
                args.newValues.sourcePoint = object.sourcePoint;
            }
            if (object.targetPoint != originalObject.targetPoint) {
                args.oldValues.targetPoint = originalObject.targetPoint;
                args.newValues.targetPoint = object.targetPoint;
            }
            return { changes: args, source: originalObject };
        },

        _undo: function (entryItem) {
            var argument = [];
            this._UndoRedo = true;

            if (entryItem) {
                if (entryItem.category == "internal") {
                    var object = entryItem.object || (entryItem.undoObject ? entryItem.undoObject.node || entryItem.undoObject : undefined) || entryItem.shape;
                    if (!object && entryItem.phase) object = entryItem.phase;
                    if (object && entryItem.undoObject && entryItem.undoObject.node)
                        object = this.nameTable[object.name] || object;
                    if (!object) {
                        this.undo();
                        return;
                    }
                    if (this.model.historyManager.undoStack.length > 0) {
                        var addObject = this.model.historyManager.undoStack.splice(0, 1);
                        this.model.historyManager.redoStack.splice(0, 0, addObject[0]);
                    }
                    argument = this._ComparehistoryChangeEvent(object, entryItem);
                    argument.cause = ej.datavisualization.Diagram.HistoryChangeCause.Undo;
                    this._raiseEvent("historyChange", argument);
                    if (object && object.parent)
                        var parent = typeof object.parent == "object" ? object.parent.name : object.parent;
                    if (parent && !object.isLane) {
                        if (!this.nameTable[parent]) {
                            this._isUndo = false;
                            this.undo();
                            return;
                        }
                    }
                    var args;
                    switch (entryItem.type) {
                        case "pagesettingschanged":
                            var entry = { isUndo: true, undoObject: entryItem.undoObject, redoObject: entryItem.redoObject }
                            this._recordPageSettingsChanged(entry);
                            break;
                            break;
                        case "positionchanged":
                            if (entryItem.swimlaneMultiSelection) {
                                entryItem.undo = true;
                                this._recordMultiPinPointChanged(entryItem);
                            }
                            else {
                                args = { object: entryItem.undoObject, isMultipleNode: entryItem.isMultipleNode };
                                this._recordPinPointChanged(args);
                            }
                            break;
                        case "rotationchanged":
                            if (entryItem.swimlaneMultiSelection) {
                                entryItem.undo = true;
                                this._recordMultiRotationChanged(entryItem);
                            }
                            else {
                                args = { object: entryItem.undoObject, isMultipleNode: entryItem.isMultipleNode };
                                this._recordRotationChanged(args);
                            }
                            break;
                        case "sizechanged":
                            entryItem.undo = true;
                            if (entryItem.swimlaneMultiSelection) {
                                this._recordMultiSizeChanged(entryItem);
                            }
                            else {
                                args = { object: entryItem.undoObject, isMultipleNode: entryItem.isMultipleNode };
                                this._recordSizeChanged(args, entryItem);
                            }
                            break;
                        case "endpointchanged":
                            args = { undoObject: entryItem.undoObject, redoObject: entryItem.redoObject, isMultipleNode: entryItem.isMultipleNode, _isUndo: true };
                            this._recordEndPointChanged(args);
                            break;
                        case "collectionchanged":
                            if (entryItem.changeType == "insert") {
                                if (!this.nameTable[entryItem.object.name]) {
                                    if (this._groupUndo) return;
                                    this._isUndo = false;
                                    this.undo();
                                }
                            }
                            args = { changeType: entryItem.changeType, childTable: entryItem.childTable, edgeTable: entryItem.edgeTable, isUndo: true, sourcePorts: entryItem.sourcePorts, targetPorts: entryItem.targetPorts, index: entryItem.index };
                            args.object = jQuery.extend(true, {}, entryItem.object);
                            var update = this._recordCollectionChanged(args, entryItem);
                            if (update) {
                                entryItem.sourcePorts = args.sourcePorts;
                                entryItem.targetPorts = args.targetPorts;
                                entryItem.edgeTable = args.edgeTable;
                                entryItem.childTable = args.childTable;
                            }
                            break;
                        case "labelchanged":
                            args = { object: entryItem.shape, label: entryItem.previousLabelValue, index: entryItem.index ? entryItem.index : 0 };
                            this._recordLabelChanged(args);
                            break;
                        case "labelcollectionchanged":
                            entryItem.isUndo = true;
                            this.labelcollectionchanged(entryItem);
                            break;
                        case "groupchanged":
                            args = { object: entryItem.object, isUndo: true, actionType: entryItem.actionType };
                            this._recordGroupChanged(args);
                            break;
                        case "phasepositionchanged":
                            entryItem.undo = true;
                            this._recordPhasesizeChanged(entryItem);
                            break;
                        case "phasecollectionchanged":
                            entryItem = $.extend(true, {}, { phase: entryItem.phase, group: entryItem.group, isAdded: entryItem.isAdded, phaseObject: entryItem.phaseObject, islastPhase: entryItem.islastPhase, });
                            entryItem.undo = true;
                            this._recordPhaseCollectionChanged(entryItem);
                            break;
                        case "propertiesChanged":
                            var node = this.nameTable[entryItem.object.name];
                            if (node) {
                                var currentState = this._getModifiedProperties(node, entryItem.values, entryItem[entryItem.elementType]);
                                if (entryItem.elementType == "node")
                                    this.updateNode(node.name, entryItem.values);
                                else if (entryItem.elementType == "connector")
                                    this.updateConnector(node.name, entryItem.values);
                                else if (entryItem.elementType == "label")
                                    entryItem.label = this.updateLabel(node.name, entryItem.label, entryItem.values);
                                else if (entryItem.elementType == "port")
                                    this.updatePort(node.name, entryItem.port, entryItem.values);
                                entryItem.values = currentState;
                            }
                            break;
                        case "portscollectionchanged":
                            entryItem.isUndo = true;
                            this._recordPortsCollectionChanged(entryItem);
                            break;
                        case "nudge":
                            this._recordNudgingChanges(object, entryItem);
                            break;
                        case "spacingCommand":
                        case "alignCommand":
                            this._recordAlignCommandChanges(entryItem);
                            break;
                        case "sizeCommand":
                            this._recordSizeCommandChanges(entryItem);
                            break;
                        case "swapLane":
                            entryItem = jQuery.extend(true, {}, { undoObject: entryItem.undoObject, redoObject: entryItem.redoObject, moveIndex: entryItem.moveIndex, insertIndex: entryItem.currentIndex });
                            entryItem.undo = true;
                            ej.datavisualization.Diagram.canvasHelper._undoSwap(this, entryItem);
                            break;
                        case "zOrder":
                            var end = entryItem.start;
                            var node = this.nameTable[entryItem.object.name];
                            this._comparePropertyValues(node, "zOrder", { zOrder: entryItem.end });
                            if (entryItem.command == "back") {
                                this._bringElementsToFront(entryItem.start, entryItem.end, entryItem.object, entryItem.nearestNode);
                                entryItem.command = "front";
                            }
                            else {
                                this._sendElementsToBack(entryItem.start, entryItem.end, entryItem.object, entryItem.nearestNode);
                                entryItem.command = "back";
                            }
                            entryItem.nearestNode = this._findObjectByIndex(end);
                            var temp = entryItem.start;
                            entryItem.start = entryItem.end;
                            entryItem.end = temp;
                            break;
                    }
                    if (this.selectionList.length && object && this.selectionList[0].name != object.name) {
                        this._clearSelection(true);
                        this._addSelection(this.nameTable[object.name], true);
                    }
                } else {
                    if (this.model.historyManager.undo) {
                        var undo = this.model.historyManager.undo;
                        if (typeof undo == "string") undo = ej.util.getObject(undo, window);
                        if ($.isFunction(undo)) {
                            var data = undo(entryItem.data);
                            if (data) entryItem.data = data;
                        }
                    }
                }
            }
        },

        _redo: function (entryItem) {
            var argument = [];
            this._UndoRedo = false;
            if (entryItem) {
                if (entryItem.category == "internal") {
                    var object = entryItem.object || (entryItem.undoObject ? entryItem.undoObject.node || entryItem.undoObject : undefined) || entryItem.shape;
                    if (!object && entryItem.phase) object = entryItem.phase;
                    if (object && entryItem.undoObject && entryItem.undoObject.node)
                        object = this.nameTable[object.name] || object;
                    if (!object) {
                        this.redo();
                        return;
                    }

                    if (this.model.historyManager.redoStack.length > 0) {
                        var addObject = this.model.historyManager.redoStack.splice(0, 1);
                        this.model.historyManager.undoStack.splice(0, 0, addObject[0]);
                    }
                    argument = this._ComparehistoryChangeEvent(object, entryItem);
                    argument.cause = ej.datavisualization.Diagram.HistoryChangeCause.Redo;
                    this._raiseEvent("historyChange", argument);
                    if (object && object.parent)
                        var parent = typeof object.parent == "object" ? object.parent.name : object.parent;
                    if (parent) {
                        if (!this.nameTable[parent]) {
                            this._isUndo = false;
                            this.redo();
                            return;
                        }
                    }
                    var args;
                    switch (entryItem.type) {
                        case "pagesettingschanged":
                            var entry = { isUndo: false, undoObject: entryItem.undoObject, redoObject: entryItem.redoObject }
                            this._recordPageSettingsChanged(entry);
                            break;
                        case "positionchanged":
                            if (entryItem.swimlaneMultiSelection) {
                                entryItem.undo = false;
                                this._recordMultiPinPointChanged(entryItem);
                            }
                            else {
                                var args = { object: entryItem.redoObject, isMultipleNode: entryItem.isMultipleNode };
                                this._recordPinPointChanged(args);
                            }
                            break;
                        case "rotationchanged":
                            if (entryItem.swimlaneMultiSelection) {
                                entryItem.undo = false;
                                this._recordMultiRotationChanged(entryItem);
                            }
                            else {
                                args = { object: entryItem.redoObject, isMultipleNode: entryItem.isMultipleNode };
                                this._recordRotationChanged(args);
                            }
                            break;
                        case "sizechanged":
                            entryItem.undo = false;
                            if (entryItem.swimlaneMultiSelection) {
                                this._recordMultiSizeChanged(entryItem);
                            }
                            else {
                                args = { object: entryItem.redoObject, isMultipleNode: entryItem.isMultipleNode };
                                this._recordSizeChanged(args);
                            }
                            break;
                        case "endpointchanged":
                            args = { undoObject: entryItem.undoObject, redoObject: entryItem.redoObject, isMultipleNode: entryItem.isMultipleNode, _isUndo: false };
                            this._recordEndPointChanged(args);
                            break;
                        case "collectionchanged":
                            args = {
                                changeType: entryItem.changeType, childTable: entryItem.childTable, edgeTable: entryItem.edgeTable,
                                isUndo: false, sourcePorts: entryItem.sourcePorts, targetPorts: entryItem.targetPorts, index: entryItem.index
                            };
                            args.object = jQuery.extend(true, {}, entryItem.object);
                            this._recordCollectionChanged(args, entryItem.object);
                            break;
                        case "labelchanged":
                            args = { object: entryItem.shape, label: entryItem.updatedLabelValue, index: entryItem.index ? entryItem.index : 0 };
                            this._recordLabelChanged(args);
                            break;
                        case "labelcollectionchanged":
                            entryItem.isUndo = false;
                            this.labelcollectionchanged(entryItem);
                            break;
                        case "groupchanged":
                            args = { object: entryItem.object, actionType: entryItem.actionType, isUndo: false };
                            this._recordGroupChanged(args);
                            break;
                        case "phasepositionchanged":
                            entryItem.undo = false;
                            this._recordPhasesizeChanged(entryItem);
                            break;
                        case "phasecollectionchanged":
                            entryItem = $.extend(true, {}, { phase: entryItem.phase, group: entryItem.group, phaseObject: entryItem.phaseObject, islastPhase: entryItem.islastPhase, isAdded: entryItem.isAdded });
                            entryItem.undo = false;
                            this._recordPhaseCollectionChanged(entryItem);
                            break;
                        case "propertiesChanged":
                            var node = this.nameTable[entryItem.object.name];
                            if (node) {
                                var currentState = this._getModifiedProperties(node, entryItem.values, entryItem[entryItem.elementType]);
                                if (entryItem.elementType == "node")
                                    this.updateNode(node.name, entryItem.values);
                                else if (entryItem.elementType == "connector")
                                    this.updateConnector(node.name, entryItem.values);
                                else if (entryItem.elementType == "label")
                                    entryItem.label = this.updateLabel(node.name, entryItem.label, entryItem.values);
                                else if (entryItem.elementType == "port")
                                    this.updatePort(node.name, entryItem.port, entryItem.values);
                                entryItem.values = currentState;
                            }
                            break;
                        case "portscollectionchanged":
                            entryItem.isUndo = false;
                            this._recordPortsCollectionChanged(entryItem);
                            break;
                        case "nudge":
                            this._recordNudgingChanges(object, entryItem, true);
                            break;
                        case "spacingCommand":
                        case "alignCommand":
                            this._recordAlignCommandChanges(entryItem);
                            break;
                        case "sizeCommand":
                            this._recordSizeCommandChanges(entryItem);
                            break;
                        case "swapLane":
                            entryItem = jQuery.extend(true, {}, { undoObject: entryItem.undoObject, redoObject: entryItem.redoObject, moveIndex: entryItem.moveIndex, insertIndex: entryItem.currentIndex });
                            entryItem.undo = false;
                            ej.datavisualization.Diagram.canvasHelper._undoSwap(this, entryItem);
                            break;
                        case "zOrder":
                            var end = entryItem.start;
                            var node = this.nameTable[entryItem.object.name];
                            this._comparePropertyValues(node, "zOrder", { zOrder: entryItem.end });
                            if (entryItem.command == "back") {
                                this._bringElementsToFront(entryItem.start, entryItem.end, entryItem.object, entryItem.nearestNode);
                                entryItem.command = "front";
                            }
                            else {
                                this._sendElementsToBack(entryItem.start, entryItem.end, entryItem.object, entryItem.nearestNode);
                                entryItem.command = "back";
                            }
                            entryItem.nearestNode = this._findObjectByIndex(end);
                            var temp = entryItem.start;
                            entryItem.start = entryItem.end;
                            entryItem.end = temp;
                            break;
                    }
                    if (this.selectionList.length && object && this.selectionList[0].name != object.name) {
                        this._clearSelection(true);
                        this._addSelection(this.nameTable[object.name], true);
                    }
                } else if (this.model.historyManager.redo) {
                    var redo = this.model.historyManager.redo;
                    if (typeof redo == "string") redo = ej.util.getObject(redo, window);
                    if ($.isFunction(redo)) {
                        var data = redo(entryItem.data);
                        if (data) entryItem.data = data;
                    }
                }
            }
        },
        _startGroupAction: function () {
            this.addHistoryEntry({ type: "startGroup", category: "internal" });
        },
        _closeGroupAction: function () {
            this.addHistoryEntry({ type: "closeGroup", category: "internal" });
        },

        addHistoryEntry: function (entry) {
            var canLog, object, params, args;
            if (!this.model.historyManager.suspend) {
                if (this.model.historyManager.canLog) {
                    canLog = this.model.historyManager.canLog;
                    if (typeof canLog == "string") canLog = ej.util.getObject(canLog, window);
                    if ($.isFunction(canLog)) {
                        object = this.getNode(entry.object || (entry.undoObject && entry.undoObject.node) || entry.shape);
                        params = this._ComparehistoryChangeEvent(object, entry);
                        args = { changes: params.changes.length ? params.changes[0] : null, source: params.source.length ? this.getNode(params.source[0]) : null };
                        if (canLog(args) == false) return;
                    }
                }
                if (entry.category != "internal") {
                    entry = { data: entry };
                }
                if (this._historyList.canUndo) {
                    if (this._historyList.currentEntry && (this._historyList.currentEntry.data || this._historyList.currentEntry.category == "internal")) {
                        var cEntry = this._historyList.currentEntry;
                        if (cEntry.next) {
                            if (cEntry.previous) {
                                var entry1 = cEntry.next;
                                entry1.previous = null;
                                cEntry.next = entry;
                                entry.previous = cEntry;
                            }
                        } else {
                            cEntry.next = entry;
                            entry.previous = cEntry;
                        }
                    }
                }
                this._historyList.currentEntry = entry;
                if (this.model.historyManager.stackLimit) {
                    if (this._historyList.currentEntry && this._historyList.currentEntry.previous && !this._lastbefore) {
                        this._lastbefore = entry;
                    }
                    else if (!this._historyList.currentEntry.previous) {
                        this._lastbefore = null;
                        this._historyCount = 0;
                    }

                    if (this._historyCount < this.model.historyManager.stackLimit)
                        this._historyCount++;
                    else {
                        if (this._lastbefore) {
                            if (this._lastbefore.previous)
                                delete this._lastbefore.previous
                            if (this._lastbefore.next)
                                this._lastbefore = this._lastbefore.next;
                        }
                    }
                }

                var object = entry.object || (entry.redoObject ? entry.redoObject.node || entry.redoObject : undefined) || entry.shape;
                var args = this._ComparehistoryChangeEvent(object, entry);
                args.cause = ej.datavisualization.Diagram.HistoryChangeCause.CustomAction;
                this._getHistoryList();
                this._raiseEvent("historyChange", args);
                this._historyList.canUndo = true;
                this._historyList.canRedo = false;
            }
        },
        removeHistoryEntry: function (entry) {
            if (this._historyList.currentEntry != null) {
                var cEntry = this._historyList.currentEntry;
                //previous and next entries of target entry
                var prev, nxt;
                if (cEntry) {
                    if (cEntry == entry) {
                        prev = cEntry.previous;
                        nxt = cEntry.next;
                        this._historyList.currentEntry = nxt || prev;
                    } else {
                        var nextEntry = cEntry.next;
                        while (nextEntry) {
                            if (nextEntry == entry) {
                                prev = nextEntry.previous;
                                nxt = nextEntry.next;
                                break;
                            } else nextEntry = nextEntry.next;
                        }
                        var prevEntry = cEntry.previous;
                        while (prevEntry) {
                            if (prevEntry == entry) {
                                prev = prevEntry.previous;
                                nxt = prevEntry.next;
                                break;
                            } else prevEntry = prevEntry.previous;
                        }
                    }
                }
                if (prev && nxt) {
                    prev.next = nxt;
                    nxt.previous = prev;
                } else if (prev) {
                    prev.next = null;
                } else if (nxt) {
                    nxt.previous = null;
                }
            }
        },
        canRemoveHistoryEntry: function (entry) {
            return entry.category != "internal";
        },
        clearHistory: function () {
            var hList = this._historyList;
            hList.currentEntry = null;
            hList.canUndo = false;
            hList.canRedo = false;
            this.model.historyManager.undoStack = [];
            this.model.historyManager.redoStack = [];
            //this._hScrollbar._scrollData = null;
            //this._vScrollbar._scrollData = null;
        },

        _getHistroyObject: function (list, object) {
            if (object) {
                list.push({
                    redoObject: object.redoObject ? object.redoObject : null,
                    undoObject: object.undoObject ? object.undoObject : null,
                    type: object.type ? object.type : null,
                    isMultipleNode: object.isMultipleNode ? object.isMultipleNode : null,
                    category: object.category ? object.category : ""
                });
            }
        },

        _getHistoryList: function () {
            var undoStack = [], redoStack = [];
            var currEntry = this._historyList.currentEntry;
            var undoObj, redoObj;


            currEntry = this._historyList.currentEntry;
            if (this._historyList.canUndo || this.model.historyManager.undoStack.length === 0)
                this._getHistroyObject(undoStack, currEntry)
            else
                this._getHistroyObject(redoStack, currEntry)

            while (currEntry && currEntry.previous) {
                undoObj = currEntry.previous;
                this._getHistroyObject(undoStack, undoObj)
                currEntry = currEntry.previous;
            }

            currEntry = this._historyList.currentEntry;
            while (currEntry && currEntry.next) {
                redoObj = currEntry.next;
                this._getHistroyObject(redoStack, redoObj)
                currEntry = currEntry.next;
            }
            this.model.historyManager.undoStack = undoStack;
            this.model.historyManager.redoStack = redoStack;
        },
        getUndoEntry: function () {
            var undoEntry = null;
            var currentEntry;
            var hList = this._historyList;
            if (hList.canUndo) {
                undoEntry = hList.currentEntry;
                currentEntry = hList.currentEntry.previous;
                if (currentEntry) {
                    hList.currentEntry = currentEntry;
                    if (!hList.canRedo)
                        hList.canRedo = true;
                } else {
                    hList.canRedo = true;
                    hList.canUndo = false;
                }
            }
            return undoEntry;
        },
        getRedoEntry: function () {
            var redoEntry = null;
            var entryCurrent;
            var hList = this._historyList;
            if (hList.canRedo) {
                if (!hList.currentEntry.previous && !hList.canUndo) {
                    entryCurrent = hList.currentEntry;
                } else
                    entryCurrent = hList.currentEntry.next;
                if (entryCurrent) {
                    hList.currentEntry = entryCurrent;
                    if (!hList.canUndo)
                        hList.canUndo = true;
                    if (!entryCurrent.next) {
                        hList.canRedo = false;
                        hList.canUndo = true;
                    }
                }
                redoEntry = hList.currentEntry;
            }
            return redoEntry;
        },
        cut: function () {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                this._pasteIndex = 0;
                this._setClipboard();
                this._eventCause["nodeCollectionChange"] = this._eventCause["connectorCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.ClipBoard;
                this._multipleAction = true;
                this._delete();
                delete this._multipleAction;
            }
        },

        insertLabel: function (name, label, index) {
            if (ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                var node = this.nameTable[name];
                if (node && label) {
                    var obj = this.getObjectType(node) == "node" ? this.model.defaultSettings.node : this.model.defaultSettings.connector;
                    if (obj && obj.labels && node.labels && obj.labels[index !== undefined ? index : node.labels.length])
                        label = $.extend(true, {}, obj.labels[index !== undefined ? index : node.labels.length], label);
                    label = ej.datavisualization.Diagram.Label(label);
                    var prtyLabels = obj.labels;
                    prtyLabels.splice();
                    node.labels.push(label);
                    var resource = { element: node, index: index, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "labels", oldValue: prtyLabels, newValue: node.labels };
                    this._raisePropertyChange(resource);
                    ej.datavisualization.Diagram.DiagramContext.addLabel(node, label, this, index);
                    this.addHistoryEntry({ type: "labelcollectionchanged", shape: node, label: label, isUndo: true, category: "internal", index: index });
                }
            }
        },
        addLabel: function (name, label) {
            if (ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                var node = this.nameTable[name];
                if (node && label) {
                    var oldlabels;
                    var obj = this.getObjectType(node) == "node" ? this.model.defaultSettings.node : this.model.defaultSettings.connector;
                    if (obj && obj.labels && node.labels && obj.labels[node.labels.length])
                        label = $.extend(true, {}, obj.labels[node.labels.length], label);
                    label = ej.datavisualization.Diagram.Label(label);
                    oldlabels = node.labels;
                    node.labels.push(label);
                    var resource = { element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "labels", oldValue: oldlabels, newValue: node.labels };
                    this._raisePropertyChange(resource);
                    ej.datavisualization.Diagram.DiagramContext.addLabel(node, label, this);
                    this.addHistoryEntry({ type: "labelcollectionchanged", shape: node, label: label, isUndo: true, category: "internal" });
                }
            }
        },
        addPorts: function (name, ports) {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                var node = this.nameTable[name];
                if (node && ports) {
                    for (var i = 0; i < ports.length; i++) {
                        ports[i] = ej.datavisualization.Diagram.Port(ports[i]);
                        node.ports.push(ports[i]);
                        this._raisePropertyChange({ element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "ports", oldValue: null, newValue: ports[i] });
                        ej.datavisualization.Diagram.DiagramContext.renderPort(node, ports[i], this);
                    }
                    this.addHistoryEntry({ type: "portscollectionchanged", object: node, collection: ports, changeType: "insert", isUndo: true, category: "internal" });
                }
            }
        },
        updatePort: function (nodeName, port, options) {
            if (nodeName && (ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                var mNode = this._findNode(nodeName);
                if (options && port && (!options.name || port.name == options.name)) {
                    if (mNode) {
                        port = this._findPort(mNode, port.name);
                        if (!this._isUndo)
                            this._recordPropertiesChanged(mNode, options, "port", port);
                        options.name = port.name;
                        this._comparePropertyValues(mNode, "ports", options);
                        for (var prop in options)
                            if (port.hasOwnProperty(prop)) {
                                if (typeof options[prop] == "object")
                                    port[prop] = $.extend(true, {}, port[prop], options[prop]);
                                else
                                    port[prop] = options[prop];
                            }
                        ej.datavisualization.Diagram.DiagramContext.updatePort(mNode, port, this);
                    }
                }
            }
        },
        copy: function () {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                this._pasteIndex = 1;
                if (this.selectionList && this.selectionList.length > 0) {
                    this._setClipboard();
                }
            }
            return this._cloneSelectionList();
        },
        paste: function (object, rename) {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                //this._isUndo = true; 
                this._eventCause["nodeCollectionChange"] = this._eventCause["connectorCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.ClipBoard;
                this._paste(object, rename !== undefined ? rename : true);
                //this._isUndo = false;
            }
        },
        _commandPaste: function () {
            this.paste();
        },
        _getNodesfrombounds: function (rect, eachNode) {
            var i, isCollection = false;
            var len;
            var type;
            var bounds;
            var collection = [];
            var nodes = this.nodes();
            for (i = 0, len = nodes.length; i < len; i++) {
                var node = this.nameTable[nodes[i].name];
                if (eachNode) {
                    isCollection = (eachNode.name === node.name) ? true : false;
                }
                if (node && node.visible && !isCollection) {
                    bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    bounds = ej.datavisualization.Diagram.Geometry.rect([bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft]);
                    if (ej.datavisualization.Diagram.Util.canSelect(node)) {
                        type = this.getObjectType(node);
                        if (ej.datavisualization.Diagram.Geometry.containsRect(rect, bounds)) {
                            if (node.parent === "")
                                collection.push(node);
                        }
                        else if (type === "group") {
                            if (this.activeTool && this.activeTool.inAction) this.activeTool._checkGroupChildren(collection, node, rect);
                        }
                    }
                }

            }
            var connectors = this.connectors();
            for (i = 0, len = connectors.length; i < len; i++) {
                var connector = this.nameTable[connectors[i].name];
                if (eachNode) {
                    isCollection = (eachNode.name === connector.name) ? true : false;
                }
                if (connector && connector.visible && !isCollection) {
                    bounds = ej.datavisualization.Diagram.Util.bounds(connector);
                    bounds = ej.datavisualization.Diagram.Geometry.rect([bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft]);
                    if (ej.datavisualization.Diagram.Util.canSelect(connector) && ej.datavisualization.Diagram.Geometry.containsRect(rect, bounds)) {
                        if (connector.parent === "")
                            collection.push(connector);
                    }
                }
            }
            return collection;
        },
        _setClipboard: function () {
            if (this.selectionList.length > 0) {
                var data, node = this.selectionList[0];
                var childTable = {}, collection = [], rectBounds, rect;
                if (node._type === "group" || node.type === "pseudoGroup") {
                    var temp, i, j;
                    var children = this._getChildren(node.children);
                    for (i = 0; i < children.length; i++) {
                        for (j = i + 1; j < children.length; j++) {
                            var nodei = this.nameTable[children[i]];
                            var nodej = this.nameTable[children[j]];
                            if (nodej && nodei) {
                                if (nodej.zOrder < nodei.zOrder) {
                                    temp = children[i];
                                    children[i] = children[j];
                                    children[j] = temp;
                                }
                            }
                        }
                    }
                    childTable = this._getChildTable(node, childTable);
                }
                childTable[node.name] = node;
                rectBounds = ej.datavisualization.Diagram.Util.bounds(node);
                rect = { x: rectBounds.x, y: rectBounds.y, width: rectBounds.width, height: rectBounds.height };
                collection = this._getNodesfrombounds(rect, node);
                data = $.extend(true, {}, { "childTable": childTable, "node": node, "collection": collection });
                if (data.node.segments) {
                    data.node.targetNode = null;
                    data.node.targetPort = null;
                    data.node.sourceNode = null;
                    data.node.sourcePort = null;
                }
                data.addInfo = this._updateClipBoardConnectors(node, childTable);
                this._clipboardData = data;
                //this._clipboardData = this._getCollectionEvent(data);


            }
        },
        _updateClipBoardConnectors: function (pseudoGroup, childTable) {
            var child, connectors = [];
            if (pseudoGroup && pseudoGroup.type === "pseudoGroup" && pseudoGroup.children.length > 0) {
                for (var i = 0; i < pseudoGroup.children.length; i++) {
                    child = this.nameTable[this._getChild(pseudoGroup.children[i])];
                    if (child && child.isSwimlane) {
                        this._updateSwimlaneGroupConnectors(pseudoGroup, child, childTable, connectors);
                    }
                }
            }
            else this._updateSwimlaneGroupConnectors(null, pseudoGroup, childTable, connectors);
            return connectors;
        },
        _updateEdgesToClipboard: function (edge, children, node, childTable, connectors, outEdges) {
            if (node.parent && edge) {
                var sNode = this.nameTable[edge.sourceNode];
                var tNode = this.nameTable[edge.targetNode];
                if (sNode && tNode) {
                    var sparent = this.nameTable[sNode.parent];
                    var tparent = this.nameTable[tNode.parent];
                    if (sparent && sparent.isLane && tparent && tparent.isLane) {
                        if (this._collectionContains(edge.name, outEdges ? node.outEdges : node.inEdges) && !this._collectionContains(edge.name, connectors) && !this._collectionContains(edge.name, children ? children : [])) {
                            connectors.push(this.nameTable[this._getChild(edge)]);
                        }
                    }
                }
            }
        },
        _updateSwimlaneConnectors: function (children, node, childTable, connectors) {
            if (node) {
                var edge, i
                for (i = 0; i < node.inEdges.length > 0; i++) {
                    edge = this.nameTable[this._getChild(node.inEdges[i])]
                    this._updateEdgesToClipboard(edge, children, node, childTable, connectors);
                }
                for (i = 0; i < node.outEdges.length > 0; i++) {
                    edge = this.nameTable[this._getChild(node.outEdges[i])]
                    this._updateEdgesToClipboard(edge, children, node, childTable, connectors, true);
                }
            }
        },
        _updateSwimlaneGroupConnectors: function (pseudoGroup, node, childTable, connectors) {

            var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(this, node), children;
            for (var i = 0; lanes && i < lanes.length; i++) {
                var lane = this.nameTable[this._getChild(lanes[i])];
                if (lane && lane.children && lane.children.length > 0) {
                    children = lane.children;
                    for (var j = 0; j < children.length; j++) {
                        var child = this.nameTable[this._getChild(children[j])];
                        if (child) {
                            this._updateSwimlaneConnectors((pseudoGroup && pseudoGroup.children) ? pseudoGroup.children : null, child, childTable, connectors);
                        }
                    }

                }
            }
        },
        //_getCollectionEvent: function (data){
        //	var args =  {};
        //	args.clipboardCollection = data.collection ? data.collection : null;
        //	args.collectiontype = ej.datavisualization.Diagram.ClipBoardChangeType.None;
        //	args.specificCollection = [];
        //	this._raiseEvent("clipboardChange", args);
        //	switch(args.collectiontype){
        //		case "all":
        //		   data.addInfo = args.clipboardCollection;
        //		   break;
        //		case "none":
        //		   data.addInfo = [];
        //		   break;
        //		case "specific":
        //		   data.addInfo = args.specificCollection;
        //	}
        //	return data;
        // },
        _getChildTable: function (group, childTable) {
            var child, names, name;
            names = this._getChildren(group.children);
            if (names) {
                for (var i = 0; i < names.length; i++) {
                    name = names[i];
                    child = this.nameTable[name];
                    if (child && (child.parent === group.name || group.type == "pseudoGroup")) {
                        var node = childTable[child.name] = $.extend(true, {}, child);
                        if (node._type === "group" || node.type === "pseudoGroup")
                            childTable = this._getChildTable(node, childTable);
                        if (node.inEdges && node.inEdges.length > 0) {
                            for (var e in node.inEdges) {
                                var cCon = this.nameTable[node.inEdges[e]];
                                if (cCon) {
                                    if (childTable[cCon.name])
                                        delete childTable[cCon.name];
                                    childTable[cCon.name] = cCon;
                                }
                            }
                        }
                        if (node.outEdges && node.outEdges.length > 0) {
                            for (var f in node.outEdges) {
                                var cCon = this.nameTable[node.outEdges[f]];
                                if (cCon) {
                                    if (childTable[cCon.name])
                                        delete childTable[cCon.name];
                                    childTable[cCon.name] = cCon;
                                }
                            }
                        }
                    }
                }
            }
            return childTable;
        },
        _paste: function (object, rename) {
            if (!object) {
                if (this._clipboardData) {
                    var data = this._clipboardData;
                    var dx, child;
                    data = $.extend(true, {}, this._clipboardData);
                    var node = data.node;
                    node.zOrder = -1;
                    if (this.tools["move"]._outOfBoundsDrag(node, this._pasteIndex * 10, this._pasteIndex * 10)) {
                        if (node && node.type != "phase") {
                            if (!node.container) {
                                if (node.type == "pseudoGroup") {
                                    var names = node.children;
                                    var pseudoGroup = ej.datavisualization.Diagram.Group({ type: "pseudoGroup", "name": "multipleSelection" });
                                    this._isUndo = true;
                                    this._eventCause["nodeCollectionChange"] = this._eventCause["connectorCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.ClipBoard;
                                    this._multipleAction = true;
                                    for (var i = 0; i < names.length; i++) {
                                        var name = names[i];
                                        child = data.childTable[name];
                                        child.zOrder = -1;
                                        if (child._annotation) delete child._annotation;
                                        if (child && (child.isSwimlane || child.type === "swimlane")) {
                                            this._isUndo = false;
                                            var child = this._pasteSwimlaneObj(child, data);
                                            if (child)
                                                pseudoGroup.children.push(child.name);
                                            this._isUndo = true;
                                        }
                                        else if (child && (child.isLane)) {
                                            var swimChild = this._pasteSwimlane(child, data, true, this._pasteIndex * 10);
                                            if (swimChild)
                                                pseudoGroup.children.push(swimChild.name);
                                            dx = this._pasteIndex * 10;
                                            this._translate(swimChild, dx, dx, this.nameTable);
                                            ej.datavisualization.Diagram.DiagramContext.update(swimChild, this);
                                        } else if (child) {
                                            name = name + ej.datavisualization.Diagram.Util.randomId();
                                            delete (data.childTable[child.name]);
                                            child.name = name;
                                            child.parent = "";
                                            data.childTable[child.name] = child;
                                            this._preserveConnection(data.childTable, child);
                                            var drawChild = true;
                                            if (child.segments) {
                                                var drawChild1 = true, drawChild2 = true;
                                                if (data.childTable[child._oldSourceNode] && !this.nameTable[child.sourceNode]) {
                                                    drawChild1 = false;
                                                    child.sourceNode = null;
                                                }
                                                if (data.childTable[child._oldTargetNode] && !this.nameTable[child.targetNode]) {
                                                    drawChild2 = false;
                                                    child.targetNode = null;
                                                }
                                                if (!drawChild1 && !drawChild2)
                                                    drawChild = false;
                                            }
                                            if (drawChild) {
                                                pseudoGroup.children.push(name);
                                                if (child._type === "group" && child.type != "bpmn") {
                                                    this._pasteChildren(data.childTable, child);
                                                }
                                                else
                                                    child.children = [];
                                                dx = this._pasteIndex * 10;
                                                this._translate(child, dx, dx, this.nameTable);
                                                if (child.segments && child.segments.length == 1 && child.segments[0].type == "orthogonal" && !child.sourceNode && !child.targetNode) {
                                                    points = child.segments[0].points;
                                                }
                                                var success = false;
                                                success = this.add(child);
                                                if (points && success) {
                                                    child = this.nameTable[child.name];
                                                    child.segments[0].points = points;
                                                    ej.datavisualization.Diagram.DiagramContext.update(child, this);
                                                    ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.selectionList[0], this._adornerSvg, this._currZoom);
                                                }
                                            }
                                        }
                                    }
                                    delete this._multipleAction;
                                    this._clearSelection();
                                    if (pseudoGroup && pseudoGroup.children.length > 0) {
                                        this.nodes().push(pseudoGroup);
                                        this._nodes = $.extend(true, [], this.nodes());
                                        this.nameTable[pseudoGroup.name] = pseudoGroup;
                                        ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, this);
                                        this._addSelection(pseudoGroup);
                                        var childTable = {};
                                        childTable = this._getChildTable(this.selectionList[0], childTable);
                                        var entry = { type: "collectionchanged", object: this._updatePsedoGroupChildren(this.selectionList[0]), childTable: jQuery.extend(true, {}, childTable), changeType: "insert", category: "internal" };
                                        this.addHistoryEntry(entry);
                                        this._isUndo = false;
                                    }
                                } else if (node.type == "bpmn") {
                                    var randomId = ej.datavisualization.Diagram.Util.randomId();
                                    node.parent = "";
                                    node.name = node.name + randomId;
                                    node.inEdges = [];
                                    node.outEdges = [];
                                    node.children = [];
                                    if (node._annotation) delete node._annotation;
                                    dx = this._pasteIndex * 10;
                                    this._translate(node, dx, dx, this.nameTable);
                                    this.add(node);
                                } else {
                                    node.name = node.name + ej.datavisualization.Diagram.Util.randomId();
                                    node.parent = "";
                                    if (node._type === "group") {
                                        this._pasteChildren(data.childTable, node);
                                    } else if (node.segments) {
                                        //this._disConnect(node);
                                    } else if (!node.segments) {
                                        //@Fix
                                        //this._disConnect(node);
                                        node.inEdges = [];
                                        node.outEdges = [];
                                    }
                                    dx = this._pasteIndex * 10;
                                    this._translate(node, dx, dx, this.nameTable);
                                    if (node.segments && node.segments.length == 1 && node.segments[0].type == "orthogonal" && !node.sourceNode && !node.targetNode) {
                                        var points = node.segments[0].points;
                                    }
                                    var success = this.add(node);
                                    if (success && points) {
                                        node = this.nameTable[node.name];
                                        node.segments[0].points = points;
                                        ej.datavisualization.Diagram.DiagramContext.update(node, this);
                                        ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.selectionList[0], this._adornerSvg, this._currZoom);
                                    }
                                    this._updateSelectionHandle();
                                    //this._clearSelection();
                                    //this._addSelection(node);
                                }
                            } else {
                                if (node.isSwimlane) {
                                    node = this._pasteSwimlaneObj(node, data);
                                    data.childTable = this._getChildTable(node, data.childTable);
                                }
                                else {
                                    if (node.isLane) {
                                        node = this._cloneLaneObj(node, ej.datavisualization.Diagram.Util.randomId(), data.childTable);
                                        if (node.orientation === "vertical") {
                                            node.height = node.height;
                                        }
                                        var swimlane = ej.datavisualization.Diagram.SwimLaneHelper._createSwimlane(node, this, this._clipboardData, true);
                                        if (swimlane) {
                                            this._pasteObj = true;
                                            this.add(swimlane);
                                            this._pasteObj = false;
                                        }
                                        node = swimlane;
                                    }
                                    else if (node.container && !node.isLane && !node.isSwimlane) {
                                        node = this._cloneContainer(node, ej.datavisualization.Diagram.Util.randomId(), data.childTable)
                                        this._preserveConnection(data.childTable, node);
                                        this.add(node);
                                        node = this.nameTable[node.name];
                                    }
                                    dx = this._pasteIndex * 10;
                                    this._translate(node, dx, dx, this.nameTable);
                                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                                }
                                if (this._selectionContains(node)) {
                                    this._clearSelection(true);
                                    this._addSelection(node);
                                }
                            }
                            if (data.addInfo.length) {
                                for (var m in data.addInfo) {
                                    var addobj, cName;
                                    addobj = data.addInfo[m];
                                    if (addobj.isSwimlane) {
                                        data.childTable[addobj.name] = addobj;
                                        data.childTable = this._getChildTable(addobj, data.childTable);
                                        addobj = this._pasteSwimlaneObj(addobj, data);
                                        data.childTable[addobj.name] = addobj;
                                        data.childTable = this._getChildTable(addobj, data.childTable);
                                    }
                                    else {
                                        if (data.childTable[addobj.name] && addobj !== data.childTable[addobj.name]) {
                                            addobj = $.extend(true, {}, data.childTable[addobj.name]);
                                        }
                                        cName = addobj.name + ej.datavisualization.Diagram.Util.randomId();
                                        addobj.name = cName;
                                        addobj.parent = "";
                                        data.childTable[addobj.name] = addobj;
                                        this._preserveConnection(data.childTable, addobj);
                                        dx = this._pasteIndex * 10;
                                        this._translate(addobj, dx, dx, this.nameTable);
                                        this.add(addobj);
                                        if (this._selectionContains(addobj)) {
                                            this._clearSelection(true);
                                        }
                                    }
                                }
                                if (!this._selectionContains(node)) {
                                    this._addSelection(node);
                                }
                            }
                            this._pasteIndex++;
                        }
                    }
                }
            }
            else {
                var name = "";
                var connectors = [];
                var pseudoGroup = ej.datavisualization.Diagram.Group({ "name": "multipleSelection", type: "pseudoGroup" });
                if (rename)
                    name = ej.datavisualization.Diagram.Util.randomId();
                for (var i = 0; i < object.length; i++) {
                    object[i].name += name;
                    if (object[i].outEdges) object[i].outEdges = [];
                    if (object[i].inEdges) object[i].inEdges = [];
                    if (object.length > 1) pseudoGroup.children.push(object[i].name);
                    if (object[i].type != "connector") {
                        if ((object[i].type === "group" || object[i].type === "bpmn") && !object[i].isSwimlane) {
                            this._clonePasteGroup(object[i], name, object);
                            this.add($.extend({}, object[i]));
                        }
                        if (object[i].isSwimlane) {
                            this._clonePasteSwimlaneObj(object[i], name, object);
                            var cloneObj = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, object[i], data);
                            if (this._outOfBoundsOnNudge(cloneObj, diagram._pasteIndex * 10, this._pasteIndex * 10)) {
                                this.add(cloneObj);
                            }
                        }
                        else this.add($.extend({}, object[i]));

                    }
                    else
                        connectors.push(object[i]);

                }
                for (var i = 0; i < connectors.length; i++) {
                    if (connectors[i].sourceNode && this.nameTable[connectors[i].sourceNode + name])
                        connectors[i].sourceNode += name;
                    else {
                        connectors[i].sourceNode = "";
                        connectors[i].sourcePort = "";
                    }
                    if (connectors[i].targetNode && this.nameTable[connectors[i].targetNode + name])
                        connectors[i].targetNode += name;
                    else {
                        connectors[i].targetNode = "";
                        connectors[i].targetPort = "";
                    }
                    if (object.length > 1) pseudoGroup.children.push(connectors[i].name);
                    this.add($.extend({}, connectors[i]));
                }
                if (object.length > 1) {
                    this.nodes().push(pseudoGroup);
                    this._nodes = $.extend(true, [], this.nodes());
                    this.nameTable[pseudoGroup.name] = pseudoGroup;
                    this._clearSelection(true);
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, this);
                    this.addSelection(pseudoGroup, true);
                }
            }
        },

        _cloneContainer: function (group, name, childTable) {
            group.name = group.name + name;
            for (var i = 0; i < group.children.length; i++) {
                var nameTable = childTable ? childTable : this.nameTable;
                var child = nameTable[this._getChild(group.children[i])];
                child.name += name;
                child.parent = group.name;
                if (child.children && child.children.length > 0) {
                    child = this._cloneContainer(child, name, childTable);
                }
                group.children[i] = child;
            }
            ej.datavisualization.Diagram.bpmnHelper.updateProcessCollection(group, this);
            return group
        },

        _clonePasteGroup: function (group, name, objects) {
            for (var i = 0; i < group.children.length; i++) {
                group.children[i].name += name;
                group.children[i].parent = group.name;
                if (group.children[i].segments) {
                    if (group.children[i].sourceNode)
                        group.children[i].sourceNode += name;
                    if (group.children[i].targetNode)
                        group.children[i].targetNode += name;
                }
                else {
                    var edge;
                    for (var e = 0; e < group.children[i].inEdges.length; e++) {
                        edge = group.children[i].inEdges[e];
                        if (this._collectionContains(edge, group.children) || (objects && this._collectionContains(edge, objects))) {
                            edge += name;
                        }
                        else group.children[i].inEdges.splice(e, 1);
                    }
                    for (var e = 0; e < group.children[i].outEdges.length; e++) {
                        edge = group.children[i].outEdges[e];
                        if (this._collectionContains(edge, group.children) || (objects && this._collectionContains(edge, objects))) {
                            edge += name;
                        }
                        else group.children[i].outEdges.splice(e, 1);
                    }
                }
            }
        },
        _clonePasteSwimlaneObj: function (obj, name, objects) {
            //obj.name += name;
            //update lanes
            if (obj.lanes && obj.lanes.length > 0) {
                for (var i = 0; i < obj.lanes.length; i++) {
                    if (obj.lanes[i]) {
                        obj.lanes[i].name += name;
                        if (obj.lanes[i].children && obj.lanes[i].children.length > 0) {
                            var children = obj.lanes[i].children;
                            var nChildren = [];
                            for (var m = 0; m < children.length; m++) {
                                var child = jQuery.extend(true, {}, children[m]);
                                child.name += name;
                                child.parent = obj.lanes[i].name;
                                for (var e = 0; e < child.inEdges.length; e++) {
                                    if (this._collectionContains(child.inEdges[e], objects)) {
                                        child.inEdges[e] += name;
                                        obj.lanes[i].children[m] = child;
                                    }
                                    else child.inEdges.splice(e, 1);
                                }
                                for (var e = 0; e < child.outEdges.length; e++) {
                                    if (this._collectionContains(child.outEdges[e], objects)) {
                                        child.outEdges[e] += name;
                                        obj.lanes[i].children[m] = child;
                                    }
                                    else child.outEdges.splice(e, 1);
                                }
                                nChildren.push(child)
                            }
                            obj.lanes[i].children = nChildren;
                        }
                    }
                }
            }
            //update phases
            if (obj.phases && obj.phases.length > 0) {
                var phases = [];
                for (var i = 0; i < obj.phases.length; i++) {
                    if (obj.phases[i]) {
                        var phase = jQuery.extend(true, {}, obj.phases[i]);
                        phase.name += name;
                        phase.parent = "";
                        phases.push(phase);
                    }
                }
                obj.phases = phases;
            }
        },

        _cloneLaneObj: function (obj, name, childTable) {
            var obj = ej.datavisualization.Diagram.SwimLaneContainerHelper._cloneLaneObj(this, obj, name, childTable)
            return obj;
        },

        _cloneSwimlaneObj: function (obj, name, data) {
            obj = $.extend(true, {}, obj);
            var obj = ej.datavisualization.Diagram.SwimLaneContainerHelper._cloneSwimlaneObj(this, obj, name, data)
            return obj;
        },

        _pasteSwimlaneObj: function (node, data) {
            node = ej.datavisualization.Diagram.SwimLaneContainerHelper._pasteSwimlaneObj(this, node, data)
            return node;
        },

        _pasteSwimlane: function (node, data, mSelection, x) {
            if (node && node.isSwimlane) {
                var cloneObj = ej.datavisualization.Diagram.SwimLaneContainerHelper._pasteSwimlane(this, node, data, mSelection, x)
                return cloneObj;
            }
        },
        _cloneNode: function (node, data, name, pnode) {
            var nameState = false;
            var parentName = null;
            if (node) {
                node = (typeof (node) === "string") ? node : node.name;
                var node = jQuery.extend(true, {}, data.childTable[node]);
                if (node.isPhaseStack) {
                    node.name = node.name.split("phaseStack")[0] + name + "phaseStack";
                    nameState = true;
                    parentName = node.name;
                }
                if (node.children && node.children.length > 0) {
                    for (var i in node.children) {
                        this._cloneNode(node.children[i], data, name, parentName);
                        if (node.children[i]) (typeof (node.children[i]) === "string") ? node.children[i] += name : node.children[i].name += name;
                    }
                }
                if (pnode) {
                    node.parent = (typeof (pnode) === "string") ? pnode : pnode.name;
                }
                else if (node.parent != "")
                    node.parent += name;
                if (!nameState)
                    node.name += name;
                this._preserveConnection(data.childTable, node);
                this.nameTable[node.name] = node;
            }
        },
        _cloneSwimlane: function (node, data, name) {
            var tempName = node.name;
            node.name += name;
            if (node.children && node.children.length > 0) {
                for (var i in node.children) {
                    this._cloneNode(node.children[i], data, name, node);
                    if (typeof (node.children[i]) === "string") {
                        (node.children[i] += name)
                    }
                    else {
                        if (node.children[i].isPhaseStack)
                            node.children[i] = tempName + name + "phaseStack";
                        else
                            node.children[i] = node.children[i].name + name;
                    }
                }
            }
            if (node.phases && node.phases.length > 0) {
                var phase;
                for (var i in node.phases) {
                    phase = jQuery.extend(true, {}, this.nameTable[node.phases[i]])
                    phase.name += name;
                    phase.parent += name;
                    this.nameTable[phase.name] = phase;
                    node.phases[i] = phase.name;
                }
            }
            this.nameTable[node.name] = node;
        },
        _pasteChild: function (child, childTable, group, childNames) {
            var name = child.name + ej.datavisualization.Diagram.Util.randomId();
            delete (childTable[child.name]);
            child.name = name;
            childTable[child.name] = child;
            this._preserveConnection(childTable, child);
            child.parent = group.name;
            childNames.push(name);
            if (child._type === "group") {
                this._pasteChildren(childTable, child);
            }
            this.add(child);
        },
        _pasteChildren: function (childTable, group) {
            var child, names, name;
            var childNames = [];
            names = group.children;
            for (var i = 0; i < names.length; i++) {
                name = this._getChild(names[i]);
                child = childTable[name];
                child.zOrder = -1;
                if (child) {
                    this._pasteChild(child, childTable, group, childNames);
                }
            }
            group.children = childNames;
            this._preserveConnection(childTable, group);
        },
        _preserveConnections: function (childTable, group) {
            var child, names;
            names = this._getChildren(group.children);
            for (var i = 0; i < names.length; i++) {
                child = childTable[names[i]];
                if (child) {
                    this._preserveConnection(childTable, child);
                    if (child._type === "group")
                        this._preserveConnections(childTable, group);
                }
            }
        },
        _preserveConnection: function (childTable, child) {
            var i, connection, len;
            if (!child.segments) {
                len = child.inEdges.length;
                if (len > 0) {
                    for (i = 0; i < len; i++) {
                        connection = childTable[child.inEdges[i]];
                        if (connection) {
                            connection._oldTargetNode = connection.targetNode;
                            connection.targetNode = child.name;
                        }
                    }
                    child.inEdges = [];
                }
                len = child.outEdges.length;
                if (len > 0) {
                    for (i = 0; i < child.outEdges.length; i++) {
                        connection = childTable[child.outEdges[i]];
                        if (connection) {
                            connection._oldSourceNode = connection.sourceNode;
                            connection.sourceNode = child.name;
                        }
                    }
                    child.outEdges = [];
                }
            } else {
                var node;
                if (child.targetNode) {
                    node = childTable[child.targetNode];
                    if (node)
                        node.inEdges.push(child.name);
                    //else
                    //    child.targetNode = null;
                }
                if (child.sourceNode) {
                    node = childTable[child.sourceNode];
                    if (node)
                        node.outEdges.push(child.name);
                    //else
                    //    child.sourceNode = null;
                }
            }
        },
        _expandChildren: function (node) {
            for (var i = 0; i < node.outEdges.length; i++) {
                var conn = this.nameTable[node.outEdges[i]];
                var target = this.nameTable[conn.targetNode];
                if (!target.excludeFromLayout) {
                    conn.visible = true;
                    ej.datavisualization.Diagram.DiagramContext.update(conn, this);
                    this._updateQuad(conn);
                    if (target.isExpanded)
                        this._expandChildren(target);
                    target.visible = true;
                    ej.datavisualization.Diagram.DiagramContext.update(target, this);
                    this._updateQuad(target);
                }
            }
        },
        _collapseChildren: function (node) {
            for (var i = 0; i < node.outEdges.length; i++) {
                var conn = this.nameTable[node.outEdges[i]];
                var target = this.nameTable[conn.targetNode];
                if (!target.excludeFromLayout) {
                    conn.visible = false;
                    ej.datavisualization.Diagram.DiagramContext.update(conn, this);
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[conn.name], conn);
                    ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, conn);
                    if (target.isExpanded)
                        this._collapseChildren(target);
                    target.visible = false;
                    ej.datavisualization.Diagram.DiagramContext.update(target, this);
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[target.name], target);
                    ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, target);
                }
            }
        },
        zoomTo: function (zoom) {
            if (!zoom) {
                zoom = new ej.datavisualization.Diagram.Zoom();
            }
            if (zoom.zoomCommand & ej.datavisualization.Diagram.ZoomCommand.ZoomIn) {
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, (1 + zoom.zoomFactor), 0, 0, zoom.focusPoint, true);
            } else {
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, (1 / (1 + zoom.zoomFactor)), 0, 0, zoom.focusPoint, true);
            }
        },
        remove: function (node) {
            if (node && this.nameTable[node.name] && (ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                this._delete(node);
            }
            else
                this._delete();
        },
        clear: function () {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                this._clearSelection();
                var i;
                var diagram = this;
                this._views.forEach(function (viewid) {
                    var view = diagram._views[viewid];
                    $(view.diagramLayer).empty();
                    $(diagram._expander).empty();
                    $(view.svg.document.parentNode.getElementsByClassName("htmlLayer")[0]).empty();
                });
                while (this.nodes().length > 0) {
                    this.nodes().pop();
                }
                while (this.connectors().length > 0) {
                    this.connectors().pop();
                }
                this._nodes = [];
                this._connectors = [];
                this.nameTable = {};
                this.selectionList = [];
                this.clearHistory();
                this._spatialSearch = ej.datavisualization.Diagram.SpatialSearch();
                this._updateScrollOffset(0, 0);
            }
        },
        _updateChildOnGroup: function (node) {
            var parent = null;
            if (node && node.parent) {
                parent = this._svg.document.getElementById(node.parent);
                var parentObj = this.nameTable[node.parent];
                if (parentObj) {
                    if (parentObj.container) {
                        ej.datavisualization.Diagram.ContainerHelper._add(this, node);
                    }
                    else {
                        node = this.nameTable[this._getChild(node)];
                        if (node != null) {
                            parentObj.children.push(node);
                        }
                        if (node._type == "group") this._initGroupNode(node);
                        ej.datavisualization.Diagram.Util._refreshParentGroup(node, this);
                    }
                }
            }
            return parent;
        },
        _raiseChildrenPropertyChange: function (node, isAdd) {
            if (node && node.parent) {
                var parent = this._findNode(node.parent);
                var element, property, currCollection = [], preCollection = [];
                if (parent) {
                    if (parent.isLaneStack) {
                        var swimlane = this._getNode(parent.parent);
                        preCollection = swimlane.lanes;
                        preCollection = preCollection.slice();
                        if (isAdd)
                            swimlane.lanes.push(node);
                        else
                            swimlane.lanes.splice(currCollection.indexOf(this.getNode(node.name)), 1)
                        currCollection = swimlane.lanes
                        element = swimlane;
                        property = "lanes";
                    }
                    else if (parent.isPhaseStack) {
                        var swimlane = this._getNode(parent.parent);
                        preCollection = swimlane.phases;
                        preCollection = preCollection.slice();
                        if (isAdd)
                            swimlane.phases.push(node);
                        else
                            swimlane.phases.splice(currCollection.indexOf(this.getNode(node.name)), 1)
                        currCollection = swimlane.phases
                        element = swimlane;
                        property = "phases";
                    }
                    else {
                        var parent = this._getNode(node.parent);
                        preCollection = parent.children.slice();
                        currCollection = parent.children.slice();
                        if (isAdd)
                            currCollection.push(node.name);
                        else
                            currCollection.splice(currCollection.indexOf(node.name), 1)
                        element = parent;
                        property = "children";
                    }

                    var resource = {
                        element: element, cause: this._isDragg || (this.activeTool.inAction) ?
                        ej.datavisualization.Diagram.ActionType.Mouse : ej.datavisualization.Diagram.ActionType.Unknown,
                        propertyName: property, oldValue: preCollection, newValue: currCollection
                    };
                    this._raisePropertyChange(resource);
                }
            }
        },
        addLane: function (node, index) {
            if (node.isLane) {
                node = this._dynamicLane(node, this);
                if (!index && !node.parent) {
                    node = ej.datavisualization.Diagram.SwimLaneHelper._createSwimlane(node, this);
                    this.add(node);
                }
                else {
                    var swimlane = this._updateDynamicLane(this, node, index);
                    if (swimlane && swimlane.isSwimlane) {
                        var stack = this.nameTable[this._getChild(swimlane.children[2])];
                        node = ej.datavisualization.Diagram.canvasHelper._updateDropLaneProperties(this, node, swimlane);
                        if (index || index === 0) {
                            stack.children.splice(index, 0, node.name);
                        }
                        else
                            stack.children.push(node.name);
                        node.parent = stack.name;
                        this._swimlaneObject = true;
                    }
                    else
                        node = ej.datavisualization.Diagram.SwimLaneHelper._createSwimlane(node, this);
                    this.add(node);
                    if (stack && swimlane) {
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, stack);
                        ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, swimlane);
                        this._clearSelection(true);
                        this._addSelection(swimlane);
                    }
                    delete this._swimlaneObject;
                }
            }
        },
        _dynamicLane: function (node, diagram) {
            var obj = ej.datavisualization.Diagram.SwimLaneHelper._createPaletteLane(node, diagram.nameTable);
            var orientation = obj.orientation;
            obj = ej.datavisualization.Diagram.SwimLaneHelper._createDiagramLane(obj, diagram.nameTable);
            obj.minHeight = node.height;
            obj.minWidth = node.width;
            obj.parent = node.parent;
            obj.orientation = orientation;
            if (node.orientation)
                obj.orientation = node.orientation;
            if (obj.isLane)
                obj = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, obj);
            return obj;
        },
        _updateDynamicLane: function (diagram, node, arg) {
            if (node.parent)
                var swimlane = diagram.nameTable[node.parent];
            else {
                for (var i = 0; i < this.selectionList.length; i++)
                    var swimlane = this.selectionList[i];
            }
            return swimlane;
        },
        _add: function (node, render, arg, restrictSelection) {
            if (!node.length > 0) {
                node = ej.datavisualization.Diagram.NodeType(node, this);
                var nodeTemplate, connectorTemplate;
                if (this.model.nodeTemplate && node._type === "node")
                    nodeTemplate = this._getNodeTemplate();
                else
                    connectorTemplate = this._getConnectorTemplate();
                if (nodeTemplate)
                    nodeTemplate(this, node);
                if (connectorTemplate)
                    connectorTemplate(this, node);
            }
            if (!node.pivot) node.pivot = { x: 0.5, y: 0.5 };
            if (this._outOfBoundsOnNudge(node, 0, 0)) {
                this._raiseChildrenPropertyChange(node, true);
                var success = false, type;
                if ((node.isSwimlane || node.type === "swimlane") && !this._pasteObj) {
                    if (this._isNewNode)
                        node = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, node);
                }
                if (node.length > 0) {
                    for (var i = 0; i < node.length; i++) {
                        this.add(node[i]);
                    }
                } else {
                    //#region for temporary
                    if (node.addInfo) {
                        if (node.addInfo.height)
                            node.height = node.addInfo.height;
                        if (node.addInfo.width)
                            node.width = node.addInfo.width;
                    }
                    //#endregion
                    if (node.type == "connector") type = "connector"; else type = "node";
                    var args = { changeType: "insert", element: this.getNode(node) };
                    if (node.isLane) {
                        args = this._raiseCollectionChangeEvent(node, type);
                        this._updateLane(node, args.element);
                    }
                    else if (node.isSwimlane) {
                        args = this._raiseCollectionChangeEvent(node, type);
                        this._updateSwimlane(node, args.element, true);

                    }
                    else if (node.container && !$.isEmptyObject(node.container)) {
                        node = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, node);
                    }
                    if (!(node.isLane || node.isSwimlane)) {
                        if (node.type != "connector") {
                            var cause = this._eventCause[type + "CollectionChange"];
                            if (!cause)
                                this._eventCause[type + "CollectionChange"] = this._isUndo ? ej.datavisualization.Diagram.CollectionChangeCause.HistoryChange : ej.datavisualization.Diagram.CollectionChangeCause.Unknown;
                            if (node._type === "group" || (node.children && node.children.length > 0)) {
                                node = ej.datavisualization.Diagram.Group(node);
                                this.nameTable[node.name] = node;
                                args = this._raiseCollectionChangeEvent(node, type);
                                node._type = "group";
                                if (node.type == "bpmn") node = ej.datavisualization.Diagram.Util._updateBpmnChild(node, this);
                                this._initGroupNode(node);
                                if (!this._isGroupNode && node.type !== "bpmn")
                                    this._udpateChildRotateAngle(node);
                            }
                            else if (!node.isPhase) {
                                //if (!(this.activeTool && this.activeTool.name === "textTool"))
                                node = this._getNewNode(node);
                                this.nameTable[node.name] = node;
                                args = this._raiseCollectionChangeEvent(node, type);
                                this._getNodeDimension(node);
                            }
                            if (!args.cancel) {
                                node._status = "new";
                                success = this.nodes().push(node);
                                this._nodes = $.extend(true, [], this.nodes());
                                this.nameTable[node.name] = node;

                                if (success) {
                                    if (node._type === "group" || (node.children && node.children.length > 0)) {
                                        this._updateParent(node);

                                        if (node.offsetX == 0 && node.offsetY == 0)
                                            ej.datavisualization.Diagram.Util._updateGroupBounds(node, this, true);
                                        this._updateChildrenEdges(node);
                                        var parent = null;
                                        parent = this._updateChildOnGroup(node);
                                        if (render && !node.parent) {
                                            delete this._isNodeInitializing;
                                            //ej.datavisualization.Diagram.Util._updateGroupBounds(node, this, true);
                                            ej.datavisualization.Diagram.DiagramContext.renderGroup(node, this);
                                        }
                                    } else {
                                        if (render) {
                                            var parent = null;
                                            parent = this._updateChildOnGroup(node);
                                            if ((node.parent === "" || node.isPhase) || this._isInsert)
                                                ej.datavisualization.Diagram.DiagramContext.renderNode(node, this, parent); if (this._selectedSymbol && node.textBlock) {
                                                    var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                                                    if (htmlLayer) {
                                                        var textElement = $(htmlLayer).find("#" + node.name)[0];
                                                        if (textElement && textElement.childNodes && textElement.childNodes.length > 0)
                                                            textElement.childNodes[0].style.display = "none";
                                                    }
                                                }
                                        }
                                    }
                                    this._updateQuad(node);
                                    this.nameTable[node.name] = node;
                                    if (render && !restrictSelection) {
                                        this._clearSelection(true);
                                        this._addSelection(node);
                                    }
                                }
                            }

                        }
                        else {
                            node = this._getNewConnector(node);
                            this.nameTable[node.name] = node;
                            var cause = this._eventCause[type + "CollectionChange"];
                            if (!cause)
                                this._eventCause[type + "CollectionChange"] = this._isUndo ? ej.datavisualization.Diagram.CollectionChangeCause.HistoryChange : ej.datavisualization.Diagram.CollectionChangeCause.Unknown;
                            args = this._raiseCollectionChangeEvent(node, type);
                            if (!args.cancel) {
                                success = (!node.parent) ? this.connectors().push(node) : true;
                                node._status = "new";
                                if (success) {
                                    this._updateEdges(node);
                                    this._dock(node, this.nameTable);
                                    ej.datavisualization.Diagram.Util.updateBridging(node, this);
                                    if (!node.parent) {
                                        if (render)
                                            ej.datavisualization.Diagram.DiagramContext.renderConnector(node, this);
                                    }
                                    this.nameTable[node.name] = node;
                                    this._updateQuad(node);
                                    this._updateChildOnGroup(node);
                                    if (render && !restrictSelection) {
                                        this._clearSelection(true);
                                        this._addSelection(node);
                                    }
                                }
                            }

                        }
                    }
                    else {
                        if (!args.cancel) {
                            if (node.isLane && (((this._selectedSymbol && this._selectedSymbol.isLane) || this._swimlaneObject) || this._isUndo))
                                success = true;
                            else
                                success = this.nodes().push(node);

                            this._nodes = $.extend(true, [], this.nodes());
                            this.nameTable[node.name] = node;

                            if (success) {
                                if (node._type === "group") {
                                    if (render) {
                                        if (this._paletteItemClick) {
                                            node.offsetX = node.minWidth / 2 + 50;
                                            node.offsetY = node.minHeight / 2 + 50;
                                        }
                                        ej.datavisualization.Diagram.DiagramContext.renderGroup(node, this);
                                        if (node.phases && node.phases.length > 0) {
                                            var cphase = null;
                                            for (var i = 0, len = node.phases.length; i < len; i++) {
                                                cphase = this.nameTable[node.phases[i]];
                                                if (cphase.type == "phase") {
                                                    ej.datavisualization.Diagram.SvgContext.renderphase(cphase, this._svg, this._diagramLayer, this);
                                                }
                                            }
                                        }
                                        this._clearSelection(true);
                                        this._addSelection(node);
                                    }
                                }
                                this._updateQuad(node);
                            }
                        }
                    }
                }
                this._setZorder(node);
                if (!this._isUndo && (!this._selectedSymbol || this._endEditing) && success) {
                    var childTable = {};
                    if (this.selectionList && this.selectionList.length > 0)
                        childTable = this._getChildTable(this.selectionList[0], childTable);
                    //if (node.isSwimlane) {
                    //    node = this._getNode(node.name, this.nameTable);
                    //}
                    if ((!arg || (arg && !arg.entryHistory)) && !node.isPhase) {
                        var entry = { type: "collectionchanged", object: jQuery.extend(true, {}, node), childTable: jQuery.extend(true, {}, childTable), changeType: "insert", category: "internal" };
                        this.addHistoryEntry(entry);
                    }
                }
                this._trigger("refresh");
                this._isRefreshTriggered = true;
                if (success && !node.isPhase && (!this._selectedSymbol || this._endEditing)) {
                    args.state = "changed";
                    this._raiseEvent(type + "CollectionChange", args);
                }
            }
            delete this._isNewNode;
            return success;
        },
        _raiseCollectionChangeEvent: function (node, type) {
            var args = { changeType: "insert", element: this.getNode(node), state: "changing" };
            if (!node.isPhase && (!this._selectedSymbol || this._endEditing)) {
                this._raiseEvent(type + "CollectionChange", args);
                node._absolutePath = null;
            }
            return args;
        },
        add: function (node, args) {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                this._isNodeInitializing = true;
                this._isNewNode = true;
                var returnVal = this._add(node, true, args);
                delete this._isNodeInitializing;
                return returnVal;
            }
        },
        updateUserHandles: function (node) {
            node = this.nameTable[node.name];
            ej.datavisualization.Diagram.SvgContext.updateUserHandles(this.model.selectedItems.userHandles, node, this._adornerSvg, false, false, this._currZoom, this);
        },
        scrollToNode: function (node) {
            var nodeX, nodeY;
            var curZoomfactor = this._currZoom;
            var elementBounds = this.element[0].getBoundingClientRect();
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            nodeX = (nodeBounds.x + nodeBounds.width / 2) * curZoomfactor;
            nodeY = (nodeBounds.y + nodeBounds.height / 2) * curZoomfactor;
            var hScrollOffset = this._hScrollOffset, vScrollOffset = this._vScrollOffset;
            if (elementBounds.width + this._hScrollOffset < (nodeX + ((nodeBounds.width / 2) * curZoomfactor))) {
                hScrollOffset = (nodeX + ((nodeBounds.width / 2 + 20) * curZoomfactor) - elementBounds.width); // * 20 as scroll bar width 
            }
            if (elementBounds.height + this._vScrollOffset < (nodeY + ((nodeBounds.height / 2) * curZoomfactor))) {
                vScrollOffset = (nodeY + ((nodeBounds.height / 2 + 20) * curZoomfactor) - elementBounds.height); // * 20 as scroll bar height 
            }
            this._updateScrollOffset(hScrollOffset, vScrollOffset);
        },
        findNode: function (id) {
            return this._findNode(id);
        },
        getObjectType: function (element) {
            return ej.datavisualization.Diagram.Util.getObjectType(element);
        },
        //#endregion
        //#region support methods       
        _registerDrawingTools: function () {
            for (var toolname in this.model.drawingTools) {
                var tool = this.model.drawingTools[toolname];
                tool.diagram = this;
                this.tools[tool.name] = tool;
            }
        },
        _sortByXvalue: function (nodes) {
            var temp, i, j;
            var fNode, lNode;
            for (i = 0; i < nodes.length; i++) {
                for (j = i + 1; j < nodes.length; j++) {
                    var nodei = this.nameTable[this._getChild(nodes[i])];
                    var nodej = this.nameTable[this._getChild(nodes[j])];
                    fNode = ej.datavisualization.Diagram.Util.bounds(nodei);
                    lNode = ej.datavisualization.Diagram.Util.bounds(nodej);
                    if ((fNode.x > lNode.x) || (fNode.right > lNode.right)) {
                        temp = nodes[i];
                        nodes[i] = nodes[j];
                        nodes[j] = temp;
                    }
                }
            }
            return nodes;
        },
        _sortByYvalue: function (nodes) {
            var temp, i, j;
            var fNode, lNode;
            for (i = 0; i < nodes.length; i++) {
                for (j = i + 1; j < nodes.length; j++) {
                    var nodei = this.nameTable[this._getChild(nodes[i])];
                    var nodej = this.nameTable[this._getChild(nodes[j])];
                    fNode = ej.datavisualization.Diagram.Util.bounds(nodei);
                    lNode = ej.datavisualization.Diagram.Util.bounds(nodej);
                    if ((fNode.y > lNode.y) || (fNode.bottom > lNode.bottom)) {
                        temp = nodes[i];
                        nodes[i] = nodes[j];
                        nodes[j] = temp;
                    }
                }
            }
            return nodes;
        },
        _sortByZIndex: function (nodes, asc) {
            var temp, i, j;
            if (!asc) {
                for (i = 0; i < nodes.length; i++) {
                    for (j = i + 1; j < nodes.length; j++) {
                        if (nodes[i].zOrder < nodes[j].zOrder) {
                            temp = nodes[i];
                            nodes[i] = nodes[j];
                            nodes[j] = temp;
                        }
                    }

                }
            }
            else {
                for (i = 0; i < nodes.length; i++) {
                    for (j = i + 1; j < nodes.length; j++) {
                        if (nodes[i].zOrder > nodes[j].zOrder) {
                            temp = nodes[i];
                            nodes[i] = nodes[j];
                            nodes[j] = temp;
                        }
                    }

                }
            }
            return nodes;
        },
        _updateBPMNIndex: function (node, asc) {
            var temp, i, j;
            if (node.type === "bpmn" && node.parent) {
                var parent = this.nameTable[node.parent];
                if (parent && parent.isLane) {
                    var children = parent.children;
                    for (i = 0; i < children.length; i++) {
                        for (j = i + 1; j < children.length; j++) {
                            var childeNode1 = this.nameTable[children[i]];
                            var childeNode2 = this.nameTable[children[j]];
                            if ((!asc ? childeNode1.zOrder < childeNode2.zOrder : childeNode1.zOrder > childeNode2.zOrder) &&
                                !childeNode1.isPhase && !childeNode2.isPhase && !childeNode1.isLane && !childeNode2.isLane) {
                                temp = children[i];
                                children[i] = children[j];
                                children[j] = temp;
                            }
                        }
                    }
                }
            }
        },
        _sortByGroupChildrenZIndex: function (asc) {
            var nodes = this.nodes();
            var temp, i, j, k;
            for (k = 0; k < nodes.length; k++) {
                var node = nodes[k];
                this._updateBPMNIndex(node, asc);
                if (node._type === "group" && node.type !== "bpmn" && !node.isSwimlane) {
                    var children = this._getChildren(node.children);
                    for (i = 0; i < children.length; i++) {
                        for (j = i + 1; j < children.length; j++) {
                            var childeNode1 = this.nameTable[children[i]];
                            var childeNode2 = this.nameTable[children[j]];
                            if ((!asc ? childeNode1.zOrder < childeNode2.zOrder : childeNode1.zOrder > childeNode2.zOrder) &&
                                !childeNode1.isPhase && !childeNode2.isPhase && !childeNode1.isLane && !childeNode2.isLane) {
                                temp = children[i];
                                children[i] = children[j];
                                children[j] = temp;
                            }
                        }
                    }
                    node.children = children;
                }
            }
        },
        _findCornerNodes: function () {
            var lNode, rNode, tNode, bNode, i, nBounds;
            var list = this.selectionList[0].children;
            var fnode = this.nameTable[this.selectionList[0].children[0]];
            lNode = fnode, rNode = fnode, tNode = fnode, bNode = fnode;
            if (list.length > 1) {
                for (i = 0; i < list.length; i++) {
                    var node = this.nameTable[list[i]];
                    nBounds = ej.datavisualization.Diagram.Util.bounds(node);

                    var rNodeBounds = ej.datavisualization.Diagram.Util.bounds(rNode);
                    if ((nBounds.x + nBounds.width) > (rNodeBounds.x + rNodeBounds.width))
                        rNode = node;

                    var bNodeBounds = ej.datavisualization.Diagram.Util.bounds(bNode);
                    if ((nBounds.y + nBounds.height) > (bNodeBounds.y + bNodeBounds.height))
                        bNode = node;

                    var lNodeBounds = ej.datavisualization.Diagram.Util.bounds(lNode);
                    if (nBounds.x < lNodeBounds.x)
                        lNode = node;

                    var tNodeBounds = ej.datavisualization.Diagram.Util.bounds(tNode);
                    if (nBounds.y < tNodeBounds.y)
                        tNode = node;
                }
            }
            return { left: lNode, right: rNode, top: tNode, bottom: bNode };
        },

        _comparePropertyOnAlign: function (node, diffX, diffY, root) {
            if (node) {
                if (!node.segments) {
                    if (node.offsetX != (node.offsetX + diffX))
                        this._comparePropertyValues(node, "offsetX", { offsetX: node.offsetX + diffX }, null, root);
                    if (node.offsetY != node.offsetY + diffY)
                        this._comparePropertyValues(node, "offsetY", { offsetX: node.offsetY + diffY }, null, root);
                }
                else {
                    this._comparePropertyValues(node, "sourcePoint", { sourcePoint: { x: node.sourcePoint.x + diffX, y: node.sourcePoint.y + diffY } }, root);
                    this._comparePropertyValues(node, "targetPoint", { targetPoint: { x: node.targetPoint.x + diffX, y: node.targetPoint.y + diffY } }, root);
                }
            }
        },

        _moveNode: function (diffX, diffY, node) {
            this._comparePropertyOnAlign(node, diffX, diffY, ej.datavisualization.Diagram.ActionType.Align);
            this._translate(node, diffX, diffY, this.nameTable);
            this._updateNodeMargin(node);
            ej.datavisualization.Diagram.DiagramContext.update(node, this);
        },

        _updateContainerOnNudge: function (node) {
            var parent = this.nameTable[node.parent];
            if (parent && parent.container) {
                ej.datavisualization.Diagram.canvasHelper._updateNodeMargin(this, node, parent);
                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, parent, true);
            }
        },


        _outOfBoundsOnNudge: function (node, ptX, ptY) {
            var lane = this.nameTable[this._getChild(node.parent)];
            if (lane && lane.isLane && lane.parent) {
                var stack = this.nameTable[this._getChild(lane.parent)];
                if (stack && stack.isLaneStack && stack.parent) {
                    var swimlane = this.nameTable[this._getChild(stack.parent)];
                    if (swimlane && this.model.pageSettings.boundaryConstraints != "infinity") {
                        var laneBounds = ej.datavisualization.Diagram.Util.bounds(lane);
                        var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
                        var swmlnBounds = ej.datavisualization.Diagram.Util.bounds(swimlane);
                        var swimRight = swmlnBounds.right;
                        var swimBottom = swmlnBounds.bottom;
                        if ((nodeBounds.bottom + ptY + 20 >= laneBounds.bottom))
                            swimBottom += ptY;
                        if ((nodeBounds.right + ptX + 20 >= laneBounds.right))
                            swimRight += ptX;
                        var size = this.activeTool._getPageBounds();
                        if ((ptY > 0 && swmlnBounds.bottom != swimBottom && swimBottom > size.height) || (ptX > 0 && swmlnBounds.right != swimRight && swimRight > size.width))
                            return false
                    }
                }
            }
            else {
                var tool = this.tools['move'];
                return tool._outOfBoundsDrag(node, ptX, ptY);
            }
            return true;
        },

        _nudge: function (node, x, y, direction, isChild, lastChild) {
            if (node && node.segments && (node.sourceNode && node.targetNode))
                return;
            var proceedY = true, proceedX = true, child;
            var pNode = this.nameTable[node.parent];

            var resource;
            if (this._outOfBoundsOnNudge(node, x, y)) {
                if (!isChild) {
                    if (!node.segments) {
                        var oldValue = (direction === "right" || direction === "left") ? node.offsetX : node.offsetY;
                        var newValue = (direction === "right" || direction === "left") ? node.offsetX + x : node.offsetY + y;
                        var propertyName = (direction === "right" || direction === "left") ? "offsetX" : "offsetY";
                        resource = { element: node, cause: ej.datavisualization.Diagram.ActionType.Nudge, keyCode: direction, propertyName: propertyName, oldValue: oldValue, newValue: newValue };
                        this._raisePropertyChange(resource);
                    }
                    else {
                        resource = {
                            element: node, cause: ej.datavisualization.Diagram.ActionType.Nudge, keyCode: direction, propertyName: "sourcePoint", oldValue: { sourcePoint: node.sourcePoint },
                            newValue: { sourcePoint: { x: node.sourcePoint.x + x, y: node.sourcePoint.y + y } }
                        };
                        this._raisePropertyChange(resource);
                        resource = {
                            element: node, cause: ej.datavisualization.Diagram.ActionType.Nudge, keyCode: direction, propertyName: "targetPoint", oldValue: { targetPoint: node.targetPoint },
                            newValue: { targetPoint: { x: node.targetPoint.x + x, y: node.targetPoint.y + y } }
                        };
                        this._raisePropertyChange(resource);
                    }
                }
                var parent = this.nameTable[node.parent];
                var move
                if (parent && parent.isLane)
                    move = this._moveOnLane(node, parent, x, y);
                if (!proceedY || (move && !move.proceedY))
                    y = 0;
                if (!proceedX || (move && !move.proceedX))
                    x = 0;
                if (node.type == "pseudoGroup") {
                    var children = this._removeContainerConnector(this._getChildren(node.children));
                    children = this._sortByYvalue(children);
                    children = this._sortByXvalue(children);
                    //ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                    for (var i = children.length - 1; i >= 0; i--) {
                        child = this.nameTable[this._getChild(children[i])];
                        if (child) {
                            if (!this._nudge(child, x, y, direction, true, (i === 0))) {
                                break;
                            }
                            this._updateContainerOnNudge(child);
                        }
                    }
                    ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdateNode(this, child);
                    delete this._disableSwimlaneUptate;
                    ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                }
                else {
                    this._translate(node, x, y, this.nameTable);
                    this._updateContainerOnNudge(node);
                }
                this._updateNodeMargin(node);
                if (node.parent) {
                    var parent = this.nameTable[node.parent];
                    if (parent && parent.container) {
                        ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                        this._disablePhaseUpdate = true;
                        this._disableSwimlaneUptate = true;
                        if (parent.container.type === "canvas")
                            ej.datavisualization.Diagram.canvasHelper._updateCollectionChange(this, parent);
                        delete this._disablePhaseUpdate;
                        if (!isChild) {
                            //delete this._disableSwimlaneUptate;
                        }
                        var laneStack = this.nameTable[parent.parent];
                        if (laneStack) {
                            var swimlane = this.nameTable[laneStack.parent];
                            ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, swimlane);
                            if (!isChild) {
                                //delete this._disableSwimlaneUptate;
                                //ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, swimlane);
                            }
                            if (!this._updateSwimlanes) {
                                this._updateSwimlanes = [];
                            }
                            if (!this._collectionContains(swimlane.name, this._updateSwimlanes))
                                this._updateSwimlanes.push(swimlane.name)
                            if (!isChild) {
                                delete this._disableSwimlaneUptate;
                                ej.datavisualization.Diagram.DiagramContext.update(swimlane, this);
                                ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, swimlane, true);

                            }
                        }
                    }
                    if (lastChild && this._updateSwimlanes) {
                        delete this._disableSwimlaneUptate;
                        for (var m = 0; m < this._updateSwimlanes.length; m++) {
                            ej.datavisualization.Diagram.DiagramContext.update(this.nameTable[this._updateSwimlanes[m]], this);
                            ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, this.nameTable[this._updateSwimlanes[m]]);
                        }
                        delete this._updateSwimlanes;
                    }
                }
                else {
                    if (lastChild && this._updateSwimlanes) {
                        for (var m = 0; m < this._updateSwimlanes.length; m++) {
                            ej.datavisualization.Diagram.DiagramContext.update(this.nameTable[this._updateSwimlanes[m]], this);
                            ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, this.nameTable[this._updateSwimlanes[m]]);
                        }
                        delete this._updateSwimlanes;
                    }
                    else
                        ej.datavisualization.Diagram.DiagramContext.update(node, this);
                }
                this._updateSelectionHandle(true);
                return true;
            }
            else return false;
            //ej.datavisualization.Diagram.SvgContext.updateSelector(node, this._svg, this._currZoom, this, this.model.selectedItems.constraints);
        },
        _removeContainerConnector: function (collection) {
            var rCollection = [];
            if (collection && collection.length > 0) {
                for (var i = 0; i < collection.length; i++) {
                    var child = this.nameTable[this._getChild(collection[i])];
                    if (child && !child.segments) {
                        rCollection.push(collection[i]);
                    }
                    else if (child.segments && ((!child.sourceNode && !child.targetNode))) {
                        rCollection.push(collection[i]);
                    }
                }
            }
            return rCollection;
        },
        _moveOnLane: function (node, parent, x, y) {
            var proceedY = false, dx = 0, proceedX = false, dy = 0;
            x = x ? x : 0; y = y ? y : 0;
            if (parent.children && parent.children.length > 0) {
                var header = this.nameTable[this._getChild(parent.children[0])];
                if (header && header.name.indexOf("_Headerr") != -1) {
                    if (parent.orientation === "horizontal") {
                        dx = header.width;
                    }
                    else if (parent.orientation === "vertical") {
                        dy = header.height;
                    }
                }
            }
            if (node && parent) {
                var nBBox = ej.datavisualization.Diagram.Util.bounds(node);
                var gBBox = ej.datavisualization.Diagram.Util.bounds(parent);
                if (nBBox.y + y >= gBBox.y + parent.paddingTop + dy) {
                    proceedY = true;
                }
                if (nBBox.x + x >= gBBox.x + parent.paddingLeft + dx) {
                    proceedX = true;
                }
                return {
                    proceedY: proceedY, proceedX: proceedX,
                    x: (gBBox.x + parent.paddingLeft + dx) - nBBox.x + x,
                    y: (gBBox.y + parent.paddingTop + dy) - nBBox.y + y,
                };
            }
        },
        _selectCommand: function (args) {
            if (this._isEditing) {
                this._endEdit();
                document.getElementById(this._id).focus();
            }
            args.keyDownEventArgs.preventDefault();
            this.selectAll();
        },
        _nudgeCommand: function (args) {
            if (!this._currentState && this.selectionList[0]) { this._currentState = { x: this.selectionList[0].offsetX, y: this.selectionList[0].offsetY }; }
            this.nudge(args.parameter, args.keyDownEventArgs.shiftKey ? 5 : 1);
            args.keyDownEventArgs.preventDefault();
        },
        _startEditCommand: function () {
            if (this.selectionList.length > 0) {
                var shape = this.selectionList[0];
                if (!(shape.type == "pseudoGroup")) {
                    if (shape.type === "text" && this._setLabelEditing(shape.textBlock))
                        this._startEdit(shape);
                    if (shape.isSwimlane) {
                        var header = this.nameTable[shape.name + "_header_swimlane"];
                        if (header)
                            this._startEdit(header);
                    }
                    else if (shape.isLane) {
                        if (shape.children && shape.children.length > 0) {
                            header = this.nameTable[this._getChild(shape.children[0])];
                            if (header)
                                this._startEdit(header);
                        }
                    }
                    else if (shape.type && shape.type === "phase") {
                        var phase = this.nameTable["phaseStack" + shape.name]
                        if (phase)
                            this._startEdit(phase);
                    }
                    else if (shape.labels.length > 0 && this._setLabelEditing(shape.labels[0]))
                        this._startEdit(shape);
                }
            }
        },
        _findObjectByName: function (name) {
            var node = null;
            if (this._findNode(name))
                node = this._findNode(name);
            if (this._findConnector(name))
                node = this._findConnector(name);
            return node;
        },
        _findObjectByIndex: function (index, group) {
            var nodes, findNode = null, node, m, k;
            if (group) {
                var parent = this.nameTable[this.selectionList[0].parent];
                if (parent) {
                    nodes = this._getChildren(parent.children);
                    for (k = 0; k < nodes.length; k++) {
                        node = this.nameTable[nodes[k]];
                        if (node.zOrder === index)
                            findNode = nodes[k];
                    }
                }
            } else {
                for (m = 0; m < this.nodes().length; m++) {
                    node = this.nodes()[m];
                    if (node.zOrder === index && !node._isProcessed) {
                        findNode = node;
                        node._isProcessed = true;
                }
                }
                for (m = 0; m < this.connectors().length; m++) {
                    node = this.connectors()[m];
                    if (node.zOrder === index && !node._isProcessed) {
                        findNode = node;
                        node._isProcessed = true;
                }
            }
            }
            if (typeof (findNode) === "string")
                return this.nameTable[findNode];
            return findNode;
        },
        _findOverlapNode: function (node) {
            var oNodes = [], m, i, rNodes = [];
            if (!node.parent) {
                for (m = 0; m < this.nodes().length; m++) {
                    oNodes.push(this.nameTable[this._getChild(this.nodes()[m])]);
                }
                for (m = 0; m < this.connectors().length; m++) {
                    oNodes.push(this.nameTable[this._getChild(this.connectors()[m])]);
                }
                var nBound = ej.datavisualization.Diagram.Util.bounds(node);
                if (node) {
                    for (i = 0; i < oNodes.length; i++) {
                        var chBound = ej.datavisualization.Diagram.Util.bounds(oNodes[i]);
                        if (node.name !== oNodes[i].name && !(node.children && this._collectionContains(oNodes[i].name, node.children))) {
                            if (this._intersect(nBound, chBound))
                                rNodes.push(oNodes[i]);
                        }
                    }
                }
            } else {
                var nBound = ej.datavisualization.Diagram.Util.bounds(node);
                var parent = this.nameTable[node.parent], child;
                if (parent) {
                    var children = this._getChildren(parent.children);
                    for (m = 0; m < children.length; m++) {
                        if (children[m] !== node.name) {
                            child = this.nameTable[children[m]];
                            var chBound = ej.datavisualization.Diagram.Util.bounds(child);
                            if (child && this._intersect(nBound, chBound))
                                rNodes.push(child);
                        }
                    }
                }
            }
            return rNodes;
        },
        _intersect: function (a, b) {
            return (a.x <= (b.x + b.width) &&
                b.x <= (a.x + a.width) &&
                a.y <= (b.y + b.height) &&
                b.y <= (a.y + a.height));
        },
        _focusToItem: function (args) {
            var nodes = this.nodes(), connectors = this.connectors();
            var index = 0, elements = [], bounds;
            var diagram = this;
            if (nodes.length || connectors.length) {
                if (!this._diagramElements) {
                    elements = this.nodes().concat(this.connectors());
                    elements = this._sortByZIndex(elements, true);
                    elements = elements.map(function (item) { return item.name; })
                    this._diagramElements = elements;
                }
                if (!this._focusedElement && !this.selectionList.length && this._diagramElements.length) {
                    index = args.keyDownEventArgs.shiftKey ? 0 : this._diagramElements.length - 1;
                }
                else {
                    if (!this._focusedElement) {
                        if (this.selectionList[0].type != "pseudoGroup")
                            index = this._diagramElements.indexOf(this.selectionList[0].name);
                        else
                            index = Math.min.apply(Math, this.selectionList[0].children.map(function (child) { return diagram._diagramElements.indexOf(child.name || child); }));
                    }
                    else index = this._diagramElements.indexOf(this._focusedElement);
                }
                do {
                    if (args.keyDownEventArgs.shiftKey)
                        index = index != 0 ? --index : this._diagramElements.length - 1;
                    else
                        index = index != this._diagramElements.length - 1 ? ++index : 0;
                    if (this.nameTable[this._diagramElements[index]].type == "pseudoGroup") continue;
                    this._focusedElement = this._diagramElements[index];
                } while (!ej.datavisualization.Diagram.Util.canSelect(this.nameTable[this._focusedElement]));

                bounds = ej.datavisualization.Diagram.Util.bounds(this.nameTable[this._focusedElement]);
                bounds = { x: bounds.x - 8, y: bounds.y - 8, width: bounds.width + 16, height: bounds.height + 16 };
                this.bringIntoView({ x: bounds.x - 25, y: bounds.y - 25, width: bounds.width + 50, height: bounds.height + 50 });
                ej.datavisualization.Diagram.SvgContext._drawNavigationHighlighter(bounds, this._adornerSvg, this._adornerLayer, this._currZoom);
                args.keyDownEventArgs.preventDefault();
            }
        },
        _selectFocusedItem: function (args) {
            ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this._adornerSvg, this._adornerLayer);
            var element = this.nameTable[this._focusedElement];
            this._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Keydown;
            if (element) this.addSelection(element, true);
            this._diagramElements = null;
            this._focusedElement = null;
            args.keyDownEventArgs.preventDefault();
        },
        //#endregion 
        //#region Rendering
        _createDefaultTooltip: function () {
            var div = document.createElement("div");
            var attr = {
                "id": this.element[0].id + "_DefaulttooltipDiv",
                "class": "e-diagram-tooltip-default",
                "style": "padding-top:3px; height: 24px;pointer-events:none;",
            };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            this._tooltipLayer.appendChild(div);
            if (!this.model.tooltipTemplateId) {
                var span = document.createElement("span");
                attr = { "class": "e-diagram-tooltipLabel-default", "id": "e-diagram-tooltipLabel-default" };
                ej.datavisualization.Diagram.Util.attr(span, attr);
                div.appendChild(span);
            }
            return div;
        },
        _createMouseOverTooltip: function () {
            var div = document.createElement("div");
            var attr = {
                "id": this.element[0].id + "_mouseovertooltipDiv",
                "class": "e-diagram-tooltip-mouseover",
                "style": "pointer-events:none;",
            };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            this._tooltipLayer.appendChild(div);
            return div;
        },
        _renderTooltip: function (object, start) {
            if (!(object.parent && this.nameTable[object.parent] && this.nameTable[object.parent].container)) {
                if (this.model.selectedItems.tooltip) {
                    var tooltipDiv = document.getElementById(this.element[0].id + "_DefaulttooltipDiv");
                    if (!tooltipDiv) {
                        tooltipDiv = this._createDefaultTooltip();
                    }
                    var template;
                    var objectValues;
                    var html;
                    var width;
                    var curZoomfactor = this._currZoom;
                    if (!this.model.selectedItems.tooltip.templateId) {
                        if (start) tooltipDiv.style.width = "150px";
                        width = 150;
                        var span = tooltipDiv.childNodes[0];
                        if (this.activeTool instanceof ej.datavisualization.Diagram.MoveTool) {
                            if (!object.segments)
                                objectValues = "X : " + Math.round((object.offsetX - object.width * object.pivot.x)) + "px  " + "Y : " + Math.round((object.offsetY - object.height * object.pivot.y)) + "px";
                        } else if (this.activeTool instanceof ej.datavisualization.Diagram.ResizeTool) {
                            objectValues = "W : " + Math.round(object.width) + "px  H : " + Math.round(object.height) + "px";
                        } else if (this.activeTool instanceof ej.datavisualization.Diagram.RotateTool) {
                            if (start) tooltipDiv.style.width = "50px";
                            width = 50;
                            objectValues = Math.round(object.rotateAngle) + "\xB0";
                        }
                        if (objectValues) {
                            var obj = this._getTooltipPosition(object, this.model.selectedItems.tooltip);
                            obj.x = -this._hScrollOffset + obj.x * curZoomfactor;
                            obj.y = -this._vScrollOffset + obj.y * curZoomfactor;
                            tooltipDiv.style.top = obj.y + "px";
                            tooltipDiv.style.left = obj.x + "px";
                            tooltipDiv.style.transform = "translate(" + obj.tx + " ," + obj.ty + ")";
                            span.textContent = objectValues;
                        } else {
                            this._removeTooltip();
                        }
                    } else if ($.templates && this.model.selectedItems.tooltip) {
                        if (!object.segments) {
                            var obj = this._getTooltipPosition(object, this.model.selectedItems.tooltip);
                            obj.x = -this._hScrollOffset + obj.x * curZoomfactor;
                            obj.y = -this._vScrollOffset + obj.y * curZoomfactor;
                            tooltipDiv.style.top = obj.y + "px";
                            tooltipDiv.style.left = obj.x + "px";
                            tooltipDiv.style.transform = "translate(" + obj.tx + " ," + obj.ty + ")";
                            template = $.templates("#" + this.model.selectedItems.tooltip.templateId);
                            // objectValues = [{ name: this.activeTool.selectedObject.name, x: (object.offsetX - object.width / 2) + "px", y: (object.offsetY - object.height / 2) + "px", width: object.width + "px", height: object.height + "px", rotationAngle: object.rotateAngle }];
                            html = template.render(object);
                            $(tooltipDiv).html(html);
                        }
                    }
                }
            }
        },
        _removeTooltip: function () {
            var tooltipDiv = document.getElementById(this.element[0].id + "_DefaulttooltipDiv");
            if (tooltipDiv) {
                tooltipDiv.parentNode.removeChild(tooltipDiv);
            }
        },
        _removeMouseOverTooltip: function () {
            var tooltipDiv = document.getElementById(this.element[0].id + "_mouseovertooltipDiv");
            if (tooltipDiv) {
                tooltipDiv.parentNode.removeChild(tooltipDiv);
            }
        },
        _renderCanvas: function (isLoad) {
            this._browserInfo = ej.browserInfo();
            this._canvas = document.getElementById(this.element[0].id + "_canvas");
            if (!this._canvas) {
                this._canvas = document.createElement("div");
                this.element.append(this._canvas);
            }
            this._canvas.setAttribute("id", this.element[0].id + "_canvas");
            if (this._canvas.getAttribute("class") === null || this._canvas.getAttribute("class") === "")
                this._canvas.setAttribute("class", "drawing");
            this._canvas.setAttribute("style", "position:relative; height:" + this.model.height + "; width:" + this.model.width + ";");
            this.element.css({
                overflow: "hidden", outline: "none", display: "block", height: this.model.height, width: this.model.width
            });
            this._views[this._id].canvas = this._canvas;
            this.element[0].setAttribute("tabindex", 0);

            this._renderDiagram(isLoad);
            if (ej.datavisualization.Diagram.Util.canFloatElements(this)) this._setItemDraggable(this._canvas);
        },
        _getDigramBounds: function (mode) {
            var left, top, right, bottom;
            left = this._spatialSearch.pageLeft || 0;
            top = this._spatialSearch.pageTop || 0;
            right = this._spatialSearch.pageRight - this._spatialSearch.pageLeft || 0;
            bottom = this._spatialSearch.pageBottom - this._spatialSearch.pageTop || 0;
            if (mode != "content") {
                if (this.model.pageSettings && this._multiplePage()) {
                    left = this._spatialSearch.pageLeft;
                    top = this._spatialSearch.pageTop;
                    if (this._pageWidth()) {
                        left = Math.floor(left / this._pageWidth()) * this._pageWidth();
                        right = Math.ceil(this._spatialSearch.pageRight / this._pageWidth()) * this._pageWidth() - left;
                    }
                    if (this._pageHeight()) {
                        top = Math.floor(top / this._pageHeight()) * this._pageHeight();
                        bottom = Math.ceil(this._spatialSearch.pageBottom / this._pageHeight()) * this._pageHeight() - top;
                    }
                    if (this._spatialSearch.pageRight === null) {
                        if (this._pageWidth() !== 0) {
                            right = this._pageWidth();
                        }
                    }
                    if (this._spatialSearch.pageBottom === null) {
                        if (this._pageHeight() !== 0) {
                            bottom = this._pageHeight();
                        }
                    }
                }
                else {
                    if (this._pageWidth()) {
                        left = 0;
                        right = this._pageWidth();
                    }
                    if (this._pageHeight()) {
                        top = 0;
                        bottom = this._pageHeight();
                    }
                }
            }
            var svgBounds = new ej.datavisualization.Diagram.Rectangle();
            svgBounds.x = left;
            svgBounds.y = top;
            svgBounds.width = right;
            svgBounds.height = bottom;
            return svgBounds;
        },
        _initContextMenu: function (isLoad) {
            if (this.enableContextMenu()) {
                this._renderContextMenu(isLoad);
            }
            else {
                $("#" + this.element[0].id + "_contextMenu").remove();
            }
        },
        _renderContextMenuItem: function (item) {
            var li = document.createElement("li");
            var a = document.createElement("a");
            var menu = ej.datavisualization.Diagram.Locale[this.locale()];
            if (!menu)
                menu = ej.datavisualization.Diagram.Locale["en-US"];
            a.innerHTML = menu[item.name] || item.text;
            li.setAttribute("id", this.element[0].id + "_contextMenu_" + item.name);
            var div = document.createElement("span");
            div.setAttribute("id", item.name + "_image");
            var imageUrlAttribute = "display:table-cell; vertical-align:middle; text-align:center;"
            if (item.imageUrl)
                imageUrlAttribute = imageUrlAttribute + "background-image: url(" + item.imageUrl + ");width:25px;height:25px";
            div.setAttribute("style", imageUrlAttribute);
            var cssClassAttribute = "sf-d-menuitem " + item.name;
            if (item.cssClass)
                cssClassAttribute = cssClassAttribute + " " + item.cssClass;
            div.setAttribute("class", cssClassAttribute);
            a.appendChild(div);
            if (item.subItems && item.subItems.length > 0) {
                var subUl = document.createElement("ul");
                var i = 0, subli;
                for (i; i < item.subItems.length; i++) {
                    subli = this._renderContextMenuItem(item.subItems[i], subUl);
                    subli.setAttribute("style", "display:block;");
                    subUl.appendChild(subli);
                }
                li.appendChild(subUl);
            }
            li.appendChild(a);
            return li;
        },
        _renderContextMenu: function (isLoad) {
            var menuCollection = $.extend(true, [], this.model.contextMenu.items);
            if (!this.model.contextMenu.showCustomMenuItemsOnly) {
                var additionalItems = [];
                for (var i = 0; i < this._defaultContextMenuItems.length; i++) {
                    var isExist = false;
                    if (this.model.contextMenu.items.length) {
                        for (var j = 0; j < this.model.contextMenu.items.length; j++) {
                            if (this.model.contextMenu.items[j].name === this._defaultContextMenuItems[i].name) {
                                isExist = true;
                                break;
                            }
                            if (j === this.model.contextMenu.items.length - 1 && !isExist) {
                                additionalItems.push(this._defaultContextMenuItems[i])
                            }
                        }
                    }
                    else
                        additionalItems.push(this._defaultContextMenuItems[i])
                }

                for (var i = 0; i < additionalItems.length; i++) {
                    menuCollection.push(additionalItems[i]);
                }
            }

            var i = 0, item, mItem;
            var ul = document.createElement("ul");
            ul.setAttribute("id", this.element[0].id + "_contextMenu");
            for (i = 0; i < menuCollection.length; i++) {
                item = menuCollection[i];
                if (item.templateId) {

                    var temptag = this._renderEjTemplate("#" + item.templateId, item);
                    if (temptag)
                        ul.innerHTML = temptag;
                }
                else {
                    if (item && item.name) {
                        mItem = this._renderContextMenuItem(item, ul);
                        ul.appendChild(mItem);
                    }
                }
            }
            this._canvas.appendChild(ul);
            $("#" + this.element[0].id + "_contextMenu").ejMenu({
                menuType: ej.MenuType.ContextMenu,
                contextMenuTarget: "#" + this.element[0].id + "_canvas",
                click: $.proxy(this._onMenuItemClick, this),
                beforeOpen: $.proxy(this._onContextMenuOpen, this),
                mouseover: $.proxy(this._onMenuItemMouseOver, this),
                mouseout: $.proxy(this._onMenuItemMouseOut, this),
                close: $.proxy(this._onContextMenuClose, this),
            });
            $("#" + this.element[0].id + "_contextMenu")[0].style.display = "none";
        },
        _onContextMenuClose: function () {
            this.element[0].focus();
        },
        _onContextMenuOpen: function (args) {
            if (args.events && !args.events.originalEvent)
                args.events.originalEvent = args.events;
            this.activeTool.mouseup(args.events, true);

            if (this._disableDefaultContextMenu) {
                delete this._disableDefaultContextMenu;
                return false;
            }
            var _id = this.element[0].id;
            var node = this._findNodeUnderMouse(args);
            if (node === null && args.target) {
                if ($(args.target).attr("class") === "segmentEnd" && this.selectionList[0]) {
                    node = this.selectionList[0];
                }
            }
            var isMulSel = false;
            if ($(args.target).parents(".e-scrollbar").length && this.enableContextMenu()) {
                args.cancel = true;
                $("#" + this.element[0].id + "_contextMenu").ejMenu("instance").hideContextMenu();
            }
            if (this.selectionList[0] && (this.selectionList[0].type === "pseudoGroup" || this.selectionList[0]._type === "group"))
                isMulSel = true;
            if (!node && this.selectionList.length > 0 && !isMulSel) {
                this._clearSelection();
            }
            if (this.enableContextMenu()) {
                if ($("#" + _id + "_contextMenu_cut")[0])
                    $("#" + _id + "_contextMenu_cut")[0].style.display = this.selectionList.length ? "block" : "none";
                if ($("#" + _id + "_contextMenu_copy")[0])
                    $("#" + _id + "_contextMenu_copy")[0].style.display = this.selectionList.length ? "block" : "none";
                if ($("#" + _id + "_contextMenu_paste")[0])
                    $("#" + _id + "_contextMenu_paste")[0].style.display = this._clipboardData ? "block" : "none";
                if ($("#" + _id + "_contextMenu_undo")[0])
                    $("#" + _id + "_contextMenu_undo")[0].style.display = this._historyList && this._historyList.canUndo ? "block" : "none";
                if ($("#" + _id + "_contextMenu_redo")[0])
                    $("#" + _id + "_contextMenu_redo")[0].style.display = this._historyList && this._historyList.canRedo ? "block" : "none";
                if ($("#" + _id + "_contextMenu_selectAll")[0])
                    $("#" + _id + "_contextMenu_selectAll")[0].style.display = this.nodes().length + this.connectors().length ? "block" : "none";
                if ($("#" + _id + "_contextMenu_grouping")[0])
                    $("#" + _id + "_contextMenu_grouping")[0].style.display = this.selectionList[0] && (this.selectionList[0].type == "group" ||
                        this.selectionList[0].type == "pseudoGroup") ? "block" : "none";
                if ($("#" + _id + "_contextMenu_order")[0])
                    $("#" + _id + "_contextMenu_order")[0].style.display = this.selectionList.length ? "block" : "none";
            }
            var obj = ({ diagram: this, contextmenu: args });
            obj.target = this.selectionList.length ? this.selectionList[0] : this.activeTool.prevSelectObject ? this.activeTool.prevSelectObject : this;
            this._trigger("contextMenuBeforeOpen", obj);
            if (this.enableContextMenu()) {
                $("#" + _id + "_contextMenu")[0].style.display = "block";
                if ($("#" + _id + "_contextMenu")[0].clientHeight <= 2) args.cancel = true;
                $("#" + _id + "_contextMenu")[0].style.display = "none";
            }
            
        },
        _onMenuItemClick: function (args) {
            var menuId = args.events.ID.replace(this._id + "_" + "contextMenu_", "");
            args.canExecute = true;
            args.target = this.selectionList.length ? this.selectionList[0] : this.activeTool.prevSelectObject ? this.activeTool.prevSelectObject : this;
            this._trigger("contextMenuClick", args);
            if (args.canExecute) {
                switch (menuId) {
                    case "cut":
                        this.cut();
                        break;
                    case "copy":
                        this.copy();
                        break;
                    case "paste":
                        this.paste();
                        break;
                    case "undo":
                        this.undo();
                        break;
                    case "redo":
                        this.redo();
                        break;
                    case "selectAll":
                        this.selectAll();
                        break;
                    case "group":
                        this.group();
                        break;
                    case "ungroup":
                        this.ungroup();
                        break;
                    case "bringToFront":
                        this.bringToFront();
                        break;
                    case "sendToBack":
                        this.sendToBack();
                        break;
                    case "moveForward":
                        this.moveForward();
                        break;
                    case "sendBackward":
                        this.sendBackward();
                        break;
                    default:
                        break;
                }
            }
        },
        _onMenuItemMouseOver: function (args) {
            var t = args.events.element.lastChild.childNodes[1];
            $(t).addClass("hover");
        },
        _onMenuItemMouseOut: function (args) {
            var t = args.events.element.lastChild.childNodes[1];
            $(t).removeClass("hover");
        },
        _renderDiagram: function (isload) {
            var diagram = this;
            this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            this._doLayout();
            this._views.forEach(function (viewid) {
                var view = diagram._views[viewid];
                if (view.type == "mainview" && view.context == ej.datavisualization.Diagram.SvgContext) {
                    view.context._renderDocument(view, diagram, isload);
                    diagram._createScrollbar(diagram._canvas);
                    ej.datavisualization.Diagram.ScrollUtil._initScrollbar(diagram);
                    ej.datavisualization.Diagram.PageUtil._updatePageSize(diagram);
                }
                if (!isload) {
                    var nodes = diagram._setNodeZOrder(view);
                    diagram._renderDiagramObjects(nodes, view);
                }
            });
            $(this._svg.document).pinchDiagram(this._view, this);
        },
        _createScrollbar: function (canvas) {
            var hScrollbar = document.createElement("div");
            hScrollbar.setAttribute("id", canvas.id + "_hScrollbar");
            if (!document.getElementById(canvas.id + "_hScrollbar"))
                canvas.appendChild(hScrollbar);
            var vScrollbar = document.createElement("div");
            vScrollbar.setAttribute("id", canvas.id + "_vScrollbar");
            if (!document.getElementById(canvas.id + "_vScrollbar"))
                canvas.appendChild(vScrollbar);
        },
        _disableScrollbar: function () {
            if (this._isMobile) {
                $("#" + this._hScrollbar._id).addClass("e-disable").attr({ "aria-disabled": true, "style": "display: none;" });
                $("#" + this._vScrollbar._id).addClass("e-disable").attr({ "aria-disabled": true, "style": "display: none;" });
            }
        },
        _doLayout: function () {
            if (this.model.layout && this._layoutType() !== ej.datavisualization.Diagram.LayoutTypes.None) {
                //this.model.layout = new ej.datavisualization.Diagram.HierarchicalLayout(this.model.layout);
                //this.model.layout._setModel(this);
                this._updateEdgeCollection();
                ej.datavisualization.Diagram.Layout.doLayout(this);
                //this.model.layout.doLayout(this);
            }
        },
        _updateNodes: function () {
            var nodes = this.nodes();
            for (var i = 0; i < nodes.length; i++) {
                ej.datavisualization.Diagram.DiagramContext.update(nodes[i], this);
            }
        },
        _updateConnectors: function () {
            var connections = this.connectors();
            for (var i = 0; i < connections.length; i++) {
                ej.datavisualization.Diagram.DiagramContext.update(connections[i], this);
            }
        },
        _updateEdgeCollection: function () {
            for (var i = 0; i < this.connectors().length; i++) {
                this._updateEdges(this.connectors()[i]);
            }
        },
        updateViewPort: function () {
            this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            ej.datavisualization.Diagram.DiagramContext.updateViewPort(this);
            this.model.scrollSettings.viewPortHeight = this._viewPort.height;
            this.model.scrollSettings.viewPortWidth = this._viewPort.width;
            var diagram = this;
            this._views.forEach(function (viewid) {
                var view = diagram._views[viewid];
                if (view.type == "overview") {
                    var ovw = $("#" + viewid).ejOverview("instance");
                    if (ovw)
                        ovw._scrollOverviewRect(diagram._hScrollOffset, diagram._vScrollOffset, diagram._currZoom);
                }
            });
        },
        _containsSameIndex: function (index, parent) {
            if (!parent) {
                var nodes = this.nodes(), cNode;
                for (var i = 0; i < nodes.length > 0; i++) {
                    cNode = nodes[i];
                    if (cNode && cNode.zOrder === index)
                        return true;
                }
                var connectors = this.connectors(), cConnector;
                for (var i = 0; i < connectors.length > 0; i++) {
                    cConnector = connectors[i];
                    if (cConnector && cConnector.zOrder === index)
                        return true;
                }
            }
            else {
                var children = parent.children, child;
                for (var i = 0; i < children.length; i++) {
                    child = this.nameTable[this._getChild(children[i])];
                    if (child && child.zOrder) {
                        if (child.zOrder === index)
                            return true;
                    }
                }
            }
            return false;
        },
        _setZorder: function (node) {
            if (node && node.zOrder) {
                if (node.zOrder == -1) {
                    if (this._containsSameIndex(this._zOrder)) {
                        do {
                            this._zOrder++;
                        } while (this._containsSameIndex(this._zOrder));
                        node.zOrder = this._zOrder;
                    }
                    else {
                        node.zOrder = this._zOrder;
                        this._zOrder++;
                    }
                }
                else {
                }
                if (node._type === "group") {
                    var children = node.children, child;
                    for (var i = 0; i < children.length; i++) {
                        child = this.nameTable[this._getChild(children[i])];
                        if (child && child.zOrder && child.zOrder === -1) {
                            this._setZorder(child);
                        }
                    }
                }
            }
        },
        _union: function (rect1, rect2) {
            var x = Math.min(rect1.x, rect2.x);
            var y = Math.min(rect1.y, rect2.y);
            var overWidth = Math.max(rect1.x + rect1.width, rect2.x + rect2.width);
            var overheight = Math.max(rect1.y + rect1.height, rect2.y + rect2.height);
            return new ej.datavisualization.Diagram.Rectangle(x, y, overWidth - x, overheight - y);
        },
        _getSeperetor: function (id) {
            return this.nameTable[id];
        },

        _updateNextPhase: function (swimlane, dif, index) {
            ej.datavisualization.Diagram.SwimLaneContainerHelper._updateNextPhase(this, swimlane, dif, index);
        },

        _getOuterNodes: function (swimlane, x, y) {
            return ej.datavisualization.Diagram.SwimLaneContainerHelper._getOuterNodes(this, swimlane, x, y);
        },

        _getInnerNodes: function (swimlane, value1, value2) {
            return ej.datavisualization.Diagram.SwimLaneContainerHelper._getInnerNodes(this, swimlane, value1, value2);
        },

        _moveOuterNodes: function (swimlane, dif, index) {
            return ej.datavisualization.Diagram.SwimLaneContainerHelper._moveOuterNodes(this, swimlane, dif, index);
        },

        _moveOnPhaseChange: function (phase, dif, index) {
            ej.datavisualization.Diagram.SwimLaneContainerHelper._moveOnPhaseChange(this, phase, dif, index);
        },

        _getPhaseDifferece: function (swimlane, index, difference) {
            return ej.datavisualization.Diagram.SwimLaneContainerHelper._getPhaseDifferece(this, swimlane, index, difference);
        },

        _updatePhaseOffset: function (obj) {
            var node = this.nameTable[obj.name], phase, dif;
            var phaseStack = this.nameTable[node.parent];
            var children = this._getChildren(phaseStack.children);
            var index = children.indexOf(node.name);
            if (children && children.length > 0) {
                if (index > -1 && obj.offset != undefined) {
                    phase = this.nameTable[children[index]];
                    dif = obj.offset - node.offset;
                    var swimlane = this.nameTable[phaseStack.parent]
                    dif = this._getPhaseDifferece(swimlane, index, dif);
                    this._moveOuterNodes(swimlane, dif, index);
                    if (index === 0) {
                        if (node.orientation === "horizontal") {
                            node.width += dif;
                            node.offset = node.width;
                            this._comparePropertyValues(swimlane, "offsetX", { offsetX: swimlane.offsetX + (dif / 2) }, this.activeTool.inAction);
                        }
                        else {
                            node.height += dif;
                            node.offset = node.height;
                            this._comparePropertyValues(swimlane, "offsetY", { offsetY: swimlane.offsetY + (dif / 2) }, this.activeTool.inAction);
                        }
                    }
                    else {
                        if (node.orientation === "horizontal") {
                            node.width += dif;
                            node.offset += dif;
                            this._comparePropertyValues(swimlane, "offsetX", { offsetX: swimlane.offsetX + (dif / 2) }, this.activeTool.inAction);
                        }
                        else {
                            node.height += dif;
                            node.offset += dif;
                            this._comparePropertyValues(swimlane, "offsetY", { offsetY: swimlane.offsetY + (dif / 2) }, this.activeTool.inAction);
                        }
                    }
                    this._disablePhaseUpdate = true;
                    this._disableSwimlaneUptate = true;
                    ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                    this._moveOnPhaseChange(node, dif, index);
                    this._updateNextPhase(swimlane, dif, index);
                    delete this._disablePhaseUpdate;
                    delete this._disableSwimlaneUptate;
                    ej.datavisualization.Diagram.DiagramContext.update(swimlane, this);
                    ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, swimlane);
                }
            }
        },
        _updatePhase: function (obj) {
            var node = this.nameTable[obj.name], phase, prevPhase, dif;
            if (node) {
                if ((node.offset != undefined && obj.offset != undefined) && obj.offset != node.offset) {
                    this._comparePropertyValues(node, "offset", { offset: obj.offset }, this.activeTool.inAction);
                    this._updatePhaseOffset(obj);
                    if (this._hasSelection())
                        this._clearSelection(true);
                }
                this._updateSwimlanePhase(node, obj);
            }
        },

        _setNodeZOrder: function (view) {
            var temp = null, jindex, iindex;
            var nodes = this.nodes();
            nodes = nodes.concat(this.connectors());
            for (var f = 0; f < nodes.length; f++) {
                if (nodes[f].parent === "")
                    this._setZorder(nodes[f]);
            }
            for (var i = 0; i < nodes.length; i++) {
                for (var j = i + 1; j < nodes.length; j++) {
                    if (nodes[i].zOrder > nodes[j].zOrder && (nodes[i].parent === "" && nodes[j].parent === "")) {
                        temp = nodes[i];
                        nodes[i] = nodes[j];
                        nodes[j] = temp;
                    }
                }
                if (nodes[i]._type === "group") {
                    var children = nodes[i].children;
                    if (!nodes[i].isSwimlane) {
                        for (var m = 0; m < children.length; m++) {
                            for (var n = m + 1; n < children.length; n++) {
                                var child1 = typeof (children[m]) === "object" ? children[m] : this.nameTable[children[m]];
                                var child2 = typeof (children[n]) === "object" ? children[n] : this.nameTable[children[n]];
                                if (child1.zOrder > child2.zOrder && !child1.isPhase && !child2.isPhase && !child1.isLane && !child2.isLane) {
                                    temp = children[m];
                                    children[m] = children[n];
                                    children[n] = temp;
                                }
                            }
                        }
                    }
                }
            }
            return nodes;
        },
        _renderDiagramObjects: function (nodes, view, isLoad, isoverView) {
            for (var i = 0, len = nodes.length; i < len; ++i) {
                if (this.getObjectType(nodes[i]) === "node" || this.getObjectType(nodes[i]) === "group") {
                    var node = this.nameTable[nodes[i].name];
                    if (this._isLoad)
                        this._disableSegmentChange = true;
                    ej.datavisualization.Diagram.DiagramContext._renderNodeObject(node, view, isLoad, isoverView, this)
                    if (this._isLoad)
                        delete this._disableSegmentChange;
                }
                else {
                    var connector = this.nameTable[nodes[i].name] || nodes[i];
                    ej.datavisualization.Diagram.DiagramContext._renderConnectorObject(connector, view, this);
                }
            }
        },

        _unWireEvents: function () {
            var svgDocument = $(this._canvas);
            this._off(svgDocument, ej.eventType.mouseDown, this._mousedown);
            this._off(svgDocument, ej.eventType.mouseMove, this._mousemove);
            this._off(svgDocument, ej.eventType.mouseUp, this._mouseup);
            this._off(svgDocument, ej.eventType.mouseLeave, this._documentmouseup);
            this._off(svgDocument, "doubletap", this._doubleclick);
            this._off(this.element, "keydown", this._keydown);
            this._off(this.element, "keyup", this._keyup);
            //this._on(this.element, "contextmenu", this._contextmenu);
            this._off(svgDocument, "pinchin", this._pinchin);
            this._off(svgDocument, "pinchout", this._pinchout);
            this._off(this.element, "touchstart", this._handleTouchStart);
            if (ej.browserInfo().name === "mozilla") {
                this._off(this.element, "DOMMouseScroll", this._handleMouseWheel);
            }
            else
                this._off(this.element, "mousewheel", this._handleMouseWheel);
            //window document event
            this._off($(document), "mouseup", this._documentmouseup);

            if (window && (this.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.Resizable)) {
                this._off($(window), "resize", this.updateViewPort);
            }
        },

        //#endregion
        //#region Events
        _wireEvents: function () {
            //svg document events
            var svgDocument = $(this._canvas);
            this._on(svgDocument, ej.eventType.mouseDown, this._mousedown);
            this._on(svgDocument, ej.eventType.mouseMove, this._mousemove);
            this._on(svgDocument, ej.eventType.mouseUp, this._mouseup);
            this._on(svgDocument, ej.eventType.mouseLeave, this._documentmouseup);
            this._on(svgDocument, "doubletap", this._doubleclick);
            this._on(this.element, "keydown", this._keydown);
            this._on(this.element, "keyup", this._keyup);
            this._on(this.element, "contextmenu", this._preventDefaultContextMenu);
            //this._on(this.element, "contextmenu", this._contextmenu);
            this._on(svgDocument, "pinchin", this._pinchin);
            this._on(svgDocument, "pinchout", this._pinchout);
            this._on(this.element, "touchstart", this._handleTouchStart);
            if (ej.browserInfo().name === "mozilla") {
                this._on(this.element, "DOMMouseScroll", this._handleMouseWheel);
            }
            else
                this._on(this.element, "mousewheel", this._handleMouseWheel);
            //window document event
            this._on($(document), "mouseup", this._documentmouseup);

            if (window && (this.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.Resizable)) {
                this._on($(window), "resize", this.updateViewPort);
            }
            var obj = this;
            $(svgDocument).ejDroppable({
                over: function (event, ui) {
                    obj._isDropOver = true;
                    var isTouch = false;
                    if (event.originalEvent && event.originalEvent.changedTouches) {
                        isTouch = true;
                    }
                    else if (event && event.changedTouches) {
                        isTouch = true;
                    }
                    if (!isTouch) {
                        if ((obj.activeTool.inAction === false) && obj._selectedSymbol) {
                            if (!obj._viewPort) obj._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(obj, true);
                            obj._addSymbolToDiagram(event);
                            obj._isSvgDropover = true;
                        }
                    }
                },
                out: function (event) {
                    delete obj._isDropOver;
                },
                drop: function (event, ui) {
                    obj._svgdrop(event, ui);
                    obj._isDropped = true;
                },
            });
        },
        _preventDefaultContextMenu: function (e) {
            if (this._disableDefaultContextMenu) {
                e.preventDefault();
                e.stopPropagation();
                delete this._disableDefaultContextMenu;
                return false;
            }
        },
        _mousePosition: function (evt, exOffset) {
            var e = this._isTouchEvent(evt);
            var scrollLeft = this._scrollLeft !== undefined ? this._scrollLeft : this._canvas.scrollLeft;
            var scrollTop = this._scrollTop !== undefined ? this._scrollTop : this._canvas.scrollTop;
            var controlBBox = this._controlBBox ? this._controlBBox : this._canvas.getBoundingClientRect();
            var layerx = (e.clientX + scrollLeft) - controlBBox.left;
            var layery = (scrollTop + e.clientY) - controlBBox.top;
            if (!exOffset) {
                layerx = (layerx + this._hScrollOffset) / this._currZoom;
                layery = (layery + this._vScrollOffset) / this._currZoom;
            }
            return new ej.datavisualization.Diagram.Point(Math.round(layerx * 100) / 100, Math.round(layery * 100) / 100);
        },
        _contextmenu: function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
        },
        _pinchin: function (evt) {
            this._getTouchEvent(evt);
            evt.preventDefault();
        },
        _pinchout: function (evt) {
            this._getTouchEvent(evt);
            evt.preventDefault();
        },
        _handleTouchStart: function (evt) {
            this._getTouchEvent(evt);
            evt.preventDefault();
        },

        _getTouchEvent: function (evt) {
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend")
                this._isTouchedEvent = true;
            else
                this._isTouchedEvent = false;
        },
        _mousedown: function (evt) {
            this._getTouchEvent(evt);
            this._isPinching = false;
            this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            this._diagramElements = null;
            ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this._adornerSvg, this._adornerLayer);
            if (this._invoke(evt)) {
                this._scrollLeft = this._canvas.scrollLeft;
                this._scrollTop = this._canvas.scrollTop;
                this._controlBBox = this._canvas.getBoundingClientRect();
                var position = this._mousePosition(evt);
				var foreignObject = this._isForeignObject(evt.originalEvent.target);
                if ((!foreignObject && !this._isHyperLink(evt)) || this._isForeignEvent(evt))
                    evt.preventDefault();
                if (this.model.contextMenu && $("#" + this.element[0].id + "_contextMenu").css("display") !== "none") {
                    evt.cancel = true;
                }
                if (this._isEditing) {
                    this._endEdit();
                    if (this.activeTool.name === "textTool") {
                        if (this.activeTool.singleAction) {
                            this.activeTool.diagram.deactivateTool();
                        }
                    }
                }
                if ((evt.which === 1 || evt.which === 3) || (evt.which === 0 && evt.originalEvent.changedTouches)) {
                    this._removeMouseOverTooltip();
                    if (evt.which === 0 && evt.originalEvent.changedTouches) {
                        var node = null;
                        var isUserHandle = this._isUserHandle(evt);
                        if ((this._isInternalTool(this.activeTool) && !this.activeTool.inAction)) {
                            if (!isUserHandle) {
                                node = this._findNodeUnderMouse(evt);
                                this._raiseMouseEvents(node, position);
                            }
                            if (!node && this.selectionList[0]) {
                                node = this.selectionList[0];
                            }
                            if (ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                                this._checkToolToActivate(evt, node);
                            }
                        }
                    }
                    if ((navigator.platform.match("Mac") ? evt.metaKey : evt.ctrlKey) && evt.shiftKey) {
                        node = this._findNodeUnderMouse(evt);
                        if (!node && this.selectionList[0]) {
                            node = this.selectionList[0];
                        }
                        this._checkToolToActivate(evt, node);
                    }
                    if (this._toolToActivate === "panTool") {
                        this.activeTool = this.tools[this._toolToActivate];
                    }
                    else {
                        if (this._toolToActivate === "move") {
                            node = this._findNodeUnderMouse(evt);
                            if (node && node.isLane && ej.datavisualization.Diagram.Util.canMultiSelectOnLane(node)) {
                                this._toolToActivate = "select";
                                this._currentCursor = "default";
                                this._updateCursor();
                            }
                        }
                        var tool = this.tools[this._toolToActivate] || this.activeTool;
                        this.activateTool(this._toolToActivate, tool ? tool.singleAction : null);
                    }
                    this.activeTool.mousedown(evt);
                        this._focusedElement = this.activeTool._findNodeUnderMouse(evt, true);
                }
            }
        },
        _mousemove: function (evt) {
            this._getTouchEvent(evt);
            this._mouseEventTriggered = true;
            if (!this._viewPort) this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            if (evt.type == "touchmove" && evt.originalEvent.touches.length > 1) {
                this._isPinching = true;
            } else {
                this._isPinching = false;
                var node = null;
                var isUserHandle = this._isUserHandle(evt);
                if ((this.activeTool.inAction === false) && this._selectedSymbol) {
                    this._addSymbolToDiagram(evt);
                } else {
                            if (ej.datavisualization.Diagram.Util.isClassifier(evt))
                                var node = ej.datavisualization.Diagram.ClassifierHelper.getSelectableElementUnderMouse(evt, this);
                            else
                                node = this._findNodeUnderMouse(evt)
                    if ((this._isInternalTool(this.activeTool) && !this.activeTool.inAction)) {
                        if (!isUserHandle) {
                            if (node) {
                                if (this._nodeUnderMouse && this._nodeUnderMouse != node && !this._nodeUnderMouse.segments) {
                                    this.activeTool._showPort(this._nodeUnderMouse, true);
                                }
                                if (!node.segments) {
                                    this.activeTool._showPort(node);
                                }
                            }
                            //this._raiseMouseEvents(node);
                        }
                        if (!node && this.selectionList[0]) {
                            node = this.selectionList[0];
                        }
                        if (ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                            this._checkToolToActivate(evt, node);
                        }
                        if (evt.which == 1 && evt.buttons == 1)
                            this._focusedElement = this.activeTool._findNodeUnderMouse(evt, true);
                    } else {
                        var canProceed = true;
                        if (this._activatedFromPort && !this.activeTool.inAction) {
                            var point, port = null;
                            if (this._nodeUnderMouse && !this._nodeUnderMouse.segments) {
                                point = this._mousePosition(evt);
                                port = this._findPortAtPoint(point, this._nodeUnderMouse);
                            }
                            if (!port || (port && !(port.constraints & ej.datavisualization.Diagram.PortConstraints.ConnectOnDrag))) {
                                ej.datavisualization.Diagram.SvgContext._removePortHighlighter(this._adornerSvg, this._adornerLayer);
                                this.deactivateTool();
                                canProceed = false;
                                delete this._activatedFromPort;
                            }
                        }
                        if (canProceed) {
                        if (!this.activeTool.inAction) {
                            this._toolToActivate = this.activeTool.name;
                            this._currentCursor = this.activeTool.cursor;
                        }
                        if (ej.datavisualization.Diagram.Util.isClassifier(evt))
                            nodeUnderMouse = ej.datavisualization.Diagram.ClassifierHelper.getDropableElementUnderMouse(evt, this);
                        else
                            nodeUnderMouse = this._findNodeUnderMouse(evt);
                        if (node) {
                            //this._raiseMouseEvents(node);
                        }
                    }
                    }
                    this._updateCursor();
                    var nodeUnderMouse = nodeUnderMouse || this._findNodeUnderMouse(evt);
                    this.activeTool.mousemove(evt);
                    // var position = this._mousePosition(evt);
                    this._raiseMouseEvents(nodeUnderMouse, evt);
                    var canAvoidConnection = false;
                    if (this.activeTool.inAction) {
                        do {
                            if (nodeUnderMouse && !ej.datavisualization.Diagram.Util.canAllowDrop(nodeUnderMouse)) {
                                if (nodeUnderMouse.parent) nodeUnderMouse = this.nameTable[nodeUnderMouse.parent];
                                else
                                    if (nodeUnderMouse.segments)
                                    { canAvoidConnection = true; break; }
                                    else if (nodeUnderMouse.container) {
                                        break;
                                    }
                                    else
                                        nodeUnderMouse = null;
                            }
                            else break;
                        } while (nodeUnderMouse);
                        if (this._nodeUnderMouse && this._nodeUnderMouse.segments && this._nodeUnderMouse != nodeUnderMouse)
                            ej.datavisualization.Diagram.SvgContext._removeConnectorHighlighter(this._adornerLayer, this._adornerSvg);
                        if (nodeUnderMouse && ((nodeUnderMouse != this._focusedElement && nodeUnderMouse != this.nodeUnderMouse) &&
                            (canAvoidConnection || ej.datavisualization.Diagram.Util.canAllowDrop(nodeUnderMouse)))) {
                            var type = this.getObjectType(nodeUnderMouse);
                            if (!((this._focusedElement && (this._focusedElement.isLane || this._focusedElement.isSwimlane || this._focusedElement.isPhase)) && type == "node" && type == "connector")) {
                                if (!((this._nodeUnderMouse && (this._nodeUnderMouse.isLane || this._nodeUnderMouse.isSwimlane || this._nodeUnderMouse.isPhase))
                                    && nodeUnderMouse.segments)) {
                                    this._nodeUnderMouse = nodeUnderMouse;
                                }
                            }
                            else this._nodeUnderMouse = null;
                        }
                        else if (nodeUnderMouse && nodeUnderMouse.container)
                        { }
                        else
                            this._nodeUnderMouse = null;
                    } else if (!this._focusedElement)
                        this._nodeUnderMouse = nodeUnderMouse;
                    this._initiateAutoScroll(evt);
                }
            }
        },
        _mouseup: function (evt) {
            this._getTouchEvent(evt);
            if (!this._isPinching && evt.originalEvent && evt.originalEvent.target) {
                if (this._invoke(evt)) {
                    var foreignObject = this._isForeignObject(evt.originalEvent.target);
                    if (!foreignObject && this._isHyperLink(evt))
                        evt.preventDefault();
                    if (this.activeTool instanceof ej.datavisualization.Diagram.PanTool) {
                        document.onmousemove = null;
                        document.onmouseup = null;
                        if ((!ej.datavisualization.Diagram.Util.isPageEditable(this) || this.activeTool instanceof ej.datavisualization.Diagram.PanTool) && !this.activeTool.inAction) {
                            var obj = this.activeTool._findNodeUnderMouse(evt);
                            if (obj)
                                this._raiseEvent("itemClick", { actualObject: obj, selectedObject: obj, model: this.model, cancel: false, event: evt });
                            var mousePosition = this._mousePosition(evt.originalEvent);
                            this._raiseEvent("click", { element: obj, actualObject: this.getNode(this.activeTool.actualObject), count: this._getEventDetail(evt), offsetX: mousePosition.x, offsetY: mousePosition.y, event: evt });
                            if (this.activeTool instanceof ej.datavisualization.Diagram.PanTool) {
                                document.onmousemove = null;
                                document.onmouseup = null;
                            }
                        }
                    } else if (evt.target.id === this._id + "_canvas_svg" && (!this.activeTool.name == "panTool" || !this.activeTool.inAction)) {
                        var mousePosition = this._mousePosition(evt.originalEvent);
                        this._raiseEvent("click", { element: this, actualObject: this.getNode(this.activeTool.actualObject), count: this._getEventDetail(evt), offsetX: mousePosition.x, offsetY: mousePosition.y, event: evt });
                    }
                    if (evt.target && !this._isAnimating) {
                        var parent = $(evt.target).parents(".ej-d-icon-template");
                        if (parent) {
                            if (parent.length) {
                                var target = parent[0];
                                if (target.id.endsWith("_expander")) {
                                    var id = target.id.replace("_expander", "");
                                    var obj = this.nameTable[id];
                                    if (obj) {
                                        var type = this.getObjectType(obj);
                                        if (type == "node" || type == "group") {
                                            this.clearSelection();
                                            ej.datavisualization.Diagram.LayoutUtil.expandSubTree(this, obj, obj.name, true, ej.datavisualization.Diagram.Util.canSelect(obj));
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (this._selectedSymbol && !this._selectedSymbol.isLane && !this._isNodeEnters) {
                        this._findLabelEditing = true;
                        this._dropSymbol(null, evt);
                        delete this._findLabelEditing;
                        this._isDragg = true;
                    }
                    else if (this._selectedSymbol && this._isNodeEnters) {
                        var element = this.findNode(this.selectionList[0].name);
                        if (this.edgeTable)
                            delete this.edgeTable;
                        else {
                            var childTable = {};
                            childTable = this._getChildTable(this.selectionList[0], childTable);
                            if (this._selectedSymbol.type == "pseudoGroup")
                                var entry = { type: "collectionchanged", object: this._updatePsedoGroupChildren(this._selectedSymbol), childTable: jQuery.extend(true, {}, childTable), changeType: "insert", category: "internal" };
                            else if (!this._selectedSymbol.isPhase)
                                var entry = { type: "collectionchanged", object: jQuery.extend(true, {}, this._selectedSymbol), childTable: jQuery.extend(true, {}, childTable), changeType: "insert", category: "internal" };
                            this.addHistoryEntry(entry);
                            this._isDragg = true;
                        }
                        this._clearSelection(true);
                        this._selectedSymbol = null;
                        delete this._isNodeEnters;

                        if (element.type == "pseudoGroup") {
                            this.nodes().push(element);
                            this._nodes = $.extend(true, [], this.nodes());
                            this.nameTable[element.name] = element;
                            ej.datavisualization.Diagram.Util._updateGroupBounds(element, this);
                        }
                        this._addSelection(element);
                    }
                    if (ej.browserInfo().name === "msie" && this._doubleClickEvent)
                        this.activeTool._isMouseDown = true;
                    this.activeTool.mouseup(evt);
                    if ((!(this.activeTool instanceof ej.datavisualization.Diagram.TextTool)) && document.activeElement && document.activeElement.id !== this.element[0].id)
                        if (!this._isEditing && !foreignObject && !(evt.which===3 && this.enableContextMenu()))
                            this.element[0].focus();
                    this._currentCursor = this.activeTool.cursor;
                    if (this.activeTool.name === "move" && this._focusedElement && !ej.datavisualization.Diagram.Util.canSelect(this._focusedElement)) {
                        this._currentCursor = "default"
                        this._updateCursor();
                    }
                    else
                        this._updateCursor();
                }
            }
            if (this._isSvgDropover) {
                $("#" + this.element[0].id + "_canvas").ejDroppable("instance")._mouseOver = false;
            }
            delete this._isSvgDropover;
            this._focusedElement = null;
            this._nodeUnderMouse = this._findNodeUnderMouse(evt);
            delete this._scrollLeft;
            delete this._scrollTop;
            delete this._controlBBox;
            this._mouseEventTriggered = false;
            this._isDragg = false;
            delete this._viewPort;
            delete this._isDropOver;
            this._timeStamp = evt.timeStamp;
        },
        _doubleclick: function (evt) {
            this._getTouchEvent(evt);
            this._doubleClickEvent = !this._doubleClickEvent;
            var args;
            var obj = this._nodeUnderMouse || this;
            args = { element: this.getNode(obj), cancel: false, actualObject: this.getNode(this.activeTool.actualObject) }
            if (!this._isEditing)
                this._raiseEvent("doubleClick", args);
            var preventEditing = this.activeTool._drawingPolygon;
            if (this.activeTool.name != "panTool") {
                if (this._nodeUnderMouse)
                    this.activeTool._doubleClick(this._nodeUnderMouse);
                if (ej.datavisualization.Diagram.Util.isClassifier(evt))
                    var editableElement = ej.datavisualization.Diagram.ClassifierHelper.getEditableElementUnderMouse(evt, this);
                if (ej.datavisualization.Diagram.Util.isPageEditable(this) && !this.activeTool.inAction && (((this.selectionList.length > 0) || editableElement) || this.activeTool.selectedObject) && !args.cancel && !preventEditing) {
                    if (this.activeTool.selectedObject)
                        var obj = this.activeTool.selectedObject;
                    else if (this.selectionList[0])
                        var obj = this.selectionList[0];
                    else
                        obj = editableElement;
                    if (obj.type == "umlclassifier") {
                        for (var i = 0; i < obj.children.length; i++) {
                            obj.children[i] = typeof obj.children[i] == "string" ? this.nameTable[obj.children[i]] : obj.children[i];
                            if (i != obj.children.length - obj.children.length && i == obj.children.length - 1)
                                obj.children[i].labels[0].text = "\n" + "---" + "\n" + obj.children[i].labels[0].text;
                            if (i != obj.children.length - obj.children.length && i == obj.children.length - 2)
                                obj.children[i].labels[0].text = "\n" + "---" + "\n" + obj.children[i].labels[0].text;
                            obj.labels[0].text += obj.children[i].labels[0].text;
                        }
                    }
                    if (!this._isEditing && !(obj.type == "pseudoGroup") && !args.cancel) {
                        this.activeTool._findLabelUnderMouse(evt, false, this._mousePosition(evt.originalEvent), true);
                        if (obj.labels && obj.labels.length > 0) {
                            var label = this.activeTool.getLabelUnderMouse();
                            if (!label) label = obj.labels[0];
                        }
                        if (!this._isEditing && obj.type === "text" && this._setLabelEditing(obj.textBlock)) {
                            this.scrollToNode(obj);
                            this._startEdit(obj);
                        }
                        else if (!this._isEditing && !obj.isLane && !obj.isSwimlane && (obj.labels && (obj.labels.length === 0 || typeof obj.labels.length === "undefined") || (obj.labels && obj.labels.length > 0 && this._setLabelEditing(label)))) {
                            this.scrollToNode(obj);
                            this._startEdit(obj);
                        }
                        else if (obj.isLane && (obj.labels && obj.labels.length > 0 && this._setLabelEditing(label))) {
                            if (obj.labels && obj.labels.length > 0) {
                                this.scrollToNode(obj);
                                this._startEdit(obj);
                            }
                            else
                                this.activeTool.selectedObject = null;
                        }
                        else if (obj.isLane) {
                            this.activeTool.selectedObject = null;
                        }
                    }
                }
            }
            this.activeTool._isMouseDown = false;
        },
        _documentmouseup: function (evt) {
            this._getTouchEvent(evt);
            var selectedSymbol = this._selectedSymbol;
            this._removeMouseOverTooltip();
            if (!this._viewPort) this._viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this, true);
            if (this.activeTool && this.activeTool.inAction && !(this.activeTool instanceof ej.datavisualization.Diagram.TextTool) &&
                !(this.activeTool instanceof ej.datavisualization.Diagram.ShapeTool && this.activeTool._drawingPolygon)) {


                if (this._selectedSymbol && evt.type != "mouseleave") {
                    this._findLabelEditing = true;
                    this._dropSymbol(null, evt);
                    delete this._findLabelEditing;
                    this._isDragg = true;
                }

                this.activeTool.mouseup(evt, true);
            }
            if (selectedSymbol) {
                if (evt.keyCode != 27 && evt.keyCode != 46) {
                    var preview = document.getElementsByClassName("e-paletteItem dragClone")[0];
                    if (preview != null) {
                        preview.style.display = "block";
                    }
                    this._selectedSymbol = selectedSymbol;
                }
                this._raiseEvent("dragLeave", { element: this.selectionList[0] });
                if (this._mouseEventTriggered) {
                    this._delete(this.selectionList[0]);
                }
            }
            if (this._isNodeEnters) {
                delete this._isNodeEnters;
                this._selectedSymbol = null;
                var preview = document.getElementsByClassName("dragClone")[0];
                if (preview != null) {
                    preview.style.display = "block";
                }
            }
            delete this._viewPort;
            delete this._isDropOver;
            this._mouseEventTriggered = false;
            this._isDragg = false;
        },
        _invoke: function (evt) {
            if (evt.originalEvent.target) {
                var className = evt.originalEvent.target.className;
                if (className && typeof className === "string" && (className == "edit" || className == "editBox" || className.indexOf("e-hhandle") > -1 || className.indexOf("e-hhandlespace") > -1 || className.indexOf("e-vhandle") > -1 || className.indexOf("e-vhandlespace") > -1)) {
                    return false;
                }
            }
            return true
        },
        _handleMouseWheel: function (evt) {
		if (!this._isForeignEvent(evt, true)) {
            if (evt.originalEvent.preventDefault)
                evt.originalEvent.preventDefault();
            var position = new ej.datavisualization.Diagram.Point(0, 0);
            if (this._isEditing) {
                this._endEdit();
            }
            //this.deactivateTool();
            if ((navigator.platform.match("Mac") ? evt.metaKey : evt.ctrlKey)) {
                position = this._mousePosition(evt.originalEvent);
                if (evt.originalEvent.wheelDelta > 0 || -40 * evt.originalEvent.detail > 0) {
                    ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, (1 + Number(this.zoomFactor())), 0, 0, position, true);
                } else {
                    ej.datavisualization.Diagram.ZoomUtil.zoomPan(this, (1 / (1 + Number(this.zoomFactor()))), 0, 0, position, true);
                }
            } else {
                var offsetY = 0;
                var oVal = {
                    zoom: this._getCurrentZoom(), horizontalOffset: this._hScrollOffset,
                    verticalOffset: this._vScrollOffset, viewPort: this._viewPort
                };
                var scrolled;
                if (evt.originalEvent.wheelDelta > 0 || -40 * evt.originalEvent.detail > 0) {
                    var top = this._vScrollbar.model.minimum;

                    var limited = this._scrollLimit() === "limited" && (this._vScrollOffset - this._scrollPixel) >= this.model.pageSettings.scrollableArea.y * this._currZoom;
                    if ((this._vScrollOffset - this._scrollPixel) >= top || this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Infinity || limited) {
                        this._updateScrollOffset(this._hScrollOffset, (this._vScrollOffset - this._scrollPixel));
                        scrolled = true;
                        offsetY = -this._scrollPixel;
                    } else {
                        this._updateScrollOffset(this._hScrollOffset, top);
                        scrolled = true;
                        offsetY = 0;
                    }
                } else {
                    var cHeight = this._vScrollbar.model.maximum;
                    var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this);
                    limited = this._scrollLimit() === "limited" &&
                       (this.model.pageSettings.scrollableArea.y + this.model.pageSettings.scrollableArea.height) * this._currZoom >=
                       (this._vScrollOffset + this._scrollPixel + viewPort.height);
                    if ((cHeight) >= (this._vScrollOffset + this._scrollPixel) || this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Infinity || limited) {
                        this._updateScrollOffset(this._hScrollOffset, (this._vScrollOffset + this._scrollPixel));
                        scrolled = true;
                        offsetY = this._scrollPixel;
                    } else {
                        this._updateScrollOffset(this._hScrollOffset, cHeight);
                        scrolled = true;
                        offsetY = 0;
                    }
                }
                if (scrolled) {
                    var nVal = {
                        zoom: this._getCurrentZoom(), horizontalOffset: this._hScrollOffset,
                        verticalOffset: this._vScrollOffset, viewPort: this._viewPort
                    };
                    if ((oVal.horizontalOffset != nVal.horizontalOffset) || (oVal.verticalOffset != nVal.verticalOffset)) {
                        this._eventCause["scrollChange"] = ej.datavisualization.Diagram.ScrollChangeCause.Pan;
                        this._raiseEvent("scrollChange", { newValues: nVal, oldValues: oVal });
                    }
                }
                this._updateEditBox(0, offsetY);
            }
			}
        },
        _setActiveTool: function (evt) {
            var point = this._mousePosition(evt);
            if (!this.activeTool.inAction && (this._isUserHandleActive(this.activeTool.name) || !this.model.selectedItems.userHandles || !this.model.selectedItems.userHandles.length)) {
                if (this._isInternalTool(this.activeTool) || this.activeTool.singleAction) {
                    var node;
                    var success = false;
                    //var handle = this._isHandle(evt);
                    if (this.selectionList[0]) {
                        node = this.selectionList[0];
                        success = this._checkToolToActivate(evt, node);
                    }
                    if (!success) {
                        node = this._findNodeUnderMouse(evt);
                        if (this._isUserHandle(evt)) {
                            var handleName = $(evt.target).parents("g").first().context.id.split("_")[0];
                            this._checkToolToActivate(evt, node);
                            this.activeTool = this.tools[this._toolToActivate];
                        }
                        else {
                            this._checkToolToActivate(evt, node);
                            this._raiseMouseEvents(node);
                            if (this._isUserHandleActive(this.activateTool.name) && !this._drawingTool)
                                this.activeTool = this.tools[this._toolToActivate];
                        }
                    }
                }
            }
        },
        _beginAutoScroll: function (option, evt, delay1) {
            var delay = delay1 ? delay1 : 100;
            var callBack = this;
            var left = 0, top = 0;
            var counter = 0;
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this);
            var cWidth = this._hScrollbar.model.maximum + viewPort.width;
            var cHeight = this._vScrollbar.model.maximum + viewPort.height;
            var intervalID;
            if (this._canAutoScroll) {
                switch (option) {
                    case "right":
                        if ((this._hScrollOffset + viewPort.width + 10) < cWidth || this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Infinity) {
                            left = 10;
                        }
                        break;
                    case "left":
                        if (this._hScrollOffset - 10 > this._hScrollbar.model.minimum || this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Infinity) {
                            left = -10;
                        }
                        break;
                    case "bottom":
                        if (this._vScrollOffset + viewPort.height + 10 < cHeight || this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Infinity) {
                            top = 10;
                        }
                        break;
                    case "top":
                        if (this._vScrollOffset - 10 > this._vScrollbar.model.minimum || this._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Infinity) {
                            top = -10;
                        }
                        break;
                }
                callBack._clearTimeOutValue = window.setTimeout(function (args) {
                    var s1 = this;
                    var args = { delay: delay };
                    callBack._raiseEvent("autoScrollChange", args);
                    callBack._updateScrollBar(left, top, option, evt, args.delay);
                }, delay);

            }
        },
        _updateScrollBar: function (x, y, option, evt, delay) {
            if (this._clearTimeOutValue)
                window.clearTimeout(this._clearTimeOutValue);
            if (x === 0 && y === 0) {
                this._canAutoScroll = false;
            }
            else if (this.activeTool.inAction) {
                var hScrollOffset = this._hScrollOffset + (x * this._currZoom);
                var vScrollOffset = this._vScrollOffset + (y * this._currZoom);
                var isUpdated = this._updateSelectionOnScroll(x, y);
                if (isUpdated) {
                    this._updateScrollOffset(hScrollOffset, vScrollOffset);
                    this._beginAutoScroll(option, evt, delay);
                }
                else {
                    this._canAutoScroll = false;
                }
            }
        },
        _updateSelectionOnScroll: function (x, y) {
            var tool = this.activeTool;
            if (tool.name === "select") {
                tool.currentPoint = new ej.datavisualization.Diagram.Point(tool.currentPoint.x + x, tool.currentPoint.y + y);
                tool._updateHelper();
            } else if (tool.name === "orthogonalLine" || tool.name === "straightLine") {
                tool.currentPoint = new ej.datavisualization.Diagram.Point(tool.currentPoint.x + x, tool.currentPoint.y + y);
                tool._targetPossibleConnection = tool._currentPossibleConnection;
                tool._targetPort = tool._possibleConnectionPort;
                tool._updateHelper();
            } else if (this.selectionList.length > 0) {
                var node = this.selectionList[0];
                if (!node.isLane)
                    tool.currentPoint = ej.datavisualization.Diagram.Point(tool.currentPoint.x + x, tool.currentPoint.y + y);
                if (tool.name === "move") {
                    if (!node.isLane && tool._outOfBoundsDrag(node, x, y)) {
                        if (tool._canMoveLabel)
                            this._translateLabel(node, tool.activeLabel, x, y);
                        else
                            this._translate(node, x, y, this.nameTable);
                    }
                    else
                        return false;
                } else if (tool.name === "resize") {
                    ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this);
                    tool._updateSize(node, tool.previousPoint, tool.currentPoint);
                } else if (tool.name === "endPoint") {
                    if (tool.selectedSegment && tool._endPoint == "segmentEnd") {
                        var difx = tool.currentPoint.x - tool.previousPoint.x;
                        var dify = tool.currentPoint.y - tool.previousPoint.y;
                        tool._updateAdjacentSegments(difx, dify);

                    } else {
                        var cancelEvent = tool._updatePoints(node);
                        if (!cancelEvent.cancel) {
                            tool._disconnect(node);
                            tool._updateConnection(node, cancelEvent.updateSelection);
                        }
                    }
                }
                tool.previousPoint = ej.datavisualization.Diagram.Point(tool.currentPoint.x, tool.currentPoint.y);
                if (!tool._canMoveLabel && node.type != "phase") {
                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                    this._updateSelectionHandle(true);
                    this._renderTooltip(node);
                }
            }
            return true;
        },
        _isUserHandle: function (evt) {
            if (evt.target.parentNode.className.animVal === "userHandle") {
                return true;
            } else {
                return false;
            }
        },
        _isUserHandleActive: function (name) {
            var userHandleActive = false;
            if (this.model.selectedItems.userHandles && this.model.selectedItems.userHandles.length > 0) {
                var i = 0;
                var length = this.model.selectedItems.userHandles.length;
                for (i; i < length; i++) {
                    if (this.model.selectedItems.userHandles[i].name === name) {
                        userHandleActive = true;
                        break;
                    } else
                        userHandleActive = true;
                }
            }
            return userHandleActive;
        },
        _getEventDetail: function (evt) {
            if (ej.browserInfo().name === "msie") {
                if (!this._timeStamp)
                    return 1;
                return ((evt.timeStamp - this._timeStamp) >= 300) ? 1 : 2;
            }
            return evt.originalEvent.detail;
        },
        _raiseMouseEvents: function (node, evt) {
            if (!this._isEditing) {
                if (this._nodeUnderMouse && (!node || this._nodeUnderMouse != node)) {
                    var tooltipDiv = document.getElementById(this.element[0].id + "_mouseovertooltipDiv");
                    if (tooltipDiv) {
                        tooltipDiv.parentNode.removeChild(tooltipDiv);
                    }
                    this._raiseEvent("mouseLeave", { element: this.getNode(this._nodeUnderMouse) });
                    if (this._nodeUnderMouse != null && (!this._nodeUnderMouse.segments) && !(this.activeTool instanceof ej.datavisualization.Diagram.LineTool)) {
                        this.activeTool._showPort(this._nodeUnderMouse, true);
                    }
                }
                if (node) {
                    if (this._nodeUnderMouse !== node) {
                        this._raiseEvent("mouseEnter", { element: this.getNode(node) });
                    }
                }
                if (node) {
                    var args = { element: this.getNode(node) };
                    this._raiseEvent("mouseOver", args);
                    if (args.element && !this.activeTool.inAction) {
                        this._renderMouseOverTooltip(node, evt);
                    }
                    else {
                        this._removeMouseOverTooltip();
                    }
                }
            }
        },
        _renderMouseOverTooltip: function (node, evt) {
            if (ej.datavisualization.Diagram.Util.canShowTooltip(node, this)) {
                var type = this.getObjectType(node);
                var tooltip;
                if (type == "node" || type == "group")
                    var Constraints = ej.datavisualization.Diagram.NodeConstraints;
                else Constraints = ej.datavisualization.Diagram.ConnectorConstraints;
                if (node.constraints & Constraints.InheritTooltip) {
                    tooltip = this.model.tooltip;
                    var modeltooltip = true;
                }
                else tooltip = node.tooltip;
                if (tooltip && (!modeltooltip || this._tooltipTemplateId())) {
                    var x, y, tx, ty;
                    var obj = this._getTooltipPosition(node, tooltip, evt, modeltooltip);
                    x = obj.x; y = obj.y; tx = obj.tx; ty = obj.ty;
                    x = -this._hScrollOffset + x * this._currZoom;
                    y = -this._vScrollOffset + y * this._currZoom;
                    var style = "left:" + x + "px; top:" + y + "px; display: block; position: absolute; pointer-events: none; transform:" + "translate(" + tx + "," + ty + ")";
                    var tooltipDiv = document.getElementById(this.element[0].id + "_mouseovertooltipDiv");
                    if (!tooltipDiv) {
                        tooltipDiv = this._createMouseOverTooltip();
                    }
                    tooltipDiv.style.left = x + "px";
                    tooltipDiv.style.top = y + "px";
                    tooltipDiv.style.transform = "translate(" + tx + " ," + ty + ")";
                    tooltipDiv.style.display = "block";
                    tooltipDiv.style.position = "absolute";
                    if ($.templates) {
                        var templateId = modeltooltip ? this._tooltipTemplateId() : tooltip.templateId;
                        var template = $.templates("#" + templateId).render(node);
                    }
                    $(tooltipDiv).html(template);

                    tooltipDiv.style.marginLeft = tooltipDiv.style.marginTop = "0px";
                    var diagramBounds = this.element[0].getBoundingClientRect();
                    var tooltipBounds = tooltipDiv.getBoundingClientRect();
                    var currentZoom = this.model.scrollSettings.currentZoom;
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node, this.activeTool.name == "rotatetool" ? true : false);
                    if ((diagramBounds.left > tooltipBounds.left) || (diagramBounds.right < tooltipBounds.right)) {
                        if ((modeltooltip ? this._tooltipMode() : tooltip.relativeMode) == "mouse" || tooltip.alignment.horizontal == "center") {
                            var side = diagramBounds.left > tooltipBounds.left ? "left" : "right";
                            var alignment = side == "right" ? tooltipBounds.right - diagramBounds.right : diagramBounds.left - tooltipBounds.left;
                            var position = side == "right" ? -alignment - tooltip.margin.right : tooltip.margin.left + alignment;
                        }
                        else {
                            if ((tooltip.alignment.horizontal == "left" || tooltip.alignment.horizontal == "right") && (tooltip.alignment.vertical == "center")) {
                                position = bounds.width * currentZoom + tooltipBounds.width + tooltip.margin.left + tooltip.margin.right;
                                position = tooltip.alignment.horizontal == "left" ? position * 1 : position * (-1);
                            }
                            else {

                                side = tooltip.alignment.horizontal;
                                if (side == "center") side = diagramBounds.left > tooltipBounds.left ? "left" : "right";
                                alignment = side == "right" ? tooltipBounds.right - diagramBounds.right : diagramBounds.left - tooltipBounds.left;
                                position = side == "right" ? -alignment - tooltip.margin.right : tooltip.margin.left + alignment;
                            }
                        }
                        tooltipDiv.style.marginLeft = position + "px";
                    }
                    if ((diagramBounds.bottom < tooltipBounds.bottom) || (diagramBounds.top > tooltipBounds.top)) {
                        if ((modeltooltip ? this._tooltipMode() : tooltip.relativeMode) == "mouse" || tooltip.alignment.vertical == "center") {
                            side = diagramBounds.top > tooltipBounds.top ? "top" : "bottom";
                            alignment = side == "top" ? tooltipBounds.top - diagramBounds.top : tooltipBounds.bottom - diagramBounds.bottom;
                            position = side == "top" ? tooltip.margin.top - alignment : -(alignment + tooltip.margin.bottom);
                        }
                        else {
                            if ((tooltip.alignment.horizontal == "center") && (tooltip.alignment.vertical == "bottom" || tooltip.alignment.vertical == "top")) {
                                position = bounds.height * currentZoom + tooltipBounds.height + (tooltip.margin.bottom + tooltip.margin.top);
                                position = tooltip.alignment.vertical == "bottom" ? position * (-1) : position * 1;
                            }
                            else {
                                alignment = tooltip.alignment.vertical == "top" ?
                                    diagramBounds.top - tooltipBounds.top : diagramBounds.bottom - tooltipBounds.bottom;
                                position = tooltip.alignment.vertical == "top" ? tooltip.margin.top + alignment : alignment - tooltip.margin.bottom;
                            }
                        }
                        tooltipDiv.style.marginTop = position + "px";
                    }
                }
            }
        },
        _getTooltipPosition: function (node, tooltip, evt, model) {
            var bounds = ej.datavisualization.Diagram.Util.bounds(node, false);
            var x, y, tx, ty;
            if ((model ? this._tooltipMode() : tooltip.relativeMode) == "object") {
                switch (model ? this._horizontalTooltipAlignment() : tooltip.alignment.horizontal) {
                    case "left":
                        x = bounds.x;
                        x -= tooltip.margin.left;
                        tx = "-100%";
                        break;
                    case "right":
                        x = bounds.right;
                        x += tooltip.margin.right;
                        tx = "0%";
                        break;
                    case "center":
                        x = bounds.center.x;
                        tx = "-50%";
                        break;
                }
                switch (model ? this._verticalTooltipAlignment() : tooltip.alignment.vertical) {
                    case "top":
                        y = bounds.y;
                        y -= tooltip.margin.top;
                        ty = "-100%";
                        break;
                    case "bottom":
                        y = bounds.bottom;
                        y += tooltip.margin.bottom;
                        ty = "0%";
                        break;
                    case "center":
                        y = bounds.center.y;
                        ty = "-50%";
                        break;
                }
            }
            else if (evt) {
                var position = this._mousePosition(evt);
                x = position.x + tooltip.margin.left; y = position.y + tooltip.margin.top;
            }
            return { x: x, y: y, tx: tx, ty: ty };
        },
        _isHandle: function (evt) {
            var handle = $(evt.target).parent("g.handle");
            if (handle.length > 0) {
                return true;
            }
            return false;
        },
        _findNodeUnderMouse: function (evt, defalt) {
            var node = null;
            var type;
            if (evt.target) {
                var parent = $(evt.target).parents(".ej-d-node,.ej-d-connector,.ej-d-group");
                var className = evt.target.className;
                var id = evt.target.id.split('_');
                if (id[id.length - 1] == "lblbg") return;
                if (parent) {
                    type = parent.attr("class");
                    if (type && (type === "ej-d-node" || type === "ej-d-group" || ej.datavisualization.Diagram.Util.isClassifier(evt))) {
                        node = this._findNode(parent.attr("id"));
                        //  node = ej.datavisualization.Diagram.ClassifierHelper.getmoveelement(node,this)
                        if (!node) node = this._findNode(parent.attr("id").split('_parentdiv')[0]);
                        if (node && node._isInternalShape && node.parent && this.nameTable[node.parent] && this.nameTable[node.parent].type == "bpmn")
                            node = this.nameTable[node.parent];
                    } else if (type === "ej-d-connector") {
                        node = this._findConnector(parent.attr("id"));
                    }
                }
            }
            return node;
        },
        _findConnectableNodeUnderMouse: function (evt) {
            var node = null;
            if (evt && evt.type === "touchmove") {
                var epoint = this._mousePosition(evt);
                var bounds = ej.datavisualization.Diagram.Rectangle(epoint.x, epoint.y, 0, 0);
                var quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(this._spatialSearch, bounds);
                for (var i = 0; i < quads.length; i++) {
                    var quad = quads[i];
                    if (quad.objects.length > 0) {
                        for (var j = 0; j < quad.objects.length; j++) {
                            var nd = quad.objects[j];
                            var nodebounds = ej.datavisualization.Diagram.Util.bounds(nd);
                            if (ej.datavisualization.Diagram.Geometry.intersectsRect(bounds, nodebounds)) {
                                if (!nd.segments && nd.visible) {
                                    return nd;
                                }
                            }
                        }
                    }
                }
            }
            else {
                var type;
                var parents = $(evt.target).parents(".ej-d-node,.ej-d-group");
                var parent = parents[0];
                var i = 1;
                while (parent) {
                    type = parent.getAttribute("class");
                    node = this._findNode(parent.getAttribute("id"));
                    if (!node)
                        node = this._findNode(parent.getAttribute("id").split('_parentdiv')[0]);
                    if (node && (ej.datavisualization.Diagram.Util.canConnect(node) || !node.parent)) {
                        parent = null;
                    } else {
                        parent = parents[i];
                        i++;
                    }
                }
                if (node) {
                    if (node.type == "umlclassifier")
                        var connector = this.activeTool.selectedObject;
                    if (connector && connector.sourceNode)
                        var sourceNode = this.nameTable[connector.sourceNode];
                    if (connector && connector.targetNode)
                        var targetNode = this.nameTable[connector.targetNode];
                    if (sourceNode)
                        node = ej.datavisualization.Diagram.ClassifierHelper.EnableorDisableConnection(node, sourceNode, connector, this);
                    if (targetNode)
                        node = ej.datavisualization.Diagram.ClassifierHelper.EnableorDisableConnection(node, targetNode, connector, this);
                }
            }
            return node;
        },
		_isForeignEvent: function (evt, keyDown) {
            if (evt.originalEvent && evt.originalEvent.target) {
                if (keyDown) {
                    if ((evt.originalEvent.target.localName === "input" && (
                        evt.originalEvent.target.type === "text" || evt.originalEvent.target.type === "password")) ||
                        evt.originalEvent.target.localName === "textarea")
                        return true;

                }
                else if (evt.originalEvent.target.localName === "img") {
                    return true;
                }
            }
        },
        _isForeignObject: function (target) {
            var foreignObj = target;
            if (foreignObj) {
                while (foreignObj.parentNode != null) {
                    if (foreignObj.tagName === "foreignObject" || (typeof foreignObj.className == "string" && foreignObj.className.split(' ').indexOf("foreignObject") !== -1)) {
                        return foreignObj;
                    } else {
                        foreignObj = foreignObj.parentNode;
                    }
                }
            }
            return null;
        },
        _altKeyPressed: function (keyModifier) {
            return keyModifier & ej.datavisualization.Diagram.KeyModifiers.Alt;
        },
        _ctrlKeyPressed: function (keyModifier) {
            return keyModifier & ej.datavisualization.Diagram.KeyModifiers.Control;
        },
        _shiftKeyPressed: function (keyModifier) {
            return keyModifier & ej.datavisualization.Diagram.KeyModifiers.Shift;
        },
        _keydown: function (evt) {
            this._isKeyDown = true;
            this._removeMouseOverTooltip();
            var keycode = evt.keyCode ? evt.keyCode : evt.which;
            var ctrlKey = navigator.platform.match("Mac") ? evt.metaKey : evt.ctrlKey;
            var key = evt.key;
			if (!this._isForeignEvent(evt, true)) {
            for (var i in this.model.commandManager.commands) {
                var command = this.model.commandManager.commands[i];
                if (command && command.gesture) {
                    if (command.gesture.keyModifiers || command.gesture.key) {
                        if ((!command.gesture.key || (keycode == command.gesture.key || key == command.gesture.key))
                            && (!command.gesture.keyModifiers || ((ctrlKey || evt.altKey || evt.shiftKey) &&
                            (!this._altKeyPressed(command.gesture.keyModifiers) || evt.altKey) &&
                            (!this._shiftKeyPressed(command.gesture.keyModifiers) || evt.shiftKey) &&
                            (!this._ctrlKeyPressed(command.gesture.keyModifiers) || ctrlKey)))) {
                            this._currentCommand = i;
                            if (this._currentCommand !== "focusToNextItem" && this._currentCommand !== "focusToPreviousItem" && this._currentCommand !== "selectFocusedItem") {
                                this._diagramElements = null;
                                this._focusedElement = null;
                                ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this._adornerSvg, this._adornerLayer);
                            }
                            if (command.execute && command.canExecute) {
                                var canExecute = command.canExecute;
                                if (typeof command.canExecute == "string") canExecute = ej.util.getObject(command.canExecute, window);
                                if ($.isFunction(canExecute) && canExecute({ model: this.model })) {
                                    var execute = command.execute;
                                    if (typeof command.execute === "string") {
                                        execute = ej.util.getObject(command.execute, window);
                                    }
                                    if ($.isFunction(execute))
                                        execute({ keyDownEventArgs: evt, parameter: command.parameter, model: this.model });
                                }
                            }
                        }
                    }
                }
            }
            this.activeTool.keydown(evt);
			}
            this._isKeyDown = false;
        },
        _keyup: function (evt) {
            var keycode = evt.keyCode ? evt.keyCode : evt.which;
            if (!this._isEditing && (keycode === 37 || keycode === 38 || keycode === 39 || keycode === 40)) {
                if (this._currentState) {
                    //this.addHistoryEntry({ type: "nudge", category: "internal", values: this._currentState, object: this.selectionList[0] });
                }
                delete this._currentState;
                evt.preventDefault();
                this.activeTool.inAction = false;
                this._updateSelectionHandle();
            }
        },
        _registerHistoryEvents: function () {
            this.historyManager.addEventHandler("collectionchanged", $.proxy(this._recordCollectionChanged, this));
            this.historyManager.addEventHandler("positionchanged", $.proxy(this._recordPinPointChanged, this));
            this.historyManager.addEventHandler("sizechanged", $.proxy(this._recordResizeChanged, this));
            this.historyManager.addEventHandler("rotationchanged", $.proxy(this._recordRotationChanged, this));
            this.historyManager.addEventHandler("endpointchanged", $.proxy(this._recordEndPointChanged, this));
            this.historyManager.addEventHandler("labelchanged", $.proxy(this._recordLabelChanged, this));
            this.historyManager.addEventHandler("groupingchanged", $.proxy(this._recordGroupChanged, this));
        },
        _svgdrop: function (evt, ui) {
            if (this._selectedSymbol && ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                var args = {};
                var e = evt.originalEvent;
                if (e.preventDefault)
                    e.preventDefault();
                else
                    e.returnValue = false;
                var scale = this._currZoom;
                var offset = $("#" + this.element[0].id).offset();
                var coor = this._isTouchEvent(evt);
                if (!coor.pageX && !evt.pageX) {
                    if (evt.originalEvent && evt.originalEvent.changedTouches) {
                        coor = evt.originalEvent.changedTouches[0];
                    }
                    else if (evt && evt.changedTouches) {
                        coor = evt.changedTouches[0];
                    }
                }
                var x = (coor ? coor.pageX : evt.pageX) + this._hScrollOffset - offset.left;
                var y = (coor ? coor.pageY : evt.pageY) + this._vScrollOffset - offset.top;
                var paletteItem = $.extend(true, {}, this._selectedSymbol);
                var symbolPaletteId = ui.helper[0].getAttribute("paletteId");
                var symbolPalette = $("#" + symbolPaletteId).ejSymbolPalette("instance");
                if (symbolPaletteId) {
                    this._selectedSymbol = null;
                    paletteItem.name += ej.datavisualization.Diagram.Util.randomId();
                    if (!paletteItem.isPhase && paletteItem.segments) {
                        if (paletteItem.segments) {
                            ej.datavisualization.Diagram.Util._translateLine(paletteItem, x, y);
                        }
                        paletteItem = this.getNode(paletteItem);
                    } else if (!paletteItem.isPhase) {
                        var palNameTable = $.extend(true, {}, symbolPalette.nameTable);
                        paletteItem.offsetX = x / scale;
                        paletteItem.offsetY = y / scale;
                        if (paletteItem._type === "group") {
                            var children = this._getChildren(paletteItem.children);
                            for (var j = 0; j < children.length; j++) {
                                var newObj = $.extend(true, {}, palNameTable[children[j]]);
                                newObj.parent = paletteItem.name;
                                newObj.name = paletteItem.name + newObj.name;
                                children[j] = newObj.name;
                                this.nameTable[newObj.name] = newObj;
                                this.nodes().push(newObj);
                                this._nodes = $.extend(true, [], this.nodes());
                                this._updateQuad(this.nameTable[newObj.name]);
                            }
                            paletteItem.height = paletteItem.width = 0;
                            this._updateChildBounds(paletteItem, this.nameTable);
                        }
                        if (paletteItem._type === "group")
                            paletteItem = this._getNewGroup(paletteItem);
                        else if (paletteItem.segments)
                            paletteItem = this._getNewConnector(paletteItem);
                        else if (!(paletteItem.isPhase || paletteItem.type === "phase"))
                            paletteItem = this._getNewNode(paletteItem);
                    }
                    if (paletteItem && paletteItem.isLane) {
                        this._cloneGroupNode(paletteItem, ej.datavisualization.Diagram.Util.randomId());
                        paletteItem = ej.datavisualization.Diagram.SwimLaneHelper._createDiagramLane(paletteItem, this.nameTable)
						paletteItem = this._initLaneContaier(paletteItem);
                    }
                    args = { element: paletteItem, cancel: false };
                    this._raiseDropEvent(args);

                    if (paletteItem && paletteItem.isLane) {
                        var header = paletteItem.children[0];
                        var swimlane = ej.datavisualization.Diagram.SwimLaneHelper._createSwimlane(paletteItem, this, null, null, header);
                        if (swimlane && swimlane.isSwimlane)
                            paletteItem = swimlane;
                    }
                    if (!paletteItem.isPhase) {
                        if (!args.cancel) {
                            this.add(paletteItem);
                        }
                        paletteItem = this.selectionList[0];
                        this.scrollToNode(paletteItem);
                        if (paletteItem.labels.length > 0 && paletteItem.labels[0].mode === "edit") {
                            this._isEditing = true;
                            this.startLabelEdit(paletteItem, paletteItem.labels[0]);
                        } else
                            this.element[0].focus();
                    }
                }
            } else {
                var node = null;
                node = this._findNodeUnderMouse(evt);
                args = { element: ui.helper, e: evt, draggable: ui.draggable, targetNode: node };
                this._raiseDropEvent(args);
            }
        },
        _isTouchEvent: function (evt) {
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend") {
                return evt.originalEvent ? evt.originalEvent.changedTouches[0] : evt.changedTouches[0];
            }
            return evt;
        },
        _raiseDropEvent: function (args) {
            args.source = this._symbolPalette ? this._symbolPalette : null;
            args.objectType = args.source ? ej.datavisualization.Diagram.ObjectTypes.Palette : ej.datavisualization.Diagram.ObjectTypes.Diagram;
            this._raiseEvent("drop", args);
            this._symbolPalette = null;
        },
        //#endregion
        //#region Undo Redo
        _recordCollectionChanged: function (args, orgObj) {
            this._isUndo = true;
            this._isInsert = true;
            var i;
            var changeType = args.changeType;
            if (args.isUndo) {
                if (args.changeType == "insert")
                    changeType = "remove";
                else
                    changeType = "insert";
            }
            this._clearSelection(changeType == "insert" ? false : true);
            if (changeType == "insert") {
                if (!args.object.container) {
                    if (args.object.type != "pseudoGroup") {
                        if (!args.object.segments) {
                            var port = null;
                            if (args.object.inEdges && args.object.inEdges.length > 0) {
                                for (i = 0; i < args.object.inEdges.length; i++) {
                                    if (this.nameTable[args.object.inEdges[i]])
                                        this.nameTable[args.object.inEdges[i]].targetNode = args.object.name;
                                    if (args.targetPorts)
                                        port = args.targetPorts[args.object.inEdges[i]];
                                    if (port)
                                        if (this.nameTable[args.object.inEdges[i]])
                                            this.nameTable[args.object.inEdges[i]].targetPort = port;
                                }
                            }
                            if (args.object.outEdges && args.object.outEdges.length > 0) {
                                for (i = 0; i < args.object.outEdges.length; i++) {
                                    if (this.nameTable[args.object.outEdges[i]])
                                        this.nameTable[args.object.outEdges[i]].sourceNode = args.object.name;
                                    if (args.sourcePorts)
                                        port = args.sourcePorts[args.object.outEdges[i]];
                                    if (port)
                                        if (this.nameTable[args.object.outEdges[i]])
                                            this.nameTable[args.object.outEdges[i]].sourcePort = port;
                                }
                            }
                        }
                        if (args.object._type === "group")
                            this._addChildren(args.object, args.childTable);
                        if (args.object.isSwimlane)
                            args.object = ej.datavisualization.Diagram.SwimLaneHelper._initSwimLane(args.object, this)
                        this.add(args.object, args);
                        if (args.object.parent) {
                            var pNode = this.nameTable[args.object.parent];
                        }
                        if (args.object._type === "group") {
                            this._addConnector(args.object, args);
                            this._addGroupConnector(args.object, args);
                        }
                        else {
                            this._addConnector(args.object, args);
                        }
                    } else {
                        delete this.nameTable["multipleSelection"];
                        var node, j, objectType, childConnectors = [];
                        var pseudoGroup = ej.datavisualization.Diagram.Group({ "name": "multipleSelection", type: "pseudoGroup" });

                        for (i = 0; i < args.object.children.length; i++) {
                            child = typeof args.object.children[i] === "object" ? args.object.children[i] : args.childTable[args.object.children[i]];
                            if (child) {
                                objectType = this.getObjectType(child);
                                if (objectType === "group" && !child.isSwimlane)
                                    this._addChildren(child, args.childTable);
                                if (child.isSwimlane) {
                                    this._swimlanePaste = true;
                                    this._isUndo = true;
                                    var child = this._pasteSwimlaneObj(child, args);
                                    delete this._swimlanePaste;
                                }
                                else if (objectType != "connector")
                                    this.add(child, args);
                                else
                                    childConnectors.push(child);
                                if (child)
                                    pseudoGroup.children.push(child.name);
                            }
                        }
                        for (i = 0; i < childConnectors.length; i++) {
                            this.add(childConnectors[i], args);
                            //  pseudoGroup.children.push(childConnectors[i].name);
                        }
                        this._addGroupConnector(args.object, args);
                        for (i = 0; i < pseudoGroup.children.length; i++) {
                            node = this.nameTable[pseudoGroup.children[i]];
                            if (node && !node.segments) {
                                if (node.inEdges.length > 0) {
                                    for (j = 0; j < node.inEdges.length; j++) {
                                        if (!this._isUndo) {
                                            this.nameTable[node.inEdges[j]].targetNode = node.name;
                                        }
                                        else {
                                            args.childTable[node.inEdges[j]].targetNode = node.name;
                                        }
                                    }
                                }
                                if (node.outEdges.length > 0) {
                                    for (j = 0; j < node.outEdges.length; j++) {
                                        if (!this._isUndo) {
                                            this.nameTable[node.outEdges[j]].sourceNode = node.name;
                                        }
                                        else {
                                            args.childTable[node.outEdges[j]].sourceNode = node.name;
                                        }
                                    }
                                }
                            }
                        }
                        this._clearSelection();
                        this.nodes().push(pseudoGroup);
                        this._nodes = $.extend(true, [], this.nodes());
                        pseudoGroup.offsetX = args.object.offsetX;
                        pseudoGroup.offsetY = args.object.offsetY;
                        pseudoGroup.height = args.object.height;
                        pseudoGroup.width = args.object.width;
                        pseudoGroup.rotateAngle = args.object.rotateAngle;
                        this.nameTable[pseudoGroup.name] = pseudoGroup;
                        this.addSelection(pseudoGroup, true);
                    }
                } else {
                    var child;
                    for (var i in args.childTable) {
                        child = args.childTable[i];
                        this.nameTable[i] = child;
                    }
                    node = args.object;
                    if (node.isSwimlane) {
                        this.nameTable[node.name] = node;
                        node.width = 0;
                        node.height = 0;
                        this._swimlanePaste = true;
                        this._multipleAction = true;
                        this._eventCause["nodeCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.HistoryChange;
                        this._pasteSwimlaneObj(node);
                        delete this._swimlanePaste;
                        this._eventCause["connectorCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.HistoryChange;
                        this._addAssiciatedChildConnectors(node);
                        delete this._multipleAction;
                        this._clearSelection(true);
                    } else if (node.isLane) {
                        if (args.object && args.object.parent)
                            var parentStack = this.nameTable[args.object.parent];
                        if (parentStack) {
                            if (parentStack)
                                var swimlane = this.nameTable[parentStack.parent];
                        }
                        if (swimlane) {
                            this.activeTool.selectedObject = args.object;
                            ej.datavisualization.Diagram.canvasHelper._addNewLane(this, node, swimlane, true, args.index);
                            this._addAssiciatedChildConnectors(node);
                            this._clearSelection(true);
                        }
                    }
                    else {
                        this.add(node);
                        this._addConnector(node, args);
                    }
                }
            }
            else if (changeType == "remove") {
                if (args.object.type != "pseudoGroup" && !args.object.isLane) {
                    this._removeAdjacentConnections(args.object, args);
                    if (args.object.isSwimlane || args.object.annotation)
                        this._remove(this.nameTable[args.object.name]);
                    else
                        this._remove(args.object);
                    return true;
                }
                else if (args.object.isLane) {
                    var obj = args.object;
                    if (!args.index && args.index != 0) {
                        var index = null;
                        if (args.object.isLane && orgObj) {
                            orgObj.index = this._getRemoveIndex(args.object, true);
                        }
                    }
                    this._remove(obj);
                }
                else {
                    for (i = 0; i < args.object.children.length; i++) {
                        this._remove(this.nameTable[this._getChild(args.object.children[i])]);
                    }
                }
            }
            if (!this._groupUndo)
                this._isUndo = false;
            this._isInsert = false;
            this.tools['move']._isLane = false;
        },

        _addAssiciatedChildConnectors: function (group) {
            var children = this._getChildren(group.children);
            if (children && children.length > 0) {
                for (var i = 0, len = children.length; i < len; i++) {
                    var child = this.nameTable[children[i]];
                    if (child) {
                        this._addConnector(child);
                        if (child.type === "group") {
                            this._addAssiciatedChildConnectors(child);
                        }
                    }
                }
            }
        },
        _updateRecordPinPoint: function (node, childTable, isMultipleSelection) {
            var object, i, item, objNode;
            // this._clearSelection();
            if (node.type == "pseudoGroup") {
                var undoObj = node;
                var children = this._getChildren(node.children);
                for (i = 0; i < children.length; i++) {
                    item = this.nameTable[children[i]];
                    objNode = childTable[children[i]];
                    if (objNode) {
                        if (!item.segments) {
                            this._propertyChangeValues(item, objNode);
                            this._translate(item, objNode.offsetX - item.offsetX, objNode.offsetY - item.offsetY, this.nameTable);
                        } else {
                            var objLine = childTable[item.name];
                            item.sourcePoint = objLine.sourcePoint;
                            item.targetPoint = objLine.targetPoint;
                            item.segments = jQuery.extend(true, item.segments, objLine.segments);
                        }
                        ej.datavisualization.Diagram.DiagramContext.update(item, this);
                    }
                }
                if (this.selectionList[0]) {
                    if (this.selectionList[0].name === undoObj.name) {
                        this.selectionList[0].offsetX = undoObj.offsetX;
                        this.selectionList[0].offsetY = undoObj.offsetY;
                    }
                }
                ej.datavisualization.Diagram.SvgContext.updateSelector(undoObj, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
            } else {
                if (node.segments) {
                    if (isMultipleSelection) {
                        object = childTable[node.name];
                        node.sourcePoint = object.sourcePoint;
                        node.targetPoint = object.targetPoint;
                        node.segments = $.extend(true, [], object.segments);
                        ej.datavisualization.Diagram.DiagramContext.update(node, this);
                    } else {
                        this._clearSelection(true);
                        object = this._findConnector(node.name);
                        var obj;

                        if (node.targetNode) {
                            obj = this.nameTable[node.targetNode];
                            ej.datavisualization.Diagram.Util.removeItem(obj.inEdges, node);
                        }
                        if (node.sourceNode) {
                            obj = this.nameTable[node.sourceNode];
                            ej.datavisualization.Diagram.Util.removeItem(obj.outEdges, node);
                        }
                        if (node.targetNode) {
                            obj = this.nameTable[node.targetNode];
                            obj.inEdges.push(node.name);
                        }
                        if (node.sourceNode) {
                            obj = this.nameTable[node.sourceNode];
                            obj.outEdges.push(node.name);
                        }
                        this._propertyChangeConnectorValues(object, node);
                        object.targetNode = node.targetNode;
                        object.sourceNode = node.sourceNode;
                        object.targetPort = node.targetPort;
                        object.sourcePort = node.sourcePort;
                        object.sourcePoint = node.sourcePoint;
                        object.targetPoint = node.targetPoint;
                        object.segments = $.extend(true, [], node.segments);
                        ej.datavisualization.Diagram.DiagramContext.update(object, this);
                        ej.datavisualization.Diagram.SvgContext.updateSelector(node, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                        this.addSelection(node, true);
                    }
                } else {
                    if (isMultipleSelection) {
                        object = childTable[node.name];
                        this._translate(node, object.offsetX - node.offsetX, object.offsetY - node.offsetY, childTable);
                        ej.datavisualization.Diagram.DiagramContext.update(object, this);
                    } else {
                        object = this._findNode(node.name);
                        this._clearSelection(true);
                        this._propertyChangeValues(object, node);
                        if (node.parent)
                            parent = this.nameTable[node.parent];
                        if (!parent) {
                            parent = this.nameTable[object.parent];
                            var update = true;
                        }
                        if (parent && parent.container) {
                            ej.datavisualization.Diagram.canvasHelper._undoDragNode(this, this.nameTable[node.name], node);
                            if (update) {
                                var swimlane = this.nameTable[parent.parent.split("laneStack")[0]];
                                if (swimlane) {
                                    ej.datavisualization.Diagram.DiagramContext.update(swimlane, this);
                                }
                            }
                        }
                        else {
                            this._translate(object, node.offsetX - object.offsetX, node.offsetY - object.offsetY, this.nameTable);
                            if (node.parent) {
                                ej.datavisualization.Diagram.Util._updateGroupBounds(this.nameTable[object.parent], this);
                            }
                            if (object.parent) {
                                var parent = this.nameTable[object.parent];
                                if (parent && object.parent && node.parent == "") {
                                    ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, object.name);
                                    this._delete(object);
                                    if (node.type === "group" || node.type === "bpmn")
                                        this._initGroupNode(node, childTable);
                                    this.add(node);
                                }
                            }
                            if (node.parent) {
                                var parent = this.nameTable[node.parent];
                                if (node.parent && object.parent == "") {
                                    this._delete(object);
                                    node = $.extend(true, {}, node);
                                    if (node.type === "group" || node.type === "bpmn")
                                        this._initGroupNode(node, childTable);
                                    this.add(node);
                                }
                            }
                        }
                        ej.datavisualization.Diagram.DiagramContext.update(object, this);
                        ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, object);
                        this.addSelection(object, true);
                    }
                }
            }
        },

        _propertyChangeValues: function (item, objNode) {
            var propertyNamex = (item.offsetX === objNode.offsetX) ? "" : "offsetX";
            var propertyNamey = (item.offsetY === objNode.offsetY) ? "" : "offsetY";
            if (propertyNamex === "offsetX") {
                var resource = { element: objNode, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: propertyNamex, oldValue: item.offsetX, newValue: objNode.offsetX };
                this._raisePropertyChange(resource);
            }
            if (propertyNamey === "offsetY") {
                resource = { element: objNode, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: propertyNamey, oldValue: item.offsetY, newValue: objNode.offsetY };
                this._raisePropertyChange(resource);
            }
        },
        _propertyChangeResizeValues: function (item, childObj) {
            var propertyName = (childObj.width === item.width) ? "" : "width";
            var propertyName1 = (childObj.height === item.height) ? "" : "height";
            if (propertyName === "width") {
                var resource = { element: item, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: propertyName, oldValue: item.width, newValue: childObj.width };
                this._raisePropertyChange(resource);
            }
            if (propertyName1 === "height") {
                resource = { element: item, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: propertyName1, oldValue: item.height, newValue: childObj.height };
                this._raisePropertyChange(resource);
            }
        },
        _propertyChangeConnectorValues: function (connector, currentObject) {
            var propertyName = (connector.sourcePoint.x === currentObject.sourcePoint.x || connector.sourcePoint.y === currentObject.sourcePoint.y) ? "" : "sourcePoint";
            var propertyName1 = (connector.targetPoint.x === currentObject.targetPoint.x || connector.targetPoint.y === currentObject.targetPoint.y) ? "" : "targetPoint";
            if (propertyName === "sourcePoint") {
                var resource = { element: currentObject, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: propertyName, oldValue: connector.sourcePoint, newValue: currentObject.sourcePoint };
                this._raisePropertyChange(resource);
            }
            if (propertyName1 === "targetPoint") {
                resource = { element: currentObject, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: propertyName1, oldValue: connector.targetPoint, newValue: currentObject.targetPoint };
                this._raisePropertyChange(resource);
            }
        },

        _renderNodeOnLane: function (group, parent) {
            var view, panel;
            var diagram = this;
            diagram._views.forEach(function (viewid) {
                var isOverView
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                parent = view.svg.getElementById(group.parent);
                if (view.type == "overview") {
                    isOverView = true;
                }
                if (group._type === "group")
                    view.context.renderGroup(group, panel, parent || view.diagramLayer, diagram.nameTable, diagram, null, true);
                else if (diagram.getObjectType(group) === "node")
                    view.context.renderNode(group, panel, parent || view.diagramLayer);
            });
        },

        _updateUndoObject: function (node, object) {
            if (object.parent)
                var parent = this.nameTable[object.parent];
            if (parent && this._collectionContains(object.name, parent.children)) {
                ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, object.name);
                if (node.parent)
                    var newParent = this.nameTable[node.parent];
                if (newParent && newParent.children && !this._collectionContains(object.name, newParent.children)) {
                    newParent.children.push(node.name);
                    this.nameTable[node.name].parent = newParent.name;
                    if (newParent.isLane) {
                        var moveTool = this.tools["move"];
                        moveTool._updateMargin(object, newParent);
                    }
                }
            }
            else {
                if (node.parent) {
                    var parent = this.nameTable[node.parent];
                }
            }
        },
        _collectionContains: function (name, coll) {
            for (var i = 0; i < coll.length; i++) {
                if (typeof (coll[i]) === "string" && coll[i] === name) {
                    return true;
                }
                else if (coll[i].name === name) {
                    return true;
                }
            }
        },

        _recordPinPointChanged: function (args) {
            var node = args.object.node;
            var childTable = args.object.childTable;
            if (node || node.isSwimlane)
                this._updateRecordPinPoint(node, childTable);
        },

        _updateRecordRotation: function (object, childTable) {
            var node, i, item, objNodeChild;
            if (object.type == "pseudoGroup") {
                this._clearSelection(true);
                this.nameTable[object.name] = object;
                node = this.nameTable[object.name];
                var children = object.children;
                for (i = 0; i < children.length; i++) {
                    item = this.nameTable[children[i]];
                    objNodeChild = childTable[children[i]];
                    if (item) {
                        if (!item.segments) {
                            if (objNodeChild) {
                                this._translate(item, objNodeChild.offsetX - item.offsetX, objNodeChild.offsetY - item.offsetY, this.nameTable);
                                this._comparePropertyValues(item, "rotateAngle", { rotateAngle: objNodeChild.rotateAngle });
                                this._rotate(item, objNodeChild.rotateAngle - item.rotateAngle, this.nameTable);
                            }
                        } else {
                            var objLine = childTable[item.name];
                            item.sourcePoint = objLine.sourcePoint;
                            item.targetPoint = objLine.targetPoint;
                        }
                        ej.datavisualization.Diagram.DiagramContext.update(item, this);
                    }
                }
                if (node) {
                    var newangle = object.rotateAngle - node.rotateAngle;
                    node.rotateAngle += newangle;
                    if (this.selectionList[0])
                        this.selectionList[0].rotateAngle = node.rotateAngle;
                }
                this.nameTable[object.name] = object;
                this.addSelection(object, true);
            }
            else {
                var parent = null;
                if (object.parent) {
                    parent = this.nameTable[object.parent];
                }
                if (parent && parent.container) {
                    var node = this._findNode(object.name);
                    ej.datavisualization.Diagram.canvasHelper._undoRotateNode(this, node, object);
                }
                else if (object) {
                    this._clearSelection(true);
                    node = this._findNode(object.name);
                    this._comparePropertyValues(node, "rotateAngle", { rotateAngle: object.rotateAngle });
                    this._rotate(node, object.rotateAngle - node.rotateAngle, this.nameTable);
                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                    this.addSelection(node, true);
                }
            }
        },

        _recordSizeChanged: function (args, entryItem) {
            var node = args.object.node;
            var childTable = args.object.childTable;
            //  if (!node.container)
            this._updateRecordSize(node, childTable, entryItem);
        },

        _updateRecordSize: function (object, childTable, args) {
            var node, i, childObj;
            this._clearSelection(true);
            if ((object._type === "group" || object.type === "pseudoGroup") && !(object.isLane || object.isSwimlane || object.type === "bpmn")) {
                if (object.type == "pseudoGroup")
                    this.nameTable[object.name] = object;
                node = this._findNode(object.name);
                var nodeChildren = this._getChildren(node.children);
                var objChildren = this._getChildren(object.children);
                for (i = 0; nodeChildren && i < nodeChildren.length; i++) {
                    var item = this.nameTable[objChildren[i]];
                    childObj = childTable[objChildren[i]];
                    if (childObj) {
                        if (!item.segments) {
                            this._propertyChangeResizeValues(item, childObj);
                            this._translate(item, childObj.offsetX - item.offsetX, childObj.offsetY - item.offsetY, this.nameTable);
                            this.scale(item, (childObj.width / item.width), (childObj.height / item.height), ej.datavisualization.Diagram.Point(item.offsetX, item.offsetY), this.nameTable);
                            //ej.datavisualization.Diagram.DiagramContext.update(item, this);
                        } else {
                            var kk = childTable[item.name];
                            item.sourcePoint = kk.sourcePoint;
                            item.targetPoint = kk.targetPoint;
                            item.segments = $.extend(true, [], kk.segments);;
                            //ej.datavisualization.Diagram.DiagramContext.update(item, this);
                        }
                    }
                }
                //if (node.name === object.name) {
                var parent = null;
                if (object.parent) {
                    parent = this.nameTable[object.parent];
                }
                if (parent && parent.container) {
                    node = this._findNode(object.name);
                    ej.datavisualization.Diagram.canvasHelper._undoResizeNode(this, node, object);
                }
                else {
                    node.offsetX = object.offsetX;
                    node.offsetY = object.offsetY;
                    node.width = object.width;
                    node.height = object.height;
                    if (!(this.activeTool.name == "resize" && this.activeTool.inAction && this.selectionList[0].type != "pseudoGroup" && this.selectionList[0].type != "group"))
                        this._updateAssociatedConnectorEnds(node, this.nameTable);

                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                    this.addSelection(node, true);
                }
            }
            else if (object.isLane || object.isSwimlane) {
                node = this._findNode(object.name);
                ej.datavisualization.Diagram.canvasHelper._undoResizeLane(this, object, args);
            }
            else if (object.type == "bpmn" && object.container) {
                node = this._findNode(object.name);
                ej.datavisualization.Diagram.canvasHelper._undoResizeNode(this, node, object);
            }
            else {
                var parent = null;
                if (object.parent) {
                    parent = this.nameTable[object.parent];
                }
                if (parent && parent.container) {
                    node = this._findNode(object.name);
                    ej.datavisualization.Diagram.canvasHelper._undoResizeNode(this, node, object);
                }
                else if (!object.segments) {
                    node = this._findNode(object.name);
                    this._propertyChangeResizeValues(node, object);
                    this._translate(node, object.offsetX - node.offsetX, object.offsetY - node.offsetY, this.nameTable);
                    this.scale(node, object.width / node.width, object.height / node.height, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), this.nameTable);
                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                    this.addSelection(node, true);
                }
                else { }
            }

        },

        _recordRotationChanged: function (args) {
            var node = args.object.node;
            var childTable = args.object.childTable;
            //  if (!node.container)
            this._updateRecordRotation(node, childTable);
        },

        _recordEndPointChanged: function (args) {
            this.clearSelection(true);
            var connector, currentObject, previousObject, obj;
            if (args._isUndo) {
                connector = currentObject = args.undoObject;
                previousObject = args.redoObject;
            }
            else {
                connector = currentObject = args.redoObject;
                previousObject = args.undoObject;
            }
            if (connector.parent) {
                connector = this._findChildren(this.nameTable[connector.parent], connector.name);
            }
            else
                connector = this._findConnector(connector.name);

            if (previousObject.targetNode) {
                obj = this.nameTable[previousObject.targetNode];
                ej.datavisualization.Diagram.Util.removeItem(obj.inEdges, previousObject.name);
            }
            if (previousObject.sourceNode) {
                obj = this.nameTable[previousObject.sourceNode];
                ej.datavisualization.Diagram.Util.removeItem(obj.outEdges, previousObject.name);
            }
            if (currentObject.targetNode) {
                obj = this.nameTable[currentObject.targetNode];
                obj.inEdges.push(currentObject.name);
            }
            if (currentObject.sourceNode) {
                obj = this.nameTable[currentObject.sourceNode];
                obj.outEdges.push(currentObject.name);
            }
            this._propertyChangeConnectorValues(connector, currentObject);
            this._comparePropertyValues(connector, "targetNode", { targetNode: currentObject.targetNode });
            connector.targetNode = currentObject.targetNode;
            this._comparePropertyValues(connector, "sourceNode", { sourceNode: currentObject.sourceNode });
            connector.sourceNode = currentObject.sourceNode;
            this._comparePropertyValues(connector, "targetPort", { targetPort: currentObject.targetPort });
            connector.targetPort = currentObject.targetPort;
            this._comparePropertyValues(connector, "sourcePort", { sourcePort: currentObject.sourcePort });
            connector.sourcePort = currentObject.sourcePort;
            this._comparePropertyValues(connector, "sourcePoint", { sourcePoint: currentObject.sourcePoint });
            connector.sourcePoint = currentObject.sourcePoint;
            this._comparePropertyValues(connector, "targetPoint", { targetPoint: currentObject.targetPoint });
            connector.targetPoint = currentObject.targetPoint;
            connector.segments = $.extend(true, [], currentObject.segments);
            this._updateEdges(connector);
            this._dock(connector, this.nameTable);
            ej.datavisualization.Diagram.Util._updateConnectorSegments(connector, connector.sourcePort, connector.targetPort, this);
            ej.datavisualization.Diagram.DiagramContext._refreshSegments(connector, this);
            ej.datavisualization.Diagram.Util.updateBridging(connector, this);
            ej.datavisualization.Diagram.DiagramContext.update(connector, this);
            this._updateConnectorBridging(connector);
            this._addSelection(connector, this._selectionContains(connector) ? true : false);
            if (this.selectionList[0])
                ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.selectionList[0], this._adornerSvg, this._currZoom);
            ej.datavisualization.Diagram.SvgContext.updateSelector(connector, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
        },
        _recordLabelChanged: function (args) {
            var node = this.nameTable[args.object.name];
            this._comparePropertyValues(node.labels[args.index ? args.index : 0], "text", { text: args.label });
            if (args.object.type === "text") {
                node.textBlock.text = args.label;
                ej.datavisualization.Diagram.DiagramContext.updateTextBlock(node, node.textBlock, this);
            } else {
                if (node.type == "umlclassifier") {
                    this._clearSelection(true);
                    args.label = ej.datavisualization.Diagram.ClassifierHelper.getEditboxValue(args.label, node, this);
                    node = ej.datavisualization.Diagram.ClassifierHelper.getClassifierNodeDimension(node, this);
                    node.labels[args.index].text = "";
                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                    this.addSelection(node, true);
                }
                else if (node.shape && node.shape.type == "umlclassifier") {
                    node = ej.datavisualization.Diagram.ClassifierHelper.getUMLConnectorValue(node, args.label, node.labels[args.index]);
                    ej.datavisualization.Diagram.DiagramContext.update(node, this);
                }
                else {
                    if (node.labels[args.index]) {
                        node.labels[args.index].text = args.label;
                        ej.datavisualization.Diagram.DiagramContext.updateLabel(node, node.labels[args.index], this);
                    }
                    else {
                        node.labels[args.index] = ej.datavisualization.Diagram.Label({ text: args.label });
                        ej.datavisualization.Diagram.DiagramContext.addNodeLabel(node, node.labels[args.index], null, this);
                    }
                }
            }
        },
        labelcollectionchanged: function (args) {
            var node = this.nameTable[args.shape.name];
            var prtyLabels = node.labels;
            prtyLabels.slice(0);
            if (args.isUndo) {
                ej.datavisualization.Diagram.Util.removeItem(node.labels, args.label);
                diagram._views.forEach(function (viewid) {
                    var view = diagram._views[viewid];
                    var htmlLayer = view.svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                    var element = $(htmlLayer).find("#" + node.name + "_" + args.label.name + "_lblbg")[0];
                    if (element)
                        element.parentNode.removeChild(element);
                });
            }
            else {
                ej.datavisualization.Diagram.DiagramContext.addLabel(node, args.label, this, args.index);
            }
            this._raisePropertyChange({ element: node, cause: ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "labels", oldValue: prtyLabels, newValue: node.labels });
        },
        _recordGroupChanged: function (args) {
            var actionType = args.actionType;
            if (args.isUndo) {
                if (args.actionType === "group")
                    actionType = "ungroup";
                if (args.actionType === "ungroup")
                    actionType = "group";
            }
            this._clearSelection(actionType == "group" ? true : false);
            var selectionList = this._getChildren(args.object.children);
            if (actionType === "group") {
                var group = new ej.datavisualization.Diagram.Group(args.object);
                group.children = [];
                for (i = 0; i < selectionList.length; i++) {
                    group.children.push(selectionList[i]);
                    var childNode = this.nameTable[selectionList[i]];
                    if (childNode.parent)
                        oldParent = this.nameTable[childNode.parent];
                    childNode.parent = group.name;
                    var groupElement = this._svg.document.getElementById(selectionList[i]);
                    if (groupElement)
                        groupElement.parentNode.removeChild(groupElement);
                    if (childNode.parent)
                        newParent = this.nameTable[childNode.parent];
                    this._raiseGroupChangeEvent(childNode, oldParent, newParent, "group");
                }
                //group.name = args.object.name;
                this._eventCause["nodeCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.HistoryChange;
                this.add(group);
                this._addSelection(group);
            }
            else {
                var i, node, oldParent, newParent;
                node = args.object;
                var groupElement = this._svg.document.getElementById(node.name);
                if (groupElement)
                    groupElement.parentNode.removeChild(groupElement);
                var nodeChildren = this._getChildren(node.children);
                for (i = 0; i < nodeChildren.length; i++) {
                    var childNode = this.nameTable[nodeChildren[i]];
                    if (childNode.parent)
                        oldParent = this.nameTable[childNode.parent];
                    childNode.parent = "";
                    this._isUndo = true;
                    if (!childNode.segments) {
                        if (childNode._type == "group")
                            ej.datavisualization.Diagram.DiagramContext.renderGroup(childNode, this);
                        else
                            ej.datavisualization.Diagram.DiagramContext.renderNode(childNode, this);
                        if (this.nodes().indexOf(childNode) === -1) {
                            this.nodes().push(childNode);
                            this._nodes = $.extend(true, [], this.nodes());
                        }
                    }
                    if (childNode.segments) {
                        ej.datavisualization.Diagram.DiagramContext.renderConnector(childNode, this);
                        if (this.connectors().indexOf(childNode) === -1) {
                            this.connectors().push(childNode);
                            this._connectors = $.extend(true, [], this.connectors());
                        }
                    }
                    this._isUndo = false;
                    this._nodes = $.extend(true, [], this.nodes());
                    if (childNode.parent)
                        newParent = this.nameTable[childNode.parent];
                    this._raiseGroupChangeEvent(childNode, oldParent, newParent, "ungroup");
                }
                this._removeElement(node);
                ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this._findNode(node.name));
                this._nodes = $.extend(true, [], this.nodes());
            }
        },

        _recordNudgingChanges: function (obj, entryItem, isRedo) {
            this._isUndo = true;
            var direction = entryItem.undoDirection;
            if (isRedo)
                direction = entryItem.redoDirection;
            this._clearSelection(true);
            if (obj.type === "pseudoGroup") {
                var pseudoGroup = ej.datavisualization.Diagram.Group(obj);
                delete this.nameTable[pseudoGroup.name];
                this.nameTable[pseudoGroup.name] = obj;
            }
            this._addSelection(this.nameTable[obj.name], true);
            this.nudge(direction, entryItem.values);
            this._isUndo = false;
        },

        _recordPropertiesChanged: function (node, options, type, object) {
            var currentState = this._getModifiedProperties((type == "port" || type == "label") ? object : node, options);
            if (currentState && Object.keys(currentState).length) {
                if (type == "connector") {
                    if (options.sourcePoint || options.sourceNode) {
                        currentState.sourcePoint = node.sourcePoint;
                        currentState.sourceNode = node.sourceNode;
                        currentState.sourcePort = node.sourcePort;
                    }
                    if (options.targetPoint || options.targetNode) {
                        currentState.targetNode = node.targetNode;
                        currentState.targetPort = node.targetPort;
                        currentState.targetPoint = node.targetPoint;
                    }
                }
                var entry = { type: "propertiesChanged", values: currentState, category: "internal", object: node, elementType: type };
                entry[type] = object;
                this.addHistoryEntry(entry);
            }
        },
        _recordAlignCommandChanges: function (entryItem) {
            if (entryItem && entryItem.values.length) {
                for (var i = 0; i < entryItem.values.length; i++) {
                    var obj = entryItem.values[i];
                    if (obj.object && obj.delta) {
                        var current = { x: -obj.delta.x, y: -obj.delta.y };
                        var child = this.nameTable[this._getChild(obj.object)];
                        this._comparePropertyOnAlign(child, -obj.delta.x, -obj.delta.y);
                        this._translate(child, -obj.delta.x, -obj.delta.y, this.nameTable);
                        this._updateContainerOnNudge(child);
                        obj.delta = current;
                        this._updateObject(child);
                    }
                }
                if (!this.nameTable[entryItem.object.name]) this.nameTable[entryItem.object.name] = entryItem.object;
                ej.datavisualization.Diagram.Util._updateGroupBounds(entryItem.object, this);
                if (this._hasSelection())
                    ej.datavisualization.Diagram.SvgContext.updateSelector(entryItem.object, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                else
                    this.addSelection(entryItem.object, true);
            }
        },
        _recordPhaseCollectionChanged: function (entryItem) {
            if (entryItem.undo) {
                if (entryItem.isAdded) {
                    if (entryItem.phase)
                        this._removePhase(entryItem.phase.name);
                }
                else {
                    if (entryItem.phase) {
                        this._addPhase(entryItem.group, entryItem.phase, entryItem);
                    }
                }
            }
            else {
                if (entryItem.isAdded) {
                    if (entryItem.phase) {
                        this._addPhase(entryItem.group, entryItem.phase, entryItem);
                    }
                }
                else {
                    if (entryItem.phase)
                        this._removePhase(entryItem.phase.name);
                }
            }
            this._clearSelection(true)
        },
        _recordSizeCommandChanges: function (entryItem) {
            if (entryItem && entryItem.values.length) {
                for (var i = 0; i < entryItem.values.length; i++) {
                    var obj = entryItem.values[i];
                    if (obj.object && obj.values) {
                        var current = { width: obj.object.width || obj.object._width || 0, height: obj.object.height || obj.object._height || 0 };
                        var child = this.nameTable[this._getChild(obj.object)];
                        this._comparePropertyValues(child, "height", { height: obj.values.height });
                        this._comparePropertyValues(child, "width", { width: obj.values.width });
                        this.scale(child, obj.values.width / (child.width || child._width || 0),
                            obj.values.height / (child.height || child.height || 0),
                          { x: child.offsetX, y: child.offsetY }, this.nameTable);
                        obj.values = current;
                        this._updateObject(child);
                    }
                }
                if (!this.nameTable[entryItem.object.name] && entryItem.object.type == "pseudoGroup") this.nameTable[entryItem.object.name] = entryItem.object;
                ej.datavisualization.Diagram.Util._updateGroupBounds(entryItem.object, this);
                if (this._hasSelection())
                    ej.datavisualization.Diagram.SvgContext.updateSelector(entryItem.object, this._adornerSvg, this._currZoom, this, this.model.selectedItems.constraints);
                else
                    this.addSelection(entryItem.object, true);
            }
        },
        _getModifiedProperties: function (node, options, object) {
            object = object || node;
            if (options && Object.keys(options).length && object) {
                var current = {};
                for (var prop in options) {
                    if (options[prop] != object[prop] || typeof object[prop] == "object") {
                        if (object[prop] && object[prop] instanceof Array)
                            current[prop] = object[prop];
                        else if (object[prop] && typeof object[prop] == "object")
                            current[prop] = $.extend(true, {}, object[prop]);
                        else
                            current[prop] = object[prop];
                    }
                }
                return current;
            }
        },
        _addCollectionChangeToHistory: function (node) {
            if (node.parent == "") {
                var childTable = {};
                if (this.selectionList && this.selectionList.length > 0)
                    childTable = this._getChildTable(this.selectionList[0], childTable);
                var entry = { type: "collectionchanged", object: jQuery.extend(true, {}, node), childTable: jQuery.extend(true, {}, childTable), changeType: "insert", category: "internal" };
                this.addHistoryEntry(entry);
            }
        },
        _recordPhasesizeChanged: function (args) {
            var undoObject = $.extend(true, {}, args.undoObject);
            var redoObject = $.extend(true, {}, args.redoObject);
            if (args.undo) {
                this._updatePhase({ name: undoObject.name, offset: undoObject.offset })
            }
            else {
                this._updatePhase({ name: redoObject.name, offset: redoObject.offset })
            }
        },
        _recordPortsCollectionChanged: function (args) {
            var changeType = args.changeType;
            if (args.isUndo) {
                if (args.changeType == "insert")
                    changeType = "remove";
                else
                    changeType = "insert";
            }
            var node = this.nameTable[args.object.name];
            if (changeType == "remove") {
                for (var i = 0; i < args.collection.length; i++) {
                    ej.datavisualization.Diagram.Util.removeItem(node.ports, args.collection[i]);
                    for (var i = 0; i < this._views.length; i++) {
                        var view = this._views[i];
                        var element = this._views[view].svg.document.getElementById(node.name + "_" + args.collection[i].name);
                        if (element)
                            element.parentNode.removeChild(element);
                    }
                }
            }
            else {
                for (var i = 0; i < args.collection.length; i++) {
                    node.ports.push(args.collection[i]);
                    ej.datavisualization.Diagram.DiagramContext.renderPort(node, args.collection[i], this);
                }
            }
        },

        //#endregion
        //#region Helper methods
		_initLaneContaier: function (element) {
            if (element.isLane) {
                element = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, element);
                var header = this.nameTable[this._getChild(element.children[0])];
                if (header && element.labels && header.labels.length > 0) {
                    header.ports = [];
                    for (var j = 0; j < header.labels.length; j++)
                        header.labels[j].visible = false;
                }
            }
            return element;
        },
        _addSymbolToDiagram: function (evt) {
            if (ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                var scale = this._currZoom;
                var offset = $("#" + this.element[0].id).offset();
                var coor = this._isTouchEvent(evt);
                if (!coor.pageX && !evt.pageX) {
                    if (evt.originalEvent && evt.originalEvent.changedTouches) {
                        coor = evt.originalEvent.changedTouches[0];
                    }
                    else if (evt && evt.changedTouches) {
                        coor = evt.changedTouches[0];
                    }
                }
                var x = (coor ? coor.pageX : evt.pageX) + this._hScrollOffset - offset.left;
                var y = (coor ? coor.pageY : evt.pageY) + this._vScrollOffset - offset.top;
                var paletteItem = $.extend(true, {}, this._selectedSymbol);
                var element;
                if (this._selectedSymbol) {
                    element = paletteItem;
                    if (!this._isNodeEnters) {
                        if (element && element.type != "pseudoGroup")
                            paletteItem.name += ej.datavisualization.Diagram.Util.randomId();
                        if (paletteItem.segments) {
                            ej.datavisualization.Diagram.Util._translateLine(paletteItem, x / scale, y / scale);
                        }
                        else {
                            this._cloneGroupNode(paletteItem, ej.datavisualization.Diagram.Util.randomId());
                            if (paletteItem._type === "group") {
                                var cBound = ej.datavisualization.Diagram.Util._getChildrenBounds(paletteItem, this);
                                ej.datavisualization.Diagram.Util._translate(paletteItem, (x / scale - cBound.x - cBound.height / 2), (y / scale - cBound.y - cBound.width / 2), this.nameTable, null, this);
                            } else {
                                paletteItem.offsetX = x / scale;
                                paletteItem.offsetY = y / scale;
                            }
                            if (paletteItem.isLane) {
                                var obj = ej.datavisualization.Diagram.SwimLaneHelper._createDiagramLane(paletteItem, this.nameTable);
                                obj.isLane = paletteItem.isLane;
                                obj.orientation = paletteItem.orientation;
                                element = obj;
                            }
                            if (paletteItem.type == "bpmn") delete element.children;
                        }
                    } else if (element.isSwimlane) {
                        this.nameTable[element.name] = element;
                        element = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, element, { childTable: this.childTable, object: element });
                        this._addAssiciatedChildConnectors(element);
                    }
                    if (element) {
                        var args = { element: element, cancel: false };
                        this._raiseEvent("dragEnter", args);
                        if (!args.cancel) {
                            if (this._isEditing) {
                                this._endEditing = true;
                                this._endEdit();
                                delete this._endEditing;
                            }
                            if (element && !this._isNodeEnters) {
                                element = this._initLaneContaier(element);
                                if (element.labels && element.labels.length > 0)
                                    for (var j = 0; j < element.labels.length; j++)
                                        element.labels[j].visible = false;
                            }
                            if (element.type != "pseudoGroup") {
                                if (element.isLane) {
                                    this.nameTable[element.children[0]]._isHeader = true;
                                }
                                this.add(element);
                            }
                            else {
                                for (var k = 0; k < element.children.length; k++) {
                                    this.add(element.children[k]);
                                    element.children[k] = element.children[k].name;
                                }
                                for (var conn in this.edgeTable) if (!this.nameTable[conn]) this.add(this.edgeTable[conn]);
                                if (this._hasSelection()) this._clearSelection(true);
                                this.nodes().push(element);
                                this._nodes = $.extend(true, [], this.nodes());
                                this.nameTable[element.name] = element;
                                ej.datavisualization.Diagram.Util._updateGroupBounds(element, this);
                                this.addSelection(element, true);
                            }
                            this._focusedElement = element;
                            if (element.isLane)
                                ej.datavisualization.Diagram.SvgContext._hideNode(element, this._svg);
                            this.element[0].focus();
                            this._toolToActivate = "move";
                            if (document.getElementsByClassName("e-paletteItem dragClone")[0]) {
                                $(".e-paletteItem.dragClone").css("display", "none");
                            }
                            this.activateTool("move", false);
                            this._symbolDrop = true;
                            this.activeTool.mousedown(evt);
                            this.activeTool.mousemove(evt);
                        }
                    }
                }
            }
            delete this._symbolDrop;
        },
        _removeSymbolFromDiagram: function () {
            if (this._selectedSymbol) {
                var displays = document.getElementsByClassName("e-paletteItem dragClone")[0];
                if (displays != null) {
                    displays.style.display = "block";
                }
                this._remove(this.selectionList[0]);
                this._selectedSymbol = null;
            }
        },
        _updateGroupChild: function (group) {
            var children = group.children;
            for (var i = 0; i < group.children.length; i++) {
                group.children[i] = this.nameTable[this._getChild(group.children[i])];
                if (group.children[i] && group.children[i]._type === "group") {
                    this._updateGroupChild(group.children[i]);
                }
            }
        },
        _dropSymbol: function (object, evt) {
            if (ej.datavisualization.Diagram.Util.isPageEditable(this)) {
                var actualObject = object || this.selectionList[0] || this.activeTool.selectedObject;
                var args = { element: this.getNode(actualObject) };
                if (this._nodeUnderMouse) {
                    args.target = this._nodeUnderMouse;
                }
                var added = false;
                if (!args.target) args.target = this.model;
                if (actualObject && actualObject._type === "group")
                    this._updateGroupChild(actualObject);
                this._remove(actualObject);
                this.nameTable[args.element.name] = args.element;
                this._selectedSymbol = null;
                var newElement = object || args.element;
                var overNode = this.activeTool._getMouseOverElement(evt);
                if (this.activeTool._outOfBoundsDrag(newElement) && ej.datavisualization.Diagram.canvasHelper._outOfBoundaryNodeDrop(this, this.activeTool.selectedObject, overNode)) {


                    this._raiseDropEvent(args);



                    if (!args.cancel) {
                        this._isInsert = true;
                        if (newElement && newElement.labels && newElement.labels.length > 0) {
                            for (var j = 0; j < newElement.labels.length; j++)
                                newElement.labels[j].visible = true;
                        }

                        if (overNode && overNode.container && ej.datavisualization.Diagram.Util.canAllowDrop(overNode) && !overNode.isSwimlane && ej.datavisualization.Diagram.bpmnHelper.canAllowDropOnContainer(this.activeTool.selectedObject, overNode)) {
                            ej.datavisualization.Diagram.canvasHelper._addNodeToContainer(this, this.activeTool.selectedObject, overNode);
                            this._raiseGroupChangeEvent(this.selectedObject, null, overNode, "group");
                        }

                        this._eventCause["nodeCollectionChange"] = this._eventCause["connectorCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.Drop;
                        added = this.add(newElement);
                        this.activeTool.selectedObject = this.selectionList[0];
                        this._isInsert = false;

                    }
                    if (added) {
                        var node = this.nameTable[args.element.name];
                        this._updateDroppedSymbol(node);
                    }
                    else
                        this.activeTool.selectedObject = null;
                }
                else {
                    this.activeTool.selectedObject = null;
                    delete this.nameTable[args.element.name];
                    this._clearSelection(true);
                }
                if (!ej.datavisualization.Diagram.Util.canDoSingleSelection(this)) {
                    this._clearSelection(true);
                    if (this.tool() & ej.datavisualization.Diagram.Tool.ZoomPan) {
                        this.activateTool("panTool");
                    }
                }
            }
        },
        _updateDroppedSymbol: function (node) {
            if (node && this.selectionList.length > 0) {
                this.scrollToNode(node);
                if ((node.labels.length > 0 && node.labels[0].mode === "edit") && !node.labels[0].readOnly) {
                    if (!node.isPhase && !(node.isSwimlane || node.isLane)) {
                        this._isEditing = true;
                        this.startLabelEdit(node, node.labels[0]);
                    }
                } else {
                    this.element[0].focus();
                }
                if (this._nodeUnderMouse && this._nodeUnderMouse.segments) {
                    ej.datavisualization.Diagram.SvgContext._removeConnectorHighlighter(this._adornerLayer, this._adornerSvg);
                }
            }
        },
        _initiateAutoScroll: function (evt) {
            if (this.activeTool.inAction && this.enableAutoScroll() && !(this.activeTool instanceof ej.datavisualization.Diagram.RotateTool)) {
                var viewPort = this._viewPort;
                var pt = this._mousePosition(evt, true);
                var autoScrollBorder = this.model.pageSettings.autoScrollBorder;
                if (pt.x + autoScrollBorder.right >= viewPort.width - 18) {
                    this._beginAutoScroll("right", evt);
                    this._canAutoScroll = true;
                }
                else if (pt.x <= autoScrollBorder.left) {
                    this._beginAutoScroll("left", evt);
                    this._canAutoScroll = true;
                }
                else if (pt.y + autoScrollBorder.bottom >= viewPort.height - 18) {
                    this._beginAutoScroll("bottom", evt);
                    this._canAutoScroll = true;
                }
                else if (pt.y <= autoScrollBorder.top) {
                    this._beginAutoScroll("top", evt);
                    this._canAutoScroll = true;
                }
                else {
                    this._canAutoScroll = false;
                }
            }
        },
        _updatePoints: function (helper, startPoint, endPoint, isTarget) {
            var offset = new ej.datavisualization.Diagram.Point(endPoint.x - startPoint.x, endPoint.y - startPoint.y);
            if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(offset)) {
                helper._updateEndPoint(offset.x, offset.y, isTarget);
            }
        },
        _cloneGroupNode: function (node, id, nameTable) {
            var child = null, clnObj;
            var children = node.children = this._getChildren(node.children);
            if (node._type === "group") {
                for (var i = 0; i < children.length; i++) {
                    if (nameTable)
                        child = nameTable[children[i]];
                    else {
                        if (this._paletteTable)
                            child = this._paletteTable[children[i]];
                    }
                    if (child) {
                        child = $.extend(true, {}, child);
                        if (child._type === "group")
                            this._cloneGroupNode(child, id);
                        clnObj = $.extend(true, {}, child);
                        clnObj.name += id;
                        clnObj.parent = node.name;
                        children[i] = clnObj.name;
                        this.nameTable[clnObj.name] = clnObj;
                    }
                }
            }
        },
        _addGroupConnector: function (group, arg) {
            var edges;
            var connector;
            var k, j, len, l;
            if (!group.segments) {
                var children = this._getChildren(group.children);
                for (k = 0; k < children.length; k++) {
                    var child = this.nameTable[children[k]];
                    if (child) {
                        if (child.inEdges && child.inEdges.length > 0) {
                            edges = child.inEdges;
                            for (j = 0, len = edges.length; j < len; j++) {
                                if (arg.edgeTable)
                                    connector = arg.edgeTable[edges[j]];
                                else
                                    connector = arg.childTable[edges[j]];
                                if (connector && !this.nameTable[connector.name])
                                    this.add(connector);
                            }
                        }
                        if (child.outEdges && child.outEdges.length > 0) {
                            edges = child.outEdges;
                            for (j = 0, len = edges.length; j < len; j++) {
                                if (arg.edgeTable)
                                    connector = arg.edgeTable[edges[j]];
                                else
                                    connector = arg.childTable[edges[j]];
                                if (connector && !this.nameTable[connector.name])
                                    this.add(connector);
                            }
                        }
                    }
                }
            }
        },
        _addConnector: function (node, arg) {
            var edges;
            var connector;
            var k, j, len, l;
            if (!node.segments) {
                if (node.inEdges && node.inEdges.length > 0) {
                    edges = node.inEdges;
                    for (j = 0, len = edges.length; j < len; j++) {
                        connector = arg ? arg.edgeTable[edges[j]] : this.nameTable[edges[j]];
                        connector.zOrder = -1;
                        this.add(connector);
                    }
                }
                if (node.outEdges && node.outEdges.length > 0) {
                    edges = node.outEdges;
                    for (j = 0, len = edges.length; j < len; j++) {
                        connector = arg ? arg.edgeTable[edges[j]] : this.nameTable[edges[j]];
                        connector.zOrder = -1;
                        this.add(connector);
                    }
                }
            }
        },
        _addChildren: function (group, childTable) {
            var children = this._getChildren(group.children);
            for (var i = 0; i < children.length; i++) {
                var node = childTable[children[i]];
                if (node._type === "group")
                    this._addChildren(node, childTable);
                this.nameTable[children[i]] = node;
                group.children[i] = node.name;
            }
        },
        _updateLabels: function (node, labels) {
            node.labels = labels;
            for (var i = 0; i < node.labels.length; i++)
                ej.datavisualization.Diagram.DiagramContext.updateLabel(node, node.labels[i], this);
        },
        _getNode: function (name, childTable) {
            if (!childTable)
                var node = typeof (name) === "object" ? this.nameTable[name.name] : this.nameTable[name];
            else var node = typeof (name) === "object" ? childTable[name.name] : childTable[name];
            if (!node && typeof (name) === "object") {
                node = name;
            }
            else if (node && typeof (name) === "string") {
                node = childTable ? childTable[name] : this.nameTable[name];
            }
            if (node) {
                if (node.isLane) {
                    return ej.datavisualization.Diagram.SwimLaneHelper._mapObject(this, node, "lane")
                }
                else if (node.isPhase || node.type === "phase") {
                    return ej.datavisualization.Diagram.SwimLaneHelper._mapObject(this, node, "phase")
                }
                else if (node.isSwimlane) {
                    return ej.datavisualization.Diagram.SwimLaneHelper._mapObject(this, node, "swimlane", childTable)
                }
                else if (node._type === "node" || node._type === "group" || node._type === "pseudoGroup" || this.getObjectType(node) == "node") {
                    return node;
                }
                    //else if (node.shape) {
                    //    return this._getNewNode(node);
                    //}
                    //else if (node.segments) {
                    //    return this._getNewConnector(node);
                    //}
                else
                    return node;
            }
            return null;
        },
        _updateEdges: function (connector) {
            var node;
            if (ej.datavisualization.Diagram.Util.isTargetConnected(connector)) {
                node = this.nameTable[connector.targetNode];
                if (node && node.inEdges.indexOf(connector.name) == -1)
                    node.inEdges.push(connector.name);
            }
            if (ej.datavisualization.Diagram.Util.isSourceConnected(connector)) {
                node = this.nameTable[connector.sourceNode];
                if (node && node.outEdges.indexOf(connector.name) == -1)
                    node.outEdges.push(connector.name);
            }
        },
        _updateChildrenEdges: function (object) {
            var children = this._getChildren(object.children);
            for (var i = 0; i < children.length; i++) {
                var child = children[i];
                if (child.segments) {
                    this._updateEdges(child);
                    this._dock(child, this.nameTable);
                }
                else if (child._type === "group") {
                    this._updateChildrenEdges(child);
                }
            }
        },
        _updateParent: function (object) {
            var children = this._getChildren(object.children);
            for (var i = 0; i < children.length; i++) {
                var index = this.nodes().indexOf(this.nameTable[children[i]]);
                var child = this.nameTable[children[i]];
                child = (child.type != "bpmn" && child.type != "connector") ? this._getNewNode(child) : child;
                if (child && child._type === "group") {
                    this._updateParent(child);
                }
                else if (child) {
                    child.parent = object.name;
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[child.name], this.nameTable[child.name]);
                    ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, this.nameTable[child.name]);
                    this.nameTable[child.name] = child;
                    if (index != -1) {
                        this.nodes()[index] = child;
                    }
                }
                this._updateQuad(this.nameTable[child.name]);
            }
        },
        _findPortAtPoint: function (point, node) {
            var ports;
            var port;
            var location;
            var size, pt, x, y;
            var bounds;
            if (node) {
                bounds = ej.datavisualization.Diagram.Util.bounds(node, true);
                ports = node.ports;
                var matrix;
                for (var i = 0, len = ports.length; i < len; ++i) {
                    port = ports[i];
                    size = ej.datavisualization.Diagram.Size(port.size, port.size);
                    pt = ej.datavisualization.Diagram.Util._getPortPosition(port, bounds);
                    matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                    pt = ej.Matrix.transform(matrix, pt);
                    x = pt.x - port.size / 2;
                    y = pt.y - port.size / 2;
                    location = ej.datavisualization.Diagram.Rectangle(x, y, size.width, size.height);
                    if (ej.datavisualization.Diagram.Geometry.containsPoint(location, point)) {
                        return ej.datavisualization.Diagram.Util.canConnect(port, true) ? port : null;
                    }
                }
            }
            return null;
        },
        _findLabelAtPoint: function (point, node) {
            var labels, label = null;
            var location;
            var size, pt, x, y, width, height, tempPt;
            var bounds, textElement, matrix;
            var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var intersectingLabels = [];
            if (node) {
                bounds = ej.datavisualization.Diagram.Util.bounds(node, true);
                labels = node.labels;
                if (labels.length > 0) {
                    label = labels[0];
                    for (var i = 0, len = labels.length; i < len; i++) {
                        label = labels[i];
                        textElement = $(htmlLayer).find("#" + node.name + "_" + label.name)[0];

                        width = textElement ? textElement.offsetWidth : 0;
                        height = textElement ? textElement.offsetHeight : 0;
                        if (!width) width = bounds.width;
                        if (!height) height = label.fontSize;
                        size = ej.datavisualization.Diagram.Size(width, height);
                        pt = ej.datavisualization.Diagram.Util._getLabelPosition(label, bounds);
                        pt.x = bounds.x + pt.x;
                        pt.y = bounds.y + pt.y;
                        matrix = ej.Matrix.identity();
                        if (!node.segments) ej.Matrix.rotate(matrix, -node.rotateAngle, node.offsetX, node.offsetY);
                        else ej.Matrix.rotate(matrix, 0, bounds.x + bounds.width / 2, bounds.y + bounds.height / 2);
                        tempPt = ej.Matrix.transform(matrix, point);
                        matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, -label.rotateAngle, pt.x, pt.y);
                        tempPt = ej.Matrix.transform(matrix, tempPt);

                        if (label.verticalAlignment == ej.datavisualization.Diagram.VerticalAlignment.Top) pt.y += size.height / 2;
                        else if (label.verticalAlignment == ej.datavisualization.Diagram.VerticalAlignment.Bottom) pt.y -= size.height / 2;

                        if (label.horizontalAlignment == ej.datavisualization.Diagram.HorizontalAlignment.Left) pt.x += size.width / 2;
                        else if (label.horizontalAlignment == ej.datavisualization.Diagram.HorizontalAlignment.Right) pt.x -= size.width / 2;

                        x = pt.x - size.width / 2;
                        y = pt.y - size.height / 2;
                        location = ej.datavisualization.Diagram.Rectangle(x, y, size.width, size.height);
                        if (ej.datavisualization.Diagram.Geometry.containsPoint(location, tempPt))
                            intersectingLabels.push(label);
                        if (i == labels.length - 1)
                            return (intersectingLabels.length ? intersectingLabels[intersectingLabels.length - 1] : null);
                    }
                }
            }
            return label;
        },
        _getCurrentZoom: function () {
            return this._currZoom;
        },
        _findNode: function (id) {
            return this.nameTable[id];
        },
        _findPort: function (node, portId) {
            var ports = node.ports;
            for (var i = 0, len = ports.length; i < len; i++) {
                if (ports[i].name === portId) {
                    return ports[i];
                }
            }
            return null;
        },
        _findLabel: function (node, labelId) {
            var labels = node.labels;
            for (var i = 0, len = labels.length; i < len; i++) {
                if (labels[i].name === labelId) {
                    return labels[i];
                }
            }
            return null;
        },
        _findConnector: function (id) {
            return this.nameTable[id];
        },
        _findChildren: function (group, name) {
            var child, innerchild;
            var children = this._getChildren(group.children);
            for (var i = 0; i < children.length; i++) {
                child = this.nameTable[children[i]];
                if (child) {
                    if (name == child.name) {
                        return child;
                    }
                    if (child._type === "group") {
                        innerchild = this._findChildren(child, name);
                        if (innerchild) return innerchild;
                    }
                }
            }
            return null;
        },
        _removeLaneParent: function (node) {
            if (node.isLane && node.parent) {
                var stack = this.nameTable[node.parent];
                if (stack.children && stack.children.length === 1) {
                    if (stack && stack.parent) {
                        var swimlane = this.nameTable[stack.parent];
                        if (swimlane) {
                            return { remove: true, node: swimlane };
                        }
                    }
                }
            }
            return { remove: false }
        },
        _delete: function (node) {
            var clearSelection = false;
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                node = node || this.selectionList[0];
                if (node) {
                    if (!node.isPhase && ((node.type && node.type != "phase") || node.segments || node._type == "node" || node._type == "pseudoGroup") || this._dropPhase) {
                        var removeParent = this._removeLaneParent(node)
                        if (removeParent.remove) {
                            node = removeParent.node;
                        }
                        if (!this._selectedSymbol) this._removeAdjacentConnections(node);
                        var obj = node;
                        if (obj.type == "pseudoGroup") {
                            var children = this._getChildren(obj.children);
                            this._multipleAction = true;
                            for (var i = children.length - 1; i >= 0; i--) {
                                if (this._remove(this.nameTable[children[i]]))
                                    clearSelection = true;
                                this._isUndo = true;
                            }
                            delete this._multipleAction;
                            this._isUndo = false;
                        }
                        else {
                            if (this._nodeUnderMouse === obj)
                                this._nodeUnderMouse = null;
                            clearSelection = this._remove(obj);
                            if (obj.container && obj.parent) {
                                var parent = this.nameTable[obj.parent];
                                if (parent && parent.container) {
                                    if (parent.container.type == "stack") {
                                        if (this._getChild(parent.children[0])) {
                                            var swimlane = this._getSwimlane(obj);
                                            if (swimlane)
                                                this._updateChildAdjacentConnectors(swimlane, true);
                                            ej.datavisualization.Diagram.DiagramContext.update(parent, this);
                                        } else {
                                            var prePar = this.nameTable[parent.parent];
                                            if (prePar) {
                                                this._remove(prePar);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (clearSelection)
                            this._clearSelection();
                    }
                    else if (node.type && node.type == "phase") {
                        this._removePhase(node.name);
                        this._clearSelection();
                    }
                }
            }
        },
        _removeAdjacentConnections: function (node, entry) {
            var childTable = {};
            var edgeTable = {};
            childTable = this._getChildTable(node, childTable);
            edgeTable = this._getEdgeTable(node, edgeTable);
            if (!this._isUndo || entry) {
                var sourcePorts = {}, targetPorts = {}, connector, count, i;
                if (!node.segments) {
                    if (node.outEdges && node.outEdges.length > 0) {
                        count = node.outEdges.length;
                        for (i = 0; i < count; i++) {
                            connector = this.nameTable[node.outEdges[i]];
                            if (connector && connector.sourcePort)
                                sourcePorts[connector.name] = connector.sourcePort;
                        }
                    }
                    if (node.inEdges && node.inEdges.length > 0) {
                        count = node.inEdges.length;
                        for (i = 0; i < count; i++) {
                            connector = this.nameTable[node.inEdges[i]];
                            if (connector && connector.targetPort)
                                targetPorts[connector.name] = connector.targetPort;
                        }
                    }
                }
                if (!this._isUndo) {
                    var index = null;
                    if (node.isLane) {
                        index = this._getRemoveIndex(node);
                    }
                    var entry = { type: "collectionchanged", object: this._updatePsedoGroupChildren(node), index: index, childTable: jQuery.extend(true, {}, childTable), edgeTable: jQuery.extend(true, {}, edgeTable), sourcePorts: sourcePorts, targetPorts: targetPorts, changeType: "remove", category: "internal" };
                    if (!node.isPhase) {
                        if (ej.datavisualization.Diagram.Util.canDelete(node))
                            this.addHistoryEntry(entry);
                    }
                }
                else {
                    entry.targetPorts = targetPorts;
                    entry.sourcePorts = sourcePorts;
                    entry.edgeTable = edgeTable;
                    entry.childTable = childTable;
                }
            }
        },
        _updatePsedoGroupChildren: function (node) {
            var obj = jQuery.extend(true, {}, node), child;
            if (node && node.type == "pseudoGroup") {
                for (var i = 0; i < obj.children.length; i++) {
                    child = this.nameTable[this._getChild(obj.children[i])];
                    if (child && child.isSwimlane) {
                        obj.children[i] = this.getNode(child);
                    }
                }
            }
            return obj;
        },
        _getRemoveIndex: function (lane, isReverse) {
            if (lane.parent) {
                var parent = this.nameTable[lane.parent], child;
                if (parent && parent.children && parent.children.length > 0) {
                    for (var i in parent.children) {
                        child = this._getChild(parent.children[i])
                        if (child === this._getChild(lane)) {
                            return Number(i);
                        }
                    }
                }
            }
            return 0;
        },
        _getSwimlaneHeader: function (group) {
            var header;
            if (group && group.isSwimlane) {
                if (group.children && group.children.length > 0) {
                    header = this.nameTable[group.children[0]];
                }
            }
            return header;
        },
        _addPhase: function (name, options, entryItem) {
            var group = this.nameTable[name];
            var excess = false;
            if (group && group.isSwimlane && options) {
                if (group && group.orientation && options.offset) {
                    if (group.orientation == "horizontal") {
                        var stoffset = group.offsetX - group.width / 2;
                        var laneHdr = this._getFirstLane(group);
                        if (laneHdr)
                            stoffset += laneHdr.width;
                        excess = ((options.offset > group.width) || (((group.offsetX - group.width / 2) + options.offset) < stoffset)) ? true : false;
                    }
                    else if (group.orientation == "vertical") {
                        stoffset = group.offsetY - group.height / 2;
                        var swlnhdr = this._getSwimlaneHeader(group);
                        if (swlnhdr)
                            stoffset += swlnhdr.height;
                        var laneHdr = this._getFirstLane(group);
                        if (laneHdr)
                            stoffset += laneHdr.height;
                        excess = (options.offset > group.height || (((group.offsetY - group.height / 2) + options.offset) < stoffset)) ? true : false;
                    }
                }
                if (options.offset && !excess) {
                    if (entryItem && entryItem.islastPhase) {
                        var itemPhase = entryItem.phase;
                        if (group.orientation === "horizontal") {
                            if (group.width > options.offset) {
                                options.width += (group.width - options.offset);
                                options.offset = group.width;
                            }
                        }
                        else {
                            if ((group.height - swlnhdr.height) > options.offset) {
                                options.height += ((group.height - swlnhdr.height) - options.offset);
                                options.offset = group.height - swlnhdr.height;
                            }
                        }
                    }
                    var phase = ej.datavisualization.Diagram.Phase(options);
                    phase.orientation = group.orientation;
                    phase.label = ej.datavisualization.Diagram.Label(options.label ? options.label : { text: "Phase" });
                    phase.parent = group.name;
                    if (this.nameTable[phase.name]) {
                        ej.datavisualization.Diagram.Util.removeItem(this.model.phases, this.nameTable[phase.name]);
                        delete this.nameTable[phase.name];
                    }
                    if (entryItem && entryItem.islastPhase) {
                        var index = this._getInsertIndex(phase) + 1;
                        var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this, group);
                        var prevPhase = $.extend(true, {}, entryItem.phaseObject.prevPhase);
                        this._updateInsertPhase(phase, prevPhase.name, group, index, entryItem);
                        ej.datavisualization.Diagram.SvgContext.renderphase(phase, this._svg, this._diagramLayer, this, group);
                        ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, this.nameTable[this._getChild(group.children[1])], true);
                        ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdatePhase(this, phase);
                    }
                    else {
                        var index = this._getInsertIndex(phase) + 1;
                        var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this, group);
                        var prevPhase = $.extend(true, {}, this.nameTable[this._getChild(phases[index - 1])]);
                        this._updateInsertPhase(phase, phases[index], group, index);
                        ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                        ej.datavisualization.Diagram.SvgContext.renderphase(phase, this._svg, this._diagramLayer, this, group);
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, this.nameTable[this._getChild(group.children[1])], true);
                        ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdatePhase(this, phase);
                    }
                    if (!this._isUndo) {
                        var entry = { type: "phasecollectionchanged", phase: phase, category: "internal", group: group.name, isAdded: true };
                        this.addHistoryEntry(entry);
                    }
                }
            }
            this._clearSelection(true);
        },
        _removePhase: function (name, needDelete) {
            var phase = this.nameTable[name];
            var islastPhase = false;
            var phaseObject = null;
            if (phase) {
                this._raiseChildrenPropertyChange(phase);
                var parent = this.nameTable[phase.parent.split('phaseStack')[0]];
                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this, parent);

                if (parent && phases && phases.length > 1) {
                    var diagram = this;
                    var index = phases.indexOf(phase.name);

                    this._views.forEach(function (viewid) {
                        var view = diagram._views[viewid];
                        var phaseEle = view.svg.getElementById(name + "_phase_g");
                        if (phaseEle)
                            phaseEle.parentNode.removeChild(phaseEle);
                    });
                    var nextPhase = ej.datavisualization.Diagram.SwimLaneContainerHelper._getNextPhase(this, phase);
                    if (index === phases.length - 1) {
                        nextPhase = ej.datavisualization.Diagram.SwimLaneContainerHelper._getPrevPhase(this, phase);
                        phaseObject = $.extend(true, {}, { prevPhase: nextPhase, currPhase: phase });
                        nextPhase.offset = phase.offset;
                        islastPhase = true;
                    }
                    if (parent.orientation === "horizontal")
                        nextPhase.width += phase.width;
                    else
                        nextPhase.height += phase.height;

                    var delNode = this.nameTable[name];
                    ej.datavisualization.Diagram.Util.removeItem(this.nodes(), delNode);
                    this._nodes = $.extend(true, [], this.nodes());
                    var stack = this.nameTable[delNode.parent];
                    delete this.nameTable[name];
                    ej.datavisualization.Diagram.SvgContext._updatephase(nextPhase, this);
                    ej.datavisualization.Diagram.Util.removeItem(phases, phase.name);
                    ej.datavisualization.Diagram.Util.removeItem(stack.children, delNode.name);
                    ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, stack, true);
                    ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdatePhase(this, phase);
                    var diagram = this;
                    this._views.forEach(function (viewid) {
                        var view = diagram._views[viewid];
                        var phaseEle = view.svg.getElementById(name);
                        if (phaseEle)
                            phaseEle.parentNode.removeChild(phaseEle);
                        var htmlLayer = view.svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                        var label = $(htmlLayer).find("#" + delNode.name)[0];
                        var element = view.svg.getElementById(delNode.name);
                        if (element && element.parentNode)
                            element.parentNode.removeChild(element);
                        if (label)
                            htmlLayer.removeChild(label);
                    });
                    if (!this._isUndo) {
                        var entry = { type: "phasecollectionchanged", phase: phase, group: parent.name, category: "internal", phaseObject: phaseObject, islastPhase: islastPhase, isAdded: false };
                        this.addHistoryEntry(entry);
                    }
                }
            }
        },

        _getEdgeTable: function (group, edgeTable) {
            var edges, len, i, j, depend;
            if (!group.segments) {
                if (group._type === "group" || group._type === "pseudoGroup") {
                    var children = this._getChildren(group.children);
                    for (i = 0; i < children.length; i++) {
                        var node = this.nameTable[children[i]];
                        if (node && node.inEdges && node.inEdges.length > 0) {
                            edges = node.inEdges;
                            for (j = 0, len = edges.length; j < len; j++) {
                                depend = this.nameTable[edges[j]];
                                if (depend)
                                    var table = edgeTable[depend.name] = $.extend(true, {}, depend);
                            }
                        }
                        if (node && node.outEdges && node.outEdges.length > 0) {
                            edges = node.outEdges;
                            for (j = 0, len = edges.length; j < len; j++) {
                                depend = this.nameTable[edges[j]];
                                if (depend)
                                    var table = edgeTable[depend.name] = $.extend(true, {}, depend);
                            }
                        }
                    }
                }
                if (group.inEdges && group.inEdges.length > 0) {
                    edges = group.inEdges;
                    for (j = 0, len = edges.length; j < len; j++) {
                        depend = this.nameTable[edges[j]];
                        if (depend)
                            var table = edgeTable[depend.name] = $.extend(true, {}, depend);
                    }
                }
                if (group.outEdges && group.outEdges.length > 0) {
                    edges = group.outEdges;
                    for (j = 0, len = edges.length; j < len; j++) {
                        depend = this.nameTable[edges[j]];
                        if (depend)
                            var table = edgeTable[depend.name] = $.extend(true, {}, depend);
                    }
                }
            }
            return edgeTable;
        },
        _remove: function (obj, dependent, isClear) {
            var isObjectDeleted = false;
            this._raiseChildrenPropertyChange(obj);
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                if (obj && (ej.datavisualization.Diagram.Util.canDelete(obj) || isClear)) {
                    var type;
                    if (obj.segments) type = "connector";
                    else type = "node";
                    var dependent = dependent ? ej.datavisualization.Diagram.dependentconnector.dependent : ej.datavisualization.Diagram.dependentconnector.independent;
                    var args = { changeType: "remove", element: this.getNode(obj), cancel: false, dependent: dependent, state: "changing" };
                    if (!obj.segments) { args.adjustDependent = true; args.deleteDependent = true; }

                    var cause = this._eventCause[type + "CollectionChange"];
                    if (!cause) {
                        if (this._isKeyDown || this._isUndo)
                            this._eventCause[type + "CollectionChange"] = (this._isUndo && !this._multipleAction) ? ej.datavisualization.Diagram.CollectionChangeCause.HistoryChange : ej.datavisualization.Diagram.CollectionChangeCause.Keydown;
                    }
                    if (!obj.isPhase && !this._selectedSymbol && !obj.isLane)
                        this._raiseEvent(type + "CollectionChange", args);
                    if (!args.cancel) {
                        isObjectDeleted = true;
                        var name = obj.name;
                        if (obj.type == "group" && obj.type != "pseudoGroup") {
                            var children = this._getChildren(obj.children);
                            for (var i = 0; i < children.length; i++) {
                                var child = this.nameTable[children[i]];
                                if (child && !ej.datavisualization.Diagram.Util.canDelete(child)) return;
                            }
                        }
                        if (obj.isSwimlane) {
                            ej.datavisualization.Diagram.SvgContext._removephases(obj, this);
                        }
                        if (obj.type == "bpmn") {
                            var children = this._getChildren(obj.children);
                            for (var i = 0; children && i < children.length; i++) {
                                var child = this.nameTable[children[i]];
                                if (child && child.annotation && child._annotation)
                                    for (var n = 0; n < child._annotation.length; n++)
                                        if (this.nameTable[child._annotation[n]]) this._remove(this.nameTable[child._annotation[n]], dependent, true);
                            }
                        }

                        if (!obj.segments) {
                            if (obj.annotation && obj._annotation) {
                                for (var n = 0; n < obj._annotation.length; n++)
                                    if (this.nameTable[obj._annotation[n]]) this._remove(this.nameTable[obj._annotation[n]]);
                            }
                            this._disConnect(obj, args);
                            //if (obj.type != "group")
                            this._removeConnector(obj, args);
                            if (this._crudDeleteNodes && !this._selectedSymbol) {
                                this._crudDeleteNodes.push(this.nameTable[obj.name]);
                            }
                            ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this.nameTable[obj.name]);
                            this._nodes = $.extend(true, [], this.nodes());
                        } else {
                            this._removeEdges(obj);
                            obj.sourceNode = obj.sourcePort = obj.targetNode = obj.targetPort = null;
                            if (this._crudDeleteNodes && !this._selectedSymbol) {
                                this._crudDeleteNodes.push(this.nameTable[obj.name]);
                            }
                            ej.datavisualization.Diagram.Util.removeItem(this.connectors(), this.nameTable[obj.name]);
                            this._connectors = $.extend(true, [], this.connectors());
                        }
                        type = this.getObjectType(obj);
                        ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(this._spatialSearch, this._spatialSearch.quadTable[obj.name], obj);
                        ej.datavisualization.Diagram.SpatialUtil._updateBounds(this, this._spatialSearch, obj, false);
                        if (obj.parent) {
                            var parent = this.nameTable[obj.parent];
                            if (parent && (parent.type == "group" || parent.type == "bpmn" || parent.type == "umlclassifier")) {
                                ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, obj.name);
                                ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                                //this._disableSwimlaneUptate = true;
                                var prevObj = $.extend(true, {}, parent)
                                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(this, parent, true);
                                //delete this._disableSwimlaneUptate;
                                if (parent.parent)
                                    ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, this.nameTable[parent.parent]);
                                ej.datavisualization.Diagram.Util._refreshParentGroup(obj, this);
                                ej.datavisualization.Diagram.canvasHelper._updateAddRemoveNodeConnectors(this, parent, prevObj);
                                ej.datavisualization.Diagram.canvasHelper._updateAddRemoveLaneConnectors(this, obj)
                                ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, this.nameTable[parent.parent]);
                                this._updateQuad(parent);
                            }
                        }
                        delete this.nameTable[name];
                        if (obj.segments)
                            this._updateConnectorBridging(obj);
                        var element = this._svg.getElementById(obj.name);
                        if (obj._type == "group" && obj.type != "pseudoGroup") {
                            this._removeChildren(obj, args);
                        }
                        this._removeElement(obj);

                        if (element && element.parentNode)
                            element.parentNode.removeChild(element);
                        ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.activeTool.selectedObject, this._adornerSvg, this._adornerLayer);
                        this._clearSelection((this._selectedSymbol || this._dropPhase) ? true : false);

                    }
                }
            }
            if (isObjectDeleted && !obj.isPhase && !this._selectedSymbol) {
                args.state = "changed";
                if (obj.type === "connector")
                    this._raiseEvent("connectorCollectionChange", args);
                else
                    this._raiseEvent("nodeCollectionChange", args);
            }
            return isObjectDeleted;
        },
        _removeConnector: function (node, args) {
            var edges;
            var connector;
            var i, len;
            if (!node.segments) {
                //If adjustDependent is false all connector associated with Nodes get deleted.
                if (args.deleteDependent && !(args.adjustDependent)) {
                    if (node.inEdges && node.inEdges.length > 0) {
                        edges = node.inEdges;
                        for (i = edges.length - 1 ; i >= 0; i--) {
                            //Remove the Connector
                            this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                    if (node.outEdges && node.outEdges.length > 0) {
                        edges = node.outEdges;
                        for (i = 0, len = edges.length; i < len; i++) {
                            //Remove the Connector
                            this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                }
                //If both deleteDependent & adjustDependent are true changes to Visio behaviour
                if (args.deleteDependent && args.adjustDependent) {
                    if (node.inEdges && node.inEdges.length > 0 && node.outEdges && node.outEdges.length > 0) {
                        edges = node.outEdges;
                        for (i = edges.length - 1 ; i >= 0; i--) {
                            //Remove the Connector
                            this._updateConnection(this.nameTable[edges[i]], true);
                        }
                        edges = node.inEdges;
                        for (i = edges.length - 1 ; i >= 0; i--) {
                            //Remove the Connector
                            if (this.nameTable[edges[i]])
                                this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                    else if (node.inEdges && node.inEdges.length == 0 && node.outEdges.length > 0) {
                        edges = node.outEdges;
                        for (i = edges.length - 1 ; i >= 0; i--) {
                            //Remove the Connector
                            this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                    else if (node.outEdges && node.outEdges.length == 0 && node.inEdges.length > 0) {
                        edges = node.inEdges;
                        for (i = edges.length - 1 ; i >= 0; i--) {
                            //Remove the Connector
                            if (this.nameTable[edges[i]])
                                this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                    else if ((node.inEdges && node.inEdges.length == 1 || node.inEdges.length > 1) && (node.outEdges.length == 1)) {
                        edges = node.outEdges;
                        for (i = 0, len = edges.length; i < len; i++) {
                            //Remove the Connector
                            this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                    else if (!(node.inEdges && node.inEdges.length > 1 && node.outEdges.length > 1)) {
                        edges = node.inEdges;
                        for (i = 0, len = edges.length; i < len; i++) {
                            //Remove the Connector
                            this._updateConnection(this.nameTable[edges[i]], true);
                        }
                    }
                }
            }
        },
        _updateConnection: function (connector, args) {
            if (connector && ej.datavisualization.Diagram.Util.canDelete(connector)) {
                this._remove(connector, args);
                this.updateConnector(connector.name);
            }
        },
        _removeElement: function (element) {
            for (var i = 0; i < this._views.length; i++) {
                var view = this._views[i];
                this._views[view].context.removeChild(element, this._views[view]);
            }
        },
        _disConnect: function (node, args, isChild) {
            var edgesIn, edgesOut, connector, parentNode, targetNode, data;
            var i, j, leni, lenj, canDelete;
            if (node.inEdges && node.inEdges.length > 0) {
                edgesIn = node.inEdges;
                for (i = 0, leni = edgesIn.length; i < leni; i++) {
                    if (ej.datavisualization.Diagram.Util.canDelete(this.nameTable[edgesIn[i]]))
                        canDelete = true;
                }
            }
            if (node.outEdges && node.outEdges.length > 0) {
                edgesOut = node.outEdges;
                for (i = 0, leni = edgesOut.length; i < leni; i++) {
                    if (ej.datavisualization.Diagram.Util.canDelete(this.nameTable[edgesOut[i]]))
                        canDelete = true;
                }
            }
            if (args.deleteDependent && args.adjustDependent && !isChild && canDelete) {
                if (node.inEdges && node.inEdges.length > 0 && node.outEdges.length > 0) {
                    edgesIn = node.inEdges;
                    edgesOut = node.outEdges;
                    if ((node.inEdges.length > 1 || node.inEdges.length == 1) && node.outEdges.length == 1) {
                        for (i = 0, leni = edgesIn.length; i < leni; i++) {
                            if (this.nameTable[edgesIn[i]] && this.nameTable[edgesOut[0]]) {
                                if ((this.nameTable[edgesIn[i]].targetNode == this.nameTable[edgesOut[0]].sourceNode)) {
                                    targetNode = this.nameTable[this.nameTable[edgesOut[0]].targetNode];
                                    if (targetNode) {
                                        data = $.extend(true, {}, targetNode);
                                        if (this.nameTable[edgesIn[i]].sourceNode != this.nameTable[edgesOut[0]].targetNode) {
                                            this.nameTable[edgesIn[i]].targetNode = this.nameTable[edgesOut[0]].targetNode;
                                            this.nameTable[edgesIn[i]].targetPort = this.nameTable[edgesOut[0]].targetPort;
                                            targetNode.inEdges.push(this.nameTable[edgesIn[i]].name);
                                        }
                                    }
                                    //Updating the Connector Dock and Connector
                                    ej.datavisualization.Diagram.Util.dock(this.nameTable[edgesIn[i]], this.nameTable);
                                    ej.datavisualization.Diagram.DiagramContext.update(this.nameTable[edgesIn[i]], this);
                                }
                            }
                        }
                        if (this.nameTable[edgesOut[0]]) {
                            this.nameTable[edgesOut[0]].sourceNode = null;
                            this.nameTable[edgesOut[0]].sourcePort = null;
                        }
                    }
                    else if (!(node.inEdges.length > 1 && node.outEdges.length > 1)) {
                        // Need to code when many in and only one out 
                        for (i = 0, leni = edgesIn.length; i < leni; i++) {
                            if (node.outEdges.length > 0) {
                                if (this.nameTable[edgesIn[i]]) {
                                    parentNode = this.nameTable[this.nameTable[edgesIn[i]].sourceNode];
                                    data = $.extend(true, {}, parentNode);
                                    for (j = 0, lenj = edgesOut.length; j < lenj; j++) {
                                        if ((this.nameTable[edgesIn[i]].targetNode == this.nameTable[edgesOut[j]].sourceNode)) {
                                            this.nameTable[edgesOut[j]].sourceNode = this.nameTable[edgesIn[i]].sourceNode;
                                            this.nameTable[edgesOut[j]].sourcePort = this.nameTable[edgesIn[i]].sourcePort;
                                            parentNode.outEdges[data.outEdges.length + j] = this.nameTable[edgesOut[j]].name;
                                            //Updating the Connector Dock and Connector
                                            ej.datavisualization.Diagram.Util.dock(this.nameTable[edgesOut[j]], this.nameTable);
                                            ej.datavisualization.Diagram.DiagramContext.update(this.nameTable[edgesOut[j]], this);
                                        }
                                    }
                                    this.nameTable[edgesIn[i]].targetNode = null;
                                    this.nameTable[edgesIn[i]].targetPort = null;
                                }
                            }
                        }
                    }
                } return;
            }
            if (node.inEdges && node.inEdges.length > 0) {
                edgesIn = node.inEdges;
                for (i = 0, leni = edgesIn.length; i < leni; i++) {
                    connector = this.nameTable[edgesIn[i]];
                    if (connector) {
                        connector.targetNode = null;
                        connector.targetPort = null;
                    }
                }
            }
            if (node.outEdges && node.outEdges.length > 0) {
                edgesOut = node.outEdges;
                for (i = 0, leni = edgesOut.length; i < leni; i++) {
                    connector = this.nameTable[edgesOut[i]];
                    if (connector) {
                        connector.sourceNode = null;
                        connector.sourcePort = null;
                    }
                }
            }
        },
        _removeEdges: function (connector) {
            if (connector.targetNode) {
                if (this.nameTable[connector.targetNode] && this.nameTable[connector.targetNode].inEdges)
                    ej.datavisualization.Diagram.Util.removeItem(this.nameTable[connector.targetNode].inEdges, connector.name);
            }
            if (connector.sourceNode) {
                if (this.nameTable[connector.sourceNode] && this.nameTable[connector.sourceNode].outEdges)
                    ej.datavisualization.Diagram.Util.removeItem(this.nameTable[connector.sourceNode].outEdges, connector.name);
            }
        },
        _selectionContains: function (node) {
            if (this._hasSelection() && node)
                for (var i = 0; i < this.selectionList.length; i++) {
                    if (node.name === this.selectionList[i].name)
                        return true;
                }
            return false;
        },
        _getPhaseIndex: function (name) {
            return ej.datavisualization.Diagram.SwimLaneContainerHelper._getPhaseIndex(this, name);
        },
        _getPhaseBounds: function (phase) {
            return ej.datavisualization.Diagram.SwimLaneContainerHelper._getPhaseBounds(this, phase);
        },
        _addSelection: function (selectedShape, preventEvent) {
            if ((ej.datavisualization.Diagram.Util.isPageEditable(this) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this)) && (ej.datavisualization.Diagram.Util.canDoSingleSelection(this) || (selectedShape && selectedShape._type === "pseudoGroup" || this._selectedSymbol) || ej.datavisualization.Diagram.Util.canEnableAPIMethods(this))) {
                if (selectedShape && (ej.datavisualization.Diagram.Util.canSelect(selectedShape) || selectedShape.type == "phase")) {
                    if (!this._selectionContains(selectedShape)) {
                        var newItems = [], oldItems = [], selectedItems = [];
                        if (this._previousSelectedItems) oldItems = this._previousSelectedItems;
                        if (selectedShape.type == "pseudoGroup") {
                            var children = this._getChildren(selectedShape.children);
                            for (var i = 0; i < children.length; i++) {
                                var child = this.nameTable[children[i]];
                                if (oldItems.indexOf(child) == -1) newItems.push(child);
                                else ej.datavisualization.Diagram.Util.removeItem(oldItems, child);
                                selectedItems.push(child);
                            }
                        }
                        else {
                            newItems.push(selectedShape);
                            selectedItems.push(selectedShape);
                        }
                        var cause = this._eventCause["selectionChange"];
                        if (!cause)
                            this._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Unknown;
                        var element = this.getNode(selectedShape)
                        var args = { changeType: "insert", element: this.getNode(selectedShape), state: "changing", selectedItems: selectedItems, oldItems: oldItems, newItems: newItems, cancel: false };
                        if ((!this._selectedSymbol || this._endEditing) && !preventEvent) {
                            this._raiseEvent("selectionChange", args);
                            this._previousSelectedItems = args.newItems;
                        }
                        if (!args.cancel) {
                            this.selectionList.push(selectedShape);
                            this._updateSelectorObject(selectedShape);
                            if (selectedShape.isPhase)
                                var bounds = this._getPhaseBounds(selectedShape);
                            //  if (selectedShape.type !="umlclassifier")
                            ej.datavisualization.Diagram.SvgContext.renderSelector(selectedShape, this._adornerSvg, this._adornerLayer, this._currZoom,
                                this.model.selectedItems.constraints, bounds);
                            if ((this.model.selectedItems.userHandles != null && this.model.selectedItems.userHandles.length > 0)) {
                                var isMultipleSelection = false;
                                if (selectedShape.type == "pseudoGroup")
                                    isMultipleSelection = true;
                                if (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                                    ej.datavisualization.Diagram.SvgContext.renderUserHandles(this.model.selectedItems.userHandles, selectedShape, this._adornerSvg, isMultipleSelection, this._currZoom, this._adornerLayer, this);
                            }
                            if ((!this._selectedSymbol || this._endEditing) && !preventEvent) {
                                args = { changeType: "insert", element: this.getNode(selectedShape), state: "changed", cause: args.cause, selectedItems: selectedItems, oldItems: oldItems, newItems: newItems, cancel: false };
                                this._raiseEvent("selectionChange", args);
                            }
                        }
                    }
                }
            }
        },
        _getInsertIndex: function (phase) {
            var index = -1, offset, cphase;
            var group = this.nameTable[phase.parent];
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this, group);
            if (phases && phases.length > 0) {
                if (this.nameTable[phases[0]]) {
                    offset = this.nameTable[phases[0]].offset;
                    for (var i = 0; i < phases.length; i++) {
                        cphase = this.nameTable[phases[i]];
                        if (cphase && cphase.offset <= phase.offset && cphase.offset >= offset) {
                            offset = cphase.offset;
                            index = i;
                        }
                    }
                }
            }
            return index;
        },
        _updateInsertPhase: function (nphase, ophase, group, index, entryItem) {
            var oldPhase = this.nameTable[ophase];
            var phaseStack = this.nameTable[this._getChild(group.children[1])];

            if (phaseStack && phaseStack.children && phaseStack.children.length > 0) {
                var oldChild = this.nameTable[ophase];
                var newStackChild = ej.datavisualization.Diagram.Node(nphase);
                if (group.isSwimlane && group.orientation && group.orientation == "vertical") {
                    if (entryItem) {
                        h = nphase.height
                        oldChild.height = entryItem.phaseObject.prevPhase.height;
                        oldChild.offset = entryItem.phaseObject.prevPhase.offset;
                    }
                    else {
                        var h = oldChild.height;
                        oldChild.height = oldPhase.offset - nphase.offset;
                        var dH = h - oldChild.height;
                        newStackChild.height = dH;
                    }
                    newStackChild.parent = phaseStack.name;
                    newStackChild.name = nphase.name;
                    newStackChild.width = oldChild.width;
                    newStackChild.isPhase = true;
                }
                else {
                    if (entryItem) {
                        w = nphase.width
                        oldChild.width = entryItem.phaseObject.prevPhase.width;
                        oldChild.offset = entryItem.phaseObject.prevPhase.offset;
                    }
                    else {
                        var w = oldChild.width;
                        oldChild.width = oldPhase.offset - nphase.offset;
                        var dW = w - oldChild.width;
                        newStackChild.width = dW;
                    }
                    newStackChild.parent = phaseStack.name;
                    newStackChild.name = nphase.name;
                    newStackChild.height = oldChild.height;

                    newStackChild.isPhase = true;
                    //var newStackChild = ej.datavisualization.Diagram.Node({ parent: phaseStack.name, name: nphase.name, height: oldChild.height, width: dW, isPhase: true });
                }
                newStackChild.x = 0;
                newStackChild.y = 0;
                if (!this._isUndo || newStackChild.labels.length === 0)
                    newStackChild.labels = [(nphase.label ? nphase.label : ej.datavisualization.Diagram.Label())];
                newStackChild.labels[0].rotateAngle = (nphase.orientation == "horizontal") ? 0 : 270;
                newStackChild.constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.Select | ej.datavisualization.Diagram.NodeConstraints.Connect);
                newStackChild.isPhase = true;
                newStackChild._type = "node";
                this.add(newStackChild, { entryHistory: true });
                //#region swapping the element 
                phaseStack.children.pop(newStackChild.name);
                phaseStack.children.splice(index, 0, newStackChild.name);
                //#endregion  
            }
        },
        _getFirstLane: function (group) {
            if (group.children[2])
                var stack = this.nameTable[this._getChild(group.children[2])];
            if (stack && stack.children && stack.children.length > 0) {
                var lane = this.nameTable[this._getChild(stack.children[0])]
                if (lane && lane.children && lane.children.length > 0) {
                    var laneHdr = this.nameTable[this._getChild(lane.children[0])];
                    if (laneHdr)
                        return laneHdr;
                }
            }
            return null;
        },
        updateSelector: function (option) {
            if (this._selectedItem != "") {
                var options = {};
                if (option.offsetX)
                    options.offsetX = Number(typeof option.offsetX === 'function' ? option.offsetX() : option.offsetX);
                if (option.offsetY)
                    options.offsetY = Number(typeof option.offsetY === 'function' ? option.offsetY() : option.offsetY);
                if (option.width)
                    options.width = Number(typeof option.width === 'function' ? option.width() : option.width);
                if (option.height)
                    options.height = Number(typeof option.height === 'function' ? option.height() : option.height);
                if (option.rotateAngle)
                    options.rotateAngle = Number(typeof option.rotateAngle === 'function' ? option.rotateAngle() : option.rotateAngle);
                this.updateNode(this._selectedItem, options);
            }
            if (option.userHandles) {
                this.model.selectedItems.userHandles = option.userHandles;
                this._initHandles();
                if (this.selectionList[0] && this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                    ej.datavisualization.Diagram.SvgContext.updateUserHandles(this.model.selectedItems.userHandles, this.selectionList[0], this._adornerSvg, this.selectionList[0].type == "pseudoGroup", false, this._currZoom, this);
            }
            if (option.tooltip) {
                this.model.selectedItems.tooltip = ej.datavisualization.Diagram.Tooltip($.extend(true, this.model.selectedItems.tooltip, {}, option.tooltip));
            }
        },
        _updateSelectorObject: function (selectedShape) {
            if (!selectedShape.segments) {
                this._selectorOffsetX(selectedShape.offsetX);
                this._selectorOffsetY(selectedShape.offsetY);
                this._selectorWidth(selectedShape.width);
                this._selectorHeight(selectedShape.height);
                this._selectorRotateAngle(selectedShape.rotateAngle);
                this._selectedItem = selectedShape.name;
            }
            if (selectedShape.type == "pseudoGroup") {
                for (var i = 0; i < selectedShape.children.length; i++) {
                    var child = selectedShape.children[i];
                    if (typeof (child) === "object") {
                        if (this.model.selectedItems.children.indexOf(child) < 0)
                            this.model.selectedItems.children.push(child);
                    }
                    else if (typeof (child) === "string") {
                        if (this.model.selectedItems.children.indexOf(this.nameTable[child]) < 0)
                            this.model.selectedItems.children.push(this.nameTable[child]);
                    }
                }
            }
            else {
                if (this.model.selectedItems.children.indexOf(selectedShape) < 0)
                    this.model.selectedItems.children.push(selectedShape);
            }
        },
        _clearSelectorObject: function () {
            this._selectorOffsetX(0);
            this._selectorOffsetY(0);
            this._selectorWidth(0);
            this._selectorHeight(0);
            this._selectorRotateAngle(0);
            this._selectedItem = "";
            this.model.selectedItems.children = [];
        },
        _raiseEvent: function (type, args) {
            if (this.model[type]) {
                args.elementType = this.getObjectType(args.element);
                if (((type === "nodeCollectionChange" || type === "connectorCollectionChange" || type === "selectionChange") && args.state === "changing") || type === "scrollChange")
                    args.cause = this._eventCause[type] ? this._eventCause[type] : "unknown";
                if (!this._multipleAction)
                    this._eventCause = {};
                args.diagramId = this.element[0].id;
                return this._trigger(type, args);
            }
        },
        _clearSelection: function (preventEvent) {
            if (this._hasSelection()) {
                if (this._isEditing && this.selectionList.length > 0 && !this._isDragg) {
                    this._endEdit();
                }
                var args = { changeType: "remove", state: "changing", element: null, selectedItems: [], oldItems: this.model.selectedItems.children, newItems: [], cancel: false };
                if (!this._selectedSymbol && !preventEvent) {
                    this._raiseEvent("selectionChange", args);
                    this._previousSelectedItems = [];
                }
                if (!args.cancel) {
                    this._clearSelectorObject();
                    if (this.selectionList[0] && this.selectionList[0].type == "pseudoGroup") {
                        ej.datavisualization.Diagram.Util.removeItem(this.nodes(), this.selectionList[0]);
                        this._nodes = $.extend(true, [], this.nodes());
                        delete this.nameTable[this.selectionList[0].name];
                    }
                    ej.datavisualization.Diagram.Util.clear(this.selectionList);
                    ej.datavisualization.Diagram.SvgContext.clearSelector(this._adornerSvg, this._adornerLayer);
                    if (!this._selectedSymbol && !preventEvent) {
                        args = { changeType: "remove", state: "changed", cause: args.cause, element: null, selectedItems: [], oldItems: this.model.selectedItems.children, newItems: [], cancel: false };
                        this._raiseEvent("selectionChange", args);
                    }
                }
            }
        },
        _updateSelectionHandle: function (isDragging) {
            if (this.selectionList.length > 0) {
                var shape = this.nameTable[this.selectionList[0].name];
                var constraints = this.model.selectedItems.constraints;
                if (isDragging && (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles))
                    constraints = constraints & ~ej.datavisualization.Diagram.SelectorConstraints.UserHandles;
                this._updateSelectorObject(shape);
                var updated = ej.datavisualization.Diagram.SvgContext.updateSelector(shape, this._adornerSvg, this._currZoom, this, constraints);
                if (!updated) {
                    if ((this.model.selectedItems.userHandles != null && this.model.selectedItems.userHandles.length > 0)) {
                        var isMultipleSelection = false;
                        if (shape.type == "pseudoGroup")
                            isMultipleSelection = true;
                        if (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                            ej.datavisualization.Diagram.SvgContext.updateUserHandles(this.model.selectedItems.userHandles, shape, this._adornerSvg, isMultipleSelection, isDragging, this._currZoom, this);
                    }
                }
            }
        },
        _hasSelection: function () {
            return this.selectionList.length > 0;
        },
        _checkToolToActivate: function (evt, node) {
            var success = false;
            var pseudoGroupConstraints;
            pseudoGroupConstraints = ej.datavisualization.Diagram.Util._getPseudoGroupConstraints(this, node, this.selectionList[0]);
            if (node) {
                if (node.segments && ((navigator.platform.match("Mac") ? evt.metaKey : evt.ctrlKey) && evt.shiftKey) || ((navigator.platform.match("Mac") ? evt.metaKey : evt.ctrlKey) && evt.altKey)) {
                    this._toolToActivate = "endPoint";
                    this._currentCursor = "move";
                    success = true;
                }
                if (!success) {
                    if (this._selectionContains(node)) {
                        if (node.segments) {
                            success = this._canActivateEndPointTool(evt, node);
                        }
                        else {
                            if (!pseudoGroupConstraints || pseudoGroupConstraints & ej.datavisualization.Diagram.NodeConstraints.Resize)
                                success = this._canActivateResizeTool(evt, node);
                            if (!success) {
                                if ((!pseudoGroupConstraints || (pseudoGroupConstraints & ej.datavisualization.Diagram.NodeConstraints.Rotate)))
                                    success = this._canActivateRotateTool(evt, node);
                            }
                        }
                        if (!success) {
                            success = this._canActivateUserHandle(evt, node);
                        }
                        if (!success) {
                            if (!pseudoGroupConstraints || pseudoGroupConstraints & ej.datavisualization.Diagram.NodeConstraints.Drag)
                                if (node && node.isLane && ej.datavisualization.Diagram.Util.canMultiSelectOnLane(node)) {
                                    this._toolToActivate = "select";
                                    this._currentCursor = "default";
                                }
                                else
                                    success = this._canActivateMoveTool(evt, node);
                        }
                        if (!success) {
                            success = this._canActivatephaseTool(evt);
                        }
                    }
                    else {
                        if (evt && evt.target && evt.target.getAttribute("class") === "ej-d-port") {
                            var point = this._mousePosition(evt);
                            var port = this._findPortAtPoint(point, node);
                            if (port && (port.constraints & ej.datavisualization.Diagram.PortConstraints.ConnectOnDrag) && ((port.visibility & ej.datavisualization.Diagram.PortVisibility.Visible) || (port.visibility & ej.datavisualization.Diagram.PortVisibility.Hover))) {
                                this._currentCursor = "crosshair";
                                var drawType = this.model.drawType;
                                var type = drawType.segments && drawType.segments.length && drawType.segments[0].type ? drawType.segments[0].type : "orthogonal";
                                if (type === "orthogonal")
                                    this.activateTool("orthogonalLine", true);
                                else
                                    this.activateTool("straightLine", true);
                                this._activatedFromPort = true;
                                success = true;
                            }
                        }
                        if (!pseudoGroupConstraints || pseudoGroupConstraints & ej.datavisualization.Diagram.NodeConstraints.Drag)
                            success = this._canActivateMoveTool(evt, node);
                    }
                }
            }
            else {
                success = this._canActivatephaseTool(evt);
            }
            if (!success) {
                if (this.tool() & ej.datavisualization.Diagram.Tool.ZoomPan) {
                    if (this.tool() & ej.datavisualization.Diagram.Tool.SingleSelect) {
                        var findNode = this._findNodeUnderMouse(evt);
                        if (findNode) {
                            this._toolToActivate = "select";
                            this._currentCursor = "default";
                            success = true;
                        }
                    }
                    if (!success) {
                        this._toolToActivate = "panTool";
                        this._currentCursor = "pointer";
                    }

                }
                else {
                    this._toolToActivate = "select";
                    this._currentCursor = "default";
                }
            }
            if (this._toolToActivate != "rotate") {
                this._adornerSvg.document.removeAttribute("class");
            }
            return success;
        },
        _canActivatephaseTool: function (evt) {
            if ($(evt.target).parents(".ej-d-seperator").first()[0]) {
                var id = $(evt.target).parents("g").first()[0].id;
                var phase = this._getSeperetor(id.split('_phase_g')[0]);
                var swimlane = this.nameTable[phase.parent.split("phaseStack")[0]];
                if (swimlane && ej.datavisualization.Diagram.Util.canResize(swimlane)) {
                    if (phase) {
                        if (phase.orientation == "horizontal")
                            this._currentCursor = "e-resize";
                        else
                            this._currentCursor = "n-resize";
                    }
                    else
                        this._currentCursor = "default";
                    this._toolToActivate = "phase";
                    return true;
                }
            }
        },
        _canActivateUserHandle: function (evt) {
            if (this._isUserHandle(evt) && evt.target) {
                var handleName = evt.target.id.split("_")[0];
                this._toolToActivate = handleName;
                this._currentCursor = this.tools[this._toolToActivate].cursor;
                return true;
            }
            return false;
        },

        _canActivateEndPointTool: function (evt, connector) {
            if (connector) {
                var endPointHandle = evt.target.getAttribute("class");
                if (endPointHandle && ((endPointHandle === "targetEndPoint" && ej.datavisualization.Diagram.Util.canDragTargetEnd(connector)) ||
                    (endPointHandle === "sourceEndPoint" && ej.datavisualization.Diagram.Util.canDragSourceEnd(connector)) ||
                (endPointHandle.match("bezierpoint") || endPointHandle == "segmentEnd") && ej.datavisualization.Diagram.Util.canDragSegmentThumbs(connector))
                    ) {
                    this._toolToActivate = "endPoint";
                    this._currentCursor = "move";
                    return true;
                }
            }
            return false;
        },
        _canActivateResizeTool: function (evt, node) {
            var dir = evt.target.getAttribute("class");
            if (ej.datavisualization.Diagram.Util.canResize(node, dir) && (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.Resizer)) {
                if (dir === "nw-resize" || dir === "n-resize" || dir === "ne-resize" || dir === "w-resize" || dir === "e-resize" || dir === "sw-resize" || dir === "s-resize" || dir === "se-resize") {
                    this._toolToActivate = "resize";
                    if ((node.rotateAngle >= 0 && node.rotateAngle < 25) || (node.rotateAngle >= 160 && node.rotateAngle <= 205) || (node.rotateAngle >= 340 && node.rotateAngle <= 360)) {
                        this._currentCursor = dir;
                    }
                    else if ((node.rotateAngle >= 25 && node.rotateAngle <= 70) || (node.rotateAngle >= 205 && node.rotateAngle <= 250)) {

                        if (dir === "n-resize" || dir === "s-resize") {
                            this._currentCursor = "ne-resize";
                        }
                        else if (dir === "nw-resize" || dir === "se-resize") {
                            this._currentCursor = "n-resize";
                        }
                        else if (dir === "e-resize" || dir === "w-resize") {
                            this._currentCursor = "nw-resize";
                        }
                        else {
                            this._currentCursor = "e-resize";
                        }
                    }
                    else if ((node.rotateAngle >= 70 && node.rotateAngle <= 115) || (node.rotateAngle >= 250 && node.rotateAngle <= 295)) {
                        if (dir === "n-resize" || dir === "s-resize") {
                            this._currentCursor = "e-resize";
                        }
                        else if (dir === "nw-resize" || dir === "se-resize") {
                            this._currentCursor = "ne-resize";
                        }
                        else if (dir === "e-resize" || dir === "w-resize") {
                            this._currentCursor = "n-resize";
                        }
                        else {
                            this._currentCursor = "nw-resize";
                        }
                    }
                    else if ((node.rotateAngle >= 115 && node.rotateAngle <= 155) || (node.rotateAngle >= 295 && node.rotateAngle <= 340)) {
                        if (dir === "n-resize" || dir === "s-resize") {
                            this._currentCursor = "nw-resize";
                        }
                        else if (dir === "nw-resize" || dir === "se-resize") {
                            this._currentCursor = "e-resize";
                        }
                        else if (dir === "e-resize" || dir === "w-resize") {
                            this._currentCursor = "ne-resize";
                        }
                        else {
                            this._currentCursor = "n-resize";
                        }
                    }
                    return true;
                }
            }
            return false;
        },
        _canActivateMoveTool: function (evt, node) {
            if (evt.target)
                var className = evt.target.className;
            if (className && ej.datavisualization.Diagram.Util.isClassifier(evt))
                var findNode = ej.datavisualization.Diagram.ClassifierHelper.getMovableElementUnderMouse(evt, this);
            else
                findNode = this._findNodeUnderMouse(evt);
            if (findNode && findNode.name === node.name) {
                var canMove = true;
                if (node.parent) {
                    if (this.selectionList.length > 0 && this._selectionContains(node))
                        canMove = true;
                    else
                        canMove = false;
                }
                if (canMove && ej.datavisualization.Diagram.Util.canMoveLabel(node)) {
                    var id = evt.target.parentNode.id.split('_');
                    var targetClass = evt.target.parentNode.getAttribute("class");
                    if (id[id.length - 1] == "lblbg" || this._isLabelTemplate(evt) || (targetClass && targetClass === "ej-d-label")) {
                        this._toolToActivate = "move";
                        this._currentCursor = "pointer";
                        return true;
                    }
                }
                var swimlane = false;
                if (node.parent) {
                    var parent = this.nameTable[node.parent];
                    if (parent && (((parent.isSwimlane || parent.isLane) && ej.datavisualization.Diagram.Util.canMove(parent)) || parent.isPhaseStack)) {
                        swimlane = true;
                    }
                }
                if (ej.datavisualization.Diagram.Util.canMove(node) || swimlane) {
                    this._toolToActivate = "move";
                    if (this._isHyperLink(evt)) {
                        this._currentCursor = "pointer";
                    }
                    else if (this.selectionList.length > 0 && (this._selectionContains(node) || (this.selectionList[0].children && this._findChildren(this.selectionList[0], node.name)))) {
                        this._currentCursor = "move";
                    }
                    else {
                        this._currentCursor = "default";
                    }
                    return true;
                }
            }
            return false;
        },
        _isLabelTemplate: function (evt) {
            if (evt) {
                var parents = $(evt.target).parents(".ej-label-template");
                var parent = parents[0]
                if (parent) {
                    var id = parent.parentNode.id.split('_');
                    if (id[id.length - 1] == "lblbg") {
                        return true;
                    }
                    else {
                        var parentNode = evt.target.parentNode;
                        var targetClass = parentNode.getAttribute("class");
                        while (parentNode) {
                            if (targetClass === "ej-label-template")
                                return true;
                            parentNode = parentNode.parentNode;
                            targetClass = parentNode.getAttribute("class");
                        }
                    }
                }
            }
        },
        _isHyperLink: function (evt) {
            var target = evt.target;
            var targetClass = target.getAttribute("class");
            if (!targetClass || !targetClass == "ej-d-label") {
                if (target.parentNode)
                    if ($(target.parentNode).hasClass("ej-d-label")) {
                        target = target.parentNode;
                        if ($(target.parentNode).hasClass("ej-d-anchor")) {
                            return true;
                        }
                    }
            }
            return false;
        },
        _canActivateRotateTool: function (evt, node) {
            if (ej.datavisualization.Diagram.Util.canRotate(node) && (this.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.Rotator)) {
                var rotateHandle = evt.target.getAttribute("class");
                if (rotateHandle === "rotateHandle") {
                    this._toolToActivate = "rotate";
                    if (ej.browserInfo().name === "msie") {
                        this._currentcursor = "default";
                        this._adornerSvg.document.setAttribute("class", "svg-rotate-ie");
                        this._currentCursor = "";
                    }
                    else {
                        this._adornerSvg.document.setAttribute("class", "svg-rotate");
                        this._currentCursor = "";
                    }
                    return true;
                }
            }
            return false;
        },
        _canActivatePivotTool: function (evt) {
            var pivotHandle = evt.target.getAttribute("class");
            if (pivotHandle === "pivot") {
                this._toolToActivate = "pivot";
                this._currentCursor = "default";
                return true;
            }
            return false;
        },
        _updateCursor: function () {
            this.element[0].style.cursor = this._currentCursor;
            this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0].style.cursor = this._currentCursor;
        },
        _getResizeCursor: function (resizeDirection) {
            var cursor = "default";
            switch (resizeDirection) {
                case "topleft": cursor = "nw-resize";
                    break;
                case "topcenter": cursor = "n-resize";
                    break;
                case "topright": cursor = "ne-resize";
                    break;
                case "middleleft": cursor = "w-resize";
                    break;
                case "middleright": cursor = "e-resize";
                    break;
                case "bottomleft": cursor = "sw-resize";
                    break;
                case "bottomcenter": cursor = "s-resize";
                    break;
                case "bottomright": cursor = "se-resize";
                    break;
            }
            return cursor;
        },
        _startEdit: function (shape) {
            var label;
            var centerX, centerY;
            var bbox;
            var nodeBounds;
            var bounds;
            var curZoomfactor;
            var matrix = ej.Matrix.identity();
            var width = shape.width ? shape.width : shape._width;
            var height = shape.height ? shape.height : shape._height;
            ej.Matrix.rotate(matrix, shape.rotateAngle, width / 2, height / 2);
            if (shape.type === "text") {
                if (this._svg.getElementById(shape.name + "_shape") !== null)
                    bbox = this._svg.getElementById(shape.name + "_shape").getBBox();
                else
                    bbox = { x: shape.offsetX - width * shape.pivot.x, y: shape.offsetY - height * shape.pivot.y, width: width, height: height };
                label = shape.textBlock;
                if (label && !label.readOnly) {
                    nodeBounds = ej.datavisualization.Diagram.Util.bounds(shape);
                    bounds = new ej.datavisualization.Diagram.Rectangle(bbox.x - label.fontSize, bbox.y - label.fontSize, bbox.width + label.fontSize / 2, bbox.height + label.fontSize / 2);
                    curZoomfactor = this._currZoom;
                    var diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Util._getLabelPosition(label, nodeBounds));
                    centerX = shape.offsetX - width * shape.pivot.x + diff.x;
                    centerY = shape.offsetY - height * shape.pivot.y + diff.y;
                    if (label.horizontalAlignment == "left")
                        centerX += bbox.width / 2;
                    else if (label.horizontalAlignment == "right")
                        centerX -= bbox.width / 2;
                    if (label.verticalAlignment == "top")
                        centerY += bbox.height / 2;
                    else if (label.verticalAlignment == "bottom")
                        centerY -= bbox.height / 2;
                    if (bbox.width === 0 || bbox.height === 0) {
                        bbox = ej.datavisualization.Diagram.Util.bounds(shape);
                        bounds.width = bbox.width == 0 ? 50 : nodeBounds.width * curZoomfactor;
                        bounds.x = (centerX * curZoomfactor - bounds.width / 2 * curZoomfactor) - this._hScrollOffset;

                        bounds.height = label.fontSize;
                        bounds.y = (centerY * curZoomfactor - bounds.height / 2 * curZoomfactor) - this._vScrollOffset;
                    }
                    else {
                        bounds.width = 50;
                        bounds.height = label.fontSize;
                        bounds.x = (centerX * curZoomfactor - (bounds.width / 2 * curZoomfactor)) - this._hScrollOffset;
                        bounds.y = (centerY * curZoomfactor - (bounds.height / 2 * curZoomfactor)) - this._vScrollOffset;
                    }
                    this._boundingBox = bounds;
                    this._createEditBox(label, bounds.x, bounds.y, bounds.width, bounds.height, shape);
                    this._isEditing = true;
                }
            }
            else {
                if (shape.labels.length > 0) {
                    label = this.activeTool.getLabelUnderMouse();
                    if (!label) label = shape.labels[0];
                }
                else {
                    var mNode = this._findNode(shape.name);
                    label = new ej.datavisualization.Diagram.Label({ "name": "label" + ej.datavisualization.Diagram.Util.randomId() });
                    shape.labels.push(label);
                    var parent = (mNode !== shape) ? mNode : null;
                    ej.datavisualization.Diagram.DiagramContext.addNodeLabel(shape, label, parent, this);
                    if (this.activeTool.name === "textTool")
                        this.activateTool.activeLabel = label;
                }
                if (label && !label.readOnly && label.hyperlink === "" && label.templateId === "") {
                    if (this.model.labelRenderingMode !== "svg") {
                        var htmlLayer = this._htmlLayer ? this._htmlLayer : this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0]
                        var element = $(htmlLayer).find("#" + shape.name + "_" + label.name)[0];
                    }
                    else {
                        var element = this._svg.document.getElementById(shape.name + "_" + label.name);
                    }
                    if (element) {
                        nodeBounds = ej.datavisualization.Diagram.Util.bounds(shape);
                        if (this.model.labelRenderingMode !== "svg") {
                            bounds = new ej.datavisualization.Diagram.Rectangle(element.offsetLeft, element.offsetTop, element.offsetWidth, element.offsetHeight);
                            bbox = bounds;
                        }
                        else {
                            bbox = element.getBBox();
                            bounds = new ej.datavisualization.Diagram.Rectangle(0, 0, bbox.width, bbox.height);
                        }
                        curZoomfactor = this.model.labelRenderingMode != "svg" ? this._currZoom : 1;
                        var position = ej.datavisualization.Diagram.Util._getLabelPosition(label, nodeBounds);
                        if (shape.segments || label.relativeMode == "segmentpath") {
                            bounds = element.getBoundingClientRect();
                            bounds = { x: bounds.left, y: bounds.top, width: bounds.width, height: bounds.height };
                            var controlBBox = this._controlBBox ? this._controlBBox : this._canvas.getBoundingClientRect();
                            centerX = (bounds.x + bounds.width / 2 - controlBBox.left + this._hScrollOffset) / curZoomfactor;
                            centerY = (bounds.y + bounds.height / 2 - controlBBox.top + this._vScrollOffset) / curZoomfactor;
                        }
                        else {
                            if (label.horizontalAlignment == "left")
                                position.x += bbox.width / 2;
                            else if (label.horizontalAlignment == "right")
                                position.x -= bbox.width / 2;
                            if (label.verticalAlignment == "top")
                                position.y += bbox.height / 2;
                            else if (label.verticalAlignment == "bottom")
                                position.y -= bbox.height / 2;
                            var diff = ej.Matrix.transform(matrix, position);
                            centerX = shape.offsetX - width * shape.pivot.x + diff.x;
                            centerY = shape.offsetY - height * shape.pivot.y + diff.y;
                        }
                        if (bbox.width === 0 || bbox.height === 0) {
                            bbox = ej.datavisualization.Diagram.Util.bounds(shape);
                            if (shape.segments) {
                                bounds.width = bbox.width < 50 ? 50 : nodeBounds.width;
                                bounds.x = (centerX * curZoomfactor - bounds.width / 2) - this._hScrollOffset;
                            }
                            else {
                                bounds.width = bbox.width < 50 ? 50 : nodeBounds.width;
                                bounds.x = (centerX * curZoomfactor - bounds.width / 2) - this._hScrollOffset;
                            }
                            if (shape.type == "umlclassifier")
                                bounds.height = shape.height;
                            else
                                bounds.height = label.fontSize;
                            bounds.y = (centerY * curZoomfactor - bounds.height / 2 * curZoomfactor) - this._vScrollOffset;
                        }
                        else {
                            bounds.x = (centerX * curZoomfactor - (bounds.width / 2 * curZoomfactor)) - this._hScrollOffset;
                            bounds.y = (centerY * curZoomfactor - (bounds.height / 2 * curZoomfactor)) - this._vScrollOffset;
                        }
                        this._boundingBox = bounds;
                        this._createEditBox(label, bounds.x, bounds.y, bounds.width, bounds.height, shape);
                        this._isEditing = true;
                    }
                    else {
                        this.activeTool.selectedObject = null;
                    }
                }
            }
        },

        _hideShowSVGLabels: function (label, shape, show) {
            if (this._svg && shape) {
                var lblEle;
                if (shape.type === "text")
                    lblEle = this._svg.document.getElementById(shape.name + "_shape_lblbg");
                else
                    lblEle = this._svg.document.getElementById(shape.name + "_" + label.name);
                if (lblEle) {
                    lblEle.setAttribute("visibility", show && (label.visible || shape.visible) ? "visible" : "hidden");
                }

                lblEle = this._svg.document.getElementById(shape.name + "_" + label.name + "_lblbg");
                if (lblEle) {
                    lblEle.setAttribute("visibility", show && label.visible ? "visible" : "hidden");
                }

            }
        },

        _createEditBox: function (label, x, y, width, height, shape) {
            if (this._svg) {
                if (this.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                    this._hideShowSVGLabels(label, shape)
                }
                else {
                    var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                    if (htmlLayer) {
                        if (shape.type === "text")
                            var lblEle = $(htmlLayer).find("#" + shape.name + "_shape_lblbg")[0];
                        else
                            var lblEle = $(htmlLayer).find("#" + shape.name + "_" + label.name + "_lblbg")[0];
                        if (lblEle) {
                            lblEle.style.display = "none";
                        }
                    }
                }
                var nodeBounds = ej.datavisualization.Diagram.Util.bounds(shape);
                var div = document.createElement("div");
                if (label.horizontalAlignment == "stretch" && label.textOverflow && label.rotateAngle == 0 && shape.isSwimlane)
                    y = y - label.fontSize;
                else if (label.horizontalAlignment == "stretch" && !shape.isSwimlane && shape._isHeader && label.textOverflow && label.rotateAngle != 0)
                    x = -x - label.fontSize - width / 4;
                var attr = {
                    "id": this.element[0].id + "_editBoxDiv",
                    "class": "edit",
                    "style": "top:" + y + "px;left:" + x + "px;width:" + width + "px;" +
                        "font-family:" + label.fontFamily + ";font-size:" + label.fontSize + "px;min-width: 50px;min-height:" + label.fontSize + "px;",
                };
                if (ej.datavisualization.Diagram.Util.canZoomTextEditor(this))
                    attr.style += "transform: scale(" + this._currZoom + ");";
                ej.datavisualization.Diagram.Util.attr(div, attr);
                var textBox = document.createElement("textarea");
                var fontColor = label.fontColor ? label.fontColor.toLowerCase() : "black";
                fontColor = fontColor != "white" && fontColor != "ffffff" && fontColor != "rgb(255,255,255)" ? fontColor : "black";
                attr = {
                    "id": this.element[0].id + "_editBox",
                    "class": "editBox",
                    "style": "font-size:" + label.fontSize + "px;font-family:" + label.fontFamily + ";min-height:"
                        + label.fontSize + "px; height: " + height + "px; line-height: normal; color:" + fontColor +
                        ";font-weight:" + (label.bold ? "bold" : "normal") + ";font-style:" + (label.italic ? "italic" : "normal") + ";text-decoration:" + (label.textDecoration),
                    "nodeWidth": nodeBounds.width, "nodeHeight": nodeBounds.height, "fontSize": label.fontSize, "nodeOffsetX": shape.offsetX, "nodeOffsetY": shape.offsetY, "containerName": shape.name,
                };
                ej.datavisualization.Diagram.Util.attr(textBox, attr);
                textBox.value = label.text;
                div.appendChild(textBox);
                $(this._canvas).append(div);
                if (label.text !== "") {
                    this._updateEditor(null, div, textBox, nodeBounds.width, label.fontSize, label, shape);
                }
                this._on($(textBox), "focusout", this._editboxfocusout);
                this._on($(textBox), "keyup", this._editBoxKeyUp);
                this._on($(textBox), "input", this._editBoxTextChange);
                this._on($(textBox), "focusin", this._editboxfocusin);
                textBox.focus();
            }
        },
        _editBoxKeyUp: function (evt) {
            this._updateLabelPosition(evt);
        },
        _editBoxTextChange: function (evt) {
            this._updateLabelPosition(evt);
        },
        _updateEditBox: function (x, y) {
            var editBox = document.getElementById(this.element[0].id + "_editBoxDiv");
            if (editBox) {
                editBox.style.left = editBox.offsetLeft - x + "px";
                editBox.style.top = editBox.offsetTop - y + "px";
            }
        },
        _editboxfocusout: function () {
            this._endEditing = true;
            this._endEdit();
            delete this._endEditing;
        },
        _editboxfocusin: function (evt) {
            evt.target.select();
            this._raiseEvent("editorFocusChange", evt);
        },
        _updateLabelPosition: function (evt) {
            var minWidth = 50;
            var curZoomfactor = this._currZoom;
            var parentBoundary = this._boundingBox;
            var fontSize = Number(evt.target.getAttribute("fontSize"));
            var nodeWidth = Number(evt.target.getAttribute("nodeWidth"));
            var conCenterX = parentBoundary.x + (parentBoundary.width / 2);
            var conCenterY = parentBoundary.y + (parentBoundary.height / 2);
            var bounds = this._textLength(evt);
            var width;
            if (bounds.width === 0) {
                width = parentBoundary.width < minWidth ? minWidth : parentBoundary.width;
                evt.target.parentNode.style.width = width + "px";
                evt.target.parentNode.style.left = conCenterX - width / 2 - fontSize / 4 + "px";
            }
            else {
                if (bounds.width <= (nodeWidth * curZoomfactor))
                    width = bounds.width < minWidth ? minWidth : bounds.width;
                else if (bounds.width >= (nodeWidth * curZoomfactor))
                    width = bounds.width > minWidth ? bounds.width : minWidth;
                else
                    width = nodeWidth < minWidth ? minWidth : (nodeWidth * curZoomfactor);
                evt.target.parentNode.style.width = width + "px";
                evt.target.parentNode.style.left = conCenterX - (width / 2) + "px";
            }
            if (bounds.height === 0) {
                evt.target.style.height = fontSize + "px";
                evt.target.parentNode.style.top = conCenterY - fontSize / 2 + 'px';
            }
            else {
                if (this._selectedItem) {
                    var node = this.nameTable[this._selectedItem];
                    if (node.type === "text") {
                        var label = this._currentLabel;
                    }
                }
            }


            this._updateEditor(evt, evt.target.parentNode, evt.target, nodeWidth, fontSize, label);

        },
        _updateEditor: function (evt, div, textBox, nodeWidth, fontSize, label, shape) {
            var offsetX, offsetY;
            var elHeight;
            var bounds = this._textLength(evt, label);
            var curZoomfactor = (this.model.labelRenderingMode != "svg" || (shape && shape.type === "text")) ? this._currZoom : 1;
            var minWidth = 50;
            var x = this._boundingBox.x;
            var y = this._boundingBox.y;
            var width = this._boundingBox.width;
            var height = this._boundingBox.height;
            var str = textBox.value;
            var line = str.split('\n');
            if (!shape)
                shape = this.activeTool.selectedObject;
            if (shape && shape.parent) {
                var node = this.nameTable[shape.parent];
            }
            if (this._nodeUnderMouse) {
                this.old = this._nodeUnderMouse;
                var type = this._nodeUnderMouse.name.match("_attribute") ? "attribute" : (this._nodeUnderMouse.name.match("_method") ? "method" : (this._nodeUnderMouse.name.match("_member") ? "member" : this._nodeUnderMouse.name.match("_header_classifier") ? "header" : "null"));
            }
            if (this.old)
                var type = this.old.name.match("_attribute") ? "attribute" : (this.old.name.match("_method") ? "method" : (this.old.name.match("_member") ? "member" : this.old.name.match("_header_classifier") ? "header" : "null"));
            if (type && type != "null")
                var temp = bounds.width > nodeWidth ? bounds.width : nodeWidth;
            else
                var temp = nodeWidth < bounds.width ? nodeWidth : bounds.width;
            if (this._browserInfo.name === "mozilla") temp += 2;
            var elWidth = temp < minWidth ? minWidth : temp;
            div.style.width = elWidth + "px";
            if (evt)
                offsetX = (elWidth - width) / 2;
            else
                offsetX = (elWidth - width * curZoomfactor) / 2;
            if (node && node.isLane && label && label.horizontalAlignment == "stretch" && label.textOverflow && label.rotateAngle != 0)
                div.style.left = x - offsetX - fontSize - width / 4 + "px";
            else
                div.style.left = x - offsetX - fontSize / 4 + "px";
            if (line.length > 1 || bounds.width != nodeWidth) {
                if (shape && shape.type != "umlclassifier")
                    textBox.style.height = '0';
                elHeight = (this._browserInfo.name === "mozilla") ? textBox.scrollHeight - 5 : textBox.scrollHeight - 4;
            }
            else
                elHeight = fontSize;
            var offset = $(textBox).offset();
            var canvasOffset = $(this._canvas).offset();
            var canvasHeight = $(this._canvas).height();
            if (!canvasHeight)
                canvasHeight = this._getCanvasHeight(this._canvas, canvasHeight);
            if (offset.top - canvasOffset.top + Number(elHeight) > canvasHeight) {
                elHeight = elHeight - ((offset.top - canvasOffset.top + Number(elHeight)) - (canvasHeight));
                if (this._browserInfo.name === "mozilla")
                    elHeight = elHeight - 7;
                else
                    elHeight = elHeight - 6;
            }
            textBox.style.height = elHeight + "px";
            var top = 0;
            if (evt) {
                offsetY = (elHeight - height) / 2;
                top = y - offsetY * curZoomfactor;
            }
            else {
                if (node && node.isSwimlane && label && label.horizontalAlignment == "stretch" && label.textOverflow && label.rotateAngle == 0)
                    offsetY = (elHeight - height * curZoomfactor) / 2 + label.fontSize;
                else
                    offsetY = (elHeight - height * curZoomfactor) / 2;
                top = y - offsetY - 3 * curZoomfactor;
            }

            div.style.top = top + "px";
            this._boundingBox = new ej.datavisualization.Diagram.Rectangle(x - offsetX, top, elWidth, elHeight);
        },
        _getCanvasHeight: function (canvas, canvasHeight) {
            var height = canvasHeight, element = canvas;
            while (height <= 0) {
                element = element.parentNode;
                if (element) {
                    height = $(element).height();
                }
            }
            return height;
        },
        _textLength: function (evt, label) {
            var temp = document.createElement("div");
            var textElement = document.getElementById(this.element[0].id + "_editBox");
            var attr = {
                "id": this.element[0].id + "_editBoxHiddenDiv",
                "style": "position : absolute; width : auto; height : auto;" +
                         "font-size:" + textElement.style.fontSize + "px;font-family:" + textElement.style.fontFamily + ";word-wrap: break-word;white-space:pre-wrap;",
            };
            if (label) {
                attr.style = "position : absolute; width : auto; height : auto;" + "font-weight:" + (label.bold ? "bold" : "normal") + ";font-style:" + (label.italic ? "italic" : "normal") + ";text-decoration:" + (label.textDecoration) + ";font-size:" + label.fontSize + "px;font-family:" + label.fontFamily + ";word-wrap: break-word;white-space:pre-wrap;";
            }
            ej.datavisualization.Diagram.Util.attr(temp, attr);
            if (evt) {
                temp.appendChild(document.createTextNode(evt.target.value));
            } else {
                temp.appendChild(document.createTextNode(textElement.value));
            }
            document.body.appendChild(temp);
            var bounds = temp.getBoundingClientRect();
            document.body.removeChild(temp);
            return bounds;
        },
        _endEdit: function (keyCode) {
            var args, entry, label, prevWidth, prevHeight;
            var editBox = document.getElementById(this.element[0].id + "_editBox");
            if (editBox) {
                var shape = this._findNode(editBox.getAttribute("containerName"));;
                if (this.activeTool.name === "textTool")
                    shape = this.activeTool.selectedObject;
                else if (!shape) {
                    for (var i = 0; i < this.selectionList.length; i++) {
                        var mNode = this.selectionList[i];
                        if (typeof mNode.labels.length != "undefined" && mNode.labels.length > 0 && mNode.labels[0].mode === ej.datavisualization.Diagram.LabelEditMode.Edit)
                            shape = this.selectionList[i];
                    }
                }
                if (shape) {
                    this._isEditing = false;
                    var label;
                    if (shape.type == "text") label = shape.textBlock;
                    else {
                        label = this.activeTool.getLabelUnderMouse();
                        if (!label) label = shape.labels[0];
                    }
                    if (shape.type == "umlclassifier")
                        editBox.value = ej.datavisualization.Diagram.ClassifierHelper.getEditboxValue(editBox.value, shape, this);
                    if (label) var prevText = label.text;
                    if (shape._type == "node" && (!shape.width || !shape.height) && this.nameTable[shape.name]) {
                        prevWidth = shape._width;
                        prevHeight = shape._height;
                        shape.labels[0].text = editBox.value;
                        this._getNodeDimension(shape);
                    }
                    if (shape.type == "umlclassifier")
                        shape = ej.datavisualization.Diagram.ClassifierHelper.getClassifierNodeDimension(shape, this);
                    var tempKeyCode;
                    if (keyCode) {
                        tempKeyCode = keyCode.keyDownEventArgs.keyCode === 27 ? "ESC" : String.fromCharCode(keyCode.keyDownEventArgs.keyCode);
                    }
                    if (editBox.value != prevText)
                        args = this._raiseEvent("textChange", { element: this.getNode(shape), label: label, value: editBox.value, keyCode: tempKeyCode });
                    if (!args) {
                        if (shape && shape.type !== undefined && shape.type === "text") {
                            var oldText = prevText;
                            shape.textBlock.text = editBox.value;
                            shape.textBlock.mode = ej.datavisualization.Diagram.LabelEditMode.View;
                            if (!this._findNode(shape.name)) {
                                if (editBox.value !== "") {
                                    var height = Number(editBox.style.height.substring(0, editBox.style.height.length - 2));
                                    if (shape.height < height) {
                                        shape.offsetY = (shape.offsetY - (shape.height / 2)) + (height / 2);
                                        shape.height = height;
                                    }
                                    if (this.selectionList.length > 0)
                                        this._clearSelection(true);
                                    if (this.tools["move"]._outOfBoundsDrag(shape)) {
                                        this.add(shape);
                                        var parent = this.nameTable[shape.parent];
                                        if (parent && parent.isLane) {
                                            var move = this._moveOnLane(shape, parent);
                                            if (!move.proceedX)
                                                this.updateNode(shape.name, { offsetX: shape.offsetX + move.x });
                                            if (!move.proceedY)
                                                this.updateNode(shape.name, { offsetY: shape.offsetY + move.y });
                                            //delete this._preventDocking;

                                            this._updateNodeMargin(shape);
                                            ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this);
                                            this._disableSwimlaneUptate = true;
                                            ej.datavisualization.Diagram.canvasHelper._updateCollectionChange(this, parent);
                                            if (parent.isLane) {
                                                var swimlane = this._getSwimlane(parent);
                                                if (swimlane) {
                                                    this._updateChildAdjacentConnectors(swimlane, true);
                                                    delete this._disableSwimlaneUptate;
                                                    ej.datavisualization.Diagram.canvasHelper._updateLastPhase(this, swimlane);
                                                    ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this, swimlane);
                                                }
                                            }
                                        }
                                    }
                                }
                                this.activeTool.selectedObject = null;
                            } else {
                                //delete this._preventDocking;
                                ej.datavisualization.Diagram.DiagramContext.update(shape, this);
                                entry = { type: "labelchanged", shape: shape, previousLabelValue: oldText, updatedLabelValue: editBox.value, category: "internal" };
                                this.addHistoryEntry(entry);
                                //entry = new ej.datavisualization.Diagram.HistoryEntry(new ej.datavisualization.Diagram.TextChangeCmd(shape, shape.textBlock.text, editBox.value));
                                //this.historyManager.addHistoryEntry(entry);
                            }
                        } else if (shape != undefined && !(shape.type == "pseudoGroup")) {
                            if (label != undefined) {
                                this._comparePropertyValues(label, "text", { text: editBox.value });
                                prevText = prevText ? prevText : label.text;
                                if (prevText != editBox.value) {
                                    entry = { type: "labelchanged", shape: shape, previousLabelValue: label.text, updatedLabelValue: editBox.value, index: shape.labels.indexOf(label), category: "internal" };
                                    this.addHistoryEntry(entry);
                                    //entry = new ej.datavisualization.Diagram.HistoryEntry(new ej.datavisualization.Diagram.LabelChangeCmd(shape, label.text, editBox.value));
                                    //this.historyManager.addHistoryEntry(entry);
                                }
                                label.text = editBox.value;
                                label.mode = ej.datavisualization.Diagram.LabelEditMode.View;
                                ej.datavisualization.Diagram.DiagramContext.updateLabel(shape, label, this);
                                if (shape.isPhase) {
                                    if ((shape.name).split("phaseStack")[1])
                                        var phase = this.nameTable[(shape.name).split("phaseStack")[1]];
                                    if (phase && phase.label)
                                        phase.label.text = editBox.value;
                                }
                                this.activeTool.selectedObject = null;
                            }
                            else if (shape.labels.length == 0) {
                                label = ej.datavisualization.Diagram.Label();
                                label.text = editBox.value;
                                label.mode = ej.datavisualization.Diagram.LabelEditMode.View;
                                shape.labels.push(label);
                                ej.datavisualization.Diagram.DiagramContext.addNodeLabel(shape, label, null, this);
                            }
                            if (this.activeTool.activeLabel) this.activeTool.activeLabel = null;
                        }
                        if (shape.shape && shape.shape.type == "umlclassifier")
                            shape = ej.datavisualization.Diagram.ClassifierHelper.getUMLConnectorValue(shape, editBox.value, label);
                        if (shape._type == "node" && (!shape.width || !shape.height) && this.nameTable[shape.name]) {
                            ej.datavisualization.Diagram.DiagramContext.update(shape, this);
                            if (shape.parent) ej.datavisualization.Diagram.DiagramContext.update(this.nameTable[shape.parent], this);

                        }

                        if (shape.type == "umlclassifier") {
                            shape.labels[0].text = "";
                            ej.datavisualization.Diagram.DiagramContext.update(shape, this);
                        }
                        if (shape.shape && shape.shape.type == "umlclassifier")
                            ej.datavisualization.Diagram.DiagramContext.update(shape, this);
                    }
                    else {
                        if (shape._width && prevWidth) shape._width = prevWidth;
                        if (shape._height && prevHeight) shape._height = prevHeight;
                        if (shape && shape.type === "text") {
                            ej.datavisualization.Diagram.DiagramContext.update(shape, this);
                        }
                        else {
                            label = this.activeTool.activeLabel ? this.activeTool.activeLabel : (shape.labels.length > 0 ? shape.labels[0] : null);
                            if (label != undefined) {
                                label.mode = ej.datavisualization.Diagram.LabelEditMode.View;
                                ej.datavisualization.Diagram.DiagramContext.updateLabel(shape, label, this);
                            }
                        }
                        if (this.activeTool) {
                            this.activeTool.activeLabel = null;
                            this.activeTool.selectedObject = null;
                        }
                    }
                }
                this._off($(editBox), "focusout", this._editboxfocusout);
                this._off($(editBox), "keyup", this._editBoxKeyUp);
                this._off($(editBox), "input", this._editBoxTextChange);
                var element = $("#" + this.element[0].id + "_editBoxDiv")[0];
                if (element)
                    element.parentNode.removeChild(element);
                if (this._svg) {
                    if (this.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                        this._hideShowSVGLabels(label, shape, true);
                    } else {
                        var htmlLayer = this._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                        if (htmlLayer) {
                            if (shape.type === "text")
                                var lblEle = $(htmlLayer).find("#" + shape.name + "_shape_lblbg")[0];
                            else {
                                if (label)
                                    var lblEle = $(htmlLayer).find("#" + shape.name + "_" + label.name + "_lblbg")[0];
                            }
                            if (lblEle) {
                                lblEle.style.display = "block";
                            }
                        }
                    }
                }
            }
            if (keyCode && keyCode.keyDownEventArgs && keyCode.keyDownEventArgs.keyCode === 27)
                this.element[0].focus();
        },
        _getSwimlane: function (lane) {
            var swimlane;
            lane = typeof (lane) === "string" ? this.nameTable[lane] : lane;
            var laneStack = this.nameTable[lane.parent];
            if (laneStack)
                swimlane = this.nameTable[laneStack.parent];
            return swimlane
        },
        _setLabelEditing: function (label) {
            var success;
            if (label) {
                if (label.readOnly) {
                    label.mode = ej.datavisualization.Diagram.LabelEditMode.View;
                    success = false;
                }
                else {
                    if (this._currentLabel)
                        this._currentLabel.mode = ej.datavisualization.Diagram.LabelEditMode.View;
                    label.mode = ej.datavisualization.Diagram.LabelEditMode.Edit;
                    this._currentLabel = label;
                    success = true;
                }
                return success;
            }
        },
        _isInternalTool: function (tool) {
            if (tool instanceof ej.datavisualization.Diagram.SelectTool || tool instanceof ej.datavisualization.Diagram.ConnectionEditTool || tool instanceof ej.datavisualization.Diagram.MoveTool || tool instanceof ej.datavisualization.Diagram.ResizeTool
                  || tool instanceof ej.datavisualization.Diagram.PhaseTool || tool instanceof ej.datavisualization.Diagram.RotateTool || (tool instanceof ej.datavisualization.Diagram.PanTool && (this.tool() & ej.datavisualization.Diagram.Tool.SingleSelect) && (this.tool() & ej.datavisualization.Diagram.Tool.ZoomPan)))
                return true;
            else
                return false;
        },
        _updateNodeMargin: function (node) {
            if (node.parent != "") {
                var group = this.nameTable[node.parent];
                if (group && group.container && group.container.type == "canvas") {
                    var groupBounds = ej.datavisualization.Diagram.Util.bounds(group);
                    var bounds1 = ej.datavisualization.Diagram.Util.bounds(node);
                    var bounds = ej.datavisualization.Diagram.Geometry.rect([bounds1.topLeft, bounds1.topRight, bounds1.bottomRight, bounds1.bottomLeft]);
                    node.marginLeft = bounds.x - (groupBounds.x + group.paddingLeft);
                    var right = (groupBounds.x + group.width) - (bounds.x + bounds.width) - group.paddingRight;
                    (right < 0) ? node.marginRight = 0 : node.marginRight = right;
                    node.marginTop = bounds.y - (groupBounds.y + group.paddingTop);
                    var bottom = (groupBounds.y + group.height) - (bounds.y + bounds.height) - group.paddingBottom;
                    (bottom < 0) ? node.marginBottom = 0 : node.marginBottom = bottom;
                    if (group.isLane) {
                        var left = 0, top = 0;
                        if (group.orientation === "horizontal") {
                            left = 50, top = 0;
                        }
                        else {
                            left = 0, top = 50;
                        }
                        node.marginLeft = node.marginLeft >= left ? node.marginLeft : left;
                        node.marginTop = node.marginTop >= top ? node.marginTop : top;
                    }
                }
            }
            if ((node.type == "pseudoGroup" || node.name == "multipleSelection") && node.children.length > 0) {
                var child;
                for (var i = 0; i < node.children.length; i++) {
                    child = this.nameTable[this._getChild(node.children[i])];
                    if (child) {
                        this._updateNodeMargin(child);
                    }
                }
            }
        },
        _raisePropertyChange: function (resource) {
            if (resource) {
                if (this._isSizingCommand)
                    resource.cause = ej.datavisualization.Diagram.ActionType.Size;
                else if (this._isUndo)
                    resource.cause = ej.datavisualization.Diagram.ActionType.HistoryChange;
                else if (this._isTouchedEvent)
                    resource.cause = ej.datavisualization.Diagram.ActionType.Touch;
                this._raiseEvent("propertyChange", resource);
            }
        },
        _updateAdjacentEdges: function (node, connTable) {
            var i, len;
            if (node.inEdges && node.inEdges.length > 0) {
                for (i = 0, len = node.inEdges.length; i < len; i++) {
                    connTable[node.inEdges[i]] = this.nameTable[node.inEdges[i]];
                }
            }
            if (node.outEdges && node.outEdges.length > 0) {
                for (i = 0, len = node.outEdges.length; i < len; i++) {
                    connTable[node.outEdges[i]] = this.nameTable[node.outEdges[i]];
                }
            }
        },
        _translate: function (node, dx, dy, nameTable, isContainer, connectorTable) {
            if (dx || dy) {
                if (!node.segments) {
                    if (!connectorTable) { var init = true; }
                    var connectorTable = connectorTable || {};
                    this._updateAdjacentEdges(node, connectorTable);
                    node.offsetX += dx;
                    node.offsetY += dy;
                    if (!this._parentNode && this.activeTool.name != "phase") this._parentNode = node;
                    if ((node._type === "group" || node.type === "pseudoGroup") && !isContainer) {
                        var nodes = this._getChildren(node.children);
                        var child;
                        for (var i = 0; i < nodes.length; i++) {
                            child = nameTable[nodes[i]];
                            if (child) {
                                this._translate(child, dx, dy, nameTable, undefined, connectorTable);
                                if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                    ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], this);
                            }
                        }
                        if (node.type != "group" && node.container)
                            ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                    }
                    if (node != this.activeTool.helper) {
                        //this._updateAssociatedConnectorEnds(node, nameTable);
                        if (this.nameTable[node.name]) this._updateQuad(node);
                        ej.datavisualization.Diagram.DefautShapes.translateBPMNAnnotationShape(node, dx, dy, null, this);
                    }
                    if (this._parentNode == node) delete this._parentNode;
                    if (init && !this._preventDocking && node != this.activeTool.helper && !this._disableSegmentChange) {
                        for (var i in connectorTable) {
                            var child = this.nameTable[i];
                            if (child) {
                                if (node.isSwimlane || ((node.type == "pseudoGroup" || node.type == "group") && !this._containsChild(node, child)))
                                    ej.datavisualization.Diagram.Util._translateLine(child, dx, dy, child);
                                this._dock(child, this.nameTable);
                                if (child.annotation) ej.datavisualization.Diagram.DefautShapes.updateAnnotationProperties(child, this);
                            }
                        }
                    }
                } else {
                    ej.datavisualization.Diagram.Util._translateLine(node, dx, dy, node);
                    this._dock(node, nameTable);
                    ej.datavisualization.Diagram.Util.updateBridging(node, this);
                    this._updateConnectorBridging(node);
                }
            }
            else return false;
        },
        _containsChild: function (group, child) {
            if (group.children && group.children.length > 0) {
                var children = this._getChildren(group.children);
                for (var i = 0; i < children.length; i++) {
                    var connector = this._collectionContains(child.name, children);
                    if (!connector) {
                        var subgroup = this._getChild(children[i]);
                        if (subgroup && subgroup.children)
                            this._containsChild(subgroup, child);
                    }
                    else return true;

                }
            }
        },
        _translateLabel: function (node, label, dx, dy) {
            var clnLabel = $.extend(true, {}, label);
            label.margin["left"] += dx;
            label.margin["top"] += dy;
            label.margin["right"] -= dx;
            label.margin["bottom"] -= dy;
            if (label.horizontalAlignment == "center") label.margin["right"] = 0;
            if (label.verticalAlignment == "center") label.margin["bottom"] = 0;
            ej.datavisualization.Diagram.DiagramContext.updateLabel(node, label, this);
            this._comparePropertyValues(node, "labels", clnLabel);
        },
        _rotate: function (node, angle, nameTable) {
            if (!node.segments && angle) {
                node.rotateAngle += angle;
                node.rotateAngle %= 360;
                if (node.rotateAngle < 0) node.rotateAngle += 360;
                if ((node._type === "group" || node.type === "pseudoGroup")) {
                    var matrix = ej.Matrix.identity();
                    var child, pinx, piny;
                    ej.Matrix.rotate(matrix, angle, node.offsetX, node.offsetY);
                    var nodes = this._getChildren(node.children);
                    var child;
                    for (var i = 0; i < nodes.length; i++) {
                        child = nameTable[nodes[i]];
                        if (child) {
                            if (!(child.segments)) {
                                this._rotate(child, angle, nameTable);
                                pinx = child.offsetX;
                                piny = child.offsetY;
                                var actualpt = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(pinx, piny));
                                this._translate(child, actualpt.x - pinx, actualpt.y - piny, nameTable);
                                this._updateAssociatedConnectorEnds(child, nameTable);
                            } else {
                                if (!child.sourceNode)
                                    this._setEndPoint(child, ej.Matrix.transform(matrix, child.sourcePoint), false);
                                if (!child.targetNode)
                                    this._setEndPoint(child, ej.Matrix.transform(matrix, child.targetPoint), true);
                            }
                            if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], this);
                        }
                    }
                    ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                }
                if (node.parent) {
                    this._updateParentBounds(node.parent);
                }
                if (node != this.activeTool.helper)
                    this._updateQuad(node);
                this._updateAssociatedConnectorEnds(node, nameTable);
            }
        },

        _raiseOffsetPropertyChange: function (shape, offsetX, offsetY, interaction) {
            if (shape && !shape.segments) {
                offsetX = offsetX ? offsetX : 0;
                offsetY = offsetY ? offsetY : 0;
                if (offsetX != shape.offsetX)
                    this._comparePropertyValues(shape, "offsetX", { offsetX: offsetX }, interaction);
                if (offsetY != shape.offsetY)
                    this._comparePropertyValues(shape, "offsetY", { offsetY: offsetY }, interaction);
            }
            else {
                offsetX = offsetX ? offsetX : 0;
                offsetY = offsetY ? offsetY : 0;
                this._comparePropertyValues(shape, "sourcePoint", { sourcePoint: { x: shape.sourcePoint.x + offsetX, y: shape.sourcePoint.y + offsetY } }, interaction);
                this._comparePropertyValues(shape, "targetPoint", { targetPoint: { x: shape.targetPoint.x + offsetX, y: shape.targetPoint.y + offsetY } }, interaction);
            }
        },
        _raiseSizePropertyChange: function (shape, delWidth, delHeight, interaction) {
            if (shape && delHeight && delWidth) {
                var height = shape.height * delHeight;
                var width = shape.width * delWidth;
                if (height != shape.height) {
                    this._comparePropertyValues(shape, "height", { height: height }, interaction);
                    this._comparePropertyValues(shape, "offsetY", { offsetY: shape.offsetY + (height - shape.height) }, interaction);
                }
                if (width != shape.width) {
                    this._comparePropertyValues(shape, "width", { width: width }, interaction);
                    this._comparePropertyValues(shape, "offsetX", { offsetX: shape.offsetX + (width - shape.width) / 2 }, interaction);
                }
            }
        },

        scale: function (node, sw, sh, pivot, nameTable, skipScalOnChild, updateMinMax, isHelper) {
            if ((sw && sw != 1) || (sh && sh != 1) || node.isPhase) {
                if (!node.container) {
                    var matrix = ej.Matrix.identity();
                    if (!node.segments) {
                        if ((node._type === "group" || node.type === "pseudoGroup")) {
                            if (node.type != "bpmn" || (node.width * sw >= 20 && node.height * sh >= 20)) {
                                var nodes = this._getChildren(node.children);
                                var child;
                                for (var i = 0; i < nodes.length; i++) {
                                    child = nameTable[nodes[i]];
                                    if (child && (node.type != "bpmn" || ej.datavisualization.Diagram.Util.canResize(child))) {
                                        this.scale(child, sw, sh, pivot, nameTable);
                                        if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                            ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], this);
                                    }
                                }
                                if (node.type == "bpmn")
                                    ej.datavisualization.Diagram.Util._updateBPMNProperties(node, this, nameTable, true);
                                if (node.children.length <= 0) {
                                    ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                                    ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                                    ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                                    var newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                                    var width = node.width ? node.width * sw : node._width * sw;
                                    var height = node.height ? node.height * sh : node._height * sh;
                                    if (width > 1) {
                                        if (node.width) {
                                            if (width != node.width) node._scaled = true;
                                            node.width = width;
                                            node.offsetX = newPosition.x;
                                        } else {
                                            if (width != node._width) node._scaled = true;
                                            node.maxWidth = (node.parent && nameTable[node.parent].width != node.maxWidth) ? nameTable[node.parent].width : width;
                                            node.offsetX = newPosition.x - (node._width * sw - node._width) / 2;
                                        }
                                    }
                                    if (height > 1) {
                                        if (node.height) {
                                            if (height != node.height) node._scaled = true;
                                            node.height = height;
                                            node.offsetY = newPosition.y;
                                        } else {
                                            if (height != node._height) node._scaled = true;
                                            node.maxHeight = (node.parent && nameTable[node.parent].height > height) ? nameTable[node.parent].height : height;
                                            node.offsetY = newPosition.y - (node._height * sh - node._height) / 2;
                                        }
                                    }
                                }
                                ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                                if (node != this.activeTool.helper) ej.datavisualization.Diagram.DefautShapes.translateBPMNAnnotationShape(node, 1 / sw, 1 / sh, pivot, this);
                            }
                        } else {
                            ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                            ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                            ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                            var newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                            var width = node.width * sw;
                            var height = node.height * sh;

                            if (node.maxWidth != 0)
                                width = Math.min(node.maxWidth, width);
                            if (node.minWidth != 0)
                                width = Math.max(node.minWidth, width);
                            if (node.maxHeight != 0)
                                height = Math.min(node.maxHeight, height)
                            if (node.minHeight != 0)
                                height = Math.max(node.minHeight, height);

                            if (width > 0) {
                                if (width != node.width) {
                                    node._scaled = true;
                                }
                                if (width != node.maxWidth && width != node.minWidth) {
                                    node.width = width;
                                    node.offsetX = newPosition.x;
                                }
                            }

                            if (height > 0) {
                                if (height != node.height) {
                                    node._scaled = true;
                                }
                                if (height != node.maxHeight && height != node.minHeight) {
                                    node.height = height;
                                    node.offsetY = newPosition.y;
                                }
                            }
                        }
                        if (node.parent) {
                            this._updateParentBounds(node.parent);
                        }
                        ej.datavisualization.Diagram.Util._updateBPMNProperties(node, this, nameTable, true);
                        if (!(this.activeTool.name == "resize" && this.activeTool.inAction && this.selectionList[0] &&
                            this.selectionList[0].type != "pseudoGroup" && this.selectionList[0].type != "group"))
                            this._updateAssociatedConnectorEnds(node, nameTable);
                        if (node != this.activeTool.helper)
                            this._updateQuad(node);
                    } else {
                        ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                        for (var i = 0; i < node.segments.length; i++) {
                            var segment = node.segments[i];
                            for (var j = 0; j < segment.points.length; j++) {
                                segment.points[j] = ej.Matrix.transform(matrix, segment.points[j]);
                                if (i == 0 && j == 0 && !node.sourceNode) {
                                    segment._startPoint = segment.points[0];
                                    segment._endPoint = segment.points[segment.points.length - 1];
                                    ej.datavisualization.Diagram.Util._setLineEndPoint(node, ej.Matrix.transform(matrix, node.sourcePoint), false);
                                }
                                if (i == node.segments.length - 1 && j == segment.points.length - 1 && !node.targetNode) {
                                    segment._startPoint = segment.points[0];
                                    segment._endPoint = segment.points[segment.points.length - 1];
                                    node.targetPoint = segment._endPoint;
                                }
                            }
                            segment._startPoint = segment.points[0];
                            segment._endPoint = segment.points[segment.points.length - 1];
                            if (segment.type == "orthogonal") {
                                if (segment.length || segment.length === 0)
                                    segment.length = segment._length = ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, segment._endPoint);
                                else
                                    ej.datavisualization.Diagram.Util._addOrthogonalPoints(segment, node.segments[i - 1], node.segments[i + 1], node.sourcePoint, node.targetPoint);
                            } else {
                                if (segment.point) {
                                    segment.point = segment._endPoint;
                                }
                                segment._point = segment._endPoint;
                            }

                        }
                        if (node.sourceNode || node.targetNode)
                            this._dock(node, nameTable);
                    }
                } else {
                    switch (node.container.type) {
                        case "canvas":
                            var newSize = {};
                            var matrix = ej.Matrix.identity();
                            ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                            ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                            ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                            newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                            width = node.width * sw;
                            height = node.height * sh;

                            if (updateMinMax) {
                                node.minHeight = height;
                                node.minWidth = width;
                            }
                            newSize.width = width;
                            newSize.height = height;
                            if (newSize && newSize.width > 1) {
                                var x = node.offsetX - node.width / 2;
                                if (node.width != newSize.width) node._scaled = true;
                                node.width = newSize.width;
                                node.offsetX = node._isBpmn ? newPosition.x : x + node.width / 2;
                            }
                            if (newSize && newSize.height > 1) {
                                var y = node.offsetY - node.height / 2;
                                if (node.height != newSize.height) node._scaled = true;
                                node.height = newSize.height;
                                node.offsetY = node._isBpmn ? newPosition.y : y + node.height / 2;
                            }

                            break;
                        case "stack":
                            var matrix = ej.Matrix.identity();
                            ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                            ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                            ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                            newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                            var marginLeft = 0;
                            var marginRight = 0;
                            if (sw != 0) {
                                marginLeft = node.marginLeft;
                                marginRight = node.marginRight;
                            }
                            width = (node.width * sw) - (marginLeft + marginRight);
                            height = (node.height * sh) - (node.marginTop + node.marginBottom);
                            newSize = { height: node.height, width: node.width }
                            if (this._resizeStack) {
                                node.width = width;
                                node.height = height;

                                node.offsetX = newPosition.x;
                                node.offsetY = newPosition.y;
                            }
                            break;
                    }
                }
            }
        },
        _updateParentBounds: function (node) {
            node = this.nameTable[this._getChild(node)];
            if (node && node.type != "bpmn" && !node.container) {
                ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                ej.datavisualization.Diagram.DiagramContext.update(node, this);
                if (node.parent) {
                    this._updateParentBounds(node.parent);
                }
            }
        },
        _dock: function (connector, nameTable, updateSelection) {
            if (!this._preventDocking && !this._disableSegmentChange && (!this._layoutInAction || !this._isAnimating)) {
                var length = connector.segments.length;
                var srcPointslength = connector.segments[0].points.length;
                var targetPointslength = connector.segments[connector.segments.length - 1].points.length;
                if (this._preventSegmentAdjusting) connector._preventSegmentAdjusting = true;
                ej.datavisualization.Diagram.Util.dock(connector, nameTable, this);
                delete connector._preventSegmentAdjusting;
                if (length != connector.segments.length && this._svg) {
                    ej.datavisualization.Diagram.Util._updateConnectorSegments(connector, connector.sourcePort, connector.targetPort, this);
                    ej.datavisualization.Diagram.DiagramContext._refreshSegments(connector, this);
                }
                if (this.selectionList[0] == connector) {
                    if (updateSelection || srcPointslength != connector.segments[0].points.length || targetPointslength != connector.segments[connector.segments.length - 1].points.length) {
                        ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.selectionList[0], this._adornerSvg, this._currZoom);
                    }
                }
                this._updateQuad(connector);
            }
        },

        _updateChildAdjacentConnectors: function (node, dock) {
            var childTable = this._getChildTable(node, {});
            for (var child in childTable) {
                var childNode = this.nameTable[child];
                if (childNode && childNode.segments && node.children.indexOf(child) == -1) {
                    if (!dock)
                        childNode._staticLength = true;
                    this._dock(childNode, this.nameTable);
                    delete childNode._staticLength;
                    ej.datavisualization.Diagram.DiagramContext.update(childNode, this);
                }
            }
        },

        _setEndPoint: function (connector, point, isTarget) {
            ej.datavisualization.Diagram.Util._setLineEndPoint(connector, point, isTarget);
            this._updateQuad(connector);
        },
        _updateAssociatedConnectorEnds: function (node, nameTable) {
            var i, len;
            var connector;
            if (!node.segments && (node.inEdges.length || node.outEdges.length)) {
                //Finding the segment points to avoid calculating path points multiple times to dock every edge
                var nodeToNode = this._isNodeToNodeConnection(node);
                var nodeToDock = node;
                if (node.type == "bpmn" && node._type == "group") {
                    nodeToDock = typeof node.children[0] == "object" ? node.children[0] : this.nameTable[node.children[0]];
                }
                if (nodeToNode) {
                    var segmentPoints = ej.datavisualization.Diagram.Util._findSegmentPoints(nodeToDock);
                }
                var childTable = {};
                if (this._parentNode) {
                    childTable = this._getChildTable(this._parentNode, {});
                }
                for (i = 0, len = node.inEdges.length; i < len; i++) {
                    connector = nameTable[node.inEdges[i]];
                    if (connector && !(this._parentNode && childTable[connector.sourceNode])) {
                        if (!connector.targetPadding) {
                            nodeToDock._segmentPoints = segmentPoints;
                        }
                        else delete nodeToDock._segmentPoints;
                        this._dock(connector, nameTable);
                    }
                }
                for (i = 0, len = node.outEdges.length; i < len; i++) {
                    connector = nameTable[node.outEdges[i]];
                    if (connector && !(this._parentNode && childTable[connector.targetNode])) {
                        if (!connector.sourcePadding) { nodeToDock._segmentPoints = segmentPoints; }
                        else delete nodeToDock._segmentPoints;
                        this._dock(connector, nameTable);
                    }
                }
                delete nodeToDock._segmentPoints;
            }
        },
        _isNodeToNodeConnection: function (node) {
            var i, len;
            if (node.inEdges.length) {
                for (i = 0, len = node.inEdges.length; i < len; i++) {
                    if (this.nameTable[node.inEdges[i]] && !this.nameTable[node.inEdges[i]].targetPort && (node.type != "bpmn" || this.nameTable[node.inEdges[i]].segments[0].type != "orthogonal")) return true;
                }
            }
            if (node.outEdges.length) {
                for (i = 0, len = node.outEdges.length; i < len; i++) {
                    if (this.nameTable[node.outEdges[i]] && !this.nameTable[node.outEdges[i]].sourcePort && (node.type != "bpmn" || this.nameTable[node.outEdges[i]].segments[this.nameTable[node.outEdges[i]].segments.length - 1].type != "orthogonal")) return true;
                }
            }
        },
        _updateChildBounds: function (node, nameTable) {
            var offX, offY;
            if (node.width == 0 && node.height == 0) {
                offX = node.offsetX;
                offY = node.offsetY;
                ej.datavisualization.Diagram.Util._updateGroupBounds(node, this);
                this._translate(node, offX - node.offsetX, offY - node.offsetY, nameTable);
            }
            else {
                offX = node.offsetX;
                offY = node.offsetY;
                var childBounds = ej.datavisualization.Diagram.Util._getChildrenBounds(node, this);
                node.offsetX = (childBounds.x + childBounds.width * node.pivot.x);
                node.offsetY = (childBounds.y + childBounds.height * node.pivot.y);
                var dx = offX - node.offsetX;
                var dy = offX - node.offsetY;
                this._translate(node, dx, dy, nameTable);
                var deltaWidth = node.width / childBounds.width;
                var deltaHeight = node.height / childBounds.height;
                this.scale(node, deltaWidth, deltaHeight, node.pivot, nameTable);;
                this._translate(node, offX - node.offsetX, offY - node.offsetY, nameTable);
            }
        },
        _updateQuad: function (object) {
            if (this._spatialSearch && this.nameTable[object.name]) {
                var type = this.getObjectType(object), skip = false;
                if (object.isPhase || object.isLane || object._isHeader || object.isLaneStack || object.isPhaseStack || object._isInternalShape || object.type == "pseudoGroup") skip = true;
                if (object.parent && this.nameTable[object.parent]) {
                    var parent = this.nameTable[object.parent];
                    if (parent.isPhaseStack || parent.isSwimlane) skip = true;
                    if (parent.type != "bpmn") this._updateQuad(parent);
                }
                if (this._selectedSymbol != null)
                    if (this._selectedSymbol.isLane && object.isLane && !object.parent) {
                        skip = false;
                    }
                if (this._disableUpdateQuad)
                    skip = true;
                if (!skip && !object._connectorType)
                    ej.datavisualization.Diagram.SpatialUtil._updateQuad(this, this._spatialSearch, object);
            }
        },
        _sliceDockLines: function (list) {
            var list1 = $.extend({}, list);
            var child = null;
            for (var i in list1) {
                child = this.nameTable[this._getChild(list1[i])];
                if (child && child.segments) {
                    if (child.sourceNode || child.targetNode) {
                        list.pop(child.name);
                    }
                }
            }
        },
        _canExecute: function () {
            if (this._isEditing && (this._currentCommand == "delete" || this._currentCommand == "cut" || this._currentCommand == "focusToPreviousItem" ||
                this._currentCommand == "undo" || this._currentCommand == "redo" || this._currentCommand == "focusToNextItem" || this._currentCommand == "selectFocusedItem" ||
            this._currentCommand == "selectAll" || this._currentCommand == "copy" || this._currentCommand == "paste" || this._currentCommand.match("nudge")))
                return false;
            if (this._currentCommand == "endEdit" && !this._isEditing) return false;
            return true;
        },

        _setItemDraggable: function (container) {
            var diagram = this;
            var perventAddingConnector = false;
            this._canDragGlobally = true;
            $(container).ejDraggable({
                clone: true,
                helper: function (event) {
                    this._selectedSymbol = null;
                    this._isDragged = false;
                    var svg = diagram._renderItemContainer("diagram_clone", document.body);
                    svg.document.setAttribute("drag", "true");
                    if (diagram.activeTool && diagram.activeTool.selectedObject && !diagram.activeTool.helper) {
                        var item = $.extend(true, {}, diagram.activeTool.selectedObject);
                        diagram._updateChildren(item);
                        diagram.edgeTable = {};
                        diagram.edgeTable = diagram._getEdgeTable(item, diagram.edgeTable);
                        this._updateSelectedItem(item, item.isSwimlane);
                        this._selectedSymbol = item;
                        this._isDragged = false;
                        this._targetId = diagram._id;
                        var bounds = ej.datavisualization.Diagram.Util.bounds(item);
                        this.cursorAt = { top: 105, left: 105 };
                        var node = ej.datavisualization.Diagram.NodeType({ offsetX: item.offsetX, offsetY: item.offsetY, width: 100, height: 100, shape: "path", opacity: 0.5, pathData: "M49.955,50.7915L1.74601,99L98.164,99zM1,1.83699L1,98.332L49.2477,50.0843zM99,1.74699L50.662,50.0845L99,98.422zM1.57701,1L49.9548,49.3773L98.332,1zM0,0L100,0L100,100L0,100z " }, diagram);
                        node = diagram._getNewNode(node);
                        ej.datavisualization.Diagram.SvgContext.renderNode(node, svg, null, true, diagram);
                    }
                    var helper = document.getElementById("diagram_clone_paletteItem");
                    $(helper).addClass("dragClone");
                    $(helper).css("display", "none");
                    return $(helper);
                },
                drag: function (evt) {
                    var diagramElement = $(evt.target).parents(".e-datavisualization-diagram");
                    if (diagramElement.length) {
                        var diagram = $("#" + diagramElement.attr("id")).ejDiagram("instance");
                        if ((this.model._isDragged || this.model._targetId != diagram._id) && this.model._selectedSymbol) {
                            if (!this.model._isDragged && this.model._targetId != diagram._id) {
                                var instance = $("#" + this.model._targetId).ejDiagram("instance");
                                instance._delete(instance.nameTable[this.model._selectedSymbol.name]);
                                perventAddingConnector = false;
                                var cur = instance._historyList.currentEntry;
                                var pre = cur.previous;
                                cur.object = pre.undoObject.node;
                                if (pre.undoObject.childTable) cur.childTable = pre.undoObject.childTable;
                                if (pre.undoObject.edgeTable) cur.edgeTable = pre.undoObject.edgeTable;
                                instance.removeHistoryEntry(pre);
                            }
                            else if (this.model._targetId != diagram._id) {
                                if (diagram.edgeTable) delete diagram.edgeTable;
                                perventAddingConnector = false;
                            }
                            this.model._isDragged = true;
                            diagram._selectedSymbol = this.model._selectedSymbol;
                            diagram._isNodeEnters = true;
                            var item = diagram._selectedSymbol;
                            var scale = diagram._currZoom;
                            var offset = $("#" + diagram.element[0].id).offset();
                            var coor = diagram._isTouchEvent(evt.event);
                            var x = ((coor ? coor.pageX : evt.event.pageX) + diagram._hScrollOffset - offset.left) / scale;
                            var y = ((coor ? coor.pageY : evt.event.pageY) + diagram._vScrollOffset - offset.top) / scale;
                            if (!item.segments)
                                this.model._translate(item, x - item.offsetX / scale, y - item.offsetY / scale);
                            else
                                this.model._translate(item, x - (item.sourcePoint.x + item.targetPoint.x) / 2 * scale, y - (item.sourcePoint.y + item.targetPoint.y) / 2 * scale);
                            if (this.model._isDragged && diagram.edgeTable && diagram.nameTable[item.name] && !perventAddingConnector && item.type != "pseudoGroup") {
                                for (var conn in diagram.edgeTable) {
                                    if (!diagram.nameTable[conn]) diagram.add(diagram.edgeTable[conn]);
                                    else {
                                        var connector = diagram.nameTable[conn];
                                        connector.sourceNode = diagram.edgeTable[conn].sourceNode;
                                        connector.sourcePort = diagram.edgeTable[conn].sourcePort;
                                        connector.targetNode = diagram.edgeTable[conn].targetNode;
                                        connector.targetPort = diagram.edgeTable[conn].targetPort;
                                    }
                                }
                                diagram._clearSelection(true);
                                diagram._addSelection(diagram.nameTable[item.name], true);
                                perventAddingConnector = true;
                            }
                        }
                        this.helper.css("display", "none");
                    }
                    else if (this.model._selectedSymbol) {
                        var diagram = $("#" + this.model._targetId).ejDiagram("instance");
                        diagram._delete(diagram.nameTable[this.model._selectedSymbol.name]);
                        perventAddingConnector = false;
                        if (!this.model._isDragged) {
                            var cur = diagram._historyList.currentEntry;
                            var pre = cur.previous;
                            cur.object = pre.undoObject.node;
                            if (pre.undoObject.childTable) cur.childTable = pre.undoObject.childTable;
                            if (pre.undoObject.edgeTable) cur.edgeTable = pre.undoObject.edgeTable;
                            diagram.removeHistoryEntry(pre);
                        }
                        this.helper.css("display", "block");
                        this.model._isDragged = true;
                    }
                    $('html,body').css('cursor', 'no-drop');
                },
                dragStop: function (evt, ui) {
                    var diagramElement = $(evt.target).parents(".e-datavisualization-diagram");
                    if (diagramElement) {
                        var diagram = $("#" + diagramElement.attr("id")).ejDiagram("instance");
                        if (this.model._isDragged && this.model._targetId == diagram._id) {
                            var cur = diagram._historyList.currentEntry;
                            var pre = cur.previous;
                            cur.undoObject.node = pre.object;
                            if (pre.childTable) cur.undoObject.childTable = pre.childTable;
                            if (pre.edgeTable) cur.undoObject.edgeTable = pre.edgeTable;
                            diagram.removeHistoryEntry(pre);
                        }
                        diagram._selectedSymbol = null;
                        delete diagram._isNodeEnters;

                    }
                    $(this.helper).remove();
                    $('html,body').css('cursor', 'default');
                },
                _translate: function (item, dx, dy) {
                    if (!item.segments) {
                        item.offsetX += dx;
                        item.offsetY += dy;
                        if (item.type == "pseudoGroup" || item.type == "group") {
                            for (var i = 0; i < item.children.length; i++)
                                this._translate(item.children[i], dx, dy);
                        }
                    }
                    else {
                        ej.datavisualization.Diagram.Util._translateLine(item, dx, dy, item);
                    }
                },
                _updateSelectedItem: function (item, isSwimlane) {
                    if (item.type == "pseudoGroup" || item.type == "group") {
                        for (var i = 0; i < item.children.length; i++) {
                            if (typeof item.children[i] === "string")
                                item.children[i] = diagram.nameTable[item.children[i]];
                            this._updateSelectedItem(item.children[i], isSwimlane);
                        }
                    }
                    if (!isSwimlane) {
                        if (!item.segments) {
                            for (var i = 0; i < item.inEdges.length; i++) {
                                var edge = diagram.findNode(item.inEdges[i]);
                                if (diagram.model.selectedItems.children.indexOf(edge) == -1) item.inEdges.splice(i, 1);
                            }
                            for (var i = 0; i < item.outEdges.length; i++) {
                                var edge = diagram.findNode(item.outEdges[i]);
                                if (diagram.model.selectedItems.children.indexOf(edge) == -1) item.outEdges.splice(i, 1);
                            }
                        }
                        else
                            item.sourceNode = item.targetNode = item.sourcePort = item.targetPort = "";
                    }
                }
            });
        },

        _renderItemContainer: function (id, content) {
            var container = document.createElement("div");
            var bounds = { width: 100, height: 100 };
            var attr = { "id": id + "_paletteItem", "draggable": "true", "height": bounds.height + "px", "width": bounds.width + "px", "style": "padding: 4; height:" + (bounds.height + 1) + "px;width:" + (bounds.width + 1) + "px;-ms-touch-action: none;touch-action: none;" };
            ej.datavisualization.Diagram.Util.attr(container, attr);
            content.appendChild(container);
            this._setItemDraggable(container);
            return this._renderAnchor(container, id, bounds);
        },
        _renderAnchor: function (container, id, itemSize) {
            var anchor = document.createElement("div");
            var attr = { "id": id + "_anchor", "height": itemSize.height + "px", "class": "e-anchor" };
            ej.datavisualization.Diagram.Util.attr(anchor, attr);
            container.appendChild(anchor);
            return this._renderSvg(anchor, id, itemSize);
        },
        _renderSvg: function (anchor, id, itemSize) {
            var parent;
            var wrapper = document.createElement("div");
            var attr = { "id": id + "_svgWrapper", "class": "e-svg-container", "style": "width:" + itemSize.width + "px;height:" + itemSize.height + "px;" };
            ej.datavisualization.Diagram.Util.attr(wrapper, attr);
            attr = {
                "id": id + "_svg", "width": itemSize.width, "height": itemSize.height,
                "version": "1.1", "xlink": "http://www.w3.org/1999/xlink"
            };
            var svg = new ej.datavisualization.Diagram.Svg(attr);
            wrapper.appendChild(svg.document);
            anchor.appendChild(wrapper);
            return svg;
        },
        //#endregion
    });
    ej.datavisualization.Diagram.Locale = {};

    ej.datavisualization.Diagram.Locale["default"] = {
        cut: "Cut",
        copy: "Copy",
        paste: "Paste",
        undo: "Undo",
        redo: "Redo",
        selectAll: "Select All",
        grouping: "Grouping",
        group: "Group",
        ungroup: "Ungroup",
        order: "Order",
        bringToFront: "Bring To Front",
        moveForward: "Move Forward",
        sendBackward: "Send Backward",
        sendToBack: "Send To Back"
    }

    ej.datavisualization.Diagram.Locale["en-US"] = {
        cut: "Cut",
        copy: "Copy",
        paste: "Paste",
        undo: "Undo",
        redo: "Redo",
        selectAll: "Select All",
        grouping: "Grouping",
        group: "Group",
        ungroup: "Ungroup",
        order: "Order",
        bringToFront: "Bring To Front",
        moveForward: "Move Forward",
        sendBackward: "Send Backward",
        sendToBack: "Send To Back"
    }

    $.fn.pinchDiagram = function (rootgroup, map) {
        var startTouches = [],
        handleTouchStart = function (evt) {
            var touches = evt.touches;
            if (touches.length >= 2) {
                for (var i = 0; i < touches.length; i++) {
                    var touch = touches[i]
                      , found = false;
                    for (var j = 0; j < startTouches.length; j++) {
                        var startTouch = startTouches[j];
                        if (touch.identifier === startTouch.identifier) {
                            found = true;
                            break;
                        }
                    }
                    if (!found) {
                        var touchCopy = $.extend({}, touch);
                        startTouches.push(touchCopy);
                    }
                }
            }
            evt.preventDefault();
        },
        getDistance = function (touch1, touch2) {
            var x = touch2.pageX - touch1.pageX,
                y = touch2.pageY - touch1.pageY;
            return Math.sqrt((x * x) + (y * y));
        },
        handleTouchEnd = function (evt) {
            var changedTouches = evt.changedTouches;
            for (var i = 0; i < changedTouches.length; i++) {
                var changedTouch = changedTouches[i];
                for (var j = 0; j < startTouches.length; j++) {
                    var startTouch = startTouches[j];
                    if (startTouch.identifier === changedTouch.identifier) {
                        var idx = startTouches.indexOf(startTouch);
                        startTouches.splice(idx, 1);
                    }
                }
            }
            evt.preventDefault();
        },
        updateTouch = function (dstTouch, srcTouch) {
            dstTouch.pageX = srcTouch.pageX;
            dstTouch.pageY = srcTouch.pageY;
        },
        handleTouchMove = function (evt) {
            evt.preventDefault();
            var touches = evt.touches, z;
            if (touches.length >= 2) {
                var touch0 = touches[0]
                  , touch1 = touches[1]
                  , startTouch0 = startTouches[0]
                  , startTouch1 = startTouches[1];
                z = getDistance(touch0, touch1) / getDistance(startTouch0, startTouch1);
                var focusPoint = map._mousePosition(evt, false);
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(map, z, 0, 0, focusPoint, true, true);
                updateTouch(startTouch0, touch0);
                updateTouch(startTouch1, touch1);
            }
        };
        this[0].addEventListener('touchstart', handleTouchStart, false);
        this[0].addEventListener('touchend', handleTouchEnd, false);
        this[0].addEventListener('touchmove', handleTouchMove, false);
    };
    //#endregion
})(jQuery, Syncfusion);;
(function ($, ej) {
    "use strict";
    ej.MatrixTypes = { Identity: 0, Translation: 1, Scaling: 2, Unknown: 4 };
    ej.MatrixDefaults = { m11: 1, m12: 0, m21: 0, m22: 1, offsetX: 0, offsetY: 0, type: ej.MatrixTypes.Identity };
    ej.Matrix = {
        identity: function () {
            return $.extend(true, {}, ej.MatrixDefaults);
        },
        multiply: function (matrix1, matrix2) {
            var type = matrix1.type;
            var type2 = matrix2.type;
            if (type2 == ej.MatrixTypes.Identity) {
                return;
            }
            if (type == ej.MatrixTypes.Identity) {
                matrix1.m11 = matrix2.m11;
                matrix1.m12 = matrix2.m12;
                matrix1.m21 = matrix2.m21;
                matrix1.m22 = matrix2.m22;
                matrix1.offsetX = matrix2.offsetX;
                matrix1.offsetY = matrix2.offsetY;
                matrix1.type = matrix2.type;
                return;
            }
            if (type2 == ej.MatrixTypes.Translation) {
                matrix1.offsetX += matrix2.offsetX;
                matrix1.offsetY += matrix2.offsetY;
                if (type != ej.MatrixTypes.Unknown) {
                    matrix1.type |= ej.MatrixTypes.Translation;
                }
                return;
            }
            if (type != ej.MatrixTypes.Translation) {
                var num = type << 4 | type2;
                switch (num) {
                    case 34:
                        matrix1.m11 *= matrix2.m11;
                        matrix1.m22 *= matrix2.m22;
                        return;
                    case 35:
                        matrix1.m11 *= matrix2.m11;
                        matrix1.m22 *= matrix2.m22;
                        matrix1.offsetX = matrix2.offsetX;
                        matrix1.offsetY = matrix2.offsetY;
                        matrix1.type = (ej.MatrixTypes.Translation | ej.MatrixTypes.Scaling);
                        return;
                    case 36: break;
                    default:
                        {
                            switch (num) {
                                case 50:
                                    matrix1.m11 *= matrix2.m11;
                                    matrix1.m22 *= matrix2.m22;
                                    matrix1.offsetX *= matrix2.m11;
                                    matrix1.offsetY *= matrix2.m22;
                                    return;
                                case 51:
                                    matrix1.m11 *= matrix2.m11;
                                    matrix1.m22 *= matrix2.m22;
                                    matrix1.offsetX = matrix2.m11 * matrix1.offsetX + matrix2.offsetX;
                                    matrix1.offsetY = matrix2.m22 * matrix1.offsetY + matrix2.offsetY;
                                    return;
                                case 52: break;
                                default:
                                    switch (num) {
                                        case 66:
                                        case 67:
                                        case 68: break;
                                        default: return;
                                    }
                                    break;
                            }
                            break;
                        }
                }
                var result = this.identity();
                this._setMatrix(result, matrix1.m11 * matrix2.m11 + matrix1.m12 * matrix2.m21,
                    matrix1.m11 * matrix2.m12 + matrix1.m12 * matrix2.m22, matrix1.m21 * matrix2.m11 + matrix1.m22 * matrix2.m21,
                    matrix1.m21 * matrix2.m12 + matrix1.m22 * matrix2.m22,
                    matrix1.offsetX * matrix2.m11 + matrix1.offsetY * matrix2.m21 + matrix2.offsetX, matrix1.offsetX * matrix2.m12 + matrix1.offsetY * matrix2.m22 + matrix2.offsetY);
                if (result.m21 || result.m12) {
                    result.type = ej.MatrixTypes.Unknown;
                }
                else {
                    if (result.m11 && result.m11 != 1.0 || result.m22 && result.m22 != 1.0) {
                        result.type = ej.MatrixTypes.Scaling;
                    }
                    if (result.offsetX || result.offsetY) {
                        result.type |= ej.MatrixTypes.Translation;
                    }
                    if ((result.type & (ej.MatrixTypes.Translation | ej.MatrixTypes.Scaling)) == ej.MatrixTypes.Identity) {
                        result.type = ej.MatrixTypes.Identity;
                    }
                }
                matrix1.m11 = result.m11;
                matrix1.m12 = result.m12;
                matrix1.m21 = result.m21;
                matrix1.m22 = result.m22;
                matrix1.offsetX = result.offsetX;
                matrix1.offsetY = result.offsetY;
                matrix1.type = result.type;
                return;
            }
            var offsetX = matrix1.offsetX;
            var offsetY = matrix1.offsetY;
            matrix1.m11 = matrix2.m11;
            matrix1.m12 = matrix2.m12;
            matrix1.m21 = matrix2.m21;
            matrix1.m22 = matrix2.m22;
            matrix1.offsetX = matrix2.offsetX;
            matrix1.offsetY = matrix2.offsetY;
            matrix1.type = matrix2.type;
            matrix1.offsetX = offsetX * matrix2.m11 + offsetY * matrix2.m21 + matrix2.offsetX;
            matrix1.offsetY = offsetX * matrix2.m12 + offsetY * matrix2.m22 + matrix2.offsetY;
            if (type2 == ej.MatrixTypes.Unknown) {
                matrix1.type = ej.MatrixTypes.Unknown;
                return;
            }
            matrix1.type = (ej.MatrixTypes.Translation | ej.MatrixTypes.Scaling);
        },
        transform: function (matrix, point) {
            var pt = this._multiplyPoint(matrix, point.x, point.y);
            return { x: Math.round(pt.x * 100) / 100, y: Math.round(pt.y * 100) / 100 };
        },
        rotate: function (matrix, angle, centerX, centerY) {
            angle %= 360.0;
            this.multiply(matrix, this._createRotationRadians(angle * 0.017453292519943295, centerX ? centerX : 0, centerY ? centerY : 0));
        },
        scale: function (matrix, scaleX, scaleY, centerX, centerY) {
            this.multiply(matrix, this._createScaling(scaleX, scaleY, centerX ? centerX : 0, centerY ? centerY : 0));
        },
        translate: function (matrix, offsetX, offsetY) {
            if (matrix.type & ej.MatrixTypes.Identity) {
                this._setMatrix(matrix, 1.0, 0.0, 0.0, 1.0, offsetX, offsetY, ej.MatrixTypes.Translation);
                return;
            }
            if (matrix.type & ej.MatrixTypes.Unknown) {
                matrix.offsetX += offsetX;
                matrix.offsetY += offsetY;
                return;
            }
            matrix.offsetX += offsetX;
            matrix.offsetY += offsetY;
            matrix.type |= ej.MatrixTypes.Translation;
        },
        _createScaling: function (scaleX, scaleY, centerX, centerY) {
            var result = this.identity();
            this._setMatrix(result, scaleX, 0.0, 0.0, scaleY, centerX - scaleX * centerX, centerY - scaleY * centerY,
                !(centerX || centerY) ? ej.MatrixTypes.Scaling : ej.MatrixTypes.Scaling | ej.MatrixTypes.Translation);
            return result;
        },
        _createRotationRadians: function (angle, centerX, centerY) {
            var result = this.identity();
            var num = Math.sin(angle);
            var num2 = Math.cos(angle);
            var offsetX = centerX * (1.0 - num2) + centerY * num;
            var offsetY = centerY * (1.0 - num2) - centerX * num;
            this._setMatrix(result, num2, num, -num, num2, offsetX, offsetY, ej.MatrixTypes.Unknown);
            return result;
        },
        _multiplyPoint: function (matrix, x, y) {
            switch (matrix.type) {
                case ej.MatrixTypes.Identity: break;
                case ej.MatrixTypes.Translation:
                    x += matrix.offsetX;
                    y += matrix.offsetY;
                    break;
                case ej.MatrixTypes.Scaling:
                    x *= matrix.m11;
                    y *= matrix.m22;
                    break;
                case ej.MatrixTypes.Translation | ej.MatrixTypes.Scaling:
                    x *= matrix.m11;
                    x += matrix.offsetX;
                    y *= matrix.m22;
                    y += matrix.offsetY;
                    break;
                default:
                    var num = y * matrix.m21 + matrix.offsetX;
                    var num2 = x * matrix.m12 + matrix.offsetY;
                    x *= matrix.m11;
                    x += num;
                    y *= matrix.m22;
                    y += num2;
                    break;
            }
            return { x: x, y: y };
        },
        _setMatrix: function (matrix, m11, m12, m21, m22, offsetX, offsetY, type) {
            matrix.m11 = m11;
            matrix.m12 = m12;
            matrix.m21 = m21;
            matrix.m22 = m22;
            matrix.offsetX = offsetX;
            matrix.offsetY = offsetY;
            matrix.type = type || ej.MatrixTypes.Identity;
        }
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej) {
    "use strict";
    //#region HitTesting
    ej.datavisualization.Diagram.HitTesting = {
        _getResizeHandleCenter: function (shape, position, scale) {
            if (!scale) scale = 1;
            var corners = this.bounds(shape);
            var center = ej.datavisualization.Diagram.Point(0, 0);
            switch (position) {
                case "topleft":
                    center = corners.topLeft;
                    break;
                case "topcenter":
                    center = corners.top;
                    break;
                case "topright":
                    center = corners.topRight;
                    break;
                case "middleleft":
                    center = corners.left;
                    break;
                case "middleright":
                    center = corners.right;
                    break;
                case "bottomleft":
                    center = corners.bottomLeft;
                    break;
                case "bottomcenter":
                    center = corners.bottom;
                    break;
                case "bottomright":
                    center = corners.bottomRight;
                    break;
                case "pivot":
                    center = ej.datavisualization.Diagram.Point(shape.offsetX, shape.offsetY);
                    break;
                case "rotate":
                    var thumbHeight = 20;
                    var dist = 20 / scale; //distance between element top and rotator thumb
                    var pt = ej.datavisualization.Diagram.Point(shape.offsetX, (shape.offsetY - shape.height * shape.pivot.y) - thumbHeight / 2 - dist);
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, shape.rotateAngle, shape.offsetX, shape.offsetY);
                    center = ej.Matrix.transform(matrix, pt);
                    break;
            }
            return center;
        },
        findResizeHandleAtPoint: function (node, point) {
            var resizeDirection = null;
            if (node) {
                var center;
                var success;
                var directions = ["topleft", "topcenter", "topright", "middleleft", "middleright", "bottomleft", "bottomcenter", "bottomright"];
                for (var i = 0, len = directions.length; i < len; i++) {
                    center = this._getResizeHandleCenter(node, directions[i]);
                    if (center !== ej.datavisualization.Diagram.Point(0, 0)) {
                        success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(center.x, center.y), 7); // right now 7 is default handle radius size, need to give as constant variable
                        if (success) {
                            resizeDirection = directions[i];
                            break;
                        }
                    }
                }
            }
            return resizeDirection;
        },
        findRotationHandleAtPoint: function (node, point, scale) {
            var center = this._getResizeHandleCenter(node, "rotate", scale);
            var success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(center.x, center.y), 10); // right now 7 is default handle radius size, need to give as constant variable
            if (success) {
                return true;
            }
            return false;
        },
        findPivotHandleAtPoint: function (node, point) {
            var center = this._getResizeHandleCenter(node, "pivot");
            var success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(center.x, center.y), 7); // right now 7 is default handle radius size, need to give as constant variable
            if (success) {
                return true;
            }
            return false;
        },
        findEndPointHandleAtPoint: function (connector, point) {
            var endPointHandle = null;
            if (connector) {
                var success;
                var points = connector.line.points;
                var pt = points[points.length - 1];
                success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(pt.x, pt.y), 7); // right now 7 is default handle radius size, need to give as constant variable
                if (success) {
                    endPointHandle = "targetEndPoint";
                }
                if (!success) {
                    pt = points[0];
                    success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(pt.x, pt.y), 7); // right now 7 is default handle radius size, need to give as constant variable
                    if (success) {
                        endPointHandle = "sourceEndPoint";
                    }
                }
                if (!success && connector.line.type === "bezier") {
                    pt = connector.line._point1;
                    success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(pt.x, pt.y), 7); // right now 7 is default handle radius size, need to give as constant variable
                    if (success) {
                        endPointHandle = "bezierpoint1";
                    }
                    if (!success) {
                        var pt1 = connector.line._point2;
                        success = ej.datavisualization.Diagram.Geometry.checkPointOnCircle(point, ej.datavisualization.Diagram.Point(pt1.x, pt1.y), 7); // right now 7 is default handle radius size, need to give as constant variable
                        if (success) {
                            endPointHandle = "bezierpoint2";
                        }
                    }
                }
            }
            return endPointHandle;
        }
    };
    //#endregion

    ej.datavisualization.Diagram.LayoutUtil = {
        expandSubTree: function (diagram, node, reference, isAnimate, select, bringIntoView, collapse) {
            if (!diagram._isAnimating) {
                var zoom = diagram.model.scrollSettings.currentZoom;
                var hOffset = node.offsetX * zoom - diagram.model.scrollSettings.viewPortWidth / 2 - diagram.model.scrollSettings.horizontalOffset;
                if (node.offsetY * zoom < diagram.model.scrollSettings.verticalOffset || node.offsetY * zoom > (diagram.model.scrollSettings.verticalOffset + diagram.model.scrollSettings.viewPortHeight - 3 * node.height * zoom))
                    diagram.update({ scrollSettings: { verticalOffset: node.offsetY - diagram.model.scrollSettings.viewPortHeight / 2 } });
                var i = 0;
                if (hOffset != 0 && bringIntoView) {
                    diagram._preventScrollerUpdate = true;
                    var panningAnimation = setInterval(function () {
                        if (i < 4)
                            diagram.update({ scrollSettings: { horizontalOffset: diagram.model.scrollSettings.horizontalOffset + hOffset / 4 } });
                        i++;
                        if (i == 5) {
                            clearInterval(panningAnimation);
                            delete diagram._preventScrollerUpdate;
                            if ((collapse !== false || !node.isExpanded) && node.outEdges.length)
                                ej.datavisualization.Diagram.LayoutUtil.expand(diagram, node, reference, isAnimate, select);
                            else
                                ej.datavisualization.Diagram.ScrollUtil._setScrollContentSize(diagram);

                        }
                    }, 25);
                }
                else {
                    delete diagram._preventScrollerUpdate;
                    if ((collapse !== false || !node.isExpanded) && node.outEdges.length)
                        this.expand(diagram, node, reference, isAnimate, select);
                    else
                        ej.datavisualization.Diagram.ScrollUtil._setScrollContentSize(diagram);
                }
            }
        },
        _updateVisiblity: function (diagram, node, opacity) {
            for (var k = 0; k < node.outEdges.length; k++) {
                var edge = node.outEdges[k];
                edge = diagram.findNode(edge);
                var targetNode = diagram.findNode(edge.targetNode);
                edge.opacity = targetNode.opacity = opacity / 100;
                ej.datavisualization.Diagram.DiagramContext.updateNodeStyle(targetNode, diagram);
                ej.datavisualization.Diagram.DiagramContext.updateConnectorStyle(edge, diagram);
                if (targetNode.isExpanded && targetNode.outEdges.length) this._updateVisiblity(diagram, targetNode, opacity);
            }
        },
        expand: function (diagram, node, reference, isAnimate, select) {
            if (reference === undefined) {
                reference = node.name;
            }
            var temp = diagram.model.layout.fixedNode;
            diagram.model.layout.fixedNode = reference;
            var selectedItem = diagram.selectionList[0] ? diagram.selectionList[0].name : "";
            if (selectedItem)
                diagram._clearSelection(true);
            if (!isAnimate)
                diagram.layout();
            else if (!diagram._isAnimating) {
                node._updateExpander = true;
                diagram._updateEdgeCollection();

                //Expand or collapse the sub tree
                if (node.isExpanded) {
                    diagram._collapseChildren(node); node.isExpanded = false;
                } else { diagram._expandChildren(node); node.isExpanded = true; }
                diagram._isAnimating = true;
                //Layout the nodes
                var objects = ej.datavisualization.Diagram.Layout.doLayout(diagram, false);

                var i = 0;

                if (objects.length) {
                    $(".ej-d-connector").attr("opacity", 0);
                    $(".ej-d-icon-template").attr("opacity", 0);
                    diagram._layoutInAction = true;
                    var leftTimer = setInterval(function () {
                        i++;
                        if (i < 5) {
                            //Move the objects towards the corresponding direction
                            for (var l = 0; l < objects.length; l++) {
                                var obj = diagram.nameTable[objects[l].object];
                                diagram._disableSegmentChange = true;
                                diagram.updateNode(obj.name, { offsetX: obj.offsetX + objects[l].diff / 4, offsetY: obj.offsetY + objects[l].diffy / 4 });
                                diagram._disableSegmentChange = false;
                            }
                        }
                        if (i == 5) {
                            clearInterval(leftTimer);
                            delete diagram._layoutInAction;
                            //update the connectors
                            var layout = diagram._internalLayout;
                            for (i = 0; i < layout._firstLevelNodes.length; i++) {
                                ej.datavisualization.Diagram.HierarchicalLayout._updateConnectors(layout, layout._firstLevelNodes[i], 1);
                            }
                            delete diagram._internalLayout;
                            $(".ej-d-connector").attr("opacity", 1);
                            $(".ej-d-icon-template").attr("opacity", 1);
                            if (selectedItem || select) diagram._addSelection(diagram.findNode(selectedItem || reference), !select);
                            diagram._isAnimating = false;
                            delete diagram._preventScrollerUpdate;
                            ej.datavisualization.Diagram.ScrollUtil._setScrollContentSize(diagram);
                        }
                    }, 50);
                }
                else {
                    //update the connectors
                    var layout = diagram._internalLayout;
                    for (i = 0; i < layout._firstLevelNodes.length; i++) {
                        ej.datavisualization.Diagram.HierarchicalLayout._updateConnectors(layout, layout._firstLevelNodes[i], 1);
                    }
                    if (selectedItem || select) diagram._addSelection(diagram.findNode(selectedItem || reference), !select);
                    diagram._isAnimating = false;
                    delete diagram._internalLayout;
                }

                //Update the opacity of the expanded or collapsed sub tree
                var opacity = 0;
                var current = this;
                if (node.isExpanded) {
                    current._updateVisiblity(diagram, node, 0)
                    var settimer = setInterval(function () {
                        if (node.isExpanded) {
                            if (opacity <= 100)
                                current._updateVisiblity(diagram, node, opacity)
                            if (opacity == 120) {
                                clearInterval(settimer);
                            }
                            opacity += 5;
                        }
                    }, 25);
                }
                ej.datavisualization.Diagram.PageUtil._updatePageSize(diagram);
            }
            diagram.model.layout.fixedNode = temp;
        }
    };

    //#region Util
    ej.datavisualization.Diagram.Util = {

        convertPathToArray: function (string) {
            var pathSegList = [], pathDataList = this.parsePathData(string);
            if (pathDataList.length > 0) {
                for (var i = 0; i < pathDataList.length; i++) {
                    var pathArray = pathDataList[i];
                    var startChar = pathArray[0];
                    switch (startChar.toLowerCase()) {
                        case "m":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, x: pathArray[j], y: pathArray[j + 1] });
                                j = j + 1;
                                if (startChar === "m")
                                    startChar = "l";
                                else if (startChar === "M")
                                    startChar = "L";
                            }
                            break;
                        case "l":
                        case "t":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, x: pathArray[j], y: pathArray[j + 1] });
                                j = j + 1;
                            }
                            break;
                        case "h":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, x: pathArray[j] });
                            }
                            break;
                        case "v":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, y: pathArray[j] });
                            }
                            break;
                        case "z":
                            pathSegList.push({ pathSegTypeAsLetter: startChar });
                            break;
                        case "c":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, x1: pathArray[j], y1: pathArray[j + 1], x2: pathArray[j + 2], y2: pathArray[j + 3], x: pathArray[j + 4], y: pathArray[j + 5] });
                                j = j + 5;
                            }
                            break;
                        case "s":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, x2: pathArray[j], y2: pathArray[j + 1], x: pathArray[j + 2], y: pathArray[j + 3] });
                                j = j + 3;
                            }
                            break;
                        case "q":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, x1: pathArray[j], y1: pathArray[j + 1], x: pathArray[j + 2], y: pathArray[j + 3] });
                                j = j + 3;
                            }
                            break;
                        case "a":
                            for (var j = 1; j < pathArray.length; j++) {
                                pathSegList.push({ pathSegTypeAsLetter: startChar, r1: pathArray[j], r2: pathArray[j + 1], angle: pathArray[j + 2], largeArcFlag: this.parseArcFlag(pathArray[j + 3]), sweepFlag: this.parseArcFlag(pathArray[j + 4]), x: pathArray[j + 5], y: pathArray[j + 6] });
                                j = j + 6;
                            }
                            break;
                    }
                }
            }
            return pathSegList;
        },
        _getImageAlignment: function (option) {
            if (option) {
                switch (option.toLowerCase()) {
                    case "xminymin":
                        return "xMinYMin";
                    case "xminymid":
                        return "xMinYMid";
                    case "xminymax":
                        return "xMinYMax";
                    case "xmidymin":
                        return "xMidYMin";
                    case "xmidymid":
                        return "xMidYMid";
                    case "xmidymax":
                        return "xMidYMax";
                    case "xmaxymin":
                        return "xMaxYMin";
                    case "xmaxymid":
                        return "xMaxYMid";
                    case "xmaxymax":
                        return "xMaxYMax";
                    case "none":
                        return "none";
                }
            }
            return "none";
        },
        parseArcFlag: function (char) {
            var flag;
            if (char === "0" || char === 0)
                flag = false;
            else if (char === "1" || char === 1)
                flag = true;
            return flag;
        },

        parsePathData: function (pathData) {
            var tokenizer = /([a-z]+)|([+-]?(?:\d+\.?\d*|\.\d+))/gi, match, current, commands = [];
            tokenizer.lastIndex = 0;
            var isExponential = false;
            while (match = tokenizer.exec(pathData)) {
                if (match[1] === "e") {
                    var s1 = "";
                    isExponential = true;
                }
                else if (match[1]) {
                    if (match[1].toLowerCase() === "zm") {
                        if (current)
                            commands.push(current);
                        commands.push(["Z"]);
                        current = [match[1].substring(1, 2)]
                    }
                    else {
                        if (current)
                            commands.push(current);
                        current = [match[1]];
                    }
                    isExponential = false;
                }
                else {
                    if (!current)
                        current = [];
                    if (!isExponential)
                        current.push(Number(match[2]));
                    isExponential = false;
                }
            }
            if (current) commands.push(current);
            return commands;
        },

        pathSegArrayAsString: function (pathSegArray) {
            var string = "";
            for (var i = 0; i < pathSegArray.length; i++) {
                var pathSeg = pathSegArray[i];
                if (i === 0)
                    string += this.pathToString(pathSeg);
                else
                    string += " " + this.pathToString(pathSeg);
            }
            return string;
        },
        canEnablePointerEvents: function (node, diagram) {
            var temp = node;
            var enabled;
            if (diagram) {
                while (temp) {
                    if (temp.segments)
                        enabled = temp.constraints & ej.datavisualization.Diagram.ConnectorConstraints.PointerEvents;
                    else
                        enabled = temp.constraints & ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                    if (!enabled) return enabled;
                    temp = typeof temp.parent == "string" ? diagram.nameTable[temp.parent] : temp;
                }

            }
            return true;
        },
        isClassifier: function (evt) {
            var className = typeof evt.target.className == "string" ? evt.target.className : evt.target.className.baseVal;
            if ($(evt.target).hasClass("ej-d-classifier") || className.indexOf("ej-d-classifier") > -1)
                return true;
            else
                return false;
        },
        pathToString: function (pathSeg) {
            var string;
            switch (pathSeg.pathSegTypeAsLetter) {
                case "Z":
                case "z":
                    string = pathSeg.pathSegTypeAsLetter;
                    break;
                case "M":
                case "m":
                case "L":
                case "l":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.x + " " + pathSeg.y;
                    break;
                case "C":
                case "c":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.x1 + " " + pathSeg.y1 + " " + pathSeg.x2 + " " + pathSeg.y2 + " " + pathSeg.x + " " + pathSeg.y;
                    break;
                case "Q":
                case "q":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.x1 + " " + pathSeg.y1 + " " + pathSeg.x + " " + pathSeg.y;
                    break;
                case "A":
                case "a":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.r1 + " " + pathSeg.r2 + " " + pathSeg.angle + " " + (pathSeg.largeArcFlag ? "1" : "0") + " " + (pathSeg.sweepFlag ? "1" : "0") + " " + pathSeg.x + " " + pathSeg.y;
                    break;
                case "H":
                case "h":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.x;
                    break;
                case "V":
                case "v":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.y;
                    break;
                case "S":
                case "s":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.x2 + " " + pathSeg.y2 + " " + pathSeg.x + " " + pathSeg.y;
                    break;
                case "T":
                case "t":
                    string = pathSeg.pathSegTypeAsLetter + " " + pathSeg.x + " " + pathSeg.y;
            }
            return string;
        },

        findPortByName: function (node, portName) {
            var port;
            if (node) {
                if (node.ports)
                    for (var i = 0, len = node.ports.length; i < len; i++) {
                        port = node.ports[i];
                        if (port.name === portName) {
                            return port;
                        }
                    }
            }
            return null;
        },
        attr: function (element, attributes) {
            for (var atr in attributes) {
                element.setAttribute(atr.toString(), attributes[atr]);
            }
        },
        removeChildFromGroup: function (array, item) {
            var index = array.indexOf(item);
            if (index < 0) {
                for (var i in array) {
                    if (typeof (array[i]) === "object" && typeof (item) === "string") {
                        if (array[i].name === item) {
                            index = i;
                            break;
                        }
                    }
                }
            }
            if (index >= 0)
                array.splice(index, 1);
        },
        removeFromCollection: function (diagram, array, item) {
            if (diagram) {
                var item = diagram.nameTable[diagram._getChild(item)];
                for (var i in array) {
                    var child = diagram.nameTable[diagram._getChild(array[i])];
                    if (child.name === item.name) {
                        array.splice(i, 1);
                    }
                }
            }
        },
        removeItem: function (array, item) {
            var index = array.indexOf(item);
            if (index >= 0)
                array.splice(index, 1);
        },
        clear: function (array) {
            while (array.length > 0) {
                array.pop();
            }
        },
        getChild: function (child) {
            if (child) {
                if (typeof (child) == "object") {
                    return child.name;
                } else {
                    return child;
                }
            }
        },
        randomId: function () {
            var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
            var id = "";
            //get 4 random chars
            for (var i = 0; i < 4; i++) {
                var num = ej.getRandomValue(0, chars.length - 1);
                id += chars.substring(num, num + 1);
            }
            return id;
        },
        htmlEncode: function (html) {
            var str = html.replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&apos;/g, '\'');
            return str;
        },
        canMove: function (node) {
            if (this.canSelect(node)) {
                if (node.segments) {
                    return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.Drag;
                } else
                    return node.constraints & ej.datavisualization.Diagram.NodeConstraints.Drag;
            }
        },
        canMoveLabel: function (node) {
            if (node.segments) {
                return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.DragLabel;
            } else
                return node.constraints & ej.datavisualization.Diagram.NodeConstraints.DragLabel;
        },
        canRotate: function (node) {
            if (node.segments) {
                return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.Rotate;
            } else
                return node.constraints & ej.datavisualization.Diagram.NodeConstraints.Rotate;
        },
        canShowTooltip: function (node, diagram) {
            if (node.segments) {
                var inherit = node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.InheritTooltip;
            } else
                var inherit = node.constraints & ej.datavisualization.Diagram.NodeConstraints.InheritTooltip;
            if (inherit) {
                return diagram.model.tooltip;
            } return node.tooltip;
        },
        canSelect: function (node) {
            if (node.segments) {
                return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.Select;
            } else
                return node.constraints & ej.datavisualization.Diagram.NodeConstraints.Select;
        },
        canBridge: function (connector, diagram) {
            if (connector.constraints & ej.datavisualization.Diagram.ConnectorConstraints.Bridging) {
                return connector.constraints & ej.datavisualization.Diagram.ConnectorConstraints.Bridging;
            }
            else if (connector.constraints & ej.datavisualization.Diagram.ConnectorConstraints.InheritBridging) {
                return diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.Bridging;
            }
        },
        canCrispEdges: function (node, diagram) {
            if (node.segments) {
                if (node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.CrispEdges) {
                    return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.CrispEdges;
                }
                else if (diagram && node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.InheritCrispEdges) {
                    return diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.CrispEdges;
                }
            } else {
                if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.CrispEdges) {
                    return node.constraints & ej.datavisualization.Diagram.NodeConstraints.CrispEdges;
                }
                else if (diagram && node.constraints & ej.datavisualization.Diagram.NodeConstraints.InheritCrispEdges) {
                    return diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.CrispEdges;
                }
            }
        },
        canAllowPan: function (node) {
            return node.constraints & ej.datavisualization.Diagram.NodeConstraints.AllowPan;
        },
        canAllowDrop: function (node) {
            if (node.segments) {
                return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.AllowDrop;
            } else
                return node.constraints & ej.datavisualization.Diagram.NodeConstraints.AllowDrop;
        },
        canDelete: function (node) {
            if (node.segments) {
                return node.constraints & ej.datavisualization.Diagram.ConnectorConstraints.Delete;
            } else
                return node.constraints & ej.datavisualization.Diagram.NodeConstraints.Delete;
        },
        isPageEditable: function (diagram) {
            if (diagram) {
                return diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.UserInteraction;
            }
        },
        canFloatElements: function (diagram) {
            if (diagram) return diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.FloatElements;
        },

        canEnableAPIMethods: function (diagram) {
            if (diagram && diagram._enableAPIMethods) {
                return diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.APIUpdate;
            }
        },

        canDoMultipleSelection: function (diagram) {
            if (diagram && this.isPageEditable(diagram)) {
                return diagram.tool() & ej.datavisualization.Diagram.Tool.MultipleSelect;
            }
        },
        canDoSingleSelection: function (diagram) {
            if (diagram && this.isPageEditable(diagram)) {
                return diagram.tool() & ej.datavisualization.Diagram.Tool.SingleSelect;
            }
        },
        canMoveOutofBoundary: function (diagram) {
            if (diagram.model.pageSettings.boundaryConstraints != "infinity")
                return true;
            return false;
        },
        _getPseudoGroupConstraints: function (diagram, node, selectionlist) {
            var pseudoGroupConstraints;
            if (selectionlist && selectionlist.type === "pseudoGroup") {
                if (selectionlist.children.indexOf(node.name) >= 0 || node.name === selectionlist.name)
                    if (diagram.model.selectedItems.getConstraints) {
                        var getConstraints = diagram.model.selectedItems.getConstraints;
                        if (typeof getConstraints == "string")
                            getConstraints = ej.util.getObject(getConstraints, window);
                    }
                if (getConstraints && $.isFunction(getConstraints))
                    pseudoGroupConstraints = getConstraints();
                else {
                    if (selectionlist.children) {
                        pseudoGroupConstraints = ej.datavisualization.Diagram.NodeConstraints.Default;
                        for (var i = 0; i < selectionlist.children.length ; i++) {
                            var nodes = diagram.nameTable[diagram._getChild(selectionlist.children[i])];
                            if (nodes) {
                                var nodeConstraints = nodes.constraints;
                                if (!(nodeConstraints & ej.datavisualization.Diagram.NodeConstraints.Resize))
                                    pseudoGroupConstraints = pseudoGroupConstraints & ~ej.datavisualization.Diagram.NodeConstraints.Resize;
                                if (!(nodeConstraints & ej.datavisualization.Diagram.NodeConstraints.Rotate))
                                    pseudoGroupConstraints = pseudoGroupConstraints & ~ej.datavisualization.Diagram.NodeConstraints.Rotate;
                                if (!(nodeConstraints & ej.datavisualization.Diagram.NodeConstraints.Drag))
                                    pseudoGroupConstraints = pseudoGroupConstraints & ~ej.datavisualization.Diagram.NodeConstraints.Drag;
                            }
                        }
                    }
                }
            }

            return pseudoGroupConstraints;
        },
        canPanning: function (diagram) {
            if (diagram) {
                return (diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.PannableX) || (diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.PannableY);
            }
        },
        canZooming: function (diagram) {
            if (diagram) {
                return (diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.Zoomable);
            }
        },
        canUndo: function (diagram) {
            if (diagram) {
                return (diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.Undoable);
            }
        },
        canZoomTextEditor: function (diagram) {
            if (diagram) return (diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.ZoomTextEditor);
        },
        canMultiSelectOnLane: function (node) {
            return node.constraints & ej.datavisualization.Diagram.NodeConstraints.MultiSelect;
        },
        canMultiSelectOnNode: function (node) {
            return node.constraints & ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
        },
        canEnableTooltip: function (diagram) {
            if (diagram.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.Tooltip)
                return true;
            else
                return false;
        },
        canDrawStackHighlighter: function (diagram, node, overNode) {
            if (ej.datavisualization.Diagram.Util.canMoveOutofBoundary(diagram)) {
                if (diagram && node && overNode) {
                    var laneStack = diagram.nameTable[overNode.parent];
                    if (laneStack && laneStack.isLaneStack) {
                        var swimlane = diagram.nameTable[laneStack.parent];
                        if (swimlane && swimlane.isSwimlane) {
                            var swimlaneBounds = this.bounds(swimlane);
                            var size = diagram.activeTool._getPageBounds();
                            if (swimlane.orientation === "horizontal") {
                                if ((node.height + swimlaneBounds.bottom >= size.height) || (node.width - swimlane.width + swimlaneBounds.right > size.width)) {
                                    diagram.activeTool.updateCursor("not-allowed");
                                    diagram._notAllow = true;
                                    return false;
                                }
                            }
                            else {
                                if ((node.width + swimlaneBounds.right >= size.width) || (node.height - swimlane.height + swimlaneBounds.bottom > size.height)) {
                                    diagram.activeTool.updateCursor("not-allowed");
                                    diagram._notAllow = true;
                                    return false;
                                }
                            }
                        }
                    }

                }
            }
            return true;
        },
        canDragSourceEnd: function (connector) {
            return connector.constraints & ej.datavisualization.Diagram.ConnectorConstraints.DragSourceEnd;
        },
        canDragTargetEnd: function (connector) {
            return connector.constraints & ej.datavisualization.Diagram.ConnectorConstraints.DragTargetEnd;
        },
        canDragSegmentThumbs: function (connector) {
            return connector.constraints & ej.datavisualization.Diagram.ConnectorConstraints.DragSegmentThumb;
        },
        isTargetConnected: function (connector) {
            return connector.targetNode ? true : false;
        },
        isSourceConnected: function (connector) {
            return connector.sourceNode ? true : false;
        },
        bounds: function (object, excludeRotation) {
            var rect = {};
            if (object) {
                if (object.segments) {
                    for (var i = 0; i < object.segments.length; i++) {
                        var segment = object.segments[i];
                        if (i == 0) {
                            if (segment.points)
                                rect = ej.datavisualization.Diagram.Geometry.rect(segment.points);
                        }
                        else
                            rect = ej.datavisualization.Diagram.Geometry.union(rect, ej.datavisualization.Diagram.Geometry.rect(segment.points));
                        if (rect.width == 0) { rect.width = object.lineWidth; rect.x -= object.lineWidth / 2; }
                        if (rect.height == 0) { rect.height = object.lineWidth; rect.y -= object.lineWidth / 2; }
                    }
                }
                else if (object._type == "node" || object._type === "group" || object.type == "umlclassifier" || object._type == "pseudoGroup") {
                    var width = object.width ? object.width : object._width || 0;
                    var height = object.height ? object.height : object._height || 0;
                    rect = { x: object.offsetX - width * object.pivot.x, y: object.offsetY - height * object.pivot.y, width: width, height: height };
                }
                else
                    rect = object;
            }
            else
                rect = ej.datavisualization.Diagram.Rectangle();
            if (rect) {
                var bounds = {};
                rect.x = Math.round(rect.x * 100) / 100;
                rect.y = Math.round(rect.y * 100) / 100;
                rect.width = Math.round(rect.width * 100) / 100;
                rect.height = Math.round(rect.height * 100) / 100;
                bounds["width"] = rect.width;
                bounds["height"] = rect.height;
                bounds["x"] = bounds["left"] = rect.x;
                bounds["right"] = rect.x + rect.width;
                bounds["y"] = bounds["top"] = rect.y;
                bounds["bottom"] = rect.y + rect.height;
                bounds["center"] = { x: rect.x + rect.width / 2, y: rect.y + rect.height / 2 };
                bounds["topLeft"] = { x: rect.x, y: rect.y };
                bounds["topCenter"] = { x: rect.x + rect.width / 2, y: rect.y };
                bounds["topRight"] = { x: rect.x + rect.width, y: rect.y };
                bounds["middleLeft"] = { x: rect.x, y: rect.y + rect.height / 2 };
                bounds["middleRight"] = { x: rect.x + rect.width, y: rect.y + rect.height / 2 };
                bounds["bottomLeft"] = { x: rect.x, y: rect.y + rect.height };
                bounds["bottomCenter"] = { x: rect.x + rect.width / 2, y: rect.y + rect.height };
                bounds["bottomRight"] = { x: rect.x + rect.width, y: rect.y + rect.height };
                if (object && object.rotateAngle && !excludeRotation) {
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, object.rotateAngle, object.offsetX, object.offsetY);
                    bounds.topLeft = ej.Matrix.transform(matrix, bounds.topLeft);
                    bounds.topCenter = ej.Matrix.transform(matrix, bounds.topCenter);
                    bounds.topRight = ej.Matrix.transform(matrix, bounds.topRight);
                    bounds.middleLeft = ej.Matrix.transform(matrix, bounds.middleLeft);
                    bounds.middleRight = ej.Matrix.transform(matrix, bounds.middleRight);
                    bounds.bottomLeft = ej.Matrix.transform(matrix, bounds.bottomLeft);
                    bounds.bottomCenter = ej.Matrix.transform(matrix, bounds.bottomCenter);
                    bounds.bottomRight = ej.Matrix.transform(matrix, bounds.bottomRight);
                    var rbounds = ej.datavisualization.Diagram.Geometry.rect([bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft]);
                    bounds.x = bounds.left = rbounds.x;
                    bounds.y = bounds.top = rbounds.y;
                    bounds.right = rbounds.x + rbounds.width;
                    bounds.bottom = rbounds.y + rbounds.height;
                    bounds.center = ej.datavisualization.Diagram.Point(rbounds.x + rbounds.width / 2, rbounds.y + rbounds.height / 2);
                }
                bounds["points"] = [bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft];
                return bounds;
            }
            return rect;
        },
        _swapBounds: function (object, bounds) {
            var object, bounds;
            bounds = bounds;
            if (object.rotateAngle) {
                if (object.rotateAngle < 45) { }
                else if (object.rotateAngle <= 135) {
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, object.rotateAngle, object.offsetX, object.offsetY);
                    var temp;
                    temp = bounds["topCenter"];
                    bounds["topCenter"] = bounds["middleLeft"];
                    bounds["middleLeft"] = bounds["bottomCenter"];
                    bounds["bottomCenter"] = bounds["middleRight"];
                    bounds["middleRight"] = temp;
                    temp = bounds["topLeft"];
                    bounds["topLeft"] = bounds["bottomLeft"];
                    bounds["bottomLeft"] = bounds["bottomRight"];
                    bounds["bottomRight"] = bounds["topRight"];
                    bounds["topRight"] = temp;
                }
                else if (object.rotateAngle <= 225) {
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, object.rotateAngle, object.offsetX, object.offsetY);
                    var temp;
                    temp = bounds["topCenter"];
                    bounds["topCenter"] = bounds["bottomCenter"];
                    bounds["bottomCenter"] = temp;
                    temp = bounds["middleLeft"];
                    bounds["middleLeft"] = bounds["middleRight"];
                    bounds["middleRight"] = temp;
                    temp = bounds["bottomLeft"];
                    bounds["bottomLeft"] = bounds["topLeft"];
                    bounds["topLeft"] = temp;
                    temp = bounds["bottomRight"];
                    bounds["bottomRight"] = bounds["topRight"];
                    bounds["topRight"] = temp;
                }
                else if (object.rotateAngle <= 315) {
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, object.rotateAngle, object.offsetX, object.offsetY);
                    var temp;
                    temp = bounds["topCenter"];
                    bounds["topCenter"] = bounds["middleRight"];
                    bounds["middleRight"] = bounds["bottomCenter"];
                    bounds["bottomCenter"] = bounds["middleLeft"];
                    bounds["middleLeft"] = temp;
                    temp = bounds["topRight"];
                    bounds["topRight"] = bounds["bottomRight"];
                    bounds["bottomRight"] = bounds["bottomLeft"];
                    bounds["bottomLeft"] = bounds["topLeft"];
                    bounds["topLeft"] = temp;
                }
                bounds["points"] = [bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft];
                return bounds;
            }
        },
        canResize: function (node, dir) {
            if (dir) {
                switch (dir) {
                    case "n-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeNorth;
                    case "s-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeSouth;
                    case "e-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeEast;
                    case "w-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeWest;
                    case "se-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast;
                    case "ne-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast;
                    case "sw-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest;
                    case "nw-resize":
                        return node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest;
                }
            }
            else
                return node.constraints & ej.datavisualization.Diagram.NodeConstraints.Resize;
        },
        canConnect: function (node, isPort) {
            var connect = null;
            if (node) {
                if (isPort) {
                    connect = node.constraints & ej.datavisualization.Diagram.PortConstraints.Connect;
                }
                else if (!node.segments)
                    connect = node.constraints & ej.datavisualization.Diagram.NodeConstraints.Connect;
            }
            return connect;
        },
        _initializeSegments: function (connector, defaultType) {
            if (connector.segments && connector.segments.length <= 1) {
                if (!connector.segments.length) {
                    connector.segments.push(ej.datavisualization.Diagram.Segment({ type: defaultType || "straight" }));
                }
                var first = connector.segments[0];
                switch (first.type) {
                    case "straight":
                        if (!first.point) { first._point = connector.targetPoint; }
                        else if (first.point.x != connector.targetPoint.x || first.point.y != connector.targetPoint.y) {
                            //Need to add a method
                            connector.segments.push({ type: first.type || "straight" });
                        }
                        break;
                    case "orthogonal":
                        if (first.length && first.direction) {
                            ej.datavisualization.Diagram.Util._addOrthogonalPoints(first, null, null, connector.sourcePoint, connector.targetPoint);
                            if (first._endPoint.x != connector.targetPoint.x || first._endPoint.y != connector.targetPoint.y) {
                                connector.segments.push({ type: first.type || "straight" });
                            }
                        }
                        else {
                            first._length = first.length || 20;
                            first._direction = first.direction || "auto";
                        }
                        break;
                    case "bezier":
                        if (!first.point) first._point = connector.targetPoint;
                        else if (first.point.x != connector.targetPoint.x || first.point.y != connector.targetPoint.y) {
                            //Need to add a method
                            connector.segments.push({ type: first.type || "straight" });
                        }
                        break;
                }
            }
            var startPoint = connector.sourcePoint;
            var prev = null;
            var next = null;
            var runAngle;
            for (var i = 0; i < connector.segments.length; i++) {
                var segment = connector.segments[i];
                segment._startPoint = startPoint;
                next = connector.segments[i + 1];
                segment = connector.segments[i] = ej.datavisualization.Diagram.Segment(connector.segments[i]);
                if (segment.type == "orthogonal") {
                    segment._direction = segment.direction || "auto";
                    segment._length = segment.length || 20;
                    runAngle = ej.datavisualization.Diagram.Util._addOrthogonalPoints(connector.segments[i], prev, next, connector.sourcePoint, connector.targetPoint, runAngle);
                    startPoint = connector.segments[i]._endPoint;
                    if (!segment.length || !segment.direction) {
                        break;
                    }
                }
                else if (segment.type == "straight") {
                    segment.points.push(startPoint);
                    segment.points.push(connector.segments[i].point || connector.targetPoint);
                    segment._point = segment._endPoint = connector.segments[i].point || connector.targetPoint;
                    runAngle = ej.datavisualization.Diagram.Geometry.findAngle(startPoint, segment._endPoint);
                    startPoint = connector.segments[i]._endPoint;
                    if (!segment.point) {
                        break;
                    }
                }
                else if (segment.type == "bezier") {
                    segment._point = segment._endPoint = connector.segments[i].point || connector.targetPoint;
                    segment.points.push(startPoint);
                    segment.points.push(connector.segments[i].point || connector.targetPoint);
                    runAngle = ej.datavisualization.Diagram.Geometry.findAngle(startPoint, segment._endPoint);
                    ej.datavisualization.Diagram.Util._updateBezierPoints(segment);
                    startPoint = connector.segments[i]._endPoint;
                    if (!segment.point) {
                        break;
                    }
                }
                else {
                    var segment = ej.datavisualization.Diagram.Segment({ type: "orthogonal" });
                    segment._direction = "auto";
                    segment._length = 20;
                    segment._startPoint = startPoint;
                    segment._endPoint = connector.targetPoint;
                    connector.segments.push(segment);
                    ej.datavisualization.Diagram.Util._addOrthogonalPoints(segment, prev, null, connector.sourcePoint, connector.targetPoint, runAngle);
                    break;
                }
                prev = connector.segments[i];
            }
            if (startPoint.x != connector.targetPoint.x || startPoint.y != connector.targetPoint.y) {
                var segment = ej.datavisualization.Diagram.Segment({ type: (prev ? prev.type : defaultType) || "straight", });
                segment._startPoint = startPoint;
                segment._endPoint = connector.targetPoint;
                if (segment.type == "orthogonal") {
                    ej.datavisualization.Diagram.Util._addOrthogonalPoints(segment, prev, null, connector.sourcePoint, connector.targetPoint, runAngle);
                }
                else {
                    segment._point = connector.targetPoint;
                    segment.points.push(startPoint);
                    segment.points.push(connector.targetPoint);
                    if (segment.type == "bezier") { this._updateBezierPoints(segment); }
                }
                connector.segments.push(segment);
            }
        },
        _getDockableBPMNNode: function (node, connector, nameTable, isTarget) {
            var segment = isTarget ? connector.segments[connector.segments.length - 1] : connector.segments[0];
            if (node && node.type == "bpmn")
                if (segment.type == "orthogonal") {
                    return node;
                } else if (node._type == "group")
                    node = (typeof node.children[0] == "object") ? node.children[0] : nameTable[node.children[0]];
            return node;
        },
        dock: function (connector, nameTable, diagram) {
            var targetNode, targetPort = null, sourceNode, sourcePort = null;
            var srcDecoratorSize = connector._srcDecoratorSize, tarDecoratorSize = connector._tarDecoratorSize;
            if (connector.sourcePadding) connector._srcDecoratorSize += connector.sourcePadding;
            if (connector.targetPadding) connector._tarDecoratorSize += connector.targetPadding
            targetNode = nameTable[connector.targetNode];
            if (targetNode)
                targetPort = this.findPortByName(targetNode, connector.targetPort);
            sourceNode = nameTable[connector.sourceNode];
            if (sourceNode)
                sourcePort = this.findPortByName(sourceNode, connector.sourcePort);
            var sourceConnected = this.isSourceConnected(connector);
            var targetConnected = this.isTargetConnected(connector);
            if (!sourcePort) {
                sourceNode = this._getDockableBPMNNode(sourceNode, connector, nameTable, false);
                if (sourceNode && sourceNode.connectorPadding) connector._srcDecoratorSize += sourceNode.connectorPadding;
            } else if (sourcePort.connectorPadding) connector._srcDecoratorSize += sourcePort.connectorPadding;
            if (!targetPort) {
                targetNode = this._getDockableBPMNNode(targetNode, connector, nameTable, true);
                if (targetNode && targetNode.connectorPadding) connector._tarDecoratorSize += targetNode.connectorPadding;
            } else if (targetPort.connectorPadding) connector._tarDecoratorSize += targetPort.connectorPadding;
            if (targetConnected && sourceConnected && targetPort && sourcePort) {
                this._dockPortToPort(connector, targetNode, targetPort, sourceNode, sourcePort);
            }
            else if (targetConnected && targetPort) {
                if (sourceConnected) {
                    if (connector.segments.length == 1) {
                        this._dockNode(connector, sourceNode, null, targetConnected, sourceConnected);
                        this._dockPortToNode(connector, targetNode, targetPort, sourceNode, sourcePort, true);
                    }
                    else {
                        this._dockNode(connector, sourceNode, null, targetConnected, sourceConnected);
                        this._updateIntermediateSegments(connector);
                        this._dockPortToPoint(connector, targetNode, targetPort, true);
                        this._updatePreviousSegment(connector);
                    }
                }
                else {
                    this._dockPortToPoint(connector, targetNode, targetPort, true);
                    this._updatePreviousSegment(connector);
                }
            }
            else if (sourceConnected && sourcePort) {
                if (targetConnected) {
                    if (connector.segments.length == 1) {
                        this._dockNode(connector, targetNode, null, targetConnected, sourceConnected);
                        this._dockPortToNode(connector, sourceNode, sourcePort, targetNode, targetPort, false);
                    }
                    else {
                        this._dockPortToPoint(connector, sourceNode, sourcePort, false);
                        this._updateIntermediateSegments(connector);
                        this._dockNode(connector, targetNode, null, targetConnected, sourceConnected);
                        this._updatePreviousSegment(connector);
                    }
                }
                else {
                    this._dockPortToPoint(connector, sourceNode, sourcePort, false);
                    this._updateIntermediateSegments(connector);
                }
            }
            else if (targetConnected && sourceConnected) {
                if (targetNode && sourceNode)
                    this._dockNode(connector, targetNode, sourceNode, targetConnected, sourceConnected, diagram);
            }
            else if (targetConnected) {
                this._dockNode(connector, targetNode, null, targetConnected, sourceConnected);

            }
            else if (sourceConnected) {
                this._dockNode(connector, sourceNode, null, targetConnected, sourceConnected);
            }
            this._adjustEndPoint(connector, sourceNode, sourcePort, targetNode, targetPort);
            connector._srcDecoratorSize = srcDecoratorSize;
            connector._tarDecoratorSize = tarDecoratorSize;
        },
        _dockPortToPort: function (connector, targetNode, targetPort, sourceNode, sourcePort) {
            if (connector.segments.length == 1) {
                var portLocation;
                if (targetNode)
                    var targetBounds = this.bounds(targetNode, true);
                if (sourceNode)
                    var sourceBounds = this.bounds(sourceNode, true);
                var matrix;
                var first = connector.segments[0];
                var last = connector.segments[connector.segments.length - 1];
                var segment = connector.segments[0];
                if (segment.type !== "orthogonal") {
                    if (targetPort) {
                        portLocation = this._getPortPosition(targetPort, targetBounds);
                        if (targetNode.rotateAngle) {
                            matrix = ej.Matrix.identity();
                            ej.Matrix.rotate(matrix, targetNode.rotateAngle, targetNode.offsetX, targetNode.offsetY);
                            portLocation = ej.Matrix.transform(matrix, portLocation);
                        }
                        this._setLineEndPoint(connector, portLocation, true);
                    }
                    if (sourcePort) {
                        portLocation = this._getPortPosition(sourcePort, sourceBounds);
                        if (sourceNode.rotateAngle) {
                            matrix = ej.Matrix.identity();
                            ej.Matrix.rotate(matrix, sourceNode.rotateAngle, sourceNode.offsetX, sourceNode.offsetY);
                            portLocation = ej.Matrix.transform(matrix, portLocation);
                        }
                        this._setLineEndPoint(connector, portLocation, false);
                    }
                    if (segment.type === "bezier")
                        this._updateBezierPoints(segment, targetNode, targetPort, targetBounds, sourceNode, sourcePort, sourceBounds);
                } else {
                    var targetPortLocation = this._getPortPosition(targetPort, targetBounds);
                    var sourcePortLocation = this._getPortPosition(sourcePort, sourceBounds);
                    var targetDirection = this._swapDirection(targetNode.rotateAngle, this._getDirection(targetBounds, targetPortLocation));
                    var sourceDirection = this._swapDirection(sourceNode.rotateAngle, this._getDirection(sourceBounds, sourcePortLocation));
                    if (sourceNode.rotateAngle) {
                        matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, sourceNode.rotateAngle, sourceNode.offsetX, sourceNode.offsetY);
                        sourcePortLocation = ej.Matrix.transform(matrix, sourcePortLocation);
                    }
                    if (targetNode.rotateAngle) {
                        matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, targetNode.rotateAngle, targetNode.offsetX, targetNode.offsetY);
                        targetPortLocation = ej.Matrix.transform(matrix, targetPortLocation);
                    }
                    this._constructSegements(connector, first, targetBounds, targetPortLocation, targetDirection, sourceBounds, sourcePortLocation, sourceDirection);
                    this._setLineEndPoint(connector, first.points[0], false);
                    this._setLineEndPoint(connector, first.points[first.points.length - 1], true);
                }
            }
            else {
                this._dockPortToPoint(connector, sourceNode, sourcePort, false);
                this._updateIntermediateSegments(connector);
                this._dockPortToPoint(connector, targetNode, targetPort, true);
                this._updatePreviousSegment(connector);
            }
        },
        _dockPortToNode: function (connector, targetNode, targetPort, sourceNode, sourcePort, isTarget) {
            var first = connector.segments[0];
            var last = connector.segments[connector.segments.length - 1];
            if (targetNode)
                var targetBounds = this.bounds(targetNode, true);
            if (sourceNode)
                var sourceBounds = this.bounds(sourceNode, true);
            var matrix;
            var segment = isTarget ? last : first;
            if (segment.type !== "orthogonal") {
                var portLocation = this._getPortPosition(targetPort, targetBounds);
                matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, targetNode.rotateAngle, targetNode.offsetX, targetNode.offsetY);
                portLocation = ej.Matrix.transform(matrix, portLocation);
                //segment._endPoint = portLocation;
                this._setLineEndPoint(connector, portLocation, isTarget);
            }
            else {
                var targetPortLocation = this._getPortPosition(targetPort, targetBounds);
                var targetDirection = this._swapDirection(targetNode.rotateAngle, this._getDirection(targetBounds, targetPortLocation));
                matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, targetNode.rotateAngle, targetNode.offsetX, targetNode.offsetY);
                targetPortLocation = ej.Matrix.transform(matrix, targetPortLocation);
                var sourcePortLocation;
                if (!isTarget) {
                    sourcePortLocation = connector.targetPoint;
                }
                else {
                    sourcePortLocation = connector.sourcePoint;
                }
                var sourceDirection;
                if (sourceNode) {
                    sourceDirection = this._getDirection(sourceBounds, sourcePortLocation);
                }
                else sourceDirection = "top";
                if (sourceDirection) {
                    targetBounds = this.bounds(targetNode);
                    if (sourceNode)
                        sourceBounds = this.bounds(sourceNode);
                    else sourceBounds = { left: sourcePortLocation.x, right: sourcePortLocation.x, top: sourcePortLocation.y, bottom: sourcePortLocation.y };
                    if (isTarget) {
                        this._setLineEndPoint(connector, targetPortLocation, true);
                        this._constructSegements(connector, last, targetBounds, targetPortLocation, targetDirection, sourceBounds, sourcePortLocation, sourceDirection);
                    }
                    else {
                        this._setLineEndPoint(connector, targetPortLocation, false);
                        this._constructSegements(connector, first, sourceBounds, sourcePortLocation, sourceDirection, targetBounds, targetPortLocation, targetDirection);
                    }
                }
            }
        },
        _dockPortToPoint: function (connector, targetNode, targetPort, isTarget) {
            var first = connector.segments[0];
            var last = connector.segments[connector.segments.length - 1];
            var segment = isTarget ? last : first;
            if (segment.type !== "orthogonal") {
                this._dockPortToNode(connector, targetNode, targetPort, null, null, isTarget);
            }
            else {
                var targetBounds = this.bounds(targetNode, true);
                var targetPortLocation = this._getPortPosition(targetPort, targetBounds);
                var targetDirection = this._swapDirection(targetNode.rotateAngle, this._getDirection(targetBounds, targetPortLocation));
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, targetNode.rotateAngle, targetNode.offsetX, targetNode.offsetY);
                targetPortLocation = ej.Matrix.transform(matrix, targetPortLocation);
                var sourcePortLocation;
                var sourcePortLocation;
                if (!isTarget) {
                    sourcePortLocation = first._endPoint;
                }
                else {
                    sourcePortLocation = last._startPoint;
                }
                var sourceBounds = this.bounds(ej.datavisualization.Diagram.Rectangle(sourcePortLocation.x, sourcePortLocation.y, 0, 0));
                targetBounds = this.bounds(targetNode);
                var sourceDirection = "top";
                if (isTarget) {
                    this._setLineEndPoint(connector, targetPortLocation, true);
                    this._pointsFromNodeToPoint(connector, last, targetDirection, targetBounds, targetNode.rotateAngle, targetPortLocation, sourcePortLocation, true); //{(connector, last, targetBounds, targetPortLocation, targetDirection, sourceBounds, sourcePortLocation, sourceDirection);
                }
                else {
                    this._setLineEndPoint(connector, targetPortLocation, false);
                    this._pointsFromNodeToPoint(connector, first, targetDirection, targetBounds, targetNode.rotateAngle, targetPortLocation, sourcePortLocation, false);
                }
            }
        },
        _containsminSpaceBetweenNode: function (diagram, sourceNode, targetNode) {
            var state = false;
            if (diagram && diagram.minSpaceBetweenNode && sourceNode && targetNode) {
                if (diagram.minSpaceBetweenNode && diagram.minSpaceBetweenNode.length > 0) {
                    for (var i in diagram.minSpaceBetweenNode) {
                        if (diagram.minSpaceBetweenNode[i] === sourceNode.name)
                            return true;
                        if (diagram.minSpaceBetweenNode[i] === targetNode.name)
                            return true;
                    }
                }
            }
            return state;
        },
        _dockNode: function (connector, targetNode, sourceNode, targetConnected, sourceConnected, diagram) {
            var startsegment, endsegment;
            var minSpace = connector._srcDecoratorSize + connector._tarDecoratorSize;
            minSpace = this._containsminSpaceBetweenNode(diagram, sourceNode, targetNode) ? 0 : minSpace;
            if (connector.segments.length == 1) {
                startsegment = endsegment = connector.segments[0];
            }
            else {
                startsegment = connector.segments[0];
                endsegment = connector.segments[connector.segments.length - 1];
            }
            if (targetConnected && sourceConnected && !connector.targetPort && !connector.sourcePort) {
                if (connector.segments.length == 1) {
                    if (connector.segments[0].type == "orthogonal") {
                        var sourceBounds = this.bounds(sourceNode);
                        var targetBounds = this.bounds(targetNode);
                        this._swapBounds(sourceNode, sourceBounds);
                        this._swapBounds(targetNode, targetBounds);
                        var srcPoint, tarPoint, srcDirection, tarDirection;
                        ////Test top side.
                        if (sourceBounds.y - minSpace >= targetBounds.bottom) {
                            srcPoint = sourceBounds.topCenter;
                            srcDirection = "top";
                            tarPoint = targetBounds.bottomCenter;
                            tarDirection = "bottom";
                        }
                            ////Test bottom side.
                        else if (sourceBounds.bottom + minSpace <= targetBounds.y) {
                            tarPoint = targetBounds.topCenter;
                            tarDirection = "top";
                            srcPoint = sourceBounds.bottomCenter;
                            srcDirection = "bottom";
                        }
                        if ((sourceBounds.bottom + minSpace > targetBounds.y) && (sourceBounds.y < targetBounds.bottom + minSpace)) {
                            if (sourceBounds.right + minSpace < targetBounds.x || (targetBounds.right >= sourceBounds.x - minSpace && sourceBounds.x > targetBounds.x)) {
                                ////rightleft
                                srcPoint = sourceBounds.middleRight;
                                srcDirection = "right";
                                tarPoint = targetBounds.middleLeft;
                                tarDirection = "left";
                            }
                            else {
                                if (targetBounds.right + minSpace < sourceBounds.x || (sourceBounds.right >= targetBounds.x - minSpace && sourceBounds.x < targetBounds.x)) {
                                    srcPoint = sourceBounds.middleLeft;
                                    srcDirection = "left";
                                    tarPoint = targetBounds.middleRight;
                                    tarDirection = "right";
                                }
                                else if (sourceBounds.x <= targetBounds.x) {
                                    srcPoint = sourceBounds.middleLeft;
                                    srcDirection = "left";
                                    tarPoint = targetBounds.middleLeft;
                                    tarDirection = "left";
                                    ////left left
                                }
                                else if (sourceBounds.x <= targetBounds.right) {
                                    ////right right
                                    srcPoint = sourceBounds.middleRight;
                                    srcDirection = "right";
                                    tarPoint = targetBounds.middleRight;
                                    tarDirection = "right";
                                }
                                else {
                                    ////left right
                                    srcPoint = sourceBounds.middleLeft;
                                    srcDirection = "left";
                                    tarPoint = targetBounds.middleRight;
                                    tarDirection = "right";
                                }
                            }
                        }
                        var targetPoint;
                        targetPoint = this._findEndPoint(srcDirection, srcPoint, sourceNode) || sourceBounds.center;
                        srcPoint = this._findIntersection(sourceNode, sourceBounds, connector, srcPoint, targetPoint, false) || srcPoint;
                        targetPoint = this._findEndPoint(tarDirection, tarPoint, targetNode) || targetBounds.center;
                        tarPoint = this._findIntersection(targetNode, targetBounds, connector, tarPoint, targetPoint, true) || tarPoint;
                        this._setLineEndPoint(connector, srcPoint, false);
                        this._setLineEndPoint(connector, tarPoint, true);
                        if (connector.segments[0].type == "orthogonal") {
                            this._constructSegements(connector, connector.segments[0], targetBounds, connector.targetPoint, tarDirection, sourceBounds, connector.sourcePoint, srcDirection);
                            connector.segments[0]._direction = srcDirection;
                        }
                    }
                    else {
                        if (targetNode) {
                            targetBounds = this.bounds(targetNode);
                            this._swapBounds(targetNode, targetBounds);
                            if (sourceNode) {
                                sourceBounds = this.bounds(sourceNode);
                                this._swapBounds(sourceNode, sourceBounds);
                                this._setLineEndPoint(connector, sourceBounds.center, false);
                                this._setLineEndPoint(connector, targetBounds.center, true);
                                this._dockBounds(connector, sourceNode, sourceBounds, false);
                            }
                            this._setLineEndPoint(connector, targetBounds.center, true);
                            this._dockBounds(connector, targetNode, targetBounds, true);
                        }
                        if (connector.segments[0].type == "bezier") {
                            this._updateBezierPoints(connector.segments[0]);
                        }
                    }
                }
                else {
                    this._dock(connector, startsegment, sourceNode, null, false);
                    this._updateIntermediateSegments(connector);
                    if (connector.segments.length == 1) {
                        this._dock(connector, startsegment, sourceNode, targetNode, false);
                        this._dock(connector, endsegment, targetNode, sourceNode, true);
                    }
                    else {
                        this._dock(connector, endsegment, targetNode, null, true);
                        this._updatePreviousSegment(connector);
                    }
                }
            }
            else if (targetConnected && !connector.targetPort) {
                this._dock(connector, endsegment, targetNode, sourceNode, true);
                this._updatePreviousSegment(connector);
            }
            else if (sourceConnected && !connector.sourcePort) {
                this._dock(connector, startsegment, targetNode, sourceNode, false);
                this._updateIntermediateSegments(connector);
            }
        },
        _adjustEndPoint: function (connector, sourceNode, sourcePort, targetNode, targetPort) {
            if (connector.sourcePadding || connector.targetPadding || sourcePort && sourcePort.connectorPadding || targetPort && targetPort.connectorPadding) {
                var length = 0;
                var targetBounds = targetNode ? this.bounds(targetNode) : null;
                var sourceBounds = sourceNode ? this.bounds(sourceNode) : null;
                if (sourceNode) {
                    var endPoint;
                    var segment = connector.segments[0];
                    if (segment.type !== "orthogonal") endPoint = segment.type !== "bezier" ? segment._endPoint : segment._point1;
                    else endPoint = segment.points[1];
                    if (sourcePort) length = connector.sourcePadding + sourcePort.connectorPadding;
                    var sourcePortLocation = this._adjustPoint(segment._startPoint, endPoint, true, length);
                    this._setLineEndPoint(connector, sourcePortLocation, false);
                    if (segment.type == "bezier") this._updateBezierPoints(segment, targetNode, targetPort, targetBounds, sourceNode, sourcePort, sourceBounds);
                }
                if (targetNode) {
                    var startPoint;
                    var segment = connector.segments[connector.segments.length - 1];
                    if (segment.type !== "orthogonal") startPoint = segment.type !== "bezier" ? segment._startPoint : segment._point2;
                    else startPoint = segment.points[segment.points.length - 2];
                    if (targetPort) length = connector.targetPadding + targetPort.connectorPadding;
                    var targetPortLocation = this._adjustPoint(startPoint, segment._endPoint, false, length);
                    this._setLineEndPoint(connector, targetPortLocation, true);
                    if (segment.type == "bezier") this._updateBezierPoints(segment, targetNode, targetPort, targetBounds, sourceNode, sourcePort, sourceBounds);
                }
            }
        },
        _findEndPoint: function (direction, point, node) {
            var targetPoint;
            switch (direction) {
                case "top":
                    targetPoint = { x: point.x, y: point.y + Math.max(node.width, node.height) };
                    break;
                case "bottom":
                    targetPoint = { x: point.x, y: point.y - Math.max(node.width, node.height) };
                    break;
                case "left":
                    targetPoint = { y: point.y, x: point.x + Math.max(node.width, node.height) };
                    break;
                case "right":
                    targetPoint = { y: point.y, x: point.x - Math.max(node.width, node.height) };
                    break;
            }
            return targetPoint;
        },
        _dock: function (connector, line, targetNode, sourceNode, isTarget) {
            var sourceBounds;
            if (targetNode) {
                var node = targetNode;
                var point = isTarget ? line._startPoint : line._endPoint;
                sourceBounds = this.bounds(targetNode);
                this._swapBounds(targetNode, sourceBounds);
                if (!isTarget) {
                    if (line.type == "orthogonal" && connector.segments[1] && connector.segments[1].type == "orthogonal") {
                        if (connector.segments[0]._isInternal && ej.datavisualization.Diagram.Geometry.containsPoint(sourceBounds, line._endPoint)) {
                            this._insertSegmentAtSourceEnd(connector, line, sourceBounds, targetNode, isTarget);
                        }
                        else if (ej.datavisualization.Diagram.Geometry.containsPoint(sourceBounds, line._endPoint)) {
                            this._removeFirstSegment(connector, line, sourceBounds, targetNode, isTarget);
                        }
                        else {
                            var dockPoint, dockDirection;;
                            switch (line.direction) {
                                case "left":
                                    dockDirection = "left";
                                    dockPoint = sourceBounds.middleLeft;
                                    break;
                                case "right": dockDirection = "right";
                                    dockPoint = sourceBounds.middleRight;
                                    break;
                                case "top": dockDirection = "top";
                                    dockPoint = sourceBounds.topCenter;
                                    break;
                                case "bottom": dockDirection = "bottom";
                                    dockPoint = sourceBounds.bottomCenter;
                                    break;
                            }
                            line.points = [];
                            var targetPoint = this._findEndPoint(dockDirection, dockPoint, targetNode) || sourceBounds.center;
                            dockPoint = this._findIntersection(targetNode, sourceBounds, connector, dockPoint, targetPoint, isTarget) || dockPoint;
                            line.points.push(dockPoint);
                            line.points.push(line._endPoint);
                            this._setLineEndPoint(connector, dockPoint, isTarget);
                        }
                    }
                    else {
                        this._dockNodeToPoint(connector, line._endPoint, targetNode, isTarget);
                    }
                }
                else {
                    if (line.type == "orthogonal") {
                        var second = connector.segments[connector.segments.length - 2];
                        if (second && second.type == "orthogonal") {
                            if (line.points.length > 2 &&
                                ej.datavisualization.Diagram.Geometry.containsPoint(sourceBounds, line.points[line.points.length - 2])) {
                                var removePreSegment = false;
                                if (second.direction == "top" || second.direction == "bottom") {
                                    if (second._endPoint.x >= sourceBounds.left && second._endPoint.x <= sourceBounds.right) {
                                        this._removeLastSegment(connector, line, second, targetNode, sourceNode, isTarget); return;
                                    }
                                    else {
                                        second._length = second.length = Math.abs(second._startPoint.y - sourceBounds.middleLeft.y);;
                                        if (second.length == 0) {
                                            removePreSegment = true;
                                        }
                                        else {
                                            if (second.length < 0) {
                                                second._length = second.length *= -1;
                                                second._direction = second.direction = (second.direction == "top") ? "bottom" : "top";
                                            }
                                            connector.targetPoint = second._endPoint.x > sourceBounds.right ? sourceBounds.middleRight : sourceBounds.middleLeft;
                                        }
                                    }
                                }
                                else {
                                    if (second._endPoint.y >= sourceBounds.top && second._endPoint.y <= sourceBounds.bottom) {
                                        this._removeLastSegment(connector, line, second, targetNode, sourceNode, isTarget); return;
                                    }
                                    else {
                                        second._length = second.length = Math.abs(second._startPoint.x - sourceBounds.topCenter.x);;
                                        if (second.length == 0) removePreSegment = true;
                                        else {
                                            if (second.length < 0) {
                                                second._length = second.length *= -1;
                                                second._direction = second.direction = (second.direction == "left") ? "right" : "left";
                                            }
                                            connector.targetPoint = second._endPoint.y > sourceBounds.bottom ? sourceBounds.bottomCenter : sourceBounds.topCenter;
                                        }
                                    }
                                }
                                if (removePreSegment) {
                                    connector.segments.splice(connector.segments.length - 2, 1);
                                    this._dock(connector, line, targetNode, sourceNode, isTarget);
                                    return;
                                }
                                connector.targetPoint = this._findIntersection(targetNode, sourceBounds, connector, connector.targetPoint, sourceBounds.center, isTarget) || connector.targetPoint;
                                this._updateConnectorSegments(connector, connector.sourcePort, connector.targetPort);
                                line._direction = this._getOrthoDirection(line._startPoint, line._endPoint, second);
                                this._setLineEndPoint(connector, connector.targetPoint, isTarget);
                            }
                            else if (ej.datavisualization.Diagram.Geometry.containsPoint(sourceBounds, line._startPoint)) {
                                var diflength = second.direction == "left" || second.direction == "right" ? node.width / 2 : node.height / 2;
                                second._length = second.length -= diflength + 30;
                                if (second.length == 0) {
                                    connector.segments.splice(connector.segments.length - 2, 1);
                                    this._dock(connector, line, targetNode, sourceNode, isTarget);
                                    return;
                                }
                                if (second.direction == "left" || second.direction == "right")
                                    connector.targetPoint = second.direction == "right" ? sourceBounds.middleLeft : sourceBounds.middleRight;
                                else
                                    connector.targetPoint = second.direction == "bottom" ? sourceBounds.topCenter : sourceBounds.bottomCenter;
                                connector.targetPoint = this._findIntersection(targetNode, sourceBounds, connector, connector.targetPoint, sourceBounds.center, isTarget) || connector.targetPoint;
                                this._updateConnectorSegments(connector, connector.sourcePort, connector.targetPort);
                                line._direction = this._getOrthoDirection(line._startPoint, line._endPoint, second);
                                this._setLineEndPoint(connector, connector.targetPoint, isTarget);
                            }
                            else {
                                this._dockNodeToPoint(connector, point, targetNode, isTarget);
                            }
                        } else {
                            this._dockNodeToPoint(connector, point, targetNode, isTarget);
                        }
                    }
                    else { this._dockNodeToPoint(connector, point, targetNode, isTarget); }
                }
            }
        },
        _removeLastSegment: function (connector, line, second, targetNode, sourceNode, isTarget) {
            connector.segments.splice(connector.segments.length - 1, 1);
            second.length = second._length = null;
            second.direction = null;
            second._direction = line._direction;
            this._dock(connector, second, targetNode, sourceNode, isTarget);
        },
        _insertSegmentAtSourceEnd: function (connector, line, sourceBounds, sourceNode, isTarget) {
            var second = connector.segments[1];
            var third = connector.segments[2];
            if (connector.segments[0].direction == "left" || connector.segments[0].direction == "right") {
                var orientation = "horizontal";
                connector.sourcePoint = second.direction == "top" ? sourceBounds.topCenter : sourceBounds.bottomCenter;
                if (second && (second.length || second.length === 0))
                    second._length = second.length = Math.max(Math.abs(connector.sourcePoint.y - second._endPoint.y), 25);
                if (third && (third.length || third.length === 0)) {
                    third.length = third._length = Math.abs(sourceBounds.topCenter.x - third._endPoint.x);
                }
            }
            else {
                var orientation = "vertical";
                connector.sourcePoint = second.direction == "left" ? sourceBounds.middleLeft : sourceBounds.middleRight;
                if (second && (second.length || second.length === 0))
                    second._length = second.length = Math.max(Math.abs(connector.sourcePoint.x - second._endPoint.x), 25);
                if (third && (third.length || third.length === 0)) {
                    third.length = third._length = Math.abs(sourceBounds.middleRight.y - third._endPoint.y);
                }
            }
            //Updating adjacent segments
            if (connector.segments[3] && (connector.segments[3].length || connector.segments[3].length == 0)) {
                var value = second.direction == "bottom" || second.direction == "right" ? second.length : -second.length;
                connector.segments[3].length = connector.segments[3]._length = orientation == "vertical" ?
                    Math.abs(connector.sourcePoint.x + value - connector.segments[3]._endPoint.x) :
                    Math.abs(connector.sourcePoint.y + value - connector.segments[3]._endPoint.y);
                if (connector.segments[3].length < 0) {
                    var value = second.direction == "bottom" || second.direction == "right" ? second.length : -second.length;
                    connector.segments[3].length = connector.segments[3]._length = orientation == "vertical" ?
                        Math.abs(connector.sourcePoint.x + value - connector.segments[3]._endPoint.x) :
                    Math.abs(connector.sourcePoint.y + value - connector.segments[3]._endPoint.y);
                }
            }
            connector.segments.splice(0, 1);
            connector.sourcePoint = this._findIntersection(sourceNode, sourceBounds, connector, connector.sourcePoint, sourceBounds.center, isTarget) || connector.sourcePoint;
            this._updateConnectorSegments(connector, connector.sourcePort, connector.targetPort);
            this._setLineEndPoint(connector, connector.sourcePoint, isTarget);
        },
        _removeFirstSegment: function (connector, line, sourceBounds, sourceNode, isTarget) {
            var newLength, firstSegLength;
            var direction = connector.segments[1].direction || this._getBezierDirection(connector.segments[1].points[0], connector.segments[1].points[1]);
            if (direction == "left" || direction == "right") {
                var length = line._endPoint.y - sourceBounds.middleRight.y;
                connector.segments[0].direction = connector.segments[0]._direction = length >= 0 ? "bottom" : "top";
                connector.segments[0].length = connector.segments[0]._length = Math.abs(length);
                var actualdist = direction == "right" ? connector.segments[1]._endPoint.x - sourceBounds.right :
                    sourceBounds.left - connector.segments[1]._endPoint.x;
                connector.sourcePoint = direction == "left" ? sourceBounds.middleLeft : sourceBounds.middleRight;
                newLength = Math.abs(connector.sourcePoint.x - connector.segments[0]._startPoint.x);
                firstSegLength = Math.abs(connector.sourcePoint.y - connector.segments[0]._endPoint.y);
            }
            else {
                if (connector.segments[0].length || connector.segments[0].length == 0) {
                    var length = line._endPoint.x - sourceBounds.bottomCenter.x;
                    connector.segments[0].direction = connector.segments[0]._direction = length >= 0 ? "right" : "left";
                    connector.segments[0].length = connector.segments[0]._length = Math.abs(length);
                }
                var actualdist = direction == "bottom" ? connector.segments[1]._endPoint.y - sourceBounds.bottom :
                    sourceBounds.top - connector.segments[1]._endPoint.y;
                connector.sourcePoint = direction == "top" ? sourceBounds.topCenter : sourceBounds.bottomCenter;
                newLength = Math.abs(connector.sourcePoint.y - connector.segments[0]._startPoint.y);
                firstSegLength = Math.abs(connector.sourcePoint.x - connector.segments[0]._endPoint.x);
            }
            if (connector.segments[1] && (connector.segments[1].length || connector.segments[1].length === 0)) {
                connector.segments[1]._length = connector.segments[1].length = actualdist - 25;
                if (connector.segments[1]._length < 0) {
                    connector.segments.splice(0, 2);
                    if (connector.segments[0].length || connector.segments[0].length === 0)
                        connector.segments[0].length = connector.segments[0]._length = newLength;
                    var newSegment = ej.datavisualization.Diagram.Segment({ type: "orthogonal", length: firstSegLength, direction: direction });
                }
            }
            if (!newSegment) {
                newSegment = ej.datavisualization.Diagram.Segment({ type: "orthogonal", length: 25, direction: direction });
            }
            var segments = [newSegment];
            newSegment._isInternal = true;
            connector.segments = segments.concat(connector.segments);
            connector.sourcePoint = this._findIntersection(sourceNode, sourceBounds, connector, connector.sourcePoint, sourceBounds.center, isTarget) || connector.sourcePoint;
            this._updateConnectorSegments(connector, connector.sourcePort, connector.targetPort);
            this._setLineEndPoint(connector, connector.sourcePoint, isTarget);
        },
        _dockNodeToPoint: function (connector, fixedPoint, node, isTarget) {
            var line, sourceBounds, segment;
            line = isTarget ? connector.segments[connector.segments.length - 1] : connector.segments[0];
            if (line.type != "orthogonal") {
                sourceBounds = this.bounds(node);
                this._swapBounds(node, sourceBounds);
                this._setLineEndPoint(connector, sourceBounds.center, isTarget);
                this._dockBounds(connector, node, sourceBounds, isTarget);
            }
            else {
                sourceBounds = this.bounds(node);
                this._swapBounds(node, sourceBounds);
                var dockPoint, dockDirection, targetDirection;
                var point = fixedPoint;
                if (connector.segments.length > 1) {
                    var prev = connector.segments[connector.segments.length - 2];
                    var left = Math.abs(point.x - sourceBounds.left);
                    var right = Math.abs(point.x - sourceBounds.right);
                    var top = Math.abs(point.y - sourceBounds.top);
                    var bottom = Math.abs(point.y - sourceBounds.bottom);
                    if (prev && isTarget) {
                        var horizontal = prev.direction == "left" || prev.direction == "right";
                        var vertical = prev.direction == "top" || prev.direction == "bottom";
                    }
                    line = !isTarget ? connector.segments[0] : connector.segments[connector.segments.length - 1];
                    if ((line.points.length == 2 || !prev) && line.type == "orthogonal") {
                        horizontal = vertical = false;
                    }
                    var targetPoint;
                    if (sourceBounds.bottom < point.y && !horizontal) {
                        dockDirection = "bottom";
                        targetDirection = "top";
                        dockPoint = sourceBounds.bottomCenter;
                    }
                    else if (sourceBounds.y > point.y && !horizontal) {
                        dockDirection = "top";
                        targetDirection = "bottom";
                        dockPoint = sourceBounds.topCenter;
                    }
                    else if (sourceBounds.right < point.x && !vertical) {
                        dockDirection = "right";
                        targetDirection = "left";
                        dockPoint = sourceBounds.middleRight;
                    }
                    else if (sourceBounds.x > point.x && !vertical) {
                        dockDirection = "left";
                        targetDirection = "right";
                        dockPoint = sourceBounds.middleLeft;
                    }
                    else {
                        var min = left;
                        dockPoint = sourceBounds.middleLeft;
                        dockDirection = "left";
                        targetDirection = "right";
                        if (min >= right && right != 0) {
                            dockPoint = sourceBounds.middleRight;
                            dockDirection = "right";
                            targetDirection = "left";
                            min = right;
                        }
                        if (min > top && top != 0) {
                            dockPoint = sourceBounds.topCenter;
                            dockDirection = "top";
                            targetDirection = "bottom";
                            min = top;
                        }
                        if (min > bottom && bottom != 0) {
                            dockPoint = sourceBounds.bottomCenter;
                            dockDirection = "bottom";
                            targetDirection = "top";
                            min = bottom;
                        }
                    }
                }
                else {
                    dockPoint = sourceBounds.center;
                    dockDirection = this._getBezierDirection(fixedPoint, dockPoint);
                    switch (dockDirection) {
                        case "left":
                            targetDirection = "right";
                            break;
                        case "right":
                            targetDirection = "left";
                            break;
                        case "top":
                            targetDirection = "bottom";
                            break;
                        case "bottom":
                            targetDirection = "top";
                            break;
                    }
                }
                if (dockPoint) {
                    if (isTarget || connector.segments.length == 1) {
                        segment = connector.segments[connector.segments.length - 1];
                        if (segment.type == "orthogonal") {
                            segment._direction = isTarget ? dockDirection : targetDirection;
                        }
                    }
                    else { segment = connector.segments[0]; }
                    targetPoint = this._findEndPoint(dockDirection, dockPoint, node) || sourceBounds.center;
                    dockPoint = this._findIntersection(node, sourceBounds, connector, dockPoint, targetPoint, isTarget) || dockPoint;
                    isTarget ? connector.targetPoint = dockPoint : connector.sourcePoint = dockPoint;
                    if (connector.segments.length != 1)
                        this._addOrthogonalPoints(segment, !isTarget ? null : connector.segments[connector.segments.length - 2], !isTarget ? connector.segments[1] : null, connector.sourcePoint, connector.targetPoint);
                    this._setLineEndPoint(connector, dockPoint, isTarget);
                }
            }
        },
        _getDockSegment: function (connector, line, rotateAngle, bounds, isTarget, direction) {
            var segment; var segments = this._getEdges(rotateAngle, bounds);
            {
                var direction = "", segment, intersecSeg;
                //var line = connector.line;
                var length = ej.datavisualization.Diagram.Geometry.distance(line._startPoint, line._endPoint);
                if (isTarget)
                    intersecSeg = ej.datavisualization.Diagram.LineSegment(line.points[line.points.length - 2], line.points[line.points.length - 1]);
                else {
                    if (length > 5) {
                        intersecSeg = ej.datavisualization.Diagram.LineSegment(line._startPoint, line._endPoint);
                    }
                    else {
                        intersecSeg = ej.datavisualization.Diagram.LineSegment(line._startPoint, connector.segments[1] ? connector.segments[1]._endPoint : connector.targetPoint);
                    }
                }
                if (ej.datavisualization.Diagram.Geometry.intersectSegment(intersecSeg, segments.left)) {
                    segment = segments.left;
                    direction = "left";
                }
                else if (ej.datavisualization.Diagram.Geometry.intersectSegment(intersecSeg, segments.top)) {
                    segment = segments.top;
                    direction = "top";
                }
                else if (ej.datavisualization.Diagram.Geometry.intersectSegment(intersecSeg, segments.right)) {
                    segment = segments.right;
                    direction = "right";
                }
                else if (ej.datavisualization.Diagram.Geometry.intersectSegment(intersecSeg, segments.bottom)) {
                    segment = segments.bottom;
                    direction = "bottom";
                }
            }
            direction = this._swapDirection(rotateAngle, direction);
            if (segment) {
                return { "dockPoint": ej.datavisualization.Diagram.Geometry.midPoint(segment), "direction": direction };
            }
            return null;
        },
        _dockBounds: function (connector, node, bounds, isTarget) {
            var line;
            line = isTarget ? connector.segments[connector.segments.length - 1] : connector.segments[0];
            var strPt = line._startPoint;
            var endPt = line._endPoint || line.point;
            if (line.type == "bezier" && (line.point1 || line.point2)) {
                if (isTarget) strPt = line._point2;
                else endPt = line._point1;
            }
            var intersection = this._findIntersection(node, bounds, connector, strPt, endPt, isTarget);
            if (intersection) {
                this._setLineEndPoint(connector, intersection, isTarget);
                if (line.type === "bezier") {
                    this._updateBezierPoints(line);
                }
            }
        },
        _findIntersection: function (node, bounds, connector, strPt, endPt, isTarget) {
            var segmentPoints, length;
            var line = isTarget ? connector.segments[connector.segments.length - 1] : connector.segments[0];
            var pad = node.connectorPadding;
            pad += isTarget ? connector.targetPadding : connector.sourcePadding;
            if (line.type == "orthogonal") {
                strPt = { x: strPt.x, y: strPt.y };
                if (strPt.x == endPt.x) if (strPt.y < endPt.y) strPt.y -= pad + 5; else strPt.y += pad + 5;
                if (strPt.y == endPt.y) if (strPt.x < endPt.x) strPt.x -= pad + 5; else strPt.x += pad + 5;
            }
            var angle;
            var point = isTarget || line.type == "orthogonal" ? strPt : endPt;
            if (line.type != "orthogonal") {
                if (isTarget) {
                    angle = ej.datavisualization.Diagram.Geometry.findAngle(strPt, endPt);
                    endPt = ej.datavisualization.Diagram.Geometry.transform({ x: endPt.x, y: endPt.y }, angle, Math.max(node.width / 2, node.height / 2));
                }
                else {
                    angle = ej.datavisualization.Diagram.Geometry.findAngle(endPt, strPt);
                    strPt = ej.datavisualization.Diagram.Geometry.transform({ x: strPt.x, y: strPt.y }, angle, Math.max(node.width / 2, node.height / 2));
                }
            }
            if (node._shape === "ellipse") {
                var thisSegment = ej.datavisualization.Diagram.LineSegment(strPt, endPt);
                intersection = this._getEllipseIntersectCoords(node, thisSegment, connector, point, isTarget);
                return intersection;
            }
            else if (node._shape === "polygon" && !(node.type == "bpmn" && line.type == "orthogonal")) {
                segmentPoints = [];
                if (!node._segmentPoints) {
                    segmentPoints = this._findSegmentPoints(node, connector, isTarget);
                } else segmentPoints = node._segmentPoints;

                if (node.rotateAngle) {
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                }
                length = segmentPoints.length;
                var pts = [];
                for (var i = 0; i < length; i++) {
                    var pt1 = ej.datavisualization.Diagram.Point(segmentPoints[i].x + (node.offsetX - node.width * node.pivot.x), segmentPoints[i].y + (node.offsetY - node.height * node.pivot.y));
                    if (node.rotateAngle != 0) {
                        pt1 = ej.Matrix.transform(matrix, pt1);
                    }
                    if (node.connectorPadding || connector.sourcePadding || connector.targetPadding) {
                        var x = node.offsetX == pt1.x ? 0 : (node.offsetX < pt1.x ? 1 : -1);
                        var y = node.offsetY == pt1.y ? 0 : (node.offsetY < pt1.y ? 1 : -1);
                        pt1 = pad ? ej.datavisualization.Diagram.Geometry.translate(pt1, x * pad, y * pad) : pt1;
                    }
                    pts[i] = pt1;
                }
                segmentPoints = pts;
            }
            else if (node._shape === "path" && !(node.type == "bpmn" && line.type == "orthogonal")) {
                if (!node._segmentPoints) {
                    var pts = this._findSegmentPoints(node, connector, isTarget);
                }
                segmentPoints = pts || node._segmentPoints;
                if (((node.pathData.split("m").length - 1) + (node.pathData.split("M").length - 1)) == 1) segmentPoints[segmentPoints.length] = segmentPoints[0];
                length = segmentPoints.length;
            }
            else {
                if (node.connectorPadding || connector.sourcePadding || connector.targetPadding) {
                    var rect = ej.datavisualization.Diagram.Rectangle(bounds.x - pad, bounds.y - pad, node.width + 2 * pad, node.height + 2 * pad);
                    bounds = this.bounds(rect);
                }
                segmentPoints = bounds.points;
                segmentPoints[segmentPoints.length] = segmentPoints[0];
                length = bounds.points.length;
            }
            var thisSegment = ej.datavisualization.Diagram.LineSegment(strPt, endPt);
            var intersection = this._getIntersectionPoints(thisSegment, segmentPoints, true, point);
            return intersection;
        },
        _getIntersectionPoints: function (thisSegment, segmentPoints, minimal, point) {
            var i;
            var length = segmentPoints.length;
            var segment = ej.datavisualization.Diagram.LineSegment(segmentPoints[0], segmentPoints[1]);
            var intersection = ej.datavisualization.Diagram.Geometry.intersectSegment(thisSegment, segment);
            if (intersection) {
                if (!minimal) return intersection;
                var min = ej.datavisualization.Diagram.Geometry.distance(intersection, point);
            }
            //if (intersection)
            if (isNaN(min) || min > 0) {
                for (i = 1; i < length - 1 ; i++) {
                    segment = ej.datavisualization.Diagram.LineSegment(segmentPoints[i], segmentPoints[i + 1]);
                    var intersect = ej.datavisualization.Diagram.Geometry.intersectSegment(thisSegment, segment);
                    if (intersect) {
                        if (!minimal) return intersect;
                        var dist = ej.datavisualization.Diagram.Geometry.distance(intersect, point);
                        if (isNaN(min) || min > dist) { min = dist; intersection = intersect; }
                        if (min >= 0 && min <= 1)
                            break;
                    }
                }
            }
            return intersection;
        },

        _findSegmentPoints: function (node, connector, isTarget) {
            var pts = [];
            if (node._shape == "path") {
                var svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
                svg.setAttribute('xlink', 'http://www.w3.org/1999/xlink');
                document.body.appendChild(svg);
                var pathNode = document.createElementNS('http://www.w3.org/2000/svg', "path");
                pathNode.setAttributeNS(null, "d", node._absolutePath || node.pathData);
                svg.appendChild(pathNode);
                var pathBounds = (!node._absoluteBounds || node._scaled || node._absolutePath) ? pathNode.getBBox() : node._absoluteBounds;
                var pad = node.connectorPadding;
                if (connector)
                    pad += isTarget ? connector.targetPadding : connector.sourcePadding;
                if (pad || !node._absolutePath || node._scaled) {
                    var pathData = ej.datavisualization.Diagram.Geometry.updatePath(-pad, -pad, node.width + 2 * pad, node.height + 2 * pad, node._absolutePath || node.pathData, null, pathBounds, pad ? null : node);
                    pathNode.setAttributeNS(null, "d", pathData);
                    if ((node._scaled && !pad) || !node._absolutePath) {
                        node._absolutePath = pathData;
                        node._scaled = false;
                    }
                } else pathNode.setAttributeNS(null, "d", node._absolutePath);
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                var pathLength = pathNode.getTotalLength();
                for (var sample, sampleLength = 0; sampleLength <= pathLength; sampleLength += 10) {
                    sample = pathNode.getPointAtLength(sampleLength);
                    var pt1 = { x: node.offsetX - node.width * node.pivot.x + sample.x, y: node.offsetY - node.height * node.pivot.y + sample.y };
                    if (node.rotateAngle != 0) {
                        pt1 = ej.Matrix.transform(matrix, pt1);
                    }
                    pts.push(pt1);
                }
                document.body.removeChild(svg);
            }
            else if (node._shape == "polygon") {
                var length = node.points.length;
                for (var i = 0; i < length; i++) pts[i] = node.points[i];
                ej.datavisualization.Diagram.Geometry.updatePolygonPoints(node, pts);
                pts[pts.length] = pts[0];
            } else return null;
            return pts;
        },
        _getEdges: function (rotateAngle, bounds) {
            var points = bounds.points;
            var segments = {};
            var angle = rotateAngle % 360;
            var temp;
            segments.left = ej.datavisualization.Diagram.LineSegment(points[3], points[0]);
            segments.top = ej.datavisualization.Diagram.LineSegment(points[0], points[1]);
            segments.right = ej.datavisualization.Diagram.LineSegment(points[1], points[2]);
            segments.bottom = ej.datavisualization.Diagram.LineSegment(points[2], points[3]);
            if (angle < 0) {
                angle += 360;
            }
            if (angle > 315 || angle < 45) {
            }
            else if (angle < 135) {
                temp = segments.top;
                segments.top = segments.left;
                segments.left = segments.bottom;
                segments.bottom = segments.right;
                segments.right = temp;
            }
            else if (angle < 225) {
                temp = segments.top;
                segments.top = segments.bottom;
                segments.bottom = temp;
                temp = segments.left;
                segments.left = segments.right;
                segments.right = temp;
            }
            else {
                temp = segments.bottom;
                segments.bottom = segments.left;
                segments.left = segments.top;
                segments.top = segments.right;
                segments.right = temp;
            }
            return segments;
        },
        _pointsFromNodeToPoint: function (connector, segment, direction, bounds, angle, point, endPoint, isTarget) {
            var dir, num;
            var minSpace = isTarget ? connector._tarDecoratorSize : connector._srcDecoratorSize;
            var points = [];
            points.push(point);
            var straight;
            straight = (point.y == endPoint.y && (direction == "left" && endPoint.x < point.x || direction == "right" && endPoint.x > point.x)) ||
               (point.x == endPoint.x && (direction == "top" && endPoint.y < point.y || direction == "bottom" && endPoint.y > point.y));
            //if (angle == 0)
            //if (!straight && !isTarget) straight = point.x > bounds.left && point.x < bounds.right && point.y > bounds.top && point.y < bounds.bottom;
            if (!straight) {
                if (direction == "top" || direction == "bottom") {
                    if (direction == "top" && endPoint.y < point.y && endPoint.y > point.y - minSpace || direction == "bottom" && endPoint.y > point.y && endPoint.y < point.y + minSpace) {
                        var y = direction == "top" ? bounds.top - minSpace : bounds.bottom + minSpace;
                        points.push({ x: point.x, y: y });
                        points.push({ x: point.x + (endPoint.x - point.x) / 2, y: y });
                        points.push({ x: point.x + (endPoint.x - point.x) / 2, y: endPoint.y });
                    }
                    else if (Math.abs(point.x - endPoint.x) > minSpace && (direction == "top" && endPoint.y < point.y || direction == "bottom" && endPoint.y > point.y)) {
                        //twosegments
                        points.push({ x: point.x, y: endPoint.y });
                    }
                    else if (Math.abs(point.x - endPoint.x) <= minSpace || ((endPoint.x < bounds.left || endPoint.x > bounds.right) && endPoint.y != point.y)) {
                        //three segments
                        var y = direction == "top" ? bounds.top - minSpace : bounds.bottom + minSpace;
                        points.push({ x: point.x, y: y });
                        points.push({ x: endPoint.x, y: y });
                    }
                    else {
                        //four segments
                        var y = direction == "top" ? bounds.top - minSpace : bounds.bottom + minSpace;
                        var x = (endPoint.x < point.x) ? bounds.left - minSpace : bounds.right + minSpace;
                        points.push({ x: point.x, y: y });
                        points.push({ x: x, y: y });
                        points.push({ x: x, y: endPoint.y });
                    }
                }
                else {
                    if (direction == "left" && endPoint.x < point.x && endPoint.x > point.x - minSpace || direction == "right" && endPoint.x > point.x && endPoint.x < point.x + minSpace) {
                        var x = direction == "left" ? bounds.left - minSpace : bounds.right + minSpace;
                        points.push({ x: x, y: point.y });
                        points.push({ x: x, y: point.y + (endPoint.y - point.y) / 2 });
                        points.push({ x: endPoint.x, y: point.y + (endPoint.y - point.y) / 2 });
                    }
                    else if (Math.abs(point.y - endPoint.y) > minSpace && (direction == "left" && endPoint.x < point.x || direction == "right" && endPoint.x > point.x)) {
                        points.push({ x: endPoint.x, y: point.y });
                        //twosegments
                    }
                    else if (Math.abs(point.y - endPoint.y) <= minSpace || ((endPoint.y < bounds.top || endPoint.y > bounds.bottom) && endPoint.x != point.x)) {
                        //three segments
                        var x = direction == "left" ? bounds.left - minSpace : bounds.right + minSpace;
                        points.push({ x: x, y: point.y });
                        points.push({ x: x, y: endPoint.y });
                    }
                    else {
                        //four segments
                        var y = (endPoint.y < point.y) ? bounds.top - minSpace : bounds.bottom + minSpace;
                        var x = direction == "left" ? bounds.left - minSpace : bounds.right + minSpace;
                        points.push({ x: x, y: point.y });
                        points.push({ x: x, y: y });
                        points.push({ x: endPoint.x, y: y });
                    }
                }
            }
            points.push(endPoint);
            if (isTarget) points.reverse();
            segment._startPoint = points[0];
            segment._endPoint = points[points.length - 1];
            segment.points = points;
            if (segment.direction) {
                if (segment.direction == "left" || segment.direction == "right") {
                    segment.length = segment._length = Math.abs(segment._startPoint.x - segment._endPoint.x);
                    if (segment._startPoint.x < segment._endPoint.x) segment._direction = segment.direction = "right"; else segment._direction = segment.direction = "left";
                }
                else {
                    segment.length = segment._length = Math.abs(segment._startPoint.y - segment._endPoint.y);
                    if (segment._startPoint.y < segment._endPoint.y) segment._direction = segment.direction = "bottom"; else segment._direction = segment.direction = "top";
                }
            }
        },
        _constructSegements: function (connector, segment, targetBounds, targetPortLocation, targetDirection, sourceBounds, sourcePortLocation, sourceDirection) {
            var points, reverse;
            if (sourceDirection === "right") {
                if (targetDirection === "left") {
                    points = this._rightToLeft(connector, segment, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, false);
                }
                else if (targetDirection === "right") {
                    points = this._rightToRight(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation);
                }
                else if (targetDirection === "top") {
                    points = this._rightToTop(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, false);
                }
                else if (targetDirection === "bottom") {
                    points = this._rightToBottom(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, false);
                }
            }
            if (sourceDirection === "left") {
                if (targetDirection === "right") {
                    points = this._rightToLeft(connector, segment, sourceBounds, sourcePortLocation, targetBounds, targetPortLocation, true);
                    reverse = true;
                }
                if (targetDirection === "left") {
                    points = this._leftToLeft(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation);
                }
                if (targetDirection === "top") {
                    points = this._leftToTop(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, false);
                }
                if (targetDirection === "bottom") {
                    points = this._leftToBottom(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, false);
                }
            }
            if (sourceDirection === "top") {
                if (targetDirection === "left") {
                    points = this._leftToTop(connector, sourceBounds, sourcePortLocation, targetBounds, targetPortLocation, true);
                    reverse = true;
                }
                if (targetDirection === "right") {
                    points = this._rightToTop(connector, sourceBounds, sourcePortLocation, targetBounds, targetPortLocation, true);
                    reverse = true;
                }
                if (targetDirection === "top") {
                    points = this._topToTop(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation);
                }
                if (targetDirection === "bottom") {
                    points = this._topToBottom(connector, segment, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, false);
                }
            }
            if (sourceDirection === "bottom") {
                if (targetDirection === "left") {
                    points = this._leftToBottom(connector, sourceBounds, sourcePortLocation, targetBounds, targetPortLocation, true);
                    reverse = true;
                }
                if (targetDirection === "right") {
                    points = this._rightToBottom(connector, sourceBounds, sourcePortLocation, targetBounds, targetPortLocation, true);
                    reverse = true;
                }
                if (targetDirection === "top") {
                    points = this._topToBottom(connector, segment, sourceBounds, sourcePortLocation, targetBounds, targetPortLocation, true);
                    reverse = true;
                }
                if (targetDirection === "bottom") {
                    points = this._bottomToBottom(connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation);
                }
            }
            if (reverse) {
                points.reverse();
            }
            var point1 = points[points.length - 1];
            var point2 = points[points.length - 2];
            while (points.length > 2 && point1.x == point2.x && point1.y == point2.y) {
                points.splice(points.length - 1, 1);
                point1 = points[points.length - 1];
                point2 = points[points.length - 2];
            }
            point1 = points[0];
            point2 = points[1];
            while (points.length > 2 && point1.x == point2.x && point1.y == point2.y) {
                points.splice(0, 1);
                point1 = points[0];
                point2 = points[1];
            }
            segment._startPoint = points[0];
            segment._endPoint = points[points.length - 1];
            segment.points = points;
            //this._setPoints(connector.line, points);
        },
        _updateIntermediateSegments: function (connector) {
            var startPoint = connector.segments[0]._endPoint;
            var prev = connector.segments[0];
            var length = prev.points.length;
            var next = null;
            var runAngle;
            if (connector.segments[1]) {
                var segment = connector.segments[1];
                segment._startPoint = startPoint;
                if (segment.type == "orthogonal" && (segment.length || segment.length === 0)) {
                    if (segment.direction == "left" || segment.direction == "right") {
                        if (connector.segments[2]) {
                            if (connector.segments[2].length || connector.segments[2].length === 0) {
                                if (connector.segments[2].direction == "top")
                                    connector.segments[2].length += segment._startPoint.y - segment._endPoint.y;
                                else
                                    connector.segments[2].length -= segment._startPoint.y - segment._endPoint.y;
                                if (connector.segments[2].length < 0) {
                                    connector.segments[2].length *= -1;
                                    connector.segments[2].direction = connector.segments[2]._direction = connector.segments[2]._direction == "bottom" ? "top" : "bottom";
                                }
                                connector.segments[2]._length = connector.segments[2].length;
                            }
                        }
                        segment._endPoint.y = segment._startPoint.y;
                    }
                    else {
                        if (connector.segments[2]) {
                            if (connector.segments[2].length || connector.segments[2].length === 0) {
                                if (connector.segments[2].direction == "left")
                                    connector.segments[2].length += segment._startPoint.x - segment._endPoint.x;
                                else
                                    connector.segments[2].length -= segment._startPoint.x - segment._endPoint.x;
                                if (connector.segments[2].length < 0) {
                                    connector.segments[2].length *= -1;
                                    connector.segments[2].direction = connector.segments[2]._direction = connector.segments[2]._direction == "right" ? "left" : "right";
                                }
                                connector.segments[2]._length = connector.segments[2].length;
                            }
                        }
                        segment._endPoint.x = segment._startPoint.x;
                    }
                    if (connector.sourcePort && prev.points.length > 2) {
                        if (segment.direction == "left" || segment.direction == "right") {
                            if (prev.points[prev.points.length - 1].y == prev.points[prev.points.length - 2].y) {
                                segment._startPoint = segment.points[0] = prev.points[prev.points.length - 2];
                                prev.points.splice(prev.points.length - 1, 1);
                                prev._endPoint = prev.points[prev.points.length - 1];
                                if (segment.points.length == 2) {
                                    segment._endPoint.y = segment._startPoint.y;
                                }
                            }
                        }
                        else {
                            if (prev.points[prev.points.length - 1].x == prev.points[prev.points.length - 2].x) {
                                segment._startPoint = segment.points[0] = prev.points[prev.points.length - 2];
                                prev.points.splice(prev.points.length - 1, 1);
                                prev._endPoint = prev.points[prev.points.length - 1];
                                if (segment.points.length == 2) {
                                    segment._endPoint.x = segment._startPoint.x;
                                }
                            }
                        }
                    }
                    if (segment.length || segment.length === 0)
                        segment.length = segment._length = ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, segment.points[1]);
                    if (segment.length > 0)
                        segment.direction = segment._direction = this._getBezierDirection(segment._startPoint, segment._endPoint) || segment._direction;
                    this._addOrthogonalPoints(segment, prev, connector.segments[2], connector.sourcePoint, connector.targetPoint);
                    if (connector.segments[2])
                        this._addOrthogonalPoints(connector.segments[2], connector.segments[1], connector.segments[3], connector.sourcePoint, connector.targetPoint);
                }
                else if (segment.type == "orthogonal" && segment.length === null) {
                    if (connector.sourcePort && prev.points.length > 2) {
                        if (segment._direction == "left" || segment._direction == "right") {
                            if (prev.points[prev.points.length - 1].y == prev.points[prev.points.length - 2].y) {
                                segment._startPoint = segment.points[0] = prev.points[prev.points.length - 2];
                                prev.points.splice(prev.points.length - 1, 1);
                                prev._endPoint = prev.points[prev.points.length - 1];
                            }
                        }
                        else {
                            if (prev.points[prev.points.length - 1].x == prev.points[prev.points.length - 2].x) {
                                segment._startPoint = segment.points[0] = prev.points[prev.points.length - 2];
                                prev.points.splice(prev.points.length - 1, 1);
                                prev._endPoint = prev.points[prev.points.length - 1];
                            }
                        }
                    }
                    segment._startPoint = segment.points[0] = connector.segments[0]._endPoint;
                    this._addOrthogonalPoints(connector.segments[1], connector.segments[0], null, connector.sourcePoint, connector.targetPoint);
                }
                else {
                    segment._startPoint = segment.points[0] = connector.segments[0]._endPoint;
                    if (segment.type == "bezier") {
                        this._updateBezierPoints(segment);
                    }
                }
            }
        },
        _updatePreviousSegment: function (connector) {
            var previousSegment = connector.segments[connector.segments.length - 2];
            var current = connector.segments[connector.segments.length - 1];
            if (previousSegment) {
                if (previousSegment.type == "orthogonal" && current.points.length > 2) {
                    var update = false;
                    var direction = previousSegment.points.length == 2 ? previousSegment.direction :
                        ej.datavisualization.Diagram.Util._getBezierDirection(previousSegment.points[previousSegment.points.length - 2],
                        previousSegment.points[previousSegment.points.length - 1]);
                    if (direction == "left" || direction == "right") {
                        if (current.points[0].y == current.points[1].y) {
                            update = true;
                            var dif = current.points[1].x - current.points[0].x;
                            current.points.splice(0, 1);
                            current._startPoint = current.points[0];
                            previousSegment._endPoint = current.points[0];
                        }
                    }
                    else {
                        if (current.points[0].x == current.points[1].x) {
                            update = true;
                            current.points.splice(0, 1);
                            current._startPoint = current.points[0];
                            previousSegment._endPoint = current.points[0];
                        }
                    }
                }
                previousSegment._endPoint = current._startPoint;
                previousSegment.points[previousSegment.points.length - 1] = current._startPoint;
                if (previousSegment.type == "orthogonal" && update) {
                    previousSegment._length = previousSegment.length = ej.datavisualization.Diagram.Geometry.distance(previousSegment._startPoint, previousSegment._endPoint);
                    if (previousSegment._length > 0)
                        previousSegment._direction = previousSegment.direction = this._getBezierDirection(previousSegment._startPoint, previousSegment._endPoint);
                    if (connector.segments.length > 2 || !connector.sourcePort)
                        this._addOrthogonalPoints(previousSegment, connector.segments[connector.segments.length - 3], current, connector.sourcePoint, connector.targetPoint);
                }
                else {
                    previousSegment.point = current._startPoint;
                }
            }
        },
        _initConnectionEnds: function (connector, diagram) {
            if (connector.segments && connector.segments[0] && connector.segments[0].type == "orthogonal" && connector.segments[0].length) {
                var port, bounds;
                if (connector.sourceNode) {
                    var srcNode = diagram.nameTable[connector.sourceNode];
                    if (srcNode) {
                        bounds = ej.datavisualization.Diagram.Util.bounds(srcNode, true);
                        if (connector.sourcePort) {
                            port = ej.datavisualization.Diagram.Util.findPortByName(diagram.nameTable[connector.sourceNode], connector.sourcePort);
                            connector.sourcePoint = ej.datavisualization.Diagram.Util._getPortPosition(port, bounds);
                        }
                        else {
                            var line = connector.segments[0];
                            switch (line.direction) {
                                case "left":
                                    connector.sourcePoint = bounds.middleLeft;
                                    break;
                                case "right":
                                    connector.sourcePoint = bounds.middleRight;
                                    break;
                                case "top":
                                    connector.sourcePoint = bounds.topCenter;
                                    break;
                                case "bottom":
                                    connector.sourcePoint = bounds.bottomCenter;
                                    break;
                            }
                        }
                    }
                }
                if (connector.targetNode) {
                    var trgNode = diagram.nameTable[connector.targetNode];
                    if (trgNode) {
                        bounds = ej.datavisualization.Diagram.Util.bounds(trgNode, true);
                        if (connector.targetPort) {
                            port = ej.datavisualization.Diagram.Util.findPortByName(diagram.nameTable[connector.targetNode], connector.targetPort);
                            connector.targetPoint = ej.datavisualization.Diagram.Util._getPortPosition(port, bounds);
                        }
                        else {
                            var line = connector.segments[0];
                            switch (line.direction) {
                                case "left":
                                    connector.targetPoint = bounds.middleLeft;
                                    break;
                                case "right":
                                    connector.targetPoint = bounds.middleRight;
                                    break;
                                case "top":
                                    connector.targetPoint = bounds.topCenter;
                                    break;
                                case "bottom":
                                    connector.targetPoint = bounds.bottomCenter;
                                    break;
                            }
                        }
                    }
                }
            }
            else {
                if (connector.sourceNode) {
                    bounds = ej.datavisualization.Diagram.Util.bounds(diagram.nameTable[connector.sourceNode], true);
                    if (connector.sourcePort) {
                        port = ej.datavisualization.Diagram.Util.findPortByName(diagram.nameTable[connector.sourceNode], connector.sourcePort);
                        connector.sourcePoint = ej.datavisualization.Diagram.Util._getPortPosition(port, bounds);
                    }
                    else
                        connector.sourcePoint = bounds.center;
                }
                if (connector.targetNode) {
                    bounds = ej.datavisualization.Diagram.Util.bounds(diagram.nameTable[connector.targetNode], true);
                    if (connector.targetPort) {
                        port = ej.datavisualization.Diagram.Util.findPortByName(diagram.nameTable[connector.targetNode], connector.targetPort);
                        connector.targetPoint = ej.datavisualization.Diagram.Util._getPortPosition(port, bounds);
                    }
                    else
                        connector.targetPoint = bounds.center;
                }
            }
        },
        _swapDirection: function (rotateAngle, direction) {
            var dir;
            var angle = rotateAngle % 360;
            if (angle < 0) {
                angle += 360;
            }
            var dirs;
            if (angle > 315 || angle < 45) {
                dir = direction;
            }
            else if (angle < 135) {
                dirs = { left: "top", top: "right", right: "bottom", bottom: "left" };
                dir = dirs[direction];
            }
            else if (angle < 225) {
                dirs = { left: "right", top: "bottom", right: "left", bottom: "top" };
                dir = dirs[direction];
            }
            else {
                dirs = { left: "bottom", top: "left", right: "top", bottom: "right" };
                dir = dirs[direction];
            }
            return dir;
        },
        _getEllipseIntersectCoords: function (node, connectorSeg, connector, point, isTarget) {
            var segmentPoints = [], intersection;
            var pad = node.connectorPadding;
            if (connector) pad += isTarget ? connector.targetPadding : connector.sourcePadding;
            if (!pad) pad = 0;
            var rx = node.width / 2;
            var ry = node.height / 2;
            //var cx = node.offsetX - node.width * node.pivot.x - pad;
            //var cy = node.offsetY - node.height * node.pivot.y - pad;
            var matrix = ej.Matrix.identity();
            ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
            //Convert Top Round Side to Path
            var topArchPath = "M " + (node.offsetX - node.width * node.pivot.x - pad) + ", " + (node.offsetY) + " A " + rx + " " + ry + " 0 0 " + 1 + " " + (node.offsetX + node.width * (1 - node.pivot.x) + pad) + ", " + (node.offsetY) +
                 " A " + rx + " " + ry + " 0 0 " + 1 + " " + (node.offsetX - node.width * node.pivot.x - pad) + ", " + (node.offsetY) + "z";
            var path = document.createElementNS('http://www.w3.org/2000/svg', "path");
            path.setAttributeNS(null, "d", topArchPath);
            var len = path.getTotalLength(), pts = [], pt1, pt2, coor;
            for (var i = 0; i < len; i = i + 3) {
                var pathSeg = path.getPointAtLength(i);
                if (node.rotateAngle != 0) {
                    pathSeg = ej.Matrix.transform(matrix, pathSeg);
                }
                pts[pts.length] = pathSeg;
            }
            if (pts[pts.length - 1] != path.getPointAtLength(len)) pts[pts.length] = path.getPointAtLength(len);
            segmentPoints = pts;
            intersection = this._getIntersectionPoints(connectorSeg, segmentPoints, true, point);
            return intersection;
        },
        _rightToLeft: function (connector, segment, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, swap) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (swap) {
                tarExtension = connector._srcDecoratorSize;
                srcExtension = connector._tarDecoratorSize;
            }
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var min = srcExtension + tarExtension;
            if (targetPortLocation.x > sourcePortLocation.x) {
                if (sourcePortLocation.y != targetPortLocation.y) {
                    if ((sourcePortLocation.x) > targetBounds.left) {
                        x = sourceBounds.right + srcExtension;
                        y = sourcePortLocation.y;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if (targetPortLocation.y > sourceBounds.top) {
                            y = targetPortLocation.y;
                        }
                        else {
                            y = targetBounds.bottom + tarExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if (targetPortLocation.y <= sourceBounds.top) {
                            x = targetBounds.right + tarExtension;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                            y = targetBounds.top - tarExtension;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                            x = targetBounds.left - tarExtension;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                            y = targetPortLocation.y;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                        }
                    }
                    else {
                        if (!segment.direction && segment.length != undefined) x = sourceBounds.right + segment.length;
                        else if (targetBounds.left - sourceBounds.right > 0) x = sourceBounds.right + (targetBounds.left - sourceBounds.right) / 2;
                        else x = sourceBounds.right + srcExtension;
                        y = sourcePortLocation.y;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetPortLocation.y;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            else {
                //5 segment
                if (Math.abs(targetBounds.top - sourceBounds.bottom) < min || Math.abs(targetBounds.bottom - sourceBounds.top) < min) {
                    if ((sourcePortLocation.x) > targetBounds.right) {
                        x = sourcePortLocation.x + srcExtension;
                        y = sourcePortLocation.y;
                    }
                    else {
                        x = targetBounds.right + tarExtension;
                        y = sourcePortLocation.y;
                    }
                }
                else {
                    x = sourceBounds.right + srcExtension;
                    y = sourcePortLocation.y;
                }
                points.push(ej.datavisualization.Diagram.Point(x, y));
                if ((targetBounds.top - sourceBounds.bottom) >= min) {
                    y = targetBounds.top - tarExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                else if (sourcePortLocation.y > targetPortLocation.y) {
                    if ((sourceBounds.top - targetBounds.bottom) < min) {
                        if (targetBounds.left > sourceBounds.right) y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2
                        else y = Math.min((targetBounds.top - tarExtension), (sourceBounds.top - srcExtension));
                    }
                    else {
                        y = targetBounds.bottom + tarExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                else {
                    if (targetBounds.left > sourceBounds.right) y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                    else y = Math.max((targetBounds.bottom + tarExtension), (sourceBounds.bottom + srcExtension));
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                x = targetBounds.left - tarExtension;
                points.push(ej.datavisualization.Diagram.Point(x, y));
                y = targetPortLocation.y;
                points.push(ej.datavisualization.Diagram.Point(x, y));
            }
            points.push(targetPortLocation);
            return points;
        },
        _rightToRight: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            y = sourcePortLocation.y;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            if (targetBounds.right >= sourceBounds.left) {
                if (sourcePortLocation.y >= targetBounds.top - tarExtension && sourcePortLocation.y <= targetBounds.bottom + tarExtension) {
                    x = sourcePortLocation.x + srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (sourcePortLocation.y >= targetBounds.center.y) {
                        if (sourcePortLocation.x > targetBounds.left) {
                            if (sourcePortLocation.y > targetPortLocation.y) {
                                y = targetBounds.bottom + tarExtension;
                            }
                            else {
                                y = targetBounds.top - tarExtension;
                            }
                        }
                        else {
                            y = targetBounds.top - tarExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else if (targetBounds.right < sourceBounds.right) {
                    x = sourceBounds.right + srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    //points.push(ej.datavisualization.Diagram.Point(x, targetPortLocation.y));
                } else {
                    x = targetPortLocation.x + tarExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    //points.push(ej.datavisualization.Diagram.Point(x, targetPortLocation.y));
                }
            }
            else {
                x = sourcePortLocation.x + srcExtension;
                points.push(ej.datavisualization.Diagram.Point(x, y));
                if (targetPortLocation.y >= sourceBounds.top - srcExtension && targetPortLocation.y <= sourceBounds.bottom + srcExtension) {
                    if (targetPortLocation.y <= sourceBounds.center.y) {
                        y = sourceBounds.top - srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = sourceBounds.bottom + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            points.push(ej.datavisualization.Diagram.Point(x, targetPortLocation.y));
            points.push(targetPortLocation);
            return points;
        },
        _rightToTop: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, swap) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            y = sourcePortLocation.y;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (swap) {
                tarExtension = connector._srcDecoratorSize;
                srcExtension = connector._tarDecoratorSize;
            }
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var min = srcExtension + tarExtension;
            if (targetPortLocation.x >= sourcePortLocation.x + srcExtension) {
                if ((sourcePortLocation.y + srcExtension) >= targetPortLocation.y && targetBounds.height !== 0) {
                    if (targetBounds.left <= sourceBounds.right) {
                        x = targetBounds.right + tarExtension;
                    }
                    else if ((targetBounds.left - sourceBounds.right) > min) {
                        x = sourceBounds.right + srcExtension;
                    }
                    else {
                        x = sourceBounds.right + (targetBounds.left - sourceBounds.right) / 2;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    y = targetBounds.top - tarExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
            }
            else {
                if (sourceBounds.bottom + srcExtension > targetBounds.top - tarExtension) {
                    if ((sourcePortLocation.x + srcExtension) <= targetBounds.right) {
                        x = targetBounds.right + tarExtension;
                    }
                    else {
                        x = sourceBounds.right + srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (sourceBounds.top >= targetBounds.top) {
                        if (targetBounds.height !== 0) {
                            y = targetBounds.top - tarExtension;
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                    }
                    else if (sourceBounds.top >= targetBounds.top - tarExtension)
                        y = targetBounds.top - tarExtension - srcExtension;
                    else {
                        y = sourceBounds.top - srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                else {
                    x = sourcePortLocation.x + srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if ((targetBounds.top - sourceBounds.bottom) < min && targetBounds.height !== 0) {
                        if ((sourceBounds.left - targetBounds.right) >= min) {
                            y = sourceBounds.bottom + srcExtension;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                            x = sourceBounds.left - srcExtension;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                            y = targetBounds.top - tarExtension;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                        }
                        else {
                            y = targetBounds.top - (targetBounds.top - sourceBounds.bottom) / 2;
                            points.push(ej.datavisualization.Diagram.Point(x, y));
                        }
                    }
                    else {
                        if (targetBounds.height !== 0) {
                            y = targetBounds.top - tarExtension;
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            points.push(targetPortLocation);
            return points;
        },
        _rightToBottom: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, swap) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            y = sourcePortLocation.y;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (swap) {
                tarExtension = connector._srcDecoratorSize;
                srcExtension = connector._tarDecoratorSize;
            }
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var min = srcExtension + tarExtension;
            if (targetPortLocation.x >= sourcePortLocation.x) {
                if (sourcePortLocation.y <= targetBounds.bottom + tarExtension) {
                    if (targetBounds.left > (sourceBounds.right + srcExtension)) {
                        x = sourcePortLocation.x + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if ((sourceBounds.right + srcExtension) > targetPortLocation.x) {
                        x = sourcePortLocation.x + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if ((sourceBounds.top - targetBounds.bottom) > min) {
                            y = targetBounds.bottom + tarExtension;
                        }
                        else {
                            y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = sourcePortLocation.y;
                    }
                }
            }
            else {
                if (sourcePortLocation.y <= targetBounds.bottom) {
                    if ((sourceBounds.right + srcExtension) > targetBounds.right) {
                        x = sourceBounds.right + srcExtension;
                    }
                    else {
                        x = targetBounds.right + tarExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    y = targetBounds.bottom + tarExtension;
                    if (y <= (sourceBounds.bottom + srcExtension)) {
                        y = sourceBounds.bottom + srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                else {
                    if ((targetBounds.bottom + tarExtension) < sourceBounds.top - srcExtension) {
                        x = sourceBounds.right + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if ((sourceBounds.top - targetBounds.bottom) < min) {
                            y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                        }
                        else {
                            y = targetBounds.bottom + tarExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        x = sourceBounds.right + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = sourceBounds.bottom + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            points.push(targetPortLocation);
            return points;
        },
        _leftToLeft: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            y = sourcePortLocation.y;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var min = srcExtension + tarExtension;
            if (targetPortLocation.x - tarExtension >= sourcePortLocation.x - srcExtension) {
                x = sourceBounds.left - srcExtension;
                points.push(ej.datavisualization.Diagram.Point(x, y));
                if (sourcePortLocation.y > targetPortLocation.y) {
                    if ((targetPortLocation.y + tarExtension) >= sourceBounds.top) {
                        y = sourceBounds.top - srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if ((targetBounds.left - sourceBounds.right) > min) {
                            x = targetBounds.left - tarExtension;
                        }
                        else {
                            x = sourceBounds.right + (targetBounds.left - sourceBounds.right) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = targetPortLocation.y;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetPortLocation.x;
                    }
                }
                else {
                    if ((sourceBounds.bottom + srcExtension) < targetPortLocation.y) {
                        y = targetPortLocation.y;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetPortLocation.x;
                    }
                    else {
                        y = sourceBounds.bottom + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if ((targetBounds.left - sourceBounds.right) > min) {
                            x = targetBounds.left - tarExtension;
                        }
                        else {
                            x = sourceBounds.right + (targetBounds.left - sourceBounds.right) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            else {
                if (targetPortLocation.y > sourcePortLocation.y) {
                    if (sourcePortLocation.y > (targetBounds.top - tarExtension)) {
                        if ((sourceBounds.left - targetBounds.right) < min) {
                            x = targetBounds.right + (sourceBounds.left - targetBounds.right) / 2;
                        }
                        else {
                            x = sourceBounds.left - srcExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.top - tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if ((targetBounds.bottom + tarExtension) >= sourcePortLocation.y) {
                        if ((sourceBounds.left - targetBounds.right) < min) {
                            x = targetBounds.right + (sourceBounds.left - targetBounds.right) / 2;
                        }
                        else {
                            x = sourceBounds.left - srcExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.left - tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                x = targetBounds.left - tarExtension;
                points.push(ej.datavisualization.Diagram.Point(x, y));
            }
            points.push(ej.datavisualization.Diagram.Point(x, targetPortLocation.y));
            points.push(targetPortLocation);
            return points;
        },
        _leftToTop: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, swap) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            y = sourcePortLocation.y;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (swap) {
                tarExtension = connector._srcDecoratorSize;
                srcExtension = connector._tarDecoratorSize;
            }
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            if (sourcePortLocation.x <= targetPortLocation.x) {
                if (sourcePortLocation.y > targetPortLocation.y && targetBounds.left <= sourceBounds.left) {
                    x = targetBounds.left - tarExtension;
                }
                else {
                    x = sourceBounds.left - srcExtension;
                }
                points.push(ej.datavisualization.Diagram.Point(x, y));
                if (sourceBounds.bottom <= targetBounds.top) {
                    if ((sourceBounds.bottom + srcExtension) < targetBounds.top - tarExtension) {
                        if (targetBounds.height !== 0) {
                            y = targetBounds.top - tarExtension;
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                    }
                    else if (targetPortLocation.x < sourceBounds.right) {
                        y = sourceBounds.bottom + (targetBounds.top - sourceBounds.bottom) / 2;
                    }
                    else {
                        y = sourceBounds.top - srcExtension;
                    }
                }
                else {
                    if (sourceBounds.top - srcExtension >= targetBounds.top - tarExtension) {
                        if (targetBounds.height !== 0) {
                            y = targetBounds.top - tarExtension;
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                    }
                    else {
                        y = sourceBounds.top - srcExtension;
                    }
                }
                points.push(ej.datavisualization.Diagram.Point(x, y));
            }
            else {
                if (targetPortLocation.y <= (sourcePortLocation.y + srcExtension)) {
                    if (sourceBounds.left - srcExtension > targetBounds.right + tarExtension) {
                        x = sourceBounds.left - srcExtension;
                    }
                    else {
                        if (targetBounds.right + tarExtension >= sourceBounds.left - srcExtension) {
                            x = targetBounds.left - tarExtension;
                        }
                        else {
                            x = targetBounds.right + (sourceBounds.left - targetBounds.right) / 2;
                        }
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    y = targetBounds.top - tarExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
            }
            points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            points.push(targetPortLocation);
            return points;
        },
        _leftToBottom: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, swap) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            y = sourcePortLocation.y;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (swap) {
                tarExtension = connector._srcDecoratorSize;
                srcExtension = connector._tarDecoratorSize;
            }
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var min = srcExtension + tarExtension;
            if (sourcePortLocation.x - srcExtension <= targetPortLocation.x) {
                if (targetBounds.left <= sourcePortLocation.x && sourcePortLocation.y <= targetBounds.top) {
                    x = targetBounds.left - tarExtension;
                }
                else {
                    x = sourceBounds.left - srcExtension;
                }
                points.push(ej.datavisualization.Diagram.Point(x, y));
                if (targetBounds.bottom + tarExtension < sourceBounds.top - srcExtension) {
                    if ((sourceBounds.top - targetBounds.bottom) < min) {
                        y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                    }
                    else {
                        y = targetBounds.bottom + tarExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                else {
                    if (targetBounds.bottom < sourceBounds.bottom) {
                        y = sourceBounds.bottom + srcExtension;
                    }
                    else {
                        y = targetBounds.bottom + tarExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
            }
            else {
                if (!(sourcePortLocation.y - srcExtension > targetPortLocation.y)) {
                    if (targetBounds.right >= sourceBounds.left) {
                        x = targetBounds.left - tarExtension;
                    }
                    else if ((sourceBounds.left - targetBounds.right) < min) {
                        x = sourceBounds.left - (sourceBounds.left - targetBounds.right) / 2;
                    }
                    else {
                        x = sourceBounds.left - srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    y = targetBounds.bottom + tarExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
            }
            points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            points.push(targetPortLocation);
            return points;
        },
        _topToTop: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            x = sourcePortLocation.x;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var min = srcExtension + tarExtension;
            if (targetPortLocation.x >= sourcePortLocation.x) {
                if (targetPortLocation.y - tarExtension >= sourcePortLocation.y - srcExtension) {
                    y = sourceBounds.top - srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (targetPortLocation.x <= sourceBounds.right) {
                        x = sourceBounds.right + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if (targetBounds.height !== 0) {
                            if ((targetBounds.top - sourceBounds.bottom) > min) {
                                y = targetBounds.top - tarExtension;
                            }
                            else {
                                y = sourceBounds.bottom + (targetBounds.top - sourceBounds.bottom) / 2;
                            }
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if (targetBounds.left <= sourcePortLocation.x) {
                        if ((sourceBounds.top - targetBounds.bottom) > min) {
                            y = sourceBounds.top - srcExtension;
                        }
                        else {
                            y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.left - tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.top - tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        if (targetBounds.height !== 0) {
                            y = targetBounds.top - tarExtension;
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            else {
                if (targetPortLocation.y - tarExtension >= sourcePortLocation.y - srcExtension) {
                    y = sourceBounds.top - srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (targetPortLocation.x >= sourceBounds.left) {
                        x = sourceBounds.left - srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if (targetBounds.height !== 0) {
                            if ((targetBounds.top - sourceBounds.bottom) > min) {
                                y = targetBounds.top - tarExtension;
                            }
                            else {
                                y = sourceBounds.bottom + (targetBounds.top - sourceBounds.bottom) / 2;
                            }
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if (targetBounds.right >= sourcePortLocation.x) {
                        if ((sourceBounds.top - targetBounds.bottom) > min) {
                            y = sourceBounds.top - srcExtension;
                        }
                        else {
                            y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.top - tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        if (targetBounds.height !== 0) {
                            y = targetBounds.top - tarExtension;
                        }
                        else {
                            y = targetPortLocation.y;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            x = targetPortLocation.x;
            points.push(ej.datavisualization.Diagram.Point(x, y));
            points.push(targetPortLocation);
            return points;
        },
        _topToBottom: function (connector, segment, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation, swap) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            x = sourcePortLocation.x;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (swap) {
                tarExtension = connector._srcDecoratorSize;
                srcExtension = connector._tarDecoratorSize;
            }
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var minSpace = srcExtension + tarExtension;
            if (targetPortLocation.x > sourcePortLocation.x) {
                if (sourceBounds.top >= targetBounds.bottom) {
                    if ((sourceBounds.top - targetBounds.bottom) > 0) {
                        if (segment.length != undefined && !segment.direction)
                            y = targetBounds.bottom + segment.length;
                        else if (sourceBounds.top - targetBounds.bottom > 0)
                            y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                        else
                            y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = sourceBounds.top - srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if ((targetBounds.left - sourceBounds.right) >= minSpace) {
                            x = sourceBounds.right + srcExtension;
                        }
                        else {
                            x = sourceBounds.right + (targetBounds.left - sourceBounds.right) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if (targetBounds.top < sourceBounds.top) {
                        if (targetBounds.left >= (sourceBounds.right + srcExtension)) {
                            y = sourceBounds.top - srcExtension;
                        }
                        else {
                            y = targetBounds.top - tarExtension;
                        }
                    }
                    else {
                        y = sourceBounds.top - srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (targetBounds.left >= (sourceBounds.right + srcExtension)) {
                        x = sourceBounds.right + srcExtension;
                    }
                    else {
                        x = targetBounds.right + tarExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    y = targetBounds.bottom + tarExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            }
            else if (targetPortLocation.x < sourcePortLocation.x) {
                if (sourceBounds.top >= targetBounds.bottom) {
                    if ((sourceBounds.top - targetBounds.bottom) > 0) {
                        if (segment.length != undefined && !segment.direction)
                            y = targetBounds.bottom + segment.length;
                        else if (sourceBounds.top - targetBounds.bottom > 0)
                            y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                        else
                            y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = sourceBounds.top - srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if ((sourceBounds.left - targetBounds.right) >= minSpace) {
                            x = sourceBounds.left - srcExtension;
                        }
                        else {
                            x = targetBounds.right + (sourceBounds.left - targetBounds.right) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if (sourceBounds.left - srcExtension >= (targetBounds.right + tarExtension)) {
                        y = sourceBounds.top - srcExtension;
                    }
                    else {
                        y = sourceBounds.top - srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (sourceBounds.left >= (targetBounds.right + tarExtension) || ((sourceBounds.right + srcExtension) < (targetBounds.right + tarExtension))) {
                        x = targetBounds.right + tarExtension;
                    }
                    else {
                        x = sourceBounds.right + srcExtension;
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (sourceBounds.left >= (targetBounds.right + tarExtension)) {
                        y = targetBounds.bottom + tarExtension;
                    }
                    else {
                        if (targetBounds.bottom <= sourceBounds.bottom) {
                            y = sourceBounds.bottom + srcExtension;
                        }
                        else {
                            y = targetBounds.bottom + tarExtension;
                        }
                    }
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                }
                points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            }
            points.push(targetPortLocation);
            return points;
        },
        _bottomToBottom: function (connector, targetBounds, targetPortLocation, sourceBounds, sourcePortLocation) {
            var points = [];
            var x, y;
            points.push(sourcePortLocation);
            x = sourcePortLocation.x;
            var srcExtension = connector._srcDecoratorSize;
            var tarExtension = connector._tarDecoratorSize;
            if (sourceBounds.width == 0) srcExtension = 0;
            if (targetBounds.width == 0) tarExtension = 0;
            var minSpace = srcExtension + tarExtension;
            if (targetPortLocation.x >= sourcePortLocation.x) {
                if (sourceBounds.bottom + srcExtension >= targetBounds.bottom + srcExtension) {
                    y = sourceBounds.bottom + srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if ((targetPortLocation.x) < sourceBounds.right) {
                        x = sourceBounds.right + srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if (sourceBounds.top - srcExtension >= targetBounds.bottom + tarExtension) {
                            if ((sourceBounds.top - targetBounds.bottom) >= minSpace) {
                                y = targetBounds.bottom + tarExtension;
                            }
                            else {
                                y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                            }
                        }
                        else {
                            y = targetBounds.bottom + tarExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if (sourcePortLocation.x > targetBounds.left) {
                        if ((targetBounds.bottom - sourceBounds.bottom) >= minSpace) {
                            y = sourceBounds.bottom + srcExtension;
                        }
                        else {
                            y = sourceBounds.bottom + (targetBounds.bottom - sourceBounds.bottom) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.left - tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            else {
                if (sourceBounds.bottom + srcExtension >= targetBounds.bottom + srcExtension) {
                    y = sourceBounds.bottom + srcExtension;
                    points.push(ej.datavisualization.Diagram.Point(x, y));
                    if (targetPortLocation.x > sourceBounds.left) {
                        x = sourceBounds.left - srcExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        if (sourceBounds.top - srcExtension >= targetBounds.bottom + tarExtension) {
                            if ((sourceBounds.top - targetBounds.bottom) >= minSpace) {
                                y = targetBounds.bottom + tarExtension;
                            }
                            else {
                                y = targetBounds.bottom + (sourceBounds.top - targetBounds.bottom) / 2;
                            }
                        }
                        else {
                            y = targetBounds.bottom + tarExtension;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
                else {
                    if (sourcePortLocation.x < targetBounds.right) {
                        if ((targetBounds.bottom - sourceBounds.bottom) >= minSpace) {
                            y = sourceBounds.bottom + srcExtension;
                        }
                        else {
                            y = sourceBounds.bottom + (targetBounds.bottom - sourceBounds.bottom) / 2;
                        }
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        x = targetBounds.right + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                    else {
                        y = targetBounds.bottom + tarExtension;
                        points.push(ej.datavisualization.Diagram.Point(x, y));
                    }
                }
            }
            points.push(ej.datavisualization.Diagram.Point(targetPortLocation.x, y));
            points.push(targetPortLocation);
            return points;
        },
        _addOrthogonalPoints: function (line, prev, next, sourcePt, endPt, runAngle) {
            var points = [];
            var strt = prev ? prev._endPoint : sourcePt;
            points.push(strt);
            if (!line._direction) line._direction = this._getOrthoDirection(strt, endPt, prev);
            if (line._direction === "auto" && !prev && !next)
                line._direction = this._getBezierDirection(strt, endPt);
            var angle = (!runAngle && runAngle != 0) ? this._directionToAngle(line._direction || this._getBezierDirection(strt, endPt)) : runAngle;
            var direction = line._direction;
            var angles = { "right": 0, "left": 180, "top": 270, "bottom": 90, "auto": 90 };
            if (direction == "left" || direction == "right" || direction == "top" || direction == "bottom") {
                angle = angles[direction];
            }
            else {
                switch (direction) {
                    case "straight":
                        angle = 1 - 1;
                        break;
                    case "clockWise90":
                        angle += 91 - 1;
                        break;
                    case "opposite":
                        angle += 181 - 1;
                        break;
                    case "antiClockWise90":
                        angle += 271 - 1;
                        break;
                }
            }
            if ((line.length || line.length == 0) && line.direction) {
                var ctrlPoint1 = ej.datavisualization.Diagram.Geometry.transform(strt, angle || 0, line._length);
                ctrlPoint1.x = Math.round(ctrlPoint1.x * 100) / 100;
                ctrlPoint1.y = Math.round(ctrlPoint1.y * 100) / 100;
                points.push(ctrlPoint1);
                line._endPoint = ctrlPoint1;
                if (next) {
                    next._startPoint = line._endPoint;
                    if (next.points) {
                        next.points[0] = line._endPoint;
                        if (next.type == "bezier") {
                            this._updateBezierPoints(next);
                        }
                    }
                }
            }
            else {
                if (strt.x != endPt.x && strt.y != endPt.y || (prev && prev._startPoint.x == endPt.x)) {
                    var extra = 20;
                    var tempx = endPt.x - (ctrlPoint1 ? ctrlPoint1.x : strt.x);
                    var tempy = endPt.y - (ctrlPoint1 ? ctrlPoint1.y : strt.y);
                    tempx = Math.abs(tempx) <= 0.0001 ? 0 : tempx;
                    tempy = Math.abs(tempy) <= 0.0001 ? 0 : tempy;
                    var ptsCount;
                    var twoPt;
                    switch (angle) {
                        case 0: if (endPt.x < strt.x) break;
                            twoPt = Math.abs(strt.x - endPt.x) < 30;
                            break;
                        case 180: if (endPt.x > strt.x) break;
                            twoPt = Math.abs(strt.x - endPt.x) < 30;
                            break;
                        case 90: if (endPt.y < strt.y) break; twoPt = Math.abs(strt.y - endPt.y) < 30; break;
                        case 270: if (endPt.y > strt.y) break;
                            twoPt = Math.abs(strt.y - endPt.y) < 30;
                            break;
                    }
                    if (!prev) {
                        if (twoPt) {
                            extra = (angle == 90 || angle == 270) ? Math.abs(strt.y - endPt.y) : Math.abs(strt.x - endPt.x);
                            ptsCount = 2;
                            if (extra < 10) { extra += 20; ptsCount = 3 }
                        }
                        else ptsCount = 3;
                        if (ptsCount != 2 || (Math.abs(tempy) > 1 && Math.abs(tempx) > 1))
                            var ctrlPoint1 = ej.datavisualization.Diagram.Geometry.transform(strt, angle, extra);
                    }
                    else ptsCount = (prev && prev._startPoint.x == endPt.x) ? 3 : (tempx == 0 || tempy == 0) ? 2 : 3;
                    if (ptsCount == 3) {
                        var direction = line._direction == "auto" ? prev ? prev._direction == "left" || prev.direction == "right" ? "left" : "top" : "bottom" : line._direction;
                        if ((direction == "left" || direction == "right") || tempy == 0) {
                            tempy = tempy > 0 ? tempy : -tempy;
                            var ctrlPoint2 = ej.datavisualization.Diagram.Geometry.transform(ctrlPoint1 || strt, 90, endPt.y - (ctrlPoint1 ? ctrlPoint1.y : strt.y));
                        }
                        else {
                            tempx = tempx > 0 ? tempx : -tempx;
                            var ctrlPoint2 = ej.datavisualization.Diagram.Geometry.transform(ctrlPoint1 || strt, 0, endPt.x - (ctrlPoint1 ? ctrlPoint1.x : strt.x));
                        }
                    }
                    if (ctrlPoint1) {
                        ctrlPoint1.x = Math.round(ctrlPoint1.x * 100) / 100;
                        ctrlPoint1.y = Math.round(ctrlPoint1.y * 100) / 100;
                        points.push(ctrlPoint1);
                    }
                    if (ctrlPoint2) {
                        ctrlPoint2.x = Math.round(ctrlPoint2.x * 100) / 100;
                        ctrlPoint2.y = Math.round(ctrlPoint2.y * 100) / 100;
                        points.push(ctrlPoint2);
                    }
                }
                line._direction = this._getBezierDirection(points[points.length - 1], endPt);
                points.push(endPt);
                line._endPoint = endPt;
                if (next) {
                    next._startPoint = line._endPoint;
                    if (!next.points) next.points = [];
                    next.points[0] = line._endPoint;
                    if (next.type == "bezier") {
                        this._updateBezierPoints(next);
                    }
                }
            }
            line.points = points;
            return angle;
        },
        _getOrthoDirection: function (src, point, prev) {
            if (!prev) {
                if (src.y < point.y) {
                    return "bottom";
                }
                else if (src.y > point.y) {
                    return "top";
                }
                else if (src.x < point.x) {
                    return "right";
                }
                else if (src.x > point.x) {
                    return "left";
                }
            }
            else {
                var tar = point;
                if (Math.abs(tar.x - src.x) > Math.abs(tar.y - src.y) && (prev && (prev._direction == "left" || prev._direction == "right"))) {
                    return src.x < tar.x ? "right" : "left";
                }
                else {
                    return src.y < tar.y ? "bottom" : "top";
                }
            }
        },
        _directionToAngle: function (direction) {
            var angles = { "right": 0, "left": 180, "top": 270, "bottom": 90, "auto": 90 };
            return angles[direction];
        },
        _resetOrthogonalPoints: function (line) {
            var points = [];
            points.push(line.sourcePoint);
            points.push(line.targetPoint);
            line.points = [];
            line.sourcePoint = points[0];
            line.points.push(points[0]);
            var ctrlPoints = this._constructOrthogonalPoints(points[0], points[1]);
            line.points.push(ctrlPoints[0]);
            line.points.push(ctrlPoints[1]);
            line.targetPoint = points[1];
            line.points.push(points[1]);
        },
        _updateBezierPoints: function (line, targetNode, targetPort, targetBounds, sourceNode, sourcePort, sourceBounds) {
            var bounds;
            var angles = { "right": 0, "left": 180, "top": 270, "bottom": 90 };
            if (line.vector1 || line.vector2) {
                if (line.vector1) {
                    line._point1 = ej.datavisualization.Diagram.Geometry.transform(line._startPoint, line.vector1.angle, line.vector1.distance);
                }
                if (line.vector2) {
                    line._point2 = ej.datavisualization.Diagram.Geometry.transform(line._endPoint, line.vector2.angle, line.vector2.distance);
                }
            }
            if ((line.point1 == null && !line.vector1) || (line.point2 == null && !line.vector2)) {
                var target = line._endPoint;
                var source = line._startPoint;
                var dir;
                var matrix;
                if (!sourcePort)
                    dir = this._getBezierDirection(source, target);
                else {
                    bounds = sourceBounds;
                    source = this._getPortPosition(sourcePort, bounds);
                    if (sourceNode.rotateAngle !== 0) {
                        matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, sourceNode.rotateAngle, sourceNode.offsetX, sourceNode.offsetY);
                        source = ej.Matrix.transform(matrix, source);
                    }
                    dir = this._getDirection(bounds, source, true);
                }
                if (!line.vector1)
                    line._point1 = line.point1 || this._getBezierAdjPoint(angles[dir], line._startPoint, line._endPoint);
                if (!targetPort) {
                    dir = this._getBezierDirection(target, source);
                }
                else {
                    bounds = targetBounds;
                    target = this._getPortPosition(targetPort, bounds);
                    if (targetNode.rotateAngle !== 0) {
                        matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, targetNode.rotateAngle, targetNode.offsetX, targetNode.offsetY);
                        target = ej.Matrix.transform(matrix, target);
                    }
                    dir = this._getDirection(bounds, target, true);
                }
                if (!line.vector2)
                    line._point2 = line.point2 || this._getBezierAdjPoint(angles[dir], line._endPoint, line._startPoint);
            }
        },
        _getBezierDirection: function (src, tar) {
            if (Math.abs(tar.x - src.x) > Math.abs(tar.y - src.y)) {
                return src.x < tar.x ? "right" : "left";
            }
            else {
                return src.y < tar.y ? "bottom" : "top";
            }
        },

        _findDocAngle: function (s, e) {
            var r = { x: e.x, y: s.y };
            var sr = this.findLength(s, r);
            var re = this.findLength(r, e);
            var es = this.findLength(e, s);
            var ang = Math.asin(re / es);
            ang = ang * 180 / Math.PI;
            if (s.x < e.x) {
                if (s.y < e.y) {

                }
                else {
                    ang = 360 - ang;
                }
            }
            else {
                if (s.y < e.y) {
                    ang = 180 - ang;
                }
                else {
                    ang = 180 + ang;
                }
            }
            return ang;

        },
        _getDirection: function (bounds, point, excludeBounds) {
            var center = bounds.center, fourty5, one35, two25, three15, dir, angle;
            if (excludeBounds) {
                //earlier implementation only for bezeir connector to get the bezeir angle.
                var points = bounds.points;
                var part = excludeBounds ? 45 : (180 / (2 + 2 / (bounds.height / bounds.width)));
                fourty5 = part;
                one35 = (180 - part);
                two25 = one35 + (2 * part);
                three15 = 360 - part;
                angle = ej.datavisualization.Diagram.Geometry.findAngle(point, center);
                if (angle > fourty5 && angle < one35) {
                    dir = "top";
                }
                else if (angle > one35 && angle < two25) {
                    dir = "right";
                }
                else if (angle > two25 && angle < three15) {
                    dir = "bottom";
                }
                else {
                    dir = "left";
                }
            }
            else {
                //source code have been derived from WPF source to get the dock angle.
                angle = this._findDocAngle(center, point);
                fourty5 = this._findDocAngle(center, bounds.bottomRight);
                one35 = this._findDocAngle(center, bounds.bottomLeft);
                two25 = this._findDocAngle(center, bounds.topLeft);
                three15 = this._findDocAngle(center, bounds.topRight);
                if (angle > two25 && angle < three15) {
                    dir = "top";
                }
                else if (angle >= fourty5 && angle < one35) {
                    dir = "bottom";
                }
                else if (angle >= one35 && angle <= two25) {
                    dir = "left";
                }
                else if (angle >= three15 || angle < fourty5) {
                    dir = "right";
                }
            }
            return dir;
        },
        _getBezierAdjPoint: function (angle, srcEnd, tarEnd) {
            var distance = 60;
            var endAdj = ej.datavisualization.Diagram.Point(0, 0);
            var dir;
            if (angle > 45 && angle < 135) {
                dir = "Bottom";
            }
            else if (angle > 135 && angle < 225) {
                dir = "Left";
            }
            else if (angle > 225 && angle < 315) {
                dir = "Top";
            }
            else {
                dir = "Right";
            }
            switch (dir) {
                case "Right":
                    distance = Math.min(Math.abs(srcEnd.x - tarEnd.x) * 0.45, distance);
                    endAdj = ej.datavisualization.Diagram.Point(srcEnd.x + distance, srcEnd.y);
                    break;
                case "Bottom":
                    distance = Math.min(Math.abs(srcEnd.y - tarEnd.y) * 0.45, distance);
                    endAdj = ej.datavisualization.Diagram.Point(srcEnd.x, srcEnd.y + distance);
                    break;
                case "Left":
                    distance = Math.min(Math.abs(srcEnd.x - tarEnd.x) * 0.45, distance);
                    endAdj = ej.datavisualization.Diagram.Point(srcEnd.x - distance, srcEnd.y);
                    break;
                case "Top":
                    distance = Math.min(Math.abs(srcEnd.y - tarEnd.y) * 0.45, distance);
                    endAdj = ej.datavisualization.Diagram.Point(srcEnd.x, srcEnd.y - distance);
                    break;
            }
            return endAdj;
        },
        _setLineEndPoint: function (connector, point, isTarget, dock) {
            var line = connector;
            point.x = Math.round(point.x * 100) / 100;
            point.y = Math.round(point.y * 100) / 100;
            if (isTarget) {
                var lastsegment = connector.segments[connector.segments.length - 1];
                line.targetPoint = point;
                if (lastsegment.type != "orthogonal") {
                    if (lastsegment.point) {
                        lastsegment.point = point;
                    }
                    lastsegment._point = point;
                }
                lastsegment.points[lastsegment.points.length - 1] = point;
                lastsegment._endPoint = point;
            }
            else {
                line.sourcePoint = point;
                var first = connector.segments[0];
                first.points[0] = point;
                first._startPoint = point;
                if (first.type == "orthogonal" && !connector.sourcePort && !connector._staticLength) {
                    if ((first.length || first.length === 0) && first.direction) {
                        if (first.points.length == 2) {
                            if (first._direction == "left" || first._direction == "right") {
                                first._endPoint.y = first._startPoint.y;
                                var length = Math.abs(first._startPoint.x - first._endPoint.x);
                            }
                            else {
                                first._endPoint.x = first._startPoint.x;
                                var length = Math.abs(first._startPoint.y - first._endPoint.y);
                            }
                            connector.segments[0]._length = length;
                            connector.segments[0].length = connector.segments[0]._length;
                            connector.segments[0].direction = connector.segments[0]._direction;
                        }
                    }
                }
            }
            var segment = isTarget ? connector.segments[connector.segments.length - 1] : connector.segments[0];
            if (segment.type === "orthogonal" && ((!isTarget && !connector.sourcePort) || isTarget && !connector.targetPort) && (!(connector.sourceNode && connector.targetNode) || connector.segments.length > 1)) {
                segment.points = [];
                this._addOrthogonalPoints(segment, isTarget ? connector.segments[connector.segments.length - 2] : null,
                    isTarget ? null : connector.segments[1], connector.sourcePoint, connector.targetPoint);
            }
            else if (segment.type === "bezier") {
                this._updateBezierPoints(segment);
            }
        },
        _setBezierPoint: function (segment, point, whichpoint) {
            if (whichpoint === "bezierpoint1") {
                if (segment.vector1) {
                    segment.vector1 = {
                        distance: ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, point),
                        angle: ej.datavisualization.Diagram.Geometry.findAngle(segment._startPoint, point),
                    };
                    segment._point1 = point;
                }
                else
                    segment.point1 = segment._point1 = point;
            }
            else {
                if (segment.vector2) {
                    segment.vector2 = {
                        distance: ej.datavisualization.Diagram.Geometry.distance(segment._endPoint, point),
                        angle: ej.datavisualization.Diagram.Geometry.findAngle(segment._endPoint, point),
                    };
                    segment._point2 = point;
                }
                else
                    segment.point2 = segment._point2 = point;
            }
        },
        _setPoints: function (line, points) {
            line.sourcePoint = line.points[0] = points[0];
            line.targetPoint = line.points[line.points.length - 1] = points[points.length - 1];
            line.points = points;
            if (line.type === "bezier") {
                line.point1 = points[2] || line.point1;
                line.point2 = points[3] || line.point2;
                if (!line.point1)
                    line._point1 = line.point1;
                if (!line.point2)
                    line._point2 = line.point2;
                this._updateBezierPoints(line);
            }
        },
        _updateConnectorSegments: function (connector, ignoreSource, ignoreTarget, diagram) {
            var runAngle;
            var startPoint = connector.sourcePoint;
            for (var i = 0; i < connector.segments.length; i++) {
                var segment = connector.segments[i];
                var prev = connector.segments[i - 1];
                var next = connector.segments[i + 1];
                segment._startPoint = prev ? prev._endPoint : startPoint;
                if (!(i == 0 && ignoreSource) && !(i == connector.segments.length - 1 && ignoreTarget)) {
                    if (segment.type == "orthogonal")
                        runAngle = ej.datavisualization.Diagram.Util._addOrthogonalPoints(segment, prev, next, connector.sourcePoint, connector.targetPoint, runAngle);
                    else {
                        runAngle = ej.datavisualization.Diagram.Geometry.findAngle(startPoint, segment._endPoint);
                        if (segment.type == "bezier") {
                            this._updateBezierPoints(segment);
                        }
                    }
                }
                startPoint = segment._endPoint;
            }
            if (diagram) {
                diagram._dock(connector, diagram.nameTable);
            }
        },
        _translateLine: function (connector, dx, dy) {
            for (var i = 0; i < connector.segments.length; i++) {
                var segment = connector.segments[i];
                for (var j = 0; j < segment.points.length; j++) {
                    if (j == 0) {
                        segment._startPoint = segment.points[j] = ej.datavisualization.Diagram.Geometry.translate(segment.points[j], dx, dy);
                        if (i == 0) {
                            connector.sourcePoint = segment._startPoint;
                        }
                    }
                    else if (j == segment.points.length - 1) {
                        segment._endPoint = segment.points[j] = ej.datavisualization.Diagram.Geometry.translate(segment.points[j], dx, dy);
                        if (i == connector.segments.length - 1)
                            connector.targetPoint = segment._endPoint;
                    }
                    else segment.points[j] = ej.datavisualization.Diagram.Geometry.translate(segment.points[j], dx, dy);
                }
                if (segment.type === ej.datavisualization.Diagram.Segments.Bezier) {
                    segment._point1 = ej.datavisualization.Diagram.Geometry.translate(segment._point1, dx, dy);
                    segment._point2 = ej.datavisualization.Diagram.Geometry.translate(segment._point2, dx, dy);
                    if (segment.point1) { segment.point1 = segment._point1; }
                    if (segment.point2) { segment.point2 = segment._point2; }
                    if (segment.point) {
                        segment.point = segment._endPoint;
                    }
                    segment._point = segment._endPoint;
                }
                else if (segment.type == "straight") {
                    if (segment.point) {
                        segment.point = segment._endPoint;
                    }
                    segment._point = segment._endPoint;
                }
            }
        },
        _adjustPoint: function (source, target, isStart, length) {
            var pt = isStart ? { x: source.x, y: source.y } : { x: target.x, y: target.y };
            if (source.x == target.x) {
                if (source.y < target.y && isStart || source.y > target.y && !isStart)
                    pt.y += length;
                else pt.y -= length;
            }
            else if (source.y == target.y) {
                if (source.x < target.x && isStart || source.x > target.x && !isStart)
                    pt.x += length;
                else pt.x -= length;
            }
            else {
                var angle;
                if (isStart) {
                    angle = ej.datavisualization.Diagram.Geometry.findAngle(source, target);
                    pt = ej.datavisualization.Diagram.Geometry.transform(source, angle, length);
                }
                else {
                    angle = ej.datavisualization.Diagram.Geometry.findAngle(target, source);
                    pt = ej.datavisualization.Diagram.Geometry.transform(target, angle, length);
                }
            }
            return pt;
        },
        _getIconPosition: function (icon, bounds, bExcludeBoundsLocation) {
            if (icon) {
                var marginX, marginY;
                marginX = icon.margin.left - icon.margin.right;
                marginY = icon.margin.top - icon.margin.bottom;
                var offsetX = icon.offset.x;
                var offsetY = icon.offset.y;
                if (bExcludeBoundsLocation) {
                    var point = ej.datavisualization.Diagram.Point(bounds.width * offsetX + marginX, bounds.height * offsetY + marginY);
                    if (point.x > bounds.width || point.y > bounds.height)
                        var point = ej.datavisualization.Diagram.Point(bounds.width * offsetX, bounds.height * offsetY);
                    return point;
                }

                else {
                    var x = bounds.center.x - bounds.width / 2 + (bounds.width * offsetX) + marginX;
                    var y = bounds.center.y - bounds.height / 2 + (bounds.height * offsetY) + marginY;
                    return ej.datavisualization.Diagram.Point(x, y);
                }
            }
        },
        _rBounds: function (object, rotateAngle) {
            var rect = {};
            if (object) {
                rect.x = object.x;
                rect.y = object.y;
                rect.width = object.width;
                rect.height = object.height;
                rect.rotateAngle = rotateAngle;
            }
            else
                rect = ej.datavisualization.Diagram.Rectangle();
            if (rect) {
                var bounds = {};
                rect.x = Math.round(rect.x * 100) / 100;
                rect.y = Math.round(rect.y * 100) / 100;
                rect.width = Math.round(rect.width * 100) / 100;
                rect.height = Math.round(rect.height * 100) / 100;
                bounds["width"] = rect.width;
                bounds["height"] = rect.height;
                bounds["x"] = bounds["left"] = rect.x;
                bounds["right"] = rect.x + rect.width;
                bounds["y"] = bounds["top"] = rect.y;
                bounds["bottom"] = rect.y + rect.height;
                bounds["center"] = { x: rect.x + rect.width / 2, y: rect.y + rect.height / 2 };
                bounds["topLeft"] = { x: rect.x, y: rect.y };
                bounds["topCenter"] = { x: rect.x + rect.width / 2, y: rect.y };
                bounds["topRight"] = { x: rect.x + rect.width, y: rect.y };
                bounds["middleLeft"] = { x: rect.x, y: rect.y + rect.height / 2 };
                bounds["middleRight"] = { x: rect.x + rect.width, y: rect.y + rect.height / 2 };
                bounds["bottomLeft"] = { x: rect.x, y: rect.y + rect.height };
                bounds["bottomCenter"] = { x: rect.x + rect.width / 2, y: rect.y + rect.height };
                bounds["bottomRight"] = { x: rect.x + rect.width, y: rect.y + rect.height };
                if (rect && rect.rotateAngle) {
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, rect.rotateAngle, rect.x + rect.width / 2, rect.y + rect.height / 2);
                    bounds.topLeft = ej.Matrix.transform(matrix, bounds.topLeft);
                    bounds.topCenter = ej.Matrix.transform(matrix, bounds.topCenter);
                    bounds.topRight = ej.Matrix.transform(matrix, bounds.topRight);
                    bounds.middleLeft = ej.Matrix.transform(matrix, bounds.middleLeft);
                    bounds.middleRight = ej.Matrix.transform(matrix, bounds.middleRight);
                    bounds.bottomLeft = ej.Matrix.transform(matrix, bounds.bottomLeft);
                    bounds.bottomCenter = ej.Matrix.transform(matrix, bounds.bottomCenter);
                    bounds.bottomRight = ej.Matrix.transform(matrix, bounds.bottomRight);
                    var rbounds = ej.datavisualization.Diagram.Geometry.rect([bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft]);
                    bounds.x = bounds.left = rbounds.x;
                    bounds.y = bounds.top = rbounds.y;
                    bounds.right = rbounds.x + rbounds.width;
                    bounds.bottom = rbounds.y + rbounds.height;
                    bounds.center = ej.datavisualization.Diagram.Point(rbounds.x + rbounds.width / 2, rbounds.y + rbounds.height / 2);
                    bounds.width = -(bounds.topLeft.x) + bounds.right
                    bounds.height = -(bounds.topRight.y) + bounds.bottom
                }
                bounds["points"] = [bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft];
                return bounds;
            }
            return rect;
        },
        _getLabelPosition: function (label, bounds, offset, isheaderY, isheaderX, text) {
            if (text) {
                var lBounds = text.getBBox();
                var rBounds = this._rBounds(lBounds, label.rotateAngle)
            }
            var x = bounds.width * (offset ? offset.x : label.offset.x);
            var y = bounds.height * (offset ? offset.y : label.offset.y);
            if (label.horizontalAlignment == "left")
                x += label.margin.left;
            else if (label.horizontalAlignment == "right")
                x -= label.margin.right;
            else
                x += label.margin.left - label.margin.right + (isheaderX ? -(((rBounds ? rBounds.width : bounds.width) / 2)) : 0);
            if (label.verticalAlignment == "top")
                y += label.margin.top;
            else if (label.verticalAlignment == "bottom")
                y -= label.margin.bottom;
            else
                y += label.margin.top - label.margin.bottom + (isheaderY ? label.fontSize / 2 : 0);
            return ej.datavisualization.Diagram.Point(x, y);
        },
        _getPortPosition: function (port, bounds, bExcludeBoundsLocation) {
            if (port) {
                var marginX = ((port.margin.left) ? (port.margin.left) : 0) + ((port.margin.right) ? (port.margin.right) : 0);
                var marginY = ((port.margin.top) ? (port.margin.top) : 0) + ((port.margin.bottom) ? (port.margin.bottom) : 0);
                if (bExcludeBoundsLocation) {
                    return ej.datavisualization.Diagram.Point(bounds.width * port.offset.x + marginX, bounds.height * port.offset.y + marginY);
                }
                else {
                    var x = bounds.center.x - bounds.width / 2 + (bounds.width * port.offset.x) + marginX;
                    var y = bounds.center.y - bounds.height / 2 + (bounds.height * port.offset.y) + marginY;
                    return ej.datavisualization.Diagram.Point(x, y);
                }
            }
        },
        _translate: function (node, dx, dy, nameTable, isContainer, diagram) {
            // if (ej.datavisualization.Diagram.Util.canMove(node))
            {
                if (!node.segments) {
                    node.offsetX += dx;
                    node.offsetY += dy;
                    if (node._type === "group" && !isContainer) {
                        var nodes = diagram._getChildren(node.children);
                        var child;
                        for (var i = 0; i < nodes.length; i++) {
                            child = nameTable[nodes[i]];
                            this._translate(child, dx, dy, nameTable, null, diagram);
                            if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], diagram);
                        }
                        if (node._type != "group" && node.container)
                            ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                    }
                } else {
                    ej.datavisualization.Diagram.Util._translateLine(node, dx, dy, node);
                }
            }
        },
        scale: function (node, sw, sh, pivot, nameTable, skipScalOnChild, updateMinMax, isHelper, diagram) {
            if (!node.container) {
                var matrix = ej.Matrix.identity();
                if (!node.segments) {
                    if (node._type === "group") {
                        var nodes = diagram._getChildren(node.children);
                        var child;
                        for (var i = 0; i < nodes.length; i++) {
                            child = nameTable[nodes[i]];
                            if (child) {
                                this.scale(child, sw, sh, pivot, nameTable);
                                if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                    ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], diagram);
                            }
                        }
                        ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                    } else {
                        ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                        ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                        ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                        var newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                        var width = node.width * sw;
                        var height = node.height * sh;
                        if (width > 1) {
                            node.width = width;
                            node.offsetX = newPosition.x;
                        }
                        if (height > 1) {
                            node.height = height;
                            node.offsetY = newPosition.y;
                        }
                    }
                } else {
                    ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                    for (var i = 0; i < node.segments.length; i++) {
                        var segment = node.segments[i];
                        for (var j = 0; j < segment.points.length; j++) {
                            segment.points[j] = ej.Matrix.transform(matrix, segment.points[j]);
                            if (i == 0 && j == 0 && !node.sourceNode) {
                                segment._startPoint = segment.points[0];
                                segment._endPoint = segment.points[segment.points.length - 1];
                                ej.datavisualization.Diagram.Util._setLineEndPoint(node, ej.Matrix.transform(matrix, node.sourcePoint), false);
                            }
                            if (i == node.segments.length - 1 && j == segment.points.length - 1 && !node.targetNode) {
                                segment._startPoint = segment.points[0];
                                segment._endPoint = segment.points[segment.points.length - 1];
                                node.targetPoint = segment._endPoint;
                            }
                        }
                        segment._startPoint = segment.points[0];
                        segment._endPoint = segment.points[segment.points.length - 1];
                        if (segment.type == "orthogonal") {
                            if (segment.length || segment.length === 0)
                                segment.length = segment._length = ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, segment._endPoint);
                            else
                                ej.datavisualization.Diagram.Util._addOrthogonalPoints(segment, node.segments[i - 1], node.segments[i + 1], node.sourcePoint, node.targetPoint);
                        } else {
                            if (segment.point) {
                                segment.point = segment._endPoint;
                            }
                            segment._point = segment._endPoint;
                        }
                    }
                }
            }
            else {
                switch (node.container.type) {
                    case "canvas":
                        var newSize = {};
                        var matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                        ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                        ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                        newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                        width = node.width * sw;
                        height = node.height * sh;
                        if (updateMinMax) {
                            node.minHeight = height;
                            node.minWidth = width;
                        }
                        if (isHelper != true)
                            newSize = diagram._getMinMaxSize(node, width, height);
                        else {
                            newSize.width = width;
                            newSize.height = height;
                        }
                        if (newSize && newSize.width > 1) {
                            var x = node.offsetX - node.width / 2;
                            node.width = newSize.width;
                            node.offsetX = x + node.width / 2;
                        }
                        if (newSize && newSize.height > 1) {
                            var y = node.offsetY - node.height / 2;
                            node.height = newSize.height;
                            node.offsetY = y + node.height / 2;
                        }
                        break;
                    case "stack":
                        var matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                        ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                        ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                        newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                        width = (node.width * sw) - (node.marginLeft + node.marginRight);
                        height = (node.height * sh) - (node.marginTop + node.marginBottom);
                        newSize = diagram._getMinMaxSize(node, width, height);
                        if (newSize.width > 1) {
                            x = node.offsetX - node.width / 2;
                            node.width = newSize.width - node.marginLeft;
                            node.offsetX = x + node.width / 2 + (node.marginLeft);
                        }
                        if (newSize.height > 1) {
                            y = node.offsetY - node.height / 2;
                            node.height = newSize.height - node.marginTop;
                            node.offsetY = y + node.height / 2 + (node.marginTop);
                        }
                        ej.datavisualization.Diagram.SvgContext._alignOnStack(node, diagram);
                        break;
                }
            }
        },
        _getIntersectingElement: function (diagram, bounds) {
            var quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(diagram._spatialSearch, bounds);
            var elements = [];
            for (var i = 0; i < quads.length; i++) {
                var quad = quads[i];
                if (quad.objects.length > 0) {
                    for (var j = 0; j < quad.objects.length; j++) {
                        var quadNode = quad.objects[j];
                        if (quadNode.visible) {
                            var nodebounds = ej.datavisualization.Diagram.Util.bounds(quadNode);
                            if (ej.datavisualization.Diagram.Geometry.intersectsRect(bounds, nodebounds)) {
                                quadNode = diagram._sortByZIndex(quadNode, true);
                                elements.push(quadNode);
                            }
                        }
                    }
                }
            }
            return elements;
        },
        _getIntersectingNodeElement: function (diagram, bounds) {
            var quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(diagram._spatialSearch, bounds);
            var elements = [];
            for (var i = 0; i < quads.length; i++) {
                var quad = quads[i];
                if (quad.objects.length > 0) {
                    for (var j = 0; j < quad.objects.length; j++) {
                        var quadNode = quad.objects[j];
                        if (quadNode.visible) {
                            var nodebounds = ej.datavisualization.Diagram.Util.bounds(quadNode);
                            if (ej.datavisualization.Diagram.Geometry.intersectsRect(bounds, nodebounds)) {
                                quadNode = diagram._sortByZIndex(quadNode, true);
                                if (!quadNode.segments)
                                    elements.push(quadNode);
                            }
                        }
                    }
                }
            }
            return elements;
        },
        _updateChildBounds: function (node, diagram) {
            var offX, offY, dx, dy;
            dx = node.width;
            dy = node.height;
            offX = node.offsetX;
            offY = node.offsetY;
            var childBounds = ej.datavisualization.Diagram.Util._getChildrenBounds(node, diagram);
            node.offsetX = childBounds.x + childBounds.width / 2;
            node.offsetY = childBounds.y + childBounds.height / 2;
            node.height = childBounds.height;
            node.width = childBounds.width;
            var deltaWidth = dx / node.width;
            var deltaHeight = dy / node.height;
            this.scale(node, deltaWidth, deltaHeight, node.pivot, diagram.nameTable, null, null, null, diagram);
            this._translate(node, offX - node.offsetX, offY - node.offsetY, diagram.nameTable, null, diagram);
        },
        _updateGroupBounds: function (node, diagram, needUpdate, angleChange) {
            var exWidth, exHeight, exOffX, exOffY;
            if (node && !node.container) {
                if (node && ((node.type === "pseudoGroup") || (node.children && node.children.length > 0))) {
                    exWidth = node.width;
                    exHeight = node.height;
                    exOffX = node.offsetX;
                    exOffY = node.offsetY;
                    if (angleChange)
                        this._updateRotateAngle(node, diagram.nameTable);
                    var bounds = this._getChildrenBounds(node, diagram, needUpdate);
                    var x = bounds.x + bounds.width * node.pivot.x;
                    var y = bounds.y + bounds.height * node.pivot.y;
                    var newposition = { x: x, y: y };
                    if (node.rotateAngle && (!diagram._isNodeInitializing || diagram._isGroupNode)) {
                        var matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, node.rotateAngle);
                        newposition = ej.Matrix.transform(matrix, newposition);
                    }
                    if (bounds) {
                        node.offsetX = newposition.x;
                        node.offsetY = newposition.y;
                        node.width = bounds.width;
                        node.height = bounds.height;
                    }
                    if (needUpdate) {
                        var child = null;
                        if (node.children && node.children.length > 0) {
                            for (var k = 0; k < node.children.length; k++) {
                                if (diagram._getChild(node.children[k]))
                                    child = diagram.nameTable[diagram._getChild(node.children[k])];
                                if (child) {
                                    if (child._type === "group" || (child.children && child.children.length > 0)) {
                                        this._updateGroupBounds(child, diagram, needUpdate);
                                    }
                                }
                            }
                        }
                        //update the initial size of the group
                        if (exWidth && exWidth != node.width)
                            diagram.scale(node, exWidth / node.width, 1, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), diagram.nameTable);
                        if (exHeight && exHeight != node.height)
                            diagram.scale(node, 1, exHeight / node.height, new ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), diagram.nameTable);
                        //update the initial offset of the group
                        if (exOffX && exOffX != node.offsetX)
                            diagram._translate(node, exOffX - node.offsetX, 1, diagram.nameTable);
                        if (exOffX && exOffY != node.offsetY)
                            diagram._translate(node, 1, exOffY - node.offsetY, diagram.nameTable);
                    }
                }
            }
        },
        _getChildrenBounds: function (group, diagram, needUpdate) {
            var children = diagram._getChildren(group.children), rect,
                bounds = ej.datavisualization.Diagram.Rectangle(), child;
            if (children.length > 0) {
                child = diagram.nameTable[children[0]];
                if (child)
                    bounds = this._rotateChildBounds(child, group, diagram);
            }
            for (var i = 0, len = children.length; i < len; i++) {
                child = diagram.nameTable[children[i]];
                if (child && (diagram.selectedItem || !child._isInternalShape)) {
                    if (child._type === "group") {
                        this._updateGroupBounds(child, diagram, needUpdate);
                        rect = this._rotateChildBounds(child, group, diagram);
                    } else
                        rect = this._rotateChildBounds(child, group, diagram);
                }
                if (rect)
                    bounds = ej.datavisualization.Diagram.Geometry.union(bounds, rect);
            }
            return bounds;
        },
        _updateRotateAngle: function (node, nameTable) {
            if (node.offsetX == 0 && node.offsetY == 0 && node.width == 0 && node.height == 0) {
                for (var i = 0; i < node.children.length; i++) {
                    var child = nameTable[node.children[i]];
                    if (child && !child.segments && !node.rotateAngle) {
                        node.rotateAngle = child.rotateAngle;
                        return;
                    }
                }
            }
        },
        _rotateChildBounds: function (child, group, diagram) {
            if (child.segments || ((group.rotateAngle || child.rotateAngle) && (!diagram._isNodeInitializing || diagram._isGroupNode))) {
                var bounds = this.bounds(child);
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, -group.rotateAngle);
                var topleft = ej.Matrix.transform(matrix, bounds.topLeft);
                var topright = ej.Matrix.transform(matrix, bounds.topRight);
                var bottomLeft = ej.Matrix.transform(matrix, bounds.bottomLeft);
                var bottomRight = ej.Matrix.transform(matrix, bounds.bottomRight);
                var x = Math.min(topleft.x, topright.x, bottomLeft.x, bottomRight.x);
                var y = Math.min(topleft.y, topright.y, bottomLeft.y, bottomRight.y);
                return {
                    x: x,
                    width: Math.max(topleft.x, topright.x, bottomLeft.x, bottomRight.x) - x,
                    y: y,
                    height: Math.max(topleft.y, topright.y, bottomLeft.y, bottomRight.y) - y
                };
            }
            return {
                x: child.offsetX - (child.width || child._width) * child.pivot.x, y: child.offsetY - (child.height || child._height) * child.pivot.y,
                width: child.width || child._width, height: child.height || child._height
            };
        },
        updateBridging: function (connector, diagram, intersectingConnectors) {
            var bounds, bounds1;
            var lstBridge = [];
            if (intersectingConnectors && intersectingConnectors.length) {
                if (connector.segments.length > 0) {
                    for (var m = 0; m < connector.segments.length; m++) {
                        var segmentBridges = connector.segments[m]._bridges;
                        for (var n = 0; n < segmentBridges.length; n++) {
                            if (segmentBridges[n]._target == intersectingConnectors[0].name)
                                segmentBridges.splice(n, 1);
                            else if (this.findLength(segmentBridges[n].startPoint, segmentBridges[n].endPoint) > intersectingConnectors[0].bridgeSpace) {
                                if (diagram.nameTable[segmentBridges[n]._target]) intersectingConnectors.push(diagram.nameTable[segmentBridges[n]._target]);
                                segmentBridges.splice(n, 1);
                            }
                        }
                    }
                }
            }
            else if (connector.segments.length > 0) {
                for (var m = 0; m < connector.segments.length; m++) {
                    connector.segments[m]._bridges = [];
                }
            }
            connector._intersects = [];
            if (ej.datavisualization.Diagram.Util.canBridge(connector, diagram)) {
                var points1 = this.getPoints(connector);
                var bridgeSpacing = connector.bridgeSpace;
                var bridgeDirection = diagram.bridgeDirection();
                var count = -1;
                bounds = intersectingConnectors && diagram.boundaryTable[connector.name] ? diagram.boundaryTable[connector.name] : ej.datavisualization.Diagram.Util.bounds(connector);
                diagram.boundaryTable[connector.name] = bounds;
                var quads = intersectingConnectors ? intersectingConnectors : diagram._getConnectors();
                if (quads.length > 0) {
                    for (var q = 0; q < quads.length; q++) {
                        var connector1 = quads[q];
                        if ((connector && connector.segments && connector.segments.length > 0 && connector.segments[0].type != "bezier") && (connector1 && connector1.segments && connector1.segments.length > 0 && connector1.segments[0].type != "bezier") &&
                            (connector1.segments && connector1.visible) && connector.name !== connector1.name) {
                            bounds1 = diagram.boundaryTable[connector1.name] ? diagram.boundaryTable[connector1.name] : ej.datavisualization.Diagram.Util.bounds(connector1);
                            diagram.boundaryTable[connector1.name] = bounds1;
                            if (ej.datavisualization.Diagram.Geometry.intersectsRect(bounds, bounds1)) {
                                var points2 = this.getPoints(connector1);
                                var intersectPts = this.interSect(points1, points2, false, diagram, true);
                                connector._intersects.push(connector1.name);
                                /* Start For Loop */
                                if (intersectPts.length > 0) {
                                    for (var i = 0; i < intersectPts.length; i++) {
                                        var fullLength = 0;
                                        var segmentIndex = 0;
                                        var length = 0;
                                        var pointIndex = 0;
                                        var obj = this.getLengthAtFractionPoint(connector, intersectPts[i]);
                                        length = obj.lengthAtFractionPt, fullLength = obj.fullLength, segmentIndex = obj.segmentIndex, pointIndex = obj.pointIndex;
                                        if (segmentIndex < 0) {
                                            continue;
                                        }
                                        if (connector.segments[0]) {
                                            var startBridge, endBridge;
                                            var fractLength = (length - (bridgeSpacing / 2)) / fullLength;
                                            startBridge = this.getPointAtLength((length - (bridgeSpacing / 2)), points1);
                                            fractLength = (length + (bridgeSpacing / 2)) / fullLength;
                                            endBridge = this.getPointAtLength((length + (bridgeSpacing / 2)), points1);
                                            if (ej.datavisualization.Diagram.Geometry.isEmptyPoint(endBridge))
                                                endBridge = startBridge;
                                            var start, end;
                                            if (segmentIndex === 0) {
                                                start = connector.sourcePoint;
                                            }
                                            else {
                                                start = connector.segments[segmentIndex - 1]._endPoint;
                                            }
                                            if (connector.segments[segmentIndex].type === "straight")
                                                end = connector.segments[segmentIndex]._point;
                                            else
                                                end = connector.segments[segmentIndex].points[pointIndex];
                                            var angle = this._findAngle(start, end);
                                            if (lstBridge.length > segmentIndex && lstBridge[segmentIndex] != null) {
                                                var fixedPoint;
                                                if (segmentIndex === 0) {
                                                    fixedPoint = connector.sourcePoint;
                                                }
                                                else {
                                                    fixedPoint = connector.segments[segmentIndex - 1]._endPoint;
                                                }
                                                var fix = Math.abs(this.findLength(fixedPoint, endBridge));
                                                var var1 = 0;
                                                var insertAt = -1;
                                                count = -1;
                                                for (var k = 0; k < lstBridge[segmentIndex].bridges.length; k++) {
                                                    count++;
                                                    var arcSeg = lstBridge[segmentIndex].bridges[k];
                                                    var1 = Math.abs(this.findLength(fixedPoint, arcSeg.endPoint));
                                                    if (fix < var1) {
                                                        insertAt = count;
                                                        break;
                                                    }
                                                }
                                                if (insertAt >= 0) {
                                                    var paths;
                                                    paths = this.createSegment(startBridge, endBridge, angle, bridgeDirection, pointIndex, connector, diagram);
                                                    paths._target = connector1.name;
                                                    lstBridge[segmentIndex].bridges.splice(insertAt, 0, paths);
                                                    lstBridge[segmentIndex].bridges.join();
                                                    lstBridge[segmentIndex].bridgeStartPoint.splice(insertAt, 0, startBridge);
                                                    lstBridge[segmentIndex].bridgeStartPoint.join();
                                                    lstBridge[segmentIndex].segmentIndex = segmentIndex;
                                                }
                                                else {
                                                    var paths = this.createSegment(startBridge, endBridge, angle, bridgeDirection, pointIndex, connector, diagram);
                                                    paths._target = connector1.name;
                                                    lstBridge[segmentIndex].bridges.push(paths);
                                                    lstBridge[segmentIndex].bridgeStartPoint.push(startBridge);
                                                    lstBridge[segmentIndex].segmentIndex = segmentIndex;
                                                }
                                            }
                                            else {
                                                if (!isNaN(startBridge.x) && !isNaN(startBridge.y) && !ej.datavisualization.Diagram.Geometry.isEmptyPoint(endBridge)) {
                                                    var arcs = this.createSegment(startBridge, endBridge, angle, bridgeDirection, pointIndex, connector, diagram);
                                                    arcs._target = connector1.name;
                                                    var stPoints = [];
                                                    var edPoints = [];
                                                    stPoints.push(startBridge);
                                                    edPoints.push(endBridge);
                                                    if (lstBridge.length < segmentIndex + 1) {
                                                    }
                                                    lstBridge[segmentIndex] = $.extend(true, {}, ej.datavisualization.Diagram.BridgeSegments, {});
                                                    lstBridge[segmentIndex].bridges.push(arcs);
                                                    lstBridge[segmentIndex].bridgeStartPoint = stPoints;
                                                    lstBridge[segmentIndex].segmentIndex = segmentIndex;
                                                }
                                            }
                                        }
                                    }
                                }
                                /* End For Loop */
                            }
                        }
                    }
                }
                if (intersectingConnectors && intersectingConnectors.length) {
                    if (connector.segments.length > 0) {
                        for (var m = 0; m < connector.segments.length; m++) {
                            var segment = connector.segments[m];
                            var segmentBridges = connector.segments[m]._bridges;
                            if (!lstBridge[m]) {
                                lstBridge[m] = $.extend(true, {}, ej.datavisualization.Diagram.BridgeSegments);
                                lstBridge[m].segmentIndex = m;
                            }
                            lstBridge[m].bridges = lstBridge[m].bridges.concat(segmentBridges).sort(function (a, b) {
                                if (segment._startPoint.x != segment._endPoint.x)
                                    return segment._startPoint.x < segment._endPoint.x ? a.startPoint.x - b.startPoint.x : b.startPoint.x - a.startPoint.x;
                                else
                                    return segment._startPoint.y < segment._endPoint.y ? a.startPoint.y - b.startPoint.y : b.startPoint.y - a.startPoint.y;
                            });
                            lstBridge[m].bridgeStartPoint = lstBridge[m].bridges.map(function (e) { return e.startPoint });
                            connector.segments[m]._bridges = [];
                        }
                    }
                }
                if (lstBridge.length != 0) {
                    for (var i = 0; i < lstBridge.length; i++) {
                        var bridge = lstBridge[i];
                        if (!bridge)
                            continue;
                        for (var k = 1; k < bridge.bridges.length; k++) {
                            if (this.findLength(bridge.bridges[k].endPoint, bridge.bridges[k - 1].endPoint) < bridgeSpacing) {
                                bridge.bridges[k - 1].endPoint = bridge.bridges[k].endPoint;
                                var subBridge = bridge.bridges[k - 1];
                                var arc = diagram.getBridgeSegment(subBridge.startPoint, subBridge.endPoint, subBridge.angle, bridgeSpacing, subBridge.sweep);
                                bridge.bridges[k - 1].path = arc;
                                if (intersectingConnectors && intersectingConnectors.length && bridge.bridges[k - 1]._target == intersectingConnectors[0].name)
                                    bridge.bridges[k - 1]._target = bridge.bridges[k]._target;
                                bridge.bridges.splice(k, 1);
                                bridge.bridgeStartPoint.splice(k, 1);
                                k--;
                            }
                        }
                        var pre = connector.sourcePoint;
                        for (var j = 0; j < bridge.bridges.length; j++) {
                            var subBridge = bridge.bridges[j];
                            var preventChecking = true;
                            for (var k = 0; intersectingConnectors && k < intersectingConnectors.length; k++)
                                if (subBridge._target == intersectingConnectors[k].name)
                                    preventChecking = false;
                            if (!preventChecking) {
                                var end;
                                if (connector.segments[bridge.segmentIndex].type === "straight")
                                    end = connector.segments[bridge.segmentIndex]._endPoint;
                                else if (connector.segments[bridge.segmentIndex].type === "orthogonal")
                                    end = connector.segments[bridge.segmentIndex].points[subBridge.segmentPointIndex];
                                if (segmentIndex != 0)
                                    pre = connector.segments[bridge.segmentIndex]._endPoint;
                                var rectPoints = [];
                                rectPoints.push(ej.datavisualization.Diagram.Point(end.x - bridgeSpacing, end.y - bridgeSpacing));
                                rectPoints.push(ej.datavisualization.Diagram.Point(end.x + bridgeSpacing, end.y + bridgeSpacing));
                                var rect = ej.datavisualization.Diagram.Geometry.rect(rectPoints);
                                rectPoints = [];
                                rectPoints.push(ej.datavisualization.Diagram.Point(pre.x - bridgeSpacing, pre.y - bridgeSpacing));
                                rectPoints.push(ej.datavisualization.Diagram.Point(pre.x + bridgeSpacing, pre.y + bridgeSpacing));
                                var rect1 = ej.datavisualization.Diagram.Geometry.rect(rectPoints);
                                if (!ej.datavisualization.Diagram.Geometry.containsPoint(rect, bridge.bridgeStartPoint[j]) &&
                                    !ej.datavisualization.Diagram.Geometry.containsPoint(rect1, subBridge.endPoint)) {
                                    connector.segments[bridge.segmentIndex]._bridges.push(subBridge);
                                    pre = subBridge.endPoint;
                                }
                            }
                            else {
                                connector.segments[bridge.segmentIndex]._bridges.push(subBridge);
                                pre = subBridge.endPoint;
                            }
                        }
                    }
                }
            }
        },
        createSegment: function (start, end, angle, bridgeDirection, segmentPointIndex, connector, diagram) {
            var arc, sweep;
            //var pathSegment = ej.datavisualization.Diagram.Util.cloneObject(ej.datavisualization.Diagram.PathSegment);
            var pathSegment = $.extend(true, {}, ej.datavisualization.Diagram.PathSegment);
            sweep = this.sweepDirection(angle, bridgeDirection, connector, diagram);
            arc = diagram.getBridgeSegment(start, end, angle, connector.bridgeSpace, sweep);
            pathSegment.path = arc;
            pathSegment.startPoint = start;
            pathSegment.endPoint = end;
            pathSegment.angle = angle;
            pathSegment.segmentPointIndex = segmentPointIndex;
            pathSegment.sweep = sweep;
            return pathSegment;
        },
        sweepDirection: function (angle, bridgeDirection, connector, diagram) {
            var angle1 = Math.abs(angle);
            if (bridgeDirection === "top" || bridgeDirection === "bottom") {
                var sweep = 1;
                if (angle1 >= 0 && angle1 <= 90) {
                    sweep = 0;
                }
            }
            else if (bridgeDirection === "right" || bridgeDirection === "left") {
                var sweep = 1;
                if (angle < 0 && angle >= -180) {
                    sweep = 0;
                }
            }
            if (bridgeDirection === "right" || bridgeDirection === "bottom") {
                if (sweep === 0)
                    sweep = 1;
                else
                    sweep = 0;
            }
            return sweep;
        },
        getPointAtLength: function (length, pts) {
            var run = 0;
            var pre = null;
            var found = ej.datavisualization.Diagram.Point(0, 0);
            for (var i = 0; i < pts.length; i++) {
                var pt = pts[i];
                if (!pre) {
                    pre = pt;
                    continue;
                }
                else {
                    var l = this.findLength(pre, pt);
                    if (run + l > length) {
                        var r = length - run;
                        var deg = this.findAngle(pre, pt);
                        var x = r * Math.cos(deg * Math.PI / 180);
                        var y = r * Math.sin(deg * Math.PI / 180);
                        found = ej.datavisualization.Diagram.Point(pre.x + x, pre.y + y);
                        break;
                    }
                    else {
                        run += l;
                    }
                }
                pre = pt;
            }
            return found;
        },
        getLengthAtFractionPoint: function (connector, pointAt) {
            var confirm = 100, fullLength = 0, segmentIndex = -1, count = 0, lengthAtFractionPt = 0, pointIndex = -1;
            if (connector.segments === null)
                return 0;
            var segments = connector.segments;
            var pt1 = connector.sourcePoint;
            var previouspt2 = pt1;
            for (var i = 0; i < connector.segments.length; i++) {
                var points = [];
                var segment1 = connector.segments[i];
                for (var j = 0; j < segment1.points.length; j++) {
                    var point2 = segment1.points[j];
                    points.push(point2);
                }
                for (var j = 0; j < points.length; j++) {
                    var pt2 = points[j];
                    var suspect = this.getSlope(pt2, pt1, pointAt, connector);
                    if (suspect < confirm) {
                        confirm = suspect;
                        lengthAtFractionPt = fullLength + this.findLength(pointAt, previouspt2);
                        segmentIndex = count;
                        pointIndex = j;
                    }
                    fullLength += this.findLength(pt2, pt1);
                    pt1 = pt2;
                    previouspt2 = pt2;
                }
                count++;
            }
            return { "lengthAtFractionPt": lengthAtFractionPt, "fullLength": fullLength, "segmentIndex": segmentIndex, "pointIndex": pointIndex };
        },
        getSlope: function (startPt, endPt, point, connector) {
            var three = 3.0;
            var delX = Math.abs(startPt.x - endPt.x);
            var delY = Math.abs(startPt.y - endPt.y);
            var lhs = ((point.y - startPt.y) / (endPt.y - startPt.y));
            var rhs = ((point.x - startPt.x) / (endPt.x - startPt.x));
            if (!isFinite(lhs) || !isFinite(rhs) || isNaN(lhs) || isNaN(rhs)) {
                if (startPt.x === endPt.x) {
                    if (startPt.y === endPt.y) {
                        return 10000;
                    }
                    else if (((startPt.y > point.y) && (point.y > endPt.y)) || ((startPt.y < point.y) && (point.y < endPt.y))) {
                        return Math.abs(startPt.x - point.x);
                    }
                    else {
                        return 10000;
                    }
                }
                else if (startPt.y == endPt.y) {
                    if (((startPt.x > point.x) && (point.x > endPt.x)) || ((startPt.x < point.x) && (point.x < endPt.x))) {
                        return Math.abs(startPt.y - point.y);
                    }
                    else {
                        return 10000;
                    }
                }
                else {
                    return 10000;
                }
            }
            else if (connector.segments.length > 0) {
                if ((startPt.x >= point.x && point.x >= endPt.x) || (startPt.x <= point.x && point.x <= endPt.x) || delX < three) {
                    if ((startPt.y >= point.y && point.y >= endPt.y) || (startPt.y <= point.y && point.y <= endPt.y) || delY < three) {
                        return Math.abs(lhs - rhs);
                    }
                    else {
                        return 10000;
                    }
                }
                else {
                    return 10000;
                }
            }
            else {
                return 10000;
            }
        },
        getPoints: function (connector) {
            var points = [];
            // points.push(connector.sourcePoint);
            if (connector.segments.length > 0) {
                for (var i = 0; i < connector.segments.length; i++) {
                    var segment = connector.segments[i];
                    if (segment.type === "straight" || segment.type === "bezier") {
                        if (i === 0)
                            points.push(connector.sourcePoint);
                        if (segment._point)
                            points.push(segment._point);
                    }
                    else if (segment.type === "orthogonal") {
                        for (var j = 0; j < connector.segments[i].points.length; j++) {
                            points.push(connector.segments[i].points[j]);
                        }
                    }
                }
            }
            return points;
        },
        interSect: function (points1, points2, self, diagram, zOrder) {
            if (self && points2.length >= 2) {
                points2.splice(0, 1);
                points2.splice(0, 1);
            }
            var points = [];
            var bridgeDirection = diagram.bridgeDirection();
            for (var i = 0; i < points1.length - 1; i++) {
                var pt = this.interSect1(points1[i], points1[i + 1], points2, diagram, zOrder, bridgeDirection);
                if (pt.length > 0) {
                    for (var k = 0; k < pt.length; k++) {
                        points.push(pt[k]);
                    }
                }
                if (self && points2.length >= 1) {
                    points2.splice(0, 1);
                }
            }
            return points;
        },
        checkforHorizontalLine: function (angle) {
            var temp = 0;
            var ang = Math.abs(angle);
            if (ang > 90) {
                temp = 180 - ang;
            }
            else {
                temp = ang;
            }
            return temp;
        },
        interSect1: function (startPoint, endPoint, points, diagram, zOrder, bridgeDirection) {
            var points1 = [];
            for (var i = 0; i < points.length - 1; i++) {
                var point = this.interSect2(startPoint, endPoint, points[i], points[i + 1]);
                if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(point)) {
                    var angle = this._findAngle(startPoint, endPoint);
                    var angle1 = this._findAngle(points[i], points[i + 1]);
                    angle = this.checkforHorizontalLine(angle);
                    angle1 = this.checkforHorizontalLine(angle1);
                    if (bridgeDirection === "left" || bridgeDirection === "right") {
                        if (angle > angle1) {
                            points1.push(point);
                        }
                    }
                    else if (bridgeDirection === "top" || bridgeDirection === "bottom") {
                        if (angle < angle1) {
                            points1.push(point);
                        }
                    }
                    if (angle === angle1 && zOrder) {
                        points1.push(point);
                    }
                }
            }
            return points1;
        },
        interSect2: function (start1, end1, start2, end2) {
            var lineUtil1 = ej.datavisualization.Diagram.LineUtil(start1.x, start1.y, end1.x, end1.y);
            var lineUtil2 = ej.datavisualization.Diagram.LineUtil(start2.x, start2.y, end2.x, end2.y);
            var line3 = this.interSect3(lineUtil1, lineUtil2);
            if (line3.enabled) {
                return line3.intersectPt;
            }
            else {
                return ej.datavisualization.Diagram.Point(0, 0);
            }
        },
        interSect3: function (lineUtil1, lineUtil2) {
            var point = ej.datavisualization.Diagram.Point(0, 0);
            var l1 = lineUtil1;
            var l2 = lineUtil2;
            var d = (l2.y2 - l2.y1) * (l1.x2 - l1.x1) - (l2.x2 - l2.x1) * (l1.y2 - l1.y1);
            var n_a = (l2.x2 - l2.x1) * (l1.y1 - l2.y1) - (l2.y2 - l2.y1) * (l1.x1 - l2.x1);
            var n_b = (l1.x2 - l1.x1) * (l1.y1 - l2.y1) - (l1.y2 - l1.y1) * (l1.x1 - l2.x1);
            if (d == 0)
                return { enabled: false, intersectPt: point };
            var ua = n_a / d;
            var ub = n_b / d;
            if (ua >= 0 && ua <= 1 && ub >= 0 && ub <= 1) {
                point.x = l1.x1 + (ua * (l1.x2 - l1.x1));
                point.y = l1.y1 + (ua * (l1.y2 - l1.y1));
                return { enabled: true, intersectPt: point };
            }
            return { enabled: false, intersectPt: point };
        },
        findLength: function (startPt, endPt) {
            try {
                var length = Math.sqrt(((startPt.x - endPt.x) * (startPt.x - endPt.x)) + ((startPt.y - endPt.y) * (startPt.y - endPt.y)));
                return length;
            }
            catch (e) {
                throw e;
            }
        },
        _findAngle: function (startPt, endPt) {
            var xDiff = startPt.x - endPt.x; var yDiff = startPt.y - endPt.y;
            return Math.atan2(yDiff, xDiff) * (180 / Math.PI);
        },
        findAngle: function (startPt, endPt) {
            if (ej.datavisualization.Diagram.Geometry.isEqualPoint(startPt, endPt))
                return 0;
            var r = ej.datavisualization.Diagram.Point(endPt.x, startPt.y);
            var sr = this.findLength(startPt, r);
            var re = this.findLength(r, endPt);
            var es = this.findLength(endPt, startPt);
            var ang = Math.asin(re / es);
            ang = ang * 180 / Math.PI;
            if (startPt.x < endPt.x) {
                if (startPt.y < endPt.y) {
                }
                else {
                    ang = 360 - ang;
                }
            }
            else {
                if (startPt.y < endPt.y) {
                    ang = 180 - ang;
                }
                else {
                    ang = 180 + ang;
                }
            }
            return ang;
        },
        _mapPalettePhase: function (item) {
            var sPoint, ePoint;
            if (item.orientation && item.orientation == "horizontal") {
                sPoint = { x: 0, y: 0 };
                ePoint = { x: 40, y: 0 };
            }
            else {
                sPoint = { x: 0, y: 0 };
                ePoint = { x: 0, y: 40 };
            }
            var phase = ej.datavisualization.Diagram.Connector({
                name: item ? item.name : ej.datavisualization.Diagram.Util.randomId(),
                segments: [{ type: "straight" }], sourcePoint: { x: sPoint.x, y: sPoint.y }, targetPoint: { x: ePoint.x, y: ePoint.y },
                lineWidth: item.lineWidth ? item.lineWidth : 1,
                lineDashArray: item.lineDashArray ? item.lineDashArray : null,
                lineColor: item.lineColor ? item.lineColor : "#606060",
                targetDecorator: { shape: "none" },
                isPhase: true,
                orientation: item.orientation ? item.orientation : "horizontal",
                labels: item.label ? [item.label] : [],
                paletteItem: item.paletteItem ? item.paletteItem : null,
            });
            return phase;
        },
        _updateShapeProperties: function (options) {
            options._type = "node";
            if (!options.shape.type) options.shape.type = "rectangle";
            switch (options.shape.type) {
                case "rectangle":
                    options.type = "basic";
                    options._shape = options.shape.type;
                    if (options.shape.cornerRadius)
                        options.cornerRadius = options.shape.cornerRadius;
                    break;
                case "ellipse":
                    options.type = "basic";
                    options._shape = options.shape.type;
                    break;
                case "path":
                    options.type = "basic";
                    options._shape = options.shape.type;
                    options.pathData = options.shape.pathData;
                    break;
                case "polygon":
                    options.type = "basic";
                    options._shape = options.shape.type;
                    options.points = options.shape.points;
                    break;
                case "image":
                    options.type = "image";
                    options._shape = options.shape.type;
                    options.source = options.shape.src;
                    break;
                case "native":
                    options.type = "native";
                    options._shape = options.shape.type;
                    options.templateId = options.shape.templateId;
                    break;
                case "text":
                    options.type = "text";
                    options._shape = options.shape.type;
                    options.textBlock = options.shape.textBlock;
                    break;
                case "html":
                    options.type = "html";
                    options._shape = options.shape.type;
                    options.templateId = options.shape.templateId;
                    break;
                default:
                    break;
            }
        },
        _refreshParentGroup: function (node, diagram) {
            var parentObj = diagram.nameTable[node.parent];
            if (parentObj) {
                this._updateGroupBounds(parentObj, diagram);
                var parent = parentObj.parent ? document.getElementById(parentObj.parent) : diagram._diagramLayer;
                ej.datavisualization.Diagram.DiagramContext.renderGroup(parentObj, diagram);
                diagram._raiseGroupChangeEvent(node, undefined, parentObj, "group");
            }
        },
        intersectsWith: function (rect, point1, point2) {
            var point = point1;
            var success = ((((rect.x < point.x) && (point.x < (rect.x + rect.width)))
           && (rect.y < point.y)) && (point.y < (rect.y + rect.height)));
            return success;
        },
        _findOffsetOnConnector: function (connector, handle, offset, diagram) {
            var length = 0;
            var lengths = [];
            //find connector length
            for (var i = 0; i < connector.segments.length; i++) {
                lengths[i] = [];
                for (var j = 0; j < connector.segments[i].points.length - 1; j++) {
                    length += ej.datavisualization.Diagram.Geometry.distance(connector.segments[i].points[j], connector.segments[i].points[j + 1]);
                    lengths[i][j] = length;
                }
            }
            var targetNode = connector.sourceNode && handle.offset == 0 && diagram.nameTable[connector.sourceNode] ||
                connector.targetNode && handle.offset == 1 && diagram.nameTable[connector.targetNode];
            var bnds = targetNode ? this.bounds(targetNode) : null;
            var offset = handle.segmentOffset || 0;
            var prevLength, targetSegment, angle, pt;
            //offset length
            var offLength = length * offset;
            for (var i = 0; i < lengths.length; i++) {
                for (var j = 0; j < lengths[i].length; j++) {
                    //segment where offset lies 
                    if (lengths[i][j] >= offLength) {
                        targetSegment = connector.segments[i];
                        angle = ej.datavisualization.Diagram.Geometry.findAngle(targetSegment.points[j], connector.segments[i].points[j + 1]);
                        pt = ej.datavisualization.Diagram.Geometry.transform(targetSegment.points[j], angle, offLength - (prevLength || 0));
                        var endPt;
                        if (targetNode) {
                            if (this.intersectsWith(bnds, pt) && !ej.datavisualization.Diagram.Geometry.containsRect(bnds, this.bounds(connector))) {
                                var direction = handle.offset == 0 ? this._getBezierDirection(targetSegment.points[j], connector.segments[i].points[j + 1])
                                    : this._getBezierDirection(targetSegment.points[j + 1], connector.segments[i].points[j]);
                                endPt = handle.offset == 0 ? targetSegment.points[j + 1] : targetSegment.points[j];
                                var skip = false;
                                switch (direction) {
                                    case "top":
                                        if (bnds.y > endPt.y)
                                            pt.y = bnds.top;
                                        else {
                                            skip = true;
                                        }
                                        break;
                                    case "bottom":
                                        if (bnds.bottom < endPt.y)
                                            pt.y = bnds.bottom;
                                        else {
                                            skip = true;
                                        }
                                        break;
                                    case "right":
                                        if (bnds.right < endPt.x)
                                            pt.x = bnds.right;
                                        else {
                                            skip = true;
                                        }
                                        break;
                                    case "left":
                                        if (bnds.left > endPt.x)
                                            pt.x = bnds.left;
                                        else {
                                            skip = true;
                                        }
                                        break;
                                }
                                if (skip) {
                                    offLength = handle.offset == 1 ? (prevLength || 0) : lengths[i][j];
                                    prevLength = handle.offset == 0 ? lengths[i][j] : (lengths[i][j - 2] || (
                                        lengths[i - 1] && lengths[i - 1].length > 1 ? lengths[i - 1][lengths[i - 1].length - 1] : lengths[i - 2] && lengths[i - 2][lengths[i - 2].length - 1]) || 0);
                                    handle.offset == 0 ? i = i : !j ? i -= 2 : j -= 2;
                                    continue;
                                }
                            } return { segment: i, point: j, offset: { x: pt.x, y: pt.y } };
                        }
                        else return { segment: i, point: j, offset: { x: pt.x, y: pt.y } };
                    }
                    prevLength = lengths[i][j];
                }
            }
        },
        _alignLabelOnSegments: function (node, label, diagram, obj) {
            var angle = obj.angle % 360;
            obj.angle %= 360;
            var fourty5 = 45;
            var one35 = 135;
            var two25 = 225;
            var three15 = 315;
            var bnds;
            if (label.segmentOffset == 0 && node.sourceNode || label.segmentOffset == 1 && node.targetNode) {
                var source = label.segmentOffset == 0 && node.sourceNode ? diagram.nameTable[node.sourceNode] : diagram.nameTable[node.targetNode];
                if (source) bnds = this.bounds(source);
                if (bnds) {
                    var part = 180 / (2 + 2 / (bnds.height / bnds.width));
                    fourty5 = part;
                    one35 = (180 - part);
                    two25 = one35 + (2 * part);
                    three15 = 360 - part;
                }
            }
            var hAlign, vAlign;
            switch (label.alignment) {
                case "before":
                    if (obj.angle >= fourty5 && obj.angle <= one35) { hAlign = "right"; vAlign = label.segmentOffset == 0.5 ? "center" : "top" }
                    else if (obj.angle >= two25 && obj.angle <= three15) { hAlign = "left"; vAlign = label.segmentOffset == 0.5 ? "center" : "bottom" }
                    else if (obj.angle > fourty5 && obj.angle < two25) { vAlign = "top"; hAlign = label.segmentOffset == 0.5 ? "center" : "right" }
                    else { vAlign = "bottom"; hAlign = (label.segmentOffset == 0.5) ? "center" : "left" }
                    break
                case "after":
                    if (obj.angle >= fourty5 && obj.angle <= one35) { hAlign = "left"; vAlign = label.segmentOffset == 0.5 ? "center" : "top" }
                    else if (obj.angle >= two25 && obj.angle <= three15) { hAlign = "right"; vAlign = label.segmentOffset == 0.5 ? "center" : "bottom" }
                    else if (obj.angle > fourty5 && obj.angle < two25) { vAlign = "bottom"; hAlign = label.segmentOffset == 0.5 ? "center" : "right" }
                    else { vAlign = "top"; hAlign = label.segmentOffset == 0.5 ? "center" : "left" }
                    break;
                case "center":
                    hAlign = "center";
                    vAlign = "center";
                    break;
            }
            if (label.boundaryConstraints && (label.segmentOffset == 0 || label.segmentOffset == 1)) {
                var length, direction;
                if (node.segments.length > 1)
                    var segment = node.segments[node.segments.length - 1];
                length = segment ? segment.points.length : node.segments[0].points.length;
                if (node.labels[0].name == label.name)
                    direction = ej.datavisualization.Diagram.Util._getBezierDirection(node.segments[0].points[0], node.segments[0].points[1]);
                else {
                    segment = segment ? segment : node.segments[0];
                    direction = ej.datavisualization.Diagram.Util._getBezierDirection(segment.points[length - 2], segment.points[length - 1]);
                }
                switch (direction) {
                    case "left":
                        hAlign = label.segmentOffset == 0 ? "right" : "left";
                        break;
                    case "right":
                        hAlign = label.segmentOffset == 0 ? "left" : "right";
                        break;
                    case "bottom":
                        vAlign = label.segmentOffset == 0 ? "top" : "bottom";
                        break;
                    case "top":
                        vAlign = label.segmentOffset == 0 ? "bottom" : "top";
                        break;
                }

            }
            return { hAlign: hAlign, vAlign: vAlign };
        },
        getObjectType: function (element) {
            if (element) {
                if (element.segments) return "connector";
                else if (element.type == "bpmn" && element.container) return "group";
                else if ((element._type === "node" || element.type == "bpmn" || element.type == "basic" || element.type == "flow" || element.type == "arrow")) return "node";
                else if (element.type === "text" || element.type === "image" || element.type === "native" || element.type === "html") return "node";
                else if (element._type != "group" && element.type == "pseudoGroup") return "pseudoGroup";
                else if (element._type === "group" || element.isLane || element.isSwimlane) return "group";
                else if (element.isSwimlane) return "swimlane";
                else return null;
            }
            return null;
        },
        _canBeTarget: function (diagram, node) {
            if (node) {
                if (diagram.activeTool.helper && diagram.activeTool.helper._name) {
                    if (diagram.activeTool.helper._name === node.name)
                        return false;
                }
            }
            return true;
        },
        getLabelbounds: function (diagram, node, label) {
            var htmlLayer = diagram._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var layerBounds = htmlLayer.getBoundingClientRect();
            if (label) {
                var element = $(htmlLayer).find("#" + node.name + "_" + label.name)[0];;
                if (element) {
                    var elementBounds = element.getBoundingClientRect();
                    return ej.datavisualization.Diagram.Rectangle(elementBounds.left - layerBounds.left, elementBounds.top - layerBounds.top, elementBounds.right - elementBounds.left, elementBounds.bottom - elementBounds.top);
                }
            }
        },
        _updateBpmnChild: function (options, diagram) {
            switch (options.shape) {
                case "event":
                    options = ej.datavisualization.Diagram.DefautShapes._getBPMNEventShape(options, diagram);
                    break;
                case "gateway":
                    options = ej.datavisualization.Diagram.DefautShapes._getBPMNGatewayShape(options, diagram);
                    break;
                case "dataobject":
                    options = ej.datavisualization.Diagram.DefautShapes._getBPMNDataShape(options, diagram);
                    break;
                case "activity":
                    options = ej.datavisualization.Diagram.DefautShapes._getBPMNActivityShape(options, diagram);
                    break;
                case "group":
                    options = ej.datavisualization.Diagram.DefautShapes._getBPMNGroupShape(options, diagram);
                    break;
            }
            return ej.datavisualization.Diagram.DefautShapes.initBPMNAnnotationShape(options, diagram);
        },
        _getUndoObject: function (diagram, node) {
            var childTable = {};
            var childTable = diagram._getChildTable(node, childTable);
            diagram.activeTool._undoObject = $.extend(true, {}, { node: node, childTable: childTable });
        },
        _getRedoObject: function (diagram, node) {
            var childTable = {};
            var childTable = diagram._getChildTable(node, childTable);
            diagram.activeTool._redoObject = $.extend(true, {}, { node: node, childTable: childTable });
        },
        _collectionContains: function (name, coll) {
            for (var i = 0; i < coll.length; i++) {
                if (typeof (coll[i]) === "string" && coll[i] === name) {
                    return true;
                }
                else if (coll[i].name === name) {
                    return true;
                }
            }
        },
        _updateBPMNProperties: function (node, diagram, nameTable, isScaling) {
            switch (node.shape) {
                case "activity":
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node, true);
                    var offsetX = node.offsetX, offsetY = node.offsetY;
                    var children = diagram._getChildren(node.children);
                    for (var i = 0; i < children.length; i++) {
                        var child = typeof children[i] == "object" ? children[i] : nameTable[children[i]];
                        if (isScaling && i == 0) {
                            bounds = ej.datavisualization.Diagram.Util.bounds(child, true);
                            offsetX = child.offsetX, offsetY = child.offsetY;
                        }
                        if (i == 0) {
                            child.pathData = child._absolutePath = ej.datavisualization.Diagram.DefautShapes._updateRoundedRectanglePath(node, 12);
                            if (node.subProcess.type == "transaction") {
                                var innerRect = { x: 3, y: 3, width: node.width - 3, height: node.height - 3 };
                                child.pathData = child._absolutePath += ej.datavisualization.Diagram.DefautShapes._updateRoundedRectanglePath(innerRect, 12)
                            }
                            delete child._absoluteBounds;
                        }
                        if (isScaling && ej.datavisualization.Diagram.Util.canResize(child)) continue;
                        var addInfo = child.addInfo;
                        if (addInfo.offset) {
                            var offset = ej.datavisualization.Diagram.Point(bounds.x + bounds.width * addInfo.offset.x, bounds.y + bounds.height * addInfo.offset.y);
                            addInfo.margin = ej.datavisualization.Diagram.Margin(addInfo.margin ? addInfo.margin : {});
                            if (addInfo.hAlign) {
                                offset.x += addInfo.margin.left - addInfo.margin.right;
                                offset.x = addInfo.hAlign == "left" ? offset.x + addInfo.margin.right : (addInfo.hAlign == "right" ? offset.x - addInfo.margin.left : offset.x);
                            }
                            if (addInfo.vAlign) {
                                offset.y += addInfo.margin.top - addInfo.margin.bottom;
                                offset.y = addInfo.vAlign == "top" ? offset.y + addInfo.margin.bottom : (addInfo.vAlign == "bottom" ? offset.y - addInfo.margin.top : offset.y);
                            }
                            if (node.rotateAngle) {
                                var matrix = ej.Matrix.identity();
                                ej.Matrix.rotate(matrix, node.rotateAngle, offsetX, offsetY);
                                offset = ej.Matrix.transform(matrix, offset);
                            }
                            child.offsetX = offset.x;
                            child.offsetY = offset.y;
                        }
                    }
                    break;
                case "group":
                    node.pathData = node._absolutePath = ej.datavisualization.Diagram.DefautShapes._updateRoundedRectanglePath(node, 15);
                    node._scaled = false;
                    break;
                case "annotation":
                    var connector;
                    for (var i = 0; i < node.outEdges.length; i++) {
                        var edge = diagram.nameTable[node.outEdges[i]];
                        if (edge._isAnnotationLine) {
                            connector = edge;
                            break;
                        }
                    }
                    if (connector) ej.datavisualization.Diagram.DefautShapes.updateBPMNAnnotationShape(connector, null, null, diagram);
                    break;
            }
        }
    };
    ej.datavisualization.Diagram.BridgeSegments = {
        bridges: [],
        bridgeStartPoint: [],
        segmentIndex: -1
    };
    ej.datavisualization.Diagram.PathSegment = {
        path: "",
        startPoint: { "x": 0, "y": 0 },
        endPoint: { "x": 0, "y": 0 },
        angle: 0,
        segmentPointIndex: -1,
        sweep: 1
    };
    ej.datavisualization.Diagram.LineUtil = function (x1, y1, x2, y2) {
        return { "x1": Number(x1) || 0, "y1": Number(y1) || 0, "x2": Number(x2) || 0, "y2": Number(y2) || 0 };
    };
    //#endregion
    //#region Geometry
    ej.datavisualization.Diagram.Geometry = {
        checkPointOnCircle: function (point, center, radius) {
            var r2 = Math.pow(radius, 2);
            var x2 = Math.pow((point.x - center.x), 2);
            var y2 = Math.pow((point.y - center.y), 2);
            if ((x2 + y2) <= r2) {
                return true;
            }
            return false;
        },
        rect: function (points) {
            var rectangle = ej.datavisualization.Diagram.Rectangle();
            if (arguments.length === 1) {
                var left = Number.MAX_VALUE;
                var top = Number.MAX_VALUE;
                var right = -Number.MAX_VALUE;
                var bottom = -Number.MAX_VALUE;
                var len = points.length;
                var x, y;
                for (var i = 0; i < len; i++) {
                    x = points[i].x;
                    y = points[i].y;
                    if (x < left) {
                        left = x;
                    }
                    if (x > right) {
                        right = x;
                    }
                    if (y < top) {
                        top = y;
                    }
                    if (y > bottom) {
                        bottom = y;
                    }
                }
                rectangle = ej.datavisualization.Diagram.Rectangle(left, top, right - left, bottom - top);
            }
            else if (arguments.length === 2) {
                var ptStart = ej.datavisualization.Diagram.Point(arguments[0]);
                var ptEnd = ej.datavisualization.Diagram.Point(arguments[1]);
                var swap;
                if (ptStart.x > ptEnd.x) {
                    swap = ptStart.x;
                    ptStart.x = ptEnd.x;
                    ptEnd.x = swap;
                }
                if (ptStart.y > ptEnd.y) {
                    swap = ptStart.y;
                    ptStart.y = ptEnd.y;
                    ptEnd.y = swap;
                }
                rectangle = ej.datavisualization.Diagram.Rectangle(ptStart.x, ptStart.y, ptEnd.x - ptStart.x, ptEnd.y - ptStart.y);
            }
            return rectangle;
        },
        union: function (rect1, rect2) {
            var x = Math.min(rect1.x, rect2.x);
            var y = Math.min(rect1.y, rect2.y);
            var width = Math.max(rect1.x + rect1.width, rect2.x + rect2.width);
            var height = Math.max(rect1.y + rect1.height, rect2.y + rect2.height);
            return ej.datavisualization.Diagram.Rectangle(x, y, width - x, height - y);
        },
        distance: function (pt1, pt2) {
            return Math.sqrt(Math.pow(pt2.x - pt1.x, 2) + Math.pow(pt2.y - pt1.y, 2));
        },
        translate: function (pt1, dx, dy) {
            return ej.datavisualization.Diagram.Point(pt1.x + dx, pt1.y + dy);
        },
        intersectsRect: function (rect1, rect2) {
            return ((((rect2.x < (rect1.x + rect1.width)) && (rect1.x < (rect2.x + rect2.width)))
                && (rect2.y < (rect1.y + rect1.height))) && (rect1.y < (rect2.y + rect2.height)));
        },
        findAngle: function (point1, point2) {
            var angle = Math.atan2(point2.y - point1.y, point2.x - point1.x);
            angle = (180 * angle / Math.PI);
            angle %= 360;
            if (angle < 0) {
                angle += 360;
            }
            return angle;
        },
        intersectSegment: function (segment1, segment2) {
            var x1 = segment1.point1.x;
            var y1 = segment1.point1.y;
            var x2 = segment1.point2.x;
            var y2 = segment1.point2.y;
            var x3 = segment2.point1.x;
            var y3 = segment2.point1.y;
            var x4 = segment2.point2.x;
            var y4 = segment2.point2.y;
            var a1, a2, b1, b2, c1, c2, x, y;
            var r1, r2, r3, r4;
            var denom, offset, num;
            a1 = y2 - y1;
            b1 = x1 - x2;
            c1 = (x2 * y1) - (x1 * y2);
            r3 = ((a1 * x3) + (b1 * y3) + c1);
            r4 = ((a1 * x4) + (b1 * y4) + c1);
            if ((r3 !== 0) && (r4 !== 0) && this.sameSign(r3, r4)) {
                return null;
            }
            a2 = y4 - y3;
            b2 = x3 - x4;
            c2 = (x4 * y3) - (x3 * y4);
            r1 = (a2 * x1) + (b2 * y1) + c2;
            r2 = (a2 * x2) + (b2 * y2) + c2;
            if ((r1 !== 0) && (r2 !== 0) && (this.sameSign(r1, r2))) {
                return null;
            }
            denom = (a1 * b2) - (a2 * b1);

            if (denom === 0) {
                return null;
            }
            if (denom < 0) {
                offset = -denom / 2;
            }
            else {
                offset = denom / 2;
            }
            offset = 0;
            num = (b1 * c2) - (b2 * c1);
            if (num < 0) {
                x = (num - offset) / denom;
            }
            else {
                x = (num + offset) / denom;
            }
            num = (a2 * c1) - (a1 * c2);
            if (num < 0) {
                y = (num - offset) / denom;
            }
            else {
                y = (num + offset) / denom;
            }
            return ej.datavisualization.Diagram.Point(x, y);
        },
        updatePath: function (x, y, width, height, pathData, svg, bounds, appendBoundsTo) {
            var bBox, isInit;
            if (svg && svg.pathBounds) {
                isInit = true;
                bBox = bounds || svg.pathBounds(pathData);
            }
            else {
                if (appendBoundsTo && !appendBoundsTo._absolutePath) isInit = true; else isInit = false;
                bBox = bounds;
            }
            if (appendBoundsTo) appendBoundsTo._absoluteBounds = bBox;
            var newX = 0, newY = 0;
            var isResize = false;
            if (x.toString() !== bBox.x || y.toString() !== bBox.y) {
                newX = x - Number(bBox.x);
                newY = y - Number(bBox.y);
            }
            if (width !== bBox.width || height !== bBox.height) {
                newX = width / Number(bBox.width ? bBox.width : 1);
                newY = height / Number(bBox.height ? bBox.height : 1);
                isResize = true;
            }
            return ej.datavisualization.Diagram.Geometry.processPathData(pathData, newX, newY, isResize, bBox.x, bBox.y, x, y, isInit, svg);
        },
        processPathData: function (path, newX, newY, isResizing, oldX, oldY, offsetX, offsetY, isInit, svg) {
            var shape = document.createElementNS('http://www.w3.org/2000/svg', "path");
            shape.setAttribute("d", path);
            if (isInit) {
                svg = svg || new ej.datavisualization.Diagram.Svg({});
                path = svg.absolutePath(shape).getAttribute('d');
                shape.setAttribute("d", path);
            }
            var x0, y0, x1, y1, x2, y2, segs = ej.datavisualization.Diagram.Util.convertPathToArray(path);
            for (var x = 0, y = 0, i = 0, length = segs.length; i < length; ++i) {
                var seg = segs[i], char = seg.pathSegTypeAsLetter;
                if ('x1' in seg) x1 = seg.x1;
                if ('x2' in seg) x2 = seg.x2;
                if ('y1' in seg) y1 = seg.y1;
                if ('y2' in seg) y2 = seg.y2;
                if ('x' in seg) x = seg.x;
                if ('y' in seg) y = seg.y;
                if (isResizing) {
                    if (x != undefined) {
                        x = ej.datavisualization.Diagram.Geometry.scalePathData(x, newX, oldX, offsetX);
                        x = Number(x.toFixed(2));
                    }
                    if (y != undefined) {
                        y = ej.datavisualization.Diagram.Geometry.scalePathData(y, newY, oldY, offsetY);
                        y = Number(y.toFixed(2));
                    }
                    if (x1 != undefined) {
                        x1 = ej.datavisualization.Diagram.Geometry.scalePathData(x1, newX, oldX, offsetX);
                        x1 = Number(x1.toFixed(2));
                    }
                    if (y1 != undefined) {
                        y1 = ej.datavisualization.Diagram.Geometry.scalePathData(y1, newY, oldY, offsetY);
                        y1 = Number(y1.toFixed(2));
                    }
                    if (x2 != undefined) {
                        x2 = ej.datavisualization.Diagram.Geometry.scalePathData(x2, newX, oldX, offsetX);
                        x2 = Number(x2.toFixed(2));
                    }
                    if (y2 != undefined) {
                        y2 = ej.datavisualization.Diagram.Geometry.scalePathData(y2, newY, oldY, offsetY);
                        y2 = Number(y2.toFixed(2));
                    }
                }
                else {
                    if (x != undefined) {
                        x = (x + newX);
                    }
                    if (y != undefined) {
                        y = (y + newY);
                    }
                    if (x1 != undefined) {
                        x1 = (x1 + newX);
                    }
                    if (y1 != undefined) {
                        y1 = (y1 + newY);
                    }
                    if (x2 != undefined) {
                        x2 = (x2 + newX);
                    }
                    if (y2 != undefined) {
                        y2 = (y2 + newY);
                    }
                }
                var newSeg;
                switch (char) {
                    case 'M':
                        newSeg = { pathSegTypeAsLetter: "M", x: x, y: y };
                        break;
                    case 'L':
                        newSeg = { pathSegTypeAsLetter: "L", x: x, y: y };
                        break;
                    case 'H':
                        newSeg = { pathSegTypeAsLetter: "H", x: x };
                        break;
                    case 'V':
                        newSeg = { pathSegTypeAsLetter: "V", y: y };
                        break;
                    case 'C':
                        newSeg = { pathSegTypeAsLetter: "C", x: x, y: y, x1: x1, y1: y1, x2: x2, y2: y2 };
                        break;
                    case 'S':
                        newSeg = { pathSegTypeAsLetter: "S", x: x, y: y, x2: x2, y2: y2 };
                        break;
                    case 'Q':
                        newSeg = { pathSegTypeAsLetter: "Q", x: x, y: y, x1: x1, y1: y1 };
                        break;
                    case 'T':
                        newSeg = { pathSegTypeAsLetter: "T", x: x, y: y };
                        break;
                    case 'A':
                        var r1 = seg.r1, r2 = seg.r2;
                        if (isResizing) {
                            r1 = (r1 * newX);
                            r2 = (r2 * newY);
                        }
                        newSeg = { pathSegTypeAsLetter: "A", x: x, y: y, r1: r1, r2: r2, angle: seg.angle, largeArcFlag: seg.largeArcFlag, sweepFlag: seg.sweepFlag };
                        break;
                    case 'z':
                    case 'Z':
                        x = x0; y = y0;
                        newSeg = segs[i];
                        break;
                }
                if (newSeg)
                    segs[i] = newSeg;
                // Record the start of a subpath
                if (char === 'M' || char === 'm') x0 = x, y0 = y;
            }
            var pathData = ej.datavisualization.Diagram.Util.pathSegArrayAsString(segs);
            return pathData;
        },
        scalePathData: function (val, scaleFactor, oldOffset, newOffset) {
            if (val !== oldOffset) {
                if (newOffset !== oldOffset) {
                    val = (((val * scaleFactor) - (Number(oldOffset) * scaleFactor - Number(oldOffset)))
                        + (newOffset - Number(oldOffset)));
                }
                else
                    val = ((Number(val) * scaleFactor) - (Number(oldOffset) * scaleFactor - Number(oldOffset)));
            }
            else {
                if (newOffset !== oldOffset) {
                    val = newOffset;
                }
            }
            return val;
        },
        updatePolygonPoints: function (node, points) {
            if (node.points) {
                if (!points)
                    points = node.points;
                ej.datavisualization.Diagram.Geometry.scalePoints(points, node);
                var bounds = ej.datavisualization.Diagram.Geometry.rect(node.points);
                for (var i = 0, len = node.points.length; i < len; ++i) {
                    var point = ej.datavisualization.Diagram.Geometry.translate(points[i], -bounds.x, -bounds.y);
                    point = ej.datavisualization.Diagram.Geometry.translate(point, 0, 0);
                    points[i] = point;
                }
            }
        },
        scalePoints: function (points, node) {
            var bounds = ej.datavisualization.Diagram.Geometry.rect(node.points);
            if (bounds.width > 0 && bounds.height > 0) {
                var scaleX = node.width / bounds.width;
                var scaleY = node.height / bounds.height;
                for (var i = 0, len = node.points.length; i < len; ++i) {
                    points[i].x = points[i].x * scaleX;
                    points[i].y = points[i].y * scaleY;
                }
            }
        },
        sameSign: function (a, b) {
            return ((a * b) >= 0);
        },
        containsPoint: function (rect, point) {
            return ((((rect.x <= point.x) && (point.x <= (rect.x + rect.width)))
            && (rect.y <= point.y)) && (point.y <= (rect.y + rect.height)));
        },
        containsRect: function (rect, value) {
            return ((((rect.x <= value.x) && ((value.x + value.width) <= (rect.x + rect.width)))
               && (rect.y <= value.y)) && ((value.y + value.height) <= (rect.y + rect.height)));
        },
        inflate: function (rect, x, y) {
            rect.x -= x;
            rect.y -= y;
            rect.width += 2 * x;
            rect.height += 2 * y;
        },
        isEmptyRect: function (rect) {
            return rect.x === 0 && rect.y === 0 && rect.width === 0 && rect.height === 0;
        },
        isEmptyPoint: function (point) {
            return point.x === 0 && point.y === 0;
        },
        isEqualPoint: function (point1, point2) {
            return point1.x === point2.x && point1.y === point2.y;
        },
        isEmptySize: function (size) {
            return size.width === 0 && size.height === 0;
        },
        length: function (segment) {
            return ej.datavisualization.Diagram.Geometry.distance(segment.point1, segment.point2);
        },
        midPoint: function (segment) {
            return ej.datavisualization.Diagram.Point((segment.point1.x + segment.point2.x) / 2, (segment.point1.y + segment.point2.y) / 2);
        },
        transform: function (point, angle, length) {
            var pt = {};
            pt.x = Math.round((point.x + length * Math.cos(angle * Math.PI / 180)) * 100) / 100;
            pt.y = Math.round((point.y + length * Math.sin(angle * Math.PI / 180)) * 100) / 100;
            return pt;
        }
    };
    ej.datavisualization.Diagram.LineSegment = function (point1, point2) {
        return { "point1": point1, "point2": point2 };
    };
    ej.datavisualization.Diagram.Point = function (x, y) {
        return { "x": Number(x) || 0, "y": Number(y) || 0 };
    };
    ej.datavisualization.Diagram.Size = function (width, height) {
        return { "width": Number(width) || 0, "height": Number(height) || 0 };
    };
    ej.datavisualization.Diagram.Rectangle = function (x, y, width, height) {
        return { "x": Number(x) || 0, "y": Number(y) || 0, "width": Number(width) || 0, "height": Number(height) || 0 };
    };
    //#endregion
    //#region Enums
    ej.datavisualization.Diagram.ImageAlignment = {
        None: "none",
        XMinYMin: "xminymin",
        XMinYMid: "xminymid",
        XMinYMax: "xminymax",
        XMidYMin: "xmidymin",
        XMidYMid: "xmidymid",
        XMidYMax: "xmidymax",
        XMaxYMin: "xmaxymin",
        XMaxYMid: "xmaxymid",
        XMaxYMax: "xmaxymax"
    }
    ej.datavisualization.Diagram.ScaleConstraints = {
        None: "none",
        Stretch: "stretch",
        Meet: "meet",
        Slice: "slice"
    }
    ej.datavisualization.Diagram.KeyModifiers = {
        None: 0,
        Control: 1 << 0,
        Meta: 1 << 0,
        Alt: 1 << 1,
        Shift: 1 << 2
    };
    ej.datavisualization.Diagram.Keys = {
        None: "",
        Number0: 0,
        Number1: 1,
        Number2: 2,
        Number3: 3,
        Number4: 4,
        Number5: 5,
        Number6: 6,
        Number7: 7,
        Number8: 8,
        Number9: 9,
        A: 65,
        B: 66,
        C: 67,
        D: 68,
        E: 69,
        F: 70,
        G: 71,
        H: 72,
        I: 73,
        J: 74,
        K: 75,
        L: 76,
        M: 77,
        N: 78,
        O: 79,
        P: 80,
        Q: 81,
        R: 82,
        S: 83,
        T: 84,
        U: 85,
        V: 86,
        W: 87,
        X: 88,
        Y: 89,
        Z: 90,
        Left: 37,
        Up: 38,
        Right: 39,
        Down: 40,
        Escape: 27,
        Delete: 46,
        Tab: 9,
        Enter: 13,
    };
    ej.datavisualization.Diagram.LabelRenderingMode = {
        Html: "html",
        Svg: "svg"
    };
    ej.datavisualization.Diagram.TemplateType = {
        Html: "html",
        Svg: "svg"
    };
    ej.datavisualization.Diagram.DecoratorShapes = {
        None: "none",
        Arrow: "arrow",
        OpenArrow: "openarrow",
        Circle: "circle",
        Diamond: "diamond",
        Path: "path"
    };
    ej.datavisualization.Diagram.ConnectorType = {
        StraightLine: "straightLine",
        OrthogonalLine: "orthogonalLine",
        Polyline: "polyline",
    };
    ej.datavisualization.Diagram.ActionType = {
        Unknown: "unknown",
        Nudge: "nudge",
        Touch: "touch",
        Mouse: "mouse",
        Order: "order",
        Align: "align",
        Size: "size",
        HistoryChange: "historyChange"
    };
    ej.datavisualization.Diagram.dependentconnector = {
        dependent: 1,
        independent: 2
    }
    ej.datavisualization.Diagram.ContainerType = {
        Canvas: "canvas",
        Stack: "stack",
    };
    ej.datavisualization.Diagram.IconShapes = {
        Minus: "minus",
        Plus: "plus",
        ArrowUp: "arrowup",
        ArrowDown: "arrowdown",
        Template: "template",
        Path: "path",
        Image: "image",
        None: "none",
    };
    ej.datavisualization.Diagram.PortShapes = {
        X: "x",
        Circle: "circle",
        Square: "square",
        Path: "path"
    };
    ej.datavisualization.Diagram.PortVisibility = {
        Visible: 1 << 0,
        Hidden: 1 << 1,
        Hover: 1 << 2,
        Connect: 1 << 3,
        Default: 1 << 3
    };
    ej.datavisualization.Diagram.TextAlign = {
        Left: "left",
        Center: "center",
        Right: "right",
        Justify: "justify"
    };
    ej.datavisualization.Diagram.HorizontalAlignment = {
        Left: "left",
        Center: "center",
        Right: "right",
        Stretch: "stretch"
    };
    ej.datavisualization.Diagram.Alignment = {
        Before: "before",
        After: "after",
        Center: "center"
    };
    ej.datavisualization.Diagram.LabelRelativeMode = {
        SegmentBounds: "segmentbounds",
        SegmentPath: "segmentpath"
    }
    ej.datavisualization.Diagram.LabelEditMode = {
        Edit: "edit",
        View: "view"
    };
    ej.datavisualization.Diagram.RelativeMode = {
        Object: "object",
        Mouse: "mouse"
    };
    ej.datavisualization.Diagram.TextWrapping = {
        NoWrap: "nowrap",
        Wrap: "wrap",
        WrapWithOverflow: "wrapwithoverflow",
    };
    ej.datavisualization.Diagram.VerticalAlignment = {
        Top: "top",
        Center: "center",
        Bottom: "bottom",
        Stretch: "stretch"
    };
    ej.datavisualization.Diagram.TextDecorations = {
        Underline: "underline",
        Overline: "overline",
        LineThrough: "line-through",
        None: "none"
    };
    ej.datavisualization.Diagram.PaletteConstraints = {
        HeaderVisibility: 1 << 1,
        Visible: 1 << 2,
        Expandable: 1 << 3,
        Default: 1 << 1 | 1 << 2 | 1 << 3
    };
    ej.datavisualization.Diagram.NodeConstraints = {
        None: 1 << 0,
        Select: 1 << 1,
        Delete: 1 << 2,
        Drag: 1 << 3,
        Rotate: 1 << 4,
        Connect: 1 << 5,
        ResizeNorthEast: 1 << 6,
        ResizeEast: 1 << 7,
        ResizeSouthEast: 1 << 8,
        ResizeSouth: 1 << 9,
        ResizeSouthWest: 1 << 10,
        ResizeWest: 1 << 11,
        ResizeNorthWest: 1 << 12,
        ResizeNorth: 1 << 13,
        Resize: 1 << 6 | 1 << 7 | 1 << 8 | 1 << 9 | 1 << 10 | 1 << 11 | 1 << 12 | 1 << 13,
        Shadow: 1 << 14,
        DragLabel: 1 << 15,
        AllowPan: 1 << 16,
        AspectRatio: 1 << 17,
        AllowDrop: 1 << 18,
        InheritTooltip: 1 << 19,
        MultiSelect: 1 << 20,
        PointerEvents: 1 << 21,
        PointerVisibility: 1 << 21,
        CrispEdges: 1 << 22,
        InheritCrispEdges: 1 << 23,
        Interaction: 1 << 1 | 1 << 3 | 1 << 4 | 1 << 6 | 1 << 7 | 1 << 8 | 1 << 9 | 1 << 10 | 1 << 11 | 1 << 12 | 1 << 13 | 1 < 21,
        Default: 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7 | 1 << 8 | 1 << 9 | 1 << 10 | 1 << 11 | 1 << 12 | 1 << 13 | 1 << 19 | 1 << 21 | 1 << 23
    };
    ej.datavisualization.Diagram.HistoryChangeCause = {
        Undo: "undo",
        Redo: "redo",
        CustomAction: "customAction"
    };
    ej.datavisualization.Diagram.CollectionChangeCause = {
        ClipBoard: "clipBoard",
        Drop: "drop",
        HistoryChange: "historyChange",
        Unknown: "unknown"
    };
    ej.datavisualization.Diagram.SelectionChangeCause = {
        Keydown: "keydown",
        RubberBand: "rubberBand",
        Mouse: "mouse",
        Touch: "touch",
        Unknown: "unknown",
    };
    ej.datavisualization.Diagram.ScrollChangeCause = {
        Zoom: "zoom",
        Pan: "pan",
        Unknown: "unknown"
    };
    ej.datavisualization.Diagram.ConnectorConstraints = {
        None: 1 << 0,
        Select: 1 << 1,
        Delete: 1 << 2,
        Drag: 1 << 3,
        DragSourceEnd: 1 << 4,
        DragTargetEnd: 1 << 5,
        DragSegmentThumb: 1 << 6,
        Bridging: 1 << 7,
        DragLabel: 1 << 8,
        InheritBridging: 1 << 9,
        AllowDrop: 1 << 10,
        InheritTooltip: 1 << 11,
        PointerEvents: 1 << 12,
        PointerVisibility: 1 << 12,
        CrispEdges: 1 << 13,
        InheritCrispEdges: 1 << 14,
        Interaction: 1 << 1 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 || 1 << 12,
        Default: 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 9 | 1 << 11 | 1 << 12 | 1 << 14
    };
    ej.datavisualization.Diagram.PortConstraints = {
        None: 1 << 0,
        Connect: 1 << 1,
        ConnectOnDrag: 1 << 2,
    };
    ej.datavisualization.Diagram.SelectorConstraints = {
        None: 1 << 0,
        Rotator: 1 << 1,
        Resizer: 1 << 2,
        UserHandles: 1 << 3,
        Tooltip: 1 << 4,
        All: 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4
    };
    ej.datavisualization.Diagram.UserHandlePositions = {
        TopLeft: "topleft",
        TopCenter: "topcenter",
        TopRight: "topright",
        MiddleLeft: "middleleft",
        MiddleRight: "middleright",
        BottomLeft: "bottomleft",
        BottomCenter: "bottomcenter",
        BottomRight: "bottomright"
    };
    ej.datavisualization.Diagram.SnapConstraints = {
        None: 0,
        SnapToHorizontalLines: 1,
        SnapToVerticalLines: 2,
        SnapToLines: 1 | 2,
        ShowHorizontalLines: 4,
        ShowVerticalLines: 8,
        ShowLines: 4 | 8,
        All: 1 | 2 | 4 | 8
    };
    ej.datavisualization.Diagram.PageOrientations = {
        Landscape: "landscape",
        Portrait: "portrait"
    };
    ej.datavisualization.Diagram.ScrollLimit = {
        Infinity: "infinity",
        Diagram: "diagram",
        Limited: "limited"
    };
    ej.datavisualization.Diagram.BoundaryConstraints = {
        Infinity: "infinity",
        Diagram: "diagram",
        Page: "page"
    };
    ej.datavisualization.Diagram.LayoutOrientations = {
        TopToBottom: "toptobottom",
        BottomToTop: "bottomtotop",
        LeftToRight: "lefttoright",
        RightToLeft: "righttoleft"
    };
    ej.datavisualization.Diagram.ObjectTypes = {
        Diagram: "diagram",
        Palette: "palette",
        Lane: "lane",
        Group: "group"
    };
    ej.datavisualization.Diagram.PaletteDefaults = {
        name: "",
        expanded: false,
        subControlId: null,
        items: [],
        constraints: ej.datavisualization.Diagram.PaletteConstraints.Default,
    };
    ej.datavisualization.Diagram.Palette = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.PaletteDefaults, options);
    };
    ej.datavisualization.Diagram.Shapes = {
        Image: "image",
        Text: "text",
        Html: "html",
        Native: "native",
        Basic: "basic",
        Flow: "flow",
        Arrow: "arrow",
        BPMN: "bpmn",
    };
    ej.datavisualization.Diagram.ClipBoardChangeType = {
        All: "all",
        None: "none",
        Specific: "specific"
    };
    ej.datavisualization.Diagram.OverflowType = {
        Clip: "clip",
        Ellipsis: "ellipsis"
    };
    ej.datavisualization.Diagram.ShapeDefaults = {
        shape: "",
        source: "",
        pathData: "",
        textBlock: null,
        points: [],
        templateId: null,
        scale: "meet",
        contentAlignment: "xmidymid"
    };
    ej.datavisualization.Diagram.Shape = function (options) {
        if (options) {
            if (options.type === "html") {
                if (typeof (options.html) === "string")
                    options.html = ej.datavisualization.Diagram.Util.htmlEncode(options.html);
            }
            if (options.type === "text") {
                options.textBlock = ej.datavisualization.Diagram.TextBlock(options.textBlock ? options.textBlock : {});
                options.fillColor = options.fillColor ? options.fillColor : "transparent";
                options.borderColor = options.borderColor ? options.borderColor : "transparent";
                options.borderWidth = options.borderWidth ? options.borderWidth : 0;
            }
            if (options.type == "image" || options.type == "native" || options.type === "text" || options.type === "html")
                options._shape = options.type;
            if (!options._type)
                options._type = options.type ? options.type : "node";
            if (!options._shape)
                options._shape = options.shape ? options.shape : "rectangle";
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.ShapeDefaults, options);
    };
    ej.datavisualization.Diagram.Segments = {
        Straight: "straight",
        Orthogonal: "orthogonal",
        Bezier: "bezier"
    };
    ej.datavisualization.Diagram.SegmentDefaults = {
        type: ej.datavisualization.Diagram.Segments.Straight,
        point: null,
        point1: null,
        point2: null,
        vector1: null,
        vector2: null,
        _point1: ej.datavisualization.Diagram.Point(),
        _point2: ej.datavisualization.Diagram.Point(),
        length: null, _length: null,
        _bridges: [],
        direction: null, _direction: null,
    };
    ej.datavisualization.Diagram.Segment = function (options) {
        var line = $.extend(true, {}, ej.datavisualization.Diagram.SegmentDefaults, options);
        var points = [];
        line["points"] = points;
        if (line.type == "orthogonal") {
            line._length = line.length;
            line._direction = line.direction;
        }
        else {
            if (line.type == "bezier") {
                line._point1 = line.point1;
                line._point2 = line.point2;
            }
            if (line.point) {
                line._point = line.point;
            }
        }
        return line;
    };
    //#endregion
    //#region Margin
    ej.datavisualization.Diagram.MarginDefaults = {
        top: 0,
        left: 0,
        right: 0,
        bottom: 0
    };
    ej.datavisualization.Diagram.Margin = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.MarginDefaults, options);
    };
    ej.datavisualization.Diagram.GestureDefaults = {
        key: ej.datavisualization.Diagram.Keys.None,
        keyModifiers: ej.datavisualization.Diagram.KeyModifiers.None
    };
    ej.datavisualization.Diagram.Gesture = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.GestureDefaults, options);
    };
    //#region Command
    ej.datavisualization.Diagram.CommandDefaults = {
        gesture: ej.datavisualization.Diagram.Gesture(),
        execute: null,
        canExecute: null,
        parameter: null
    };
    ej.datavisualization.Diagram.Command = function (options) {
        if (options.gesture) options.gesture = ej.datavisualization.Diagram.Gesture(options.gesture);
        if (!options.canExecute) options.canExecute = function (args) {
            return true;
        }
        if (!options.execute) options.execute = function (args) {
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.CommandDefaults, options);
    };
    //#endregion
    //#region Tooltip
    ej.datavisualization.Diagram.TooltipDefaults = {
        templateId: "",
        relativeMode: "object",
        alignment: {
            horizontal: "center",
            vertical: "bottom",
        },
        margin: { left: 5, right: 5, top: 5, bottom: 5 },
        offset: null,
        delay: 0
    };
    ej.datavisualization.Diagram.Tooltip = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.TooltipDefaults, options);
    };
    ej.datavisualization.Diagram.BackgroundImageDefaults = {
        source: "",
        alignment: "xmidymid",
        scale: "meet"
    };
    ej.datavisualization.Diagram.BackgroundImage = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.BackgroundImageDefaults, options);
    };
    //#endregion
    //#region Path Util
    ej.datavisualization.Diagram.Path = function () {
        this._path = "";
    };
    ej.datavisualization.Diagram.Path.prototype = {
        moveTo: function (x, y) {
            this._path += "M" + x + "," + y; return this;
        },
        lineTo: function (x, y) {
            this._path += "L" + x + "," + y; return this;
        },
        cubicBezierTo: function (points, isSmooth) {
            if (isSmooth)
                this._path += "S";
            else
                this._path += "C";
            this._addPoints(points);
            return this;
        },
        quadraticBezierTo: function (points, isSmooth) {
            if (isSmooth)
                this._path += "T";
            else
                this._path += "Q";
            this._addPoints(points);
            return this;
        },
        ellipticalArcTo: function (rx, ry, xAngle, arcFlag, sweepFlag, x, y) {
            this._path += "A" + rx + "," + ry + " " + xAngle + " " + arcFlag + "," + sweepFlag + " " + x + "," + y;
            return this;
        },
        close: function () {
            this._path += "Z"; return this;
        },
        toString: function () {
            return this._path;
        },
        _addPoints: function (points) {
            var point;
            for (var i = 0; i < points.length; i++) {
                point = points[i];
                this._path += point.x + ", " + point.y;
                if (i !== (points.length - 1))
                    this._path += " ";
            }
        }
    };
    //#endregion
    ej.datavisualization.Diagram.DecoratorDefaults = {
        shape: ej.datavisualization.Diagram.DecoratorShapes.Arrow,
        width: 8,
        height: 8,
        borderColor: "black",
        borderWidth: 1,
        fillColor: "black",
        pathData: "",
        cssClass: ""
    };
    ej.datavisualization.Diagram.Decorator = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.DecoratorDefaults, options);
    };
    //#endregion
    ej.datavisualization.Diagram.TextBlockDefaults = {
        readOnly: false,
        bold: false,
        italic: false,
        text: "",
        textDecoration: ej.datavisualization.Diagram.TextDecorations.None,
        fontSize: 12,
        fontFamily: "Arial",
        fontColor: "black",
        boundaryConstraints: true,
        segmentOffset: 0.5,
        offset: ej.datavisualization.Diagram.Point(0.5, 0.5),
        textAlign: ej.datavisualization.Diagram.TextAlign.Center,
        alignment: ej.datavisualization.Diagram.Alignment.Center,
        relativeMode: ej.datavisualization.Diagram.LabelRelativeMode.SegmentPath,
        horizontalAlignment: ej.datavisualization.Diagram.HorizontalAlignment.Center,
        verticalAlignment: ej.datavisualization.Diagram.VerticalAlignment.Center,
        wrapping: ej.datavisualization.Diagram.TextWrapping.WrapWithOverflow,
        margin: ej.datavisualization.Diagram.Margin(),
        textOverflow: false,
        overflowType: ej.datavisualization.Diagram.OverflowType.Ellipsis,
        mode: ej.datavisualization.Diagram.LabelEditMode.Edit,
        width: 50,
        rotateAngle: 0,
        opacity: 1,
        templateId: "",
        templateType: "html"
    };
    ej.datavisualization.Diagram.TextBlock = function (options) {
        if (options.wrapText !== undefined) {
            if (options.wrapText) options.wrapping = "wrapwithoverflow";
            else options.wrapping = "nowrap";
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.TextBlockDefaults, options);
    };
    ej.datavisualization.Diagram.LabelDefaults = $.extend(true, {}, ej.datavisualization.Diagram.TextBlockDefaults, {
        name: "",
        visible: true,
        borderColor: "transparent",
        borderWidth: 0,
        fillColor: "transparent",
        cssClass: "",
        hyperlink: "",
    });
    ej.datavisualization.Diagram.Label = function (options) {
        var label = $.extend(true, {}, ej.datavisualization.Diagram.LabelDefaults, options);
        if (!label.name)
            label.name = "label_" + ej.datavisualization.Diagram.Util.randomId();
        return label;
    };
    //#endregion


    //#region ExportSettings
    ej.datavisualization.Diagram.ExportSettingsDefaults = {
        multiplePage: false,
        pageWidth: null,
        pageHeight: null,
        pageOrientation: "portrait",
        stretch: "none"
    };
    ej.datavisualization.Diagram.ExportSettings = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ExportSettingsDefaults, options);
    };
    //#endregion

    //#region PrintSettings
    ej.datavisualization.Diagram.PrintSettingsDefaults = {
        multiplePage: false,
        pageWidth: null,
        pageHeight: null,
        pageOrientation: "portrait",
        margin: { left: 0, top: 0, right: 0, bottom: 0 },
        region: "pageSettings"
    };
    ej.datavisualization.Diagram.PrintSettings = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.PrintSettingsDefaults, options);
    };
    //#endregion

    ej.datavisualization.Diagram.IconDefaults = {
        shape: ej.datavisualization.Diagram.IconShapes.None,
        width: 15,
        height: 15,
        offset: { x: 0.5, y: 1 },
        borderColor: "#1a1a1a",
        borderWidth: 1,
        margin: ej.datavisualization.Diagram.Margin(),
        horizontalAlignment: ej.datavisualization.Diagram.HorizontalAlignment.Center,
        verticalAlignment: ej.datavisualization.Diagram.VerticalAlignment.Center,
        cornerRadius: 0,
        fillColor: "white",
        source: "",
        pathData: "",
        templateId: "",
    };
    ej.datavisualization.Diagram.expandIcon = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.IconDefaults, options);
    };
    ej.datavisualization.Diagram.collapseIcon = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.IconDefaults, options);
    };
    //#region Port
    ej.datavisualization.Diagram.PortDefaults = {
        name: "",
        visibility: ej.datavisualization.Diagram.PortVisibility.Default,
        constraints: ej.datavisualization.Diagram.PortConstraints.Connect,
        size: 8,
        offset: ej.datavisualization.Diagram.Point(0, 0),
        borderColor: "#1a1a1a",
        borderWidth: 1,
        fillColor: "white",
        shape: ej.datavisualization.Diagram.PortShapes.Square,
        pathData: "",
        connectorPadding: 0,
        cssClass: "",
        margin: ej.datavisualization.Diagram.Margin(),
    };
    //#region Shadow
    ej.datavisualization.Diagram.ShadowDefaults = {
        distance: 5,
        angle: 45,
        opacity: 0.7
    };
    ej.datavisualization.Diagram.Shadow = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ShadowDefaults, options);
    };
    ej.datavisualization.Diagram.Port = function (options) {
        var port = $.extend(true, {}, ej.datavisualization.Diagram.PortDefaults, options);
        if (!port.name)
            port.name = "port_" + ej.datavisualization.Diagram.Util.randomId();
        return port;
    };
    //#endregion
    //#region Gradient
    ej.datavisualization.Diagram.StopDefaults = {
        color: "",
        offset: 0,
        opacity: 1
    };
    ej.datavisualization.Diagram.Stop = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.StopDefaults, options);
    };
    ej.datavisualization.Diagram.LinearGradientDefaults = {
        type: "linear",
        x1: 0,
        x2: 0,
        y1: 0,
        y2: 0,
        stops: []
    };
    ej.datavisualization.Diagram.LinearGradient = function (options) {
        for (var i = 0; options.stops && i < options.stops.length; i++) {
            options.stops[i] = ej.datavisualization.Diagram.Stop(options.stops[i]);
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.LinearGradientDefaults, options);
    };
    ej.datavisualization.Diagram.RadialGradientDefaults = {
        type: "radial",
        cx: 0,
        cy: 0,
        fx: 0,
        fy: 0,
        r: 50,
        stops: []
    };
    ej.datavisualization.Diagram.RadialGradient = function (options) {
        for (var i = 0; i < options.stops.length; i++) {
            options.stops[i] = ej.datavisualization.Diagram.Stop(options.stops[i]);
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.RadialGradientDefaults, options);
    };
    //#region Node
    ej.datavisualization.Diagram.NodeBaseDefaults = {
        name: "",
        width: 0,
        height: 0,
        offsetX: 0,
        offsetY: 0,
        visible: true,
        zOrder: -1,
        excludeFromLayout: false,
        constraints: ej.datavisualization.Diagram.NodeConstraints.Default,
        parent: "",
        labels: [],
        expandIcon: {
            shape: ej.datavisualization.Diagram.IconShapes.None,
            width: 13,
            height: 10,
            margin: ej.datavisualization.Diagram.Margin(),
            offset: { x: 0.5, y: 1 },
            borderColor: "#1a1a1a",
            borderWidth: 1,
            cornerRadius: 0,
            fillColor: "black",
            pathData: "",
            templateId: "",
        },
        collapseIcon: {
            shape: ej.datavisualization.Diagram.IconShapes.None,
            width: 13,
            height: 10,
            margin: ej.datavisualization.Diagram.Margin(),
            offset: { x: 0.5, y: 1 },
            borderColor: "#1a1a1a",
            borderWidth: 1,
            cornerRadius: 0,
            fillColor: "black",
            pathData: "",
            templateId: "",
        },
        ports: [],
        inEdges: [],
        outEdges: [],
        rotateAngle: 0,
        pivot: ej.datavisualization.Diagram.Point(0.5, 0.5),
        addInfo: {},
        marginLeft: 0,
        marginTop: 0,
        marginRight: 0,
        marginBottom: 0,
        horizontalAlign: ej.datavisualization.Diagram.HorizontalAlignment.Left,
        verticalAlign: ej.datavisualization.Diagram.VerticalAlignment.Top,
        minWidth: 0,
        maxWidth: 0,
        minHeight: 0,
        maxHeight: 0,
        connectorPadding: 0,
        cornerRadius: 0,
        paletteItem: null,
    };

    ej.datavisualization.Diagram.NodeBase = function (options) {
        var i;
        if (options.expandIcon)
            options.expandIcon = ej.datavisualization.Diagram.expandIcon(options.expandIcon ? options.expandIcon : {});
        if (options.collapseIcon)
            options.collapseIcon = ej.datavisualization.Diagram.collapseIcon(options.collapseIcon ? options.collapseIcon : {});
        if (options.labels)
            for (i = 0; i < options.labels.length; i++) {
                options.labels[i] = ej.datavisualization.Diagram.Label(options.labels[i]);
            }
        if (options.ports)
            for (i = 0; i < options.ports.length; i++) {
                options.ports[i] = ej.datavisualization.Diagram.Port(options.ports[i]);
            }
        options.paletteItem = ej.datavisualization.Diagram.PaletteItem(options.paletteItem ? options.paletteItem : {});
        return $.extend(true, {}, ej.datavisualization.Diagram.NodeBaseDefaults, options);
    };
    ej.datavisualization.Diagram.NodeDefaults = {
        fillColor: "white",
        borderColor: "black",
        borderWidth: 1,
        borderDashArray: "",
        opacity: 1,
        gradient: null,
        type: ej.datavisualization.Diagram.Shapes.Basic,
        isExpanded: true,
        shadow: ej.datavisualization.Diagram.Shadow(),
        cssClass: ""
    };
    ej.datavisualization.Diagram.Node = function (options) {
        options = options || {};
        if (options.container && $.isEmptyObject(options.container)) {
            options.container = null;
        }
        if (options.linearGradient || options.radialGradient) options.gradient = options.linearGradient || options.radialGradient;
        if (options.gradient) {
            if (options.gradient.type === "linear") {
                options.gradient = ej.datavisualization.Diagram.LinearGradient(options.gradient);
            }
            else if (options.gradient.type === "radial") {
                options.gradient = ej.datavisualization.Diagram.RadialGradient(options.gradient);
            }
        }
        if (options.shadow) {
            options.shadow = ej.datavisualization.Diagram.Shadow(options.shadow);
        }
        if (options.tooltip) {
            options.tooltip = ej.datavisualization.Diagram.Tooltip(options.tooltip);
        }
        if (options && !options.name) {
            options.name = "node_" + ej.datavisualization.Diagram.Util.randomId();
        }
        options.minWidth = options.minWidth ? options.minWidth : 0;
        options.minHeight = options.minHeight ? options.minHeight : 0;
        options.maxWidth = options.maxWidth ? options.maxWidth : 0;
        options.maxHeight = options.maxHeight ? options.maxHeight : 0;
        if (!options.width && !options._width) options._width = options.minWidth ? options.minWidth : options.maxWidth;
        if (!options.height && !options._height) options._height = options.minHeight ? options.minHeight : options.maxHeight;
        if (options._hidePorts)
            options.ports = [];
        return $.extend(true, {}, ej.datavisualization.Diagram.NodeDefaults, ej.datavisualization.Diagram.NodeBase(options), ej.datavisualization.Diagram.Shape(options));
    };
    //#endregion
    //#region Connector
    ej.datavisualization.Diagram.ConnectorDefaults = {
        name: "",
        visible: true,
        lineDashArray: "",
        targetDecorator:
            {
                shape: ej.datavisualization.Diagram.DecoratorShapes.Arrow,
                width: 8,
                height: 8,
                borderColor: "black",
                fillColor: "black",
                pathData: ""
            },
        sourceDecorator:
            {
                shape: ej.datavisualization.Diagram.DecoratorShapes.Arrow,
                width: 8,
                height: 8,
                borderColor: "black",
                fillColor: "black",
                pathData: ""
            },
        shape: undefined,
        segments: [ej.datavisualization.Diagram.Segment({ type: "straight" })],
        sourcePoint: ej.datavisualization.Diagram.Point(),
        targetPoint: ej.datavisualization.Diagram.Point(),
        lineColor: "black",
        lineWidth: 1,
        constraints: ej.datavisualization.Diagram.ConnectorConstraints.Default,
        opacity: 1,
        parent: "",
        labels: [],
        zOrder: -1,
        lineHitPadding: 10,
        addInfo: {},
        targetNode: null,
        targetPort: null,
        sourceNode: null,
        sourcePort: null,
        marginLeft: 0,
        marginTop: 0,
        marginRight: 0,
        marginBottom: 0,
        horizontalAlign: ej.datavisualization.Diagram.HorizontalAlignment.Left,
        verticalAlign: ej.datavisualization.Diagram.VerticalAlignment.Top,
        cornerRadius: 0,
        bridgeSpace: 10,
        sourcePadding: 0,
        targetPadding: 0,
        type: "connector",
        cssClass: ""
    };
    ej.datavisualization.Diagram.Connector = function (options) {
        options = options || {};
        options.name = options.name ? options.name : ej.datavisualization.Diagram.Util.randomId();
        options.targetDecorator = ej.datavisualization.Diagram.Decorator(options.targetDecorator || {});
        options.sourceDecorator = ej.datavisualization.Diagram.Decorator((options.sourceDecorator && !$.isEmptyObject(options.sourceDecorator)) ? options.sourceDecorator : { shape: ej.datavisualization.Diagram.DecoratorShapes.None });
        options.segments = options.segments || [ej.datavisualization.Diagram.Segment({ type: "straight" })];
        options._srcDecoratorSize = Math.max(parseInt(options.sourceDecorator.height), parseInt(options.sourceDecorator.width)) + 5 * options.sourceDecorator.borderWidth;
        options._tarDecoratorSize = Math.max(parseInt(options.targetDecorator.height), parseInt(options.targetDecorator.width)) + 5 * options.targetDecorator.borderWidth;
        options._inlineDecorators = [];
        if (options.segments) {
            options.sourcePoint = options.sourcePoint || ej.datavisualization.Diagram.Point();
            options.targetPoint = options.targetPoint || ej.datavisualization.Diagram.Point();
            ej.datavisualization.Diagram.Util._initializeSegments(options, options.defaultType);
        }
        if (options.labels)
            for (var i = 0; i < options.labels.length; i++) {
                options.labels[i] = ej.datavisualization.Diagram.Label(options.labels[i]);
            }
        if (options.tooltip) {
            options.tooltip = ej.datavisualization.Diagram.Tooltip(options.tooltip);
        }
        options.paletteItem = ej.datavisualization.Diagram.PaletteItem(options.paletteItem ? options.paletteItem : {});
        return $.extend(true, {}, ej.datavisualization.Diagram.ConnectorDefaults, options);
    };
    //#endregion
    //#region Container
    ej.datavisualization.Diagram.ContainerDefaults = {
        type: ej.datavisualization.Diagram.ContainerType.Canvas,
        orientation: "vertical",
    };
    ej.datavisualization.Diagram.Container = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ContainerDefaults, options);
    };
    // #endregion
    //#region Group
    ej.datavisualization.Diagram.GroupDefaults = {
        children: [],
        canUngroup: true,
        allowDrop: true,
        container: null,
        paddingLeft: 0,
        paddingTop: 0,
        paddingRight: 0,
        paddingBottom: 0,
        minWidth: 100,
        maxWidth: Number.POSITIVE_INFINITY,
        minHeight: 100,
        maxHeight: Number.POSITIVE_INFINITY,
        type: "group"
    };
    ej.datavisualization.Diagram.Group = function (options) {
        options = options ? options : {};
        if (options.type == "bpmn") options = ej.datavisualization.Diagram.Node(options);
        options.minWidth = options.minWidth ? options.minWidth : 100;
        options.minHeight = options.minHeight ? options.minHeight : 100;
        options.maxWidth = options.maxWidth ? options.maxWidth : Number.POSITIVE_INFINITY;
        options.maxHeight = options.maxHeight ? options.maxHeight : Number.POSITIVE_INFINITY;
        options.container = options.container ? ej.datavisualization.Diagram.Container(options.container) : null;
        options.fillColor = options.fillColor ? options.fillColor : "transparent";
        options.borderColor = options.borderColor ? options.borderColor : "transparent";
        if (options && !options.name) {
            options.name = "group_" + ej.datavisualization.Diagram.Util.randomId();
        }
        if (options.tooltip) {
            options.tooltip = ej.datavisualization.Diagram.Tooltip(options.tooltip);
        }
        if (!options._type && !(options.type == "umlclassifier")) options._type = options.type ? options.type : "group";
        return $.extend(true, {}, ej.datavisualization.Diagram.NodeDefaults, ej.datavisualization.Diagram.GroupDefaults, ej.datavisualization.Diagram.NodeBase(options));
    };
    //#endregion
    //#region ZoomCommand
    ej.datavisualization.Diagram.ZoomCommand = {
        ZoomIn: 1,
        ZoomOut: 2
    };
    ej.datavisualization.Diagram.Zoom = function (options) {
        return $.extend(true, {}, { zoomFactor: 0.2, focusPoint: null, zoomCommand: ej.datavisualization.Diagram.ZoomCommand.ZoomIn }, options);
    };
    //#endregion
    ej.datavisualization.Diagram.DragState = {
        Starting: "starting",
        Dragging: "dragging",
        Completed: "completed"
    };
    ej.datavisualization.Diagram.ResizeState = {
        Starting: "starting",
        Resizing: "resizing",
        Completed: "completed"
    };
    ej.datavisualization.Diagram.DiagramConstraints = {
        None: 1 << 0,
        UserInteraction: 1 << 1,
        APIUpdate: 1 << 2,
        PageEditable: 1 << 1 | 1 << 2,
        Bridging: 1 << 3,
        Zoomable: 1 << 4,
        PannableX: 1 << 5,
        PannableY: 1 << 6,
        Pannable: 1 << 5 | 1 << 6,
        Undoable: 1 << 7,
        Resizable: 1 << 8,
        ZoomTextEditor: 1 << 9,
        FloatElements: 1 << 10,
        CrispEdges: 1 << 11,
        Default: 1 << 1 | 1 << 2 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7 | 1 << 8
    };
    ej.datavisualization.Diagram.BridgeDirection = {
        Top: "top",
        Bottom: "bottom",
        Left: "left",
        Right: "right"
    };
    ej.datavisualization.Diagram.Tool = {
        None: 1 << 0,
        SingleSelect: 1 << 1,
        MultipleSelect: 1 << 2,
        ZoomPan: 1 << 3,
        DrawOnce: 1 << 4,
        ContinuesDraw: 1 << 5
    };
    ej.datavisualization.Diagram.Region = {
        Content: "content",
        PageSettings: "pageSettings"
    };
    ej.datavisualization.Diagram.FileFormats = {
        JPG: "jpg",
        PNG: "png",
        BMP: "bmp",
        SVG: "svg"
    };
    ej.datavisualization.Diagram.ExportModes = {
        Download: "download",
        Data: "data"
    };
    ej.datavisualization.Diagram.FitMode = {
        Page: "page",
        Width: "width",
        Height: "height"
    };
    ej.datavisualization.Diagram.Stretch = {
        None: "none",
        Fill: "fill",
        Uniform: "uniform",
        UniformToFill: "uniformtofill"
    };
    ej.datavisualization.Diagram.shapeType = {
        Image: "image",
        Path: "path",
        Native: "native"
    };

    //#endregion
    //#region UserHandle
    ej.datavisualization.Diagram.UserHandleDefaults = {
        name: "",
        pathData: "",
        templateId: "",
        source: "",
        shape: ej.datavisualization.Diagram.shapeType.Path,
        borderColor: "",
        backgroundColor: "#2382c3",
        position: ej.datavisualization.Diagram.UserHandlePositions.BottomCenter,
        pathColor: "white",
        tool: "",
        size: 20,
        visible: true,
        enableMultiSelection: false
    };
    ej.datavisualization.Diagram.UserHandle = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.UserHandleDefaults, options);
    };
    //#endregion
    //#region Swimlane
    ej.datavisualization.Diagram.SwimLaneDefaults = {
        header: $.extend(true, {}, ej.datavisualization.Diagram.LabelDefaults, {
            text: "Title",
            borderColor: "black",
            fillColor: "#C7D4DF",
            horizontalAlignment: ej.datavisualization.Diagram.HorizontalAlignment.Stretch,
            verticalAlignment: ej.datavisualization.Diagram.VerticalAlignment.Stretch
        }),
        fillColor: "transparent",
        orientation: "vertical",
        type: "group",
        isSwimlane: true,
        offsetX: 100,
        offsetY: 100,
        minHeight: 100,
        maxHeight: Number.POSITIVE_INFINITY,
        minWidth: 100,
        maxWidth: Number.POSITIVE_INFINITY,
        height: 100,
        width: 100,
        lanes: [],
        phases: [],
        phaseSize: 20,
        constraints: ej.datavisualization.Diagram.NodeConstraints.Default | ej.datavisualization.Diagram.NodeConstraints.AllowDrop & ~(ej.datavisualization.Diagram.NodeConstraints.ResizeNorth |
                      ej.datavisualization.Diagram.NodeConstraints.ResizeWest | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest |
                  ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest),
        addInfo: {},
        cssClass: ""
    };
    ej.datavisualization.Diagram.SwimLane = function (options) {
        options = options || {};
        if (options && !options.name) {
            options.name = "swimlane_" + ej.datavisualization.Diagram.Util.randomId();
        }
        if (options.tooltip) {
            options.tooltip = ej.datavisualization.Diagram.Tooltip(options.tooltip);
        }
        if (!options.header)
            options.header = {};
        options.header.height = options.header.height ? options.header.height : 50;
        options.header.width = options.header.width ? options.header.width : 50;

        return $.extend(true, {}, ej.datavisualization.Diagram.SwimLaneDefaults, options);
    };
    //#endregion  
    //#region Lane
    ej.datavisualization.Diagram.LaneDefaults = {
        header: $.extend(true, {}, ej.datavisualization.Diagram.LabelDefaults, {
            text: "Function",
            borderColor: "black",
            fillColor: "#C7D4DF",
            horizontalAlignment: ej.datavisualization.Diagram.HorizontalAlignment.Stretch,
            verticalAlignment: ej.datavisualization.Diagram.VerticalAlignment.Stretch
        }),
        name: "",
        children: [],
        isLane: true,
        orientation: "horizontal",
        fillColor: "#f5f5f5",
        labels: [],
        addInfo: {},
        minHeight: 100,
        minWidth: 100,
        maxHeight: Number.POSITIVE_INFINITY,
        maxWidth: Number.POSITIVE_INFINITY,
        constraints: ej.datavisualization.Diagram.NodeConstraints.Default | ej.datavisualization.Diagram.NodeConstraints.AllowDrop & ~ej.datavisualization.Diagram.NodeConstraints.Connect,
        cssClass: ""
    };
    ej.datavisualization.Diagram.Lane = function (options) {
        options = options || {};
        if (options && !options.name) {
            options.name = "lane_" + ej.datavisualization.Diagram.Util.randomId();
        }
        if (options.tooltip) {
            options.tooltip = ej.datavisualization.Diagram.Tooltip(options.tooltip);
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.LaneDefaults, options);
    };
    //#endregion  
    //#region phase
    ej.datavisualization.Diagram.PhaseDefaults = {
        name: "",
        type: "phase",
        offset: 100,
        lineWidth: 1,
        lineDashArray: "3,3",
        lineColor: "#606060",
        parent: "",
        fillColor: "white",
        orientation: "horizontal",
        label: { text: "Phase" }
    };
    ej.datavisualization.Diagram.Phase = function (options) {
        if (options.label) {
            options.label = ej.datavisualization.Diagram.Label(options.label);
            if (!options._UndoRedo)
            options.label.text = options.label.text ? options.label.text : "Phase"
        }
        return $.extend(true, {}, ej.datavisualization.Diagram.PhaseDefaults, options);
    };
    //#endregion 
    //#region paletteItem
    ej.datavisualization.Diagram.PaletteItemDefaults = {
        width: undefined,
        height: undefined,
        enableScale: true,
        previewHeight: undefined,
        previewWidth: undefined,
        wrapping: ej.datavisualization.Diagram.TextWrapping.NoWrap,
        label: null,
        margin: ej.datavisualization.Diagram.Margin({ left: 4, right: 4, top: 4, bottom: 4 })
    };
    ej.datavisualization.Diagram.PaletteItem = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.PaletteItemDefaults, options);
    };
    //#endregion 
    ej.datavisualization.Diagram.SwimLaneHelper = {
        //#region diagram
        _initSwimLane: function (obj, diagram, headAdded) {
            var canvas = null;
            var lanes = null;
            var obj = ej.datavisualization.Diagram.SwimLane(obj);
            obj.orientation = obj.orientation ? obj.orientation : "vertical";
            var phases = this._initphases(obj, diagram);
            lanes = this._initLanes(obj, diagram, headAdded);
            var childern = [];
            var header = null;
            if (!obj.header) {
                obj.header = { text: "", height: 0, fillColor: "white" };
            }
            if (obj.orientation === "horizontal") {
                var height = obj.header.height;
            } else {
                var width = obj.header.width;
            }
            if (obj.header) {
                header = ej.datavisualization.Diagram.Node({
                    _type: "node",
                    _isHeader: true,
                    name: obj.name + "_header_swimlane",
                    labels: [obj.header],
                    height: height ? height : 50,
                    width: width ? width : 50,
                    fillColor: obj.header.fillColor ? obj.header.fillColor : "white",
                    rotateAngle: 0,
                    constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect,
                    horizontalAlign: "stretch",
                    parent: obj.name,
                });
            }
            if (header) {
                diagram.nodes().push(header);
                diagram._nodes = $.extend(true, [], diagram.nodes());
                diagram.nameTable[header.name] = header;
                childern.push(header.name);
            }
            //var phaseNode = this._initPhaseNode(obj, diagram, childern);
            var seprtrValue = null;
            if (obj.phaseSize == 0)
                var seprtrValue = 0.001;
            else
                var seprtrValue = obj.phaseSize ? obj.phaseSize : 20;
            var PhaseStack = this._initPhaseStack(obj, diagram, childern, seprtrValue);
            var hAlign = null, vAlign = null;
            if (obj.orientation == "vertical")
                vAlign = "stretch";
            else
                hAlign = "stretch";
            var orientation, marginLeft = 0, marginTop = 0, minHeight = 0;
            if (obj.orientation == "horizontal") {
                orientation = "vertical";
                marginTop = (obj.header ? obj.header.height : 50) + seprtrValue;
                minHeight = 0;
            }
            else {
                orientation = "horizontal";
                marginTop = (obj.header ? obj.header.height : 50);
                marginLeft = (obj.phaseSize ? obj.phaseSize : seprtrValue);
                minHeight = (obj.header ? obj.header.height : 50) + seprtrValue;
            }
            var stack = ej.datavisualization.Diagram.Group({
                name: obj.name + "_stack",
                children: lanes,
                parent: obj.name,
                container: { type: ej.datavisualization.Diagram.ContainerType.Stack, orientation: orientation },
                horizontalAlign: "stretch",
                verticalAlign: "stretch",
                marginTop: marginTop,
                width: 10,
                height: 10,
                marginLeft: marginLeft,
                minHeight: minHeight,
                constraints: ej.datavisualization.Diagram.NodeConstraints.Default & ~
                    (ej.datavisualization.Diagram.NodeConstraints.Select | ej.datavisualization.Diagram.NodeConstraints.Connect),
            });
            var cW = 0, cH = 0;
            if (obj.orientation == "horizontal") {
                cW = obj.width;
                cH = 100;
            }
            else if (obj.orientation == "vertical") {
                cW = 100;
                cH = obj.height - header.height;
            }
            diagram.nodes().push(stack);
            diagram._nodes = $.extend(true, [], diagram.nodes());
            diagram.nameTable[stack.name] = stack;
            childern.push(stack.name);
            canvas = ej.datavisualization.Diagram.Group({
                name: obj.name ? obj.name : "",
                type: "group",
                addInfo: obj.addInfo ? obj.addInfo : {},
                parent: "",
                offsetX: obj.offsetX ? obj.offsetX : 100,
                offsetY: obj.offsetY ? obj.offsetY : 100,
                children: childern,
                zOrder: (obj.zOrder || obj.zOrder === 0) ? obj.zOrder : -1,
                fillColor: "transparent",
                labels: [{ mode: ej.datavisualization.Diagram.LabelEditMode.View }],
                container: { type: ej.datavisualization.Diagram.ContainerType.Canvas, },
                minHeight: cH ? cH : 100,
                maxHeight: obj.maxHeight ? obj.maxHeight : Number.POSITIVE_INFINITY,
                minWidth: cW ? cW : 100,
                maxWidth: obj.maxWidth ? obj.maxWidth : Number.POSITIVE_INFINITY,
                constraints: obj.constraints ? obj.constraints | ej.datavisualization.Diagram.NodeConstraints.AllowDrop : (ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.AllowDrop ^ ej.datavisualization.Diagram.NodeConstraints.ResizeNorth ^
                        ej.datavisualization.Diagram.NodeConstraints.ResizeWest ^ ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest ^
                    ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast ^ ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest),
                phaseSize: seprtrValue,
                cssClass: obj.cssClass
            });
            //diagram._setZorder(canvas);
            canvas.isSwimlane = true;
            //this.nodes().push(canvas);
            canvas.phases = phases;
            canvas.orientation = obj.orientation;
            if (canvas.orientation == "horizontal")
                canvas.constraints = canvas.constraints ^ ej.datavisualization.Diagram.NodeConstraints.ResizeEast ^ ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast;
            else
                canvas.constraints = canvas.constraints ^ ej.datavisualization.Diagram.NodeConstraints.ResizeSouth ^ ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast;
            return canvas;
        },
        _initPhaseStack: function (obj, diagram, children, seprtrValue) {
            var orientation = "horizontal", horizontalAlign = "left", verticalAlign = "top", isHoizon;
            if (orientation) {
                if (obj.orientation == "horizontal") {
                    orientation = "horizontal";
                    horizontalAlign = "stretch";
                    isHoizon = true;
                }
                else {
                    orientation = "vertical";
                    verticalAlign = "stretch";
                    isHoizon = false;
                }
            }
            var phaseStack = ej.datavisualization.Diagram.Group({
                name: obj.name + "phaseStack",
                container: { type: "stack", orientation: orientation },
                type: "group",
                parent: obj.name,
                offsetX: 0,
                offsetY: 0,
                minHeight: seprtrValue,
                maxHeight: seprtrValue,
                minWidth: seprtrValue,
                maxWidth: seprtrValue,
                marginTop: obj.header ? obj.header.height : 50,
                isPhaseStack: true,
                constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect
                //horizontalAlign: horizontalAlign,
                //verticalAlign: verticalAlign,
            });
            var df = 0;
            var rotateAngle = 0;
            if (obj.phaseSize) {
                obj.phaseSize = obj.phaseSize < 1 ? 20 : obj.phaseSize;
            }
            var height, width;
            for (var i = 0; i < obj.phases.length; i++) {
                if (isHoizon) {
                    height = obj.phaseSize ? obj.phaseSize : 20;
                    width = obj.phases[i].offset - df;
                }
                else {
                    height = obj.phases[i].offset - df;
                    if (i == 0)
                        height = height - (obj.header ? obj.header.height : 50);//added swimlane header height
                    width = obj.phaseSize ? obj.phaseSize : 20;
                    if (obj.phases[i].label)
                        obj.phases[i].label.rotateAngle = 270;
                }
                var node = ej.datavisualization.Diagram.Node({
                    parent: obj.name + "phaseStack",
                    _isHeader: true,
                    name: "phaseStack" + obj.phases[i].name,
                    height: height, width: width,
                    labels: [obj.phases[i].label],
                    constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect
                });
                node.labels[0].name = "phaseStack" + obj.phases[i].name + "label",
                node.labels[0].mode = ej.datavisualization.Diagram.LabelEditMode.View,
                node.isPhase = true;
                df = obj.phases[i].offset;
                diagram.nameTable[node.name] = node;
                phaseStack.children.push(node.name);
                diagram.nodes().push(node);
                diagram._nodes = $.extend(true, [], diagram.nodes());
            }
            diagram.nodes().push(phaseStack);
            diagram._nodes = $.extend(true, [], diagram.nodes());
            children.push(phaseStack);
            diagram.nameTable[phaseStack.name] = phaseStack;
        },

        _setDefaultLaneProperties: function (obj) {
            obj.lanes = obj.lanes ? obj.lanes : [];
            obj.lanes.push(ej.datavisualization.Diagram.Lane({}))
        },

        _initLanes: function (obj, diagram, headAdded) {
            var lanes = [], lane = null;
            if (!obj.lanes || obj.lanes.length === 0) {
                this._setDefaultLaneProperties(obj);
            }
            if (obj.lanes) {
                for (var i = 0; i < obj.lanes.length; i++) {
                    if (jQuery.isEmptyObject(obj.lanes[i])) {
                        obj.lanes[i] = ej.datavisualization.Diagram.Lane();
                    }
                    obj.lanes[i]._laneHeader = obj.lanes[i]._laneHeader ? obj.lanes[i]._laneHeader : obj.lanes[i].header
                    lane = this._initLane(obj.lanes[i], obj, diagram, headAdded);
                    lanes.push(lane.name);
                    diagram.nodes().push(lane);
                    diagram._nodes = $.extend(true, [], diagram.nodes());
                    diagram.nameTable[lane.name] = lane;
                }
            }
            return lanes;
        },
        _initLane: function (laneobj, obj, diagram, headAdded) {
            var hAlign = null, vAlign = null;
            if (obj.orientation == "horizontal")
                hAlign = "stretch";
            else vAlign = "stretch";
            var success = false;
            var lane = ej.datavisualization.Diagram.Group({
                name: laneobj.name,
                addInfo: laneobj.addInfo ? laneobj.addInfo : {},
                type: "group",
                isLane: true,
                parent: obj.name + "_stack",
                offsetX: 0,
                offsetY: 0,
                borderColor: laneobj.borderColor ? laneobj.borderColor : "black",
                orientation: obj.orientation ? obj.orientation : "horizontal",
                fillColor: laneobj.fillColor,
                container: { type: ej.datavisualization.Diagram.ContainerType.Canvas, },
                horizontalAlign: hAlign ? hAlign : "left",
                verticalAlign: vAlign ? vAlign : "top",
                minHeight: laneobj.height ? laneobj.height : 100,
                maxHeight: laneobj.maxHeight ? laneobj.maxHeight : Number.POSITIVE_INFINITY,
                minWidth: laneobj.width ? laneobj.width : 100,
                maxWidth: laneobj.maxWidth ? laneobj.maxWidth : Number.POSITIVE_INFINITY,
                paddingTop: 20,
                paddingRight: 20,
                paddingBottom: 20,
                paddingLeft: 20,
                constraints: laneobj.constraints ? laneobj.constraints | ej.datavisualization.Diagram.NodeConstraints.AllowDrop : (ej.datavisualization.Diagram.NodeConstraints.Default | ej.datavisualization.Diagram.NodeConstraints.AllowDrop & ~ej.datavisualization.Diagram.NodeConstraints.Connect),
                cssClass: laneobj.cssClass
            });
            if (laneobj.labels && laneobj.labels.length > 0) {
                for (var h = 0; h < laneobj.labels.length; h++) {
                    laneobj.labels[h] = ej.datavisualization.Diagram.Label(laneobj.labels[h]);
                }
                lane.labels = laneobj.labels;
            }
            if (!headAdded) {
                var laneHeader = laneobj._laneHeader ? laneobj._laneHeader : null;
                var header = this._iniLaneHeader(laneobj, lane.name, obj, diagram, laneHeader);
                if (header) {
                    diagram.nodes().push(header);
                    diagram._nodes = $.extend(true, [], diagram.nodes());
                    diagram.nameTable[header.name] = header;
                    lane.children.push(header.name);
                }
            }
            var laneChildren;
            laneChildren = this._initChildren(laneobj, lane.name, diagram);
            for (var i = 0; i < laneChildren.length; i++) {
                lane.children.push(laneChildren[i]);
            }

            return lane;
        },
        _iniLaneHeader: function (headObj, parentName, obj, diagram, laneHeader) {
            var node = null;
            if (headObj.header) {
                node = ej.datavisualization.Diagram.Node({
                    _isHeader: true,
                    name: parentName + "_Headerr_",
                    type: "node",
                    labels: [obj.header],
                    height: laneHeader.height ? laneHeader.height : 50,
                    width: laneHeader.width ? laneHeader.width : 50,
                    fillColor: headObj.header.fillColor ? headObj.header.fillColor : "white",
                    rotateAngle: 0,
                    constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect,
                    marginLeft: -20,
                    marginTop: -20,
                    marginRight: -20,
                    marginBottom: -20,
                    parent: parentName,
                });
                if (obj.orientation && obj.orientation == "horizontal") {
                    node.verticalAlign = "stretch";
                    node.height = 1;
                    node.width = laneHeader.width ? laneHeader.width : 50;
                }
                else if (obj.orientation && obj.orientation == "vertical") {
                    node.horizontalAlign = "stretch";
                    node.labels[0].rotateAngle = 0;
                    node.height = laneHeader.width ? laneHeader.width : 50;
                    node.width = 1;
                }
            }
            return node;
        },
        _initChildren: function (laneObj, parentName, diagram) {
            var children = [], child = null;
            if (laneObj.children) {
                for (var i = 0; i < laneObj.children.length; i++) {
                    if (typeof laneObj.children[i] == "object") {
                        if (laneObj.type && laneObj.type === "bpmn")
                            child = laneObj.children[i]
                        else
                            child = this._initChild(laneObj.children[i], parentName, diagram);
                    }
                    else
                        child = diagram.nameTable[laneObj.children[i]];
                    if (child) {
                        if (!child.segments) {
                            if (child.children)
                                var childNodes = this._initChildren(child, child.name, diagram);
                            if (childNodes) child.children = childNodes;
                            diagram.nodes().push(child);
                            diagram._nodes = $.extend(true, [], diagram.nodes());
                        }
                        else {
                            diagram.connectors().push(child);
                            diagram._connectors = $.extend(true, [], diagram.connectors());
                        }
                        children.push(child.name);
                        diagram.nameTable[child.name] = child;
                    }
                }
            }
            return children;
        },
        _initChild: function (child, parentName, diagram) {
            var node = null;
            if (child && child.children && child.children.length > 0) {
                node = diagram._getNewGroup(ej.datavisualization.Diagram.NodeType(child, diagram))
            }
            else
                node = diagram._getNewNode(ej.datavisualization.Diagram.NodeType(child, diagram));
            node.parent = parentName;
            return node;
        },
        _swapPhaseSize: function (obj) {
            if (obj.phases.length > 0) {
                var phases = obj.phases, i, j, temp;
                for (i = 0; i < phases.length; i++) {
                    for (j = 0; j < (phases.length - i - 1) ; j++) {
                        if (phases[j].offset > phases[j + 1].offset) {
                            temp = phases[j];
                            phases[j] = phases[j + 1];
                            phases[j + 1] = temp;
                        }
                    }
                }
            }
        },
        _setSwimlaneSize: function (obj) {
            if (obj.phases.length > 0) {
                var phase;
                for (var i in obj.phases) {
                    phase = obj.phases[i];
                    if (obj.orientation === "horizontal") {
                        if (phase.offset > obj.width)
                            obj.width = phase.offset;
                    }
                    else {
                        if (phase.offset > obj.height)
                            obj.height = phase.offset;
                    }
                }
            }
        },
        _setLastPhaseSize: function (obj) {
            if (obj.phases.length > 0) {
                var lastPhase = obj.phases[obj.phases.length - 1];
                if (obj.orientation === "horizontal")
                    lastPhase.offset = obj.width;
                else
                    lastPhase.offset = obj.height;
            }
        },
        _NeedDefaultPhase: function (obj, offset) {
            if (obj.phases.length > 0)
                return false;
            return true;
        },
        _checkForDefPhase: function (obj) {
            if (obj.phases.length > 0)
                return false;
            return true;
        },
        _initphases: function (obj, diagram) {
            var phases = [];
            var phase = null, angle = 0;
            //if (!diagram.model.phases)
            //    diagram.model.phases = [];
            var offset = 0;

            if (obj.orientation === "vertical") {
                offset = obj.height;
                angle = 270;
            }
            else {
                offset = obj.width;
            }
            var defPhase = ej.datavisualization.Diagram.Phase({ name: obj.name + "defPhase", offset: offset, label: obj._lastPhase ? obj._lastPhase.labels[0] : { text: "Phase", rotateAngle: angle } });
            if (this._NeedDefaultPhase(obj))
                obj.phases.push(defPhase);
            else {
                this._swapPhaseSize(obj);
                this._setSwimlaneSize(obj);
                this._setLastPhaseSize(obj);
            }
            if (obj.phases && obj.phases.length > 0) {
                for (var i = 0; i < obj.phases.length; i++) {
                    phase = ej.datavisualization.Diagram.Phase(obj.phases[i]);
                    phase.parent = obj.name;
                    phase.orientation = obj.orientation;
                    //diagram.model.phases.push(phase);
                    diagram.nameTable[phase.name] = phase;
                    phases.push(phase.name);
                }
            }
            return phases;
        },
        //#endregion
        //#region palette
        _createSwimlane: function (obj, diagram, data, fromObject, header) {
            var children = [], child = null, headAdded = false;
            var nameTable = data ? data.childTable : diagram.nameTable;
            var height = 500, width = 500;
            var headNode = null;
            var constraints = obj.constraints ? obj.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            if (obj.children[0]) {
                var node = fromObject ? obj.children[0] : nameTable[diagram._getChild(obj.children[0])];
                if (!node)
                    node = header;
                if (typeof (node) === "string")
                    node = nameTable[node];
                headNode = { text: "Title", width: 50, fillColor: node.fillColor ? node.fillColor : obj.fillColor, height: 50 };

            } else headNode = { text: "Title", width: 50, fillColor: "white", height: 50 };

            if (!obj.orientation) {
                if (obj.container)
                    obj.orientation = obj.container.orientation;
            }
            var swlnHeight = 0;
            if (obj.orientation == "horizontal" && diagram._selectedSymbol) {
                height = obj.height ? obj.height : 100;
                width = obj.width ? obj.width : 650;
                swlnHeight = height;
            } else {
                height = obj.height ? obj.height : 650;
                width = obj.width ? obj.width : 100;
                swlnHeight = obj.height + headNode.height
            }
            if (obj.children.length > 1) {
                obj.children.splice(0, 0);
                children = obj.children;
            }

            var nSwimLane = {
                name: obj.name + ej.datavisualization.Diagram.Util.randomId(),
                header: headNode,
                fillColor: "white",
                isSwimlane: true,
                minWidth: width,
                minHeight: height,
                height: swlnHeight + 1,
                width: width + 1,
                maxHeight: height + Number.POSITIVE_INFINITY,
                maxWidth: width + Number.POSITIVE_INFINITY,
                offsetX: obj.offsetX,
                offsetY: obj.offsetY,
                orientation: obj.orientation ? obj.orientation : "horizontal",
                addInfo: obj.addInfo ? obj.addInfo : null,
                paletteItem: obj.paletteItem ? obj.paletteItem : null,
                lanes: [
                    {
                        name: obj.name,
                        addInfo: obj.addInfo ? obj.addInfo : {},
                        constraints: constraints,
                        header: {
                            text: node.labels[0].text ? node.labels[0].text : "HEADER",
                            fontSize: node.labels[0].fontSize ? node.labels[0].fontSize : 11,
                            width: node.width ? node.width : 50,
                            height: node.height ? node.height : 50,
                            fillColor: node.fillColor,
                            bold: node.labels[0].bold ? true : false,
                            italic: node.labels[0].italic ? true : false,
                            fontFamily: node.labels[0].fontFamily ? node.labels[0].fontFamily : "Arial",
                            fontColor: node.labels[0].fontColor ? node.labels[0].fontColor : "black",
                        },
                        fillColor: obj.fillColor ? obj.fillColor : "white",
                        height: height,
                        width: width,
                        minHeight: height,
                        minWidth: width,
                        children: children ? children : [],
                        _laneHeader: obj._laneHeader ? obj._laneHeader : null
                    },
                ]
            };
            //var item = this._initSwimLane(ej.datavisualization.Diagram.SwimLane(nSwimLane), diagram, headAdded);
            var item = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, nSwimLane);
            return item;
        },
        _createDiagramLane: function (obj, nameTable) {
            var objLane = obj._lane ? obj._lane : null;
            var orientation = obj.orientation;
            var constraints = obj.constraints ? obj.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            var lane = {
                children: [
                    {
                        name: obj.name + "_Headerr_",
                        height: objLane.header ? objLane.header.height : 50,
                        width: objLane.header ? objLane.header.width : 50,
                        fillColor: objLane.header ? objLane.header.fillColor : 50,
                        labels: objLane.header ? [objLane.header] : [],
                        horizontalAlign: orientation === "vertical" ? "stretch" : "left",
                        verticalAlign: orientation === "vertical" ? "top" : "stretch",
                    }
                ],
                container: { type: "canvas" },
                name: obj.name ? obj.name : ej.datavisualization.Diagram.Util.randomId(),
                minHeight: objLane.minHeight ? objLane.minHeight : 100,
                minWidth: objLane.minWidth ? objLane.minWidth : 100,
                maxHeight: Number.POSITIVE_INFINITY,
                maxWidth: Number.POSITIVE_INFINITY,
                borderColor: "black",
                constraints: constraints | ej.datavisualization.Diagram.NodeConstraints.AllowDrop & ~ej.datavisualization.Diagram.NodeConstraints.Connect,
                cssClass: objLane.cssClass ? objLane.cssClass : "",
                addInfo: objLane.addInfo ? objLane.addInfo : null,
                paletteItem: obj.paletteItem ? obj.paletteItem : null,
                fillColor: objLane.fillColor ? objLane.fillColor : "white",
                isLane: true,
                offsetX: obj.offsetX ? obj.offsetX : 100,
                offsetY: obj.offsetY ? obj.offsetY : 100,
                orientation: orientation ? orientation : "horizontal"
            };
            lane.children[0].labels[0].rotateAngle = orientation === "horizontal" ? 270 : 0;
            return lane;
        },
        _createPaletteLane: function (obj, nameTable) {
            var height = 0, width = 0, offsetX = 0, offsetY = 0, rotateAngle = 0, mleft = 0, mTop = 0, align = "left";
            var offx = 0, offY = 0;
            obj = ej.datavisualization.Diagram.Lane(obj);
            var constraints = obj.constraints ? obj.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            if (obj.paletteItem && !obj.paletteItem.enableScale && !obj.paletteItem.width) {
                if (obj.orientation === "horizontal") {
                    offx += 2;
                }
            }
            if (obj.orientation == "horizontal") {
                height = obj.height ? obj.height : 50;
                width = 25;
                offsetX = 14 + offx;
                offsetY = height / 2 + 1;
                rotateAngle = 270;
                align = "left";
            }
            else if (obj.orientation == "vertical") {
                height = 25;
                width = obj.width ? obj.width : 50;
                offsetX = width / 2;
                offsetY = 15;
                align = "left";
            }
            var name = obj.header.text ? obj.header.text : "";
            var header = ej.datavisualization.Diagram.Node({
                name: obj.name + "_" + name,
                _type: "node",
                labels: [
                    { text: obj.header.text ? obj.header.text : "Function", fontSize: obj.header.fontSize ? obj.header.fontSize : 11, offset: { x: 0.5, y: .5 }, width: 100, rotateAngle: rotateAngle, }
                ],
                height: height,
                width: width,
                fillColor: obj.header.fillColor ? obj.header.fillColor : "white",
                //constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select,
                parent: obj.name,
                offsetX: offsetX,
                offsetY: offsetY,
                constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Connect,
            });
            nameTable[header.name] = header;
            if (obj.orientation == "horizontal") {
                height = obj.height;
                width = obj.width - 25;
                offsetX = 25 + width / 2 + offx;
                offsetY = height / 2 + 1;
            }
            else if (obj.orientation == "vertical") {
                height = obj.height - 25;
                width = obj.width;
                offsetX = width / 2;
                offsetY = 25 + height / 2;
            }
            var content = ej.datavisualization.Diagram.Node({
                name: obj.name + "content",
                _type: "node",
                height: height,
                width: width,
                fillColor: obj.fillColor ? obj.fillColor : "white",
                //constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select,
                parent: obj.name,
                offsetX: offsetX,
                offsetY: offsetY,
            });
            content._laneHeader = obj.header;
            nameTable[content.name] = content;
            var group = ej.datavisualization.Diagram.Group({
                name: obj.name + "_group",
                addInfo: obj.addInfo ? obj.addInfo : {},
                height: obj.height,
                width: obj.width,
                header: obj.header ? obj.header : null,
                offsetX: obj.offsetX,
                offsetY: obj.offsetY,
                children: [header.name, content.name, ],
                paletteItem: obj.paletteItem ? obj.paletteItem : null,
            });
            group._lane = obj;
            group.constraints = constraints;
            group.isLane = true;
            group.orientation = obj.orientation;
            return group;
        },
        //#endregion
        //#region Map swimlane
        _mapObject: function (diagram, node, type, childTable) {
            var obj;
            switch (type) {
                case "lane":
                    obj = this._mapLane(diagram, node);
                    break;
                case "phase":
                    obj = this._mapPhase(diagram, node);
                    break;
                case "swimlane":
                    obj = this._mapSwimlane(diagram, node, childTable);
                    break;
            }
            return obj;
        },
        //#region for mapping the Lane
        _mapLane: function (diagram, lane, childTable) {
            var nLane = ej.datavisualization.Diagram.Lane();
            this._mapLaneHeader(diagram, lane, nLane, childTable);
            this._mapChildren(diagram, lane, nLane, childTable);
            nLane.name = lane.name;
            nLane.labels = lane.labels;
            nLane.fillColor = lane.fillColor;
            nLane.orientation = lane.orientation;
            nLane.maxHeight = lane.maxHeight;
            nLane.maxWidth = lane.maxWidth;
            nLane.minHeight = lane.height > lane.minHeight ? lane.height : lane.minHeight;
            nLane.minWidth = lane.width > lane.minWidth ? lane.width : lane.minWidth;
            nLane.constraints = lane.constraints;
            nLane.addInfo = lane.addInfo ? lane.addInfo : {};
            if (lane.orientation === "horizontal") {
                nLane.height = lane.height;
                nLane.width = null;
            }
            else {
                nLane.height = null;
                nLane.width = lane.width;
            }
            return nLane;
        },
        _mapLaneHeader: function (diagram, orgobj, clObj, childTable) {
            if (orgobj.children[0])
                var head = diagram.nameTable[diagram._getChild(orgobj.children[0])];
            if (!head && childTable)
                var head = childTable[diagram._getChild(orgobj.children[0])];
            if (head) {
                //clObj.header.name = head.name;
                if (head.labels && head.labels[0]) {
                    clObj.header.text = head.labels[0].text
                    clObj.header.fontColor = head.labels[0].fontColor
                    clObj.header.fontSize = head.labels[0].fontSize
                    clObj.header.fontFamily = head.labels[0].fontFamily
                    clObj.header.bold = head.labels[0].bold
                    clObj.header.italic = head.labels[0].italic
                    clObj.header.textDecoration = head.labels[0].textDecoration
                    clObj.header.rotateAngle = head.labels[0].rotateAngle
                    clObj.header.textOverflow = head.labels[0].textOverflow
                    clObj.header.overflowType = head.labels[0].overflowType
                }
                clObj.header.fillColor = head.fillColor;
                if (orgobj.orientation === "vertical") {
                    clObj.header.height = head.height;
                    clObj.header.width = null;
                }
                else {
                    clObj.header.height = null;
                    clObj.header.width = head.width;
                }
            }
        },
        _mapChildren: function (diagram, orgobj, clObj, childTable) {
            var child;
            if (orgobj.children && orgobj.children.length >= 2) {
                for (var i = 1; i < orgobj.children.length; i++) {
                    if (diagram._getChild(orgobj.children[i]))
                        child = diagram.nameTable[diagram._getChild(orgobj.children[i])];
                    if (childTable && !child)
                        child = childTable[diagram._getChild(orgobj.children[i])];
                    if (child) {
                        child.marginRight = 0;
                        child.marginBottom = 0;
                        clObj.children.push(child);
                    }
                }
            }
        },
        //#endregion 
        //#region for mapping the swimlane
        _mapSwimlane: function (diagram, swimlane, childTable) {
            var nSwimlane = ej.datavisualization.Diagram.SwimLane();
            this._mapSwimlaneHeader(diagram, swimlane, nSwimlane, childTable);
            this._mapLanes(diagram, swimlane, nSwimlane, childTable);
            this._mapPhases(diagram, swimlane, nSwimlane, childTable);
            nSwimlane.name = swimlane.name;
            nSwimlane.orientation = swimlane.orientation;
            nSwimlane.offsetX = swimlane.offsetX;
            nSwimlane.offsetY = swimlane.offsetY;
            nSwimlane.maxHeight = swimlane.maxHeight;
            nSwimlane.maxWidth = swimlane.maxWidth;
            nSwimlane.minHeight = swimlane.minHeight;
            nSwimlane.minWidth = swimlane.minWidth;
            if (nSwimlane.orientation === "horizontal")
                nSwimlane.minWidth = (swimlane.width && swimlane.minWidth && swimlane.width > swimlane.minWidth) ? swimlane.width : swimlane.minWidth;
            else
                nSwimlane.minWidth = swimlane.minWidth;
            nSwimlane.phaseSize = swimlane.phaseSize;
            nSwimlane.constraints = swimlane.constraints;
            nSwimlane.zOrder = swimlane.zOrder;
            nSwimlane.addInfo = swimlane.addInfo ? swimlane.addInfo : {};
            nSwimlane.height = swimlane.height;
            nSwimlane.width = swimlane.width;
            return nSwimlane;
        },
        _mapSwimlaneHeader: function (diagram, orgobj, clObj, childTable) {
            if (orgobj.children[0])
                var head = diagram.nameTable[diagram._getChild(orgobj.children[0])];
            if (!head && childTable)
                head = childTable[diagram._getChild(orgobj.children[0])];
            if (head) {
                if (head.labels && head.labels[0]) {
                    clObj.header.text = head.labels[0].text
                    clObj.header.fontColor = head.labels[0].fontColor
                    clObj.header.fontSize = head.labels[0].fontSize
                    clObj.header.fontFamily = head.labels[0].fontFamily
                    clObj.header.bold = head.labels[0].bold
                    clObj.header.italic = head.labels[0].italic
                    clObj.header.textDecoration = head.labels[0].textDecoration
                    clObj.header.textOverflow = head.labels[0].textOverflow
                    clObj.header.overflowType = head.labels[0].overflowType
                }
                clObj.header.fillColor = head.fillColor;
                clObj.header.height = head.height;
                clObj.header.width = head.width;
            }
        },
        _mapLanes: function (diagram, orgobj, clObj, childTable) {
            var laneStack, lane, nLane;
            if (orgobj.children[2] && diagram._getChild(orgobj.children[2]))
                laneStack = childTable ? childTable[diagram._getChild(orgobj.children[2])] : diagram.nameTable[diagram._getChild(orgobj.children[2])];
            if (laneStack && laneStack.children && laneStack.children.length > 0) {
                for (var i = 0; i < laneStack.children.length; i++) {
                    if (diagram._getChild(laneStack.children[i]))
                        lane = childTable ? childTable[diagram._getChild(laneStack.children[i])] : diagram.nameTable[diagram._getChild(laneStack.children[i])];
                    if (lane) {
                        nLane = this._mapLane(diagram, lane, childTable);
                        if (nLane) clObj.lanes.push(nLane);
                    }
                }

            }
        },
        _mapPhases: function (diagram, orgobj, clObj, childTable) {
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, orgobj, childTable);
            if (phases && phases.length > 0) {
                var length = phases.length;
                var nameTable = childTable ? childTable : diagram.nameTable;
                if (phases[phases.length - 1] && nameTable[phases[phases.length - 1]]) {
                    var lstPhse = nameTable[phases[phases.length - 1]];
                    if (!(lstPhse.name.split("defPhase").length > 1) && (lstPhse.offset != orgobj.width))
                        length++;
                }
                for (var i = 0; i < length; i++) {
                    var cphase = this._mapPhase(diagram, nameTable[diagram._getChild(phases[i])], childTable);
                    if (cphase) {
                        clObj.phases.push(cphase);
                    }
                }
                if (nameTable["phaseStack" + phases[phases.length - 1]])
                    clObj._lastPhase = this._mapPhase(diagram, nameTable["phaseStack" + phases[phases.length - 1]], childTable);
            }
        },
        //#endregion 
        //#region for mapping the Phase
        _mapPhase: function (diagram, phase, childTable) {
            var cphase;
            if (phase)
                cphase = childTable ? childTable[phase.name] : diagram.nameTable[phase.name];
            if (cphase)
                return cphase;
            else return null;
        },
        _getSwimLaneNode: function (node, selNode, isPhase, diagram) {
            if (node.isSwimlane) {
                if (isPhase) {
                    if (diagram.nameTable[diagram._getChild(node.children[2])].container.orientation == selNode.orientation)
                        return node;
                }
                else if (diagram.nameTable[diagram._getChild(node.children[2])].container.orientation != selNode.orientation)
                    return node;
            }
            if (node.parent) {
                var parent = diagram.nameTable[node.parent];
                if (parent) {
                    return this._getSwimLaneNode(parent, selNode, undefined, diagram);
                }
            }
            return null;
        }
        //#endregion 
        //#endregion 
    };
})(jQuery, Syncfusion);

;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej) {
    "use strict";
    ej.datavisualization.Diagram.BasicShapes = {
        Rectangle: "rectangle",
        Ellipse: "ellipse",
        Path: "path",
        Polygon: "polygon",
        Triangle: "triangle",
        Plus: "plus",
        Star: "star",
        Pentagon: "pentagon",
        Heptagon: "heptagon",
        Octagon: "octagon",
        Trapezoid: "trapezoid",
        Decagon: "decagon",
        RightTriangle: "righttriangle",
        Cylinder: "cylinder"
    };
    ej.datavisualization.Diagram.FlowShapes = {
        Process: "process",
        Decision: "decision",
        Document: "document",
        PreDefinedProcess: "predefinedprocess",
        Terminator: "terminator",
        PaperTap: "papertap",
        DirectData: "directdata",
        SequentialData: "sequentialdata",
        Sort: "sort",
        MultiDocument: "multidocument",
        Collate: "collate",
        SummingJunction: "summingjunction",
        Or: "or",
        InternalStorage: "internalstorage",
        Extract: "extract",
        ManualOperation: "manualoperation",
        Merge: "merge",
        OffPageReference: "offpagereference",
        SequentialAccessStorage: "sequentialaccessstorage",
        Annotation1: "annotation1",
        Annotation2: "annotation2",
        Data: "data",
        Card: "card"
    };
    ej.datavisualization.Diagram.ArrowShapes = {
        None: "none",
        CircularArrow: "circulararrow",
        CurvedRightArrow: "curvedrightarrow",
        CurvedUpArrow: "curveduparrow",
        CurvedLeftArrow: "curvedleftarrow",
        CurvedDownArrow: "curveddownarrow",
        JumpingRightArrow: "jumpingrightarrow",
        JumpingLeftArrow: "jumpingleftarrow"
    };
    ej.datavisualization.Diagram.BPMNShapes = {
        Event: "event",
        Gateway: "gateway",
        Message: "message",
        DataObject: "dataobject",
        DataSource: "datasource",
        Activity: "activity",
        Group: "group"
    };

    ej.datavisualization.Diagram.BPMNEvents = {
        Start: "start",
        Intermediate: "intermediate",
        End: "end",
        NonInterruptingStart: "noninterruptingstart",
        NonInterruptingIntermediate: "noninterruptingintermediate",
        ThrowingIntermediate: "throwingintermediate"
    };

    ej.datavisualization.Diagram.BPMNTriggers = {
        None: "none",
        Message: "message",
        Timer: "timer",
        Escalation: "escalation",
        Link: "link",
        Error: "error",
        Compensation: "compensation",
        Signal: "signal",
        Multiple: "multiple",
        Parallel: "parallel",
        Cancel: "cancel",
        Conditional: "conditional",
        Terminate: "terminate"
    };

    ej.datavisualization.Diagram.BPMNGateways = {
        None: "none",
        Exclusive: "exclusive",
        Inclusive: "inclusive",
        Parallel: "parallel",
        Complex: "complex",
        EventBased: "eventbased",
        ExclusiveEventBased: "exclusiveeventbased",
        ParallelEventBased: "paralleleventbased",
    };

    ej.datavisualization.Diagram.BPMNDataObjects = {
        None: "none",
        Input: "input",
        Output: "output",
    };

    ej.datavisualization.Diagram.BPMNActivity = {
        None: "none",
        Task: "task",
        SubProcess: "subprocess",
    };

    ej.datavisualization.Diagram.BPMNLoops = {
        None: "none",
        Standard: "standard",
        ParallelMultiInstance: "parallelmultiinstance",
        SequenceMultiInstance: "sequencemultiinstance"
    };
    ej.datavisualization.Diagram.BPMNTasks = {
        None: "none",
        Service: "service",
        Receive: "receive",
        Send: "send",
        InstantiatingReceive: "instantiatingreceive",
        Manual: "manual",
        BusinessRule: "businessrule",
        User: "user",
        Script: "script",
        Parallel: "parallel",
    };

    ej.datavisualization.Diagram.BPMNSubProcessTypes = {
        None: "none",
        Transaction: "transaction",
        Event: "event"
    };

    ej.datavisualization.Diagram.BPMNBoundary = {
        Default: "default",
        Call: "call",
        Event: "event",
    };
    ej.datavisualization.Diagram.BPMNAnnotationDirections = {
        Top: "top",
        Left: "left",
        Right: "right",
        Bottom: "bottom"
    };
    ej.datavisualization.Diagram.BPMNFlows = {
        Sequence: "sequence",
        Association: "association",
        Message: "message"
    };
    ej.datavisualization.Diagram.BPMNSequenceFlows = {
        Normal: "normal",
        Conditional: "conditional",
        Default: "default"
    };
    ej.datavisualization.Diagram.BPMNMessageFlows = {
        Default: "default",
        InitiatingMessage: "initiatingmessage",
        NonInitiatingMessage: "noninitiatingmessage"
    };
    ej.datavisualization.Diagram.ClassifierShapes = {
        Package: "package",
        Class: "class",
        Interface: "interface",
        Enumeration: "enumeration",
        CollapsedPackage: "collapsedpackage",
        Inheritance: "inheritance",
        Association: "association",
        Aggregation: "aggregation",
        Composition: "composition",
        Realization: "realization",
        DirectedAssociation: "directedassociation",
        Dependency: "dependency"
    };
    ej.datavisualization.Diagram.AssociationFlows = {
        Default: "default",
        Directional: "directional",
        BiDirectional: "bidirectional"
    };
    ej.datavisualization.Diagram.UMLActivityShapes = {
        Action: "action",
        Decision: "decision",
        MergeNode: "mergenode",
        InitialNode: "initialnode",
        FinalNode: "finalnode",
        ForkNode: "forknode",
        JoinNode: "joinnode",
        TimeEvent: "timeevent",
        AcceptingEvent: "acceptingevent",
        SendSignal: "sendsignal",
        ReceiveSignal: "receivesignal",
        StructuredNode: "structurednode",
        Note: "note"
    };
    ej.datavisualization.Diagram.UMLActivityFlow = {
        Object: "object",
        Control: "control",
        Exception: "exception"
    };
    ej.datavisualization.Diagram.BPMNEventDefaults = {
        event: ej.datavisualization.Diagram.BPMNEvents.Start,
        trigger: ej.datavisualization.Diagram.BPMNTriggers.None,
        name: null,
        offset: ej.datavisualization.Diagram.Point()
    };
    ej.datavisualization.Diagram.BPMNGatewayDefaults = {
        gateway: ej.datavisualization.Diagram.BPMNGateways.None,
    };
    ej.datavisualization.Diagram.BPMNDataObject = function (options) {
        return $.extend(true, {}, { type: ej.datavisualization.Diagram.BPMNDataObjects.None, collection: false }, options);
    };
    ej.datavisualization.Diagram.BPMNDataObjectDefaults = {
        data: ej.datavisualization.Diagram.BPMNDataObject()
    };
    ej.datavisualization.Diagram.BPMNTaskDefaults = {
        loop: ej.datavisualization.Diagram.BPMNLoops.None,
        type: ej.datavisualization.Diagram.BPMNTasks.None,
        call: false,
        compensation: false,
        events: []
    };
    ej.datavisualization.Diagram.BPMNTask = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.BPMNTaskDefaults, options);
    };
    ej.datavisualization.Diagram.BPMNSubProcessDefaults = {
        type: ej.datavisualization.Diagram.BPMNSubProcessTypes.None,
        event: ej.datavisualization.Diagram.BPMNEvents.Start,
        trigger: ej.datavisualization.Diagram.BPMNTriggers.Message,
        boundary: ej.datavisualization.Diagram.BPMNBoundary.Default,
        loop: ej.datavisualization.Diagram.BPMNLoops.None,
        adhoc: false,
        compensation: false,
        collapsed: true,
        events: [],
        processes: []
    };
    ej.datavisualization.Diagram.BPMNSubProcess = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.BPMNSubProcessDefaults, options);
    };
    ej.datavisualization.Diagram.BPMNActivityDefaults = {
        activity: ej.datavisualization.Diagram.BPMNActivity.Task,
        task: ej.datavisualization.Diagram.BPMNTask(),
        subProcess: ej.datavisualization.Diagram.BPMNSubProcess(),
    };
    ej.datavisualization.Diagram.BPMNTextAnnotationDefaults = {
        annotation: {
            width: 20, height: 20, angle: 0, length: 0, text: "",
            direction: ej.datavisualization.Diagram.BPMNAnnotationDirections.Left,
        }
    };
    ej.datavisualization.Diagram.ConnectorShapeDefaults = {
        type: "bpmn",
        flow: ej.datavisualization.Diagram.BPMNFlows.Sequence,
        sequence: ej.datavisualization.Diagram.BPMNSequenceFlows.Normal,
        association: ej.datavisualization.Diagram.AssociationFlows.Default,
        message: ej.datavisualization.Diagram.BPMNMessageFlows.Default
    };
    ej.datavisualization.Diagram.Multiplicity = {
        OneToOne: "onetoone",
        OneToMany: "onetomany",
        ManyToOne: "manytoone",
        ManyToMany: "manytomany"
    };
    ej.datavisualization.Diagram.ClassifierMultiplicityDefault = {
        type: ej.datavisualization.Diagram.Multiplicity.OneToOne,
        source: {
            optional: true,
            lowerBounds: null,
            upperBounds: null
        },
        target: {
            optional: true,
            lowerBounds: null,
            upperBounds: null
        }
    };
    ej.datavisualization.Diagram.UMLActivityFlowDefaults = {
        type: "umlactivity",
        activityFlow: ej.datavisualization.Diagram.UMLActivityFlow.Control
    };
    ej.datavisualization.Diagram.AssociationDefaults = {
        type: "classifier",
        association: ej.datavisualization.Diagram.AssociationFlows.BiDirectional,
        multiplicity: ej.datavisualization.Diagram.ClassifierMultiplicityDefault
    };
    ej.datavisualization.Diagram.AggregationDefaults = {
        type: "classifier",
        multiplicity: ej.datavisualization.Diagram.ClassifierMultiplicityDefault
    };
    ej.datavisualization.Diagram.CompositionDefaults = {
        type: "classifier",
        multiplicity: ej.datavisualization.Diagram.ClassifierMultiplicityDefault
    };
    ej.datavisualization.Diagram.DependencyDefaults = {
        type: "classifier",
        multiplicity: ej.datavisualization.Diagram.ClassifierMultiplicityDefault
    };
    ej.datavisualization.Diagram.RealizationDefaults = {
        type: "classifier",
        multiplicity: ej.datavisualization.Diagram.ClassifierMultiplicityDefault
    };
    ej.datavisualization.Diagram.InheritanceDefaults = {
        type: "classifier",
        multiplicity: ej.datavisualization.Diagram.ClassifierMultiplicityDefault
    };
    ej.datavisualization.Diagram.ScopeValueDefaults = {
        Public: "public",
        Protected: "",
        Private: "",
        Package: ""
    };
    ej.datavisualization.Diagram.ClassMemberDefaults = {
        name: "",
        value: ""
    };
    ej.datavisualization.Diagram.ClassAttributeDefaults = {
        name: "",
        type: "",
        scope: ej.datavisualization.Diagram.ScopeValueDefaults.Public
    };
    ej.datavisualization.Diagram.ClassMethodsArgumentsDefault = {
        name: "",
        type: "",
    };
    ej.datavisualization.Diagram.ClassMethodsDefaults = {
        name: "",
        type: "",
        arguments: ej.datavisualization.Diagram.ClassMethodsArgumentsDefault,
        scope: ej.datavisualization.Diagram.ScopeValueDefaults.Public
    };
    ej.datavisualization.Diagram.ClassmethodArguments = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ClassMethodsArgumentsDefault, options);
    };
    ej.datavisualization.Diagram.ClassMethod = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ClassMethodsDefaults, options);
    };
    ej.datavisualization.Diagram.ClassMember = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ClassMemberDefaults, options);
    };
    ej.datavisualization.Diagram.ClassAttribute = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ClassAttributeDefaults, options);
    };
    ej.datavisualization.Diagram.ClassifierClass = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ClassDefaults, options);
    };
    ej.datavisualization.Diagram.ClassifierInterface = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.InterfaceDefaults, options);
    };
    ej.datavisualization.Diagram.ClassifierEnumeration = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.EnumerationDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnector = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.UMLConnectorDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorAssociation = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.AssociationDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorAggregation = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.AggregationDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorComposition = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.CompositionDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorDependency = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.DependencyDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorRealization = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.RealizationDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorInheritance = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.InheritanceDefaults, options);
    };
    ej.datavisualization.Diagram.UMLConnectorMultiplicity = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.ClassifierMultiplicityDefault, options);
    };
    ej.datavisualization.Diagram.UMLActivityFlow = function (options) {
        return $.extend(true, {}, ej.datavisualization.Diagram.UMLActivityFlowDefaults, options);
    }
    ej.datavisualization.Diagram.ClassDefaults = {
        name: " ",
        attributes: [
         ej.datavisualization.Diagram.ClassAttribute()
        ],
        methods: [
            ej.datavisualization.Diagram.ClassMethod()
        ]

    };
    ej.datavisualization.Diagram.InterfaceDefaults = {
        name: " ",
        attributes: [
            ej.datavisualization.Diagram.ClassAttribute()
        ],
        methods: [
            ej.datavisualization.Diagram.ClassMethod()
        ]
    };
    ej.datavisualization.Diagram.EnumerationDefaults = {
        name: " ",
        members: [
            ej.datavisualization.Diagram.ClassMember()
        ],
    };
    ej.datavisualization.Diagram.NodeType = function (options, diagram) {
        if (!options._isInternalShape) {
            var defaultType = diagram.model.defaultSettings && diagram.model.defaultSettings.node && diagram.model.defaultSettings.node.type ? diagram.model.defaultSettings.node.type : "";
            var nodeDefault = !options.isPhase && diagram.model.defaultSettings && diagram.model.defaultSettings.node ? diagram.model.defaultSettings.node : {};
            if (!options.type && !options.children && !options.isLane && !options.isSwimlane && !options.isPhase && !options.isPhaseStack) {
                if (options.segments || options.sourceNode || options.sourcePort || options.sourcePoint || options.targetNode || options.targetPort || options.targetPoint)
                    options.type = "connector";
                else
                    options.type = defaultType ? defaultType : "basic";
            }
            if (options.isSwimlane || options.type == "swimlane") options._type = "group";
            if (options.type == "basic" || options.type == "flow" || options.type == "arrow" || options.type == "bpmn" || options.type == "image" || options.type == "native" || options.type === "html" || options.type === "text" || options.type == "umlactivity") {
                if (!diagram._isLoad || (diagram._isLoad && !options._type))
                    options._type = "node";
                options = $.extend(true, {}, nodeDefault, options);
            }
            if (!diagram._isLoad || diagram.model.nodeTemplate) {
                if (options.type == "basic")
                    options = ej.datavisualization.Diagram.BasicShape(options);
                else if (options.type == "flow")
                    options = ej.datavisualization.Diagram.FlowShape(options);
                else if (options.type == "arrow")
                    options = ej.datavisualization.Diagram.ArrowShape(options);
                else if (options.type == "bpmn")
                    options = ej.datavisualization.Diagram.BPMNShape(options);
                else if (options.type == "umlclassifier")
                    options = ej.datavisualization.Diagram.ClassifierShape(options, diagram);
                else if (options.type == "umlactivity")
                    options = ej.datavisualization.Diagram.UMLActivityShape(options, diagram);
            }
        }
        return options;
    };
    ej.datavisualization.Diagram.BasicShape = function (options) {
        options._shape = "path";
        if (!options.shape) options.shape = "rectangle";
        switch (options.shape) {
            case "rectangle":
                options._shape = "rectangle";
                break;
            case "ellipse":
                options._shape = "ellipse";
                break;
            case "path":
                options._shape = "path";
                break;
            case "polygon":
                options._shape = "polygon";
                break;
            case "triangle":
                options.pathData = "M81.1582,85.8677L111.1582,33.9067L141.1582,85.8677L81.1582,85.8677z";
                break;
            case "plus":
                options.pathData = "M696.6084,158.2656L674.8074,158.2656L674.8074,136.4656L658.4084,136.4656L658.4084,158.2656L636.6084,158.2656L636.6084,174.6646L658.4084,174.6646L658.4084,196.4656L674.8074,196.4656L674.8074,174.6646L696.6084,174.6646L696.6084,158.2656z";
                break;
            case "star":
                options.pathData = "M540.3643,137.9336L546.7973,159.7016L570.3633,159.7296L550.7723,171.9366L558.9053,194.9966L540.3643,179.4996L521.8223,194.9966L529.9553,171.9366L510.3633,159.7296L533.9313,159.7016L540.3643,137.9336z";
                break;
            case "pentagon":
                options.pathData = "M370.9702,194.9961L359.5112,159.7291L389.5112,137.9341L419.5112,159.7291L408.0522,194.9961L370.9702,194.9961z";
                break;
            case "heptagon":
                options.pathData = "M223.7783,195.7134L207.1303,174.8364L213.0713,148.8034L237.1303,137.2174L261.1883,148.8034L267.1303,174.8364L250.4813,195.7134L223.7783,195.7134z";
                break;
            case "octagon":
                options.pathData = "M98.7319,196.4653L81.1579,178.8923L81.1579,154.0393L98.7319,136.4653L123.5849,136.4653L141.1579,154.0393L141.1579,178.8923L123.5849,196.4653L98.7319,196.4653z";
                break;
            case "trapezoid":
                options.pathData = "M127.2842,291.4492L95.0322,291.4492L81.1582,256.3152L141.1582,256.3152L127.2842,291.4492z";
                break;
            case "decagon":
                options.pathData = "M657.3379,302.4141L642.3369,291.5161L636.6089,273.8821L642.3369,256.2481L657.3379,245.3511L675.8789,245.3511L690.8789,256.2481L696.6089,273.8821L690.8789,291.5161L675.8789,302.4141L657.3379,302.4141z";
                break;
            case "righttriangle":
                options.pathData = "M836.293,292.9238L776.293,292.9238L776.293,254.8408L836.293,292.9238z";
                break;
            case "cylinder":
                options.pathData = "M 542.802,362.009C 542.802,368.452 525.341,373.676 503.802,373.676C 482.263,373.676 464.802,368.452 464.802,362.009L 464.802,466.484C 464.802,472.928 482.263,478.151 503.802,478.151C 525.341,478.151 542.802,472.928 542.802,466.484L 542.802,362.016C 542.802,368.459 525.341,373.534 503.802,373.534C 482.263,373.534 464.802,368.31 464.802,361.867L 464.802,362.016C 464.802,355.572 482.263,350.349 503.802,350.349C 525.341,350.349 542.802,355.572 542.802,362.016";
                break;
                //case "diamond": options.pathData = "M 397.784,287.875L 369.5,316.159L 341.216,287.875L 369.5,259.591L 397.784,287.875 Z"; break;
        }
        return options;
    };
    ej.datavisualization.Diagram.FlowShape = function (options) {
        options._shape = "path";
        if (!options.shape) options.shape = "process";
        var constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
        if (!(options.constraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio))
            constraints = constraints | ej.datavisualization.Diagram.NodeConstraints.AspectRatio;
        switch (options.shape) {
            case "process":
                options.pathData = "M419.511,76.687L359.511,76.687L359.511,43.086L419.511,43.086z";
                break;
            case "decision":
                options.pathData = "M 253.005,115.687L 200.567,146.071L 148.097,115.687L 200.534,85.304L 253.005,115.687 Z";
                break;
            case "document":
                options.pathData = "M 60 31.9 c 0 0 -11 -7.7 -30 0 s -30 0 -30 0 V 0 h 60 V 31.9 Z";
                break;
            case "predefinedprocess":
                options.pathData = "M 0,0 L 50,0 L 50,50 L 0,50 Z  M 8.333333333333334,0 L 8.333333333333334,50 M 41.66666666666667,0 L 41.66666666666667,50";
                break;
            case "terminator":
                options.pathData = "M 269.711,29.3333C 269.711,44.061 257.772,56 243.044,56L 158.058,56C 143.33,56 131.391,44.061 131.391,29.3333L 131.391,29.3333C 131.391,14.6057 143.33,2.66669 158.058,2.66669L 243.044,2.66669C 257.772,2.66669 269.711,14.6057 269.711,29.3333 Z";
                break;
            case "papertap":
                options.pathData = "M0.000976562,17.2042 L0.000976562,47.1654 C0.000976562,47.1654 14.403,53.5455 25.001,47.1654 C35.599,40.7852 44.403,43.5087 50.001,47.1654 L50.001,17.2042 M50.001,32.7987 L50.001,2.84052 C50.001,2.84052 35.599,-3.54271 25.001,2.84052 C14.403,9.22376 5.599,6.49418 0.000976562,2.84052 L0.000976562,32.7987";
                break;
            case "directdata":
                options.pathData = "M 1477 613 L 1619 613 C 1627 613 1634 636 1634 665 C 1634 694 1627 717 1619 717 L 1477 717 C 1469 717 1461 694 1461 665 C 1461 636 1469 613 1477 613 ZM 1619 613 C 1610 613 1603 636 1603 665 C 1603 694 1610 717 1619 717M 1619 613 C 1610 613 1603 636 1603 665 C 1603 694 1610 717 1619 717";
                break;
            case "sequentialdata":
                options.pathData = "M0.00297546,24.999 C0.00297546,11.1922 10.433,0.00216177 23.295,0.00216177 C36.159,0.00216177 46.585,11.1922 46.585,24.999 C46.585,38.8057 36.159,49.9979 23.295,49.9979 C10.433,49.9979 0.00297546,38.8057 0.00297546,24.999 z M23.294,49.999 L50.002,49.999";
                break;
            case "sort":
                options.pathData = "M50.001,24.9971 L25.001,49.9971 L0.000976562,24.9971 L25.001,-0.00286865 L50.001,24.9971 z M0.000976562,24.9971 L50.001,24.9971";
                break;
            case "multidocument":
                options.pathData = "M43.6826,40 C44.8746,40.6183 45.8586,41.3502 46.8366,42.1122 L46.8366,4.74487 L3.09857,4.74487 L3.09857,10.9544 M46.837,35.1437 C48.027,35.7653 49.025,36.6042 50.003,37.3695 L50.003,0.0021928 L6.26497,0.0021928 L6.26497,4.74451 M43.6826,47.1132 L43.6826,10.7652 L0.00257874,10.7652 L0.00257874,47.1132 C0.00257874,47.1132 12.5846,53.6101 21.8426,47.1132 C31.1006,40.6163 38.7926,43.3935 43.6826,47.1132 z";
                break;
            case "collate":
                options.pathData = "M50.001,0.00286865 L25.001,25.0029 L0.000976562,0.00286865 L50.001,0.00286865 z M0.000976562,50.0029 L25.001,25.0029 L50.001,50.0029 L0.000976562,50.0029 z";
                break;
            case "summingjunction":
                options.constraints = constraints;
                options.pathData = "M7.3252,42.6768 L42.6772,7.32477 M42.6768,42.6768 L7.3248,7.32477 M0.000976562,25.001 C0.000976562,11.193 11.197,0.000976562 25.001,0.000976562 C38.809,0.000976562 50.001,11.193 50.001,25.001 C50.001,38.809 38.809,50.001 25.001,50.001 C11.197,50.001 0.000976562,38.809 0.000976562,25.001 z";
                break;
            case "or":
                options.pathData = "M 0 50 L 100 50 M 50 100 L 50 0.0 M 0 50 C 0 22.384 22.392 0 50 0 C 77.616 0 100 22.384 100 50 C 100 77.616 77.616 100 50 100 C 22.392 100 0 77.616 0 50 Z";
                break;
            case "internalstorage":
                options.pathData = "M 0 3.8194444444444446A 2.5,3.8194444444444446 0 0,1 2.5,0L 47.5 0A 2.5,3.8194444444444446 0 0,1 50,3.8194444444444446L 50 45.833333333333336A 2.5,3.8194444444444446 0 0,1 47.5,49.65277777777778L 2.5 49.65277777777778A 2.5,3.8194444444444446 0 0,1 0,45.833333333333336L 0 3.8194444444444446ZM 0 11.458333333333334L 50 11.458333333333334M 12.5 0L 12.5 49.65277777777778";
                break;
            case "extract":
                options._shape = "polygon";
                options.constraints = constraints;
                options.points = [{ x: 0, y: 35 }, { x: 30, y: 0 }, { x: 60, y: 35 }];

                break;
            case "manualoperation":
                options._shape = "polygon";
                options.points = [{ x: 46.4, y: 28.8 }, { x: 14.8, y: 28.8 }, { x: 0, y: 0 }, { x: 60, y: 0 }];
                break;
            case "merge":
                options._shape = "polygon";
                options.constraints = constraints;
                options.points = [{ x: 60, y: 0 }, { x: 30, y: 35 }, { x: 0, y: 0 }];
                break;
            case "offpagereference":
                options._shape = "polygon";
                options.points = [{ x: 60, y: 33.3 }, { x: 30.1, y: 39 }, { x: 0, y: 33.3 }, { x: 0, y: 0 }, { x: 60, y: 0 }];
                break;
            case "sequentialaccessstorage":
                options.constraints = constraints;
                options.pathData = "M 60 30 C 60 13.4 46.6 0 30 0 S 0 13.4 0 30 s 13.4 30 30 30 h 28.6 v -6.5 h -9.9 C 55.5 48 60 39.5 60 30 Z";
                break;
            case "annotation1":
                options.pathData = "M49.9984,50.0029 L-0.00271199,50.0029 L-0.00271199,0.00286865 L49.9984,0.00286865";
                break;
            case "annotation2":
                options.pathData = "M49.9977,50.0029 L25.416,50.0029 L25.416,0.00286865 L49.9977,0.00286865 M25.4166,25.0029 L-0.00227869,25.0029";
                break;
                //case "display": options.pathData = "M47.8809,19.2914 L32.7968,-0.00594145 L11.3902,-0.00594145 C7.93166,-0.00594145 0.00124586,11.187 0.00124586,24.9968 C0.00124586,38.8032 7.93166,49.9962 11.3902,49.9962 L32.7968,49.9962 L47.615,31.0388 C47.615,31.0388 52.7986,24.9968 47.8809,19.2914 z"; break;
                //case "delay": options.pathData = "M50.0044,-0.00482496 L18.9098,-0.00482496 L3.46654,18.958 C3.46654,18.958 -4.06481,25.0015 3.07999,30.7062 L18.9098,50.0013 L50.0044,50.0013"; break;
                //case "storeddata": options.pathData = "M 5.555555555555555 0L 50 0A 1.5,30 0 0,1 50,0A 5.555555555555555,25 0 0,0 50,50A 1.5,30 0 0,1 50,50L 5.555555555555555 50A 5.555555555555555,25 0 0,1 5.555555555555555,0Z"; break;
            case "card":
                options._shape = "polygon";
                options.points = [{ x: 275, y: 60 }, { x: 400, y: 60 }, { x: 400, y: 110 }, { x: 260, y: 110 }, { x: 260, y: 75 }]; break;
            case "data": options.pathData = "M 10 0 L 40 0 L 30 40 L 0 40 Z "; break;
        }
        return options;
    };
    ej.datavisualization.Diagram.ArrowShape = function (options) {
        options._shape = "path";
        if (!options.shape) options.shape = "circulararrow";
        switch (options.shape) {
            case "circulararrow":
                options.pathData = "M433.4624,503.8848C429.4244,493.2388,419.1354,485.6678,407.0734,485.6678C391.4884,485.6678,378.8544,498.3018,378.8544,513.8868L384.4984,513.8868C384.4984,501.4178,394.6054,491.3108,407.0734,491.3108C415.9494,491.3108,423.6264,496.4338,427.3144,503.8848L422.9114,503.8848L426.8974,508.8848L430.8824,513.8868L434.8684,508.8848L438.8544,503.8848L433.4624,503.8848z";
                break;
            case "curvedrightarrow":
                options.pathData = "M0.83006144,28.226993 C2.4030598,37.092016 9.5750604,44.49601 19.365042,48.044014 L19.365042,43.129004 25.376032,47.706001 31.386044,52.282999 25.376032,56.858988 19.365042,61.436991 19.365042,55.399027 C8.24608,51.372995 0.50004381,42.368995 0.50004357,31.905003 0.50004381,30.65601 0.6160717,29.429996 0.83006144,28.226993 z M31.402985,0.5 L31.402985,7.4419994 C15.834992,7.4419994 2.9619988,16.497999 0.81800008,28.275999 0.61199981,27.139999 0.49999988,25.981999 0.5,24.803999 0.49999988,11.379999 14.334993,0.5 31.402985,0.5 z";
                break;
            case "curveduparrow":
                options.pathData = "M52.283021,0.51798058 L56.859025,6.5279841 61.436024,12.537989 55.399022,12.537989 C51.373021,23.656996 42.369015,31.403002 31.905011,31.403002 30.65601,31.403002 29.430011,31.288002 28.22701,31.073002 37.092015,29.500999 44.496018,22.328995 48.044018,12.537989 L43.129018,12.537989 47.706021,6.5279841 z M0.5,0.5 L7.4420163,0.5 C7.4420163,16.067989 16.497985,28.940971 28.276,31.083977 27.140013,31.290977 25.981993,31.402 24.804015,31.402 11.380005,31.402 0.5,17.567989 0.5,0.5 z";
                break;
            case "curvedleftarrow":
                options.pathData = "M31.073116,28.227982 C31.287107,29.429977 31.403074,30.65599 31.403074,31.905989 31.403074,42.368966 23.657099,51.372959 12.538074,55.399935 L12.538074,61.436979 6.5270846,56.85898 0.51707193,52.282993 6.5270846,47.706976 12.538074,43.129983 12.538074,48.044958 C22.328056,44.496956 29.500118,37.091961 31.073116,28.227982 z M0.5,0.5 C17.568025,0.5 31.403045,11.380997 31.403045,24.803993 31.403045,25.981992 31.291046,27.139992 31.085045,28.276992 28.941042,16.497995 16.068023,7.442997 0.5,7.442997 z";
                break;
            case "curveddownarrow":
                options.pathData = "M24.804015,0.50000453 C25.981993,0.50000453 27.140013,0.61301103 28.276,0.8180277 16.498045,2.9630154 7.4420161,15.836023 7.4420156,31.404005 L0.5,31.404005 C0.5,14.336024 11.380004,0.50000453 24.804015,0.50000453 z M31.90502,0.5 C42.369025,0.49999976 51.37303,8.2460016 55.399031,19.365004 L61.436034,19.365004 56.859034,25.377005 52.28303,31.387007 47.70603,25.377005 43.129027,19.365004 48.044028,19.365004 C44.496027,9.5760015 37.092024,2.4040001 28.227019,0.82999995 29.43002,0.61699978 30.65602,0.49999976 31.90502,0.5 z";
                break;
            case "jumpingrightarrow":
                options.pathData = "M571.7207,727.7451L563.4507,716.8841L572.3297,716.8841C565.9217,699.1961,552.5427,686.2371,536.5277,683.3951C538.6997,683.0091,540.9157,682.8001,543.1717,682.8001C562.0777,682.8001,578.3457,696.7961,585.6187,716.8841L596.5277,716.8841L588.2577,727.7451L579.9907,738.6041L571.7207,727.7451z";
                break;
            case "jumpingleftarrow":
                options.pathData = "M688.4209,727.7441L696.6889,716.8851L687.8119,716.8851C694.2179,699.1971,707.5989,686.2381,723.6119,683.3941C721.4409,683.0101,719.2259,682.8011,716.9679,682.8011C698.0639,682.8011,681.7959,696.7951,674.5209,716.8851L663.6119,716.8851L671.8839,727.7441L680.1509,738.6031L688.4209,727.7441z";
                break;
                //case "uTurnArrow": options.pathData = "M1093.3154,165.6641L1093.3154,157.0071C1093.3154,145.6621,1084.1184,136.4651,1072.7724,136.4651C1061.4274,136.4651,1052.2304,145.6621,1052.2304,157.0071L1052.2304,196.4651L1061.5834,196.4511L1061.5834,157.5951C1061.5834,151.4141,1066.5934,146.4041,1072.7724,146.4041C1078.9534,146.4041,1083.9624,151.4141,1083.9624,157.5951L1083.9624,165.6641L1074.1574,165.6641L1081.1214,174.9601L1088.0864,184.2561L1095.0514,174.9601L1102.0164,165.6641L1093.3154,165.6641z"; break;
        }
        return options;
    };
    ej.datavisualization.Diagram.UMLConnectorShape = function (options) {
        if (!options.shape.relationship) options.shape.relationship = "association";
        switch (options.shape.relationship) {
            case "association":
                options.shape = ej.datavisualization.Diagram.UMLConnectorAssociation(options.shape);
                break;
            case "aggregation":
                options.shape = ej.datavisualization.Diagram.UMLConnectorAggregation(options.shape);
                break;
            case "composition":
                options.shape = ej.datavisualization.Diagram.UMLConnectorComposition(options.shape);
                break;
            case "realization":
                options.shape = ej.datavisualization.Diagram.UMLConnectorRealization(options.shape);
                break;
            case "dependency":
                options.shape = ej.datavisualization.Diagram.UMLConnectorDependency(options.shape);
                break;
            case "inheritance":
                options.shape = ej.datavisualization.Diagram.UMLConnectorInheritance(options.shape);
                break;
        }
        if (options.shape.type == "umlactivity") {
            options.shape = ej.datavisualization.Diagram.UMLActivityFlow(options.shape);
            if (options.shape.activityFlow == "object") {
                options = $.extend(true, options, { lineDashArray: "8 4", targetDecorator: { shape: "openarrow" }, lineWidth: 2 });
                if (options.labels)
                    for (var i = 0; i < options.labels.length; i++) {
                        options.labels[i] = ej.datavisualization.Diagram.Label(options.labels[i]);
                        options.labels[i].text = "[" + options.labels[i].text + "]"
                    }
            }
            else if (options.shape.activityFlow == "control")
                options = $.extend(true, options, { sourceDecorator: { shape: "none" }, targetDecorator: { shape: "openarrow" }, lineWidth: 2 });
            else if (options.shape.activityFlow == "exception")
                options = $.extend(true, options, { segments: [{ type: "straight" }], sourceDecorator: { shape: "none" }, targetDecorator: { shape: "openarrow" }, });
        }
        else if (options.shape.multiplicity) {
            var labels = [];
            labels = ej.datavisualization.Diagram.ClassifierHelper.umlConnectorMultiplicity(options);
            if (options.labels) {
                for (var i = 0; i < labels.length; i++)
                    options.labels.push(labels[i]);
            }
            else
                options = $.extend(true, {}, { labels: labels }, options);
        }
        if (options.shape.type == "umlclassifier") {
            if (options.shape.relationship == "association") {
                if (options.shape.association == "bidirectional")
                    options = $.extend(true, options, { segments: [{ type: "straight" }], sourceDecorator: { shape: "none" }, targetDecorator: { shape: "none" }, lineWidth: 2 });
                else if (options.shape.association == "directional")
                    options = $.extend(true, options, { segments: [{ type: "straight" }], sourceDecorator: { shape: "none" }, targetDecorator: { shape: "arrow" }, lineWidth: 2 });
            }
            if (options.shape.relationship == "inheritance")
                options = $.extend(true, options, { segments: [{ type: "orthogonal" }], sourceDecorator: { shape: "none" }, targetDecorator: { shape: "arrow", fillColor: "white" }, lineWidth: 2, lineDashArray: "4 4" });
            if (options.shape.relationship == "composition")
                options = $.extend(true, options, { segments: [{ type: "orthogonal" }], sourceDecorator: { shape: "diamond", fillColor: "black" }, targetDecorator: { shape: "none" }, lineWidth: 2 });
            if (options.shape.relationship == "aggregation")
                options = $.extend(true, options, { segments: [{ type: "orthogonal" }], sourceDecorator: { shape: "diamond", fillColor: "white" }, targetDecorator: { shape: "none" }, lineWidth: 2 });
            if (options.shape.relationship == "dependency")
                options = $.extend(true, options, { segments: [{ type: "orthogonal" }], sourceDecorator: { shape: "none" }, targetDecorator: { shape: "openarrow", fillColor: "white" }, lineWidth: 2, lineDashArray: "4 4" });
            if (options.shape.relationship == "realization")
                options = $.extend(true, options, { segments: [{ type: "orthogonal" }], sourceDecorator: { shape: "none" }, targetDecorator: { shape: "arrow", fillColor: "white" }, lineWidth: 2 });

        }
        return options;
    };
    ej.datavisualization.Diagram.BPMNShape = function (options) {
        if (!options.shape) options.shape = "event";
        //if (options._annotation) delete options._annotation;
        if (options.shape != "sequentialflow" || options.shape != "associationflow" || options.shape != "messageflow") {
            if (!(options.labels && options.labels.length))
                options.labels = [{}];
            if (!(options.labels.length && options.labels[0].offset))
                options.labels[0] = $.extend(true, {}, options.labels[0], { offset: { x: 0.5, y: 1 }, verticalAlignment: "top", margin: { top: 2 } });
        }
        switch (options.shape) {
            case "event":
            case "gateway":
            case "dataobject":
            case "activity":
                options._type = "group";
                options._isBpmn = true;
                if (options.children == undefined) options.children = [];
                if (options.shape == "activity" && options.activity == "subprocess" && options.subProcess && options.subProcess.collapsed == false)
                    options = $.extend(true, { container: { type: "canvas" }, paddingLeft: 10, paddingRight: 10, paddingBottom: 10, paddingTop: 10 }, options);
                break;
            case "message":
                options = $.extend(true, options, { _shape: "path", pathData: "M0,0L19.8,12.8L40,0L0,0L0,25.5L40,25.5L40,0z" });
                break;
            case "datasource":
                options = $.extend(true, options, { _shape: "path", pathData: "M 0 10.6 c 0 5.9 16.8 10.6 37.5 10.6 S 75 16.4 75 10.6 v 0 v 68.9 v -0.1 C 75 85.3 58.2 90 37.5 90 S 0 85.3 0 79.4 l 0 0.1 V 56 V 40.6 L 0 10.6 C 0 4.7 16.8 0 37.5 0 S 75 4.7 75 10.6 S 58.2 21.2 37.5 21.2 S 0 16.5 0 10.6 l 0 6.7 v -0.2 c 0 5.9 16.8 10.6 37.5 10.6 S 75 22.9 75 17.1 v 6.8 v -0.1 c 0 5.9 -16.8 10.6 -37.5 10.6 S 0 29.6 0 23.8" });
                break;
            case "group":
                options = $.extend(true, options, { _type: "group", _isBpmn: true, minWidth: options.width, minHeight: options.height, cornerRadius: 10, container: { type: "canvas" }, paddingLeft: 10, paddingRight: 10, paddingBottom: 10, paddingTop: 10, borderDashArray: "2 2 6 2" });
                break;
        }
        return options;
    };
    ej.datavisualization.Diagram.ClassifierShape = function (options, diagram) {
        if (!options.classifier) options.classifier = "class";
        if (!options.labels) options.labels = [{ margin: {} }];
        if (!options.fillColor) options.fillColor = "transparent"
        if (!options.borderColor) options.borderColor = "transparent";
        if (!options.borderWidth) options.borderWidth = 1;
        if (!options.opacity) options.opacity = 1;

        switch (options.classifier) {
            case "class":
                options["class"] = ej.datavisualization.Diagram.ClassifierClass(options["class"])
                for (var i = 0; i < options["class"].attributes.length; i++)
                    options["class"].attributes[i] = ej.datavisualization.Diagram.ClassAttribute(options["class"].attributes[i])
                for (var j = 0; j < options["class"].methods.length; j++)
                    options["class"].methods[j] = ej.datavisualization.Diagram.ClassMethod(options["class"].methods[j])
                options = ej.datavisualization.Diagram.DefautShapes._getClassShape(options, diagram);
                break;
            case "interface":
                options["interface"] = ej.datavisualization.Diagram.ClassifierInterface(options["interface"]);
                for (var i = 0; i < options["interface"].attributes.length; i++)
                    options["interface"].attributes[i] = ej.datavisualization.Diagram.ClassAttribute(options["interface"].attributes[i])
                for (var j = 0; j < options["interface"].methods.length; j++)
                    options["interface"].methods[j] = ej.datavisualization.Diagram.ClassMethod(options["interface"].methods[j])
                //  options = $.extend(true, {}, ej.datavisualization.Diagram.ClassifierInterface(), options);
                options = ej.datavisualization.Diagram.DefautShapes._getClassShape(options, diagram);
                break;
            case "enumeration":
                options.enumeration = ej.datavisualization.Diagram.ClassifierEnumeration(options.enumeration);
                //  options = $.extend(true, {}, ej.datavisualization.Diagram.ClassifierEnumeration(), options);
                options = ej.datavisualization.Diagram.DefautShapes._getClassShape(options, diagram);
                break;
            case "member":
                options.labels[0] = $.extend(true, {}, { name: options.name + "_member", horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 }, text: "Member" }, options.labels[0]);
                options = $.extend(true, {}, { borderColor: "transparent", fillColor: "transparent", _shape: "rectangle", horizontalAlign: "stretch", verticalAlign: "bottom", _isClassMember: true }, options);
                break;
            case "package":
                //  options = ej.datavisualization.Diagram.DefautShapes._getUMLPackageShape(options, diagram);
                break;
            case "collapsedpackage":
                // options.labels[0] = $.extend(true, {}, { offset: { x: 0.5, y: 0.5 }, text: options.packageName }, options.labels[0]);
                //  options = $.extend(true, {}, { _shape: "rectangle" }, options);
                break;
        }
        return options;
    };
    ej.datavisualization.Diagram.UMLActivityShape = function (options) {
        options.type = "umlactivity";
        if (!options.shape) options.shape = "action";
        options._shape = "path";
        // options.port = [];
        switch (options.shape) {
            case "action":
                options.pathData = "M 90 82.895 C 90 86.819 86.776 90 82.8 90 H 7.2 C 3.224 90 0 86.819 0 82.895 V 7.105 C 0 3.181 3.224 0 7.2 0 h 75.6 C 86.776 0 90 3.181 90 7.105 V 82.895 Z";
                break;
            case "decision":
                options.pathData = "M10,19.707L0.293,10L10,0.293L19.707,10L10,19.707z";
                break;
            case "mergenode":
                options.pathData = "M10,19.707L0.293,10L10,0.293L19.707,10L10,19.707z";
                break;
            case "initialnode":
                options.pathData = "M10,19.5c-5.238,0-9.5-4.262-9.5-9.5S4.762,0.5,10,0.5s9.5,4.262,9.5,9.5S15.238,19.5,10,19.5z";
                break;
            case "finalnode":
                options.borderColor = "transparent";
                options._type = "group";
                var childNodes = [], i = 0;
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.PointerEvents | ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.Resize);
                childNodes.push({
                    name: options.name + "_activity_final_1", width: options.width, height: options.height, offsetX: options.offsetX, offsetY: options.offsetY,
                    constraints: constraints | ej.datavisualization.Diagram.NodeConstraints.Resize, type: "node", shape: "path",
                    pathData: "M164.1884,84.6909000000001C156.2414,84.6909000000001,149.7764,78.2259000000001,149.7764,70.2769000000001C149.7764,62.3279000000001,156.2414,55.8629000000001,164.1884,55.8629000000001C172.1354,55.8629000000001,178.6024,62.3279000000001,178.6024,70.2769000000001C178.6024,78.2259000000001,172.1354,84.6909000000001,164.1884,84.6909000000001"
                });
                childNodes.push({
                    name: options.name + "_activity_final_2", width: options.width / 2, height: options.height / 2, fillColor: "black", offsetX: options.offsetX, offsetY: options.offsetY,
                    constraints: constraints | ej.datavisualization.Diagram.NodeConstraints.Resize, type: "node", shape: "path",
                    pathData: "M 25 50 C 11.21 50 0 38.79 0 25 C 0 11.21 11.21 0 25 0 C 38.78 0 50 11.21 50 25 C 50 38.79 38.78 50 25 50"
                });
                for (i = 0; i < childNodes.length; i++)
                    childNodes[i] = ej.datavisualization.Diagram.Node(childNodes[i]);
                options.elementType = "group";
                options.children = childNodes; break;
            case "forknode":
                options.width = options.width ? options.width : 40;
                options.height = 5;
                options.fillColor = "black"
                options.pathData = "m0.75,0.75l636.00002,0l0,290l-636.00002,0l0,-290z";
                options.labels = [{ readOnly: true }];
                options.ports = [];
                break;
            case "joinnode":
                options.width = options.width ? options.width : 40;
                options.height = 5;
                options.fillColor = "black"
                options.pathData = "m0.75,0.75l636.00002,0l0,290l-636.00002,0l0,-290z";
                options.labels = [{ readOnly: true }];
                options.ports = [];
                break;
            case "timeevent":
                options.pathData = "M50.001,0.00286865 L25.001,25.0029 L0.000976562,0.00286865 L50.001,0.00286865 z M0.000976562,50.0029 L25.001,25.0029 L50.001,50.0029 L0.000976562,50.0029 z";
                break;
            case "acceptingevent":
                options.pathData = "M17.8336 32.164 L29.64 24 L17.32 16 L48.1664 16 L48.5 32 Z";
                break;
            case "sendsignal":
                options.pathData = "M48.164 31.8336 L56 23.832 L47.836 16 L16.168 16 L16.1668 31.8336 Z";
                break;
            case "receivesignal":
                options.pathData = "M48.1664 31.8336 L39.836 24 L47.836 16 L16.168 16 L16.168 31.836 Z";
                break;
            case "structurednode":
                options._shape = "rectangle";
                options.borderDashArray = "2 3";
                options.labels = [{ text: "<<" + options.labels[0].text + ">>", wrapText: "nowrap", fillColor: "white" }];
                break;
            case "note":
                options.pathData = "M20 12 L4 12 L4 22 L22 22 L22 14 L20 14 L20 12 L22 14 Z";
                break;
        }
        return options;
    };
    ej.datavisualization.Diagram.DefautShapes = {
        //#region BPMN
        _getBPMNEventShape: function (options, diagram) {
            var childNodes = [], i;
            if (options.children == undefined) options.children = [];
            options._type = "group";
            options.canUngroup = false;
            options = $.extend(true, {}, ej.datavisualization.Diagram.BPMNEventDefaults, options);
            for (i = 0; i < options.children.length; i++) {
                if (diagram.nameTable[options.children[i].name || options.children[i]]) {
                    childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
                    childNodes[i].rotateAngle = options.rotateAngle;
                }
            }
            var pivot = options.pivot || { x: 0.5, y: 0.5 };
            var centerX = options.offsetX ? (options.offsetX - options.width * pivot.x + options.width / 2) : options.width * pivot.x + options.width / 2;
            var centerY = options.offsetY ? (options.offsetY - options.height * pivot.y + options.height / 2) : options.height * pivot.y + options.height / 2;
            if (!childNodes.length) {
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.PointerEvents | ej.datavisualization.Diagram.NodeConstraints.Connect);
                var defaultProperty = { parent: options.name, type: "node", shape: "path", offsetX: centerX, offsetY: centerY, ports: [], rotateAngle: options.rotateAngle, constraints: constraints, _isDisabled: true, _isInternalShape: true };
                childNodes.push({ name: options.name + "_0", width: options.width, height: options.height });
                childNodes.push({ name: options.name + "_1", width: options.width * .85, height: options.height * .85 });
                childNodes.push({ name: options.name + "_2", width: options.width * .5, height: options.height * .5 });
                for (i = 0; i < childNodes.length; i++)
                    childNodes[i] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, childNodes[i]));
            }
            options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            options.children = this._updateBPMNEventShape(options, childNodes, options.event, options.trigger);
            return options;
        },
        _getBPMNGatewayShape: function (options, diagram) {
            var childNodes = [], i;
            if (options.children == undefined) options.children = [];
            options._type = "group";
            options.canUngroup = false;
            options = $.extend(true, {}, ej.datavisualization.Diagram.BPMNGatewayDefaults, options);
            for (i = 0; i < options.children.length; i++) {
                if (diagram.nameTable[options.children[i].name || options.children[i]]) {
                    childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
                    childNodes[i].rotateAngle = options.rotateAngle;
                }
            }
            var pivot = options.pivot || { x: 0.5, y: 0.5 };
            var centerX = options.offsetX ? (options.offsetX - options.width * pivot.x + options.width / 2) : options.width * pivot.x + options.width / 2;
            var centerY = options.offsetY ? (options.offsetY - options.height * pivot.y + options.height / 2) : options.height * pivot.y + options.height / 2;
            if (!childNodes.length) {
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ (ej.datavisualization.Diagram.NodeConstraints.PointerEvents | ej.datavisualization.Diagram.NodeConstraints.Connect);
                var defaultProperty = { parent: options.name, type: "node", shape: "path", offsetX: centerX, offsetY: centerY, ports: [], rotateAngle: options.rotateAngle, constraints: constraints, _isDisabled: true, _isInternalShape: true };
                childNodes.push({ name: options.name + "_0", width: options.width, height: options.height, pathData: "M 40 20 L 20 40 L 0 20 L 20 0 L 40 20 Z" });
                childNodes.push({ name: options.name + "_1", width: options.width * .45, height: options.height * .45 });
                for (i = 0; i < childNodes.length; i++)
                    childNodes[i] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, childNodes[i]));
            }
            if (childNodes && childNodes[0]) {
                constraints = childNodes[0].constraints ? childNodes[0].constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
                if (options.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                    constraints = constraints | ej.datavisualization.Diagram.NodeConstraints.Shadow;
                }
            }
            options.children = childNodes;
            options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            $.extend(true, childNodes, [{ fillColor: options.fillColor, constraints: constraints, shadow: options.shadow, borderColor: options.borderColor, borderWidth: options.borderWidth, opacity: options.opacity, gradient: options.gradient }, { opacity: options.opacity, fillColor: "black", visible: true }]);
            switch (options.gateway) {
                case "none":
                    childNodes[1].visible = false;
                    break;
                case "exclusive":
                    childNodes[1].pathData = "M 11.196 29.009 l 6.36 -9.712 l -5.764 -8.899 h 4.393 l 3.732 5.979 l 3.656 -5.979 h 4.354 l -5.789 9.039 l 6.36 9.572 h -4.532 l -4.126 -6.437 l -4.139 6.437 H 11.196 Z";
                    break;
                case "inclusive":
                    childNodes[1].pathData = "M 20.323 31.333 c -6.625 0 -12.015 -5.39 -12.015 -12.015 s 5.39 -12.015 12.015 -12.015 s 12.016 5.39 12.016 12.015 S 26.948 31.333 20.323 31.333 Z M 20.323 9.303 c -5.522 0 -10.015 4.493 -10.015 10.015 s 4.492 10.015 10.015 10.015 s 10.016 -4.493 10.016 -10.015 S 25.846 9.303 20.323 9.303 Z";
                    break;
                case "parallel":
                    childNodes[1].pathData = "M 18.394 29.542 v -8.833 H 9.626 v -3.691 h 8.768 V 8.251 h 3.734 v 8.767 h 8.768 v 3.691 h -8.768 v 8.833 H 18.394 Z";
                    break;
                case "complex":
                    childNodes[1].pathData = "M29.198,19.063L23.089,19.063L27.794,14.358L26.38,12.944L21.223,18.101L21.223,10.443L19.223,10.443L19.223,17.976L14.022,12.776L12.608,14.19L17.48,19.063L10.365,19.063L10.365,21.063L18.261,21.063L12.392,26.932L13.806,28.346L19.223,22.929L19.223,30.225L21.223,30.225L21.223,22.805L25.925,27.507L27.339,26.093L22.309,21.063L29.198,21.063z";
                    break;
                case "eventbased":
                    childNodes[1].fillColor = "white";
                    childNodes[1].pathData = "M 20.322 29.874 c -5.444 0 -9.873 -4.43 -9.873 -9.874 s 4.429 -9.874 9.873 -9.874 s 9.874 4.429 9.874 9.874 S 25.767 29.874 20.322 29.874 Z M 20.322 32.891 c -7.107 0 -12.89 -5.783 -12.89 -12.891 c 0 -7.107 5.782 -12.89 12.89 -12.89 c 7.108 0 12.891 5.783 12.891 12.89 C 33.213 27.108 27.431 32.891 20.322 32.891 Z M 24.191 25.386 h -7.984 l -2.469 -7.595 l 6.461 -4.693 l 6.461 4.693 L 24.191 25.386 Z";
                    break;
                case "exclusiveeventbased":
                    childNodes[1].fillColor = "white";
                    childNodes[1].pathData = "M 30 15 C 30 23.28 23.28 30 15 30 S 0 23.28 0 15 S 6.72 0 15 0 S 30 6.72 30 15 z M 15 5 L 5 12.5 L 8 22.5 H 22 L 25 12.5 z";
                    break;
                case "paralleleventbased":
                    childNodes[1].fillColor = "white";
                    childNodes[1].pathData = "M 35 17.5 C 35 27.16 27.16 35 17.5 35 S 0 27.16 0 17.5 S 7.84 0 17.5 0 S 35 7.84 35 17.5 z M 14.58 5.83 V 14.58 H 5.83 V 20.42 H 14.58 V 29.17 H 20.42 V 20.42 H 29.17 V 14.58 H 20.42 V 5.83 z";
                    break;
            }
            return options;
        },
        /*  _getUMLPackageShape: function (options, diagram) {
              var childNodes = [], i, x, y;
              var x = options.offsetX - options.width / 2, y = options.offsetY - options.height / 2;
              if (!options.children) {
                  var constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ (ej.datavisualization.Diagram.NodeConstraints.Select | ej.datavisualization.Diagram.NodeConstraints.Connect);
                  var defaultProperty = { parent: options.name, shape: "path", ports: [], borderColor: options.borderColor, borderWidth: options.borderWidth, constraints: constraints };
                  var labelWidth = options.packageName.length * 10;
                  childNodes.push({ name: options.name + "_package_header" + "_classifier", minWidth: labelWidth, maxWidth: options.width, minHeight: 26, type: "node", offsetX: x + labelWidth / 2, offsetY: y + 13, pathData: "M79.75,65.786H8.91v-47.5h70.84V65.786z", labels: [{ text: options.packageName, horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 }, margin: { left: 5, right: 5, top: 4, bottom: 4 }, fontSize: 14, bold: true }], _isClassMember: true, });
                  childNodes.push({ name: options.name + "_package_content" + "_classifier", minWidth: options.width, minHeight: options.height - 26, type: "group", offsetX: x + options.width / 2, offsetY: y + 26 + (options.height - 26) * .5, fillColor: "transparent", pathData: "M39.083,19.286H8.91V9.37h30.173V19.286z", container: { type: "canvas", orientation: "vertical" }, children: [], labels: [{ readOnly: true }], paddingRight: 10, paddingLeft: 10, paddingTop: 10, paddingBottom: 10, allowDrop: true, _isPackage: true });
                  for (i = 0; i < childNodes.length; i++)
                      childNodes[i] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, childNodes[i]));
                  if (childNodes[1].constraints)
                      childNodes[1].constraints |= ej.datavisualization.Diagram.NodeConstraints.AllowDrop;
                  var classnodes = [];
                  if (options.members) {
                      for (var i = 0; i < options.members.length; i++) {
                          var classnode = ej.datavisualization.Diagram.ClassifierShape(options.members[i], diagram);
                          classnode.parent = childNodes[1].name;
                          classnodes.push(classnode);
                      }
                      for (var j = 0; j < classnodes.length;j++)
                          childNodes[1].children.push( classnodes[j]);
                  }
                  options.children = childNodes;
                  options._type = "group";
                  options.labels[0] = $.extend(true, {}, { readOnly: true }, options.labels[0]);
                  options.container = { type: "stack", orientation: "vertical" };
                  options.allowDrop = false;
                  options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
                  options.constraints = options.constraints & ~(ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeWest | ej.datavisualization.Diagram.NodeConstraints.ResizeNorth);
              }
              else {
                  for (i = 0; i < options.children.length; i++)
                      if (diagram.nameTable[options.children[i].name]) {
                          if (diagram.nameTable[options.children[i].name || options.children[i]])
                              childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
                      }
                      else
                          childNodes.push(typeof options.children[i] == "object" ? options.children[i] : diagram.nameTable[options.children[i]]);
              }
              childNodes[0].fillColor = options.fillColor;
              childNodes[0].borderColor = options.borderColor;
              childNodes[0].borderWidth = options.borderWidth;
              childNodes[0].opacity = options.opacity;
              if (options.gradient) childNodes[0].gradient = options.gradient;
              return options;
          },*/
        _getClassShape: function (options, diagram) {
            var childNodes = [], i, textNode, height, width;
            var attributeText = "", methodText = "", memberText = "", argumentText = "";
            if (!options.children) {
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.Select | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeNorth | ej.datavisualization.Diagram.NodeConstraints.ResizeSouth | ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.Rotate | ej.datavisualization.Diagram.NodeConstraints.ResizeEast | ej.datavisualization.Diagram.NodeConstraints.Drag);
                var defaultProperty = { width: options.width, offsetX: options.offsetX, parent: options.name, ports: [], fillColor: "transparent", borderColor: options.borderColor, type: "node", labels: [{ margin: { left: 5, right: 5, top: 5, bottom: 5 } }], _isClassMember: true };
                if (options.fillColor) defaultProperty.fillColor = options.fillColor;
                if (options.borderColor) defaultProperty.borderColor = options.borderColor;
                if (options.borderWidth) defaultProperty.borderWidth = options.borderWidth
                if (options.labels) {
                    for (var i = 0; i < options.labels.length; i++)
                        defaultProperty.labels[i] = $.extend(true, {}, defaultProperty.labels[i], options.labels[i])
                }
                switch (options.classifier) {
                    case "class":
                        childNodes.push({ ports: [], name: options.name + "_header" + "_classifier", minHeight: 30, labels: [{ name: "title", offset: { x: 0.5, y: 0.65 }, text: options["class"].name, bold: true, fontSize: 14 }, { name: "class", offset: { x: 0.5, y: 0.25 }, text: "<<Class>>" }], constraints: constraints });
                        break;
                    case "interface":
                        childNodes.push({ name: options.name + "_header" + "_classifier", minHeight: 40, labels: [{ name: "title", offset: { x: 0.5, y: 0.65 }, text: options["interface"].name, bold: true, fontSize: 14 }, { name: "interface", offset: { x: 0.5, y: 0.25 }, text: "<<Interface>>" }], constraints: constraints });
                        break;
                    case "enumeration":
                        childNodes.push({ name: options.name + "_header" + "_classifier", minHeight: 40, labels: [{ name: options.name + "Label1", offset: { x: 0.5, y: 0.65 }, text: options.enumeration.name, bold: true, fontSize: 14 }, { name: options.name + "enumeration", offset: { x: 0.5, y: 0.25 }, text: "<<Enumeration>>" }], constraints: constraints });
                        break;
                }
                var attribute = options["class"] ? options["class"] : options["interface"];
                if (attribute && attribute.attributes && attribute.attributes.length) {
                    for (i = 0; i < (attribute.attributes.length) ; i++) {
                        attribute.attributes[i] = ej.datavisualization.Diagram.ClassAttribute(attribute.attributes[i]);
                        if (options.Interface)
                            attribute.attributes[i].scope = ej.datavisualization.Diagram.ScopeValueDefaults.Public;
                        if (attribute.attributes[i].scope && attribute.attributes[i].scope == "public")
                            var text = "+";
                        if (attribute.attributes[i].scope && attribute.attributes[i].scope == "private")
                            text = "-";
                        if (attribute.attributes[i].scope && attribute.attributes[i].scope == "protected")
                            text = "#";
                        if (attribute.attributes[i].scope && attribute.attributes[i].scope == "package")
                            text = "~";
                        if (attribute.attributes[i].name != "")
                            if (text)
                                attributeText += text + " " + attribute.attributes[i].name + " " + ": " + attribute.attributes[i].type;
                            else
                                attributeText += attribute.attributes[i].name + ": " + attribute.attributes[i].type;
                        if (i != attribute.attributes.length - 1)
                            attributeText += "\n";
                    }
                    if (attributeText)
                        childNodes.push({ name: options.name + "_attribute" + "_classifier", labels: [{ text: attributeText, horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                }
                var member = options.enumeration;
                if (member && member.members && member.members.length) {
                    for (i = 0; i < member.members.length; i++) {
                        member.members[i] = ej.datavisualization.Diagram.ClassMember(member.members[i]);
                        if (member.members[i].name != "")
                            memberText += member.members[i].name;
                        if (i != member.members.length - 1)
                            memberText += "\n";
                    }
                    if (memberText)
                        childNodes.push({ name: options.name + "_member" + "_classifier", labels: [{ text: memberText, horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                }
                var method = options["class"] ? options["class"] : options["interface"];
                if (method && method.methods && method.methods.length) {
                    for (i = 0; i < method.methods.length ; i++) {
                        method.methods[i] = ej.datavisualization.Diagram.ClassMethod(method.methods[i]);
                        if (method.methods[i].scope && method.methods[i].scope == "public")
                            var text = "+";
                        if (method.methods[i].scope && method.methods[i].scope == "private")
                            text = "-";
                        if (method.methods[i].scope && method.methods[i].scope == "protected")
                            text = "#";
                        if (method.methods[i].scope && method.methods[i].scope == "package")
                            text = "~";
                        if (method.methods[i].arguments) {
                            for (var j = 0; j < method.methods[i].arguments.length; j++) {
                                if (method.methods[i].arguments[j].type)
                                    argumentText += method.methods[i].arguments[j].name + ":" + method.methods[i].arguments[j].type;
                                else
                                    argumentText += method.methods[i].arguments[j].name;
                                if (j != method.methods[i].arguments.length - 1)
                                    argumentText += ",";
                            }
                        }
                        if (method.methods[i].name != "") {
                            if (text)
                                methodText += text + " " + method.methods[i].name + "(" + argumentText + ")" + " " + ":" + " " + method.methods[i].type;
                            else
                                methodText += method.methods[i].name + "(" + argumentText + ")" + " " + ":" + method.methods[i].type;
                        }
                        if (i != method.methods.length - 1)
                            methodText += "\n";
                    }
                    if (methodText)
                        childNodes.push({ name: options.name + "_method" + "_classifier", labels: [{ text: methodText, horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                }
                for (i = 0; i < childNodes.length; i++) {
                    childNodes[i] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, childNodes[i]));
                    for (var j = 0; j < childNodes[i].labels.length; j++)
                        childNodes[i].labels[j] = $.extend(true, {}, childNodes[i].labels[j], defaultProperty.labels[0]);
                }
                options.children = childNodes;
                options._type = "group";
                //  options.labels[0] = $.extend(true, {}, { readOnly: true }, options.labels[0]);
                options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
                options.constraints = options.constraints & ~(ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeNorth | ej.datavisualization.Diagram.NodeConstraints.ResizeSouth | ej.datavisualization.Diagram.NodeConstraints.Rotate | ej.datavisualization.Diagram.NodeConstraints.ResizeEast | ej.datavisualization.Diagram.NodeConstraints.Drag);
                for (var i = 0; i < childNodes.length; i++) {
                    if (childNodes.length == 1) {
                        if (options["class"]) {
                            delete options["class"].attributes;
                            delete options["class"].methods;
                        }
                        if (options["interface"]) {
                            delete options["interface"].attributes;
                            delete options["interface"].methods;
                        }
                        if (options.enumeration)
                            delete options.enumeration.members;
                    }
                    if (childNodes.length == 2) {
                        options.children[i] = typeof options.children[i] == "string" ? diagram.nameTable[options.children[i]] : options.children[i];
                        if (options["class"]) {
                            if (options.children[i].name.match("attribute"))
                                delete options["class"].methods;
                            if (options.children[i].name.match("method"))
                                delete options["class"].attributes;
                        }
                        if (options["interface"]) {
                            if (options.children[i].name.match("attribute"))
                                delete options["interface"].methods;
                            if (options.children[i].name.match("method"))
                                delete options["interface"].attributes;
                        }
                    }
                }
            }
            else {
                for (i = 0; i < options.children.length; i++)
                    if (diagram.nameTable[options.children[i].name || options.children[i]])
                        childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
                if (childNodes.length <= 0 && options.children.length > 0) {
                    for (var j = 0; j < options.children.length; j++)
                        childNodes.push(options.children[j]);
                }
            }

            options._height = 0;
            for (i = 0; i < childNodes.length; i++) {
                diagram._getNodeDimension(childNodes[i], childNodes[i].labels[0]);
                //   this._updateClassNode(childNodes[i], options)
                height = childNodes[i].height ? childNodes[i].height : childNodes[i]._height;
                childNodes[i].offsetY = options._height + height / 2;
                options._height += height;
            }
            width = childNodes[0]._width;
            if (childNodes[1])
                width = childNodes[0]._width > childNodes[1]._width ? childNodes[0]._width : childNodes[1]._width
            if (childNodes[2])
                width = childNodes[2]._width > width ? childNodes[2]._width : width;
            childNodes[0].width = width;
            if (childNodes[1])
                childNodes[1].width = width;
            if (childNodes[2])
                childNodes[2].width = width;
            options._width = width;
            options.width = options._width;
            options.height = options._height;
            for (i = 0; i < childNodes.length; i++)
                childNodes[i].offsetY += (options.offsetY - options.height / 2);
            return options;
        },
        _updateClassNode: function (node, parent) {
            if (node.name.match("_header")) {
                if (parent.type == "class") parent.className = node.labels[0].text;
                else if (parent.type == "interface") parent.interfaceName = node.labels[0].text;
                else parent.enumerationName = node.labels[0].text;
            }
            else {
                var type = node.name.match("_attribute") ? "attribute" : (node.name.match("_method") ? "method" : "member");
                var label = node.labels[0];
                var str = label.text.split("\n");
                var classMember = [], data, i;
                for (i = 0; i < str.length; i++) {
                    var text = parent["Class"] ? parent["Class"] : parent.Interface;
                    switch (type) {
                        case "attribute":
                            data = str[i].split(/:[ ]*/g);
                            classMember.push(ej.datavisualization.Diagram.ClassMember({ name: data[0], type: data[1] }));
                            break;
                        case "method":
                            data = str[i].replace(")", "").replace("(", ":").split(/:[ ]*/g);
                            classMember.push(ej.datavisualization.Diagram.ClassMember({ name: data[0], returnType: data[1], parameter: data[2] }));
                            break;
                        case "member":
                            classMember.push(ej.datavisualization.Diagram.ClassMember({ name: str[i] }));
                            break;
                    }
                }
                if (type == "attribute") parent.attributes = classMember;
                else if (type == "method") parent.methods = classMember;
                else parent.members = classMember;
            }

        },
        _getBPMNDataShape: function (options, diagram) {
            var childNodes = [], i;
            if (options.children == undefined) options.children = [];
            options._type = "group";
            var pivot = options.pivot || { x: 0.5, y: 0.5 };
            options.canUngroup = false;
            options = $.extend(true, {}, ej.datavisualization.Diagram.BPMNDataObjectDefaults, options);
            var x = options.offsetX ? options.offsetX - options.width * pivot.x : options.width * pivot.x;
            var y = options.offsetY ? options.offsetY - options.height * pivot.y : options.height * pivot.y;
            for (i = 0; i < options.children.length; i++) {
                if (diagram.nameTable[options.children[i].name || options.children[i]]) {
                    childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
                    childNodes[i].rotateAngle = options.rotateAngle;
                }
            }
            var centerX = options.offsetX ? (options.offsetX - options.width * pivot.x + options.width / 2) : options.width * pivot.x + options.width / 2;
            if (!childNodes.length) {
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ (ej.datavisualization.Diagram.NodeConstraints.PointerEvents | ej.datavisualization.Diagram.NodeConstraints.Connect);
                var defaultProperty = { parent: options.name, type: "node", shape: "path", offsetX: centerX, ports: [], rotateAngle: options.rotateAngle, constraints: constraints, _isDisabled: true, _isInternalShape: true };
                childNodes.push({ name: options.name + "_0", width: options.width, height: options.height, offsetY: y + options.height / 2, shape: "polygon", points: [{ x: 29.904, y: 5 }, { x: 7.853, y: 5 }, { x: 7.853, y: 45 }, { x: 42.147, y: 45 }, { x: 42.147, y: 17.242 }, { x: 29.932, y: 5 }, { x: 29.932, y: 17.242 }, { x: 42.147, y: 17.242 }] });
                childNodes.push({ name: options.name + "_1", width: options.width * .075, height: options.height * .15, offsetY: options.height * .85 + y, fillColor: "black", pathData: "M 0 0 L 0.1 0 L 0.1 2 L 0 2 Z M 0.4 0 L 0.6 0 L 0.6 2 L0.4 2 Z M 0.9 0 L 1 0 L 1 2 L 0.9 2 Z " });
                childNodes.push({ name: options.name + "_2", width: options.width * .25, height: options.height * .2, offsetX: x + options.width * .175, offsetY: y + options.height * .15, borderColor: "black", fillColor: "white", pathData: "M 3 9.4 l 6 0 v 2.4 l 3.6 -4 L 9 4 v 2.5 H 3 V 9.4 Z" });
                for (i = 0; i < childNodes.length; i++)
                    childNodes[i] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, childNodes[i]));
            }
            options.children = childNodes;
            options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            $.extend(true, childNodes, [{ fillColor: options.fillColor, constraints: options.constraints, shadow: options.shadow, borderColor: options.borderColor, borderWidth: options.borderWidth, opacity: options.opacity, gradient: options.gradient }, { opacity: options.opacity, visible: options.data.collection }, { opacity: options.opacity, visible: true }]);
            switch (options.data.type) {
                case "none":
                    childNodes[2].visible = false;
                    break;
                case "input":
                    childNodes[2].fillColor = "white";
                    break;
                case "output":
                    childNodes[2].fillColor = "black";
                    break;
            }
            return options;
        },
        _getBPMNActivityShape: function (options, diagram) {
            var childNodes = [], childTable = {}, i;
            if (options.children == undefined) options.children = [];
            options._type = "group";
            options.canUngroup = false;
            options = $.extend(true, {}, ej.datavisualization.Diagram.BPMNActivityDefaults, options);
            for (i = 0; i < options.children.length; i++) {
                if (diagram.nameTable[options.children[i].name || options.children[i]]) {
                    childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
                    childNodes[i].rotateAngle = options.rotateAngle;
                }
            }
            if (!childNodes.length) {
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.PointerEvents | ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.Resize);
                var defaultProperty = { parent: options.name, type: "node", shape: "path", ports: [], labels: [], constraints: constraints, rotateAngle: options.rotateAngle, _isDisabled: true, _isInternalShape: true };
                childNodes.push({ name: options.name + "_activity", width: options.width, height: options.height, addInfo: { offset: { x: 0.5, y: 0.5 } }, constraints: constraints | ej.datavisualization.Diagram.NodeConstraints.Resize });
                childNodes.push({ name: options.name + "_taskType", width: 14, height: 14, borderColor: "black", addInfo: { offset: { x: 0, y: 0 }, hAlign: "left", vAlign: "top", margin: { left: 14, top: 14 } }, pathData: "M10 0L40 0L30 40L0 40Z" });
                childNodes.push({ name: options.name + "_loop", width: 12, height: 12, addInfo: { offset: { x: 0.5, y: 1 }, hAlign: "center", vAlign: "bottom", margin: { bottom: 12 } }, borderColor: "black", fillColor: "black", pathData: "M10 0L40 0L30 40L0 40Z" });
                childNodes.push({ name: options.name + "_compensation", width: 12, height: 12, addInfo: { offset: { x: 0.5, y: 1 }, hAlign: "center", vAlign: "bottom", margin: { bottom: 12 } }, borderColor: "black", fillColor: "black", pathData: "M10 0L40 0L30 40L0 40Z" });
                childNodes.push({ name: options.name + "_expanded", width: 12, height: 12, constraints: ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.Resize | ej.datavisualization.Diagram.NodeConstraints.Select), addInfo: { offset: { x: 0.5, y: 1 }, hAlign: "center", vAlign: "bottom", margin: { bottom: 12 } }, borderColor: "black", fillColor: "black", pathData: "M10 0L40 0L30 40L0 40Z" });
                childNodes.push({ name: options.name + "_adhoc", width: 12, height: 8, addInfo: { offset: { x: 0.5, y: 1 }, hAlign: "center", vAlign: "bottom", margin: { bottom: 12 } }, borderColor: "black", fillColor: "black", pathData: "M10 0L40 0L30 40L0 40Z" });
                childNodes.push({ name: options.name + "_event_1", width: 24, height: 24, addInfo: { offset: { x: 0, y: 0 }, hAlign: "left", vAlign: "top", margin: { left: 18, top: 18 } } });
                childNodes.push({ name: options.name + "_event_2", width: 20.4, height: 20.4, addInfo: { offset: { x: 0, y: 0 }, hAlign: "left", vAlign: "top", margin: { left: 18, top: 18 } } });
                childNodes.push({ name: options.name + "_event_3", width: 12, height: 12, addInfo: { offset: { x: 0, y: 0 }, hAlign: "left", vAlign: "top", margin: { left: 18, top: 18 } } });

                for (i = 0; i < childNodes.length; i++)
                    childNodes[i] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, childNodes[i]));

                if (options.activity == "subprocess" && !options.subProcess.collapsed && options.subProcess.processes.length) {
                    for (var j = 0, process = options.subProcess.processes; j < options.subProcess.processes.length; j++) {
                        process[j] = ej.datavisualization.Diagram.Node(ej.datavisualization.Diagram.NodeType(process[j], diagram));
                        childNodes.push(process[j]);
                    }
                }
            }
            options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            options.children = this._updateBPMNActivityShape(options, childNodes);
            for (i = 0; i < options.children.length; i++)
                childTable[options.children[i].name] = options.children[i];
            ej.datavisualization.Diagram.Util._updateBPMNProperties(options, diagram, childTable);
            return options;
        },
        _getBPMNGroupShape: function (options, diagram) {
            var childNodes = [], i = 0;
            if (options.children == undefined) options.children = [];
            for (i = 0; i < options.children.length; i++)
                if (diagram.nameTable[options.children[i].name || options.children[i]])
                    childNodes.push(diagram.nameTable[options.children[i].name || options.children[i]]);
            if (!childNodes.length) {
                for (i = 0; i < options.children.length; i++) {
                    var child = ej.datavisualization.Diagram.Node(ej.datavisualization.Diagram.NodeType(options.children[i], diagram));
                    if (child.type == "bpmn") childNodes.push(child);
                }
            }
            options.ports = [];
            options.children = childNodes;
            options.constraints = options.constraints ? options.constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
            options.constraints = options.constraints & ~ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.AllowDrop;;
            return options;
        },

        _updateBPMNEventShape: function (node, childNodes, event, trigger) {
            var constraints;
            if (childNodes && childNodes[0]) {
                constraints = childNodes[0].constraints ? childNodes[0].constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
                if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                    constraints = constraints | ej.datavisualization.Diagram.NodeConstraints.Shadow;
                }
            }
            var defaultPathData = "M164.1884,84.6909000000001C156.2414,84.6909000000001,149.7764,78.2259000000001,149.7764,70.2769000000001C149.7764,62.3279000000001,156.2414,55.8629000000001,164.1884,55.8629000000001C172.1354,55.8629000000001,178.6024,62.3279000000001,178.6024,70.2769000000001C178.6024,78.2259000000001,172.1354,84.6909000000001,164.1884,84.6909000000001";
            var defaultChildNodes = [{ pathData: defaultPathData, fillColor: node.fillColor, constraints: constraints, shadow: node.shadow, borderWidth: node.borderWidth, borderColor: node.borderColor, borderDashArray: "1 0", opacity: node.opacity, gradient: node.gradient, visible: true },
                                     { pathData: defaultPathData, fillColor: node.fillColor, borderColor: node.borderColor, borderDashArray: "1 0", opacity: node.opacity, gradient: node.gradient, visible: true },
                                     { pathData: defaultPathData, fillColor: "white", borderColor: node.borderColor, opacity: node.opacity, height: childNodes[0].height * .5, visible: true }];
            $.extend(true, childNodes, defaultChildNodes);
            switch (event) {
                case "start":
                    childNodes[1].visible = false;
                    break;
                case "noninterruptingstart":
                    childNodes[0].borderDashArray = "2 3";
                    childNodes[1].visible = false;
                    break;
                case "intermediate":
                    childNodes[0].fillColor = "white";
                    childNodes[0].gradient = null;
                    break;
                case "noninterruptingintermediate":
                    childNodes[0].fillColor = "white";
                    childNodes[0].gradient = null;
                    childNodes[0].borderDashArray = "2 3";
                    childNodes[1].borderDashArray = "2 3";
                    break;
                case "throwingintermediate":
                case "end":
                    childNodes[0].fillColor = event != "end" ? "white" : "black";
                    childNodes[0].gradient = null;
                    childNodes[2].fillColor = "black";
                    childNodes[2].borderColor = node.fillColor;
                    break;
            }
            switch (trigger) {
                case ej.datavisualization.Diagram.BPMNTriggers.None:
                    childNodes[2].visible = false;
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Message:
                    childNodes[2].pathData = "M0,0 L19.8,12.8 L40,0 L0, 0 L0, 25.5 L40, 25.5 L 40, 0";
                    childNodes[2].height = 3 * childNodes[2].width / 4;
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Timer:
                    childNodes[2].pathData = "M40,20c0,8.654-5.496,16.024-13.189,18.81" +
                                             "C24.685,39.58,22.392,40,20,40C8.954,40,0,31.046,0,20S8.954,0,20,0S40,8.954,40,20z M20,0 L20,2.583 L20,5.283 M10.027,2.681 L11.659,5.507 L12.669,7.257 M2.731,9.989 L6.014,11.885 L7.307,12.631 M0.067,19.967 L2.667,19.967 L5.35,19.967" +
                                             "M2.748,29.939 L5.731,28.217 L7.323,27.298 M10.056,37.236 L11.292,35.095 L12.698,32.66 M20.033,39.9 L20.033,36.417 L20.033,34.617 M30.006,37.219 L28.893,35.292 L27.364,32.643 M37.302,29.911 L34.608,28.355 L32.727,27.269" +
                                             "M39.967,19.933 L37.417,19.933 L34.683,19.933 M37.286,9.961 L34.583,11.521 L32.71,12.602 M29.977,2.664 L28.653,4.957 L27.336,7.24 M22.104,8.5 L19.688,20 L24.75,20 L31.604,20 L24.75,20 L19.688,20z";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Error:
                    childNodes[2].pathData = "M 23.77 18.527 l -7.107 27.396 l 8.507 -17.247 L 36.94 40.073 l 6.394 -25.997 l -8.497 15.754 L 23.77 18.527 Z";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Escalation:
                    childNodes[2].pathData = "M 30.001 8.098 L 11.842 43.543 l 18.159 -18.882 l 18.162 18.882 L 30.001 8.098 Z ";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Cancel:
                    childNodes[2].pathData = "M 3.5 16 L 0 12.6 L 4.6 8 L 0 3.5 L 3.4 0 L 8 4.6 l 4.5 -4.5 L 16 3.5 L 11.5 8 l 4.5 4.5 l -3.4 3.5 L 8 11.4 L 3.5 16 Z";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Compensation:
                    childNodes[2].pathData = "M 25.7086 0 L 0 25 L 25.7086 50 V 26.3752 L 50 50 V 0 L 25.7086 23.6248 V 0 Z ";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Conditional:
                    childNodes[2].pathData = "M 0 0 H 16 V 16 H 0 z M 1.14 3.2 H 14.85 M 1.14 6.4 H 14.85 M 1.14 9.6 H 14.85 M 1.14 12.8 H 14.85";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Link:
                    childNodes[2].pathData = "M 32.014 19.258 v 5.992 H 9.373 v 9.504 h 22.641 v 5.988 L 50.622 30 L 32.014 19.258 Z";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Signal:
                    childNodes[2].pathData = "M 50 50 H 0 L 25.0025 0 L 50 50 Z";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Terminate:
                    childNodes[2].pathData = "M 25 50 C 11.21 50 0 38.79 0 25 C 0 11.21 11.21 0 25 0 C 38.78 0 50 11.21 50 25 C 50 38.79 38.78 50 25 50";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Multiple:
                    childNodes[2].pathData = "M 17.784 48.889 H 42.21 l 7.548 -23.23 L 29.997 11.303 L 10.236 25.658 L 17.784 48.889 Z";
                    break;
                case ej.datavisualization.Diagram.BPMNTriggers.Parallel:
                    childNodes[2].pathData = "M 27.276 49.986 h 5.58 v -17.15 h 17.146 V 27.17 h -17.15 l 0.004 -17.15 h -5.58 l -0.004 17.15 H 9.994 v 5.666 h 17.278 L 27.276 49.986 Z";
                    break;
            }
            return childNodes;
        },
        _updateBPMNActivityShape: function (node, childNodes) {
            var constraints;
            if (childNodes && childNodes[0]) {
                constraints = childNodes[0].constraints ? childNodes[0].constraints : ej.datavisualization.Diagram.NodeConstraints.Default;
                if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                    constraints = constraints | ej.datavisualization.Diagram.NodeConstraints.Shadow;
                }
            }
            var defaultChildNodes = [{ fillColor: node.fillColor, borderWidth: node.borderWidth, constraints: constraints, shadow: node.shadow, borderColor: node.borderColor, borderDashArray: "1 0", opacity: node.opacity, gradient: node.gradient, pathData: this._updateRoundedRectanglePath(node, 12) },
                                    { fillColor: "white", borderColor: "black", width: 14, height: 14, opacity: node.opacity, visible: false },
                                    { addInfo: { margin: { left: 0 } }, opacity: node.opacity, visible: true }, { addInfo: { margin: { left: 0 } }, opacity: node.opacity, visible: true },
                                    { addInfo: { margin: { left: 0 } }, opacity: node.opacity, visible: false }, { addInfo: { margin: { left: 0 } }, opacity: node.opacity, visible: false },
                                    { opacity: node.opacity, visible: false }, { opacity: node.opacity, visible: false }, { opacity: node.opacity, visible: false }];
            var subActivities = [], start = 9, j = 0;
            $.extend(true, childNodes, defaultChildNodes);
            if (node.activity == "subprocess" && !node.subProcess.collapsed && childNodes.length > start && node.subProcess.processes.length)
                subActivities = childNodes.splice(childNodes.length - node.subProcess.processes.length, node.subProcess.processes.length);
            var loop = node.activity == "task" ? node.task.loop : node.subProcess.loop;
            var compensation = node.activity == "task" ? node.task.compensation : node.subProcess.compensation;
            switch (loop) {
                case "none":
                    childNodes[2].visible = false;
                    break;
                case "standard":
                    childNodes[2].pathData = "M 52.002 73.379 c -2.494 -2.536 -6.55 -2.534 -9.043 0 c -1.208 1.228 -1.874 2.861 -1.874 4.598 c 0 1.225 0.337 2.395 0.957 3.411 l -1.167 1.186 l 2.071 0.458 l 2.071 0.458 l -0.45 -2.106 l -0.45 -2.106 l -1.292 1.314 c -1.119 -2.065 -0.842 -4.709 0.877 -6.458 c 2.084 -2.119 5.475 -2.117 7.557 0 c 2.083 2.119 2.083 5.565 0 7.685 c -0.976 0.992 -2.272 1.557 -3.65 1.59 l 0.025 1.068 c 1.65 -0.041 3.2 -0.716 4.368 -1.903 c 1.208 -1.228 1.874 -2.861 1.874 -4.597 C 53.875 76.24 53.209 74.607 52.002 73.379 Z";
                    break;
                case "parallelmultiinstance":
                    childNodes[2].pathData = "M 51.5,69.5 L52.5,69.5 L52.5,84.5 L51.5 84.5 Z M 46.5,69.5 L47.5,69.5 L47.5,84.5 L46.5 84.5 Z M 41.5,69.5 L42.5,69.5 L42.5,84.5 L41.5 84.5 Z  ";
                    break;
                case "sequencemultiinstance":
                    childNodes[2].pathData = "M 40.375,71.5 L 55.375,71.5 L 55.375,72.5 L 40.375,72.5 Z M 40.375,76.5 L 55.375,76.5 L 55.375,77.5 L 40.375,77.5 Z M 40.375,76.5 L 55.375,76.5 L 55.375,77.5 L 40.375,77.5 Z M 40.375,81.5 L 55.375,81.5 L 55.375,82.5 L 40.375,82.5 Z";;
                    break;
            }
            if (compensation)
                childNodes[3].pathData = "M 22.462 18.754 l -6.79 3.92 l 6.79 3.92 V 22.89 l 6.415 3.705 v -7.841 l -6.415 3.705 V 18.754 Z M 28.331 19.701 v 5.947 l -5.149 -2.973 L 28.331 19.701 Z M 21.916 25.647 l -5.15 -2.973 l 5.15 -2.973 V 25.647 Z M 22.275 12.674 c -5.513 0 -9.999 4.486 -9.999 9.999 c 0 5.514 4.486 10.001 9.999 10.001 c 5.514 0 9.999 -4.486 9.999 -10.001 C 32.274 17.16 27.789 12.674 22.275 12.674 Z M 22.275 32.127 c -5.212 0 -9.453 -4.241 -9.453 -9.454 c 0 -5.212 4.241 -9.453 9.453 -9.453 c 5.212 0 9.453 4.241 9.453 9.453 C 31.728 27.887 27.487 32.127 22.275 32.127 Z";
            else
                childNodes[3].visible = false;
            var eventCollections = node.activity == ej.datavisualization.Diagram.BPMNActivity.Task ? node.task.events : node.subProcess.events;
            if (eventCollections && eventCollections.length) {
                for (var i = 0; i < eventCollections.length; i++) {
                    var eventNodes = childNodes.slice(start + i * 3, start + 3 + i * 3);
                    if (!eventNodes.length || eventNodes.length < 3) {
                        var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.PointerEvents | ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.Resize);
                        var defaultProperty = { parent: node.name, type: "node", shape: "path", ports: [], labels: [], constraints: constraints, rotateAngle: node.rotateAngle, _isInternalShape: true, opacity: node.opacity, visible: false, addInfo: { offset: eventCollections[i].offset } };
                        eventCollections[i] = $.extend(true, {}, ej.datavisualization.Diagram.BPMNEventDefaults, eventCollections[i]);
                        eventNodes = [{ width: 24, height: 24 }, { width: 20.4, height: 20.4 }, { width: 12, height: 12 }];
                        for (var j = 0; j < eventNodes.length; j++) {
                            eventNodes[j] = ej.datavisualization.Diagram.Node($.extend(true, { name: node.name + "_" + ej.datavisualization.Diagram.Util.randomId() }, defaultProperty, eventNodes[j]));
                            if (j == 0) {
                                eventNodes[j].constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~ej.datavisualization.Diagram.NodeConstraints.Resize;
                                eventNodes[j].name = eventCollections[i].name ? eventCollections[i].name : node.name + "_" + eventCollections[i].event + "_" + eventCollections[i].trigger + "_" + ej.datavisualization.Diagram.Util.randomId();
                            }
                        }
                        childNodes = childNodes.concat(eventNodes);
                    }
                    this._updateBPMNEventShape(node, eventNodes, eventCollections[i].event, eventCollections[i].trigger);
                }
            }
            else
                childNodes.splice(start, childNodes.length - 1);
            if (node.activity == ej.datavisualization.Diagram.BPMNActivity.Task) {
                childNodes[1].visible = true;
                switch (node.task.type) {
                    case "none":
                        childNodes[1].visible = false;
                        break;
                    case "service":
                        childNodes[1].pathData = "M 32.699 20.187 v -4.005 h -3.32 c -0.125 -0.43 -0.292 -0.83 -0.488 -1.21 l 2.373 -2.375 l -2.833 -2.83 l -2.333 2.333 c -0.44 -0.253 -0.9 -0.448 -1.387 -0.595 v -3.32 h -4.003 v 3.32 c -0.46 0.137 -0.89 0.322 -1.3 0.537 l -2.285 -2.275 l -2.833 2.83 l 2.285 2.278 c -0.235 0.42 -0.41 0.847 -0.547 1.307 h -3.33 v 4.005 h 3.33 c 0.148 0.488 0.343 0.955 0.588 1.395 l -2.325 2.325 l 2.822 2.832 l 2.373 -2.382 c 0.392 0.205 0.792 0.37 1.212 0.497 v 3.33 h 4.003 v -3.33 c 0.46 -0.138 0.89 -0.323 1.3 -0.547 l 2.43 2.432 l 2.822 -2.832 l -2.42 -2.422 c 0.222 -0.41 0.4 -0.85 0.535 -1.297 H 32.699 Z M 22.699 21.987 c -2.1 0 -3.803 -1.703 -3.803 -3.803 c 0 -2.1 1.703 -3.803 3.803 -3.803 c 2.1 0 3.803 1.703 3.803 3.803 C 26.502 20.285 24.8 21.987 22.699 21.987 Z";
                        break;
                    case "receive":
                        childNodes[1].pathData = "M 12.217 12.134 v 13.334 h 20 V 12.134 H 12.217 Z M 30.44 13.007 l -8.223 5.35 l -8.223 -5.35 H 30.44 Z M 13.09 24.594 V 13.459 l 9.127 5.94 l 9.127 -5.94 v 11.135 H 13.09 Z";
                        childNodes[1].height = 12;
                        break;
                    case "send":
                        childNodes[1].pathData = "M 45.7256 3.16055 L 25 23.4017 L 4.27442 3.16055 H 45.7256 Z M 47.8963 46.8413 H 2.10375 V 4.80813 L 25 27.1709 L 47.8963 4.80813 V 46.8413 Z";
                        childNodes[1].height = 12;
                        childNodes[1].fillColor = "black";
                        childNodes[1].borderColor = "white";
                        break;
                    case "instantiatingreceive":
                        childNodes[1].pathData = "M 16.306 17.39 v 8.79 h 13.198 v -8.79 H 16.306 Z M 28.375 17.946 l -5.47 3.558 l -5.47 -3.558 H 28.375 Z M 28.948 25.625 H 16.861 v -7.389 l 6.043 3.931 l 6.043 -3.931 V 25.625 Z M 22.905 11.785 c -5.514 0 -9.999 4.486 -9.999 10 c 0 5.514 4.485 10 9.999 10 s 9.999 -4.486 9.999 -10 C 32.904 16.272 28.419 11.785 22.905 11.785 Z M 22.905 31.239 c -5.212 0 -9.453 -4.241 -9.453 -9.454 c 0 -5.212 4.241 -9.453 9.453 -9.453 s 9.452 4.241 9.452 9.453 C 32.357 26.998 28.117 31.239 22.905 31.239 Z";
                        childNodes[1].width = 20;
                        childNodes[1].height = 20;
                        break;
                    case "manual":
                        childNodes[1].pathData = "M 13.183 15.325 h 2.911 c 0.105 0 0.207 -0.043 0.281 -0.117 c 0.078 -0.074 0.117 -0.176 0.117 -0.281 c 0 -0.753 0.718 -1.362 1.596 -1.362 h 2.579 c -0.117 0.227 -0.191 0.48 -0.195 0.757 c 0 0.433 0.168 0.851 0.46 1.144 c 0.008 0.004 0.015 0.011 0.019 0.015 c -0.289 0.285 -0.475 0.691 -0.479 1.148 c 0 0.433 0.168 0.846 0.46 1.139 c 0.011 0.012 0.023 0.02 0.035 0.032 c -0.301 0.281 -0.491 0.694 -0.495 1.155 c 0 0.432 0.168 0.847 0.46 1.143 c 0.265 0.266 0.612 0.414 0.975 0.414 h 0.839 c 0.027 0.004 0.051 0.012 0.074 0.012 h 8.443 c 0.352 0 0.636 0.344 0.636 0.761 c 0 0.414 -0.285 0.753 -0.636 0.753 h -6.687 c -0.019 0 -0.035 -0.008 -0.051 -0.008 h -2.27 c -0.121 -0.835 -0.667 -1.187 -1.795 -1.187 h -2.158 c -0.223 0 -0.402 0.18 -0.402 0.403 c 0 0.219 0.179 0.398 0.402 0.398 h 2.158 c 0.972 0 1.019 0.203 1.019 0.784 c 0 0.219 0.179 0.399 0.402 0.399 c 0.008 0 0.016 -0.004 0.027 -0.004 c 0.028 0.004 0.055 0.016 0.082 0.016 h 2.56 c 0.34 0.015 0.616 0.343 0.616 0.752 c 0 0.418 -0.285 0.757 -0.636 0.761 h -0.004 h -6.442 c -0.878 0 -1.595 -0.639 -1.595 -1.427 v -0.683 c 0 -0.109 -0.043 -0.211 -0.114 -0.285 c -0.078 -0.074 -0.179 -0.117 -0.285 -0.117 h -0.004 l -2.989 0.027 c -0.223 0 -0.398 0.184 -0.398 0.402 c 0 0.219 0.179 0.395 0.398 0.395 h 0.004 l 2.591 -0.02 v 0.282 c 0 1.229 1.073 2.223 2.391 2.223 h 3.895 c 0.004 0 0.007 0.004 0.011 0.004 h 2.536 c 0.792 0 1.436 -0.698 1.436 -1.561 c 0 -0.273 -0.07 -0.53 -0.188 -0.752 h 5.49 c 0.792 0 1.436 -0.695 1.436 -1.553 c 0 -0.858 -0.644 -1.557 -1.436 -1.557 h -3.566 c 0.121 -0.226 0.199 -0.487 0.199 -0.768 c 0 -0.468 -0.195 -0.882 -0.495 -1.167 c 0.301 -0.285 0.495 -0.698 0.495 -1.163 c 0 -0.456 -0.191 -0.866 -0.483 -1.152 c 0.293 -0.285 0.483 -0.694 0.483 -1.151 c 0 -0.858 -0.647 -1.557 -1.439 -1.557 h -8.373 c -1.167 0 -2.142 0.757 -2.352 1.76 l -2.548 -0.004 c -0.219 0 -0.399 0.18 -0.399 0.403 C 12.784 15.145 12.964 15.325 13.183 15.325 L 13.183 15.325 Z M 21.907 19.707 c -0.191 0 -0.328 -0.094 -0.41 -0.176 c -0.144 -0.145 -0.226 -0.355 -0.226 -0.577 c 0.003 -0.418 0.289 -0.753 0.643 -0.753 h 4.468 c 0.008 0 0.015 -0.004 0.027 -0.008 h 0.051 c 0.351 0 0.636 0.344 0.636 0.761 c 0 0.414 -0.286 0.753 -0.636 0.753 H 21.907 Z M 27.097 16.629 c 0 0.414 -0.286 0.753 -0.64 0.753 h -4.464 c -0.004 0 -0.004 0 -0.004 0 h -0.082 c -0.191 0 -0.328 -0.098 -0.414 -0.18 c -0.14 -0.145 -0.222 -0.352 -0.222 -0.573 c 0 -0.413 0.285 -0.749 0.631 -0.753 h 3.434 c 0 0 0 0 0.004 0 h 1.116 c 0.008 0 0.012 -0.004 0.02 -0.004 C 26.819 15.887 27.097 16.215 27.097 16.629 L 27.097 16.629 Z M 27.097 14.322 c 0 0.41 -0.278 0.737 -0.62 0.749 c -0.008 0 -0.012 0 -0.016 0 h -3.637 c -0.008 0 -0.015 0.004 -0.023 0.004 h -0.886 c -0.004 0 -0.008 0 -0.012 0 c -0.187 0 -0.324 -0.094 -0.406 -0.176 c -0.144 -0.144 -0.226 -0.355 -0.226 -0.577 c 0.003 -0.414 0.293 -0.753 0.643 -0.753 h 4.468 c 0.008 0 0.015 -0.004 0.027 -0.004 h 0.051 C 26.811 13.565 27.097 13.905 27.097 14.322 L 27.097 14.322 Z M 27.097 14.322";
                        childNodes[1].width = 20;
                        break;
                    case "businessrule":
                        childNodes[1].pathData = "M 32.844 13.245 h -0.089 v 0 H 13.764 v -0.015 h -1.009 v 16.989 h 0.095 v 0.011 h 19.716 v -0.011 h 0.278 V 13.245 Z M 31.844 14.229 v 4.185 h -18.08 v -4.185 H 31.844 Z M 18.168 25.306 v 3.938 h -4.404 v -3.938 H 18.168 Z M 13.764 24.322 v -4.923 h 4.404 v 4.923 H 13.764 Z M 19.177 25.306 h 12.667 v 3.938 H 19.177 V 25.306 Z M 19.177 24.322 v -4.923 h 12.667 v 4.923 H 19.177 Z";
                        break;
                    case "user":
                        childNodes[1].pathData = "M 21.762 21.935 c 2.584 0 4.687 -2.561 4.687 -5.703 c 0 -3.147 -2.103 -5.703 -4.687 -5.703 c -1.279 0 -2.475 0.61 -3.363 1.721 c -0.855 1.071 -1.327 2.484 -1.324 3.983 C 17.075 19.374 19.178 21.935 21.762 21.935 L 21.762 21.935 Z M 21.762 11.779 c 1.894 0 3.436 1.995 3.436 4.452 c 0 2.453 -1.541 4.452 -3.436 4.452 c -1.895 0 -3.44 -1.999 -3.44 -4.452 C 18.323 13.774 19.864 11.779 21.762 11.779 L 21.762 11.779 Z M 25.699 21.309 c -0.348 0 -0.626 0.277 -0.626 0.626 c 0 0.344 0.277 0.622 0.626 0.622 c 2.136 0 3.875 1.74 3.875 3.879 c 0 0.272 -0.227 0.498 -0.501 0.498 H 14.447 c -0.274 0 -0.497 -0.223 -0.497 -0.498 c 0 -2.139 1.736 -3.879 3.872 -3.879 c 0.344 0 0.625 -0.277 0.625 -0.622 c 0 -0.348 -0.28 -0.626 -0.625 -0.626 c -2.826 0 -5.124 2.297 -5.124 5.126 c 0 0.965 0.784 1.749 1.748 1.749 h 14.626 c 0.964 0 1.748 -0.784 1.748 -1.749 C 30.822 23.606 28.524 21.309 25.699 21.309 L 25.699 21.309 Z M 22.217 9.832 c 0.448 -0.263 0.924 -0.396 1.419 -0.396 c 1.895 0 3.436 1.995 3.436 4.452 c 0 0.439 -0.048 0.873 -0.143 1.284 c -0.08 0.336 0.128 0.672 0.464 0.751 c 0.048 0.012 0.098 0.019 0.143 0.019 c 0.284 0 0.541 -0.195 0.608 -0.483 c 0.119 -0.506 0.18 -1.034 0.18 -1.571 c 0 -3.147 -2.102 -5.703 -4.687 -5.703 c -0.711 0 -1.419 0.198 -2.054 0.573 c -0.296 0.174 -0.397 0.559 -0.219 0.855 C 21.536 9.911 21.921 10.009 22.217 9.832 L 22.217 9.832 Z M 27.697 18.81 c -0.345 0 -0.626 0.277 -0.626 0.622 c 0 0.348 0.281 0.626 0.626 0.626 c 2.137 0 3.75 1.782 3.75 3.918 c 0 0.07 -0.013 0.141 -0.043 0.205 c -0.14 0.314 0.003 0.684 0.318 0.823 c 0.082 0.037 0.167 0.055 0.253 0.055 c 0.241 0 0.466 -0.141 0.57 -0.373 c 0.101 -0.226 0.153 -0.464 0.153 -0.714 C 32.699 21.15 30.523 18.81 27.697 18.81 L 27.697 18.81 Z M 27.697 18.81";
                        break;
                    case "script":
                        childNodes[1].pathData = "M 22.453 15.04 c 0 0 -1.194 -3.741 2.548 -3.774 c 0 0 2.497 0.126 1.766 4.321 c -0.008 0.043 -0.015 0.086 -0.024 0.13 c -0.806 4.323 -2.516 8.42 -3.193 10.581 h 3.904 c 0 0 0.983 4.581 -2.549 4.968 H 13.292 c 0 0 -3.097 -1.42 -1.517 -5.323 l 3 -10.839 H 11.84 c 0 0 -1.129 -2.902 1.709 -3.806 l 11.425 -0.032 l -0.73 0.355 l -1.193 1.726 L 22.453 15.04 Z M 22.409 12.597 c 0 0 -0.242 0.483 -0.278 0.98 h -9.098 c 0 0 -0.06 -0.871 0.714 -1.041 L 22.409 12.597 Z M 26.341 27.734 c 0 0 -0.13 2.678 -2.226 1.871 c 0 0 -0.823 -0.565 -0.758 -1.855 L 26.341 27.734 Z M 22.905 15.008 c 0 0 0.653 -0.258 0.709 -1.501 c 0 0 0.145 -1.144 1.483 -0.693 c 0 0 0.808 0.355 0.259 2.404 c 0 0 -2.226 8.5 -3.032 10.339 c 0 0 -1.064 2.646 0.096 4.226 h -8.581 c 0 0 -1.806 -0.452 -0.741 -3.613 c 0 0 2.935 -9.549 3.193 -11.162 L 22.905 15.008 Z";
                        break;
                }
                if (node.task.call) childNodes[0].borderWidth = 4;
                if (node.task.compensation && node.task.loop != "none") {
                    childNodes[2].addInfo.margin.left -= childNodes[2].width / 2 + 2;
                    childNodes[3].addInfo.margin.left += childNodes[3].width / 2 + 2;
                }
            }
            else if (node.activity == ej.datavisualization.Diagram.BPMNActivity.SubProcess) {
                var markerX = 0, markerWidth = 0, index = 2;
                if (node.subProcess.collapsed) {
                    childNodes[4].constraints = constraints | ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                    childNodes[4].visible = true;
                    childNodes[4].pathData = "M 8.13789 15 H 0 V 0 H 8.13789 V 15 Z M 0.625991 13.75 H 7.51189 V 1.25 H 0.625991 V 13.75 Z M 2.18095 7.03125 L 5.95631 7.03125 L 5.95631 7.46875 L 2.18095 7.46875 Z M 3.8342 3.73 L 4.30369 3.73 L 4.30369 11.2687 L 3.8342 11.2687 Z";
                }
                else {
                    childNodes[4].constraints = childNodes[4].constraints | ej.datavisualization.Diagram.NodeConstraints.PointerEvents;
                    childNodes[4].visible = true;
                    childNodes[4].pathData = "M 8.13789 15 H 0 V 0 H 8.13789 V 15 Z M 0.625991 13.75 H 7.51189 V 1.25 H 0.625991 V 13.75 Z M 2.18095 7.03125 L 5.95631 7.03125 L 5.95631 7.46875 L 2.18095 7.46875 Z M 3.8342 3.73 L 4.30369 3.73 L 4.30369 11.2687 L 3.8342 11.2687 Z";
                    childNodes[0] = $.extend(true, childNodes[0], { marginLeft: -node.paddingLeft, marginRight: -node.paddingRight, marginTop: -node.paddingTop, marginBottom: -node.paddingBottom, minWidth: node.width, minHeight: node.height });
                    node.constraints = node.constraints | ej.datavisualization.Diagram.NodeConstraints.AllowDrop;
                    node.minWidth = node.width;
                    node.minHeight = node.height;
                    while (j < subActivities.length) {
                        if (subActivities[j].type != "bpmn") subActivities.splice(j, 1);
                        j++;
                    }
                    childNodes = childNodes.concat(subActivities);
                }
                switch (node.subProcess.boundary) {
                    case "default":
                        childNodes[0].borderWidth = 1;
                        childNodes[0].borderDashArray = "1 0";
                        break;
                    case "call":
                        childNodes[0].borderWidth = 4;
                        childNodes[0].borderDashArray = "1 0";
                        break;
                    case "event":
                        childNodes[0].borderWidth = 1;
                        childNodes[0].borderDashArray = "2 2";
                        break;
                }
                if (node.subProcess.adhoc) {
                    childNodes[5].visible = true;
                    childNodes[5].pathData = "M 49.832 76.811 v -2.906 c 0 0 0.466 -1.469 1.931 -1.5 c 1.465 -0.031 2.331 1.219 2.897 1.688 s 1.06 0.75 1.526 0.75 c 0.466 0 1.548 -0.521 1.682 -1.208 s 0.083 3.083 0.083 3.083 s -0.76 0.969 -1.859 0.969 c -1.066 0 -1.865 -0.625 -2.464 -1.438 s -1.359 -0.998 -2.064 -0.906 C 50.598 75.467 49.832 76.811 49.832 76.811 Z";
                }
                else if (node.subProcess.type == "event") {
                    childNodes[0].borderWidth = 1;
                    childNodes[0].borderDashArray = "2 2";
                    this._updateBPMNEventShape(node, childNodes.slice(6, 9), node.subProcess.event, node.subProcess.trigger);

                }
                else if (node.subProcess.type == "transaction") {
                    var innerRect = { x: 3, y: 3, width: node.width - 3, height: node.height - 3 };
                    childNodes[0].pathData += ej.datavisualization.Diagram.DefautShapes._updateRoundedRectanglePath(innerRect, 12);
                }
                //Reset Marker's postion
                do {
                    if (childNodes[index].visible) {
                        childNodes[index].addInfo.margin.left = markerWidth + childNodes[index].width / 2;
                        markerWidth += childNodes[index].width + 2;
                    }
                    index++;
                } while (index < 6);
                markerWidth -= 2;
                index = 2;
                markerX = markerWidth / 2;
                do {
                    if (childNodes[index].visible)
                        childNodes[index].addInfo.margin.left -= markerX;
                    index++;
                } while (index < 6);
            }
            return childNodes;
        },
        _updateRoundedRectanglePath: function (node, a) {
            var d = "", i = 0;
            var points = [{ x: node.x || 0, y: node.y || 0 }, { x: node.x || 0, y: node.height }, { x: node.width, y: node.height }, { x: node.width, y: node.y || 0 }];
            var vector = [{ x: a, y: a }, { x: a, y: -a }, { x: -a, y: -a }, { x: -a, y: a }];
            for (i = 0; i < points.length; i++) {
                d += !d ? "M" : "L";
                d += (points[i].x + (i % 2 == 0 ? vector[i].x : 0)) + "," + (points[i].y + (i % 2 != 0 ? vector[i].y : 0));
                d += "C" + points[i].x + "," + points[i].y + " " + points[i].x + "," + points[i].y;
                d += " " + (points[i].x + (i % 2 != 0 ? vector[i].x : 0)) + "," + (points[i].y + (i % 2 == 0 ? vector[i].y : 0));
            }
            d += "L" + (points[0].x + vector[0].x) + "," + (points[0].y);
            d += "Z";
            return d;
        },

        initBPMNAnnotationShape: function (options, diagram) {
            var annotationNodes = [], n = 0;
            if (options._annotation && options._annotation.length) {
                while (n < options._annotation.length) {
                    var element = diagram.nameTable[options._annotation[n++]];
                    if (element && element.name.split('annotation_')[0] != options.name) options._annotation.splice(--n, 1);
                    else if (element) annotationNodes.push(element);
                    else break;
                }
            }
            if (options.annotation && options.annotation.text) {
                options = $.extend(true, {}, ej.datavisualization.Diagram.BPMNTextAnnotationDefaults, options);
                if (!annotationNodes.length) {
                    var visibility = ej.datavisualization.Diagram.PortVisibility.Hidden;
                    var portConstraints = ej.datavisualization.Diagram.PortConstraints.None;
                    var ports = [{ offset: { x: 0, y: 0.5 }, name: "left", visibility: visibility, constraints: portConstraints }, { offset: { x: 0.5, y: 0 }, name: "top", visibility: visibility, constraints: portConstraints }, { offset: { x: 1, y: 0.5 }, name: "right", visibility: visibility, constraints: portConstraints }, { offset: { x: 0.5, y: 1 }, name: "bottom", visibility: visibility, constraints: portConstraints }];
                    var name0 = options.name + "annotation_" + ej.datavisualization.Diagram.Util.randomId(), name1 = options.name + "annotation_" + ej.datavisualization.Diagram.Util.randomId();
                    var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.Connect);
                    var connectorConstraints = ej.datavisualization.Diagram.ConnectorConstraints.Default & ~(ej.datavisualization.Diagram.ConnectorConstraints.DragSourceEnd | ej.datavisualization.Diagram.ConnectorConstraints.Drag);
                    if (options._annotation && options._annotation.length) {
                        name0 = typeof options._annotation[0] == "string" ? options._annotation[0] : options._annotation[0].name;
                        name1 = typeof options._annotation[1] == "string" ? options._annotation[1] : options._annotation[1].name;
                    }
                    else
                        options._annotation = [];
                    annotationNodes.push({ name: name0, labels: [{ text: options.annotation.text }], annotation: options.annotation, type: "bpmn", shape: "annotation", _type: "node", _shape: "path", ports: ports, constraints: constraints, width: options.annotation.width, height: options.annotation.height, _preventStretch: true });
                    annotationNodes.push({ name: name1, labels: [{ readOnly: true }], type: "connector", segments: [{ type: "straight" }], targetDecorator: { shape: "none" }, sourceNode: annotationNodes[0].name, targetNode: options.name, constraints: connectorConstraints, annotation: options.annotation, _isAnnotationLine: true });
                }
                annotationNodes[0].offsetX = options.offsetX + options.annotation.length * Math.cos(-options.annotation.angle * (Math.PI / 180));
                annotationNodes[0].offsetY = options.offsetY + options.annotation.length * Math.sin(-options.annotation.angle * (Math.PI / 180));
                var defaultChildNodes = [{ fillColor: "transparent", borderColor: options.borderColor, rotateAngle: options.rotateAngle, opacity: options.opacity, ports: [] },
                                        { lineColor: options.borderColor, opacity: options.opacity }];
                $.extend(true, annotationNodes, defaultChildNodes);
                var node = diagram.nameTable[annotationNodes[0].name], connector = diagram.nameTable[annotationNodes[1].name];
                if (!node) {
                    node = diagram._getNewNode(annotationNodes[0]);
                    diagram.nameTable[node.name] = node;
                    options._annotation.splice(0, 1, node.name);
                }
                if (!connector) {
                    connector = diagram._getNewConnector(annotationNodes[1]);
                    diagram.nameTable[connector.name] = connector;
                    options._annotation.splice(1, 1, connector.name);
                }
                this.updateBPMNAnnotationShape(connector, node, null, options, diagram);
            }
            return options;
        },
        renderBPMNAnnotationShape: function (node, diagram) {
            if (node._annotation && node._annotation.length) {
                for (var n = 0; n < node._annotation.length; n++) {
                    var element = typeof node._annotation[n] == "string" ? diagram.nameTable[node._annotation[n]] : node._annotation[n];
                    if (element) {
                        diagram.nameTable[element.name] = element;
                        var type = diagram.getObjectType(element);
                        if (type == "node") {
                            ej.datavisualization.Diagram.DiagramContext.renderNode(element, diagram);
                        }
                        else if (type == "connector") {
                            var disableSegmentChange = diagram._disableSegmentChange;
                            diagram._disableSegmentChange = false;
                            diagram._updateEdges(element);
                            diagram._dock(element, diagram.nameTable);
                            ej.datavisualization.Diagram.DiagramContext.renderConnector(element, diagram);
                            diagram._disableSegmentChange = disableSegmentChange;
                        }
                    }
                }
            }
        },
        updateBPMNAnnotationShape: function (element, annotationNode, previousTarget, currentTarget, diagram) {
            if (diagram.getObjectType(element) == "connector" && element._isAnnotationLine) {
                if (previousTarget && diagram.nameTable[previousTarget]) {
                    var prevNode = diagram.nameTable[previousTarget];
                    $.extend(true, prevNode, ej.datavisualization.Diagram.BPMNTextAnnotationDefaults);
                    delete prevNode._annotation;
                }
                if (!currentTarget) currentTarget = diagram.nameTable[element.targetNode];
                var annotationBounds = ej.datavisualization.Diagram.Util.bounds(annotationNode);
                var w = 20, h = 20, targetBounds;
                if (currentTarget) targetBounds = ej.datavisualization.Diagram.Util.bounds(currentTarget);
                else targetBounds = { x: element.targetPoint.x, y: element.targetPoint.y, width: element.lineWidth, height: element.lineWidth };
                var port = "";
                if (annotationBounds.x <= targetBounds.x + targetBounds.width && annotationBounds.x + annotationBounds.width >= targetBounds.x) {
                    if (annotationBounds.y + annotationBounds.height < targetBounds.y) port = "bottom";
                    if (annotationBounds.y > targetBounds.y + targetBounds.height) port = "top";
                }
                if (!port) {
                    if (annotationBounds.x > targetBounds.x + targetBounds.width) port = "left";
                    if (annotationBounds.x + annotationBounds.width < targetBounds.x) port = "right";
                }
                if (!port && !element.annotation.direction) port = "left";
                element.annotation.direction = port;
                annotationNode.labels[0].horizontalAlignment = annotationNode.labels[0].verticalAlignment = annotationNode.labels[0].textAlign = "center";
                switch (element.annotation.direction) {
                    case "left":
                        h = annotationBounds.height;
                        annotationNode.pathData = "M" + w + "," + h + " L0," + h + " L0,0 L" + w + ",0";
                        annotationNode.labels[0].horizontalAlignment = "left";
                        annotationNode.labels[0].textAlign = "left";
                        annotationNode.labels[0].offset = ej.datavisualization.Diagram.Point(0.05, 0.5);
                        break;
                    case "right":
                        h = annotationBounds.height;
                        w = annotationBounds.width - 20;
                        annotationNode.pathData = "M" + w + "," + h + " L" + (w + 20) + "," + h + " L" + (w + 20) + ",0 L" + w + ",0";
                        annotationNode.labels[0].horizontalAlignment = "right";
                        annotationNode.labels[0].textAlign = "right";
                        annotationNode.labels[0].offset = ej.datavisualization.Diagram.Point(0.95, 0.5);
                        break;
                    case "top":
                        w = annotationBounds.width;
                        annotationNode.pathData = "M" + w + "," + h + " L" + w + ",0 L0,0 L0," + h;
                        annotationNode.labels[0].verticalAlignment = "top";
                        annotationNode.labels[0].offset = ej.datavisualization.Diagram.Point(0.5, 0);
                        break;
                    case "bottom":
                        h = annotationBounds.height - 20;
                        w = annotationBounds.width;
                        annotationNode.pathData = "M" + w + "," + h + " L" + w + "," + (h + 20) + " L0," + (h + 20) + " L0," + h;
                        annotationNode.labels[0].verticalAlignment = "bottom";
                        annotationNode.labels[0].offset = ej.datavisualization.Diagram.Point(0.5, 1);
                        break;
                }
                if (diagram.nameTable[element.name]) {
                    var disableSegmentChange = diagram._disableSegmentChange;
                    diagram._disableSegmentChange = false;
                    element.annotation.direction = element.sourcePort = port;
                    diagram._updateEdges(element);
                    diagram._dock(element, diagram.nameTable);
                    diagram._disableSegmentChange = disableSegmentChange;
                }
                ej.datavisualization.Diagram.DiagramContext.update(annotationNode, diagram);
            }
        },
        translateBPMNAnnotationShape: function (node, sw, sh, pivot, diagram) {
            if (node.annotation && node.shape != "annotation") {
                var annotationNodes = [];
                if (node.annotation && node.annotation.text) {
                    node = $.extend(true, {}, ej.datavisualization.Diagram.BPMNTextAnnotationDefaults, node);
                    if (node._annotation && node._annotation.length) {
                        for (var n = 0; n < node._annotation.length; n++)
                            if (diagram.nameTable[node._annotation[n]])
                                annotationNodes.push(diagram.nameTable[node._annotation[n]]);
                        if (annotationNodes.length) {
                            var dx = sw, dy = sh;
                            //pivot is previous offset value
                            if (pivot) {
                                var dx = 0, dy = 0;
                                var matrix = ej.Matrix.identity();
                                if (node.rotateAngle) {
                                    ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                                    ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                                    ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                                }
                                else ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                                var diffx = node.offsetX - pivot.x, diffy = node.offsetY - pivot.y;
                                var cornerPoints = {
                                    bottom: { x: node.offsetX, y: bounds.y },
                                    left: { x: bounds.x + bounds.width, y: node.offsetY },
                                    top: { x: node.offsetX, y: bounds.y + bounds.height },
                                    right: { x: bounds.x, y: node.offsetY }
                                }
                                var pt = cornerPoints[annotationNodes[0].annotation.direction];
                                var oldPosition = ej.Matrix.transform(matrix, { x: pt.x - diffx, y: pt.y - diffy });
                                if (oldPosition.x != pt.x) dx = pt.x - oldPosition.x;
                                if (oldPosition.y != pt.y) dy = pt.y - oldPosition.y;
                            }
                            diagram._translate(annotationNodes[0], dx, dy, diagram.nameTable);
                        }
                    }
                }
            }
            else if (node.annotation && node.shape == "annotation") {
                var connector;
                for (var i = 0; i < node.outEdges.length; i++) {
                    var edge = diagram.nameTable[node.outEdges[i]];
                    if (edge._isAnnotationLine) {
                        connector = edge;
                        break;
                    }
                }
                if (connector) {
                    var target = node.targetNode ? diagram.nameTable[node.targetNode] : null;
                    this.updateBPMNAnnotationShape(connector, diagram.nameTable[connector.sourceNode], null, target, diagram);
                }
            }
        },
        updateAnnotationProperties: function (element, diagram) {
            if (diagram.getObjectType(element) == "node")
                element = diagram.nameTable[element.outEdges[0]];
            var currentTarget = diagram.nameTable[element.targetNode];
            var annotationNode = diagram.nameTable[element.sourceNode];
            if (currentTarget && annotationNode) {
                element.annotation.angle = ej.datavisualization.Diagram.Util._findAngle({ x: annotationNode.offsetX, y: annotationNode.offsetY }, { x: currentTarget.offsetX, y: currentTarget.offsetY }) * -1;
                element.annotation.length = ej.datavisualization.Diagram.Util.findLength({ x: currentTarget.offsetX, y: currentTarget.offsetY }, { x: annotationNode.offsetX, y: annotationNode.offsetY });
                annotationNode.annotation = currentTarget.annotation = $.extend(true, {}, element.annotation);
                currentTarget._annotation = [element.sourceNode, element.name];
                if (diagram.nodes().indexOf(annotationNode) > -1) {
                    ej.datavisualization.Diagram.Util.removeItem(diagram.nodes(), annotationNode);
                    ej.datavisualization.Diagram.Util.removeItem(diagram.connectors(), element);
                    diagram._nodes = $.extend(true, [], diagram.nodes());
                }
            }
            else if (annotationNode) {
                element.annotation.angle = ej.datavisualization.Diagram.Util._findAngle({ x: annotationNode.offsetX, y: annotationNode.offsetY }, element.targetPoint) * -1;
                element.annotation.length = ej.datavisualization.Diagram.Util.findLength(element.targetPoint, { x: annotationNode.offsetX, y: annotationNode.offsetY });
                annotationNode.annotation = $.extend(true, {}, element.annotation);
                diagram.nodes().push(annotationNode);
                diagram.connectors().push(element);
                diagram._nodes = $.extend(true, [], diagram.nodes());
            }
        },
        updateInlineDecoratorsShape: function (connector, diagram) {
            var node;
            if (connector.shape && connector.shape.type == "bpmn" && connector.shape.flow == "message") {
                if (connector._inlineDecorators.length) {
                    var nodes = connector._inlineDecorators.filter(function (e) { if (e.name == connector.name + "_" + connector.shape.message) return e; });
                    if (nodes.length) node = nodes[0];

                }
                connector._inlineDecorators = [];
                if (connector.shape.message == "initiatingmessage" || connector.shape.message == "noninitiatingmessage") {
                    var position = ej.datavisualization.Diagram.Util._findOffsetOnConnector(connector, { segmentOffset: 0.5 }, 0.5, diagram);
                    var fillColor = connector.shape.message == "noninitiatingmessage" ? "lightgrey" : "white";
                    if (node) {
                        node.offsetX = position.offset.x; node.offsetY = position.offset.y; node.fillColor = fillColor;
                    } else
                        node = ej.datavisualization.Diagram.Node({ name: connector.name + "_" + connector.shape.message, width: 25, height: 15, offsetX: position.offset.x, offsetY: position.offset.y, fillColor: fillColor, shape: "path", pathData: "M0,0 L19.8,12.8 L40,0 L0, 0 L0, 25.5 L40, 25.5 L 40, 0", constraints: ej.datavisualization.Diagram.NodeConstraints.Delete });
                    connector._inlineDecorators.push(node);
                }
            }
            return connector;
        },
        //#endregion
    };
    ej.datavisualization.Diagram.bpmnHelper = {
        resetNodeMargin: function (node, overnode, diagram) {
            var margins = { marginLeft: node.marginLeft, marginRight: node.marginRight, marginTop: node.marginTop, marginBottom: node.marginBottom };
            ej.datavisualization.Diagram.canvasHelper._updateNodeMargin(diagram, node, overnode);
            if (overnode && overnode._type == "group") {
                for (var i = 0; i < overnode.children.length; i++) {
                    var child = typeof overnode.children[i] == "string" ? diagram.nameTable[overnode.children[i]] : overnode.children[i];
                    for (var margin in margins)
                        if (margins[margin] == 0) child[margin] = 0;
                }
            }
        },
        updateCanvas: function (node, diagram) {
            if (!diagram._isUndo) ej.datavisualization.Diagram.canvasHelper._updateNodeMargin(diagram, node, diagram.nameTable[node.parent])
            if (node.container && node.container.type === "canvas") {
                ej.datavisualization.Diagram.canvasHelper._setSize(diagram, node, true);
                this.updateProcessCollection(node, diagram);
                if (node.parent && diagram.nameTable[node.parent]) {
                    var parent = diagram.nameTable[node.parent];
                    this.resetNodeMargin(node, parent, diagram);
                    this.updateCanvas(parent, diagram);
                }
                else {
                    ej.datavisualization.Diagram.canvasHelper._updateNodeMargin(diagram, node, diagram.nameTable[node.parent]);
                }
                if (diagram.nameTable[node.name]) {
                    var disableSegmentChange = diagram._disableSegmentChange;
                    diagram._disableSegmentChange = false;
                    diagram._updateAssociatedConnectorEnds(node, diagram.nameTable);
                    ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
                    diagram._disableSegmentChange = disableSegmentChange;
                }
            }
        },
        updateProcessCollection: function (node, diagram) {
            if (node.shape == "activity" && node.activity == "subprocess") {
                var process = node.subProcess.processes, i = 0;
                var children = diagram._getChildren(node.children);
                while (process && process.length && i < process.length) {
                    if (children.indexOf(process[i].name) == -1)
                        ej.datavisualization.Diagram.Util.removeItem(process, process[i]);
                    else
                        process[i] = diagram.nameTable[process[i++].name];
                }
                for (var i = 0; i < node.children.length; i++) {
                    var child = typeof node.children[i] == "string" ? diagram.nameTable[node.children[i]] : node.children[i];
                    if (!child._isInternalShape && process.indexOf(child) == -1)
                        process.push(child);
                }
            }
        },
        isBPMNContainerChild: function (node, diagram) {
            if (node && node.parent) {
                var parent = diagram.nameTable[node.parent];
                return (parent && parent.type == "bpmn" && parent.shape != "group" && parent.container) ? true : false;
            }
        },
        canMoveOutofBounds: function (diagram, element, ptX, ptY) {
            if (diagram.getObjectType(element) == "connector") {
                if (element.sourceNode || element.targetNode) {
                    var node = diagram.nameTable[element.sourceNode || element.targetNode];
                    if (node && this.isBPMNContainerChild(node, diagram)) {
                        var bpmnContainer = diagram.nameTable[node.parent];
                        var bounds = ej.datavisualization.Diagram.Util.bounds(bpmnContainer);
                        bounds = ej.datavisualization.Diagram.Geometry.rect([bounds.topLeft, bounds.topRight, bounds.bottomRight, bounds.bottomLeft]);
                        return ((ptX >= bounds.x + bounds.width || ptX <= bounds.x) || (ptY >= bounds.y + bounds.height || ptY <= bounds.y)) ? false : true;
                    }
                }
            }
            return true;
        },
        canAllowConnection: function (diagram, connectedNode, possibleConnection) {
            var parent = null, element = null;
            if (connectedNode && possibleConnection && possibleConnection.type == "bpmn") {
                if (possibleConnection.parent)
                    parent = diagram.nameTable[possibleConnection.parent];
                if (parent && parent.type == "bpmn" && parent.shape != "group" && connectedNode.parent != possibleConnection.parent)
                    return parent;
                else if (diagram._containsChild(possibleConnection, connectedNode) || diagram._containsChild(connectedNode, possibleConnection))
                    return null;
            }
            return possibleConnection;
        },
        canAllowDropOnContainer: function (node, target) {
            if (target.type != "bpmn" || (node.type == "bpmn" && node.shape != "annotation"))
                return true;
            return false;
        }
    };
})(jQuery, Syncfusion);;

(function ($, ej) {
    "use strict";

    //#region SVG
    var Svg = (function () {
        function Svg(attr) {
            this.xmlns = "http://www.w3.org/2000/svg";
            this.document = document.createElementNS(this.xmlns, "svg");
            this.id = attr.id;
            if (attr) {
                ej.datavisualization.Diagram.Util.attr(this.document, attr);
            }
            return this;
        }
        Svg.prototype.element = function (attr, tag) {
            var element;
            if (attr && attr.id) {
                element = this.document.getElementById(attr.id);
            }
            if (!element) {
                element = document.createElementNS(this.xmlns, tag);
            }
            if (attr)
                ej.datavisualization.Diagram.Util.attr(element, attr);
            return element;
        };
        Svg.prototype.g = function (attr) {
            return this.element(attr, "g");
        };
        Svg.prototype.defs = function (attr) {
            return this.element(attr, "defs");
        };
        Svg.prototype.image = function (attr) {
            return this.element(attr, "image");
        };
        Svg.prototype.path = function (attr) {
            return this.element(attr, "path");
        };
        Svg.prototype.text = function (attr) {
            return this.element(attr, "text");
        };
        Svg.prototype.textPath = function (attr) {
            return this.element(attr, "textPath");
        };
        Svg.prototype.tspan = function (attr) {
            return this.element(attr, "tspan");
        };
        Svg.prototype.rect = function (attr) {
            return this.element(attr, "rect");
        };
        Svg.prototype.ellipse = function (attr) {
            return this.element(attr, "ellipse");
        };
        Svg.prototype.circle = function (attr) {
            return this.element(attr, "circle");
        };
        Svg.prototype.title = function (attr) {
            return this.element(attr, "title");
        };
        Svg.prototype.line = function (attr) {
            return this.element(attr, "line");
        };
        Svg.prototype.polyline = function (attr) {
            return this.element(attr, "polyline");
        };
        Svg.prototype.polygon = function (attr) {
            return this.element(attr, "polygon");
        };
        Svg.prototype.foreignObject = function (attr) {
            return this.element(attr, "foreignObject");
        };
        Svg.prototype.linearGradient = function (attr) {
            return this.element(attr, "linearGradient");
        };
        Svg.prototype.radialGradient = function (attr) {
            return this.element(attr, "radialGradient");
        };
        Svg.prototype.stop = function (attr) {
            return this.element(attr, "stop");
        };
        Svg.prototype.pattern = function (attr) {
            return this.element(attr, "pattern");
        };
        Svg.prototype.appendChild = function (element) {
            this.document.appendChild(element);
        };
        Svg.prototype.removeChild = function (element, parent) {
            if (parent) {
                parent.removeChild(element);
            } else {
                this.document.removeChild(element);
            }
        };
        Svg.prototype.getElementById = function (id) {
            return this.document.getElementById(id);
        };
        Svg.prototype.getElementsByClassName = function (name) {
            return this.document.getElementsByClassName(name);
        };
        Svg.prototype.getElementsByTagName = function (name) {
            return this.document.getElementsByTagName(name);
        };
        Svg.prototype.pathBounds = function (data) {
            var attributes = { d: data };
            var path = this.path(attributes);
            var svg = new ej.datavisualization.Diagram.Svg({ "id": "TempSvg" });
            document.body.appendChild(svg.document);
            svg.document.appendChild(path);
            var bounds = path.getBBox();
            document.body.removeChild(svg.document);
            return bounds;
        };
        Svg.prototype.textBounds = function (text, attr, textElement) {
            var bounds = null;
            if (text && attr) {
                var svgText = this.text(attr);
                svgText.appendChild(document.createTextNode(text));
                this.document.appendChild(svgText);
                bounds = svgText.getBBox();
                this.document.removeChild(svgText);
            }
            else if (textElement) {
                this.document.appendChild(textElement);
                bounds = textElement.getBBox();
                this.document.removeChild(textElement);
            }
            return bounds;
        };
        Svg.prototype.absolutePath = function (path) {
            var x0, y0, x1, y1, x2, y2, segs = ej.datavisualization.Diagram.Util.convertPathToArray(path.getAttribute("d"));
            for (var x = 0, y = 0, i = 0, length = segs.length; i < length; ++i) {
                var seg = segs[i], char = seg.pathSegTypeAsLetter;
                if (/[MLHVCSQTA]/.test(char)) {
                    if ('x' in seg) x = seg.x;
                    if ('y' in seg) y = seg.y;
                } else {
                    if ('x1' in seg) x1 = x + seg.x1;
                    if ('x2' in seg) x2 = x + seg.x2;
                    if ('y1' in seg) y1 = y + seg.y1;
                    if ('y2' in seg) y2 = y + seg.y2;
                    if ('x' in seg) x += seg.x;
                    if ('y' in seg) y += seg.y;
                    var newSeg;
                    switch (char) {
                        case 'm':
                            newSeg = { pathSegTypeAsLetter: "M", x: x, y: y };
                            break;
                        case 'l':
                            newSeg = { pathSegTypeAsLetter: "L", x: x, y: y };
                            break;
                        case 'h':
                            newSeg = { pathSegTypeAsLetter: "H", x: x };
                            break;
                        case 'v':
                            newSeg = { pathSegTypeAsLetter: "V", y: y };
                            break;
                        case 'c':
                            newSeg = { pathSegTypeAsLetter: "C", x: x, y: y, x1: x1, y1: y1, x2: x2, y2: y2 };
                            break;
                        case 's':
                            newSeg = { pathSegTypeAsLetter: "S", x: x, y: y, x2: x2, y2: y2 };
                            break;
                        case 'q':
                            newSeg = { pathSegTypeAsLetter: "Q", x: x, y: y, x1: x1, y1: y1 };
                            break;
                        case 't':
                            newSeg = { pathSegTypeAsLetter: "T", x: x, y: y };
                            break;
                        case 'a':
                            newSeg = { pathSegTypeAsLetter: "A", x: x, y: y, r1: seg.r1, r2: seg.r2, angle: seg.angle, largeArcFlag: seg.largeArcFlag, sweepFlag: seg.sweepFlag };
                            break;
                        case 'z':
                        case 'Z':
                            x = x0; y = y0;
                            newSeg = segs[i];
                            break;
                    }
                    if (newSeg)
                        segs[i] = newSeg;
                }
                if (char === 'M' || char === 'm') x0 = x, y0 = y;
            }
            path.setAttribute("d", ej.datavisualization.Diagram.Util.pathSegArrayAsString(segs));
            return path;
        };
        return Svg;
    })();

    ej.datavisualization.Diagram.Svg = Svg;
    //#endregion

    //#region SVG Renderer
    ej.datavisualization.Diagram.SvgContext = {

        _renderDocument: function (view, diagram, isload) {
            if (window.SVGSVGElement) {
                var attr = {
                    id: view.canvas.id + "_svg",
                    version: "1.1",
                    xlink: "http://www.w3.org/1999/xlink",
                    "style": "position:absolute",
                    "class": "mainview_svg",
                    "role": "img",
                };
                if (ej.isMobile())
                    attr.style = "position: inherit";
                if (!isload)
                    var svg = new ej.datavisualization.Diagram.Svg(attr);
                else
                    svg = diagram._svg
                view.svg = svg;
                if (diagram) {
                    diagram._svg = svg;
                    if (!isload && !document.getElementById(svg.document.id))
                        view.canvas.appendChild(svg.document);
                    diagram._view = this._renderView(view.canvas, view.svg, isload);
                    diagram._page = this._renderPage(view.canvas, view.svg, diagram._view, isload);
                    this._renderBackground(diagram, view.canvas, view.svg, diagram._page, diagram.model, isload);
                    diagram._pageBackgroundLayer = this._renderBackgroundLayer(view.canvas, view.svg, diagram._page, isload);
                    this._renderGrid(view.canvas, view.svg, diagram._page, diagram);
                    diagram._diagramLayer = view.diagramLayer = this._renderDiagramLayer(view.canvas, view.svg, diagram._page);
                    diagram._htmlLayer = this._renderHtmlLayer(view.canvas, isload);
                    this._renderAdornerLayer(diagram, view.canvas, isload, view);
                }
                else {


                }
            }
        },

        _renderView: function (canvas, svg, isload) {
            var view = svg.document.getElementById(canvas.id + "_view");
            if (!view) {
                var attr = { id: canvas.id + "_view" };
                view = svg.g(attr);
            }
            if (!isload)
                svg.appendChild(view);
            return view;
        },

        _renderHtmlLayer: function (canvas, isload) {
            var div = document.getElementById(canvas.id + "_htmlLayer");
            if (!div)
                div = document.createElement("div");
            var attr = { "id": canvas.id + "_htmlLayer", "class": "htmlLayer" };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            var htmlLayer = div;
            div.style.pointerEvents = "none";
            if (!isload)
                canvas.appendChild(htmlLayer);
            return htmlLayer;
        },

        _renderAdornerLayer: function (diagram, canvas, isload, view) {
            var div = document.getElementById(canvas.id + "_adorner");
            if (!div)
                div = document.createElement("div");
            var attr = { "id": canvas.id + "_adorner", "class": "adornerLayer", "style": "position:absolute;left:0px;top:0px" };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            diagram._adornerLayer = this._renderAdornerSvg(diagram, canvas, div, isload, view);
            diagram._tooltipLayer = this._renderTooltipLayer(canvas, div, isload);
            if (!isload)
                canvas.appendChild(div);
        },

        _renderTooltipLayer: function (canvas, parent, isload) {
            var div = document.getElementById(canvas.id + "_tooltip");
            if (!div)
                div = document.createElement("div");
            var attr = { "id": canvas.id + "_tooltip", "class": "diagram_tooltip" };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            var tooltipdiv = div;
            div.style.pointerEvents = "none";
            if (!isload)
                parent.appendChild(tooltipdiv);
            return tooltipdiv;
        },

        _renderPage: function (canvas, svg, parent, isload) {
            var page = svg.document.getElementById(canvas.id + "_page");
            if (!page) {
                var attr = { "id": canvas.id + "_page", "class": "page" };
                page = svg.g(attr);
            }
            if (!isload)
                parent.appendChild(page);
            return page;
        },

        _renderDiagramLayer: function (canvas, svg, parent) {
            var diagramLayer = svg.document.getElementById(canvas.id + "_diagramLayer");
            if (!diagramLayer) {
                var attr = { "id": canvas.id + "_diagramLayer", "class": "DiagramLayer" };
                diagramLayer = svg.g(attr);
                parent.appendChild(diagramLayer);
            }
            return diagramLayer;
        },

        _renderAdornerSvg: function (diagram, canvas, parent, isload, view) {
            if (window.SVGSVGElement) {
                var attr = {
                    id: canvas.id + "_svg_adorner",
                    version: "1.1",
                    xlink: "http://www.w3.org/1999/xlink",
                    "style": "position:absolute",
                    "fill": "none",
                    "pointer-events": "none"
                };
                var svg;
                if (!isload)
                    svg = new ej.datavisualization.Diagram.Svg(attr);
                else
                    svg = diagram._adornerSvg;
                if (!isload && !document.getElementById(svg.document.id))
                    parent.appendChild(svg.document);
                var expander = svg.document.getElementById(canvas.id + "_expander");
                if (!expander) {
                    var attr = { "id": canvas.id + "_expander", "class": "ExpanderLayer", "pointer-events": "all" };
                    expander = svg.g(attr);
                    svg.document.appendChild(expander);
                }
                view._expander = diagram._expander = expander;
                var adornerLayer = svg.document.getElementById(canvas.id + "_adornerLayer");
                if (!adornerLayer) {
                    var attr = { "id": canvas.id + "_adornerLayer", "class": "AdornerLayer", "pointer-events": "none" };
                    adornerLayer = svg.g(attr);
                    svg.document.appendChild(adornerLayer);
                }
                diagram._adornerSvg = svg;
                return adornerLayer;
            }
        },

        _renderBackgroundLayer: function (canvas, svg, parent, isload) {
            var pageBackgroundLayer = svg.document.getElementById(canvas.id + "_pageBackground");
            if (!pageBackgroundLayer) {
                var attr = {
                    "id": canvas.id + "_pageBackground",
                    "class": "PageBackgroundLayer",
                    "style": "pointer-events:none;",
                };
                pageBackgroundLayer = svg.g(attr);
            }
            if (!isload)
                parent.appendChild(pageBackgroundLayer);
            return pageBackgroundLayer;
        },

        _renderBackground: function (diagram, canvas, svg, parent, model, isload) {
            svg.document.style.msTouchAction = "none";
            svg.document.style.display = "block";
            svg.document.style.backgroundColor = "white";
            var attr = { id: canvas.id + "_backgroundLayer" };
            var g = svg.g(attr);
            var pageBounds = diagram._getDigramBounds();
            if (diagram._backgroundImage()) {
                var bgImg = diagram._backgroundImage();
                var alignment = ej.datavisualization.Diagram.Util._getImageAlignment(bgImg.alignment);
                var preserveAspectRatio = "none " + alignment != "none" && bgImg.scale != "none" ? alignment + " " + bgImg.scale : "none";
                attr = { "id": canvas.id + "_backgroundImage", "x": pageBounds.x, "y": pageBounds.y, "width": pageBounds.width, "height": pageBounds.height, "preserveAspectRatio": preserveAspectRatio, "pointer-events": "none" };
                var image = svg.image(attr);
                image.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", bgImg.source);
                if (!svg.getElementById(canvas.id + "_backgroundImage")) {
                    g.appendChild(image);
                }
            }
            var bgColor = diagram._backgroundColor();
            var rect = svg.rect({
                "id": canvas.id + "_backgroundColor", "width": "100%", "height": "100%", "fill": bgColor, "preserveAspectRatio": "none", "pointer-events": "none"

            });
            if (bgColor) {
                if (!svg.getElementById(canvas.id + "_backgroundColor")) {
                    g.appendChild(rect);
                }
            }
            else {
                if (svg.getElementById(rect.id)) {
                    g.removeChild(svg.getElementById(rect.id));
                }
            }

            if (!svg.getElementById(g.id))
                parent.appendChild(g);

        },

        _renderGrid: function (canvas, svg, parent, diagram) {
            var defs = diagram._svg.document.getElementById(canvas.id + "patterndefinition")
            if (!defs) {
                defs = svg.defs({ "id": canvas.id + "patterndefinition" });
                svg.appendChild(defs);
            }
            var g;
            if (diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.ShowHorizontalLines ||
                diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.ShowVerticalLines) {
                var grid = document.getElementById(canvas.id + "_grid");
                var rect = document.getElementById(canvas.id + "pattern_gridline");
                var pattern = document.getElementById(canvas.id + "pattern_grid");
                if (pattern && pattern.parentNode)
                    pattern.parentNode.removeChild(pattern);
                var attr = { id: canvas.id + "_grid", "pointer-events": "none" };
                g = svg.g(attr);
                var height = 0;
                if (diagram.model.snapSettings.horizontalGridLines.linesInterval) {
                    diagram.model.snapSettings.horizontalGridLines.linesInterval.forEach(function (entry) {
                        height += entry;
                    });
                }
                var width = 0;
                if (diagram.model.snapSettings.verticalGridLines.linesInterval) {
                    diagram.model.snapSettings.verticalGridLines.linesInterval.forEach(function (entry) {
                        width += entry;
                    });
                }
                var scale = this._scaleSnapInterval(diagram.model, diagram._currZoom);;

                attr = { id: canvas.id + "pattern_grid", x: 0, y: 0, width: width * scale, height: height * scale, patternUnits: "userSpaceOnUse" };
                var pattern = svg.pattern(attr);
                //pattern.setAttribute("patternUnits", "userSpaceOnUse");
                scale = this._scaleSnapInterval(diagram.model, scale);
                this._renderHorizontalGridlines(scale, pattern, width, diagram, svg);
                this._renderVerticalGridlines(scale, pattern, height, diagram, svg);
                defs.appendChild(pattern);
                var rect = svg.rect({ id: canvas.id + "pattern_gridline", "x": diagram._hScrollOffset, "y": diagram._vScrollOffset, "width": "100%", "height": "100%", "fill": "url(#" + canvas.id + "pattern_grid)" });
                g.appendChild(rect);
                if (!grid) {
                    if (diagram._diagramLayer) { parent.insertBefore(g, diagram._diagramLayer); }
                    else
                        parent.appendChild(g);
                }
            }
            else {
                g = document.getElementById(canvas.id + "_grid");
                if (g) {
                    var grid = document.getElementById(canvas.id + "pattern_gridline");
                    if (grid && grid.parentNode)
                        grid.parentNode.removeChild(grid);
                }
            }
        },

        _updateBackground: function (hoffset, voffset, scale, diagram) {
            var attr = {
                x: hoffset,
                y: voffset
            };
            var bgClr = document.getElementById(diagram._id + "_canvas_backgroundColor");
            if (bgClr)
                ej.datavisualization.Diagram.Util.attr(bgClr, attr);
            var bgImg = document.getElementById(diagram._id + "_canvas_backgroundImage");
            var pageBounds = diagram._getDigramBounds();
            if (bgImg)
                ej.datavisualization.Diagram.Util.attr(bgImg, { "transform": "scale(" + scale + ")", "x": pageBounds.x, "y": pageBounds.y, "width": pageBounds.width, "height": pageBounds.height });
        },

        _updateGrid: function (hoffset, voffset, scale, diagram) {
            var grid = document.getElementById(diagram._canvas.id + "pattern_gridline");
            var i;
            if (grid) {
                var pattern = document.getElementById(diagram._canvas.id + "pattern_grid");
                var height = 0;
                if (diagram.model.snapSettings.horizontalGridLines.linesInterval) {
                    for (i = 0; i < diagram.model.snapSettings.horizontalGridLines.linesInterval.length; i++) {
                        height += diagram.model.snapSettings.horizontalGridLines.linesInterval[i];
                    }
                }
                var width = 0;
                if (diagram.model.snapSettings.verticalGridLines.linesInterval) {
                    for (i = 0; i < diagram.model.snapSettings.verticalGridLines.linesInterval.length; i++) {
                        width += diagram.model.snapSettings.verticalGridLines.linesInterval[i];
                    }
                }

                var attr = {
                    x: hoffset,
                    y: voffset
                };
                ej.datavisualization.Diagram.Util.attr(grid, attr);

                scale = this._scaleSnapInterval(diagram.model, scale);
                var svg = diagram._svg;
                var defs = svg.defs({ "id": diagram._canvas.id + "patterndefinition" });
                if (pattern)
                    defs.removeChild(pattern);
                var attr = { id: diagram._canvas.id + "pattern_grid", x: 0, y: 0, width: width * scale, height: height * scale, patternUnits: "userSpaceOnUse" };
                pattern = diagram._svg.pattern(attr);
                this._renderHorizontalGridlines(scale, pattern, width, diagram, diagram._svg);
                this._renderVerticalGridlines(scale, pattern, height, diagram, diagram._svg);
                defs.appendChild(pattern);
            }
        },

        _scaleSnapInterval: function (model, scale) {
            if (scale >= 2) {
                while (scale >= 2) {
                    scale /= 2;
                }
            }
            else if (scale <= 0.5) {
                while (scale <= 0.5) {
                    scale *= 2;
                }
            }
            var i;
            if (scale !== 1) {
                model.snapSettings.horizontalGridLines._snapinterval = [];
                for (i = 0; i < model.snapSettings.horizontalGridLines.snapInterval.length; i++) {
                    model.snapSettings.horizontalGridLines._snapinterval[i] =
                        model.snapSettings.horizontalGridLines.snapInterval[i] * scale;
                }
                model.snapSettings.verticalGridLines._snapinterval = [];
                for (i = 0; i < model.snapSettings.verticalGridLines.snapInterval.length; i++) {
                    model.snapSettings.verticalGridLines._snapinterval[i] =
                        model.snapSettings.verticalGridLines.snapInterval[i] * scale;
                }
            }
            return scale;
        },

        _renderHorizontalGridlines: function (scale, pattern, width, diagram, svg) {
            var model = diagram.model;
            var snapSettings = model.snapSettings;
            if (diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.ShowHorizontalLines) {
                var space = 0;
                var cnt = 0;
                for (var i = 0; i < snapSettings.horizontalGridLines.linesInterval.length; i = i + 2) {
                    var thickness = snapSettings.horizontalGridLines.linesInterval[i];
                    var line = svg.line({
                        "x1": 0, "y1": space * scale, "x2": width * scale, "y2": space * scale, "stroke": snapSettings.horizontalGridLines.lineColor,
                        "stroke-width": thickness, "stroke-dasharray": snapSettings.horizontalGridLines.lineDashArray
                    });
                    //svg.appendChild(line);
                    space += snapSettings.horizontalGridLines.linesInterval[i + 1] + thickness;
                    pattern.appendChild(line);
                    cnt++;
                }
            }
        },

        _renderVerticalGridlines: function (scale, pattern, height, diagram, svg) {
            var model = diagram.model;
            var snapSettings = model.snapSettings;
            if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.ShowVerticalLines) {
                var space = 0;
                var cnt = 0;
                for (var i = 0; i < snapSettings.verticalGridLines.linesInterval.length; i = i + 2) {
                    var thickness = model.snapSettings.verticalGridLines.linesInterval[i];
                    var line = svg.line({
                        "x1": space * scale, "y1": 0, "x2": space * scale, "y2": height * scale, "stroke": snapSettings.verticalGridLines.lineColor,
                        "stroke-width": thickness, "stroke-dasharray": snapSettings.verticalGridLines.lineDashArray
                    });
                    space += snapSettings.verticalGridLines.linesInterval[i + 1] + thickness;
                    pattern.appendChild(line);
                    cnt++;
                }
            }
        },
        //#region Transformation
        transformView: function (diagram, hOffset, vOffset) {
            var view = diagram._view;
            var attr = {
                "transform": "translate(" + hOffset + "," + vOffset + ")"
            };
            ej.datavisualization.Diagram.Util.attr(view, attr);
            ej.datavisualization.Diagram.Util.attr(diagram._adornerLayer, attr);
            ej.datavisualization.Diagram.Util.attr(diagram._expander, {
                "transform": "translate(" + hOffset + "," + vOffset + "),scale(" + diagram.model.scrollSettings.currentZoom + ")"
            });
            if (diagram._htmlLayer) {
                diagram._htmlLayer.style.left = hOffset + "px";
                diagram._htmlLayer.style.top = vOffset + "px";
                diagram._htmlLayer.style.position = "absolute";
            }
        },
        scaleContent: function (diagram, scale) {
            var diagramLayer = diagram._diagramLayer;
            ej.datavisualization.Diagram.Util.attr(diagramLayer, { "transform": "scale(" + scale + ")" });
            var hOffset1 = typeof diagram.model.scrollSettings.horizontalOffset === "function" ? diagram.model.scrollSettings.horizontalOffset() : diagram.model.scrollSettings.horizontalOffset;
            var vOffset1 = typeof diagram.model.scrollSettings.verticalOffset === "function" ? diagram.model.scrollSettings.verticalOffset() : diagram.model.scrollSettings.verticalOffset;
            ej.datavisualization.Diagram.Util.attr(diagram._expander, { "transform": "translate(" + (-hOffset1) + "," + (-vOffset1) + "),scale(" + scale + ")" });
            if (diagram._htmlLayer) {
                diagram._htmlLayer.style.webkitTransform = "scale(" + scale + ")";
                diagram._htmlLayer.style.MozTransform = "scale(" + scale + ")";
                diagram._htmlLayer.style.OTransform = "scale(" + scale + ")";
                diagram._htmlLayer.style.msTransform = "scale(" + scale + ")";
                diagram._htmlLayer.style.transform = "scale(" + scale + ")";
            }
            if (diagram.selectionList.length > 0)
                this.updateSelector(diagram.selectionList[0], diagram._adornerSvg, scale, diagram, diagram.model.selectedItems.constraints);
            if (diagram.selectionList[0]) {
                if ((diagram.model.selectedItems.userHandles && diagram.model.selectedItems.userHandles.length > 0)) {
                    var isMultipleSelection = false;
                    if (diagram.selectionList[0].type == "pseudoGroup")
                        isMultipleSelection = true;
                    if (diagram.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                        ej.datavisualization.Diagram.SvgContext.updateUserHandles(diagram.model.selectedItems.userHandles, diagram.selectionList[0], diagram._adornerSvg, isMultipleSelection, false, scale, diagram);
                }
            }
        },
        setSize: function (diagram, width, height) {
            ej.datavisualization.Diagram.Util.attr(diagram._svg.document, { width: width + "px", height: height + "px" });
            ej.datavisualization.Diagram.Util.attr(diagram._adornerSvg.document, { width: width + "px", height: height + "px" });
        },
        //#endregion

        _findIndex: function (diagram, node) {
            var lastNode, newIndex = 1, index, elements;
            if (node.parent)
                elements = $("#" + node.parent.name).find(">.node,>.connector,>.group");
            else
                elements = $("#DiagramContent_canvas_svg").find(">.node,>.connector,>.group");
            if (node.name != "helper") {
                lastNode = elements[elements.length - 1];
                if (lastNode && lastNode.id == "helper")
                    lastNode = elements[elements.length - 2];
                if (lastNode) {
                    index = 0;
                    if (lastNode.className.animVal == "ej-d-node" || lastNode.className.animVal == "ej-d-group") {
                        newIndex = index + 1;
                    }
                    else if (lastNode.className.animVal == "ej-d-connector") {
                        newIndex = index + 1;
                    }
                }
            }
            return newIndex;
        },
        //#region Render Node

        //#region render
        renderNode: function (node, svg, parent, palette, diagram) {
            var g;
            // if (node.visible) 
            {
                var g;

                var width = node.width ? node.width : node._width || 0;
                var height = node.height ? node.height : node._height || 0;
                var name = node.name;
                var offX = 0, offY = 0, x = 0, y = 0, rAngle = 0;
                var visible = node.visible ? "visible" : "hidden";
                if (!palette) {
                    x = node.offsetX - width * node.pivot.x;
                    y = node.offsetY - height * node.pivot.y;
                    offX = node.offsetX;
                    offY = node.offsetY;
                    rAngle = node.rotateAngle;
                }
                if (ej.datavisualization.Diagram.Util.canCrispEdges(node, diagram)) {
                    x = Math.floor(x) + 0.5;
                    y = Math.floor(y) + 0.5
                }
                var attr = {
                    "id": name, "class": "ej-d-node", "transform": "rotate(" + rAngle + "," + offX + "," + offY +
                            "),translate(" + x + "," + y + ")", "visibility": visible
                };
                if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(node, diagram))
                    attr["style"] = "pointer-events:none";
                if (node._isClassifier)
                    attr["class"] += " " + "ej-d-classifier";
                g = svg.g(attr);
                if (parent) {
                    parent.appendChild(g);
                }
                else {
                    svg.appendChild(g);
                }
                if (node._isDisabled)
                    ej.datavisualization.Diagram.Util.attr(g, { "style": "pointer-events:none;" });
                this._renderNode(node, svg, g, diagram, palette);
                if (node && node.annotation)
                    ej.datavisualization.Diagram.DefautShapes.renderBPMNAnnotationShape(node, diagram);
            }
            if (node._isClassifier)
                delete node._isClassifier;
            return g;
        },

        _renderNode: function (node, svg, g, diagram, palette) {
            this._renderShape(node, svg, g, diagram);
            this._renderLabels(node, svg, diagram, palette);
            this._renderPorts(node, svg, g);
            if (node.outEdges.length > 0) {
                this._renderIcons(node, diagram);
            }
        },

        _renderShadow: function (node, svg) {
            if (!node.segments) {

                var g = svg.document.getElementById(node.name);
                if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                    var fill = node.fillColor;
                    if (node.type === "image" || node.type === "text" || node.type === "html") {
                        var shape = svg.document.getElementById(node.name + "_backRect");
                    }
                    else if (node.type != "text" && node.type != "image") {
                        var shape = svg.document.getElementById(node.name + "_shape");
                    }
                    if (shape) {
                        var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                        var attr = {
                            "id": node.name + "_shadow", "width": node.width, "height": node.height, "stroke": node.borderColor != "none" || node.borderColor != "transparent" ? "lightgrey" : "none", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                            "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity, "stroke-dasharray": ""
                        };
                        if (node.type === "native" || node.type === "html")
                            g.insertBefore(svg.rect(attr), shape);
                        else {
                            var shadow = shape.cloneNode(true);
                            g.insertBefore(shadow, shape);
                            ej.datavisualization.Diagram.Util.attr(shadow, attr);
                        }
                    }
                }
            }
        },

        _updateShadow: function (node, svg) {
            var g = svg.document.getElementById(node.name);
            var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
            var attr = { id: node.name + "_shadow", transform: "translate(" + point.x + "," + point.y + ")", opacity: node.shadow.opacity };
            svg.g(attr);

        },

        _removeShadow: function (node, svg) {
            if (node.type != "text") {
                var g, shadow, nodeName = node.name;
                if (node.type === "bpmn" && node.children && (node.shape != "group")) {
                    nodeName = node.children[0].name;
                }
                g = svg.document.getElementById(nodeName);
                shadow = svg.document.getElementById(nodeName + "_shadow");
                if (g && shadow) {
                    g.removeChild(shadow);
                }
            }
        },

        _renderphase: function (node, svg, parent, diagram, parNode) {
            var g;
            g = svg.g({ "id": node.name + "_phase_g", "class": "ej-d-seperator" });
            if (node.parent) {
                //parent = svg.getElementById(node.parent);
                //if (parent)
                parent.appendChild(g);
            } else {
                svg.appendChild(g);
            }
            var visibility = "visible";
            var tx = 0, ty = 0;
            if (parNode) {
                var children = diagram._getChildren(parNode.children);
                if (children.length > 1)
                    var header = diagram.nameTable[children[0]];
                var bounds = ej.datavisualization.Diagram.Util.bounds(parNode);
                var points = [], nPoint;
                var top = bounds.top + 50;
                var left = bounds.left + 50;
                if (node.orientation == "vertical") {
                    points.push({ x: 0, y: 0 });
                    points.push({ x: bounds.width, y: 0 });
                    nPoint = this._convertToSVGPoints(points);
                    tx = bounds.x;
                    ty = bounds.y + node.offset + header.height;
                    if (header)
                        top += header.height;
                    if (!(ty < bounds.bottom && ty > top)) {
                        visibility = "hidden";
                    }
                } else {
                    points.push({ x: 0, y: header.height ? header.height : 0 });
                    points.push({ x: 0, y: bounds.height });
                    nPoint = this._convertToSVGPoints(points);
                    tx = bounds.x + node.offset;
                    ty = bounds.y;

                    if (!(tx < bounds.right && tx > left)) {
                        visibility = "hidden";
                    }
                }


                var attr = {
                    "id": node.name + "_phase",
                    "stroke": node.lineColor,
                    "stroke-width": node.lineWidth,
                    "stroke-dasharray": node.lineDashArray,
                    "points": nPoint,
                    //"transform": "translate(" + tx + "," + ty + ")",
                };
                var line = svg.polyline(attr);
                g.appendChild(line);

                attr = {
                    "id": node.name + "_phase_hitTest",
                    "class": "hitTest",
                    "stroke-width": 10,
                    "points": nPoint,
                    //"transform": "translate(" + tx + "," + ty + ")",
                    "stroke": "transparent",

                };
                line = svg.polyline(attr);
                g.appendChild(line);
                g.setAttribute("transform", "translate(" + tx + "," + ty + ")");
            }

        },

        renderphase: function (node, svg, parent, diagram, group) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                if (parent)
                    parent = panel.document.getElementById(parent.id)
                view.context._renderphase(node, panel, parent || view.diagramLayer, diagram, group);
            });
        },

        _renderGroupBackground: function (group, g, svg, diagram) {
            if (group.fillColor != "none") {
                var x = group.offsetX - group.width * group.pivot.x;
                var y = group.offsetY - group.height * group.pivot.y;
                var fillColor = group.fillColor, borderColor = group.borderColor;
                if ((group.type == "bpmn" && group.shape != "group") || (group.classifier && group.classifier == "package")) {
                    fillColor = "transparent";
                    borderColor = "transparent";
                }
                if (ej.datavisualization.Diagram.Util.canCrispEdges(group, diagram)) {
                    x = Math.floor(x) + 0.5;
                    y = Math.floor(y) + 0.5;
                }
                var angle = group.rotateAngle;
                var pt = new ej.datavisualization.Diagram.Point(x + group.width * group.pivot.x, y + group.height * group.pivot.y);
                var attr = {
                    "id": group.name + "_shape",
                    "rx": group.cornerRadius,
                    "ry": group.cornerRadius,
                    "width": Math.round((group.width < 0) ? 0 : group.width),
                    "height": Math.round((group.height < 0) ? 0 : group.height),
                    "fill": fillColor,
                    "stroke": borderColor,
                    "stroke-width": group.borderWidth,
                    "opacity": group.opacity,
                    "stroke-dasharray": group.borderDashArray,
                    "transform": "rotate(" + angle + "," + pt.x + "," + pt.y + "),translate(" + x + "," + y + ")",
                };
                if (group.type == "umlclassifier" || group._isClassifier)
                    attr["class"] = "ej-d-group" + " " + "ej-d-classifier";
                if (group.gradient && group.type != "bpmn")
                    attr["fill"] = this._renderGradient(group.name, group.gradient, svg);
                this._addCssClass(group, attr);
                var rect = svg.rect(attr);
                g.appendChild(rect);
                if (group.type === "bpmn" && group.shape === "group" && (group.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)) {
                    var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, group.shadow.angle, group.shadow.distance);
                    if (group.shape === "group" && group.children.length === 0) {
                        point.x = (group.offsetX - group.width * group.pivot.x) + point.x;
                        point.y = (group.offsetY - group.height * group.pivot.y) + point.y;
                    }
                    var attr1 = {
                        "id": group.name + "_shadow", "width": group.width, "height": group.height, "stroke": group.borderColor != "none" || group.borderColor != "transparent" ? "lightgrey" : "none", "fill": fillColor != "none" || fillColor != "transparent" ? "lightgrey" : "none",
                        "transform": "translate(" + point.x + "," + point.y + ")", "opacity": group.shadow.opacity, "stroke-dasharray": ""
                    };
                    var shadow = rect.cloneNode(true);
                    g.insertBefore(shadow, rect);
                    ej.datavisualization.Diagram.Util.attr(shadow, attr1);

                }

            }
        },

        renderGroup: function (group, svg, parent, nameTable, diagram, isLoad, overView) {
            var g;
            var visible = group.visible ? "visible" : "hidden";
            //if (group.visible) 
            {
                var attr = { "id": group.name, "class": "ej-d-group", "visibility": visible };
                if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(group, diagram))
                    attr["style"] = "pointer-events:none";
                if (group.type == "umlclassifier" || group._isClassifier)
                    attr["class"] += " " + "ej-d-classifier";
                g = svg.g(attr);
                if (parent) {
                    parent.appendChild(g);
                } else {
                    svg.appendChild(g);
                }
                if (group.parent == "" && group.container) {
                    if (isLoad) {
                        group.height = 0;
                        group.width = 0;
                    }
                    if (!overView) {
                        diagram._updateChildAdjacentConnectors(group);
                    }
                }
                this._renderGroupBackground(group, g, svg, diagram);
                if (group.isSwimlane)
                    diagram._disableSwimlaneUptate = true;
                var children = group.children;
                if (children && children.length > 0) {
                    for (var i = 0, len = children.length; i < len; i++) {
                        var child = nameTable[ej.datavisualization.Diagram.Util.getChild(children[i])];
                        if (child) {
                            if (child._type === "group") {
                                if (group.type == "umlclassifier")
                                    child._isClassifier = true;
                                this.renderGroup(child, svg, g, nameTable, diagram, isLoad, overView);
                                ej.datavisualization.Diagram.Util._updateGroupBounds(child, diagram, true);
                                ej.datavisualization.Diagram.DiagramContext.update(child, diagram);
                            }
                            else if (child.segments) {
                                ej.datavisualization.Diagram.Util.updateBridging(child, diagram);
                                this.renderConnector(child, svg, g, diagram);
                            }
                            else {
                                if (group.type == "umlclassifier")
                                    child._isClassifier = true;
                                this.renderNode(child, svg, g, undefined, diagram);
                            }
                        }
                    }
                }
                this._renderLabels(group, svg, diagram);
                this._renderPorts(group, svg, g);
                if (group.isSwimlane)
                    delete diagram._disableSwimlaneUptate;
            }
            if (group && group.annotation)
                ej.datavisualization.Diagram.DefautShapes.renderBPMNAnnotationShape(group, diagram);
            if (group && group.isSwimlane) {
                var view, panel, parent;
                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, group);
                diagram._views.forEach(function (viewid) {
                    view = diagram._views[viewid];
                    panel = view.svg || view._canvas;
                    if (parent)
                        parent = panel.document.getElementById(parent.id)
                    for (var i = 0; phases && i < phases.length; i++) {
                        var node = diagram.nameTable[phases[i]];
                        if (node)
                            view.context._renderphase(node, panel, parent || view.diagramLayer, diagram, group);
                    }
                });
            }
            if (group._isClassifier)
                delete group._isClassifier;
            return g;
        },


        _renderGradient: function (name, gradient, svg) {

            var fill;
            var id;
            if (gradient.type === "linear") {
                id = this._renderLinearGradient(svg.id + "_" + name, gradient, svg);
                fill = "url(#" + id + ")";
            }
            else if (gradient.type === "radial") {
                id = this._renderRadialGradient(svg.id + "_" + name, gradient, svg);
                fill = "url(#" + id + ")";
            }
            return fill;
        },

        _checkGradientTag: function (name, svg, linear) {
            if (svg.getElementById(name + "_gradient")) {
                var gradTag = svg.getElementById(name + "_gradient")
                if ((linear && gradTag.localName === "radialGradient") || (!linear && gradTag.localName === "linearGradient"))
                    gradTag.parentNode.removeChild(gradTag);
            }
        },
        _renderLinearGradient: function (name, gradient, svg) {
            var defs = svg.document.getElementById(svg.document.parentNode.id + "patterndefinition") || svg.document.getElementById(name + "patterndefinition");
            if (defs) {
                this._checkGradientTag(name, svg, true);
                var attr = { "id": name + "_gradient", "x1": gradient.x1 + "%", "y1": gradient.y1 + "%", "x2": gradient.x2 + "%", "y2": gradient.y2 + "%" };
                var linear = svg.linearGradient(attr);
                this._renderStops(gradient, svg, linear);
                defs.appendChild(linear);
                return linear.id;
            }
            return null;
        },

        _renderRadialGradient: function (name, gradient, svg) {
            var defs = svg.document.getElementById(svg.document.parentNode.id + "patterndefinition") || svg.document.getElementById(name + "patterndefinition");
            if (defs) {
                this._checkGradientTag(name, svg, false);
                var attr = {
                    "id": name + "_gradient", "cx": gradient.cx + "%", "cy": gradient.cy + "%",
                    "fx": gradient.fx + "%", "fy": gradient.fy + "%", "r": gradient.r + "%"
                };
                var radial = svg.radialGradient(attr);
                this._renderStops(gradient, svg, radial);
                defs.appendChild(radial);
                return radial.id;
            }
            return null;
        },

        _renderStops: function (gradient, svg, element) {
            if (svg.getElementById(element.getAttribute("id")) === element) {
                while (element.firstChild) {
                    element.removeChild(element.firstChild);
                }
            }
            var stops = gradient.stops;
            var stop;
            for (var i = 0, len = stops.length; i < len; i++) {
                stop = stops[i];
                element.appendChild(svg.stop({ "offset": stop.offset + "%", "stop-color": stop.color, "stop-opacity": stop.opacity }));
            }
        },

        _renderShape: function (node, svg, g, diagram) {
            var type = node._shape ? node._shape : node.type;
            switch (type) {
                case "rectangle":
                    this._renderRect(node, svg, g);
                    break;
                case "ellipse":
                    this._renderEllipse(node, svg, g);
                    break;
                case "image":
                    this._renderImage(node, svg, g);
                    break;
                case "path":
                    this._renderPath(node, svg, g);
                    break;
                case "polygon":
                    this._renderPolygon(node, svg, g);
                    break;
                case "text":
                    this._renderTextElement(node, svg, g, diagram);
                    break;
                case "html":
                    this._renderHtmlElement(node, svg, g, diagram);
                    break;
                case "native":
                    this._rendercontent(node, svg, g, diagram);
                    break;
            }
        },

        _renderHTMLTemplate: function (node, diagram) {
            if (node.templateId && $.templates) {
                return diagram._renderEjTemplate("#" + node.templateId, node);
            }
        },

        _renderSvgTemplate: function (node, svg, g, html) {
            var div = document.createElement('div');
            div.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg"><g id="tempNative">' + html + '</g></svg>';
            document.body.appendChild(div);
            var content = document.getElementById("tempNative").cloneNode(true);
            content.id = node.name + "_shape";
            g.appendChild(content);
            var attr = {
                "id": node.name + "_shape",
                "fill": node.fillColor, "stroke": node.borderColor,
                "stroke-width": node.borderWidth, "opacity": node.opacity, "stroke-dasharray": node.borderDashArray
            };
            this._addCssClass(node, attr);
            if (node.gradient)
                attr["fill"] = this._renderGradient(node.name, node.gradient, svg);
            svg.g(attr);
            var object = this._scaleNodeContent(node, content);
            if (object)
                content.setAttribute("transform", "translate(" + object.x + "," + object.y + "),scale(" + object.sx + "," + object.sy + ")");
            content.setAttribute("id", node.name + "_shape");
            div.parentNode.removeChild(div);
        },

        _scaleNodeContent: function (node, content) {
            if (node.scale != "none") {
                if (content)
                    var bounds = node.type == "html" ? content.getBoundingClientRect() : content.getBBox();
                if (node.type == "html") { bounds.x = bounds.left; bounds.y = bounds.top };
                var width = node.width ? node.width : node._width;
                var height = node.height ? node.height : node._height;
                if (!content) var bounds = { x: node.offsetX - node.width * node.pivot.x, y: node.offsetY - node.height * node.pivot.y, width: width, height: height };
                var proportionX = bounds.width ? width / bounds.width : 1;
                var proportionY = bounds.height ? height / bounds.height : 1;
                var x = ((bounds.x * proportionX) * -1);
                var y = ((bounds.y * proportionY) * -1);
                if (node.scale != "stretch" && node.contentAlignment != "none") {
                    var proportion = node.scale == "meet" ? Math.min(proportionX, proportionY) : Math.max(proportionX, proportionY);
                    if (node.contentAlignment.indexOf("xmid") > -1) {
                        x = width / 2 - bounds.width * proportion / 2;
                    }
                    else if (node.contentAlignment.indexOf("xmax") > -1) {
                        x = bounds.x + width - bounds.width * proportion;
                    }
                    if (node.contentAlignment.indexOf("ymid") > -1) {
                        y = bounds.y + height / 2 - bounds.height * proportion / 2;
                    }
                    else if (node.contentAlignment.indexOf("ymax") > -1) {
                        y = bounds.y + height - bounds.height * proportion;
                    }
                    return { x: x, y: y, sx: proportion, sy: proportion };
                }
                return { x: x, y: y, sx: proportionX, sy: proportionY };
            }
            return null;
        },
        _rendercontent: function (node, svg, g, diagram) {
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                var fill = node.fillColor;
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                var shadow = {
                    "id": node.name + "_shadow", "width": node.width, "height": node.height, "stroke": node.borderColor != "none" || node.borderColor != "transparent" ? "lightgrey" : "none", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity
                };
                g.appendChild(svg.rect(shadow));
            }

            if (!node.segments && node.templateId && $.templates) {
                var width = node.width;
                var height = node.height;
                if (node._type === "node" && !node.height && !node.width) {
                    node.width = node._width;
                    node.height = node._height;
                }
                var html = diagram._renderEjTemplate("#" + node.templateId, node);
                node.width = width;
                node.height = height;
                this._renderSvgTemplate(node, svg, g, html);
            }
        },

        _fill: function (node, svg) {
            var fill;
            if (node.gradient) {
                fill = this._renderGradient(node.name, node.gradient, svg);
            }
            if (!fill) {
                fill = node.fillColor;
            }
            return fill;
        },

        _addCssClass: function (object, attr) {
            if (object.cssClass) {
                if (attr) {
                    if (attr["class"])
                        attr["class"] = attr["class"] + " " + object.cssClass;
                    else
                        attr["class"] = object.cssClass;
                }
            }
            object._cssClass = object.cssClass;
            return attr;
        },

        _updateCssClass: function (object, attr) {
            if ((object._cssClass != "" || (object._cssClass === "" && object.cssClass !== "")) && object._cssClass !== undefined && object.cssClass != object._cssClass) {
                var classTmp = attr["class"];
                if (classTmp)
                    attr["class"] = classTmp.replace(object._cssClass, "").trim();
                return this._addCssClass(object, attr);
            }
            return attr;
        },

        _renderRect: function (node, svg, g) {
            var fill = this._fill(node, svg);
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var attr = {
                "id": node.name + "_shape", "rx": node.cornerRadius, "ry": node.cornerRadius, "role": "presentation",
                "width": width, "height": height, "fill": fill, "stroke": node.borderColor,
                "stroke-width": node.borderWidth, "opacity": node.opacity, "stroke-dasharray": node.borderDashArray
            };
            if (node._isClassifier)
                var class1 = "ej-d-node" + " " + "ej-d-classifier";
            attr["class"] = class1;
            this._addCssClass(node, attr);
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                var shadow = {
                    "id": node.name + "_shadow", "rx": node.cornerRadius, "ry": node.cornerRadius,
                    "width": node.width, "height": node.height, "stroke": node.borderColor != "none" || node.borderColor != "transparent" ? "lightgrey" : "none", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity
                };
                g.appendChild(svg.rect(shadow));
            }
            g.appendChild(svg.rect(attr));
        },

        _renderEllipse: function (node, svg, g) {
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var fill = this._fill(node, svg);
            var attr = {
                "id": node.name + "_shape", "rx": width / 2, "ry": height / 2, "role": "presentation",
                "cx": width / 2, "cy": height / 2,
                "fill": fill, "stroke": node.borderColor, "stroke-width": node.borderWidth,
                "opacity": node.opacity, "stroke-dasharray": node.borderDashArray

            };
            this._addCssClass(node, attr);
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                var shadow = {
                    "id": node.name + "_shadow", "rx": node.width / 2, "ry": node.height / 2,
                    "cx": node.width / 2, "cy": node.height / 2, "stroke": node.borderColor != "none" || node.borderColor != "transparent" ? "lightgrey" : "none", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity
                };
                g.appendChild(svg.ellipse(shadow));
            }
            g.appendChild(svg.ellipse(attr));
        },

        _renderImage: function (node, svg, g) {
            var fill = node.fillColor;
            var backRect = this._renderBackgroundRect(node, svg, g);
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var alignment = ej.datavisualization.Diagram.Util._getImageAlignment(node.contentAlignment);
            var scale = node.scale == "none" ? "meet" : node.scale;
            var attr = {
                "id": node.name + "_shape",
                "opacity": node.opacity, "preserveAspectRatio": (scale != "stretch" && alignment != "none" ? alignment + " " + scale : "none"),
                "width": width, "height": height, "role": "img",
            };
            var image = new Image();
            image.src = node.source;
            if (node.scale == "none") {
                attr["width"] = image.width || width; attr["height"] = image.height || height;
            }
            var shape = svg.image(attr);
            shape.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.src);
            g.appendChild(shape);
        },

        _renderPolygon: function (node, svg, g) {
            var fill = this._fill(node, svg);
            ej.datavisualization.Diagram.Geometry.updatePolygonPoints(node);
            var points = this._convertToSVGPoints(node.points);
            var attr = {
                "id": node.name + "_shape", "fill": fill, "stroke": node.borderColor, "role": "presentation",
                "stroke-width": node.borderWidth, "opacity": node.opacity,
                "stroke-dasharray": node.borderDashArray, "points": points
            };
            this._addCssClass(node, attr);
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                var shadow = {
                    "id": node.name + "_shadow", "points": points, "stroke": node.borderColor != "none" || node.borderColor != "transparent" ? "lightgrey" : "none", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity
                };
                g.appendChild(svg.polygon(shadow));
            }
            g.appendChild(svg.polygon(attr));
        },

        _renderPath: function (node, svg, g) {
            var fill = this._fill(node, svg);
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var d;
            if (!node._preventStretch && !node._polyline)
                node._absolutePath = d = ej.datavisualization.Diagram.Geometry.updatePath(0, 0, width, height, node.pathData, svg, null, node);
            else node._absolutePath = d = node.pathData;
            var attr = {
                "id": node.name + "_shape", "width": width,
                "height": height, "d": d, "opacity": node.opacity, "role": "presentation",
                "stroke-dasharray": node.borderDashArray, "stroke": node.borderColor,
                "stroke-width": node.borderWidth, "fill": fill

            };
            if (node._isClassifier)
                attr["class"] = "ej-d-node" + " " + "ej-d-classifier";
            this._addCssClass(node, attr);
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                var shadow = {
                    "id": node.name + "_shadow", "width": node.width,
                    "height": node.height, "d": d, "stroke": node.borderColor != "none" || node.borderColor != "transparent" ? "lightgrey" : "none", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity
                };
                g.appendChild(svg.path(shadow));
            }
            g.appendChild(svg.path(attr));
        },

        _renderHtmlElement: function (node, svg, g, diagram) {
            var backRect = this._renderBackgroundRect(node, svg, g);
            if (!node.segments && node.templateId) {
                var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                var element = $(htmlLayer).children("#" + node.name + "_parentdiv")[0];
                if (element) htmlLayer.removeChild(element);
                var width = node.width ? node.width : node._width;
                var height = node.height ? node.height : node._height;
                var x = node.offsetX - width * node.pivot.x;
                var y = node.offsetY - height * node.pivot.y;
                var div = svg.document.getElementById(node.name + "_html")
                if (!div)
                    var div = document.createElement("div");
                var style = "width:" + width + "px;height:" + height + "px;padding:1px; left:" + x + "px; top:" + y + "px;position:absolute;";
                style += "display: block; border:0px; pointer-events: all; opacity:" + node.opacity + ";";
                style += "transform:" + "rotate(" + node.rotateAngle + "deg)";
                var attr = { "id": node.name + "_html", "class": "foreignObject", "style": style };
                this._addCssClass(node, attr);
                ej.datavisualization.Diagram.Util.attr(div, attr);
                if (!node.segments && node.templateId) {
                    var tmplString = this._renderHTMLTemplate(node, diagram)
                    div.innerHTML = tmplString;
                }
                var parentdiv = document.createElement("div");
                var attr1 = { "id": node.name + "_parentdiv", "class": "ej-d-node" };
                ej.datavisualization.Diagram.Util.attr(parentdiv, attr1);
                parentdiv.appendChild(div);
                var visibility = node.visible ? "visible" : "hidden";
                parentdiv.style.visibility = visibility;
                var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                if (htmlLayer)
                    htmlLayer.appendChild(parentdiv);
                else
                    svg.document.parentNode.appendChild(div);
            }
        },

        _initializeGuidelines: function (svg, attr, parent) {
            var g = svg.g(attr);
            parent.appendChild(g);
            return g;
        },

        _renderSideAlignmentLines: function (start, end, g, svg, scale) {
            var line = svg.line({
                "x1": start.x * scale, "y1": start.y * scale,
                "x2": end.x * scale, "y2": end.y * scale, "stroke": "#07EDE1", "stroke-width": 1
            });
            g.appendChild(line);
        },

        _renderCenterAlignmentLines: function (start, end, g, svg, scale) {
            var line = svg.line({
                "x1": start.x * scale, "y1": start.y * scale,
                "x2": end.x * scale, "y2": end.y * scale, "stroke": "#07EDE1", "stroke-width": 1,
            });
            g.appendChild(line);
        },

        _renderSpacingLines: function (start, end, g, svg, scale) {
            if (g) {
                var d, d1;
                var div1 = svg.g({});
                if (start.x == end.x) {
                    d = "M" + (start.x * scale - 5) + " " + (start.y * scale + 5) + " L" + start.x * scale + " " + start.y * scale + " L" + (start.x * scale + 5) + " " + (start.y * scale + 5) + "z";
                    d1 = "M" + (end.x * scale - 5) + " " + (end.y * scale - 5) + " L" + end.x * scale + " " + end.y * scale + " L" + (end.x * scale + 5) + " " + (end.y * scale - 5) + "z";
                    div1.appendChild(svg.line({ "x1": start.x * scale - 8, "x2": start.x * scale + 8, "y1": start.y * scale - 1, "y2": start.y * scale - 1, "stroke": "#07EDE1", "stroke-width": 1 }));
                    div1.appendChild(svg.line({ "x1": end.x * scale - 8, "x2": end.x * scale + 8, "y1": end.y * scale + 1, "y2": end.y * scale + 1, "stroke": "#07EDE1", "stroke-width": 1 }));
                }
                else {
                    d = "M" + (start.x * scale + 5) + " " + (start.y * scale + 5) + " L" + start.x * scale + " " + start.y * scale + " L" + (start.x * scale + 5) + " " + (start.y * scale - 5) + "z";
                    d1 = "M" + (end.x * scale - 5) + " " + (end.y * scale - 5) + " L" + end.x * scale + " " + end.y * scale + " L" + (end.x * scale - 5) + " " + (end.y * scale + 5) + "z";
                    div1.appendChild(svg.line({ "x1": start.x * scale - 1, "x2": start.x * scale - 1, "y1": start.y * scale - 8, "y2": start.y * scale + 8, "stroke": "#07EDE1", "stroke-width": 1 }));
                    div1.appendChild(svg.line({ "x1": end.x * scale + 1, "x2": end.x * scale + 1, "y1": end.y * scale - 8, "y2": end.y * scale + 8, "stroke": "#07EDE1", "stroke-width": 1 }));
                }
                div1.appendChild(svg.path({ "d": d, "fill": "#07EDE1" }));
                var line = svg.line({
                    "x1": start.x * scale, "y1": start.y * scale,
                    "x2": end.x * scale, "y2": end.y * scale, "stroke": "#07EDE1", "stroke-width": 0.6, "fill": "#07EDE1"
                });
                div1.appendChild(line);
                div1.appendChild(svg.path({ "d": d1, "fill": "#07EDE1" }));
                g.appendChild(div1);
            }
        },

        _removeGuidelines: function (parent, g) {
            if (g != null) {
                parent.removeChild(g);
            }
        },

        //#endregion

        //#region update
        update: function (data, diagram) {
            if (diagram && !diagram._isInit && data._status !== "new")
                data._status = "update";
            var svg = diagram._svg;
            if (data._type === "group")
                this.updateGroup(data, svg, diagram);
            else if (data.segments)
                this.updateConnector(data, svg, diagram);
            else
                this.updateNode(data, svg, diagram);
        },

        _updateGoupBackground: function (group, svg, diagram) {
            var x = group.offsetX - group.width * group.pivot.x;
            var y = group.offsetY - group.height * group.pivot.y;
            var angle = group.rotateAngle;
            var pt = new ej.datavisualization.Diagram.Point(x + group.width * group.pivot.x, y + group.height * group.pivot.y);
            var fillColor = group.fillColor, borderColor = group.borderColor;
            var nodeConstraints = ej.datavisualization.Diagram.NodeConstraints;
            if ((group.type == "bpmn" && group.shape != "group") || (group.classifier && group.classifier == "package")) {
                fillColor = "transparent";
                borderColor = "transparent";
            }
            if (ej.datavisualization.Diagram.Util.canCrispEdges(group, diagram)) {
                x = Math.floor(x) + 0.5;
                y = Math.floor(y) + 0.5;
            }
            var attr = {
                "id": group.name + "_shape",
                "rx": group.cornerRadius,
                "ry": group.cornerRadius,
                "width": Math.round((group.width < 0) ? 0 : group.width),
                "height": Math.round((group.height < 0) ? 0 : group.height),
                "fill": fillColor,
                "stroke": borderColor,
                "stroke-width": group.borderWidth,
                "opacity": group.opacity,
                "stroke-dasharray": group.borderDashArray,
                "transform": "rotate(" + angle + "," + pt.x + "," + pt.y + "),translate(" + x + "," + y + ")",
            };
            if (group.shape === "group" && (group.constraints & nodeConstraints.Shadow)) {
                var shadow = svg.document.getElementById(group.name + "_shadow");
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, group.shadow.angle, group.shadow.distance);
                x = (group.offsetX - group.width * group.pivot.x) + point.x;
                y = (group.offsetY - group.height * group.pivot.y) + point.y;
                var attr1 = {
                    "id": group.name + "_shadow", "width": group.width, "height": group.height, "stroke": group.borderColor != "none" || group.borderColor != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + x + "," + y + ")", "opacity": group.shadow.opacity, "stroke-dasharray": ""
                };
                if (shadow)
                    ej.datavisualization.Diagram.Util.attr(shadow, attr1);
            }
            if (group.gradient && group.type != "bpmn")
                attr["fill"] = this._renderGradient(group.name, group.gradient, svg);
            var element = svg.getElementById(group.name + "_shape");
            if (element) {
                attr["class"] = element.getAttribute("class");
                this._updateCssClass(group, attr);
                ej.datavisualization.Diagram.Util.attr(element, attr);
            }
        },

        updateGroup: function (group, svg, diagram, layout) {
            var children = diagram._getChildren(group.children);
            var visible = group.visible ? "visible" : "hidden";
            var style = "display:block;"
            if (!(group.visible))
                style = "display:none;"
            if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(group, diagram))
                style = "pointer-events:none";

            svg.g({ "id": group.name, "visibility": "visible", "style": style });
            for (var i = 0, len = children.length; i < len; i++) {
                var child = diagram.nameTable[children[i]];
                if (child) {
                    if (child._type === "group")
                        this.updateGroup(child, svg, diagram, layout);
                    else if (child.segments) {
                        ej.datavisualization.Diagram.Util.updateBridging(child, diagram);
                        this.updateConnector(child, svg, diagram);
                    }
                    else
                        this.updateNode(child, svg, diagram, layout);
                }
            }
            svg.g({ "id": group.name, "visibility": visible, "style": style });
            this._updateGoupBackground(group, svg, diagram);

            this._updateAssociatedConnector(group, svg, diagram);
            this._updateLabels(group, svg, diagram);
            this._updatePorts(group, svg);
            if (group.isSwimlane) {
                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, group);
                var phase = null;
                if (phases && phases.length > 0) {
                    for (var j = 0; j < phases.length; j++) {
                        phase = diagram.nameTable[diagram._getChild(phases[j])];
                        if (phase)
                            this._updatephase(phase, diagram, group);
                    }
                }
            }
        },

        _removephases: function (group, diagram) {
            if (group.isSwimlane) {
                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, group);
                if (phases) {
                    for (var j = phases.length ; j >= 0; j--) {
                        var phase = diagram.nameTable[phases[j]];
                        this._removePhase(diagram, phase);
                    }
                }
            }
        },
        _removePhase: function (diagram, phase) {
            if (phase) {
                diagram._views.forEach(function (viewid) {
                    var view = diagram._views[viewid];
                    var panel = view.svg || view._canvas;
                    var element = panel.document.getElementById(phase.name + "_phase_g");
                    if (element)
                        element.parentNode.removeChild(element);
                });
            }
        },
        _updatePhaseStyle: function (phase, options, diagram) {
            if (phase && options) {
                var visible = phase.visible ? "visible" : "hidden";
                diagram._svg.g({ "id": phase.name + "_phase_g", "visibility": visible });
                options.id = phase.name + "_phase";
                diagram._svg.g(options);
            }
        },

        _updatephase: function (node, diagram, group) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                view.context._updatephase1(node, diagram, panel, group);
            });
        },

        _updatephase1: function (node, diagram, svg, parNode) {
            svg = svg ? svg : diagram._svg;

            if (parNode) {
                var tx = 0, ty = 0, transform = null;
                var points = [], nPoint;
                var bounds = ej.datavisualization.Diagram.Util.bounds(parNode);
                var children = diagram._getChildren(parNode.children);
                if (children.length > 1)
                    var header = diagram.nameTable[children[0]];
                var top = bounds.top + 50;
                var left = bounds.left + 50;
                var visibility = "visible";
                if (node.orientation == "vertical") {
                    tx = bounds.x;
                    ty = bounds.y + header.height + node.offset;
                    if (header)
                        top += header.height;
                    if (ty - .1 <= bounds.bottom && ty - .1 >= top) {
                        transform = "translate(" + tx + "," + ty + ")";
                    }
                    points.push({ x: 0, y: 0 });
                    points.push({ x: bounds.width, y: 0 });
                    nPoint = this._convertToSVGPoints(points);
                }
                else {
                    tx = bounds.x + node.offset;
                    ty = bounds.y;
                    if (tx - .1 <= bounds.right && tx - .1 > left) {
                        transform = "translate(" + tx + "," + ty + ")";
                    }
                    if (header) {
                        points.push({ x: 0, y: header.height });
                        points.push({ x: 0, y: bounds.height });
                    }
                    nPoint = this._convertToSVGPoints(points);
                }

                var attr = {
                    "points": nPoint,
                    "id": node.name + "_phase",
                };
                svg.polyline(attr);
                attr = {
                    "points": nPoint,
                    "id": node.name + "_phase_hitTest",
                };
                svg.polyline(attr);
                if (transform)
                    attr = {
                        "id": node.name + "_phase_g",
                        "transform": transform,
                        //"visibility": visibility
                    }
                if (node.label && diagram.model.labelRenderingMode != ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                    this._updatePhaseLabel(node, node.label, diagram)
                }
                svg.g(attr);
                if (svg.getElementById(attr.id))
                    $('#' + attr.id).insertAfter($('#' + attr.id)[0].parentNode.lastChild);
            }
        },
        _updatePhaseLabel: function (node, label, diagram) {
            var svg = diagram._svg;
            var bounds = diagram._getPhaseBounds(node);
            var text = svg.getElementById(node.name + "_" + label.name);
            if (text) {
                text.setAttribute("fill", label.fontColor);
                if (!label.text)
                    return;
                text.textContent = label.text;
                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                this._wrapText(node, bounds, text, label, svg);
                this._alignTextOnPhase(node, bounds, text, label, svg);
            }
        },
        updateLabelStyle: function (node, label, svg, diagram) {
            if (!label.templateId) {
                if (diagram && diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                    var attr = {
                        "id": node.name + "_" + label.name + "_lblbg",
                        "fill": label.fillColor,
                        "stroke": label.borderColor, "stroke-width": label.borderWidth,
                        "pointer-events": "none",
                        "visibility": label.visible ? "visible" : "hidden",
                        "fill-opacity": label.opacity,
                        "stroke-opacity": label.opacity,
                    };
                    svg.rect(attr);

                    attr = {
                        "id": node.name + "_" + label.name,
                        "class": "ej-d-label", "font-family": label.fontFamily,
                        "font-size": label.fontSize, "fill": label.fontColor,
                        "text-decoration": label.textDecoration,
                        "font-weight": label.bold ? "bold" : "normal",
                        "font-style": label.italic ? "italic" : "normal",
                        "visibility": label.visible ? "visible" : "hidden",
                        "fill-opacity": label.opacity,
                        "stroke-opacity": label.opacity,
                    };
                    var text = svg.text(attr);

                    attr["class"] = text.getAttribute("class");
                    this._updateCssClass(label, attr);
                    ej.datavisualization.Diagram.Util.attr(text, attr);

                }
                else {
                    var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                    var text = $(htmlLayer).find("#" + node.name + "_" + label.name)[0];
                    if (node && text && label && !label.templateId) {
                        if (label.bold) text.style.fontWeight = "bold"; else text.style.fontWeight = "";
                        if (label.italic) text.style.fontStyle = "italic"; else text.style.fontStyle = "";
                        if (label.visible) text.style.visibility = ""; else text.style.visibility = "hidden";
                        text.style.opacity = label.opacity;
                        text.style.textDecoration = label.textDecoration;
                        text.style.fontFamily = label.fontFamily;
                        text.style.fontSize = label.fontSize + "px";
                        text.style.color = label.fontColor;
                        text.style.backgroundColor = label.fillColor;
                        text.style.borderColor = label.borderColor;
                        text.style.borderWidth = label.borderWidth + "px";
                        text.style.borderStyle = "solid";
                        if (node._isHeader) {
                            text.style.borderWidth = 0 + "px";
                            text.style.backgroundColor = "transparent";
                        }
                        var attr = this._updateCssClass(label, { "class": text.className });
                        if (attr)
                            text.className = attr["class"];
                    }
                }
            }
        },

        updatePort: function (node, port, svg) {
            var portshape = svg.getElementById(node.name + "_" + port.name);
            if (portshape) {
                if (portshape && portshape.parentNode)
                    portshape.parentNode.removeChild(portshape);
                var g = document.getElementById(node.name);
                portshape = ej.datavisualization.Diagram.SvgContext._renderPort(node, port, svg);
                g.appendChild(portshape);
            }

        },

        _updateNodeStyle: function (node, svg) {
            if (node && svg) {
                var attr = {};
                attr["opacity"] = node.opacity;
                attr["fill"] = node.fillColor;
                attr["stroke"] = node.borderColor;
                attr["stroke-width"] = node.borderWidth;
                attr["stroke-dasharray"] = node.borderDashArray;
                if (node.gradient)
                    attr["fill"] = this._renderGradient(node.name, node.gradient, svg);
                if (node._type == "node") {
                    var type = node.type == "text" || node.type == "html" ? "_backRect" : "_shape";
                    if (node.type == "html") {
                        var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                        var element = $(htmlLayer).children("#" + node.name + "_parentdiv")[0].childNodes[0];
                        if (element) {
                            element.style.opacity = node.opacity;
                        }
                    }
                    var element = svg.getElementById(node.name + type);
                    if (element) {
                        attr["class"] = element.getAttribute("class");
                        this._updateCssClass(node, attr);
                        ej.datavisualization.Diagram.Util.attr(element, attr);
                    }

                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                        var shadow = svg.document.getElementById(node.name + "_shadow");
                        if (shadow)
                            ej.datavisualization.Diagram.Util.attr(shadow, { "fill": node.fillColor != "none" || node.fillColor != "transparent" ? "lightgrey" : "none" });
                    }
                }
            }
        },

        _updateConnectorStyle: function (connector, svg) {
            if (connector && svg) {
                var attr = {};
                attr["opacity"] = connector.opacity;
                attr["stroke"] = connector.lineColor;
                attr["stroke-width"] = connector.lineWidth;
                attr["stroke-dasharray"] = connector.lineDashArray;
                var element = svg.getElementById(connector.name + "_segments");
                if (element) {
                    attr["class"] = element.getAttribute("class");
                    this._updateCssClass(connector, attr);
                    ej.datavisualization.Diagram.Util.attr(element, attr);
                }

            }
        },

        updateTargetDecoratorStyle: function (connector, svg) {
            if (svg) {
                var attr = {};
                attr["stroke"] = connector.targetDecorator.borderColor;
                attr["fill"] = connector.targetDecorator.fillColor;
                var element = svg.getElementById(connector.name + "_targetDecorator");
                if (element) {
                    attr["class"] = element.getAttribute("class");
                    this._updateCssClass(connector.targetDecorator, attr);
                    ej.datavisualization.Diagram.Util.attr(element, attr);
                }
            }
        },

        updateSourceDecoratorStyle: function (connector, svg) {
            if (svg) {
                var attr = {};
                attr["stroke"] = connector.sourceDecorator.borderColor;
                attr["fill"] = connector.sourceDecorator.fillColor;
                var element = svg.getElementById(connector.name + "_sourceDecorator");
                if (element) {
                    attr["class"] = element.getAttribute("class");
                    this._updateCssClass(connector.sourceDecorator, attr);
                    ej.datavisualization.Diagram.Util.attr(element, attr);
                }
            }
        },

        updateNode: function (node, svg, diagram, layout) {
            if (svg) {
                if (diagram && !diagram._isInit && node._status !== "new")
                    node._status = "update";
                this._updateLabels(node, svg, diagram);
                this._updateNode(node, svg, diagram);
                if (node.outEdges.length)
                    this._updateIcons(node, svg, diagram);
                node._scaled = false;
                if (diagram._layoutInAction) return;
                this._updateAssociatedConnector(node, svg, diagram);
                if (!diagram.activeTool.inAction || diagram.activeTool.name !== "move" && diagram.activeTool.name !== "rotate") {
                    this._updatePorts(node, svg);
                }
            }
        },

        updateTextBlock: function (node, label, svg, diagram) {
            var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var parent = $(htmlLayer).children("#" + node.name)[0];
            var textContainter = $(parent).children("#" + node.name + "_shape_lblbg")[0];
            var text = textContainter.childNodes[0];
            if (node && text && label) {
                if (label.bold) text.style.fontWeight = "bold"; else text.style.fontWeight = "";
                if (label.italic) text.style.fontStyle = "italic"; else text.style.fontStyle = "";
                text.style.textDecoration = label.textDecoration;
                text.style.fontFamily = label.fontFamily;
                text.style.fontSize = label.fontSize + "px";
                text.style.color = label.fontColor;
            }
            this._updateTextElement(node, svg, diagram);
        },

        _updateAssociatedConnector: function (node, svg, diagram) {
            var i, len;
            if (node.inEdges && node.inEdges.length > 0) {
                for (i = 0, len = node.inEdges.length; i < len; i++) {
                    if (diagram.nameTable[node.inEdges[i]]) {
                        if (diagram.nameTable[node.inEdges[i]] && ej.datavisualization.Diagram.Util.canBridge(diagram.nameTable[node.inEdges[i]], diagram)) {
                            ej.datavisualization.Diagram.Util.updateBridging(diagram.nameTable[node.inEdges[i]], diagram);
                            diagram._updateConnectorBridging(diagram.nameTable[node.inEdges[i]]);
                        }
                        if (!diagram._disableSegmentChange)
                            ej.datavisualization.Diagram.DiagramContext.update(diagram.nameTable[node.inEdges[i]], diagram);
                    }
                }
            }
            if (node.outEdges && node.outEdges.length > 0) {
                for (i = 0, len = node.outEdges.length; i < len; i++) {
                    if (diagram.nameTable[node.outEdges[i]]) {
                        if (diagram.nameTable[node.outEdges[i]] && ej.datavisualization.Diagram.Util.canBridge(diagram.nameTable[node.outEdges[i]], diagram)) {
                            ej.datavisualization.Diagram.Util.updateBridging(diagram.nameTable[node.outEdges[i]], diagram);
                            diagram._updateConnectorBridging(diagram.nameTable[node.outEdges[i]]);
                        }
                        if (!diagram._disableSegmentChange)
                            ej.datavisualization.Diagram.DiagramContext.update(diagram.nameTable[node.outEdges[i]], diagram);
                    }
                }
            }
        },

        _updateNode: function (node, svg, diagram, layout) {
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var x = node.offsetX - width * node.pivot.x;
            var y = node.offsetY - height * node.pivot.y;
            var angle = node.rotateAngle;
            var pt = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
            var visible = node.visible ? "visible" : "hidden";
            if (ej.datavisualization.Diagram.Util.canCrispEdges(node, diagram)) {
                x = Math.floor(x) + 0.5
                y = Math.floor(y) + 0.5;
            }
            var attr = ({
                "id": node.name, "transform": "rotate(" + angle + "," + pt.x + "," + pt.y + "),translate(" + x + "," + y + ")",
                "visibility": visible
            });
            if (!(ej.datavisualization.Diagram.Util.canEnablePointerEvents(node, diagram)))
                attr["style"] = "pointer-events:none";
            else
                attr["style"] = "";
            svg.g(attr);
            var type = node._shape ? node._shape : node.type;
            switch (type) {
                case "rectangle":
                    svg.rect({
                        "id": node.name + "_shape", "width": (width < 0) ? 0 : width, "height": (height < 0) ? 0 : height,
                    });
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.rect({
                            "id": node.name + "_shadow", "width": node.width, "height": node.height,
                        });
                    break;
                case "ellipse":
                    svg.ellipse({
                        "id": node.name + "_shape", "rx": width / 2, "ry": height / 2,
                        "cx": width / 2, "cy": height / 2
                    });
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.ellipse({
                            "id": node.name + "_shadow", "rx": node.width / 2, "ry": node.height / 2,
                            "cx": node.width / 2, "cy": node.height / 2
                        });
                    break;
                case "image":
                    this._updateBackgroundRect(node, svg);
                    var alignment = ej.datavisualization.Diagram.Util._getImageAlignment(node.contentAlignment);
                    var scale = node.scale == "none" ? "meet" : node.scale;
                    var attr = {
                        "id": node.name + "_shape", "preserveAspectRatio": (scale != "stretch" && alignment != "none" ? alignment + " " + scale : "none")
                    };
                    if (node.scale != "none") {
                        attr["width"] = width; attr["height"] = height;
                    }

                    svg.image(attr);
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.rect({
                            "id": node.name + "_shadow", "width": node.width, "height": node.height,
                        });
                    break;
                case "path":
                    var d;
                    if (node._preventStretch)
                        d = node._absolutePath = node.pathData;
                    else {
                        if (node._scaled || !node._absolutePath) {
                            d = ej.datavisualization.Diagram.Geometry.updatePath(0, 0, width, height, node.pathData, svg, node._absoluteBounds);
                            node._absolutePath = d;
                            node._scaled = false;
                        }
                        else d = node._absolutePath;
                    }
                    svg.path({
                        "id": node.name + "_shape", "d": d,
                    });
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.path({
                            "id": node.name + "_shadow", "d": d,
                        });
                    break;
                case "polygon":
                    this._updatePolygon(node, svg);
                    break;
                case "text":
                    this._updateTextElement(node, svg, diagram);
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.rect({
                            "id": node.name + "_shadow", "width": node.width, "height": node.height,
                        });
                    break;
                case "html":
                    this._updateHtmlElement(node, svg);
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.rect({
                            "id": node.name + "_shadow", "width": node.width, "height": node.height
                        });
                    break;
                case "native":
                    var object = this._scaleNodeContent(node, $("#" + node.name + "_shape")[0]);
                    var attr = {
                        "id": node.name + "_shape", "width": node.width, "height": node.height
                    }
                    if (object) attr["transform"] = "translate(" + object.x + "," + object.y + "),scale(" + object.sx + "," + object.sy + ")"
                    svg.g(attr);
                    if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                        svg.rect({
                            "id": node.name + "_shadow", "width": node.width, "height": node.height
                        });
                    break;
            }
        },

        _updateHtmlElement: function (node, svg) {
            this._updateBackgroundRect(node, svg);
            var visibility = node.visible ? "visible" : "hidden";
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var x = node.offsetX - width * node.pivot.x;
            var y = node.offsetY - height * node.pivot.y;
            var div;
            var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var parentDiv = $(htmlLayer).children("#" + node.name + "_parentdiv");
            if (parentDiv) {
                div = $(parentDiv).children("#" + node.name + "_html")[0];
                if (div) {
                    div.style.left = x + "px";
                    div.style.top = y + "px";
                    div.style.webkitTransform = "rotate(" + node.rotateAngle + "deg)";
                    div.style.MozTransform = "rotate(" + node.rotateAngle + "deg)";
                    div.style.OTransform = "rotate(" + node.rotateAngle + "deg)";
                    div.style.msTransform = "rotate(" + node.rotateAngle + "deg)";
                    div.style.transform = "rotate(" + node.rotateAngle + "deg)";
                    div.style.opacity = node.opacity;
                    div.style.visibility = visibility;
                }
            }
            if (div) {
                div.style.width = node.width.toString() + "px";
                div.style.height = node.height.toString() + "px";
            }
        },

        _updatePolygon: function (node, svg) {
            ej.datavisualization.Diagram.Geometry.updatePolygonPoints(node);
            svg.polygon({
                "id": node.name + "_shape", "points": this._convertToSVGPoints(node.points)
            });
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow)
                svg.polygon({
                    "id": node.name + "_shadow", "points": this._convertToSVGPoints(node.points)
                });
        },

        _convertToSVGPoints: function (points) {
            var pts = "";
            for (var i = 0, len = points.length; i < len; i++) {
                pts += points[i].x + "," + points[i].y + " ";
            }
            return pts.trim();
        },



        _renderTextElement: function (node, svg, g, diagram) {
            if (diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                this._renderBackgroundRect(node, svg, g);
                var label = node.textBlock;
                var nodeElement = svg.getElementById(node.name);

                var attr = {
                    "id": node.name + "_shape_lblbg", "class": "ej-d-label", "font-family": label.fontFamily, "font-size": label.fontSize, "fill": label.fontColor, "text-decoration": label.textDecoration, "font-weight": label.bold ? "bold" : "normal", "font-style": label.italic ? "italic" : "normal",
                };
                var textElement = svg.text(attr);
                nodeElement.appendChild(textElement);
                this._renderLabelSpanElement(textElement, node, label, svg, diagram, false);
            }
            else {
                var textElement = node.textBlock;
                if (textElement) {
                    var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                    this._renderBackgroundRect(node, svg, g);
                    var container = document.createElement("div");
                    var text = document.createElement("span");
                    ej.datavisualization.Diagram.Util.attr(text, { "id": node.name, "class": "ej-d-label", "style": "display: inline-block; position: absolute; pointer-events: all; line-height: normal; alignment-baseline:middle" });
                    if (textElement.bold) text.style.fontWeight = "bold";
                    if (textElement.italic) text.style.fontStyle = "italic";
                    text.style.textDecoration = textElement.textDecoration;
                    text.style.fontFamily = textElement.fontFamily;
                    text.style.fontSize = textElement.fontSize + "px";
                    text.style.color = textElement.fontColor;
                    text.textContent = textElement.text;
                    var style = "display: inline-block; position: absolute; width: inherit; height: inherit; pointer-events: none; ";
                    ej.datavisualization.Diagram.Util.attr(container, { "id": node.name + "_shape_lblbg", "style": style });
                    container.appendChild(text);

                    var element = $(htmlLayer).children("#" + node.name)[0];
                    if (element) htmlLayer.removeChild(element);
                    element = document.createElement("div");
                    var width = node.width ? node.width : node._width;
                    var height = node.height ? node.height : node._height;
                    var x = node.offsetX - width * node.pivot.x;
                    var y = node.offsetY - height * node.pivot.y;
                    var style = "width:" + width + "px; height:" + height + "px; left:" + x + "px; top:" + y + "px; display: block; position: absolute; pointer-events: none; ";
                    var class1 = "ej-d-node";
                    ej.datavisualization.Diagram.Util.attr(element, { "id": node.name, "class": class1, "style": style });
                    element.style.webkitTransform = "rotate(" + node.rotateAngle + "deg) ";
                    element.style.MozTransform = "rotate(" + node.rotateAngle + "deg) ";
                    element.style.OTransform = "rotate(" + node.rotateAngle + "deg) ";
                    element.style.msTransform = "rotate(" + node.rotateAngle + "deg)";
                    element.style.transform = "rotate(" + node.rotateAngle + "deg) ";
                    element.appendChild(container);

                    if (htmlLayer)
                        htmlLayer.appendChild(element);
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    this._alignTextOnLabel(node, bounds, text, container, node.textBlock);
                    //this._renderShadow(node, svg, g);
                }
            }
        },

        _updateTextElement: function (node, svg, diagram) {
            if (diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                this._updateBackgroundRect(node, svg);
                var label = node.textBlock;
                var nodeElement = svg.getElementById(node.name);

                var attr = {
                    "id": node.name + "_shape_lblbg",
                    "class": "ej-d-label", "font-family": label.fontFamily, "font-size": label.fontSize, "fill": label.fontColor, "text-decoration": label.textDecoration, "font-weight": label.bold ? "bold" : "normal", "font-style": label.italic ? "italic" : "normal",
                };
                var textElement = svg.text(attr);
                this._updateLabelSpanElement(node, label, svg, diagram, false);
            }
            else {
                this._updateBackgroundRect(node, svg);
                var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                if (htmlLayer) {
                    var parent = this._findChild(htmlLayer.childNodes, node);
                    var visible = node.visible ? "visible" : "hidden";
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    var width, height, x, y;
                    if (parent) {
                        width = bounds.width; height = bounds.height;
                        x = node.offsetX - node.width * node.pivot.x; y = node.offsetY - node.height * node.pivot.y;
                        parent.style.width = width + "px";
                        parent.style.height = height + "px";
                        parent.style.left = x + "px";
                        parent.style.top = y + "px";
                        parent.style.visibility = visible;
                        parent.style.webkitTransform = "rotate(" + node.rotateAngle + "deg)";
                        parent.style.MozTransform = "rotate(" + node.rotateAngle + "deg)";
                        parent.style.OTransform = "rotate(" + node.rotateAngle + "deg)";
                        parent.style.msTransform = "rotate(" + node.rotateAngle + "deg)";
                        parent.style.transform = "rotate(" + node.rotateAngle + "deg)";

                    }
                    var textContainer = $(parent).children("#" + node.name + "_shape_lblbg")[0];
                    if (textContainer) {
                        var text = textContainer.childNodes[0];
                        text.textContent = node.textBlock.text;
                        this._alignTextOnLabel(node, bounds, text, textContainer, node.textBlock, diagram);
                    }
                }
            }
        },

        _renderBackgroundRect: function (node, svg, g) {
            var fill = this._fill(node, svg);
            var attr = {
                "id": node.name + "_backRect", "class": "backrect", "x": 0, "y": 0,
                "width": node.width, "height": node.height, "fill": fill,
                "stroke": node.borderColor, "stroke-width": node.borderWidth, "opacity": node.opacity,
                "stroke-dasharray": node.borderDashArray
            };
            this._addCssClass(node, attr);
            if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                var point = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                var shadow = {
                    "id": node.name + "_shadow", "class": "backrect", "width": node.width, "height": node.height, "stroke": "lightgrey", "fill": fill != "none" || fill != "transparent" ? "lightgrey" : "none",
                    "transform": "translate(" + point.x + "," + point.y + ")", "opacity": node.shadow.opacity
                };
                g.appendChild(svg.rect(shadow));
            }
            g.appendChild(svg.rect(attr));

        },

        _updateBackgroundRect: function (node, svg) {
            var fill = this._fill(node, svg);
            var attr = {
                "id": node.name + "_backRect", "x": 0, "y": 0,
                "width": node.width, "height": node.height,
                "fill": fill, "stroke": node.borderColor, "stroke-width": node.borderWidth,
                "opacity": node.opacity, "stroke-dasharray": node.borderDashArray, "class": node.cssClass
            };
            svg.rect(attr);
        },

        _hideNode: function (node, svg) {
            var attr = { "id": node.name, "style": "pointer-events:none;" };
            svg.rect(attr);
        },

        _showNode: function (node, svg) {
            var attr = { "id": node.name, "style": "pointer-events:auto;" };
            svg.rect(attr);
        },
        _removePhasehelper: function (diagram) {
            if (diagram._adornerSvg.getElementById("phase_helper"))
                diagram._adornerSvg.removeChild(diagram._adornerSvg.getElementById("phase_helper"), diagram._adornerLayer);
        },
        _updatePhaseHelper: function (diagram, phase, bounds) {
            if (phase) {
                var svg = diagram._adornerSvg, scale = diagram._currZoom, attr;
                bounds.width = bounds.width < 0 ? 1 : bounds.width;
                bounds.height = bounds.height < 0 ? 1 : bounds.height;
                attr = {
                    "id": "phase_helper", "class": "helper", "pointer-events": "none", "width": bounds.width * scale, "height": bounds.height * scale
                };
                diagram._adornerSvg.rect(attr);
            }
        },
        _phasehelper: function (diagram, phase, bounds) {
            if (phase) {
                var svg = diagram._adornerSvg, scale = diagram._currZoom;
                var offsetX = (bounds.x + bounds.width / 2);
                var offsetY = (bounds.y + bounds.height / 2);
                var rect = svg.rect({
                    "id": "phase_helper", "class": "helper",
                    "stroke-width": 2, "stroke-dasharray": "3,3", "pointer-events": "none",
                    "width": bounds.width * scale, "height": bounds.height * scale, "fill": "transparent", "stroke": "green",
                    "transform": "translate(" + (offsetX - bounds.width / 2) * scale + "," + (offsetY - bounds.height / 2) * scale + "),rotate(" + 0 + "," + (bounds.width / 2) * scale + "," + (bounds.height / 2) * scale + ")"
                });
                diagram._adornerLayer.appendChild(rect);
            }
        },
        _drawContainerHelper: function (diagram) {
            var shape = diagram.activeTool.helper;
            var svg = diagram._adornerSvg;
            var scale = diagram._currZoom;
            if (shape)
                var bounds = ej.datavisualization.Diagram.Util.bounds(shape, true);
            var height = bounds.height;
            var width = bounds.width;
            var pivot;
            if (shape.pivot) pivot = { x: bounds.width * shape.pivot.x, y: bounds.height * shape.pivot.y };
            else pivot = { x: width / 2, y: height / 2 };
            var rotateAngle = shape.rotateAngle ? shape.rotateAngle : 0;
            var rect = svg.rect({
                "id": "helper", "class": "helper",
                "stroke-width": 1, "stroke-dasharray": "3,3", "pointer-events": "none",
                "width": width * scale, "height": height * scale, "fill": "transparent", "stroke": "red",
                "transform": "translate(" + (bounds.x) * scale + "," + (bounds.y) * scale + "),rotate(" + rotateAngle + "," + (pivot.x) * scale + "," + (pivot.y) * scale + ")"
            });
            diagram._adornerLayer.appendChild(rect);
        },

        _updateContainerHelper: function (diagram) {
            var attr;
            var shape = diagram.activeTool.helper;
            var scale = diagram._currZoom;
            if (shape)
                var bounds = ej.datavisualization.Diagram.Util.bounds(shape, true);
            var height = bounds.height;
            var width = bounds.width;
            var pivot;
            if (shape.pivot) pivot = { x: bounds.width * shape.pivot.x, y: bounds.height * shape.pivot.y };
            else pivot = { x: width / 2, y: height / 2 };
            diagram._raiseOffsetPropertyChange(shape, bounds.center.x, bounds.center.y, true);
            diagram._raiseSizePropertyChange(shape, bounds.width / shape.width, bounds.height / shape.height, true);
            var rotateAngle = shape.rotateAngle ? shape.rotateAngle : 0;
            attr = {
                "id": "helper", "class": "helper",
                "width": width * scale, "height": height * scale, "fill": "transparent", "stroke": "red",
                "transform": "translate(" + (bounds.x) * scale + "," + (bounds.y) * scale + "),rotate(" + rotateAngle + "," + (pivot.x) * scale + "," + (pivot.y) * scale + ")"
            };
            diagram._adornerSvg.rect(attr);
        },

        _removeContainerHelper: function (node, svg, parent) {
            if (svg.getElementById("helper"))
                svg.removeChild(svg.getElementById("helper"), parent);
        },
        //#endregion

        setNodeShape: function (node, svg, parent, diagram) {
            var g;
            if (parent) {
                var parentg = svg.getElementById(parent.name);
                g = $(parentg).find("#" + node.name)[0];
            }
            else {
                g = svg.getElementById(node.name);
            }
            if (g) {
                $(g).empty();
                this._renderNode(node, svg, g, diagram);
            }
        },

        setLine: function (connector, svg, parent, diagram) {
            var g;
            if (parent) {
                var parentg = svg.getElementById(parent.name);
                g = $(parentg).find("#" + connector.name)[0];
            }
            else {
                g = svg.getElementById(connector.name);
            }
            $(g).empty();

            this.renderConnector(connector, svg, g, diagram);
        },

        addNodeLabel: function (node, label, svg, parent, diagram) {
            this._renderLabels(node, svg, diagram);
        },
        //#endregion

        //#region Render Connector
        renderConnector: function (connector, svg, parent, diagram) {
            var g, attr;
            var visible = connector.visible ? "visible" : "hidden";
            if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                attr = { "id": connector.name, "class": "ej-d-connector", "visibility": visible, "opacity": connector.opacity, "transform": "translate(" + 0.5 + "," + 0.5 + ")" };
            else
                attr = { "id": connector.name, "class": "ej-d-connector", "visibility": visible, "opacity": connector.opacity };
            if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(connector, diagram))
                attr["style"] = "pointer-events:none";
            g = svg.g(attr);
            if (parent) {
                if (parent.id !== g.id) {
                    parent.appendChild(g);
                }
            }
            else {
                svg.appendChild(g);
            }
            var seg = svg.g({ "id": connector.name + "segments" });
            this._renderSegments(connector, svg, seg, diagram);
            g.appendChild(seg);
            this._renderLabels(connector, svg, diagram);
            this._renderDecorators(connector, svg, g, diagram);
            if (connector.shape) {
                ej.datavisualization.Diagram.DefautShapes.updateInlineDecoratorsShape(connector, diagram);
                for (var i = 0; i < connector._inlineDecorators.length; i++)
                    this.renderNode(connector._inlineDecorators[i], svg, g, undefined, diagram);
            }
            return g;
        },

        _renderSegments: function (connector, svg, g, diagram) {
            var visibility = connector.visible && ((diagram && diagram._browserInfo ? diagram._browserInfo.name : ej.browserInfo().name) === "msie") ? "collapse" : "hidden";
            var path = this._findPath(connector, diagram);
            var attr = {
                "id": connector.name + "_hitTest", "class": "hitTest", "stroke-width": connector.lineHitPadding, "d": path,
                "stroke": "transparent", "visibility": "hidden"
            };
            if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(connector, diagram))
                attr["pointer-events"] = "none";
            else
                attr["pointer-events"] = connector.visible ? "stroke" : "none";
            var line = svg.path(attr);
            g.appendChild(line);
            attr = {
                "id": connector.name + "_segments",
                "d": path, "fill": "none", "stroke": connector.lineColor,
                "stroke-width": connector.lineWidth, "stroke-dasharray": connector.lineDashArray, "opacity": connector.opacity
            };
            this._addCssClass(connector, attr);
            line = svg.path(attr);
            g.appendChild(line);
            if (connector.shape && connector.shape.type == "umlactivity" && connector.shape.activityFlow == "exception") {
                var attr = {
                    "id": connector.name + "_Activityflow", "class": "umlactivityflow", "fill": "none", "stroke": connector.lineColor, "pointer-events": "none", "stroke-width": connector.lineWidth, "stroke-dasharray": connector.lineDashArray, "opacity": connector.opacity, "d": connector._temppath,
                };
                var line1 = svg.path(attr);
                this._addCssClass(connector, attr);
                g.appendChild(line1);
            }
        },

        _findPath: function (connector, diagram) {
            var st, end, path;
            for (var i = 0; i < connector.segments.length; i++) {
                var seg = connector.segments[i];
                if (seg._bridges.length > 0) {
                    for (var n = 0; n < seg._bridges.length; n++) {
                        var bridge = seg._bridges[n];
                        bridge._rendered = false;
                    }
                }
                var points = seg.points;
                if (connector.shape && connector.shape.flow == "sequence" && connector.shape.sequence == "default" && i == 0) {
                    var beginningpoint = { x: seg.points[0].x, y: seg.points[0].y };
                    var distance = ej.datavisualization.Diagram.Geometry.distance(seg.points[0], seg.points[1]);
                    distance = Math.min(30, distance / 2);
                    var angle = ej.datavisualization.Diagram.Geometry.findAngle(seg.points[0], seg.points[1]);
                    var transferpoint = ej.datavisualization.Diagram.Geometry.transform({ x: beginningpoint.x, y: beginningpoint.y }, angle, distance);
                    var startpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: transferpoint.x, y: transferpoint.y }, angle + 45, -12);
                    var endpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: startpoint1.x, y: startpoint1.y }, angle + 45, 12 * 2);
                    if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                        var path1 = "M" + Math.floor(startpoint1.x) + " " + Math.floor(startpoint1.y) + " L" + Math.floor(endpoint1.x) + " " + Math.floor(endpoint1.y);
                    else
                        var path1 = "M" + startpoint1.x + " " + startpoint1.y + " L" + endpoint1.x + " " + endpoint1.y;
                }
                if (connector.shape && connector.shape.type == "umlactivity" && connector.shape.activityFlow == "exception" && i == 0) {
                    var beginningpoint = { x: seg.points[0].x, y: seg.points[0].y };
                    var distance = ej.datavisualization.Diagram.Geometry.distance(seg.points[0], seg.points[1]);
                    distance = Math.max(30, distance / 2);
                    var angle = ej.datavisualization.Diagram.Geometry.findAngle(seg.points[0], seg.points[1]);
                    var transferpoint = ej.datavisualization.Diagram.Geometry.transform({ x: beginningpoint.x, y: beginningpoint.y }, angle, distance);
                    var startpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: transferpoint.x, y: transferpoint.y }, angle + 145, 9);
                    var endpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: startpoint1.x, y: startpoint1.y }, angle + 225, 7 * 2);
                    if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                        var path1 = "M" + Math.floor(startpoint1.x) + " " + Math.floor(startpoint1.y) + " L" + Math.floor(endpoint1.x) + " " + Math.floor(endpoint1.y);
                    else
                        var path1 = "M" + endpoint1.x + " " + startpoint1.y + "L" + endpoint1.x + " " + endpoint1.y + " L" + startpoint1.x + " " + startpoint1.y + " L" + startpoint1.x + " " + endpoint1.y;
                }
                if (i == 0) {
                    if (diagram && connector.sourceNode) var node = diagram._findNode(connector.sourceNode);
                    points = this._clipDecorators(connector, seg, true, node);
                    if (seg.type == "bezier" && connector.sourceDecorator && connector.sourceDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                        points[0] = ej.datavisualization.Diagram.Util._adjustPoint(points[0], seg._point1, true, connector.lineWidth);
                    }
                    if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                        path = "M" + Math.floor(points[0].x) + " " + Math.floor(points[0].y);
                    else
                        path = "M" + points[0].x + " " + points[0].y;
                }
                if (i == connector.segments.length - 1) {
                    if (diagram && connector.targetNode) var node = diagram._findNode(connector.targetNode);
                    points = this._clipDecorators(connector, seg, false, node);
                }
                if (seg.type != "bezier") {
                    if (connector.cornerRadius > 0) {
                        for (var j = 0; j < points.length - 1; j++) {
                            var segLength = ej.datavisualization.Diagram.Geometry.distance(points[j], points[j + 1]);
                            if (segLength > 0) {
                                if (i < connector.segments.length - 1 || j < points.length - 2) {
                                    if (segLength < connector.cornerRadius * 2) {
                                        end = ej.datavisualization.Diagram.Util._adjustPoint(points[j], points[j + 1], false, segLength / 2);
                                    }
                                    else end = ej.datavisualization.Diagram.Util._adjustPoint(points[j], points[j + 1], false, connector.cornerRadius);
                                }
                                else end = points[j + 1];

                                if (i > 0 || j > 0) {
                                    if (segLength < connector.cornerRadius * 2) {
                                        st = ej.datavisualization.Diagram.Util._adjustPoint(points[j], points[j + 1], true, segLength / 2);
                                        if (i < connector.segments.length - 1 || j < points.length - 2)
                                            end = null;
                                    }
                                    else st = ej.datavisualization.Diagram.Util._adjustPoint(points[j], points[j + 1], true, connector.cornerRadius);
                                }

                                if (st) {
                                    if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                                        path += " Q" + Math.floor(points[j].x) + " " + Math.floor(points[j].y) + " " + Math.floor(st.x) + " " + Math.floor(st.y);
                                    else
                                        path += " Q" + points[j].x + " " + points[j].y + " " + st.x + " " + st.y;
                                }
                                if (end) {
                                    if (seg._bridges.length > 0) {
                                        path = this._updateBridging(seg, path, j);
                                        if (seg.type === "orthogonal")
                                            path = this._updateBridging(seg, path, j + 1);
                                    }
                                    if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                                        path += " L" + Math.floor(end.x) + " " + Math.floor(end.y);
                                    else
                                        path += " L" + end.x + " " + end.y;
                                }
                            }
                        }
                    }
                    else {
                        for (var j = 0; j < points.length; j++) {
                            if (j > 0) {
                                path = this._updateBridging(seg, path, j);
                                if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                                    path += " L" + Math.floor(points[j].x) + " " + Math.floor(points[j].y);
                                else
                                    path += " L" + points[j].x + " " + points[j].y;
                            }
                        }
                    }
                }
                else {
                    var endPoint = seg._endPoint;
                    if (connector.targetDecorator && connector.targetDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                        endPoint = ej.datavisualization.Diagram.Util._adjustPoint(seg._endPoint, seg._point2, true, connector.lineWidth);
                    }
                    if (connector.targetNode && diagram) {
                        var targetNode = diagram._findNode(connector.targetNode);
                        if (node.borderColor != "none")
                            endPoint = ej.datavisualization.Diagram.Util._adjustPoint(endPoint, seg._point2, true, targetNode.borderWidth / 2);
                    }
                    if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                        path += " C" + Math.floor(seg._point1.x) + " " + Math.floor(seg._point1.y) + " " + Math.floor(seg._point2.x) + " " + Math.floor(seg._point2.y) + " " + Math.floor(endPoint.x) + " " + Math.floor(endPoint.y);
                    else
                        path += " C" + seg._point1.x + " " + seg._point1.y + " " + seg._point2.x + " " + seg._point2.y + " " + endPoint.x + " " + endPoint.y;
                }
            }
            if (connector.shape && connector.shape.flow == "sequence" && connector.shape.sequence == "default") {
                path += path1;
            }
            if (connector.shape && connector.shape.activityFlow == "exception" && connector.shape.type == "umlactivity") {
                path = path;
                connector._temppath = path1;
            }
            return path;
        },

        _updateBridging: function (seg, path, pointIndex) {
            var pathData = path;
            if (seg._bridges.length > 0) {
                if (seg.type === "straight") {
                    for (var n = 0; n < seg._bridges.length; n++) {
                        var bridge = seg._bridges[n];
                        if (!bridge._rendered) {
                            pathData += " L" + bridge.startPoint.x + " " + bridge.startPoint.y;
                            pathData += bridge.path;
                        }
                    }
                }
                else if (seg.type === "orthogonal") {
                    for (var n = 0; n < seg._bridges.length; n++) {
                        var bridge = seg._bridges[n];
                        if (bridge.segmentPointIndex === pointIndex && !bridge._rendered) {
                            pathData += " L" + bridge.startPoint.x + " " + bridge.startPoint.y;
                            pathData += bridge.path;
                            bridge._rendered = true;
                        }
                    }
                }
            }
            return pathData;
        },

        _refreshSegments: function (connector, svg, diagram) {
            this._updateConnector(connector, svg, diagram);
            this._updateDecorators(connector, svg, diagram);
        },

        _refreshOnlySegments: function (connector, svg, diagram) {
            var path = this._findPath(connector, diagram);
            var element = svg.document.getElementById(connector.name + "_segments");
            if (element) {
                element.setAttribute("d", path);
                element = svg.document.getElementById(connector.name + "_hitTest");
                element.setAttribute("d", path);
            }
        },

        _clipDecorators: function (connector, segment, source, node) {
            var points = [];
            if (!source && connector.targetDecorator && connector.targetDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                var start, end;
                for (var i = 0; i < segment.points.length; i++) {
                    points[i] = segment.points[i];
                }
                start = points[points.length - 1];
                end = points[points.length - 2];
                var len = ej.datavisualization.Diagram.Geometry.distance(start, end);
                len = (len == 0) ? 1 : len;
                var width = connector.lineWidth;
                var newPoint = ej.datavisualization.Diagram.Point();
                newPoint.x = start.x + width * (end.x - start.x) / len;
                newPoint.y = start.y + width * (end.y - start.y) / len;
                if (node && node.borderColor != "none")
                    newPoint = ej.datavisualization.Diagram.Util._adjustPoint(newPoint, end, true, node.borderWidth / 2);
                points[points.length - 1] = newPoint;
            }
            else if (source && connector.sourceDecorator && connector.sourceDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                for (var i = 0; i < segment.points.length; i++) {
                    points[i] = segment.points[i];
                }
                start = points[0];
                end = points[1];
                var len = ej.datavisualization.Diagram.Geometry.distance(start, end);
                len = (len == 0) ? 1 : len;
                var width = connector.lineWidth;
                var newPoint = ej.datavisualization.Diagram.Point();
                newPoint.x = start.x + width * (end.x - start.x) / len;
                newPoint.y = start.y + width * (end.y - start.y) / len;
                if (segment.type == "bezier") {
                    newPoint.x = start.x + (segment._point1.x - start.x) / len;
                    newPoint.y = start.y + (segment._point1.y - start.y) / len;
                }
                if (node && node.borderColor != "none")
                    newPoint = ej.datavisualization.Diagram.Util._adjustPoint(newPoint, segment.type != "bezier" ? end : segment._point1, true, node.borderWidth / 2);
                points[0] = newPoint;
            }
            else if (source) {
                for (var i = 0; i < segment.points.length; i++) {
                    points[i] = segment.points[i];
                }
                if (node && node.borderColor != "none")
                    points[0] = ej.datavisualization.Diagram.Util._adjustPoint(points[0], points[1], true, node.borderWidth / 2);
            }
            else {
                for (var i = 0; i < segment.points.length; i++) {
                    points[i] = segment.points[i];
                }
                if (node && node.borderColor != "none")
                    points[points.length - 1] = ej.datavisualization.Diagram.Util._adjustPoint(points[points.length - 1], points[points.length - 2], true, node.borderWidth / 2);
            }
            return points;
        },

        _updateConnector: function (connector, svg, diagram) {
            if (diagram && !diagram._isInit && connector._status !== "new")
                connector._status = "update";
            var path = this._findPath(connector, diagram);
            svg.path({ "id": connector.name + "_segments", "d": path });
            var attr = { "id": connector.name + "_hitTest", "d": path, "stroke-width": connector.lineHitPadding };
            if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(connector, diagram))
                attr["pointer-events"] = "none";
            else
                attr["pointer-events"] = (connector.isPhase ||
                        (diagram._selectedSymbol && diagram.selectionList[0] && diagram.selectionList[0].name == connector.name))
                        ? "none" : (connector.visible ? "stroke" : "none")
            svg.path(attr);
            if (connector.shape && connector.shape.type == "umlactivity" && connector.shape.activityFlow == "exception") {
                var attr = {
                    "id": connector.name + "_Activityflow", "class": "umlactivityflow", "fill": "none", "stroke": connector.lineColor, "pointer-events": "none", "stroke-width": connector.lineWidth, "stroke-dasharray": connector.lineDashArray, "opacity": connector.opacity, "d": connector._temppath,
                };
                svg.path(attr);
            }

        },

        updateConnector: function (connector, svg, diagram) {
            //var svg = diagram._svg;
            if (svg) {
                var visible = connector.visible ? "visible" : "hidden";
                var attr;
                if (ej.datavisualization.Diagram.Util.canCrispEdges(connector, diagram))
                    attr = { "id": connector.name, "visibility": visible, opacity: connector.opacity, "transform": "translate(" + 0.5 + "," + 0.5 + ")" };
                else
                    attr = { "id": connector.name, "visibility": visible, opacity: connector.opacity };
                if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(connector, diagram))
                    attr["style"] = "pointer-events:none";
                else
                    attr["style"] = "";
                if (!diagram._animatingLayout)
                    svg.g(attr);
                this._updateConnector(connector, svg, diagram);
                this._updateLabels(connector, svg, diagram);
                this._updateDecorators(connector, svg, diagram);
                if (connector.shape) {
                    ej.datavisualization.Diagram.DefautShapes.updateInlineDecoratorsShape(connector, diagram);
                    for (var i = 0; i < connector._inlineDecorators.length; i++)
                        this.updateNode(connector._inlineDecorators[i], svg, diagram);
                }
            }
        },

        renderDecorators: function (connector, svg, diagram) {
            var g = svg.getElementById(connector.name);
            this._renderDecorators(connector, svg, g, diagram);
        },

        clearDecorators: function (connector, svg, diagram) {
            this._updateConnector(connector, svg, diagram);
            var g = svg.getElementById(connector.name);
            var dec = svg.getElementById(connector.name + "_targetDecorator");
            if (dec)
                svg.removeChild(dec, g);
            dec = svg.getElementById(connector.name + "_sourceDecorator");
            if (dec)
                svg.removeChild(dec, g);
        },
        //#endregion

        //#region Render Decorator
        _renderDecorators: function (connector, svg, g, diagram) {
            var startPoint;
            var endPoint;
            if (connector.targetDecorator && connector.targetDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                var segment = connector.segments[connector.segments.length - 1];
                startPoint = segment.points[segment.points.length - 2];
                endPoint = connector.targetPoint;
                if (segment.type == "bezier") {
                    startPoint = segment._point2;
                }
                if (connector.targetNode && diagram) {
                    var targetNode = diagram._findNode(connector.targetNode);
                    if (targetNode && targetNode.borderColor != "none")
                        endPoint = ej.datavisualization.Diagram.Util._adjustPoint(endPoint, startPoint, true, targetNode.borderWidth / 2);
                }
                this._renderDecorator(connector.name + "_targetDecorator", endPoint,
                    startPoint, connector, connector.targetDecorator, svg, g);
            }
            if (connector.sourceDecorator && connector.sourceDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                var segment = connector.segments[0];
                startPoint = connector.sourcePoint;
                endPoint = segment.points[1];
                if (segment.type == "bezier") {
                    endPoint = segment._point1;
                }
                if (connector.sourceNode && diagram) {
                    var sourceNode = diagram._findNode(connector.sourceNode);
                    if (sourceNode && sourceNode.borderColor != "none")
                        startPoint = ej.datavisualization.Diagram.Util._adjustPoint(startPoint, endPoint, true, sourceNode.borderWidth / 2);
                }
                this._renderDecorator(connector.name + "_sourceDecorator", startPoint,
                    endPoint, connector, connector.sourceDecorator, svg, g);
            }
        },
        _renderIcons: function (node, diagram) {
            var expandicon = node.expandIcon;
            var collapseicon = node.collapseIcon;
            if (expandicon.shape != "none" || collapseicon.shape != "none") {
                var g;
                var width = node.width ? node.width : node._width || 0;
                var height = node.height ? node.height : node._height || 0;
                var name = node.name;
                var offX = 0, offY = 0, x = 0, y = 0, rAngle = 0;
                var visible = node.visible ? "visible" : "hidden";
                x = node.offsetX - width * node.pivot.x;
                y = node.offsetY - height * node.pivot.y;
                offX = node.offsetX;
                offY = node.offsetY;
                rAngle = node.rotateAngle;
                var attr = {
                    "id": name, "transform": "rotate(" + rAngle + "," + offX + "," + offY +
                            "),translate(" + x + "," + y + ")", "visibility": visible
                };
                var svg = diagram._adornerSvg;
                g = svg.g(attr);
                var expander = svg.document.parentNode.getElementsByClassName("ExpanderLayer")[0] || diagram._expander;
                expander.appendChild(g);
                if (expandicon != undefined && node.isExpanded) {
                    this._renderIcon(node, svg, expandicon, g, diagram);
                } if (collapseicon != undefined && !node.isExpanded) {
                    this._renderIcon(node, svg, collapseicon, g, diagram);
                }
            }
        },
        _renderIcon: function (node, svg, icon, g, diagram) {
            var shape;
            var attr, point;
            if (icon != undefined) {
                point = ej.datavisualization.Diagram.Util._getIconPosition(icon, ej.datavisualization.Diagram.Util.bounds(node, true), true);
                if (icon.shape != "path") {
                    this._renderExpanderTemplate(node, svg, icon, g, diagram, point);
                }
                else
                    //path
                    if (icon.shape == "path") {
                        var g = document.createElementNS('http://www.w3.org/2000/svg', 'g');
                        g.setAttribute("id", node.name + "_expander");
                        g.setAttribute("class", "ej-d-icon-template");
                        var d = ej.datavisualization.Diagram.Geometry.updatePath(point.x - icon.width / 2, point.y - icon.height / 2, icon.width, icon.height, icon.pathData, svg);
                        var visible = node.visible ? "visible" : "hidden";
                        icon._absolutePath = d;
                        if (icon.margin.left && icon.margin.right)
                            icon.width -= (icon.margin.left || 0) + (icon.margin.right || 0);
                        if (icon.margin.top && icon.margin.bottom)
                            icon.height -= (icon.margin.top || 0) + (icon.margin.bottom || 0);
                        attr = {
                            "id": node.name + "_pathexpander",
                            "x": point.x, "y": point.y, "width": icon.width,
                            "height": icon.height, "fill": icon.borderColor, "stroke": icon.borderColor, "stroke-width": icon.borderWidth, "visibility": visible,
                            "d": d
                        };
                        this._addCssClass(g, attr);
                        var a = svg.path(attr);
                        g.appendChild(a);
                        return g;
                    }
                //image
                if (icon.shape == "image") {
                    var image = new Image();
                    image.src = icon.source;
                    var shape = svg.image(attr);
                    shape.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.src);
                    g.appendChild(shape);

                } return shape;
            }
        },
        _renderExpanderTemplate: function (node, svg, icon, g, diagram, point, update) {
            //drawing iconShape using template
            var temp = this.construct_template_iconshape(icon, node.isExpanded, diagram);
            if (temp != "undefined") {
                if (update)
                    g.removeChild(svg.document.getElementById(node.name + "_expander"));
                var div = document.createElement('div'); div.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg"><g id="tempNative">' + temp + '</g></svg>';
                document.body.appendChild(div);
                var element = document.getElementById("tempNative");
                var content = element.cloneNode(true);
                content.id = node.name + "_expander";
                var bounds = element.getBBox();
                var width = icon.width;
                var height = icon.height;
                var delwidth = bounds.width ? width / (bounds.width) : 1;
                var delheight = bounds.height ? height / (bounds.height) : 1;
                div.parentNode.removeChild(div);
                g.appendChild(content);
                var ratio = Math.min(delwidth, delheight);
                var visible = node.visible ? "visible" : "hidden";
                if (icon.horizontalAlignment || icon.verticalAlignment) {
                    var x = 0, y = 0;
                    var offset = { x: icon.offset.x, y: icon.offset.y };
                    switch (icon.horizontalAlignment) {
                        case "left":
                            point.x += 0;
                            break;
                        case "center":
                            point.x -= icon.width / 2;
                            break;
                        case "right":
                            point.x -= icon.width;
                            break;
                    }
                    switch (icon.verticalAlignment) {
                        case "top":
                            point.y += 0;
                            break;
                        case "center":
                            point.y -= icon.height / 2;
                            break;
                        case "bottom":
                            point.y -= icon.height;
                            break;
                    }
                    var left = ((point.x) - bounds.x * delwidth);
                    var top = ((point.y) - bounds.y * delheight);
                    var attr = {
                        "id": node.name + "_expander", "class": "ej-d-icon-template",
                        "transform": "translate(" + left + "," + top + "),scale(" + delwidth + "," + delheight + ")",
                        "x": point.x, "y": point.y, "width": icon.width,
                        "height": icon.height, "fill": icon.borderColor, "stroke": icon.borderColor, "stroke-width": icon.borderWidth
                    }; svg.g(attr);
                }
            }
        },
        construct_template_iconshape: function (icon, expanded, diagram) {
            var content;
            if (icon.shape) {
                switch (icon.shape) {
                    case "arrowup":
                        content = '<rect  x="2.5" y="2.5" width="15" height="15" style="fill:#FFFFFF;stroke:#000000;stroke-miterlimit:10"/><path d="M8.7,7.2L8.9,7h2.2l0.2,0.2l0,0l4.8,4.8h-2.5L10,8.4L6.4,12H3.9L8.7,7.2L8.7,7.2z"/></path></rect>';
                        break;
                    case "arrowdown":
                        content = '<rect  x="2.5" y="2.5" width="15" height="15" style="fill:#FFFFFF;stroke:#000000;stroke-miterlimit:10"/><path d="M9,12.2l0.1,0.1h1.7l0.1-0.1l0,0l3.8-3.8h-2L10,11.2L7.2,8.4h-2L9,12.2L9,12.2z"/></path></rect>';
                        break;
                    case "plus":
                        content = '<rect x="2.5" y="2.5" width="15" height="15" style="fill:#FFFFFF;stroke:#000000;stroke-miterlimit:10"/><line style="fill:#FFFFFF;stroke:#000000;stroke-width:2;stroke-miterlimit:10" x1="6.1" y1="10" x2="13.9" y2="10"/></line><line style=" fill:#FFFFFF;stroke:#000000;stroke-width:2;stroke-miterlimit:10" x1="10" y1="6.1" x2="10" y2="13.9"/></line></rect>';
                        break;
                    case "minus":
                        content = ' <rect x="2.5" y="2.5" width="15" height="15" style="fill:#FFFFFF;stroke:#000000;stroke-miterlimit:10"/><line style="fill:#FFFFFF;stroke:#000000;stroke-width:2;stroke-miterlimit:10" x1="6.1" y1="10" x2="13.9" y2="10"/></line></rect>';
                        break;
                    case "template":
                        content = diagram._renderEjTemplate("#" + icon.templateId, icon);
                } return content;
            }
        },
        _updateIcons: function (node, svg, diagram) {
            var expandicon = node.expandIcon;
            var collapseicon = node.collapseIcon;
            if (expandicon.shape != "none" || collapseicon.shape != "none") {
                var g;
                var width = node.width ? node.width : node._width || 0;
                var height = node.height ? node.height : node._height || 0;
                var name = node.name;
                var offX = 0, offY = 0, x = 0, y = 0, rAngle = 0;
                var visible = node.visible ? "visible" : "hidden";
                x = node.offsetX - width * node.pivot.x;
                y = node.offsetY - height * node.pivot.y;
                offX = node.offsetX;
                offY = node.offsetY;
                rAngle = node.rotateAngle;
                var attr = {
                    "id": name, "transform": "rotate(" + rAngle + "," + offX + "," + offY +
                            "),translate(" + x + "," + y + ")", "visibility": visible
                };
                var svg = diagram._adornerSvg;
                g = svg.g(attr);
                var expander = svg.document.parentNode.getElementsByClassName("ExpanderLayer")[0] || diagram._expander;
                if (expandicon != undefined && node.isExpanded) {
                    this._updateIcon(node, diagram._adornerSvg, g, expandicon, diagram);
                } if (collapseicon != undefined && !node.isExpanded) {
                    this._updateIcon(node, diagram._adornerSvg, g, collapseicon, diagram);
                }
            }
        },
        _updateIcon: function (node, svg, g, icon, diagram) {
            var attr, point;
            var d, x;
            if (icon != undefined && (node._scaled || node._updateExpander)) {
                point = ej.datavisualization.Diagram.Util._getIconPosition(icon, ej.datavisualization.Diagram.Util.bounds(node, true), true);
                if (icon.shape != "path") {
                    if (node._scaled || node._updateExpander) {
                        //drawingtemplate
                        this._renderExpanderTemplate(node, svg, icon, g, diagram, point, true);
                    }
                }
                else {
                    if (icon.shape == "path") {
                        var d = ej.datavisualization.Diagram.Geometry.updatePath(point.x - icon.width / 2, point.y - icon.height / 2, icon.width, icon.height, icon.pathData, svg);
                        var visible = node.visible ? "visible" : "hidden";
                        icon._absolutePath = d;
                        if (icon.margin.left && icon.margin.right)
                            icon.width -= (icon.margin.left || 0) + (icon.margin.right || 0);
                        if (icon.margin.top && icon.margin.bottom)
                            icon.height -= (icon.margin.top || 0) + (icon.margin.bottom || 0);
                        attr = {
                            "id": node.name + "_pathexpander",
                            "x": point.x, "y": point.y, "width": icon.width,
                            "height": icon.height, "fill": icon.borderColor, "stroke": icon.borderColor, "stroke-width": icon.borderWidth, "visibility": visible,
                            "d": d
                        };
                        svg.path(attr);
                    }
                }
                //image
                if (icon.shape == "image") {
                    var image = new Image();
                    image.src = icon.source;
                    var shape = svg.image(attr);
                    shape.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.src);
                    g.appendChild(shape);
                }

                node._updateExpander = false;
            }

        },
        _renderDecorator: function (name, point1, point2, connector, decorator, svg, g) {
            var shape;
            var attr;
            var d, x;
            var size = ej.datavisualization.Diagram.Size(decorator.width, decorator.height);
            switch (decorator.shape) {
                case "arrow":
                    d = this._constructArrow(point1, size);
                    attr = { "id": name, "class": "decorator", "d": d, "fill": decorator.fillColor, "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth };
                    this._addCssClass(decorator, attr);
                    shape = svg.path(attr);
                    x = 1.1 * decorator.borderWidth;
                    break;
                case "openarrow":
                    d = this._constructArrow(point1, size, true);
                    attr = { "id": name, "class": "decorator", "d": d, "fill": "transparent", "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth };
                    this._addCssClass(decorator, attr);
                    shape = svg.path(attr);
                    x = 1.1 * decorator.borderWidth;
                    break;
                case "circle":
                    var rx = size.width / 2;
                    var ry = size.height / 2;
                    attr = {
                        "id": name, "class": "decorator", "rx": rx, "ry": ry, "cx": (point1.x + size.width / 2), "cy": (point1.y),
                        "fill": decorator.fillColor, "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth
                    };
                    this._addCssClass(decorator, attr);
                    shape = svg.ellipse(attr);
                    x = 0.5 * decorator.borderWidth;
                    break;
                case "diamond":
                    d = this._constructDiamond(point1, size, svg);
                    attr = {
                        "id": name, "class": "decorator", "x": point1.x, "y": point1.y, "width": size.width,
                        "height": size.height, "d": d, "fill": decorator.fillColor, "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth
                    };
                    this._addCssClass(decorator, attr);
                    shape = svg.path(attr);
                    x = 0.7 * decorator.borderWidth;
                    break;
                case "path":
                    d = ej.datavisualization.Diagram.Geometry.updatePath(point1.x, point1.y - size.height / 2, size.width, size.height, decorator.pathData, svg);
                    decorator._absolutePath = d;
                    attr = {
                        "id": name, "class": "decorator", "x": point1.x, "y": point1.y, "width": size.width,
                        "height": size.height, "d": d, "fill": decorator.fillColor, "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth
                    };
                    this._addCssClass(decorator, attr);
                    shape = svg.path(attr);
                    x = 0.5 * decorator.borderWidth;
                    break;
            }
            //apply translate matrix and rotate matrix here
            if (shape) {
                if (decorator.borderColor != "none") {
                    var angle = ej.datavisualization.Diagram.Geometry.findAngle(point1, point2);
                    var extra = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, angle, x);
                    shape.setAttribute("transform", "translate(" + extra.x + "," + extra.y + "),rotate(" + angle + " " + point1.x + " " + point1.y + ")");
                }
                else
                    shape.setAttribute("transform", "rotate(" + ej.datavisualization.Diagram.Geometry.findAngle(point1, point2) + " " + point1.x + " " + point1.y + ")");
                g.appendChild(shape);
            }
        },

        _updateDecorators: function (connector, svg, diagram) {
            var startPoint;
            var endPoint;
            if (connector.targetDecorator && connector.targetDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                var segment = connector.segments[connector.segments.length - 1];
                var points = segment.points;
                startPoint = points[points.length - 2];
                endPoint = connector.targetPoint;
                if (segment.type == "bezier") {
                    startPoint = segment._point2;
                }
                if (connector.targetNode && diagram) {
                    var targetNode = diagram._findNode(connector.targetNode);
                    if (targetNode && targetNode.borderColor != "none")
                        endPoint = ej.datavisualization.Diagram.Util._adjustPoint(connector.targetPoint, startPoint, true, targetNode.borderWidth / 2);
                }
                this._updateDecorator(connector.name + "_targetDecorator", endPoint, startPoint, connector, connector.targetDecorator, svg);
            }
            if (connector.sourceDecorator && connector.sourceDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                var segment = connector.segments[0];
                var points = segment.points;
                startPoint = connector.sourcePoint;
                endPoint = points[1];
                if (segment.type == "bezier") {
                    endPoint = segment._point1;
                }
                if (connector.sourceNode && diagram) {
                    var sourceNode = diagram._findNode(connector.sourceNode);
                    if (sourceNode.borderColor != "none")
                        startPoint = ej.datavisualization.Diagram.Util._adjustPoint(connector.sourcePoint, endPoint, true, sourceNode.borderWidth / 2);
                }
                this._updateDecorator(connector.name + "_sourceDecorator", startPoint, endPoint, connector, connector.sourceDecorator, svg);
            }
        },

        _updateDecorator: function (name, point1, point2, connector, decorator, svg) {
            var shape;
            var attr;
            var d, x;
            var size = ej.datavisualization.Diagram.Size(decorator.width, decorator.height);

            switch (decorator.shape) {
                case "arrow":
                    d = this._constructArrow(point1, size);
                    attr = { "id": name, "d": d };
                    shape = svg.path(attr);
                    x = 1.1 * decorator.borderWidth;
                    break;
                case "openarrow":
                    d = this._constructArrow(point1, size, true);
                    attr = { "id": name, "d": d, "fill": "transparent", "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth };
                    shape = svg.path(attr);
                    x = 1.1 * decorator.borderWidth;
                    break;
                case "circle":
                    var rx = size.width / 2;
                    var ry = size.height / 2;
                    attr = { "id": name, "rx": rx, "ry": ry, "cx": (point1.x + size.width / 2), "cy": (point1.y), "fill": decorator.fillColor, "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth };
                    shape = svg.ellipse(attr);
                    x = 0.5 * decorator.borderWidth;
                    break;
                case "diamond":
                    d = this._constructDiamond(point1, size, svg);
                    attr = { "id": name, "x": point1.x, "y": point1.y, "width": size.width, "height": size.height, "d": d, "fill": decorator.fillColor, "stroke": decorator.borderColor, "stroke-width": decorator.borderWidth };
                    shape = svg.path(attr);
                    x = 0.7 * decorator.borderWidth;
                    break;
                case "path":
                    d = ej.datavisualization.Diagram.Geometry.updatePath(point1.x, point1.y - size.height / 2, size.width, size.height, decorator.pathData, svg);
                    decorator._absolutePath = d;
                    attr = {
                        "id": name, "d": d
                    };
                    shape = svg.path(attr);
                    x = 0.5 * decorator.borderWidth;
                    break;
            }
            //apply translate matrix and rotate matrix here
            if (shape) {
                if (decorator.borderColor != "none") {
                    var angle = ej.datavisualization.Diagram.Geometry.findAngle(point1, point2);
                    var extra = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, angle, x);
                    shape.setAttribute("transform", "translate(" + extra.x + "," + extra.y + "),rotate(" + angle + " " + point1.x + " " + point1.y + ")");
                }
                else
                    shape.setAttribute("transform", "rotate(" + ej.datavisualization.Diagram.Geometry.findAngle(point1, point2) + " " + point1.x + " " + point1.y + ")");
            }
        },

        _constructArrow: function (point, size, isOpen) {
            var path = new ej.datavisualization.Diagram.Path();
            path.moveTo(point.x + size.width, point.y + size.height / 2);
            path.lineTo(point.x, point.y);
            path.lineTo(point.x + size.width, point.y - size.height / 2);
            if (!isOpen) {
                path.close();
            }
            return path.toString();
        },

        _constructDiamond: function (point, size, svg) {
            var path = new ej.datavisualization.Diagram.Path();
            path.moveTo(point.x + size.width, point.y);
            path.lineTo(point.x + size.width / 2, point.y + size.height / 2);
            path.lineTo(point.x, point.y);
            path.lineTo(point.x + size.width / 2, point.y - size.height / 2);
            path.lineTo(point.x + size.width, point.y);
            var d = path.toString();
            return d;
        },
        //#endregion

        //#region Render Label
        _addLabel: function (node, label, panel, diagram, index) {
            if (diagram && diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                var container = this._renderSVGLabel(node, label, diagram._svg, diagram);
                if (index != undefined) {
                    if (index != node.labels.length - 1 && !(index > node.labels.length - 1)) {
                        var currentLabel = node.labels[index];
                        if (currentLabel) {
                            var curLblElement = diagram._svg.document.getElementById(node.name + "_" + currentLabel.name + "_lblbg");
                            var labelBG = diagram._svg.document.getElementById(node.name + "_" + label.name + "_lblbg");
                            var labelEle = diagram._svg.document.getElementById(node.name + "_" + label.name);
                            if (curLblElement && labelBG)
                                curLblElement.parentNode.insertBefore(labelBG, curLblElement);
                            if (labelEle && labelEle)
                                curLblElement.parentNode.insertBefore(labelEle, curLblElement);
                        }
                    }
                }
            }
            else {
                var width, height, x, y;
                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                width = bounds.width;
                height = bounds.height;
                x = bounds.x; y = bounds.y;
                var element;
                var htmlLayer = panel.document.parentNode.getElementsByClassName("htmlLayer")[0];
                element = $(htmlLayer).children("#" + node.name)[0];
                var classname = node._type === "node" ? "ej-d-node" : (node._type === "group" ? "ej-d-group" : "ej-d-connector");
                ej.datavisualization.Diagram.Util.attr(element, { "id": node.name, "class": classname });
                var container = this._renderLabel(node, bounds, label, element, htmlLayer, panel, width, height, diagram);
                if (index != undefined) {
                    element.insertBefore(container, element.childNodes[index]);
                }
            }
        },
        _getCharBoundsValues: function (char, label, svg, node, index) {

            var attr = {
                "id": node.name + "_" + label.name + "temp",
                "class": "ej-d-label", "font-family": label.fontFamily,
                "font-size": 12,

            };
            var textElement = svg.text(attr);
            svg.document.appendChild(textElement);
            var tspan = svg.tspan({
                "id": node.name + "_" + label.name + "temp_snap"
            });
            tspan.textContent = char;
            textElement.appendChild(tspan);
            var normal = textElement.childNodes[0].getComputedTextLength();

            attr["font-style"] = "normal";
            attr["font-weight"] = "bold";
            svg.text(attr);
            var bold = textElement.childNodes[0].getComputedTextLength();

            attr["font-style"] = "italic";
            attr["font-weight"] = "normal";
            svg.text(attr);
            var italic = textElement.childNodes[0].getComputedTextLength();

            attr["font-style"] = "italic";
            attr["font-weight"] = "bold";
            svg.text(attr);
            var boldItalic = textElement.childNodes[0].getComputedTextLength();
            svg.document.removeChild(textElement);
            if (char == " ") {
                var pre = label.text[index - 1] && label.text[index - 1] != "\n" ? label.text[index - 1] : "W";
                var next = label.text[index + 1] && label.text[index + 1] != "\n" ? label.text[index + 1] : "W";
                var forSpace1 = this._getCharBoundsValues(pre, label, svg, node, index);
                var forSpace2 = this._getCharBoundsValues(next, label, svg, node, index);
                var forSpace3 = this._getCharBoundsValues(pre + " " + next, label, svg, node, index);
                return {
                    normal: forSpace3.normal - (forSpace1.normal + forSpace2.normal),
                    bold: forSpace3.bold - (forSpace1.bold + forSpace2.bold),
                    italic: forSpace3.italic - (forSpace1.italic + forSpace2.italic),
                    boldItalic: forSpace3.boldItalic - (forSpace1.boldItalic + forSpace2.boldItalic)
                }
            }
            return {
                normal: normal, bold: bold, italic: italic, boldItalic: boldItalic
            }
            return Wbounds;
        },

        _updateHashTableValues: function (textSeries, fontTable, label, node, svg, diagram) {

            for (var j = 0; j < textSeries.length; j++) {
                if (!fontTable[textSeries[j]]) {
                    var cchar = textSeries[j] == "\n" ? "new_space_line" : textSeries[j];
                    fontTable[cchar] = this._getCharBoundsValues(textSeries[j], label, svg, node, j);
                }
            }
        },
        _updateHashTable: function (label, node, svg, diagram, isTextOverFlow) {
            if (label && svg && diagram) {
                if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.Wrap || isTextOverFlow) {
                    if (label.text != "" || label.hyperlink != "") {
                        var text = label.text ? label.text : label.hyperlink;
                        var fontTable = diagram._labelHashTable[label.fontFamily];
                        if (!fontTable)
                            fontTable = diagram._labelHashTable[label.fontFamily] = {};
                        this._updateHashTableValues(text, fontTable, label, node, svg, diagram)
                    }
                }
                else if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.WrapWithOverflow) {
                    var text = label.text ? label.text : label.hyperlink;
                    var newLines = text.split("\n");
                    for (var i = 0; i < newLines.length; i++) {
                        var newLine = newLines[i];
                        var textSeries = newLine.split(" ");
                        var fontTable = diagram._labelHashTable[label.fontFamily];
                        if (!fontTable)
                            fontTable = diagram._labelHashTable[label.fontFamily] = {};
                        this._updateHashTableValues(textSeries, fontTable, label, node, svg, diagram)
                    }
                    fontTable["new_space_line"] = this._getCharBoundsValues(" ", label, svg, node);
                }
            }
        },

        _getSuitableLabelSize: function (label, char, diagram) {
            char = (char == "\n" || char === ".") ? "new_space_line" : char;
            var hashChar = diagram._labelHashTable[label.fontFamily][char];
            if (label.bold && label.italic)
                return hashChar.boldItalic;
            if (label.bold)
                return hashChar.bold;
            if (label.italic)
                return hashChar.italic;
            else
                return hashChar.normal;
            return;
        },
        _postionConnectorTextElement: function (node, label, textElement, svg, diagram) {
            var x = 0;
            var y = 0;
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            var textBounds = textElement.getBBox();
            var wideTextBounds = this._getCharBoundsValues("W", label, svg, node);
            var hAlign = label.horizontalAlignment;
            var vAlign = label.verticalAlignment;
            var relatetiveMode = false;
            if (node.segments && label.relativeMode == "segmentpath") {
                var obj = this._getConnectorHandlePosition(label, node, 1, diagram);
                var pt = obj.position;
                x = pt.x;
                y = pt.y;
                var alignment = ej.datavisualization.Diagram.Util._alignLabelOnSegments(node, label, diagram, obj);
                vAlign = alignment.vAlign; hAlign = alignment.hAlign
                relatetiveMode = true;
                switch (hAlign) {
                    case "left":
                        x = x - textBounds.x + label.margin.left;
                        break;
                    case "right":
                        x = x - textBounds.width - label.margin.right;
                        break;
                    case "stretch":
                    case "center":
                        x = (x - (textBounds.width / 2)) + label.margin.left - label.margin.right;
                        break;
                }
                switch (vAlign) {
                    case "top":
                        y = y - textBounds.y + label.fontSize + label.margin.top;
                        break;
                    case "bottom":
                        y = y - textBounds.height + label.fontSize - label.margin.bottom;
                        break;
                    case "stretch":
                    case "center":
                        y = (y - (textBounds.height / 2)) + label.fontSize + label.margin.top - label.margin.bottom;
                        break;
                }
            }
            else {

                switch (hAlign) {
                    case "left":
                        x = nodeBounds.width / 2 + label.margin.left;
                        break;
                    case "right":
                        x = nodeBounds.width / 2 - textBounds.width + label.margin.right;
                        break;
                    case "stretch":
                    case "center":
                        x = (nodeBounds.width / 2) - (textBounds.width / 2) + label.margin.left - label.margin.right
                        break;
                }
                switch (vAlign) {
                    case "top":
                        y = nodeBounds.height / 2 + textBounds.height / 2 + label.margin.top;
                        break;
                    case "bottom":
                        y = nodeBounds.height / 2 - textBounds.height / 2 + label.margin.bottom;
                        break;
                    case "stretch":
                        y = (nodeBounds.height / 2) - (textBounds.height / 2) + label.margin.top - label.margin.bottom;
                        break;
                    case "center":
                        y = (nodeBounds.height / 2) - (textBounds.height / 2) + label.margin.top - label.margin.bottom;
                        break;
                }
                if (node.segments) {
                    x += nodeBounds.left;
                    y += nodeBounds.top;
                }
            }
            if (!label.relativeMode == "segmentpath") {
                x = x * (label.offset.x ? (label.offset.x / 0.5) : 0);
                y = y * (label.offset.y ? (label.offset.y / 0.5) : 0) + label.fontSize;
                var x = x + (nodeBounds.center.x - nodeBounds.width / 2);
                var y = y + (nodeBounds.center.y - nodeBounds.height / 2);
            }
            this._updateLabelBackground(x, y, textBounds, node, label, textElement, svg, diagram);
            if (node.segments && node.segments.length > 0) {
                textElement.setAttribute("transform", "translate(" + x + "," + y + ")");
            }
            else {
                textElement.setAttribute("transform", "translate(" + x + "," + y + ") rotate(" + label.rotateAngle + " " + (textBounds.x + (textBounds.width / 2)) + " " + (textBounds.y + (textBounds.height / 2)) + ")");
            }
        },

        _postionNodeTextElement: function (node, label, textElement, svg, diagram) {
            var x = 0;
            var y = 0;
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            var textBounds = textElement.getBBox();
            var wideTextBounds = this._getCharBoundsValues("W", label, svg, node);

            switch (label.horizontalAlignment) {
                case "left":
                    x = nodeBounds.width / 2 + label.margin.left;
                    break;
                case "right":
                    x = nodeBounds.width / 2 - textBounds.width;
                    break;
                case "stretch":
                    x = (nodeBounds.width / 2) - (textBounds.width / 2);
                    break;
                case "center":
                    x = ((nodeBounds.width / 2)) - (textBounds.width / 2);
                    break;
            }
            switch (label.verticalAlignment) {
                case "top":
                    y = nodeBounds.height / 2;
                    break;
                case "bottom":
                    y = nodeBounds.height / 2 - textBounds.height;
                    break;
                case "stretch":
                    y = (nodeBounds.height / 2) - (textBounds.height / 2);
                    break;
                case "center":
                    y = (nodeBounds.height / 2) - (textBounds.height / 2);
                    break;
            }
            x = x * (label.offset.x ? (label.offset.x / 0.5) : 0) + label.margin.left - label.margin.right
            y = y * (label.offset.y ? (label.offset.y / 0.5) : 0) + label.fontSize + label.margin.top - label.margin.bottom;

            this._updateLabelBackground(x, y, textBounds, node, label, textElement, svg, diagram);
            if (node.segments && node.segments.length > 0) {
                textElement.setAttribute("transform", "translate(" + (nodeBounds.center.x - (textBounds.width / 2)) + "," + (nodeBounds.center.y - (textBounds.height / 2) + label.fontSize) + ")");
            }
            else {
                if (node.type === "group" || (node.children && node.children.length > 0)) {
                    var pt = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
                    var width = node.width ? node.width : node._width;
                    var height = node.height ? node.height : node._height;
                    var x = x + (node.offsetX - node.width / 2);
                    var y = y + (node.offsetY - node.height / 2);
                    var angle = node.rotateAngle + label.rotateAngle;
                    textElement.setAttribute("transform", "rotate(" + angle + "," + pt.x + "," + pt.y + "),translate(" + x + "," + y + ")");
                }
                else
                    textElement.setAttribute("transform", "translate(" + x + "," + y + ") rotate(" + label.rotateAngle + " " + (textBounds.x + (textBounds.width / 2)) + " " + (textBounds.y + (textBounds.height / 2)) + ")");
            }
        },
        _postionSpanElement: function (node, label, textElement, svg, diagram) {
            for (var i = 0; i < textElement.childNodes.length; i++) {
                var child = textElement.childNodes[i];
                if (child) {
                    var position = this._getSVGTextAlignPosition(child, node, label, textElement, svg, diagram);
                    child.setAttribute("x", position.x);
                }
            }
        },
        _getSVGTextAlignPosition: function (child, node, label, textElement, svg, diagram) {
            var x = 0, y = 0;
            if (child && label) {
                var width = child.getAttribute("totalWidth");
                if (width)
                    width = Number(width);
                else
                    width = child.getComputedTextLength();
                var textBounds = textElement.getBBox();
                switch (label.textAlign) {
                    case "left":
                        x = (textBounds.x);
                        break;
                    case "right":
                        x = (textBounds.x + textBounds.width) - (width);
                        break;
                    case "center":
                    case "justify":
                        x = (textBounds.x + textBounds.width / 2) - (width / 2);
                        break;
                }
            }
            return {
                x: x, y: y
            };

        },
        _updateTspanElement: function (node, label, textElement, svg, diagram) {
            this._postionSpanElement(node, label, textElement, svg, diagram);
            if (node.segments && node.segments.length > 0)
                this._postionConnectorTextElement(node, label, textElement, svg, diagram);
            else
                this._postionNodeTextElement(node, label, textElement, svg, diagram);
        },
        _updateLabelBackground: function (x, y, textBounds, node, label, textElement, svg, diagram) {
            var height = label.verticalAlignment === "stretch" ? node.height - 2 : textBounds.height;
            var width = label.horizontalAlignment === "stretch" ? node.width - 2 : textBounds.width;
            x = label.horizontalAlignment === "stretch" ? 1 : x;
            y = label.verticalAlignment === "stretch" ? 1 : y - label.fontSize;
            var labelbg = $("#" + node.name + "_" + label.name + "_lblbg")[0];
            var attr = {
                id: node.name + "_" + label.name + "_lblbg",
                height: height, width: width,
                x: x, y: y,
                "transform": "rotate(" + label.rotateAngle + " " + (x + width / 2) + " " + (y + height / 2) + ")"
            };
            if (node.type === "group" || (node.children && node.children.length > 0)) {
                var pt = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
                var x = x + (node.offsetX - node.width / 2);
                var y = y + (node.offsetY - node.height / 2);
                var angle = node.rotateAngle + label.rotateAngle;
                attr.x = 0;
                attr.y = 0;
                attr.transform = "rotate(" + angle + "," + pt.x + "," + pt.y + "),translate(" + x + "," + y + ")";
            }
            svg.rect(attr);
        },
        _renderLabelSpanElement: function (textElement, node, label, svg, diagram, palette) {
            if (!label.templateId) {
                this._updateHashTable(label, node, svg, diagram);
                if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.Wrap) {
                    this._svgTextWrapping(textElement, node, label, svg, diagram, palette);
                }
                else if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.WrapWithOverflow) {
                    this._svgWordWrapping(textElement, node, label, svg, diagram, palette);
                }
                else {
                    var tspan = svg.tspan();
                    textElement.appendChild(tspan);
                    tspan.setAttribute("x", "0px");
                    tspan.setAttribute("y", "0px");
                    if (label.textOverflow) {
                        var labelSize = this._getLabelSize(label, node, diagram);
                        this._updateOverFlowTspan(textElement, node, label, svg, diagram, palette, label.text, tspan, labelSize)
                    }
                    else
                        tspan.textContent = label.text;

                }
                this._updateTspanElement(node, label, textElement, svg, diagram);
            }
        },
        _getLabelSize: function (label, node, diagram) {
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            return Math.max(label.width, bounds.width);
        },
        _svgTextWrapping: function (textElement, node, label, svg, diagram, palette) {
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            var tspan = svg.tspan();
            textElement.appendChild(tspan);
            tspan.setAttribute("x", "0px");
            tspan.setAttribute("y", "0px");
            var totawidth = 0
            var text = label.text ? label.text : label.hyperlink;
            tspan.textContent += text[0];
            var labelSize = this._getLabelSize(label, node, diagram);
            totawidth += (this._getSuitableLabelSize(label, text[0], diagram) * (label.fontSize / 12));
            for (var i = 1; i < text.length; i++) {
                if (text[i] == "\n" || totawidth + (this._getSuitableLabelSize(label, text[i], diagram) * (label.fontSize / 12)) >= labelSize) {
                    if (label.textOverflow) {
                        if (label.overflowType == "ellipsis") {
                            tspan.textContent = tspan.textContent.substr(0, tspan.textContent.length - 3);
                            tspan.textContent += "...";
                        }
                        return false;
                    }
                    else {
                        tspan.setAttribute("totalWidth", totawidth);
                        var tspan = svg.tspan();
                        textElement.appendChild(tspan);
                        var textElementBounds = textElement.getBBox();
                        tspan.setAttribute("x", "0px");
                        tspan.setAttribute("y", textElementBounds.height + "px");
                        if (text[i] != "\n") {
                            tspan.textContent += text[i];
                            totawidth = (this._getSuitableLabelSize(label, text[i], diagram) * (label.fontSize / 12));
                        }
                        else totawidth = 0;
                    }
                }
                else {
                    tspan.textContent += text[i];
                    totawidth += (this._getSuitableLabelSize(label, text[i], diagram) * (label.fontSize / 12));
                }
            }
        },
        _updateOverFlowTspan: function (textElement, node, label, svg, diagram, palette, newLine, tspan, labelSize) {
            var textSeries = newLine;
            this._updateHashTable(label, node, svg, diagram, true);
            var eTextWidth = 0, eText = "", eTspanText = "", eDotWidth = 0;
            if (label.overflowType == "ellipsis")
                eDotWidth = (this._getSuitableLabelSize(label, ".", diagram) * (label.fontSize / 12)) * 3;
            for (var e = 0; e < textSeries.length; e++) {
                eText = textSeries[e];
                eTextWidth += (this._getSuitableLabelSize(label, eText, diagram) * (label.fontSize / 12));
                if (eTextWidth + eDotWidth >= labelSize)
                    break;
                eTspanText += eText;
            }
            tspan.textContent = eTspanText + ((label.overflowType == "ellipsis") ? "..." : "");
        },
        _svgWordWrapping: function (textElement, node, label, svg, diagram, palette) {
            var nodeBounds, tspan, totawidth = 0, text;
            nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            var newLines = label.text ? label.text.split("\n") : label.hyperlink.split("\n");
            for (var i = 0; i < newLines.length; i++) {
                var textElementBounds = textElement.getBBox();
                var tspan = svg.tspan();
                textElement.appendChild(tspan);
                tspan.setAttribute("x", "0px");
                tspan.setAttribute("y", textElementBounds.height + "px");
                var newLine = newLines[i];
                totawidth = 0;
                var labelSize = this._getLabelSize(label, node, diagram);
                var textSeries = newLine.split(" ");
                for (var j = 0; j < textSeries.length; j++) {
                    //totawidth += (this._getSuitableLabelSize(label, "new_space_line", diagram) * (label.fontSize / 12));
                    if (totawidth + (this._getSuitableLabelSize(label, textSeries[j], diagram) * (label.fontSize / 12)) >= labelSize) {
                        if (label.textOverflow) {
                            this._updateOverFlowTspan(textElement, node, label, svg, diagram, palette, newLine, tspan, labelSize);
                            break;
                        }
                        else {
                            tspan.setAttribute("totalWidth", totawidth);
                            var tspan = svg.tspan();
                            textElement.appendChild(tspan);
                            var textElementBounds = textElement.getBBox();
                            tspan.setAttribute("x", "0px");
                            tspan.setAttribute("y", textElementBounds.height + "px");
                            if (textSeries[j] != "\n") {
                                tspan.textContent += textSeries[j];
                                totawidth = (this._getSuitableLabelSize(label, textSeries[j], diagram) * (label.fontSize / 12));
                            }
                            else totawidth = 0;
                        }
                    }
                    else {
                        if (totawidth)
                            tspan.textContent += " ";
                        tspan.textContent += textSeries[j];
                        totawidth += (this._getSuitableLabelSize(label, textSeries[j], diagram) * (label.fontSize / 12));
                    }
                }
            }
        },
        _renderSVGLabel: function (node, label, svg, diagram, palette) {
            var nodeElement = svg.getElementById(node.name);
            if (label.templateId && label.templateType === ej.datavisualization.Diagram.TemplateType.Svg) {
                var html = diagram._renderEjTemplate("#" + label.templateId, label);
                var div = document.createElement('div');
                div.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg"><g class="ej-label-template" id=' + node.name + "_" + label.name + '>' + html + '</g></svg>';
                document.body.appendChild(div);
                var content = document.getElementById(node.name + "_" + label.name).cloneNode(true);
                nodeElement.appendChild(content);
                div.parentNode.removeChild(div);
                this._updateSVGTemplate(node, label, svg, diagram, palette);
            }
            else {
                var attr = {
                    "id": node.name + "_" + label.name + "_lblbg",
                    "fill": node._isHeader ? "transparent" : label.fillColor,
                    "stroke": label.borderColor, "stroke-width": label.borderWidth,
                    "pointer-events": "none",
                    "visibility": label.visible ? "visible" : "hidden",
                    "fill-opacity": label.opacity,
                    "stroke-opacity": label.opacity,
                };

                var background = svg.rect(attr);
                nodeElement.appendChild(background);
                attr = {
                    "id": node.name + "_" + label.name,
                    "class": "ej-d-label", "font-family": label.fontFamily,
                    "font-size": label.fontSize,
                    "fill": label.hyperlink !== "" ? "blue" : label.fontColor,
                    "text-decoration": label.hyperlink !== "" ? "underline" : label.textDecoration,
                    "font-weight": label.bold ? "bold" : "normal",
                    "font-style": label.italic ? "italic" : "normal",
                    "visibility": label.visible ? "visible" : "hidden",
                    "fill-opacity": label.opacity,
                    "stroke-opacity": label.opacity,
                };
                this._addCssClass(label, attr);
                if (label.hyperlink) {
                    var anchor = document.createElementNS("http://www.w3.org/2000/svg", "a");
                    anchor.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", label.hyperlink);
                    anchor.setAttribute("target", '_blank');
                    anchor.setAttribute("class", "ej-d-anchor");
                    var textElement = svg.text(attr);
                    anchor.appendChild(textElement);
                    nodeElement.appendChild(anchor);
                }
                else {
                    var textElement = svg.text(attr);
                    nodeElement.appendChild(textElement);
                }
                this._renderLabelSpanElement(textElement, node, label, svg, diagram, palette);
            }
            return nodeElement;
        },
        _renderSVGLabels: function (node, svg, diagram, palette) {
            if (node.labels.length && node.type != "text") {
                var labels = node.labels;
                for (var i = 0; i < labels.length; i++) {
                    this._renderSVGLabel(node, labels[i], svg, diagram, palette);
                }
            }
        },
        _updateLabelSpanElement: function (node, label, svg, diagram, palette) {
            var textElement = svg.getElementById(node.name + "_" + label.name);
            if (node.textBlock)
                textElement = svg.getElementById(node.name + "_shape_lblbg");
            if (textElement) {
                $(textElement).empty();
                this._updateHashTable(label, node, svg, diagram);
                if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.Wrap) {
                    this._svgTextWrapping(textElement, node, label, svg, diagram, palette);
                }
                else if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.WrapWithOverflow) {
                    this._svgWordWrapping(textElement, node, label, svg, diagram, palette);
                }
                else {
                    var tspan = svg.tspan();
                    textElement.appendChild(tspan);
                    tspan.setAttribute("x", "0px");
                    tspan.setAttribute("y", "0px");
                    if (label.textOverflow) {
                        var labelSize = this._getLabelSize(label, node, diagram);
                        this._updateOverFlowTspan(textElement, node, label, svg, diagram, palette, label.text, tspan, labelSize)
                    }
                    else
                        tspan.textContent = label.text;
                }
                this._updateTspanElement(node, label, textElement, svg, diagram);
            }
        },
        _updateSVGTemplate: function (node, label, svg, diagram, palette) {

            var x = 0;
            var y = 0;
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            var templateElement = svg.document.getElementById(node.name + "_" + label.name)
            if (templateElement) {
                var templateBounds = templateElement.getBBox();
                if (node.segments && label.relativeMode == "segmentpath") {

                    var obj = this._getConnectorHandlePosition(label, node, 1, diagram);
                    var pt = obj.position;
                    x = pt.x;
                    y = pt.y;
                    var alignment = ej.datavisualization.Diagram.Util._alignLabelOnSegments(node, label, diagram, obj);
                    var vAlign = alignment.vAlign; var hAlign = alignment.hAlign
                    var relatetiveMode = true;
                    switch (hAlign) {
                        case "left":
                            x = x - templateBounds.x + label.margin.left;
                            break;
                        case "right":
                            x = x - templateBounds.width - label.margin.right;
                            break;
                        case "stretch":
                        case "center":
                            x = (x - (templateBounds.width / 2)) + label.margin.left - label.margin.right;
                            break;
                    }
                    switch (vAlign) {
                        case "top":
                            y = y - templateBounds.y + label.margin.top;
                            break;
                        case "bottom":
                            y = y - templateBounds.height + label.margin.bottom;
                            break;
                        case "stretch":
                        case "center":
                            y = (y - (templateBounds.height / 2)) + label.margin.top - label.margin.bottom;
                            break;
                    }
                }
                else {
                    switch (label.horizontalAlignment) {
                        case "left":
                            x = nodeBounds.width / 2 + label.margin.left;
                            break;
                        case "right":
                            x = nodeBounds.width / 2 - templateBounds.width;
                            break;
                        case "stretch":
                            x = (nodeBounds.width / 2) - (templateBounds.width / 2);
                            break;
                        case "center":
                            x = ((nodeBounds.width / 2)) - (templateBounds.width / 2);
                            break;
                    }
                    switch (label.verticalAlignment) {
                        case "top":
                            y = nodeBounds.height / 2;
                            break;
                        case "bottom":
                            y = nodeBounds.height / 2 - templateBounds.height;
                            break;
                        case "stretch":
                            y = (nodeBounds.height / 2) - (templateBounds.height / 2);
                            break;
                        case "center":
                            y = (nodeBounds.height / 2) - (templateBounds.height / 2);
                            break;
                    }
                    x = x * (label.offset.x ? (label.offset.x / 0.5) : 0) + label.margin.left - label.margin.right
                    y = y * (label.offset.y ? (label.offset.y / 0.5) : 0) + label.margin.top - label.margin.bottom;
                    if (node.segments) {
                        x += nodeBounds.left;
                        y += nodeBounds.top;
                    }
                }
                templateElement.setAttribute("transform", "translate(" + x + "," + y + ")");
            }
        },
        _updateSVGLabel: function (node, label, svg, diagram, palette) {
            if (label.templateId) {
                this._updateSVGTemplate(node, label, svg, diagram, palette);
            }
            else {
                var attr = {
                    "id": node.name + "_" + label.name,
                    "class": "ej-d-label", "font-family": label.fontFamily,
                    "font-size": label.fontSize,
                    "fill": label.hyperlink !== "" ? "blue" : label.fontColor,
                    "text-decoration": label.hyperlink !== "" ? "underline" : label.textDecoration,
                };
                svg.text(attr);
                this._updateLabelSpanElement(node, label, svg, diagram, palette);
            }
        },
        _updateSVGLabels: function (node, svg, diagram, palette) {
            if (node.labels.length && node.type != "text") {
                var labels = node.labels;
                for (var i = 0; i < labels.length; i++) {
                    this._updateSVGLabel(node, labels[i], svg, diagram, palette);
                }
            }
        },
        _renderLabels: function (node, svg, diagram, palette) {
            if (diagram && diagram.model.labelRenderingMode != ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                if (node.labels.length && node.type != "text") {

                    var labels = node.labels;
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    var width, height, x, y;
                    var element;
                    var isEleCreated = false;
                    for (var i = 0; i < labels.length; i++) {
                        if (node.labels[i].hyperlink && !node.labels[i].text)
                            this._renderSVGLabel(node, node.labels[i], svg, diagram, palette);
                        else {
                            if (!isEleCreated) {
                                isEleCreated = true;
                                var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                                element = $(htmlLayer).children("#" + node.name)[0];
                                if (element) htmlLayer.removeChild(element);
                                element = document.createElement("div");
                                if (!node.segments) {
                                    width = node.width ? node.width : node._width;
                                    height = node.height ? node.height : node._height;
                                    x = node.offsetX - width * node.pivot.x;
                                    y = node.offsetY - height * node.pivot.y;
                                }
                                else {
                                    width = bounds.width;
                                    height = bounds.height;
                                    x = bounds.x; y = bounds.y;
                                }
                                if (palette) {
                                    x = 0;
                                    y = 0;
                                }
                                var visibility = node.visible ? "visible" : "hidden";
                                var style = "width:" + width + "px; height:" + height + "px; left:" + x + "px; top:" + y + "px; display: block; position: absolute; pointer-events: none; " + "visibility:" + visibility + "; padding: inherit;";
                                var class1 = node._type === "node" ? "ej-d-node" : (node._type === "group" ? "ej-d-group" : "ej-d-connector");
                                if (node._isClassifier)
                                    class1 += " " + "ej-d-classifier";
                                ej.datavisualization.Diagram.Util.attr(element, {
                                    "id": node.name, "class": class1, "style": style
                                });
                                if (node.rotateAngle) {
                                    element.style.webkitTransform = "rotate(" + node.rotateAngle + "deg) ";
                                    element.style.MozTransform = "rotate(" + node.rotateAngle + "deg) ";
                                    element.style.OTransform = "rotate(" + node.rotateAngle + "deg) ";
                                    element.style.msTransform = "rotate(" + node.rotateAngle + "deg)";
                                    element.style.transform = "rotate(" + node.rotateAngle + "deg) ";
                                    element.style["transform-origin"] = node.pivot.x * 100 + "% " + node.pivot.y * 100 + "%";

                                }
                                if (htmlLayer) htmlLayer.appendChild(element);
                            }
                            this._renderLabel(node, bounds, labels[i], element, htmlLayer, svg, width, height, diagram)
                        }
                    }
                }
            }
            else {
                this._renderSVGLabels(node, svg, diagram, palette);
            }
        },
        _isParentVisible: function (name, svg) {
            var nodeEle = svg.document.getElementById(name);
            while (nodeEle && (nodeEle.getAttribute("class") != "DiagramLayer" || nodeEle.localName && nodeEle.localName !== "svg")) {
                if (nodeEle.localName && nodeEle.localName !== "svg")
                    break;
                if (nodeEle && (nodeEle.getAttribute("visibility") !== "visible"))
                    return true;
                nodeEle = nodeEle.parentNode;
            }
        },


        _renderLabel: function (node, nodeBounds, label, element, htmlLayer, svg, width, height, diagram) {
            var container = document.createElement("div");
            var text = document.createElement("span");
            if (label.templateId)
                var html = diagram._renderEjTemplate("#" + label.templateId, label);
            if (svg.document && svg.document.getAttribute("class") === "overview_svg")
                ej.datavisualization.Diagram.Util.attr(text, this._addCssClass(label, { "id": node.name + "_" + label.name, "class": "ej-d-label", "style": "display: inline-block; position: absolute; line-height: normal; pointer-events: none" }));
            else {
                var enabled = ej.datavisualization.Diagram.Util.canEnablePointerEvents(node, diagram);
                var class1 = "ej-d-label"
                if (node._isClassifier)
                    class1 += " " + "ej-d-classifier"
                ej.datavisualization.Diagram.Util.attr(text, this._addCssClass(label, { "id": node.name + "_" + label.name, "class": class1, "style": "display: inline-block; position: absolute; line-height: normal; pointer-events:" + (enabled ? "all" : "none") }));
            }
            if (label.horizontalAlignment == "stretch" || label.verticalAlignment == "stretch") {
                var actualDimensions = this._rotateLabel(width, height, label);
                if (label.horizontalAlignment == "stretch") text.style.width = Math.abs(actualDimensions.x) + "px";
                if (label.verticalAlignment == "stretch") {
                    text.style.alignItems = "center"; text.style.display = "flex"; text.style.justifyContent = "center"; text.style.height = Math.abs(actualDimensions.y) + "px";
                }
                if (label.textOverflow) {
                    text.style.display = "inline-block"
                    if (label.rotateAngle == 0 && node._isHeader) {
                        text.style.top = (Math.abs(actualDimensions.y) / 2 - label.fontSize / 2) + "px"
                        text.style.left = "0px"
                    }
                    else if (node._isHeader) {
                        text.style.left = (Math.abs(actualDimensions.y) / 2 - label.fontSize / 2) + "px"
                        text.style.top = "0px"
                    }
                }
            }
            if (label.bold) text.style.fontWeight = "bold";
            if (label.italic) text.style.fontStyle = "italic";
            if (!label.visible || this._isParentVisible(node.name, svg)) text.style.visibility = "hidden";
            text.style.opacity = label.opacity;
            text.style.textDecoration = label.textDecoration;
            text.style.fontFamily = label.fontFamily;
            text.style.fontSize = label.fontSize + "px";
            text.style.color = label.fontColor;
            text.style.backgroundColor = label.fillColor;
            text.style.borderColor = label.borderColor;
            text.style.borderWidth = label.borderWidth + "px";
            if (node._isHeader) {
                text.style.borderWidth = 0 + "px";
                text.style.backgroundColor = "transparent";
            }
            text.style.borderStyle = "solid";
            text.textContent = label.text;
            width = width > label.width ? width : label.width;
            height = height > label.height ? height : label.height;
            if (label.margin.left && label.margin.right) width -= (label.margin.left || 0) + (label.margin.right || 0);
            if (label.margin.top && label.margin.bottom) height -= (label.margin.top || 0) + (label.margin.bottom || 0);
            var style = "display: inline-block; position: absolute; pointer-events: none; " + "width:" + width + "px;height:" + height + "px;";
            ej.datavisualization.Diagram.Util.attr(container, { "id": node.name + "_" + label.name + "_lblbg", "style": style });
            if (!label.templateId) {
                container.appendChild(text);
                element.appendChild(container);
                this._alignTextOnLabel(node, nodeBounds, text, container, label, diagram, templateDiv);
            }
            if (label.templateId) {
                var templateDiv = document.createElement("div");
                templateDiv.setAttribute("class", "ej-label-template")
                templateDiv.innerHTML = html;
                container.appendChild(templateDiv);
                element.appendChild(container);
                var marginX, marginY;
                templateDiv.style.position = "absolute";
                this._alignTextOnLabel(node, nodeBounds, templateDiv, container, label, diagram);
            }

            return container;
        },

        _findChild: function (childNodes, node) {
            var length = childNodes.length;
            for (var i = 0; i < length; i++) {
                if (childNodes[i].id == node.name) {
                    return childNodes[i];
                }
            }
        },
        _updateLabels: function (node, svg, diagram) {
            if (diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                this._updateSVGLabels(node, svg, diagram);
            }
            else if (node.labels && node.labels.length && node.type != "text") {
                var labels = node.labels;
                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                var width, height, x, y;
                var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                if (htmlLayer) {
                    var parent = htmlLayer.childNodes[node.zOrder];
                    if (!parent || parent.id != node.name) {
                        var childNodes = htmlLayer.childNodes;
                        parent = this._findChild(childNodes, node, svg);
                    }
                }
                if (parent) {
                    if (!node.segments) {
                        width = node.width ? node.width : node._width;
                        height = node.height ? node.height : node._height;
                        x = node.offsetX - width * node.pivot.x;
                        y = node.offsetY - height * node.pivot.y;
                    }
                    else {
                        width = bounds.width; height = bounds.height;
                        x = bounds.x; y = bounds.y;
                    }
                    var visibility = node.visible ? "visible" : "hidden";
                    parent.style.width = width + "px";
                    parent.style.height = height + "px";
                    parent.style.left = x + "px";
                    parent.style.top = y + "px";
                    parent.style.opacity = node.opacity;
                    var transform = "rotate(" + node.rotateAngle + "deg) ";
                    var origin;
                    if (node.pivot)
                        origin = node.pivot.x * 100 + "% " + node.pivot.y * 100 + "%";
                    else
                        origin = 50 + "% " + 50 + "%";
                    parent.style.webkitTransform = transform;
                    parent.style.MozTransform = transform;
                    parent.style.OTransform = transform;
                    parent.style.msTransform = transform;
                    parent.style.transform = transform;
                    parent.style["transform-origin"] = parent.style["ms-transform-origin"] = parent.style["webkit-transform-origin"] =
                         parent.style["o-transform-origin"] = parent.style["moz-transform-origin"] = origin;
                    parent.style.visibility = visibility;
                }
                var textContainter, labelheight, labelwidth;
                for (var i = 0; i < labels.length; i++) {
                    if (node.labels[i].hyperlink && !node.labels[i].text)
                        this._updateSVGLabel(node, node.labels[i], svg, diagram);
                    else if (parent) {
                        var label = labels[i];
                        textContainter = parent.childNodes[i];
                        if (textContainter) {
                            var text = textContainter.childNodes[0];
                            if (label.text || text.textContent) {
                                labelwidth = width > label.width ? width : label.width;
                                if (label.margin.left && label.margin.right) labelwidth -= (label.margin.left || 0) + (label.margin.right || 0);
                                if (label.margin.top && label.margin.bottom) labelheight -= (label.margin.top || 0) + (label.margin.bottom || 0);
                                textContainter.style.height = labelheight + "px";
                                textContainter.style.width = labelwidth + "px";
                                if (!label.templateId)
                                    text.textContent = label.text;
                                if (label.horizontalAlignment == "stretch" || label.verticalAlignment == "stretch") {
                                    var actualDimensions = this._rotateLabel(width, height, label);
                                    if (label.horizontalAlignment == "stretch") text.style.width = Math.abs(actualDimensions.x) + "px";
                                    if (label.verticalAlignment == "stretch") {
                                        text.style.alignItems = "center"; text.style.display = "flex"; text.style.justifyContent = "center"; text.style.height = Math.abs(actualDimensions.y) + "px";
                                    }
                                    if (label.textOverflow)
                                        text.style.display = "inline-block";
                                }
                                this._alignTextOnLabel(node, bounds, text, textContainter, label, diagram);
                            }
                        }
                    }
                }


            }
        },

        _alignTextOnPhase: function (node, bounds, text, label, svg) {
            if (svg.getElementById(node.name))
                var phaseBounds = svg.getElementById(node.name).getBoundingClientRect();
            if (phaseBounds) {
                var textbounds = text.getBBox();
                var background = svg.getElementById(node.name + "_" + label.name + "_lblbg");
                text.setAttribute("transform", "translate(" + -textbounds.width / 2 + "," + 50 + "), rotate(" + 0 + "," + 0 + "," + 0 + ")");
                text.setAttribute("pointer-events", "auto");
                if (background) {
                    var attr = {
                        "width": textbounds.width, "height": textbounds.height, "fill": label.fillColor,
                        "stroke": label.borderColor, "stroke-width": label.borderWidth,
                        "transform": "translate(" + -textbounds.width + "," + phaseBounds.top + "), rotate(" + 0 + "," + 0 + "," + 0 + ")"
                    };
                    ej.datavisualization.Diagram.Util.attr(background, attr);
                }
            }
        },

        updateLabel: function (node, label, svg, diagram) {
            if (typeof label.text === "string") {
                var textContainter, labelheight, labelwidth, width, height;
                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                var htmlLayer = svg.document.parentNode.getElementsByClassName("htmlLayer")[0] || diagram._htmlLayer;
                var parent = $(htmlLayer).children("#" + node.name)[0];
                if (!node.segments) {
                    width = node.width ? node.width : node._width;
                    height = node.height ? node.height : node._height;
                }
                else {
                    width = bounds.width; height = bounds.height;
                }
                textContainter = $(parent).children("#" + node.name + "_" + label.name + "_lblbg")[0];
                if (textContainter) {
                    var text = textContainter.childNodes[0];
                    labelwidth = width > label.width ? width : label.width;
                    if (label.margin.left && label.margin.right) labelwidth -= (label.margin.left || 0) + (label.margin.right || 0);
                    if (label.margin.top && label.margin.bottom) labelheight -= (label.margin.top || 0) + (label.margin.bottom || 0);
                    textContainter.style.height = labelheight + "px";
                    textContainter.style.width = labelwidth + "px";
                    if (!label.templateId)
                        text.textContent = label.text;
                    text.style.opacity = label.opacity;
                    if (label.horizontalAlignment == "stretch" || label.verticalAlignment == "stretch") {
                        var actualDimensions = this._rotateLabel(width, height, label);
                        if (label.horizontalAlignment == "stretch") text.style.width = Math.abs(actualDimensions.x) + "px";
                        if (label.verticalAlignment == "stretch") {
                            text.style.alignItems = "center"; text.style.display = "flex"; text.style.justifyContent = "center"; text.style.height = Math.abs(actualDimensions.y) + "px";
                        }
                        if (label.textOverflow)
                            text.style.display = "inline-block";
                    } if (node.type == "node" && !node.width && !node.height)
                        this.updateNode(node, svg, diagram);
                    this._alignTextOnLabel(node, bounds, text, textContainter, label, diagram);
                }
                else {
                    this._updateLabelSpanElement(node, label, svg, diagram);
                }
            }
        },

        _alignTextOnLabel: function (node, nodeBounds, text, textContainter, label, diagram) {
            var actualDimensions, hAlign, vAlign;
            if (node.segments && label.relativeMode == "segmentpath") {
                var obj = this._getConnectorHandlePosition(label, node, 1, diagram);
                var pt = obj.position;
                var offset = {
                    x: (pt.x - nodeBounds.x) / nodeBounds.width,
                    y: (pt.y - nodeBounds.y) / nodeBounds.height
                };
                var alignment = ej.datavisualization.Diagram.Util._alignLabelOnSegments(node, label, diagram, obj);
                vAlign = alignment.vAlign; hAlign = alignment.hAlign;
            }
            else {
                var offset = { x: label.offset.x, y: label.offset.y };
                hAlign = label.horizontalAlignment;
                vAlign = label.verticalAlignment;
            }
            if (!ej.datavisualization.Diagram.Util.canEnablePointerEvents(node, diagram))
                text.style["pointer-events"] = "none";
            else if (diagram && diagram.activeTool && diagram.activeTool.name === "move" && diagram.activeTool.inAction)
                text.style["pointer-events"] = "none";
            else
                text.style["pointer-events"] = "all";
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            width -= label.margin.left + label.margin.right;
            height -= label.margin.top + label.margin.bottom;
            actualDimensions = { x: width, y: height };
            if (label.textOverflow) {
                text.style.textOverflow = label.overflowType;
                text.style.overflow = "hidden";
                text.style.whiteSpace = "nowrap";
                text.style.width = width + "px";
            }
            if (label.rotateAngle) {
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, label.rotateAngle, offset.x, offset.y);
                actualDimensions = ej.Matrix.transform(matrix, { x: width, y: height });
            }
            var x = 0, y = 0, marginX, marginY;
            var canMoveLabel = ej.datavisualization.Diagram.Util.canMoveLabel(node);
            if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.NoWrap) {
                text.style.whiteSpace = "nowrap";
                text.style.wordWrap = "normal";
                text.style.maxWidth = "";
                text.style.maxHeight = "";
            }
            else {
                if (!label.templateId) {
                    if (!label.textOverflow) {
                        if (label.textAlign != "justify")
                            text.style.whiteSpace = "pre-wrap";
                        else text.style.whiteSpace = "pre-line";
                    }
                    if (label.wrapping == ej.datavisualization.Diagram.TextWrapping.Wrap) {
                        text.style.wordBreak = "break-all";
                        text.style.wordWrap = "break-word";
                        if (!node.segments) {
                            if (Math.abs(actualDimensions.x) < label.width) actualDimensions.x = label.width;
                            text.style.maxWidth = Math.abs(actualDimensions.x) + "px";
                            text.style.maxHeight = Math.abs(actualDimensions.y) + "px";
                        }
                        else text.style.maxWidth = Math.abs(label.width) + "px";
                    }
                    else {
                        text.style.wordWrap = "break-word";
                        text.style.maxWidth = "";
                        text.style.maxHeight = "";
                    }
                }
            }
            switch (hAlign) {
                case ej.datavisualization.Diagram.HorizontalAlignment.Left:
                    x = "0%";
                    marginX = label.margin.left + "px";
                    break;
                case ej.datavisualization.Diagram.HorizontalAlignment.Center:
                    x = "-50%";
                    marginX = label.margin.left - label.margin.right + "px";
                    break;
                case ej.datavisualization.Diagram.HorizontalAlignment.Right:
                    x = "-100%";
                    marginX = -label.margin.right + "px";
                    break;
                case ej.datavisualization.Diagram.HorizontalAlignment.Stretch:
                    x = "-50%";
                    break;
            }
            switch (vAlign) {
                case ej.datavisualization.Diagram.VerticalAlignment.Top:
                    y = "0%";
                    marginY = label.margin.top + "px";
                    break;
                case ej.datavisualization.Diagram.VerticalAlignment.Center:
                    y = "-50%";
                    marginY = label.margin.top - label.margin.bottom + "px";
                    break;
                case ej.datavisualization.Diagram.VerticalAlignment.Bottom:
                    y = "-100%";
                    marginY = -label.margin.bottom + "px";
                    break;
                case ej.datavisualization.Diagram.VerticalAlignment.Stretch:
                    y = "-50%";
                    break;
            }
            if (label.margin.left && label.margin.right && label.margin.top && label.margin.bottom && !node._isClassifier && !node._isClassMember) {
                text.style.marginLeft = marginX;
                text.style.marginTop = marginY;
            }
            else {
                textContainter.style.marginLeft = marginX;
                textContainter.style.marginTop = marginY;
            }
            offset.x *= 100;
            offset.y *= 100;
            text.style.textAlign = label.textAlign;
            text.style.webkitTransform = "translate(" + x + ", " + y + ") rotate(" + label.rotateAngle + "deg)";
            text.style.MozTransform = "translate(" + x + ", " + y + ") rotate(" + label.rotateAngle + "deg)";
            text.style.OTransform = "translate(" + x + ", " + y + ") rotate(" + label.rotateAngle + "deg)";
            text.style.msTransform = "translate(" + x + ", " + y + ") rotate(" + label.rotateAngle + "deg)";
            text.style.transform = "translate(" + x + ", " + y + ") rotate(" + label.rotateAngle + "deg)";

            if (label.horizontalAlignment != "stretch" && label.verticalAlignment != "stretch" && !(label.templateId)) {
                text.style.left = "0px";
                text.style.top = "0px";
            }
            if (textContainter) {
                textContainter.style.left = offset.x + "%";
                textContainter.style.top = offset.y + "%";
            }
        },

        _rotateLabel: function (width, height, label) {
            var actualDimensions = { x: width, y: height };
            if (label.rotateAngle) {
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, label.rotateAngle, 0, 0);
                actualDimensions = ej.Matrix.transform(matrix, { x: width, y: height });
            }
            return actualDimensions;
        },
        _renderLabelGroup: function (node, svg, diagram) {
            if (node._type == "group") {
                for (var i = 0; i < node.children.length; i++) {
                    var child = diagram.nameTable[diagram._getChild(node.children[i])];
                    if (child._type == "group")
                        this._renderLabelGroup(child, svg, diagram);
                    else
                        this._renderLabelsAsSvg(child, svg, diagram);
                }
                this._renderLabelsAsSvg(node, svg, diagram);
            }
        },
        //#region Render labels as svg
        _renderLabelsAsSvg: function (node, svg, diagram) {
            var g = svg.document.getElementById(node.name);
            if (node.type == "text") {
                this._renderTextElementAsSvg(node, node.textBlock, g, svg, diagram);
            } else {
                for (var i = 0; i < node.labels.length; i++) {
                    this._renderTextElementAsSvg(node, node.labels[i], g, svg, diagram);
                }
            }
        },
        _renderTextElementAsSvg: function (node, label, g, svg, diagram) {
            var attr = {
                "id": node.name + "_" + label.name, "class": "ej-d-label", "font-family": label.fontFamily,
                "font-size": label.fontSize, "fill": label.fontColor, "text-decoration": label.textDecoration, "visibility": label.visible ? "visible" : "hidden",
                "pointer-events": "none"
            };
            if (label.bold)
                attr["font-weight"] = "bold";
            if (label.italic)
                attr["font-style"] = "italic";
            var text = svg.text(attr);
            text.setAttributeNS("http://www.w3.org/XML/1998/namespace", "xml:space", "preserve");
            text.textContent = label.text;
            attr = {
                "id": node.name + "_" + label.name + "_lblbg",
                "fill": label.fillColor,
                "stroke": label.borderColor, "stroke-width": label.borderWidth, "transform": "translate(" + 0 + "," + 0 + ")"
            };
            var bg = svg.rect(attr);
            if (!label.text)
                return;
            g.appendChild(text);
            g.insertBefore(bg, text);
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            var labelRotate = false;
            if (node._isHeader && label.rotateAngle) {
                if (diagram) {
                    var lane = diagram.nameTable[node.parent];
                    if (lane && lane.isLane) {
                        labelRotate = true;
                    }
                    var phaseStack = diagram.nameTable[node.parent];
                    if (phaseStack && phaseStack.isPhaseStack && !node.orientation == "vertical") {
                        labelRotate = true;
                    }
                }
            }

            this._wrapText(node, bounds, text, label, svg, labelRotate);
            this._alignTextOnSvgLabel(node, bounds, text, label, svg, diagram, labelRotate);
        },

        _alignTextOnSvgLabel: function (node, nodeBounds, text, label, svg, diagram, labelRotate) {
            var bounds = text.getBBox();
            var offset = ej.datavisualization.Diagram.Util._getLabelPosition(label, nodeBounds);
            if (labelRotate) {
                bounds = ej.datavisualization.Diagram.Util._rBounds(bounds, label.rotateAngle);
                offset = ej.datavisualization.Diagram.Util._getLabelPosition(label, nodeBounds, null, null, labelRotate, text);
            }
            if (labelRotate)
                point = offset;
            else
                var point = this._adjustOffsetWithTextBounds(node, label, text, offset, bounds, nodeBounds, diagram);
            var bWidth = label.borderWidth || 0;
            text.setAttribute("transform", "translate(" + (point.x + bWidth) + "," + (point.y + bWidth) + "), rotate(" + label.rotateAngle + "," + (offset.x - point.x) + "," + (offset.y - point.y) + ")");
            //Updates the label background
            var background = svg.getElementById(node.name + "_" + label.name + "_lblbg");
            if (background) {
                var x = point.x + bounds.x;
                var y = point.y;
                if (ej.browserInfo().name === "mozilla")
                    y = point.y + label.fontSize / 2;
                x = x + bWidth / 2;
                y = y + bWidth / 2;
                var attr = {
                    "width": bounds.width + bWidth, "height": bounds.height + bWidth, "transform": "translate(" + x + "," + y + "), rotate(" + label.rotateAngle + "," + (offset.x - x) + "," + (offset.y - y) + ")", "fill": label.fillColor ? label.fillColor : "transparent",
                    "stroke": label.borderColor, "stroke-width": label.borderWidth
                };
                if (labelRotate)
                    attr["fill"] = "transparent";
                ej.datavisualization.Diagram.Util.attr(background, attr);
            }
        },
        _adjustOffsetWithTextBounds: function (node, label, text, offset, bounds, nodeBounds, diagram) {
            var point = { x: 0, y: 0 };
            var y = 0;
            var vAlign, hAlign;
            if (node.segments && label.relativeMode === "segmentpath") {
                var obj = this._getConnectorHandlePosition(label, node, 1, diagram);
                var pt = obj.position;
                var ptt = {
                    x: (pt.x - nodeBounds.x) / nodeBounds.width,
                    y: (pt.y - nodeBounds.y) / nodeBounds.height
                };
                ptt = ej.datavisualization.Diagram.Util._getLabelPosition(label, nodeBounds, ptt);
                offset.x = ptt.x;
                offset.y = ptt.y;
                var alignment = ej.datavisualization.Diagram.Util._alignLabelOnSegments(node, label, diagram, obj);
                hAlign = alignment.hAlign;
                vAlign = alignment.vAlign;
            }
            else {
                hAlign = label.horizontalAlignment;
                vAlign = label.verticalAlignment;
            }
            if (vAlign == ej.datavisualization.Diagram.VerticalAlignment.Top)
                y = offset.y;
            else if (vAlign == ej.datavisualization.Diagram.VerticalAlignment.Center)
                y = offset.y - bounds.height / 2;
            else if (vAlign == ej.datavisualization.Diagram.VerticalAlignment.Bottom)
                y = offset.y - bounds.height;
            else if (vAlign == ej.datavisualization.Diagram.VerticalAlignment.Stretch)
                y = offset.y - bounds.height / 2;
            point.y = y;
            if (label.textAlign == "justify") {
                if (text.childNodes.length > 1) {
                    {
                        point.x = offset.x - node.width / 2;
                    }
                }
                else {
                    point.x = offset.x;
                }
            }
            else {
                switch (hAlign) {
                    case ej.datavisualization.Diagram.HorizontalAlignment.Left:
                        switch (label.textAlign) {
                            case ej.datavisualization.Diagram.TextAlign.Left:
                                point.x = offset.x;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Center:
                                point.x = offset.x + bounds.width / 2;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Right:
                                point.x = offset.x + bounds.width;
                                break;
                        }
                        break;
                    case ej.datavisualization.Diagram.HorizontalAlignment.Center:
                        switch (label.textAlign) {
                            case ej.datavisualization.Diagram.TextAlign.Left:
                                point.x = offset.x - bounds.width / 2;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Center:
                                point.x = offset.x;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Right:
                                point.x = offset.x + bounds.width / 2;
                                break;
                        }
                        break;
                    case ej.datavisualization.Diagram.HorizontalAlignment.Right:
                        switch (label.textAlign) {
                            case ej.datavisualization.Diagram.TextAlign.Left:
                                point.x = offset.x - bounds.width;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Center:
                                point.x = offset.x - bounds.width / 2;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Right:
                                point.x = offset.x;
                                break;
                        }
                        break;
                    case ej.datavisualization.Diagram.HorizontalAlignment.Stretch:
                        switch (label.textAlign) {
                            case ej.datavisualization.Diagram.TextAlign.Left:
                                point.x = offset.x - nodeBounds.width / 2;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Center:
                                point.x = offset.x;
                                break;
                            case ej.datavisualization.Diagram.TextAlign.Right:
                                point.x = offset.x + nodeBounds.width / 2;
                                break;
                        }
                        break;
                }
            }
            if (node.segments || node._type == "group") {
                point.x = point.x + nodeBounds.x;
                point.y = point.y + nodeBounds.y;
                offset.x += nodeBounds.x;
                offset.y += nodeBounds.y;
            }
            if (ej.browserInfo().name === "mozilla")
                point.y = point.y - label.fontSize / 2;
            return point;
        },

        _wrapText: function (node, textBBox, text, label, svg, labelRotate) {
            var str = label.text; var attr = null;
            while (text.hasChildNodes()) {
                text.removeChild(text.lastChild);
            }
            var bbWidth, bbHeight;
            if (node.segments) {
                bbWidth = textBBox.width;
                bbHeight = textBBox.height;
            }
            else {
                bbWidth = textBBox.width - label.margin.left - label.margin.right;
                bbHeight = textBBox.height - label.margin.top - label.margin.bottom;
            }
            if (labelRotate) {
                var temp = bbWidth;
                bbWidth = bbHeight;
                bbHeight = temp;
            }
            bbWidth -= 2 * (label.borderWidth ? label.borderWidth : 1);
            bbWidth = bbWidth < label.width ? label.width : bbWidth;
            var eachLine = str.split('\n');
            var x, y, tspan, j, string = "", childNodes, bounds, i;
            if (svg.getElementById(text.id))
                childNodes = svg.getElementById(text.id).childNodes;
            if (childNodes) {
                var wrap = label.wrapping == "wrapwithoverflow" ? true : false;
                for (j = 0; j < eachLine.length; j++) {
                    tspan = svg.tspan();
                    tspan.style.fontSize = label.fontSize;
                    text.appendChild(tspan);
                    if (label.wrapping != "nowrap") {
                        var words = label.wrapping == "wrapwithoverflow" ? eachLine[j].split(" ") : eachLine[j];
                        for (i = 0; i < words.length; i++) {
                            tspan.textContent += ((txt && wrap) ? " " : "") + words[i];
                            bounds = childNodes[childNodes.length - 1].getComputedTextLength();
                            if (bounds >= bbWidth) {
                                if (!(i == words.length - 1)) {
                                    tspan = svg.tspan();
                                    text.appendChild(tspan);
                                    txt = "";
                                }
                            }
                            else {
                                if (wrap) {
                                    var txt = tspan.textContent;
                                    tspan.textContent += (words[i + 1] || "");
                                    var isEmptyLine = (i === words.length - 1 && words[i] == "") ? true : false;
                                    var length = (txt === " ") ? 1 : childNodes[childNodes.length - 1].getComputedTextLength();
                                    tspan.textContent = txt;
                                    if (length > bbWidth || isEmptyLine) {
                                        tspan = svg.tspan();
                                        if (!isEmptyLine)
                                        text.appendChild(tspan);
                                        txt = "";
                                    }
                                }
                            }
                        }

                    }
                    else tspan.textContent += eachLine[j];
                }
                this._wrapTextAlign(text, childNodes, label.fontSize, label.textAlign, node, label, svg);
            }
        },
        _getTSpanLength: function (tspan, label, svg, node) {
            var length = 0;
            if (tspan && tspan.textContent) {
                for (var i = 0; i < tspan.textContent.length; i++) {
                    length += this._getCharBoundsValues(tspan.textContent[i], label, svg, node).bold
                }
            }
            return length;
        },
        _wrapTextAlign: function (text, childNodes, height, textAlign, node, label, svg) {
            var x, difspace, wordSpacing, txt, prevHeight, prevX = null, def = 2, removeChild = [], tspan;
            for (var i = 0; i < childNodes.length; i++) {
                var tspan = childNodes[i];
                if (textAlign == "justify" && i != childNodes.length - 1) {
                    txt = tspan.textContent;
                    if (txt[txt.length - 1] == " ") {
                        txt = txt.slice(0, txt.length - 1);
                    } if (txt[0] == " ") {
                        txt = txt.slice(1, txt.length);
                    }
                    tspan.textContent = txt;
                    x = tspan.getComputedTextLength();
                    difspace = node.width - x;
                    wordSpacing = difspace / (txt.split(" ").length - 1);
                    tspan.setAttribute("word-spacing", wordSpacing + "px");
                    x = tspan.getComputedTextLength();
                }
                else {
                    var length = this._getTSpanLength(tspan, label, svg, node)
                    x = length ? length : tspan.getComputedTextLength();

                }
                if (textAlign == "justify") {
                    childNodes.length > 1 ? textAlign = "left" : textAlign = "center";
                }
                switch (textAlign) {
                    case "left":
                        x = 0;
                        break;
                    case "center":
                        x = -x / 2;
                        break;
                    case "right":
                        x = -x;
                        break;
                }
                var attr = {
                    "x": Number(x), "dy": def > 2 ? (height * def) : height
                };
                if (x == 0) {
                    def++;
                }
                else def = 2;
                ej.datavisualization.Diagram.Util.attr(tspan, attr);
            }
        },
        //#endregion

        //#region Render Port
        _renderPorts: function (node, svg, g) {
            var ports = node.ports;
            var port;
            for (var i = 0, len = ports.length; i < len; ++i) {
                port = ports[i];
                var shape = this._renderPort(node, port, svg);
                g.appendChild(shape);
            }
        },

        _renderPort: function (node, port, svg) {
            var shape;
            var attr, visibility;
            var size = ej.datavisualization.Diagram.Size(port.size, port.size);
            var point;
            if (port.visibility & ej.datavisualization.Diagram.PortVisibility.Hidden || port.visibility & ej.datavisualization.Diagram.PortVisibility.Hover || port.visibility & ej.datavisualization.Diagram.PortVisibility.Connect)
                visibility = "hidden";
            else
                visibility = "visible";
            if (node._type === "group")
                point = ej.datavisualization.Diagram.Util._getPortPosition(port, ej.datavisualization.Diagram.Util.bounds(node, true), false);
            else
                point = ej.datavisualization.Diagram.Util._getPortPosition(port, ej.datavisualization.Diagram.Util.bounds(node, true), true);
            if (node._type === "group" && node.rotateAngle) {
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                point = ej.Matrix.transform(matrix, point);
                port._absolutePoint = point;
            }
            switch (port.shape) {
                case "x":
                    var d = this._constructX(point, port.size);
                    attr = {
                        "id": node.name + "_" + port.name, "class": "ej-d-port", "fill": port.fillColor, "visibility": visibility,
                        "stroke": port.borderColor, "stroke-width": port.borderWidth, "d": d
                    };
                    this._addCssClass(port, attr);
                    shape = svg.path(attr);
                    break;
                case "circle":
                    var rx = size.width / 2;
                    var ry = size.height / 2;
                    attr = {
                        "id": node.name + "_" + port.name, "class": "ej-d-port", "rx": rx, "ry": ry, "visibility": visibility,
                        "cx": point.x, "cy": point.y, "fill": port.fillColor, "stroke": port.borderColor,
                        "stroke-width": port.borderWidth
                    };
                    this._addCssClass(port, attr);
                    shape = svg.ellipse(attr);
                    break;
                case "square":
                    attr = {
                        "id": node.name + "_" + port.name, "class": "ej-d-port", "x": point.x - port.size / 2, "visibility": visibility,
                        "y": point.y - port.size / 2, "width": size.width, "height": size.height,
                        "fill": port.fillColor, "stroke": port.borderColor, "stroke-width": port.borderWidth
                    };
                    this._addCssClass(port, attr);
                    shape = svg.rect(attr);
                    break;
                case "path":
                    var width = size.width;
                    var height = size.height;
                    var d = port._absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(point.x - port.size / 2, point.y - port.size / 2, width, height, port.pathData, svg);
                    var attr = {
                        "id": node.name + "_" + port.name, "width": width,
                        "height": height, "d": d, "stroke": port.borderColor,
                        "stroke-width": port.borderWidth, "fill": port.fillColor, "visibility": visibility

                    };
                    this._addCssClass(port, attr);
                    shape = svg.path(attr);
                    break;
            }
            return shape;
        },
        _insertPort: function (node, port, svg) {
            var g;
            g = document.getElementById(node.name);
            var portshape = ej.datavisualization.Diagram.SvgContext._renderPort(node, port, svg);
            g.appendChild(portshape);
            if (port.visibility & ej.datavisualization.Diagram.PortVisibility.Hidden || port.visibility & ej.datavisualization.Diagram.PortVisibility.Hover || port.visibility & ej.datavisualization.Diagram.PortVisibility.Connect) {
                portshape.setAttribute("visibility", "hidden");
            }

        },
        _updatePort: function (node, port, svg) {
            var size = ej.datavisualization.Diagram.Size(port.size, port.size);
            var point = null;
            if (node._type === "group")
                point = ej.datavisualization.Diagram.Util._getPortPosition(port, ej.datavisualization.Diagram.Util.bounds(node, true), false);
            else
                point = ej.datavisualization.Diagram.Util._getPortPosition(port, ej.datavisualization.Diagram.Util.bounds(node, true), true);
            var id = node.name + "_" + port.name;
            if (node._type === "group" && node.rotateAngle) {
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                point = ej.Matrix.transform(matrix, point);
                port._absolutePoint = point;
            }
            switch (port.shape) {
                case "x": var d = this._constructX(point, port.size);
                    svg.path({ "id": id, "d": d });
                    break;
                case "circle":
                    var rx = size.width / 2;
                    var ry = size.height / 2;
                    if (node.type === "group") {
                        svg.ellipse({ "id": id, "rx": rx, "ry": ry, "cx": 0, "cy": 0, "transform": "rotate(" + node.rotateAngle + "," + (point.x) + "," + (point.y) + "),translate(" + (point.x) + "," + (point.y) + ")" });
                    }
                    else
                        svg.ellipse({ "id": id, "rx": rx, "ry": ry, "cx": point.x, "cy": point.y });
                    break;
                case "square":
                    if (node.type === "group") {
                        svg.rect({ "id": id, "x": 0, "y": 0, "transform": "rotate(" + node.rotateAngle + "," + (point.x) + "," + (point.y) + "),translate(" + (point.x - port.size / 2) + "," + (point.y - port.size / 2) + ")" });
                    }
                    else
                        svg.rect({ "id": id, "x": point.x - port.size / 2, "y": point.y - port.size / 2 });
                    break;
                case "path":
                    var width = size.width;
                    var height = size.height;
                    var d = port._absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(point.x - port.size / 2, point.y - port.size / 2, width, height, port.pathData, svg);
                    var attr = {
                        "id": id, "d": d
                    };
                    if (node.type === "group") {
                        attr = {
                            "id": id, "d": d, "transform": "rotate(" + node.rotateAngle + "," + (point.x) + "," + (point.y) + ")"
                        };
                    }
                    svg.path(attr);
                    break;
            }
        },

        _updatePorts: function (node, svg) {
            var ports = node.ports;
            for (var i = 0, len = ports.length; i < len; ++i) {
                var port = ports[i];
                this._updatePort(node, port, svg);
            }
        },

        _constructX: function (point, size) {
            var path = new ej.datavisualization.Diagram.Path();
            path.moveTo((point.x - size / 2), (point.y - size / 2));
            path.lineTo((point.x + size / 2), (point.y + size / 2));
            path.moveTo((point.x + size / 2), (point.y - size / 2));
            path.lineTo((point.x - size / 2), (point.y + size / 2));
            return path.toString();
        },
        _enableSelectedNode: function (node, svg, diagram) {
            if (node) {
                if (node.type == "pseudoGroup") {
                    var children = node.children;
                    for (var i = 0, len = children.length; i < len; i++) {
                        var child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child)
                            this._enableSelectedNode(child, svg, diagram);
                    }
                } else {
                    var attr = {
                        "id": node.name,
                        "pointer-events": "auto",
                        "style": "pointer-events:block",
                    }
                    if (node.segments) {
                        var element = svg.document.getElementById(node.name + "_hitTest");
                        if (element)
                            element.setAttribute("pointer-events", node.visible ? "stroke" : "none");
                    }
                    svg.g(attr);
                }

                if (node && node.type === "html") {
                    var htmlLayer = diagram._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                    if (htmlLayer)
                        var htmlnode = $(htmlLayer).find("#" + node.name + "_parentdiv")[0];
                    if (htmlnode) {
                        htmlnode.style.pointerEvents = "all";
                        var html = htmlnode.children[0];
                        if (html) {
                            html.style.pointerEvents = "all";
                        }
                    }
                }

                if (diagram._adornerSvg) {
                    var selector = diagram._adornerSvg.document.getElementById(diagram._adornerSvg.document.id + "handle_g");
                    if (selector) selector.setAttribute("pointer-events", "visible");
                }
                $(".ej-d-seperator").css("pointer-events", "stroke");
                $(".e-resize").css("pointer-events", "visible");
                $(".s-resize").css("pointer-events", "visible");
            }
        },
        _disableSelectedNode: function (node, svg, diagram) {
            if (node) {
                if (node.type == "pseudoGroup") {
                    var children = node.children;
                    for (var i = 0, len = children.length; i < len; i++) {
                        var child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child)
                            this._disableSelectedNode(child, svg, diagram);
                    }
                } else {
                    var attr = {
                        "id": node.name,
                        "style": "pointer-events:none",
                        "pointer-events": "none",
                    }
                    if (node.segments) {
                        var element = svg.document.getElementById(node.name + "_hitTest");
                        element.setAttribute("pointer-events", "none");
                    }
                    svg.g(attr);
                }
                if (diagram._adornerSvg) {
                    var selector = diagram._adornerSvg.document.getElementById(diagram._adornerSvg.document.id + "handle_g");
                    if (selector) selector.setAttribute("pointer-events", "none");
                }

                if (node && node.type === "html") {
                    var htmlLayer = diagram._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                    if (htmlLayer)
                        var htmlnode = $(htmlLayer).find("#" + node.name + "_parentdiv")[0];
                    if (htmlnode) {
                        htmlnode.style.pointerEvents = "none";
                        var html = htmlnode.children[0];
                        if (html) {
                            html.style.pointerEvents = "none";
                        }
                    }
                }

                $(".e-resize").css("pointer-events", "none");
                $(".ej-d-seperator").css("pointer-events", "none");
                $(".s-resize").css("pointer-events", "none");
            }
        },

        _drawStackHighlighter: function (node, svg, parent, scale, currentPoint, isVertcal) {
            var nPoint, points = [];
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            if (isVertcal) {
                if (currentPoint.y >= bounds.y && currentPoint.y < bounds.center.y) {
                    points.push({ x: bounds.topLeft.x * scale - 5, y: bounds.topLeft.y * scale - 5 });
                    points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
                    points.push({ x: bounds.topLeft.x * scale - 5, y: bounds.topLeft.y * scale + 5 });
                    points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
                    points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
                    points.push({ x: bounds.topRight.x * scale + 5, y: bounds.topRight.y * scale - 5 });
                    points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
                    points.push({ x: bounds.topRight.x * scale + 5, y: bounds.topRight.y * scale + 5 });
                    points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
                }
                else {
                    points.push({ x: bounds.bottomLeft.x * scale - 5, y: bounds.bottomLeft.y * scale - 5 });
                    points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
                    points.push({ x: bounds.bottomLeft.x * scale - 5, y: bounds.bottomLeft.y * scale + 5 });
                    points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale + 5, y: bounds.bottomRight.y * scale - 5 });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale + 5, y: bounds.bottomRight.y * scale + 5 });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                }
            }
            else {
                if (currentPoint.x >= bounds.x && currentPoint.x < bounds.center.x) {
                    points.push({ x: bounds.topLeft.x * scale - 5, y: (bounds.topLeft.y) * scale - 5 });
                    points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
                    points.push({ x: bounds.topLeft.x * scale + 5, y: (bounds.topLeft.y) * scale - 5 });
                    points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
                    points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
                    points.push({ x: bounds.bottomLeft.x * scale - 5, y: bounds.bottomLeft.y * scale + 5 });
                    points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
                    points.push({ x: bounds.bottomLeft.x * scale + 5, y: bounds.bottomLeft.y * scale + 5 });
                    points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
                    points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
                }
                else {
                    points.push({ x: bounds.topRight.x * scale - 5, y: bounds.topRight.y * scale - 5 });
                    points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
                    points.push({ x: bounds.topRight.x * scale + 5, y: (bounds.topRight.y) * scale - 5 });
                    points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale - 5, y: (bounds.bottomRight.y) * scale + 5 });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale + 5, y: (bounds.bottomRight.y) * scale + 5 });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                    points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
                }

            }
            var nPoint = this._convertToSVGPoints(points);
            var attr = {
                "id": "nodeHighlighter",
                "points": nPoint,
                "fill": "transparent",
                "stroke": "red",
                "stroke-width": 2,
                "pointer-events": "none",
                "style": "pointer-events: none",
            };
            var line = svg.polyline(attr);
            parent.appendChild(line);
            return line;
        },

        _drawNodeHighlighter: function (node, svg, parent, scale) {
            var shape;
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var x = node.offsetX - width * node.pivot.x;
            var y = node.offsetY - height * node.pivot.y;
            var center = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
            var transform = "rotate(" + node.rotateAngle + "," + center.x * scale + "," + center.y * scale + ")";
            var stroke = node.isLane || node.isSwimlane ? "red" : "#0dc923";
            var attr = {
                "id": "nodeHighlighter",
                "class": "ej-d-node",
                "x": x * scale,
                "y": y * scale,
                "width": width * scale,
                "height": height * scale,
                "fill": "transparent",
                "stroke": stroke,
                "stroke-width": 2,
                "pointer-events": "none",
                "transform": transform,
                "style": "pointer-events: none",
            };
            shape = svg.rect(attr);
            parent.appendChild(shape);
            return shape;
        },

        _drawNavigationHighlighter: function (bounds, svg, parent, scale) {
            var attr = {
                "id": "nodeHighlighter", "x": bounds.x * scale, "y": bounds.y * scale, "width": bounds.width * scale, "height": bounds.height * scale,
                "fill": "transparent", "stroke": "black", "stroke-dasharray": "2 2", "shape-rendering": "crispEdges", "style": "pointer-events: none"
            }
            parent.appendChild(svg.rect(attr));
        },
        _removeNodeHighlighter: function (svg, parent) {
            var highlighter = svg.getElementById("nodeHighlighter");
            if (highlighter) {
                svg.removeChild(highlighter, parent);
            }
        },
        _drawPortHighlighter: function (port, node, svg, parent, scale) {
            var shape, size, point, x, y, transform;
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var bounds;
            var fill = "#8CC63F";
            var border = "#1A1A1A";
            var borderWidth = 0.5;
            if (!port) {
                bounds = ej.datavisualization.Diagram.Util.bounds(node, true);
                size = ej.datavisualization.Diagram.Size(bounds.width, bounds.height);
                point = ej.datavisualization.Diagram.Point(bounds.x, bounds.y);
                x = point.x * scale;
                y = point.y * scale;
                border = fill;
                fill = "transparent";
                borderWidth = 2;
                var center = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
                transform = "rotate(" + node.rotateAngle + "," + center.x * scale + "," + center.y * scale + ")";
            }
            else {
                size = ej.datavisualization.Diagram.Size(port.size * 2, port.size * 2);
                point = ej.datavisualization.Diagram.Util._getPortPosition(port, ej.datavisualization.Diagram.Util.bounds(node, true));
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, node.rotateAngle, node.offsetX, node.offsetY);
                point = ej.Matrix.transform(matrix, point);
                x = (point.x - port.size) * scale;
                y = (point.y - port.size) * scale;
                transform = "rotate(" + 0 + "," + (x + size.width / 2) + "," + (y + size.height / 2) + ")";
            }
            var attr = {
                "id": "portHighlighter", "class": "ej-d-port", "x": x,
                "y": y, "width": size.width * scale, "height": size.height * scale,
                "fill": fill, "stroke": border, "stroke-width": borderWidth, "pointer-events": "none", "transform": transform
            };
            shape = svg.rect(attr);
            parent.appendChild(shape);
            return shape;
        },

        _drawConnectorHighlighter: function (connector, diagram, scale) {
            var svg = diagram._adornerSvg;
            var g = svg.g({ "id": "connector_highlighter", "visibility": "visible", transform: "scale(" + scale + ")" });
            diagram._adornerLayer.appendChild(g);
            var path = this._findPath(connector, diagram);
            var attr = {
                "id": "highlighter_segments",
                "d": path, "fill": "none", "stroke": "#0dc923",
                "stroke-width": connector.lineWidth, "pointer-events": "none"
            };
            var line = svg.path(attr);
            g.appendChild(line);
            return g;
        },

        _removeConnectorHighlighter: function (parent, svg) {
            var highlighter = svg.getElementById("connector_highlighter");
            if (highlighter) {
                parent.removeChild(highlighter);
            }
        },
        _removePortHighlighter: function (svg, parent) {
            var highlighter = svg.getElementById("portHighlighter");
            if (highlighter) {
                svg.removeChild(highlighter, parent);
            }
        },

        _renderPhaseResize: function (shape, svg, scale, constraints, parent) {
            var nPoint, points = [];
            var clName = "", isHorizon = false, isVerti = false;
            var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
            //#region left
            nPoint, points = [];
            points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
            points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
            nPoint = this._convertToSVGPoints(points);
            var attr = {
                "id": "w-resize", "points": nPoint, "stroke-dasharray": "3,3", "fill": "transparent", "stroke": "red", "stroke-width": 2, "pointer-events": "none"
            };
            line = svg.polyline(attr);
            parent.appendChild(line);
            //#endregion  

            //#region Top
            nPoint, points = [];
            points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
            points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
            nPoint = this._convertToSVGPoints(points);
            var attr = {
                "id": "n-resize", "points": nPoint, "stroke-dasharray": "3,3", "fill": "transparent", "stroke": "red", "stroke-width": 2, "pointer-events": "none"
            };
            line = svg.polyline(attr);
            parent.appendChild(line);
            //#endregion 

            //#region right
            clName = "";
            if (shape.orientation == "vertical") {
                clName = "e-resize"
                isVerti = true;
            }
            nPoint, points = [];
            points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
            points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
            nPoint = this._convertToSVGPoints(points);
            if (isVerti) {
                attr = {
                    "id": "e-resize-hitTest", "class": clName, "points": nPoint, "fill": "transparent", "stroke": "transparent", "stroke-width": 10, "pointer-events": isVerti ? "stroke" : "none"
                };
                var line = svg.polyline(attr);
                parent.appendChild(line);
            }
            var attr = {
                "id": "e-resize", "class": clName, "points": nPoint, "stroke-dasharray": "3,3", "fill": "transparent", "stroke": "red", "stroke-width": 2, "pointer-events": isVerti ? "stroke" : "none"
            };
            line = svg.polyline(attr);
            parent.appendChild(line);
            //#endregion

            //#region bottom
            clName = "";
            if (shape.orientation == "horizontal") {
                clName = "s-resize"
                isHorizon = true;
            }
            nPoint, points = [];
            points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
            points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
            nPoint = this._convertToSVGPoints(points);
            if (isHorizon) {
                attr = {
                    "id": "s-resize-hitTest", "class": clName, "points": nPoint, "fill": "transparent", "stroke": "transparent", "stroke-width": 10, "pointer-events": isHorizon ? "stroke" : "none"
                };
                var line = svg.polyline(attr);
                parent.appendChild(line);
            }
            var attr = {
                "id": "s-resize", "class": clName, "points": nPoint, "stroke-dasharray": "3,3", "fill": "transparent", "stroke": "red", "stroke-width": 2, "pointer-events": isHorizon ? "stroke" : "none"
            };
            line = svg.polyline(attr);
            parent.appendChild(line);
            //#endregion
        },
        //#endregion

        //#region Render Selector

        renderSelector: function (shape, svg, parent, scale, constraints, bounds) {
            $(".phaseSelector").remove();
            var width = shape.width ? shape.width : shape._width;
            var height = shape.height ? shape.height : shape._height;
            if (shape.segments) {
                var g = svg.g({
                    "id": svg.document.id + "handle_g", "class": "handle", "pointer-events": "visible"
                });
                parent.appendChild(g);
                this._renderEndPointHandle(shape, svg, scale);
            }
            else if (shape.type != "phase") {
                if (!(shape.isLane || shape.isSwimlane)) {
                    var g = svg.g({
                        "id": svg.document.id + "handle_g", "class": "handle", "pointer-events": "visible",
                        "transform": "translate(" + (shape.offsetX - width * shape.pivot.x) * scale + "," + (shape.offsetY - height * shape.pivot.y) * scale + "),rotate(" + shape.rotateAngle + "," + (width * shape.pivot.x) * scale + "," + (height * shape.pivot.y) * scale + ")"
                    });
                    parent.appendChild(g);
                    this._renderResizeHandle(shape, svg, scale, constraints);
                }
                else {
                    var g = svg.g({
                        "id": svg.document.id + "handle_g", "class": "handle", "pointer-events": "visible"
                    });
                    parent.appendChild(g);
                    this._renderPhaseResize(shape, svg, scale, constraints, g, bounds);
                }
            }
            else if (shape.type == "phase" && bounds) {
                var g = svg.g({
                    "id": svg.document.id + "handle_g", "class": "handle", "pointer-events": "visible",
                    "transform": "translate(" + (bounds.x) * scale + "," + (bounds.y) * scale + "),rotate(0," + (bounds.width / 2) * scale + "," + (bounds.height / 2) * scale + ")"
                });
                if (!svg.document.getElementById(svg.document.id + "handle_g"))
                    parent.appendChild(g);
                var rect = svg.rect({
                    "id": "phaseSelector", "class": "phaseSelector",
                    "stroke-width": 2, "stroke-dasharray": "3,3", "pointer-events": "none",
                    "width": (bounds.width < 0) ? 1 : bounds.width * scale, "height": (bounds.height < 0) ? 1 : bounds.height * scale, "fill": "transparent", "stroke": "red",
                });
                g.appendChild(rect);
            }
        },

        _renderResizeHandle: function (node, svg, scale, constraints) {
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var pivot = node.pivot;
            var rotate = ej.datavisualization.Diagram.Point(width * pivot.x, -20 / scale);
            if (constraints & ej.datavisualization.Diagram.SelectorConstraints.Rotator && node.type != "umlclassifier") {
                this._renderPivotLine(node, svg, scale);
                this._renderRotateThumb("rotateHandle", node, rotate.x, rotate.y, scale, svg);
            }
            if (constraints & ej.datavisualization.Diagram.SelectorConstraints.Resizer) {
                this._renderResizeBorder("resizeBorder", node, svg, scale);
                if (node.type != "umlclassifier") {
                    this._renderResizeCorner("nw-resize", node, 0, 0, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest));
                    this._renderResizeCorner("n-resize", node, (width / 2) * scale, 0, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeNorth));
                    this._renderResizeCorner("ne-resize", node, width * scale, 0, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast));
                    this._renderResizeCorner("w-resize", node, 0, (height / 2) * scale, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeWest));
                    this._renderResizeCorner("e-resize", node, width * scale, (height / 2) * scale, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeEast));
                    this._renderResizeCorner("sw-resize", node, 0, height * scale, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest));
                    this._renderResizeCorner("s-resize", node, (width / 2) * scale, height * scale, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeSouth));
                    this._renderResizeCorner("se-resize", node, width * scale, height * scale, svg, !(node.constraints & ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast));
                }
            }
        },

        renderUserHandles: function (handles, shape, svg, isMultipleSelection, scale, parent, diagram) {
            if (shape) {
                if (shape.type === "phase" && diagram)
                    var bounds = diagram._getPhaseBounds(shape);
                if (handles.length) {
                    var g = svg.g({ "id": svg.document.id + "userHandle_g", "class": "userHandle", "pointer-events": "visible" });
                    parent.appendChild(g);
                    for (var handleIndex = 0; handleIndex < handles.length; handleIndex++) {
                        if ((isMultipleSelection && handles[handleIndex].enableMultiSelection) || !isMultipleSelection) {
                            this._renderUserHandle(handles[handleIndex], shape, svg, scale, g, bounds, diagram);
                        }
                    }
                }
            }
        },

        _renderUserHandle: function (handle, node, svg, scale, g, bounds, diagram) {
            var icon;
            var position = this._getHandlePosition(handle, node, scale, bounds, diagram);
            var x = position.x * scale;// - (node.segments ? 0 : handle.size / 4);
            var y = position.y * scale;// - (node.segments ? 0 : handle.size / 4)
            var shape = this._getHandleShape(handle, x, y);
            handle._size = handle.size;
            var circle = g.appendChild(svg.circle(shape));
            var titleattr = {
                "id": handle.name + "_title"
            };
            var title = svg.title(titleattr);
            title.innerHTML = handle.name;
            circle.appendChild(title);
            switch (handle.shape) {
                case "path":
                    var d = handle._absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(0, 0, handle.size / 2, handle.size / 2, handle.pathData, svg);
                    icon = this._getHandleIcon(handle, x - handle.size / 4, y - handle.size / 4);
                    icon["d"] = d;
                    g.appendChild(svg.path(icon));
                    break;
                case "image":
                    icon = this._getHandleIcon(handle, x - handle.size / 4, y - handle.size / 4);
                    icon["preserveAspectRatio"] = "none";
                    var image = new Image();
                    image.src = handle.source;
                    var imageshape = svg.image(icon);
                    imageshape.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", image.src);
                    g.appendChild(imageshape);
                    break;
                case "native":
                    var visible = handle.visible ? "visible" : "hidden";
                    icon = this._getHandleIcon(handle, x - handle.size / 4, y - handle.size / 4);
                    var html = diagram._renderEjTemplate("#" + handle.templateId, handle);
                    var div = document.createElement('div');
                    div.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg"><g id="tempNative">' + html + '</g></svg>';
                    document.body.appendChild(div);
                    var content = document.getElementById("tempNative").cloneNode(true);
                    content.id = handle.name + "_shape";
                    g.appendChild(content);
                    var bounds = content.getBBox();
                    var width = icon.width;
                    var height = icon.height;
                    var delwidth = bounds.width ? width / bounds.width : 1;
                    var delheight = bounds.height ? height / bounds.height : 1;
                    content.setAttribute("transform", "scale(" + delwidth + "," + delheight + ")");
                    div.parentNode.removeChild(div);
                    var nativecontent = svg.g(icon);
                    nativecontent.appendChild(content);
                    g.appendChild(nativecontent);
                    break;
            }
        },

        _getHandleIcon: function (handle, x, y) {
            var visible = handle.visible ? "visible" : "hidden";
            var icon = {
                "id": handle.name + "_icon", "class": "userHandle-icon", "fill": handle.pathColor, "transform": "translate(" + x + "," + y + ")",
                "visibility": visible, "width": handle.size / 2, "height": handle.size / 2
            };
            return icon;
        },

        _getHandlePosition: function (handle, node, scale, phsBounds, diagram) {
            if (node) {
                if (!node.segments || !handle.offset) {
                    var positionPoints = ej.datavisualization.Diagram.Point();
                    if (node.type === "phase" && phsBounds)
                        var bounds = ej.datavisualization.Diagram.Util.bounds(phsBounds);
                    else
                        var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    var position = handle.position;
                    var distance = 10;
                    var matrix = ej.Matrix.identity();
                    if (node.rotateAngle)
                        ej.Matrix.rotate(matrix, node.rotateAngle);
                    var point = new ej.datavisualization.Diagram.Point();
                    switch (position) {
                        case "topleft":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(distance + (handle.size / 2), distance + (handle.size / 2)));
                            positionPoints.x = bounds.topLeft.x - (point.x / scale);
                            positionPoints.y = bounds.topLeft.y - (point.y / scale);
                            break;
                        case "topcenter":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(0, distance + (handle.size / 2)));
                            positionPoints.x = bounds.topCenter.x - (point.x / scale);
                            positionPoints.y = bounds.topCenter.y - point.y / scale;
                            break;
                        case "topright":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(distance + (handle.size / 2), -(distance + (handle.size / 2))));
                            positionPoints.x = bounds.topRight.x + (point.x / scale);
                            positionPoints.y = bounds.topRight.y + (point.y / scale);
                            break;
                        case "middleleft":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(-(distance + (handle.size / 2)), 0));
                            positionPoints.x = bounds.middleLeft.x + (point.x / scale);
                            positionPoints.y = bounds.middleLeft.y + (point.y / scale);
                            break;
                        case "middleright":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(distance + (handle.size / 2), 0));
                            positionPoints.x = bounds.middleRight.x + (point.x / scale);
                            positionPoints.y = bounds.middleRight.y + (point.y / scale);
                            break;
                        case "bottomleft":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(-(distance + (handle.size / 2)), distance + (handle.size / 2)));
                            positionPoints.x = bounds.bottomLeft.x + (point.x / scale);
                            positionPoints.y = bounds.bottomLeft.y + (point.y / scale);
                            break;
                        case "bottomcenter":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(0, distance + (handle.size / 2)));
                            positionPoints.x = bounds.bottomCenter.x + (point.x / scale);
                            positionPoints.y = bounds.bottomCenter.y + (point.y / scale);
                            break;
                        case "bottomright":
                            point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(distance + (handle.size / 2), distance + (handle.size / 2)));
                            positionPoints.x = bounds.bottomRight.x + (point.x / scale);
                            positionPoints.y = bounds.bottomRight.y + (point.y / scale);
                            break;
                    }
                    return positionPoints;
                }
                else {
                    return this._getConnectorHandlePosition(handle, node, scale, diagram).position;
                }
            }
        },
        _getConnectorHandlePosition: function (handle, node, scale, diagram) {
            var length = 0;
            var position = ej.datavisualization.Diagram.Util._findOffsetOnConnector(node, handle, handle.segmentOffset, diagram);
            var i = position.segment;
            var j = position.point;
            var pt = position.offset;
            var targetSegment = node.segments[i]; var targetPoint = node.segments[i].points[j];
            var angle = ej.datavisualization.Diagram.Geometry.findAngle(targetPoint, node.segments[i].points[j + 1]);
            if (handle.alignment && handle.alignment != "auto") {
                if (handle.offset == 1) angle += 180;
                return {
                    position: ej.datavisualization.Diagram.Geometry.transform(position.offset, handle.offset != 0 && handle.offset != 1 ? angle + 45 : angle, this._getAlignedPosition(node, handle)), angle: angle
                };
            }
            else {
                //avoid overlapping
                var obj = this._avoidOverlapWithSourceAndTarget(node, handle.offset, handle.size, position.offset, angle, i, j, diagram);
                pt = {
                    position: obj.position, angle: handle.offset == 1 ? (180 + angle) % 360 : angle, direction: obj.direction
                };
            }
            return pt;
        },
        _getAlignedPosition: function (connector, handle) {
            var cnst = handle.text === undefined ? 10 : 0;
            switch (handle.alignment) {
                case "center":
                    return 0;
                case "before":
                    return -((handle.size || 0) / 2 + cnst);
                case "after":
                    return (handle.size || 0) / 2 + cnst;
            }
            return 0;
        },
        _avoidOverlapWithSourceAndTarget: function (connector, offset, size, position, angle, i, j, diagram) {
            var next, ang;
            var pt = position; var targetSegment = connector.segments[i];
            var cnst = 90;
            if (offset == 0) {
                next = connector.segments[i].points[j + 2] ? connector.segments[i].points[j + 2] : connector.segments[i + 1] ? connector.segments[i + 1].points[1] : null;
                if (next) {
                    ang = ej.datavisualization.Diagram.Geometry.findAngle(connector.segments[i].points[j], next);
                }
                if (connector.sourceNode) cnst = 45;
            }
            else if (offset == 1) {
                next = connector.segments[i].points[j - 1] ? connector.segments[i].points[j - 1] : connector.segments[i - 1] ? connector.segments[i - 1][connector.segments[i].points.length - 2] : null;
                if (next) {
                    ang = ej.datavisualization.Diagram.Geometry.findAngle(connector.segments[i].points[j + 1], next);
                }
                angle += 180;
                angle %= 360;
                if (connector.targetNode) cnst = 45;
            }
            if (next) {
                if (angle % 90 == 0) {
                    var direction;
                    if (ang > 270 && angle == 0) angle = 360;
                    if (angle == 90) {
                        if (ang < angle) {
                            angle += cnst; direction = "right";
                        }
                        else {
                            angle -= cnst; direction = "left";
                        }
                    }
                    else if (angle == 270) {
                        if (ang < angle) {
                            angle += cnst; direction = "left";
                        }
                        else {
                            angle -= cnst; direction = "right";
                        }
                    }
                    else if (angle == 180) {
                        if (ang < angle) {
                            angle += cnst; direction = "bottom";
                        }
                        else {
                            angle -= cnst; direction = "top";
                        }
                    }
                    else {
                        if (ang < angle) {
                            angle += cnst; direction = "top";
                        }
                        else {
                            angle -= cnst; direction = "bottom";
                        }
                    }
                    pt = ej.datavisualization.Diagram.Geometry.transform(pt, angle, size != undefined ? Math.max(5, size / 2 + 10) : 0);
                } else {
                    var fourty5 = 45;
                    var one35 = 135;
                    var two25 = 225;
                    var three15 = 315;
                    var bounds;
                    if (offset == 0 && connector.sourceNode || offset == 1 && connector.targetNode) {
                        var source = offset == 0 && connector.sourceNode ? diagram.nameTable[connector.sourceNode] : diagram.nameTable[connector.targetNode];
                        if (source) bounds = ej.datavisualization.Diagram.Util.bounds(source);
                        if (bounds) {
                            var part = 180 / (2 + 2 / (bounds.height / bounds.width));
                            fourty5 = part;
                            one35 = (180 - part);
                            two25 = one35 + (2 * part);
                            three15 = 360 - part;
                        }
                    }
                    if (angle >= fourty5 && angle <= one35 || angle >= two25 && angle <= three15) cnst = angle % 180 > 90 ? -cnst : cnst;
                    else if (angle > one35 && angle < two25) angle > 180 ? cnst = -45 : cnst = 45;
                    else angle > 0 ? cnst = -45 : cnst = 45;
                    pt = ej.datavisualization.Diagram.Geometry.transform(pt, angle + cnst, size != undefined ? Math.max(5, size / 2 + 10) : 0);
                }
            } else {
                var fourty5 = 45;
                var one35 = 135;
                var two25 = 225;
                var three15 = 315;
                var bounds;
                if (offset == 0 && connector.sourceNode || offset == 1 && connector.targetNode) {
                    var source = offset == 0 && connector.sourceNode ? diagram.nameTable[connector.sourceNode] : diagram.nameTable[connector.targetNode];
                    if (source) bounds = ej.datavisualization.Diagram.Util.bounds(source);
                    if (bounds) {
                        var part = 180 / (2 + 2 / (bounds.height / bounds.width));
                        fourty5 = part;
                        one35 = (180 - part);
                        two25 = one35 + (2 * part);
                        three15 = 360 - part;
                    }
                }
                if (angle >= fourty5 && angle <= one35 || angle >= two25 && angle <= three15) cnst = angle % 180 > 90 ? -cnst : cnst;
                else if (angle > one35 && angle < two25) angle > 180 ? cnst = -45 : cnst = 45;
                else angle <= fourty5 ? cnst = -45 : cnst = 45;
                angle += 360;
                angle %= 360;
                pt = ej.datavisualization.Diagram.Geometry.transform(pt, angle + cnst, size != undefined ? Math.max(5, size / 2 + (Math.abs(cnst % 45) > 0 ? 13 : 10)) : 0);
            }
            return {
                position: pt, direction: direction
            };
        },
        _getHandleShape: function (handle, cx, cy) {
            var visible = handle.visible ? "visible" : "hidden";
            var shape = {
                "id": handle.name + "_shape", "class": "userHandle", "cx": cx, "cy": cy, "r": handle.size / 2, "fill": handle.backgroundColor,
                "stroke": handle.borderColor, "stroke-width": handle.borderWidth || 0,
                "visibility": visible
            };
            return shape;
        },

        _updateHandleShape: function (handle, cx, cy, svg) {
            var visible = handle.visible ? "visible" : "hidden";
            var attr = {
                "id": handle.name + "_shape", "cx": cx, "cy": cy, "r": handle.size / 2, "fill": handle.backgroundColor,
                "stroke": handle.borderColor, "stroke-width": handle.borderWidth || 0, "visibility": visible
            };
            svg.circle(attr);
        },

        _updateHanleIcon: function (handle, d, svg, x, y) {
            var visible = handle.visible ? "visible" : "hidden";
            var attr = { "id": handle.name + "_icon", "d": d, "fill": handle.pathColor, "transform": "translate(" + x + "," + y + ")", "visibility": visible };
            svg.path(attr);
        },

        _getHanleIcon: function (handle, d, cx, cy) {
            var icon = {
                "id": handle.name, "d": d, "stroke": handle.borderColor,
                "stroke-width": handle.borderWidth, "fill": handle.fillColor
            };
            return icon;
        },

        renderPivotPoint: function (node, scale, svg) {
            var x = node.width * node.pivot.x;
            var y = node.height * node.pivot.y;
            if (!svg.getElementById("pivot")) {
                ej.datavisualization.Diagram.SvgContext._renderResizeCorner("pivot", node,
                      x * scale, y * scale, svg, undefined, 4);
            }
            else ej.datavisualization.Diagram.SvgContext._updateResizeCorner("pivot",
                      x * scale, y * scale, svg);
            this._updatePivotLine(node, svg, scale, true);
        },

        _removePivotPoint: function (node, svg, scale) {
            var pivot = svg.getElementById("pivot");
            if (pivot) {
                pivot.parentNode.removeChild(pivot);
                this._updatePivotLine(node, svg, scale, false);
            }
        },

        _renderPivotLine: function (node, svg, scale) {
            if (!node.container) {
                var width = node.width ? node.width : node._width;
                var height = node.height ? node.height : node._height;
                var rotateThumb = ej.datavisualization.Diagram.Point(width * node.pivot.x, -20 / scale);
                var pivot = ej.datavisualization.Diagram.Point(width * node.pivot.x, 0);
                var handle = svg.getElementById(svg.document.id + "handle_g");
                var line = svg.line({
                    "id": "pivotLine", "x1": rotateThumb.x * scale, "y1": rotateThumb.y * scale, "x2": pivot.x * scale, "y2": pivot.y * scale,
                    "stroke": "black", "stroke-width": 1, "stroke-dasharray": "2,3", "fill": "none"
                });
                handle.appendChild(line);
            }
        },

        _renderResizeBorder: function (id, node, svg, scale) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            if (node.type == "umlclassifier")
                var rect = ej.datavisualization.Diagram.ClassifierHelper.renderResizeBorder(id, node, svg, scale);
            else {
                var rect = svg.rect({
                    "id": id, "class": "resizeRect", "width": width * scale, "height": height * scale, "stroke": "#097F7F", "stroke-width": 0.6, "stroke-dasharray": "6,3", "fill": "none", "pointer-events": "none"
                });
            }
            handle.appendChild(rect);
        },

        _renderResizeCorner: function (corner, node, cx, cy, svg, state, r) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            var pEvnts;
            var fill = "white";
            if (!(ej.datavisualization.Diagram.Util.canResize(node))) {
                fill = "darkgray";
            }
            if (state) {
                fill = "darkgray";
                pEvnts = "none";
            }
            var attr = { "id": corner, "class": "resizeCorners", "fill": fill, "stroke": "black", "stroke-width": 1, "cx": cx, "cy": cy, "r": r || 7 };
            handle.appendChild(svg.circle(attr));
            attr = { "id": corner + "_transparent", "class": corner, "fill": "transparent", "cx": cx, "cy": cy, "r": r || 10 };
            if (pEvnts) attr["pointer-events"] = pEvnts;
            handle.appendChild(svg.circle(attr));
        },

        _renderRotateThumb: function (corner, node, cx, cy, scale, svg) {
            if (!node.container) {
                var handle = svg.getElementById(svg.document.id + "handle_g");
                var d = "M 16.856 10.239 L 18 3.438 l -2.189 0.817 c -0.974 -1.694 -2.482 -2.995 -4.326 -3.696 C 9.375 -0.245 7.071" +
                    "-0.18 5.01 0.744 C 2.942 1.668 1.365 3.342 0.558 5.453 c -0.803 2.115 -0.738 4.414 0.185 6.478 c 0.925 2.064 " +
                "2.6 3.645 4.714 4.45 c 0.969 0.371 1.993 0.554 3.013 0.554 c 1.345 0 2.685 -0.317 3.897 -0.948 l -1.016 -1.962 c -1.584 0.822" +
                "-3.445 0.929 -5.114 0.293 c -1.56 -0.596 -2.793 -1.762 -3.479 -3.289 C 2.078 9.502 2.031 7.803 2.622 6.244 C 3.216 4.68 4.387" +
                " 3.443 5.914 2.761 C 7.437 2.079 9.137 2.03 10.7 2.626 c 1.246 0.475 2.271 1.328 2.986 2.424 L 11.54 5.851 L 16.856 10.239 Z";
                var fill = "#231f20";
                if (!(ej.datavisualization.Diagram.Util.canRotate(node)))
                    fill = "darkgray";
                var width = 20;
                var height = 20;
                var dist = 20;
                var attr = {
                    "id": "rotatehandle", "class": corner, "fill": fill, "stroke": "black", "stroke-width": 0.5, "width": width, "height": height, "d": d,
                    "transform": "translate(" + (cx * scale - width / 2) + "," + (cy * scale - height) + ")"
                };
                var path = svg.path(attr);
                var circle = svg.circle({
                    "id": "rotate", "class": corner, "fill": "transparent", "stroke": "none", "cx": width / 2, "cy": height / 2, "r": 13,
                    "transform": "translate(" + (cx * scale - width / 2) + "," + (cy * scale - height) + ")"
                });
                handle.appendChild(path);
                handle.appendChild(circle);
            }
        },

        _refreshEndPointHandles: function (shape, svg, scale) {
            if (shape && shape.segments) {
                var handle = svg.getElementById(svg.document.id + "handle_g");
                if (handle && handle.childNodes.length > 0) {
                    for (var i = handle.childNodes.length - 1; i >= 0 ; i--) {
                        var child = handle.childNodes[i];
                        if (child.id !== "sourceEndPoint" && child.id !== "targetEndPoint") {
                            child.parentNode.removeChild(child);
                        }
                    }
                }
                this._renderEndPointHandle(shape, svg, scale);
            }
        },
        _renderEndPointHandle: function (connector, svg, scale) {
            if (!connector.isPhase) {
                var enabled = ej.datavisualization.Diagram.Util.canDragSegmentThumbs(connector);
                for (var i = 0; i < connector.segments.length; i++) {
                    var segment = connector.segments[i];
                    if (segment.type == "bezier") {
                        this._renderBezierLine("bezierline1_" + i, segment._startPoint, segment._point1, scale, svg, enabled);
                        this._renderBezierLine("bezierline2_" + i, segment._endPoint, segment._point2, scale, svg, enabled);
                        this._renderEndPointCorner("bezierpoint1_" + i, segment._point1.x * scale, segment._point1.y * scale, false, svg, enabled);
                        this._renderEndPointCorner("bezierpoint2_" + i, segment._point2.x * scale, segment._point2.y * scale, false, svg, enabled);
                    }
                    var points = segment.points;
                    if (i == 0) {
                        this._renderEndPointCorner("sourceEndPoint", segment._startPoint.x * scale, segment._startPoint.y * scale, ej.datavisualization.Diagram.Util.isSourceConnected(connector), svg,
                              ej.datavisualization.Diagram.Util.canDragSourceEnd(connector));
                    }
                    if (i == connector.segments.length - 1) {
                        this._renderEndPointCorner("targetEndPoint", segment._endPoint.x * scale, segment._endPoint.y * scale, ej.datavisualization.Diagram.Util.isTargetConnected(connector), svg,
                            ej.datavisualization.Diagram.Util.canDragTargetEnd(connector));
                        if (segment.type == "orthogonal") {
                            this._renderTerminalOrthoThumbs(segment, svg, scale, i, enabled);
                        }
                    }
                    else {
                        if (segment.type != 'orthogonal') {
                            this._renderSegmentEndThumb("segmentEnd_" + i, segment._endPoint.x * scale, segment._endPoint.y * scale, ej.datavisualization.Diagram.Util.isSourceConnected(connector), svg,
                                   ej.datavisualization.Diagram.Util.canDragSourceEnd(connector));
                        } else {
                            this._renderTerminalOrthoThumbs(segment, svg, scale, i, enabled);
                        }

                    }
                }
            }
        },

        _renderTerminalOrthoThumbs: function (segment, svg, scale, index, isEnabled) {
            var orientation;
            if (segment.points.length > 2)
                for (var i = 0; i < segment.points.length - 1; i++) {
                    var length = ej.datavisualization.Diagram.Geometry.distance(segment.points[i], segment.points[i + 1]);
                    if (segment.points[i].y.toFixed(2) == segment.points[i + 1].y.toFixed(2)) {
                        orientation = "horizontal";
                    }
                    else orientation = "vertical";
                    var visible;
                    if (length >= 50) visible = "visible"; else visible = "hidden";
                    this._renderOrthogonalThumb(("OrthoThumb_" + i) + "_" + index, ((segment.points[i].x + segment.points[i + 1].x) / 2) * scale, ((segment.points[i].y + segment.points[i + 1].y) / 2) * scale, svg, visible, orientation, isEnabled);
                }
            else {
                var length = segment.length || ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, segment._endPoint);
                if (length >= 50) visible = "visible"; else visible = "hidden";
                if (segment._startPoint.y.toFixed(2) == segment._endPoint.y.toFixed(2)) {
                    orientation = "horizontal";
                }
                else orientation = "vertical";
                this._renderOrthogonalThumb("OrthoThumb_" + index, ((segment._endPoint.x + segment._startPoint.x) / 2) * scale, ((segment._endPoint.y + segment._startPoint.y) / 2) * scale, svg, visible, orientation, isEnabled);
            }
        },

        _renderEndPointCorner: function (corner, x, y, isConnected, svg, isenabled) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            var fill = isConnected ? "#8CC63F" : "white";
            if (!isenabled) fill = "darkgray";
            var attr = { "id": corner, "class": corner, opacity: 0.75, "fill": fill, "stroke": "black", "stroke-width": 2, "cx": x, "cy": y, "r": 7 };
            if (!svg.getElementById(corner))
                handle.appendChild(svg.circle(attr));
            else
                svg.circle(attr);

        },

        _renderSegmentEndThumb: function (corner, x, y, isConnected, svg, isenabled) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            var fill = "#e2e2e2";
            if (!isenabled) fill = "darkgray";
            var attr = { "id": corner, "class": "segmentEnd", "fill": fill, "stroke": "black", "stroke-width": 2, "cx": x, "cy": y, "r": 5 };
            handle.appendChild(svg.circle(attr));
        },
        _renderOrthogonalThumb: function (corner, x, y, svg, visibility, orientation, isEnabled) {
            var path, h, v; if (orientation == "horizontal") {
                path = "M0,7 L15,0 L30,7 L15,14 z"; h = -15; v = -7;
            } else { path = "M7,0 L0,15 L7,30 L14,15 z"; h = -7; v = -15; };
            var handle = svg.getElementById(svg.document.id + "handle_g");
            var fill = "#e2e2e2";
            if (!isEnabled) fill = "darkgray";
            var attr = {
                "id": corner, "class": "segmentEnd", "fill": fill, "stroke": "black", "stroke-width": 1, d: path, transform: "translate(" + (x + h) + "," + (y + v) + ")",
                "visibility": visibility
            };
            handle.appendChild(svg.path(attr));
        },
        _renderBezierLine: function (id, start, end, scale, svg) {
            var line = svg.line({
                "id": id, "x1": start.x * scale, "y1": start.y * scale, "x2": end.x * scale, "y2": end.y * scale,
                "stroke": "black", "stroke-width": 1, "stroke-dasharray": "3,3", "fill": "none"
            });
            var handle = svg.getElementById(svg.document.id + "handle_g");
            handle.appendChild(line);
        },
        _renderControlPointCorner: function (corner, point, index, svg) {
            var g = svg.g({ "class": corner });
            svg.getElementById(svg.document.id + "handle_g").appendChild(g);
            var attr = {
                "id": corner + "_" + index, "fill": "white", "stroke": "black", "stroke-width": 2,
                "cx": point.x, "cy": point.y, "r": 5
            };
            g.appendChild(svg.circle(attr));
        },
        updateSelector: function (shape, svg, scale, diagram, constraints) {
            if (shape) {
                var width = shape.width ? shape.width : shape._width;
                var height = shape.height ? shape.height : shape._height;
                if (shape.segments) {
                    this._updateEndPointHandle(shape, svg, scale);
                    if (constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles)
                        this.updateUserHandles(diagram.model.selectedItems.userHandles, shape, svg, false, false, scale, diagram);
                } else if (shape.type === "phase") {
                    var bounds = diagram._getPhaseBounds(shape);
                    svg.g({
                        "id": svg.document.id + "handle_g", "class": "handle", "pointer-events": "visible",
                        "transform": "translate(" + (bounds.x) * scale + "," + (bounds.y) * scale + "),rotate(0," + (bounds.width / 2) * scale + "," + (bounds.height / 2) * scale + ")"
                    });
                    svg.rect({
                        "id": "phaseSelector", "class": "phaseSelector",
                        "stroke-width": 2, "stroke-dasharray": "3,3", "pointer-events": "none",
                        "width": (bounds.width < 0) ? 1 : bounds.width * scale, "height": (bounds.height < 0) ? 1 : bounds.height * scale, "fill": "transparent", "stroke": "red",
                    });
                } else {
                    if (!(shape.isSwimlane || shape.isLane)) {
                        var g = svg.g({
                            "id": svg.document.id + "handle_g",
                            "transform": "translate(" + (shape.offsetX - width * shape.pivot.x) * scale + "," + (shape.offsetY - height * shape.pivot.y) * scale + "),rotate(" + shape.rotateAngle + "," + (width * shape.pivot.x) * scale + "," + (height * shape.pivot.y) * scale + ")"
                        });
                    }
                    var type = diagram.getObjectType(shape);
                    if (type === "group" || shape.type === "pseudoGroup" || !((diagram.activeTool.name == "move" || diagram.activeTool.name == "rotate") && diagram.activeTool.inAction)) {
                        this._updateResizeHandle(shape, svg, scale, constraints);
                    }
                    if (diagram.activeTool.name == "rotatetool" && diagram.activeTool.inAction) {
                        this.renderPivotPoint(shape, scale, svg);
                    }
                    if (diagram.model.selectedItems.userHandles && diagram.model.selectedItems.userHandles.length > 0) {
                        var isMultipleSelection = false;
                        if (diagram.selectionList[0] && diagram.selectionList[0].name == "multipleSelection")
                            isMultipleSelection = true;
                        if (constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles) {
                            this.updateUserHandles(diagram.model.selectedItems.userHandles, shape, svg, isMultipleSelection, false, scale, diagram);
                            return true;
                        }
                    }
                }
            }
        },

        _updatePhaseResize: function (node, svg, scale, constraints) {
            var nPoint, points = [], attr;
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            //#region left
            nPoint, points = [];
            points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
            points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
            nPoint = this._convertToSVGPoints(points);
            attr = { "id": "w-resize", "points": nPoint, };
            svg.polyline(attr);
            //#endregion  

            //#region top
            nPoint, points = [];
            points.push({ x: bounds.topLeft.x * scale, y: bounds.topLeft.y * scale });
            points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
            nPoint = this._convertToSVGPoints(points);
            attr = { "id": "n-resize", "points": nPoint };
            svg.polyline(attr);
            //#endregion 

            //#region right 
            nPoint, points = [];
            points.push({ x: bounds.topRight.x * scale, y: bounds.topRight.y * scale });
            points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
            nPoint = this._convertToSVGPoints(points);
            attr = { "id": "e-resize-hitTest", "points": nPoint };
            svg.polyline(attr);
            attr = { "id": "e-resize", "points": nPoint };
            svg.polyline(attr);
            //#endregion


            //#region bottom
            nPoint, points = [];
            points.push({ x: bounds.bottomLeft.x * scale, y: bounds.bottomLeft.y * scale });
            points.push({ x: bounds.bottomRight.x * scale, y: bounds.bottomRight.y * scale });
            nPoint = this._convertToSVGPoints(points);
            attr = { "id": "s-resize-hitTest", "points": nPoint, };
            svg.polyline(attr);
            attr = { "id": "s-resize", "points": nPoint, };
            svg.polyline(attr);
            //#endregion

        },
        _updateResizeHandle: function (node, svg, scale, constraints) {
            if (!(node.isSwimlane || node.isLane)) {
                var width = node.width ? node.width : node._width;
                var height = node.height ? node.height : node._height;
                var corner = node._corners;
                var rotate = ej.datavisualization.Diagram.Point(width * node.pivot.x, -20 / scale);
                if (constraints & ej.datavisualization.Diagram.SelectorConstraints.Rotator && node.type != "umlclassifier") {
                    this._updateRotateHandle("rotate", rotate.x, rotate.y, scale, svg, node);
                    this._updatePivotLine(node, svg, scale);
                }
                //this._updateResizeCorner("pivot", node.offsetX * scale, node.offsetY * scale, svg);
                if (constraints & ej.datavisualization.Diagram.SelectorConstraints.Resizer) {
                    if (node.type != "umlclassifier") {
                        this._updateResizeCorner("nw-resize", 0, 0, svg);
                        this._updateResizeCorner("n-resize", (width / 2) * scale, 0, svg);
                        this._updateResizeCorner("ne-resize", width * scale, 0, svg);
                        this._updateResizeCorner("w-resize", 0, (height / 2) * scale, svg);
                        this._updateResizeCorner("e-resize", width * scale, (height / 2) * scale, svg);
                        this._updateResizeCorner("sw-resize", 0, height * scale, svg);
                        this._updateResizeCorner("s-resize", (width / 2) * scale, height * scale, svg);
                        this._updateResizeCorner("se-resize", width * scale, height * scale, svg);
                    }
                    this._updateResizeBorder("resizeBorder", node, svg, scale);
                }
            }
            else this._updatePhaseResize(node, svg, scale, constraints);
        },
        _updateRotateHandle: function (thumb, cx, cy, scale, svg, node) {
            var width = 20;
            var height = 20;
            var dist = 20;
            var attr = {
                "id": "rotatehandle",
                "transform": "translate(" + (cx * scale - width / 2) + "," + (cy * scale - height) + ")"
            };
            svg.path(attr);
            svg.circle({
                "id": "rotate",
                "transform": "translate(" + (cx * scale - width / 2) + "," + (cy * scale - height) + ")"
            });
        },

        _updatePivotLine: function (node, svg, scale, considerpivot) {
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var rotateThumb = ej.datavisualization.Diagram.Point(width * node.pivot.x, -20 / scale);
            var pivot;
            if (considerpivot) {
                pivot = ej.datavisualization.Diagram.Point(width * node.pivot.x, height * node.pivot.y);
            } else pivot = ej.datavisualization.Diagram.Point(width * node.pivot.x, 0);
            var line = svg.line({
                "id": "pivotLine", "x1": rotateThumb.x * scale, "y1": rotateThumb.y * scale, "x2": pivot.x * scale, "y2": pivot.y * scale
            });
        },
        _updateResizeBorder: function (id, node, svg, scale) {
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            if (node.type == "umlclassifier")
                var rect = ej.datavisualization.Diagram.ClassifierHelper.renderResizeBorder(id, node, svg, scale);
            else
                svg.rect({
                    "id": id, "width": width * scale, "height": height * scale,
                });
        },

        _updateResizeCorner: function (corner, cx, cy, svg) {
            var attr = { "id": corner, "cx": cx, "cy": cy };
            svg.circle(attr);
            var attr = { "id": corner + "_transparent", "cx": cx, "cy": cy };
            svg.circle(attr);
        },

        _updateEndPointHandle: function (connector, svg, scale) {
            var enabled = ej.datavisualization.Diagram.Util.canDragSegmentThumbs(connector);
            for (var i = 0; i < connector.segments.length; i++) {
                var segment = connector.segments[i];
                var points = segment.points;
                if (i == connector.segments.length - 1) {
                    this._updateEndPointCorner("targetEndPoint", points[points.length - 1].x * scale, points[points.length - 1].y * scale, ej.datavisualization.Diagram.Util.isTargetConnected(connector), svg,
                ej.datavisualization.Diagram.Util.canDragTargetEnd(connector));
                    if (segment.type == "orthogonal") {
                        this._updateTerminalOrthoThumbs(segment, svg, scale, i, enabled);
                    }
                }
                else {
                    if (segment.type != "orthogonal") {
                        this._updateSegmentEndThumb("segmentEnd_" + i, segment._endPoint.x * scale, segment._endPoint.y * scale, ej.datavisualization.Diagram.Util.isSourceConnected(connector), svg,
                            ej.datavisualization.Diagram.Util.canDragSourceEnd(connector));
                    }
                    else {
                        this._updateTerminalOrthoThumbs(segment, svg, scale, i, enabled);
                    }
                }
                if (i == 0)
                    this._updateEndPointCorner("sourceEndPoint", points[0].x * scale, points[0].y * scale, ej.datavisualization.Diagram.Util.isSourceConnected(connector), svg,
                        ej.datavisualization.Diagram.Util.canDragSourceEnd(connector));
                if (segment.type == "bezier") {
                    this._updateEndPointCorner("bezierpoint1_" + i, segment._point1.x * scale, segment._point1.y * scale, false, svg, enabled);
                    this._updateEndPointCorner("bezierpoint2_" + i, segment._point2.x * scale, segment._point2.y * scale, false, svg, enabled);
                    this._updateBezierLine("bezierline1_" + i, segment._startPoint, segment._point1, scale, svg);
                    this._updateBezierLine("bezierline2_" + i, segment._endPoint, segment._point2, scale, svg);
                }
            }
            //if (points.length > 2) {
            //    for (var i = 1, len = points.length; i < len - 1; ++i) {
            //        this._updateControlPointCorner("controlPoint", points[i], i, svg);
            //    }
            //}
        },

        _updateEndPointCorner: function (corner, x, y, isConnected, svg, isenabled) {
            var fill = isConnected ? "#8CC63F" : "white";
            if (!isenabled) fill = "darkgray";
            var attr = { "id": corner, "fill": fill, "cx": x, "cy": y };
            svg.circle(attr);
        },
        _updateSegmentEndThumb: function (corner, x, y, isConnected, svg, isenabled) {
            var attr = { "id": corner, "cx": x, "cy": y };
            svg.circle(attr);
        },
        _updateOrthoThumb: function (corner, x, y, svg, visibility, orientation, enabled) {
            var fill = "#e2e2e2";
            if (!enabled) fill = "darkgray";
            var path, h, v; if (orientation == "horizontal") {
                path = "M0,7 L15,0 L30,7 L15,14 z"; h = -15; v = -7;
            } else { path = "M7,0 L0,15 L7,30 L14,15 z"; h = -7; v = -15; };
            var attr = { "id": corner, visibility: visibility, transform: "translate(" + (x + h) + "," + (y + v) + ")", d: path, fill: fill };
            svg.path(attr);
        },
        _updateTerminalOrthoThumbs: function (segment, svg, scale, index, enabled) {
            var orientation;
            if (segment.points.length > 2)
                for (var i = 0; i < segment.points.length - 1; i++) {
                    var length = ej.datavisualization.Diagram.Geometry.distance(segment.points[i], segment.points[i + 1]);
                    if (segment.points[i].y.toFixed(2) == segment.points[i + 1].y.toFixed(2)) {
                        orientation = "horizontal";
                    }
                    else orientation = "vertical";
                    var visible;
                    if (length >= 50) visible = "visible"; else visible = "hidden";
                    this._updateOrthoThumb(("OrthoThumb_" + i) + "_" + index, ((segment.points[i].x + segment.points[i + 1].x) / 2) * scale, ((segment.points[i].y + segment.points[i + 1].y) / 2) * scale, svg, visible, orientation, enabled);

                }
            else {
                var length = segment.length || ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, segment._endPoint);
                if (segment._startPoint.y.toFixed(2) == segment._endPoint.y.toFixed(2)) {
                    orientation = "horizontal";
                }
                else orientation = "vertical";
                if (length >= 50) visible = "visible"; else visible = "hidden";
                this._updateOrthoThumb("OrthoThumb_" + index, ((segment._endPoint.x + segment._startPoint.x) / 2) * scale, ((segment._endPoint.y + segment._startPoint.y) / 2) * scale, svg, visible, orientation, enabled);
            }
        },
        _updateBezierLine: function (id, start, end, scale, svg) {
            var line = svg.line({
                "id": id, "x1": start.x * scale, "y1": start.y * scale, "x2": end.x * scale, "y2": end.y * scale
            });
        },
        _updateControlPointCorner: function (corner, point, index, svg) {
            svg.circle({ "id": corner + "_" + index, "cx": point.x, "cy": point.y });
        },

        updateUserHandles: function (handles, node, svg, isMultipleSelection, isDragging, scale, diagram) {
            var userHandle = svg.document.getElementById(svg.document.id + "userHandle_g");
            if (diagram.model.selectedItems.constraints & ej.datavisualization.Diagram.SelectorConstraints.UserHandles) {
                if (!userHandle) {
                    this.renderUserHandles(handles, node, svg, isMultipleSelection, scale, diagram._adornerLayer, diagram);
                } else {
                    if (handles && handles.length > 0) {
                        for (var handleIndex = 0; handleIndex < handles.length; handleIndex++) {
                            if ((isMultipleSelection && handles[handleIndex].enableMultiSelection) || !isMultipleSelection)
                                this._updateHandle(handles[handleIndex], node, svg, isDragging, scale, diagram);
                        }
                    }
                }
            }
        },

        _updateHandle: function (handle, node, svg, isDragging, scale, diagram) {
            if (!isDragging && node && handle.visible) {
                var position = this._getHandlePosition(handle, node, scale, null, diagram);
                var d = handle._absolutePath;
                if (!d || handle.size != handle._size) d = handle._absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(0, 0, handle.size / 2, handle.size / 2, handle.pathData, svg);
                handle._size = handle._size;
                var x = position.x * scale;// - (node.segments ? 0 : handle.size / 4);
                var y = position.y * scale;// - (node.segments ? 0 : handle.size / 4)
                this._updateHandleShape(handle, x, y, svg);
                this._updateHanleIcon(handle, d, svg, x - handle.size / 4, y - handle.size / 4);
                if (svg.getElementById(handle.name + "_shape") && handle.visible) {
                    svg.getElementById(handle.name + "_shape").style.display = "block";
                    svg.getElementById(handle.name + "_icon").style.display = "block";
                }
            }
            else {
                if (svg.getElementById(handle.name + "_shape")) {
                    svg.getElementById(handle.name + "_shape").style.display = "none";
                    svg.getElementById(handle.name + "_icon").style.display = "none";
                }
            }
        },

        clearSelector: function (svg, parent) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            if (handle)
                parent.removeChild(handle);
            handle = svg.getElementById(svg.document.id + "userHandle_g");
            if (handle)
                parent.removeChild(handle);
        },

        clearSegments: function (svg) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            $(handle).find(".segmentEnd").remove();
        },

        addSegments: function (svg, connector, scale) {
            var handle = svg.getElementById(svg.document.id + "handle_g");
            this._renderSegmentHandle(connector, svg, scale);
        },

        _renderSegmentHandle: function (connector, svg, scale) {
            if (!connector.isPhase) {
                var enabled = ej.datavisualization.Diagram.Util.canDragSegmentThumbs(connector);
                for (var i = 0; i < connector.segments.length; i++) {
                    var segment = connector.segments[i];
                    if (segment.type == "bezier") {
                        this._renderBezierLine("bezierline1_" + i, segment._startPoint, segment._point1, scale, svg, enabled);
                        this._renderBezierLine("bezierline2_" + i, segment._endPoint, segment._point2, scale, svg, enabled);
                        this._renderEndPointCorner("bezierpoint1_" + i, segment._point1.x * scale, segment._point1.y * scale, false, svg, enabled);
                        this._renderEndPointCorner("bezierpoint2_" + i, segment._point2.x * scale, segment._point2.y * scale, false, svg, enabled);
                    }
                    var points = segment.points;
                    if (!(i === 0 || i === connector.segments.length - 1)) {
                        if (segment.type != 'orthogonal') {
                            this._renderSegmentEndThumb("segmentEnd_" + i, segment._endPoint.x * scale, segment._endPoint.y * scale, ej.datavisualization.Diagram.Util.isSourceConnected(connector), svg,
                                   ej.datavisualization.Diagram.Util.canDragSourceEnd(connector));
                        } else {
                            this._renderTerminalOrthoThumbs(segment, svg, scale, i, enabled);
                        }
                    }
                }
            }
        },

        _initializePageBreaks: function (svg, attr, g) {
            var g1 = svg.g(attr);
            g.appendChild(g1);
            return g1;
        },

        _renderVPageBreakLine: function (start, end, svg, g) {
            var line = svg.line({
                "x1": start.x, "y1": start.y,
                "x2": end.x, "y2": end.y,
                "style": "stroke:#aaaaaa;stroke-width:1;stroke-dasharray:10,10 "
            });
            g.appendChild(line);
        },

        _renderPageSettingsRect: function (start, end, svg, g, _stroke, _fill, _strokewidth) {
            var rect = svg.rect({
                "id": "pageback",
                "x": start.x, "y": start.y, "width": end.x, "height": end.y,
                "style": "fill:" + _fill + ";stroke:" + _stroke + ";stroke-width:" + _strokewidth + ""
            });
            g.appendChild(rect);
        },

        _updatePageBakground: function (start, end, svg, g, _stroke, _fill, _strokewidth) {
            var rect = svg.document.getElementById("pageback");
            var attr = {
                "x": start.x, "y": start.y, "width": (end.x < 0) ? 0 : end.x, "height": (end.y < 0) ? 0 : end.y,
                "style": "fill:" + _fill + ";stroke:" + _stroke + ";stroke-width:" + _strokewidth + ""
            };
            if (rect)
                ej.datavisualization.Diagram.Util.attr(rect, attr);
        },

        _renderHPageBreakLine: function (start, end, svg, g) {
            var line = svg.line({
                "x1": start.x, "y1": start.y,
                "x2": end.x, "y2": end.y,
                "style": "stroke:#aaaaaa;stroke-width:1;stroke-dasharray:10,10 "
            });
            g.appendChild(line);
        },

        _removePageBreaks: function (svg, g, layer) {
            if (g != null) {
                if (layer != null) {
                    layer.removeChild(g);
                }
            }
        },
        removeChild: function (element, view) {
            var elementTar = view.svg.document.getElementById(element.name);
            var htmlLayer = view.svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
            var label = this._findChild(htmlLayer.childNodes, element);
            if (elementTar)
                elementTar.parentNode.removeChild(elementTar);
            if (label)
                htmlLayer.removeChild(label);
            if (element._type === "node" && element.type === "html") {
                var htmlelement = htmlLayer.children[element.name + "_parentdiv"];
                if (htmlelement && htmlelement.parentNode)
                    htmlelement.parentNode.removeChild(htmlelement);
            }
        }
        //#endregion
    };
    //#endregion

    //#region Common Renderer
    ej.datavisualization.Diagram.DiagramContext = {

        _renderNodes: function (view, isLoad, isoverView, diagram) {
            if (diagram.nodes()) {
                var nodes = diagram.nodes();
                for (var i = 0, len = nodes.length; i < len; ++i) {
                    var node = diagram.nameTable[nodes[i].name];
                    var panel = view.svg || view._canvas;
                    this._renderNodeObject(node, view, isLoad, isoverView, diagram);
                }
            }
        },

        _renderNodeObject: function (node, view, isLoad, isoverView, diagram) {
            var panel = view.svg || view._canvas;
            if (node._type === "group" && !node.parent) {
                if (!node.container) {
                    //ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram, true);
                }
                view.context.renderGroup(node, panel, view.diagramLayer, diagram.nameTable, diagram, isLoad, isoverView);
                // ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
            }
            else {
                if (!node.parent)
                    view.context.renderNode(node, panel, view.diagramLayer, null, diagram);
            }
        },

        _renderConnectors: function (view, diagram) {
            if (diagram.connectors()) {
                var connectors = diagram.connectors();
                var panel = view.svg || view._canvas;
                var connector;
                for (var i = 0, len = connectors.length; i < len; ++i) {
                    connector = connectors[i];
                    diagram._setZorder(connector);
                }
                for (var i = 0, len = connectors.length; i < len; ++i) {
                    connector = connectors[i];
                    this._renderConnectorObject(connector, view, diagram);
                }
            }
        },

        _renderConnectorObject: function (connector, view, diagram) {
            var panel = view.svg || view._canvas;
            ej.datavisualization.Diagram.Util.updateBridging(connector, diagram);
            if (!connector.parent)
                view.context.renderConnector(connector, panel, view.diagramLayer, diagram);
        },

        updateViewPort: function (diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                if (view.context == ej.datavisualization.Diagram.SvgContext && view.type == "mainview") {
                    ej.datavisualization.Diagram.PageUtil._updatePageSize(diagram);
                }
            });
        },
        renderNode: function (node, diagram, parent) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                if (parent)
                    parent = panel.document.getElementById(parent.id)
                view.context.renderNode(node, panel, parent || view.diagramLayer, undefined, diagram);
            });
        },
        addLabel: function (node, label, diagram, index) {
            var view, panel;
            if (diagram._views) {
                diagram._views.forEach(function (viewid) {
                    view = diagram._views[viewid];
                    panel = view.svg || view.canvas;
                    view.context._addLabel(node, label, panel, diagram, index);
                });
            }
        },
        renderPort: function (node, port, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                view.context._insertPort(node, port, panel);
            });
        },
        renderConnector: function (connector, diagram, parent) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                view.context.renderConnector(connector, panel, parent || view.diagramLayer, diagram);
            });
        },

        renderGroup: function (group, diagram, parent) {
            var view, panel;

            diagram._views.forEach(function (viewid) {
                var isOverView
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                parent = view.svg.getElementById(group.parent);
                if (view.type == "overview") {
                    isOverView = true;
                }
                view.context.renderGroup(group, panel, parent || view.diagramLayer, diagram.nameTable, diagram, null, isOverView);
            });
        },
        update: function (data, diagram, layout) {
            var update = true;
            if (data.isSwimlane && diagram._disableSwimlaneUptate) {
                update = false;
            }
            if (update) {
                var view, panel;
                diagram._views.forEach(function (viewid) {
                    view = diagram._views[viewid];
                    panel = view.svg || view._canvas;
                    if (diagram && !diagram._isInit && data._status !== "new")
                        data._status = "update";
                    if (data._type === "group" || data.type === "pseudoGroup")
                        view.context.updateGroup(data, panel, diagram, layout);
                    else if (data.segments)
                        view.context.updateConnector(data, panel, diagram);
                    else
                        view.context.updateNode(data, panel, diagram, layout);
                });
            }
        },
        _refreshSegments: function (connector, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                if (connector.segments)
                    view.context._refreshSegments(connector, panel, diagram);
            });
        },
        _refreshOnlySegments: function (connector, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                if (connector.segments)
                    view.context._refreshOnlySegments(connector, panel, diagram);
            });
        },
        renderShadow: function (node, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                view.context._renderShadow(node, panel);
            });
        },
        updateShadow: function (node, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                view.context._updateShadow(node, panel);
            });
        },
        removeShadow: function (node, diagram) {
            var view, panel;

            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view._canvas;
                view.context._removeShadow(node, panel);
            });
        },
        addNodeLabel: function (shape, label, parent, diagram) {
            var view, panel;
            if (diagram._views) {
                diagram._views.forEach(function (viewid) {
                    view = diagram._views[viewid];
                    panel = view.svg || view.canvas;
                    view.context.addNodeLabel(shape, label, panel, parent, diagram);
                });
            }
        },

        updateLabel: function (node, label, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                if (diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                    view.context._updateSVGLabel(node, label, panel, diagram);
                }
                else
                    view.context.updateLabel(node, label, panel, diagram);
            });
        },

        updatePort: function (node, port, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.updatePort(node, port, panel, diagram);
            });
        },

        setNodeShape: function (node, diagram, parent) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.setNodeShape(node, panel, parent, diagram);
            });
        },

        setLine: function (connector, diagram, parent) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.setLine(connector, panel, parent, diagram);
            });
        },

        renderDecorators: function (connector, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.renderDecorators(connector, panel, diagram);
            });
        },

        clearDecorators: function (connector, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.clearDecorators(connector, panel, diagram);
            });
        },

        updateTargetDecoratorStyle: function (node, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.updateTargetDecoratorStyle(node, panel);
            });
        },

        updateSourceDecoratorStyle: function (node, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.updateSourceDecoratorStyle(node, panel);
            });
        },

        updateNodeStyle: function (node, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context._updateNodeStyle(node, panel);
            });
        },

        updateLabelStyle: function (node, label, diagram) {
            diagram._views.forEach(function (viewid) {
                var view = diagram._views[viewid];
                var panel = view.svg || view.canvas;
                view.context.updateLabelStyle(node, label, panel, diagram);
            });
        },

        updateConnectorStyle: function (connector, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context._updateConnectorStyle(connector, panel);
            });
        },

        updateTextBlock: function (node, label, diagram) {
            var view, panel;
            diagram._views.forEach(function (viewid) {
                view = diagram._views[viewid];
                panel = view.svg || view.canvas;
                view.context.updateTextBlock(node, label, panel, diagram);
            });

        },

        updateBPMNNodeStyle: function (node, diagram) {
            var child, children, i = 0;
            node = ej.datavisualization.Diagram.Util._updateBpmnChild(node, diagram);
            if (node.children) {
                children = diagram._getChildren(node.children);
                for (i = 0; i < children.length; i++) {
                    child = diagram.nameTable[children[i]];
                    ej.datavisualization.Diagram.DiagramContext.updateNodeStyle(child, diagram, node);
                }
            } else ej.datavisualization.Diagram.DiagramContext.updateNodeStyle(node, diagram);
        },

        updateBPMNNodeShape: function (node, diagram) {
            var child, children, i = 0;
            node = ej.datavisualization.Diagram.Util._updateBpmnChild(node, diagram);
            children = diagram._getChildren(node.children);
            if (children.length > 0 && diagram.nameTable[children[0]]) {
                for (i = 0; i < children.length; i++) {
                    child = diagram.nameTable[children[i]];
                    if (child)
                        ej.datavisualization.Diagram.DiagramContext.setNodeShape(child, diagram, node);
                }
            }
            else {
                var element = diagram._svg.getElementById(node.name);
                element.parentNode.removeChild(element);
                diagram.add(node);
            }
        }
    };
    //#endregion
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html SymbolPalette elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    "use strict";
    //#region SymbolPalette widget
    ej.widget("ejSymbolPalette", "ej.datavisualization.SymbolPalette", {
        element: null,
        model: null,
        _requiresID: true,
        nameTable: {},
        //#region Initialization
        defaults: {
            width: "250px",
            height: "400px",
            labelRenderingMode: "html",
            paletteItemWidth: undefined,
            paletteItemHeight: undefined,
            previewWidth: undefined,
            previewHeight: undefined,
            previewOffset: { x: 110, y: 110 },
            diagramId: "",
            headerHeight: 30,
            selectedPaletteName: "",
            cssClass: "e-datavisualization-symbolpalette",
            showPaletteItemText: true,
            allowDrag: true,
            palettes: [],
            defaultSettings: {
                connector: null,
                node: null
            },
            selectionChange: null,
            create: null,
            destroy: null,
        },
        _oldItem: null,
        _labelHashTable: {},
        dataTypes: {
            paletteItemWidth: "number",
            paletteItemHeight: "number",
            previewWidth: "number",
            previewHeight: "number",
            headerHeight: "number",
            showPaletteItemText: "boolean",
            allowDrag: "boolean",
            palettes: "array",
        },
        _canvas: null,
        _init: function () {
            if (!(ej.browserInfo().name === "msie" && Number(ej.browserInfo().version) < 9)) {
                this.nameTable = {};
                this.selectedItem = null;
                this.activePalette = null;
                this._selectedElement = null;
                this._renderSymbolPalette();
                this._wireEvents();
                this.updateScrollerViewport();
            }
        },
        _setModel: function (options) {
            for (var option in options) {
                switch (option) {
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "paletteItemWidth":
                        this.model.paletteItemWidth = options[option];
                        this._redrawContent();
                        break;
                    case "paletteItemHeight":
                        this.model.paletteItemHeight = options[option];
                        this._redrawContent();
                        break;
                    case "headerHeight":
                        this._setHeaderHeight(options[option]);
                        break;
                    case "cssClass":
                        this._setCssClass(options[option]);
                        break;
                    case "showPaletteItemText":
                        this._showItemText(options[option]);
                        break;
                    case "allowDrag":
                        this._setAllowDrag(options[option]);
                        break;
                    case "palettes":
                        this._updatePalettes(options[option]);
                        break;
                    case "selectedPaletteName":
                        var palette = this._getPalette(options.selectedPaletteName);
                        if (palette && palette !== this.activePalette) {
                            $(document.getElementById(this.activePalette.name + "_header")).removeClass("selected");
                            this.activePalette = palette;
                            $(document.getElementById(this.activePalette.name + "_header")).addClass("selected");
                        }
                        break;
                }
            }
        },
        _destroy: function () {
            this.element.empty().removeClass(this.model.cssClass);
        },
        //#endregion
        //#region Rendering
        _renderSymbolPalette: function () {
            this._canvas = document.createElement("div");
            this._canvas.setAttribute("class", "e-scanvas");
            this._canvas.setAttribute("id", this.element[0].id + "_canvas");
            this.element[0].setAttribute("style", "height:" + this.model.height + "; width:" + this.model.width + ";");
            this.element.append(this._canvas);
            this.element.ejScroller({ width: this._setViewPortWidth(), height: this._setViewPortHeight(), enableTouchScroll: false });
            this._renderPalettes();
        },
        _updatePalettes: function (option) {
            this.model.palettes = option;
            $("#" + this.element[0].id + "_canvas").empty();
            this._renderPalettes();
            this.updateScrollerViewport();
        },
        _renderPalettes: function () {
            var palettes = this.model.palettes;
            if (palettes) {
                for (var i = 0, len = palettes.length; i < len; i++) {
                    palettes[i] = ej.datavisualization.Diagram.Palette(palettes[i]);
                    this._initPaletteitems(palettes[i]);
                    this._renderPalette(palettes[i]);
                }
            }
        },

        _updatePaletteItemWidth: function (item) {
            var bounds = ej.datavisualization.Diagram.Util.bounds(item);
            if (!item.segments) {
                if (item.width > (this.element.width() - 40)) {
                    item.width = this.element.width() - 40;
                }
                else if (item.paletteItem && item.paletteItem.width && item.paletteItem.width > (this.element.width() - 40)) {
                    item.paletteItem.width = this.element.width() - 40;
                }
            }
            else {
                if (bounds.width > (this.element.width() - 40) && !item.paletteItem) {
                    ej.datavisualization.Diagram.Util.scale(item, (this.element.width() - 45) / bounds.width, 1, bounds.center);
                }
            }
        },
        _renderHtmlLayer: function (canvas, parent) {
            var div = document.createElement("div");
            var attr = { "id": canvas.id + "_htmlLayer", "class": "htmlLayer" };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            var htmlLayer = div;
            div.style.pointerEvents = "none";
            div.style.position = "absolute";
            div.style.left = parent ? parent.style.paddingLeft : "0px";
            div.style.top = parent ? parent.style.paddingTop : "0px";
            canvas.appendChild(htmlLayer);
            return htmlLayer;
        },
        _initPaletteitems: function (options) {
            if (options.items) {
                for (var i = 0; i < options.items.length; i++) {
                    options.items[i] = this._extendPaletteItem (options.items[i])
                }
            }
        },
        _initGroupNode: function (group) {
            var child = null;
            var nodeDefault = this.model.defaultSettings && this.model.defaultSettings.node ? this.model.defaultSettings.node : null;
            var connectorDefault = this.model.defaultSettings && this.model.defaultSettings.connector ? this.model.defaultSettings.connector : null;
            for (var i = 0; i < group.children.length; i++) {
                child = group.children[i];
                if (typeof (child) == "object") {
                    if (child._type == "group") {
                        child = ej.datavisualization.Diagram.Group($.extend(true, {}, nodeDefault, child));
                        child = ej.datavisualization.Diagram.Util._updateBpmnChild(child, this)
                        this._initGroupNode(child);
                    }
                    else if (child.segments)
                        child = ej.datavisualization.Diagram.Connector($.extend(true, {}, connectorDefault, child));
                    else
                        child = ej.datavisualization.Diagram.Node($.extend(true, {}, nodeDefault, child));
                    child = ej.datavisualization.Diagram.NodeType(child, this);
                    child.parent = group.name;
                    group.children[i] = child.name;
                    this.nameTable[child.name] = child;
                }
            }
        },
        _setViewPortWidth: function () {
            this.element[0].setAttribute("style", "width:" + this.model.width + ";");
            var w = this.element.width();
            // var left = this.element[0].offsetLeft;
            return Math.abs(w);
        },
        _setViewPortHeight: function () {
            this.element[0].setAttribute("style", "height:" + this.model.height + ";");
            var h = this.element.height();
            //var top = this.element[0].offsetTop;
            return Math.abs(h);
        },
        _renderPalette: function (palette) {
            this._renderHeader(palette);
            this._updateHeaderWrapper(palette, this.model.headerHeight);
            this._renderContent(palette);
            this._collapse(palette);
            this._updatePaletteVisibility(palette);
        },
        _renderHeader: function (palette) {
            var header = document.createElement("div");
            var attr = { "id": palette.name + "_header", "class": "e-header", "style": "height:" + this.model.headerHeight + "px;" };
            if (!(palette.constraints & this._canHeaderVisible(palette))) {
                attr.style += "display:none";
            }
            ej.datavisualization.Diagram.Util.attr(header, attr);
            this._renderHeaderArrow(header, palette.expanded, palette.name, this._canExpand(palette));
            if (palette.templateId && $.templates)
                this._renderHeaderTemplate(header, palette);
            else
                this._renderHeaderText(header, palette.name);
            this._addExpandedClass(header, palette.expanded);
            this._disableClickClass(header, this._canExpand(palette));
            if (this.model.selectedPaletteName === palette.name) {
                $(header).addClass("selected");
                this.activePalette = palette;
            }
            this._canvas.appendChild(header);
        },
        _renderHeaderText: function (header, text) {
            var span = document.createElement("span");
            span.setAttribute("class", "e-header-text");
            span.innerHTML = text;
            header.appendChild(span);
        },
        _renderHeaderTemplate: function (header, palette) {
            var html = this._renderEjTemplate("#" + palette.templateId, palette);
            var wrapper = document.createElement("div");
            var attr = {
                "id": palette.name + "_Wrapper",
                "class": "e-header-wrapper"
            };
            ej.datavisualization.Diagram.Util.attr(wrapper, attr);
            this._renderTemplateContent(palette, wrapper, html);
            header.appendChild(wrapper);
        },
        _renderTemplateContent: function (palette, wrapper, html) {
            var div = document.createElement('div');
            div.innerHTML = html;
            div.style.display = "inline-block";
            document.body.appendChild(div);
            var content = div.cloneNode(true);
            content.id = palette.name + "_templateHeader";
            var width = div.offsetWidth, height = div.offsetHeight;
            var scaleX = $("#" + this._id).width() - 18 / width;
            var scaleY = this.model.headerHeight / height;
            var scale = Math.min(scaleX, scaleY);
            var left = (scale - 1) * width / 2;
            ej.datavisualization.Diagram.Util.attr(content, { style: "position: relative; left: " + left + "px; transform: scale(" + scale + ")" });
            wrapper.appendChild(content);
            div.parentNode.removeChild(div);
        },
        _renderHeaderArrow: function (header, expanded, index, enableClick) {
            if (enableClick) {
                var arrow = header.getElementsByClassName("e-header-arrow e-icon")[0];
                if (!arrow) {
                    arrow = document.createElement("span");
                    arrow.setAttribute("class", "e-header-arrow e-icon");
                    arrow.setAttribute("style", "top:" + (this.model.headerHeight - 16) / 2 + "px;");
                    this._addExpandedClass(arrow, expanded);
                    if (this.model.selectedPaletteName === name)
                        $(arrow).addClass("selected");
                    header.appendChild(arrow);
                }
            }
            else {
                var icon = header.getElementsByClassName("e-header-arrow e-icon")[0];
                if (icon) {
                    icon.parentNode.removeChild(icon);
                }
            }
        },
        _renderContent: function (palette) {
            var content = document.getElementById(palette.name + "_content");
            if (!content) {
                content = document.createElement("div");
                this._canvas.appendChild(content);
            }
            content.setAttribute("id", palette.name + "_content");
            content.setAttribute("class", "e-scontent");
            if ((this.model.palettes.length - 1) === this.model.palettes.indexOf(palette))
                content.setAttribute("style", "border-bottom-width: 0px;");

            var paletteItems = palette.items;
            if (paletteItems && paletteItems.length > 0) {
                for (var i = 0, len = paletteItems.length; i < len; i++) {
                    if (paletteItems[i].parent)
                        this.nameTable[paletteItems[i].name] = paletteItems[i];
                    else {
                        this._renderItem(paletteItems[i], content);
                        this.nameTable[paletteItems[i].name] = paletteItems[i];
                    }
                }
            }
        },
        _updateRenderSize: function (paletteItem, preSize, nameTable) {
            if (!paletteItem.paletteItem || (paletteItem.type === "group" && !paletteItem.isLane) || (paletteItem._type === "group" && paletteItem.type === "bpmn")) {
                if (!paletteItem.segments) {
                    if (paletteItem._type == "group") {
                        if (this._checkItemUpdate(paletteItem)) {
                            var deltaWidth = preSize.width / paletteItem.width;
                            var deltaHeight = preSize.height / paletteItem.height;
                            this.scale(paletteItem, deltaWidth, deltaHeight, paletteItem.pivot, nameTable, null, null, null, this);
                            ej.datavisualization.Diagram.Util._translate(paletteItem, preSize.width / 2 - paletteItem.offsetX, preSize.height / 2 - paletteItem.offsetY, nameTable, null, this);
                        }
                        else {
                            ej.datavisualization.Diagram.Util._translate(paletteItem, paletteItem.width / 2 - paletteItem.offsetX, paletteItem.height / 2 - paletteItem.offsetY, nameTable, null, this);
                        }
                    }
                    else {
                        paletteItem.width = preSize.width;
                        paletteItem.height = preSize.height;
                        paletteItem.offsetX = preSize.width / 2;
                        paletteItem.offsetY = preSize.height / 2;
                    }
                }
                else {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                    ej.datavisualization.Diagram.Util._translate(paletteItem, preSize.width / 2 - bounds.center.x, preSize.height / 2 - bounds.center.y, this.nameTable);
                }
            }
            else if (paletteItem.segments && paletteItem.paletteItem && paletteItem.paletteItem.enableScale && !paletteItem.isPhase) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                var dx = (paletteItem.paletteItem.width ? paletteItem.paletteItem.width : this.model.paletteItemWidth) / bounds.width;
                var dy = (paletteItem.paletteItem.height ? paletteItem.paletteItem.height : this.model.paletteItemHeight) / bounds.height;
                ej.datavisualization.Diagram.Util.scale(paletteItem, dx, dy, { x: .5, y: .5 });
                this._updatePaletteItemWidth(paletteItem);
            }
            else if ((paletteItem.segments && paletteItem.paletteItem && paletteItem.paletteItem.enableScale && !paletteItem.isPhase) || (paletteItem.isPhase && paletteItem.paletteItem.width != paletteItem.paletteItem.height)) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                var dx = (paletteItem.paletteItem.width ? paletteItem.paletteItem.width : this.model.paletteItemWidth) / bounds.width;
                var dy = (paletteItem.paletteItem.height ? paletteItem.paletteItem.height : this.model.paletteItemHeight) / bounds.height;
                ej.datavisualization.Diagram.Util.scale(paletteItem, dx, dy, { x: .5, y: .5 });
                this._updatePaletteItemWidth(paletteItem);
            }
            else if (paletteItem._type == "node" && this._checkItemUpdate(paletteItem)) {
                paletteItem.width = preSize.width;
                paletteItem.height = preSize.height;
                paletteItem.offsetX = preSize.width / 2;
                paletteItem.offsetY = preSize.height / 2;
            }
        },
        _checkItemUpdate: function (paletteItem) {
            if (!(paletteItem.paletteItem && paletteItem.paletteItem.enableScale))
                return true;
            return false;
        },
        _updatePreviewSize: function (paletteItem, preSize) {
            if (!paletteItem.paletteItem || (paletteItem.type === "group" && !paletteItem.isLane)) {
                if (!paletteItem.segments) {
                    if (paletteItem.container && !paletteItem.isLane) {
                        var deltaWidth = preSize.width / paletteItem.width;
                        var deltaHeight = preSize.height / paletteItem.height;
                        this.scale(paletteItem, deltaWidth, deltaHeight, paletteItem.pivot, this.nameTable, null, null, null, this);
                        ej.datavisualization.Diagram.Util._translate(paletteItem, preSize.width / 2 - paletteItem.offsetX, preSize.height / 2 - paletteItem.offsetY, this.nameTable, null, this);
                    }
                    else {
                        paletteItem.width = preSize.width;
                        paletteItem.height = preSize.height;
                        paletteItem.offsetX = preSize.width / 2;
                        paletteItem.offsetY = preSize.height / 2;
                    }
                }
                else {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                    ej.datavisualization.Diagram.Util._translate(paletteItem, preSize.width / 2 - bounds.center.x, preSize.height / 2 - bounds.center.y, this.nameTable);
                }
            }
            else if (paletteItem.segments && paletteItem.paletteItem && paletteItem.paletteItem.enableScale && !paletteItem.isPhase) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                var dx = (paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : this.model.previewWidth) / bounds.width;
                var dy = (paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : this.model.previewHeight) / bounds.height;
                ej.datavisualization.Diagram.Util.scale(paletteItem, dx, dy, { x: .5, y: .5 });
                this._updatePaletteItemWidth(paletteItem);
            }
            else if ((paletteItem.segments && paletteItem.paletteItem && paletteItem.paletteItem.enableScale && !paletteItem.isPhase) || (paletteItem.isPhase && paletteItem.paletteItem.previewWidth != paletteItem.paletteItem.previewHeight)) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                var dx = (paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : this.model.previewWidth) / bounds.width;
                var dy = (paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : this.model.previewHeight) / bounds.height;
                ej.datavisualization.Diagram.Util.scale(paletteItem, dx, dy, { x: .5, y: .5 });
                this._updatePaletteItemWidth(paletteItem);
            }
            else if (paletteItem._type == "node" || paletteItem._type == "group") {
                paletteItem.width = preSize.width;
                paletteItem.height = preSize.height;
                paletteItem.offsetX = preSize.width / 2;
                paletteItem.offsetY = preSize.height / 2;
            }
        },
        _getRenderItemSize: function (paletteItem) {
            var width = this.model.paletteItemWidth, height = this.model.paletteItemHeight;
            if (!paletteItem.segments) {
                if (paletteItem.type === "group") {
                    bounds = ej.datavisualization.Diagram.Util._getChildrenBounds(paletteItem, this);
                    if (paletteItem.paletteItem && (!paletteItem.isLane)) {
                        width = paletteItem.paletteItem.width ? paletteItem.paletteItem.width : width;
                        height = paletteItem.paletteItem.height ? paletteItem.paletteItem.height : height;
                        width = width ? width : bounds.width;
                        height = height ? height : bounds.height;
                        paletteItem.paletteItem.width = width;
                        paletteItem.paletteItem.height = height;
                    }
                    else if (paletteItem.paletteItem && paletteItem.isLane) {
                        if (!paletteItem.paletteItem.enableScale) {
                            var dx = (paletteItem.paletteItem.width ? paletteItem.paletteItem.width : this.model.paletteItemWidth) / paletteItem.width;
                            var dy = (paletteItem.paletteItem.height ? paletteItem.paletteItem.height : this.model.paletteItemHeight) / paletteItem.height;
                            ej.datavisualization.Diagram.Util.scale(paletteItem, dx, dy, { x: .5, y: .5 }, this.nameTable, false, false, false, this);
                            var x = 0.0001, y = 0.001;
                            if (paletteItem.isLane && paletteItem.paletteItem && !paletteItem.paletteItem.enableScale) {
                                if (paletteItem.orientation === "horizontal") x -= 2.2;
                                else x += .8; y -= 1;
                            }
                            ej.datavisualization.Diagram.Util._translate(paletteItem, x, y, this.nameTable, false, this);
                            width = paletteItem.width ? paletteItem.width : width;
                            height = paletteItem.height ? paletteItem.height : height;
                        }
                        else {
                            width = paletteItem.paletteItem.width ? paletteItem.paletteItem.width : width;
                            height = paletteItem.paletteItem.height ? paletteItem.paletteItem.height : height;
                            width = width ? width : bounds.width;
                            height = height ? height : bounds.height;
                            paletteItem.paletteItem.width = width;
                            paletteItem.paletteItem.height = height;
                        }
                    }
                    else {
                        width = width ? width : bounds.width;
                        height = height ? height : bounds.height;
                    }
                }
                else {
                    if (paletteItem.paletteItem) {
                        width = paletteItem.paletteItem.width ? paletteItem.paletteItem.width : width;
                        height = paletteItem.paletteItem.height ? paletteItem.paletteItem.height : height;
                        width = width ? width : paletteItem.width;
                        height = height ? height : paletteItem.height;
                        paletteItem.paletteItem.width = width;
                        paletteItem.paletteItem.height = height;
                    }
                    else {
                        var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                        width = bounds.width ? bounds.width : width;
                        height = bounds.height ? bounds.height : height;
                    }
                }
            }
            else {
                var dec, size, bounds;
                bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                if (paletteItem.paletteItem) {
                    width = paletteItem.paletteItem.width ? paletteItem.paletteItem.width : width;
                    height = paletteItem.paletteItem.height ? paletteItem.paletteItem.height : height;
                    width = width ? width : paletteItem.width;
                    height = height ? height : paletteItem.height;
                    paletteItem.paletteItem.width = width;
                    paletteItem.paletteItem.height = height;
                }
                else {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                    width = width ? width : bounds.width;
                    height = height ? height : bounds.height;
                }
            }
            return { width: width, height: height };
        },
        _renderPetternDefinition: function (id, svg) {
            if (id && svg) {
                var defs = svg.document.getElementById(id + "patterndefinition")
                if (!defs) {
                    defs = svg.defs({ "id": id + "patterndefinition" });
                    svg.appendChild(defs);
                }
            }
        },
        _renderItem: function (paletteItem, content) {

            var item = $.extend(true, {}, paletteItem);
            var itemSize = this._getRenderItemSize(item);
            var nameTable = [];
            for (var i = 0; paletteItem.children && i < paletteItem.children.length; i++)
                nameTable[paletteItem.children[i]] = $.extend(true, {}, this.nameTable[paletteItem.children[i]])
            this._updateRenderSize(item, itemSize, nameTable);
            var svg = this._renderItemContainer(item.name, content, null, itemSize, item);
            if (item.segments) {
                this._renderConnector(item, svg, itemSize);
            }
            else if (item._type == "node" && !(item.children && item.children.length > 0))
                this._renderNode(item, svg, itemSize);
            else
                this._renderGroup(item, svg, itemSize, nameTable);
            if (item.isLane && item.paletteItem && !item.paletteItem.enableScale) {
                if (item.orientation === "vertical") {
                    svg.document.setAttribute("height", itemSize.height + 2);
                }
            }
            return item;
        },
        _getPreviewItemSize: function (paletteItem) {
            var width = this.model.previewWidth, height = this.model.previewHeight;
            if (!paletteItem.segments) {
                if (paletteItem.type === "group") {
                    bounds = ej.datavisualization.Diagram.Util._getChildrenBounds(paletteItem, this);
                    if (paletteItem.paletteItem && (!paletteItem.isLane)) {
                        width = paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : width;
                        height = paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : height;
                        width = width ? width : bounds.width;
                        height = height ? height : bounds.height;
                        paletteItem.paletteItem.previewWidth = width;
                        paletteItem.paletteItem.previewHeight = height;
                    }
                    else if (paletteItem.paletteItem && paletteItem.isLane) {
                        if (!paletteItem.paletteItem.enableScale) {
                            width = paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : width;
                            height = paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : height;
                        }
                        else {
                            width = paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : width;
                            height = paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : height;
                            width = width ? width : bounds.width;
                            height = height ? height : bounds.height;
                            paletteItem.paletteItem.previewWidth = width;
                            paletteItem.paletteItem.previewHeight = height;
                        }
                    }
                    else {
                        width = width ? width : bounds.width;
                        height = height ? height : bounds.height;
                    }
                }
                else {
                    if (paletteItem.paletteItem) {
                        width = paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : width;
                        height = paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : height;
                        width = width ? width : paletteItem.width;
                        height = height ? height : paletteItem.height;
                        paletteItem.paletteItem.previewWidth = width;
                        paletteItem.paletteItem.previewHeight = height;
                    }
                    else {
                        var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                        width = bounds.width ? bounds.width : width;
                        height = bounds.height ? bounds.height : height;
                    }
                }
            }
            else {
                var dec, size, bounds;
                bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                if (paletteItem.paletteItem) {
                    width = paletteItem.paletteItem.previewWidth ? paletteItem.paletteItem.previewWidth : width;
                    height = paletteItem.paletteItem.previewHeight ? paletteItem.paletteItem.previewHeight : height;
                    width = width ? width : paletteItem.width;
                    height = height ? height : paletteItem.height;
                    width = width ? width : bounds.width;
                    height = height ? height : bounds.height;
                    paletteItem.paletteItem.previewWidth = width;
                    paletteItem.paletteItem.previewHeight = height;
                }
                else {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(paletteItem);
                    width = width ? width : bounds.width;
                    height = height ? height : bounds.height;
                }
            }
            return { width: width, height: height };
        },
        _renderItemContainer: function (id, content, isDrag, itemSize, item) {
            var container = document.createElement("div");
            var height = this.model.showPaletteItemText ? itemSize.height + 18 : itemSize.height;
            var width = itemSize.width;
            var mLeft = (item && item.paletteItem) ? item.paletteItem.margin.left : 4;
            var mTop = (item && item.paletteItem) ? item.paletteItem.margin.top : 4;
            var mRight = (item && item.paletteItem) ? item.paletteItem.margin.right : 4;
            var mBottom = (item && item.paletteItem) ? item.paletteItem.margin.bottom : 4;
            var attr = {
                "id": id + "_paletteItem", "draggable": "true", "height": height + "px", "width": width + "px", "class": "e-paletteItem",
                "style": "padding-left:" + mLeft + "px;padding-right:" + (mRight + 2) + "px;padding-top:" + (mTop + 1) + "px;padding-bottom:" + (mBottom + 1) + "px;height:" + (height + 1) + "px;width:" + (width + 1) +
                          "px;-ms-touch-action: none;touch-action: none;"
            };
            ej.datavisualization.Diagram.Util.attr(container, attr);
            content.appendChild(container);
            if (this.model.allowDrag)
                this._setItemDraggable(container);
            return this._renderAnchor(container, id, itemSize, item);
        },
        _renderAnchor: function (container, id, itemSize, item) {
            var anchor = document.createElement("div");
            var attr = {
                "id": id + "_anchor", "height": itemSize.height + "px", "class": "e-anchor"
            };
            ej.datavisualization.Diagram.Util.attr(anchor, attr);
            container.appendChild(anchor);
            var svg = this._renderSvg(anchor, id, itemSize);
            this._renderText(anchor, id, itemSize, item);
            return svg;
        },
        _renderSvg: function (anchor, id, itemSize) {
            var parent;
            var wrapper = document.createElement("div");
            var attr = {
                "id": id + "_svgWrapper", "width": this.model.paletteItemWidth + "px;",
                "height": +this.model.paletteItemHeight + "px;", "class": "e-svg-container",
                "style": "width:" + itemSize.width + "px;height:" + itemSize.height + "px;"
            };
            ej.datavisualization.Diagram.Util.attr(wrapper, attr);
            attr = {
                "id": id + "_svg", "width": itemSize.width, "height": itemSize.height,
                "version": "1.1", "xlink": "http://www.w3.org/1999/xlink"
            };
            var svg = new ej.datavisualization.Diagram.Svg(attr);
            wrapper.appendChild(svg.document);
            if (anchor.id.split("_clone").length > 1)
                parent = $(anchor).parents(".e-paletteItem")[0];
            this._renderHtmlLayer(wrapper, parent);
            anchor.appendChild(wrapper);
            return svg;
        },
        _renderText: function (anchor, text, itemSize, item) {
            var div = document.createElement("div");
            div.setAttribute("class", "e-text-container");
            div.setAttribute("style", "width:" + itemSize.width + "px; text-align : center;overflow: hidden;text-overflow: ellipsis;font-size: 12px;");
            var span = document.createElement("span");
            span.setAttribute("class", "e-paletteItemText");
            if (item && item.paletteItem)
                text = item.paletteItem.label ? item.paletteItem.label : text;
            if (text.split("_clone").length > 1)
                span.innerHTML = text.split("_clone")[0];
            else
                span.innerHTML = text;
            if (item && item.paletteItem.wrapping == ej.datavisualization.Diagram.TextWrapping.NoWrap) {
                span.style.whiteSpace = "nowrap";
                span.style.wordWrap = "normal";
            }
            if (item && item.paletteItem.wrapping == ej.datavisualization.Diagram.TextWrapping.Wrap) {
                span.style.whiteSpace = "pre-wrap";
                span.style.wordBreak = "break-all";
                span.style.wordWrap = "break-word";
            }
            if (item && item.paletteItem.wrapping == ej.datavisualization.Diagram.TextWrapping.WrapWithOverflow) {
                span.style.whiteSpace = "pre-wrap";
                span.style.wordWrap = "break-word";
            }
            div.appendChild(span);
            if (!this.model.showPaletteItemText)
                div.style.display = "none";
            anchor.appendChild(div);
            if (item && !item.paletteItem.enableScale) {
                var element = document.getElementById(item.name + "_paletteItem");
                var bounds = document.getElementById(item.name + "_anchor").lastChild.getBoundingClientRect();
                element.style.height = itemSize.height + bounds.height + "px";
            }
        },
        _renderNode: function (node, svg, scaleSize, palette) {
            this._renderPetternDefinition(svg.id + "_" + node.name, svg);
            var group = ej.datavisualization.Diagram.SvgContext.renderNode(node, svg, null, true, this);
            var isDrag = false;
            if (svg.document.getAttribute("drag") != null) {
                isDrag = true;
            }
            this._transformItem(group, node.width, node.height, node, isDrag, scaleSize);
        },
        _updateChildBounds: function (node, nameTable) {
            var child = null;
            if (node._type == "group") {
                var children = this._getChildren(node.children);
                for (var i = 0; i < children.length; i++) {
                    child = nameTable[children[i]];
                    if (child._type == "group")
                        this._updateChildBounds(child, nameTable);
                }
                ej.datavisualization.Diagram.Util._updateChildBounds(node, this);
            }
        },
        _getChildren: function (children) {
            if (children) {
                var children1 = [];
                for (var i = 0; i < children.length; i++) {
                    var child = children[i];
                    if (child) {
                        if (typeof (child) == "object") {
                            children1.push(child.name);
                        }
                        else if (typeof (child) == "string") {
                            children1.push(child);
                        }
                    }
                }
                return children1;
            }
        },
        _renderGroup: function (node, svg, itemSize, nameTable) {
            this._renderPetternDefinition(svg.id + "_" + node.name, svg);
            if (!nameTable) nameTable = this.nameTable;
            if (!node.container || node.isLane) this._updateChildBounds(node, nameTable);
            var group = ej.datavisualization.Diagram.SvgContext.renderGroup(node, svg, null, nameTable, this, false, true);
            var isDrag = false;
            if (svg.document.getAttribute("drag") != null) {
                isDrag = true;
            }
            this._transformItem(group, node.width, node.height, node, isDrag, itemSize);

        },
        _renderConnector: function (connector, svg, itemSize) {
            var group = ej.datavisualization.Diagram.SvgContext.renderConnector(connector, svg, null, this);
            var bounds = ej.datavisualization.Diagram.Util.bounds(connector);
            var isDrag = false;
            if (svg.document.getAttribute("drag") != null) {
                isDrag = true;
            }
            this._transformItem(group, bounds.width, bounds.height, connector, isDrag, itemSize);
        },
        //#endregion
        //#region Events
        _wireEvents: function () {
            this._on(this.element, ej.eventType.click, ".e-header", this._headerClick);
            this._on(this.element, ej.eventType.mouseDown, ".e-header", this._headerMouseDown);
            this._on(this.element, "mouseover", ".e-header", this._headerMouseOver);
            this._on(this.element, "mouseout", ".e-header", this._headerMouseOut);
            this._on(this.element, ej.eventType.mouseDown, ".e-paletteItem", this._itemMouseDown);
            this._on(this.element, "mouseover", ".e-paletteItem", this._itemMouseOver);
            this._on(this.element, "mouseout", ".e-paletteItem", this._itemMouseOut);
            this._on(this.element, ej.eventType.click, ".e-anchor", this._itemClick);
        },
        _headerClick: function (evt) {
            this._expandOrCollapsePalette("", evt.currentTarget);
            var palette = this._getActivePalette(evt.currentTarget.id);
            if (palette && palette !== this.activePalette)
                this.activePalette = palette;
        },
        _headerMouseDown: function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
        },
        _headerMouseOver: function (evt) {
            var palette = this._getActivePalette(evt.currentTarget.id);
            if (palette && this._canExpand(palette)) {
                $(evt.currentTarget).addClass("hover");
                $(evt.currentTarget).find(".e-header-arrow").addClass("hover");
            }
        },
        _headerMouseOut: function (evt) {
            $(evt.currentTarget).removeClass("hover");
            $(evt.currentTarget).find(".e-header-arrow").removeClass("hover");
        },
        _itemMouseDown: function (evt) {
            if (this.model.diagramId) {
                var diagram = $("#" + this.model.diagramId).ejDiagram("instance");
                if (diagram.activeTool instanceof ej.datavisualization.Diagram.LineTool) {
                    diagram.activeTool._showAllPorts(true);
                    diagram.deactivateTool();
                }
            }
            if (!this.model.allowDrag) {
                evt.preventDefault();
                evt.stopPropagation();
            }
            if (this._selectedElement) {
                if (this._selectedElement !== evt.currentTarget) {
                    $(this._selectedElement).removeClass("selected");
                    this._selectedElement = evt.currentTarget;
                }
            }
            else
                this._selectedElement = evt.currentTarget;
            if (!($(evt.currentTarget).hasClass("selected")))
                $(evt.currentTarget).addClass("selected");

            var palette = this._getActivePalette(evt.currentTarget.parentElement.id);
            if (palette && palette !== this.activePalette) {
                this._clearHeaderSelection();
                this._updateHeaderSelection($(evt.currentTarget.parentElement).prev());
                this.activePalette = palette;
            }

            if (this.activePalette && this._selectedElement) {
                var name = this._selectedElement.id.slice(0, this._selectedElement.id.lastIndexOf('_'));
                var items = this.activePalette.items;
                for (var i = 0, len = items.length; i < len; i++) {
                    var item = items[i];
                    if (item.name === name)
                        this.selectedItem = item;
                }
            }
        },
        _itemMouseOver: function (evt) {
            $(evt.currentTarget).addClass("hover");
        },
        _itemMouseOut: function (evt) {
            $(evt.currentTarget).removeClass("hover");
        },
        _itemDraStart: function (evt) {
            var dataTransfer = evt.originalEvent.dataTransfer;
            dataTransfer.setData("Text", this.element[0].id);
            dataTransfer.effectAllowed = "copy";
        },
        _itemClick: function (evt) {
            if (evt.type === "click" || (evt.type === "touchend" && !$(".dragClone")[0])) {
                if (this.model.diagramId) {
                    var diagram = $("#" + this.model.diagramId).ejDiagram("instance");
                    var item = $.extend(true, {}, this.selectedItem);
                    item.name += ej.datavisualization.Diagram.Util.randomId();
                    if (item.type == "bpmn") item.children = [];
                    var type = diagram.getObjectType(item);
                    var swimlane;
                    if (type == "group") {
                        var children = this._getChildren(item.children);
                        for (var j = 0; j < children.length; j++) {
                            var newObj = $.extend(true, {}, this.nameTable[children[j]]);
                            newObj.parent = item.name;
                            newObj.name = item.name + newObj.name;
                            item.children[j] = newObj.name;
                            diagram.nameTable[newObj.name] = newObj;
                            diagram.nodes().push(newObj);
                            diagram._nodes = $.extend(true, [], diagram.nodes());
                            if (diagram.nameTable[newObj])
                                diagram._updateQuad(diagram.nameTable[newObj]);
                        }
                        if (!item.isLane) {
                            item.height = item.width = 0;
                            diagram._updateChildBounds(item, diagram.nameTable);
                        }
                    }
                    if (item) {
                        if (item.isLane) {
                            var randomId = ej.datavisualization.Diagram.Util.randomId();
                            diagram._cloneGroupNode(item, randomId);
                            var obj = ej.datavisualization.Diagram.SwimLaneHelper._createDiagramLane(item, diagram.nameTable);
                            obj.isLane = item.isLane;
                            obj.orientation = item.orientation;
                            obj.height = 120;
                            obj = ej.datavisualization.Diagram.Lane(obj);
                            var swimlane = ej.datavisualization.Diagram.SwimLaneHelper._createSwimlane(obj, diagram, null, true);
                            if (swimlane) {
                                swimlane.offsetX += 10;
                                swimlane.offsetY += 40;
                            }
                        }
                    }
                    var oldElement = $.extend(true, {}, this._oldItem);
                    var newElement = swimlane ? swimlane : item;
                    this._oldItem = $.extend(true, {}, newElement);
                    var args = { oldElement: oldElement, newElement: newElement };
                    this._trigger("selectionChange", args);
                }
            }
        },
        _updatePaletteVisibility: function (palette) {
            if (this._canHeaderVisible(palette)) {
                if (this._canPaletteVisible(palette)) {
                    document.getElementById(palette.name + "_header").style.display = ""
                    document.getElementById(palette.name + "_content").style.display = ""
                }
                else {
                    document.getElementById(palette.name + "_header").style.display = "none"
                    document.getElementById(palette.name + "_content").style.display = "none"
                }
            }
        },
        _collectionChanged: function (args) {
            if (args.changeType == "insert") {
                this._renderPalette(args.element);
            }
            else if (args.changeType == "remove") {
                var palette = args.element;
                if (palette != null) {
                    var paletteHeader = document.getElementById(palette.name + "_header");
                    if (paletteHeader)
                        paletteHeader.parentNode.removeChild(paletteHeader);
                    var paletteContent = document.getElementById(palette.name + "_content");
                    if (paletteContent)
                        paletteContent.parentNode.removeChild(paletteContent);
                }
            }
        },
        //#endregion
        //#region Public methods
        _extendPaletteItem : function (item) {
            var nodeDefault = (this.model.defaultSettings && this.model.defaultSettings.node) ? this.model.defaultSettings.node : null;
            var connectorDefault = (this.model.defaultSettings && this.model.defaultSettings.connector) ? this.model.defaultSettings.connector : null;
            if (item.shape && typeof item.shape == "object")
                ej.datavisualization.Diagram.Util._updateShapeProperties(item);
            else item = ej.datavisualization.Diagram.NodeType(item, this);
            if (item.type == "connector")
                item = ej.datavisualization.Diagram.Connector($.extend(true, {}, connectorDefault, item));
            else {
                if (item.isLane)
                    item = ej.datavisualization.Diagram.SwimLaneHelper._createPaletteLane(item, this.nameTable);
                else if (item.type == "phase")
                    item = ej.datavisualization.Diagram.Util._mapPalettePhase(item);
                else if (item.container)
                    item = ej.datavisualization.Diagram.ContainerHelper._initContainer(this, item);
                else if (item._type === "group" || (item.children && item.children.length > 0)) {
                    item = ej.datavisualization.Diagram.Group($.extend(true, {}, nodeDefault, item));
                    item = ej.datavisualization.Diagram.Util._updateBpmnChild(item, this);
                    this._initGroupNode(item, this);
                    ej.datavisualization.Diagram.Util._updateGroupBounds(item, this);
                }
                else
                    item = ej.datavisualization.Diagram.Node($.extend(true, {}, nodeDefault, item));
            }
            return item;
        },
        addPaletteItem: function (paletteName, items) {
            var content, palette;
            for (var i = 0; i < this.model.palettes.length; i++) {
                var items1 = [];
                if (!items.length)
                    items1.push(items);
                else
                    items1 = items;
                for (var j = 0; j < items1.length; j++) {
                    palette = this.model.palettes[i];
                    if (palette.name === paletteName) {
                        var node = this._extendPaletteItem (items1[j])
                        palette.items.push(node);
                        content = document.getElementById(paletteName + "_content");
                        this.nameTable[node.name] = node;
                        this._renderItem(node, content);
                    }
                }
            }
        },
        removePaletteItem: function (paletteName, items) {
            var content, palette;
            for (var i = 0; i < this.model.palettes.length; i++) {
                var items1 = [];
                if (!items.length)
                    items1.push(items);
                else
                    items1 = items;
                for (var j = 0; j < items1.length; j++) {
                    palette = this.model.palettes[i];
                    if (palette.name === paletteName) {
                        var item = items1[j];
                        ej.datavisualization.Diagram.Util.removeItem(palette.items, item);
                        delete this.nameTable[item.name];
                        if (item.children && item.children.length) {
                            for (var k = 0; k < item.children.length; k++) {
                                var child = item.children[k];
                                if (child) {
                                    if (typeof (child) == "object") {
                                        delete this.nameTable[child.name];
                                    } else {
                                        delete this.nameTable[child];
                                    }
                                }
                            }
                        }
                        content = document.getElementById(paletteName + "_content");
                        var node = $(content).find("#" + item.name + "_paletteItem")[0];
                        if (node) {
                            content.removeChild(node);
                            this.selectedItem = null;
                        }
                    }
                }
            }
        },
        expandPalette: function (paletteName) {
            var palette = this._findPalette(paletteName);
            if (palette && !palette.expanded) {
                if (this._canExpand(palette)) {
                    palette.expanded = true;
                    this._expandOrCollapsePalette(paletteName);
                }
            }
        },
        collapsePalette: function (paletteName) {
            var palette = this._findPalette(paletteName);
            if (palette && palette.expanded) {
                if (this._canExpand(palette)) {
                    palette.expanded = false;
                    this._expandOrCollapsePalette(paletteName);
                }
            }
        },
        addPalette: function (palette) {
            this.model.palettes.push(palette);
            this._renderPalette(palette);
        },
        removePalette: function (paletteName) {
            var paletteHeader, paletteContent, palette;
            for (var i = 0; i < this.model.palettes.length; i++) {
                palette = this.model.palettes[i];
                if (palette.name === paletteName) {
                    ej.datavisualization.Diagram.Util.removeItem(this.model.palettes, palette);
                    paletteHeader = document.getElementById(palette.name + "_header");
                    if (paletteHeader)
                        paletteHeader.parentNode.removeChild(paletteHeader);
                    paletteContent = document.getElementById(palette.name + "_content");
                    if (paletteContent)
                        paletteContent.parentNode.removeChild(paletteContent);
                }
            }
        },
        setWidth: function (value) {
            this.model.width = value;
            this._setWidth(value);
        },
        setHeight: function (value) {
            this.model.height = value;
            this._setHeight(value);
        },
        setPaletteItemWidth: function (value) {
            this.model.paletteItemWidth = value;
            this._redrawContent();
        },
        setPaletteItemHeight: function (value) {
            this.model.paletteItemHeight = value;
            this._redrawContent();
        },
        setHeaderHeight: function (value) {
            this.model.headerHeight = value;
            this._setHeaderHeight(value);
        },
        setCssClass: function (value) {
            this._setCssClass(value);
            this.model.cssClass = value;
        },
        showPaletteItemText: function (value) {
            this._showItemText(value);
            this.model.showPaletteItemText = value;
        },
        searchPalette: function (palette, key) {
            var paletteCollection = new ej.datavisualization.Diagram.Collection();
            var paletteItems = null;
            if (key != "") {
                palette = this._getSearchPaletteItems(key);
                paletteCollection.add(palette);
            }
            return paletteCollection;
        },
        updatePalette: function (paletteName, args) {
            var palette = this._findPalette(paletteName);
            if (palette && args) {
                if (args.constraints && (palette.constraints != args.constraints)) {
                    palette.constraints = args.constraints;
                    var header = document.getElementById(palette.name + "_header");
                    this._renderHeaderArrow(header, palette.expanded, palette.name, this._canExpand(palette));
                    this._disableClickClass(header, this._canExpand(palette));
                    this._updatePaletteVisibility(palette);
                    if (this._canHeaderVisible(palette) && this._canPaletteVisible(palette))
                        header.style.display = "";
                    else
                        header.style.display = "none";

                }
                if (args.expanded != undefined) {
                    if (this._canExpand(palette)) {
                        palette.expanded = args.expanded;
                        this._expandOrCollapsePalette(paletteName);
                    }
                }
                if (args.items && args.items.length > 0) {
                    var paletteContent = document.getElementById(palette.name + "_content");
                    paletteContent.innerHTML = "";
                    palette.items = args.items;
                    this._initPaletteitems(palette);
                    this._renderContent(palette);
                }

            }
            this.updateScrollerViewport();
        },
        //#endregion
        //#region Helper methods
        _findPalette: function (paletteName) {
            var palette;
            for (var i = 0; i < this.model.palettes.length; i++) {
                if (this.model.palettes[i].name == paletteName) {
                    palette = this.model.palettes[i];
                    break;
                }
            }
            return palette;
        },
        _canExpand: function (palette) {
            return palette.constraints & ej.datavisualization.Diagram.PaletteConstraints.Expandable;
        },
        _canHeaderVisible: function (palette) {
            return palette.constraints & ej.datavisualization.Diagram.PaletteConstraints.HeaderVisibility;
        },
        _canPaletteVisible: function (palette) {
            return palette.constraints & ej.datavisualization.Diagram.PaletteConstraints.Visible;
        },

        _canClick: function (header) {
            if (header) {
                var paletteName = (header.id).split("_header")[0];
                if (paletteName) {
                    var palette = this._findPalette(paletteName);
                    if (this._canExpand(palette)) {
                        return true;
                    }
                }
            }
        },
        _expandOrCollapsePalette: function (paletteName, header) {
            var header = header || (paletteName ? document.getElementById(paletteName + "_header") : null);
            if (header) {
                if (this._canClick(header)) {
                    var proxy = this;
                    $(header).next(".e-scontent").slideToggle(200, function () {
                        proxy._refresh();
                    });
                    this._updateHeaderState(header);
                }
                else return false;
            }
        },
        _getSearchPaletteItems: function (key) {
            var palette = new ej.datavisualization.Diagram.Palette();
            var palettes = this.model.palettes, i, j;
            for (i = 0; i < palettes.length; i++) {
                if ((((palettes[i].name).toLocaleLowerCase()).search(key.toLocaleLowerCase())) >= 0) {
                    for (j = 0; j < palettes[i].items.length; j++) {
                        this.element.find("#" + palettes[i].items[j].name + "_paletteItem")[0].style.display = "block";
                    }
                }
                else {
                    for (j = 0; j < palettes[i].items.length; j++) {
                        if ((((palettes[i].items[j].name).toLocaleLowerCase()).search(key.toLocaleLowerCase())) >= 0) {
                            this.element.find("#" + palettes[i].items[j].name + "_paletteItem")[0].style.display = "block";
                        }
                        else
                            this.element.find("#" + palettes[i].items[j].name + "_paletteItem")[0].style.display = "none";
                    }
                }
            }
            return palette;
        },
        _disableClickClass: function (element, disable) {
            if (disable)
                $(element).removeClass("e-disableclick");
            else
                $(element).addClass("e-disableclick");
        },
        _addExpandedClass: function (element, expanded) {
            if (expanded)
                $(element).addClass("expanded");
            else
                $(element).addClass("collapsed");
        },
        _collapse: function (palette) {
            if (!palette.expanded)
                $(document.getElementById(palette.name + "_header")).next(".e-scontent").slideToggle(10);

        },
        _transformItem: function (group, width, height, node, isDrag, scaleSize) {
            if (!isDrag) {
                if (scaleSize && !node.segments && node.paletteItem && node.paletteItem.width && node.paletteItem.height && node.paletteItem.enableScale) {
                    var fx = (30 * scaleSize.width) / 100;
                    var fy = (30 * scaleSize.height) / 100;
                    var sx = (scaleSize.width - fx) / node.width;
                    var sy = (scaleSize.height - fy) / node.height;
                    sx = sy = Math.min(sx, sy);
                    sx = sx > 1 ? 1 : sx;
                    sy = sy > 1 ? 1 : sy;
                    var translate1 = ((scaleSize.width) / 2 - (width * sx) / 2);
                    var translate2 = ((scaleSize.height) / 2 - (height * sy) / 2);
                    var transform = "";
                    //translate
                    transform += "translate(" + translate1 + "," + translate2 + ")";
                    //scale
                    transform += "scale(" + sx + "," + sy + ")";
                    group.setAttribute("transform", transform);
                    var htmlLayer = group.parentNode.nextSibling;
                    if (!htmlLayer) htmlLayer = document.getElementById(group.id + "_svgWrapper_htmlLayer");
                    htmlLayer.style.webkitTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                    htmlLayer.style.MozTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                    htmlLayer.style.OTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                    htmlLayer.style.msTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                    htmlLayer.style.transform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                    if (node && ej.browserInfo().name === "msie") {
                        if (node._type == "group" && node.type === "html") {
                            var htmlDiv = document.getElementById(node.name + "_html");
                            htmlDiv.setAttribute("style", "zoom:" + scale + ";");
                        }
                    }
                }
                else if (!node.segments) {
                    var xd = width / (width + (node.borderWidth * 3));
                    var yd = height / (height + (node.borderWidth * 3));
                    var x = (width - (width * xd)) / 2;
                    var y = (height - (height * yd)) / 2;
                    group.childNodes[0].setAttribute("transform", "scale(" + xd + "," + yd + ") translate(" + x + "," + y + ")");
                    if (node && node.type === "image" && group.childNodes[1]) {
                        group.childNodes[1].setAttribute("transform", "scale(" + xd + "," + yd + ") translate(" + x + "," + y + ")");
                    }
                    else if (node && node._type === "group") {
                        group.setAttribute("transform", "scale(" + xd + "," + yd + ") translate(" + x + "," + y + ")");
                    }
                }
                else {
                    if (scaleSize && node.paletteItem && node.paletteItem.width && node.paletteItem.height || (node.isPhase && node.paletteItem && node.paletteItem.enableScale)) {
                        var fx = (10 * scaleSize.width) / 100;
                        var fy = (10 * scaleSize.height) / 100;
                        var sx = (scaleSize.width - fx) / width;
                        var sy = (scaleSize.height - fy) / height;
                        sx = sy = Math.min(sx, sy);
                        sx = sx > 1 ? 1 : sx;
                        sy = sy > 1 ? 1 : sy;
                        var translate1 = ((scaleSize.width) / 2 - (width * sx) / 2);
                        var translate2 = ((scaleSize.height) / 2 - (height * sy) / 2);
                        var transform = "";
                        //translate
                        transform += "translate(" + translate1 + "," + translate2 + ")";
                        //scale
                        transform += "scale(" + sx + "," + sy + ")";
                        group.setAttribute("transform", transform);
                        var htmlLayer = document.getElementById(group.id + "_svgWrapper_htmlLayer");
                        htmlLayer.style.webkitTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                        htmlLayer.style.MozTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                        htmlLayer.style.OTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                        htmlLayer.style.msTransform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                        htmlLayer.style.transform = "translate(" + translate1 + "px," + translate2 + "px) scale(" + sx + ", " + sy + ")";
                        if (node && ej.browserInfo().name === "msie") {
                            if (node._type == "group" && node.type === "html") {
                                var htmlDiv = document.getElementById(node.name + "_html");
                                htmlDiv.setAttribute("style", "zoom:" + scale + ";");
                            }
                        }
                    }
                }
            }
        },
        _getScaleFactor: function (width, height) {
            var fx = (30 * this.model.paletteItemWidth) / 100;
            var fy = (30 * this.model.paletteItemHeight) / 100;
            var sx = (this.model.paletteItemWidth - fx) / width;
            var sy = (this.model.paletteItemHeight - fy) / height;
            sx = sx > 1 ? 1 : sx;
            sy = sy > 1 ? 1 : sy;
            return Math.min(sx, sy);
        },
        _getTranslateFactor: function (width, height) {
            var x = (15 / 100) * this.model.paletteItemWidth;
            var y = (15 / 100) * this.model.paletteItemHeight;
            return Math.min(x, y);
        },
        _setWidth: function (val) {
            this.element.css("width", val);
        },
        _setHeight: function (val) {
            this.element.css("height", val);
        },
        _setHeaderHeight: function (val) {
            this.element.find(".e-header").css("height", val);
            this.element.find(".e-header-arrow").css("top", (val - 16) / 2);
            for (var i = 0; i < this.model.palettes.length; i++) {
                var palette = this.model.palettes[i];
                if (palette) {
                    this._updateHeaderWrapper(palette, val);
                }
            }
            this.updateScrollerViewport();
        },
        _updateHeaderWrapper: function (palette, val) {
            var paletteWrapper = document.getElementById(palette.name + "_Wrapper");
            if (paletteWrapper) {
                var bounds = paletteWrapper.getBoundingClientRect();
                if (bounds.height > 0)
                    paletteWrapper.style.marginTop = val / 2 - bounds.height / 2 + "px";
            }
        },
        _setCssClass: function (val) {
            this.element.removeClass(this.model.cssClass).addClass(val);
        },
        _showItemText: function (val) {
            if (val !== this.model.showPaletteItemText)
                if (val) {
                    this.element.find(".e-text-container").show();
                }
                else
                    this.element.find(".e-text-container").hide();
        },
        _setAllowDrag: function (val) {
            this.model.allowDrag = val;
            var palettes = this.model.palettes;
            var container;
            if (palettes) {
                for (var i = 0; i < palettes.length; i++) {
                    var paletteItems = palettes[i].items;
                    if (paletteItems) {
                        for (var j = 0; j < paletteItems.length; j++) {
                            container = document.getElementById(paletteItems[j].name + "_paletteItem");
                            if (this.model.allowDrag)
                                this._setItemDraggable(container);
                            else
                                $(container).ejDraggable("instance").destroy();
                        }
                    }
                }
            }
        },
        _cloneNode: function (node) {
            var id = ej.datavisualization.Diagram.Util.randomId(), obj;
            if (node.children && node.children.length > 0) {
                for (var i = 0; i < node.children.length; i++) {
                    obj = this._cloneChildren(node.children[i], id);
                    this.nameTable[obj.name] = obj;
                    node.children[i] = obj.name;
                }
            }
            node.name += id;
            return node;
        },
        _cloneChildren: function (child, id) {
            if (typeof (child) === "object") {
                obj = $.extend(true, {}, child);
                obj.parent += id;
                obj.name += id;
                return obj;
            }
            else if (typeof (child) === "string") {
                var obj = this.nameTable[child];
                if (obj) {
                    obj = this._cloneChildren(obj, id);
                    return obj;
                }
            }
        },
        _setItemDraggable: function (container) {
            var paletteId = this.element[0].id;
            var context = this;
            $(container).ejDraggable({
                clone: true,
                cursorAt: { top: context.model.previewOffset.y, left: context.model.previewOffset.x },
                helper: function (event) {
                    var diagram = $("#" + context.model.diagramId).ejDiagram("instance");
                    var paletteItemWidth, paletteItemHeight;
                    paletteItemWidth = context.model.paletteItemWidth;
                    paletteItemHeight = context.model.paletteItemHeight;
                    diagram._selectedSymbol = context.selectedItem;
                    diagram._symbolPalette = context.model;
                    var item = $.extend(true, {}, context.selectedItem);
                    //if (item.type != "bpmn")
                    item = context._cloneNode(item);
                    if (item.isLane) {
                        context.model.paletteItemWidth = (item.paletteItem && item.paletteItem.previewWidth) ? item.paletteItem.previewWidth : context.model.previewWidth;
                        context.model.paletteItemHeight = (item.paletteItem && item.paletteItem.previewHeight) ? item.paletteItem.previewHeight : context.model.previewHeight;
                    }
                    var previewSize = context._getPreviewItemSize(context.selectedItem);
                    var svg = context._renderItemContainer(context.selectedItem.name + "_clone", document.body, true, previewSize);
                    svg.document.setAttribute("drag", "true");
                    diagram._paletteTable = context.nameTable;
                    diagram._palNameTable = $.extend(true, {}, context.nameTable);
                    if (item.segments) {
                        var bounds = ej.datavisualization.Diagram.Util.bounds(item);
                        var delWidth = (previewSize.width - 10) / bounds.width;
                        var delHeight = (previewSize.height - 10) / bounds.height;
                        ej.datavisualization.Diagram.Util.scale(item, delWidth, delHeight, bounds.topLeft, diagram.nameTable);
                        context._renderConnector(item, svg, previewSize);
                    }
                    else {
                        if ((item.isLane && item.paletteItem && !item.paletteItem.enableScale)) {
                            item.width = previewSize.width;
                            item.height = previewSize.height;
                            item.offsetX = item.width / 2;
                            item.offsetY = item.height / 2;
                        }
                        else if (item._type == "group") {
                            var nameTable = []
                            var deltaWidth = previewSize.width / item.width;
                            var deltaHeight = previewSize.height / item.height;
                            context.scale(item, deltaWidth, deltaHeight, item.pivot, context.nameTable, null, null, null, context);
                            ej.datavisualization.Diagram.Util._translate(item, item.width / 2 - item.offsetX, item.height / 2 - item.offsetY, context.nameTable, null, context);
                        }
                        else {
                            item.width = previewSize.width - 10;
                            item.height = previewSize.height - 10;
                            if (previewSize) {
                                previewSize.width = previewSize.width - 10;
                                previewSize.height = previewSize.height - 10;
                            }
                            item.offsetX = item.width / 2 + 10;
                            item.offsetY = item.height / 2 + 1;
                        }
                        context._updatePreviewSize(item, previewSize);
                        if (item._type == "node")
                            context._renderNode(item, svg, previewSize);
                        else {
                            context._renderGroup(item, svg);
                        }
                    }
                    var helper = document.getElementById(context.selectedItem.name + "_clone_paletteItem");
                    $(helper).addClass("dragClone");
                    context.model.paletteItemWidth = paletteItemWidth;
                    context.model.paletteItemHeight = paletteItemHeight;
                    return $(helper);
                },
                drag: function () {
                    var element = this.helper[0];
                    $("#" + context.selectedItem.name + "_clone_svg").css("padding", "2px");
                    $("#" + context.selectedItem.name + "_clone_svg").siblings(".htmlLayer").css("padding", "2px");
                    if (element) {
                        element.setAttribute("paletteId", paletteId);
                    }
                },
                dragStop: function (event, ui) {
                    var isTouch = false;
                    if (event.event && event.event.originalEvent && event.event.originalEvent.changedTouches) {
                        isTouch = true;
                    }
                    else if (event.event && event.event.changedTouches) {
                        isTouch = true;
                    }
                    var diagram = $("#" + context.model.diagramId).ejDiagram("instance");
                    if (isTouch && diagram._isDropOver) {
                        diagram._svgdrop(event.event, this);
                        diagram._isDropped = true;
                    }
                    diagram._selectedSymbol = null;
                    $(this.helper).remove();
                }
            });
        },
        _redrawContent: function () {
            var contents = this.element.find(".e-scontent");
            for (var i = 0, len = contents.length; i < len; ++i) {
                var content = contents[i];
                $(content).empty();
                var palette = this.model.palettes[i];
                var paletteItems = palette.items;
                if (paletteItems && paletteItems.length > 0) {
                    for (var count = 0, l = paletteItems.length; count < l; count++) {
                        this._renderItem(paletteItems[count], content);
                    }
                }
            }
        },
        _getPalette: function (name) {
            var palettes = this.model.palettes;
            for (var i = 0, len = palettes.length; i < len; i++) {
                var palette = palettes[i];
                if (palette.name === name && palette !== this.activePalette)
                    return palette;
            }
            return null;
        },
        _getActivePalette: function (elementId) {
            var name = elementId.slice(0, elementId.lastIndexOf('_'));
            return this._getPalette(name);;
        },
        _updateHeaderState: function (target) {
            this._clearHeaderSelection();
            this._updateExpandState(target);
            this._updateHeaderSelection(target);
        },
        _updateExpandState: function (target) {
            if (($(target).hasClass("expanded"))) {
                $(target).removeClass("expanded").addClass("collapsed");
                $(target).find(".e-header-arrow").removeClass("expanded").addClass("collapsed");
                $(target).attr("aria-expanded", "false");
                $(target).attr("aria-selected", "false");
            }
            else {
                $(target).removeClass("collapsed").addClass("expanded");
                $(target).find(".e-header-arrow").removeClass("collapsed").addClass("expanded");
                $(target).attr("aria-selected", "true");
                $(target).attr("aria-expanded", "true");
            }
        },
        _updateHeaderSelection: function (target) {
            if (!($(target).hasClass("selected"))) {
                $(target).addClass("selected");
                $(target).find(".e-header-arrow").addClass("selected");
            }
        },
        _clearHeaderSelection: function () {
            this.element.find(".e-header").removeClass("selected");
            this.element.find(".e-header-arrow").removeClass("selected");
        },
        _addItem: function (palette, item) {
            var content = document.getElementById(palette.name + "_content");
            this._renderItem(item, content);
        },
        _removeItem: function (palette, item) {
            var content = document.getElementById(palette.name + "_content");
            content.removeChild(document.getElementById(item.name + "_paletteItem"));
            if (item === this._selectedElement)
                this._selectedElement = null;
        },
        updateScrollerViewport: function () {
            var scroller = this.element.ejScroller("instance");
            scroller.model.touchScroll = false;
            scroller.model.width = this._setViewPortWidth();
            scroller.model.height = this._setViewPortHeight();
            this._refresh();
        },
        _refresh: function () {
            this.element.ejScroller("refresh");
        },
        _getNodeDimension: function (node) {
            var prevWidth = node._width, prevHeight = node._height;
            var width = node.width ? node.width : (node.maxWidth ? node.maxWidth : node.minWidth);
            var text = document.createElement("span");
            var w = 0, h = 0, label, i;
            if (node.labels.length) {
                ej.datavisualization.Diagram.Util.attr(text, { "id": node.name + "_label", "class": "ej-d-label", "style": "display: inline-block; position: absolute; pointer-events: all; line-height: normal;" });
                this.element[0].appendChild(text);
                for (i = 0; i < node.labels.length; i++) {
                    label = node.labels[i];
                    if (label.bold) text.style.fontWeight = "bold";
                    if (label.italic) text.style.fontStyle = "italic";
                    text.style.textDecoration = label.textDecoration;
                    text.style.fontFamily = label.fontFamily;
                    text.style.fontSize = label.fontSize + "px";
                    text.style.color = label.fontColor;
                    text.style.backgroundColor = label.fillColor;
                    text.style.borderColor = label.borderColor;
                    text.style.borderWidth = label.borderWidth;
                    text.textContent = label.text;
                    text.style.wordWrap = "break-word";
                    text.style.whiteSpace = "pre";
                    if (width) text.style.maxWidth = width - (label.margin.left + label.margin.right) - label.fontSize + "px";
                    w += text.offsetWidth + label.margin.left + label.margin.right;
                    h += text.offsetHeight + label.margin.top + label.margin.bottom;
                }
                node._width = w;
                node._height = h;
                if (node.minWidth && (node.minWidth > node._width || !node._width)) node._width = node.minWidth;
                if (node.maxWidth && (node.maxWidth < node._width || !node._width)) node._width = node.maxWidth;
                if (node.minHeight && (node.minHeight > node._height || !node._height)) node._height = node.minHeight;
                if (node.maxHeight && (node.maxHeight < node._height || !node._height)) node._height = node.maxHeight;
                if (!node.width && node.labels[0].horizontalAlignment == "left") node.offsetX += (node._width - prevWidth) * (1 - node.pivot.x);
                if (!node.width && node.labels[0].horizontalAlignment == "right") node.offsetX -= (node._width - prevWidth) * node.pivot.x;
                if (!node.height && node.labels[0].verticalAlignment == "top") node.offsetY += (node._height - prevHeight) * (1 - node.pivot.y);
                if (!node.height && node.labels[0].verticalAlignment == "bottom") node.offsetY -= (node._height - prevHeight) * node.pivot.y;
                this.element[0].removeChild(text);
            }
        },
        _getNewNode: function (options) {
            if (options.shape && typeof options.shape === "object")
                ej.datavisualization.Diagram.Util._updateShapeProperties(options);
            return ej.datavisualization.Diagram.Node($.extend(true, {}, this.model.defaultSettings.node, options));
        },
        _getNewGroup: function (options) {
            if (options.type == "bpmn") options = ej.datavisualization.Diagram.Util._updateBpmnChild(ej.datavisualization.Diagram.Node(options), this);
            return ej.datavisualization.Diagram.Group($.extend(true, {}, this.model.defaultSettings.group, options));
        },
        scale: function (node, sw, sh, pivot, nameTable, skipScalOnChild, updateMinMax, isHelper, diagram) {
            var matrix = ej.Matrix.identity();
            if (!node.segments) {
                if (node._type === "group") {
                    var nodes = node.children;
                    var child;
                    for (var i = 0; i < nodes.length; i++) {
                        child = nameTable[typeof nodes[i] == "string" ? nodes[i] : nodes[i].name];
                        if (child) {
                            this.scale(child, sw, sh, pivot, nameTable);
                            if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], diagram);
                        }
                    }
                    ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                }
                ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                var newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                var width = node.width * sw;
                var height = node.height * sh;
                if (width > 1) {
                    node.width = width;
                    node.offsetX = newPosition.x;
                }
                if (height > 1) {
                    node.height = height;
                    node.offsetY = newPosition.y;
                }
            } else {
                ej.Matrix.scale(matrix, sw, sh, pivot.x, pivot.y);
                for (var i = 0; i < node.segments.length; i++) {
                    var segment = node.segments[i];
                    for (var j = 0; j < segment.points.length; j++) {
                        segment.points[j] = ej.Matrix.transform(matrix, segment.points[j]);
                        if (i == 0 && j == 0 && !node.sourceNode) {
                            segment._startPoint = segment.points[0];
                            segment._endPoint = segment.points[segment.points.length - 1];
                            ej.datavisualization.Diagram.Util._setLineEndPoint(node, ej.Matrix.transform(matrix, node.sourcePoint), false);
                        }
                        if (i == node.segments.length - 1 && j == segment.points.length - 1 && !node.targetNode) {
                            segment._startPoint = segment.points[0];
                            segment._endPoint = segment.points[segment.points.length - 1];
                            node.targetPoint = segment._endPoint;
                        }
                    }
                    segment._startPoint = segment.points[0];
                    segment._endPoint = segment.points[segment.points.length - 1];
                    if (segment.type == "orthogonal") {
                        if (segment.length || segment.length === 0)
                            segment.length = segment._length = ej.datavisualization.Diagram.Geometry.distance(segment._startPoint, segment._endPoint);
                        else
                            ej.datavisualization.Diagram.Util._addOrthogonalPoints(segment, node.segments[i - 1], node.segments[i + 1], node.sourcePoint, node.targetPoint);
                    } else {
                        if (segment.point) {
                            segment.point = segment._endPoint;
                        }
                        segment._point = segment._endPoint;
                    }
                }
            }
        },
        _translate: function (node, dx, dy, nameTable, isContainer, diagram) {
            // if (ej.datavisualization.Diagram.Util.canMove(node))
            {
                if (!node.segments) {
                    node.offsetX += dx;
                    node.offsetY += dy;
                    if (node._type === "group" && !isContainer) {
                        var nodes = diagram._getChildren(node.children);
                        var child;
                        for (var i = 0; i < nodes.length; i++) {
                            child = nameTable[nodes[i]];
                            this._translate(child, dx, dy, nameTable, null, diagram);
                            if (child.parent && (child.parent != node.name && node.type != "pseudoGroup"))
                                ej.datavisualization.Diagram.Util._updateGroupBounds(nameTable[child.parent], diagram);
                        }
                        if (node._type != "group" && node.container)
                            ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                    }
                } else {
                    ej.datavisualization.Diagram.Util._translateLine(node, dx, dy, node);
                }
            }
        },
        //#endregion
    });
    //#endregion
})(jQuery, Syncfusion);;


(function ($, ej) {
    "use strict";
    //#region Extends
    ej.datavisualization.Diagram.extend = function (d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
        function __() { this.constructor = d; }
        __.prototype = b.prototype;
        d.prototype = new __();
    }
    //#endregion

    //#region Tool
    var ToolBase = (function () {
        function ToolBase(name, diagram) {
            this.name = name;
            this.diagram = diagram;
            this.helper = null;
            this.inAction = false;
            this.selectedObject = null;
            this.startPoint = ej.datavisualization.Diagram.Point(0, 0);
            this.currentPoint = ej.datavisualization.Diagram.Point(0, 0);
            this.previousPoint = ej.datavisualization.Diagram.Point(0, 0);
            this.cursor = "default";
            this._currentPossibleConnection = null;
            this._previousPossibleConnection = null;
            this._possibleConnectionPort = null;
            this.singleAction = false;
            this.svgHelper = null;
            this.single = null;
            this._centralPoint = ej.datavisualization.Diagram.Point(0, 0);
            this._enableAutoNode = null;
            this._prevTool = null;
            this.activeLabel = null;
            this._adjustLines = {
                lines: []
            }
        }
        ToolBase.prototype.abort = function (evt) {
            this._endAction();
            if (this.diagram.selectionList && this.diagram.selectionList[0])
                ej.datavisualization.Diagram.SvgContext.updateSelector(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom, this.diagram, this.diagram.model.selectedItems.constraints);
            this.diagram._removeTooltip();
        };
        ToolBase.prototype._snapTop = function (horizontalsnap, verticalsnap, delx, dely, shape, ended) {
            var dify = dely;
            verticalsnap.top = true;
            horizontalsnap.left = horizontalsnap.right = false;
            var snapSettings = this.diagram.model.snapSettings;
            var zoomFactor = this.diagram._currZoom;
            if (this.diagram._enableSnapToObject() && !shape.rotateAngle &&
                (!this.selectedObject.isLane && !this.selectedObject.isSwimlane)) {
                var y = this.initialBounds.y - this.initialBounds.height * shape.pivot.y + dely - (shape.offsetY - shape.height * shape.pivot.y);
                ej.datavisualization.Diagram.SnapUtil._snapSize(this.diagram, horizontalsnap, verticalsnap, delx, y, this.selectedObject, ended);
            }
            if (!verticalsnap.snapped) {
                if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToHorizontalLines) {
                    var top = this.initialBounds.y - this.initialBounds.height * shape.pivot.y;
                    var actualTop = top + dely;
                    var roundedTop = ej.datavisualization.Diagram.SnapUtil._round(actualTop, snapSettings.horizontalGridLines.snapInterval, zoomFactor);
                    dify = roundedTop - top;
                }
            }
            else {
                dify = (dely - y) + verticalsnap.offset;
            }
            return dify;
        };
        ToolBase.prototype._getSwimLaneStackIndex = function (node) {
            var index = null;
            if (node.container.type == "canvas") {
                if (node.parent)
                    var parent = this.diagram.nameTable[node.parent];
                if (parent) {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    if (parent.container.orientation === "vertical") {
                        if (this.currentPoint.y >= bounds.y && this.currentPoint.y < bounds.center.y) {
                            index = this._getIndex(parent.children, node);
                        }
                        else {
                            index = this._getIndex(parent.children, node) + 1;
                        }
                    }
                    else {
                        if (this.currentPoint.x >= bounds.x && this.currentPoint.x < bounds.center.x) {
                            index = this._getIndex(parent.children, node);
                        }
                        else {
                            index = this._getIndex(parent.children, node) + 1;
                        }
                    }
                }
            }
            return index;
        };
        ToolBase.prototype._getIndex = function (list, node) {
            if (list && node) {
                var child = null;
                for (var i = 0; i < list.length; i++) {
                    child = this.diagram.nameTable[this.diagram._getChild(list[i])];
                    if (child) {
                        if (child.name == node.name)
                            return i;
                    }
                }
            }
            else return -1;
        };
        ToolBase.prototype._snapLeft = function (horizontalsnap, verticalsnap, delx, dely, shape, ended) {
            var difx = delx;
            horizontalsnap.left = true;
            verticalsnap.top = verticalsnap.bottom = false;
            var snapSettings = this.diagram.model.snapSettings;
            var zoomFactor = this.diagram._currZoom;
            if (this.diagram._enableSnapToObject() && !shape.rotateAngle &&
                (!this.selectedObject.isLane && !this.selectedObject.isSwimlane)) {
                var x = this.initialBounds.x - this.initialBounds.width * shape.pivot.x + delx - (shape.offsetX - shape.width * shape.pivot.x);
                ej.datavisualization.Diagram.SnapUtil._snapSize(this.diagram, horizontalsnap, verticalsnap, x, dely, this.selectedObject, ended);;
            }
            var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
            if (!horizontalsnap.snapped) {
                if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToVerticalLines) {
                    var left = this.initialBounds.x - this.initialBounds.width * shape.pivot.x;
                    var actualLeft = left + delx;
                    var roundedLeft = ej.datavisualization.Diagram.SnapUtil._round(actualLeft, snapSettings.horizontalGridLines.snapInterval, zoomFactor);
                    difx = roundedLeft - left;
                }
            }
            else {
                difx = (delx - x) + horizontalsnap.offset;
            }
            return difx;
        };
        ToolBase.prototype._snapBottom = function (horizontalsnap, verticalsnap, delx, dely, shape, ended, disableSnap) {
            var dify = dely;
            if (!this.diagram._disableSnap) {
                verticalsnap.bottom = true;
                horizontalsnap.left = horizontalsnap.right = false;
                var snapSettings = this.diagram.model.snapSettings;
                var zoomFactor = this.diagram._currZoom;
                if (this.diagram._enableSnapToObject() && !shape.rotateAngle &&
                       (!this.selectedObject.isLane && !this.selectedObject.isSwimlane)) {
                    var y = this.initialBounds.y + this.initialBounds.height * (1 - shape.pivot.y) + dely - (shape.offsetY + shape.height * (1 - shape.pivot.y));
                    ej.datavisualization.Diagram.SnapUtil._snapSize(this.diagram, horizontalsnap, verticalsnap, delx, y, this.selectedObject, ended);;
                }
                var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
                if (!verticalsnap.snapped) {
                    if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToHorizontalLines) {
                        var bottom = this.initialBounds.y + this.initialBounds.height * (1 - shape.pivot.y);
                        var actualBottom = bottom + dely;
                        var roundedBottom = ej.datavisualization.Diagram.SnapUtil._round(actualBottom, snapSettings.horizontalGridLines.snapInterval, zoomFactor);
                        dify = roundedBottom - bottom;
                    }
                }
                else {
                    dify = (dely - y) + verticalsnap.offset;
                }
            }
            return dify;
        };

        ToolBase.prototype._snapRight = function (horizontalsnap, verticalsnap, delx, dely, shape, ended, disableSnap) {
            var difx = delx;
            if (!this.diagram._disableSnap) {
                horizontalsnap.right = true;
                verticalsnap.top = verticalsnap.bottom = false;
                var snapSettings = this.diagram.model.snapSettings;
                var zoomFactor = this.diagram._currZoom;
                if (this.diagram._enableSnapToObject() && !shape.rotateAngle &&
                       (!this.selectedObject.isLane && !this.selectedObject.isSwimlane)) {
                    var x = this.initialBounds.x + this.initialBounds.width * (1 - shape.pivot.x) + delx - (shape.offsetX + shape.width * (1 - shape.pivot.x));
                    ej.datavisualization.Diagram.SnapUtil._snapSize(this.diagram, horizontalsnap, verticalsnap, x, dely, this.selectedObject, ended);
                }
                if (!horizontalsnap.snapped) {
                    if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToVerticalLines) {
                        var right = this.initialBounds.x + this.initialBounds.width * (1 - shape.pivot.x);
                        var actualRight = right + delx;
                        var roundedRight = ej.datavisualization.Diagram.SnapUtil._round(actualRight, snapSettings.verticalGridLines.snapInterval, zoomFactor);
                        difx = roundedRight - right;
                    }
                }
                else {
                    difx = (delx - x) + horizontalsnap.offset;
                }
            }

            return difx;
        };

        ToolBase.prototype.keydown = function (evt) {
            var keycode = evt.keyCode ? evt.keyCode : evt.which;
            if (keycode === 27 && this.inAction) {

                if (this.diagram._selectedSymbol) {
                    this.diagram._documentmouseup(evt);
                    this._removeHighLighter();
                    ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
                    this.diagram._selectedSymbol = null;
                }
                else {
                    if (this.seletedObject || this.selectedObject) {
                        if (this.selectedObject) {
                            ej.datavisualization.Diagram.SvgContext._enableSelectedNode(this.selectedObject, this.diagram._svg, this.diagram);
                            ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                        }
                        if (this.seletedObject) {
                            ej.datavisualization.Diagram.SvgContext._enableSelectedNode(this.seletedObject, this.diagram._svg, this.diagram);
                            ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.seletedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                        }
                        this._removeHighLighter();
                        ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
                    }
                }
                this.abort();
            }
            else if (keycode === 46 && this.inAction) {
                if (this.diagram._selectedSymbol) {
                    this.diagram._documentmouseup(evt);
                    this.diagram._selectedSymbol = null;
                }
                this.abort();
            }
            else if (!this.inAction && keycode == 27) {
                this.diagram._clearSelection();
            }
        };
        ToolBase.prototype._getSwimlaneHeader = function (group) {
            var header;
            if (group && group.isSwimlane) {
                if (group.children && group.children.length > 0) {
                    header = this.diagram.nameTable[group.children[0]];
                }
            }
            return header;
        };
        ToolBase.prototype._removeHelpers = function () {
            ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
            ej.datavisualization.Diagram.SvgContext._removeConnectorHighlighter(this.diagram._adornerLayer, this.diagram._adornerSvg);
            this._removeHighLighter();
        };
        ToolBase.prototype._cloneGroupNode = function (node, id) {
            var child = null, child1, clnObj, node1;
            node1 = $.extend(true, {}, node);
            node1.name += id;
            if (node && node._type === "group") {
                node1.children = [];
                var children = this.diagram._getChildren(node.children);
                for (var i = 0; i < children.length; i++) {
                    child = this.diagram.nameTable[children[i]];
                    child1 = $.extend(true, {}, child);
                    child1.name += id;
                    if (child1.parent)
                        child1.parent += id;
                    if (child1._type === "group")
                        this._cloneGroupNode(child1, id);
                    this.diagram.nameTable[child1.name] = child1;
                    this.diagram.nodes().push(child1);
                    this.diagram._nodes = $.extend(true, [], this.diagram.nodes());
                    node1.children.push(child1.name);
                }
            }
            return node1;
        };
        ToolBase.prototype._updateNextPhases = function (seperator, dx, dy) {
            var dif = 0, index, cphase;
            var group;
            if (seperator.orientation == "horizontal") {
                dif = dx;
            }
            else {
                dif = dy;
            }
            index = this.diagram._getPhaseIndex(seperator.name);
            group = this.diagram.nameTable[seperator.parent];
            for (var i = index + 1; i < group.phases.length; i++) {
                cphase = this.diagram.nameTable[group.phases[i]];
                if (cphase)
                    cphase.offset += dif;
                ej.datavisualization.Diagram.SvgContext._updatephase(cphase, this.diagram);
            }
        };

        ToolBase.prototype._getphase = function (id) {
            return this.diagram.nameTable[id];
        };


        ToolBase.prototype._containsSwimlane = function (list) {
            for (var i in list) {
                var child = this.diagram.nameTable[list[i]];
                if (child.isSwimlane || child.isLane)
                    return true;
            }
            return false;
        };

        ToolBase.prototype._raiseEndPointDrag = function (connector, isTarget, isSource, dragState) {
            if (isTarget || isSource) {
                var type, node, port, point;
                node = this._currentPossibleConnection ? this._currentPossibleConnection : null;
                port = this._possibleConnectionPort ? this._possibleConnectionPort : null;
                point = this.currentPoint;
                if (isTarget)
                    type = "Target";
                else type = "Source";
                return this._raiseEvent("connector" + type + "Change", { element: connector, node: node, port: port, point: point, dragState: dragState, cancel: false });
            }
        };

        ToolBase.prototype._decideSelectedItem = function (evt, node, skip) {
            var obj = null;
            if (node) {
                if (node.parent) {
                    if (this.diagram.selectionList && this.diagram.selectionList[0] && node.parent == this.diagram.selectionList[0].name && !skip) {
                        obj = node;
                        if (this.diagram.selectionList[0].type == "bpmn")
                            obj = this.diagram.selectionList[0];
                    }
                    else {
                        if (skip && this.diagram.selectionList[0] && this.diagram.selectionList[0].name == node.name) {
                            obj = node;
                        }
                        else {
                            var item = this.diagram.nameTable[node.parent];
                            if (node.isPhase) {
                                var name = (node.name).split("phaseStack")[1];
                                if (name) {
                                    node = this.diagram.nameTable[name];
                                }
                                obj = node;
                            }
                            else {
                                obj = this._decideSelectedItem(evt, item, skip);
                                if (this.diagram.selectionList && this.diagram.selectionList[0]) {
                                    if (obj && this.diagram.selectionList[0].name == obj.name && !skip)
                                        obj = node;
                                }
                            }
                        }
                    }
                } else {
                    obj = node;
                }
            }
            else {
                return null;
            }
            return obj;
        };
        ToolBase.prototype._isParentAsLane = function (pGroup) {
            var child, lane, laneStack;
            for (var i = 0; pGroup.children && i < pGroup.children.length > 0; i++) {
                child = this.diagram.nameTable[this.diagram._getChild(pGroup.children[i])];
                if (child) {
                    lane = this.diagram.nameTable[child.parent];
                    if (lane && lane.isLane) {
                        laneStack = this.diagram.nameTable[lane.parent];
                        this.diagram._activeSwimLane = this.diagram.nameTable[laneStack.parent];
                        return true;
                    }
                }
            }
            return null;
        };
        ToolBase.prototype._getAdjustjecentLines = function (child) {
            if (!child.segments) {
                for (var i = 0; child.inEdges && child.inEdges.length > 0 && i < child.inEdges.length ; i++) {
                    if (!this._containsCollection(this._adjustLines.lines, this.diagram.nameTable[child.inEdges[i]]))
                        this._adjustLines.lines.push(jQuery.extend(true, {}, this.diagram.nameTable[child.inEdges[i]]));
                }
                for (i = 0; child.outEdges && child.outEdges.length > 0 && i < child.outEdges.length ; i++) {
                    if (!this._containsCollection(this._adjustLines.lines, this.diagram.nameTable[child.outEdges[i]]))
                        this._adjustLines.lines.push(jQuery.extend(true, {}, this.diagram.nameTable[child.outEdges[i]]));
                }
            }
        };
        ToolBase.prototype._containsCollection = function (collection, obj) {
            for (var i = 0; collection && collection.length > 0 && i < collection.length; i++) {
                if (obj && collection[i].name === obj.name)
                    return true;
            }
        };
        ToolBase.prototype._updateMultipleUndoObject = function (psedoGroup) {
            var child, collection = [];
            for (var i = 0; psedoGroup.children && psedoGroup.children.length > 0 && i < psedoGroup.children.length; i++) {
                child = this.diagram.nameTable[psedoGroup.children[i]];
                if (child) {
                    collection.push(jQuery.extend(true, {}, child));
                    this._getAdjustjecentLines(child);
                }
            }
            if (!this._undoObject) {
                this._undoObject = {
                    collection: collection,
                    adjustLines: jQuery.extend(true, {}, this._adjustLines)
                };
            }
        };
        ToolBase.prototype._updateNameTable = function (node) {
            this.diagram._updateNameTable(node);
        };
        ToolBase.prototype._getParentSwimlane = function (lane) {
            var laneStack;
            if (lane && lane.isLane) {
                laneStack = this.diagram.nameTable[lane.parent];
                return this.diagram.nameTable[laneStack.parent];
            }
            return null;
        };
        ToolBase.prototype._removeHighLighter = function () {
            ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this.diagram._adornerSvg, this.diagram._adornerLayer);
        };
        ToolBase.prototype._getPadding = function (node) {
            var padX = 0, padY = 0;
            if (node && node.parent) {
                var parent = this.diagram.nameTable[node.parent];
                if (parent) {
                    padX = parent.paddingRight;
                    padY = parent.paddingBottom;
                }
            }
            return { x: padX, y: padY };
        };

        ToolBase.prototype._findStackOverNode = function (node, evt) {
            if (node) {
                var parent = this.diagram.nameTable[node.parent];
                var child = null, pos, childBounds;
                if (parent) {
                    var length = parent.children.length;
                    for (var i = 0; i < length; i++) {
                        child = this.diagram.nameTable[this.diagram._getChild(parent.children[i])];
                        pos = this.mousePosition(evt);
                        childBounds = ej.datavisualization.Diagram.Util.bounds(child);
                        var lastChild = this.diagram.nameTable[this.diagram._getChild(parent.children[length - 1])];
                        var firstChild = this.diagram.nameTable[this.diagram._getChild(parent.children[0])];
                        if (parent.container.orientation == "vertical") {
                            if (pos.y >= childBounds.y && pos.y <= childBounds.bottom) {
                                return child;
                            }
                            else if (pos.y <= firstChild.offsetY - firstChild.height / 2) {
                                return firstChild;
                            }
                            else if (pos.y >= lastChild.offsetY + lastChild.height / 2) {
                                return lastChild;
                            }

                        }
                        else {
                            if (pos.x >= childBounds.x && pos.x <= childBounds.right) {
                                return child;
                            }
                            else if (pos.x <= firstChild.offsetX - firstChild.width / 2) {
                                return firstChild;
                            }
                            else if (pos.x >= lastChild.offsetX + lastChild.width / 2) {
                                return lastChild;
                            }
                        }
                    }
                }
            }
        };

        ToolBase.prototype._getPageBounds = function () {
            var size = ej.datavisualization.Diagram.Rectangle(0, 0, 0, 0);
            var pageSettings = this.diagram.model.pageSettings;
            size.x = (pageSettings.boundaryConstraints === "diagram") ? Math.min(this.diagram._getDigramBounds().x, 0) : 0;
            size.y = (pageSettings.boundaryConstraints === "diagram") ? Math.min(this.diagram._getDigramBounds().y, 0) : 0;
            size.width = (pageSettings.boundaryConstraints === "page") ? (pageSettings.pageWidth ? pageSettings.pageWidth : this.diagram.element.width()) : this.diagram.element.width();
            size.height = (pageSettings.boundaryConstraints === "page") ? (pageSettings.pageHeight ? pageSettings.pageHeight : this.diagram.element.height()) : this.diagram.element.height();
            return size;
        };
        ToolBase.prototype._nodeHighLighter = function (overNode, evt) {
            var source = null, childBounds = null, target = null;
            if (overNode && this.selectedObject.parent) //&& this.selectedObject.parent != overNode.name)
            {
                var parent = this.diagram.nameTable[this.selectedObject.parent];
                if (parent) {
                    if (parent.container && parent.container.type == "stack" && this.selectedObject.name != overNode.name) {
                        var stackOverNode = this._stackOverNode;
                        ej.datavisualization.Diagram.SvgContext._drawStackHighlighter(stackOverNode, this.diagram._adornerSvg, this.diagram._adornerLayer, this.diagram._currZoom, this.currentPoint, (parent.container.orientation === "vertical") ? true : false);
                    }
                    else if (parent.container && parent.container.type == "canvas" && this.selectedObject.parent != overNode.name && !overNode.isPhase && ej.datavisualization.Diagram.Util.canAllowDrop(overNode)) {
                        if (ej.datavisualization.Diagram.Util._canBeTarget(this.diagram, overNode))
                            ej.datavisualization.Diagram.SvgContext._drawNodeHighlighter(overNode, this.diagram._adornerSvg, this.diagram._adornerLayer, this.diagram._currZoom);
                    }
                    else this._removeHighLighter();
                }
            }
            else if (overNode && overNode.container && !overNode.isSwimlane) {
                if (this.selectedObject.isLane) {
                    parent = this.diagram.nameTable[overNode.parent];
                    if (parent && overNode.name.indexOf("phaseStack") === -1 && (ej.datavisualization.Diagram.Util.canDrawStackHighlighter(this.diagram, this.selectedObject, overNode)))
                        ej.datavisualization.Diagram.SvgContext._drawStackHighlighter(overNode, this.diagram._adornerSvg, this.diagram._adornerLayer, this.diagram._currZoom, this.currentPoint, (parent.container.orientation === "vertical") ? true : false);
                }
                else
                    ej.datavisualization.Diagram.SvgContext._drawNodeHighlighter(overNode, this.diagram._adornerSvg, this.diagram._adornerLayer, this.diagram._currZoom);
            }
            else if (!overNode.segments) {
                ej.datavisualization.Diagram.SvgContext._drawNodeHighlighter(overNode, this.diagram._adornerSvg, this.diagram._adornerLayer, this.diagram._currZoom);
            }
            else
                this._removeHighLighter();
            if (this._nodeToHit && overNode && overNode.name != this._nodeToHit.name) {
                childBounds = ej.datavisualization.Diagram.Util.bounds(this._nodeToHit);
                target = this._getTargetNode(this._nodeToHit, childBounds);
                this._raiseEvent("mouseLeave", { element: this.diagram.getNode(this.selectedObject), source: this.diagram.getNode(this._nodeToHit), target: this.diagram.getNode(target) });
            }
            if (overNode) {
                if (this._nodeToHit && this._nodeToHit.name !== overNode.name || !this._nodeToHit) {
                    this._nodeToHit = overNode;
                    if (this.selectedObject.parent)
                        source = this.diagram.nameTable[this.selectedObject.parent];
                    if (this.selectedObject.type == "pseudoGroup") {
                        var fChild = this.diagram.nameTable[this.diagram._getChild(this.selectedObject.children[0])];
                        if (fChild && fChild.parent)
                            source = this.diagram.nameTable[fChild.parent];
                    }
                    childBounds = ej.datavisualization.Diagram.Util.bounds(overNode);
                    target = this._getTargetNode(overNode, childBounds);
                    this._raiseEvent("mouseEnter", { element: this.diagram.getNode(this.selectedObject), source: this.diagram.getNode(source), target: this.diagram.getNode(target) });
                }
            }
            else {
                this._nodeToHit = null;
            }
            if (overNode) {
                if (this.selectedObject.parent)
                    source = this.diagram.nameTable[this.selectedObject.parent];
                childBounds = ej.datavisualization.Diagram.Util.bounds(overNode);
                target = this._getTargetNode(overNode, childBounds);
                this._raiseEvent("mouseOver", { element: this.diagram.getNode(this.selectedObject), source: this.diagram.getNode(source), target: this.diagram.getNode(target) });
            }
        };

        ToolBase.prototype._doubleClick = function (element) {
            if (element && element.parent) {
                var parent = this.diagram.nameTable[element.parent];
                if (parent) {
                    var name = element.name;
                    this.diagram.updateSelectedObject(name);
                    if (!parent.isLane && !parent.isSwimlane && !parent.isPhaseStack) {
                        this.diagram._clearSelection(true);
                        this.diagram.addSelection(element, true);
                    }
                }
            }
        };

        ToolBase.prototype._itemClick = function (element, actualObject, selectedObject, prevSelected) {

            if (actualObject && actualObject.parent) {
                var parent = this.diagram.nameTable[actualObject.parent];
                if (parent) {
                    if (parent.container) {
                        if (actualObject && !this.diagram._selectedSymbol) {
                            var name = actualObject.name;
                            if (name.indexOf("_header_swimlane") != -1) {
                                if (element)
                                    this.diagram.updateSelectedObject(element.parent, parent);
                            }
                            else if (name.indexOf("_Headerr_") != -1)
                                this.diagram.updateSelectedObject(actualObject.parent);
                            else if (actualObject && actualObject.isPhase) {
                                if (element.isPhase) {
                                    var obj = this.diagram.nameTable[element.parent];
                                    if (obj && (this.diagram.selectionList.length === 0 || this.diagram.selectionList[0].name != obj.name)) {
                                        this.diagram._clearSelection(true);
                                        this.diagram.addSelection(element, true);
                                        this.selectedObject = null;
                                    }
                                }
                            }
                            else
                                this.diagram.updateSelectedObject(name);
                        }
                        this.diagram._selectedGNode = null;
                    }
                    else if (parent.type === "group") {
                        if (parent.parent) {
                            if (!(this.startPoint.x != this.currentPoint.x || this.startPoint.y != this.currentPoint.y)) {
                                while (parent.parent) {
                                    var lane = this.diagram.nameTable[parent.parent];
                                    if (lane && lane.isLane)
                                        break
                                    else {
                                        var tParent = this.diagram.nameTable[parent.parent];
                                        if (this.diagram._selectedGNode && tParent) {
                                            if (tParent.name === this.diagram._selectedGNode.name) {
                                                this.diagram.updateSelectedObject(parent.name);
                                                break;
                                            }
                                            else parent = tParent;
                                        }
                                        else parent = tParent;
                                    }
                                }
                            }
                            else lane = this.diagram.nameTable[parent.parent];
                            if (lane && lane.isLane) {
                                var obj = this._getSelectedItem(actualObject, prevSelected);
                                if (obj)
                                    this.diagram.updateSelectedObject(obj.name)
                            }
                        }
                        if (this.selectedObject && this.selectedObject.parent)
                            this.diagram._selectedGNode = this.selectedObject;
                    }
                }
            }
            else if (actualObject) {
                if (!this.diagram._selectedSymbol)
                    this.diagram.updateSelectedObject(actualObject.name);
            }
            else this.diagram._selectedGNode = null;
            if (element && (element.type == "pseudoGroup" || element.name == "multipleSelection") && actualObject && !this._containsChild(element, actualObject.name)) {
                this.diagram.updateSelectedObject(element.name)
            }

        };

        ToolBase.prototype._getSelectedItem = function (item, prevSelected) {
            var parent;
            if (item) {
                if (item.parent) {
                    parent = this.diagram.nameTable[item.parent];
                    if (prevSelected && prevSelected.name == parent.name) {
                        return item
                    }
                    else if (parent.isLane)
                        return item;
                    else return this._getSelectedItem(parent);
                }
            }
        };

        ToolBase.prototype._getTargetNode = function (node, childBounds) {
            var bounds = null, nodes = [];
            var quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(this.diagram._spatialSearch, childBounds);
            for (var i = 0; i < quads.length; i++) {
                var quad = quads[i];
                if (quad.objects.length > 0) {
                    for (var j = 0; j < quad.objects.length; j++) {
                        var nd = quad.objects[j];
                        if (!nd.segments && nd.visible) {
                            bounds = ej.datavisualization.Diagram.Util.bounds(nd);
                            if (nodes.indexOf(nd) == -1 && ej.datavisualization.Diagram.Geometry.intersectsRect(childBounds, bounds))
                                nodes.push(nd);

                        }
                    }
                }
            }
            var collection = [];
            collection.push(node);
            for (i = 0; i < nodes.length; i++) {
                if (nodes[i].name != node.name)
                    collection.push(nodes[i]);
            }
            return collection;
        };
        ToolBase.prototype._updateMargin = function (node, group) {
            if (node.type == "pseudoGroup") {
                var child = null;
                var children = this.diagram._getChildren(node.children);
                for (var i = 0; i < children.length; i++) {
                    child = this.diagram.nameTable[children[i]];
                    this._updateMargin(child, group);
                }
            }
            else if (group && group.container && group.container.type == "canvas") {
                var groupBounds = ej.datavisualization.Diagram.Util.bounds(group); //ej.datavisualization.Diagram.SvgContext.getCanvasBoundingBox(group, this.diagram, node, true);
                var bounds1 = ej.datavisualization.Diagram.Util.bounds(node);
                var bounds = ej.datavisualization.Diagram.Geometry.rect([bounds1.topLeft, bounds1.topRight, bounds1.bottomRight, bounds1.bottomLeft]);
                node.marginLeft = bounds.x - (groupBounds.x + group.paddingLeft);
                //node.marginRight = (groupBounds.x + group.width) - (bounds.x + bounds.width) - group.paddingRight;
                node.marginTop = bounds.y - (groupBounds.y + group.paddingTop);
                //node.marginBottom = groupBounds.bottom - (bounds.y + bounds.height) - group.paddingBottom;
                if (group.isLane) {
                    var left = 0, top = 0;
                    if (group.orientation === "horizontal") {
                        left = 50, top = 0;
                    }
                    else {
                        left = 0, top = 50;
                    }
                    node.marginLeft = node.marginLeft >= left ? node.marginLeft : left;
                    node.marginTop = node.marginTop >= top ? node.marginTop : top;
                }

            }

        };
        ToolBase.prototype._getNodeUnderMouse = function (evt) {
            var node = this.diagram._nodeUnderMouse; var obj, skip;
            if (this.diagram._focusedElement && (this.diagram._focusedElement.isPhase || this.diagram._focusedElement.isLane || this.diagram._focusedElement.isSwimlane)) skip = true;
            if (this.diagram._focusedElement && node && this._containsChild(this.diagram._focusedElement, node.name)) {
                if (node && (skip || !ej.datavisualization.Diagram.Util.canAllowDrop(node))) {
                    var type = this.diagram.getObjectType(node);
                    if (type == "connector" || type === "group") {
                        obj = node;
                    }
                    else {
                        if (node.parent) {
                            var parent1 = this.diagram.nameTable[node.parent];
                            if (parent1 && parent1.container && parent1.container.type == "stack" && ej.datavisualization.Diagram.Util.canAllowDrop(node)) {
                                return obj = node;
                            }
                            type = this.diagram.getObjectType(parent1);
                            if (parent1 && type != "node") {
                                obj = parent1;
                            }
                        }
                    }
                }
            }
            if (!obj) {
                if (node && this.selectedObject != node && ej.datavisualization.Diagram.Util.canAllowDrop(node))
                    return node;
            }
            else if (this.selectedObject != obj && ej.datavisualization.Diagram.Util.canAllowDrop(obj) && (obj.type != "bpmn" || this.selectedObject.type == "bpmn"))
                return obj;

        };

        ToolBase.prototype._isChange = function (obj1, obj2) {
            var status = null;
            if (obj1._type === "group" || obj1.type === "pseudoGroup" || obj2._type === "group" || obj2.type === "pseudoGroup") {
                if ((obj1._type === "group" || obj1.type === "pseudoGroup") && !(obj2._type === "group" || obj2.type === "pseudoGroup")) {
                    status = !this._containsChild(obj1, obj2.name);
                }
                if (!(obj1._type === "group" || obj1.type === "pseudoGroup") && (obj2._type === "group" || obj2.type === "pseudoGroup")) {
                    status = !this._containsChild(obj2, obj1.name);
                }
                else if ((obj1._type === "group" || obj1.type === "pseudoGroup") && (obj2._type === "group" || obj2.type === "pseudoGroup")) {
                    if (obj1.name == obj2.name)
                        status = true;
                }
            }
            else {
                if (obj1.name == obj2.name)
                    status = true;
            }
            return status;
        };
        ToolBase.prototype._containsChild = function (node, childName) {
            var status = true;
            var child = null;
            var type;
            if (node.children) {
                var children = this.diagram._getChildren(node.children);
                for (var i = 0; i < children.length; i++) {
                    child = this.diagram.nameTable[children[i]];
                    type = this.diagram.getObjectType(child);
                    if (type === "group")
                        status = this._containsChild(child, childName);
                    else {
                        if (child && child.name == childName)
                            status = false;
                    }
                }
            }
            return status;
        };

        ToolBase.prototype._findNodeUnderMouse = function (evt, skip) {
            var obj = null;
            var node = null;
            var type;
            var foreignObject = this.diagram._isForeignObject(evt.target);
            if (foreignObject)
                evt.target = foreignObject;
            var parent = $(evt.target).parents(".ej-d-node,.ej-d-connector,.ej-d-group");
            var className = evt.target.className;
            if (parent && (foreignObject || evt.target.localName != "div")) {
                type = parent.attr("class");
                if (type && (type === "ej-d-node" || type === "ej-d-group" || ej.datavisualization.Diagram.Util.isClassifier(evt))) {
                    node = this.diagram._findNode(parent.attr("id"));
                    if (!node) node = this.diagram._findNode(parent.attr("id").split('_parentdiv')[0]);
                } else if (type === "ej-d-connector") {
                    node = this.diagram._findConnector(parent.attr("id"));
                }
            }
            else {
                if (this.diagram._isLabelTemplate(evt)) {
                    node = this.diagram._findNode(parent.attr("id"));
                    if (!node) {
                        node = this.diagram._findConnector(parent.attr("id"));
                    }
                }
            }
            if (node && !node.parent)
                obj = node;
            else
                obj = this._decideSelectedItem(evt, node, skip);
            this.prevSelectObject = obj;

            if (skip && this.diagram.selectionList[0]) {
                if (obj && obj._type === "group" && !this._containsChild(obj, this.diagram.selectionList[0].name))
                    obj = obj;
                else if (obj && this.diagram.selectionList[0].name != obj.name && this._isChange(this.diagram.selectionList[0], obj))
                    obj = this.diagram.selectionList[0];
                else if (node && node.name == this.diagram.selectionList[0].name && !this._isChange(this.diagram.selectionList[0], obj)) {
                    obj = this.diagram.selectionList[0];

                }
            }
            if (node && this.diagram._selectedSymbol && node.name != this.diagram._selectedSymbol.name && this.diagram._symbolDrop)
                this.actualObject = this.diagram._selectedSymbol;
            else
                this.actualObject = node;
            return obj;

        };

        ToolBase.prototype._findLabelUnderMouse = function (evt, skip, mousePosition, drag) {
            var obj;
            var target = $(evt.target);
            var targetClass = target[0].getAttribute("class");
            if (this.diagram.model.labelRenderingMode == ej.datavisualization.Diagram.LabelRenderingMode.Svg) {
                if (!targetClass || !targetClass == "ej-d-label") {
                    if (target[0].parentNode)
                        var className = target[0].parentNode.getAttribute("class");
                    if (className === "ej-d-label") {
                        var nameArray = target[0].parentNode.id.split("_");
                        var name = "";
                        for (var i = 1; i < nameArray.length; i++) {
                            name += nameArray[i]
                            if (i != nameArray.length - 1) {
                                name += "_"
                            }
                        }
                        var node = this.diagram.nameTable[nameArray[0]];
                        if (node && node.labels.length > 0) {
                            for (var i = 0; i < node.labels.length; i++) {
                                if (node.labels[i].name === name) {
                                    this.activeLabel = node.labels[i];
                                    return node.labels[i];
                                }
                            }
                        }
                    }
                    else {
                        var parentNode = evt.target.parentNode;
                        var targetClass = parentNode.getAttribute("class");
                        while (parentNode) {
                            if (targetClass === "ej-label-template") {
                                var id = parentNode.id.split('_');
                                obj = this.diagram._findNode(id[0]);
                                if (!obj)
                                    obj = this.diagram._findConnector(id[0]);
                                for (var i = 0; obj && i < obj.labels.length; i++) {
                                    id1 = obj.labels[i].name.split('_');
                                    if (id[id.length - 1] == id1[id1.length - 1]) {
                                        curlabel = obj.labels[i];
                                        if (!this.diagram._selectedSymbol)
                                            this.activeLabel = curlabel;
                                        return curlabel;
                                    }
                                }
                            }
                            parentNode = parentNode.parentNode;
                            targetClass = parentNode.getAttribute("class");
                        }
                    }
                }
            }
            else if (targetClass == "ej-d-label") {
                var parent = $(evt.target).parents(".ej-d-node,.ej-d-connector,.ej-d-group");
                if (parent) {
                    var id = parent[0].getAttribute("id");
                    var type = parent[0].getAttribute("class");
                    if (type) {
                        if (type === "ej-d-node" || type === "ej-d-group") {
                            obj = this.diagram._findNode(id);
                            var curlabel = this.diagram._findLabelAtPoint(mousePosition ? mousePosition : this.currentPoint, obj);
                            if (!this.diagram._selectedSymbol)
                                this.activeLabel = curlabel;
                        }
                        else if (type === "ej-d-connector") {
                            obj = this.diagram._findConnector(id);
                            var curlabel = this.diagram._findLabelAtPoint(mousePosition ? mousePosition : this.currentPoint, obj);
                            if (ej.datavisualization.Diagram.Util.canMoveLabel(obj) || drag) {
                                if (curlabel == null) {
                                    var target = $(evt.target);
                                    var id1;
                                    var targetClass = target[0].getAttribute("class");
                                    if (targetClass == "ej-d-label") {
                                        var id = evt.target.id.split('_');
                                        for (var i = 0; i < obj.labels.length; i++) {
                                            id1 = obj.labels[i].name.split('_');
                                            if (id[id.length - 1] == id1[id1.length - 1])
                                                curlabel = obj.labels[i];
                                        }
                                    }
                                }
                            }
                            else
                                curlabel = null;
                            if (!this.diagram._selectedSymbol)
                                this.activeLabel = curlabel;
                        }
                    }
                }
            }
            else if (this.diagram._isLabelTemplate(evt)) {

                var parents = $(evt.target).parents(".ej-label-template");
                var parent = parents[0]
                if (parent) {
                    //var id = parent.parentNode.id.split('_');

                    var id = parent.parentNode.id.split('_')
                    obj = this.diagram._findNode(id[0]);
                    if (!obj)
                        obj = this.diagram._findConnector(id[0]);
                    if (obj) {
                        for (var i = 0; i < obj.labels.length; i++) {
                            id1 = obj.labels[i].name.split('_');
                            if (id[2] == id1[id1.length - 1])
                                curlabel = obj.labels[i];
                        }
                    }
                    if (!this.diagram._selectedSymbol)
                        this.activeLabel = curlabel;
                }
            }
            else {
                this.activeLabel = null;
            }
            return obj;
        };
        ToolBase.prototype._selectionContainsChild = function (name) {
            if (this.diagram.selectionList[0].children) {
                var children = this.diagram._getChildren(this.diagram.selectionList[0].children);
                var child = null;
                for (var i = 0; i < children.length; i++) {
                    child = this.diagram.nameTable[children[i]];
                    if (child && child.name == name)
                        return true;
                }
            }
            else if (this.diagram.selectionList[0]._type === "group" && this.diagram.selectionList[0].type != "pseudoGroup") {
                if (this.diagram.selectionList[0].name == name)
                    return true;
            }
            else if (this.diagram.nameTable[name] && this.diagram.nameTable[name]._type === "group") {
                children = this.diagram._getChildren(this.diagram.nameTable[name].children);
                for (var j = 0; j < children.length; j++) {
                    child = this.diagram.nameTable[children[j]];
                    if (child)
                        var status = this._selectionContainsChild(child.name);
                    if (status)
                        return status;
                }
            }
            else if (this.diagram.selectionList[0].name == name)
                return true;

            return false;
        };

        ToolBase.prototype._isSelected = function (name) {
            var child = null;
            var node = this.diagram.nameTable[name];
            if (this._selectionContainsChild(node.name))
                return true;
            else if (node._type === "group") {
                var children = this.diagram._getChildren(node.children);
                for (var i = 0; i < children.length; i++) {
                    child = children[i];
                    if (this._selectionContainsChild(child))
                        return true;
                }
            }
            return false;
        };
        ToolBase.prototype._isColleagueSelected = function (name) {
            var node = this.diagram.nameTable[name];
            var child = null;
            if (node.parent) {
                var parent = this.diagram.nameTable[node.parent];
                if (parent) {
                    var children = this.diagram._getChildren(parent.children);
                    for (var i = 0; i < children.length; i++) {
                        child = children[i];
                        if (this._isSelected(child))
                            return true;
                    }
                }
            }
            return false;
        };
        ToolBase.prototype._isInSelection = function (name) {
            if (this.diagram.selectionList[0].type == "pseudoGroup" && this.diagram.selectionList[0].children) {
                var children = this.diagram._getChildren(this.diagram.selectionList[0].children);
                var child = null;
                for (var i = 0; i < children.length; i++) {
                    child = this.diagram.nameTable[children[i]];
                    if (child.name == name)
                        return true;
                }
            }
        };
        ToolBase.prototype._getCloneNode = function (node) {
            var obj = null;
            obj = jQuery.extend(true, {}, node);
            obj.children = [];
            obj.minHeight = 0;
            obj.minWidth = 0;
            obj.maxHeight = 0;
            obj.maxWidth = 0;
            return obj;
        };
        ToolBase.prototype._getProcessedObject = function (name, obj) {
            var node = this.diagram.nameTable[name];
            if (node) {
                if (this._isInSelection(name)) {
                    return null;
                }
                else if (this._selectionContainsChild(node.name))
                    return { add: node, remove: null };
                else {
                    if (node.parent) {
                        if (this._selectionContainsChild(node.parent)) {
                            if (this._isInSelection(node.parent))
                                return { add: node, remove: this.diagram.nameTable[node.parent] };
                            else {
                                var parent = this.diagram.nameTable[node.parent];
                                if (parent)
                                    return { add: parent, remove: this.diagram.nameTable[parent.parent] };
                            }
                        } else {
                            if (this._isColleagueSelected(node.parent) && !this._selectionContainsChild(node.parent)) {
                                if (this._isSelected(node.parent)) {
                                    return { add: node, remove: null };
                                }
                                else
                                    return { add: this.diagram.nameTable[node.parent], remove: null };
                            }
                            else if (this.diagram.selectionList[0] && this._isInSelection(node.parent)) {
                                return { add: this.diagram.nameTable[node.name], remove: this.diagram.nameTable[node.parent] };

                            }
                            else
                                return this._getProcessedObject(node.parent);
                        }
                    }
                    else {
                        return { add: node, remove: null };
                    }
                }
            }
        };

        ToolBase.prototype.hasSameParent = function () {
            if (this.selectedObject.type == "pseudoGroup") {
                var list = this.selectedObject;
                var child = null;
                if (this.diagram.nameTable[this.diagram._getChild(list.children[0])]) {
                    var parent = this.diagram.nameTable[this.diagram._getChild(list.children[0])].parent;
                    var lChildren = this.diagram._getChildren(list.children);
                    for (var i = 0; i < lChildren.length; i++) {
                        child = this.diagram.nameTable[lChildren[i]];
                        if (child.parent != parent || child.parent == "")
                            return false;
                    }
                }
                return true;
            }
            return false;
        };
        ToolBase.prototype._fromDiagram = function (list) {
            var state = true;
            var child = null;
            for (var i = 0; i < list.length; i++) {
                child = this.diagram.nameTable[this.diagram._getChild(list[i])];
                if (child && child.parent) {
                    state = false;
                    break;
                }
            }
            return state;
        };
        ToolBase.prototype._fromContainer = function (list) {
            var child = null, parent = null;
            for (var i = 0; i < list.length; i++) {
                child = this.diagram.nameTable[this.diagram._getChild(list[i])];
                if (child.parent) {
                    parent = this.diagram.nameTable[child.parent];
                    if (parent) {
                        if (parent.container)
                            return true;
                    }
                }
            }
        };

        ToolBase.prototype._fromSameContainer = function (list) {
            var child = null;
            var parent = null;
            for (var i = 0; i < list.length; i++) {
                child = this.diagram.nameTable[this.diagram._getChild(list[i])];
                if (!parent && child.parent)
                    parent = child.parent;
                if (child.parent) {
                    if (child.parent != parent)
                        return false;
                }
            }
            return true;
        };
        ToolBase.prototype._anyFromContainer = function (list) {
            var child = null;
            var parent = null;
            for (var i = 0; i < list.length; i++) {
                child = this.diagram.nameTable[this.diagram._getChild(list[i])];
                if (child.parent)
                    var parent = this.diagram.nameTable[child.parent];
                if (parent && parent.container && parent.container.type === "canvas") {
                    return true;
                }
            }
            return false;
        };

        ToolBase.prototype._processCtrlKey = function (evt) {
            var obj;
            if (this.diagram.selectionList.length > 0 && ej.datavisualization.Diagram.Util.canDoMultipleSelection(this.diagram)) {
                var selectionList = this.diagram.selectionList;
                var isMultipleSelection, nObj, changeType, newItems = [], oldItems = [], selectedItems = [];
                if (selectionList[0].type == "pseudoGroup") {
                    isMultipleSelection = true;
                    obj = this._findNodeUnderMouse(evt);
                }
                else {

                    obj = this._findNodeUnderMouse(evt);
                }
                var obj1 = this._findNodeUnderMouse(evt, true);
                var tempVal = this.selectedObject;
                var args = this._raiseEvent("itemClick", { element: this.selectedObject, actualObject: this.actualObject, selectedObject: obj1, cancel: false, event: evt });
                this._itemClick(this.selectedObject, this.actualObject, obj1);
                if (args.cancel)
                    this.selectedObject = tempVal;
                if (this.actualObject) {
                    if (this.actualObject.parent) {
                        if (isMultipleSelection) {

                            var mulSelection = selectionList[0];
                            var temp = this._getProcessedObject(this.actualObject.name);
                            if (temp) {
                                if (this.selectedObject) {
                                    mulSelection.children = this.diagram._getChildren(mulSelection.children);
                                    ej.datavisualization.Diagram.Util.removeItem(mulSelection.children, this.selectedObject.name);
                                }
                                else if (temp.remove) {
                                    mulSelection.children = this.diagram._getChildren(mulSelection.children);
                                    ej.datavisualization.Diagram.Util.removeItem(mulSelection.children, temp.remove.name);
                                }


                                if (this.selectedObject) {
                                    if (!this._hasMultipleSelection(this.selectedObject)) {
                                        mulSelection.children.push(this.selectedObject.name);
                                    }
                                } else if (temp.add) {
                                    if (!this._hasMultipleSelection(temp.add)) {
                                        mulSelection.children.push(temp.add.name);
                                    }
                                }
                            } else {
                                nObj = this.actualObject;
                                if (this.selectedObject) {
                                    if (!this._hasMultipleSelection(this.selectedObject))
                                        mulSelection.children.push(this.selectedObject.name);
                                    else {
                                        mulSelection.children = this.diagram._getChildren(mulSelection.children);
                                        ej.datavisualization.Diagram.Util.removeItem(mulSelection.children, this.selectedObject.name);
                                    }
                                } else {
                                    if (!this._hasMultipleSelection(nObj))
                                        mulSelection.children.push(nObj.name);
                                    else {
                                        mulSelection.children = this.diagram._getChildren(mulSelection.children);
                                        ej.datavisualization.Diagram.Util.removeItem(mulSelection.children, nObj.name);
                                    }
                                }
                            }
                            ej.datavisualization.Diagram.Util._updateGroupBounds(mulSelection, this.diagram);
                            if (mulSelection.children.length <= 1) {
                                var child = this.diagram.nameTable[this.diagram._getChild(mulSelection.children[0])];
                                if (this.diagram._hasSelection()) {
                                    this.diagram._clearSelection(true);
                                }
                                this.selectedObject = child;
                                this.diagram._addSelection(this.selectedObject);
                            } else {
                                this.selectedObject = selectionList[0];
                                this.diagram.updateSelection()
                            }

                        } else {
                            if (this.diagram.selectionList[0]._type === "group" && this.diagram.selectionList[0].type !== "bpmn") {
                                selectionList = this.diagram.selectionList[0];
                                temp = this._getProcessedObject(this.actualObject.name);
                                nObj = temp.add;
                                if (temp) {
                                    if (this.diagram._hasSelection()) {
                                        this.diagram._clearSelection();
                                    }
                                }

                            } else {
                                temp = null;
                                if (obj._type === "group") {
                                    temp = this._getProcessedObject(this.actualObject.name);
                                }
                                if (temp)
                                    nObj = temp.add;
                                else
                                    nObj = obj;
                                selectionList = this.diagram.selectionList[0];
                                if (this.diagram._hasSelection()) {
                                    this.diagram._clearSelection();
                                }
                            }
                            this.diagram._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Keydown
                            pseudoGroup = ej.datavisualization.Diagram.Group({ type: "pseudoGroup", "name": "multipleSelection" });
                            if (selectionList.name != nObj.name)
                                pseudoGroup.children.push(selectionList.name);
                            if (this.selectedObject)
                                pseudoGroup.children.push(this.selectedObject.name);
                            else
                                if (this._containsChild(pseudoGroup, nObj.name))
                                    pseudoGroup.children.push(nObj.name);

                            this._checkRepeatedChild(pseudoGroup.children);

                            this.diagram.nodes().push(pseudoGroup);
                            this.diagram._nodes = $.extend(true, [], this.diagram.nodes());
                            this.diagram.nameTable[pseudoGroup.name] = pseudoGroup;
                            ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, this.diagram);
                            this.selectedObject = pseudoGroup;
                            this.diagram._addSelection(this.selectedObject);
                        }
                    }
                    else {
                        if (isMultipleSelection) {
                            mulSelection = selectionList[0];
                            nObj = this.selectedObject ? this.selectedObject : this.actualObject;
                            changeType = (!this._hasMultipleSelection(nObj)) ? "insert" : "remove";
                            if (changeType == "insert") {
                                mulSelection.children.push(nObj.name);
                                newItems.push(nObj);
                            }
                            else {
                                ej.datavisualization.Diagram.Util.removeItem(mulSelection.children, nObj.name);
                                oldItems.push(nObj);
                            }
                            for (var i = 0; i < mulSelection.children.length; i++)
                                selectedItems.push(this.diagram.nameTable[mulSelection.children[i]]);
                            args = { changeType: changeType, state: "changing", element: this.diagram.nameTable["multipleSelection"], selectedItems: selectedItems, oldItems: oldItems, newItems: newItems, cancel: false };
                            this._raiseEvent("selectionChange", args);
                            if (!args.cancel) {
                                if (changeType == "remove") ej.datavisualization.Diagram.Util.removeItem(this.diagram.model.selectedItems.children, nObj);
                                this.diagram.updateSelection(this.selectedObject);
                                ej.datavisualization.Diagram.Util._updateGroupBounds(mulSelection, this.diagram);
                                this.selectedObject = selectionList[0];
                                if (this.diagram.model.selectedItems.children.length)
                                    ej.datavisualization.Diagram.SvgContext.updateSelector(this.selectedObject, this.diagram._adornerSvg, this.diagram._currZoom, this.diagram, this.diagram.model.selectedItems.constraints);
                                else {
                                    ej.datavisualization.Diagram.Util.clear(this.diagram.selectionList);
                                    ej.datavisualization.Diagram.SvgContext.clearSelector(this.diagram._adornerSvg, this.diagram._adornerLayer);
                                }
                                args = { changeType: changeType, state: "changed", element: this.diagram.nameTable["multipleSelection"], selectedItems: selectedItems, oldItems: oldItems, newItems: newItems, cancel: false };
                                this._raiseEvent("selectionChange", args);
                            }
                        }
                        else {
                            var nObj = this.actualObject;
                            this.diagram._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Keydown
                            selectionList = this.diagram.selectionList[0];
                            if (nObj != selectionList) {
                                if (this.diagram._hasSelection()) {
                                    this.diagram._clearSelection(true);
                                }
                                var pseudoGroup = ej.datavisualization.Diagram.Group({ type: "pseudoGroup", "name": "multipleSelection" });
                                pseudoGroup.children.push(selectionList.name);
                                if (this.selectedObject)
                                    pseudoGroup.children.push(this.selectedObject.name);
                                else
                                    pseudoGroup.children.push(nObj.name);
                                this.diagram.nodes().push(pseudoGroup);
                                this.diagram._nodes = $.extend(true, [], this.diagram.nodes());
                                this.diagram.nameTable[pseudoGroup.name] = pseudoGroup;
                                ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, this.diagram, null, true);
                                this.selectedObject = pseudoGroup;
                                this.diagram._addSelection(this.selectedObject);
                            }
                        }
                    }
                }

                this.selectedObject = this.diagram.selectionList[0];
            }
            else {
                obj = this._findNodeUnderMouse(evt);
                if ((ej.datavisualization.Diagram.Util.canDoSingleSelection(this.diagram)))
                this.selectedObject = obj;
            }
            return obj;
        };

        ToolBase.prototype._checkRepeatedChild = function (list) {
            var child = null;
            var cloneList = $.extend(true, {}, list);
            cloneList = this.diagram._getChildren(cloneList);
            for (var i = 0; i < cloneList.length; i++) {
                child = this.diagram.nameTable[cloneList.children[i]];
                if (child._type === "group") {
                    for (var j = 0; j < cloneList.children.length; j++) {
                        if (!this._containsChild(child, cloneList.children[j])) {
                            list.children = this.diagram._getChildren(list.children);
                            ej.datavisualization.Diagram.Util.removeItem(list.children, cloneList.children[j]);
                        }
                    }
                }
            }
        };
        ToolBase.prototype._hasMultipleSelection = function (node) {
            var children = this.diagram._getChildren(this.diagram.selectionList[0].children);
            for (var i = 0; i < children.length; i++) {
                if (node.name == children[i])
                    return true;
            }
            return false;
        };

        ToolBase.prototype._getNextParent = function (node) {
            if (node.parent) {
                var parent = this.diagram.nameTable[node.parent];
                if (this._hasMultipleSelection(parent))
                    return node;
                else
                    return this._getNextParent(parent);
            }
            else
                return node;
        };
        ToolBase.prototype._findObj = function (element, group) {
            var obj;
            var id = element.getAttribute("id");
            if (group) {
                obj = this.diagram._findChildren(group, id);
            }
            else {
                var type = element.getAttribute("class");
                if (type) {
                    if (type === "ej-d-node" || type === "ej-d-group") {
                        obj = this.diagram._findNode(id);
                    }
                    else if (type === "ej-d-connector") {
                        obj = this.diagram._findConnector(id);
                    }
                }
            }
            return obj;
        };
        ToolBase.prototype.mousedown = function (evt) {
            this.startPoint = this.mousePosition(evt);
            this.currentPoint = this.startPoint;
            this.previousPoint = this.startPoint;
            this.diagramBounds = this.diagram._getDigramBounds();
        };
        ToolBase.prototype._isPolyline = function () {
            if (this.diagram.model.connectorType === ej.datavisualization.Diagram.ConnectorType.Polyline)
                return true;
        };
        ToolBase.prototype.mousemove = function (evt) {
            if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(this.startPoint) ||
                this instanceof ej.datavisualization.Diagram.LineTool || this._isPolyline())
                this.currentPoint = this.mousePosition(evt);
        };
        ToolBase.prototype.mouseup = function (evt) {
            this._endAction();
            if (this.diagram._pageBackgroundLayer) {
                ej.datavisualization.Diagram.PageUtil._updatePageSize(this.diagram);
            }
            if (this.singleAction) {
                this.diagram.activateTool("select");
            }
            delete this.diagramBounds;
            this._adjustLines = {
                lines: []
            }
            this._undoObject = null;
            this._redoObject = null;
        };
        ToolBase.prototype.mousePosition = function (evt) {
            return this.diagram._mousePosition(evt);
        };
        ToolBase.prototype.updateCursor = function (cursor) {
            this.diagram._currentCursor = cursor;
            this.diagram._updateCursor();
        };
        ToolBase.prototype.nearestGridPoint = function (point) {
            var snapPt = ej.datavisualization.Diagram.Point();
            if (this.diagram.model.snap & ej.datavisualization.Diagram.Snap.Grid) {
                var magnification = this.diagram.model.magnification / 100;
                var hSpacing = this.diagram.model.grid.horizontalSpacing * magnification;
                var vSpacing = this.diagram.model.grid.verticalSpacing * magnification;
                var width = point.x % hSpacing;
                var height = point.y % vSpacing;
                if (width >= (hSpacing / 2)) {
                    snapPt.x = point.x + hSpacing - width;
                }
                else {
                    snapPt.x = point.x - width;
                }
                if (height >= (vSpacing / 2)) {
                    snapPt.y = point.y + vSpacing - height;
                }
                else {
                    snapPt.y = point.y - height;
                }
            }
            return snapPt;
        };
        ToolBase.prototype.snap = function (point) {
            var snapSettings = this.diagram.model.snapSettings;
            var zoomFactor = this.diagram._currZoom;
            if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToVerticalLines)
                point.x = ej.datavisualization.Diagram.SnapUtil._round(point.x, snapSettings.verticalGridLines.snapInterval, zoomFactor);
            if (snapSettings.snapConstraints & ej.datavisualization.Diagram.SnapConstraints.SnapToHorizontalLines)
                point.y = ej.datavisualization.Diagram.SnapUtil._round(point.y, snapSettings.horizontalGridLines.snapInterval, zoomFactor);
            return point;

        };
        ToolBase.prototype._endAction = function () {
            this.inAction = false;

            if (this.svgHelper) {
                var helper = this.helper;
                var search = this.diagram._spatialSearch;
                if (helper._type != "group") {
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(search, search.quadTable[helper.name], helper);
                }
                else {
                    var length = this.helper.children.length - 1;
                    for (var i = length; i >= 0; i--) {
                        ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(search, search.quadTable[helper.children[i].name], helper.children[i]);
                    }
                }
            }
            if (this.helper) {
                if (this.svgHelper) {
                    var diagram = this.diagram;
                    var _currTool = this;
                    this.diagram._views.forEach(function (viewid) {
                        var view = diagram._views[viewid];
                        if (_currTool.helper) {
                            var element = view.svg.getElementById(_currTool.helper.name);
                            var htmlLayer = view.svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                            var label = $(htmlLayer).find("#" + _currTool.helper.name)[0];
                        }
                        if (element && element.parentNode)
                            element.parentNode.removeChild(element);
                        if (label)
                            htmlLayer.removeChild(label);

                    });
                }
                if (this.helper.gradient) {
                    var defs = this.diagram._svg.getElementsByTagName("defs")[0];
                    var hlprEle = this.diagram._svg.getElementById(this.helper.name + "_gradient");
                    if (defs && hlprEle)
                        defs.removeChild(this.diagram._svg.getElementById(this.helper.name + "_gradient"));
                }
                var htmlElement = document.getElementById(this.helper.name + "_parentdiv");
                if (htmlElement)
                    htmlElement.parentNode.removeChild(htmlElement);
            }
            if (this._previousPossibleConnection) {
                this._previousPossibleConnection = null;
                ej.datavisualization.Diagram.SvgContext._removePortHighlighter(this.diagram._adornerSvg, this.diagram._adornerLayer);
            }
            this._currentPossibleConnection = null;
            this._possibleConnectionPort = null;
            this.helper = null;
            this.svgHelper = null;
            this.selectedObject = null;
            this.startPoint = ej.datavisualization.Diagram.Point(0, 0);
            this.currentPoint = ej.datavisualization.Diagram.Point(0, 0);
            this.previousPoint = ej.datavisualization.Diagram.Point(0, 0);
        };
        ToolBase.prototype._isResizeCorner = function (type) {
            var isResizeCorner = false;
            switch (type) {
                case "n-resize":
                case "e-resize":
                case "w-resize":
                case "s-resize":
                case "ne-resize":
                case "nw-resize":
                case "se-resize":
                case "sw-resize":
                case "targetEndPoint":
                case "sourceEndPoint":
                    isResizeCorner = true;
                    break;
            }
            return isResizeCorner;
        };
        ToolBase.prototype._initHelper = function () {
            if (this.selectedObject) {
                this.helper = $.extend(true, {}, this.selectedObject);
                this._updateHelperName(this.helper);
            }
        };
        ToolBase.prototype._updateHelperName = function (helper, child) {
            if (child) {
                helper.name += "helper";
            }
            else
                helper.name = "helper";
            helper.opacity = 0.5;
            var labels = helper.labels;
            for (var i = 0, len = labels.length; i < len; ++i) {
                labels[i].name += "helper";
            }
            if (helper.ports) {
                var ports = helper.ports;
                for (i = 0, len = ports.length; i < len; ++i) {
                    ports[i].name += "helper";
                }
            }
            if (helper._type === "group") {
                var children = this.diagram._getChildren(helper.children);
                for (i = 0, len = children.length; i < len; i++) {
                    this._updateHelperName(children[i], true);
                }
            }
        };
        ToolBase.prototype._raiseEvent = function (type, args) {
            if (this.diagram.model[type]) {
                args.elementType = this.diagram.getObjectType(args.element);
                args.diagramId = this.diagram.element[0].id;
                this.diagram._trigger(type, args);
            }
            return args;
        };
        ToolBase.prototype._findPort = function (pt, node) {
            var port = this.diagram._findPortAtPoint(pt, node);
            if (!port && node._type === "group") {
                var childPort;
                var children = this.diagram._getChildren(node.children);
                for (var j = 0; j < children.length; j++) {
                    var child = this.diagram.nameTable[children[j]];
                    if (child && !child.segments && !child._isInternalShape) {
                        childPort = this._findPort(pt, child);
                        if (childPort && this.diagram.getObjectType(child) != "group") {
                            this._currentPossibleConnection = child;
                            port = childPort;
                        }
                        else if (childPort) {
                            return childPort;
                        }
                    }
                }
            }
            return port;
        };
        ToolBase.prototype._checkConnectionPossible = function (evt) {
            var port = null, possibleConnector = null;
            var connectedNode = this._sourcePossibleConnection;
            var pt = ej.datavisualization.Diagram.Point(this.currentPoint.x, this.currentPoint.y);
            var node = this.diagram._findConnectableNodeUnderMouse(evt);
            if (node && (this._sourcePossibleConnection || this.selectedObject)) {
                if (this.selectedObject) {
                    if (this._endPoint == "targetEndPoint" && this.selectedObject.sourceNode)
                        connectedNode = this.diagram.nameTable[this.selectedObject.sourceNode];
                    if (this._endPoint == "sourceEndPoint" && this.selectedObject.targetNode)
                        connectedNode = this.diagram.nameTable[this.selectedObject.targetNode];
                }
                if (this.selectedObject && !this.selectedObject._isAnnotationLine)
                    node = ej.datavisualization.Diagram.bpmnHelper.canAllowConnection(this.diagram, connectedNode, node);
            }
            if (node && !(node.segments)) {
                if (!(node.type == "pseudoGroup") && !node.isLane && !node.isSwimlane) {
                    this._showPorts(node);
                    this._currentPossibleConnection = node;
                    if (this._previousPossibleConnection == null || this._previousPossibleConnection.name !== this._currentPossibleConnection.name) {
                        this._previousPossibleConnection = this._currentPossibleConnection;
                    }
                }
                else {
                    this._currentPossibleConnection = null;
                    this._possibleConnectionPort = null;
                }
            }
            else if (this.diagram.activeTool instanceof ej.datavisualization.Diagram.LineTool) {
                this._showPorts();
                this._currentPossibleConnection = null;
                this._possibleConnectionPort = null;
            }
            else {
                var epoint = ej.datavisualization.Diagram.Point(0, 0);
                if (this._endPoint == "targetEndPoint") {
                    epoint.x = this.selectedObject.targetPoint.x - 25;
                    epoint.y = this.selectedObject.targetPoint.y - 25;
                }
                else if (this._endPoint == "sourceEndPoint") {

                    epoint.x = this.selectedObject.sourcePoint.x - 25;
                    epoint.y = this.selectedObject.sourcePoint.y - 25;
                }
                var bounds = ej.datavisualization.Diagram.Rectangle(epoint.x, epoint.y, 50, 50);
                var quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(this.diagram._spatialSearch, bounds);
                for (var i = 0; this._nearestNodes && i < this._nearestNodes.length; i++)
                    this._showPort(this._nearestNodes[i], true);
                this._nearestNodes = [];
                for (var i = 0; i < quads.length; i++) {
                    var quad = quads[i];
                    if (quad.objects.length > 0) {
                        for (var j = 0; j < quad.objects.length; j++) {
                            var nd = quad.objects[j];
                            var nodebounds = ej.datavisualization.Diagram.Util.bounds(nd);
                            if (ej.datavisualization.Diagram.Geometry.intersectsRect(bounds, nodebounds)) {
                                if (!nd.segments && nd.visible) {
                                    this._showPort(nd);
                                    this._nearestNodes.push(nd);
                                }
                            }
                            else {
                                if (!nd.segments) {
                                    this._showPort(nd, true);
                                }
                            }
                        }
                    }
                }

                this._currentPossibleConnection = null;
                this._possibleConnectionPort = null;
            }
            if (this._currentPossibleConnection) {
                port = this._findPort(pt, this._currentPossibleConnection);
                if (this._currentPossibleConnection && (this._sourcePossibleConnection || this.selectedObject)) {
                    if (this.selectedObject && !this.selectedObject._isAnnotationLine) {
                        possibleConnector = ej.datavisualization.Diagram.bpmnHelper.canAllowConnection(this.diagram, connectedNode, this._currentPossibleConnection);
                        if (this._currentPossibleConnection != possibleConnector) {
                            this._showPort(this._currentPossibleConnection, true);
                            if (possibleConnector) this._showPort(possibleConnector);
                            port = null;
                        }
                        this._currentPossibleConnection = possibleConnector;
                    }
                }
                if ((port && ej.datavisualization.Diagram.Util.canConnect(port, true)) || ej.datavisualization.Diagram.Util.canConnect(this._currentPossibleConnection)) {
                    ej.datavisualization.Diagram.SvgContext._drawPortHighlighter(port, this._currentPossibleConnection, this.diagram._adornerSvg, this.diagram._adornerLayer,
                        this.diagram._currZoom);
                }
                else {
                    ej.datavisualization.Diagram.SvgContext._removePortHighlighter(this.diagram._adornerSvg, this.diagram._adornerLayer);
                }
                this._possibleConnectionPort = port;
                if (port && ej.datavisualization.Diagram.Util.canConnect(port, true)) {
                    var connectionNode = this._currentPossibleConnection;
                    var point = ej.datavisualization.Diagram.Util._getPortPosition(this._possibleConnectionPort, ej.datavisualization.Diagram.Util.bounds(connectionNode, true));
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, connectionNode.rotateAngle, connectionNode.offsetX, connectionNode.offsetY);
                    point = ej.Matrix.transform(matrix, point);
                    this.currentPoint = point;
                }
            }
            else {
                if (this._previousPossibleConnection) {
                    this._previousPossibleConnection = null;
                    ej.datavisualization.Diagram.SvgContext._removePortHighlighter(this.diagram._adornerSvg, this.diagram._adornerLayer);
                    this._possibleConnectionPort = null;
                }
            }

        };
        ToolBase.prototype._showPorts = function (node) {
            if (node) {
                if (this._currentPossibleConnection && this._currentPossibleConnection.name !== node.name) {
                    this._showPort(this._currentPossibleConnection, true);
                }
                this._showPort(node);
            }
            else {
                if (this._currentPossibleConnection != null) {
                    this._showPort(this._currentPossibleConnection, true);
                }
            }
        };
        ToolBase.prototype._showPort = function (node, hide) {
            var ports;
            var port;
            var portShape;
            var i;
            var len;
            if (hide) {
                ports = node.ports;
                if (ports) {
                    for (i = 0, len = ports.length; i < len; ++i) {
                        port = ports[i];
                        if (port.visibility & ej.datavisualization.Diagram.PortVisibility.Hover ||
                            (port.visibility & ej.datavisualization.Diagram.PortVisibility.Connect &&
                            (this.name == "endPoint" || this instanceof ej.datavisualization.Diagram.LineTool))) {
                            portShape = this.diagram._svg.getElementById(node.name + "_" + port.name);
                            if (portShape)
                                portShape.setAttribute("visibility", "hidden");
                        }
                    }
                }
            }
            else {
                if (node.visible) {
                    ports = node.ports;
                    if (ports) {
                        for (i = 0, len = ports.length; i < len; ++i) {
                            port = ports[i];
                            if (port.visibility & ej.datavisualization.Diagram.PortVisibility.Hover ||
                                (port.visibility & ej.datavisualization.Diagram.PortVisibility.Connect &&
                                (this.name == "endPoint" && this.inAction || this instanceof ej.datavisualization.Diagram.LineTool))) {
                                portShape = this.diagram._svg.getElementById(node.name + "_" + port.name);
                                if (portShape)
                                    portShape.setAttribute("visibility", "visible");
                            }
                        }
                    }
                }
            }
        };
        ToolBase.prototype._getAllLaneChildren = function (node, list) {
            var swilane = this.diagram.getNode(node.name)
            if (swilane && swilane.lanes && swilane.lanes.length > 0) {
                for (var i = 0; i < swilane.lanes.length; i++) {
                    for (var j = 0; j < swilane.lanes[i].children.length; j++) {
                        list.push(swilane.lanes[i].children[j]);
                    }
                }
            }
            return list;
        };
        ToolBase.prototype._getAllChildren = function (list) {
            for (var i = 0; i < list.length; i++) {
                if (list[i].isSwimlane)
                    list.concat(this._getAllLaneChildren(list[i], list));
            }
            return list;
        };
        ToolBase.prototype._showAllPorts = function (hide) {
            var i;
            var len;
            var nodes = this.diagram.nodes();
            nodes = nodes.slice();
            nodes = this._getAllChildren(nodes);
            if (!ej.datavisualization.Diagram.Util.isPageEditable(this.diagram)) hide = true;
            if (hide) {
                for (i = 0, len = nodes.length; i < len; i++) {
                    this._showPort(nodes[i], hide);
                }
            }
            else {
                for (i = 0, len = nodes.length; i < len; ++i) {
                    this._showPort(nodes[i]);
                }
            }
        };
        ToolBase.prototype._disconnect = function (connector) {
            var args;
            var node = this.diagram.nameTable[connector.targetNode];
            var port = null;
            if (node) {
                port = ej.datavisualization.Diagram.Util.findPortByName(node, connector.targetPort);
                args = this._raiseEvent("connectionChange", { element: connector, connection: node, port: port, cancel: false });
                ej.datavisualization.Diagram.Util.removeItem(node.inEdges, connector.name);
                if (!args.cancel) {
                    connector.targetNode = null;
                    connector.targetPort = null;
                }
            }
            node = this.diagram.nameTable[connector.sourceNode];
            if (node) {
                port = ej.datavisualization.Diagram.Util.findPortByName(node, connector.sourcePort);
                args = this._raiseEvent("connectionChange", { element: connector, connection: node, port: port, cancel: false });
                ej.datavisualization.Diagram.Util.removeItem(node.outEdges, connector.name);
                if (!args.cancel) {
                    connector.sourceNode = null;
                    connector.sourcePort = null;
                }
            }
        };
        ToolBase.prototype.getLabelUnderMouse = function () {
            if (!this.diagram._findLabelEditing)
                return this.activeLabel;
            return null;
        };
        return ToolBase;
    })();

    ej.datavisualization.Diagram.ToolBase = ToolBase;
    //#endregion

    //#region SelectTool
    var SelectTool = (function (base) {
        ej.datavisualization.Diagram.extend(SelectTool, base);
        function SelectTool(diagram) {
            base.call(this, "select", diagram);
            this.cursor = "default";
            this._svgHelper = null;
        }
        SelectTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            var node = this._findNodeUnderMouse(evt);
            if (node && ej.datavisualization.Diagram.Util.canSelect(node)) {
                this.selectedObject = node;
            }
            else
                this.selectedObject = null;

            this._itemClick(this.selectedObject, this.actualObject, this.selectedObject);
            this._nodeUnderMouseDown = this.diagram._findNodeUnderMouse(evt);
        };
        SelectTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            var node = this._nodeUnderMouseDown;
            if ((!this.selectedObject && !ej.datavisualization.Diagram.Geometry.isEmptyPoint(this.startPoint)) ||
            (node && node.isLane && ej.datavisualization.Diagram.Util.canMultiSelectOnLane(node)) || (node && node._type != "connector" && ej.datavisualization.Diagram.Util.canMultiSelectOnNode(node))) {
                if (ej.datavisualization.Diagram.Util.canDoMultipleSelection(this.diagram)) {
                    if (!this.inAction && (this.startPoint.x != this.currentPoint.x || this.startPoint.y != this.currentPoint.y)) {
                        this.inAction = true;
                        this._initHelper();
                    }
                    else
                        this._updateHelper();
                }
            }
        };
        SelectTool.prototype.mouseup = function (evt) {
            this.diagram._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Mouse;
            if (this.inAction) {
                this.currentPoint = this.mousePosition(evt);
                var rect = ej.datavisualization.Diagram.Geometry.rect([{ x: this.startPoint.x, y: this.startPoint.y }, { x: this.currentPoint.x, y: this.currentPoint.y }]);
                if (rect.width !== 0 || rect.height !== 0) {
                    var collection = [];
                    collection = this.diagram._getNodesfrombounds(rect);
                    if (this.diagram._hasSelection()) {
                        collection = this.diagram._getChildren(collection);
                        ej.datavisualization.Diagram.Util.removeItem(collection, "multipleSelection");
                        this.diagram._clearSelection(collection.length ? true : false);
                    }
                    if (collection.length > 0) {
                        var children = collection;
                        var selection;
                        this.diagram._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.RubberBand
                        if (children.length > 1) {
                            var pseudoGroup = ej.datavisualization.Diagram.Group({ type: "pseudoGroup", "name": "multipleSelection" });
                            for (var i = 0 ; i < children.length; i++) {
                                //children[i].parent = "multipleSelection";
                                pseudoGroup.children.push(this.diagram._getChild(children[i]));
                            }
                            this.diagram.nodes().push(pseudoGroup);
                            this.diagram._nodes = $.extend(true, [], this.diagram.nodes());
                            this.diagram.nameTable[pseudoGroup.name] = pseudoGroup;
                            selection = pseudoGroup;
                        }
                        else {
                            if (ej.datavisualization.Diagram.Util.canDoSingleSelection(this.diagram))
                                selection = collection[0];
                        }
                        if (selection) {
                            if (selection._type === "group" || selection.type === "pseudoGroup")
                                ej.datavisualization.Diagram.Util._updateGroupBounds(selection, this.diagram);
                            this.diagram._addSelection(selection);
                        }
                    }
                }
                else {
                    if (this.diagram._hasSelection() && !this.diagram._isDropped) {
                        this.diagram._clearSelection();
                    }
                }
            }
            else {
                if (this.selectedObject || this.diagram._hasSelection()) {
                    if (evt.ctrlKey || evt.shiftKey) {
                        if (ej.datavisualization.Diagram.Util.canDoMultipleSelection(this.diagram)) {
                            this._processCtrlKey(evt);
                        }
                    }
                    else if (this.diagram._hasSelection() && (!this.selectedObject || (this.diagram.selectionList[0].name != this.selectedObject.name)))
                        this.diagram._clearSelection(this.selectedObject ? true : false);
                    this.diagram._enableAPIMethods = false;
                    this.diagram._addSelection(this.selectedObject);
                    this.diagram._enableAPIMethods = true;
                }
                else if (this.diagram._hasSelection() && !this.diagram._isDropped) {
                    this.diagram._clearSelection();
                }
            }
            this.diagram._isDropped = false;
            this._nodeUnderMouseDown = null;
            if (this.selectedObject || this.actualObject) {
                var obj = this.selectedObject || this.actualObject;
                var mousePosition = this.diagram._mousePosition(evt.originalEvent);
                this._raiseEvent("click", { element: this.diagram.getNode(obj), actualObject: this.actualObject, count: this.diagram._getEventDetail(evt), offsetX: mousePosition.x, offsetY: mousePosition.y, event: evt });
            }
            base.prototype.mouseup.call(this, evt);

        };
        SelectTool.prototype._endAction = function () {
            if (this._svgHelper) {
                this.diagram._adornerLayer.removeChild(this._svgHelper);
                this.selectedObject = null;
                this._svgHelper = null;
            }
            base.prototype._endAction.apply(this);
        };
        SelectTool.prototype._initHelper = function () {
            if (!this._svgHelper) {
                var g = this.diagram._adornerSvg.g();
                this.diagram._adornerLayer.appendChild(g);

                var scale = this.diagram._currZoom;
                var selectionRect = this.diagram._svg.rect({
                    "id": "helper", "class": "rubberBandSelection", "x": this.startPoint.x * scale, "y": this.startPoint.y * scale,
                    "fill": "transparent", "stroke": "gray", "stroke-dasharray": "2 2", "shape-rendering": "crispEdges"
                });
                g.appendChild(selectionRect);
                g.setAttribute("pointer-events", "none");
                this._svgHelper = g;
            }
        };
        SelectTool.prototype._updateHelper = function () {
            var helper = this.diagram._adornerSvg.getElementById("helper");
            var width = Math.abs(this.startPoint.x - this.currentPoint.x);
            var height = Math.abs(this.startPoint.y - this.currentPoint.y);
            var scale = this.diagram._currZoom;
            var x = ((this.startPoint.x > this.currentPoint.x) ? this.currentPoint.x : this.startPoint.x) * scale;
            var y = ((this.startPoint.y > this.currentPoint.y) ? this.currentPoint.y : this.startPoint.y) * scale;

            if (helper) {
                this.diagram._adornerSvg.rect({
                    "id": helper.id, "x": x,
                    "y": y, "width": width * scale, "height": height * scale
                });
            }
        };
        SelectTool.prototype._checkGroupChildren = function (collection, group, bounds) {
            var child, childBounds;
            var children = this.diagram._getChildren(group.children);
            for (var i = 0; i < children.length; i++) {
                child = this.diagram.nameTable[children[i]];
                if (child && ej.datavisualization.Diagram.Util.canSelect(child)) {
                    childBounds = ej.datavisualization.Diagram.Util.bounds(child);
                    if (ej.datavisualization.Diagram.Geometry.containsRect(bounds, childBounds) && collection.indexOf(child) < 0) {
                        collection.push(child);
                    }
                    else if (child._type === "group") {
                        this._checkGroupChildren(collection, child, bounds);
                    }
                }
            }
        }
        return SelectTool;
    })(ToolBase);

    ej.datavisualization.Diagram.SelectTool = SelectTool;
    //#endregion

    //#region MoveTool
    var MoveTool = (function (base) {

        ej.datavisualization.Diagram.extend(MoveTool, base);

        function MoveTool(diagram) {
            base.call(this, "move", diagram);
            this.cursor = "move";
            this._isMouseDown = false;
            this.diffx = 0;
            this.diffy = 0;
            this.helper = null;
            this.hoverNode = null;
            this.stackOverNode = null;
            this.undoObject = [];
            this.activeLabel = null;
            this._canMoveLabel = false;
            this.dragState = "";
        }

        MoveTool.prototype.mousedown = function (evt) {
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            this.diffx = 0;
            this.diffy = 0;
            this._allowPan(this.selectedObject, "mousedown", evt);
            base.prototype.mousedown.call(this, evt);
            this._isMouseDown = true;
            this._canMoveLabel = false;
            this.activeLabel = null;
            if (evt)
                var node = this._findNodeUnderMouse(evt);
            if (node && !ej.datavisualization.Diagram.Util.canSelect(node)) {
                this.updateCursor("default");
            }
            else if (this.diagram._currentCursor != "pointer")
                this.updateCursor(this.cursor);
            this._findLabelUnderMouse(evt);
            this.dragState = ej.datavisualization.Diagram.DragState.Starting;
        };

        MoveTool.prototype.mousemove = function (evt) {
            this.diagram._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Mouse;
            this._allowPan(this.selectedObject, "mousemove", evt);
            base.prototype.mousemove.call(this, evt);
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            var start = !this.inAction;
            //Initiate move action
            if (this._isMouseDown && !this.inAction &&
                (this.startPoint.x != this.currentPoint.x || this.startPoint.y != this.currentPoint.y || this.diagram._selectedSymbol)) {
                if (!this.selectedObject && ((this.diagram.selectionList && this.diagram.selectionList[0] && this.diagram.selectionList[0].type === "pseudoGroup") || this.diagram._selectedSymbol || (ej.datavisualization.Diagram.Util.canDoSingleSelection(this.diagram)))) {
                    //set the selected object
                    this._updateSelectedObject();
                    // raise item click event
                    //var tempVal = this.selectedObject;
                    //var args = this._raiseEvent("itemClick",
                    //    { actualObject: this.actualObject, selectedObject: this.selectedObject, model: this.diagram.model, cancel: false });
                    this._itemClick(this.selectedObject, this.actualObject, this.diagram.model);
                    //if (args.cancel)
                    //this.selectedObject = tempVal;
                    if (this.selectedObject != null) {
                        var newbounds, oldbounds;
                        newbounds = oldbounds = ej.datavisualization.Diagram.Util.bounds(this.selectedObject);
                        var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: this.selectedObject.offsetX, offsetY: this.selectedObject.offsetY, width: this.selectedObject.width, height: this.selectedObject.height };
                        var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: this.selectedObject.offsetX, offsetY: this.selectedObject.offsetY, width: this.selectedObject.width, height: this.selectedObject.height };
                        if (this.diagram.selectionList[0] != this.selectedObject)
                            this.diagram._clearSelection(true);
                        this._raiseDragEvent({ element: this.diagram.getNode(this.selectedObject), offset: { x: 0, y: 0 }, oldValue: oldValue, newValue: newValue, cancel: false });
                        var childTable = {};
                        if (this.selectedObject && (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup"))
                            childTable = this.diagram._getChildTable(this.selectedObject, childTable);
                        var data = $.extend(true, {}, { "childTable": childTable, "node": this.selectedObject });
                        this.undoObject = jQuery.extend(true, {}, data);
                    }
                }
            }

            if (this._isMouseDown && this.selectedObject && ej.datavisualization.Diagram.Util.canSelect(this.selectedObject) && !this.diagram._isEditing) {
                this.dragState = ej.datavisualization.Diagram.DragState.Dragging;
                if (!this.inAction) {
                    this.inAction = true;
                    if (!this._canMoveLabel)
                        this.updateCursor("move");
                    this._updateSelection();
                    //Disconnect the connector, if it is being dragged
                    if (this.selectedObject.segments && !this._canMoveLabel) {
                        if (ej.datavisualization.Diagram.Util.isTargetConnected(this.selectedObject) ||
                            ej.datavisualization.Diagram.Util.isSourceConnected(this.selectedObject)) {
                            this._disconnect(this.selectedObject);
                        }
                    }
                    //disable pointer events to the selected object
                    ej.datavisualization.Diagram.SvgContext._disableSelectedNode(this.selectedObject, this.diagram._svg, this.diagram);
                }
                if (this._canMoveLabel)
                    this._updateLabelXY(this.activeLabel, this.previousPoint, this.currentPoint);
                else {
                    if (this.diagram && !this.diagram._isEditing) {
                        this._containerMouseMove(evt);
                    }
                    //visually update the selected object
                    if (!this.helper)
                        this._updateObject();
                    //update the tooltip
                    if (!this.selectedObject.segments && !this.selectedObject.isLane)
                        this.diagram._renderTooltip(this.selectedObject, start);
                    //not needed since it is enough to update the selection for the first time
                    //this._updateSelection();
                    this.diagram._updateSelectionHandle(true);
                }
            }
            this.previousPoint = this.currentPoint;
            this._stackOverNode = this._findStackOverNode(this.helper, evt);
            delete this.diagram._notAllow;
        };

        //set the selected object
        MoveTool.prototype._updateSelectedObject = function () {
            var selectedObject = this.diagram._focusedElement;
            if (selectedObject) {
                if (this.activeLabel && !this.diagram._selectedSymbol) {
                    if (ej.datavisualization.Diagram.Util.canMoveLabel(selectedObject))
                        this._canMoveLabel = true;
                    else {
                        this._disableLabel(selectedObject, this.activeLabel);
                        this._canMoveLabel = false;
                    }
                }
                if (this.diagram.selectionList[0] && this.diagram.selectionList[0].type == "pseudoGroup") {
                    if (this._canMoveLabel) {
                        this.selectedObject = selectedObject;
                        this.diagram._clearSelection(true);
                    }
                    else
                        this.selectedObject = this.diagram.selectionList[0];

                } else {
                    if (this.diagram.selectionList[0] != selectedObject) {
                        this.diagram._clearSelection(true);
                        this.selectedObject = this.diagram.nameTable[selectedObject.name];
                    } else {
                        this.selectedObject = this.diagram.nameTable[this.diagram.selectionList[0].name];
                    }
                }
            }
        };
        MoveTool.prototype._nodeCanHighlight = function (hoverNode) {
            var status = false;
            if ((this.diagram._getChildren(hoverNode.children)).indexOf(this.selectedObject.name) == -1) {
                if (this.selectedObject._type != "group") {
                    status = true;
                }
                else {
                    if (hoverNode._type === "group") {
                        if (!this._containsChild(this.selectedObject, hoverNode.name))
                            status = true;
                    }
                }
            }
            return status;
        },
        MoveTool.prototype._swimlanPhaseDrag = function (evt) {
            if (this.selectedObject && this.selectedObject.isPhase) {
                var swimlane = null;
                var btmNode = this._getNodeUnderMouse();
                if (btmNode)
                    swimlane = this._getSwimLaneNode(btmNode, this.selectedObject, true);
                if (swimlane) {
                    ej.datavisualization.Diagram.SvgContext._drawNodeHighlighter(swimlane, this.diagram._adornerSvg, this.diagram._adornerLayer, this.diagram._currZoom);
                }
            }
        };
        MoveTool.prototype._containerMouseMove = function (evt) {
            //#region for Container
            var overNode, gHighLight;
            var parent = this.selectedObject.parent && this.diagram.nameTable[this.selectedObject.parent];
            if (parent && parent.container) {
                var container = parent.container;
                if (container.type == "canvas" || container.type == "stack") {
                    ej.datavisualization.Diagram.canvasHelper._updateHelper(this.diagram);
                    ej.datavisualization.Diagram.canvasHelper._updateHighlighter(this.diagram, evt);
                }
            } else {
                if (!this.selectedObject.isSwimlane) {
                    if ((this.selectedObject.type == "pseudoGroup") && this._isParentAsLane(this.selectedObject)) {
                        this._removeHighLighter();
                    }
                    else if (!this.isDiagram(evt) && !this.selectedObject.segments) {
                        overNode = this._getNodeUnderMouse();
                        //this.hoverNode = this.stackOverNode;
                        if (overNode && overNode.container && (this.selectedObject.isSwimlane || this.selectedObject.isLane)) {
                            if (this._getSwimLaneNode(overNode, this.selectedObject))
                                this._nodeHighLighter(overNode);
                        }
                        else if (overNode && overNode.container && overNode.container.type != "stack") {
                            if (this.selectedObject.name != overNode.name && this.selectedObject.type != "pseudoGroup" && ej.datavisualization.Diagram.bpmnHelper.canAllowDropOnContainer(this.selectedObject, overNode))
                                this._nodeHighLighter(overNode);

                            if (overNode && (this.selectedObject.type == "pseudoGroup" || this.selectedObject.name == "multipleSelection")) {
                                if (this._fromDiagram(this.selectedObject.children)) {
                                    this._nodeHighLighter(overNode);
                                }
                            }
                        }
                        else if (overNode) {
                            this._removeHighLighter();
                            if (!overNode.segments)
                                this._nodeHighLighter(overNode);
                            else {
                                ej.datavisualization.Diagram.SvgContext._drawConnectorHighlighter(overNode, this.diagram, this.diagram._currZoom);
                            }
                        }
                    }
                    else if (!this.isDiagram(evt) && this.selectedObject.isPhase) {
                        ej.datavisualization.Diagram.SvgContext._disableSelectedNode(this.selectedObject, this.diagram._svg, this.diagram);
                    }
                    else
                        this._removeHighLighter();
                }
                if (!gHighLight) {
                    if (this.selectedObject.type == "pseudoGroup") {
                        if (this._fromDiagram(this.diagram._getChildren(this.selectedObject.children))) {
                            if (!this._undoObject)
                                ej.datavisualization.Diagram.Util._getUndoObject(this.diagram, this.selectedObject);
                            this._updateXY(this.selectedObject, this.previousPoint, this.currentPoint);
                        }
                        else if ((this._fromSameContainer(this.diagram._getChildren(this.selectedObject.children)) && this.hasSameParent()) || this._anyFromContainer(this.diagram._getChildren(this.selectedObject.children))) {
                            ej.datavisualization.Diagram.canvasHelper._removeFromParentContainer(this.diagram, this.selectedObject);
                            this._updateXY(this.selectedObject, this.previousPoint, this.currentPoint);
                        }
                    }
                    else if (ej.datavisualization.Diagram.Util.canMove(this.selectedObject))
                        this._updateXY(this.selectedObject, this.previousPoint, this.currentPoint);
                }
            }
            //#endregion  
            this._swimlanPhaseDrag(evt);
        };

        MoveTool.prototype.isDiagram = function (evt) {
            if (evt.target.id == this.diagram._id + "_canvas_svg" || evt.target.id.match(this.selectedObject.name))
                return true;
            else
                return false;
        };
        MoveTool.prototype._allowPan = function (node, moveType, evt) {
            if (moveType === "mousedown")
                this.diagram.tools["panTool"].mousedown(evt);
            if (node && (node._type === "group" || node._type == "node") && (node.constraints & ej.datavisualization.Diagram.NodeConstraints.AllowPan)) {
                if (moveType === "mousemove")
                    this.diagram.tools["panTool"].mousemove(evt);
                else if (moveType === "mouseup")
                    this.diagram.tools["panTool"].mouseup(evt);
            }
        };
        MoveTool.prototype._checkForDropEvent = function (hoverNode, skip) {
            if (!this.diagram._selectedSymbol) {
                var source = this.diagram, target = hoverNode, childBounds = null, objectType = ej.datavisualization.Diagram.ObjectTypes.Diagram;
                if (this.selectedObject && this.selectedObject.parent) {
                    source = this.diagram.nameTable[this.selectedObject.parent];
                    if (source.isLane) objectType = ej.datavisualization.Diagram.ObjectTypes.Lane;
                    else if (source._type == "group") objectType = ej.datavisualization.Diagram.ObjectTypes.Group;
                }
                if (hoverNode && !skip) {
                    childBounds = ej.datavisualization.Diagram.Util.bounds(hoverNode);
                    target = this._getTargetNode(hoverNode, childBounds);
                }
                do {
                    if (hoverNode && !ej.datavisualization.Diagram.Util.canAllowDrop(hoverNode)) {
                        if (hoverNode.parent) hoverNode = this.diagram.nameTable[hoverNode.parent];
                        else
                            if (hoverNode.container) {
                                break;
                            }
                            else
                                hoverNode = null;
                    }
                    else break;
                } while (hoverNode);
                if (hoverNode) {
                    var args = this._raiseEvent("drop", { cancel: false, element: this.selectedObject, source: this.diagram.getNode(source), target: this.diagram.getNode(target), sourceType: objectType });
                    return args.cancel;
                }
            }
            return false;
        };

        MoveTool.prototype._getSwimLaneNode = function (node, selNode, isPhase) {
            if (node.isSwimlane) {
                if (isPhase) {
                    if (this.diagram.nameTable[this.diagram._getChild(node.children[2])].container.orientation == selNode.orientation)
                        return node;
                }
                else if (this.diagram.nameTable[this.diagram._getChild(node.children[2])].container.orientation != selNode.orientation)
                    return node;
            }
            if (node.parent) {
                var parent = this.diagram.nameTable[node.parent];
                if (parent) {
                    return this._getSwimLaneNode(parent, selNode, isPhase);
                }
            }
            return null;
        };
        MoveTool.prototype._cloneGroupNode = function (node, id) {
            var child = null, child1, clnObj, node1;
            node1 = $.extend(true, {}, node);
            node1.name += id;
            if (node && node._type === "group") {
                node1.children = [];
                var children = this.diagram._getChildren(node.children);
                for (var i = 0; i < children.length; i++) {
                    child = this.diagram.nameTable[children[i]];
                    child1 = $.extend(true, {}, child);
                    child1.name += id;
                    if (child1.parent)
                        child1.parent += id;
                    if (child1._type === "group")
                        this._cloneGroupNode(child1, id);
                    this.diagram.nameTable[child1.name] = child1;
                    node1.children.push(child1.name);
                }
            }
            return node1;
        };
        MoveTool.prototype._outOfBoundsLaneDrop = function (node, swimlane) {
            if (node && node.isLane && ej.datavisualization.Diagram.Util.canMoveOutofBoundary(this.diagram)) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                var size = this._getPageBounds();
                var offsetX = swimlane.offsetX, offsetY = swimlane.offsetY, height = 0, width = 0, phaseSize = 0, headHeight = 0;
                var laneStack = this.diagram.nameTable[swimlane.children[2]];
                var header = this.diagram.nameTable[swimlane.children[0]];
                headHeight = header ? header.height : headHeight;
                phaseSize = swimlane.phaseSize ? swimlane.phaseSize : phaseSize;
                if (laneStack) {
                    var lane = this.diagram.nameTable[laneStack.children[0]];
                    if (lane) {
                        height = lane.minHeight > 100 ? lane.minHeight : 100;
                        width = lane.minWidth > 100 ? lane.minWidth : 100;
                    }
                }
                if (node.orientation === "horizontal") {
                    var aX = width;
                    var aY = height + header.height + phaseSize;
                }
                else {
                    var aX = width + phaseSize;
                    var aY = height + header.height;
                }

                if (offsetX + aX / 2 + 5 >= size.width || offsetX - aX / 2 - 5 <= size.x) {
                    return false
                }
                if (offsetY + aY / 2 + 5 >= size.height || offsetY - aY / 2 - 5 <= size.y) {
                    return false
                }

            }
            return true;
        };
        MoveTool.prototype._getMouseOverElement = function (evt, mouseup) {
            var node = null;
            if (evt && evt.target) {
                var parents = $(evt.target).parents(".ej-d-node,.ej-d-connector,.ej-d-group,.ej-d-group ej-d-classifier,.ej-d-node ej-d-classifier,.ej-d-label ej-d-classifier");
                var parent = parents[0];
                var i = 1;
                while (parent) {
                    var foreignObject = this.diagram._isForeignObject(evt.target);
                    if (foreignObject)
                        node = this.diagram._findNode(parent.getAttribute("id").split('_parentdiv')[0]);
                    else
                        node = this.diagram._findNode(parent.getAttribute("id"));
                    if (node && node.container) {
                        parent = null;
                    } else {
                        if (node && mouseup && node._isHeader && node.parent) {
                            var pObj = this.diagram.nameTable[node.parent];
                            if (pObj && pObj.isSwimlane) {
                                break;
                            }
                        }
                        parent = parents[i];
                        if (!parent && node && node.parent) {
                            var parentObj = this.diagram.nameTable[node.parent];
                            if (parentObj && parentObj.isLane)
                                node = parentObj;
                        }
                        i++;
                    }
                }
            }
            return node;
        };
        MoveTool.prototype._multiNodedrag = function (evt, overNode) {
            if (ej.datavisualization.Diagram.canvasHelper && !this._containsSwimlane(this.selectedObject.children))
                ej.datavisualization.Diagram.canvasHelper._multiNodedrag(this.diagram, evt, this.selectedObject);
        },
        MoveTool.prototype._changeNodeState = function (evt, doc, mouseup) {
            var newObj, pNode, mergNode = null;
            var overNode = this._getMouseOverElement(evt, mouseup);
            if (overNode) overNode = (this.selectedObject && !this.selectedObject.isLane || overNode.isLane) ? overNode : null;
            //#region drop fropm palette
            if (this.diagram._selectedSymbol && this.diagram._selectedSymbol.isLane && !doc) {
                this.diagram._isDragg = true;
                if (overNode)
                    mergNode = this._getSwimLaneNode(overNode, this.selectedObject);
                if (overNode && mergNode) {
                    ej.datavisualization.Diagram.canvasHelper._addNewLane(this.diagram, overNode, mergNode);
                }
                else {
                    //add new stack
                    var header = this.diagram.nameTable[this.selectedObject.children[0]];
                    this.diagram._isUndo = true;
                    this.diagram.remove(this.selectedObject);
                    ej.datavisualization.Diagram.containerCommon._removeObject(this.diagram, this.selectedObject);
                    if (this.diagram._selectedSymbol)
                        ej.datavisualization.Diagram.containerCommon._removeObject(this.diagram, this.diagram._selectedSymbol);
                    this.diagram._isUndo = false;


                    var swimlane = ej.datavisualization.Diagram.SwimLaneHelper._createSwimlane(this.selectedObject, this.diagram, null, null, header);
                    if (swimlane) {
                        var args;
                        args = { element: this.diagram.getNode(this.selectedObject), cancel: false };

                        this.diagram._selectedSymbol = null;
                        if (this._outOfBoundsLaneDrop(this.selectedObject, swimlane)) {
                            this.diagram._raiseDropEvent(args);
                            if (!args.cancel) {
                                this.diagram._eventCause["nodeCollectionChange"] = ej.datavisualization.Diagram.CollectionChangeCause.Drop;
                                if (this.diagram.add(swimlane)) {
                                    swimlane = this.diagram.nameTable[swimlane.name] || swimlane;
                                    this.diagram._selectedSymbol = swimlane;
                                    this.diagram._updateDroppedSymbol(swimlane);
                                    this.selectedObject = swimlane;
                                }
                                else {
                                    this.selectedObject = null;
                                }
                            }
                            else {
                                this.selectedObject = null;
                            }
                        }
                        else this.selectedObject = null;
                    }
                }
            }//#endregion
                //#region for Container 
            else if (this.selectedObject && this.selectedObject.parent && this.diagram.nameTable[this.selectedObject.parent].container) {
                var selectedParent = this.diagram.nameTable[this.selectedObject.parent];
                if (selectedParent) {
                    var container = selectedParent.container;
                    this._removeHelpers();
                    if (container && container.type == "canvas") {
                        ej.datavisualization.Diagram.SvgContext._showNode(this.selectedObject, this.diagram._svg);
                        if (this.selectedObject.type != "pseudoGroup" && !this.diagram._isDragg)
                            this._swimlaneNodeDragged = ej.datavisualization.Diagram.canvasHelper._singleNodedrag(this.diagram, evt, overNode);
                    } else if (container.type == "stack") {
                        ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                    } else { //add to diagram
                        if (this.isDiagram(evt)) {
                            this._addToDiagram();
                        }
                        this.diffx = this.diffy = 0;
                    }
                }
            }
            else {///added from diagram to container
                if (this.selectedObject && !this.selectedObject.isSwimlane) {
                    if (this.selectedObject.type == "pseudoGroup" && this.hasSameParent()) {
                        this.currentPoint = this.previousPoint;
                        this.diffx = 0; this.diffy = 0;
                        this._removeHelpers();
                        this._multiNodedrag(evt, overNode);
                    }
                    else if ((this.selectedObject.type != "connector" || this.selectedObject.isPhase) && !this.isDiagram(evt) && this.selectedObject.type != "pseudoGroup") {
                        var overNode = this._getMouseOverElement(evt);
                        if (!this.diagram._isDragg) {
                            if (overNode && overNode.container && ej.datavisualization.Diagram.Util.canAllowDrop(overNode) && (!this._checkForDropEvent(overNode)) && !overNode.isSwimlane && ej.datavisualization.Diagram.bpmnHelper.canAllowDropOnContainer(this.selectedObject, overNode)) {
                                var drgNode = this.helper ? this.helper : this.selectedObject;
                                if (ej.datavisualization.Diagram.canvasHelper._outOfBoundaryNodeDrop(this.diagram, drgNode, overNode)) {
                                    ej.datavisualization.Diagram.canvasHelper._addNodeToContainer(this.diagram, this.selectedObject, overNode);
                                    this.diagram._raiseGroupChangeEvent(this.selectedObject, null, overNode, "group");
                                }
                                else {
                                    this.diagram._translate(this.selectedObject, (this.undoObject.node.offsetX - this.selectedObject.offsetX), (this.undoObject.node.offsetY - this.selectedObject.offsetY), this.diagram.nameTable);
                                    this.diagram._updateAssociatedConnectorEnds(this.selectedObject, this.diagram.nameTable);
                                }
                            }
                            else if (overNode && this.selectedObject.name != overNode.name) {
                                this._checkForDropEvent(overNode, true);
                            }
                        }
                    }
                    else {
                        if (this.selectedObject.type != "connector" || this.selectedObject.isPhase) {
                            if ((this.selectedObject.type == "pseudoGroup" || this.selectedObject.name == "multipleSelection") && this.diagram._activeSwimLane) {
                                //this._updateChildContainer(this.selectedObject);
                                this._multiNodedrag(evt, overNode);
                                this.selectedObject = null;
                            }
                            else if (!this.diagram._activeSwimLane && overNode && overNode.isLane) {
                                this.diagram._activeSwimLane = this._getParentSwimlane(overNode);
                                //this._updateChildContainer(this.selectedObject);
                                this._multiNodedrag(evt, overNode);
                                this.selectedObject = null;
                            }
                            else if (overNode && overNode.type == "bpmn") {
                                this._multiNodedrag(evt, overNode);
                                this.selectedObject = null;
                            }
                        }
                        else if (overNode && (this.selectedObject.type == "pseudoGroup" || this.selectedObject.name == "multipleSelection")) {
                            if (this._fromDiagram(this.selectedObject.children)) {
                                if (ej.datavisualization.Diagram.Util.canAllowDrop(overNode)) {
                                    ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                                    ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this.diagram._adornerSvg, this.diagram._adornerLayer);
                                    this._multiNodedrag(evt, overNode);
                                }

                            }
                        }
                    }
                }
            }
            this._removeHelpers();
            this._checkPhaseDrop(evt);
            return newObj;
            //#endregion   
        };
        MoveTool.prototype._checkPhaseDrop = function (evt) {
            var swimlane = null, nOffset, orientation;
            if (this.selectedObject && this.selectedObject.isPhase) {
                var btmNode = this._findNodeUnderMouse(evt);
                if (btmNode)
                    swimlane = this._getSwimLaneNode(btmNode, this.selectedObject, true);
                if (swimlane) {
                    ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                    ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this.diagram._adornerSvg, this.diagram._adornerLayer);
                    var swimlaneHeader = this._getSwimlaneHeader(swimlane)
                    if (this.selectedObject.orientation == "vertical") {
                        nOffset = this.currentPoint.x - (swimlane.offsetX - (swimlane.width / 2));
                        orientation = "horizontal";
                    }
                    else {
                        nOffset = this.currentPoint.y - (swimlane.offsetY - (swimlane.height / 2));
                        nOffset -= swimlaneHeader ? swimlaneHeader.height : 0;
                        orientation = "vertical";
                    }
                    var args;
                    args = { element: this.selectedObject, cancel: false, target: swimlane };
                    this.diagram._dropPhase = true;
                    this.diagram.remove(this.selectedObject);
                    delete this.diagram._dropPhase;
                    this.diagram._selectedSymbol = null;
                    this.inAction = false;
                    var label = (this.selectedObject.labels && this.selectedObject.labels.length > 0) ? this.selectedObject.labels[0] : { text: "Phase" };
                    this.diagram._addPhase(swimlane.name, {
                        name: ej.datavisualization.Diagram.Util.randomId(), offset: nOffset, orientation: orientation,
                        label: label,
                        lineColor: this.selectedObject.lineColor,
                        lineDashArray: this.selectedObject.lineDashArray,
                        lineWidth: this.selectedObject.lineWidth,
                    });
                    this.diagram._selectedSymbol = null;
                }
                else {
                    this.diagram._remove(this.selectedObject);
                    this.diagram._clearSelection(true);
                    this.selectedObject = null;
                    this.diagram._selectedSymbol = null;
                }
            }
        };
        MoveTool.prototype._removeHelpers = function () {
            ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
            ej.datavisualization.Diagram.SvgContext._removeConnectorHighlighter(this.diagram._adornerLayer, this.diagram._adornerSvg);
            this._removeHighLighter();
            this.diffx = 0;
            this.diffy = 0;
        };
        MoveTool.prototype._updateNodeState = function (evt, newObj) {
            if (this.diagram.nameTable[this.selectedObject.parent])
                var container = this.diagram.nameTable[this.selectedObject.parent].container;
            var overNode = this._getNodeUnderMouse();
            if (overNode) overNode = (!this.selectedObject.isLane || overNode.isLane) ? overNode : null;
            if (container) {
                if (container.type == "canvas") {
                    if (overNode && newObj) {
                        var pNode = this.selectedObject.parent;
                        var swimlane = this.diagram._getSwimlane(pNode);
                        if (swimlane)
                            this.diagram._updateChildAdjacentConnectors(swimlane, true);
                        ej.datavisualization.Diagram.DiagramContext.update(newObj, this.diagram);
                    }
                }
                else if (container.type == "stack") {
                    var evtArgs = this._checkForDropEvent(overNode);
                    if (!evtArgs) {
                        var stackOverNode = this._stackOverNode;
                        if (stackOverNode) {
                            var parent = this.diagram.nameTable[stackOverNode.parent];
                            if (!parent) parent = overNode;
                            var groupBounds123 = ej.datavisualization.Diagram.Util.bounds(parent);
                            var grAngle = parent.rotateAngle;
                            if (!(parent.rotateAngle == 0) && (grAngle == 0))
                                this.diagram._rotate(parent, -parent.rotateAngle, this.diagram.nameTable);
                            parent.children = this.diagram._getChildren(parent.children);
                            if (this.selectedObject.name != stackOverNode.name) {
                                ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this.diagram)
                                ej.datavisualization.Diagram.canvasHelper._swapLane(this.diagram, parent.children, this.selectedObject.name, stackOverNode.name, ((parent.container.orientation === "vertical") ? true : false), parent);


                            }

                        } else {
                            this.diffx = this.diffy = 0;
                        }
                    }
                }
            }
            else if (this.selectedObject.type == "pseudoGroup") {
                var fNode = this.diagram.nameTable[this.diagram._getChild(this.selectedObject.children[0])];
                if (fNode && fNode.parent)
                    container = this.diagram.nameTable[fNode.parent].container;
                if (container && container.type == "canvas") {
                    if (overNode && newObj) {
                        pNode = this.selectedObject.parent;
                        this.diagram._updateChildAdjacentConnectors(pNode, true);
                        ej.datavisualization.Diagram.DiagramContext.update(newObj, this.diagram);
                    }
                }

            }
        };
        MoveTool.prototype.mouseup = function (evt, doc) {
            var skip = this.inAction;
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            var clickedObject, newObj;
            this.diagram._eventCause["selectionChange"] = ej.datavisualization.Diagram.SelectionChangeCause.Mouse;
            if (this.inAction) {
                this.dragState = ej.datavisualization.Diagram.DragState.Completed;
                ej.datavisualization.Diagram.SvgContext._enableSelectedNode(this.selectedObject, this.diagram._svg, this.diagram);
                if (!this._canMoveLabel) newObj = this._changeNodeState(evt, doc, true);
                this.inAction = false;
                if (this.selectedObject) {
                    if (this._canMoveLabel)
                        this._updateLabelXY(this.activeLabel, this.previousPoint, this.currentPoint);
                    else {
                        var newbounds, oldbounds;
                        newbounds = oldbounds = ej.datavisualization.Diagram.Util.bounds(this.selectedObject);
                        var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: this.selectedObject.offsetX, offsetY: this.selectedObject.offsetY, width: this.selectedObject.width, height: this.selectedObject.height };
                        var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: this.selectedObject.offsetX, offsetY: this.selectedObject.offsetY, width: this.selectedObject.width, height: this.selectedObject.height };
                        if (!this.selectedObject.isLane) {
                            if (!this._swimlaneNodedragged)
                                var endAction = this._updateXY(this.selectedObject, this.previousPoint, this.currentPoint);
                            if (!(this.selectedObject && this.selectedObject.parent && this.diagram.nameTable[this.selectedObject.parent].container) || !newObj) {
                                this._raiseDragEvent({ element: this.diagram.getNode(this.selectedObject), offset: { x: 0, y: 0 }, oldValue: oldValue, newValue: newValue, cancel: false });
                                this.dragState = "";
                            }
                        }
                    }
                    //#region for Container
                    if (!doc) this._updateNodeState(evt, newObj);
                    //#endregion 
                    this._updateObject();
                    var data;
                    var childTable = {};
                    if (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup")
                        childTable = this.diagram._getChildTable(this.selectedObject, childTable);
                    if (!this.diagram._selectedSymbol && !this.selectedObject.isPhase && !this.selectedObject.isLane && !this._isLane && !this.diagram._isDragg) {
                        var temp = { "childTable": childTable, "node": this.selectedObject };
                        data = $.extend(true, {}, temp);
                        var entry = { type: "positionchanged", undoObject: jQuery.extend(true, {}, this.undoObject), redoObject: jQuery.extend(true, {}, data), isMultipleNode: (this.selectedObject._type === "group") ? true : false, category: "internal" };
                        if (!this._multipleUndo)
                            this.diagram.addHistoryEntry(entry);
                        if (this.selectedObject.parent && this.diagram.nameTable[this.selectedObject.parent].type == "bpmn" && this.diagram._isGroupActionEnabled) {
                            this.diagram._closeGroupAction();
                            delete this.diagram._isGroupActionEnabled;
                        }
                    }
                    if (this.diagram._selectedSymbol && this.diagram._selectedSymbol.isSwimlane) this.diagram._selectedSymbol = null;
                    this.diagram._updateSelectionHandle();
                    clickedObject = this.selectedObject;
                    this._isLane = false;
                    this._multipleUndo = false;
                }
            }
            else {
                if (!this.selectedObject) {
                    if (evt.ctrlKey || evt.shiftKey) {
                        clickedObject = this._processCtrlKey(evt);
                    }
                    else {
                        var isMulSelect = true;
                        var className = evt.target.className;
                        if (ej.datavisualization.Diagram.Util.isClassifier(evt))
                            var mNode = ej.datavisualization.Diagram.ClassifierHelper.getSelectableElementUnderMouse(evt, this.diagram);
                        else
                            mNode = this._findNodeUnderMouse(evt);
                        if (evt.which === 3 && this.diagram.selectionList[0] && (this.diagram.selectionList[0].type === "pseudoGroup" || this.diagram.selectionList[0]._type === "group") && this._hasMultipleSelection(mNode))
                            isMulSelect = false;
                        if (ej.datavisualization.Diagram.Util.canDoSingleSelection(this.diagram) && this._isMouseDown) {
                            if (isMulSelect)
                                this.selectedObject = mNode;
                            else
                                this.selectedObject = this.diagram.selectionList[0];
                        }
                        clickedObject = this.selectedObject;
                    }
                    var selectedObject = this.diagram.selectionList.length > 0 ? this.diagram.selectionList[0] : null;
                    if (this.selectedObject && !this.diagram._selectionContains(this.selectedObject))
                        this.diagram._clearSelection(true);
                }
                else {
                    clickedObject = this._findNodeUnderMouse(evt);
                }
            }
            if (!endAction && this.selectedObject) {
                if (this.selectedObject && this.selectedObject.type != "pseudoGroup") {
                    if (!skip) {
                        var obj1 = this._findNodeUnderMouse(evt, true);
                        var tempVal = this.selectedObject;
                        var args = this._raiseEvent("itemClick", { element: this.selectedObject, actualObject: this.actualObject, selectedObject: obj1, model: this.diagram.model, cancel: false, event: evt });
                        this._itemClick(this.selectedObject, this.actualObject, obj1, selectedObject);
                        if (args.cancel)
                            this.selectedObject = tempVal;
                    }
                }
                if (this.selectedObject) {
                    this._allowPan(this.selectedObject, "mouseup", evt);
                    if (!this.selectedObject.isPhase)
                        this._updateSelection();
                    this._enableLabel(this.selectedObject, this.activeLabel);
                    if (this.selectedObject && this.selectedObject.parent === "") {
                        if (!this.selectedObject.isSwimlane)
                            ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                        else {
                            ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this.diagram);
                            ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                            ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this.diagram, this.selectedObject);
                        }
                        var selectObj = this.selectedObject;
                        if (this.diagram._isDragg && !this.diagram._selectionContains(selectObj)) {
                            this.diagram._clearSelection();
                            if (!selectObj.isPhase)
                                this.diagram._addSelection(selectObj);
                        }
                    }
                }
                if (clickedObject && !skip) {
                    //raise click event
                    var mousePosition = this.diagram._mousePosition(evt.originalEvent);
                    this._raiseEvent("click", { element: this.diagram.getNode(clickedObject), actualObject: this.diagram.getNode(this.actualObject), count: this.diagram._getEventDetail(evt), offsetX: mousePosition.x, offsetY: mousePosition.y, event: evt });
                }
            }
            this._multipleUndo = false;
            delete this.diffx;
            delete this.diffy;
            delete this._isMouseDown;
            delete this.actualObject;
            delete this._swimlaneNodedragged;
            this.diagram._removeTooltip();
            if (!this.diagram._isEditing && !this.diagram._isDragg)
                this.diagram._endEdit();
            delete this.hoverNode;

            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            this.diagram._activeSwimLane = null;
            base.prototype.mouseup.call(this, evt);
        };
        MoveTool.prototype._updateObject = function () {
            if (this.selectedObject) {
                if (this.selectedObject.type == "pseudoGroup") {
                    var child;
                    var children = this.diagram._getChildren(this.selectedObject.children);
                    for (var i = 0, len = children.length; i < len; i++) {
                        child = this.diagram.nameTable[children[i]];
                        if (child) {
                            ej.datavisualization.Diagram.DiagramContext.update(child, this.diagram);
                        }
                    }
                }
                else {
                    if (this.selectedObject.parent) {
                        ej.datavisualization.Diagram.Util._updateGroupBounds(this.diagram.nameTable[this.selectedObject.parent], this.diagram);
                    }
                    if (!this.selectedObject.isSwimlane)
                        ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                    else {
                        ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this.diagram);
                        ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                        ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this.diagram, this.selectedObject);
                    }
                }
            }
        };
        MoveTool.prototype._endAction = function () {
            base.prototype._endAction.apply(this);
            this._isMouseDown = false;
            this._mouseOffset = ej.datavisualization.Diagram.Size(0, 0);
        };
        MoveTool.prototype._updateHelperXY = function (shape, startPoint, endPoint) {
            var towardsLeft = endPoint.x < startPoint.x;
            var towardsTop = endPoint.y < startPoint.y;
            var difx = this.diffx + (endPoint.x - startPoint.x);
            var dify = this.diffy + (endPoint.y - startPoint.y);
            var offset;
            if (((this.diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.SnapToHorizontalLines) ||
                (this.diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.SnapToVerticalLines)) &&
                this.diagram._enableSnapToObject())
                offset = ej.datavisualization.Diagram.SnapUtil._snapPoint(this.diagram, this.helper, towardsLeft, towardsTop, ej.datavisualization.Diagram.Point(difx, dify),
                    endPoint, startPoint);
            if (!offset)
                offset = ej.datavisualization.Diagram.Point(difx, dify);
            this.diffx = difx - offset.x;
            this.diffy = dify - offset.y;
            if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(offset)) {
                var oldbounds = ej.datavisualization.Diagram.Util.bounds(shape);
                oldbounds = ej.datavisualization.Diagram.Rectangle(oldbounds.left, oldbounds.top, oldbounds.right - oldbounds.left, oldbounds.bottom - oldbounds.top);
                var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: shape.offsetX, offsetY: shape.offsetY, width: shape.width, height: shape.height };
                if (this._outOfBoundsDrag(shape, offset.x, offset.y))
                    this.diagram._translate(shape, offset.x, offset.y, this.diagram.nameTable);
                var newbounds = ej.datavisualization.Diagram.Util.bounds(shape);
                newbounds = ej.datavisualization.Diagram.Rectangle(newbounds.left, newbounds.top, newbounds.right - newbounds.left, newbounds.bottom - newbounds.top);
                var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: shape.offsetX, offsetY: shape.offsetY, width: shape.width, height: shape.height };
                var args = this._raiseDragEvent({ element: this.diagram.getNode(this.helper), offset: offset, oldValue: oldValue, newValue: newValue, cancel: false });
                if (args && !args.cancel) {
                    if (!this.inAction)
                        if (shape._type === "group") {
                            ej.datavisualization.Diagram.Util._updateGroupBounds(shape, this.diagram);
                        }
                }
                else { this.diagram._translate(shape, -offset.x, -offset.y, this.diagram.nameTable); }
            }
        };


        MoveTool.prototype._outOfBoundsDrag = function (node, ptX, ptY, orientation) {
            ptX = ptX ? ptX : 0;
            ptY = ptY ? ptY : 0;
            if (node && ej.datavisualization.Diagram.Util.canMoveOutofBoundary(this.diagram)) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                var size = this._getPageBounds();
                if (orientation) {
                    ptX = (orientation === "horizontal") ? 0 : ptX;
                    ptY = (orientation === "vertical") ? 0 : ptY;
                }
                if (bounds) {
                    var padding = this._getPadding(node);
                    if (node.isPhase)
                        return true;
                    if ((!this.diagram._selectedSymbol || this._skipSelectedSymbol) && (bounds.right + ptX + padding.x > size.width || bounds.left + ptX - padding.x < size.x)) {
                        this.updateCursor("not-allowed");
                        return false
                    }
                    if ((!this.diagram._selectedSymbol || this._skipSelectedSymbol) && (bounds.bottom + ptY + padding.y > size.height || bounds.top + ptY - padding.y < size.y)) {
                        this.updateCursor("not-allowed");
                        return false
                    }
                }
            }
            if (!this.diagram._notAllow)
                this.updateCursor("move");
            return true
        };

        MoveTool.prototype._updateXY = function (shape, startPoint, endPoint, preventSegmentAdjusting) {
            var towardsLeft = endPoint.x < startPoint.x;
            var towardsTop = endPoint.y < startPoint.y;
            var difx = this.diffx + (endPoint.x - startPoint.x);
            var dify = this.diffy + (endPoint.y - startPoint.y);
            var offset;
            if (((this.diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.SnapToHorizontalLines) ||
                (this.diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.SnapToVerticalLines)) || this.diagram._enableSnapToObject())
                offset = ej.datavisualization.Diagram.SnapUtil._snapPoint(this.diagram, this.selectedObject, towardsLeft, towardsTop, ej.datavisualization.Diagram.Point(difx, dify),
                    endPoint, startPoint);

            if (!offset)
                offset = ej.datavisualization.Diagram.Point(difx, dify);

            this.diffx = difx - offset.x;
            this.diffy = dify - offset.y;
            if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(offset) || this.diagram._selectedSymbol && !this.inAction) {
                var args;
                var oldbounds = ej.datavisualization.Diagram.Util.bounds(shape);
                oldbounds = ej.datavisualization.Diagram.Rectangle(oldbounds.left, oldbounds.top, oldbounds.right - oldbounds.left, oldbounds.bottom - oldbounds.top);
                var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: shape.offsetX, offsetY: shape.offsetY, width: shape.width, height: shape.height };
                if (!shape.segments) {
                    if (ej.datavisualization.Diagram.Util.canAllowPan(shape)) {
                        if (this.diagram._hScrollOffset === 0) {
                            offset.x = 0;
                        }
                        if (this.diagram._vScrollOffset === 0) {
                            offset.y = 0;
                        }
                    }
                }
                if (preventSegmentAdjusting && !shape.isSwimlane && shape.type != "pseudoGroup")
                    this.diagram._preventDocking = true;
                if (this._outOfBoundsDrag(shape, offset.x, offset.y)) {
                    this.diagram._raiseOffsetPropertyChange(shape, offset.x, offset.y, true);
                    this.diagram._translate(shape, offset.x, offset.y, this.diagram.nameTable);
                    delete this.diagram._preventDocking;
                    var newbounds = ej.datavisualization.Diagram.Util.bounds(shape);
                    newbounds = ej.datavisualization.Diagram.Rectangle(newbounds.left, newbounds.top, newbounds.right - newbounds.left, newbounds.bottom - newbounds.top);
                    var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: shape.offsetX, offsetY: shape.offsetY, width: shape.width, height: shape.height };
                    if (!this.diagram._selectedSymbol) {
                        args = this._raiseDragEvent({ element: this.diagram.getNode(this.selectedObject), offset: offset, oldValue: oldValue, newValue: newValue, cancel: false });
                    }
                    else {
                        args = { element: this.diagram.getNode(this.selectedObject), allowDrop: true, target: this._getNodeUnderMouse(), oldValue: oldValue, newValue: newValue, cancel: false };
                        if (args.target && args.target.segments) {
                            ej.datavisualization.Diagram.SvgContext._drawConnectorHighlighter(args.target, this.diagram, this.diagram._currZoom);
                        }
                        this._raiseEvent("dragOver", args);
                        if (!args.allowDrop) {
                            this.updateCursor("not-allowed");
                            if (!this.inAction) { this.diagram._removeSymbolFromDiagram(); return true; }
                        }
                        else {
                            if (!this.diagram._notAllow)
                                this.updateCursor("move");
                        }
                    }
                    if ((args && !args.cancel) || this.diagram._selectedSymbol) {
                        if (shape._type === "group" && shape.type != "bpmn" || (shape.type === "pseudoGroup")) {
                            ej.datavisualization.Diagram.Util._updateGroupBounds(shape, this.diagram);
                        }
                    }
                    else if (args && args.cancel) {
                        this.diagram._translate(shape, -offset.x, -offset.y, this.diagram.nameTable);
                    }
                }
            }
        };

        MoveTool.prototype._updateLabelXY = function (label, startPoint, endPoint) {
            var difx = endPoint.x - startPoint.x;
            var dify = endPoint.y - startPoint.y;
            if (!this.selectedObject.segments) {
                var matrix = ej.Matrix.identity();
                ej.Matrix.rotate(matrix, -this.selectedObject.rotateAngle);
                var diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
            }
            this.diagram._translateLabel(this.selectedObject, label, difx, dify);
            var args = this._raiseDragEvent({ element: this.diagram.getNode(label), offset: label.offset, cancel: false });
            if (args && args.cancel)
                this.diagram._translateLabel(this.selectedObject, label, -difx, -dify);
        };

        MoveTool.prototype._raiseDragEvent = function (args) {
            if (!this.diagram._selectedSymbol && !this.diagram._isDragg) {
                args.dragState = this.dragState;
                return this._raiseEvent("drag", args);
            }
        };

        MoveTool.prototype._updateSelection = function () {
            if (!this.diagram._selectionContains(this.selectedObject)) {
                this.diagram._clearSelection(true);
                this.diagram._addSelection(this.selectedObject);
            }
        };
        MoveTool.prototype._disableLabel = function (selectedObject, label) {
            if (selectedObject && label) {
                var htmlLayer = this.diagram._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                var name = selectedObject._shape == "text" ? selectedObject.name : selectedObject.name + "_" + label.name;
                var text = $(htmlLayer).find("#" + name + ".ej-d-label")[0];
                if (text) text.style.pointerEvents = "none";
            }
        };
        MoveTool.prototype._enableLabel = function (selectedObject, label) {
            if (selectedObject && label) {
                var htmlLayer = this.diagram._svg.document.parentNode.getElementsByClassName("htmlLayer")[0];
                var name = selectedObject._shape == "text" ? selectedObject.name : selectedObject.name + "_" + label.name;
                var text = $(htmlLayer).find("#" + name + ".ej-d-label")[0];
                if (text) text.style.pointerEvents = "all";
            }
        };
        return MoveTool;
    })(ToolBase);

    ej.datavisualization.Diagram.MoveTool = MoveTool;
    //#endregion

    //#region ResizeTool
    var ResizeTool = (function (base) {
        ej.datavisualization.Diagram.extend(ResizeTool, base);
        function ResizeTool(diagram) {
            base.call(this, "resize", diagram);
            this.cursor = "default";//update resize cursor during action i.e in action
            this._resizeDirection = null;
            this._mouseOffset = ej.datavisualization.Diagram.Size(0, 0);
            this.diffx = 0;
            this.diffy = 0;
            this._startPoint = ej.datavisualization.Diagram.Size(0, 0);
            this.undoObject = null;
            this.pseudoGroupConstraints = null;
            this._mouseDown = false;
            this.resizeState = "";
        }

        ResizeTool.prototype.mousedown = function (evt) {
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            base.prototype.mousedown.call(this, evt);
            this._mouseDown = true;
            this.resizeState = ej.datavisualization.Diagram.ResizeState.Starting;
        };
        ResizeTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            var start = !this.inAction;
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);

            if (!this.inAction && this.diagram.selectionList[0] && this._mouseDown) {
                this.selectedObject = this.diagram.nameTable[this.diagram.selectionList[0].name];
                var data;
                var childTable = {};
                var newbounds, oldbounds;
                newbounds = oldbounds = ej.datavisualization.Diagram.Util.bounds(this.selectedObject);
                var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: this.selectedObject.offsetX, offsetY: this.selectedObject.offsetY, width: this.selectedObject.width, height: this.selectedObject.height };
                var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: this.selectedObject.offsetX, offsetY: this.selectedObject.offsetY, width: this.selectedObject.width, height: this.selectedObject.height };
                this._raiseEvent("sizeChange", { element: this.diagram.getNode(this.selectedObject), resizeState: this.resizeState, offset: { x: 0, y: 0 }, oldValue: oldValue, newValue: newValue, cancel: false, direction: this._resizeDirection });
                if (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup")
                    childTable = this.diagram._getChildTable(this.selectedObject, childTable);
                var temp = { "childTable": childTable, "node": this.selectedObject };
                if (this.selectedObject && this.selectedObject.type === "pseudoGroup") {
                    if (this.diagram.model.selectedItems.getConstraints && $.isFunction(this.diagram.model.selectedItems.getConstraints)) {
                        this.pseudoGroupConstraints = this.diagram.model.selectedItems.getConstraints();
                    }
                    else this.pseudoGroupConstraints = ej.datavisualization.Diagram.Util._getPseudoGroupConstraints(this.diagram, this.selectedObject, this.selectedObject);
                }
                data = $.extend(true, {}, temp);
                this.undoObject = jQuery.extend(true, {}, data);
                //this.undoObject = ej.datavisualization.Diagram.Util.clone(this.selectedObject);
                this._resizeDirection = evt.target.getAttribute("class");
                if (!this.selectedObject.width) this.selectedObject.width = this.selectedObject._width;
                if (!this.selectedObject.height) this.selectedObject.height = this.selectedObject._height;
                this.initialBounds = { width: this.selectedObject.width, height: this.selectedObject.height, y: this.selectedObject.offsetY, x: this.selectedObject.offsetX };
                ej.datavisualization.Diagram.SvgContext._removePivotPoint(this.selectedObject, this.diagram._svg, this.diagram._currZoom);
                this.inAction = true;
            }
            if (this.selectedObject) {
                this.resizeState = ej.datavisualization.Diagram.DragState.Resizing;
                var canvasChild = false;
                if (this.selectedObject && this.selectedObject.parent) {
                    var parNode = this.diagram.nameTable[this.selectedObject.parent];
                    if (parNode.container && (parNode.container.type == "canvas" || parNode.container.type == "stack"))
                        canvasChild = true;
                }
                else if (this.selectedObject.type == "pseudoGroup" && this.hasSameParent() && this._fromContainer(this.diagram._getChildren(this.selectedObject.children))) {
                    canvasChild = true;
                }
                if ((this.selectedObject && canvasChild) || (this.selectedObject.type === "pseudoGroup" && this._anyFromContainer(this.diagram._getChildren(this.selectedObject.children)))) {
                    if (this.selectedObject.type === "pseudoGroup" && this._isParentAsLane(this.selectedObject)) {
                        ej.datavisualization.Diagram.canvasHelper._removeFromParentContainer(this.diagram, this.selectedObject);
                    }
                    else ej.datavisualization.Diagram.canvasHelper._updateResizeHelper(this.diagram);
                }
                else if (this.selectedObject && this.diagram.nameTable[this.selectedObject.name].container) {
                    ej.datavisualization.Diagram.canvasHelper._updateResizeHelper(this.diagram);
                }
                else if (this.selectedObject.parent && this.diagram.nameTable[this.selectedObject.parent] &&
                    this.diagram.nameTable[this.selectedObject.parent].container && this.diagram.nameTable[this.selectedObject.parent].container.type == "stack") {
                    if (!this.helper) {
                        this.helper = this._getCloneNode(this.selectedObject);
                    }
                    ej.datavisualization.Diagram.SvgContext._drawContainerHelper(this.diagram);
                    this._startPoint = this.currentPoint;
                    this._updateSize(this.helper, this.previousPoint, this.currentPoint);
                    ej.datavisualization.Diagram.DiagramContext.update(this.helper, this.diagram);
                }
                else {
                    if (this.selectedObject.type != "pseudoGroup")
                        this._updateSize(this.selectedObject, this.previousPoint, this.currentPoint);
                    else if (this.selectedObject.type == "pseudoGroup" && !this._fromContainer(this.diagram._getChildren(this.selectedObject.children)) && this._fromSameContainer(this.diagram._getChildren(this.selectedObject.children))) {
                        if (!this._undoObject)
                            ej.datavisualization.Diagram.Util._getUndoObject(this.diagram, this.selectedObject);
                        this._updateSize(this.selectedObject, this.previousPoint, this.currentPoint);
                    }
                }
                if (!this.helper) {
                    if (!this.selectedObject.isSwimlane)
                        ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                    else {
                        if (!this._isMouseDown) {
                            ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(this.diagram);
                            ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                            ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(this.diagram, this.selectedObject);
                        }
                    }
                }
                this.diagram._renderTooltip(this.selectedObject, start);
                this.diagram._updateSelectionHandle(true);
            }

            this.previousPoint = this.currentPoint;
        };
        ResizeTool.prototype.mouseup = function (evt) {
            var undoObj = null;
            this._mouseDown = false;
            if (this.inAction) {
                this.resizeState = ej.datavisualization.Diagram.ResizeState.Completed;
                ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
                this.inAction = false;
                var canvasChild = false;
                var newbounds, oldbounds;
                oldbounds = ej.datavisualization.Diagram.Util.bounds(this.undoObject.node);
                var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: this.undoObject.node.offsetX, offsetY: this.undoObject.node.offsetY, width: this.undoObject.node.width, height: this.undoObject.node.height };
                if (this.selectedObject.parent) {
                    var parent = this.diagram.nameTable[this.selectedObject.parent];
                    if (parent && parent.container)
                        newbounds = ej.datavisualization.Diagram.Util.bounds(this.helper);
                }
                else {
                    newbounds = ej.datavisualization.Diagram.Util.bounds(this.selectedObject);
                }
                var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: newbounds.x + (newbounds.width) / 2, offsetY: newbounds.y + (newbounds.height) / 2, width: newbounds.width, height: newbounds.height };
                this._raiseEvent("sizeChange", { element: this.diagram.getNode(this.selectedObject), resizeState: this.resizeState, offset: { x: 0, y: 0 }, oldValue: oldValue, newValue: newValue, cancel: false, direction: this._resizeDirection });
                this.resizeState = "";
                if (this.selectedObject.isLane || this.selectedObject.isSwimlane) {
                    var childTable = {};
                    childTable = this.diagram._getChildTable(this.selectedObject, childTable);
                    undoObj = $.extend(true, {}, { "childTable": childTable, "node": this.selectedObject });
                }
                if (this.selectedObject && this.selectedObject.parent) {
                    var parNode = this.diagram.nameTable[this.selectedObject.parent];
                    if (parNode.container && (parNode.container.type == "canvas" || parNode.container.type == "stack"))
                        canvasChild = true;
                }
                else if (this.selectedObject.type == "pseudoGroup" && this.hasSameParent() && this._fromContainer(this.diagram._getChildren(this.selectedObject.children))) {
                    canvasChild = true;
                }
                if (this.selectedObject && canvasChild && !parNode.isLaneStack) {
                    ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                    if (ej.datavisualization.Diagram.canvasHelper._outOfBoundaryNodeDrop(this.diagram, this.diagram.activeTool.helper, parNode)) {
                        if (!this.selectedObject.container)
                            ej.datavisualization.Diagram.canvasHelper._singleNodeResize(this.diagram, evt, this.selectedObject);
                        else
                            ej.datavisualization.Diagram.canvasHelper._resizeLane(this.diagram, this.selectedObject);
                        ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
                    }
                }
                else if (this.selectedObject && this.diagram.nameTable[this.selectedObject.name].container) {
                    ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                    ej.datavisualization.Diagram.canvasHelper._resizeLane(this.diagram, this.selectedObject);

                }
                else if ((this.selectedObject.type == "pseudoGroup" || this.selectedObject.name == "multipleSelection") && this.diagram._activeSwimLane) {
                    ej.datavisualization.Diagram.canvasHelper._multiNodeResize(this.diagram, evt, this.selectedObject);
                }
                if (this.selectedObject.parent) {
                    ej.datavisualization.Diagram.Util._updateGroupBounds(this.diagram.nameTable[this.selectedObject.parent], this.diagram);
                }
                ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                this.diagram._updateSelectionHandle();

                var data;
                var childTable = {};
                if (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup")
                    childTable = this.diagram._getChildTable(this.selectedObject, childTable);
                var temp = { "childTable": childTable, "node": this.selectedObject };
                data = $.extend(true, {}, temp);

                var entry = { type: "sizechanged", undoObject: undoObj ? undoObj : this.undoObject, redoObject: jQuery.extend(true, {}, data), isMultipleNode: (this.selectedObject._type === "group") ? true : false, category: "internal" };
                if (!this._multipleUndo)
                    this.diagram.addHistoryEntry(entry);
                this.diagram._removeTooltip();
                this._multipleUndo = false;
            }
            base.prototype.mouseup.call(this, evt);
        };
        ResizeTool.prototype._updateSize = function (shape, startPoint, endPoint, x1, y1, updateMinMax, isHelper, phase, disableSnap) {
            var deltaWidth, deltaHeight, diff;
            var matrix = ej.Matrix.identity();
            ej.Matrix.rotate(matrix, -shape.rotateAngle);
            var horizontalsnap = { snapped: false, offset: 0, left: false, right: false };
            var verticalsnap = { snapped: false, offset: 0, top: false, bottom: false };
            var difx = x1 ? x1 : (this.currentPoint.x - this.startPoint.x);
            var dify = y1 ? y1 : (this.currentPoint.y - this.startPoint.y);
            var pivot = ej.datavisualization.Diagram.Point(0, 0);
            var trans = ej.Matrix.identity();
            var x = shape.offsetX;
            var y = shape.offsetY;
            ej.Matrix.rotate(trans, shape.rotateAngle, x, y);
            var w = shape.width;
            var h = shape.height;
            x = x - w * shape.pivot.x;
            y = y - h * shape.pivot.y;
            switch (this._resizeDirection) {
                case "n-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x + w / 2, y + h));
                    var deltaWidth = 1;
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify));
                    difx = diff.x; dify = diff.y;
                    dify = this._snapTop(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    deltaHeight = (this.initialBounds.height - dify) / shape.height;
                    break;
                case "e-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x, y + h / 2));
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
                    difx = this._snapRight(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint, disableSnap);
                    dify = 0;
                    deltaWidth = (this.initialBounds.width + difx) / shape.width;
                    deltaHeight = 1;
                    break;
                case "w-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x + w, y + h / 2));
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
                    difx = this._snapLeft(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    dify = 0;
                    deltaWidth = (this.initialBounds.width - difx) / shape.width;
                    deltaHeight = 1;
                    break;
                case "s-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x + w / 2, y));
                    deltaWidth = 1;
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify));
                    difx = diff.x; dify = diff.y;
                    dify = this._snapBottom(horizontalsnap, verticalsnap, diff.x, diff.y, shape, (endPoint && startPoint && endPoint == startPoint) ? true : false);
                    deltaHeight = (this.initialBounds.height + dify) / shape.height;
                    break;
                case "ne-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x, y + h));
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
                    difx = this._snapRight(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint, disableSnap);
                    dify = this._snapTop(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    deltaWidth = (this.initialBounds.width + difx) / shape.width;
                    deltaHeight = (this.initialBounds.height - dify) / shape.height;
                    break;
                case "nw-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x + w, y + h));
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
                    dify = this._snapTop(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    difx = this._snapLeft(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    deltaWidth = (this.initialBounds.width - difx) / shape.width;
                    deltaHeight = (this.initialBounds.height - dify) / shape.height;
                    break;
                case "se-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x, y));
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
                    dify = this._snapBottom(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint, disableSnap);
                    difx = phase ? difx : this._snapRight(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    deltaWidth = (this.initialBounds.width + difx) / shape.width;
                    deltaHeight = (this.initialBounds.height + dify) / shape.height;
                    break;
                case "sw-resize":
                    pivot = ej.Matrix.transform(trans, ej.datavisualization.Diagram.Point(x + w, y));
                    diff = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(difx, dify)); difx = diff.x; dify = diff.y;
                    dify = this._snapBottom(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint, disableSnap);
                    difx = this._snapLeft(horizontalsnap, verticalsnap, difx, dify, shape, endPoint == startPoint);
                    deltaWidth = (this.initialBounds.width - difx) / shape.width;
                    deltaHeight = (this.initialBounds.height + dify) / shape.height;
                    break;
            }
            if (shape)
                if (!this.pseudoGroupConstraints) {
                    this.pseudoGroupConstraints = shape.constraints;
                }
            if (this.pseudoGroupConstraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio) {
                if (this._resizeDirection == "n-resize" || this._resizeDirection == "s-resize" || this._resizeDirection == "w-resize" || this._resizeDirection == "e-resize") {
                    var rotatedDif = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(startPoint.x - endPoint.x, startPoint.y - endPoint.y));
                    if (Math.abs(rotatedDif.x) > Math.abs(rotatedDif.y))
                        deltaHeight = deltaWidth;
                    else
                        deltaWidth = deltaHeight;
                }
                else if (startPoint != endPoint)
                    deltaHeight = deltaWidth = Math.max(deltaHeight, deltaWidth);
                else
                    deltaHeight = deltaWidth = 0;
            }
            var size = ej.datavisualization.Diagram.Size();
            if (deltaWidth < 0) deltaWidth = 1;
            if (deltaHeight < 0) deltaHeight = 1;
            size.width = deltaWidth;
            size.height = deltaHeight;
            var oldbounds = ej.datavisualization.Diagram.Util.bounds(shape);
            oldbounds = ej.datavisualization.Diagram.Rectangle(oldbounds.left, oldbounds.top, oldbounds.right - oldbounds.left, oldbounds.bottom - oldbounds.top);
            var oldValue = { bounds: { x: oldbounds.x, y: oldbounds.y, width: oldbounds.width, height: oldbounds.height }, offsetX: shape.offsetX, offsetY: shape.offsetY, width: shape.width, height: shape.height };
            if (!ej.datavisualization.Diagram.Geometry.isEmptySize(size)) {
                this.resizeState = ej.datavisualization.Diagram.ResizeState.Resizing;
                if (this._outOfBoundsDrag(shape, deltaWidth, deltaHeight, pivot)) {
                    this.diagram._raiseSizePropertyChange(shape, deltaWidth, deltaHeight, true);
                    this.diagram.scale(shape, deltaWidth, deltaHeight, pivot, this.diagram.nameTable, null, updateMinMax, isHelper);
                    var newbounds = ej.datavisualization.Diagram.Util.bounds(shape);
                    newbounds = ej.datavisualization.Diagram.Rectangle(newbounds.left, newbounds.top, newbounds.right - newbounds.left, newbounds.bottom - newbounds.top);
                    var newValue = { bounds: { x: newbounds.x, y: newbounds.y, width: newbounds.width, height: newbounds.height }, offsetX: shape.offsetX, offsetY: shape.offsetY, width: shape.width, height: shape.height };
                    var pathData = shape.pathData;
                    if (oldbounds.width != newbounds.width || oldbounds.height != newbounds.height) {
                        var args = this._raiseEvent("sizeChange", { element: this.diagram.getNode(this.selectedObject), resizeState: this.resizeState, offset: size, oldValue: oldValue, newValue: newValue, direction: this._resizeDirection });
                    }
                    if (pathData && shape.pathData != pathData) {
                        shape._absoluteBounds = null;
                        shape._scaled = true;
                    }
                    if (args && args.cancel && !isHelper) {
                        this.diagram.scale(shape, 1 / deltaWidth, 1 / deltaHeight, pivot, this.diagram.nameTable);
                    }
                    if (shape._type === "group") {
                        ej.datavisualization.Diagram.Util._updateGroupBounds(shape, this.diagram);
                    }
                    this.diagram._updateAssociatedConnectorEnds(shape, this.diagram.nameTable);
                }
                else return true;
            }
            this.pseudoGroupConstraints = null;
        };
        ResizeTool.prototype._getSwimLaneNode = function (node) {
            if (node) {
                var laneStackName = node.parent;
                var laneStack = this.diagram.nameTable[laneStackName];
                if (laneStack) {
                    var swimlaneName = laneStack.parent;
                    if (swimlaneName) {
                        var swimlane = this.diagram.nameTable[swimlaneName];
                        if (swimlane)
                            return swimlane;
                    }
                }
            }
        };
        ResizeTool.prototype._outOfBoundsDrag = function (node, delWidth, delHeight, pivot) {
            if (!this.diagram._skipoutOfBounds && node && ej.datavisualization.Diagram.Util.canMoveOutofBoundary(this.diagram)) {
                var size = this._getPageBounds();
                var incY = (node.height * delHeight) - node.height;
                var incX = (node.width * delWidth) - node.width;
                if (!this.inAction && node.isLane) {
                    var getSwimlane = this._getSwimLaneNode(node);
                    var bounds = ej.datavisualization.Diagram.Util.bounds(getSwimlane);
                    var padding = this._getPadding(node);

                    if (!this.diagram._selectedSymbol && (bounds.right + incX + padding.x > size.width)) {
                        this.updateCursor("not-allowed");
                        return false
                    }
                    if (!this.diagram._selectedSymbol && (bounds.bottom + incY + padding.y > size.height)) {
                        this.updateCursor("not-allowed");
                        return false
                    }
                }
                else {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(node);
                    var padding = this._getPadding(node);
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, -node.rotateAngle, pivot.x, pivot.y);
                    ej.Matrix.scale(matrix, delWidth, delHeight, pivot.x, pivot.y);
                    ej.Matrix.rotate(matrix, node.rotateAngle, pivot.x, pivot.y);
                    var newPosition = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY));
                    if (!this.diagram._selectedSymbol && (newPosition.x + (bounds.width + incX) / 2 + padding.x > size.width || newPosition.x - (bounds.width + incX) / 2 < size.x)) {
                        this.updateCursor("not-allowed");
                        return false
                    }
                    if (!this.diagram._selectedSymbol && (newPosition.y + (bounds.height + incY) / 2 + padding.y > size.height || newPosition.y - (bounds.height + incY) / 2 < size.y)) {
                        this.updateCursor("not-allowed");
                        return false
                    }
                }
                this.updateCursor(this._resizeDirection)
            }
            return true
        };
        return ResizeTool;
    })(ToolBase);

    ej.datavisualization.Diagram.ResizeTool = ResizeTool;
    //#endregion

    //#region EndPointTool
    var ConnectionEditTool = (function (base) {
        ej.datavisualization.Diagram.extend(ConnectionEditTool, base);
        function ConnectionEditTool(diagram) {
            base.call(this, "endPoint", diagram);
            this.cursor = "move";
            this._endPoint = null;
            this._undoObject = null;
        }
        ConnectionEditTool.prototype.mousedown = function (evt) {
            if (!this.inAction) {
                base.prototype.mousedown.call(this, evt);
                if (evt.ctrlKey && evt.shiftKey) {
                    var parent = $(evt.target).parents(".ej-d-connector");
                    if (parent.length > 0) {
                        this.selectedObject = this.diagram.nameTable[parent[0].id];
                        if (this.diagram._hasSelection())
                            this.diagram._clearSelection(true);
                        this.diagram._addSelection(this.selectedObject);
                    }
                }
                this._initialValue = null;
                if (this.diagram.selectionList[0] && !this.selectedObject) this.selectedObject = this.diagram.nameTable[this.diagram.selectionList[0].name];
                this.undoObject = this._getClonedObject(this.selectedObject);
                this._endPoint = evt.target.getAttribute("class");
                this.targetid = evt.target.id;
                this._selectedSegment = "";
                this._nearestNodes = [];
                var isTarget = (this._endPoint == "targetEndPoint") ? true : false;
                var isSource = (this._endPoint == "sourceEndPoint") ? true : false;
                var dragargs = this._raiseEndPointDrag(this.selectedObject, isTarget, isSource, ej.datavisualization.Diagram.DragState.Starting);
            }
        };
        ConnectionEditTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            var start = !this.inAction;
            if (this.selectedObject && !(evt.ctrlKey && evt.shiftKey)) {
                //  if (ej.datavisualization.Diagram.Util.canMove(this.selectedObject)) {
                var isTwo = false;
                if (this.selectedObject.segments.length == 2) isTwo = true;
                var difx = this.currentPoint.x - this.previousPoint.x;
                var dify = this.currentPoint.y - this.previousPoint.y;
                var _srcPoint = $.extend(true, {}, this.selectedObject.sourcePoint);
                var _trgPoint = $.extend(true, {}, this.selectedObject.targetPoint);
                var _segments = $.extend(true, {}, this.selectedObject.segments);
                if (this._outOfBoundsDrag(this.selectedObject, this.currentPoint.x, this.currentPoint.y)) {
                    if (!this.inAction && (this.startPoint.x != this.currentPoint.x || this.startPoint.y != this.currentPoint.y)) {
                        this.inAction = true;
                        if (this.selectedObject.segments.length > 0) {
                            for (var m = 0; m < this.selectedObject.segments.length; m++) {
                                this.selectedObject.segments[m]._bridges = [];
                            }
                        }
                        var hitTest = (this.diagram._svg.getElementById(this.selectedObject.name + "_hitTest"));
                        if (hitTest) hitTest.setAttribute("pointer-events", "none");
                        var sNode = this.diagram._svg.getElementById(this.selectedObject.name);
                        if (sNode) sNode.setAttribute("pointer-events", "none");
                        var handle = this.diagram._adornerSvg.getElementById(this.diagram._adornerSvg.document.id + "handle_g");
                        if (handle) handle.setAttribute("pointer-events", "none");
                        var coll = this.targetid.split("_");
                        coll.reverse();
                        var index = Number(coll[0]);
                        this.selectedSegment = this.selectedObject.segments[index];
                        var segment = this.selectedSegment;
                        if (this.selectedSegment && this.selectedSegment.type == "orthogonal") {
                            var refresh = false;
                            if (index === 0) {
                                var editfirstsegment = true;
                            }
                            if (!this.selectedSegment.length || !this.selectedSegment.direction) {
                                this._addTerminalSegment(difx, dify, coll);
                                refresh = true;
                            }
                            else if (index == 0) {
                                this.insertFirstSegment(difx, dify, coll);
                                refresh = true;
                            }
                            else {
                                this.nextSegment = this.selectedObject.segments[index + 1];
                            }
                        }
                        else
                            this.nextSegment = this.selectedObject.segments[index + 1];
                        if (refresh) {
                            ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, !(isTwo || editfirstsegment || !this.selectedObject.sourcePort), !(isTwo || !(segment.length || segment.length === 0) || !this.selectedObject.targetPort), this.diagram);
                            ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);
                            ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
                        }
                        if (!this.selectedSegment && this._endPoint == "targetEndPoint") this.selectedSegment = this.selectedObject.segments[this.selectedObject.segments.length - 1];
                        if (!this.selectedSegment && this._endPoint == "sourceEndPoint") {
                            this.selectedSegment = this.selectedObject.segments[0];
                            this.nextSegment = this.selectedObject.segments[1];
                        }
                        if (this.selectedSegment)
                            this._initialValue = { x: this.selectedSegment._endPoint.x, y: this.selectedSegment._endPoint.y };
                        this.diagram._updateSelectionHandle(true);
                        this._raiseSegmentEditEvent(ej.datavisualization.Diagram.DragState.Starting);
                    }
                    else if (this.inAction) {
                        if (this.selectedSegment && this._endPoint == "segmentEnd") {
                            var args = this._raiseSegmentEditEvent(ej.datavisualization.Diagram.DragState.Dragging);
                            if (!args.cancel && (difx != 0 || dify != 0)) {
                                var actualdifX = this.currentPoint.x - this.startPoint.x;
                                var actualdifY = this.currentPoint.y - this.startPoint.y;
                                if (this._initialValue) {
                                    actualdifX = this._initialValue.x + actualdifX - this.selectedSegment._endPoint.x;
                                    actualdifY = this._initialValue.y + actualdifY - this.selectedSegment._endPoint.y;
                                }
                                if (difx * actualdifX < 0) difx = 0; else difx = actualdifX;
                                if (dify * actualdifY < 0) dify = 0; else dify = actualdifY;
                                this._updateAdjacentSegments(difx, dify);
                            }
                        }
                        else if (this._endPoint != "segmentEnd") {
                            if (this._endPoint == "targetEndPoint" || this._endPoint == "sourceEndPoint")
                                this._checkConnectionPossible(evt);
                            var cancelEvent = this._updatePoints(this.selectedObject, ej.datavisualization.Diagram.DragState.Dragging);
                            if (!cancelEvent.cancel) {
                                this._disconnect(this.selectedObject);
                                this._updateConnection(this.selectedObject, cancelEvent.updateSelection);
                            }
                        }
                        this.diagram._updateSelectionHandle(true);
                        this.diagram._updateQuad(this.selectedObject);
                        ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                        //}
                    }
                }
                this.diagram._comparePropertyValues(this.selectedObject, "sourcePoint", { sourcePoint: _srcPoint }, true);
                this.diagram._comparePropertyValues(this.selectedObject, "targetPoint", { targetPoint: _trgPoint }, true);
                this.diagram._comparePropertyValues(this.selectedObject, "segments", { segments: _segments }, true);
            }
            this.previousPoint = this.currentPoint;
        };
        ConnectionEditTool.prototype._raiseSegmentEditEvent = function (state) {
            return this._raiseEvent("segmentChange", { element: this.selectedObject, dragState: state, point: this.currentPoint, cancel: false });
        };
        ConnectionEditTool.prototype._updateAdjacentSegments = function (difx, dify) {
            var current = this.selectedSegment;
            var pt = { x: difx + current._endPoint.x, y: dify + current._endPoint.y };
            pt = this.snap(pt);
            if (current.type == "orthogonal") {
                if (current._direction == "left" || current._direction == "right") {
                    dify = pt.y - current._endPoint.y;
                    current._startPoint.y += dify;
                    current._endPoint.y = current._startPoint.y;
                }
                else {
                    difx = pt.x - current._endPoint.x;
                    current._startPoint.x += difx;
                    current._endPoint.x = current._startPoint.x;
                }
                current.points[0] = current._startPoint;
                current.points[current.points.length - 1] = current._endPoint;
                var index = this.selectedObject.segments.indexOf(this.selectedSegment);
                var prev = this.selectedObject.segments[index - 1];
                if (prev) this.updatePreviousSegment(current, prev, difx, dify);
            }
            else if (current.type == "straight") {
                current.points[current.points.length - 1] = current._endPoint = pt;
                current._point = current.point = pt;
            }
            else {
                current.points[current.points.length - 1] = current._endPoint = pt;
                current._point = current.point = pt;
                ej.datavisualization.Diagram.Util._updateBezierPoints(current);
            }
            if (this.nextSegment)
                this.updateNextSegment(current, this.nextSegment, difx, dify);
        }
        ConnectionEditTool.prototype._addTerminalSegment = function (difx, dify, coll) {
            var segment = this.selectedSegment;
            this.selectedObject.segments.pop();
            var first = this.selectedObject.segments[this.selectedObject.segments.length - 1] && this.selectedObject.segments[this.selectedObject.segments.length - 1].type == "orthogonal" ? this.selectedObject.segments[this.selectedObject.segments.length - 1] : null;
            for (var i = 0; i < segment.points.length - 2; i++) {
                var seg = ej.datavisualization.Diagram.Segment({
                    type: "orthogonal",
                    length: ej.datavisualization.Diagram.Geometry.distance(segment.points[i], segment.points[i + 1]),
                    direction: ej.datavisualization.Diagram.Util._getBezierDirection(segment.points[i], segment.points[i + 1])
                });
                if (seg.length == 0) {
                    if (first.direction == "top" || first.direction == "bottom") {
                        seg._direction = seg.direction = difx > 0 ? "right" : "left";
                    }
                    else {
                        seg._direction = seg.direction = dify > 0 ? "bottom" : "top";
                    }
                }
                first = seg;
                this.selectedObject.segments.push(seg);
            }
            var sec = Number(coll[1]);
            if (segment.points.length == 2 || sec == segment.points.length - 2) {
                if (first) {
                    first.length += 5;
                    first._length = first.length;
                }
                if (sec != 0) {
                    var length = ej.datavisualization.Diagram.Geometry.distance(segment.points[segment.points.length - 2], segment._endPoint);
                    var direction = ej.datavisualization.Diagram.Util._getBezierDirection(segment.points[segment.points.length - 2], segment._endPoint);
                    var newsegment = ej.datavisualization.Diagram.Segment({ type: "orthogonal", length: 2 * length / 3, direction: direction });
                    this.selectedObject.segments.push(newsegment);

                }
            }
            var lastseg = ej.datavisualization.Diagram.Segment({ type: "orthogonal" });
            this.selectedObject.segments.push(lastseg);
            var index = Number(coll[0]) + (Number(coll[1]) || 0);
            this.selectedSegment = this.selectedObject.segments[index];
            this.nextSegment = this.selectedObject.segments[index + 1];
            if (index == this.selectedObject.segments.length - 2) {
                if (Number(coll[0]) == 0) {
                    this.nextSegment._direction = ej.datavisualization.Diagram.Util._getBezierDirection(segment.points[segment.points.length - 2], segment._endPoint);;
                }
                else
                    this.nextSegment._direction = segment._direction;
            }
            else {
                lastseg._direction = ej.datavisualization.Diagram.Util._getBezierDirection(segment.points[segment.points.length - 2], segment._endPoint);;
            }
            if (index == 0) this.insertFirstSegment(difx, dify, coll);

        },
        ConnectionEditTool.prototype.insertFirstSegment = function (difx, dify, coll) {
            var segment = this.selectedSegment;
            if (this.selectedObject.sourcePort && segment.length && this.selectedObject.segments[0].points.length > 2) {
                this.selectedObject.segments.splice(0, 1);
                var segments = [];
                var prev;
                for (var i = 0; i < segment.points.length - 1; i++) {
                    var first = ej.datavisualization.Diagram.Segment({
                        type: "orthogonal",
                        length: ej.datavisualization.Diagram.Geometry.distance(segment.points[i], segment.points[i + 1]),
                        direction: ej.datavisualization.Diagram.Util._getBezierDirection(segment.points[i], segment.points[i + 1])
                    });
                    if (first.length == 0) {
                        if (prev && (prev.direction == "top" || prev.direction == "bottom")) {
                            first._direction = first.direction = difx > 0 ? "right" : "left";
                        }
                        else {
                            first._direction = first.direction = dify > 0 ? "bottom" : "top";
                        }
                    }
                    prev = first;
                    segments.push(first);
                }
                this.selectedObject.segments = segments.concat(this.selectedObject.segments);
                this.selectedSegment = this.selectedObject.segments[Number(coll[1])];
                this.nextSegment = this.selectedObject.segments[Number(coll[1]) + 1];
            }
            else {
                var segment = this.selectedObject.segments[0];
                var segments = [];
                segments.push(ej.datavisualization.Diagram.Segment({ type: "orthogonal", "direction": segment.direction, length: segment.length / 3 }));
                if (segment.direction == "bottom" || segment.direction == "top") {
                    var length = Math.max(5, Math.abs(difx));
                    var direction = difx > 0 ? "right" : "left";
                }
                else {
                    var length = Math.max(5, Math.abs(dify));
                    var direction = dify > 0 ? "bottom" : "top";
                }
                segments.push(ej.datavisualization.Diagram.Segment({ type: "orthogonal", "direction": direction, length: length }));
                var nextseg = this.selectedObject.segments[1];
                if (nextseg && nextseg.length) {
                    if (direction != nextseg.direction) {
                        length *= -1;
                    }
                    nextseg.length -= length;
                    nextseg._length = nextseg.length;
                }
                segment.length = segment._length = 2 * segment._length / 3;
                this.selectedObject.segments = segments.concat(this.selectedObject.segments);
                var index = Number(coll[0]) + Number(coll[1]);
                this.selectedSegment = this.selectedObject.segments[2];
                this.nextSegment = this.selectedObject.segments[3];
            }
        },
        ConnectionEditTool.prototype.updatePreviousSegment = function (current, prev, difx, dify) {
            prev._endPoint = prev.points[prev.points.length - 1] = current._startPoint;
            if (prev.type == "orthogonal") {
                if (prev.direction == "bottom") {
                    prev.length += dify;
                    if (prev.length < 0) {
                        prev._direction = prev.direction = "top";
                        prev.length *= -1;
                    }
                }
                else if (prev.direction == "top") {
                    prev.length -= dify;
                    if (prev.length < 0) {
                        prev._direction = prev.direction = "bottom";
                        prev.length *= -1;
                    }
                }
                else if (prev.direction == "right") {
                    prev.length += difx
                    if (prev.length < 0) {
                        prev._direction = prev.direction = "left";
                        prev.length *= -1;
                    }
                }
                else if (prev.direction == "left") {
                    prev.length -= difx;
                    if (prev.length < 0) {
                        prev._direction = prev.direction = "right";
                        prev.length *= -1;
                    }
                }
                prev._length = prev.length;
            }
            else {
                if (prev.type == "bezier") {
                    ej.datavisualization.Diagram.Util._updateBezierPoints(prev);
                }
            }
        };
        ConnectionEditTool.prototype.updateNextSegment = function (current, next, difx, dify) {
            var pt = current._endPoint;
            next._startPoint = next.points[0] = this.selectedSegment._endPoint;
            if (next) {
                if (next.type == "orthogonal") {
                    if (next.length || next.length === 0) {
                        if (next._direction == "left" || next._direction == "right") {
                            if (difx != 0) {
                                if (next._direction == "right") {
                                    next._length -= difx;
                                }
                                else {
                                    next._length += difx;
                                }

                                if (next.length || next.length === 0) {
                                    next.length = next._length;
                                    if (next.length < 0) {
                                        if (next.direction == "left") next.direction = "right";
                                        else if (next.direction == "right") next.direction = "left";
                                        next.length *= -1;
                                        next._direction = next.direction;
                                        next._length = next.length;
                                    }
                                }

                            }
                            if (dify != 0) {
                                if (current.type != "orthogonal") {
                                    next._startPoint.y = next.points[0].y = next._endPoint.y = next.points[next.points.length - 1].y = pt.y;
                                    var index = this.selectedObject.segments.indexOf(next);
                                    var segment = this.selectedObject.segments[index + 1];
                                    segment._startPoint.y = segment.points[0].y = next._endPoint.y;
                                    if (segment.length) {
                                        if (segment.direction == "bottom") {
                                            segment.length -= dify;
                                            if (segment.length < 0) {
                                                segment.direction = "top";
                                                segment.length *= -1;
                                            }
                                        }
                                        else {
                                            segment.length += dify;
                                            if (segment.length < 0) {
                                                segment.direction = "bottom";
                                                segment.length *= -1;
                                            }
                                        }
                                    }
                                }
                            }

                        }
                        else {
                            if (dify != 0) {
                                if (next._direction == "bottom") {
                                    next._length -= dify;
                                }
                                else {
                                    next._length += dify;
                                }

                                if (next.length || next.length === 0) {
                                    next.length = next._length;
                                    if (next.length < 0) {
                                        if (next.direction == "top") next.direction = "bottom";
                                        else if (next.direction == "bottom") next.direction = "top";
                                        next.length *= -1;
                                        next._length = next.length;
                                        next._direction = next.direction;
                                    }
                                }

                            }
                            if (difx != 0) {
                                if (current.type != "orthogonal") {
                                    next._startPoint.x = next.points[0].x = next._endPoint.x = next.points[next.points.length - 1].x = pt.x;
                                    var index = this.selectedObject.segments.indexOf(next);
                                    var segment = this.selectedObject.segments[index + 1];
                                    if (segment.length) {
                                        if (segment.direction == "right") {
                                            segment.length += difx;
                                            if (segment.length < 0) {
                                                segment.direction = "left";
                                                segment.length *= -1;
                                            }
                                        }
                                        else {
                                            segment.length -= difx;
                                            if (segment.length < 0) {
                                                segment.direction = "right";
                                                segment.length *= -1;
                                            }
                                        }
                                    }
                                }
                            }
                        }

                    }
                }
                else {

                    if (next.type == "bezier")
                        ej.datavisualization.Diagram.Util._updateBezierPoints(next);
                }
            }
        };
        ConnectionEditTool.prototype.mouseup = function (evt) {
            if (evt.shiftKey && evt.ctrlKey) {
                this._addOrRemoveStraightSegments(evt);
            }
            else
                if (this.inAction) {
                    this.inAction = false;
                    if (this._endPoint == "segmentEnd" && this.selectedSegment.type == "orthogonal") {
                        var args = this._raiseSegmentEditEvent(ej.datavisualization.Diagram.DragState.Completed);
                        if (!args.cancel) {
                            var index = this.selectedObject.segments.indexOf(this.selectedSegment);
                            var prev = this.selectedObject.segments[index - 1];
                            var next = this.selectedObject.segments[index + 1];
                            var refresh = false;
                            if (prev && prev.type == "orthogonal" && Math.abs(prev.length) < 5) {
                                if (index != 1) {
                                    refresh = this._removePrevSegment(index);
                                }
                            }
                            else if (next && next.type == "orthogonal") {
                                var length = (next.length || next.length === 0) ? next.length : ej.datavisualization.Diagram.Geometry.distance(next.points[0], next.points[1]);
                                if (Math.abs(length <= 5)) {
                                    refresh = this._removeNextSegment(index);
                                }
                            }
                            if (refresh) {
                                ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, this.selectedObject.sourcePort, this.selectedObject.targetPort, this.diagram);
                                ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);
                                ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
                            }
                        }
                    }
                    else if (this._endPoint != "segmentEnd") {
                        var cancelEvent = this._updatePoints(this.selectedObject, ej.datavisualization.Diagram.DragState.Completed);
                        if (!this.diagram.nameTable[this.selectedObject.name]) this.selectedObject = null;
                        if (this.selectedObject) {
                            if (!cancelEvent.cancel) {
                                this._disconnect(this.selectedObject);
                                var args;
                                if (this._currentPossibleConnection && !this.inAction) {
                                    this._updateConnection(this.selectedObject);
                                }
                                else {
                                    if (this.selectedObject.sourceNode || this.selectedObject.targetNode) {
                                        this._updateConnection(this.selectedObject);
                                    }
                                }
                                ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                                if (this.selectedObject.parent)
                                    ej.datavisualization.Diagram.Util._updateGroupBounds(this.diagram.nameTable[this.selectedObject.parent], this.diagram);
                            }
                            else {
                                if (cancelEvent && cancelEvent.cancel && cancelEvent.eventType) {
                                    if (cancelEvent.eventType === "connectorSourceChange") {
                                        if (this.undoObject.sourceNode) {
                                            this.selectedObject.sourceNode = this.undoObject.sourceNode;
                                            this.diagram.nameTable[this.undoObject.sourceNode].outEdges.push(this.selectedObject.name);
                                            this.selectedObject.sourcePort = this.undoObject.sourcePort;
                                        }
                                        else if (this.undoObject.sourceNode == null && this.selectedObject.sourceNode) {
                                            this.selectedObject.sourceNode = this.undoObject.sourceNode;
                                            this.selectedObject.sourcePort = this.undoObject.sourcePort;
                                            this.selectedObject.sourcePoint = this.undoObject.sourcePoint;
                                            this.selectedObject.segments = this.undoObject.segments;
                                        }
                                        else {
                                            this.selectedObject.sourcePoint = this.undoObject.sourcePoint;
                                            this.selectedObject.segments = this.undoObject.segments;
                                        }
                                    }
                                    if (cancelEvent.eventType === "connectorTargetChange") {
                                        if (this.undoObject.targetNode) {
                                            this.selectedObject.targetNode = this.undoObject.targetNode;
                                            this.diagram.nameTable[this.undoObject.targetNode].inEdges.push(this.selectedObject.name);
                                            this.selectedObject.targetPort = this.undoObject.targetPort;
                                        }
                                        else if (this.undoObject.targetNode == null && this.selectedObject.targetNode) {
                                            this.selectedObject.targetNode = this.undoObject.targetNode;
                                            this.selectedObject.targetPort = this.undoObject.targetPort;
                                            this.selectedObject.targetPoint = this.undoObject.targetPoint;
                                            this.selectedObject.segments = this.undoObject.segments;
                                        }
                                        else {
                                            this.selectedObject.segments = this.undoObject.segments;
                                            this.selectedObject.targetPoint = this.undoObject.targetPoint;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (this.selectedObject) {
                        if (this.selectedObject.annotation) {
                            var targetNode = this.diagram.nameTable[this.selectedObject.targetNode];
                            ej.datavisualization.Diagram.DefautShapes.updateBPMNAnnotationShape(this.selectedObject, this.undoObject.targetNode, targetNode, this.diagram);
                        }
                        this.diagram._dock(this.selectedObject, this.diagram.nameTable, true);
                        ej.datavisualization.Diagram.Util.updateBridging(this.selectedObject, this.diagram);
                        ej.datavisualization.Diagram.SvgContext.update(this.selectedObject, this.diagram);
                        this.diagram._updateConnectorBridging(this.selectedObject);
                        this.diagram._updateQuad(this.selectedObject);
                        this.diagram._updateSelectionHandle();
                        if (this.selectedObject.annotation)
                            ej.datavisualization.Diagram.DefautShapes.updateAnnotationProperties(this.selectedObject, this.diagram);
                        if (this.selectedObject) {
                            (this.diagram._svg.getElementById(this.selectedObject.name + "_hitTest")).setAttribute("pointer-events", "stroke");
                            (this.diagram._svg.getElementById(this.selectedObject.name)).setAttribute("pointer-events", "auto");
                        }
                        (this.diagram._adornerSvg.getElementById(this.diagram._adornerSvg.document.id + "handle_g")).setAttribute("pointer-events", "visible");
                        this._initialValue = null;
                    }
                }
            if (this.selectedObject) {
                var entry = { type: "endpointchanged", undoObject: this.undoObject, redoObject: this._getClonedObject(this.selectedObject), isMultipleNode: (this.selectedObject._type === "group") ? true : false, category: "internal" };
                this.diagram.addHistoryEntry(entry);
                for (var i = 0; i < this._nearestNodes.length; i++)
                    this._showPort(this._nearestNodes[i], true);
            }
            delete this._nearestNodes;
            base.prototype.mouseup.call(this, evt);
        };
        ConnectionEditTool.prototype._addOrRemoveStraightSegments = function (evt) {
            if (this._endPoint == "segmentEnd") {
                var targetid = evt.target.id;
                var coll = targetid.split("_");
                coll.reverse();
                var index = Number(coll[0]);
                var segment = this.selectedObject.segments[index];
                if (segment && segment.type == "straight") {
                    var prevseg = this.selectedObject.segments[index + 1];
                    if (prevseg) {
                        this.selectedObject.segments.splice(index, 1);
                        prevseg._startPoint = prevseg.points[0] = segment._startPoint;
                        update = true;
                    }
                }
            }
            else {
                var className = evt.target.getAttribute("class");
                var targetid = evt.target.id;
                var update = false;
                var index = this._findIndex();
                if (this.selectedObject.segments && this.selectedObject.segments[index] && this.selectedObject.segments[index].type == "straight") {
                    var segment = this.selectedObject.segments[index];
                    var newseg = ej.datavisualization.Diagram.Segment({ type: "straight", _point: segment._endPoint });
                    this.selectedObject.segments.splice(index + 1, 0, newseg);
                    if (index + 1 != this.selectedObject.segments.length - 1) {
                        newseg.point = newseg._point;
                    }
                    segment._point = segment.point = segment.points[1] = segment._endPoint = this.currentPoint;
                    newseg.points[0] = newseg._startPoint = this.currentPoint;
                    newseg.points[1] = newseg._endPoint = newseg._point;
                    update = true;
                }
            }
            if (update) {
                ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, this.selectedObject.sourcePort, this.selectedObject.targetPort, this.diagram);
                ej.datavisualization.Diagram.Util.updateBridging(this.selectedObject, this.diagram);
                ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);
                //ej.datavisualization.Diagram.SvgContext.clearSelector(this.diagram._svg, this.diagram._adornerLayer);
                ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
            }
        };
        ConnectionEditTool.prototype._findIndex = function () {
            var intersectingSegs = [];
            for (var i = 0; i < this.selectedObject.segments.length; i++) {
                var segment = this.selectedObject.segments[i];
                var rect;
                rect = {
                    x: Math.min(segment._startPoint.x, segment._endPoint.x), y: Math.min(segment._startPoint.y, segment._endPoint.y),
                    width: Math.abs(segment._startPoint.x - segment._endPoint.x), height: Math.abs(segment._startPoint.y - segment._endPoint.y)
                };
                ej.datavisualization.Diagram.Geometry.inflate(rect, this.selectedObject.lineHitPadding / 2, this.selectedObject.lineHitPadding / 2);
                if (ej.datavisualization.Diagram.Geometry.containsPoint(rect, this.currentPoint)) {
                    intersectingSegs.push(segment);
                }
            }
            if (intersectingSegs.length == 1) {
                return this.selectedObject.segments.indexOf(intersectingSegs[0]);
            }
            else {
                var ratio, min, index, seg, v, h;
                for (var i = 0; i < intersectingSegs.length; i++) {
                    seg = intersectingSegs[i];
                    var point = this.currentPoint;
                    v = (point.y - seg._startPoint.y) / (seg._endPoint.y - point.y);
                    h = (point.x - seg._startPoint.x) / (seg._endPoint.x - point.x);
                    ratio = Math.abs(v - h);
                    if (i == 0) { min = ratio; index = 0; }
                    if (ratio < min) { min = ratio; index = i; }
                }
                return this.selectedObject.segments.indexOf(intersectingSegs[index]);
            }
        }
        ConnectionEditTool.prototype._removeNextSegment = function (index) {
            var first = this.selectedObject.segments[index - 1];
            var last = this.selectedObject.segments[index + 2];
            var next = this.selectedObject.segments[index + 1];
            if (next.length || next.length === 0) {
                this.selectedObject.segments.splice(index, 2);
                if (this.selectedSegment.direction == "top" || this.selectedSegment.direction == "bottom") {
                    last._startPoint.y = this.selectedSegment._startPoint.y;
                    first._endPoint.x = last._startPoint.x;
                }
                else {
                    last._startPoint.x = this.selectedSegment._startPoint.x;
                    first._endPoint.y = last._startPoint.y;
                }
            }
            else {
                this.selectedObject.segments.splice(index + 1, 1);
                if (this.selectedSegment.direction == "top" || this.selectedSegment.direction == "bottom") {
                    first._endPoint.x = next._endPoint.x;
                }
                else {
                    first._endPoint.y = next._endPoint.y;
                }
                first._length = first.length = ej.datavisualization.Diagram.Geometry.distance(first._startPoint, first._endPoint);
                if (first.length)
                    first._direction = first.direction = ej.datavisualization.Diagram.Util._getBezierDirection(first._startPoint, first._endPoint);
                this.selectedSegment.length = this.selectedSegment._length = this.selectedSegment.direction = null;
            }

            if (first && last) {
                first._length = first.length = ej.datavisualization.Diagram.Geometry.distance(first._startPoint, last._startPoint);
                if (first.length)
                    first._direction = first.direction = ej.datavisualization.Diagram.Util._getBezierDirection(first._startPoint, last._startPoint);
                if (last.length || last.length === 0) {
                    last._length = last.length = ej.datavisualization.Diagram.Geometry.distance(first._endPoint, last._endPoint);
                    if (last.length)
                        last._direction = last.direction = ej.datavisualization.Diagram.Util._getBezierDirection(first._endPoint, last._endPoint);
                }
            }
            return true;
        },
        ConnectionEditTool.prototype._removePrevSegment = function (index) {
            var first = this.selectedObject.segments[index - 2];
            var next = this.selectedObject.segments[index + 1];
            var length = (next.length || next.length === 0) ? next.length : ej.datavisualization.Diagram.Geometry.distance(next.points[0], next.points[1]);
            if (length <= 5) {
                var end = this.selectedObject.segments[index + 2];
                if (next.length === length)
                    this.selectedObject.segments.splice(index - 1, 4);
                else
                    this.selectedObject.segments.splice(index - 1, 3);
                if (end) {
                    if (first.direction == "top" || first.direction == "bottom") {
                        first._endPoint.y = end._endPoint.y;
                        end._startPoint.x = first._endPoint.x;
                    }
                    else {
                        first._endPoint.x = end._endPoint.x;
                        end._startPoint.y = first._endPoint.y;
                    }
                    if (first.length || first.length === 0) {
                        first._length = first.length = ej.datavisualization.Diagram.Geometry.distance(first._startPoint, first._endPoint);
                        if (first.length)
                            first._direction = first.direction = ej.datavisualization.Diagram.Util._getBezierDirection(first._startPoint, first._endPoint);
                    }
                    if (end.length || end.length === 0) {
                        end._length = end.length = ej.datavisualization.Diagram.Geometry.distance(end._startPoint, end._endPoint);
                        if (end._length)
                            end._direction = end.direction = ej.datavisualization.Diagram.Util._getBezierDirection(end._startPoint, end._endPoint);
                    }
                }
                else {
                    first._endPoint = this.selectedObject.endPoint;
                    first.direction = first.length = first._length = null;
                    first._direction = next._direction;
                }
            }
            else {

                var last = this.selectedObject.segments[index + 1];
                this.selectedObject.segments.splice(index - 1, 2);
                var segment = this.selectedSegment;
                if (segment.direction == "left" || segment.direction == "right") {
                    first._endPoint.x = last._startPoint.x;
                    last._startPoint.y = first._endPoint.y;
                }
                else {
                    first._endPoint.y = last._startPoint.y;
                    last._startPoint.x = first._endPoint.x;
                }
                if (this.selectedSegment.length || this.selectedSegment.length === 0) {
                    first._length = first.length = ej.datavisualization.Diagram.Geometry.distance(first._startPoint, first._endPoint);
                    if (first._length)
                        first._direction = first.direction = ej.datavisualization.Diagram.Util._getBezierDirection(first._startPoint, first._endPoint);
                }
                if (last.length || last.length === 0) {
                    last._length = last.length = ej.datavisualization.Diagram.Geometry.distance(last._startPoint, last._endPoint);
                    if (last.length)
                        last._direction = last.direction = ej.datavisualization.Diagram.Util._getBezierDirection(last._startPoint, last._endPoint);
                }
            }

            return true;
        },
        ConnectionEditTool.prototype._getClonedObject = function (connector) {
            if (connector) {
                var clonedObject = $.extend(true, {}, connector);
                clonedObject.targetNode = connector.targetNode;
                clonedObject.sourceNode = connector.sourceNode;
                clonedObject.targetPort = connector.targetPort;
                clonedObject.sourcePort = connector.sourcePort;
                return clonedObject;
            }
        };
        ConnectionEditTool.prototype._updateConnection = function (connector, updateSelection) {
            var connectionChange;
            if (this._endPoint == "targetEndPoint") {
                if (this._currentPossibleConnection) {
                    if (this._possibleConnectionPort && ej.datavisualization.Diagram.Util.canConnect(this._possibleConnectionPort, true)) {
                        if (connector.targetNode != this._currentPossibleConnection.name || connector.targetPort != this._possibleConnectionPort.name) {
                            connectionChange = this._raiseConnectionChangeEvent(connector, true);
                        }
                    }
                    else if (ej.datavisualization.Diagram.Util.canConnect(this._currentPossibleConnection)) {
                        if (connector.targetNode != this._currentPossibleConnection.name || connector.targetPort) {
                            connectionChange = this._raiseConnectionChangeEvent(connector, true);
                        }
                    }
                }
                else {
                    if (this.selectedObject.targetNode) {
                        connectionChange = this._raiseConnectionChangeEvent(connector, true);
                    }
                }
                if (connectionChange) {
                    ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, this.selectedObject.sourcePort, this.selectedObject.targetPort, this.diagram);
                    ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);
                    if (connector.segments.length > 2 || connector.segments[0].points.length == 2)
                        ej.datavisualization.Diagram.Util._updatePreviousSegment(connector);
                    ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
                }
            }
            else if (this._endPoint == "sourceEndPoint") {
                if (this._currentPossibleConnection) {
                    if (this._possibleConnectionPort && ej.datavisualization.Diagram.Util.canConnect(this._possibleConnectionPort, true)) {
                        if (connector.sourceNode != this._currentPossibleConnection.name || connector.sourcePort != this._possibleConnectionPort.name) {
                            connectionChange = this._raiseConnectionChangeEvent(connector);
                        }
                    }
                    else if (ej.datavisualization.Diagram.Util.canConnect(this._currentPossibleConnection)) {
                        if (connector.sourceNode != this._currentPossibleConnection.name || connector.sourcePort) {
                            connectionChange = this._raiseConnectionChangeEvent(connector);
                        }
                    }

                }
                else {
                    if (this.selectedObject.sourceNode) {
                        connectionChange = this._raiseConnectionChangeEvent(connector);
                        //if (connectionChange)
                        {
                            ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, this.selectedObject.sourcePort, this.selectedObject.targetPort, this.diagram);
                            ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);

                        }
                    }
                    if (connectionChange) {
                        ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
                    }
                }

            }

            var endPoint = this.selectedSegment._endPoint;
            this.diagram._dock(connector, this.diagram.nameTable, updateSelection);
            if (connectionChange && this._endPoint == "sourceEndPoint" && this.selectedObject.segments.length > 1) {
                if (this.selectedSegment.points.length == 2 && !this.selectedObject.sourcePort && this.selectedSegment.length) {
                    if (this.selectedSegment.direction == "right" || this.selectedSegment.direction == "left") {
                        if (this.selectedSegment._startPoint.x < endPoint.x) {
                            this.selectedSegment.direction = this.selectedSegment._direction = "right";
                        }
                        else this.selectedSegment.direction = this.selectedSegment._direction = "left";
                        this.selectedSegment.length = this.selectedSegment._length = Math.abs(this.selectedSegment._startPoint.x - endPoint.x);
                    }
                    else {
                        if (this.selectedSegment._startPoint.y < endPoint.y) {
                            this.selectedSegment.direction = this.selectedSegment._direction = "bottom";
                        }
                        else this.selectedSegment.direction = this.selectedSegment._direction = "top";
                        this.selectedSegment.length = this.selectedSegment._length = Math.abs(this.selectedSegment._startPoint.y - endPoint.y);

                    }
                    ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, this.selectedObject.sourcePort, this.selectedObject.targetPort, this.diagram);
                    ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);
                    ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
                }
                else {
                    if (connectionChange) {
                        ej.datavisualization.Diagram.Util._updateConnectorSegments(this.selectedObject, this.selectedObject.sourcePort, this.selectedObject.targetPort, this.diagram);
                        ej.datavisualization.Diagram.DiagramContext._refreshSegments(this.selectedObject, this.diagram);
                        ej.datavisualization.Diagram.SvgContext._refreshEndPointHandles(this.diagram.selectionList[0], this.diagram._adornerSvg, this.diagram._currZoom);
                    }
                }
            }
        };
        ConnectionEditTool.prototype._raiseConnectionChangeEvent = function (connector, isTarget) {
            var args = this._raiseEvent("connectionChange", { element: this.selectedObject, endPoint: this._endPoint, connection: this._currentPossibleConnection, port: this._possibleConnectionPort, cancel: false });
            if (!args.cancel) {
                if (isTarget) {
                    if (!this._currentPossibleConnection || connector.targetNode != this._currentPossibleConnection.name) {
                        if (this._currentPossibleConnection)
                            this._currentPossibleConnection.inEdges.push(connector.name);
                        if (connector.targetNode) {
                            var node = this.diagram.nameTable[this.selectedObject.targetNode];
                            if (node)
                                ej.datavisualization.Diagram.Util.removeItem(node.inEdges, connector.name);
                        }
                    }
                    this.diagram._comparePropertyValues(connector, "targetNode", { targetNode: this._currentPossibleConnection ? this._currentPossibleConnection.name : null }, true);
                    connector.targetNode = this._currentPossibleConnection ? this._currentPossibleConnection.name : null;
                    this.diagram._comparePropertyValues(connector, "targetPort", { targetPort: this._possibleConnectionPort ? this._possibleConnectionPort.name : null }, true);
                    connector.targetPort = this._possibleConnectionPort ? this._possibleConnectionPort.name : null;
                }
                else {
                    if (!this._currentPossibleConnection || connector.sourceNode != this._currentPossibleConnection.name) {
                        if (this._currentPossibleConnection)
                            this._currentPossibleConnection.outEdges.push(connector.name);
                        if (connector.sourceNode) {
                            var node = this.diagram.nameTable[this.selectedObject.sourceNode];
                            if (node)
                                ej.datavisualization.Diagram.Util.removeItem(node.outEdges, connector.name);
                        }
                    }
                    this.diagram._comparePropertyValues(connector, "sourceNode", { sourceNode: this._currentPossibleConnection ? this._currentPossibleConnection.name : null }, true);
                    connector.sourceNode = this._currentPossibleConnection ? this._currentPossibleConnection.name : null;
                    this.diagram._comparePropertyValues(connector, "sourcePort", { sourcePort: this._possibleConnectionPort ? this._possibleConnectionPort.name : null }, true);
                    connector.sourcePort = this._possibleConnectionPort ? this._possibleConnectionPort.name : null;
                }

                return true;
            }
        }
        ConnectionEditTool.prototype._disconnect = function (connector) {
            var args;
            //var node = this.diagram.nameTable[connector.targetNode];
            var port = null;
            //if (this._endPoint == "targetEndPoint" && node) {
            //    port = ej.datavisualization.Diagram.Util.findPortByName(node, connector.targetPort);
            //    args = this._raiseEvent("connectionChange", { element: connector, endPoint: this._endPoint, connection: node, port: port, cancel: false });
            //    if (!args.cancel) {
            //        ej.datavisualization.Diagram.Util.removeItem(node.inEdges, connector.name);
            //        connector.targetNode = null;
            //        connector.targetPort = null;
            //    }

            //}
            //var node = this.diagram.nameTable[connector.sourceNode];
            //if ((this._endPoint == "sourceEndPoint") && node) {
            //    port = ej.datavisualization.Diagram.Util.findPortByName(node, connector.sourcePort);
            //    args = this._raiseEvent("connectionChange", { element: connector, endPoint: this._endPoint, connection: node, port: port, cancel: false });
            //    if (!args.cancel) {
            //        ej.datavisualization.Diagram.Util.removeItem(node.outEdges, connector.name);
            //        connector.sourceNode = null;
            //        connector.sourcePort = null;
            //    }
            //}
        };
        ConnectionEditTool.prototype._endAction = function () {
            this._showPorts();
            var possibleConnection;
            if (this._currentPossibleConnection && !this._possibleConnectionPort) {
                possibleConnection = this._currentPossibleConnection;
            }
            base.prototype._endAction.apply(this);
            if (this._endPoint) {
                this._endPoint = null;
                if (possibleConnection) {
                    this.diagram._checkToolToActivate(possibleConnection, this.currentPoint);
                    this.diagram._updateCursor();
                }
            }
        };

        ConnectionEditTool.prototype._outOfBoundsDrag = function (node, ptX, ptY, isTarget) {
            ptX = ptX ? ptX : 0;
            ptY = ptY ? ptY : 0;
            if (node && ej.datavisualization.Diagram.Util.canMoveOutofBoundary(this.diagram)) {
                var size = this._getPageBounds();
                if (!this.diagram._selectedSymbol && (ptX >= size.width || ptX <= size.x)) {
                    this.updateCursor("not-allowed");
                    return false;
                }
                if (!this.diagram._selectedSymbol && (ptY >= size.height || ptY <= size.y)) {
                    this.updateCursor("not-allowed");
                    return false;
                }
            }
            else if (!ej.datavisualization.Diagram.bpmnHelper.canMoveOutofBounds(this.diagram, node, ptX, ptY)) {
                this.updateCursor("not-allowed");
                return false;
            }
            this.updateCursor(this.cursor);
            return true;
        };
        ConnectionEditTool.prototype._updatePoints = function (connector, dragState) {
            var cancel = false, eventType = "";
            if (this._endPoint && this._endPoint != "segmentEnd" && this.selectedSegment) {
                var isTarget = (this._endPoint == "targetEndPoint") ? true : false;
                var isSource = (this._endPoint == "sourceEndPoint") ? true : false;

                var endPoint;
                if (this._endPoint) {
                    var end = this._endPoint.match("bezierpoint1") ? "bezierpoint1" : this._endPoint.match("bezierpoint2") ? "bezierpoint2" : this._endPoint;;

                    switch (end) {
                        case "targetEndPoint":
                            endPoint = this.selectedSegment._endPoint;
                            break;
                        case "sourceEndPoint":
                            endPoint = this.selectedSegment._startPoint;
                            break;
                        case "bezierpoint1":
                            endPoint = this.selectedSegment._point1;
                            break;
                        case "bezierpoint2":
                            endPoint = this.selectedSegment._point2;
                            break;
                    }

                    var ptCur = this.currentPoint;
                    if (this._possibleConnectionPort == null) {
                        ptCur = this.snap(ptCur);
                    }
                    var offset = ej.datavisualization.Diagram.Point(endPoint.x - ptCur.x, endPoint.y - ptCur.y);

                    var dragargs = this._raiseEndPointDrag(connector, isTarget, isSource, dragState);
                    if (dragargs) {
                        cancel = dragargs.cancel;
                        eventType = dragargs.type;
                    }
                    if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(offset)) {
                        if (!cancel) {
                            if (isTarget || isSource) {
                                var connected = this._currentPossibleConnection ? ej.datavisualization.Diagram.Util.canConnect(this._currentPossibleConnection, false) : false;
                                if (this._outOfBoundsDrag(this.selectedObject, ptCur.x, ptCur.y, isTarget)) {
                                    if (this.selectedObject.segments.length > 1) {
                                        if (!isTarget && !connected && this.selectedSegment.type == "orthogonal" && (this.selectedSegment.length || this.selectedSegment.length === 0)) {
                                            this.selectedObject.sourcePoint = ptCur;
                                            var difx = ptCur.x - this.selectedSegment._startPoint.x;
                                            var dify = ptCur.y - this.selectedSegment._startPoint.y;
                                            if (this.selectedSegment.direction == "left" || this.selectedSegment.direction == "right") {
                                                this.selectedSegment._endPoint.y = this.selectedSegment.points[this.selectedSegment.points.length - 1].y = ptCur.y;
                                            }
                                            else {
                                                this.selectedSegment._endPoint.x = this.selectedSegment.points[this.selectedSegment.points.length - 1].x = ptCur.x;
                                            }
                                            this.selectedSegment._startPoint = this.selectedSegment.points[0] = ptCur;
                                            this.selectedSegment._length = this.selectedSegment.length = ej.datavisualization.Diagram.Geometry.distance(ptCur, this.selectedSegment._endPoint);
                                            if (this.selectedSegment._length)
                                                this.selectedSegment._direction = this.selectedSegment.direction = ej.datavisualization.Diagram.Util._getBezierDirection(ptCur, this.selectedSegment._endPoint);

                                            this.updateNextSegment(this.selectedObject.segments[0], this.selectedObject.segments[1], difx,
                                                dify);
                                            var next = this.selectedObject.segments[1];
                                            var updated = false;
                                            if (next && (next.length)) {
                                                next.length = next._length = ej.datavisualization.Diagram.Geometry.distance(this.selectedSegment._endPoint, next._endPoint);
                                                if (next.length)
                                                    next.direction = next._direction = ej.datavisualization.Diagram.Util._getBezierDirection(this.selectedSegment._endPoint, next._endPoint);
                                            }
                                            if (this.selectedSegment.length == 0 || next.length === 0) {
                                                if (next.length == 0 && this.selectedObject.segments.length > 2) {
                                                    this.selectedObject.segments.splice(0, 2);
                                                }
                                                else if (this.selectedObject.segments.length > 1) {
                                                    this.selectedObject.segments.splice(0, 1);
                                                }
                                                this.selectedSegment = this.selectedObject.segments[0];
                                                this.selectedSegment._startPoint = this.selectedSegment.points[0] = ptCur;
                                                if (this.selectedSegment._direction == "left" || this.selectedSegment._direction == "right") {
                                                    this.selectedSegment._endPoint.y = this.selectedSegment.points[this.selectedSegment.points.length - 1].y = ptCur.y;
                                                }
                                                else {
                                                    this.selectedSegment._endPoint.x = this.selectedSegment.points[this.selectedSegment.points.length - 1].x = ptCur.x;
                                                }

                                                var next = this.selectedObject.segments[1];
                                                if (this.selectedObject.segments.length > 1) {
                                                    this.selectedSegment._length = this.selectedSegment.length = ej.datavisualization.Diagram.Geometry.distance(ptCur, next._startPoint);
                                                    ej.datavisualization.Diagram.Util._addOrthogonalPoints(this.selectedSegment, null, connector.segments[1], connector.sourcePoint, connector.targetPoint);
                                                    ej.datavisualization.Diagram.Util._addOrthogonalPoints(connector.segments[1], connector.segments[0], connector.segments[2], connector.sourcePoint, connector.targetPoint);
                                                    next._startPoint = next.points[0] = connector.segments[0]._endPoint;
                                                }
                                                else ej.datavisualization.Diagram.Util._addOrthogonalPoints(this.selectedSegment, null, connector.segments[1], connector.sourcePoint, connector.targetPoint);

                                                updated = true;
                                            }
                                            else ej.datavisualization.Diagram.Util._addOrthogonalPoints(this.selectedSegment, null, connector.segments[1], connector.sourcePoint, connector.targetPoint);
                                            if (next && (next.length)) {
                                                next.length = next._length = ej.datavisualization.Diagram.Geometry.distance(this.selectedSegment._endPoint, next._endPoint);
                                                if (next.length)
                                                    next.direction = next._direction = ej.datavisualization.Diagram.Util._getBezierDirection(this.selectedSegment._endPoint, next._endPoint);
                                            }
                                        }
                                        else if (isTarget && !connected && this.selectedSegment.type == "orthogonal" && this.selectedSegment.points.length == 2) {
                                            var difx = ptCur.x - this.selectedSegment._endPoint.x;
                                            var dify = ptCur.y - this.selectedSegment._endPoint.y;

                                            if (this.selectedSegment._direction == "left" || this.selectedSegment._direction == "right") {
                                                this.selectedSegment._startPoint.y = (this.selectedSegment.points[0].y += dify);
                                                this.selectedSegment._endPoint.y = this.selectedSegment.points[1].y = this.selectedSegment._startPoint.y;
                                            }
                                            else {
                                                this.selectedSegment._startPoint.x = (this.selectedSegment.points[0].x += difx);
                                                this.selectedSegment._endPoint.x = this.selectedSegment.points[1].x = this.selectedSegment._startPoint.x;
                                            }
                                            var index = this.selectedObject.segments.length - 1;
                                            if (this.selectedObject.segments[index - 1])
                                                this.updatePreviousSegment(this.selectedObject.segments[index], this.selectedObject.segments[index - 1], difx,
                                                    dify);
                                        }
                                    }
                                    if ((isSource || isTarget) && !connected) {
                                        var srclength = this.selectedSegment.points.length;
                                        this.diagram._setEndPoint(connector, ej.datavisualization.Diagram.Point(ptCur.x, ptCur.y), isTarget);
                                        if (srclength != this.selectedSegment.points.length || updated) {
                                            return { updateSelection: true, cancel: cancel };
                                        }
                                    }
                                }
                            }
                            else
                                ej.datavisualization.Diagram.Util._setBezierPoint(this.selectedSegment, ej.datavisualization.Diagram.Point(ptCur.x, ptCur.y), end);
                        }
                    }
                }
            }
            return { cancel: cancel, eventType: eventType };
        };
        return ConnectionEditTool;
    })(ToolBase);

    ej.datavisualization.Diagram.ConnectionEditTool = ConnectionEditTool;
    //#endregion

    //#region ShapeTool
    var ShapeTool = (function (base) {
        ej.datavisualization.Diagram.extend(ShapeTool, base);
        function ShapeTool(diagram) {
            base.call(this, "shapeTool", diagram);
            this.cursor = "crosshair";
            this._drawingPolygon = false;
            this._points = [];
        }
        ShapeTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);

            if (this._isPolyline() && evt && !this._sourcePossibleConnection) {
                if (this._currentPossibleConnection) {
                    var point = this.mousePosition(evt);
                    this._possibleConnectionPort = this.diagram._findPortAtPoint(point, this._currentPossibleConnection);
                }
                if (this._currentPossibleConnection) {
                    this._sourcePossibleConnection = this._currentPossibleConnection;
                    this._sourcePort = this._possibleConnectionPort;
                }
            }

            if (!this._drawingPolygon) {
                this.selectedObject = this.createNode();
                if (this.selectedObject.type == "bpmn") this.diagram._initGroupNode(this.selectedObject);
                this.selectedObject._type = "node";
            }
            else {
                var pt = this.helper.points[this.helper.points.length - 1];
                pt = { x: pt.x, y: pt.y };
                this.helper.points.push(pt);
                this._points.push(this.snap(this.currentPoint));
            }

            this._prevPoint = this.currentPoint;
        };
        ShapeTool.prototype.createNode = function () {
            if (this._isPolyline()) {
                var connector = this.diagram.model.drawType;
                connector.sourcePoint = this.currentPoint,
                connector.targetPoint = this.currentPoint,
                connector.segments = [{ type: "straight" }]
                node = this.diagram._getNewConnector(connector);
            }
            else
            var node = this.diagram._getNewNode(this.diagram.model.drawType);
            if (this.diagram.model.drawType.name) {
                node.name = this.diagram.model.drawType.name + ej.datavisualization.Diagram.Util.randomId();
            }
            else {
                node.name = "node" + ej.datavisualization.Diagram.Util.randomId();
            }
            var currentPoint = this.snap(this.currentPoint);
            if (!this._isPolyline()) {
            node.offsetX = currentPoint.x;
            node.offsetY = currentPoint.y;
            node.width = 5;
            node.height = 5;
            }
            if (node.type != "text" && !this._isPolyline())
                node.shape = this.diagram.model.drawType.shape ? this.diagram.model.drawType.shape : node.shape;

            else if ((this.diagram.model.drawType.shape == "polygon" || this._isPolyline()) && (!this.diagram.model.drawType.points || !this.diagram.model.drawType.points.length)) {
                this._drawingPolygon = true;
                var startPoint = this.snap(this.startPoint);
                node.points = [{ x: startPoint.x, y: startPoint.y },
                    { x: currentPoint.x, y: currentPoint.y }];
                this._points = [{ x: startPoint.x, y: startPoint.y },
                    { x: currentPoint.x, y: currentPoint.y }];
            }
            return ej.datavisualization.Diagram.NodeType(node, this.diagram);
        };
        ShapeTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            if (this.selectedObject) {
                if (!this.inAction) {
                    this.inAction = true;
                    if (this.selectedObject.shape === "polygon" && (!this.diagram.model.drawType.points || !this.diagram.model.drawType.points.length)) {
                        if (this.startPoint.x != this.currentPoint.x || this.startPoint.y != this.currentPoint.y) {
                            var startPoint = this.snap(this.startPoint);
                            var currentPoint = this.snap(this.currentPoint);
                            this.selectedObject.points = [{ x: startPoint.x, y: startPoint.y },
                                { x: currentPoint.x, y: currentPoint.y }];
                            this._points = [{ x: startPoint.x, y: startPoint.y },
                                { x: currentPoint.x, y: currentPoint.y }];
                        }
                    }
                    this._initHelper();
                    this._renderHelper();
                }
                else {
                    this._updateHelper();
                }
            }
            if (this._isPolyline() && evt) {
                this._checkConnectionPossible(evt);
            }
            this.previousPoint = this.currentPoint;
        };
        ShapeTool.prototype._addPolyline = function (evt) {
            if (this._currentPossibleConnection) {
                var point = this.mousePosition(evt);
                this._targetPossibleConnection = this._currentPossibleConnection;
                this._targetPort = this.diagram._findPortAtPoint(point, this._currentPossibleConnection);
            }
            var segments = [];
            for (var i = 1; i < this.selectedObject.points.length - 2; i++)
                segments.push({ type: "straight", point: this.selectedObject.points[i] });
            var connector = this.diagram._getNewConnector(this.selectedObject)
            connector.name = this.selectedObject.name;
            connector.sourcePoint = this.selectedObject.points[0];
            connector.targetPoint = this.selectedObject.points[this.selectedObject.points.length - 1];
            connector.segments = segments;
            connector.sourceNode = this._sourcePossibleConnection ? this._sourcePossibleConnection.name : null;
            connector.targetNode = this._targetPossibleConnection ? this._targetPossibleConnection.name : null;
            connector.sourcePort = this._sourcePort ? this._sourcePort.name : null;
            connector.targetPort = this._targetPort ? this._targetPort.name : null;
            this.diagram.add(connector);
            this._sourcePossibleConnection = null;
            this._targetPossibleConnection = null;
            this._sourcePort = null;
            this._targetPort = null;
        };
        ShapeTool.prototype.mouseup = function (evt) {
            if ((!this._drawingPolygon || evt.button == 2 || this.diagram._getEventDetail(evt) == 2) || (this._sourcePossibleConnection && this._currentPossibleConnection
                    && (this._sourcePossibleConnection.name != this._currentPossibleConnection.name)
                    || (this._sourcePort && this._targetPort && this._sourcePort.name !== this._targetPort.name))) {
                if (this.inAction) {
                    this.inAction = false;
                    if (this._drawingPolygon) this.selectedObject.points = this.helper.points;
                    this._updateSize(this.selectedObject, this.startPoint, this.currentPoint);
                    if (this._isPolyline()) {
                        this._addPolyline(evt);
                    }
                    else
                    this.diagram.add(this.selectedObject);
                    //this.diagram._clearSelection(true);
                    //this.diagram._addSelection(this.selectedObject);
                }
                this.diagram._toolToActivate = "selectTool";
                this.diagram._drawingTool = false;
                base.prototype.mouseup.call(this, evt);
                if (this._drawingPolygon) {
                    this.diagram._disableDefaultContextMenu = true;
                    delete this._drawingPolygon;
                    delete this._points;
                }
            }
        };
        ShapeTool.prototype._renderHelper = function () {
            if (!this.svgHelper) {
                if (this._isPolyline())
                    this.svgHelper = ej.datavisualization.Diagram.SvgContext.renderConnector(this.helper, this.diagram._svg, this.diagram._diagramLayer, undefined, this.diagram);
                else if (this.helper.type != "bpmn")
                    this.svgHelper = ej.datavisualization.Diagram.SvgContext.renderNode(this.helper, this.diagram._svg, this.diagram._diagramLayer, undefined, this.diagram);
                else {
                    this.helper._type = "group";
                    this.diagram._initGroupNode(this.helper);
                    this.svgHelper = ej.datavisualization.Diagram.SvgContext.renderGroup(this.helper, this.diagram._svg, this.diagram._diagramLayer, this.diagram.nameTable, this.diagram);
                }
                this.svgHelper = document.getElementById(this.helper.name);
                this.svgHelper.setAttribute("pointer-events", "none");
            }
        };
        ShapeTool.prototype._updateHelper = function () {
            if (this._drawingPolygon) {
                var currentPoint = this.snap(this.currentPoint);
                var previousPoint = this.snap(this.previousPoint);
                var dif = { x: currentPoint.x - previousPoint.x, y: currentPoint.y - previousPoint.y };
                this.helper.points[this.helper.points.length - 1].x += dif.x;
                this.helper.points[this.helper.points.length - 1].y += dif.y;
                this._points[this._points.length - 1].x += dif.x;
                this._points[this._points.length - 1].y += dif.y;
                if (this._isPolyline()) {
                    var segments = [];
                    for (var i = 0; i < this.helper.points.length - 1  ; i++)
                        segments.push({ type: "straight", point: this.helper.points[i] });
                    this.helper.sourcePoint = this.helper.points[0];
                    this.helper.targetPoint = this.helper.points[this.helper.points.length - 1];
                    this.helper.segments = segments;
                    this.helper = this.diagram._getNewConnector(this.helper)
                    this.diagram._dock(this.helper, this.diagram.nameTable);
            }
            }
            var prtyObject = $.extend(true, {}, this.helper);
            this._updateSize(this.helper, this.snap(this.startPoint), this.snap(this.currentPoint));
            this.diagram._comparePropertyValues(this.helper, "height", { height: prtyObject.height }, true);
            this.diagram._comparePropertyValues(this.helper, "width", { width: prtyObject.width }, true);
            this.diagram._comparePropertyValues(this.helper, "offsetX", { offsetX: prtyObject.offsetX }, true);
            this.diagram._comparePropertyValues(this.helper, "offsetY", { offsetY: prtyObject.offsetY }, true);
            if (this.helper.shape == "polygon" && !this._drawingPolygon) {
                this.helper.width = this.helper.width != 0 ? this.helper.width : 5;
                this.helper.height = this.helper.height != 0 ? this.helper.height : 5;
            }
            ej.datavisualization.Diagram.SvgContext.update(this.helper, this.diagram);
        };
        ShapeTool.prototype._updateSize = function (shape, startPoint, currentPoint) {
            var pts = this._drawingPolygon ? this._points : [startPoint, currentPoint];
            var rect = ej.datavisualization.Diagram.Geometry.rect(pts);
            var size = { width: rect.width, height: rect.height };
            var offset = { x: rect.x, y: rect.y };
            if (!ej.datavisualization.Diagram.Geometry.isEmptySize(size)) {
                if (this.helper.type != "bpmn") {
                    shape.offsetX = offset.x + size.width / 2;
                    shape.offsetY = offset.y + size.height / 2;
                    shape.width = size.width;
                    shape.height = size.height;
                    if (shape._shape === "path")
                        shape._scaled = true;
                }
                else {
                    shape._type = "group";
                    this.diagram._translate(shape, (offset.x + size.width / 2) - shape.offsetX, (offset.y + size.height / 2) - shape.offsetY, this.diagram.nameTable);
                    this.diagram.scale(shape, size.width / this.helper.width, size.height / this.helper.height, new ej.datavisualization.Diagram.Point(shape.offsetX, shape.offsetY), this.diagram.nameTable);
                    ej.datavisualization.Diagram.Util._updateGroupBounds(shape, this.diagram);
                }
            }
        };
        return ShapeTool;
    })(ToolBase)

    ej.datavisualization.Diagram.ShapeTool = ShapeTool;
    //#endregion

    //#region LineTool
    var LineTool = (function (base) {
        ej.datavisualization.Diagram.extend(LineTool, base);
        function LineTool(name, diagram) {
            base.call(this, name, diagram);
            this.cursor = "crosshair";
            this._isMouseDown = false;
            this._targetPossibleConnection = null;
            this._sourcePossibleConnection = null;
            this._targetPort = null;
            this._sourcePort = null;
        }
        LineTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            if (ej.datavisualization.Diagram.Util.isPageEditable(this.diagram)) {
                this._isMouseDown = true;
                if (this.diagram._hasSelection()) {
                    this.diagram._clearSelection();
                }
                if (evt && evt.type === "touchstart") {
                    this._currentPossibleConnection = this.diagram._findConnectableNodeUnderMouse(evt);
                    if (this._currentPossibleConnection) {
                        var point = this.mousePosition(evt);
                        this._possibleConnectionPort = this.diagram._findPortAtPoint(point, this._currentPossibleConnection);
                    }
                }
                if (this._currentPossibleConnection) {
                    this._sourcePossibleConnection = this._currentPossibleConnection;
                    this._sourcePort = this._possibleConnectionPort;
                }
                this._raiseEndPointDrag(this.helper, true, false, ej.datavisualization.Diagram.DragState.Starting);
            }
        };
        LineTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            this._checkConnectionPossible(evt);
            if (this._isMouseDown) {
                if (!this.inAction) {
                    this.inAction = true;
                    this._initHelper();
                    this._renderHelper();
                }
                else {
                    this._targetPossibleConnection = this._currentPossibleConnection;
                    this._targetPort = this._possibleConnectionPort;
                    if (this.helper) {
                        var dragargs = this._raiseEndPointDrag(this.helper, true, false, ej.datavisualization.Diagram.DragState.Dragging);
                        var prptyObject = $.extend(true, {}, this.helper);
                        if (!dragargs.cancel)
                            this._updateHelper();
                        this.diagram._comparePropertyValues(this.helper, "sourcePoint", { sourcePoint: prptyObject.sourcePoint }, true);
                        this.diagram._comparePropertyValues(this.helper, "targetPoint", { targetPoint: prptyObject.targetPoint }, true);
                        this.diagram._comparePropertyValues(this.helper, "segments", { segments: prptyObject.segments }, true);
                        this.diagram._comparePropertyValues(this.helper, "targetNode", { targetNode: this._targetPossibleConnection }, true);
                        this.diagram._comparePropertyValues(this.helper, "targetPort", { targetPort: this._targetPort }, true);
                    }
                }
            }
            this.previousPoint = this.currentPoint;
        };
        LineTool.prototype.mouseup = function (evt) {
            this._isMouseDown = false;
            if (this.inAction) {
                this.inAction = false;
                var ptStart = this._getStartPoint();
                var ptEnd = this._getCurrentPoint();
                var distance = ej.datavisualization.Diagram.Geometry.distance(ptStart, ptEnd);
                if (this._outOfBoundsDrag(this.helper, ptEnd.x, ptEnd.y) && this._outOfBoundsDrag(this.helper, ptStart.x, ptStart.y)) {
                    if (distance > 0) {
                        var connector = this.createConnector(ptStart, ptEnd);
                        connector.name = "connector" + ej.datavisualization.Diagram.Util.randomId();
                        var args, dragargs;
                        if (this._sourcePossibleConnection) {
                            if (this._sourcePort && ej.datavisualization.Diagram.Util.canConnect(this._sourcePort, true)) {
                                args = this._raiseEvent("connectionChange", { element: connector, connection: this._sourcePossibleConnection, port: this._sourcePort, cancel: false });
                                ej.datavisualization.Diagram.Util.removeItem(this._sourcePossibleConnection.outEdges, this.helper.name);
                                dragargs = this._raiseEndPointDrag(connector, true, false, ej.datavisualization.Diagram.DragState.Completed);
                                if (!args.cancel && !dragargs.cancel) {
                                    connector.sourceNode = this._sourcePossibleConnection.name;
                                    connector.sourcePort = this._sourcePort.name;
                                }
                            }
                            else if (ej.datavisualization.Diagram.Util.canConnect(this._sourcePossibleConnection)) {
                                args = this._raiseEvent("connectionChange", { element: connector, connection: this._sourcePossibleConnection, port: this._sourcePort, cancel: false });
                                ej.datavisualization.Diagram.Util.removeItem(this._sourcePossibleConnection.outEdges, this.helper.name);
                                dragargs = this._raiseEndPointDrag(connector, true, false, ej.datavisualization.Diagram.DragState.Completed);
                                if (!args.cancel && !dragargs.cancel) {
                                    connector.sourceNode = this._sourcePossibleConnection.name;
                                }
                            }
                        }
                        if (this._targetPossibleConnection) {
                            if (this._targetPort && ej.datavisualization.Diagram.Util.canConnect(this._targetPort, true)) {
                                args = this._raiseEvent("connectionChange", { element: connector, connection: this._targetPossibleConnection, port: this._targetPort, cancel: false });
                                ej.datavisualization.Diagram.Util.removeItem(this._targetPossibleConnection.inEdges, this.helper.name);
                                dragargs = this._raiseEndPointDrag(connector, true, false, ej.datavisualization.Diagram.DragState.Completed);
                                if (!args.cancel && !dragargs.cancel) {
                                    connector.targetNode = this._targetPossibleConnection.name;
                                    connector.targetPort = this._targetPort.name;
                                }
                            }
                            else if (ej.datavisualization.Diagram.Util.canConnect(this._targetPossibleConnection)) {
                                args = this._raiseEvent("connectionChange", { element: connector, connection: this._targetPossibleConnection, port: this._targetPort, cancel: false });
                                ej.datavisualization.Diagram.Util.removeItem(this._targetPossibleConnection.inEdges, this.helper.name);
                                dragargs = this._raiseEndPointDrag(connector, true, false, ej.datavisualization.Diagram.DragState.Completed);
                                if (!args.cancel && !dragargs.cancel) {
                                    connector.targetNode = this._targetPossibleConnection.name;
                                }
                            }
                        }
                        var success = this.diagram.add(connector);
                        if (success) {
                            connector = this.diagram.nameTable[connector.name];
                            ej.datavisualization.Diagram.Util.updateBridging(connector, this.diagram);
                            ej.datavisualization.Diagram.SvgContext.update(connector, this.diagram);
                            this.diagram._updateConnectorBridging(connector);
                        }
                    }
                }
            }
            if (this.singleAction)
                this.diagram.deactivateTool();
            if (this._prevTool)
                this._prevTool.inAction = false;
            this._showPorts();
            base.prototype.mouseup.call(this, evt);
        };

        LineTool.prototype._getStartPoint = function () {
            var ptStart;
            if (this._sourcePossibleConnection && this._sourcePort) {
                ptStart = ej.datavisualization.Diagram.Util._getPortPosition(this._sourcePort, ej.datavisualization.Diagram.Util.bounds(this._sourcePossibleConnection));
            }
            else {
                ptStart = this.snap(this.startPoint);
            }
            return ptStart;
        };
        LineTool.prototype._getCurrentPoint = function () {
            var ptCur;
            if (this._targetPossibleConnection && this._targetPort) {
                ptCur = ej.datavisualization.Diagram.Util._getPortPosition(this._targetPort, ej.datavisualization.Diagram.Util.bounds(this._targetPossibleConnection));
            }
            else {
                ptCur = this.snap(this.currentPoint);
            }
            return ptCur;
        };
        LineTool.prototype._initHelper = function () {
            this.helper = this.createConnector(ej.datavisualization.Diagram.Point(0, 0), ej.datavisualization.Diagram.Point(0, 0));
            this.diagram._setZorder(this.helper);
            this.helper.name = "helper";
            this.helper._connectorType = "helper";
        };
        LineTool.prototype.createConnector = function (startPoint, endPoint) {
            return null;
        };
        LineTool.prototype._renderHelper = function () {
            if (!this.svgHelper) {
                this.svgHelper = ej.datavisualization.Diagram.SvgContext.renderConnector(this.helper, this.diagram._svg, this.diagram._diagramLayer, this.diagram);
                this.svgHelper = this.diagram._svg.document.getElementById(this.helper.name);
                this.svgHelper.setAttribute("pointer-events", "none");
                $(this.diagram._svg.getElementById(this.svgHelper.id)).attr("pointer-events", "none");
                $(this.diagram._svg.getElementById(this.svgHelper.id + "_hitTest")).attr("pointer-events", "none");
            }
        };

        LineTool.prototype._outOfBoundsDrag = function (node, ptX, ptY, isTarget) {
            ptX = ptX ? ptX : 0;
            ptY = ptY ? ptY : 0;
            if (node && ej.datavisualization.Diagram.Util.canMoveOutofBoundary(this.diagram)) {
                var size = this._getPageBounds();
                if (!this.diagram._selectedSymbol && (ptX >= size.width || ptX <= size.x)) {
                    this.updateCursor("not-allowed");
                    return false
                }
                if (!this.diagram._selectedSymbol && (ptY >= size.height || ptY <= size.y)) {
                    this.updateCursor("not-allowed");
                    return false
                }
            }
            else if (node.sourceNode != null && !ej.datavisualization.Diagram.bpmnHelper.canMoveOutofBounds(this.diagram, node, ptX, ptY)) {
                this.updateCursor("not-allowed");
                return false;
            }
            this.updateCursor(this.cursor);
            return true
        };

        LineTool.prototype._updateHelper = function () {
            var points = [];
            var ptStart = this._getStartPoint();
            var ptEnd = this._getCurrentPoint();
            points.push(ptStart);
            points.push(ptEnd);
            if (this._outOfBoundsDrag(this.helper, ptEnd.x, ptEnd.y) && this._outOfBoundsDrag(this.helper, ptStart.x, ptStart.y)) {
                this.diagram._setEndPoint(this.helper, ptStart, false);
                this.diagram._setEndPoint(this.helper, ptEnd, true);
                this._disconnect(this.helper);
                if (this._sourcePossibleConnection) {
                    if (this._sourcePort && ej.datavisualization.Diagram.Util.canConnect(this._sourcePort, true)) {
                        this.helper.sourceNode = this._sourcePossibleConnection.name;
                        this.helper.sourcePort = this._sourcePort.name;
                        this._sourcePossibleConnection.outEdges.push(this.helper.name);
                    }
                    else if (ej.datavisualization.Diagram.Util.canConnect(this._sourcePossibleConnection)) {
                        this.helper.sourceNode = this._sourcePossibleConnection.name;
                        this._sourcePossibleConnection.outEdges.push(this.helper.name);
                    }
                }
                if (this._targetPossibleConnection) {
                    if (this._targetPort && ej.datavisualization.Diagram.Util.canConnect(this._targetPort, true)) {
                        this.helper.targetNode = this._targetPossibleConnection.name;
                        this.helper.targetPort = this._targetPort.name;
                        this._targetPossibleConnection.inEdges.push(this.helper.name);
                    }
                    else if (ej.datavisualization.Diagram.Util.canConnect(this._targetPossibleConnection)) {
                        this.helper.targetNode = this._targetPossibleConnection.name;
                        this._targetPossibleConnection.inEdges.push(this.helper.name);
                    }
                }
                this.diagram._dock(this.helper, this.diagram.nameTable);
            }
            ej.datavisualization.Diagram.SvgContext.update(this.helper, this.diagram);
        };
        LineTool.prototype._endAction = function () {
            base.prototype._endAction.apply(this);
            this._targetPossibleConnection = null;
            this._sourcePossibleConnection = null;
            this._targetPort = null;
            this._sourcePort = null;
            this._isMouseDown = false;
        };
        LineTool.prototype._showPorts = function (node) {
        };
        LineTool.prototype._showAllPorts = function (hide) {
            base.prototype._showAllPorts.call(this, hide);
        };
        return LineTool;
    })(ToolBase);

    ej.datavisualization.Diagram.LineTool = LineTool;
    //#endregion

    //#region StraightLineTool
    var StraightLineTool = (function (base) {
        ej.datavisualization.Diagram.extend(StraightLineTool, base);
        function StraightLineTool(diagram) {
            base.call(this, "straightLine", diagram);
        }
        StraightLineTool.prototype.createConnector = function (startPoint, endPoint) {
            var connector = { "segments": [{ "type": "straight" }], "sourcePoint": startPoint, "targetPoint": endPoint };
            return this.diagram._getNewConnector($.extend(true, {}, connector, this.diagram.model.drawType));
        };
        return StraightLineTool;
    })(LineTool);

    ej.datavisualization.Diagram.StraightLineTool = StraightLineTool;
    //#endregion

    //#region OrthogonalLineTool
    var OrthogonalLineTool = (function (base) {
        ej.datavisualization.Diagram.extend(OrthogonalLineTool, base);
        function OrthogonalLineTool(diagram) {
            base.call(this, "orthogonalLine", diagram);
        }
        OrthogonalLineTool.prototype.createConnector = function (startPoint, endPoint) {
            var connector = { "segments": [{ "type": "orthogonal" }], "sourcePoint": startPoint, "targetPoint": endPoint };
            return this.diagram._getNewConnector($.extend(true, {}, connector, this.diagram.model.drawType));
        };
        return OrthogonalLineTool;
    })(LineTool);

    ej.datavisualization.Diagram.OrthogonalLineTool = OrthogonalLineTool;
    //#endregion

    //#region BezierLineTool
    var BezierLineTool = (function (base) {
        ej.datavisualization.Diagram.extend(BezierLineTool, base);
        function BezierLineTool(diagram) {
            base.call(this, "bezierLine", diagram);
        }
        BezierLineTool.prototype.createConnector = function (startPoint, endPoint) {
            var connector = { "segments": [{ "type": "bezier" }], "sourcePoint": startPoint, "targetPoint": endPoint };
            return this.diagram._getNewConnector($.extend(true, {}, connector, this.diagram.model.drawType));
        };
        return BezierLineTool;
    })(LineTool);
    ej.datavisualization.Diagram.BezierLineTool = BezierLineTool;
    //#endregion

    //#region RotateTool
    var RotateTool = (function (base) {
        ej.datavisualization.Diagram.extend(RotateTool, base);
        function RotateTool(diagram) {
            base.call(this, "rotatetool", diagram);
            this._mouseOffset = ej.datavisualization.Diagram.Size(0, 0);
            this.undoObject = null;
        }
        RotateTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            this.selectedObject = this.diagram.selectionList[0];
            //this.undoObject = ej.datavisualization.Diagram.Util.clone(this.selectedObject);

            var data;
            var childTable = {};
            if (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup")
                childTable = this.diagram._getChildTable(this.selectedObject, childTable);
            var temp = { "childTable": childTable, "node": this.selectedObject };
            data = $.extend(true, {}, temp);
            this.undoObject = jQuery.extend(true, {}, data);

            var scale = this.diagram._currZoom;
            //ej.datavisualization.Diagram.SvgContext.renderPivotPoint(this.selectedObject, this.diagram._currZoom, this.diagram._svg);

        };
        RotateTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            var start = !this.inAction;
            if (this.selectedObject) {
                if (!this.inAction) {
                    if (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup") {
                        var children = this.diagram._getChildren(this.selectedObject.children);
                        for (var i = 0; i < children.length; i++) {
                            var child = this.diagram.nameTable[children[i]];
                            if (!child.segments)
                                if (!ej.datavisualization.Diagram.Util.canRotate(child)) return;
                        }
                    }
                    this._initialValue = this.selectedObject.rotateAngle;
                    this.inAction = true;
                }
                {
                    var isContainer = false;
                    if (this.selectedObject.parent) {
                        var parent = this.diagram.nameTable[this.selectedObject.parent];
                        if (parent.container) {
                            isContainer = true;
                        }
                    }
                    else if (this.selectedObject.type == "pseudoGroup" && this._fromContainer(this.diagram._getChildren(this.selectedObject.children))) {
                        isContainer = true;
                    }
                    if (isContainer) {
                        if (this.selectedObject.type == "pseudoGroup" && this._isParentAsLane(this.selectedObject)) {
                            ej.datavisualization.Diagram.canvasHelper._removeFromParentContainer(this.diagram, this.selectedObject);
                            this._rotate(this.selectedObject);
                            if (this.selectedObject.parent) {
                                ej.datavisualization.Diagram.Util._updateGroupBounds(this.diagram.nameTable[this.selectedObject.parent], this.diagram);
                            }
                        }
                        else {
                            if (!this.helper) {
                                this.helper = this._getCloneNode(this.selectedObject);
                                this.helper.inEdges = this.helper.outEdges = [];
                                this.helper.type = null;
                                this.helper.name = "helper";
                            }
                            this._rotate(this.helper);
                            ej.datavisualization.Diagram.SvgContext._drawContainerHelper(this.diagram);
                        }
                    }

                    else {
                        if (this.selectedObject.type == "pseudoGroup" && this._fromContainer(this.diagram._getChildren(this.selectedObject.children))) {// && this._fromContainer(this.selectedObject.children) && this.hasSameParent()) {
                            if (this._fromContainer(this.diagram._getChildren(this.selectedObject.children))) {
                                this._rotate(this.selectedObject);
                                if (this.selectedObject.parent) {
                                    ej.datavisualization.Diagram.Util._updateGroupBounds(this.diagram.nameTable[this.selectedObject.parent], this.diagram);
                                }
                                ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                                this.diagram._updateSelectionHandle(true);
                                this.diagram._renderTooltip(this.selectedObject, start);
                            }
                        }
                        else {
                            if (this.selectedObject.type === "pseudoGroup")
                                this._updateMultipleUndoObject(this.selectedObject);
                            this._rotate(this.selectedObject);
                            if (this.selectedObject.parent) {
                                ej.datavisualization.Diagram.Util._updateGroupBounds(this.diagram.nameTable[this.selectedObject.parent], this.diagram);
                            }
                            ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);
                            this.diagram._updateSelectionHandle(true);
                            this.diagram._renderTooltip(this.selectedObject, start);
                        }
                    }
                }
            }
            this.previousPoint = this.currentPoint;
        };
        RotateTool.prototype._rotate = function (node) {
            var cancel = false;
            var oldbounds, newbounds;
            var pt = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
            var crntpoint = this.currentPoint;
            var angle = ej.datavisualization.Diagram.Geometry.findAngle(ej.datavisualization.Diagram.Point(pt.x, pt.y), crntpoint) + 90;
            angle = ej.datavisualization.Diagram.SnapUtil._snapAngle(this.diagram, angle) - node.rotateAngle;
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            oldbounds = ej.datavisualization.Diagram.Rectangle(bounds.left, bounds.top, bounds.right - bounds.left, bounds.bottom - bounds.top);
            var oldValue = { bounds: oldbounds, offsetX: node.offsetX, offsetY: node.offsetY, width: node.width, height: node.height };
            this.diagram._comparePropertyValues(node, "rotateAngle", { rotateAngle: angle }, true);
            this.diagram._rotate(node, angle, this.diagram.nameTable);
            bounds = ej.datavisualization.Diagram.Util.bounds(node);
            newbounds = ej.datavisualization.Diagram.Rectangle(bounds.left, bounds.top, bounds.right - bounds.left, bounds.bottom - bounds.top);
            var newValue = { bounds: newbounds, offsetX: node.offsetX, offsetY: node.offsetY, width: node.width, height: node.height };
            var args = this._raiseEvent("rotationChange", { element: this.diagram.getNode(node), angle: node.rotateAngle, oldValue: oldValue, newValue: newValue, cancel: false });
            if (args.cancel)
                this.diagram._rotate(node, -angle, this.diagram.nameTable);
        };
        RotateTool.prototype.mouseup = function (evt) {
            if (this.inAction) {
                this.inAction = false;
                var isContainer = false;
                var rotateState = true;
                var canvasChild = false;
                if (this.selectedObject.parent) {
                    var parent = this.diagram.nameTable[this.selectedObject.parent];
                    if (parent.container) {
                        isContainer = true;
                    }
                }
                else if (this.selectedObject.type == "pseudoGroup" && this.hasSameParent() && this._fromContainer(this.diagram._getChildren(this.selectedObject.children))) {
                    var fNode = this.diagram.nameTable[this.diagram._getChild(this.selectedObject.children[0])];
                    parent = this.diagram.nameTable[fNode.parent];
                    if (parent.container) {
                        isContainer = true;
                    }
                }
                if ((this.selectedObject.type == "pseudoGroup" || this.selectedObject.name == "multipleSelection") && this.diagram._activeSwimLane) {
                    ej.datavisualization.Diagram.canvasHelper._multiNodeRotate(this.diagram, evt, this.selectedObject);
                }
                else if (isContainer) {
                    ej.datavisualization.Diagram.SvgContext._removeContainerHelper(this.selectedObject, this.diagram._adornerSvg, this.diagram._adornerLayer);
                    this._removeHighLighter(); //ej.datavisualization.Diagram.SvgContext._removeNodeHighlighter(this.diagram._svg, this.diagram._adornerLayer);
                    if (parent.container.type == "canvas")
                        canvasChild = true;
                    if (canvasChild) {
                        if (ej.datavisualization.Diagram.canvasHelper._outOfBoundaryNodeDrop(this.diagram, this.diagram.activeTool.helper, parent)) {
                            ej.datavisualization.Diagram.canvasHelper._singleNodeRotate(this.diagram, evt, this.selectedObject);
                        }
                        else {
                            rotateState = false;
                        }
                    }
                }
                if (this.selectedObject.type != "pseudoGroup") {
                    if (rotateState)
                        this._rotate(this.selectedObject);
                }
                else {
                    if (!this._fromContainer(this.diagram._getChildren(this.selectedObject.children)))
                        this._rotate(this.selectedObject);
                }
                ej.datavisualization.Diagram.DiagramContext.update(this.selectedObject, this.diagram);

                var data;
                var childTable = {};
                if (this.selectedObject._type === "group" || this.selectedObject.type === "pseudoGroup")
                    childTable = this.diagram._getChildTable(this.selectedObject, childTable);
                var temp = { "childTable": childTable, "node": this.selectedObject };
                data = $.extend(true, {}, temp);
                var entry = { type: "rotationchanged", undoObject: this.undoObject, redoObject: jQuery.extend(true, {}, data), isMultipleNode: (this.selectedObject._type === "group") ? true : false, category: "internal" };
                if (!this._multipleUndo)
                    this.diagram.addHistoryEntry(entry);
                if (this.selectedObject)
                    ej.datavisualization.Diagram.SvgContext._removePivotPoint(this.selectedObject, this.diagram._adornerSvg, this.diagram._currZoom);
                this.diagram._updateSelectionHandle();
                this.diagram._removeTooltip();
            }
            this._multipleUndo = false;
            //this.diagram._removeTooltip(); 
            base.prototype.mouseup.call(this, evt);
        };
        return RotateTool;
    })(ToolBase);

    ej.datavisualization.Diagram.RotateTool = RotateTool;
    //#endregion 

    //#region PivotTool
    var PivotTool = (function (base) {
        ej.datavisualization.Diagram.extend(PivotTool, base);
        function PivotTool(diagram) {
            base.call(this, "PivotTool", diagram);
            this._mouseOffset = ej.datavisualization.Diagram.Size(0, 0);
        }
        PivotTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            this.selectedObject = this.diagram.selectionList[0];
        };
        PivotTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);

            if (this.selectedObject) {
                if (!this.inAction) {
                    this.inAction = true;
                }
                else {
                    var delx = this.currentPoint.x - this.previousPoint.x;
                    var dely = this.currentPoint.y - this.previousPoint.y;
                    var matrix = ej.Matrix.identity();
                    ej.Matrix.rotate(matrix, -this.selectedObject.rotateAngle);
                    var delta = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(delx, dely));
                    var difx = (this.selectedObject.width * this.selectedObject.pivot.x + delta.x) / this.selectedObject.width;
                    var dify = (this.selectedObject.height * this.selectedObject.pivot.y + delta.y) / this.selectedObject.height;
                    this.selectedObject.pivot.x = difx;
                    this.selectedObject.pivot.y = dify;
                    this.selectedObject.offsetX += delx;
                    this.selectedObject.offsetY += dely;
                    this.diagram._updateSelectionHandle();
                }
            }
            this.previousPoint = this.currentPoint;
        };
        PivotTool.prototype._rotate = function (node) {
            var pt = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY);
            var crntpoint = this.currentPoint;
            var angle = this.FindAngle(pt, crntpoint);
            this.diagram._rotate(node, angle - node.rotateAngle, pt, this.diagram.nameTable);
        };
        PivotTool.prototype.mouseup = function (evt) {
            if (this.inAction) {
                this.inAction = false;
                this.diagram._updateSelectionHandle();
            }
            base.prototype.mouseup.call(this, evt);
        };
        return PivotTool;
    })(ToolBase);
    ej.datavisualization.Diagram.PivotTool = PivotTool;
    //#endregion

    //#region PanTool
    var PanTool = (function (base) {
        ej.datavisualization.Diagram.extend(PanTool, base);
        function PanTool(diagram) {
            base.call(this, "panTool", diagram);
            this.diagram = diagram;
            this._isMouseDown = false;
            this.cursor = "pointer";
        }
        PanTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            var svgDocument = this.diagram._svg.document;
            var pt = this.diagram._svg.document.createSVGPoint();
            var originalEvent = this.diagram._isTouchEvent(evt);
            pt.x = originalEvent.clientX;
            pt.y = originalEvent.clientY;
            var mousept = pt.matrixTransform(this.diagram._svg.document.getScreenCTM().inverse());
            svgDocument.lastMouseX = mousept.x;
            svgDocument.lastMouseY = mousept.y;
            this._isMouseDown = true;
            return false;
        };

        PanTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            if (this._isMouseDown && (this.startPoint.x != this.currentPoint.x || this.startPoint.y != this.currentPoint.y)) {
                this.inAction = true;
                var svgDocument = this.diagram._svg.document;
                var pt = this.diagram._svg.document.createSVGPoint();
                var originalEvent = this.diagram._isTouchEvent(evt);
                pt.x = originalEvent.clientX;
                pt.y = originalEvent.clientY;
                var mousept = pt.matrixTransform(this.diagram._svg.document.getScreenCTM().inverse());
                var ex = mousept.x;
                var ey = mousept.y;
                var nx, ny;

                nx = ((ex - svgDocument.lastMouseX));
                ny = ((ey - svgDocument.lastMouseY));
                if (!(this.diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.PannableX))
                    nx = 0;
                if (!(this.diagram.model.constraints & ej.datavisualization.Diagram.DiagramConstraints.PannableY))
                    ny = 0;
                ej.datavisualization.Diagram.ZoomUtil.zoomPan(this.diagram, 1, nx, ny, ej.datavisualization.Diagram.Point(ex, ey));
                svgDocument.lastMouseX = ex;
                svgDocument.lastMouseY = ey;
                return false;
            }
        };
        PanTool.prototype.mouseup = function (evt) {
            this.inAction = false;
            document.onmousemove = null;
            document.onmouseup = null;
            this._isMouseDown = false;
            this.diagram._removeTooltip();
            if (!this.diagram._isEditing && !this.diagram._isDragg)
                this.diagram._endEdit();
            delete this.hoverNode;
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            base.prototype.mouseup.call(this, evt);
        };
        return PanTool;
    })(ToolBase);
    ej.datavisualization.Diagram.PanTool = PanTool;
    //#endregion

    //#region TextToolBase
    var TextToolBase = (function (base) {
        ej.datavisualization.Diagram.extend(TextToolBase, base);
        function TextToolBase(name, diagram) {
            base.call(this, name, diagram);
            this.boundingRect = ej.datavisualization.Diagram.Rectangle();
            this.activeLabel = null;
            this._overNode = "";
            this.cursor = "crosshair";
        }
        TextToolBase.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            this._findNodeUnderMouse(evt);
            var overNode = this._getNodeUnderMouse();
            if (overNode) this._overNode = (this.selectedObject && !this.selectedObject.isLane || overNode.isLane) ? overNode.name : "";
            if (this.diagram._isEditing) {
                this.diagram._endEdit();
            }
        };
        TextToolBase.prototype.createNode = function (rect) {

        };
        TextToolBase.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            if (ej.datavisualization.Diagram.Util.isPageEditable(this.diagram)) {
                if (!this.selectedObject && !ej.datavisualization.Diagram.Geometry.isEmptyPoint(this.startPoint) && !this.diagram._isEditing) {
                    if (!this.inAction) {
                        this.inAction = true;
                        this._initHelper();
                    }
                    else {
                        this._updateHelper();
                    }
                }
            }
        };
        TextToolBase.prototype.mouseup = function (evt) {
            this.activeLabel = null;
            var minHeight = 12;
            if (this.inAction) {
                var rect = this.getBoundingRect(this.startPoint, this.currentPoint);
                this._endAction();
                if (rect.width === 0 || rect.height === 0) {
                    rect.width = 90;
                    rect.height = minHeight;
                }
                this.selectedObject = this.createNode(rect.x + (rect.width / 2), (rect.y + (rect.height / 2)), rect.width, rect.height);
                this.diagram._startEdit(this.selectedObject);
            }
            else {
                var node = this._findNodeUnderMouse(evt);
                if (ej.datavisualization.Diagram.Util.isPageEditable(this.diagram)) {
                    if (node != null && !node.isSwimlane && !node.isLane) {
                        this.selectedObject = node;
                        this.diagram._startEdit(this.selectedObject);
                    }
                    else {
                        var rect = ej.datavisualization.Diagram.Rectangle(this.currentPoint.x - (90 / 2), this.currentPoint.y - (minHeight / 2), 90, minHeight);
                        this._endAction();
                        this.selectedObject = this.createNode(rect.x + (rect.width / 2), rect.y + (rect.height / 2), rect.width, minHeight);
                        this.diagram._startEdit(this.selectedObject);
                    }
                }
            }
            this._overNode = "";
        };
        TextToolBase.prototype.getBoundingRect = function (startPoint, currentPoint) {
            var startPoint = this.snap(this.startPoint);
            var currentPoint = this.snap(this.currentPoint);
            var width = Math.abs(startPoint.x - currentPoint.x);
            var height = Math.abs(startPoint.y - currentPoint.y);
            var x = (startPoint.x > currentPoint.x) ? currentPoint.x : startPoint.x;
            var y = (startPoint.y > currentPoint.y) ? currentPoint.y : startPoint.y;
            return { x: x, y: y, width: width, height: height };
        };
        TextToolBase.prototype._initHelper = function () {
            if (!this._svgHelper) {
                var g = this.diagram._adornerSvg.g();
                this.diagram._adornerLayer.appendChild(g);
                var scale = this.diagram._currZoom;
                var selectionRect = this.diagram._svg.rect({ "id": "helper", "x": this.startPoint.x * scale, "y": this.startPoint.y * scale, "fill": "transparent", "stroke": "gray", "stroke-dasharray": "2 2", "shape-rendering": "crispEdges" });
                g.appendChild(selectionRect);
                g.setAttribute("pointer-events", "none");
                this._svgHelper = g;
            }
        };
        TextToolBase.prototype._updateHelper = function () {
            var startPoint = this.snap(this.startPoint);
            var currentPoint = this.snap(this.currentPoint);
            var helper = this.diagram._adornerSvg.getElementById("helper");
            var width = Math.abs(startPoint.x - currentPoint.x);
            var height = Math.abs(startPoint.y - currentPoint.y);
            var scale = this.diagram._currZoom;
            var x = ((startPoint.x > currentPoint.x) ? currentPoint.x : startPoint.x) * scale;
            var y = ((startPoint.y > currentPoint.y) ? currentPoint.y : startPoint.y) * scale;
            if (helper) {
                this.diagram._adornerSvg.rect({ "id": helper.id, "x": x, "y": y, "width": width * scale, "height": height * scale });
            }
        };
        TextToolBase.prototype._endAction = function () {
            if (this._svgHelper) {
                this.diagram._adornerLayer.removeChild(this._svgHelper);
                this._svgHelper = null;
            }
            base.prototype._endAction.apply(this);
        };
        TextToolBase.prototype._findNodeUnderMouse = function (evt, skip) {
            var obj;
            var foreignObject = this.diagram._isForeignObject(evt.target);
            if (foreignObject)
                evt.target = foreignObject;
            var textElement = evt.target;
            if (textElement.getAttribute("class") == "ej-d-label") {
                var parentNode = $(textElement).parents(".ej-d-node,.ej-d-connector,.ej-d-group")[0];
                obj = this._findObj(parentNode);
                this.activeLabel = this.diagram._findLabelAtPoint(this.currentPoint, obj);
            }
            else {
                var parents = $(evt.target).parents("g");
                if (parents.length > 3) {
                    var element = parents[parents.length - 4];
                    var id = element.getAttribute("id");
                    var type = element.getAttribute("class");
                    if (type) {
                        if (type === "ej-d-node" || type === "ej-d-group") {
                            obj = this.diagram._findNode(id);
                            var curlabel = this.diagram._findLabelAtPoint(this.currentPoint, obj);
                            this.activeLabel = curlabel;
                        }
                        else if (type === "ej-d-connector") {
                            obj = this.diagram._findConnector(id);
                            var curlabel = this.diagram._findLabelAtPoint(this.currentPoint, obj);
                            this.activeLabel = curlabel;
                        }
                    }
                }
            }
            return obj;
        };
        return TextToolBase;
    })(ej.datavisualization.Diagram.ToolBase);
    ej.datavisualization.Diagram.TextToolBase = TextToolBase;
    //#endregion

    //#region TextTool
    var TextTool = (function (base) {
        ej.datavisualization.Diagram.extend(TextTool, base);
        function TextTool(diagram) {
            base.call(this, "textTool", diagram);
        }
        TextTool.prototype.createNode = function (x, y, width, height) {
            var textnode = { "offsetX": x, "offsetY": y, "width": width, "height": height, "parent": this._overNode, "labels": [], "ports": [], "type": "text" };
            var node = this.diagram._getNewNode($.extend(true, {}, textnode, this.diagram.model.drawType));
            if (this.diagram.model.drawType.name) {
                node.name = this.diagram.model.drawType.name + ej.datavisualization.Diagram.Util.randomId();
            }
            else {
                node.name = "text" + ej.datavisualization.Diagram.Util.randomId();
            }
            if (node._type = "text") node._type = "node";
            var parent = this.diagram.nameTable[node.parent];
            if (parent && parent.container)
                this._updateMargin(node, parent);
            return node;
        };
        return TextTool;
    })(ej.datavisualization.Diagram.TextToolBase);
    ej.datavisualization.Diagram.TextTool = function (diagram) {
        return new TextTool(diagram);
    };
    //#endregion

    //#region PhaseTool
    var PhaseTool = (function (base) {
        ej.datavisualization.Diagram.extend(PhaseTool, base);
        function PhaseTool(diagram) {
            base.call(this, "phase", diagram);
            this.selectedSeperator = null;
            this._svgHelper = null;
        }
        PhaseTool.prototype.mousedown = function (evt) {
            base.prototype.mousedown.call(this, evt);
            this.inAction = true;
            this.diagram._selectedGNode = null;
        };
        PhaseTool.prototype._getSeperator = function (evt) {
            if ($(evt.target).parents("g").first()[0]) {
                var id = $(evt.target).parents("g").first()[0].id;
                if (id) {
                    return this._getphase(id.split('_phase_g')[0]);
                }
            }
        };
        PhaseTool.prototype._removePhasehelper = function () {
            ej.datavisualization.Diagram.SvgContext._removePhasehelper(this.diagram);
        };
        PhaseTool.prototype._outOfBoundsDrag = function (node) {
            var diffX = this.currentPoint.x - this.startPoint.x;
            var diffY = this.currentPoint.y - this.startPoint.y;
            if (node && ej.datavisualization.Diagram.Util.canMoveOutofBoundary(this.diagram)) {
                var size = this._getPageBounds();
                var parent = this.diagram.nameTable[node.parent];
                if (parent) {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(parent)
                    if (!this.diagram._selectedSymbol && (bounds.right + diffX >= size.width || node.offset + diffX < size.x)) {
                        this.updateCursor("not-allowed")
                        return false
                    }
                    if (!this.diagram._selectedSymbol && (bounds.bottom + diffY >= size.height || node.offset + diffY < size.y)) {
                        this.updateCursor("not-allowed")
                        return false
                    }
                }
                node.orientation == "horizontal" ? this.updateCursor("e-resize") : this.updateCursor("n-resize");
            }


            return true
        };
        PhaseTool.prototype._updatePhasehelper = function (phase) {
            var bounds = this._bounds ? jQuery.extend(true, {}, this._bounds) : this.diagram._getPhaseBounds(phase), dx, dy;
            var ptSrt = this.startPoint;
            var ptCur = this.currentPoint;
            var horizontalsnap = { snapped: false, offset: 0, left: false, right: false };
            var verticalsnap = { snapped: false, offset: 0, top: false, bottom: false };
            this.selectedObject = this.diagram.nameTable[this.selectedSeperator.parent];
            this.initialBounds = { width: this.selectedObject.width, height: this.selectedObject.height, y: this.selectedObject.offsetY, x: this.selectedObject.offsetX };

            if (phase.orientation === "horizontal") {
                dx = ptCur.x - ptSrt.x;
                dx = this._snapRight(horizontalsnap, verticalsnap, dx, 0, this.selectedObject, false);
                dy = 0;
                this.diagram._comparePropertyValues(phase, "offset", { offset: phase.offset + dx }, true);
            }
            else {
                dx = 0;
                dy = ptCur.y - ptSrt.y;
                dy = this._snapBottom(horizontalsnap, verticalsnap, 0, dy, this.selectedObject, false);
                this.diagram._comparePropertyValues(phase, "offset", { offset: phase.offset + dy }, true);
            }
            if (bounds) {
                bounds.width += dx;
                bounds.height += dy;
                this._helperBounds = $.extend(true, {}, bounds);
                ej.datavisualization.Diagram.SvgContext._updatePhaseHelper(this.diagram, phase, bounds);
            }
        };
        PhaseTool.prototype._drawPhasehelper = function (phase) {
            var bounds = this.diagram._getPhaseBounds(phase);
            if (phase && bounds)
                ej.datavisualization.Diagram.SvgContext._phasehelper(this.diagram, phase, bounds);
        };
        PhaseTool.prototype.mousemove = function (evt) {
            base.prototype.mousemove.call(this, evt);
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            if (this._outOfBoundsDrag(this.selectedSeperator)) {
                if (!this.selectedSeperator) {
                    if (this.inAction) {
                        var phase = this._getSeperator(evt);
                        if (phase && !this.selectedSeperator) {
                            this.selectedSeperator = phase;
                        }
                    }
                    this._drawPhasehelper(this.selectedSeperator);
                    if (this.diagram.selectionList[0] && this.diagram.selectionList[0].type != "phase") {
                        this.diagram._clearSelection(true);
                        this.diagram.addSelection(this.selectedSeperator, true);
                    }
                    else
                        this.diagram.addSelection(this.selectedSeperator, true);
                }
                else if (this.selectedSeperator) {
                    if (!this._bounds)
                        this._bounds = this.diagram._getPhaseBounds(this.selectedSeperator);
                    this._updatePhasehelper(this.selectedSeperator);
                }
                this.previousPoint = this.currentPoint;
            }
        };
        PhaseTool.prototype._getPadding = function (swimlane) {
            var xpad = 20, ypad = 20;
            var laneStack = this.diagram.nameTable[this.diagram._getChild(swimlane.children[swimlane.children.length - 1])];
            if (laneStack) {
                var lanes = laneStack.children;
                if (lanes.length > 0) {
                    var lane = this.diagram.nameTable[this.diagram._getChild(lanes[0])];
                    if (lane && lane.isLane) {
                        xpad = lane.paddingRight;
                        ypad = lane.paddingBottom;
                    }
                }
            }
            return { x: xpad, y: ypad };
        };
        PhaseTool.prototype.mouseup = function (evt) {
            var phase = this._getSeperator(evt);

            if (this.diagram.selectionList.length > 0 && phase && this.diagram.selectionList[0].name != phase.name)
                this.diagram._clearSelection(true);
            if (phase && !this.selectedSeperator) {
                this.selectedSeperator = phase;
                this.diagram.addSelection(this.selectedSeperator, true);
            }
            else {
                if (this.selectedSeperator) {
                    var swimlaneName = this.selectedSeperator.parent.split('phaseStack')[0];
                    if (swimlaneName) {
                        var swimlane = this.diagram.nameTable[swimlaneName];
                        if (swimlane && this._helperBounds) {
                            if (swimlane.isSwimlane) {
                                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(this.diagram, swimlane);
                                var prevOffset = 0;
                                var index = phases.indexOf(this.selectedSeperator.name);
                                if (index > 0) {
                                    prevOffset = this.diagram.nameTable[phases[index - 1]].offset;
                                }
                                else {
                                    if (swimlane.orientation === "horizontal")
                                        prevOffset = 50;
                                }

                                var undoObject = jQuery.extend(true, {}, this.selectedSeperator);
                                if (swimlane.orientation === "horizontal")
                                    this.diagram._updatePhase({ name: this.selectedSeperator.name, offset: prevOffset + this._helperBounds.width })
                                else
                                    this.diagram._updatePhase({ name: this.selectedSeperator.name, offset: prevOffset + this._helperBounds.height })
                                var entry = { type: "phasepositionchanged", undoObject: jQuery.extend(true, {}, undoObject), redoObject: jQuery.extend(true, {}, jQuery.extend(true, {}, this.selectedSeperator)), category: "internal" };
                                if (!this._multipleUndo)
                                    this.diagram.addHistoryEntry(entry);
                                this.diagram.addSelection(this.selectedSeperator, true);
                            }
                        }
                    }
                }
            }

            this._removePhasehelper();
            this._bounds = null;
            this.inAction = false;
            this.selectedSeperator = null;
            ej.datavisualization.Diagram.SnapUtil._removeGuidelines(this.diagram);
            base.prototype.mouseup.call(this, evt);
        };
        PhaseTool.prototype._getOuterPhaseNodes = function (group, isVertical) {
            if (group) {
                var stack = this.diagram.nameTable[this.diagram._getChild(group.children[2])];
                var tchildren = [];
                var tchild = null;
                var bounds = null;
                var laneChild = null
                for (var i = 0; stack && i < stack.children.length; i++) {
                    var lane = this.diagram.nameTable[this.diagram._getChild(stack.children[i])];
                    if (lane && lane.children && lane.children.length > 1) {
                        for (var j = 0; j < lane.children.length; j++) {
                            laneChild = this.diagram.nameTable[this.diagram._getChild(lane.children[j])];
                            if (laneChild) {
                                bounds = ej.datavisualization.Diagram.Util.bounds(laneChild);
                                if (isVertical) {
                                    if (bounds.y > ((group.offsetY - group.height / 2) + this.selectedSeperator.offset))
                                        tchildren.push(laneChild);
                                }
                                else {
                                    if (bounds.x > ((group.offsetX - group.width / 2) + this.selectedSeperator.offset))
                                        tchildren.push(laneChild);
                                }
                            }
                        }
                    }
                }
            }
            return tchildren;
        };
        return PhaseTool;
    })(ToolBase);
    ej.datavisualization.Diagram.PhaseTool = PhaseTool;
    //#endregion
})(jQuery, Syncfusion);;
(function ($, ej) {
    "use strict";
    ej.datavisualization.Diagram.LayoutTypes = {
        None: "none",
        HierarchicalTree: "hierarchicaltree",
        OrganizationalChart: "organizationalchart",
        RadialTree: "radialtree"
    };
    ej.datavisualization.Diagram.ChartOrientations = {
        Horizontal: "horizontal",
        Vertical: "vertical"
    };
    ej.datavisualization.Diagram.ChartTypes = {
        Left: "left",
        Right: "right",
        Alternate: "alternate",
        Center: "center"
    };

    ej.datavisualization.Diagram.Layout = {
        doLayout: function (diagram, updateView) {
            var model = diagram.model;
            var layout = {
                diagram: diagram, _anchorX: 0, _anchorY: 0, _graphNodes: {},
                _firstLevelNodes: [], _centerNode: null, levels: [], maxLevel: 0, layoutNodes: [],
            };
            for (var prop in model.layout) {
                if (prop == "type") layout.type = diagram._layoutType();
                else if (prop == "orientation") layout.orientation = diagram._layoutOrientation();
                else if (prop == "fixedNode") layout.fixedNode = diagram._fixedNode();
                else if (prop == "horizontalSpacing") layout.horizontalSpacing = Number(diagram._horizontalSpacing());
                else if (prop == "verticalSpacing") layout.verticalSpacing = Number(diagram._verticalSpacing());
                else if (prop == "marginX") layout.marginX = Number(diagram._layoutMarginX());
                else if (prop == "marginY") layout.marginY = Number(diagram._layoutMarginY());
                else if (prop == "getLayoutInfo") {
                    if (typeof model.layout.getLayoutInfo === "string") {
                        layout.getLayoutInfo = ej.util.getObject(model.layout.getLayoutInfo, window);
                    }
                    else
                        if ($.isFunction(model.layout.getLayoutInfo)) {
                            layout.getLayoutInfo = model.layout.getLayoutInfo;
                        }
                }
                else if (prop == "getConnectorSegments") {
                    if (typeof model.layout.getConnectorSegments === "string") {
                        layout.getConnectorSegments = ej.util.getObject(model.layout.getConnectorSegments, window);
                    }
                    else
                        if ($.isFunction(model.layout.getConnectorSegments)) {
                            layout.getConnectorSegments = model.layout.getConnectorSegments;
                        }
                }
                else layout[prop] = model.layout[prop];
            }
            layout.updateView = updateView === undefined ? true : layout.updateView;
            layout.objects = [];
            if (layout.type != "radialtree")
                ej.datavisualization.Diagram.HierarchicalLayout.doLayout(layout);
            else
                ej.datavisualization.Diagram.RadialTreeLayout.doLayout(layout);

            if (!layout.updateView) return layout.objects;
        }
    };

    //region Hierarchical layout
    ej.datavisualization.Diagram.HierarchicalLayout = {
        doLayout: function (layout) {
            var diagram, model, nodes, node, layoutInfo, i;
            diagram = layout.diagram
            model = diagram.model;
            nodes = diagram.nodes();
            if (nodes.length > 0) {
                for (var i = 0; i < nodes.length; i++) {
                    node = nodes[i];
                    if (!node.excludeFromLayout) {
                        layoutInfo = layout._graphNodes[node.name] = this._setUpLayoutInfo(layout, node);
                        layoutInfo.tree.hasSubTree = false;
                        if (!node.inEdges || !node.inEdges.length) { layout._firstLevelNodes.push(node); }
                    }
                }

                //Update relationship(parent and children)
                for (i = 0; i < layout._firstLevelNodes.length; i++) {
                    node = layout._firstLevelNodes[i];
                    this._updateEdges(layout, node, 1);
                }
                if (layout._firstLevelNodes.length > 0) {
                    layout._rootNode = layout._firstLevelNodes[0];
                    var bounds, x = 0, y = 0, minX, maxX, minY, maxY;
                    for (i = 0; i < layout._firstLevelNodes.length; i++) {
                        bounds = this._updateTree(layout, x, y, layout._firstLevelNodes[i], 0, layout._firstLevelNodes[i - 1]);
                        var rootInfo = layout._graphNodes[layout._firstLevelNodes[i].name];
                        if (rootInfo.y < bounds.y) bounds.y = rootInfo.y;
                        if (rootInfo.x < bounds.x) bounds.x = rootInfo.x;
                        if (layout.orientation == "lefttoright" || layout.orientation == "righttoleft") y = bounds.right + layout.horizontalSpacing;
                        else x = bounds.right + layout.horizontalSpacing;
                        if (i == 0) { minX = bounds.x; minY = bounds.y; maxX = bounds.right; maxY = bounds.bottom; }
                        else {
                            minX = Math.min(minX, bounds.x); minY = Math.min(minY, bounds.y); maxX = Math.max(maxX, bounds.right); maxY = Math.max(maxY, bounds.bottom);
                        }
                    }
                    this._updateAnchor(layout, { x: minX, y: minY, right: maxX, bottom: maxY });
                    diagram._layoutInAction = true;
                    for (i = 0; i < layout._firstLevelNodes.length; i++) {
                        this._updateNodes(layout, layout._firstLevelNodes[i], 0);
                    }
                    diagram._layoutInAction = false;
                    if (!layout.updateView) diagram._internalLayout = layout;
                    if (layout.updateView) {
                        for (i = 0; i < layout._firstLevelNodes.length; i++) {
                            this._updateConnectors(layout, layout._firstLevelNodes[i], 1);
                        }
                        for (var j = 0; j < layout.diagram.model.connectors.length; j++) {
                            delete layout.diagram.model.connectors[j]._visited;
                        }
                        for (var j = 0; j < layout.diagram.model.nodes.length; j++) {
                            delete layout.diagram.model.nodes[j]._visited1;
                            delete layout.diagram.model.nodes[j]._isRightAdded;
                        }
                    }
                }
            }
            delete layout.diagram.minSpaceBetweenNode;
        },

        _getGroupBounds: function (children, layout, mod) {
            var bounds = ej.datavisualization.Diagram.Rectangle(), child;
            for (var i = 0, len = children.length; i < len; i++) {
                child = layout.diagram.nameTable[layout.diagram._getChild(children[i])];
                if (child) {
                    var rect;
                    if (child._visited)
                        rect = ej.datavisualization.Diagram.Util.bounds(child);
                    else {
                        var width = child.width ? child.width : child._width || 0;
                        var height = child.height ? child.height : child._height || 0;
                        var offsetX = layout._anchorX;
                        var offsetY = layout._anchorY;
                        var mod1 = 0;// + (layout._graphNodes[child.name].subTreeTranslation || 0);
                        if (layout.orientation == "lefttoright") {
                            offsetX += layout._graphNodes[child.name].y + width / 2;
                            offsetY += layout._graphNodes[child.name].x + mod1 + height / 2;
                        }
                        else if (layout.orientation == "righttoleft") {
                            offsetX -= layout._graphNodes[child.name].y + width / 2;
                            offsetY += layout._graphNodes[child.name].x + mod1 + height / 2;
                        }
                        else if (layout.orientation == "toptobottom") {
                            offsetX += layout._graphNodes[child.name].x + mod1 + width / 2;
                            offsetY += layout._graphNodes[child.name].y + height / 2;
                        }
                        else {
                            offsetX += layout._graphNodes[child.name].x + mod1 + width / 2;
                            offsetY -= layout._graphNodes[child.name].y + height / 2;
                        }
                        offsetX = offsetX;
                        offsetY = offsetY;
                        rect = { x: offsetX - width * child.pivot.x, y: offsetY - height * child.pivot.y, width: width, height: height };
                    }
                }
                if (rect) {
                    if (ej.datavisualization.Diagram.Geometry.isEmptyRect(bounds))
                        bounds = rect;
                    else
                        bounds = ej.datavisualization.Diagram.Geometry.union(bounds, rect);
                }
            }
            return bounds;
        },

        _updateTree: function (layout, x, y, shape, level, prev, dontupdate) {
            if (!shape._visited1) {
                shape._visited1 = true;
                var dimensions, info, lev, obj, hasChild;
                dimensions = this._getDimensions(layout, shape, x, y, level);
                info = layout._graphNodes[shape.name];
                //Set maximum level of layout
                layout.maxLevel = Math.max(layout.maxLevel, level);
                lev = level;
                hasChild = this._hasChild(layout, shape);
                if (!hasChild && !info.tree.assistants.length) {
                    //update leaf nodes
                    shape._treeBounds = this._updateLeafNode(layout, shape, prev, dimensions, level, dontupdate);
                    return shape._treeBounds;
                }
                else {
                    var treeBounds, shapeBounds, levelBounds, d, asstBounds, space;
                    var bottom = dimensions.y + dimensions.height + layout.verticalSpacing;
                    if (info.tree.assistants.length) {
                        //Vertically place assistants
                        obj = this._setDepthSpaceForAssistants(layout, shape, bottom, dimensions.height, level, layout.verticalSpacing);
                        lev = obj.level;
                        bottom = obj.bottom;
                    }
                    if (!info.tree.assistants.length && info.tree.orientation != "horizontal") bottom = dimensions.y + dimensions.height + layout.verticalSpacing / 2;
                    if (info.tree.children.length) {
                        if (info.tree.orientation == "horizontal" && (info.tree.type != "balanced" || info.tree.children.length == 1))
                            treeBounds = this._updateHorizontalTree(layout, shape, prev, dimensions.x, bottom, lev);
                        else if (info.tree.type == "balanced")
                            treeBounds = this._updateHorizontalTreeWithMultipleRows(layout, shape, prev, dimensions.x, bottom, lev);
                        else
                            treeBounds = this._updateVerticalTree(layout, shape, dimensions.x, bottom, lev, dontupdate);
                    }

                    if (!(info.y && info.y > dimensions.y))
                        info.y = dimensions.y;
                    if (!(x && x > info.mid))
                        x = info.mid;
                    if (info.tree.assistants.length) {
                        //Set breadth space for assistants
                        space = x !== undefined ? x : dimensions.x;
                        asstBounds = this._setBreadthSpaceForAssistants(layout, shape, dimensions, space, bottom, level);
                        if (!hasChild) {
                            levelBounds = treeBounds = asstBounds;
                            x = (levelBounds.x + levelBounds.right) / 2 - dimensions.width / 2;
                            treeBounds = levelBounds;
                        }
                        d = asstBounds ? asstBounds.canMoveBy : undefined;
                    }
                    info.x = x;
                    if (!info.translate) info._treeWidth = treeBounds.right - treeBounds.x;
                    shapeBounds = { x: x, y: dimensions.y, right: x + dimensions.width, bottom: dimensions.y + dimensions.height };
                    this._translateSubTree(layout, shape, shapeBounds, treeBounds, dimensions, level, d, prev != undefined, dontupdate);
                    if (typeof info.firstChild != "string")
                        info.firstChild.x += info.subTreeTranslation;
                    shape._treeBounds = treeBounds;
                    return treeBounds;
                }
            }
            else {

                return shape._treeBounds;
            }
        },

        _updateLeafNode: function (layout, shape, prev, dimensions, level, dontupdate) {
            var info, bounds;
            info = layout._graphNodes[shape.name];
            if (!(info.x && info.x > dimensions.x))
                info.x = dimensions.x;
            if (!(info.y && info.y > dimensions.y))
                info.y = dimensions.y;
            info.maxLevel = Math.max(level, info.maxLevel || 0);
            bounds = { x: dimensions.x, y: dimensions.y, right: dimensions.x + dimensions.width, bottom: dimensions.y + dimensions.height };
            info.maxLevel = Math.max(info.maxLevel || 0, level);
            this._translateSubTree(layout, shape, bounds, bounds, dimensions, level, undefined, prev != undefined, dontupdate);
            return { x: info.x, y: info.y, right: info.x + dimensions.width, bottom: info.y + dimensions.height };
        },

        _translateSubTree: function (layout, shape, shapeBounds, treeBounds, dimensions, level, assistDiff, translate, dontupdate) {
            var info = layout._graphNodes[shape.name];
            var firstChild = layout.diagram.nameTable[info.firstChild ? info.firstChild.child : info.tree.children[0]];
            var firstChildInfo = firstChild ? layout._graphNodes[firstChild.name] : null;
            var hasChild = this._hasChild(layout, shape);
            var intersect = this._findIntersectingLevels(layout, shapeBounds, level, info.actualLevel);
            var treeIntersect = this._findIntersectingLevels(layout, treeBounds, level, info.actualLevel);
            var levelBounds = [], diff;
            if (intersect.length && info.translate) {
                info.intersect = intersect;
                this._spaceLeftFromPrevSubTree(layout, shape, shapeBounds);
                info.canMoveBy = info.diff;
                if (assistDiff !== undefined)
                    info.canMoveBy = Math.min(assistDiff, info.canMoveBy);
                if (firstChild && firstChildInfo.canMoveBy !== undefined) {
                    if (firstChildInfo.canMoveBy >= info.canMoveBy) info.translated = true;
                    info.canMoveBy = Math.min(info.canMoveBy, firstChildInfo.canMoveBy);
                }
                if (translate) {
                    info.x -= info.canMoveBy;
                    info.subTreeTranslation -= info.canMoveBy;
                    if (hasChild) {
                        this._shiftSubordinates(layout, treeIntersect, info.canMoveBy);
                        treeBounds.x = Math.min(treeBounds.x, info.x);
                        treeBounds.right = Math.max(treeBounds.right, info.x + dimensions.width);
                        treeBounds.bottom = Math.max(treeBounds.bottom, info.y + dimensions.height);
                        treeBounds.x -= info.canMoveBy;
                        treeBounds.right -= info.canMoveBy;
                    }
                    if (firstChild && firstChildInfo.canMoveBy > info.canMoveBy) {
                        info.canMoveBy = firstChildInfo.canMoveBy - info.canMoveBy;
                    }
                    else if (firstChild && info.canMoveBy !== undefined) {
                        info.canMoveBy = 0;
                    }
                }
            }
            else {
                if (hasChild) {
                    treeBounds.x = Math.min(treeBounds.x, shapeBounds.x);
                    treeBounds.right = Math.max(treeBounds.right, shapeBounds.x + dimensions.width);
                    treeBounds.bottom = Math.max(treeBounds.bottom, info.y + dimensions.height);
                }
                if (!info.translate) {
                    info.canMoveBy = 0;
                    info.subTreeTranslation = 0;
                }
            }
            if (!dontupdate) {
                shapeBounds = { x: info.x, y: dimensions.y, right: info.x + dimensions.width, bottom: dimensions.y + dimensions.height };
                levelBounds.push({ rBounds: shapeBounds });
                this._updateRearBounds(layout, shape, levelBounds, level);
            }
        },

        _updateRearBounds: function (layout, shape, levelBounds, level, intersect) {
            var bnds, index, intersect, firstLevel, lastLevel, isLastLeaf = true;
            if (shape) {
                var info = layout._graphNodes[shape.name];
                intersect = info.intersect;
                isLastLeaf = !info.tree.children.length && !info.tree.assistants.length;
            }
            firstLevel = levelBounds[0].rBounds;
            lastLevel = levelBounds[levelBounds.length - 1].rBounds;
            if (intersect && intersect.length) {
                bnds = layout.levels[intersect[0]].rBounds;
                var bottom = bnds.bottom;
                if (bnds.y < firstLevel.y) {
                    bnds.bottom = firstLevel.y;
                    levelBounds.splice(0, 0, { rBounds: bnds });
                }
                if (bottom > lastLevel.bottom) {
                    levelBounds.push({ rBounds: { x: bnds.x, right: bnds.right, y: firstLevel.bottom, bottom: bottom } });
                }
                else {
                    bnds = layout.levels[intersect[intersect.length - 1]].rBounds;
                    if (isLastLeaf && bnds.bottom > lastLevel.bottom) {
                        bnds.y = lastLevel.bottom;
                        levelBounds.push({ rBounds: bnds });
                    }
                }
                index = intersect[0];
                for (var i = levelBounds.length - 1; i >= 0; i--)
                    layout.levels.splice(index, 0, levelBounds[i]);
                index += levelBounds.length;
                layout.levels.splice(index, intersect.length);
            }
            else {
                index = this._findLevel(layout, levelBounds[levelBounds.length - 1].rBounds, level);
                for (var i = levelBounds.length - 1; i >= 0; i--)
                    layout.levels.splice(index, 0, levelBounds[i]);
            }
        },

        _shiftSubordinates: function (layout, intersect, diff) {
            var i;
            //Shift the sublevels by the distance diff
            if (diff != 0) {
                for (i = 0; i < intersect.length; i++) {
                    if (layout.levels[intersect[i]].rBounds) {
                        layout.levels[intersect[i]].rBounds.x -= diff;
                        layout.levels[intersect[i]].rBounds.right -= diff;
                    }
                }
            }
        },

        _setDepthSpaceForAssistants: function (layout, shape, bottom, height, lev, verticalSpacing) {
            var info = layout._graphNodes[shape.name];
            var asst, asstHeight, i, asstElement;
            var max = bottom;
            //Vertically place the assistants as alternate layout(alternatively at both right and left sides of parent)
            for (i = 0; i < info.tree.assistants.length; i++) {
                asst = layout._graphNodes[info.tree.assistants[i]];
                if (asst) {
                    asst.tree.children = asst.tree.assistants = [];
                    asst.y = bottom;
                    asstElement = layout.diagram.nameTable[info.tree.assistants[i]];
                    asstHeight = asstElement.height ? asstElement.height : asstElement._height;
                    if (layout.orientation == "lefttoright" || layout.orientation == "righttoleft")
                        asstHeight = asstElement.width ? asstElement.width : asstElement._width;
                    max = bottom + asstHeight + verticalSpacing / 2;
                    layout.maxLevel = lev + 1;
                    if (i % 2 == 1 && i != info.tree.assistants.length - 1) {
                        bottom = max;
                        lev++;
                    }
                }
            }
            return { level: layout.maxLevel, bottom: bottom + asstHeight + verticalSpacing };
        },

        _setBreadthSpaceForAssistants: function (layout, shape, dimensions, space, bottom, level) {
            var asst, asstWidth, prevBounds, bounds, asstElement;
            var info = layout._graphNodes[shape.name];
            var max = bottom;
            var lev = level;
            var left, diff, levelBounds, intersect, i;
            for (i = 0; i < info.tree.assistants.length; i++) {
                asst = layout._graphNodes[info.tree.assistants[i]];
                //Arrange assistants at both left and right sides of parent(like alternate layout)
                //Check - By default, distance to be left between parent and child nodes is assumed as 20. It can be modified/customized later.
                if (asst) {
                    asstElement = layout.diagram.nameTable[info.tree.assistants[i]];
                    asstWidth = asstElement.width ? asstElement.width : asstElement._width;
                    if (layout.orientation == "lefttoright" || layout.orientation == "righttoleft")
                        asstWidth = asstElement.height ? asstElement.height : asstElement._height;
                    if (i % 2 == 0) left = space + dimensions.width / 2 - 20 - asstWidth;
                    else left = space + dimensions.width / 2 + 20;
                    //Check - What will happen if update leaf node is called? Since assistants don't have children
                    bounds = this._updateTree(layout, left, asst.y, layout.diagram.nameTable[info.tree.assistants[i]], lev + 1);
                    if (!this._hasChild(layout, shape))
                        if (i == 0) levelBounds = bounds;
                        else this._uniteRects(levelBounds, bounds);
                    if (i % 2 == 0 && asst.prevBounds) {
                        if (diff === undefined) diff = asst.canMoveBy;
                        else diff = Math.min(diff, asst.canMoveBy);
                    }
                    if (i % 2 == 1 || i == info.tree.assistants.length - 1) {
                        intersect = this._findIntersectingLevels(layout, bounds, lev + 1);
                        //Update rightmost positions of known layout levels
                        this._updateRearBounds(layout, null, [{ rBounds: bounds }], lev + 1, intersect);
                        lev++;
                    }
                }
            }
            if (levelBounds)
                levelBounds.canMoveBy = diff;
            return levelBounds;
        },

        _updateHorizontalTree: function (layout, shape, prev, x, y, level) {
            var child, childInfo, childBounds, childWidth, childHeight, firstChildInfo;
            var prevBounds, bounds, actBounds, maxLevel, translateSibilingsBy;
            //Get dimensions with respect to layout orientations
            var dimensions = this._getDimensions(layout, shape, x, y, level);
            var info = layout._graphNodes[shape.name];
            var side = info.tree.type;
            var lev = level;
            var right = x;
            var bottom = y;
            var width, height;
            var prevLayoutLevels = layout.levels.slice(0, layout.levels.length);
            if (this._hasChild(layout, shape)) {
                var h = layout.orientation == "lefttoright" || layout.orientation == "righttoleft" ? true : false;
                for (var i = 0; i < info.tree.children.length; i++) {
                    var oldActBounds;
                    child = layout.diagram.nameTable[info.tree.children[i]];
                    width = child.width ? child.width : child._width;
                    height = child.height ? child.height : child._height;
                    childWidth = h ? height : width;
                    childHeight = h ? width : height;
                    prevBounds = layout.levels[lev + 1] ? layout.levels[lev + 1].rBounds : null;
                    //Update sub tree
                    childBounds = this._updateTree(layout, right, bottom, child, lev + 1, layout.diagram.nameTable[info.tree.children[i - 1]]);
                    childInfo = layout._graphNodes[child.name];
                    info.maxLevel = Math.max(info.maxLevel || 0, childInfo.maxLevel || 0);
                    actBounds = { x: childInfo.x, y: childInfo.y, right: childInfo.x + childWidth, bottom: childInfo.y + childHeight };
                    if (i == 0) {
                        //Compare with previous(right most) subtree
                        bounds = { x: Math.min(childInfo.x, childBounds.x), y: Math.min(childInfo.y, childBounds.y), right: childBounds.right, bottom: childBounds.bottom };
                        firstChildInfo = childInfo;
                    }
                    if (!oldActBounds)
                        oldActBounds = actBounds;
                    else {
                        oldActBounds.x = actBounds.x;
                        oldActBounds.y = actBounds.y;
                        if (actBounds.right > oldActBounds.right)
                            oldActBounds.right = actBounds.right;
                        oldActBounds.bottom = actBounds.bottom;
                        //oldActBounds = actBounds;
                    }
                    //Compare with previous subtree if level of the child is greater than the level of previous sub tree
                    //Check - what will happen if level of second child is greater than current child

                    if (i == 0) info.firstChild = { x: childInfo.x, canMoveBy: childInfo.canMoveBy, child: child.name };
                    if (this._hasChild(layout, child)) {
                        if (!info.firstChild || info.firstChild.x >= childInfo.firstChild.x) {
                            if (childInfo.firstChild && info.firstChild.canMoveBy < childInfo.canMoveBy) {
                                var canMoveBy = info.firstChild.canMoveBy;
                                childInfo.canMoveBy = canMoveBy;
                                layout._graphNodes[info.firstChild.child].canMoveBy = canMoveBy;
                                info.firstChild.canMoveBy = canMoveBy;
                            }
                            info.firstChild = { x: childInfo.firstChild.x, canMoveBy: canMoveBy !== undefined ? canMoveBy : childInfo.canMoveBy, child: child.name }
                        }
                        else if (childInfo.firstChild && childInfo.translated && info.firstChild.canMoveBy > childInfo.canMoveBy) {
                            info.firstChild.canMoveBy = layout._graphNodes[info.firstChild.child].canMoveBy = childInfo.canMoveBy;
                        }
                    }
                    maxLevel = maxLevel ? Math.max(childInfo.maxLevel, maxLevel) : childInfo.maxLevel;
                    if (!child._isRightAdded) {
                        this._uniteRects(bounds, childBounds);
                        if (i != 0 && !this._hasChild(layout, child) && childInfo.subTreeTranslation < 0)
                            right = childBounds.right - childInfo.subTreeTranslation + layout.horizontalSpacing;
                        else
                            right = childBounds.right + layout.horizontalSpacing;
                    }
                    child._isRightAdded = true;
                }
                if (!isNaN(translateSibilingsBy)) firstChildInfo.canMoveBy = translateSibilingsBy;
                info.mid = (firstChildInfo.x + oldActBounds.right) / 2 - dimensions.width / 2;
                //Set parent based on the chart type
                if (side == "left") info.mid = actBounds.right - dimensions.width; else if (side == "right") info.mid = x;
            }
            return bounds;
        },
        _updateHorizontalTreeWithMultipleRows: function (layout, shape, prev, x, y, level, centered) {
            var child, childInfo, childBounds, childWidth, childHeight, firstChildInfo;
            var prevBounds, bounds, actBounds, maxLevel, translateSibilingsBy, rowBounds;
            //Get dimensions with respect to layout orientations
            var dimensions = this._getDimensions(layout, shape, x, y, level);
            var info = layout._graphNodes[shape.name];
            var side = info.tree.type;
            var lev = level;
            var right = x;
            var bottom = y;
            var width, height;
            var prevLayoutLevels = layout.levels.slice(0, layout.levels.length);
            var fchild;
            var centered = [];
            var maxRowWidth;
            var minTranslation = 0;
            if (this._hasChild(layout, shape)) {
                var h = layout.orientation == "lefttoright" || layout.orientation == "righttoleft" ? true : false;
                var rows = this._splitChildrenInRows(layout, shape);
                var unique = info.tree.children.length == 5 && rows[0].length == 3;
                var left = [];
                var centerTree = [];
                var rightTree = [];
                if (!unique)
                    for (var i = 0; i < rows.length; i++) {
                        left[i] = []; rightTree[i] = [];
                        var half = rows[i].length;
                        if (rows[i].length % 2 != 1) {
                            half = Math.ceil(rows[i].length / 2);
                            for (var k = 0; k < half ; k++) {
                                left[i].push(rows[i][k]);
                            }
                        }
                        for (var j = left[i].length; j < rows[i].length; j++)
                            rightTree[i].push(rows[i][j]);
                    }
                else rightTree = rows;

                var leftBounds = [];
                var rightMost, minTranslation = 0;
                //Arrange left side
                for (var i = 0; i < left.length && left[i].length; i++) {
                    right = x;
                    if (leftBounds[i - 1]) bottom = leftBounds[i - 1].bottom + layout.verticalSpacing;
                    for (var j = 0; j < left[i].length; j++) {
                        child = layout.diagram.nameTable[left[i][j]];
                        width = child.width ? child.width : child._width;
                        height = child.height ? child.height : child._height;
                        childWidth = h ? height : width;
                        childHeight = h ? width : height;
                        prevBounds = layout.levels[lev + 1] ? layout.levels[lev + 1].rBounds : null;
                        //Update sub tree
                        childInfo = layout._graphNodes[child.name];
                        childInfo.actualLevel = lev + 1 + i;
                        childBounds = this._updateTree(layout, right, bottom, child, lev + 1, layout.diagram.nameTable[left[i][j - 1]]);
                        if (j == 0) {
                            leftBounds[i] = { x: childBounds.x, y: childBounds.y, right: childBounds.right, bottom: childBounds.bottom };
                        }
                        else {
                            this._uniteRects(leftBounds[i], childBounds);
                        }
                        if (i == 0 && j == 0) {
                            minTranslation = childInfo.canMoveBy;
                            info.firstChild = { x: childInfo.x, child: child.name, canMoveBy: childInfo.canMoveBy };
                        }
                        else if (j == 0 && childInfo.canMoveBy !== undefined && minTranslation > childInfo.canMoveBy) {
                            minTranslation = Math.min(minTranslation, childInfo.canMoveBy || 0);
                            info.firstChild = { x: childInfo.x, child: child.name, canMoveBy: childInfo.canMoveBy };
                        }
                        right = childBounds.right + layout.horizontalSpacing;
                    }
                    if (i == 0)
                        rightMost = leftBounds[i].right;
                    else rightMost = Math.max(rightMost, leftBounds[i].right);
                    prevBounds = actBounds;
                }

                //Translate to same positions
                for (var i = 0; i < left.length && left[i].length; i++) {
                    if (rightMost != leftBounds[i].right) {
                        var diff = rightMost - leftBounds[i].right;
                        for (var j = 0; j < left[i].length; j++) {
                            var element = layout.diagram.nameTable[left[i][j]];
                            var elementInfo = layout._graphNodes[left[i][j]];
                            elementInfo.x += diff;
                        }
                        //leftBounds[i].x += diff;
                        //leftBounds[i].right += diff;
                    }
                    if (i == 0) {
                        bounds = { x: leftBounds[0].x, y: leftBounds[0].y, right: leftBounds[0].right, bottom: leftBounds[0].bottom };
                    }
                    else this._uniteRects(bounds, leftBounds[i]);
                    prevBounds = childBounds;
                }


                var center = (rightMost || 0) + (rightMost !== undefined ? (layout.horizontalSpacing / 2) : 0);
                if (rightMost !== undefined) {
                    info.mid = center - dimensions.width / 2;
                    var rightX = rightMost + layout.horizontalSpacing;
                }
                var maxRowWidth;
                bottom = y;
                var rightBounds = [];
                for (var i = 0; i < rightTree.length; i++) {
                    if (rows[i].length % 2 == 1 && i == rightTree.length - 1 || unique) right = x;
                    else right = rightX || x;
                    if (i != 0) bottom = rightBounds[i - 1].bottom + layout.verticalSpacing;
                    for (var j = 0; j < rightTree[i].length; j++) {
                        child = layout.diagram.nameTable[rightTree[i][j]];
                        width = child.width ? child.width : child._width;
                        height = child.height ? child.height : child._height;
                        childWidth = h ? height : width;
                        childHeight = h ? width : height;
                        prevBounds = layout.levels[lev + 1] ? layout.levels[lev + 1].rBounds : null;
                        //Update sub tree
                        childInfo = layout._graphNodes[child.name];
                        childInfo.actualLevel = lev + 1 + i;
                        if (j == 0 && left[i] && left[i].length) childInfo.translate = false;
                        if (unique && i == 1) {
                            if (j == 0 && leftCenter + childWidth + layout.horizontalSpacing <= rightCenter) {
                                var align = true;
                                right = leftCenter - childWidth / 2;
                            }
                            if (align && j == 1) { right = rightCenter - childWidth / 2; }
                        }

                        childBounds = this._updateTree(layout, right, bottom, child, lev + 1, layout.diagram.nameTable[rightTree[i][j - 1]]);
                        if (unique && j <= 2 && i == 0) {
                            if (j == 1) {
                                var leftCenter = childBounds.x - layout.horizontalSpacing / 2;
                                var rightCenter = childBounds.x + childWidth + layout.horizontalSpacing / 2;
                            }
                        }
                        if (j == 0) {
                            rightBounds[i] = { x: childBounds.x, y: childBounds.y, right: childBounds.right, bottom: childBounds.bottom };
                        }
                        else {
                            this._uniteRects(rightBounds[i], childBounds);
                        }
                        if (!bounds) bounds = { x: rightBounds[i].x, y: rightBounds[i].y, right: rightBounds[i].right, bottom: rightBounds[i].bottom };
                        this._uniteRects(bounds, rightBounds[i]);
                        right = childBounds.right + layout.horizontalSpacing;
                        prevBounds = childBounds;

                        if (!info.firstChild || ((i == rightTree.length - 1 && rows[i].length % 2 == 1) || unique) && j == 0 && childInfo.canMoveBy !== undefined && minTranslation > childInfo.canMoveBy) {
                            minTranslation = Math.min(minTranslation, childInfo.canMoveBy || 0);
                            info.firstChild = { x: childInfo.x, child: child.name, canMoveBy: childInfo.canMoveBy };
                        }
                    }
                    if (unique && i == 1) {
                        var max = (rightBounds[0].right - rightBounds[0].x) >= (rightBounds[1].right - rightBounds[1].x) ? 0 : 1;
                    }
                    if (i == rows.length - 1) {
                        if (rows[i].length % 2 == 1 || unique && i == 1) {
                            var centered = rightTree[i][Math.floor(rightTree[i].length / 2)];
                            var centerObjct = layout.diagram.nameTable[centered];
                            var childDimension = this._getDimensions(layout, centerObjct, layout._graphNodes[centered].x, layout._graphNodes[centered].y, lev + 1);
                            diff = undefined;
                            if (!align && unique) {
                                if (max == 1) i = 0;
                                diff = (rightBounds[max].x + rightBounds[max].right) / 2 - (rightBounds[i].x + rightBounds[i].right) / 2;
                                if (i == 0) info.mid += diff;
                            }
                            else if (!unique && rightX !== undefined) diff = rightX - layout.horizontalSpacing / 2 - (layout._graphNodes[centered].x + childDimension.width / 2);

                            if (diff !== undefined) {
                                for (var j = 0; j < rightTree[i].length; j++) {
                                    layout._graphNodes[rightTree[i][j]].x += diff;
                                    layout._graphNodes[rightTree[i][j]].canMoveBy += diff;
                                    if (j == rightTree[i].length - 1) {
                                        var chldDimensions = this._getDimensions(layout, layout.diagram.nameTable[rightTree[i][j]], layout._graphNodes[rightTree[i][j]].x, layout._graphNodes[rightTree[i][j]].y, layout._graphNodes[rightTree[i][j]].actualLevel);
                                        var child = layout._graphNodes[rightTree[i][j]];
                                        var intersect = this._findIntersectingLevels(layout, { x: child.x, y: child.y, right: child.x + dimensions.width, bottom: child.y + dimensions.height }, layout._graphNodes[rightTree[i][j]].actualLevel);
                                        this._updateRearBounds(layout, null, [{ rBounds: { x: child.x, y: child.y, right: child.x + dimensions.width, bottom: child.y + dimensions.height } }], layout._graphNodes[rightTree[i][j]].actualLevel, intersect);
                                    }
                                }
                            }
                            if (unique)
                                info.mid = (rightCenter + leftCenter) / 2 + (i == 0 ? diff : 0) - dimensions.width / 2;
                            if (info.mid == undefined && layout._graphNodes[centered]) { info.mid = layout._graphNodes[centered].x; }
                            align = false;
                            i++;
                        }
                    }
                }
            }
            return bounds;
        },
        _updateVerticalTree: function (layout, shape, x, y, level, dontupdate) {
            //declare local variables
            var child, childInfo, childBounds, childWidth, childHeight, prevBounds, bounds, actBounds, oddBounds, evenBounds;
            var dimensions, info, firstChild, h, factor, right, bottom, lev, i;
            var diff, type, canMoveBy, levels = [], oddLevels = [], intersect;
            var width, height;
            //Get dimensions with respect to layout orientations
            dimensions = this._getDimensions(layout, shape, x, y, level);
            info = layout._graphNodes[shape.name];
            firstChild = layout.diagram.nameTable[info.tree.children[0]];
            h = layout.orientation == "lefttoright" || layout.orientation == "righttoleft" ? true : false;
            factor = info.tree.type == "left" || info.tree.type == "leftoffset" ? -1 : 0;
            right = x;
            bottom = y;
            lev = level;
            for (i = 0; i < info.tree.children.length; i++) {
                if (info.tree.type == "alternate") {
                    //arrange at both left and right
                    type = (i % 2 == 0 && info.tree.children.length > 2) ? "left" : "right";
                    factor = (i % 2 == 0 && info.tree.children.length > 2) ? -1 : 0;
                }
                right = x + this._findOffset(layout, shape, info, type);
                child = layout.diagram.nameTable[info.tree.children[i]];
                width = child.width ? child.width : child._width;
                height = child.height ? child.height : child._height;
                childWidth = h ? height : width;
                childHeight = h ? width : height;
                //Update sub tree
                childBounds = this._updateTree(layout, right + factor * childWidth, bottom, child, level + 1, undefined, true);
                childInfo = layout._graphNodes[child.name];
                actBounds = { x: childInfo.x, y: childInfo.y, right: childInfo.x + childWidth, bottom: childInfo.y + childHeight };
                if (i == 0) {
                    this._uniteRects(childBounds, actBounds);
                    bounds = childBounds;
                }
                else
                    this._uniteRects(bounds, childBounds);
                //Check and adjust the space left from previous subtree/sibling
                if (childInfo.prevBounds && !(info.tree.type == "alternate" && i % 2 == 1 && info.tree.children.length > 2)) {
                    canMoveBy = canMoveBy !== undefined ? Math.min(childInfo.canMoveBy, canMoveBy) : childInfo.canMoveBy;
                }
                //Max level of the subtree node
                info.maxLevel = Math.max(info.maxLevel || 0, childInfo.maxLevel || 0);
                if (!(info.tree.type == "alternate" && info.tree.children.length > 2 && i % 2 == 0)) {
                    if (info.tree.type == "alternate" && info.tree.children.length > 2)
                        //alternate - arrange children with even index(0,2,4,6,..) at the next level
                        bottom = Math.max(childBounds.bottom, prevBounds.bottom) + layout.verticalSpacing / 2;
                    else
                        // left/right - arrange next child at the nect level(bottom)
                        bottom = childBounds.bottom + layout.verticalSpacing / 2;

                    level = info.maxLevel;
                    levels.push({ rBounds: actBounds });
                    if (!evenBounds) evenBounds = { x: childInfo.x, y: childInfo.y, right: childInfo.x + childWidth, bottom: childInfo.y + childHeight };
                    else this._uniteRects(evenBounds, actBounds);
                    if (childInfo.levelBounds) levels = levels.concat(childInfo.levelBounds);
                }
                else {
                    if (i != 0) bottom = prevBounds.bottom + layout.verticalSpacing / 2;
                    oddLevels.push({ rBounds: actBounds });
                    if (childInfo.levelBounds) oddLevels = oddLevels.concat(childInfo.levelBounds);
                }
                if (i == 0) info.firstChild = { x: childInfo.x, canMoveBy: childInfo.canMoveBy, child: child.name };
                if (this._hasChild(layout, child)) {
                    if (!info.firstChild || info.firstChild.x >= childInfo.firstChild.x) {
                        if (childInfo.firstChild && info.firstChild.canMoveBy < childInfo.canMoveBy) {
                            var canMoveBy = info.firstChild.canMoveBy;
                            childInfo.canMoveBy = canMoveBy;
                            layout._graphNodes[info.firstChild.child].canMoveBy = canMoveBy;
                            info.firstChild.canMoveBy = canMoveBy;
                        }
                        info.firstChild = { x: childInfo.firstChild.x, canMoveBy: canMoveBy !== undefined ? canMoveBy : childInfo.canMoveBy, child: child.name }
                    }
                    else if (childInfo.firstChild && childInfo.translated && info.firstChild.canMoveBy > childInfo.canMoveBy) {
                        info.firstChild.canMoveBy = layout._graphNodes[info.firstChild.child].canMoveBy = childInfo.canMoveBy;
                    }
                }
                prevBounds = actBounds;
            }
            //To set level bounds(right most position of levels)
            if (!dontupdate) {
                if (info.tree.type == "alternate" && info.tree.children.length > 2) {
                    oddBounds = { x: oddLevels[0].rBounds.x, y: oddLevels[0].rBounds.y, right: oddLevels[oddLevels.length - 1].rBounds.right, bottom: oddLevels[oddLevels.length - 1].rBounds.bottom };
                    intersect = this._findIntersectingLevels(layout, oddBounds, lev + 1);
                    this._updateRearBounds(layout, null, oddLevels, lev + 1, intersect);
                }
                intersect = this._findIntersectingLevels(layout, evenBounds || bounds, lev + 1);
                this._updateRearBounds(layout, null, evenBounds ? levels : [{ rBounds: bounds }], lev + 1, intersect);
            }
            else info.levelBounds = levels;

            if (!isNaN(canMoveBy))
                layout._graphNodes[firstChild.name].canMoveBy = canMoveBy;
            info.childBounds = bounds;
            info.mid = x;
            return bounds;
        },
        _splitChildrenInRows: function (layout, shape) {
            var info = layout._graphNodes[shape.name];
            var column = 4;
            var rows = [];
            var childNodes = info.tree.children.length;
            var children = $.extend([], true, info.tree.children);
            if (info.tree.rows) {
                var count = info.tree.children.length;
                var columns = Math.ceil(count / info.tree.rows);
                if (columns % 2 == 0)
                    column = columns;
                else {
                    column = columns + 1;
                }
            }
            else if (info.tree.children.length == 3 || info.tree.children.length == 4)
                column = 2;
            else if (info.tree.children.length == 5) {
                column = 3;
            }
            while (childNodes > 0) {
                rows[rows.length] = children.splice(0, column);
                childNodes -= column;
                if (childNodes < column) {
                    column = childNodes;
                }
            }
            return rows;
        },
        _findOffset: function (layout, shape, info, type) {
            var offset = 0;
            var space = (layout.orientation == "lefttoright" || layout.orientation == "righttoleft") ? shape.height ? shape.height : shape._height : shape.width ? shape.width : shape._width;
            var ch = type ? type : info.tree.type;
            offset = info.tree.offset || (info.tree.offset === 0 ? 0 : 20);

            if (info.tree.type == "alternate")
                if (offset >= layout.horizontalSpacing) offset = layout.horizontalSpacing / 2;
            switch (ch) {
                case "left":
                    offset = space / 2 - offset;
                    break;
                case "right":
                    offset = offset + space / 2;
                    break;
            }
            return offset;
        },

        _translateSiblings: function (layout, shape, child) {
            var i, childInfo, info, diff;
            info = layout._graphNodes[shape.name];
            diff = layout._graphNodes[child.name].diff - layout._graphNodes[child.name].canMoveBy;
            for (i = 0; i < info.tree.children.length; i++) {
                if (child.name == info.tree.children[i])
                    break;
                childInfo = layout._graphNodes[info.tree.children[i]];
                childInfo.x += diff;
            }
        },

        _uniteRects: function (rect1, rect2) {
            //Unite two rects
            rect1.x = Math.min(rect1.x, rect2.x);
            rect1.right = Math.max(rect1.right, rect2.right);
            rect1.bottom = Math.max(rect1.bottom, rect2.bottom);
        },

        _spaceLeftFromPrevSubTree: function (layout, shape, bounds) {
            var info = layout._graphNodes[shape.name];
            var dif, prevBounds, intersect, k;
            var space = layout.horizontalSpacing;
            //Find the minimum distance to move towards previous sub tree
            for (k = 0; k < info.intersect.length; k++) {
                prevBounds = layout.levels[info.intersect[k]].rBounds;
                dif = bounds.x - (prevBounds.right + space);
                if (info.diff == undefined || dif < info.diff) {
                    info.diff = dif;
                    info.prevBounds = layout.levels[info.intersect[k]];
                }
            }
        },

        _findIntersectingLevels: function (layout, bounds, level, actualLevel) {
            //intersecting with exact Level
            var bnds = { x: bounds.x, y: bounds.y, right: bounds.right, bottom: bounds.bottom };
            bnds.y -= layout.verticalSpacing / 2;
            bnds.bottom += layout.verticalSpacing / 2;
            var intersectingLevels = [];
            var rBounds;
            var l = actualLevel !== undefined ? actualLevel : level;
            rBounds = layout.levels[l] ? layout.levels[l].rBounds : null;
            //Performance - We can consider only the intersecting levels
            do {
                if (rBounds && ((bnds.y < rBounds.y && bnds.bottom > rBounds.y) || (bnds.y < rBounds.bottom && rBounds.bottom < bnds.bottom) ||
                    bnds.y >= rBounds.y && bnds.bottom <= rBounds.bottom || bnds.y < rBounds.y && bnds.bottom > rBounds.bottom)) {
                    intersectingLevels.splice(0, 0, l);
                }
                else if (rBounds && rBounds.bottom < bnds.y) break;
                l--;
                rBounds = layout.levels[l] ? layout.levels[l].rBounds : null;
            } while (l >= 0);

            l = (actualLevel !== undefined ? actualLevel : level) + 1;
            rBounds = layout.levels[l] ? layout.levels[l].rBounds : null;
            do {
                if (rBounds && ((bnds.y < rBounds.y && bnds.bottom > rBounds.y) || (bnds.y < rBounds.bottom && rBounds.bottom < bnds.bottom) ||
                    bnds.y >= rBounds.y && bnds.bottom <= rBounds.bottom || bnds.y < rBounds.y && bnds.bottom > rBounds.bottom)) {
                    intersectingLevels.push(l);
                }
                else if (rBounds && rBounds.y > bnds.bottom) break;
                l++;
                rBounds = layout.levels[l] ? layout.levels[l].rBounds : null;
            } while (l <= layout.levels.length);

            return intersectingLevels;
        },

        _findLevel: function (layout, bounds, level) {
            var bnds = bounds;
            var l = 0;
            var rBounds = layout.levels[l] ? layout.levels[l].rBounds : null;
            while (l < layout.levels.length) {
                if (rBounds && bnds.bottom < rBounds.y) {
                    return l;
                }
                else l++;
                rBounds = layout.levels[l] ? layout.levels[l].rBounds : null;
            }
            return l;
        },

        _updateEdges: function (layout, node, depth) {
            var layoutInfo = layout._graphNodes[node.name];
            if (node.outEdges && node.outEdges.length && node.isExpanded) {
                for (var j = 0; j < node.outEdges.length; j++) {
                    var edge = layout.diagram.nameTable[layout.diagram.nameTable[node.outEdges[j]].targetNode];
                    if (!edge.excludeFromLayout) {
                        if (!ej.datavisualization.Diagram.Util._collectionContains(edge.name, layoutInfo.tree.children)) {
                            layoutInfo.tree.children.push(edge.name);
                        }
                        if (edge.outEdges && edge.outEdges.length && edge.isExpanded) {
                            layoutInfo.tree.hasSubTree = true;
                        }
                        this._updateEdges(layout, edge, depth + 1);
                    }
                }
            }

            //set level info
            layoutInfo.tree.level = depth;

            //By default, orientation is horizontal for nested trees
            if (layoutInfo.tree.hasSubTree) layoutInfo.tree.orientation = "horizontal";

            //Customizing assistants and children collection
            //Performance-Instead of reading the method everytime, we can set once and can reuse that
            if (layout.getLayoutInfo && layout.type == "organizationalchart") {
                layout.getLayoutInfo(layout.diagram, node, layoutInfo.tree);
                if (layoutInfo.tree.type == "balanced" && layoutInfo.tree.hasSubTree) { layoutInfo.tree.type = "center"; layoutInfo.tree.orientation = "horizontal" }
            }
            if (layout.level && layoutInfo.tree.type != "alternate" && depth >= layout.level)
                layoutInfo.tree.hasSubTree = false;
        },

        _updateAnchor: function (layout, bounds) {
            var node, viewPort, fixedNode, width, height, mod;
            //Update anchor based on viewport
            layout.diagram.viewPort = viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(layout.diagram, true);
            viewPort.x = 0; viewPort.y = 0;
            var layoutbounds = layout.bounds ? layout.bounds : viewPort;
            var orientation = layout.diagram._layoutOrientation();
            if (orientation == "toptobottom" || orientation == "bottomtotop") {
                switch (layout.horizontalAlignment) {
                    case "left":
                        layout._anchorX = (layoutbounds.x - bounds.x) + layout.margin.left;
                        break;
                    case "right":
                        layout._anchorX = layoutbounds.x + layoutbounds.width - layout.margin.right - bounds.right;
                        break;
                    case "center":
                        layout._anchorX = layoutbounds.x + layoutbounds.width / 2 - (bounds.x + bounds.right) / 2;
                        break;
                }
                switch (layout.verticalAlignment) {
                    case "top":
                        var top = layoutbounds.y + layout.margin.top;
                        layout._anchorY = orientation == "toptobottom" ? top : bounds.bottom + top;
                        break;
                    case "bottom":
                        var bottom = layoutbounds.y + layoutbounds.height - layout.margin.bottom;
                        layout._anchorY = orientation == "toptobottom" ? bottom - bounds.bottom : bottom;
                        break;
                    case "center":
                        var center = layoutbounds.y + layoutbounds.height / 2;
                        layout._anchorY = layout.orientation == "toptobottom" ? center - (bounds.y + bounds.bottom) / 2 : center + (bounds.y + bounds.bottom) / 2;
                        break;
                }
            }
            else if (orientation == "lefttoright" || orientation == "righttoleft") {
                switch (layout.horizontalAlignment) {
                    case "left":
                        var left = layoutbounds.x + layout.margin.left;
                        layout._anchorX = orientation == "lefttoright" ? left : bounds.bottom + left;
                        break;
                    case "right":
                        var right = layoutbounds.x + layoutbounds.width - layout.margin.right;
                        layout._anchorX = orientation == "lefttoright" ? right - bounds.bottom : right;
                        break;
                    case "center":
                        var center = layoutbounds.width / 2 + layoutbounds.x;
                        layout._anchorX = layout.orientation == "lefttoright" ? center - (bounds.y + bounds.bottom) / 2 : center + (bounds.y + bounds.bottom) / 2;
                        break;
                }
                switch (layout.verticalAlignment) {
                    case "top":
                        layout._anchorY = layoutbounds.y + layout.margin.top - bounds.x;
                        break;
                    case "center":
                        layout._anchorY = layoutbounds.y + layoutbounds.height / 2 - (bounds.right + bounds.x) / 2;
                        break;
                    case "bottom":
                        layout._anchorY = layoutbounds.y + layoutbounds.height - layout.margin.bottom - bounds.right;
                        break;
                }
            }

            //Anchor based on fixed nodes
            if (layout.fixedNode) {
                fixedNode = layout.diagram.nameTable[layout.fixedNode];
                width = fixedNode.width ? fixedNode.width : fixedNode._width;
                height = fixedNode.height ? fixedNode.height : fixedNode._height;
                layout._anchorX = fixedNode.offsetX;
                layout._anchorY = fixedNode.offsetY;
                layout._anchorX += layout.orientation == "righttoleft" ? width * fixedNode.pivot.x : -width * fixedNode.pivot.x;
                layout._anchorY += layout.orientation == "bottomtotop" ? height * fixedNode.pivot.y : -height * fixedNode.pivot.y;
                node = fixedNode, mod = 0;
                while (node.inEdges.length) {
                    node = this._getParentNode(layout, node);
                    mod += layout._graphNodes[node.name].subTreeTranslation || 0;
                }
                if (layout.orientation == "lefttoright" || layout.orientation == "righttoleft") {
                    layout._anchorX -= layout._graphNodes[fixedNode.name].y;
                    layout._anchorY -= layout._graphNodes[fixedNode.name].x + mod;
                } else {
                    layout._anchorX -= layout._graphNodes[fixedNode.name].x + mod;
                    layout._anchorY -= layout._graphNodes[fixedNode.name].y;
                }
            }

        },

        _updateConnectors: function (layout, node, level) {
            var i, conn, target, info, direction, offsetDir, segments;
            var nodeWidth = 0, nodeHeight = 0, targetWidth = 0, targetHeight = 0, length = 0, offsetLen = 0;
            //Route out edges
            info = layout._graphNodes[node.name];
            if (node.outEdges.length) {
                for (i = 0; i < node.outEdges.length; i++) {
                    conn = layout.diagram.nameTable[node.outEdges[i]];
                    target = layout.diagram.nameTable[conn.targetNode];
                    if (conn.visible && !conn._visited) {
                        conn._visited = true;
                        if (layout.getConnectorSegments) {
                            segments = layout.getConnectorSegments(layout.diagram, conn);
                        }
                        else {
                            if (info && info.tree.children.indexOf(conn.targetNode) != -1) {

                                var nwidth = node.width ? node.width : node._width;
                                var nheight = node.height ? node.height : node._height;
                                var twidth = target.width ? target.width : target._width;
                                var theight = target.height ? target.height : target._height;
                                if (layout.type == "organizationalchart") {
                                    if (layout.orientation == "toptobottom" || layout.orientation == "bottomtotop") {
                                        //Connector routing - vertical layouts
                                        nodeHeight = layout.orientation == "toptobottom" ? nheight : -nheight;
                                        targetHeight = layout.orientation == "toptobottom" ? -theight : theight;
                                        direction = layout.orientation == "toptobottom" ? "bottom" : "top";
                                        if (info.tree.assistants.length) {
                                            //Route inedge of child node, if the parent has assistants
                                            length = Math.abs((target.offsetY + targetHeight / 2) - (node.offsetY + nodeHeight / 2)) - layout.verticalSpacing / 2;
                                            segments = [{ type: "orthogonal", length: length, direction: direction }];
                                        }
                                        else {
                                            //Route inedge of child node
                                            if (info.tree.orientation == "horizontal" && (conn.segments.length == 1 || info.tree.type == "balanced")) {
                                                if (info.tree.type == "balanced") {
                                                    if (info.tree.children.length == 5 && i > 2) {
                                                        var relative = info.tree.children[1];
                                                        if (isNaN(layout._graphNodes[relative]._treeWidth)) layout._graphNodes[relative]._treeWidth = layout.diagram.nameTable[relative].width;
                                                        if (i == 3)
                                                            var center = layout.diagram.nameTable[relative].offsetX - layout._graphNodes[relative]._treeWidth / 2 - layout.horizontalSpacing / 2;
                                                        else
                                                            var center = layout.diagram.nameTable[relative].offsetX + layout._graphNodes[relative]._treeWidth / 2 + layout.horizontalSpacing / 2;
                                                        segments = [
                                                        { type: "orthogonal", length: layout.verticalSpacing / 2, direction: "bottom" },
                                                        {
                                                            type: "orthogonal", length: node.offsetX - center, direction: "left"
                                                        }, {
                                                            type: "orthogonal", length: target.offsetY + targetHeight / 2 - (node.offsetY + nodeHeight / 2) - layout.verticalSpacing, direction: "bottom"
                                                        }
                                                        ];

                                                    }
                                                    else {
                                                        var spacing = Math.min(30, layout.verticalSpacing / 2) * (direction == "bottom" ? 1 : -1);
                                                        length = Math.abs(target.offsetY + (targetHeight * target.pivot.y) - spacing - (node.offsetY + nodeHeight * (1 - target.pivot.y)));
                                                        segments = [{ type: "orthogonal", length: length, direction: direction }];
                                                    }
                                                }
                                                else
                                                    layout.diagram._dock(conn, layout.diagram.nameTable);
                                            }
                                            else {
                                                if (info.tree.orientation == "horizontal") {
                                                    segments = [{ type: "orthogonal" }];
                                                }
                                                else {

                                                    if (info.tree.enableRouting) {
                                                        length = Math.abs(target.offsetY - (node.offsetY + nodeHeight / 2));
                                                        segments = [{ type: "orthogonal", length: length, direction: direction }];
                                                        if (info.tree.offset < 5) {
                                                            offsetDir = info.tree.type == "left" ? "right" : "left";
                                                            length = layout.verticalSpacing / 4;
                                                            offsetLen = Math.abs(info.tree.offset) + layout.horizontalSpacing / 2;
                                                            segments = [{ type: "orthogonal", length: length, direction: direction },
                                                             { type: "orthogonal", length: offsetLen, direction: offsetDir }];
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else {
                                        //Connector routing - Horizontal layout orientation
                                        nodeWidth = layout.orientation == "lefttoright" ? nwidth : -nwidth;
                                        targetWidth = layout.orientation == "lefttoright" ? -twidth : twidth;
                                        direction = layout.orientation == "lefttoright" ? "right" : "left";
                                        if (info.tree.assistants.length) {
                                            //Route inedge of child node, if the parent has assistants
                                            length = Math.abs((target.offsetX + targetWidth / 2) - (node.offsetX + nodeWidth / 2)) - layout.verticalSpacing / 2;
                                            segments = [{ type: "orthogonal", length: length, direction: direction }];
                                        }
                                        else {
                                            //Route inedge of child node
                                            if (info.tree.orientation == "horizontal" && (conn.segments.length == 1 || info.tree.type == "balanced")) {
                                                if (info.tree.type == "balanced") {
                                                    if (info.tree.children.length == 5 && i > 2) {
                                                        var relative = info.tree.children[1];
                                                        if (isNaN(layout._graphNodes[relative]._treeWidth)) layout._graphNodes[relative]._treeWidth = layout.diagram.nameTable[relative].width;
                                                        if (i == 3)
                                                            var center = layout.diagram.nameTable[relative].offsetY - layout._graphNodes[relative]._treeWidth / 2 - layout.verticalSpacing / 2;
                                                        else
                                                            var center = layout.diagram.nameTable[relative].offsetY + layout._graphNodes[relative]._treeWidth / 2 + layout.verticalSpacing / 2;
                                                        segments = [
                                                        { type: "orthogonal", length: layout.horizontalSpacing / 2, direction: "right" },
                                                        {
                                                            type: "orthogonal", length: node.offsetY - center, direction: "top"
                                                        }, {
                                                            type: "orthogonal", length: target.offsetX + targetWidth / 2 - (node.offsetX + nodeWidth / 2) - layout.horizontalSpacing, direction: "right"
                                                        }

                                                        ];
                                                    }
                                                    else {
                                                        var spacing = Math.min(30, layout.horizontalSpacing / 2) * (direction == "right" ? 1 : -1);
                                                        length = Math.abs(target.offsetX + (targetWidth * target.pivot.x) - spacing - (node.offsetX + nodeWidth * (1 - target.pivot.x)));
                                                        segments = [{ type: "orthogonal", length: length, direction: direction }];
                                                    }
                                                }
                                                else {
                                                    layout.diagram._dock(conn, layout.diagram.nameTable);
                                                }
                                            }
                                            else {
                                                if (info.tree.orientation == "horizontal") {
                                                    segments = [{ type: "orthogonal" }];
                                                }
                                                else {
                                                    length = Math.abs(target.offsetX - (node.offsetX + nodeWidth / 2));
                                                    segments = [{ type: "orthogonal", length: length, direction: direction }];
                                                    if (info.tree.offset < 5) {
                                                        offsetDir = info.tree.type == "left" ? "bottom" : "top";
                                                        length = layout.verticalSpacing / 4;
                                                        offsetLen = Math.abs(info.tree.offset) + 10;
                                                        segments = [{ type: "orthogonal", length: length, direction: direction },
                                                         { type: "orthogonal", length: offsetLen, direction: offsetDir }];
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (segments)
                            layout.diagram.updateConnector(conn.name, { segments: segments });
                        else layout.diagram._dock(conn, layout.diagram.nameTable);
                        if (layout.diagram._svg)
                            ej.datavisualization.Diagram.DiagramContext.update(conn, layout.diagram);
                        if (target && (target.isExpanded || this._hasChild(layout, target)))
                            this._updateConnectors(layout, target, level + 1);

                    }
                }
            }
            if (info && info.tree.assistants.length) {
                //In-Edge routing of assistant nodes
                for (i = 0; i < info.tree.assistants.length; i++) {
                    target = layout.diagram.nameTable[info.tree.assistants[i]];
                    conn = layout.diagram.nameTable[target.inEdges[0]];
                    length = Math.abs(target.offsetY - (node.offsetY + nodeHeight / 2));
                    segments = [{ type: "orthogonal", length: length, direction: direction }];
                    if (segments) { layout.diagram.updateConnector(conn.name, { segments: segments }); }
                    if (layout.diagram._svg)
                        ej.datavisualization.Diagram.DiagramContext.update(conn, layout.diagram);
                    if (target.isExpanded || this._hasChild(layout, target))
                        this._updateConnectors(layout, target, level + 1);
                }
            }
        },

        _updateNodes: function (layout, node, mod, update, dx, dy) {
            var child, i;
            node._visited = true;
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var offsetX = node.offsetX;
            var offsetY = node.offsetY;
            if (!node.excludeFromLayout) {
                offsetX = layout._anchorX;
                offsetY = layout._anchorY;
                //Performance - instead of checking conditions for every node, we can make the layout related conditions once and we can reuse them
                if (layout.orientation == "lefttoright") {
                    offsetX += layout._graphNodes[node.name].y + width / 2;
                    offsetY += layout._graphNodes[node.name].x + mod + height / 2;
                }
                else if (layout.orientation == "righttoleft") {
                    offsetX -= layout._graphNodes[node.name].y + width / 2;
                    offsetY += layout._graphNodes[node.name].x + mod + height / 2;
                }
                else if (layout.orientation == "toptobottom") {
                    offsetX += layout._graphNodes[node.name].x + mod + width / 2;
                    offsetY += layout._graphNodes[node.name].y + height / 2;
                }
                else {
                    offsetX += layout._graphNodes[node.name].x + mod + width / 2;
                    offsetY -= layout._graphNodes[node.name].y + height / 2;
                }

                if (layout._graphNodes) {
                    var updNode = layout._graphNodes[node.name]
                    if (updNode) {
                        var upnodeTree = updNode.tree;
                        if (!upnodeTree.enableRouting) {
                            if (!layout.diagram.minSpaceBetweenNode)
                                layout.diagram.minSpaceBetweenNode = []
                            layout.diagram.minSpaceBetweenNode.push(node.name);
                        }
                    }
                }

                dx = dx ? dx : 0;
                dy = dy ? dy : 0;
                offsetX += dx;
                offsetY += dy;

                if (node.inEdges && node.inEdges.length > 1) {
                    var parents = [];
                    for (var m = 0; m < node.inEdges.length; m++) {
                        var pedge = layout.diagram.nameTable[node.inEdges[m]];
                        var pnode = layout.diagram.nameTable[pedge.sourceNode];
                        if (pnode && pnode.outEdges && pnode.outEdges.length <= 1)
                            parents.push(pnode.name);
                    }
                    if (parents && parents.length > 0) {
                        var fLevelbounds = this._getGroupBounds(parents, layout, mod);
                        if (layout.orientation === "toptobottom" || layout.orientation === "bottomtotop")
                            dx = (fLevelbounds.x + fLevelbounds.width / 2) - offsetX;
                        else
                            dy = (fLevelbounds.y + fLevelbounds.height / 2) - offsetY;

                        offsetX += dx;
                        offsetY += dy;

                        // layout._graphNodes[node.name].subTreeTranslation += offsetX;
                    }

                }

                if (!layout.updateView) {
                    update = (node.name == layout.fixedNode) || update;
                    if (!update && this._withinView(offsetX, offsetY, width, height, node, layout)) {
                        if (offsetX != node.offsetX || offsetY != node.offsetY)
                            layout.objects.push({
                                object: node.name, diff: offsetX - node.offsetX, diffy: offsetY - node.offsetY
                            });
                    } else
                        layout.diagram._translate(node, offsetX - (node.offsetX || 0), offsetY - (node.offsetY || 0), layout.diagram.nameTable);
                }
                else
                    layout.diagram._translate(node, offsetX - (node.offsetX || 0), offsetY - (node.offsetY || 0), layout.diagram.nameTable);
            }
            var list = [];
            if (this._hasChild(layout, node)) {
                for (i = 0; i < layout._graphNodes[node.name].tree.children.length; i++) {
                    child = layout.diagram.nameTable[layout._graphNodes[node.name].tree.children[i]];
                    this._updateNodes(layout, child, mod + (layout._graphNodes[node.name].subTreeTranslation || 0), update, dx, dy);
                    list.push(child);
                }
            }
            //this._updateChildTreePosition(layout, list);
            if (layout._graphNodes[node.name].tree.assistants.length) {
                for (i = 0; i < layout._graphNodes[node.name].tree.assistants.length; i++) {
                    child = layout.diagram.nameTable[layout._graphNodes[node.name].tree.assistants[i]];
                    this._updateNodes(layout, child, mod + (layout._graphNodes[node.name].subTreeTranslation || 0), null, dx, dy);
                }
            }
            layout.diagram._updateQuad(layout.diagram.nameTable[node.name]);
            if (layout.diagram._svg)
                ej.datavisualization.Diagram.DiagramContext.update(node, layout.diagram);
        },

        _withinView: function (newoffsetX, newoffsetY, width, height, node, layout) {
            var left = layout.diagram.model.scrollSettings.horizontalOffset / layout.diagram.model.scrollSettings.currentZoom;
            var top = layout.diagram.model.scrollSettings.verticalOffset / layout.diagram.model.scrollSettings.currentZoom;
            var right = layout.diagram.model.scrollSettings.viewPortWidth / layout.diagram.model.scrollSettings.currentZoom + left;
            var bottom = layout.diagram.model.scrollSettings.viewPortHeight / layout.diagram.model.scrollSettings.currentZoom + top;
            if ((newoffsetX + width / 2 > left || node.offsetX + width / 2 > left) && (newoffsetX - width / 2 < right || node.offsetX - width / 2 < right) &&
            (newoffsetY + height / 2 > top || node.offsetY + height / 2 > top) && (newoffsetY - height / 2 < bottom || node.offsetY - height / 2 < bottom)) {
                return true;
            }
            return false;
        },

        _getDimensions: function (layout, shape, x, y, level) {
            var width = shape.width ? shape.width : shape._width;
            var height = shape.height ? shape.height : shape._height;
            if (layout.orientation == "lefttoright" || layout.orientation == "righttoleft") {
                if (!level) {
                    var temp = x;
                    x = y;
                    y = temp;
                }
                height = shape.width ? shape.width : shape._width;
                width = shape.height ? shape.height : shape._height;
            }
            return { x: x, y: y, width: width, height: height };
        },

        _getParentNode: function (layout, node) {
            //Return the first parent node
            if (node.inEdges && node.inEdges.length) {
                return layout.diagram.nameTable[layout.diagram.nameTable[node.inEdges[0]].sourceNode];
            }
        },

        _hasChild: function (layout, shape) {
            //Check whether the node has children
            var shape = layout._graphNodes[shape.name];
            return shape.tree.children && shape.tree.children.length;
        },

        _setUpLayoutInfo: function (layout, item) {
            //Initialize graph node info
            var info = {};
            info.subTreeTranslation = 0;
            if (layout.type == "organizationalchart")
                info.tree = { orientation: "vertical", type: "alternate", offset: 20, enableRouting: true };
            else if (layout.type == "hierarchicaltree")
                info.tree = { orientation: "horizontal", type: "center", enableRouting: true };
            info.tree.children = [];
            info.tree.assistants = [];
            info.tree.level = 0;
            info.translate = true;
            return info;
        }

    };
    //end region

    //region Radialtree layout
    ej.datavisualization.Diagram.RadialTreeLayout = {
        doLayout: function (layout) {
            var diagram, nodes, node;
            diagram = layout.diagram;
            nodes = diagram.nodes();
            for (var i = 0; i < nodes.length; i++) {
                if (!nodes[i].excludeFromLayout) {
                    layout._graphNodes[nodes[i].name] = this._setUpLayoutInfo(layout, nodes[i]);
                    if (!nodes[i].inEdges || !nodes[i].inEdges.length) { layout._firstLevelNodes.push(nodes[i]); }
                }
            }
            if (layout.rootNode && diagram.nameTable[layout.rootNode])
                layout._centerNode = diagram.nameTable[layout.rootNode];
            else if (layout._firstLevelNodes.length) {
                layout._centerNode = layout._firstLevelNodes[0];
                diagram.model.layout.rootNode = layout._centerNode.name;
            }
            if (layout._centerNode) {
                this._updateEdges(layout, layout._centerNode, 0);
                this._depthFirstAllignment(layout, layout._centerNode, 0, 0);
                this._populateLevels(layout);
                this._transformToCircleLayout(layout);
                this._updateAnchor(layout);
                this._updateNodes(layout, layout._centerNode)
            }
        },

        _updateEdges: function (layout, node, depth) {
            var nodeInfo = layout._graphNodes[node.name];
            layout.layoutNodes.push(nodeInfo);
            nodeInfo.level = depth;
            nodeInfo.visited = true;
            layout.maxLevel = Math.max(layout.maxLevel, depth);
            for (var j = 0; j < node.outEdges.length; j++) {
                var edge = layout.diagram.nameTable[layout.diagram.nameTable[node.outEdges[j]].targetNode];
                if (!edge.excludeFromLayout && !edge.visited) {
                    nodeInfo.children.push(edge);
                    this._updateEdges(layout, edge, depth + 1);
                }
            }
        },

        _depthFirstAllignment: function (layout, node, x, y) {
            if (node) {
                var newValue;
                var nodeInfo = layout._graphNodes[node.name];
                if (nodeInfo.children.length) {
                    y += 300;
                    for (var i = 0; i < nodeInfo.children.length; i++) {
                        newValue = this._depthFirstAllignment(layout, nodeInfo.children[i], x, y);
                        x = newValue.x; y = newValue.y;
                    }
                    nodeInfo.children = nodeInfo.children.sort(function (obj1, obj2) { return layout._graphNodes[obj1.name].x - layout._graphNodes[obj2.name].x; });
                    var min = layout._graphNodes[nodeInfo.children[0].name].min;
                    var max = layout._graphNodes[nodeInfo.children[nodeInfo.children.length - 1].name].max;
                    nodeInfo.x = min + (max - min) / 2;
                    x = max + layout.horizontalSpacing;
                    nodeInfo.segmentOffset = max + layout.horizontalSpacing;
                    nodeInfo.x -= nodeInfo.width / 2;
                    nodeInfo.y -= nodeInfo.height / 2;
                    nodeInfo.min = min;
                    nodeInfo.max = max;
                    if (nodeInfo.x < min && nodeInfo.visited) {
                        nodeInfo.x = min;
                        x = nodeInfo.x + nodeInfo.width / 2 - (max - min) / 2;
                        nodeInfo.visited = false;
                        for (var i = 0; i < nodeInfo.children.length; i++) {
                            newValue = this._depthFirstAllignment(layout, nodeInfo.children[i], x, y);
                        }
                        nodeInfo.visited = true;
                        x = nodeInfo.x + nodeInfo.width + layout.horizontalSpacing;
                    }
                    max = layout._graphNodes[nodeInfo.children[nodeInfo.children.length - 1].name].segmentOffset;
                    x = x < max ? max : x;
                    y -= 300;
                    nodeInfo.y = y;
                }
                else {
                    nodeInfo.x = x;
                    nodeInfo.y = y;
                    nodeInfo.min = x;
                    nodeInfo.max = x + nodeInfo.width;
                    x += nodeInfo.width + layout.horizontalSpacing;
                }
                return { x: x, y: y };
            }
        },

        _populateLevels: function (layout) {
            var stages = [];
            var min = Math.min.apply(Math, layout.layoutNodes.map(function (nodeInfo) { return nodeInfo.x; }));
            var max = Math.max.apply(Math, layout.layoutNodes.map(function (nodeInfo) { return nodeInfo.x + nodeInfo.width + layout.horizontalSpacing; }));
            var full = max - min;
            layout.levels = [];
            for (var i = 0; i <= layout.maxLevel; i++) {
                stages = layout.layoutNodes.filter(function (nodeInfo) { if (nodeInfo.level == i) return nodeInfo; });
                var newlevel = {};
                stages = stages.sort(function (nodeInfo1, nodeInfo2) { return nodeInfo1.x - nodeInfo2.x; });
                newlevel.min = stages[0].x;
                newlevel.max = stages[stages.length - 1].x + stages[stages.length - 1].width + layout.horizontalSpacing;
                newlevel._actualCircumference = 0;
                newlevel.height = 0;
                for (var k = 0; k < stages.length; k++) {
                    if (stages[k].height > newlevel.height) newlevel.height = stages[k].height;
                    newlevel._actualCircumference += Math.max(stages[k].width, stages[k].height);
                    if (k != stages.length - 1) newlevel._actualCircumference += layout.horizontalSpacing;
                }
                newlevel.circumference = newlevel.max - newlevel.min;
                if (newlevel._actualCircumference < newlevel.circumference) newlevel.circumference = (newlevel.circumference + newlevel._actualCircumference) / 2;
                newlevel.radius = newlevel.circumference / (2 * Math.PI) + newlevel.height;
                newlevel.nodes = [];
                if (i > 1) {
                    if (layout.levels[i - 1].radius + layout.levels[i - 1].height >= newlevel.radius)
                        newlevel.radius = layout.levels[i - 1].radius + layout.levels[i - 1].height;
                }
                for (var j = 0; j < stages.length; j++) {
                    stages[j].ratio = Math.abs(stages[j].x + stages[j].width / 2 - min) / full;
                    newlevel.nodes.push(stages[j]);
                }
                layout.levels.push(newlevel);
            }
        },

        _transformToCircleLayout: function (layout) {
            var root = layout._graphNodes[layout._centerNode.name];
            root.x = 0;
            root.y = 0;
            //root.x = -root.width;
            //root.y = -root.height;
            for (var i = 1; i < layout.levels.length; i++) {
                for (var j = 0; j < layout.levels[i].nodes.length; j++) {
                    var nodeInfo = layout.levels[i].nodes[j];
                    nodeInfo.x = Math.cos(nodeInfo.ratio * 360 * Math.PI / 180) * (layout.levels[i].radius + layout.verticalSpacing * i);
                    nodeInfo.y = Math.sin(nodeInfo.ratio * 360 * Math.PI / 180) * (layout.levels[i].radius + layout.verticalSpacing * i);
                    //nodeInfo.x -= nodeInfo.width / 2;
                    //nodeInfo.y -= nodeInfo.height / 2;
                    layout._anchorX = Math.min(layout._anchorX, nodeInfo.x);
                    layout._anchorY = Math.min(layout._anchorY, nodeInfo.y);
                }
            }
        },

        _updateAnchor: function (layout) {
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(layout.diagram);
            layout._anchorX = viewPort.width / 2;
            layout._anchorY = viewPort.height / 2;
        },

        _updateNodes: function (layout, node) {
            var nodeInfo = layout._graphNodes[node.name];
            var offsetX = nodeInfo.x + layout._anchorX;
            var offsetY = nodeInfo.y + layout._anchorY;
            layout.diagram._translate(node, offsetX - node.offsetX || 0, offsetY - node.offsetY || 0, layout.diagram.nameTable);
            for (var i = 0; i < nodeInfo.children.length; i++) {
                var childInfo = nodeInfo.children[i];
                this._updateNodes(layout, layout.diagram.nameTable[childInfo.name]);
            }
            if (layout.diagram._svg)
                ej.datavisualization.Diagram.DiagramContext.update(node, layout.diagram);
        },

        _isValidLayout: function (layout) {
            if (layout._centerNode) {
                var maxParents = Math.max.apply(Math, layout.diagram.nodes().map(function (obj) { return obj.inEdges.length; }));
                if (maxParents < 2) return true;
            }
            return false;
        },

        _setUpLayoutInfo: function (layout, item) {
            var info = {};
            info.name = item.name;
            info.x = 0;
            info.y = 0;
            info.min = 0;
            info.max = 0;
            info.width = item.width ? item.width : item._width;
            info.height = item.height ? item.height : item._height;
            info.children = [];
            info.level = 0;
            info.ratio = 0;
            info.visited = false;
            return info;
        },

    };
    //end region
})(jQuery, Syncfusion);;

(function ($, ej) {
    "use strict";

    //#region ZoomAndPan
    ej.datavisualization.Diagram.ZoomUtil = {
        zoomPan: function (diagram, currentZoom, deltaX, deltaY, focusPoint, isZoom) {
            if ((isZoom && ej.datavisualization.Diagram.Util.canZooming(diagram)) || (!isZoom && ej.datavisualization.Diagram.Util.canPanning(diagram))) {
                var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(diagram, true);
                var oVal = {
                    zoom: diagram._getCurrentZoom(), horizontalOffset: diagram._hScrollOffset,
                    verticalOffset: diagram._vScrollOffset, viewPort: viewPort
                };
                var matrix = ej.Matrix.identity();
                ej.Matrix.scale(matrix, diagram._currZoom, diagram._currZoom);
                ej.Matrix.translate(matrix, -diagram._hScrollOffset, -diagram._vScrollOffset);
                var newScale = diagram._currZoom * currentZoom;
                if (newScale > 30) {
                    currentZoom = 30 / diagram._currZoom;
                }
                else if (newScale < 0.25) {
                    currentZoom = 0.25 / diagram._currZoom;
                }
                var dMatrix = ej.Matrix.identity();
                var pivot;
                if (focusPoint) {
                    pivot = ej.Matrix.transform(matrix, focusPoint);
                }
                else {
                    pivot = ej.datavisualization.Diagram.Point($(diagram.element).width() / 2, $(diagram.element).height() / 2);
                }
                ej.Matrix.scale(dMatrix, currentZoom, currentZoom, pivot.x, pivot.y);
                newScale = diagram._currZoom * currentZoom;
                ej.Matrix.translate(dMatrix, deltaX, deltaY);
                ej.Matrix.multiply(matrix, dMatrix);
                var point = ej.Matrix.transform(matrix, ej.datavisualization.Diagram.Point(0, 0));
                diagram._compareModelProperty("scrollSettings", true);
                this._applyTransform(diagram, newScale, point, isZoom, viewPort);
                var nVal = {
                    zoom: diagram._getCurrentZoom(), horizontalOffset: diagram._hScrollOffset,
                    verticalOffset: diagram._vScrollOffset, viewPort: viewPort
                };
                diagram._eventCause["scrollChange"] = ej.datavisualization.Diagram.ScrollChangeCause.Zoom;
				if(!isZoom)diagram._eventCause["scrollChange"] = ej.datavisualization.Diagram.ScrollChangeCause.Pan;
                diagram._raiseEvent("scrollChange", { newValues: nVal, oldValues: oVal });
            }
        },
        _applyTransform: function (diagram, currentZoom, point, isZoom, viewPort) {
            diagram._currZoom = currentZoom;
            var zoomX = point.x * -1;
            var zoomY = point.y * -1;
            var bounds = diagram._getDigramBounds();
            if (!isZoom) {
                if (diagram._scrollLimit() !== ej.datavisualization.Diagram.ScrollLimit.Infinity) {
                    if (diagram._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Diagram) {
                        bounds.x -= diagram.model.scrollSettings.padding.left;
                        bounds.y -= diagram.model.scrollSettings.padding.top;
                        bounds.width += diagram.model.scrollSettings.padding.left + diagram.model.scrollSettings.padding.right;
                        bounds.height += diagram.model.scrollSettings.padding.top + diagram.model.scrollSettings.padding.bottom;
                        var isBoundsWidthHigh = bounds.width * diagram._currZoom > viewPort.width;
                        var isBoundsHeightHigh = bounds.height * diagram._currZoom > viewPort.height;
                        var diffX = (bounds.width + bounds.x) * diagram._currZoom - viewPort.width;
                        var diffY = (bounds.height + bounds.y) * diagram._currZoom - viewPort.height;
                        if ((!isBoundsWidthHigh && zoomX > diagram._hScrollOffset && zoomX > bounds.x * diagram._currZoom) || (isBoundsWidthHigh && zoomX < diagram._hScrollOffset && zoomX < bounds.x * diagram._currZoom))
                            zoomX = diagram._hScrollOffset;
                        else if ((!isBoundsWidthHigh && zoomX < diagram._hScrollOffset && zoomX < diffX) || (isBoundsWidthHigh && zoomX > diagram._hScrollOffset && zoomX > diffX))
                            zoomX = diagram._hScrollOffset;
                        if ((!isBoundsHeightHigh && zoomY > diagram._vScrollOffset && zoomY > bounds.y * diagram._currZoom) || (isBoundsHeightHigh && zoomY < diagram._vScrollOffset && zoomY < bounds.y * diagram._currZoom))
                            zoomY = diagram._vScrollOffset;
                        else if ((!isBoundsHeightHigh && zoomY < diagram._vScrollOffset && zoomY < diffY) || (isBoundsHeightHigh && zoomY > diagram._vScrollOffset && zoomY > diffY))
                            zoomY = diagram._vScrollOffset;
                    }
                    else {
                        if (zoomX < diagram._hScrollbar.model.minimum && !(diagram._hScrollbar.model.minimum == 0 && -diagram._hScrollOffset > point.x))
                            zoomX = diagram._hScrollOffset;
                        else if (zoomX > diagram._hScrollbar.model.maximum) {
                            zoomX = diagram._hScrollbar.model.maximum;
                        }
                        if (zoomY < diagram._vScrollbar.model.minimum && !(diagram._vScrollbar.model.minimum == 0 && -diagram._vScrollOffset > point.y))
                            zoomY = diagram._vScrollOffset;
                        else if (zoomY > diagram._vScrollbar.model.maximum) {
                            zoomY = diagram._vScrollbar.model.maximum;
                        }
                    }
                }
            }
            diagram._updateScrollOffset(zoomX, zoomY, true, isZoom);
        }
    };
    //#endregion 

    //#region PageSettings
    ej.datavisualization.Diagram.PageUtil = {
        _createPageBreaks: function (diagram) {
            this._removePageBreaks(diagram);
            var attr = { id: diagram._canvas.id + "pagebreaks", "pointer-events": "none" };
            var g = ej.datavisualization.Diagram.SvgContext._initializePageBreaks(diagram._svg, attr, diagram._pageBackgroundLayer);
            this._updatePageBreaks(g, diagram);
        },
        _removePageBreaks: function (diagram) {
            var g = diagram._svg.getElementById(diagram._canvas.id + "pagebreaks");
            if (g) { ej.datavisualization.Diagram.SvgContext._removePageBreaks(diagram._svg, g, diagram._pageBackgroundLayer); }
        },
        _updatePageBreaks: function (g, diagram) {
            var bounds = diagram._getDigramBounds();
            var pageSettings = diagram.model.pageSettings;
            var left = bounds.x;
            var right = bounds.width + bounds.x;
            var top = bounds.y;
            var bottom = bounds.height + bounds.y;
            var zoom = diagram._currZoom;
            var pHeight = diagram._pageHeight();
            var pWidth = diagram._pageWidth();
            var pMargin = diagram._pageMargin();
            var columncount = parseInt(Math.ceil((right - left) / pWidth));
            var rowcount = parseInt(Math.ceil((bottom - top) / pHeight));
            left = -diagram._canvas.clientLeft + (pMargin + left) * zoom;
            top = -diagram._canvas.clientTop + (pMargin + top) * zoom;
            var width = (pWidth * columncount - pMargin * 2) * zoom;
            var height = (pHeight * rowcount - pMargin * 2) * zoom;
            ej.datavisualization.Diagram.SvgContext._renderVPageBreakLine(ej.datavisualization.Diagram.Point(left, top), ej.datavisualization.Diagram.Point(left + width, top), diagram._svg, g);
            ej.datavisualization.Diagram.SvgContext._renderHPageBreakLine(ej.datavisualization.Diagram.Point(left, top), ej.datavisualization.Diagram.Point(left, top + height), diagram._svg, g);
            for (var column = 1; column < columncount; column++) {
                ej.datavisualization.Diagram.SvgContext._renderVPageBreakLine(ej.datavisualization.Diagram.Point(left + (pWidth * column - pMargin) * zoom, top),
                    ej.datavisualization.Diagram.Point(left + (pWidth * column - pMargin) * zoom, top + height), diagram._svg, g);
            }
            for (var row = 1; row < rowcount; row++) {
                ej.datavisualization.Diagram.SvgContext._renderHPageBreakLine(ej.datavisualization.Diagram.Point(left, top + (pHeight * row - pMargin) * zoom),
                    ej.datavisualization.Diagram.Point(left + width, top + (pHeight * row - pMargin) * zoom), diagram._svg, g);
            }
            ej.datavisualization.Diagram.SvgContext._renderVPageBreakLine(ej.datavisualization.Diagram.Point(left + width, top), ej.datavisualization.Diagram.Point(left + width, top + height), diagram._svg, g);
            ej.datavisualization.Diagram.SvgContext._renderHPageBreakLine(ej.datavisualization.Diagram.Point(left, top + height), ej.datavisualization.Diagram.Point(left + width, top + height), diagram._svg, g);
        },
        _updatePageSize: function (diagram, updatePage) {
            var swap = false;
            if (diagram._pageOrientation() == ej.datavisualization.Diagram.PageOrientations.Landscape) {
                if (diagram._pageHeight() > diagram._pageWidth()) {
                    swap = true;
                }
            }
            else {
                if (diagram._pageWidth() > diagram._pageHeight()) {
                    swap = true;
                }
            }
            if (swap) {
                var temp = diagram._pageWidth();
                diagram._pageWidth(diagram._pageHeight());
                diagram._pageHeight(temp);
            }
            var bounds = diagram._getDigramBounds();
            var zoom = diagram._currZoom;
            var left = bounds.x * zoom;
            var top = bounds.y * zoom;
            var width = bounds.width * zoom;
            var height = bounds.height * zoom;
            var pageSettings = diagram.model.pageSettings;
            if (diagram._pageBackgroundLayer && diagram._pageBackgroundLayer.firstChild) {
                ej.datavisualization.Diagram.SvgContext._updatePageBakground(ej.datavisualization.Diagram.Point(left, top), ej.datavisualization.Diagram.Point(width, height), diagram._svg, diagram._pageBackgroundLayer, diagram._pageBorderColor(), diagram._pageBackgroundColor(), diagram._pageBorderWidth());
            }
            else {
                ej.datavisualization.Diagram.SvgContext._renderPageSettingsRect(ej.datavisualization.Diagram.Point(left, top), ej.datavisualization.Diagram.Point(width, height), diagram._svg, diagram._pageBackgroundLayer, diagram._pageBorderColor(), diagram._pageBackgroundColor(), diagram._pageBorderWidth());
            }
            if (diagram.model.backgroundImage && diagram.model.backgroundImage.source)
                ej.datavisualization.Diagram.SvgContext._updateBackground(diagram._hScrollOffset, diagram._vScrollOffset, diagram._currZoom, diagram);
            diagram._svg.document.style.left = 0;
            diagram._svg.document.style.top = 0;
            var check = false;
            if (!diagram._pageWidth()) {
                if (!diagram._pageHeight()) {
                    check = true;
                }
            }
            if (pageSettings.pageWidth && diagram._pageHeight()) {
                if (diagram._showPageBreak()) {
                    this._createPageBreaks(diagram);
                }
                else {
                    this._removePageBreaks(diagram);
                }
            }
            if (!updatePage)
                ej.datavisualization.Diagram.ScrollUtil._setScrollContentSize(diagram);
        }
    };
    //#endregion

    //#region Scroller
    ej.datavisualization.Diagram.ScrollUtil = {
        _transform: function (diagram, hOffset, vOffset, canScale) {
            ej.datavisualization.Diagram.SvgContext.transformView(diagram, -hOffset, -vOffset);
            if (canScale) {
                ej.datavisualization.Diagram.SvgContext.scaleContent(diagram, diagram._currZoom);
            }

            ej.datavisualization.Diagram.PageUtil._updatePageSize(diagram);
            // ej.datavisualization.Diagram.SvgContext._updateBackground(hOffset, vOffset, diagram._currZoom, diagram);
            ej.datavisualization.Diagram.SvgContext._updateGrid(hOffset, vOffset, diagram._currZoom, diagram);
        },
        _viewPort: function (diagram, update) {
            if (diagram._viewPort && !update) return diagram._viewPort;
            var element = diagram.element[0];
            var bRect = diagram.element[0].getBoundingClientRect();
            var eWidth = bRect.width;
            var vScrollHeight = diagram._vScrollbar && diagram._vScrollbar.model.height ? diagram._vScrollbar.model.height : null;
            var eHeight = vScrollHeight ? (bRect.height === vScrollHeight) ? vScrollHeight + 18 : bRect.height : bRect.height;
            var screenX = (window.screenX < 0) ? window.screenX * -1 : window.screenX;
            if (eWidth === 0) {
                eWidth = Math.floor(((window.innerWidth - screenX) - Math.floor(bRect.left)));
            }
            var screenY = (window.screenY < 0) ? window.screenY * -1 : window.screenY;
            if (eHeight === 0) {
                eHeight = Math.floor(((window.innerHeight - screenY) - Math.floor(bRect.window)));
            }
            return ej.datavisualization.Diagram.Size(eWidth, eHeight);
        },

        _union: function (rect, rect1) {
            if (rect.width <= 0) {
                rect = rect1;
                return rect;
            }
            if (rect.width > 0) {
                var num = Math.min(rect.x, rect1.x);
                var num2 = Math.min(rect.y, rect1.y);
                if (rect1.width === Infinity || rect.width === Infinity) {
                    rect.width = Infinity;
                }
                else {
                    var num3 = Math.max(rect.x + rect.width, rect1.x + rect1.width);
                    rect.width = Math.max(num3 - num, 0);
                }
                if (rect1.height === Infinity || rect.height === Infinity) {
                    rect.height = Infinity;
                }
                else {
                    var num4 = Math.max(rect.y + rect.height, rect1.y + rect1.height);
                    rect.height = Math.max(num4 - num2, 0);
                }
                rect.x = num;
                rect.y = num2;
                return rect;
            }
        },

        _setScrollContentSize: function (diagram) {
            var scale = diagram._currZoom;
            var viewPort = this._viewPort(diagram);
            viewPort = ej.datavisualization.Diagram.Rectangle(diagram._hScrollOffset, diagram._vScrollOffset, viewPort.width, viewPort.height);
            var scrollPadding = diagram.model.scrollSettings.padding;
            var left = diagram._spatialSearch.pageLeft;
            var right = diagram._spatialSearch.pageRight;
            var top = diagram._spatialSearch.pageTop;
            var bottom = diagram._spatialSearch.pageBottom;
            if (left > right) {
                left = right = 0;
            }
            if (top > bottom) {
                top = bottom = 0;
            }

            if (diagram.model.pageSettings) {
                var pageWidth = Number(diagram._pageWidth());
                var pageHeight = Number(diagram._pageHeight());

                if (pageWidth > 0 && pageHeight > 0) {
                    if (diagram._multiplePage()) {
                        left = Math.floor(left / pageWidth) * pageWidth;
                        top = Math.floor(top / pageHeight) * pageHeight;
                        right = Math.ceil(right / pageWidth) * pageWidth;
                        bottom = Math.ceil(bottom / pageHeight) * pageHeight;
                    }
                    else {
                        left = 0;
                        top = 0;
                        right = pageWidth;
                        bottom = pageHeight;
                    }
                    left -= scrollPadding.left;
                    right += scrollPadding.right;
                    top -= scrollPadding.top;
                    bottom += scrollPadding.bottom;
                }
                else {
                    left = left < 0 ? left : 0;
                    top = top < 0 ? top : 0;
                    right = right > viewPort.width ? right : viewPort.width;
                    bottom = bottom > viewPort.height ? bottom : viewPort.height;
                    if ((diagram._spatialSearch.pageLeft - left) < scrollPadding.left) left += diagram._spatialSearch.pageLeft - left - scrollPadding.left;
                    if ((diagram._spatialSearch.pageTop - top) < scrollPadding.top) top += diagram._spatialSearch.pageTop - top - scrollPadding.top;
                    if (diagram._spatialSearch.pageRight + scrollPadding.right > viewPort.width && diagram._spatialSearch.pageRight < viewPort.width) right += scrollPadding.right + diagram._spatialSearch.pageRight - viewPort.width;
                    else if (diagram._spatialSearch.pageRight > viewPort.width) right += scrollPadding.right;
                    if (diagram._spatialSearch.pageBottom + scrollPadding.bottom > viewPort.height && diagram._spatialSearch.pageBottom < viewPort.height) bottom += scrollPadding.bottom + diagram._spatialSearch.pageBottom - viewPort.height;
                    else if (diagram._spatialSearch.pageBottom > viewPort.height) bottom += scrollPadding.bottom;
                }
            }
            left = left * scale;
            top = top * scale;
            right = right * scale;
            bottom = bottom * scale;

            var diagramArea = ej.datavisualization.Diagram.Rectangle(0, 0, 0, 0);
            diagramArea = this._union(diagramArea, ej.datavisualization.Diagram.Rectangle(0, 0, viewPort.width, viewPort.height));
            diagramArea = this._union(diagramArea, ej.datavisualization.Diagram.Geometry.rect([{ x: left, y: top }, { x: right, y: bottom }]));
            diagramArea.width -= viewPort.width;
            diagramArea.height -= viewPort.height;

            if (diagramArea.x > diagram._hScrollOffset) {
                var diff = diagramArea.x - diagram._hScrollOffset;
                diagramArea.x -= diff;
                diagramArea.width += diff;
            }
            if (diagram._hScrollOffset > diagramArea.x + diagramArea.width) {
                diagramArea.width = diagram._hScrollOffset - diagramArea.x;
            }

            var minimumX = diagramArea.x;
            var maximumX = Math.max(0, diagramArea.x + diagramArea.width);

            if (diagramArea.y > diagram._vScrollOffset) {
                var diff = diagramArea.y - diagram._vScrollOffset;
                diagramArea.y -= diff;
                diagramArea.height += diff;
            }
            if (diagram._vScrollOffset > diagramArea.y + diagramArea.height) {
                diagramArea.height = diagram._vScrollOffset - diagramArea.y;
            }
            var minimumY = diagramArea.y;
            var maximumY = Math.max(0, diagramArea.y + diagramArea.height);

            diagramArea.width = diagramArea.width < viewPort.width ? viewPort.width : diagramArea.width;
            diagramArea.height = diagramArea.height < viewPort.height ? viewPort.height : diagramArea.height;

            if (diagram._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Limited) {
                var scrollableArea = diagram.model.pageSettings.scrollableArea;
                minimumX = scrollableArea.x * scale;
                minimumY = scrollableArea.y * scale;
                maximumX = (scrollableArea.x + scrollableArea.width) * scale - viewPort.width;
                maximumY = (scrollableArea.y + scrollableArea.height) * scale - viewPort.height;
                bottom = (scrollableArea.y + scrollableArea.height) * scale;
                right = (scrollableArea.x + scrollableArea.width) * scale;
                top = scrollableArea.y * scale;
                left = scrollableArea.x * scale;
            }

            if (left >= diagram._hScrollOffset && right <= viewPort.width + diagram._hScrollOffset) {
                diagram._hScrollbar._remove();
                diagram._hScrollbar.model.width = 0;
                if (diagram._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Limited) diagram._hScrollbar.model.minimum = Math.min(0, minimumX);
                else diagram._hScrollbar.model.minimum = 0;
                diagram._hScrollbar.model.maximum = 0;
            }
            else {
                if (!diagram._preventScrollerUpdate) {
                    $("#" + diagram._canvas.id + "_hScrollbar").ejScrollBar({ width: viewPort.width - 18, viewportSize: viewPort.width - 18, maximum: maximumX, minimum: minimumX });
                    $("#" + diagram._canvas.id + "_hScrollbar").ejScrollBar("scroll", diagram._hScrollOffset);
                }
                else {
                    diagram._hScrollbar.model.minimum = minimumX;
                    diagram._hScrollbar.model.maximum = maximumX;
                }
                var hScroll = document.getElementById(diagram._canvas.id + "_hScrollbar");
                hScroll.style.marginTop = viewPort.height - 18 + "px";
            }

            if (top >= diagram._vScrollOffset && bottom <= viewPort.height + diagram._vScrollOffset) {
                diagram._vScrollbar._remove();
                diagram._vScrollbar.model.height = 0;
                if (diagram._scrollLimit() === ej.datavisualization.Diagram.ScrollLimit.Limited) diagram._vScrollbar.model.minimum = Math.min(0, minimumY);
                else diagram._vScrollbar.model.minimum = 0;
                diagram._vScrollbar.model.maximum = 0;
            }
            else {
                if (!diagram._preventScrollerUpdate) {
                    $("#" + diagram._canvas.id + "_vScrollbar").ejScrollBar({ height: viewPort.height - 18, viewportSize: viewPort.height - 18, maximum: maximumY, minimum: minimumY });
                    $("#" + diagram._canvas.id + "_vScrollbar").ejScrollBar("scroll", diagram._vScrollOffset);
                }
                else {
                    diagram._vScrollbar.model.minimum = minimumY;
                    diagram._vScrollbar.model.maximum = maximumY;
                }
            }
            if (diagram._isMobile) diagram._disableScrollbar();
            ej.datavisualization.Diagram.SvgContext.setSize(diagram, diagramArea.width, diagramArea.height);
        },

        _setMinMaxValues: function (diagram, minX, minY, maxX, maxY, viewPort, scale) {
            var scrollableArea = diagram.model.pageSettings.scrollableArea;
            minX = Math.max(minX, scrollableArea.x * scale);
            minY = Math.max(minY, scrollableArea.y * scale);
            maxX = Math.min((scrollableArea.x + scrollableArea.width) * scale - viewPort.width, maxX);
            maxY = Math.min((scrollableArea.y + scrollableArea.height) * scale - viewPort.height, maxY);
            maxX = maxX > 0 ? maxX : 0;
            maxY = maxY > 0 ? maxY : 0;
            return { minX: minX, minY: minY, maxX: maxX, maxY: maxY };
        },

        _initScrollbar: function (diagram) {
            var canvas = diagram._canvas;
            var hScrollbar = document.getElementById(canvas.id + "_hScrollbar");
            var vScrollbar = document.getElementById(canvas.id + "_vScrollbar");
            var viewPort = this._viewPort(diagram);
            $(hScrollbar).ejScrollBar({
                orientation: ej.ScrollBar.Orientation.Horizontal,
                width: viewPort.width - 18,
                viewportSize: viewPort.width - 18,
                scroll: function (e) {
                    if (e.source != null) {
                        if (e.source == "thumb" || e.source == "button" || e.source == "key") {
                            if (e.scrollData != null) {
                                var oVal = {
                                    zoom: diagram._getCurrentZoom(), horizontalOffset: diagram._hScrollOffset,
                                    verticalOffset: diagram._vScrollOffset, viewPort: diagram._viewPort
                                };
                                diagram._updateScrollOffset(e.scrollLeft, diagram._vScrollOffset);
                                var nVal = {
                                    zoom: diagram._getCurrentZoom(), horizontalOffset: diagram._hScrollOffset,
                                    verticalOffset: diagram._vScrollOffset, viewPort: diagram._viewPort
                                };
                                diagram._compareModelProperty("scrollSettings", true);
                                diagram._eventCause["scrollChange"] = ej.datavisualization.Diagram.ScrollChangeCause.Pan;
                                diagram._raiseEvent("scrollChange", { newValues: nVal, oldValues: oVal });
                            }
                        }
                    }
                }
            });
            diagram._hScrollbar = $(hScrollbar).ejScrollBar("instance");

            $(vScrollbar).ejScrollBar({
                orientation: ej.ScrollBar.Orientation.Vertical,
                height: viewPort.height - 18,
                viewportSize: viewPort.height - 18,
                scroll: function (e) {
                    if (e.source != null) {
                        if (e.source == "thumb" || e.source == "button" || e.source == "key") {
                            if (e.scrollData != null) {
                                var oVal = {
                                    zoom: diagram._getCurrentZoom(), horizontalOffset: diagram._hScrollOffset,
                                    verticalOffset: diagram._vScrollOffset, viewPort: diagram._viewPort
                                };
                                diagram._updateScrollOffset(diagram._hScrollOffset, e.scrollTop);
                                var nVal = {
                                    zoom: diagram._getCurrentZoom(), horizontalOffset: diagram._hScrollOffset,
                                    verticalOffset: diagram._vScrollOffset, viewPort: diagram._viewPort
                                };
                                diagram._compareModelProperty("scrollSettings", true);
                                diagram._eventCause["scrollChange"] = ej.datavisualization.Diagram.ScrollChangeCause.Pan;
                                diagram._raiseEvent("scrollChange", { newValues: nVal, oldValues: oVal });
                            }
                        }
                    }
                }
            });
            diagram._vScrollbar = $(vScrollbar).ejScrollBar("instance");

        },
    };
    //#endregion

    //#region Snapping
    ej.datavisualization.Diagram.SnapUtil = {
        _canConsider: function (nameTable, selectedObject, target) {
            var consider = false;
            if (selectedObject != target) {
                if (selectedObject._type == "group" || selectedObject._type == "pseudoGroup") {
                    consider = (target.isSwimlane && !selectedObject.isSwimlane) ? false : !this._contains(nameTable, selectedObject, target);
                }
                else if ((target._type == "group" && target.type != "bpmn") || target.type == "pseudoGroup")
                    consider = (target.isSwimlane && !selectedObject.isSwimlane) ? false : !this._contains(nameTable, target, selectedObject);
                else if (!selectedObject.segments) {
                    consider = !(selectedObject == target);
                }
            }
            return consider;
        },
        _contains: function (nameTable, group, target) {
            var name = target.name;
            var node = null;
            if (group.children.indexOf(name) >= 0) {
                node = nameTable[name];
                if (node == target)
                    return true;
            }
            else if (group.children.indexOf(target) >= 0) {
                return true;
            }
            if (group._type == "group" || group._type == "pseudoGroup") {
                var contains = false;
                for (var i = 0; i < group.children.length; i++) {
                    if (this.diagram) {
                        var child = typeof group.children[i] == "string" ? nameTable[group.children[i]] : nameTable[group.children[i].name];
                        if (child) {
                            if (typeof child == "string") child = nameTable[child];
                            if (child._type == "group")
                                contains = this._contains(nameTable, child, target);
                            if (contains) return contains;
                        }
                    }
                }
                return contains;
            }
            //return this._contains(nameTable, node, child);
            return false;
        },
        _round: function (value, snapintervals, scale) {
            if (scale > 1) scale = Math.pow(2, Math.floor(Math.log(scale) / Math.log(2)));
            else scale = Math.pow(2, Math.ceil(Math.log(scale) / Math.log(2)));
            var cutoff = 0, i;
            for (i = 0; i < snapintervals.length; i++) {
                cutoff += snapintervals[i];
            }
            cutoff /= scale;
            var quotient = Math.floor(Math.abs(value) / cutoff);
            var bal = value % cutoff;
            var prev = quotient * cutoff;
            if (prev != value) {
                if (value >= 0) {
                    for (i = 0; i < snapintervals.length ; i++) {
                        if (bal <= snapintervals[i] / scale) {
                            return prev + (bal < (snapintervals[i] / (2 * scale)) ? 0 : snapintervals[i] / scale);
                        }
                        else {
                            prev += snapintervals[i] / scale;
                            bal -= snapintervals[i] / scale;
                        }
                    }
                }
                else {
                    prev = prev * -1;
                    for (i = snapintervals.length - 1; i >= 0; i--) {
                        if (Math.abs(bal) <= snapintervals[i] / scale) {
                            return prev - (Math.abs(bal) < (snapintervals[i] / (2 * scale)) ? 0 : snapintervals[i] / scale);
                        }
                        else {
                            prev -= snapintervals[i] / scale;
                            bal += snapintervals[i] / scale;
                        }
                    }
                }
            }
            return value;
        },
        _findNodes: function (spatialSearch, node, child, viewPort, nodesInView) {
            var nodes = [], quad, nd, bounds;
            var quads;
            quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(spatialSearch, nodesInView ? viewPort : child);
            for (var i = 0; i < quads.length; i++) {
                quad = quads[i];
                if (quad.objects.length > 0) {
                    for (var j = 0; j < quad.objects.length; j++) {
                        nd = quad.objects[j];
                        if (!nd.segments && nd.visible) {
                            bounds = ej.datavisualization.Diagram.Util.bounds(nd);
                            if (nodes.indexOf(nd) == -1 && ej.datavisualization.Diagram.Geometry.intersectsRect(child, bounds))
                                nodes.push(nd);
                            if (nodesInView && nodesInView.indexOf(nd) && ej.datavisualization.Diagram.Geometry.intersectsRect(viewPort, bounds)) {
                                nodesInView.push(nd);
                            }
                        }
                    }
                }
            }
            return nodes;
        },
        _snapAngle: function (diagram, angle) {
            var snapAngle = diagram._snapAngle();
            var width = angle % snapAngle;
            if (width >= (snapAngle / 2)) {
                return angle + snapAngle - width;
            }
            else {
                return angle - width;
            }
        },
        _snapPoint: function (diagram, selectedObject, towardsLeft, towardsTop, del, endPoint, startPoint) {
            var snapSettings = diagram.model.snapSettings;
            var zoomFactor = diagram._currZoom;
            var offset = ej.datavisualization.Diagram.Point();
            var bounds = ej.datavisualization.Diagram.Util.bounds(selectedObject);
            var horizontallysnapped = { snapped: false, offset: 0 };
            var verticallysnapped = { snapped: false, offset: 0 };
            this.diagram = diagram;
            if (diagram._enableSnapToObject())
                this._snapObject(diagram, selectedObject, horizontallysnapped,
                    verticallysnapped, del, startPoint == endPoint);
            //original position
            var left = bounds.x + del.x;
            var top = bounds.y + del.y;
            var right = bounds.x + bounds.width + del.x;
            var bottom = bounds.y + bounds.height + del.y;
            //snapped positions
            var roundedRight = this._round(right, snapSettings.verticalGridLines.snapInterval, zoomFactor);
            var roundedLeft = this._round(left, snapSettings.verticalGridLines.snapInterval, zoomFactor);
            var roundedTop = this._round(top, snapSettings.horizontalGridLines.snapInterval, zoomFactor);
            var roundedBottom = this._round(bottom, snapSettings.horizontalGridLines.snapInterval, zoomFactor);
            //currentposition
            var currentright = bounds.x + bounds.width;
            var currentbottom = bounds.y + bounds.height;
            if (!horizontallysnapped.snapped) {
                if (diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.SnapToVerticalLines) {
                    if (Math.abs(del.x) >= 1) {
                        if (towardsLeft) {
                            if (Math.abs(roundedRight - currentright) > Math.abs(roundedLeft - bounds.x)) {
                                offset.x += roundedLeft - bounds.x;
                            } else
                                offset.x += roundedRight - currentright;
                        } else {
                            if (Math.abs(roundedRight - currentright) < Math.abs(roundedLeft - bounds.x)) {
                                offset.x += roundedRight - currentright;
                            } else
                                offset.x += roundedLeft - bounds.x;
                        }
                    }
                } else {
                    offset.x = endPoint.x - startPoint.x;
                }
            } else {
                if (diagram._enableSnapToObject())
                    offset.x = horizontallysnapped.offset;
                else
                    offset.x = endPoint.x - startPoint.x;
            }
            if (!verticallysnapped.snapped) {
                if (diagram._snapConstraints() & ej.datavisualization.Diagram.SnapConstraints.SnapToHorizontalLines) {
                    if (Math.abs(del.y) >= 1) {
                        if (towardsTop) {
                            if (Math.abs(roundedBottom - currentbottom) > Math.abs(roundedTop - bounds.y)) {
                                offset.y += roundedTop - bounds.y;
                            }
                            else
                                offset.y += roundedBottom - currentbottom;
                        }
                        else {
                            if (Math.abs(roundedBottom - currentbottom) < Math.abs(roundedTop - bounds.y)) {
                                offset.y += roundedBottom - currentbottom;
                            }
                            else
                                offset.y += roundedTop - bounds.y;
                        }
                    }
                }
                else
                    offset.y = endPoint.y - startPoint.y;
            }
            else
                offset.y = verticallysnapped.offset;

            return offset;
        },
        _snapObject: function (diagram, selectedObject, hSnap, vSnap, del, ended) {
            var lengthX = null, lengthY = null;
            var hTarget, vTarget;
            var objectsAtLeft = [], objectsAtRight = [], objectsAtTop = [], objectsAtBottom = [];
            var bounds = ej.datavisualization.Diagram.Util.bounds(selectedObject);
            var scale = diagram._currZoom;
            var hoffset = diagram._hScrollOffset;
            var voffset = diagram._vScrollOffset;
            var snapObjDistance = diagram._snapObjectDistance();
            var viewPort = diagram._viewPort;
            var hIntersectRect = ej.datavisualization.Diagram.Rectangle(hoffset / scale, (bounds.y - snapObjDistance - 5), viewPort.width / scale,
                (bounds.height + 2 * snapObjDistance + 10));
            var vIntersectRect = ej.datavisualization.Diagram.Rectangle((bounds.x - snapObjDistance - 5), voffset / scale,
                (bounds.width + 2 * snapObjDistance + 10), viewPort.height / scale);
            viewPort = ej.datavisualization.Diagram.Rectangle(hoffset / scale, voffset / scale, viewPort.width / scale,
                viewPort.height / scale);
            var nodes = this._findNodes(diagram._spatialSearch, selectedObject, vIntersectRect, viewPort);
            var i, target, targetBounds;
            var nameTable = diagram.nameTable;
            for (i = 0; i < nodes.length; i++) {
                target = nodes[i];
                if (ej.datavisualization.Diagram.Util._canBeTarget(diagram, target)) {
                    if (!target.segments && this._canConsider(nameTable, selectedObject, target)) {
                        targetBounds = ej.datavisualization.Diagram.Util.bounds(target);
                        if (targetBounds.y + targetBounds.height < bounds.y + del.y) {
                            objectsAtTop.push({ object: target, distance: Math.abs(bounds.y + del.y - targetBounds.y - targetBounds.height) });
                        }
                        else if (targetBounds.y > bounds.y + del.y + bounds.height) {
                            objectsAtBottom.push({ object: target, distance: Math.abs(bounds.y + del.y + bounds.height - targetBounds.y) });
                        }
                        if (lengthX == null || lengthX > Math.abs(targetBounds.y - bounds.y - del.y)) {
                            if (Math.abs(targetBounds.x + targetBounds.width / 2 - (bounds.x + bounds.width / 2 + del.x)) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "centerX");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            } else if (Math.abs(targetBounds.x - (bounds.x + del.x)) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "left");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            } else if (Math.abs(targetBounds.x + targetBounds.width - (bounds.x + bounds.width + del.x)) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "right");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            } else if (Math.abs(targetBounds.x + targetBounds.width - (bounds.x + del.x)) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "leftRight");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            } else if (Math.abs(targetBounds.x - (bounds.x + bounds.width + del.x)) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "rightLeft");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            }
                        }
                    }
                }
            }
            nodes = this._findNodes(diagram._spatialSearch, selectedObject, hIntersectRect, viewPort);
            for (i = 0; i < nodes.length; i++) {
                target = nodes[i];
                if (ej.datavisualization.Diagram.Util._canBeTarget(diagram, target)) {
                    if (!target.segments && this._canConsider(nameTable, selectedObject, target)) {
                        targetBounds = ej.datavisualization.Diagram.Util.bounds(target);
                        if (targetBounds.x + targetBounds.width < bounds.x + del.x) {
                            objectsAtLeft[objectsAtLeft.length] = { object: target, distance: Math.abs((bounds.x + del.x) - targetBounds.x - targetBounds.width) };
                        }
                        if (targetBounds.x > bounds.x + del.x + bounds.width) {
                            objectsAtRight[objectsAtRight.length] = { object: target, distance: Math.abs(bounds.x + del.x + bounds.width - targetBounds.x) };
                        }
                        if (lengthY == null || lengthY > Math.abs(targetBounds.x - bounds.x - del.x)) {
                            if (Math.abs(targetBounds.y + targetBounds.height / 2 - (bounds.y + bounds.height / 2 + del.y)) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "centerY");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            } else if (Math.abs(targetBounds.y - bounds.y - del.y) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "top");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            } else if (Math.abs(targetBounds.y + targetBounds.height - (bounds.y + bounds.height + del.y)) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "bottom");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            } else if (Math.abs(targetBounds.y + targetBounds.height - bounds.y - del.y) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "topBottom");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            } else if (Math.abs(targetBounds.y - (bounds.y + bounds.height + del.y)) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "bottomTop");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            }
                        }
                    }
                }
            }
            var g = this._createGuidelines(diagram, hTarget, vTarget, hSnap, vSnap, ended);
            if (!hSnap.snapped) {
                this._createHSpacingLines(diagram, selectedObject, objectsAtLeft, objectsAtRight, hSnap, vSnap, ended, g, del, snapObjDistance);
            }
            if (!vSnap.snapped) {
                this._createVSpacingLines(diagram, selectedObject, objectsAtTop, objectsAtBottom, hSnap, vSnap, ended, g, del, snapObjDistance);
            }
        },

        _snapSize: function (diagram, hSnap, vSnap, delx, dely, selectedObject, ended) {
            var lengthX = null, lengthY = null;
            var hTarget;
            var vTarget;
            var bounds = ej.datavisualization.Diagram.Util.bounds(selectedObject);
            var nameTable = diagram.nameTable;
            var sameWidth = [];
            var sameHeight = [];
            var scale = diagram._currZoom;
            var hoffset = diagram._hScrollOffset;
            var voffset = diagram._vScrollOffset;
            var snapObjDistance = diagram._snapObjectDistance();
            var viewPort = diagram._viewPort;
            var hintersectedrect = ej.datavisualization.Diagram.Rectangle(hoffset / scale, (bounds.y - 5) / scale,
                viewPort.width / scale, (bounds.height + 10) / scale);
            var vintersectedrect = ej.datavisualization.Diagram.Rectangle((bounds.x - 5) / scale, voffset / scale,
                (bounds.width + 10) / scale, viewPort.height / scale);
            viewPort = ej.datavisualization.Diagram.Rectangle(hoffset / scale, voffset / scale, viewPort.width / scale,
               viewPort.height / scale);
            var nodesInView = [];
            var nodes = this._findNodes(diagram._spatialSearch, selectedObject, vintersectedrect, viewPort, nodesInView);
            var i, target, targetBounds;
            for (i = 0; i < nodes.length; i++) {
                target = nodes[i];
                if (this._canConsider(nameTable, selectedObject, target) && !target.segments) {
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(target);
                    if (lengthX == null || lengthX > Math.abs(targetBounds.y - bounds.y)) {
                        if (hSnap.left) {
                            if (Math.abs(bounds.x + delx - targetBounds.x) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "left");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            }
                            else if (Math.abs(bounds.x + delx - targetBounds.x - targetBounds.width) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "leftRight");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            }
                        }
                        else if (hSnap.right) {
                            if (Math.abs(bounds.x + delx + bounds.width - targetBounds.x - targetBounds.width) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "right");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            }
                            else if (Math.abs(bounds.x + delx + bounds.width - targetBounds.x) <= snapObjDistance) {
                                hTarget = this._createSnapObject(targetBounds, bounds, "rightLeft");
                                lengthX = Math.abs(targetBounds.y - bounds.y);
                            }
                        }
                    }
                }
            }
            nodes = this._findNodes(diagram._spatialSearch, selectedObject, hintersectedrect, viewPort);
            for (i = 0; i < nodes.length; i++) {
                target = nodes[i];
                if (this._canConsider(nameTable, selectedObject, target) && !target.segments) {
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(target);
                    if (lengthY == null || lengthY > Math.abs(targetBounds.x - bounds.x)) {
                        if (vSnap.top) {
                            if (Math.abs(bounds.y + dely - targetBounds.y) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "top");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            }
                            else if (Math.abs(bounds.y + dely - targetBounds.y - targetBounds.height) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "topBottom");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            }
                        }
                        else if (vSnap.bottom) {
                            if (Math.abs(bounds.y + bounds.height + dely - targetBounds.y - targetBounds.height) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "bottom");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            }
                            else if (Math.abs(bounds.y + bounds.height + dely - targetBounds.y) <= snapObjDistance) {
                                vTarget = this._createSnapObject(targetBounds, bounds, "bottomTop");
                                lengthY = Math.abs(targetBounds.x - bounds.x);
                            }
                        }
                    }
                }
            }
            for (i = 0; i < nodesInView.length; i++) {
                target = nodesInView[i];
                if (this._canConsider(nameTable, selectedObject, target)) {
                    var targetbounds = ej.datavisualization.Diagram.Util.bounds(target);
                    var del = hSnap.left ? -delx : delx;
                    var diff = Math.abs(bounds.width + del - targetbounds.width);
                    var actualDiff;
                    if (diff <= snapObjDistance) {
                        actualDiff = hSnap.left ? -targetbounds.width + bounds.width : targetbounds.width - bounds.width;
                        sameWidth[sameWidth.length] = { source: target, diff: diff, offset: actualDiff };
                    }
                    del = vSnap.top ? -dely : dely;
                    var dify = Math.abs(bounds.height + del - targetbounds.height);
                    if (dify <= snapObjDistance) {
                        actualDiff = vSnap.top ? -targetbounds.height + bounds.height : targetbounds.height - bounds.height;
                        sameHeight[sameHeight.length] = { source: target, diff: dify, offset: actualDiff };
                    }
                }
            }
            if (!diagram.activeTool.selectedSeperator)
                var g = this._createGuidelines(diagram, hTarget, vTarget, hSnap, vSnap, ended);
            if (!hSnap.snapped && sameWidth.length > 0 && (hSnap.left || hSnap.right)) {
                this._addSameWidthLines(diagram, sameWidth, hSnap, ended, g, selectedObject);
            }
            if (!vSnap.snapped && sameHeight.length > 0 && (vSnap.top || vSnap.bottom)) {
                this._addSameHeightLines(diagram, sameHeight, vSnap, ended, g, selectedObject);
            }
        },
        _createSnapObject: function (targetbounds, bounds, snap) {
            var snapObject;
            switch (snap) {
                case "left":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(targetbounds.x, Math.min(targetbounds.y, bounds.y)),
                        end: ej.datavisualization.Diagram.Point(targetbounds.x, Math.max(targetbounds.y + targetbounds.height, bounds.y + bounds.height)),
                        offsetX: targetbounds.x - bounds.x, offsetY: 0, type: "sideAlign"
                    };
                    break;
                case "right":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(targetbounds.x + targetbounds.width, Math.min(targetbounds.y, bounds.y)),
                        end: ej.datavisualization.Diagram.Point(targetbounds.x + targetbounds.width, Math.max(targetbounds.y + targetbounds.height, bounds.y + bounds.height)),
                        offsetX: targetbounds.x + targetbounds.width - bounds.x - bounds.width, offsetY: 0, type: "sideAlign"
                    };
                    break;
                case "top":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(Math.min(targetbounds.x, bounds.x), targetbounds.y),
                        end: ej.datavisualization.Diagram.Point(Math.max(targetbounds.x + targetbounds.width, bounds.x + bounds.width), targetbounds.y),
                        offsetY: targetbounds.y - bounds.y, offsetX: 0, type: "sideAlign"
                    };
                    break;
                case "bottom":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(Math.min(targetbounds.x, bounds.x), targetbounds.y + targetbounds.height),
                        end: ej.datavisualization.Diagram.Point(Math.max(targetbounds.x + targetbounds.width, bounds.x + bounds.width), targetbounds.y + targetbounds.height),
                        offsetY: targetbounds.y + targetbounds.height - bounds.y - bounds.height, offsetX: 0, type: "sideAlign"
                    };
                    break;
                case "topBottom":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(Math.min(targetbounds.x, bounds.x), targetbounds.y + targetbounds.height),
                        end: ej.datavisualization.Diagram.Point(Math.max(targetbounds.x + targetbounds.width, bounds.x + bounds.width), targetbounds.y + targetbounds.height),
                        offsetY: targetbounds.y + targetbounds.height - bounds.y, offsetX: 0, type: "sideAlign"
                    };
                    break;
                case "bottomTop":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(Math.min(targetbounds.x, bounds.x), targetbounds.y),
                        end: ej.datavisualization.Diagram.Point(Math.max(targetbounds.x + targetbounds.width, bounds.x + bounds.width), targetbounds.y),
                        offsetY: targetbounds.y - bounds.y - bounds.height, offsetX: 0, type: "sideAlign"
                    };
                    break;
                case "leftRight":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(targetbounds.x + targetbounds.width, Math.min(targetbounds.y, bounds.y)),
                        end: ej.datavisualization.Diagram.Point(targetbounds.x + targetbounds.width, Math.max(targetbounds.y + targetbounds.height, bounds.y + bounds.height)),
                        offsetX: targetbounds.x + targetbounds.width - bounds.x, offsetY: 0, type: "sideAlign"
                    };
                    break;
                case "rightLeft":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(targetbounds.x, Math.min(targetbounds.y, bounds.y)),
                        end: ej.datavisualization.Diagram.Point(targetbounds.x, Math.max(targetbounds.y + targetbounds.height, bounds.y + bounds.height)),
                        offsetX: targetbounds.x - bounds.x - bounds.width, offsetY: 0, type: "sideAlign"
                    };
                    break;
                case "centerX":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(targetbounds.x + targetbounds.width / 2, Math.min(targetbounds.y, bounds.y)),
                        end: ej.datavisualization.Diagram.Point(targetbounds.x + targetbounds.width / 2, Math.max(targetbounds.y + targetbounds.height, bounds.y + bounds.height)),
                        offsetX: targetbounds.x + targetbounds.width / 2 - (bounds.x + bounds.width / 2), offsetY: 0, type: "centerAlign"
                    };
                    break;
                case "centerY":
                    snapObject = {
                        start: ej.datavisualization.Diagram.Point(Math.min(targetbounds.x, bounds.x), targetbounds.y + targetbounds.height / 2),
                        end: ej.datavisualization.Diagram.Point(Math.max(targetbounds.x + targetbounds.width, bounds.x + bounds.width), targetbounds.y + targetbounds.height / 2),
                        offsetY: targetbounds.y + targetbounds.height / 2 - (bounds.y + bounds.height / 2), offsetX: 0, type: "centerAlign"
                    };
                    break;
            }
            return snapObject;
        },
        _createGuidelines: function (diagram, hTarget, vTarget, hsnap, vsnap, ended) {
            var attr = { id: diagram._canvas.id + "guideline", "style": "pointer-events:none;" };
            var g = ej.datavisualization.Diagram.SvgContext._initializeGuidelines(diagram._adornerSvg, attr, diagram._adornerLayer);
            var scale = diagram._currZoom;
            var hOffset = diagram._hScrollOffset;
            var vOffset = diagram._vScrollOffset;
            if (hTarget) {
                hsnap.offset = hTarget.offsetX;
                hsnap.snapped = true;
                if (!ended) {
                    if (hTarget.type == "sideAlign") {
                        ej.datavisualization.Diagram.SvgContext._renderSideAlignmentLines(hTarget.start, hTarget.end, g, diagram._adornerSvg, scale, hOffset, vOffset);
                    }
                    else if (hTarget.type == "centerAlign") {
                        ej.datavisualization.Diagram.SvgContext._renderCenterAlignmentLines(hTarget.start, hTarget.end, g, diagram._adornerSvg, scale, hOffset, vOffset);
                    }
                }
            }
            if (vTarget) {
                vsnap.offset = vTarget.offsetY;
                vsnap.snapped = true;
                if (!ended) {
                    if (vTarget.type == "sideAlign") {
                        ej.datavisualization.Diagram.SvgContext._renderSideAlignmentLines(vTarget.start, vTarget.end, g, diagram._adornerSvg, scale, hOffset, vOffset);
                    }
                    else if (vTarget.type == "centerAlign") {
                        ej.datavisualization.Diagram.SvgContext._renderCenterAlignmentLines(vTarget.start, vTarget.end, g, diagram._adornerSvg, scale, hOffset, vOffset);
                    }
                }
            }
            return g;
        },
        _removeGuidelines: function (diagram) {
            var g = diagram._adornerSvg.getElementById(diagram._canvas.id + "guideline");
            if (g != null) { ej.datavisualization.Diagram.SvgContext._removeGuidelines(diagram._adornerLayer, g); }
        },
        _sortByDistance: function (obj, value, asc) {
            var i, j, temp;
            if (asc) {
                for (i = 0; i < obj.length; i++) {
                    for (j = i + 1; j < obj.length; j++) {
                        if (obj[i][value] > obj[j][value]) {
                            temp = obj[i];
                            obj[i] = obj[j];
                            obj[j] = temp;
                        }
                    }
                }
            }
            else {
                for (i = 0; i < obj.length; i++) {
                    for (j = i + 1; j < obj.length; j++) {
                        if (obj[i][value] < obj[j][value]) {
                            temp = obj[i];
                            obj[i] = obj[j];
                            obj[j] = temp;
                        }
                    }
                }
            }
        },
        _createHSpacingLines: function (diagram, shape, objectsAtLeft, objectsAtRight, hSnap, vSnap, ended, g, del, snapObjDistance) {
            var top = null;
            this._sortByDistance(objectsAtLeft, "distance", true);
            this._sortByDistance(objectsAtRight, "distance", true);
            var equallySpaced = [];
            var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
            var nearestleft, nearestright;
            var targetBounds;
            if (objectsAtLeft.length > 0) {
                equallySpaced[equallySpaced.length] = objectsAtLeft[0];
                nearestleft = ej.datavisualization.Diagram.Util.bounds(objectsAtLeft[0].object);
                top = nearestleft.y;
                if (objectsAtLeft.length > 1) {
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtLeft[1].object);
                    var equaldistance = nearestleft.x - targetBounds.x - targetBounds.width;
                    if (Math.abs(equaldistance - objectsAtLeft[0].distance) <= snapObjDistance) {
                        top = this._findEquallySpacedNodesAtLeft(objectsAtLeft, equaldistance, top, equallySpaced);

                    } else equaldistance = objectsAtLeft[0].distance;
                } else equaldistance = objectsAtLeft[0].distance;
            }
            this._sortByDistance(equallySpaced, "distance");
            equallySpaced[equallySpaced.length] = { object: shape, distance: 0 };
            top = bounds.y < top || !top ? bounds.y : top;
            if (objectsAtRight.length > 0) {
                var dist;
                nearestright = ej.datavisualization.Diagram.Util.bounds(objectsAtRight[0].object);
                top = nearestright.y < top ? nearestright.y : top;
                if (objectsAtRight.length > 1) {
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtRight[1].object);
                    dist = targetBounds.x - nearestright.x - nearestright.width;
                }
                if (objectsAtLeft.length > 0) {
                    if (Math.abs(objectsAtRight[0].distance - objectsAtLeft[0].distance) <= snapObjDistance) {
                        var adjustablevalue = Math.abs(objectsAtRight[0].distance - objectsAtLeft[0].distance) / 2;
                        (objectsAtRight[0].distance < objectsAtLeft[0].distance) ?
                        equaldistance -= adjustablevalue : equaldistance += adjustablevalue;
                        equallySpaced[equallySpaced.length] = objectsAtRight[0];
                    }
                    else if (objectsAtLeft.length == 1) {
                        nearestleft = undefined;
                        equallySpaced.splice(0, 1);
                        equallySpaced[equallySpaced.length] = objectsAtRight[0];
                        equaldistance = dist;
                    }
                }
                else {
                    equaldistance = dist;
                    equallySpaced[equallySpaced.length] = objectsAtRight[0];
                }
                if (objectsAtRight.length > 1 && nearestright.x + nearestright.width < targetBounds.x) {
                    top = this._findEquallySpacedNodesAtRight(objectsAtRight, dist, top, equallySpaced, snapObjDistance);
                }
            }
            if (equallySpaced.length > 2) {
                this._addHSpacingLines(diagram, equallySpaced, ended, g, top);
                var delta = 0;
                if (ended)
                    delta = del.x;
                if (nearestleft)
                    hSnap.offset = equaldistance - Math.abs(bounds.x + delta - nearestleft.x - nearestleft.width) + delta;
                else if (nearestright)
                    hSnap.offset = Math.abs(bounds.x + bounds.width + delta - nearestright.x) - equaldistance + delta;
                hSnap.snapped = true;
            }
        },
        _createVSpacingLines: function (diagram, shape, objectsAtTop, objectsAtBottom, hSnap, vSnap, ended, g, del, snapObjDistance) {
            var right = null;
            this._sortByDistance(objectsAtTop, "distance", true);
            this._sortByDistance(objectsAtBottom, "distance", true);
            var equallySpaced = [];
            var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
            var nearesttop, nearestbottom;
            var targetBounds;
            if (objectsAtTop.length > 0) {
                equallySpaced[equallySpaced.length] = objectsAtTop[0];
                nearesttop = ej.datavisualization.Diagram.Util.bounds(objectsAtTop[0].object);
                right = nearesttop.x + nearesttop.width;
                if (objectsAtTop.length > 1) {
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtTop[1].object);
                    var equaldistance = nearesttop.y - targetBounds.y - targetBounds.height;
                    if (Math.abs(equaldistance - objectsAtTop[0].distance) <= snapObjDistance) {
                        right = this._findEquallySpacedNodesAtTop(objectsAtTop, equaldistance, right, equallySpaced);
                    } else equaldistance = objectsAtTop[0].distance;
                } else equaldistance = objectsAtTop[0].distance;
            }
            this._sortByDistance(equallySpaced, "distance");
            equallySpaced[equallySpaced.length] = { object: shape, distance: 0 };
            right = bounds.x + bounds.width > right || !right ? bounds.x + bounds.width : right;
            var dist;
            if (objectsAtBottom.length > 0) {
                nearestbottom = ej.datavisualization.Diagram.Util.bounds(objectsAtBottom[0].object);
                right = nearestbottom.x + nearestbottom.width > right ? nearestbottom.x + nearestbottom.width : right;
                if (objectsAtBottom.length > 1) {
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtBottom[1].object);
                    dist = targetBounds.y - nearestbottom.y - nearestbottom.height;
                }

                if (objectsAtTop.length > 0) {
                    if (Math.abs(objectsAtBottom[0].distance - objectsAtTop[0].distance) <= snapObjDistance) {
                        var adjustablevalue = Math.abs(objectsAtBottom[0].distance - objectsAtTop[0].distance) / 2;
                        (objectsAtBottom[0].distance < objectsAtTop[0].distance) ?
                        equaldistance -= adjustablevalue : equaldistance += adjustablevalue;
                        equallySpaced[equallySpaced.length] = objectsAtBottom[0];
                    }
                    else if (objectsAtTop.length == 1) {
                        nearesttop = undefined;
                        equallySpaced.splice(0, 1);
                        equallySpaced[equallySpaced.length] = objectsAtBottom[0];
                        equaldistance = dist;
                    }
                }
                else {
                    equaldistance = dist;
                    equallySpaced[equallySpaced.length] = objectsAtBottom[0];
                }
                if (objectsAtBottom.length > 1 && targetBounds.y > nearestbottom.y + nearestbottom.height) {
                    right = this._findEquallySpacedNodesAtBottom(objectsAtBottom, dist, right, equallySpaced, snapObjDistance);
                }

            }
            if (equallySpaced.length > 2) {
                this._addVSpacingLine(diagram, equallySpaced, ended, g, right);
                var delta = 0;
                if (ended)
                    delta = del.y;
                if (nearesttop)
                    vSnap.offset = equaldistance - Math.abs(bounds.y + delta - nearesttop.y - nearesttop.height) + delta;
                else if (nearestbottom)
                    vSnap.offset = Math.abs(bounds.y + bounds.height + delta - nearestbottom.y) - equaldistance + delta;
                vSnap.snapped = true;
            }
        },
        _addHSpacingLines: function (diagram, equallySpaced, ended, g, top) {
            var scale = diagram._currZoom;
            var hoffset = diagram._hScrollOffset;
            var voffset = diagram._vScrollOffset;
            if (equallySpaced.length > 2) {
                if (!ended) {
                    for (var i = 0; i < equallySpaced.length - 1; i++) {
                        var crnt = ej.datavisualization.Diagram.Util.bounds(equallySpaced[i].object);
                        var next = ej.datavisualization.Diagram.Util.bounds(equallySpaced[i + 1].object);
                        ej.datavisualization.Diagram.SvgContext._renderSpacingLines(ej.datavisualization.Diagram.Point(crnt.x + crnt.width, top - 15),
                       ej.datavisualization.Diagram.Point(next.x, top - 15), g, diagram._adornerSvg, scale, hoffset, voffset);
                    }
                }

            }
        },
        _addVSpacingLine: function (diagram, equallySpaced, ended, g, right) {
            var scale = diagram._currZoom;
            var hoffset = diagram._hScrollOffset;
            var voffset = diagram._vScrollOffset;
            if (equallySpaced.length > 2) {
                if (!ended) {
                    var crnt, next;
                    for (var i = 0; i < equallySpaced.length - 1; i++) {
                        crnt = ej.datavisualization.Diagram.Util.bounds(equallySpaced[i].object);
                        next = ej.datavisualization.Diagram.Util.bounds(equallySpaced[i + 1].object);
                        ej.datavisualization.Diagram.SvgContext._renderSpacingLines(ej.datavisualization.Diagram.Point(right + 15, crnt.y + crnt.height),
                      ej.datavisualization.Diagram.Point(right + 15, next.y), g, diagram._adornerSvg, scale, hoffset, voffset);
                    }
                }

            }
        },
        _addSameWidthLines: function (diagram, sameWidths, hSnap, ended, g, shape) {
            var scale = diagram._currZoom;
            var hOffset = diagram._hScrollOffset;
            var vOffset = diagram._vScrollOffset;
            this._sortByDistance(sameWidths, "offset");
            var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
            var target = sameWidths[0];
            var targetBounds = ej.datavisualization.Diagram.Util.bounds(target.source);
            var sameSizes = [];
            sameSizes.push(sameWidths[0]);
            var i, crntbounds;
            for (i = 1; i < sameWidths.length; i++) {
                crntbounds = ej.datavisualization.Diagram.Util.bounds(sameWidths[i].source);
                if (crntbounds.width == targetBounds.width)
                    sameSizes.push(sameWidths[i]);
            }
            if (sameSizes.length > 0) {
                if (!ended) {
                    ej.datavisualization.Diagram.SvgContext._renderSpacingLines(ej.datavisualization.Diagram.Point(bounds.x + target.offset, bounds.y - 15),
                        ej.datavisualization.Diagram.Point(bounds.x + bounds.width + target.offset, bounds.y - 15), g, diagram._adornerSvg, scale, hOffset, vOffset);
                    for (i = 0; i < sameSizes.length; i++) {
                        bounds = ej.datavisualization.Diagram.Util.bounds(sameSizes[i].source);
                        ej.datavisualization.Diagram.SvgContext._renderSpacingLines(ej.datavisualization.Diagram.Point(bounds.x, bounds.y - 15),
                        ej.datavisualization.Diagram.Point(bounds.x + bounds.width, bounds.y - 15), g, diagram._adornerSvg, scale, hOffset, vOffset);
                    }
                }
            }
            hSnap.offset = target.offset;
            hSnap.snapped = true;
        },
        _addSameHeightLines: function (diagram, sameHeights, vSnap, ended, g, shape) {
            var scale = diagram._currZoom;
            var hOffset = diagram._hScrollOffset;
            var vOffset = diagram._vScrollOffset;
            this._sortByDistance(sameHeights, "offset");
            var bounds = ej.datavisualization.Diagram.Util.bounds(shape);
            var target = sameHeights[0];
            var targetBounds = ej.datavisualization.Diagram.Util.bounds(target.source);
            var sameSizes = [];
            sameSizes.push(sameHeights[0]);
            var i, crntBounds;
            for (i = 0; i < sameHeights.length; i++) {
                crntBounds = ej.datavisualization.Diagram.Util.bounds(sameHeights[i].source);
                if (crntBounds.height == targetBounds.height)
                    sameSizes.push(sameHeights[i]);
            }
            if (sameSizes.length > 0) {
                if (!ended) {
                    ej.datavisualization.Diagram.SvgContext._renderSpacingLines(ej.datavisualization.Diagram.Point(bounds.x + bounds.width + 15, bounds.y + target.offset),
                        ej.datavisualization.Diagram.Point(bounds.x + bounds.width + 15, bounds.y + bounds.height + target.offset), g, diagram._adornerSvg, scale, hOffset, vOffset);
                    for (i = 0; i < sameSizes.length; i++) {
                        bounds = ej.datavisualization.Diagram.Util.bounds(sameSizes[i].source);
                        ej.datavisualization.Diagram.SvgContext._renderSpacingLines(ej.datavisualization.Diagram.Point(bounds.x + bounds.width + 15, bounds.y),
                        ej.datavisualization.Diagram.Point(bounds.x + bounds.width + 15, bounds.y + bounds.height), g, diagram._adornerSvg, scale, hOffset, vOffset);

                    }
                }
                vSnap.offset = target.offset;
                vSnap.snapped = true;
            }
        },
        _findEquallySpacedNodesAtLeft: function (objectsAtLeft, equalDistance, top, equallySpaced) {
            var prevBounds, targetBounds, dist;
            for (var i = 1; i < objectsAtLeft.length; i++) {
                prevBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtLeft[i - 1].object);
                targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtLeft[i].object);
                dist = prevBounds.x - targetBounds.x - targetBounds.width;
                if (Math.abs(dist - equalDistance) <= 1) {
                    equallySpaced[equallySpaced.length] = objectsAtLeft[i];
                    if (targetBounds.y < top)
                        top = targetBounds.y;
                }
                else
                    break;
            }
            return top;
        },
        _findEquallySpacedNodesAtRight: function (objectsAtRight, equalDistance, top, equallySpaced, snapObjDistance) {
            var actualDistance = objectsAtRight[0].distance;
            var target, targetBounds, prevBounds, dist;
            if (Math.abs(equalDistance - actualDistance) <= snapObjDistance) {
                for (var i = 0; i < objectsAtRight.length - 1; i++) {
                    target = objectsAtRight[i].object;
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtRight[i + 1].object);
                    prevBounds = ej.datavisualization.Diagram.Util.bounds(target);
                    dist = targetBounds.x - prevBounds.x - prevBounds.width;
                    if (Math.abs(dist - equalDistance) <= 1) {
                        equallySpaced[equallySpaced.length] = objectsAtRight[i + 1];
                        if (prevBounds.y < top) {
                            top = prevBounds.y;
                        }
                    }
                    else
                        break;
                }
            }
            return top;
        },
        _findEquallySpacedNodesAtTop: function (objectsAtTop, equalDistance, right, equallySpaced) {
            var prevBounds, targetBounds, dist;
            for (var i = 1; i < objectsAtTop.length; i++) {
                prevBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtTop[i - 1].object);
                targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtTop[i].object);
                dist = prevBounds.y - targetBounds.y - targetBounds.height;
                if (Math.abs(dist - equalDistance) <= 1) {
                    equallySpaced[equallySpaced.length] = objectsAtTop[i];
                    if (targetBounds.x + targetBounds.width > right)
                        right = targetBounds.x + targetBounds.width;
                }
                else
                    break;
            }
            return right;
        },
        _findEquallySpacedNodesAtBottom: function (objectsAtBottom, equalDistance, right, equallySpaced, snapObjDistance) {
            var actualDistance = objectsAtBottom[0].distance;
            var target, targetBounds, prevBounds, dist;
            if (Math.abs(equalDistance - actualDistance) <= snapObjDistance) {
                for (var i = 0; i < objectsAtBottom.length - 1; i++) {
                    target = objectsAtBottom[i].object;
                    targetBounds = ej.datavisualization.Diagram.Util.bounds(objectsAtBottom[i + 1].object);
                    prevBounds = ej.datavisualization.Diagram.Util.bounds(target);
                    dist = targetBounds.y - prevBounds.y - prevBounds.height;
                    if (Math.abs(dist - equalDistance) <= 1) {
                        equallySpaced[equallySpaced.length] = objectsAtBottom[i + 1];
                        if (prevBounds.x + prevBounds.width > right)
                            right = prevBounds.x + prevBounds.width;
                    }
                    else
                        break;
                }
            }
            return right;
        },

    };
    //#endregion

    //#region SpatialSearch
    ej.datavisualization.Diagram.SpatialUtil = {
        findQuads: function (spatialSearch, viewPort) {
            spatialSearch.quads = [];
            var quad = spatialSearch.parentQuad;
            this._findQuads(spatialSearch, quad, viewPort);
            return spatialSearch.quads;
        },
        _addIntoAQuad: function (spatialSearch) {
            var isAdded = false;
            while (!isAdded) {
                isAdded = this._add(spatialSearch, spatialSearch.parentQuad);
            }
        },
        _setCurrentNode: function (spatialSearch, node) {
            spatialSearch.childnode = node;
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            spatialSearch.childLeft = bounds.left;
            spatialSearch.childTop = bounds.top;
            spatialSearch.childRight = bounds.right;
            spatialSearch.childBottom = bounds.bottom;
        },
        _add: function (spatialSearch, quad) {
            if (this._isContained(spatialSearch, quad)) {
                this._selectQuad(spatialSearch, quad);
                return true;
            } else {
                var newParent;
                var isEmpty = !quad.objects.length && quad.first == null && quad.second == null && quad.third == null && quad.fourth == null;
                if (spatialSearch.childLeft < quad.left) {
                    if (spatialSearch.childTop < quad.top) {
                        newParent = ej.datavisualization.Diagram.Quad(quad.left - quad.width, quad.top - quad.height, quad.width * 2, quad.height * 2);
                        if (!isEmpty)
                            newParent.fourth = quad;
                    }
                    else {
                        newParent = ej.datavisualization.Diagram.Quad(quad.left - quad.width, quad.top, quad.width * 2, quad.height * 2);
                        if (!isEmpty)
                            newParent.second = quad;
                    }
                }
                else if (spatialSearch.childTop < quad.top) {
                    newParent = ej.datavisualization.Diagram.Quad(quad.left, quad.top - quad.height, quad.width * 2, quad.height * 2);
                    if (!isEmpty)
                        newParent.third = quad;
                }
                else {
                    newParent = ej.datavisualization.Diagram.Quad(quad.left, quad.top, quad.width * 2, quad.height * 2);
                    if (!isEmpty)
                        newParent.first = quad;
                }
                quad.parent = newParent;
                spatialSearch.parentQuad = newParent;
                return false;
            }
        },
        _isContained: function (spatialSearch, quad) {
            if (spatialSearch.childLeft >= quad.left && spatialSearch.childRight <= quad.left + quad.width &&
                spatialSearch.childTop >= quad.top && spatialSearch.childBottom <= quad.top + quad.height) {
                return true;
            }
            return false;
        },
        _selectQuad: function (spatialSearch, quad) {
            var current = quad;
            while (current !== null) {
                current = this._getQuad(spatialSearch, current);
            }
        },
        _getQuad: function (spatialSearch, quad) {
            var halfWidth = quad.width / 2;
            var halfHeight = quad.height / 2;
            if (halfWidth >= 100 && halfHeight >= 100) {
                var xCenter = quad.left + halfWidth;
                var yCenter = quad.top + halfHeight;
                if (spatialSearch.childRight <= xCenter) {
                    if (spatialSearch.childBottom <= yCenter) {
                        return quad.first ? quad.first :
                               quad.first = ej.datavisualization.Diagram.Quad(quad.left, quad.top, halfWidth, halfHeight, quad);
                    }
                    else if (spatialSearch.childTop >= yCenter) {
                        return quad.third ? quad.third :
                                quad.third = ej.datavisualization.Diagram.Quad(quad.left, yCenter, halfWidth, halfHeight, quad);
                    }
                }
                else if (spatialSearch.childLeft >= xCenter) {
                    if (spatialSearch.childBottom <= yCenter) {
                        return quad.second ? quad.second :
                               quad.second = ej.datavisualization.Diagram.Quad(xCenter, quad.top, halfWidth, halfHeight, quad);
                    }
                    else if (spatialSearch.childTop >= yCenter) {
                        return quad.fourth ? quad.fourth :
                                quad.fourth = ej.datavisualization.Diagram.Quad(xCenter, yCenter, halfWidth, halfHeight, quad);
                    }
                }
            }
            quad.objects.push(spatialSearch.childnode);
            spatialSearch.quadTable[spatialSearch.childnode.name] = quad;
            return null;
        },
        _findQuads: function (spatialSearch, quad, viewPort) {
            if (quad.first && this._isIntersect(quad.first, viewPort)) {
                this._findQuads(spatialSearch, quad.first, viewPort);
            }
            if (quad.second && this._isIntersect(quad.second, viewPort)) {
                this._findQuads(spatialSearch, quad.second, viewPort);
            }
            if (quad.third && this._isIntersect(quad.third, viewPort)) {
                this._findQuads(spatialSearch, quad.third, viewPort);
            }
            if (quad.fourth && this._isIntersect(quad.fourth, viewPort)) {
                this._findQuads(spatialSearch, quad.fourth, viewPort);
            }
            if (quad.objects.length > 0)
                spatialSearch.quads.push(quad);
        },
        _isIntersect: function (quad, viewPort) {
            if (quad.left + quad.width < viewPort.x || quad.top + quad.height < viewPort.y || quad.left > viewPort.x + viewPort.width || quad.top > viewPort.y + viewPort.height) {
                return false;
            }
            return true;
        },
        _update: function (quad) {
            if (quad.parent != null && quad.objects.length == 0 && quad.first == null &&
                quad.second == null && quad.third == null && quad.fourth == null) {
                var parent = quad.parent;
                if (parent.first == quad) {
                    parent.first = null;
                }
                else if (parent.second == quad) {
                    parent.second = null;
                }
                else if (parent.third == quad) {
                    parent.third = null;
                }
                else if (parent.fourth == quad) {
                    parent.fourth = null;
                }
                this._update(quad.parent);
            }
            else
                return;
        },
        _isWithinPageBounds: function (spatialSearch, bounds) {
            if (bounds.left >= spatialSearch.pageLeft && bounds.right <= spatialSearch.pageRight &&
                bounds.top >= spatialSearch.pageTop && bounds.bottom <= spatialSearch.pageBottom)
                return true;
            else
                return false;
        },
        _updateBounds: function (diagram, spatialSearch, node, update) {
            var modified = false;
            if (spatialSearch.topElement && node.name == spatialSearch.topElement.name) {
                modified = true;
                spatialSearch.pageTop = null;
                this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "top");
            }
            if (spatialSearch.leftElement && node.name == spatialSearch.leftElement.name) {
                modified = true;
                spatialSearch.pageLeft = null;
                this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "left");
            }
            if (spatialSearch.rightElement && node.name == spatialSearch.rightElement.name) {
                modified = true;
                spatialSearch.pageRight = null;
                this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "right");
            }
            if (spatialSearch.bottomElement && node.name == spatialSearch.bottomElement.name) {
                modified = true;
                spatialSearch.pageBottom = null;
                this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "bottom");
            }
            if (modified) {
                if (diagram._pageBackgroundLayer) {
                    ej.datavisualization.Diagram.PageUtil._updatePageSize(diagram, (update !== undefined) ? update : true);
                }
            }
        },
        _findQuadElement: function (spatialSearch, quad, direction) {
            switch (direction) {
                case "bottom":
                    if (quad.third != null || quad.fourth != null) {
                        if (quad.third != null) {
                            this._findQuadElement(spatialSearch, quad.third, direction);
                        }
                        if (quad.fourth != null) {
                            this._findQuadElement(spatialSearch, quad.fourth, direction);
                        }
                    }
                    else {
                        if (quad.first != null) {
                            this._findQuadElement(spatialSearch, quad.first, direction);
                        }
                        if (quad.second != null) {
                            this._findQuadElement(spatialSearch, quad.second, direction);
                        }
                    }
                    break;
                case "top":
                    if (quad.first != null || quad.second != null) {
                        if (quad.first != null) {
                            this._findQuadElement(spatialSearch, quad.first, direction);
                        }
                        if (quad.second != null) {
                            this._findQuadElement(spatialSearch, quad.second, direction);
                        }
                    }
                    else {
                        if (quad.third != null) {
                            this._findQuadElement(spatialSearch, quad.third, direction);
                        }
                        if (quad.fourth != null) {
                            this._findQuadElement(spatialSearch, quad.fourth, direction);
                        }
                    }
                    break;
                case "left":
                    if (quad.first != null || quad.third != null) {
                        if (quad.first != null) {
                            this._findQuadElement(spatialSearch, quad.first, direction);
                        }
                        if (quad.third != null) {
                            this._findQuadElement(spatialSearch, quad.third, direction);
                        }
                    }
                    else {
                        if (quad.second != null) {
                            this._findQuadElement(spatialSearch, quad.second, direction);
                        }
                        if (quad.fourth != null) {
                            this._findQuadElement(spatialSearch, quad.fourth, direction);
                        }
                    }
                    break;
                case "right":
                    if (quad.second != null || quad.fourth != null) {
                        if (quad.second != null) {
                            this._findQuadElement(spatialSearch, quad.second, direction);
                        }
                        if (quad.fourth != null) {
                            this._findQuadElement(spatialSearch, quad.fourth, direction);
                        }
                    }
                    else {
                        if (quad.third != null) {
                            this._findQuadElement(spatialSearch, quad.third, direction);
                        }
                        if (quad.first != null) {
                            this._findQuadElement(spatialSearch, quad.first, direction);
                        }
                    }

                    break;
            }

            var bounds, type;
            for (var i = 0; i < quad.objects.length; i++) {
                bounds = ej.datavisualization.Diagram.Util.bounds(quad.objects[i]);
                if (direction === "bottom" && (spatialSearch.pageBottom <= bounds.bottom || spatialSearch.pageBottom == null)) {
                    spatialSearch.pageBottom = bounds.bottom;
                    spatialSearch.bottomElement = quad.objects[i];
                }
                else if (direction === "top" && (spatialSearch.pageTop >= bounds.top || spatialSearch.pageTop == null)) {
                    spatialSearch.pageTop = bounds.top;
                    spatialSearch.topElement = quad.objects[i];
                }
                else if (direction === "left" && (spatialSearch.pageLeft >= bounds.left || spatialSearch.pageLeft == null)) {
                    spatialSearch.pageLeft = bounds.left;
                    spatialSearch.leftElement = quad.objects[i];
                }
                else if (direction === "right" && (spatialSearch.pageRight <= bounds.right || spatialSearch.pageRight == null)) {
                    spatialSearch.pageRight = bounds.right;
                    spatialSearch.rightElement = quad.objects[i];
                }
            }
        },
        _initializeNodes: function (diagram, spatialSearch) {
            var nodes = diagram.nodes();
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                var type = this.getObjectType(node);
                if (type != "group") {
                    this._updateQuad(diagram, spatialSearch, node);
                }
            }
        },

        _initializeConnectors: function (diagram, spatialSearch) {
            var connectors = diagram.connectors();
            for (var i = 0; i < connectors.length; i++) {
                this._updateQuad(diagram, spatialSearch, connectors[i]);
            }
        },

        _updateQuad: function (diagram, spatialSearch, node, layoutinAction) {
            this._setCurrentNode(spatialSearch, node);
            var bounds = ej.datavisualization.Diagram.Util.bounds(node);
            var quad = spatialSearch.quadTable[node.name];
            if (quad) {
                if (!this._isContained(spatialSearch, quad)) {
                    this._removeFromaQuad(spatialSearch, quad, node);
                    this._addIntoAQuad(spatialSearch);
                }
            }
            else {
                if (!spatialSearch.parentQuad)
                    spatialSearch.parentQuad = ej.datavisualization.Diagram.Quad(0, 0, 200, 200);
                this._addIntoAQuad(spatialSearch);
            }
            if (!(this._isWithinPageBounds(spatialSearch, bounds) && spatialSearch.leftElement != node &&
                spatialSearch.topElement != node && spatialSearch.rightElement != node && spatialSearch.bottomElement != node)) {
                var modified = false, endElement = false;
                if (spatialSearch.pageLeft >= spatialSearch.childLeft || spatialSearch.pageLeft == null) {
                    spatialSearch.pageLeft = spatialSearch.childLeft;
                    spatialSearch.leftElement = node;
                    modified = true;
                }
                else if (node == spatialSearch.leftElement) {
                    spatialSearch.pageLeft = null;
                    this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "left");
                    endElement = modified = true;
                }

                if (spatialSearch.pageTop >= spatialSearch.childTop || spatialSearch.pageTop == null) {
                    spatialSearch.pageTop = spatialSearch.childTop;
                    spatialSearch.topElement = node;
                    modified = true;
                }
                else if (node == spatialSearch.topElement) {
                    spatialSearch.pageTop = null;
                    this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "top");
                    endElement = modified = true;
                }

                if (spatialSearch.pageBottom <= spatialSearch.childBottom || spatialSearch.pageBottom == null) {
                    modified = true;
                    spatialSearch.pageBottom = spatialSearch.childBottom;
                    spatialSearch.bottomElement = node;
                }
                else if (node == spatialSearch.bottomElement) {
                    spatialSearch.pageBottom = null;
                    this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "bottom");
                    endElement = modified = true;
                }

                if (spatialSearch.pageRight <= spatialSearch.childRight || spatialSearch.pageRight == null) {
                    spatialSearch.pageRight = spatialSearch.childRight;
                    spatialSearch.rightElement = node;
                    modified = true;
                }
                else if (node == spatialSearch.rightElement) {
                    spatialSearch.pageRight = null;
                    this._findQuadElement(spatialSearch, spatialSearch.parentQuad, "right");
                    endElement = modified = true;
                }
            }
            var pageBounds = diagram.activeTool.diagramBounds;
            if (modified && diagram.model.pageSettings.multiplePage &&
                (diagram.model.pageSettings.pageWidth || diagram.model.pageSettings.pageHeight) && pageBounds) {
                modified = false;
                if (endElement || spatialSearch.pageLeft < pageBounds.x || spatialSearch.pageTop < pageBounds.y ||
                    spatialSearch.pageRight > pageBounds.x + pageBounds.width || spatialSearch.pageBottom > pageBounds.y + pageBounds.height) {
                    modified = true;
                    diagram.activeTool.diagramBounds = diagram._getDigramBounds();
                }
            }
            if (modified) {
                diagram._views.forEach(function (viewid) {
                    var view = diagram._views[viewid];
                    if (view.type == "overview") {
                        var ovw = $("#" + viewid).ejOverview("instance");
                        if (ovw)
                            ovw._updateOverview(view);
                    }
                });
                if (!diagram._layoutInAction && diagram._pageBackgroundLayer) {
                    ej.datavisualization.Diagram.PageUtil._updatePageSize(diagram, diagram.activeTool.inAction || diagram._selectedSymbol);
                }
            }
        },
        _removeFromaQuad: function (spatialSearch, quad, node) {
            if (quad) {
                var index = quad.objects.indexOf(node);
                quad.objects.splice(index, 1);
                this._update(quad);
                delete spatialSearch.quadTable[node.name];
            }
        }

    };

    ej.datavisualization.Diagram.Quad = function (left, top, width, height, parent) {
        return {
            left: left, top: top, width: width, height: height, parent: parent,
            first: null, second: null, third: null, fourth: null, objects: []
        };
    }
    ej.datavisualization.Diagram.SpatialSearch = function () {
        return {
            pageLeft: null, pageRight: null, pageTop: null, pageBottom: null,
            topElement: null, bottomElement: null, rightElement: null, leftElement: null,
            childLeft: null, childTop: null, childRight: null, childBottom: null, childNode: null,
            quads: null, parentQuad: ej.datavisualization.Diagram.Quad(0, 0, 200, 200), quadTable: {}
        };
    };
    //#endregion
    ej.datavisualization.Diagram.ClassifierHelper = {
        getEditableElementUnderMouse: function (evt, diagram) {
            var element = diagram._findNodeUnderMouse(evt);
            if (element) {
                var type = element.name.match("_attribute") ? "attribute" : (element.name.match("_method") ? "method" : (element.name.match("_member") ? "member" : "header"));
                if (type && element.parent)
                    element = diagram.nameTable[element.parent];
            }
            return element;
        },
        getMovableElementUnderMouse: function (evt, diagram, defult) {
            var element = diagram._findNodeUnderMouse(evt);
            var className = evt.target.className;
            if (element && element.parent && !(element.type == "umlclassifier"))
                element = diagram.nameTable[element.parent]
            return element;
        },
        getSelectableElementUnderMouse: function (evt, diagram, skip) {
            var node = diagram._findNodeUnderMouse(evt);
            if (node && node.parent && !(node.type == "umlclassifier"))
                node = diagram.nameTable[node.parent];
            return node;
        },
        getDropableElementUnderMouse: function (evt, diagram) {
            var element = diagram._findNodeUnderMouse(evt);
            if (!diagram._nodeUnderMouse)
                diagram._nodeUnderMouse = element;
            if (element && ej.datavisualization.Diagram.Util.canAllowDrop(element))
                return element;
            else
                return true;
        },
        renderResizeBorder: function (id, node, svg, scale) {
            var width = node.width ? node.width : node._width;
            var height = node.height ? node.height : node._height;
            var rect = svg.rect({
                "id": id, "width": (width * scale) + node.borderWidth + 4, "height": height * scale + node.borderWidth + 4, x: -(node.borderWidth / 2 + 2), y: -(node.borderWidth / 2 + 2), "stroke": "#f93732", "stroke-width": 2, "stroke-dasharray": "0", "fill": "none", "pointer-events": "none"
            });
            return rect;
        },
        getEditboxValue: function (editBoxValue, shape, diagram) {
            for (var i = 0; i < shape.children.length; i++) {
                if (typeof shape.children[i] == "string")
                    shape.children[i] = diagram.nameTable[shape.children[i]];
                var type = shape.children[i].name.match("_attribute") ? "attribute" : (shape.children[i].name.match("_method") ? "method" : (shape.children[i].name.match("_member") ? "member" : "header"));
            }
            var text = editBoxValue.split("\n");
            for (var j = 0; j < text.length; j++) {
                text[j] = text[j].trim().replace(/\s+/g, " ");
                if (!text[j].indexOf("---") > -1 && text[j].charAt(0) == "+" || text[j].charAt(0) == "-" || text[j].charAt(0) == "#" || text[j].charAt(0) == "~")
                    text[j] = text[j];
                else if (j != text[j].length - text[j].length && !text[j].indexOf("---") > -1 && text[j].length > 0 && type != "member" && !shape.enumeration) {
                    text[j] = "+" + " " + text[j];
                }
                if (text[j].indexOf("---") > -1 && text[j].match(/\w|\d|\D|\s/g)) {
                    var spliter = text[j].match(/---/g);
                    text[j] = spliter[0];
                }
            }
            editBoxValue = text.join("\n");
            var editLabel = editBoxValue.split("\n---\n");
            for (var j = 0; j < editLabel.length; j++)
                editLabel[j] = editLabel[j].replace(/^\n+/g, "");
            if (editLabel[0].indexOf("+") > -1)
                editLabel[0] = editLabel[0].replace(/[+]/g, "");
            if (editLabel[0].length > 0)
                shape.children[0].labels[0].text = editLabel[0];
            if (shape.children[1] && !editLabel[2])
                shape.children[1].labels[0].text = editLabel[1];
            else if (shape.children[1] && editLabel[2]) {
                if (shape.children[1].name.indexOf("method") > -1) {
                    if (shape.children[1].labels[0].text.indexOf(editLabel[1]) > -1) {
                        shape.children[1].labels[0].text = editLabel[1];
                        editLabel.pop()
                    }
                    else
                        shape.children[1].labels[0].text = editLabel[2];
                }
                else {
                    var value = shape.children[1].name.indexOf("attribute") > -1 ? editLabel[1] : (shape.children[1].name.indexOf("member") > -1 ? editLabel[1] : editLabel[2]);
                    shape.children[1].labels[0].text = value;
                }
            }
            if (shape.children[2])
                shape.children[2].labels[0].text = editLabel[2];
            for (var i = 0; i < shape.children.length; i++) {
                var textEdit = shape.children[i].labels[0].text;
                if (textEdit && textEdit.indexOf("--") > -1) {
                    textEdit = textEdit.replace(/---\n*/g, "");
                    shape.children[i].labels[0].text = textEdit;
                }
                if (textEdit && textEdit.endsWith("\n")) {
                    var newText = textEdit.replace(/\n+$/g, "");
                    shape.children[i].labels[0].text = newText;
                }
                var labelLength = shape.children[i].labels[0].text ? shape.children[i].labels[0].text.length : null;
                if (!labelLength && labelLength <= 0) {
                    diagram._remove(shape.children[i]);
                    i--;
                }
                diagram.nameTable[shape.children[i].name] = shape.children[i];
            }
            if ((editLabel[2] && !shape.children[2]) || (editLabel[1] && !shape.children[1])) {
                var nodes = [];
                var constraints = ej.datavisualization.Diagram.NodeConstraints.Default & ~(ej.datavisualization.Diagram.NodeConstraints.Select | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthEast | ej.datavisualization.Diagram.NodeConstraints.ResizeNorthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeSouthWest | ej.datavisualization.Diagram.NodeConstraints.ResizeNorth | ej.datavisualization.Diagram.NodeConstraints.ResizeSouth | ej.datavisualization.Diagram.NodeConstraints.Connect | ej.datavisualization.Diagram.NodeConstraints.Rotate | ej.datavisualization.Diagram.NodeConstraints.ResizeEast);
                var defaultProperty = { width: shape.width, offsetX: shape.offsetX, parent: shape.name, ports: [], fillColor: "transparent", borderColor: shape.borderColor, type: "node", labels: [{ margin: { left: 5, right: 5, top: 5, bottom: 5 } }], _isClassMember: true };
                for (var i = 0; i < shape.children.length; i++) {
                    if (i != 0 && shape.children[i].name.indexOf("_attribute") > -1 && editLabel[2].length > 0)
                        nodes.push({ name: shape.name + "_method" + "_classifier", labels: [{ text: editLabel[2], horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                    else if (i != 0 && shape.children[i].name.indexOf("_method") > -1 && editLabel[1].length > 0)
                        nodes.push({ name: shape.name + "_attribute" + "_classifier", labels: [{ text: editLabel[1], horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                }
                if (shape.children.length < 2) {
                    if (editLabel[1])
                        nodes.push({ name: shape.name + "_attribute" + "_classifier", labels: [{ text: editLabel[1], horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                    if (editLabel[2])
                        nodes.push({ name: shape.name + "_method" + "_classifier", labels: [{ text: editLabel[2], horizontalAlignment: "left", textAlign: "left", offset: { x: 0, y: 0.5 } }], constraints: constraints });
                }
                for (var j = 0; j < nodes.length; j++) {
                    nodes[j].labels[0] = $.extend(true, {}, shape.labels[0], nodes[j].labels[0]);
                    nodes[j] = ej.datavisualization.Diagram.Node($.extend(true, {}, defaultProperty, nodes[j]));
                    diagram._getNodeDimension(nodes[j], nodes[j].labels[0]);
                    nodes[j].offsetY += (shape.offsetY - shape.height / 2);
                    diagram.add(nodes[j]);
                    diagram.nameTable[nodes[j].name] = nodes[j];
                }
                if (shape.children[2] && shape.children[2].match("_attribute")) {
                    shape.children.splice(1, 0, shape.children[2]);
                    shape.children.pop();
                }
                if (typeof shape.children[1] == "string")
                    shape.children[1] = diagram.nameTable[shape.children[1]];
                if (typeof shape.children[2] == "string")
                    shape.children[2] = diagram.nameTable[shape.children[2]];
            }
            for (var i = 0; i < shape.children.length; i++) {
                if (shape.children.length == 1) {
                    if (shape["class"]) {
                        delete shape["class"].attributes;
                        delete shape["class"].methods;
                    }
                    if (shape["interface"]) {
                        delete shape["interface"].attributes;
                        delete shape["interface"].methods;
                    }
                    if (shape.enumeration)
                        delete shape.enumeration.members;
                }
                if (shape.children.length == 2) {
                    if (shape["class"]) {
                        if (shape.children[i].name.match("attribute"))
                            delete shape["class"].methods;
                        if (shape.children[i].name.match("method"))
                            delete shape["class"].attributes;
                    }
                    if (shape["interface"]) {
                        if (shape.children[i].name.match("attribute"))
                            delete shape["interface"].methods;
                        if (shape.children[i].name.match("method"))
                            delete shape["interface"].attributes;
                    }
                }
                this._updateClassNode(shape.children[i], shape);
            }
            return editBoxValue;
        },
        getUMLConnectorValue: function (shape, editBoxValue, label) {
            var available, option;
            if (label.name === shape.name + "_sourcelabel" || label.name === shape.name + "_targetlabel") {
                if (shape.shape.multiplicity.type == "onetoone" || shape.shape.multiplicity.type == "manytoone" || shape.shape.multiplicity.type == "onetomany") {
                    if (editBoxValue.length == 1 && (editBoxValue.indexOf("1") > -1 || editBoxValue.indexOf("*") > -1))
                        available = true;
                    option = false;
                    if ((label.name === shape.name + "_sourcelabel") && (shape.shape.multiplicity.type == "onetoone" || shape.shape.multiplicity.type == "onetomany")) {
                        editBoxValue = "1";
                        shape.shape.multiplicity = $.extend(true, {}, shape.shape.multiplicity, { source: { optional: option, lowerBounds: null, upperBounds: null } });
                    }
                    else if ((label.name === shape.name + "_targetlabel") && (shape.shape.multiplicity.type == "manytoone" || shape.shape.multiplicity.type == "onetoone")) {
                        editBoxValue = "1";
                        shape.shape.multiplicity = $.extend(true, {}, shape.shape.multiplicity, { target: { optional: option, lowerBounds: null, upperBounds: null } });
                    }
                }
                editBoxValue = this.umlConnectorEditBox(editBoxValue);
                if (editBoxValue.match(/\d\.{3}\d/g))
                    var text = editBoxValue.split("...");
                else if (!available) {
                    var labels = this.umlConnectorMultiplicity(shape);
                    if (label.name == shape.name + "_sourcelabel") {
                        var text = labels[0].text.split("...");
                        editBoxValue = labels[0].text;
                    }
                    else {
                        var text = labels[1].text.split("...");
                        editBoxValue = labels[1].text;
                    }
                }
                if (text) {
                    if (label.name == shape.name + "_sourcelabel")
                        shape.shape.multiplicity = $.extend(true, {}, shape.shape.multiplicity, { source: { optional: option, lowerBounds: text[0], upperBounds: text[1] } });
                    else
                        shape.shape.multiplicity = $.extend(true, {}, shape.shape.multiplicity, { target: { optional: option, lowerBounds: text[0], upperBounds: text[1] } });
                }
            }
            label.text = editBoxValue;
            return shape;
        },
        umlConnectorMultiplicity: function (options) {
            var labels = [], text, text1, sourceText, targetText, lower, upper;
            if (options.shape.multiplicity.source) {
                options.shape.multiplicity.source.lowerBounds = this.umlConnectorEditBox(options.shape.multiplicity.source.lowerBounds);
                options.shape.multiplicity.source.upperBounds = this.umlConnectorEditBox(options.shape.multiplicity.source.upperBounds);
            }
            if (options.shape.multiplicity.target) {
                options.shape.multiplicity.target.lowerBounds = this.umlConnectorEditBox(options.shape.multiplicity.target.lowerBounds);
                options.shape.multiplicity.target.upperBounds = this.umlConnectorEditBox(options.shape.multiplicity.target.upperBounds);
            }
            lower = options.shape.multiplicity.source;
            upper = options.shape.multiplicity.target;
            text = lower.upperBounds ? lower.lowerBounds + "..." + lower.upperBounds : lower.lowerBounds;
            text1 = upper.upperBounds ? upper.lowerBounds + "..." + upper.upperBounds : upper.lowerBounds;
            if (options.shape.multiplicity.type == "manytoone") {
                options.shape.multiplicity.target.optional = false;
                sourceText = text ? text : "*"; targetText = "1";
            }
            if (options.shape.multiplicity.type == "onetomany") {
                options.shape.multiplicity.source.optional = false;
                targetText = text1 ? text1 : "*"; sourceText = "1";
            }
            if (options.shape.multiplicity.type == "manytomany") {
                sourceText = text ? text : "*"; targetText = text1 ? text1 : "*";
            }
            if (options.shape.multiplicity.type == "onetoone") {
                options.shape.multiplicity.target.optional = false;
                options.shape.multiplicity.source.optional = false;
                sourceText = "1"; targetText = "1"
            }
            labels.push({ name: options.name + "_sourcelabel", text: sourceText, segmentOffset: 0, alignment: "before", margin: { left: 5, top: 5 } }, { name: options.name + "_targetlabel", text: targetText, segmentOffset: 1, alignment: "before", margin: { right: 5, bottom: 5 } });
            return labels;
        },
        umlConnectorEditBox: function (text) {
            if (typeof text == "string") {
                if (text.match(/[a-zA-Z]/g))
                    text = text.replace(/[a-zA-Z]/g, "");
            }
            return text;
        },
        EnableorDisableConnection: function (child, node, connector, diagram) {
            if (connector.shape) {
                if (connector.shape.type == "umlclassifier" && connector.shape.relationship != "association") {
                    if (connector.shape.relationship != "dependency" && connector.shape.relationship != "inheritance" && connector.shape.relationship != "realization") {
                        if (node && child) {
                            if (child["interface"] && node["class"])
                                child = null;
                        }
                    }
                    if (connector.shape.relationship == "dependency") {
                        if (node && child) {
                            if (child["class"] && node["interface"])
                                child = null;
                        }
                    }
                }
            }
            return child;
        },
        getClassifierNodeDimension: function (shape, diagram) {
            for (var i = 0; i < shape.children.length; i++)
                diagram._getNodeDimension(shape.children[i]);
            shape._height = 0;
            for (var i = 0; i < shape.children.length; i++) {
                var height = shape.children[i].height ? shape.children[i].height : shape.children[i]._height;
                shape.children[i].offsetY = shape._height + height / 2;
                shape._height += height;
                shape.height = shape._height;
            }
            var width = shape.children[0]._width;
            if (shape.children[1])
                var width = shape.children[0]._width > shape.children[1]._width ? shape.children[0]._width : shape.children[1]._width
            if (shape.children[2])
                width = shape.children[2]._width > width ? shape.children[2]._width : width;
            shape.children[0].width = width;
            if (shape.children[1])
                shape.children[1].width = width;
            if (shape.children[2])
                shape.children[2].width = width;
            shape.width = width;
            for (var j = 0; j < shape.children.length; j++)
                shape.children[j].offsetY += (shape.offsetY - shape.height / 2);
            diagram._updateAssociatedConnectorEnds(shape, diagram.nameTable);
            return shape;
        },
        _updateClassNode: function (node, parent) {
            if (node.name.match("_header")) {
                if (parent["class"]) parent["class"].name = node.labels[0].text;
                else if (parent["interface"]) parent["interface"].name = node.labels[0].text;
                else parent.enumeration.name = node.labels[0].text;
            }
            else {
                var type = node.name.match("_attribute") ? "attribute" : (node.name.match("_method") ? "method" : "member");
                var label = node.labels[0];
                var scopeValue, argument, classArgument = [], argumentText;
                var str = label.text.split("\n");
                var classMember = [], data, i;
                for (i = 0; i < str.length; i++) {
                    if (str[i].indexOf("+") > -1)
                        scopeValue = "public";
                    else if (str[i].indexOf("-") > -1)
                        scopeValue = "private";
                    else if (str[i].indexOf("#") > -1)
                        scopeValue = "protected";
                    else if (str[i].indexOf("~") > -1)
                        scopeValue = "package";
                    if (str[i].indexOf("+") > -1 || str[i].indexOf("-") > -1 || str[i].indexOf("#") > -1 || str[i].indexOf("~") > -1)
                        str[i] = str[i].replace(/[+|~|#|-]\s/g, "");
                    switch (type) {
                        case "attribute":
                            data = str[i].split(/:[ ]*/g);
                            classMember.push(ej.datavisualization.Diagram.ClassAttribute({ name: data[0], type: data[1], scope: scopeValue }));
                            break;
                        case "method":
                            argument = str[i].split(/["("|")"]/g);
                            for (var k = 0; k < argument.length; k++) {
                                if (argument[k].indexOf(",") > -1)
                                    data = argument[k].split(",");
                                if (k == argument.length - 1)
                                    argument[k] = argument[k].replace(/[:\s]|:/g, "");
                            }
                            if (data) {
                                for (var j = 0; j < data.length; j++) {
                                    argumentText = data[j].split(":");
                                    classArgument.push(ej.datavisualization.Diagram.ClassmethodArguments({ name: argumentText[0], type: argumentText[1] }))
                                }
                            }
                            if (argument.length == 3 && !data) {
                                if (argument[1].indexOf(":") > -1) {
                                    argumentText = argument[1].split(":");
                                    classArgument.push(ej.datavisualization.Diagram.ClassmethodArguments({ name: argumentText[0], type: argumentText[1] }))
                                }
                                else
                                    classArgument.push(ej.datavisualization.Diagram.ClassmethodArguments({ name: argument[1] }))
                            }
                            classMember.push(ej.datavisualization.Diagram.ClassMethod({ name: argument[0], arguments: classArgument, type: argument[argument.length - 1], scope: scopeValue }));
                            break;
                        case "member":
                            classMember.push(ej.datavisualization.Diagram.ClassMember({ name: str[i] }));
                            break;
                    }
                }
                if (type == "attribute") {
                    if (parent["class"])
                        parent["class"].attributes = classMember;
                    else if (parent["interface"])
                        parent["interface"].attributes = classMember;
                }
                else if (type == "method") {
                    if (parent["class"])
                        parent["class"].methods = classMember;
                    else if (parent["interface"])
                        parent["interface"].methods = classMember;
                }
                else parent.enumeration.members = classMember;
            }

        },

    }
    //#region Swimlane 
    ej.datavisualization.Diagram.SwimLaneContainerHelper = {
        //#region initDefaults
        _initSwimLane: function (diagram, node) {
            var node = ej.datavisualization.Diagram.SwimLane(node);
            node = this._initLaneCollection(diagram, node);
            this._swapPhaseSize(node);
            node = this._setPhaseMinValues(diagram, node);
            node = this._initPhaseCollection(diagram, node);

            return node;
        },
        _initLaneCollection: function (diagram, node) {
            if (node.lanes.length === 0)
                node.lanes = [ej.datavisualization.Diagram.Lane({ orientation: node.orientation })];
            for (var i = 0; i < node.lanes.length; i++) {
                node.lanes[i] = ej.datavisualization.Diagram.Lane(node.lanes[i]);
                node.lanes[i].container = { type: "canvas", orientation: node.orientation }
                node.lanes[i].borderColor = node.lanes[i].borderColor ? node.lanes[i].borderColor : "black",
                node.lanes[i].orientation = node.orientation ? node.orientation : "horizontal",
                node.lanes[i].horizontalAlign = node.orientation === "horizontal" ? "stretch" : "left",
                node.lanes[i].verticalAlign = node.orientation === "vertical" ? "stretch" : "top",
                node.lanes[i].addInfo = node.lanes[i].addInfo ? node.lanes[i].addInfo : {},
                node.lanes[i].fillColor = node.lanes[i].fillColor,
                node.lanes[i].paddingTop = 20,
                node.lanes[i].paddingRight = 20,
                node.lanes[i].paddingBottom = 20,
                node.lanes[i].paddingLeft = 20,
                node.lanes[i].constraints = node.lanes[i].constraints ? node.lanes[i].constraints | ej.datavisualization.Diagram.NodeConstraints.AllowDrop : (ej.datavisualization.Diagram.NodeConstraints.Default | ej.datavisualization.Diagram.NodeConstraints.AllowDrop & ~ej.datavisualization.Diagram.NodeConstraints.Connect),
                node.lanes[i].cssClass = node.lanes[i].cssClass,
                node.lanes[i]._laneHeader = node.lanes[i]._laneHeader ? node.lanes[i]._laneHeader : null

                if (node.lanes[i].labels && node.lanes[i].labels.length > 0) {
                    for (var h = 0; h < node.lanes[i].labels.length; h++) {
                        node.lanes[i].labels[h] = ej.datavisualization.Diagram.Label(node.lanes[i].labels[h]);
                    }
                }
                var laneHeader = node.lanes[i]._laneHeader = node.lanes[i]._laneHeader ? node.lanes[i]._laneHeader : node.lanes[i].header
                var header = this._initLaneHeader(diagram, node.lanes[i], laneHeader, node);
                node.lanes[i].children.splice(0, 0, header);

            }
            return node;
        },
        _initLaneHeader: function (diagram, lane, laneHeader, node) {
            var headObj = lane.header;
            var nodeOrientation = node.orientation;
            if (nodeOrientation === "horizontal") {
                var hAlign = "left";
                var vAlign = "stretch";
                headObj.rotateAngle = 270;
            }
            else {
                hAlign = "stretch";
                vAlign = "top";
                headObj.rotateAngle = 0;
            }

            var node = ej.datavisualization.Diagram.Node({
                _hidePorts: true,
                _isHeader: true,
                name: (diagram._isUndo && laneHeader.name) ? laneHeader.name : lane.name + "_Headerr_",
                type: "node",
                labels: [headObj],
                height: laneHeader.height ? laneHeader.height : 50,
                width: laneHeader.width ? laneHeader.width : 50,
                fillColor: headObj.fillColor ? headObj.fillColor : "white",
                rotateAngle: 0,
                horizontalAlign: hAlign,
                verticalAlign: vAlign,
                constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect,
                marginLeft: -20,
                marginTop: -20,
                marginRight: -20,
                marginBottom: -20,
            });
            return node;
        },
        _initPhaseCollection: function (diagram, node) {
            var offY = 0, offX = 0;
            if (node.phases.length === 0)
                node.phases = [ej.datavisualization.Diagram.Phase({ orientation: node.orientation })];
            for (var i = 0; i < node.phases.length; i++) {
                node.phases[i]._UndoRedo = diagram._UndoRedo;
                node.phases[i] = ej.datavisualization.Diagram.Phase(node.phases[i]);
                node.phases[i].isPhase = true;
                node.phases[i]._hidePorts = true,
                node.phases[i].constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect,
                node.phases[i].parent = "";
                node.phases[i]._isHeader = true;
                node.phases[i]._type = "node";
                //node.phases[i].fillColor = 'blue';
                node.phases[i].orientation = node.orientation;
                if (!diagram._isLoad) {
                    if (node.phases[i].label && node.phaseSize != 0) {
                        node.phases[i].label.rotateAngle = node.orientation === "vertical" ? 270 : 0;
                        node.phases[i].labels = [node.phases[i].label];
                    }
                }
                else {
                    if (node.phases[i].labels && node.phases[i].labels.length > 0) {
                        node.phases[i].label = [node.phases[i].labels[0]]
                    }
                }
                if (node.orientation === "horizontal") {
                    //node.phases[i].verticalAlign = "stretch";
                    node.phases[i].width = node.phases[i].offset - offX;
                    node.phases[i].height = node.phaseSize;
                    offX = node.phases[i].offset;
                }
                else {
                    //node.phases[i].horizontalAlign = "stretch";
                    node.phases[i].height = node.phases[i].offset - offY;
                    node.phases[i].width = node.phaseSize;
                    offY = node.phases[i].offset;
                }
            }

            return node;
        },
        _setPhaseMinValues: function (diagram, node) {
            var cphase, fphase;
            fphase = node.phases[0];
            if (fphase) {
                if (fphase.offset < 70)
                    fphase.offset = 70;
                for (var i = 1; i < node.phases.length; i++) {
                    cphase = node.phases[i];
                    fphase = node.phases[i - 1];
                    if (fphase.offset + 20 >= cphase.offset)
                        cphase.offset = fphase.offset + 20;
                }
            }
            return node;
        },
        _swapPhaseSize: function (obj) {
            if (obj.phases.length > 0) {
                var phases = obj.phases, i, j, temp;
                for (i = 0; i < phases.length; i++) {
                    for (j = 0; j < (phases.length - i - 1) ; j++) {
                        if (phases[j].offset > phases[j + 1].offset) {
                            temp = phases[j];
                            phases[j] = phases[j + 1];
                            phases[j + 1] = temp;
                        }
                    }
                }
            }
        },
        _setLastPhaseSize: function (obj) {
            if (obj.phases.length > 0) {
                var lastPhase = obj.phases[obj.phases.length - 1];
                if (obj.orientation === "horizontal")
                    lastPhase.offset = obj.width;
                else
                    lastPhase.offset = obj.height;
            }
        },
        //#endregion

        //#region create
        _createSwimlane: function (diagram, node) {
            var header = this._createSwimlaneHeader(diagram, node);

            var stackOrientation = (node.orientation === "horizontal") ? "vertical" : "horizontal";
            var nodeOrientation = node.orientation;

            if (nodeOrientation === "horizontal") {
                var marginTop = Math.round(header.height + node.phaseSize);
                var marginLeft = 0;
            }
            else {
                marginTop = header.height;
                marginLeft = Math.round(node.phaseSize);
            }


            var phaseStack = {
                name: node.name + "phaseStack",
                isPhaseStack: true,
                container: { type: "stack", orientation: nodeOrientation },
                minHeight: 10,
                minWidth: 10,
                children: node.phases,
                marginTop: header.height,
                constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect & ~ej.datavisualization.Diagram.NodeConstraints.AllowDrop
                //verticalAlign: nodeOrientation === "vertical" ? "stretch" : "top",
                //horizontalAlign: nodeOrientation === "horizontal" ? "stretch" : "left",
            };
            var laneStack = {
                name: node.name + "laneStack",
                isLaneStack: true,
                container: { type: "stack", orientation: stackOrientation },
                children: node.lanes,
                marginTop: marginTop,
                marginLeft: marginLeft,
                verticalAlign: "stretch",
                horizontalAlign: "stretch",
                constraints: (ej.datavisualization.Diagram.NodeConstraints.Default | ej.datavisualization.Diagram.NodeConstraints.AllowDrop) & ~ej.datavisualization.Diagram.NodeConstraints.Connect
            };
            var swimlane = {
                _hidePorts: true,
                name: node.name,
                container: { type: "canvas" },
                children: [
                    header,
                    //phaseStack,
                    laneStack
                ],
                addInfo: node.addInfo ? node.addInfo : null,
                paletteItem: node.paletteItem ? node.paletteItem : null,
                constraints: node.constraints,
                cssClass: node.cssClass,
                offsetX: node.offsetX ? node.offsetX : 100,
                offsetY: node.offsetY ? node.offsetY : 100,
                orientation: node.orientation,
                phaseSize: node.phaseSize,
                isSwimlane: true,
                height: node.height ? node.height : 100,
                width: node.width ? node.width : 100,
            };

            swimlane.offsetX = node.offsetX ? node.offsetX : 100;
            swimlane.offsetY = node.offsetY ? node.offsetY : 100;
            //#region temp
            var cloneObj = ej.datavisualization.Diagram.containerCommon._cloneObject(diagram, swimlane, ej.datavisualization.Diagram.Util.randomId());
            cloneObj = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, cloneObj);
            var cloneObjBounds = ej.datavisualization.Diagram.Util.bounds(cloneObj);

            cloneObjBounds = this._setSwimlaneSize(diagram, swimlane, cloneObjBounds);

            ej.datavisualization.Diagram.containerCommon._removeObject(diagram, cloneObj);
            //#endregion

            if (nodeOrientation === "horizontal") {
                phaseStack.maxHeight = node.phaseSize;
                phaseStack.minWidth = 10;
            }
            else {
                phaseStack.minHeight = 10;
                phaseStack.maxWidth = node.phaseSize;
            }
            swimlane.children.splice(1, 0, phaseStack);
            this._setPhaseValues(diagram, swimlane, cloneObjBounds);
            var canvas = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, swimlane);
            return canvas;
        },
        _setSwimlaneSize: function (diagram, swimlane, cloneBounds) {
            if (swimlane.orientation === "horizontal") {
                if (swimlane.width > cloneBounds.width) {
                    var lanes = swimlane.children[1].children;
                    for (var i = 0; i < lanes.length; i++) {
                        lanes[i].minWidth = swimlane.width;
                    }
                    cloneBounds.width = swimlane.width;
                }

                if (swimlane.height > cloneBounds.height) {
                    var lanes = swimlane.children[1].children;
                    var lastLane = lanes[lanes.length - 1];
                    lastLane.minHeight += swimlane.height - cloneBounds.height;
                    cloneBounds.height = swimlane.height;
                }
            }
            else {
                if (swimlane.width > cloneBounds.width) {
                    var lanes = swimlane.children[1].children;
                    var lastLane = lanes[lanes.length - 1];
                    lastLane.minWidth += swimlane.width - cloneBounds.width;
                    cloneBounds.height = swimlane.height;
                }


                if (swimlane.height > cloneBounds.height) {
                    var lanes = swimlane.children[1].children;
                    for (var i = 0; i < lanes.length; i++) {
                        lanes[i].minHeight = swimlane.height - (2 * swimlane.children[0].height);
                    }
                    cloneBounds.height = swimlane.height;
                }
            }
            return cloneBounds;
        },
        _setPhaseValues: function (diagram, swimlane, bounds) {
            var phases = swimlane.children[1].children;
            var lastPhase = phases[phases.length - 1];
            var orientation = swimlane.orientation;
            if (orientation === "horizontal") {
                if (lastPhase.offset <= bounds.width) {
                    if (phases.length == 1) {
                        lastPhase.offset = bounds.width;
                        lastPhase.width = bounds.width;
                    }
                    else {
                        var prevPhase = phases[phases.indexOf(lastPhase) - 1];
                        lastPhase.offset = bounds.width;
                        lastPhase.width = bounds.width - prevPhase.offset;
                    }

                    var lanes = swimlane.children[2].children;
                    for (var i = 0; i < lanes.length; i++) {
                        lanes[i].minWidth = lastPhase.offset;
                    }
                }
                else {
                    var maxOffset = 0;
                    for (var i = 0; i < phases.length; i++) {
                        if (phases[i].offset >= maxOffset) {
                            maxOffset = phases[i].offset;
                        }
                    }
                    var lanes = swimlane.children[2].children;
                    for (var i = 0; i < lanes.length; i++) {
                        lanes[i].minWidth = maxOffset;
                    }
                }
            }
            else {
                var header = swimlane.children[0];
                if (lastPhase.offset <= bounds.height - header.height) {
                    if (phases.length == 1) {
                        lastPhase.offset = bounds.height - header.height;
                        lastPhase.height = lastPhase.offset;
                    }
                    else {
                        var prevPhase = phases[phases.indexOf(lastPhase) - 1];
                        lastPhase.offset = bounds.height - header.height;
                        lastPhase.height = bounds.height - prevPhase.offset - header.height;
                    }

                    var lanes = swimlane.children[2].children;
                    for (var i = 0; i < lanes.length; i++) {
                        lanes[i].minHeight = lastPhase.offset;
                    }
                }
                else {
                    var maxOffset = 0;
                    for (var i = 0; i < phases.length; i++) {
                        if (phases[i].offset >= maxOffset) {
                            maxOffset = phases[i].offset;
                        }
                    }
                    var lanes = swimlane.children[2].children;
                    for (var i = 0; i < lanes.length; i++) {
                        lanes[i].minHeight = maxOffset;
                    }
                }
            }

        },
        _createSwimlaneHeader: function (diagram, node) {
            var headObj = node.header;
            var laneHeader = node.lanes[0]._laneHeader ? node.lanes[0]._laneHeader : null;
            var header = ej.datavisualization.Diagram.Node({
                _type: "node",
                _hidePorts: true,
                _isHeader: true,
                name: node.name + "_header_swimlane",
                labels: [headObj],
                height: headObj.height ? headObj.height : 50,
                width: headObj.width ? headObj.width : 50,
                fillColor: node.header.fillColor ? node.header.fillColor : (laneHeader ? laneHeader.fillColor : "white"), // laneHeader ? laneHeader.fillColor : node.header.fillColor ? node.header.fillColor : "white",
                rotateAngle: 0,
                constraints: ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect,
                horizontalAlign: "stretch",
                parent: node.name,
            });
            header.labels[0].fillColor = "transparent";
            if (diagram._isLoad) {
                header.fillColor = node.header.fillColor;
            }
            return header;
        },
        //#endregion

        //#region update
        _updateSwimlane: function (diagram, node) {
            this._updateLaneStack(diagram, node);
            this._updatePhaseStack(diagram, node);
            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, node);
        },
        _updateLaneStack: function (diagram, swimlane) {
            var lanes = this.getLanes(diagram, swimlane), lane;
            for (var i = 0; i < lanes.length; i++) {
                lane = diagram.nameTable[diagram._getChild(lanes[i])];
                if (lane) {
                    for (var j = 1; j < lane.children.length; j++) {
                        var child = typeof lane.children[j] == "string" ? diagram.nameTable[lane.children[j]] : lane.children[j];
                        child.marginBottom = child.marginRight = 0;
                    }
                    this._updateLane(diagram, lane);
                }
            }
        },
        _updatePhaseStack: function (diagram, swimlane) {
            var PhaseStack = diagram.nameTable[diagram._getChild(swimlane.children[1])];
            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, PhaseStack);
        },
        _updateLane: function (diagram, node) {
            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, node);
        },

        //#endregion 

        //#region helper
        getPhases: function (diagram, swimlane, childTable) {
            if (swimlane) {
                if (swimlane.children[1])
                    var phaseStack = childTable ? childTable[diagram._getChild(swimlane.children[1])] : diagram.nameTable[diagram._getChild(swimlane.children[1])];
                if (phaseStack) {
                    var phases = diagram._getChildren(phaseStack.children);
                    if (phases && phases.length > 0) {
                        return phases;
                    }
                }

            }
        },
        getLanes: function (diagram, swimlane) {
            if (swimlane && swimlane.isSwimlane && swimlane.children[2])
                var laneStack = diagram.nameTable[diagram._getChild(swimlane.children[2])];
            if (laneStack) {
                var lanes = laneStack.children;
                if (lanes && lanes.length > 0) {
                    return lanes;
                }
            }


        },

        _updateLanesMinValue: function (diagram, swimlane, prop, value) {
            var lanes = this.getLanes(diagram, swimlane), lane;
            for (var i = 0; i < lanes.length; i++) {
                lane = diagram.nameTable[diagram._getChild(lanes[i])];
                if (lane) {
                    lane[prop] = value;
                }
            }
        },
        _resizeLastPhase: function (diagram, swimlane) {
        },
        _getPhaseBounds: function (diagram, phase) {
            var bounds = null, group, phaseBounds, prevOffset, left = 0, right = 0, top = 0, bottom = 0;
            if (phase && phase.type == "phase" && phase.parent) {
                var prevPhase = this._getPrevPhase(diagram, phase);
                var nextPhase = this._getNextPhase(diagram, phase)
                group = diagram.nameTable[phase.parent.split("phaseStack")[0]];
                if (group && group.orientation) {
                    bounds = ej.datavisualization.Diagram.Util.bounds(group)
                    if (group.orientation == "horizontal") {
                        prevOffset = this._getPrevOffset(diagram, phase, prevPhase, nextPhase, group, bounds);
                        if (prevPhase && prevPhase.name === phase.name) {
                            left = prevOffset.left + bounds.left;
                            right = left + (phase.offset - left - prevOffset.left);
                        }
                        else {
                            if (prevPhase)
                                left = bounds.left + prevPhase.offset;
                            right = (phase.offset - left + bounds.left);
                        }
                        top = prevOffset.top + bounds.top;
                        bottom = bounds.bottom - top;
                        phaseBounds = ej.datavisualization.Diagram.Rectangle(left, top, right, bottom);
                    }
                    else {
                        prevOffset = this._getPrevOffset(diagram, phase, prevPhase, nextPhase, group, bounds);
                        if (prevPhase === phase) {

                            left = prevOffset.left + bounds.left;
                            bottom = phase.offset + top;

                            top = prevOffset.top + bounds.top;
                        }
                        else {
                            var head = (typeof (group.children[0]) === "string") ? diagram.nameTable[group.children[0]] : diagram.nameTable[group.children[0].name];

                            var headHeight = head ? head.height : 0;
                            left = prevOffset.left + bounds.left;
                            if (prevPhase)
                                top = (prevPhase.offset + bounds.top) + headHeight;
                            bottom = bounds.top + phase.offset - top + headHeight;
                        }
                        right = bounds.right - left;
                        phaseBounds = ej.datavisualization.Diagram.Rectangle(left, top, right, bottom);
                    }
                }
            }
            return phaseBounds;
        },
        _getPrevPhase: function (diagram, phase) {
            var prevPhase = null, index;
            var group = diagram.nameTable[phase.parent.split("phaseStack")[0]];
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, group);
            if (group && phases && phases.length > 0) {
                index = this._getPhaseIndex(diagram, phase.name);
                if (index === 0)
                    prevPhase = diagram.nameTable[phases[0]];
                else
                    prevPhase = diagram.nameTable[phases[index - 1]];
            }
            return prevPhase;
        },
        _getPrevOffset: function (diagram, phase, prevPhase, nextPhase, parent, parentBounds) {
            var stckHeadWidth = 50, stack, firstCanvas, dleft = 0, dtop = 0;
            if (parent.children[0]) {
                var head = diagram.nameTable[diagram._getChild(parent.children[0])];
                if (head) {
                    dtop = head.height;
                }
            }
            if (parent.orientation == "horizontal") {
                if (parent.children[2])
                    stack = diagram.nameTable[diagram._getChild(parent.children[2])];
                if (stack && stack.children && stack.children.length > 0) {
                    firstCanvas = diagram.nameTable[diagram._getChild(stack.children[0])];
                    if (firstCanvas && firstCanvas.children && firstCanvas.children.length > 0) {
                        var _firstchild = diagram.nameTable[diagram._getChild(firstCanvas.children[0])]
                        if (_firstchild && _firstchild.name.indexOf("_Headerr") != -1) {
                            dleft = _firstchild.width;
                        }
                    }
                }
            }
            return { left: dleft, top: dtop };
        },
        _getNextPhase: function (diagram, phase) {
            var nxtPhase = null, index;
            var group = diagram.nameTable[phase.parent.split("phaseStack")[0]];
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, group);
            if (group && phases && phases.length > 0) {
                index = diagram._getPhaseIndex(phase.name);
                if (index === phases.length - 1)
                    nxtPhase = diagram.nameTable[phases[index]];
                else
                    nxtPhase = diagram.nameTable[phases[index + 1]];
            }
            return nxtPhase;
        },
        _getPhaseIndex: function (diagram, name) {
            var phase, group, index = -1;
            phase = diagram.nameTable[name];
            if (phase && phase.parent) {
                group = diagram.nameTable[phase.parent.split("phaseStack")[0]];
                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, group);
                if (phases && phases.length > 0) {
                    index = phases.indexOf(name);
                }
            }
            return index;
        },
        _cloneLaneObj: function (diagram, obj, name, childTable) {
            var nameTable = childTable ? childTable : diagram.nameTable;
            obj = $.extend(true, {}, obj);
            var children = obj.children;
            if (children && children.length > 0) {
                for (var m = 0; m < children.length; m++) {
                    var child = nameTable[diagram._getChild(children[m])];
                    if (child) {
                        child = jQuery.extend(true, {}, child);
                        if (child && child.children && child.children.length) {
                            child = diagram._cloneLaneObj(child, name, childTable);
                        }
                        child.name += name;
                        child.parent = name;
                        obj.children[m] = child;
                        if (childTable)
                            diagram._preserveConnection(childTable, child);
                    }
                }
            }
            if (obj && obj.header) {
                obj.header.name += name;
            }
            obj.name += name;
            return obj;
        },
        _cloneSwimlaneObj: function (diagram, obj, name, data) {
            obj = $.extend(true, {}, obj);
            if (obj && obj.isSwimlane) {
                obj = jQuery.extend(true, {}, obj);
                obj.name += name;
                //update lanes
                if (obj.lanes && obj.lanes.length > 0) {
                    for (var i = 0; i < obj.lanes.length; i++) {
                        if (obj.lanes[i]) {
                            obj.lanes[i] = diagram._cloneLaneObj(obj.lanes[i], name, (data && data.childTable) ? data.childTable : null);
                        }
                    }
                }
                //update phases
                if (obj.phases && obj.phases.length > 0) {
                    for (var i = 0; i < obj.phases.length; i++) {
                        if (obj.phases[i]) {
                            obj.phases[i].name += name;
                            obj.phases[i].parent = "";
                        }
                    }
                }
            }
            return obj;
        },
        _pasteSwimlaneObj: function (diagram, node, data) {
            node = diagram._pasteSwimlane(node, data);
            if (node) {
                var dx = diagram._isUndo ? 0 : (diagram._pasteIndex * 10);
                diagram._translate(node, dx, dx, diagram.nameTable);
                ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
            }
            return node;
        },
        _pasteSwimlane: function (diagram, node, data, mSelection, x) {
            diagram._pasteObj = true;
            if (node && node.isSwimlane) {
                var dx = diagram._isUndo ? 0 : diagram._pasteIndex * 10;
                var cloneObj = diagram._cloneSwimlaneObj(diagram._getNode(node.name, data ? data.childTable : null), diagram._swimlanePaste ? "" : ej.datavisualization.Diagram.Util.randomId(), data);
                cloneObj = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, cloneObj, data);
                if (diagram._outOfBoundsOnNudge(cloneObj, dx, dx)) {
                    diagram.add(cloneObj);
                }
                else {
                    ej.datavisualization.Diagram.containerCommon._removeObject(diagram, cloneObj);
                    return null
                };
                diagram._pasteObj = false;
                return cloneObj;
            }
        },
        _updateNextPhase: function (diagram, swimlane, dif, index) {
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, swimlane), phase;
            for (var i = index + 1; i < phases.length; i++) {
                phase = diagram.nameTable[diagram._getChild(phases[i])];
                if (phase) {
                    phase.offset += dif;
                }
            }
        },
        _getOuterNodes: function (diagram, swimlane, x, y) {
            var outerNodes = [];
            var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, swimlane);
            var prop = swimlane.orientation === "horizontal" ? "left" : "top";
            var value = swimlane.orientation === "horizontal" ? x : y;
            for (var i = 0; i < lanes.length; i++) {
                var lane = diagram.nameTable[diagram._getChild(lanes[i])];
                if (lane && lane.children.length > 1) {
                    for (var j = 0; j < lane.children.length; j++) {
                        var child = diagram.nameTable[diagram._getChild(lane.children[j])];
                        if (child) {
                            var childBounds = ej.datavisualization.Diagram.Util.bounds(child);
                            if (childBounds[prop] > value)
                                outerNodes.push(child);
                        }
                    }
                }
            }
            return outerNodes;
        },
        _getInnerNodes: function (diagram, swimlane, value1, value2) {
            var innerNodes = [];
            var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, swimlane);
            var prop1 = swimlane.orientation === "horizontal" ? "left" : "top";
            var prop2 = swimlane.orientation === "horizontal" ? "right" : "bottom";
            for (var i = 0; i < lanes.length; i++) {
                var lane = diagram.nameTable[diagram._getChild(lanes[i])];
                if (lane && lane.children.length > 1) {
                    for (var j = 0; j < lane.children.length; j++) {
                        var child = diagram.nameTable[diagram._getChild(lane.children[j])];
                        if (child) {
                            var bounds = ej.datavisualization.Diagram.Util.bounds(child);
                            if (bounds[prop1] >= value1 && bounds[prop2] <= value2)
                                innerNodes.push(child);
                        }
                    }
                }
            }
            return innerNodes;
        },
        _moveOuterNodes: function (diagram, swimlane, dif, index) {
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, swimlane);
            var phase = diagram.nameTable[diagram._getChild(phases[index])];
            var bounds = ej.datavisualization.Diagram.Util.bounds(swimlane);
            var swimlaneHeader = diagram.nameTable[diagram._getChild(swimlane.children[0])];
            var x = bounds.left + phase.offset;
            var y = bounds.top + phase.offset + swimlaneHeader.height;

            var prop = swimlane.orientation === "horizontal" ? "offsetX" : "offsetY";
            var value = swimlane.orientation === "horizontal" ? x : y;
            var margin = swimlane.orientation === "horizontal" ? "marginLeft" : "marginTop";
            var nodes = diagram._getOuterNodes(swimlane, x, y);

            if (nodes && nodes.length > 0) {
                for (var i = 0; i < nodes.length; i++) {
                    var child = diagram.nameTable[diagram._getChild(nodes[i])];
                    //child[prop] += dif;
                    diagram._translate(child, (prop === "offsetX" ? dif : 0), (prop === "offsetY" ? dif : 0), diagram.nameTable);
                    child[margin] += dif;
                }
            }
        },
        _moveOnPhaseChange: function (diagram, phase, dif, index) {
            var lane;
            var swimlaneName = phase.parent.split('phaseStack')[0];
            if (swimlaneName)
                var swimlane = diagram.nameTable[swimlaneName];
            if (swimlane) {
                var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, swimlane);
                var swimlaneHeader = diagram.nameTable[diagram._getChild(swimlane.children[0])];
                for (var i = 0; i < lanes.length; i++) {
                    lane = diagram.nameTable[diagram._getChild(lanes[i])];
                    if (lane) {
                        if (phase.orientation === "horizontal") {
                            lane.width += dif;
                            lane.minWidth = lane.width;
                        }
                        else {
                            lane.height += dif;
                            lane.minHeight = lane.height
                        }
                    }
                }
                if (phase.orientation === "horizontal") {
                    swimlane.minWidth += dif;
                }
                else {
                    swimlane.minHeight = lane.height
                }
                //diagram._updateNextPhase(swimlane, dif, index);
                //diagram._moveOuterNoder(swimlane, dif, index);
                ej.datavisualization.Diagram.SwimLaneContainerHelper._updateSwimlane(diagram, swimlane);
            }
        },
        _getPhaseDifferece: function (diagram, swimlane, index, difference) {
            var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, swimlane);
            var phase = diagram.nameTable[diagram._getChild(phases[index])];
            var swimlaneBounds = ej.datavisualization.Diagram.Util.bounds(swimlane);
            var prop = swimlane.orientation === "horizontal" ? "left" : "top";
            var swimlaneHeader = diagram.nameTable[diagram._getChild(swimlane.children[0])], head = 0;
            if (swimlane.orientation === "vertical")
                head = swimlaneHeader.height;
            if (index === 0) {
                var innerNodes = diagram._getInnerNodes(swimlane, swimlaneBounds[prop] + head, swimlaneBounds[prop] + phase.offset + head)
                if (innerNodes && innerNodes.length > 0) {
                    var pseudoGroup = ej.datavisualization.Diagram.Group({ "name": "multipleSelection", type: "pseudoGroup", children: innerNodes });
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                    var bounds = ej.datavisualization.Diagram.Util.bounds(pseudoGroup);
                }
                else {
                    var bounds = ej.datavisualization.Diagram.Util.bounds();
                    bounds.right = swimlaneBounds.left + 50;
                }
                if (swimlane.orientation === "horizontal") {
                    if (swimlaneBounds.left + (phase.offset + difference) >= bounds.right + 20) {
                    }
                    else {
                        var temp = (bounds.right + 20) - (swimlaneBounds.left + (phase.offset + difference));
                        difference = difference + temp;
                    }
                    if (phase.offset + difference < 100)
                        difference = 0;
                }
                else {
                    if (swimlaneBounds.top + swimlaneHeader.height + (phase.offset + difference) >= bounds.bottom + 20) {
                    }
                    else {
                        var temp = (bounds.bottom + 20) - (swimlaneBounds.top + head + (phase.offset + difference));
                        difference = difference + temp;
                    }
                    if (phase.offset + difference < 100)
                        difference = 0;
                }
            }
            else {
                var prevPhase = diagram.nameTable[diagram._getChild(phases[index - 1])];
                var innerNodes = diagram._getInnerNodes(swimlane, swimlaneBounds[prop] + prevPhase.offset + head, swimlaneBounds[prop] + phase.offset + head)
                if (innerNodes && innerNodes.length > 0) {
                    var pseudoGroup = ej.datavisualization.Diagram.Group({ "name": "multipleSelection", type: "pseudoGroup", children: innerNodes });
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                    var bounds = ej.datavisualization.Diagram.Util.bounds(pseudoGroup);
                }
                else {
                    bounds = ej.datavisualization.Diagram.Util.bounds();
                    bounds.bottom = swimlaneBounds.top + swimlaneHeader.height + prevPhase.offset;
                }
                if (swimlane.orientation === "horizontal") {
                    if (swimlaneBounds.left + (phase.offset + difference) >= bounds.right + 20) {
                    }
                    else {
                        var temp = (bounds.right + 20) - (swimlaneBounds.left + (phase.offset + difference));
                        difference = difference + temp;
                    }
                }
                else {
                    if (swimlaneBounds.top + swimlaneHeader.height + (phase.offset + difference) >= bounds.bottom + 20) {
                    }
                    else {
                        var temp = (bounds.bottom + 20) - (swimlaneBounds.top + swimlaneHeader.height + (phase.offset + difference));
                        difference = difference + temp;
                    }
                }
            }
            if (prevPhase && phase.offset - prevPhase.offset + difference < 20) {
                difference -= (phase.offset - prevPhase.offset + difference - 20);
            }
            return difference;
        },
        //#endregion
    };

    ej.datavisualization.Diagram.ContainerHelper = {
        _initContainer: function (diagram, node, data) {
            if (node.container) {
                switch (node.container.type) {
                    default:
                    case "canvas":
                        node = ej.datavisualization.Diagram.canvasHelper._initCanvas(diagram, node);
                        if (node.type == "bpmn") {
                            var parent = ej.datavisualization.Diagram.ContainerHelper.updateparent(node, diagram);
                            if (!parent)
                                ej.datavisualization.Diagram.bpmnHelper.updateCanvas(node, diagram);
                        }
                        break;
                    case "stack":
                        node = ej.datavisualization.Diagram.stackHelper._initStack(diagram, node);
                        break;
                }
            }
            else if (node.type === "swimlane" || node.isSwimlane) {
                node = ej.datavisualization.Diagram.SwimLaneContainerHelper._initSwimLane(diagram, node);
                node = ej.datavisualization.Diagram.SwimLaneContainerHelper._createSwimlane(diagram, node);
            }
            return node;
        },
        _add: function (diagram, node) {
            var parent;
            if (diagram.getObjectType(node) !== "connector") {
                parent = (node.parent) ? diagram.nameTable[node.parent] : null;
                if (parent && parent.container) {
                    for (var i = parent.children.length - 1; i >= 0; i--) {
                        var child = diagram.nameTable[diagram._getChild(parent.children[i])];
                        if (child.name === node.name)
                            ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, parent.children[i]);
                    }
                    parent.children.push(node.name);
                    diagram._disableSwimlaneUptate = true;
                    ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(diagram);
                    var prevObj = $.extend(true, {}, parent)
                    this._updateCollectionChange(diagram, parent, true);
                    ej.datavisualization.Diagram.canvasHelper._updateAddRemoveNodeConnectors(diagram, parent, prevObj);
                    delete diagram._disableSwimlaneUptate
                    ej.datavisualization.Diagram.canvasHelper._updateLastSwimlanePhase(diagram, node);
                    var parentObj = diagram._svg.document.getElementById(node.parent);
                    if (node._type === "group")
                        ej.datavisualization.Diagram.DiagramContext.renderGroup(node, diagram, parentObj);
                    else
                        ej.datavisualization.Diagram.DiagramContext.renderNode(node, diagram, parentObj);
                    ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdateNode(diagram, node);
                }
            }
        },
        updateparent: function (node, diagram) {
            var temp = node;
            if (diagram) {
                while (temp && temp.parent) {
                    temp = diagram.nameTable[temp.parent]
                    if (temp && temp.isLane)
                        return temp;
                }
            }
            return false;
        },
        _updateCollectionChange: function (diagram, node, updateOffset, parent) {
            if (!diagram._diagramClear) {
                var oldXY, currXY, update = true;
                if (node) {
                    var oldBounds = ej.datavisualization.Diagram.Util.bounds(node);
                    oldXY = { x: oldBounds.x, y: oldBounds.y };
                    if (node.container) {
                        if (node.container.type === "canvas") {
                            if (node._isBpmn) {
                                var parent = this.updateparent(node, diagram);
                                if (!parent) ej.datavisualization.Diagram.bpmnHelper.updateCanvas(node, diagram);
                                else ej.datavisualization.Diagram.canvasHelper._updateCollectionChange(diagram, node);
                            }
                            else ej.datavisualization.Diagram.canvasHelper._updateCollectionChange(diagram, node);
                        }
                        else
                            ej.datavisualization.Diagram.stackHelper._updateCollectionChange(diagram, node, null, parent);
                    }
                    if ((updateOffset && !node.isLane && !node._isBpmn) || node.isSwimlane) {
                        if (diagram._disableSwimlaneUptate)
                            update = false;
                        var currBounds = ej.datavisualization.Diagram.Util.bounds(node);
                        currXY = { x: currBounds.x, y: currBounds.y };
                        diagram._translate(node, oldXY.x - currXY.x, oldXY.y - currXY.y, diagram.nameTable)
                        if (update) {
                            ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
                        }
                    }
                }
                if (node && node.container && !node.isLane && !node.isSwimlane && !node.isLaneStack && !node.isPhaseStack)
                    ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
            }
        },
    };

    ej.datavisualization.Diagram.stackHelper = {
        _initStack: function (diagram, node) {
            node = ej.datavisualization.Diagram.Group(node);
            node = this._initGroupNode(diagram, node);
            node = this._initChildren(diagram, node);
            this._setSize(diagram, node);
            this._alignChildren(diagram, node);
            return node;
        },
        _initGroupNode: function (diagram, node) {
            return ej.datavisualization.Diagram.containerCommon._initGroupNode(diagram, node);
        },
        _initChildren: function (diagram, node) {
            return ej.datavisualization.Diagram.containerCommon._initChildren(diagram, node);
        },
        _setSize: function (diagram, node) {
            var pBounds = this._getStackBoundsBounds(diagram, node);
            if (pBounds.width >= node.minWidth && pBounds.width <= node.maxWidth)
                node.width = pBounds.width
            else if (pBounds.width <= node.minWidth)
                node.width = node.minWidth
            else if (pBounds.width >= node.maxWidth)
                node.width = node.maxWidth


            if (pBounds.height >= node.minHeight && pBounds.height <= node.maxHeight)
                node.height = pBounds.height
            else if (pBounds.height <= node.minHeight)
                node.height = node.minHeight
            else if (pBounds.height >= node.maxHeight)
                node.height = node.maxHeight
        },
        _getStackBoundsBounds: function (diagram, node) {
            var fRect = ej.datavisualization.Diagram.Rectangle(), i, child, cRect, height = 0, width = 0, maxWidth = 0, maxHeight = 0;
            var orientation = node.container.orientation ? node.container.orientation : "vertical";
            if (node.children && node.children.length > 0) {
                var children = node.children;
                for (i = 0; i < children.length; i++) {
                    child = typeof (children[i]) === "string" ? diagram.nameTable[children[i]] : children[i];
                    if (child) {
                        cRect = ej.datavisualization.Diagram.Util.bounds(child);
                        cRect = ej.datavisualization.Diagram.Geometry.rect([cRect.topLeft, cRect.topRight, cRect.bottomRight, cRect.bottomLeft]);
                        if (cRect) {
                            if (orientation === "vertical") {
                                width = cRect.width += child.marginLeft + child.marginRight;
                                if (width > maxWidth) {
                                    maxWidth = cRect.width = width;
                                }
                                cRect.width = (child.horizontalAlign === "stretch") ? (cRect.width > child.minWidth ? cRect.width : maxWidth) : maxWidth;
                                cRect.height += child.marginTop + child.marginBottom;
                                cRect.height += fRect.height;
                            }
                            else {
                                height = cRect.height += child.marginTop + child.marginBottom;
                                if (height > maxHeight) {
                                    maxHeight = cRect.height = height;
                                }

                                cRect.height = (child.verticalAlign === "stretch") ? (cRect.height > child.minHeight ? cRect.height : maxHeight) : maxHeight;
                                cRect.width += child.marginLeft + child.marginRight;
                                cRect.width += fRect.width;
                            }
                            cRect.x = 0; cRect.y = 0;
                        }
                        fRect = diagram._union(fRect, cRect);
                    }
                }
            }
            fRect.width += node.paddingLeft + node.paddingRight;
            fRect.height += node.paddingTop + node.paddingBottom;
            return fRect;
        },
        _alignChildren: function (diagram, node) {
            var child, transX = 0, transY = 0;;
            var children = node.children;
            for (var i = 0; i < children.length; i++) {
                child = typeof (children[i]) === "string" ? diagram.nameTable[children[i]] : children[i];
                if (child) {
                    var pos = this._getStackPosition(diagram, child, node, transX, transY);
                    this._translate(diagram, child, pos.x, pos.y);

                    if (node.container.orientation == "vertical")
                        transY += (child.height ? child.height : child._height) + child.marginTop + child.marginBottom;
                    else
                        transX += (child.width ? child.width : child._width) + child.marginLeft + child.marginRight;
                }
            }
        },
        _getStackPosition: function (diagram, child, parent, transX, transY) {
            var dx = 0, dy = 0;
            var groupBounds = ej.datavisualization.Diagram.Util.bounds(parent);
            var bounds = ej.datavisualization.Diagram.Util.bounds(child);
            var orientation = parent.container.orientation ? parent.container.orientation : "vertical";
            var width = child.width ? child.width : child._width;
            var height = child.height ? child.height : child._height;
            if (parent.container.orientation == "vertical") {
                dy = groupBounds.y - bounds.y + transY + child.marginTop + parent.paddingTop;
                switch (child.horizontalAlign) {
                    case "left":
                        dx = groupBounds.x - bounds.x + child.marginLeft + parent.paddingLeft;
                        break;
                    case "center":
                        dx = groupBounds.center.x - bounds.center.x;
                        break;
                    case "right":
                        dx = (groupBounds.x + groupBounds.width) - (bounds.x + bounds.width + parent.paddingRight);
                        break;
                    case "stretch":
                        var deltaWidth = (parent.width - (parent.paddingLeft + parent.paddingRight) - (child.marginLeft + child.marginRight)) / width;
                        diagram.scale(child, deltaWidth, 1, parent.pivot, diagram.nameTable);
                        groupBounds = ej.datavisualization.Diagram.Util.bounds(parent);
                        bounds = ej.datavisualization.Diagram.Util.bounds(child, diagram);
                        dx = (groupBounds.x + parent.paddingLeft + child.marginLeft) - (bounds.x);
                        break;
                }
            }
            else {
                dx = groupBounds.x - bounds.x + transX + child.marginLeft + parent.paddingLeft;
                switch (child.verticalAlign) {
                    case "top":
                        dy = groupBounds.y - bounds.y + child.marginTop + parent.paddingTop;
                        break;
                    case "center":
                        dy = groupBounds.center.y - bounds.center.y;
                        break;
                    case "bottom":
                        dy = (groupBounds.y + groupBounds.height) - (bounds.y + bounds.height + parent.paddingBottom);
                        break;
                    case "stretch":
                        var deltaHeight = (parent.height - (parent.paddingTop + parent.paddingBottom) - (child.marginTop + child.marginBottom)) / height;
                        diagram.scale(child, 1, deltaHeight, parent.pivot, diagram.nameTable);
                        groupBounds = ej.datavisualization.Diagram.Util.bounds(parent);
                        bounds = ej.datavisualization.Diagram.Util.bounds(child, diagram);
                        dy = (groupBounds.y + parent.paddingTop + child.marginTop) - (bounds.y);
                        break;
                }
            }
            return { x: dx, y: dy }
        },
        _translate: function (diagram, node, dx, dy) {
            if (dx || dy) {
                if (!node.segments) {
                    node.offsetX += dx;
                    node.offsetY += dy;
                    if ((node._type === "group" || node.type === "pseudoGroup" || node.type == "umlclassifier")) {
                        var nodes = node.children;
                        var child;
                        for (var i = 0; nodes && i < nodes.length; i++) {
                            child = diagram.nameTable[diagram._getChild(nodes[i])];
                            if (child) {
                                this._translate(diagram, child, dx, dy);
                            }
                        }
                    }
                    ej.datavisualization.Diagram.DefautShapes.translateBPMNAnnotationShape(node, dx, dy, null, diagram);
                } else {
                    ej.datavisualization.Diagram.Util._translateLine(node, dx, dy, node);
                }
            }
        },

        //#region update
        _updateCollectionChange: function (diagram, node, updateParent, parentObj) {
            this._setSize(diagram, node);
            this._alignChildren(diagram, node);
            if (node.parent) {
                var parent = diagram.nameTable[node.parent];
                if (!parent) {
                    if (parentObj && node.isPhaseStack) {
                        parent = parentObj;
                    }
                }
                if (parent && parent.container && !updateParent) {
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent);
                }
            }
            //ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
        }
        //#endregion
    };

    ej.datavisualization.Diagram.canvasHelper = {

        //#region helpers

        _initCanvas: function (diagram, node) {
            node._type = "group";
            if (!node.type) node.type = "group";
            node = ej.datavisualization.Diagram.Group(node);
            node = this._initGroupNode(diagram, node);
            node = this._initChildren(diagram, node);
            this._setSize(diagram, node);
            this._alignChildren(diagram, node);
            //this._setSize(diagram, node);
            return node;
        },
        _initGroupNode: function (diagram, node) {
            return ej.datavisualization.Diagram.containerCommon._initGroupNode(diagram, node);
        },
        _initChildren: function (diagram, node) {
            return ej.datavisualization.Diagram.containerCommon._initChildren(diagram, node);
        },
        _setSize: function (diagram, node, updatePosition, useBottomRight) {
            var pBounds = this._getCanvasBounds(diagram, node, useBottomRight);
            var pervBounds = ej.datavisualization.Diagram.Util.bounds(node);
            pervBounds = ej.datavisualization.Diagram.Geometry.rect([pervBounds.topLeft, pervBounds.topRight, pervBounds.bottomRight, pervBounds.bottomLeft]);
            if (pBounds.width >= node.minWidth && pBounds.width <= node.maxWidth)
                pBounds.width = pBounds.width
            else if (pBounds.width <= node.minWidth)
                pBounds.width = node.minWidth
            else if (pBounds.width >= node.maxWidth)
                pBounds.width = node.maxWidth


            if (pBounds.height >= node.minHeight && pBounds.height <= node.maxHeight)
                pBounds.height = pBounds.height
            else if (pBounds.height <= node.minHeight)
                pBounds.height = node.minHeight
            else if (pBounds.height >= node.maxHeight)
                pBounds.height = node.maxHeight

            if (updatePosition) {
                var scaleX = pBounds.width / pervBounds.width, scaleY = pBounds.height / pervBounds.height;
                var dx = (pBounds.x + pBounds.width / 2) - (pervBounds.x + pervBounds.width / 2);
                var dy = (pBounds.y + pBounds.height / 2) - (pervBounds.y + pervBounds.height / 2);
                var offset = ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY)
                diagram._translate(node, dx, dy, diagram.nameTable, true);
                diagram.scale(node, scaleX, scaleY, ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), diagram.nameTable);
                if (node._isBpmn) {
                    var children = diagram._getChildren(node.children);
                    for (var i = 0; i < children.length; i++) {
                        var child = diagram.nameTable[children[i]];
                        if (child && child._isInternalShape && ej.datavisualization.Diagram.Util.canResize(child))
                            child = $.extend(true, child, { offsetX: node.offsetX, offsetY: node.offsetY, width: node.width, height: node.height });
                    }
                    ej.datavisualization.Diagram.Util._updateBPMNProperties(node, diagram, diagram.nameTable, true);
                }
                ej.datavisualization.Diagram.DefautShapes.translateBPMNAnnotationShape(node, 1 / scaleX, 1 / scaleY, offset, diagram);
            } else {
                node.width = pBounds.width;
                node.height = pBounds.height;
            }
        },
        _alignChildren: function (diagram, node) {
            var child, update = true;
            var children = node.children;
            for (var i = 0; i < children.length; i++) {
                child = typeof (children[i]) === "string" ? diagram.nameTable[children[i]] : children[i];
                if (child && !child._isInternalShape) {
                    if (diagram._disablePhaseUpdate && child.isPhaseStack)
                        update = false;
                    if (update) {
                        var pos = this._getCanvasPosition(diagram, child, node);
                        this._translate(diagram, child, pos.x, pos.y);
                    }
                }
                if (child && child._isInternalShape && ej.datavisualization.Diagram.Util.canResize(child)) {
                    child = $.extend(true, child, { offsetX: node.offsetX, offsetY: node.offsetY, width: node.width, height: node.height });
                    ej.datavisualization.Diagram.Util._updateBPMNProperties(node, diagram, diagram.nameTable, true);
                }
            }
        },
        _translate: function (diagram, node, dx, dy) {
            if (dx || dy) {
                if (!node.segments) {
                    node.offsetX += dx;
                    node.offsetY += dy;
                    if ((node._type === "group" || node.type === "pseudoGroup")) {
                        var nodes = node.children;
                        var child;
                        for (var i = 0; i < nodes.length; i++) {
                            child = diagram.nameTable[diagram._getChild(nodes[i])];
                            if (child) {
                                this._translate(diagram, child, dx, dy);
                                diagram._updateQuad(child);
                            }
                        }
                    }
                    ej.datavisualization.Diagram.DefautShapes.translateBPMNAnnotationShape(node, dx, dy, null, diagram);
                } else {
                    ej.datavisualization.Diagram.Util._translateLine(node, dx, dy, node);
                }
            }
        },
        _getCanvasPosition: function (diagram, child, parent) {
            var dx = 0, dy = 0;
            var groupBounds = ej.datavisualization.Diagram.Util.bounds(parent);
            var bounds = ej.datavisualization.Diagram.Util.bounds(child);
            switch (child.horizontalAlign) {
                case "left":
                    dx = groupBounds.x - bounds.x + child.marginLeft + parent.paddingLeft;
                    break;
                case "center":
                    dx = (groupBounds.x + groupBounds.width / 2) - (bounds.x + bounds.width / 2) + child.marginLeft + parent.paddingLeft;
                    break;
                case "right":
                    dx = (groupBounds.x + groupBounds.width - child.marginRight) - (bounds.x + bounds.width + parent.paddingRight);
                    break;
                case "stretch":
                    var deltaWidth = (groupBounds.width - parent.paddingLeft - parent.paddingRight - child.marginLeft - child.marginRight) / child.width;
                    diagram.scale(child, deltaWidth, 0, parent.pivot, diagram.nameTable);
                    bounds = ej.datavisualization.Diagram.Util.bounds(child, diagram);
                    dx = (groupBounds.x + parent.paddingLeft) - (bounds.x) + child.marginLeft;
                    break;
            }
            switch (child.verticalAlign) {
                case "top":
                    dy = groupBounds.y - bounds.y + child.marginTop + parent.paddingTop;
                    break;
                case "center":
                    dy = (groupBounds.y + groupBounds.height / 2) - (bounds.y + bounds.height / 2) + child.marginTop + parent.paddingTop;
                    break;
                case "bottom":
                    dy = (groupBounds.y + groupBounds.height - child.marginBottom) - (bounds.y + bounds.height + parent.paddingBottom);
                    break;
                case "stretch":
                    var deltaHeight = (groupBounds.height - parent.paddingTop - parent.paddingBottom - child.marginTop - child.marginBottom) / child.height;
                    diagram.scale(child, 0, deltaHeight, parent.pivot, diagram.nameTable);
                    bounds = ej.datavisualization.Diagram.Util.bounds(child, diagram);
                    dy = (groupBounds.y + parent.paddingTop) - (bounds.y) + child.marginTop;
                    break;

            }
            return { x: dx, y: dy };
        },
        _getCanvasBounds: function (diagram, node, useBottomRight) {
            var fRect = ej.datavisualization.Diagram.Rectangle(), i = 0, child, cRect;
            var x, y, diffx, diffy;
            if (node.children && node.children.length > 0) {
                var children = node.children;
                for (; i < children.length; i++) {
                    child = typeof (children[i]) === "string" ? diagram.nameTable[children[i]] : children[i];
                    if (child && !child._isInternalShape) {
                        cRect = ej.datavisualization.Diagram.Util.bounds(child);
                        cRect = ej.datavisualization.Diagram.Geometry.rect([cRect.topLeft, cRect.topRight, cRect.bottomRight, cRect.bottomLeft]);
                        if (child.horizontalAlign === "stretch") {
                            cRect.width = cRect.width >= node.minWidth ? cRect.width : 1;
                            if ((node.isLane || node.isSwimlane) && i == 0)
                                cRect.width = 1;
                        }
                        if (child.verticalAlign === "stretch") {
                            cRect.height = cRect.height >= node.minHeight ? cRect.height : 1;
                            if (node.isLane && i == 0)
                                cRect.height = 1;
                        }
                        if (cRect) {
                            diffx = child.marginLeft > 0 ? cRect.x - child.marginLeft : cRect.x;
                            diffy = child.marginTop > 0 ? cRect.y - child.marginTop : cRect.y;
                            x = x == undefined ? diffx : Math.min(x, diffx);
                            y = y == undefined ? diffy : Math.min(y, diffy);
                            cRect.width += child.marginLeft + (useBottomRight ? 0 : child.marginRight);
                            cRect.height += child.marginTop + (useBottomRight ? 0 : child.marginBottom);
                            cRect.x = 0; cRect.y = 0;
                            if (node.type == "bpmn") {
                                if (child.marginLeft < 0) cRect.width -= child.marginLeft;
                                if (child.marginTop < 0) cRect.height -= child.marginTop;
                            }
                        }
                        fRect = ej.datavisualization.Diagram.Geometry.union(fRect, cRect);
                    }
                }
            }
            if (node.type == "bpmn" && ej.datavisualization.Diagram.Geometry.isEmptyRect(fRect)) {
                fRect = ej.datavisualization.Diagram.Util.bounds(node);
                fRect = ej.datavisualization.Diagram.Geometry.rect([fRect.topLeft, fRect.topRight, fRect.bottomRight, fRect.bottomLeft]);
            }
            else {
                fRect.width += node.paddingLeft + node.paddingRight;
                fRect.height += node.paddingTop + node.paddingBottom;
                fRect.x = x - node.paddingLeft;
                fRect.y = y - node.paddingTop;
            }
            return fRect;
        },

        //#endregion 

        //#region update
        _updateCollectionChange: function (diagram, node) {
            var useBottomRight = false;
            if (diagram.activeTool.name === "resize" && node.isLane) {
                useBottomRight = true;
            }
            this._setSize(diagram, node, null, useBottomRight);
            this._alignChildren(diagram, node);
            if (node.parent) {
                var parent = diagram.nameTable[node.parent];
                if (parent && parent.container) {
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent);
                }
            }
            //ej.datavisualization.Diagram.DiagramContext.update(node, diagram);
        },
        //#endregion

        _getSwimlane: function (diagram, laneName) {
            var lane = diagram.nameTable[diagram._getChild(laneName)];
            if (lane && lane.isLane) {
                var laneStack = diagram.nameTable[lane.parent];
                if (laneStack) {
                    var swimlane = diagram.nameTable[laneStack.parent];
                    if (swimlane)
                        return diagram.getNode(swimlane.name);
                }
            }

        },
        //#region swapping lane
        _laneConnectors: function (diagram, lane, connectors) {
            var m, i, j, k, lane, child, lanes;
            if (lane && lane.isLane) {
                for (j = 0; j < lane.children.length; j++) {
                    child = diagram.nameTable[diagram._getChild(lane.children[j])];
                    if (child) {
                        if (child.inEdges && child.inEdges.length > 0) {
                            for (m = 0; m < lane.children.length; m++) {
                                if (!diagram._collectionContains(child.inEdges[m], connectors))
                                    connectors.push(child.inEdges[m])
                            }
                        }
                        if (child.outEdges && child.outEdges.length > 0) {
                            for (m = 0; m < lane.children.length; m++) {
                                if (!diagram._collectionContains(child.outEdges[m], connectors))
                                    connectors.push(child.outEdges[m])
                            }
                        }
                    }
                }
            }
        },
        _connectorRelateTolaneCollection: function (diagram, connector, interLanes) {
            if (connector) {
                var swimlane, lIndex, sparent, tparent, tnode, snode, i;
                snode = connector.sourceNode ? diagram.nameTable[connector.sourceNode] : null;
                tnode = connector.targetNode ? diagram.nameTable[connector.targetNode] : null;
                if (snode && snode.parent) {
                    sparent = diagram.nameTable[snode.parent];
                }
                if (tnode && tnode.parent) {
                    tparent = diagram.nameTable[tnode.parent];
                }
                if (sparent && tparent && tparent.name === sparent.name)
                    return false;
                for (i = 0; i < interLanes.length; i++) {
                    if (sparent && sparent.name === interLanes[i])
                        return true;
                    if (tparent && tparent.name === interLanes[i])
                        return true;
                }

            }
            return false;
        },

        _recreateConnectorSegments: function (diagram, node, list, name1, name2) {
            if (diagram && node) {
                var connectors = [], swimConnectors = [], swimlane, connector, m, i, j, k, lane, child, lanes, interLanes;
                node = diagram.nameTable[diagram._getChild(node)];
                if (node && node.isLane || node.isSwimlane) {
                    if (node.isLane) {
                        if (Array.isArray(list)) {
                            interLanes = this._getIntermediateLanes(diagram, list, name1, name2);
                            for (i = 0 ; i < interLanes.length ; i++) {
                                lane = diagram.nameTable[diagram._getChild(interLanes[i])];
                                this._laneConnectors(diagram, lane, connectors)
                            }

                            swimlane = this._getSwimlane(diagram, node.name);
                            lanes = swimlane.lanes;
                            for (i = 0 ; i < lanes.length ; i++) {
                                lane = diagram.nameTable[diagram._getChild(lanes[i])];
                                this._laneConnectors(diagram, lane, swimConnectors)
                            }

                            for (i = 0 ; i < connectors.length ; i++) {
                                connector = diagram.nameTable[diagram._getChild(connectors[i])];
                                if (connector) {
                                    if (this._connectorRelateTolaneCollection(diagram, connector, [name1, name2])) {
                                        connector.segments = [];
                                        ej.datavisualization.Diagram.Util._initializeSegments(connector, "orthogonal");
                                    }
                                }
                            }
                            for (i = 0 ; i < swimConnectors.length ; i++) {
                                connector = diagram.nameTable[diagram._getChild(swimConnectors[i])];
                                if (connector) {
                                    this._updateConnectorEndPoints(diagram, connector);
                                }
                            }
                        }
                    }
                }
            }
        },

        _isLineInterSectingNode: function (diagram, connector, node) {
            var isInterSecting = false;
            if (connector && node) {
                var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
                var nodePoints = [
                        { x: nodeBounds.topLeft.x, y: nodeBounds.topLeft.y },
                        { x: nodeBounds.topRight.x, y: nodeBounds.topRight.y },
                        { x: nodeBounds.bottomRight.x, y: nodeBounds.bottomRight.y },
                        { x: nodeBounds.bottomLeft.x, y: nodeBounds.bottomLeft.y },
                        { x: nodeBounds.topLeft.x, y: nodeBounds.topLeft.y }
                ];
            }
            var segments = connector.segments;
            if (segments && segments.length > 0) {
                for (var i = 0; !isInterSecting && i < segments.length; i++) {
                    var segment = segments[i];
                    if (segment && segment.points.length > 0) {
                        var points = segment.points, point1, point2, point3, point4;
                        for (var j = 0; !isInterSecting && j < points.length - 1; j++) {
                            point1 = points[j];
                            point2 = points[j + 1];
                            for (var m = 0; !isInterSecting && m < nodePoints.length - 1; m++) {
                                point3 = nodePoints[m];
                                point4 = nodePoints[m + 1];
                                if (this._isInterSecting(point1.x, point1.y, point2.x, point2.y, point3.x, point3.y, point4.x, point4.y, true)) {
                                    isInterSecting = true;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            return isInterSecting;
        },

        _updateConnectorEndPoints: function (diagram, connector) {

            if (diagram && connector) {
                var reset = false;
                connector.sourcePoint = ej.datavisualization.Diagram.Point();
                connector.targetPoint = ej.datavisualization.Diagram.Point();
                ej.datavisualization.Diagram.Util._initConnectionEnds(connector, diagram);
                ej.datavisualization.Diagram.Util._initializeSegments(connector, "orthogonal");
                diagram._dock(connector, diagram.nameTable);
                if (connector.sourceNode)
                    var sourceNode = diagram.nameTable[connector.sourceNode];
                if (sourceNode && this._isLineInterSectingNode(diagram, connector, sourceNode))
                    reset = true;
                if (connector.targetNode)
                    var targetNode = diagram.nameTable[connector.targetNode];
                if (targetNode && this._isLineInterSectingNode(diagram, connector, targetNode)) {
                    if (this._anySegmentOrtho(connector)) {
                        reset = false;
                    }
                    else reset = true;
                }
                if (reset) {
                    connector.segments = [];
                    ej.datavisualization.Diagram.Util._initializeSegments(connector, "orthogonal");
                    diagram._dock(connector, diagram.nameTable);
                }
                ej.datavisualization.Diagram.Util._initializeSegments(connector, "orthogonal");
                diagram._dock(connector, diagram.nameTable);
            }
        },

        _anySegmentOrtho: function (connector) {
            var state = false;
            if (connector) {
                if (connector.segments && connector.segments.length > 0) {
                    for (var segment, i = 0; i < connector.segments.length; i++) {
                        segment = connector.segments[i];
                        if (segment && segment.type !== "orthogonal") {
                            state = true;
                            break;
                        }
                    }
                }
            }
            return state
        },

        _getIntermediateLanes: function (diagram, list, name1, name2) {
            var rlist = [], i;
            if (list) {
                var index1 = list.indexOf(name1);
                var index2 = list.indexOf(name2);
                var start = Math.min(index1, index2);
                var end = Math.max(index1, index2);
                for (i = start; i <= end; i++) {
                    rlist.push(list[i])
                }
            }
            return rlist;
        },
        _swapLane: function (diagram, list, name1, name2, isVertical, parent) {
            var btNode = diagram.nameTable[name2];
            var tList = list.slice();
            var tool = diagram.tools["move"];
            var prevSwimlane = this._getSwimlane(diagram, name1);
            tool._undoObject = $.extend(true, {}, { name1: name1, name2: name2 });
            if (btNode) {
                var bounds = ej.datavisualization.Diagram.Util.bounds(btNode);
                //btNode.height += 10;
                var currentIndex = list.indexOf(name1);
                var moveIndex = list.indexOf(name2);
                list.splice(list.indexOf(name1), 1);
                moveIndex += currentIndex > moveIndex ? 0 : -1;
                moveIndex += isVertical ? tool.currentPoint.y >= bounds.y && tool.currentPoint.y < bounds.center.y ? 0 : 1 :
                     tool.currentPoint.x >= bounds.x && tool.currentPoint.x < bounds.center.x ? 0 : 1;
                list.splice(moveIndex, 0, name1);
            }
            tool._redoObject = $.extend(true, {}, { name1: name2, name2: name1 });
            var entry = {
                type: "swapLane", undoObject: jQuery.extend(true, {}, tool._undoObject), redoObject: jQuery.extend(true, {}, tool._redoObject), currentIndex: currentIndex, moveIndex: moveIndex, category: "internal"
            };
            var currLaneSwimlane = this._getSwimlane(diagram, name1);
            if (prevSwimlane)
                diagram._comparePropertyValues(currLaneSwimlane, "lanes", { lanes: prevSwimlane.lanes }, true);
            diagram.addHistoryEntry(entry);
            tool._multipleUndo = true;
            if (parent)
                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, false);
            if (diagram.activeTool.selectedObject) {
                ej.datavisualization.Diagram.canvasHelper._recreateConnectorSegments(diagram, diagram.activeTool.selectedObject.name, tList, name1, name2);
                ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdateLane(diagram, diagram.activeTool.selectedObject)
            }
        },
        //#endregion

        //#region dragging singleNode
        _updateHelper: function (diagram) {
            if (!diagram.activeTool.helper) {
                this._initHelper(diagram);
            } else {
                this._updateHelperXY(diagram, diagram.activeTool.helper, diagram.activeTool.previousPoint, diagram.activeTool.currentPoint);
                ej.datavisualization.Diagram.SvgContext._updateContainerHelper(diagram);
            }
        },
        _updateHelperXY: function (diagram, shape, startPoint, endPoint) {
            var towardsLeft = endPoint.x < startPoint.x;
            var towardsTop = endPoint.y < startPoint.y;
            var difx = diagram.activeTool.diffx + (endPoint.x - startPoint.x);
            var dify = diagram.activeTool.diffy + (endPoint.y - startPoint.y);
            var offset;
            var enableSnapToObject = diagram.activeTool.diagram._enableSnapToObject();
            diagram.activeTool.diagram._enableSnapToObject(true);
            offset = ej.datavisualization.Diagram.SnapUtil._snapPoint(diagram, diagram.activeTool.helper, towardsLeft, towardsTop, ej.datavisualization.Diagram.Point(difx, dify),
        endPoint, startPoint);
            diagram.activeTool.diagram._enableSnapToObject(enableSnapToObject);
            if (!offset)
                offset = ej.datavisualization.Diagram.Point(difx, dify);
            diagram.activeTool.diffx = difx - offset.x;
            diagram.activeTool.diffy = dify - offset.y;
            if (!ej.datavisualization.Diagram.Geometry.isEmptyPoint(offset)) {
                var args = diagram.activeTool._raiseDragEvent({ element: diagram.getNode(diagram.activeTool.helper), offset: offset, cancel: false });
                if (args && !args.cancel) {
                    if (diagram.activeTool._outOfBoundsDrag(shape, offset.x, offset.y))
                        diagram._translate(shape, offset.x, offset.y, diagram.nameTable);
                    if (shape._type === "group") {
                        ej.datavisualization.Diagram.Util._updateGroupBounds(shape, diagram);
                    }
                }
            }
        },
        _initHelper: function (diagram) {
            diagram.activeTool.helper = this._getCloneNode(diagram.activeTool.selectedObject);
            diagram.activeTool.helper._name = diagram.activeTool.selectedObject.name;
            diagram.activeTool.helper.name = "helper";
            diagram.activeTool.startPoint = diagram.activeTool.currentPoint;
            ej.datavisualization.Diagram.SvgContext._drawContainerHelper(diagram);
        },
        _getCloneNode: function (node) {
            var obj = null;
            obj = jQuery.extend(true, {}, node);
            obj.children = [];
            obj.minHeight = 0;
            obj.minWidth = 0;
            obj.maxHeight = 0;
            obj.maxWidth = 0;
            return obj;
        },
        _updateHighlighter: function (diagram, evt) {
            var overNode = diagram.activeTool._getMouseOverElement(evt);
            if (overNode && !overNode.segments && (!diagram.activeTool.selectedObject.isLane || overNode.isLane)) {
                diagram.activeTool._nodeHighLighter(overNode, evt);
            } else {
                diagram.activeTool._removeHighLighter();
            }
        },
        _updateNodeMargin: function (diagram, node, overNode) {
            if (node._type == "group") {
                for (var i = 0; i < node.children.length; i++) {
                    var child = node.children[i];
                    this._updateNodeMargin(diagram, typeof child == "string" ? diagram.nameTable[child] : child, node);
                }
            }
            if (node && overNode) {
                var prevNode = $.extend(true, {}, node);
                var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
                var groupBounds = ej.datavisualization.Diagram.Util.bounds(overNode);
                var isStack = (overNode.container && overNode.container.type && overNode.container.type == "stack") ? true : false
                if (isStack) {
                    if (overNode.container.orientation === "horizontal")
                        node.marginTop = nodeBounds.top - groupBounds.top - overNode.paddingTop;
                    else node.marginLeft = nodeBounds.left - groupBounds.left - overNode.paddingLeft;
                }
                else {
                    node.marginLeft = nodeBounds.left - groupBounds.left - overNode.paddingLeft;
                    node.marginTop = nodeBounds.top - groupBounds.top - overNode.paddingTop;
                }
                var nodeWidth = nodeBounds.right - nodeBounds.left, nodeHeight = nodeBounds.bottom - nodeBounds.top;
                var right = (groupBounds.x + groupBounds.width) - (nodeBounds.x + nodeWidth) - overNode.paddingRight;
                (right < 0) ? node.marginRight = 0 : node.marginRight = right;
                var bottom = (groupBounds.y + groupBounds.height) - (nodeBounds.y + nodeHeight) - overNode.paddingBottom;
                (bottom < 0) ? node.marginBottom = 0 : node.marginBottom = bottom;
                if (overNode.isLane) {
                    var left = 0, top = 0;
                    if (overNode.orientation === "horizontal") {
                        left = 50, top = 0;
                    }
                    else {
                        left = 0, top = 50;
                    }
                    node.marginLeft = node.marginLeft >= left ? node.marginLeft : left;
                    node.marginTop = node.marginTop >= top ? node.marginTop : top;
                    diagram._comparePropertyValues(node, "marginLeft", { marginLeft: prevNode.marginLeft }, true);
                    diagram._comparePropertyValues(node, "marginRight", { marginLeft: prevNode.marginRight }, true);
                    diagram._comparePropertyValues(node, "marginBottom", { marginLeft: prevNode.marginBottom }, true);
                    diagram._comparePropertyValues(node, "marginRight", { marginLeft: prevNode.marginRight }, true);
                }
            }
        },
        _singleNodedrag: function (diagram, evt, overNode) {
            var checkDrop = !diagram.activeTool._checkForDropEvent(overNode);
            if (checkDrop) {
                if (overNode) {
                    if (ej.datavisualization.Diagram.Util.canAllowDrop(overNode) || (overNode.name == diagram.activeTool.selectedObject.parent)) {
                        if (overNode.container && overNode.container.type == "canvas") {
                            var newParent, oldParent;
                            var addToContainer = !overNode._isBpmn || (overNode._isBpmn && diagram.activeTool.selectedObject.parent != overNode.name) ? true : false;
                            if (ej.datavisualization.Diagram.canvasHelper._outOfBoundaryNodeDrop(diagram, diagram.activeTool.helper, overNode) && addToContainer) {
                                if (overNode.isLane)
                                    this._disableConnectorUpdate(diagram);
                                diagram.activeTool.seletedObject = diagram.nameTable[diagram.activeTool.selectedObject.name];
                                if (diagram.activeTool.selectedObject.parent)
                                    oldParent = diagram.nameTable[diagram.activeTool.selectedObject.parent];
                                diagram._disablePhaseUpdate = true;
                                diagram._disableSwimlaneUptate = true;
                                this._removeNodeFromContainer(diagram, diagram.activeTool.selectedObject);
                                this._addNodeToContainer(diagram, diagram.activeTool.selectedObject, overNode, null, true);
                                diagram._raiseGroupChangeEvent(diagram.activeTool.selectedObject, oldParent, overNode, "group");
                                diagram._comparePropertyValues(diagram.activeTool.selectedObject, "parent", { parent: oldParent.name }, true);
                                delete diagram._disablePhaseUpdate;
                                delete diagram._disableSwimlaneUptate;
                                this._updateLastSwimlanePhase(diagram, diagram.activeTool.selectedObject);
                                if (overNode.isLane)
                                    this._enableConnectorUpdateNode(diagram, diagram.activeTool.selectedObject);
                            }
                            else if (overNode._isBpmn) {
                                var canvasContainer = diagram.nameTable[diagram.activeTool.selectedObject.parent];
                                var prevWidth = canvasContainer.width, prevHeight = canvasContainer.height, offset = { x: canvasContainer.offsetX, y: canvasContainer.offsetY };
                                diagram._translate(diagram.activeTool.selectedObject, (diagram.activeTool.helper.offsetX - diagram.activeTool.selectedObject.offsetX), (diagram.activeTool.helper.offsetY - diagram.activeTool.selectedObject.offsetY), diagram.nameTable);
                                diagram._updateAssociatedConnectorEnds(diagram.activeTool.selectedObject, diagram.nameTable);
                                var parent = ej.datavisualization.Diagram.ContainerHelper.updateparent(overNode, diagram);
                                if (!parent)
                                    ej.datavisualization.Diagram.bpmnHelper.updateCanvas(canvasContainer, diagram);
                                else {
                                    this._removeNodeFromContainer(diagram, diagram.activeTool.selectedObject);
                                    this._addNodeToContainer(diagram, diagram.activeTool.selectedObject, overNode, null, true);
                                }

                            }
                            else {
                                diagram._translate(diagram.activeTool.selectedObject, (diagram.activeTool.undoObject.node.offsetX - diagram.activeTool.selectedObject.offsetX), (diagram.activeTool.undoObject.node.offsetY - diagram.activeTool.selectedObject.offsetY), diagram.nameTable);
                                diagram._updateAssociatedConnectorEnds(diagram.activeTool.selectedObject, diagram.nameTable);
                                this._updateLastSwimlanePhase(diagram, overNode);
                            }
                        }
                    }
                }
                else {
                    var selectedNode = $.extend(true, {}, diagram.activeTool.selectedObject);
                    if (diagram.activeTool.selectedObject.type != "pseudoGroup")
                        this._disableConnectorUpdate(diagram);
                    if (diagram.activeTool.selectedObject.parent)
                        oldParent = diagram.nameTable[diagram.activeTool.selectedObject.parent];
                    this._removeNodeFromContainer(diagram, diagram.activeTool.selectedObject);
                    diagram._raiseGroupChangeEvent(diagram.activeTool.selectedObject, oldParent, null, "group");
                    this._addMultiNodeToDiagram(diagram, diagram.activeTool.selectedObject);
                    this._enableConnectorUpdateNode(diagram, selectedNode);
                    diagram._updateAssociatedConnectorEnds(selectedNode, diagram.nameTable);
                }
            }
            return true;
        },

        _updateLastSwimlanePhase: function (diagram, node) {
            var lane = ej.datavisualization.Diagram.ContainerHelper.updateparent(node, diagram);
            if (lane && lane.isLane) {
                var laneStack = diagram.nameTable[lane.parent];
                if (laneStack) {
                    var swimlane = diagram.nameTable[laneStack.parent];
                    if (swimlane) {
                        this._updateLastPhase(diagram, swimlane);
                    }
                }
            }

        },
        _updateLastPhase: function (diagram, swimlane) {
            if (swimlane && swimlane.isSwimlane) {
                var laneStack = diagram.nameTable[diagram._getChild(swimlane.children[2])];
                var phaseStack = diagram.nameTable[diagram._getChild(swimlane.children[1])];
                var lBounds = ej.datavisualization.Diagram.stackHelper._getStackBoundsBounds(diagram, laneStack);
                var pBounds = ej.datavisualization.Diagram.stackHelper._getStackBoundsBounds(diagram, phaseStack);
                var phases = ej.datavisualization.Diagram.SwimLaneContainerHelper.getPhases(diagram, swimlane);
                var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, swimlane), lane;
                lane = diagram.nameTable[diagram._getChild(lanes[0])];
                if (phases.length > 0) {
                    var lastPhase = diagram.nameTable[phases[phases.length - 1]];
                    if (lastPhase) {
                        if (swimlane.orientation === "horizontal") {
                            var d = lBounds.width - pBounds.width;
                            lastPhase.width += d;
                            lastPhase.offset += d;
                            if (lane && lane.isLane)
                                lane.minWidth += d;
                        }
                        else {
                            d = lBounds.height - pBounds.height;
                            lastPhase.height += d;
                            lastPhase.offset += d;
                            if (lane && lane.isLane)
                                lane.minHeight += d;
                        }
                    }
                    ej.datavisualization.Diagram.SwimLaneContainerHelper._updatePhaseStack(diagram, swimlane);
                }
            }
        },

        //#endregion

        //#region connector update
        _disableConnectorUpdate: function (diagram) {
            diagram._disableSegmentChange = true;
        },

        _enableConnectorUpdate: function (diagram, swimlane, fromNudge) {
            delete diagram._disableSegmentChange;
            if (swimlane) {
                diagram._updateChildAdjacentConnectors(swimlane, true)
                if (!fromNudge) {
                    diagram._disableSegmentChange = true;
                    this._updateSwimalneAssociatedConnectors(diagram, swimlane, diagram._svg);
                    delete diagram._disableSegmentChange;
                }
                this._updateChildAdjacentConnectors(diagram, swimlane);
            }
        },
        _updateChildAdjacentConnectors: function (diagram, swimlane) {
            var childTable = diagram._getChildTable(swimlane, {});
            for (var child in childTable) {
                var childNode = diagram.nameTable[child];
                if (childNode && childNode.segments && swimlane.children.indexOf(child) == -1) {
                    ej.datavisualization.Diagram.DiagramContext.update(childNode, diagram);
                }
            }
        },
        _updateSwimalneAssociatedConnectors: function (diagram, group, svg, layout) {
            var children = diagram._getChildren(group.children);
            if (children && children.length > 0) {
                for (var i = 0, len = children.length; i < len; i++) {
                    var child = diagram.nameTable[children[i]];
                    if (child) {
                        if (child._type === "group")
                            this._updateSwimalneAssociatedConnectors(diagram, child, svg, layout);
                        else
                            this._updateSwimalneAssociatedConnectors(diagram, child, svg, layout);
                    }
                }
            }
            if (group.type != "group") {
                ej.datavisualization.Diagram.SvgContext._updateAssociatedConnector(group, svg, diagram);
            }
        },

        _enableConnectorUpdateNode: function (diagram, node) {
            var parent = null;
            if (node && node.parent) {
                parent = diagram.nameTable[node.parent];
            }
            if (parent) {
                if (parent.isLane) {
                    var swimlane = diagram.nameTable[parent.parent.split("laneStack")[0]];
                    if (swimlane && swimlane.isSwimlane) {
                        this._enableConnectorUpdate(diagram, swimlane);
                    }
                }
                else if (parent.type == "bpmn") {
                    this._enableConnectorUpdate(diagram, parent);
                }
            }
        },
        _enableConnectorUpdatePhase: function (diagram, phase) {
            if (phase && (phase.isPhase || phase.type === "phase")) {
                var swimlane = diagram.nameTable[phase.parent.split("phaseStack")[0]];
                if (swimlane && swimlane.isSwimlane) {
                    this._enableConnectorUpdate(diagram, swimlane);
                }
            }
        },
        _enableConnectorUpdateLane: function (diagram, lane) {
            if (lane && lane.isLane) {
                var swimlane = diagram.nameTable[lane.parent.split("laneStack")[0]];
                if (swimlane && swimlane.isSwimlane) {
                    this._enableConnectorUpdate(diagram, swimlane);
                }
            }
        },
        //#endregion

        //#region dragging multiNode

        _outOfBoundaryMultiNodeDrop: function (diagram, pseudoGroup) {
            var state = true;
            if (ej.datavisualization.Diagram.Util.canMoveOutofBoundary(diagram)) {
                if (pseudoGroup && pseudoGroup.type === "pseudoGroup") {
                    var child, targets, container;
                    var children = pseudoGroup.children;
                    for (var i = 0; i < children.length; i++) {
                        child = diagram.nameTable[diagram._getChild(children[i])];
                        targets = this._getTargets(diagram, child);
                        if (targets && targets.length > 0 && !child.segments) {
                            container = this._getContainerFromTarget(diagram, targets, child);
                            if (container) {
                                if (!this._isExeedBounds(diagram, child, container))
                                    return false
                            }
                        }
                    }
                }
            }
            return state;
        },

        _multiNodedrag: function (diagram, evt, pseudoGroup) {
            if (this._outOfBoundaryMultiNodeDrop(diagram, pseudoGroup)) {
                if (pseudoGroup) {
                    diagram._disableSwimlaneUptate = true;
                    this._disableConnectorUpdate(diagram);
                    if (pseudoGroup.children.length > 0) {
                        var child, targets, container;
                        var children = pseudoGroup.children;
                        for (var i = 0; i < children.length; i++) {
                            child = diagram.nameTable[diagram._getChild(children[i])];
                            targets = this._getTargets(diagram, child);
                            if (targets && targets.length > 0) {
                                container = this._getContainerFromTarget(diagram, targets, child);
                                if (container) {
                                    this._addNodeToContainer(diagram, child, container);
                                }
                                else this._addMultiNodeToDiagram(diagram, child);
                            }
                            else this._addMultiNodeToDiagram(diagram, child);
                            if (child.parent) {
                                var lane = diagram.nameTable[child.parent];
                                if (lane && lane.isLane) {
                                    var swimlane = diagram.nameTable[lane.parent.split("laneStack")[0]];
                                    if (swimlane) {
                                        if (!diagram._updateSwimlanes) {
                                            diagram._updateSwimlanes = [];
                                        }
                                        if (!diagram._collectionContains(swimlane.name, diagram._updateSwimlanes))
                                            diagram._updateSwimlanes.push(swimlane.name)
                                    }
                                }
                            }
                        }
                    }
                    delete diagram._disableSwimlaneUptate;
                    if (diagram._updateSwimlanes && diagram._updateSwimlanes.length > 0) {
                        for (var m = 0; m < diagram._updateSwimlanes.length; m++) {
                            ej.datavisualization.Diagram.DiagramContext.update(diagram.nameTable[diagram._updateSwimlanes[m]], diagram);
                            ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(diagram, diagram.nameTable[diagram._updateSwimlanes[m]]);
                        }
                    }
                    else delete diagram._disableSegmentChange;
                    delete diagram._updateSwimlanes;
                    this._getRedoObject(diagram, pseudoGroup);
                    var entry = { type: "positionchanged", node: jQuery.extend(true, {}, pseudoGroup), undoObject: jQuery.extend(true, {}, diagram.activeTool._undoObject), redoObject: jQuery.extend(true, {}, diagram.activeTool._redoObject), category: "internal", swimlaneMultiSelection: true };
                    diagram.addHistoryEntry(entry);
                    diagram.activeTool._multipleUndo = true;
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                    diagram.updateSelection();
                }
            }
            else {
                this._updateBoundsExceedNodes(diagram, pseudoGroup, "move");
            }
        },

        _updateBoundsExceedNodes: function (diagram, pseudoGroup, tool) {
            var undoObj = diagram.tools[tool].undoObject;
            var children = pseudoGroup.children;
            pseudoGroup.rotateAngle = undoObj.node.rotateAngle;
            for (var i = 0; i < children.length; i++) {
                var child = undoObj.childTable[children[i]];
                var orgChild = diagram.nameTable[children[i]];
                if (child && orgChild) {
                    if (tool === "move") {
                        diagram._translate(orgChild, (child.offsetX - orgChild.offsetX), (child.offsetY - orgChild.offsetY), diagram.nameTable);
                    }
                    else if (tool === "resize") {
                        diagram._translate(orgChild, child.offsetX - orgChild.offsetX, child.offsetY - orgChild.offsetY, diagram.nameTable);
                        diagram.scale(orgChild, (child.width / orgChild.width), (child.height / orgChild.height), ej.datavisualization.Diagram.Point(orgChild.offsetX, orgChild.offsetY), diagram.nameTable);
                    }
                    else if (tool === "rotate") {
                        diagram._translate(orgChild, (child.offsetX - orgChild.offsetX), (child.offsetY - orgChild.offsetY), diagram.nameTable);
                        var newangle = child.rotateAngle - orgChild.rotateAngle;
                        orgChild.rotateAngle += newangle;
                    }
                    if (orgChild._type === "group") {
                        ej.datavisualization.Diagram.Util._updateGroupBounds(orgChild, diagram);
                    }
                    diagram._updateAssociatedConnectorEnds(child, diagram.nameTable);
                    if (child.parent) {
                        var parent = diagram.nameTable[child.parent];
                        if (parent && parent.children.length > 0) {
                            parent.children.push(child.name);
                            orgChild.parent = child.parent;
                        }
                    }
                    ej.datavisualization.Diagram.DiagramContext.update(child, diagram);
                }
            }
            ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
            diagram.updateSelection();
        },
        _getContainerFromTarget: function (diagram, collection, child) {
            var childBounds, tarBounds;
            for (var i = 0; i < collection.length; i++) {
                if (collection[i].container && collection[i].container.type === "canvas") {
                    childBounds = ej.datavisualization.Diagram.Util.bounds(child);
                    tarBounds = ej.datavisualization.Diagram.Util.bounds(collection[i]);
                    if (childBounds.center.x > tarBounds.left && childBounds.center.x < tarBounds.right &&
                        childBounds.center.y > tarBounds.top && childBounds.center.y < tarBounds.bottom
                        ) {
                        return collection[i];
                    }
                }
            }
        },
        _getTargets: function (diagram, child) {
            var bounds = null, childBounds, nodes = [], lane;
            if (child) {
                childBounds = ej.datavisualization.Diagram.Util.bounds(child);
                var quads = ej.datavisualization.Diagram.SpatialUtil.findQuads(diagram._spatialSearch, childBounds);
                for (var i = 0; i < quads.length; i++) {
                    var quad = quads[i];
                    if (quad.objects.length > 0) {
                        for (var j = 0; j < quad.objects.length; j++) {
                            var nd = quad.objects[j];
                            if (!nd.segments && nd.visible) {
                                bounds = ej.datavisualization.Diagram.Util.bounds(nd);
                                if (nodes.indexOf(nd) == -1 && ej.datavisualization.Diagram.Geometry.intersectsRect(childBounds, bounds)) {
                                    if (nd.isSwimlane) {
                                        var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, nd);
                                        for (var k in lanes) {
                                            lane = diagram.nameTable[diagram._getChild(lanes[k])];
                                            if (lane)
                                                nodes.splice(0, 0, lane);
                                        }
                                    }
                                    else
                                        nodes.push(nd);
                                }
                            }
                        }
                    }
                }
            }
            return nodes;
        },
        _removeFromParentContainer: function (diagram, pseudoGroup) {
            this._removeNodeFromContainer(diagram, pseudoGroup);
        },
        _removeNodeFromContainer: function (diagram, node, updateParent) {
            diagram._removedFromContiner = true;
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[node.parent], child;
                if (parent) {
                    var children = parent.children;
                    var prevChildren = children;
                    prevChildren = prevChildren.slice(0);
                    for (var i = 0; i < children.length; i++) {
                        child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child.name === node.name)
                            ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, children[i]);
                    }
                    ej.datavisualization.Diagram.SpatialUtil._removeFromaQuad(diagram._spatialSearch, diagram._spatialSearch.quadTable[child.name], child);
                    var resource = { element: parent, cause: diagram.activeTool.inAction ? ej.datavisualization.Diagram.ActionType.Mouse : ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "children", oldValue: prevChildren, newValue: children };
                    diagram._raisePropertyChange(resource);
                    diagram._comparePropertyValues(node, "parent", { parent: "" }, resource.cause);
                    node.parent = "";
                    if (child._type === "group") {
                        ej.datavisualization.Diagram.SvgContext.renderGroup(child, diagram._svg, diagram._diagramLayer, diagram.nameTable, diagram);
                    } else if (child.segments) {
                        ej.datavisualization.Diagram.SvgContext.renderConnector(child, diagram._svg, diagram._diagramLayer);
                    } else {
                        ej.datavisualization.Diagram.SvgContext.renderNode(child, diagram._svg, diagram._diagramLayer, undefined, diagram);
                    }
                    if (!updateParent)
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
            }
            else {
                var children = node.children;
                if (children.length > 0) {
                    this._getUndoObject(diagram, node);
                    for (var i = 0; i < children.length; i++) {
                        var child = diagram.nameTable[children[i]];
                        if (child) {
                            this._removeNodeFromContainer(diagram, child, true);
                        }
                    }
                    if (child.parent)
                        var parent = diagram.nameTable[child.parent];
                    if (parent)
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
            }
        },
        _addDrgaHistoryEntry: function (diagram, node) {
            var childTable = {};
            var childTable = diagram._getChildTable(node, childTable);
            diagram.activeTool._multipleUndo = true;
            var entry = { type: "positionchanged", node: jQuery.extend(true, {}, node), childTable: childTable, category: "internal", swimlaneMultiSelection: true };
            diagram.addHistoryEntry(entry);
        },

        _cloneNode: function (diagram, node, name) {
            if (node) {
                node = $.extend(true, {}, node);
                node.name += name;
                node.parent += name;
                if (node.children && node.children.length > 0) {
                    var child;
                    var children = node.children;
                    for (var i = 0; i < children.length; i++) {
                        child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child) {
                            node.children[i] = this._cloneNode(diagram, child, name)
                        }
                    }
                }
                return node;
            }
        },

        _isExeedBounds: function (diagram, node, overNode) {
            diagram._disableUpdateQuad = true;
            if (node && overNode && overNode.isLane) {
                var swimlane = diagram.nameTable[overNode.parent.split("laneStack")[0]];
                if (swimlane) {
                    var randomId = ej.datavisualization.Diagram.Util.randomId();
                    var clSwimlane = diagram._cloneSwimlaneObj(diagram._getNode(swimlane.name), randomId);
                    clSwimlane = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, clSwimlane);
                    var clNode = this._cloneNode(diagram, node, randomId)
                    diagram.nameTable[clNode.name] = clNode;
                    var clLane = diagram.nameTable[overNode.name + randomId];
                    if (clLane) {
                        clLane.children.push(clNode.name);
                        this._updateNodeMargin(diagram, clNode, diagram.nameTable[overNode.name + randomId]);
                        diagram._disableSwimlaneUptate = true;
                        this._disableConnectorUpdate(diagram);
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, clLane);
                        ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, clSwimlane);
                        delete diagram._disableSegmentChange;
                        delete diagram._disableSwimlaneUptate
                        var clSwimlaneBounds = ej.datavisualization.Diagram.Util.bounds(clSwimlane);
                        ej.datavisualization.Diagram.containerCommon._removeObject(diagram, clLane);
                        ej.datavisualization.Diagram.containerCommon._removeObject(diagram, clSwimlane);
                        delete diagram._disableUpdateQuad;
                        var size = diagram.activeTool._getPageBounds();
                        if (clSwimlaneBounds.bottom > size.height)
                            return false
                        if (clSwimlaneBounds.right > size.width)
                            return false
                        clLane.children.pop(clNode.name);
                    }
                    diagram.nameTable[clNode.name]
                }
            }
            delete diagram._disableUpdateQuad;
            return true;
        },

        _outOfBoundaryNodeDrop: function (diagram, node, overNode) {
            if (ej.datavisualization.Diagram.Util.canMoveOutofBoundary(diagram)) {
                return this._isExeedBounds(diagram, node, overNode);
            }
            return true;
        },

        _addNodeToContainer: function (diagram, node, overNode, updateParent, enableConnectorUpdate) {
            if (diagram.getObjectType(node) !== "connector") {
                if (node && overNode && !node.isPhase) {
                    if (node.parent) {
                        var oGroup = diagram.nameTable[node.parent];
                        if (!oGroup.container) {
                            var oChjildren = oGroup.children;
                            ej.datavisualization.Diagram.Util.removeFromCollection(diagram, oChjildren, node);
                            ej.datavisualization.Diagram.Util._updateGroupBounds(oGroup, diagram);
                        }
                    }
                    if (node.type !== "pseudoGroup") {
                        var nodeBounds = ej.datavisualization.Diagram.Util.bounds(diagram.activeTool.helper);
                        var selObjBounds = ej.datavisualization.Diagram.Util.bounds(diagram.activeTool.selectedObject);
                        var diffX = diagram.activeTool.helper ? nodeBounds.x - selObjBounds.x : 0;
                        var diffY = diagram.activeTool.helper ? nodeBounds.y - selObjBounds.y : 0;
                        diagram._raiseOffsetPropertyChange(node, node.offsetX + diffX, node.offsetY + diffY, true);
                        diagram._translate(node, diffX, diffY, diagram.activeTool.diagram.nameTable);
                        var prevChildren = overNode.children;
                        prevChildren = prevChildren.slice(0);
                        overNode.children.push(node.name);
                        var resource = { element: overNode, cause: diagram.activeTool.inAction ? ej.datavisualization.Diagram.ActionType.Mouse : ej.datavisualization.Diagram.ActionType.Unknown, propertyName: "children", oldValue: prevChildren, newValue: overNode.children };
                        diagram._raisePropertyChange(resource);
                        diagram._comparePropertyValues(node, "parent", { parent: overNode.name }, resource.cause);
                        node.parent = overNode.name;
                        this._updateNodeMargin(diagram, node, overNode);
                        if (diagram._isDragg) {
                            var historyList = diagram._historyList;
                            if (historyList) {
                                if (historyList.currentEntry && historyList.currentEntry.object && historyList.currentEntry.object.parent === "")
                                    historyList.currentEntry.object = $.extend(true, {}, node);
                            }
                        }
                        var parentElement = diagram._svg.getElementById(overNode.name);
                        if (node._type === "group") {
                            ej.datavisualization.Diagram.DiagramContext.renderGroup(node, diagram, parentElement);
                        } else if (node.segments) {
                            //ej.datavisualization.Diagram.DiagramContext.renderConnector(node, diagram, parentElement);
                        } else {
                            ej.datavisualization.Diagram.DiagramContext.renderNode(node, diagram, parentElement);
                        }
                        this._disableConnectorUpdate(diagram);
                        if (!updateParent) {
                            var undoObject;
                            if (overNode.type == "bpmn") undoObject = $.extend(true, {}, { node: overNode });
                            var prevObj = jQuery.extend(true, {}, overNode)
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, overNode, true);
                            this._updateAddRemoveNodeConnectors(diagram, overNode, prevObj);
                            if (overNode.type == "bpmn") {
                                diagram._isGroupActionEnabled = true;
                                diagram._startGroupAction();
                                var entry = { type: "sizechanged", node: jQuery.extend(true, {}, overNode), undoObject: undoObject, redoObject: $.extend(true, {}, { node: overNode }), category: "internal" };
                                diagram.addHistoryEntry(entry);
                            }
                        }
                        this._updateLastSwimlanePhase(diagram, node);
                        if (!enableConnectorUpdate)
                            this._enableConnectorUpdateNode(diagram, node);
                        if (diagram._findLabelEditing)
                            overNode.children.splice(overNode.children.indexOf(node.name), 1);
                    }
                    else {
                        var children = node.children;
                        if (children.length > 0) {
                            for (var i = 0; i < children.length; i++) {
                                var child = diagram.nameTable[diagram._getChild(children[i])];
                                if (child) {
                                    this._addNodeToContainer(diagram, child, overNode, true)
                                }
                            }
                            if (child && child.parent)
                                var parent = diagram.nameTable[child.parent];
                            if (parent) {
                                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                                ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                                ej.datavisualization.Diagram.SvgContext.updateSelector(node, diagram._adornerSvg, diagram._currZoom, diagram, diagram.model.selectedItems.constraints);
                            }
                        }
                    }
                }
            }
        },
        _addMultiNodeToDiagram: function (diagram, child) {
            if (diagram.activeTool.helper) {
                var nodeBounds = ej.datavisualization.Diagram.Util.bounds(diagram.activeTool.helper);
                var selObjBounds = ej.datavisualization.Diagram.Util.bounds(child);
                var diffX = diagram.activeTool.helper ? nodeBounds.x - selObjBounds.x : 0;
                var diffY = diagram.activeTool.helper ? nodeBounds.y - selObjBounds.y : 0;
                diagram._translate(child, diffX, diffY, diagram.nameTable);
            }
            var nodes = diagram.nodes();
            for (var i = nodes.length - 1; i >= 0; i--) {
                var node = diagram.nameTable[diagram._getChild(nodes[i])];
                if (child.name === node.name)
                    ej.datavisualization.Diagram.Util.removeItem(nodes, nodes[i]);
            }
            diagram.nodes().push(child);
            if (diagram._removedFromContiner) {
                if (child._type === "group") {
                    ej.datavisualization.Diagram.SvgContext.renderGroup(child, diagram._svg, diagram._diagramLayer, diagram.nameTable, diagram);
                } else if (child.segments) {
                    ej.datavisualization.Diagram.SvgContext.renderConnector(child, diagram._svg, diagram._diagramLayer);
                } else {
                    ej.datavisualization.Diagram.SvgContext.renderNode(child, diagram._svg, diagram._diagramLayer, undefined, diagram);
                }
            }
            delete diagram._removedFromContiner;
            if (diagram.activeTool.helper) {
                this._updateLastSwimlanePhase(diagram, diagram.activeTool.helper);
            }
        },
        //#endregion

        //#region resizing singleNode
        _singleNodeResize: function (diagram, evt, node) {
            if (diagram.activeTool.selectedObject) {
                this._resizeNode(diagram, node);
            }
        },
        _resizeNode: function (diagram, node) {
            if (node) {
                var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
                var helperBounds = ej.datavisualization.Diagram.Util.bounds(diagram.activeTool.helper);
                var updateChild = true;
                if ((!node.container)) {
                    if (node.parent == "") {
                        if (node._parent) {
                            node.parent = node._parent;
                            delete node._parent;
                            updateChild = false;
                        }
                    }
                    if (!node.segments) {
                        if (node.parent)
                            var parent = diagram.nameTable[node.parent];
                        if (parent && parent.isLane) {
                            this._disableConnectorUpdate(diagram);
                        }
                        if (updateChild)
                            diagram.activeTool._updateSize(node, diagram.activeTool.startPoint, diagram.activeTool.currentPoint);
                        if (parent) {
                            this._updateNodeMargin(diagram, node, parent);
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                            this._updateLastSwimlanePhase(diagram, node);
                        }
                        this._enableConnectorUpdateNode(diagram, node);
                    }
                }
            }
        },
        _updateResizeHelper: function (diagram) {
            if (!diagram.activeTool.helper) {
                diagram.activeTool.helper = diagram.activeTool._getCloneNode(diagram.activeTool.selectedObject);
                diagram.activeTool.helper.inEdges = diagram.activeTool.helper.outEdges = [];
                diagram.activeTool.helper.type = null;
                diagram.activeTool.helper.name = "helper";
                ej.datavisualization.Diagram.SvgContext._drawContainerHelper(diagram);
                diagram.activeTool._startPoint = diagram.activeTool.currentPoint;
                diagram._resizeStack = true;
                diagram.activeTool._updateSize(diagram.activeTool.helper, diagram.activeTool.previousPoint, diagram.activeTool.currentPoint, null, null, null, true);
                delete diagram._resizeStack;
            } else {
                var groupBounds123 = ej.datavisualization.Diagram.Util.bounds(diagram.activeTool.helper);
                diagram._resizeStack = true;
                diagram.activeTool._updateSize(diagram.activeTool.helper, diagram.activeTool.previousPoint, diagram.activeTool.currentPoint, null, null, null, true);
                delete diagram._resizeStack;
                var groupBounds1231 = ej.datavisualization.Diagram.Util.bounds(diagram.activeTool.helper);
                if (diagram.activeTool.selectedObject.container && !diagram.activeTool.helper._isBpmn)
                    diagram._translate(diagram.activeTool.helper, groupBounds123.topLeft.x - groupBounds1231.topLeft.x, groupBounds123.topLeft.y - groupBounds1231.topLeft.y, diagram.nameTable);
                ej.datavisualization.Diagram.SvgContext._updateContainerHelper(diagram);
            }
        },
        //#endregion

        //#region resizing multiNode

        _multiNodeResize: function (diagram, evt, pseudoGroup) {
            if (pseudoGroup) {
                if (this._outOfBoundaryMultiNodeDrop(diagram, pseudoGroup)) {
                    if (pseudoGroup.children.length > 0) {
                        var child, targets, container;
                        var children = pseudoGroup.children;
                        for (var i = 0; i < children.length; i++) {
                            child = diagram.nameTable[diagram._getChild(children[i])];
                            targets = this._getTargets(diagram, child);
                            if (targets && targets.length > 0) {
                                container = this._getContainerFromTarget(diagram, targets, child);
                                if (container) {
                                    this._addNodeToContainer(diagram, child, container);
                                }
                                else this._addMultiNodeToDiagram(diagram, child);
                            }
                            else this._addMultiNodeToDiagram(diagram, child);
                        }
                    }
                    this._getRedoObject(diagram, pseudoGroup);
                    var entry = { type: "sizechanged", node: jQuery.extend(true, {}, pseudoGroup), undoObject: jQuery.extend(true, {}, diagram.activeTool._undoObject), redoObject: jQuery.extend(true, {}, diagram.activeTool._redoObject), category: "internal", swimlaneMultiSelection: true };
                    diagram.addHistoryEntry(entry);
                    diagram.activeTool._multipleUndo = true;
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                    diagram.updateSelection();
                }
                else {
                    this._updateBoundsExceedNodes(diagram, pseudoGroup, "resize");
                }
            }
        },
        //#endregion

        //#region rotate singleNode
        _singleNodeRotate: function (diagram, evt, node) {
            if (diagram.activeTool.selectedObject) {
                this._rotateNode(diagram, node);
            }
        },
        _rotateNode: function (diagram, node) {
            if (node) {
                var updateChild = true;
                if ((!node.container)) {
                    if (node.parent == "") {
                        if (node._parent) {
                            node.parent = node._parent;
                            delete node._parent;
                            updateChild = false;
                        }
                    }
                    if (node.parent)
                        var parent = diagram.nameTable[node.parent];
                    if (parent && parent.isLane) {
                        this._disableConnectorUpdate(diagram);
                    }
                    if (!node.segments) {
                        if (updateChild) {
                            var object = diagram.nameTable[diagram.activeTool.selectedObject.name];
                            if (diagram.activeTool.helper) {
                                var difAngle = diagram.activeTool.helper.rotateAngle - diagram.nameTable[diagram.activeTool.selectedObject.name].rotateAngle;
                                diagram._comparePropertyValues(node, "rotateAngle", { rotateAngle: diagram.activeTool.helper.rotateAngle }, true);
                                diagram._rotate(diagram.activeTool.selectedObject, difAngle, diagram.nameTable);
                            }
                        }

                        if (parent) {
                            this._updateNodeMargin(diagram, node, parent);
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                            this._updateLastSwimlanePhase(diagram, node);
                        }
                        this._enableConnectorUpdateNode(diagram, node);
                    }
                }
            }
        },
        //#endregion

        //#region rotate multiNode
        _multiNodeRotate: function (diagram, evt, pseudoGroup) {
            if (pseudoGroup) {
                if (this._outOfBoundaryMultiNodeDrop(diagram, pseudoGroup)) {
                    if (pseudoGroup.children.length > 0) {
                        var child, targets, container;
                        var children = pseudoGroup.children;
                        for (var i = 0; i < children.length; i++) {
                            child = diagram.nameTable[diagram._getChild(children[i])];
                            targets = this._getTargets(diagram, child);
                            if (targets && targets.length > 0) {
                                container = this._getContainerFromTarget(diagram, targets, child);
                                if (container) {
                                    this._addNodeToContainer(diagram, child, container);
                                }
                                else this._addMultiNodeToDiagram(diagram, child);
                            }
                            else this._addMultiNodeToDiagram(diagram, child);
                        }
                    }
                    this._getRedoObject(diagram, pseudoGroup);
                    var entry = { type: "rotationchanged", node: jQuery.extend(true, {}, pseudoGroup), undoObject: jQuery.extend(true, {}, diagram.activeTool._undoObject), redoObject: jQuery.extend(true, {}, diagram.activeTool._redoObject), category: "internal", swimlaneMultiSelection: true };
                    diagram.addHistoryEntry(entry);
                    diagram.activeTool._multipleUndo = true;
                    ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                    diagram.updateSelection();
                }
                else {
                    this._updateBoundsExceedNodes(diagram, pseudoGroup, "rotate");
                }
            }
        },
        //#endregion

        //#region add New Lane
        _updateDropLaneProperties: function (diagram, lane, swimlane) {
            if (lane && swimlane) {
                lane.orientation = swimlane.orientation;
                lane.horizontalAlign = swimlane.orientation === "horizontal" ? "stretch" : "left";
                lane.verticalAlign = swimlane.orientation === "vertical" ? "stretch" : "top";
                lane.paddingBottom = 20;
                lane.paddingTop = 20;
                lane.paddingLeft = 20;
                lane.paddingRight = 20;
                var header = diagram.nameTable[lane.children[0]];
                if (header) {
                    header.marginLeft = -20;
                    header.marginTop = -20;
                    header.marginRight = -20;
                    header.marginBottom = -20;
                    header.constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Select ^ ej.datavisualization.Diagram.NodeConstraints.Connect;
                    header._isHeader = true;
                }
            }
            return lane;
        },
        _updateAddRemoveNodeConnectors: function (diagram, orgNode, dupNode) {
            if (orgNode && orgNode.isLane && dupNode && dupNode.isLane) {
                var xdiff = 0, ydiff = 0;
                xdiff = orgNode.width - dupNode.width;
                ydiff = orgNode.height - dupNode.height;
                if (xdiff || ydiff)
                    this._updateOverlappedConnectorSegment(diagram, dupNode, xdiff, ydiff);
            }
        },

        _updateAddRemoveLaneConnectors: function (diagram, lane) {
            if (lane && lane.isLane) {
                var swimConnectors = [], connector, swimlane, lanes, i, lane;
                swimlane = this._getSwimlane(diagram, lane.name);
                lanes = swimlane.lanes;
                for (i = 0 ; i < lanes.length ; i++) {
                    lane = diagram.nameTable[diagram._getChild(lanes[i])];
                    this._laneConnectors(diagram, lane, swimConnectors)
                }
                for (i = 0 ; i < swimConnectors.length ; i++) {
                    connector = diagram.nameTable[diagram._getChild(swimConnectors[i])];
                    if (connector) {
                        this._updateConnectorEndPoints(diagram, connector);
                    }
                }
            }
        },
        _outOfBoundaryAddLane: function (diagram, swimlane, lane, index) {

            if (ej.datavisualization.Diagram.Util.canMoveOutofBoundary(diagram)) {
                var clSwimlane = diagram._cloneSwimlaneObj(diagram._getNode(swimlane.name), ej.datavisualization.Diagram.Util.randomId());
                clSwimlane = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, clSwimlane);
                var clLane = diagram.activeTool._cloneGroupNode($.extend(true, {}, lane), ej.datavisualization.Diagram.Util.randomId());
                //clLane.children = [];
                diagram.nameTable[clLane.name] = clLane;
                var stack = diagram.nameTable[diagram._getChild(clSwimlane.children[2])];
                if (index || index === 0) {
                    stack.children.splice(index, 0, clLane.name);
                }
                else
                    stack.children.push(clLane.name);
                clLane.parent = stack.name;
                diagram._disableSwimlaneUptate = true;
                this._disableConnectorUpdate(diagram);
                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, clLane);
                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, clSwimlane);
                this._enableConnectorUpdate(diagram, clSwimlane);


                delete diagram._disableSwimlaneUptate

                var clSwimlaneBounds = ej.datavisualization.Diagram.Util.bounds(clSwimlane);
                ej.datavisualization.Diagram.containerCommon._removeObject(diagram, clLane);
                ej.datavisualization.Diagram.containerCommon._removeObject(diagram, clSwimlane);

                var size = diagram.activeTool._getPageBounds();
                if (clSwimlaneBounds.bottom > size.height)
                    return false
                if (clSwimlaneBounds.right > size.width)
                    return false
            }
            return true;
        },

        _addNewLane: function (diagram, overNode, swimlane, updateName, index) {
            diagram.activeTool._removeHelpers();
            var addSelection;
            var stack = diagram.nameTable[diagram._getChild(swimlane.children[2])];
            if (stack) {
                var selctObject = diagram.activeTool._cloneGroupNode(diagram.activeTool.selectedObject, updateName ? "" : ej.datavisualization.Diagram.Util.randomId());
                selctObject = this._updateDropLaneProperties(diagram, selctObject, swimlane);
                var _undo = diagram._isUndo; diagram._isUndo = true;
                diagram.activeTool.selectedObject = null;
                diagram.remove(diagram.activeTool.selectedObject);
                //ej.datavisualization.Diagram.containerCommon._removeObject(diagram, diagram.activeTool.selectedObject);
                diagram._isUndo = _undo;
                if (diagram._isUndo || this._outOfBoundaryAddLane(diagram, swimlane, selctObject, index)) {
                    var args = { element: diagram.getNode(selctObject), cancel: false, target: overNode };
                    if (overNode)
                        var index = index !== undefined ? index : diagram.activeTool._getSwimLaneStackIndex(overNode);
                    if (index || index === 0) {
                        stack.children.splice(index, 0, selctObject.name);
                    }
                    else
                        stack.children.push(selctObject.name);
                    selctObject.parent = stack.name;
                    diagram._raiseDropEvent(args);
                    diagram.remove(selctObject);
                    if (!args.cancel) {
                        diagram.activeTool._isLane = true;
                        if (selctObject.isLane) {
                            var header = diagram.nameTable[diagram._getChild(selctObject.children[0])];
                            if (header && selctObject.labels && header.labels.length > 0) {
                                for (var j = 0; j < header.labels.length; j++)
                                    header.labels[j].visible = true;
                            }
                        }
                        if (!diagram._isUndo) {
                            var childTable = diagram._getChildTable(selctObject, {});
                            var entry = { type: "collectionchanged", object: jQuery.extend(true, {}, selctObject), childTable: jQuery.extend(true, {}, childTable), index: index, changeType: "insert", category: "internal" };
                            diagram.addHistoryEntry(entry);
                        }
                        if (diagram.add(selctObject)) {
                            diagram._updateDroppedSymbol(selctObject);
                        }
                    }
                    this._disableConnectorUpdate(diagram);
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, stack);
                    this._updateAddRemoveLaneConnectors(diagram, selctObject)
                    ej.datavisualization.Diagram.canvasHelper._updateLastPhase(diagram, swimlane);
                    this._enableConnectorUpdateLane(diagram, selctObject);
                    addSelection = true;
                }
                diagram._clearSelection(true);
                if (addSelection)
                    diagram._addSelection(swimlane, true);
                diagram.activeTool.selectedObject = null;
                //diagram.selectionList = [];
                //diagram.selectionList.push(swimlane);
            }
        },
        //#endregion

        //#region resize lane

        _outOfBoundsOnLaneResize: function (diagram, node, isLane) {
            if (ej.datavisualization.Diagram.Util.canMoveOutofBoundary(diagram)) {
                if (isLane) {
                    var swimlane = diagram.nameTable[node.parent.split("laneStack")[0]];
                }
                else
                    swimlane = node;
                var randomId = ej.datavisualization.Diagram.Util.randomId();
                if (swimlane) {
                var clSwimlane = diagram._cloneSwimlaneObj(diagram._getNode(swimlane.name), randomId);
                clSwimlane = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, clSwimlane);
                if (isLane) {
                    var clLane = diagram.nameTable[node.name + randomId];
                    if (clLane) {
                        clLane.minWidth = diagram.activeTool.helper.width;
                        clLane.minHeight = diagram.activeTool.helper.height;
                    }
                }
                else {
                    clSwimlane.minWidth = diagram.activeTool.helper.width;
                    clSwimlane.minHeight = diagram.activeTool.helper.height;
                }


                diagram._disableSwimlaneUptate = true;
                this._disableConnectorUpdate(diagram);
                if (isLane)
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, clLane);
                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, clSwimlane);
                this._enableConnectorUpdateLane(diagram, clSwimlane);


                delete diagram._disableSwimlaneUptate

                var clSwimlaneBounds = ej.datavisualization.Diagram.Util.bounds(clSwimlane);

                ej.datavisualization.Diagram.containerCommon._removeObject(diagram, clSwimlane);

                var size = diagram.activeTool._getPageBounds();
                if (clSwimlaneBounds.bottom > size.height)
                    return false
                if (clSwimlaneBounds.right > size.width)
                    return false
            }
            }
            return true;
        },
        _getLaneIndex: function (swimlane, lane) {
            var lanes = swimlane.lanes, i;
            for (i = 0; i < lanes.length; i++) {
                if (lane.name === lanes[i].name)
                    return i;
            }
            return null;
        },

        _isCanAddNodeToSegmentUpdate: function (diagram, index, node) {
            if (node) {
                if (node && node.parent) {
                    var lane = diagram.nameTable[node.parent], swimlane, lIndex;
                    if (lane && lane.isLane) {
                        swimlane = this._getSwimlane(diagram, lane.name);
                        lIndex = this._getLaneIndex(swimlane, lane);
                        if (lIndex > index) {
                            return true;
                        }
                    }
                    else return false;
                }
                else return false;
            }
            return false;
        },
        _getUpdateConnectorByEdges: function (diagram, node, index, connectors) {
            if (node) {
                this._getUpdateSegmentConnectors(diagram, node, index, connectors, node.inEdges)
                this._getUpdateSegmentConnectors(diagram, node, index, connectors, node.outEdges)
            }
        },
        _getUpdateSegmentConnectors: function (diagram, node, index, connectors, edges) {
            if (edges && edges.length > 0) {
                var line, sNode, tNode;
                for (var i = 0; i < edges.length; i++) {
                    line = diagram.nameTable[edges[i]];
                    if (line.sourceNode)
                        sNode = diagram.nameTable[line.sourceNode];
                    if (line.targetNode)
                        tNode = diagram.nameTable[line.targetNode];
                    if (sNode && tNode) {
                        if (this._isCanAddNodeToSegmentUpdate(diagram, index, sNode) && this._isCanAddNodeToSegmentUpdate(diagram, index, tNode) && !diagram._collectionContains(line.name, connectors))
                            connectors.push(line);
                    }
                }
            }
        },
        _updateConnectorSegments: function (diagram, node, dx, dy) {
            var swimlane = this._getSwimlane(diagram, node.name), index, connectors, lanes, i, children, j;
            index = this._getLaneIndex(swimlane, node);
            if (index != null) {
                connectors = [];
                lanes = swimlane.lanes;
                for (i = index + 1; i < lanes.length; i++) {
                    children = lanes[i].children;
                    for (j = 0; j < children.length; j++) {
                        this._getUpdateConnectorByEdges(diagram, children[j], index, connectors);
                    }
                }
            }
            if (connectors && connectors.length > 0 && dx != null && dy != null) {
                for (i = 0; i < connectors.length; i++) {
                    ej.datavisualization.Diagram.Util._translateLine(connectors[i], dx, dy, connectors[i]);

                }
            }
        },
        _resizeLane: function (diagram, node) {
            var object = diagram.nameTable[node.name];
            var needUpdate = true;
            if (object) {
                if (object.isLane || object._isBpmn) {
                    if (this._outOfBoundsOnLaneResize(diagram, object, true)) {
                        if (object.type == "bpmn" && object.container) {
                            var helper = diagram.activeTool.helper;
                            var scaleX = helper.width / node.width, scaleY = helper.height / node.height, offset = { x: node.offsetX, y: node.offsetY };
                            diagram._raiseSizePropertyChange(node, helper.width / node.width, helper.height / node.height, true);
                            diagram.activeTool._undoObject = $.extend(true, {}, { node: object });
                            object = $.extend(true, object, { width: helper.width, height: helper.height, offsetX: helper.offsetX, offsetY: helper.offsetY, minWidth: helper.width, minHeight: helper.height });
                            if (object.parent) {
                                var parent = ej.datavisualization.Diagram.ContainerHelper.updateparent(object, diagram);
                                if (parent) {
                                    object.minWidth = diagram.activeTool.helper.width;
                                    object.minHeight = diagram.activeTool.helper.height;
                                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, object, true);
                                    this._updateLastSwimlanePhase(diagram, object);
                                }
                                else
                                    ej.datavisualization.Diagram.bpmnHelper.updateCanvas(object, diagram);
                            }
                            else
                                ej.datavisualization.Diagram.bpmnHelper.updateCanvas(object, diagram);
                            ej.datavisualization.Diagram.DefautShapes.translateBPMNAnnotationShape(object, 1 / scaleX, 1 / scaleY, offset, diagram);
                            diagram.activeTool._redoObject = $.extend(true, {}, { node: object });
                        }
                        else if (object.container) {
                            diagram._raiseSizePropertyChange(node, diagram.activeTool.helper.width / node.width, diagram.activeTool.helper.height / node.height, true);
                            diagram.activeTool._undoObject = $.extend(true, {}, { node: object });
                            diagram._comparePropertyValues(node, "minWidth", { minWidth: diagram.activeTool.helper.width }, true);
                            diagram._comparePropertyValues(node, "offsetX", { offsetX: node.offsetX + diagram.activeTool.helper.width / 2 }, true);
                            object.minWidth = diagram.activeTool.helper.width <= 100 ? 100 : diagram.activeTool.helper.width;
                            diagram._comparePropertyValues(node, "minHeight", { minHeight: diagram.activeTool.helper.height }, true);
                            diagram._comparePropertyValues(node, "offsetY", { offsetY: node.offsetY + diagram.activeTool.helper.height / 2 }, true);
                            object.minHeight = diagram.activeTool.helper.height <= 100 ? 100 : diagram.activeTool.helper.height;
                            diagram.activeTool._redoObject = $.extend(true, {}, { node: object });
                        }
                        var entry = { type: "sizechanged", node: jQuery.extend(true, {}, object), undoObject: jQuery.extend(true, {}, diagram.activeTool._undoObject), redoObject: jQuery.extend(true, {}, diagram.activeTool._redoObject), category: "internal" };
                        diagram.addHistoryEntry(entry);
                        diagram.activeTool._multipleUndo = true;
                        if (object.isLane) {
                            this._disableConnectorUpdate(diagram);
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, object, true);
                            var xdiff = object.width - diagram.activeTool._undoObject.node.width, ydiff = object.height - diagram.activeTool._undoObject.node.height, _preventDocking, _disableSegmentChange;
                            _preventDocking = diagram._preventDocking;
                            _disableSegmentChange = diagram._disableSegmentChange
                            delete diagram._preventDocking;
                            delete diagram._disableSegmentChange
                            this._updateOverlappedConnectorSegment(diagram, diagram.activeTool._undoObject.node, xdiff, ydiff);
                            diagram._preventDocking = _preventDocking;
                            diagram._disableSegmentChange = _disableSegmentChange;
                            this._updateConnectorSegments(diagram, object, xdiff, ydiff);
                            this._enableConnectorUpdateLane(diagram, object);
                        }
                    }
                }
                else if (object.isSwimlane) {
                    var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, object), minLaneSize;
                    if (lanes.length > 0) {
                        var lastLane = diagram.nameTable[lanes[lanes.length - 1]];
                        if (lastLane) {
                            diagram.activeTool._undoObject = $.extend(true, {}, { node: lastLane });
                            diagram._raiseSizePropertyChange(object, diagram.activeTool.helper.width / object.width, diagram.activeTool.helper.height / object.height, true);
                            if (object.orientation === "vertical") {
                                minLaneSize = lastLane.width + diagram.activeTool.helper.width - object.width;
                                diagram._comparePropertyValues(lastLane, "minWidth", { minWidth: minLaneSize }, true);
                                diagram._comparePropertyValues(lastLane, "offsetX", { offsetX: node.offsetX + minLaneSize / 2 }, true);
                                lastLane.minWidth = minLaneSize <= 100 ? 100 : minLaneSize;
                            }
                            else {
                                minLaneSize = lastLane.height + diagram.activeTool.helper.height - object.height
                                if (minLaneSize == lastLane.minHeight) {
                                    needUpdate = false;
                                }
                                else {
                                    diagram._comparePropertyValues(lastLane, "minHeight", { minHeight: minLaneSize }, true);
                                    diagram._comparePropertyValues(lastLane, "offsetY", { offsetY: node.offsetY + minLaneSize / 2 }, true);
                                    lastLane.minHeight = minLaneSize <= 100 ? 100 : minLaneSize;
                                }
                            }
                            if (needUpdate) {
                                this._disableConnectorUpdate(diagram);
                                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, lastLane, true);
                                this._enableConnectorUpdateLane(diagram, object);
                                diagram.activeTool._redoObject = $.extend(true, {}, { node: lastLane });

                                var entry = { type: "sizechanged", node: jQuery.extend(true, {}, object), undoObject: jQuery.extend(true, {}, diagram.activeTool._undoObject), redoObject: jQuery.extend(true, {}, diagram.activeTool._redoObject), category: "internal" };
                                diagram.addHistoryEntry(entry);
                                diagram.activeTool._multipleUndo = true;
                                this._disableConnectorUpdate(diagram);
                                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, object, true);
                                this._enableConnectorUpdateLane(diagram, object);
                            }
                        }
                    }
                }
                else if (object.container) {
                    object.minWidth = diagram.activeTool.helper.width;
                    object.minHeight = diagram.activeTool.helper.height;
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, object, true);
                }
            }
        },

        _updateOverlappedConnectorSegment: function (diagram, lane, xdiff, ydiff) {
            if (lane) {
                var start, end, interSectors, i, interSectSegments, j, connectorName, segmentindex, connector, length;
                if (xdiff != undefined && ydiff != undefined)
                    var ovrConncts = this._overLappedConnectros(diagram, lane);
                if (ovrConncts && ovrConncts.length > 0) {
                    var bounds = ej.datavisualization.Diagram.Util.bounds(lane);
                    if (lane.orientation === "horizontal") {
                        start = bounds.bottomLeft;
                        end = bounds.bottomRight;
                    }
                    else {
                        start = bounds.topRight;
                        end = bounds.bottomRight;
                    }
                    interSectors = [];
                    for (i = 0; i < ovrConncts.length; i++) {
                        interSectSegments = this._lineSegmentsIntersect(diagram, lane, ovrConncts[i], { start: start, end: end });
                        if (interSectSegments && interSectSegments.length > 0) {
                            for (j = 0; j < interSectSegments.length; j++) {
                                connectorName = Object.keys(interSectSegments[j])[0];
                                segmentindex = interSectSegments[j][connectorName]["index"];
                                var point = interSectSegments[j][connectorName]["point"];
                                connector = diagram.nameTable[diagram._getChild(connectorName)]
                                if (connector && connector.segments && connector.segments.length > 0) {
                                    if (lane.orientation === "horizontal") {
                                        if (connector.segments[segmentindex])
                                        length = connector.segments[segmentindex].length;
                                        if (length) {
                                            connector.segments[segmentindex].length += ydiff
                                        }
                                    }
                                    else {
                                        length = connector.segments[segmentindex].length;
                                        if (length) { connector.segments[segmentindex].length += xdiff }
                                    }
                                    this._updateConnectorEndPoints(diagram, connector);
                                }
                            }
                        }
                    }
                }
            }
        },

        _lineSegmentsIntersect: function (diagram, lane, connector, line1, interSectors) {
            var x1, y1, x2, y2, i, segment, j, point1, point2, x3, y3, x4, y4, data, interSectSegments;
            x1 = line1.start.x;
            y1 = line1.start.y;
            x2 = line1.end.x;
            y2 = line1.end.y;
            interSectSegments = [];
            var orientation = (lane && lane.orientation) ? lane.orientation : "horizontal";
            connector = diagram.nameTable[diagram._getChild(connector)];
            if (connector && connector.segments && connector.segments.length > 0) {
                if (connector.segments.length === 1) {
                }
                else {
                    for (i = 0; i < connector.segments.length; i++) {
                        segment = connector.segments[i];
                        if (segment && segment.points.length > 0) {
                            for (j = 0; j < segment.points.length - 1; j++) {
                                point1 = segment.points[j];
                                point2 = segment.points[j + 1];
                                if (point1 && point2) {
                                    x3 = point1.x;
                                    y3 = point1.y;
                                    x4 = point2.x;
                                    y4 = point2.y;
                                    if (this._isInterSecting(x1, y1, x2, y2, x3, y3, x4, y4)) {
                                        data = {
                                        };
                                        var pointindex = j;
                                        if (orientation === "horizontal") {
                                            if (point1.y > y1)
                                                pointindex = -1;
                                        }
                                        else {
                                            if (point1.x > x1)
                                                pointindex = -1;
                                        }
                                        data[connector.name] = {
                                            index: i, point: pointindex
                                        };
                                        interSectSegments.push(data);
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return interSectSegments;
        },

        _isInterSecting: function (x1, y1, x2, y2, x3, y3, x4, y4, isCrossing) {
            var a_dx = x2 - x1;
            var a_dy = y2 - y1;
            var b_dx = x4 - x3;
            var b_dy = y4 - y3;
            var s = (-a_dy * (x1 - x3) + a_dx * (y1 - y3)) / (-b_dx * a_dy + a_dx * b_dy);
            var t = (+b_dx * (y1 - y3) - b_dy * (x1 - x3)) / (-b_dx * a_dy + a_dx * b_dy);
            if (isCrossing)
                return (s > 0 && s < 1 && t > 0 && t < 1);
            else
                return (s >= 0 && s <= 1 && t >= 0 && t <= 1);

        },
        _overLappedConnectros: function (diagram, lane) {
            var swimlane = this._getSwimlane(diagram, lane.name);
            var lIndex, lanes, connectors, i, prevLane, j, child, m;
            if (swimlane && swimlane.isSwimlane) {
                lIndex = this._getLaneIndex(swimlane, lane);
                lanes = diagram.nameTable[lane.parent];
                connectors = [];
                if (lanes && lanes.isLaneStack) {
                    if (lanes && lanes.children.length > 0) {
                        for (i = lIndex ; i >= 0; i--) {
                            prevLane = diagram.nameTable[diagram._getChild(lanes.children[i])];
                            if (prevLane && prevLane.isLane) {
                                this._laneConnectors(diagram, prevLane, connectors);
                            }
                        }
                    }
                }
            }
            return connectors;
        },
        //#endregion

        //#region undo dragNode
        _getUndoObject: function (diagram, node) {
            var childTable = {};
            var childTable = diagram._getChildTable(node, childTable);
            diagram.activeTool._undoObject = $.extend(true, {}, { node: node, childTable: childTable });
        },
        _getRedoObject: function (diagram, node) {
            var childTable = {};
            var childTable = diagram._getChildTable(node, childTable);
            diagram.activeTool._redoObject = $.extend(true, {}, { node: node, childTable: childTable });
        },
        _undoRemoveNodeFromContainer: function (diagram, node) {
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[node.parent], child;
                if (parent) {
                    node.parent = "";
                    var children = parent.children, child;
                    for (var i = 0; i < children.length; i++) {
                        child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child) {
                            if (child.name === node.name)
                                ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, children[i]);
                        }
                    }
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
            }
        },
        _undoAddNodeToContainer: function (diagram, node, object) {
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[object.parent], child, parentElement;
                diagram._translate(node, object.offsetX - node.offsetX, object.offsetY - node.offsetY, diagram.nameTable);
                if (parent) {
                    node.parent = parent.name;
                    parent.children.push(node.name);
                    parentElement = diagram._svg.getElementById(parent.name);
                    if (parent._isBpmn) {
                        ej.datavisualization.Diagram.bpmnHelper.resetNodeMargin(node, parent, diagram);
                        node = $.extend(true, node, { marginLeft: object.marginLeft, marginRight: object.marginRight, marginTop: object.marginTop, marginBottom: object.marginBottom });
                    }
                    else
                        this._updateNodeMargin(diagram, node, parent);
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
                if (node._type === "group") {
                    ej.datavisualization.Diagram.DiagramContext.renderGroup(node, diagram, parentElement);
                } else if (node.segments) {
                    ej.datavisualization.Diagram.DiagramContext.renderConnector(node, diagram, parentElement);
                } else {
                    ej.datavisualization.Diagram.DiagramContext.renderNode(node, diagram, parentElement);
                }
            }
        },
        _undoDragNode: function (diagram, node, object, pseudoGroup) {
            object = $.extend(true, {}, object);
            if (node && object) {
                if (node.type !== "pseudoGroup") {
                    var tempObj = $.extend(true, {}, object);
                    var tempNode = $.extend(true, {}, node);
                    if (!pseudoGroup) {
                        this._disableConnectorUpdate(diagram);
                        diagram._disableSwimlaneUptate = true;
                    }
                    this._undoRemoveNodeFromContainer(diagram, node);
                    this._undoAddNodeToContainer(diagram, node, object);
                    if (!pseudoGroup)
                        delete diagram._disableSwimlaneUptate
                    diagram._clearSelection(true);
                    diagram._addSelection(node, true);
                    //diagram.activeTool.selectedObject = node;
                    this._updateLastSwimlanePhase(diagram, node);
                    if (!pseudoGroup) {
                        if (tempNode.parent)
                            this._enableConnectorUpdateNode(diagram, tempNode);
                        else this._enableConnectorUpdateNode(diagram, tempObj);
                    }
                }
            }
        },
        _undoMultiDragNode: function (diagram, args) {
            var pseudoGroup = $.extend(true, {}, args.node), obj;
            if (pseudoGroup && (pseudoGroup.type === "pseudoGroup")) {
                var children = pseudoGroup.children;
                diagram._disableSwimlaneUptate = true;
                for (var i = 0; i < children.length; i++) {
                    this._disableConnectorUpdate(diagram);
                    var node = diagram.nameTable[diagram._getChild(children[i])];
                    var parent = node.parent;
                    if (args.undo && node)
                        obj = args.undoObject.childTable ? args.undoObject.childTable[node.name] : null;
                    else
                        obj = args.redoObject.childTable ? args.redoObject.childTable[node.name] : null;
                    this._undoDragNode(diagram, node, obj, true);
                    if (!parent) {
                        if (obj.parent) {
                            parent = obj.parent;
                        }
                    }
                    if (parent) {
                        var lane = diagram.nameTable[parent];
                        if (lane && lane.isLane) {
                            var swimlane = diagram.nameTable[lane.parent.split("laneStack")[0]];
                            if (swimlane) {
                                if (!diagram._updateSwimlanes) {
                                    diagram._updateSwimlanes = [];
                                }
                                if (!diagram._collectionContains(swimlane.name, diagram._updateSwimlanes))
                                    diagram._updateSwimlanes.push(swimlane.name)
                            }
                        }
                    }
                    else {
                        delete diagram._disableSegmentChange;
                        this._updateAssociatedConnectorEnds(diagram, node, diagram.nameTable);
                    }
                    delete diagram._disableSegmentChange;
                    this._updateAssociatedConnectorEnds(diagram, node, diagram.nameTable);
                }

                delete diagram._disableSwimlaneUptate;
                if (diagram._updateSwimlanes && diagram._updateSwimlanes.length > 0) {
                    for (var m = 0; m < diagram._updateSwimlanes.length; m++) {
                        ej.datavisualization.Diagram.DiagramContext.update(diagram.nameTable[diagram._updateSwimlanes[m]], diagram);
                        ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdate(diagram, diagram.nameTable[diagram._updateSwimlanes[m]]);
                    }
                }
                delete diagram._updateSwimlanes;
                diagram._clearSelection(true);
                ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                diagram._addSelection(pseudoGroup, true);
                delete diagram.nameTable[pseudoGroup.name];
                diagram.nameTable[pseudoGroup.name] = pseudoGroup;
                //diagram.activeTool.selectedObject = pseudoGroup;
            }
        },


        _updateAssociatedConnectorEnds: function (diagram, node, nameTable) {
            var i, len;
            var connector;
            if (diagram.getObjectType(node) !== "connector") {
                if (node.inEdges.length || node.outEdges.length) {
                    //Finding the segment points to avoid calculating path points multiple times to dock every edge
                    var nodeToNode = diagram._isNodeToNodeConnection(node);
                    var nodeToDock = node;
                    if (node.type == "bpmn" && node._type == "group") {
                        nodeToDock = typeof node.children[0] == "object" ? node.children[0] : diagram.nameTable[node.children[0]];
                    }
                    if (nodeToNode) {
                        var segmentPoints = ej.datavisualization.Diagram.Util._findSegmentPoints(nodeToDock);
                    }
                    var childTable = {};
                    if (diagram._parentNode) {
                        childTable = diagram._getChildTable(diagram._parentNode, {});
                    }
                    for (i = 0, len = node.inEdges.length; i < len; i++) {
                        connector = nameTable[node.inEdges[i]];
                        if (connector && !(diagram._parentNode && childTable[connector.sourceNode])) {
                            if (!connector.targetPadding) {
                                nodeToDock._segmentPoints = segmentPoints;
                            }
                            else delete nodeToDock._segmentPoints;
                            diagram._dock(connector, nameTable);
                            ej.datavisualization.Diagram.DiagramContext.update(connector, diagram);
                        }
                    }
                    for (i = 0, len = node.outEdges.length; i < len; i++) {
                        connector = nameTable[node.outEdges[i]];
                        if (connector && !(diagram._parentNode && childTable[connector.targetNode])) {
                            if (!connector.sourcePadding) { nodeToDock._segmentPoints = segmentPoints; }
                            else delete nodeToDock._segmentPoints;
                            diagram._dock(connector, nameTable);
                            //ej.datavisualization.Diagram.DiagramContext.update(connector, diagram);
                        }
                    }
                    delete nodeToDock._segmentPoints;
                }
            }
        },
        //#endregion

        //#region undo resizeNode
        _undoRemoveResizeNodeFromContainer: function (diagram, node) {
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[node.parent], child;
                if (parent) {
                    node.parent = "";
                    var children = parent.children, child;
                    for (var i = 0; i < children.length; i++) {
                        child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child) {
                            if (child.name === node.name)
                                ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, children[i]);
                        }
                    }
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
            }
        },
        _undoAddResizeNodeToContainer: function (diagram, node, object) {
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[object.parent], child, parentElement;
                if (!node.segments) {
                    diagram._translate(node, object.offsetX - node.offsetX, object.offsetY - node.offsetY, diagram.nameTable);
                    diagram.scale(node, (object.width / node.width), (object.height / node.height), ej.datavisualization.Diagram.Point(node.offsetX, node.offsetY), diagram.nameTable);
                    if (node._type === "group") ej.datavisualization.Diagram.Util._updateGroupBounds(node, diagram);
                    if (node.container) ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, node, true);
                }
                if (parent) {
                    node.parent = parent.name;
                    parent.children.push(node.name);
                    parentElement = diagram._svg.getElementById(parent.name);
                    if (parent._isBpmn) {
                        ej.datavisualization.Diagram.bpmnHelper.resetNodeMargin(node, parent, diagram);
                        node = $.extend(true, node, { marginLeft: object.marginLeft, marginRight: object.marginRight, marginTop: object.marginTop, marginBottom: object.marginBottom });
                    }
                    else
                        this._updateNodeMargin(diagram, node, parent);
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
                if (node._type === "group") {
                    ej.datavisualization.Diagram.DiagramContext.renderGroup(node, diagram, parentElement);
                } else if (node.segments) {
                    ej.datavisualization.Diagram.DiagramContext.renderConnector(node, diagram, parentElement);
                } else {
                    ej.datavisualization.Diagram.DiagramContext.renderNode(node, diagram, parentElement);
                }
            }
        },
        _undoResizeNode: function (diagram, node, object, pseudoGroup) {
            object = $.extend(true, {}, object);
            if (node && object) {
                if (node.type !== "pseudoGroup") {
                    if (!pseudoGroup)
                        this._disableConnectorUpdate(diagram);
                    this._undoRemoveResizeNodeFromContainer(diagram, node);
                    this._undoAddResizeNodeToContainer(diagram, node, object);
                    diagram._clearSelection(true);
                    diagram._addSelection(node, true);
                    this._updateLastSwimlanePhase(diagram, node);
                    if (!pseudoGroup)
                        this._enableConnectorUpdateNode(diagram, node);
                }
            }
        },
        _undoMultiResizeNode: function (diagram, args) {
            var pseudoGroup = $.extend(true, {}, args.node), obj;
            if (pseudoGroup && (pseudoGroup.type === "pseudoGroup")) {
                var children = pseudoGroup.children;
                for (var i = 0; i < children.length; i++) {
                    var node = diagram.nameTable[diagram._getChild(children[i])];
                    if (args.undo && node)
                        obj = args.undoObject.childTable ? args.undoObject.childTable[node.name] : null;
                    else
                        obj = args.redoObject.childTable ? args.redoObject.childTable[node.name] : null;
                    this._undoResizeNode(diagram, node, obj);
                }
                diagram._clearSelection(true);
                ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                diagram._addSelection(pseudoGroup, true);
                delete diagram.nameTable[pseudoGroup.name];
                diagram.nameTable[pseudoGroup.name] = pseudoGroup;
            }
        },
        _undoResizeLane: function (diagram, object, args) {
            var node = diagram.nameTable[object.name];
            if (node) {
                if (args && args.node && args.node.isSwimlane) {
                    var lanes = ej.datavisualization.Diagram.SwimLaneContainerHelper.getLanes(diagram, args.node);
                    if (lanes.length > 0) {
                        var lastLane = diagram.nameTable[lanes[lanes.length - 1]];
                        if (lastLane) {
                            if (args.undo) {
                                object = (args.undoObject && args.undoObject.node) ? args.undoObject.node : lastLane;
                            }
                            else {
                                object = (args.undoObject && args.redoObject.node) ? args.redoObject.node : lastLane;
                            }
                            diagram._comparePropertyValues(lastLane, "minWidth", { minWidth: object.minWidth });
                            lastLane.minWidth = object.minWidth;
                            diagram._comparePropertyValues(lastLane, "minHeight", { minHeight: object.minHeight });
                            lastLane.minHeight = object.minHeight;
                            this._disableConnectorUpdate(diagram);
                            ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, node, true);
                            this._enableConnectorUpdateLane(diagram, node);
                        }
                    }
                }
                else if (node.isLane) {
                    if (node.container) {
                        diagram.activeTool._undonode = $.extend(true, {}, { node: node });
                        diagram._comparePropertyValues(node, "minWidth", { minWidth: object.minWidth });
                        node.minWidth = object.minWidth;
                        diagram._comparePropertyValues(node, "minHeight", { minHeight: object.minHeight });
                        node.minHeight = object.minHeight;
                    }
                    this._disableConnectorUpdate(diagram);
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, node, true);
                    var xdiff = node.width - diagram.activeTool._undonode.node.width, ydiff = node.height - diagram.activeTool._undonode.node.height, _preventDocking, _disableSegmentChange;
                    _preventDocking = diagram._preventDocking;
                    _disableSegmentChange = diagram._disableSegmentChange
                    delete diagram._preventDocking;
                    delete diagram._disableSegmentChange
                    this._updateOverlappedConnectorSegment(diagram, diagram.activeTool._undonode.node, xdiff, ydiff);
                    diagram._preventDocking = _preventDocking;
                    diagram._disableSegmentChange = _disableSegmentChange;
                    this._updateConnectorSegments(diagram, node, xdiff, ydiff);
                    this._enableConnectorUpdateLane(diagram, node);
                }
            }
        },
        //#endregion

        //#region undo rotateNode
        _undoRemoveRotateNodeFromContainer: function (diagram, node) {
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[node.parent], child;
                if (parent) {
                    node.parent = "";
                    var children = parent.children, child;
                    for (var i = 0; i < children.length; i++) {
                        child = diagram.nameTable[diagram._getChild(children[i])];
                        if (child) {
                            if (child.name === node.name)
                                ej.datavisualization.Diagram.Util.removeChildFromGroup(parent.children, children[i]);
                        }
                    }
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
            }
        },
        _undoAddRotateNodeToContainer: function (diagram, node, object) {
            if (node.type !== "pseudoGroup") {
                var parent = diagram.nameTable[object.parent], child, parentElement;
                if (!node.segments) {
                    var newangle = object.rotateAngle - node.rotateAngle;
                    diagram._rotate(node, newangle, diagram.nameTable);
                }
                if (parent) {
                    node.parent = parent.name;
                    parent.children.push(node.name);
                    parentElement = diagram._svg.getElementById(parent.name);
                    if (parent._isBpmn) {
                        ej.datavisualization.Diagram.bpmnHelper.resetNodeMargin(node, parent, diagram);
                        node = $.extend(true, node, { marginLeft: object.marginLeft, marginRight: object.marginRight, marginTop: object.marginTop, marginBottom: object.marginBottom });
                    }
                    else
                        this._updateNodeMargin(diagram, node, parent);
                    ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, true);
                }
                if (node._type === "group") {
                    ej.datavisualization.Diagram.DiagramContext.renderGroup(node, diagram, parentElement);
                } else if (node.segments) {
                    ej.datavisualization.Diagram.DiagramContext.renderConnector(node, diagram, parentElement);
                } else {
                    ej.datavisualization.Diagram.DiagramContext.renderNode(node, diagram, parentElement);
                }
            }
        },
        _undoRotateNode: function (diagram, node, object, pseudoGroup) {
            object = $.extend(true, {}, object);
            if (node && object) {
                if (node.type !== "pseudoGroup") {
                    if (!pseudoGroup)
                        this._disableConnectorUpdate(diagram);
                    this._undoRemoveRotateNodeFromContainer(diagram, node);
                    this._undoAddRotateNodeToContainer(diagram, node, object);
                    diagram._clearSelection(true);
                    diagram._addSelection(node, true);
                    this._updateLastSwimlanePhase(diagram, node);
                    if (!pseudoGroup)
                        this._enableConnectorUpdateNode(diagram, node);
                }
            }
        },
        _undoMultiRotateNode: function (diagram, args) {
            var pseudoGroup = $.extend(true, {}, args.node), obj;
            if (pseudoGroup && (pseudoGroup.type === "pseudoGroup")) {
                var children = pseudoGroup.children;
                for (var i = 0; i < children.length; i++) {
                    var node = diagram.nameTable[diagram._getChild(children[i])];
                    if (args.undo && node)
                        obj = args.undoObject.childTable ? args.undoObject.childTable[node.name] : null;
                    else
                        obj = args.redoObject.childTable ? args.redoObject.childTable[node.name] : null;
                    this._undoRotateNode(diagram, node, obj, true);
                }
                diagram._clearSelection(true);
                pseudoGroup.rotateAngle = obj.rotateAngle;
                ej.datavisualization.Diagram.Util._updateGroupBounds(pseudoGroup, diagram);
                diagram._addSelection(pseudoGroup, true);
                delete diagram.nameTable[pseudoGroup.name];
                diagram.nameTable[pseudoGroup.name] = pseudoGroup;
            }
        },
        //#endregion

        //#region swapping lane
        _undoSwap: function (diagram, args) {
            diagram.activeTool._removeHelpers();
            diagram._clearSelection(true);
            var index = args.undo ? args.insertIndex : args.moveIndex;
            var node = diagram.nameTable[args.undoObject.name1];
            var parent = node && node.parent ? diagram.nameTable[node.parent] : null;
            if (parent && parent.children.length > 0)
                var list = parent.children;
            var tList = list.slice();
            var prevSwimlane = this._getSwimlane(diagram, list[0]);
            if (list && list.length > 0) {
                ej.datavisualization.Diagram.canvasHelper._disableConnectorUpdate(diagram);
                this._undoSwapLane(diagram, list, index, node, null);
                ej.datavisualization.Diagram.ContainerHelper._updateCollectionChange(diagram, parent, false);
                ej.datavisualization.Diagram.canvasHelper._recreateConnectorSegments(diagram, node.name, tList, args.undoObject.name2, args.undoObject.name1);
                ej.datavisualization.Diagram.canvasHelper._enableConnectorUpdateLane(diagram, node);
            }
            var currLaneSwimlane = this._getSwimlane(diagram, list[0]);
            diagram._comparePropertyValues(currLaneSwimlane, "lanes", { lanes: prevSwimlane.lanes });
        },
        _undoSwapLane: function (diagram, list, index, node, isVertical) {
            if (list && list.length > 0) {
                list.splice(list.indexOf(node.name), 1);
                list.splice(index, 0, node.name);
            }
        },
        //#endregion
    };

    ej.datavisualization.Diagram.containerCommon = {
        _initGroupNode: function (diagram, group) {
            var child = null;
            group = diagram._getNewGroup(group);
            for (var i = 0; i < group.children.length; i++) {
                child = group.children[i];
                if (child && typeof (child) == "object") {
                    if (typeof child.shape !== "object")
                        child = ej.datavisualization.Diagram.NodeType(child, diagram);
                    //if (child.type === "bpmn")
                    //    child._type = "node";
                    if (child._type != "group" && !child.children && !child.segments && child.type != "connector") {
                        if (group.type != "bpmn") child = diagram._getNewNode(child);
                        if (child.name == "")
                            child.name = ej.datavisualization.Diagram.Util.randomId();
                        if (child._type == "node" && child.labels.length && (child.width == 0 || child.height == 0))
                            diagram._getNodeDimension(child);
                    }
                    else if (child.segments || child.type == "connector") {
                        child = diagram._getNewConnector(child);
                        if (child.name == "") {
                            child.name = ej.datavisualization.Diagram.Util.randomId();
                        }
                    }
                    else {
                        child = diagram._getNewGroup(child);
                        if (child.name == "") {
                            child.name = ej.datavisualization.Diagram.Util.randomId();
                        }
                        child = this._initGroupNode(diagram, child);
                    }
                    group.children[i] = child;
                    child.parent = group.name;
                }
            }
            return group;
        },
        _initChildren: function (diagram, node) {
            if (node.children && node.children.length > 0) {
                var children = node.children;
                for (var i = 0; i < children.length; i++) {
                    var child = typeof (children[i]) === "string" ? diagram.nameTable[children[i]] : children[i];
                    if (child) {
                        if (!child._isInternalShape) {
                            if (node.container) {
                                if (child.type === "bpmn")
                                    diagram._translate(child, 0 - child.offsetX, 0 - child.offsetY, diagram.nameTable)
                                else
                                    child.offsetX = 0; child.offsetY = 0;
                            }
                            if (child.container) {
                                children[i] = ej.datavisualization.Diagram.ContainerHelper._initContainer(diagram, child);
                            }
                            else if (child.children) {
                                children[i] = ej.datavisualization.Diagram.Group(child);
                                children[i] = this._initGroupNode(diagram, children[i]);
                                children[i] = diagram._getNewGroup(children[i]);
                                children[i] = this._initChildren(diagram, children[i]);
                                if (diagram._isLoad && children[i].type !== "bpmn")
                                this._updateGroupBounds(diagram, children[i]);
                            }
                            else if (child.segments) {
                                children[i] = ej.datavisualization.Diagram.Connector(child);
                                children[i] = diagram._getNewConnector(child);
                            }
                            else {
                                children[i] = ej.datavisualization.Diagram.NodeType(child, diagram);
                                children[i] = diagram._getNewNode(child);
                            }
                        }
                        diagram.nameTable[children[i].name] = children[i];
                        node.children[i] = children[i].name;
                        if (diagram._spatialSearch) diagram._updateQuad(diagram.nameTable[node.children[i]]);
                    }
                }
            }
            return node;
        },
        _getChildrenBounds: function (diagram, group) {
            var children = group.children, rect,
                bounds = ej.datavisualization.Diagram.Rectangle(), child;
            if (children.length > 0) {
                child = diagram.nameTable[diagram._getChild(children[0])];
                if (child)
                    bounds = ej.datavisualization.Diagram.Util._rotateChildBounds(child, group, diagram);
            }
            for (var i = 0, len = children.length; i < len; i++) {
                child = diagram.nameTable[diagram._getChild(children[i])];
                if (child) {
                    if (child._type === "group") {
                        ej.datavisualization.Diagram.Util._updateGroupBounds(child, diagram);
                        rect = ej.datavisualization.Diagram.Util._rotateChildBounds(child, group, diagram);
                    } else
                        rect = ej.datavisualization.Diagram.Util._rotateChildBounds(child, group, diagram);
                }
                if (rect)
                    bounds = ej.datavisualization.Diagram.Geometry.union(bounds, rect);
            }
            return bounds;
        },
        _updateGroupBounds: function (diagram, node, angleChange) {
            var exWidth, exHeight, exOffX, exOffY;
            if (node && !node.container) {
                if (node && ((node.type === "pseudoGroup") || (node.children && node.children.length > 0))) {
                    exWidth = node.width;
                    exHeight = node.height;
                    exOffX = node.offsetX;
                    exOffY = node.offsetY;
                    if (angleChange)
                        ej.datavisualization.Diagram.Util._updateRotateAngle(node, diagram.nameTable);
                    var bounds = this._getChildrenBounds(diagram, node);
                    var x = bounds.x + bounds.width * node.pivot.x;
                    var y = bounds.y + bounds.height * node.pivot.y;
                    var newposition = { x: x, y: y };
                    if (node.rotateAngle) {
                        var matrix = ej.Matrix.identity();
                        ej.Matrix.rotate(matrix, node.rotateAngle);
                        newposition = ej.Matrix.transform(matrix, newposition);
                    }
                    if (bounds) {
                        node.offsetX = newposition.x;
                        node.offsetY = newposition.y;
                        node.width = bounds.width;
                        node.height = bounds.height;
                    }
                }
            }
        },
        _cloneObject: function (diagram, node, id) {
            if (node) {
                var obj = $.extend(true, {}, node);
                var child;
                if (obj.children && obj.children.length > 0) {
                    for (var i = 0; i < obj.children.length; i++) {
                        obj.children[i] = this._cloneObject(diagram, obj.children[i], id);
                    }
                }
                obj.name += id;
            }
            return obj;
        },
        _removeObject: function (diagram, node) {
            if (node) {
                if (typeof (node) === "string")
                    node = diagram.nameTable[node];
                var child;
                if (node && node.children && node.children.length > 0) {
                    for (var i = 0; i < node.children.length; i++) {
                        this._removeObject(diagram, node.children[i]);
                    }
                }
                if (node)
                    delete diagram.nameTable[node.name];
            }
        },
    }
    //#endregion

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Overview elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    "use strict";
    //#region Overview widget
    ej.widget("ejOverview", "ej.datavisualization.Overview", {
        element: null,
        validTags: ["div"],
        model: null,
        //#region Initialization
        defaults: {
            sourceID: "",
            width: null,
            height: null
        },
        _canvas: null,
        _actionName: "",
        _startPoint: null,
        _currentPoint: null,
        _prevPoint: null,
        _helper: null,
        _viewPortRatio: 1,
        _resizeDirection: "",
        _inAction: false,
        _init: function () {
            if (!(ej.browserInfo().name === "msie" && Number(ej.browserInfo().version) < 9)) {
                this._wireEvents();
                this._renderCanvas();
                this._setParent(this.model.sourceID);
            }
        },
        _renderCanvas: function () {
            var canvas = $("#" + this.element[0].id + "_canvas")[0];
            if (!canvas) {
            var canvas = document.createElement("div");
                this.element.append(canvas);
            }
            canvas.setAttribute("id", this.element[0].id + "_canvas");
            canvas.setAttribute("class", "drawing");
            canvas.setAttribute("style", "position:relative; height:" + this.model.height + "; width:" + this.model.width + ";style:-ms-touch-action: none;touch-action: none;");
            this.element[0].setAttribute("tabindex", 0);
            this.element.css({
                overflow: "hidden", outline: "none", display: "block", height: this.model.height, width: this.model.width
            });
            this._canvas = canvas;
        },
        _renderDocument: function (view) {
            view.canvas = this._canvas;
            if (window.SVGSVGElement) {
                var svg = $("#" + this._canvas.id + "_svg")[0];
                if (svg)
                    svg.parentNode.removeChild(svg);
                var attr = {
                    id: this._canvas.id + "_svg",
                    version: "1.1",
                    xlink: "http://www.w3.org/1999/xlink",
                    "style": view.style,
                    "class": "overview_svg"
                };
                var svg = new ej.datavisualization.Diagram.Svg(attr);
                this._svg = svg;
                view.svg = svg;
                var ovw = document.getElementById(this._id);
                var element = ovw;
                var eWidth = $(element).width();
                var eHeight = $(element).height();
                var bRect = element.getBoundingClientRect();
                var screenX = (window.screenX < 0) ? window.screenX * -1 : window.screenX;
                if (eWidth === 0) {
                    eWidth = Math.floor(((window.innerWidth - screenX) - Math.floor(bRect.left)));
                }
                var screenY = (window.screenY < 0) ? window.screenY * -1 : window.screenY;
                if (eHeight === 0) {
                    eHeight = Math.floor(((window.innerHeight - screenY) - Math.floor(bRect.top)));
                }
                svg.document.setAttribute("width", eWidth);
                svg.document.setAttribute("height", eHeight);
                this.width = eWidth;
                this.height = eHeight;
                view.diagramLayer = ej.datavisualization.Diagram.SvgContext._renderDiagramLayer(view.canvas, view.svg, view.svg);
                var defs = svg.defs({ "id": view.canvas.id + "patterndefinition" });
                svg.appendChild(defs);
                view.canvas.appendChild(svg.document);
                this._renderHtmlLayer(view.canvas);
                this._addOverviewRectPanel(view);
            }
        },
        _removeDocument: function (view) {
            var svg = document.getElementById(this._canvas.id + "_svg");
            this._canvas.removeChild(svg);
            var htmlLayer = document.getElementById(this._canvas.id + "_htmlLayer");
            this._canvas.removeChild(htmlLayer);
            //var rect = document.getElementById("overview_canvasrect");
            //this._canvas.removeChild(rect);
        },
        _renderHtmlLayer: function (canvas) {
            var div = document.createElement("div");
            var attr = { "id": canvas.id + "_htmlLayer", "class": "htmlLayer" };
            ej.datavisualization.Diagram.Util.attr(div, attr);
            var htmlLayer = div;
            div.style.pointerEvents = "none";
            div.style.position = "absolute";
            div.style.left = "0px";
            div.style.top = "0px";
            canvas.appendChild(htmlLayer);
            return htmlLayer;
        },
        _setModel: function (options) {
            var updateSize = false;
            for (var option in options) {
                switch (option) {
                    case "sourceID":
                        this._setParent(options[option]);
                        break;
                    case "width":
                    case "height":
                        if (!updateSize) {
                            this._renderCanvas();
                            this._setParent(this.model.sourceID);
                }
                        updateSize = true;
                        break;
            }
            }
        },
        _setParent: function (diagram) {
            if (this._parent) {
                var oldparent = $("#" + this._parent._id).ejDiagram("instance");
                this._parent = null;
                oldparent._setOverview(null, this._id);
            }
            if (diagram) {
                this.model.sourceID = diagram;
                this._parent = $("#" + diagram).ejDiagram("instance");
                if (this._parent)
                    this._parent._setOverview(this);
            }
        },
        _destroy: function () {
            this.element.empty().removeClass(this.model.cssClass);
        },
        //#endregion
        //#region Events
        _wireEvents: function () {
            var canvas = $(this._canvas);
            this._on(canvas, ej.eventType.mouseDown, this._mousedown);
            this._on(canvas, ej.eventType.mouseMove, this._mousemove);
            this._on(canvas, ej.eventType.mouseUp, this._mouseup);
            this._on(canvas, ej.eventType.mouseLeave, this._documentmouseup);
            this._on(canvas, "touchstart", this.handleTouchStart);
            this._on(canvas, "touchmove", this.handleTouchMove);
            this._on(canvas, "touchend", this.handleTouchEnd);
        },
        _mouseup: function (evt) {
            this._currentPoint = this._mouseposition(evt);
            var offwidth = this.width;
            var offheight = this.height;
            if (this._actionName)
                if ((this._startPoint.x != this._currentPoint.x || this._startPoint.y != this._currentPoint.y)) {
                    if (this._actionName == "pan") { }
                    else {
                        if (this._helper) {
                            var bounds = this._helper.getBBox();
                            this._resizeDirection = this._resizeDirection || "";
                            var x = bounds.x;
                            var y = bounds.y;
                            var width = bounds.width;
                            var height = bounds.height;
                            var adjust = this._resizeDirection == "topleft" || this._resizeDirection == "topright" || this._resizeDirection == "bottomleft" ||
                                this._resizeDirection == "bottomright";
                            this._renderOverviewRect(x, y, width, height);
                        }
                    }
                }
                else
                    if (evt.target.id == this._canvas.id + "overviewbackrect" || evt.target.id == "helper")
                        if (this._startPoint.x == this._currentPoint.x && this._startPoint.y == this._currentPoint.y) {
                            var g = document.getElementById(this._canvas.id + "overviewrect");
                            var bounds = g.getBBox();
                            var width = bounds.width || 100;
                            var height = bounds.height || 100 / this._viewPortRatio;
                            this.inAction = true;
                            this._actionName = "pan";
                            this._renderOverviewRect(this._currentPoint.x - width / 2, this._currentPoint.y - height / 2, width, height);
                            this.inAction = false;
                        }
            if (this._helper) {
                var g = document.getElementById(this._canvas.id + "overviewhandle");
                g.removeChild(this._helper);
                this._helper = null;
            }
            this._actionName = "";
            this._startPoint = null;
            this._currentPoint = null;
            this._prevPoint = null;
            this._helper = null;
            this._viewPortRatio = 1;
            this._resizeDirection = "";
            this._inAction = false
        },
        _mousedown: function (evt) {
            if (evt.target.className.animVal == "overviewbackrect")
                this._actionName = "draw";
            if (evt.target.id == this._canvas.id + "overviewrect") this._actionName = "pan";
            if (evt.target.className.animVal == "overviewresizer") {
                this._actionName = "scale";
                switch (evt.target.id) {
                    case this._canvas.id + "left":
                        this._resizeDirection = "left";
                        break;
                    case this._canvas.id + "right":
                        this._resizeDirection = "right"; break;
                    case this._canvas.id + "top":
                        this._resizeDirection = "top"; break;
                    case this._canvas.id + "bottom":
                        this._resizeDirection = "bottom"; break;
                    case this._canvas.id + "topleft":
                        this._resizeDirection = "topleft"; break;
                    case this._canvas.id + "topright":
                        this._resizeDirection = "topright"; break;
                    case this._canvas.id + "bottomleft":
                        this._resizeDirection = "bottomleft"; break;
                    case this._canvas.id + "bottomright":
                        this._resizeDirection = "bottomright"; break;
                }
            }
            this._startPoint = this._prevPoint = this._mouseposition(evt);
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this._parent);
            this._viewPortRatio = viewPort.width / viewPort.height;
        },
        _mouseposition: function (evt) {
            var e = this._parent._isTouchEvent(evt);
            if (!e) {
                e = evt;
            }
            var scrollLeft = this._canvas.scrollLeft;
            var scrollTop = this._canvas.scrollTop;
            var controlBBox = this._canvas.getBoundingClientRect();
            var layerx = (e.clientX + scrollLeft) - controlBBox.left;
            var layery = (scrollTop + e.clientY) - controlBBox.top;
            return new ej.datavisualization.Diagram.Point(layerx, layery);
        },
        _updateCursor: function (evt) {
            if (evt.target.className.animVal == "overviewresizer") {
                switch (evt.target.id) {
                    case this._canvas.id + "left":
                        this._canvas.style.cursor = "w-resize";
                        break;
                    case this._canvas.id + "right":
                        this._canvas.style.cursor = "e-resize"; break;
                    case this._canvas.id + "top":
                        this._canvas.style.cursor = "n-resize"; break;
                    case this._canvas.id + "bottom":
                        this._canvas.style.cursor = "s-resize"; break;
                    case this._canvas.id + "topleft":
                        this._canvas.style.cursor = "nw-resize"; break;
                    case this._canvas.id + "topright":
                        this._canvas.style.cursor = "ne-resize"; break;
                    case this._canvas.id + "bottomleft":
                        this._canvas.style.cursor = "sw-resize"; break;
                    case this._canvas.id + "bottomright":
                        this._canvas.style.cursor = "se-resize"; break;
                }
            }
            else this._canvas.style.cursor = "default";
        },
        _mousemove: function (evt) {
            this._updateCursor(evt);
            this._currentPoint = this._mouseposition(evt);
            if (this._actionName)
                switch (this._actionName) {
                    case "draw":
                        if (!this._inAction && (this._startPoint.x != this._currentPoint.x || this._startPoint.y == this._currentPoint.y)) {
                            this._initHelper();
                            this._inAction = true;
                        }
                        if (this._inAction)
                            this._updateHelper();
                        break;
                    case "scale":
                        if (!this._inAction) {
                            this._initHelper();
                            this._inAction = true;
                        }
                        this._updateOverviewRectangle();
                        break;
                    case "pan":
                        if ((this._startPoint.x != this._currentPoint.x || this._startPoint.y == this._currentPoint.y) || this._inAction) {
                            this._inAction = true;
                            this._translateOverviewRectangle();
                        }
                        break;

                }
            this._prevPoint = this._currentPoint;
        },
        _documentmouseup: function (evt) {
            this._inAction = false;
            this._actionName = "";
            if (this._helper) {
                var g = document.getElementById(this._canvas.id + "overviewhandle");
                g.removeChild(this._helper);
                this._helper = null;
            }
        },
        _addOverviewRectPanel: function (view) {
            var svg = $("#" + this._canvas.id + "_overviewsvg")[0];
            if (svg)
                svg.parentNode.removeChild(svg)
            svg = new ej.datavisualization.Diagram.Svg({
                id: this._canvas.id + "_overviewsvg",
                version: "1.1",
                xlink: "http://www.w3.org/1999/xlink",
                "style": "position:absolute;left:0px;top:0px",
                width: this.width,
                height: this.height
            });
            this._canvas.appendChild(svg.document);
            var ovw = svg.g({ "id": this._id + "_overviewlayer" });
            svg.appendChild(ovw);
            var rect = svg.rect({ "fill": "transparent", "width": "100%", "height": "100%", "class": "overviewbackrect", "id": this._canvas.id + "overviewbackrect" });
            ovw.appendChild(rect);
            var svgDocument = $(ovw);
            this._on(svgDocument, ej.eventType.mouseDown, this._mousedown);
            this._on(svgDocument, ej.eventType.mouseMove, this._mousemove);
            this._on(svgDocument, ej.eventType.mouseUp, this._mouseup);
            this._on(svgDocument, ej.eventType.mouseLeave, this._documentmouseup);
            this._on(svgDocument, "touchstart", this.handleTouchStart);
            this._on(svgDocument, "touchmove", this.handleTouchMove);
            this._on(svgDocument, "touchend", this.handleTouchEnd);
            var g = svg.g({ "id": this._canvas.id + "overviewhandle" });
            ovw.appendChild(g);
            var innerrect = svg.rect({ "id": this._canvas.id + "overviewrect", "fill": "transparent" });
            g.appendChild(innerrect);
            this._renderOverviewCorner("left", g);
            this._renderOverviewCorner("right", g);
            this._renderOverviewCorner("top", g);
            this._renderOverviewCorner("bottom", g);
            this._renderOverviewCorner("topleft", g);
            this._renderOverviewCorner("topright", g);
            this._renderOverviewCorner("bottomleft", g);
            this._renderOverviewCorner("bottomright", g);
        },
        _updateOverview: function (view) {
            view = view || this._parent._views[this._id];
            var width, height;
            var bounds = this._parent._getDigramBounds();
            width = bounds.width;
            height = bounds.height;
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this._parent);
            var offwidth = this.width;
            var offheight = this.height;
            if (view.context == ej.datavisualization.Diagram.SvgContext) {
                var w = Math.max(width, viewPort.width);
                var h = Math.max(height, viewPort.height);
                this.contentWidth = w = Math.max(w, (offwidth / offheight) * h);
                this.contentHeight = h = Math.max(h, (offheight / offwidth) * w);
                var g = document.getElementById(this._canvas.id + "_diagramLayer");
                var scale = Math.min(offwidth / w, offheight / h);
                this.scale = scale;
                g.setAttribute("transform", "scale(" + scale + "," + scale + "),translate(" + -bounds.x + "," + (-bounds.y) + ")");
                var htmlLayer = document.getElementById(this._canvas.id + "_htmlLayer");
                htmlLayer.style.webkitTransform = "scale(" + scale + ") translate(" + -bounds.x + "px," + (-bounds.y) + "px)";
                htmlLayer.style.MozTransform = "scale(" + scale + ") translate(" + -bounds.x + "px," + (-bounds.y) + "px)";
                htmlLayer.style.OTransform = "scale(" + scale + ") translate(" + -bounds.x + "px," + (-bounds.y) + "px)";
                htmlLayer.style.msTransform = "scale(" + scale + ") translate(" + -bounds.x + "px," + (-bounds.y) + "px)";
                htmlLayer.style.transform = "scale(" + scale + ") translate(" + -bounds.x + "px," + (-bounds.y) + "px)";
                // if (bounds.x < 0 || bounds.y < 0) 
                {
                    var ovw = document.getElementById(this._id + "_overviewlayer");
                    ovw.setAttribute("transform", "translate(" + (-bounds.x * scale) + "," + (-bounds.y * scale) + ")");
                }
            }
            else {
                var context = view._canvas.document.getContext("2d");
                if (view.scale) {
                    context.scale(1 / view.scale.x, 1 / view.scale.y);
                }
                view.scale = { x: scale, y: scale };
                context.scale(scale, scale);
                ej.datavisualization.Diagram.CanvasContext.refreshCanvas(this._parent.model, view);
            }
            this._scrollOverviewRect(this._parent._hScrollOffset, this._parent._vScrollOffset, this._parent._currZoom);
        },
        _updateOverviewRectangle: function () {
            var difx = this._currentPoint.x - this._prevPoint.x;
            var dify = this._currentPoint.y - this._prevPoint.y;
            if (this._actionName == "scale") {
                var size = { "width": 0, "height": 0 };
                var x = 0, y = 0; var w, h;
                switch (this._resizeDirection) {
                    case "left":
                        size.width -= difx;
                        size.height -= difx / this._viewPortRatio;
                        x = difx;
                        y = difx / this._viewPortRatio;
                        y /= 2;
                        break;
                    case "right":
                        size.width += difx;
                        size.height += difx / this._viewPortRatio;
                        y = difx / this._viewPortRatio;
                        y /= -2;
                        break;
                    case "top":
                        size.height -= dify;
                        size.width -= dify * this._viewPortRatio;
                        y = dify;
                        x = dify * this._viewPortRatio;
                        x /= 2;
                        break;
                    case "bottom":
                        size.height += dify;
                        size.width += dify * this._viewPortRatio;
                        x = dify * this._viewPortRatio;
                        x /= -2;
                        break;
                    case "topleft":
                        if (Math.abs(dify) > Math.abs(difx)) { difx = dify * this._viewPortRatio; }
                        else
                            dify = difx / this._viewPortRatio;
                        size.width -= difx;
                        size.height -= dify;
                        x = difx;
                        y = dify;
                        break;
                    case "topright":
                        if (Math.abs(dify) > Math.abs(difx)) { difx = -dify * this._viewPortRatio; }
                        else
                            dify = -(difx / this._viewPortRatio);
                        y = dify;
                        size.width += difx;
                        size.height -= dify;
                        break;
                    case "bottomleft":
                        if (Math.abs(dify) > Math.abs(difx)) { difx = -dify * this._viewPortRatio; }
                        else
                            dify = -difx / this._viewPortRatio;
                        x = difx;
                        size.width -= difx;
                        size.height += dify;
                        break;
                    case "bottomright":
                        if (Math.abs(dify) > Math.abs(difx)) { difx = dify * this._viewPortRatio; }
                        else
                            dify = difx / this._viewPortRatio;
                        size.width += difx;
                        size.height += dify;
                        break;
                }
                this._updateHelper(x, y, size, w, h);
            }
        },
        _initHelper: function () {
            if (!this._helper) {
                var svg = this._svg;
                var g = document.getElementById(this._canvas.id + "overviewhandle");
                var scale = this._parent._currZoom;
                var x = this._startPoint.x;
                var y = this._startPoint.y; var width = 1; var height = 1;
                if (this._actionName == "scale") {
                    var rect = document.getElementById(this._canvas.id + "overviewrect");
                    var bounds = rect.getBBox();
                    x = bounds.x; y = bounds.y; width = bounds.width; height = bounds.height;
                }
                var selectionRect = svg.rect({
                    "id": "helper", x: x, y: y, width: width, height: height,
                    "fill": "transparent", "stroke": "gray", "stroke-dasharray": "2 2", "shape-rendering": "crispEdges"
                });
                g.appendChild(selectionRect);
                this._helper = selectionRect;
            }
        },
        _updateHelper: function (difx, dify, size) {
            if (size) {
                var bounds = this._helper.getBBox();
                var x = bounds.x + difx;
                var y = bounds.y + dify;
                var width = bounds.width + size.width;
                var height = bounds.height + size.height;
            }
            else {
                var difx;
                if (this._currentPoint.x > this._startPoint.x)
                    difx = this._currentPoint.x - this._prevPoint.x;
                else
                    difx = this._prevPoint.x - this._currentPoint.x;
                var dify;
                if (this._currentPoint.y > this._startPoint.y)
                    dify = this._currentPoint.y - this._prevPoint.y;
                else dify = this._prevPoint.y - this._currentPoint.y;
                var w, h;
                if (Math.abs(dify) > Math.abs(difx)) {
                    difx = this._viewPortRatio * dify; h = true; w = false;
                }
                else { dify = difx / this._viewPortRatio; w = true; h = false; }
                var bounds = this._helper.getBBox();
                var x = ((this._startPoint.x > this._currentPoint.x) ?
                    bounds.x - difx : bounds.x);
                var y = ((this._startPoint.y > this._currentPoint.y) ? bounds.y - dify : bounds.y);
                var width = bounds.width + difx;
                var height = bounds.height + dify;
            }
            if (this._helper) {
                ej.datavisualization.Diagram.Util.attr(this._helper, {
                    "id": this._helper.id, "x": x, "y": y,
                    "width": (width < 0) ? 0 : width, "height": (height < 0) ? 0 : height
                });
            }
        },
        _renderOverviewCorner: function (name, parent) {
            var svg = this._svg;
            if (name == "top" || name == "bottom" || name == "right" || name == "left") {
                var innerrect = svg.rect({ "id": this._canvas.id + "visible" + name });
                parent.appendChild(innerrect);
                var transrect = svg.rect({ "id": this._canvas.id + name, "class": "overviewresizer", "fill": "transparent" });
                parent.appendChild(transrect);
            }
            else {
                var innerrect = svg.circle({ "id": this._canvas.id + "visible" + name });
                parent.appendChild(innerrect);
                var transrect = svg.circle({ "id": this._canvas.id + name, "class": "overviewresizer", "fill": "transparent" });
                parent.appendChild(transrect);
            }
        },
        _updateOverviewrect: function (x, y, width, height) {
            if (width && height) {
                var rect = document.getElementById(this._canvas.id + "overviewrect");
                var attr = { x: x, y: y, width: Math.max(1, width), height: Math.max(1, height) };
                ej.datavisualization.Diagram.Util.attr(rect, attr);
                this._updateOverviewCorner("top", x + 8, y - 2, Math.max(0, width - 16), 2);
                this._updateOverviewCorner("bottom", x + 8, y + height, Math.max(0, width - 16), 2);
                this._updateOverviewCorner("left", x - 2, y + 8, 2, Math.max(0, height - 16));
                this._updateOverviewCorner("right", x + width, y + 8, 2, Math.max(0, height - 16));
                this._updateOverviewCorner("topleft", x, y, 5, 5);
                this._updateOverviewCorner("topright", x + width, y, 5, 5);
                this._updateOverviewCorner("bottomleft", x, y + height, 5, 5);
                this._updateOverviewCorner("bottomright", x + width, y + height, 5, 5);
            }
        },
        _scrollOverviewRect: function (hoffset, voffset, currentzoom, isoverviewresize) {
            if (!(this._actionName) || isoverviewresize) {
                var offwidth = this.width;
                var offheight = this.height;
                var scale = Math.min(this.contentWidth / offwidth, this.contentHeight / offheight);
                var bounds = {};
                var x = bounds.x = (hoffset / currentzoom) / scale;
                var y = bounds.y = (voffset / currentzoom) / scale;
                var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this._parent);
                var width = bounds.width = (viewPort.width / currentzoom) / scale;
                var height = bounds.height = (viewPort.height / currentzoom) / scale;
                var ratio = viewPort.width / viewPort.height;
				if(isoverviewresize)
					return { x:x, y:y, width:width, height:height };
                this._updateOverviewrect(x, y, width, height);
            }
        },
        _updateOverviewCorner: function (name, x, y, width, height) {
            var rectname = "visible" + name;
            var rect = document.getElementById(this._canvas.id + rectname);
            if (name == "top" || name == "bottom" || name == "right" || name == "left") {
                var attr = { x: x, y: y, width: width, height: height, fill: "#ED1C24" };
                var transattr = { x: x - 2, y: y - 2, width: width == 2 ? 4 : width, height: height == 2 ? 4 : height };
            }
            else {
                var attr = { cx: x, cy: y, "r": 4, fill: "#ED1C24" };
                var transattr = { cx: x, cy: y, "r": 6, fill: "transparent" };
            }
            ej.datavisualization.Diagram.Util.attr(rect, attr);
            var transrect = document.getElementById(this._canvas.id + name);
            ej.datavisualization.Diagram.Util.attr(transrect, transattr);
        },
        _translateOverviewRectangle: function () {
            var offwidth = this.width;
            var offheight = this.height;
            var difx = this._currentPoint.x - this._prevPoint.x;
            var dify = this._currentPoint.y - this._prevPoint.y;
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this._parent);
            var zoom = Math.min(viewPort.width / offwidth, viewPort.height / offheight);
            var panel = document.getElementById(this._canvas.id + "overviewrect");
            var bounds = panel.getBBox();
            var x = bounds.x + difx;
            var y = bounds.y + dify;
            var width = bounds.width;
            var height = bounds.height;
            this._updateOverviewrect(x, y, width, height);
            this._updateView(this._parent._currZoom, x, y, width, height, null);
        },
        _updateView: function (zoom, x, y, width, height, focuspoint) {
            var offwidth = this.width;
            var offheight = this.height;
            var scalex = this.contentWidth / offwidth;
            var scaley = this.contentHeight / offheight;
            var hoffset = x * scalex * zoom;
            var voffset = y * scaley * zoom;
            var bounds = this._parent._getDigramBounds();
            if (zoom != 1 || this._actionName == "pan") {
                var scrollModel = $("#" + this._parent._canvas.id + "_hScrollbar").ejScrollBar("instance").model;
                var scrollwidth = -hoffset + (scrollModel.maximum);
                var delx = -hoffset + this._parent._hScrollOffset;;
                var dely = -voffset + this._parent._vScrollOffset;
                if (bounds.width * zoom < scrollwidth) {
                    var difwidth = bounds.width * zoom - scrollwidth;
                    if (Math.abs(difwidth) < Math.abs(delx)) {
                        delx = delx - difwidth;
                    }
                    //else delx = 0;
                }
                scrollModel = $("#" + this._parent._canvas.id + "_vScrollbar").ejScrollBar("instance").model;
                var scrollheight = -voffset + (scrollModel.maximum);
                if (bounds.height * zoom < scrollheight) {
                    var difwidth = bounds.height * zoom - scrollheight;
                    if (Math.abs(difwidth) < Math.abs(dely)) {
                        dely = dely - difwidth;
                    }
                    //else dely = 0;
                }
            }
            ej.datavisualization.Diagram.ZoomUtil.zoomPan(this._parent, zoom / this._parent._currZoom, delx, dely, focuspoint, false);
        },
        _renderOverviewRect: function (x, y, width, height) {
            var offwidth = this.width;
            var offheight = this.height;
            var viewPort = ej.datavisualization.Diagram.ScrollUtil._viewPort(this._parent);
            var viewwidth = (width / offwidth) * this.contentWidth;
            var viewheight = (height / offheight) * this.contentHeight;
            var zoom = Math.max(viewPort.width / viewwidth, viewPort.height / viewheight);
            if (zoom >= 0.25 && zoom <= 30) {
                this._updateView(zoom, x, y, width, height, new ej.datavisualization.Diagram.Point(0, 0));
				var bounds = this._scrollOverviewRect( this._parent._hScrollOffset, this._parent._vScrollOffset, this._parent._currZoom, true);
				this._updateOverviewrect(bounds.x, bounds.y, bounds.width, bounds.height);
            }
        },
        handleTouchStart: function (evt) {
            evt.preventDefault();
        },
        handleTouchMove: function (evt) {
            evt.preventDefault();
        },
        handleTouchEnd: function (evt) {
            evt.preventDefault();
        },
        handleTouchLeave: function (evt) {
            evt.preventDefault();
        },
        //#endregion
    });
    //#endregion
})(jQuery, Syncfusion);;

(function ($, ej) {
    "use strict";

    //#region SVG
    var Canvas = (function () {
        function Canvas(attr) {
            this.document = document.createElement("canvas");
            this.id = attr.id;
            this._scaleX = 1;
            this._scaleY = 1;
            if (attr) {
                ej.datavisualization.Diagram.Util.attr(this.document, attr);
            }
            return this;
        }

        //rect
        Canvas.prototype.rect = function (x, y, width, height, rotation, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            if (style) {
                this.setStyle(style, ctx);
                if (style.dashArray)
                    this.dashedRectangle(x, y, width, height, style.dashArray);
            }
            ctx.fillRect(x, y, width, height);
            ctx.strokeRect(x, y, width, height);
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }
        //Rounded rect
        Canvas.prototype.roundedRect = function (x, y, width, height, radius, rotation, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            var points = [{ x: x + radius, y: y }, { x: x + width - radius, y: y },
                { x: x + width, y: y + radius }, { x: x + width, y: y + height - radius },
                { x: x + width - radius, y: y + height }, { x: x + radius, y: y + height },
                { x: x, y: y + height - radius }, { x: x, y: y + radius }
            ];
            var corners = [{ x: x + width, y: y }, { x: x + width, y: y + height }, { x: x, y: y + height }, { x: x, y: y }];
            var corner = 0;
            var point2, next;
            if (style)
                this.setStyle(style, ctx);
            //draw
            ctx.moveTo(points[0].x, points[0].y);
            var i;
            for (i = 0; i < points.length; i = i + 2) {
                point2 = points[i + 1];
                ctx.lineTo(point2.x, point2.y);
                next = points[i + 2] || points[0];
                ctx.quadraticCurveTo(corners[corner].x, corners[corner].y, next.x, next.y);
                corner++;
            }
            ctx.fill();
            if (style && style.dashArray) {
                corner = 0;
                for (i = 0; i < points.length; i = i + 2) {
                    this.dashedLine(points[i].x, points[i].y, points[i + 1].x, points[i + 1].y, style.dashArray);
                    this.quadraticCurve(points[i + 1], corners[corner], points[i + 2] || points[0], style);
                    corner++;
                }
            }
            ctx.stroke();
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }
        //ellipse
        Canvas.prototype.ellipse = function (cx, cy, rx, ry, rotation, style) {
            var ctx = this.document.getContext("2d");
            if (style) {
                this.setStyle(style, ctx);
            }
            var r = 4 * ((Math.sqrt(2) - 1) / 3);
            ctx.beginPath();
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            ctx.moveTo(cx, cy - ry);
            ctx.bezierCurveTo(cx + (r * rx), cy - ry, cx + rx, cy - (r * ry), cx + rx, cy);
            ctx.bezierCurveTo(cx + rx, cy + (r * ry), cx + (r * rx), cy + ry, cx, cy + ry);
            ctx.bezierCurveTo(cx - (r * rx), cy + ry, cx - rx, cy + (r * ry), cx - rx, cy);
            ctx.bezierCurveTo(cx - rx, cy - (r * ry), cx - (r * rx), cy - ry, cx, cy - ry);
            ctx.fill();
            if (style && style.dashArray) {
                this.bezierCurve(ej.datavisualization.Diagram.Point(cx, cy - ry),
                    new ej.datavisualization.Diagram.Point(cx + (r * rx), cy - ry),
                    new ej.datavisualization.Diagram.Point(cx + rx, cy - (r * ry)),
                    new ej.datavisualization.Diagram.Point(cx + rx, cy), style);
                this.bezierCurve(ej.datavisualization.Diagram.Point(cx + rx, cy),
                    new ej.datavisualization.Diagram.Point(cx + rx, cy + (r * ry)),
                    new ej.datavisualization.Diagram.Point(cx + (r * rx), cy + ry),
                    new ej.datavisualization.Diagram.Point(cx, cy + ry), style);
                this.bezierCurve(ej.datavisualization.Diagram.Point(cx, cy + ry),
                    new ej.datavisualization.Diagram.Point(cx - (r * rx), cy + ry),
                    new ej.datavisualization.Diagram.Point(cx - rx, cy + (r * ry)),
                    new ej.datavisualization.Diagram.Point(cx - rx, cy), style);
                this.bezierCurve(ej.datavisualization.Diagram.Point(cx - rx, cy),
                    new ej.datavisualization.Diagram.Point(cx - rx, cy - (r * ry)),
                    new ej.datavisualization.Diagram.Point(cx - (r * rx), cy - ry),
                    new ej.datavisualization.Diagram.Point(cx, cy - ry), style);
            }
            ctx.stroke();
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        //circle
        Canvas.prototype.circle = function (centerx, centery, radius, rotation, style) {
            var ctx = this.document.getContext("2d");
            if (style) {
                this.setStyle(style, ctx);
            }
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            if (style && style.dashArray) {
                ctx.beginPath();
                ctx.arc(centerx, centery, radius, 0, 2 * Math.PI);
                ctx.fill();
                ctx.stroke();
                ctx.closePath();
            }
            else { this.ellipse(centerx, centery, radius * 2, radius * 2, rotation, style); }
            if (rotation && rotation.angle)
                ctx.restore();
        }
        Canvas.prototype.arc = function (centerx, centery, radius, angle, sweep, style) {
            var rotation = { "angle": angle, x: centerx, y: centery };
            var ctx = this.document.getContext("2d");
            if (style) {
                this.setStyle(style, ctx);
            }
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            ctx.beginPath();
            var stAngle = 0;
            var endAngle = Math.PI;
            if (!sweep) {
                stAngle = Math.PI;
                endAngle = 0;
            }
            if (style && style.dashArray) {
                ctx.arc(centerx, centery, radius, stAngle, endAngle);
            }
            else { ctx.arc(centerx, centery, radius, stAngle, endAngle); }
            //ctx.fill();
            ctx.stroke();
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        //path
        Canvas.prototype.path = function (path, x, y, width, height, rotation, style) {
            var ctx = this.document.getContext("2d");
            if (style) {
                this.setStyle(style, ctx);
            }
            ctx.beginPath();
            var transX = x, transY = y;
            ctx.translate(transX, transY);
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            var shape = document.createElementNS('http://www.w3.org/2000/svg', "path");
            shape.setAttribute("d", path);
            this.document.appendChild(shape);
            var segments = this.getSegments(shape);
            var offsetX = x;
            var offsetY = y;
            var pathstr = "";
            var x0, y0, x1, y1, x2, y2, segs = segments;
            for (var x = 0, y = 0, i = 0, length = segs.length; i < length; ++i) {
                var seg = segs[i], char = seg.command;
                if ('x1' in seg) x1 = seg.x1;
                if ('x2' in seg) x2 = seg.x2;
                if ('y1' in seg) y1 = seg.y1;
                if ('y2' in seg) y2 = seg.y2;
                if ('x' in seg) x = seg.x;
                if ('y' in seg) y = seg.y;
                switch (char) {
                    case 'M':
                        ctx.moveTo(x, y); seg.x = x; seg.y = y;
                        break;
                    case 'L':
                        ctx.lineTo(x, y);
                        seg.x = x; seg.y = y;
                        break;
                    case 'C':
                        ctx.bezierCurveTo(x1, y1, x2, y2, x, y);
                        seg.x = x; seg.y = y; seg.x1 = x1; seg.y1 = y1; seg.x2 = x2; seg.y2 = y2;
                        break;
                    case 'Q':
                        ctx.quadraticCurveTo(x1, y1, x, y);
                        seg.x = x; seg.y = y; seg.x1 = x1; seg.y1 = y1;
                        break;
                    case 'A':
                        var curr = new ej.datavisualization.Diagram.Point(x0, y0);
                        var rx = seg.r1, ry = seg.r2;
                        var xAxisRotation = seg.angle * (Math.PI / 180.0);
                        var largeArcFlag = seg.largeArcFlag;
                        var sweepFlag = seg.sweepFlag;
                        var cp = new ej.datavisualization.Diagram.Point(x, y);

                        var currp = new ej.datavisualization.Diagram.Point(
                            Math.cos(xAxisRotation) * (curr.x - cp.x) / 2.0 + Math.sin(xAxisRotation) * (curr.y - cp.y) / 2.0,
                            -Math.sin(xAxisRotation) * (curr.x - cp.x) / 2.0 + Math.cos(xAxisRotation) * (curr.y - cp.y) / 2.0
                        );

                        var l = Math.pow(currp.x, 2) / Math.pow(rx, 2) + Math.pow(currp.y, 2) / Math.pow(ry, 2);
                        if (l > 1) {
                            rx *= Math.sqrt(l);
                            ry *= Math.sqrt(l);
                        }

                        var s = (largeArcFlag == sweepFlag ? -1 : 1) * Math.sqrt(
                            ((Math.pow(rx, 2) * Math.pow(ry, 2)) - (Math.pow(rx, 2) * Math.pow(currp.y, 2)) - (Math.pow(ry, 2) * Math.pow(currp.x, 2))) /
                            (Math.pow(rx, 2) * Math.pow(currp.y, 2) + Math.pow(ry, 2) * Math.pow(currp.x, 2))
                        );
                        if (isNaN(s)) s = 0;
                        var cpp = new ej.datavisualization.Diagram.Point(s * rx * currp.y / ry, s * -ry * currp.x / rx);

                        var centp = new ej.datavisualization.Diagram.Point(
                            (curr.x + cp.x) / 2.0 + Math.cos(xAxisRotation) * cpp.x - Math.sin(xAxisRotation) * cpp.y,
                            (curr.y + cp.y) / 2.0 + Math.sin(xAxisRotation) * cpp.x + Math.cos(xAxisRotation) * cpp.y
                        );
                        // vector magnitude
                        var m = function (v) { return Math.sqrt(Math.pow(v[0], 2) + Math.pow(v[1], 2)); }
                        // ratio between two vectors
                        var r = function (u, v) { return (u[0] * v[0] + u[1] * v[1]) / (m(u) * m(v)) }
                        // angle between two vectors
                        var a = function (u, v) { return (u[0] * v[1] < u[1] * v[0] ? -1 : 1) * Math.acos(r(u, v)); }
                        // initial angle
                        var a1 = a([1, 0], [(currp.x - cpp.x) / rx, (currp.y - cpp.y) / ry]);
                        // angle delta
                        var u = [(currp.x - cpp.x) / rx, (currp.y - cpp.y) / ry];
                        var v = [(-currp.x - cpp.x) / rx, (-currp.y - cpp.y) / ry];
                        var ad = a(u, v);
                        if (r(u, v) <= -1) ad = Math.PI;
                        if (r(u, v) >= 1) ad = 0;

                        var dir = 1 - sweepFlag ? 1.0 : -1.0;
                        var ah = a1 + dir * (ad / 2.0);
                        var halfWay = new ej.datavisualization.Diagram.Point(
                            centp.x + rx * Math.cos(ah),
                            centp.y + ry * Math.sin(ah)
                        );
                        seg.centp = centp;
                        seg.xAxisRotation = xAxisRotation;
                        seg.rx = rx;
                        seg.ry = ry;
                        seg.a1 = a1; seg.ad = ad; seg.sweepFlag = sweepFlag;
                        if (ctx != null) {
                            var r = rx > ry ? rx : ry;
                            var sx = rx > ry ? 1 : rx / ry;
                            var sy = rx > ry ? ry / rx : 1;
                            ctx.save();
                            ctx.translate(centp.x, centp.y);
                            ctx.rotate(xAxisRotation);
                            ctx.scale(sx, sy);
                            ctx.arc(0, 0, r, a1, a1 + ad, 1 - sweepFlag);
                            ctx.scale(1 / sx, 1 / sy);
                            ctx.rotate(-xAxisRotation);
                            ctx.translate(-centp.x, -centp.y);
                            ctx.restore();
                        }
                        break;
                    case 'Z':
                    case 'z':
                        ctx.closePath();
                        x = x0; y = y0;
                        break;
                }
                // Record the start of a subpath
                x0 = x, y0 = y;
            }
            ctx.fill();
            if (style && style.dashArray)
                this.drawDashedPath(segs, style);
            else
                ctx.stroke();
            ctx.translate(-transY, -transY);
            if (rotation && rotation.angle)
                ctx.restore();
        }

        Canvas.prototype.getSegments = function (shape) {
            var x0, y0, x1, y1, x2, y2, initx, inity, segs = ej.datavisualization.Diagram.Util.convertPathToArray(shape.getAttribute("d"));
            var segments = [];
            for (var x = 0, y = 0, i = 0, length = segs.length; i < length; ++i) {
                var seg = segs[i], char = seg.pathSegTypeAsLetter;
                if ('x1' in seg) x1 = seg.x1;
                if ('x2' in seg) x2 = seg.x2;
                if ('y1' in seg) y1 = seg.y1;
                if ('y2' in seg) y2 = seg.y2;
                if ('x' in seg) x = seg.x;
                if ('y' in seg) y = seg.y;
                switch (char) {
                    case 'M':
                        segments.push({ command: "M", x: x, y: y });
                        break;
                    case 'L':
                        segments.push({ command: "L", x0: x0, y0: y0, x: x, y: y });
                        break;
                    case 'H':
                        segments.push({ command: "L", x0: x0, y0: y0, x: x, y: y0 });
                        break;
                    case 'V':
                        segments.push({ command: "L", x0: x0, y0: y0, x: x0, y: y });
                        break;
                    case 'C':
                        segments.push({ command: "C", x0: x0, y0: y0, x1: x1, y1: y1, x2: x2, y2: y2, x: x, y: y });
                        break;
                    case 'S':
                        if (prev) {
                            if (prev.command == "C" || prev.command == "S") {
                                var ctrl = { x: prev.x2, y: prev.y2 };
                            }
                            else
                                var ctrl = { x: prev.x0, y: prev.y0 };
                            var cpt2 = new ej.datavisualization.Diagram.Point(2 * x0 - ctrl.x, 2 * y0 - ctrl.y);

                            segments.push({ command: "C", x0: x0, y0: y0, x1: cpt2.x, y1: cpt2.y, x2: x2, y2: y2, x: x, y: y });
                        }
                        break;
                    case 'Q':
                        //ctx.quadraticCurveTo(x1, y1, x, y);
                        segments.push({ command: "Q", x0: x0, y0: y0, x1: x1, y1: y1, x: x, y: y });
                        break;
                    case 'T':
                        if (prev) {
                            if (prev.command == "Q") {
                                var ctrl = { x: prev.x1, y: prev.y1 };
                            }
                            else
                                var ctrl = { x: prev.x0, y: prev.y0 };
                            var cpt2 = new ej.datavisualization.Diagram.Point(2 * x0 - ctrl.x, 2 * y0 - ctrl.y);

                            segments.push({ command: "Q", x0: x0, y0: y0, x1: cpt2.x, y1: cpt2.y, x: x, y: y });
                        }
                        break;
                    case 'A'://need to update for "A"
                        var newSeg = $.extend(true, {}, seg);
                        newSeg.command = "A";
                        segments.push(newSeg);
                        break;
                    case 'Z':
                    case 'z':
                        segments.push({ command: "L", x0: x, y0: y, x: initx, y: inity });
                        x = x0; y = y0;
                        break;
                }
                var prev = segments[segments.length - 1];
                // Record the start of a subpath
                if (char === 'M' || char === 'm') {
                    initx = x, inity = y;
                }
                x0 = x, y0 = y;
            }
            return segments;
        }

        Canvas.prototype.drawDashedPath = function (segs, style) {
            var x1, y1, x2, y2, x0, y0;
            var initial;
            for (var x = 0, y = 0, i = 0, length = segs.length; i < length; ++i) {
                var seg = segs[i], char = seg.command;
                if ('x1' in seg) x1 = seg.x1;
                if ('x2' in seg) x2 = seg.x2;
                if ('y1' in seg) y1 = seg.y1;
                if ('y2' in seg) y2 = seg.y2;
                if ('x' in seg) x = seg.x;
                if ('y' in seg) y = seg.y;
                switch (char) {
                    case 'M':
                        initial = { x: x, y: y };
                        break;
                    case 'L':
                        this.dashedLine(x0, y0, x, y, style.dashArray);
                        break;
                    case 'H':
                        this.dashedLine(x0, y0, x, y0, style.dashArray);
                        break;
                    case 'V':
                        this.dashedLine(x0, y0, x0, y, style.dashArray);
                        break;
                    case 'C':
                        this.bezierCurve(ej.datavisualization.Diagram.Point(x0, y0), ej.datavisualization.Diagram.Point(x1, y1), ej.datavisualization.Diagram.Point(x2, y2), ej.datavisualization.Diagram.Point(x, y), style);
                        break;
                    case 'Q':
                        this.quadraticCurve(ej.datavisualization.Diagram.Point(x0, y0), ej.datavisualization.Diagram.Point(x1, y1), ej.datavisualization.Diagram.Point(x, y), style);
                        break;
                    case 'A':
                        var ctx = this.document.getContext("2d");
                        if (ctx != null) {
                            var r = seg.rx > seg.ry ? seg.rx : seg.ry;
                            var sx = seg.rx > seg.ry ? 1 : seg.rx / seg.ry;
                            var sy = seg.rx > seg.ry ? seg.ry / seg.rx : 1;
                            ctx.save();
                            ctx.translate(seg.centp.x, seg.centp.y);
                            ctx.rotate(seg.xAxisRotation);
                            ctx.scale(sx, sy);
                            this.dashedArc(r, 0, 0, seg.a1, seg.a1 + seg.ad, 1 - seg.sweepFlag, style.dashArray);
                            ctx.scale(1 / sx, 1 / sy);
                            ctx.rotate(-seg.xAxisRotation);
                            ctx.translate(-seg.centp.x, -seg.centp.y);
                            ctx.restore();
                        }
                        break;
                    case 'Z':
                    case 'z':
                        //ctx.closePath();
                        this.dashedLine(x, y, initial.x, initial.y, style.dashArray);
                        x = x0; y = y0;
                        break;
                }
                // Record the start of a subpath
                //if (char === 'M' || char === 'm') x0 = x, y0 = y;
                x0 = x, y0 = y;
            }
            //ctx.fill();
        }
        Canvas.prototype.calculateCirclePoints = function (radius, cx, cy, stAngle, endAngle, couterClockwise, dashSize) {
            stAngle = stAngle * 180 / Math.PI;
            endAngle = endAngle * 180 / Math.PI;
            var n = (2 * Math.PI * radius) * (Math.abs(stAngle - endAngle) / 360) * 0.7;
            var alpha = Math.abs(stAngle - endAngle) / n;
            alpha = couterClockwise ? alpha * -1 : alpha;
            var i = 0;
            var points = [];
            while (i < n) {
                points.push(ej.datavisualization.Diagram.Geometry.transform({ x: cx, y: cy }, stAngle + alpha * i, radius));
                i++;
            }
            return points;
        }

        //polygon
        Canvas.prototype.polygon = function (points, rotation, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            if (style) {
                this.setStyle(style, ctx);
            }
            ctx.moveTo(points[0].x, points[0].y);
            for (var i = 1; i < points.length; i++) {
                ctx.lineTo(points[i].x, points[i].y);
            }
            ctx.lineTo(points[0].x, points[0].y);
            ctx.fill();
            if (style && style.dashArray) {
                for (var i = 1; i < points.length; i++) {
                    this.line(points[i - 1], points[i], style);
                }
                this.line(points[i - 1], points[0], style);
            }
            ctx.stroke();
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        //image
        Canvas.prototype.image = function (image, x, y, width, height, rotation, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            if (style) {
                this.setStyle(style, ctx);
            }
            if (width && height)
                ctx.drawImage(image, x, y, width, height);
            else
                ctx.drawImage(image, x, y);
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        //text
        Canvas.prototype.text = function (text, x, y, rotation, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            if (style)
                this.setStyle(style, ctx);
            ctx.fillText(text.text, x, y);
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        //line
        Canvas.prototype.line = function (start, end, style, dontstart, dontclose) {
            var ctx = this.document.getContext("2d");
            if (!dontstart) {
                ctx.beginPath();
                if (style) {
                    this.setStyle(style, ctx);
                }
            }
            if (style && style.dashArray) {
                this.dashedLine(start.x, start.y, end.x, end.y, style.dashArray);
            }
            else {
                if (!dontstart)
                    ctx.moveTo(start.x, start.y);
                ctx.lineTo(end.x, end.y);
                ctx.stroke();
            }
            if (!dontclose)
                ctx.closePath();
        }

        //polyline
        Canvas.prototype.polyline = function (points, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (style) {
                this.setStyle(style, ctx);
            }
            for (var i = 1; i < points.length; i++) {
                this.line(points[i - 1], points[i], style);
            }
            ctx.stroke();
        }

        //bezier curve
        Canvas.prototype.bezierCurve = function (startPoint, cpt1, cpt2, cpt3, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            ctx.moveTo(startPoint.x, startPoint.y);
            if (style) {
                this.setStyle(style, ctx);
            }
            if (style && style.dashArray) {
                var points = [];
                this.flattenCubicBezier(points, startPoint, cpt1, cpt2, cpt3);
                var dashLength = 0;
                for (var i = 0; i < style.dashArray.length; i++) {
                    dashLength += Number(style.dashArray[i]);
                }
                var dashcount = points.length / dashLength;
                var draw = true;
                var drawn = 0;
                for (var i = 0; i < dashcount; i++) {
                    for (var j = 0; j < style.dashArray.length; j++) {
                        drawn += Number(style.dashArray[j]);
                        if (drawn < points.length) {
                            if (draw) {
                                ctx.lineTo(points[drawn].x, points[drawn].y);
                            }
                            else ctx.moveTo(points[drawn].x, points[drawn].y);
                        }
                        draw = !draw;
                    }
                }


            }
            else {
                ctx.moveTo(startPoint.x, startPoint.y);
                ctx.bezierCurveTo(cpt1.x, cpt1.y, cpt2.x, cpt2.y, cpt3.x, cpt3.y);
            }
            ctx.stroke();
        }

        Canvas.prototype.quadraticCurve = function (startPoint, cpt1, cpt2, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            ctx.moveTo(startPoint.x, startPoint.y);
            if (style) {
                this.setStyle(style, ctx);
            }
            if (style && style.dashArray) {
                var points = [];
                this.flattenQuadraticBezier(points, startPoint, cpt1, cpt2);
                var dashLength = 0;
                for (var i = 0; i < style.dashArray.length; i++) {
                    dashLength += Number(style.dashArray[i]);
                }
                var dashcount = points.length / dashLength;
                var draw = true;
                var drawn = 0;
                for (var i = 0; i < dashcount; i++) {
                    for (var j = 0; j < style.dashArray.length; j++) {
                        drawn += Number(style.dashArray[j]);
                        if (drawn < points.length) {
                            if (draw) {
                                ctx.lineTo(points[drawn].x, points[drawn].y);
                            }
                            else ctx.moveTo(points[drawn].x, points[drawn].y);
                        }
                        draw = !draw;
                    }
                }

            }
            else {
                ctx.moveTo(startPoint.x, startPoint.y);
                ctx.quadraticCurveTo(cpt1.x, cpt1.y, cpt2.x, cpt2.y);
            }
            ctx.stroke();
        }

        //arrow
        Canvas.prototype.arrow = function (point, rotation, size, isOpen, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (style) {
                this.setStyle(style, ctx);
            }
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            ctx.moveTo(point.x + size.width, point.y + size.height / 2);
            ctx.lineTo(point.x, point.y);
            ctx.lineTo(point.x + size.width, point.y - size.height / 2);
            if (!isOpen) {
                ctx.closePath();
                ctx.fill();
            }
            ctx.stroke();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        //diamond
        Canvas.prototype.diamond = function (point, rotation, size, style) {
            var ctx = this.document.getContext("2d");
            ctx.beginPath();
            if (style) {
                this.setStyle(style, ctx);
            }
            if (rotation && rotation.angle) {
                this.rotateContext(rotation, ctx);
            }
            ctx.moveTo(point.x + size.width, point.y);
            ctx.lineTo(point.x + size.width / 2, point.y + size.height / 2);
            ctx.lineTo(point.x, point.y);
            ctx.lineTo(point.x + size.width / 2, point.y - size.height / 2);
            ctx.lineTo(point.x + size.width, point.y);
            ctx.stroke();
            ctx.fill();
            ctx.closePath();
            if (rotation && rotation.angle)
                ctx.restore();
        }

        Canvas.prototype.dashedLine = function (x1, y1, x2, y2, dashArray) {
            var ctx = this.document.getContext("2d");
            ctx.save();
            var dx = (x2 - x1), dy = (y2 - y1);
            var length = Math.sqrt(dx * dx + dy * dy);
            var angle = Math.atan2(dy, dx);
            ctx.beginPath();
            ctx.translate(x1, y1);
            ctx.moveTo(0, 0);
            ctx.rotate(angle);
            var dcount = dashArray.length;
            var dindex = 0, draw = true;
            var x = 0;
            while (length > x) {
                x += Number(dashArray[dindex++ % dcount]);
                if (x > length) x = length;
                draw ? ctx.lineTo(x, 0) : ctx.moveTo(x, 0);
                draw = !draw;
                ctx.stroke();
            }
            ctx.restore();
        }

        Canvas.prototype.dashedRectangle = function (x, y, width, height, dashArray) {
            this.dashedLine(x, y, x + width, y, dashArray);
            this.dashedLine(x + width, y, x + width, y + height, dashArray);
            this.dashedLine(x + width, y + height, x, y + height, dashArray);
            this.dashedLine(x, y + height, x, y, dashArray);
        }

        Canvas.prototype.dashedArc = function (radius, cx, cy, stAngle, endAngle, couterClockwise, dashArray) {
            var dashLength = 0;
            for (var i = 0; i < dashArray.length; i++) {
                dashLength += Number(dashArray[i]);
            }
            var points = this.calculateCirclePoints(radius, cx, cy, stAngle, endAngle, couterClockwise, dashLength);
            var ctx = this.document.getContext("2d");
            ctx.beginPath();

            var dashcount = points.length / dashLength;
            var draw = true;
            var drawn = 0;
            for (var i = 0; i < dashcount; i++) {
                for (var j = 0; j < dashArray.length; j++) {
                    drawn += Number(dashArray[j]);
                    if (drawn < points.length) {
                        if (draw) {
                            ctx.lineTo(points[drawn].x, points[drawn].y);
                            ctx.stroke();
                        }
                        else ctx.moveTo(points[drawn].x, points[drawn].y);
                    }
                    draw = !draw;
                }
            }
            ctx.closePath();
        }
        Canvas.prototype.absolutePath = function (path) {
            var minx, miny, maxx, maxy;
            var x0, y0, x1, y1, x2, y2, segs = ej.datavisualization.Diagram.Util.convertPathToArray(path.getAttribute("d"));
            for (var x = 0, y = 0, i = 0, length = segs.length; i < length; ++i) {
                var seg = segs[i], char = seg.pathSegTypeAsLetter;
                if (/[MLHVCSQTA]/.test(char)) {
                    if ('x' in seg) x = seg.x;
                    if ('y' in seg) y = seg.y;
                } else {
                    if ('x1' in seg) x1 = x + seg.x1;
                    if ('x2' in seg) x2 = x + seg.x2;
                    if ('y1' in seg) y1 = y + seg.y1;
                    if ('y2' in seg) y2 = y + seg.y2;
                    if ('x' in seg) x += seg.x;
                    if ('y' in seg) y += seg.y;
                    var newSeg;
                    switch (char) {
                        case 'm':
                            newSeg = { pathSegTypeAsLetter: "M", x: x, y: y };
                            break;
                        case 'l':
                            newSeg = { pathSegTypeAsLetter: "L", x: x, y: y };
                            break;
                        case 'h':
                            newSeg = { pathSegTypeAsLetter: "H", x: x };
                            break;
                        case 'v':
                            newSeg = { pathSegTypeAsLetter: "V", y: y };
                            break;
                        case 'c':
                            newSeg = { pathSegTypeAsLetter: "C", x: x, y: y, x1: x1, y1: y1, x2: x2, y2: y2 };
                            break;
                        case 's':
                            newSeg = { pathSegTypeAsLetter: "S", x: x, y: y, x2: x2, y2: y2 };
                            break;
                        case 'q':
                            newSeg = { pathSegTypeAsLetter: "Q", x: x, y: y, x1: x1, y1: y1 };
                            break;
                        case 't':
                            newSeg = { pathSegTypeAsLetter: "T", x: x, y: y };
                            break;
                        case 'a':
                            newSeg = { pathSegTypeAsLetter: "A", x: x, y: y, r1: r1, r2: r2, angle: angle, largeArcFlag: largeArcFlag, sweepFlag: sweepFlag };
                            break;
                        case 'z':
                        case 'Z':
                            x = x0; y = y0;
                            newSeg = segs[i];
                            break;
                    }
                    if (newSeg)
                        segs[i] = newSeg;
                }
                if (char === 'M' || char === 'm') x0 = x, y0 = y;
            }

            path.setAttribute("d", ej.datavisualization.Diagram.Util.pathSegArrayAsString(segs));

            Canvas.prototype._scalePathData = function (val, scaleFactor, oldOffset, newOffset) {
                if (val !== oldOffset) {
                    if (newOffset !== oldOffset) {
                        val = (((val * scaleFactor) - (Number(oldOffset) * scaleFactor - Number(oldOffset)))
                            + (newOffset - Number(oldOffset)));
                    }
                    else
                        val = ((Number(val) * scaleFactor) - (Number(oldOffset) * scaleFactor - Number(oldOffset)));
                }
                else {
                    if (newOffset !== oldOffset) {
                        val = newOffset;
                    }
                }
                return val;
            }
            return path;
        };

        Canvas.prototype.setStyle = function (style, ctx) {
            if (style.fill)
                ctx.fillStyle = style.fill;
            if (style.stroke)
                ctx.strokeStyle = style.stroke == "none" ? "transparent" : style.stroke;
            if (style.font)
                ctx.font = style.font;
            if (style.lineWidth)
                ctx.lineWidth = style.lineWidth;
        }

        Canvas.prototype.rotateContext = function (rotation, ctx) {
            ctx.save();
            ctx.translate(rotation.x, rotation.y);
            ctx.rotate(rotation.angle * Math.PI / 180);
            ctx.translate(-rotation.x, -rotation.y);
        }

        Canvas.prototype.pathBounds = function (segments) {
            //var segs = shape.pathSegList;
            var x1, y1, x2, y2, x0, y0;
            var minx, miny, maxx, maxy;
            for (var x = 0, y = 0, i = 0, length = segments.length; i < length; ++i) {
                var seg = segments[i], char = seg.command;
                if (i == 0 && seg.x && seg.y) {
                    minx = maxx = seg.x;
                    miny = maxy = seg.y;
                }
                //var seg = segs.getItem(i), char = seg.pathSegTypeAsLetter;
                if ('x1' in seg) x1 = seg.x1;
                if ('x2' in seg) x2 = seg.x2;
                if ('y1' in seg) y1 = seg.y1;
                if ('y2' in seg) y2 = seg.y2;
                if ('x' in seg) x = seg.x;
                if ('y' in seg) y = seg.y;

                switch (char) {
                    case 'M':
                        x0 = x; y0 = y;
                    case 'L':
                    case 'H':
                    case 'V':
                        if (x) {
                            minx = Math.min(x, minx);
                            maxx = Math.max(x, maxx);
                        }
                        if (y) {
                            miny = Math.min(y, miny);
                            maxy = Math.max(y, maxy);
                        }
                        break;
                    case 'C':

                    case 'S':
                        var bounds = this.getBezierBounds(ej.datavisualization.Diagram.Point(x0, y0), ej.datavisualization.Diagram.Point(x1, y1), ej.datavisualization.Diagram.Point(x2, y2), ej.datavisualization.Diagram.Point(x, y));
                        minx = Math.min(bounds.x, minx);
                        maxx = Math.max(bounds.x + bounds.width, maxx);
                        miny = Math.min(bounds.y, miny);
                        maxy = Math.max(bounds.y + bounds.height, maxy);
                        break;
                    case 'Q':
                    case "q":
                    case 'T':
                        var bounds = this.getQuadraticBounds(ej.datavisualization.Diagram.Point(x0, y0), ej.datavisualization.Diagram.Point(x1, y1), ej.datavisualization.Diagram.Point(x, y));
                        minx = Math.min(bounds.x, minx);
                        maxx = Math.max(bounds.x + bounds.width, maxx);
                        miny = Math.min(bounds.y, miny);
                        maxy = Math.max(bounds.y + bounds.height, maxy);
                        break;
                    case 'A':
                        break;
                    case 'Z':
                    case 'z':
                        //ctx.closePath();
                        x = x0; y = y0;
                        break;
                }
            }
            return { x: minx, y: miny, width: maxx - minx, height: maxy - miny };
        };

        Canvas.prototype.flattenCubicBezier = function (points, ptStart, ptCtrl1, ptCtrl2, ptEnd, tolerance) {
            var tolerance = 1.5;

            var max = Number((ej.datavisualization.Diagram.Geometry.distance(ptCtrl1, ptStart) +
                              ej.datavisualization.Diagram.Geometry.distance(ptCtrl2, ptCtrl1) +
                              ej.datavisualization.Diagram.Geometry.distance(ptEnd, ptCtrl2)) / tolerance);

            for (var i = 0; i <= max; i++) {
                var t = i / max;

                var x = (1 - t) * (1 - t) * (1 - t) * ptStart.x +
                           3 * t * (1 - t) * (1 - t) * ptCtrl1.x +
                           3 * t * t * (1 - t) * ptCtrl2.x +
                           t * t * t * ptEnd.x;

                var y = (1 - t) * (1 - t) * (1 - t) * ptStart.y +
                           3 * t * (1 - t) * (1 - t) * ptCtrl1.y +
                           3 * t * t * (1 - t) * ptCtrl2.y +
                           t * t * t * ptEnd.y;

                points.push(new ej.datavisualization.Diagram.Point(x, y));
            }
        }

        Canvas.prototype.flattenQuadraticBezier = function (points, ptStart, ptCtrl1, ptEnd, tolerance) {
            var tolerance = 1.5;

            var max = Number((ej.datavisualization.Diagram.Geometry.distance(ptCtrl1, ptStart) +
                             ej.datavisualization.Diagram.Geometry.distance(ptEnd, ptCtrl1)) / tolerance);

            for (var i = 0; i <= max; i++) {
                var t = i / max;

                var x = (1 - t) * (1 - t) * ptStart.x +
                                          2 * t * (1 - t) * ptCtrl1.x +
                                          t * t * ptEnd.x;

                var y = (1 - t) * (1 - t) * ptStart.y +
                           2 * t * (1 - t) * ptCtrl1.y +
                           t * t * ptEnd.y;

                points.push(new ej.datavisualization.Diagram.Point(x, y));
            }
        }

        Canvas.prototype.getBezierBounds = function (ptStart, ptCtrl1, ptCtrl2, ptEnd, tolerance) {
            var tolerance = 3;
            var minx, miny, maxx, maxy;
            var max = Number((ej.datavisualization.Diagram.Geometry.distance(ptCtrl1, ptStart) +
                              ej.datavisualization.Diagram.Geometry.distance(ptCtrl2, ptCtrl1) +
                              ej.datavisualization.Diagram.Geometry.distance(ptEnd, ptCtrl2)) / tolerance);

            for (var i = 0; i <= max; i++) {

                var t = i / max;

                var x = (1 - t) * (1 - t) * (1 - t) * ptStart.x +
                           3 * t * (1 - t) * (1 - t) * ptCtrl1.x +
                           3 * t * t * (1 - t) * ptCtrl2.x +
                           t * t * t * ptEnd.x;

                var y = (1 - t) * (1 - t) * (1 - t) * ptStart.y +
                           3 * t * (1 - t) * (1 - t) * ptCtrl1.y +
                           3 * t * t * (1 - t) * ptCtrl2.y +
                           t * t * t * ptEnd.y;
                if (i == 0) {
                    minx = maxx = x;
                    miny = maxy = y;
                }
                else {
                    minx = Math.min(x, minx);
                    miny = Math.min(y, miny);
                    maxx = Math.max(x, maxx);
                    maxy = Math.max(y, maxy);
                }
            }
            return { x: minx, y: miny, width: maxx - minx, height: maxy - miny };
        }

        Canvas.prototype.getQuadraticBounds = function (ptStart, ptCtrl1, ptEnd, tolerance) {
            var tolerance = 3;
            var minx, miny, maxx, maxy;
            var max = Number((ej.datavisualization.Diagram.Geometry.distance(ptCtrl1, ptStart) +
                              ej.datavisualization.Diagram.Geometry.distance(ptEnd, ptCtrl1)) / tolerance);

            for (var i = 0; i <= max; i++) {
                var t = i / max;


                var x = (1 - t) * (1 - t) * ptStart.x +
                           2 * t * (1 - t) * ptCtrl1.x +
                           t * t * ptEnd.x;

                var y = (1 - t) * (1 - t) * ptStart.y +
                           2 * t * (1 - t) * ptCtrl1.y +
                           t * t * ptEnd.y;

                if (i == 0) {
                    minx = maxx = x;
                    miny = maxy = y;
                }
                else {
                    minx = Math.min(x, minx);
                    miny = Math.min(y, miny);
                    maxx = Math.max(x, maxx);
                    maxy = Math.max(y, maxy);
                }
            }
            return { x: minx, y: miny, width: maxx - minx, height: maxy - miny };
        }

        return Canvas;
    })();

    ej.datavisualization.Diagram.Canvas = Canvas;
    //#endregion

    //#region Renderer
    ej.datavisualization.Diagram.CanvasContext = {

        _renderDocument: function (view, diagram) {
            var attr = {
                id: view.canvas.id + "_canvas",
                width: diagram._canvas.clientWidth,
                height: diagram._canvas.clientHeight,
                version: "1.1",
                xlink: "http://www.w3.org/1999/xlink",
                "style": view.style,
                "pointer-events": "none"
            };
            view._canvas = new ej.datavisualization.Diagram.Canvas(attr);
            diagram._view = view.canvas;
            view.canvas.appendChild(view._canvas.document);
            if (view.type == "mainview") {
                this._canvas = view.canvas;
                diagram._svg = this._svg = view._canvas;
            }
        },

        _renderGroupBackground: function (group, canvas, diagram) {
            if (!group.pivot) {
                group.pivot = {};
                group.pivot.x = .5;
                group.pivot.y = .5;
            }

            var ctx = canvas.document.getContext("2d");
            if (group.visible) {
                var rotation = { "angle": group.rotateAngle, x: group.offsetX * canvas._scaleX, y: group.offsetY * canvas._scaleY };
                ctx.save();
                ctx.translate(rotation.x, rotation.y);
                ctx.rotate(rotation.angle * Math.PI / 180);
                ctx.translate(-rotation.x, -rotation.y);
                ctx.fillStyle = group.type != "bpmn" ? group.fillColor : "transparent";
                ctx.strokeStyle = group.type != "bpmn" ? group.borderColor : "transparent";
                ctx.lineWidth = group.borderWidth;
                if (group.borderDashArray) {
                    if (group.borderDashArray.indexOf("[") != -1 || group.borderDashArray instanceof Array) {
                        dashArray = group.borderDashArray;
                    } else if (group.borderDashArray.indexOf(",") != -1) {
                        var dashArray = group.borderDashArray.split(",");
                    } else if (group.borderDashArray.indexOf(" ") != -1) {
                        var dashArray = group.borderDashArray.split(" ");
                    }
                    if (ctx.setLineDash) {
                        ctx.setLineDash(dashArray);
                    } else if (ctx.mozDash) {
                        ctx.mozDash = dashArray;
                    } else {
                        var style = { dashArray: dashArray };
                    }
                }
            }

            var x = (group.offsetX * canvas._scaleX) - (group.width * canvas._scaleX) * group.pivot.x;
            var y = (group.offsetY * canvas._scaleY) - (group.height * canvas._scaleY) * group.pivot.y;
            if (ej.datavisualization.Diagram.Util.canCrispEdges(group, diagram)) {
                x = Math.floor(x) + 0.5;
                y = Math.floor(y) + 0.5;
            }
            canvas.rect(x, y, group.width * canvas._scaleX, group.height * canvas._scaleY, null, style);
            ctx.restore();
        },

        renderGroup: function (group, canvas, diagram) {
            if (group.visible) {
                var ctx = canvas.document.getContext("2d");
                var rotation = { "angle": group.rotateAngle, x: group.offsetX * canvas._scaleX, y: group.offsetY * canvas._scaleY };
                ctx.save();
                this._renderGroupBackground(group, canvas, diagram);
                for (var i = 0; i < group.children.length; i++) {
                    var child = diagram.nameTable[diagram._getChild(group.children[i])];
                    if (child) {
                        if (child._type === "group") {
                            this.renderGroup(child, canvas, diagram);
                        }
                        else if (child._type === "node") {
                            this.renderNode(child, canvas);
                        }
                        else if (child.segments) {
                            this.renderConnector(child, canvas);
                        }
                    }
                }
                ctx.translate(rotation.x, rotation.y);
                ctx.rotate(rotation.angle * Math.PI / 180);
                ctx.translate(-rotation.x, -rotation.y);
                var x = (group.offsetX * canvas._scaleX) - (group.width * canvas._scaleX) * group.pivot.x;
                var y = (group.offsetY * canvas._scaleY) - (group.height * canvas._scaleY) * group.pivot.y;
                if (!group.isLane) {
                    this.renderLabels(group, canvas);
                    this.renderPorts(group, canvas, x, y);
                }
                if (group.isSwimlane) {
                    diagram._renderCanvasPhase(group, canvas);
                }
                if (group.annotation) {
                    if (group._annotation && group._annotation.length) {
                        for (var n = 0; n < group._annotation.length; n++) {
                            if (diagram.nameTable[group._annotation[n]]) {
                                var element = diagram.nameTable[group._annotation[n]];
                                var type = diagram.getObjectType(element);
                                if (type == "node")
                                    this.renderNode(element, canvas);
                                else if (type == "connector")
                                    this.renderConnector(element, canvas);
                            }
                        }
                    }
                }
                ctx.restore();
            }
        },
        _isExportable: function (node, canvas) {
            var state = true, content;
            if (node.type === "image") {
                try {
                    var canvas = new ej.datavisualization.Diagram.Canvas({ "id": "temp_canvas", "width": 100, "height": 100 });
                    var ctx = canvas.document.getContext("2d");
                    ctx.save();
                    canvas.rect(0, 0, (node.width * canvas._scaleX), (node.height * canvas._scaleY));
                    var image = new Image();
                    image.src = node.source;
                    canvas.image(image, 0, 0, (node.width * canvas._scaleX), (node.height * canvas._scaleY));
                    ctx.restore();
                    content = canvas.document.toDataURL();
                }
                catch (e) {
                    state = false;
                }
            }
            return state;
        },

        _isImageExportable: function (backgroundImage) {
            var state = true, content;
            if (backgroundImage.source) {
                try {
                    var canvas = new ej.datavisualization.Diagram.Canvas({ "id": "temp_canvas", "width": 100, "height": 100 });
                    var ctx = canvas.document.getContext("2d");
                    ctx.save();
                    var image = new Image();
                    image.src = backgroundImage.source;
                    canvas.image(image, 0, 0, 100, 100);
                    ctx.restore();
                    content = canvas.document.toDataURL();
                }
                catch (e) {
                    state = false;
                }
            }
            return state;
        },

        renderNode: function (node, canvas) {
            var ctx = canvas.document.getContext("2d");
            if (node.visible && this._isExportable(node, canvas)) {
                var nodeWidth = node.width || node._width || 0;
                var nodeHeight = node.height || node._height || 0;
                nodeWidth *= canvas._scaleX;
                nodeHeight *= canvas._scaleY;
                var offsetX = node.offsetX * canvas._scaleX;
                var offsetY = node.offsetY * canvas._scaleY;
                var rotation = { "angle": node.rotateAngle, x: offsetX, y: offsetY };
                ctx.save();
                ctx.translate(rotation.x, rotation.y);
                ctx.rotate(rotation.angle * Math.PI / 180);
                ctx.translate(-rotation.x, -rotation.y);
                ctx.save();
                ctx.fillStyle = node.fillColor;
                ctx.strokeStyle = (node.borderColor == "none" || !node.borderWidth) ? "transparent" : node.borderColor;
                ctx.lineWidth = node.borderWidth;
                ctx.globalAlpha = node.opacity;
                var x = offsetX - nodeWidth * node.pivot.x;
                var y = offsetY - nodeHeight * node.pivot.y;
                if (ej.datavisualization.Diagram.Util.canCrispEdges(node, canvas._diagram)) {
                    x = Math.floor(x) + 0.5;
                    y = Math.floor(y) + 0.5
                }
                if (node._shape == "path")
                    this._renderGradient(node, ctx, 0, 0);
                else
                    this._renderGradient(node, ctx, x, y);
                var fill = node.fillColor;
                if (node.constraints & ej.datavisualization.Diagram.NodeConstraints.Shadow) {
                    ctx.save();
                    ctx.strokeStyle = "lightgrey";
                    var t = ej.datavisualization.Diagram.Geometry.transform({ x: 0, y: 0 }, node.shadow.angle, node.shadow.distance);
                    ctx.fillStyle = fill != "none" || fill != "transparent" ? "lightgrey" : "none";
                    switch (node._shape) {
                        case "image":
                        case "rectangle":
                            if (node.cornerRadius)
                                canvas.roundedRect(x + t.x, y + t.y, nodeWidth, nodeHeight, node.cornerRadius, null);
                            else canvas.rect(x + t.x, y + t.y, nodeWidth, nodeHeight, null);
                            break;
                        case "ellipse":
                            canvas.ellipse(x + nodeWidth / 2 + t.x, y + nodeHeight / 2 + t.y, nodeWidth / 2, nodeHeight / 2, null);
                            break;
                        case "path":
                            var absolutePath = node._absolutePath;
                            if (canvas._scaleX !== 1 || canvas._scaleY !== 1)
                                absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(x, y, nodeWidth, nodeHeight, absolutePath, canvas._diagram._svg, null, null);
                            canvas.path(absolutePath, x + t.x, y + t.y, nodeWidth, nodeHeight, null);
                            break;
                        case "polygon":
                            var points = this._updatePolygonPoints(node, canvas);
                            ctx.translate(t.x, t.y);
                            canvas.polygon(points, null, style);
                            break;
                    }
                    ctx.restore();
                }
                if (node.borderDashArray) {
                    if (node.borderDashArray.indexOf("[") != -1 || node.borderDashArray instanceof Array) {
                        dashArray = node.borderDashArray;
                    }
                    else
                        if (node.borderDashArray.indexOf(",") != -1) {
                            var dashArray = node.borderDashArray.split(",");
                        }
                        else if (node.borderDashArray.indexOf(" ") != -1) { var dashArray = node.borderDashArray.split(" "); }
                    if (ctx.setLineDash) {
                        ctx.setLineDash(dashArray);
                    }
                    else if (ctx.mozDash) { ctx.mozDash = dashArray; }
                    else
                    {
                        var style = { dashArray: dashArray };
                    }
                }
                switch (node._shape) {
                    case "rectangle":
                        if (node.cornerRadius)
                            canvas.roundedRect(x, y, nodeWidth, nodeHeight, node.cornerRadius, null, style);
                        else canvas.rect(x, y, nodeWidth, nodeHeight, null, style);
                        break;
                    case "ellipse":
                        canvas.ellipse(x + nodeWidth / 2, y + nodeHeight / 2, nodeWidth / 2, nodeHeight / 2, null, style);
                        break;
                    case "path":
                        var absolutePath = node._absolutePath;
                        if (canvas._scaleX !== 1 || canvas._scaleY !== 1)
                            absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(0, 0, nodeWidth, nodeHeight, absolutePath, canvas._diagram._svg, null, null);
                        canvas.path(absolutePath, x, y, nodeWidth, nodeHeight, null, style);
                        break;
                    case "image":
                        var rotation = { angle: node.rotateAngle, x: offsetX, y: offsetY };
                        canvas.rect(x, y, nodeWidth, nodeHeight, null, style);
                        var image = new Image();
                        image.src = node.source;
                        canvas.image(image, x, y, nodeWidth, nodeHeight, null);
                        break;
                    case "text":
                        canvas.rect(x, y, nodeWidth, nodeHeight, null, style);
                        if (node.textBlock) {
                            var font = "";
                            if (node.textBlock.italic)
                                font += "italic ";
                            if (node.textBlock.bold)
                                font += "bold ";
                            font += node.textBlock.fontSize + " ";
                            font += node.textBlock.fontFamily;
                            ctx.font = font;
                            this._renderTextElement(node, node.textBlock, canvas);
                        }
                        break;
                    case "polygon":
                        var points = this._updatePolygonPoints(node, canvas);
                        canvas.polygon(points, null, style);
                        break;
                    case "native":
                    case "html":
                        diagram._raiseEvent("templateNodeRendering", { element: node, canvas: canvas });
                        break;
                }
                ctx.restore();
                this.renderPorts(node, canvas, x, y);
                if (node.type != "text")
                    this.renderLabels(node, canvas);
                if (node.annotation) {
                    if (node._annotation && node._annotation.length) {
                        for (var n = 0; n < node._annotation.length; n++) {
                            if (diagram.nameTable[node._annotation[n]]) {
                                var element = diagram.nameTable[node._annotation[n]];
                                var type = diagram.getObjectType(element);
                                if (type == "node")
                                    this.renderNode(element, canvas);
                                else if (type == "connector")
                                    this.renderConnector(element, canvas);
                            }
                        }
                    }
                }
                ctx.restore();
            }
        },

        renderPhases: function (phase, canvas, points) {
            var style;
            if (phase && canvas) {
                var ctx = canvas.document.getContext("2d");
                ctx.save();
                ctx.strokeStyle = phase.lineColor ? phase.lineColor : "black";
                ctx.lineWidth = phase.lineWidth ? phase.lineWidth : 1;
                if (phase.lineDashArray) {
                    if (phase.lineDashArray.indexOf("[") != -1 || phase.lineDashArray instanceof Array) {
                        dashArray = phase.lineDashArray;
                    }
                    else {
                        if (phase.lineDashArray.indexOf(",") != -1) {
                            var dashArray = phase.lineDashArray.split(",");
                        }
                        else if (phase.lineDashArray.indexOf(" ") != -1) { var dashArray = phase.lineDashArray.split(" "); }
                    }

                    if (ctx.setLineDash) { ctx.setLineDash(dashArray); }
                    else if (ctx.mozDash) { ctx.mozDash = dashArray; }
                    else
                        style = { "dashArray": dashArray }
                }
                if (points && points.length > 0) {
                    canvas.line(points[0], points[1], style);
                }
            }
            ctx.restore();
        },

        renderConnector: function (connector, canvas) {
            if (connector.visible) {
                var ctx = canvas.document.getContext("2d");
                ctx.save();
                ctx.strokeStyle = connector.lineColor;
                ctx.lineWidth = connector.lineWidth;
                if (connector.lineDashArray) {
                    if (connector.lineDashArray.indexOf("[") != -1 || connector.lineDashArray instanceof Array) {
                        dashArray = connector.lineDashArray;
                    }
                    else {
                        if (connector.lineDashArray.indexOf(",") != -1) {
                            var dashArray = connector.lineDashArray.split(",");
                        }
                        else if (connector.lineDashArray.indexOf(" ") != -1) { var dashArray = connector.lineDashArray.split(" "); }
                    }
                    if (ctx.setLineDash) { ctx.setLineDash(dashArray); }
                    else if (ctx.mozDash) { ctx.mozDash = dashArray; }
                    else
                        var style = { "dashArray": dashArray }
                }
                if (connector.segments) {
                    this._renderSegments(connector, canvas, style);
                }
                ctx.restore();
                this._renderDecorators(connector, canvas);
                this.renderLabels(connector, canvas);
                if (connector.shape) {
                    for (var i = 0; i < connector._inlineDecorators.length; i++)
                        this.renderNode(connector._inlineDecorators[i], canvas)
                }
            }
        },

        _renderSegments: function (connector, canvas, style) {
            for (var i = 0; i < connector.segments.length; i++) {
                var segment = connector.segments[i];
                if (segment._bridges.length > 0) {
                    for (var n = 0; n < segment._bridges.length; n++) {
                        var bridge = segment._bridges[n];
                        bridge._rendered = false;
                    }
                }
                var points = segment.points;
                var diagram = canvas._diagram;
                if (i == 0) {
                    if (diagram && connector.sourceNode) var node = diagram._findNode(connector.sourceNode);
                    points = ej.datavisualization.Diagram.SvgContext._clipDecorators(connector, segment, true, node);
                    if (segment.type == "bezier" && connector.sourceDecorator && connector.sourceDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                        points[0] = ej.datavisualization.Diagram.Util._adjustPoint(points[0], segment._point1, true, connector.lineWidth);
                    }
                    var startPoint = points[0];
                    var starting = true;
                }
                else starting = false;
                if (i == connector.segments.length - 1) {
                    if (diagram && connector.targetNode) var node = diagram._findNode(connector.targetNode);
                    points = ej.datavisualization.Diagram.SvgContext._clipDecorators(connector, segment, false, node);
                    if (startPoint && connector.segments.length < 2) {
                        points[0] = startPoint; startPoint = null;
                    }
                    var ending = true;
                }
                if (connector.shape && connector.shape.flow == "sequence" && connector.shape.sequence == "default" && i == 0) {
                    var beginningpoint = { x: segment.points[0].x, y: segment.points[0].y };
                    var distance = ej.datavisualization.Diagram.Geometry.distance(segment.points[0], segment.points[1]);
                    distance = Math.min(30, distance / 2);
                    var angle = ej.datavisualization.Diagram.Geometry.findAngle(segment.points[0], segment.points[1]);
                    var transferpoint = ej.datavisualization.Diagram.Geometry.transform({ x: beginningpoint.x, y: beginningpoint.y }, angle, distance);
                    var startpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: transferpoint.x, y: transferpoint.y }, angle + 135, -12);
                    var endpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: startpoint1.x, y: startpoint1.y }, angle + 135, 12 * 2);
                }
                if (connector.shape && connector.shape.flow == "sequence" && connector.shape.sequence == "default" && i == 0) {
                    var beginningpoint = { x: segment.points[0].x, y: segment.points[0].y };
                    var distance = ej.datavisualization.Diagram.Geometry.distance(segment.points[0], segment.points[1]);
                    distance = Math.min(30, distance / 2);
                    var angle = ej.datavisualization.Diagram.Geometry.findAngle(segment.points[0], segment.points[1]);
                    var transferpoint = ej.datavisualization.Diagram.Geometry.transform({ x: beginningpoint.x, y: beginningpoint.y }, angle, distance);
                    var startpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: transferpoint.x, y: transferpoint.y }, angle + 135, -12);
                    var endpoint1 = ej.datavisualization.Diagram.Geometry.transform({ x: startpoint1.x, y: startpoint1.y }, angle + 135, 12 * 2);
                }
                if (segment.type == "bezier") {
                    var startPoint = points[0];
                    var endPoint = segment._endPoint;
                    if (connector.targetDecorator && connector.targetDecorator.shape !== ej.datavisualization.Diagram.DecoratorShapes.None) {
                        endPoint = ej.datavisualization.Diagram.Util._adjustPoint(segment._endPoint, segment._point2, true, connector.lineWidth);
                    }
                    canvas.bezierCurve(startPoint, segment._point1, segment._point2, endPoint, style);
                }
                else {
                    if (connector.cornerRadius > 0) {
                        var st, end;
                        for (var j = 0; j < points.length - 1; j++) {
                            var segLength = ej.datavisualization.Diagram.Geometry.distance(points[j], points[j + 1]);
                            if (segLength > 0) {
                                var endpoint = end || st;
                                if (i < connector.segments.length - 1 || j < points.length - 2) {
                                    if (segLength < connector.cornerRadius * 2) {
                                        end = this._adjustPoint(points[j], points[j + 1], false, segLength / 2);
                                    }
                                    else end = this._adjustPoint(points[j], points[j + 1], false, connector.cornerRadius);
                                }
                                else end = points[j + 1];

                                if (i > 0 || j > 0) {
                                    if (segLength < connector.cornerRadius * 2) {
                                        st = this._adjustPoint(points[j], points[j + 1], true, segLength / 2);
                                        if (i < connector.segments.length - 1 || j < points.length - 2)
                                            end = null;
                                    }
                                    else st = this._adjustPoint(points[j], points[j + 1], true, connector.cornerRadius);
                                }

                                if (endpoint && st) {
                                    canvas.quadraticCurve(endpoint, points[j], st, style);
                                }
                                else st = points[j];
                                if (segment._bridges.length > 0) {
                                    this._updateBridging(segment, canvas, j + 1, st ? st : points[j], end ? end : points[j + 1], connector.bridgeSpace, style,
                                        starting && k == 1 ? true : false, ending && k == points.length - 1 ? true : false);
                                }
                                if (end) {
                                    if (!(segment._bridges.length > 0)) {
                                        canvas.line(st, end, style);
                                    }
                                }
                            }
                        }
                    }
                    else {
                        for (var k = 1; k < points.length; k++) {
                            if (segment._bridges.length > 0) {
                                this._updateBridging(segment, canvas, k, points[k - 1], points[k], connector.bridgeSpace, style,
                                    starting && k == 1 ? true : false, ending && k == points.length - 1 ? true : false);
                            }
                            else {
                                canvas.line(this._scalePointforStretch(points[k - 1], canvas, connector), this._scalePointforStretch(points[k], canvas, connector), style,
                                    starting && k == 1 ? false : true, ending && k == points.length - 1 ? false : true);
                            }
                        }
                    };
                }
            }
            if (connector.shape && connector.shape.flow == "sequence" && connector.shape.sequence == "default") {
                canvas.line(this._scalePointforStretch(startpoint1, canvas, connector), this._scalePointforStretch(endpoint1, canvas, connector), style);
            }
        },

        _scalePointforStretch: function (pt, canvas, connector) {
            var tempPt = { x: pt.x, y: pt.y };
            if (connector && ej.datavisualization.Diagram.Util.canCrispEdges(connector, canvas._diagram)) {
                tempPt.x = Math.floor(tempPt.x);
                tempPt.y = Math.floor(tempPt.y);
            }
            tempPt.x *= canvas._scaleX;
            tempPt.y *= canvas._scaleY;
            return tempPt;
        },

        _updateBridging: function (seg, canvas, pointIndex, startPt, endPt, bridgeSpace, style, start, end) {
            var bridgeSP;
            var angle = this._findAngle(startPt, endPt);
            var bridgeDirection = canvas._diagram.bridgeDirection();
            if (seg._bridges.length > 0) {
                if (seg.type === "straight") {
                    for (var n = 0; n < seg._bridges.length; n++) {
                        var bridge = seg._bridges[n];
                        if (!bridge._rendered) {
                            bridgeSP = seg._bridges[n - 1] != null && seg._bridges[n - 1].segmentPointIndex == bridge.segmentPointIndex ? seg._bridges[n - 1].endPoint : startPt;
                            canvas.line(bridgeSP, bridge.startPoint, style, !(start || n == 0), true);
                            var centerX = bridge.startPoint.x + ((bridge.endPoint.x - bridge.startPoint.x) / 2);
                            var centerY = bridge.startPoint.y + ((bridge.endPoint.y - bridge.startPoint.y) / 2);
                            var sweep = ej.datavisualization.Diagram.Util.sweepDirection(angle, bridgeDirection, null, canvas._diagram);
                            canvas.arc(centerX, centerY, bridgeSpace / 2, angle, sweep, style);
                            if (seg._bridges[n + 1] != null && seg._bridges[n + 1].segmentPointIndex == bridge.segmentPointIndex)
                                canvas.line(bridge.endPoint, seg._bridges[n + 1].startPoint, style, false);
                            else
                                canvas.line(bridge.endPoint, endPt, style, false, !end);
                            bridge._rendered = true;
                        }
                    }
                }
                else if (seg.type === "orthogonal") {
                    var ept = startPt;
                    for (var n = 0; n < seg._bridges.length; n++) {
                        var bridge = seg._bridges[n];
                        if (bridge.segmentPointIndex === pointIndex && !bridge._rendered) {
                            bridgeSP = seg._bridges[n - 1] != null && seg._bridges[n - 1].segmentPointIndex == bridge.segmentPointIndex ? seg._bridges[n - 1].endPoint : startPt;
                            canvas.line(bridgeSP, bridge.startPoint, style, !(start || n == 0), true);
                            var centerX = bridge.startPoint.x + ((bridge.endPoint.x - bridge.startPoint.x) / 2);
                            var centerY = bridge.startPoint.y + ((bridge.endPoint.y - bridge.startPoint.y) / 2);
                            var sweep = ej.datavisualization.Diagram.Util.sweepDirection(angle, bridgeDirection, null, canvas._diagram);
                            canvas.arc(centerX, centerY, bridgeSpace / 2, angle, sweep, style);
                            if (seg._bridges[n + 1] != null && seg._bridges[n + 1].segmentPointIndex == bridge.segmentPointIndex)
                                canvas.line(bridge.endPoint, seg._bridges[n + 1].startPoint, style, false);
                            else
                                ept = bridge.endPoint;
                            bridge._rendered = true;
                        }
                    }
                    canvas.line(ept, endPt, style, false, !end);
                }
            }
        },

        _findAngle: function (startPt, endPt) {
            var xDiff = startPt.x - endPt.x; var yDiff = startPt.y - endPt.y;
            return Math.atan2(yDiff, xDiff) * (180 / Math.PI);
        },

        _adjustPoint: function (source, target, isStart, length) {
            var pt = isStart ? { x: source.x, y: source.y } : { x: target.x, y: target.y };
            if (source.x == target.x) {
                if (source.y < target.y && isStart || source.y > target.y && !isStart)
                    pt.y += length;
                else pt.y -= length;
            }
            else if (source.y == target.y) {
                if (source.x < target.x && isStart || source.x > target.x && !isStart)
                    pt.x += length;
                else pt.x -= length;
            }
            else {
                var angle;
                if (isStart) {
                    angle = ej.datavisualization.Diagram.Geometry.findAngle(source, target);
                    pt = ej.datavisualization.Diagram.Geometry.transform(source, angle, length);
                }
                else {
                    angle = ej.datavisualization.Diagram.Geometry.findAngle(target, source);
                    pt = ej.datavisualization.Diagram.Geometry.transform(target, angle, length);
                }
            }
            return pt;
        },

        renderLabels: function (node, canvas) {
            for (var i = 0; i < node.labels.length; i++) {
                var label = node.labels[i];
                var ctx = canvas.document.getContext("2d");
                ctx.save();
                ctx.globalAlpha = label.opacity;
                ctx.lineWidth = label.borderWidth;
                ctx.strokeStyle = label.borderColor;
                if (label.text && label.visible)
                    this._renderTextElement(node, label, canvas);
                ctx.restore();
            }
        },

        renderPorts: function (node, canvas, x, y) {
            var ctx = canvas.document.getContext("2d");
            for (var i = 0; i < node.ports.length; i++) {
                var port = node.ports[i];
                if (!(port.visibility & ej.datavisualization.Diagram.PortVisibility.Hidden || port.visibility & ej.datavisualization.Diagram.PortVisibility.Hover || port.visibility & ej.datavisualization.Diagram.PortVisibility.Connect)) {
                    var point = ej.datavisualization.Diagram.Util._getPortPosition(port, ej.datavisualization.Diagram.Util.bounds(node, true));
                    point = this._scalePointforStretch(point, canvas);
                    var portSize = port.size * canvas._scaleY;
                    ctx.fillStyle = port.fillColor;
                    ctx.strokeStyle = port.borderColor;
                    ctx.lineWidth = port.borderWidth;
                    switch (port.shape) {
                        case "x":
                            ctx.beginPath();
                            ctx.moveTo((point.x - portSize / 2), (point.y - portSize / 2));
                            ctx.lineTo((point.x + portSize / 2), (point.y + portSize / 2));
                            ctx.moveTo((point.x + portSize / 2), (point.y - portSize / 2));
                            ctx.lineTo((point.x - portSize / 2), (point.y + portSize / 2));
                            ctx.stroke();
                            ctx.fill();
                            ctx.closePath();
                            break;
                        case "circle":
                            var rx = portSize / 2;
                            var ry = portSize / 2;
                            canvas.ellipse(point.x, point.y, rx, ry);
                            break;
                        case "square":
                            canvas.rect(point.x - portSize / 2, point.y - portSize / 2, portSize, portSize);
                            break;
                        case "path":
                            ctx.save();
                            if (node._type == "group") {
                                ctx.translate(offsetX, node.offsetY);
                                ctx.rotate(-node.rotateAngle * Math.PI / 180);
                                ctx.translate(-offsetX, -node.offsetY);
                                var rotation;
                                if (node.rotateAngle)
                                    rotation = { angle: node.rotateAngle, x: port._absolutePoint.x, y: port._absolutePoint.y };
                                var absolutePath = port._absolutePath;
                                if (canvas._scaleX !== 1 || canvas._scaleY !== 1)
                                    absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(port._absolutePoint.x, port._absolutePoint.y, portSize, portSize, absolutePath, canvas._diagram._svg, null, null);
                                canvas.path(absolutePath, 0, 0, portSize, portSize, rotation);
                            }
                            else {
                                x = point.x - node.width * port.offset.x;
                                y = point.y - node.height * port.offset.y;
                                var absolutePath = port._absolutePath;
                                if (canvas._scaleX !== 1 || canvas._scaleY !== 1)
                                    absolutePath = ej.datavisualization.Diagram.Geometry.updatePath(x, y, portSize, portSize, absolutePath, canvas._diagram._svg, null, null);
                                canvas.path(absolutePath, x, y, portSize, portSize, rotation);
                            }
                            ctx.restore();
                    }
                }
            }
        },

        _renderTextElement: function (node, textElement, canvas) {
            if (textElement) {
                var text = { childNodes: [] };
                var ctx = canvas.document.getContext("2d");
                ctx.save();
                var font = "";
                if (textElement.italic)
                    font += "italic ";
                if (textElement.bold)
                    font += "bold ";
                font += (textElement.fontSize * canvas._scaleY) + "px ";
                font += textElement.fontFamily;
                ctx.font = font;
                var bounds = this._wrapText(node, text, textElement, canvas);
                this._alignTextOnLabel(textElement, node, text, canvas, bounds);
                ctx.restore();
            }
        },

        _alignTextOnLabel: function (label, node, text, canvas, labelBounds) {
            var nodeWidth = node.width || node._width || 0;
            var nodeHeight = node.height || node._height || 0;
            nodeWidth *= canvas._scaleX;
            nodeHeight *= canvas._scaleY;
            var bounds = { "width": labelBounds && labelBounds.width || label.width, "height": text.childNodes.length * (label.fontSize * canvas._scaleY) };
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            nodeBounds.width *= canvas._scaleX;
            nodeBounds.height *= canvas._scaleY;
            nodeBounds.x *= canvas._scaleX;
            nodeBounds.y *= canvas._scaleY;
            var offset, hAlign, vAlign;
            var diagram = canvas._diagram;
            if (node.segments && label.relativeMode == "segmentpath") {
                var obj = ej.datavisualization.Diagram.SvgContext._getConnectorHandlePosition(label, node, 1, diagram);
                var pt = this._scalePointforStretch(obj.position, canvas);
                offset = {
                    x: (pt.x - nodeBounds.x) / nodeBounds.width,
                    y: (pt.y - nodeBounds.y) / nodeBounds.height
                };
                var alignment = ej.datavisualization.Diagram.Util._alignLabelOnSegments(node, label, diagram, obj);
                vAlign = alignment.vAlign; hAlign = alignment.hAlign;
            }
            else {
                hAlign = label.horizontalAlignment;
                vAlign = label.verticalAlignment;
            }
            offset = ej.datavisualization.Diagram.Util._getLabelPosition(label, nodeBounds, offset);
            var point = { x: 0, y: 0 }, tempPt = { x: offset.x, y: offset.y };
            var y = 0;
            if (vAlign == ej.datavisualization.Diagram.VerticalAlignment.Top)
                y = offset.y + bounds.height / 2;
            else if (vAlign == ej.datavisualization.Diagram.VerticalAlignment.Center || vAlign == ej.datavisualization.Diagram.VerticalAlignment.Stretch)
                y = offset.y;
            else
                y = offset.y - bounds.height / 2;
            point.y = y;
            point.x = offset.x;
            tempPt.y = y;
            var ctx = canvas.document.getContext("2d");
            if (label.textAlign == "justify") {
                if (text.childNodes.length > 1) {
                    ctx.textAlign = "left";
                    bounds.width = nodeWidth - 2 * label.borderWidth;
                }
                else ctx.textAlign = "center";
            } else {
                ctx.textAlign = label.textAlign;
            }
            switch (hAlign) {
                case ej.datavisualization.Diagram.HorizontalAlignment.Left:
                    tempPt.x = offset.x + bounds.width / 2;
                    switch (ctx.textAlign) {
                        case ej.datavisualization.Diagram.TextAlign.Left:
                            point.x = offset.x;
                            break;
                        case ej.datavisualization.Diagram.TextAlign.Center:
                            point.x = offset.x + bounds.width / 2;
                            break;
                        case ej.datavisualization.Diagram.TextAlign.Right:
                            point.x = offset.x + bounds.width;
                            break;
                    }
                    break;
                case ej.datavisualization.Diagram.HorizontalAlignment.Center:
                    tempPt.x = offset.x;
                    switch (ctx.textAlign) {
                        case ej.datavisualization.Diagram.TextAlign.Left:
                            point.x = offset.x - bounds.width / 2;
                            break;
                        case ej.datavisualization.Diagram.TextAlign.Center:
                            point.x = offset.x;
                            break;
                        case ej.datavisualization.Diagram.TextAlign.Right:
                            point.x = offset.x + bounds.width / 2;
                            break;
                    }
                    break;
                case ej.datavisualization.Diagram.HorizontalAlignment.Right:
                    tempPt.x = offset.x - bounds.width / 2;
                    switch (ctx.textAlign) {
                        case ej.datavisualization.Diagram.TextAlign.Left:
                            point.x = offset.x - bounds.width;
                            break;
                        case ej.datavisualization.Diagram.TextAlign.Center:
                            point.x = offset.x - bounds.width / 2;
                            break;
                        case ej.datavisualization.Diagram.TextAlign.Right:
                            point.x = offset.x;
                            break;
                    }
                    break;
                case ej.datavisualization.Diagram.HorizontalAlignment.Stretch:
                    tempPt.x = offset.x;
                    point.x = offset.x;
                    break;
            }
            var rotation, labelX = nodeBounds.x, labelY = nodeBounds.y;
            if (!node.segments) {
                labelX = (node.offsetX * canvas._scaleX) - nodeWidth * node.pivot.x;
                labelY = (node.offsetY * canvas._scaleY) - nodeHeight * node.pivot.y;
            }

            var bWidth = label.borderWidth || 0;
            var x = labelX + point.x + (labelBounds ? labelBounds.x : 0) - bWidth / 2;
            var y = labelY + point.y - bounds.height / 2 - bWidth / 2;
            if (label.verticalAlignment == "stretch") {
                canvas.rect(x, nodeBounds.y, bounds.width + bWidth, nodeBounds.height + bWidth, null,
                    { fill: label.fillColor && !node._isHeader ? label.fillColor : "transparent", stroke: (bWidth && !node._isHeader) ? (label.borderColor || "transparent") : "transparent", lineWidth: bWidth });
            }
            else
                canvas.rect(x, y, bounds.width + bWidth, bounds.height + bWidth, null,
                    { fill: label.fillColor ? label.fillColor : "transparent", stroke: bWidth ? (label.borderColor || "transparent") : "transparent", lineWidth: bWidth });

            rotation = { "angle": label.rotateAngle, x: labelX + tempPt.x, y: labelY + tempPt.y };
            if (label.textAlign == "justify") {
                var labelWidth = Math.max(nodeWidth, label.width) - 2 * label.borderWidth;
            }
            ctx.save();
            ctx.translate(rotation.x, rotation.y);
            ctx.rotate(rotation.angle * Math.PI / 180);
            ctx.translate(-rotation.x, -rotation.y);
            for (var i = 0; i < text.childNodes.length; i++) {
                var child = text.childNodes[i];
                var text_x = x + child.x - labelBounds.x + bWidth / 2;
                var text_y = y + child.dy * i + ((label.fontSize * canvas._scaleY) * 0.8) + bWidth / 2;
                var width = ctx.measureText(child.text).width;
                if (labelWidth > width && i < text.childNodes.length - 1) {
                    var txt = child.text;
                    if (txt[txt.length - 1] == " ") { txt = txt.slice(0, txt.length - 1); } if (txt[0] == " ") { txt = txt.slice(1, txt.length); }
                    width = ctx.measureText(txt).width;
                    var words = txt.split(" ");
                    if (words.length > 1) {
                        var extra = (((labelWidth - width) / ctx.measureText(" ").width) / (words.length - 1));
                        extra = Math.round(extra);
                        var extText = "";
                        for (var k = 0; k < extra; k++) {
                            extText += " ";
                        }
                        child.text = txt.replace(" ", extText);
                    }
                }
                if (label.horizontalAlignment == "stretch") {
                    switch (label.textAlign) {
                        case "left":
                            child.x = offset.x - bounds.width / 2;
                            break;
                        case "center":
                            child.x = -bounds.width / 2;
                            break;
                        case "right":
                            child.x = -offset.x - bounds.width / 2;
                            break;
                    }
                }
                canvas.text({ text: child.text }, text_x - child.x, text_y, null, { fill: label.fontColor });
                if (label.textDecoration != "none")
                    this._renderTextDecoration(text_x - child.x, text_y, ctx.measureText(child.text).width, label, canvas);
            }
            ctx.restore();
        },

        _wrapText: function (node, text, label, canvas) {
            var str = label.text; var attr = null;
            if (label.rotateAngle != undefined) {
                if (canvas && canvas._diagram) {
                    var lane = canvas._diagram.nameTable[node.parent];
                    if (lane && lane.isLane && label.rotateAngle !== 0) {
                        var textBBox = ej.datavisualization.Diagram.Util.bounds(node);
                        var width = textBBox.width;
                        textBBox.width = textBBox.height;
                        textBBox.height = width;
                    }
                    else
                        var textBBox = ej.datavisualization.Diagram.Util.bounds(node);
                }
                else
                    var textBBox = ej.datavisualization.Diagram.Util.bounds(node);
            }
            else var textBBox = ej.datavisualization.Diagram.Util.bounds(node);
            textBBox.width *= canvas._scaleX;
            textBBox.height *= canvas._scaleY;
            textBBox.x *= canvas._scaleX;
            textBBox.y *= canvas._scaleY;
            var bbWidth, bbHeight;
            if (node.segments) {
                bbWidth = textBBox.width;
                bbHeight = textBBox.height;
            }
            else {
                bbWidth = textBBox.width - label.margin.left - label.margin.right;
                bbHeight = textBBox.height - label.margin.top - label.margin.bottom;
            }
            bbWidth -= 2 * (label.borderWidth ? label.borderWidth : 1);
            bbWidth = bbWidth < label.width ? label.width : bbWidth;
            var eachLine = str.split('\n');
            var x, y, tspan, j, string = "", childNodes, bounds, i;
            var ctx = canvas.document.getContext("2d");
            var wrap = label.wrapping == "wrapwithoverflow" ? true : false;
            for (j = 0; j < eachLine.length; j++) {
                var txt = "";
                if (label.wrapping != "nowrap") {
                    var words = label.wrapping == "wrapwithoverflow" ? eachLine[j].split(" ") : eachLine[j];
                    for (i = 0; i < words.length; i++) {
                        txt += ((txt && wrap) ? " " : "") + words[i];
                        bounds = ctx.measureText(txt).width;
                        if (bounds >= bbWidth) {
                            text.childNodes[text.childNodes.length] = { text: txt };
                            txt = "";
                        }
                        else {
                            if (wrap) {
                                var newText = txt + " " + (words[i + 1] || "");
                                if (ctx.measureText(newText).width > bbWidth) {
                                    text.childNodes[text.childNodes.length] = { text: txt };
                                    txt = "";
                                }
                            }
                            if (i == words.length - 1) {
                                text.childNodes[text.childNodes.length] = { text: txt };
                                txt = "";
                            }
                        }
                    }

                }
                else {
                    txt += eachLine[j];
                    text.childNodes[text.childNodes.length] = { text: txt };
                }

            }
            return this._wrapTextAlign(text, text.childNodes, (label.fontSize * canvas._scaleY), label.textAlign, ctx, node, label, canvas);
        },

        _wrapTextAlign: function (text, childNodes, height, textAlign, ctx, node, label, canvas) {
            var width, bounds;
            var nodeBounds = ej.datavisualization.Diagram.Util.bounds(node);
            nodeBounds.width *= canvas._scaleX;
            nodeBounds.height *= canvas._scaleY;
            nodeBounds.x *= canvas._scaleX;
            nodeBounds.y *= canvas._scaleY;
            for (var i = 0; i < childNodes.length; i++) {
                var x = ctx.measureText(childNodes[i].text).width;
                width = x;
                if (label.horizontalAlignment == "stretch") {
                    width = nodeBounds.width;
                    x = -width / 2;
                }
                else
                    switch (textAlign) {
                        case "left":
                            x = 0;
                            break;
                        case "center":
                            x = -x / 2;
                            break;
                        case "right":
                            x = -x;
                            break;
                        case "justify":
                            x = childNodes.length > 1 ? 0 : -x / 2;
                            break;
                    }
                childNodes[i].x = Number(x);
                childNodes[i].dy = height;
                if (!bounds) {
                    bounds = {
                        x: x,
                        width: width
                    };
                } else {
                    bounds.x = Math.min(bounds.x, x);
                    bounds.width = Math.max(bounds.width, width);
                }
            }
            return bounds;
        },

        _renderTextDecoration: function (x, y, width, label, canvas) {
            var ctx = canvas.document.getContext("2d");
            ctx.save();
            ctx.strokeStyle = label.fontColor;
            ctx.lineWidth = 1;
            switch (ctx.textAlign) {
                case "center":
                    x -= (width / 2); break;
                case "right":
                    x -= width; break;
            }
            y += 2;
            switch (label.textDecoration) {
                case "overline":
                    y -= (label.fontSize * canvas._scaleY); break;
                case "line-through":
                    y -= (label.fontSize / 2 * canvas._scaleY); break;
            }
            var stPt = { x: x, y: y };
            var edPt = { x: x + width, y: y };
            canvas.line(stPt, edPt, null);
            ctx.restore();
        },

        _renderGradient: function (node, ctx, x, y) {
            if (node.gradient) {
                var max, min;
                for (var i = 0; i < node.gradient.stops.length; i++) {
                    max = !max ? node.gradient.stops[i].offset : Math.max(max, node.gradient.stops[i].offset);
                    min = !min ? node.gradient.stops[i].offset : Math.min(min, node.gradient.stops[i].offset);
                }
                if (node.gradient.type == "linear") {
                    var grd = ctx.createLinearGradient(x + node.gradient.x1, y + node.gradient.y1, x + node.gradient.x2, y + node.gradient.y2);
                    for (var i = 0; i < node.gradient.stops.length; i++) {
                        var stop = node.gradient.stops[i];
                        var offset = min < 0 ? (max + stop.offset) / (2 * max) : stop.offset / max;
                        grd.addColorStop(offset, stop.color);
                    }
                }
                else if (node.gradient.type == "radial") {
                    var grd = ctx.createRadialGradient(x + node.gradient.fx, y + node.gradient.fy, 0, x + node.gradient.cx, y + node.gradient.cy, node.gradient.r);
                    for (var i = 0; i < node.gradient.stops.length; i++) {
                        var stop = node.gradient.stops[i];
                        var offset = min < 0 ? (max + stop.offset) / (2 * max) : stop.offset / max;
                        grd.addColorStop(offset, stop.color);
                    }
                }
                ctx.fillStyle = grd;
            }
        },

        _renderDecorators: function (connector, canvas) {
            var startPoint;
            var endPoint;
            var diagram = canvas._diagram;
            if (connector.targetDecorator && connector.targetDecorator.shape) {
                var segment = connector.segments[connector.segments.length - 1];
                startPoint = segment.points[segment.points.length - 2];
                endPoint = connector.targetPoint;
                if (segment.type == "bezier") {
                    startPoint = segment._point2;
                }
                if (connector.targetNode && diagram) {
                    var targetNode = diagram._findNode(connector.targetNode);
                    if (targetNode && targetNode.borderColor != "none")
                        endPoint = ej.datavisualization.Diagram.Util._adjustPoint(endPoint, startPoint, true, targetNode.borderWidth / 2);
                }
                this._renderDecorator(connector.name + "_targetDecorator", endPoint,
                    startPoint, connector.targetDecorator, canvas);
            }
            if (connector.sourceDecorator && connector.sourceDecorator.shape) {
                var segment = connector.segments[0];
                startPoint = connector.sourcePoint;
                endPoint = segment.points[1];
                if (segment.type == "bezier") {
                    endPoint = segment._point1;
                }
                if (connector.sourceNode && diagram) {
                    var sourceNode = diagram._findNode(connector.sourceNode);
                    if (sourceNode && sourceNode.borderColor != "none")
                        startPoint = ej.datavisualization.Diagram.Util._adjustPoint(startPoint, endPoint, true, sourceNode.borderWidth / 2);
                }
                this._renderDecorator(connector.name + "_sourceDecorator", startPoint,
                    endPoint, connector.sourceDecorator, canvas);
            }
        },

        _renderDecorator: function (name, point1, point2, decorator, canvas) {
            var shape;
            var attr;
            var d;
            var scalePoint1 = this._scalePointforStretch(point1, canvas);
            var scalePoint2 = this._scalePointforStretch(point2, canvas);
            var size = new ej.datavisualization.Diagram.Size(Number(decorator.width * canvas._scaleY), Number(decorator.height * canvas._scaleY));
            var ctx = canvas.document.getContext("2d");
            ctx.fillStyle = decorator.fillColor;
            ctx.strokeStyle = decorator.borderColor == "none" ? "transparent" : decorator.borderColor;
            ctx.lineWidth = decorator.borderWidth;
            var angle = ej.datavisualization.Diagram.Geometry.findAngle(scalePoint1, scalePoint2);
            var rotation = { angle: angle, x: scalePoint1.x, y: scalePoint1.y };
            switch (decorator.shape) {
                case "arrow":
                    canvas.arrow(scalePoint1, rotation, size);
                    break;
                case "openarrow":
                    canvas.arrow(scalePoint1, rotation, size, true);
                    break;
                case "circle":
                    var rx = size.width / 2;
                    var ry = size.height / 2;
                    canvas.ellipse(scalePoint1.x + size.width / 2, scalePoint1.y, rx, ry, rotation);
                    break;
                case "diamond":
                    canvas.diamond(scalePoint1, rotation, size);
                    break;
                case "path":
                    canvas.path(decorator._absolutePath, 0, 0, size.width, size.height, rotation);
                    break;
            }
            return shape;
        },

        _updatePolygonPoints: function (node, canvas) {
            var points = [];
            if (node.points) {
                var nodeWidth = node.width || node._width || 0;
                var nodeHeight = node.height || node._height || 0;
                nodeWidth *= canvas._scaleX;
                nodeHeight *= canvas._scaleY;
                for (var i = 0; i < node.points.length; i++) {
                    var point1 = node.points[i];
                    points.push({ x: point1.x, y: point1.y });
                }
                if (points.length) {
                    this._scalePoints(points, node, canvas);
                    var bounds = ej.datavisualization.Diagram.Geometry.rect(points);
                    var x = (node.offsetX * canvas._scaleX) - nodeWidth * node.pivot.x - bounds.x;
                    var y = (node.offsetY * canvas._scaleY) - nodeHeight * node.pivot.y - bounds.y;
                    for (var i = 0, len = points.length; i < len; ++i) {
                        var point = ej.datavisualization.Diagram.Geometry.translate(points[i], x, y);
                        points[i] = point;
                    }
                }
            }
            return points;
        },

        _scalePoints: function (points, node, canvas) {
            var bounds = ej.datavisualization.Diagram.Geometry.rect(points);
            if (bounds.width > 0 && bounds.height > 0) {
                var nodeWidth = node.width || node._width || 0;
                var nodeHeight = node.height || node._height || 0;
                nodeWidth *= canvas._scaleX;
                nodeHeight *= canvas._scaleY;
                var scaleX = nodeWidth / bounds.width;
                var scaleY = nodeHeight / bounds.height;
                for (var i = 0, len = points.length; i < len; ++i) {
                    points[i].x = points[i].x * scaleX;
                    points[i].y = points[i].y * scaleY;
                }
            }
        },

        updateNode: function (model, canvas) {
            this.refreshCanvas(model, canvas);
        },

        updateConnector: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateGroup: function (model, canvas) { this.refreshCanvas(model, canvas); },

        refreshCanvas: function (model, canvas) {

            var ctx = canvas.document.getContext("2d");
            ctx.save();
            if (view.scale) {
                ctx.scale(1 / view.scale.x, 1 / view.scale.y);
            }
            var bounds = { x: canvas.document.offsetLeft, y: canvas.document.offsetTop, width: canvas.document.offsetWidth, height: canvas.document.offsetHeight };
            ctx.clearRect(bounds.x, bounds.y, bounds.width, bounds.height);
            if (view.scale) {
                ctx.scale(view.scale.x, view.scale.y);
            }
            ctx.restore();
            for (var i = 0; i < model.nodes.length; i++) {
                if (model.nodes[i]._type === "node")
                    this.renderNode(model.nodes[i], canvas);
                else if (model.nodes[i]._type === "group")
                    this.renderGroup(model.nodes[i], canvas);
            }
            for (var i = 0; i < model.connectors.length; i++) {
                this.renderConnector(model.connectors[i], canvas);
            }
        },

        updateViewport: function (diagram) {
            //diagram._scroller._updateViewPort();
            //diagram.model.pageSettings._updatePageSize(diagram, true);
        },

        addNodeLabel: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateLabel: function (model, canvas) { this.refreshCanvas(model, canvas); },

        setNodeShape: function (model, canvas) { this.refreshCanvas(model, canvas); },

        setLine: function (model, canvas) { this.refreshCanvas(model, canvas); },

        renderDecorators: function (model, canvas) { this.refreshCanvas(model, canvas); },

        clearDecorators: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateTargetDecoratorStyle: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateSourceDecoratorStyle: function (model, canvas) { this.refreshCanvas(model, canvas); },

        _updateNodeStyle: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateLabelStyle: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateConnectorStyle: function (model, canvas) { this.refreshCanvas(model, canvas); },

        updateTextBlock: function (model, label, canvas) { this.refreshCanvas(model, canvas); },

        removeChild: function (element, view, diagram) {
            this.refreshCanvas(model, canvas);
        }
    };
    //#endregion

})(jQuery, Syncfusion);;
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ejSparkline;
(function (ejSparkline) {
    (function (Type) {
        Type[Type["Line"] = "line"] = "Line";
        Type[Type["Column"] = "column"] = "Column";
        Type[Type["Area"] = "area"] = "Area";
        Type[Type["WinLoss"] = "winloss"] = "WinLoss";
        Type[Type["Pie"] = 'pie'] = "Pie";
    })(ejSparkline.Type || (ejSparkline.Type = {}));
    var Type = ejSparkline.Type;
    (function (Themes) {
        Themes[Themes["flatlight"] = "flatlight"] = "flatlight";
        Themes[Themes["azurelight"] = "azurelight"] = "azurelight";
        Themes[Themes["limelight"] = "limelight"] = "limelight";
        Themes[Themes["saffronlight"] = "saffronlight"] = "saffronlight";
        Themes[Themes["gradientlight"] = "gradientlight"] = "gradientlight";
        Themes[Themes["flatdark"] = "flatdark"] = "flatdark";
        Themes[Themes["azuredark"] = "azuredark"] = "azuredark";
        Themes[Themes["limedark"] = "limedark"] = "limedark";
        Themes[Themes["saffrondark"] = "saffrondark"] = "saffrondark";
        Themes[Themes["gradientdark"] = "gradientdark"] = "gradientdark";
    })(ejSparkline.Themes || (ejSparkline.Themes = {}));
    var Themes = ejSparkline.Themes;
    var Sparkline = (function (_super) {
        __extends(Sparkline, _super);
        function Sparkline(id, options) {
            _super.call(this);
            this.defaults = {
                locale: null,
                enableGroupSeparator: false,
                enableCanvasRendering: false,
                padding: 8,
                palette: ["#8A2BE2", "#ff1a75", "#99cc00", "#4d4dff", "#660066", "#FFA500", "#FFD700", "#FF00FF", "#808000", "#990000"],
                isResponsive: true,
                dataSource: null,
                xName: "",
                yName: "",
                type: Type.Line,
                width: 1,
                stroke: null,
                opacity: 1,
                fill: "#33ccff",
                border: {
                    color: "transparent",
                    width: 1,
                },
                rangeBandSettings: {
                    startRange: null,
                    endRange: null,
                    opacity: 0.4,
                    color: "transparent"
                },
                highPointColor: null,
                lowPointColor: null,
                negativePointColor: null,
                startPointColor: null,
                endPointColor: null,
                tooltip: {
                    visible: false,
                    template: null,
                    fill: "white",
                    border: {
                        width: 1,
                        color: null,
                    },
                    font: {
                        fontFamily: "Segoe UI",
                        fontStyle: "Normal",
                        fontWeight: "Regular",
                        color: "#111111",
                        opacity: 1,
                        size: "8px"
                    }
                },
                markerSettings: {
                    visible: false,
                    fill: null,
                    width: 2,
                    opacity: 1,
                    border: {
                        color: "white",
                        width: 1,
                    }
                },
                background: "transparent",
                size: {
                    height: "",
                    width: ""
                },
                axisLineSettings: {
                    visible: false,
                    color: "#111111",
                    width: 1,
                    dashArray: "",
                },
                theme: Themes.flatlight,
                load: null,
                loaded: null,
                sparklineMouseMove: null,
                sparklineMouseLeave: null,
                seriesRendering: null,
                pointRegionMouseMove: null,
                pointRegionMouseClick: null,
                tooltipInitialize: null,
            };
            this.dataTypes = {
                dataSource: "data",
                palette: "array",
                type: "enum",
                theme: "enum",
            };
            this.model = null;
            this.svgLink = "http://www.w3.org/2000/svg";
            this._id = null;
            this.negativePointIndexes = [];
            this.validTags = ['div'];
            this._id = id;
            if (!!options)
                this.model = ejSparkline.compareExtend({}, options, this.defaults);
        }
        Sparkline.prototype.isTouch = function (evt) {
            var event = evt.originalEvent ? evt.originalEvent : evt;
            if ((event.pointerType == "touch") || (event.pointerType == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        };
        Sparkline.prototype.browserInfo = function () {
            var browser = {}, clientInfo = [], browserClients = {
                webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
                opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
            };
            for (var client in browserClients) {
                if (browserClients.hasOwnProperty(client)) {
                    clientInfo = navigator.userAgent.match(browserClients[client]);
                    if (clientInfo) {
                        browser.name = clientInfo[1].toLowerCase();
                        browser.version = clientInfo[2];
                        if (!!navigator.userAgent.match(/Trident\/7\./)) {
                            browser.name = "msie";
                        }
                        break;
                    }
                }
            }
            browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
            browser.pointerEnabled = window.navigator.pointerEnabled;
            return browser;
        };
        Sparkline.prototype.fadeOut = function (tooltip) {
            var op = 1;
            var timer = setInterval(function () {
                if (op <= 0.1) {
                    clearInterval(timer);
                    tooltip.parentNode ? tooltip.parentNode.removeChild(tooltip) : tooltip;
                }
                tooltip.style.opacity = op;
                tooltip.style.filter = 'alpha(opacity=' + op * 100 + ")";
                op -= op * 0.1;
            }, 50);
        };
        Sparkline.prototype._setModel = function (options) {
            for (var prop in options) {
                var $content;
                switch (prop) {
                    default:
                        ejSparkline.deepExtend(true, this.model, {}, options[prop]);
                }
            }
            this.redraw();
        };
        Sparkline.prototype.unBindEvents = function () {
            var sparklineEle = document.getElementById(this.rootId), insideEvents = "", browserInfo = this.browserInfo(), isPointer = browserInfo.isMSPointerEnabled, isIE11Pointer = browserInfo.pointerEnabled, touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup", touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove";
            insideEvents = touchStopEvent + " " + touchMoveEvent;
            insideEvents = insideEvents.split(" ");
            for (var event in insideEvents) {
                sparklineEle.removeEventListener(insideEvents[event], this.sparkMouseMove);
            }
            sparklineEle.removeEventListener("mouseout", this.sparkMouseLeave);
        };
        Sparkline.prototype.bindEvents = function (ele) {
            this.sparkMouseMove = this.sparkMouseMove.bind(this);
            this.sparkMouseLeave = this.sparkMouseLeave.bind(this);
            var insideEvents = "", browserInfo = this.browserInfo(), isPointer = browserInfo.isMSPointerEnabled, isIE11Pointer = browserInfo.pointerEnabled, touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup", touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove";
            insideEvents = touchStopEvent + " " + touchMoveEvent;
            insideEvents = insideEvents.split(" ");
            for (var event in insideEvents) {
                ele.addEventListener(insideEvents[event], this.sparkMouseMove);
            }
            ele.addEventListener("mouseout", this.sparkMouseLeave);
        };
        Sparkline.prototype.sparkMouseMove = function (evt) {
            var isTouch = this.isTouch(evt);
            if (!(isTouch && (evt.type.toString().toLowerCase().indexOf("move") > -1))) {
                var model = this.model, currentObj = this, locale = model.locale, localizedText = locale && model.enableGroupSeparator, tooltipXValue, tooltipYValue, pointsLocations = this.visiblePoints, markerId = this.container.id + "_markerExplode", pointIndex, text, labelText, markerOptions, tooltipOptions, textOptions, textPad = model.enableCanvasRendering ? 0 : 3, tooltipShape = '', tooltipHeight, tooltipWidth, eventArgs, tooltip, markerFill, containerHeight = parseInt(model.size.height), containerWidth = parseInt(model.size.width), font = model.tooltip.font, xFormat = "#point.x#", yFormat = "#point.y#", tooltipId = this.container.id + "_tooltip", tracker = document.getElementById(tooltipId), trackerPosX, tooltipBorder = model.tooltip.border.color, trackballOptions, rootele = document.getElementById(this.container.id), height = rootele.clientHeight, parent = rootele.parentNode, offset = rootele.getClientRects()[0], trackerTop = offset.top, trackerLeft = offset.left, mouseX = evt.clientX || (evt.changedTouches ? evt.changedTouches[0].clientX : evt.touches ? evt.touches[0].clientX : 0), mouseY = evt.clientY || (evt.changedTouches ? evt.changedTouches[0].clientY : evt.touches ? evt.touches[0].clientY : 0), trackerPositions = pointsLocations.map(function (obj) { return obj['location']['X'] + offset.left; }), tooltipPos = pointsLocations.map(function (obj) { return obj['location']['markerPos'] + offset.top; }), temp = Infinity, measure = this.measureText, pad, spMarker = this.model.markerSettings, mousePos, canvasTracker, canvasContext, canvasOptions, X, Y, canTracker = document.getElementById(this.container.id + "_canvasTracker");
                for (var i = 0, diff, len = trackerPositions.length; i < len; i++) {
                    diff = Math.abs(mouseX - trackerPositions[i]);
                    if (temp > diff) {
                        temp = diff;
                        mousePos = trackerPositions[i];
                        this.pointIndex = i;
                    }
                }
                if ((mouseX > trackerLeft && mouseX < (trackerLeft + offset.width)) && (mouseY > trackerTop && mouseY < (trackerTop + offset.height))) {
                    temp = pointsLocations[this.pointIndex]['location'];
                    var trackTooltipModify = function (text) {
                        pad = text.length / 2;
                        var size = measure(text, font);
                        tooltipHeight = size.height + 4;
                        tooltipWidth = size.width + pad;
                        X = temp['X'];
                        Y = temp['markerPos'];
                        if ((Y - tooltipHeight / 2) < 0)
                            Y += (tooltipHeight / 2);
                        else if ((Y + tooltipHeight / 2) > containerHeight)
                            Y -= (tooltipHeight / 2);
                        if ((X + tooltipWidth + (tooltipWidth / 10)) > (containerWidth - model.padding)) {
                            X = (temp['X'] - Number(model.markerSettings.width) - Number(model.markerSettings.border.width) - 4);
                            tooltipShape = 'M ' + (X) + " " + temp['markerPos'] + " L " + (X - tooltipWidth / 10) + " " + (Y - 4) + " L " + (X - tooltipWidth / 10) + " " + (Y - (tooltipHeight / 2)) + " L " + (X - tooltipWidth - tooltipWidth / 10) + " " + (Y - (tooltipHeight / 2)) + " L " + (X - tooltipWidth - tooltipWidth / 10) + " " + (Y + (tooltipHeight / 2)) + " L " + (X - tooltipWidth / 10) + " " + (Y + (tooltipHeight / 2)) + " L " + (X - tooltipWidth / 10) + " " + (Y + 4) + " Z";
                        }
                        else {
                            X = (temp['X'] + Number(model.markerSettings.width) + Number(model.markerSettings.border.width) + 4);
                            tooltipShape = 'M ' + (X) + " " + temp['markerPos'] + " L " + (X + tooltipWidth / 10) + " " + (Y - 4) + " L " + (X + tooltipWidth / 10) + " " + (Y - (tooltipHeight / 2)) + " L " + (X + tooltipWidth + tooltipWidth / 10) + " " + (Y - (tooltipHeight / 2)) + " L " + (X + tooltipWidth + tooltipWidth / 10) + " " + (Y + (tooltipHeight / 2)) + " L " + (X + tooltipWidth / 10) + " " + (Y + (tooltipHeight / 2)) + " L " + (X + tooltipWidth / 10) + " " + (Y + 4) + " Z";
                        }
                    };
                    if (model.tooltip.template == null || model.tooltip.template == "") {
                        tooltipXValue = localizedText && temp['Xval'] ? temp['Xval'].toLocaleString(locale) : temp['Xval'];
                        tooltipYValue = localizedText && temp['Yval'] ? temp['Yval'].toLocaleString(locale) : temp['Yval'];
                        labelText = " X : " + tooltipXValue + " Y : " + tooltipYValue + " ";
                        trackTooltipModify(labelText);
                    }
                    pointIndex = this.pointIndex;
                    if (this.prevMousePos == undefined) {
                        this.prevMousePos = mousePos;
                    }
                    var checkPointFill = function (index) {
                        var mFill, highIndex = currentObj.highPointIndex, lowIndex = currentObj.lowPointIndex, negatives = currentObj.negativePointIndexes, startIndex = currentObj.startPointIndex, endIndex = currentObj.endPointIndex;
                        if (index == highIndex)
                            mFill = model.highPointColor;
                        else if (index == lowIndex)
                            mFill = model.lowPointColor;
                        else if (index == startIndex && (model.startPointColor != null))
                            mFill = model.startPointColor;
                        else if (index == endIndex && (model.endPointColor != null))
                            mFill = model.endPointColor;
                        else if (negatives.indexOf(index) >= 0 && model.negativePointColor != null)
                            mFill = model.negativePointColor;
                        else
                            mFill = spMarker.fill ? spMarker.fill : model.fill;
                        return mFill;
                    };
                    if (tracker || canTracker) {
                        if (this.prevMousePos != mousePos) {
                            eventArgs = {
                                data: {
                                    "pointIndex": pointIndex,
                                    "currentText": labelText,
                                    "location": temp
                                }
                            };
                            if (this.model.tooltipInitialize != null)
                                this._trigger("tooltipInitialize", eventArgs);
                            trackerPosX = (temp['X'] - (model.width / 2));
                            if (labelText != eventArgs.data.currentText) {
                                labelText = eventArgs.data.currentText;
                                trackTooltipModify(labelText);
                            }
                            this.prevMousePos = mousePos;
                            markerFill = checkPointFill(pointIndex);
                            markerOptions = {
                                'id': markerId,
                                'cx': temp['X'],
                                'cy': temp['markerPos'],
                                'r': Number(spMarker.width),
                                'fill': spMarker.border.color,
                                'stroke': markerFill,
                                'stroke-width': Number(spMarker.border.width),
                            };
                            if (model.tooltip.template == null || model.tooltip.template == "") {
                                tooltipOptions = {
                                    'id': tooltipId,
                                    'fill': model.tooltip.fill,
                                    'stroke': (tooltipBorder != null) ? tooltipBorder : markerFill,
                                    'stroke-width': model.tooltip.border.width,
                                    'd': tooltipShape
                                };
                                textOptions = {
                                    'x': (temp['X'] + tooltipWidth + (tooltipWidth / 10)) > (containerWidth - model.padding) ? (X + textPad - (tooltipWidth) - (tooltipWidth / 10)) : X + textPad + (tooltipWidth / 10),
                                    'y': Y + tooltipHeight / 4,
                                    'fill': font.color,
                                    'font-size': font.size,
                                    'font-family': font.fontFamily,
                                    'font-weight': font.fontWeight,
                                    'font-style': font.fontStyle,
                                };
                            }
                            else {
                                var ele = document.getElementById(model.tooltip.template), html = ele.innerHTML, html = html.replace(xFormat, "&nbsp" + temp['Xval'] + "&nbsp"), html = html.replace(yFormat, "&nbsp" + temp['Yval'] + "&nbsp"), text1 = ele.innerText, gap = Number(model.markerSettings.width), text1 = text1.replace(xFormat, "&nbsp" + temp['Xval'] + "&nbsp"), text1 = text1.replace(yFormat, "&nbsp" + temp['Yval'] + "&nbsp"), template = measure(text1, font), toolX = temp['X'] + Number(spMarker.width) + Number(spMarker.border.width) + gap;
                                Y = (trackerTop + temp['markerPos'] - template['height'] / 2);
                                X = (trackerLeft + toolX);
                                if ((temp['markerPos'] - template['height'] / 2) < model.padding)
                                    Y += (template['height'] / 2);
                                else if ((temp['markerPos'] + template['height'] / 2) > (containerHeight - model.padding))
                                    Y -= (template['height'] / 2);
                                if ((toolX + template['width']) > (containerWidth - model.padding))
                                    X = (X - template['width']) - ((Number(spMarker.width) + Number(spMarker.border.width) + gap) * 2);
                                tooltipOptions = {
                                    'background': model.tooltip.fill,
                                    'border': model.tooltip.border.width + 'px solid ' + ((tooltipBorder != null) ? tooltipBorder : markerFill),
                                    'left': X + 'px',
                                    'top': Y + 'px',
                                };
                                tooltip = document.getElementById(tooltipId),
                                    tooltip.innerHTML = html;
                                this.setStyles(tooltipOptions, tooltip);
                            }
                            if (!model.enableCanvasRendering) {
                                var groupTooltip = document.getElementById(tooltipId + "_g");
                                this.drawCircle(markerOptions, groupTooltip);
                                if (model.tooltip.template == null) {
                                    this.drawPath(tooltipOptions, groupTooltip);
                                    text = rootele.getElementsByTagName('text')[0];
                                    text.textContent = labelText;
                                    this.setAttributes(textOptions, text);
                                    groupTooltip.appendChild(text);
                                }
                            }
                            else {
                                canvasTracker = document.getElementById(this.container.id + "_canvasTracker");
                                canvasContext = canvasTracker.getContext('2d');
                                canvasContext.clearRect(0, 0, containerWidth, containerHeight);
                                this.canvasDrawCircle(markerOptions, canvasContext);
                                if (model.tooltip.template == null || model.tooltip.template == "") {
                                    this.canvasDrawPath(tooltipOptions, canvasContext);
                                    textOptions.font = font.size + " " + font.fontFamily;
                                    this.canvasDrawText(textOptions, labelText, canvasContext);
                                }
                            }
                        }
                    }
                    else {
                        eventArgs = {
                            data: {
                                "pointIndex": pointIndex,
                                "currentText": labelText,
                                "location": temp
                            }
                        };
                        if (this.model.tooltipInitialize != null)
                            this._trigger("tooltipInitialize", eventArgs);
                        trackerPosX = (temp['X'] - (model.width / 2));
                        if (labelText != eventArgs.data.currentText) {
                            labelText = eventArgs.data.currentText;
                            trackTooltipModify(labelText);
                        }
                        var tooltipElements = document.getElementsByClassName("ej-sparkline-tooltip");
                        if (tooltipElements[0]) {
                            tooltipElements[0].parentNode.removeChild(tooltipElements[0]);
                        }
                        markerFill = checkPointFill(pointIndex);
                        markerOptions = {
                            'id': markerId,
                            'cx': temp['X'],
                            'cy': temp['markerPos'],
                            'r': Number(spMarker.width),
                            'fill': spMarker.border.color,
                            'stroke': markerFill,
                            'stroke-width': Number(spMarker.border.width),
                        };
                        if (model.tooltip.template == null || model.tooltip.template == "") {
                            tooltipOptions = {
                                'id': tooltipId,
                                'fill': model.tooltip.fill,
                                'stroke': (tooltipBorder != null) ? tooltipBorder : markerFill,
                                'stroke-width': model.tooltip.border.width,
                                'd': tooltipShape
                            };
                            textOptions = {
                                'x': (temp['X'] + tooltipWidth + (tooltipWidth / 10)) > (containerWidth - model.padding) ? (X + textPad - (tooltipWidth) - (tooltipWidth / 10)) : X + textPad + (tooltipWidth / 10),
                                'y': Y + tooltipHeight / 4,
                                'fill': font.color,
                                'opacity': font.opacity,
                                'font-size': font.size,
                                'font-family': font.fontFamily,
                                'font-weight': font.fontWeight,
                                'font-style': font.fontStyle,
                            };
                        }
                        else {
                            var ele = document.getElementById(model.tooltip.template), html = ele.innerHTML, html = html.replace(xFormat, "&nbsp" + temp['Xval'] + "&nbsp"), html = html.replace(yFormat, "&nbsp" + temp['Yval'] + "&nbsp"), text1 = ele.innerText, gap = Number(model.markerSettings.width), text1 = text1.replace(xFormat, "&nbsp" + temp['Xval'] + "&nbsp"), text1 = text1.replace(yFormat, "&nbsp" + temp['Yval'] + "&nbsp"), template = measure(text1, font);
                            var toolX = temp['X'] + Number(spMarker.width) + Number(spMarker.border.width) + gap;
                            Y = (trackerTop + temp['markerPos'] - template['height'] / 2);
                            X = (trackerLeft + toolX);
                            if ((temp['markerPos'] - template['height'] / 2) < model.padding)
                                Y += (template['height'] / 2);
                            else if ((temp['markerPos'] + template['height'] / 2) > (containerHeight - model.padding))
                                Y -= (template['height'] / 2);
                            if ((toolX + template['width']) > (containerWidth - model.padding))
                                X = (X - template['width']) - ((Number(spMarker.width) + Number(spMarker.border.width) + gap) * 2);
                            tooltipOptions = {
                                'background': model.tooltip.fill,
                                'border': model.tooltip.border.width + 'px solid ' + ((tooltipBorder != null) ? tooltipBorder : markerFill),
                                'left': X + 'px',
                                'top': Y + 'px',
                                'position': 'fixed',
                                'height': 'auto',
                                'width': 'auto',
                                'display': 'block',
                                'opacity': font.opacity,
                                'font': font.size + " " + font.fontFamily,
                            };
                            tooltip = document.createElement('div');
                            this.setAttributes({ 'id': tooltipId, 'class': 'ej-sparkline-tooltip' }, tooltip);
                            this.setStyles(tooltipOptions, tooltip);
                            tooltip.innerHTML = html;
                            parent.appendChild(tooltip);
                        }
                        if (!model.enableCanvasRendering) {
                            var tooltipGroup = document.createElementNS(this.svgLink, "g");
                            this.setAttributes({ "id": tooltipId + "_g", 'class': 'ej-sparkline-tooltip' }, tooltipGroup);
                            this.container.appendChild(tooltipGroup);
                            this.drawCircle(markerOptions, tooltipGroup);
                            if (model.tooltip.template == null) {
                                this.drawPath(tooltipOptions, tooltipGroup);
                                text = this.createText(textOptions, labelText);
                                tooltipGroup.appendChild(text);
                            }
                        }
                        else {
                            canvasTracker = document.createElement('canvas');
                            canvasOptions =
                                {
                                    'id': this.container.id + "_canvasTracker",
                                    'fill': 'transparent',
                                    'class': 'ej-sparkline-tooltip',
                                    'height': model.size.height,
                                    'width': model.size.width,
                                };
                            this.setAttributes(canvasOptions, canvasTracker);
                            this.setStyles({ 'left': (trackerLeft) + 'px', 'top': (trackerTop) + 'px', 'position': 'fixed' }, canvasTracker);
                            canvasContext = canvasTracker.getContext('2d');
                            this.canvasDrawCircle(markerOptions, canvasContext);
                            if (model.tooltip.template == null || model.tooltip.template == "") {
                                this.canvasDrawPath(tooltipOptions, canvasContext);
                                textOptions.font = font.size + " " + font.fontFamily;
                                this.canvasDrawText(textOptions, labelText, canvasContext);
                            }
                            this.container.parentNode.appendChild(canvasTracker);
                        }
                    }
                }
                if (isTouch) {
                    var eleId = (model.tooltip.template == null || model.tooltip.template == "") ? ((model.enableCanvasRendering) ? (this.container.id + "_canvasTracker") : (tooltipId + "_g")) : (tooltipId);
                    var touchtooltip = document.getElementById(eleId);
                    var sparklineObj = this;
                    setTimeout(function () {
                        sparklineObj.fadeOut(touchtooltip);
                    }, 1000);
                }
            }
        };
        Sparkline.prototype.sparkMouseLeave = function (evt) {
            var mouseX = evt.clientX || (evt.touches[0] ? evt.touches[0].clientX : evt.changedTouches[0].clientX), mouseY = evt.clientY || (evt.touches[0] ? evt.touches[0].clientY : evt.changedTouches[0].clientY), rootele = this.container, height = rootele.clientHeight, offset = rootele.getClientRects()[0], trackerTop = offset.top, trackerLeft = offset.left, model = this.model, tooltipId = this.container.id + "_tooltip";
            if ((mouseX < trackerLeft || mouseX > (trackerLeft + offset.width)) || (mouseY < trackerTop || mouseY > (trackerTop + offset.height)) || this.touchEnd) {
                if (model.tooltip.template != null && model.tooltip.template != "") {
                    var tooltemp = document.getElementById(tooltipId);
                    tooltemp ? tooltemp.parentNode.removeChild(tooltemp) : tooltemp;
                }
                if (!this.model.enableCanvasRendering) {
                    var trackerId = tooltipId + "_g", tracker = document.getElementById(trackerId);
                    tracker ? this.container.removeChild(tracker) : tracker;
                }
                else {
                    var canEle = document.getElementById(this.container.id + '_canvasTracker');
                    canEle ? canEle.parentNode.removeChild(canEle) : canEle;
                }
            }
        };
        Sparkline.prototype.bindPieEvents = function (ele) {
            this.pieTooltip = this.pieTooltip.bind(this);
            this.pieTooltipHide = this.pieTooltipHide.bind(this);
            var insideEvents = "", browserInfo = this.browserInfo(), isPointer = browserInfo.isMSPointerEnabled, isIE11Pointer = browserInfo.pointerEnabled, touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup", touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove";
            insideEvents = touchStopEvent + " " + touchMoveEvent;
            insideEvents = insideEvents.split(" ");
            for (var event in insideEvents) {
                ele.addEventListener(insideEvents[event], this.pieTooltip);
            }
            ele.addEventListener("mouseout", this.pieTooltipHide);
            if (this.model.pointRegionMouseClick != null) {
                ele.addEventListener("click", this.pieTooltip);
                ele.addEventListener("touchstart", this.pieTooltip);
            }
        };
        Sparkline.prototype.unbindPieEvents = function () {
            var insideEvents = "", browserInfo = this.browserInfo(), isPointer = browserInfo.isMSPointerEnabled, isIE11Pointer = browserInfo.pointerEnabled, touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup", touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove", sparklineEle = document.getElementById(this.rootId);
            insideEvents = touchStopEvent + " " + touchMoveEvent;
            insideEvents = insideEvents.split(" ");
            for (var event in insideEvents) {
                sparklineEle.removeEventListener(insideEvents[event], this.pieTooltip);
            }
            sparklineEle.removeEventListener("mouseout", this.pieTooltipHide);
        };
        Sparkline.prototype.pieTooltip = function (evt) {
            var isTouch = this.isTouch(evt);
            if (isTouch)
                evt.stopImmediatePropagation();
            if (!(isTouch && (evt.type.toString().toLowerCase().indexOf("move") > -1))) {
                if (this.model.sparklineMouseMove != null)
                    this._trigger("sparklineMouseMove");
                var model = this.model, mouseX = evt.clientX || (evt.changedTouches ? evt.changedTouches[0].clientX : evt.touches ? evt.touches[0].clientX : 0), containerHeight = parseInt(model.size.height), containerWidth = parseInt(model.size.width), font = model.tooltip.font, mouseY = evt.clientY || (evt.changedTouches ? evt.changedTouches[0].clientY : evt.touches ? evt.touches[0].clientY : 0), rootele = document.getElementById(this.container.id), parent = rootele.parentNode, offset = rootele.getClientRects()[0], containerTop = offset.top, containerLeft = offset.left, visiblePos = this.visiblePoints.map(function (a) { return a['coordinates']; }), data = this.visiblePoints.map(function (a) { return a['location']; }), radius = this.visiblePoints['radius'], centerPos = this.visiblePoints['centerPos'], angles = this.visiblePoints, currStDeg, currEdDeg, sliceIndex, dx = mouseX - (centerPos.X + containerLeft), dy = mouseY - (centerPos.Y + containerTop), angle = Math.atan2(dy, dx), pietipId = this.container.id + "_pieTooltip", tooltip = document.getElementById(pietipId), tooltipOptions, tooltipBorder = model.tooltip.border.color, pointRadius = Math.sqrt(dx * dx + dy * dy), eventType = (model.pointRegionMouseClick != null) ? "pointRegionMouseClick" : (model.pointRegionMouseMove != null) ? "pointRegionMouseMove" : null, colors = model.palette, locale = model.locale, localizedText = model.enableGroupSeparator;
                if (Math.abs(pointRadius) <= radius) {
                    for (var i = 0, len = angles.length; i < len; i++) {
                        currStDeg = angles[i]['stAng'];
                        currEdDeg = angles[i]['endAng'];
                        angle = angle < 0 ? (6.283 + angle) : angle;
                        if (angle <= currEdDeg && angle >= currStDeg) {
                            sliceIndex = i;
                            if ((eventType == "pointRegionMouseClick" && (evt.type == "click" || evt.type == "touchstart")) || eventType == "pointRegionMouseMove")
                                this._trigger(eventType, {
                                    data: {
                                        "pointIndex": i,
                                        "seriesType": "Pie",
                                        'locationX': mouseX,
                                        'locationY': mouseY
                                    }
                                });
                        }
                    }
                }
                else if (tooltip)
                    tooltip.parentNode.removeChild(tooltip);
                if (tooltip && sliceIndex != null) {
                    var text = data[sliceIndex]['Percent'].toFixed(2);
                    text = localizedText ? "&nbsp" + parseFloat(text).toLocaleString(locale) : text + "&nbsp%&nbsp";
                    var size = this.measureText(text, font);
                    tooltipOptions = {
                        'left': mouseX + 12 + "px",
                        'top': mouseY + "px",
                        'border': model.tooltip.border.width + "px solid " + ((tooltipBorder != null) ? tooltipBorder : colors[sliceIndex % colors.length]),
                        'background-color': model.tooltip.fill,
                        'height': size.height + "px",
                        'width': size.width + "px",
                    };
                    this.setStyles(tooltipOptions, tooltip);
                    tooltip.innerHTML = text;
                }
                else if (sliceIndex != null) {
                    tooltip = document.createElement('div');
                    var text = data[sliceIndex]['Percent'].toFixed(2);
                    text = localizedText ? "&nbsp" + parseFloat(text).toLocaleString(locale) : text + "&nbsp%&nbsp";
                    var size = this.measureText(text, font);
                    tooltipOptions = {
                        'left': mouseX + 12 + "px",
                        'top': mouseY + "px",
                        'background-color': model.tooltip.fill,
                        'color': font.color,
                        'border': model.tooltip.border.width + "px solid " + ((tooltipBorder != null) ? tooltipBorder : colors[sliceIndex % colors.length]),
                        'height': size.height + "px",
                        'width': size.width + "px",
                        'font-size': font.size,
                        'opacity': font.opacity,
                        'font-weight': font.fontWeight,
                        'font-family': font.fontFamily,
                        'font-style': font.fontStyle,
                        'z-index': "100000",
                        'position': "fixed"
                    };
                    tooltip.setAttribute('id', pietipId);
                    this.setStyles(tooltipOptions, tooltip);
                    tooltip.innerHTML = text;
                    document.body.appendChild(tooltip);
                }
                if (isTouch) {
                    this.touchEnd = true;
                    var touchtooltip = document.getElementById(this.container.id + "_pieTooltip");
                    var sparklineObj = this;
                    setTimeout(function () {
                        sparklineObj.fadeOut(touchtooltip);
                    }, 500);
                }
            }
        };
        Sparkline.prototype.pieTooltipHide = function (evt) {
            if (!this.touchEnd) {
                if (this.model.sparklineMouseLeave != null)
                    this._trigger("sparklineMouseLeave");
                var pietipId = this.container.id + "_pieTooltip", tooltip = document.getElementById(pietipId);
                tooltip ? document.body.removeChild(tooltip) : tooltip;
            }
        };
        Sparkline.prototype.bindRegionEvents = function (ele) {
            this.sparklineEvent = this.sparklineEvent.bind(this);
            var browser = this.findBrowser();
            if (browser == "IE" || browser == 'firefox') {
                ele.style['touch-action'] = 'none';
            }
            if (this.model.pointRegionMouseMove != null) {
                ele.addEventListener("mousemove", this.sparklineEvent, true);
                ele.addEventListener("touchmove", this.sparklineEvent, true);
            }
            if (this.model.pointRegionMouseClick != null) {
                ele.addEventListener("click", this.sparklineEvent, true);
                ele.addEventListener("touchstart", this.sparklineEvent, true);
            }
            if (this.model.sparklineMouseMove != null) {
                ele.addEventListener("mousemove", this.sparklineEvent, true);
                ele.addEventListener("touchmove", this.sparklineEvent, true);
            }
            if (this.model.sparklineMouseLeave != null) {
                this.sparklineLeave = this.sparklineLeave.bind(this);
                ele.addEventListener('mouseout', this.sparklineLeave, true);
                if (browser == 'firefox') {
                    ele.addEventListener('mouseup', this.sparklineLeave, true);
                }
                ele.addEventListener('touchend', this.sparklineLeave, true);
            }
        };
        Sparkline.prototype.sparklineLeave = function () {
            if (this.model.sparklineMouseLeave != null)
                this._trigger("sparklineMouseLeave");
        };
        Sparkline.prototype.sparklineEvent = function (evt) {
            if (this.model.sparklineMouseMove != null)
                this._trigger("sparklineMouseMove");
            var model = this.model, mouseX = evt.clientX || evt.touches[0].clientX, mouseY = evt.clientY || evt.touches[0].clientY, stype = model.type, pointLoc = this.visiblePoints, rX1, rY1, rX2, rY2, width, height, rootele = document.getElementById(this.container.id), parent = rootele.parentNode, offset = rootele.getClientRects()[0], containerTop = offset.top, containerLeft = offset.left, eventType;
            eventType = (model.pointRegionMouseClick != null) ? "pointRegionMouseClick" : (model.pointRegionMouseMove != null) ? "pointRegionMouseMove" : null;
            if (stype == Type.Line || stype == Type.Area) {
                width = 2 * (model.markerSettings.width + model.markerSettings.border.width);
                height = width;
                for (var i = 0, len = pointLoc.length; i < len; i++) {
                    rX1 = containerLeft + pointLoc[i]['location'].X - (width / 2);
                    rY1 = containerTop + pointLoc[i]['location'].Y - (height / 2);
                    rX2 = rX1 + width;
                    rY2 = rY1 + height;
                    if (mouseX >= rX1 && mouseX <= rX2 && mouseY >= rY1 && mouseY <= rY2) {
                        if (eventType != null)
                            this._trigger(eventType, {
                                data: {
                                    "pointIndex": i,
                                    "seriesType": stype,
                                    'locationX': pointLoc[i]['location'].X,
                                    'locationY': pointLoc[i]['location'].Y
                                }
                            });
                    }
                }
            }
            else if (stype == Type.Column || stype == Type.WinLoss) {
                width = pointLoc[0]['location'].width;
                for (var i = 0, len = pointLoc.length; i < len; i++) {
                    height = pointLoc[i]['location'].height;
                    rX1 = containerLeft + pointLoc[i]['location'].X;
                    rY1 = containerTop + pointLoc[i]['location'].Y;
                    rX2 = rX1 + width;
                    rY2 = rY1 + height;
                    if (mouseX >= rX1 && mouseX <= rX2 && mouseY >= rY1 && mouseY <= rY2) {
                        if (eventType != null)
                            this._trigger(eventType, {
                                data: {
                                    "pointIndex": i,
                                    "seriesType": stype,
                                    'locationX': pointLoc[i]['location'].X,
                                    'locationY': pointLoc[i]['location'].Y
                                }
                            });
                    }
                }
            }
        };
        Sparkline.prototype.findBrowser = function () {
            var browser;
            if (navigator.userAgent.indexOf("Firefox") != -1) {
                browser = 'firefox';
            }
            else if ((navigator.userAgent.indexOf("MSIE") != -1) || (!!document['documentMode'] == true)) {
                browser = 'IE';
            }
            else {
                browser = null;
            }
            return browser;
        };
        Sparkline.prototype.resize = function (evt) {
            var currentObj = this;
            var element = document.getElementById(this.rootId);
            if (element != null || element != undefined) {
                window.removeEventListener("resize", this.resize);
                this._destroy();
                this.createSvg();
                this.renderSparkline();
            }
            else {
                window.removeEventListener("resize", this.resize);
            }
        };
        Sparkline.prototype.supportsSvg = function () {
            return !!document.createElementNS && !!document.createElementNS('http://www.w3.org/2000/svg', "svg");
        };
        Sparkline.prototype._init = function (options) {
            if (this.supportsSvg()) {
                this.rootId = (this.rootId != null) ? this.rootId : this._id;
                this.parentElement = (this.parentElement != null) ? this.parentElement : document.getElementById(this.rootId);
                if (this.model.load != null)
                    this._trigger("load");
                this.setTheme(this.model);
                this.height = parseInt(this.model.size.height);
                this.width = parseInt(this.model.size.width);
                this.createSvg();
                this.renderSparkline();
                if (this.model.loaded != null)
                    this._trigger("loaded");
            }
        };
        Sparkline.prototype.redraw = function () {
            this.emptyContainer();
            this.renderSparkline();
        };
        Sparkline.prototype.touchCheck = function (event) {
            this.touchEnd = true;
            if (this.model.type.toString().toLocaleLowerCase() != "pie") {
                this.sparkMouseLeave(event);
            }
            else
                this.pieTooltipHide(event);
        };
        Sparkline.prototype.emptyContainer = function () {
            var model = this.model;
            if (model.enableCanvasRendering) {
                this.ctx.clearRect(0, 0, this.height, this.width);
            }
            else {
                var container = this.container;
                while (container.firstChild) {
                    container.removeChild(container.firstChild);
                }
            }
        };
        Sparkline.prototype._destroy = function () {
            var container = document.getElementById(this.container.id);
            if (container != null) {
                this.unBindEvents();
                this.unbindPieEvents();
                window.removeEventListener("resize", this.resize);
                container.parentNode.removeChild(container);
            }
            else {
                window.removeEventListener("resize", this.resize);
            }
        };
        Sparkline.prototype.renderSparkline = function () {
            this.setStyles({ 'background': this.model.background }, this.container);
            this.calculatePoints();
            this.seriesRender();
            this.resize = this.resize.bind(this);
            if (this.model.isResponsive) {
                window.addEventListener("resize", this.resize);
            }
            else {
                window.removeEventListener("resize", this.resize);
            }
            if ((this.model.type != Type.WinLoss && this.model.type != Type.Pie) && this.model.tooltip.visible)
                this.bindEvents(this.parentElement);
            else
                this.unBindEvents();
            if (this.model.type == Type.Pie && this.model.tooltip.visible)
                this.bindPieEvents(this.parentElement);
            else
                this.unbindPieEvents();
            this.bindRegionEvents(this.parentElement);
        };
        Sparkline.prototype.animateSparkline = function () {
            var model = this.model, sparkObj = this, stype = model.type, padding = model.padding, axisHeight = this.axisHeight, width = parseInt(model.size.width), height = parseInt(model.size.height), i, temp, timer, def = document.createElementNS(this.svgLink, "defs"), clipRect = document.createElementNS(this.svgLink, "clipPath"), animOption, clipOption, rect;
            if (stype == Type.Pie)
                rect = document.createElementNS(this.svgLink, "path");
            else
                rect = document.createElementNS(this.svgLink, "rect");
            if (stype == Type.Line || stype == Type.Area) {
                animOption = {
                    "id": "clipRectSparkline",
                    "x": 0,
                    "y": 0,
                    "width": 0,
                    "height": height
                };
                timer = width / 10;
                var animater = setInterval(animate, 120);
                i = timer;
            }
            else if (stype == Type.Column || stype == Type.WinLoss) {
                if (axisHeight == padding) {
                    animOption = {
                        "id": "clipRectSparkline",
                        "x": 0,
                        "y": 0,
                        "width": width,
                        "height": 0
                    };
                    timer = height / 10;
                    i = timer;
                    var ngtiveRectAnimater = setInterval(animateNegtiveRect, 120);
                }
                else if (axisHeight == (height - padding)) {
                    animOption = {
                        "id": "clipRectSparkline",
                        "x": 0,
                        "y": height,
                        "width": width,
                        "height": 0
                    };
                    timer = height / 10;
                    i = height;
                    var rectAnimater = setInterval(animateRect, 120);
                }
                else {
                    animOption = {
                        "id": "clipRectSparkline",
                        "x": 0,
                        "y": axisHeight,
                        "width": width,
                        "height": 0
                    };
                    timer = height / 10;
                    i = axisHeight;
                    var upperAnimater = setInterval(animateUpper, 120);
                }
            }
            else {
                var values = this.visiblePoints, centerPos = values['centerPos'], area = values['radius'], deg, stRad, edRad, pathArc = "", stDeg = 90, edDeg = 0, flag;
                i = 0;
                animOption = {
                    "id": "clipRectSparkline",
                    "d": pathArc,
                };
                var pieAnimater = setInterval(pieAnimate, 120);
            }
            clipOption = {
                "id": this.container.id + "_sparklineRect",
            };
            this.setAttributes(animOption, rect);
            this.setAttributes(clipOption, clipRect);
            clipRect.appendChild(rect);
            def.appendChild(clipRect);
            this.container.appendChild(def);
            function animate() {
                if (i <= width) {
                    rect.setAttribute("width", i.toString());
                }
                else {
                    clearInterval(animater);
                    sparkObj._trigger("animationComplete");
                }
                i = i + timer;
            }
            function animateRect() {
                temp = height - i;
                if (i >= 0) {
                    rect.setAttribute("y", i.toString());
                    rect.setAttribute("height", temp);
                }
                else {
                    clearInterval(rectAnimater);
                    sparkObj._trigger("animationComplete");
                }
                i = i - timer;
            }
            ;
            function animateNegtiveRect() {
                if (i <= height) {
                    rect.setAttribute("height", i.toString());
                }
                else {
                    clearInterval(ngtiveRectAnimater);
                    sparkObj._trigger("animationComplete");
                }
                i = i + timer;
            }
            ;
            function animateUpper() {
                temp = (axisHeight - i) * 2;
                if (i >= -timer) {
                    rect.setAttribute("y", i < 0 ? 0 : i.toString());
                    rect.setAttribute("height", temp);
                }
                else {
                    clearInterval(upperAnimater);
                    sparkObj._trigger("animationComplete");
                }
                i = i - timer;
            }
            ;
            function pieAnimate() {
                if (i <= (values.length - 1)) {
                    stDeg = 90;
                    deg = values[i]['location']['Degree'];
                    edDeg += deg + (i == 0 ? stDeg : 0);
                    stRad = (stDeg - 90) * Math.PI / 180.0;
                    edRad = (edDeg - 90) * Math.PI / 180.0;
                    if (i == values.length - 1)
                        edRad -= 0.0001;
                    temp = { sX: centerPos.X + (area * Math.cos(stRad)), sY: centerPos.Y + (area * Math.sin(stRad)), eX: centerPos.X + (area * Math.cos(edRad)), eY: centerPos.Y + (area * Math.sin(edRad)) };
                    pathArc = "M " + centerPos.X + " " + centerPos.Y + " L " + temp.eX + " " + temp.eY + " A " + area + " " + area + " 0 " + 1 + ",0 " + temp.sX + " " + temp.sY + " Z";
                    rect.setAttribute("d", pathArc);
                }
                else {
                    clearInterval(pieAnimater);
                    sparkObj._trigger("animationComplete");
                }
                i += 1;
            }
        };
        Sparkline.prototype.setTheme = function (model) {
            var theme = model.theme, defaults = this.defaults;
            if (theme == Themes.flatdark) {
                model.background = (model.background == defaults.background) ? "#111111" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#B5B5B5" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#F6D321" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#AAAAAA" : model.axisLineSettings.color;
            }
            else if (theme == Themes.gradientlight) {
                model.background = (model.background == defaults.background) ? "transparent" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#F34649" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#597B15" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#8E8E8E" : model.axisLineSettings.color;
            }
            else if (theme == Themes.gradientdark) {
                model.background = (model.background == defaults.background) ? "#111111" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#005378" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#6A9319" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#AAAAAA" : model.axisLineSettings.color;
            }
            else if (theme == Themes.azuredark) {
                model.background = (model.background == defaults.background) ? "#111111" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#007fff" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#f0ffff" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#336699" : model.axisLineSettings.color;
            }
            else if (theme == Themes.azurelight) {
                model.background = (model.background == defaults.background) ? "transparent" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#336699" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#007fff" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#336699" : model.axisLineSettings.color;
            }
            else if (theme == Themes.limedark) {
                model.background = (model.background == defaults.background) ? "#111111" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#238f23" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#32CD32" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#43da21" : model.axisLineSettings.color;
            }
            else if (theme == Themes.limelight) {
                model.background = (model.background == defaults.background) ? "transparent" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#238f23" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#32CD32" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#43da21" : model.axisLineSettings.color;
            }
            else if (theme == Themes.saffrondark) {
                model.background = (model.background == defaults.background) ? "#111111" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#ffaa33" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#ffdba9" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#ffc26e" : model.axisLineSettings.color;
            }
            else if (theme == Themes.saffronlight) {
                model.background = (model.background == defaults.background) ? "transparent" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#ffaa33" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#ffdba9" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#ffc26e" : model.axisLineSettings.color;
            }
            else if (theme == null || theme == Themes.flatlight) {
                model.background = (model.background == defaults.background) ? "transparent" : model.background;
                model.fill = (model.fill == defaults.fill) ? "#33ccff" : model.fill;
                model.stroke = (model.stroke == defaults.stroke) ? "#33ccff" : model.stroke;
                model.axisLineSettings.color = (model.axisLineSettings.color) == defaults.axisLineSettings.color ? "#FF0000" : model.axisLineSettings.color;
            }
        };
        Sparkline.prototype.createSvg = function () {
            var model = this.model, parentElement = this.parentElement, options, parentHeight = (parseInt(parentElement.style.height) > parentElement.clientHeight) ? parseInt(parentElement.style.height) : parentElement.clientHeight, parentWidth = (parseInt(parentElement.style.width) > parentElement.clientWidth) ? parseInt(parentElement.style.width) : parentElement.clientWidth, width = parseInt(model.size.width), height = parseInt(model.size.height);
            height = (height > 0) ? height : (parentHeight > 0) ? parentHeight : 30;
            width = (width > 0) ? width : (parentWidth > 0) ? parentWidth : 50;
            model.size.height = height.toString();
            model.size.width = width.toString();
            this.height = height;
            this.width = width;
            options = {
                "id": this.rootId + "_sparkline_svg",
                "width": width,
                "height": height,
            };
            if (!model.enableCanvasRendering) {
                this.container = document.createElementNS(this.svgLink, "svg");
            }
            else {
                this.container = document.createElement("canvas");
                this.ctx = this.container.getContext('2d');
            }
            this.setAttributes(options, this.container);
            parentElement.appendChild(this.container);
        };
        Sparkline.prototype.setStyles = function (Options, element) {
            var properties = Object.keys(Options), temp;
            var values = properties.map(function (property) { return Options[property]; });
            for (var i = 0, len = properties.length; i < len; i++) {
                temp = properties[i];
                element.style[temp] = values[i];
            }
        };
        Sparkline.prototype.setAttributes = function (Options, element) {
            var properties = Object.keys(Options);
            var values = properties.map(function (property) { return Options[property]; });
            for (var i = 0, len = properties.length; i < len; i++) {
                element.setAttribute(properties[i], values[i]);
            }
        };
        Sparkline.prototype.getDefaultPoints = function (count) {
            var data = [], i = 1;
            for (; i <= count; i++) {
                if ((Math.random() * 10) > 5)
                    data.push(-Math.round(Math.random() * 100));
                data.push(Math.round(Math.random() * 100));
            }
            return data;
        };
        Sparkline.prototype.calculatePoints = function () {
            var model = this.model, stype = model.type, data = (model.dataSource != null) ? model.dataSource : this.getDefaultPoints(12), x, y, max, min, minX, maxX, visiblePoints = [], maxPointsLength = data.length, temp, sumofValues = 0;
            if (Array.isArray(data) && typeof data[0] != 'object') {
                if (model.type == Type.Pie) {
                    for (var i = 0; i < maxPointsLength; i++) {
                        sumofValues += Math.abs(data[i]);
                    }
                }
                else {
                    max = Math.max.apply(null, data);
                    min = Math.min.apply(null, data);
                    minX = 0;
                    maxX = maxPointsLength - 1;
                }
            }
            else {
                if (model.type == Type.Pie) {
                    for (var i = 0; i < maxPointsLength; i++) {
                        sumofValues += Math.abs(data[i][model.yName]);
                    }
                }
                else {
                    if (!data[0][model.xName]) {
                        var x = data.map(function (z) { return z[model.yName]; });
                        max = Math.max.apply(null, x);
                        min = Math.min.apply(null, x);
                    }
                    else {
                        temp = data;
                        temp = temp.sort(function (a, b) { return a[model.yName] - b[model.yName]; });
                        max = temp[temp.length - 1][model.yName];
                        min = temp[0][model.yName];
                    }
                    if (data[0][model.xName]) {
                        temp = temp.sort(function (a, b) { return a[model.xName] - b[model.xName]; });
                        maxX = temp[temp.length - 1][model.xName];
                        minX = temp[0][model.xName];
                    }
                    else {
                        minX = 0;
                        maxX = maxPointsLength - 1;
                    }
                }
            }
            if (model.type != Type.Pie) {
                this.maxLength = maxPointsLength;
                var location, padding = Number(model.padding), height = parseInt(model.size.height) - (padding * 2), width = parseInt(model.size.width) - (padding * 2), unitX = maxX - minX, unitY = max - min, unitX = unitX == 0 ? 1 : unitX;
                unitY = unitY == 0 ? 1 : unitY;
                this.min = min;
                this.unitX = unitX;
                this.minX = minX;
                this.unitY = unitY;
                this.max = max;
                this.maxX = maxX;
                var X1 = 0, Y1 = height - ((height / unitY) * (-min)), Y2, Y1 = (min < 0 && max < 0) ? 0 : (min < 0 && max > 0) ? Y1 : height;
                this.axisHeight = Y1 + padding;
                if (stype != Type.WinLoss && model.axisLineSettings.visible)
                    this.drawAxis();
            }
            else
                var percent, location;
            for (var i = 0; i < maxPointsLength; i++) {
                if (!(data[i][model.xName]) && !(data[i][model.yName])) {
                    x = i;
                    y = data[i];
                }
                else if (!(data[i][model.xName])) {
                    x = i;
                    y = data[i][model.yName];
                }
                else {
                    x = data[i][model.xName];
                    y = data[i][model.yName];
                }
                if (stype == Type.Line || stype == Type.Area) {
                    Y2 = (maxPointsLength != 1) ? height - Math.round(height * ((y - min) / unitY)) : 0;
                    location = { X: (maxPointsLength != 1) ? Math.round(width * ((x - minX) / unitX)) : width / 2, Y: Y2, markerPos: Y2 };
                }
                else if (stype == Type.Column || stype == Type.WinLoss) {
                    var colWidth = width / maxPointsLength, calSpace = 0.5, space = (calSpace * 2);
                    colWidth -= (space);
                    X1 = (i * (colWidth + space)) + (space / 2);
                    if (stype == Type.WinLoss) {
                        var winLossFactor = 0.5, drawHeightFactor = 40;
                        Y2 = (y > 0) ? height / 4 : (y < 0) ? (height * winLossFactor) : (height * winLossFactor) - (height / drawHeightFactor);
                        location = { X: X1, Y: Y2, height: (y != 0) ? (height / 4) : height / 20, width: colWidth };
                    }
                    else {
                        Y2 = (maxPointsLength != 1) ? height - ((height / unitY) * (y - min)) : 0;
                        location = { X: X1, Y: (Y2 > Y1) ? Y1 : Y2, height: Math.abs(Y2 - Y1), width: colWidth, markerPos: (Y2 > Y1) ? (Y1 + Math.abs(Y2 - Y1)) : Y2 };
                    }
                }
                else if (stype == Type.Pie) {
                    percent = (Math.abs(y) / sumofValues) * 100;
                    location = {
                        Percent: percent, Degree: ((Math.abs(y) / sumofValues) * 360)
                    };
                }
                if (stype != Type.Pie) {
                    location.X += padding;
                    location.Y += padding;
                }
                if (stype != Type.WinLoss)
                    location.markerPos += padding;
                location['Xval'] = x;
                location['Yval'] = y;
                visiblePoints.push({ location: location });
            }
            this.visiblePoints = visiblePoints;
        };
        Sparkline.prototype.seriesRender = function () {
            var model = this.model, visiblePoints = this.visiblePoints, points_length = visiblePoints.length, eventArgs, seriesType = model.type;
            eventArgs = {
                data: {
                    "minX": this.minX,
                    "minY": this.min,
                    "maxX": this.maxX,
                    "maxY": this.max,
                    "xName": model.xName,
                    "yName": model.yName,
                    "pointsCount": points_length,
                    "seriesType": seriesType,
                    "visiblePoints": this.visiblePoints
                }
            };
            if (this.model.seriesRendering != null)
                this._trigger("seriesRendering", eventArgs);
            if (seriesType == Type.Line) {
                this.drawLineSeries(visiblePoints);
            }
            else if (seriesType == Type.Area) {
                this.drawAreaSeries(visiblePoints);
            }
            else if (seriesType == Type.Column) {
                this.drawColumnSeries(visiblePoints);
            }
            else if (seriesType == Type.WinLoss) {
                this.drawWinlossSeries(visiblePoints);
            }
            else if (seriesType == Type.Pie) {
                this.drawPieSeries();
            }
            if (model.markerSettings.visible && (seriesType != Type.WinLoss) && (seriesType != Type.Pie))
                this.drawMarker(visiblePoints);
            if ((model.rangeBandSettings.startRange != null) && (model.rangeBandSettings.endRange != null) && (seriesType != Type.WinLoss) && (seriesType != Type.Pie))
                this.drawRangeBand();
        };
        Sparkline.prototype.drawPieSeries = function () {
            var model = this.model, values = this.visiblePoints;
            model.padding = (model.padding == this.defaults.padding) ? 2 : model.padding;
            var len = values.length, height = parseInt(model.size.height) - (model.padding * 2), width = parseInt(model.size.width) - (model.padding * 2), area = (height <= width) ? height / 2 : width / 2, stRad, edRad, centerPos = { X: width / 2, Y: height / 2 }, temp, pathArc, pathOptions, colors = model.palette, deg = 0, stroke = model.border.color, opacity = model.opacity, strokeWidth = model.border.width, gEle;
            values['centerPos'] = centerPos;
            values['radius'] = area;
            for (var i = 0, stDeg = 90, edDeg, flag; i < values.length; i++) {
                stDeg += deg;
                deg = values[i]['location']['Degree'];
                edDeg = stDeg + deg;
                stRad = (stDeg - 90) * Math.PI / 180.0;
                edRad = (edDeg - 90) * Math.PI / 180.0;
                values[i]['stAng'] = stRad;
                values[i]['endAng'] = edRad;
                flag = (deg < 180) ? "0" : "1";
                temp = values[i]['coordinates'] = { sX: centerPos.X + (area * Math.cos(stRad)), sY: centerPos.Y + (area * Math.sin(stRad)), eX: centerPos.X + (area * Math.cos(edRad)), eY: centerPos.Y + (area * Math.sin(edRad)) };
                pathArc = "M " + centerPos.X + " " + centerPos.Y + " L " + temp.eX + " " + temp.eY + " A " + area + " " + area + " 0 " + flag + ",0 " + temp.sX + " " + temp.sY + " Z";
                pathOptions = {
                    'id': this.container.id + "_pieBase" + i,
                    'fill': colors[i % colors.length],
                    'stroke': stroke,
                    'opacity': opacity,
                    'stroke-width': strokeWidth,
                    'd': pathArc,
                    'start': edRad,
                    'end': stRad,
                    'x': centerPos.X,
                    'y': centerPos.Y,
                    'counterClockWise': flag,
                    'radius': area
                };
                if (model.enableCanvasRendering)
                    this.canvasDrawPath(pathOptions);
                else {
                    gEle = this.createGroup({ "id": "sparkpieSeries" });
                    this.setStyles({ "clip-path": "url(#" + this.container.id + "_sparklineRect)" }, gEle);
                    this.container.appendChild(gEle);
                    this.drawPath(pathOptions, gEle);
                }
            }
        };
        Sparkline.prototype.drawRangeBand = function () {
            var model = this.model, height = (parseInt(model.size.height) - model.padding * 2), width = (parseInt(model.size.width) - model.padding * 2), stValue = model.rangeBandSettings.startRange, edValue = model.rangeBandSettings.endRange, stHeight = Number(height - ((height / this.unitY) * (stValue - this.min))) + model.padding, edHeight = Number(height - ((height / this.unitY) * (edValue - this.min))) + model.padding, options;
            edHeight = edHeight > Number(height + model.padding) ? Number(height + model.padding) : edHeight < (0 + model.padding) ? (0 + model.padding) : edHeight;
            stHeight = stHeight > Number(height + model.padding) ? Number(height + model.padding) : stHeight < (0 + model.padding) ? (0 + model.padding) : stHeight;
            var path = 'M ' + model.padding + " " + stHeight + " L " + (width + Number(model.padding)) + " " + stHeight + " L " + (width + Number(model.padding)) + " " + edHeight + " L " + model.padding + " " + edHeight + " Z";
            options = {
                'id': this.container.id + "_rangeBand",
                'fill': model.rangeBandSettings.color,
                'opacity': model.rangeBandSettings.opacity,
                'stroke': "transparent",
                'stroke-width': model.border.width,
                'd': path,
            };
            if (model.enableCanvasRendering)
                this.canvasDrawPath(options);
            else
                this.drawPath(options);
        };
        Sparkline.prototype.drawAxis = function () {
            var model = this.model, height = this.axisHeight, strclr = model.axisLineSettings.color, seriesType = model.type;
            if ((seriesType != Type.WinLoss) && (seriesType != Type.Pie)) {
                if (!model.axisLineSettings.visible)
                    strclr = 'transparent';
                var xAxis = {
                    'id': this.container.id + "_Sparkline_XAxis",
                    'x1': 0 + model.padding,
                    'y1': height,
                    'x2': parseInt(model.size.width) - model.padding,
                    'y2': height,
                    'stroke': strclr,
                    'stroke-dasharray': model.axisLineSettings.dashArray,
                    'stroke-width': model.axisLineSettings.width,
                };
                if (model.enableCanvasRendering)
                    this.canvasDrawLine(xAxis);
                else
                    this.drawLine(xAxis);
            }
        };
        Sparkline.prototype.drawColumnSeries = function (points) {
            var rectOptions, temp, model = this.model, mod = [], len = points.length, locations = ejSparkline.compareExtend({}, mod, points), strwd = model.border.width, lowPos, opacity = model.opacity, highPos, fill = model.fill, stroke = model.border.color, highPointColor = model.highPointColor, lowPointColor = model.lowPointColor, startPointColor = model.startPointColor, endPointColor = model.endPointColor, negativePointColor = model.negativePointColor, gEle;
            if (highPointColor || lowPointColor) {
                var pointsYPos = locations.map(function (a) { return a['location']['markerPos']; });
                highPos = Math.min.apply(null, pointsYPos);
                lowPos = Math.max.apply(null, pointsYPos);
            }
            if (model.enableCanvasRendering == false) {
                gEle = this.createGroup({ "id": this.container.id + "sparkcolumnSeries" });
                this.setStyles({ "clip-path": "url(#" + this.container.id + "_sparklineRect)" }, gEle);
                this.container.appendChild(gEle);
            }
            for (var i = 0; i < len; i++) {
                temp = points[i].location;
                rectOptions = {
                    'id': this.container.id + "_column_series_" + i,
                    'x': temp.X,
                    'y': temp.Y,
                    'height': temp.height,
                    'width': temp.width,
                    'fill': fill,
                    'stroke': stroke,
                    'opacity': opacity,
                    "stroke-width": strwd,
                };
                if (temp.markerPos == highPos && highPointColor) {
                    rectOptions.fill = highPointColor;
                    this.highPointIndex = i;
                }
                else if (temp.markerPos == lowPos && lowPointColor) {
                    rectOptions.fill = lowPointColor;
                    this.lowPointIndex = i;
                }
                else if (i == 0 && startPointColor) {
                    rectOptions.fill = startPointColor;
                    this.startPointIndex = i;
                }
                else if ((i == (len - 1)) && endPointColor) {
                    rectOptions.fill = endPointColor;
                    this.endPointIndex = i;
                }
                else if (temp.markerPos >= this.axisHeight && negativePointColor) {
                    rectOptions.fill = negativePointColor;
                    this.negativePointIndexes.push(i);
                }
                if (model.enableCanvasRendering)
                    this.canvasDrawRectangle(rectOptions);
                else {
                    this.drawRect(rectOptions, gEle);
                }
                temp.X += temp.width / 2;
            }
        };
        Sparkline.prototype.drawWinlossSeries = function (points) {
            var rectOptions, temp, model = this.model, strwd = model.border.width, padding = model.padding, stroke = model.border.color, opacity = model.opacity, tieColor = "#EE82EE", len = points.length, height = parseInt(model.size.height) - (padding * 2), gEle;
            if (model.enableCanvasRendering == false) {
                gEle = this.createGroup({ "id": this.container.id + "sparkwinlossSeries" });
                this.setStyles({ "clip-path": "url(#" + this.container.id + "_sparklineRect)" }, gEle);
                this.container.appendChild(gEle);
            }
            for (var i = 0; i < len; i++) {
                temp = points[i].location;
                rectOptions = {
                    'id': this.container.id + "_winloss_series_" + i,
                    'x': temp.X,
                    'y': temp.Y,
                    'height': temp.height,
                    'width': temp.width,
                    'fill': (temp.Y < (height / 2 + padding)) ? (temp.Y > (height / 4 + padding)) ? tieColor : model.fill : model.negativePointColor ? model.negativePointColor : "#FF0000",
                    'stroke': stroke,
                    'opacity': opacity,
                    "stroke-width": strwd
                };
                if (model.enableCanvasRendering)
                    this.canvasDrawRectangle(rectOptions);
                else {
                    this.drawRect(rectOptions, gEle);
                }
            }
        };
        Sparkline.prototype.drawAreaSeries = function (points) {
            var linepath = "", totHeight = this.axisHeight, model = this.model, options, gEle;
            for (var i = 0, len = points.length; i < len; i++) {
                if (i == 0) {
                    linepath = "M " + points[0].location.X + " " + totHeight + " ";
                }
                linepath += "L " + points[i].location.X + " " + points[i].location.Y + " ";
                if (i == len - 1) {
                    linepath += "L " + points[i].location.X + " " + totHeight + " Z";
                }
            }
            options = {
                "id": this.container.id + "_area_series_fill",
                "fill": model.fill,
                "stroke": model.stroke ? model.stroke : model.fill,
                'fill-opacity': model.opacity,
                "stroke-width": model.width,
                "d": linepath
            };
            if (model.enableCanvasRendering)
                this.canvasDrawPath(options);
            else {
                gEle = this.createGroup({ "id": "sparkAreaSeries" });
                this.container.appendChild(gEle);
                this.drawPath(options, gEle);
                this.setStyles({ "clip-path": "url(#" + this.container.id + "_sparklineRect)" }, gEle);
            }
        };
        Sparkline.prototype.drawLineSeries = function (points) {
            var linepath = '', model = this.model, gEle;
            for (var i = 0, len = points.length; i < len; i++) {
                if (i == 0)
                    linepath = "M " + points[0].location.X + " " + points[i].location.Y + " ";
                linepath += "L " + points[i].location.X + " " + points[i].location.Y + " ";
            }
            var line_options = {
                'id': this.container.id + "_Line_series",
                'fill': 'transparent',
                'stroke': model.stroke ? model.stroke : model.fill,
                'opacity': model.opacity,
                'stroke-width': model.width,
                'd': linepath
            };
            if (model.enableCanvasRendering)
                this.canvasDrawPath(line_options);
            else {
                gEle = this.createGroup({ "id": "sparklineSeries" });
                this.container.appendChild(gEle);
                this.drawPath(line_options, gEle);
                this.setStyles({ "clip-path": "url(#" + this.container.id + "_sparklineRect)" }, gEle);
            }
        };
        Sparkline.prototype.drawMarker = function (points) {
            var length = points.length, marker_options, marker = this.model.markerSettings, mod = [], model = this.model, locations = ejSparkline.compareExtend({}, mod, points), fill = marker.fill ? marker.fill : model.fill, stroke = marker.border.color, strwid = marker.width, opacity = marker.opacity, brdwid = marker.border.width, temp, lowPos, highPos, highPointColor = model.highPointColor, lowPointColor = model.lowPointColor, startPointColor = model.startPointColor, endPointColor = model.endPointColor, negativePointColor = model.negativePointColor, gEle;
            if (model.enableCanvasRendering == false) {
                gEle = this.createGroup({ "id": this.container.id + "sparkmarkers" });
                this.setStyles({ "clip-path": "url(#" + this.container.id + "_sparklineRect)" }, gEle);
                this.container.appendChild(gEle);
            }
            if (marker.visible == false || (model.type == Type.Pie || model.type == Type.WinLoss)) {
                strwid = 0;
                brdwid = 0;
            }
            if (highPointColor || lowPointColor) {
                var pointsYPos = locations.map(function (a) { return a['location']['markerPos']; });
                highPos = Math.min.apply(null, pointsYPos);
                lowPos = Math.max.apply(null, pointsYPos);
            }
            for (var i = 0, wid; i < length; i++) {
                temp = points[i].location;
                wid = (temp.width != undefined) ? (temp.width / 2) : 0;
                marker_options = {
                    'id': this.container.id + "_marker_" + i,
                    'cx': temp.X,
                    'cy': temp.markerPos,
                    'r': strwid,
                    'fill': fill,
                    'stroke': stroke,
                    'opacity': opacity,
                    'stroke-width': brdwid
                };
                if (temp.markerPos == highPos && highPointColor) {
                    marker_options.fill = highPointColor;
                    this.highPointIndex = i;
                }
                else if (temp.markerPos == lowPos && lowPointColor) {
                    marker_options.fill = lowPointColor;
                    this.lowPointIndex = i;
                }
                else if (i == 0 && startPointColor) {
                    marker_options.fill = startPointColor;
                    this.startPointIndex = i;
                }
                else if ((i == (length - 1)) && endPointColor) {
                    marker_options.fill = endPointColor;
                    this.endPointIndex = i;
                }
                else if (temp.markerPos >= this.axisHeight && negativePointColor) {
                    marker_options.fill = negativePointColor;
                    this.negativePointIndexes.push(i);
                }
                if (this.model.enableCanvasRendering)
                    this.canvasDrawCircle(marker_options);
                else
                    this.drawCircle(marker_options, gEle);
            }
        };
        Sparkline.prototype.drawLine = function (Options) {
            var svgshape = document.getElementById(Options['id']);
            if (!svgshape)
                svgshape = document.createElementNS(this.svgLink, "line");
            this.setAttributes(Options, svgshape);
            this.container.appendChild(svgshape);
        };
        Sparkline.prototype.drawCircle = function (Options, element) {
            element = (!!element) ? element : this.container;
            var svgshape = document.getElementById(Options['id']);
            if (!svgshape)
                svgshape = document.createElementNS(this.svgLink, "circle");
            this.setAttributes(Options, svgshape);
            element.appendChild(svgshape);
        };
        Sparkline.prototype.drawPolyLine = function (Options) {
            var svgshape = document.getElementById(Options['id']);
            if (!svgshape)
                svgshape = document.createElementNS(this.svgLink, "polyline");
            this.setAttributes(Options, svgshape);
            this.container.appendChild(svgshape);
        };
        Sparkline.prototype.drawPath = function (Options, element) {
            element = (!!element) ? element : this.container;
            var svgshape = document.getElementById(Options['id']);
            if (!svgshape)
                svgshape = document.createElementNS(this.svgLink, "path");
            this.setAttributes(Options, svgshape);
            element.appendChild(svgshape);
        };
        Sparkline.prototype.drawRect = function (Options, element) {
            element = (!!element) ? element : this.container;
            var svgshape = document.getElementById(Options['id']);
            if (!svgshape)
                svgshape = document.createElementNS(this.svgLink, "rect");
            this.setAttributes(Options, svgshape);
            element.appendChild(svgshape);
        };
        Sparkline.prototype.createGroup = function (options) {
            var group = document.createElementNS(this.svgLink, "g");
            this.setAttributes(options, group);
            return group;
        };
        Sparkline.prototype.createText = function (options, label) {
            var text = document.createElementNS(this.svgLink, "text");
            this.setAttributes(options, text);
            if (label)
                text.textContent = label;
            return text;
        };
        Sparkline.prototype.canvasDrawLine = function (options, canvasContext) {
            var context2d = canvasContext ? canvasContext : this.ctx;
            context2d.save();
            context2d.beginPath();
            context2d.lineWidth = options["stroke-width"];
            context2d.strokeStyle = options["stroke"];
            context2d.moveTo(options["x1"], options["y1"]);
            context2d.lineTo(options["x2"], options["y2"]);
            context2d.stroke();
            context2d.restore();
            this.dataURL = this.container.toDataURL();
        };
        Sparkline.prototype.canvasDrawRectangle = function (options, canvasContext) {
            var context2d = canvasContext ? canvasContext : this.ctx, canvasCtx = canvasContext ? canvasContext : this.ctx;
            context2d.save();
            context2d.beginPath();
            context2d.globalAlpha = options["opacity"];
            context2d.lineWidth = options["stroke-width"];
            var dashArray = options["stroke-dasharray"] ? options["stroke-dasharray"].split(",") : false;
            if (dashArray)
                this.ctx.setLineDash(dashArray);
            context2d.strokeStyle = options["stroke"];
            context2d.rect(options["x"], options["y"], options["width"], options["height"]);
            if (options["fill"] == "none")
                options["fill"] = "transparent";
            context2d.fillStyle = options["fill"];
            context2d.fillRect(options["x"], options["y"], options["width"], options["height"]);
            context2d.stroke();
            context2d.restore();
            context2d = canvasCtx;
            this.dataURL = this.container.toDataURL();
        };
        Sparkline.prototype.canvasDrawPath = function (options, canvasContext) {
            var path = options["d"];
            var dataSplit = path.split(" ");
            var borderWidth = options["stroke-width"];
            var context2d = canvasContext ? canvasContext : this.ctx, canvasCtx = canvasContext ? canvasContext : this.ctx;
            context2d.save();
            context2d.beginPath();
            context2d.globalAlpha = options["opacity"] ? options["opacity"] : options["fill-opacity"];
            var flag = true;
            context2d.lineWidth = borderWidth;
            var dashArray = options["stroke-dasharray"] ? options["stroke-dasharray"].split(",") : false;
            if (dashArray)
                context2d.setLineDash(dashArray);
            context2d.strokeStyle = options["stroke"];
            for (var i = 0; i < dataSplit.length; i = i + 3) {
                var x1 = parseFloat(dataSplit[i + 1]);
                var y1 = parseFloat(dataSplit[i + 2]);
                switch (dataSplit[i]) {
                    case "M":
                        if (!options["innerR"] && !options["cx"])
                            context2d.moveTo(x1, y1);
                        break;
                    case "L":
                        if (!options["innerR"])
                            context2d.lineTo(x1, y1);
                        break;
                    case "C":
                        context2d.bezierCurveTo(x1, y1, parseFloat(dataSplit[i + 3]), parseFloat(dataSplit[i + 4]), parseFloat(dataSplit[i + 5]), parseFloat(dataSplit[i + 6]));
                        i = i + 4;
                        break;
                    case "A":
                        if (!options["innerR"]) {
                            if (options["cx"]) {
                                context2d.arc(options["cx"], options["cy"], options["radius"], 0, 2 * Math.PI, options["counterClockWise"]);
                            }
                            else {
                                context2d.moveTo(options["x"], options["y"]);
                                context2d.arc(options["x"], options["y"], options["radius"], options["start"], options["end"], options["counterClockWise"]);
                                context2d.lineTo(options["x"], options["y"]);
                            }
                        }
                        else if (flag) {
                            context2d.arc(options["x"], options["y"], options["radius"], options["start"], options["end"], options["counterClockWise"]);
                            context2d.arc(options["x"], options["y"], options["innerR"], options["end"], options["start"], !options["counterClockWise"]);
                            flag = false;
                        }
                        i = i + 5;
                        break;
                    case "Z":
                        context2d.closePath();
                        break;
                }
            }
            if (options["fill"] != "none" && options["fill"] != undefined) {
                context2d.fillStyle = options["fill"];
                context2d.fill();
            }
            if (borderWidth > 0)
                context2d.stroke();
            context2d.restore();
            context2d = canvasCtx;
            this.dataURL = this.container.toDataURL();
        };
        Sparkline.prototype.canvasDrawCircle = function (options, canvasContext) {
            var context2d = canvasContext ? canvasContext : this.ctx, canvasCtx = canvasContext ? canvasContext : this.ctx, dashArray;
            context2d.save();
            context2d.beginPath();
            context2d.arc(options["cx"], options["cy"], options["r"], 0, 2 * Math.PI);
            context2d.fillStyle = options["fill"];
            context2d.globalAlpha = options["opacity"];
            context2d.fill();
            context2d.lineWidth = options["stroke-width"];
            dashArray = options["stroke-dasharray"] ? options["stroke-dasharray"].split(",") : false;
            if (dashArray)
                context2d.setLineDash(dashArray);
            context2d.strokeStyle = options["stroke"];
            context2d.stroke();
            context2d.restore();
            context2d = canvasCtx;
            this.dataURL = this.container.toDataURL();
        };
        Sparkline.prototype.canvasDrawPolyline = function (options, canvasContext) {
            var context2d = canvasContext ? canvasContext : this.ctx;
            context2d.save();
            context2d.beginPath();
            var points = options["points"].split(" ");
            for (var i = 0; i < points.length - 1; i++) {
                var point = points[i].split(",");
                var x = point[0];
                var y = point[1];
                if (i == 0)
                    context2d.moveTo(x, y);
                else
                    context2d.lineTo(x, y);
            }
            context2d.lineWidth = options["stroke-width"];
            context2d.strokeStyle = options["stroke"];
            context2d.stroke();
            context2d.restore();
            this.dataURL = this.container.toDataURL();
        };
        Sparkline.prototype.canvasDrawText = function (options, label, canvasContext) {
            var font = options['font'];
            var anchor = options["text-anchor"];
            var opacity = options["opacity"] !== undefined ? options["opacity"] : 1;
            if (anchor == "middle")
                anchor = "center";
            var context2d = canvasContext ? canvasContext : this.ctx;
            context2d.save();
            context2d.fillStyle = options["fill"];
            context2d.font = font;
            context2d.textAlign = anchor;
            context2d.globalAlpha = opacity;
            if (options["baseline"])
                context2d.textBaseline = options["baseline"];
            var txtlngth = 0;
            if (options["labelRotation"] == 90 && options["id"].indexOf("XLabel") != -1)
                txtlngth = context2d.measureText(label).width;
            context2d.translate(options["x"] + (txtlngth / 2), options["y"]);
            context2d.rotate(options["labelRotation"] * Math.PI / 180);
            context2d.fillText(label, 0, 0);
            context2d.restore();
            this.dataURL = this.container.toDataURL();
        };
        Sparkline.prototype.measureText = function (text, font) {
            var element = document.getElementById("measureTex"), textObj;
            if (!element || element.clientHeight == 0) {
                textObj = document.createElement('text');
                textObj.setAttribute('id', 'measureTex');
                document.body.appendChild(textObj);
            }
            else {
                textObj = element;
            }
            var style = null, size = null, family = null, weight = null;
            if (typeof (text) == "string" && (text.indexOf("<") > -1 || text.indexOf(">") > -1)) {
                var textArray = text.split(" ");
                for (var i = 0; i < textArray.length; i++) {
                    if (textArray[i].indexOf("<br/>") == -1)
                        textArray[i] = textArray[i].replace(/[<>]/g, '&');
                }
                text = textArray.join(' ');
            }
            textObj.innerHTML = text;
            if (font != undefined && font.size == undefined) {
                var fontarray = font;
                fontarray = fontarray.split(" ");
                style = fontarray[0];
                size = fontarray[1];
                family = fontarray[2];
                weight = fontarray[3];
            }
            if (font != null) {
                textObj.style.fontSize = (font.size > 0) ? (font.size + "px") : font.size ? font.size : size;
                if (textObj.style.fontStyle)
                    textObj.style.fontStyle = (font.fontStyle) ? font.fontStyle : style;
                textObj.style.fontFamily = font.fontFamily ? font.fontFamily : family;
                if (window.navigator.userAgent.indexOf('MSIE 8.0') == -1)
                    textObj.style.fontWeight = font.fontWeight ? font.fontWeight : weight;
            }
            textObj.style.backgroundColor = 'white';
            textObj.style.position = 'absolute';
            textObj.style.top = -100 + "px";
            textObj.style.left = 0 + 'px';
            textObj.style.visibility = 'hidden';
            textObj.style.whiteSpace = 'nowrap';
            var bounds = { width: textObj.offsetWidth, height: textObj.offsetHeight };
            return bounds;
        };
        return Sparkline;
    }(ej.WidgetBase));
    ejSparkline.Sparkline = Sparkline;
    ej.widget("ejSparkline", "ej.Sparkline", new Sparkline());
    ejSparkline.deepExtend = function (out) {
        out = out || {};
        for (var i = 1; i < arguments.length; i++) {
            var obj = arguments[i];
            if (!obj)
                continue;
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    if (typeof obj[key] === 'object')
                        out[key] = ejSparkline.deepExtend(out[key], obj[key]);
                    else
                        out[key] = obj[key];
                }
            }
        }
        return out;
    };
    ejSparkline.compareExtend = function (temp, src, def) {
        if (typeof def === 'object' && def !== null) {
            var defProp = Object.keys(def), len = defProp.length, currPro;
            for (var i = 0; i < len; i++) {
                currPro = defProp[i];
                if (src.hasOwnProperty(currPro) && src[currPro] != null) {
                    if (Array.isArray(src[currPro]) || typeof src[currPro] === 'object' && src[currPro] !== null) {
                        ejSparkline.compareExtend({}, src[currPro], def[currPro]);
                    }
                }
                else {
                    src[currPro] = def[currPro];
                }
            }
        }
        return src;
    };
})(ejSparkline || (ejSparkline = {}));
;
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ejSunburstChart;
(function (ejSunburstChart) {
    (function (sunburstHorizontalAlignment) {
        sunburstHorizontalAlignment[sunburstHorizontalAlignment["left"] = "left"] = "left";
        sunburstHorizontalAlignment[sunburstHorizontalAlignment["right"] = "right"] = "right";
        sunburstHorizontalAlignment[sunburstHorizontalAlignment["center"] = "center"] = "center";
    })(ejSunburstChart.sunburstHorizontalAlignment || (ejSunburstChart.sunburstHorizontalAlignment = {}));
    var sunburstHorizontalAlignment = ejSunburstChart.sunburstHorizontalAlignment;
    (function (sunburstLegendShape) {
        sunburstLegendShape[sunburstLegendShape["circle"] = "circle"] = "circle";
        sunburstLegendShape[sunburstLegendShape["diamond"] = "diamond"] = "diamond";
        sunburstLegendShape[sunburstLegendShape["cross"] = "cross"] = "cross";
        sunburstLegendShape[sunburstLegendShape["pentagon"] = "pentagon"] = "pentagon";
        sunburstLegendShape[sunburstLegendShape["rectangle"] = "rectangle"] = "rectangle";
        sunburstLegendShape[sunburstLegendShape["triangle"] = "triangle"] = "triangle";
    })(ejSunburstChart.sunburstLegendShape || (ejSunburstChart.sunburstLegendShape = {}));
    var sunburstLegendShape = ejSunburstChart.sunburstLegendShape;
    (function (sunburstVerticalAlignment) {
        sunburstVerticalAlignment[sunburstVerticalAlignment["top"] = "top"] = "top";
        sunburstVerticalAlignment[sunburstVerticalAlignment["bottom"] = "bottom"] = "bottom";
        sunburstVerticalAlignment[sunburstVerticalAlignment["middle"] = "middle"] = "middle";
    })(ejSunburstChart.sunburstVerticalAlignment || (ejSunburstChart.sunburstVerticalAlignment = {}));
    var sunburstVerticalAlignment = ejSunburstChart.sunburstVerticalAlignment;
    (function (sunburstTheme) {
        sunburstTheme[sunburstTheme["flatlight"] = "flatlight"] = "flatlight";
        sunburstTheme[sunburstTheme["flatdark"] = "flatdark"] = "flatdark";
    })(ejSunburstChart.sunburstTheme || (ejSunburstChart.sunburstTheme = {}));
    var sunburstTheme = ejSunburstChart.sunburstTheme;
    (function (sunburstHighlightType) {
        sunburstHighlightType[sunburstHighlightType["opacity"] = "opacity"] = "opacity";
        sunburstHighlightType[sunburstHighlightType["color"] = "color"] = "color";
    })(ejSunburstChart.sunburstHighlightType || (ejSunburstChart.sunburstHighlightType = {}));
    var sunburstHighlightType = ejSunburstChart.sunburstHighlightType;
    (function (sunburstAnimationType) {
        sunburstAnimationType[sunburstAnimationType["rotation"] = "rotation"] = "rotation";
        sunburstAnimationType[sunburstAnimationType["fadeIn"] = "fadeIn"] = "fadeIn";
    })(ejSunburstChart.sunburstAnimationType || (ejSunburstChart.sunburstAnimationType = {}));
    var sunburstAnimationType = ejSunburstChart.sunburstAnimationType;
    (function (sunburstSelectionType) {
        sunburstSelectionType[sunburstSelectionType["opacity"] = "opacity"] = "opacity";
        sunburstSelectionType[sunburstSelectionType["color"] = "color"] = "color";
    })(ejSunburstChart.sunburstSelectionType || (ejSunburstChart.sunburstSelectionType = {}));
    var sunburstSelectionType = ejSunburstChart.sunburstSelectionType;
    (function (sunburstLegendPosition) {
        sunburstLegendPosition[sunburstLegendPosition["top"] = "top"] = "top";
        sunburstLegendPosition[sunburstLegendPosition["bottom"] = "bottom"] = "bottom";
        sunburstLegendPosition[sunburstLegendPosition["left"] = "left"] = "left";
        sunburstLegendPosition[sunburstLegendPosition["right"] = "right"] = "right";
        sunburstLegendPosition[sunburstLegendPosition["float"] = "float"] = "float";
    })(ejSunburstChart.sunburstLegendPosition || (ejSunburstChart.sunburstLegendPosition = {}));
    var sunburstLegendPosition = ejSunburstChart.sunburstLegendPosition;
    (function (sunburstLegendClickAction) {
        sunburstLegendClickAction[sunburstLegendClickAction["none"] = "none"] = "none";
        sunburstLegendClickAction[sunburstLegendClickAction["toggleSegmentVisibility"] = "toggleSegmentVisibility"] = "toggleSegmentVisibility";
        sunburstLegendClickAction[sunburstLegendClickAction["toggleSegmentSelection"] = "toggleSegmentSelection"] = "toggleSegmentSelection";
    })(ejSunburstChart.sunburstLegendClickAction || (ejSunburstChart.sunburstLegendClickAction = {}));
    var sunburstLegendClickAction = ejSunburstChart.sunburstLegendClickAction;
    (function (sunburstAlignment) {
        sunburstAlignment[sunburstAlignment["near"] = "near"] = "near";
        sunburstAlignment[sunburstAlignment["far"] = "far"] = "far";
        sunburstAlignment[sunburstAlignment["center"] = "center"] = "center";
    })(ejSunburstChart.sunburstAlignment || (ejSunburstChart.sunburstAlignment = {}));
    var sunburstAlignment = ejSunburstChart.sunburstAlignment;
    (function (sunburstHighlightMode) {
        sunburstHighlightMode[sunburstHighlightMode["point"] = "point"] = "point";
        sunburstHighlightMode[sunburstHighlightMode["all"] = "all"] = "all";
        sunburstHighlightMode[sunburstHighlightMode["child"] = "child"] = "child";
        sunburstHighlightMode[sunburstHighlightMode["parent"] = "parent"] = "parent";
    })(ejSunburstChart.sunburstHighlightMode || (ejSunburstChart.sunburstHighlightMode = {}));
    var sunburstHighlightMode = ejSunburstChart.sunburstHighlightMode;
    (function (sunburstSelectionMode) {
        sunburstSelectionMode[sunburstSelectionMode["point"] = "point"] = "point";
        sunburstSelectionMode[sunburstSelectionMode["all"] = "all"] = "all";
        sunburstSelectionMode[sunburstSelectionMode["child"] = "child"] = "child";
        sunburstSelectionMode[sunburstSelectionMode["parent"] = "parent"] = "parent";
    })(ejSunburstChart.sunburstSelectionMode || (ejSunburstChart.sunburstSelectionMode = {}));
    var sunburstSelectionMode = ejSunburstChart.sunburstSelectionMode;
    (function (sunburstLabelOverflowMode) {
        sunburstLabelOverflowMode[sunburstLabelOverflowMode["trim"] = "trim"] = "trim";
        sunburstLabelOverflowMode[sunburstLabelOverflowMode["hide"] = "hide"] = "hide";
        sunburstLabelOverflowMode[sunburstLabelOverflowMode["none"] = "none"] = "none";
    })(ejSunburstChart.sunburstLabelOverflowMode || (ejSunburstChart.sunburstLabelOverflowMode = {}));
    var sunburstLabelOverflowMode = ejSunburstChart.sunburstLabelOverflowMode;
    (function (sunburstLabelRotationMode) {
        sunburstLabelRotationMode[sunburstLabelRotationMode["angle"] = "angle"] = "angle";
        sunburstLabelRotationMode[sunburstLabelRotationMode["normal"] = "normal"] = "normal";
    })(ejSunburstChart.sunburstLabelRotationMode || (ejSunburstChart.sunburstLabelRotationMode = {}));
    var sunburstLabelRotationMode = ejSunburstChart.sunburstLabelRotationMode;
    (function (titleAlignment) {
        titleAlignment[titleAlignment["center"] = "center"] = "center";
        titleAlignment[titleAlignment["near"] = "near"] = "near";
        titleAlignment[titleAlignment["far"] = "far"] = "far";
    })(ejSunburstChart.titleAlignment || (ejSunburstChart.titleAlignment = {}));
    var titleAlignment = ejSunburstChart.titleAlignment;
    var SunburstChart = (function (_super) {
        __extends(SunburstChart, _super);
        function SunburstChart(id, options) {
            _super.call(this);
            this.defaults = {
                enableAnimation: false,
                load: null,
                preRender: null,
                loaded: null,
                dataLabelRendering: null,
                titleRendering: null,
                tooltipInitialize: null,
                pointRegionClick: null,
                drillDownClick: null,
                drillDownBack: null,
                drillDownReset: null,
                pointRegionMouseMove: null,
                legendItemRendering: null,
                legendItemClick: null,
                segmentRendering: null,
                animationType: sunburstAnimationType.rotation,
                palette: null,
                opacity: 1,
                valueMemberPath: null,
                margin: { top: 10, bottom: 10, left: 10, right: 10 },
                points: {
                    x: null,
                    y: null,
                    text: null,
                    fill: null
                },
                border: {
                    color: null,
                    width: 2
                },
                segmentBorder: {
                    color: null,
                    width: 2
                },
                startAngle: null,
                endAngle: null,
                dataSource: null,
                isResponsive: true,
                size: {
                    height: "",
                    width: ""
                },
                innerRadius: 0.4,
                radius: 1,
                tooltip: {
                    visible: false,
                    border: {
                        color: "#707070",
                        width: 1
                    },
                    fill: "#FFFFFF",
                    opacity: 0.95,
                    font: {
                        fontFamily: "Segoe UI",
                        fontStyle: "Normal",
                        fontWeight: "Regular",
                        color: "#707070",
                        opacity: 1,
                        size: "12px"
                    },
                    template: null,
                    format: "#point.x# : #point.y#",
                },
                dataLabelSettings: {
                    visible: false,
                    labelRotationMode: sunburstLabelRotationMode.angle,
                    font: {
                        fontFamily: "Segoe UI",
                        fontStyle: "Normal",
                        fontWeight: "Regular",
                        color: null,
                        opacity: 1,
                        size: "12px"
                    },
                    template: null,
                    fill: null,
                    labelOverflowMode: sunburstLabelOverflowMode.trim
                },
                title: {
                    text: "",
                    textAlignment: sunburstAlignment.center,
                    font: {
                        fontFamily: "Segoe UI",
                        fontWeight: "Regular",
                        fontStyle: "Normal",
                        color: null,
                        opacity: 1,
                        size: "20px"
                    },
                    subtitle: {
                        visible: true,
                        textAlignment: sunburstAlignment.far,
                        text: "",
                        font: {
                            fontFamily: "Segoe UI",
                            fontWeight: "Regular",
                            fontStyle: "Normal",
                            color: null,
                            opacity: 1,
                            size: "12px"
                        },
                    },
                    visible: true
                },
                zoomSettings: {
                    enable: false,
                    toolbarHorizontalAlignment: sunburstHorizontalAlignment.right,
                    toolbarVerticalAlignment: sunburstVerticalAlignment.top
                },
                highlightSettings: {
                    enable: false,
                    mode: sunburstHighlightMode.point,
                    opacity: 0.5,
                    color: "red",
                    type: sunburstHighlightType.opacity
                },
                selectionSettings: {
                    enable: false,
                    mode: sunburstSelectionMode.point,
                    opacity: 0.5,
                    color: "green",
                    type: sunburstSelectionType.opacity
                },
                levels: null,
                legend: {
                    clickAction: sunburstLegendClickAction.toggleSegmentVisibility,
                    visible: false,
                    position: sunburstLegendPosition.bottom,
                    rowCount: null,
                    columnCount: null,
                    shape: sunburstLegendShape.circle,
                    alignment: sunburstAlignment.center,
                    title: {
                        font: {
                            fontFamily: "Segoe UI",
                            fontWeight: "Regular",
                            fontStyle: "Normal",
                            color: null,
                            opacity: 1,
                            size: "12px"
                        },
                        text: "",
                        textAlignment: sunburstAlignment.center,
                        visible: true
                    },
                    itemStyle: {
                        height: 7.5,
                        width: 7.5,
                    },
                    itemPadding: 10,
                    size: {
                        height: null,
                        width: null
                    },
                    border: {
                        color: null,
                        width: 1
                    },
                    font: {
                        fontFamily: "Segoe UI",
                        fontWeight: "Regular",
                        fontStyle: "Normal",
                        color: null,
                        opacity: 1,
                        size: "12px"
                    },
                    location: {
                        x: null,
                        y: null
                    },
                },
                theme: sunburstTheme.flatlight,
                background: null
            };
            this.model = null;
            this.svgLink = "http://www.w3.org/2000/svg";
            this.elementSpacing = 10;
            this._id = null;
            this._legendHighlight = false;
            this.legendClicked = false;
            this._legendMaxWidth = 0;
            this._legendMaxHeight = 0;
            this._drillInnerRadius = [];
            this._drillOuterRadius = [];
            this.common = { data: null, cancel: false };
            this.legendPages = [];
            this.groupID = [];
            this.highlightgroupID = [];
            this.selectedgroupID = [];
            this.baseID = null;
            this._previousState = [];
            this._drillDownStartAngle = [];
            this._drillDownEndAngle = [];
            this._sunburstRedraw = false;
            this._isDoubleClickEvent = false;
            this.tapCount = 0;
            this.drilldownCount = 0;
            this.tapped = 0;
            this._points = [];
            this.visiblePoints = [];
            this.parentNames = [];
            this.levelNames = [];
            this.isResize = false;
            this.revAnimation = false;
            this.validTags = ['div'];
            this._id = id;
            if (!!options)
                this.model = ejSunburstChart.compareExtend({}, options, this.defaults);
        }
        SunburstChart.prototype._destroy = function () {
            var container;
            container = document.getElementById(this.container.id);
            if (!this.isNullOrUndefined(container)) {
                this.unBindEvents(this.parentElement);
                this.unbindResizeEvents();
                container.parentNode.removeChild(container);
            }
        };
        SunburstChart.prototype.unBindEvents = function (element) {
            var insideEvents = "", browserInfo = this.browserInfo(), isPointer = browserInfo.isMSPointerEnabled, isIE11Pointer = browserInfo.pointerEnabled, touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup", touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove";
            insideEvents = touchMoveEvent;
            insideEvents = insideEvents.split(" ");
            for (var event_1 in insideEvents) {
                element.removeEventListener(insideEvents[event_1], this.sunburstMousemove);
                element.removeEventListener(touchStopEvent, this.sunburstLeave);
            }
            element.removeEventListener('mouseout', this.sunburstLeave);
        };
        SunburstChart.prototype.unbindResizeEvents = function () {
            if (ej.isTouchDevice() && this._isOrientationSupported())
                window.removeEventListener("orientationchange", this.sunBurstResize);
            else
                window.removeEventListener('resize', this.sunBurstResize);
        };
        SunburstChart.prototype._setModel = function (options) {
            for (var prop in options) {
                switch (prop) {
                    default:
                        ejSunburstChart.deepExtend(true, this.model, {}, options[prop]);
                }
            }
            this.redraw();
        };
        SunburstChart.prototype.supportSVG = function () {
            return !!document.createElementNS && !!document.createElementNS('http://www.w3.org/2000/svg', "svg");
        };
        SunburstChart.prototype._init = function () {
            if (this.supportSVG()) {
                var element = void 0, svgElement = void 0, commonLoadEventArgs = void 0, commonpreRenderEventArgs = void 0, commonLoadedEventArgs = void 0;
                this._startAngle = this.model.startAngle;
                this._endAngle = this.model.endAngle;
                if (!this.isResize) {
                    this._enableAnimation = this.model.enableAnimation;
                    this._drillDownStartAngle = [];
                    this._drillDownEndAngle = [];
                    this._drillInnerRadius = [];
                    this._drillOuterRadius = [];
                }
                commonLoadEventArgs = $.extend({}, this.common);
                this._trigger("load", commonLoadEventArgs);
                this.parentElement = this.isNullOrUndefined(this.parentElement) ? document.getElementById(this._id) : this.parentElement;
                svgElement = this.createSvg({ 'id': this._id + '_svg' });
                this.container = svgElement;
                this.parentElement.appendChild(svgElement);
                this.setSvgsize(this.model.size, this._id);
                if (this._sunburstRedraw == false)
                    this.bindEvents(this.parentElement);
                if (!this.isResize) {
                    if (!this.isNullOrUndefined(this.model.dataSource) && this.model.dataSource.length > 0)
                        this.processDataSource(this.model.dataSource);
                    this.setColors(this.model.points);
                    this._previousState.push(this.model.points);
                    this.processData(this.model.points);
                }
                else
                    this.isResize = this.isResize ? false : true;
                commonpreRenderEventArgs = $.extend({}, this.common);
                commonpreRenderEventArgs['data'] = {};
                this._trigger("preRender", commonpreRenderEventArgs);
                this.drawSunburst(this.layerData);
                if (this._isDrillDown)
                    this.drawToolbar(svgElement);
                commonLoadedEventArgs = $.extend({}, this.common);
                commonLoadedEventArgs['data'] = { model: this.model };
                this._trigger("loaded", commonLoadedEventArgs);
            }
            else {
                alert("Sunburst will not be support in IE version < 8");
            }
        };
        SunburstChart.prototype.drawSunburst = function (layerData) {
            var rect, titleEle, sunburst, datalabelEle, size, title = this.model.title, legend = this.model.legend, dataLabel = this.model.dataLabelSettings, enableAnimation = this.model.enableAnimation;
            rect = this.drawContainerRect();
            document.getElementById(this._id + '_svg').appendChild(rect);
            if (legend['visible'] && !this.legendClicked) {
                this.calculateLegendBounds();
            }
            size = { width: this.width, height: this.height };
            if (title['text'] != "" && title['visible']) {
                titleEle = this.drawTitle(title, size);
                document.getElementById(this._id + '_svg').appendChild(titleEle);
            }
            this.areaBounds = this.calculateSize(size, title);
            sunburst = this.sunburstRender(layerData);
            document.getElementById(this._id + "_svg").appendChild(sunburst);
            if (this._enableAnimation) {
                var endAngle = void 0, length_1;
                this.groupingRegions(this.model.points);
                if (this.animationRegions.length > 0) {
                    if (this.model.animationType == sunburstAnimationType.rotation) {
                        if (!this._isDrillDown)
                            this.rotateAnimation(this, this.animationRegions);
                        else
                            this.rotateDrillDownAnimation(this, this.animationRegions);
                    }
                    else {
                        if (this.totallayerCount > 1) {
                            length_1 = this.animationRegions[0].length;
                            endAngle = this.animationRegions[0][length_1 - 1]['endAngle'];
                        }
                        else {
                            length_1 = this.animationRegions.length;
                            endAngle = this.animationRegions[length_1 - 1][0]['endAngle'];
                        }
                        this.animateLayer(this, sunburst, this.animationRegions[0], 0, 0, endAngle);
                    }
                }
            }
            if (dataLabel['visible']) {
                datalabelEle = this.drawDatalabel(layerData);
                if (dataLabel['template'] == null) {
                    if (this._enableAnimation)
                        datalabelEle.setAttribute('visibility', 'hidden');
                    document.getElementById(this._id + "_svg").appendChild(datalabelEle);
                }
                else {
                    if (this._enableAnimation)
                        document.getElementById(datalabelEle.id).style.visibility = 'hidden';
                }
                this.sunburstDoubleClick = this.sunburstDoubleClick.bind(this);
                document.getElementById(datalabelEle.id).addEventListener('dblclick', this.sunburstDoubleClick, true);
            }
            if (legend['visible']) {
                this.gLegendEle = this.createGroup({ id: this._id + "SunburstLegend" });
                if (this.model.legendInitialize) {
                    var commonEventArgs = $.extend({}, this.common);
                    this._trigger("legendInitialize", commonEventArgs);
                }
                this.drawSunburstLegend();
            }
        };
        SunburstChart.prototype.animateLayer = function (sunburst, sunburstEle, layer, pointInd, layerInd, totalendAngle) {
            var startAngle = layer[pointInd]['startAngle'], endAngle = layer[pointInd]['endAngle'], totalDegree, point, layerNumber, layerIndex, pointIndex, end, result, radius, path, start = startAngle, elementId, opacityRatio, opacity = 0, frameCount = 50, ct;
            totalDegree = (endAngle - startAngle) / Math.ceil(((frameCount * (endAngle - startAngle)) / totalendAngle));
            opacityRatio = (sunburst.model.opacity / 2) / Math.ceil(((frameCount * (endAngle - startAngle)) / totalendAngle));
            point = layer[pointInd];
            this.layeranim = setInterval(function () {
                layerNumber = point['layerNumber'];
                layerIndex = point['layerIndex'];
                pointIndex = point['pointIndex'];
                radius = sunburst.circularRadius[layerNumber - 1];
                elementId = point['id'];
                start = start + totalDegree;
                end = start;
                point['endAngle'] = end > endAngle ? endAngle : end;
                if (sunburst.isNullOrUndefined(sunburst.model))
                    clearInterval(sunburst.layeranim);
                else {
                    result = sunburst.calculateArcData(point, layerNumber, radius);
                    path = sunburstEle.querySelector('#' + elementId);
                    opacity += opacityRatio;
                    if (path) {
                        path.setAttribute('d', result['Direction']);
                        path.setAttribute('opacity', opacity.toString());
                    }
                    if (document.getElementById(elementId).getAttribute('visibility') == 'hidden') {
                        document.getElementById(elementId).setAttribute('visibility', 'visible');
                    }
                    if (end >= endAngle) {
                        clearInterval(sunburst.layeranim);
                        sunburst.fadeIn(path, opacity, sunburst, opacityRatio);
                        pointInd = pointInd + 1;
                        if (pointInd < layer.length) {
                            sunburst.animateLayer(sunburst, sunburstEle, layer, pointInd, layerInd, totalendAngle);
                        }
                        else {
                            pointInd = 0;
                            layerInd = layerInd + 1;
                            if (layerInd < sunburst.animationRegions.length)
                                sunburst.animateLayer(sunburst, sunburstEle, sunburst.animationRegions[layerInd], pointInd, layerInd, totalendAngle);
                            else {
                                if (sunburst.model.dataLabelSettings.visible)
                                    document.getElementById(sunburst._id + "_svg_DataLabelGroup").style.visibility = "visible";
                            }
                        }
                    }
                }
            }, 10);
        };
        SunburstChart.prototype.fadeIn = function (path, opacity, sunburst, opacityRatio) {
            var fadeIn = setInterval(function () {
                opacity = opacity + 0.1;
                path.setAttribute('opacity', opacity.toString());
                if (sunburst.model == null || opacity >= sunburst.model.opacity)
                    clearInterval(fadeIn);
            }, 50);
        };
        SunburstChart.prototype.rotateAnimation = function (sunburst, region) {
            var length = region.length, start = 0, end = 0, existingGroup, currentGroupPath, endAngle, startAngle, svg, scaleX = 0, transX, transY, angleDiff, scaleIncr, increaseAngle = 0;
            svg = document.getElementById(sunburst._id + "_svg");
            startAngle = sunburst.model.startAngle || 0;
            endAngle = sunburst.model.endAngle || 360;
            angleDiff = Math.abs(endAngle - startAngle);
            scaleIncr = 1 / (angleDiff / 10);
            end = (20 / 360) * angleDiff + startAngle;
            if (length > 0) {
                this.rotateanim = setInterval(function () {
                    if (sunburst.model) {
                        existingGroup = document.getElementById(sunburst._id + "_svg_SunBurstElementGroup");
                        if (existingGroup != null)
                            existingGroup.parentNode.removeChild(existingGroup);
                        sunburst.model.startAngle = startAngle;
                        sunburst.model.endAngle = end > endAngle ? endAngle : end;
                        sunburst._enableAnimation = false;
                        currentGroupPath = sunburst.sunburstRender(sunburst.layerData);
                        svg.appendChild(currentGroupPath);
                        scaleX = scaleX + scaleIncr;
                        scaleX = scaleX > 1 ? 1 : scaleX;
                        transX = (sunburst.width / 2) * (1 - scaleX);
                        transY = (sunburst.height / 2) * (1 - scaleX);
                        currentGroupPath.setAttribute("transform", "translate(" + transX + "," + transY + ") scale(" + scaleX + ")");
                        if (end >= endAngle) {
                            clearInterval(sunburst.rotateanim);
                            sunburst.rotateanim = undefined;
                            sunburst._enableAnimation = true;
                            sunburst.model.startAngle = startAngle;
                            sunburst.model.endAngle = endAngle;
                            if (sunburst.model.dataLabelSettings.visible) {
                                var dataLabel = document.getElementById(sunburst._id + "_svg_DataLabelGroup"), opacity = 0.1;
                                if (sunburst.model.dataLabelSettings.template == null)
                                    document.getElementById(sunburst._id + "_svg").appendChild(dataLabel);
                                else
                                    document.getElementById(sunburst._id).appendChild(dataLabel);
                                dataLabel.style.visibility = "visible";
                                dataLabel.style.opacity = opacity.toString();
                                sunburst.datalabelanim = setInterval(function () {
                                    dataLabel.style.opacity = opacity.toString();
                                    opacity = opacity + 0.05;
                                    if (opacity > 1)
                                        clearInterval(sunburst.datalabelanim);
                                }, 10);
                            }
                        }
                        end = end + (10 - increaseAngle);
                        increaseAngle = increaseAngle + 0.1;
                        scaleIncr = 1 / (angleDiff / 10 - increaseAngle);
                    }
                    else
                        clearInterval(sunburst.rotateanim);
                }, 25);
            }
        };
        SunburstChart.prototype.rotateDrillDownAnimation = function (sunburst, region) {
            var length = region.length, start = 0, end = 0, existingGroup, currentGroupPath, endAngle, startAngle, svg, increaseAngle = 0, animationStartAngle = 0, increaseStartAngle, increaseEndAngle, interval = 1, increaseInterval = 0.05, animationEndAngle = 0;
            svg = document.getElementById(sunburst._id + "_svg");
            startAngle = sunburst.model.startAngle || 0;
            endAngle = sunburst.model.endAngle || 360;
            start = animationStartAngle = sunburst._drillDownStartAngle[sunburst.drilldownCount - 1];
            end = animationEndAngle = sunburst._drillDownEndAngle[sunburst.drilldownCount - 1];
            increaseStartAngle = (start - startAngle) / 20;
            increaseEndAngle = (endAngle - end) / 20;
            if (length > 0) {
                var animate_1 = setInterval(function () {
                    existingGroup = document.getElementById(sunburst._id + "_svg_SunBurstElementGroup");
                    existingGroup.parentNode.removeChild(existingGroup);
                    sunburst.model.startAngle = animationStartAngle < startAngle ? startAngle : animationStartAngle;
                    sunburst.model.endAngle = animationEndAngle > endAngle ? endAngle : animationEndAngle;
                    sunburst._enableAnimation = false;
                    currentGroupPath = sunburst.sunburstRender(sunburst.layerData);
                    svg.appendChild(currentGroupPath);
                    if (animationStartAngle <= startAngle && animationEndAngle >= endAngle) {
                        clearInterval(animate_1);
                        sunburst._enableAnimation = true;
                        sunburst.model.startAngle = startAngle;
                        sunburst.model.endAngle = endAngle;
                        if (sunburst.model.dataLabelSettings.visible) {
                            var dataLabel = document.getElementById(sunburst._id + "_svg_DataLabelGroup"), opacity = 0.1;
                            if (sunburst.model.dataLabelSettings.template == null)
                                document.getElementById(sunburst._id + "_svg").appendChild(dataLabel);
                            else
                                document.getElementById(sunburst._id).appendChild(dataLabel);
                            dataLabel.style.visibility = "visible";
                            dataLabel.style.opacity = opacity.toString();
                            var dataLabelAnimate_1 = setInterval(function () {
                                dataLabel.style.opacity = opacity.toString();
                                opacity = opacity + 0.05;
                                if (opacity > 1)
                                    clearInterval(dataLabelAnimate_1);
                            }, 10);
                        }
                    }
                    interval = interval + (1 - increaseInterval);
                    increaseInterval = increaseInterval + 0.015;
                    increaseInterval = increaseInterval > 0.7 ? 0.7 : increaseInterval;
                    animationStartAngle = start - (increaseStartAngle * interval);
                    animationEndAngle = end + (increaseEndAngle * interval);
                }, 25);
            }
        };
        SunburstChart.prototype.groupingRegions = function (points) {
            var regions = this.sunburstRegions, elements, layer, parentRegion = this.sunburstRegions[this.sunburstRegions.length - 1]['region'], layerData, layerNumber, layers = [], groupNumber;
            this.animationRegions = [];
            layers.push(parentRegion);
            for (var i = 0; i < parentRegion.length; i++) {
                if (regions.length > 1) {
                    elements = [];
                    layer = this.layerData[parentRegion[i]['layerIndex']]['point'][parentRegion[i]['pointIndex']];
                    groupNumber = layer['groupNumber'];
                    if (!this.isNullOrUndefined(layer['point'])) {
                        this.findChildRegions(layer['point'], elements, layer['layerNumber'], layers, groupNumber);
                    }
                    if (this.model.animationType == sunburstAnimationType.rotation) {
                        elements.splice(0, 0, layer);
                        layer['count'] = 0;
                        layer['groupLength'] = elements.length;
                        this.animationRegions.push(elements);
                    }
                    else {
                        this.animationRegions = layers;
                    }
                }
                else {
                    elements = [];
                    elements.push(parentRegion[i]);
                    this.animationRegions.push(elements);
                }
            }
        };
        SunburstChart.prototype.findChildRegions = function (layer, elements, layerNumber, layers, groupNumber) {
            for (var i = 0; i < layer['length']; i++) {
                layer[i]['pointIndex'] = i;
                layer[i]['layerNumber'] = this.layerData[layer['layerData']]['layerNumber'];
                layer[i]['groupNumber'] = groupNumber;
                layer[i]['count'] = 0;
                if (this.model.animationType == sunburstAnimationType.rotation)
                    elements.push(layer[i]);
                else {
                    if (this.isNullOrUndefined(layers[layer[i]['layerNumber'] - 1]))
                        layers[layer[i]['layerNumber'] - 1] = [];
                    layers[layer[i]['layerNumber'] - 1].push(layer[i]);
                }
                if (!this.isNullOrUndefined(layer[i]['point'])) {
                    this.findChildRegions(layer[i]['point'], elements, layerNumber, layers, groupNumber);
                }
            }
        };
        SunburstChart.prototype.bindEvents = function (element) {
            var insideEvents = "", mouseMove = "", browserInfo = this.browserInfo(), isDevice = ej.isDevice(), isPointer = browserInfo.isMSPointerEnabled, isIE11Pointer = browserInfo.pointerEnabled, touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : "touchend mouseup", touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : "touchmove mousemove";
            insideEvents = touchMoveEvent;
            insideEvents = insideEvents.split(" ");
            this.sunburstMousemove = this.sunburstMousemove.bind(this);
            this.sunburstClick = this.sunburstClick.bind(this);
            element.addEventListener('click', this.sunburstClick, true);
            this.sunburstLeave = this.sunburstLeave.bind(this);
            for (var event_2 in insideEvents) {
                element.addEventListener(touchStopEvent, this.sunburstLeave);
                mouseMove = insideEvents[event_2];
                if (isDevice && mouseMove == "mousemove")
                    continue;
                element.addEventListener(mouseMove, this.sunburstMousemove);
            }
            if (isDevice)
                element.addEventListener("mousedown", this.sunburstMousemove);
            element.addEventListener('mouseout', this.sunburstLeave, true);
            if (this.getIEversion() != -1) {
                this.sunburstDoubletap = this.sunburstDoubletap.bind(this);
                element.addEventListener('pointerdown', this.sunburstDoubletap, true);
            }
            if (this.model.isResponsive)
                this.bindResizeEvents();
        };
        SunburstChart.prototype.browserInfo = function () {
            var browser = {}, clientInfo = [], browserClients = {
                webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
                opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
            };
            for (var client in browserClients) {
                if (browserClients.hasOwnProperty(client)) {
                    clientInfo = navigator.userAgent.match(browserClients[client]);
                    if (clientInfo) {
                        browser.name = clientInfo[1].toLowerCase();
                        browser.version = clientInfo[2];
                        if (!!navigator.userAgent.match(/Trident\/7\./)) {
                            browser.name = "msie";
                        }
                        break;
                    }
                }
            }
            browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
            browser.pointerEnabled = window.navigator.pointerEnabled;
            return browser;
        };
        SunburstChart.prototype.sunburstDoubletap = function (event) {
            var targetid = event.target['id'], totalnum;
            if (targetid.indexOf("reset") == -1 && targetid.indexOf("back") == -1) {
                event.preventDefault();
                this.tapped = this.tapped + 1;
                totalnum = this.tapped;
            }
        };
        SunburstChart.prototype.bindResizeEvents = function () {
            this.sunBurstResize = this.sunBurstResize.bind(this);
            if (ej.isTouchDevice() && this._isOrientationSupported())
                window.addEventListener("orientationchange", this.sunBurstResize, true);
            else
                window.addEventListener('resize', this.sunBurstResize.bind(this), true);
        };
        SunburstChart.prototype._isOrientationSupported = function () {
            return ("orientation" in window && "onorientationchange" in window);
        };
        SunburstChart.prototype.sunBurstResize = function (element) {
            var sunburst = this;
            var $svgObj = $(sunburst.container);
            if (this._resizeTO)
                clearTimeout(this._resizeTO);
            this._resizeTO = setTimeout(function () {
                if (sunburst.model) {
                    sunburst.isResize = true;
                    if (!sunburst.isNullOrUndefined(document.getElementById(sunburst._id + 'reset'))) {
                        sunburst._isDrillDown = true;
                    }
                    sunburst.legendClicked = true;
                    sunburst._enableAnimation = false;
                    sunburst.redraw();
                    sunburst._enableAnimation = sunburst.model.enableAnimation;
                    sunburst._isDrillDown = false;
                    sunburst.legendClicked = false;
                }
            }, 500);
        };
        SunburstChart.prototype.getIEversion = function () {
            var rv = -1, ua, re;
            if (navigator.appName == 'Microsoft Internet Explorer') {
                ua = navigator.userAgent;
                re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
                if (re.exec(ua) != null)
                    rv = parseFloat(RegExp.$1);
            }
            else if (navigator.appName == 'Netscape') {
                ua = navigator.userAgent;
                re = new RegExp("Trident/.*rv:([0-9]{1,}[\.0-9]{0,})");
                if (re.exec(ua) != null)
                    rv = parseFloat(RegExp.$1);
            }
            return rv;
        };
        SunburstChart.prototype.sunburstDoubleClick = function (event) {
            var data;
            if (this.model.zoomSettings.enable) {
                data = this.getSunburstPoint(event);
                if (!this.isNullOrUndefined(data)) {
                    if (data['pointData'][0]['layerNumber'] == 1) {
                        if (this.drilldownCount == 0) {
                            this.drillDown(data);
                        }
                    }
                    else {
                        this.drillDown(data);
                    }
                }
            }
        };
        SunburstChart.prototype.drillDown = function (data) {
            var layer, point = [], option, drillDownData, element, commonEventArgs, svgElement;
            element = document.getElementById(this._id + '_svg');
            element.parentNode.replaceChild(element.cloneNode(false), element);
            layer = this.layerData[data.pointData[0].layerIndex]['point'][data.pointData[0].pointIndex];
            this.drilldownCount = this.drilldownCount + 1;
            this._drillDownStartAngle.push((layer['startAngle'] * 180) / Math.PI);
            this._drillDownEndAngle.push((layer['endAngle'] * 180) / Math.PI);
            this._isDrillDown = true;
            this._isDoubleClickEvent = true;
            if (this.model.enableAnimation && this.model.animationType == sunburstAnimationType.rotation) {
                var layerNumber = data.pointData[0].layerNumber;
                if (layerNumber == 1) {
                    this._drillInnerRadius.push(this.innerRadius);
                    this._drillOuterRadius.push(this.circularRadius);
                }
                else {
                    var inRadius = this.innerRadius.slice(layerNumber - 1, this.innerRadius.length);
                    var outrRadius = this.circularRadius.slice(layerNumber - 1, this.circularRadius.length);
                    this._drillInnerRadius.push(inRadius);
                    this._drillOuterRadius.push(outrRadius);
                }
            }
            drillDownData = { 'fill': data['pointData'][0].fill, 'x': data['pointData'][0].x, 'y': data['pointData'][0].y, 'point': layer['point'], 'text': data['pointData'][0].text };
            if (this.model.drillDownClick) {
                commonEventArgs = $.extend({}, this.common);
                commonEventArgs['data'] = drillDownData;
                this._trigger("drillDownClick", commonEventArgs);
            }
            point.push(drillDownData);
            this._previousState.push(point);
            this.processData(point);
            this.drawSunburst(this.layerData);
            this._isDrillDown = false;
            if (this.isNullOrUndefined(document.getElementById(this._id + 'reset'))) {
                svgElement = document.getElementById(this._id + '_svg');
                this.drawToolbar(svgElement);
            }
        };
        SunburstChart.prototype.drawToolbar = function (svgElement) {
            var backGroup, resetGroup, svgBounds;
            svgBounds = svgElement.getBoundingClientRect();
            resetGroup = this.drawResetButton(svgBounds);
            svgElement.appendChild(resetGroup);
            this.reset = this.reset.bind(this);
            document.getElementById(this._id + "reset").addEventListener('click', this.reset, true);
            backGroup = this.drawBackButton(svgBounds);
            svgElement.appendChild(backGroup);
            this.back = this.back.bind(this);
            document.getElementById(this._id + "back").addEventListener('click', this.back, true);
            if (!ej.isDevice()) {
                document.getElementById(this._id + "back").addEventListener('mousemove', this.sunburstMousemove, true);
                document.getElementById(this._id + "reset").addEventListener('mousemove', this.sunburstMousemove, true);
            }
            this.toolbarPositioning(backGroup, resetGroup);
        };
        SunburstChart.prototype.toolbarPositioning = function (backGroup, resetGroup) {
            var translate, resettransX, backtransX, transY, resetOptions, backOptions, elementSpacing = this.elementSpacing, tbhorizontalalignment = this.model.zoomSettings.toolbarHorizontalAlignment, tbverticalalignment = this.model.zoomSettings.toolbarVerticalAlignment;
            backOptions = backGroup.getBoundingClientRect();
            resetOptions = resetGroup.getBoundingClientRect();
            if (tbhorizontalalignment == sunburstHorizontalAlignment.right) {
                resettransX = this.width - elementSpacing - resetOptions['width'];
                backtransX = this.width - (2 * elementSpacing) - (2 * resetOptions['width']);
            }
            else if (tbhorizontalalignment == sunburstHorizontalAlignment.left) {
                backtransX = elementSpacing;
                resettransX = (backOptions['width']) + (2 * elementSpacing);
            }
            else if (tbhorizontalalignment == sunburstHorizontalAlignment.center) {
                backtransX = (this.width / 2) - ((backOptions['width'] + elementSpacing + resetOptions['width']) / 2);
                resettransX = backtransX + elementSpacing + backOptions['width'];
            }
            if (tbverticalalignment == sunburstVerticalAlignment.top) {
                transY = elementSpacing;
            }
            else if (tbverticalalignment == sunburstVerticalAlignment.bottom) {
                transY = this.height - elementSpacing - backOptions['height'];
            }
            else if (tbverticalalignment == sunburstVerticalAlignment.middle) {
                transY = (this.height / 2) - (backOptions['height'] / 2);
            }
            translate = 'translate(' + resettransX.toString() + ',' + transY.toString() + ')';
            resetGroup.setAttribute('transform', translate);
            translate = 'translate(' + backtransX.toString() + ',' + transY.toString() + ')';
            backGroup.setAttribute('transform', translate);
        };
        SunburstChart.prototype.drawBackButton = function (rect) {
            var options, element, backGroup;
            backGroup = this.createGroup({ 'id': this._id + 'back' });
            options = {
                'id': this._id + 'backPath',
                'd': "M24,27H3c-1.7,0-3-1.3-3-3V3c0-1.7,1.3-3,3-3h21c1.7,0,3,1.3,3,3v21C27,25.7,25.7,27,24,27z",
                'fill': '#D6D6D6',
            };
            element = this.drawPath(options);
            backGroup.appendChild(element);
            options = {
                'id': this._id + 'backPath1',
                'x': 7.7,
                'y': 12.5,
                'width': 13.8,
                'height': 2,
                'fill': "#5E5C5C"
            };
            element = this.drawRect(options);
            backGroup.appendChild(element);
            options = {
                'id': this._id + 'backPath2',
                'points': "11.4,19.8 5.5,13.5 11.4,7.2 12.9,8.6 8.2,13.5 12.9,18.4",
                'fill': "#5E5C5C",
            };
            element = this.drawPolygon(options);
            backGroup.appendChild(element);
            return backGroup;
        };
        SunburstChart.prototype.back = function (event) {
            var layerData = this.layerData, element = document.getElementById(this._id + '_svg'), backEle = document.getElementById(this._id + "back"), resetEle = document.getElementById(this._id + "reset"), model = this.model, rootEle, commonDrillDownBackEventArgs;
            if (!this.revAnimation) {
                if (model['drillDownBack']) {
                    commonDrillDownBackEventArgs = $.extend({}, this.common);
                    commonDrillDownBackEventArgs['data'] = layerData;
                    this._trigger("drillDownBack", commonDrillDownBackEventArgs);
                }
                if (this._enableAnimation && model['animationType'] == sunburstAnimationType.rotation) {
                    this._enableAnimation = false;
                    this.reverseAnimation(this, this.animationRegions);
                }
                else {
                    element.parentNode.replaceChild(element.cloneNode(false), element);
                    var len = this._previousState.length - 1;
                    this.layerData = this._previousState[len - 1];
                    this._previousState.splice(len, 1);
                    this.drilldownCount = this.drilldownCount - 1;
                    this.processData(this.layerData);
                    this.drawSunburst(this.layerData);
                    if (this.drilldownCount != 0) {
                        rootEle = document.getElementById(this._id + "_svg");
                        rootEle.appendChild(resetEle);
                        rootEle.appendChild(backEle);
                    }
                }
            }
        };
        SunburstChart.prototype.reverseAnimation = function (sunburst, region) {
            var length = region.length, start = 0, end = 0, existingGroup, currentGroupPath, endAngle, startAngle, svg, sAngle, eAngle, increaseStartAngle, increaseEndAngle, interval = 0, dataLabel, backEle = document.getElementById(sunburst._id + "back"), resetEle = document.getElementById(sunburst._id + "reset"), pieSegmentGroup, tempLabel, len, container, opacity = 0.1;
            svg = document.getElementById(sunburst._id + "_svg");
            startAngle = sunburst.model.startAngle || 0;
            endAngle = sunburst.model.endAngle || 360;
            start = sunburst._drillDownStartAngle[sunburst.drilldownCount - 1], end = sunburst._drillDownEndAngle[sunburst.drilldownCount - 1];
            increaseStartAngle = (start - startAngle) / 20;
            increaseEndAngle = (endAngle - end) / 20;
            dataLabel = document.getElementById(sunburst._id + "_svg_DataLabelGroup");
            if (length > 0) {
                var animate_2 = setInterval(function () {
                    sunburst.revAnimation = true;
                    existingGroup = document.getElementById(sunburst._id + "_svg_SunBurstElementGroup");
                    if (existingGroup)
                        existingGroup.parentNode.removeChild(existingGroup);
                    if (dataLabel)
                        dataLabel.style.visibility = "hidden";
                    sAngle = increaseStartAngle * interval + startAngle;
                    sunburst.model.startAngle = sAngle >= start ? start : sAngle;
                    eAngle = endAngle - (increaseEndAngle * interval);
                    sunburst.model.endAngle = eAngle < end ? end : eAngle;
                    currentGroupPath = sunburst.sunburstRender(sunburst.layerData);
                    svg.appendChild(currentGroupPath);
                    if (eAngle <= end && sAngle >= start) {
                        clearInterval(animate_2);
                        pieSegmentGroup = document.getElementById(sunburst._id + "_svg_SunBurstElementGroup");
                        pieSegmentGroup.id = sunburst._id + "_svg_tempSeg";
                        tempLabel = document.getElementById(sunburst._id + "_svg_DataLabelGroup");
                        svg.parentNode.replaceChild(svg.cloneNode(false), svg);
                        document.getElementById(sunburst._id + "_svg").appendChild(pieSegmentGroup);
                        if (tempLabel) {
                            tempLabel.id = sunburst._id + "_svg_tempLabel";
                            document.getElementById(sunburst._id + "_svg").appendChild(tempLabel);
                        }
                        len = sunburst._previousState.length - 1;
                        sunburst.layerData = sunburst._previousState[len - 1];
                        sunburst._previousState.splice(len, 1);
                        sunburst.model.startAngle = startAngle;
                        sunburst.model.endAngle = endAngle;
                        sunburst.drilldownCount = sunburst.drilldownCount - 1;
                        sunburst._drillDownStartAngle.length = sunburst.drilldownCount;
                        sunburst._drillDownEndAngle.length = sunburst.drilldownCount;
                        sunburst._drillInnerRadius.length = sunburst.drilldownCount;
                        sunburst._drillOuterRadius.length = sunburst.drilldownCount;
                        sunburst.processData(sunburst.layerData);
                        sunburst.drawSunburst(sunburst.layerData);
                        if (sunburst.drilldownCount != 0) {
                            svg = document.getElementById(sunburst._id + "_svg");
                            svg.appendChild(resetEle);
                            svg.appendChild(backEle);
                        }
                        sunburst._enableAnimation = true;
                        container = document.getElementById(sunburst._id + "_svg_SunBurstElementGroup");
                        container.style.opacity = opacity.toString();
                        if (dataLabel)
                            dataLabel.style.opacity = opacity.toString();
                        if (sunburst.model.dataLabelSettings.visible) {
                            dataLabel = document.getElementById(sunburst._id + "_svg_DataLabelGroup");
                            if (sunburst.model.dataLabelSettings.template == null)
                                document.getElementById(sunburst._id + "_svg").appendChild(dataLabel);
                            else
                                document.getElementById(sunburst._id).appendChild(dataLabel);
                            dataLabel.style.visibility = "visible";
                            dataLabel.style.opacity = opacity.toString();
                        }
                        var animateByOpacity_1 = setInterval(function () {
                            container.style.opacity = opacity.toString();
                            if (dataLabel)
                                dataLabel.style.opacity = opacity.toString();
                            if (opacity >= 1) {
                                clearInterval(animateByOpacity_1);
                                sunburst.revAnimation = false;
                                pieSegmentGroup.parentNode.removeChild(pieSegmentGroup);
                                if (tempLabel)
                                    tempLabel.parentNode.removeChild(tempLabel);
                            }
                            opacity = opacity + 0.1;
                        }, 50);
                    }
                    interval = interval + 1;
                }, 40);
            }
        };
        SunburstChart.prototype.drawResetButton = function (rect) {
            var options, path, resetGroup, polygon;
            resetGroup = this.createGroup({ 'id': this._id + 'reset' });
            options = {
                'id': this._id + 'resetPath',
                'd': "M24,27H3c-1.7,0-3-1.3-3-3V3c0-1.7,1.3-3,3-3h21c1.7,0,3,1.3,3,3v21C27,25.7,25.7,27,24,27z",
                'fill': '#D6D6D6',
            };
            path = this.drawPath(options);
            resetGroup.appendChild(path);
            options = {
                'id': this._id + 'resetPath1',
                'd': "M13.6,21.9c-3.6,0-6.8-2.3-8-5.7l1.8-0.6c0.9,2.6,3.4,4.4,6.2,4.4c3.4,0,6.2-2.6,6.5-6l1.9,0.2   C21.6,18.6,18,21.9,13.6,21.9z",
                'fill': "#5E5C5C"
            };
            path = this.drawPath(options);
            resetGroup.appendChild(path);
            options = {
                'id': this._id + 'resetPath2',
                'd': "M7.1,12.5l-1.9-0.3c0.6-4.1,4.2-7.1,8.3-7.1c3,0,5.8,1.6,7.3,4.2c0.1,0.2,0.2,0.4,0.3,0.6l-1.7,0.8   c-0.1-0.2-0.2-0.3-0.2-0.4c-1.2-2-3.3-3.3-5.7-3.3C10.4,7,7.6,9.3,7.1,12.5z",
                'fill': "#5E5C5C"
            };
            path = this.drawPath(options);
            resetGroup.appendChild(path);
            options = {
                'id': this._id + 'resetPath3',
                'points': "21.4,11.9 16.2,10.7 16.6,8.9 19.9,9.6 20.7,6.3 22.5,6.7",
                'fill': "#5E5C5C"
            };
            polygon = this.drawPolygon(options);
            resetGroup.appendChild(polygon);
            options = {
                'id': this._id + 'resetPath4',
                'points': "6.3,20.3 4.5,19.9 5.6,14.8 10.8,16 10.4,17.8 7.1,17.1",
                'fill': "#5E5C5C"
            };
            polygon = this.drawPolygon(options);
            resetGroup.appendChild(polygon);
            return resetGroup;
        };
        SunburstChart.prototype.reset = function (event) {
            if (this.model.drillDownReset) {
                var commonDrillDownResetEventArgs = $.extend({}, this.common);
                this._trigger("drillDownReset", commonDrillDownResetEventArgs);
            }
            this.redraw();
        };
        SunburstChart.prototype.redraw = function () {
            this.legendPages = [];
            if (!this.isResize) {
                this.drilldownCount = 0;
                this._previousState = [];
                this._drillDownStartAngle = [];
                this._drillDownEndAngle = [];
                this._drillInnerRadius = [];
                this._drillOuterRadius = [];
            }
            this._sunburstRedraw = true;
            var element = document.getElementById(this._id + "_svg");
            if (!this.isNullOrUndefined(element)) {
                element.parentNode.removeChild(element);
                if (this.rotateanim || this.model.enableAnimation) {
                    this.stopAnimation();
                }
                this.parentElement = undefined;
                this._init();
                this._sunburstRedraw = false;
            }
        };
        SunburstChart.prototype.stopAnimation = function () {
            if (this.rotateanim) {
                clearInterval(this.rotateanim);
                if (!this.isResize)
                    this._enableAnimation = this.model.enableAnimation;
                this.model.startAngle = this._startAngle;
                this.model.endAngle = this._endAngle;
                if (this.datalabelanim)
                    clearInterval(this.datalabelanim);
            }
            if (this.layeranim)
                clearInterval(this.layeranim);
        };
        SunburstChart.prototype.sunburstMousemove = function (event) {
            var elementId = event.target.id, element, data, commonPointRegionMouseMoveEventArgs, transToolTipOptions, location, layerPoint, layer;
            if (elementId.indexOf('reset') != -1 || elementId.indexOf('back') != -1) {
                this.toolbarTooltip(event, elementId);
                if (elementId.indexOf('reset') != -1) {
                    element = document.getElementById(this._id + "reset");
                    for (var i = 0; i < 5; i++) {
                        if (i == 0)
                            document.getElementById(this._id + "resetPath").setAttribute("fill", "rgb(20, 185, 255)");
                        else
                            document.getElementById(this._id + "resetPath" + i.toString()).setAttribute("fill", "#FFFFFF");
                    }
                }
                else {
                    for (var i = 0; i < 3; i++) {
                        if (i == 0)
                            document.getElementById(this._id + "backPath").setAttribute("fill", "rgb(20, 185, 255)");
                        else
                            document.getElementById(this._id + "backPath" + i.toString()).setAttribute("fill", "#FFFFFF");
                    }
                }
            }
            else {
                if (document.getElementById(this._id + "toolbarTooltip") != null && document.getElementById(this._id + "toolbarTooltip").style.visibility != "hidden") {
                    document.getElementById(this._id + "toolbarTooltip").style.visibility = "hidden";
                    if (document.getElementById(this._id + "reset") != null && document.getElementById(this._id + "back") != null) {
                        for (var i = 0; i < 5; i++) {
                            if (i == 0) {
                                document.getElementById(this._id + "resetPath").setAttribute("fill", "#D6D6D6");
                            }
                            else
                                document.getElementById(this._id + "resetPath" + i.toString()).setAttribute("fill", "#5E5C5C");
                        }
                        for (var i = 0; i < 3; i++) {
                            if (i == 0) {
                                document.getElementById(this._id + "backPath").setAttribute("fill", "#D6D6D6");
                            }
                            else
                                document.getElementById(this._id + "backPath" + i.toString()).setAttribute("fill", "#5E5C5C");
                        }
                    }
                }
            }
            data = this.getSunburstPoint(event);
            if (data != undefined && this.model.pointRegionMouseMove) {
                commonPointRegionMouseMoveEventArgs = $.extend({}, this.common);
                commonPointRegionMouseMoveEventArgs['data'] = data;
                this._trigger("pointRegionMouseMove", commonPointRegionMouseMoveEventArgs);
            }
            if (!this.isNullOrUndefined(data) && this.model.tooltip.visible) {
                transToolTipOptions = { 'id': this._id + '_ToolTip' };
                this.gTransToolEle = this.createGroup(transToolTipOptions);
                location = { X: (data['location'].x), Y: Math.abs(data['location'].y) };
                for (var i = 0; i < this.layerData.length; i++) {
                    if (this.layerData[i]['layerNumber'] == data['pointData'][0].layerNumber) {
                        if (this.isNullOrUndefined(data['pointData'][0].parentName)) {
                            layer = this.layerData[0];
                            layerPoint = this.layerData[0]['point'][data['pointData'][0].pointIndex];
                        }
                        else {
                            if (this.layerData[i]['parentName'] == data['pointData'][0].parentName) {
                                layer = this.layerData[i];
                                layerPoint = this.layerData[i]['point'][data['pointData'][0].pointIndex];
                            }
                        }
                    }
                }
                if (this.model.tooltip.template) {
                    this.createTooltiptemplate(location, layerPoint, layer, data);
                }
                else {
                    this.showTooltip(location, layerPoint, layer, data);
                }
            }
            else {
                if (!this.isNullOrUndefined(document.getElementById(this._id + "_ToolTip"))) {
                    document.getElementById(this._id + "_ToolTip").style.visibility = "hidden";
                }
            }
            if (this.model.highlightSettings.enable) {
                var legendItem = void 0, highlightSettings = this.model.highlightSettings;
                this.highlightSunburst(data);
                if (!this.isNullOrUndefined(data) && this.model.legend.visible) {
                    for (var j = 0; j < this.model.points.length; j++) {
                        legendItem = document.getElementById(this._id + "_svg_LegendItemShape" + j);
                        if (highlightSettings['type'] == sunburstHighlightType.opacity) {
                            if (this.selectedGroupNumber - 1 != j) {
                                if (data['pointData'][0].legendIndex != j) {
                                    legendItem.style.opacity = highlightSettings['opacity'].toString();
                                }
                            }
                        }
                        else {
                            if (data['pointData'][0].legendIndex == j) {
                                if (legendItem.getAttribute('class') != "SelectionStyleSunburst") {
                                    legendItem.setAttribute("class", "HighlightStyleSunburst");
                                    legendItem.style.opacity = highlightSettings['opacity'].toString();
                                }
                            }
                            else {
                                if (!(legendItem.getAttribute("class") == "HighlightStyleSunburst"))
                                    legendItem.removeAttribute("class");
                            }
                        }
                    }
                }
            }
            if (elementId.indexOf(this._id + "_svg_LegendItem") != -1 && this.model.legend.clickAction == sunburstLegendClickAction.toggleSegmentSelection) {
                this.legendSegments(elementId);
            }
        };
        SunburstChart.prototype.legendSegments = function (elementid) {
            var legendId, legendIndex, legendSegment, childNodes, highlightOpacity, pieSegment, dataLabelGroup;
            legendId = elementid.replace(this._id + "_svg", "");
            legendIndex = parseInt(legendId.replace(/[^0-9\.]/g, ''));
            legendSegment = document.getElementById(this._id + "legendItem_Group");
            childNodes = legendSegment.childNodes;
            highlightOpacity = this.model.highlightSettings.opacity.toString();
            for (var l = 0; l < childNodes.length; l++) {
                if (legendIndex != l)
                    document.getElementById(childNodes[l]['id']).style.opacity = highlightOpacity;
                else
                    document.getElementById(childNodes[l]['id']).style.opacity = "1";
            }
            pieSegment = document.getElementById(this._id + '_svg_SunBurstElementGroup');
            childNodes = pieSegment.childNodes;
            for (var j = 0; j < childNodes.length; j++) {
                if (childNodes[j]['id'].indexOf("_legendIndex" + legendIndex) == -1)
                    document.getElementById(childNodes[j]['id']).style.opacity = highlightOpacity;
            }
            if (this.model.dataLabelSettings.visible) {
                dataLabelGroup = document.getElementById(this._id + '_svg_DataLabelGroup');
                if (dataLabelGroup) {
                    childNodes = dataLabelGroup.childNodes;
                    for (var j = 0; j < childNodes.length; j++) {
                        if (childNodes[j]['id'].indexOf("_legendIndex" + legendIndex) == -1)
                            document.getElementById(childNodes[j]['id']).style.opacity = highlightOpacity;
                    }
                }
            }
            this._legendHighlight = true;
        };
        SunburstChart.prototype.toolbarTooltip = function (event, elementid) {
            var tooltipdiv, rectoptions;
            if (elementid.indexOf("reset") != -1) {
                elementid = 'Reset';
            }
            else
                elementid = 'Back';
            rectoptions = {
                'top': event['clientY'],
                'left': event['clientX'],
                'background-color': "white",
                "border-style": "solid",
                "position": "absolute",
                "border-color": "#2F4F4F",
                "border-width": "1px",
                "opacity": 0.95,
                'z-index': 1000000,
                "border-radius": "0px 0px",
                "padding-left": '5px',
                "padding-right": '5px',
                "padding-top": '2px',
                "padding-bottom": '2px'
            };
            if (this.isNullOrUndefined(document.getElementById(this._id + "toolbarTooltip"))) {
                tooltipdiv = document.createElement('div');
                tooltipdiv.setAttribute('id', this._id + "toolbarTooltip");
            }
            else {
                tooltipdiv = document.getElementById(this._id + "toolbarTooltip");
            }
            tooltipdiv['style'].pointerEvents = "none";
            this.setStyles(rectoptions, tooltipdiv);
            var textOptions = {
                'top': event['clientY'],
                'left': event['clientX'],
                "color": this.model.tooltip.font.color,
                'font-size': this.model.tooltip.font.size,
                'font-family': this.model.tooltip.font.fontFamily,
                'font-style': this.model.tooltip.font.fontStyle,
                'font-weight': this.model.tooltip.font.fontWeight,
                "align-self": "baseline"
            };
            this.setStyles(textOptions, tooltipdiv);
            if (this.isNullOrUndefined(document.getElementById(this._id + "toolbarTooltip"))) {
                document.body.appendChild(tooltipdiv);
            }
            tooltipdiv.innerHTML = elementid;
            if (tooltipdiv['style'].visibility == "hidden") {
                tooltipdiv['style'].visibility = "visible";
            }
            tooltipdiv['style'].left = (event['clientX'] + window.pageXOffset + 10).toString() + 'px';
            tooltipdiv['style'].top = (event['clientY'] + window.pageYOffset + 10).toString() + 'px';
        };
        SunburstChart.prototype.removeHighlight = function (ID) {
            for (var i = 0; i < ID.length && document.getElementById(ID[i]) != null; i++) {
                if (document.getElementById(ID[i]).getAttribute('class') == "HighlightStyleSunburst")
                    document.getElementById(ID[i]).removeAttribute('class');
            }
        };
        SunburstChart.prototype.isSelectedElement = function (elementId, selectedgrpId) {
            var selected = false;
            for (var i = 0; i < selectedgrpId.length; i++) {
                if (elementId == selectedgrpId[i])
                    selected = true;
            }
            return selected;
        };
        SunburstChart.prototype.highlightSunburst = function (pointObj) {
            var path = document.getElementsByTagName('path'), pointIndex, data = pointObj, highele, element, groupElements, baseid, highlightgroup, legendItem, legend = this.model.legend, highlightSettings = this.model.highlightSettings, points = this.model.points, selected;
            if (!this.isNullOrUndefined(data)) {
                if (highlightSettings['mode'] == sunburstHighlightMode.point) {
                    if (highlightSettings['type'] != sunburstHighlightType.opacity) {
                        highele = document.getElementsByClassName("HighlightStyleSunburst");
                        if (highlightSettings['mode'] == sunburstHighlightMode.point) {
                            if (highele.length > 0) {
                                highele[0].removeAttribute('class');
                            }
                        }
                        element = document.getElementById(data['pointData'][0]['id']);
                        selected = this.isSelectedElement(element.id, this.selectedgroupID);
                        if (document.getElementById(element.id).getAttribute("class") == null && !selected)
                            this.createHighlightStyle(element, highlightSettings);
                        this.baseID = element.id;
                    }
                    else {
                        for (var j = 0; j < path.length; j++) {
                            if (this.selectedgroupID.indexOf(path[j].id) == -1)
                                path[j].style.opacity = highlightSettings['opacity'].toString();
                        }
                        document.getElementById(data['pointData'][0]['id']).style.opacity = '1';
                    }
                }
                else if (highlightSettings['mode'] == sunburstHighlightMode.all) {
                    groupElements = this.findGroupElements(data);
                    baseid = this._id + '_legendIndex' + groupElements[0].legendIndex + '_layerNumber1_layerIndex0_pointIndex' + groupElements[0].pointIndex.toString();
                    if (highlightSettings['type'] != sunburstHighlightType.opacity) {
                        highlightgroup = document.getElementsByClassName("HighlightStyleSunburst");
                        if (highlightgroup.length > 0) {
                            for (var k_1 = 0; k_1 < highlightgroup.length; k_1++) {
                                this.highlightgroupID.push(highlightgroup[k_1].id);
                                if (this.highlightgroupID[k_1].indexOf(this._id + "_svg_LegendItemShape") < 0)
                                    this.removeHighlight(this.highlightgroupID);
                            }
                        }
                        this.groupID = undefined;
                        this.highlightgroupID = [];
                        this.selelectedElementId = undefined;
                    }
                    this.highlightGroup(groupElements, data);
                    if (highlightSettings['type'] == sunburstHighlightType.opacity) {
                        for (var k = 0; k < path.length; k++) {
                            if (this.selectedgroupID.indexOf(path[k].id) == -1)
                                path[k].style.opacity = highlightSettings['opacity'].toString();
                        }
                        for (var j = 0; j < this.highlightgroupID.length; j++) {
                            document.getElementById(this.highlightgroupID[j]).style.opacity = '1';
                        }
                    }
                }
                else if (highlightSettings['mode'] == sunburstHighlightMode.child) {
                    baseid = data['pointData'][0]['id'];
                    if (highlightSettings['type'] != sunburstHighlightType.opacity) {
                        if (!this.isNullOrUndefined(this.highlightgroupID) && this.highlightgroupID.length > 0) {
                            this.removeHighlight(this.highlightgroupID);
                        }
                        this.highlightgroupID = [];
                        this.highlightedElementId = undefined;
                    }
                    this.highlightChild(data);
                    if (highlightSettings['type'] == sunburstHighlightType.opacity) {
                        for (var l = 0; l < path.length; l++) {
                            if (this.selectedgroupID.indexOf(path[l].id) == -1)
                                path[l].style.opacity = highlightSettings['opacity'].toString();
                        }
                        for (var j = 0; j < this.highlightgroupID.length; j++) {
                            document.getElementById(this.highlightgroupID[j]).style.opacity = '1';
                        }
                        this.highlightedElementId = undefined;
                    }
                }
                else {
                    baseid = data['pointData'][0]['id'];
                    if (highlightSettings['type'] != sunburstHighlightType.opacity) {
                        if (!this.isNullOrUndefined(this.groupID) && this.groupID.length > 0)
                            this.removeHighlight(this.groupID);
                        this.groupID = undefined;
                        this.selelectedElementId = undefined;
                    }
                    this.highlightParent(data);
                    if (highlightSettings['type'] == sunburstHighlightType.opacity) {
                        for (var m = 0; m < path.length; m++) {
                            if (this.selectedgroupID.indexOf(path[m].id) == -1)
                                path[m].style.opacity = this.model.selectionSettings.opacity.toString();
                        }
                        for (var j = 0; j < this.groupID.length; j++) {
                            document.getElementById(this.groupID[j]).style.opacity = '1';
                        }
                    }
                }
            }
            else {
                if (highlightSettings['type'] != sunburstHighlightType.opacity) {
                    if (highlightSettings['mode'] == sunburstHighlightMode.point) {
                        highele = document.getElementsByClassName("HighlightStyleSunburst");
                        if (highele.length > 0) {
                            highele[0].removeAttribute('class');
                            this.baseID = undefined;
                        }
                    }
                    else if (highlightSettings['mode'] == sunburstHighlightMode.all) {
                        if (!this.isNullOrUndefined(this.highlightgroupID)) {
                            for (var i = 0; i < this.highlightgroupID.length; i++) {
                                if (document.getElementById(this.highlightgroupID[i]) != null && (document.getElementById(this.highlightgroupID[i]).getAttribute("class") == null || document.getElementById(this.highlightgroupID[i]).getAttribute("class") == "HighlightStyleSunburst"))
                                    document.getElementById(this.highlightgroupID[i]).removeAttribute('class');
                            }
                            this.groupID = undefined;
                            this.selelectedElementId = undefined;
                        }
                    }
                    else {
                        highele = document.getElementsByClassName('HighlightStyleSunburst');
                        if (highele.length > 0) {
                            for (var i_1 = 0; i_1 < highele.length; i_1++) {
                                this.highlightgroupID.push(highele[i_1].id);
                            }
                            this.removeHighlight(this.highlightgroupID);
                            this.highlightgroupID = [];
                            this.highlightedElementId = null;
                        }
                    }
                }
                else {
                    for (var j = 0; j < path.length; j++) {
                        if (this.selectedgroupID.length == 0) {
                            if (this.selectedgroupID.indexOf(path[j].id) == -1) {
                                path[j].style.opacity = '1';
                            }
                        }
                        else {
                            if (this.selectedgroupID.indexOf(path[j].id) == -1) {
                                path[j].style.opacity = this.model.selectionSettings.opacity.toString();
                            }
                        }
                    }
                }
            }
        };
        SunburstChart.prototype.highlightGroup = function (groupElement, data) {
            var element, highlightSettings = this.model.highlightSettings, selected = false;
            this.highlightgroupID = [];
            for (var i = 0; i < groupElement.length; i++) {
                if ((groupElement[i].layerNumber == 1)) {
                    element = document.getElementById(this._id + '_legendIndex' + data.pointData[0].legendIndex + '_layerNumber1_layerIndex0_pointIndex' + groupElement[i].pointIndex.toString());
                    selected = this.isSelectedElement(element.id, this.selectedgroupID);
                    if (highlightSettings['type'] != sunburstHighlightType.opacity && (document.getElementById(element.id).getAttribute("class") == null) && !selected) {
                        this.createHighlightStyle(element, highlightSettings);
                        this.selelectedElementId = element.id;
                    }
                    this.highlightgroupID.push(element.id);
                }
                else {
                    for (var j = 0; j < groupElement[i].point.length; j++) {
                        if (groupElement[i].layerNumber != 1) {
                            element = document.getElementById(this._id + '_legendIndex' + data.pointData[0].legendIndex + '_layerNumber' + groupElement[i].layerNumber.toString() + '_layerIndex' + groupElement[i].layerIndex.toString() + '_pointIndex' + j.toString());
                            selected = this.isSelectedElement(element.id, this.selectedgroupID);
                            if (highlightSettings['type'] != sunburstHighlightType.opacity && (document.getElementById(element.id).getAttribute("class") == null) && !selected)
                                this.createHighlightStyle(element, highlightSettings);
                            this.highlightgroupID.push(element.id);
                        }
                    }
                }
            }
        };
        SunburstChart.prototype.highlightParent = function (data) {
            var element, style, baseid, highlightSettings = this.model.highlightSettings, selected = false;
            this.groupID = [];
            this.parentEle = [];
            this.parentEle.push(data.pointData[0]);
            baseid = data.pointData[0]['id'];
            if (!this.isNullOrUndefined(data.pointData[0].parentName)) {
                this.findSelectionparent(data.pointData[0].parentName);
            }
            for (var i = 0; i < this.parentEle.length; i++) {
                if (!document.getElementById("selectionSunburst")) {
                    element = document.getElementById(this._id + '_legendIndex' + data.pointData[0].legendIndex + '_layerNumber' + this.parentEle[i]['layerNumber'].toString() + '_layerIndex' + this.parentEle[i]['layerIndex'].toString() + '_pointIndex' + this.parentEle[i]['pointIndex']);
                    selected = this.isSelectedElement(element.id, this.selectedgroupID);
                    if (highlightSettings['type'] != sunburstHighlightType.opacity && !selected)
                        this.createHighlightStyle(element, highlightSettings);
                    this.groupID.push(element.id);
                    this.highlightgroupID.push(element.id);
                }
                else {
                    element = document.getElementById(this._id + '_legendIndex' + data.pointData[0].legendIndex + '_layerNumber' + this.parentEle[i]['layerNumber'].toString() + '_layerIndex' + this.parentEle[i]['layerIndex'].toString() + '_pointIndex' + this.parentEle[i]['pointIndex']);
                    selected = this.isSelectedElement(element.id, this.selectedgroupID);
                    if (highlightSettings['type'] != sunburstHighlightType.opacity && !selected)
                        this.createHighlightStyle(element, highlightSettings);
                    this.groupID.push(element.id);
                    this.highlightgroupID.push(element.id);
                }
            }
        };
        SunburstChart.prototype.highlightChild = function (data) {
            var layer, baseid, highlightSettings = this.model.highlightSettings, layerNumber, childid, childele, selected = false;
            this.childEle = [];
            this.highlightgroupID = [];
            layer = this.layerData[data.pointData[0].layerIndex]['point'][data.pointData[0].pointIndex];
            baseid = data.pointData[0]['id'];
            var element = document.getElementById(baseid);
            selected = this.isSelectedElement(element.id, this.selectedgroupID);
            if (!layer['point'] && layer['layerIndex'] != 0 && !selected) {
                if (highlightSettings['type'] != sunburstHighlightType.opacity) {
                    this.createHighlightStyle(element, highlightSettings);
                    this.highlightedElementId = baseid;
                }
                this.highlightgroupID.push(element.id);
            }
            else {
                layerNumber = data.pointData[0].layerNumber;
                if (!this.isNullOrUndefined(layer['point']))
                    this.findChild(layer, layerNumber);
                if (highlightSettings['type'] != sunburstHighlightType.opacity && !selected)
                    this.createHighlightStyle(element, highlightSettings);
                this.highlightgroupID.push(element.id);
                this.highlightedElementId = baseid;
                for (var i = 0; i < this.childEle.length; i++) {
                    if (this.childEle[i].layerNumber > data.pointData[0].layerNumber) {
                        for (var j = 0; j < this.childEle[i].length; j++) {
                            childid = this._id + '_legendIndex' + data.pointData[0].legendIndex + '_layerNumber' + this.childEle[i].layerNumber.toString() + '_layerIndex' + this.childEle[i].layerIndex + '_pointIndex' + j.toString();
                            childele = document.getElementById(childid);
                            selected = this.isSelectedElement(childid, this.selectedgroupID);
                            if (highlightSettings['type'] != sunburstHighlightType.opacity && !selected)
                                this.createHighlightStyle(childele, highlightSettings);
                            this.highlightgroupID.push(childele.id);
                        }
                    }
                }
            }
        };
        SunburstChart.prototype.createHighlightStyle = function (element, settings) {
            var style, fill, opacity;
            if (element.getAttribute('class') != "SelectionStyleSunburst") {
                if (!document.getElementById("highlightSunburst")) {
                    style = document.createElement('style');
                    style.type = 'text/css';
                    fill = settings.color;
                    opacity = '1';
                    style.innerHTML = ' .HighlightStyleSunburst{ fill:' + fill + ';' + 'opacity:' + opacity + ';' + 'stroke:;stroke-width:1}';
                    style.setAttribute('id', "highlightSunburst");
                    document.body.appendChild(style);
                }
                element.setAttribute('class', 'HighlightStyleSunburst');
            }
        };
        SunburstChart.prototype.showTooltip = function (location, layerPoint, layer, data) {
            var padding = 7, tooltipText, tooltipdivRect, rectOptions, x, y, commonToolTipTextArgs, tooltip = this.model.tooltip;
            var svgEle = document.getElementById(this._id + "_svg"), scrlltop = window.pageYOffset, scrollleft = window.pageXOffset, rect = svgEle.getBoundingClientRect();
            x = location.X + (padding / 2) + scrollleft + rect['left'];
            y = location.Y - (3 * padding) + scrlltop + rect['top'];
            if (document.getElementById(this._id + "_ToolTip") == null) {
                tooltipdivRect = document.createElement("div");
                tooltipdivRect.id = this._id + "_ToolTip";
                tooltipdivRect.style.pointerEvents = 'none';
            }
            else {
                tooltipdivRect = document.getElementById(this._id + "_ToolTip");
                tooltipdivRect.style.pointerEvents = 'none';
            }
            tooltipText = this.formatTooltip(data.pointData[0], tooltip['format']);
            commonToolTipTextArgs = $.extend({}, this.common);
            commonToolTipTextArgs['data'] = { pointIndex: data.pointData[0].pointIndex, currentText: tooltipText, Location: { x: x, Y: y } };
            this._trigger("tooltipInitialize", commonToolTipTextArgs);
            tooltipdivRect.innerHTML = commonToolTipTextArgs['data'].currentText;
            rectOptions = {
                'top': commonToolTipTextArgs['data'].Location.X,
                'left': commonToolTipTextArgs['data'].Location.Y,
                'background-color': tooltip['fill'],
                "border-style": "solid",
                "position": "absolute",
                "border-color": tooltip['border'].color,
                "border-width": tooltip['border'].width + "px",
                "opacity": tooltip['opacity'],
                "z-index": 1000000,
                "border-radius": "0px 0px",
                "padding-left": '5px',
                "padding-right": '5px',
                "padding-top": '2px',
                "padding-bottom": '2px'
            };
            this.setStyles(rectOptions, tooltipdivRect);
            var textOptions = {
                'top': y,
                'left': x,
                "color": tooltip['font'].color,
                'font-size': tooltip['font'].size,
                'font-family': tooltip['font'].fontFamily,
                'font-style': tooltip['font'].fontStyle,
                'font-weight': tooltip['font'].fontWeight,
                "align-self": "baseline"
            };
            this.setStyles(textOptions, tooltipdivRect);
            if (this.isNullOrUndefined(document.getElementById(this._id + "Tooltip"))) {
                document.body.appendChild(tooltipdivRect);
            }
            if (tooltipdivRect.style.visibility == "hidden") {
                tooltipdivRect.style.visibility = "visible";
            }
            tooltipdivRect.style.left = x.toString() + 'px';
            tooltipdivRect.style.top = y.toString() + 'px';
        };
        SunburstChart.prototype.formatTooltip = function (pointData, format) {
            var text = format;
            if (text.search("#point.x#") != -1) {
                text = text.replace("#point.x#", pointData['x']);
            }
            if (text.search("#point.y#") != -1)
                text = text.replace("#point.y#", pointData['y']);
            return text;
        };
        SunburstChart.prototype.setStyles = function (Options, element) {
            var properties = Object.keys(Options), temp;
            var values = properties.map(function (property) { return Options[property]; });
            for (var i = 0, len = properties.length; i < len; i++) {
                temp = properties[i];
                element.style[temp] = values[i];
            }
        };
        SunburstChart.prototype.createTooltiptemplate = function (location, layerPoint, layer, data) {
            var tooltipdiv = document.getElementById('tooltipDiv'), x, y, svgEle = document.getElementById(this._id + "_svg"), scrlltop = window.pageYOffset, padding = 10, scrollleft = window.pageXOffset, rect = svgEle.getBoundingClientRect();
            x = location['X'] + scrollleft + rect['left'] + padding;
            y = location['Y'] + scrlltop + rect['top'];
            if (this.isNullOrUndefined(tooltipdiv)) {
                this.tooltipfirst = true;
                tooltipdiv = document.createElement("div");
                tooltipdiv.className = "tooltipDiv";
                tooltipdiv.style.position = 'absolute';
                tooltipdiv.style.zIndex = '13000';
                tooltipdiv.style.display = 'block';
                tooltipdiv.id = "tooltipDiv";
                tooltipdiv.style.backgroundColor = "white";
                document.body.appendChild(tooltipdiv);
                this.clonenode = document.getElementById(this.model.tooltip.template).cloneNode(true);
                this.clonenode['style'].display = 'block';
                document.getElementById('tooltipDiv').innerHTML = '';
                this.clonenode['innerHTML'] = this.parseTooltipTemplate(data.pointData[0], this.clonenode['innerHTML']);
                document.getElementById('tooltipDiv').appendChild(this.clonenode);
            }
            else {
                tooltipdiv.style.display = 'block';
                this.tooltipfirst = false;
                this.clonenode['innerHTML'] = this.parseTooltipTemplate(data.pointData[0], this.clonenode['innerHTML']);
            }
            document.getElementById('tooltipDiv').style.left = x.toString() + 'px';
            document.getElementById('tooltipDiv').style.top = y.toString() + 'px';
        };
        SunburstChart.prototype.parseTooltipTemplate = function (point, clonenode) {
            var clone = document.getElementById(this.model.tooltip.template).cloneNode(true);
            var text = clone.innerHTML;
            if (text.search('#point.x#') != -1) {
                text = text.replace('#point.x#', point['x'].toString());
            }
            if (text.search('#point.y#') != -1) {
                text = text.replace('#point.y#', point['y'].toString());
            }
            if (text.search('#point.text#') != -1) {
                if (!this.isNullOrUndefined(point['text'])) {
                    text = text.replace('#point.text#', point['text'].toString());
                }
                else {
                    text = text.replace('#point.text#', point['y'].toString());
                }
            }
            return text;
        };
        SunburstChart.prototype.bindClickEvent = function (event) {
            var data, commonPointClickEventArgs;
            data = this.getSunburstPoint(event);
            if (!this.isNullOrUndefined(data) && this.model.pointRegionClick) {
                commonPointClickEventArgs = $.extend({}, this.common);
                commonPointClickEventArgs['data'] = data;
                this._trigger("pointRegionClick", commonPointClickEventArgs);
            }
            return data;
        };
        SunburstChart.prototype.sunburstClick = function (event) {
            var data = this.bindClickEvent(event), sunburst, doubleTapTimer, backTooltip, selectionSettings = this.model.selectionSettings, point, legendItem;
            if (selectionSettings['enable']) {
                this.selectSunburst(data, event);
                if (!this.isNullOrUndefined(data) && this.model.legend.visible) {
                    for (var i = 0; i < this.model.points.length; i++) {
                        legendItem = document.getElementById(this._id + '_svg_LegendItemShape' + i);
                        point = this.model.points[i];
                        if (selectionSettings['type'] == sunburstSelectionType.opacity) {
                            if (data['pointData'][0].legendIndex != i) {
                                legendItem.style.opacity = selectionSettings['opacity'].toString();
                            }
                        }
                        else {
                            if (this.selectedGroupNumber - 1 == i) {
                                legendItem.setAttribute('class', 'SelectionStyleSunburst');
                                legendItem.style.opacity = selectionSettings['opacity'].toString();
                            }
                            else {
                                if (!(legendItem.getAttribute("class") == "SelectionStyleSunburst"))
                                    legendItem.removeAttribute("class");
                            }
                        }
                    }
                }
            }
            sunburst = this;
            sunburst.tapCount++;
            doubleTapTimer = setTimeout(function () {
                if (sunburst.tapCount >= 2 && sunburst._isDoubleClickEvent == false) {
                    sunburst.sunburstDoubleClick(event);
                    sunburst._isDoubleClickEvent = false;
                }
                sunburst.tapCount = 0;
            }, 200);
            backTooltip = document.getElementById(sunburst._id + "toolbarTooltip");
            if (!sunburst.isNullOrUndefined(backTooltip)) {
                backTooltip.parentNode.removeChild(backTooltip);
            }
        };
        SunburstChart.prototype.isTouch = function (evt) {
            var browserInfo, event;
            browserInfo = this.browserInfo();
            event = evt['originalEvent'] ? evt['originalEvent'] : evt;
            if ((event['pointerType'] == "touch") || (event['pointerType'] == 2) || (event.type.indexOf("touch") > -1))
                return true;
            return false;
        };
        SunburstChart.prototype.sunburstLeave = function (event) {
            var sunburst = this, elementId = event.target.id, legendSegment, childNodes, legendIndex, sunburstSegment, legendItem, tooltipDiv, backTooltip;
            if (this._legendHighlight) {
                legendSegment = document.getElementById(this._id + "legendItem_Group");
                childNodes = legendSegment.childNodes;
                for (var l = 0; l < childNodes.length; l++)
                    document.getElementById(childNodes[l]['id']).style.opacity = "1";
                sunburstSegment = document.querySelectorAll("[id^=" + this._id + "_legendIndex]");
                for (var j = 0; j < sunburstSegment.length; j++)
                    document.getElementById(sunburstSegment[j].id).style.opacity = "1";
                this._legendHighlight = false;
            }
            if (this.model.legend.visible && this.model.highlightSettings.enable) {
                for (var l = 0; l < this.model.points.length; l++) {
                    legendItem = document.getElementById(this._id + "_svg_LegendItemShape" + l);
                    if (legendItem != null) {
                        legendItem.style.opacity = "1";
                        legendItem.removeAttribute("class");
                    }
                }
            }
            if (!this.isNullOrUndefined(document.getElementById(sunburst._id + "_ToolTip"))) {
                if (ej.isTouchDevice() || this.isTouch(event)) {
                    var hideTooltip = setTimeout(function () {
                        document.getElementById(sunburst._id + "_ToolTip").style.visibility = "hidden";
                    }, 3000);
                }
                else if (elementId == sunburst._id + "_svg_svgRect") {
                    if (!this._hideTooltip)
                        clearTimeout(this._hideTooltip);
                    this._hideTooltip = setTimeout(function () {
                        document.getElementById(sunburst._id + "_ToolTip").style.visibility = "hidden";
                    }, 1000);
                }
            }
            backTooltip = document.getElementById(sunburst._id + "toolbarTooltip");
            if (!sunburst.isNullOrUndefined(backTooltip)) {
                backTooltip.parentNode.removeChild(backTooltip);
            }
            tooltipDiv = document.getElementById('tooltipDiv');
            if (!sunburst.isNullOrUndefined(tooltipDiv)) {
                if (ej.isTouchDevice() || this.isTouch(event)) {
                    var hideTooltipTemplate = setTimeout(function () {
                        tooltipDiv.style.display = "none";
                    }, 3000);
                }
                else if (elementId == sunburst._id + "_svg_svgRect") {
                    if (!this._hideTooltipTemplate)
                        clearTimeout(this._hideTooltipTemplate);
                    this._hideTooltipTemplate = setTimeout(function () {
                        tooltipDiv.style.display = "none";
                    }, 1000);
                }
            }
            if (elementId.indexOf(this._id + 'reset') != -1) {
                for (var i = 0; i < 5; i++) {
                    if (i == 0)
                        document.getElementById(this._id + "resetPath").setAttribute("fill", "#D6D6D6");
                    else
                        document.getElementById(this._id + "resetPath" + i.toString()).setAttribute("fill", "#5E5C5C");
                }
            }
            if (elementId.indexOf(this._id + 'back') != -1) {
                for (var i = 0; i < 3; i++) {
                    if (i == 0)
                        document.getElementById(this._id + "backPath").setAttribute("fill", "#D6D6D6");
                    else
                        document.getElementById(this._id + "backPath" + i.toString()).setAttribute("fill", "#5E5C5C");
                }
            }
        };
        SunburstChart.prototype.selectSunburst = function (data, event) {
            var element, selectedele, pointIndex, style, baseID, canvas, styleOptions, fill, highlighted, selected, selectionMode = this.model.selectionSettings.mode.toString(), path = document.getElementsByTagName('path'), mouseClickedElement, selectionOpacity = this.model.selectionSettings.opacity.toString(), selecttype = this.model.selectionSettings.type, legend = this.model.legend, points = this.model.points, legendItem, groupElements, selectedEle, highlightEle;
            if (!this.isNullOrUndefined(data)) {
                if (this.selectedgroupID.length > 0)
                    this.removeSelection(this.selectedgroupID);
                if (selectionMode == "point") {
                    this.selectedgroupID = [];
                    mouseClickedElement = event.target.id.replace('_layerIndex' + data.pointData[0].layerIndex.toString(), "");
                    if (sunburstSelectionType.opacity != selecttype) {
                        if (!this.isNullOrUndefined(this.highlightgroupID) && this.highlightgroupID.length > 0) {
                            this.removeHighlight(this.highlightgroupID);
                        }
                        element = document.getElementById(data.pointData[0]['id']);
                        if (element.getAttribute('class') == 'SelectionStyleSunburst') {
                            element.removeAttribute('class');
                            if (this.highlightgroupID.indexOf(element.id) != -1) {
                                element.setAttribute('class', 'HighlightStyleSunburst');
                            }
                        }
                        else {
                            selectedEle = document.getElementsByClassName('SelectionStyleSunburst');
                            if (this.highlightgroupID.length > 0 && selectedEle.length > 0) {
                                if (this.highlightgroupID.indexOf(selectedEle[0].id) != -1) {
                                    selectedEle[0].setAttribute('class', 'HighlightStyleSunburst');
                                }
                            }
                            if (selectedEle.length > 0 && selectedEle[0].getAttribute('class') == "SelectionStyleSunburst")
                                selectedEle[0].removeAttribute('class');
                            if (!this.isNullOrUndefined(this.highlightgroupID) && this.highlightgroupID.length > 0) {
                                this.removeHighlight(this.highlightgroupID);
                            }
                            this.selectPointData(element);
                            this.selectedgroupID.push(element.id);
                        }
                    }
                    else {
                        if (this.mouseClickedElementId != mouseClickedElement) {
                            for (var i = 0; i < path.length; i++) {
                                path[i].style.opacity = selectionOpacity;
                            }
                            document.getElementById(data.pointData[0]['id']).style.opacity = '1';
                            this.mouseClickedElementId = mouseClickedElement;
                            this.selectedgroupID.push(data.pointData[0]['id']);
                        }
                        else {
                            for (var j = 0; j < path.length; j++) {
                                path[j].style.opacity = '1';
                            }
                            this.mouseClickedElementId = "";
                        }
                        this.selectedGroupNumber = data.pointData[0].groupNumber;
                    }
                    if (legend['visible'] && this.selectedgroupID.length > 0) {
                        for (var k = 0; k < points.length; k++) {
                            legendItem = document.getElementById(this._id + '_svg_LegendItemShape' + k);
                            if (data.pointData[0].legendIndex != k) {
                                if (legendItem != null) {
                                    legendItem.style.opacity = selectionOpacity;
                                    legendItem.removeAttribute("class");
                                }
                            }
                            else {
                                if (sunburstSelectionType.opacity == selecttype)
                                    legendItem.style.opacity = '1';
                                else {
                                    legendItem.setAttribute("class", "SelectionStyleSunburst");
                                    legendItem.style.opacity = selectionOpacity;
                                }
                            }
                        }
                    }
                    if (this.selectedgroupID.length == 0)
                        this.removeLegendSelection();
                }
                else if (selectionMode == "all") {
                    groupElements = this.findGroupElements(data);
                    baseID = data.pointData[0]['id'];
                    if (this.selectedgroupID.indexOf(baseID) == -1) {
                        if (this.selectedGroupNumber != groupElements[0]['groupNumber']) {
                            if (this.selectedgroupID.length > 0) {
                                this.removeSelection(this.selectedgroupID);
                            }
                            this.selectGroup(groupElements, data);
                            this.selectedGroupNumber = groupElements[0]['groupNumber'];
                        }
                        else {
                            if (this.selectedgroupID.length > 0) {
                                this.removeSelection(this.selectedgroupID);
                            }
                            this.selectedgroupID = [];
                            this.selectedGroupNumber = null;
                        }
                        if (sunburstSelectionType.opacity == selecttype) {
                            for (var i = 0; i < path.length; i++) {
                                path[i].style.opacity = selectionOpacity;
                            }
                            for (var j = 0; j < this.selectedgroupID.length; j++) {
                                document.getElementById(this.selectedgroupID[j]).style.opacity = '1';
                            }
                            this.isSelected = true;
                        }
                        if (legend['visible']) {
                            for (var k_2 = 0; k_2 < points.length; k_2++) {
                                legendItem = document.getElementById(this._id + '_svg_LegendItemShape' + k_2);
                                if (legendItem != null) {
                                    legendItem.style.opacity = selectionOpacity;
                                    legendItem.removeAttribute("class");
                                }
                            }
                            if (sunburstSelectionType.opacity != selecttype)
                                document.getElementById(this._id + '_svg_LegendItemShape' + groupElements[0]['pointIndex'].toString()).setAttribute("class", "SelectionStyleSunburst");
                            else
                                document.getElementById(this._id + '_svg_LegendItemShape' + groupElements[0]['pointIndex'].toString()).style.opacity = '1';
                        }
                    }
                    else {
                        if (this.selectedgroupID.length > 0) {
                            if (sunburstSelectionType.opacity != selecttype)
                                this.removeSelection(this.selectedgroupID);
                            else {
                                for (var i = 0; i < path.length; i++) {
                                    path[i].style.opacity = '1';
                                }
                            }
                        }
                        this.isSelected = false;
                        this.selectedGroupNumber = null;
                        this.selectedgroupID = [];
                        this.baseID = '';
                        this.removeLegendSelection();
                    }
                }
                else if (selectionMode == "child") {
                    baseID = data.pointData[0]['id'];
                    if (this.selectedgroupID.indexOf(baseID) == -1) {
                        if (!this.isNullOrUndefined(this.selectedgroupID) && this.selectedgroupID.length > 0) {
                            this.removeSelection(this.selectedgroupID);
                        }
                        if (!this.isNullOrUndefined(this.highlightgroupID) && this.highlightgroupID.length > 0) {
                            this.removeHighlight(this.highlightgroupID);
                        }
                        this.selectedgroupID = [];
                        this.selelectedElementId = undefined;
                        this.selectchild(data);
                        if (sunburstSelectionType.opacity == selecttype) {
                            for (var i = 0; i < path.length; i++) {
                                path[i].style.opacity = selectionOpacity;
                            }
                            for (var j = 0; j < this.selectedgroupID.length; j++) {
                                document.getElementById(this.selectedgroupID[j]).style.opacity = '1';
                            }
                            this.isSelected = true;
                        }
                        this.selectedGroupNumber = data.pointData[0].groupNumber;
                        if (legend['visible']) {
                            for (var k = 0; k < points.length; k++) {
                                legendItem = document.getElementById(this._id + '_svg_LegendItemShape' + k);
                                if (data.pointData[0].legendIndex != k) {
                                    if (legendItem != null) {
                                        legendItem.style.opacity = selectionOpacity;
                                        legendItem.removeAttribute("class");
                                    }
                                }
                                else {
                                    if (sunburstSelectionType.opacity == selecttype)
                                        legendItem.style.opacity = '1';
                                    else {
                                        legendItem.setAttribute("class", "SelectionStyleSunburst");
                                        legendItem.style.opacity = selectionOpacity;
                                    }
                                }
                            }
                        }
                    }
                    else {
                        this.selectedgroupID = [];
                        this.selelectedElementId = this.baseID = '';
                        this.removeSegmentSelection(path, selecttype);
                        this.removeLegendSelection();
                        this.isSelected = false;
                    }
                }
                else {
                    baseID = data.pointData[0]['id'];
                    if (this.selectedgroupID.indexOf(baseID) == -1) {
                        if (!this.isNullOrUndefined(this.groupNumber) && this.groupNumber != data.pointData[0].groupNumber)
                            this.removeSegmentSelection(path, this.model.selectionSettings.type);
                        else if (this.selectedgroupID.length > 0) {
                            this.removeSelection(this.selectedgroupID);
                            this.selectedgroupID = [];
                        }
                        if (!this.isNullOrUndefined(this.highlightgroupID) && this.highlightgroupID.length > 0) {
                            this.removeHighlight(this.highlightgroupID);
                        }
                        this.selectParent(data);
                        this.groupNumber = data.pointData[0].groupNumber;
                        if (sunburstSelectionType.opacity == selecttype) {
                            for (var i = 0; i < path.length; i++) {
                                path[i].style.opacity = selectionOpacity;
                            }
                            for (var j = 0; j < this.selectedgroupID.length; j++) {
                                document.getElementById(this.selectedgroupID[j]).style.opacity = '1';
                            }
                        }
                        this.selectedGroupNumber = data.pointData[0].groupNumber;
                        pointIndex = data.pointData[0].legendIndex;
                        if (legend['visible']) {
                            for (var k_3 = 0; k_3 < points.length; k_3++) {
                                legendItem = document.getElementById(this._id + '_svg_LegendItemShape' + k_3);
                                if (legendItem != null) {
                                    legendItem.style.opacity = selectionOpacity;
                                    legendItem.removeAttribute("class");
                                }
                            }
                            if (sunburstSelectionType.opacity != selecttype)
                                document.getElementById(this._id + '_svg_LegendItemShape' + pointIndex.toString()).setAttribute("class", "SelectionStyleSunburst");
                            else
                                document.getElementById(this._id + '_svg_LegendItemShape' + pointIndex.toString()).style.opacity = '1';
                        }
                    }
                    else {
                        this.selectedgroupID = [];
                        this.selelectedElementId = this.baseID = '';
                        this.removeSegmentSelection(path, this.model.selectionSettings.type);
                        this.removeLegendSelection();
                    }
                }
            }
            else {
                if (sunburstSelectionType.opacity != selecttype) {
                    if (selectionMode == "point") {
                        selectedEle = document.getElementsByClassName('SelectionStyleSunburst');
                        if (selectedEle.length > 0)
                            selectedEle[0].removeAttribute('class');
                    }
                    else {
                        if (this.selectedgroupID.length > 0) {
                            this.removeSelection(this.selectedgroupID);
                            this.selectedgroupID = [];
                            this.selectedGroupNumber = null;
                            if (selectionMode == "child")
                                this.selelectedElementId = null;
                            if (selectionMode == "parent") {
                                this.groupNumber = null;
                            }
                        }
                    }
                }
                else {
                    this.selectedgroupID = [];
                    for (var j = 0; j < path.length; j++) {
                        path[j].style.opacity = '1';
                    }
                    this.mouseClickedElementId = "";
                    this.selectedGroupNumber = null;
                }
                this.removeLegendSelection();
            }
        };
        SunburstChart.prototype.removeSegmentSelection = function (path, selectType) {
            for (var i = 0; i < path.length; i++) {
                if (selectType == sunburstSelectionType.opacity)
                    path[i].style.opacity = "1";
                else
                    path[i].removeAttribute('class');
            }
        };
        SunburstChart.prototype.removeLegendSelection = function () {
            var legendItem;
            if (this.model.legend.visible) {
                for (var k = 0; k < this.model.points.length; k++) {
                    legendItem = document.getElementById(this._id + '_svg_LegendItemShape' + k);
                    if (legendItem != null) {
                        legendItem.style.opacity = "1";
                        legendItem.removeAttribute("class");
                    }
                }
            }
        };
        SunburstChart.prototype.selectParent = function (data) {
            var element, style, lgndIndx, selectionSettings = this.model.selectionSettings, selectedEle, highlightEle;
            this.parentEle = [];
            lgndIndx = data.pointData[0].legendIndex;
            if (sunburstSelectionType.opacity == selectionSettings['type'])
                this.selectedgroupID = [];
            this.parentEle.push(data.pointData[0]);
            var baseid = data.pointData[0]['id'];
            if (sunburstSelectionType.opacity != selectionSettings['type']) {
                this.selectedgroupID = [];
                this.removeSelection(this.selectedgroupID);
                this.selelectedElementId = baseid;
            }
            if (!this.isNullOrUndefined(data.pointData[0].parentName)) {
                this.findSelectionparent(data.pointData[0].parentName);
            }
            for (var i = 0; i < this.parentEle.length; i++) {
                if (!document.getElementById("selectionSunburst")) {
                    element = document.getElementById(this._id + '_legendIndex' + lgndIndx + '_layerNumber' + this.parentEle[i]['layerNumber'].toString() + '_layerIndex' + this.parentEle[i]['layerIndex'].toString() + '_pointIndex' + this.parentEle[i]['pointIndex']);
                    if (sunburstSelectionType.opacity != this.model.selectionSettings.type) {
                        style = this.createselectionStyle(element, this.model.selectionSettings);
                        document.body.appendChild(style);
                        element.setAttribute('class', 'SelectionStyleSunburst');
                    }
                    this.selectedgroupID.push(element.id);
                }
                else {
                    element = document.getElementById(this._id + '_legendIndex' + lgndIndx + '_layerNumber' + this.parentEle[i]['layerNumber'].toString() + '_layerIndex' + this.parentEle[i]['layerIndex'].toString() + '_pointIndex' + this.parentEle[i]['pointIndex']);
                    if (sunburstSelectionType.opacity != this.model.selectionSettings.type)
                        element.setAttribute('class', 'SelectionStyleSunburst');
                    this.selectedgroupID.push(element.id);
                }
            }
        };
        SunburstChart.prototype.findSelectionparent = function (data) {
            var region = this.sunburstRegions;
            loop1: for (var i = 0; i < region.length; i++) {
                for (var j = 0; j < region[i]['region'].length; j++) {
                    if (data == region[i]['region'][j]['x']) {
                        this.parentEle.push(region[i]['region'][j]);
                        if (!this.isNullOrUndefined(region[i]['region'][j]['parentName'])) {
                            this.findSelectionparent(region[i]['region'][j]['parentName']);
                            break loop1;
                        }
                        else {
                            break loop1;
                        }
                    }
                }
            }
        };
        SunburstChart.prototype.selectchild = function (data) {
            var layer, baseid, element, selectionSettings = this.model.selectionSettings, style, lgndIndx, childid, childele;
            this.childEle = [];
            layer = this.layerData[data.pointData[0].layerIndex]['point'][data.pointData[0].pointIndex];
            baseid = data.pointData[0]['id'];
            element = document.getElementById(baseid);
            if (!layer['point'] && layer['layerIndex'] != 0) {
                if (selectionSettings['type'] != sunburstSelectionType.opacity) {
                    if (!document.getElementById("selectionSunburst")) {
                        style = this.createselectionStyle(element, selectionSettings);
                        document.body.appendChild(style);
                    }
                    element.setAttribute('class', 'SelectionStyleSunburst');
                    this.selelectedElementId = baseid;
                }
                this.selectedgroupID.push(element.id);
            }
            else {
                var layerNumber = data.pointData[0].layerNumber;
                if (!this.isNullOrUndefined(layer['point']))
                    this.findChild(layer, layerNumber);
                if (selectionSettings['type'] != sunburstSelectionType.opacity) {
                    if (!document.getElementById("SelectionStyleSunburst")) {
                        style = this.createselectionStyle(element, selectionSettings);
                        document.body.appendChild(style);
                    }
                    element.setAttribute('class', 'SelectionStyleSunburst');
                }
                this.selectedgroupID.push(element.id);
                this.selelectedElementId = baseid;
                lgndIndx = data.pointData[0].legendIndex;
                for (var i = 0; i < this.childEle.length; i++) {
                    if (this.childEle[i].layerNumber > data.pointData[0].layerNumber) {
                        for (var j = 0; j < this.childEle[i].length; j++) {
                            childid = this._id + '_legendIndex' + lgndIndx + '_layerNumber' + this.childEle[i].layerNumber.toString() + '_layerIndex' + this.childEle[i].layerIndex + '_pointIndex' + j.toString();
                            childele = document.getElementById(childid);
                            if (selectionSettings['type'] != sunburstSelectionType.opacity)
                                childele.setAttribute('class', 'SelectionStyleSunburst');
                            this.selectedgroupID.push(childele.id);
                        }
                    }
                }
            }
        };
        SunburstChart.prototype.findChild = function (layer, layerNumber) {
            var points = [];
            for (var i = 0; i < layer['point'].length; i++) {
                if (layer['point'][i].point) {
                    points.push(layer['point'][i]);
                    this.findChild(layer['point'][i], layerNumber + 1);
                }
                else {
                    points.push(layer['point'][i]);
                }
            }
            points.layerNumber = layerNumber + 1;
            points.layerIndex = layer['point'].layerData;
            this.childEle.push(points);
        };
        SunburstChart.prototype.selectGroup = function (groupElement, data) {
            var legendIndex, selectionSettings = this.model.selectionSettings, element, style;
            this.selectedgroupID = [];
            legendIndex = data.pointData[0].legendIndex;
            for (var i = 0; i < groupElement.length; i++) {
                if (groupElement[i].layerNumber == 1) {
                    element = document.getElementById(this._id + '_legendIndex' + legendIndex + '_layerNumber1_layerIndex0_pointIndex' + groupElement[i].pointIndex.toString());
                    if (selectionSettings['type'] != sunburstSelectionType.opacity) {
                        style = this.createselectionStyle(element, selectionSettings);
                        document.body.appendChild(style);
                        element.setAttribute('class', 'SelectionStyleSunburst');
                    }
                    this.selectedgroupID.push(element.id);
                }
                else {
                    for (var j = 0; j < groupElement[i].point.length; j++) {
                        element = document.getElementById(this._id + '_legendIndex' + legendIndex + '_layerNumber' + groupElement[i].layerNumber.toString() + '_layerIndex' + groupElement[i].layerIndex.toString() + '_pointIndex' + j.toString());
                        if (selectionSettings['type'] != sunburstSelectionType.opacity) {
                            var selele = document.getElementById('selectionSunburst');
                            if (selele)
                                element.setAttribute('class', 'SelectionStyleSunburst');
                            else {
                                style = this.createselectionStyle(element, selectionSettings);
                                document.body.appendChild(style);
                                element.setAttribute('class', 'SelectionStyleSunburst');
                            }
                        }
                        this.selectedgroupID.push(element.id);
                    }
                }
            }
        };
        SunburstChart.prototype.removeSelection = function (ID) {
            for (var i = 0; i < ID.length && document.getElementById(ID[i]) != null; i++) {
                if (document.getElementById(ID[i]).getAttribute('class') == "SelectionStyleSunburst")
                    document.getElementById(ID[i]).removeAttribute('class');
            }
        };
        SunburstChart.prototype.findGroupElements = function (data) {
            var groupNumber = data.pointData[0].groupNumber ? data.pointData[0].groupNumber : data.pointData[0].pointIndex + 1, groupPoints = [];
            for (var i = 0; i < this.layerData.length; i++) {
                if (i == 0) {
                    for (var j = 0; j < this.layerData[i]['point'].length; j++) {
                        if (this.layerData[i]['point'][j].groupNumber == groupNumber) {
                            groupPoints.push(this.layerData[i]['point'][j]);
                        }
                    }
                }
                else {
                    if (this.layerData[i]['groupNumber'] == groupNumber) {
                        this.layerData[i]['layerIndex'] = i;
                        groupPoints.push(this.layerData[i]);
                    }
                }
            }
            return groupPoints;
        };
        SunburstChart.prototype.selectPointData = function (element) {
            var style;
            if (!document.getElementById("selectionSunburst")) {
                style = this.createselectionStyle(element, this.model.selectionSettings);
                document.body.appendChild(style);
                element.setAttribute('class', 'SelectionStyleSunburst');
                this.selelectedElementId = element.id;
            }
            else {
                element.setAttribute('class', 'SelectionStyleSunburst');
                this.selelectedElementId = element.id;
            }
        };
        SunburstChart.prototype.createselectionStyle = function (element, settings) {
            var style, fill, opacity;
            style = document.createElement('style');
            style.type = 'text/css';
            fill = settings.color;
            opacity = '1';
            style.innerHTML = ' .SelectionStyleSunburst{ fill:' + fill + ';' + 'opacity:' + opacity + ';' + 'stroke:;stroke-width:1}';
            style.setAttribute('id', "selectionSunburst");
            return style;
        };
        SunburstChart.prototype.getSunburstPoint = function (event) {
            var mouseX, mouseY, currentX, currentY, region, width, height, distanceFromcenter, radiusCollection, mouseposition, startAngle, endAngle, sunStartAngle;
            mouseposition = this.calMousePosition(event);
            radiusCollection = this.circularRadius;
            currentX = mouseposition['X'];
            currentY = mouseposition['Y'];
            startAngle = this.model.startAngle;
            endAngle = this.model.endAngle;
            width = this.areaBounds['actualWidth'];
            height = this.areaBounds['actualHeight'];
            sunStartAngle = this.model.startAngle * (Math.PI / 180);
            this.sunburstRegions.forEach(function (regionItem, regionIndex) {
                var sunburstData = regionItem.sunburstData, regionData = regionItem.region, fromCenterX, fromCenterY, innerRadius, segment, arcAngle = 0, clickAngle, pointStartAngle, pointEndAngle, pointData = [], totalDegree, chartStartAngle;
                innerRadius = sunburstData['innerRadius'] ? sunburstData['innerRadius'] : 0;
                fromCenterX = (currentX) - (sunburstData['centerX']);
                fromCenterY = (currentY) - (sunburstData['centerY']);
                segment = regionItem.region;
                startAngle = startAngle < 0 ? startAngle + 360 : startAngle;
                endAngle = endAngle < 0 ? endAngle + 360 : endAngle;
                totalDegree = endAngle - startAngle;
                chartStartAngle = (-.5 * Math.PI) + sunStartAngle;
                if (totalDegree < 0) {
                    endAngle = endAngle / 360;
                    arcAngle = (endAngle) ? 2 * Math.PI * (endAngle < 0 ? 1 + endAngle : endAngle) : 0;
                    clickAngle = (Math.atan2(fromCenterY, fromCenterX) - chartStartAngle - arcAngle) % (2 * Math.PI);
                    if (clickAngle < 0)
                        clickAngle = 2 * Math.PI + clickAngle;
                    for (var i = 0; i < regionData.length; i++) {
                        pointStartAngle = parseFloat(regionData[i]['startAngle'].toFixed(14));
                        pointEndAngle = parseFloat(regionData[i]['endAngle'].toFixed(14));
                        pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                        pointEndAngle = pointEndAngle < 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
                        pointStartAngle -= arcAngle;
                        pointEndAngle -= arcAngle;
                        pointStartAngle = parseFloat(pointStartAngle.toFixed(14));
                        pointEndAngle = parseFloat(pointEndAngle.toFixed(14));
                        if (clickAngle <= pointStartAngle && clickAngle >= pointEndAngle) {
                            pointData.push(regionData[i]);
                            break;
                        }
                    }
                }
                else {
                    clickAngle = (Math.atan2(fromCenterY, fromCenterX) - chartStartAngle) % (2 * Math.PI);
                    if (clickAngle < 0)
                        clickAngle = 2 * Math.PI + clickAngle;
                    for (var i = 0; i < regionData.length; i++) {
                        pointStartAngle = parseFloat(regionData[i]['startAngle'].toFixed(14));
                        pointEndAngle = parseFloat(regionData[i]['endAngle'].toFixed(14));
                        pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                        pointEndAngle = pointEndAngle < 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
                        pointStartAngle = parseFloat(pointStartAngle.toFixed(14));
                        pointEndAngle = parseFloat(pointEndAngle.toFixed(14));
                        if (clickAngle >= pointStartAngle && clickAngle <= pointEndAngle) {
                            pointData.push(regionData[i]);
                            break;
                        }
                    }
                }
                if (pointData.length > 0) {
                    var distanceFromCenter = Math.sqrt(Math.pow(Math.abs(fromCenterX), 2) + Math.pow(Math.abs(fromCenterY), 2));
                    if (distanceFromCenter <= sunburstData['Radius'] && distanceFromCenter > innerRadius) {
                        region = { pointData: pointData, location: { x: currentX, y: currentY } };
                    }
                }
            });
            return region;
        };
        SunburstChart.prototype.calMousePosition = function (evt) {
            var mouseX, mouseY, mouseposition, element, rect, scrlltop, scrollleft;
            mouseposition = this.mousePosition(evt);
            evt.pageX = mouseposition['x'];
            evt.pageY = mouseposition['y'];
            element = document.getElementById(this._id + "_svg");
            scrlltop = window.pageYOffset;
            scrollleft = window.pageXOffset;
            rect = element.getBoundingClientRect();
            mouseX = evt.pageX - scrollleft - rect['left'];
            mouseY = evt.pageY - scrlltop - rect['top'];
            return { X: mouseX, Y: mouseY };
        };
        SunburstChart.prototype.mousePosition = function (evt) {
            if (!this.isNullOrUndefined(evt.pageX) && evt.pageX > 0)
                return { x: evt.pageX, y: evt.pageY };
            else
                return { x: 0, y: 0 };
        };
        SunburstChart.prototype.drawSunburstLegend = function () {
            var legend = this.model.legend, legendTitle = this.model.legend.title, maximumLegendSpace, translate, width, x, legendBounds, y, scrollButtons, divele, isScroll = false, legendGrp, legElegrp, elementSpacing = this.elementSpacing, legendItems, titleTransform, legendgrp, legendItemgrp;
            this.gLegendEle = this.createGroup({ 'id': this._id + "_legend_group" });
            if (legend['position'] == sunburstLegendPosition.top || legend['postion'] == sunburstLegendPosition.bottom) {
                maximumLegendSpace = this.height * (20 / 100);
            }
            document.getElementById(this._id + '_svg').appendChild(this.gLegendEle);
            if (legendTitle['text'] != "" && legendTitle['visible'])
                this.gLegendEle.appendChild(this.drawLegendTitle(legendTitle, legend));
            legendGrp = this.drawlegendItem(legend, this.legendCollection, isScroll);
            if (this.drilldownCount == 0) {
                this.legendClick = this.legendClick.bind(this);
                this.legendItemGroup.addEventListener('click', this.legendClick, true);
            }
            this.gLegendEle.appendChild(legendGrp);
            if (this.legendPages.length > 0) {
                this.drawScrollbuttons(legend);
            }
            this.legendPositioning(legend, isScroll);
        };
        SunburstChart.prototype.legendPositioning = function (legend, isScroll) {
            var legendgrp, legendItemgrp, legendItems, legendBounds, width, x, elementSpacing = this.elementSpacing, y, translate, divele, scrollButtons, titleTransform;
            legendgrp = document.getElementById(this._id + "_legend_group");
            legendItemgrp = document.getElementById(this._id + "legendItem_Group");
            if (legend['position'] == sunburstLegendPosition.bottom || legend['position'] == sunburstLegendPosition.top) {
                legendItems = document.getElementById(this._id + "legendItem_Group");
                legendBounds = legendItems.getBoundingClientRect();
                width = legendBounds['width'];
                x = (this.width / 2) - (width / 2);
                if (legend['position'] == sunburstLegendPosition.bottom) {
                    if (this.isNullOrUndefined(legend['size']['height']))
                        y = this.LegendBounds['Height'] - elementSpacing;
                    else
                        y = legendBounds['height'] + elementSpacing;
                }
                else {
                    if (this.isNullOrUndefined(legend['size']['height']))
                        y = 0;
                    else {
                        y = this.LegendBounds['Height'] - legendBounds['top'] + elementSpacing;
                    }
                }
                translate = 'translate(' + x.toString() + ',' + '0)';
                legendItems.setAttribute('transform', translate);
                if (legend['title']['text'] != "" && legend['title']['visible'])
                    document.getElementById(this._id + "_LegendTitleText").setAttribute('transform', translate);
                if (this.legendPages.length > 0) {
                    divele = document.getElementById(this._id).getBoundingClientRect();
                    x = (this.width / 2) - (document.getElementById("scrollButtons").getBoundingClientRect().width / 2);
                    if (legend['position'] == sunburstLegendPosition.bottom) {
                        y = legendBounds['bottom'] - divele['top'];
                    }
                    else if (legend['position'] == sunburstLegendPosition.top) {
                        y = legendBounds['top'] + legendBounds['height'];
                    }
                    translate = 'translate(' + x.toString() + ',' + y.toString() + ')';
                    document.getElementById("scrollButtons").setAttribute('transform', translate);
                }
            }
            else if ((legend['position'] == sunburstLegendPosition.left || legend['position'] == sunburstLegendPosition.right)) {
                if (!isScroll) {
                    var grpXTransform = void 0;
                    var grpYTransform = (this.height - legendgrp.getBoundingClientRect().height - document.getElementById(this._id + "_legend_group").getBoundingClientRect().top) / 2;
                    if (legend['position'] == sunburstLegendPosition.left)
                        translate = 'translate(' + this.elementSpacing.toString() + ',' + grpYTransform.toString() + ')';
                    else {
                        if (this.isNullOrUndefined(legend['size']['width']))
                            grpXTransform = (this.width - legendgrp.getBoundingClientRect().width - legendgrp.getBoundingClientRect().left - (2 * this.elementSpacing));
                        else {
                            grpXTransform = (this.width - legendgrp.getBoundingClientRect().width - legendgrp.getBoundingClientRect().left - (2 * this.elementSpacing));
                            grpXTransform = grpXTransform - legend['size']['width'];
                        }
                        translate = 'translate(' + grpXTransform.toString() + ',' + grpYTransform.toString() + ')';
                    }
                    legendgrp.setAttribute('transform', translate);
                }
                if (this.legendPages.length > 0) {
                    legendBounds = legendgrp.getBoundingClientRect();
                    scrollButtons = document.getElementById("scrollButtons").getBoundingClientRect();
                    x = legendBounds['width'] / 2 - scrollButtons['width'] / 2;
                    y = legendBounds['height'];
                    translate = 'translate(' + x.toString() + ',' + y.toString() + ')';
                    document.getElementById("scrollButtons").setAttribute('transform', translate);
                }
            }
            else {
                if (legend['title']['visible'] && legend['title']['text'] != "") {
                    titleTransform = (legendItemgrp.getBoundingClientRect().width - document.getElementById(this._id + "_LegendTitleText").getBoundingClientRect().width) / 2;
                    translate = 'translate(' + titleTransform.toString() + ',0)';
                    document.getElementById(this._id + "_LegendTitleText").setAttribute('transform', translate);
                }
            }
            if ((legend['position'] == sunburstLegendPosition.bottom || legend['position'] == sunburstLegendPosition.top) && legend['alignment'] != sunburstAlignment.center) {
                if (legend['alignment'] == sunburstAlignment.near) {
                    x = -Math.abs(legendItemgrp.getBoundingClientRect().left) + this.elementSpacing;
                    translate = 'translate(' + x.toString() + '0)';
                    legendgrp.setAttribute('transform', translate);
                }
                else if (legend['alignment'] == sunburstAlignment.far) {
                    x = Math.abs(legendItemgrp.getBoundingClientRect().right - legendItemgrp.getBoundingClientRect().width);
                    x = x - (this.elementSpacing + this.model.margin.right);
                    translate = 'translate(' + x.toString() + ',0)';
                    legendgrp.setAttribute('transform', translate);
                }
            }
            else if ((legend['position'] == sunburstLegendPosition.left || legend['position'] == sunburstLegendPosition.right) && legend['alignment'] != sunburstAlignment.center) {
                var trans = legendgrp.getAttribute("transform").split(" ");
                if (legend['alignment'] == sunburstAlignment.near) {
                    x = legendgrp.getBoundingClientRect().left + this.elementSpacing;
                    y = this.elementSpacing + this.model.margin.top;
                    translate = trans[0] + ',' + y.toString() + ')';
                    legendgrp.setAttribute('transform', translate);
                }
                else {
                    x = legendgrp.getBoundingClientRect().left + this.elementSpacing;
                    y = this.areaBounds['actualHeight'] - legendgrp.getBoundingClientRect().height + this.elementSpacing + this.model.margin.bottom;
                    translate = trans[0] + ',' + y.toString() + ')';
                    legendgrp.setAttribute('transform', translate);
                }
            }
        };
        SunburstChart.prototype.drawScrollbuttons = function (legend) {
            var legendItemgroup, legendItemsize, position = legend['position'], options, scrollgroup, scrollPath, pageText, pageNumber;
            if (legend['position'] != sunburstLegendPosition.float) {
                scrollgroup = this.createGroup({ 'id': 'scrollButtons' });
                options = {
                    'id': 'scrollUp',
                    'd': 'M 6 0 L 12 12 0 12 Z',
                    'fill': '#3E576F'
                };
                scrollPath = this.drawPath(options);
                scrollgroup.appendChild(scrollPath);
                options = {
                    'id': 'scrollDown',
                    'd': 'M 40.359375 0 L 52.359375 0 46.359375 12 Z',
                    'fill': '#3E576F'
                };
                scrollPath = this.drawPath(options);
                scrollgroup.appendChild(scrollPath);
                options = {
                    'id': 'pageNumber',
                    'x': 15,
                    'y': 10,
                    'fill': legend['font']['color'],
                    'font-size': legend['font']['size'],
                    'font-style': legend['font']['fontStyle'],
                    'font-family': legend['font']['fontFamily'],
                    'font-weight': legend['font']['fontWeight'],
                    'text-anchor': 'start',
                };
                pageNumber = this.currentpageNumber.toString() + '/' + this.totalpageNumbers;
                pageText = this.createText(options, pageNumber);
                scrollgroup.appendChild(pageText);
                this.scrollClick = this.scrollClick.bind(this);
                scrollgroup.addEventListener('click', this.scrollClick, true);
            }
            this.gLegendEle.appendChild(scrollgroup);
        };
        SunburstChart.prototype.scrollClick = function (event) {
            var legend = this.model.legend, targetId = event.target['id'], legendGroupEle, transform, currentPageNumber = this.currentpageNumber, totalPageNumber = this.totalpageNumbers, pageNumber, legendGrp;
            legendGroupEle = document.getElementById(this._id + "legendItem_Group");
            pageNumber = document.getElementById("pageNumber");
            if (targetId == 'scrollDown' && currentPageNumber != totalPageNumber) {
                this.currentpageNumber = currentPageNumber + 1;
                legendGroupEle.parentNode.removeChild(legendGroupEle);
                legendGrp = this.drawlegendItem(legend, this.legendPages[this.currentpageNumber - 1], true);
                this.gLegendEle.appendChild(legendGrp);
                document.getElementById(this._id + "_svg").appendChild(this.gLegendEle);
                pageNumber.textContent = this.currentpageNumber.toString() + '/' + this.totalpageNumbers.toString();
                this.legendClick = this.legendClick.bind(this);
                legendGroupEle.addEventListener('click', this.legendClick, true);
            }
            else if (targetId == 'scrollUp' && currentPageNumber != 1) {
                this.currentpageNumber = currentPageNumber - 1;
                legendGroupEle.parentNode.removeChild(legendGroupEle);
                legendGrp = this.drawlegendItem(legend, this.legendPages[this.currentpageNumber - 1], true);
                this.gLegendEle.appendChild(legendGrp);
                document.getElementById(this._id + "_svg").appendChild(this.gLegendEle);
                pageNumber.textContent = this.currentpageNumber.toString() + '/' + this.totalpageNumbers.toString();
                this.legendClick = this.legendClick.bind(this);
                legendGroupEle.addEventListener('click', this.legendClick, true);
            }
            if (legend['position'] == sunburstLegendPosition.top || legend['position'] == sunburstLegendPosition.bottom)
                this.legendPositioning(legend, false);
        };
        SunburstChart.prototype.drawLegendTitle = function (legendTitle, legend) {
            var text = legendTitle['text'], textLocation, textSize = this.measureText(legendTitle['text'], legendTitle['font']), options, elementSpacing = this.elementSpacing, radius = this.circularRadius[this.totallayerCount - 1], x, y, textAnchor, titleText, startX = 0, startY = 0, fill = legendTitle['font'].color;
            fill = this.isNullOrUndefined(fill) ? (this.model.theme.toString().indexOf("dark") != -1 ? "white" : "black") : fill;
            if (legend['position'] == sunburstLegendPosition.bottom) {
                startY = this.areaBounds['actualHeight'] + (textSize['height'] / 2) + elementSpacing + this.yOffset;
            }
            else if (legend['position'] == sunburstLegendPosition.top) {
                startY = elementSpacing + this.yOffset + (textSize['height'] / 2);
                if (!this.isNullOrUndefined(legend['size']['height']))
                    startY = legend['size']['height'] + this.yOffset;
            }
            else if (legend['position'] == sunburstLegendPosition.left || legend['position'] == sunburstLegendPosition.right) {
                startY = elementSpacing + this.model.margin.top;
                startX -= elementSpacing;
            }
            else {
                startY = legend['location'].y;
                startX = legend['location'].x;
            }
            switch (legendTitle['textAlignment']) {
                case 'far':
                    startX += this.LegendBounds['Width'] - textSize['width'] / 2;
                    break;
                case 'near':
                    startX += (textSize['width']) / 2;
                    break;
                case 'center':
                    startX += this.LegendBounds['Width'] / 2;
            }
            this.legendTitleLocation = { 'x': startX, 'y': startY, width: textSize['width'], height: textSize['height'] };
            options = {
                'id': this._id + '_LegendTitleText',
                'x': startX,
                'y': startY,
                'fill': fill,
                'font-size': legendTitle['font']['size'],
                'font-style': legendTitle['font']['fontStyle'],
                'font-family': legendTitle['font']['fontFamily'],
                'font-weight': legendTitle['font']['fontWeight'],
                'text-anchor': 'middle',
            };
            titleText = this.createText(options, legendTitle['text']);
            return titleText;
        };
        SunburstChart.prototype.drawlegendItem = function (legend, legendCollection, isScroll) {
            var xlocation = 0, ylocation = 0, textSize, radius, symbol = this.model.legend.itemStyle, fill, shape, textwidth = 0, legendGroup, textoptions, text, itemPadding;
            this.legendItemGroup = this.createGroup({ 'id': this._id + 'legendItem_Group' });
            if (this.model.legend.position == sunburstLegendPosition.bottom || this.model.legend.position == sunburstLegendPosition.top) {
                return this.drawBottomTopLegend(legend, legendCollection);
            }
            else if (this.model.legend.position == sunburstLegendPosition.left || this.model.legend.position == sunburstLegendPosition.right) {
                return this.drawLeftRightLegend(legend, legendCollection, isScroll);
            }
            else {
                itemPadding = 0;
                if (legend['title']['visible'] && legend['title']['text'] != " ") {
                    textSize = this.measureText(legend['title']['text'], legend['title']['font']);
                    ylocation = legend['location']['y'] + (textSize['height'] / 2) + this.elementSpacing;
                }
                else
                    ylocation = legend['location']['y'];
                xlocation = legend['location']['x'];
                for (var i = 0; i < legendCollection.length; i++) {
                    xlocation += textwidth + itemPadding;
                    radius = Math.sqrt(symbol['width'] * symbol['width'] + symbol['height'] * symbol['height']) / 2;
                    fill = legendCollection[i]['visibility'] ? legendCollection[i]['fill'] : 'grey';
                    shape = this.drawLegendShape(legendCollection[i], xlocation, ylocation, i);
                    if (this.model.legendItemRendering) {
                        var commonEventArgs = $.extend({}, this.common);
                        var data = {
                            location: { x: xlocation, y: ylocation },
                            text: legendCollection[i]['Text'],
                            shape: legendCollection[i]['sunburstLegendShape']
                        };
                        commonEventArgs.data = data;
                        this._trigger("legendItemRendering", commonEventArgs);
                    }
                    textwidth = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['width'] + (radius) + this.model.legend.itemPadding;
                    itemPadding = legend['itemPadding'];
                    legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                    legendGroup['style']['cursor'] = 'pointer';
                    textoptions = {
                        'id': this._id + '_svg' + '_LegendItemText' + i.toString(),
                        'x': xlocation + (radius),
                        'y': ylocation + (((radius * 3) / 4)),
                        'fill': legendCollection[i]['font']['color'],
                        'font-size': legendCollection[i]['font']['size'],
                        'font-style': legendCollection[i]['font']['fontStyle'],
                        'font-family': legendCollection[i]['font']['fontFamily'],
                        'font-weight': legendCollection[i]['font']['fontWeight'],
                        'text-anchor': 'start',
                    };
                    text = this.createText(textoptions, legendCollection[i]['Text']);
                    legendGroup.appendChild(shape);
                    legendGroup.appendChild(text);
                    this.legendItemGroup.appendChild(legendGroup);
                }
                return this.legendItemGroup;
            }
        };
        SunburstChart.prototype.legendClick = function (event) {
            var targetId, childElement, legendText, points = [], legendpoint = {}, circleElement, fill, parentElement, element;
            if (this.rotateanim || this.model.enableAnimation) {
                this.stopAnimation();
            }
            if (this.model.legend.clickAction == sunburstLegendClickAction.toggleSegmentVisibility) {
                targetId = event['target']['id'];
                parentElement = document.getElementById(targetId).parentNode;
                childElement = parentElement.childNodes[1];
                circleElement = parentElement.childNodes[0];
                legendText = childElement.textContent;
                element = document.getElementById(this._id + '_svg');
                element.parentNode.replaceChild(element.cloneNode(false), element);
                for (var i = 0; i < this.legendCollection.length; i++) {
                    if (legendText == this.legendCollection[i]['Text']) {
                        if (this.legendCollection[i]['visibility']) {
                            this.legendCollection[i]['visibility'] = false;
                            legendpoint = { 'x': this.legendCollection[i]['x'], 'y': this.legendCollection[i]['y'], 'fill': this.legendCollection[i]['fill'], 'text': this.legendCollection[i]['Text'], 'point': this.legendCollection[i]['points'] };
                        }
                        else {
                            this.legendCollection[i]['visibility'] = true;
                            points.push({ 'x': this.legendCollection[i]['x'], 'y': this.legendCollection[i]['y'], 'fill': this.legendCollection[i]['fill'], 'text': this.legendCollection[i]['Text'], 'point': this.legendCollection[i]['points'] });
                        }
                    }
                    else {
                        if (this.legendCollection[i]['visibility'])
                            points.push({ 'x': this.legendCollection[i]['x'], 'y': this.legendCollection[i]['y'], 'fill': this.legendCollection[i]['fill'], 'text': this.legendCollection[i]['Text'], 'point': this.legendCollection[i]['points'] });
                    }
                }
                if (this.model.legendItemClick) {
                    var commonEventArgs = $.extend({}, this.common);
                    var data = {
                        location: { x: legendpoint['x'], y: legendpoint['y'] },
                        text: legendText,
                        point: legendpoint['point']
                    };
                    commonEventArgs.data = data;
                    this._trigger("legendItemClick", commonEventArgs);
                }
                this.processData(points);
                this.legendClicked = true;
                this.drawSunburst(this.layerData);
                this.legendClicked = false;
            }
        };
        SunburstChart.prototype.drawLegendShape = function (legendCollection, locX, locY, index) {
            var symbol = this.model.legend.itemStyle, width = symbol['width'], height = symbol['height'], fill = legendCollection['visibility'] ? legendCollection['fill'] : 'grey', shape = legendCollection['sunburstLegendShape'], funcName = 'Path', stroke = legendCollection['visibility'] ? this.model.legend.border.color : 'grey', path, x = locX + (-width / 2), y = locY + (-height / 2), radius, renderOption, eq, xValue, yValue;
            renderOption = {
                'id': this._id + '_svg' + '_LegendItemShape' + index.toString(),
                'fill': fill,
                'stroke': stroke,
                'stroke-width': this.model.legend.border.width,
                'x': x,
                'y': y,
                'width': width,
                'height': height
            };
            switch (shape) {
                case 'circle':
                    funcName = 'Circle';
                    radius = Math.sqrt(height * height + width * width) / 2;
                    renderOption['r'] = radius;
                    renderOption['cx'] = locX;
                    renderOption['cy'] = locY;
                    break;
                case 'diamond':
                    path = 'M' + ' ' + x + ' ' + locY + ' ' +
                        'L' + ' ' + locX + ' ' + (locY + (-height / 2)) + ' ' +
                        'L' + ' ' + (locX + (width / 2)) + ' ' + locY + ' ' +
                        'L' + ' ' + locX + ' ' + (locY + (height / 2)) + ' ' +
                        'L' + ' ' + x + ' ' + locY + ' z';
                    renderOption['d'] = path;
                    break;
                case 'rectangle':
                    path = 'M' + ' ' + x + ' ' + (locY + (-height / 2)) + ' ' +
                        'L' + ' ' + (locX + (width / 2)) + ' ' + (locY + (-height / 2)) + ' ' +
                        'L' + ' ' + (locX + (width / 2)) + ' ' + (locY + (height / 2)) + ' ' +
                        'L' + ' ' + x + ' ' + (locY + (height / 2)) + ' ' +
                        'L' + ' ' + x + ' ' + (locY + (-height / 2)) + ' z';
                    renderOption['d'] = path;
                    break;
                case 'triangle':
                    path = 'M' + ' ' + x + ' ' + (locY + (height / 2)) + ' ' +
                        'L' + ' ' + locX + ' ' + (locY + (-height / 2)) + ' ' +
                        'L' + ' ' + (locX + (width / 2)) + ' ' + (locY + (height / 2)) + ' ' +
                        'L' + ' ' + x + ' ' + (locY + (height / 2)) + ' z';
                    renderOption['d'] = path;
                    break;
                case 'pentagon':
                    eq = 72;
                    radius = Math.sqrt(height * height + width * width) / 2;
                    for (var i = 0; i <= 5; i++) {
                        xValue = radius * Math.cos((Math.PI / 180) * (i * eq));
                        yValue = radius * Math.sin((Math.PI / 180) * (i * eq));
                        if (i === 0) {
                            path = 'M' + ' ' + (locX + xValue) + ' ' + (locY + yValue) + ' ';
                        }
                        else {
                            path = path.concat('L' + ' ' + (locX + xValue) + ' ' + (locY + yValue) + ' ');
                        }
                    }
                    path = path.concat('Z');
                    renderOption['d'] = path;
                    break;
                case 'cross':
                    path = "M" + " " + (locX - width) + " " + locY + " " + "L" + " " + (locX + width) + " " + locY + " " +
                        "M" + " " + locX + " " + (locY + height) + " " + "L" + " " + locX + " " + (locY - height);
                    renderOption['d'] = path;
                    renderOption['stroke'] = fill;
                    break;
            }
            return this['draw' + funcName](renderOption);
        };
        SunburstChart.prototype.drawBottomTopLegend = function (legend, legendCollection) {
            var legendTitleLocation = this.legendTitleLocation, margin = this.model.margin, yOffset = this.yOffset, xlocation = 0, itemPadding = 0, elementSpacing = this.elementSpacing, legendTextcolor, ylocation, textSize, radius, symbol = this.model.legend.itemStyle, fill = this.model.legend.font.color, circleoptions, shape, textwidth = 0, legendGroup, textoptions, text;
            legendTextcolor = this.isNullOrUndefined(fill) ? (this.model.theme.toString().indexOf("dark") != -1 ? "white" : "black") : fill;
            if (this.isNullOrUndefined(legend['rowCount'] || legend['columnCount'])) {
                this.legendItemGroup = this.createGroup({ 'id': this._id + 'legendItem_Group' });
                if (legend['title'].visible && legend['title'].text != " ") {
                    textSize = this.measureText(legend['title']['text'], legend['title']['font']);
                    if (legend['position'] == sunburstLegendPosition.bottom)
                        ylocation = this.areaBounds['actualHeight'] + (textSize['height']) + (2 * elementSpacing) + yOffset;
                    else
                        ylocation = yOffset + textSize['height'] + (2 * elementSpacing);
                }
                else {
                    if (legend['position'] = sunburstLegendPosition.bottom)
                        ylocation = elementSpacing + margin['top'] + (2 * this.circularRadius[this.totallayerCount - 1]) + yOffset + elementSpacing;
                    else
                        ylocation = elementSpacing + margin['top'] + yOffset + elementSpacing;
                }
                for (var i = 0; i < legendCollection.length; i++) {
                    xlocation += elementSpacing + textwidth + itemPadding;
                    radius = Math.sqrt(symbol['width'] * symbol['width'] + symbol['height'] * symbol['height']) / 2;
                    fill = legendCollection[i]['visibility'] ? legendCollection[i]['fill'] : 'grey';
                    if (xlocation + textwidth > 900) {
                        ylocation = ylocation + this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['height'] + elementSpacing;
                        xlocation = elementSpacing;
                    }
                    this.findLegendPosition(radius, xlocation, ylocation, legend, legendCollection[i]);
                    if (this.legendInRegion) {
                        if (this.model.legendItemRendering) {
                            var commonEventArgs = $.extend({}, this.common);
                            var data = {
                                location: { x: xlocation, y: ylocation },
                                text: legendCollection[i]['Text'],
                                shape: legendCollection[i]['sunburstLegendShape']
                            };
                            commonEventArgs.data = data;
                            this._trigger("legendItemRendering", commonEventArgs);
                        }
                        legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                        legendGroup['style']['cursor'] = 'pointer';
                        shape = this.drawLegendShape(legendCollection[i], xlocation, ylocation, i);
                        legendGroup.appendChild(shape);
                        textwidth = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['width'] + (radius * 2);
                        textoptions = {
                            'id': this._id + '_svg' + '_LegendItemText' + i.toString(),
                            'x': xlocation + elementSpacing,
                            'y': ylocation + ((radius * 3) / 4),
                            'fill': legendTextcolor,
                            'font-size': legendCollection[i]['font']['size'],
                            'font-style': legendCollection[i]['font']['fontStyle'],
                            'font-family': legendCollection[i]['font']['fontFamily'],
                            'font-weight': legendCollection[i]['font']['fontWeight'],
                            'text-anchor': 'start',
                        };
                        itemPadding = legend['itemPadding'];
                        text = this.createText(textoptions, legendCollection[i]['Text']);
                        legendGroup.appendChild(text);
                        this.legendItemGroup.appendChild(legendGroup);
                    }
                    else {
                        this.legendPaging(legend, i, legendCollection);
                        break;
                    }
                }
            }
            else {
                var rowCount = legend['rowCount'], columnCount = legend['columnCount'], legendItemCount = legendCollection.length, Num = 0, renderasper = void 0, count = void 0, currentX = 10, currentY = 26, startX = 10;
                if (legend['title'].visible && legend['title'].text != " ") {
                    textSize = this.measureText(legend['title']['text'], legend['title']['font']);
                    if (legend['position'] == sunburstLegendPosition.bottom)
                        ylocation = (2 * elementSpacing) + margin['top'] + (2 * this.circularRadius[this.totallayerCount - 1]) + yOffset + (textSize['height']);
                    else
                        ylocation = (2 * elementSpacing) + margin['top'] + yOffset + textSize['height'];
                }
                else {
                    if (legend['position'] == sunburstLegendPosition.bottom)
                        ylocation = (2 * elementSpacing) + margin['top'] + (2 * this.circularRadius[this.totallayerCount - 1]) + yOffset;
                    else
                        ylocation = (2 * elementSpacing) + margin['top'] + yOffset;
                }
                for (var i = 0; i < legendItemCount; i++) {
                    fill = legendCollection[i]['visibility'] ? legendCollection[i]['fill'] : 'grey';
                    legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                    radius = Math.sqrt(symbol['width'] * symbol['width'] + symbol['height'] * symbol['height']) / 2;
                    if (currentX + legendCollection[i]['Bounds']['Width'] > this.LegendBounds['Width'] + startX) {
                        currentX = textwidth = 10;
                        ylocation += elementSpacing + legendCollection[i]['Bounds']['Height'];
                    }
                    this.findLegendPosition(radius, currentX, ylocation, legend, legendCollection[i]);
                    if (this.legendInRegion) {
                        if (this.model.legendItemRendering) {
                            var commonEventArgs = $.extend({}, this.common);
                            var data = {
                                location: { x: currentX, y: ylocation },
                                text: legendCollection[i]['Text'],
                                shape: legendCollection[i]['sunburstLegendShape']
                            };
                            commonEventArgs.data = data;
                            this._trigger("legendItemRendering", commonEventArgs);
                        }
                        textwidth = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['width'] + (radius * 2);
                        legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                        legendGroup['style']['cursor'] = 'pointer';
                        shape = this.drawLegendShape(legendCollection[i], currentX, ylocation, i);
                        legendGroup.appendChild(shape);
                        textwidth = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['width'] + (radius * 2);
                        textoptions = {
                            'id': this._id + '_svg' + '_LegendItemText' + i.toString(),
                            'x': currentX + elementSpacing,
                            'y': ylocation + (((radius * 3) / 4)),
                            'fill': legendTextcolor,
                            'font-size': legendCollection[i]['font']['size'],
                            'font-style': legendCollection[i]['font']['fontStyle'],
                            'font-family': legendCollection[i]['font']['fontFamily'],
                            'font-weight': legendCollection[i]['font']['fontWeight'],
                            'text-anchor': 'start',
                        };
                        currentX += textwidth + elementSpacing;
                        text = this.createText(textoptions, legendCollection[i]['Text']);
                        legendGroup.appendChild(text);
                        this.legendItemGroup.appendChild(legendGroup);
                    }
                    else {
                        this.legendPaging(legend, i, legendCollection);
                        break;
                    }
                }
            }
            return this.legendItemGroup;
        };
        SunburstChart.prototype.drawLeftRightLegend = function (legend, legendCollection, isScroll) {
            var xlocation = 0, itemPadding = 0, legendTextcolor, ylocation = 0, textSize, radius, symbol = this.model.legend.itemStyle, fill = this.model.legend.font.color, shape, textwidth = 0, legendGroup, textoptions, text, textheight = 0, elementSpacing = this.elementSpacing, margin = this.model.margin;
            legendTextcolor = this.isNullOrUndefined(fill) ? (this.model.theme.toString().indexOf("dark") != -1 ? "white" : "black") : fill;
            if (this.isNullOrUndefined(legend['rowCount'] || legend['columnCount'])) {
                if (legend['title'].visible && legend['title'].text != " ") {
                    textSize = this.measureText(legend['title']['text'], legend['title']['font']);
                    textheight = (textSize['height']) + elementSpacing;
                }
                ylocation = textheight + elementSpacing + itemPadding;
                xlocation = elementSpacing + margin['left'];
                for (var i = 0; i < legendCollection.length; i++) {
                    textSize = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font']);
                    radius = Math.sqrt(symbol['width'] * symbol['width'] + symbol['height'] * symbol['height']) / 2;
                    fill = legendCollection[i]['visibility'] ? legendCollection[i]['fill'] : 'grey';
                    this.findLegendPosition(radius, xlocation, ylocation, legend, legendCollection[i]);
                    if (this.legendInRegion) {
                        if (this.model.legendItemRendering) {
                            var commonEventArgs = $.extend({}, this.common);
                            var data = {
                                location: { x: xlocation, y: ylocation },
                                text: legendCollection[i]['Text'],
                                shape: legendCollection[i]['sunburstLegendShape']
                            };
                            commonEventArgs.data = data;
                            this._trigger("legendItemRendering", commonEventArgs);
                        }
                        shape = this.drawLegendShape(legendCollection[i], xlocation, ylocation, i);
                        textwidth += textSize['width'] + (radius);
                        legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                        textoptions = {
                            'id': this._id + '_svg' + '_LegendItemText' + i.toString(),
                            'x': xlocation + (this.elementSpacing),
                            'y': ylocation + (((radius * 3) / 4)),
                            'fill': legendTextcolor,
                            'font-size': legendCollection[i]['font']['size'],
                            'font-style': legendCollection[i]['font']['fontStyle'],
                            'font-family': legendCollection[i]['font']['fontFamily'],
                            'font-weight': legendCollection[i]['font']['fontWeight'],
                            'text-anchor': 'start',
                        };
                        itemPadding = legend['itemPadding'];
                        ylocation += textSize['height'] / 2 + this.elementSpacing;
                        text = this.createText(textoptions, legendCollection[i]['Text']);
                        legendGroup.appendChild(shape);
                        legendGroup.appendChild(text);
                        this.legendItemGroup.appendChild(legendGroup);
                    }
                    else {
                        this.legendPaging(legend, i, legendCollection);
                        break;
                    }
                }
                return this.legendItemGroup;
            }
            else {
                var rowCount = legend['rowCount'], columnCount = legend['columnCount'], legendItemCount = legendCollection.length, Num = 0, renderasper = void 0, count = void 0, currentX = 10, currentY = 26, startX = 10, maxWidth = 0;
                if (!isScroll)
                    this.LegendBounds['Height'] += this.measureText(legend['title']['text'], legend['title']['font'])['height'];
                if (this.model.legend.title.visible && this.model.legend.title.text != " ") {
                    textSize = this.measureText(legend['title']['text'], legend['title']['font']);
                    textheight = (textSize['height']);
                }
                ylocation = textheight + this.elementSpacing;
                xlocation = this.elementSpacing + this.model.margin.left;
                for (var i = 0; i < legendItemCount; i++) {
                    fill = legendCollection[i]['visibility'] ? legendCollection[i]['fill'] : 'grey';
                    legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                    radius = Math.sqrt(symbol['width'] * symbol['width'] + symbol['height'] * symbol['height']) / 2;
                    if (((currentY + legendCollection[i]['Bounds']['Height'] + legend['itemPadding']) + textheight + 2 > this.LegendBounds['Height'] + 26)) {
                        currentY = 26;
                        currentX += maxWidth + (legend['itemPadding']);
                    }
                    currentY += (legendCollection[i]['Bounds']['Height'] / 2) + legend['itemPadding'];
                    maxWidth = Math.max(maxWidth, legendCollection[i]['Bounds']['Width']);
                    this.findLegendPosition(radius, currentX, currentY, legend, legendCollection[i]);
                    if (this.legendInRegion) {
                        if (this.model.legendItemRendering) {
                            var commonEventArgs = $.extend({}, this.common);
                            var data = {
                                location: { x: currentX, y: currentY },
                                text: legendCollection[i]['Text'],
                                shape: legendCollection[i]['sunburstLegendShape']
                            };
                            commonEventArgs.data = data;
                            this._trigger("legendItemRendering", commonEventArgs);
                        }
                        textwidth = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['width'] + (radius * 2);
                        legendGroup = this.createGroup({ id: this._id + '_svg' + '_Legend' + i.toString() });
                        legendGroup['style']['cursor'] = 'pointer';
                        shape = this.drawLegendShape(legendCollection[i], currentX, currentY, i);
                        legendGroup.appendChild(shape);
                        textwidth = this.measureText(legendCollection[i]['Text'], legendCollection[i]['font'])['width'] + (radius * 2);
                        textoptions = {
                            'id': this._id + '_svg' + '_LegendItemText' + i.toString(),
                            'x': currentX + radius,
                            'y': currentY + (((radius * 3) / 4)),
                            'fill': legendTextcolor,
                            'font-size': legendCollection[i]['font']['size'],
                            'font-style': legendCollection[i]['font']['fontStyle'],
                            'font-family': legendCollection[i]['font']['fontFamily'],
                            'font-weight': legendCollection[i]['font']['fontWeight'],
                            'text-anchor': 'start',
                        };
                        text = this.createText(textoptions, legendCollection[i]['Text']);
                        legendGroup.appendChild(text);
                        this.legendItemGroup.appendChild(legendGroup);
                    }
                    else {
                        this.legendPaging(legend, i, legendCollection);
                        break;
                    }
                }
                return this.legendItemGroup;
            }
        };
        SunburstChart.prototype.legendPaging = function (legend, drawnLegendCount, legendCollection) {
            var totalLegendCount = this.legendCollection.length, visibleLegendCount = drawnLegendCount, pages;
            this.legendPages = [];
            this.currentpageNumber = 1;
            this.totalpageNumbers = drawnLegendCount == 0 ? totalLegendCount : (totalLegendCount % drawnLegendCount) == 0 ? Math.floor(totalLegendCount / drawnLegendCount) : Math.floor(totalLegendCount / drawnLegendCount) + 1;
            for (var i = 0; i < totalLegendCount; i = i + visibleLegendCount) {
                pages = [];
                for (var j = 0; j < visibleLegendCount; j++) {
                    if ((i + j) < totalLegendCount)
                        pages.push(legendCollection[i + j]);
                }
                if (visibleLegendCount == 0) {
                    pages.push(legendCollection[i]);
                    this.legendPages.push(pages);
                    break;
                }
                this.legendPages.push(pages);
            }
        };
        SunburstChart.prototype.findLegendPosition = function (radius, xlocation, ylocation, legend, legendItem) {
            var elementSpacing = this.elementSpacing, textsize, maximum = 20 / 100;
            if (legend['position'] == sunburstLegendPosition.bottom) {
                if (radius + ylocation + elementSpacing > this.height - elementSpacing) {
                    this.legendInRegion = false;
                }
                else
                    this.legendInRegion = true;
            }
            else if (legend['position'] == sunburstLegendPosition.top) {
                if ((this.yOffset + (maximum * this.height) - this.elementSpacing - radius) > ylocation)
                    this.legendInRegion = true;
                else
                    this.legendInRegion = false;
            }
            else if ((legend['position'] == sunburstLegendPosition.left) || (legend['position'] == sunburstLegendPosition.right)) {
                if (!this.isNullOrUndefined(legend['rowCount']) || !this.isNullOrUndefined(legend['columnCount'])) {
                    textsize = this.measureText(legendItem['Text'], legendItem['font']);
                    if ((maximum * this.width + elementSpacing) > (xlocation + radius + textsize['width']))
                        this.legendInRegion = true;
                    else
                        this.legendInRegion = false;
                }
                else {
                    if (radius + ylocation + elementSpacing > this.height - elementSpacing)
                        this.legendInRegion = false;
                    else
                        this.legendInRegion = true;
                }
            }
        };
        SunburstChart.prototype.drawDatalabel = function (layerData) {
            this.dataLabelGroupEle = this.createGroup({ 'id': this._id + '_svg_DataLabelGroup' });
            for (var i = 0; i < layerData.length; i++) {
                var layerPoints = layerData[i];
                var point = void 0, text = void 0, textsize = void 0, sunburstStartAngle = void 0, midAngle = void 0, midPoint = void 0, childMidPoint = void 0, bounds = void 0, radius = void 0, size = void 0, position = void 0, positionX = void 0, positionY = void 0, textAnchor = void 0, textOptions = void 0, textele = void 0, startPoint = void 0, textOffset = void 0, startX = void 0, startY = void 0, midX = void 0, midY = void 0, childMidX = void 0, childMidY = void 0, layerNumber = void 0, dMidX = void 0, dMidY = void 0, model = this.model, sliceRadius = this.circularRadius[0] - this.innerRadius[0], sunburstMidPoint = void 0;
                for (var j = 0; j < layerPoints.point.length; j++) {
                    point = layerPoints.point[j];
                    if (point['y'] != null) {
                        layerNumber = layerPoints['layerNumber'];
                        text = point['text'] ? point['text'] : (model['dataSource']) ? point['x'] : point['y'].toString();
                        textsize = this.measureText(text, model['dataLabelSettings'].font);
                        sunburstStartAngle = -0.5 * Math.PI;
                        radius = this.circularRadius[layerPoints.layerNumber - 1];
                        textOffset = textsize['height'] / 2;
                        startX = this.circleCenterX;
                        startY = this.circleCenterY;
                        midAngle = point['midAngle'] + sunburstStartAngle;
                        midX = this.getXcordinate(startX, radius, midAngle);
                        midY = this.getYcordinate(startY, radius, midAngle);
                        dMidX = this.getXcordinate(startX, this.innerRadius[layerNumber - 1], midAngle);
                        dMidY = this.getYcordinate(startY, this.innerRadius[layerNumber - 1], midAngle);
                        sunburstMidPoint = { 'dMidX': dMidX, 'dMidY': dMidY };
                        if (layerPoints.layerNumber > 1) {
                            childMidX = this.getXcordinate(startX, this.circularRadius[layerPoints.layerNumber - 2], midAngle);
                            childMidY = this.getYcordinate(startY, this.circularRadius[layerPoints.layerNumber - 2], midAngle);
                        }
                        midPoint = { midX: midX, midY: midY };
                        childMidPoint = { childMidX: childMidX, childMidY: childMidY };
                        bounds = { midPoint: midPoint, childMidPoint: childMidPoint, 'sunburstMidPoint': sunburstMidPoint };
                        startPoint = { startX: startX, startY: startY };
                        size = {
                            width: this.width, height: this.height
                        };
                        position = this.calculateLabelPosition(startPoint, bounds);
                        positionX = position['positionX'];
                        positionY = position['positionY'];
                        textAnchor = "middle";
                        textOptions = this.textOptions(point, positionX, positionY, textsize, textAnchor, layerPoints.layerNumber, j);
                        if (this.isNullOrUndefined(model['dataLabelSettings'].template)) {
                            var commonDataLabelEventArgs = $.extend({}, this.common);
                            commonDataLabelEventArgs.data = { Text: text, location: { x: positionX, y: positionY }, pointIndex: point['pointIndex'] };
                            this._trigger("dataLabelRendering", commonDataLabelEventArgs);
                            if (model['dataLabelSettings'].labelRotationMode == sunburstLabelRotationMode.normal && model['dataLabelSettings'].labelOverflowMode != sunburstLabelOverflowMode.none && this.isNullOrUndefined(model['dataLabelSettings'].template)) {
                                text = this.horizontalTrim(textOptions, textsize['width'], commonDataLabelEventArgs.data.Text, startX, startY, point, this.model.dataLabelSettings.font, layerNumber - 1);
                            }
                            else if (model['dataLabelSettings'].labelRotationMode == sunburstLabelRotationMode.angle && model['dataLabelSettings'].labelOverflowMode != sunburstLabelOverflowMode.none && this.isNullOrUndefined(model['dataLabelSettings'].template)) {
                                text = this.rotatedTrim(textOptions, textsize['width'], commonDataLabelEventArgs.data.Text, sliceRadius, point);
                            }
                            if (text != '') {
                                textele = this.createText(textOptions, text);
                                this.dataLabelGroupEle.appendChild(textele);
                            }
                        }
                        else {
                            this.labelTemplate(positionX, positionY, textOptions, textsize, point);
                        }
                    }
                }
            }
            return this.dataLabelGroupEle;
        };
        SunburstChart.prototype.labelTemplate = function (positionX, positionY, textOptions, textsize, point) {
            var areaBoundsX, areaBoundsY, areaBoundsWidth, areaBoundsHeight, xPosition = 0, yPosition = 0, sunburstContainer = this._id, style = { 'interior': this.model.dataLabelSettings.fill, 'opacity': 1, 'borderColor': 'white', 'borderWidth': 0.1 }, color, width, height, templateContainer, templategroup, left, top, right, backgroundColor;
            if (!this.isNullOrUndefined(style) && style['interior']) {
                color = style['interior'];
            }
            else {
                color = "transparent";
            }
            templategroup = document.getElementById(this._id + "_svg_DataLabelGroup");
            if (this.isNullOrUndefined(templategroup)) {
                templategroup = document.createElement('div');
                templategroup.id = this._id + "_svg_DataLabelGroup";
                templategroup.style.zIndex = '5000';
                document.getElementById(this._id).appendChild(templategroup);
            }
            templateContainer = document.createElement('div');
            templateContainer.id = 'template_ele_' + this._id;
            this.clonenode = document.getElementById(this.model.dataLabelSettings.template).cloneNode(true);
            this.clonenode['style'].display = 'block';
            this.clonenode['innerHTML'] = this.parseTemplate(this.clonenode, point);
            templateContainer.style.backgroundColor = color;
            templateContainer.style.display = 'block';
            templateContainer.style.cursor = 'default';
            templateContainer.style.position = 'absolute';
            templateContainer.appendChild(this.clonenode);
            document.getElementById(this._id + "_svg_DataLabelGroup").appendChild(templateContainer);
            left = templateContainer.clientWidth;
            top = templateContainer.clientHeight;
            templateContainer.style.left = (textOptions['x'] - left / 2).toString() + 'px';
            templateContainer.style.top = (textOptions['y'] - top / 2).toString() + 'px';
        };
        SunburstChart.prototype.parseTemplate = function (clonenode, point) {
            var str;
            str = clonenode.innerHTML;
            if (str.search('#point.x#') != -1) {
                str = str.replace('#point.x#', point['x'].toString());
            }
            if (str.search('#point.y#') != -1) {
                str = str.replace('#point.y#', point['y'].toString());
            }
            if (str.search('#point.text#') != -1) {
                if (!this.isNullOrUndefined(point['text'])) {
                    str = str.replace('#point.text#', point['text'].toString());
                }
                else {
                    str = str.replace('#point.text#', point['y'].toString());
                }
            }
            return str;
        };
        SunburstChart.prototype.rotatedTrim = function (textOptions, textSize, text, radius, point) {
            var ellipsis = '...', model = this.model;
            while (radius - model['segmentBorder'].width < textSize) {
                if (model['dataLabelSettings'].labelOverflowMode == sunburstLabelOverflowMode.trim) {
                    text = this.trimText(text, text.length, ellipsis);
                    if (text == '...') {
                        text = '';
                        break;
                    }
                    else
                        textSize = this.measureText(text, model['dataLabelSettings'].font)['width'];
                }
                else {
                    text = '';
                    break;
                }
            }
            return text;
        };
        SunburstChart.prototype.trimText = function (text, maxLength, ellipsis) {
            var length, trimmedText;
            maxLength--;
            length = maxLength - ellipsis.length;
            trimmedText = text.substr(0, length);
            return trimmedText + ellipsis;
        };
        SunburstChart.prototype.horizontalTrim = function (textOptions, datalabelLength, datalabelText, startX, startY, point, datalabelFont, layerNumber) {
            var sunburstStartAngle = -0.5 * Math.PI, startAngle, endAngle, pointStartAngle, pointEndAngle, ellipsis = '...', totalDegree, distanceFromCenter, textinRegion, model = this.model, position;
            position = this.calculatePosition(textOptions, datalabelLength, startX, startY);
            startAngle = model['startAngle'];
            endAngle = model['endAngle'];
            totalDegree = endAngle - startAngle;
            startAngle = (Math.atan2(position['rightEndY'], position['rightEndX']) - sunburstStartAngle) % (2 * Math.PI);
            if (startAngle < 0)
                startAngle = 2 * Math.PI + startAngle;
            endAngle = (Math.atan2(position['leftEndY'], position['leftEndX']) - sunburstStartAngle) % (2 * Math.PI);
            if (endAngle < 0)
                endAngle = 2 * Math.PI + endAngle;
            pointStartAngle = parseFloat(point['start'].toFixed(14));
            pointEndAngle = parseFloat(point['end'].toFixed(14));
            if (totalDegree > 0) {
                pointStartAngle = pointStartAngle;
                pointEndAngle = pointEndAngle;
            }
            else {
                pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                pointEndAngle = pointEndAngle < 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
            }
            if (startAngle < 0 && (endAngle > 0 || endAngle == null)) {
                pointStartAngle = pointStartAngle < 0 ? 2 * Math.PI + pointStartAngle : pointStartAngle;
                pointEndAngle = pointEndAngle <= 0 ? 2 * Math.PI + pointEndAngle : pointEndAngle;
            }
            if (this.circleCenterX < textOptions['x'])
                distanceFromCenter = Math.sqrt(Math.pow(Math.abs(position['rightEndX']), 2) + Math.pow(Math.abs(position['rightEndY']), 2));
            else
                distanceFromCenter = Math.sqrt(Math.pow(Math.abs(position['leftEndX']), 2) + Math.pow(Math.abs(position['leftEndY']), 2));
            if (totalDegree < 0)
                pointEndAngle = [pointStartAngle, pointStartAngle = pointEndAngle][0];
            if ((endAngle >= pointStartAngle && endAngle <= pointEndAngle) && (startAngle >= pointStartAngle && startAngle <= pointEndAngle) &&
                (distanceFromCenter <= this.circularRadius[layerNumber] - model['segmentBorder'].width && distanceFromCenter > 0)) {
                textinRegion = true;
            }
            else {
                if (model['dataLabelSettings'].labelOverflowMode == sunburstLabelOverflowMode.hide) {
                    return '';
                }
                else {
                    textinRegion = false;
                    while (!textinRegion) {
                        datalabelText = this.trimText(datalabelText, datalabelText.length, ellipsis);
                        if (datalabelText == ellipsis) {
                            datalabelText = '';
                            break;
                        }
                        datalabelLength = this.measureText(datalabelText, model['dataLabelSettings'].font)['width'];
                        position = this.calculatePosition(textOptions, datalabelLength, startX, startY);
                        startAngle = (Math.atan2(position['rightEndY'], position['rightEndX']) - sunburstStartAngle) % (2 * Math.PI);
                        if (startAngle < 0)
                            startAngle = 2 * Math.PI + startAngle;
                        endAngle = (Math.atan2(position['leftEndY'], position['leftEndX']) - sunburstStartAngle) % (2 * Math.PI);
                        if (endAngle < 0)
                            endAngle = 2 * Math.PI + endAngle;
                        if (this.circleCenterX < textOptions['x'])
                            distanceFromCenter = Math.sqrt(Math.pow(Math.abs(position['rightEndX']), 2) + Math.pow(Math.abs(position['rightEndY']), 2));
                        else
                            distanceFromCenter = Math.sqrt(Math.pow(Math.abs(position['leftEndX']), 2) + Math.pow(Math.abs(position['leftEndY']), 2));
                        if ((endAngle >= pointStartAngle && endAngle <= pointEndAngle) && (startAngle >= pointStartAngle && startAngle <= pointEndAngle) && (distanceFromCenter <= this.circularRadius[layerNumber] && distanceFromCenter > 0)) {
                            textinRegion = true;
                        }
                    }
                }
            }
            return datalabelText;
        };
        SunburstChart.prototype.calculatePosition = function (textOptions, datalabelLength, startX, startY) {
            var rightEndX, rightEndY, leftEndX, leftEndY;
            rightEndX = (textOptions['x'] + (datalabelLength / 2)) - startX;
            rightEndY = textOptions['y'] - startY;
            leftEndX = (textOptions['x'] - (datalabelLength / 2)) - startX;
            leftEndY = textOptions['y'] - startY;
            return { 'rightEndX': rightEndX, 'rightEndY': rightEndY, 'leftEndX': leftEndX, 'leftEndY': leftEndY };
        };
        SunburstChart.prototype.textOptions = function (point, positionX, positionY, textsize, textAnchor, layerNumber, pointIndex) {
            var degree, correctAngle, angle = 0, textOptions, hexaValue, pointColor, dataLabelFont = this.model.dataLabelSettings.font, textColor = dataLabelFont['color'];
            if (this.model.dataLabelSettings.labelRotationMode == sunburstLabelRotationMode.angle) {
                if (point.midAngle > (2 * Math.PI) || point.midAngle < 0) {
                    correctAngle = this.findAngle(point.midAngle);
                }
                if (point.midAngle <= Math.PI || !this.isNullOrUndefined(correctAngle)) {
                    if (this.isNullOrUndefined(correctAngle))
                        angle = (((point.startAngle - (Math.PI / 2)) + (point.endAngle - (Math.PI / 2))) / 2) * (180 / Math.PI);
                    else {
                        if (correctAngle <= Math.PI)
                            angle = (((point.startAngle - (Math.PI / 2)) + (point.endAngle - (Math.PI / 2))) / 2) * (180 / Math.PI);
                        else
                            angle = ((((point.startAngle + point.endAngle) / 2) * 180) / Math.PI) - 270;
                    }
                }
                else {
                    angle = ((((point.startAngle + point.endAngle) / 2) * 180) / Math.PI) - 270;
                }
            }
            pointColor = this._colorNameToHex(point.fill);
            if (this.isNullOrUndefined(textColor) || textColor == "") {
                var rgbValue = this._hexToRgb(pointColor);
                var contrast = Math.round(((parseInt(rgbValue.r) * 299) + (parseInt(rgbValue.g) * 587) + (parseInt(rgbValue.b) * 114)) / 1000);
                textColor = (contrast >= 128) ? "black" : "white";
            }
            textOptions = {
                'id': this._id + '_legendIndex' + point.legendIndex + '_layerNumber' + layerNumber.toString() + '_pointIndex' + pointIndex.toString(),
                'x': positionX,
                'y': positionY + (textsize.height / 4),
                'fill': textColor,
                'font-size': dataLabelFont['size'],
                'font-family': dataLabelFont['fontFamily'],
                'font-style': dataLabelFont['fontStyle'],
                'font-weight': dataLabelFont['fontWeight'],
                'opacity': dataLabelFont['opacity'],
                'text-anchor': textAnchor,
                'cursor': 'default',
                'transform': 'rotate(' + angle + ',' + (positionX) + ',' + (positionY) + ')',
            };
            return textOptions;
        };
        SunburstChart.prototype._colorNameToHex = function (colour) {
            var color = colour;
            var colours = {
                "aliceblue": "#f0f8ff", "antiquewhite": "#faebd7", "aqua": "#00ffff", "aquamarine": "#7fffd4", "azure": "#f0ffff",
                "beige": "#f5f5dc", "bisque": "#ffe4c4", "black": "#000000", "blanchedalmond": "#ffebcd", "blue": "#0000ff", "blueviolet": "#8a2be2", "brown": "#a52a2a", "burlywood": "#deb887",
                "cadetblue": "#5f9ea0", "chartreuse": "#7fff00", "chocolate": "#d2691e", "coral": "#ff7f50", "cornflowerblue": "#6495ed", "cornsilk": "#fff8dc", "crimson": "#dc143c", "cyan": "#00ffff",
                "darkblue": "#00008b", "darkcyan": "#008b8b", "darkgoldenrod": "#b8860b", "darkgray": "#a9a9a9", "darkgreen": "#006400", "darkkhaki": "#bdb76b", "darkmagenta": "#8b008b", "darkolivegreen": "#556b2f",
                "darkorange": "#ff8c00", "darkorchid": "#9932cc", "darkred": "#8b0000", "darksalmon": "#e9967a", "darkseagreen": "#8fbc8f", "darkslateblue": "#483d8b", "darkslategray": "#2f4f4f", "darkturquoise": "#00ced1",
                "darkviolet": "#9400d3", "deeppink": "#ff1493", "deepskyblue": "#00bfff", "dimgray": "#696969", "dodgerblue": "#1e90ff",
                "firebrick": "#b22222", "floralwhite": "#fffaf0", "forestgreen": "#228b22", "fuchsia": "#ff00ff",
                "gainsboro": "#dcdcdc", "ghostwhite": "#f8f8ff", "gold": "#ffd700", "goldenrod": "#daa520", "gray": "#808080", "green": "#008000", "greenyellow": "#adff2f",
                "honeydew": "#f0fff0", "hotpink": "#ff69b4",
                "indianred ": "#cd5c5c", "indigo ": "#4b0082", "ivory": "#fffff0", "khaki": "#f0e68c",
                "lavender": "#e6e6fa", "lavenderblush": "#fff0f5", "lawngreen": "#7cfc00", "lemonchiffon": "#fffacd", "lightblue": "#add8e6", "lightcoral": "#f08080", "lightcyan": "#e0ffff", "lightgoldenrodyellow": "#fafad2",
                "lightgrey": "#d3d3d3", "lightgreen": "#90ee90", "lightpink": "#ffb6c1", "lightsalmon": "#ffa07a", "lightseagreen": "#20b2aa", "lightskyblue": "#87cefa", "lightslategray": "#778899", "lightsteelblue": "#b0c4de",
                "lightyellow": "#ffffe0", "lime": "#00ff00", "limegreen": "#32cd32", "linen": "#faf0e6",
                "magenta": "#ff00ff", "maroon": "#800000", "mediumaquamarine": "#66cdaa", "mediumblue": "#0000cd", "mediumorchid": "#ba55d3", "mediumpurple": "#9370d8", "mediumseagreen": "#3cb371", "mediumslateblue": "#7b68ee",
                "mediumspringgreen": "#00fa9a", "mediumturquoise": "#48d1cc", "mediumvioletred": "#c71585", "midnightblue": "#191970", "mintcream": "#f5fffa", "mistyrose": "#ffe4e1", "moccasin": "#ffe4b5",
                "navajowhite": "#ffdead", "navy": "#000080",
                "oldlace": "#fdf5e6", "olive": "#808000", "olivedrab": "#6b8e23", "orange": "#ffa500", "orangered": "#ff4500", "orchid": "#da70d6",
                "palegoldenrod": "#eee8aa", "palegreen": "#98fb98", "paleturquoise": "#afeeee", "palevioletred": "#d87093", "papayawhip": "#ffefd5", "peachpuff": "#ffdab9", "peru": "#cd853f", "pink": "#ffc0cb", "plum": "#dda0dd", "powderblue": "#b0e0e6", "purple": "#800080",
                "red": "#ff0000", "rosybrown": "#bc8f8f", "royalblue": "#4169e1",
                "saddlebrown": "#8b4513", "salmon": "#fa8072", "sandybrown": "#f4a460", "seagreen": "#2e8b57", "seashell": "#fff5ee", "sienna": "#a0522d", "silver": "#c0c0c0", "skyblue": "#87ceeb", "slateblue": "#6a5acd", "slategray": "#708090", "snow": "#fffafa", "springgreen": "#00ff7f", "steelblue": "#4682b4",
                "tan": "#d2b48c", "teal": "#008080", "thistle": "#d8bfd8", "tomato": "#ff6347", "turquoise": "#40e0d0",
                "violet": "#ee82ee",
                "wheat": "#f5deb3", "white": "#ffffff", "whitesmoke": "#f5f5f5",
                "yellow": "#ffff00", "yellowgreen": "#9acd32"
            };
            if (Object.prototype.toString.call(color) == '[object Array]')
                return color;
            if (typeof colours[color.toLowerCase()] != 'undefined')
                return colours[color.toLowerCase()];
            return color;
        };
        SunburstChart.prototype._hexToRgb = function (hex) {
            var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16)
            } : null;
        };
        SunburstChart.prototype.findAngle = function (midAngle) {
            var totalangle;
            if (midAngle > 0) {
                totalangle = midAngle % (2 * Math.PI);
                if (totalangle > (2 * Math.PI)) {
                    this.findAngle(totalangle);
                }
                else
                    return totalangle;
            }
            else {
                return ((2 * Math.PI) + midAngle);
            }
        };
        SunburstChart.prototype.calculateLabelPosition = function (startPoints, bounds) {
            var positionX, positionY, midX, midY, childMidX, childMidY, startX, startY, dMidX, dMidY;
            midX = bounds.midPoint.midX;
            midY = bounds.midPoint.midY;
            childMidX = bounds.childMidPoint.childMidX;
            childMidY = bounds.childMidPoint.childMidY;
            startX = startPoints.startX;
            startY = startPoints.startY;
            dMidX = bounds.sunburstMidPoint.dMidX;
            dMidY = bounds.sunburstMidPoint.dMidY;
            if (this.isNullOrUndefined(childMidX)) {
                positionX = (midX + dMidX) / 2;
                positionY = (midY + dMidY) / 2;
            }
            else {
                positionX = (midX + childMidX) / 2;
                positionY = (midY + childMidY) / 2;
            }
            return { positionX: positionX, positionY: positionY };
        };
        SunburstChart.prototype.drawPath = function (Options) {
            var path = document.getElementById(Options._id);
            if (path === null) {
                path = this.createElement('path');
            }
            this.setAttributes(Options, path);
            return path;
        };
        SunburstChart.prototype.sunburstRender = function (layerData) {
            this.circleCenterX = [];
            this.circleCenterY = [];
            this.circularRadius = [];
            this.sunburstRegions = [];
            this.startX = [];
            this.startY = [];
            this._visiblePoints = layerData;
            var layer;
            this.calculateSliceAngle(layerData[0].point);
            for (layer = 2; layer <= this.totallayerCount; layer++) {
                for (var j = 1; j < layerData.length; j++) {
                    if (layer == layerData[j].layerNumber) {
                        this.calculateChildAngle(layerData[j]);
                    }
                }
            }
            this.circularRadius = this.calculateRadius((this.areaBounds['actualWidth']), (this.areaBounds['actualHeight']), this.totallayerCount);
            if (this._drillInnerRadius.length == 0)
                this.circularRadius = this.calculateRadius((this.areaBounds['actualWidth']), (this.areaBounds['actualHeight']), this.totallayerCount);
            else {
                this.circularRadius = this._drillOuterRadius[this.drilldownCount - 1];
                this.innerRadius = this._drillInnerRadius[this.drilldownCount - 1];
            }
            this.gSeriesGroupEle = this.createGroup({ 'id': this._id + '_svg_SunBurstElementGroup' });
            for (var i = this.totallayerCount; i > 0; i--) {
                for (var j = 0; j < layerData.length; j++) {
                    if (i == layerData[j].layerNumber) {
                        this.drawRegion(layerData[j], j);
                    }
                }
            }
            this.sunburstDoubleClick = this.sunburstDoubleClick.bind(this);
            this.gSeriesGroupEle.addEventListener('dblclick', this.sunburstDoubleClick, true);
            return this.gSeriesGroupEle;
        };
        SunburstChart.prototype.calculateArcData = function (point, layerNumber, radius) {
            var visiblePoints, chartStartAngle, startAngle, endAngle, totalDegree, longArc, midAngle, direction, startX, startY, clockWise, x1, x2, y1, y2, centerx, centery;
            visiblePoints = this.model.points;
            chartStartAngle = -.5 * Math.PI;
            startAngle = point.startAngle + chartStartAngle;
            endAngle = point.endAngle + chartStartAngle - 0.000001;
            totalDegree = this.model.endAngle - this.model.startAngle;
            longArc = endAngle - startAngle < Math.PI ? 0 : 1;
            midAngle = (startAngle + endAngle) / 2;
            if (point.currentMidAngle == undefined) {
                point.currentMidAngle = (startAngle + endAngle) / 2;
            }
            clockWise = totalDegree > 0 ? 1 : 0;
            longArc = clockWise ? endAngle - startAngle < Math.PI ? 0 : 1 : endAngle - startAngle > -1 * Math.PI ? 0 : 1;
            startX = this.circleCenterX;
            startY = this.circleCenterY;
            x1 = startX + radius * Math.cos(startAngle);
            y1 = startY + radius * Math.sin(startAngle);
            x2 = startX + radius * Math.cos(endAngle);
            y2 = startY + radius * Math.sin(endAngle);
            var dStartX = startX + this.innerRadius[layerNumber - 1] * Math.cos(startAngle);
            var dStartY = startY + this.innerRadius[layerNumber - 1] * Math.sin(startAngle);
            var dEndX = startX + this.innerRadius[layerNumber - 1] * Math.cos(endAngle);
            var dEndY = startY + this.innerRadius[layerNumber - 1] * Math.sin(endAngle);
            var dClockWise = clockWise ? 0 : 1;
            if ((startAngle < 0) && Math.round(point.endAngle - point.startAngle) == 6) {
                dEndX = dEndX - 0.01;
                x2 = x2 - 0.01;
            }
            direction = "M" + " " + x1 + " " + y1 + " " + "A" + " " + radius + " " + radius + " " + "0" + " " + longArc + " " + clockWise + " " + x2 + " " + y2 + " " + "L" + " " + dEndX + " " + dEndY + " " + "A" + " " + this.innerRadius[layerNumber - 1] + " " + this.innerRadius[layerNumber - 1] + " " + "1" + " " + longArc + " " + dClockWise + " " + dStartX + " " + dStartY + " " + "z";
            return { Direction: direction, centerX: centerx, centerY: centery };
        };
        SunburstChart.prototype.findParent = function (visiblePoints) {
            var parentLayer = visiblePoints.layerNumber - 1;
            for (var i = 0; i < this._visiblePoints.length; i++) {
                if (parentLayer == this._visiblePoints[i]['layerNumber']) {
                    for (var j = 0; j < this._visiblePoints[i]['point'].length; j++) {
                        if (this._visiblePoints[i]['point'][j].x == visiblePoints.parentName
                            && this._visiblePoints[i]['point'][j].legendIndex == visiblePoints.legendIndex)
                            return this._visiblePoints[i]['point'][j];
                    }
                }
            }
        };
        SunburstChart.prototype.drawRegion = function (visiblePoints, layerIndex) {
            var result, options, sliceXY, point, id, region, sunburstRegion = [], sunburstData, radius, model = this.model, startAngle, opacity, fill = model["segmentBorder"].color, commonsegmentRendering, selected, selection, regionColor, pathElement;
            startAngle = this.model.startAngle * (Math.PI / 180);
            selection = model['selectionSettings'];
            fill = this.isNullOrUndefined(fill) ? (this.model.theme.toString().search("dark") != -1 ? "black" : "white") : fill;
            for (var j = 0; j < visiblePoints.point.length; j++) {
                selected = false;
                opacity = model['opacity'];
                if (isNaN(visiblePoints.point[j].startAngle))
                    continue;
                point = visiblePoints.point[j];
                regionColor = point['fill'];
                result = this.calculateArcData(point, visiblePoints.layerNumber, this.circularRadius[visiblePoints.layerNumber - 1]);
                sliceXY = result['Direction'].split(" ");
                radius = this.circularRadius[visiblePoints.layerNumber - 1];
                point['layerIndex'] = layerIndex;
                id = this._id + '_legendIndex' + point['legendIndex'] + '_layerNumber' + visiblePoints.layerNumber.toString() + '_layerIndex' + layerIndex.toString() + '_pointIndex' + j.toString();
                for (var i = 0; i < this.selectedgroupID.length; i++) {
                    if (id == this.selectedgroupID[i]) {
                        selected = true;
                    }
                }
                if (selection['type'] == sunburstSelectionType.opacity && !selected && this.selectedgroupID.length > 0)
                    opacity = selection['opacity'];
                point['id'] = id;
                options = {
                    'id': id,
                    'fill': point['fill'],
                    'stroke-width': model['segmentBorder'].width,
                    'stroke-dasharray': '',
                    'd': result['Direction'],
                    'stroke': fill,
                    'stroke-linecap': "butt",
                    'stroke-linejoin': "round",
                    'opacity': opacity,
                    'radius': radius,
                    'start': point['startAngle'] - 1.57,
                    'end': point['endAngle'] - 1.57,
                    'innerR': this.innerRadius[visiblePoints['layerNumber'] - 1],
                    'counterClockWise': false,
                    'x': this.circleCenterX,
                    'y': this.circleCenterY,
                    'visibility': this._enableAnimation ? 'hidden' : 'visible'
                };
                commonsegmentRendering = $.extend({}, this.common);
                commonsegmentRendering['data'] = { 'point': point, pathOptions: options };
                this._trigger("segmentRendering", commonsegmentRendering);
                pathElement = this.drawPath(options);
                if (selected && selection['type'] == sunburstSelectionType.color)
                    this.selectPointData(pathElement);
                this.gSeriesGroupEle.appendChild(pathElement);
                region = {
                    'x': point['x'], 'y': point['y'], 'fill': point['fill'], 'text': point['text'],
                    layerNumber: visiblePoints.layerNumber, layerIndex: layerIndex, parentName: visiblePoints.parentName,
                    pointIndex: j, startAngle: point['startAngle'] - startAngle, endAngle: point['endAngle'] - startAngle, startX: this.startX,
                    startY: this.startY, groupNumber: visiblePoints.groupNumber, id: id,
                    legendIndex: point['legendIndex']
                };
                sunburstRegion.push(region);
            }
            sunburstData = { Radius: this.circularRadius[visiblePoints.layerNumber - 1], centerX: this.circleCenterX, centerY: this.circleCenterY, innerRadius: this.innerRadius[visiblePoints['layerNumber'] - 1] };
            var finalRegion = { sunburstData: sunburstData, region: sunburstRegion };
            this.sunburstRegions.push(finalRegion);
        };
        SunburstChart.prototype.calculateRadius = function (width, height, layercount) {
            var radius = 0, radiusCollection = [], sunburstCoefficient, coefficient = this.model.radius, minimum = Math.min(width, height), availableRadius, holeCoefficient = this.model.innerRadius;
            this.innerRadius = [];
            sunburstCoefficient = coefficient > 1 ? 1 : coefficient < 0 ? 0 : coefficient;
            availableRadius = (minimum / 2) * sunburstCoefficient;
            if (holeCoefficient != 0)
                this.innerRadius.push(holeCoefficient * availableRadius);
            else
                this.innerRadius.push(0);
            for (var i = 0; i < layercount; i++) {
                if (i == 0) {
                    radius = ((availableRadius - this.innerRadius[0]) / layercount) + this.innerRadius[0];
                    radiusCollection[i] = radius;
                }
                else {
                    this.innerRadius.push(radius);
                    radius = (radius - this.innerRadius[i - 1]) + radius;
                    radiusCollection[i] = radius;
                }
            }
            return radiusCollection;
        };
        SunburstChart.prototype.calculateSliceAngle = function (visiblePoints) {
            var visiblePointLength = visiblePoints.length, sumofYValues = 0, totalDegree = 360, point, margin = this.model.margin, actualHeight, actualWidth, endAngle, itemCurrentXPos = 0, seriesIndex = 0, chartStarttingAngle, sunburstFactor, pointIndex, midAngle, legXSpace = 0, legYSpace = 0, borderWidth = this.model.border.width, legend = this.model.legend;
            for (var i = 0; i < visiblePointLength; i++) {
                visiblePoints[i].y = !this.isNullOrUndefined(visiblePoints[i].y) ? visiblePoints[i].y : (!this.isNullOrUndefined(visiblePoints[i].point) ? this.calculateSumofY(visiblePoints[i], sumofYValues) : 0);
                sumofYValues += visiblePoints[i].y;
            }
            if (this.model.startAngle > this.model.endAngle) {
                if (this.model.endAngle == 0)
                    this.model.endAngle = 360;
                else if (this.model.endAngle < 0) {
                    this.model.endAngle = 360 + this.model.endAngle;
                }
            }
            if (this.model.endAngle != null && this.model.startAngle < this.model.endAngle)
                totalDegree = this.model.endAngle - this.model.startAngle;
            else if (this.model.startAngle > this.model.endAngle && !this.isNullOrUndefined(this.model.endAngle)) {
                totalDegree = (360 - this.model.startAngle) + this.model.endAngle;
            }
            else
                totalDegree = 360;
            totalDegree = (totalDegree != 360 && totalDegree != -360) ? totalDegree % 360 : totalDegree;
            if (this.model.startAngle) {
                this.model.startAngle = this.model.startAngle % 360;
                this.model.endAngle = this.model.startAngle + totalDegree;
                itemCurrentXPos = this.model.startAngle ? (sumofYValues / 360) * this.model.startAngle : 0;
                itemCurrentXPos = itemCurrentXPos / sumofYValues;
            }
            else
                this.model.endAngle = totalDegree;
            if (legend['visible']) {
                if (legend['position'] == sunburstLegendPosition.right || legend['position'] == sunburstLegendPosition.left) {
                    legXSpace += this.elementSpacing + this.LegendBounds['Width'];
                    if (!this.isNullOrUndefined(legend['size']['width']))
                        legXSpace = parseFloat(legend['size']['width']);
                }
                else if (legend['position'] == sunburstLegendPosition.bottom || legend['position'] == sunburstLegendPosition.top) {
                    legYSpace += this.elementSpacing + this.LegendBounds['Height'];
                    if (!this.isNullOrUndefined(legend['size']['height']))
                        legYSpace = parseFloat(legend['size']['height']);
                }
            }
            actualHeight = this.height - (legYSpace + margin['top'] + margin['bottom'] + (borderWidth * 2) + this.yOffset);
            actualWidth = this.width - (legXSpace + margin['left'] + margin['right'] + (borderWidth * 2));
            this.circleCenterX = (actualWidth * 0.5) + margin['left'] + ((legend['visible'] && legend['position'] == sunburstLegendPosition.left) ? legXSpace : 0);
            this.circleCenterY = (actualHeight * 0.5) + margin['top'] + this.yOffset + ((legend['visible'] && legend['position'] == sunburstLegendPosition.top) ? legYSpace : 0);
            totalDegree = this.model.endAngle - this.model.startAngle;
            sunburstFactor = totalDegree / 180;
            for (pointIndex = 0; pointIndex < visiblePointLength; pointIndex++) {
                point = visiblePoints[pointIndex];
                if (pointIndex == 0)
                    point.startAngle = 2 * Math.PI * itemCurrentXPos;
                else
                    point.startAngle = endAngle;
                endAngle = point.endAngle = sunburstFactor * Math.PI * (point.y / sumofYValues) + point.startAngle;
                endAngle = point.endAngle = (isNaN(endAngle)) ? point.startAngle : endAngle;
                point.start = point.startAngle;
                point.end = point.endAngle;
                point.midAngle = (point.endAngle + point.startAngle) / 2;
                point.pointIndex = pointIndex;
                chartStarttingAngle = -.5 * Math.PI;
                point.radian = (point.midAngle / 2) % (2 * Math.PI);
                itemCurrentXPos += point.y / sumofYValues;
                midAngle = point.midAngle + chartStarttingAngle;
                this.startX[pointIndex] = this.circleCenterX;
                this.startY[pointIndex] = this.circleCenterY;
            }
        };
        SunburstChart.prototype.calculateTotaldegree = function (startAngle, endAngle) {
            var totalDegree = 0;
            if (startAngle < endAngle) {
                totalDegree = endAngle - startAngle;
            }
            else if (startAngle > endAngle) {
                totalDegree = 360 - startAngle + endAngle;
            }
            return totalDegree;
        };
        SunburstChart.prototype.calculateSumofY = function (visiblePoints, sumofYvalues) {
            var point = visiblePoints.point;
            for (var i = 0; i < point.length; i++) {
                if (!this.isNullOrUndefined(point[i]['y']))
                    sumofYvalues += point[i]['y'];
                else {
                    if (!this.isNullOrUndefined(point[i]['point'])) {
                        point[i]['y'] = this.calculateSumofY(point[i], sumofYvalues);
                        sumofYvalues += point[i]['y'];
                    }
                }
            }
            return sumofYvalues;
        };
        SunburstChart.prototype.calculateChildAngle = function (visiblePoints) {
            var parentNode, endAngle, startAngle, totalAngle, sumofY = 0, parentY, ratio;
            parentNode = this.findParent(visiblePoints);
            for (var j = 0; j < visiblePoints.point.length; j++) {
                sumofY = sumofY + visiblePoints.point[j].y;
            }
            parentY = parentNode.y;
            startAngle = endAngle = parentNode.startAngle;
            totalAngle = parentNode.endAngle - parentNode.startAngle;
            for (var i = 0; i < visiblePoints.point.length; i++) {
                if (i == 0) {
                    visiblePoints.point[i].startAngle = startAngle;
                    visiblePoints.point[i].start = startAngle;
                    endAngle = ((visiblePoints.point[i].y / sumofY) * totalAngle) + startAngle;
                    visiblePoints.point[i].end = visiblePoints.point[i].endAngle = endAngle;
                    visiblePoints.point[i].midAngle = (visiblePoints.point[i].startAngle + visiblePoints.point[i].endAngle) / 2;
                }
                else {
                    visiblePoints.point[i].startAngle = endAngle;
                    visiblePoints.point[i].start = endAngle;
                    endAngle = ((visiblePoints.point[i].y / sumofY) * totalAngle) + endAngle;
                    visiblePoints.point[i].end = visiblePoints.point[i].endAngle = endAngle;
                    visiblePoints.point[i].midAngle = (visiblePoints.point[i].startAngle + visiblePoints.point[i].endAngle) / 2;
                }
            }
        };
        SunburstChart.prototype.calculateSize = function (size, title) {
            var actualWidth, actualHeight, titleText, yOffset, realwidth, borderWidth = this.model.border.width, spaceValue, x, rightSpace, width, y, margin = this.model.margin, elementSpacing = this.elementSpacing;
            spaceValue = this._getLegendSpace(this.model.legend);
            x = spaceValue['leftLegendWidth'] + borderWidth + margin['left'];
            rightSpace = spaceValue['rightLegendWidth'] + margin['right'] + margin['left'] + (2 * borderWidth);
            width = size['width'];
            actualWidth = width - (x + rightSpace);
            y = margin['top'] + elementSpacing + spaceValue['modelTitleHeight'] + (spaceValue['modelsubTitleHeight']) + spaceValue['topLegendHeight'] + borderWidth;
            this.yOffset = (title['text'] && title['visible']) ? (this.titleLocation['size'].height + elementSpacing) + (title['subtitle'].text == '' ? 0 : (title['subtitle'].text && title['subtitle'].visible) ? (this.subTitleLocatation['size'].height) : 0) : 0;
            actualHeight = size['height'] - (spaceValue['modelTitleHeight'] + elementSpacing + margin['top'] + spaceValue['modelsubTitleHeight'] + spaceValue['topLegendHeight'] + spaceValue['bottomLegendHeight']);
            return { x: x, y: y, actualWidth: actualWidth, actualHeight: actualHeight };
        };
        SunburstChart.prototype._getLegendSpace = function (legend) {
            var bounds = this.LegendActualBounds, itemPadding = 10, elementSpacing = this.elementSpacing, legendBorder = this.model.legend.border.width, leftLegendWidth = 0, rightLegendWidth = 0, topLegendHeight = 0, bottomLegendHeight = 0, space, position = this.model.legend.position, ltheight = 0, titleHeight = 0, subtitleHeight = 0, modelTitleHeight, modelsubTitleHeight, maxHeight, maxWidth, title = this.model.title;
            elementSpacing = this.legendClicked ? 0 : elementSpacing;
            if (legend['visible']) {
                space = (parseFloat(bounds['Width']) + (itemPadding / 2) + elementSpacing + (2 * legendBorder));
                maxWidth = this.width * (20 / 100);
                leftLegendWidth = position == sunburstLegendPosition.left ? space : 0;
                if (leftLegendWidth > maxWidth && this.isNullOrUndefined(legend['size']['width'])) {
                    leftLegendWidth = maxWidth;
                }
                rightLegendWidth = position == sunburstLegendPosition.right ? space : 0;
                if (rightLegendWidth > maxWidth && this.isNullOrUndefined(legend['size']['width'])) {
                    rightLegendWidth = maxWidth;
                }
                maxHeight = this.height * (20 / 100);
                ltheight = legend['title'].visible ? this.measureText(legend['title'].text, legend['title'].font)['height'] : 0;
                topLegendHeight = position == sunburstLegendPosition.top ? elementSpacing + parseFloat(bounds['Height']) + ltheight : 0;
                bottomLegendHeight = position == sunburstLegendPosition.bottom ? elementSpacing + parseFloat(bounds['Height']) + ltheight : 0;
                if (topLegendHeight > maxHeight && this.isNullOrUndefined(legend['size']['height'])) {
                    topLegendHeight = maxHeight;
                }
                else if (bottomLegendHeight > maxHeight && this.isNullOrUndefined(legend['size']['height'])) {
                    bottomLegendHeight = maxHeight;
                }
                this.LegendActualBounds['Height'] = (topLegendHeight == 0 && bottomLegendHeight != 0) ? bottomLegendHeight : (topLegendHeight != 0) ? topLegendHeight : this.LegendActualBounds['Height'];
                this.LegendActualBounds['Width'] = (rightLegendWidth == 0 && leftLegendWidth != 0) ? leftLegendWidth : (rightLegendWidth != 0) ? rightLegendWidth : this.LegendActualBounds['Width'];
            }
            titleHeight = this.measureText(title['text'], title['font'])['height'];
            subtitleHeight = this.measureText(title['subtitle'].text, title['subtitle'].font)['height'];
            modelTitleHeight = (title['text'] == "" || !title['visible']) ? 0 : (titleHeight + elementSpacing);
            modelsubTitleHeight = (title['subtitle'].text == "" || !title['subtitle'].visible) ? 0 : (subtitleHeight);
            return {
                leftLegendWidth: leftLegendWidth, rightLegendWidth: rightLegendWidth, topLegendHeight: topLegendHeight, bottomLegendHeight: bottomLegendHeight, modelTitleHeight: modelTitleHeight, modelsubTitleHeight: modelsubTitleHeight
            };
        };
        SunburstChart.prototype.calculateLegendBounds = function () {
            this.legendCollection = [];
            this.legendRegion = [];
            this.legendTextRegion = [];
            this._legendMaxHeight = 0;
            this._legendMaxWidth = 0;
            var legend = this.model.legend, padding = 10, legendSizeHeight = legend['size']['height'], legendSizeWidth = legend['size']['width'], itemPadding = legend['itemPadding'] > 0 ? legend['itemPadding'] : 0, position = legend['position'].toLowerCase(), width = 0, height = 0, svgHeight = this.height, svgWidth = this.width, legendItemWidth = 0, legendItemHeight = 0, legendWidth = 0, legendHeight = 0, legnedHeightIncr = 1, legendviewerHeight = 0, legendviewerWidth = 0, tempSeries = {}, legendSeries = [], rowCount = this.model.legend.rowCount, columnCount = this.model.legend.columnCount, elementSpacing = this.elementSpacing, titleSize = this.measureText(legend['title']['text'], legend['title']['font']), legendBorder = legend['border']['width'], borderSize = this.model.border.width, svgObjectHeight = svgHeight - ((elementSpacing * 4) + (borderSize * 2) + (legendBorder * 2)), svgObjectWidth = svgWidth - ((elementSpacing * 4) + (borderSize * 2) + (legendBorder * 2)), visiblePoints = [], length, legendColor, legendName, legendSeriesLength, currentLegend, shapeWidth, legendsize, colorGradName, point, bounds, legendHeightTemp, legendBounds;
            if (legend['visible']) {
                visiblePoints = this.layerData[0]['point'];
                length = visiblePoints.length;
                for (var i = 0; i < length; i++) {
                    point = visiblePoints[i];
                    legendColor = visiblePoints[i]['fill'];
                    legendName = visiblePoints[i]['x'];
                    tempSeries = {
                        'sunburstLegendShape': legend['shape'],
                        'Text': legendName,
                        'displayText': legendName,
                        'font': legend['font'],
                        'groupNumber': visiblePoints[i]['groupNumber'],
                        'layerIndex': visiblePoints[i]['layerIndex'],
                        'layerNumber': visiblePoints[i]['layerNumber'],
                        'Shape': 'None',
                        'visibility': true,
                        'fill': visiblePoints[i]['fill'],
                        'points': visiblePoints[i]['point'],
                        'x': visiblePoints[i]['x'],
                        'y': visiblePoints[i]['y']
                    };
                    legendSeries.push(tempSeries);
                }
                legendSeriesLength = legendSeries.length;
                for (var j = 0; j < legendSeriesLength; j++) {
                    currentLegend = legendSeries[j];
                    shapeWidth = legend['itemStyle']['width'];
                    legendsize = this._getLegendSize(currentLegend);
                    legendItemWidth = Math.max(this._legendMaxWidth > 0 ? (this._legendMaxWidth + itemPadding + shapeWidth) : legendsize['Width'], legendItemWidth);
                    legendItemHeight = Math.max(legendsize['Height'], legendItemHeight);
                }
                legendHeight = legendItemHeight + elementSpacing * 2;
                legendWidth = legendItemWidth;
                if (rowCount || columnCount) {
                    legendBounds = this.legendItemBounds(legendSeriesLength, legendItemWidth + itemPadding, legendItemHeight + itemPadding);
                    legendWidth = legendBounds['LegendWidth'];
                    legendHeight = legendBounds['LegendHeight'];
                    if (position === 'top' || position === 'bottom' || position === 'custom')
                        legendHeight = legendHeight - itemPadding + elementSpacing;
                    else
                        legendWidth = legendWidth - itemPadding;
                }
                for (var k_4 = 0; k_4 < legendSeriesLength; k_4++) {
                    currentLegend = legendSeries[k_4];
                    legendsize = this._getLegendSize(currentLegend);
                    bounds = (rowCount || columnCount) ? { 'Width': legendItemWidth, 'Height': legendItemHeight } : legendsize;
                    bounds['_Width'] = legendsize['Width'];
                    legendSeries[k_4]['Bounds'] = bounds;
                    this.legendCollection.push(currentLegend);
                }
                for (var k = 0; k < legendSeriesLength; k++) {
                    currentLegend = legendSeries[k];
                    legendsize = this._getLegendSize(currentLegend);
                    if (!(rowCount) && !(columnCount)) {
                        if ((position == 'top' || position == 'bottom' || position == 'custom')) {
                            width += legendsize['Width'] + itemPadding;
                            if (width > svgObjectWidth && k != 0) {
                                width -= legendsize['Width'] + itemPadding;
                                legendWidth = Math.max(legendWidth, width);
                                width = legendsize['Width'] + itemPadding;
                                legnedHeightIncr++;
                                legendHeight += legendItemHeight + itemPadding;
                            }
                            else
                                legendWidth = Math.max(legendWidth, width);
                            height = Math.max(height, legendItemHeight);
                        }
                        else {
                            height += legendsize['Height'] + itemPadding;
                            if (height > svgObjectHeight) {
                                height -= legendsize['Height'] + itemPadding;
                                legendHeight = Math.max(legendHeight, height);
                                height = legendsize['Height'] + itemPadding;
                                legendWidth += legendItemWidth + itemPadding;
                            }
                            else
                                legendHeight = Math.max(legendHeight, height);
                            width = Math.max(width, legendItemWidth);
                        }
                    }
                    bounds = (rowCount || columnCount) ? { Width: legendItemWidth, Height: legendItemHeight } : legendsize;
                    bounds['_Width'] = legendsize['Width'];
                    legendSeries[k]['Bounds'] = bounds;
                }
                if (position === 'top' || position === 'bottom' || position === 'custom') {
                    legendWidth = titleSize['width'] > legendWidth - itemPadding ? (titleSize['width'] + padding * 2 + itemPadding) : legendWidth + padding * 2;
                    width += padding;
                    height += padding * 2;
                    this.LegendBounds = { 'Width': Math.max(legendWidth, width) - itemPadding, 'Height': Math.max(legendHeight, height), 'Rows': legnedHeightIncr };
                }
                else {
                    legendWidth = titleSize['width'] > legendWidth - itemPadding ? (titleSize['width'] + padding * 2 + itemPadding) : legendWidth + padding * 2;
                    width += padding;
                    height += padding * 2;
                    this.LegendBounds = { 'Width': Math.max(legendWidth, width), 'Height': Math.max(legendHeight, height) + padding - itemPadding, 'Columns': legnedHeightIncr };
                }
            }
            else {
                this.LegendBounds = { Width: 0, Height: 0 };
            }
            this.LegendActualBounds = this.LegendBounds;
            if (legendSizeWidth != null)
                this.LegendActualBounds['Width'] = legendSizeWidth;
            if (legendSizeHeight != null)
                this.LegendActualBounds['Height'] = legendSizeHeight;
        };
        SunburstChart.prototype._getLegendSize = function (series) {
            var legend = this.model.legend, symbolSize = legend['itemStyle'], textsize = this.measureText(series['Text'], series['font']), padding = 10, width = symbolSize['width'] + padding + textsize['width'], height = Math.max(symbolSize['height'], textsize['height']);
            return { 'Width': width, 'Height': height };
        };
        SunburstChart.prototype.legendItemBounds = function (itemCount, legendItemWidth, legendItemHeight) {
            var legend = this.model.legend, legVal, position = legend['position'], itemPadding = legend['itemPadding'], legnedHeightIncr, column, legendWidth = 0, legendHeight = 0;
            if (this.isNullOrUndefined(legend['columnCount']) && legend['rowCount']) {
                legnedHeightIncr = legend['rowCount'];
                column = Math.ceil(itemCount / legnedHeightIncr);
                legendWidth = legendItemWidth * column;
                legendHeight = legendItemHeight * legnedHeightIncr;
            }
            else if (this.isNullOrUndefined(legend['rowCount']) && legend['columnCount']) {
                legnedHeightIncr = Math.ceil(itemCount / legend['columnCount']);
                legVal = legend['columnCount'];
                legendWidth = legendItemWidth * legVal;
                legendHeight = legendItemHeight * legnedHeightIncr;
            }
            else if ((legend['rowCount']) && legend['columnCount']) {
                if (legend['columnCount'] < legend['rowCount']) {
                    legnedHeightIncr = legend['rowCount'];
                    column = Math.ceil(itemCount / legnedHeightIncr);
                    legendWidth = legendItemWidth * column;
                    legendHeight = legendItemHeight * legnedHeightIncr;
                }
                else if (legend['columnCount'] > legend['rowCount']) {
                    if (position === 'top' || position === 'bottom' || position === 'custom') {
                        legnedHeightIncr = Math.ceil(itemCount / legend['columnCount']);
                        legVal = legend['columnCount'];
                        legendWidth = legendItemWidth * legVal;
                        legendHeight = legendItemHeight * legnedHeightIncr;
                    }
                    else {
                        legnedHeightIncr = Math.ceil(itemCount / legend['columnCount']);
                        column = Math.ceil(itemCount / legnedHeightIncr);
                        legendWidth = legendItemWidth * column;
                        legendHeight = legendItemHeight * legnedHeightIncr;
                    }
                }
                else {
                    if (position === 'top' || position === 'bottom') {
                        legnedHeightIncr = Math.ceil(itemCount / legend['columnCount']);
                        legVal = Math.ceil(itemCount / legend['rowCount']);
                        legendWidth = legendItemWidth * legend['columnCount'];
                        legendHeight = legendItemHeight * legVal;
                    }
                    else {
                        legnedHeightIncr = legend['rowCount'];
                        column = Math.ceil(itemCount / legnedHeightIncr);
                        legendWidth = legendItemWidth * column;
                        legendHeight = legendItemHeight * legnedHeightIncr;
                    }
                }
            }
            legendHeight += this.elementSpacing;
            return { LegendWidth: legendWidth, LegendHeight: legendHeight };
        };
        SunburstChart.prototype.drawTitle = function (titleOptions, size) {
            var textSize, x, y, options, titleEle, commonTitleEventArgs, elementSpacing = this.elementSpacing, fill = titleOptions['font'].color;
            fill = this.isNullOrUndefined(fill) ? (this.model.theme.toString().indexOf("dark") != -1 ? "white" : "black") : fill;
            textSize = this.measureText(titleOptions['text'], titleOptions['font']);
            x = titleOptions['textAlignment'] == sunburstAlignment.center ? (size['width'] / 2 - textSize['width'] / 2) : (titleOptions['textAlignment'] == sunburstAlignment.near ? (2 * elementSpacing) : (size['width'] - textSize['width'] - (2 * elementSpacing)));
            y = textSize['height'] / 2 + elementSpacing;
            commonTitleEventArgs = $.extend({}, this.common);
            commonTitleEventArgs.data = { TitleText: titleOptions['text'], location: { X: x, Y: y }, size: textSize };
            this._trigger("titleRendering", commonTitleEventArgs);
            options = {
                'id': this._id + "SunburstTitle",
                'x': commonTitleEventArgs.data.location.X,
                'y': commonTitleEventArgs.data.location.Y,
                'fill': fill,
                'font-size': titleOptions['font'].size,
                'font-family': titleOptions['font'].fontFamily,
                'font-style': titleOptions['font'].fontStyle,
                'font-weight': titleOptions['font'].fontWeight,
                'opacity': titleOptions['font'].opacity,
                'text-anchor': 'start'
            };
            this.gTitleGroupElement = this.createGroup({ id: this._id + "SunburstTitle" });
            titleEle = this.createText(options, commonTitleEventArgs.data.TitleText);
            this.gTitleGroupElement.appendChild(titleEle);
            this.titleLocation = { size: textSize, x: commonTitleEventArgs.data.location.X, y: commonTitleEventArgs.data.location.Y };
            if (titleOptions['subtitle'].text != "" && titleOptions['subtitle'].visible) {
                this.drawSubtitle(titleOptions, size, textSize, this.titleLocation);
            }
            return this.gTitleGroupElement;
        };
        SunburstChart.prototype.drawSubtitle = function (titleOptions, size, titleSize, titleLocation) {
            var subtitleSize, x, y, options, subtitleEle, textAnchor, fill = titleOptions['subtitle'].font.color;
            fill = this.isNullOrUndefined(fill) ? (this.model.theme.toString().indexOf("dark") != -1 ? "white" : "black") : fill;
            subtitleSize = this.measureText(titleOptions['subtitle'].text, titleOptions['subtitle'].font);
            x = titleOptions['subtitle'].textAlignment == sunburstAlignment.far ? titleLocation['x'] + titleLocation['size'].width : (titleOptions['subtitle'].textAlignment == sunburstAlignment.near) ? titleLocation['x'] : (titleLocation['x'] + (titleSize['width'] / 2));
            y = titleLocation['size'].height + (2 * this.elementSpacing);
            textAnchor = titleOptions['subtitle'].textAlignment == sunburstAlignment.far ? "end" : (titleOptions['subtitle'].textAlignment == sunburstAlignment.near) ? "start" : "middle";
            options = {
                'id': this._id + "SunburstSunbtitle",
                'x': x,
                'y': y,
                'fill': fill,
                'font-size': titleOptions['subtitle'].font.size,
                'font-family': titleOptions['subtitle'].font.fontFamily,
                'font-style': titleOptions['subtitle'].font.fontStyle,
                'font-weight': titleOptions['subtitle'].font.fontWeight,
                'opacity': titleOptions['subtitle'].font.opacity,
                'text-anchor': textAnchor,
            };
            this.subTitleLocatation = { size: subtitleSize, x: x, y: y };
            subtitleEle = this.createText(options, titleOptions['subtitle'].text);
            this.gTitleGroupElement.appendChild(subtitleEle);
        };
        SunburstChart.prototype.measureText = function (text1, fontOptions) {
            var element = document.querySelectorAll("#measureTex"), textObj;
            if (element.length == 0) {
                textObj = document.createElement('text');
                textObj.setAttribute('id', 'measureTex');
                document.body.appendChild(textObj);
            }
            else {
                textObj = element[0];
                textObj.style.display = 'block';
            }
            textObj.innerHTML = text1;
            textObj.style.fontSize = fontOptions['size'];
            textObj.style.fontFamily = fontOptions['fontFamily'];
            textObj.style.fontWeight = fontOptions['fontWeight'];
            textObj.style.backgroundColor = 'white';
            textObj.style.position = 'absolute';
            textObj.style.visibility = 'hidden';
            textObj.style.whiteSpace = 'nowrap';
            return { width: textObj.offsetWidth, height: textObj.offsetHeight };
        };
        SunburstChart.prototype.drawContainerRect = function () {
            var rect, rectOptions;
            rectOptions = {
                'id': this._id + "_svg" + '_svgRect',
                'x': 0,
                'y': 0,
                'width': this.width,
                'height': this.height,
                'fill': this.model.background || "transparent",
                'stroke': this.model.border.color,
                'stroke-width': this.model.border.width,
                'opacity': '0.5'
            };
            rect = this.drawRect(rectOptions);
            return rect;
        };
        SunburstChart.prototype.processData = function (visiblePoints) {
            var visiblePointsLength = visiblePoints.length, point;
            this.findBaseData(visiblePoints);
            for (var i = 0; i < visiblePoints.length; i++) {
                point = visiblePoints[i];
                point['legendIndex'] = i;
                if (visiblePoints[i].point) {
                    this.findLayerData(visiblePoints[i].point, visiblePoints[i].x, 1, visiblePoints[i].groupNumber, i);
                }
            }
        };
        SunburstChart.prototype.findBaseData = function (visiblePoins) {
            var layerpoints = [];
            this.layerData = [];
            for (var i = 0; i < visiblePoins.length; i++) {
                layerpoints.push(visiblePoins[i]);
                layerpoints[i]['groupNumber'] = i + 1;
                layerpoints[i]['layerIndex'] = 0;
                layerpoints[i]['layerNumber'] = 1;
                layerpoints[i]['legendIndex'] = i;
                visiblePoins[i].groupNumber = i + 1;
            }
            this.layerData.push({ point: layerpoints, layerNumber: 1, legendIndex: 0 });
            this.totallayerCount = 1;
        };
        SunburstChart.prototype.findLayerData = function (point, parentName, layerNumber, groupNumber, legendIndex) {
            var points = [];
            for (var j = 0; j < point.length; j++) {
                if (point[j].point) {
                    point[j].legendIndex = legendIndex;
                    this.findLayerData(point[j].point, point[j].x, layerNumber + 1, groupNumber, legendIndex);
                    point[j].layerIndex = this.layerData.length;
                    points.push(point[j]);
                }
                else {
                    point[j].legendIndex = legendIndex;
                    point[j].layerIndex = this.layerData.length;
                    points.push(point[j]);
                }
            }
            point.layerData = this.layerData.length;
            this.layerData.push({ point: points, parentName: parentName, layerNumber: layerNumber + 1, groupNumber: groupNumber, layerIndex: this.layerData.length, legendIndex: legendIndex });
            if ((layerNumber + 1) > this.totallayerCount) {
                this.totallayerCount = layerNumber + 1;
            }
        };
        SunburstChart.prototype.setColors = function (points) {
            var defaultColors = ["#3082bd", "#e55725", "#9cbb59", "#F6851F", "#8165a3", "#4fa045", "#d456a0", "#0dbdef", "#e2a325", "#03a09c"], index, palette = this.model.palette, fill;
            for (var i = 0; i < points.length; i++) {
                if (this.isNullOrUndefined(points[i]['fill']) || this._sunburstRedraw) {
                    if (!this.isNullOrUndefined(palette) && palette.length == 0)
                        points[i]['fill'] = "black";
                    else {
                        points[i]['fill'] = (this.isNullOrUndefined(palette)) ? defaultColors[i % defaultColors.length] : palette[i % palette.length];
                        if (points[i]['fill'].trim().length == 0)
                            points[i]['fill'] = "black";
                    }
                    if (!this.isNullOrUndefined(points[i]['point'])) {
                        this.setchildColors(points[i]['point'], points[i]['fill']);
                    }
                }
                else {
                    if (!this.isNullOrUndefined(points[i]['point'])) {
                        if (points[i]['fill'].trim().length == 0)
                            points[i]['fill'] = "black";
                        this.setchildColors(points[i]['point'], points[i]['fill']);
                    }
                }
            }
        };
        SunburstChart.prototype.setchildColors = function (point, fill) {
            fill = fill.trim().length == 0 ? "black" : fill;
            for (var i = 0; i < point.length; i++) {
                if (this.isNullOrUndefined(point[i]['fill']) || this._sunburstRedraw) {
                    point[i]['fill'] = fill;
                    if (point[i]['fill'].trim().length == 0)
                        point[i]['fill'] = "black";
                    if (!this.isNullOrUndefined(point[i]['point'])) {
                        this.setchildColors(point[i]['point'], fill);
                    }
                }
                else {
                    if (!this.isNullOrUndefined(point[i]['point'])) {
                        this.setchildColors(point[i]['point'], fill);
                    }
                }
            }
        };
        SunburstChart.prototype.processDataSource = function (dataSource) {
            var levelscount = this.model.levels.length, checkPoints = [], i = 0, data, memberPath, xValue, check;
            this.model.points = [];
            this.parentNames = [];
            this.levelNames = [];
            this.childProcess = undefined;
            for (var j = 0; j < dataSource.length; j++) {
                data = dataSource[j];
                memberPath = this.model.levels[i]['groupMemberPath'];
                xValue = data[memberPath];
                check = $.inArray(xValue, checkPoints);
                if (check < 0) {
                    this.model.points.push({ x: xValue, y: dataSource[j][this.model.valueMemberPath], layer: i + 1, parentName: xValue, parentChildName: xValue });
                    checkPoints.push(xValue);
                }
                else {
                    for (var k = 0; k < this.model.points.length; k++)
                        if (this.model.points[k].x == xValue)
                            this.model.points[k].y += dataSource[j][this.model.valueMemberPath];
                }
            }
            if (this.model.levels.length > 1)
                this.createOtherLayerPoints(dataSource, 1);
        };
        SunburstChart.prototype.createOtherLayerPoints = function (dataSource, startLevel) {
            var data = dataSource, currentMemberPath = this.model.levels[startLevel]["groupMemberPath"], yValue, levels = this.model.levels, points = this.model.points;
            for (var j = 0; j < data.length; j++) {
                var parent_level_Name = "", parentName = "", count = 0, parent_1 = void 0, member = void 0, check = void 0, member1 = void 0;
                for (var start = 0; start <= startLevel; start++) {
                    member = levels[start]["groupMemberPath"];
                    parentName = data[j][member];
                    if (!this.isNullOrUndefined(parentName))
                        parent_level_Name += parentName + "_";
                    if ((count) == startLevel)
                        parent_level_Name = parent_level_Name.substring(0, parent_level_Name.length - 1);
                    count++;
                }
                check = $.inArray(parent_level_Name, this.levelNames);
                member1 = levels[startLevel - 1]["groupMemberPath"];
                parent_1 = data[j][member1];
                if (check < 0 && !this.isNullOrUndefined((data[j][currentMemberPath]))) {
                    this.levelNames.push(parent_level_Name);
                    yValue = data[j][this.model.valueMemberPath];
                    points.push({ x: data[j][currentMemberPath], 'y': yValue, layer: startLevel + 1, parentChildName: parent_level_Name, parentName: parent_1 });
                }
                else if (!this.isNullOrUndefined((data[j][currentMemberPath]))) {
                    for (var i = 0; i < points.length; i++) {
                        if (points[i]['parentName'] == parent_1 && parent_level_Name == points[i]['parentChildName'])
                            points[i]['y'] += yValue;
                    }
                }
            }
            if (startLevel < (levels.length - 1))
                this.createOtherLayerPoints(data, startLevel + 1);
            else {
                this._points = points;
                this.model.points = [];
                this.alignDataSourcePoints(data, 1);
            }
        };
        SunburstChart.prototype.alignDataSourcePoints = function (dataSource, startLevel) {
            var levels = this.model.levels;
            for (var i = startLevel; i < levels.length; i++) {
                for (var j = 0; j < this._points.length; j++) {
                    if (i == this._points[j]["layer"]) {
                        this.parentNames.push(this._points[j]["parentName"] + "_layer_" + this._points[j]["layer"]);
                    }
                    else {
                        i = levels.length;
                        break;
                    }
                }
            }
            this.findParentElements(this.model.points);
        };
        SunburstChart.prototype.findParentElements = function (points) {
            for (var i = 0; i < this.parentNames.length; i++) {
                var name = this.parentNames[i];
                for (var j = 0; j < this._points.length; j++) {
                    if (name == this._points[j]["x"] + "_layer_" + this._points[j]["layer"]) {
                        points.push(this._points[j]);
                    }
                }
            }
            if (this.isNullOrUndefined(this.childProcess) || this.childProcess)
                this.findChildElements(points, 0);
        };
        SunburstChart.prototype.findChildElements = function (points, pointCount) {
            var point, currentPoints;
            this.visiblePoints = [];
            if (pointCount <= points.length - 1) {
                this.childProcess = true;
                this.visiblePoints.push(points[pointCount]);
                this.findOtherChildElements(this.visiblePoints, this.parentNames[pointCount], 2, 0, point, currentPoints, pointCount);
            }
            else
                this.childProcess = false;
        };
        SunburstChart.prototype.findOtherChildElements = function (points, parentName, startLayer, count, previousPoints, currentPoints, pointCount) {
            var parenPoints = points;
            var childPoint;
            var parentActualName = parentName.substring(0, parentName.indexOf("_layer_"));
            for (var i = 0; i < parenPoints.length; i++) {
                parenPoints[i]["point"] = [];
                for (var j = 0; j < this._points.length; j++) {
                    if (startLayer == this._points[j]["layer"] && parenPoints[i]["x"] == this._points[j]["parentName"] && this._points[j]["parentChildName"].indexOf(parentActualName) >= 0) {
                        parenPoints[i]["point"].push(this._points[j]);
                    }
                }
                if (this.isNullOrUndefined(previousPoints)) {
                    previousPoints = parenPoints;
                    currentPoints = [];
                    currentPoints.push({ layer: startLayer });
                    currentPoints[0]["point"] = [];
                }
                else if (count >= previousPoints[i]["point"].length) {
                    if (count >= previousPoints[i]["point"].length && startLayer >= this.model.levels.length) {
                        this.findChildElements(this.model.points, (pointCount + 1));
                    }
                    count = 0;
                    for (var m = 0; m < parenPoints[i]["point"].length; m++) {
                        currentPoints[0].point.push(parenPoints[i]["point"][m]);
                    }
                    previousPoints = currentPoints;
                }
                else {
                    for (var m = 0; m < parenPoints[i]["point"].length; m++) {
                        currentPoints[0]["point"].push(parenPoints[i]["point"][m]);
                    }
                }
                for (var p = count; p < previousPoints[i]["point"].length; p++) {
                    if (count < previousPoints[i]["point"].length) {
                        startLayer = (count == 0) ? (startLayer + 1) : startLayer;
                        count++;
                        var totalPoint = previousPoints[i]["point"][p];
                        childPoint = [];
                        childPoint.push(totalPoint);
                    }
                    if (this.childProcess)
                        this.findOtherChildElements(childPoint, parentName, startLayer, count, previousPoints, currentPoints, pointCount);
                }
            }
        };
        SunburstChart.prototype.setSvgsize = function (size, id) {
            var containerWidth, containerHeight, height, width, chartWidth, chartHeight;
            containerWidth = document.getElementById(id).clientWidth;
            containerHeight = document.getElementById(id).clientHeight;
            height = 450;
            width = (ej.isTouchDevice()) ? 250 : 600;
            if (size['width'] != "" && (!this.isResize || !this.model.isResponsive)) {
                chartWidth = size['width'];
                if (typeof (chartWidth) == "string" && chartWidth.indexOf("%") != -1)
                    width = (containerWidth / 100) * parseInt(chartWidth);
                else
                    width = parseFloat(size['width']);
            }
            else if (containerWidth > 0)
                width = containerWidth;
            this.width = width;
            this.container.setAttribute('width', width.toString());
            if (size['height'] != "") {
                chartHeight = size['height'];
                if (typeof (chartHeight) == "string" && chartHeight.indexOf("%") != -1)
                    height = (containerHeight / 100) * parseInt(chartHeight);
                else
                    height = parseFloat(size['height']);
            }
            else if (containerHeight > 0)
                height = containerHeight;
            this.height = height;
            this.container.setAttribute('height', height.toString());
        };
        SunburstChart.prototype.isNullOrUndefined = function (value) {
            return value === undefined || value === null;
        };
        SunburstChart.prototype.createSvg = function (option) {
            var svg = this.createElement("svg");
            this.setAttributes(option, svg);
            return svg;
        };
        SunburstChart.prototype.drawPolygon = function (Options) {
            var polygon = document.getElementById(Options['id']);
            if (this.isNullOrUndefined(polygon))
                polygon = this.createElement('polygon');
            this.setAttributes(Options, polygon);
            return polygon;
        };
        SunburstChart.prototype.createText = function (options, label) {
            var text = this.createElement("text");
            this.setAttributes(options, text);
            if (label)
                text.textContent = label;
            return text;
        };
        SunburstChart.prototype.createGroup = function (options) {
            var group = this.createElement("g");
            this.setAttributes(options, group);
            return group;
        };
        SunburstChart.prototype.drawRect = function (Options) {
            var rectangle = document.getElementById(Options._id);
            if (rectangle === null) {
                rectangle = this.createElement('rect');
            }
            this.setAttributes(Options, rectangle);
            return rectangle;
        };
        SunburstChart.prototype.drawCircle = function (Options) {
            var circle = document.getElementById(Options['id']);
            if (this.isNullOrUndefined(circle))
                circle = this.createElement('circle');
            this.setAttributes(Options, circle);
            return circle;
        };
        SunburstChart.prototype.createElement = function (elementName) {
            return document.createElementNS("http://www.w3.org/2000/svg", elementName);
        };
        SunburstChart.prototype.getXcordinate = function (x, radius, angle) {
            return (x + radius * (Math.cos(angle)));
        };
        SunburstChart.prototype.getYcordinate = function (y, radius, angle) {
            return (y + radius * (Math.sin(angle)));
        };
        SunburstChart.prototype.setAttributes = function (Options, element) {
            var properties, values;
            properties = Object.keys(Options);
            values = properties.map(function (property) { return Options[property]; });
            for (var i = 0, len = properties.length; i < len; i++) {
                element.setAttribute(properties[i], values[i]);
            }
        };
        return SunburstChart;
    }(ej.WidgetBase));
    ejSunburstChart.SunburstChart = SunburstChart;
    ej.widget("ejSunburstChart", "ej.SunburstChart", new SunburstChart());
    ejSunburstChart.compareExtend = function (temp, src, def) {
        if (typeof def === 'object' && def !== null) {
            var defProp = Object.keys(def), len = defProp.length, currPro;
            for (var i = 0; i < len; i++) {
                currPro = defProp[i];
                if (src.hasOwnProperty(currPro) && src[currPro] != null) {
                    if (Array.isArray(src[currPro]) || typeof src[currPro] === 'object' && src[currPro] !== null) {
                        ejSunburstChart.compareExtend({}, src[currPro], def[currPro]);
                    }
                }
                else {
                    src[currPro] = def[currPro];
                }
            }
        }
        return src;
    };
    ejSunburstChart.deepExtend = function (out) {
        out = out || {};
        for (var i = 1; i < arguments.length; i++) {
            var obj = arguments[i];
            if (!obj)
                continue;
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    if (typeof obj[key] === 'object')
                        out[key] = ejSunburstChart.deepExtend(out[key], obj[key]);
                    else
                        out[key] = obj[key];
                }
            }
        }
        return out;
    };
})(ejSunburstChart || (ejSunburstChart = {}));
;
(function($, ej, undefined){
    ej.olap =  ej.olap || {};
    ej.olap.base = {
        _initProperties: function () {
            this._columnHeaders = [],
            this._rowHeaders = [],
            this._valueCells = [],
            this.pivotEngine = [],
            this.olapCtrlObj = null,
            this._cBIndx = null,
            this._rBIndx = null,
            this._OlapDataSource,
            this._measureDt = {},
            this._cTotIndexInfo = null,
            this._rTotIndexInfo = null;
            this._kpi = null;
            this._rowCount = 0;
            this._colCount = 0;
            this._isPaging = false;
            this._indexRCell = 0;
            this._indexCCell = 0;
        },
        _initControlProperties: function(controlObj)
        {
            controlObj._drilledCellSet = (controlObj.model.enablePaging || controlObj.model.enableVirtualScrolling) ? (ej.isNullOrUndefined(controlObj._drilledCellSet) ? [] : controlObj._drilledCellSet) : [];
            controlObj.XMLACellSet = null;
            if (ej.isNullOrUndefined(controlObj._fieldData) || (!ej.isNullOrUndefined(controlObj._fieldData) && ej.isNullOrUndefined(controlObj._fieldData.hierarchy)))
                this._getFieldItemsInfo(controlObj);
            this._currIndex = {};
            this._isRowDrilled = false;
            this._isColDrilled = false;
            this._isNoSummary = controlObj.model.layout == "nosummaries" ? true : false;
        },
        getJSONData: function (args, dataSource, controlObj) {

            if (args.action && (args.action == "initialLoad" || args.action == "navPaging")) {
                this._initControlProperties(controlObj);
                this._applyTrim(controlObj);
            }
            this._initProperties();
            this.olapCtrlObj = controlObj;
            this._OlapDataSource = dataSource;
            var parsedMDX ="", serverPath = dataSource.data, pData;
            if(controlObj.model.enableGroupingBar){
                controlObj._createGroupingBar(dataSource);
            }
            
            this._isPaging = (this.olapCtrlObj.model.enablePaging || this.olapCtrlObj.model.enableVirtualScrolling) ? true : false;
            if(dataSource.MDXQuery)
                parsedMDX = dataSource.MDXQuery;
            else
                parsedMDX = this._getParsedMDX(dataSource, dataSource.cube, args.action && args.action != "navPaging" && this._isPaging && !ej.isNullOrUndefined(this.olapCtrlObj.model.dataSource.pagerOptions) ? true : false);

            var conStr = this._getConnectionInfo(this.olapCtrlObj.model.dataSource.data);
            if (ej.isNullOrUndefined(dataSource.providerName) || dataSource.providerName == ej.olap.Providers.SSAS)
                pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"> <Header></Header> <Body> <Execute xmlns=\"urn:schemas-microsoft-com:xml-analysis\"> <Command> <Statement> " + parsedMDX + " </Statement> </Command> <Properties> <PropertyList> <Catalog>" + dataSource.catalog + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier> </PropertyList> </Properties></Execute> </Body> </Envelope>";
            else
                pData = "<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"><SOAP-ENV:Body><Execute xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><Command><Statement><![CDATA[" + parsedMDX + "]]></Statement></Command><Properties><PropertyList><DataSourceInfo>" + dataSource.sourceInfo + "</DataSourceInfo><Catalog>" + dataSource.catalog + "</Catalog><AxisFormat>TupleFormat</AxisFormat><Content>Data</Content><Format>Multidimensional</Format></PropertyList></Properties></Execute></SOAP-ENV:Body></SOAP-ENV:Envelope>";
            if (args.action == "drilldown" && !this._isPaging) {
                this.olapCtrlObj.doAjaxPost("POST", conStr.url, { XMLA: pData }, this._onDemandExpand, null, args);
            }
            else
                this.olapCtrlObj.doAjaxPost("POST", conStr.url, { XMLA: pData }, (args.action && args.action != "navPaging" && this._isPaging && !ej.isNullOrUndefined(this.olapCtrlObj.model.dataSource.pagerOptions) ? this._generatePagingData : this._generateJSONData), null, args);
        },
        _getParsedMDX: function (olapReport, cube, refPaging) {
            if (olapReport != undefined) {
                var mdxQuery = "", rowQuery, columnQuery, slicerQuery, isMondrian = (olapReport.providerName == ej.olap.Providers.Mondrian);
                if (isMondrian && olapReport["columns"].length == 0 && !(olapReport['values'][0].axis == "columns" && olapReport['values'][0].measures.length > 0))
                    return "";
                rowQuery = ej.olap._mdxParser._getRowMDX(olapReport);
                columnQuery = ej.olap._mdxParser._getcolumnMDX(olapReport);
                delete olapReport["_isCollapse"];
                rowQuery = rowQuery.length > 0 ? (this._isPaging && !refPaging || isMondrian) ? "(" + rowQuery + ")" : "NON EMPTY(" + rowQuery + ")" : "";
                columnQuery = columnQuery.length > 0 ? (this._isPaging && !refPaging || isMondrian) ? "(" + columnQuery + ")" : "NON EMPTY(" + columnQuery + ")" : "";
                if (this._isPaging && !refPaging && !ej.isNullOrUndefined(this.olapCtrlObj.model.dataSource.pagerOptions)) {
                    var pagingQuery = this._getPagingQuery(rowQuery, columnQuery);
                    rowQuery = pagingQuery.rowQuery;
                    columnQuery = pagingQuery.columnQuery;
                }
                slicerQuery = ej.olap._mdxParser._getSlicerMDX(olapReport, this.olapCtrlObj);
                mdxQuery = "\nSelect \n" + (columnQuery == "" ? "{}" : columnQuery) + "\ndimension properties MEMBER_TYPE,CHILDREN_CARDINALITY, PARENT_UNIQUE_NAME  ON COLUMNS \n" + (rowQuery == "" ? "" : "," + rowQuery + "\ndimension properties MEMBER_TYPE,CHILDREN_CARDINALITY, PARENT_UNIQUE_NAME  ON ROWS") + "\n " + ej.olap._mdxParser._getIncludefilterQuery(olapReport, cube, this.olapCtrlObj) + slicerQuery + "\n CELL PROPERTIES VALUE, FORMAT_STRING, FORMATTED_VALUE \n ";
                if (columnQuery == "")
                    mdxQuery.replace(/NON EMPTY/g, " ");
            }
            return mdxQuery;
        },
        _getPagingQuery: function (rowQuery, columnQuery) {
            var categCurrPage = (Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize) < parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage) || parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage) == 0) ? ((Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize) < parseInt(this.olapCtrlObj._categCurrentPage) && this._colCount > 0) ? Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize) : this.olapCtrlObj._categCurrentPage) : parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage);
            var seriesCurrPage = (Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize) < parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage) || parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage) == 0) ? ((Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize) < parseInt(this.olapCtrlObj._seriesCurrentPage) && this._rowCount > 0) ? Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize) : this.olapCtrlObj._seriesCurrentPage) : parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage);
            var rowQueryCpy = rowQuery;
            return { rowQuery: rowQuery != "" ? ("SUBSET({NONEMPTY(" + rowQuery + (columnQuery != "" ? "," + columnQuery : "") + ")}," + (((seriesCurrPage == 0 ? 1 : seriesCurrPage) - 1) * (this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize)) + "," + this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize + ")") : "", columnQuery: columnQuery != "" ? ("SUBSET({NONEMPTY(" + columnQuery + (rowQueryCpy != "" ? "," + rowQueryCpy : "") + ")}," + (((categCurrPage == 0 ? 1 : categCurrPage) - 1) * (this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize)) + "," + this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize + ")") : "" };
        },
        _getAxisElementsUName : function(axisElements){		
            var elementsName = "";
            for(var elCnt =0; elCnt < axisElements.length; elCnt++)
            {
                elementsName += (elementsName== "" ? "{" + axisElements[elCnt].uniqueName + "}" : ", {" + axisElements[elCnt].uniqueName + "}");
            }
            return elementsName;
        },
        _generatePagingData: function (customArgs, args) {
            if ($(args).find("Error").length > 0) {
                this.olapCtrlObj._createErrorDialog($(args).find("faultstring").text(), customArgs.action);
                return false;
            }
            var XMLACellSet = $(args).find("Axes, CellData");
            this._rowCount = XMLACellSet.find("Axis[name|='Axis1'] Tuple").length;
            this._colCount = XMLACellSet.find("Axis[name|='Axis0'] Tuple").length;

            var parsedMDX = this._getParsedMDX(this.olapCtrlObj.model.dataSource, this.olapCtrlObj.model.dataSource.cube, false);
            var conStr = this._getConnectionInfo(this.olapCtrlObj.model.dataSource.data);
            this.olapCtrlObj.doAjaxPost("POST", conStr.url, { XMLA: ej.olap._mdxParser.getSoapMsg(parsedMDX, this.olapCtrlObj.model.dataSource.data, this.olapCtrlObj.model.dataSource.catalog) }, this._generateJSONData, null, customArgs);
        },
        _generateJSONData: function (customArgs, args) {
            this.olapCtrlObj.model.dataSource = this._OlapDataSource;
            if (this._isPaging && customArgs.action == "drilldown")
                this._onDemandExpand(customArgs, args);
            var tranposeEngine = [], jsonObj = [];
            if ($(args).find("Error").length > 0) {
                ej.Pivot._createErrorDialog($(args).find("faultstring").text(), "Error", this.olapCtrlObj);
                return false;
            }
            $(args).find("Axis[name|='SlicerAxis']").remove();
            this.olapCtrlObj.XMLACellSet = $(args).find("Axes, CellData");
            var axis0Tuples, axis1Tuples, temp, testData = [], cellData;
            if (customArgs == "onDemandDrill")
                this.olapCtrlObj.XMLACellSet = args;
            axis0Tuples = $(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis0'] Tuple");
            axis1Tuples = $(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis1'] Tuple");
            if (axis0Tuples.length > 0) {
                cellData = $(this.olapCtrlObj.XMLACellSet).find("CellData Cell");
                this._rowHeaders = this._getHeaderCollection(axis1Tuples, "rowheader");
                this._columnHeaders = this._getHeaderCollection(axis0Tuples, "colheader");
                this._valueCells = this._getValueCells(cellData, axis0Tuples.length);
                this._indexRCell = this._measureDt.axis == 'rowheader' ? (ej.sum(this._rowHeaders.maxLvlLen) + 1) : ej.sum(this._rowHeaders.maxLvlLen);
                this._indexCCell = this._measureDt.axis == 'colheader' ? (ej.sum(this._columnHeaders.maxLvlLen) + 1) : ej.sum(this._columnHeaders.maxLvlLen);
                if (this._rowHeaders.headers.length > 0 && ej.sum(this._rowHeaders.maxLvlLen) == 0)
                    this._indexRCell = this._rowHeaders.headers[0].length;
                if (this._columnHeaders.headers.length > 0 && ej.sum(this._columnHeaders.maxLvlLen) == 0)
                    this._indexCCell = this._columnHeaders.headers[0].length;
                if (this._isPaging)
                {
                    for (var rCnt = 0; rCnt < this._rowHeaders.headers.length; rCnt++) {
                        for (var cCnt = 0; cCnt < this._columnHeaders.headers.length; cCnt++) {
                            if (ej.isNullOrUndefined(this._valueCells[rCnt]))
                            {
                                this._valueCells[rCnt] = [];
                                this._valueCells[rCnt][cCnt] = { FormatString: "#,#", Value: "" };
                            }
                            else if (ej.isNullOrUndefined(this._valueCells[rCnt][cCnt])) {
                                this._valueCells[rCnt][cCnt] = { FormatString: "#,#", Value: "" };
                            }
                        }
                    }
                }
                this._populateEngine(this._rowHeaders.headers, this._columnHeaders.headers, this._valueCells);
                $(this.olapCtrlObj).find(".pivotGridTable").remove();
                this.olapCtrlObj._measureDt = this._measureDt;
                var rowLenth = this._rowHeaders.headers.length + this._indexCCell, colLength = this._columnHeaders.headers.length + this._indexRCell;
                if (this.pivotEngine.length > 1)
                    rowLenth = this.pivotEngine.length;
                for (var rCnt = 0; rCnt < rowLenth ; rCnt++) {
                    for (var cCnt = 0; cCnt < colLength ; cCnt++) {
                        if (tranposeEngine[cCnt] == undefined)
                            tranposeEngine[cCnt] = [];
                        if (this.pivotEngine[rCnt] != undefined && this.pivotEngine[rCnt][cCnt] != undefined) {
                            tranposeEngine[cCnt][rCnt] = {
                                Index: cCnt + ',' + rCnt, CSS: (this.pivotEngine[rCnt][cCnt].CSS == "" ? "none" : this.pivotEngine[rCnt][cCnt].CSS == undefined ? "value" : this.pivotEngine[rCnt][cCnt].CSS), Value: this.pivotEngine[rCnt][cCnt].Value, State: this.pivotEngine[rCnt][cCnt].ChildCount > 0 ? 2 : this.pivotEngine[rCnt][cCnt].ChildCount < 0 ? 1 : 0,
                                RowSpan: (this.pivotEngine[rCnt][cCnt].RowSpan != undefined ? this.pivotEngine[rCnt][cCnt].RowSpan : 1),
                                ColSpan: (this.pivotEngine[rCnt][cCnt].ColSpan != undefined ? this.pivotEngine[rCnt][cCnt].ColSpan : 1), Info: (this.pivotEngine[rCnt][cCnt].UName + "::" + this.pivotEngine[rCnt][cCnt].LName + "::" + this.pivotEngine[rCnt][cCnt].Value + "::" + this.pivotEngine[rCnt][cCnt].PUName), Span: this.pivotEngine[rCnt][cCnt].Span == "Block" ? "Block" : "None", Expander: 1
                            };
                            if (this.pivotEngine[rCnt][cCnt].kpiInfo)
                            {
                                tranposeEngine[cCnt][rCnt].kpi = this.pivotEngine[rCnt][cCnt].kpi;
                                tranposeEngine[cCnt][rCnt].kpiInfo = this.pivotEngine[rCnt][cCnt].kpiInfo;
                            }
                            if(this.pivotEngine[rCnt][cCnt].ActualValue)
                                tranposeEngine[cCnt][rCnt].ActualValue = this.pivotEngine[rCnt][cCnt].ActualValue;
                        }
                        else if (this.pivotEngine[rCnt] != undefined) {
                            var css = "none";
                            if (rCnt < this._indexCCell && cCnt < this._indexRCell)
                                css = "rowheader";
                            tranposeEngine[cCnt][rCnt] = {
                                Index: cCnt + ',' + rCnt, CSS: css, Value: "", State: 0,
                                RowSpan: 1,
                                ColSpan: 1, Info: "", Span: "Block", Expander: 0
                            };
                        }
                    }
                }
                for (var rCnt = 0; rCnt < colLength; rCnt++) {
                    for (var cCnt = 0; cCnt < rowLenth ; cCnt++) {
                        if (tranposeEngine[rCnt] != undefined && tranposeEngine[rCnt][cCnt] != undefined)
                            jsonObj.push(tranposeEngine[rCnt][cCnt]);
                    }
                }
                var _rowCount = 0;
                for (var index = 0; index < jsonObj.length; index++) {
                    if (parseInt(jsonObj[index].Index.split(',')[0]) == 0)
                        _rowCount++;
                    else
                        break;
                }
            }
                this.olapCtrlObj["_pivotRecords"] = { records: jsonObj, rowCount: _rowCount };
                if (!(typeof (this.olapCtrlObj.model.dataSource.data) == "string") || this.olapCtrlObj.pluginName == "ejPivotGrid")
                    this._renderPivotGrid(customArgs, jsonObj);
                else if ((!(typeof (this.olapCtrlObj.model.dataSource.data) == "string") || this.olapCtrlObj.pluginName == "ejPivotChart") || (!(typeof (this.olapCtrlObj.model.dataSource.data) == "string") || this.olapCtrlObj.pluginName == "ejPivotGauge") || (!(typeof (this.olapCtrlObj.model.dataSource.data) == "string") || this.olapCtrlObj.pluginName == "ejPivotTreeMap"))
                    this.olapCtrlObj.generateJSON({ baseObj: this }, tranposeEngine);
                else {
                    this._renderPager(customArgs);
                    this.olapCtrlObj.generateJSON({ baseObj: this, tranposeEngine: tranposeEngine, jsonObj: jsonObj });
                }
            this._columnHeaders = this._rowHeaders = this._valueCells = this.pivotEngine = []; this._cBIndx = this._rBIndx = null; this._measureDt = { axis: "", posision: null },
            this._cTotIndexInfo = this._rTotIndexInfo = null;
        },
        _renderPager: function (customArgs) {
            if (this._isPaging && customArgs.action != "navPaging") {
                if (!ej.isNullOrUndefined(this.olapCtrlObj.model.dataSource.pagerOptions)) {
                    var categCurrPage = (Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize) < parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage) || parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage) == 0) ? (Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize) < parseInt(this.olapCtrlObj._categCurrentPage) ? Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize) : this.olapCtrlObj._categCurrentPage) : parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage);
                    var seriesCurrPage = (Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize) < parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage) || parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage) == 0) ? (Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize) < parseInt(this.olapCtrlObj._seriesCurrentPage) ? Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize) : this.olapCtrlObj._seriesCurrentPage) : parseInt(this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage);
                    categCurrPage = categCurrPage == 0 ? 1 : categCurrPage;
                    seriesCurrPage = seriesCurrPage == 0 ? 1 : seriesCurrPage;
                    this._colCount = this._colCount == 0 ? 1 : this._colCount;
                    this._rowCount = this._rowCount == 0 ? 1 : this._rowCount;
                    if (this.olapCtrlObj.model.enablePaging) {
                        var pageSettings = { CategorialCurrentPage: categCurrPage, CategorialPageSize: this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize, SeriesCurrentPage: seriesCurrPage, SeriesPageSize: this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize };
                        var headerCount = { Column: this._colCount, Row: this._rowCount };
                        this.olapCtrlObj._pagerObj.element.css("opacity", "1");
                        this.olapCtrlObj._pagerObj.element.find(".pagerTextBox").removeAttr('disabled');
                        this.olapCtrlObj._pagerObj._unwireEvents();
                        this.olapCtrlObj._pagerObj._wireEvents();
                        this.olapCtrlObj._pagerObj.initPagerProperties(headerCount, pageSettings);
                    }
                    else if (this.olapCtrlObj.model.enableVirtualScrolling) {
                        this.olapCtrlObj._categPageCount = Math.ceil(this._colCount / this.olapCtrlObj.model.dataSource.pagerOptions.categoricalPageSize);
                        this.olapCtrlObj._seriesPageCount = Math.ceil(this._rowCount / this.olapCtrlObj.model.dataSource.pagerOptions.seriesPageSize);
                    }
                    this.olapCtrlObj.model.dataSource.pagerOptions.categoricalCurrentPage = this.olapCtrlObj.model.dataSource.pagerOptions.seriesCurrentPage = 0;
                    this.olapCtrlObj._categCurrentPage = categCurrPage;
                    this.olapCtrlObj._seriesCurrentPage = seriesCurrPage;
                    if (!ej.isNullOrUndefined(this.olapCtrlObj._pivotGrid)) {
                        this.olapCtrlObj._pivotGrid._categCurrentPage = categCurrPage;
                        this.olapCtrlObj._pivotGrid._seriesCurrentPage = seriesCurrPage;
                        this.olapCtrlObj._pivotGrid._categPageCount = this.olapCtrlObj._categPageCount;
                        this.olapCtrlObj._pivotGrid._seriesPageCount = this.olapCtrlObj._seriesPageCount;
                    }
                }
                else if (this.olapCtrlObj.model.enablePaging) {
                    var pageSettings = { CategorialCurrentPage: 1, CategorialPageSize: 1, SeriesCurrentPage: 1, SeriesPageSize: 1 };
                    var headerCount = { Column: 1, Row: 1 };
                    this.olapCtrlObj._pagerObj.initPagerProperties(headerCount, pageSettings);
                    this.olapCtrlObj._pagerObj.element.css("opacity", "0.5");
                    this.olapCtrlObj._pagerObj.element.find(".pagerTextBox").attr('disabled', 'disabled');
                    this.olapCtrlObj._pagerObj._unwireEvents();
                }
            }
        },
        _renderPivotGrid: function (customArgs,jsonObj) {
            this.olapCtrlObj._dataModel = "XMLA";
            this.olapCtrlObj.setJSONRecords(JSON.stringify(jsonObj));
            this.olapCtrlObj.setOlapReport(this.olapCtrlObj.model.dataSource);
            this._renderPager(customArgs);
            if (this.olapCtrlObj.model.enableGroupingBar)
                this.olapCtrlObj._createGroupingBar(this.olapCtrlObj.model.dataSource);
            if (this.olapCtrlObj.model.layout != null && this.olapCtrlObj.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
                this.olapCtrlObj.excelLikeLayout(jsonObj);
            else
                this.olapCtrlObj.renderControlFromJSON(jsonObj);
            if (customArgs.action && (customArgs.action == "initialLoad" || customArgs.action == "navPaging")) {
                this.olapCtrlObj._trigger("renderSuccess", this.olapCtrlObj);
                this.olapCtrlObj._fieldData = { hierarchy: this.olapCtrlObj._fieldData.hierarchy, measures: this.olapCtrlObj._fieldData.measures};
            }
            //if (this.olapCtrlObj.pluginName == "ejPivotGrid")
            //    this.olapCtrlObj._ogridWaitingPopup.hide();
        },
        _onDemandExpand: function (customArgs, args) {
            var drillCellSet = args, repItms, prevItems, childPos = "", tempCellSet = this.olapCtrlObj.XMLACellSet, indxHeads, tPColCnt = 0, dCLen, dRLen,
                colLen = $(this.olapCtrlObj.XMLACellSet).find("Axis[name='Axis0'] Tuple").length, rowLen = $(this.olapCtrlObj.XMLACellSet).find("Axis[name='Axis1'] Tuple").length, cellIndx,
		        drilledVCellsln = 0, tVCells = 0;
            rowLen = rowLen ? rowLen : 1;
            drilledVCellsln = $(args).find("CellData Cell").length;
            tVCells = $(this.olapCtrlObj.XMLACellSet).find("CellData Cell").length;
            prevItems = customArgs.cellInfo.previousElements.split('>#>');
            var drilledCCells = $(args).find("Axis[name|='Axis0'] Tuple"), drilledRCells = $(args).find("Axis[name|='Axis1'] Tuple"),
		    dCLen = drilledCCells.length; dRLen = drilledRCells.length;
		    $(args).find("Axis[name='SlicerAxis']").remove();

		    var itmPos = customArgs.cellInfo.itemPosition, itmUName, selFTup, totDEle = 0, canBreak = false, prevMem = "";
		    if (customArgs.cellInfo.axis == "rowheader")
		        selFTup = drilledRCells[0];
		    else
		        selFTup = drilledCCells[0];
		    childPos = itmUName = $(selFTup).find("Member:nth-child(" + (itmPos + 1) + ") PARENT_UNIQUE_NAME").text();
            for (var itmCnt = itmPos + 1; itmCnt > 0; itmCnt--) {
                tempCellSet = $(tempCellSet).find("Tuple Member:nth-child(" + itmCnt + ") UName:contains('" + itmUName + "')").parents('tuple');
                itmUName = $(selFTup).find("Member:nth-child(" + (itmCnt - 1) + ") UName").text();
                prevMem = itmUName + prevMem;
            }
            childPos = prevMem + childPos;
            cellIndx = tempCellSet.index() + 1;
            childPos = customArgs.cellInfo.previousElements.split(">#>").join().replace(/,/g, "");
            repItms = customArgs.cellInfo.preRepItm.split(">#>").join().replace(/,/g, "");
            if (this.olapCtrlObj._drilledCellSet)
                totDEle = this.olapCtrlObj._drilledCellSet.length;

            childPos = childPos + " !#" + customArgs.cellInfo.axis
            if (!this.olapCtrlObj._drilledCellSet[0] || !totDEle) {
                this.olapCtrlObj._drilledCellSet[0] = [];
                this.olapCtrlObj._drilledCellSet[0][0] = { key: childPos, repItms: repItms};
                canBreak = true;
            }
            else {
                for (var dLen = 0; dLen < totDEle; dLen++) {
                    var chTT = this.olapCtrlObj._drilledCellSet[dLen].length, pUname = customArgs.cellInfo.parentUniqueName;
                    for (var cEllen = 0; cEllen < chTT; cEllen++) {
                        if (customArgs.cellInfo.previousElements.startsWith(this.olapCtrlObj._drilledCellSet[dLen][cEllen].key)) {
                            this.olapCtrlObj._drilledCellSet[dLen].push({ key: childPos, repItms: repItms});
                            canBreak = true;
                            break;
                        }
                        else if (this.olapCtrlObj._drilledCellSet[dLen][cEllen].key.startsWith(customArgs.cellInfo.previousElements)) {
                            this.olapCtrlObj._drilledCellSet[dLen].splice(cEllen, 0, { key: childPos, repItms: repItms });
                            canBreak = true;
                            break;
                        }
                    }

                    if (canBreak)
                        break;
                }
            }
            if(!canBreak)
            {
                this.olapCtrlObj._drilledCellSet[totDEle] = [];
                this.olapCtrlObj._drilledCellSet[totDEle].push({ key: childPos, repItms: repItms });
            }
            if (!this._isPaging) {
                if (customArgs.cellInfo.axis == "rowheader") {
                    var tuples = $(args).find("Axis[name|='Axis1'] Tuple");
                    this._insertCellSet("rowheader", tempCellSet, drilledRCells, drilledCCells, dRLen, colLen, dCLen, cellIndx, args);
                }
                else {
                    var tuples = $(args).find("Axis[name|='Axis1'] Tuple");
                    this._insertCellSet("colheader", tempCellSet, drilledCCells, drilledRCells, rowLen, colLen, dCLen, cellIndx, args);
                }
                this._generateJSONData("onDemandDrill", this.olapCtrlObj.XMLACellSet);
                //this.getJSONData("onDemandDrill", this.olapCtrlObj.model.dataSource, this.olapCtrlObj);
            }
        },
       
        _insertCellSet : function(axis, drilledSet, tuples, drilledCells, rowLen, colLen,dCLen, cellIndx,args){
            var emptyCell = $($(args).find("CellData Cell")[0]).clone();
             $(emptyCell).find("FmtValue").text("");
            if(drilledSet.length > 1){
                $(drilledSet[0]).after(tuples);
            }
            else
                $(drilledSet).after(tuples);
            var selHdrs, selColvalue = colLen;
            if(axis == "rowheader")
                selHdrs = $(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis0'] Tuple");
            else{
                selHdrs = $(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis1'] Tuple");
                selColvalue = dCLen;
            }
            var inEle = 0, indxHeads = $(selHdrs).filter(function(i,ele){
                if(drilledCells[inEle] && $(ele).find("UName").text() == $(drilledCells[inEle]).find("UName").text())
                {
                    inEle++;
                    return true;
                }
            });
            var rSelCnt = 0, checkEle = false;
            for (var rlen = 0; rlen < rowLen; rlen++) {
                var cellsData = "", elCnt = 0, tempCnt = 0;
                var tempScle;
                if (axis == "rowheader")
                    tempScle = (cellIndx + rlen) * selColvalue;
                else {
                    tempScle = (rlen * (colLen + selColvalue)) + cellIndx;
                }
                for (var clen = 0; clen < selColvalue; clen++) {
                    if ((axis == "rowheader" && $(indxHeads[elCnt]).index() == clen) || (axis == "colheader" && $(indxHeads[rSelCnt]).index() == rlen || !selHdrs.length)) {
                        var axisSel;
                        if (axis == "rowheader")
                            axisSel = (rlen * dCLen);
                        else
                            axisSel = rSelCnt * dCLen;
                        cellsData = $($(args).find("CellData Cell")[axisSel + elCnt]).clone();

                        $(this.olapCtrlObj.XMLACellSet).find("CellData Cell:nth-child(" + (tempScle + tempCnt) + ")").after(cellsData);
                        elCnt++; checkEle = true;
                    }
                    else {
                        $(this.olapCtrlObj.XMLACellSet).find("CellData Cell:nth-child(" + (tempScle + tempCnt) + ")").after($(emptyCell).clone());
                    }
                    tempCnt++;
                }
                if (axis == "colheader") {
                    if (checkEle)
                        rSelCnt++;
                    checkEle = false;
                }
            }
            this._setCellOrdinal(this.olapCtrlObj.XMLACellSet[1]);
        },
        _clearDrilledCellSet: function () {
            var drillCells =  $.extend([], this.olapCtrlObj._drilledCellSet), prevItm="", axis ="", drillMem;
            for (var len = 0; len < drillCells.length; len++) {
                prevItm = drillCells[len][0].key.split("!#");
                if (prevItm.length)
                    drillMem = this._getDrilledMemeber({ item: { previousElements: prevItm[0] } });
                if (drillMem.length)
                    this._onDemandCollapse({ drilledMembers: drillMem, action: "" }, prevItm[1]);
            }
        },
        _onDemandCollapse: function (args, axis) {
            var rHeads, cHeads, selHeads, lenthSHds = 0, drCHeads, drRHeads, selDrillHd;//, drilledSet = args.drilledMembers[args.drilledMembers.length - 1].cSet;
            cHeads = $(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis0'] Tuple");
            rHeads = $(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis1'] Tuple");
            //drCHeads = $(drilledSet).find("Axis[name|='Axis0'] Tuple");
            //drRHeads = $(drilledSet).find("Axis[name|='Axis1'] Tuple");
            try{
                //if(axis == "rowheader"){
                //    selHeads = drRHeads;
                //}
                //else
                //    selHeads = drCHeads;
                //if (axis == "rowheader")
                //    this._removeCellSets(selHeads, rHeads, cHeads, drCHeads, drRHeads, axis);
                //else
                //    this._removeCellSets(selHeads, cHeads, rHeads, drRHeads, drCHeads, axis);
                this.olapCtrlObj.model.dataSource = ej.olap._mdxParser._clearCollapsedItems(axis, args.drilledMembers[args.drilledMembers.length - 1], this.olapCtrlObj.model.dataSource);
                args.drilledMembers = args.drilledMembers.splice(0, args.drilledMembers.length - 1);
            }
            catch (ex) {
                this.olapCtrlObj._ogridWaitingPopup.hide();
            }
            if (args.drilledMembers.length)
                this._onDemandCollapse({ drilledMembers: args.drilledMembers, action: args.action }, axis);
            else if (args.action == "collapse") {
                // this._generateJSONData("onDemandDrill", this.olapCtrlObj.XMLACellSet);
                this.olapCtrlObj.model.dataSource._isCollapse = true;
                delete this._currIndex["axis"];
                this.getJSONData({ action: "onDemandCollapse" }, this.olapCtrlObj.model.dataSource, this.olapCtrlObj);
            }
        },
        _removeCellSets: function (selHeads, rHeads, cHeads, drCHeads, drRHeads, axis) {
            var lenthSHds = selHeads.length, colLen, posRemRHd, posRemCHd, selDrillHd = drRHeads[0];
            for (var len = 0; len < rHeads.length; len++) {
                if ($(rHeads[len]).find("UName").text() == $(selDrillHd).find("UName").text()) {
                    posRemRHd = rHeads[len];
                    break;
                }
            }
            var remEl = lenthSHds, remIndx = $(posRemRHd).index(), removeEl;
            if (remIndx) {
                if (axis == "rowheader") {
                    colLen = cHeads.length;
                    while (remEl > 0) {
                        $($(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis1'] Tuple")[remIndx]).remove();
                        remEl--;
                    }
                    var remCel = ext = remIndx;
                    for (; remCel < (ext + lenthSHds) ; remCel++) {
                        removeEl = $($(this.olapCtrlObj.XMLACellSet).find("CellData Cell")).splice(remIndx * colLen, colLen);
                        $(removeEl).remove();
                    }
                }
                else {
                    colLen = rHeads.length; var rowLen = cHeads.length;
                    while (remEl > 0) {
                        $($(this.olapCtrlObj.XMLACellSet).find("Axis[name|='Axis0'] Tuple")[remIndx]).remove();
                        remEl--;
                    }
                    for (var remCel = 0; remCel < rowLen; remCel++) {
                        removeEl = $($(this.olapCtrlObj.XMLACellSet).find("CellData Cell")).splice(((colLen * remCel) - (remCel * lenthSHds)) + remIndx, lenthSHds);
                        $(removeEl).remove();
                    }
                }
            }
            this._setCellOrdinal(this.olapCtrlObj.XMLACellSet[1]);
        },
        _getDrilledMemeber: function (args) {
            var cellSets = [],  dataSet;
            var keyVal = args.item.previousElements.split('>#>').join().replace(/,/g, ""),
            dataSet = this.olapCtrlObj._drilledCellSet;
            cellSets = $.map(this.olapCtrlObj._drilledCellSet, function (ele, indx) {
                return cellSets = $.map(ele, function (item, n) {
                    if (item.key.startsWith(keyVal)) {
                        return item;
                    }
                });
           });
           
            for (var i = 0; i < dataSet.length; i++)
                {
                for (var rem = 0, ele = dataSet[i]; dataSet[i] && rem < dataSet[i].length; rem++) {
                    if (ele[rem] && ele[rem].key.startsWith(keyVal)) {
                            ele.splice(rem, 1);
                            rem--;
                            if (!ele.length) {
                                dataSet.splice(i, 1);
                                i--;
                            }
                        }
                       
                    }
                }
            return cellSets;
        },
        _getHeaderCollection : function(axisData, axis){
            var headerCollection, setIndx, tempIndx = [], level, type = "", maxLvlLen = [], KPIIndx = null, kpiInfo = {}, measuredt = {}, currentObj = this;
            headerCollection = $(axisData).filter(function (index, mem1) {
                var mem = $(mem1).find('Member'), mCol = [], preIsAll = $(mem[0]).find('LName').text().indexOf("[(All)]") != -1, allCnt = (preIsAll ? 1 : 0), curIsAll = 0;
                KPIIndx = null;
                if(preIsAll){
                    level = 0; type = "total";
                }
                else
                { 
                    type = ""; level = mem.length;
                }
                var mLen = 1;
                if($(mem[0]).find('LName').text().toLowerCase().indexOf("[measures]")!= -1)
                    mLen = 0;
                for(mLen;mLen < mem.length; mLen++)
                {
                    if($(mem[mLen]).find('LName').text().toLowerCase().indexOf("[measures]")!= -1){
                        curIsAll = preIsAll; measuredt.axis = axis; measuredt.posision = mLen;
                        if (parseInt($(mem[mLen]).find('MEMBER_TYPE').text()) == 4) {
                            var memUName = $(mem[mLen]).find('UName').text().toLowerCase();
                            if (memUName.indexOf("trend]") != -1) {
                                if (!currentObj._kpi) {
                                    currentObj._loadKpi(currentObj.olapCtrlObj.model.dataSource, this._loadKpiSuccess, "");
                                }
                                if (kpiInfo = currentObj._isKpi($(mem[mLen]).find('UName').text(), "trend")) {
                                    KPIIndx = "trend"; measuredt.isKpiExist = true;
                                }
                            }
                            else if (memUName.indexOf("status]") != -1) {
                                if (!currentObj._kpi) {
                                    currentObj._loadKpi(currentObj.olapCtrlObj.model.dataSource, this._loadKpiSuccess, "");
                                }
                                if (kpiInfo = currentObj._isKpi($(mem[mLen]).find('UName').text(), "status")) {
                                    KPIIndx = "status"; measuredt.isKpiExist = true;
                                }
                            }
                            else if (memUName.indexOf("goal]") != -1) {
                                if (!currentObj._kpi) {
                                    currentObj._loadKpi(currentObj.olapCtrlObj.model.dataSource, this._loadKpiSuccess, "");
                                }
                                if (kpiInfo = currentObj._isKpi($(mem[mLen]).find('UName').text() + "::" + $(mem[mLen]).find('Caption').text(), "goal")) {
                                    KPIIndx = "goal";
                                    measuredt.isKpiExist = true;
                                }
                            }
                        }
                    }
                    else
                        curIsAll =($(mem[mLen]).find('LName').text().indexOf("[(All)]")!= -1);
                    if((preIsAll == false && curIsAll == true) || (preIsAll == true && curIsAll == false)){	
                        allCnt++; level = mLen, type = "total";
                    }
                    preIsAll = curIsAll;
                }
                setIndx = index;
                if (allCnt < 2)
                {
                    tempIndx.push({ selIndx: setIndx, totLvl: level, type: type, kpi: KPIIndx, kpiInfo: kpiInfo });
                }
                return allCnt < 2;
            }).map(function (index, ele) {
                var mem = $(ele).find('Member'), mCol = [];
                for(var mLen =0;mLen < mem.length; mLen++)
                {
                    var levNum = parseInt($(mem[mLen]).find('LNum').text()), pUName;

                    if (axis == "colheader" && currentObj._OlapDataSource.columns[mLen]) {
                        if (currentObj._OlapDataSource.columns[mLen].hasAllMember)
                            levNum += 1;
                    }
                    else if (axis == "rowheader" && currentObj._OlapDataSource.rows[mLen])
                        if (currentObj._OlapDataSource.rows[mLen].hasAllMember)
                            levNum += 1;

                    pUName = $(mem[mLen]).find('PARENT_UNIQUE_NAME').length ? $(mem[mLen]).find('PARENT_UNIQUE_NAME').text() : "";
                    mCol.push({
                        CSS: axis, Value: $(mem[mLen]).find('Caption').text() == "" ? "(Blank)" : $(mem[mLen]).find('Caption').text(), ColSpan: 1, RowSpan: 1, HUName: $(mem[mLen]).attr('Hierarchy'), LName: $(mem[mLen]).find('LName').text(), UName: $(mem[mLen]).find('UName').text(),
                        ChildCount: parseInt($(mem[mLen]).find('CHILDREN_CARDINALITY').text()), PUName: pUName, LNum: levNum, MemberType: parseInt($(mem[mLen]).find('MEMBER_TYPE').text())
                    });

                    if ($(mem[mLen]).find('LName').text().toLowerCase().indexOf("[measures]") != -1 && tempIndx[index].kpi) {
                        mCol[mCol.length - 1].kpiInfo = tempIndx[index].kpiInfo;
                        mCol[mCol.length - 1].kpi = tempIndx[index].kpi;
                    }
                    if(maxLvlLen[mLen] == undefined)
                        maxLvlLen[mLen] = levNum;
                    else{
                        if(maxLvlLen[mLen] < levNum)
                            maxLvlLen[mLen] = levNum;
                    }							
                }
                var temp = [];
                temp[0] = mCol;
                return temp;
            });
            if(axis == "colheader")
                this._cTotIndexInfo = tempIndx;
            else
                this._rTotIndexInfo = tempIndx;
            headerCollection = { headers: headerCollection, indxInfo: tempIndx, maxLvlLen: maxLvlLen };
            if (!$.isEmptyObject(measuredt))
                this._measureDt = $.extend({}, measuredt);
            var measureCnt = 1;
            if(axis.indexOf(this._OlapDataSource.values[0].axis.substring(0,3)) > -1)
                measureCnt = this._measureDt.measureCount = this._OlapDataSource.values[0].measures.length;
            if (!this._OlapDataSource._enableBasicEngine && !this._isPaging) {
                
                var totItems = { headers: [], indxInfo: [] }, items = tempIndx, itemsCnt = tempIndx.length, totCnt = totItems.length, spanCnt = [], leafNodCmp = [], leafNodLen = 0, subPos = [], isSubTRem = false;
                try {
                    for (var hCnt = 0; hCnt < itemsCnt; hCnt++)
                    {
                        if (hCnt < itemsCnt && headerCollection.indxInfo[hCnt].type == "total")
                        {
                            totItems.indxInfo.push(headerCollection.indxInfo.splice(hCnt, 1)[0]);
                            totItems.headers.push(headerCollection.headers.splice(hCnt,1)[0]);
                            itemsCnt--; hCnt--; 					
                        }	
                    }
                    var hlen = headerCollection.headers.length > 0 ? headerCollection.headers[0].length: 0, insertCnt = 0, measUd = 0;
                    if (this._measureDt.posision == hlen - 1 && this._measureDt.axis == axis)
                        measUd = 1;
                    itemsCnt = headerCollection.headers.length;
                    for (var hCnt = 0; hCnt <= itemsCnt; hCnt++) {
                        var prevMem = null, nextMem = null, currentMem = null, members = null;
                        members = this._updateMemberVariables(headerCollection.headers, prevMem, nextMem, currentMem, hCnt);
                        prevMem = members.prev; nextMem = members.next; currentMem = members.cur;
                        members = null;
                        for (var cnt = hlen - 2 - measUd; cnt >= 0; cnt--)
                        {
                            var isDif = this._comparePrevMembers(headerCollection.headers, itemsCnt, hCnt, cnt, hlen, -2);
                            if (hCnt == itemsCnt || (hCnt > 0 && ((prevMem && prevMem[cnt].UName != currentMem[cnt].UName) || (prevMem[cnt].UName == currentMem[cnt].UName && isDif)))) {

                                //Removing additional total here
                                if (currentMem && prevMem[cnt].UName == currentMem[cnt].PUName) {
                                    var remLen = this._removeSubtotalMembers(headerCollection, hCnt, cnt);
                                    hCnt -= remLen;
                                    itemsCnt -= remLen;
                                    members = this._updateMemberVariables(headerCollection.headers, prevMem, nextMem, currentMem, hCnt);
                                    prevMem = members.prev; nextMem = members.next; currentMem = members.cur;
                                    members = null;
                                }
                                else {
                                    var findParent = prevMem, headers, totCnt = 0, collection, start = 0, end = 0;
                                    if (prevMem)
                                        end = prevMem[cnt].LNum;
                                    if (currentMem)
                                        start = currentMem[cnt].LNum;
                                    var isParent = false;
                                    for (var ttLn = start; ttLn <= end; ttLn++) {
                                        collection = this._getSummaryHeaders(findParent, totItems, cnt, isParent, measUd);
                                        totCnt = collection.headers.length;
                                        while (collection.headers.length > 0) {
                                            headerCollection.headers.splice(hCnt, 0, collection.headers.pop());
                                            headerCollection.indxInfo.splice(hCnt, 0, collection.indexInfo.pop());
                                        }
                                        isParent = true;
                                        hCnt += totCnt; itemsCnt += totCnt;
                                        findParent = headerCollection.headers[hCnt-1];
                                    }
                                
                                }
                            }
                        }
                        if (hCnt == itemsCnt && totItems.headers.length > 0)
                        {
                            var incCount = 0;
                            while (totItems.headers.length > 0) {
                                headerCollection.headers.splice(hCnt, 0, totItems.headers.pop());
                                headerCollection.indxInfo.splice(hCnt, 0, totItems.indxInfo.pop());
                                itemsCnt++; incCount++;
                            }
                            hCnt += incCount;
                        }
                    }
                    var cnt = 0, isLeafSum = false, parentUN = "";
                    leafNodCmp = { headers: [], indxInfo: [] }; cnt = hlen - 1 - measUd;
                    itemsCnt = headerCollection.headers.length;
                    for (var hCnt = 0; hCnt < itemsCnt; hCnt++) {
                        var nextMem, prevMem = this._findPreviousMember(headerCollection.headers, hCnt - 1, cnt), parentUN;
                        if (hCnt > 0 && headerCollection.headers[hCnt - 1][cnt].UName != headerCollection.headers[hCnt][cnt].UName && (cnt == hlen - 1 - measUd && maxLvlLen[cnt] > 1)) {
                            if (hCnt > 0 && headerCollection.headers[hCnt] != undefined && headerCollection.headers[hCnt - 1][cnt].LNum != 0 && headerCollection.headers[hCnt - 1][cnt].UName == headerCollection.headers[hCnt][cnt].PUName) {
                                for (var len = prevMem; len < 0; len++) {
                                    headerCollection.indxInfo[(hCnt + len)].lnum = headerCollection.headers[hCnt + len][cnt].LNum;
                                    headerCollection.indxInfo[(hCnt + len)].type = "total";
                                    leafNodCmp.indxInfo.push(headerCollection.indxInfo.splice((hCnt + len) , 1)[0]);
                                    leafNodCmp.headers.push(headerCollection.headers.splice((hCnt + len), 1)[0]);
                                    if (hCnt + 1 == itemsCnt)
                                        parentUN = headerCollection.headers[hCnt][cnt].PUName;
                                    else {
                                        hCnt--; itemsCnt--;
                                    }
                                }
                            }
                            if (hCnt != 0 && headerCollection.headers[hCnt] != undefined && headerCollection.headers[hCnt - 1][cnt].LNum > headerCollection.headers[hCnt][cnt].LNum || isLeafSum) {
                                var remIndx = [], retObj = this._insertSummaryHeaders(headerCollection, leafNodCmp, remIndx, hCnt, cnt, hlen, insertCnt, parentUN, isSubTRem, subPos);
                                    itemsCnt = retObj.itmCnt, hCnt = retObj.hCnt, insertCnt = retObj.insCnt, subPos[cnt] = retObj.subPos;
                            }
                        }
                       
                    }
                }
                catch (ex) {
                    this.olapCtrlObj._waitingPopup.hide();
                }
            }
            if(axis =="rowheader")
                this._rBIndx = tempIndx;
            else 
                this._cBIndx = tempIndx;
             
            return headerCollection;
        },
        _insertSummaryHeaders: function (headerCollection, leafNodCmp, remIndx, hCnt, cnt, hlen, insertCnt, parentUN, isSubTRem, subPos) {
            var ln = 0, remIndx = [], start, endLp, itemsCnt, uniqueNM = "", insertCnt = 0;

            if (headerCollection.headers[hCnt - 1])
                parentUN = headerCollection.headers[hCnt - 1][cnt].PUName;
            itemsCnt = headerCollection.headers.length;
            start = headerCollection.headers[hCnt][cnt].LNum;
            endLp = headerCollection.headers[hCnt - 1][cnt].LNum;
            var innerFlag = this._comparePrevMembers(headerCollection.headers, itemsCnt, hCnt, cnt, hlen, insertCnt);
            for (var lev = start; lev < endLp; lev++) {
                $.grep(leafNodCmp.headers, function (ele, indx) {
                    if (parentUN == ele[cnt].UName || headerCollection.headers[hCnt + 1 + insertCnt] != undefined && headerCollection.headers[hCnt][cnt].UName != headerCollection.headers[hCnt + 1 + insertCnt][cnt].UName && headerCollection.headers[hCnt][cnt].PUName == ele[cnt].UName && innerFlag) {
                        uniqueNM = ele[cnt].PUName;
                        remIndx.push(indx);
                    }
                });
                parentUN = uniqueNM;
                if (innerFlag) {
                    remIndx.reverse(); innerFlag = false;
                }
                while (remIndx.length > 0) {
                    var remLn = remIndx.length - 1, remVal = remIndx[remIndx.length - 1];
                    headerCollection.headers.splice(hCnt, 0, leafNodCmp.headers.splice(remIndx[remIndx.length - 1], 1)[0]);
                    headerCollection.indxInfo.splice(hCnt, 0, leafNodCmp.indxInfo.splice(remIndx[remIndx.length - 1], 1)[0]);
                    while (remLn >= 0) {
                        if (remVal < remIndx[remLn])
                            remIndx[remLn]--;
                        remLn--;
                    }
                    remIndx.pop();
                    itemsCnt++;  insertCnt++;
                    if (isSubTRem)
                        subPos[cnt]++;
                }
                if(insertCnt > 0)
                {
                    hCnt += insertCnt;
                    insertCnt = 0;
                }
            }
            return { itmCnt: itemsCnt, hCnt: hCnt, insCnt: insertCnt, subPos: subPos[cnt] };
        },
        _comparePrevMembers: function (headers, itemsCnt, hCnt, cnt, hlen, insertCnt) {
            var isDiff = false;
            if (cnt > 0 && hCnt < itemsCnt && hCnt + 1 + insertCnt >= 0 && hCnt + 1 + insertCnt < itemsCnt) {
                for (var prv = cnt - 1; prv >= 0; prv--)
                    if (headers[hCnt][prv].UName != headers[hCnt + 1 + insertCnt][prv].UName)
                        isDiff = true;
            }
            return isDiff;
        },
        _updateMemberVariables: function(headers, prevMem, nextMem, currentMem, hCnt){
            if (headers[hCnt])
                currentMem = headers[hCnt];
            if (headers[hCnt + 1])
                nextMem = headers[hCnt + 1];
            else
                nextMem = null;
            if (headers[hCnt - 1])
                prevMem = headers[hCnt - 1];
            else
                prevMem = null;
            return {cur: currentMem, prev: prevMem, next:nextMem};
        },
        _removeSubtotalMembers: function (headerCollection, hCnt, cnt)
        {
            var remLn = hCnt - 1, uname = headerCollection.headers[remLn][cnt].UName;
            while (headerCollection.headers[remLn] && headerCollection.headers[remLn][cnt].UName == uname)
            {
                headerCollection.indxInfo.splice(remLn, 1);
                headerCollection.headers.splice(remLn, 1);
                remLn--;
            }
            return (hCnt - (remLn + 1));
        },
        _getSummaryHeaders: function (prevMem, totHeaders, cnt, isParent, measUd) {
            var ttHeaders = totHeaders.headers, prev = prevMem, elCnt = cnt, header, rinfo = [],info = [], indInfo = totHeaders.indxInfo, totInfo;

            //Matched totals
            totInfo = $.grep(ttHeaders, function (ele, index) {
                var isMatch = false;
                for (var ln = elCnt; ln >= 0; ln--) {
                    if (ele[ln].UName == prev[ln].UName || (isParent && ln == elCnt  && ele[ln].UName == prev[ln].PUName)) {
                        if (ln == 0) {
                            isMatch = true;
                            info.push(indInfo[index]);
                        }
                    }
                    else
                        break;
                }
                return isMatch;
            });

            //Remaining items
            totHeaders.headers = $.grep(ttHeaders, function (ele, index) {
                var isMatch = true;
                for (var ln = elCnt; ln >= 0; ln--) {
                    if (ele[ln].UName == prev[ln].UName || (isParent && ln == elCnt && ele[ln].UName == prev[ln].PUName)) {
                        if (ln == 0) {
                            isMatch = false;

                        }
                    }
                    else
                        break;
                }
                if (isMatch)
                    rinfo.push(indInfo[index]);
                return isMatch;
            });
            totHeaders.indxInfo = rinfo;
            return { headers: totInfo, indexInfo: info  };
        },
        _drillOrderHeaderCollection: function (headersInfo, axisData, curAxis) {
            var orderInfo = headersInfo, selectedHeaders, headerData = axisData, axis = curAxis, rowCnt = 0, currentObj = this;

            selectedHeaders = $(orderInfo).map(function (indx, info) {
                var mem = $(headerData[info.selIndx]).find('Member'), mCol = [];
                mCol[rowCnt] = [];
                    for (var mLen = 0; mLen < mem.length; mLen++) {
                        var levNum = parseInt($(mem[mLen]).find('LNum').text()), pUName;
                        if (axis == "colheader" && currentObj._OlapDataSource.columns[mLen]) {
                        if (currentObj._OlapDataSource.columns[mLen].hasAllMember)
                            levNum += 1;
                    }
                    else if (axis == "rowheader" && currentObj._OlapDataSource.rows[mLen])
                        if (currentObj._OlapDataSource.rows[mLen].hasAllMember)
                            levNum += 1;
                        pUName = $(mem[mLen]).find('PARENT_UNIQUE_NAME').length ? $(mem[mLen]).find('PARENT_UNIQUE_NAME').text() : "";
                        mCol[rowCnt].push({
                            CSS: axis, Value: $(mem[mLen]).find('Caption').text(), ColSpan: 1, RowSpan: 1, HUName: $(mem[mLen]).attr('Hierarchy'), LName: $(mem[mLen]).find('LName').text(), UName: $(mem[mLen]).find('UName').text(),
                            ChildCount: parseInt($(mem[mLen]).find('CHILDREN_CARDINALITY').text()), PUName: pUName, LNum: levNum, MemberType: parseInt($(mem[mLen]).find('MEMBER_TYPE').text())
                        });
                        var member = mCol[rowCnt][mCol[rowCnt].length - 1];
                        
                        if (info.kpiInfo && member.UName.toLowerCase().indexOf("[measures]") > -1 && member.MemberType == 4)
                            mCol[rowCnt][mCol[rowCnt].length - 1].kpiInfo = info.kpiInfo;
                        if (info.kpi && member.UName.toLowerCase().indexOf("[measures]") > -1 && member.MemberType == 4)
                            mCol[rowCnt][mCol[rowCnt].length - 1].kpi = info.kpi;
                    }
                return mCol;
            });
            return selectedHeaders;

        },
        _loadKpi: function (args, successMethod, customArgs) {
            customArgs = { action: "loadFieldElements" };
            var conStr = this._getConnectionInfo(args.data);
            var pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>MDSCHEMA_KPIS</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + args.catalog + "</CATALOG_NAME><CUBE_NAME>" + args.cube + "</CUBE_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + args.catalog + "</Catalog></PropertyList></Properties></Discover></Body></Envelope>";
            this.olapCtrlObj.doAjaxPost("POST", conStr.url, { XMLA: pData }, this._loadKpiSuccess, null, customArgs);
        },
        _loadKpiSuccess: function (customArgs, args) {
            this._kpi = args;
        },
        _isKpi: function (memeberUName, type) {
            var kpiRow = $(this._kpi).find("row:contains(" + memeberUName.split("::")[0] + ")"), kpiInfo = {};
            if (kpiRow.length) {
                if (type == "trend") {
                    kpiInfo.Graphic = $(kpiRow).find("KPI_TREND_GRAPHIC").text();
                    kpiInfo.Value = $(kpiRow).find("KPI_NAME").text();
                }
                else if (type == "status") {
                    kpiInfo.Graphic = $(kpiRow).find("KPI_STATUS_GRAPHIC").text();
                    kpiInfo.Value = $(kpiRow).find("KPI_NAME").text();
                }
                else if (type == "goal") {
                    kpiInfo.Caption = memeberUName.split("::")[1];
                    kpiInfo.Value = $(kpiRow).find("KPI_NAME").text();
                }
                return kpiInfo;
            }
            else
                return false;
        },
     
        _getValueCells: function (cellData, colBLen) {
            var valueCell, colLen = this._columnHeaders.headers.length, rowLen = this._rowHeaders.headers.length ? this._rowHeaders.headers.length : 1, rCnt = 0, cCnt = 0, vCell = [];
            this._valueCells[rCnt] = [];
            this._fillAllValueCells();
            cellData = $(this.olapCtrlObj.XMLACellSet).find("CellData Cell");
            if (this._OlapDataSource._enableBasicEngine || this._isPaging)
                for (var cLen = 0; cLen < cellData.length; cLen++) {
                    if (cCnt < colLen) {
                        this._valueCells[rCnt][cCnt] = { Value: ($(cellData[cLen]).find("FmtValue")[0] ? $(cellData[cLen]).find("FmtValue").text() : ""), FormatString: ($(cellData[cLen]).find("FormatString")[0] ? $(cellData[cLen]).find("FormatString").text() : "") };
                        cCnt++;
                    }
                    if (cCnt == colLen && rCnt + 1 < rowLen) {
                        cCnt = 0; rCnt++;
                        this._valueCells[rCnt] = [];
                    }
                }
            else {

                for (var rLen = 0; rLen < rowLen; rLen++) {
                    var rowIndx = this._rBIndx.length ? this._rBIndx[rLen].selIndx : 0;
                    for (var cLen = 0; cLen < colLen; cLen++) {
                        var cellVal = $(cellData[((rowIndx * colBLen) + this._cBIndx[cLen].selIndx)]), summary = "";
                        if (this._columnHeaders.indxInfo[cLen] && this._columnHeaders.indxInfo[cLen].type == "total" || this._rowHeaders.indxInfo[rLen] && this._rowHeaders.indxInfo[rLen].type == "total")
                            summary = "summary";
                        if (cCnt < colLen) {
                            this._valueCells[rLen][cLen] = { ActualValue: $(cellVal).find("Value").text(), Value: $(cellVal).find("FmtValue")[0] ? this._getFormatedValue($(cellVal), $(cellVal).find("FormatString")[0]) : "", FormatString: $(cellVal).find("FormatString")[0] ? $(cellVal).find("FormatString").text() : "", kpi: this._cBIndx[cLen].kpi ? this._cBIndx[cLen].kpi : this._rBIndx[rLen] ? this._rBIndx[rLen].kpi : "", summary: summary, Span: this._isNoSummary && summary == "summary"? "Block" : "None"};
                            cCnt++;
                        }
                        if (cCnt == colLen && rCnt + 1 < rowLen) {
                            cCnt = 0; rCnt++;
                            this._valueCells[rCnt] = [];
                        }
                    }
                }
            }
            return this._valueCells;
        },
        _fillAllValueCells: function (cellData) {
            cellData = $(this.olapCtrlObj.XMLACellSet).find("CellData Cell");
            var emptyCell = $(cellData[0]).clone();
            $(emptyCell).find("FmtValue").text("");
            var cell = cellData;
            for (var cnt = 0; cnt < cellData.length; cnt++)
            {
                var curVal = parseInt($(cellData[cnt]).attr("CellOrdinal")), nextVal;
                if (cellData[cnt + 1])
                    nextVal = parseInt($(cellData[cnt+1]).attr("CellOrdinal"))
                if(curVal + 1 < nextVal)
                {
                    for(var ins= curVal+1; ins < nextVal; ins++)
                    {
                        // cellData.splice(ins, 0, $(emptyCell).clone().attr("CellOrdinal", ins)[0]);
                        $(cellData[cnt]).after($(emptyCell).clone().attr("CellOrdinal", ins)[0]);
                        //cnt++;
                    }
                }
            }
            return cellData;
        },
        _setCellOrdinal: function (cellData) {
            var cellCol = $(cellData).find("Cell");
            for (var len = 0; len < cellCol.length; len++)
                $(cellCol[len]).attr("CellOrdinal", len);
        },
        _getFormatedValue: function (cell, format) {
            var val, format;
            if ((this.olapCtrlObj.model.locale == "en-US" || !$.isNumeric(parseFloat($(cell).find("Value").text())))&&$(cell).length>0)
                val = $(cell).find("FmtValue").text();
            else
            {
                var format = $(format).length > 0 ? $(format).text().toLowerCase() : (ej.isNullOrUndefined(format) ? "" : format.length > 0 ? format : "");
                var val = $(cell).length > 0 ? parseFloat(cell.find("Value").text()) : cell;
                switch (format) {
                    case "decimal":
                        val = parseFloat(ej.widgetBase.formatting("{0:D2}", val, this.olapCtrlObj.model.locale));
                        break;
                    case "percent":
                        val = ej.widgetBase.formatting("{0:P0}", val, this.olapCtrlObj.model.locale);
                        break;
                    case "number":
                        val = ej.widgetBase.formatting("{0:N}", val, this.olapCtrlObj.model.locale);
                        break;
                    case "currency":
                        val = ej.widgetBase.formatting("{0:C2}", val, this.olapCtrlObj.model.locale);
                        break;
                    case "date":
                        val = new Date(((Number(val) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                        if (this._isDateTime(val))
                            val = ej.widgetBase.formatting("{0:MM/dd/yyyy}", val, this.olapCtrlObj.model.locale)
                        break;
                    case "scientific":
                        val = Number(val).toExponential(2).replace("e", "E");
                        break;
                    case "accounting":
                        val = this._toAccounting(val, "{0:C2}", this.olapCtrlObj.model.locale);
                        break;
                    case "time":
                        val = new Date(((Number(val) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                        if (this._isDateTime(val))
                            val = ej.widgetBase.formatting("{0:h:mm:ss tt}", val, this.olapCtrlObj.model.locale);
                        break;
                    case "fraction":
                        val = this._toFraction(val);
                        val = "numerator" in val ? val.integer + " " + val.numerator + "/" + val.denominator : val.integer
                        break;
                    default: val = $(cell).find("FmtValue").text();
                }
            }
            return val;
        },

        _isDateTime: function (date) {
            return Object.prototype.toString.call(date) === "[object Date]" && !isNaN(date.valueOf());
        },
        _toAccounting: function (value, formatStr, locale) {
            var numFormat = ej.preferredCulture(locale).numberFormat, prefix, suffix, symbol = numFormat.currency.symbol;
            val = ej.widgetBase.formatting(formatStr, value, this.olapCtrlObj.model.locale);
            var trunVal = val.replace(symbol, ""), idx = val.indexOf(symbol);
            if (!idx || (value < 0 && idx === 1)) {
                prefix = symbol;
                suffix = !Number(value) ? "-" : trunVal;
            }
            else {
                prefix = !Number(value) ? "-" : trunVal;
                suffix = symbol;
            }
            value = prefix + "   " + suffix;
            return value;
        },
        _toFraction: function (value) {
            if (this._isNumber(value)) {
                var input = value.toString(), integerVal = input.split(".")[0], decimalVal = input.split(".")[1];
                if (!decimalVal)
                    return { integer: value };
                var wholeVal = (+decimalVal).toString(), placeVal = this._getPlaceValue(decimalVal, wholeVal), gcd = this._getGCD(wholeVal, placeVal);
                return { integer: integerVal, numerator: Number(wholeVal) / gcd, denominator: Number(placeVal) / gcd };
            }
            return null;
        },
        _isNumber: function (val) {
            return val - parseFloat(val) >= 0;
        },
        _getGCD: function (a, b) {  //make generic gcd of multiple no
            a = Number(a);
            b = Number(b);
            if (!b)
                return a;
            return this._getGCD(b, a % b);
        },
        _getPlaceValue: function (val, digit) {
            var index = val.indexOf(digit) + digit.length;
            return "1" + Array(index + 1).join("0");
        },
        _populateEngine: function (rwHeaders, colHeaders, valueCells) {
            var rLen = rwHeaders.length, cLen = colHeaders.length, rILen = rLen ? rwHeaders[0].length : rLen, cILen = cLen ? colHeaders[0].length : cLen, rIndex, cIndex, headerEngine = [],
            vRLen = valueCells.length, vCLen = valueCells[0].length;
            try{
                this.pivotEngine = [];
                var cDrillPos = [], cRSpanCalc = [], temPosChk = false, noSumSpanCalc = [];
                var isNamedSets = false, rowEngine = [];
                for (var rCnt = 0; rCnt < cLen; rCnt++) {
                    if (this.pivotEngine[rCnt + cILen] == undefined)
                        this.pivotEngine[rCnt + cILen] = [];
                    if (rCnt == 0) {
                        this.pivotEngine[0] = [];
                        this.pivotEngine[0][0] = { CSS: "none", Value: "", ColSpan: (this._indexCCell ? this._indexCCell : 1), RowSpan: (this._indexRCell ? this._indexRCell : 1), HUName: "", LName: "", UName: "", LNum: "" };
                    }
                    for (var cCnt = 0; cCnt < cILen; cCnt++) {
                        isNamedSets = false;
                        if (this._OlapDataSource.columns && this._OlapDataSource.columns[cCnt] && this._OlapDataSource.columns[cCnt].isNamedSets)
                            isNamedSets = true;
                        this._pivotEngineSpanCalculation("colheader", colHeaders, rwHeaders, this._columnHeaders.maxLvlLen, valueCells, cCnt, rCnt, cRSpanCalc, cDrillPos, this._cTotIndexInfo, isNamedSets, noSumSpanCalc);
                    }
                }
                rowEngine = this.pivotEngine.slice(); this.pivotEngine = [];
                for (var rCnt = 0; rCnt < rowEngine.length; rCnt++) {
                    if (rowEngine[rCnt])
                        for (var cCnt = 0; cCnt < rowEngine[rCnt].length; cCnt++) {
                            if (rowEngine[rCnt][cCnt]) {
                                if (this.pivotEngine[cCnt] == undefined)
                                    this.pivotEngine[cCnt] = [];
                           
                                this.pivotEngine[cCnt][rCnt] = { CSS: rowEngine[rCnt][cCnt].CSS, ColSpan: rowEngine[rCnt][cCnt].RowSpan, HUName: rowEngine[rCnt][cCnt].HUName, LName: rowEngine[rCnt][cCnt].LName, LNum: rowEngine[rCnt][cCnt].LNum, RowSpan: rowEngine[rCnt][cCnt].ColSpan, UName: rowEngine[rCnt][cCnt].UName, PUName: rowEngine[rCnt][cCnt].PUName, Value: rowEngine[rCnt][cCnt].Value, ChildCount: rowEngine[rCnt][cCnt].ChildCount, MemberType: rowEngine[rCnt][cCnt].MemberType, Span: rowEngine[rCnt][cCnt].Span == "Block" ? "Block" : "None" };
                                if (rowEngine[rCnt][cCnt].kpiInfo) {
                                    this.pivotEngine[cCnt][rCnt].kpiInfo = rowEngine[rCnt][cCnt].kpiInfo;
                                    this.pivotEngine[cCnt][rCnt].kpi = rowEngine[rCnt][cCnt].kpi;
                                }
                            }
                        }
                }

                var drillPos = [], rSpanCalc = [], temPosChk = false, noSumSpanCalc = [];
                for (var rCnt = 0; rCnt < rLen; rCnt++) {
                    if (this.pivotEngine[rCnt + this._indexCCell] == undefined)
                        this.pivotEngine[rCnt + this._indexCCell] = [];

                    for (var cCnt = 0; cCnt < rILen; cCnt++) {
                        isNamedSets = false;
                        if (this._OlapDataSource.rows && this._OlapDataSource.rows[cCnt] && this._OlapDataSource.rows[cCnt].isNamedSets)
                            isNamedSets = true;
                        this._pivotEngineSpanCalculation("rowheader", rwHeaders, colHeaders, this._rowHeaders.maxLvlLen, valueCells, cCnt, rCnt, rSpanCalc, drillPos, this._rTotIndexInfo, isNamedSets, noSumSpanCalc);
                    }
                }

                headerEngine = $.extend(true, [], this.pivotEngine);
                rILen = this._measureDt.axis == 'rowheader' ? (this._indexRCell + 1) : this._indexRCell;
                cILen = this._indexCCell ? this._indexCCell : cILen;
                for (var rCnt = 0; rCnt < vRLen; rCnt++) {
                    if (this.pivotEngine[rCnt + cILen] != undefined)
                        rILen = this.pivotEngine[rCnt + cILen].length;
                    for (var cCnt = 0; cCnt < vCLen; cCnt++) {
                        if (!ej.isNullOrUndefined(valueCells[rCnt][cCnt])) {
                            if (this.pivotEngine[rCnt + cILen] == undefined)
                                this.pivotEngine[rCnt + cILen] = [];
                            var cssName = this._setClassName(valueCells[rCnt][cCnt]);
                            valueCells[rCnt][cCnt].CSS = cssName;
                            if (cssName.indexOf("kpiiconvalue") > -1 && (!this.olapCtrlObj.pluginName === "ejPivotGauge" || this.olapCtrlObj.pluginName == "ejPivotGrid"))
                                valueCells[rCnt][cCnt].Value = "";
                            else if (cssName.indexOf("kpiiconvalue") > -1)
                                valueCells[rCnt][cCnt].Value = parseInt(valueCells[rCnt][cCnt].Value);
                            this.pivotEngine[rCnt + this._indexCCell][cCnt + this._indexRCell] = valueCells[rCnt][cCnt];
                        }
                    }
                }
                var test = $.grep(this.pivotEngine, function (value, index) {
                    var temp = value;
                    return temp;
                });
                if (this._isPaging) {
                    if (!ej.isNullOrUndefined(this.olapCtrlObj._pagingSavedObjects.curDrilledItem.uniqueName) && this.olapCtrlObj._pagingSavedObjects.curDrilledItem.action == "collapse") {
                        $.each(this.olapCtrlObj._pagingSavedObjects.drillEngine, function (i, v) {
                            if (v.UName == (ej.olap.base.olapCtrlObj._pagingSavedObjects.curDrilledItem.uniqueName.split("::")[0]).split("amp;").join("")) {
                                ej.olap.base.olapCtrlObj._pagingSavedObjects.drillEngine.splice(i, 1);
                                return false;
                            }
                        })
                    }
                    else if (!ej.isNullOrUndefined(this.olapCtrlObj._pagingSavedObjects.curDrilledItem.index)) {
                        this.olapCtrlObj._pagingSavedObjects.drillEngine.push(this.olapCtrlObj._pagingSavedObjects.savedHdrEngine[parseInt(this.olapCtrlObj._pagingSavedObjects.curDrilledItem.index.split(',')[1])][parseInt(this.olapCtrlObj._pagingSavedObjects.curDrilledItem.index.split(',')[0])]);
                        this.olapCtrlObj._pagingSavedObjects.drillEngine[this.olapCtrlObj._pagingSavedObjects.drillEngine.length - 1].ChildCount = -1;
                    }
                    else if (!ej.isNullOrUndefined(this.olapCtrlObj._pagingSavedObjects.curDrilledItem.uniqueName)) {
                        $.each(this.olapCtrlObj._pagingSavedObjects.savedHdrEngine, function (rI, row) {
                            $.each(row, function (cI, column) {
                                if (!ej.isNullOrUndefined(column) && column.UName == (ej.olap.base.olapCtrlObj._pagingSavedObjects.curDrilledItem.uniqueName.split("::")[0]).split("amp;").join("")) {
                                    ej.olap.base.olapCtrlObj._pagingSavedObjects.drillEngine.push(ej.olap.base.olapCtrlObj._pagingSavedObjects.savedHdrEngine[rI][cI]);
                                    return false;
                                }
                            })
                        })
                        this.olapCtrlObj._pagingSavedObjects.drillEngine[this.olapCtrlObj._pagingSavedObjects.drillEngine.length - 1].ChildCount = -1;
                    }
                    $.map(this.olapCtrlObj._pagingSavedObjects.drillEngine, function (value) {
                        var inColAxis = $.map(ej.olap.base.olapCtrlObj.model.dataSource.columns, function (cField) {
                            return cField.fieldName == value.HUName ? true : false;
                        })
                        value.CSS = inColAxis[0] ? "colheader" : "rowheader";
                    })
                    this.olapCtrlObj._pagingSavedObjects.curDrilledItem = {};

                    for (var rCnt = this.pivotEngine[0][0].RowSpan - 2; rCnt >= 0; rCnt--) {
                        var UName = "empty";
                        for (cCnt = 1; cCnt < this.pivotEngine[this.pivotEngine[0][0].RowSpan - 1].length ; cCnt++) {
                            if (ej.isNullOrUndefined(this.pivotEngine[rCnt])) {
                                this.pivotEngine[rCnt] = [];
                            }
                            if (!ej.isNullOrUndefined(this.pivotEngine[rCnt + 1]) && ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt]) && !ej.isNullOrUndefined(this.pivotEngine[rCnt + 1][cCnt])) {
                                this.pivotEngine[rCnt][cCnt] = $.grep(this.olapCtrlObj._pagingSavedObjects.drillEngine, function (v) {
                                    return v.UName == ej.olap.base.pivotEngine[rCnt + 1][cCnt].PUName;
                                })[0];
                                if (!ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt])) {
                                    if (!ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt - 1]) && this.pivotEngine[rCnt][cCnt - 1].UName == this.pivotEngine[rCnt][cCnt].UName)
                                        this.pivotEngine[rCnt][cCnt].ColSpan = this.pivotEngine[rCnt][cCnt - 1].ColSpan + 1;
                                    else
                                        this.pivotEngine[rCnt][cCnt].ColSpan = 1;
                                    this.pivotEngine[rCnt][cCnt].RowSpan = 1;
                                    UName = this.pivotEngine[rCnt][cCnt].UName;
                                }
                            }
                        }
                        var colSpan = 1;
                        for (cCnt = this.pivotEngine[this.pivotEngine[0][0].RowSpan - 1].length - 2; cCnt > 0 ; cCnt--) {
                            if (!ej.isNullOrUndefined(this.pivotEngine[rCnt]) && !ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt]) && !ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt + 1]) && this.pivotEngine[rCnt][cCnt + 1].UName == this.pivotEngine[rCnt][cCnt].UName) {
                                this.pivotEngine[rCnt][cCnt].ColSpan == this.pivotEngine[rCnt][cCnt + 1].ColSpan;
                                colSpan++;
                            }
                            else if (!ej.isNullOrUndefined(this.pivotEngine[rCnt]) && !ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt + 1])) {
                                this.pivotEngine[rCnt][cCnt + 1].ColSpan = colSpan == 1 ? this.pivotEngine[rCnt][cCnt + 1].ColSpan : colSpan;
                                colSpan = 1;
                            }
                        }
                    }

                    for (var rCnt = this.pivotEngine[0][0].RowSpan; rCnt < this.pivotEngine.length; rCnt++) {
                        var PUName = "empty";
                        for (cCnt = this.pivotEngine[0][0].ColSpan - 1; cCnt >= 0; cCnt--) {
                            if (!ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt]))
                                PUName = this.pivotEngine[rCnt][cCnt].PUName;
                            else {
                                if (!ej.isNullOrUndefined(this.pivotEngine[rCnt - 1][cCnt]) && this.pivotEngine[rCnt - 1][cCnt].UName == PUName) {
                                    this.pivotEngine[rCnt][cCnt] = $.grep(this.olapCtrlObj._pagingSavedObjects.drillEngine, function (v) {
                                        return v.UName == PUName;
                                    })[0];
                                    if (!ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt])) {
                                        this.pivotEngine[rCnt][cCnt].RowSpan = this.pivotEngine[rCnt - 1][cCnt].RowSpan + 1;
                                        this.pivotEngine[rCnt][cCnt].ColSpan = 1;
                                        PUName = this.pivotEngine[rCnt][cCnt].PUName;
                                    }
                                }
                                else {
                                    this.pivotEngine[rCnt][cCnt] = $.grep(this.olapCtrlObj._pagingSavedObjects.drillEngine, function (v) {
                                        return v.UName == PUName;
                                    })[0];
                                    if (!ej.isNullOrUndefined(this.pivotEngine[rCnt][cCnt])) {
                                        this.pivotEngine[rCnt][cCnt].RowSpan = 1;
                                        this.pivotEngine[rCnt][cCnt].ColSpan = 1;
                                        PUName = this.pivotEngine[rCnt][cCnt].PUName;
                                    }
                                }
                            }
                        }
                    }
                    this.olapCtrlObj._pagingSavedObjects.savedHdrEngine = headerEngine;
                }
            }
            catch (ex) {
                this.olapCtrlObj._waitingPopup.hide();
            }
        },
        _pivotEngineSpanCalculation: function (curAxis, rwHeaders, colHeaders, maxLvlLen, valueCells, cCnt, rCnt, rSpanCalc, drillPos, totIndexInfo, isNamedSets, noSumSpanCalc) {
            var rLen = rwHeaders.length, summaryAxis = "",rSCnt, cLen = colHeaders.length, rILen = rLen ? rwHeaders[0].length : rLen, cILen = cLen ? colHeaders[0].length : cLen, rIndex, cIndex,
                vRLen = valueCells.length, vCLen = valueCells[0].length;
            if (curAxis == "rowheader") {
                cILen = this._indexCCell ? this._indexCCell : cILen;
                summaryAxis = "row";            }
            else {
                cILen = this._indexRCell ? this._indexRCell : cILen;
                summaryAxis = "col";
            }
            var tPosCnt = 1, measUd = 0;
            if (isNamedSets)
                rwHeaders[rCnt][cCnt].ChildCount = 0;
            if (this._measureDt.axis == curAxis && this._measureDt.posision == rILen - 1)
                measUd = 1;
            if (!rSpanCalc[cCnt])
                rSpanCalc[cCnt] = [];
            if (this._isNoSummary && !noSumSpanCalc[cCnt])
                noSumSpanCalc[cCnt] = [];
            if (!this.pivotEngine[rCnt + cILen])
                this.pivotEngine[rCnt + cILen] = [];
           
            drillPos[cCnt] = rCnt;
            var limit = maxLvlLen[cCnt] ? maxLvlLen[cCnt] : 1;
            var levPos = 0, spanLvlPos = 0;
            for (var lp = 0; lp < cCnt; lp++) {
                if (maxLvlLen[lp]) {
                    levPos += maxLvlLen[lp] - 1;
                    spanLvlPos += maxLvlLen[lp];
                }
            }
            if (!this._OlapDataSource._enableBasicEngine || this._OlapDataSource._checkSummaryHeaders)
                    for (var lLen = 1; lLen <= limit; lLen++) {
                        var preCmp = 1, rowPos = null, isBreak = false;
                        var temLvl = rwHeaders[rCnt][cCnt].LNum;
                        if (rSpanCalc[cCnt][lLen] == undefined)
                            rSpanCalc[cCnt][lLen] = 0;
                        if (this._isNoSummary && noSumSpanCalc[cCnt][lLen] == undefined)
                            noSumSpanCalc[cCnt][lLen] = 0;
                        if (rwHeaders[rCnt - 1] && rSpanCalc[cCnt][temLvl] && (rwHeaders[rCnt][cCnt].LNum != 0 && rwHeaders[rCnt - 1][cCnt].PUName == rwHeaders[rCnt][cCnt].UName || (cCnt + measUd == rILen - 1 && rwHeaders[rCnt - 1][cCnt].LNum < rwHeaders[rCnt][cCnt].LNum))) {
                            var tempSpan = rSpanCalc[cCnt][temLvl];
                            if (this._isNoSummary) {
                                tempSpan += noSumSpanCalc[cCnt][temLvl];
                                noSumSpanCalc[cCnt][temLvl] = 0;
                            }
                            this.pivotEngine[rCnt + cILen - tempSpan][cCnt + temLvl - 1 + levPos] = (rwHeaders[rCnt][cCnt]);
                            if (cCnt + measUd != rILen - 1) {
                                this.pivotEngine[rCnt + cILen][cCnt + temLvl - 1 + levPos] = $.extend({}, (rwHeaders[rCnt][cCnt]));
                                if (this._isNoSummary) 
                                    this.pivotEngine[rCnt + cILen][cCnt + temLvl - 1 + levPos].Span = "Block";
                            }
                            if (this._isNoSummary)
                                this.pivotEngine[rCnt + cILen - tempSpan][cCnt + temLvl - 1 + levPos].RowSpan = 0;
                            if (!isNamedSets)
                                this.pivotEngine[rCnt + cILen - tempSpan][cCnt + temLvl - 1 + levPos].ChildCount = -1;
                            this.pivotEngine[rCnt + cILen - tempSpan][cCnt + temLvl - 1 + levPos].ColSpan = 1;
                            this.pivotEngine[rCnt + cILen - tempSpan][cCnt + temLvl - 1 + levPos].RowSpan += rSpanCalc[cCnt][temLvl];
                            this._drilledJSONData(rCnt + cILen - tempSpan, rCnt + cILen , cCnt + temLvl - 1 + levPos, rwHeaders[rCnt][cCnt]);
                            rSpanCalc[cCnt][temLvl] = 0;                           
                            if (cCnt + measUd == rILen - 1) {
                                if (rwHeaders[rCnt - 1][cCnt].LNum > rwHeaders[rCnt][cCnt].LNum) {
                                    var colLen = maxLvlLen[cCnt] - temLvl, nextMem = this._findNextMember(rwHeaders, rCnt, cCnt);
                                    for (var mlen = 0; mlen < nextMem; mlen++) {
                                        if (!this.pivotEngine[rCnt + cILen + mlen])
                                            this.pivotEngine[rCnt + cILen + mlen] = [];
                                        this.pivotEngine[rCnt + cILen + mlen][cCnt + levPos + temLvl] = { CSS: "summary " + summaryAxis, Value: "Total", ColSpan: colLen, RowSpan: 1, HUName: "", LName: "", UName: "", LNum: "", MemberType: "", ChildCount: "",  Span: this._isNoSummary ? "Block" : "None" };
                                    }
                                    if (!this._isNoSummary)
                                        this.pivotEngine[rCnt + cILen - tempSpan][cCnt + temLvl - 1 + levPos].RowSpan += (nextMem - 1);
                                }
                            }

                        }
                        if (rwHeaders[rCnt][cCnt].LNum > lLen && !(this._isNoSummary && totIndexInfo[rCnt].type == "total")) {
                            rSpanCalc[cCnt][lLen]++;
                        }
                        else if (rwHeaders[rCnt][cCnt].LNum > lLen && this._isNoSummary && totIndexInfo[rCnt].type == "total")
                        {
                            noSumSpanCalc[cCnt][lLen]++;
                        }
                        rowPos = rCnt + cILen;
                        if (lLen == rwHeaders[rCnt][cCnt].LNum && rCnt == 0 && rwHeaders[rCnt][cCnt].LNum > 1) {
                            if (!this.pivotEngine[rowPos]) this.pivotEngine[rowPos] = [];
                            this.pivotEngine[rowPos][cCnt + lLen - 1 + levPos] = (rwHeaders[rCnt][cCnt]);
                            if (!(rwHeaders[rCnt + 1] != undefined && (rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt + 1][cCnt].LNum)) || (cCnt + measUd == rILen - 1 &&  rwHeaders[rCnt + 1] && rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt + 1][cCnt].LNum))
                                this.pivotEngine[rowPos][cCnt + lLen - 1 + levPos].ColSpan += maxLvlLen[cCnt] - this.pivotEngine[rowPos][cCnt + lLen - 1 + levPos].LNum;
                        }
                        else if (rCnt != 0 && rwHeaders[rCnt][cCnt].LNum > 1 && lLen == rwHeaders[rCnt][cCnt].LNum && rwHeaders[rCnt - 1][cCnt].UName != rwHeaders[rCnt][cCnt].UName
                        && rwHeaders[rCnt - 1][cCnt].PUName != rwHeaders[rCnt][cCnt].UName) {
                            if (this.pivotEngine[rowPos] == undefined)
                                this.pivotEngine[rowPos] = [];
                            this.pivotEngine[rowPos][cCnt + lLen - 1 + levPos] = (rwHeaders[rCnt][cCnt]); //drillPos++;
                            if (!(rwHeaders[rCnt + 1] != undefined && (rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt + 1][cCnt].LNum))
                                || (cCnt + measUd == rILen - 1 &&  rwHeaders[rCnt + 1] && rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt + 1][cCnt].LNum))
                                this.pivotEngine[rowPos][cCnt + lLen - 1 + levPos].ColSpan += maxLvlLen[cCnt] - this.pivotEngine[rowPos][cCnt + lLen - 1 + levPos].LNum;
                        }
                        else if (rCnt != 0 && lLen == rwHeaders[rCnt][cCnt].LNum && rwHeaders[rCnt - 1][cCnt].UName == rwHeaders[rCnt][cCnt].UName) {
                            if (!(this._isNoSummary && totIndexInfo[rCnt].type == "total"))
                                rSpanCalc[cCnt][lLen]++;
                            else if (this._isNoSummary && totIndexInfo[rCnt].type == "total")
                                noSumSpanCalc[cCnt][lLen]++;
                            this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos] = (rwHeaders[rCnt][cCnt]);
                            if (this._isNoSummary && totIndexInfo[rCnt].type == "total")
                                this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos].Span = "Block";
                            if ((rwHeaders[rCnt + 1] != undefined && rwHeaders[rCnt + 1][cCnt].UName != rwHeaders[rCnt][cCnt].UName) || (rCnt + 1 == rLen && rSpanCalc[cCnt][lLen] > 0)) {
                                var rlen = rSpanCalc[cCnt][lLen], levnum = rwHeaders[rCnt][cCnt].LNum;
                                if (this._isNoSummary) {
                                    rlen += noSumSpanCalc[cCnt][lLen];
                                    noSumSpanCalc[cCnt][lLen] = 0;
                                }
                                if (rlen && this.pivotEngine[rCnt + cILen - rlen][cCnt + levnum - 1 + levPos] != undefined && this.pivotEngine[rCnt + cILen - rlen][cCnt + levnum - 1 + levPos].Value != undefined) {
                                    this.pivotEngine[rCnt + cILen - rlen][cCnt + levnum - 1 + levPos].RowSpan += rSpanCalc[cCnt][lLen];
                                    this._drilledJSONData(rCnt + cILen - rlen, rCnt + cILen, cCnt + levnum - 1 + levPos, rwHeaders[rCnt][cCnt]);
                                }
                                //if (!(this._isNoSummary && totIndexInfo[rCnt].type == "total"))
                                rSpanCalc[cCnt][lLen] = 0;

                            }
                        }
                        else if ((rwHeaders[rCnt][cCnt].LNum < 2 && (lLen == rwHeaders[rCnt][cCnt].LNum || rwHeaders[rCnt][cCnt].LNum == 0)) ||
                        (rwHeaders[rCnt][cCnt].LNum < lLen && rwHeaders[rCnt - 1] && rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt - 1][cCnt].LNum && totIndexInfo[rCnt].type == "total" && this._measureDt.axis == curAxis)) {

                            var tlevPos = lLen - 1;
                            if (rwHeaders[rCnt - 1] && rwHeaders[rCnt - 1][cCnt].UName == rwHeaders[rCnt][cCnt].UName && rwHeaders[rCnt][cCnt].LName.toLowerCase().indexOf("[measures]") > -1) {
                                this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos] = $.extend({},(rwHeaders[rCnt][cCnt]));
                                if (!(this._measureDt.measureCount > 1 && curAxis == this._measureDt.axis) && !(this._isNoSummary && totIndexInfo[rCnt].type == "total"))
                                    rSpanCalc[cCnt][lLen]++;
                                else if (!(this._measureDt.measureCount > 1 && curAxis == this._measureDt.axis) && this._isNoSummary && totIndexInfo[rCnt].type == "total") {
                                    noSumSpanCalc[cCnt][lLen]++;
                                }
                                if (this._isNoSummary && totIndexInfo[rCnt].type == "total" )
                                    this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos].Span = "Block";
                            }
                            if (!(rwHeaders[rCnt][cCnt].UName.indexOf("Measures") != -1 && this._isPaging) && totIndexInfo[rCnt].type != "total") {
                                if (!(rwHeaders[rCnt - 1] && rwHeaders[rCnt - 1][cCnt].UName == rwHeaders[rCnt][cCnt].UName)) {

                                    this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos] = (rwHeaders[rCnt][cCnt]);
                                    rSCnt = rSpanCalc[cCnt][lLen];
                                    if (this._isNoSummary) {
                                        rSCnt += noSumSpanCalc[cCnt][lLen];
                                        noSumSpanCalc[cCnt][lLen] = 0;
                                    }
                                    if (rSCnt && this.pivotEngine[rCnt + cILen - rSCnt][cCnt + lLen - 1 + levPos] != undefined) {
                                        this.pivotEngine[rCnt + cILen - rSCnt][cCnt + lLen - 1 + levPos].RowSpan += rSpanCalc[cCnt][lLen];
                                        this._drilledJSONData(rCnt + cILen - rSCnt, rCnt + cILen, cCnt + lLen - 1 + levPos, rwHeaders[rCnt][cCnt]);
                                    }
                                    rSpanCalc[cCnt][lLen] = 0;
                                }
                                if (!rwHeaders[rCnt][cCnt].LNum == 0 && (!(rwHeaders[rCnt + 1] != undefined && rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt + 1][cCnt].LNum) || ((cCnt + measUd == rILen - 1 && rwHeaders[rCnt + 1] && rwHeaders[rCnt][cCnt].LNum < rwHeaders[rCnt + 1][cCnt].LNum))) && this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos])
                                    this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos].ColSpan += maxLvlLen[cCnt] - this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos].LNum;
                            }
                            else if (totIndexInfo[rCnt].type == "total" && rwHeaders[rCnt][cCnt].LName.toLowerCase().indexOf("[measures]") == -1 && rwHeaders[rCnt][cCnt].LNum != lLen && maxLvlLen[cCnt] != 0) {
                                if ((rwHeaders[rCnt][cCnt - 1] && rwHeaders[rCnt][cCnt - 1].LName.toLowerCase().indexOf("[measures]") == -1 || this._measureDt.axis != curAxis) && (cCnt > totIndexInfo[rCnt].totLvl || (cCnt == rILen - 1 && (lLen > totIndexInfo[rCnt].totLvl && totIndexInfo[rCnt].totLvl != 0)) || (totIndexInfo[rCnt].totLvl == 0 && lLen - 1 > totIndexInfo[rCnt].totLvl)))
                                    break;
                                var tempColSpan = 1, tmpLvl = 1, sumCnt = 0;
                                while (rwHeaders[rCnt - tmpLvl][cCnt] && rwHeaders[rCnt - tmpLvl][cCnt].LNum == 0 && !rwHeaders[rCnt][cCnt].LName.toLowerCase().indexOf("[measures]") > -1) {
                                    if (rwHeaders[rCnt][cCnt - 1] && rwHeaders[rCnt - tmpLvl + 1][cCnt - 1].UName != rwHeaders[rCnt - tmpLvl][cCnt - 1].UName) {
                                        sumCnt++;
                                    }
                                    tmpLvl++;
                                }

                                if (0) { // inside the condtion - this._measureDt.axis == curAxis
                                    var spnWtMsr = 0, initVal, endVal; isBreak = false;
                                    sumCnt = 0;
                                    if (cCnt < this._measureDt.posision) {
                                        initVal = cCnt;
                                        endVal = this._measureDt.posision;
                                    }
                                    else if (cCnt > this._measureDt.posision) {
                                        endVal = maxLvlLen.length;
                                        initVal = cCnt;
                                        isBreak = true;
                                    }
                                    for (var ml = initVal; ml < endVal; ml++)
                                        spnWtMsr += maxLvlLen[ml];
                                    if (rwHeaders[rCnt][cCnt + 1] && rwHeaders[rCnt][cCnt + 1].LName.toLowerCase().indexOf("[measures]") > -1 && maxLvlLen[cCnt] > 1) {
                                        isBreak = true;
                                        spnWtMsr -= rwHeaders[rCnt][cCnt].LNum;

                                    }
                                    tempColSpan = spnWtMsr;
                                }
                                else if (rwHeaders[rCnt][cCnt].LNum == 0 && !rwHeaders[rCnt][cCnt].LName.toLowerCase().indexOf("[measures]") > -1) { // inside the condtion - rwHeaders[rCnt][cCnt].LNum == 0

                                    var prev = 0, corColPos = 0;
                                    if (rCnt > 0 && cCnt > 0 && rwHeaders[rCnt][cCnt].LName.indexOf("(All)") > -1 && rwHeaders[rCnt][cCnt - 1] && maxLvlLen[cCnt - 1] > 1)
                                        prev = this._findPreviousMember(rwHeaders, rCnt, cCnt - 1);
                                    if (rCnt != 0 && rwHeaders[rCnt][cCnt - 1] && maxLvlLen[cCnt - 1] > 1 && rwHeaders[rCnt + prev] && rwHeaders[rCnt][cCnt - 1].LNum < rwHeaders[rCnt + prev][cCnt - 1].LNum)
                                        sumCnt = maxLvlLen[cCnt - 1] - rwHeaders[rCnt][cCnt - 1].LNum;
                                    if (curAxis == "rowheader") {
                                        tempColSpan = this._indexRCell - spanLvlPos + sumCnt;
                                        corColPos = this._indexRCell - tempColSpan;
                                    }
                                    else if (curAxis == "colheader") {
                                        tempColSpan = this._indexCCell - spanLvlPos + sumCnt;
                                        corColPos = this._indexCCell - tempColSpan;
                                    }
                                    if ((maxLvlLen.length != 1 && cCnt == rILen - 1) || (maxLvlLen.length > 1 && cCnt < rILen - 1))
                                        isBreak = true;

                                    if (this._measureDt.axis == curAxis) {
                                        tempColSpan -= 1;
                                    }
                                    var preLlen, maxLn, cspan = 1;
                                    if (rCnt != 0 && rwHeaders[rCnt][cCnt - 1])
                                        preLlen = rwHeaders[rCnt][cCnt - 1].LNum + 1;
                                    var incr = 1, prev = rCnt + cILen;
                                    this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos - sumCnt] = { CSS: "summary " + summaryAxis, Value: "Total", ColSpan: tempColSpan, RowSpan: 1, HUName: "", LName: "", UName: "", LNum: "", MemberType: "", ChildCount: "", Span: this._isNoSummary ? "Block" : "None" };

                                    // Below commentted lines are used for total spanning in row

                                    //while (this.pivotEngine[rCnt + cILen - incr][cCnt + lLen - 1 + levPos] && this.pivotEngine[rCnt + cILen - incr][cCnt + lLen - 1 + levPos].CSS.indexOf("summary") > -1
                                    //&& this.pivotEngine[rCnt + cILen - incr][cCnt + lLen - 1 + levPos].ColSpan == tempColSpan)
                                    //{
                                    //    incr++;
                                    //}
                                    //if (incr > 1)
                                    //    this.pivotEngine[rCnt + cILen - incr + 1][cCnt + lLen - 1 + levPos].RowSpan = incr;
                                }
                                //this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos - sumCnt] = { CSS: "summary " + summaryAxis, Value: "Total", ColSpan: tempColSpan, RowSpan: 1, HUName: "", LName: "", UName: "", LNum: "", MemberType: "", ChildCount: "" };
                            }
                            else if (rwHeaders[rCnt][cCnt].LName.toLowerCase().indexOf("[measures]") != -1) {
                                if (!(rwHeaders[rCnt - 1] && rwHeaders[rCnt - 1][cCnt].UName == rwHeaders[rCnt][cCnt].UName)) {
                                    this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos] = $.extend({},rwHeaders[rCnt][cCnt]);
                                    if (this._isNoSummary && totIndexInfo[rCnt].type == "total")
                                        this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos].Span = "Block";
                                }

                                if (rwHeaders[rCnt - 1] && rwHeaders[rCnt - 1][cCnt].UName != rwHeaders[rCnt][cCnt].UName || (rCnt + 1 == rLen)) {
                                    rSCnt = rSpanCalc[cCnt][lLen];
                                    if (this._isNoSummary) {
                                        rSCnt += noSumSpanCalc[cCnt][lLen];
                                        noSumSpanCalc[cCnt][lLen] = 0;
                                    }
                                    if (rSCnt && this.pivotEngine[rCnt + cILen - rSCnt][cCnt + lLen - 1 + levPos] != undefined) {
                                        this.pivotEngine[rCnt + cILen - rSCnt][cCnt + lLen - 1 + levPos].RowSpan += rSpanCalc[cCnt][lLen];
                                        this._drilledJSONData(rCnt + cILen - rSCnt, rCnt + cILen, cCnt + lLen - 1 + levPos, rwHeaders[rCnt][cCnt]);
                                    }
                                    rSpanCalc[cCnt][lLen] = 0;
                                }
                            }
                            else if(totIndexInfo[rCnt].type == "total" && rwHeaders.length == 1)
                            {
                                this.pivotEngine[rCnt + cILen][cCnt + lLen - 1 + levPos] = { CSS: "summary " + summaryAxis, Value: "Total", ColSpan: 1, RowSpan: 1, HUName: "", LName: "", UName: "", LNum: "", MemberType: "", ChildCount: "", Span: this._isNoSummary ? "Block" : "None" };
                            }
                        }

                       
                        if (isBreak)
                            break;
                    }
                else 
                    this.pivotEngine[rCnt + cILen][cCnt] = rwHeaders[rCnt][cCnt];
        },
        _findNextMember: function (rHeader, row, col)
        {
            var inc = 0, isParent = false;
            while (rHeader[row + inc] && rHeader[row][col].UName == rHeader[row + inc][col].UName)
            {
                inc++;
            }
            return inc;
        },
        _findPreviousMember: function (rHeader, row, col) {
            var inc = -1, isParent = false;
            while (rHeader[row + inc] && rHeader[row][col].UName == rHeader[row + inc][col].UName) {
                inc--;
            }
            return inc;
        },
        _drilledJSONData: function (start, end, col, data) {
            for (var st = start + 1; st < end; st++) {
                
                this.pivotEngine[st][col] = $.extend({},data);
                if (this._isNoSummary)
                    this.pivotEngine[st][col].Span = "Block";
            }
        },
        _setClassName: function (valueCell) {
            var val = parseInt(valueCell.Value), cssVal = "value";
            if (valueCell.kpi)
                if (valueCell.kpi == "trend") {
                    switch(val)
                    {
                        case -1:
                            cssVal = "value kpiiconvalue kpidownarrow";
                            break;
                        case 0:
                            cssVal = "value kpiiconvalue kpirightarrow";
                            break;
                        case 1:
                            cssVal = "value kpiiconvalue kpiuparrow";
                            break;
                    }
           
                }
                
                else if (valueCell.kpi == "status") {
                    switch (val) {
                        case -1:
                            cssVal = "value kpiiconvalue kpidiamond";
                            break;
                        case 0:
                            cssVal = "value kpiiconvalue kpitriangle";
                            break;
                        case 1:
                            cssVal = "value kpiiconvalue kpicircle";
                            break;
                    }
                }
            
            return valueCell.summary+" " + cssVal;
        },
        _getFieldItemsInfo: function (controlObj) {
            var conStr = this._getConnectionInfo(controlObj.model.dataSource.data);
             var pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>MDSCHEMA_HIERARCHIES</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + controlObj.model.dataSource.catalog + "</CATALOG_NAME><CUBE_NAME>" + controlObj.model.dataSource.cube + "</CUBE_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + controlObj.model.dataSource.catalog + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier></PropertyList></Properties></Discover></Body></Envelope>";
             controlObj.doAjaxPost("POST", conStr.url, { XMLA: pData }, this._getHierarchyInfo, null, { pvtGridObj: controlObj, action: "loadFieldElements" });
        },
        _getHierarchyInfo: function (customArgs, args) {
            var hierarchyElements = [];
            var controlObj = customArgs.pvtGridObj, conStr = this._getConnectionInfo(controlObj.model.dataSource.data);
            for (var i = 0; i < $(args).find("row").length; i++) {
                var element = $($(args).find("row")[i]);
                hierarchyElements.push({ pid: element.find("DIMENSION_UNIQUE_NAME").text(), id: element.find("HIERARCHY_UNIQUE_NAME").text(), name: element.find("HIERARCHY_CAPTION").text(), tag: element.find("HIERARCHY_UNIQUE_NAME").text(), hasAllMember: (element.children("ALL_MEMBER").length == 0) ? true : false });
            }

            controlObj["_fieldData"] = { hierarchy: hierarchyElements, hierarchySuccess: (args), measures: [] };
            if (!(conStr.LCID.indexOf("1033") >= 0) || controlObj.model.enableDrillThrough) {
                var pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>MDSCHEMA_MEASURES</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + controlObj.model.dataSource.catalog + "</CATALOG_NAME><CUBE_NAME>" + controlObj.model.dataSource.cube + "</CUBE_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + controlObj.model.dataSource.catalog + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier> </PropertyList></Properties></Discover></Body></Envelope>";
                controlObj.doAjaxPost("POST", conStr.url, { XMLA: pData }, this._getMeasureInfo, null, { pvtGridObj: controlObj, action: "loadFieldElements" });
            }
        },
        _getMeasureInfo: function (customArgs, e) {
            var measureData = [];
            for (var i = 0; i < $(e).find("row").length; i++) {
                var element = $($(e).find("row")[i]), measureGRPName = element.children("MEASUREGROUP_NAME").text(), measureUQName = element.find("MEASURE_UNIQUE_NAME").text();
                measureData.push({ id: measureUQName, pid: measureGRPName, name: element.children("MEASURE_CAPTION").text(), tag: measureUQName });
            }
            customArgs.pvtGridObj._fieldData["measures"] = measureData;
            customArgs.pvtGridObj._fieldData["measureSuccess"] = e;
        },
        _getConnectionInfo: function (connectionString) {
            var connectionInfo = { url: "", LCID: "1033" };
            if (connectionString != "")
            {
                $.map(connectionString.split(";"), function (obj, index) {
                    if (obj.toLowerCase().indexOf("locale") < 0 && connectionInfo.url.length==0) {
                        connectionInfo.url = obj;
                    }
                    else if (obj.toLowerCase().indexOf("locale") >= 0) {
                        connectionInfo.LCID = obj.replace(/ /g, "").split("=")[1];//obj.split(";")[0]
                    }
                });
            }
            return connectionInfo;
        },

        _applyTrim: function (controlObj) {
            var fieldInfo = [], dataSource = controlObj.model.dataSource, me = this;
            if (controlObj["_fieldData"] && controlObj._fieldData.measures && controlObj._fieldData.hierarchy) {
                $.merge(fieldInfo, controlObj._fieldData.hierarchy);
                $.merge(fieldInfo, controlObj._fieldData.measures);
            }
            else
                controlObj["_fieldData"] && controlObj._fieldData.hierarchy ? controlObj._fieldData.hierarchy : [];

            dataSource.rows = $.map(dataSource.rows, function (obj, index) {
                if (!ej.isNullOrUndefined(obj) && obj.fieldName != undefined) {
                    obj.fieldName = $.trim(obj.fieldName);
                    return me._getCaption(obj, fieldInfo);
                }
            });
            dataSource.columns = $.map(dataSource.columns, function (obj, index) {
                if (!ej.isNullOrUndefined(obj) && obj.fieldName != undefined) {
                    obj.fieldName = $.trim(obj.fieldName);
                    return me._getCaption(obj, fieldInfo); 
                }
            });
            dataSource.filters = $.map(dataSource.filters, function (obj, index) {
                if (!ej.isNullOrUndefined(obj) && obj.fieldName != undefined) {
                    obj.fieldName = $.trim(obj.fieldName);
                   return me._getCaption(obj, fieldInfo);
                }
            });
            dataSource.values = dataSource.values.length > 0 && dataSource.values[0]["measures"] != undefined ? dataSource.values : [{ measures: [], axis: "columns" }];
            dataSource.values[0]["measures"] = $.map(dataSource.values[0]["measures"], function (obj, index) {
                if (!ej.isNullOrUndefined(obj) && obj.fieldName != undefined) {
                    obj.fieldName = $.trim(obj.fieldName);
                    return me._getCaption(obj, fieldInfo);
                }
            });

            controlObj.model.dataSource = dataSource;
        },

        _getCaption: function (fieldItem, fieldInfo) {
            var fieldName = fieldItem.fieldName, captionInfo=[];
            if (fieldInfo.length > 0) {
                captionInfo = $.map(fieldInfo, function (obj, index) { if (obj.tag != undefined && obj.tag.toLowerCase() == $.trim(fieldName.toLowerCase())) { return obj; } });
                if (fieldName.toLowerCase().indexOf("[measures]") >= 0 && captionInfo.length == 0 && fieldName.split(".[").length > 0)
                    fieldItem["fieldCaption"] = fieldName.split(".[")[1].replace(/]/g, "");
                else if (captionInfo.length > 0) {
                    fieldItem["hasAllMember"] = captionInfo[0]["hasAllMember"] ? true : false;
                    fieldItem["fieldCaption"] = captionInfo[0].name;
                }
            }
            else if (captionInfo.length==0)
                fieldItem["fieldCaption"] = fieldName;
            return fieldItem;
        },
        clearDrilledItems: function (dataSource, args,ctrlObj) {
            var action = args.action;
            dataSource.rows = $.grep(dataSource.rows, function (value) {
                (value.filterItems != undefined && action != "filtering") ? delete value.filterItems : value;
                (value.filterItems != undefined && action != "advancedFilter") ? delete value.advancedFilter : value;
                (value.drilledItems != undefined) ? delete value.drilledItems : value; return value;
            });
            dataSource.columns = $.grep(dataSource.columns, function (value) {
                (value.filterItems != undefined && action != "filtering") ? delete value.filterItems : value;
                (value.filterItems != undefined && action != "advancedFilter") ? delete value.advancedFilter : value;
                (value.drilledItems != undefined) ? delete value.drilledItems : value; return value;
            });
            dataSource.filters = $.grep(dataSource.filters, function (value) {
                (value.filterItems != undefined && action != "filtering") ? delete value.filterItems : value;
                (value.filterItems != undefined && action != "advancedFilter") ? delete value.advancedFilter : value;
                (value.drilledItems != undefined) ? delete value.drilledItems : value; return value;
            });
            if (action != "filtering") {
                ctrlObj._currentReportItems = $.map(ctrlObj._currentReportItems, function (obj, index)
                {
                    if (!(ej.isNullOrUndefined(obj.dataSrc))) {
                        if ((obj.dataSrc.cube == dataSource.cube)) {
                            if (!(obj.dataSrc.reportName == dataSource.reportName))
                                return obj;
                        }
                        else
                            return obj;
                    }
                });
                if (!ej.isNullOrUndefined(ctrlObj._schemaData))
                    ctrlObj._schemaData.element.find(".filter").remove();
            }
           ej.olap.base._clearDrilledCellSet();
            return dataSource;
        },
       
    },
    ej.olap._mdxParser =
        {
            _getRowMDX: function (olapReport) {

                var rowElements = $(olapReport)[0].rows, rowQuery = "", measureQuery = "", updateQuery = [], isSorted = false, isDrilled = false, isCollapse = olapReport["_isCollapse"];
                var isMeasureAxis = olapReport["values"].length > 0 && olapReport["values"][0]["measures"] != undefined && olapReport["values"][0]["axis"] == ej.olap.AxisName.Row;
                if (ej.isNullOrUndefined(olapReport.providerName) || olapReport.providerName == ej.olap.Providers.SSAS) {
                    if (rowElements.length > 0) {
                        isDrilled = ej.isNullOrUndefined(rowElements[0].drillCellInfo) ? false : true;
                        for (var i = 0; i < rowElements.length; i++) {

                            var isNamedSet = (ej.isNullOrUndefined(rowElements[i]["isNamedSets"]) || !rowElements[i]["isNamedSets"]) ? false : true, dimensionQuery = "", p_dimensionQuery = "";

                            if (rowElements[i].fieldName != undefined && !isNamedSet) {

                                dimensionQuery = this._getDimensionQuery(rowElements[i], olapReport, "rows", i, false);
                                updateQuery.push(dimensionQuery.replace(/["'\(\)]/g, "").replace(/["'\{\}]/g, "").replace(/\levels0/g, "levels(0)"));

                                if (ej.olap.base._isPaging && isDrilled) {
                                    p_dimensionQuery = this._getDimensionQuery(rowElements[i], olapReport, "rows", i, true);
                                }

                                if (rowElements[i]["sortOrder"] && rowElements[i]["sortOrder"] != ej.olap.SortOrder.None) {
                                    var sortOrder = rowElements[i]["sortOrder"] == ej.olap.SortOrder.Ascending ? "asc" : "desc"; isSorted = true;
                                    rowQuery = rowQuery + (i > 0 ? "*" : "") + "{ORDER({HIERARCHIZE({" + ((ej.olap.base._isPaging && isDrilled) ? p_dimensionQuery : dimensionQuery) + "})}," + rowElements[i].fieldName + ".CurrentMember.MEMBER_CAPTION," + sortOrder + ")}";
                                }
                                else
                                    rowQuery = rowQuery + (i > 0 ? "*" : "") + "{HIERARCHIZE({({" + ((ej.olap.base._isPaging && isDrilled) ? p_dimensionQuery : dimensionQuery) + "})})}";
                            }
                            else if (isNamedSet) {
                                rowQuery = i > 0 ? rowQuery + "*" + "{" + rowElements[i].fieldName + "}" : "{" + rowElements[i].fieldName + "}";
                            }
                        }

                        if (ej.olap.base._isPaging) {
                            this._updateOlapReport($(olapReport)[0].rows, rowQuery, "rows", updateQuery)
                        }
                        if (isCollapse)
                            isSorted = isCollapse;
                        rowQuery = (!isSorted ? " HIERARCHIZE " : " ") + "( {" + (ej.olap.base._isPaging ? rowQuery : this._updateOlapReport($(olapReport)[0].rows, rowQuery, "rows", updateQuery)) + "})";
                        if (isCollapse)
                            rowQuery = "HIERARCHIZE(" + rowQuery + ")";
                    }
                    if (isMeasureAxis) {
                        measureQuery = ej.olap._mdxParser._getMeasuresQuery(olapReport);
                        rowQuery = rowQuery != "" ? (ej.olap.base._isPaging ? rowQuery.slice(0, -1) : rowQuery) + ((rowQuery != "" && measureQuery != "") ? (ej.olap.base._isPaging ? "*" : ",") : "") + measureQuery : (ej.olap.base._isPaging ? (measureQuery != "" ? "(" : "") : "") + measureQuery;
                    }
                    if (ej.olap.base._isPaging) {
                        rowQuery = rowQuery != "" ? (measureQuery == "" ? (rowQuery[rowQuery.length - 1] != "}" ? rowQuery.slice(0, -1) : rowQuery) + this._getDrilledSection(olapReport, $.extend(true, {}, rowElements), "row", measureQuery) + ")" : rowQuery + this._getDrilledSection(olapReport, $.extend(true, {}, rowElements), "row", measureQuery) + ")") : "";
                    }
                }
                else
                {
                    rowQuery = this._generateAxisMDXOnMondrian(olapReport, rowElements, isMeasureAxis);
                }
                return rowQuery;
            },
            _generateAxisMDXOnMondrian: function (olapReport, rowElements, isMeasureAxis)
            {
                var axisQuery = "", decendants, fElements;
                for (var i = 0; i < rowElements.length; i++) {
                    var reportEl = "DrillDownLevel({" + rowElements[i].fieldName + "})";
                    if (!ej.isNullOrUndefined(rowElements[i].drilledItems) && rowElements[i].drilledItems.length > 0) {
                        reportEl = this._getDrilledMDXOnMondrian(rowElements[i].drilledItems, reportEl);
                    }
                    if (!ej.isNullOrUndefined(rowElements[i].filterItems) && !ej.isNullOrUndefined(rowElements[i].filterItems.values) && rowElements[i].filterItems.values.length > 0)
                    {
                        decendants = "Descendants(" + rowElements[i].fieldName + "," + olapReport._maxLevel + ", SELF_AND_BEFORE)";
                        fElements = "{" + rowElements[i].filterItems.values.join() + "}";
                        reportEl = "({{hierarchize(Union(Intersect((Except(" + decendants + "," + fElements + "))," + reportEl + ")," + "Except(" + reportEl + "," + fElements + ")))}})"
                    }
                    axisQuery += (axisQuery == "" ? "" : "*") + reportEl;
                   
                }
                if (isMeasureAxis) {
                    axisQuery += (axisQuery == "" ? "" : "*") + ej.olap._mdxParser._getMeasuresQuery(olapReport);
                }
                return axisQuery;
            },
            _getDrilledMDXOnMondrian: function (dItems, drillQuery) {
               // var dItems = rowElements.drilledItems;
                for (var ln = 0; ln < dItems.length; ln++)
                {
                    drillQuery = "DrillDownMember(" + drillQuery + ", {" + dItems[ln].join() + "})";
                }
                return drillQuery;
            },
            _getcolumnMDX: function (olapReport) {

                var colElements = $(olapReport)[0].columns, columnQuery = "", measureQuery = "", updateQuery = [], isSorted = false, isDrilled = false,  isCollapse = olapReport["_isCollapse"];
                var isMeasureAxis = olapReport["values"].length > 0 && olapReport["values"][0]["measures"] != undefined && olapReport["values"][0]["axis"] == ej.olap.AxisName.Column;
                if (ej.isNullOrUndefined(olapReport.providerName) || olapReport.providerName == ej.olap.Providers.SSAS) {

                    if (colElements.length > 0) {
                        isDrilled = ej.isNullOrUndefined(colElements[0].drillCellInfo) ? false : true;
                        for (var i = 0; i < colElements.length; i++) {
                            var isNamedSet = (ej.isNullOrUndefined(colElements[i]["isNamedSets"]) || !colElements[i]["isNamedSets"]) ? true : false, isSorted = false, dimensionQuery = "", p_dimensionQuery = "";

                            if (colElements[i].fieldName != undefined && isNamedSet) {

                                dimensionQuery = this._getDimensionQuery(colElements[i], olapReport, "columns", i, false);
                                updateQuery.push(dimensionQuery.replace(/["'\(\)]/g, "").replace(/["'\{\}]/g, ""));

                                if (ej.olap.base._isPaging && isDrilled) {
                                    p_dimensionQuery = this._getDimensionQuery(colElements[i], olapReport, "columns", i, true);
                                }

                                if (colElements[i]["sortOrder"] && colElements[i]["sortOrder"] != ej.olap.SortOrder.None) {
                                    var sortOrder = colElements[i]["sortOrder"] == ej.olap.SortOrder.Ascending ? "asc" : "desc", isSorted = true;;
                                    columnQuery = columnQuery + (i > 0 ? "*" : "") + "{ ORDER ({HIERARCHIZE ({" + ((ej.olap.base._isPaging && isDrilled) ? p_dimensionQuery : dimensionQuery) + "})}," + colElements[i].fieldName + ".CurrentMember.MEMBER_CAPTION," + sortOrder + ")}";
                                }
                                else
                                    columnQuery = columnQuery + (i > 0 ? "*" : "") + "{" + ((ej.olap.base._isPaging && isDrilled) ? p_dimensionQuery : dimensionQuery) + "}";
                            }
                            else
                                columnQuery = i > 0 ? columnQuery + "*" + "{" + colElements[i].fieldName + "}" : "{" + colElements[i].fieldName + "}";
                        }
                        if (ej.olap.base._isPaging && isDrilled) {
                            this._updateOlapReport($(olapReport)[0].columns, columnQuery, "columns", updateQuery)
                        }
                        if (isCollapse)
                            isSorted = isCollapse;
                        columnQuery = (!isSorted ? " HIERARCHIZE " : " ") + "( {" + (ej.olap.base._isPaging ? columnQuery : this._updateOlapReport(colElements, columnQuery, "columns", updateQuery)) + "})";
                        if (isCollapse)
                            columnQuery = "HIERARCHIZE(" + columnQuery + ")";
                    }

                    if (isMeasureAxis) {
                        measureQuery = ej.olap._mdxParser._getMeasuresQuery(olapReport);
                        columnQuery = columnQuery != "" ? ((ej.olap.base._isPaging ? columnQuery.slice(0, -1) : columnQuery) + ((columnQuery != "" && measureQuery != "") ? (ej.olap.base._isPaging ? "*" : ",") : "") + measureQuery) : (ej.olap.base._isPaging ? (measureQuery != "" ? "(" : "") : "") + measureQuery;
                    }
                    if (ej.olap.base._isPaging) {
                        columnQuery = columnQuery != "" ? (measureQuery == "" ? (columnQuery[columnQuery.length - 1] != "}" ? columnQuery.slice(0, -1) : columnQuery) + this._getDrilledSection(olapReport, $.extend(true, {}, colElements), "column", measureQuery) + ")" : columnQuery + this._getDrilledSection(olapReport, $.extend(true, {}, colElements), "column", measureQuery) + ")") : "";
                    }
                }
                else
                {
                    columnQuery = this._generateAxisMDXOnMondrian(olapReport, colElements, isMeasureAxis);
                }
                return columnQuery;
            },

            _getDrilledSection: function (olapReport, reportElements, axis, measureQuery) {
                var query = "", reportElements = reportElements;
                $.each(reportElements, function (index, val) {
                    if (!ej.isNullOrUndefined(val.drilledItems)) {
                        $.each(val.drilledItems, function (dindex, dval) {
                            var aQuery = "", sQuery = "";
                            $.each(dval, function (curIndex, curValue) {
                                aQuery = aQuery == "" ? ("{" + curValue + "}") : (aQuery + "*" + "{" + curValue + "}");
                                curValue = curIndex == index ? curValue.replace(".children", "") : curValue;
                                sQuery = sQuery == "" ? ("{" + curValue + "}") : (sQuery + "*" + "{" + curValue + "}");
                            })
                            if (measureQuery != "") {
                                aQuery = aQuery + "*" + measureQuery;
                                sQuery = sQuery + "*" + measureQuery;
                            }
                            query = query == "" ? "+{" + aQuery + "}" + "-{" + sQuery + "}" : query + "+{" + aQuery + "}" + "-{" + sQuery + "}";
                        })
                    }
                })
                return query;
            },

            _getSortedMembers: function (obj, reportInfo) {
                var fieldName = obj.fieldName, sortElement = [];
                if (obj["sortOrder"] && obj["sortOrder"] != ej.olap.SortOrder.None) {
                    var order = obj["sortOrder"] == "ascending" ? "asc" : "desc";
                    sortElement = $.map(obj["drilledItems"], function (items, i) {
                        var sortData = $.map(items, function (element, i) {
                            if (element.indexOf(fieldName) >= 0)
                                element = "order ( " + element + " , " + fieldName + ".CurrentMember.MEMBER_CAPTION," + order + ")"
                            return element;
                        });
                        return sortData;
                    });
                    return sortElement;
                }
                else
                    return obj["drilledItems"];
            },

            _updateOlapReport: function (reportInfo, dimensionSet, axis, updateQuery) {
                var me = this;
                if (axis == "rows") {
                    var drillRowInfo = $.map(reportInfo, function (obj, index) {
                        if (reportInfo[index]["drilledItems"] != undefined) {
                            return me._getSortedMembers(obj, reportInfo);
                        }
                    });
                    if (ej.olap.base._isRowDrilled && "rows" == ej.olap.base._currIndex["axis"] && reportInfo[ej.olap.base._currIndex.Index] != undefined && reportInfo[ej.olap.base._currIndex.Index]["drilledItems"] != undefined) {
                        var members = $.map(updateQuery, function (obj, index) { if (obj.indexOf("DrillDownlevel") >= 0) obj = obj.replace("DrillDownlevel", "DrillDownlevel(") + ")"; return obj; });
                        reportInfo[ej.olap.base._currIndex.Index]["drilledItems"].push(members);
                        ej.olap.base._isRowDrilled = false;
                    }
                    else if (drillRowInfo.length > 0 && (ej.olap.base._currIndex["axis"] == undefined || (ej.olap.base._currIndex["axis"] == "columns" && !ej.olap.base._isRowDrilled)))
                        dimensionSet = this._getDrillQuery(drillRowInfo, dimensionSet, reportInfo);

                    if (!ej.isNullOrUndefined(ej.olap.base._currIndex["axis"]) && ej.olap.base._currIndex["axis"] == "rows")
                        ej.olap.base._currIndex = {};

                }
                else {
                    var drillColInfo = $.map(reportInfo, function (obj, index) {
                        if (reportInfo[index]["drilledItems"] != undefined) {
                            return me._getSortedMembers(obj, reportInfo);
                        }
                    });
                    if (ej.olap.base._isColDrilled && "columns" == ej.olap.base._currIndex["axis"] && reportInfo[ej.olap.base._currIndex.Index] != undefined && reportInfo[ej.olap.base._currIndex.Index]["drilledItems"] != undefined) {
                        var members = $.map(updateQuery, function (obj, index) { if (obj.indexOf("DrillDownlevel") >= 0) obj = obj.replace("DrillDownlevel", "DrillDownlevel(") + ")"; return obj; });
                        reportInfo[ej.olap.base._currIndex.Index]["drilledItems"].push(members);
                        ej.olap.base._isColDrilled = false;
                    }
                    else if (drillColInfo.length > 0 && (ej.olap.base._currIndex["axis"] == undefined || (ej.olap.base._currIndex["axis"] == "rows" && !ej.olap.base._isColDrilled))) {
                        dimensionSet = this._getDrillQuery(drillColInfo, dimensionSet, reportInfo);
                    }
                    if (!ej.isNullOrUndefined(ej.olap.base._currIndex["axis"]) && ej.olap.base._currIndex["axis"] == "columns")
                        ej.olap.base._currIndex = {};
                }
                return dimensionSet;
            },


            _getDrillQuery: function (drilledInfo, mdx, report) {
                var query = "";
                for (var i = 0; i < drilledInfo.length; i++) {
                    if (!(drilledInfo[i][drilledInfo[i].length - 1].toLowerCase().indexOf(".children") >= 0) && !(drilledInfo[i][drilledInfo[i].length - 1].toLowerCase().indexOf("drilldownlevel") >= 0) && !(drilledInfo[i][drilledInfo[i].length - 1].toLowerCase().indexOf("members") >= 0)) {
                        drilledInfo[i][drilledInfo[i].length - 1] = drilledInfo[i][drilledInfo[i].length - 1] + ".children";
                    }
                    if (drilledInfo[i].length != report.length) {
                        var temp = $.map(report, function (obj, index) {
                            if (obj.fieldName != undefined && obj.fieldName != drilledInfo[i][[drilledInfo[i].length - 1]].split(".").splice(0, 2).join("."))
                                return { uniqueName: ej.olap.base._isPaging ? "(" + $.trim(obj.fieldName) + ").children" : "DrillDownLevel(" + $.trim(obj.fieldName) + ")", fieldName: $.trim(obj.fieldName) };
                        });
                        for (var j = 0; j < temp.length; j++) {
                            var pos = this._getItemPosition(report, temp[j].fieldName)[0];
                            if (!(drilledInfo[i].toString().indexOf(temp[j].fieldName) >= 0))
                                drilledInfo[i].splice(pos, 0, temp[j].uniqueName);
                        }
                        query = query + "" + (i > 0 ? "," : "") + "\n (" + drilledInfo[i] + ")";
                    }
                    else
                        query = query + "" + (i > 0 ? "," : "") + "\n (" + drilledInfo[i].toString() + ")\n";
                }
                return "(" + mdx + ")," + query
            },

			_createDrillThroughQuery: function (text, args) {
			    if (args.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
			        args._waitingPopup.show();
			        args.doAjaxPost("POST", args.model.url + "/" + args.model.serviceMethodSettings.drillThroughDataTable, JSON.stringify({ "currentReport": ($(args.element).parents(".e-pivotclient").length > 0 || $(args.element).length > 0) ? args.currentReport : JSON.parse(args.getOlapReport()).Report, "layout": args.model.layout, "cellPos": "", "selectorValue": text }), function (args) {
			            this._trigger("drillThrough", { element: args.element, data: args });
			        });
			        args._waitingPopup.hide();
			    }
			    else {
			        var measureGrpName = args.measureGrp, measure = "";
			        var drillQuery = "DRILLTHROUGH Select(" + args._colHeader.join() + "," + args._rowHeader.join() + ") on 0 from [" + args.model.dataSource.cube + "] RETURN";
			        $.map(args._fieldData.measures, function (obj, index) { if (obj.pid == measureGrpName) measure += measure == "" ? "[" + measureGrpName + "]." + obj.id.split(".")[1] : ",[" + measureGrpName + "]." + obj.id.split(".")[1] })
			        drillQuery += (text != "" && !ej.isNullOrUndefined(text)) ? " " + measure + "," + text : " " + measure;
			        drillQuery = drillQuery.replace(/&/g, "&amp;");
			        var conStr = args._getConnectionInfo(args.model.dataSource.data);
			        pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"> <Header></Header> <Body> <Execute xmlns=\"urn:schemas-microsoft-com:xml-analysis\"> <Command> <Statement> " + drillQuery + " </Statement> </Command> <Properties> <PropertyList> <Catalog>" + args.model.dataSource.catalog + "</Catalog> </PropertyList> </Properties></Execute> </Body> </Envelope>";
			        args.doAjaxPost("POST", conStr.url, { XMLA: pData }, ej.Pivot._generateDrillData, null, { pvtGridObj: args, action: "loadFieldElements" });
			    }
            },

			_getDimensionQuery: function (dimElement, report, axis, index, isDrillOnPaging) {

                var dimQuery = "";
                if (dimElement["drillCellInfo"] != undefined && !isDrillOnPaging) {
                    dimQuery = "{(" + dimElement["drillCellInfo"].uniqueName + ")}";
                    delete dimElement.drillCellInfo;
                }
                else {
                    if (ej.isNullOrUndefined(dimElement.hasAllMember) || !dimElement.hasAllMember) {
                        dimQuery = ej.olap.base._isPaging ? "((" + $.trim(dimElement.fieldName) + ").children)" : "DrillDownlevel((" + $.trim(dimElement.fieldName) + "))";
                    }
                    else
                        dimQuery = "((" + $.trim(dimElement.fieldName) + ").levels(0).members)";
                }
                return dimQuery
            },

			_updateReport: function (members, cellInfo, reportItem, pvtGridObj) {
			    var isMondrian = pvtGridObj.model.dataSource.providerName == ej.olap.Providers.Mondrian, preRepIm, drilledCol, args = {};
			    if (isMondrian) {
			        var itmPos;
			        preRepIm = cellInfo.preRepItm.split(">#>");
			        itmPos = cellInfo.itemPosition;
			        if (itmPos)
			            drilledCol = cellInfo.previousElements.split(preRepIm[itmPos - 1])[1].split("][").length;
			        else
			            drilledCol = cellInfo.previousElements.split("][").length;
			        if (reportItem.drilledItems) {
			            if (reportItem.drilledItems.length <= (drilledCol -1))
			                reportItem.drilledItems[drilledCol - 1] = [];
			            if (cellInfo.action && cellInfo.action == "collapse")
			            {
			                reportItem.drilledItems[drilledCol - 1] = $.grep(reportItem.drilledItems[drilledCol - 1], function (ele) {
			                    return ele != preRepIm[itmPos];
			                });
			            }
                        else
			                reportItem.drilledItems[drilledCol - 1].push(preRepIm[itmPos]);
			        }
			    }
			    else {
			        reportItem["drillCellInfo"] = $.extend({}, cellInfo);
			        reportItem["drillCellInfo"].uniqueName = "(" + $.trim(reportItem["drillCellInfo"].uniqueName) + ".children)";
			        args = { action: "drilldown", cellInfo: cellInfo };
			    }
                ej.olap.base.getJSONData(args, pvtGridObj.model.dataSource, pvtGridObj);
            },
            
            _splitCellInfo: function (args) {
                var spliceLn = ej.olap.base.olapCtrlObj.model.dataSource.providerName == ej.olap.Providers.Mondrian ? 1 : 2;
                if (args) 
                var cellInfo = {
                    hierarchyUniqueName: args.split("::")[1].split(".").splice(0, spliceLn).join("."),
                    uniqueName: args.split("::")[0],//.replace(/\&/g, "&amp;")
                    levelUniqueName: args.split("::")[1],
                    leveName: args.split("::")[2],
                    parentUniqueName: args.split("::")[3],//.replace(/\&/g, "&amp;")
                };
                return cellInfo
            },

            updateDrilledReport: function (args, currentAxis, pvtGridObj) {
                if (ej.olap.base._isPaging && !ej.isNullOrUndefined(pvtGridObj._pagingSavedObjects.curDrilledItem)) {
                    pvtGridObj._pagingSavedObjects.curDrilledItem = args;
                }
                var me = ej.olap._mdxParser, reportItem = null, cellInfo, fieldItems, prevItems = "", preRepItm = "", reportInfo, axis,
                    isMondrian = pvtGridObj.model.dataSource.providerName == ej.olap.Providers.Mondrian;
                cellInfo = this._splitCellInfo(args.uniqueName);
                cellInfo.targetUName = args.uniqueName,
                cellInfo.previousElements = "";

                fieldItems = (currentAxis == "rowheader") ? pvtGridObj.model.dataSource.rows : (currentAxis == "colheader") ? pvtGridObj.model.dataSource.columns : null;

                if (fieldItems.length > 0) {
                    reportInfo = $.map(fieldItems, function (obj, index) { if (obj.fieldName != undefined && ($.trim(obj.fieldName).toLowerCase() == $.trim(cellInfo.hierarchyUniqueName).toLowerCase())) return { report: obj, index: index }; });
                    reportItem = reportInfo[0].report;
                    cellInfo.itemPosition = reportInfo[0].index;
                    var currentIndex = $.map(pvtGridObj._pivotRecords.records, function (obj, index) { if (obj.Info.replace(/&/g, "&amp;") == args.uniqueName) return obj.Index; });

                    reportItem.drilledItems != undefined ? reportItem.drilledItems : reportItem["drilledItems"] = [];
                    ej.olap.base._currIndex = { axis: (currentAxis == "rowheader") ? "rows" : "columns", Index: reportInfo[0].index };

                    if (pvtGridObj.pluginName == "ejPivotChart" || pvtGridObj.pluginName == "ejPivotTreeMap" || ej.isNullOrUndefined(args.index)) {
                        cellInfo.cellIndex = currentIndex.length > 0 ? "" : args.index;
                        cellInfo.axis = axis = currentAxis;
                        (currentAxis != "rowheader") ? ej.olap.base._isColDrilled = ((args["action"] != undefined && args.action == "collapse") ? false : true) : ej.olap.base._isRowDrilled = ((args["action"] != undefined && args.action == "collapse") ? false : true);
                        for (var i = 0; i < pvtGridObj.model.dataSource.rows.length; i++) {
                            if (args.seriesInfo[i] == args.uniqueName)
                                break;
                            else
                                pvtGridObj.model.dataSource.rows[i]["drillCellInfo"] = this._splitCellInfo(args.seriesInfo[i]);
                        }

                        cellInfo.previousElements = "", cellInfo["preRepItm"] = "";
                        for (var i = 0; i < args.uniqueNameArray.length; i++)
                            cellInfo.previousElements += this._splitCellInfo(args.uniqueNameArray[i]).uniqueName;
                        for (var i = 0; i < args.seriesInfo.length; i++)
                            cellInfo.preRepItm += cellInfo.preRepItm == "" ? this._splitCellInfo(args.seriesInfo[i]).uniqueName : ">#>" + this._splitCellInfo(args.seriesInfo[i]).uniqueName;
                    }
                    else {
                        cellInfo.cellIndex = args.index;
                        var currentHierarchyName = cellInfo.hierarchyUniqueName,
                            axis = "", prevItems = "", currCellInfo = "",
                            colPos = cellInfo.cellIndex.split(",")[0],
                            rowPos = cellInfo.cellIndex.split(",")[1];

                        if (!(currentAxis == "rowheader")) {
                            axis = "colheader"; ej.olap.base._isColDrilled = (args["action"] != undefined && args.action == "collapse") ? false : true;

                            for (var i = parseInt(rowPos) ; i >= 0; i--) {

                                if (!pvtGridObj._pivotRecords.records[parseInt((colPos * pvtGridObj._pivotRecords.rowCount) + parseInt(i))].Info.indexOf(currentHierarchyName) >= 0) {
                                    currCellInfo = pvtGridObj._pivotRecords.records[parseInt((colPos * pvtGridObj._pivotRecords.rowCount) + parseInt(i))].Info;
                                    var headerUn = this._splitCellInfo(currCellInfo);
                                    if (headerUn) prevItems = headerUn.uniqueName + ">#>" + prevItems;
                                    if (currCellInfo != "" && !(currCellInfo.indexOf(currentHierarchyName) >= 0)) {
                                        var headerDrillInfo = this._splitCellInfo(currCellInfo);
                                        headerDrillInfo.uniqueName = headerDrillInfo.uniqueName.replace(/&/g, "&amp;")
                                        preRepItm = headerDrillInfo.uniqueName + preRepItm;
                                        currReport = $.map(fieldItems, function (obj, index) { if (obj.fieldName != undefined && ($.trim(obj.fieldName).toLowerCase() == $.trim(headerDrillInfo.hierarchyUniqueName).toLowerCase())) return index; });
                                        if (args.action != "collapse")
                                            pvtGridObj.model.dataSource.columns[currReport[0]]["drillCellInfo"] = headerDrillInfo;
                                        currentHierarchyName = headerDrillInfo.hierarchyUniqueName;
                                    }
                                }
                            }
                        }
                        else {
                            axis = "rowheader"; ej.olap.base._isRowDrilled = (args["action"] != undefined && args.action == "collapse") ? false : true;
                            for (var i = parseInt(colPos) ; i >= 0; i--) {
                                if (!pvtGridObj._pivotRecords.records[parseInt((i * pvtGridObj._pivotRecords.rowCount) + parseInt(colPos))].Info.indexOf(currentHierarchyName) >= 0) {
                                    currCellInfo = pvtGridObj._pivotRecords.records[parseInt((i * pvtGridObj._pivotRecords.rowCount) + parseInt(rowPos))].Info;
                                    var headerUn = this._splitCellInfo(currCellInfo);
                                    if (headerUn) prevItems = headerUn.uniqueName + prevItems;
                                    if (currCellInfo != "" && !(currCellInfo.indexOf(currentHierarchyName) >= 0)) {
                                        var headerDrillInfo = this._splitCellInfo(currCellInfo);
                                        headerDrillInfo.uniqueName = headerDrillInfo.uniqueName.replace(/&/g, "&amp;");
                                        preRepItm = headerDrillInfo.uniqueName + ">#>" + preRepItm;
                                        currReport = $.map(fieldItems, function (obj, index) { if (obj.fieldName != undefined && ($.trim(obj.fieldName).toLowerCase() == $.trim(headerDrillInfo.hierarchyUniqueName).toLowerCase())) return index; });
                                        if (args.action != "collapse")
                                            pvtGridObj.model.dataSource.rows[currReport[0]]["drillCellInfo"] = headerDrillInfo;
                                        currentHierarchyName = headerDrillInfo.hierarchyUniqueName;
                                    }
                                }
                            }
                        }
                        //prevItems = cellInfo.uniqueName + ">#>" + prevItems;
                        preRepItm += cellInfo.uniqueName;
                        cellInfo.previousElements = prevItems.replace(/&amp;/g, "&");
                        cellInfo.preRepItm = preRepItm.replace(/&amp;/g, "&");
                        cellInfo.axis = axis;
                    }
                    cellInfo.previousElements = cellInfo.previousElements.replace(/&amp;/g, "&");
                    cellInfo.preRepItm = cellInfo.preRepItm.replace(/&amp;/g, "&");
                    if (!args.action) {
                        var drilledMem = ej.olap.base._getDrilledMemeber({ item: cellInfo });
                        //if (drilledMem.length)
                           // ej.olap.base._onDemandCollapse({ drilledMembers: drilledMem, action: "collapse" }, axis);
                        ej.olap._mdxParser._updateReport(reportItem.drilledItems, cellInfo, reportItem, pvtGridObj);
                    }
                    else if (args.action) {
                        if (isMondrian) {
                            cellInfo.action = "collapse";
                            ej.olap._mdxParser._updateReport(reportItem.drilledItems, cellInfo, reportItem, pvtGridObj);
                            return;
                        }
                        var drilledMem = ej.olap.base._getDrilledMemeber({ item: cellInfo });
                        if (drilledMem.length && !ej.olap.base._isPaging)
                            ej.olap.base._onDemandCollapse({ drilledMembers: drilledMem, action: args.action }, axis);
                        else {
                            while (drilledMem.length != 0) {
                                ej.olap.base.olapCtrlObj.model.dataSource = ej.olap._mdxParser._clearCollapsedItems(axis, drilledMem[drilledMem.length - 1], ej.olap.base.olapCtrlObj.model.dataSource);
                                drilledMem = drilledMem.splice(0, drilledMem.length - 1);
                            }
                            ej.olap.base.getJSONData(args, ej.olap.base.olapCtrlObj.model.dataSource, ej.olap.base.olapCtrlObj);
                        }
                    }
                    else {
                        var clonedEl = $(args.drilledMember).clone(true);
                        ej.olap.base._onDemandExpand({ action: "drilldown", cellInfo: cellInfo, isExist: true }, args.drilledMember);
                    }
                }
            },
            _clearCollapsedItems: function (dragAxis, headerText, dataSource) {
                if (dragAxis == "rowheader") {
                    dataSource.rows = $.map(dataSource.rows, function (value) { 
                        if ((value.drilledItems != undefined) && value.drilledItems.length){
                            value.drilledItems = $.map(value.drilledItems, function (values) { if (values.join("").indexOf(headerText.repItms.replace(/&/g, "&amp;")) < 0) return [values]; });
                        }
                        return value;
                    });
                }
                else if (dragAxis == "colheader") {
                    dataSource.columns = $.map(dataSource.columns, function (value) {
                        if ((value.drilledItems != undefined) && value.drilledItems.length) {
                            value.drilledItems = $.map(value.drilledItems, function (values) {
                                if (values.join("").indexOf(headerText.repItms.replace(/&/g, "&amp;")) < 0)
                                    return [values];
                            });
                        }
                        return value;
                    });
                }
                return dataSource;
            },
             _getSlicerMDX: function (olapReport, pvtGridObj) {
                 var filterElements = $(olapReport)[0].filters, dimensionSet = "", me = this, fieldData = pvtGridObj["_fieldData"],
                     isMondrian = olapReport.providerName == ej.olap.Providers.Mondrian, gridEle = $.merge($.merge([], olapReport.columns), olapReport.rows);
                for (var i = 0; i < filterElements.length; i++) {
                    var iscol = $.grep(gridEle, function (value) {
                        var colUN = me._getDimensionUniqueName(value.fieldName, fieldData), filtUN = me._getDimensionUniqueName(filterElements[i].fieldName, fieldData), isMatch = false;
                        isMatch = colUN == filtUN && !(isMondrian && filtUN == "" && colUN == "");
                        return isMatch;
                    }).length > 0;
                    //if(!iscol)
                       // iscol = $.grep($(olapReport)[0].rows, function (value) { return me._getDimensionUniqueName(value.fieldName, fieldData) == me._getDimensionUniqueName(filterElements[i].fieldName, fieldData); }).length > 0;
                    if (!iscol) {
                        if (filterElements[i].fieldName != undefined && filterElements[i].filterItems == undefined)
                            dimensionSet = dimensionSet + (dimensionSet != "" ? "*" : "") + "{" + this._getDimensionQuery(filterElements[i]) + "}"; //i > 0
                        else if (filterElements[i].filterItems != undefined) {
                            dimensionSet = dimensionSet + (dimensionSet != "" ? "*" : "") + "{" + (filterElements[i].filterItems.values.toString()) + "}";
                        }
                    }
                }
                return dimensionSet!="" ? "where (" + dimensionSet.replace(/DrillDownlevel/g, "") + ")" : "";
            },

             _getDimensionUniqueName: function (headerText, fieldData) {
                var _hierarchyNodes = fieldData.hierarchy;
                if (_hierarchyNodes)
                {
                    var parentUniqueName = $.map(_hierarchyNodes, function (obj, index) {  if (obj.id.toLowerCase() == headerText.toLowerCase()) { return obj.pid; }});
                    return parentUniqueName.length > 0 ? parentUniqueName[0] : "";
                }
                else
                    return headerText.split(".")[0];
            },
            _getMeasuresQuery: function (olapReports) {

                var valueElements = $(olapReports)[0].values, valueQueryArr = [], query = "", axisName = "";
                if(valueElements.length>0)
                {
                    var measureInfo = jQuery.map(valueElements, function (n, i) { if (n["measures"] != undefined) return { measureElements: n["measures"], Index: i, axisName: n["axis"] }; });
                    var measureQuery = measureInfo.length > 0 ? $.map(measureInfo[0]["measureElements"], function (x) {
                        return x.fieldName;
                    }) : null;
                    (measureQuery != null) ? valueQueryArr.push({ values: measureQuery, Index: measureInfo[0].Index }) : valueQueryArr;
                    axisName = valueElements["axis"];
                }
                query = $.map(valueQueryArr, function (x) {
                    return x.values.toString();
                });
                 return query[0] != "" ? "{" + query + "}" : "";
            },

            _getIncludefilterQuery: function (report, cube, pvtGridObj) {
                var filterQuery = "FROM [" + cube + "]", query = "FROM ( SELECT (", rowFilter, columnFilter, fieldData = pvtGridObj["_fieldData"];
                var advancedFilterQuery = [], filterAxis = "COLUMNS";
                if (report.providerName == ej.olap.Providers.Mondrian)
                    return filterQuery;
                rowFilter = $.map($(report.rows), function (field, i) { if (field.filterItems != undefined) return [field.filterItems.values];});
                columnFilter = $.map($(report.columns), function (field, i) { if (field.filterItems != undefined) return [field.filterItems.values]; });

                for (var i = 0; i < report.filters.length; i++) {
                    var filterElements = report.filters, me = this ,isFound=false;
                    $.map(report.columns, function (value, index) {
                        if (me._getDimensionUniqueName(value.fieldName, fieldData) == me._getDimensionUniqueName(filterElements[i].fieldName, fieldData)) {
                            if (filterElements[i].filterItems != undefined) {
                                columnFilter.push(filterElements[i].filterItems.values);
                                isFound = true;
                            }
                        }
                    });
                    if(!isFound)
                    $.map(report.rows, function (value, index) {
                        if (me._getDimensionUniqueName(value.fieldName, fieldData) == me._getDimensionUniqueName(filterElements[i].fieldName, fieldData)) {
                            if (filterElements[i].filterItems != undefined)
                                rowFilter.push(filterElements[i].filterItems.values);
                        }
                    });
                }
                if (report.enableAdvancedFilter) {
                    for (var i = 0; i <= report.columns.length - 1; i++) {
                        if (report.columns[i].advancedFilter) { $.merge(advancedFilterQuery, (this._getAdvancedFilterQuery(report.columns[i], query, filterAxis))); }
                    }
                    for (var i = 0; i <= report.rows.length - 1; i++) {
                        if (report.rows[i].advancedFilter)
                            $.merge(advancedFilterQuery, (this._getAdvancedFilterQuery(report.rows[i], query, filterAxis)));
                    }
                }
                for (var i = 0; i <= columnFilter.length - 1; i++)
                    query = i == 0 ? query + "{" + columnFilter[i].toString() + "}" : query + ",{" + columnFilter[i].toString() + "}";

                if (columnFilter.length > 0)
                    query = (rowFilter.length > 0) ? query + " ) on COLUMNS " + ",(" : query + " ) on COLUMNS ";

                for (var i = 0; i <= rowFilter.length - 1; i++)
                    query = (i > 0) ? query + ",{" + rowFilter[i].toString() + "}" : query + "{" + rowFilter[i].toString() + "}";

                query = (columnFilter.length > 0 && rowFilter.length > 0) ? query = query + ") on ROWS " : (columnFilter.length == 0 && rowFilter.length > 0) ? query + ") on COLUMNS " : query;
                if (advancedFilterQuery.length > 0) {
                    advancedFilterQuery = ((columnFilter.length > 0 || rowFilter.length > 0) ? query : "") + " " + advancedFilterQuery.join(" ") + " " + filterQuery + Array(advancedFilterQuery.length + 1 + columnFilter.length + rowFilter.length).join(")");
                }
                filterQuery = (columnFilter.length == 0 && rowFilter.length == 0) ? filterQuery : query + filterQuery + ")";
                return (advancedFilterQuery.length > 0) ? advancedFilterQuery : filterQuery;
            },
            _getAdvancedFilterQuery: function (fieldItem, query, currentAxis) {
                var filterQuery = [], me = this;
                $.map(fieldItem.advancedFilter, function (filterItem, index) {
                    if (!(ej.isNullOrUndefined(filterItem["labelFilterOperator"]) && filterItem["labelFilterOperator"]==ej.olap.LabelFilterOptions.None &&
                          ej.isNullOrUndefined(filterItem["valueFilterOperator"]) &&  filterItem["valueFilterOperator"]==ej.olap.ValueFilterOptions.None )) {
                        filterQuery.push("FROM (SELECT Filter(" + $.trim(filterItem.name) + ".AllMembers, " + me._getAdvancedFilterCondtions(fieldItem.fieldName,
                            ((filterItem["advancedFilterType"] == ej.olap.AdvancedFilterType.LabelFilter || ej.isNullOrUndefined(filterItem["advancedFilterType"])) ? filterItem["labelFilterOperator"] : filterItem["valueFilterOperator"]),
                            filterItem.values,
                            filterItem["advancedFilterType"], filterItem["measure"]) + ")) on " + currentAxis);
                    }
                });
                return filterQuery;
            },

            _getAdvancedFilterCondtions: function (fieldName, filterOperator, values, filterType, measures) {
                var advancedFilterQuery = "", filterType=ej.isNullOrUndefined(filterType)?"label":filterType;
                switch (filterOperator.toLowerCase()) {
                    case "equals":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption =\"" + values[0] + "\"") : (measures + " = " + values[0]));
                        break;
                    case "notequals":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &lt;&gt;\"" + values[0] + "\"") : (measures + " &lt;&gt;" + values[0]));
                        break;
                    case "contains":
                        advancedFilterQuery = "( InStr (1," + fieldName + ".CurrentMember.member_caption,\"" + values[0] + "\")&gt;0";
                        break;
                    case "notcontains":
                        advancedFilterQuery = "( InStr (1," + fieldName + ".CurrentMember.member_caption,\"" + values[0] + "\")=0";
                        break;
                    case "beginswith":
                        advancedFilterQuery = "( Left (" + fieldName + ".CurrentMember.member_caption," + values[0].length + ")=\"" + values[0] + "\"";
                        break;
                    case "notbeginswith":
                        advancedFilterQuery = "( Left (" + fieldName + ".CurrentMember.member_caption," + values[0].length + ")&lt;&gt;\"" + values[0] + "\"";
                        break;
                    case "endswith":
                        advancedFilterQuery = "( Right (" + fieldName + ".CurrentMember.member_caption," + values[0].length + ")=\"" + values[0] + "\"";
                        break;
                    case "notendswith":
                        advancedFilterQuery = "( Right (" + fieldName + ".CurrentMember.member_caption," + values[0].length + ")&lt;&gt;\"" + values[0] + "\"";
                        break;
                    case "greaterthan":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &gt;\"" + values[0] + "\"") : (measures + " &gt;" + values[0] + ""));
                        break;
                    case "greaterthanorequalto":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &gt;=\"" + values[0] + "\"") : (measures + " &gt;=" + values[0] + ""));
                        break;
                    case "lessthan":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &lt;\"" + values[0] + "\"") : (measures + " &lt;" + values[0] + ""));
                        break;
                    case "lessthanorequalto":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &lt;=\"" + values[0] + "\"") : (measures + " &lt;=" + values[0] + ""));
                        break;
                    case "between":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &gt;=\"" + values[0] + "\"AND " + fieldName + ".CurrentMember.member_caption &lt;=\"" + values[1] + "\"") : (measures + " &gt;=" + values[0] + " AND " + measures + "&lt;=" + values[1]));
                        break;
                    case "notbetween":
                        advancedFilterQuery = "(" + (filterType != "value" ? (fieldName + ".CurrentMember.member_caption &gt;=\"" + values[0] + "\"OR " + fieldName + ".CurrentMember.member_caption &lt;=\"" + values[1] + "\"") : (measures + " &gt;=" + values[0] + " OR " + measures + "&lt;=" + values[1]));
                        break;
                    default:
                        advancedFilterQuery = "( InStr (1," + fieldName + ".CurrentMember.member_caption,\"" + values[0] + "\")&gt;0";
                        break;
                }

                return advancedFilterQuery;
            },
            _getItemPosition: function (report, element) {
                return $.map(report, function (obj, index) {
                    if (obj.fieldName != undefined && $.trim(obj.fieldName) == $.trim(element))
                    { return index; }
                })
            },

            getAllMember: function (dataSource, fieldName, controlObj) {
                var mdxQuery = "select {" + fieldName + "} dimension properties CHILDREN_CARDINALITY on 0 from [" + $.trim(dataSource.cube) + "]";
                var xmla = ej.olap._mdxParser.getSoapMsg(mdxQuery, dataSource.data, dataSource.catalog);
                var conStr = ej.olap.base._getConnectionInfo(dataSource.data);
                controlObj.doAjaxPost("POST", conStr.url, { XMLA: xmla }, controlObj._generateAllMember, null, { action: "loadFieldElements" });
            },

            getMembers: function (dataSource, fieldName, controlObj) {
                var reportItem = ej.Pivot.getReportItemByFieldName(fieldName, dataSource).item, dimProp = "dimension properties CHILDREN_CARDINALITY, MEMBER_TYPE";
                if (!ej.isNullOrUndefined(controlObj.model.pivotControl) && controlObj.model.pivotControl.model.dataSource.providerName == ej.olap.Providers.Mondrian) {
                    this._controlObj = controlObj.model.pivotControl;
                }
                // var mdxQuery = "select {" + ((reportItem  && reportItem["hasAllMember"]) ? fieldName + ".levels(0).members" : fieldName + ".children") + "} dimension properties CHILDREN_CARDINALITY on 0 from [" + $.trim(dataSource.cube) + "]";
                var mdxQuery = "select {" + ((reportItem && reportItem["hasAllMember"]) ? fieldName + ".levels(0).members" : fieldName + ".children") + "}" + dimProp +" on 0 from [" + $.trim(dataSource.cube) + "]";
                var xmla = ej.olap._mdxParser.getSoapMsg(mdxQuery, dataSource.data, dataSource.catalog);
                var conStr = ej.olap.base._getConnectionInfo(dataSource.data);
                //if (!ej.isNullOrUndefined(controlObj.model.pivotControl) && controlObj.model.pivotControl.model.enableMemberEditorPaging) {
                //    this._memberCount = controlObj.doAjaxPost("POST", conStr.url, { XMLA: xmla }, controlObj._generateMembers, null, { action: "loadFieldElements" });
                //    mdxQuery = "WITH SET [AllDimensions] as {" + ((reportItem > 0 && reportItem["hasAllMember"]) ? fieldName + ".levels(0).members" : fieldName + ".children") + "} SELECT { Subset([AllDimensions]," + controlObj.model.pivotControl._memberPageSettings.startPage + "," + controlObj.model.pivotControl.model.memberEditorPageSize + ")} DIMENSION PROPERTIES MEMBER_UNIQUE_NAME on 0, {} ON 1 from [" + $.trim(dataSource.cube) + "]";
                //    xmla = ej.olap._mdxParser.getSoapMsg(mdxQuery, dataSource.data, dataSource.catalog, dsInfo);
                //}
                controlObj.doAjaxPost("POST", conStr.url, { XMLA: xmla }, controlObj._generateMembers, null, { action: "fetchMembers" });
            },
            getChildren: function (dataSource, memberUQName, controlObj) {
                var mdxQuery = "select {" + memberUQName + ".children} dimension properties CHILDREN_CARDINALITY on 0 from [" + dataSource.cube + "]", parentCnt = controlObj.model.pivotControl;
                if (!ej.isNullOrUndefined(parentCnt) && parentCnt.model.dataSource.providerName == ej.olap.Providers.Mondrian)
                    this._controlObj = controlObj.model.pivotControl;
                var xmlaData = ej.olap._mdxParser.getSoapMsg(mdxQuery, dataSource.data, dataSource.catalog);
                var conStr = ej.olap.base._getConnectionInfo(dataSource.data);
                controlObj.doAjaxPost("POST", conStr.url, { XMLA: xmlaData }, ej.Pivot.generateChildMembers, null, { action: "nodeExpand", currentNode: memberUQName });
            },
            getSoapMsg: function (mdx, url, catlogName) {
                var conStr = ej.olap.base._getConnectionInfo(url), dsInfo = "", isMondrain = false, xmlMsg;
                if (!ej.isNullOrUndefined(this["_controlObj"]))
                {
                    dsInfo = this._controlObj.model.dataSource.sourceInfo
                    xmlMsg = "<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"><SOAP-ENV:Body><Execute xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><Command><Statement><![CDATA[" + mdx + "]]></Statement></Command><Properties><PropertyList><DataSourceInfo>" + dsInfo + "</DataSourceInfo><Catalog>" + catlogName + "</Catalog><AxisFormat>TupleFormat</AxisFormat><Content>Data</Content><Format>Multidimensional</Format></PropertyList></Properties></Execute></SOAP-ENV:Body></SOAP-ENV:Envelope>";
                    delete this["_controlObj"];
                }
                else
                    xmlMsg = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"> <Header></Header> <Body> <Execute xmlns=\"urn:schemas-microsoft-com:xml-analysis\"> <Command> <Statement> " + mdx + " </Statement> </Command> <Properties> <PropertyList> <Catalog>" + catlogName + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier></PropertyList> </Properties> </Execute> </Body> </Envelope>";
                return xmlMsg
            }
        },
   
     ej.olap.SortOrder = {
         None: "none",
         Ascending: "ascending",
         Descending: "descending"
     }
    ej.olap.Providers = {
        SSAS: "ssas",
        Mondrian:"mondrian"
    }
    ej.olap.AdvancedFilterType = {
        LabelFilter: "label",
        ValueFilter: "value"
    }

    ej.olap.ValueFilterOptions = {
        None: "none",
        Equals: "equals",
        NotEquals: "notequals",
        GreaterThan: "greaterthan",
        GreaterThanOrEqualTo: "greaterthanorequalto",
        LessThan: "lessthan",
        LessThanOrEqualTo: "lessthanorequalto",
        Between: "between",
        NotBetween: "notbetween"
    }

    ej.olap.LabelFilterOptions = {
        None: "none",
        BeginsWith: "beginswith",
        NotBeginsWith: "notbeginswith",
        EndsWith: "endswith",
        NotEndsWith: "notendswith",
        Contains: "contains",
        NotContains: "notcontains",
        Equals: "equals",
        NotEquals: "notequals",
        GreaterThan: "greaterthan",
        GreaterThanOrEqualTo: "greaterthanorequalto",
        LessThan: "lessthan",
        LessThanOrEqualTo: "lessthanorequalto",
        Between: "between",
        NotBetween: "notbetween"
        
    }

    ej.olap.AxisName = {
        Row: "rows",
        Column: "columns"
    };
})(jQuery, Syncfusion);
;
(function ($, ej, undefined) {

    ej.PivotAnalysis = {

        _initProperties: function () {
            this._colKeysCalcValues = [];
            this._rowKeysCalcValues = [];
            this._tableKeysCalcValues = [];
            this._gridMatrix = null;
            this._rowTotCalc = [];
            this._colTotCalc = [];
            this._transposeEngine = [];
            this._tRowCnt = 0;
            this._tColCnt = 0;
            this._cellType = "";
            this._valueFilterArray = ej.isNullOrUndefined(this._valueFilterArray) ? [] : this._valueFilterArray;
            this._currentFilterVal = {};
            this._fieldMembers = {};
            this._summaryTypes = [];
            this._editCellsInfo = [];
            this._locale = "en-US";
            this._valueSorting = ej.isNullOrUndefined(this._valueSorting) ? null : this._valueSorting;
            this._sort = ej.isNullOrUndefined(this._sort) ? null : this._sort;
        },

        setFieldCaptions: function (dataSource) {
            $.each(dataSource.rows, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
            $.each(dataSource.columns, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
            $.each(dataSource.filters, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
            $.each(dataSource.values, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
        },

        getTreeViewData: function (dataSource) {
            var pivotFieldList = new Array(), treeViewData = new Array();
            if (dataSource.data != null) {
                for (var i = 0; i < dataSource.data.length; i++) {
                    jQuery.each(dataSource.data[i], function (fieldName, value) {
                        if ((jQuery.inArray(fieldName, pivotFieldList)) == -1)
                            pivotFieldList.push(fieldName);
                    });
                }
            }
            jQuery.each(dataSource.values, function (item, value) {
                if (value.isCalculatedField == true && (jQuery.inArray(value.fieldName, pivotFieldList)) == -1)
                    pivotFieldList.push(value.fieldName);
            });

            var multipleArrays = [dataSource.rows, dataSource.columns, dataSource.filters, dataSource.values];
            var singleArray = [].concat.apply([], multipleArrays);
            for (var i = 0; i < pivotFieldList.length; i++) {
                for (var j = 0; j < singleArray.length; j++) {
                    if ((pivotFieldList[i]["caption"] == undefined || pivotFieldList[i]["caption"] == "") && (singleArray[j].fieldName == pivotFieldList[i]))
                        pivotFieldList[i] = { name: singleArray[j].fieldName, caption: singleArray[j].fieldCaption, format: singleArray[j].format, formatString: singleArray[j].formatString, showSubTotal: !ej.isNullOrUndefined(singleArray[j].showSubTotal) ? singleArray[j].showSubTotal : true };
                }
                if (pivotFieldList[i]["caption"] == undefined || pivotFieldList[i]["caption"] == "")
                    pivotFieldList[i] = { name: pivotFieldList[i].name || pivotFieldList[i], caption: pivotFieldList[i].name || pivotFieldList[i] };
            }
            for (var t = 0; t < pivotFieldList.length; t++) {
                var checkedState = $.grep(dataSource.rows, function (item) { return item.fieldName == pivotFieldList[t].name; }).length > 0 || $.grep(dataSource.columns, function (item) { return item.fieldName == pivotFieldList[t].name; }).length > 0 || $.grep(dataSource.values, function (item) { return item.fieldName == pivotFieldList[t].name; }).length > 0 || $.grep(dataSource.filters, function (item) { return item.fieldName == pivotFieldList[t].name; }).length > 0;
                treeViewData.push({ id: pivotFieldList[t].name, name: pivotFieldList[t].name, caption: pivotFieldList[t].caption, format: pivotFieldList[t].format, formatString: pivotFieldList[t].formatString, showSubTotal: !ej.isNullOrUndefined(pivotFieldList[t].showSubTotal) ? pivotFieldList[t].showSubTotal : true, isSelected: checkedState, spriteCssClass: "" });
            }
            return treeViewData;
        },

        pivotEnginePopulate: function (model) {
            var dataSource = model.dataSource, currentObj = this, isLiteral = false;
            this._initProperties();
            if ( model.dataSource.enableAdvancedFilter && this._valueFilterArray.length == 0)
            {
                this._valueFilterArray = $.grep(dataSource.columns, function (item) { if (item.advancedFilter && item.advancedFilter.length > 0 && item.advancedFilter[0].advancedFilterType == ej.Pivot.AdvancedFilterType.ValueFilter) return item.advancedFilter; });
                var rowFilters = $.grep(dataSource.rows, function (item) { if (item.advancedFilter && item.advancedFilter.length > 0 && item.advancedFilter[0].advancedFilterType == ej.Pivot.AdvancedFilterType.ValueFilter) return item.advancedFilter; });
				if(rowFilters.length>0)
                  $.merge(this._valueFilterArray, rowFilters);
            }
            this._locale = model.locale;
            var colAxis = dataSource.columns, rowAxis = dataSource.rows, filters = dataSource.filters, calcValues = dataSource.values, colLen, jsonObj = [], pivotFieldList = [], rowLen;
            for (var lit = 0; dataSource.values.length > lit; lit++)
            {
                var formatSt = "";
                if (dataSource.values[lit].format)
                    formatSt = dataSource.values[lit].format.toLowerCase();
                if (formatSt == "string" || formatSt == "text" || formatSt == "literal") {
                    isLiteral = true;
                    break;
                }
            }
            this._editCellsInfo = [];
            if (!ej.isNullOrUndefined(model.editCellsInfo)) {
                var rowHeaders = model.editCellsInfo.rowHeader, colHeaders = model.editCellsInfo.columnHeader, values = model.editCellsInfo.JSONRecords;

                if (!ej.isNullOrUndefined(values)) {
                    for (uV = 0; uV < values.length; uV++) {
                        var fields = {};
                        if (rowAxis.length > 0)
                            fields["row"] = rowHeaders[uV].toString().split('#').splice(0, rowAxis.length).join(".");
                        if (colAxis.length > 0)
                            fields["column"] = colHeaders[uV].toString().split('#').splice(0, colAxis.length).join(".");
                        fields["value"] = colHeaders[uV].toString().split('#')[colHeaders[uV].toString().split('#').length - 1] + "#" + values[uV].Value;
                        this._editCellsInfo.push(fields);
                    }
                    for (var vC = 0; vC < calcValues.length; vC++) {
                        $.each(this._editCellsInfo, function (index, val) {
                            if (calcValues[vC].fieldName == val["value"].split('#')[0])
                                ej.PivotAnalysis._editCellsInfo[index]["value"] = vC + "#" + val["value"].split('#')[1];
                        })
                    }
                }
            }

            for (var i = 0; i < calcValues.length; i++) this._summaryTypes.push(calcValues[i].summaryType != null && calcValues[i].summaryType != undefined ? calcValues[i].summaryType : ej.PivotAnalysis.SummaryType.Sum);
            if (dataSource.data != null) {
                var list;
                for (var cnt = 0; cnt < dataSource.data.length; cnt++) {
                    list = jQuery.extend(true, {}, dataSource.data[cnt]);
                    var table = { keys: [], uniqueName: "", value: null }, row = { keys: [], uniqueName: "", value: null }, col = { keys: [], uniqueName: "", value: null }, values = { keys: [], uniqueName: "", value: null };
                    var isExcluded = false;

                    for (var i = 0; i < filters.length; i++) {
                        var val = this._getReflectedValue(list, filters[i].fieldName, null, null);
                        if (this._fieldMembers[filters[i].fieldName] == undefined || this._fieldMembers[filters[i].fieldName] == null)
                            this._fieldMembers[filters[i].fieldName] = [val];
                        else if ($.inArray(val, this._fieldMembers[filters[i].fieldName]) == -1)
                            this._fieldMembers[filters[i].fieldName].push(val);
                        if (filters[i].filterItems != null && filters[i].filterItems != undefined) {
                            if (((filters[i].filterItems.filterType == ej.PivotAnalysis.FilterType.Exclude || filters[i].filterItems.filterType == null) && $.inArray(val != null ? val.toString() : val, filters[i].filterItems.values) >= 0) || (filters[i].filterItems.filterType == ej.PivotAnalysis.FilterType.Include && $.inArray(val != null ? val.toString() : val, filters[i].filterItems.values) < 0)) {
                                isExcluded = true;
                                break;
                            }
                        }
                    }

                    for (var nC = 0; nC < calcValues.length; nC++) {
                        var val = "";
                        if (calcValues[nC] != undefined && calcValues[nC] != null) {
                            list[calcValues[nC].fieldName] = model.dataSource.isFormattedValues ? this._getNumber($(list).prop(calcValues[nC].fieldName), calcValues[nC].formatString) : list[calcValues[nC].fieldName];
                            val = this._getReflectedValue(list, calcValues[nC].fieldName, calcValues[nC].format, calcValues[nC].formatString);
                            if (this._fieldMembers[calcValues[nC].fieldName] == undefined || this._fieldMembers[calcValues[nC].fieldName] == null)
                                this._fieldMembers[calcValues[nC].fieldName] = [val];
                            else if ($.inArray(val, this._fieldMembers[calcValues[nC].fieldName]) == -1)
                                this._fieldMembers[calcValues[nC].fieldName].push(val);
                        }
                        var outputString = val != null ? val.toString().replace(/([AMPME~!@#$%^&*()_+=`{}\[\]\|\\:;'<>,-.\/? ])+/g, '') : "0";
                        outputString = outputString.replace(ej.globalize.preferredCulture(this._locale).numberFormat.currency.symbol, "");
                        if ($.isNumeric(outputString) || calcValues[nC].format == "date")
                            values.keys.push((val != null ? val : 0));
                        else {
                            values.keys.push(1);
                            if (isLiteral) {
                                if (values.uniqueName == "")
                                    values.uniqueName = [];
                                if (!ej.isNullOrUndefined(calcValues[nC].format) && (calcValues[nC].format.toLowerCase() == "string" || calcValues[nC].format.toLowerCase() == "literal" || calcValues[nC].format.toLowerCase() == "text")) {
                                    values.uniqueName.push(val);
                                }
                                else
                                    values.uniqueName.push(" ");
                            }
                        }
                    }

                    for (var rC = 0; rC < rowAxis.length; rC++) {
                        var val = "";
                        if (rowAxis[rC] != undefined && rowAxis[rC] != null) {
                            val = this._getReflectedValue(list, rowAxis[rC].fieldName, !ej.isNullOrUndefined(rowAxis[rC].format) ? rowAxis[rC].format : null, (!ej.isNullOrUndefined(rowAxis[rC].format) && !ej.isNullOrUndefined(rowAxis[rC].formatString)) ? rowAxis[rC].formatString : null);
                            if (this._fieldMembers[rowAxis[rC].fieldName] == undefined || this._fieldMembers[rowAxis[rC].fieldName] == null)
                                this._fieldMembers[rowAxis[rC].fieldName] = [val];
                            else if ($.inArray(val, this._fieldMembers[rowAxis[rC].fieldName]) == -1)
                                this._fieldMembers[rowAxis[rC].fieldName].push(val);

                            // Label filter implementation
                            if (dataSource.enableAdvancedFilter && !ej.isNullOrUndefined(rowAxis[rC].advancedFilter) && rowAxis[rC].advancedFilter.length && rowAxis[rC].advancedFilter[0].advancedFilterType == ej.Pivot.AdvancedFilterType.LabelFilter) {
                                var isFiltered = this._applyLabelFilter(rowAxis[rC].advancedFilter, val);
                                if (isFiltered) {
                                    isExcluded = true;
                                    break;
                                }
                            }
                            else if (rowAxis[rC].filterItems != null && rowAxis[rC].filterItems != undefined) {
                                if (((rowAxis[rC].filterItems.filterType == ej.PivotAnalysis.FilterType.Exclude || rowAxis[rC].filterItems.filterType == null) && $.inArray(val != null ? val.toString() : val, rowAxis[rC].filterItems.values) >= 0) || (rowAxis[rC].filterItems.filterType == ej.PivotAnalysis.FilterType.Include && $.inArray(val != null ? val.toString() : val, rowAxis[rC].filterItems.values) < 0)) {
                                    isExcluded = true;
                                    break;
                                }
                            }
                        }
                        if (val == null || !val.toString().replace(/^\s+|\s+$/gm, ''))
                            val = "(blank)";
                        row.keys.push(val)
                        row.uniqueName += (row.uniqueName == "" ? val : ("." + val));
                        table.keys.push(val);
                        table.uniqueName += (table.uniqueName == "" ? val : ("." + val));
                    }

                    for (var cC = 0; cC < colAxis.length; cC++) {
                        var val = "";
                        if (colAxis[cC] != undefined && colAxis[cC] != null) {
                            val = this._getReflectedValue(list, colAxis[cC].fieldName, !ej.isNullOrUndefined(colAxis[cC].format) ? colAxis[cC].format : null, (!ej.isNullOrUndefined(colAxis[cC].format) && !ej.isNullOrUndefined(colAxis[cC].formatString)) ? colAxis[cC].formatString : null);
                            if (this._fieldMembers[colAxis[cC].fieldName] == undefined || this._fieldMembers[colAxis[cC].fieldName] == null)
                                this._fieldMembers[colAxis[cC].fieldName] = [val];
                            else if ($.inArray(val, this._fieldMembers[colAxis[cC].fieldName]) == -1)
                                this._fieldMembers[colAxis[cC].fieldName].push(val);

                            // Label filter implementation
                            if (dataSource.enableAdvancedFilter && !ej.isNullOrUndefined(colAxis[cC].advancedFilter) && colAxis[cC].advancedFilter.length && colAxis[cC].advancedFilter[0].advancedFilterType == ej.Pivot.AdvancedFilterType.LabelFilter) {
                                var isFiltered = this._applyLabelFilter(colAxis[cC].advancedFilter, val);
                                if (isFiltered) {
                                    isExcluded = true;
                                    break;
                                }
                            }
                            else if (colAxis[cC].filterItems != null && colAxis[cC].filterItems != undefined) {
                                if (((colAxis[cC].filterItems.filterType == ej.PivotAnalysis.FilterType.Exclude || colAxis[cC].filterItems.filterType == null) && $.inArray(val != null ? val.toString() : val, colAxis[cC].filterItems.values) >= 0) || (colAxis[cC].filterItems.filterType == ej.PivotAnalysis.FilterType.Include && $.inArray(val != null ? val.toString() : val, colAxis[cC].filterItems.values) < 0)) {
                                    isExcluded = true;
                                    break;
                                }
                            }
                        }
                        if (val == null || !val.toString().replace(/^\s+|\s+$/gm, ''))
                            val = "(blank)";
                        col.keys.push(val);
                        col.uniqueName += (col.uniqueName == "" ? val : ("." + val));
                        table.keys.push(val);
                        table.uniqueName += (table.uniqueName == "" ? val : ("." + val));
                    }

                    if (!isExcluded) {
                        this._isMemberExist("row", row, $.extend(true, {}, values), dataSource);
                        this._isMemberExist("column", col, $.extend(true, {}, values), dataSource);
                        this._isMemberExist("calc", table, $.extend(true, {}, values), dataSource);
                    }


                }
            }

            for (var i = 0; i < calcValues.length; i++) {
                var temp = $.grep(calcValues, function (value) { return (value.isCalculatedField == true) });
                if (calcValues[i].isCalculatedField && temp.length != calcValues.length) {
                    for (var j = 0; j < this._tableKeysCalcValues.length; j++) {
                        var formula = calcValues[i].formula.replace(/\s/g, "");
                        for (var k = 0; k < calcValues.length; k++) {
                            if (calcValues[k].isCalculatedField != true) {
                                var value = ej.globalize.parseFloat(this._tableKeysCalcValues[j].value.keys[k] == null ? "0" : calcValues[k].format == "date" ? this._dateToInt(this._tableKeysCalcValues[j].value.keys[k].toString()).toString() : calcValues[k].format == "time" ? this._dateToInt(new Date("1900", this._tableKeysCalcValues[j].value.keys[k].toString().split(":")[0], this._tableKeysCalcValues[j].value.keys[k].toString().split(":")[1], this._tableKeysCalcValues[j].value.keys[k].toString().split(":")[2].split(" ")[0]).toString()).toString() : this._tableKeysCalcValues[j].value.keys[k].toString(),this._locale);
                                formula = formula.replace(new RegExp(calcValues[k].fieldName, 'g'), calcValues[k].format == "percentage" && value != 0 ? (value < 0 ? "(" + value / 100 + ")" : value) : (value < 0 ? "(" + value + ")" : value));
                            }
                        }
                        if (formula.indexOf("^") > -1)
                            formula = this._powerFunction(formula);
                        var oldValue = (!isNaN(eval(formula))) && isFinite(eval(formula)) ? this._getReflectedValue({ calcField: eval(formula) }, "calcField", calcValues[i].format, calcValues[i].formatString) : dataSource.values[i].format == null ? 0 : "0";
                        var newValue = dataSource.values[i].format == null ? 0 : "0";
                        this._tableKeysCalcValues[j].value.keys[i] = this._getSummaryValue(oldValue, newValue, 1, this._summaryTypes[i], dataSource.values[i].format, dataSource.values[i].formatString);
                    }
                }
                else if (calcValues[i].isCalculatedField) {
                    var val = { keys: [], uniqueName: "", value: null };
                    for (var j = 0; j < this._tableKeysCalcValues.length; j++) {
                        for (var k = 0; k < calcValues.length && calcValues[k].isCalculatedField; k++) {
                            var formula = calcValues[k].formula.replace(/\s/g, "");
                            if (formula.indexOf("^") > -1)
                                formula = this._powerFunction(formula);
                            var oldValue = (!isNaN(eval(formula))) && isFinite(eval(formula)) ? this._getReflectedValue({ calcField: eval(formula) }, "calcField", calcValues[k].format, calcValues[k].formatString) : dataSource.values[k].format == null ? 0 : "0";
                            var newValue = dataSource.values[k].format == null ? 0 : "0";
                            val.keys.push(this._getSummaryValue(oldValue, newValue, 1, "sum", dataSource.values[k].format, dataSource.values[k].formatString));
                        }
                        this._tableKeysCalcValues[j].value = val;
                        val = { keys: [], uniqueName: "", value: null };
                    }
                }
            }
            if (rowAxis.length > 0)
                this._rowKeysCalcValues = this._sortHeaders(this._rowKeysCalcValues, rowAxis, 0);
            if (colAxis.length > 0)
                this._colKeysCalcValues = this._sortHeaders(this._colKeysCalcValues, colAxis, 0);

            var colkeyvalues = $.extend([], this._colKeysCalcValues);
            var rowKeyValues = $.extend([], this._rowKeysCalcValues);
            if (colAxis.length > 0)
                this._insertTotalHeader(colAxis, this._colKeysCalcValues);
            if (rowAxis.length > 0)
                this._insertTotalHeader(rowAxis, this._rowKeysCalcValues);
            else if (calcValues.length > 0) {
                if (this._rowKeysCalcValues.length > 0)
                    this._rowKeysCalcValues[0].keys[0] = "Grand Total";
                else {
                    this._rowKeysCalcValues.push({ keys: [""], value: { keys: [] } });
                    for (var i = 0; i < calcValues.length; i++) {
                        this._rowKeysCalcValues[0].value.keys.push();
                    }
                    this._rowKeysCalcValues[0].keys[0] = "Grand Total";
                }
            }

            this._tRowCnt = 0, this._tColCnt = 0;
            this._currentFilterVal = this._valueFilterArray.length > 0 ? this._valueFilterArray[0] : {};
            this._calculateValues(dataSource);
            for (var i = 0; i < this._valueFilterArray.length; i++)
            {
                if (this._advancedFilterInfo.length > 0) {
                    var me = this;
                    this._rowKeysCalcValues = this._filterKeyValues(rowKeyValues);
                    this._colKeysCalcValues = this._filterKeyValues(colkeyvalues);
                    this._gridMatrix = null;
                    colkeyvalues = $.extend([], this._colKeysCalcValues);
                    rowKeyValues = $.extend([], this._rowKeysCalcValues);

                    if (colAxis.length > 0)
                        this._insertTotalHeader(colAxis, this._colKeysCalcValues);
                    if (rowAxis.length > 0)
                        this._insertTotalHeader(rowAxis, this._rowKeysCalcValues);
                    else if (calcValues.length > 0)
                        this._rowKeysCalcValues[0].keys[0] = "Grand Total";
                    this._tRowCnt = 0, this._tColCnt = 0;
                    if (this._valueFilterArray.length != i + 1)
                        this._currentFilterVal = this._valueFilterArray[i + 1];
                    else
                        this._currentFilterVal = {};
                    this._calculateValues(dataSource);
                }
            }
            var isColumnEmpty = (this._colKeysCalcValues.length == 1 && this._colKeysCalcValues[0].cellType == "RGTot");
            this._colTotCalc = [], this._rowTotCalc = [], this._colKeysCalcValues = []; this._rowKeysCalcValues = []; this._tableKeysCalcValues = [];
            this._transposeEngineCreation();
            if (!ej.isNullOrUndefined(model.valueSortSettings) && !ej.isNullOrUndefined(model.valueSortSettings.sortOrder) && model.valueSortSettings.sortOrder != "none" && model.dataSource.values.length > 0 && (!ej.isNullOrUndefined(this._valueSorting) || (!ej.isNullOrUndefined(model.valueSortSettings.headerText) && model.valueSortSettings.headerText != ""))) {
                var j = 0;
                model.valueSortSettings.headerDelimiters = model.valueSortSettings.headerDelimiters == undefined ? "##" : model.valueSortSettings.headerDelimiters;
                if (ej.isNullOrUndefined(this._valueSorting)) {
                    for (var i = 0; i < this._transposeEngine.length; i++) {
                        for (var k = 0; k < model.valueSortSettings.headerText.split(model.valueSortSettings.headerDelimiters).length; k++) {
                            if (!ej.isNullOrUndefined(this._transposeEngine[i][k]) && this._transposeEngine[i][k].Value == model.valueSortSettings.headerText.split(model.valueSortSettings.headerDelimiters)[k]) {
                                j++;
                            }
                        }
                        if (j == model.valueSortSettings.headerText.split(model.valueSortSettings.headerDelimiters).length) {
                            this._valueSorting = i;
                            break;
                        }
                        j = 0;
                    }
                    this._sort = (!ej.isNullOrUndefined(model.valueSortSettings) && !ej.isNullOrUndefined(model.valueSortSettings.sortOrder)) ? model.valueSortSettings.sortOrder : this._sort;
                    if ((model.dataSource.columns.length + 1) == model.valueSortSettings.headerText.split(model.valueSortSettings.headerDelimiters).length && !ej.isNullOrUndefined(this._valueSorting))
                        this._applyValueSorting(model);
                }
                else {
                    this._applyValueSorting(model);
                }                   
            }
            for (var rCnt = 0; rCnt < (this._tColCnt - 1) ; rCnt++) {
                rowAxis.length = rowAxis.length == 0 ? 1 : rowAxis.length;
                if (rCnt < rowAxis.length) {
                    var emptyCellColSpan = (isColumnEmpty ? 1 : colAxis.length) + (dataSource.values.length > 0 ? 1 : 0);
                    if (emptyCellColSpan == 0 && rowAxis.length > 0) emptyCellColSpan = 1;
                    for (var tcnt = 0; tcnt < emptyCellColSpan ; tcnt++) {
                        if (this._gridMatrix.length > 0)
                            jsonObj.push({
                                Index: rCnt + ',' + tcnt, CSS: "none", Value: "", State: 0,
                                ColSpan: ((rCnt == 0 && tcnt == 0) ? rowAxis.length : 1),
                                RowSpan: ((rCnt == 0 && tcnt == 0) ? (isColumnEmpty ? 1 : colAxis.length) + (dataSource.values.length > 0 ? 1 : 0) : 1), Info: "", Span: "None", Expander: 0
                            });
                    }
                }
                for (var cCnt = 0; cCnt < (this._tRowCnt - 1) ; cCnt++) {
                    if (this._transposeEngine[rCnt] != undefined && this._transposeEngine[rCnt][cCnt] != undefined && !(cCnt < (isColumnEmpty ? 1 : colAxis.length) + (dataSource.values.length > 0 ? 1 : 0) && rCnt < rowAxis.length))
                        jsonObj.push(this._transposeEngine[rCnt][cCnt]);
                }
            }
            this._gridMatrix = [];
            if (dataSource.rows[0] == undefined)
                dataSource.rows.length = 0;
            return ({ json: jsonObj, pivotEngine: this._transposeEngine });
        },

        _applyValueSorting: function (model) {
            var value = [], summary = [], k = 0, sumIndex = 0,hText = "";
            for (var i = 0; i < this._transposeEngine.length; i++) {
                value[k] = [];
                if (ej.isNullOrUndefined(summary[sumIndex])) summary[sumIndex] = [];
                for (var j = 0; j < this._transposeEngine[i].length && this._valueSorting == Number(this._transposeEngine[i][j].Index.split(",")[0]) ; j++) {
                    if (this._transposeEngine[i][j].CSS == "colheader" || this._transposeEngine[i][j].CSS.trim() == "calc" || this._transposeEngine[i][j].CSS == "colheader calc" || this._transposeEngine[i][j].CSS == "summary cstot" || this._transposeEngine[i][j].CSS == "summary cstot calc" || this._transposeEngine[i][j].CSS == "summary cgtot" || this._transposeEngine[i][j].CSS == "summary cgtot calc") {
                        hText = hText == "" ? this._transposeEngine[i][j].Value : hText + model.valueSortSettings.headerDelimiters + this._transposeEngine[i][j].Value;
                    }
                    if (this._transposeEngine[model.dataSource.rows.length][j].CSS == "value") {
                        value[k].push(this._transposeEngine[i][j]);
                        sumIndex = 0;
                    }
                    if (this._transposeEngine[model.dataSource.rows.length][j].CSS == "summary value") {
                        summary[sumIndex].push(this._transposeEngine[i][j]);
                        if (value[k].length > 0) {
                            k = k + 1;
                            value[k] = [];
                        }
                        if (this._transposeEngine[0][j].CSS != "summary rgtot" && summary[sumIndex].length > 0)
                            sumIndex++;
                        if (ej.isNullOrUndefined(summary[sumIndex])) summary[sumIndex] = [];
                    }
                }
            }
            model.valueSortSettings.headerText = hText; model.valueSortSettings.sortOrder = this._sort;
            for (var k = 0; k < value.length; k++) {
                for (var i = 0; i < value[k].length; i++) {
                    for (var j = i; j < value[k].length; j++) {
                        var sort = this._sort == "descending" ? (this._getNumber(value[k][i].Value) < this._getNumber(value[k][j].Value)) : (this._getNumber(value[k][i].Value) > this._getNumber(value[k][j].Value));
                        if (sort) {
                            var temp = value[k][j];
                            value[k][j] = value[k][i];
                            value[k][i] = temp;
                        }
                    }
                }
            }
            for (var k = 0; k < value.length; k++) { if (value[k].length == 0) value.splice(k, 1); };
            var index = [];
            for (var i = 0; i < this._tRowCnt - 1; i++) {
                index[i] = {index: 0,level:-1};
            }
            var val = 0,region = [],regionS = [];
            for (var k = summary.length - 2; k >= 0 ; k--) {
                var ind = 0;
                for (var j = 0; j < summary[k].length; j++) {
                    for (var i = j; i < summary[k].length; i++) {
                        var sort = this._sort == "descending" ? (this._getNumber(summary[k][j].Value) < this._getNumber(summary[k][i].Value)) : (this._getNumber(summary[k][j].Value) > this._getNumber(summary[k][i].Value));
                        if (sort) {
                            var temp = summary[k][i];
                            summary[k][i] = summary[k][j];
                            summary[k][j] = temp;
                        }
                    }
                }
                if (val == 0) {
                    for (var j = 0; j < summary[k].length; j++) {
                        ind = ind == 0 ? (this._transposeEngine[val][Number(summary[k][j].Index.split(",")[1])].MCnt + model.dataSource.columns.length + 1) : (this._transposeEngine[val][Number(summary[k][j].Index.split(",")[1])].MCnt + ind + 1);
                        index[ind] = { index: Number(summary[k][j].Index.split(",")[1]), level: val };
                        if (region[j] == undefined)
                            region[j] = {};
                        region[j].end = Number(summary[k][j].Index.split(",")[1]); region[j].start = Number(summary[k][j].Index.split(",")[1]) - this._transposeEngine[val][Number(summary[k][j].Index.split(",")[1])].MCnt;
                    }
                }
                else {
                    var arr = [], m = 0;
                    for (var l = 0; l < region.length; l++) {
                        arr = [];
                        for (var j = 0; j < summary[k].length ; j++) {
                            if (Number(summary[k][j].Index.split(",")[1]) > region[l].start && Number(summary[k][j].Index.split(",")[1]) < region[l].end)
                                arr.push(summary[k][j]);
                        }
                        for (var j = 0; j < arr.length; j++) {
                            ind = ind == 0 ? (this._transposeEngine[val][Number(arr[j].Index.split(",")[1])].MCnt + model.dataSource.columns.length + 1) : (this._transposeEngine[val][Number(arr[j].Index.split(",")[1])].MCnt + ind + 1);
                            index[ind] = { index: Number(arr[j].Index.split(",")[1]), level: val};
                            if (regionS[m] == undefined)
                                regionS[m] = {};
                            regionS[m].end = Number(arr[j].Index.split(",")[1]); regionS[m].start = Number(arr[j].Index.split(",")[1]) - this._transposeEngine[val][Number(arr[j].Index.split(",")[1])].MCnt;
                            m++;
                        }
                        while (ind < this._tRowCnt - 2 && (index[ind].level > index[ind + 1].level))
                        {
                            ind++;
                        }
                        ind--;
                    }
                    region = jQuery.extend(true, [], regionS);
                }
                val++;
            }
            if (summary.length == 1 && summary[0].length > 0) {
                var num = model.dataSource.columns.length + 1;
                for (var i = 0; i < value[0].length; i++) {
                    index[num] = { index: Number(value[0][i].Index.split(",")[1]) };
                    num++;
                }
            }
            var cnt = model.dataSource.columns.length + 1;
            for (var l = 0; l < region.length; l++) {               
                for (var k = 0; k < value.length; k++) {
                    if (Number(value[k][0].Index.split(",")[1]) >= region[l].start && Number(value[k][0].Index.split(",")[1]) <= region[l].end) {
                        var j = 0;
                        for (var i = region[l].start; i < region[l].end; i++) {
                            index[cnt] = { index: Number(value[k][j].Index.split(",")[1])};
                            j++;
                            cnt++;
                        }
                        cnt++;
                        while (index[cnt].index != 0 && cnt <= index.length) {
                            cnt++;
                        }
                    }
                }
            }
            var arrMat = [];
            for (var i = 0; i < (model.dataSource.columns.length + 1) ; i++) {
                index[i] = { index: i };
            }
            for (var i = 0; i < index.length - 1; i++) {
                arrMat.push(this._gridMatrix[index[i].index]);
            }
            arrMat.push(this._gridMatrix[i]);
            for (var i = 0; i < this._gridMatrix.length && this._gridMatrix[i] != undefined && arrMat[i] != undefined; i++) {
                for (var j = 0; j < this._gridMatrix[i].length && this._gridMatrix[i][j] != undefined; j++) {
                    if (this._gridMatrix[i][j] != undefined && arrMat[i][j] != undefined) {
                        arrMat[i][j].Index = this._gridMatrix[i][j].Index;
                    }
                }
            }
            for (var j = 0; j < model.dataSource.rows.length - 1; j++) {
                var sum = model.dataSource.columns.length + 1, span = 0, k = 0;
                var isSum = false;
                for (var i = (model.dataSource.columns.length + (model.dataSource.values.length > 0 ? 1 : 0)) ; i < arrMat.length; i++) {
                    if (arrMat[i] != undefined && arrMat[i][j] != undefined && arrMat[i][j].CSS == "rowheader" && arrMat[i][j].RowSpan != undefined) {
                        isSum = true;
                        span = span > arrMat[i][j].RowSpan ? span : arrMat[i][j].RowSpan;
                    }
                    if (arrMat[i] != undefined && arrMat[i][j] != undefined && arrMat[i][j].CSS == "summary rstot" && isSum && !ej.isNullOrUndefined(arrMat[sum])) {
                        isSum = false;
                        while (arrMat[sum] == undefined || arrMat[sum][j] == undefined) {
                            sum++;
                        }
                        arrMat[sum][j].RowSpan = span;
                        span = 0;
                        var len = 0;
                        sum = i + 1;
                        k++;
                    }
                }
            }
            this._gridMatrix = arrMat;
            this._transposeEngineCreation();
        },

        _transposeEngineCreation: function(){
            for (var rCnt = 0; rCnt < (this._tRowCnt - 1) ; rCnt++) {
                for (var cCnt = 0; cCnt < (this._tColCnt - 1) ; cCnt++) {
                    if (this._transposeEngine[cCnt] == undefined)
                        this._transposeEngine[cCnt] = [];
                    if (this._gridMatrix[rCnt] != undefined && this._gridMatrix[rCnt][cCnt] != undefined)
                        this._transposeEngine[cCnt][rCnt] = {
                            Index: cCnt + ',' + rCnt, CSS: this._gridMatrix[rCnt][cCnt].CSS, Value: ((typeof (this._gridMatrix[rCnt][cCnt]) === 'string' || typeof (this._gridMatrix[rCnt][cCnt]) === 'number' || typeof (this._gridMatrix[rCnt][cCnt]) === 'object') ? this._gridMatrix[rCnt][cCnt].Value == 0 ? "" : this._gridMatrix[rCnt][cCnt].Value == undefined ? "" : !ej.isNullOrUndefined(this._gridMatrix[rCnt][cCnt].valueText) ? this._gridMatrix[rCnt][cCnt].valueText : this._gridMatrix[rCnt][cCnt].Value : ""), State: this._gridMatrix[rCnt][cCnt].State,
                            RowSpan: (this._gridMatrix[rCnt][cCnt].RowSpan != undefined ? this._gridMatrix[rCnt][cCnt].RowSpan : 1),
                            ColSpan: (this._gridMatrix[rCnt][cCnt].ColSpan != undefined ? this._gridMatrix[rCnt][cCnt].ColSpan : 1), Info: "", Span: "None", Expander: this._gridMatrix[rCnt][cCnt].Expander, MCnt: (this._gridMatrix[rCnt][cCnt].MCnt != undefined ? this._gridMatrix[rCnt][cCnt].MCnt : 1)
                        };
                    else if (this._gridMatrix[rCnt] != undefined)
                        this._transposeEngine[cCnt][rCnt] = {
                            Index: cCnt + ',' + rCnt, CSS: "none", Value: "", State: 0,
                            RowSpan: 1,
                            ColSpan: 1, Info: "", Span: "None", Expander: 0
                        };
                }
            }
        },

        _filterKeyValues: function (keyCollection) {
            var me = this;
          var filteredCol=  $.grep(keyCollection, function (value) {
                var isFound = false;
                for (var i = 0; i < (!ej.isNullOrUndefined(value.uniqueName) && value.uniqueName.split(".").length) ; i++) {
                    isFound = $.inArray(value.uniqueName.split(".")[i], me._advancedFilterInfo) > -1 ? true : isFound;
                    isFound = $.inArray(value.uniqueName, me._advancedFilterInfo) > -1 ? true : isFound;
                    if (isFound)
                        break;
                }
                if (!isFound)
                    return value;
          });
          return filteredCol;
        },
        _getFilteredIndex: function (currFieldItems,values, kCnt, keyCol) {
            return $.map(values, function (value, index) {
                if (currFieldItems.length > 0 && keyCol[kCnt].keys.length > 0 &&
                    currFieldItems[keyCol[kCnt].keys.length - 1].advancedFilter &&
                    currFieldItems[keyCol[kCnt].keys.length - 1].advancedFilter.length > 0 &&
                    (currFieldItems[keyCol[kCnt].keys.length - 1].advancedFilter[0].measure == value.fieldName ||
                    currFieldItems[keyCol[kCnt].keys.length - 1].advancedFilter[0].name == value.fieldName
                    ))
                    return index;
            })[0];
        },
        _applyValueFilter: function (filterInfo, filterValue) {
            isFiltered = false;
            if (filterInfo.length > 0 && !ej.isNullOrUndefined(filterValue)) {
                var filterOperator = filterInfo[0].valueFilterOperator, filterValues = filterInfo[0].values;
                switch (filterOperator.toLowerCase()) {
                    case "equals":
                        isFiltered = !(filterValue == JSON.parse(filterInfo[0].values[0]));
                        break;
                    case "notequals":
                        isFiltered = !(filterValue != JSON.parse(filterInfo[0].values[0]));
                        break;
                    case "greaterthan":
                        isFiltered = !(filterValue > JSON.parse(filterInfo[0].values[0]));
                        break;
                    case "greaterthanorequalto":
                        isFiltered = !(filterValue >= JSON.parse(filterInfo[0].values[0]));
                        break;
                    case "lessthan":
                        isFiltered = !(filterValue < JSON.parse(filterInfo[0].values[0]));
                        break;
                    case "lessthanorequalto":
                        isFiltered = !(filterValue <= JSON.parse(filterInfo[0].values[0]));
                        break;
                    case "between":
                        isFiltered = (!(filterValue > JSON.parse(filterValues[0])) || (!((filterValue < JSON.parse(filterValues[1])))));
                        break;
                    case "notbetween":
                        isFiltered = !(!(filterValue > JSON.parse(filterValues[0])) || (!((filterValue < JSON.parse(filterValues[1])))));
                        break;
                    default:
                        isFiltered = !(filterValue == JSON.parse(filterInfo[0].values[0]));
                        break;
                }
            }
            return isFiltered;
        },
        _applyLabelFilter: function (filterInfo, memberCaption)
        {
            if (filterInfo.length > 0) {
                var filterOperator = filterInfo[0].labelFilterOperator, filterValues = filterInfo[0].values, isFiltered = false;
                memberCaption = !ej.isNullOrUndefined(memberCaption) ? memberCaption.toString():"";
                switch (filterOperator.toLowerCase()) {
                    case "equals":
                        isFiltered = !(memberCaption.toLowerCase() ==(filterValues[0].toLowerCase()));
                        break;
                    case "notequals":
                        isFiltered = (memberCaption.toLowerCase() == (filterValues[0].toLowerCase()));
                        break;
                    case "contains":
                        isFiltered = !(memberCaption.toLowerCase().indexOf(filterValues[0].toLowerCase()) > -1);
                        break;
                    case "notcontains":
                        isFiltered = (memberCaption.toLowerCase().indexOf(filterValues[0].toLowerCase()) > -1);
                        break;
                    case "beginswith":
                        isFiltered = !(memberCaption.toLowerCase().indexOf(filterValues[0].toLowerCase()) ==0);
                        break;
                    case "notbeginswith":
                        isFiltered = (memberCaption.toLowerCase().indexOf(filterValues[0].toLowerCase()) == 0);
                        break;
                    case "endswith":
                        isFiltered = ej.isNullOrUndefined((memberCaption.toLowerCase().match(filterValues[0].toLowerCase() + "$")));
                        break;
                    case "notendswith":
                        isFiltered = !ej.isNullOrUndefined((memberCaption.toLowerCase().match(filterValues[0].toLowerCase() + "$")));
                        break;
                    case "greaterthan":
                        isFiltered = !((memberCaption.toLowerCase()>(filterValues[0].toLowerCase())));
                        break;
                    case "greaterthanorequalto":
                        isFiltered = !((memberCaption.toLowerCase() >= (filterValues[0].toLowerCase())));
                        break;
                    case "lessthan":
                        isFiltered = !((memberCaption.toLowerCase() < (filterValues[0].toLowerCase())));
                        break;
                    case "lessthanorequalto":
                        isFiltered = !((memberCaption.toLowerCase() <= (filterValues[0].toLowerCase())));
                        break;
                    case "between":
                        isFiltered = (!(memberCaption.toLowerCase() > (filterValues[0].toLowerCase())) && (!((memberCaption.toLowerCase() < (filterValues[1].toLowerCase())))));
                        break;
                    case "notbetween":
                          isFiltered =!( !((memberCaption.toLowerCase() > (filterValues[0].toLowerCase()))) && !((memberCaption.toLowerCase() < (filterValues[1].toLowerCase()))));
                        break;
                    default:
                        isFiltered = !(memberCaption.toLowerCase().indexOf(filterValues[0].toLowerCase()) > -1);
                        break;
                }
                return isFiltered;
            }
        },

        getMembers: function (field, data) {
            if (ej.isNullOrUndefined(data))
                return ej.isNullOrUndefined(this._fieldMembers) ? [] : ej.isNullOrUndefined(this._fieldMembers[field]) ? [] : this._fieldMembers[field];
            else {
                var memberList = {};
                for (var i = 0; i < data.length; i++) {
                    var dataItem = data[i];
                    $.each(dataItem, function (item, value) {
                        if (ej.isNullOrUndefined(memberList[item]))
                            memberList[item] = [value];
                        else if(memberList[item].indexOf(value)<0)
                            memberList[item].push(value);
                    });
                }
                return memberList[field];
            }
        },

        _powerFunction: function (formula) {
            if (formula.indexOf("^") > -1) {
                var items = [];
                while (formula.indexOf("(") > -1) {
                    formula = formula.replace(/(\([^\(\)]*\))/g, function (text, item) {
                        items.push(item);
                        return ("~" + (items.length - 1));
                    });
                }

                items.push(formula);
                formula = "~" + (items.length - 1);
                while (formula.indexOf("~") > -1) {
                    formula = formula.replace(new RegExp("~" + "(\\d+)", "g"), function (text, index) {
                        return items[index].replace(/(\w*)\^(\w*)/g, "Math.pow" + "($1,$2)");
                    });
                }
            }
            return formula;
        },
        _calculatedFieldSummaryValue: function (index, calValue, dataSource) {
            if (dataSource.values[index].isCalculatedField == true) {
                var formula = dataSource.values[index].formula.replace(/\s/g, "");
                for (var i = 0; i < dataSource.values.length; i++) {
                    if (dataSource.values[i].isCalculatedField != true) {
                        var value= ej.globalize.parseFloat(calValue[i] == null ? "0" : dataSource.values[i].format == "date" ? this._dateToInt(calValue[i].toString()).toString() : dataSource.values[i].format == "time" ? this._dateToInt(new Date("1900", calValue[i].toString().split(":")[0], calValue[i].toString().split(":")[1], calValue[i].toString().split(":")[2].split(" ")[0]).toString()).toString() : calValue[i].toString(),this._locale);
                        formula = formula.replace(new RegExp(dataSource.values[i].fieldName, 'g'), dataSource.values[i].format == "percentage" && value != 0 ? (value < 0 ? "(" + value / 100 + ")" : value) : (value < 0 ? "(" + value + ")" : value));
                    }
                }
                if (formula.indexOf("^") > -1)
                    formula = this._powerFunction(formula);
                var oldValue = (!isNaN(eval(formula))) && isFinite(eval(formula)) ? this._getReflectedValue({ calcField: eval(formula) }, "calcField", dataSource.values[index].format, dataSource.values[index].formatString) : dataSource.values[index].format == null ? 0 : "0";
                var newValue = dataSource.values[index].format == null ? 0 : "0";
                return this._getSummaryValue(oldValue, newValue, 1, this._summaryTypes[index] == "count" ? "sum" : this._summaryTypes[index], dataSource.values[index].format, dataSource.values[index].formatString);
            }
        },

        _sortHeaders: function (memberArray, axisElements, level) {
            var subArray = [], resultantArray = [], membersCount = 0;
            var sortedArray;
            if (axisElements[level].sortOrder != ej.PivotAnalysis.SortOrder.None){
                if (!ej.isNullOrUndefined(axisElements[level].format))
                    sortedArray = this._getSortedHeaders(memberArray, axisElements, level);
                else
                    sortedArray = ej.DataManager(memberArray).executeLocal(ej.Query().sortBy("keys." + level, axisElements[level].sortOrder != null && axisElements[level].sortOrder == ej.PivotAnalysis.SortOrder.Descending ? ej.sortOrder.Descending : ej.sortOrder.Ascending, false));
            }
            else
                sortedArray = memberArray;
            while (membersCount < sortedArray.length) {
                var memberName = sortedArray[membersCount].keys[level];
                subArray = $.grep(sortedArray, function (item) { return item.keys[level] == memberName; });
                if (subArray.length > 1 && level + 1 < sortedArray[membersCount].keys.length)
                    subArray = this._sortHeaders(subArray, axisElements, level + 1);
                resultantArray = resultantArray.concat(subArray);
                membersCount += subArray.length;
            }
            return resultantArray;
        },
        _getSortedHeaders: function (memberArray, axisElements, level) {
            return axisElements[level].sortOrder == ej.PivotAnalysis.SortOrder.Descending ? memberArray.sort(function (a, b) {
                return ej.PivotAnalysis._formatToInt(b.keys[level], ej.isNullOrUndefined(axisElements[level].format) ? null : axisElements[level].format, ej.isNullOrUndefined(axisElements[level].formatString) ? null : axisElements[level].formatString) - ej.PivotAnalysis._formatToInt(a.keys[level], ej.isNullOrUndefined(axisElements[level].format) ? null : axisElements[level].format, ej.isNullOrUndefined(axisElements[level].formatString) ? null : axisElements[level].formatString)
            }) : memberArray.sort(function (a, b) { return ej.PivotAnalysis._formatToInt(a.keys[level], ej.isNullOrUndefined(axisElements[level].format) ? null : axisElements[level].format, ej.isNullOrUndefined(axisElements[level].formatString) ? null : axisElements[level].formatString) - ej.PivotAnalysis._formatToInt(b.keys[level], ej.isNullOrUndefined(axisElements[level].format) ? null : axisElements[level].format, ej.isNullOrUndefined(axisElements[level].formatString) ? null : axisElements[level].formatString) });
        },

        _isValidTime: function (val) {
            var timeSplit = val.indexOf(':') > -1 ? val.split(':') : [];
            if (timeSplit.length == 3) {
                timeSplit[3] = timeSplit[2].indexOf(' ') > -1 ? timeSplit[2].split(' ')[1] : "AM";
                timeSplit[2] = timeSplit[2].indexOf(' ') > -1 ? timeSplit[2].split(' ')[0] : timeSplit[2];
                if ((Number(timeSplit[0]) > -1 && Number(timeSplit[0]) < 13) && (Number(timeSplit[1]) > -1 && Number(timeSplit[1]) < 61) && jQuery.isNumeric(timeSplit[2]) && (timeSplit[3] == "AM" || timeSplit[3] == "PM"))
                    return true;
                else
                    return false;
            }
            else
                return false;
        },

        _getNumber: function (value, formatString) {
            if (!ej.isNullOrUndefined(value)) {
                if (jQuery.isNumeric(value.toString().replace(/[,.]/g, ''))) {
                    value = value.toString().replace(/[,]/g, ej.preferredCulture(this._locale).numberFormat[","] == ',' ? '' : '~').replace(/[.]/g, ej.preferredCulture(this._locale).numberFormat["."] == '.' ? '.' : '');
                    value = Number(value.toString().replace(/[~]/g, '.'));
                }
                else {
                    if (this._isValidTime(value))
                        value = this._formatToInt(value, "time", formatString);
                    else if (!ej.isNullOrUndefined(ej.parseDate(value, formatString == undefined ? "MM/dd/yyyy" : formatString)))
                        value = this._formatToInt(value, "date", formatString);
                    else if (value.indexOf('/') != -1 && value.split('/') == 2)
                        value = this._formatToInt(value, "fraction", undefined);
                    else if (value.trim().indexOf('%') == value.trim().length - 1)
                        value = Number(value.replace(/[^\d.-]/g, '')) / 100;
                    else {
                        if (/[a-zA-Z]/.test(value))
                            value = 1
                        else
                            value = Number(value.replace(/[^\d.-]/g, ''));
                    }
                }
            }
            return value;
        },

        _setFormat: function (val, format, formatString) {
            switch (format) {
                case "percentage":
                    var division = jQuery.isNumeric(val) ? 1 : 100;
                    val = typeof val == "string" ? val.toString().split(ej.preferredCulture(this._locale).numberFormat[","]).join('').replace(',', '.').replace(ej.preferredCulture(this._locale).numberFormat.percent.symbol, "").trim() : val;
                    val = jQuery.isNumeric(val) ? val : 0;
                    val = ej.widgetBase.formatting("{0:P}", val == "" ? 0 : val / division, this._locale);
                    break;
                case "decimal":
                case "number":
                    val = typeof val == "string" ? val.toString().split(ej.preferredCulture(this._locale).numberFormat[","]).join('').replace(',', '.') : val;
                    val = jQuery.isNumeric(val) ? val : 0;
                    val = ej.widgetBase.formatting("{0:N}", val, this._locale);
                    break;
                case "currency":
                    val = typeof val == "string" ? val.toString().split(ej.preferredCulture(this._locale).numberFormat[","]).join('').replace(',', '.').replace(ej.preferredCulture(this._locale).numberFormat.currency.symbol, "").trim() : val;
                    val = jQuery.isNumeric(val) ? val : 0;
                    val = ej.widgetBase.formatting("{0:C2}", val == "" ? 0 : val, this._locale);
                    break;
                case "date":
                    if (jQuery.isNumeric(val)) {
                        val = new Date(((Number(val) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                        if (this._isDateTime(val))
                            val = ej.widgetBase.formatting("{0:" + (formatString == undefined ? "MM/dd/yyyy" : formatString) + "}", val, this._locale)
                    }
                    else if (new Date(val) != "Invalid Date") {
                        val = new Date(val);
                        val = ej.widgetBase.formatting("{0:" + (formatString == undefined ? "MM/dd/yyyy" : formatString) + "}", val, this._locale)
                    }
                    else {
                        val = new Date(((Number(0) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                        val = ej.widgetBase.formatting("{0:" + (formatString == undefined ? "MM/dd/yyyy" : formatString) + "}", val, this._locale)
                    }
                    break;
                case "scientific":
                    val = typeof val == "string" ? val.split(ej.preferredCulture(this._locale).numberFormat[","]).join('').replace(',', '.') : val;
                    val = jQuery.isNumeric(val) ? val : 0;
                    val = Number(val).toExponential(2).replace("e", "E");
                    break;
                case "accounting":
                    val = this._toAccounting(val, "{0:C2}", this._locale);
                    break;
                case "time":
                    if (jQuery.isNumeric(val)) {
                        val = new Date(((Number(val) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                        if (this._isDateTime(val))
                            val = ej.widgetBase.formatting("{0:h:mm:ss tt}", val, this._locale);
                    }
                    else if (this._isValidTime(val))
                        val = ej.widgetBase.formatting("{0:h:mm:ss tt}", val, this._locale);
                    else {
                        val = new Date(((Number(0) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                        val = ej.widgetBase.formatting("{0:h:mm:ss tt}", val, this._locale);
                    }
                    break;
                case "fraction":
                    val = typeof val == "string" ? val.split(ej.preferredCulture(this._locale).numberFormat[","]).join('').replace(',', '.') : val;
                    val = jQuery.isNumeric(val) ? this._toFraction(val) : this._toFraction(0);
                    val = "numerator" in val ? val.integer + " " + val.numerator + "/" + val.denominator : val.integer
                    break;
                default: val;
            }
            return val;
        },

        _getReflectedValue: function (recSet, fieldName, format, formatString) {
            var val = $(recSet).prop(fieldName);
            if (val == null)
                return val;
            else if (!jQuery.isNumeric(val))
                format = formatString = null;
            return this._setFormat(val, format, formatString);
        },

        _formatToInt: function (value, format, formatString) {
            switch (format) {
                case "date":
                    value = ej.parseDate(value.toString(), (formatString == undefined ? "MM/dd/yyyy" : formatString), this._locale) != null ? this._dateToInt(ej.parseDate(value, (formatString == undefined ? "MM/dd/yyyy" : formatString), this._locale)) : value;
                    break;
                case "percentage":
                    value = value != 0 ? ej.globalize.parseFloat(value.toString(), this._locale) / 100 : Number(value);
                    break;
                case "currency":
                case "accounting":
                    value = value != 0 ? ej.globalize.parseFloat(ej.globalize.format(value.toString(), "c", this._locale), this._locale) : Number(value);
                    break;
                case "decimal":
                case "number":
                    value = value != 0 ? ej.globalize.parseFloat(value.toString(), this._locale) : Number(value);
                    break;
                case "scientific":
                    value = value != 0 || value == 0.00E+0 ? parseFloat(value) : Number(value);
                    break;
                case "time":
                    if (!this._isNumber(value)) {
                        var time = value.toString().split(":");
                        time = new Date("1900", time[0], time[1], time[2].split(" ")[0]).toString();
                        value = this._dateToInt(time);
                    }
                    break;
                case "fraction":
                    var temp1 = parseFloat(value.toString().split(" ")[0]),
                        temp2 = eval(value.toString().split(" ")[1]) != undefined ? parseFloat(eval(value.toString().split(" ")[1])) : parseFloat(0),
                    value = value != 0 ? temp1 + temp2 : Number(value);
                    break;
            }
            return value;
        },

        _isDateTime: function (date) {
            return Object.prototype.toString.call(date) === "[object Date]" && !isNaN(date.valueOf());
        },
        _toAccounting: function (value, formatStr, locale) {
            var numFormat = ej.preferredCulture(locale).numberFormat, prefix, suffix, symbol = numFormat.currency.symbol;
            val = ej.widgetBase.formatting(formatStr, value);
            val = val.indexOf(' ') > -1 ? val.split(' ').join('') : val;
            var trunVal = val.replace(symbol, ""), idx = jQuery.isNumeric(trunVal.toString().split(numFormat[","]).join('').replace(',', '.')) ? val.indexOf(symbol) : 0;
            trunVal = jQuery.isNumeric(trunVal.toString().split(',').join('')) ? trunVal : "0.00";
            if (!idx || (Number(trunVal) < 0 && idx === 1)) {
                prefix = symbol;
                suffix = trunVal;
            }
            else {
                prefix = trunVal;
                suffix = symbol;
            }
            value = prefix + "   " + suffix;
            return value;
        },
        _toFraction: function (value) {
            if (this._isNumber(value)) {
                var input = value.toString(), integerVal = input.split(".")[0], decimalVal = input.split(".")[1];
                if (!decimalVal)
                    return { integer: value };
                var wholeVal = (+decimalVal).toString(), placeVal = this._getPlaceValue(decimalVal, wholeVal), gcd = this._getGCD(wholeVal, placeVal);
                return { integer: integerVal, numerator: Number(wholeVal) / gcd, denominator: Number(placeVal) / gcd };
            }
            return null;
        },
        _isNumber: function (val) {
            return val - parseFloat(val) >= 0;
        },
        _getGCD: function (a, b) {  //make generic gcd of multiple no
            a = Number(a);
            b = Number(b);
            if (!b)
                return a;
            return this._getGCD(b, a % b);
        },
        _getPlaceValue: function (val, digit) {
            var index = val.indexOf(digit) + digit.length;
            return "1" + Array(index + 1).join("0");
        },
        _cellEdit: function (axisData, value, valPos, dataSource) {
            $.each(this._editCellsInfo, function (index, val) {
                if (axisData == ((ej.isNullOrUndefined(val.row) && ej.isNullOrUndefined(val.column)) ? "" : (ej.isNullOrUndefined(val.row) ? val.column : (ej.isNullOrUndefined(val.column) ? val.row : val.row + "." + val.column))) && valPos == parseInt(val.value.split('#')[0])) {
                    value = ej.PivotAnalysis._setFormat(ej.isNullOrUndefined(dataSource.format) ? (jQuery.isNumeric(val.value.split('#')[1].toString().split(',').join('')) ? parseFloat(val.value.split('#')[1].toString().split(',').join('')) : 0) : val.value.split('#')[1], dataSource.format, dataSource.formatString);
                    return false;
                }
            })
            return value;
        },
        _isMemberExist: function (axis, axisData, value, dataSource) {
            var currentObj = this;
            switch (axis) {
                case "row":
                    var pos, flag = false;

                    if (this._rowKeysCalcValues.length == 0)
                        this._rowKeysCalcValues.push(axisData);
                    for (var cnt = 0; cnt < this._rowKeysCalcValues.length; cnt++)
                        if (axisData.uniqueName == this._rowKeysCalcValues[cnt].uniqueName) {
                            flag = true; pos = cnt;
                            break;
                        }
                    if (flag) {
                        for (var vC = 0; vC < value.keys.length; vC++)
                            if (this._rowKeysCalcValues[pos].value == null) {
                                this._rowKeysCalcValues[pos].value = value;
                                break;
                            }
                            else
                                this._rowKeysCalcValues[pos].value.keys[vC] += value.keys[vC];
                    }
                    else
                        this._rowKeysCalcValues.push(axisData);

                    break;
                case "column":
                    var pos, flag = false;

                    if (this._colKeysCalcValues.length == 0 && (dataSource.columns.length > 0 || dataSource.values.length > 0))
                        this._colKeysCalcValues.push(axisData);
                    for (var cnt = 0; cnt < this._colKeysCalcValues.length; cnt++)
                        if (axisData.uniqueName == this._colKeysCalcValues[cnt].uniqueName) {
                            flag = true; pos = cnt;
                            break;
                        }
                    if (flag) {
                        for (var vC = 0; vC < value.keys.length; vC++)
                            if (this._colKeysCalcValues[pos].value == null) {
                                this._colKeysCalcValues[pos].value = value;
                                break;
                            }
                            else
                                this._colKeysCalcValues[pos].value.keys[vC] += value.keys[vC];
                    }
                    else if (dataSource.columns.length > 0 || dataSource.values.length > 0)
                        this._colKeysCalcValues.push(axisData);
                    break;
                case "calc":
                    var pos, flag = false;

                    if (this._tableKeysCalcValues.length == 0)
                        this._tableKeysCalcValues.push(axisData);
                    for (var cnt = 0; cnt < this._tableKeysCalcValues.length; cnt++)
                        if (axisData.uniqueName == this._tableKeysCalcValues[cnt].uniqueName) {
                            flag = true; pos = cnt;
                            break;
                        }
                    if (flag) {
                        for (var vC = 0; vC < value.keys.length; vC++) {
                            if (this._tableKeysCalcValues[pos].value == null) {
                                this._tableKeysCalcValues[pos].value = value;
                                this._tableKeysCalcValues[pos].value["count"] = 1;
                                for (var i = 0; i < value.keys.length; i++) {
                                    if (this._summaryTypes[i] == ej.PivotAnalysis.SummaryType.Count)
                                        this._tableKeysCalcValues[pos].value.keys[i] = this._tableKeysCalcValues[pos].value.count;
                                }
                                break;
                            }
                            else {
                                var calVal = dataSource.values[vC];
                                if (this._tableKeysCalcValues[pos].value.uniqueName[vC] != value.uniqueName[vC] || (!ej.isNullOrUndefined(calVal.formatString) && calVal.formatString.toLowerCase() == "single-entry"))
                                    this._tableKeysCalcValues[pos].value.uniqueName[vC] = " ";
                                this._tableKeysCalcValues[pos].value.count++;
                                if (dataSource.values[vC].isCalculatedField != true)
                                    this._tableKeysCalcValues[pos].value.keys[vC] = this._getSummaryValue(this._tableKeysCalcValues[pos].value.keys[vC], value.keys[vC], this._tableKeysCalcValues[pos].value.count, this._summaryTypes[vC], dataSource.values[vC].format, dataSource.values[vC].formatString);
                            }
                        }
                    }
                    else {
                        this._tableKeysCalcValues.push(axisData);
                        this._tableKeysCalcValues[this._tableKeysCalcValues.length - 1].value = value;
                        for (var i = 0; i < value.keys.length; i++) {
                            if (this._summaryTypes[i] == ej.PivotAnalysis.SummaryType.Count)
                                this._tableKeysCalcValues[this._tableKeysCalcValues.length - 1].value.keys[i] = 1;
                            this._tableKeysCalcValues[this._tableKeysCalcValues.length - 1].value["count"] = 1;
                        }
                    }
                    break;
            }
        },

        _getSummaryValue: function (oldValue, newValue, count, type, format, formatString) {
            oldValue = this._formatToInt(oldValue, format, formatString);
            newValue = this._formatToInt(newValue, format, formatString);
            switch (type) {
                case ej.PivotAnalysis.SummaryType.Sum:
                    oldValue += newValue;
                    break;
                case ej.PivotAnalysis.SummaryType.Average:
                    oldValue = (oldValue * (count - 1) + newValue) / count;
                    if (Math.floor(oldValue) != oldValue) oldValue = Number(oldValue.toFixed(2));
                    break;
                case ej.PivotAnalysis.SummaryType.Min:
                    oldValue = count == 1 ? newValue : Math.min(oldValue, newValue);
                    break;
                case ej.PivotAnalysis.SummaryType.Max:
                    oldValue = count == 1 ? newValue : Math.max(oldValue, newValue);
                    break;
                case ej.PivotAnalysis.SummaryType.Count:
                    oldValue = count;
                    break;
            }
            switch (format) {
                case "percentage":
                    oldValue = ej.widgetBase.formatting("{0:P}", oldValue, this._locale);
                    break;
                case "decimal":
                case "number":
                    oldValue = ej.widgetBase.formatting("{0:N}", oldValue, this._locale);
                    break;
                case "date":
                    oldValue = new Date(((Number(oldValue) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                    if (this._isDateTime(oldValue))
                        oldValue = ej.widgetBase.formatting("{0:" + (formatString == undefined ? "MM/dd/yyyy" : formatString) + "}", oldValue, this._locale);
                    break;
                case "currency":
                    oldValue = ej.widgetBase.formatting("{0:C2}", oldValue, this._locale);
                    break;
                case "scientific":
                    oldValue = oldValue.toExponential(2).replace("e", "E");
                    break;
                case "accounting":
                    oldValue = this._toAccounting(oldValue, "{0:C2}", this._locale);
                    break;
                case "time":
                    oldValue = new Date(((Number(oldValue) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
                    if (this._isDateTime(oldValue))
                        oldValue = ej.widgetBase.formatting("{0:h:mm:ss tt}", oldValue, this._locale);
                    break;
                case "fraction":
                    oldValue = this._toFraction(oldValue);
                    oldValue = "numerator" in oldValue ? oldValue.integer + " " + oldValue.numerator + "/" + oldValue.denominator : oldValue.integer
                    break;
                default: oldValue;
            }
            return oldValue;
        },
        _dateToInt: function (date) {
            var date1 = new Date("01/01/1900"), date2 = this._isDateTime(date) ? date : new Date(date),
            timeDiff = (date2.getTime() - date1.getTime()),
            diffDays = (timeDiff / (1000 * 3600 * 24)) + 2;
            return diffDays;
        },
        _insertTotalHeader: function (axisItems, headerList) {
            if (axisItems.length <= 1) {
                headerList.push({ cellType: "RGTot", keys: ["Grand Total"], tot: "sub" });
                return;
            }
            var level = -1;
            for (var lC = axisItems.length - 2; lC >= 0; lC--) {
                level++;
                var pivotCount = headerList.length;
                if (pivotCount > 0) {
                    var prevVal = headerList[0].uniqueName.split('.'), prevTxt = headerList[0].keys[level];
                    prevVal = prevVal.slice(0, lC + 1).join('.');
                    var newVal = "", prevCnt = 0, newTxt = "";
                    for (var hCnt = 1; hCnt <= pivotCount; hCnt++) {
                        if (headerList[hCnt] != undefined) {

                            newVal = headerList[hCnt].uniqueName.split('.');
                            newVal = newVal.slice(0, lC + 1).join('.');
                            newTxt = headerList[hCnt].keys[lC + 1];
                        }
                        else {
                            newVal = undefined;
                        }
                        if (newVal != undefined && newVal.indexOf("Total") == -1) {
                            if (prevVal != undefined && ((newVal != prevVal))) {
                                headerList.splice(hCnt, 0, { keys: [prevVal.split('.')[lC] + " Total"], cellType: "SubTot", uniqueName: prevVal, level: lC, mSpan: hCnt - prevCnt });
                                if (headerList[prevCnt]['span'] == undefined)

                                    headerList[prevCnt]['span'] = [];
                                headerList[prevCnt]['span'][lC] = hCnt - prevCnt;

                                hCnt++; pivotCount++; prevVal = newVal; prevCnt = hCnt; prevTxt = newTxt;
                            }

                        }
                        else if (prevVal != undefined) {
                            headerList.splice(hCnt, 0, { keys: [prevVal.split('.')[lC] + " Total"], cellType: "SubTot:", uniqueName: prevVal, level: lC, mSpan: hCnt - prevCnt });
                            if (headerList[prevCnt]['span'] == undefined)

                                headerList[prevCnt]['span'] = [];
                            headerList[prevCnt]['span'][lC] = hCnt - prevCnt;
                            hCnt++; pivotCount++; prevVal = newVal; prevCnt = hCnt; prevTxt = newTxt;
                        }
                    }
                }
            }
            headerList.push({ cellType: "RGTot", keys: ["Grand Total"] });
        },

        _isPreviousLevelEqual: function (headerList, hCnt, prevCnt, level) {
            for (var prev = level - 1; prev >= 0; prev--) {
                if (headerList[hCnt].keys[prev] != headerList[prevCnt].keys[prev])
                    return true;
                else
                    return false;
            }
        },

        _calculateValues: function (dataSource) {
            var rowCount = this._rowKeysCalcValues.length + (dataSource.values.length > 0 ? 1 : 0);
            var colCount = this._colKeysCalcValues.length == 0 ? 1 : (this._colKeysCalcValues.length * (dataSource.values.length == 0 ? 1 : dataSource.values.length)) + 1;
            this._gridMatrix = new Array(rowCount + dataSource.rows.length + 1);
            this._populateRowHeaders(dataSource, rowCount + dataSource.rows.length + 1, (dataSource.rows.length == 0 ? 1 : dataSource.rows.length));
            var colHdRowCnt = dataSource.columns.length + 1, colHdColCnt = colCount + (dataSource.rows.length == 0 ? 1 : dataSource.rows.length);
            this._populateColumnHeaders(dataSource, colHdRowCnt, colHdColCnt);
            this._advancedFilterInfo = [];
            if (dataSource.values.length > 0)
                this._populateCalcTable(dataSource);      
            this._tRowCnt = rowCount + colHdRowCnt, this._tColCnt = colHdColCnt;
        },

        _populateRowHeaders: function (dataSource, rowCnt, columnCount) {
            if (this._rowKeysCalcValues.length == 0)
                return;
            var rowIndex;
            if (this._colKeysCalcValues.length == 1 && this._colKeysCalcValues[0].cellType == "RGTot")
                rowIndex = 1 + (dataSource.values.length > 0 ? 1 : 0);
            else
                rowIndex = dataSource.columns.length + (dataSource.values.length > 0 ? 1 : 0);
            this._gridMatrix = [];
            var previousValue = "";
            for (var cnt = 0; cnt < this._rowKeysCalcValues.length; cnt++) {
                previousValue = this._rowKeysCalcValues[cnt];
                {
                    var colIndex = 0, tempCIndx = 0, tempCSpan = 0, rowKLen = 0;
                    if (this._rowKeysCalcValues[cnt].keys != undefined && this._rowKeysCalcValues[cnt].keys.length != 0) {
                        this._gridMatrix[rowIndex] = new Array(columnCount);
                        rowKLen = this._rowKeysCalcValues[cnt].keys.length;
                        for (var kCnt = 0; kCnt < rowKLen; kCnt++) {
                            if (this._rowKeysCalcValues[cnt].cellType != undefined) {
                                if (this._rowKeysCalcValues[cnt].cellType.indexOf("SubTot") > -1) {
                                    tempCIndx = this._rowKeysCalcValues[cnt].level + colIndex;
                                    tempCSpan = columnCount - this._rowKeysCalcValues[cnt].level;
                                    this._cellType = "summary rstot";
                                }
                                else {
                                    this._cellType = "summary rgtot";
                                    tempCIndx = colIndex; tempCSpan = dataSource.rows.length;
                                }
                            }
                            else {
                                this._cellType = "rowheader";
                                tempCIndx = colIndex;
                                tempCSpan = 1;
                            }
                            var expand = rowKLen > 1 ? rowKLen - kCnt > 1 ? 1 : 0 : 0;
                            this._gridMatrix[rowIndex][tempCIndx] = {
                                Index: tempCIndx + ',' + rowIndex, CSS: this._cellType, Value: this._rowKeysCalcValues[cnt].keys[kCnt], State: expand,
                                RowSpan: (this._rowKeysCalcValues[cnt].span != undefined ? this._rowKeysCalcValues[cnt].span[kCnt] : 1),
                                ColSpan: tempCSpan, Info: "", Span: "None", Expander: expand, MCnt: this._rowKeysCalcValues[cnt].mSpan != undefined ? this._rowKeysCalcValues[cnt].mSpan : 0
                            };
                            colIndex++;
                        }
                    }
                    rowIndex++;
                }
            }
            this._cellType = "";
        },

        _populateColumnHeaders: function (dataSource, colHdRowCnt, colHdColCnt) {
            if (this._colKeysCalcValues.length == 0)
                return;
            var tempCnt, colKLen, tempRIndx, tempRSpan, tempCSpan;
            var colIndex = tempCnt = (dataSource.rows.length == 0 ? 1 : dataSource.rows.length), loopCnt = dataSource.values.length == 0 ? 1 : dataSource.values.length, prevVal = "", rowIndex = colKLen = 0;
            var lastRow = (this._colKeysCalcValues.length == 1 && this._colKeysCalcValues[0].cellType == "RGTot") ? 1 : dataSource.columns.length;
            for (var cnt = 0; cnt < this._colKeysCalcValues.length; cnt++) {
                rowIndex = 0, tempRIndx = 0, tempRSpan = 0, tempCSpan = 0;
                prevVal = this._colKeysCalcValues[cnt].keys;
                if (this._gridMatrix[rowIndex] == undefined)
                    this._gridMatrix[rowIndex] = new Array();
                colKLen = this._colKeysCalcValues[cnt].keys.length;
                for (var kCnt = 0; kCnt < colKLen; kCnt++) {
                    if (this._gridMatrix[rowIndex] == undefined)
                        this._gridMatrix[rowIndex] = new Array();

                    if (this._colKeysCalcValues[cnt].cellType != undefined) {
                        if (this._colKeysCalcValues[cnt].cellType.indexOf("SubTot") > -1) {
                            tempRIndx = this._colKeysCalcValues[cnt].level + rowIndex;
                            tempRSpan = colHdRowCnt - this._colKeysCalcValues[cnt].level - 1;
                            this._cellType = "summary cstot";
                        }
                        else {
                            tempRIndx = rowIndex;
                            tempRSpan = (this._colKeysCalcValues.length == 1 && this._colKeysCalcValues[0].cellType == "RGTot") ? 1 : dataSource.columns.length;
                            this._cellType = "summary cgtot";
                        }
                    }
                    else {
                        tempRIndx = rowIndex;
                        tempRSpan = 1;
                        this._cellType = "colheader";
                    }
                    var expand = colKLen > 1 ? colKLen - kCnt > 1 ? 1 : 0 : 0;
                    for (var cCnt = 0; cCnt < loopCnt; cCnt++) {
                        this._gridMatrix[tempRIndx][(loopCnt * cnt) + cCnt + tempCnt] = {
                            Index: colIndex + ',' + tempRIndx, CSS: this._cellType, Value: this._colKeysCalcValues[cnt].keys[kCnt], State: expand,
                            ColSpan: (this._colKeysCalcValues[cnt].span != undefined ? this._colKeysCalcValues[cnt].span[kCnt] == undefined ? 1 : this._colKeysCalcValues[cnt].span[kCnt] : 1) * loopCnt,
                            RowSpan: tempRSpan, Info: "", Span: "None", Expander: expand
                        };
                    }

                    rowIndex++;

                }
                if (dataSource.values.length > 0) {
                    for (var cCnt = 0; cCnt < loopCnt; cCnt++) {
                        if (this._gridMatrix[rowIndex] == undefined)
                            this._gridMatrix[rowIndex] = new Array();

                        this._gridMatrix[lastRow][(loopCnt * cnt) + cCnt + tempCnt] = {
                            Index: ((loopCnt * cnt) + cCnt + tempCnt) + ',' + rowIndex, CSS: this._cellType + " calc", Value: dataSource.values[cCnt].fieldCaption == undefined ? dataSource.values[cCnt].fieldName : dataSource.values[cCnt].fieldCaption, State: 0, ColSpan: 1,
                            RowSpan: 1, Info: "", Span: "None", Expander: 0
                        };
                    }
                }
                colIndex++;
            }
            this._cellType = "";
        },

        _populateCalcTable: function (dataSource) {
            var calValue = [],calTxt = null, calCnt = dataSource.values.length, currentObj = this;
            this._rowTotCalc = [];
            this._rowTotCalc = [];
            var colIndex = (dataSource.rows.length == 0 ? 1 : dataSource.rows.length), sTot = 0, isUniqe = false, totRIndx = 0;
            var rowIndex = (this._colKeysCalcValues.length == 1 && this._colKeysCalcValues[0].cellType == "RGTot") ? 2 : (dataSource.columns.length + 1);
            var rwIndx = rowIndex, clIndx, totFlagR = false, totCIndx = 0, totFlagC = false;
            for (var rCnt = 0; rCnt < this._rowKeysCalcValues.length; rCnt++) {
                this._colTotCalc = []; clIndx = colIndex;
                isUniqe = true;
                if (this._gridMatrix[rCnt + rowIndex] == undefined)
                    this._gridMatrix[rCnt + rowIndex] = new Array();
                this._rowTotCalc[totRIndx] = new Array();

                for (var cCnt = 0; cCnt < this._colKeysCalcValues.length; cCnt++) {
                    calValue = [];
                    calTxt = null;
                    this._cellType = "value";
                    if (dataSource.columns.length > 0 && dataSource.rows.length > 0)
                        $.grep(currentObj._tableKeysCalcValues, function (item) {
                            if (item.uniqueName == currentObj._rowKeysCalcValues[rCnt].uniqueName + "." + currentObj._colKeysCalcValues[cCnt].uniqueName) {
                                for (ky = 0 ; ky < item.value.keys.length; ky++)
                                    calValue.push(item.value.keys[ky]);
                                if(item.value.uniqueName !="")
                                    calTxt = item.value.uniqueName;
                            }
                            return;
                        });
                    else if (dataSource.rows.length == 0)
                        $.grep(currentObj._tableKeysCalcValues, function (item) {
                            if (item.uniqueName == currentObj._colKeysCalcValues[cCnt].uniqueName) {
                                for (ky = 0 ; ky < item.value.keys.length; ky++)
                                    calValue.push(item.value.keys[ky]);
                                if (item.value.uniqueName != "")
                                    calTxt = item.value.uniqueName;
                            }
                            return;
                        });
                    else
                        $.grep(currentObj._tableKeysCalcValues, function (item) {
                            if (item.uniqueName == currentObj._rowKeysCalcValues[rCnt].uniqueName) {
                                for (ky = 0 ; ky < item.value.keys.length; ky++)
                                    calValue.push(item.value.keys[ky]);
                                if (item.value.uniqueName != "")
                                    calTxt = item.value.uniqueName;
                            }
                            return;
                        });
                    if (this._editCellsInfo.length > 0)
                        for (var val = 0; val < dataSource.values.length; val++) {
                            calValue[val] = ej.PivotAnalysis._cellEdit((dataSource.columns.length > 0 && dataSource.rows.length > 0) ? (this._rowKeysCalcValues[rCnt].uniqueName + "." + this._colKeysCalcValues[cCnt].uniqueName) : (dataSource.rows.length == 0 ? this._colKeysCalcValues[cCnt].uniqueName : this._rowKeysCalcValues[rCnt].uniqueName), calValue[val], val, dataSource.values[val]);
                        }
                    if (this._colKeysCalcValues[cCnt].cellType != undefined && (this._colKeysCalcValues[cCnt].cellType.indexOf("SubTot") > -1 || this._colKeysCalcValues[cCnt].cellType.indexOf("RGTot") > -1)) {
                        calValue = []; calTxt = null;
                        for (var ky = 0; ky < calCnt; ky++) {
                            var count = 0, cCount = 0;
                            for (var tCnt = clIndx ; tCnt <= ((cCnt * calCnt) + colIndex) ; tCnt++) {
                                if (this._gridMatrix[rCnt + rowIndex] != undefined && this._gridMatrix[rCnt + rowIndex][clIndx + (count * calCnt) + ky] != undefined && this._gridMatrix[rCnt + rowIndex][clIndx + (count * calCnt) + ky].Value != undefined) {
                                    if (calValue[ky] == undefined)
                                        calValue[ky] = 0;
                                    cCount++;

                                    if (dataSource.values[ky].isCalculatedField)
                                        calValue[ky] = this._calculatedFieldSummaryValue(ky, calValue, dataSource);
                                    else
                                        calValue[ky] = this._getSummaryValue(calValue[ky], this._gridMatrix[rCnt + rowIndex][clIndx + (count * calCnt) + ky].Value, cCount, this._summaryTypes[ky] == "count" ? "sum" : this._summaryTypes[ky], dataSource.values[ky].format, dataSource.values[ky].formatString);
                                }
                                count++;
                            }

                        }
                        sTot = 0;
                        clIndx = ((cCnt + 1) * calCnt) + colIndex;
                        if (calValue != 0) {
                            this._colTotCalc.push({ uniqueName: this._colKeysCalcValues[cCnt].uniqueName, level: this._colKeysCalcValues[cCnt].level, value: calValue });
                        }
                        if (this._colKeysCalcValues[cCnt - 1] != undefined && this._colKeysCalcValues[cCnt - 1].cellType != undefined && this._colKeysCalcValues[cCnt - 1].cellType.indexOf("SubTot") > -1 && this._colKeysCalcValues[cCnt - 1].cellType.indexOf("RGTot") == -1) {
                            var tempVal = $(this._colTotCalc).filter(function (index, x) {
                                return x != undefined && x.uniqueName != undefined && currentObj._colKeysCalcValues[cCnt].uniqueName != undefined && x.level != undefined && currentObj._colKeysCalcValues[cCnt].level != undefined && x.uniqueName.indexOf(currentObj._colKeysCalcValues[cCnt].uniqueName) === 0 && currentObj._colKeysCalcValues[cCnt].level + 1 == x.level;

                            }).map(function (ind, val) {
                                for (var ky = 0; ky < val.value.length; ky++) {
                                    calValue[ky] = ej.isNullOrUndefined(calValue[ky]) ? 0 : calValue[ky];
                                    val.value[ky] = ej.isNullOrUndefined(val.value[ky]) ? 0 : val.value[ky];
                                    if (dataSource.values[ky].isCalculatedField)
                                        calValue[ky] = ej.PivotAnalysis._calculatedFieldSummaryValue(ky, calValue, dataSource);
                                    else
                                        calValue[ky] += val.value[ky];
                                }
                                return calValue;
                            });

                            if (calValue != 0) {
                                this._colTotCalc.push({ uniqueName: this._colKeysCalcValues[cCnt].uniqueName, level: this._colKeysCalcValues[cCnt].level, value: calValue });

                            }
                        }
                        this._cellType = "summary value";
                    }
                    if (this._colKeysCalcValues[cCnt].cellType != undefined && this._colKeysCalcValues[cCnt].cellType.indexOf("RGTot") > -1 && calValue == 0) {
                        calValue = [];
                        calTxt = null;
                        var cCount = 0;
                        var tempVal = $(this._colTotCalc).filter(function (index, x) {
                            return x != undefined && x != undefined && x.level != undefined && x.level == 0;
                        }).map(function (ind, val) {

                            for (var ky = 0; ky < val.value.length; ky++) {
                                calValue[ky] = ej.isNullOrUndefined(calValue[ky]) ? 0 : calValue[ky];
                                val.value[ky] = ej.isNullOrUndefined(val.value[ky]) ? 0 : val.value[ky];
                                cCount++;
                                if (dataSource.values[ky].isCalculatedField)
                                    calValue[ky] = ej.PivotAnalysis._calculatedFieldSummaryValue(ky, calValue, dataSource);
                                else
                                    calValue[ky] = ej.PivotAnalysis._getSummaryValue(calValue[ky], val.value[ky], cCount, currentObj._summaryTypes[ky] == "count" ? "sum" : currentObj._summaryTypes[ky], dataSource.values[ky].format, dataSource.values[ky].formatString);
                            }
                            return calValue;
                        });
                        this._cellType = "summary value";
                    }
                    if (this._rowKeysCalcValues[rCnt].cellType != undefined && (this._rowKeysCalcValues[rCnt].cellType.indexOf("SubTot") > -1 || this._rowKeysCalcValues[rCnt].cellType.indexOf("RGTot") > -1)) {
                        calValue = [];
                        calTxt = null;
                        var memberName = this._rowKeysCalcValues[rCnt].uniqueName;
                        if (this._rowKeysCalcValues[rCnt - 1] != undefined && this._rowKeysCalcValues[rCnt - 1].cellType != undefined && this._rowKeysCalcValues[rCnt - 1].cellType.indexOf("SubTot") > -1 && this._rowKeysCalcValues[rCnt].cellType.indexOf("RGTot") == -1) {
                            var cCount = 0;
                            var tempVal = $(this._rowTotCalc).filter(function (index, x) {
                                return x[0] != undefined && x[0].uniqueName != undefined && currentObj._rowKeysCalcValues[rCnt].uniqueName != undefined && x[0].level != undefined && currentObj._rowKeysCalcValues[rCnt].level != undefined && x[0].uniqueName.indexOf(currentObj._rowKeysCalcValues[rCnt].uniqueName) === 0 && currentObj._rowKeysCalcValues[rCnt].level + 1 == x[0].level;
                            }).map(function (ind, val) {
                                if (val[colIndex + cCnt].length > 0) {
                                    cCount++;
                                    for (var ky = 0; ky < val[colIndex + cCnt].length; ky++) {
                                        calValue[ky] = ej.isNullOrUndefined(calValue[ky]) ? 0 : calValue[ky];
                                        val[colIndex + cCnt][ky] = ej.isNullOrUndefined(val[colIndex + cCnt][ky]) ? 0 : val[colIndex + cCnt][ky];
                                        if (dataSource.values[ky].isCalculatedField)
                                            calValue[ky] = ej.PivotAnalysis._calculatedFieldSummaryValue(ky, calValue, dataSource);
                                        else
                                            calValue[ky] = ej.PivotAnalysis._getSummaryValue(calValue[ky], val[colIndex + cCnt][ky], cCount, currentObj._summaryTypes[ky] == "count" ? "sum" : currentObj._summaryTypes[ky], dataSource.values[ky].format);
                                    }
                                }
                                return calValue;
                            });
                        }
                        if (this._rowKeysCalcValues[rCnt].cellType != undefined && this._rowKeysCalcValues[rCnt].cellType.indexOf("RGTot") > -1) {
                            var cCount = 0;
                            var tempVal = $(this._rowTotCalc).filter(function (index, x) {
                                return x != undefined && x[0] != undefined && x[0].level != undefined && x[0].level == 0;
                            }).map(function (ind, val) {
                                if (val[colIndex + cCnt].length > 0) {
                                    cCount++;
                                    for (var ky = 0; ky < val[colIndex + cCnt].length; ky++) {
                                        calValue[ky] = ej.isNullOrUndefined(calValue[ky]) ? 0 : calValue[ky];
                                        val[colIndex + cCnt][ky] = ej.isNullOrUndefined(val[colIndex + cCnt][ky]) ? 0 : val[colIndex + cCnt][ky];
                                        if (dataSource.values[ky].isCalculatedField)
                                            calValue[ky] = ej.PivotAnalysis._calculatedFieldSummaryValue(ky, calValue, dataSource);
                                        else
                                            calValue[ky] = ej.PivotAnalysis._getSummaryValue(calValue[ky], val[colIndex + cCnt][ky], cCount, currentObj._summaryTypes[ky] == "count" ? "sum" : currentObj._summaryTypes[ky], dataSource.values[ky].format, dataSource.values[ky].formatString);
                                    }
                                }
                                return calValue;
                            });
                        }
                        var cCount = 1;
                        for (var tCnt = rwIndx ; tCnt <= (rCnt + rowIndex) ; tCnt++) {
                            var isAvailable = false;
                            for (var ky = 0; ky < calCnt; ky++) {
                                var count = 0;
                                if (this._gridMatrix[tCnt] != undefined && this._gridMatrix[tCnt][colIndex + (cCnt * calCnt) + ky] != undefined && this._gridMatrix[tCnt][colIndex + (cCnt * calCnt) + ky].Value != undefined) {
                                    if (calValue[ky] == undefined)
                                        calValue[ky] = 0;
                                    isAvailable = true;
                                    if (dataSource.values[ky].isCalculatedField)
                                        calValue[ky] = this._calculatedFieldSummaryValue(ky, calValue, dataSource);
                                    else
                                        calValue[ky] = this._getSummaryValue(calValue[ky], this._gridMatrix[tCnt][colIndex + (cCnt * calCnt) + ky].Value, cCount, this._summaryTypes[ky] == "count" ? "sum" : this._summaryTypes[ky], dataSource.values[ky].format, dataSource.values[ky].formatString);
                                }
                                count++;
                            }
                            if (isAvailable) cCount++;
                        }

                        sTot = 0;
                        totFlagR = true;
                        if (isUniqe) {
                            this._rowTotCalc[totRIndx][0] = { uniqueName: this._rowKeysCalcValues[rCnt].uniqueName, level: this._rowKeysCalcValues[rCnt].level };
                            isUniqe = false;
                        }
                        this._rowTotCalc[totRIndx][colIndex + cCnt] = calValue;

                        this._cellType = "summary value";
                    }

                    //VALUE FILTER IMPLEMENTTAION
                    if (dataSource.enableAdvancedFilter) {
                        var filterIndex = 0, me = this, filterVal;
                        var fieldItem = this._currentFilterVal.fieldName ? ej.Pivot.getReportItemByFieldName(this._currentFilterVal.fieldName, dataSource) : null;
                        if (fieldItem != null && fieldItem.axis == "rows")
                        filterIndex = this._getFilteredIndex(dataSource.rows,dataSource.values, rCnt, me._rowKeysCalcValues);
                        if (!ej.isNullOrUndefined(filterIndex) && fieldItem != null && fieldItem.axis != "rows") 
                        filterIndex = this._getFilteredIndex(dataSource.columns,dataSource.values, cCnt, me._colKeysCalcValues);                                

                        if (!ej.isNullOrUndefined(filterIndex)) {
                            var rowFilterValue = (this._rowKeysCalcValues[rCnt].keys.length > 0 && dataSource.rows.length > 0 && dataSource.rows[this._rowKeysCalcValues[rCnt].keys.length - 1].advancedFilter && dataSource.rows[this._rowKeysCalcValues[rCnt].keys.length - 1].advancedFilter.length > 0 && dataSource.rows[this._rowKeysCalcValues[rCnt].keys.length - 1].advancedFilter[0].advancedFilterType == ej.Pivot.AdvancedFilterType.ValueFilter) ? 1 : null;
                            var isRowFiltered = (fieldItem && fieldItem != null && rowFilterValue != null && dataSource.rows[this._rowKeysCalcValues[rCnt].keys.length - 1].fieldName == fieldItem.item.fieldName) ? this._applyValueFilter(
                                dataSource.rows[this._rowKeysCalcValues[rCnt].keys.length - 1].advancedFilter
                                , calValue[filterIndex]) : false;

                            //ROW FILTER
                            if ((this._colKeysCalcValues[cCnt].keys.indexOf("Grand Total") >= 0) && isRowFiltered && this._rowKeysCalcValues[rCnt].uniqueName)
                                this._advancedFilterInfo.push(this._rowKeysCalcValues[rCnt].uniqueName);
                            else if (dataSource.columns.length == 0 && isRowFiltered && this._rowKeysCalcValues[rCnt].uniqueName)
                                this._advancedFilterInfo.push(this._rowKeysCalcValues[rCnt].uniqueName);

                            // COLUMN FILTER
                            var colFilterValue = (this._colKeysCalcValues[cCnt].keys.length > 0 && dataSource.columns.length > 0 && dataSource.columns[this._colKeysCalcValues[cCnt].keys.length - 1].advancedFilter && dataSource.columns[this._colKeysCalcValues[cCnt].keys.length - 1].advancedFilter.length > 0 && dataSource.columns[this._colKeysCalcValues[cCnt].keys.length - 1].advancedFilter[0].advancedFilterType == ej.Pivot.AdvancedFilterType.ValueFilter) ? 1 : null;
                            var isColFiltered = (fieldItem != null && colFilterValue != null && dataSource.columns[this._colKeysCalcValues[cCnt].keys.length - 1].fieldName == fieldItem.item.fieldName) ? this._applyValueFilter(dataSource.columns[this._colKeysCalcValues[cCnt].keys.length - 1].advancedFilter, calValue[filterIndex]) : false;

                            if (this._colKeysCalcValues[cCnt].uniqueName && jQuery.type( this._rowKeysCalcValues[rCnt].keys[0]) === "string" && this._rowKeysCalcValues[rCnt].keys[0].indexOf("Grand Total") > -1 && isColFiltered)
                                this._advancedFilterInfo.push(this._colKeysCalcValues[cCnt].uniqueName);
                        }
                    }
                    for (var val = 0; val < calCnt; val++) {
                        if (calValue != undefined && calValue.length != undefined) {
                            var valTxt = null;
                            if (calTxt != null && calTxt[val]!= "" && calTxt[val]!=" ")
                                valTxt = calTxt[val];
                            this._gridMatrix[rowIndex + rCnt][(calCnt * cCnt) + val + colIndex] = {
                                Index: ((calCnt * cCnt) + val + colIndex) + ',' + rowIndex + rCnt, CSS: this._cellType, Value: calValue[val], valueText: valTxt, State: 0,
                                ColSpan: 1,
                                RowSpan: 1, Info: "", Span: "None", Expander: 0
                            };
                        }
                        else
                            this._gridMatrix[rowIndex + rCnt][(calCnt * cCnt) + val + colIndex] = 0;
                    }
                }
                if (totFlagR) {
                    totRIndx++;
                    rwIndx = rCnt + rowIndex + 1; totFlagR = false;
                }
            }
            for (var rCnt = 0; rCnt < this._rowKeysCalcValues.length; rCnt++) {
                for (cCnt = 0; cCnt < this._colKeysCalcValues.length; cCnt++) {
                    for (var val = 0; val < calCnt; val++) {
                        if (dataSource.values[val].isCalculatedField && this._gridMatrix[rowIndex + rCnt][(calCnt * cCnt) + val + colIndex].Value == null) {
                            this._gridMatrix[rowIndex + rCnt][(calCnt * cCnt) + val + colIndex].Value = this._calculatedFieldSummaryValue(val, [], dataSource);
                        }
                    }
                }
            }


            return this._gridMatrix;
        }
    }

    ej.PivotAnalysis.SortOrder = {
        Ascending: "ascending",
        Descending: "descending",
        None:"none"
    };

    ej.PivotAnalysis.FilterType = {
        Exclude: "exclude",
        Include: "include"
    };

    ej.PivotAnalysis.SummaryType = {
        Sum: "sum",
        Average: "average",
        Count: "count",
        Min: "min",
        Max: "max"
    };

})(jQuery, Syncfusion);;
ej.Pivot = ej.Pivot || {};

(function ($, ej, undefined) {

    ej.Pivot = {

        //Report Manipulations
        addReportItem: function (dataSource, args) {
            if (!args.isMeasuresDropped) {
                var reportItem = this.removeReportItem(dataSource, args.droppedFieldName, args.isMeasuresDropped);
                if (ej.isNullOrUndefined(reportItem)) reportItem = { fieldName: args.droppedFieldName, fieldCaption: args.droppedFieldCaption, format: args.droppedFieldFormat, formatString: args.droppedFieldFormatString, showSubTotal: args.droppedFieldShowSubTotal };
                for (var itm in reportItem) { if ((itm == "format" || itm == "formatString") && (ej.isNullOrUndefined(reportItem[itm]) || reportItem[itm] == "")) delete reportItem[itm]; }
                switch (args.droppedClass) {
                    case "row":
                        args.droppedPosition.toString() != "" ? dataSource.rows.splice(args.droppedPosition, 0, reportItem) : dataSource.rows.push(reportItem);
                        break;
                    case "column":
                        args.droppedPosition.toString() != "" ? dataSource.columns.splice(args.droppedPosition, 0, reportItem) : dataSource.columns.push(reportItem);
                        break;
                    case "value":
                        if (dataSource.cube == "")
                            args.droppedPosition.toString() != "" ? dataSource.values.splice(args.droppedPosition, 0, reportItem) : dataSource.values.push(reportItem);
                        else
                            args.droppedPosition.toString() != "" ? dataSource.values[0].measures.splice(args.droppedPosition, 0, reportItem) : dataSource.values[0].measures.push(reportItem);
                        break;
                    case "filter":
                        args.droppedPosition.toString() != "" ? dataSource.filters.splice(args.droppedPosition, 0, reportItem) : dataSource.filters.push(reportItem);
                        break;
                }
            }
            else {
                if (args.droppedClass != "")
                    dataSource.values[0].axis = args.droppedClass == "row" ? "rows" : args.droppedClass == "column" ? "columns" : dataSource.values[0].axis;
                else
                    dataSource.values[0].measures = [];
            }
        },

        removeReportItem: function (dataSource, droppedFieldName, isMeasuresDropped) {
            var analysisMode = dataSource.cube == "" ? ej.Pivot.AnalysisMode.Pivot : ej.Pivot.AnalysisMode.Olap;
            var reportItem = $.grep(dataSource.columns, function (value) { return value.fieldName == droppedFieldName; });
            if (!isMeasuresDropped) {
                if (reportItem.length > 0) dataSource.columns = $.grep(dataSource.columns, function (value) { return value.fieldName != droppedFieldName; });
                else {
                    reportItem = $.grep(dataSource.rows, function (value) { return value.fieldName == droppedFieldName; });
                    if (reportItem.length > 0) dataSource.rows = $.grep(dataSource.rows, function (value) { return value.fieldName != droppedFieldName; });
                    else {
                        var valueItems = (analysisMode == ej.Pivot.AnalysisMode.Olap ? dataSource.values[0]["measures"] : dataSource.values);
                        reportItem = $.grep(valueItems, function (value) { return value.fieldName == droppedFieldName; });
                        if (reportItem.length > 0)
                            dataSource.values = analysisMode == ej.Pivot.AnalysisMode.Olap ? [{ measures: $.grep(valueItems, function (value) { return value.fieldName != droppedFieldName; }), axis: dataSource.values[0].axis }] : $.grep(valueItems, function (value) { return value.fieldName != droppedFieldName; });
                        else {
                            reportItem = $.grep(dataSource.filters, function (value) { return value.fieldName == droppedFieldName; });
                            if (reportItem.length > 0) dataSource.filters = $.grep(dataSource.filters, function (value) { return value.fieldName != droppedFieldName; });
                        }
                    }
                }
            }
            else
                dataSource.values[0].measures = [];
            return reportItem[0];
        },

        getReportItemByFieldName: function (fieldName, dataSource) {
            var axis = "columns";
            var reportItem = $.grep(dataSource.columns, function (value) { return value.fieldName.toLowerCase() == fieldName.toLowerCase(); });
            if (reportItem.length == 0) {
                reportItem = $.grep(dataSource.rows, function (value) { return value.fieldName.toLowerCase() == fieldName.toLowerCase() });
                axis = "rows";
            }
            if (reportItem.length == 0) {
                var valuesItems = dataSource.cube == "" ? dataSource.values : (dataSource.values.length > 0 && !ej.isNullOrUndefined(dataSource.values[0].measures)) ? dataSource.values[0].measures : [];
                reportItem = $.grep(valuesItems, function (value) { return value.fieldName.toLowerCase() == fieldName.toLowerCase(); });
                axis = "values"
            }
            if (reportItem.length == 0) {
                reportItem = $.grep(dataSource.filters, function (value) { return (value.fieldName.toLowerCase() == fieldName.toLowerCase()); });
                axis = "filters"
            }
            return { item: reportItem[0], axis: axis };
        },

        getReportItemByFieldCaption: function (fieldCaption, dataSource) {
            var axis = "columns";
            var reportItem = $.grep(dataSource.columns, function (value) { return value.fieldCaption.toLowerCase() == fieldCaption.toLowerCase(); });
            if (reportItem.length == 0) {
                reportItem = $.grep(dataSource.rows, function (value) { return value.fieldCaption.toLowerCase() == fieldCaption.toLowerCase() });
                axis = "rows";
            }
            if (reportItem.length == 0) {
                var valuesItems = dataSource.cube == "" ? dataSource.values : (dataSource.values.length > 0 && !ej.isNullOrUndefined(dataSource.values[0].measures)) ? dataSource.values[0].measures : [];
                reportItem = $.grep(valuesItems, function (value) { return value.fieldCaption.toLowerCase() == fieldCaption.toLowerCase(); });
                axis = "values"
            }
            if (reportItem.length == 0) {
                reportItem = $.grep(dataSource.filters, function (value) { return (value.fieldCaption.toLowerCase() == fieldCaption.toLowerCase()); });
                axis = "filters"
            }
            return { item: reportItem[0], axis: axis };
        },

        //Common functionalities

        closePreventPanel: function (args) {
            var ctrlObj = args.type != 'close' ? args : this;
            ctrlObj.element.find("#preventDiv").remove();
            if (!ej.isNullOrUndefined(ctrlObj.model.pivotControl)) ctrlObj.model.pivotControl.element.find("#preventDiv").remove();
            if (!ej.isNullOrUndefined(ctrlObj._waitingPopup))
                ctrlObj._waitingPopup.hide();
            if (!ej.isNullOrUndefined(ctrlObj.model.pivotControl) && !ej.isNullOrUndefined(ctrlObj.model.pivotControl._waitingPopup))
                ctrlObj.model.pivotControl._waitingPopup.hide();
        },

        openPreventPanel: function(controlObj){
            var backgroundDiv = ej.buildTag("div#preventDiv.errorDlg").css({ "width": $('body').width() + "px", "height": $('body').height() + "px", "position": "absolute", "top": $('body').offset().top + "px", "left": $('body').offset().left + "px", "z-index": 10 })[0].outerHTML;
            $('#' + controlObj._id).append(backgroundDiv);
        },

        _createErrorDialog: function (args, action, obj) {
            ej.Pivot.closePreventPanel(obj);
            obj._errorDialog = action;
            ej.Pivot.openPreventPanel(obj);
            if (obj.element.find(".errorDialog:visible").length == 0) {
                if (!ej.isNullOrUndefined(args.Exception))
                    var dialogElem = ej.buildTag("div.errorDialog#ErrorDialog", ej.buildTag("div.warningImg")[0].outerHTML + ej.buildTag("div.warningContent action:", (args.Exception.Message))[0].outerHTML + ej.buildTag("br")[0].outerHTML + ej.buildTag("div." + obj._id + "stackTraceContent", "Stack Trace :" + args.Exception.StackTraceString)[0].outerHTML + ej.buildTag("div", ej.buildTag("button#ErrOKBtn.errOKBtn", "OK", { "margin": "20px 0 10px 165px" })[0].outerHTML)[0].outerHTML).attr("title", action)[0].outerHTML;
                else
                    var dialogElem = ej.buildTag("div.errorDialog#ErrorDialog", ej.buildTag("div.warningImg")[0].outerHTML + ej.buildTag("div.warningContent action:", (args))[0].outerHTML + ej.buildTag("div", ej.buildTag("button#ErrOKBtn.errOKBtn", "OK", { "margin": "20px 0 10px 165px" })[0].outerHTML)[0].outerHTML).attr("title", action)[0].outerHTML;
                obj.element.append(dialogElem);
                obj.element.find(".errorDialog").ejDialog({ target: "#" + obj._id, enableResize: false, enableRTL: obj.model.enableRTL, width: "400px", close: ej.proxy(ej.Pivot.closePreventPanel, obj) });
                var _errorDialog = obj.element.find(".errorDialog").data("ejDialog");
                $("#" + _errorDialog._id + "_wrapper").css({ left: "50%", top: "50%" });
                obj.element.find(".errOKBtn").ejButton({ type: ej.ButtonType.Button, width: "50px" }).on(ej.eventType.click, function (e) {
                    if (obj._errorDialog == "nodeCheck" && !ej.isNullOrUndefined(obj._schemaData) && !ej.isNullOrUndefined(obj._schemaData._selectedTreeNode))
                        obj._schemaData._tableTreeObj.uncheckNode(obj._schemaData._selectedTreeNode);
                    obj.element.find("#preventDiv").remove();
                    if (obj._errorDialog == "Warning" || obj._errorDialog == "Exception" || obj._errorDialog == "Error")
                        obj.element.children("#ErrorDialog_wrapper").remove();
                });
                obj.element.find(".e-dialog .e-close").attr("title", "Close");
                if (!ej.isNullOrUndefined($("#" + obj._id).data("ejWaitingPopup"))) {
                    $("#" + obj._id).data("ejWaitingPopup").hide();
                }
                if (typeof oclientWaitingPopup != 'undefined' && oclientWaitingPopup != null)
                    oclientWaitingPopup.hide();

                if (!ej.isNullOrUndefined(args.Exception)) {
                    var showChar = 50;
                    var ellipsestext = "...";
                    var moretext = "Show more";
                    var lesstext = "Show less";
                    $('.' + obj._id + 'stackTraceContent').each(function () {
                        var content = $(this).html();
                        if (content.length > showChar) {
                            obj._id
                            var c = content.substr(0, showChar);
                            var h = content.substr(showChar, content.length - showChar);
                            var html = c + ej.buildTag("span." + obj._id + "moreellipses", ellipsestext)[0].outerHTML + ej.buildTag("span." + obj._id + "morecontent", ej.buildTag("span", h).css("display", "none")[0].outerHTML + ej.buildTag("a." + obj._id + "morelink", moretext).css("display", "block")[0].outerHTML)[0].outerHTML;
                            $(this).html(html);
                        }
                    });
                    $("." + obj._id + "morelink").click(function () {
                        if ($(this).hasClass("less")) {
                            $(this).removeClass("less");
                            $(this).html(moretext);
                        } else {
                            $(this).addClass("less");
                            $(this).html(lesstext);
                        }
                        $(this).parent().prev().toggle("slow", function () { });
                        $(this).prev().toggle("slow", function () { });
                        return false;
                    });
                }
            }
        },  
        
        _contextMenuOpen: function (args, ctrlObj) {
            ej.Pivot.openPreventPanel(ctrlObj);
            ctrlObj._selectedMember = $(args.target);
            var mode;
            var menuObj;
            if(ctrlObj.pluginName == "ejPivotGrid"){
                mode = ctrlObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? "olap" : "pivot";
                menuObj = $("#pivotTree").data('ejMenu');
            }
            else {
                if (!ej.isNullOrUndefined(ctrlObj.model.pivotControl))
                mode = ctrlObj.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? "olap" : "pivot";
                menuObj = $("#pivotTreeContextMenu").data('ejMenu');
            }
            if (mode == ej.Pivot.AnalysisMode.Olap) {
                if (ej.isNullOrUndefined($(args.target).parent().attr("tag"))) {
                    if ($(args.target).hasClass("pivotButton") && $(args.target).children(".pvtBtn:eq(0)").length>0) {
                        ctrlObj._selectedMember = $(args.target).children(".pvtBtn:eq(0)");
                        return false;
                    }
                }
                if ($(args.target).parent().attr("tag").split(":")[1].toLowerCase().startsWith("[measures]")) {          
                    menuObj.disable();
                }
                else if (ctrlObj._selectedMember.parent().attr("tag").split(":")[1].toLowerCase() == "measures") {        
                    menuObj.disableItem(ctrlObj._getLocalizedLabels("AddToValues"));
                    menuObj.disableItem(ctrlObj._getLocalizedLabels("AddToFilter"));
                    menuObj.enableItem(ctrlObj._getLocalizedLabels("AddToRow"));
                    menuObj.enableItem(ctrlObj._getLocalizedLabels("AddToColumn"));
                }
                else {
                    menuObj.disableItem(ctrlObj._getLocalizedLabels("AddToValues"));
                    $(args.target.parentElement).find(".namedSetCDB").length > 0 ? menuObj.disableItem(ctrlObj._getLocalizedLabels("AddToFilter")) : menuObj.enableItem(ctrlObj._getLocalizedLabels("AddToFilter"));
                    menuObj.enableItem(ctrlObj._getLocalizedLabels("AddToRow"));
                    menuObj.enableItem(ctrlObj._getLocalizedLabels("AddToColumn"));
                }
            }
            else if (mode == ej.Pivot.AnalysisMode.Pivot) {
                var targetText = args.target.textContent;
                if ($(args.target).hasClass("e-btn")) {
                    menuObj.enable();
                    if (ctrlObj.pluginName == "ejPivotGrid") {
                        menuObj.disableItem(ctrlObj._getLocalizedLabels("CalculatedField"));
                        if (($(args.target).parents(".pivotButton").attr("tag").split(":")[0]).toLowerCase() == "values")
                        {
                            if (ctrlObj.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && $.grep(ctrlObj.model.dataSource.values, function (value) { return value.fieldCaption == targetText && value.isCalculatedField == true; }).length > 0)
                                menuObj.disable();
                            else if (ctrlObj.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && $.grep(JSON.parse(ctrlObj.getOlapReport()).PivotCalculations, function (value) { return value.FieldHeader == targetText && value.CalculationType == 8; }).length > 0)
                                menuObj.disable();
                            menuObj.enableItem(ctrlObj._getLocalizedLabels("CalculatedField"));
                        }
    			    }
                }
                else {
                    var menuObj = $("#pivotTree").data('ejMenu');
                    menuObj.disable();
                }
            }
        },		

        _searchTreeNodes: function (args) {
            var inputObj = $(args.target).hasClass("searchTreeView") ? this.element.find(".searchTreeView").data("ejMaskEdit") : this.element.find(".searchEditorTreeView").data("ejMaskEdit");
            var treeobj = $(args.target).hasClass("searchTreeView") ? (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) ? this.element.find(".schemaFieldTree").data("ejTreeView") : this.element.find(".cubeTreeView").data("ejTreeView")) : this.element.find(".editorTreeView").data("ejTreeView");
            var treeElement = treeobj.element;
            var searchVal = !ej.isNullOrUndefined(inputObj.get_StrippedValue()) ? inputObj.get_StrippedValue().toLowerCase() : "";

            if (searchVal.length > 0) {
                var matchedNode = [], otherNodes = [];
                var linkNodes = treeElement.find('ul>li>div>a');
                for (var p = 0; p < linkNodes.length; p++) {
                    if ($(linkNodes[p]).text().toLowerCase().indexOf(searchVal) != -1)
                        matchedNode.push(linkNodes[p]);
                    else
                        otherNodes.push(linkNodes[p]);
                }
                var resultNodes = treeElement.find(matchedNode).closest("li").css("display", "block");
                treeElement.find(otherNodes).closest("li").css("display", "none");
                for (var i = 0; i < resultNodes.length; i++) {
                    var currentNode = $(resultNodes[i]);
                    var parentNode = currentNode.parents('ul').closest('li').css("display", "block");
                    if (parentNode.length > 0) {
                        treeobj.expandNode(parentNode);
                        if (treeobj.model.expandedNodes.indexOf($(treeobj._liList).index(parentNode)) == -1 && !ej.isNullOrUndefined(window._temp))
                            window._temp.push(parentNode);
                    }
                    var childrenUl = currentNode.children('ul');
                    if (childrenUl.length > 0 && childrenUl.children('li:visible').length == 0) {
                        currentNode.children('ul').children('li').css("display", "block");
                        treeobj.expandNode(resultNodes[i]);
                        if (treeobj.model.expandedNodes.indexOf($(treeobj._liList).index(resultNodes[i])) == -1 && !ej.isNullOrUndefined(window._temp))
                            window._temp.push(resultNodes[i]);
                    }
                }
            }
            else {
                treeElement.find('ul>li').css("display", "block");
                if (!ej.isNullOrUndefined(window._temp))
                    for (var i = 0; i < window._temp.length; i++) {
                        treeobj._collpaseNode(window._temp[i]);
                    }
                window._temp = [];
                if ($(args.target).hasClass("searchTreeView"))
                  treeobj.collapseAll();
            }
        },

        editorTreeNavigatee: function (args, me) {
            var currentPage = me._memberPageSettings.currentMemeberPage;
            if (!$(args.target).hasClass("pageDisabled")) {
                if ($(args.target).hasClass("nextPage")) {
                    me._memberPageSettings.startPage += me.model.memberEditorPageSize;
                    me._memberPageSettings.currentMemeberPage += 1;
                    me._memberPageSettings.endPage += me.model.memberEditorPageSize;
                }
                else if ($(args.target).hasClass("prevPage")) {
                    me._memberPageSettings.currentMemeberPage -= 1;
                    me._memberPageSettings.startPage = Math.abs(me._memberPageSettings.startPage - (me._memberPageSettings.currentMemeberPage == 1 ? me.model.memberEditorPageSize : me.model.memberEditorPageSize));
                    me._memberPageSettings.endPage -= me.model.memberEditorPageSize;
                }
                else if ($(args.target).hasClass("firstPage")) {
                    me._memberPageSettings.currentMemeberPage = 1;
                    me._memberPageSettings.endPage = me.model.memberEditorPageSize;
                    me._memberPageSettings.startPage = 0;
                }
                else if ($(args.target).hasClass("lastPage")) {
                    me._memberPageSettings.currentMemeberPage = parseInt(me.element.find(".memberPageCount").text().split("/")[1].trim());
                    me._memberPageSettings.endPage = (me._memberPageSettings.currentMemeberPage * me.model.memberEditorPageSize);
                    me._memberPageSettings.startPage = (me._memberPageSettings.endPage - me.model.memberEditorPageSize);
                }
                else {
                    if (parseInt($(args.target).val()) > me.element.find(".memberPageCount").text().split("/")[1].trim() || parseInt($(args.target).val()) == 0) {
                        me.element.find(".memberCurrentPage").val(currentPage);
                        return false;
                    }
                    else {
                        me._memberPageSettings.currentMemeberPage = parseInt($(args.target).val());
                        me._memberPageSettings.endPage = me._memberPageSettings.currentMemeberPage * me.model.memberEditorPageSize;
                        me._memberPageSettings.startPage = me._memberPageSettings.currentMemeberPage == 1 || me._memberPageSettings.currentMemeberPage == 0 ? 0 : (me._memberPageSettings.endPage - me.model.memberEditorPageSize);
                    }
                }
                me._waitingPopup.show();
                if (me.pluginName == "ejPivotClient" && me.model.analysisMode == ej.Pivot.AnalysisMode.Olap && me.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                    me._isSearchApplied = false;
                    this.editorTreePageInfoSuccess(me._editorTreeData, me);
                }
                else {
                    if (me.pluginName != "ejPivotSchemaDesigner")
                        me._isMemberPageFilter = true;
                    else
                        me.model.pivotControl._isMemberPageFilter = true;
                    var memberTreeObj = ej.Pivot.updateTreeView(me);
                    var treeData = ej.DataManager(me._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(me._memberPageSettings.currentMemeberPage, me.pluginName == "ejPivotSchemaDesigner" ? me.model.pivotControl.model.memberEditorPageSize : me.model.memberEditorPageSize));
                    treeData.splice(0, 0, { id: "All", name: "All", checkedStatus: me._isAllMemberChecked, tag: "" });
                    me._memberPageSettings.currentMemeberPage > 1 ? me.element.find(".prevPage, .firstPage").removeClass("pageDisabled").addClass("pageEnabled") : me.element.find(".prevPage, .firstPage").removeClass("pageEnabled").addClass("pageDisabled");
                    me._memberPageSettings.currentMemeberPage == parseInt(me.element.find(".memberPageCount").text().split("/")[1].trim()) ? me.element.find(".nextPage, .lastPage").removeClass("pageEnabled").addClass("pageDisabled") : me.element.find(".nextPage, .lastPage").removeClass("pageDisabled").addClass("pageEnabled");
                    me.element.find(".memberCurrentPage").val(me._memberPageSettings.currentMemeberPage);
                    me.element.find(".nextPageDiv .pageDisabled").css("opacity", "0.5");
                    me.element.find(".nextPageDiv .pageEnabled").css("opacity", "1");
                    ej.Pivot._createSearchTreeview(treeData, me);
                    me._waitingPopup.hide();
                }
            }
        },

        editorTreePageInfoSuccess: function (editorTree, me) {
            setTimeout(function () {
                me._memberPageSettings.currentMemeberPage > 1 ? me.element.find(".prevPage, .firstPage").removeClass("pageDisabled").addClass("pageEnabled") : me.element.find(".prevPage, .firstPage").removeClass("pageEnabled").addClass("pageDisabled");
                me._memberPageSettings.currentMemeberPage == parseInt(me.element.find(".memberPageCount").text().split("/")[1].trim()) ? me.element.find(".nextPage, .lastPage").removeClass("pageEnabled").addClass("pageDisabled") : me.element.find(".nextPage, .lastPage").removeClass("pageDisabled").addClass("pageEnabled");
                var editorTreeInfo, treeViewData;
                if (me.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                    if (editorTree[0] != undefined)
                        editorTreeInfo = editorTree[0].Value;
                    else if (editorTree.d != undefined)
                        editorTreeInfo = editorTree.d[0].Value;
                    else
                        editorTreeInfo = editorTree.EditorTreeInfo;
                    treeViewData = $.parseJSON(editorTreeInfo);
                    treeViewData.splice(-1, 1);
                }
                me.element.find(".memberCurrentPage").val(me._memberPageSettings.currentMemeberPage);
                var isSlicerAxis = me.element.find(".pvtBtn").parent("[tag='Slicers:" + me._selectedFieldName.replace(/\[/g, "").replace(/\]/g, "") + "']").length > 0;
                me._appendTreeViewData(me.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? treeViewData : ej.DataManager(me._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(me._memberPageSettings.currentMemeberPage, me.model.memberEditorPageSize)), isSlicerAxis);
                me._waitingPopup.hide();
            }, 0);
        },

        _searchEditorTreeNodes: function (args, ctrlObj) {
            ctrlObj._waitingPopup.show();
            var _this = this;
            setTimeout(function () {
                var searchVal = "";
                if (ctrlObj.pluginName == "ejPivotClient" && !ej.isNullOrUndefined(ctrlObj._pivotSchemaDesigner))
                    searchVal = !ej.isNullOrUndefined($.trim(ctrlObj._pivotSchemaDesigner.element.find(".searchEditorTreeView").val())) ? $.trim(ctrlObj._pivotSchemaDesigner.element.find(".searchEditorTreeView").val()).toLowerCase() : "";
                else
                    searchVal = !ej.isNullOrUndefined($.trim(ctrlObj.element.find(".searchEditorTreeView").val())) ? $.trim(ctrlObj.element.find(".searchEditorTreeView").val()).toLowerCase() : "";

                if (searchVal != "") {
                    var searchTreeNodes = jQuery.extend(true, [], ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("name", "contains", searchVal, true)));
                    var childNodes = jQuery.extend(true, [], ej.DataManager(searchTreeNodes).executeLocal(ej.Query().where("pid", "notEqual", null || undefined).where("name", "contains", searchVal, true)));
                    //searchTreeNodes = [];
                    for (var i = 0; i < childNodes.length; i++) {
                        //childNodes[i].expanded = false;
                        _this._appendParentNodes(searchTreeNodes, childNodes[i], ctrlObj);
                    }
                    ctrlObj._isSearchApplied = true;
                    if (ctrlObj.pluginName == "ejPivotClient" && ctrlObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap && ctrlObj.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                        var isSlicerAxis = ctrlObj.element.find(".pvtBtn").parent("[tag='Slicers:" + ctrlObj._selectedFieldName.replace(/\[/g, "").replace(/\]/g, "") + "']").length > 0;
                        ctrlObj._appendTreeViewData(searchTreeNodes, isSlicerAxis);
                    }
                    else {
                        if (searchTreeNodes.length > 0)
                            searchTreeNodes.splice(0, 0, { id: "All", name: "All", checkedStatus: ctrlObj._isAllMemberChecked, tag: "" });
                        _this._createSearchTreeview(searchTreeNodes, ctrlObj);
                    }

                    //ctrlObj._memberTreeObj.expandAll(null, true);
                    //me._appendTreeViewData(ej.DataManager(me._editorTreeData).executeLocal(ej.Query().where("name", "contains", searchVal, true)), false);
                }
                else {
                    ctrlObj._isSearchApplied = false;
                    if (ctrlObj.pluginName == "ejPivotClient" && ctrlObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap && ctrlObj.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                        var isSlicerAxis = ctrlObj.element.find(".pvtBtn").parent("[tag='Slicers:" + ctrlObj._selectedFieldName.replace(/\[/g, "").replace(/\]/g, "") + "']").length > 0;
                        ctrlObj._appendTreeViewData(ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(ctrlObj._memberPageSettings.currentMemeberPage, ctrlObj.model.memberEditorPageSize)), isSlicerAxis);
                    }
                    else {
                        var searchTreeNodes = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(ctrlObj._memberPageSettings.currentMemeberPage, ctrlObj.pluginName == "ejPivotSchemaDesigner" ? ctrlObj.model.pivotControl.model.memberEditorPageSize : ctrlObj.model.memberEditorPageSize));
                        searchTreeNodes.splice(0, 0, { id: "All", name: "All", checkedStatus: ctrlObj._isAllMemberChecked, tag: "" });
                        _this._createSearchTreeview(searchTreeNodes, ctrlObj);
                    }
                }
                ctrlObj._waitingPopup.hide();
            }, 0);
        },
        _createSearchTreeview: function (searchTreeNodes, ctrlObj) {
            ctrlObj.element.find(".editorTreeView").ejTreeView({
                showCheckbox: true,
                loadOnDemand: true,
                enableRTL: ctrlObj.model.enableRTL,
                beforeDelete: function () {
                    return false;
                },
                height: ctrlObj.element.find(".memberEditorDiv").height(),
                fields: { id: "id", text: "name", isChecked: "checkedStatus", hasChild: "hasChildren", dataSource: searchTreeNodes },
            });
            var treeViewElements = ctrlObj.element.find(".editorTreeView").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                if (!ej.isNullOrUndefined($(treeViewElements[i]).attr("id")))
                    $(treeViewElements[i]).attr("tag", ej.DataManager(searchTreeNodes).executeLocal(ej.Query().where("id", "equal", $(treeViewElements[i]).attr("id")))[0].tag);
            }
            ctrlObj._memberTreeObj = ctrlObj.element.find(".editorTreeView").data("ejTreeView");
            ctrlObj._memberTreeObj.model.nodeCheck = ej.proxy(ctrlObj._nodeCheckChanges, ctrlObj);
            ctrlObj._memberTreeObj.model.nodeUncheck = ej.proxy(ctrlObj._nodeCheckChanges, ctrlObj);
            if (ctrlObj.pluginName == "ejPivotGrid")
                (ctrlObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) ? ctrlObj._memberTreeObj.model.beforeExpand = ej.proxy(ctrlObj._beforeNodeExpand, ctrlObj) : ctrlObj._memberTreeObj.model.nodeClick = ej.proxy(ctrlObj._nodeExpand, ctrlObj);
            else 
            (ctrlObj.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) ? ctrlObj._memberTreeObj.model.beforeExpand = ej.proxy(ctrlObj._beforeNodeExpand, ctrlObj) : ctrlObj._memberTreeObj.model.nodeClick = ej.proxy(ctrlObj._nodeExpand, ctrlObj);
//            ctrlObj._memberTreeObj.model.beforeExpand = ej.proxy(ctrlObj._beforeNodeExpand, ctrlObj);
            if (!ej.isNullOrUndefined(ctrlObj.element.find(".e-dialog .e-text:visible").first())) {
                if (ctrlObj.element.find(".e-dialog .e-text:visible").length > 0) {
                    ctrlObj.element.find(".e-dialog .e-text:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
                    ctrlObj.element.find(".e-dialog button").removeClass("hoverCell");
                }
                else
                    ctrlObj.element.find(".e-dialog button:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
            }
            if (ctrlObj._memberTreeObj.element.find(".e-plus").length == 0) {
                ctrlObj._memberTreeObj.element.find(".e-item").css("padding", "0px");
            }
        },
        _fetchMemberPageSuccess: function (msg) {
            var currentMembers;
            if (msg[0] != undefined && msg.length > 0) {
                currentMembers = msg[0].Value;
                if (msg[1] != null && msg[1] != undefined)
                    this.model.customObject = msg[1].Value;
            }
            else if (msg.d != undefined && msg.d.length > 0) {
                currentMembers = msg.d[0].Value;
                if (msg.d[1] != null && msg.d[1] != undefined)
                    this.model.customObject = msg.d[1].Value;
            }
            else if (msg != undefined && msg.length > 0) {
                currentMembers = msg.EditorTreeInfo;
                if (msg != null && msg.customObject != undefined)
                    this.model.customObject = msg.customObject;
            }
            else if (msg != undefined) {
                currentMembers = msg.EditorTreeInfo;
                if (msg != null && msg.customObject != undefined)
                    this.model.customObject = msg.customObject;
            }
            this._memberPageSettings.endPage = this.pluginName == "ejPivotSchemaDesigner" ? this.model.pivotControl.model.memberEditorPageSize : this.model.memberEditorPageSize;
            this._memberPageSettings.startPage = 0;
            this._memberPageSettings.currentMemeberPage = 1;
            filteredData = JSON.parse(currentMembers);
            filteredData.splice(0, 1);
            if ((this.pluginName == "ejPivotSchemaDesigner" && this.model.pivotControl && this.model.pivotControl.model.enableAdvancedFilter && this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) || (this.pluginName == "ejPivotGrid" && this.model.enableAdvancedFilter && this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode))
                this._memberPagingAvdData = filteredData.splice(filteredData.length - 1, 1);
            this._editorTreeData = filteredData;
            this._memberCount = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
            filteredData = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.pluginName == "ejPivotSchemaDesigner" ? this.model.pivotControl.model.memberEditorPageSize : this.model.memberEditorPageSize));
            filteredData.splice(0, 0, { id: "All", name: "All", checkedStatus: this._isAllMemberChecked, tag: "" })
            this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(filteredData) });
        },
        _memberPageNodeUncheck: function (e, pivotControlObj) {
            var temp = "";
            if ($(e.currentElement).parent().parent().hasClass("editorTreeView") && !pivotControlObj._isSearchApplied)
                temp = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().page(pivotControlObj._memberPageSettings.currentMemeberPage, pivotControlObj.pluginName == "ejPivotSchemaDesigner" ? pivotControlObj.model.pivotControl.model.memberEditorPageSize : pivotControlObj.model.memberEditorPageSize).where("id", "equal", e.currentElement.attr("id")))[0];
            else
                temp = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().where("id", "equal", e.currentElement.attr("id")))[0];
            if (!ej.isNullOrUndefined(temp)) {
                temp.checkedStatus = false;
                if (!ej.isNullOrUndefined(temp.pid)) {
                    var nodeItem = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", temp.pid).where("checkedStatus", "equal", true));
                    if (!ej.isNullOrUndefined(nodeItem) && nodeItem.length == 0)
                        ej.Pivot._unSelectParentTreeNode(temp, pivotControlObj);
                }
                var nodeItem = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", temp.id));
                if (!ej.isNullOrUndefined(nodeItem) && nodeItem.length > 0)
                    ej.Pivot._unSelectChildTreeNode(temp, pivotControlObj);
            }
        },

        _memberPageNodeCheck: function (e, pivotControlObj) {
            var temp = "";
            if ($(e.currentElement).parent().parent().hasClass("editorTreeView") && !pivotControlObj._isSearchApplied)
                temp = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().page(pivotControlObj._memberPageSettings.currentMemeberPage, pivotControlObj.pluginName == "ejPivotSchemaDesigner" ? pivotControlObj.model.pivotControl.model.memberEditorPageSize : pivotControlObj.model.memberEditorPageSize).where("id", "equal", e.currentElement.attr("id")))[0];
            else
                temp = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().where("id", "equal", e.currentElement.attr("id")))[0];
            if (!ej.isNullOrUndefined(temp)) {
                temp.checkedStatus = true;
                if (!ej.isNullOrUndefined(temp.pid)) {
                    //var nodeItem = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", temp.pid).where("checkedStatus", "equal", true));
                    //if (!ej.isNullOrUndefined(nodeItem) && nodeItem.length > 0)
                    ej.Pivot._selectParentTreeNode(temp, pivotControlObj);
                }
                if (!ej.isNullOrUndefined(temp.id)) {
                    var childNodeItem = ej.DataManager(pivotControlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", temp.id));
                    if (!ej.isNullOrUndefined(childNodeItem) && childNodeItem.length > 0) {
                        for (var i = 0; i < childNodeItem.length; i++) {
                            childNodeItem[i].checkedStatus = true;
                            ej.Pivot._selectChildTreeNode(childNodeItem[i], pivotControlObj);
                        }
                    }
                }

            }
        },
        _appendParentNodes: function (searchTreeNodes, childNode, ctrlObj) {
            var parentNode = jQuery.extend(true, [], ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("id", "equal", childNode.pid)));
            for (var i = 0; i < searchTreeNodes.length; i++) {
                if (!ej.isNullOrUndefined(searchTreeNodes[i].pid))
                    searchTreeNodes[i].parentId = searchTreeNodes[i].pid;
            }
            if (!ej.isNullOrUndefined(parentNode) && parentNode.length > 0 && ej.DataManager(searchTreeNodes).executeLocal(ej.Query().where("id", "equal", parentNode[0].id)).length == 0) {
                parentNode[0].expanded = true;
                searchTreeNodes.push(parentNode[0]);
                if (!ej.isNullOrUndefined(parentNode[0].pid))
                    this._appendParentNodes(searchTreeNodes, parentNode[0], ctrlObj);
            }
        },
        _selectParentTreeNode: function (node, ctrlObj) {
            var parentItem = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("id", "equal", node.pid));
            if (!ej.isNullOrUndefined(parentItem) && parentItem.length > 0) {
                parentItem[0].checkedStatus = true;
                this._selectParentTreeNode(parentItem[0], ctrlObj);
            }
        },
        _selectChildTreeNode: function (node, ctrlObj) {
            var childNodeItem = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", node.id));
            if (!ej.isNullOrUndefined(childNodeItem) && childNodeItem.length > 0) {
                for (var i = 0; i < childNodeItem.length; i++) {
                    childNodeItem[i].checkedStatus = true;
                    this._selectChildTreeNode(childNodeItem[i], ctrlObj);
                }
            }
        },
        _unSelectChildTreeNode: function (node, ctrlObj) {
            var childNodeItem = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", node.id));
            if (!ej.isNullOrUndefined(childNodeItem) && childNodeItem.length > 0) {
                for (var i = 0; i < childNodeItem.length; i++) {
                    childNodeItem[i].checkedStatus = false;
                    this._selectChildTreeNode(childNodeItem[i], ctrlObj);
                }
            }
        },
        _unSelectParentTreeNode: function (node, ctrlObj) {
            var parentItem = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("id", "equal", node.pid));
            if (!ej.isNullOrUndefined(parentItem) && parentItem.length > 0) {
                parentItem[0].checkedStatus = false;
                if (ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", parentItem[0].pid).where("checkedStatus", "equal", true)).length == 0)
                    this._unSelectParentTreeNode(parentItem[0], ctrlObj);
            }
        },
        _getSelectedTreeState: function (isSlicer, ctrlObj) {
            if (isSlicer) {
                var selectedNodes = new Array();
                var firstLevelNodes = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined));
                for (var i = 0; i < firstLevelNodes.length; i++) {
                    var nodeExpanded = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", firstLevelNodes[i].id));
                    var nodeInfo = { caption: firstLevelNodes[i].name, parentId: ej.isNullOrUndefined(firstLevelNodes[i].pid) ? "None" : firstLevelNodes[i].pid, id: firstLevelNodes[i].id, checked: firstLevelNodes[i].checkedStatus, expanded: nodeExpanded.length > 0 ? true : false, childNodes: new Array(), tag: firstLevelNodes[i].tag };
                    if (nodeExpanded.length > 0) {
                        for (var j = 0; j < nodeExpanded.length; j++) {
                            nodeInfo.childNodes.push(this._getEditorSlicerInfo(nodeExpanded[j], ctrlObj));
                        }
                    }
                    selectedNodes.push(nodeInfo);
                }
                return JSON.stringify(selectedNodes);
            }
            else {
                var selectedNodes = "";
                for (var i = 0; i < ctrlObj._editorTreeData.length; i++) {
                    if (ctrlObj._editorTreeData[i].checkedStatus == true)
                        selectedNodes += "::" + ctrlObj._editorTreeData[i].id + "||" + ctrlObj._editorTreeData[i].tag;
                }
                return selectedNodes;
            }
        },
        _getUnSelectedTreeState: function (ctrlObj) {
            var unSelectedNodes = "";
            for (var i = 0; i < ctrlObj._editorTreeData.length; i++) {
                if (ctrlObj._editorTreeData[i].checkedStatus == false)
                    unSelectedNodes += "::" + ctrlObj._editorTreeData[i].id + "||" + ctrlObj._editorTreeData[i].tag;
            }
            return unSelectedNodes;
        },
        _getEditorSlicerInfo: function (node, ctrlObj) {
            var nodeExpanded = ej.DataManager(ctrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", node.id));
            var childNode = { caption: node.name, parentId: ej.isNullOrUndefined(node.pid) ? "None" : node.pid, id: node.id, checked: node.checkedStatus, expanded: nodeExpanded.length > 0 ? true : false, childNodes: new Array(), tag: node.tag };
            if (nodeExpanded.length > 0) {
                for (var j = 0; j < nodeExpanded.length; j++) {
                    childNode.childNodes.push(this._getEditorSlicerInfo(nodeExpanded[j], ctrlObj));
                }
            }
            return childNode;
        },
        createErrorDialog: function (controlObj) {
            ej.Pivot.openPreventPanel(controlObj);
            var dialogObj;
            if (controlObj.element.find(".errorDialog").length == 0) {
                var dialogElem = ej.buildTag("div.errorDialog#ErrorDialog", ej.buildTag("div.warningImg")[0].outerHTML + ej.buildTag("div.warningContent", controlObj._getLocalizedLabels("AlertMsg"))[0].outerHTML + ej.buildTag("div", ej.buildTag("button#ErrOKBtn.errOKBtn", "OK")[0].outerHTML)[0].outerHTML).attr("title", controlObj._getLocalizedLabels("Warning"))[0].outerHTML;
                controlObj.element.append(dialogElem);
                controlObj.element.find(".errorDialog").ejDialog({ target: "#" + controlObj._id, enableResize: false, enableRTL: controlObj.model.enableRTL, width: "400px" });
                dialogObj = controlObj.element.find(".errorDialog").data("ejDialog");
                $("#" + dialogObj._id + "_wrapper").css({ left: "50%", top: "50%" });
                controlObj.element.find(".errOKBtn").ejButton({ type: ej.ButtonType.Button, click: ej.proxy(ej.Pivot.errOKBtnClick, controlObj) });
                controlObj.element.find(".e-dialog .e-close").attr("title", controlObj._getLocalizedLabels("Close"));
            }
            else {
                dialogObj = controlObj.element.find(".errorDialog").data("ejDialog");
                dialogObj.open();
            }
        },

        errOKBtnClick: function (args) {
            this.element.find("#preventDiv").remove();
            var dialogObj = this.element.find(".errorDialog").data("ejDialog");
            dialogObj._ejDialog.find("div.e-dialog-icon").trigger("click");
        },

        //OLAP functionalities
        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            var contentType, dataType, successEvt, isAsync = true;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, ej.olap.base, customArgs), isAsync = ((ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9) ? false : (!ej.isNullOrUndefined(customArgs) && customArgs["action"] != "loadFieldElements") ? true : false);
            $.ajax({
                type: type,
                url: url,
                contentType: contentType,
                async: isAsync,
                dataType: dataType,
                data: data,
                success: successEvt,
                complete: ej.proxy(function (onComplete) {
                    $.proxy(onComplete, this);
                    var eventArgs = { "action": this._currentAction, "customObject": "", element: this.element };
                }, this),
                error: ej.proxy(function (msg, textStatus, errorThrown) {
                    if (typeof this._ogridWaitingPopup != 'undefined' && this._ogridWaitingPopup != null)
                        this._ogridWaitingPopup.hide();
                    if (typeof oclientWaitingPopup != 'undefined' && oclientWaitingPopup != null)
                        oclientWaitingPopup.hide();
                    var eventArgs = { "action": this._drillAction != "" ? this._drillAction : "initialize", "customObject": "", "element": this.element, "Message": msg };
                    this._trigger("renderFailure", eventArgs);
                    this.renderControlFromJSON("");
                    if (this._dataModel == "XMLA")
                        this._createErrorDialog(msg.statusText, this._getLocalizedLabels("Error")); msg.statusText
                }, this)
            });
        },        

        getCubeList: function (customArgs, e) {
            var cubeList = [];
            for (var i = 0; i < $(e).find("row").length; i++) {
                var element = $($(e).find("row")[i]);
                cubeList.push({ name: $(element).children("CUBE_NAME").text() });
            }
            customArgs.pvtCtrldObj.setCubeList(cubeList);
        },

        generateTreeViewData: function (schemaObj) {
            var args = { catalog: schemaObj.model.pivotControl.model.dataSource.catalog, cube: schemaObj.model.pivotControl.model.dataSource.cube, url: schemaObj.model.pivotControl.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            this._getTreeData(args, this.loadDimensionElements, { schemaData: schemaObj, action: "loadFieldElements" });
        },

        loadDimensionElements: function (customArgs, data) {
            var dimensionName, contObj = customArgs.schemaData.model.pivotControl, measures = {}, conStr = ej.olap.base._getConnectionInfo(contObj.model.dataSource.data), args = {}, isMon = contObj.model.dataSource.providerName == ej.olap.Providers.Mondrian;
            args = { catalog: contObj.model.dataSource.catalog, cube: contObj.model.dataSource.cube, url: contObj.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" };
            contObj["schemaTreeView"] = []; contObj["reportItemNames"] = [];

            for (var i = 0; i < $(data).find("row").length; i++) {
                var element = $($(data).find("row")[i]), dimensionUniqueName = element.find("DIMENSION_UNIQUE_NAME").text(), dimensionName = element.find("DIMENSION_CAPTION").text();
                if (dimensionUniqueName.toLowerCase().indexOf("[measure") >= 0)
                    measures = { hasChildren: true, isSelected: false, id: dimensionUniqueName, name: dimensionName, spriteCssClass: dimensionUniqueName.toLowerCase() == "[measures]" ? "folderCDB e-icon" : "dimensionCDB e-icon", tag: dimensionUniqueName }
                else if (!$($(data).find("row")[0]).find("HIERARCHY_CAPTION").length > 0) {
                    contObj.schemaTreeView.push({ hasChildren: true, isSelected: false, id: (isMon ? dimensionUniqueName + "~#^Dim" : dimensionUniqueName), name: dimensionName, spriteCssClass: "dimensionCDB e-icon", tag: dimensionUniqueName, defaultHierarchy: $($(data).find("row")[i]).children("DEFAULT_HIERARCHY").text() });
                }
            }
            contObj.schemaTreeView.splice(0, 0, measures);
            if (!contObj.model.enableDrillThrough || (customArgs.schemaData != undefined && customArgs.schemaData.model.olap.showNamedSets)) {
                args.request = "MDSCHEMA_SETS";
                ej.Pivot._getTreeData(args, ej.Pivot.loadNamedSetElements, customArgs);
            }
            else {
                args.request = "MDSCHEMA_HIERARCHIES";
                if (ej.isNullOrUndefined(contObj._fieldData) || (!ej.isNullOrUndefined(contObj._fieldData) && ej.isNullOrUndefined(contObj._fieldData.hierarchy)))
                    this._getFieldItemsInfo(contObj);
                if (contObj._fieldData.hierarchySuccess == undefined)
                    ej.Pivot._getTreeData(args, contObj.loadHierarchyElements, customArgs);
                else
                    ej.Pivot.loadHierarchyElements(customArgs, contObj._fieldData.hierarchySuccess);
            }
        },

        loadNamedSetElements: function (customArgs, data) {
            var contObj = customArgs.schemaData.model.pivotControl, args = { catalog: contObj.model.dataSource.catalog, cube: contObj.model.dataSource.cube, url: contObj.model.dataSource.data, request: "MDSCHEMA_HIERARCHIES" }
            var data = contObj.model.dataSource, treeNodeElement = {}, measureGroupItems = [], reportElement;

            reportElement = $.map(data.rows, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName });
            $.merge(reportElement, ($.map(data.columns, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));
            $.merge(reportElement, ($.map(data.filters, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));

            for (var i = 0; i < $(data).find("row").length; i++) {
                var element = $($(data).find("row")[i]);
                if ((!($.inArray(element.find("DIMENSIONS").text().split(".")[0], measureGroupItems) >= 0))) {
                    contObj.schemaTreeView.push({ hasChildren: true, isSelected: false, pid: element.find("DIMENSIONS").text().split(".")[0], id: element.find("SET_DISPLAY_FOLDER").text() + "_" + element.find("DIMENSIONS").text().split(".")[0], name: element.find("SET_DISPLAY_FOLDER").text(), spriteCssClass: "folderCDB e-icon namedSets" });
                    measureGroupItems.push(element.find("DIMENSIONS").text().split(".")[0]);
                }
                contObj.schemaTreeView.push({
                    hasChildren: true, isSelected: ($.inArray("[" + $.trim(element.children("SET_NAME").text()) + "]", reportElement) >= 0),
                    pid: element.find("SET_DISPLAY_FOLDER").text() + "_" + element.find("DIMENSIONS").text().split(".")[0],
                    id: "[" + $.trim(element.children("SET_NAME").text()).replace(/\&/g, "&amp;") + "]",
                    name: element.children("SET_CAPTION").text(), spriteCssClass: "namedSetCDB e-icon", tag: element.find("EXPRESSION").text()
                });
            }

            if (ej.isNullOrUndefined(contObj._fieldData) || contObj._fieldData.hierarchySuccess == undefined)
                ej.Pivot._getTreeData(args, ej.Pivot.loadHierarchyElements, customArgs);
            else
                ej.Pivot.loadHierarchyElements(customArgs, contObj._fieldData.hierarchySuccess);
        },

        loadHierarchyElements: function (customArgs, data) {
            var contObj = customArgs.schemaData.model.pivotControl, args = { catalog: contObj.model.dataSource.catalog, cube: contObj.model.dataSource.cube, url: contObj.model.dataSource.data, request: "MDSCHEMA_LEVELS" };
            var reportInfo = contObj.model.dataSource, displayFolder = "", reportElement, isMon = contObj.model.dataSource.providerName == ej.olap.Providers.Mondrian;

            reportElement = $.map(reportInfo.rows, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName });
            $.merge(reportElement, ($.map(reportInfo.columns, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));
            $.merge(reportElement, ($.map(reportInfo.filters, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));

            for (var i = 0; i < $(data).find("row").length; i++) {
                var element = $($(data).find("row")[i]), dimensionUniqueName = element.find("DIMENSION_UNIQUE_NAME").text(), hierarchyUniqueName = element.find("HIERARCHY_UNIQUE_NAME").text();
                var currElement = $(contObj.schemaTreeView).filter(function (i, x) {
                    return (x.tag == dimensionUniqueName);
                }).map(function (i, x) { return x });
                if (currElement.length > 0 && (dimensionUniqueName != hierarchyUniqueName || isMon))
                contObj.schemaTreeView.push({ hasChildren: true, isSelected: ($.inArray(hierarchyUniqueName, reportElement) >= 0), pid: dimensionUniqueName +(isMon? "~#^Dim":""), id: hierarchyUniqueName, name: element.find("HIERARCHY_CAPTION").text(), spriteCssClass: ((element.find("HIERARCHY_ORIGIN").text() != "2") && element.find("HIERARCHY_ORIGIN").text() != "6") ? "hierarchyCDB e-icon" : "attributeCDB e-icon", tag: hierarchyUniqueName, });
            }
            ej.Pivot._getTreeData(args, ej.Pivot.loadLevelElements, customArgs);
        },

        loadLevelElements: function (customArgs, data) {
            var contObj = customArgs.schemaData.model.pivotControl,  newDataSource = $.map($(data).find("row"), function (obj, index) {
                if (parseInt($(obj).children("LEVEL_TYPE").text()) != "1" && $(obj).children("HIERARCHY_UNIQUE_NAME").text().toLowerCase() != "[measures]")
                    return { hasChildren: false, isChecked: false, id: $(obj).find("LEVEL_UNIQUE_NAME").text(), pid: $(obj).find("HIERARCHY_UNIQUE_NAME").text(), name: $(obj).find("LEVEL_CAPTION").text(), tag: $(obj).find("LEVEL_UNIQUE_NAME").text(), spriteCssClass: "level" + parseInt($(obj).children("LEVEL_NUMBER").text()) + " e-icon" };
            });
            $.merge(contObj.schemaTreeView, newDataSource);
            if (!contObj.model.enableDrillThrough || contObj._fieldData.measureSuccess) {
                if (ej.isNullOrUndefined(contObj._fieldData) || !contObj._fieldData.measureSuccess) {
                    var args = { catalog: contObj.model.dataSource.catalog, cube: contObj.model.dataSource.cube, url: contObj.model.dataSource.data, request: "MDSCHEMA_MEASURES" }
                    ej.Pivot._getTreeData(args, ej.Pivot.loadMeasureElements, customArgs);
                }
                else
                    ej.Pivot.loadMeasureElements(customArgs, contObj._fieldData.measureSuccess);
            }
        },

        loadMeasureGroups: function (customArgs, data) {
            if (ej.isNullOrUndefined(customArgs.pivotControl._fieldData))
                customArgs.pivotControl._fieldData = {};
            customArgs.pivotControl._fieldData["measuresGroups"] = $(data).find("row");
        },

        loadMeasureElements: function (customArgs, data) {
            var contObj= customArgs.schemaData.model.pivotControl,args = { catalog: contObj.model.dataSource.catalog, cube: contObj.model.dataSource.cube, url: contObj.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            var elements = [], measureGroupItems = [], measureGroup = "", caption;

            elements = $.map(contObj.model.dataSource.values, function (obj, index) { if (obj["measures"] != undefined) return obj["measures"] });
            contObj.reportItemNames = $.map(elements, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName });

            if (contObj.model.locale != "en-US") {
                var args = { catalog: contObj.model.dataSource.catalog, cube: contObj.model.dataSource.cube, url: contObj.model.dataSource.data, request: "MDSCHEMA_MEASUREGROUPS" }
                ej.Pivot._getTreeData(args, ej.Pivot.loadMeasureGroups, { pivotControl: contObj, action: "loadFieldElements" });
            }

            for (var i = 0; i < $(data).find("row").length; i++) {
                var element = $($(data).find("row")[i]), measureGRPName = element.children("MEASUREGROUP_NAME").text(), measureUQName = element.find("MEASURE_UNIQUE_NAME").text();
                if ((!($.inArray(measureGRPName, measureGroupItems) >= 0))) {
                    if (contObj.model.locale != "en-US") {
                        var measureInfo = $.map(contObj._fieldData["measuresGroups"], function (item) { if ($(item).children("MEASUREGROUP_NAME").text() == measureGRPName) return $(item).children("MEASUREGROUP_CAPTION").text() });
                        caption = measureInfo.length > 0 ? measureInfo[0] : measureGRPName
                    }
                    else
                        caption = measureGRPName;
                    if (measureGRPName != "")
                        contObj.schemaTreeView.push({ hasChildren: true, isChecked: false, pid: "[Measures]", id: measureGRPName, name: caption, spriteCssClass: "measureGroupCDB e-icon", tag: measureGRPName });
                    measureGroupItems.push(measureGRPName);
                }
                contObj.schemaTreeView.push({ hasChildren: true, isSelected: ($.inArray(measureUQName, contObj.reportItemNames) >= 0), id: measureUQName, pid: measureGRPName == "" ? "[Measures]" : measureGRPName, name: element.children("MEASURE_CAPTION").text(), spriteCssClass: "measure", tag: measureUQName });
                if (($.inArray(measureUQName, contObj.reportItemNames) >= 0))
                    contObj.reportItemNames.splice(contObj.reportItemNames.indexOf(measureUQName), 1);
            }

            if (!ej.isNullOrUndefined(customArgs.schemaData) && customArgs.schemaData.model.olap.showKpi) {
                treeNodeElement = { hasChildren: true, isChecked: false, id: "folderStruct", name: "KPI", spriteCssClass: "KPICDB folderCDB e-icon", tag: "" }
                contObj.schemaTreeView.splice(1, 0, treeNodeElement);
                args.request = "MDSCHEMA_KPIS";
                contObj._getTreeData(args, contObj.loadKPIElements, customArgs);
            }
            else if (!ej.isNullOrUndefined(customArgs.schemaData))
                customArgs.schemaData._createTreeView(this, contObj.schemaTreeView);
        },

        loadKPIElements: function (customArgs, data) {
            var contObj= customArgs.schemaData.model.pivotControl, data = contObj.model.dataSource, reportElement = this.reportItemNames, measureGroupItems = [], measureGroup = "";

            for (var i = 0; i < $(data).find("row").length; i++) {
                var element = $($(data).find("row")[i]), kpiName = element.children("KPI_CAPTION").text(),
                    kpiGoal = element.children("KPI_goal").text(), kpiStatus = element.children("KPI_STATUS").text(),
                    kpiTrend = element.children("KPI_TREND").text(), kpiValue = element.find("KPI_VALUE").text();
                if ((!($.inArray(element.children("KPI_NAME").text(), measureGroupItems) >= 0))) {
                    treeNodeElement = { hasChildren: true, isChecked: false, pid: "folderStruct", id: kpiName, name: kpiName, spriteCssClass: "measureGroupCDB e-icon", tag: kpiName }
                    contObj.schemaTreeView.push(treeNodeElement);
                    measureGroupItems.push(kpiName);
                }
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiGoal, reportElement) >= 0), id: kpiGoal, pid: kpiName, name: contObj._getLocalizedLabels("Goal"), spriteCssClass: "kpiGoal e-icon", tag: kpiGoal };
                contObj.schemaTreeView.push(treeNodeElement);
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiStatus, reportElement) >= 0), id: kpiStatus, pid: kpiName, name: contObj._getLocalizedLabels("Status"), spriteCssClass: "kpiStatus e-icon", tag: kpiStatus };
                contObj.schemaTreeView.push(treeNodeElement);
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiTrend, reportElement) >= 0), id: kpiTrend, pid: kpiName, name: contObj._getLocalizedLabels("Trend"), spriteCssClass: "kpiTrend e-icon", tag: kpiTrend };
                contObj.schemaTreeView.push(treeNodeElement);
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiValue, reportElement) >= 0), id: kpiValue, pid: kpiName, name: contObj._getLocalizedLabels("Value"), spriteCssClass: "kpiValue e-icon", tag: kpiValue };
                contObj.schemaTreeView.push(treeNodeElement);
            }
            customArgs.schemaData._createTreeView(this, contObj.schemaTreeView);
            delete contObj.reportItemNames;
            delete contObj.schemaTreeView;
        },
        _createCalcMemberDialog: function (calcMemberTree) {
            var calcMemberTreeData = "";
            if (calcMemberTree.length > 1 && calcMemberTree[0] != undefined)
                calcMemberTreeData = JSON.parse(calcMemberTree[0].Value);
            else if (calcMemberTree.d != undefined)
                calcMemberTreeData = JSON.parse(calcMemberTree.d[0].Value);
            else
                calcMemberTreeData = JSON.parse(calcMemberTree.CubeTreeInfo);
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "fetchCalcMemberTreeView", element: this.element, customObject: this.model.customObject });

            ej.Pivot.openPreventPanel(this);
            this.element.find(".calcMemberDialog", ".clientDialog", ".e-dialog").remove();
            var treeviewPanel = ej.buildTag("div.cubeBrowserCalcMember", ej.buildTag("div#" + this._id + "_cubeTreeViewCalcMember.cubeTreeViewCalcMember")[0].outerHTML, {})[0].outerHTML;
            var captionFields = ej.buildTag("label.lblCaption", this._getLocalizedLabels("Caption"), {})[0].outerHTML + ej.buildTag("input#" + this._id + "_captionFieldCM.captionFieldCM", "", {}).attr("aria-label", this._getLocalizedLabels("Caption"))[0].outerHTML;
            var expressionFields = ej.buildTag("label.lblexpression", this._getLocalizedLabels("Expression"), {})[0].outerHTML + ej.buildTag("textarea#" + this._id + "_expressionFieldCM.e-textarea e-droppable expressionFieldCM" + (this.model.enableRTL ? " e-rtl" : ""), "", {}).attr("aria-label", this._getLocalizedLabels("Expression"))[0].outerHTML;
            var memberFields = ej.buildTag("label.lblmemberType", this._getLocalizedLabels("MemberType"), {})[0].outerHTML + ej.buildTag("input#" + this._id + "_memberTypeFieldCM.memberTypeFieldCM", "", {}).attr("aria-label", this._getLocalizedLabels("MemberType"))[0].outerHTML + ej.buildTag("input#" + this._id + "_dimensionFieldCM.dimensionFieldCM", "", {}).attr("aria-label", "dimension")[0].outerHTML;
            var formatFields = ej.buildTag("label.lblformat", this._getLocalizedLabels("FormatString"), {})[0].outerHTML + ej.buildTag("input#" + this._id + "_formatFieldCM.formatFieldCM", "", {}).attr("aria-label", this._getLocalizedLabels("FormatString"))[0].outerHTML + ej.buildTag("input#" + this._id + "_customFormatFieldCM.customFormatFieldCM", "", {}).attr("aria-label", "custom format")[0].outerHTML;

            var fieldPanel = ej.buildTag("div.calcMemberFieldPanel", captionFields + expressionFields + memberFields + formatFields, {})[0].outerHTML;

            var okBtn = ej.buildTag("button#" + this._id + "_btnOk.btnCalcMemberOk", this._getLocalizedLabels("OK"), {}, { name: this._getLocalizedLabels("OK") }).attr("aria-label", this._getLocalizedLabels("OK"))[0].outerHTML;
            var cancelBtn = ej.buildTag("button#" + this._id + "_btnCancel.btnCalcMemberCancel", this._getLocalizedLabels("Cancel"), {}, { name: this._getLocalizedLabels("Cancel") }).attr("aria-label", this._getLocalizedLabels("Cancel"))[0].outerHTML;
            var dialogFooter = ej.buildTag("div.calcMemberFooter", okBtn + cancelBtn, {})[0].outerHTML;

            this._calcMemberDialog = ej.buildTag("div#" + this._id + "_calcMemberDialog", treeviewPanel + fieldPanel + dialogFooter, {})[0].outerHTML;
            $(this._calcMemberDialog).appendTo("#" + this._id);
            $("#" + this._id + "_calcMemberDialog").ejDialog({
                width: "auto",
                title: this._getLocalizedLabels("CalculatedMember"),
                cssClass: this.model.cssClass + " calcMemberDialog",
                enableModal: false,
                target: "#" + this._id,
                enableRTL: this.model.enableRTL,
                enableResize: false,
                close: ej.proxy(function () { ej.Pivot.closePreventPanel(this) }, this),
                beforeOpen: ej.proxy(function () {
                    this.element.find(".calcMemberDialog .e-dialog").css("display", "block");
                }, this)
            });
            this._calcMemberDialog = this.element.find("#" + this._id + "_calcMemberDialog").data("ejDialog");
            $("#" + this._id + "_btnCancel").ejButton({
                type: ej.ButtonType.Button, width: "80px", enableRTL: this.model.enableRTL, click: ej.proxy(function () {
                    this._calcMemberDialog.close();
                    this._selectedCalcMember = null;
                    ej.Pivot.closePreventPanel(this);
                },this)
            });
            $("#" + this._id + "_btnOk").ejButton({
                type: ej.ButtonType.Button, width: "80px", enableRTL: this.model.enableRTL, click: ej.proxy(function () {
                    if ($.trim(this.element.find("#" + this._id + "_captionFieldCM").val()) == "" || $.trim(this.element.find("#" + this._id + "_expressionFieldCM").val()) == "") {
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("EmptyField"), this._getLocalizedLabels("Warning"), this);
                        return;
                    }
                    else if (this.element.find("#" + this._id + "_formatFieldCM").val() == "Custom" && $.trim(this.element.find("#" + this._id + "_customFormatFieldCM").val()) == "") {
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("EmptyFormat"), this._getLocalizedLabels("Warning"), this);
                        return;
                    }
                    if (ej.isNullOrUndefined(this._selectedCalcMember)) {
                        for (var i = 0; i < this._calcMembers.length; i++) {
                            if ($.trim(this.element.find("#" + this._id + "_captionFieldCM").val()).toLowerCase() == this._calcMembers[i].name.toLowerCase()) {
                                if (confirm(this._getLocalizedLabels("Confirm")))
                                    this._selectedCalcMember = $.trim(this.element.find("#" + this._id + "_captionFieldCM").val());
                                else
                                    return;
                                //ej.Pivot._createErrorDialog(this._getLocalizedLabels("DuplicateCalcMeasure"), this._getLocalizedLabels("Warning"), this);
                            }
                        }
                    }
                    //this._calcMembers.push({ name: $.trim(this.element.find("#" + this._id + "_captionFieldCM").val()), expression: $.trim(this.element.find("#" + this._id + "_expressionFieldCM").val()) });
                    this._calcMemberDialog.close();
                    ej.Pivot.closePreventPanel(this);
                    //if (!ej.isNullOrUndefined(this._selectedCalcMember)) {
                    //    var liElement = this.element.find(".cubeTreeView .calcMemberCDB").parents("li").find("li");
                    //    for (var i = 0; i < liElement.length; i++) {
                    //        if ($(liElement[i]).text().toLowerCase() == this._selectedCalcMember.toLowerCase()) {
                    //            this._calcMemberTreeObj.updateText($(liElement[i]).attr("id"), $.trim(this.element.find("#" + this._id + "_captionFieldCM").val()));
                    //            if ($(liElement[i]).children("div").find("> .e-text")[0] != null)
                    //                $(liElement[i]).children("div").find("> .e-text")[0].lastChild.nodeValue = $.trim(this.element.find("#" + this._id + "_captionFieldCM").val());
                    //            liElement[i].setAttribute("expression", $.trim(this.element.find("#" + this._id + "_expressionFieldCM").val()));
                    //            liElement[i].setAttribute("formatString", this.element.find("#" + this._id + "_formatFieldCM").val() == "Custom" ? $.trim(this.element.find("#" + this._id + "_customFormatFieldCM").val()) : this.element.find("#" + this._id + "_formatFieldCM").val());
                    //            liElement[i].setAttribute("nodeType", this.element.find("#" + this._id + "_memberTypeFieldCM").val() == "Measure" ? 0 : 1);
                    //        }
                    //    }
                    //    for (var i = 0; i < this._calcMembers.length; i++) {
                    //        if (this._calcMembers[i].name.toLowerCase() == this._selectedCalcMember.toLowerCase()) {
                    //            this._calcMembers[i].name = $.trim(this.element.find("#" + this._id + "_captionFieldCM").val());
                    //            this._calcMembers[i].expression = $.trim(this.element.find("#" + this._id + "_expressionFieldCM").val());
                    //            this._calcMembers[i].formatString = this.element.find("#" + this._id + "_formatFieldCM").val() == "Custom" ? $.trim(this.element.find("#" + this._id + "_customFormatFieldCM").val()) : this.element.find("#" + this._id + "_formatFieldCM").val();
                    //            this._calcMembers[i].nodeType = this.element.find("#" + this._id + "_memberTypeFieldCM").val() == "Measure" ? 0 : 1;
                    //        }
                    //    }
                    //}
                    var calcMemberTag = "";
                    if (!ej.isNullOrUndefined(this._selectedCalcMember)) {
                        var calcMember = ej.DataManager(this._calcMembers).executeLocal(ej.Query().where("name", "equal", this._selectedCalcMember, true));
                        if (!ej.isNullOrUndefined(calcMember) && calcMember.length > 0)
                            calcMemberTag = calcMember[0].tag;
                    }
                    this._selectedCalcMember = null;
                    this._waitingPopup.show();
                    var eventArgs = JSON.stringify({ "action": "calculatedMember", "olapReport": this.currentReport, "clientReports": this.reports, "caption": this.currentCubeName + "%" + $.trim(this.element.find("#" + this._id + "_captionFieldCM").val()), expression: $.trim(this.element.find("#" + this._id + "_expressionFieldCM").val()), memberType: this.element.find("#" + this._id + "_memberTypeFieldCM").val(), dimension: this.element.find("#" + this._id + "_dimensionFieldCM").val(), formatString: this.element.find("#" + this._id + "_formatFieldCM").val() == "Custom" ? $.trim(this.element.find("#" + this._id + "_customFormatFieldCM").val()) : this.element.find("#" + this._id + "_formatFieldCM").val(), "uniqueName": calcMemberTag, "customObject": this.model.customObject });
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.calculatedMember, eventArgs, this._calcMemberDroppedSuccess);
                }, this)
            });
          
            this.element.find("#" + this._id + "_cubeTreeViewCalcMember").ejTreeView({
                fields: { id: "id", parentId: "pid", text: "name", spriteCssClass: "spriteCssClass", dataSource: calcMemberTreeData },
                allowDragAndDrop: true,
                enableRTL: this.model.enableRTL,
                allowDropChild: false,
                allowDropSibling: false,
                dragAndDropAcrossControl: true,
                cssClass: 'calcMemberTreeViewDragedNode',
                nodeDropped: ej.proxy(function (args) {
                    if (args.target != null && args.target.attr("id") == "" + this._id + "_expressionFieldCM")
                        this.element.find("#" + this._id + "_expressionFieldCM").val(this.element.find("#" + this._id + "_expressionFieldCM").val() + $(args.droppedElement).attr("tag"));
                }, this),
                beforeExpand: ej.proxy(ej.Pivot._getMemberChildNodes, this),
            });
            this.element.find("#" + this._id + "_captionFieldCM").ejMaskEdit({
                name: "inputbox",
                inputMode: ej.InputMode.Text,
                watermarkText: "",
                maskFormat: "",
                textAlign: this.model.enableRTL ? "right" : "left",
                width: "100%"
            });
            this.element.find("#" + this._id + "_customFormatFieldCM").ejMaskEdit({
                name: "inputbox",
                inputMode: ej.InputMode.Text,
                watermarkText: "",
                maskFormat: "",
                textAlign: this.model.enableRTL ? "right" : "left",
                width: "100%",
                cssClass: "calcMemberCustomFormat"
            });
            this.element.find(".calcMemberCustomFormat").css("visibility", "hidden");
            this.element.find("#" + this._id + "_memberTypeFieldCM").ejDropDownList({
                dataSource: [{ text: "Measure", value: "Measure" }, { text: "Dimension", value: "Dimension" }], enableRTL: this.model.enableRTL,
                width: "100%", selectedIndex: 0, change: ej.proxy(function (args) {
                    if (args.text == "Dimension")
                        this.element.find(".calcMemberDimensionField").css("visibility", "visible");
                    else
                        this.element.find(".calcMemberDimensionField").css("visibility", "hidden");
                }, this)
            });
            var dimensions = ej.DataManager(calcMemberTreeData).executeLocal(ej.Query().where("spriteCssClass", "contains", "dimensionCDB"));
            var dimensionNames = [];
            for (var i = 0; i < dimensions.length; i++) {
                dimensionNames.push({ text: dimensions[i].name, value: dimensions[i].name })
            }
            this.element.find("#" + this._id + "_dimensionFieldCM").ejDropDownList({
                dataSource: dimensionNames,selectedIndex: 0,
                width: "100%", enableRTL: this.model.enableRTL, cssClass: "calcMemberDimensionField"
            });
            this.element.find(".calcMemberDimensionField").css("visibility", "hidden");
            this.element.find("#" + this._id + "_formatFieldCM").ejDropDownList({
                dataSource: [{ text: "Standard", value: "Standard" }, { text: "Currency", value: "Currency" }, { text: "Percent", value: "Percent" }, { text: "Custom", value: "Custom" }],
                enableRTL: this.model.enableRTL, selectedIndex: 0,
                width: "100%", enableRTL: this.model.enableRTL, change: ej.proxy(function (args) {
                    if (args.text == "Custom")
                        this.element.find(".calcMemberCustomFormat").css("visibility", "visible");
                    else
                        this.element.find(".calcMemberCustomFormat").css("visibility", "hidden");
                }, this)
            });
            var treeViewElements = this.element.find(".cubeTreeViewCalcMember").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                if (!ej.isNullOrUndefined($(treeViewElements[i]).attr("id")))
                    $(treeViewElements[i]).attr("tag", ej.DataManager(calcMemberTreeData).executeLocal(ej.Query().where("id", "equal", $(treeViewElements[i]).attr("id")))[0].tag);
            }
            var folders = this.element.find(".cubeTreeViewCalcMember .folderCDB");
            for (var i = 0; i < folders.length; i++) {
                $(folders[i].parentElement).removeClass("e-draggable");
            }
            if (this.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").length > 0)
                this.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").parent().removeClass("e-draggable");
            this._calcMemberTreeObj = this.element.find('.cubeTreeViewCalcMember').data("ejTreeView");
            if (!ej.isNullOrUndefined(this._selectedCalcMember)) {
                var calcMember = ej.DataManager(this._calcMembers).executeLocal(ej.Query().where("name", "equal", this._selectedCalcMember));
                if (calcMember.length > 0) {
                    this.element.find("#" + this._id + "_captionFieldCM").val(calcMember[0].name);
                    this.element.find("#" + this._id + "_expressionFieldCM").val(calcMember[0].expression);
                    this.element.find("#" + this._id + "_memberTypeFieldCM").data("ejDropDownList").selectItemsByIndices(calcMember[0].nodeType);
                    if (calcMember[0].nodeType == 1) {
                        var dimensionName = calcMember[0].tag.split(".")[0].replace(/\[/g, "").replace(/\]/g, "");
                        var dimensionFieldLen = this.element.find("#" + this._id + "_dimensionFieldCM").data("ejDropDownList").model.dataSource;
                        for (var i = 0; i < dimensionFieldLen.length; i++) {
                            if (dimensionFieldLen[i].value == dimensionName)
                                this.element.find("#" + this._id + "_dimensionFieldCM").data("ejDropDownList").selectItemsByIndices(i);
                        }
                    }
                    if (!ej.isNullOrUndefined(calcMember[0].formatString)) {
                        if (calcMember[0].formatString == "Currency")
                            this.element.find("#" + this._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(1);
                        else if (calcMember[0].formatString == "Percent")
                            this.element.find("#" + this._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(2);
                        else {
                            this.element.find("#" + this._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(2);
                            this.element.find("#" + this._id + "_customFormatFieldCM").val(calcMember[0].formatString);
                        }
                    }
                }
            }
            //$(".cubeBrowserHierarchy").ejScroller({ height: "300px", width: "300px" });
            //$("#calcMemberDialog").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
            this._waitingPopup.hide();
        },
        _getMemberChildNodes: function (args) {
            if ($(args.currentElement).find("a > span")[0].className.indexOf("level") > -1 || $(args.currentElement).find("a > span")[0].className.indexOf("member") > -1) {
                var blankNode = ej.DataManager(this._calcMemberTreeObj.dataSource()).executeLocal(ej.Query().where("pid", "equal", $(args.currentElement).attr("id")).where("name", "equal", "(Blank)"));
                if (!ej.isNullOrUndefined(blankNode) && blankNode.length > 0) {
                    this._calcMemberTreeObj.hideNode(blankNode[0].id);
                    this.pNode = args.currentElement;
                    this._waitingPopup.show();
                    var nodeType = $(args.currentElement).find("a > span")[0].className.indexOf("level") > -1 ? "level" : "member";
                    if (this.model.beforeServiceInvoke != null)
                        this._trigger("beforeServiceInvoke", { action: "fetchMemberChildNodes", element: this.element, customObject: this.model.customObject });
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.fetchMemberTreeNodes, JSON.stringify({ "action": "fetchMemberChildNodes", "dimensionName": $(args.currentElement).attr("tag") + ":" + nodeType + ":" + $(args.currentElement).attr("id"), "olapReport": this.currentReport, "customObject": serializedCustomObject }), ej.proxy(ej.Pivot._fetchMemberSuccess, this));
                }
            }
        },
        _fetchMemberSuccess: function (data) {
            var childNodes = [];
            if (data.length > 1 && data[0] != undefined)
                childNodes = JSON.parse(data[0].Value);
            else if (data.d != undefined)
                childNodes = JSON.parse(data.d[0].Value);
            else
                childNodes = JSON.parse(data.MemberChildNodes);
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "fetchMemberChildNodes", element: this.element, customObject: this.model.customObject });
            this._calcMemberTreeObj.model.beforeExpand = null;
            this._calcMemberTreeObj.addNode(childNodes, $(this.pNode));
           // this._calcMemberTreeObj.addNode()
            var blankNode = ej.DataManager(this._calcMemberTreeObj.dataSource()).executeLocal(ej.Query().where("pid", "equal", $(this.pNode).attr("id")).where("name", "equal", "(Blank)"));
            if (!ej.isNullOrUndefined(blankNode) && blankNode.length > 0) {
                this._calcMemberTreeObj.removeNode(blankNode[0].id);
            }
            $.each($(this.pNode).children().find("li"), function (index, value) {
                value.setAttribute("tag", childNodes[index].tag);
            });
            var elements = $(this.pNode).children().find("li");
            for (i = 0; i < elements.length; i++) {
                if (childNodes[i].hasChildren == true) {
                    this._calcMemberTreeObj.addNode({ id: childNodes[i].id + "_Blank_" + i, name: "(Blank)", parentId: childNodes[i].id }, elements[i]);
                    this.element.find("#" + childNodes[i].id).find('> div > div:first').removeClass("e-process");
                    this._calcMemberTreeObj.collapseNode(this.element.find("#" + childNodes[i].id));
                }
            }
            this._calcMemberTreeObj.model.beforeExpand = ej.proxy(ej.Pivot._getMemberChildNodes, this);
            this._waitingPopup.hide();
        },
        _drillThroughCellClick: function (args, gridObj) {
            gridObj._waitingPopup.show();
            var measures, measureGrp;
            var cellPos = $(args.currentTarget.parentElement).attr('p');
            if (gridObj.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                gridObj.doAjaxPost("POST", gridObj.model.url + "/" + gridObj.model.serviceMethodSettings.drillThroughDataTable, JSON.stringify({ "currentReport": JSON.parse(gridObj.getOlapReport()).Report, "layout": gridObj.model.layout, "cellPos": cellPos, "customObject": JSON.stringify(gridObj.model.customObject) }), function (args) {
                    if ($(gridObj.element).parents(".e-pivotclient").length > 0) {
                        $(gridObj.element).parents(".e-pivotclient").data("ejPivotClient")._trigger("drillThrough", { element: gridObj.element, data: args });
                    }
                    else
                        gridObj._trigger("drillThrough", { element: gridObj.element, data: args });
                });
            }
            else {
                var rowSpan = $("#" + gridObj._id).find("tbody").find('tr:first').find('th').length;
                for (i = 0; i < rowSpan; i++) {
                    var rowInfo = (gridObj.getJSONRecords()[parseInt((i * gridObj._rowCount) + parseInt(cellPos.split(",")[1]))].Info.indexOf("Measures") != -1 || gridObj.getJSONRecords()[parseInt((i * gridObj._rowCount) + parseInt(cellPos.split(",")[1]))].RowSpan <= 1) ? gridObj.getJSONRecords()[parseInt((i * gridObj._rowCount) + parseInt(cellPos.split(",")[1]))].Info.split("::")[0] : "";
                    if (rowInfo.indexOf("Measures") != -1)
                        measures = rowInfo;
                    if (rowInfo != "")
                        gridObj._rowHeader[i] = rowInfo;
                }
                var columnHeaderCount = $("#" + gridObj._id).find("tbody").find('[p="' + parseInt(cellPos.split(",")[0]) + "," + parseInt(cellPos.split(",")[1]) + '"]').closest('tbody').prev().children('tr').length;
                for (i = 0; i < columnHeaderCount; i++) {
                    var colInfo = (gridObj.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * gridObj._rowCount) + i)].Info.indexOf("Measures") != -1 || gridObj.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * gridObj._rowCount) + i)].ColSpan <= 1) ? gridObj.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * gridObj._rowCount) + i)].Info.split("::")[0] : "";
                    if (colInfo.indexOf("Measures") != -1)
                        measures = colInfo;
                    if (colInfo != "")
                        gridObj._colHeader[i] = colInfo;
                }
                if (ej.isNullOrUndefined(gridObj._fieldData) || (!ej.isNullOrUndefined(gridObj._fieldData) && ej.isNullOrUndefined(gridObj._fieldData.hierarchy)))
                    gridObj._getFieldItemsInfo(gridObj);
                for (j = 0; j < gridObj._fieldData.measures.length; j++) {
                    if (measures == gridObj._fieldData.measures[j].id)
                        gridObj.measureGrp = gridObj._fieldData.measures[j].pid
                }
                gridObj._rowHeader = $.grep(gridObj._rowHeader, function (n) { return n == 0 || n });
                gridObj._colHeader = $.grep(gridObj._colHeader, function (n) { return n == 0 || n });
                gridObj._createDrillThroughQuery("", gridObj);
            }
        },
        openHierarchySelector: function (e, data) {
            if (e.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                this._createDrillThroughDialog(e, data);
            else {
                var controlObj;
                e._waitingPopup.show();
                if (e.target.className.indexOf("e-pivotclient") >= 0)
                    controlObj = e._pivotGrid;
                else controlObj = e;
                var conStr = controlObj._getConnectionInfo(e.model.dataSource.data);
                var pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>MDSCHEMA_MEASUREGROUP_DIMENSIONS</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + e.model.dataSource.catalog + "</CATALOG_NAME><CUBE_NAME>" + e.model.dataSource.cube + "</CUBE_NAME><MEASUREGROUP_NAME>" + controlObj.measureGrp + "</MEASUREGROUP_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + e.model.dataSource.catalog + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier></PropertyList></Properties></Discover></Body></Envelope>";
                this.doAjaxPost("POST", conStr.url, { XMLA: pData }, controlObj._loadDimensionElements, null, { pvtGridObj: controlObj, action: "loadMeasureElements" });
            }
        },
        
        _createDrillThroughDialog: function (args, dataSourceInfo) {
            if (args.model.operationalMode != ej.PivotGrid.OperationalMode.ServerMode)
                dataSourceInfo.shift();
            args.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
            var textTitle = ej.buildTag("label#", args._getLocalizedLabels("SelectHierarchy"))[0].outerHTML;
            var textArea = "<br><textarea id='hrSel' style='width:270px; height:300px; resize:none; margin:0px 5px 0 5px'></textarea></br><br>",
            browserPanel = "<div class=cubeTable style='width:200px; overflow:auto'><div valign=\"bottom\">" + this._createHierarchyBrowser() + "</div></div>";
            var dialogContent = ej.buildTag("div#dropDlg.dropDlg", "<table class=\"outerTable\"><tr><td>" + browserPanel + "</td><td>" + textTitle + textArea + "</td></tr></table>")[0].outerHTML + "</br>",
            dialogFooter = ej.buildTag("div", ej.buildTag("button#btnOK.dialogBtnOK", args._getLocalizedLabels("OK"))[0].outerHTML + ej.buildTag("button#btnCancel.dialogBtnCancel", args._getLocalizedLabels("Cancel"))[0].outerHTML, { "float": "right", "margin": "-5px 0 6px" })[0].outerHTML,
            ejDialog = ej.buildTag("div#clientDialog.clientDialog", dialogContent + dialogFooter, { "opacity": "1" }).attr("title", "Hierarchy Selector")[0].outerHTML;
            $(ejDialog).appendTo("#" + args._id);
            $("#btnOK, #btnCancel").ejButton();
            $("#btnOK, #btnCancel").css({ margin: "0 20px 20px 0", width: "50px" });
            args.element.find(".clientDialog").ejDialog({ width: 550, target: "#" + args._id, enableResize: false, enableRTL: args.model.enableRTL, close: ej.proxy(ej.Pivot.closePreventPanel, args) });
            args.element.find(".cubeTreeViewHierarchy").ejTreeView({
                showCheckbox: true,
                fields: { id: "id", parentId: "pid", text: "name", isChecked: "isSelected", spriteCssClass: "spriteCssClass", dataSource: args.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? $.parseJSON(dataSourceInfo.d) : dataSourceInfo },
                allowDragAndDrop: true,
                allowDropChild: false,
                allowDropSibling: false,
                enableRTL: args.model.enableRTL ? true : false,
                beforeDelete: function () {
                    return false;
                },
                dragAndDropAcrossControl: true,
                nodeDropped: ej.proxy(this._hierarchyNodeDropped, args),
            });
            args._tableTreeObj = args.element.find(".cubeTreeViewHierarchy").data("ejTreeView");
            args._tableTreeObj.element.find(".e-ul").css({ "width": "100%", "height": "100%" });
            args._tableTreeObj.element.find(".e-chkbox-wrap").remove();
            var treeViewElements = args._tableTreeObj.element.find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                var tagValue = args.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? $.parseJSON(dataSourceInfo.d)[i].tag : dataSourceInfo[i].tag
                treeViewElements[i].setAttribute("tag", tagValue);
            }
            if (args._tableTreeObj) {
                args._tableTreeObj.element.find("li").mouseover(ej.proxy(function (evt) {
                    if ($(evt.target).parent().find(".measureGroupCDB, .dimensionCDB, .folderCDB").length > 0)
                        $(evt.target).css("cursor", "default");
                }, args));
            }
            var grid = args;
            $("#btnOK").click(function () {
                var text = $("#hrSel").val();
                $(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog, .drilltableDialog").remove();
                grid._waitingPopup.show();
                ej.olap._mdxParser._createDrillThroughQuery(text, grid);
                grid._waitingPopup.hide();
            });
            $("#btnCancel").click(function () {
                $(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
                grid._waitingPopup.hide()
            });
            if (args.model.enableRTL) {
                $('.e-dialog').addClass("e-rtl");
                $('.dialogBtnCancel').css("margin", "0 -70px 0 0");
            }
        },

        _createHierarchyBrowser: function (cubeTreeInfo) {
            return ej.buildTag("div.cubeBrowserHierarchy", ej.buildTag("div.cubeTreeViewHierarchy")[0].outerHTML, { width: "200px", height: "300px", overflow: "auto" })[0].outerHTML;
        },

        _hierarchyNodeDropped: function (sender) {
            if (sender.dropTarget[0].id == "hrSel") {
                var target;
                if ($($(sender.droppedElement).children()[0]).find(".dimensionCDB").length > 0)
                    target = this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? $(sender.droppedElement).find("li:first").attr("tag") : $(sender.droppedElement).find("li:first")[0].id;
                else if ($(sender.droppedElement).find("li:first").length == 0)
                    target = this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? $(sender.droppedElement.parent().parent()).attr("tag") : $(sender.droppedElement.parent().parent())[0].id;
                else
                    target = this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? $(sender.droppedElement).attr("tag") : sender.droppedElementData.id;
                target = target.replace("[", "[$");
                for (var i = 0; i < $("#hrSel").val().split(",").length; i++) {
                    if (target == $("#hrSel").val().split(",")[i])
                        return false;
                }
                var tex = this.element.find('#hrSel').val();
                if (tex.length != 0) {
                    tex = tex + ',' + target;
                    this.element.find('#hrSel').val(tex);
                }
                else
                    this.element.find('#hrSel').val(target);
            }
        },

        _generateDrillData: function (customArgs, args) {
            var tag = $(args).find("row").children();
            var json = $.map(tag, function (a) {
                var num = parseFloat(a.textContent);
                var text = a.tagName.replace(/_x005B_/g, "[").replace(/_x0020_/g, " ").replace(/_x005D_/g, "]").replace(/_x0024_/g, "$").replace("].[", "]-[");
                return '"' + text + '"' + ":" + num;
            })
            var value = json[0], gridJSON = "";
            for (var i = 0; i < json.length; i++) {
                if (json[i] == value) {
                    gridJSON += gridJSON == "" ? "[{" + json[i] : "}, {" + json[i];
                    continue;
                }
                gridJSON += "," + json[i];
            }
            gridJSON += "}]";
            if ($(customArgs.pvtGridObj.element).parents(".e-pivotclient").length > 0){
                $(customArgs.pvtGridObj.element).parents(".e-pivotclient").data("ejPivotClient")._trigger("drillThrough", { element: customArgs.pvtGridObj.element, data: gridJSON });
            }
            else
                customArgs.pvtGridObj._trigger("drillThrough", { element: customArgs.pvtGridObj.element, data: gridJSON });
        },

        _getFilterState: function (olapClientMode, members, item, controlObj) {
            var filterState = "";
            if (controlObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                if (olapClientMode) {
                    if (controlObj._fieldSelectedMembers[item.fieldName.toLowerCase()] == "All" || ej.isNullOrUndefined(controlObj._fieldSelectedMembers[item.fieldName.toLowerCase()]))
                        ej.olap._mdxParser.getAllMember(controlObj.model.dataSource, item.fieldName, controlObj);
                    filterState = (controlObj._fieldSelectedMembers[item.fieldName.toLowerCase()] == "All" || ej.isNullOrUndefined(controlObj._fieldSelectedMembers[item.fieldName.toLowerCase()]) ? controlObj._allMember : controlObj._fieldSelectedMembers[item.fieldName.toLowerCase()]);
                }
                else {
                    if (item.filterItems.filterType == "include") {
                        if (item.filterItems.values.length == 1)
                            filterState = item.filterItems.values[0];
                        else
                            filterState = controlObj._getLocalizedLabels("MultipleItems");
                    }
                    else {
                        if (members.length - (item.filterItems.values.indexOf("All") == -1 ? item.filterItems.values.length : item.filterItems.values.length - 1) == 1)
                            filterState = members.filter(function (itm) { if (item.filterItems.values.indexOf(itm.toString()) == -1) return itm });
                        else
                            filterState = controlObj._getLocalizedLabels("MultipleItems");
                    }
                }
            }
            else
            {
                if (controlObj.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var excludeMem = !ej.isNullOrUndefined(controlObj._tempFilterData) ? $.map(controlObj._tempFilterData, function (itm) { return itm[item.DimensionName] }) : [];
                    if (excludeMem.length > 0 && controlObj._fieldMembers[item.DimensionName])
                        filterState = controlObj._fieldMembers[item.DimensionName].length - excludeMem.length == 1 ? (controlObj._fieldMembers[item.DimensionName]).filter(function (itm) { if (excludeMem.indexOf(itm) == -1) return itm }) : controlObj._getLocalizedLabels("MultipleItems");
                    else
                        filterState = controlObj._getLocalizedLabels("All");
                }
                else {
                    filterState = (controlObj._fieldSelectedMembers[item.Tag] == "All" ? item.AllMember : controlObj._fieldSelectedMembers[item.Tag]) || item.AllMember;
                }
            }
            return filterState;
        },

        _getTreeViewItems: function (controlObj) {
            var treeElement = controlObj.element.find(".editorTreeView");
            var treeItems = [];
            var data = $(treeElement).find(':input.nodecheckbox');
            for (var i = 0; i < data.length; i++) {
                var parentNode = $(data[i]).parents('li:eq(0)');
                treeItems.push({ Id: parentNode[0].id, name: $(parentNode[0]).find('a:eq(0)').text() });
            }
            return treeItems;
        },

        _getEditorMember: function (data, controlObj, isSchema) {
            if (controlObj.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                var tmpItems = this._getTreeViewItems(isSchema ? controlObj._schemaData : controlObj);
                var ds = $.extend(true, [], isSchema ? controlObj._schemaData._memberTreeObj.dataSource() : controlObj._memberTreeObj.dataSource());
                var treeItems = $.map(tmpItems, function (item1) {
                    if (item1.Id != "All") {
                        $.map(ds, function (item2) {
                            if (item1.Id == item2.id) {
                                item1 = item2;
                                item1.name = ej.isNullOrUndefined(item1.parentId) ? item1.name + "_" + 1 : item1.name;
                            }
                        });
                        return item1;
                    }
                });
                var nodes = [];
                var items = $.map(treeItems, function (item1) {
                    $.map(treeItems, function (item2) {
                        if (item1.parentId == item2.id) {
                            item1.name = item1.name + "_" + (Number(item2.name.split('_')[item2.name.split('_').length - 1]) + 1);
                        }
                    });
                    return item1;
                });
                $.map(items, function (item) {
                    var val = item.name.split('_')[item.name.split('_').length - 2];
                    var lvl = Number(item.name.split('_')[item.name.split('_').length - 1]);
                    var chkState = item.checkedStatus;
                    nodes.push({ name: val, checked: chkState, level: Number(lvl) });
                });
               
                return this._updateEditorMembers(data, nodes, controlObj);
            }
            else {
                if (controlObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    var nodes = [];
                    if (controlObj.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && controlObj.model.enableMemberEditorPaging) {
                        var items = controlObj._editorTreeData;
                        $.map(items, function (item) {
                            var val = item.name;
                            var lvl = item.id.split('_')[item.id.split('_').length - 1];
                            var chkState = item.checkedStatus;
                            nodes.push({ name: val, checked: chkState, level: Number(lvl) });
                        });
                    }
                    else {
                        var treeElement = isSchema ? controlObj._schemaData.element.find('.editorTreeView') : controlObj.element.find(".editorTreeView");
                        var items = $(treeElement).find(':input.nodecheckbox');
                        $.map(items, function (item) {
                            if ($(item).parents('li:eq(0)').attr("id") != "All") {
                                var val = $(item).parent().siblings('a').text();
                                var lvl = item.value.split('_')[item.value.split('_').length - 1];
                                var chkState = item.checked || $(item.parentElement).attr('aria-checked') == 'mixed' ? true : false;
                                nodes.push({ name: val, checked: chkState, level: Number(lvl) });
                            }
                        });
                    }
                    return this._updateEditorMembers(data, nodes, controlObj);
                }
                else {
                    var textArr = [];
                    for (var i = 1; i < data.length; i++)
                        textArr.push($(data[i].parentElement).siblings("a").text());
                    return textArr;
                }
            }
        },

        _updateEditorMembers: function(data, nodes, controlObj){
            if (!ej.isNullOrUndefined(controlObj._fieldMembers[data])) {
                var tmpArray = [], buffer = 0, member = "";
                var savedFields = controlObj._fieldMembers[data];
                for (var i = 0; i < nodes.length; i++) {
                    if (ej.isNullOrUndefined(savedFields[i + buffer]) || nodes[i].level == savedFields[i + buffer].level) {
                        tmpArray.push(nodes[i]);
                    }
                    else if (ej.isNullOrUndefined(savedFields[i + buffer]) || nodes[i].level < savedFields[i + buffer].level) {
                        var count = i;
                        do {
                            if (nodes[i - 1].checked)
                                tmpArray.push(savedFields[count]);
                            buffer++;
                            count++;
                        } while (nodes[i].level < savedFields[count].level);
                        i--;
                    }
                    else if (ej.isNullOrUndefined(savedFields[i + buffer]) || nodes[i].level > savedFields[i + buffer].level) {
                        var svdlvl = savedFields[i + buffer].level;
                        var count = i;
                        do {
                            tmpArray.push(nodes[count]);
                            buffer--;
                            count++;
                            i = count - 1;
                        } while (nodes[count].level > svdlvl);
                    }
                }
            }
            controlObj._fieldMembers[data] = ej.isNullOrUndefined(controlObj._fieldMembers[data]) ? nodes : tmpArray;


            var lvl = 1, parent = "", state = "", checkedMembers = [];
            do {
                var lvlMembers = $.map(controlObj._fieldMembers[data], function (item) {
                  if (item.level == lvl)
                        return item;
                });
                checkedMembers = $.map(lvlMembers, function (item) {
                    if (item.checked)
                        return item;
                });
                if (lvlMembers.length == checkedMembers.length) {
                    member = lvl == 1 ? "All" : parent;
                    if (lvlMembers.length > 1)
                    state = "All";
                    lvl++;
                }
                else if (checkedMembers.length == 1) {
                    parent = member = state == "All" ? "multiple" : checkedMembers[0].name;
                    lvl++;
                }
                else if (checkedMembers.length > 1 && lvlMembers.length > checkedMembers.length) {
                    member = "multiple";
                    break;
                }
            } while (checkedMembers.length > 0 && member != "All" && member != "multiple" && $.map(controlObj._fieldMembers[data], function (item) { if (item.level == lvl) return item; }).length > 0);

            return member;
        },

        _getTreeData: function (args, successMethod, customArgs) {
            var conStr = ej.olap.base._getConnectionInfo(args.url);
            var xmlMsg = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>" + args.request + "</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + args.catalog + "</CATALOG_NAME>" +
           (customArgs.action == "loadcubelist" ? "" : "<CUBE_NAME>" + args.cube + "</CUBE_NAME>") + "</RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + args.catalog + "</Catalog><LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier> </PropertyList></Properties></Discover></Body></Envelope>";
            customArgs.action = "loadFieldElements";
            this.doAjaxPost("POST", conStr.url, { XMLA: xmlMsg }, successMethod, null, customArgs);
        },        

        updateTreeView: function (controlObj) {
            var treeViewElements = controlObj.element.find(".editorTreeView").find("li"),treeViewLength = treeViewElements.length, dataSource = controlObj._memberTreeObj.dataSource(),dSourceLen = dataSource.length;
            if (controlObj.element.find(".editorTreeView").parents("#" + controlObj._id + "_ClientDialog").children(".editorPara").text() == controlObj._getLocalizedLabels("KPIs")) {
                for (var i = 0; i < treeViewLength; i++) {
                    var isAreaChecked = $(treeViewElements[i]).find("span:first").attr('aria-checked');
                    for (var j = 0; j < dSourceLen; j++) {
                        if (treeViewElements[i]["id"] == dataSource[j]["id"] && (isAreaChecked == "mixed" || isAreaChecked == "true")) {
                            {
                                if (ej.isNullOrUndefined(dataSource[j]["parentId"]))
                                    dataSource[j]["checkedStatus"] = true;
                                else if ($(treeViewElements[i]["parentElement"]).parent().attr("id") == dataSource[j]["parentId"])
                                    dataSource[j]["checkedStatus"] = true;
                            }
                        }
                        else if (treeViewElements[i]["id"] == dataSource[j]["id"] && isAreaChecked == "false") {
                            {
                                if (ej.isNullOrUndefined(dataSource[j]["parentId"]))
                                    dataSource[j]["checkedStatus"] = false;
                                else if ($(treeViewElements[i]["parentElement"]).parent().attr("id") == dataSource[j]["parentId"])
                                    dataSource[j]["checkedStatus"] = false;
                            }
                        }
                    }
                }
            }
            else {
                for (var i = 0; i < treeViewLength; i++) {
                    var isAreaChecked = $(treeViewElements[i]).find("span:first").attr('aria-checked');
                    for (var j = 0; j < dSourceLen; j++) {
                        if (treeViewElements[i]["id"] == dataSource[j]["id"] && (isAreaChecked == "mixed" || isAreaChecked == "true")) {
                            dataSource[j]["checkedStatus"] = true;
                            break;
                        }
                        else if (treeViewElements[i]["id"] == dataSource[j]["id"] && isAreaChecked == "false") {
                            dataSource[j]["checkedStatus"] = false;
                            break;
                        }
                    }
                }
            }
            for (var i = 0; i < dataSource.length; i++) {
                var memberStatus = false;
                if (dataSource[i]["checkedStatus"] == true) {
                    for (var j = 0; j < dataSource.length; j++) {
                        if (dataSource[j].hasOwnProperty("parentId") && dataSource[j]["parentId"] == dataSource[i]["id"] && dataSource[j]["checkedStatus"] == true) {
                            memberStatus = true;
                            break;
                        }
                    }
                    if (!memberStatus) {
                        for (var m = 0; m < dataSource.length; m++) {
                            if (dataSource[m].hasOwnProperty("parentId") && dataSource[m]["parentId"] == dataSource[i]["id"])
                                dataSource[m]["checkedStatus"] = true;
                        }
                    }
                }
                else if (dataSource[i]["checkedStatus"] == false) {
                    for (var k = 0; k < dataSource.length; k++) {
                        if (dataSource[k].hasOwnProperty("parentId") && dataSource[k]["parentId"] == dataSource[i]["id"])
                            dataSource[k]["checkedStatus"] = false;
                    }
                }
            }
            for (var i = 0; i < treeViewLength; i++) {
                if ($(treeViewElements[i]).attr("tag") == null || undefined) {
                    for (var j = 0; j < dSourceLen; j++) {
                        if ($(treeViewElements[i]).attr("id") == dataSource[j]["id"]) {
                            $(treeViewElements[i]).attr("tag", dataSource[j]["tag"]);
                            break;
                        }
                    }
                }
            }
            return controlObj._memberTreeObj;
        },

        getNodesState: function (treeViewObj) {
            var selectedNodes = "", unSelectedNodes = "", dataSource = [];;
            if (treeViewObj.pluginName == "ejTreeView")
                dataSource = treeViewObj.dataSource();
            else
                dataSource = treeViewObj
            for (var i = 0; i < dataSource.length; i++) {
                if (dataSource[i].checkedStatus == true)
                    selectedNodes += "::" + dataSource[i].id + "||" + dataSource[i].tag + "||" + dataSource[i].parentId + "||" + dataSource[i].name;
                else
                    unSelectedNodes += "::" + dataSource[i].parentId + "||" + dataSource[i].tag + "||" + dataSource[i].name;
            }
            return { selectedNodes: selectedNodes, unSelectedNodes: unSelectedNodes };
        },

        removeParentSelectedNodes: function (selectedNodes) {
            var selectedElements = $.extend([], selectedNodes);
            for (var i = 0; i < selectedNodes.length; i++) {
                for (var j = 0; j < selectedElements.length; j++) {
                    if (selectedElements[j].Id == selectedNodes[i].parentId)
                        selectedElements.splice(j, 1);
                }
            }
            return $.map(selectedElements, function (element, index) { if (element.tag != "" && element.tag != undefined) return element.tag.replace(/\&/g, "&amp;") });
        },

        getChildNodes: function (args, currentHierarchy, treeViewCollection, dataSource, ctrlObj) {
            var selectedItem = args.targetElement, tagInfo, cubeName = dataSource.cube, catloagName = dataSource.catalog, url = dataSource.data, successMethod = ctrlObj._generateChildMembers, childCount = $(args.currentElement).find("li").length, isLoadOnDemand = false;
            if (childCount == 0) {
                var onLoad = ej.buildTag("span.nodeExpand e-load e-icon")[0].outerHTML;
                var currMember = $(selectedItem).parents("li:eq(0)").attr("id");
                var reportItem = $.map(treeViewCollection, function (obj, index) {
                    if (obj["fieldName"] == currentHierarchy && !ej.isNullOrUndefined(obj["filterItems"])) {
                        var filterItems = obj["filterItems"];
                        if (ej.isNullOrUndefined(ctrlObj.model.pivotControl) ? ctrlObj.model.enableMemberEditorPaging : ctrlObj.model.pivotControl.model.enableMemberEditorPaging) {
                            filterItems = $.map(filterItems, function (obj, index) {
                                if (obj["pid"] != undefined && obj["pid"] == currMember.replace(/\]*\]/g, '-').replace(/\[*\[/g, '-')) {
                                    isLoadOnDemand = true;
                                    return obj;
                                }
                            });
                            if (filterItems.length > 0 && isLoadOnDemand == true) {
                                $(selectedItem).parents("li:eq(0)").find(".nodeExpand").remove();
                                $(selectedItem).parents("li:eq(0)").find(".e-load").removeClass("e-load");
                                $.each(filterItems, function (index, value) { delete value.parentId });
                                ctrlObj._memberTreeObj.model.nodeCheck = null;
                                ctrlObj._memberTreeObj.model.nodeUncheck = null;
                                ctrlObj._memberTreeObj.addNode(filterItems, $(selectedItem).parents("li:eq(0)"));
                                ctrlObj._memberTreeObj.model.nodeCheck = ej.proxy(ctrlObj._nodeCheckChanges, ctrlObj);
                                ctrlObj._memberTreeObj.model.nodeUncheck = ej.proxy(ctrlObj._nodeCheckChanges, ctrlObj);
                                $.each($(selectedItem).parents("li:eq(0)").find("li"), function (index, value) { value.setAttribute("tag", filterItems[index].tag); });
                            }
                        }
                        else {
                            $.map(filterItems, function (obj, index) {
                                if (obj["parentId"] != undefined && obj["parentId"] == currMember.replace(/\]*\]/g, '-').replace(/\[*\[/g, '-'))
                                    isLoadOnDemand = true;
                            });
                        }
                    }
                });
                isLoadOnDemand ? args.isChildLoaded = true : args.isChildLoaded = false
                if (!isLoadOnDemand) {
                    $(selectedItem).parents("li:eq(0)").prepend(onLoad);
                    if ($(selectedItem).parents("li:eq(0)").attr("tag") == undefined) {
                        var filterItem = $.map(treeViewCollection, function (obj, index) { if (obj["fieldName"] == currentHierarchy) return obj; })[0]
                        if (filterItem)
                            $.map(filterItem["filterItems"], function (obj, index) { if (obj["id"] == $(selectedItem).parents("li:eq(0)").attr("id")) $(selectedItem).parents("li:eq(0)").attr("tag", obj["tag"]); });
                    }
                    var uniqueName = $(selectedItem).parents("li:eq(0)").attr("tag").replace(/\&/g, "&amp;");
                    ej.olap._mdxParser.getChildren(dataSource, uniqueName, ctrlObj);
                }
            }
        },
        _getFilterParams: function (droppedClass, tempFilterData, headerText) {
            var filterParams = "";
            if (droppedClass != "schemaValue") {
                var filterData = "";
                if (!ej.isNullOrUndefined(tempFilterData)) {
                    for (var i = 0; i < tempFilterData.length; i++) {
                        if (!ej.isNullOrUndefined(tempFilterData[i][headerText])) {
                            for (var j = 0; j < tempFilterData[i][headerText].length; j++) {
                                filterData += "##" + tempFilterData[i][headerText][j];
                            }
                        }
                    }
                }
                if (filterData != "")
                    filterParams = droppedClass + "::" + headerText + "::FILTERED" + filterData;
            }
            return filterParams;
        },
        generateChildMembers: function (customArgs, args) {
            var data = $(args).find("Axis:eq(0) Tuple"), treeViewData = [];
            var pNode = $("[tag='" + customArgs.currentNode.replace(/&amp;/g, "&") + "']");
            for (var i = 0; i < data.length; i++) {
                var memberUqName = $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[0]).text();
                var memberName = $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children()).find("Caption").text() == "" ? "(Blank)" : $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children()).find("Caption").text();
                var treeNodeInfo = { hasChildren: $(data[i]).find("CHILDREN_CARDINALITY").text() != "0", checkedStatus: false, id: memberUqName.replace(/\]*\]/g, '-').replace(/\[*\[/g, '-'), name: memberName, tag: memberUqName, level: parseInt($(data[i]).find("LNum").text()) }
                treeViewData.push(treeNodeInfo);
            }
            if ($(pNode).parents("li").length > 1)
                parentNode = $(pNode).parents("li").first();
            else
                parentNode = $(pNode).parents("li");
            $($(parentNode).find('input.nodecheckbox')[0]).ejCheckBox({ checked: false })
            this._memberTreeObj = $(".editorTreeView").data("ejTreeView");
            var controlObj = this;
            if (!ej.isNullOrUndefined(controlObj.olapCtrlObj))
                controlObj = controlObj.olapCtrlObj;
            if (treeViewData.length > 0 && (controlObj.pluginName == "ejPivotSchemaDesigner" ? controlObj.model.pivotControl.model.enableMemberEditorPaging : controlObj.model.enableMemberEditorPaging)) {
                var hierarchyName = controlObj.pluginName == "ejPivotGrid" ? controlObj._selectedField : controlObj._selectedFieldName;
                $.map(controlObj.pluginName == "ejPivotSchemaDesigner" ? controlObj.model.pivotControl._currentReportItems : controlObj._currentReportItems, function (obj, index) {
                    if (obj["fieldName"] == hierarchyName && !ej.isNullOrUndefined(obj["filterItems"])) {
                        $.each(treeViewData, function (index, value) { value.pid = $(pNode).attr("id"); });
                        $.merge(obj["filterItems"], treeViewData);
                        controlObj._editorTreeData = obj["filterItems"];
                    }
                });
            }
            pNode.find(".nodeExpand").remove();
            pNode.find(".e-load").removeClass("e-load");
            this._memberTreeObj.addNode(treeViewData, $(pNode));
            $.each(pNode.find("li"), function (index, value) { value.setAttribute("tag", treeViewData[index].tag); });
        },

        createAdvanceFilterTag: function (args, ctrlObj) {
            var filterTag = "", seperator = ej.buildTag("li.e-separator").css("margin-left", "29px")[0].outerHTML, opMode = ctrlObj.element.hasClass("e-pivotschemadesigner") ? ctrlObj.model.pivotControl.model.operationalMode : ctrlObj.model.operationalMode, analysisMode = ctrlObj.element.hasClass("e-pivotschemadesigner") ? ctrlObj.model.pivotControl.model.analysisMode : ctrlObj.model.analysisMode;
            if (args.action == "filterTag") {
                filterTag = [{ id: "ascOrder", text: ctrlObj._getLocalizedLabels("SortAtoZ"), parentId: null, spriteCssClass: "ascImage e-icon" },
                         { id: "descOrder", text: ctrlObj._getLocalizedLabels("SortZtoA"), parentId: null, spriteCssClass: "descImage e-icon" },
                         { id: "clearSorting", text: ctrlObj._getLocalizedLabels("ClearSorting"), parentId: null, spriteCssClass: "e-clrSort e-icon" },
                         { id: "sep", parentId: null, text: "", spriteCssClass: "e-seperator" },
                         { id: "clearAllFilters", text: ctrlObj._getLocalizedLabels("ClearFilterFrom"), parentId: null, spriteCssClass: "e-clrFilter e-icon" },
                         { id: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("LabelFilters"), parentId: null },
                         { id: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("ValueFilters"), parentId: null },
                         { id: "labelClearFilter", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("ClearFilter"), spriteCssClass: "e-clrFilter e-icon" },
                         { id: "sep", parentId: "labelFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "equals", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("Equals"), spriteCssClass: "sprite" },
                         { id: "notequals", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("DoesNotEquals") + "...", spriteCssClass: "sprite" },
                         { id: "sep", parentId: "labelFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "beginswith", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("BeginsWith") + "...", spriteCssClass: "sprite" },
                         { id: "notbeginswith", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("DoesNotBeginsWith") + "...", spriteCssClass: "sprite" },
                         { id: "endswith", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("EndsWith") + "...", spriteCssClass: "sprite" },
                         { id: "notendswith", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("DoesNotEndsWith") + "...", spriteCssClass: "sprite" },
                         { id: "sep", parentId: "labelFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "contains", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("Contains") + "...", spriteCssClass: "sprite" },
                         { id: "notcontains", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("DoesNotContains") + "...", spriteCssClass: "sprite" },
                         { id: "sep", parentId: "labelFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "greaterthan", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("GreaterThan") + "...", spriteCssClass: "sprite" },
                         { id: "greaterthanorequalto", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("GreaterThanOrEqualTo") + "...", spriteCssClass: "sprite" },
                         { id: "lessthan", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("LessThan") + "...", spriteCssClass: "sprite" },
                         { id: "lessthanorequalto", parentId: "labelFilterBtn", text: ctrlObj._getLocalizedLabels("LessThanOrEqualTo") + "...", spriteCssClass: "sprite" },
                         { id: "valueClearFilter", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("ClearFilter"), spriteCssClass: "e-clrFilter e-icon" },
                         { id: "sep", parentId: "valueFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "equals", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("Equals"), spriteCssClass: "equals" },
                         { id: "notequals", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("DoesNotEquals") + "...", spriteCssClass: "sprite" },
                         { id: "sep", parentId: "valueFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "greaterthan", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("GreaterThan") + "...", spriteCssClass: "sprite" },
                         { id: "greaterthanorequalto", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("GreaterThanOrEqualTo") + "...", spriteCssClass: "sprite" },
                         { id: "lessthan", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("LessThan") + "...", spriteCssClass: "sprite" },
                         { id: "lessthanorequalto", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("LessThanOrEqualTo") + "...", spriteCssClass: "sprite" },
                         { id: "sep", parentId: "valueFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "between", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("Between") + "...", spriteCssClass: "sprite" },
                         { id: "notbetween", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("NotBetween") + "...", spriteCssClass: "sprite" },
                         { id: "sep", parentId: "valueFilterBtn", text: "", spriteCssClass: "e-seperator" },
                         { id: "topCount", parentId: "valueFilterBtn", text: ctrlObj._getLocalizedLabels("Top10") + "...", spriteCssClass: "sprite" }
                ];

                if (opMode == ej.Pivot.OperationalMode.ClientMode || (opMode == ej.Pivot.OperationalMode.ServerMode && analysisMode == ej.Pivot.AnalysisMode.Pivot)) 
                    filterTag.splice(filterTag.length - 1, 2);


            }
            else if (args.action == "clearFilter") {
                filterTag = ej.buildTag("div.clearSorting", ej.buildTag("span.e-clrSort", "", { "padding": "0px 10px 0px 4px" }).addClass("e-icon").attr("aria-label", "clear sort")[0].outerHTML + ej.buildTag("span.clearSortText", "Clear Sorting", { "padding": "5px 0px" })[0].outerHTML)[0].outerHTML + ej.buildTag("div.separator", { "padding": "5px 0px" })[0].outerHTML +
                           ej.buildTag("div.clearAllFilters", ej.buildTag("span.e-clrFilter", "", { "padding": "0px 10px 0px 4px" }).addClass("e-icon").attr("aria-label", " clear filter")[0].outerHTML + ej.buildTag("span.clearFltrText", "Clear Filter From\"" + args.selectedLevel.text + "\"", { "padding": "5px 0px" })[0].outerHTML)[0].outerHTML;
            }
            else if (args.action == "sort") {
                filterTag = ej.buildTag("div#sortDiv.sortDiv",
                            ej.buildTag("li#ascOrder.ascOrder", ej.buildTag("span.ascImage").addClass("e-icon").attr("aria-label", "ascending")[0].outerHTML + ctrlObj._getLocalizedLabels("Sort") + " A to Z")[0].outerHTML +
                            ej.buildTag("li#descOrder.descOrder", ej.buildTag("span.descImage").addClass("e-icon").attr("aria-label", "descending")[0].outerHTML + ctrlObj._getLocalizedLabels("Sort") + " Z to A")[0].outerHTML)[0].outerHTML;
            }
            else if (args.action == "labelFilterDlg" || args.action == "valueFilterDlg") {

                var dialogContent = "", dropdownValues = [];
                if (args.action == "labelFilterDlg") {
                    dialogContent = ej.buildTag("table.labelfilter",
                                            ej.buildTag("tr", ej.buildTag("td", ctrlObj._getLocalizedLabels("LabelFilterLabel")).attr("colspan", "2")[0].outerHTML)[0].outerHTML +
                                            ej.buildTag("tr", ej.buildTag("td", "<input type='text' id='filterOptions' class='filterOptions'  style='width:220px'/>")[0].outerHTML +
                                            ej.buildTag("td.filterValuesTd", "<input type='text' id='filterValue1'  value='" + (args.filterInfo.length > 0 ? (opMode == ej.Pivot.OperationalMode.ClientMode ? args.filterInfo[0].values[0] : args.filterInfo[0].value1) : "") + "' style='display:inline; width:160px; height:19px; margin-left:7px;' class='filterValues'/></br>")[0].outerHTML)[0].outerHTML)[0].outerHTML;

                    dropdownValues = [{ value: "equals", option: ctrlObj._getLocalizedLabels("Equals").toLowerCase() },
                                          { value: "not equals", option: ctrlObj._getLocalizedLabels("DoesNotEquals").toLowerCase() },
                                          { value: "begins with", option: ctrlObj._getLocalizedLabels("BeginsWith").toLowerCase() },
                                          { value: "not begins with", option: ctrlObj._getLocalizedLabels("DoesNotBeginsWith").toLowerCase() },
                                          { value: "ends with", option: ctrlObj._getLocalizedLabels("EndsWith").toLowerCase() },
                                          { value: "not ends with", option: ctrlObj._getLocalizedLabels("DoesNotEndsWith").toLowerCase() },
                                          { value: "contains", option: ctrlObj._getLocalizedLabels("Contains").toLowerCase() },
                                          { value: "not contains", option: ctrlObj._getLocalizedLabels("DoesNotContains").toLowerCase() },
                                          { value: "greater than", option: ctrlObj._getLocalizedLabels("IsGreaterThan").toLowerCase() },
                                          { value: "greater than or equal to", option: ctrlObj._getLocalizedLabels("IsGreaterThanOrEqualTo").toLowerCase() },
                                          { value: "less than", option: ctrlObj._getLocalizedLabels("IsLessThan").toLowerCase() },
                                          { value: "less than or equal to", option: ctrlObj._getLocalizedLabels("IsLessThanOrEqualTo").toLowerCase() },
                    ];
                }
                else {
                    var measureNames = new Array(), innerContent, colSpan = ($(args["selectedArgs"].element).attr("id") == ("between") || $(args["selectedArgs"].element).attr("id") == ("notbetween") || (args["selectedArgs"].value == "between" || args["selectedArgs"].value == "not between")) ? "4" : "3";
                    if (ctrlObj.element.find(".cubeTreeView ").length > 0) {
                        measureNames = $.map(ctrlObj.element.find(".cubeTreeView [tag*='[Measures]'] "), function (currentElement, index) { return { option: $(currentElement).text(), value: $(currentElement).attr("tag") } });
                    }
                    else {
                        var pvtBtns = ctrlObj.element.hasClass("e-pivotschemadesigner") ? ctrlObj.element.find(".schemaValue .pivotButton") : ctrlObj.element.find(".groupingBarPivot .values .pivotButton");
                        pvtBtns = (ctrlObj._schemaData && pvtBtns.length == 0) ? $(ctrlObj._schemaData.element.find(".schemaValue .pivotButton")) : pvtBtns;
                        for (i = 0; i < pvtBtns.length; i++) {
                            measureNames.push({ "option": $(pvtBtns[i]).text(), "value": $(pvtBtns[i]).attr("tag").split(":")[1] });
                        }
                    }
                    innerContent = !($(args["selectedArgs"].element).hasClass("topCount")) ?
                                     (ej.buildTag("td", "<input type='text' id='filterMeasures' class='filterMeasures' />").attr("width", "180px")[0].outerHTML +
                                     ej.buildTag("td", "<input type='text' id='filterOptions' class='filterOptions'/>").attr("width", "180px")[0].outerHTML +
                                     ej.buildTag("td.filterValuesTd", "<input type='text' id='filterValue1' value='" + (args.filterInfo.length > 0 ? (opMode == ej.Pivot.OperationalMode.ClientMode ? args.filterInfo[0].values[0] : args.filterInfo[0].value1) : "") + "' style='display:inline; width:190px; height:19px;' class='filterValues'/>" + (colSpan == "4" ? "<span>"+ ctrlObj._getLocalizedLabels("and")+" </span><input type='text' id='filterValue2' value='" + (args.filterInfo.length > 0 ? (opMode == ej.Pivot.OperationalMode.ClientMode && !ej.isNullOrUndefined(args.filterInfo[0].values[1])) ? args.filterInfo[0].values[1] : ((opMode == ej.Pivot.OperationalMode.ServerMode && !ej.isNullOrUndefined(args.filterInfo[0].value2)) ? args.filterInfo[0].value2 : "") : "") + "' style='display:inline; width:190px; height:19px;' class='filterValues'/> </br>" : "</br>"))[0].outerHTML) :

                                     ej.buildTag("td", "<input type='text' id='filterOptions' class='filterOptions' />").attr("width", "80px")[0].outerHTML +
                                     ej.buildTag("td", "<input type='text' id='filterValue1' class='filterValues' />").attr("width", "50px")[0].outerHTML +
                                     ej.buildTag("td", "<input type='text' id='filterMeasures' class='filterMeasures' />").attr("width", "180px")[0].outerHTML;

                    dialogContent = ej.buildTag("table.valuefilter",
                                     ej.buildTag("tr", ej.buildTag("td", (ctrlObj._getLocalizedLabels("ValueFilterLabel"))).attr("colspan", (args.text == "Between" ? "4" : "3"))[0].outerHTML)[0].outerHTML +
                                     ej.buildTag("tr", innerContent)[0].outerHTML)[0].outerHTML;

                    dropdownValues = [{ value: "equals", option: ctrlObj._getLocalizedLabels("Equals").toLowerCase() },
                                      { value: "not equals", option: ctrlObj._getLocalizedLabels("DoesNotEquals").toLowerCase() },
                                      { value: "greater than", option: ctrlObj._getLocalizedLabels("IsGreaterThan").toLowerCase() },
                                      { value: "greater than or equal to", option: ctrlObj._getLocalizedLabels("IsGreaterThanOrEqualTo").toLowerCase() },
                                      { value: "less than", option: ctrlObj._getLocalizedLabels("IsLessThan").toLowerCase() },
                                      { value: "less than or equal to", option: ctrlObj._getLocalizedLabels("IsLessThanOrEqualTo").toLowerCase() },
                                      { value: "between", option: ctrlObj._getLocalizedLabels("Between").toLowerCase() },
                                      { value: "not between", option: ctrlObj._getLocalizedLabels("NotBetween").toLowerCase() }];
                }
                var dialogFooter = ej.buildTag("div", ej.buildTag("button#filterDlgOKBtn.dialogOKBtn", "OK")[0].outerHTML + ej.buildTag("button#filterDlgCancelBtn.dialogCancelBtn", "Cancel")[0].outerHTML, { "float": ctrlObj.model.enableRTL ? "left" : "right", "margin": "8px 0 6px" })[0].outerHTML;
                ctrlObj.element.find(".e-dialog").remove();
                $(ej.buildTag("div#filterDialog.filterDialog", dialogContent + dialogFooter, { "opacity": "1" })).appendTo("#" + ctrlObj._id);
                ctrlObj.element.find(".filterDialog").ejDialog({ enableRTL: ctrlObj.model.enableRTL, enableResize: false, cssClass: "labelValueFilterDlg", width: "auto", content: "#" + ctrlObj._id, close: ej.proxy(ej.Pivot.closePreventPanel, ctrlObj) });
                if (args.action == "valueFilterDlg") {
                    ctrlObj.element.find(".filterMeasures").ejDropDownList({ dataSource: measureNames, width: "180px", height: "25px", fields: { text: "option", value: "value" }, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
                    ctrlObj._measureDDL = ctrlObj.element.find(".filterMeasures").data("ejDropDownList");

                    var selectedMeasure = measureNames.length > 0 ? measureNames[0].value : (args.filterInfo.length > 0) ? args.filterInfo[0].measure : ""
                    if (selectedMeasure != "")
                        ctrlObj._measureDDL.selectItemByValue(selectedMeasure);
                }

                if ($(args["selectedArgs"].element).attr("id") == "topCount") {
                    ctrlObj.element.find("#filterOptions").ejDropDownList({
                        dataSource: [{ option: "Top", value: "topCount" }, { option: "Bottom", value: "BottomCount" }],
                        fields: { text: "option", value: "value" },
                        value: (args.filterInfo.length > 0) ? args.filterInfo[0]["operator"] : "topCount",
                        create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                    });
                    ctrlObj.element.find("#filterValue1").ejNumericTextbox({ value: (args.filterInfo.length > 0) ? parseInt(args.filterInfo[0].value1) : 5, minValue: 1 });
                }
                else {
                    var selectedIndex = $(args.selectedArgs.element).parent().children("li:not(#sep)").index(args.selectedArgs.element)
                    ctrlObj.element.find(".filterOptions").ejDropDownList({
                        dataSource: dropdownValues, width: "180px",
                        height: "25px", fields: { value: "value", text: "option", },
                        selectedIndices: [selectedIndex - 1],
                        change: ej.proxy(ctrlObj._filterOptionChanged, ctrlObj),
                        create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                    });
                    if ($(args.selectedArgs.element).length == 0)
                    {
                        var filterDDL = ctrlObj.element.find(".filterOptions").data("ejDropDownList");
                        filterDDL.selectItemByValue(args.selectedArgs.selectedValue);
                    }
                }
                ctrlObj.element.find("#filterDlgOKBtn").ejButton({
                    type: ej.ButtonType.Button,
                    click: ej.proxy(ctrlObj._filterElementOkBtnClick, ctrlObj)
                });
                ctrlObj.element.find("#filterDlgCancelBtn").ejButton({
                    type: ej.ButtonType.Button, click: function () {
                        $(".e-dialog").hide();
                        ej.Pivot.closePreventPanel(ctrlObj);
                    }
                });
                ctrlObj.element.find(".e-titlebar").prepend(ej.buildTag("div", (args.action == "valueFilterDlg" ? (ctrlObj._getLocalizedLabels("ValueFilters") + "(") : (ctrlObj._getLocalizedLabels("LabelFilters") + "(") )+(ctrlObj._selectedLevelUniqueName.indexOf(".") == -1 ? ctrlObj._selectedLevelUniqueName : (ctrlObj._selectedLevelUniqueName.indexOf(".") < 0 ? ctrlObj._selectedLevelUniqueName : ctrlObj._selectedLevelUniqueName.split('.')[2].replace(/\[/g, '').replace(/\]/g, ''))) + ")", { "display": "inline" }));
            }
            return filterTag;
        }
    }
    ej.Pivot.SortOrder = {
        None: "none",
        Ascending: "ascending",
        Descending: "descending"
    }

    ej.Pivot.AdvancedFilterType = {
        LabelFilter: "label",
        ValueFilter: "value"
    }

    ej.Pivot.ValueFilterOptions = {
        None: "none",
        Equals: "equals",
        NotEquals: "notequals",
        GreaterThan: "greaterthan",
        GreaterThanOrEqualTo: "greaterthanorequalto",
        LessThan: "lessthan",
        LessThanOrEqualTo: "lessthanorequalto",
        Between: "between",
        NotBetween: "notbetween"
    }

    ej.Pivot.LabelFilterOptions = {
        None: "none",
        BeginsWith: "beginswith",
        NotBeginsWith: "notbeginswith",
        EndsWith: "endswith",
        NotEndsWith: "notendswith",
        Contains: "contains",
        NotContains: "notcontains",
        Equals: "equals",
        NotEquals: "notequals",
        GreaterThan: "greaterthan",
        GreaterThanOrEqualTo: "greaterthanorequalto",
        LessThan: "lessthan",
        LessThanOrEqualTo: "lessthanorequalto",
        Between: "between",
        NotBetween: "notbetween"

    }
    ej.Pivot.AnalysisMode = {
        Olap: "olap",
        Pivot: "pivot"
    };
    ej.Pivot.OperationalMode = {
        ClientMode: "clientmode",
        ServerMode: "servermode"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview PivotGrid control to visualize the data
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.olap = ej.olap || {};

    ej.widget("ejPivotGrid", "ej.PivotGrid", {

        _rootCSS: "e-pivotgrid",
        element: null,
        model: null,
        _requiresID: true,
        validTags: ["div", "span"],
        defaults: {
            url: "",
            cssClass: "",
            jsonRecords: "",
            currentReport: "",
            layout: "normal",
            analysisMode: "olap",
            operationalMode: "clientmode",
            filterType:"filterType",
            enablePivotFieldList: true,
            enableGroupingBar: false,
            enableDeferUpdate: false,
            enableJSONRendering: false,
            enableVirtualScrolling: false,
            enablePaging: false,
            enableColumnResizing:false,
            enableContextMenu: false,
            enableCellContext: false,
            enableRTL: false,
            enableToolTip: true,
            enableToolTipAnimation: true,
            enableCellSelection: false,
            enableConditionalFormatting: false,
			enableCellEditing : false,
            enableColumnGrandTotal: true,
            enableRowGrandTotal: true,
            enableGrandTotal: true,
            enableCollapseByDefault: false,
            enableCellDoubleClick: false,
			enableDrillThrough: false,
			isResponsive: false,
			enableAdvancedFilter: false,
			showUniqueNameOnPivotButton: false,
			enableMemberEditorPaging:false,
			editCellsInfo: {},
            hyperlinkSettings: {
                enableValueCellHyperlink: false,
                enableRowHeaderHyperlink: false,
                enableColumnHeaderHyperlink: false,
                enableSummaryCellHyperlink: false
            },
            headerSettings: {
                showRowItems: false,
                showColumnItems: false
            },
            frozenHeaderSettings: {
                enableFrozenRowHeaders: false,
                enableFrozenColumnHeaders: false,
                enableFrozenHeaders: false,
                scrollerSize: 18
            },
            valueSortSettings:{
                headerText:"",
                headerDelimiters:"##",
                sortOrder:ej.PivotAnalysis.SortOrder.None
            },
            serviceMethodSettings: {
                initialize: "InitializeGrid",
                drillDown: "DrillGrid",
                exportPivotGrid: "Export",
                paging: "Paging",
                fetchMembers: "FetchMembers",
                nodeStateModified: "NodeStateModified",
                nodeDropped: "NodeDropped",
                filtering: "Filtering",
                sorting: "Sorting",
                valueSorting:"ValueSorting",
                deferUpdate: "DeferUpdate",
                memberExpand: "MemberExpanded",
                writeBack: "WriteBack",
                cellEditing : "CellEditing",
                saveReport: "SaveReport",
                loadReport: "LoadReportFromDB",
                calculatedField: "CalculatedField",
                drillThroughHierarchies: "DrillThroughHierarchies",
                drillThroughDataTable: "DrillThroughDataTable",
                removeButton:"RemoveButton"
            },
            customObject: {},
            locale: "en-US",
            dataSource: {
                data: null,
                sourceInfo: "",
                providerName:"ssas",
                enableAdvancedFilter: false,
                isFormattedValues: false,
                reportName: "Default",
                columns: [],
                cube: "",
                catalog:"",
                rows: [],
                values: [],
                filters: [],
                pagerOptions: {
                    categoricalPageSize: 0,
                    seriesPageSize: 0,
                    categoricalCurrentPage: 0,
                    seriesCurrentPage: 0
                }
            },
            pivotTableFieldListID:"",
            collapsedMembers: null,
            cellSelection: null,
            valueCellHyperlinkClick: null,
            rowHeaderHyperlinkClick: null,
            columnHeaderHyperlinkClick: null,
            summaryCellHyperlinkClick: null,
            beforeServiceInvoke: null,
            afterServiceInvoke: null,
            drillThrough: null,
            drillSuccess: null,
            cellContext: null,
            load: null,
            renderComplete: null,
            renderFailure: null,
            renderSuccess: null,
            cellDoubleClick: null,
            applyFieldCaption: null,
            beforeExport:null,
			beforePivotEnginePopulate: null,
            saveReport: null,
            loadReport: null,
            cellEdit: null,
            memberEditorPageSize:100
        },

        dataTypes: {
            dataSource: {
                data: "data",
                columns: "array",
                rows: "array",
                values: "array",
                filters: "array"
            },
            serviceMethodSettings: {
                initialize: "enum",
                drillDown: "enum",
                exportPivotGrid: "enum",
                paging: "enum",
                fetchMembers: "enum",
                nodeStateModified: "enum",
                nodeDropped: "enum",
                filtering: "enum",
                sorting: "enum",
                deferUpdate: "enum",
                memberExpand: "enum",
                writeBack: "enum",
                cellEditing: "enum",
                saveReport: "enum",
                loadReport: "enum",
                calculatedField: "enum",
                drillThroughHierarchies: "enum",
                drillThroughDataTable: "enum",
                removeButton: "enum"
            },
            customObject: "data",
        },

        observables: ["layout", "enableCellContext", "hyperlinkSettings.enableValueCellHyperlink", "hyperlinkSettings.enableRowHeaderHyperlink", "hyperlinkSettings.enableColumnHeaderHyperlink", "hyperlinkSettings.enableSummaryCellHyperlink"],
        layout: ej.util.valueFunction("layout"),
        enableCellContext: ej.util.valueFunction("enableCellContext"),
        enableValueCellHyperlink: ej.util.valueFunction("hyperlinkSettings.enableValueCellHyperlink"),
        enableRowHeaderHyperlink: ej.util.valueFunction("hyperlinkSettings.enableRowHeaderHyperlink"),
        enableColumnHeaderHyperlink: ej.util.valueFunction("hyperlinkSettings.enableColumnHeaderHyperlink"),
        enableSummaryCellHyperlink: ej.util.valueFunction("hyperlinkSettings.enableSummaryCellHyperlink"),
        locale: ej.util.valueFunction("locale"),

        getOlapReport: function () {
            return this._olapReport;
        },

        setOlapReport: function (value) {
            this._olapReport = value;
        },

        getJSONRecords: function () {
            return this._JSONRecords;
        },

        setJSONRecords: function (value) {
            this._JSONRecords = $.parseJSON(value);
        },

        _init: function () {
            this._initPrivateProperties();
            this._load();
        },

        _destroy: function () {
            if ($(this.element).next().length > 0 && $(this.element).next()[0].className == "pGridTooltip")
                $(this.element).next().remove();
            this.element.empty().removeClass("e-pivotgrid" + this.model.cssClass);
            if (this._waitingPopup != undefined)
                this._waitingPopup._destroy();
        },

        _initPrivateProperties: function () {
            this._id = this.element.attr("id");
            this._olapReport = "";
            this._JSONRecords = null;
            this._excelLikeJSONRecords = null;
            this._drillCaption = "";
            this._drillAction = "";
            this._startDrilldown = false;
            this._pagerObj = null;
            this._seriesPageCount = null;
            this._categPageCount = null;
            this._seriesCurrentPage = 1;
            this._categCurrentPage = 1;
            this._drillHeaders = new Array();
            this._collapsedRowHeaders = new Array();
            this._isDragging = false;
            this._droppedClass = "";
            this._dataModel = "";
            this._ascdes = "";
            this._filterUpdate = new Array();
            this._pivotRow = new Array();
            this._pivotColumn = new Array();
            this._pivotCalculation = new Array();
            this._pivotFilter = new Array();
            this._pivotTableFields = new Array();
            this._schemaData = null;
            this._waitingPopup = null;
            this._oriX = null;
            this._oriY = null;
            this._startPosCell = null;
            this._maxViewLoading = null;
            this._list = new Array();
            this._list.push(this._getLocalizedLabels("AddNew"));
            this._rowCount = 0;
            this._excelRowCount = 0;
            this._dialogTitle = "";
            this._selectedField = "";
            this._selectedAxis = "";
            this._isUpdateRequired = false;
            this._isMembersFiltered = false;
            this._selectedCell = null;
            this._onholdKey = "";
            this._primaryCellPos = "";
            this._currentReportItems = [];
			this._rowHeader = [];
			this._colHeader = [];
			this._cellInfo = [];
            this._editorFlag = true;
            this._isSubTotalHide = false;
            this._isSubTotalhidden = false;
			this._dimension;
			this._calculatedField = [];
			this._isFormatApply = false;
			this._cFormat = [];
			this._curFocus = { cell: null, tab: null, tree: null, cformat: null, grp: null, selection: null, filter: null, field: null, formula: null };
			this._index = { index: 0, grp: 1, cell: 1, dialog: 1, paging: 1, cformat: 1, filter: 0, field: 0, formula: 0 };
			var i, j, k, l;
			this._dataSet = [];
			this._currentCell = -1;
			this._target = null;
		    this._orgX = null;
			this._orgY = null;
			this._expand = false;
			this._excelFilterInfo = [];
			this._pagingSavedObjects = {
			    drillEngine: [],
			    savedHdrEngine: [],
			    curDrilledItem: {}
			};
			this._isSchemaInitialize = true;
			this._fieldMembers = {};
			this._fieldSelectedMembers = {};
			this._allMember = "";
			this._selectedMeasure = "";
			this._selectedFormat = "";
			this._dialogName = "";
			this._pivotClientObj = null;
			this._memberPageSettings = {
			    currentMemeberPage: 1,
			    startPage: 0,
			    endPage: 0
			};
			this._isAllMemberChecked = true;
			this._editorTreeData = [];
			this._memberPagingAvdData = [];
        },

        _load: function () {
            var eventArgs = { element: this.element, customObject: this.model.customObject };
            if (this.model.enableAdvancedFilter || this.model.dataSource.enableAdvancedFilter)
                this.model.dataSource.enableAdvancedFilter = this.model.enableAdvancedFilter=true;
            if (this.model.enableCellEditing && this.model.enableCellSelection)
                this.model.enableCellSelection = false;
            this._trigger("load", eventArgs);
            this.element.addClass(this.model.cssClass);
            if ($(this.element).parents(".e-pivotclient").length > 0) {
                this._pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                if ($("#" + this._pivotClientObj._id + "_maxView")[0])
                    $("#" + this._pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                if (ej.isNullOrUndefined(this._waitingPopup) && !ej.isNullOrUndefined(this._pivotClientObj._waitingPopup))
                    this._waitingPopup = this._pivotClientObj._waitingPopup;
                this._waitingPopup.show();
            }
            else {
                if (ej.isNullOrUndefined(this._waitingPopup)) {
                    $("#" + this._id).ejWaitingPopup({ showOnInit: true });
                    this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
                }
            }
            this._waitingPopup.show();
            if (this.model.enableJSONRendering) {
                this.setJSONRecords(this.model.jsonRecords)
                if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
                    this.excelLikeLayout(this.getJSONRecords());
                else
                    this.renderControlFromJSON();
            }
            else if (ej.isNullOrUndefined(this.model.dataSource.data) && this.model.url == "" && !ej.isNullOrUndefined(this._pivotClientObj)) {
                this.renderControlFromJSON();
                this._waitingPopup.hide();
            }
            else {
                if ((this.model.dataSource.data == null && this.model.url != "") || (this.model.dataSource.data != null && this.model.url != "" && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)) {
                    this.model.operationalMode = ej.Pivot.OperationalMode.ServerMode;
                    if (!ej.isNullOrUndefined(this.model.beforeServiceInvoke))
                        this._trigger("beforeServiceInvoke", { action: "initialize", element: this.element, customObject: this.model.customObject });
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    if (this.model.enableVirtualScrolling) this.model.layout = ej.PivotGrid.Layout.NoSummaries;
                    if (this.element[0] != null && this.element.parents().find(".controlPanel").length > 0 && this.layout() != "" && this.layout() != ej.PivotGrid.Layout.Normal)
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": "initializeGrid", "currentReport": this.model.currentReport, "gridLayout": this.layout(), "customObject": serializedCustomObject }), this._renderControlSuccess);
                    else if (this.element[0] != null && this.element.parents().find(".controlPanel").length > 0)
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": (this.model.enableCellDoubleClick || this.model.enableDrillThrough) ? "initializeGrid:getDataSet" : "initializeGrid", "currentReport": this.model.currentReport, "customObject": serializedCustomObject }), this._renderControlSuccess);
                    else
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": (this.model.enableCellDoubleClick || this.model.enableDrillThrough) ? "initializeGrid:getDataSet" : "initializeGrid", "gridLayout": this.layout(), "enablePivotFieldList": this.model.enablePivotFieldList, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject }), this._renderControlSuccess);
                }
                else {
                    this.model.operationalMode = ej.Pivot.OperationalMode.ClientMode;
                    this.model.dataSource.data = ((ej.isNullOrUndefined(this.model.dataSource.cube) || this.model.dataSource.cube == "") && this.model.dataSource.data == null) ? {} : this.model.dataSource.data;
                    if (this.model.dataSource.cube != "") {
                        this.model.analysisMode = ej.Pivot.AnalysisMode.Olap;
                        this._trigger("beforePivotEnginePopulate", { pivotGridObj: this });
                        ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
                    }
                    else if (this.model.dataSource.data != null) {
                        for (var i = 0; i < this.model.dataSource.rows.length; i++)
                            this._applyGrouping("rows", i);
                        for (var i = 0; i < this.model.dataSource.columns.length; i++)
                            this._applyGrouping("columns", i)
                        for (var i = 0; i < this.model.dataSource.values.length; i++)
                            this._applyGrouping("values", i);
                        for (var i = 0; i < this.model.dataSource.filters.length; i++)
                            this._applyGrouping("filters", i);
                        this.model.analysisMode = ej.Pivot.AnalysisMode.Pivot;
                        ej.PivotAnalysis.setFieldCaptions(this.model.dataSource);
                        this._populatePivotGrid();
                    }
                }
            }
        },
		
        _formatChange: function(date,formatString,delimiter){
            var format = formatString.split(delimiter);
            if ((format[0].indexOf("M") > -1 && format[1].indexOf("d") > -1) || (format[1].indexOf("M") > -1 && format[2].indexOf("d") > -1)) {
                return date;
            }
            else if (format[1].indexOf("M") > -1 && format[0].indexOf("d") > -1) {
                var dd = date.split(delimiter);
                return (dd[1] + delimiter + dd[0] + delimiter + dd[2]);
            }
            else if (format[2].indexOf("M") > -1 && format[0].indexOf("d") > -1) {
                var dd = date.split(delimiter);
                return (dd[2] + delimiter + dd[0] + delimiter + dd[1]);
            }
            else if (format[2].indexOf("M") > -1 && format[1].indexOf("d") > -1) {
                var dd = date.split(delimiter);
                return (dd[2] + delimiter + dd[1] + delimiter + dd[0]);
            }
            else if (format[0].indexOf("M") > -1 && format[2].indexOf("d") > -1) {
                var dd = date.split(delimiter);
                return (dd[0] + delimiter + dd[2] + delimiter + dd[1]);
            }
        },

        _applyGrouping: function (items, i) {
			var data = this.model.dataSource.data,index = -1;
			index = -1;
			for (var k=0; this.model.dataSource[items][i].groupByDate != undefined && k<this.model.dataSource[items][i].groupByDate.interval.length; k++){
			    var fName = (this.model.dataSource[items][i].groupByDate.interval[k].indexOf("MM") > -1 && this.model.dataSource[items][i].groupByDate.interval[k].indexOf("dd") == -1) ? "Months" : (this.model.dataSource[items][i].groupByDate.interval[k].indexOf("dd") > -1) ? "Days" : (this.model.dataSource[items][i].groupByDate.interval[k].indexOf("qq") > -1) ? "Quarters" : "Years";
			    var formatString = this.model.dataSource[items][i].formatString, delimiter = this.model.dataSource[items][i].delimiter;
			    var val = { fieldName: fName + "-" + this.model.dataSource[items][i].fieldName, fieldCaption: fName + "-" + this.model.dataSource[items][i].fieldCaption };
				this.model.dataSource[items].push(val);
				for (var j = 0; j < data.length; j++) {
				    if(this.model.dataSource[items][i].groupByDate.interval[k].indexOf("MM") > -1 && this.model.dataSource[items][i].groupByDate.interval[k].indexOf("DD") == -1)
				        data[j][fName + "-" + this.model.dataSource[items][i].fieldName] = ej.PivotAnalysis._setFormat(this._formatChange(data[j][this.model.dataSource[items][i].fieldCaption],formatString,delimiter),"date", this.model.dataSource[items][i].groupByDate.interval[k]);
				    else if (this.model.dataSource[items][i].groupByDate.interval[k].indexOf("dd") > -1)
				        data[j][fName + "-" + this.model.dataSource[items][i].fieldName] = ej.PivotAnalysis._setFormat(this._formatChange(data[j][this.model.dataSource[items][i].fieldCaption], formatString, delimiter), "date", this.model.dataSource[items][i].groupByDate.interval[k]);
				    else if (this.model.dataSource[items][i].groupByDate.interval[k].indexOf("qq") > -1)
				        data[j][fName + "-" + this.model.dataSource[items][i].fieldName] = ((this.model.dataSource[items][i].groupByDate.interval[k] == "qq" ? "Qtr - " : "Quarter - ") + this._getQuarter(this._formatChange(data[j][this.model.dataSource[items][i].fieldCaption], formatString, delimiter)));
					else
				        data[j][fName + "-" + this.model.dataSource[items][i].fieldName] = ej.PivotAnalysis._setFormat(this._formatChange(data[j][this.model.dataSource[items][i].fieldCaption], formatString, delimiter), "date", this.model.dataSource[items][i].groupByDate.interval[k]);
				}
				index = i;
			}
			if(index != -1)
				this.model.dataSource[items].splice(i, 1);
        },

        _getQuarter: function (val) {
            if (jQuery.isNumeric(val)) {
                day = new Date(((Number(val) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
            }
            else if (new Date(val) != "Invalid Date"){
                var day = new Date(val);
            }
            else {
                day = new Date(((Number(0) - 2) * (1000 * 3600 * 24)) + new Date("01/01/1900").getTime());
            }
            return Math.floor((day.getMonth() + 3) / 3);
        },
		
        refreshControl: function () {
            ej.Pivot.openPreventPanel(this);
            this._trigger("beforePivotEnginePopulate", { pivotObject: this });
            if (this.model.enableGroupingBar)
                this._createGroupingBar(this.model.dataSource);
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var pivotEngine = ej.PivotAnalysis.pivotEnginePopulate(this.model);
                this.setJSONRecords(JSON.stringify(pivotEngine.json));
                if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
                    this.excelLikeLayout(pivotEngine.json);
                else
                    this.renderControlFromJSON(pivotEngine.json);
                this._trigger("renderSuccess", this);
            }
            else
                ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
        },

        _setCaptions: function () {
            $.each(this.model.dataSource.rows, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
            $.each(this.model.dataSource.columns, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
            $.each(this.model.dataSource.filters, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
            $.each(this.model.dataSource.values, function (index, value) { if (ej.isNullOrUndefined(value.fieldCaption)) value.fieldCaption = value.fieldName; });
        },

        refreshFieldCaption: function (name, caption, className) {
            if (className.indexOf("row") >= 0) {
                for (var i = 0; i < this.model.dataSource.rows.length; i++) {
                    if (name == this.model.dataSource.rows[i].fieldName)
                        this.model.dataSource.rows[i].fieldCaption = caption;
                }
            }
            else if (className.indexOf("calc") >= 0) {
                for (var i = 0; i < this.model.dataSource.values.length; i++) {
                    if (name == this.model.dataSource.values[i].fieldName)
                        this.model.dataSource.values[i].fieldCaption = caption;
                }
            }
            else if (className.indexOf("col") >= 0) {
                for (var i = 0; i < this.model.dataSource.columns.length; i++) {
                    if (name == this.model.dataSource.columns[i].fieldName)
                        this.model.dataSource.columns[i].fieldCaption = caption;
                }
            }
            else {
                for (var i = 0; i < this.model.dataSource.filters.length; i++) {
                    if (name == this.model.dataSource.filters[i].fieldName)
                        this.model.dataSource.filters[i].fieldCaption = caption;
                }
            }
            for (var i = 0; i < this._pivotTableFields.length; i++) {
                if (name == this._pivotTableFields[i].name)
                    this._pivotTableFields[i]["caption"] = caption;
            }
        },

        refreshPivotGrid: function () {
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    if (this.getOlapReport()) {
                        if (this.model.dataSource.rows)
                            this.model.dataSource.rows = this.getOlapReport().rows;
                        if (this.model.dataSource.columns)
                            this.model.dataSource.columns = this.getOlapReport().columns;
                        if (this.model.dataSource.filters)
                            this.model.dataSource.filters = this.getOlapReport().filters;
                        if (this.model.dataSource.values)
                            this.model.dataSource.values = this.getOlapReport().values;
                    }
                    this.model.editCellsInfo = {};
                    this._populatePivotGrid();
                }
                else {
                    this._trigger("beforePivotEnginePopulate", { olapObject: this });
                    ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
                }
            }
            else
                this._load();
        },

		_populatePivotGrid: function () {         
		    this._trigger("beforePivotEnginePopulate", { pivotObject: this });
		    var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
		    var calculatedField = $.grep(this.model.dataSource.values, function (value) { return value.isCalculatedField == true; });
		    this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) { return ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false; });
		    for (var i = 0; i < calculatedField.length; i++) {
		        var formula = calculatedField[i].formula;
		        if ($.grep(this._calculatedField, function (value) { return value.name == calculatedField[i].fieldName; }).length == 0) {
		            formula = formula.replace(/\s+|\s+$/gm, '');
		            formula = this._parenthesisAsterisk(formula);
		            formula = formula.replace(/[-+/^%*]/g, function (text) { return " " + text + " "; });
		            this._calculatedField.push({ name: calculatedField[i].fieldName, formula: formula });
		        }
		        calculatedField[i].formula = formula;
		        this.model.dataSource.values.push(calculatedField[i]);
		    }
		    var pivotEngine = ej.PivotAnalysis.pivotEnginePopulate(this.model);
		    this.setJSONRecords(JSON.stringify(pivotEngine.json));
		    this.setOlapReport(this.model.dataSource);
            this._createGroupingBar(this.model.dataSource);
		    if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
		        this.excelLikeLayout(pivotEngine.json);
		    else
		    this.renderControlFromJSON();
		    if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
		    this._waitingPopup.hide();
		    this._trigger("renderSuccess", this);
		    if (!ej.isNullOrUndefined(this._pivotClientObj) && typeof (this._pivotClientObj._pivotSchemaDesigner) != "undefined")
		        this._schemaData = this._pivotClientObj._pivotSchemaDesigner;
		    if (this._schemaData != null) {
		        this._schemaData._waitingPopup.hide();
		        if (this._calculatedField.length > 0)
		            this._schemaCalculatedField();
		    }
		},

        _setFirst: false,

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "OlapReport": this.setOlapReport(options[key]); break;
                    case "JsonData": this.setOlapReport(options[key]); break;
                    case "RefreshOlapGrid": this.element.renderControlFromJSON(options[key]); break;
                    case "layout": this._load(); break;
                    case "customObject": this.model.customObject = options[key]; break;
                    case "enableCellContext": this._load(); break;
                    case "enableValueCellHyperlink": this._load(); break;
                    case "enableRowHeaderHyperlink": this._load(); break;
                    case "enableColumnHeaderHyperlink": this._load(); break;
                    case "enableSummaryCellHyperlink": this._load(); break;
                    case "locale": this._load(); break;
                    case "dataSource": {
                        this.model.dataSource = ($.extend({}, this.model.dataSource, options[key]));
                        this.refreshControl();
                        if (this._schemaData)
                            this._schemaData._load();
                        break;
                    }
                }
            }
        },

        _wireEvents: function () {
            this._on(this.element, "mouseover", ".value,.rowheader,.colheader,.summary", ej.proxy(function (evt) {
                if (!$(evt.target).hasClass("cellValue") && !$(evt.target).children().hasClass("cellValue")) {
                    var val = $(evt.target).contents().filter(function () { return this.nodeType == 3; });
                    if (val.text() != 0) {
                        var isSort = $(evt.target).find(".valueSorting").length > 0 ? true : false;
                        var sorting = isSort ? $(evt.target).find(".valueSorting") : "";
                        $(evt.target).find(".valueSorting").remove();
                        $(evt.target).contents().filter(function () { return this.nodeType == 3; }).remove();
                        $(evt.target).append("<span class='cellValue'>" + val.text() + "</span>");
                        isSort && ($(evt.target).hasClass("colheader") || $(evt.target).hasClass("summary")) && $(evt.target).hasClass("calc") && (!$(evt.target).hasClass("rowheader")) ? $(evt.target).append(sorting) : "";
                    }
                }
            }));
            this._on(this.element, "contextmenu", ".value,.rowheader,.colheader,.summary", ej.proxy(function (evt) {

                if (this.model.enableContextMenu && ej.isNullOrUndefined(this._pivotClientObj) && !this.model.enableCellContext) {
                    evt.preventDefault();
                    var advancedfilter = "", numberformatting = "", paging = "", pagingOptions = "", collapseByDefault = "", layouts = "";

                    layouts = this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? "<li><a>" + this._getLocalizedLabels("Layouts") + "</a><ul><li id='normalLayout'><a>" + this._getLocalizedLabels("NormalLayout") + "</a><li><li id='excelLikeLayout'><a>" + this._getLocalizedLabels("ExcelLikeLayout") + "</a><li></ul></li>" : (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? "<li><a>" + this._getLocalizedLabels("Layouts") + "</a><ul><li id='normalLayout'><a>" + this._getLocalizedLabels("NormalLayout") + "</a><li><li id='excelLikeLayout'><a>" + this._getLocalizedLabels("ExcelLikeLayout") + "</a><li><li id='noSummariesLayout'><a>" + this._getLocalizedLabels("NoSummaries") + "</a><li></ul></li>" : "<li><a>" + this._getLocalizedLabels("Layouts") + "</a><ul><li id='normalLayout'><a>" + this._getLocalizedLabels("NormalLayout") + "</a><li><li id='excelLikeLayout'><a>" + this._getLocalizedLabels("ExcelLikeLayout") + "</a><li><li id='noSummariesLayout'><a>" + this._getLocalizedLabels("NoSummaries") + "</a><li><li id='normalTopSummaryLayout'><a>" + this._getLocalizedLabels("NormalTopSummary") + "</a><li></ul></li>");
                    advancedfilter = !((this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot || this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)?ej.buildTag("li.advancedFiltering", ej.buildTag("a", this._getLocalizedLabels("AdvancedFiltering"))[0].outerHTML)[0].outerHTML:"";
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                        collapseByDefault = ej.buildTag("li.collapseByDefault", ej.buildTag("a", this._getLocalizedLabels("CollapseByDefault"))[0].outerHTML)[0].outerHTML;
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                        numberformatting = ej.buildTag("li.numberFormatting", ej.buildTag("a", this._getLocalizedLabels("NumberFormatting"))[0].outerHTML)[0].outerHTML;
                    var hyperlink = "<li><a>" + this._getLocalizedLabels("HyperLink") + "</a><ul><li id='rowHeader'><a>" + this._getLocalizedLabels("EnableRowHeaderHyperlink") + "</a></li><li id='columnHeader'><a>" + this._getLocalizedLabels("EnableColumnHeaderHyperlink") + "</a></li><li id='valueCell'><a>" + this._getLocalizedLabels("EnableValueCellHyperlink") + "</a></li><li id='summaryCell'><a>" + this._getLocalizedLabels("EnableSummaryCellHyperlink") + "</a></li></ul></li>";
                    var exporting = "<li><a>" + this._getLocalizedLabels("Exporting") + "</a><ul><li id='excel'><a>" + this._getLocalizedLabels("Excel") + "</a></li><li id='word'><a>" + this._getLocalizedLabels("Word") + "</a></li><li id='pdf'><a>" + this._getLocalizedLabels("PDF") + "</a></li><li id='csv'><a>" + this._getLocalizedLabels("CSV") + "</a></li></ul></li>";
                    var frozen = "<li class='e-separator'><a>" + this._getLocalizedLabels("FrozenHeader") + "</a><ul><li id='row'><a>" + this._getLocalizedLabels("Row") + "</a></li><li id='column'><a>" + this._getLocalizedLabels("Column") + "</a></li></ul></li>";
                    var listContext = ej.buildTag("ul#"+this._id+"contextMenu.pivotGridContextMenu",
                    ej.buildTag("li.cellSelect", ej.buildTag("a", this._getLocalizedLabels("CellSelection"))[0].outerHTML)[0].outerHTML +
                    ej.buildTag("li.columnResize", ej.buildTag("a", this._getLocalizedLabels("ColumnResize"))[0].outerHTML)[0].outerHTML +
                    ej.buildTag("li.toolTip", ej.buildTag("a", this._getLocalizedLabels("ToolTip"))[0].outerHTML)[0].outerHTML + collapseByDefault + advancedfilter +
                    ej.buildTag("li.groupingBar", ej.buildTag("a", this._getLocalizedLabels("GroupingBar"))[0].outerHTML)[0].outerHTML +
                    (this.model.analysisMode == "pivot" ? ej.buildTag("li.cellEditing", ej.buildTag("a", this._getLocalizedLabels("CellEditing"))[0].outerHTML)[0].outerHTML : "") +
                    ej.buildTag("li.drillThrough", ej.buildTag("a", this._getLocalizedLabels("DrillThrough"))[0].outerHTML)[0].outerHTML +
                    ej.buildTag("li.rtl", ej.buildTag("a", this._getLocalizedLabels("RTL"))[0].outerHTML)[0].outerHTML + layouts + hyperlink + exporting +frozen+
                    ej.buildTag("li.summaryCustomize", ej.buildTag("a", this._getLocalizedLabels("SummaryCustomization"))[0].outerHTML)[0].outerHTML +
                    ej.buildTag("li.conditionalFormat", ej.buildTag("a", this._getLocalizedLabels("ConditionalFormatting"), {})[0].outerHTML)[0].outerHTML +
                    (this.model.analysisMode == "pivot" ? (ej.buildTag("li.calculatedField", ej.buildTag("a", this._getLocalizedLabels("CalculatedField"))[0].outerHTML)[0].outerHTML  + numberformatting + (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? ej.buildTag("li.summaryTypes", ej.buildTag("a", this._getLocalizedLabels("SummaryTypes"), {})[0].outerHTML)[0].outerHTML : "")) : ""))[0].outerHTML;

                    $("#" + this._id).append(listContext);
                    $("li.rtl").addClass("e-separator");
                    var ele = this.element.find(".pivotGridTable");

                    this.element.find("#"+this._id+"contextMenu").ejMenu({
                        width: "200px",
                        menuType: ej.MenuType.ContextMenu,
                        contextMenuTarget: ele,
                        enableRTL: this.model.enableRTL,
                        click: ej.proxy(this._contextMenuClick, this)
                    });
                    this._stateMaintenance();
                }
            }));
            this._on($(document), 'keydown', this._keyDownPress);
            this._on($(document), 'keyup', this._keyUpPress);
			if (this.model.enableCellSelection) {
                this._on(this.element, "mousedown touchstart", ".value", this._initCellSelection);
                this._on(this.element, "click", ".colheader,.rowheader", this._headerClickCellSelection);
            }
            if (this.enableCellContext() == true) {
                if (document.addEventListener) {
                    document.removeEventListener('contextmenu', this._cellContext, false);
                    document.addEventListener('contextmenu', this._cellContext, false);
                }
                else {
                    document.detachEvent('oncontextmenu', this._cellContext);
                    document.attachEvent('oncontextmenu', this._cellContext);
                }
            }

            this._on(this.element, "mouseover", ".pivotButton", ej.proxy(function (evt) {
                if (this._isDragging) {
                    this.element.append(ej.buildTag("span.dropIndicator dropIndicatorActive")[0].outerHTML);
                    if (evt.target.className.indexOf("pivotButton") >= 0)
                        this.element.find(".dropIndicator").css("top", $(evt.target).position().top - 20).css("left", $(evt.target).position().left - 3);
                    else
                        this.element.find(".dropIndicator").css("top", $(evt.target).parents(".pivotButton").position().top - 20).css("left", $(evt.target).parents(".pivotButton").position().left - 3);
                }
            }, this));

            this._on(this.element, "mouseleave", ".pivotButton", ej.proxy(function (evt) {
                if (this._isDragging)
                    this.element.find(".dropIndicator").removeClass("dropIndicatorActive");
            }, this));

            this._on(this.element, "click", "#preventDiv", ej.proxy(function (evt) {
                if (this.element.find(".e-dialog.advancedFilterDlg:visible").length > 0) {
                    this.element.find(".e-dialog.advancedFilterDlg").hide();
                    this.element.find("#preventDiv").remove();
                }
            }, this));

            if (this.model.enableCellEditing) {
                this._on(this.element, "mousedown", ".value", this._initCellEditing)
            }
            this.drillDownHandler = $.proxy(this._drillDown, this);
            this.addHyperlinkHandler = $.proxy(this._addHyperlink, this);
            this.removeHyperlinkHandler = $.proxy(this._removeHyperlink, this);
            if (this.model.enableCellSelection) {
                $(document).on("click", this._clearSelection);
                $(document).on("keyup", this._endCellSelection);
                $(document).on("keydown", this._startCellSelection);
            }
            this._on(this.element, "mouseover", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value .cellValue, .rowheader .cellValue, .colheader .cellValue" : ".value .cellValue, .rowheader .cellValue, .colheader .cellValue, .summary .cellValue", this.addHyperlinkHandler);
            this._on(this.element, "mouseleave", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value, .rowheader, .colheader" : ".value .cellValue, .rowheader .cellValue, .colheader .cellValue, .summary .cellValue", this.removeHyperlinkHandler);
            this._on(this.element, "click", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value .cellValue, .rowheader .cellValue, .colheader .cellValue" : ".value .cellValue, .rowheader .cellValue, .colheader .cellValue, .summary .cellValue", function (e) {
                if (e.target.className.indexOf("hyperlink") != -1) {
                    var cellPos = this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout ? $(e.target.parentElement).attr("i") : $(e.target.parentElement).attr("p");
                    var rawdata = this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout ? this._excelLikeJSONRecords[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))].Info : this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._excelRowCount) + parseInt(cellPos.split(",")[1]))].Info;
                    var cellInfo = {
                        cellValue: e.target.innerHTML,
                        cellPosition: cellPos,
                        cellType: e.target.parentElement.className.split(' ')[0],
                        uniqueName: rawdata.split('::')[0],
                        args: e,
                        rawdata: rawdata
                    };
                    if ((this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && e.target.parentElement.className.indexOf("summary") >= 0) || e.target.parentElement.className.indexOf("summary value") >= 0)
                        this._trigger("summaryCellHyperlinkClick", { element: this.element, customObject: this.model.customObject, args: cellInfo });
                    else if (e.target.parentElement.className.indexOf("value") >= 0)
                        this._trigger("valueCellHyperlinkClick", { element: this.element, customObject: this.model.customObject, args: cellInfo });
                    else if (e.target.parentElement.className.indexOf("rowheader") >= 0)
                        this._trigger("rowHeaderHyperlinkClick", { element: this.element, customObject: this.model.customObject, args: cellInfo });
                    else if (e.target.parentElement.className.indexOf("colheader") >= 0)
                        this._trigger("columnHeaderHyperlinkClick", { element: this.element, customObject: this.model.customObject, args: cellInfo });
                    if (e.target.parentElement.className.indexOf("value") >= 0 && this.model.enableDrillThrough) {
                        this._rowHeader = []; this._colHeader = [];
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                            ej.Pivot._drillThroughCellClick(e, this);
                        else
                            this._cellRangeInfo(e);
                }
                }
            });
            this._on(this.element, "click", this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? ".rowheader, .colheader, .summary" : ".rowheader, .colheader", function (e) {
                if (this.model.enableCellSelection) {
                    if (!($(e.target).hasClass("cellValue") && $(e.target).hasClass("hyperlinkHeaderCell"))) {
                        var targetCell = $(e.target).hasClass("cellValue") ? e.target.parentElement : e.target;
                        if (e.shiftKey) {
                            window.getSelection().removeAllRanges();
                            $(this.element).find(".selected").removeClass("selected");
                            var selectedCellPos = $(this._selectedCell).attr('p'), targetCellPos = $(targetCell).attr('p');
                            if (($(targetCell).hasClass("rowheader") || $(targetCell).attr('role') == "rowheader") && ($(this._selectedCell).hasClass("rowheader") || $(this._selectedCell).attr('role') == "rowheader")) //|| 
                                for (var i = Math.min(selectedCellPos.split(',')[1], targetCellPos.split(',')[1]) ; i <= Math.max(selectedCellPos.split(',')[1], targetCellPos.split(',')[1]) ; i++)
                                    this.element.find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']").addClass("selected");
                            if (($(targetCell).hasClass("colheader") || $(targetCell).attr('role') == "columnheader") && ($(this._selectedCell).hasClass("colheader") || $(this._selectedCell).attr('role') == "columnheader"))
                                for (var i = Math.min(selectedCellPos.split(',')[0], targetCellPos.split(',')[0]) ; i <= Math.max(selectedCellPos.split(',')[0], targetCellPos.split(',')[0]) ; i++)
                                    this.element.find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']").addClass("selected");
                            var selectedCells = $(this.element).find(".selected");
                            if (selectedCells.length > 0) {
                                var selectedCellsInfo = new Array();
                                for (var i = 0; i < selectedCells.length; i++) {
                                    var cellPos = $(selectedCells[i]).attr('p');
                                    var cellInfo = this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))];
                                    cellInfo.Value = $(selectedCells[i]).text().trim();
                                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) cellInfo["Field"] = this._getFieldName(selectedCells[i]);
                                    selectedCellsInfo.push(cellInfo);
                                }
                                this._trigger("cellSelection", { JSONRecords: selectedCellsInfo });
                            }
                        }
                        else {
                            if (!e.ctrlKey) $(this.element).find(".selected").removeClass("selected");
                            if ($(targetCell).hasClass("colheader") || $(targetCell).hasClass("rowheader") || $(targetCell).attr("role") == "rowheader" || $(targetCell).attr("role") == "columnheader") {
                                e.ctrlKey ? $(targetCell).toggleClass("selected") : $(targetCell).addClass("selected");
                                this._selectedCell = targetCell;
                                this._primaryCellPos = $(targetCell).attr('p');
                                var cellInfo = this.getJSONRecords()[parseInt((parseInt(this._primaryCellPos.split(",")[0]) * this._rowCount) + parseInt(this._primaryCellPos.split(",")[1]))];
                                cellInfo.Value = $(targetCell).text().trim();
                                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) cellInfo["Field"] = this._getFieldName(targetCell);
                                if (!e.ctrlKey) this._trigger("cellSelection", { JSONRecords: [cellInfo] });
                            }
                        }
                    }
                }
            });
            if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                if (!this._pivotClientObj.model.enableDeferUpdate)
                    this._on(this.element, "click", ".expand, .collapse", ej.proxy(this._drillDown, this));
            }
            else
                this._on(this.element, "click", ".expand, .collapse", ej.proxy(this._drillDown, this));
            this._on(this.element, "mouseover", ".colheader, .rowheader, .expand, .collapse", function (evt) {
                if (evt.target.className.indexOf("expand") > -1 && !$(evt.target).hasClass("header-hover-expand"))
                    $(evt.target).addClass("header-hover-expand");
                else if (evt.target.className.indexOf("collapse") > -1 && !$(evt.target).hasClass("header-hover-collapse"))
                    $(evt.target).addClass("header-hover-collapse");
                else if ((evt.target.className.indexOf("expand") < 0 || evt.target.className.indexOf("collapse") < 0) && $(evt.target).children("span").length > 0) {
                    var child = $(evt.target).children("span")[0];
                    if (!$(child).hasClass("header-hover-expand") && child.className.indexOf("expand") > -1)
                        $(child).addClass("header-hover-expand");
                    else if (!$(child).hasClass("header-hover-collapse") && child.className.indexOf("collapse") > -1)
                        $(child).addClass("header-hover-collapse");
                }
            });
            this._on(this.element, "mouseleave", ".colheader, .rowheader, .expand, .collapse", function (evt) {
                this.element.find(".expand, .collapse").removeClass("header-hover-expand header-hover-collapse");
            });
            if (this.model.enableToolTip) {
                this._on(this.element, "mouseover", ".value", this._applyToolTip);
                this._on(this.element, "mouseleave", ".value", function (e) {
                    if(this.model.enableToolTipAnimation)
                        $("#" + this._id + "_gridTooltip").hide("slow");
                    else
                        $("#" + this._id + "_gridTooltip").hide();
                });
            }
			if (this.model.enableDrillThrough) {
                $.proxy(this._addHyperlink, this);
            }
            this._on(this.element, "click", ".filter", ej.proxy(this._filterBtnClick, this));
            this._on(this.element, "click", ".sorting", ej.proxy(this._sortBtnClick, this));
            this._on(this.element, "click", ".removeBtn", ej.proxy(this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._removePvtBtn : this._clientRemovePvtBtn, this));
            this._on(this.element, "click", ".ascOrder, .descOrder", ej.proxy(this._sortField, this));
            this._on(this.element, "mouseover", ".pvtBtn", function (evt) {
                $(evt.target.parentElement).addClass("e-btn e-select");
            });
            this._on(this.element, "mouseleave", ".pvtBtn", function (evt) {
                $(evt.target.parentElement).removeClass("e-btn e-select");
                $(evt.target).removeClass("hoverBtn");
            });
            this._on(this.element, "mouseover", ".pivotButton", function (evt) {
                evt.target.title = evt.target.textContent;
                $(evt.target).find("button").addClass("hoverBtn");
            });
            this._on(this.element, "mouseleave", ".pivotButton", function (evt) {
                $(evt.target).find("button").removeClass("hoverBtn");
            });
            this._on(this.element, "mouseover", ".filter,.sorting,.removeBtn", function (evt) {
                $(evt.target.parentElement).find("button").addClass("hoverBtn");
            });
            this._on(this.element, "mouseleave", ".filter,.sorting,.removeBtn", function (evt) {
                $(evt.target.parentElement).find("button").removeClass("hoverBtn");
            });
            this._on(this.element, "mouseleave", ".value,.rowheader,.colheader,.summary", ej.proxy(function (evt) {
                var val = $(evt.target).find(".cellValue").contents().filter(function () { return this.nodeType == 3; });
                if (val.text() != 0) {
                    var isSort = $(evt.target).find(".valueSorting").length > 0 ? true : false;
                    var sorting = isSort ? $(evt.target).find(".valueSorting") : "";
                    $(evt.target).find(".valueSorting").remove()
                    $(evt.target).find(".cellValue").remove();
                    $(evt.target).append(val.text());
                    isSort && ($(evt.target).hasClass("colheader") || $(evt.target).hasClass("summary")) && $(evt.target).hasClass("calc") && (!$(evt.target).hasClass("rowheader")) ? $(evt.target).append(sorting) : "";
                }
            }));

            this._on(this.element, "click", ".e-close", ej.proxy(function (evt) {
                this.element.find("#preventDiv").remove();
            }));

            this._on(this.element, "click", ".dialogOkBtn", ej.proxy(this._dialogOKBtnClick, this));

            if (this.model.enableContextMenu || ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar&& !this._pivotClientObj.model.displaySettings.enableFullScreen)) {

                this._on(this.element, "click", ".cellSelect", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".columnResize", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".excelLikeLayout", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".advancedFiltering", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".toolTip", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".collapseByDefault", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".rtl", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".calculatedField", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".cellEditing", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".conditionalFormat", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".summaryCustomize", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".summaryTypes", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".numberFormatting", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".rowHeaderHyperLink", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".colHeaderHyperLink", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".valueCellHyperLink", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".summaryCellHyperLink", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".rowFreeze", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".colFreeze", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".excel", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".word", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".pdf", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".csv", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".normalLayout", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".normalTopSummaryLayout", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".noSummariesLayout", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".drillThrough", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".groupingBar", ej.proxy(this._contextMenuClick, this));
                this._on(this.element, "click", ".frozenHeaders", ej.proxy(this._createMenuIcons, this));
                this._on(this.element, "click", ".exporting", ej.proxy(this._createMenuIcons, this));
                this._on(this.element, "click", ".hyperlinkOptions", ej.proxy(this._createMenuIcons, this));
                this._on(this.element, "click", ".layouts", ej.proxy(this._createMenuIcons, this));
                $(document).click(function (e) {
                    if (e.target.className.indexOf('hyperlinkOptions') == -1)
                        $(".hyperLinkDialog").remove();
                    if (e.target.className.indexOf('exporting') == -1)
                        $(".exportDialog").remove();
                    if (e.target.className.indexOf('frozenHeaders') == -1)
                        $(".frozenDialog").remove();
                    if (e.target.className.indexOf('layouts') == -1)
                        $(".layoutsDialog").remove();
                });
            }
            this._on(this.element, "click", ".dialogCancelBtn", ej.proxy(function (evt) {
                this.element.find(".e-dialog, .clientDialog").hide();
                $("#preventDiv").remove();
            }));
            if (this.model.enableColumnResizing) {
                this._on(this.element, "mousemove", ej.proxy(function (evt) {
                    this._colResizing(evt);
                }));
                this._on(this.element, "mousedown", "thead,.pivotGridFrozenTable,.pivotGridColValueTable", ej.proxy(function (evt) {
                    this._startColResizing(evt);
                }));
                this._on(this.element, "mouseup", ".e-reSizeColbg",ej.proxy(function (evt) {
                    this._endColResizing(evt);
                }));
            }
            this._on(this.element, "click", ".nextPage, .prevPage, .firstPage, .lastPage", ej.proxy(this._navigateTreeData, this));
            this._on(this.element, "click", ".searchEditorTree", ej.proxy(function (evt) {
                ej.Pivot._searchEditorTreeNodes(evt, this);
            }, this));
            this._on(this.element, "click", ".colheader,.cstot,.cgtot,.calc,.stot,.gtot", ej.proxy(function (evt) {
                if ($(evt.target).hasClass("collapse") || ($(evt.target).hasClass("expand")))
                    return false;
                if (!ej.isNullOrUndefined(this.model.valueSortSettings) && !ej.isNullOrUndefined(this.model.valueSortSettings.sortOrder) && this.model.valueSortSettings.sortOrder != "none" && (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && ((this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.dataSource.values.length > 0) || (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && JSON.parse(this.getOlapReport()).PivotCalculations.length > 0)))) {
                    var sort = this.model.valueSortSettings.sortOrder;
                    var ele = $(evt.target).hasClass("cellValue") || $(evt.target).hasClass("valueSorting") || $(evt.target).hasClass("expand") || $(evt.target).hasClass("collapse") ? $(evt.target).parent() : $(evt.target);
                    if (!ele.hasClass("calc")) {
                        ele = $(this.element).find("[p='" + (Number(ele.attr("p").split(',')[0]) + Number(ele.attr("colspan")) - 1) + "," + (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? this.model.dataSource.columns.length : JSON.parse(this.getOlapReport()).PivotColumns.length) + "']")[0];
                    }
                    sort = $(ele).find(".valueSorting").length > 0 ? $(ele).find(".valueSorting").hasClass("descending") ? "ascending" : "descending" : sort;
                    this.element.find(".valueSorting").remove();
                    if ($(ele).find(".valueSorting").length == 0 && !$(ele).hasClass("rowheader")) {
                        var sorting = ej.buildTag("span.valueSorting e-icon " + sort).css("width", "30px").attr("role", "button").attr("aria-label", "sort")[0].outerHTML;
                        $(ele).append(sorting);
                    }
                    else {
                        $(ele).find(".valueSorting").removeClass("ascending").removeClass("descending").addClass(sort);
                    }
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    ej.PivotAnalysis._valueSorting = Number($(ele).attr("p").split(',')[0]);
                    ej.PivotAnalysis._sort = sort;
                    if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                        this.refreshControl();
                    }
                    else {
                        var hText = "";
                        for (var i = 0; i < this.getJSONRecords().length ; i++) {
                            if (Number(this.getJSONRecords()[i].Index.split(",")[0]) == ej.PivotAnalysis._valueSorting && Number(this.getJSONRecords()[i].Index.split(",")[1]) < (JSON.parse(this.getOlapReport()).PivotColumns.length + 1)) {
                                hText = hText == "" ? (this.getJSONRecords()[i].Value.indexOf(".") == -1 ? this.getJSONRecords()[i].Value : this.getJSONRecords()[i].Value.split(".")[1]) : hText + this.model.valueSortSettings.headerDelimiters + (this.getJSONRecords()[i].Value.indexOf(".") == -1 ? this.getJSONRecords()[i].Value : this.getJSONRecords()[i].Value.split(".")[1]);
                            }
                        }
                        this.model.valueSortSettings.index = ej.PivotAnalysis._valueSorting;
                        this.model.valueSortSettings.headerText = hText;
                        this.model.valueSortSettings.sortOrder = sort;
                        this._waitingPopup = this.element.data("ejWaitingPopup");
                        if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.valueSorting, JSON.stringify({ "action": "valueSorting", "valueSorting": JSON.stringify(this.model.valueSortSettings), "currentReport": JSON.parse(this.getOlapReport()).Report, "customObject": serializedCustomObject }), this._renderControlSuccess);
                        delete this.model.valueSortSettings["index"];
                    }
                }
            }));
        },
        _navigateTreeData: function (args) {
            ej.Pivot.editorTreeNavigatee(args, this);
        },
        _stateMaintenance: function () {
            var enabledState = ej.buildTag("span.enabledState").addClass("e-icon").attr("aria-label", this._getLocalizedLabels("EnabledState"))[0].outerHTML;
            if (this.model.dataSource.enableAdvancedFilter) {
                if (this.element.parents(".e-pivotclient").length > 0)
                    $(".advancedFiltering").addClass("enabled");
                    else
                    $(".advancedFiltering a:eq(0)").append(enabledState);
            }
            if (this.model.enableDrillThrough) {
                $(".drillThrough a:eq(0)").append(enabledState);
                $("#" + this._id + "contextMenu").ejMenu("disableItem", this._getLocalizedLabels("CellEditing"));
            }
            if (this.element.parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableDrillThrough) {
                this.element.find(".drillThrough").addClass("enabled");
               this.element.find(".toolBar").ejToolbar("disableItemByID", "cellEditing");
            }
            if (this.model.enableToolTip && !this.model.frozenHeaderSettings.enableFrozenRowHeaders && !this.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                if (this.element.parents(".e-pivotclient").length > 0)
                    $(".toolTip").addClass("enabled");
                else
                    $(".toolTip a:eq(0)").append(enabledState);
            }
            if (this.model.enableCellSelection) {
                $(".cellSelect a:eq(0)").append(enabledState);
                $("#"+this._id+"contextMenu").ejMenu("disableItem", this._getLocalizedLabels("CellEditing"));
            }
            if (this.model.enableColumnResizing) {
                if (this.element.parents(".e-pivotclient").length > 0)
                {
                    $(".columnResize").addClass("enabled");
                    $(".toolBar").ejToolbar("disableItemByID", "collapseByDefault");
                }
                else {
                    $(".columnResize a:eq(0)").append(enabledState);
                    $("#" + this._id + "contextMenu").ejMenu("disableItem", this._getLocalizedLabels("CollapseByDefault"));
                }
            }
            if (this.model.enableGroupingBar)
                $(".groupingBar a:eq(0)").append(enabledState);
            if (this.model.enableRTL) {
                if (this.element.parents(".e-pivotclient").length > 0)
                    $(".rtl").addClass("enabled");
                else
                    $(".rtl a:eq(0)").append(enabledState);
            }
            if (this.model.enableCollapseByDefault) {
                if (this.element.parents(".e-pivotclient").length > 0) {
                        $(".toolBar").ejToolbar("disableItemByID", "columnResize");
                        $(".toolBar").ejToolbar("disableItemByID", "frozenHeaders");
                        $(".collapseByDefault").addClass("enabled");
                }
                else {
                    $("#"+this._id+"contextMenu").ejMenu("disableItem", this._getLocalizedLabels("ColumnResize"));
                    $("#"+this._id+"contextMenu").ejMenu("disableItem", this._getLocalizedLabels("FrozenHeader"));
                       $(".collapseByDefault a:eq(0)").append(enabledState);
                }
             }
            if (this.model.enableCellEditing) {
                if (this.element.parents(".e-pivotclient").length > 0)
                {
                    this.element.find(".cellEditing").addClass("enabled");
                    this.element.find(".toolBar").ejToolbar("disableItemByID", "drillThrough");
                }
                else
                    $(".cellEditing a:eq(0)").append(enabledState);
                $("#" + this._id + "contextMenu").ejMenu("disableItem", this._getLocalizedLabels("DrillThrough"));
                $("#"+this._id+"contextMenu").ejMenu("disableItem", this._getLocalizedLabels("CellSelection"));
            }
            if (this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                $("li#row a:eq(0)").append(enabledState);
            if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders)
                $("li#column a:eq(0)").append(enabledState);
            if (this.model.hyperlinkSettings.enableRowHeaderHyperlink)
                $("li#rowHeader a:eq(0)").append(enabledState);
            if (this.model.hyperlinkSettings.enableColumnHeaderHyperlink)
               $("li#columnHeader a:eq(0)").append(enabledState);
            if (this.model.hyperlinkSettings.enableValueCellHyperlink)
               $("li#valueCell a:eq(0)").append(enabledState);
            if (this.model.hyperlinkSettings.enableSummaryCellHyperlink)
                $("li#summaryCell a:eq(0)").append(enabledState);
            if (this.model.layout==ej.PivotGrid.Layout.Normal)
                $("li#normalLayout a:eq(0)").append(enabledState);
            if (this.model.layout == ej.PivotGrid.Layout.NoSummaries)
                $("li#noSummariesLayout a:eq(0)").append(enabledState);
            if (this.model.layout == ej.PivotGrid.Layout.ExcelLikeLayout)
                $("li#excelLikeLayout a:eq(0)").append(enabledState);
            if (this.model.layout == ej.PivotGrid.Layout.NormalTopSummary)
                $("li#normalTopSummaryLayout a:eq(0)").append(enabledState);
            if (this.model.layout == ej.PivotGrid.Layout.NormalTopSummary || this.model.layout == ej.PivotGrid.Layout.ExcelLikeLayout || this.model.layout == ej.PivotGrid.Layout.NoSummaries || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders)
            {
                if (this.element.parents(".e-pivotclient").length > 0)
                    $(".toolBar").ejToolbar("disableItemByID", "summaryCustomize");
                else
                    $("#"+this._id+"contextMenu").ejMenu("disableItem", this._getLocalizedLabels("SummaryCustomization"));
            }
        },
        _contextMenuClick: function (evt) {
            var enabledState = ej.buildTag("span.enabledState").addClass("e-icon").attr("aria-label", "")[0].outerHTML;
            var selectedMenuItem = this.element.parents(".e-pivotclient").length > 0 ? $(evt.target) : $(evt.element);
            if ($(evt.element).hasClass("numberFormatting") || $(evt.target).hasClass("numberFormatting"))
                this._createMenuDialog(evt);
            if ($(evt.element).hasClass("cellSelect") || $(evt.target).hasClass("cellSelect")) {
                if (!this.model.enableCellEditing) {
                    this.model.enableCellSelection = !this.model.enableCellSelection;
                 }
                this.renderControlFromJSON();
            }
            if (($(evt.element).hasClass("columnResize") || $(evt.target).hasClass("columnResize"))&& (!this.model.enableCollapseByDefault)) {
                this.model.enableColumnResizing = !this.model.enableColumnResizing;
                this.renderControlFromJSON();
            }
            if ($(evt.element).hasClass("toolTip") || $(evt.target).hasClass("toolTip")) {
                this.model.enableToolTip = !this.model.enableToolTip;
                this.renderControlFromJSON();
            }
            if (($(evt.element).hasClass("collapseByDefault") || $(evt.target).hasClass("collapseByDefault")) && !this.model.enableColumnResizing && !this.model.enableFrozenColumnHeaders && !this.model.enableFrozenRowHeaders) {
                if (this.model.enableCollapseByDefault) {
                    this.model.enableCollapseByDefault = false;
                }
                else {
                    this.model.enableCollapseByDefault = true;
                    this.model.collapsedMembers = null;
                }
                this.renderControlFromJSON();
            }
            if ($(evt.element).hasClass("rtl") || $(evt.target).hasClass("rtl")) {
                this.model.enableRTL = !this.model.enableRTL;
                this.renderControlFromJSON();
            }
            if ($(evt.element).hasClass("calculatedField") || $(evt.target).hasClass("calculatedField")) {
                this._createCalculatedField();
            }
            if ($(evt.element).hasClass("cellEditing") || $(evt.target).hasClass("cellEditing")) {
                if (!this.model.enableCellSelection) {
                    this.model.enableCellEditing = !this.model.enableCellEditing;
                    this.model.enableDrillThrough = false;
                }
                this.renderControlFromJSON();

            }
            if ($(evt.element).hasClass("drillThrough") || $(evt.target).hasClass("drillThrough")) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    dialogTitle = "Cube Configuration";
                    dialogContent = "<p>" + "Please configure cube" + "!</p>";
                    var ejDialog = ej.buildTag("div#clientDialog.clientDialog", { "opacity": "1" }).attr("title", dialogTitle)[0].outerHTML;
                    $(ejDialog).appendTo("#" + this._id);
                    $(dialogContent).appendTo(this.element.find(".clientDialog"));
                    this.element.find(".clientDialog").ejDialog({ enableRTL: this.model.enableRTL, width: 200, target: "#" + this._id, enableResize: false, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
                  }
                else {
                    if (this.element.parents(".e-pivotclient").length > 0) {
                        this._pivotClientObj.model.enableDrillThrough = !this._pivotClientObj.model.enableDrillThrough;
                        this.model.enableDrillThrough = this._pivotClientObj.model.enableDrillThrough;
                        this.model.enableCellEditing = false;
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                            this.renderControlFromJSON();
                        else
                            this._pivotClientObj._load();
                    }
                    else {
                        this.model.enableDrillThrough = !this.model.enableDrillThrough;
                        this.model.enableCellEditing = false;
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                            this.renderControlFromJSON();
                        else
                            this._load();
                    }
                }
                
            }
            if ($(evt.element).hasClass("summaryCustomize") || $(evt.target).hasClass("summaryCustomize")) {
                this._createMenuDialog(evt);
            }
            if ($(evt.element).hasClass("conditionalFormat") || $(evt.target).hasClass("conditionalFormat")) {
                if (this.element.parents(".e-pivotclient").length > 0) {
                    if (this._pivotClientObj.model.operationalMode == "clientmode")
                        this.setOlapReport(this._pivotClientObj.model.dataSource);
             }
                this.model.enableConditionalFormatting = true;
                this.openConditionalFormattingDialog();
				ej.Pivot.closePreventPanel(this);
            }
            if ($(evt.element).hasClass("summaryTypes") || $(evt.target).hasClass("summaryTypes")) {
                this._createMenuDialog(evt);
            }
            if ($(evt.element).hasClass("advancedFiltering") || $(evt.target).hasClass("advancedFiltering")) {
                this.model.dataSource.enableAdvancedFilter = !this.model.dataSource.enableAdvancedFilter;
                this.renderControlFromJSON();
            }
            if ($(evt.element).hasClass("groupingBar")) {
                this.model.enableGroupingBar = !this.model.enableGroupingBar;
                this.renderControlFromJSON();
            }
            if ((evt.element != "undefined" && evt.parentText == this._getLocalizedLabels("Layouts")) || $(evt.target).parents().hasClass("layoutsDialog")) {
                if (evt.ID == "normalLayout" || $(evt.target).hasClass("normalLayout"))
                {
                    this.model.layout=ej.PivotGrid.Layout.Normal;
                    if(this.element.parents(".e-pivotclient").length > 0) this._pivotClientObj.model.gridLayout = "normal";
                 }
                if (evt.ID == "excelLikeLayout" || $(evt.target).hasClass("excelLikeLayout")) {
                    this.model.layout = ej.PivotGrid.Layout.ExcelLikeLayout;
                    if (this.element.parents(".e-pivotclient").length > 0)
                        this._pivotClientObj.model.gridLayout = "excellikelayout";
                }
                if (evt.ID == "noSummariesLayout" || $(evt.target).hasClass("noSummariesLayout")) {
                    this.model.layout = ej.PivotGrid.Layout.NoSummaries;
                    if (this.element.parents(".e-pivotclient").length > 0)
                        this._pivotClientObj.model.gridLayout = "nosummaries";
                }
                if (evt.ID == "normalTopSummaryLayout" || $(evt.target).hasClass("normalTopSummaryLayout")) {
                    this.model.layout = ej.PivotGrid.Layout.NormalTopSummary;
                    if (this.element.parents(".e-pivotclient").length > 0)
                        this._pivotClientObj.model.gridLayout = "normaltopsummary";
                }
                if(evt.ID == "excelLikeLayout" || $(evt.target).hasClass("excelLikeLayout"))
                    this.excelLikeLayout(this.getJSONRecords());
                else
                {
                    this._excelLikeJSONRecords = null;
                    this.refreshPivotGrid();
                }

            }
            if ((evt.element != "undefined" && evt.parentText == this._getLocalizedLabels("HyperLink")) || $(evt.target).parents().hasClass("hyperLinkDialog")) {
                if (evt.ID == "rowHeader" || $(evt.target).hasClass("rowHeaderHyperLink"))
                    this.model.hyperlinkSettings.enableRowHeaderHyperlink = !this.model.hyperlinkSettings.enableRowHeaderHyperlink;
               if (evt.ID == "columnHeader" || $(evt.target).hasClass("colHeaderHyperLink"))
                   this.model.hyperlinkSettings.enableColumnHeaderHyperlink = !this.model.hyperlinkSettings.enableColumnHeaderHyperlink;
               if (evt.ID == "valueCell" || $(evt.target).hasClass("valueCellHyperLink")) 
                    this.model.hyperlinkSettings.enableValueCellHyperlink = !this.model.hyperlinkSettings.enableValueCellHyperlink;
               if (evt.ID == "summaryCell" || $(evt.target).hasClass("summaryCellHyperLink"))
                    this.model.hyperlinkSettings.enableSummaryCellHyperlink = !this.model.hyperlinkSettings.enableSummaryCellHyperlink;
              
               this.renderControlFromJSON();
            }

            if ((evt.element != undefined && evt.parentText == this._getLocalizedLabels("Exporting")) || $(evt.target).parents().hasClass("exportDialog")) {
                var selectedValue = this.element.parents(".e-pivotclient").length > 0 ? $(evt.target).attr("class").split(" ")[0] : evt.ID;
                if (this.element.parents(".e-pivotclient").length > 0 && !ej.isNullOrUndefined(this._pivotClientObj))
                    this.model.beforeExport = this._pivotClientObj.model.beforeExport;
               this.exportPivotGrid(selectedValue, "Sample");
            }
            if (((evt.element != undefined && evt.parentText == this._getLocalizedLabels("FrozenHeader")) || $(evt.target).parents().hasClass("frozenDialog")) && (!this.model.enableCollapseByDefault)) {
                if (evt.ID == "row" || $(evt.target).hasClass("rowFreeze")) {
                    if (this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                        this.model.frozenHeaderSettings.enableFrozenRowHeaders = false;
                    else
                        this.model.frozenHeaderSettings.enableFrozenRowHeaders = true;
                }
                if (evt.ID == "column" || $(evt.target).hasClass("colFreeze")) {
                    if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders)
                        this.model.frozenHeaderSettings.enableFrozenColumnHeaders = false
                    else
                        this.model.frozenHeaderSettings.enableFrozenColumnHeaders = true;
                }
                this.renderControlFromJSON();
            }
        },
        
        _createMenuIcons: function (evt) {
            if ($(evt.target).hasClass("exporting")) {
                var exportDlg = ej.buildTag("div.exportDialog#exportDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                       ej.buildTag("td", ej.buildTag("div.excel exportingIcons").attr({ "aria-label": this._getLocalizedLabels("Excel"), "title": this._getLocalizedLabels("Excel"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.word exportingIcons").attr({ "aria-label": this._getLocalizedLabels("Word"), "title": this._getLocalizedLabels("Word"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.pdf exportingIcons").attr({ "aria-label": this._getLocalizedLabels("PDF"), "title": this._getLocalizedLabels("PDF"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.csv exportingIcons").attr({ "aria-label": this._getLocalizedLabels("CSV"), "title": this._getLocalizedLabels("CSV"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML;
                if (this.element.find("div .exportDialog").length == 0) {
                    $(exportDlg).appendTo(this.element);
                    $(".exportDialog").css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop + 15) + "px");
                }
            }
            if ($(evt.target).hasClass("hyperlinkOptions")) {
                var hyperLinkDlg = ej.buildTag("div.hyperLinkDialog#hyperLinkTypesDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                       ej.buildTag("td", ej.buildTag("div.rowHeaderHyperLink hyperLinkIcons").attr({ "aria-label": this._getLocalizedLabels("EnableRowHeaderHyperlink"), "title": this._getLocalizedLabels("EnableRowHeaderHyperlink"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.colHeaderHyperLink hyperLinkIcons").attr({ "aria-label": this._getLocalizedLabels("EnableColumnHeaderHyperlink"), "title": this._getLocalizedLabels("EnableColumnHeaderHyperlink"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.valueCellHyperLink hyperLinkIcons").attr({ "aria-label": this._getLocalizedLabels("EnableValueCellHyperlink"), "title": this._getLocalizedLabels("EnableValueCellHyperlink"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.summaryCellHyperLink hyperLinkIcons").attr({ "aria-label": this._getLocalizedLabels("EnableSummaryCellHyperlink"), "title": this._getLocalizedLabels("EnableSummaryCellHyperlink"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
                if (this.element.find('div.hyperLinkDialog').length == 0) {
                    $(hyperLinkDlg).appendTo(this.element);
                    $(hyperLinkDlg).css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop +15) + "px");
                    if (this.model.hyperlinkSettings.enableRowHeaderHyperlink)
                        this.element.find(".rowHeaderHyperLink").addClass("enabled");
                    if (this.model.hyperlinkSettings.enableColumnHeaderHyperlink)
                        this.element.find(".colHeaderHyperLink").addClass("enabled");
                    if (this.model.hyperlinkSettings.enableValueCellHyperlink)
                        this.element.find(".valueCellHyperLink").addClass("enabled");
                    if (this.model.hyperlinkSettings.enableSummaryCellHyperlink)
                        this.element.find(".summaryCellHyperLink").addClass("enabled");
                }
            }
            if ($(evt.target).hasClass("frozenHeaders")) {
                var frozenDlg = ej.buildTag("div.frozenDialog#frozenDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                 ej.buildTag("td", ej.buildTag("div.rowFreeze frozenHeaderIcons").attr({ "aria-label": this._getLocalizedLabels("Row"), "title": this._getLocalizedLabels("Row"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                 ej.buildTag("td", ej.buildTag("div.colFreeze frozenHeaderIcons").attr({ "aria-label": this._getLocalizedLabels("Column"), "title": this._getLocalizedLabels("Column"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML;
                   if (this.element.find("div.frozenDialog").length == 0) {
                    $(frozenDlg).appendTo(this.element);
                    $(".frozenDialog").css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop +15) + "px");
                    if (this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                        this.element.find(".rowFreeze").addClass("enabled");
                    if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders)
                        this.element.find(".colFreeze").addClass("enabled");
                    if (this.model.frozenHeaderSettings.enableFrozenHeaders)
                        this.element.find(".bothFreeze").addClass("enabled");
                }
            }
            if ($(evt.target).hasClass("layouts")) {
                var layoutsDialog = ej.buildTag("div.layoutsDialog#layoutsDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                       ej.buildTag("td", ej.buildTag("div.normalLayout layoutIcons").attr({ "aria-label": this._getLocalizedLabels("NormalLayout"), "title": this._getLocalizedLabels("NormalLayout"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       ej.buildTag("td", ej.buildTag("div.excelLikeLayout layoutIcons").attr({ "aria-label": this._getLocalizedLabels("ExcelLikeLayout"), "title": this._getLocalizedLabels("ExcelLikeLayout"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                       (this.model.analysisMode==ej.Pivot.AnalysisMode.Olap?ej.buildTag("td", ej.buildTag("div.noSummariesLayout layoutIcons").attr({ "aria-label": this._getLocalizedLabels("NoSummaries"), "title": this._getLocalizedLabels("NoSummaries"), tabindex: 0 })[0].outerHTML)[0].outerHTML:"") +
					   (this.model.analysisMode==ej.Pivot.AnalysisMode.Olap && this.model.operationalMode==ej.Pivot.OperationalMode.ServerMode?ej.buildTag("td", ej.buildTag("div.normalTopSummaryLayout layoutIcons").attr({ "aria-label": this._getLocalizedLabels("NormalTopSummary"), "title": this._getLocalizedLabels("NormalTopSummary"), tabindex: 0 })[0].outerHTML)[0].outerHTML:""))[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML;
                if (this.element.find("div .layoutsDialog").length == 0) {
                    $(layoutsDialog).appendTo(this.element);
                    $(".layoutsDialog").css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop + 15) + "px");
                    if (this.model.layout==ej.PivotGrid.Layout.Normal)
                        this.element.find(".normalLayout").addClass("enabled");
                    if (this.model.layout == ej.PivotGrid.Layout.ExcelLikeLayout)
                        this.element.find(".excelLikeLayout").addClass("enabled");
                    if (this.model.layout == ej.PivotGrid.Layout.NoSummaries)
                        this.element.find(".noSummariesLayout").addClass("enabled");
                    if (this.model.layout == ej.PivotGrid.Layout.NormalTopSummary)
                        this.element.find(".normalTopSummaryLayout").addClass("enabled");
                }
            }
        },
        _createMenuDialog: function (evt) {
            this._dialogName = !ej.isNullOrUndefined(evt.target) ? $(evt.target).attr("class").split(" ")[0] : $(evt.element).attr("class").split(" ")[0];
            ej.Pivot.openPreventPanel(this);
            var ejDialog = ej.buildTag("div#clientDialog.clientDialog", { "opacity": "1" })[0].outerHTML;
            var dialogTitle = currentTag = dialogContent = "";
            if ($(evt.target).hasClass("numberFormatting") || $(evt.element).hasClass("numberFormatting")) {
                dialogTitle = this._getLocalizedLabels("NumberFormatting");
                currentTag = "Number Formatting";
                var measure = ej.buildTag("label", this._getLocalizedLabels("Measures"))[0].outerHTML;
                var measureList = "<select id='measureOption'>";
                for (var i = 0; i < this.model.dataSource.values.length; i++) {
                    measureList += "<option>" + this.model.dataSource.values[i].fieldName + "</option>";
                }
                measureList += "</select>";
                var format = ej.buildTag("label", this._getLocalizedLabels("NumberFormats"))[0].outerHTML;
                var numberformatting = "<div class='summarTypes'><select id='numberFormatOption'><option value='Decimal'>Decimal</option><option value='Currency'>Currency</option><option value='Percentage'>Percentage</option><option value='Number'>Number</option><option value='Date'>Date</option><option value='Time'>Time</option><option value='Scientific'>Scientific</option><option value='Fraction'>Fraction</option></select></div>";
                dialogContent = ej.buildTag("div#reportDlg.reportDlg", "<table><tr><td>" + measure + "</td><td>" + measureList + "</td></tr><tr><td>" + format + "</td><td>" + numberformatting + "</td></tr></table>")[0].outerHTML;
            }
            if ($(evt.target).hasClass("summaryCustomize") || $(evt.element).hasClass("summaryCustomize")) {
                dialogTitle = this._getLocalizedLabels("SummaryCustomization");
                var label1 = ej.buildTag("label", this._getLocalizedLabels("HideGrandTotal"))[0].outerHTML;
                var label2 = ej.buildTag("label", this._getLocalizedLabels("HideSubTotal"))[0].outerHTML;
                var measureList = "<div class='measures'><select id='hideSubTotal'>";
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    for (var i = 0; i < this.model.dataSource.columns.length; i++) {
                        measureList += "<option>" + this.model.dataSource.columns[i].fieldCaption + "</option>";
                    }
                    for (var i = 0; i < this.model.dataSource.rows.length; i++) {
                        measureList += "<option>" + this.model.dataSource.rows[i].fieldCaption + "</option>";
                    }
                }
                else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var olapReport = $(this.element).parents(".e-pivotclient").length > 0 ? this._pivotClientObj.getOlapReport() : this.getOlapReport();
                    for (var i = 0; i < (JSON.parse(olapReport).PivotRows).length; i++) {
                        measureList += "<option>" + (JSON.parse(olapReport).PivotRows[i].FieldName) + "</option>";
                    }
                    for (var i = 0; i < (JSON.parse(olapReport).PivotColumns).length; i++) {
                        measureList += "<option>" + (JSON.parse(olapReport).PivotColumns[i].FieldName) + "</option>";
                    }
                }
                measureList += "</div>";
                var rowGrndRadio = ej.buildTag("input#rowSumCheckBox.rowSumCheckBox", "", {}, { name: 'row', type: 'checkbox', tabindex: 0 })[0].outerHTML + " " + ej.buildTag("label.rowGrndlabel", this._getLocalizedLabels("Row"))[0].outerHTML + "<br/>";
                var colGrndRadio = ej.buildTag("input#colSumCheckBox.colSumCheckBox", "", {}, { name: 'column', type: 'checkbox', tabindex: 0 })[0].outerHTML + " " + ej.buildTag("label.colGrndlabel", this._getLocalizedLabels("Column"))[0].outerHTML + "<br/>";
                var bothGrndRadio = ej.buildTag("input#bothSumCheckBox.bothSumCheckBox", "", {}, { name: 'both', type: 'checkbox', tabindex: 0 })[0].outerHTML + " " + ej.buildTag("label.bothGrndlabel", this._getLocalizedLabels("Both"))[0].outerHTML + "<br/>";
                if (this.model.analysisMode == "pivot")
                    dialogContent = ej.buildTag("div#customizeDlg.customizeDlg", "<table><tr><td style='vertical-align:top'>" + label1 + "</td><td>" + rowGrndRadio + colGrndRadio + bothGrndRadio + "</td></tr><tr><td>" + label2 + "</td><td>" + measureList + "</td></tr></table>")[0].outerHTML;
                else
                    dialogContent = ej.buildTag("div#customizeDlg.customizeDlg", "<table><tr><td>" + label1 + "</td><td>" + rowGrndRadio + colGrndRadio + bothGrndRadio + "</td></tr></table>")[0].outerHTML;
            }
            if ($(evt.target).hasClass("summaryTypes") || $(evt.element).hasClass("summaryTypes")) {
                dialogTitle = this._getLocalizedLabels("SummaryTypes");
                var label1 = ej.buildTag("label", this._getLocalizedLabels("Measures"))[0].outerHTML;
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    var measureList = "<div class='measures'><select id='drillMeasure'>";
                    for (var i = 0; i < this.model.dataSource.values.length; i++) {
                        measureList += "<option>" + this.model.dataSource.values[i].fieldCaption + "</option>";
                    }
                    measureList += "</div>";
                }
                var label2 = ej.buildTag("label", this._getLocalizedLabels("SummaryType"))[0].outerHTML;
                var drpdown2 = ej.buildTag("input#drillSum").attr("type", "text")[0].outerHTML;
                dialogContent = ej.buildTag("div#summaryDlg.#summaryDlg", "<table><tr><td>" + label1 + "</td><td>" + measureList + "</td></tr><tr><td>" + label2 + "</td><td>" + drpdown2 + "</td></tr></table>")[0].outerHTML;
            }
            var EditorDiv = ej.buildTag("div#EditorDiv.editorDiv", "", { "margin-left": "5px" })[0].outerHTML;
            dialogContent += EditorDiv;
            var okBtn = "<button id=OKBtn class='dialogOkBtn'>" + this._getLocalizedLabels("OK") + "</button>";
            var cancelBtn = "<button id=CancelBtn class='dialogCancelBtn'>" + this._getLocalizedLabels("Cancel") + "</button>";
            dialogFooter = ej.buildTag("div.dialogFooter", okBtn + cancelBtn, { "float": "right", "margin-bottom": "7px" })[0].outerHTML;
            $(ejDialog).appendTo("#preventDiv");
            $(dialogContent + dialogFooter).appendTo(".clientDialog");
            $(".clientDialog").ejDialog({ enableRTL: this.model.enableRTL, width: 'auto', target: "#" + this._id, enableResize: false, close: ej.Pivot.closePreventPanel(this) });
            $(".e-titlebar").prepend(ej.buildTag("div", dialogTitle, { "display": "inline" })[0].outerHTML)[0];
            $(".dialogOkBtn, .dialogCancelBtn").ejButton({ width:"67px",enableRTL: this.model.enableRTL, type: ej.ButtonType.Button });
            if (this._selectedFormat == "" && this._selectedMeasure == "") {
                $("#numberFormatOption").ejDropDownList({ enableRTL: this.model.enableRTL, selectedIndex: 0, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
                $("#measureOption").ejDropDownList({ enableRTL: this.model.enableRTL, selectedIndex: 0, showCheckbox: true, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
            }
            if (this._selectedMeasure != "" && this._selectedFormat != "") {
                $("#numberFormatOption").ejDropDownList({ enableRTL: this.model.enableRTL, text: this._selectedFormat, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
                $("#measureOption").ejDropDownList({ enableRTL: this.model.enableRTL, text: this._selectedMeasure, showCheckbox: true, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
            }
            $("#categoricalInput").ejMaskEdit({ name: "mask", inputMode: ej.InputMode.Text, watermarkText: "Column Page Size" });
            $("#seriesInput").ejMaskEdit({ name: "mask", inputMode: ej.InputMode.Text, watermarkText: "Row Page Size" });

            $("#rowSumCheckBox,#colSumCheckBox,#bothSumCheckBox").ejCheckBox({ size: "small", showRoundedCorner: true });
            this.rowCheckBox = $("#rowSumCheckBox").data("ejCheckBox"); this.colCheckBox = $("#colSumCheckBox").data("ejCheckBox"); this.bothCheckBox = $("#bothSumCheckBox").data("ejCheckBox");
            if ($(evt.target).hasClass("summaryCustomize") || $(evt.element).hasClass("summaryCustomize")) {
                if (this.rowGrand == false)
                    this.rowCheckBox.setModel({ checked: 'checked' });
                if (this.colGrand == false)
                    this.colCheckBox.setModel({ checked: 'checked' });
                if (this.bothGrand == false)
                    this.bothCheckBox.setModel({ checked: 'checked' });

                $("#hideSubTotal").ejDropDownList({
                    showCheckbox: true,
                    enableRTL: this.model.enableRTL,
                    create: function(){ $(this.wrapper.find('.e-input')).focus(function () { $(this).blur();})}
                });
                this.dropmeasure = $("#hideSubTotal").data("ejDropDownList");
                if (this.selval != undefined) {
                    this.dropmeasure.setModel({ value: this.selval });
                }
            }
            if ($(evt.target).hasClass("summaryTypes") || $(evt.element).hasClass("summaryTypes")) {
                $("#_summaryOK,#_summaryCancel").ejButton({ enableRTL: this.model.enableRTL });
                $("#drillMeasure").ejDropDownList({
                    selectedIndices: [0],
                    enableRTL: this.model.enableRTL,
                   create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }

                });
                $("#drillSum").ejDropDownList({
                    dataSource: [{ option: "Sum", value: this._getLocalizedLabels("Sum") },
                             { option: "Average", value: this._getLocalizedLabels("Average") },
                             { option: "Count", value: this._getLocalizedLabels("Count") },
                             { option: "Min", value: this._getLocalizedLabels("Min") },
                             { option: "Max", value: this._getLocalizedLabels("Max") }
                    ],
                    fields: { text: "value", value: "option" },
                    selectedIndices: [0],
                    enableRTL: this.model.enableRTL,
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                drilmes = $("#drillMeasure").data("ejDropDownList");
                drilsum = $("#drillSum").data("ejDropDownList");
                if (this.drilsumval != undefined) {
                    drilmes.setModel({ value: this.drilsumval });
                }
                if (this.sumtyp != null) {
                    drilsum.setModel({ value: this.sumtyp });
                }
            }
        },
        _dialogOKBtnClick: function (e) {
            if (this._dialogName == "numberFormatting") {
                this._selectedFormat = $("#numberFormatOption").ejDropDownList("getSelectedValue");
                this._selectedMeasure = $("#measureOption").ejDropDownList("getSelectedValue");
                var measureList = this._selectedMeasure.split(',');
                this.element.find(".e-dialog").remove();
                ej.Pivot.closePreventPanel(this);
                for (var i = 0; i < this.model.dataSource.values.length; i++) {
                    for (var j = 0; j < measureList.length; j++) {
                        if (this.model.dataSource.values[i].fieldName == measureList[j])
                            this.model.dataSource.values[i]["format"] = this._selectedFormat.toLowerCase();
                    }
                }
                if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.analysisMode == "pivot" && this._pivotClientObj.model.operationalMode == "clientmode")
                    this.model.collapsedMembers = null;
                this._populatePivotGrid();
            }
            if (this._dialogName == "summaryCustomize") {
                pGridObj = this;
                if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.analysisMode == "pivot" && this._pivotClientObj.model.operationalMode == "clientmode")
                    pGridObj.model.collapsedMembers = null;
                if (pGridObj.rowCheckBox.model.checked) {
                    pGridObj.model.enableColumnGrandTotal = pGridObj.model.enableGrandTotal = true;
                    pGridObj.model.enableRowGrandTotal = pGridObj.rowGrand = false;
                }
                else
                    pGridObj.model.enableRowGrandTotal = pGridObj.rowGrand = true;
                if (pGridObj.colCheckBox.model.checked) {
                    pGridObj.model.enableRowGrandTotal = pGridObj.model.enableGrandTotal = true;
                    pGridObj.model.enableColumnGrandTotal = pGridObj.colGrand = false;
                }
                else
                    pGridObj.model.enableColumnGrandTotal = pGridObj.colGrand = true;
                if (pGridObj.bothCheckBox.model.checked || (pGridObj.colCheckBox.model.checked && pGridObj.rowCheckBox.model.checked)) {
                    pGridObj.model.enableRowGrandTotal = pGridObj.model.enableColumnGrandTotal = true;
                    pGridObj.model.enableGrandTotal = pGridObj.bothGrand = false;
                }
                else
                    pGridObj.model.enableGrandTotal = pGridObj.bothGrand = true;
                if ($("#hideSubTotal").ejDropDownList("getSelectedValue") != null && this.model.analysisMode == "pivot" && this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    pGridObj.selval = $("#hideSubTotal").ejDropDownList("getSelectedValue");
                    var selectedValues = $("#hideSubTotal").ejDropDownList("getSelectedValue").split(',');
                    if (pGridObj.model.dataSource.rows.length > 0)
                        $.each(pGridObj.model.dataSource.rows, function (e, item) { if (item.fieldName.length > 0) item["showSubTotal"] = true; });
                    if (pGridObj.model.dataSource.columns.length > 0)
                        $.each(pGridObj.model.dataSource.columns, function (e, item) { if (item.fieldName.length > 0) item["showSubTotal"] = true; });
                    $.each(selectedValues, function (e, selectedValue) {
                        if (pGridObj.model.dataSource.rows.length > 0)
                            $.each(pGridObj.model.dataSource.rows, function (e, item) { if (item.fieldName.length > 0 && item.fieldName == selectedValue) item["showSubTotal"] = false; });
                        if (pGridObj.model.dataSource.columns.length > 0)
                            $.each(pGridObj.model.dataSource.columns, function (e, item) { if (item.fieldName.length > 0 && item.fieldName == selectedValue) item["showSubTotal"] = false; });
                    });
                    pGridObj._populatePivotGrid();
                }

                else if (this.model.analysisMode == "pivot" && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    pGridObj.selval = $("#hideSubTotal").ejDropDownList("getSelectedValue");
                    var selectedValues = $("#hideSubTotal").ejDropDownList("getSelectedValue").split(',');
                    var dataSource = ($(this.element).parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? JSON.parse(this._pivotClientObj.getOlapReport()) : JSON.parse(pGridObj.getOlapReport());
                    if (dataSource.PivotRows.length > 0)
                        $.each(dataSource.PivotRows, function (e, item) { if (item.FieldName.length > 0) item["showSubTotal"] = true; });
                    if (dataSource.PivotColumns.length > 0)
                        $.each(dataSource.PivotColumns, function (e, item) { if (item.FieldName.length > 0) item["showSubTotal"] = true; });
                    $.each(selectedValues, function (e, selectedValue) {
                        if (dataSource.PivotRows.length > 0)
                            $.each(dataSource.PivotRows, function (e, item) {
                                if (item.FieldName.length > 0 && item.FieldName == selectedValue)
                                    item["showSubTotal"] = false;
                            });
                        if (dataSource.PivotColumns.length > 0)
                            $.each(dataSource.PivotColumns, function (e, item) {
                                if (item.FieldName.length > 0 && item.FieldName == selectedValue)
                                    item["showSubTotal"] = false;
                            });
                    });
                    var msg = { JsonRecords: JSON.stringify(pGridObj.getJSONRecords()), PivotReport: JSON.stringify(dataSource) }
                    pGridObj._renderControlSuccess(msg);
                }
                else
                    pGridObj._load();
                ej.Pivot.closePreventPanel(this);
            }
            if (this._dialogName == "summaryTypes") {
                if ($("#drillSum").val() != undefined) {
                    this.drilsumval = $("#drillMeasure").ejDropDownList("getSelectedValue");
                    var summarytyp = this.sumtyp = $("#drillSum").val();
                    if (summarytyp != null)
                        var s = summarytyp.toLowerCase();
                    if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                        var len = $("#drillMeasure").ejDropDownList("getSelectedValue").split(",").length;
                        for (var i = 0; i < len; i++) {
                            var selectedValue = $("#drillMeasure").ejDropDownList("getSelectedValue").split(",")[i];
                            $.grep(this.model.dataSource.values, function (item) { return item.fieldName == selectedValue; })[0]["summaryType"] = s;
                        }
                        if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.analysisMode == "pivot" && this._pivotClientObj.model.operationalMode == "clientmode")
                            this.model.collapsedMembers = null;
                        this._populatePivotGrid();
                    }
                }
                ej.Pivot.closePreventPanel(this);
            }
        },

        _keyUpPress:function(e){

            if (e.which === 16 && this.model.enableCellSelection) {
                this._completeCellSelection(e);
                $("#" + this._id).find(".value").removeClass("hoverCell");
                this._startPosCell = null;
                _startPosCell = null;
            }  
            if (e.which === 13 && this.model.enableCellEditing && !this.model.enableCellSelection && $("#" + this._id).find(".value.hoverCell").length) {
                $("#" + this._id).find(".value.hoverCell").trigger("mouseover");
                _startPosCell = $($("#" + this._id).find(".value.hoverCell")).attr("p");
                var selEle = { target: $("#" + this._id).find(".value.hoverCell > span")[0] };
                this._completeCellEditing(selEle);
                e.preventDefault();
                $("#" + this._id).find(".value.hoverCell .curInput").focus();
                $("#" + this._id).find(".value").removeClass("hoverCell");
            }
        },
        _keyDownPress: function (e) {
            if ($(".e-pivotpager[targetcontrolid='" + this._id + "']:visible").length > 0) {
                if (document.activeElement.id == "Pager_CategCurrentPage" || document.activeElement.id == "Pager_SeriesCurrentPage") {
                    if (e.which === 35) {
                        e.preventDefault();
                        if (document.activeElement.id == "Pager_CategCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .moveLast").first().trigger("click");
                        }
                        else if (document.activeElement.id == "Pager_SeriesCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .moveLast").last().trigger("click");
                        }
                    }
                    else if (e.which == 36) {
                        e.preventDefault();
                        if (document.activeElement.id == "Pager_CategCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .moveFirst").first().trigger("click");
                        }
                        else if (document.activeElement.id == "Pager_SeriesCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .moveFirst").last().trigger("click");
                        }
                    }
                    if (e.which === 39) {
                        if (document.activeElement.id == "Pager_CategCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .moveNext").first().trigger("click");
                        }
                        else if (document.activeElement.id == "Pager_SeriesCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .moveNext").last().trigger("click");
                        }
                    }
                    else if (e.which === 37) {
                        if (document.activeElement.id == "Pager_CategCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .movePrevious").first().trigger("click");
                        }
                        else if (document.activeElement.id == "Pager_SeriesCurrentPage") {
                            $(".e-pivotpager[targetcontrolid='" + this._id + "'] .movePrevious").last().trigger("click");
                        }
                    }
                }
                e.stopImmediatePropagation();
            }
            if (e.which === 27 && (!ej.isNullOrUndefined(this._curFocus.grp) || (!ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("pivotButton")))) {
                var focEl;
                this._curFocus.tab.mouseleave().removeClass("hoverCell");
                if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                    var tag = this._curFocus.grp.attr("tag");
                    focEl = this._curFocus.grp = $("#" + this._id).find("[tag='" + tag + "']");
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("pivotButton")) {
                    var tag = this._curFocus.tab.attr("tag");
                    focEl = this._curFocus.tab = $("#" + this._id).find("[tag='" + tag + "']");
                }
                focEl.mouseover().addClass("hoverCell").focus();
                this._index.filter = 0;
                if (this.model.dataSource.enableAdvancedFilter) {
                    this._index.dialog = 0;
                }
                else {
                    this._index.dialog = 1;
                }
                this._index.field = 0;
            }
            else if (e.which === 27) {
                this._index.dialog = 0;
            }
            if (e.which === 70 && e.ctrlKey) {
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                    this._curFocus.grp.find(".filter").click();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.find(".filter").click();
                }
            }
            if (e.which === 83 && e.ctrlKey) {
                e.preventDefault();
                var focEl;
                if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                    this._curFocus.grp.find(".sorting").click();
                    var tag = this._curFocus.grp.attr("tag");
                    focEl = this._curFocus.grp = $("#" + this._id).find("[tag='" + tag + "']");
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.find(".sorting").click();
                    var tag = this._curFocus.tab.attr("tag");
                    focEl = this._curFocus.tab = $("#" + this._id).find("[tag='" + tag + "']");
                }
                focEl.mouseover().addClass("hoverCell").focus();
            }
            if (e.which === 46 || (e.which === 82 && e.ctrlKey)) {
                if (e.which != 46)
                    e.preventDefault();
                if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                    this._curFocus.grp.find(".removeBtn").click();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.find(".removeBtn").click();
                }
            }
            if (e.shiftKey) {
                if (ej.isNullOrUndefined(this._startPosCell)) {
                    _startPosCell = e.target.getAttribute("p");
                    this._startPosCell = e.target.getAttribute("p");
                }
            }
            if (e.which === 39 && $("#" + this._id).find(".e-dialog .hoverCell").length > 0) {
                $("#" + this._id).find(".e-dialog .hoverCell").parent().find(".e-plus").click();
            }
            else if (e.which === 37 && $("#" + this._id).find(".e-dialog .hoverCell").length > 0) {
                $("#" + this._id).find(".e-dialog .hoverCell").parent().find(".e-minus").click();
            }
            if ((e.which === 40 || e.which === 39 || e.which === 38 || e.which === 37) && e.shiftKey && this.model.enableCellSelection) {
                $("#" + this._id).find(".hoverCell").removeClass("hoverCell");
                if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.attr("tabindex", "0");
                }
                var selectedCell = $(e.target);
                if (e.which == "40") {  //Down arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[1]) + Number(selectedCell.attr("rowspan"));
                    var cell;
                    while (ej.isNullOrUndefined(cell) && i < this._rowCount) {
                        var currentCell = $($("#" + this._id)).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        this._curFocus.selection = $(cell);
                        i++;
                    }
                }
                else if (e.which == "38") {  //Up arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[1]) - 1;
                    var cell;
                    while (ej.isNullOrUndefined(cell) && i >= 0) {
                        var currentCell = $($("#" + this._id)).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                        if (ej.isNullOrUndefined(currentCell)) {
                            currentCell = $($("#" + this._id)).find("[p='" + (parseInt(selectedCellPos.split(',')[0]) - 1) + "," + i + "']")[0];
                        }
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        this._curFocus.selection = $(cell);
                        i--;
                    }
                }
                else if (e.which == "39") {  //Right arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[0]) + Number(selectedCell.attr("colspan"));
                    var cell;
                    while (ej.isNullOrUndefined(cell) && i < Math.ceil(this.getJSONRecords().length / this._rowCount)) {
                        var currentCell = $($("#" + this._id)).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        this._curFocus.selection = $(cell);
                        i++;
                    }
                }
                else if (e.which == "37") {  //Left Arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[0]) - 1;
                    var cell = $($("#" + this._id)).find("[p='" + (parseInt(selectedCellPos.split(',')[0]) - 1) + "," + selectedCellPos.split(',')[1] + "']")[0];
                    while (ej.isNullOrUndefined(cell) && i >= 0) {
                        var currentCell = $($("#" + this._id)).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        i--;
                    }
                    this._curFocus.selection = $(cell);
                }
                this._curFocus.selection.attr("tabindex", "-1").focus().addClass("hoverCell");
                if (Number(_startPosCell.split(",")[0]) <= Number(this._curFocus.selection.attr("p").split(",")[0]) && Number(_startPosCell.split(",")[1]) <= Number(this._curFocus.selection.attr("p").split(",")[1])) {
                    for (i = Number(_startPosCell.split(",")[0]) ; i <= Number(this._curFocus.selection.attr("p").split(",")[0]) ; i++) {
                        for (j = Number(_startPosCell.split(",")[1]) ; j <= Number(this._curFocus.selection.attr("p").split(",")[1]) ; j++) {
                            if ($("#" + this._id).find("[p='" + i + "," + j + "']").hasClass("value")) {
                                $("#" + this._id).find("[p='" + i + "," + j + "']").addClass("hoverCell");
                            }
                        }
                    }
                }
                else if (Number(_startPosCell.split(",")[0]) >= Number(this._curFocus.selection.attr("p").split(",")[0]) && Number(_startPosCell.split(",")[1]) >= Number(this._curFocus.selection.attr("p").split(",")[1])) {
                    for (i = Number(_startPosCell.split(",")[0]) ; i >= Number(this._curFocus.selection.attr("p").split(",")[0]) ; i--) {
                        for (j = Number(_startPosCell.split(",")[1]) ; j >= Number(this._curFocus.selection.attr("p").split(",")[1]) ; j--) {
                            if ($("#" + this._id).find("[p='" + i + "," + j + "']").hasClass("value")) {
                                $("#" + this._id).find("[p='" + i + "," + j + "']").addClass("hoverCell");
                            }
                        }
                    }
                }
                else if (Number(_startPosCell.split(",")[0]) <= Number(this._curFocus.selection.attr("p").split(",")[0]) && Number(_startPosCell.split(",")[1]) >= Number(this._curFocus.selection.attr("p").split(",")[1])) {
                    for (i = Number(_startPosCell.split(",")[0]) ; i <= Number(this._curFocus.selection.attr("p").split(",")[0]) ; i++) {
                        for (j = Number(_startPosCell.split(",")[1]) ; j >= Number(this._curFocus.selection.attr("p").split(",")[1]) ; j--) {
                            if ($("#" + this._id).find("[p='" + i + "," + j + "']").hasClass("value")) {
                                $("#" + this._id).find("[p='" + i + "," + j + "']").addClass("hoverCell");
                            }
                        }
                    }
                }
                else if (Number(_startPosCell.split(",")[0]) >= Number(this._curFocus.selection.attr("p").split(",")[0]) && Number(_startPosCell.split(",")[1]) <= Number(this._curFocus.selection.attr("p").split(",")[1])) {
                    for (i = Number(_startPosCell.split(",")[0]) ; i >= Number(this._curFocus.selection.attr("p").split(",")[0]) ; i--) {
                        for (j = Number(_startPosCell.split(",")[1]) ; j <= Number(this._curFocus.selection.attr("p").split(",")[1]) ; j++) {
                            if ($("#" + this._id).find("[p='" + i + "," + j + "']").hasClass("value")) {
                                $("#" + this._id).find("[p='" + i + "," + j + "']").addClass("hoverCell");
                            }
                        }
                    }
                }
            }
            else if ((e.which === 40 || e.which === 38 || e.which === 37 || e.which === 39) && $("#" + this._id).find(".calcFormulaDiv:visible").length > 0) {
                e.preventDefault();
                var td = $("#" + this._id).find(".calcFormulaDiv td:visible");
                if (!ej.isNullOrUndefined(this._curFocus.formula)) {
                    this._curFocus.formula.removeClass("hoverCell").mouseleave();
                    if (e.which === 39) {
                        this._index.formula = this._index.formula + 1 > td.length - 1 ? 0 : this._index.formula + 1;
                    }
                    else if (e.which === 37) {
                        this._index.formula = this._index.formula - 1 < 0 ? td.length - 1 : this._index.formula - 1;
                    }
                    else if (e.which === 40) {
                        this._index.formula = this._index.formula + 4 > td.length - 1 ? (this._index.formula + 4) % 10 : this._index.formula + 4;
                    }
                    else if (e.which === 38) {
                        this._index.formula = this._index.formula - 4 < 0 ? (this._index.formula - 4) + 20 : this._index.formula - 4;
                    }
                    this._curFocus.formula = td.eq(this._index.formula).addClass("hoverCell").mouseover();
                }
                else {
                    this._index.formula = e.which == 39 ? 0 : e.which == 37 ? td.length - 1 : 0;
                    this._curFocus.formula = td.eq(this._index.formula).addClass("hoverCell").mouseover();
                }
            }
            else if ((e.keyCode === 40 || e.which === 38) && $("#" + this._id).find(".e-dialog:visible").length > 0 && !ej.isNullOrUndefined($("#" + this._id).find(".e-dialog .e-text")) && $(".e-dialog .e-text").hasClass("hoverCell")) {
                $("#" + this._id).find(".e-dialog .hoverCell").removeClass("hoverCell");
                e.preventDefault();
                var td = $("#" + this._id).find(".e-dialog .e-text:visible");
                if (!ej.isNullOrUndefined(this._curFocus.filter)) {
                    this._curFocus.filter.attr("tabindex", "0").removeClass("hoverCell");
                    if (e.which === 40) {
                        this._index.filter = this._index.filter + 1 > td.length - 1 ? 0 : this._index.filter + 1;
                    }
                    else if (e.which === 38) {
                        this._index.filter = this._index.filter - 1 < 0 ? td.length - 1 : this._index.filter - 1;
                    }
                    this._curFocus.filter = td.eq(this._index.filter).attr("tabindex", "-1");
                }
                else {
                    this._index.filter = e.which == 40 ? 1 : e.which == 38 ? td.length - 1 : 0;
                    this._curFocus.filter = td.eq(this._index.filter).attr("tabindex", "-1");
                }
                this._curFocus.filter.focus().addClass("hoverCell");
                $(".e-node-focus").removeClass("e-node-focus");
            }
            else if ((e.which === 40 || e.which === 38 || e.which === 37 || e.which === 39) && !ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("pivotButton") && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0 && !$("#" + this._id).find(".e-dialog:visible").length > 0) {
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.mouseleave().attr("tabindex", "0").removeClass("hoverCell");
                }
                var td = $("#" + this._id).find(".pivotButton");
                if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                    this._curFocus.grp.attr("tabindex", "0").removeClass("hoverCell").mouseleave();
                    if (e.which === 40 || e.which === 39) {
                        this._index.grp = this._index.grp + 1 > td.length - 1 ? 0 : this._index.grp + 1;
                    }
                    else if (e.which === 38 || e.which === 37) {
                        this._index.grp = this._index.grp - 1 < 0 ? td.length - 1 : this._index.grp - 1;
                    }
                    this._curFocus.grp = td.eq(this._index.grp);
                }
                else {
                    if (e.which === 40 || e.which === 39) {
                        this._curFocus.grp = td.eq(1).attr("tabindex", "-1");
                    }
                    else if (e.which === 38 || e.which === 37) {
                        this._curFocus.grp = td.eq(td.length - 1).attr("tabindex", "-1");
                    }
                }
                this._curFocus.grp.addClass("hoverCell").mouseover().focus();
            }
            else if ((e.which === 40 || e.which === 38 || e.which === 37 || e.which === 39) && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0 && (document.activeElement.getAttribute("role") == "columnheader" || document.activeElement.getAttribute("role") == "rowheader" || document.activeElement.getAttribute("role") == "gridcell")) {
                if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.attr("tabindex", "0");
                }
                if (!ej.isNullOrUndefined(this._curFocus.cell)) {
                    this._curFocus.cell.attr("tabindex", "0").removeClass("hoverCell");
                    if (this.model.hyperlinkSettings.enableColumnHeaderHyperlink) {
                        this._curFocus.cell.find("span").mouseleave();
                    }
                }
                this._index.menu = 0;
                this._curFocus.cmenu = null;
                var selectedCell = $(e.target);
                if (e.which == "40") {  //Down arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[1]) + Number(selectedCell.attr("rowspan"));
                    var cell;
                    while (ej.isNullOrUndefined(cell) && i <= this._rowCount) {
                        var currentCell = $("#" + this._id).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                        if (ej.isNullOrUndefined(currentCell) /*&& i == 0*/) {
                            for (k = parseInt(selectedCellPos.split(',')[0]) - 1; k >= 0; k--) {
                                if (ej.isNullOrUndefined(currentCell)) {
                                    currentCell = $("#" + this._id).find("[p='" + k + "," + i + "']")[0];
                                }
                            }
                        }
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        if (!ej.isNullOrUndefined(cell)) {
                            this._curFocus.cell = $(cell);
                        }
                        i++;
                    }
                }
                else if (e.which == "38") {  //Up arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[1]) - 1;
                    var cell;
                    var j = parseInt(selectedCellPos.split(',')[0]);
                    while (ej.isNullOrUndefined(cell) && i >= 0) {
                        var currentCell = $("#" + this._id).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                        if (ej.isNullOrUndefined(currentCell) && ((selectedCell.attr("role") == "gridcell") || (selectedCell.hasClass("summary") && (selectedCell.hasClass("calc"))))) {
                            for (k = parseInt(selectedCellPos.split(',')[1]) - 1; k >= 0; k--) {
                                if (ej.isNullOrUndefined(currentCell)) {
                                    currentCell = $("#" + this._id).find("[p='" + j + "," + k + "']")[0];
                                }
                            }
                        }
                        if (ej.isNullOrUndefined(currentCell) /*&& i == 0*/) {
                            for (k = parseInt(selectedCellPos.split(',')[0]) - 1; k >= 0; k--) {
                                if (ej.isNullOrUndefined(currentCell)) {
                                    currentCell = $("#" + this._id).find("[p='" + k + "," + i + "']")[0];
                                }
                            }
                        }
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        if (!ej.isNullOrUndefined(cell) && !$(cell).hasClass("grpRow")) {
                            this._curFocus.cell = $(cell);
                        }
                        i--;
                        j--;
                    }
                }
                else if (e.which == "39") {  //Right arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[0]) + Number(selectedCell.attr("colspan"));
                    var cell;
                    while (ej.isNullOrUndefined(cell) && i <= Math.ceil((Number($("#" + this._id).find(".pivotGridTable td:last").attr("p").split(",")[0]) + 1) * (Number($("#" + this._id).find(".pivotGridTable td:last").attr("p").split(",")[1]) + 1) / this._rowCount)) {
                        var currentCell = $("#" + this._id).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                        if (ej.isNullOrUndefined(currentCell) /*&& i == 0*/) {
                            for (k = parseInt(selectedCellPos.split(',')[1]) - 1; k >= 0; k--) {
                                if (ej.isNullOrUndefined(currentCell)) {
                                    currentCell = $("#" + this._id).find("[p='" + i + "," + k + "']")[0];
                                }
                            }
                        }
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        if (!ej.isNullOrUndefined(cell)) {
                            this._curFocus.cell = $(cell);
                        }
                        i++;
                    }
                }
                else if (e.which == "37") {  //Left Arrow
                    var selectedCellPos = selectedCell.attr('p'), i = parseInt(selectedCellPos.split(',')[0]) - 1;
                    var cell = $("#" + this._id).find("[p='" + (parseInt(selectedCellPos.split(',')[0]) - 1) + "," + selectedCellPos.split(',')[1] + "']")[0];
                    var j = parseInt(selectedCellPos.split(',')[1]);
                    while (ej.isNullOrUndefined(cell) && i >= 0) {
                        var currentCell = $("#" + this._id).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                        if (ej.isNullOrUndefined(currentCell) && (selectedCell.attr("role") == "gridcell")) {
                            for (k = parseInt(selectedCellPos.split(',')[0]) - 1; k >= 0; k--) {
                                if (ej.isNullOrUndefined(currentCell)) {
                                    currentCell = $("#" + this._id).find("[p='" + k + "," + j + "']")[0];
                                }
                            }
                        }
                        if (ej.isNullOrUndefined(currentCell)) {
                            for (k = parseInt(selectedCellPos.split(',')[1]) - 1; k >= 0; k--) {
                                if (ej.isNullOrUndefined(currentCell)) {
                                    currentCell = $("#" + this._id).find("[p='" + i + "," + k + "']")[0];
                                }
                            }
                        }
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                        i--;
                        j--;
                    }
                    if (!ej.isNullOrUndefined(cell) && !$(cell).hasClass("grpRow")) {
                        this._curFocus.cell = $(cell);
                    }
                }
                if (!ej.isNullOrUndefined(this._curFocus.cell)) {
                    $(".hoverCell").removeClass("hoverCell");
                    this._curFocus.cell.attr("tabindex", "-1").focus().addClass("hoverCell");
                    if (this.model.hyperlinkSettings.enableColumnHeaderHyperlink) {
                        this._curFocus.cell.mouseover();
                        this._curFocus.cell.find("span").mouseover();
                    }
                }
            }
            else if(e.which == 40 && $(".e-list").hasClass("hoverCell")){
                $("#" + this._id).find(".hoverCell").removeClass("hoverCell");
            }
            if (e.which === 9 && $("#" + this._id).find(".colheader.hoverCell")) {
                this._curFocus.cell = $("#" + this._id).find(".colheader.hoverCell");
            }
            if (((e.which === 9 && e.shiftKey) || e.which === 9) && $("#" + this._id).find("#" + this._id + "_clientDlg_wrapper :visible").length > 0) {
                e.preventDefault();
                if (!$("#" + this._id + "_editCon_hidden").hasClass("e-disable") && $("#" + this._id + "_conTo").attr("disabled") != "disabled") {
                    var td = $("#" + this._id).find("#" + this._id + "_conType_wrapper,#" + this._id + "_editCon_wrapper,#" + this._id + "_removeBtn,#" + this._id + "_conFrom,#" + this._id + "_conTo,#" + this._id + "_backcolor_wrapper,#" + this._id + "_borderrange_wrapper,#" + this._id + "_conFrom,#" + this._id + "_backcolor_wrapper,#" + this._id + "_bordercolor_wrapper,#" + this._id + "_borderstyle_wrapper,#" + this._id + "_fStyle_wrapper,#" + this._id + "_fSize_wrapper,#" + this._id + "_OKBtn,#" + this._id + "_CancelBtn,.e-dialog .e-close");
                }
                else if ($("#" + this._id + "_conTo").attr("disabled") != "disabled") {
                    var td = $("#" + this._id).find("#" + this._id + "_conType_wrapper,#" + this._id + "_conFrom,#" + this._id + "_conTo,#" + this._id + "_backcolor_wrapper,#" + this._id + "_borderrange_wrapper,#" + this._id + "_conFrom,#" + this._id + "_backcolor_wrapper,#" + this._id + "_bordercolor_wrapper,#" + this._id + "_borderstyle_wrapper,#" + this._id + "_fStyle_wrapper,#" + this._id + "_fSize_wrapper,#" + this._id + "_OKBtn,#" + this._id + "_CancelBtn,.e-dialog .e-close");
                }
                else if (!$("#" + this._id + "_editCon_hidden").hasClass("e-disable")) {
                    var td = $("#" + this._id).find("#" + this._id + "_conType_wrapper,#" + this._id + "_editCon_wrapper,#" + this._id + "_removeBtn,#" + this._id + "_conFrom,#" + this._id + "_backcolor_wrapper,#" + this._id + "_borderrange_wrapper,#" + this._id + "_conFrom,#" + this._id + "_backcolor_wrapper,#" + this._id + "_bordercolor_wrapper,#" + this._id + "_borderstyle_wrapper,#" + this._id + "_fStyle_wrapper,#" + this._id + "_fSize_wrapper,#" + this._id + "_OKBtn,#" + this._id + "_CancelBtn,.e-dialog .e-close");
                }
                else {
                    var td = $("#" + this._id).find("#" + this._id + "_conType_wrapper,#" + this._id + "_backcolor_wrapper,#" + this._id + "_borderrange_wrapper,#" + this._id + "_conFrom,#" + this._id + "_backcolor_wrapper,#" + this._id + "_bordercolor_wrapper,#" + this._id + "_borderstyle_wrapper,#" + this._id + "_fStyle_wrapper,#" + this._id + "_fSize_wrapper,#" + this._id + "_OKBtn,#" + this._id + "_CancelBtn,.e-dialog .e-close");
                }
                if (!ej.isNullOrUndefined(this._curFocus.cformat)) {
                    this._curFocus.cformat.attr("tabindex", "0").removeClass("hoverCell");
                    if (e.which === 9 && e.shiftKey) {
                        this._index.cformat = this._index.cformat - 1 < 0 ? td.length - 1 : this._index.cformat - 1;
                    }
                    else if (e.which === 9) {
                        this._index.cformat = this._index.cformat + 1 > td.length - 1 ? 0 : this._index.cformat + 1;
                    }
                    this._curFocus.cformat = td.eq(this._index.cformat).attr("tabindex", "-1");
                }
                else {
                    this._index.cformat = 1;
                    this._curFocus.cformat = td.eq(this._index.cformat).attr("tabindex", "-1");
                }
                this._curFocus.cformat.focus().addClass("hoverCell");
            }
            else if (((e.which === 9 && e.shiftKey) || e.which === 9) && $("#" + this._id).find(".dlgCalculatedField:visible").length > 0) {
                e.preventDefault();
                if ($("#" + this._id).find(".calcFormulaDiv:visible").length > 0) {
                    $("#" + this._id).find(".calcFormulaDiv").css("display", "none");
                }
                var focEle = [];
                focEle.push($("#" + this._id).find("#" + this._id + "_calculateFieldName:visible"));
                focEle.push($("#" + this._id).find("#" + this._id + "_calculateFieldList_dropdown:visible"));
                focEle.push($("#" + this._id).find(".calculatorFields:visible"));
                focEle.push($("#" + this._id).find(".editFormula:visible"));
                focEle.push($("#" + this._id).find("#" + this._id + "_fieldCollection_container:visible"));
                if ($("#" + this._id).find("#" + this._id + "_btnInsert:visible:not([aria-disabled='true'])").length > 0) {
                    focEle.push($("#" + this._id).find("#" + this._id + "_btnInsert:visible:not([aria-disabled='true'])"));
                }
                focEle.push($("#" + this._id).find("#" + this._id + "_btnAdd:visible"));
                focEle.push($("#" + this._id).find("#" + this._id + "_btnDelete:visible"));
                focEle.push($("#" + this._id).find("#" + this._id + "_btnOk:visible"));
                focEle.push($("#" + this._id).find("#" + this._id + "_btnCancel:visible"));
                if (!ej.isNullOrUndefined(this._curFocus.field)) {
                    this._curFocus.field.attr("tabindex", "0").removeClass("hoverCell").blur();
                    if (e.which === 9 && e.shiftKey) {
                        this._index.field = this._index.field - 1 < 0 ? focEle.length - 1 : this._index.field - 1;
                    }
                    else if (e.which === 9) {
                        this._index.field = this._index.field + 1 > focEle.length - 1 ? 0 : this._index.field + 1;
                    }
                    this._curFocus.field = focEle[this._index.field].attr("tabindex", "-1");
                }
                else {
                    this._index.field = focEle.length > 5 ? 6 : 0;
                    this._curFocus.field = focEle[this._index.field].attr("tabindex", "-1");
                }
                this._curFocus.field.focus().addClass("hoverCell");
            }
            else if (((e.which === 9 && e.shiftKey) || e.which === 9) && $("#" + this._id).find(".e-dialog:visible").length > 0) {
                e.preventDefault();
                $("#" + this._id).find(".e-dialog .hoverCell").removeClass("hoverCell");
                this._curFocus.filter = null;
                this._index.filter = 0;
                var focEle = $("#" + this._id).find(".dialogOKBtn:visible:not([aria-disabled='true']),.dialogCancelBtn:visible,.e-close:visible,#GroupLabelDrop_wrapper:visible,.filterElementTag:visible,.e-dialog .e-text:visible:first,.filterValues:visible,#filterMeasures_wrapper:visible,#filterOptions_wrapper:visible,#filterValue1:visible,#filterValue2:visible,.searchEditorTreeView");
                if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                    this._curFocus.tree.attr("tabindex", "0").removeClass("hoverCell");
                    if (e.which === 9 && e.shiftKey) {
                        this._index.dialog = this._index.dialog - 1 < 0 ? focEle.length - 1 : this._index.dialog - 1;
                    }
                    else if (e.which === 9) {
                        this._index.dialog = this._index.dialog + 1 > focEle.length - 1 ? 0 : this._index.dialog + 1;
                    }
                    this._curFocus.tree = focEle.eq(this._index.dialog).attr("tabindex", "-1").focus();
                }
                else {
                    if (this.model.dataSource.enableAdvancedFilter) {
                        this._index.dialog = 1;
                    }
                    else {
                        this._index.dialog = 2;
                    }
                    this._curFocus.tree = focEle.eq(this._index.dialog).attr("tabindex", "-1").focus();
                }
                if (this._curFocus.tree.hasClass("filterElementTag")) {
                    this._curFocus.tree.find(".e-list:first:visible").addClass("hoverCell");
                }
                else {
                    this._curFocus.tree.addClass("hoverCell");
                }
            }
            else if (((e.which === 9 && e.shiftKey) || e.which === 9) && !$(".e-dialog:visible").length > 0 && ej.isNullOrUndefined(this._pivotClientObj)) {
                e.preventDefault();
                $("#" + this._id).find(".hoverCell").removeClass("hoverCell");
                if (!ej.isNullOrUndefined(this._schemaData)) {
                    $("#" + this._schemaData._id).find(".hoverCell").removeClass("hoverCell");
                }
                if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                    this._curFocus.grp.mouseleave();
                }
                this._index.field = 0;
                this._index.grp = 1;
                this._index.cell = 1;
                this._index.filter = 0;
                if (this.model.dataSource.enableAdvancedFilter) {
                    this._index.dialog = 0;
                }
                else {
                    this._index.dialog = 1;
                }
                if (!ej.isNullOrUndefined(this._schemaData) && !ej.isNullOrUndefined(this._schemaData._curFocus)) {
                    this._schemaData._curFocus.tree = null;
                    this._schemaData._curFocus.node = null;
                    this._schemaData._curFocus.button = null;
                }
                this._curFocus.field = null;
                this._curFocus.cell = null;
                this._curFocus.grp = null;
                this._curFocus.tree = null;
                this._curFocus.cmenu = null;
                this._curFocus.cformat = null;
                this._curFocus.selection = null;
                var focEle = [];
                if (this.model.enableGroupingBar && $("#" + this._id).find(".pivotButton:visible").first().length > 0) {
                    focEle.push($("#" + this._id).find(".pivotButton:visible").first());
                }
                if ($(".e-pivotpager[targetcontrolid='" + this._id + "']:visible").length > 0 && $("[role='columnheader']:visible:not([p='0,0'])").first().length > 0) {
                    focEle.push($("[role='columnheader']:visible:not([p='0,0'])").first());
                }
                else if ($("#" + this._id).find("[role='columnheader']:visible").first().length > 0) {
                    focEle.push($("[role='columnheader']:not('.grpRow'):visible:first"));
                }
                if (!ej.isNullOrUndefined(this._schemaData) && $("#" + this._schemaData._id).find(".e-text:visible").first().length > 0) {
                    focEle.push($("#" + this._schemaData._id).find(".e-text:visible").first());
                }
                if (!ej.isNullOrUndefined(this._schemaData) && $("#" + this._schemaData._id).find(".pvtBtn:visible").first().length > 0) {
                    focEle.push($("#" + this._schemaData._id).find(".pvtBtn:visible").first());
                }
                if ($(".e-pivotpager[targetcontrolid='" + this._id + "']:visible").length > 0 && $("#Pager_CategCurrentPage:visible").length > 0) {
                    focEle.push($("#Pager_CategCurrentPage:visible"));
                }
                if ($(".e-pivotpager[targetcontrolid='" + this._id + "']:visible").length > 0 && $("#Pager_SeriesCurrentPage:visible").length > 0) {
                    focEle.push($("#Pager_SeriesCurrentPage:visible"));
                }
                if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.attr("tabindex", "0").removeClass("hoverCell");
                    if (this._curFocus.tab.hasClass("e-active")) {
                        this._curFocus.tab.removeClass("e-active");
                    }
                    if (!ej.isNullOrUndefined(this._schemaData)) {
                        $("#" + this._schemaData._id).find(".e-active").removeClass("e-active");
                        $("#" + this._schemaData._id).find(".e-node-hover").removeClass("e-node-hover");
                        $("#" + this._schemaData._id).find(".e-node-focus").removeClass("e-node-focus");
                    }
                    if (this._curFocus.tab.hasClass("e-node-hover")) {
                        this._curFocus.tab.removeClass("e-node-hover");
                    }
                    this._curFocus.tab.mouseleave();
                    if (e.which === 9 && e.shiftKey) {
                        this._index.index = this._index.index - 1 < 0 ? focEle.length - 1 : this._index.index - 1;
                    }
                    else if (e.which === 9) {
                        this._index.index = this._index.index + 1 > focEle.length - 1 ? 0 : this._index.index + 1;
                    }
                    this._curFocus.tab = focEle[this._index.index].attr("tabindex", "-1");
                }
                else {
                    this._curFocus.tab = focEle[0].attr("tabindex", "-1");
                }
                this._curFocus.tab.focus().addClass("hoverCell").mouseover();
                if (this.model.hyperlinkSettings.enableColumnHeaderHyperlink) {
                    this._curFocus.tab.mouseover();
                    this._curFocus.tab.find("span").mouseover();
                }
                $(".e-node-focus").removeClass("e-node-focus");
                e.stopImmediatePropagation();
            }
            if (e.which === 93 && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0 && this.model.enableGroupingBar && (!ej.isNullOrUndefined(this._curFocus.grp) || !ej.isNullOrUndefined(this._curFocus.tab))) {
                e.preventDefault();
                if (document.activeElement.className.startsWith("pivotButton")) {
                    if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                        var position = { x: $(this._curFocus.grp).offset().left + $(this._curFocus.grp).outerWidth(), y: $(this._curFocus.grp).offset().top + $(this._curFocus.grp).outerHeight() };
                        this._curFocus.grp.find("button").trigger({ type: 'mouseup', which: 3, clientX: position.x, clientY: position.y, pageX: position.x, pageY: position.y });
                    }
                    else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        var position = { x: $(this._curFocus.tab).offset().left + $(this._curFocus.tab).outerWidth(), y: $(this._curFocus.tab).offset().top + $(this._curFocus.tab).outerHeight() };
                        this._curFocus.tab.find("button").trigger({ type: 'mouseup', which: 3, clientX: position.x, clientY: position.y, pageX: position.x, pageY: position.y });
                    }
                }
            }
            if (e.which === 13 && this.model.hyperlinkSettings.enableColumnHeaderHyperlink) {
                if (!ej.isNullOrUndefined(this._curFocus.cell)) {
                    this._curFocus.cell.find(".cellValue").click();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.find(".cellValue").click();
                }
            }
            else if (e.which == 13 && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0 && !$(".e-waitpopup-pane:visible").length > 0) {
                if ($("#" + this._id).find(".e-dialog:visible").length > 0) {
                    if ($(e.target).hasClass("memberCurrentPage")) {
                        ej.Pivot.editorTreeNavigatee(e, this);
                        return;
                    }
                    if ($(e.target).hasClass("searchEditorTreeView") && $(e.target).parents(".e-dialog").find(".nextPageDiv").length > 0) {
                        ej.Pivot._searchEditorTreeNodes(e, this);
                        return;
                    }
                }
                if ($("#" + this._id).find(".e-dialog .hoverCell").length > 0 && $("#" + this._id).find(".e-dialog .hoverCell").hasClass("e-text")) {
                    $("#" + this._id).find(".e-dialog .hoverCell").parent().find(".e-chkbox-small").click();
                }
                else if (document.activeElement.className.startsWith("pivotGridTable") || document.activeElement.getAttribute("role") == "rowheader" || document.activeElement.getAttribute("role") == "columnheader") {
                    if (!ej.isNullOrUndefined(this._curFocus.cell)) {
                        if ((this._curFocus.cell).find(".expand,.collapse").length > 0) {
                            this._curFocus.cell.find(".expand,.collapse").click();
                            this._curFocus.cell.removeClass("hoverCell").attr("tabindex", "0");
                            this._curFocus.cell = $("#" + this._id).find("[role='" + this._curFocus.cell.attr("role") + "']:contains('" + this._curFocus.cell.text() + "'):visible").first();
                            this._curFocus.cell.attr("tabindex", "-1").focus().addClass("hoverCell");
                        }
                        else {
                            this._curFocus.cell.click();
                            this._curFocus.cell.removeClass("hoverCell").attr("tabindex", "0");
                            this._curFocus.cell = $("#" + this._id).find("[p='" + this._curFocus.cell.attr("p") + "']");
                            this._curFocus.cell.attr("tabindex", "-1").focus().addClass("hoverCell");
                        }
                        
                    }
                    else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        if ((this._curFocus.tab).find(".expand").length > 0) {
                            this._curFocus.tab.find(".expand").click();
                        }
                        else if ((this._curFocus.tab).find(".collapse").length > 0) {
                            this._curFocus.tab.find(".collapse").click();
                        }
                        this._curFocus.tab = $("#" + this._id).find("[role='" + this._curFocus.tab.attr("role") + "']:contains('" + this._curFocus.tab.text() + "'):visible").first();
                        this._curFocus.tab.attr("tabindex", "-1").focus().addClass("hoverCell");
                    }
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tree) || !ej.isNullOrUndefined(this._curFocus.formula) || (!ej.isNullOrUndefined(this._curFocus.field) && this._curFocus.field.hasClass("editFormula"))) {
                    if ($("#" + this._id).find(".e-dialog .hoverCell:visible").length > 0) {
                        $("#" + this._id).find(".e-dialog .hoverCell:visible").click();
                        this._index.tree = 1;
                    }
                }
                if ($(".e-pivotpager[targetcontrolid='" + this._id + "']:visible").length > 0 && (!ej.isNullOrUndefined(this._curFocus.tab))) {
                    this._curFocus.tab.attr("tabindex", "-1").focus();
                }
            }
            if (e.keyCode == 79 && $("#" + this._id).find(".e-dialog").length > 0) {
                if (e.ctrlKey) {
                    e.preventDefault();
                    $("#" + this._id).find(".dialogOKBtn:visible").click();
                    this._index.field = 0;
                    this._index.filter = 0;
                    if (this.model.dataSource.enableAdvancedFilter) {
                        this._index.dialog = 0;
                    }
                    else {
                        this._index.dialog = 1;
                    }
                    this._curFocus.tree = null;
                    var focEl;
                    if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        this._curFocus.tab.mouseleave().removeClass("hoverCell");
                    }
                    if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                        var tag = this._curFocus.grp.attr("tag");
                        focEl = this._curFocus.grp = $("#" + this._id).find("[tag='" + tag + "']");
                    }
                    else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        var tag = this._curFocus.tab.attr("tag");
                        focEl = this._curFocus.tab = $("#" + this._id).find("[tag='" + tag + "']");
                    }
                    if (!ej.isNullOrUndefined(focEl)) {
                        focEl.mouseover().addClass("hoverCell").focus();
                    }
                }
            }
            if (e.keyCode == 67 && $("#" + this._id).find(".e-dialog:visible").length > 0) {
                if (e.ctrlKey) {
                    e.preventDefault();
                    $("#" + this._id).find(".dialogCancelBtn:visible").click();
                    this._index.field = 0;
                    this._index.filter = 0;
                    if (this.model.dataSource.enableAdvancedFilter) {
                        this._index.dialog = 0;
                    }
                    else {
                        this._index.dialog = 1;
                    }
                    this._curFocus.tree = null;
                    var focEl;
                    if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        this._curFocus.tab.mouseleave().removeClass("hoverCell");
                    }
                    if (!ej.isNullOrUndefined(this._curFocus.grp)) {
                        var tag = this._curFocus.grp.attr("tag");
                        focEl = this._curFocus.grp = $("#" + this._id).find("[tag='" + tag + "']");
                    }
                    else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        var tag = this._curFocus.tab.attr("tag");
                        focEl = this._curFocus.tab = $("#" + this._id).find("[tag='" + tag + "']");
                    }
                    if (!ej.isNullOrUndefined(focEl)) {
                        focEl.mouseover().addClass("hoverCell").focus();
                    }
                }
            }
        },

        _unWireEvents: function () {
            this._off(this.element, "click", ".colheader,.cstot,.cgtot,.calc,.stot,.gtot");
            this._off($(document), 'keydown', this._keyDownPress);
            this._off($(document), 'keyup', this._keyUpPress);
            this._off(this.element, "click", "#preventDiv");
            this._off(this.element, "click", ".expand, .collapse");
            this._off(this.element, "dblclick", ".value, .summary");
            this._off(this.element, "mouseover", ".colheader, .rowheader, .expand, .collapse");
            this._off(this.element, "mouseleave", ".colheader, .rowheader, .expand, .collapse");
            this._off(this.element, "mouseover", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value, .rowheader, .colheader" : ".value, .rowheader, .colheader, .summary", this.addHyperlinkHandler);
            this._off(this.element, "mouseleave", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value, .rowheader, .colheader" : ".value, .rowheader, .colheader, .summary", this.removeHyperlinkHandler);
            this._off(this.element, "click", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value, .rowheader, .colheader" : ".value, .rowheader, .colheader, .summary");
            this._off(this.element, "click", this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ".value .cellValue, .rowheader .cellValue, .colheader .cellValue" : ".value .cellValue, .rowheader .cellValue, .colheader .cellValue, .summary .cellValue");
            this._off(this.element, "mouseover", ".value");
            this._off(this.element, "mouseleave", ".value");
            this._off(this.element, "mousedown touchstart", ".value");
            this._off(this.element, "mouseup touchend", ".value");
            this._off(this.element, "click", ".filter");
            this._off(this.element, "click", ".sorting");
            this._off(this.element, "click", ".removeBtn");
            this._off(this.element, "mouseover", ".pvtBtn");
            this._off(this.element, "mouseleave", ".pvtBtn");
            $(document).off("keyup", this._endCellSelection);
            $(document).off("keydown", this._startCellSelection);
            $(document).off("click", this._clearSelection);
            this._off(this.element, "click", ".calculatedFieldPopup .menuItem ");
            this._off(this.element, "contextmenu", ".values .pivotButton");
            this._off(this.element, "click", ".filter", ej.proxy(this._filterBtnClick, this));
            this._off(this.element, "click", ".sorting", ej.proxy(this._sortBtnClick, this));
            this._off(this.element, "click", ".removeBtn", ej.proxy(this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode? this._removePvtBtn:this._clientRemovePvtBtn, this));
            this._off(this.element, "click", ".ascOrder, .descOrder");
            this._off(this.element, "click", ".clearAllFilters, .clearSorting");
            this._off(this.element, "contextmenu");
            this._off(this.element, "click", ".dialogOkBtn");
            this._off(this.element, "click", ".cellSelect");
            this._off(this.element, "click", ".columnResize");
            this._off(this.element, "click", ".excelLikeLayout");
            this._off(this.element, "click", ".advancedFiltering");
            this._off(this.element, "click", ".toolTip");
            this._off(this.element, "click", ".collapseByDefault");
            this._off(this.element, "click", ".rtl");
            this._off(this.element, "click", ".calculatedField");
            this._off(this.element, "click", ".cellEditing");
            this._off(this.element, "click", ".groupingBar");
            this._off(this.element, "click", ".conditionalFormat");
            this._off(this.element, "click", ".summaryCustomize");
            this._off(this.element, "click", ".summaryTypes");
            this._off(this.element, "click", ".numberFormatting");
            this._off(this.element, "click", ".rowHeaderHyperLink");
            this._off(this.element, "click", ".colHeaderHyperLink");
            this._off(this.element, "click", ".valueCellHyperLink");
            this._off(this.element, "click", ".summaryCellHyperLink");
            this._off(this.element, "click", ".rowFreeze");
            this._off(this.element, "click", ".colFreeze");
            this._off(this.element, "click", ".bothFreeze");
            this._off(this.element, "click", ".excel");
            this._off(this.element, "click", ".word");
            this._off(this.element, "click", ".pdf");
            this._off(this.element, "click", ".csv");
            this._off(this.element, "click", ".frozenHeaders");
            this._off(this.element, "click", ".exporting");
            this._off(this.element, "click", ".layouts");
            this._off(this.element, "click", ".hyperlinkOptions");
            this._off(this.element, "click", ".normalLayout");
            this._off(this.element, "click", ".normalTopSummaryLayout");
            this._off(this.element, "click", ".noSummariesLayout");
            this._off(this.element, "click", ".drillThrough");
            this._off(this.element, "mousedown touchstart", ".value", this._initCellSelection);
            this._off(this.element, "click", ".colheader,.rowheader", this._headerClickCellSelection);
            this._off(this.element, "click", ".nextPage, .prevPage, .firstPage, .lastPage");
            this._off(this.element, "click", ".searchEditorTree");
        },

        _getFieldName: function (cell) {
            if ($(cell).hasClass("colheader") || $(cell).attr("role") == "columnheader") {
                var columnPos = parseInt($(cell).attr('p').split(',')[1]);
                var items = (ej.isNullOrUndefined(this.model.dataSource.data) || this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? (($(this.element).parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? JSON.parse(this._pivotClientObj.getOlapReport()).PivotColumns : JSON.parse(this.getOlapReport()).PivotColumns) : this.model.dataSource.columns;
                var textContent = cell.textContent.replace("expanded", "");
                return columnPos < items.length ? this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? items[columnPos].fieldName : items[columnPos].FieldName : textContent;
            }
            else if ($(cell).hasClass("rowheader") || $(cell).attr("role") == "rowheader") {
                var rowPos = parseInt($(cell).attr('p').split(',')[0]);
                //return ej.isNullOrUndefined(this.model.dataSource.rows[rowPos]) ? JSON.parse(this.getOlapReport()).PivotRows[rowPos].FieldName : this.model.dataSource.rows[rowPos].fieldName;
                return (ej.isNullOrUndefined(this.model.dataSource.data) || this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? ((this.element.parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)?JSON.parse(this._pivotClientObj.getOlapReport()).PivotRows[rowPos].FieldName:JSON.parse(this.getOlapReport()).PivotRows[rowPos].FieldName) : (ej.isNullOrUndefined(this.model.dataSource.rows) ? this.model.dataSource.rows[rowPos].fieldName : "");
            }
        },
        _colResizing: function (e) {
            if (this.model.enableColumnResizing) {
                if (this._expand) {
                    x = e.clientX;
                    y = e.clientY;
                    _hedBound = this.element.find('thead,.pivotGridFrozenTable,.pivotGridColValueTable').first()[0].getBoundingClientRect();
                    if ((_hedBound.left + document.documentElement.scrollLeft + _hedBound.width < x) || (x < _hedBound.left + document.documentElement.scrollLeft)) {
                        this.element.find(".e-reSizeColbg").remove();
                    }
                    else if (this._currentCell != -1) {
                        this.element.find(".e-reSizeColbg").css({ left: x, top: this._tableY });
                    }
                }
                else {
                    if (this.element.find(".e-reSizeColbg").is(":visible"))
                        return;
                    if ($(e.target).attr("role") == "columnheader") {
                        var resCell = this.resCell = e.target;
                        var celLoc = resCell.getBoundingClientRect();
                        x = e.clientX;
                        y = e.clientY;
                        if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                            var tothedwidth = $('.pivotGridFrozenTable,.pivotGridColValueTable').width() + $('.pivotGridFrozenTable,.pivotGridColValueTable').find('tr').offset().left;
                        else
                            var tothedwidth = $(this.element).find('thead').width() + $(this.element).find('thead tr').offset().left;
                        if (((x >= (celLoc.left + document.documentElement.scrollLeft + resCell.offsetWidth - 5)) || (x <= (celLoc.left + 3))) && (x < tothedwidth) && (x >= celLoc.left) && (y <= (celLoc.top + document.documentElement.scrollTop + e.target.offsetHeight))) {
                            if (x > (celLoc.left + 3)) {
                                var tempTarget = $(e.target).find("span");
                                this._currentCell = e.target;
                            }
                            else {
                                var tempTarget = $(e.target).prevAll("th:visible:first").find("span");
                                this._currentCell = $(e.target).prev();
                            }
                            if (tempTarget.length)
                                $(e.target).parents('.pivotGridTable tr').css("cursor", "col-resize");
                        }
                        else {
                            $(e.target).parent('tr').css("cursor", "pointer");
                            this._currentCell = null;
                        }
                    }
                    else {
                        this.element.find("thead,.pivotGridFrozenTable,.pivotGridColValueTable tr").css("cursor", "pointer");
                        this._currentCell = null;
                    }
                }
            }

           },

        _startColResizing: function (e) {
            if ($(e.target).closest("tr").css("cursor") == 'col-resize') {
                x = e.clientX, y = e.clientY;
                this._target = e.target;
                this._orgX = x;
                x += document.documentElement.scrollLeft;
               if (e.button != 2)
               {
                   var hedCel = $(this._target).parent("tr").find("[role='columnheader']");
                   if (this._currentCell != null)
                        var j = $(this._currentCell)[0].getBoundingClientRect();
                   _top = this._tableY = (j == undefined ? 0 : j.top) + document.documentElement.scrollTop;
                   if ($(this._target).closest("tr").css("cursor") == 'col-resize') {
                       var vElement  = $(document.createElement('div'));
                       var _height = this.model.enableGroupingBar ? this.element.height() - this.element.find(".groupingBarPivot").height() : this.element.height();
                       var hRow = this.element.find("thead,.pivotGridFrozenTable,.pivotGridColValueTable").find("tr[role='row']");
                       var curentIndex = ($(this._target).parent("tr")[0]) == undefined ? 0 : $(this._target).parent("tr")[0].rowIndex;
                       for (i = 0; i < curentIndex; i++) {
                           _height = (_height - $(hRow[i]).height());
                       }
                       vElement.addClass("e-reSizeColbg").appendTo(this.element).attr("unselectable", "on").css("visibility", "hidden");
                       vElement.css({ visibility: "visible", height: _height + 'px', cursor: 'col-resize', left: x, top: _top, position: 'fixed' });
                       this._orgX = x;
                       this._orgY = y;
                       this._expand = true;
                   }
                   else {
                       this._currentCell = null;
                   }
               }
            }
        },
        _endColResizing: function (e) {
           if (this._expand) 
                x = e.clientX, y = e.clientY;
           this.element.find(".e-reSizeColbg").remove();
           x += document.documentElement.scrollLeft;
           var _rowobj = $(this._target).parents('thead,.pivotGridFrozenTable,.pivotGridColValueTable');
           if (this._currentCell != null && this._expand) {
                var _colMinWid = 30;
                this._expand = false;
                var _outerCell = this._currentCell;
                var _oldWidth = $(_outerCell)[0].offsetWidth;
                var _extra = x - this._orgX;
           if (parseInt(_extra) + parseInt(_oldWidth) > _colMinWid) {
                  if (_extra != 0){
                    _rowobj.css("cursor", 'default');
                    var colspn = parseInt($(this._currentCell).attr("colspan"));
                    var pos;
                    if (((this.model.frozenHeaderSettings.enableFrozenHeaders || (!this.model.frozenHeaderSettings.enableFrozenColumnHeaders && this.model.frozenHeaderSettings.enableFrozenRowHeaders) || (this.model.frozenHeaderSettings.enableFrozenColumnHeaders && this.model.frozenHeaderSettings.enableFrozenRowHeaders)) && this._JSONRecords[0].CSS == "none"))
                        pos = parseInt($(_outerCell).attr("p").split(",")[0]) - this._JSONRecords[0].ColSpan;
                    else if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
                        pos = parseInt($(_outerCell).attr("i").split(",")[0]);
                    else
                        pos = parseInt($(_outerCell).attr("p").split(",")[0]);
                    var _newExtra = Math.round(_extra / colspn);
                    var colWidth = (this.element.find("col:eq(" + pos + ")").width()) + (_newExtra);
                    this._setWidthColResize(pos, colspn, colWidth);
                    if ($(_outerCell).next().length) {
                        var pos1;
                     var colspn1 = parseInt($(_outerCell).next().attr("colspan"));
                     if (((this.model.frozenHeaderSettings.enableFrozenHeaders || (!this.model.frozenHeaderSettings.enableFrozenColumnHeaders && this.model.frozenHeaderSettings.enableFrozenRowHeaders) || (this.model.frozenHeaderSettings.enableFrozenColumnHeaders && this.model.frozenHeaderSettings.enableFrozenRowHeaders)) && this._JSONRecords[0].CSS == "none"))
                         pos1 = parseInt($(_outerCell).next().attr("p").split(",")[0]) - this._JSONRecords[0].ColSpan;
                     else if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
                         pos1 = parseInt($(_outerCell).next().attr("i").split(",")[0]);
                     else
                         pos1 = parseInt($(_outerCell).next().attr("p").split(",")[0]);
                     var _newExtra1 = Math.round(_extra / colspn1);
                     var colWidth1 = (this.element.find("col:eq(" + pos1 + ")").width()) - (_newExtra1);
                     this._setWidthColResize(pos1, colspn1, colWidth1);
                     this.element.find("tr").css("cursor", "default");
                        }
                    }
                }
            }
               if (this.model.enableGroupingBar)
                   this._createFields(null, $("#" + this._id).find(".pivotGridTable").width(), $("#" + this._id).find(".pivotGridTable th").outerWidth());
               if (this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders)
                   this._refreshScroller();
               if(!this.model.frozenHeaderSettings.enableFrozenColumnHeaders&&this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                {
                    var scroll = this.element.find(".e-scroller").data("ejScroller");
                    scroll.model.enableTouchScroll = false;
                }
                if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders && !this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                {
                    if (this.element.find("#coltable").width() < this.element.find(".valScrollArea").width())
                        this.element.find("#coltable").width(this.element.find(".valScrollArea").width());
                }
            this._target = null;
            this.element.find(".e-reSizeColbg").remove();
            this._expand = false;
            this._currentCell = null;
        },
        _setWidthColResize: function (pos, colspn, colWidth) {
            var colMinWidth = 30;
            var newWidth = colWidth > colMinWidth ? colWidth : colMinWidth;
            for (var lim = pos; lim < (pos + colspn) ; lim++)
                this.element.find("colgroup").find("col:eq(" + lim + ")").outerWidth(newWidth);
         },
        _direction: function (value) {
            if (this.model.enableRTL && value.indexOf('-') > -1)
                return value.split('-').reverse().join('-');
            else
                return value;
        },

        _clearSelection: function (e) {
            if ($(e.target).parents(".pivotGridTable").length == 0)
                $(this.element).find(".selected").removeClass("selected");
        },

        _startCellSelection: function (e) {
            if (this._onholdKey == "Control" || ej.isNullOrUndefined(this._selectedCell)) return;
            e.preventDefault();
            if (this._onholdKey == "") this._onholdKey = e.which.toString() == "16" ? "Shift" : e.which.toString() == "17" ? "Control" : "";
            if (e.which == "40") {  //Down arrow
                var selectedCellPos = $(this._selectedCell).attr('p'), i = parseInt(selectedCellPos.split(',')[1]) + this._selectedCell.rowSpan, newCell;
                while (ej.isNullOrUndefined(newCell) && i < this._rowCount) {
                    var currentCell = $(this.element).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                    if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader")) newCell = currentCell;
                    i++;
                }
                if (!ej.isNullOrUndefined(newCell))
                    this._selectCells("Down", newCell);
            }
            else if (e.which == "38") {  //Up arrow
                var selectedCellPos = $(this._selectedCell).attr('p'), i = parseInt(selectedCellPos.split(',')[1]) - 1, newCell;
                while (ej.isNullOrUndefined(newCell) && i >= 0) {
                    var currentCell = $(this.element).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                    if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader")) newCell = currentCell;
                    i--;
                }
                if (ej.isNullOrUndefined(newCell) && this._onholdKey != "Shift" && ($(this._selectedCell).hasClass("colheader") || $(this._selectedCell).attr('role') == "columnheader")) {
                    for (column = parseInt(selectedCellPos.split(',')[0]) - 1; column > 0 && ej.isNullOrUndefined(newCell) ; column--) {
                        for (row = parseInt(selectedCellPos.split(',')[1] - 1) ; row >= 0 && ej.isNullOrUndefined(newCell) ; row--) {
                            var currentCell = $(this.element).find("[p='" + column + "," + row + "']")[0];
                            if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader")) newCell = currentCell;
                        }
                    }
                }
                if (!ej.isNullOrUndefined(newCell))
                    this._selectCells("Up", newCell);
            }
            else if (e.which == "39") {  //Right arrow
                var selectedCellPos = $(this._selectedCell).attr('p'), i = parseInt(selectedCellPos.split(',')[0]) + this._selectedCell.colSpan, newCell;
                while (ej.isNullOrUndefined(newCell) && i < Math.ceil(this.getJSONRecords().length / this._rowCount)) {
                    var currentCell = $(this.element).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                    if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader")) newCell = currentCell;
                    i++;
                }
                if (!ej.isNullOrUndefined(newCell))
                    this._selectCells("Right", newCell);
            }
            else if (e.which == "37") {  //Left Arrow
                var selectedCellPos = $(this._selectedCell).attr('p'), i = parseInt(selectedCellPos.split(',')[0]) - 1, newCell;
                var newCell = $(this.element).find("[p='" + (parseInt(selectedCellPos.split(',')[0]) - 1) + "," + selectedCellPos.split(',')[1] + "']")[0];
                while (ej.isNullOrUndefined(newCell) && i >= 0) {
                    var currentCell = $(this.element).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                    if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader")) newCell = currentCell;
                    i--;
                }
                if (ej.isNullOrUndefined(newCell) && this._onholdKey != "Shift" && ($(this._selectedCell).hasClass("rowheader") || $(this._selectedCell).attr('role') == "rowheader")) {
                    var j = parseInt(selectedCellPos.split(',')[1]) - 1;
                    while (ej.isNullOrUndefined(newCell) && j > 0) {
                        var currentCell = $(this.element).find("[p='" + parseInt(selectedCellPos.split(',')[0] - 1) + "," + j + "']")[0];
                        if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader")) newCell = currentCell;
                        j--;
                    }
                }
                if (!ej.isNullOrUndefined(newCell))
                    this._selectCells("Left", newCell);
            }
        },

        _endCellSelection: function (e) {
            if (ej.isNullOrUndefined(this._selectedCell)) return;
            e.preventDefault();
            if (e.which == 16 || e.which == 17) {
                this._onholdKey = "";
                var selectedCells = $(this.element).find(".selected");
                if (selectedCells.length > 0) {
                    var selectedCellsInfo = new Array();
                    for (var i = 0; i < selectedCells.length; i++) {
                        var cellPos = $(selectedCells[i]).attr('p');
                        var cellInfo = this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))];
                            cellInfo.Value = $(selectedCells[i]).text().trim();
                            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) cellInfo["Field"] = this._getFieldName(selectedCells[i]);
                        selectedCellsInfo.push(cellInfo);
                    }
                    this._trigger("cellSelection", { JSONRecords: selectedCellsInfo });
                }
            }
        },

        _selectCells: function (key, newCell) {
            if (this._onholdKey == "Shift") {
                if ((key == "Up" || key == "Down") && ($(newCell).hasClass("rowheader") || $(newCell).attr("role") == "rowheader") || (key == "Right" || key == "Left") && ($(newCell).hasClass("colheader") || $(newCell).attr("role") == "columnheader")) {
                    var index = key == "Up" || key == "Down" ? 1 : 0;
                    if ((key == "Up" || key == "Left") && (parseInt($(newCell).attr('p').split(',')[index]) >= parseInt(this._primaryCellPos.split(',')[index])) || (key == "Right" || key == "Down") && (parseInt($(newCell).attr('p').split(',')[index]) <= parseInt(this._primaryCellPos.split(',')[index])))
                        $(this._selectedCell).removeClass("selected");
                    else
                        if ($(newCell).attr('p') != "0,0") $(newCell).addClass("selected");
                }
            }
            else if ($(newCell).attr('p') != "0,0") {
                this.element.find(".selected").removeClass("selected");
                $(newCell).addClass("selected");
                this._primaryCellPos = $(newCell).attr('p');
                var selectedCells = $(this.element).find(".selected");
                if (selectedCells.length > 0) {
                    var selectedCellsInfo = new Array();
                    for (var i = 0; i < selectedCells.length; i++) {
                        var cellPos = $(selectedCells[i]).attr('p');
                        var cellInfo = this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))];
                            cellInfo.Value = $(selectedCells[i]).text().trim();
                            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) cellInfo["Field"] = this._getFieldName(selectedCells[i]);
                        selectedCellsInfo.push(cellInfo);
                    }
                    this._trigger("cellSelection", { JSONRecords: selectedCellsInfo });
                }
            }
            var isValidCell = key == "Up" || key == "Down" ? !$(this._selectedCell).hasClass("colheader") && $(this._selectedCell).attr('role') != "columnheader" : !$(this._selectedCell).hasClass("rowheader") && $(this._selectedCell).attr('role') != "rowheader";
            if ($(newCell).attr('p') != "0,0" && (this._onholdKey != "Shift" || isValidCell)) this._selectedCell = newCell;
        },

        _sortBtnClick: function (args) {
            ej.PivotAnalysis._valueSorting = null;
            if (!ej.isNullOrUndefined(this.model.valueSortSettings)) this.model.valueSortSettings.headerText = "";
            this._isUpdateRequired = true;
            if ($(args.delegateTarget).attr("id") == this._id) {
                $(args.target).toggleClass("descending");
                if (!ej.isNullOrUndefined(this._schemaData)) {
                    this._schemaData.element.find(".pivotButton[tag='" + $(args.target).parent().attr('tag') + "']").find(".sorting").toggleClass("descending");
                }
            }
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                var fieldName = $(args.target).siblings(".pvtBtn").attr("fieldName");
                var reportItem = ej.Pivot.getReportItemByFieldName(fieldName, this.model.dataSource).item;
                reportItem.sortOrder = args.target.className.indexOf("descending") >= 0 ? ej.PivotAnalysis.SortOrder.Descending : ej.PivotAnalysis.SortOrder.Ascending;
                this.refreshControl();
            }
            else {
                var sortValues = this._ascdes.split("##"), count = 0;
                for (var i = 0; i < sortValues.length; i++) {
                    if (sortValues[i] == $($(args.target).siblings(".pvtBtn")).text())
                        count = 1;
                }
                var classNames = args.target.className;
                var isDescending = new RegExp("descending");
                if (isDescending.test(classNames)) {
                    if (count == 0)
                        this._ascdes += ($($(args.target).siblings(".pvtBtn")).text() + "##");
                }
                else {
                    if (count == 1)
                        this._ascdes = (this._ascdes.replace($($(args.target).siblings(".pvtBtn")).text() + "##", ""));
                }
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                var report;
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "sorting", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                var eventArgs = JSON.stringify({ "action": "sorting", "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject });
                this._waitingPopup = this.element.data("ejWaitingPopup");
                if (!ej.isNullOrUndefined(this._waitingPopup))
                    this._waitingPopup.show();
                if (!this.model.enableDeferUpdate)
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.sorting, eventArgs, this._sortingSuccess);
                else
                    this._waitingPopup.hide();
            }
        },

        calculateCellWidths: function () {
            var args = {
                rowHeight: 0,
                columnWidths: []
            }
            var columnCount;
            columnCount = this._excelLikeJSONRecords != null ? this._excelLikeJSONRecords.length / this._excelRowCount : this.getJSONRecords() != null ? this.getJSONRecords().length / this._rowCount : 0;
            var colSpan = 1, isInserted = false;
            if (columnCount > 0) {
                args.rowHeight = this.element.find('tbody tr:visible').length > 0 ? this.element.find('tbody tr:visible').outerHeight() : 0;
                for (var index = 0; index < columnCount && colSpan <= columnCount; index++) {
                    $((this._excelLikeJSONRecords != null ? this.element.find("th[i^=" + index + "]:visible") : this.element.find("th[p^=" + index + "]:visible"))).each(function () {
                        if ($(this).length > 0 && $(this).attr("colspan") == colSpan && ($(this).attr('i') != null ? $(this).attr('i').split(",")[0] == index : $(this).attr('p').split(",")[0] == index)) {
                            args.columnWidths.push($(this).outerWidth());
                            index += colSpan - 1; colSpan = 1; isInserted = true;
                            return false;
                        }
                        else
                            isInserted = false;
                    });
                    if (!isInserted && colSpan != columnCount) {
                        index--;
                        colSpan++;
                    }
                    else
                        colSpan = 1;
                }
            }
            return args;
        },

        _deferUpdate: function () {
            if (!this._isUpdateRequired) return false;
            this._isUpdateRequired = false;
            var report;
            try {
                report = JSON.parse(this.getOlapReport()).Report;
            }
            catch (err) {
                report = this.getOlapReport();
            }
            var filterValues = "";
            for (var i = 0; i < this._filterUpdate.length; i++) {
                filterValues += this._filterUpdate[i] + "%%";
            }
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            var eventArgs = JSON.stringify({ "action": "deferUpdate", "sortedHeaders": this._ascdes, "filterParams": filterValues, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), customObject: serializedCustomObject });
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.deferUpdate, eventArgs, this._renderControlSuccess);
            this._filterUpdate = [];
            this._waitingPopup = this.element.data("ejWaitingPopup");
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.show();
        },

        _dialogBtnClick: function (args) {
            this.element.find(".e-dialog, .clientDialog").hide();
            if (args.model.text.toLowerCase() == "cancel" || !this._isMembersFiltered) {
                ej.Pivot.closePreventPanel(this);
                if (!ej.isNullOrUndefined(this._schemaData))
                    this._schemaData.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
                return false;
            }
            this._isUpdateRequired = true;
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                var selectedNodes = [], unSelectedNodes = [];
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    ej.PivotAnalysis._valueSorting = null;
                    if (this.model.enableMemberEditorPaging) {
                        jQuery.each(this._editorTreeData, function (index, item) { if (item.name != "All" && item.checkedStatus) selectedNodes.push(item.name); });
                        jQuery.each(this._editorTreeData, function (index, item) {
                            if (!item.checkedStatus)
                                unSelectedNodes.push(item.name = item.name == "(blank)" ? "" : item.name);
                        });
                    }
                    else {
                        jQuery.each(this._memberTreeObj.element.find(":input.nodecheckbox:checked"), function (index, item) { if (item.value != "All") selectedNodes.push(item.value); });
                        jQuery.each(this._memberTreeObj.element.find(":input.nodecheckbox:not(:checked)"), function (index, item) {
                            unSelectedNodes.push(item.value = item.value == "(blank)" ? "" : item.value);
                        });
                    }
                    this._pivotFilterItems(selectedNodes, unSelectedNodes);
                    var reportItem = ej.Pivot.getReportItemByFieldName(this._selectedField, this.model.dataSource).item;
                    if (reportItem)
                        reportItem["advancedFilter"] = [];
                    this.model.editCellsInfo = {};
                    this._populatePivotGrid();
                }
                else {
                    this._waitingPopup.show();
                    var currElement = this._selectedField.toLocaleLowerCase(),treeNodeState;
                    this._currentReportItems = $.grep(this._currentReportItems, function (value, i) { if (value["fieldName"] != undefined && value["fieldName"].toLocaleLowerCase() != currElement) return value; });
                    this._memberTreeObj = ej.Pivot.updateTreeView(this);
                    treeNodeState = ej.Pivot.getNodesState(this.model.enableMemberEditorPaging ? this._editorTreeData : this._memberTreeObj);
                    if (this._schemaData != null)
                        this._schemaData._memberTreeObj = this._memberTreeObj;
                    this._currentReportItems.push({ filterItems: this.model.enableMemberEditorPaging ? this._editorTreeData : this._memberTreeObj.dataSource(), fieldName: this._selectedField, pageSettings: this._memberCount });
                    selectedNodes = $.map(treeNodeState.selectedNodes.split("::"), function (element, index) { { return { Id: element.split("||")[0], tag: element.split("||")[1], parentId: element.split("||")[2] } } });//$.map(this._getSelectedNodes().split("::"), function (element, index) { return { Id: element.split("||")[0], tag: element.split("||")[1],parentId:element.split("||")[2] } });
                    if (this.model.enableGroupingBar) {
                        var member = ej.Pivot._getEditorMember(currElement, this, false);
                        this._fieldSelectedMembers[currElement] = $.map(this._fieldMembers[currElement], function (item) { if (!item.checked) return item }).length == 0 ? "All" : ((member != "All" && member != "multiple") ? member : this._getLocalizedLabels("MultipleItems"));
                    }
                    var reportItem = ej.Pivot.getReportItemByFieldName(currElement, this.model.dataSource).item;
                    if (!ej.isNullOrUndefined(reportItem)) {
                        if (treeNodeState.unSelectedNodes != "") {
                            this.model.dataSource = this.clearDrilledItems(this.model.dataSource, { action: "filtering" },this);
                            reportItem["advancedFilter"] = [];
                            reportItem.filterItems = { filterType: "include", values: this._removeSelectedNodes(selectedNodes) };
                            this.element.find(".pivotButton:contains('" + this._selectedField + "') .filter").addClass("filtered")
                            if (this._schemaData != null && this._schemaData._tableTreeObj.element.find("li[tag='" + this._selectedField + "'] .filter").length == 0){
                                this._schemaData._tableTreeObj.element.find("li[tag='" + this._selectedField + "'] div:first .e-text").after(ej.buildTag("span.e-icon", { "display": "none" }).addClass("filter")[0].outerHTML);
                                this._schemaData.element.find(".pvtBtn[fieldname='"+this._selectedField+"']").parent().find(".filter").addClass("filtered");                            
                            }
                        }
                        else {
                            delete reportItem.filterItems;
                            if (this._schemaData != null){
                                this._schemaData._tableTreeObj.element.find("li[tag='" + this._selectedField + "'] .filter").remove();
                                this._schemaData.element.find(".pvtBtn[fieldname='" + this._selectedField + "']").parent().find(".filter").removeClass("filtered");
                            }
                        }
                    }
                    this.getJSONData({action:"filtering"}, this.model.dataSource, this);
                }
            }
            else {
                var unselectedNodes = "", editorNodes = "", enableFilterIndigator;
                editorNodes = this.element.find(".editorTreeView :input.nodecheckbox");
                var uncheckedNodes = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? unselectedNodes = this._getUnSelectedNodes() + "FILTERED" + this._getSelectedNodes(this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this._curFilteredAxis == "Slicers" ? true : false : this._curFilteredAxis == "Filter" ? true : false) : this.model.enableMemberEditorPaging ? this._editorTreeData:this._memberTreeObj.element.find(":input:gt(0).nodecheckbox:not(:checked)"), isFiltered = false,
                filterParams = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? (this.model.enableMemberEditorPaging ? ej.Pivot._getUnSelectedTreeState(this) + "FILTERED" + ej.Pivot._getSelectedTreeState((this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this._curFilteredAxis == "Slicers" ? true : false : this._curFilteredAxis == "Filter" ? true : false), this) : uncheckedNodes) : this._curFilteredAxis + "::" + this._curFilteredText + "::FILTERED";
                var text = this._curFilteredText, textArr = new Array(), obj = {};
                enableFilterIndigator = this.model.enableMemberEditorPaging ? (ej.Pivot._getUnSelectedTreeState(this) != "" ? true : false) : (this._getUnSelectedNodes() != "" ? true : false);
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    if (this.model.enableGroupingBar && ej.isNullOrUndefined(this._fieldMembers[text]))
                        this._fieldMembers[text] = ej.Pivot._getEditorMember(editorNodes, this, false);
                    this._removeFilterTag(this._curFilteredText);
                    for (var i = 0; i < uncheckedNodes.length; i++) {
                        if (!this.model.enableMemberEditorPaging)
                            textArr.push($(uncheckedNodes[i].parentElement).siblings("a").text());
                        else {
                            if (uncheckedNodes[i].checkedStatus == false)
                                textArr.push(uncheckedNodes[i].name);
                        }
                    }
                    obj[text] = textArr;
                    if (ej.isNullOrUndefined(this._tempFilterData))
                        this._tempFilterData = new Array();
                    for (var i = 0; i < this._tempFilterData.length; i++) {
                        if (!ej.isNullOrUndefined(this._tempFilterData[i][text])) {
                            this._tempFilterData[i][text] = textArr;
                            isFiltered = true;
                        }
                    }
                    if (!isFiltered)
                        this._tempFilterData.push(obj);
                    if (this._schemaData != null) {
                        this._schemaData._tempFilterData = this._tempFilterData;
                    }
                    if (ej.isNullOrUndefined(this._curFilteredAxis) || this._curFilteredAxis != "") {
                        for (var i = 0; i < uncheckedNodes.length; i++) {
                            if (!this.model.enableMemberEditorPaging)
                                filterParams += "##" + $(uncheckedNodes[i].parentElement).siblings("a").text();
                            else {
                                if (uncheckedNodes[i].checkedStatus == false)
                                    filterParams += "##" + uncheckedNodes[i].name;
                            }
                        }
                    }
                }
                else {
                    if (this.model.enableGroupingBar) {
                        var member = ej.Pivot._getEditorMember(text.split(":")[1], this, false);
                        this._fieldSelectedMembers[text.split(":")[1]] = $.map(this._fieldMembers[text.split(":")[1]], function (item) { if (!item.checked) return item; }).length == 0 ? "All" : ((member != "All" && member != "multiple") ? member : this._getLocalizedLabels("MultipleItems"));
                    }
                    obj[(this._curFilteredText).split(":")[1]] = filterParams;
                    if (ej.isNullOrUndefined(this._tempFilterData))
                        this._tempFilterData = new Array();
                    for (var i = 0; i < this._tempFilterData.length; i++) {
                        if (!ej.isNullOrUndefined(this._tempFilterData[i][(this._curFilteredText).split(":")[1]])) {
                            this._tempFilterData[i] = obj;
                            isFiltered = true;
                        }
                    }
                    if (!isFiltered)
                        this._tempFilterData.push(obj);
                }
                var filteredBtn = this.model.layout == "excel" ? this.element.find(".schemaFieldTree li:contains('" + this._curFilteredText + "')") : this.element.find("." + this._curFilteredAxis + " .pivotButton:contains(" + this._curFilteredText + ") .filterBtn");
                var filterEle = this._curFilteredText;
                if (this.model.layout == ej.PivotGrid.Layout.Normal && this._schemaData != null) {
                    for (var i = 0; i < this._schemaData.element.find(".fieldTable").find("li").length; i++) {
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                            if (this._curFilteredText.split(":")[1] == $(this._schemaData.element.find(".fieldTable").find("li")[i]).attr("tag").replace(/\]/g, '').replace(/\[/g, '')) {
                                this._schemaData._selectedTreeNode = this._schemaData.element.find(".fieldTable").find("li")[i];
                                filterEle = this._curFilteredText.split(":")[1].split(".")[1];
                                }
                        }
                        else {
                            if (this._curFilteredText == this._schemaData.element.find(".fieldTable").find("li")[i].id) {
                                this._schemaData._selectedTreeNode = this._schemaData.element.find(".fieldTable").find("li")[i];
                                filterEle = this._curFilteredText;
                                }
                        }
                    }
                    if ($(this._schemaData._selectedTreeNode).parents("li:eq(0)").children().children("span").hasClass("hierarchyCDB")) {
                        this._schemaData._selectedTreeNode = $($(this._schemaData._selectedTreeNode).parents("li:eq(0)"));
                    }
                    if (enableFilterIndigator && $(this._schemaData._selectedTreeNode).find(".filter").length <= 0) {
                        var filterSpan = ej.buildTag("span.e-icon", { "display": "none" }).addClass("filter")[0].outerHTML;
                        $($(this._schemaData._selectedTreeNode).find(".e-text")[0]).after(filterSpan);
                        this._schemaData.element.find(".pvtBtn:contains('" + filterEle + "')").parent().find(".filter").addClass("filtered");
                    }
                    else if (!enableFilterIndigator) {
                        $(this._schemaData._selectedTreeNode).find(".filter").remove();
                        this._schemaData.element.find(".pvtBtn:contains('" + filterEle + "')").parent().find(".filter").removeClass("filtered");
                    }
                    if (this._curFilteredAxis == "")
                        return false;
                }
                var report;
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                if (this.model.enableAdvancedFilter)
                {
                    if (this._selectedLevelUniqueName) {
                        if (this._selectedLevelUniqueName.split("].").length == 3) {
                            var filterInfo = this._getAdvancedFilterInfo(this._selectedLevelUniqueName.split("].").slice(0, 2).join(".").replace(/\[/g, ''));
                            if (filterInfo.length > 0)
                                this._removeFilterTag(filterInfo[0].levelUniqueName);
                        }
                    }
                }
                if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: "filtering", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = this.model.customObject != {} && filterParams != "" ? JSON.stringify({ "action": "filtering", "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.layout }) : this.model.customObject != {} ? JSON.stringify({ "action": "filtering", "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.layout }) : filterParams != "" ? JSON.stringify({ "action": "filtering", "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "gridLayout": this.model.layout }) : JSON.stringify({ "action": "filtering" });
                this._waitingPopup = this.element.data("ejWaitingPopup");
                if (!ej.isNullOrUndefined(this._waitingPopup))
                    this._waitingPopup.show();
                if (!ej.isNullOrUndefined(this._schemaData))
                    this._schemaData.element.find(".schemaNoClick").addClass("freeze").width($(this._schemaData.element).width()).height($(this._schemaData.element).height()).css({ "top": $(this._schemaData.element).offset().top, "left": $(this._schemaData.element).offset().left });
                if (!this.model.enableDeferUpdate)
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                else {
                    this._filterUpdate.push(filterParams);
                    $.each(this.element.find(".pivotButton .filter"), function (index, itm) {
                        $(itm).removeClass("filtered")
                    })
                    if (!ej.isNullOrUndefined(this._tempFilterData)) {
                        for (var j = 0; j < this._tempFilterData.length; j++) {
                            for (var key in this._tempFilterData[j]) {
                                if (this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap) {
                                    if (key == text.split(':')[1] && this._tempFilterData[j][text.split(':')[1]].split("FILTERED::")[0].length > 0)
                                        this.element.find(".pivotButton[tag='" + text + "']").find("span.filter").addClass("filtered");
                                }
                                else {
                                    if (key == text && this._tempFilterData[j][text].length > 0)
                                        this.element.find("#pivotButton" + text).next().addClass("filtered");
                                }
                            }
                        }
                    }
                    ej.Pivot.closePreventPanel(this);
                    if (!ej.isNullOrUndefined(this._schemaData))
                        this._schemaData.element.find(".schemaNoClick").removeClass("freeze").removeAttr("style");
                }
            }
            if (!ej.isNullOrUndefined(this._schemaData))
                this._schemaData._refreshPivotButtons();
        },
        _removeSelectedNodes: function (selectedNodes) {
            var selectedElements = $.extend([], selectedNodes);
            for (var i = 0; i < selectedNodes.length; i++) {
                for (var j = 0; j < selectedElements.length; j++) {
                    if (selectedElements[j].Id == selectedNodes[i].parentId) {
                        selectedElements.splice(j, 1);
                    }
                }
            }
            return $.map(selectedElements, function (element, index) { if (element.tag != "" && element.tag != undefined) return element.tag.replace(/\&/g, "&amp;") });
        },
        _pivotFilterItems: function (selectedNodes, unSelectedNodes) {
            var axisItems = this.model.dataSource[this._selectedAxis == "Slicers" ? "filters" : this._selectedAxis.toLowerCase()];
            var members = ej.PivotAnalysis.getMembers(this._selectedField);
            jQuery.each(members, function (itemIndex, itemValue) {
                if (itemValue == null || !itemValue.toString().replace(/^\s+|\s+$/gm, '')) {
                    jQuery.each(unSelectedNodes, function (nodeIndex, nodeValue) {
                        if (!nodeValue.toString().replace(/^\s+|\s+$/gm, ''))
                            unSelectedNodes[nodeIndex] = itemValue;
                    });
                }
            });
            var selectedField = this._selectedField, dialogTitle = this._dialogTitle;
            var items = $.grep(axisItems, function (item) { return item.fieldName == selectedField});
            for (var i = 0; i < items.length; i++)
                items[i].filterItems = selectedNodes.length == members.length ? null : { filterType: ej.PivotAnalysis.FilterType.Exclude, values: unSelectedNodes };
            if (this._schemaData != null) {
                if (unSelectedNodes.length > 0 && this._schemaData.element.find(".schemaFieldTree li[id='" + this._selectedField + "']").find(".filter").length <= 0) {
                    var filterSpan = ej.buildTag("span.e-icon", { "display": "none" }).addClass("filter")[0].outerHTML;
                    this._schemaData.element.find(".schemaFieldTree li[id='" + this._selectedField + "']").find(".e-text").after(filterSpan);
                    this._schemaData.element.find(".pvtBtn[fieldname='" + this._selectedField + "']").parent().find(".filter").addClass("filtered");
                }
                else if (unSelectedNodes.length == 0) {
                    this._schemaData.element.find(".schemaFieldTree li[id='" + this._selectedField + "']").find(".filter").remove();
                    this._schemaData.element.find(".pvtBtn[fieldname='" + this._selectedField + "']").parent().find(".filter").removeClass("filtered");
                }
            }
        },

        _getUnSelectedNodes: function () {
            var treeElement = this.element.find(".editorTreeView")[0];
            var unselectedNodes = "";
            var data = $(treeElement).find(":input.nodecheckbox:not(:checked)");
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                for (var i = 0; i < data.length; i++) {
                    if (!($(data[i].parentElement).find('span:nth-child(1)').attr('class').indexOf("e-chk-act") > -1) && $(data[i].parentElement).attr('aria-checked') != 'mixed') {
                        var parentNode = $(data[i]).parents('li:eq(0)');
                        unselectedNodes += "::" + parentNode[0].id + "||" + $(parentNode).attr('tag');
                    }
                }
            }


            return unselectedNodes;
        },
        _getSelectedNodes: function (isSlicer) {
            if (isSlicer) {
                var treeElement;
                if (this.element.find(".editorTreeView").length > 0)
                    treeElement = this.element.find(".editorTreeView")[0].childNodes[0];
                else if (!ej.isNullOrUndefined(this._schemaData)) {
                    treeElement = this._memberTreeObj.element[0].childNodes[0];
                }
                var selectedNodes = new Array();
                var data = $(treeElement).children();
                for (var i = 0; i < data.length; i++) {
                    var parentNode = data[i];
                    var nodeInfo = { caption: $(parentNode.firstChild).find("a").text(), parentId: parentNode.parentElement.parentElement.className.indexOf("editorTreeView") > -1 ? "None" : $(parentNode).parents()[1].id, id: parentNode.id, checked: $(parentNode).find(':input.nodecheckbox')[0].checked || ($(parentNode).find('span:nth-child(1)').attr('class').indexOf("e-chk-indeter") > -1), expanded: $(parentNode.firstChild).find(".e-minus").length > 0 ? true : false, childNodes: new Array(), tag: $(parentNode).attr('tag') };
                    if ($(parentNode).find("ul:first").children().length > 0) {
                        var liElements = $(parentNode).find("ul:first").children();
                        for (var j = 0; j < liElements.length; j++) {
                            nodeInfo.childNodes.push(this._getNodeInfo(liElements[j]));
                        }
                    }
                    selectedNodes.push(nodeInfo);
                }
                return JSON.stringify(selectedNodes);
            }
            else {
                var treeElement = this.element.find(".editorTreeView")[0];
                var selectedNodes = "";
                var data = $(treeElement).find(':input.nodecheckbox');
                for (var i = 0; i < data.length; i++) {
                    if (data[i].checked || $(data[i].parentElement).attr('aria-checked') == 'mixed') {
                        var parentNode = $(data[i]).parents('li:eq(0)');
                        selectedNodes += "::" + parentNode[0].id + "||" + $(parentNode).attr('tag');
                    }
                }
                return selectedNodes;
            }
        },
        _getNodeInfo: function (node) {
            var childNode = { caption: $(node.firstChild).find("a").text(), parentId: node.parentElement.parentElement.className.indexOf("editorTreeView") > -1 ? "None" : $(node).parents()[1].id, id: node.id, checked: ($(node).find(':input.nodecheckbox')[0].checked || $(node).find('span:nth-child(1)').attr('class').indexOf("e-chk-indeter") > -1), expanded: $(node.firstChild).find(".e-minus").length > 0 ? true : false, childNodes: new Array(), tag: $(node).attr('tag') };
            if ($(node).find("ul:first").children().length > 0) {
                var liElements = $(node).find("ul:first").children();
                for (var i = 0; i < liElements.length; i++) {
                    childNode.childNodes.push(this._getNodeInfo(liElements[i]));
                }
            }
            return childNode;
        },

        _getLevelInfo: function (customArgs, e) {
            var newData = $.map($(e).find("row"), function (obj, index) {
                if ((parseInt($(obj).children("LEVEL_TYPE").text()) != "1" && $(obj).children("HIERARCHY_UNIQUE_NAME").text().toLowerCase() != "[measures]") && ($(obj).find("HIERARCHY_UNIQUE_NAME").text() == customArgs.hierarchy))
                    return { value: $(obj).find("LEVEL_UNIQUE_NAME").text(), text: $(obj).find("LEVEL_CAPTION").text() };
            });
            this.olapCtrlObj._currentReportItems.push({ fieldName: customArgs.hierarchy, dropdownData: newData });
        },

     
        _sortField: function (args, me) {
            //if (!ej.isNullOrUndefined(me))
            //    me.element.find(".e-dialog, .clientDialog").remove();
            //else
                this.element.find(".e-dialog, .clientDialog").remove();
                ej.Pivot.closePreventPanel(this);
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                        var selectedField = this._selectedField;
                        this._ascdes = this._ascdes+selectedField + "##";
                        if ($(args.element).attr("id") != "descOrder")
                            this._ascdes = $.grep(this._ascdes.split("##"), function (i, value) { return i != selectedField }).join("##");
                        this._applySorting();
                        return false
                    }
                    else {
                        var reportItem = ej.Pivot.getReportItemByFieldName(this._selectedField, this.model.dataSource).item;
                        reportItem.sortOrder = $(args.element).attr("id") == "descOrder" ? ej.PivotAnalysis.SortOrder.Descending : ej.PivotAnalysis.SortOrder.Ascending;
                        this.refreshControl();
                    }
                }
                else {
                    if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                        if (this._waitingPopup)
                            this._waitingPopup.show();
                        var report;
                        try { report = JSON.parse(this.getOlapReport()).Report; }
                        catch (err) { report = this.getOlapReport(); }
                        var isElementFound = false;
                        if (this._excelFilterInfo.length > 0) {
                            this._selectedField = this._selectedLevelUniqueName.split("].").splice(0, 2).join("].") + "]";
                            var levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedField;
                            this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                                if ((item.hierarchyUniqueName == hierarchyName || ej.isNullOrUndefined(hierarchyName)||(ej.isNullOrUndefined(item.hierarchyUniqueName)) ) && item.levelUniqueName == levelName) {
                                    isElementFound = true;
                                    if ($(args.element).find(".e-clrSort").length == 0)
                                        item.sortOrder = $(args.element).attr("id");
                                    else
                                        delete item.sortOrder;
                                }
                                return item;
                            });
                        }
                        if(!isElementFound)
                            this._excelFilterInfo.push({ hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, sortOrder: $(args.element).attr("id") });
                        this._selectedField = this._selectedLevelUniqueName.split("].").splice(0, 2).join("].") + "]";
                        var filterParams = this._selectedField + "--" + $(args.element).attr("id");//this._curFilteredAxis + "::" + this._curFilteredText + "## Clear Filter";
                        var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": "labelSorting", "filterParams": filterParams, "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                        return false;
                    }
                    else {
                        ej.olap.base._clearDrilledCellSet();
                        if ($(args.element).attr("id") == "descOrder" || $(args.element).attr("id") == "ascOrder") {
                            var reportItem = ej.Pivot.getReportItemByFieldName(this._selectedField, this.model.dataSource).item;
                            reportItem["sortOrder"] = $(args.element).attr("id") == "descOrder" ? ej.olap.SortOrder.Descending : ej.olap.SortOrder.Ascending;
                            this._waitingPopup.show();
                            ej.olap.base.getJSONData({ action: "sorting" }, this.model.dataSource, this)
                        }
                    }
                }
        },

        _applySorting: function () {
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            var report;
            try {
                report = JSON.parse(this.getOlapReport()).Report;
            }
            catch (err) {
                report = this.getOlapReport();
            }
            if (this.model.beforeServiceInvoke != null)
                this._trigger("beforeServiceInvoke", { action: "sorting", element: this.element, customObject: this.model.customObject });
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            var eventArgs = JSON.stringify({ "action": "sorting", "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject });
            this._waitingPopup = this.element.data("ejWaitingPopup");
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.show();
            if (!this.model.enableDeferUpdate)
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.sorting, eventArgs, this._sortingSuccess);
            else {
                if (!ej.isNullOrUndefined(this._waitingPopup))
                    this._waitingPopup.hide();
            }
        },
        _createDialog: function (title, treeViewData) {
            var isAdvancedFilter = (this.model.enableAdvancedFilter || this.model.dataSource.enableAdvancedFilter),isPivotAdvanceFilter=false ,pos;

            if (isAdvancedFilter) {
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                        this._selectedField = this._curFilteredText;
                        if(this._curFilteredAxis != "Slicers")
                        isPivotAdvanceFilter = this._getAdvancedFilterInfo(this._curFilteredText).length>0;
                        isAdvancedFilter = (!(this.element.find(".pivotButton button[fieldname='" + this._curFilteredText + "']").parents("div:eq(0)").hasClass("drag"))) ? true : false;
                    }
                    else
                        isAdvancedFilter = (isAdvancedFilter && !(this.element.find(".pivotButton[tag='" + this._curFilteredText + "']").parents("div:eq(0)").hasClass("drag"))) ? true : false;
                }
                else
                    isAdvancedFilter = (isAdvancedFilter && ej.Pivot.getReportItemByFieldName(this._selectedField, this.model.dataSource).axis != "filters") ? true : false;
            }
            this.element.find(".e-dialog, .clientDialog").remove();
            var currentHierarchy = this._selectedField, levelInfo,  groupDropDown = "", filterElementTag = "", memberSearchEditor = "";
            var documentHeight = $(document).height();
            if (isAdvancedFilter) {
                var treeviewInfo = JSON.parse(treeViewData);
                treeviewInfo[0].name = "(Select All)"
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap) {
                    levelInfo = this.model.enableMemberEditorPaging ? this._memberPagingAvdData : treeviewInfo.splice(treeviewInfo.length - 1, 1);
                    levelInfo = JSON.parse(levelInfo[0].levels);
                }
                else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap) {
                    levelInfo = $.map(this._currentReportItems, function (obj, index) { if (obj["fieldName"] == currentHierarchy) { return obj["dropdownData"]; } });
                    if (levelInfo.length == 0) {
                        var conStr = this._getConnectionInfo(this.model.dataSource.data);
                        var soapInfo = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>MDSCHEMA_LEVELS</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + this.model.dataSource.catalog + "</CATALOG_NAME><CUBE_NAME>" + this.model.dataSource.cube + "</CUBE_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + this.model.dataSource.catalog + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier> </PropertyList></Properties></Discover></Body></Envelope>";
                        this.doAjaxPost("POST", conStr.url, { XMLA: soapInfo }, this._getLevelInfo, null, { pvtGridObj: this, action: "loadFieldElements", hierarchy: this._selectedField });
                        levelInfo = $.map(this._currentReportItems, function (obj, index) { if (obj["fieldName"] == currentHierarchy) { return obj["dropdownData"]; } });
                    }
                }
                else 
                    levelInfo = [{ value: this._selectedField, text: this._selectedField }]
                
                treeViewData = JSON.stringify(treeviewInfo);
                groupDropDown = ej.buildTag("div.ddlGroupWrap", this._getLocalizedLabels("SelectField") + ej.buildTag("input#GroupLabelDrop.groupLabelDrop").attr("type", "text")[0].outerHTML, {})[0].outerHTML;
                filterElementTag = ej.buildTag("ul.filterElementTag")[0].outerHTML;
                var filterTag = ej.Pivot.createAdvanceFilterTag({ action: "filterTag" }, this)
            }
            memberSearchEditor = ej.buildTag("div.memberSearchEditorDiv", ej.buildTag("input#searchEditorTreeView.searchEditorTreeView").attr("type", "text")[0].outerHTML + (this.model.enableMemberEditorPaging && $.parseJSON(treeViewData).length >= this.model.memberEditorPageSize ? ej.buildTag("span.e-icon searchEditorTree", {})[0].outerHTML : ""), { "padding": isAdvancedFilter ? "5px 5px 0px 9px" : "0px" })[0].outerHTML;
            var dialogContent = ej.buildTag("div#EditorDiv.editorDiv", groupDropDown + ej.buildTag("div", filterElementTag + memberSearchEditor + ej.buildTag("div.memberEditorDiv", ej.buildTag("div#editorTreeView.editorTreeView")[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML + ((!ej.isNullOrUndefined(treeViewData) && this.model.enableMemberEditorPaging && ($.parseJSON(treeViewData).length >= this.model.memberEditorPageSize || this.model.memberEditorPageSize < this._memberPageSettings.endPage)) ? "" : "</br>"),
            dialogFooter = ej.buildTag("div", ej.buildTag("button#OKBtn.dialogOKBtn", this._getLocalizedLabels("OK"))[0].outerHTML + ej.buildTag("button#CancelBtn.dialogCancelBtn", this._getLocalizedLabels("Cancel"))[0].outerHTML, { "float": "right", "margin": "-5px " + (isAdvancedFilter ? " 5px  11px " : "0px 5px ") + "  0px" })[0].outerHTML,
            editorNavPanel = ej.buildTag("div.memberPager", ej.buildTag("div#" + this._id + "_NextpageDiv.nextPageDiv", ej.buildTag("div.e-icon e-media-backward_01 firstPage", {})[0].outerHTML + ej.buildTag("div.e-icon e-arrowhead-left prevPage", {})[0].outerHTML + ej.buildTag("input.memberCurrentPage#memberCurrentPage", {}, { "width": "20px", "height": "10px" })[0].outerHTML + ej.buildTag("span.memberPageCount#memberPageCount")[0].outerHTML + ej.buildTag("div.e-icon e-arrowhead-right nextPage", {})[0].outerHTML + ej.buildTag("div.e-icon e-media-forward_01 lastPage", {})[0].outerHTML)[0].outerHTML)[0].outerHTML,
            ejDialog = ej.buildTag("div#clientDialog.clientDialog", dialogContent + (!ej.isNullOrUndefined(treeViewData) && this.model.enableMemberEditorPaging && ($.parseJSON(treeViewData).length >= this.model.memberEditorPageSize || this.model.memberEditorPageSize < this._memberPageSettings.endPage) ? editorNavPanel : "") + dialogFooter, { "opacity": "1" }).attr("title", title)[0].outerHTML,
            treeViewData = JSON.parse(treeViewData);
            for (var i = 0; i < treeViewData.length; i++)
            if (treeViewData[i].name == null || !treeViewData[i].name.toString().replace(/^\s+|\s+$/gm, '')) { treeViewData[i].name = "(blank)"; treeViewData[i].id = "(blank)"; }
            var selectedData;
            if (this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? !ej.isNullOrUndefined(this._fieldMembers) : !ej.isNullOrUndefined(this._tempFilterData)) {
                if (this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    for (var i = 0; i < Object.keys(this._fieldMembers).length; i++) {
                        if (!ej.isNullOrUndefined(this._fieldMembers[this._curFilteredText.split(':')[1]]))
                            selectedData = $.map(this._fieldMembers[this._curFilteredText.split(':')[1]], function (item) {if(!item.checked) return item.name });
                    }
                }
                else {
                    for (var i = 0; i < this._tempFilterData.length; i++) {
                        if (!ej.isNullOrUndefined(this._tempFilterData[i][title]))
                            selectedData = this._tempFilterData[i][title];
                    }
                }
                if (!ej.isNullOrUndefined(selectedData)) {
                    for (var i = 0; i < selectedData.length; i++) {
                        for (var j = 0; j < treeViewData.length; j++) {
                            if (selectedData[i] == treeViewData[j].name)
                                treeViewData[j].checkedStatus = false;
                        }
                    }
                }
            }
            $(ejDialog).appendTo("#" + this._id);
            if (this.model.enableMemberEditorPaging && (treeViewData.length >= this.model.memberEditorPageSize || this.model.memberEditorPageSize < this._memberPageSettings.endPage)) {
                this.element.find(".prevPage, .firstPage").addClass("pageDisabled");
                this.element.find(".nextPage, .lastPage").addClass("pageEnabled");
                var pageCount = (this._memberCount / this.model.memberEditorPageSize);
                if (pageCount != Math.round(pageCount))
                    pageCount = parseInt(pageCount) + 1;
                this.element.find(".memberPageCount").html("/ " + pageCount);
                this.element.find(".memberCurrentPage").val(this._memberPageSettings.currentMemeberPage);
                this._memberPageSettings.currentMemeberPage > 1 ? this.element.find(".prevPage, .firstPage").removeClass("pageDisabled").addClass("pageEnabled") : this.element.find(".prevPage, .firstPage").removeClass("pageEnabled").addClass("pageDisabled");
                this._memberPageSettings.currentMemeberPage == parseInt(this.element.find(".memberPageCount").text().split("/")[1].trim()) ? this.element.find(".nextPage, .lastPage").removeClass("pageEnabled").addClass("pageDisabled") : this.element.find(".nextPage, .lastPage").removeClass("pageDisabled").addClass("pageEnabled");
                this.element.find(".nextPageDiv .pageDisabled").css("opacity", "0.5");
            }
            this.element.find("#searchEditorTreeView").ejMaskEdit({
                name: "inputbox",
                width: "100%",
                inputMode: ej.InputMode.Text,
                watermarkText: this._getLocalizedLabels("Search") + " " + title,
                maskFormat: "",
                textAlign: this.model.enableRTL ? "right" : "left",
                change: (!this.model.enableMemberEditorPaging || this.element.find(".nextPageDiv").length == 0) ? ej.proxy(ej.Pivot._searchTreeNodes, this) : ej.proxy(function (args) { if (ej.isNullOrUndefined(args.value)) ej.Pivot._searchEditorTreeNodes(args, this); }, this)
            });
            this.element.find(".editorTreeView").ejTreeView({
                showCheckbox: true,
                loadOnDemand: true,
                enableRTL: this.model.enableRTL,
                beforeDelete: function () {
                    return false;
                },
                height: $(".memberEditorDiv").height(),
                fields: { id: "id", text: "name", isChecked: "checkedStatus", hasChild: "hasChildren", dataSource: treeViewData },
            });
            if (isAdvancedFilter) {
                pos = this.element.find("[tag*='" + (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this._selectedField : this._curFilteredText) + "']").offset();
                this.element.find(".filterElementTag").ejMenu({
                    fields: { dataSource: filterTag, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" },
                    menuType: ej.MenuType.NormalMenu,
                    enableRTL: this.model.enableRTL,
                    width: "100%",
                    orientation: ej.Orientation.Vertical,
                    click: ej.proxy(this._filterElementClick, this)
                });
                this.element.find(".groupLabelDrop").ejDropDownList({
                    width: "99%",
                    enableRTL: this.model.enableRTL,
                    dataSource: levelInfo,
                    fields: { id: "id", text: "text", value: "value" },
                    change: ej.proxy(this._groupLabelChange, this),
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                var levelDropTarget = this.element.find('.groupLabelDrop').data("ejDropDownList");
                levelDropTarget.selectItemByText(levelDropTarget.model.dataSource[0].text);
                this.element.find(".memberEditorDiv").addClass("advancedFilter");
            }
            if (isPivotAdvanceFilter)
                this.element.find(".editorTreeView").data("ejTreeView").checkAll();

            var isTreeNodeHasChild = $.grep(treeViewData, function (item, index) { if (item.hasChildren == true) return item; }).length > 0;
            if (!isTreeNodeHasChild)
                this.element.find(".memberEditorDiv").addClass("noChildNode");
            var treeViewElements = this.element.find(".editorTreeView").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                treeViewElements[i].setAttribute("tag", treeViewData[i].tag);
            }
            this.element.find(".dialogOKBtn, .dialogCancelBtn").ejButton({ type: ej.ButtonType.Button, click: ej.proxy(this._dialogBtnClick, this) });
            this._dialogOKBtnObj = this.element.find(".dialogOKBtn").data("ejButton");
            this._memberTreeObj = this.element.find(".editorTreeView").data("ejTreeView");
            var treeViewLi = this.element.find(".editorTreeView li:gt(0)"), firstNode = $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)"),
            uncheckedNodes = $(treeViewLi).find(":input.nodecheckbox:not(:checked)");
            if (uncheckedNodes.length > 0) {
                $(firstNode).removeClass("e-checkmark").addClass("e-stop");
            }
            if (this.model.enableMemberEditorPaging) {
                //this.element.find(".memberPager").css("margin-top", "0px");
                if (!this._isAllMemberChecked) {
                    this._dialogOKBtnObj.disable();
                    this.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                    $(firstNode).removeClass("e-checkmark").removeClass("e-stop").addClass("e-chk-inact");
                }
            }
            this.element.find(".clientDialog").ejDialog({ width: isAdvancedFilter? "auto" : 265, target: "#" + this._id, enableResize: false, enableRTL: this.model.enableRTL, close: ej.proxy(ej.Pivot.closePreventPanel, this) });

            this.element.find("#clientDialog_wrapper").css("top", this.element[0].offsetTop + 20);
            this.element.find(".clientDialog").next(".e-scrollbar").hide();
            if (isAdvancedFilter) {
                this.element.find("#clientDialog_wrapper").addClass("advancedFilterDlg");
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap)
                    this.element.find("#clientDialog_wrapper").addClass("advancedFilterDlgOSM");
                var cntrlWidth = $(".cols-sample-area").position();
                if (cntrlWidth && cntrlWidth.left > 0) {
                    this.element.find("#clientDialog_wrapper").css({ "left": (pos.left + 50 - cntrlWidth.left), top: pos.top });
                }
                else if (!ej.isNullOrUndefined(pos))
                    this.element.find("#clientDialog_wrapper").css({ "left": pos.left+50, top: pos.top });
                this.element.find(".clientDialog").css({"padding":"0px" , "min-width":"265px"}).parents().find(".e-titlebar").remove();
            }
            this._memberTreeObj.model.nodeCheck = ej.proxy(this._nodeCheckChanges, this);
            this._memberTreeObj.model.nodeUncheck = ej.proxy(this._nodeCheckChanges, this);
            if (this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap)
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode)
                    this._memberTreeObj.model.beforeExpand = ej.proxy(this._beforeNodeExpand, this);
                else
                    this._memberTreeObj.model.nodeClick = ej.proxy(this._nodeExpand, this);
            if (this._memberTreeObj.element.find(".e-plus").length == 0) {
                this._memberTreeObj.element.find(".e-item").css("padding", "0px");
            }
            this._isMembersFiltered = false;
            this._unWireEvents();
            this._wireEvents();
            this.element.find(".e-dialog .e-close").attr("title", this._getLocalizedLabels("Close"));
            this.element.find(".e-dialog .e-close").click(function (args) {
                var pivotGrid = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                if (!ej.isNullOrUndefined(pivotGrid._schemaData))
                    pivotGrid._schemaData.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
            });
        },
        _clearSorting: function (args) {
            if ($(args.target).parent().attr("disabled") == "disabled")
                return false;
			ej.Pivot.closePreventPanel(this);
			if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
			    if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
			        this._sortField(args);
			    else {
			        var reportItem = ej.Pivot.getReportItemByFieldName(this._selectedField, this.model.dataSource).item;
			        reportItem.sortOrder = ej.PivotAnalysis.SortOrder.None;
			        this.refreshControl();
			    }
			}
			else {
			    if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
			        if (this._waitingPopup)
			            this._waitingPopup.show();
			        this._selectedField = this._selectedLevelUniqueName.split("].").splice(0, 2).join("].") + "]";

			        if (this._excelFilterInfo.length > 0) {
			            var levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedField;
			            this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
			                if ((item.hierarchyUniqueName == hierarchyName || ej.isNullOrUndefined(hierarchyName)||(ej.isNullOrUndefined(item.hierarchyUniqueName)) ) && item.levelUniqueName == levelName) {
			                        delete item.sortOrder;
			                }
			                return item;
			            });
			        }

			        var report;
			        try { report = JSON.parse(this.getOlapReport()).Report; }
			        catch (err) { report = this.getOlapReport(); }
			        var filterParams = this._selectedField + "--" + $(args.element).attr("id");//this._curFilteredAxis + "::" + this._curFilteredText + "## Clear Filter";
			        var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": "labelSorting", "filterParams": filterParams, "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.layout });
			        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
			        return false;
			    }
			    else {
			        var dataSource = this.model.dataSource;
			        var currElement = this._selectedField.toLowerCase();
			        var reportItem = $.map(dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currElement)) return obj; });
			        if (reportItem.length == 0)
			            reportItem = $.map(dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currElement)) return obj; });
			        if (reportItem.length > 0)
			            delete reportItem[0]["sortOrder"];
			        this.model.dataSource = dataSource;
			        this.element.find(".e-dialog").remove();
			        this.element.find("#preventDiv").remove();
			        if (this._schemaData != null) {
			            this._schemaData.element.find(".e-dialog").remove();
			        }
			        this._waitingPopup.show();
			        this.getJSONData({ action: "clearSorting" }, this.model.dataSource, this);
			    }
			}
        },

        _clearAllFilters: function (args) {
            if ($(args.target).parent().attr("disabled") == "disabled")
                return false;
            ej.Pivot.closePreventPanel(this);
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                var dataSource = this.model.dataSource;
                var currElement = this._selectedField.toLowerCase();
                var reportItem = $.map(dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currElement)) return obj; });
                if (reportItem.length == 0) {
                    reportItem = $.map(dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currElement)) return obj; });
                }
                if (reportItem.length > 0) {
                    var selectedLevelInfo = this.element.find(".groupLabelDrop").length > 0 ? this.element.find(".groupLabelDrop").data("ejDropDownList") : (this._schemaData == null ? null : this._schemaData.element.find(".groupLabelDrop").data("ejDropDownList"));
                    if (selectedLevelInfo != null) {
                        if (reportItem[0]["advancedFilter"])
                            reportItem[0]["advancedFilter"] = $.map(reportItem[0]["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLowerCase() != selectedLevelInfo.getSelectedValue().toLowerCase())) return obj; });
                        if (this._schemaData != null) {
                            if (reportItem[0]["advancedFilter"] && reportItem[0]["advancedFilter"].length == 0)
                                this._schemaData._tableTreeObj.element.find("li[tag ='" + reportItem[0].fileName + "'] div:eq(0) .filter").remove();
                            this._schemaData._tableTreeObj.element.find("li[tag='" + selectedLevelInfo.getSelectedValue() + "'] div:eq(0) .filter").remove();
                        }
                    }
                    else
                        delete reportItem[0].advancedFilter;
                    delete reportItem[0].filterItems;
                }
                this._currentReportItems = $.grep(this._currentReportItems, function (value, i) { if (value["fieldName"] != undefined && value["fieldName"].toLocaleLowerCase() != currElement) return value; });
                this.model.dataSource = dataSource;
                this.element.find(".e-dialog").remove();
                this.element.find("#preventDiv").remove();
            if (this._schemaData != null)
            {
                    this._schemaData._tableTreeObj.element.find("li[tag ='" + this._selectedField + "'] .filter").remove();
                    this._schemaData.element.find(".e-dialog").remove();
                }
                this._waitingPopup.show();
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    ej.PivotAnalysis._valueFilterArray = $.grep(ej.PivotAnalysis._valueFilterArray, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() != currElement)) return obj; });
                    this.refreshControl();
                }
                else
                    this.getJSONData({ action: "advancedfiltering" }, this.model.dataSource, this);
            }
            else {
                var report;
                try { report = JSON.parse(this.getOlapReport()).Report; }
                catch (err) { report = this.getOlapReport();}
                this._removeFilterTag(this._curFilteredText);
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var filterParams = this._curFilteredAxis + "::" + this._curFilteredText + "## Clear Filter";
                    var selectedData = this._curFilteredText;
                    this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                    var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": "labelfiltering", "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                }
                else {
                    if (!ej.isNullOrUndefined(this._tempFilterData) ) {
                        for (var j = 0; j < this._tempFilterData.length; j++) {
                            for (var key in this._tempFilterData[j]) {
                                if (key == this._curFilteredText.split(":")[1] && this._tempFilterData[j][this._curFilteredText.split(":")[1]] != "") {
                                    this._tempFilterData.splice(j, 1);
                                    delete this._fieldMembers[this._curFilteredText.split(":")[1]]
                                }
                            }
                        }
                    }
                    var sortOrder = this._removeFilterTag(this._selectedLevelUniqueName);
                    this._excelFilterInfo.push({ hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, sortOrder: sortOrder });
                    var filterParams = this._selectedLevelUniqueName + "--Clear Filter"; //.split("].").splice(0, 2).join("].") + "]"
                    var selectedData = this._curFilteredText;
                    this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                    var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": "labelfiltering", "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                }
            }
        },

        _removeFilterTag: function (uniqueName) {
            var sortOrder = [];
            var isPivotServerMode = (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
            if (uniqueName.indexOf("].") >= 0 || isPivotServerMode) {
                var removeElement = (uniqueName.split("].").length > 2 || isPivotServerMode) ? "levelUniqueName" : "hierarchyUniqueName";
                if (this._excelFilterInfo.length > 0) {
                        levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;
                    this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                        if (!(item[removeElement] == uniqueName))
                            return item;
                        else
                            sortOrder = item.sortOrder;
                    });
                }
            }
            return sortOrder;
        },
        _groupLabelChange: function (args) {

            var filterMenuObj = this.element.find(".filterElementTag").data("ejMenu");
            filterMenuObj.disableItemByID("labelClearFilter");
            filterMenuObj.disableItemByID("valueClearFilter");
            filterMenuObj.disableItemByID("clearAllFilters");
            filterMenuObj.disableItemByID("clearSorting");
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                var me = this.element.hasClass("e-pivotschemadesigner") ? this.model.pivotControl : this;
                var selectedLevelInfo = this.element.find(".groupLabelDrop").length > 0 ? this.element.find(".groupLabelDrop").data("ejDropDownList") : [];
                var filterData = me._getAdvancedFiltervalue(me._selectedField, selectedLevelInfo.getSelectedValue());               
                var isIncludeFilter = ej.Pivot.getReportItemByFieldName(me._selectedField, me.model.dataSource).item;
                var filterIndicator = ej.buildTag("span.filterState").addClass("e-icon").attr("aria-label", "filter state")[0].outerHTML;
                var activeFilter = ej.buildTag("span.activeFilter").addClass("e-icon")[0].outerHTML;
                var reportItem = ej.Pivot.getReportItemByFieldName(me._selectedField, me.model.dataSource).item, selectedOrder;
                if (reportItem) {
                    if (reportItem["sortOrder"] && reportItem["sortOrder"] != ej.Pivot.SortOrder.None) {
                        selectedOrder = (reportItem && reportItem["sortOrder"] == ej.Pivot.SortOrder.Descending) ? "desc" : "asc";
                        if (ej.isNullOrUndefined(selectedOrder) || selectedOrder == "asc")
                            this.element.find(".clientDialog .ascImage").addClass("selectedSort");
                        else
                            this.element.find(".clientDialog .descImage").addClass("selectedSort");
                        filterMenuObj.enableItemByID("clearSorting");
                    }
                }
                this.element.find(".filterState,.activeFilter").remove();
               var filterElem= this.element.find("#clearAllFilters a").children().clone();
               this.element.find("#clearAllFilters a").text(this._getLocalizedLabels("ClearFilter") + " from \"" + args.text + "\"").append(filterElem);
                if (filterData.length > 0) {
                    if (filterData[0]["advancedFilterType"] == ej.Pivot.AdvancedFilterType.LabelFilter) {
                        this.element.find("#labelFilterBtn a:eq(0)").append(filterIndicator);
                        this.element.find("#labelFilterBtn .clearFilter").css("opacity", "1").removeAttr("disabled");
                        this.element.find("#labelFilterBtn li#" + filterData[0]["labelFilterOperator"] + " a").append(activeFilter);
                        filterMenuObj.enableItemByID("labelClearFilter");
                    }
                    else {
                        this.element.find("#valueFilterBtn a:eq(0)").append(filterIndicator);
                        this.element.find("#valueFilterBtn .clearFilter").css("opacity", "1").removeAttr("disabled");
                        this.element.find("#valueFilterBtn li#" + filterData[0]["valueFilterOperator"] + " a").append(activeFilter);
                        filterMenuObj.enableItemByID("valueClearFilter");
                    }
                    filterMenuObj.enableItemByID("clearAllFilters");
                }
                else if (isIncludeFilter && isIncludeFilter["filterItems"]) {
                    this.element.find(".memberEditorDiv").before(filterIndicator);
                    this.element.find(".filterState").addClass("memberFilter").css("visibility", "hidden");
                    filterMenuObj.enableItemByID("clearAllFilters");
                }
            }
            else {
                var levelName = this._selectedLevelUniqueName = args.selectedValue;
                var filterIndicator = ej.buildTag("span.filterState").addClass("e-icon").attr("aria-label", "filter state")[0].outerHTML;
                var filterInfo = [];
                if (this._excelFilterInfo.length > 0) {
                    var levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;
                    filterInfo = $.map(this._excelFilterInfo, function (item, index) {
                        if ( item.hierarchyUniqueName == hierarchyName && item.levelUniqueName == levelName)
                            return { action: item.action, operator: item.operator, value1: item.value1,sortInfo:item.sortOrder };
                    });
                }
                var filterElem = this.element.find("#clearAllFilters a").children().clone();
                this.element.find("#clearAllFilters a").text(this._getLocalizedLabels("ClearFilter") + " from \"" + args.text + "\"").append(filterElem);
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var sorting = $.grep(this._ascdes.split("##"), function (value, i) { if (value == levelName) return value; });
                    if (sorting.length > 0) {
                        this.element.find(".descImage").addClass("selectedSort");
                        filterMenuObj.enableItemByID("clearSorting");
                    }
                    else
                        this.element.find(".ascImage").addClass("selectedSort");
                }
                else {
                    if (!(filterInfo.length > 0 && (ej.isNullOrUndefined(filterInfo[0]["sortInfo"]) || (!ej.isNullOrUndefined(filterInfo[0]["sortInfo"]) && filterInfo[0]["sortInfo"].length == 0)) || filterInfo.length == 0)) {
                        if (filterInfo[0]["sortInfo"].length > 0) {
                            this.element.find("#" + filterInfo[0]["sortInfo"] + " span:eq(0)").addClass("selectedSort");
                            filterMenuObj.enableItemByID("clearSorting");
                        }
                    }
                }
                this.element.find(".filterElementTag .activeFilter,.filterIndicator").remove();
                if (filterInfo.length > 0 && !ej.isNullOrUndefined(filterInfo[0]["operator"])) {
                    filterMenuObj.enableItemByID("clearAllFilters");
                    var filterTag = "";
                    if ((filterInfo[0].action == "valuefiltering")) {
                        filterTag = "valueFilterBtn";
                        filterMenuObj.enableItemByID("valueClearFilter");
                    }
                    else {
                        filterTag = "labelFilterBtn";
                        filterMenuObj.enableItemByID("labelClearFilter");
                    }
                    this.element.find("#"+filterTag+" a:eq(0)").append(filterIndicator);
                    if (filterInfo[0]["operator"].replace(/ /g, '') == "BottomCount")
                        this.element.find("#" + filterTag + " li#" + filterInfo[0]["operator"].replace(/ /g, '').replace("Bottom", "top") + " a").append($(ej.buildTag("span.activeFilter e-icon")[0].outerHTML));
                    else
                        this.element.find("#" + filterTag + " li#" + filterInfo[0]["operator"].replace(/ /g, '') + " a").append($(ej.buildTag("span.activeFilter e-icon")[0].outerHTML));
                }
                else {
                    if (this._getUnSelectedNodes() != "") {
                        this.element.find(".memberEditorDiv").before("<div class='filterState e-icon' style='margin-top:5px;position:absolute;visibility:hidden' />");
                        filterMenuObj.enableItemByID("clearAllFilters");
                    }
                }
            }
        },

        _getAdvancedFiltervalue: function (hierarchyUqName, levelUqName) {
            var filterItem = ej.Pivot.getReportItemByFieldName(hierarchyUqName, this.model.dataSource).item, levelItem = [];
            if (filterItem && filterItem.advancedFilter)
                levelItem = $.map(filterItem.advancedFilter, function (obj, index) { if (obj.name != undefined && (obj.name.toLocaleLowerCase() == levelUqName.toLowerCase())) return obj; });
            return levelItem;

        },
        _filterElementClick: function (args, me) {
            if (args.ID == "labelFilterBtn" || args.ID == "valueFilterBtn")
                return false;
            var selectedLevelInfo = this.element.find(".groupLabelDrop").length > 0 ? this.element.find(".groupLabelDrop").data("ejDropDownList") : me.element.find(".groupLabelDrop").data("ejDropDownList");
            this._selectedLevelUniqueName = selectedLevelInfo.getSelectedValue();
            if (args.ID == "clearAllFilters" || (args.ID == "valueClearFilter" && this.model.analysisMode == "pivot" && this.model.operationalMode == "servermode"))
            {
                this._clearAllFilters(args);
                if (args.ID == "valueClearFilter" && this.model.analysisMode == "pivot" && this.model.operationalMode == "servermode")
                    return false;
            }
            else if (args.ID == "clearSorting")
                this._clearSorting(args);
            else if (args.ID == "ascOrder" || args.ID == "descOrder")
                this._sortField(args);
            this.element.find(".e-dialog, .filterDialog, #preventDiv").remove();
            if (this._schemaData != null) {
                this._schemaData.element.find(".e-dialog").remove();
            }
            if ($(args.element).parent().hasClass("filterElementTag") || args.ID == "ascOrder" || args.ID == "descOrder" || args.ID == "clearSorting" || args.ID == "clearAllFilters") return;
            var currentHierarchy = this._selectedField;
            if (!ej.isNullOrUndefined(args.element)) 
                this._filterAction = $(args.element).parents("#valueFilterBtn").length==0 ? "labelFiltering" : "valueFiltering";
            else if (!ej.isNullOrUndefined(args.parentId) || (!ej.isNullOrUndefined(args.menuId) && args.menuId != ""))
                this._filterAction = args.parentId == "valueFilterBtn" ? "valueFiltering" : args.menuId == "labelFilterBtn" ? "labelFiltering" : "";
            else
                this._filterAction = $(args.selectedItem).attr("id") == "valueFilterBtn" ? "valueFiltering" : $(args.selectedItem).attr("id") == "labelFilterBtn" ? "labelFiltering" : "";
            if ($.trim(args.text) == $.trim(this._getLocalizedLabels("ClearFilter"))) {
                if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                    this._removeFilterTag(this._selectedLevelUniqueName);
                    var report;
                    try {
                        report = JSON.parse(this.getOlapReport()).Report;
                    }
                    catch (err) {
                        report = this.getOlapReport();
                    }
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        var serializedCustomObject = JSON.stringify(this.model.customObject),
                        eventArgs = JSON.stringify({ "action": this._filterAction.toLowerCase(), "filterParams": this._selectedLevelUniqueName + "--Clear Filter", "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                    }
                    else {
                        var selectedData = this._curFilteredText;
                        this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                        var filterParams = this._curFilteredAxis + "::" + this._curFilteredText + "## Clear Filter";
                        var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": this._filterAction.toLowerCase(), "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                    }
                }
                else {
                    ej.Pivot.closePreventPanel(this);
                    var currentLevelInfo = this._selectedLevelUniqueName.toLowerCase(), filterInfo = [];
                    var reportItem = $.map(this.model.dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currentHierarchy.toLowerCase())) return obj; });
                    if (reportItem.length == 0) {
                        reportItem = $.map(this.model.dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currentHierarchy.toLowerCase())) return obj; });
                    }
                    ej.PivotAnalysis._valueFilterArray = $.grep(ej.PivotAnalysis._valueFilterArray, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() != currentHierarchy.toLowerCase())) return obj; });
                    if (reportItem.length > 0) {

                        if (reportItem[0]["advancedFilter"])
                            filterInfo = $.map(reportItem[0]["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLowerCase() != currentLevelInfo)) return obj; });
                        reportItem[0]["advancedFilter"] = filterInfo;

                        if (this._schemaData) {
                            if (reportItem[0]["advancedFilter"].length == 0)
                                this._schemaData._tableTreeObj.element.find("li[tag ='" + currentHierarchy + "'] div:eq(0) .filter").remove();
                            this._schemaData._tableTreeObj.element.find("li[tag='" + this._selectedLevelUniqueName + "'] div:eq(0) .filter").remove();
                        }
                    }
                    this._waitingPopup.show();
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                        this.refreshControl();
                    else
                        this.getJSONData({ action: "advancedfiltering" }, this.model.dataSource, this);
                    return false;
                }
            }
            else {
                if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                    var filterVal = [], levelName = this._selectedLevelUniqueName;
                    if (this._excelFilterInfo.length > 0 && $(args.element).siblings("li:eq(0)").attr("disable") != "true") {
                        filterVal = $.map(this._excelFilterInfo, function (item, index) {
                            if (item.levelUniqueName == levelName && !ej.isNullOrUndefined(item.operator))
                                return { value1: item.value1, value2: item.value2, operator: item.operator, measure: item.measure };
                        });
                        if (filterVal.length > 0 && (args.ID != (filterVal[0]["operator"].replace(/ /g, ''))))
                            filterVal = [];
                    }
                    ej.Pivot.createAdvanceFilterTag({ action: (this._filterAction == "labelFiltering" ? "labelFilterDlg" : "valueFilterDlg"), selectedArgs: args, filterInfo: filterVal }, this);
                }
                else {
                    var reportItem = $.map(this.model.dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currentHierarchy.toLowerCase())) return obj; });
                    if (reportItem.length == 0) {
                        reportItem = $.map(this.model.dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currentHierarchy.toLowerCase())) return obj; });
                    }
                    var filterVal = [];
                    if (reportItem[0]["advancedFilter"])
                        filterVal = $.map(reportItem[0]["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLowerCase() != currentLevelInfo)) return obj; });
                    ej.Pivot.createAdvanceFilterTag({ action: (this._filterAction == "labelFiltering" ? "labelFilterDlg" : "valueFilterDlg"), selectedArgs: args, filterInfo: filterVal }, this);
                }
            }
        },

        _filterOptionChanged: function (args) {
            var filterValue = this._getAdvancedFiltervalue(this._selectedField, this._selectedLevelUniqueName);
            if (filterValue.length > 0) {
                if (filterValue[0].advancedFilterType == 'label' && args.value.replace(/ /g, '') == filterValue[0].labelFilterOperator)
                    filterValue = filterValue[0].values;
                else if (filterValue[0].advancedFilterType == 'value' && args.value.replace(/ /g, '') == filterValue[0].valueFilterOperator)
                    filterValue = filterValue[0].values;
                else
                    filterValue = [""];
            }
            else
                filterValue = [""];            
            var valuesTd = this.element.find(".filterValuesTd")[0];
            if (args.value.toLowerCase().indexOf("between") >= 0)
                $(valuesTd).html("<input type='text' id='filterValue1' class='filterValues' value='" + filterValue[0] + "' style='display:inline'/> <span>" + this._getLocalizedLabels("and") + "</span> <input type='text' id='filterValue2' value='" + (ej.isNullOrUndefined(filterValue[1]) ? "" : filterValue[1]) + "' class='filterValues' style='display:inline' /> </br>");
            if (args.value.toLowerCase().indexOf("between") < 0)
                $(valuesTd).html("<input type='text' id='filterValue1' class='filterValues' value='" + filterValue[0] + "' style='display:inline'/>");
        },

        _filterElementOkBtnClick: function (args) {
            ej.Pivot.closePreventPanel(this);
            var selectedOperator = this.element.find(".filterOptions")[0].value,
                enteredValue = [this.element.find("#filterValue1")[0].value],
                selectedMeasure, filterInfo = [], currentHierarchy = this._selectedField;

            if ( this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                var filterValue1 = enteredValue[0].value,
                     filterValue2 = (this.element.find("#filterValue2").length > 0 ? this.element.find("#filterValue2")[0].value : ""),
             selectedMeasure, params, levelFilterInfo = [], actionName = this._filterAction.toLowerCase();
                params = this._selectedLevelUniqueName + "--" + selectedOperator + "--" + enteredValue[0];
                if (this.element.find(".filterMeasures").length > 0) {
                    if (this.element.find("#filterValue2").length > 0)
                        params = params + "," + filterValue2;
                    selectedMeasure = this.element.find(".filterMeasures").data("ejDropDownList").model.value;
                    params = params + "--" + selectedMeasure;
                    actionName = "valuefiltering";
                    if (selectedMeasure == null)
                        return;
                }
                var report;
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }

                var serializedCustomObject = JSON.stringify(this.model.customObject),
                    eventArgs = JSON.stringify({ "action": actionName, "filterParams": params, "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                this._waitingPopup = this.element.data("ejWaitingPopup");
                if (!ej.isNullOrUndefined(this._waitingPopup))
                    this._waitingPopup.show();
                if (!ej.isNullOrUndefined(this._schemaData))
                    this._schemaData.element.find(".schemaNoClick").addClass("freeze").width($(this._schemaData.element).width()).height($(this._schemaData.element).height()).css({ "top": $(this._schemaData.element).offset().top, "left": $(this._schemaData.element).offset().left });

                var selectedField = this._curFilteredText.indexOf(":") > -1 ? this._curFilteredText.split(":")[1] : "";
                if (selectedField != "" && this._tempFilterData) {
                    this._tempFilterData = $.grep(this._tempFilterData, function (item) { if (ej.isNullOrUndefined(item[selectedField])) return item; });
                }
                var sortOrder = this._removeFilterTag(this._selectedLevelUniqueName);
                this._excelFilterInfo.push({ action: actionName, hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, operator: selectedOperator, measure: selectedMeasure, value1: enteredValue[0], value2: filterValue2, sortOrder: sortOrder });
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    if (!this.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                }
                else if (this._filterAction == "labelFiltering") {
                    var selectedData = this._curFilteredText;
                    this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                    var filterParams = this._curFilteredAxis + "::" + this._curFilteredText + "##" + selectedOperator + "::" + enteredValue[0];
                    var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": actionName, "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);
                }
                else {
                    var selectedData = this._curFilteredText;
                    this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                    this._measureDDL = this.element.find(".filterMeasures").data("ejDropDownList");
                    selectedMeasure = this._measureDDL.getSelectedValue();
                    var filterParams = this._curFilteredText + "::" + selectedOperator + "::" + selectedMeasure + "::" + enteredValue[0] + "::" + (this.element.find("#filterValue2").length > 0 ? this.element.find("#filterValue2")[0].value : "");
                    var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": actionName, "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filtering, eventArgs, this._filterElementSuccess);

                }
                return false;
            }

            if (this._filterAction == "valueFiltering") {
                this._measureDDL = this.element.find(".filterMeasures").data("ejDropDownList");
                selectedMeasure = this._measureDDL.getSelectedValue();
                if (!(!isNaN(parseFloat(enteredValue[0])) && isFinite(enteredValue[0])) || selectedMeasure == "") { return; };
                this.element.find("#filterValue2")[0] != undefined ? "," + enteredValue.push(this.element.find("#filterValue2")[0].value) : enteredValue;
            }
            this.element.find(".e-dialog").remove();

            if (this._schemaData) {
                var filterIndicator = ej.buildTag("span.filter").addClass("e-icon")[0].outerHTML;
                var selectedLevel   = this._schemaData._tableTreeObj.element.find("li[tag='" + this._selectedLevelUniqueName + "'] div:eq(0)");
                var selectedHierarchy = this._schemaData._tableTreeObj.element.find("li[tag ='" + currentHierarchy + "'] div:eq(0)");
                if(selectedLevel.find(".filter").length==0)
                    selectedLevel.append(filterIndicator);
                if (selectedHierarchy.find(".filter").length === 0)
                    selectedHierarchy.append(filterIndicator);
            }
           
            var currentLevelInfo = this._selectedLevelUniqueName.toLowerCase();
            var reportItem = $.map(this.model.dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLocaleLowerCase() == currentHierarchy.toLowerCase())) return obj; });
            if (reportItem.length == 0) {
                reportItem = $.map(this.model.dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLocaleLowerCase() == currentHierarchy.toLowerCase())) return obj; });
            }

            if (reportItem.length > 0) {
                delete reportItem[0]["filterItems"];
                if (reportItem[0]["advancedFilter"])
                    filterInfo = $.map(reportItem[0]["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLocaleLowerCase() != currentLevelInfo)) return obj; });
                if (this._filterAction.toLowerCase() == "labelfiltering")
                    filterInfo.push({ name: this._selectedLevelUniqueName, labelFilterOperator: selectedOperator.replace(/ /g, ""), advancedFilterType: ej.Pivot.AdvancedFilterType.LabelFilter, values: enteredValue });
                else
                    filterInfo.push({ name: this._selectedLevelUniqueName, valueFilterOperator: selectedOperator.replace(/ /g, ""), advancedFilterType: ej.Pivot.AdvancedFilterType.ValueFilter, values: enteredValue, measure: selectedMeasure });

                this._currentReportItems = $.grep(this._currentReportItems, function (value, i) { if (value["fieldName"] != currentHierarchy) return value; });
                reportItem[0]["advancedFilter"] = filterInfo;
               if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                   this.model.dataSource = this.clearDrilledItems(this.model.dataSource, { action: "filtering" }, this);
            }

            this._waitingPopup.show();

            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                ej.PivotAnalysis._valueSorting = null;
                ej.PivotAnalysis._valueFilterArray = $.grep(ej.PivotAnalysis._valueFilterArray, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() != currentHierarchy.toLowerCase())) return obj; });
                if (this._filterAction == "valueFiltering") {
                    ej.PivotAnalysis._valueFilterArray.push(reportItem[0]);
                }
                this.refreshControl();
            }
            else
                this.getJSONData({ action: "advancedfiltering" }, this.model.dataSource, this);
        },

        _nodeCheckChanges: function (args) {
            this._isMembersFiltered = true;
            
            if ((args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() == "all") && args.type == "nodeUncheck") {
                this._memberTreeObj.model.nodeCheck = "";
                this._memberTreeObj.model.nodeUncheck = "";
                this.element.find(".editorTreeView").ejTreeView("unCheckAll");
                this._memberTreeObj.model.nodeCheck = ej.proxy(this._nodeCheckChanges, this);
                this._memberTreeObj.model.nodeUncheck = ej.proxy(this._nodeCheckChanges, this);
                this._dialogOKBtnObj.disable();
                if (this.model.enableMemberEditorPaging) {
                    this.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                    this._isAllMemberChecked = false;
                    for (var i = 0; i < this._editorTreeData.length; i++)
                        this._editorTreeData[i].checkedStatus = false;
                }
            }
            else if ((args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() == "all") && args.type == "nodeCheck") {
                this._memberTreeObj.model.nodeCheck = "";
                this._memberTreeObj.model.nodeUncheck = "";
                this.element.find(".editorTreeView").ejTreeView("checkAll");
                $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)").removeClass("e-stop");
                this._memberTreeObj.model.nodeCheck = ej.proxy(this._nodeCheckChanges, this);
                this._memberTreeObj.model.nodeUncheck = ej.proxy(this._nodeCheckChanges, this);
                this._dialogOKBtnObj.enable();
                if (this.model.enableMemberEditorPaging) {
                    this.element.find(".dialogOKBtn").removeAttr("disabled");
                    this._isAllMemberChecked = true;
                    for (var i = 0; i < this._editorTreeData.length; i++)
                        this._editorTreeData[i].checkedStatus = true;
                }
            }
            else if ((args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() != "all") && this.model.enableMemberEditorPaging) {
                if (args.type == "nodeUncheck") {
                    this._isMembersFiltered = true;
                    var temp = "";
                    ej.Pivot._memberPageNodeUncheck(args, this);
                    temp = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).where("checkedStatus", "equal", true));
                    var firstNode = $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)");
                    if (!ej.isNullOrUndefined(temp) && temp.length == 0) {
                        this._dialogOKBtnObj.disable();
                        this.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                        this._isAllMemberChecked = false;
                        firstNode.removeClass("e-stop").removeClass("e-checkmark").addClass("e-chk-inact");
                    }
                    else
                        $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)").removeClass("e-stop").addClass("e-checkmark");
                }
                else if (args.type == "nodeCheck") {
                    this._isMembersFiltered = true;
                    ej.Pivot._memberPageNodeCheck(args, this);
                    this.element.find(".dialogOKBtn").data("ejButton").enable();
                    this.element.find(".dialogOKBtn").removeAttr("disabled");
                    this._isAllMemberChecked = true;
                    $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)").removeClass("e-stop").addClass("e-checkmark");
                }
            }
            else if (args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() != "all") {
                var uncheckedNodes = this._memberTreeObj.element.find(":input:gt(0).nodecheckbox:not(:checked)"),
                firstNode = $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)");
                if (uncheckedNodes.length == 0 || (uncheckedNodes.length == 1 && uncheckedNodes[0].id[uncheckedNodes[0].id.length - 1] == 0)) {
                    $(firstNode).parent().removeClass("e-chk-inact").removeClass("e-chk-ind").addClass("e-chk-act");
                    firstNode.removeClass("e-stop").addClass("e-checkmark");
                }
                else if (args.type == "nodeCheck" && uncheckedNodes.length == 1 && uncheckedNodes[0].id[uncheckedNodes[0].id.length - 1] == 0)
                    firstNode.removeClass("e-stop").addClass("e-checkmark");
                else if (uncheckedNodes.length > 0)
                    firstNode.removeClass("e-checkmark").addClass("e-stop");
                this._dialogOKBtnObj.enable();
                if (args.type == "nodeUncheck" && uncheckedNodes.length + 1 == this._memberTreeObj.element.find("li").length) {
                    firstNode.removeClass("e-checkmark").removeClass("e-stop");
                    this._dialogOKBtnObj.disable();
                }
            }
        },

        _fetchMemberSuccess: function (msg) {
            if (msg[0] != undefined && msg.length > 0) {
                this._currentMembers = msg[0].Value;
                if (msg[1] != null && msg[1] != undefined)
                    this.model.customObject = msg[1].Value;
            }
            else if (msg.d != undefined && msg.d.length > 0) {
                this._currentMembers = msg.d[0].Value;
                if (msg.d[1] != null && msg.d[1] != undefined)
                    this.model.customObject = msg.d[1].Value;
            }
            else if (msg != undefined && msg.length > 0) {
                this._currentMembers = msg.EditorTreeInfo;
                if (msg != null && msg != undefined)
                    this.model.customObject = msg.customObject;
            }
            else if (msg != undefined) {
                this._currentMembers = msg.EditorTreeInfo;
            }
            this._createDialog(this._dialogHead, this._currentMembers);
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "fetchMembers", element: this.element, customObject: this.model.customObject });
            if (this.model.dataSource.enableAdvancedFilter) {
                this.element.find(".e-dialog #GroupLabelDrop_wrapper:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
            }
            else if (!ej.isNullOrUndefined(this.element.find(".e-dialog .e-text:visible").first())) {
                this.element.find(".e-dialog .e-text:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
            }
            this._waitingPopup.hide();
        },

        _filterElementSuccess: function (report) {
            if (report[0] != undefined) {
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
            }
            else {
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "filtering", element: this.element, customObject: this.model.customObject });
            this._renderControlSuccess(report);
        },

        _sortingSuccess: function (msg) {
            if (msg[0] != undefined) {
                if (msg[2] != undefined && msg.length > 0)
                    this.model.customObject = msg[2].Value;
            }
            else if (msg.d != undefined && msg.d.length > 0) {
                if (msg.d[2] != null && msg.d[2] != undefined)
                    this.model.customObject = msg.d[2].Value;
            }
            else if (msg != undefined && msg.length > 0) {
                if (msg.customObject != null && msg.customObject != undefined)
                    this.model.customObject = msg.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "sorting", element: this.element, customObject: this.model.customObject });
            this._renderControlSuccess(msg)
        },
        _nodeExpand: function (args) {
            var selectedItem = (args.event.originalEvent != undefined && args.event.originalEvent.target != undefined) ? args.event.originalEvent.target : args.event.target; var tagInfo, dimenName = "";
            var childCount = $(selectedItem).parents("li").first().children().find("li").length;
            if (!ej.isNullOrUndefined(this) && this.model.enableMemberEditorPaging && ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", args.id)).length > 0 && selectedItem != undefined && selectedItem.className != undefined && selectedItem.className != "" && selectedItem.className.indexOf("e-plus") > -1 && childCount == 0) {
                args.isChildLoaded = true;
                ej.Pivot.closePreventPanel(this);
                this.pNode = selectedItem;
                this._fetchChildNodeSuccess({ ChildNodes: JSON.stringify(ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", args.id))), customObject: this.model.customObject });
                return;
            }
            if (selectedItem != undefined && selectedItem.className != undefined && selectedItem.className != "" && selectedItem.className.indexOf("e-plus") > -1 && childCount == 0) {
                $(selectedItem).removeClass("e-plus").addClass("e-load");
                var checkedState = $(selectedItem).parent().find("input.e-checkbox").prop("checked"), report;
                var tagInfo = $(selectedItem).parents("li").first().attr("tag");
                this.pNode = selectedItem;
                try {
                    report = JSON.parse(this.model.pivotControl != undefined ? this.model.pivotControl.getOlapReport() : this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.model.pivotControl != undefined ? this.model.pivotControl.getOlapReport() : this.getOlapReport();
                }
                var pivotButtons = this.element.find(".pivotButton"), parentTag, tagName;
                for (var bt = 0; bt < pivotButtons.length > 0; bt++) {
                    if ($(pivotButtons[bt]).attr("tag").indexOf(!ej.isNullOrUndefined(this._curFilteredText) ? this._curFilteredText : !ej.isNullOrUndefined(this._schemaData) ? this._schemaData._curFilteredText : "") > -1 && $(pivotButtons[bt]).attr("tag").split(":")[1].length == (!ej.isNullOrUndefined(this._curFilteredText) ? this._curFilteredText.length : !ej.isNullOrUndefined(this._schemaData)? this._schemaData._curFilteredText.length : 0))
                        dimenName = $(pivotButtons[bt]).attr("tag");
                    else if ($(pivotButtons[bt]).attr("tag").indexOf(!ej.isNullOrUndefined(this._curFilteredText) ? this._curFilteredText : !ej.isNullOrUndefined(this._schemaData) ? this._schemaData._curFilteredText : "") > -1)
                        tagName = $(pivotButtons[bt]).attr("tag");
                }
                dimenName = dimenName == "" ? !ej.isNullOrUndefined(tagName) ? tagName.split(":")[1] : !ej.isNullOrUndefined(this._curFilteredText) ? this._curFilteredText : this._schemaData._curFilteredText : dimenName.split(":")[1];
                if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: "memberExpanded", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.memberExpand, JSON.stringify({
                    "action": "memberExpanded", "checkedStatus": checkedState, "parentNode": $(selectedItem).parents("li")[0].id, "tag": tagInfo, "cubeName": JSON.parse(this._olapReport).CurrentCube + "##" + dimenName, "currentReport": report, "customObject": serializedCustomObject
                }), this._fetchChildNodeSuccess);
            }
        },

        _fetchChildNodeSuccess: function (data) {
            var newDataSource; var parentNode;
            if (data.length > 1 && data[0] != undefined) {
                newDataSource = JSON.parse(data[0].Value);
                if (data[1] != null && data[1] != undefined)
                    this.model.customObject = data[1].Value;
            }
            else if (data.d != undefined) {
                newDataSource = JSON.parse(data.d[0].Value);
                if (data.d[1] != null && data.d[1] != undefined)
                    this.model.customObject = data.d[1].Value;
            }
            else {
                newDataSource = JSON.parse(data.ChildNodes);
                if (data.customObject != null && data.customObject != undefined)
                    this.model.customObject = data.customObject;
            }
            var mapper = { id: "id", parentId: "pid", hasChild: "hasChildren", text: "name", isChecked: "checkedStatus" };
            if ($(this.pNode).parents("li").length > 1)
                parentNode = $(this.pNode).parents("li").first();
            else
                parentNode = $(this.pNode).parents("li");
            $($(parentNode).find('input.nodecheckbox')[0]).ejCheckBox({ checked: false })
            if (!ej.isNullOrUndefined(this._memberTreeObj) && (this._editorFlag))
                this._memberTreeObj._createSubNodesWhenLoadOnDemand(newDataSource, this.pNode, mapper);
            else if (!ej.isNullOrUndefined(this._schemaData._memberTreeObj))
                this._schemaData._memberTreeObj._createSubNodesWhenLoadOnDemand(newDataSource, this.pNode, mapper);
            if (newDataSource.length > 0 && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.enableMemberEditorPaging && !ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", newDataSource[0].pid)).length > 0)
                $.merge(this._editorTreeData, $.extend(true, [], newDataSource));
            $.each($(parentNode).children().find("li"), function (index, value) {
                value.setAttribute("tag", newDataSource[index].tag);
            });
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "memberExpanded", element: this.element, customObject: this.model.customObject });
            // this._memberTreeObj._expandCollapseAction(this.pNode);
            if (!ej.isNullOrUndefined(this._schemaData))
                this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
        },

        _beforeNodeExpand: function (args) {
            ej.Pivot.getChildNodes(args, this._selectedField, this._currentReportItems, this.model.dataSource, this);
        },
        _generateAllMember: function(customArgs,args){
            this.olapCtrlObj._allMember = $($(args).find("Axis:eq(0) Tuple:eq(0)").children().children()[1]).text();
        },
        _generateMembers: function (customArgs,args) {
            var data = $(args).find("Axis:eq(0) Tuple"),    treeViewData = [],treeNodeInfo={};
            treeViewData.push({ id: "All", name: "All", checkedStatus: true,tag:"" });
            for(var i=0;i<data.length;i++){
                var memberUqName=$($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[0]).text(), 
                    memberName=$($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[1]).text();
                treeNodeInfo = { hasChildren:  $(data[i]).find("CHILDREN_CARDINALITY").text()!="0", checkedStatus:true, id: memberUqName.replace(/\]*\]/g, '-').replace(/\[*\[/g, '-'), name: memberName,    tag: memberUqName };
                treeViewData.push(treeNodeInfo);
            }
            if (!ej.isNullOrUndefined(this.olapCtrlObj)) {
                this.olapCtrlObj._waitingPopup.hide();
                if (this.olapCtrlObj.model.enableMemberEditorPaging) {
                    this.olapCtrlObj._editorTreeData = treeViewData;
                    this.olapCtrlObj._editorTreeData.splice(0, 1);
                    this.olapCtrlObj._memberCount = ej.DataManager(this.olapCtrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
                    this.olapCtrlObj._currentReportItems.push({ filterItems: this.olapCtrlObj._editorTreeData, fieldName: this.olapCtrlObj._selectedField, dataSrc: this.olapCtrlObj.model.dataSource, pageSettings: this.olapCtrlObj._memberCount });
                    var treeData = ej.DataManager(this.olapCtrlObj._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this.olapCtrlObj._memberPageSettings.currentMemeberPage, this.olapCtrlObj.model.memberEditorPageSize));
                    treeData.splice(0, 0, { id: "All", name: "All", checkedStatus: this.olapCtrlObj._isAllMemberChecked, tag: "" })
                    this.olapCtrlObj._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(treeData) });
                }
                else
                    this.olapCtrlObj._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(treeViewData) });
            }

        },
        _filterBtnClick: function (args) {
            this._editorFlag = true;
            ej.Pivot.openPreventPanel(this);
            this._isAllMemberChecked = true;
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                if (this.model.enableMemberEditorPaging) {
                    this._memberPageSettings.endPage = this.model.memberEditorPageSize;
                    this._memberPageSettings.startPage = 0;
                    this._memberPageSettings.currentMemeberPage = 1;
                }
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    var currentHierarchy = this._selectedField = $(args.currentTarget.parentNode).attr("tag").split(":")[1], filteredData = [], reportItem = {}, pageSettings;
                    this._dialogHead = $(args.target).siblings(".pvtBtn").attr("fieldCaption");
                    filteredData = $.map(this._currentReportItems, function (obj, index) {
                        if (obj["fieldName"] == currentHierarchy) {
                            pageSettings = obj.pageSettings;
                            return obj["filterItems"];
                        }
                    });
                    if (this.model.enableMemberEditorPaging && pageSettings) {
                        if (pageSettings)
                            this._memberCount = pageSettings;
                    }
                    if (filteredData.length > 0) {
                        if (this.model.enableMemberEditorPaging) {
                            this._editorTreeData = filteredData;
                            this._memberCount = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
                            filteredData = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.model.memberEditorPageSize));;
                            filteredData.splice(0, 0, { id: "All", name: "All", checkedStatus: this._isAllMemberChecked, tag: "" })
                        }
                        this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(filteredData) });
                    }
                    else {
                        this._waitingPopup.show();
                        ej.olap._mdxParser.getMembers(this.model.dataSource, currentHierarchy, this);
                    }
                }
                else {
                    this._selectedField = $(args.target).siblings(".pvtBtn").attr("fieldName");
                    this._dialogHead = $(args.target).siblings(".pvtBtn").attr("fieldCaption");
                    this._selectedAxis = $(args.target).siblings(".pvtBtn").attr("axis");                   
                    var treeViewData = this._getTreeViewData(this._selectedField, this._selectedAxis);
                    if (this.model.enableMemberEditorPaging) {
                        var filteredData = treeViewData;
                        filteredData.splice(0, 1);
                        this._editorTreeData = filteredData;
                        this._memberCount = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
                        filteredData = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.model.memberEditorPageSize));;
                        filteredData.splice(0, 0, { id: "All", name: "All", checkedStatus: this._isAllMemberChecked, tag: "" })
                        this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(filteredData) });
                    }
                    else
                        this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(treeViewData) });
                }
            }
            else {
                this._curFilteredAxis = args.target.parentElement.attributes.tag.value.split(":")[0];
                this._curFilteredText = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? args.target.parentElement.attributes.tag.value : $($(args.target).siblings()[1]).attr("fieldname");
                this._dialogTitle = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? args.target.parentElement.attributes.tag.value : $($(args.target).siblings()[1]).attr("fieldname");
                this._dialogHead = $($(args.target).siblings("button")).attr("fieldCaption");
                var report;
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                this._waitingPopup.show();
                if (!ej.isNullOrUndefined(this._schemaData))
                    this._schemaData.element.find(".schemaNoClick").addClass("freeze").width($(this._schemaData.element).width()).height($(this._schemaData.element).height()).css({ "top": $(this._schemaData.element).offset().top, "left": $(this._schemaData.element).offset().left });
                if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: "fetchMembers", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                var eventArgs = JSON.stringify({ "action": "fetchMembers", "headerTag": (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.enableAdvancedFilter) ? this._dialogTitle + "##" + this.model.enableAdvancedFilter : (this._dialogTitle), "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject });
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.fetchMembers, eventArgs, this.model.enableMemberEditorPaging ? ej.Pivot._fetchMemberPageSuccess : this._fetchMemberSuccess);
            }
        },

        _getTreeViewData: function (fieldName) {
            var item = ej.Pivot.getReportItemByFieldName(fieldName, this.model.dataSource).item;
            var members = ej.PivotAnalysis.getMembers(fieldName);
            var treeViewData = [{ id: "All", name: "All", checkedStatus: true }];
            if (item.filterItems != null && item.filterItems != undefined)
                for (var i = 0; i < members.length; i++) treeViewData.push({ id: members[i], name: members[i], checkedStatus: item.filterItems.filterType == ej.PivotAnalysis.FilterType.Include ? $.inArray(members[i] != null ? members[i].toString() : members[i], item.filterItems.values) >= 0 : $.inArray(members[i] != null ? members[i].toString() : members[i], item.filterItems.values) < 0 });
            else
                for (var i = 0; i < members.length; i++) treeViewData.push({ id: members[i], name: members[i], checkedStatus: true });
            return treeViewData;
        },

        _applyToolTip: function (e) {
            if (this.model.enableToolTip) {
                var toolTipInfo; var rowValue; var cellPos; var columnValue = "", valueCell = "";
                var targetCell = $(e.target).hasClass("cellValue") ? e.target.parentElement : e.target;
                if ($(targetCell).find("input").length == 0 && !$(targetCell).hasClass("curInput") && !ej.isNullOrUndefined($(targetCell).attr("role"))) {
                    cellPos = this.element.find(".summary[role!='gridcell'][p$='," + $(targetCell).attr('p').split(',')[1] + "'] , .rowheader[role!='gridcell'][p$='," + $(targetCell).attr('p').split(',')[1] + "']").last().attr("p")
                    if (cellPos == null)
                        cellPos = $(targetCell).parent("tr").find(".summary,.rowheader").attr("p");
                    if (cellPos != null) {
                        if ((cellPos[0] == 0) && ((parseInt(cellPos.split(",")[0])) != null)) {
                            if (cellPos == this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))].Index) {
                                rowValue = this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))].Value;
                            }
                        }
                        else
                            while (cellPos[0] >= 0) {
                                if (cellPos == this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))].Index) {
                                    toolTipInfo = this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))].Value;
                                    cellPos = parseInt(cellPos.split(",")[0]) - 1 + "," + parseInt(cellPos.split(",")[1]);
                                }
                                if (rowValue)
                                    rowValue = toolTipInfo != "" ? toolTipInfo + "-" + rowValue : rowValue;
                                else
                                    rowValue = toolTipInfo;
                            }
                    }
                    var isFrozenEnabled = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders
                    var columnHeaderCount = this.element.find(isFrozenEnabled ? ".pivotGridFrozenTable " : "" + 'tr:has(".colheader")').length - 1;
                    var currentCellPos = $(targetCell).attr("p");
                    if ((currentCellPos != undefined) && (currentCellPos == this.getJSONRecords()[parseInt((parseInt(currentCellPos.split(",")[0]) * this._rowCount) + parseInt(currentCellPos.split(",")[1]))].Index)) {
                        var colPos = parseInt(currentCellPos.split(",")[0]);
                    }
                    for (var i = 0; i <= columnHeaderCount; i++) {
                        var columnHeaderPos = colPos + "," + i;
                        if (colPos != null)
                            if (columnHeaderPos == this.getJSONRecords()[parseInt((parseInt(columnHeaderPos.split(",")[0]) * this._rowCount) + parseInt(columnHeaderPos.split(",")[1]))].Index) {
                                toolTipInfo = this.getJSONRecords()[parseInt((parseInt(columnHeaderPos.split(",")[0]) * this._rowCount) + parseInt(columnHeaderPos.split(",")[1]))].Value;
                                if (columnValue == "")
                                    columnValue = toolTipInfo;
                                else if (toolTipInfo != "")
                                    columnValue = columnValue + "-" + toolTipInfo;
                            }
                    }
                    $("#" + this._id + "_gridTooltip").remove();
                    this.element.find("span#celval").remove();
                    var tdPos = $(targetCell).position();
                    if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders) {
                        var scrollElement = this.element.find(".e-scroller").data("ejScroller");
                        if ((this.model.frozenHeaderSettings.enableFrozenColumnHeaders && !this.model.frozenHeaderSettings.enableFrozenRowHeaders) || ((!this.model.frozenHeaderSettings.enableFrozenColumnHeaders && this.model.frozenHeaderSettings.enableFrozenRowHeaders))) {
                            tdPos.left = (tdPos.left + this.element.find(".rowhead").width()) - scrollElement.model.scrollLeft;
                            tdPos.top = tdPos.top - scrollElement.model.scrollTop;
                        }
                        else if (this.model.frozenHeaderSettings.enableFrozenHeaders) {
                            tdPos.top = tdPos.top + (this.element.find(".e-vscrollbar").length > 0 ? this.element.find(".valueCell").height() - 80 : 0);
                            tdPos.left = tdPos.left + ((this.element.find(".e-vscrollbar").length > 0 && this.element.find(".e-hscrollbar").length > 0 || (this.element.find(".e-vscrollbar").length == 0 && this.element.find(".e-hscrollbar").length == 0)) ? this.element.find(".rowhead").width() : 0);
                        }
                    }
                    $("#" + this._id).append("<div id=\"" + this._id + "_gridTooltip\" class=\"pGridTooltip\" role='tooltip'></div>");
                    $(targetCell).append("<span id='celval' style='display:none'>" + "row- " + rowValue + ": column- " + columnValue + "</span>");
                    $(targetCell).find("span.cellValue").attr("aria-describedby", "span#celval");
                    var tooltipval = $(targetCell).find("span.cellValue:not('#celval')").text();
                    if (this.model.enableRTL) {
                        $("#" + this._id + "_gridTooltip").append("<p id=\"value\" class=\"tooltipText\">" + (tooltipval ? tooltipval : this._getLocalizedLabels("NoValue")) + ":" + this._getLocalizedLabels("ToolTipValue") + "</p>");
                        $("#" + this._id + "_gridTooltip").append("<p id=\"row\" class=\"tooltipText\">" + ((rowValue == undefined || this._rowCount == 1) ? this._getLocalizedLabels("NoValue") : this._direction(rowValue)) + ":" + this._getLocalizedLabels("ToolTipRow") + "</p>");
                        $("#" + this._id + "_gridTooltip").append("<p id=\"column\" class=\"tooltipText\">" + ((columnValue == undefined || columnValue == "") ? this._getLocalizedLabels("NoValue") : this._direction(columnValue)) + ":" + this._getLocalizedLabels("ToolTipColumn") + "</p>");
                    }
                    else {
                        $("#" + this._id + "_gridTooltip").append("<p id=\"value\" class=\"tooltipText\">" + this._getLocalizedLabels("ToolTipValue") + ": " + (tooltipval ? tooltipval : this._getLocalizedLabels("NoValue")) + "</p>");
                        $("#" + this._id + "_gridTooltip").append("<p id=\"row\" class=\"tooltipText\">" + this._getLocalizedLabels("ToolTipRow") + ": " + ((rowValue == undefined || this._rowCount == 1) ? this._getLocalizedLabels("NoValue") : rowValue) + "</p>");
                        $("#" + this._id + "_gridTooltip").append("<p id=\"column\" class=\"tooltipText\">" + this._getLocalizedLabels("ToolTipColumn") + ": " + ((columnValue == undefined || columnValue == "") ? this._getLocalizedLabels("NoValue") : columnValue) + "</p>");
                    }
                    var containerEndPos = 0;
                    if (!ej.isNullOrUndefined(this._pivotClientObj))
                        containerEndPos = $("#" + this._id).parent().position().left + this._pivotClientObj.element.find(".gridContainer").width();
                    else
                        containerEndPos = $("#" + this._id).parent().position().left + $("#" + this._id).parent().width();
                    var tooltipEndPos = tdPos.left + $("#" + this._id + "_gridTooltip").width();
                    $("#" + this._id + "_gridTooltip").css({ left: ((tdPos.left > 0 ? tdPos.left : 0) + ((containerEndPos - tooltipEndPos) < 0 ? ((containerEndPos - tooltipEndPos) - 20) : 5)), top: ($(this.element).height() - tdPos.top) < 100 ? (tdPos.top - $("#" + this._id + "_gridTooltip").outerHeight() - 2) : tdPos.top + 40 });
                    if (this.model.enableToolTipAnimation)
                        $("#" + this._id + "_gridTooltip").show("fast");
                    else
                        $("#" + this._id + "_gridTooltip").show();
                    if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.controlPlacement() == "tile")
                        $("#" + this._id + "_gridTooltip").css("position", "absolute");
                }
            }
        },

        _applyVScrolling: function () {           
            var _mouseWheel, isPivotClient = (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.enableVirtualScrolling),
            oGridDiv = !isPivotClient ? $(this.element).find('.virtualScrollGrid') : this._pivotClientObj.element.find(".e-pivotgrid"),
            ctrlObj = !isPivotClient ? this : this._pivotClientObj,
            pGridObj = (isPivotClient && !ej.isNullOrUndefined(this._pivotClientObj._pivotGrid)) ? this._pivotClientObj._pivotGrid : this;
            var isClientWithResponsive = isPivotClient && this.model.isResponsive;

            if (pGridObj._seriesPageCount > 1) {
                var getMinVerticalPos = function () { return isClientWithResponsive ? (Math.round(ctrlObj.element.find(".vScrollPanel").offset().top) + 1) : (Math.round(ctrlObj.element.find(".vScrollPanel").position().top) + 1); };
                var vScrollBar = $(ctrlObj.element).find(".vScrollPanel");
                vScrollBar.height(!isPivotClient ? $(oGridDiv).height() : (this._pivotClientObj.model.isResponsive ? parseInt(this._pivotClientObj.element.find(".controlPanel").height()) : parseInt(this._pivotClientObj.element.find(".gridContainer").height())));
                vScrollBar.html(ej.buildTag("div.vScrollThumb")[0].outerHTML);
                var vScrollHandle = vScrollBar.find(".vScrollThumb");
                vScrollHandle.height(Math.max(Math.ceil((!isPivotClient ? $(oGridDiv).height() : (this._pivotClientObj.model.isResponsive ? parseInt(this._pivotClientObj.element.find(".controlPanel").height()) : parseInt(this._pivotClientObj.element.find(".gridContainer").height()))) / pGridObj._seriesPageCount), 15));
                var vDragRange = vScrollBar.height() - vScrollHandle.height() - 2;
                vScrollHandle.offset({ top: getMinVerticalPos() + (pGridObj._seriesCurrentPage - 1) * (vDragRange / (pGridObj._seriesPageCount - 1)) });

                $(".vScrollPanel").on('mousewheel DOMMouseScroll', function (e) {
                  
                    $('body').on('mousewheel DOMMouseScroll', function (e) { e.preventDefault(); e.stopPropagation(); return false; });
                    initThumbPos = (isClientWithResponsive ? vScrollHandle.offset().top : vScrollHandle.position().top) - getMinVerticalPos(), currentPage = pGridObj._seriesCurrentPage;
                    movedDistance = (e.originalEvent.wheelDelta < 0 || e.originalEvent.detail > 0) ? e.target.offsetParent.offsetTop + 10 : -e.target.offsetParent.offsetTop - 10;
                    ctrlObj.element.find(".seriesPageIndicator").removeClass("inActive").css({ top: vScrollHandle.position().top, left: vScrollHandle.position().left + 20 });
                    var currentPage = pGridObj._seriesCurrentPage;
                    window.navigator.userAgent.indexOf('MSIE ') > -1 ? $(document).on("selectstart", function (e) { e.preventDefault(); }) : window.getSelection().removeAllRanges();
                    var topPos;
                    ((movedDistance > 0 && initThumbPos + movedDistance <= vDragRange) || (movedDistance < 0 && initThumbPos + movedDistance >= 0)) ? topPos = initThumbPos + movedDistance + getMinVerticalPos() : (initThumbPos + movedDistance > vDragRange) ? topPos = getMinVerticalPos() + vDragRange : (initThumbPos + movedDistance < 0) ? topPos = getMinVerticalPos() : "";
                    vScrollHandle.offset({ top: topPos });
                    currentPage = Math.ceil(((isClientWithResponsive ? vScrollHandle.offset().top : vScrollHandle.position().top) - getMinVerticalPos()) / (vDragRange / pGridObj._seriesPageCount)) == 0 ? 1 : Math.ceil(((isClientWithResponsive ? vScrollHandle.offset().top : vScrollHandle.position().top) - getMinVerticalPos()) / (vDragRange / pGridObj._seriesPageCount));
                    if (currentPage > pGridObj._seriesPageCount) { currentPage = pGridObj._seriesPageCount }
                    ctrlObj.element.find(".seriesPageIndicator").css({ top: vScrollHandle.position().top });
                    ctrlObj.element.find(".series_CurrentPage").html(currentPage);
                    if (currentPage != pGridObj._seriesCurrentPage) {
                        pGridObj._seriesCurrentPage = currentPage;
                        clearTimeout(_mouseWheel);
                        _mouseWheel = setTimeout(function () {
                            isPivotClient ? pGridObj._pivotClientObj.refreshPagedPivotClient("series", pGridObj._seriesCurrentPage) :
                            pGridObj.refreshPagedPivotGrid("series", pGridObj._seriesCurrentPage);
                        }, 250);
                    }
                });

                $(vScrollHandle).on('mousedown touchstart', function (e) {                   
                    $(this).addClass("dragging");
                    var initCursorPos = e.pageY - getMinVerticalPos();
                    var initThumbPos = (isClientWithResponsive ? vScrollHandle.offset().top : vScrollHandle.position().top) - getMinVerticalPos();
                    ctrlObj.element.find(".seriesPageIndicator").removeClass("inActive").css({ top: vScrollHandle.position().top, left: vScrollHandle.position().left + 20 });
                    var currentPage = pGridObj._seriesCurrentPage;
                    $(document).on('mousemove touchmove', function (e) {
                        if (window.navigator.userAgent.indexOf('Trident') > -1)
                            $(document).on("selectstart", function (e) { e.preventDefault(); });
                        else
                            window.getSelection().removeAllRanges();
                        var movedDistance = (e.pageY - getMinVerticalPos()) - initCursorPos;
                        if (movedDistance > 0 && initThumbPos + movedDistance <= vDragRange)
                            vScrollHandle.offset({ top: initThumbPos + movedDistance + getMinVerticalPos() });
                        else if (movedDistance < 0 && initThumbPos + movedDistance >= 0)
                            vScrollHandle.offset({ top: initThumbPos + movedDistance + getMinVerticalPos() });
                        else if (initThumbPos + movedDistance > vDragRange)
                            vScrollHandle.offset({ top: getMinVerticalPos() + vDragRange });
                        else if (initThumbPos + movedDistance < 0)
                            vScrollHandle.offset({ top: getMinVerticalPos() });
                        currentPage = Math.floor((Math.round((isClientWithResponsive ? vScrollHandle.offset().top : vScrollHandle.position().top)) - getMinVerticalPos()) / (vDragRange / pGridObj._seriesPageCount)) == 0 ? 1 : Math.floor((Math.round((isClientWithResponsive ? vScrollHandle.offset().top : vScrollHandle.position().top)) - getMinVerticalPos()) / (vDragRange / pGridObj._seriesPageCount));
                        ctrlObj.element.find(".seriesPageIndicator").css({ top: vScrollHandle.position().top });
                        ctrlObj.element.find(".series_CurrentPage").html(currentPage);
                        ctrlObj.element.find(".vScrollThumb").attr("title", ctrlObj.element.find(".seriesPageIndicator").text());
                    });
                    $(document).on('mouseup touchend', function () {
                        $(document).off("selectstart");
                        $(this).off('mousemove touchmove').off('mouseup touchend');
                        $(vScrollHandle).removeClass("dragging");
                        if (currentPage != pGridObj._seriesCurrentPage) {
                            pGridObj._seriesCurrentPage = currentPage;
                            isPivotClient ? pGridObj._pivotClientObj.refreshPagedPivotClient("series", pGridObj._seriesCurrentPage) : pGridObj.refreshPagedPivotGrid("series", pGridObj._seriesCurrentPage);
                        }
                        else
                            ctrlObj.element.find(".seriesPageIndicator").addClass("inActive");
                    });
                });
            }

            if (pGridObj._categPageCount > 1) {
                var getMinHorizontalPos = function () { return isClientWithResponsive ? (Math.round(ctrlObj.element.find(".hScrollPanel").offset().left) + 1) : (Math.round(ctrlObj.element.find(".hScrollPanel").position().left) + 1); };
                if (this.element.parents(".e-pivotclient").length > 0 && this._pivotClientObj.element.find(".childsplit").length > 0)
                    this._pivotClientObj.element.find(".childsplit").data("ejSplitter").refresh();
                var hScrollBar = $(ctrlObj.element).find(".hScrollPanel");
                hScrollBar.width(!isPivotClient ? $(oGridDiv).width() : (this._pivotClientObj.model.enableSplitter ? parseInt(this._pivotClientObj.element.find(".controlPanelTD").width()) : parseInt(this._pivotClientObj.element.find(".controlPanel").width())));
                hScrollBar.html(ej.buildTag("div.hScrollThumb")[0].outerHTML);
                var hScrollHandle = hScrollBar.find(".hScrollThumb");
                hScrollHandle.width(Math.max(Math.ceil((!isPivotClient ? $(oGridDiv).width() : (this._pivotClientObj.model.enableSplitter ? parseInt(this._pivotClientObj.element.find(".controlPanelTD").width()) : parseInt(this._pivotClientObj.element.find(".controlPanel").width()))) / pGridObj._categPageCount), 15));
                var hDragRange = hScrollBar.width() - hScrollHandle.width() - 2;
                if (this.model.enableRTL)
                    hScrollHandle.css({ right: ((pGridObj._categCurrentPage - 1) * (hDragRange / (pGridObj._categPageCount - 1))) });
                else
                    hScrollHandle.offset({ left: getMinHorizontalPos() + (pGridObj._categCurrentPage - 1) * (hDragRange / (pGridObj._categPageCount - 1)) });

                $(".hScrollPanel").on('mousewheel DOMMouseScroll', function (e) {
                    $('body').on('mousewheel DOMMouseScroll', function (e) { e.preventDefault(); e.stopPropagation(); return false; });
                    initThumbPos = ctrlObj.model.enableRTL ? ctrlObj.element.find(".hScrollPanel").width() - (((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) + 16) - getMinHorizontalPos()) : (isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) - getMinHorizontalPos(), currentPage = pGridObj._categCurrentPage;
                    movedDistance = (e.originalEvent.wheelDelta < 0 || e.originalEvent.detail > 0) ? (isPivotClient ? e.target.offsetParent.children[1].offsetLeft + 10 : e.target.offsetParent.offsetLeft + 10) : (isPivotClient ? -e.target.offsetParent.children[1].offsetLeft - 10 : -e.target.offsetParent.offsetLeft - 10);
                    movedDistance = ctrlObj.model.enableRTL ? -movedDistance : movedDistance;
                    ctrlObj.element.find(".categPageIndicator").removeClass("inActive").css({ left: hScrollHandle.position().left, top: hScrollHandle.position().top + 20 });
                    window.navigator.userAgent.indexOf('MSIE ') > -1 ? $(document).on("selectstart", function (e) { e.preventDefault(); }) : window.getSelection().removeAllRanges();
                    var leftPos;
                    ctrlObj.model.enableRTL ? (((movedDistance > 0 && initThumbPos + movedDistance <= hDragRange) || (movedDistance < 0 && initThumbPos + movedDistance >= 0)) ? leftPos = initThumbPos + movedDistance : (initThumbPos + movedDistance > hDragRange) ? leftPos = hDragRange : (initThumbPos + movedDistance < 0) ? leftPos = 0 : "") : (((movedDistance > 0 && initThumbPos + movedDistance <= hDragRange) || (movedDistance < 0 && initThumbPos + movedDistance >= 0)) ? leftPos = initThumbPos + movedDistance + getMinHorizontalPos() : (initThumbPos + movedDistance > hDragRange) ? leftPos = getMinHorizontalPos() + hDragRange : (initThumbPos + movedDistance < 0) ? leftPos = getMinHorizontalPos() : "");
                    ctrlObj.model.enableRTL ? hScrollHandle.css("right", leftPos) : hScrollHandle.offset({ left: leftPos });
                    currentPage = ctrlObj.model.enableRTL ? (Math.floor((ctrlObj.element.find(".hScrollPanel").width() - (((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) + 16) - getMinHorizontalPos())) / (hDragRange / pGridObj._categPageCount)) == 0 ? 1 : Math.floor((ctrlObj.element.find(".hScrollPanel").width() - (((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) + 16) - getMinHorizontalPos())) / (hDragRange / pGridObj._categPageCount))) : (Math.floor((Math.round((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left)) - getMinHorizontalPos()) / (hDragRange / pGridObj._categPageCount)) == 0 ? 1 : Math.floor((Math.round((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left)) - getMinHorizontalPos()) / (hDragRange / pGridObj._categPageCount)));
                    currentPage = currentPage > pGridObj._categPageCount ? pGridObj._categPageCount : (currentPage < 1 ? 1 : currentPage);
                    ctrlObj.element.find(".categPageIndicator").css({ left: hScrollHandle.position().left });
                    ctrlObj.element.find(".categ_CurrentPage").html(currentPage);
                    if (currentPage != pGridObj._categCurrentPage) {
                        pGridObj._categCurrentPage = currentPage;
                        clearTimeout(_mouseWheel);
                        _mouseWheel = setTimeout(function () {
                            isPivotClient ? pGridObj._pivotClientObj.refreshPagedPivotClient("categ", pGridObj._categCurrentPage) :
                            pGridObj.refreshPagedPivotGrid("categ", pGridObj._categCurrentPage);
                        }, 250);
                    }
                });

                $(hScrollHandle).on('mousedown touchstart', function (e) {
                    $(this).addClass("dragging");
                    var initCursorPos = ctrlObj.model.enableRTL ? ctrlObj.element.find(".hScrollPanel").width() - (e.pageX - getMinHorizontalPos()) : e.pageX - getMinHorizontalPos();
                    var initThumbPos = ctrlObj.model.enableRTL ? ctrlObj.element.find(".hScrollPanel").width() - (((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) + 16) - getMinHorizontalPos()) : (isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) - getMinHorizontalPos();
                    ctrlObj.element.find(".categPageIndicator").removeClass("inActive").css({ left: hScrollHandle.position().left, top: hScrollHandle.position().top + 20 });
                    var currentPage = pGridObj._categCurrentPage;
                    $(document).on('mousemove touchmove', function (e) {
                        if (window.navigator.userAgent.indexOf('Trident') > -1)
                            $(document).on("selectstart", function (e) { e.preventDefault(); });
                        else
                            window.getSelection().removeAllRanges();
                        var movedDistance = ctrlObj.model.enableRTL ? (ctrlObj.element.find(".hScrollPanel").width() - (e.pageX - getMinHorizontalPos())) - initCursorPos : (e.pageX - getMinHorizontalPos()) - initCursorPos;
                        if (movedDistance > 0 && initThumbPos + movedDistance <= hDragRange)
                            ctrlObj.model.enableRTL ? hScrollHandle.css({ right: (initThumbPos + movedDistance) }) : hScrollHandle.offset({ left: initThumbPos + movedDistance + getMinHorizontalPos() });
                        else if (movedDistance < 0 && initThumbPos + movedDistance >= 0)
                            ctrlObj.model.enableRTL ? hScrollHandle.css({ right: (initThumbPos + movedDistance) }) : hScrollHandle.offset({ left: initThumbPos + movedDistance + getMinHorizontalPos() });
                        else if (initThumbPos + movedDistance > hDragRange)
                            ctrlObj.model.enableRTL ? hScrollHandle.css({ right: (hDragRange) }) : hScrollHandle.offset({ left: getMinHorizontalPos() + hDragRange });
                        else if (initThumbPos + movedDistance < 0)
                            ctrlObj.model.enableRTL ? hScrollHandle.css({ right: "0px" }) : hScrollHandle.offset({ left: getMinHorizontalPos() });
                        currentPage = ctrlObj.model.enableRTL ? (Math.floor((ctrlObj.element.find(".hScrollPanel").width() - (((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) + 16) - getMinHorizontalPos())) / (hDragRange / pGridObj._categPageCount)) == 0 ? 1 : Math.floor((ctrlObj.element.find(".hScrollPanel").width() - (((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left) + 16) - getMinHorizontalPos())) / (hDragRange / pGridObj._categPageCount))) : (Math.floor((Math.round((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left)) - getMinHorizontalPos()) / (hDragRange / pGridObj._categPageCount)) == 0 ? 1 : Math.floor((Math.round((isClientWithResponsive ? hScrollHandle.offset().left : hScrollHandle.position().left)) - getMinHorizontalPos()) / (hDragRange / pGridObj._categPageCount)));
                        currentPage = currentPage > pGridObj._categPageCount ? pGridObj._categPageCount : (currentPage < 1 ? 1 : currentPage);
                        ctrlObj.element.find(".categPageIndicator").css({ left: hScrollHandle.position().left });
                        ctrlObj.element.find(".categ_CurrentPage").html(currentPage);
                        ctrlObj.element.find(".hScrollThumb").attr("title", ctrlObj.element.find(".categPageIndicator").text());
                    });
                    $(document).on('mouseup touchend', function () {
                        $(document).off("selectstart");
                        $(this).off('mousemove touchmove').off('mouseup touchend');
                        $(hScrollHandle).removeClass("dragging");
                        if (currentPage != pGridObj._categCurrentPage) {
                            pGridObj._categCurrentPage = currentPage;
                            isPivotClient ? pGridObj._pivotClientObj.refreshPagedPivotClient("categ", pGridObj._categCurrentPage) :
                            pGridObj.refreshPagedPivotGrid("categ", pGridObj._categCurrentPage);
                        }
                        else
                            ctrlObj.element.find(".categPageIndicator").addClass("inActive");
                    });
                });
            }
            $('body').off('mousewheel DOMMouseScroll');
        },

        _getLocalizedLabels: function (property) {
            return ej.PivotGrid.Locale[this.locale()][property] === undefined ? ej.PivotGrid.Locale["en-US"][property] : ej.PivotGrid.Locale[this.locale()][property];
        },

        _drillDown: function (e) {
            this._drillCaption = $(e.target).parent().find(".cellValue").text();
            var targetClass = e.target.className;
            this._startDrilldown = true;
            var gridObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            targetClass = targetClass.split(" ");
            if ($(e.target).hasClass("expand"))
                this._drillAction = "drilldown";
            else if ($(e.target).hasClass("collapse"))
                this._drillAction = "drillup";
            var axis = $($(e.target).parent()).hasClass("rowheader") || $($(e.target).parent()).attr("role") == "rowheader" ? "rowheader" : "colheader";
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode== ej.Pivot.OperationalMode.ClientMode) {
                //this._waitingPopup = this.element.data("ejWaitingPopup");
                if (!ej.isNullOrUndefined(pivotClientObj)) {
                    pivotClientObj._isTimeOut = true;
                    setTimeout(function () {
                        if (pivotClientObj._isTimeOut)
                            gridObj._waitingPopup.show();
                    }, 800);
                }
                else
                    this._waitingPopup.show();
                var cPos = $(e.target).parent().attr("p");
                var memberInfo = this.getJSONRecords()[parseInt((parseInt(cPos.split(",")[0]) * this._rowCount) + parseInt(cPos.split(",")[1]))].Info, drilledMember;

                var uniqName = memberInfo.replace(/&/g, "&amp;");
                // drilledMember = this._getDrilledMemeber(uniqName, axis);                
                
                var colPos = parseInt(cPos.split(',')[0]), rowPos = parseInt(cPos.split(',')[1]);
                while (colPos > 0) {
                    colPos--;
                    var tempCellInfo = this.getJSONRecords()[(colPos * this._rowCount) + rowPos].Info, rPos = rowPos;
                    while (tempCellInfo == "" && rPos > 0) {
                        rPos--;
                        tempCellInfo = this.getJSONRecords()[(colPos * this._rowCount) + rPos].Info;
                    }
                    memberInfo = tempCellInfo + ">#>" + memberInfo;
                }

                var currentObj;
                if (this.element.parents(".e-pivotclient").length > 0 ) {
                    currentObj = this.element.parents(".e-pivotclient").data("ejPivotClient");
                    if (axis == "rowheader" && currentObj.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                        currentObj._drillInfo = memberInfo;
                        currentObj.setChartDrillParams(memberInfo, this._drillAction);
                    }
                }
                else
                    currentObj = this;
                currentObj["_pivotRecords"] = { records: this.getJSONRecords(), rowCount: this._rowCount };
                if ($(e.target).hasClass("collapse")) {
                    this.updateDrilledReport({ uniqueName: uniqName, index: cPos, action: "collapse" }, axis, currentObj);
                }
                else {
                    this.updateDrilledReport({ uniqueName: uniqName, index: cPos }, axis, currentObj);
                }
                return false;
            }
            this.element.find(".e-dialog").remove();
            if (!this.model.enableDeferUpdate) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                    this._off(this.element, "click", ".expand, .collapse");
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                    this.element.find(".colheader, .rowheader, .value").removeClass("e-droppable");
                var targetClass = e.target.className;
                var targetEle = $(e.target).parent();
                this._startDrilldown = true;
                targetClass = targetClass.split(" ");
                if (targetClass[0] == "expand")
                    this._drillAction = "drilldown";
                else if (targetClass[0] == "collapse")
                    this._drillAction = "drillup";

                if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: "drillDown", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                var cellPos = $(e.target).parent().attr("p");
                this._drillCaption = $(e.target).parent().find(".cellValue").text();

                if (!ej.isNullOrUndefined(this._pivotClientObj) && !ej.isNullOrUndefined(this._pivotClientObj._waitingPopup)) {
                    pivotClientObj._isTimeOut = true;
                    setTimeout(function () {
                        if (pivotClientObj._isTimeOut) {
                            if ($("#" + gridObj._pivotClientObj._id + "_maxView")[0]) {
                                $("#" + gridObj._pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                                gridObj._maxViewLoading = $("#" + gridObj._pivotClientObj._id + "_maxView").data("ejWaitingPopup");
                            }
                            else
                                gridObj._pivotClientObj._waitingPopup.show();
                        }
                    }, 800);
                }
                else {
                    if (!ej.isNullOrUndefined(pivotClientObj)) {
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                gridObj._waitingPopup.show();
                        }, 800);
                    }
                    else
                        this._waitingPopup.show();
                }
                var headerInfo = this.model.analysisMode == "relational" ? this._drillHeaders.join("||") : this.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * this._rowCount) + parseInt(cellPos.split(",")[1]))].Info;
                var report;
                try {
                    report = ($(this.element).parents(".e-pivotclient").length > 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? JSON.parse(this._pivotClientObj.getOlapReport()).Report : this._pivotClientObj.currentReport) : JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = ($(this.element).parents(".e-pivotclient").length > 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? this._pivotClientObj.getOlapReport() : this._pivotClientObj.currentReport) : this.getOlapReport();
                }

                if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var pGridTb = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders ? $(this.element).find(".pivotGridTable") : $(this.element).find("table").detach();
                    var field = this._getFieldName($(e.target).parent()[0]);
                    if ($(e.target).hasClass("collapse")) {
                        if (ej.isNullOrUndefined(this.model.collapsedMembers)) this.model.collapsedMembers = {};
                        ej.isNullOrUndefined(this.model.collapsedMembers[field]) ? this.model.collapsedMembers[field] = [$(e.target).parent()[0].textContent] : this.model.collapsedMembers[field].push($($(e.target).parent()[0]).clone().children().remove().end().text());
                    }
                    else if ($(e.target).hasClass("expand"))
                        this.model.collapsedMembers[field] = $.grep(this.model.collapsedMembers[field], function (item) { return item != $(e.target).parent()[0].textContent });
                    var drilledCellType = $($(e.target).parent()).hasClass("rowheader") || $($(e.target).parent()).attr("role") == "rowheader" ? "rowheader" : $($(e.target).parent()).hasClass("colheader") || $($(e.target).parent()).attr("role") == "columnheader" ? "columnheader" : "";
                    this._collapseMember(pGridTb, e.target);
                    if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar&& !this._pivotClientObj.model.displaySettings.enableFullScreen)
                        this.element.find("#"+this._id+"Toolbar").append(pGridTb);
                    else
                        this.element.append(pGridTb);
                    if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                        this._applyFrozenHeaderWidth(this._JSONRecords, this._drillAction, targetEle);
                    this._hideGrandTotal(pGridTb);
                    if (this.model.enableGroupingBar) {
                        var tableWidth = $("#" + this._id).find(".pivotGridTable").width();
                        this.element.find(".groupingBarPivot .drag").width(tableWidth - 5);
                        var cellWidth = $("#" + this._id).find(".pivotGridTable").find("th").width();
                        this.element.find(".groupingBarPivot .values").width(cellWidth - 2);
                        this.element.find(".groupingBarPivot .columns").width(tableWidth - cellWidth);
                        this.element.find(".groupingBarPivot .valueColumn").width(tableWidth);
                    }
                    this.element.find(".colheader, .rowheader, .value").addClass("e-droppable");
                    if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                    this._waitingPopup.hide();
                    var eventArgs = e;
                    var colPos = parseInt(cellPos.split(',')[0]), rowPos = parseInt(cellPos.split(',')[1]);
                    var memberInfo = this._drillCaption;
                    if (drilledCellType == "rowheader") {
                        while (colPos > 0) {
                            colPos--;
                            var tempCellInfo = this.getJSONRecords()[this._rowCount * colPos + rowPos].Value, rPos = rowPos;
                            while (tempCellInfo == "" && rPos > 0) {
                                rPos--;
                                tempCellInfo = this.getJSONRecords()[this._rowCount * colPos + rPos].Value;
                            }
                            memberInfo = tempCellInfo + ">#>" + memberInfo;
                        }
                    }
                    this._trigger("drillSuccess", { gridObj: this, drillAction: this._drillAction, drilledMember: memberInfo, fieldName: field, axis: axis, cellPosition: cellPos });
                    if (this.model.enableGroupingBar)
                        this._createFields("drilldown", $("#" + this._id).find(".pivotGridTable").width(), $("#" + this._id).find(".pivotGridTable th").outerWidth());
                    this._unWireEvents();
                    this._wireEvents();
                    this._drillAction = "";
                }
                else {
                    if (this.layout() != "" || this.layout() != "normal") {
                        if (!ej.isNullOrUndefined(this._pivotClientObj))
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillDownGrid", "cellPosition": cellPos, "currentReport": report, "clientReports": this._pivotClientObj.reports, "headerInfo": headerInfo, "layout": this.layout(), "customObject": serializedCustomObject }), this._drillDownSuccess);
                        else
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillDownGrid", "cellPosition": cellPos, "currentReport": report, "headerInfo": headerInfo, "layout": this.layout(), "customObject": serializedCustomObject }), this._drillDownSuccess);
                    }
                    else {
                        if (!ej.isNullOrUndefined(this._pivotClientObj))
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillDownGrid", "cellPosition": cellPos, "currentReport": report, "clientReports": this._pivotClientObj.reports, "headerInfo": headerInfo, "customObject": serializedCustomObject }), this._drillDownSuccess);
                        else
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillDownGrid", "cellPosition": cellPos, "currentReport": report, "headerInfo": headerInfo, "customObject": serializedCustomObject }), this._drillDownSuccess);
                    }
                }
            }
        },

        _collapseMember: function (pGridTb, targetCell) {
            var clickedTh = $(targetCell).parent()[0];
            var positionTh = $(clickedTh).attr("p");            
            var rowSpan = $(targetCell).attr("tag") != undefined ? (parseInt($(targetCell).attr("tag")) + clickedTh.rowSpan) : clickedTh.rowSpan;
            var colsSpan = (this.model.enableAdvancedFilter && !ej.isNullOrUndefined($(clickedTh).attr("vfcolspan"))) ? (parseInt($(clickedTh).attr("vfcolspan"))) : $(targetCell).attr("tag") != undefined ? (parseInt($(targetCell).attr("tag")) + clickedTh.colSpan) : clickedTh.colSpan;
            var row = $(targetCell).closest("tr")[0];
            var nextRow = null, prevRow = null, isTdFRow = "false", hiddenRCnt = 0;

            if (clickedTh.className.indexOf("rowheader") >= 0 || (clickedTh.className.indexOf("summary") >= 0 && $(clickedTh).attr("role") == "rowheader")) {
                if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout) {
                    var indexRow = this.getJSONRecords()[1].Index == "0,0" ? 1 : 0;
                    var rowSpan = this.getJSONRecords()[(parseInt(positionTh.split(',')[0]) * this._rowCount + (parseInt(positionTh.split(',')[1]))) + indexRow].RowSpan;
                    var drillCell = row;
                    if ($(targetCell).attr("class").indexOf("expand") > -1)
                        $(row).removeAttr("tag");
                    for (var rCount = 0; rCount < rowSpan; rCount++) {
                        if ($(targetCell).attr("class") && $(targetCell).attr("class").indexOf("collapse") > -1) {
                            if ($($(row).next()).attr("tag") == undefined)
                                $($(row).next()).attr("tag", positionTh);
                            $($(row).next()).css("display", "none");
                            if (this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders) 
                                $(pGridTb).find(".pivotGridValueTable  td[i$='," + $($(row).next()).find("td").attr('i').split(',')[1] + "']").css("display", "none");
                        }
                        if ($(targetCell).attr("class").indexOf("expand") > -1) {
                            if ($($(row).next()).attr("tag") == undefined || $($(row).next()).attr("tag") == positionTh) {
                                $($(row).next()).css("display", "table-row");
                                $($(row).next()).removeAttr("tag");
                                if ( this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders) 
                                    this.element.find(".pivotGridValueTable td[i$='," + $($(row).next()).find("td").attr('i').split(',')[1] + "']").css("display", "");
                            }
                        }
                        row = $(row).next();
                    }
                    var tableTag = (this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders) ? "td" : "th";
                    var level = $(drillCell).find(tableTag+" span:not(.cellValue)").css("margin-left")
                    $(drillCell).find(tableTag+" span:not(.cellValue)").remove();
                    $(drillCell).find(tableTag).prepend($(targetCell).attr("class").indexOf("collapse") > -1 ? "<span style=\"margin-left:" + level + "\" class=\"expand\ e-icon\" aria-describedby='expansion' title=\"" + this._getLocalizedLabels("Expand") + "\">&nbsp;<p id='expansion' style='display:none'>collapsed</p></span>" : "<span style=\"margin-left:" + level + "\" class=\"collapse\ e-icon\" aria-describedby='collapsing' title=\"" + this._getLocalizedLabels("Collapse") + "\">&nbsp;<p id='collapsing' style='display:none'>expanded</p></span>");
                    return;
                }
                var isTdSameRow = !$(clickedTh).index() > 0;
                var isLeafHide;
                var isHide = isLeafHide = false;
                var subNode = true;
                if ( $(targetCell).attr("class") && $(targetCell).attr("class").indexOf("collapse") > -1) {
                    for (var rCount = 0; rCount < rowSpan; rCount++) {
                        nextRow = $(row).next();
                        if (isTdSameRow) {
                            if ($(row).find(".stot,.rstot").length >= 1)
                                if (rCount == 1 && $($(row).find(".stot,.rstot")).find(".expand").length >= 1)
                                    isLeafHide = true;
                            if ($($(row).find(".stot,.rstot")).find(".expand").length >= 1 || $(row).css('display') == 'none')
                                isHide = true;
                            $(row).css("display", "none");
                            if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders) {
                                $(pGridTb).find(".pivotGridValueTable tr:eq(" + $(row).index() + ")").css("display", "none");                               
                            }
                            $(row).attr("tag", $(row).attr("tag") != undefined ? parseInt($(row).attr("tag")) + 1 : 1);
                        }
                        else {
                            var nextTd = clickedTh;
                            for (tdCnt = 0; tdCnt <= $(clickedTh).nextAll().length; tdCnt++) {
                                $(nextTd).css("display", "none").attr("hc", $(nextTd).attr("hc") == undefined ? 1 : parseInt($(nextTd).attr("hc")) + 1);
                                nextTd = $(nextTd).next();
                            }
                            isTdSubSameRow = false;
                            isTdFRow = "true";
                        }
                        row = nextRow;
                        isTdSameRow = true;
                    }
                    var subractRSpan = isTdFRow == "true" ? (clickedTh.rowSpan - 1) : clickedTh.rowSpan;
                    var rowSubSpan;
                    if ($(row).css('display') != 'none' && isLeafHide)
                        rowSubSpan = $(targetCell).attr("subTag") != undefined ? parseInt($(targetCell).attr("subTag")) == -1 ? clickedTh.rowSpan + 1 : (parseInt($(targetCell).attr("subTag")) + clickedTh.rowSpan) : clickedTh.rowSpan;
                    if ($(row).css('display') == 'none') {
                        $(row).css("display", "");
                            isHide = true;
                        subractRSpan = subractRSpan - 1;
                    }
                    if (isHide && ej.isNullOrUndefined(rowSubSpan))
                        rowSubSpan = $(targetCell).attr("subTag") != undefined ? parseInt($(targetCell).attr("subTag")) == -1 ? clickedTh.rowSpan : (parseInt($(targetCell).attr("subTag")) + clickedTh.rowSpan) : clickedTh.rowSpan;
                    if ((this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) && $(pGridTb).find(".pivotGridValueTable").length > 0) {
                        $(row).find("td").text($(row).find("td").text().replace(" Total", ""));
                        $(row).find("td span:not(.cellValue)").remove();
                        $(row).find("td").prepend("<span class=\"expand\ e-icon\" title=\"" + this._getLocalizedLabels("Expand") + "\" tag=\"" + rowSpan + ":" + isTdFRow + "\">&nbsp;</span>");
                    }
                    else {
                        $(row).find("th").text($(row).find("th").text().replace(" Total", ""));
                        $(row).find("th span:not(.cellValue)").remove();
                        $(row).find("th").prepend("<span class=\"expand\ e-icon\" title=\"" + this._getLocalizedLabels("Expand") + "\" tag=\"" + rowSpan + ":" + isTdFRow + ((!ej.isNullOrUndefined(rowSubSpan)) ? ($(targetCell).attr("isChildSubNode") == "true") ? "\" subTag=\"" + rowSubSpan + ":" + isTdFRow + "\" isChildSubNode=\"" + subNode : "\" subTag=\"" + rowSubSpan + ":" + isTdFRow : "") + "\">&nbsp;</span>");
                    }
                    var prevThRowSpan = $(row).prevAll().find("th:has(span):not(.summary), td:has(span):not(.summary)");
                    for (var rCount = 0; rCount < prevThRowSpan.length; rCount++) {
                        if (parseInt($(prevThRowSpan[rCount]).attr("p").split(",")[0]) < parseInt(positionTh.split(",")[0]) && (parseInt($(prevThRowSpan[rCount]).attr("p").split(",")[1]) + prevThRowSpan[rCount].rowSpan + ($(prevThRowSpan[rCount]).find("span").attr("tag") != undefined ? parseInt($(prevThRowSpan[rCount]).find("span").attr("tag")) : 0)) >= (parseInt(positionTh.split(",")[1]) + rowSpan)) {
                            prevThRowSpan[rCount].rowSpan -= subractRSpan;
                            if ($(prevThRowSpan[rCount]).find("span").attr("tag") == undefined)
                                $(prevThRowSpan[rCount]).find("span").attr("isChildSubNode", true);
                            $(prevThRowSpan[rCount]).find("span").attr("tag", $(prevThRowSpan[rCount]).find("span").attr("tag") != undefined ? (parseInt($(prevThRowSpan[rCount]).find("span").attr("tag")) + (subractRSpan)) : subractRSpan);
                            $(prevThRowSpan[rCount]).find("span").attr("subTag", $(prevThRowSpan[rCount]).find("span").attr("subTag") != undefined ? (parseInt($(prevThRowSpan[rCount]).find("span").attr("subTag")) + (subractRSpan)) : subractRSpan);
                        }
                    }
                }
                else if ($(targetCell).attr("class") && $(targetCell).attr("class").indexOf("expand") > -1) {
                    var isFrozenEnabled = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders;
                    var removeSubSpan;
                    var removeSpan = removeSubSpan = this._isSubTotalhidden = false;
                    var loop = 0;
                    for (var rCount = parseInt($(targetCell).attr("tag").split(":")[0]) ; rCount >= 0 ; rCount--) {
                        prevRow = $(row).prev();
                        if ($(row).attr("tag") == undefined || parseInt($(row).attr("tag")) <= 1) {
                            this._hideSubTotal($(row), loop, $(targetCell))
                            if (this._isSubTotalHide) {
                                removeSpan = true;
                                this._isSubTotalHide = false;
                                $(row).css("display", "none");
                                if (isFrozenEnabled)
                                    $(pGridTb).find(".pivotGridValueTable tr eq:(" + $(row).index() + ")").css("display", "none");
                            }
                            else {
                                $(row).css("display", "table-row");
                                if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders || this.model.frozenHeaderSettings.enableFrozenHeaders) {
                                    $(pGridTb).find(".pivotGridValueTable tr:eq(" + $(row).index() + ")").css("display", "table-row");
                                }
                            }
                        }
                        else
                            hiddenRCnt++;
                        loop = loop == 0 ? 1 : loop;
                        if ($(row).attr("tag") != undefined) {
                            if ((parseInt($(row).attr("tag") - 1)) == 0)
                                $(row).removeAttr("tag");
                            else
                                $(row).attr("tag", parseInt($(row).attr("tag")) - 1);
                        }
                        row = prevRow;
                    }
                    if ($(targetCell).attr("tag").split(":")[1] == "true") {
                        var nextTd = $(pGridTb).find((isFrozenEnabled ? ".pivotGridRowTable " : "th") + "[p='" + parseInt($(clickedTh).attr("p").split(",")[0]) + "," + (parseInt($(clickedTh).attr("p").split(",")[1]) - parseInt($(targetCell).attr("tag").split(":")[0])) + "'], td[p='" + parseInt($(clickedTh).attr("p").split(",")[0]) + "," + (parseInt($(clickedTh).attr("p").split(",")[1]) - parseInt($(targetCell).attr("tag").split(":")[0])) + "']"), ttCnt = $(nextTd).nextAll().length;
                        for (tdCnt = 0; tdCnt <= ttCnt; tdCnt++) {
                            if ($(nextTd).attr("hc") == undefined || parseInt($(nextTd).attr("hc")) <= 1) {
                                $(nextTd).removeAttr("hc");
                                if ($(nextTd).attr("ch") == undefined)
                                    $(nextTd).css("display", "");
                            }
                            else
                                $(nextTd).attr("hc", (parseInt($(nextTd).attr("hc")) - 1));
                            nextTd = $(nextTd).next();
                        }
                    }
                    var prevThRowSpan = $($(targetCell).closest("tr")[0]).prevAll().find("th:has(span):not(.summary), td:has(span):not(.summary)");
                    var rSpnCnt,pTarget;
                    if ($(targetCell).attr("subTag") != undefined && removeSpan)
                        rSpnCnt = ($(targetCell).attr("subTag").split(":")[1] == "true" ? (parseInt($(targetCell).attr("subTag").split(":")[0]) - 1) : parseInt($(targetCell).attr("subTag").split(":")[0]));
                    else
                        rSpnCnt = ($(targetCell).attr("tag").split(":")[1] == "true" ? (parseInt($(targetCell).attr("tag").split(":")[0]) - 1) : parseInt($(targetCell).attr("tag").split(":")[0])) - hiddenRCnt;
                    pTarget = $(pGridTb).find("th[p='" + parseInt($(clickedTh).attr("p").split(",")[0]) + "," + (parseInt($(clickedTh).attr("p").split(",")[1]) - parseInt($(targetCell).attr("tag").split(":")[0])) + "'], td[p='" + parseInt($(clickedTh).attr("p").split(",")[0]) + "," + (parseInt($(clickedTh).attr("p").split(",")[1]) - parseInt($(targetCell).attr("tag").split(":")[0])) + "']");

                    if (removeSpan) {
                        rSpnCnt = parseInt($(pTarget).attr("rowspan"));
                        if ($(targetCell).attr("subTag") != undefined) {
                            rSpnCnt = ($(targetCell).attr("subTag").split(':')[1] == "true" ? (rSpnCnt - 1) : rSpnCnt);
                        }
                        else
                            rSpnCnt = ($(targetCell).attr("tag").split(':')[1] == "true" ? (rSpnCnt - 1) : rSpnCnt);
                        rSpnCnt = $(targetCell).attr("subTag") != undefined ? parseInt($(targetCell).attr("subTag").split(":")[0]) == -1 ? rSpnCnt : (!this._isSubTotalhidden) ? rSpnCnt : rSpnCnt - 1 : rSpnCnt - 1;
                    }
                    for (var rCount = 0; rCount < prevThRowSpan.length; rCount++) {
                        if (parseInt($(prevThRowSpan[rCount]).attr("p").split(",")[0]) < parseInt(positionTh.split(",")[0]) && (parseInt($(prevThRowSpan[rCount]).attr("p").split(",")[1]) + prevThRowSpan[rCount].rowSpan + ($(prevThRowSpan[rCount]).find("span").attr("tag") != undefined ? parseInt($(prevThRowSpan[rCount]).find("span").attr("tag")) : 0)) >= (parseInt(positionTh.split(",")[1]))) {
                            if (removeSpan) {
                                this._isSubTotalhidden = removeSpan = false;
                                //rSpnCnt = $($(prevThRowSpan[rCount]).find("span")[0]).attr("subTag") != undefined ? parseInt($($(prevThRowSpan[rCount]).find("span")[0]).attr("subTag").split(":")[0]) <= rSpnCnt ? rSpnCnt : rSpnCnt + 1 : rSpnCnt;
                                if ($(targetCell).attr("isChildSubNode") == "true") {
                                    //rSpnCnt = rSpnCnt - hiddenRCnt;
                                    $(targetCell).removeAttr("isChildSubNode");
                                }
                            }
                            prevThRowSpan[rCount].rowSpan += rSpnCnt;
                            if ($(prevThRowSpan[rCount]).find("span").attr("tag") != undefined)
                                $(prevThRowSpan[rCount]).find("span").attr("tag", (parseInt($(prevThRowSpan[rCount]).find("span").attr("tag")) - rSpnCnt));
                            if (parseInt($(prevThRowSpan[rCount]).find("span").attr("tag")) == 0)
                                $(prevThRowSpan[rCount]).find("span").removeAttr("tag");
                            if ($(prevThRowSpan[rCount]).find("span").attr("subTag") != undefined)
                                $(prevThRowSpan[rCount]).find("span").attr("subTag", (parseInt($(prevThRowSpan[rCount]).find("span").attr("subTag")) - rSpnCnt));
                            if (parseInt($(prevThRowSpan[rCount]).find("span").attr("subTag")) == 0)
                                $(prevThRowSpan[rCount]).find("span").removeAttr("subTag");
                        }
                    }
                    if ($(clickedTh).find(".cellValue").length>0)
                        $(clickedTh).find(".cellValue").text($.trim($(clickedTh).find(".cellValue").text()) + " Total");
                    else
                        $(clickedTh).text($.trim($(clickedTh).text()) + " Total");
                    $(clickedTh).find(".expand").remove();
                    $(clickedTh).prepend("<span style='margin-left:10px'></span>");
                }
            }
            if (clickedTh.className.indexOf("colheader") >= 0 || (clickedTh.className.indexOf("summary") >= 0 && $(clickedTh).attr("role") == "columnheader")) {
                var tdPosVal = parseInt(positionTh.split(",")[0]), tbRows = $(pGridTb).find("tr");
                if ($(targetCell).attr("class") && $(targetCell).attr("class").indexOf("collapse") > -1) {
                    var span = clickedTh.colSpan;
                    if ($(clickedTh).next().css('display') == 'none') {
                        var positionSubTh = $(clickedTh).next().attr("p"), tdSubPosVal = parseInt(positionSubTh.split(",")[0]), tbSubRows = $(pGridTb).find("tr"), colsSpanSub = parseInt($(clickedTh).next().attr("colspan"));
                        if ($(clickedTh).next().attr("class").indexOf("stot","cstot") > -1) {
                            for (var cCount = 0; cCount < colsSpanSub; cCount++) {
                                var thList = $(row).nextAll().find("th[p^='" + (cCount + tdSubPosVal) + ",']");
                                for (var thCnt = 0; thCnt < $(thList).length; thCnt++) {
                                    $(thList[thCnt]).css("display", "");;
                                }
                                if ($(thList[thCnt]).attr("hc") == undefined || parseInt($(thList[thCnt]).attr("hc")) < 1) {
                                    $(pGridTb).find("td[p^='" + (cCount + tdSubPosVal) + ",']").css("display", "");;
                                    for (var i = 0; i < $(pGridTb).find("td[p^='" + (cCount + tdSubPosVal) + ",']").length; i++) {
                                        if ($($(pGridTb).find("td[p^='" + (cCount + tdSubPosVal) + ",']")[i]).attr("hc") != undefined || $($(pGridTb).find("td[p^='" + (cCount + tdSubPosVal) + ",']")[i]).attr("hc") > -1)
                                            $($(pGridTb).find("td[p^='" + (cCount + tdSubPosVal) + ",']")[i]).css('display', 'none');
                                    }
                                }
                            }
                        }
                        $(clickedTh).next().css("display", "");;
                        span = clickedTh.colSpan - colsSpanSub;
                    }
                    for (var cCount = 0; cCount < colsSpan; cCount++) {
                        var thList = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders ? $(row).nextAll().find("td[p^='" + (cCount + tdPosVal) + ",']") : $(row).nextAll().find("th[p^='" + (cCount + tdPosVal) + ",']");
                        if (thList.length == 0) 
                            continue;
                        for (var thCnt = 0; thCnt < $(thList).length; thCnt++) {
                            $(thList[thCnt]).attr("hc", $(thList[thCnt]).attr("hc") != undefined ? parseInt($(thList[thCnt]).attr("hc")) + 1 : 1).css("display", "none");
                        }
                        if ($(thList[thCnt]).attr("hc") == undefined || parseInt($(thList[thCnt]).attr("hc")) < 1) {
                            if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                                $(pGridTb).find(".pivotGridValueTable td[p^='" + (cCount + tdPosVal) + ",']").css("display", "none");
                                $(pGridTb).find(".pivotGridValueTable td[p^='0,']:not(.summary)").parent().find("td[p^='" + (cCount + tdPosVal) + ",']").attr("ch", 1)
                            }
                            else {
                                $(pGridTb).find("td[p^='" + (cCount + tdPosVal) + ",']").css("display", "none");
                                $(pGridTb).find("th[p^='0,']:not(.summary)").parent().find("td[p^='" + (cCount + tdPosVal) + ",']").attr("ch", 1);
                            }
                        }
                    }
                    $(clickedTh).attr("hc", 1).css("display", "none");
                    $(clickedTh).next().text($(clickedTh).next().text().replace(" Total", ""));
                    $(clickedTh).next().find("span:not(.cellValue)").remove();
                    $(clickedTh).next().prepend("<span class=\"expand\ e-icon\" title=\"" + this._getLocalizedLabels("Expand") + "\" tag=\"" + colsSpan + "\">&nbsp;</span>");
                    var prevThColSpan = $(row).prevAll().find("th:has(span):not(.summary), td:has(span):not(.summary)");
                    for (var cCount = 0; cCount < prevThColSpan.length; cCount++) {
                        var prevColSpan = (this.model.enableAdvancedFilter && !ej.isNullOrUndefined($(prevThColSpan[cCount]).attr("vfcolspan"))) ? parseInt($(prevThColSpan[cCount]).attr("vfcolspan")) : prevThColSpan[cCount].colSpan;
                             if ((parseInt($(prevThColSpan[cCount]).attr("p").split(",")[1]) < parseInt(positionTh.split(",")[1]) && parseInt($(prevThColSpan[cCount]).attr("p").split(",")[0]) <= parseInt(positionTh.split(",")[0])) && (parseInt($(prevThColSpan[cCount]).attr("p").split(",")[0]) + prevColSpan + ($(prevThColSpan[cCount]).find("span").attr("tag") != undefined ? parseInt($(prevThColSpan[cCount]).find("span").attr("tag")) : 0)) >= (parseInt(positionTh.split(",")[0]) + colsSpan)) {
                            prevThColSpan[cCount].colSpan -= span;
                            $(prevThColSpan[cCount]).find("span").attr("tag", $(prevThColSpan[cCount]).find("span").attr("tag") != undefined ? (parseInt($(prevThColSpan[cCount]).find("span").attr("tag")) + (span)) : span);
                        }
                    }
                }
                else if ($(targetCell).attr("class") && $(targetCell).attr("class").indexOf("expand") > -1) {
                    var hdnCCount = 0;
                    var removeCell;
                    var removeSpan = removeCell = this._isSubTotalhidden = false;
                    var loop = 0;
                    var colsSpanSub = parseInt($(clickedTh).attr("colspan"));
                    this._hideSubTotal($(row), loop, $(targetCell))
                    if (this._isSubTotalHide) {
                        removeCell = removeSpan = true;
                        this._isSubTotalHide = false;
                        var positionSubTh = $(clickedTh).attr("p"), tdSubPosVal = parseInt(positionSubTh.split(",")[0]), tbSubRows = $(pGridTb).find("tr");
                        if ($(clickedTh).attr("class").indexOf("stot","cstot") > -1) {
                            for (var cCount = 0; cCount < colsSpanSub; cCount++) {
                                var thSubList = $(row).nextAll().find("th[p^='" + (cCount + tdSubPosVal) + ",']");
                                for (var thCnt = 0; thCnt < $(thSubList).length; thCnt++) {
                                    $(thSubList[thCnt]).css('display', 'none');
                                }
                                if ($(thSubList[thCnt]).attr("hc") == undefined || parseInt($(thSubList[thCnt]).attr("hc")) < 1) {
                                    $(pGridTb).find("td[p^='" + (cCount + tdSubPosVal) + ",']").css('display', 'none');
                                }
                            }
                        }
                        $(clickedTh).css('display', 'none');
                    }
                    var span = colsSpan - (colsSpanSub - 1);
                    for (var cCount = 1; cCount < span; cCount++) {
                        var thList = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders ? $(row).nextAll().find("td[p^='" + (tdPosVal - cCount) + ",']") : $(row).nextAll().find("th[p^='" + (tdPosVal - cCount) + ",']");
                        for (var thCnt = 0; thCnt < $(thList).length; thCnt++) {
                            removeCell = false;
                            for (var k = 0; k < $(thList[thCnt]).length; k++) {
                                if (($($(thList[thCnt])[k]).hasClass("stot") || $($(thList[thCnt])[k]).hasClass("cstot")) && !$($(thList[thCnt])[k]).hasClass("calc"))
                                    this._hideSubTotal($($(thList[thCnt])[k]), loop, $(targetCell))
                            }
                            if (this._isSubTotalHide) {
                                removeCell = true;
                                this._isSubTotalHide = false;
                                var positionSubTh = $(thList[thCnt]).attr("p"), tdSubPosVal = parseInt(positionSubTh.split(",")[0]), tbSubRows = $(pGridTb).find("tr"), colsSpanSub = parseInt($(thList[thCnt]).attr("colspan"));
                                if ($(thList[thCnt]).attr("class").indexOf("stot","cstot") > -1 && !($(thList[thCnt]).find(".expand").length > 0)) {
                                    for (var cSubCount = 0; cSubCount < colsSpanSub; cSubCount++) {
                                        var thSubList = $(row).nextAll().find("th[p^='" + (cSubCount + tdSubPosVal) + ",']");
                                        for (var thCnt = 0; thCnt < $(thSubList).length; thCnt++) {
                                            $(thSubList[thCnt]).css('display', 'none');
                                        }
                                        if ($(thSubList[thCnt]).attr("hc") == undefined || parseInt($(thSubList[thCnt]).attr("hc")) < 1) {
                                            $(pGridTb).find("td[p^='" + (cSubCount + tdSubPosVal) + ",']").css('display', 'none');
                                        }
                                        else
                                            hdnCCount++;
                                    }
                                }
                                $(thList[thCnt]).css('display', 'none');
                            }
                            if ($(thList[thCnt]).attr("hc") == undefined || parseInt($(thList[thCnt]).attr("hc")) == 1) {
                                $(thList[thCnt]).css("display", "");
                                $(thList[thCnt]).removeAttr("hc");
                            }
                            else {
                                if ((parseInt($(thList[thCnt]).attr("hc")) - 1) == 0)
                                    $(thList[thCnt]).removeAttr("hc");
                                else
                                    $(thList[thCnt]).attr("hc", (parseInt($(thList[thCnt]).attr("hc")) - 1));
                            }
                        }
                        loop = loop == 0 ? 1 : loop;
                        if (!removeCell) {
                            if ($(thList).last().attr("hc") == undefined) {
                                var isFrozenEnabled = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders;
                                isFrozenEnabled ? $(pGridTb).find("td[p^='" + (tdPosVal - cCount) + ",']").css("display", "") : $(pGridTb).find("td[p^='" + (tdPosVal - cCount) + ",']").css("display", "");
                                var rHdnTds = [];
                                if (!isFrozenEnabled)
                                    rHdnTds = $(pGridTb).find("[p^='0,']:not(.summary)").parent().find("td[p^='" + (tdPosVal - cCount) + ",']");
                                else
                                {
                                    var rowHdrs = $(pGridTb).find("[p^='0,']:not(.summary)").parent();
                                    var rwHeader = "";
                                    for (var i = 0; i < rowHdrs.length; i++) 
                                        rwHeader = rwHeader + (i!=0? " , ":"") +"  .pivotGridValueTable td:eq(" + $(rowHdrs[i]).index() + ")";
                                    rHdnTds = $(pGridTb).find(rwHeader);
                                }
                                $(rHdnTds).removeAttr("ch");
                                for (var tdCnt = 0; tdCnt <= $(rHdnTds).length; tdCnt++) {
                                    if ($(rHdnTds[tdCnt]).attr("hc") != undefined)
                                        $(rHdnTds[tdCnt]).css("display", "none");
                                }
                            }
                            else
                                hdnCCount++;
                        }
                    }
                    $(clickedTh).prev().removeAttr("hc").css("display", "");
                    var spanRemove = parseInt($(clickedTh).prev().attr("colspan"));
                    var cSpnCnt = parseInt($(targetCell).attr("tag")) - hdnCCount;
                    var prevThColSpan = $(row).prevAll().find("th:has(span):not(.summary), td:has(span):not(.summary)");
                    if (removeSpan) {
                        removeSpan = false;
                        var olapReport = ($(this.element).parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? this._pivotClientObj.getOlapReport() : this.getOlapReport();
                        cSpnCnt = this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? parseInt($(clickedTh).prev().attr("colSpan")) - this.model.dataSource.values.length : parseInt($(clickedTh).prev().attr("colSpan")) - JSON.parse(olapReport).PivotCalculations.length;
                    }
                    for (var cCount = 0; cCount < prevThColSpan.length; cCount++) {
                        var prevColSpan = (this.model.enableAdvancedFilter && !ej.isNullOrUndefined($(prevThColSpan[cCount]).attr("vfcolspan"))) ? parseInt($(prevThColSpan[cCount]).attr("vfcolspan")) : prevThColSpan[cCount].colSpan;
                        if ((parseInt($(prevThColSpan[cCount]).attr("p").split(",")[1]) < parseInt(positionTh.split(",")[1]) && parseInt($(prevThColSpan[cCount]).attr("p").split(",")[0]) < parseInt(positionTh.split(",")[0])) && (parseInt($(prevThColSpan[cCount]).attr("p").split(",")[0]) +
                           //prevColSpan // 
                            prevThColSpan[cCount].colSpan
                            + ($(prevThColSpan[cCount]).find("span").attr("tag") != undefined ? parseInt($(prevThColSpan[cCount]).find("span").attr("tag")) : 0)) >= (parseInt(positionTh.split(",")[0]))) {
                            prevThColSpan[cCount].colSpan += cSpnCnt;
                            if ($(prevThColSpan[cCount]).find("span").attr("tag") != undefined)
                                $(prevThColSpan[cCount]).find("span").attr("tag", (parseInt($(prevThColSpan[cCount]).find("span").attr("tag")) - cSpnCnt));
                            if (parseInt($(prevThColSpan[cCount]).find("span").attr("tag")) == 0)
                                $(prevThColSpan[cCount]).find("span").removeAttr("tag");
                        }
                    }
                    if ($(clickedTh).find(".cellValue").length > 0)
                        $(clickedTh).find(".cellValue").text($.trim($(clickedTh).find(".cellValue").text()) + " Total");
                    else
                        $(clickedTh).text($.trim($(clickedTh).text()) + " Total");
                    $(clickedTh).find(".expand").remove();
                    $(clickedTh).prepend("<span style='margin-left:10px'></span>");
                }
            }
        },
		
        _generateTreeViewData: function (e) {
            var args = { catalog: this.model.dataSource.catalog, cube: this.model.dataSource.cube, url: this.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            this._getTreeData(args, this._loadDimensionElements, { pvtGridObj: this, action: "loadFieldElements" });
        },
        _dimensionsDetails: function (customArgs, e) {
            customArgs.pvtGridObj._dimension = $(e).find("row");
        },
        _loadDimensionElements: function (customArgs, e) {
            customArgs.pvtGridObj._waitingPopup.show();
            var dimensionName, treeNodeElement = {}, measures = {}, conStr = customArgs.pvtGridObj._getConnectionInfo(customArgs.pvtGridObj.model.dataSource.data);
            customArgs.pvtGridObj["schemaTreeView"] = []; customArgs.pvtGridObj["reportItemNames"] = [];
            var data = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>MDSCHEMA_DIMENSIONS</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + customArgs.pvtGridObj.model.dataSource.catalog + "</CATALOG_NAME><CUBE_NAME>" + customArgs.pvtGridObj.model.dataSource.cube + "</CUBE_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + customArgs.pvtGridObj.model.dataSource.catalog + "</Catalog> <LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier></PropertyList></Properties></Discover></Body></Envelope>";
            customArgs.pvtGridObj.doAjaxPost("POST", conStr.url, { XMLA: data }, customArgs.pvtGridObj._dimensionsDetails, null, { pvtGridObj: customArgs.pvtGridObj, action: "loadFieldElements" });
            var dimension = customArgs.pvtGridObj._dimension;
            for (var i = 0; i < $(e).find("row").length; i++) {
                var element = $($(e).find("row")[i]);
                var dimensionUniqueName = element.find("DIMENSION_UNIQUE_NAME").text();
                if (customArgs.pvtGridObj.model.enableDrillThrough){
                    for (var j = 0; j < dimension.length; j++) {
                        if(dimensionUniqueName == $(dimension[j]).find("DIMENSION_UNIQUE_NAME").text())
                            dimensionName = $(dimension[j]).find("DIMENSION_CAPTION").text();
                    }
                }
                else 
                    dimensionName = element.find("DIMENSION_CAPTION").text();

                if (dimensionUniqueName.toLowerCase() == "[measures]")
                    measures = { hasChildren: true, isSelected: false, id: dimensionUniqueName, name: dimensionName, spriteCssClass: dimensionUniqueName.toLowerCase() == "[measures]" ? "folderCDB e-icon" : "dimensionCDB e-icon", tag: dimensionUniqueName }
                else if (!$($(e).find("row")[0]).find("HIERARCHY_CAPTION").length > 0) {
                    treeNodeElement = { hasChildren: true, isSelected: false, id: dimensionUniqueName, name: dimensionName, spriteCssClass: "dimensionCDB e-icon", tag: dimensionUniqueName };
                    customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                }
            }
            customArgs.pvtGridObj.schemaTreeView.splice(0, 0, measures);
            var args = { catalog: customArgs.pvtGridObj.model.dataSource.catalog, cube: customArgs.pvtGridObj.model.dataSource.cube, url: customArgs.pvtGridObj.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            if (!customArgs.pvtGridObj.model.enableDrillThrough || (customArgs.pvtGridObj._schemaData != undefined && customArgs.pvtGridObj._schemaData.model.olap.showNamedSets)) {
                args.request = "MDSCHEMA_SETS";
                customArgs.pvtGridObj._getTreeData(args, customArgs.pvtGridObj._loadNamedSetElements, customArgs);
            }
            else {
                args.request = "MDSCHEMA_HIERARCHIES";
                if (customArgs.pvtGridObj._fieldData.hierarchySuccess == undefined)
                    customArgs.pvtGridObj._getTreeData(args, customArgs.pvtGridObj._loadHierarchyElements, customArgs);
                else {
                    customArgs.pvtGridObj._loadHierarchyElements(customArgs, customArgs.pvtGridObj._fieldData.hierarchySuccess);
                }
            }
        },
        _loadNamedSetElements: function (customArgs, e) {
            customArgs.pvtGridObj._waitingPopup.show();
            var args = { catalog: customArgs.pvtGridObj.model.dataSource.catalog, cube: customArgs.pvtGridObj.model.dataSource.cube, url: customArgs.pvtGridObj.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            var data = customArgs.pvtGridObj.model.dataSource;
            var reportElement = $.map(data.rows, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName });
            $.merge(reportElement, ($.map(data.columns, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));
            $.merge(reportElement, ($.map(data.filters, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));

            measureGroupItems = [];

            for (var i = 0; i < $(e).find("row").length; i++) {
                var element = $($(e).find("row")[i]);
                if ((!($.inArray(element.find("DIMENSIONS").text().split(".")[0], measureGroupItems) >= 0))) {
                    treeNodeElement = {
                        hasChildren: true, isSelected: false, pid: element.find("DIMENSIONS").text().split(".")[0], id: element.find("SET_DISPLAY_FOLDER").text() + "_" + element.find("DIMENSIONS").text().split(".")[0],
                        name: element.find("SET_DISPLAY_FOLDER").text(), spriteCssClass: "folderCDB e-icon namedSets"
                    }
                    customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                    measureGroupItems.push(element.find("DIMENSIONS").text().split(".")[0]);
                }
                treeNodeElement = {
                    hasChildren: true, isSelected: ($.inArray("[" + $.trim(element.children("SET_NAME").text()) + "]", reportElement) >= 0),
                    pid: element.find("SET_DISPLAY_FOLDER").text() + "_" + element.find("DIMENSIONS").text().split(".")[0],
                    id: "[" + $.trim(element.children("SET_NAME").text()).replace(/\&/g, "&amp;") + "]",
                    name: element.children("SET_CAPTION").text(), spriteCssClass: "namedSetCDB e-icon", tag: element.find("EXPRESSION").text()
                }
                customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
            }
            args.request = "MDSCHEMA_HIERARCHIES";
            if (customArgs.pvtGridObj._fieldData.hierarchySuccess == undefined)
                customArgs.pvtGridObj._getTreeData(args, customArgs.pvtGridObj._loadHierarchyElements, customArgs);
            else {
                customArgs.pvtGridObj._loadHierarchyElements(customArgs, customArgs.pvtGridObj._fieldData.hierarchySuccess);
            }
        },
        _loadHierarchyElements: function (customArgs, e) {
            customArgs.pvtGridObj._waitingPopup.show();
            var args = { catalog: customArgs.pvtGridObj.model.dataSource.catalog, cube: customArgs.pvtGridObj.model.dataSource.cube, url: customArgs.pvtGridObj.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            var data = customArgs.pvtGridObj.model.dataSource;
            var reportElement = $.map(data.rows, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName });
            $.merge(reportElement, ($.map(data.columns, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));
            $.merge(reportElement, ($.map(data.filters, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName })));
            var treeNodeElement = {}, displayFolder = "";
            for (var i = 0; i < $(e).find("row").length; i++) {
                var element = $($(e).find("row")[i]);
                var dimensionUniqueName = element.find("DIMENSION_UNIQUE_NAME").text();
                var hierarchyUniqueName = element.find("HIERARCHY_UNIQUE_NAME").text();
                var currElement = $(customArgs.pvtGridObj.schemaTreeView).filter(function (i,x) { return x.tag == dimensionUniqueName; }).map(function (i,x) { return x });
                if (currElement.length > 0 && dimensionUniqueName != hierarchyUniqueName) {
                    treeNodeElement = {
                        hasChildren: true, isSelected: ($.inArray(hierarchyUniqueName, reportElement) >= 0), pid: dimensionUniqueName, id: hierarchyUniqueName, name: element.find("HIERARCHY_CAPTION").text(),
                        spriteCssClass: ((element.find("HIERARCHY_ORIGIN").text() != "2") && element.find("HIERARCHY_ORIGIN").text() != "6") ? "hierarchyCDB e-icon" : "attributeCDB e-icon", tag: hierarchyUniqueName  //HIERARCHY_ORDINAL
                    },
                    customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                }
            }
            args.request = "MDSCHEMA_LEVELS"
            customArgs.pvtGridObj._getTreeData(args, customArgs.pvtGridObj._loadLevelElements, customArgs);
        },
        _loadLevelElements: function (customArgs, args) {
            customArgs.pvtGridObj._waitingPopup.show();
            var newDataSource = $.map($(args).find("row"), function (obj, index) {
                if (parseInt($(obj).children("LEVEL_TYPE").text()) != "1" && $(obj).children("HIERARCHY_UNIQUE_NAME").text().toLowerCase() != "[measures]") {
                    treeNodeElement = {
                        hasChildren: false, isChecked: false, id: $(obj).find("LEVEL_UNIQUE_NAME").text(), pid: $(obj).find("HIERARCHY_UNIQUE_NAME").text(), name: $(obj).find("LEVEL_CAPTION").text(),
                        spriteCssClass: "level" + parseInt($(obj).children("LEVEL_NUMBER").text()) + " e-icon", tag: $(obj).find("LEVEL_UNIQUE_NAME").text()
                    };
                    return treeNodeElement;
                }
            });
            $.merge(customArgs.pvtGridObj.schemaTreeView, newDataSource);
            if (!customArgs.pvtGridObj.model.enableDrillThrough && customArgs.pvtGridObj._fieldData.measureSuccess) {
                if (!customArgs.pvtGridObj._fieldData.measureSuccess) {
                    var args = { catalog: customArgs.pvtGridObj.model.dataSource.catalog, cube: customArgs.pvtGridObj.model.dataSource.cube, url: customArgs.pvtGridObj.model.dataSource.data, request: "MDSCHEMA_MEASURES" }
                    customArgs.pvtGridObj._getTreeData(args, customArgs.pvtGridObj._loadMeasureElements, customArgs);
                }
                else {
                    customArgs.pvtGridObj._loadMeasureElements(customArgs, customArgs.pvtGridObj._fieldData.measureSuccess);
                }
            }
            else
                ej.Pivot._createDrillThroughDialog(customArgs.pvtGridObj, customArgs.pvtGridObj.schemaTreeView);
        },
        _loadMeasureGroups: function (customArgs, e) {
            customArgs.pvtGridObj._fieldData["measuresGroups"] = $(e).find("row");
        },
        _loadMeasureElements: function (customArgs, e) {
            var args = { catalog: customArgs.pvtGridObj.model.dataSource.catalog, cube: customArgs.pvtGridObj.model.dataSource.cube, url: customArgs.pvtGridObj.model.dataSource.data, request: "MDSCHEMA_DIMENSIONS" }
            var data = customArgs.pvtGridObj.model.dataSource;
            var elements = $.map(data.values, function (obj, index) { if (obj["measures"] != undefined) return obj["measures"] });
            this.reportItemNames = $.map(elements, function (obj, index) { if (obj.fieldName != undefined) return obj.fieldName });
            var measureGroupItems = [], measureGroup = "", caption;
            {
                if (customArgs.pvtGridObj.model.locale != "en-US") {
                    var args = { catalog: customArgs.pvtGridObj.model.dataSource.catalog, cube: customArgs.pvtGridObj.model.dataSource.cube, url: customArgs.pvtGridObj.model.dataSource.data, request: "MDSCHEMA_MEASUREGROUPS" }
                    customArgs.pvtGridObj._getTreeData(args, this._loadMeasureGroups, {pvtGridObj: this, action: "loadFieldElements" });
                }
                for (var i = 0; i < $(e).find("row").length; i++) {
                    var element = $($(e).find("row")[i]), measureGRPName = element.children("MEASUREGROUP_NAME").text(), measureUQName = element.find("MEASURE_UNIQUE_NAME").text();
                    if ((!($.inArray(measureGRPName, measureGroupItems) >= 0))) {
                        if (customArgs.pvtGridObj.model.locale != "en-US") {
                            var measureInfo = $.map(customArgs.pvtGridObj._fieldData["measuresGroups"], function (item) { if ($(item).children("MEASUREGROUP_NAME").text() == measureGRPName) return $(item).children("MEASUREGROUP_CAPTION").text() });
                            caption = measureInfo.length > 0 ? measureInfo[0] : measureGRPName
                        }
                        else
                            caption = measureGRPName;

                        treeNodeElement = { hasChildren: true, isChecked: false, pid: "[Measures]", id: measureGRPName, name: caption, spriteCssClass: "measureGroupCDB e-icon", tag: measureGRPName }
                        customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                        measureGroupItems.push(measureGRPName);
                    }
                    treeNodeElement = { hasChildren: true, isSelected: ($.inArray(measureUQName, this.reportItemNames) >= 0), id: measureUQName, pid: measureGRPName, name: element.children("MEASURE_CAPTION").text(), spriteCssClass: "measure", tag: measureUQName }
                    customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                    if (($.inArray(measureUQName, customArgs.pvtGridObj.reportItemNames) >= 0)) {
                        customArgs.pvtGridObj.reportItemNames.splice(customArgs.pvtGridObj.reportItemNames.indexOf(measureUQName), 1)
                    }
                }
            }
            if (customArgs.pvtGridObj._schemaData.model.olap.showKpi) {
                treeNodeElement = { hasChildren: true, isChecked: false, id: "folderStruct", name: "KPI", spriteCssClass: "KPICDB folderCDB e-icon", tag: "" }
                customArgs.pvtGridObj.schemaTreeView.splice(1, 0, treeNodeElement);
                args.request = "MDSCHEMA_KPIS";
                customArgs.pvtGridObj._getTreeData(args, customArgs.pvtGridObj._loadKPIElements, customArgs);
            }
            else
                customArgs.pvtGridObj._schemaData._createTreeView(this, customArgs.pvtGridObj.schemaTreeView);

        },
        _loadKPIElements: function (customArgs, e) {
            var data = customArgs.pvtGridObj.model.dataSource;
            var reportElement = this.reportItemNames;
            var measureGroupItems = [];
            var measureGroup = "";
            for (var i = 0; i < $(e).find("row").length; i++) {
                var element = $($(e).find("row")[i]),
                    kpiName = element.children("KPI_CAPTION").text(),
                    kpiGoal = element.children("KPI_goal").text(),
                    kpiStatus = element.children("KPI_STATUS").text(),
                    kpiTrend = element.children("KPI_TREND").text(),
                    kpiValue = element.find("KPI_VALUE").text();
                if ((!($.inArray(element.children("KPI_NAME").text(), measureGroupItems) >= 0))) {
                    treeNodeElement = { hasChildren: true, isChecked: false, pid: "folderStruct", id: kpiName, name: kpiName, spriteCssClass: "measureGroupCDB e-icon", tag: kpiName }
                    customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                    measureGroupItems.push(kpiName);
                }

                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiGoal, reportElement) >= 0), id: kpiGoal, pid: kpiName, name: customArgs.pvtGridObj._getLocalizedLabels("Goal"), spriteCssClass: "kpiGoal e-icon", tag: kpiGoal };
                customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiStatus, reportElement) >= 0), id: kpiStatus, pid: kpiName, name: customArgs.pvtGridObj._getLocalizedLabels("Status"), spriteCssClass: "kpiStatus e-icon", tag: kpiStatus };
                customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiTrend, reportElement) >= 0), id: kpiTrend, pid: kpiName, name: customArgs.pvtGridObj._getLocalizedLabels("Trend"), spriteCssClass: "kpiTrend e-icon", tag: kpiTrend };
                customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
                treeNodeElement = { hasChildren: true, isSelected: ($.inArray(kpiValue, reportElement) >= 0), id: kpiValue, pid: kpiName, name: customArgs.pvtGridObj._getLocalizedLabels("Value"), spriteCssClass: "kpiValue e-icon", tag: kpiValue };
                customArgs.pvtGridObj.schemaTreeView.push(treeNodeElement);
            }

            customArgs.pvtGridObj._schemaData._createTreeView(this, customArgs.pvtGridObj.schemaTreeView);
            delete customArgs.pvtGridObj.reportItemNames;
            delete customArgs.pvtGridObj.schemaTreeView;
        },
        _getTreeData: function (args, successMethod, customArgs) {
            var conStr = ej.olap.base._getConnectionInfo(args.url);
            var pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"><Header/><Body><Discover xmlns=\"urn:schemas-microsoft-com:xml-analysis\"><RequestType>" + args.request + "</RequestType><Restrictions><RestrictionList><CATALOG_NAME>" + args.catalog + "</CATALOG_NAME><CUBE_NAME>" + args.cube + "</CUBE_NAME></RestrictionList></Restrictions><Properties><PropertyList><Catalog>" + args.catalog + "</Catalog><LocaleIdentifier>" + conStr.LCID + "</LocaleIdentifier> </PropertyList></Properties></Discover></Body></Envelope>";
            this.doAjaxPost("POST", conStr.url, { XMLA: pData }, successMethod, null, customArgs);
        },

        _addHyperlink: function (e) {
            if ($(".hyperlinkValueCell")[0])
                $($(".hyperlinkValueCell")[0]).removeClass("hyperlinkValueCell");
            if ($(".hyperlinkHeaderCell")[0])
                $($(".hyperlinkHeaderCell")[0]).removeClass("hyperlinkHeaderCell");
            if ($(e.target).text() == "" || $(e.target).text() == null)
                return false;
            var fieldIndex;
            if (e.target.parentElement.className.replace(/^\s+/, "").split(" ")[0] == "value" && (this.enableValueCellHyperlink() || ((!ej.isNullOrUndefined(this._pivotClientObj)) ? this._pivotClientObj.model.enableDrillThrough : this.model.enableDrillThrough)))
                $(e.target).addClass("hyperlinkValueCell");
            else if ($(e.target.parentElement).hasClass("summary value") && this.enableSummaryCellHyperlink())
                $(e.target).addClass("hyperlinkValueCell");

            else if (e.target.parentElement.className.split(" ")[0] == "rowheader" || (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && $(e.target.parentElement).attr("role") == "rowheader")) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && !this.model.enableDeferUpdate && $(this.element).parents(".e-pivotclient").length == 0) {
                    if (!$(e.target.parentElement).hasClass("rgtot")) {
                        fieldIndex = $(e.target.parentElement).attr("p").split(",")[0];
                        if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && !ej.isNullOrUndefined(JSON.parse(this.getOlapReport()).PivotRows[fieldIndex]) && JSON.parse(this.getOlapReport()).PivotRows[fieldIndex].EnableHyperlink)
                            $(e.target).addClass("hyperlinkHeaderCell");
                        else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.dataSource.rows.length > 0 && !ej.isNullOrUndefined(this.model.dataSource.rows[fieldIndex].enableHyperlink) && this.model.dataSource.rows[fieldIndex].enableHyperlink)
                            $(e.target).addClass("hyperlinkHeaderCell");
                        else if (this.enableRowHeaderHyperlink())
                            $(e.target).addClass("hyperlinkHeaderCell");
                    }
                }
                else if (this.enableRowHeaderHyperlink())
                    $(e.target).addClass("hyperlinkHeaderCell");
            }
            else if (e.target.parentElement.className.split(" ")[0] == "colheader" || (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && $(e.target.parentElement).attr("role") == "columnheader")) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && !this.model.enableDeferUpdate && $(this.element).parents(".e-pivotclient").length == 0) {
                    if (!$(e.target.parentElement).hasClass("calc") && !$(e.target.parentElement).hasClass("cgtot") && !$(e.target.parentElement).hasClass("gtot")) {
                        fieldIndex = $(e.target.parentElement).attr("p").split(",")[1];
                        if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && !ej.isNullOrUndefined(JSON.parse(this.getOlapReport()).PivotColumns[fieldIndex]) && JSON.parse(this.getOlapReport()).PivotColumns[fieldIndex].EnableHyperlink)
                            $(e.target).addClass("hyperlinkHeaderCell");
                        else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && !ej.isNullOrUndefined(this.model.dataSource.columns[fieldIndex].enableHyperlink) && this.model.dataSource.columns[fieldIndex].enableHyperlink)
                            $(e.target).addClass("hyperlinkHeaderCell");
                        else if (this.enableColumnHeaderHyperlink())
                            $(e.target).addClass("hyperlinkHeaderCell");
                    }
                }
                else if (this.enableColumnHeaderHyperlink())
                    $(e.target).addClass("hyperlinkHeaderCell");
            }
        },

        _removeHyperlink: function (e) {
            $(e.target).removeClass("hyperlinkValueCell").removeClass("hyperlinkHeaderCell");
        },

        _cellContext: function (e) {
            var pGridObj = $(e.target).parents(".e-pivotgrid").data("ejPivotGrid");
            var currentCell = ($(e.target).hasClass("cellValue") ? $(e.target).parent()[0] : e.target) || ($(e.srcElement).hasClass("cellValue") ? $(e.srcElement).parent()[0] : e.srcElement);
            if (!ej.isNullOrUndefined(pGridObj) && pGridObj.enableCellContext() == true && $(currentCell).parents("#" + pGridObj._id)[0]) {
                var cellPos = $(currentCell).attr("p");
                if (cellPos) {
                    var cellPos = pGridObj._excelLikeJSONRecords != null && pGridObj.model.layout.toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout ? $(currentCell).attr("i") : $(currentCell).attr("p");
                    var rawdata = pGridObj._excelLikeJSONRecords != null && pGridObj.model.layout.toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout ? pGridObj._excelLikeJSONRecords[parseInt((parseInt(cellPos.split(",")[0]) * pGridObj._excelRowCount) + parseInt(cellPos.split(",")[1]))].Info : pGridObj.getJSONRecords()[parseInt((parseInt(cellPos.split(",")[0]) * pGridObj._rowCount) + parseInt(cellPos.split(",")[1]))].Info;
                    var cellInfo = {
                        cellValue: currentCell.innerHTML,
                        cellPosition: cellPos,
                        cellType: currentCell.className.split(" ")[0] != "" ? currentCell.className.split(" ")[0] : currentCell.className.split(" ")[1],
                        role: $(currentCell).attr('role'),
                        uniqueName: rawdata.split('::')[0],
                        args: e,
                        rawdata: rawdata
                    };
                    if (cellInfo.cellType != "")
                        pGridObj._trigger("cellContext", { args: cellInfo });
                    e.target ? e.preventDefault() : (window.event.returnValue = false);
                }
            }
        },

        _initCellSelection: function (e) {
            $("#" + this._id + " td,th").removeClass("highlighted");
            this._on(this.element, "mouseup touchend", ".value", this._completeCellSelection);
            var targetCell;
            _oriX = e.pageX, _oriY = e.pageY;
            targetCell = e.target || window.event.srcElement;
            if ($(targetCell).hasClass("cellValue")) targetCell = targetCell.parentElement;
            $(".value").addClass("selection");
            $("#" + this._id).append(ej.buildTag("div.cellSelection#" + this._id + "_cellSelection", "", {}));
            _startPosCell = $(targetCell)[0].attributes.getNamedItem("p").value;
            if (this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout) {
                var startIndex = this._excelLikeJSONRecords[(0 * this._rowCount + (parseInt($(targetCell)[0].attributes.getNamedItem("i").value.split(',')[1])))].Index;
                _startPosCell = this.getJSONRecords()[((parseInt($(targetCell)[0].attributes.getNamedItem("p").value.split(',')[0])) * this._rowCount + parseInt(startIndex.split(',')[1]))].Index;
            }
            this._on(this.element, "mousemove touchmove", ".value, .cellSelection", this._cellSelection);
        },

        _headerClickCellSelection: function (e) {
            var target = ($(e.target).attr("class").indexOf("colheader") && $(e.target).attr("class").indexOf("rowheader") == -1) ? ($(e.target).attr("class").indexOf("cellValue") != -1 ? $(e.target).parent() : null) : $(e.target);
            if (target != null) {
                $("#" + this._id + " td,th").removeClass("highlighted");
                var _headerType, _span, _position, _cellInfo = [], _colHeader = [], _rowHeader = [], _measureCount = 0;
                _headerType = target.attr("role");
                _position = _headerType == "columnheader" ? target.attr("p").split(',')[0] : target.attr("p").split(',')[1];
                _span = _headerType == "columnheader" ? target.attr("colspan") : target.attr("rowspan");
                if (this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout) {
                    var rowSpanIndex = (parseInt(target.attr("p").split(',')[0]) * this._rowCount + (parseInt(target.attr("p").split(',')[1])));
                    _span = _headerType == "columnheader" ? this._excelLikeJSONRecords[(parseInt(target.attr("i").split(',')[0]) * this._rowCount + (parseInt(target.attr("i").split(',')[1])))].ColSpan : this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.getJSONRecords()[rowSpanIndex + this._rowCount] != null && this.getJSONRecords()[rowSpanIndex + this._rowCount].CSS.indexOf("value") == -1 ? this.getJSONRecords()[rowSpanIndex].RowSpan + 1 : this.getJSONRecords()[rowSpanIndex].RowSpan;
                }
                for (var i = 0; i < _span; i++) {
                    if (_headerType == "columnheader") {
                        $("#" + this._id + " [p^='" + (parseInt(i) + parseInt(_position)) + ",']").addClass("highlighted");
                        $("#" + this._id + " [p^='" + (parseInt(i) + parseInt(_position)) + ",']" + "[role='columnheader']").each(function (index, el) {
                            if (parseInt(el.attributes['p'].value.split(',')[1]) <= parseInt(target.attr("p").split(',')[1]) || parseInt(el.attributes['colspan'].value) > parseInt(target.attr("colspan")))
                                $(el).removeClass("highlighted");
                        })
                    }
                    else {
                        $("#" + this._id + " [p$='," + (parseInt(i) + parseInt(_position)) + "']").addClass("highlighted");
                        $("#" + this._id + " [p$='," + (parseInt(i) + parseInt(_position)) + "']" + "[role='rowheader']").each(function (index, el) {
                            if (parseInt(el.attributes['p'].value.split(',')[0]) <= parseInt(target.attr("p").split(',')[0]) || parseInt(el.attributes['rowspan'].value) > parseInt(target.attr("rowspan")))
                                $(el).removeClass("highlighted");
                        })
                    }
                }
                _startPosCell = _headerType == "columnheader" ? $("#" + this._id + " [p^='" + (0 + parseInt(_position)) + ",']" + ".value").eq(0).attr("p") : $("#" + this._id + " [p$='," + (0 + parseInt(_position)) + "']" + ".value").eq(0).attr("p");
                if (this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout && !(this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode))
                    _startPosCell = _headerType == "columnheader" ? $("#" + this._id + " [p^='" + (0 + parseInt(_position)) + ",']" + ".value:not(.summary)").eq(0).attr("p") : $("#" + this._id + " [p$='," + (0 + parseInt(_position)) + "']" + ".value:not(.summary)").eq(0).attr("p");
                var el = _headerType == "columnheader" ? $("#" + this._id + " [p^='" + ((parseInt(_span) - 1) + parseInt(_position)) + ",']").eq($("#" + this._id + " [p^='" + ((parseInt(_span) - 1) + parseInt(_position)) + ",']").length - 1) : $("#" + this._id + " [p$='," + ((parseInt(_span) - 1) + parseInt(_position)) + "']").eq($("#" + this._id + " [p$='," + ((parseInt(_span) - 1) + parseInt(_position)) + "']").length - 1);
                this._completeCellSelection(el);
            }
        },

        _cellSelection: function (e) {
            $("#" + this._id + "_gridTooltip").hide();
            var isPivotClient = ($(e.target).parents(".e-pivotclient").length > 0);
            var width = e.pageX - this.element.offset().left - (_oriX - this.element.offset().left);
            var height = e.pageY - this.element.offset().top - (_oriY - this.element.offset().top);
            var posX = _oriX - this.element.offset().left;
            var posY = _oriY - this.element.offset().top + 3;
            if (width < 0) {
                width = Math.abs(width);
                posX -= width - 5;
            }
            if (height < 0) {
                height = Math.abs(height);
                posY -= height - 12;
            }
            if (e.pageX < _oriX) {
                $("#" + this._id + "_cellSelection").css({ left: (isPivotClient) ? posX : (e.pageX + 2), width: (isPivotClient) ? width : (_oriX - e.pageX) });
            }
            else {
                $("#" + this._id + "_cellSelection").css({ left: (isPivotClient) ? posX : (_oriX - 6), width: (isPivotClient) ? width : (e.pageX - _oriX) });
            }
            if (e.pageY < _oriY) {
                $("#" + this._id + "_cellSelection").css({ top: (isPivotClient) ? posY : e.pageY, height: (isPivotClient) ? height : (_oriY - e.pageY - 7) });
            }
            else {
                $("#" + this._id + "_cellSelection").css({ top: (isPivotClient) ? posY : (_oriY + 7), height: (isPivotClient) ? height : (e.pageY - _oriY - 11) });
            }
            $(".pivotGridTable").mouseleave(function (e) {
                var pGridObj = $(e.target).parents(".e-pivotgrid").data("ejPivotGrid");
                if (!ej.isNullOrUndefined(e.toElement) && !ej.isNullOrUndefined(e.toElement.classList) && e.toElement.classList[0] == "e-pivotgrid") {
                    $("#" + pGridObj._id + "_cellSelection").remove();
                    $(".value").removeClass("selection");
                    pGridObj._off(pGridObj.element, "mouseup mouseend", ".value");
                }
            });
        },

        _completeCellSelection: function (e) {
            var targetCell, endPosCell, cellInfo = [], rowHeader = [], rowLThPos, colHeader = [], curCelPos;
            this._off(this.element, "mousemove touchmove", ".value");
            $(".value").removeClass("selection");
            targetCell = $(e).hasClass("value") ? e : e.target || window.event.srcElement;
            if ($(targetCell).hasClass("cellValue")) targetCell = targetCell.parentElement;
            endPosCell = $(targetCell)[0].attributes.getNamedItem("p").value;
            if (this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout && !($(e).hasClass("value"))) {
                var endIndex = this._excelLikeJSONRecords[(0 * this._rowCount + (parseInt($(targetCell)[0].attributes.getNamedItem("i").value.split(',')[1])))].Index;
                endPosCell = this.getJSONRecords()[((parseInt($(targetCell)[0].attributes.getNamedItem("p").value.split(',')[0])) * this._rowCount + parseInt(endIndex.split(',')[1]))].Index;

            }
            var count = 0;
            for (var rowSelCnt = (parseInt(_startPosCell.split(",")[1]) < parseInt(endPosCell.split(",")[1]) ? parseInt(_startPosCell.split(",")[1]) : parseInt(endPosCell.split(",")[1])) ; rowSelCnt <= (parseInt(_startPosCell.split(",")[1]) > parseInt(endPosCell.split(",")[1]) ? parseInt(_startPosCell.split(",")[1]) : parseInt(endPosCell.split(",")[1])) ; rowSelCnt++) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap || $("#" + this._id).find("td[p*='," + rowSelCnt + "']").parent().is(":visible")) {
                    for (var colSelCnt = (parseInt(_startPosCell.split(",")[0]) < parseInt(endPosCell.split(",")[0]) ? parseInt(_startPosCell.split(",")[0]) : parseInt(endPosCell.split(",")[0])) ; colSelCnt <= (parseInt(_startPosCell.split(",")[0]) > parseInt(endPosCell.split(",")[0]) ? parseInt(_startPosCell.split(",")[0]) : parseInt(endPosCell.split(",")[0])) ; colSelCnt++) {
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap || $("#" + this._id).find("[p*='" + colSelCnt + ",']").last("th").is(":Visible")) {
                            cellInfo[count] = this.getJSONRecords()[((colSelCnt) * this._rowCount) + rowSelCnt];
                            var rowInfo, rowValue = "";
                            var tempThPos, measureColumn, measureRowCount = 0, measureColCount = 0;
                            rowLThPos = this.element.find(".summary[role!='gridcell'][p$='," + rowSelCnt + "'] , .rowheader[role!='gridcell'][p$='," + rowSelCnt + "']").last().attr("p");
                            if (rowLThPos == undefined) {
                                rowLThPos = $("#" + this._id).find("tbody").find('[p="' + colSelCnt + "," + rowSelCnt + '"]').parent("tr").find(".summary").first().attr('p');
                            }
                            tempThPos = rowLThPos;
                            if (rowLThPos != null) {
                                while (rowLThPos[0] >= 0) {
                                    if (rowLThPos == this.getJSONRecords()[parseInt((parseInt(rowLThPos.split(",")[0]) * this._rowCount) + parseInt(rowLThPos.split(",")[1]))].Index) {
                                        rowInfo = this.getJSONRecords()[parseInt((parseInt(rowLThPos.split(",")[0]) * this._rowCount) + parseInt(rowLThPos.split(",")[1]))].Value;
                                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                                            rowInfo = ($("#" + this._id).find("td[p*='" + colSelCnt + "," + rowSelCnt + "']")).prevAll("th").children(".expand").length > 0 ? rowInfo.replace(this._getLocalizedLabels("Total"), "") : rowInfo;
                                        }
                                        rowLThPos = parseInt(rowLThPos.split(",")[0]) - 1 + "," + parseInt(rowLThPos.split(",")[1]);
                                    }
                                    if ((rowValue) && (rowInfo != ""))
                                        rowValue = rowInfo + "##" + rowValue;
                                    else if (rowInfo != "")
                                        rowValue = rowInfo;
                                }
                                rowHeader[count] = rowValue;
                            }
                            var columnValue = "", headerInfo;
                            var colHeadRCnt = this.element.find('tr:has(".colheader")').length - 1;
                            measureColumn = colHeadRCnt;
                            curCelPos = cellInfo[count].Index;
                            if ((curCelPos != undefined) && (curCelPos == this.getJSONRecords()[parseInt((parseInt(curCelPos.split(",")[0]) * this._rowCount) + parseInt(curCelPos.split(",")[1]))].Index)) {
                                var colPos = parseInt(curCelPos.split(",")[0]);
                            }
                            for (var rCnt = 0; rCnt <= colHeadRCnt; rCnt++) {
                                if (colPos != null)
                                    if ((colPos + "," + rCnt) == (this.getJSONRecords()[parseInt((parseInt(colPos) * this._rowCount) + rCnt)].Index)) {
                                        headerInfo = this.getJSONRecords()[parseInt((parseInt(colPos) * this._rowCount) + rCnt)].Value;
                                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                                            for (var i = colPos; i >= 0; i--) {
                                                if ($("#" + this._id).find("th[p*='" + i + "," + rCnt + "']").length > 0) {
                                                    headerInfo = $("#" + this._id).find("th[p*='" + i + "," + rCnt + "']").find(".expand").length > 0 ? headerInfo.replace(this._getLocalizedLabels("Total"), "") : headerInfo;
                                                    break;
                                                }
                                            }
                                        }
                                        if (columnValue == "")
                                            columnValue = headerInfo;
                                        else if (headerInfo != "")
                                            columnValue = columnValue + "##" + headerInfo;
                                    }
                                colHeader[count] = columnValue;
                            }
                            count++;
                        }
                    }
                }
            }
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
            var measureValue = this.getJSONRecords()[parseInt((parseInt(tempThPos.split(",")[0]) * this._rowCount) + parseInt(tempThPos.split(",")[1]))].Info;
            while (measureValue[0] >= 0) {
                rowInfo = this.getJSONRecords()[parseInt((parseInt(measureValue.split(",")[0]) * this._rowCount) + parseInt(measureValue.split(",")[1]))].Info;
                if (rowInfo.split("::")[0].indexOf("Measures") > 0 || rowInfo.split("::")[0].indexOf("MEASURES") > 0) {
                    measureRowCount++;
                }
                rowLThPos = parseInt(rowLThPos.split(",")[0]) - 1 + "," + parseInt(rowLThPos.split(",")[1]);
            }
            var columnpos = parseInt(curCelPos.split(",")[0]);
            if (measureRowCount == 0)
                for (var colRCnt = 0; colRCnt <= measureColumn; colRCnt++) {
                    if (columnpos != null)
                        var headerValue = this.getJSONRecords()[parseInt((parseInt(columnpos) * this._rowCount) + colRCnt)].Info;
                    if (headerValue.split("::")[0].indexOf("Measures") > 0 || headerValue.split("::")[0].indexOf("MEASURES") > 0) {
                        measureColCount++;
                    }
                }
            }
            else
                measureCount = (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? (JSON.parse(this.getOlapReport()).PivotCalculations.length) : (this.model.dataSource.values.length);
            args = { JSONRecords: cellInfo, rowHeader: rowHeader, columnHeader: colHeader, measureCount: (measureRowCount > 0 ? ("Row:" + measureRowCount) : ("Column:" + measureColCount)) }
            this._trigger("cellSelection", args);
            cellInfo = rowHeader = colHeader = [];
            $("#" + this._id + "_cellSelection").remove();
            if (this.model.enableToolTip) {
                this._on(this.element, "mousemove touchmove", ".value", this._applyToolTip);
            }
            this._off(this.element, "mouseup touchend", ".value");
        },

        exportPivotGrid: function (exportOption, fileName) {
            var exportSetting = { url: "", fileName: "PivotGrid", exportMode: ej.PivotGrid.ExportMode.JSON, title: "", description: "", exportType: exportOption, controlName: this };
            this._trigger("beforeExport", exportSetting);
            var colorDetails = {
                rowCellColor: !ej.isNullOrUndefined(this.element.find(".rowheader")) ? ej.isNullOrUndefined(this.element.find(".rowheader").css("color")) ? "rgb(51, 51, 51)" : this.element.find(".rowheader").css("color") : "",
                rowCellBGColor: !ej.isNullOrUndefined(this.element.find(".rowheader")) ? ej.isNullOrUndefined(this.element.find(".rowheader").css("background-color")) ? "rgb(255, 255, 255)" : this.element.find(".rowheader").css("background-color") : "",
                columnCellColor: !ej.isNullOrUndefined(this.element.find(".colheader")) ? ej.isNullOrUndefined(this.element.find(".colheader").css("color")) ? "rgb(51, 51, 51)" : this.element.find(".colheader").css("color") : "",
                columnCellBGColor: !ej.isNullOrUndefined(this.element.find(".colheader")) ? ej.isNullOrUndefined(this.element.find(".colheader").css("background-color")) ? "rgb(255, 255, 255)" : this.element.find(".colheader").css("background-color") : "",
                valueCellColor: !ej.isNullOrUndefined(this.element.find(".value")) ? ej.isNullOrUndefined(this.element.find(".value").css("color")) ? "rgb(51, 51, 51)" : this._cFormat.length <= 0 ? this.element.find(".value").css("color") : "rgb(51, 51, 51)" : "",
                valueCellBGColor: !ej.isNullOrUndefined(this.element.find(".value")) ? ej.isNullOrUndefined(this.element.find(".value").css("background-color")) ? "rgb(255, 255, 255)" : this._cFormat.length <= 0 ? this.element.find(".value").css("background-color") : "rgb(255, 255, 255)" : "",
                summaryCellColor: !ej.isNullOrUndefined(this.element.find(".summary")) ? ej.isNullOrUndefined(this.element.find(".summary").css("color")) ? "rgb(51, 51, 51)" : this.element.find(".summary").css("color") : "",
                summaryCellBGColor: !ej.isNullOrUndefined(this.element.find(".summary")) ? ej.isNullOrUndefined(this.element.find(".summary").css("background-color")) ? "rgb(255, 255, 255)" : this.element.find(".summary").css("background-color") : ""
            };

            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode || exportSetting.exportMode == ej.PivotGrid.ExportMode.JSON) {  //this.model.layout == "excellikelayout"
                var params = {
                    args: JSON.stringify({ "pGridData": (this.exportRecords != null && this.exportRecords != "") ? this.exportRecords : null, "rowCount": this._excelLikeJSONRecords != null ? this._excelRowCount : this._rowCount, "columnCount": this._excelLikeJSONRecords != null ? Math.floor(this._excelLikeJSONRecords.length / this._excelRowCount) : this.getJSONRecords() != null ? Math.floor(this.getJSONRecords().length / this._rowCount) : 0, "fileName": ej.isNullOrUndefined(fileName) ? (ej.isNullOrUndefined(exportSetting.fileName) ? "PivotGrid" : exportSetting.fileName) : fileName, "colorSettings": colorDetails, "Formatting": this._cFormat, title: exportSetting.title, description: exportSetting.description, customObject: JSON.stringify(this.model.customObject) })
                };
                if (ej.raiseWebFormsServerEvents && ((exportOption == "excelExport" || exportOption == "wordExport" || exportOption == "pdfExport" || exportOption == "csvExport") && exportSetting.exportMode == ej.PivotGrid.ExportMode.JSON && $.trim(exportSetting.url) == "")) {
                    var serverArgs = { model: this.model, originalEventType: exportOption };
                    var clientArgs = params;
                    ej.raiseWebFormsServerEvents(exportOption, serverArgs, clientArgs);
                    setTimeout(function () {
                        ej.isOnWebForms = true;
                    }, 1000);
                }
                else
                    this.doPostBack($.trim(exportSetting.url) != "" ? exportSetting.url : exportOption, params);
            }
            else {
                var report;
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                var params = {
                    args: JSON.stringify({
                        exportOption: exportOption,
                        currentReport: report,
                        layout: this.layout(),
                        colorSettings: colorDetails != undefined ? JSON.stringify(colorDetails) : "",
                        customObject: JSON.stringify(this.model.customObject),
                        title: exportSetting.title,
                        description: exportSetting.description
                    })
                };
                this.doPostBack($.trim(exportSetting.url) != "" ? exportSetting.url : this.model.url + "/" + this.model.serviceMethodSettings.exportPivotGrid, params);
            }
        },

        _createCalculatedField: function () {
            ej.Pivot.openPreventPanel(this);
            this.element.find(".calculatedFieldPopup", ".clientDialog", ".e-dialog").remove();
            dialogTitle = this._getLocalizedLabels("CalculatedField");
            var nameLabel = ej.buildTag("label#" + this._id + "_lblCalFieldName", this._getLocalizedLabels("Name"))[0].outerHTML;
            var calculateFieldList = ej.buildTag("span.fieldDropDown", ej.buildTag("input#" + this._id + "_calculateFieldList", "", {}, { type: 'text' })[0].outerHTML + ej.buildTag("input#" + this._id + "_calculateFieldName.calculateFieldName", "", { "margin-left": this.model.enableRTL ? "56px" : "2px", "outline": "none" }, { type: 'text' })[0].outerHTML, {})[0].outerHTML;
            var addBtn = ej.buildTag("button#" + this._id + "_btnAdd", this._getLocalizedLabels("Add"), {"margin-top":"-5px"}, { name: this._getLocalizedLabels("Add") })[0].outerHTML;
            var formulaLabel = ej.buildTag("label#" + this._id + "_lblCalFieldFormula", this._getLocalizedLabels("Formula"))[0].outerHTML;
            var formulaTextBox = ej.buildTag("input.calculatedFieldFormula#" + this._id + "_calculatedFieldFormula", "", { width: "192px", height: "27px" }, { type: 'text', disabled: "disabled" })[0].outerHTML;
            var deleteBtn = ej.buildTag("button#" + this._id + "_btnDelete", this._getLocalizedLabels("Delete"), { "margin-top": "-24px" }, { name: this._getLocalizedLabels("Delete") })[0].outerHTML;
            var fieldsLabel = ej.buildTag("label#" + this._id + "_pivotGridValueFields", this._getLocalizedLabels("Fields"))[0].outerHTML;
            var fieldCollection = ej.buildTag("ul#" + this._id + "_fieldCollection", "")[0].outerHTML;
            //  var calculatorFields = ej.buildTag("span.calculatorFields e-icon e-sigma", "", { "padding": "3px" }).attr("aria-label","calculated button")[0].outerHTML;
            var calculatorFields = ej.buildTag("button.calculatorFields", "", { "margin-left": this.model.enableRTL ? "0px" : "10px", "margin-right": this.model.enableRTL ? "10px" : "0px"})[0].outerHTML;
            var editFormula = ej.buildTag("span.editFormula e-icon e-cancel", "", { "padding": "3px", "margin-left": "-54px", "margin-right": this.model.enableRTL ?"-54px":"0px","position":"relative"}).attr("aria-label","cancel")[0].outerHTML;
            var insertButton = ej.buildTag("span", ej.buildTag("button#" + this._id + "_btnInsert", this._getLocalizedLabels("InsertField"), {}, { name: this._getLocalizedLabels("InsertField") })[0].outerHTML, { "margin-right": "150px", "margin-left": "150px" })[0].outerHTML;

            var okBtn = ej.buildTag("button#" + this._id + "_btnOk", this._getLocalizedLabels("OK"), { "margin-left": "10px", }, { name: this._getLocalizedLabels("OK") })[0].outerHTML;
            var cancelBtn = ej.buildTag("button#" + this._id + "_btnCancel", this._getLocalizedLabels("Cancel"), { "margin-left": this.model.enableRTL ? "0px" : "10px", }, { name: this._getLocalizedLabels("Cancel") })[0].outerHTML;
            dialogFooter = ej.buildTag("div", okBtn + cancelBtn, { "float": this.model.enableRTL ? "left" : "right", "margin-bottom": "15px", "margin-top": "4px" })[0].outerHTML;

            var calculatorDiv = ej.buildTag("div.calcFormulaDiv", ej.buildTag("table", ej.buildTag("tbody",
                               ej.buildTag("tr", ej.buildTag("td", "+")[0].outerHTML + ej.buildTag("td", "-")[0].outerHTML + ej.buildTag("td", "*")[0].outerHTML + ej.buildTag("td", "/")[0].outerHTML)[0].outerHTML +
                               ej.buildTag("tr", ej.buildTag("td", "7")[0].outerHTML + ej.buildTag("td", "8")[0].outerHTML + ej.buildTag("td", "9")[0].outerHTML + ej.buildTag("td", "%")[0].outerHTML)[0].outerHTML +
                               ej.buildTag("tr", ej.buildTag("td", "4")[0].outerHTML + ej.buildTag("td", "5")[0].outerHTML + ej.buildTag("td", "6")[0].outerHTML + ej.buildTag("td", "^")[0].outerHTML)[0].outerHTML +
                               ej.buildTag("tr", ej.buildTag("td", "1")[0].outerHTML + ej.buildTag("td", "2")[0].outerHTML + ej.buildTag("td", "3")[0].outerHTML + ej.buildTag("td", "(")[0].outerHTML)[0].outerHTML +
                               ej.buildTag("tr", ej.buildTag("td", ".")[0].outerHTML + ej.buildTag("td", "0")[0].outerHTML + ej.buildTag("td", "C")[0].outerHTML + ej.buildTag("td", ")")[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML, { "display": "none" })[0].outerHTML;

            var dialogContent = ej.buildTag("div#calculatedField.dlgCalculatedField", "<table class=\"outerTable\"><tr><td>" + nameLabel + "</td><td>" + calculateFieldList + "</td><td>" + addBtn + "</td></tr>" + "<tr><td>" + formulaLabel + "</td><td>" + formulaTextBox + calculatorFields + editFormula + "</td><td>" + deleteBtn + "</td></tr></table>" +"<p class=\"borderLine\"></p>"+ "<table class=\"fieldTable\"><tr><td>" + fieldsLabel + "</td></tr><tr><td>" + fieldCollection + "</td></tr><tr><td>" + insertButton + "</td></tr></table>")[0].outerHTML,
            ejDialog = ej.buildTag("div#clientDialog.clientDialog", dialogContent + dialogFooter + calculatorDiv, { "opacity": "1" }).attr("title", dialogTitle)[0].outerHTML;
            $(ejDialog).appendTo("#" + this._id);

            this.element.find(".clientDialog").ejDialog({ width: "auto", target: "#" + this._id, enableRTL: this.model.enableRTL, enableResize: false, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
            $("#" + this._id + "_btnAdd" + "," + "#" + this._id + "_btnDelete" + "," + "#" + this._id + "_btnOk" + "," + "#" + this._id + "_btnCancel").ejButton({ type: ej.ButtonType.Button, width: "80", enableRTL: this.model.enableRTL });
            $("#" + this._id + "_btnInsert").ejButton({ type: ej.ButtonType.Button, enabled: false, width: "100", enableRTL: this.model.enableRTL });
            $(".calculatorFields").ejButton({ type: ej.ButtonType.Button,contentType: "imageonly", prefixIcon: "e-icon e-sigma", htmlAttributes: { title: "Click Me" }, enableRTL: this.model.enableRTL });
            $("#" + this._id + "_calculateFieldList").ejDropDownList({ width: "230px", enableRTL: this.model.enableRTL, dataSource: this._calculatedField, fields: { text: "name", value: "name" }, select: ej.proxy(this._calculatedFieldListChange, this), create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });

            var valueFields = [];
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                $(JSON.parse(this.getOlapReport()).PivotCalculations).each(function (e) { if (this.CalculationType != 8 && this.CalculationType != "Formula") valueFields.push({ fields: this.FieldName }); });
            }
            else {
                $($.grep(this.model.dataSource.values, function (item) { return ej.isNullOrUndefined(item.isCalculatedField) || item.isCalculatedField == false; })).each(function (e) { valueFields.push({ fields: this.fieldName }) });
            }

            var btnobject1 = $("#" + this._id + "_btnInsert").data("ejButton");
            if (this._calculatedField.length == 0) { $("#" + this._id + "_btnOk").ejButton("disable"); $("#" + this._id + "_btnOk").attr('disabled', 'disabled'); }
            $("#" + this._id + "_fieldCollection").ejListBox({ dataSource: valueFields, enableRTL: this.model.enableRTL, select: function () { btnobject1.enable(); }, height: "130", width: "400" });

            btnobject1.disable();
            this.element.find(".e-dialog .e-close").attr("title", this._getLocalizedLabels("Close"));

            $(".calculatorFields").click(function (evt) {
                $('div.calcFormulaDiv').removeAttr("style");
            });

            $(".editFormula").click(function (evt) {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                var index = $("#" + pGridObj._id + "_calculatedFieldFormula").val().lastIndexOf(" ");
                if ($("#" + pGridObj._id + "_calculatedFieldFormula").val() !== "" && index > 0) {
                    if (index + 1 == $("#" + pGridObj._id + "_calculatedFieldFormula").val().length)
                        $("#" + pGridObj._id + "_calculatedFieldFormula").val($("#" + pGridObj._id + "_calculatedFieldFormula").val().substring(0, index - 2));
                    else
                        $("#" + pGridObj._id + "_calculatedFieldFormula").val($("#" + pGridObj._id + "_calculatedFieldFormula").val().substring(0, index) + " ");
                }
                else
                    $("#" + pGridObj._id + "_calculatedFieldFormula").val("");
            });


            $(document).click(function (event) {
                if (($(event.target).hasClass("calculatorFields")) || $(event.target).hasClass("e-sigma") || ($(event.target).parents(".calcFormulaDiv").length > 0))
                    return;
                $('div.calcFormulaDiv').css("display", "none");
            });

            $("div.calcFormulaDiv").on("click", "td", function (evt) {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                var text = this.textContent == "C" ? $("#" + pGridObj._id + "_calculatedFieldFormula").val("") : $("#" + pGridObj._id + "_calculatedFieldFormula").val($("#" + pGridObj._id + "_calculatedFieldFormula").val() + ("+-/%^*".indexOf(this.textContent) > -1 ? " " + this.textContent + " " : this.textContent));
            });

            $("#" + this._id + "_btnInsert").click(function (evt) {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                var text = $("#" + pGridObj._id + "_fieldCollection").data("ejListBox");
                $("#" + pGridObj._id + "_calculatedFieldFormula").val($("#" + pGridObj._id + "_calculatedFieldFormula").val() + text.value());
            });

            $("#" + this._id + "_btnAdd").click(function (evt) {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                var text = $("#" + pGridObj._id + "_calculatedFieldFormula").val().split(" ");
                var index = -1;
                if ($("#" + pGridObj._id + "_calculateFieldName").val() == '' || $("#" + pGridObj._id + "_calculatedFieldFormula").val() == '') {
                    ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("EmptyField"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                    return;
                }

                for (var i = 0; i < text.length; i++) {
                    index = "+-/%^*".indexOf(text[i]) > -1 ? i : -1;
                    if (index > -1 && text.length > 0 && (text[0] == "" || text[0] == "." || text[text.length - 1] == "" || text[text.length - 1] == "." || text[index + 1] == "" || text[index + 1] == ".")) {
                        ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("NotValid"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                        return;
                    }
                    else if (text[i].indexOf("(") == (text[i].length - 1) || text[i].indexOf(")") == 0 || ($("#" + pGridObj._id + "_calculatedFieldFormula").val().replace(/[^\(_]/g, "")).length != ($("#" + pGridObj._id + "_calculatedFieldFormula").val().replace(/[^\)_]/g, "")).length) {
                        ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("NotValid"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                        return;
                    }
                }

                var valueFields = [];
                if (pGridObj.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    $(JSON.parse(pGridObj.getOlapReport()).PivotCalculations).each(function (e) { if (this.CalculationType != 8 && this.CalculationType != "Formula") valueFields.push({ fields: this.FieldName }); });
                }
                else
                    $(pGridObj.model.dataSource.values).each(function (fields) { valueFields.push({ fields: this.fieldName }) });

                text = $("#" + pGridObj._id + "_calculatedFieldFormula").val().replace(/\(|\)/g, ' ').split(" ");
                for (var i = 0; i < text.length; i++) {
                    var flag = false;;
                    for (var j = 0; j < valueFields.length; j++) {
                        if ((text[i].indexOf(valueFields[j].fields) > -1) && text[i] != valueFields[j].fields) 
                            flag = true;
                        else if (text[i] == valueFields[j].fields) {
                            flag = false;
                            break;
                        }

                    }
                    if (flag) {
                        ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("NotPresent"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                        return;
                    }
                }

                for (var i = 0; i < pGridObj._calculatedField.length; i++) {
                    if (pGridObj._calculatedField[i].name == $("#" + pGridObj._id + "_calculateFieldName").val()) {
                        if (confirm(pGridObj._getLocalizedLabels("Confirm"))) {
                            pGridObj._calculatedField[i].formula = $("#" + pGridObj._id + "_calculatedFieldFormula").val();
                            $("#" + pGridObj._id + "_calculatedFieldFormula").val("");
                            $("#" + pGridObj._id + "_calculateFieldName").val("");
                            $("#" + pGridObj._id + "_calculateFieldList").ejDropDownList({ dataSource: pGridObj._calculatedField, fields: { text: "name", value: "name" }, enableRTL: pGridObj.model.enableRTL, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
                            return;
                        } else
                            return;
                    }
                }

                pGridObj._calculatedField.push({ name: $("#" + pGridObj._id + "_calculateFieldName").val(), formula: $("#" + pGridObj._id + "_calculatedFieldFormula").val() });
                $("#" + pGridObj._id + "_calculatedFieldFormula").val("");
                $("#" + pGridObj._id + "_calculateFieldName").val("");
                $("#" + pGridObj._id + "_calculateFieldList").ejDropDownList({ dataSource: pGridObj._calculatedField, fields: { text: "name", value: "name" }, enableRTL: pGridObj.model.enableRTL, create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) } });
                if (pGridObj._calculatedField.length > 0) { $("#" + pGridObj._id + "_btnOk").ejButton("enable"); $("#" + pGridObj._id + "_btnOk").removeAttr("disabled"); }
            });

            $("#" + this._id + "_btnDelete").click(function (evt) {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                if (pGridObj._calculatedField.length == 0) { ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("CalculatedFieldNameNotFound"), pGridObj._getLocalizedLabels("Warning"), pGridObj); return; }
                var headerText = hederTag = $("#" + pGridObj._id + "_calculateFieldName").val();
                for (var i = 0; i < pGridObj._calculatedField.length; i++) {
                    if (pGridObj._calculatedField[i].name == $("#" + pGridObj._id + "_calculateFieldName").val()) {
                        if (pGridObj.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                            pGridObj.model.dataSource.values = $.grep(pGridObj.model.dataSource.values, function (value) { return value.fieldCaption != (pGridObj._calculatedField[i].name); });
                            pGridObj._calculatedField.splice(i, 1);
                            pGridObj._populatePivotGrid();
                        }

                        else {
                            pGridObj._calculatedField.splice(i, 1);
                            var report, eventArgs, filterTag;
                            for (var i = 0; i < pGridObj._pivotTableFields.length; i++) {
                                if (pGridObj._pivotTableFields[i].name == headerText) {
                                    pGridObj._pivotTableFields[i].isSelected = false;
                                    headerTag = pGridObj._pivotTableFields[i];
                                    pGridObj._pivotTableFields.splice(i, 1);
                                }
                            }
                            try {
                                report = JSON.parse(pGridObj.getOlapReport()).Report;
                            }
                            catch (err) {
                                report = pGridObj.getOlapReport();
                            }
                            filterTag = "schemaRow::" + headerTag.id + "::FILTERED";
                            if (pGridObj._schemaData == null) {
                                if (pGridObj.model.beforeServiceInvoke != null && pGridObj.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                                    pGridObj._trigger("beforeServiceInvoke", { action: "nodeStateModified", element: pGridObj.element, customObject: pGridObj.model.customObject });
                                var serializedCustomObject = JSON.stringify(pGridObj.model.customObject);
                                eventArgs = JSON.stringify({ "action": "nodeStateModified", "headerTag": JSON.stringify(headerTag), "dropAxis": "schemaValue::", "sortedHeaders": pGridObj._ascdes, "filterParams": filterTag, "currentReport": report, "valueSorting": JSON.stringify(pGridObj.model.valueSortSettings), "customObject": serializedCustomObject });
                                if (!pGridObj.model.enableDeferUpdate)
                                    pGridObj.doAjaxPost("POST", pGridObj.model.url + "/" + pGridObj.model.serviceMethodSettings.nodeStateModified, eventArgs, pGridObj._nodeStateModifiedSuccess);
                                else {
                                    pGridObj.doAjaxPost("POST", pGridObj.model.url + "/" + pGridObj.model.serviceMethodSettings.nodeStateModified, eventArgs.replace("nodeStateModified", "nodeStateModifiedDeferUpdate"), pGridObj._nodeStateModifiedSuccess);
                                }
                            }
                        }
                        if (pGridObj._schemaData != null) {
                            var schemaUncheck = pGridObj._schemaData._tableTreeObj.element.find("li[id='" + headerText + "']");
                            pGridObj._schemaData._tableTreeObj.uncheckNode(schemaUncheck);
                            pGridObj._schemaData._tableTreeObj.model.beforeDelete = null;
                            pGridObj._schemaData._tableTreeObj.removeNode(schemaUncheck);
                            pGridObj._schemaData._tableTreeObj.model.beforeDelete = function () { return false };
                        }
                    }
                    else if (i == pGridObj._calculatedField.length - 1) { ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("CalculatedFieldNameNotFound"), pGridObj._getLocalizedLabels("Warning"), pGridObj); return; }
                }
            });

            $("#" + this._id + "_btnOk").click(function (evt) {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                if (pGridObj.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode)
                    pGridObj.model.dataSource.values = $.grep(pGridObj.model.dataSource.values, function (value) { return ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false; });
                for (var i = 0; i < pGridObj._calculatedField.length; i++) {
                    var items = pGridObj._calculatedField[i].formula.replace(/\(|\)/g, " ").replace(/[-+*/^%]/g, " ").split(" ");
                    for (var k = 0; k < items.length; k++) {
                        if (!$.isNumeric(items[k]) && items[k].replace(/\s+|\s+$/gm, "") != "") {
                            var isPresent = pGridObj.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? $.grep(JSON.parse(pGridObj.getOlapReport()).PivotCalculations, function (value) { return value.FieldName == items[k] }).length : $.grep(pGridObj.model.dataSource.values, function (value) { return value.fieldName == items[k] }).length;
                            if (isPresent == 0) {
                                ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("NotPresent"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                                return;
                            }
                        }
                    }
                    var formula = pGridObj._calculatedField[i].formula.replace(/\s+|\s+$/gm, '');
                    formula = pGridObj._parenthesisAsterisk(formula);
                    if (pGridObj.model.operationalMode != ej.PivotGrid.OperationalMode.ServerMode) {
                        if ($.grep(pGridObj.model.dataSource.values, function (item) { if (item.fieldName == pGridObj._calculatedField[i].name) { item.formula = pGridObj._calculatedField[i].formula; } return item.fieldName == pGridObj._calculatedField[i].name }).length == 0) {
                            pGridObj.model.dataSource.values.push({ fieldName: pGridObj._calculatedField[i].name, fieldCaption: pGridObj._calculatedField[i].name, isCalculatedField: true, formula: formula });
                            if (pGridObj._schemaData != null && pGridObj._schemaData._tableTreeObj.element.find("li[id='" + pGridObj._calculatedField[i].name + "']").find(".e-chk-inact").length > 0)
                                pGridObj._schemaData._tableTreeObj.checkNode(pGridObj._calculatedField[i].name);
                        }
                    }
                }
                pGridObj.element.find(".e-dialog, .clientDialog").remove();
                ej.Pivot.closePreventPanel(pGridObj);
                if (pGridObj.model.operationalMode != ej.PivotGrid.OperationalMode.ServerMode)
                    pGridObj._populatePivotGrid();
                else
                {
                    if (!ej.isNullOrUndefined(pGridObj._waitingPopup))
                        pGridObj._waitingPopup.show();
                    try {
                        report = JSON.parse(pGridObj.getOlapReport()).Report;
                    }
                    catch (err) {
                        report = pGridObj.getOlapReport();
                    }
                    if (pGridObj.model.beforeServiceInvoke != null)
                        pGridObj._trigger("beforeServiceInvoke", { action: "calculatedField", element: pGridObj.element, customObject: pGridObj.model.customObject });
                    var serializedCustomObject = JSON.stringify(pGridObj.model.customObject);
                    eventArgs = JSON.stringify({ "action": "calculatedField", "headerTag": JSON.stringify(pGridObj._calculatedField), "currentReport": report, "valueSorting": JSON.stringify(pGridObj.model.valueSortSettings), "customObject": serializedCustomObject });
                    if (!pGridObj.model.enableDeferUpdate)
                        pGridObj.doAjaxPost("POST", pGridObj.model.url + "/" + pGridObj.model.serviceMethodSettings.calculatedField, eventArgs, pGridObj._schemaData == null ? pGridObj._renderControlSuccess : pGridObj._schemaCalculatedField);
                    else {
                        if (!ej.isNullOrUndefined(pGridObj._waitingPopup))
                            pGridObj._waitingPopup.hide();
                        pGridObj.doAjaxPost("POST", pGridObj.model.url + "/" + pGridObj.model.serviceMethodSettings.calculatedField, eventArgs.replace("calculatedField", "calculatedFieldDeferUpdate"), pGridObj._schemaData == null ? pGridObj._renderControlSuccess : pGridObj._schemaCalculatedField);
                    }
                }
            });

            $("#" + this._id + "_btnCancel").click(function () {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                pGridObj.element.find(".e-dialog, .clientDialog").remove();
                ej.Pivot.closePreventPanel(pGridObj);
            });
            this._curFocus.field = this.element.find(".e-dialog .calculateFieldName").attr("tabindex", "-1").focus().addClass("hoverCell");
        },

        _schemaCalculatedField: function (msg) {
                this._schemaData._tableTreeObj.model.nodeCheck = null;
                this._schemaData._tableTreeObj.model.nodeUncheck = null;
                for (var i = 0; i < this._calculatedField.length; i++) {
                    var treeObj = this._schemaData.element.find(".schemaFieldTree").data("ejTreeView");
                    if (this._schemaData._tableTreeObj.element.find("li[id='" + this._calculatedField[i].name + "']").length == 0) {
                        var item;
                        if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode)
                            item = { id: this._calculatedField[i].name, name: this._calculatedField[i].name, caption: this._calculatedField[i].name, isSelected: true, spriteCssClass: "" }
                        else
                            item = { id: this._calculatedField[i].name, name: this._calculatedField[i].name, isSelected: true, calculationType: 8, formula: this._calculatedField[i].formula, summaryType: 6, format: null, allowRunTimeGroupByField: "false", pivotType: "PivotComputationInfo", spriteCssClass: "" };
                        this._pivotTableFields.push(item);
                        if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode)
                            this._pivotTableFields = ej.PivotAnalysis.getTreeViewData(this.model.dataSource);
                        this._schemaData._setTableFields(this._pivotTableFields);
                        treeObj.addNode(item);
                        this._schemaData._tableTreeObj.element.find(".e-item").css("padding", "0px");

                    }
                    else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this._schemaData != null && this._schemaData._tableTreeObj.element.find("li[id='" + this._calculatedField[i].name + "']").find(".e-chk-inact").length > 0)
                        this._schemaData._tableTreeObj.checkNode(this._calculatedField[i].name);
                    else
                        this._schemaData._tableTreeObj.element.find("li[id='" + this._calculatedField[i].name + "']").removeClass("filter").find(".treeDrop , .filter").remove();
                }
                this._schemaData.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
                
                this._schemaData._tableTreeObj.model.nodeCheck = this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? ej.proxy(this._schemaData._checkedStateModified, this._schemaData) : ej.proxy(this._schemaData._pivotCheckedStateModified, this._schemaData);
                this._schemaData._tableTreeObj.model.nodeUncheck = this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? ej.proxy(this._schemaData._checkedStateModified, this._schemaData) : ej.proxy(this._schemaData._pivotCheckedStateModified, this._schemaData);
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    if (!this.model.enableDeferUpdate)
                        this._renderControlSuccess(msg);
                    else {
                        this._isUpdateRequired = true;
                        this._deferUpdateSuccess(msg);
                    }
                }
                $(this._schemaData.element.find(".schemaValue .pivotButton")).each(function () { $(this).remove(); });
                if (!ej.isNullOrUndefined(this._pivotClientObj) && typeof (this._pivotClientObj._pivotSchemaDesigner) != "undefined") {
                    this._schemaData._refreshPivotButtons();
                }
                else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    report = JSON.parse(this.getOlapReport());
                    for (var i = 0; i < report.PivotCalculations.length; i++)
                        this._schemaData._createPivotButton({ fieldName: report.PivotCalculations[i].FieldName, fieldCaption: report.PivotCalculations[i].FieldHeader}, "value", "", "", "");
                }
                else {
                    for (var i = 0; i < this.model.dataSource.values.length; i++)
                        this._schemaData._createPivotButton({ fieldName: this.model.dataSource.values[i].fieldName, fieldCaption: this.model.dataSource.values[i].fieldCaption }, "value", "", "", "");
                }
                this._schemaData._setPivotBtnWidth();
        },

        _calculatedFieldListChange: function (e) {
            $("#" + this._id + "_calculateFieldName").val(e.selectedText);
            for (var i = 0; i < this._calculatedField.length; i++) {
                if (this._calculatedField[i].name == e.selectedText)
                    $("#" + this._id + "_calculatedFieldFormula").val(this._calculatedField[i].formula);
            }
        },

        _parenthesisAsterisk: function (formula) {
            for (var j = 1; j < formula.length - 1; j++) {
                if (formula[j] == "(" && "+-/%^*(".indexOf(formula[j - 1]) == -1) {
                    formula = formula.substring(0, j) + "*" + formula.substring(j);
                    j--;
                }
                if (formula[j] == ")" && "+-/%^*)".indexOf(formula[j + 1]) == -1) {
                    formula = formula.substring(0, j + 1) + "*" + formula.substring(j + 1);
                    j--;
                }
            }
            return formula;
        },

        _calcFieldNodeDrop:function(droppedItem){
                var schemaRemoveElement = $.grep(this.model.dataSource.values, function (value) {
                    return value.isCalculatedField == true && value.formula.indexOf(droppedItem.fieldName) > -1;
                });
                for (var i = 0; i < schemaRemoveElement.length; i++)
                    this._schemaData._tableTreeObj.uncheckNode(schemaRemoveElement[i].fieldName);
        },

        _schemaButtonCreate:function(){

            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                $(this._schemaData.element.find(".schemaValue .pivotButton")).each(function () { $(this).remove(); });
                report = JSON.parse(this.getOlapReport());
                for (var i = 0; i < report.PivotCalculations.length; i++)
                    this._schemaData._createPivotButton({ fieldName: report.PivotCalculations[i].FieldName, fieldCaption: report.PivotCalculations[i].FieldHeader }, "value", "", "", "");
            }
            this._schemaData._setPivotBtnWidth();
        },

        _calculatedFieldNodeRemove: function (headerTag) {
        
            var removeElement = $.grep(JSON.parse(this.getOlapReport()).PivotCalculations, function (value) { return value.CalculationType == 8 && value.Formula.indexOf(headerTag["id"]) > -1; })
            for (var i = 0; i < removeElement.length; i++) {
                this._schemaData._tableTreeObj.model.nodeUncheck = null;
                this._schemaData._tableTreeObj.uncheckNode(removeElement[i].FieldName);
                this._schemaData._tableTreeObj.element.find("li[id='" + removeElement[i].FieldName + "']").removeClass("filter").find(".treeDrop").remove()
                this._schemaData._tableTreeObj.model.nodeUncheck = ej.proxy(this._schemaData._checkedStateModified, this._schemaData);
            }
        },
		
		createConditionalDialog: function() {
			this.openConditionalFormattingDialog();
		},

        openConditionalFormattingDialog: function () {
            if (!this.model.enableConditionalFormatting)
                return false;
            ej.Pivot.openPreventPanel(this);
            this.element.find(".e-dialog").remove();
            var ejDialog = ej.buildTag("div#" + this._id + "_clientDlg.clientDialog", { "opacity": "1" })[0].outerHTML;
            var dialogContent; var dialogTitle; var currentTag;
            var ddlBackColor, ddlBorderColor, ddlBorderStyle, ddlBorderWidth, ddlFont, ddlFontSize, ddlEditCondition, ddlConditionTYpe, removeBtn, okBtn, cancelBtn;
            dialogTitle = this._getLocalizedLabels("ConditionalFormatting");
            var conditionLbl = ej.buildTag("label#" + this._id + "_conLbl.conditionLbl", this._getLocalizedLabels("Condition"))[0].outerHTML;
            var conditionDropDown = ej.buildTag("input#" + this._id + "_conType.conditionType", "", {}, { type: 'text', tabindex: 0, accesskey: 'f' })[0].outerHTML;
            var editcondition = ej.buildTag("label#" + this._id + "_editcond.editcondition", this._getLocalizedLabels("Editcondtion"))[0].outerHTML;
            var value1Lbl = ej.buildTag("label#" + this._id + "_value1.value1", this._getLocalizedLabels("Value1"))[0].outerHTML;
            var value2Lbl = ej.buildTag("label#" + this._id + "_value2.value2", this._getLocalizedLabels("Value2"))[0].outerHTML;
            var backcolorLbl = ej.buildTag("label#" + this._id + "_backcolorLbl.backcolorLbl", this._getLocalizedLabels("Backcolor"))[0].outerHTML;
            var bordercolorLbl = ej.buildTag("label#" + this._id + "_bordercolorLbl.bordercolorLbl", this._getLocalizedLabels("Bordercolor"))[0].outerHTML;
            var borderrangeLbl = ej.buildTag("label#" + this._id + "_borderrangeLbl.borderrangeLbl", this._getLocalizedLabels("Borderrange"))[0].outerHTML;
            var borderstyleLbl = ej.buildTag("label#" + this._id + "_borderstyleLbl.borderstyleLbl", this._getLocalizedLabels("Borderstyle"))[0].outerHTML;
            var fStyleLbl = ej.buildTag("label#" + this._id + "_fStyleLbl.fStyleLbl", this._getLocalizedLabels("Fontstyle"))[0].outerHTML;
            var fSizeLbl = ej.buildTag("label#" + this._id + "_fSizeLbl.fSizeLbl", this._getLocalizedLabels("Fontsize"))[0].outerHTML;
            var fValueLbl = ej.buildTag("label#" + this._id + "_fValueLbl.fValueLbl", this._getLocalizedLabels("Measures"))[0].outerHTML;
            var editconditionDropDown = ej.buildTag("input#" + this._id + "_editCon.editconditionDropDown", "", {}, { type: 'text', tabindex: 1, accesskey: 'e' })[0].outerHTML;
            var removeBtn = ej.buildTag("button#" + this._id + "_removeBtn.dialogremoveBtn e-icon", "", {}, { name: this._getLocalizedLabels("Remove") }).attr("role", "button").attr("aria-label", "remove")[0].outerHTML;
            var value1 = ej.buildTag("input#" + this._id + "_conFrom.conditionFrom" + (ej.isMobile() ? " inputConditionMbl" : ""), "", {}, { name: 'inputVal', type: ej.isMobile() ? 'number' : 'text', inputmode: ej.isMobile() ? 'numeric' : '', pattern: ej.isMobile() ? '[0-9]*' : '', tabindex: 2 })[0].outerHTML;
            var value2 = ej.buildTag("input#" + this._id + "_conTo.conditionTo" + (ej.isMobile() ? " inputConditionMbl" : ""), "", {}, { name: 'inputVal', type: ej.isMobile() ? 'number' : 'text', inputmode: ej.isMobile() ? 'numeric' : '', pattern: ej.isMobile() ? '[0-9]*' : '', tabindex: 3 })[0].outerHTML;
            var backcolor = ej.buildTag("input#" + this._id + "_backcolor.backcolor", "", {}, { type: 'text', tabindex: 4, accesskey: 'b' })[0].outerHTML;
            var bordercolor = ej.buildTag("input#" + this._id + "_bordercolor.bordercolor", "", {}, { type: 'text', tabindex: 5, accesskey: 'c' })[0].outerHTML;
            var borderrange = ej.buildTag("input#" + this._id + "_borderrange.borderrange", "", {}, { type: 'text', tabindex: 6, accesskey: 'r' })[0].outerHTML;
            var borderstyle = ej.buildTag("input#" + this._id + "_borderstyle.borderstyle", "", {}, { type: 'text', tabindex: 7, accesskey: 's' })[0].outerHTML;
            var fStyle = ej.buildTag("input#" + this._id + "_fStyle.fStyle", "", {}, { type: 'text', tabindex: 8, accesskey: 'o' })[0].outerHTML;
            var fSize = ej.buildTag("input#" + this._id + "_fSize.fSize", "", {}, { type: 'text', tabindex: 9, accesskey: 'l' })[0].outerHTML;
            var fValue = ej.buildTag("input#" + this._id + "_fValue.fValue", "", {}, { type: 'text', tabindex: 10, accesskey: 'v' })[0].outerHTML;
            var conditionDiv = ej.buildTag("div#" + this._id + "_conditionDlg.conditionDlg", "<table class='conditionformatTbl'><tr><td>" + conditionLbl + "</td><td>" + conditionDropDown + "</td><td>" + editcondition + "</td><td>" + editconditionDropDown + "</td><td>" + removeBtn + "</td></tr><tr><td>" + value1Lbl + "</td><td>" + value1 + "</td><td>" + value2Lbl + "</td><td>" + value2 + "</td></tr><tr><td>" + backcolorLbl + "</td><td>" + backcolor + "</td><td>" + borderrangeLbl + "</td><td>" + borderrange + "</td></tr><tr><td>" + bordercolorLbl + "</td><td>" + bordercolor + "</td><td>" + borderstyleLbl + "</td><td>" + borderstyle + "</td></tr><tr><td>" + fStyleLbl + "</td><td>" + fStyle + "</td><td>" + fSizeLbl + "</td><td>" + fSize + "</td></tr><tr><td>" + fValueLbl + "</td><td>" + fValue + "</td></tr></table>")[0].outerHTML;
            dialogContent = conditionDiv;
            var OKBtn = ej.buildTag("button#" + this._id + "_OKBtn.dialogOKBtn", "", {}, { name: this._getLocalizedLabels("OK") })[0].outerHTML;
            var CancelBtn = ej.buildTag("button#" + this._id + "_CancelBtn.dialogCancelBtn", "", {}, { name: this._getLocalizedLabels("Cancel") })[0].outerHTML;
            dialogFooter = ej.buildTag("div", OKBtn + CancelBtn, { "float": this.model.enableRTL ? "left" : "right", "margin": "20px 39px 6px" })[0].outerHTML;
            $("#" + this._id).after(ejDialog);

            $("#" + this._id + "_clientDlg").append(dialogContent + dialogFooter);

            $("#" + this._id + "_clientDlg").ejDialog({ width: "auto", target: "#" + this._id, enableResize: false, enableRTL: this.model.enableRTL, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
            $(".e-titlebar").prepend(ej.buildTag("div", dialogTitle, { "display": "inline" })[0].outerHTML)[0];
            $("#" + this._id + "_OKBtn" + "," + "#" + this._id + "_CancelBtn" + "," + "#" + this._id + "_removeBtn").ejButton({ type: ej.ButtonType.Button });
            $("#" + this._id + "_OKBtn" + "," + "#" + this._id + "_CancelBtn").css({ margin: "0 0 0 10px", width: "67px" });
            $("#" + this._id + "_removeBtn").css({ width: "29px", height: "29px" });
            $("#" + this._id + "_conFrom" + "," + "#" + this._id + "_conTo").css({ width: "200px", height: "26px" });
            $("#" + this._id + "_conditionDlg").css({ margin: "13px 0 0 0" });
            $("#" + this._id + "_editcond" + "," + "#" + this._id + "_value2" + "," + "#" + this._id + "_borderrangeLbl" + "," + "#" + this._id + "_borderstyleLbl" + "," + "#" + this._id + "_fSizeLbl").css({ margin: "0 0 0 15px" });

            $("#" + this._id + "_conTo").attr("disabled", "disabled");
            this.removeBtn = $("#" + this._id + "_removeBtn").data("ejButton");
            okBtn = $("#" + this._id + "_OKBtn").data("ejButton");
            cancelBtn = $("#" + this._id + "_CancelBtn").data("ejButton");
            this.removeBtn.setModel({ "enabled": false });
            okBtn.setModel({ text: this._getLocalizedLabels("OK") });
            cancelBtn.setModel({ text: this._getLocalizedLabels("Cancel") });
            $("#" + this._id + "_conType").ejDropDownList({
                change: "_activeConditionChange",
                dataSource: [{ option: "Less Than", value: this._getLocalizedLabels("LessThan") },
                             { option: "Less Than Or Equal To", value: this._getLocalizedLabels("LessThanOrEqualTo") },
                             { option: "Greater Than", value: this._getLocalizedLabels("GreaterThan") },
                             { option: "Greater Than Or Equal To", value: this._getLocalizedLabels("GreaterThanOrEqualTo") },
                             { option: "Equals", value: this._getLocalizedLabels("Equals") },
                             { option: "Not Equals", value: this._getLocalizedLabels("NotEquals") },
                             { option: "Between", value: this._getLocalizedLabels("Between") },
                             { option: "Not Between", value: this._getLocalizedLabels("NotBetween") },
                            ],
                fields: { text: "value", value: "option" },
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_editCon").ejDropDownList({
                change: "_editConditionChange",
                dataSource: this._list,
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_backcolor").ejDropDownList({
                dataSource: [{ option: "AliceBlue", value: this._getLocalizedLabels("AliceBlue") },
                             { option: "Black", value: this._getLocalizedLabels("Black") },
                             { option: "Blue", value: this._getLocalizedLabels("Blue") },
                             { option: "Brown", value: this._getLocalizedLabels("Brown") },
                             { option: "Gold", value: this._getLocalizedLabels("Gold") },
                             { option: "Green", value: this._getLocalizedLabels("Green") },
                             { option: "Lime", value: this._getLocalizedLabels("Lime") },
                             { option: "Maroon", value: this._getLocalizedLabels("Maroon") },
                             { option: "Orange", value: this._getLocalizedLabels("Orange") },
                             { option: "Pink", value: this._getLocalizedLabels("Pink") },
                             { option: "Red", value: this._getLocalizedLabels("Red") },
                             { option: "Violet", value: this._getLocalizedLabels("Violet") },
                             { option: "White", value: this._getLocalizedLabels("White") },
                             { option: "Yellow", value: this._getLocalizedLabels("Yellow") },
                           ],
                fields: { text: "value", value: "option" },
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_bordercolor").ejDropDownList({
                dataSource: [{ option: "AliceBlue", value: this._getLocalizedLabels("AliceBlue") },
                             { option: "Black", value: this._getLocalizedLabels("Black") },
                             { option: "Blue", value: this._getLocalizedLabels("Blue") },
                             { option: "Brown", value: this._getLocalizedLabels("Brown") },
                             { option: "Gold", value: this._getLocalizedLabels("Gold") },
                             { option: "Green", value: this._getLocalizedLabels("Green") },
                             { option: "Lime", value: this._getLocalizedLabels("Lime") },
                             { option: "Maroon", value: this._getLocalizedLabels("Maroon") },
                             { option: "Orange", value: this._getLocalizedLabels("Orange") },
                             { option: "Pink", value: this._getLocalizedLabels("Pink") },
                             { option: "Red", value: this._getLocalizedLabels("Red") },
                             { option: "Violet", value: this._getLocalizedLabels("Violet") },
                             { option: "White", value: this._getLocalizedLabels("White") },
                             { option: "Yellow", value: this._getLocalizedLabels("Yellow") },
                            ],
                fields: { text: "value", value: "option" },
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_borderrange").ejDropDownList({
                dataSource: ["1", "2", "3", "4", "5", "6", "7", "8", "9"],
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_borderstyle").ejDropDownList({
                dataSource: [{ option: "Solid", value: this._getLocalizedLabels("Solid") },
                             { option: "Dashed", value: this._getLocalizedLabels("Dashed") },
                             { option: "Dotted", value: this._getLocalizedLabels("Dotted") },
                             { option: "Double", value: this._getLocalizedLabels("Double") },
                             { option: "Groove", value: this._getLocalizedLabels("Groove") },
                             { option: "Inset", value: this._getLocalizedLabels("Inset") },
                             { option: "Outset", value: this._getLocalizedLabels("Outset") },
                             { option: "Ridge", value: this._getLocalizedLabels("Ridge") },
                             { option: "None", value: this._getLocalizedLabels("None") },
                            ],
                fields: { text: "value", value: "option" },
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_fStyle").ejDropDownList({
                dataSource: [{ option: "Algerian", value: this._getLocalizedLabels("Algerian") },
                             { option: "Arial", value: this._getLocalizedLabels("Arial") },
                             { option: "Bodoni MT", value: this._getLocalizedLabels("BodoniMT") },
                             { option: "Britannic Bold", value: this._getLocalizedLabels("BritannicBold") },
                             { option: "Cambria", value: this._getLocalizedLabels("Cambria") },
                             { option: "Calibri", value: this._getLocalizedLabels("Calibri") },
                             { option: "Courier New", value: this._getLocalizedLabels("CourierNew") },
                             { option: "DejaVu Sans", value: this._getLocalizedLabels("DejaVuSans") },
                             { option: "Forte", value: this._getLocalizedLabels("Forte") },
                             { option: "Gerogia", value: this._getLocalizedLabels("Gerogia") },
                             { option: "Impact", value: this._getLocalizedLabels("Impact") },
                             { option: "Segoe UI", value: this._getLocalizedLabels("SegoeUI") },
                             { option: "Tahoma", value: this._getLocalizedLabels("Tahoma") },
                             { option: "Times New Roman", value: this._getLocalizedLabels("TimesNewRoman") },
                             { option: "Verdana", value: this._getLocalizedLabels("Verdana") },
                             { option: "None", value: this._getLocalizedLabels("None") },
                            ],
                fields: { text: "value", value: "option" },
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            $("#" + this._id + "_fSize").ejDropDownList({
                dataSource: ["12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30"],
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            var dataSource = [],value=[],fvalue,clientValue=[];
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                if ($(this.element).parents(".e-pivotclient").length > 0) {
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        for (var i = 0; i < this._JSONRecords.length; i++) {
                            if (this._JSONRecords[i].Info.indexOf("Measures") > -1)
                                value.push(this._JSONRecords[i].Value);
                        }
                    }
                    else
                        value = JSON.parse(this._pivotClientObj.getOlapReport()).PivotCalculations;
                }
                else
                value = JSON.parse(this.getOlapReport()).PivotCalculations;
               fvalue = "FieldHeader";
            }
           else {
                fvalue = "fieldCaption";
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    value = this.model.dataSource.values;
                }
                else {
                    for (var i = 0; i < this.model.dataSource.values.length; i++) {
                        value = this.model.dataSource.values[i].measures;
                    }
                }
            }
            dataSource = value.length > 0 ? ["All"] : dataSource;
             for (var j = 0; j < value.length; j++) {
                 {
                     if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                         dataSource.push(value[j]);
                     else
                        dataSource.push(value[j][fvalue]);
                    }
                }
            
            dataSource = dataSource.length > 0 ? dataSource : ["No Measure"];
            $("#" + this._id + "_fValue").ejDropDownList({
                dataSource: dataSource,
                selectedIndices: [0],
                enableRTL: this.model.enableRTL,
                width: "200px",
                height: "30px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            this.element.find("#" + this._id + "_conType").ejDropDownList("option", "change", ej.proxy(this._activeConditionChange, this));
            this.element.find("#" + this._id + "_editCon").ejDropDownList("option", "change", ej.proxy(this._editConditionChange, this));

            this.isNewFormat = true;
            this.ddlEditCondition = $("#" + this._id + "_editCon").data("ejDropDownList");
            this.ddlConditionType = $("#" + this._id + "_conType").data("ejDropDownList");
            this.ddlFont = $("#" + this._id + "_fStyle").data("ejDropDownList");
            this.ddlFontSize = $("#" + this._id + "_fSize").data("ejDropDownList");
            this.ddlBackColor = $("#" + this._id + "_backcolor").data("ejDropDownList");
            this.ddlBorderColor = $("#" + this._id + "_bordercolor").data("ejDropDownList");
            this.ddlBorderStyle = $("#" + this._id + "_borderstyle").data("ejDropDownList");
            this.ddlBorderWidth = $("#" + this._id + "_borderrange").data("ejDropDownList");
            this.ddlFieldValue = $("#" + this._id + "_fValue").data("ejDropDownList");
            this.element.find("#" + this._id + "_conFrom" + "," + "#" + this._id + "_conTo").keypress(function (event) {
                if (event.which == 8 || event.which == 0) {
                    return true;
                }

                if (event.which < 45 || (event.which ==45 && (event.target.value != "" || (event.target.value.indexOf("-") > -1))) || event.which > 58) {
                    return false;
                }
                if ((event.which == 46 && $(this).val().indexOf('.') != -1) || event.which == 47) {
                    return false;
                }
            });
            $("#" + this._id + "_OKBtn").click(function () {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                this.ddlEditCondition = $("#" + pGridObj._id + "_editCon").data("ejDropDownList");
                if ($("#" + pGridObj._id + '_conFrom').val() == '') {
                    ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("EnterOperand1"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                }

                else if (!($("#" + pGridObj._id + "_conTo").attr("disabled")) && $("#" + pGridObj._id + '_conTo').val() == '') {
                    ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("EnterOperand2"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                }
                else if ($("#" + pGridObj._id + "_fValue").attr("disabled") && $("#" + pGridObj._id + '_fValue').val() == 'No Measure') {
                    ej.Pivot._createErrorDialog(pGridObj._getLocalizedLabels("NoMeasure"), pGridObj._getLocalizedLabels("Warning"), pGridObj);
                }
                else {
                    pGridObj._applyFormatting();
                    ej.Pivot.closePreventPanel(pGridObj);
                }
            });

            if (this.ddlEditCondition.getListData().length > 1) {
                $("#" + this._id + "_editCon").ejDropDownList("enable");
            }
            else {
                $("#" + this._id + "_editCon").ejDropDownList("disable");
                $("#" + this._id + "_editcond").css("color", "#cbcbcb");
            }
            if (this.ddlFieldValue.getListData().length == 1 && this.ddlFieldValue._selectedValue == "No Measure") {
                $("#" + this._id + "_fValue").ejDropDownList("disable");
                $("#" + this._id + "_fValueLbl").css("color", "#cbcbcb");
            }
            else {
                $("#" + this._id + "_fValue").ejDropDownList("enable");
            }
            if (this._cFormat.length > 0) {
                this.ddlEditCondition.selectItemByValue(this._cFormat[this._cFormat.length - 1].split(",")[0]);
                this._editConditionChange();
            }
            $("#" + this._id + "_removeBtn").click(function () {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                if (!pGridObj.removeBtn.option('enabled')) return;
                var condition = confirm(pGridObj._getLocalizedLabels("ConditionalFormattingConformMsg"));
                if (condition == true){
                    var Index = pGridObj.ddlEditCondition._selectedIndices[0];
                    pGridObj._removeCellFormatting(Index, condition);
                }
            });
            $("#" + this._id + "_CancelBtn").click(function () {
                var pGridObj = $(this).parents(".e-pivotgrid").data("ejPivotGrid");
                pGridObj.element.find(".e-dialog, .clientDialog").remove();
                ej.Pivot.closePreventPanel(pGridObj);
            });
            return false;
        },

        _activeConditionChange: function (args) {
            if (args.selectedValue == "Between" || args.selectedValue == "Not Between")
                $("#" + this._id + "_conTo").removeAttr("disabled");
            else {
                $("#" + this._id + "_conTo").attr("disabled", "disabled");
                $("#" + this._id + "_conTo").val("");
            }
        },

        _editConditionChange: function () {
            if (this.ddlEditCondition._selectedIndices[0] > 0) {
                var i = (this.ddlEditCondition._selectedIndices[0]) - 1;
                var array = this._cFormat[i].split(",");
                this.ddlConditionType.selectItemByValue(array[1]);
                $("#" + this._id + '_conFrom').val(array[8]);
                if (array[9] != "undefined")
                    $("#" + this._id + '_conTo').val(array[9]);
                this.ddlBackColor.selectItemByValue(array[2]);
                this.ddlBorderColor.selectItemByValue(array[3]);
                this.ddlBorderStyle.selectItemByValue(array[7]);
                this.ddlBorderWidth.selectItemByValue(array[4]);
                this.ddlFont.selectItemByValue(array[5]);
                this.ddlFontSize.selectItemByValue(array[6]);
                this.ddlFieldValue.selectItemByValue(array[10]);
                this.removeBtn.option('enabled', true);
                this._conditionTypeChange();
            }
            else {
                this.removeBtn.option('enabled', false);
                this._clearWindow();
            }
        },

        _clearWindow: function () {
            $("#" + this._id + "_clientDlg").find("#" + this._id + "_conFrom" + "," + "#" + this._id + "_conTo").val('');
            $("#" + this._id + "_conTo").disabled = true;
        },

        _conditionTypeChange: function () {
            $("#" + this._id + "_conTo").disabled = !(this.ddlConditionType._selectedIndices[0] == 4 || this.ddlConditionType._selectedIndices[0] == 5);
        },

        _removeCellFormatting: function (index, flag) {
            var Index = index;
            for (var j = 0; j < this._cFormat.length && index; j++) { 
                if (flag) {
                    j = index - 1;
                    index = 0;
                }
                for (var i = 0; i < this._JSONRecords.length; i++) {
                    this._JSONRecords[i].CSS = this._JSONRecords[i].CSS.replace(" " + this._cFormat[j].split(",")[0], "");
                }
            }
            if (flag) {
                this._cFormat.splice(Index - 1, 1);
                this._list.splice(Index, 1);
            }
            else {
                this._cFormat = [];
                this._list = [];
            }
            this.renderControlFromJSON();
        },

        _applyStyle: function(axis,jsonValue,mValue,val,fv1,fv2,condition,i,format){
            var css = jsonValue.CSS, isValue = false;
            var value = axis == "rows" ? jsonValue.Index.split(",")[1] : axis == "columns" ? jsonValue.Index.split(",")[0] : null;
            if (jsonValue.Value == mValue || mValue == "All") {
                $.inArray(Number(value), val) == -1 ? val.push(Number(value)) : val;
            }
            var num = $.isNumeric(jsonValue.Value) == true ? jsonValue.Value : jsonValue.Value.replace(/[^\d.]/g, '');
            $.inArray(Number(value), val) != -1 ? isValue = true : isValue = false;
            if (this._getResult(Number(fv1), Number(fv2), num, condition) && num != "" && $.isNumeric(num) && isValue && jsonValue.CSS.indexOf("value") != -1) {
                jsonValue.CSS = css + " " + format;
            }
        },

        _refreshCellFormatting: function (jsonObj) {
            var axis = this._getAxis();
            var isValue = false;
            for (var j = 0; j < this._cFormat.length; j++) {
                var val = [];
                var array = this._cFormat[j].split(",");
                for (var i = 0; i < jsonObj.length; i++) {
                    if (jsonObj[i].CSS.indexOf(array[0]) === -1) {
                        this._applyStyle(axis, jsonObj[i], array[10], val, array[8], array[9], array[1], i, this._cFormat[j].split(",")[0]);
                    }
                }
            }
            return jsonObj;
        },

        _createDynamicRule: function (bgcolor, borderstyle, borderwidth, bordercolor, fontsize, fontstyle, name) {
            var sheet = (function () {
                var style = document.createElement("style");
                style.appendChild(document.createTextNode(""));
                document.head.appendChild(style);
                return style.sheet;
            })();
            var str = "background-color: " + bgcolor + " !important;border:" + borderstyle + " " + borderwidth + "px " + bordercolor + " !important;font:" + fontsize + "px " + fontstyle + " !important;"
            sheet.insertRule("." + name +"{"+str+"}",0);
        },

        _getAxis: function () {
			if(this.getOlapReport())
			{
				var field = null,axis = "";
				if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {               
				    if (this.getOlapReport() != undefined && this.getOlapReport() != "" && JSON.parse(this.getOlapReport()).PivotCalculations.length > 0 && !$(this.element).parents(".e-pivotclient").length > 0) {
				        field = JSON.parse(this.getOlapReport()).PivotCalculations[0].FieldHeader
				    }
				    else
				        field = JSON.parse(this._pivotClientObj.getOlapReport()).PivotCalculations[0].FieldHeader;
					for (var i = 0; i < this._JSONRecords.length; i++) {
						if (this._JSONRecords[i].Value == field) {
							axis = this._JSONRecords[i].CSS == "colheader" ? "columns" : this._JSONRecords[i].CSS == "rowheader" ? "rows" : "";
							break;
						}
					}
				}
				else {
					if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
						axis = "columns";
					}
					else {
						for (var i = 0; i < this.getOlapReport().values.length; i++) {
							axis = this.getOlapReport().values[i].axis;
						}	
					}
				}
			}
            return axis;
        },
        _applyCodeBehindFormatting: function (jsonObj) {
            var st;
            var isValue = false;
            this._isFormatApply = true;
            var axis = this._getAxis();
            if (!ej.isNullOrUndefined(this.model.conditionalFormatSettings)) {
                for (var l = 0; l < this.model.conditionalFormatSettings.length; l++) {
                    var array = [];
                    array = this.model.conditionalFormatSettings[l].measures.split(",");
                    if ($.inArray(this.model.conditionalFormatSettings[l].name, this._list) == -1) {
                        for (var j = 0; j < array.length; j++) {
                            var val = [];
                            st = array[j];
                            for (var i = 0; i < jsonObj.length; i++) {
                                this._applyStyle(axis, jsonObj[i], st, val, this.model.conditionalFormatSettings[l].value.split(",")[0], this.model.conditionalFormatSettings[l].value.split(",")[1], this.model.conditionalFormatSettings[l].condition, i, this.model.conditionalFormatSettings[l].name);
                            }
                        }
                        var format = this.model.conditionalFormatSettings[l].name + "," + this.model.conditionalFormatSettings[l].condition + "," + this.model.conditionalFormatSettings[l].style.backgroundcolor + "," + this.model.conditionalFormatSettings[l].style.bordercolor + "," + this.model.conditionalFormatSettings[l].style.borderwidth + "," + this.model.conditionalFormatSettings[l].style.fontstyle + "," + this.model.conditionalFormatSettings[l].style.fontsize + "," + this.model.conditionalFormatSettings[l].style.borderstyle + "," + this.model.conditionalFormatSettings[l].value.split(",")[0] + "," + this.model.conditionalFormatSettings[l].value.split(",")[1] + "," + st;
                        this._cFormat.push(format);
                        this._list.push(this.model.conditionalFormatSettings[l].name);
                        this._createDynamicRule(this.model.conditionalFormatSettings[l].style.backgroundcolor, this.model.conditionalFormatSettings[l].style.borderstyle, this.model.conditionalFormatSettings[l].style.borderwidth, this.model.conditionalFormatSettings[l].style.bordercolor, this.model.conditionalFormatSettings[l].style.fontsize, this.model.conditionalFormatSettings[l].style.fontstyle, this.model.conditionalFormatSettings[l].name);
                    }
                }
            }
            this._JSONRecords = jsonObj;
            return jsonObj;
        },

        _applyFormatting: function () {
			this._isFormatApply = true;
            var format, formatName, json, index, st, val = [], axis;
            var isValue = false;
            if (!ej.isNullOrUndefined($("#" + this._id + '_conFrom').val())) {
                this._formatValue1 = $("#" + this._id + '_conFrom').val(), this._formatValue2 = $("#" + this._id + '_conTo').val(), cdnTxt = this.ddlConditionType._selectedValue, color = this.ddlBackColor._selectedValue, bordercolor = this.ddlBorderColor._selectedValue,
                    borderrange = this.ddlBorderWidth._selectedValue, fStyle = this.ddlFont._selectedValue, fSize = this.ddlFontSize._selectedValue, borderstyle = this.ddlBorderStyle._selectedValue, editCdn = this.ddlEditCondition._selectedValue;
            }
            st = this.ddlFieldValue._selectedValue != undefined ? this.ddlFieldValue._selectedValue : "";
            if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    for (var i = 0; i < this._JSONRecords.length; i++) {
                        if (this._JSONRecords[i].Info.indexOf("Measures") > -1) {
                            axis = this._JSONRecords[i].CSS == "colheader" ? "columns" : this._JSONRecords[i].CSS == "rowheader" ? "rows" : "";
                        }
                        if (axis != "")
                            break;
                    }
                }
                
                else {
                    field = JSON.parse(this.getOlapReport()).PivotCalculations[0].FieldHeader;
                    for (var i = 0; i < this._JSONRecords.length; i++) {
                        if (this._JSONRecords[i].Value == field) {
                            axis = this._JSONRecords[i].CSS == "colheader calc" ? "columns" : this._JSONRecords[i].CSS == "rowheader" ? "rows" : "";
                            break;
                        }
                        
                     }
                    
                }
        }
        else
            axis = this._getAxis();
            if ($("#" + this._id + "_editCon").val() == this._getLocalizedLabels("AddNew")) {
                for (var i = this._cFormat.length; i < this._cFormat.length + 1; i++) {
                    formatName = "Format" + i;
                    for (var j = i; $.inArray(formatName, this._list) != -1; j++) {
                        formatName = "Format" + j;
                    }
                }
                format = formatName + "," + this.ddlConditionType._selectedValue + "," + color + "," + bordercolor + "," + borderrange + "," + fStyle + "," + fSize + "," + borderstyle + "," + this._formatValue1 + "," + this._formatValue2 + "," + st;
                this._cFormat.push(format);
                this._list.push(formatName);
            }
            else {
                formatName = this.ddlEditCondition._selectedValue;
                index = this.ddlEditCondition._selectedIndices[0] - 1;
                this._cFormat[index] = formatName + "," + this.ddlConditionType._selectedValue + "," + color + "," + bordercolor + "," + borderrange + "," + fStyle + "," + fSize + "," + borderstyle + "," + this._formatValue1 + "," + this._formatValue2 + "," + st;
                for (var i = 0; i < this._JSONRecords.length; i++) {
                    this._JSONRecords[i].CSS = this._JSONRecords[i].CSS.replace(" " + formatName, "");
                }
            }
            for (var i = 0; i < this._JSONRecords.length; i++) {
                this._applyStyle(axis, this._JSONRecords[i], st, val, this._formatValue1, this._formatValue2, this.ddlConditionType._selectedValue, i, formatName);
            }
            this._createDynamicRule(color, borderstyle, borderrange, bordercolor, fSize, fStyle, formatName);
            this.renderControlFromJSON();
            this.element.find(".e-dialog, .clientDialog").remove();
        },

        _getResult: function (conditionalValue1, conditionalValue2, cellValue, operator) {
            switch (operator) {
                case "Less Than":
                    return cellValue < conditionalValue1;
                    break;
                case "Less Than Or Equal To":
                    if (cellValue <= conditionalValue1)
                        return cellValue;
                    break;
                case "Greater Than":
                    return cellValue > conditionalValue1;
                    break;
                case "Greater Than Or Equal To":
                    if (cellValue >= conditionalValue1)
                        return cellValue;
                    break;
                case "Equals":
                    if (cellValue == conditionalValue1)
                        return cellValue;
                    break;
                case "Not Equals":
                    return cellValue != conditionalValue1;
                    break;
                case "Between":
                    return (conditionalValue1 < conditionalValue2 && cellValue > conditionalValue1 && cellValue < conditionalValue2) ||
                    (conditionalValue1 > conditionalValue2 && cellValue < conditionalValue1 && cellValue > conditionalValue2) ||
                    (cellValue == conditionalValue1 && cellValue == conditionalValue2);
                    break;
                case "Not Between":
                    return !((conditionalValue1 < conditionalValue2 && cellValue > conditionalValue1 && cellValue < conditionalValue2) ||
                    (conditionalValue1 > conditionalValue2 && cellValue < conditionalValue1 && cellValue > conditionalValue2) ||
                    (cellValue == conditionalValue1 && cellValue == conditionalValue2));
                    break;
            }
        },

        _appendCssClassName: function (jsonObj) {
            var isVCss,isCCss,index;
            var isRow = true, isRCss = isCCss = isVCss = false, isVal = false, pos = index = -1, val, css, rows, columns, values;
            if(this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode){
                val = "FieldHeader", css = "CssClass", rows = JSON.parse(this.getOlapReport()).PivotRows, columns = JSON.parse(this.getOlapReport()).PivotColumns, values = JSON.parse(this.getOlapReport()).PivotCalculations;
            }
            else {
                val = "fieldCaption", css = "cssClass", rows = this.model.dataSource.rows, columns = this.model.dataSource.columns, values = this.model.dataSource.values;
            }
            for (var j = 0; j < rows.length && !isRCss; j++) {
                if (!ej.isNullOrUndefined(rows[j]["cssClass"]))
                    isRCss = true;
            }
            for (var j = 0; j < columns.length && !isCCss; j++) {
                if (!ej.isNullOrUndefined(columns[j]["cssClass"]))
                    isCCss = true;
            }
            for (var j = 0; j < values.length && !isVCss; j++) {
                if (!ej.isNullOrUndefined(values[j]["cssClass"]))
                    isVCss = true;
            }
            for (var i = 0; i < jsonObj.length && (isRCss || isCCss || isVCss); i++) {
                for (var j = 0; j < rows.length && isRow && isRCss; j++) {
                    if (!ej.isNullOrUndefined(rows[j][css]) && Number(jsonObj[i].Index.split(",")[0]) == j && jsonObj[i].CSS.indexOf("none") == -1 && jsonObj[i].CSS.indexOf(rows[j][css]) == -1) {
                        jsonObj[i].CSS = jsonObj[i].CSS + " " + rows[j][css];
                    }
                    if (isRow && jsonObj[i].CSS.indexOf("colheader") > -1)
                        isRow = false;
                }
                for (var j = 0; j < columns.length && isCCss; j++) {
                    if (!ej.isNullOrUndefined(columns[j][css]) && Number(jsonObj[i].Index.split(",")[1]) == j && jsonObj[i].CSS.indexOf("none") == -1 && jsonObj[i].CSS.indexOf(columns[j][css]) == -1) {
                        jsonObj[i].CSS = jsonObj[i].CSS + " " + columns[j][css];
                    }
                }
                for (var j = 0; j < values.length && isVCss; j++) {
                    if (isVal && (jsonObj[i].CSS.indexOf("colheader") > -1 || jsonObj[i].CSS.indexOf("cgtot") > -1 || jsonObj[i].CSS.indexOf("cstot") > -1 || jsonObj[i].CSS.indexOf("gtot") > -1 || jsonObj[i].CSS.indexOf("stot") > -1) && jsonObj[i].CSS.indexOf("calc") == -1)
                        isVal = false;
                    if (values[j][val] == jsonObj[i].Value) {
                        isVal = true;
                        pos = jsonObj[i].Index.split(",")[0];
                        index = j;
                    }
                    if (!ej.isNullOrUndefined(values[j][css]) && isVal && pos == jsonObj[i].Index.split(",")[0] && index == j && jsonObj[i].CSS.indexOf(values[j][css]) == -1) {
                        jsonObj[i].CSS = jsonObj[i].CSS + " " + values[j][css];
                    }
                }
            }
            return jsonObj;
        },

        _updateReportSettings: function (msg) {
            var JsonRecords = $.map(msg, function (obj, index) { if (obj.Key == "JsonRecords" || obj.Key == "PivotRecords") return obj; });
            var report = $.map(msg, function (obj, index) { if (obj.Key == "PivotReport" || obj.Key == "OlapReport") return obj; });
            var valueSorting = $.map(msg, function (obj, index) { if (obj.Key == "SortColIndex") return obj; });
            this.setJSONRecords(JsonRecords[0].Value); this.setOlapReport(report[0].Value);
            if (valueSorting.length>0) {
                ej.PivotAnalysis._valueSorting = JSON.parse(valueSorting[0].Value);
                ej.PivotAnalysis._sort = this.model.valueSortSettings.sortOrder;
            }
            else {
                ej.PivotAnalysis._valueSorting = null;
            }
        },
        _updatePageSettings: function (msg, pivotClientObj) {
            var pageSettings = $.map(msg, function (obj, index) { if (obj.Key == "PageSettings") return obj; });
            var headerSettings = $.map(msg, function (obj, index) { if (obj.Key == "HeaderCounts") return obj; });
            if (pageSettings.length > 0 && pivotClientObj._pagerObj != null) {
                pivotClientObj._pagerObj.element.css("opacity", "1");
                pivotClientObj._pagerObj.element.find(".pagerTextBox").removeAttr('disabled');
                pivotClientObj._pagerObj._unwireEvents();
                pivotClientObj._pagerObj._wireEvents();
                pivotClientObj._pagerObj.initPagerProperties(JSON.parse(headerSettings[0].Value), JSON.parse(pageSettings[0].Value));
            }
        },
        _removeCells: function (msg) {

            var FilteredColumnHeaders = [];
            var FilteredRowHeaders = [];
            var message = [];
            if (msg[0] != undefined && msg.length > 0) {
                var colHeaders = $.map(msg, function (value) { if (value.Key == "FilteredColumnHeaders") return value; });
                var rowHeaders = $.map(msg, function (value) { if (value.Key == "FilteredRowHeaders") return value; });
                if (colHeaders.length > 0)
                    FilteredColumnHeaders = JSON.parse(colHeaders[0].Value);
                if (rowHeaders.length > 0)
                    FilteredRowHeaders = JSON.parse(rowHeaders[0].Value);
            }
            else if (msg.d != undefined) {
                var colHeaders = $.map(msg.d, function (value) { if (value.Key == "FilteredColumnHeaders") return value; });
                var rowHeaders = $.map(msg.d, function (value) { if (value.Key == "FilteredRowHeaders") return value; });
                if (colHeaders.length > 0)
                    FilteredColumnHeaders = JSON.parse(colHeaders[0].Value);
                if (rowHeaders.length > 0)
                    FilteredRowHeaders = JSON.parse(rowHeaders[0].Value);
            }
            else {
                if (msg.FilteredColumnHeaders)
                    FilteredColumnHeaders = JSON.parse(msg.FilteredColumnHeaders);
                if (msg.FilteredRowHeaders)
                    FilteredRowHeaders = JSON.parse(msg.FilteredRowHeaders);
            }
            if (FilteredColumnHeaders.length > 0) {
                var hiddenCells = FilteredColumnHeaders;
                for (var i = 0; i < hiddenCells.length; i++) {
                    for (var j = hiddenCells[i].From; j <= hiddenCells[i].To; j++) {
                        for (var rc = hiddenCells[i].Level; rc < this._rowCount; rc++)
                            this.element.find(".pivotGridTable  [p='" + (j) + "," + rc + "']").remove();
                    }
                }
                var rowHeaders = this.element.find(".pivotGridTable thead").children();
                for (var rw = (rowHeaders.length - 2) ; rw >= 0 ; rw--) {
                    var vsHeaders = ($(rowHeaders[rw]).find("th.colheader:visible"));
                    for (var rH = 0 ; rH <= vsHeaders.length - 1; rH++) {
                        var thColSpan = $(vsHeaders[rH]).attr("colSpan");
                        for (var rc = 0; rc <= (parseInt($(vsHeaders[rH]).attr("colSpan")) - 1) ; rc++) {
                            var colNav = parseInt($(vsHeaders[rH]).attr("p").split(",")[0]) + rc;
                            var visibleCells = (this.element.find(".pivotGridTable  [p='" + colNav + "," + (rw + 1) + "']:visible"));
                            if (!($(visibleCells).length > 0))
                                thColSpan--;
                            else
                                thColSpan = parseInt(thColSpan) + ($(visibleCells).attr("colspan") ? parseInt($(visibleCells).attr("colspan")) - 1 : 0);
                        }
                        if (thColSpan == 0 && $(vsHeaders[rH]).nextAll(".summary.stot:eq(0)").length > 0) {
                            var rowHeadCells = $(vsHeaders[rH]).nextAll(".summary.stot:eq(0)").attr("p").split(",")[0];
                            var hiddenSpanCells = [], hiddenCells = [];
                            for (var rc = 0; rc < this._rowCount; rc++) {
                                var selector = "[p='" + parseInt(rowHeadCells) + "," + rc + "'] ";
                                hiddenCells.push(selector);

                                if (this._JSONRecords[parseInt(rowHeadCells) * this._rowCount + rc].ColSpan > 1) {
                                    if (this.element.find(".pivotGridTable [p='" + parseInt(rowHeadCells) + "," + rc + "']:visible").length > 0) {
                                        for (var st = 1; st <= (this._JSONRecords[parseInt(rowHeadCells) * this._rowCount + rc].ColSpan - 1) ; st++) {
                                            hiddenSpanCells.push(parseInt(rowHeadCells) + st);
                                        }
                                    }
                                }
                                for (hc = 0; hc < hiddenSpanCells.length; hc++)
                                    selector += ", [p='" + (hiddenSpanCells[hc]) + "," + rc + "'] ";
                                this.element.find(".pivotGridTable " + selector).remove();
                            }
                        }
                        if (ej.isNullOrUndefined($(vsHeaders[rH]).attr("vfColSpan")))
                            $(vsHeaders[rH]).attr("vfColSpan", $(vsHeaders[rH]).attr("colSpan"));
                        $(vsHeaders[rH]).attr("colSpan", thColSpan);
                    }
                }
                this.element.find(".colheader[colspan='0']:not(.gtot,.calc)").remove();
            }
            if (FilteredRowHeaders.length > 0) {
                {
                    var hiddenCells = FilteredRowHeaders, colInd = parseInt(this.element.find(".pivotGridTable td:eq(0)").attr("p").split(",")[0]) - 2;
                    for (var i = 0; i < hiddenCells.length; i++) {
                        for (var j = hiddenCells[i].From; j <= hiddenCells[i].To; j++) {
                            this.element.find(".pivotGridTable tr:eq(" + j + ") th:last").css("display", "none");
                            this.element.find(".pivotGridTable tr:eq(" + j + ") td").css("display", "none");
                        }
                    }
                    for (var k = colInd; k >= 0; k--) {
                        var rowHeaderVisibleCells = this.element.find(".pivotGridTable tbody").find((" .rowheader[p^='" + k + ",'] :visible")); //$(".pivotGridTable tbody").find((" [p^='" + colInd + ",'] :visible"));
                        var rowHeaderCells = this.element.find(".pivotGridTable th.rowheader").parent();
                        for (var ce = 0; ce <= rowHeaderVisibleCells.length; ce++) {
                            var th = $(rowHeaderVisibleCells[ce]).parent(), rowSpan = parseInt(th.attr("rowSpan")), pTag = th.attr("p");
                            if (pTag) {
                                var rowIndex = parseInt(pTag.split(",")[1]), colIndex = parseInt(pTag.split(",")[0]), spanInfo = 0;
                                for (var cc = rowIndex; cc <= (rowIndex + rowSpan) ; cc++) {
                                    var cellData = rowHeaderCells.children(" [p='" + (k + 1) + "," + cc + "']");
                                    if (cellData.length > 0 && !cellData.is(":visible"))
                                        spanInfo = spanInfo + parseInt(cellData.attr("rowSpan")) + ((cellData.next("th.rowheader").length > 0 || parseInt(cellData.attr("rowSpan")) > 1) ? 1 : 0);
                                }
                                if (spanInfo == rowSpan)
                                th.css("display", "none");
                            }
                        }
                    }
                    for (var k = 0; k < $(this.element.find(".summary.stot")).length; k++) {
                        if ($(this.element.find(".summary.stot")[k]).nextAll().text() == "") {
                            $(this.element.find(".summary.stot")[k]).css("display", "none");
                            $(this.element.find(".summary.stot")[k]).nextAll().css("display", "none");
                        }
                    }
                }
            }
            if (this.model.enableGroupingBar)
                this._createFields(null, $("#" + this._id).find(".pivotGridTable").width(), $("#" + this._id).find(".pivotGridTable th").outerWidth());
        },
        _renderControlSuccess: function (msg) {
            try {
                if (msg[0] != undefined && msg.length > 0) {
                    this._updateReportSettings(msg)
                    if (msg[2] != null && msg[2] != undefined && msg[2].Key == "PageSettings") {
                        if (this.model.enableVirtualScrolling || ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj.model.enableVirtualScrolling)) {
                            this._categPageCount = Math.ceil(JSON.parse(msg[3].Value).Column / JSON.parse(msg[2].Value).CategorialPageSize);
                            this._seriesPageCount = Math.ceil(JSON.parse(msg[3].Value).Row / JSON.parse(msg[2].Value).SeriesPageSize);
                            this._categCurrentPage = JSON.parse(msg[2].Value).CategorialCurrentPage;
                            this._seriesCurrentPage = JSON.parse(msg[2].Value).SeriesPageSize;
                        }
                        else if ($(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined && this._pagerObj!=null)
                            this._pagerObj.initPagerProperties(JSON.parse(msg[3].Value), JSON.parse(msg[2].Value));
                        if (!ej.isNullOrUndefined(msg[4])) {
                            if (msg[4].Key == "DataSet") {
                                this._dataSet = msg[4].Value;
                                if (!ej.isNullOrUndefined(msg[5]))
                                    this.model.customObject = msg[5].Value;
                            }
                            else
                                this.model.customObject = msg[4].Value;
                        }
                    }
                    if (!ej.isNullOrUndefined(msg[2]) && msg[2].Key != "PageSettings") {
                        if (msg[2].Key == "DataSet") {
                            this._dataSet = msg[2].Value;
                            if (!ej.isNullOrUndefined([3]))
                                this.model.customObject = msg[3].Value;
                        }
                        else
                            this.model.customObject = msg[2].Value;
                    }
                    if ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj._pagerObj != null) {
                        this._updatePageSettings(msg, this._pivotClientObj)
                    }
                }
                else if (msg.d != undefined && msg.d.length > 0) {
                        this._updateReportSettings(msg.d);
                    if (msg.d[2] != null && msg.d[2] != undefined && msg.d[2].Key == "PageSettings") {
                        if (this.model.enableVirtualScrolling || ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj.model.enableVirtualScrolling)) {
                            this._categPageCount = Math.ceil(JSON.parse(msg.d[3].Value).Column / JSON.parse(msg.d[2].Value).CategorialPageSize);
                            this._seriesPageCount = Math.ceil(JSON.parse(msg.d[3].Value).Row / JSON.parse(msg.d[2].Value).SeriesPageSize);
                            this._categCurrentPage = JSON.parse(msg.d[2].Value).CategorialCurrentPage;
                            this._seriesCurrentPage = JSON.parse(msg.d[2].Value).SeriesCurrentPage;
                        }
                        else if (this._pagerObj !=null && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                            this._pagerObj.initPagerProperties(JSON.parse(msg.d[3].Value), JSON.parse(msg.d[2].Value));
                        if (!ej.isNullOrUndefined(msg.d[4])) {
                            if (msg.d[4].Key == "DataSet") {
                                this._dataSet = msg.d[4].Value;
                                if (!ej.isNullOrUndefined(msg.d[5]))
                                    this.model.customObject = msg.d[5].Value;
                            }
                            else
                                this.model.customObject = msg.d[4].Value;
                        }
                        if ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj._pagerObj != null) {
                            this._updatePageSettings(msg.d, this._pivotClientObj);
                        }
                    }
                    else if ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj._pagerObj != null && (msg.d.length == 2)) {
                        this._pivotClientObj._pagerObj.element.css("opacity", "0.5");
                        this._pivotClientObj._pagerObj.element.find(".pagerTextBox").attr('disabled', 'disabled');
                        this._pivotClientObj._pagerObj._unwireEvents();
                    }
                    if (!ej.isNullOrUndefined(msg[2]) && msg.d[2].Key != "PageSettings") {
                        if (msg.d[2].Key == "DataSet") {
                            this._dataSet = msg.d[2].Value;
                            if (!ej.isNullOrUndefined([3]))
                                this.model.customObject = msg.d[3].Value;
                        }
                        else
                            this.model.customObject = msg.d[2].Value;
                    }
                }
                else if (!ej.isNullOrUndefined(msg) && ej.isNullOrUndefined(msg.d)) {
                    if (msg.SortColIndex != undefined) {
                        ej.PivotAnalysis._valueSorting = JSON.parse(msg.SortColIndex)[0];
                        ej.PivotAnalysis._sort = this.model.valueSortSettings.sortOrder;
                    }
                    else {
                        ej.PivotAnalysis._valueSorting = null;
                    }
                    if (msg.PivotRecords != undefined) {
                        this.setJSONRecords(msg.PivotRecords); this.setOlapReport(msg.OlapReport);
                        if (msg.HeaderCounts != undefined && (this.model.enableVirtualScrolling || (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.enableVirtualScrolling))) {
                            this._categPageCount = Math.ceil(JSON.parse(msg.HeaderCounts).Column / JSON.parse(msg.PageSettings).CategorialPageSize);
                            this._seriesPageCount = Math.ceil(JSON.parse(msg.HeaderCounts).Row / JSON.parse(msg.PageSettings).SeriesPageSize);
                            this._categCurrentPage = JSON.parse(msg.PageSettings).CategorialCurrentPage;
                            this._seriesCurrentPage = JSON.parse(msg.PageSettings).SeriesCurrentPage;
                        }
                        else if (msg.HeaderCounts != undefined && this._pagerObj != null && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                            this._pagerObj.initPagerProperties(JSON.parse(msg.HeaderCounts), JSON.parse(msg.PageSettings));
                        else if (msg.HeaderCounts != undefined && (!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj._pagerObj != null)
                            this._pivotClientObj._pagerObj.initPagerProperties(JSON.parse(msg.HeaderCounts), JSON.parse(msg.PageSettings));
                    }
                    else if (msg.JsonRecords != undefined && this.model.enableJSONRendering == true) {
                        this.setJSONRecords(JSON.stringify(msg.JsonRecords)); this.setOlapReport(JSON.stringify(msg.PivotReport));
                        if (msg.DataSet != null) this._dataSet = msg.DataSet;
                    }
                    else if (msg.JsonRecords != undefined) {
                        this.setJSONRecords(msg.JsonRecords); this.setOlapReport(msg.PivotReport);
                        if (msg.DataSet != null) this._dataSet = msg.DataSet;
                    }
                    else if (msg.JsonRecords == undefined) {
                        this.setJSONRecords(null);
                        if (msg.PivotReport)
                            this.setOlapReport(msg.PivotReport);
                        if (msg.OlapReport)
                            this.setOlapReport(msg.OlapReport);
                    }
                    if (msg.customObject != null && msg.customObject != undefined)
                        this.model.customObject = msg.customObject;
                }
                if (ej.isNullOrUndefined(this.getJSONRecords()) && !ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.enablePaging) {
                    var pageSettings = { CategorialCurrentPage: 1, CategorialPageSize: 1, SeriesCurrentPage: 1, SeriesPageSize: 1 };
                    var headerCount = { Column: 1, Row: 1 };
                    this._pivotClientObj._pagerObj.initPagerProperties(headerCount, pageSettings);
                }
                if (this.model.enableVirtualScrolling || ($(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined))
                    this.layout("nosummaries");
                if (this.getOlapReport() != undefined && this.getOlapReport() != "" && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                    try {
                        if (!ej.isNullOrUndefined(JSON.parse(this.getOlapReport()).DataModel))
                            this.model.analysisMode = JSON.parse(this.getOlapReport()).DataModel == "Olap" ? ej.Pivot.AnalysisMode.Olap : ej.Pivot.AnalysisMode.Pivot;
                    }
                    catch (err) {
                    }
                }
                if (this.model.enableGroupingBar == true) {
                    var report = JSON.parse(this.getOlapReport());
                    var itemProp = ej.isNullOrUndefined(report.ItemsProperties) ? [] : JSON.parse(report.ItemsProperties);
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                        var items = report.PivotRows.concat(report.PivotColumns, report.PivotCalculations, report.Filters);
                        var itemProps = $.grep(itemProp, function (value) { $.grep(items, function (field) { if (value.id == (field.FieldHeader || field.DimensionHeader)) value.id = (field.FieldName || field.DimensionName); }); return value; });
                        this._pivotTableFields = itemProps;
                    }
                    else
                        this._pivotTableFields = itemProp;
                    this._createGroupingBar(report);
                }
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    var report = JSON.parse(this.getOlapReport());
                    for (var i = 0; i < report.PivotCalculations.length; i++) {
                        if (report.PivotCalculations[i].CalculationType == 8 || report.PivotCalculations[i].CalculationType == "Formula") {
                            if ($.grep(this._calculatedField, function (field) { return field.name == report.PivotCalculations[i].FieldName; }).length == 0)
                                this._calculatedField.push({ name: report.PivotCalculations[i].FieldName, formula: report.PivotCalculations[i].Formula });
                        }
                    }
                }
                if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("afterServiceInvoke", { action: "initialize", element: this.element, customObject: this.model.customObject });
                if (this.getJSONRecords() != null && this.getJSONRecords().length > 0) {
                    if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout && this.model.enableVirtualScrolling == false && $(".e-pivotpager")[0] == null)
                        this.excelLikeLayout(this.getJSONRecords());
                    else
                    this.renderControlFromJSON(this.getJSONRecords());
                }
                else
                    this.renderControlFromJSON("");
                var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
                if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._waitingPopup != null) {
                    if ($("#" + this._pivotClientObj._id + "_maxView")[0] && this._maxViewLoading) {
                        this._maxViewLoading.hide();
                    }
                    else
                        this._pivotClientObj._waitingPopup.hide();
                }
                else
                    this._waitingPopup.hide();
                if (!ej.isNullOrUndefined(this._schemaData))
                    this._schemaData.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
            }
            catch (err) {
            }
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this._calculatedField.length > 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this._schemaData != null)
                this._schemaButtonCreate();
            var eventArgs = { action: "initialize", customObject: this.model.customObject, element: this.element };
            this._trigger("renderSuccess", eventArgs);
            if (!ej.isNullOrUndefined(msg.Exception)) {
                ej.Pivot._createErrorDialog(msg, "Exception", this);
            }
            if (this.model.enableAdvancedFilter && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                this._removeCells(msg);
        },

        _hideGrandTotal: function (tableGrid) {
            var frozenHeaderColTable = tableGrid.find(".pivotGridFrozenTable");
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                if ((!this.model.enableRowGrandTotal || !this.model.enableGrandTotal)) {
                    if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                        tableGrid.find(".rowhead tr:last").hide();
                    if (tableGrid.find("tbody").children().length > 0)
                        tableGrid.find("tr:last").hide();
                }
                if ((tableGrid.find("tr:first th.summary").attr("p") != undefined || tableGrid.find(".pivotGridFrozenTable tr:first td.summary").attr("p") != undefined) && (!this.model.enableColumnGrandTotal || !this.model.enableGrandTotal) && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var calcGTTh = [];
                    if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                        calcGTTh = (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? frozenHeaderColTable.find(".gtot[role^='columnheader']") : frozenHeaderColTable.find(".cgtot[role^='columnheader']"));
                    }
                    else
                        calcGTTh = (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? tableGrid.find("th.gtot[role^='columnheader']") : tableGrid.find("th.cgtot[role^='columnheader']"));
                    for (cLen = 0; cLen < calcGTTh.length; cLen++) {
                        tableGrid.find("[p^=\"" + (parseInt($(calcGTTh[cLen]).attr("p").split(",")[0])) + ",\"]").hide();
                        tableGrid.find("[p^=\"" + (parseInt($(calcGTTh[cLen]).attr("p").split(",")[0])) + ",\"]").hide();
                    }
                }
            }
            else {
                if (this.model.layout == "normal") {
                    var isCheckSum = true, count = 0, gTotCells;
                    if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode || this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        if (!this.model.enableColumnGrandTotal || !this.model.enableGrandTotal) {
                            rwLen = ($(tableGrid).find("thead tr").length || $(tableGrid).find(".pivotGridFrozenTable tr").length);
                            if (rwLen > 1 || (rwLen == 1 && $(tableGrid).find("th.summary[p$='," + count + "']").length > 0)) {
                                while (isCheckSum) {
                                    gTotCells = (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) ? $(tableGrid).find("td.summary[p$='," + count + "']") : $(tableGrid).find("th.summary[p$='," + count + "']");
                                    if (gTotCells.length)
                                        isCheckSum = false;
                                         count++;
                                }
                                for (var p = 0; p < gTotCells.length; p++) {
                                    var cnt = count, cols = 0, colcel;
                                    var selectedCell = gTotCells[p]; selectedCellPos = $(selectedCell).attr('p'), i = parseInt(selectedCellPos.split(',')[1]) - 1;
                                    var colspn = $(selectedCell).attr("colspan");
                                    var rowLen = $(tableGrid).find("thead tr").length + $(tableGrid).find("tbody tr").length;
                                    for (var cl = 0; cl < parseInt(colspn) ; cl++) {
                                        $(tableGrid).find(" [p^='" + (parseInt(selectedCellPos.split(',')[0]) + cl) + ",']").css("display", "none");
                                    }
                                    for (var s = 0; s < rwLen; s++) {
                                        if (this.model.frozenHeaderSettings.enableFrozenHeaders) {
                                            if ($(frozenHeaderColTable).find("tr:eq(" + s + ") td").length == 1) {
                                                var currentColspan = $(frozenHeaderColTable).find(" tr:eq(" + s + ") td").attr("colspan");
                                                $(frozenHeaderColTable).find(" tr:eq(" + s + ") td").attr("colspan", parseInt(currentColspan) - parseInt(colspn));
                                            }
                                        }
                                        else if ($(tableGrid).find("thead tr:eq(" + s + ") th").length == 1) {
                                            var currentColspan = $(tableGrid).find("thead tr:eq(" + s + ") th").attr("colspan");
                                            $(tableGrid).find("thead tr:eq(" + s + ") th").attr("colspan", parseInt(currentColspan) - parseInt(colspn))
                                        }
                                    }
                                    if (i >= 0) {
                                        var cell = $(tableGrid).find(" [p^='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                                        while (cnt > 1) {
                                            if (ej.isNullOrUndefined(cell)) {
                                                for (i = parseInt(selectedCellPos.split(',')[1]) - 1; i >= 0; i--) {
                                                    var currentCell = $(tableGrid).find("[p='" + selectedCellPos.split(',')[0] + "," + i + "']")[0];
                                                    if (ej.isNullOrUndefined(currentCell)) {
                                                        for (k = parseInt(selectedCellPos.split(',')[0]) - 1; k >= 0; k--) {
                                                            if (ej.isNullOrUndefined(currentCell)) {
                                                                currentCell = $(tableGrid).find("[p='" + k + "," + i + "']")[0];
                                                            }
                                                        }
                                                    }
                                                    if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                                                    {
                                                        set_spn = parseInt($(currentCell).attr("colspan")) - parseInt(colspn);
                                                        $(currentCell).attr("colspan", set_spn)
                                                    }
                                                }
                                            }
                                            if (!ej.isNullOrUndefined(currentCell))
                                                cnt--;
                                        }
                                    }
                                }
                            }
                        }
                        isCheckSum = true, count = 0, gTotCells = "";
                        if (!this.model.enableRowGrandTotal || !this.model.enableGrandTotal) {
                            var isFrozenEnabled = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders;
                            rwLen = $(tableGrid).find("tbody tr").length;
                            if (rwLen > 1 || (rwLen == 1 && $(tableGrid).find(isFrozenEnabled ? "" : "th" + "[p^='" + count + ",']") == "summary")) {
                                rwLen = $(tableGrid).find("tbody tr").length;
                                while (isCheckSum) {
                                    gTotCells = (isFrozenEnabled) ? $(tableGrid).find("td.summary[p^='" + count + ",']") : $(tableGrid).find("th.summary[p^='" + count + ",']");
                                    if (gTotCells.length)
                                        isCheckSum = false;
                                          count++;
                                 }
                            }
                            if (rwLen > 0) {
                                for (var p = 0; p < gTotCells.length; p++) {
                                    var cnt = count;
                                    var selectedCell = gTotCells[p]; selectedCellPos = $(selectedCell).attr('p'), i = parseInt(selectedCellPos.split(',')[0]) - 1;
                                    var rwspn = $(selectedCell).attr("rowspan");
                                    var row = $(selectedCell).parent();
                                    for (var rl = 0; rl < selectedCell.rowSpan; rl++) {
                                        $(row).css("display", "none");
                                        if (isFrozenEnabled)
                                            $(tableGrid).find(".pivotGridValueTable tr:eq(" + $(row).index() + ")").css("display", "none");
                                        row = $(row).next();
                                    }
                                    if (i >= 0) {
                                        var cell = $(tableGrid).find(" [p^='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                                        while (cnt > 1) {
                                            if (ej.isNullOrUndefined(cell)) {
                                                for (i = parseInt(selectedCellPos.split(',')[0]) - 1; i >= 0; i--) {
                                                    var currentCell = $(tableGrid).find("[p='" + i + "," + selectedCellPos.split(',')[1] + "']")[0];
                                                    if (ej.isNullOrUndefined(currentCell)) {
                                                        for (k = parseInt(selectedCellPos.split(',')[1]) - 1; k >= 0; k--) {
                                                            if (ej.isNullOrUndefined(currentCell)) {
                                                                currentCell = $(tableGrid).find("[p='" + i + "," + k + "']")[0];
                                                            }
                                                        }
                                                    }
                                                    if (!ej.isNullOrUndefined(currentCell) && $(currentCell).css("display") != "none" && $($(currentCell).parents("tr")[0]).css("display") != "none" && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader" || $(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader" || $(currentCell).hasClass("value") || $(currentCell).attr('role') == "gridcell")) cell = currentCell;
                                                    {
                                                        set_spn = parseInt($(currentCell).attr("rowspan")) - parseInt(rwspn);
                                                        $(currentCell).attr("rowspan", set_spn)
                                                    }
                                                }
                                            }
                                            if (!ej.isNullOrUndefined(currentCell))
                                                cnt--;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },

        _hideSubTotal: function (gridTable, targetLoop, target) {
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var rowData = this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? this.model.dataSource.rows : (this.element.parents(".e-pivotclient").length > 0 ? JSON.parse(this._pivotClientObj.getOlapReport()).PivotRows : JSON.parse(this.getOlapReport()).PivotRows), subThs;
                var columnData = this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? this.model.dataSource.columns : (this.element.parents(".e-pivotclient").length > 0 ? JSON.parse(this._pivotClientObj.getOlapReport()).PivotColumns : JSON.parse(this.getOlapReport()).PivotColumns);
                if (!ej.isNullOrUndefined(rowData)) {
                    for (var i = 0; i < rowData.length; i++) {
                        if (rowData[i].showSubTotal == false) {
                            var rowIndex = i.toString();
                            if ($(gridTable).attr("role") == "row" && $(gridTable).parent().is("tbody")) {
                                if (($(gridTable).find(".stot,.rstot").length == 0 || (this._isSubTotalhidden && $(gridTable).find(".stot,.rstot").find(".expand").length >= 1)) || ($(gridTable).find(".stot,.rstot").attr("p").split(",")[0] == rowIndex && (targetLoop == 1 && ($(gridTable).find(".stot,.rstot").find(".expand").length >= 1))))
                                    break;
                                else if ($(gridTable).find(".stot,.rstot").attr("p").split(",")[0] == rowIndex) {
                                    if ($(target).parent().attr("p").split(",")[0] == rowIndex)
                                        this._isSubTotalhidden = true;
                                    this._isSubTotalHide = true;
                                    break;
                                }
                            }
                            else if ($(gridTable).find("tbody").length > 0) {
                                subThs = this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? gridTable.find(".summary.rstot[p^=\"" + i + ",\"]") : gridTable.find(".summary.stot[p^=\"" + i + ",\"]");
                                if (subThs.length > 0)
                                    for (var j = 0; j < subThs.length; j++) {
                                        var thHide = $(subThs[j]).closest("tr");
                                        var positionTh = $(thHide).find(".stot,.rstot").attr("p"), cnt = parseInt(positionTh.split(',')[0]) - 1;
                                        var rowSpan = parseInt($(thHide).find(".stot,.rstot").attr("rowspan"));
                                        $(thHide).css("display", "none");
                                        //$(gridTable).find(".valueCell td[p$='," + positionTh.split(',')[1] + "']").css("display", "none");
                                        var lnt = parseInt(positionTh.split(',')[1]);
                                        while (cnt >= 0) {
                                            var currentCell = null;
                                            while (ej.isNullOrUndefined(currentCell) && lnt >= 0) {
                                                currentCell = $(gridTable).find("[p='" + cnt + "," + lnt + "']")[0];
                                                if (!ej.isNullOrUndefined(currentCell) && $($(currentCell).closest("tr")[0]).css("display") != "none" && $(currentCell).hasClass("rowheader") && $(currentCell).attr('role') == "rowheader") {
                                                    if (parseInt($(currentCell).attr("p").split(",")[0]) < parseInt(positionTh.split(",")[0]) && (parseInt($(currentCell).attr("p").split(",")[1]) + currentCell.rowSpan + ($(currentCell).find("span").attr("tag") != undefined ? parseInt($(currentCell).find("span").attr("tag")) : 0)) >= (parseInt(positionTh.split(",")[1]) + rowSpan)) {
                                                        currentCell.rowSpan -= 1;
                                                        $(currentCell).find("span").attr("tag", $(currentCell).find("span").attr("tag") != undefined ? (parseInt($(currentCell).find("span").attr("tag")) + (1)) : 1);
                                                        break;
                                                    }
                                                }
                                                lnt--;
                                            }
                                            cnt--;
                                        }
                                    }
                            }
                        }
                    }
                }
                if (!ej.isNullOrUndefined(columnData)) {
                    for (var i = 0; i < columnData.length; i++) {
                        if (columnData[i].showSubTotal == false) {
                            var columnIndex = i.toString()
                            if (($(gridTable).hasClass("stot") || $(gridTable).hasClass("cstot")) && $(gridTable).attr("role") == "columnheader") {
                                if ((this._isSubTotalhidden && $(gridTable).find(".stot,.cstot").find(".expand").length >= 1) || ($(gridTable).attr("p").split(",")[1] == columnIndex && (targetLoop == 1 && ($(gridTable).find(".expand").length >= 1))))
                                    break;
                                else if ($(gridTable).attr("p").split(",")[1] == columnIndex) {
                                    this._isSubTotalhidden = this._isSubTotalHide = true;
                                    break;
                                }
                            }
                            else if ($(gridTable).attr("role") == "row" && $(gridTable).parent().is("thead")) {
                                if (($(gridTable).find(".stot,.cstot").length == 0 || (this._isSubTotalhidden && $(gridTable).find(".stot,.cstot").find(".expand").length >= 1)) || ($(gridTable).find(".stot,.cstot").attr("p").split(",")[1] == columnIndex && (targetLoop == 1 && ($(gridTable).find(".stot,.cstot").find(".expand").length >= 1))))
                                    break;
                                else if ($(gridTable).find(".stot,.cstot").attr("p").split(",")[1] == columnIndex) {
                                    this._isSubTotalhidden = this._isSubTotalHide = true;
                                    break;
                                }
                            }
                            else if (($(gridTable).find("thead").length > 0 || $(gridTable).find(".colhead").length > 0)) {
                                subThs = this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? gridTable.find("th.summary.cstot[p$=\"," + i + "\"]") : gridTable.find("th.summary.stot[p$=\"," + i + "\"]");
                                if (subThs.length > 0) {
                                    var colsTotal = subThs;
                                    for (var k = 0; k < colsTotal.length; k++) {
                                        var hideTh = $(colsTotal[k]), pGridTb = $(gridTable), positionTh = $(colsTotal[k]).attr("p"), row = $(colsTotal[k]).closest("tr")[0], tdPosVal = parseInt(positionTh.split(",")[0]), rowSpan = parseInt($(colsTotal[k]).attr("rowspan")), colsSpan = parseInt($(colsTotal[k]).attr("colspan")), lnt = parseInt(positionTh.split(',')[1]) - 1;;
                                        for (var cCount = 0; cCount < colsSpan; cCount++) {
                                            var thList = $(row).nextAll().find("[p^='" + (cCount + tdPosVal) + ",']");
                                            for (var thCnt = 0; thCnt < $(thList).length; thCnt++) {
                                                $(thList[thCnt]).css("display", "none");
                                            }
                                            if ($(thList[thCnt]).attr("hc") == undefined || parseInt($(thList[thCnt]).attr("hc")) < 1) {
                                                $(pGridTb).find("[p^='" + (cCount + tdPosVal) + ",']").css("display", "none");
                                                $(pGridTb).find("[p^='0,']:not(.summary)").parent().find("td[p^='" + (cCount + tdPosVal) + ",']").attr("ch", 1);
                                            }
                                        }
                                        $(hideTh).css("display", "none");
                                        var cnt = parseInt(positionTh.split(',')[0]);
                                        while (lnt >= 0) {
                                            var currentCell = null;
                                            while (ej.isNullOrUndefined(currentCell) && cnt >= 0) {
                                                currentCell = $(gridTable).find("[p='" + cnt + "," + lnt + "']")[0];
                                                if (!ej.isNullOrUndefined(currentCell) && $($(currentCell).closest("tr")[0]).css("display") != "none" && $(currentCell).hasClass("colheader") && $(currentCell).attr('role') == "columnheader") {
                                                    if ((parseInt($(currentCell).attr("p").split(",")[1]) < parseInt(positionTh.split(",")[1]) && parseInt($(currentCell).attr("p").split(",")[0]) <= parseInt(positionTh.split(",")[0])) && (parseInt($(currentCell).attr("p").split(",")[0]) + currentCell.colSpan + ($(currentCell).find("span").attr("tag") != undefined ? parseInt($(currentCell).find("span").attr("tag")) : 0)) >= (parseInt(positionTh.split(",")[0]) + colsSpan)) {
                                                        currentCell.colSpan -= colsSpan;
                                                        $(currentCell).find("span").attr("tag", $(currentCell).find("span").attr("tag") != undefined ? (parseInt($(currentCell).find("span").attr("tag")) + (colsSpan)) : colsSpan);
                                                        break;
                                                    }
                                                }
                                                cnt--;
                                            }
                                            lnt--;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
       },

        _filterReport: function (report) {
            for (var i = 0; i < report.Filters.length; i++) {
                if (report.PivotColumns.length >= 1) {
                    for (var j = 0; j < report.PivotColumns.length; j++) {
                        if (report.Filters.length != 0 && !ej.isNullOrUndefined(report.Filters[i]) && report.Filters[i].Tag == report.PivotColumns[j].FieldName) {
                            report.Filters.splice(i, 1);
                            i = -1;
                        }
                    }
                }
            }
            for (var i = 0; i < report.Filters.length; i++) {
                if (report.PivotRows.length >= 1) {
                    for (var j = 0; j < report.PivotRows.length; j++) {
                        if (report.Filters.length != 0 && !ej.isNullOrUndefined(report.Filters[i]) && report.Filters[i].Tag == report.PivotRows[j].FieldName) {
                            report.Filters.splice(i, 1);
                            i = -1;
                        }
                    }
                }
            }
            for (var i = 0; i < report.Filters.length; i++) {
                if (report.PivotCalculations.length >= 1) {
                    for (var j = 0; j < report.PivotCalculations.length; j++) {
                        if (report.Filters.length != 0 && !ej.isNullOrUndefined(report.Filters[i]) && report.Filters[i].Tag == report.PivotCalculations[j].FieldName) {
                            report.Filters.splice(i, 1);
                            i = -1;
                        }
                    }
                }
            }

            return report;
        },
        _createGroupingBar: function (report) {
            var filterTag;
            this._pivotFilter = this._getLocalizedLabels("DragFieldHere");
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                report = this._filterReport(report);
                filterTag = this._createPivotButtons(this._pivotFilter != null && report.Filters.length > 1 && report.Filters[0].Tag == report.Filters[1].Tag ? report.Filters.slice(1) : report.Filters, "filter");
            }
            else
                filterTag = this._createPivotButtons(this._pivotFilter != null && report.filters.length > 0 ? report.filters : "", "filter");
            this._pivotFilter = filterTag;
            this._pivotRow = this._createPivotButtons(this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? report.PivotRows : report.rows, "row");            
            this._pivotColumn = this._createPivotButtons(this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? report.PivotColumns : report.columns, "column");
            this._pivotCalculation = this._createPivotButtons(this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? report.PivotCalculations : report.values, "values");
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && (report.values.length > 0 && report.values[0]["measures"])) {
                if (report.values[0]["axis"] == "columns" && report.values[0]["measures"].length > 0)
                    this._pivotColumn = this._pivotColumn + this._createPivotButtons(this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? report.PivotColumns : [{ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }], "column");
                else if (report.values[0]["axis"] == "rows" && report.values[0]["measures"].length > 0)
                    this._pivotRow = this._pivotRow + this._createPivotButtons(this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? report.PivotColumns : [{ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }], "row");
            }
        },

        _contextOpen: function (args) {
            ej.Pivot._contextMenuOpen(args, this);
        },
        _pivotContextClick: function (args) {
            if (args.text != this._getLocalizedLabels("CalculatedField")) {
                if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                    var droppedClass = args.text == this._getLocalizedLabels("AddToColumn") ? "column" : args.text == this._getLocalizedLabels("AddToRow") ? "row" : args.text == this._getLocalizedLabels("AddToValues") ? "value" : args.text == this._getLocalizedLabels("AddToFilter") ? "filter" : "";
                    var droppedField = $(this._selectedMember).attr("fieldName");
                    var droppedFieldCaption = $(this._selectedMember).text();
                    var dropArgs = { droppedFieldName: droppedField, droppedFieldCaption: droppedFieldCaption, droppedClass: droppedClass, droppedPosition: "", isMeasuresDropped: (droppedField.toLocaleLowerCase().indexOf("measures") == 0) };
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this._calculatedField.length > 0 && droppedClass != "values") {
                        this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) {
                            return (ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false) || (value.isCalculatedField == true && value.formula.indexOf(dropArgs.droppedFieldName) == -1);
                        });
                    }
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        this.model.dataSource = this.clearDrilledItems(this.model.dataSource, { action: "pvtBtnDropped" }, this);
                    }
                    ej.Pivot.addReportItem(this.model.dataSource, dropArgs);
                    this.refreshControl();
					if (!ej.isNullOrUndefined(this._schemaData))
						this._schemaData._refreshPivotButtons();
                }
                else {
                    var droppedPosition = args.text == this._getLocalizedLabels("AddToColumn") ? this.element.find(".columns") : args.text == this._getLocalizedLabels("AddToRow") ? this.element.find(".grpRow") : args.text == this._getLocalizedLabels("AddToValues") ? this.element.find(".values") : args.text == this._getLocalizedLabels("AddToFilter") ? this.element.find(".drag") : "";
                    var params = { element: this._selectedMember, target: droppedPosition, cancel: false };
                    this._pvtBtnDropped(params);
                }
            }
            else
                this._createCalculatedField();
        },

        _getAdvancedFilterInfo: function (levelUqName) {
            var filterItem=[];
            if(this._excelFilterInfo.length>0){
                var hierarchy=levelUqName;
                filterItem = $.grep(this._excelFilterInfo, function (value) {
                    try {
                        //.split('.').splice(0, 2).join(".")
                        if (value.levelUniqueName.replace(/]/g, "").replace(/\[/g, "").indexOf(levelUqName) > -1 && !ej.isNullOrUndefined(value.operator))
                            return value;
                    }
                    catch (e){}
                   
                });
            }
            return filterItem;
        },
        _createPivotButtons: function (axisItems, axis) {
            var clientMode = (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) ? true : false;
            if (!ej.isNullOrUndefined(axisItems)) {
                var rowBtns = "", tagAxis = axis == "column" ? "Columns" : axis == "row" ? "Rows" : axis == "filter" ? "Slicers" : "Values";
                var filterState = "";

                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    var tagAxis = axis == "column" ? "Columns" : axis == "row" ? "Rows" : axis == "filter" ? "filters" : "values";
                    if (tagAxis == "values" && clientMode)
                        axisItems = $.map(axisItems, function (obj, index) { return obj["measures"]; });
                    for (var i = 0; i < axisItems.length; i++) {
                        filterState = axisItems[i].fieldCaption;
                        var members = clientMode ? "" : ej.PivotAnalysis.getMembers(axisItems[i].fieldName);
                        var fieldItem = (ej.Pivot.getReportItemByFieldName(axisItems[i].fieldName, this.model.dataSource));
                        var filtered = ((axisItems[i].filterItems != null && axisItems[i].filterItems.values.length > 0) || (!ej.isNullOrUndefined(axisItems[i]["advancedFilter"]) && axisItems[i]["advancedFilter"].length > 0 && fieldItem.item && fieldItem.axis != "filters")) ? "filtered" : "";
                        if (axis == "filter") {
                            if (filtered == "filtered") {
                                filterState = ej.Pivot._getFilterState(clientMode, members, axisItems[i], this);
                            }
                            else if (clientMode) {
                                ej.olap._mdxParser.getAllMember(this.model.dataSource, axisItems[i].fieldName, this);
                                filterState = this._allMember;
                            }
                            else
                                filterState = this._getLocalizedLabels("All");
                        }
                        var sort = clientMode ? "" : axisItems[i].sortOrder == ej.PivotAnalysis.SortOrder.Descending ? "descending" : "";
                        rowBtns += ej.buildTag("span.pivotButton", ej.buildTag("button.pvtBtn#pivotButton_" + (axisItems[i].fieldName || axisItems[i]), (1 == 1 ? (this.model.showUniqueNameOnPivotButton ? (axis != "values" ? (axisItems[i].fieldName.replace(/\[/g, '').replace(/\]/g, '')) : (axisItems[i].fieldCaption == undefined ? axisItems[i].fieldName : axisItems[i].fieldCaption || axisItems[i])) : (axisItems[i].fieldCaption == undefined ? axisItems[i].fieldName : axisItems[i].fieldCaption || axisItems[i])) + (axis == "filter" ? " (" + filterState + ")" : "") : $.grep(this._pivotTableFields, function (item) { return item.name == axisItems[i].fieldName; })[0].caption || $.grep(this._pivotTableFields, function (item) { return item.name == axisItems[i]; })[0].caption), {}, { "fieldName": axisItems[i].fieldName, "fieldCaption": axisItems[i].fieldCaption, "axis": tagAxis })[0].outerHTML +
                                  (clientMode && (axisItems[i].fieldName.toLowerCase() == "measures" || (!ej.isNullOrUndefined(axisItems[i].isNamedSet) && !axisItems[i].isNamedSet)) ? "" : ej.buildTag("span.filter e-icon " + filtered).attr("role", "button").attr("aria-label", "filter")[0].outerHTML) + (clientMode ? " " : ej.buildTag("span.sorting e-icon " + sort).attr("role", "button").attr("aria-label", "sort").attr("aria-expanded", "false")[0].outerHTML) + ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML).attr("tag", tagAxis + ":" + axisItems[i].fieldName || axisItems[i])[0].outerHTML;
                    }
                }
                else {
                    if (tagAxis == "Values" && axis == "values") {
                        var tempAxis = this.element.find(".pivotButton:contains('" + this._getLocalizedLabels("Measures") + "')").length > 0 ? this.element.find(".pivotButton:contains('" + this._getLocalizedLabels("Measures") + "')").parent()[0].className.split(" ")[0] : "schemaColumn";
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                            tagAxis = tempAxis == "schemaColumn" || tempAxis == "columns" ? "Columns" : "Rows";
                    }
                    for (var i = 0; i < axisItems.length; i++) {
                        var l = this._ascdes.split("##"), count = 0; sort = "", filtered = "";
                        for (var j = 0; j < l.length; j++) {
                            if ((this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && l[j] == axisItems[i].Tag) || (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && l[j] == axisItems[i])) {
                                count = 1;
                            }
                        }
                        if (count == 1) {
                            sort = "descending";
                        }
                        if (!ej.isNullOrUndefined(this._tempFilterData)) {
                            for (var j = 0; j < this._tempFilterData.length; j++) {
                                for (var key in this._tempFilterData[j]) {
                                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                                        if (key == ((axisItems[i].FieldName || axisItems[i].DimensionName)) && this._tempFilterData[j][(axisItems[i].FieldName || axisItems[i].DimensionName)] != "")
                                            filtered = "filtered";
                                    }
                                    else if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                                        if (key == (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? axisItems[i].Tag : axisItems[i]) && this._tempFilterData[j][axisItems[i].Tag].indexOf("FILTERED") != 0)
                                            filtered = "filtered";
                                    }
                                }
                            }
                        }
                        if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                            axisItems[i].FieldHeader = axisItems[i].FieldHeader == "Measures" ? this._getLocalizedLabels("Measures") : axisItems[i].FieldHeader;
                            filtered = (axis!="filter" && this.model.enableAdvancedFilter &&  this._getAdvancedFilterInfo(axisItems[i].Tag).length > 0) ? "filtered" : filtered;
                            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                                var excludeMem = !ej.isNullOrUndefined(this._tempFilterData) ? $.map(this._tempFilterData, function (item) { return item[axisItems[i].DimensionName] }) : [];
                                if (axis == "filter") {
                                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.enableAdvancedFilter && this._getAdvancedFilterInfo(axisItems[i].Tag).length > 0) {                                        
                                        filtered = "filtered";
                                    }
                                    if (excludeMem.length > 0 && filtered && this._fieldMembers[axisItems[i].DimensionName])
                                        filterState = this._fieldMembers[axisItems[i].DimensionName].length - excludeMem.length == 1 ? (this._fieldMembers[axisItems[i].DimensionName]).filter(function (item) { if (excludeMem.indexOf(item) == -1) return item }) : this._getLocalizedLabels("MultipleItems");
                                    else
                                        filterState = this._getLocalizedLabels("All");
                                }
                            }
                            else {
                                if (axis == "filter") {
                                    filterState = (this._fieldSelectedMembers[axisItems[i].Tag] == "All" ? axisItems[i].AllMember : this._fieldSelectedMembers[axisItems[i].Tag]) || axisItems[i].AllMember;
                                }
                            }
                            var filterIcon = axisItems[i].FieldHeader == "Measures" || axisItems[i].Tag == "Measures" ? "" : ej.buildTag("span.filter e-icon " + filtered).attr("role", "button").attr("aria-label", "filter")[0].outerHTML;
                            rowBtns += ej.buildTag("span.pivotButton", ej.buildTag("span.dropIndicator")[0].outerHTML + ej.buildTag("button.pvtBtn#pivotButton" + axisItems[i].FieldHeader || axisItems[i].FieldName || axisItems[i].Name || axisItems[i].DimensionHeader || axisItems[i].DimensionName, ((this.model.showUniqueNameOnPivotButton ? (axis != "values" ? axisItems[i].Tag : axisItems[i].FieldHeader || axisItems[i].FieldName || axisItems[i].Name || axisItems[i].DimensionHeader || axisItems[i].DimensionName) : axisItems[i].FieldHeader || axisItems[i].FieldName || axisItems[i].Name || axisItems[i].DimensionHeader || axisItems[i].DimensionName) + (axis == "filter" ? " (" + filterState + ")" : "")), {}, this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? { "fieldname": axisItems[i].FieldName || axisItems[i].DimensionName || axisItems[i].FieldHeader || axisItems[i].DimensionHeader, "fieldCaption": axisItems[i].FieldHeader || axisItems[i].DimensionHeader || axisItems[i].FieldName || axisItems[i].DimensionName } : { "fieldCaption": axisItems[i].FieldHeader })[0].outerHTML +
                              filterIcon + ej.buildTag("span.sorting e-icon " + sort).attr("role", "button").attr("aria-label", "sort")[0].outerHTML + ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML).attr("tag", tagAxis + ":" + axisItems[i].Tag)[0].outerHTML;
                        }
                        else
                            rowBtns += ej.buildTag("span.pivotButton", ej.buildTag("span.dropIndicator")[0].outerHTML + ej.buildTag("button.pvtBtn#pivotButton" + axisItems[i], axisItems[i])[0].outerHTML + ej.buildTag("span.filter e-icon " + filtered).attr("role", "button").attr("aria-label", "filter")[0].outerHTML + ej.buildTag("span.sorting e-icon " + sort).attr("role", "button").attr("aria-label", "sort").attr("aria-expanded", "false")[0].outerHTML + ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML).attr("tag", tagAxis + ":" + axisItems[i])[0].outerHTML;
                    }
                }
                return rowBtns;
            }
        },

        _createFields: function (tableOlapGrid, tableWidth, cellWidth) {
            this.element.find(".groupingBarPivot").remove();
            this.element.prepend(ej.buildTag("div#groupingBarPivot.groupingBarPivot")[0].outerHTML);
            this.element.find(".groupingBarPivot").prepend(ej.buildTag("div.valueColumn", ej.buildTag("span.values", ej.buildTag("span#grpvalue", "values", { "display": "none" })[0].outerHTML).attr("aria-describedby", "grpvalue")[0].outerHTML + ej.buildTag("span.columns", ej.buildTag("span#grpcol", "column", { "display": "none" })[0].outerHTML).attr("aria-describedby", "grpcol")[0].outerHTML, { "width": "100%" })); // Math.max(valueColumnWidth, 280) - 5
            this.element.find(".groupingBarPivot").prepend(ej.buildTag("div.drag", ej.buildTag("span", "", { "width": "5px", "display": "inline-block" })[0].outerHTML + ej.buildTag("span#grpdrag", "filter", { "display": "none" })[0].outerHTML + this._getLocalizedLabels("DragFieldHere"), { "width": "100%" })[0].outerHTML).attr("aria-describedby", "grpdrag");// Math.max(filterWidth, 280)
            if (this._pivotFilter != "" && this._pivotFilter != null)
                this.element.find(".drag").text("").append("<span id='grpdrag' style='display:none'>filter</span>");
            this.element.find(".drag").append(this._pivotFilter);
            this.element.find(".values").append(this._pivotCalculation);
            this.element.find(".columns").append(this._pivotColumn);
            if (this.element.find(".values .pivotButton").length == 0) {
                this.element.find(".values").append(ej.buildTag("span", "", { "width": "5px", "display": "inline-block" })[0].outerHTML + this._getLocalizedLabels("ValueArea"));
            }
            if (this.element.find(".columns .pivotButton").length == 0) {
                this.element.find(".columns").append(ej.buildTag("span", "", { "width": "5px", "display": "inline-block" })[0].outerHTML + this._getLocalizedLabels("ColumnArea"));
            }
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.element.find(".rows").length == 0 && !ej.isNullOrUndefined(this.getJSONRecords()) && this.getJSONRecords().length > 0 && this.getJSONRecords()[0].CSS == "colheader") {
                this.element.find(".pivotGridTable thead tr:first").prepend(ej.buildTag('th.grpRow', ej.buildTag("div.rows", ej.buildTag("span", "", { "width": "5px", "display": "inline-block" })[0].outerHTML + this._getLocalizedLabels("RowArea"))[0].outerHTML, {}, { rowspan: this.element.find("thead tr").length })[0].outerHTML);
                this.element.find(".pivotGridTable tbody tr:first").prepend(ej.buildTag('td.rowheader', this._getLocalizedLabels("Total"))[0].outerHTML);
            }
            else if (this.element.find(".rows .pivotButton").length == 0) {
                this.element.find(".rows").text("").children("span").remove();
                this.element.find(".rows").append(ej.buildTag("span", "", { "width": "5px", "display": "inline-block" })[0].outerHTML + this._getLocalizedLabels("RowArea"));
            }
            if (this.element.find(".rowheader").length == 0 && this.element.find(".colheader").length == 0 && this.element.find(".values .pivotButton").length == 0 || this.element.find(".pivotGridTable th").length == 0) {
                var rowArea = ej.buildTag("div.emptyRows", ej.buildTag("span.rows", this._pivotRow != "" ? this._pivotRow : this._getLocalizedLabels("RowArea"), { "width": "5px" })[0].outerHTML, { "width": 140 })[0].outerHTML;
                this.element.find(".rows").length == 0 ? this.element.find(".groupingBarPivot").append(rowArea) : "";
                if (this.model.enableDeferUpdate && this._pivotRow != "") {
                    this.element.find(".rows").text("");
                    this.element.find(".rows").append(this._pivotRow);
                }
                if (this.getJSONRecords() == null || this.getJSONRecords().length == 0)
                    this.element.find(".groupingBarPivot").addClass("emptyPivotGrid");
                this.element.find(".emptyRows,.rows").ejDroppable({
                });
            }
            this.element.find(".values").find(".filter").remove();
            this.element.find(".values").find(".sorting").remove();
            this.element.find(".drag").find(".sorting").remove();
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                this.element.find(".pivotButton").find(".sorting").remove();
            if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                this.element.find(".rows").width(this.element.find(".pivotGridRowTable").width());
                this._setGroupingBarFrozenRowBtnWidth();
            }
            this.element.find(".pivotButton .pvtBtn").ejButton({ size: "normal", type: ej.ButtonType.Button }).ejDraggable({
                handle: 'button', clone: true,
                cursorAt: { left: -5, top: -5 },
                dragStart: ej.proxy(function (args) {
                    this._isDragging = true;
                }, this),
                dragStop: ej.proxy(this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this._clientPvtBtnDropped : this._pvtBtnDropped, this),
                helper: ej.proxy(function (event, ui) {
                    $(event.element).parent().addClass("dragHover");
                    $(event.element).addClass("dragHover");
                    if (event.sender.target.className.indexOf("e-btn") > -1)
                        return $(event.sender.target).clone().addClass("dragClone").appendTo(this.element);
                    else
                        return false;
                }, this)
            });

            this.element.find(".drag, .values, .columns, .grpRow, .rows").ejDroppable({
            });
            if (this.element.find(".pivotGridTable").find("thead th:eq(1), tbody td.value:eq(0)").length > 0) {
                this.element.find(".groupingBarPivot").width(this.element.find(".pivotGridTable").width());
            }
            else if (this.element.find(".pivotGridTable").find("thead, tbody").length > 0) {
                if (!this.model.isResponsive)
                    this.element.find(".groupingBarPivot").width(this.element.find(".rows").width() + 150);
            }
            else {
                if (this.element.find(".columns .pivotButton").length == 0 || (this.element.find(".values .pivotButton").length == 0 && this.element.find(".columns .pivotButton").length == 1))
                    this.element.find(".groupingBarPivot").width(300);
                else {
                    var MaxBtnWidth = 0;
                    for (var i = 0; i < $(this.element.find(".columns .pivotButton")).length; i++) {
                        MaxBtnWidth = Math.max($(this.element.find(".columns .pivotButton")[i]).width(), MaxBtnWidth);
                    }
                    MaxBtnWidth < 140 ? this.element.find(".columns").css("min-width", MaxBtnWidth + "px") : "";
                    var grpwidth = (MaxBtnWidth * $(this.element.find(".columns .pivotButton")).length) + this.element.find(".values").width() + 10;
                    this.element.find(".groupingBarPivot").width(grpwidth);
                }
            }
            if (this.element.find(".rows").width() > 140 || (this.model.enableDeferUpdate) && (this.element.find(".rows").width() < this.element.find(".grpRow").width()) && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                if (this.enableDeferUpdate)
                    this.element.find(".rows").width(this.element.find(".colheader").length == 0 ? this.element.find(".grpRow").width() - 140 : this.element.find(".grpRow").width());
                else if (!this.model.isResponsive)
                    this.element.find(".rows").width((this.model.enableDeferUpdate) ? (this.element.find(".grpRow").width()) - 8 : (this.element.find(".grpRow").width()));
            }
            if (this.element.find(".pivotGridTable thead").length > 0 || this.model.enableDeferUpdate && this.element.find(".pivotGridTable thead").length == 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode || this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                if (this.model.isResponsive && this.element.find(".values .pivotButton").length == 0 && this.element.find(".columns .pivotButton").length == 0) {
                    this.element.find(".values").width(140);
                }
                else
                    this.element.find(".values").width(this.element.find(".grpRow").length > 0 ? this.model.enableDeferUpdate && this.element.find(".colheader").length == 0 ? this.element.find(".grpRow").width() : this.element.find(".grpRow").width() + 4 : 140);//this.element.find(".colheader").length==0?this.element.find(".grpRow").width()+140:
                if (this.model.enableDeferUpdate && this.element.find(".colheader").length == 0 && this.element.find(".pivotGridTable .rowheader").length != 0) {
                    var columnWidth = this.element.find(".groupingBarPivot").width() - this.element.find(".values").width();
                    if (columnWidth < 140)
                        this.element.find(".groupingBarPivot").width(this.element.find(".groupingBarPivot").width() + 140)
                }
                if (this.element.find(".pivotGridTable").find("thead th:eq(1), tbody td.value:eq(0)").length > 0 || this.model.enableDeferUpdate && this.element.find(".columns .pivotButton").length == 0 || this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                    var colWidth = this.element.find(".pivotGridTable").width() - this.element.find(".values").width() - 4;
                    if (this.element.find(".pivotGridTable").find("thead th:eq(2), tbody td:eq(1)").length == 0) {
                        this.element.find(".columns").css("min-width", colWidth >= 30 && this.element.find(".pivotGridTable .colheader").length == 0 && this.element.find(".columns .pivotButton").length == 0 ? 140 : colWidth).width(colWidth >= 30 && this.element.find(".pivotGridTable .colheader").length == 0 && this.element.find(".columns .pivotButton").length == 0 ? 82 : colWidth);
                        this.element.find(".values").height(colWidth >= 30 && this.element.find(".pivotGridTable .colheader").length == 0 && this.element.find(".columns .pivotButton").length == 0 ? this.element.find(".columns").height() : this.element.find(".values").height());
                        if (this.element.find(".columns .pivotButton").length == 0 || this.model.enableDeferUpdate && this.element.find(".pivotGridTable .colheader").length == 0) {
                            if (this.element.find(".columns .pivotButton").length == 0) {
                                var colWidth = this.element.find(".groupingBarPivot").width() - this.element.find(".values").width() - 5;
                                this.element.find(".columns").width(colWidth);
                                if (colWidth < 140 && ($(".groupingBarPivot .values .pivotButton").length == 1 || $(".groupingBarPivot .values .pivotButton").length == 0 && this.model.enableDeferUpdate))
                                    this.element.find(".columns").css("min-width", colWidth + "px");
                            }
                            this.element.find(".columns").addClass("widthSetter");
                        }
                    }
                    else {
                        if (colWidth < 140) {
                            if ($('.columns .pivotButton').length < 2)
                                this.element.find(".columns").css("min-width", colWidth).addClass("widthSetter");
                            else {
                                this.element.find(".columns").width(colWidth).css("min-width", colWidth);
                                this.element.find(".values").height(this.element.find(".columns").height());
                                
                            }
                        }
                        else
                            this.element.find(".columns").width(colWidth);
                    }
                }
                else if (this.element.find(".pivotGridTable").find("thead th:eq(1)").length == 0 && !this.model.enableDeferUpdate) {
                    var colBtnCount = this.element.find(".columns .pivotButton").length < 1 ? 1 : this.element.find(".columns .pivotButton").length;
                    this.element.find(".columns").addClass("widthSetter");
                    this.element.find(".columns").css("min-width", (this.element.find(".groupingBarPivot").width() - this.element.find(".values").width() - 7) / colBtnCount);
                }
            }
            if (this.model.dataSource.data != null && this.model.url == "") {
                var totalWidth = 0;
                $('.columns .pivotButton').each(function (index) { totalWidth += parseInt($(this).width() + 10); });
                if ($(".valueColumn").height() > 30 && this.element.find(".values button").length == 0 && this.element.find(".columns").width() < totalWidth) {
                    var btnCnt = (this.element.find(".columns .pivotButton").length);
                    var btnWidth = ((this.element.find(".valueColumn").width() - this.element.find(".values").width()) / (btnCnt == 0 ? 1 : btnCnt)) - 70;
                    this.element.find(".columns .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
                }
            }
            if (this.element.find(".columns").height() > 30) {
                if (!this.model.isResponsive)
                    var btnWidth = this.element.find(".columns").width() / 2 - 60;
                else
                    var btnWidth = this.element.find(".columns").width() / (this.element.find(".columns .pivotButton").length) - 5;
                this.element.find(".columns .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
            }
            else {
                if (this.element.find(".columns .pivotButton").width() > this.element.find(".columns").width()) {
                    var btnWidth = this.element.find(".columns").width() - 60;
                    this.element.find(".columns .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
                }
            }

            if (this.element.find(".drag").height() > 30) {
                var btnWidth = this.element.find(".groupingBarPivot").width() / 4 - 35;
                this.element.find(".drag .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
            }
            else if (this.element.find(".drag .pivotButton").width() > this.element.find(".drag").width()) {
                var btnWidth = this.element.find(".drag").width() -60;
                this.element.find(".drag .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
            }
            if (this.element.find(".values").height() > 30) {
                if (!this.model.isResponsive)
                    var btnWidth = this.element.find(".values").width() / 2 - 40;
                else
                    var btnWidth = this.element.find(".values").width() / (this.element.find(".values .pivotButton").length) - 5;
                this.element.find(".values .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
            }
            else {
                if (this.element.find(".values .pivotButton").width() > this.element.find(".values").width() || (this.element.find(".pivotGridTable").find("thead th:eq(1), tbody td.value:eq(0)").length == 0 && this.element.find(".values .pivotButton").length > 0)) {
                    var btnWidth = this.element.find(".values").width() - 40;
                    this.element.find(".values .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
                }
            }
            var addedbtnwidth = 0;
            for (var i = 0; i < this.element.find(".rows .pivotButton").length; i++) {
                addedbtnwidth = addedbtnwidth + this.element.find(".rows .pivotButton:eq(" + i + ")").width()
            }
            if ((addedbtnwidth > this.element.find(".rows").width()) || (this.element.find(".colfreeze").length>0 && addedbtnwidth > this.element.find(".colfreeze").width()) || (this.element.find(".rows").parent(".emptyRows").length > 0 && this.element.find(".rows").parent(".emptyRows").width() < addedbtnwidth)) {
                var btnWidth = 0
                if (this.element.find(".colfreeze").length > 0)
                    btnWidth = (this.element.find(".colfreeze").width()) / 2 - 40;
                else
                    btnWidth = (this.element.find(".rows").width()) / 2 - 40;
                this.element.find(".rows .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
            }
            if (this.model.enableDeferUpdate && this.element.find(".columns .pivotButton").length != 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                var pvtBtnWidth = 0, columnWidth = 0;
                for (var i = 0; this.element.find(".columns .pivotButton").length > i; i++) {
                    pvtBtnWidth = this.element.find(".columns .pivotButton:eq(" + i + ")").width() + pvtBtnWidth + 7;
                }
                this.element.find('.pivotGridTable .colheader,.pivotGridTable tr:eq(0) .summary').each(function () {
                    columnWidth = columnWidth + $(this).width();
                });
                if (pvtBtnWidth >= columnWidth) {
                    var isempty = this.element.find(".pivotGridTable .colheader").length > 0 ? 1 : 0;
                    var colWidth = isempty == 0 ? 140 : columnWidth;
                    var btnWidth = colWidth / (this.model.enableDeferUpdate ? this.element.find(".columns .pivotButton").length : 3) - 15;
                    this.model.enableDeferUpdate ? this.element.find(".columns .pvtBtn").width(30).css({ "text-overflow": "ellipsis" }) : this.element.find(".columns .pvtBtn").width(btnWidth).css({ "text-overflow": "ellipsis" });
                }
            }

            if (this.element.find(".values").height() > this.element.find(".columns").height() || this.element.find(".columns").height() > this.element.find(".values").height()) {
                if (this.element.find(".values").height() > this.element.find(".columns").height()) {
                    this.element.find(".columns").height(this.element.find(".values").height());
                }
                else
                    this.element.find(".values").height(this.element.find(".columns").height());
            }
            this.element.find(".colheader, .rowheader, .value").addClass("e-droppable");
            this.element.find(".summary").removeClass("e-droppable");
            if (this.model.enableGroupingBar) {
                var ele = this.element.find(".pvtBtn");
                var contextTag = ej.buildTag("ul.pivotTree#pivotTree", (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? ej.buildTag("li.calculatedFieldMenuItem", ej.buildTag("a.menuItem", this._getLocalizedLabels("CalculatedField"))[0].outerHTML)[0].outerHTML : " ") + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToFilter"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToRow"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToColumn"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToValues"))[0].outerHTML)[0].outerHTML)[0].outerHTML;
                $(this.element).append(contextTag);
                $("#pivotTree").ejMenu({
                    menuType: ej.MenuType.ContextMenu,
                    enableRTL: this.model.enableRTL,
                    openOnClick: false,
                    contextMenuTarget: ele,
                    click: ej.proxy(this._pivotContextClick, this),
                    beforeOpen: ej.proxy(this._contextOpen, this),
                    close: ej.proxy(ej.Pivot.closePreventPanel, this)
                });
            }
        },

        _clientPvtBtnDropped: function (args) {
            ej.PivotAnalysis._valueSorting = null;
            this._isDragging = false;
            ej.Pivot.openPreventPanel(this);
            args.element.removeClass("dragHover").css("background-color", "inherit");
            args.element.parent().removeClass("dragHover");
            this.element.find(".dragClone").remove();
            this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
            this.element.find(".dragClone,.dropIndicator").remove();
            var droppedClass = $(args.target).hasClass("columns") || $(args.target).parents(".columns").length > 0 ? "column" : $(args.target).hasClass("grpRow") || $(args.target).parents(".grpRow").length > 0 || $(args.target).hasClass("rows") ? "row" : $(args.target).hasClass("values") || $(args.target).parents(".values").length > 0 ? "value" : $(args.target).hasClass("drag") || $(args.target).parents(".drag").length > 0 ? "filter" : "";
            var droppedFieldCaption = args.element.text();
            var droppedField = $(args.element).attr("fieldName");
            if (droppedClass != "" && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if ((droppedField.toLowerCase().indexOf("[measures]") >= 0 && droppedClass != "value") || (droppedField == this._getLocalizedLabels("Measures") && droppedClass != "row" && droppedClass != "column") || (droppedField.toLowerCase().indexOf("[measures]") < 0 && droppedClass == "value")) {
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("GroupingBarAlertMsg"), this._getLocalizedLabels("Warning"), this);
                    return;
                }
            }
			if(droppedClass == "" && this._schemaData){
			    if(droppedFieldCaption.toLowerCase() == "measures" && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap){
					var i =0;
					while (this.model.dataSource.values[0]["measures"].length > 0) {
                            selectedTreeNode = this._schemaData._tableTreeObj.element.find("li[tag='" + this.model.dataSource.values[0]["measures"][i].fieldName + "']");
                            this._schemaData._tableTreeObj.uncheckNode(selectedTreeNode);
                        }
				}
				else if(this._schemaData)
				{
					var schemaUncheck = this._schemaData._tableTreeObj.element.find("li:contains('" + droppedFieldCaption + "')");
					this._schemaData._tableTreeObj.uncheckNode(schemaUncheck);
				}
			}
			if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && droppedClass!="" && droppedClass != "value" && $.grep(this._calculatedField, function (value) { return value.name == droppedField; }).length > 0) {
                ej.Pivot._createErrorDialog(this._getLocalizedLabels("CalcValue"), this._getLocalizedLabels("Warning"), this);
                this.element.find(".dragClone,.dropIndicator").remove();
                return;
            }
            var droppedPosition = droppedClass == "" ? "" : this._setSplitBtnTargetPos(args.event, droppedClass, "drop");
            var orginalPosition = droppedClass == "" ? "" : this._setSplitBtnTargetPos(args, droppedClass, "original");
            var droppedAxis = $(args.element).hasClass("columns") || $(args.element).parents(".columns").length > 0 ? "column" : $(args.element).hasClass("grpRow") || $(args.element).parents(".grpRow").length > 0 || $(args.element).hasClass("rows") ? "row" : $(args.element).hasClass("values") || $(args.element).parents(".values").length > 0 ? "value" : $(args.element).hasClass("drag") || $(args.element).parents(".drag").length > 0 ? "filter" : "";
            if (droppedClass != "" && droppedClass.toLowerCase() == droppedAxis.toLowerCase() && droppedPosition > orginalPosition) droppedPosition = droppedPosition - 1;
            var dropArgs = { droppedFieldName: droppedField, droppedFieldCaption: droppedFieldCaption, droppedClass: droppedClass, droppedPosition: droppedPosition, isMeasuresDropped: (droppedField.toLocaleLowerCase().indexOf("measures") == 0) };
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this._calculatedField.length > 0 && droppedClass != "value") {
                this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) {
                    return (ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false) || (value.isCalculatedField == true && value.formula.indexOf(dropArgs.droppedFieldName) == -1);
                });
            }
            else if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                this._fieldMembers = {};
                this._fieldSelectedMembers = {};
                this.model.dataSource = this.clearDrilledItems(this.model.dataSource, { action: "pvtBtnDropped" }, this);
            }
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.show();
            ej.Pivot.addReportItem(this.model.dataSource, dropArgs);
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var calculatedField = $.grep(this.model.dataSource.values, function (value) { return value.isCalculatedField == true; });
                this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) { return ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false; });
                $.merge(this.model.dataSource.values, calculatedField);
            }
            if ((this.model.enableAdvancedFilter || this.model.dataSource.enableAdvancedFilter) && droppedClass == "filter") {
                var fieldItem = ej.Pivot.getReportItemByFieldName(this._selectedField, this.model.dataSource).item;
                if(fieldItem && fieldItem.advancedFilter) 
                    fieldItem.advancedFilter = [];
            }
            this.refreshControl();
            if (!ej.isNullOrUndefined(this._schemaData)) {
                if (ej.Pivot.getReportItemByFieldName(droppedField, this.model.dataSource).item == null && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                    this._schemaData._tableTreeObj.element.find("li[tag='" + droppedField + "']").removeClass("filter").find(".treeDrop,.filter").remove();
                this._schemaData._refreshPivotButtons();
            }
        },

        _pvtBtnDropped: function (args) {
            ej.Pivot.openPreventPanel(this);
            $(args.element).parent().removeClass("dragHover");
            $(args.element).removeClass("dragHover");
            this._isUpdateRequired = true;
            this._isDragging = false;
            var droppedClass;
            this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
            var axis = null, axisName = "", headerTag = "", headerText, isFiltered = false, isSorted = false;
            if (!ej.isNullOrUndefined(args.target.className)) {
                droppedClass = args.target.className.indexOf("e-droppable") >= 0 ? args.target.className.split(" ")[0] : "";
            }
            else {
                droppedClass = $(args.target).hasClass("columns") ? "columns" : $(args.target).hasClass("grpRow") ? "rows" : $(args.target).hasClass("values") ? "values" : $(args.target).hasClass("drag") ? "drag" : "";
            }
            droppedClass = droppedClass == "grpRow" ? "rows" : droppedClass;
            isFiltered = $(args.element).parent().find(".filtered").length > 0 ? true : false;
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                if ($(args.target).hasClass("pvtBtn") && (this.model.operationalMode != ej.PivotGrid.OperationalMode.ServerMode))
				droppedClass = $(args.target).attr("axis").toLowerCase();
                headerText = !(ej.isNullOrUndefined(args.element.attr("fieldCaption"))) ? args.element.attr("fieldCaption") : args.element.text();
                        isSorted = $(args.element).parent().find(".descending").length > 0 ? true : false;
                
                if (droppedClass == "" && (args.target.tagName == "BUTTON" || args.target.tagName == "SPAN")) {
                    droppedClass = args.target.parentNode.parentElement.className.split(" ")[0];
                }
                for (var i = 0; i < this._pivotTableFields.length; i++) {
                    if (this._pivotTableFields[i].name == headerText) {
                        this._pivotTableFields[i].isSelected = true;
                        headerTag = this._pivotTableFields[i];
                    }
                }
            }
            else
            {
                if (!ej.isNullOrUndefined(args.target.className)) {
                    axis = args.target.className.indexOf("pvtBtn") > -1 ? $(args.target).parents(".e-droppable")[0] : args.target.className.indexOf("e-droppable") ? args.target : args.target[0].tagName.toLowerCase() == "td" ? args.target.children(":last")[0] : args.target;
                    axisName = axis.className.split(" ")[0] == "columns" ? "Categorical" : axis.className.split(" ")[0] == "rows" || axis.className.split(" ")[0] == "grpRow" ? "Series" : axis.className.split(" ")[0] == "filters" ? "Slicer" : "";
                    droppedClass = axis.className.split(" ")[0];
                }
                else {
                    axis = $(args.target);
                    axisName = $(args.target).hasClass("columns") ? "Categorical" : $(args.target).hasClass("grpRow") ? "Series" : $(args.target).hasClass("drag") ? "Slicer" : "";
                    droppedClass = $(args.target).hasClass("columns") ? "columns" : $(args.target).hasClass("grpRow") ? "rows" : $(args.target).hasClass("values") ? "values" : $(args.target).hasClass("drag") ? "drag" : "";
                }
                if (axisName == "" && args.element.parent().attr("tag").indexOf("[Measures]") > -1)
                    axisName = this.element.find(".schemaRow .pivotButton:contains('" + this._getLocalizedLabels("Measures") + "')").length > 0 ? "Series" : "Categorical";
                headerTag = $(args.element.parent()[0]).attr("tag");
                droppedClass = droppedClass == "grpRow" ? "rows" : droppedClass;
                axisName = axisName == "grpRow" ? "Series" : axisName;
                headerText = args.element.text();
            }
            this.element.find(".dragClone").remove();
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if ((headerTag.split(":")[1].toLocaleUpperCase() == "MEASURES" && (droppedClass != "columns" || droppedClass != "rows") && (droppedClass == "drag" || droppedClass == "values")) || (headerTag.toUpperCase().indexOf("[MEASURES]") > -1 && droppedClass != "values" && (droppedClass == "rows" || droppedClass == "columns" || droppedClass == "drag"))) {
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("GroupingBarAlertMsg"), this._getLocalizedLabels("Error"), this);
                    this.element.find(".dragClone,.dropIndicator").remove();
                    args.element.parent().removeAttr("style");
                    args.element.css("background-color", "inherit");
                    return false;
                }
                else if (headerTag.toUpperCase().indexOf("[MEASURES]") == -1 && droppedClass == "values") {
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("GroupingBarAlertMsg"), this._getLocalizedLabels("Error"), this);
                    this.element.find(".dragClone,.dropIndicator").remove();
                    args.element.parent().removeAttr("style");
                    args.element.css("background-color", "inherit");
                    return false;
                }
            }
            if (droppedClass == "rows" || droppedClass == "columns" || droppedClass == "values" || droppedClass == "drag") {
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && droppedClass != "values" && ($.grep(this._calculatedField, function (value) { return value.name == headerText; }).length > 0 || $.grep(JSON.parse(this.getOlapReport()).PivotCalculations, function (value) { return value.FieldHeader == headerText && value.CalculationType == 8; }).length > 0)) {
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("CalcValue"), this._getLocalizedLabels("Warning"),this);
                    args.element.parent().removeAttr("style");
                    args.element.css("background-color", "inherit");
                    return;
                }
                var droppedPosition = this._setSplitBtnTargetPos(args, droppedClass, "drop");
                var orignalPosition = this._setSplitBtnTargetPos(args, droppedClass, "original");
                var report,params,eventArgs;
                if (droppedClass == "drag") {
                    this.element.find(".drag").text("").append("<span id='grpdrag' style='display:none'>filter</span>");
                }
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                $(args.element.parent()).remove();
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    var droppedAxis = args.element.parents(".pivotButton").attr("tag").split(":")[0];
                    this._waitingPopup = this.element.data("ejWaitingPopup");
                    if (!ej.isNullOrUndefined(this._waitingPopup))
                        this._waitingPopup.show();

                    if ($.isNumeric(droppedPosition)) {
                        if (droppedClass == droppedAxis.toLowerCase() && droppedPosition > orignalPosition)
                            droppedPosition = droppedPosition - 1;
                    }
                    droppedClass = droppedClass == "rows" ? "schemaRow" : droppedClass == "columns" ? "schemaColumn" : droppedClass == "drag" ? "schemaFilter" : droppedClass == "values" ? "schemaValue" : "";
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        if (this.model.enableAdvancedFilter && droppedClass == "schemaFilter") {
                            if (!ej.isNullOrUndefined(this._curFilteredText) && this._curFilteredText.indexOf(":") > -1) {
                                var filterInfo = this._getAdvancedFilterInfo(this._curFilteredText.split(":")[1]);
                                if (filterInfo.length > 0)
                                    this._removeFilterTag(filterInfo[0].levelUniqueName);
                            }
                        }
                        axisName = droppedClass == "schemaFilter" ? "Slicer" : axisName;
                        params = JSON.parse(this._olapReport).CurrentCube + "--" + headerTag + "--" + axisName + "--" + droppedPosition;
                        if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                            this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
                        var serializedCustomObject = JSON.stringify(this.model.customObject);
                        eventArgs = JSON.stringify({ "action": "nodeDropped", "dropType": "SplitButton", "nodeInfo": params, "currentReport": report, "gridLayout": this.model.layout, "customObject": serializedCustomObject });
                        if (!this.model.enableDeferUpdate)
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeDropped, eventArgs, this._pvtBtnDroppedSuccess);
                        else {
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._pvtBtnDroppedSuccess);
                        }
                    }
                    else {
                        if (this._calculatedField.length > 0 && droppedClass != "schemaValue" && this._schemaData != null)
                            this._calculatedFieldNodeRemove(headerTag);
                        if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                            this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
                        var serializedCustomObject = JSON.stringify(this.model.customObject);
                        var filterParams = ej.Pivot._getFilterParams(droppedClass, this._tempFilterData, headerText);
                        eventArgs = JSON.stringify({ "action": "nodeDropped", "dropAxis": droppedClass + "::" + droppedPosition, "headerTag": JSON.stringify(headerTag), "sortedHeaders": this._ascdes, "filterParams": filterParams, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject });
                            var successMethod = this._renderControlSuccess;
                            if (!this.model.enableDeferUpdate)
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeDropped, eventArgs, this._pvtBtnDroppedSuccess);
                            else {
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._pvtBtnDroppedSuccess);
                            }
                    }
                }
                else {
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && droppedClass != "values" && $.grep(this._calculatedField, function (value) { return value.name == headerText; }).length > 0) {
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("CalcValue"), this._getLocalizedLabels("Warning"), this);
                        this.model.editCellsInfo = {};
                        this._populatePivotGrid();
                        return;
                    }
                    var droppedItem = this._getDroppedItem(headerText);
                    var buttonFields = { fieldName: droppedItem[0].fieldName, fieldCaption: droppedItem[0].fieldCaption };
                    var droppedAxis = args.element.parents(".pivotButton").attr("tag").split(":")[0];
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && droppedItem.length > 0 && (droppedClass == "drag"))
                        droppedItem[0]["advancedFilter"] = [];
                    if ($.isNumeric(droppedPosition)) {
                        if (droppedClass == droppedAxis.toLowerCase() && droppedPosition > orignalPosition)
                            droppedClass == "rows" ? this.model.dataSource.rows.splice(droppedPosition - 1, 0, droppedItem[0]) : droppedClass == "columns" ? this.model.dataSource.columns.splice(droppedPosition - 1, 0, droppedItem[0]) : droppedClass == "values" ? (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this.model.dataSource.values[0]["measures"].splice(droppedPosition - 1, 0, droppedItem[0]) : this.model.dataSource.values.splice(droppedPosition, 0, droppedItem[0])) : this.model.dataSource.filters.splice(droppedPosition, 0, droppedItem[0]);
                        else
                            droppedClass == "rows" ? this.model.dataSource.rows.splice(droppedPosition, 0, droppedItem[0]) : droppedClass == "columns" ? this.model.dataSource.columns.splice(droppedPosition, 0, droppedItem[0]) : droppedClass == "values" ? (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this.model.dataSource.values[0]["measures"].splice(droppedPosition, 0, droppedItem[0]) : this.model.dataSource.values.splice(droppedPosition, 0, droppedItem[0])) : this.model.dataSource.filters.splice(droppedPosition, 0, droppedItem[0]);
                    }
                    else
                        droppedClass == "rows" ? this.model.dataSource.rows.push(droppedItem[0]) : droppedClass == "columns" ? this.model.dataSource.columns.push(droppedItem[0]) : droppedClass == "values" ? this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this.model.dataSource.values[0]["measures"].push(droppedItem[0]) : this.model.dataSource.values.push(droppedItem[0]) : this.model.dataSource.filters.push(droppedItem[0]);

                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this._calculatedField.length > 0 && droppedClass != "values") {
                        if (this._schemaData != null)
                            this._calcFieldNodeDrop(droppedItem[0]);
                        this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) {
                            return (ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false) || (value.isCalculatedField == true && value.formula.indexOf(droppedItem[0].fieldName) == -1);
                        });
                    }

                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        this.model.dataSource = this.clearDrilledItems(this.model.dataSource, { action: "pvtBtnDropped" },this);
                    }
                    if (this._schemaData != null) {
                        if (droppedClass == droppedAxis && droppedPosition > orignalPosition)
                            droppedPosition = droppedPosition - 1;
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                            this._schemaData.element.find("button[fieldName='" + headerText + "']").remove();
                        else
                            this._schemaData.element.find("#pivotButton" + headerText).parent().remove();
                        this._schemaData._createPivotButton(buttonFields, droppedClass == "rows" ? "row" : droppedClass == "columns" ? "column" : droppedClass == "drag" ? "filter" : droppedClass == "values" ? "value" : "", isFiltered, isSorted, droppedPosition);
                    }
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                        this.getJSONData({ action: "pvtBtnDropped" }, this.model.dataSource, this);
                    }
                    else {
                        this.model.editCellsInfo = {};
                        this._populatePivotGrid();
                    }
                }
            }
            else
                this._removePvtBtn(args);
            if (!ej.isNullOrUndefined(this._schemaData))
            this._schemaData._setPivotBtnWidth();
        },

        _getDroppedItem1: function (headerText) {
            var isOlapMode = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? true : false;
            var droppedItem = $.grep(this.model.dataSource.columns, function (value) { return value.fieldName == headerText; });
            if (droppedItem.length > 0) this.model.dataSource.columns = $.grep(this.model.dataSource.columns, function (value) { return value.fieldName != headerText; });
            else {
                droppedItem = $.grep(this.model.dataSource.rows, function (value) { return value.fieldName == headerText; });
                if (droppedItem.length > 0) this.model.dataSource.rows = $.grep(this.model.dataSource.rows, function (value) { return value.fieldName != headerText; });
                else {
                    var valuesItems = this.model.dataSource.values;
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                    {
                        valuesItems = this.model.dataSource.values[0]["measures"];
                    }
                    droppedItem = $.grep(valuesItems, function (value) { return value.fieldName == headerText; });
                    if (droppedItem.length > 0)
                    {
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                            this.model.dataSource.values[0]["measures"] = $.grep(valuesItems, function (value) { return value.fieldName != headerText; });
                        else
                            this.model.dataSource.values = $.grep(valuesItems, function (value) { return value.fieldName != headerText; });
                    }
                    else {
                        droppedItem = $.grep(this.model.dataSource.filters, function (value) { return value.fieldName == headerText; });
                        if (droppedItem.length > 0) this.model.dataSource.filters = $.grep(this.model.dataSource.filters, function (value) { return value.fieldName != headerText; });
                    }
                }
            }
            return droppedItem;
        },
       
        _clearCollapsedItems: function (dragAxis, headerText, dataSource) {
            if (dragAxis == "rowheader") {
                dataSource.rows = $.map(dataSource.rows, function (value) { 
                    if ((value.drilledItems != undefined) && value.drilledItems.length){
                        value.drilledItems = $.map(value.drilledItems, function (values) { if (values.join("").indexOf(headerText.repItms.replace(/&/g, "&amp;")) < 0) return [values]; });
                    }
                    return value;
                });
            }
            else if (dragAxis == "colheader") {
                dataSource.columns = $.map(dataSource.columns, function (value) {
                    if ((value.drilledItems != undefined) && value.drilledItems.length) {
                        value.drilledItems = $.map(value.drilledItems, function (values) {
                            if (values.join("").indexOf(headerText.repItms.replace(/&/g, "&amp;")) < 0)
                                return [values];
                        });
                    }
                    return value;
                });
            }
            return dataSource;
        },

        _setSplitBtnTargetPos: function (args, droppedClass, element) {
            var targetPosition = ""; var AEBdiv; var targetSplitBtn; var className;
            if (element == "drop")
                targetSplitBtn = $(args.target).parents(".pivotButton");
            else
                targetSplitBtn = $(args.element).parents(".pivotButton");
            droppedClass = droppedClass == "column" ? "columns" : droppedClass == "row" ? "rows" : droppedClass == "filter" ? "drag" : droppedClass == "value" ? "values" : droppedClass;
            AEBdiv = this.element.find("." + droppedClass).children(".pivotButton");
            for (var i = 0; i < AEBdiv.length; i++) {
                if ($(AEBdiv[i]).attr("tag") == $(targetSplitBtn).attr("tag"))
                    targetPosition = i;
            }
            return targetPosition;
        },

        _pvtBtnDroppedSuccess: function (args) {
            var report = null;
            if (!ej.isNullOrUndefined(args[0]) && args.length > 0) {
                if (args[2] != null && args[2] != undefined)
                    this.model.customObject = args[2].Value;
            }
            else if (!ej.isNullOrUndefined(args.d) && args.d.length > 0) {
                if (args.d[2] != null && args.d[2] != undefined)
                    this.model.customObject = args.d[2].Value;
            }
            else if (!ej.isNullOrUndefined(args) && !ej.isNullOrUndefined(args.OlapReport)) {
                if (args != null && args.customObject != undefined)
                    this.model.customObject = args.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
            if (!this.model.enableDeferUpdate)
                this._renderControlSuccess(args);
            else
                this._deferUpdateSuccess(args);
            if (this._schemaData != null)
                this._schemaData._refreshPivotButtons();
        },

        _deferUpdateSuccess: function (msg) {
            if (!ej.isNullOrUndefined(msg.PivotReport) || !ej.isNullOrUndefined(msg.OlapReport)) {
                ej.isNullOrUndefined(msg.PivotReport) ? this.setOlapReport(msg.OlapReport) : this.setOlapReport(msg.PivotReport);
                if (msg.HeaderCounts != undefined && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                    this.model.pivotControl._pagerObj.initPagerProperties(JSON.parse(msg.HeaderCounts), JSON.parse(msg.PageSettings));
            }
            else {
                this.setOlapReport(msg.d[0].Value);
                if ($(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                    this.model.pivotControl._pagerObj.initPagerProperties(JSON.parse(msg.d[2].Value), JSON.parse(msg.d[1].Value));
            }
            if (this.model.enableGroupingBar) {
                report = JSON.parse(this.getOlapReport());
                this._pivotTableFields = JSON.parse(report.ItemsProperties);
                this._createGroupingBar(report);
                this.element.find(".grpRow .rows").text("");
                this.element.find(".grpRow .rows").children().remove();
                this.element.find(".grpRow .rows").append(this._pivotRow);
                this._createFields(null, $("#" + this._id).find(".pivotGridTable").width(), $("#" + this._id).find(".pivotGridTable th").outerWidth());
            }
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this._calculatedField.length > 0 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this._schemaData != null)
                this._schemaButtonCreate();
            ej.Pivot.closePreventPanel(this);
        },

        _clientRemovePvtBtn: function (args) {
            ej.PivotAnalysis._valueSorting = null;
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.show();
            var headerText = $($(args.target).siblings()[0]).attr("fieldName");
            delete this._fieldMembers[headerText.toLowerCase()];
            delete this._fieldSelectedMembers[headerText.toLowerCase()];
            if (this._calculatedField.length > 0 && $.grep(this.model.dataSource.values, function (value) { return value.fieldName == headerText; }).length > 0)
                this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) { return ((value.isCalculatedField == null || value.isCalculatedField == false) || value.formula.indexOf(headerText) == -1) && value.fieldName != headerText; });
            else
                ej.Pivot.removeReportItem(this.model.dataSource, headerText, headerText.toLocaleLowerCase().indexOf("measures") == 0);
            this.refreshControl();
            if (!ej.isNullOrUndefined(this._schemaData)) {
                    this._schemaData._tableTreeObj.element.find("li[tag='" + headerText + "']").removeClass("filter").find(".treeDrop,.filter").remove();
                    this._schemaData.refreshControl();
            }
        },

        _removePvtBtn: function (args) {
            this._isUpdateRequired = true;
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                var caption;
                if (args.type == "click") {
                    var headerText = $($(args.target).siblings()[0]).attr("fieldName"), selectedElement = "", uniqueName = "";
                    caption = $($(args.target).siblings()[0]).text();
                }
                else {
                    var headerText = args.element.attr("fieldName"), selectedElement = "", uniqueName = "";
                    caption = args.element.text();
                }
                for (var i = 0; i < this.element.find(".pivotButton").length; i++) {
                    uniqueName = $(this.element.find(".pivotButton")[i]).find("button").attr("fieldName");
                    if (uniqueName == headerText)
                        selectedElement = $(this.element.find(".pivotButton")[i]);
                }
                $(selectedElement).remove();
                if (this._schemaData != null) {
                    var schemaUncheck = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this._schemaData._tableTreeObj.element.find("li [tag='" + headerText + "']") : this._schemaData._tableTreeObj.element.find("li[id='" + headerText + "']");
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && schemaUncheck.length == 0 && headerText.toLowerCase() == "measures") {
                        this._schemaData.element.find("div[tag='" + selectedElement.attr("tag") + "']").remove();
                        for (var i = 0; i < this.model.dataSource.values[0]["measures"].length; i++) {
                            this._schemaData._nodeCheck = true;
                            selectedTreeNode = this._schemaData._tableTreeObj.element.find("li[tag='" + this.model.dataSource.values[0]["measures"][i].fieldName + "']");
                            this._schemaData._tableTreeObj.uncheckNode(selectedTreeNode);
                            this.element.find("div[tag='values:" + this.model.dataSource.values[0]["measures"][i].fieldName + "']").remove();
                            this._schemaData.element.find("div[tag='values:" + this.model.dataSource.values[0]["measures"][i].fieldName + "']").remove();
                        }
                        this.model.dataSource.values[0]["measures"] = [];
                        if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                        this.getJSONData({ action: "removeBtn" }, this.model.dataSource, this);
                    }
                    this._schemaData._tableTreeObj.uncheckNode(schemaUncheck);
                }
                else {
                    this.model.dataSource.columns = $.grep(this.model.dataSource.columns, function (value) {
                        return value.fieldName != headerText;
                    });
                    this.model.dataSource.rows = $.grep(this.model.dataSource.rows, function (value) {
                      
                        return value.fieldName != headerText;
                    });
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        if ((selectedElement.attr("tag").split(":")[1].toLowerCase() == "measures")) {
                            this.model.dataSource.values[0]["measures"] = []
                        }
                        else if ((this._getItemPosition(this.model.dataSource.values[0]["measures"], selectedElement.attr("tag").split(":")[1])).length > 0)
                            this.model.dataSource.values[0]["measures"].splice(this._getItemPosition(this.model.dataSource.values[0]["measures"], selectedElement.attr("tag").split(":")[1])[0], 1);
                    }
                    else {
                        if (this._calculatedField.length > 0)
                            this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) { return ((value.isCalculatedField == null || value.isCalculatedField == false)|| value.formula.indexOf(headerText) == -1) && value.fieldName != headerText; });
                        else
                            this.model.dataSource.values = $.grep(this.model.dataSource.values, function (value) { return value.fieldName != headerText; });
                    }
                    this.model.dataSource.filters = $.grep(this.model.dataSource.filters, function (value) {
                        return value.fieldName != headerText;
                    });
                    if (this.model.analysisMode != ej.Pivot.AnalysisMode.Olap && this.model.operationalMode != ej.Pivot.OperationalMode.ClientMode) {
                        this.model.editCellsInfo = {};
                        this._populatePivotGrid();
                    }
                    else {
                        if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                        this.model.dataSource = this.clearDrilledItems(this.model.dataSource, { action: "removeButton" },this);
                        this.getJSONData({ action: "removeButton" }, this.model.dataSource, this);
                    }

                }
            }
            else {
                var headerText;
                if (args.type == "click") {
                    headerText = $($(args.target).siblings('button')).attr("fieldcaption");
                    var headerTag = $($(args.target).siblings('button')).parent().attr('tag');
                    var report, eventArgs;
                }
                else {
                    headerText = args.element.attr("fieldcaption");
                    var headerTag = args.element.parent().attr("tag"), eventArgs;
                }
                if (!ej.isNullOrUndefined(this._tempFilterData) && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    for (var j = 0; j < this._tempFilterData.length; j++) {
                        for (var key in this._tempFilterData[j]) {
                            if (key == headerTag.split(":")[1] && this._tempFilterData[j][headerTag.split(":")[1]] != "") {
                                this._tempFilterData.splice(j, 1);
                            }
                        }
                    }
                }
                delete this._fieldMembers[headerTag.split(':')[headerTag.split(':').length - 1]];
                delete this._fieldSelectedMembers[headerTag.split(':')[headerTag.split(':').length - 1]];
                filterTag = "", filterItems = "", selectedElement = "", headerTag = "", uniqueName = "", report = "";
                selectedElement = this.element.find(".pivotButton:contains(" + headerText + ")");
                for (var i = 0; i < this._pivotTableFields.length; i++) {
                    if (this._pivotTableFields[i].name == headerText) {
                        this._pivotTableFields[i].isSelected = false;
                        headerTag = this._pivotTableFields[i];
                    }
                }
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    headerTag = $(selectedElement).attr("tag");
                    var uniqueName = ((headerTag.indexOf("[Measures]") > -1) || (headerTag.indexOf("[") > -1)) ? headerTag.split(":")[1] : this._getNodeUniqueName(headerTag);
                    if (uniqueName == "[Measures]") {
                        selectedElement.remove();
                        if (!ej.isNullOrUndefined(this._schemaData)) {
                            this._schemaData.element.find(".pivotButton:contains(" + headerText + ")").remove();
                            for (var i = 0; i < this._schemaData.model.pivotCalculations.length && headerTag.indexOf("Measures") > -1; i++) {
                                uniqueName = this._schemaData.model.pivotCalculations[i].Tag;
                                this._schemaData._isMeasureBtnRemove = true;
                                selectedTreeNode = this._getNodeByUniqueName(uniqueName);
                                this._schemaData._tableTreeObj.uncheckNode(selectedTreeNode);
                            }
                        }
                        this._waitingPopup.show();                            
                        if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                            this._trigger("beforeServiceInvoke", { action: "removeButton", element: this.element, customObject: this.model.customObject });
                        var serializedCustomObject = JSON.stringify(this.model.customObject);
                        eventArgs = JSON.stringify({ "action": "removeButton", "headerInfo": headerTag, "currentReport": report, "gridLayout": this.model.layout, "customObject": serializedCustomObject });
                        if ((!ej.isNullOrUndefined(this._schemaData)) && headerTag.indexOf("[Measures]") < 0 && headerTag.indexOf("Measures") >= 0) {
                            this._schemaData.element.find(".schemaValue .pivotButton").remove()
                        }
                        if (this.model.enableDeferUpdate && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                            this._removeButtonDeferUpdate = true;
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.removeButton, eventArgs.replace("removeButton", "removeButtonDeferUpdate"), this._pvtBtnDroppedSuccess)
                            this.element.find(".schemaNoClick").removeClass("freeze");
							this._waitingPopup.hide(); 
                        }
                        else {
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.removeButton, eventArgs, this._pvtBtnDroppedSuccess);
                        }
                    }
                    else {
                        if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                        if (!ej.isNullOrUndefined(this._schemaData)) {
                            selectedTreeNode = this._getNodeByUniqueName(uniqueName);
                            this._schemaData._tableTreeObj.uncheckNode(selectedTreeNode);
                        }
                        else {
                            var serializedCustomObject = JSON.stringify(this.model.customObject);
                            eventArgs = JSON.stringify({ "action": "removeButton", "headerInfo": headerTag, "currentReport": report, "gridLayout": this.model.layout, "customObject": serializedCustomObject });
                            if (ej.isNullOrUndefined(headerTag))
                                return false;
                            if (!this.model.enableDeferUpdate)
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.removeButton, eventArgs, this._pvtBtnDroppedSuccess)
                            else {
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.removeButton, eventArgs.replace("removeButton", "removeButtonDeferUpdate"), this._pvtBtnDroppedSuccess)
                            }
                        }
                    }
                }
                else {
                    filterTag = "schemaRow::" + headerTag.id + "::FILTERED" + filterItems;
                    var dropAxis = this._droppedClass != "" ? this._droppedClass : headerTag.pivotType == "PivotItem" ? "schemaRow" : "schemaValue", eventArgs, axisName, params;
                    this._droppedClass = "";
                    $(selectedElement).remove();
                    this._waitingPopup = this.element.data("ejWaitingPopup");
                    if (!ej.isNullOrUndefined(this._waitingPopup))
                        this._waitingPopup.show();
                    if (this._schemaData != null) {
                            var schemaUncheck = this._schemaData._tableTreeObj.element.find("li:contains('" + headerText + "')");
                            this._schemaData._tableTreeObj.uncheckNode(schemaUncheck);
                    }
                    else {
                        if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.customObject });
                        var serializedCustomObject = JSON.stringify(this.model.customObject);
                        eventArgs = JSON.stringify({ "action": "nodeStateModified", "headerTag": JSON.stringify(headerTag), "dropAxis": dropAxis + "::", "sortedHeaders": this._ascdes, "filterParams": filterTag, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject });
                        if (!this.model.enableDeferUpdate)
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeStateModified, eventArgs, this._nodeStateModifiedSuccess);
                        else {
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeStateModified, eventArgs.replace("nodeStateModified", "nodeStateModifiedDeferUpdate"), this._nodeStateModifiedSuccess);
                        }
                    }
                }
            }
        },

        _getNodeUniqueName: function (headerTag) {
            var uniqueName = "", selectedTreeNode = null;
            for (var i = 0; i < (headerTag.split(':')[1]).split('.').length; i++) {
                if (uniqueName != "")
                    uniqueName += ".";
                uniqueName += "[" + ((headerTag.split(':')[1]).split('.')[i]) + "]";
            }
            return uniqueName;
        },

        _getNodeByUniqueName: function (nodeUniqueName) {
            var selectedTreeNode = null;
            for (var i = 0; i < $(this._schemaData._tableTreeObj.element.find("li")).length; i++) {
                if ($(this._schemaData._tableTreeObj.element.find("li")[i]).attr("tag").toLowerCase() == nodeUniqueName.toLowerCase())
                    selectedTreeNode = $((this._schemaData._tableTreeObj.element.find("li"))[i]);
            }

            return selectedTreeNode;
        },

        _nodeStateModifiedSuccess: function (report) {
            if (report[0] != undefined) {
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
            }
            else {
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.customObject });
            if (!this.model.enableDeferUpdate)
                this._renderControlSuccess(report);
            else
                this._deferUpdateSuccess(report);
        },

        _drillDownSuccess: function (msg) {
            if (msg[0] != undefined) {
                this.setJSONRecords(msg[0].Value);
                this.setOlapReport(msg[1].Value);
                if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                    this._pivotClientObj.currentReport = JSON.parse(msg[1].Value).Report;
                    if (msg[2].Value != undefined && msg[2].Value != "undefined")
                        this._pivotClientObj.reports = msg[2].Value;
                }
                if (msg[3] != null && msg[3] != undefined && msg[3].Key == "PageSettings") {
                    if (this.model.enableVirtualScrolling) {
                        this._categPageCount = Math.ceil(JSON.parse(msg[4].Value).Column / JSON.parse(msg[3].Value).CategorialPageSize);
                        this._seriesPageCount = Math.ceil(JSON.parse(msg[4].Value).Row / JSON.parse(msg[3].Value).SeriesPageSize);
                        this._categCurrentPage = JSON.parse(msg[3].Value).CategorialCurrentPage;
                        this._seriesCurrentPage = JSON.parse(msg[3].Value).SeriesPageSize;
                    }
                    else if (this._pagerObj !=null && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                        this._pagerObj.initPagerProperties(JSON.parse(msg[4].Value), JSON.parse(msg[3].Value));
                    else if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._pagerObj != null) {
                        this._pivotClientObj._pagerObj.initPagerProperties(JSON.parse(msg[4].Value), JSON.parse(msg[3].Value));
                    }
                    if (msg[5] != null && msg[5] != undefined)
                        this.model.customObject = msg[5].Value;
                }
                if (msg[3] != null && msg[3] != undefined && msg[3].Key != "PageSettings")
                    this.model.customObject = msg[3].Value;
            }
            else if (msg.d != undefined) {
                this.setJSONRecords(msg.d[0].Value);
                this.setOlapReport(msg.d[1].Value);
                if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                    this._pivotClientObj.currentReport = JSON.parse(msg.d[1].Value).Report;
                    if (msg.d[2].Value != undefined && msg.d[2].Value != "undefined")
                        this._pivotClientObj.reports = msg.d[2].Value;
                    this._updatePageSettings(msg.d, this._pivotClientObj);
                }
                if (msg.d[3] != null && msg.d[3] != undefined && msg.d[3].Key == "PageSettings") {
                    if (this.model.enableVirtualScrolling || ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj.model.enableVirtualScrolling)) {
                        this._categPageCount = Math.ceil(JSON.parse(msg.d[4].Value).Column / JSON.parse(msg.d[3].Value).CategorialPageSize);
                        this._seriesPageCount = Math.ceil(JSON.parse(msg.d[4].Value).Row / JSON.parse(msg.d[3].Value).SeriesPageSize);
                        this._categCurrentPage = JSON.parse(msg.d[3].Value).CategorialCurrentPage;
                        this._seriesCurrentPage = JSON.parse(msg.d[3].Value).SeriesCurrentPage;
                    }
                    else if (this._pagerObj != null && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                        this._pagerObj.initPagerProperties(JSON.parse(msg.d[4].Value), JSON.parse(msg.d[3].Value));
                    else if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._pagerObj != null) {
                        this._pivotClientObj._pagerObj.initPagerProperties(JSON.parse(msg.d[4].Value), JSON.parse(msg.d[3].Value));
                    }
                    if (msg.d[5] != null && msg.d[5] != undefined)
                        this.model.customObject = msg.d[5].Value;
                }
                if (msg.d[3] != null && msg.d[3] != undefined && msg.d[3].Key != "PageSettings")
                    this.model.customObject = msg.d[3].Value;
            }
            else {
                if (ej.isNullOrUndefined(msg.PivotRecords)) {
                    if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._waitingPopup != null) {
                            this._pivotClientObj._waitingPopup.hide();
                    }
                    else if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                        this._pivotClientObj._waitingPopup.hide();
                    }
                    else if (ej.isNullOrUndefined(this._pivotClientObj)) {
                        this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
                        this._waitingPopup.hide();
                    }
                    return false;
                }
                this.setJSONRecords(msg.PivotRecords);
                this.setOlapReport(msg.OlapReport);
                if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                    this._pivotClientObj.currentReport = JSON.parse(msg.OlapReport).Report;
                    if (msg.ClientReports != undefined && msg.ClientReports != "undefined")
                        this._pivotClientObj.reports = msg.ClientReports;
                    if ((msg.PageSettings != undefined && msg.PageSettings != null) && this._pivotClientObj._pagerObj != null) {
                        this._pivotClientObj._pagerObj.initPagerProperties(JSON.parse(msg.HeaderCounts), JSON.parse(msg.PageSettings));
                    }
                }
                if (msg.PageSettings != undefined && msg.PageSettings != null) {
                    if (this.model.enableVirtualScrolling || ((!ej.isNullOrUndefined(this._pivotClientObj)) && this._pivotClientObj.model.enableVirtualScrolling)) {
                        this._categPageCount = Math.ceil(JSON.parse(msg.HeaderCounts).Column / JSON.parse(msg.PageSettings).CategorialPageSize);
                        this._seriesPageCount = Math.ceil(JSON.parse(msg.HeaderCounts).Row / JSON.parse(msg.PageSettings).SeriesPageSize);
                        this._categCurrentPage = JSON.parse(msg.PageSettings).CategorialCurrentPage;
                        this._seriesCurrentPage = JSON.parse(msg.PageSettings).SeriesCurrentPage;
                    }
                    else if (this._pagerObj && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                        this._pagerObj.initPagerProperties(JSON.parse(msg.HeaderCounts), JSON.parse(msg.PageSettings));
                }
                if (msg.customObject != null && msg.customObject != undefined)
                    this.model.customObject = msg.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "drillDown", element: this.element, customObject: this.model.customObject });
            if (this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout && this.model.enableVirtualScrolling == false && $(".e-pivotpager")[0] == null)
                this.excelLikeLayout(this.getJSONRecords());
            else
            this.renderControlFromJSON(this.getJSONRecords());
            try {
                this.model.currentReport = JSON.parse(this.getOlapReport()).Report;
            }
            catch (err) {
                this.model.currentReport = this.getOlapReport();
            }
            this._trigger("drillSuccess", this.element);
            if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._waitingPopup != null) {
                if ($("#" + this._pivotClientObj._id + "_maxView")[0] && this._maxViewLoading) {
                    this._maxViewLoading.hide();
                    this._pivotClientObj._waitingPopup.hide();
                }
                else if (this._pivotClientObj.model.displaySettings.mode == "gridOnly")
                    this._pivotClientObj._waitingPopup.hide();
            }
            else if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                if (this._pivotClientObj && !this._pivotClientObj._pivotGrid._startDrilldown && !this._pivotClientObj._pivotChart._startDrilldown || this._pivotClientObj.model.displaySettings.mode == "gridOnly")
                    this._pivotClientObj._waitingPopup.hide();
            }
            else if (ej.isNullOrUndefined(this._pivotClientObj)) {
                this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
                this._waitingPopup.hide();
            }
            if (!ej.isNullOrUndefined(this._pivotClientObj))
                this._pivotClientObj._pivotGrid._startDrilldown = false;
            else
                this._waitingPopup.hide();
            var eventArgs = { action: this._drillAction, customObject: this.model.customObject, element: this.element };
            this._trigger("renderSuccess", eventArgs);
        },
		
        saveReport: function (name, storage, url) {
            var mode;
            if (storage.toLowerCase() == "local")
                this._trigger("saveReport", ({ report: this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? this.model.dataSource : this.getOlapReport() }));
            else {
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    report = JSON.stringify(this.model.dataSource);
                    mode = "clientMode";
                }
                else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    report = JSON.parse(this.getOlapReport()).Report;
                    mode = "serverMode";
                }
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "saveReport", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", url + "/" + this.model.serviceMethodSettings.saveReport, JSON.stringify({
                    "reportName": name, "clientReports": report, "operationalMode": mode, "customObject": serializedCustomObject
                }));
            }
        },

        loadReport: function (name, storage, url) {
            var args, mode;
            this._waitingPopup.show();
            if (storage.toLowerCase() == "local") {
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    this._trigger("loadReport", { targetControl: this, dataModel: this.model.analysisMode });
                    this.refreshPivotGrid();
                }
                else {
                    this._trigger("loadReport", { targetControl: this, dataModel: this.model.analysisMode });
                    var clientReports;
                    try {
                        clientReports = JSON.parse(this.getOlapReport()).Report;
                    }
                    catch (err) {
                        clientReports = this.getOlapReport();
                    }
                    if (this.model.beforeServiceInvoke != null)
                        this._trigger("beforeServiceInvoke", { action: "loadReport", element: this.element, customObject: this.model.customObject });
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    args = JSON.stringify({ "action": "loadReport", "gridLayout": this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this.model.layout : this.layout(), "enablePivotFieldList": this.model.enablePivotFieldList, "reportName": name, "operationalMode": "serverMode", "clientReports": clientReports, "customObject": serializedCustomObject });
                    this.doAjaxPost("POST", url + "/" + this.model.serviceMethodSettings.loadReport, args, this._renderControlSuccess);
                }
            }
            else {
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "loadReport", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    mode = "clientMode";
                    this.doAjaxPost("POST", url + "/" + this.model.serviceMethodSettings.loadReport, JSON.stringify({ "action": "loadReport", "gridLayout": this.layout(), "enablePivotFieldList": this.model.enablePivotFieldList, "reportName": name, "operationalMode": mode, "customObject": serializedCustomObject }), this._loadReportSuccess);
                }
                else if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    mode = "serverMode";
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        args = JSON.stringify({ "action": "loadReport", "reportName": name, "gridLayout": this.model.layout, "enablePivotFieldList": this.model.enablePivotFieldList, "operationalMode": mode, "customObject": serializedCustomObject });
                    }
                    else
                        args = JSON.stringify({ "action": "loadReport", "gridLayout": this.layout(), "enablePivotFieldList": this.model.enablePivotFieldList, "reportName": name, "operationalMode": mode, "customObject": serializedCustomObject });
                    this.doAjaxPost("POST", url + "/" + this.model.serviceMethodSettings.loadReport, args, this._renderControlSuccess);
                }
            }
        },

        _loadReportSuccess: function (input) {
			(input.d != undefined && input.d.length > 0) ? this.setOlapReport(JSON.parse(input.d[0].Value)) : this.setOlapReport(JSON.parse(input.report));
            this.model.dataSource = this.getOlapReport();
            this.refreshPivotGrid();
            this._unWireEvents();
            this._wireEvents();
        },
		
        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            if (ej.isNullOrUndefined(data["XMLA"]) && JSON.parse(data)["action"] != "cellEditing") 
                this.model.editCellsInfo = {};
            var contentType, dataType, successEvt, isAsync=true;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, ej.olap.base, customArgs), isAsync = ((ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9) ? false : (!ej.isNullOrUndefined(customArgs) && customArgs["action"] != "loadFieldElements") ? true : false);
            $.ajax({
                type: type,
                url: url,
                contentType: contentType,
                async: isAsync,
                dataType: dataType,
                data: data,
                success: successEvt,
                complete: ej.proxy(function (onComplete) {
                    $.proxy(onComplete, this);
                    var eventArgs = { "action": !ej.isNullOrUndefined(customArgs) && !ej.isNullOrUndefined(customArgs.action) ? customArgs.action : JSON.parse(data)["action"], "customObject": this.model.customObject, element: this.element };
                    this._trigger("renderComplete", eventArgs);
                }, this),
                error: ej.proxy(function (msg, textStatus, errorThrown) {
                    if (typeof this._waitingPopup !='undefined' && this._waitingPopup != null)
                    this._waitingPopup.hide();
                    if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._waitingPopup != null)
                        this._pivotClientObj._waitingPopup.hide();
                    var eventArgs = { "action": this._drillAction != "" ? this._drillAction : "initialize", "customObject": this.model.customObject, "element": this.element, "Message": msg };
                    this._trigger("renderFailure", eventArgs);
                    this.renderControlFromJSON("");
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                       ej.Pivot._createErrorDialog(msg.statusText, this._getLocalizedLabels("Error"), this); msg.statusText
                }, this)
            });
            
        },

        doPostBack: function (url, params) {
            var form = $('<form>').attr({ 'action': url, 'method': 'POST', 'name': 'export' });
            var addParam = function (paramName, paramValue) {
                var input = $('<input type="hidden" title="params">').attr({
                    'id': paramName,
                    'name': paramName,
                    'value': paramValue
                }).appendTo(form);
            };
            for (var item in params)
                addParam(item, params[item]);
            form.appendTo(document.body).submit().remove();
        },

        refreshPagedPivotGrid: function (axis, pageNo) {
            this._isUpdateRequired = true;
            if (ej.isNullOrUndefined(this._pivotClientObj)) {
                this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
                this._waitingPopup.show();
            }
            axis = axis.indexOf('categ') != -1 ? "categorical" : "series";
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if (axis == "categorical")
                    this._categCurrentPage = parseInt(pageNo);
                else
                    this._seriesCurrentPage = parseInt(pageNo);
                ej.olap.base.getJSONData({ action: "navPaging" }, this.model.dataSource, this);
            }
            else {
                var report;
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
                if (!this.model.enableDeferUpdate)
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.paging, JSON.stringify({ "action": "paging", "pagingInfo": axis + ":" + pageNo, "currentReport": report, "layout": this.layout(), "customObject": JSON.stringify(this.model.customObject) }), this._renderControlSuccess);
                else {
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.paging, JSON.stringify({ "action": "pagingDeferUpdate", "pagingInfo": axis + ":" + pageNo, "currentReport": report, "layout": this.layout(), "customObject": JSON.stringify(this.model.customObject) }), this._deferUpdateSuccess);
                }
            }
        },

        excelLikeLayout: function (jsonObj) {
            this._excelRowCount = 0;
            for (var index = 0; index < jsonObj.length; index++) {
                if (parseInt(jsonObj[index].Index.split(',')[0]) == 0)
                    this._excelRowCount++;
                else
                    break;
            }
            this._rowCount = this._excelRowCount;
            var copiedObject = jQuery.extend(true, [], jsonObj), excelLikeJSONRecords = [], tempRecord = [], measurePosition = null, tempColSpan = 0;
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                var olapReport = ($(this.element).parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) ? this._pivotClientObj.getOlapReport() : this.getOlapReport();
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && ((this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.dataSource.rows.length == 0 && this.model.dataSource.data != null) || (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && olapReport !== "" && JSON.parse(olapReport).PivotRows.length == 0))) {
                this._excelLikeJSONRecords = null;
                this.renderControlFromJSON();
                this._excelRowCount = 0;
                return;
            }
            else if (this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot && copiedObject != null && copiedObject != "") {
                var colMeasurePos = null, colHeaderLen;
                //for (var pos = (copiedObject[0].CSS != "colheader" ? (copiedObject[0].ColSpan) * this._rowCount : 0) ; pos < (copiedObject[0].CSS != "colheader" ? (copiedObject[0].ColSpan * this._rowCount + copiedObject[0].RowSpan - 1) : copiedObject.length) && copiedObject[pos].CSS.indexOf("value") == -1 && this._dataModel != "Pivot"; pos++) {
                for (var pos = (copiedObject[0].CSS != "colheader" ? (copiedObject[0].ColSpan) * this._excelRowCount : 0) ; pos < copiedObject.length; pos++) {
                    if (copiedObject[pos].Info.toLowerCase().indexOf("[measure") > -1)
                        colMeasurePos = parseInt(copiedObject[pos].Index.split(',')[1]);
                    if (copiedObject[pos].CSS.indexOf("value") > -1)
                        break;
                    colHeaderLen = parseInt(copiedObject[pos].Index.split(',')[1]);
                }
                if (colMeasurePos != null && colMeasurePos != colHeaderLen && colMeasurePos != 0)
                    this._columnExcelLikeLayout(copiedObject, colMeasurePos, colHeaderLen);  // measure in middle,moved totals at last of the current item
                var columnCount = copiedObject.length / this._excelRowCount;
                for (var columnC = 0; columnC < columnCount && columnC < copiedObject.length; columnC++) {  //Moved total cell to top.
                    for (var rowC = 0; rowC <= colHeaderLen && rowC < copiedObject.length; rowC++) {
                        var index = columnC * this._excelRowCount + rowC;
                        if (copiedObject[index].CSS == "colheader" && copiedObject[index].Span != "Block" && (copiedObject[index].Info.toLowerCase().indexOf("[measure") == -1 ||(copiedObject[index].Info.toLowerCase().indexOf("[measure") > -1 &&  colMeasurePos != null && colMeasurePos == 0)) && copiedObject[index].ColSpan > 1) {
                            for (var i = index; i < index + copiedObject[index].RowSpan; i++) {
                                for (var j = i + this._excelRowCount; j < i + (copiedObject[index].ColSpan * this._excelRowCount) ; j = j + this._excelRowCount)
                                    copiedObject[j].Span = "Block";
                                if (i != index)
                                    copiedObject[i].Span = "Block";
                            }
                            var totalCell = index + (copiedObject[index].RowSpan - 1) + ((copiedObject[index].ColSpan - 1) * this._excelRowCount) + 1, parentIndex = null;
                            if (copiedObject[totalCell].CSS.indexOf("summary") > -1 && copiedObject[totalCell].Value == this._getLocalizedLabels("Total") && copiedObject[totalCell - this._excelRowCount].CSS.indexOf("summary") == -1)
                                parentIndex = totalCell;             //index + (copiedObject[index].RowSpan - 1) + ((copiedObject[index].ColSpan - 1) * this._rowCount) + 1;
                            else if (copiedObject[totalCell].CSS.indexOf("summary") > -1 && copiedObject[totalCell - this._excelRowCount].CSS.indexOf("summary") > -1) {
                                for (var i = totalCell - this._excelRowCount; i >= 0 && i < copiedObject.length; i = i - this._excelRowCount) {
                                    if (copiedObject[i].ColSpan > 1 || (copiedObject[i - this._excelRowCount].CSS.indexOf("summary") == -1 && this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode)) {
                                        parentIndex = i;  //Select total cell parent including unwanted total and multiple measure total.
                                        break;
                                    }
                                }
                            }
                            if (parentIndex != null) {
                                copiedObject[parentIndex].ColSpan = (this.model.operationalMode != ej.PivotGrid.OperationalMode.ClientMode ? copiedObject[parentIndex].ColSpan : (parseInt(copiedObject[totalCell].Index.split(",")[0]) - parseInt(copiedObject[parentIndex].Index.split(",")[0])) + 1);
                                copiedObject[index].ColSpan = copiedObject[index].ColSpan - copiedObject[parentIndex].ColSpan;
                                copiedObject[index + ((copiedObject[index].ColSpan) * this._excelRowCount)] = $.extend(true, {}, copiedObject[parentIndex]);
                                copiedObject[index + ((copiedObject[index].ColSpan) * this._excelRowCount)].RowSpan = copiedObject[parentIndex].RowSpan + copiedObject[index].RowSpan;
                                copiedObject[index + ((copiedObject[index].ColSpan) * this._excelRowCount)].Value = copiedObject[index].Value + " Total";
                            }
                        }
                    }
                }
            }
            if (copiedObject != null && copiedObject != "" && copiedObject[0].CSS != "colheader" && !(this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)) {
                if (copiedObject[0].Index == "0,0" && copiedObject[0].CSS != "colheader") {
                    tempColSpan = copiedObject[0].ColSpan;
                    if (copiedObject[0].RowSpan == 0)
                        copiedObject[0].RowSpan = 1;
                    for (var i = 0; i < copiedObject[0].RowSpan && i < copiedObject.length; i++) {
                        excelLikeJSONRecords.push(copiedObject[i]);
                        copiedObject[i].Level = 1;
                        copiedObject[i].Span = "Block";
                        //copiedObject[i].itemIndex = copiedObject[i].Index;
                    }
                }
                for (var pos = copiedObject[0].RowSpan; pos < copiedObject.length && this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot && this.model.dataSource.rows.length > 0; pos = pos + this._excelRowCount) {
                    if (copiedObject[pos].Info.toLowerCase().indexOf("[measure") > -1) {
                        measurePosition = parseInt(copiedObject[pos].Index.split(',')[0]);
                        break;
                    }
                }
                for (var index = 0; index < copiedObject.length && index < this._excelRowCount; index++) {
                    if (copiedObject[index].CSS == "rowheader" && parseInt(copiedObject[index].Index.split(',')[0]) == 0 && copiedObject[index].Span != "Block") {
                        copiedObject[index].Level = 1;
                        if (copiedObject[index + this._excelRowCount] != null && copiedObject[index + this._excelRowCount].CSS.indexOf("value") == -1)
                            copiedObject[index].itemIndex = copiedObject[index + copiedObject[index].RowSpan - (this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot ? 1 : 0)].Index;
                        excelLikeJSONRecords.push(copiedObject[index]);
                        if (measurePosition != null && measurePosition == 0 && copiedObject[index].Info.toLowerCase().indexOf("[measure") > -1)
                            tempRecord.push(copiedObject[index]);
                        for (var i = index + 1; i < index + copiedObject[index].RowSpan; i++) {
                            if (copiedObject[i].Info.toLowerCase().indexOf("[measure") == -1 || measurePosition != null && measurePosition != tempColSpan - 1)
                                copiedObject[i].Span = "Block";
                        }
                        this._rowExcelLikeLayout(index, copiedObject, excelLikeJSONRecords, 2, measurePosition, tempRecord, tempColSpan);
                    }
                    else if ((copiedObject[index].CSS == "summary rgtot" || copiedObject[index].CSS == "summary gtot" || copiedObject[index].CSS == "summary calc gtot" || (copiedObject[index].CSS == "colheader" && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) || (((copiedObject[index].CSS == "summary" && copiedObject[index].Value.indexOf(this._getLocalizedLabels("Total")) > -1) || copiedObject[index].CSS == "summary row") && this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot)) && parseInt(copiedObject[index].Index.split(',')[0]) == 0) {
                        if (measurePosition != null && measurePosition == tempColSpan - 1)
                            copiedObject[index].Value += " " + copiedObject[index + (this._excelRowCount * parseInt(copiedObject[index].ColSpan))].Value;
                        copiedObject[index].Value = copiedObject[index].Value == this._getLocalizedLabels("Total") ? this._getLocalizedLabels("GrandTotal") : copiedObject[index].Value;
                        excelLikeJSONRecords.push(copiedObject[index]);
                        copiedObject[index].Level = 1;
                    }
                }
                if (measurePosition != null && measurePosition == 0) {
                    for (var index = 0; index < tempRecord.length; index++) {
                        excelLikeJSONRecords.push($.extend(true, {}, tempRecord[index]));
                        excelLikeJSONRecords[excelLikeJSONRecords.length - 1].CSS = "summary";
                        excelLikeJSONRecords[excelLikeJSONRecords.length - 1].Value = this._getLocalizedLabels("Total")+" " + excelLikeJSONRecords[excelLikeJSONRecords.length - 1].Value;
                    }
                    tempRecord.splice(0, tempRecord.length);
                }
                var len = excelLikeJSONRecords.length, currentIndex = 0, valueIndex, nextIndex;
                var isInsertable = false;
                for (var index = 0; index < len; index++) {
                    currentIndex = currentIndex + index;
                    valueIndex = excelLikeJSONRecords[index].itemIndex != null ? excelLikeJSONRecords[index].itemIndex : excelLikeJSONRecords[index].Index;
                    nextIndex = (parseInt(valueIndex.split(',')[0]) * this._excelRowCount + (parseInt(valueIndex.split(',')[1])));
                    for (var nextItem = nextIndex ; nextItem < copiedObject.length; nextItem = nextItem + this._excelRowCount) {
                        if (((copiedObject[nextItem].CSS.indexOf("value") > -1 || copiedObject[nextItem].CSS.indexOf("colheader") > -1 || copiedObject[nextItem].CSS.indexOf("calc") > -1 || copiedObject[nextItem].CSS.indexOf("cstot") > -1 || copiedObject[nextItem].CSS.indexOf("cgtot") > -1) || copiedObject[nextItem].CSS.indexOf("none") > -1) && parseInt(copiedObject[nextItem].Index.split(',')[0]) >= tempColSpan)
                            isInsertable = true;
                        if (isInsertable) {
                            currentIndex = currentIndex + (this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot ? parseInt(len) : this._excelRowCount);
                            excelLikeJSONRecords[currentIndex] = $.extend(true, {}, copiedObject[nextItem]);
                        }
                    }
                    currentIndex = 0;
                    isInsertable = false;
                }
                for (var index = 0; index < len; index++) {
                    if (excelLikeJSONRecords[index] != null) {
                        excelLikeJSONRecords[index].Span = "none";
                        if (isNaN(excelLikeJSONRecords[index].Level))
                            excelLikeJSONRecords[index].Level = 1;
                        // excelLikeJSONRecords[index].Index = '0,' + index + '';
                        if (!(excelLikeJSONRecords[index].Index == "0,0" && excelLikeJSONRecords[index].CSS != "colheader" && index == 0))
                            excelLikeJSONRecords[index].RowSpan = 1;
                        if (measurePosition != null && measurePosition == tempColSpan - 1 && excelLikeJSONRecords[index].CSS == "rowheader" && excelLikeJSONRecords[index].Info.toLowerCase().indexOf("[measure") == -1)
                            excelLikeJSONRecords[index].ColSpan = excelLikeJSONRecords.length / len;
                        else if (measurePosition != null && measurePosition == 0 && (excelLikeJSONRecords[index].Info.toLowerCase().indexOf("[measure") > -1 && (excelLikeJSONRecords[index].CSS == "rowheader")))
                            excelLikeJSONRecords[index].ColSpan = excelLikeJSONRecords.length / len;
                        else if (measurePosition != null && measurePosition != tempColSpan - 1 && measurePosition != 0 && (excelLikeJSONRecords[index].Info.toLowerCase().indexOf("[measure") > -1 || (excelLikeJSONRecords[index].CSS == "rowheader" && parseInt(excelLikeJSONRecords[index].Index.split(",")[0]) < measurePosition)))
                            excelLikeJSONRecords[index].ColSpan = excelLikeJSONRecords.length / len;
                        else
                            excelLikeJSONRecords[index].ColSpan = 1;
                    }
                }
                this._excelRowCount = len;
            }
            if (copiedObject != null && excelLikeJSONRecords.length == 0)
                excelLikeJSONRecords = copiedObject;
            for (var i = 0; i < excelLikeJSONRecords.length / this._excelRowCount ; i++) {
                for (var j = 0; j < this._excelRowCount ; j++) {
                    excelLikeJSONRecords[i * this._excelRowCount + j].i = "" + i + "," + j + "";
                    excelLikeJSONRecords[i * this._excelRowCount + j].Span = "none";
                }
            }
            this._excelLikeJSONRecords = excelLikeJSONRecords;
            this.renderControlFromJSON();

        },
        _rowExcelLikeLayout: function (index, copiedObject, excelLikeJSONRecords, level, measurePosition, tempRecord,tempColSpan) {
            var isMeasure = false;
            for (var rowCellIndex = index + (this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot ? copiedObject[index].ColSpan * this._excelRowCount : this._excelRowCount), span = 0; span < copiedObject[index].RowSpan && rowCellIndex < copiedObject.length && (copiedObject[rowCellIndex].CSS.indexOf("value")==-1) ; rowCellIndex++, span++) {
                if ((measurePosition != null && measurePosition != tempColSpan - 1 && measurePosition != 0) && copiedObject[rowCellIndex].Info.toLowerCase().indexOf("[measure")>-1 && copiedObject[rowCellIndex].Span != "Block")
                    isMeasure = true;
                var isMeasureLast = (measurePosition != null && measurePosition == tempColSpan - 1) ? (copiedObject[rowCellIndex].CSS == "summary row" && (copiedObject[rowCellIndex + this._excelRowCount].CSS == "summary row" || copiedObject[rowCellIndex + this._excelRowCount].CSS == "none" || copiedObject[rowCellIndex + this._excelRowCount].Info.toLowerCase().indexOf("[measure") > -1)) : (measurePosition != null && measurePosition != tempColSpan - 1 && measurePosition != 0) ? (copiedObject[rowCellIndex].CSS == "summary" && (copiedObject[rowCellIndex + this._excelRowCount].CSS == "summary" || copiedObject[rowCellIndex + this._excelRowCount].CSS == "none" || copiedObject[rowCellIndex + this._excelRowCount].Info.toLowerCase().indexOf("[measure") > -1 || parseInt(copiedObject[rowCellIndex].Index.split(",")[0]) - 1 <= measurePosition)) : false;
                if (((copiedObject[rowCellIndex].CSS == "rowheader" || copiedObject[rowCellIndex].CSS == "none") || isMeasureLast) && copiedObject[rowCellIndex].Span != "Block") {
                    for (var i = rowCellIndex + 1; i < rowCellIndex + copiedObject[rowCellIndex].RowSpan; i++) {
                        if (copiedObject[i].Info.toLowerCase().indexOf("[measure") == -1 || measurePosition != null && measurePosition != tempColSpan - 1)
                            copiedObject[i].Span = "Block";
                    }
                    copiedObject[rowCellIndex].Level = level;
                    if (copiedObject[rowCellIndex].CSS != "none") {
                        if (copiedObject[rowCellIndex + this._excelRowCount] != null && copiedObject[rowCellIndex + this._excelRowCount].CSS.indexOf("value") == -1)
                            copiedObject[rowCellIndex].itemIndex = copiedObject[rowCellIndex + copiedObject[rowCellIndex].RowSpan - (this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot ? 1 : 0)].Index;
                        if (isMeasureLast) {
                            for (var rowIndex = rowCellIndex - copiedObject[index].ColSpan * this._excelRowCount; rowIndex >= 0 && rowIndex < copiedObject.length; rowIndex--) {
                                if (copiedObject[rowIndex].Value != "") {
                                    copiedObject[rowCellIndex].Value = copiedObject[rowIndex].Value;
                                    copiedObject[rowCellIndex].Level = copiedObject[index].Level; //== 1 ? 1 : (copiedObject[index].Level - 2) <= 1 ? ;
                                    break;
                                }
                            }
                            if ((measurePosition != null && measurePosition != tempColSpan - 1 && measurePosition != 0) && parseInt(copiedObject[rowCellIndex].Index.split(",")[0]) - 1 == measurePosition)
                                tempRecord.push(copiedObject[rowCellIndex]);
                            else {
                                copiedObject[rowCellIndex].Value += " " + copiedObject[rowCellIndex + (this._excelRowCount * parseInt(copiedObject[rowCellIndex].ColSpan))].Value;
                                excelLikeJSONRecords.push(copiedObject[rowCellIndex]);
                            }
                        }
                        else
                            excelLikeJSONRecords.push(copiedObject[rowCellIndex]);
                    }
                    copiedObject[rowCellIndex].Span = "Block";
                    if (copiedObject[rowCellIndex].CSS != "summary row" && copiedObject[rowCellIndex].CSS != "summary")
                        this._rowExcelLikeLayout(rowCellIndex, copiedObject, excelLikeJSONRecords, level + 1, measurePosition, tempRecord, tempColSpan);
                }
                if (isMeasure && span + 1 == copiedObject[index].RowSpan) {
                    isMeasure = false;
                    for (var i = 0; i < tempRecord.length; i++) {
                        // tempRecord[i].Value = tempRecord[i].Value.split(" ")[0];
                        tempRecord[i].Value = copiedObject[index].Value + " " + tempRecord[i].Value;
                        excelLikeJSONRecords.push(tempRecord[i]);
                    }
                    tempRecord.splice(0, tempRecord.length);
                }
            }
        },
        _columnExcelLikeLayout: function (copiedObject, colMeasurePos, colHeaderLen) {    //Moves total to last of current item, when measure is above 1
            var columnCount = copiedObject.length / this._excelRowCount;
            for (var columnC = 0; columnC < columnCount && columnC < copiedObject.length; columnC++) {
                for (var rowC = 0; rowC <= colHeaderLen && rowC < copiedObject.length; rowC++) {
                    var index = columnC * this._excelRowCount + rowC;
                    if (copiedObject[index].CSS == "colheader" && copiedObject[index].Span != "Block" && copiedObject[index].Info.toLowerCase().indexOf("[measure") == -1 && copiedObject[index].ColSpan > 1) {
                        for (var i = index; i < index + copiedObject[index].RowSpan; i++) {
                            for (var j = i + this._excelRowCount; j < i + (copiedObject[index].ColSpan * this._excelRowCount) ; j = j + this._excelRowCount)
                                copiedObject[j].Span = "Block";
                            if (i != index)
                                copiedObject[i].Span = "Block";
                        }
                        var measureCell = index + (copiedObject[index].RowSpan - 1) + ((copiedObject[index].ColSpan - 1) * this._excelRowCount) + 1;
                        if (copiedObject[measureCell].Info.toLowerCase().indexOf("[measure") > -1 && JSON.parse(this.getOlapReport()).PivotCalculations.length > 1 && colMeasurePos != null && colMeasurePos != colHeaderLen && colMeasurePos != 0) {
                            //var start = parseInt(copiedObject[index].Index.split(",")[0]), end = parseInt(copiedObject[measureCell - 1].Index.split(",")[0]);
                            var removeIndex = [];
                            for (var i = index + (copiedObject[index].RowSpan) ; i <= measureCell; i = i + (copiedObject[i].ColSpan + 1) * this._excelRowCount) { //loop from start to end of the current item for slecting measure totals
                                var totalCell = i + (copiedObject[i].RowSpan - 1) + ((copiedObject[i].ColSpan - 1) * this._excelRowCount) + 1;
                                if (copiedObject[totalCell].CSS.indexOf("summary") > -1) {       //&& copiedObject[totalCell].Value == "Total" && copiedObject[totalCell - this._rowCount].CSS.indexOf("summary") == -1) {                                     copiedObject[totalCell].Value = "";
                                    copiedObject[totalCell - 1].RowSpan = copiedObject[totalCell - 1].RowSpan + copiedObject[totalCell].RowSpan;
                                    var colToDel = (parseInt(copiedObject[totalCell].Index.split(',')[0]) * this._excelRowCount);
                                    for (var j = 0; j < this._excelRowCount; j++)
                                        copiedObject.splice((parseInt(copiedObject[measureCell].Index.split(',')[0]) * this._excelRowCount + this._excelRowCount) + j + removeIndex.length * this._excelRowCount, 0, $.extend(true, {}, copiedObject[colToDel + j]));  //Insert total cell column at last of current item and store that index
                                    removeIndex.push(colToDel);
                                    copiedObject[i].ColSpan = copiedObject[i].ColSpan - 1;
                                }
                            }
                            for (var colIndex = removeIndex.length - 1; colIndex >= 0; colIndex--)
                                copiedObject.splice((parseInt(copiedObject[removeIndex[colIndex]].Index.split(',')[0]) * this._excelRowCount), this._excelRowCount); // after inserting all totals for current item at last , remove the column at initial posiiton
                            if (removeIndex.length > 0) {
                                copiedObject[index].ColSpan = copiedObject[index].ColSpan - removeIndex.length;
                                var newTotal = index + ((copiedObject[index].ColSpan) * this._excelRowCount);
                                copiedObject[newTotal].ColSpan = removeIndex.length;
                                copiedObject[newTotal].RowSpan = copiedObject[index].RowSpan;
                                copiedObject[newTotal].Value = copiedObject[index].Value + " Total";
                                copiedObject[newTotal].CSS = "summary";
                                copiedObject[newTotal].Span = "none";
                                copiedObject[newTotal].State = 0;
                            }
                        }
                        else if (copiedObject[measureCell].Info.toLowerCase().indexOf("[measure") > -1 && copiedObject[measureCell + 1].CSS.indexOf("summary") > -1 && JSON.parse(this.getOlapReport()).PivotCalculations.length == 1 && colMeasurePos != null && colMeasurePos != colHeaderLen && colMeasurePos != 0) {
                            copiedObject[index].ColSpan = copiedObject[index].ColSpan - 1;
                            copiedObject[index + ((copiedObject[index].ColSpan) * this._excelRowCount)] = $.extend(true, {}, copiedObject[measureCell + 1]);
                            copiedObject[measureCell + 1].Value = "";
                            copiedObject[index + ((copiedObject[index].ColSpan) * this._excelRowCount)].Value = copiedObject[index].Value + " Total";
                            copiedObject[index + ((copiedObject[index].ColSpan) * this._excelRowCount)].RowSpan = copiedObject[index].RowSpan;
                        }
                    }
                }
            }
        },
        _getColumnIndices: function (axis, jsonValue, mValue,val) {
            var value = axis == "rows" ? jsonValue.Index.split(",")[1] : axis == "columns" ? jsonValue.Index.split(",")[0] : null;
            if (jsonValue.Value == mValue) {
                $.inArray(Number(value), val) == -1 ? val.push(Number(value)) : val;
            }
            return val;
        },
        renderControlFromJSON: function () {
            var sortEle = null;
            if (!(ej.isNullOrUndefined(this.model.valueSortSettings)) && this.element.find(".valueSorting").length > 0 && !(ej.isNullOrUndefined(ej.PivotAnalysis._valueSorting))) {
                sortEle = this.element.find(".valueSorting").parent();
            }
            var jsonObj = this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout ? this._excelLikeJSONRecords : this.getJSONRecords();
            if (!(ej.isNullOrUndefined(jsonObj))) jsonObj = this._appendCssClassName(jsonObj);
            if (this.model.enableConditionalFormatting && this._isFormatApply)
                jsonObj = this._refreshCellFormatting(jsonObj);
            if (this.model.enableConditionalFormatting && !this._isFormatApply)
                jsonObj = this._applyCodeBehindFormatting(jsonObj);
            if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar && !this._pivotClientObj.model.displaySettings.enableFullScreen)
                var toolBar = $("<div id=" + this._id + "Toolbar style='width:" + this._pivotClientObj._gridWidth + ";height:" + this._pivotClientObj._gridHeight + ";overflow:auto;margin-top:5px;margin-left:5px'></div>");
            if (jsonObj != null && jsonObj != "") {
                for (var l = 0; l < jsonObj.length; l++) {
                    if (jsonObj[l].Value == "Total")
                        jsonObj[l].Value = this._getLocalizedLabels("Total");
                    if (jsonObj[l].Value == "Grand Total")
                        jsonObj[l].Value = this._getLocalizedLabels("GrandTotal");
                }
            }
            if (this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                this._applyLocale(jsonObj);
            }

            var tableOlapGrid = $("<table class=\"pivotGridTable\" cellspacing=\"0\" cellpadding=\"0\" role='grid'  aria-readonly='true'></table>");
            if (this.model.isResponsive)
                tableOlapGrid.addClass("e-table");
            if (((jsonObj == null || jsonObj == "") && !this.model.enableGroupingBar)) {
                var theademptyGrid = ej.buildTag("tr", ej.buildTag("th", "", { "width": "70px" })[0].outerHTML + ej.buildTag("th", "", { "width": "70px" })[0].outerHTML + ej.buildTag("th", "", { "width": "70px" })[0].outerHTML);
                var tbodyemptyGrid = ej.buildTag("tr", ej.buildTag("td", "", { "width": "70px" })[0].outerHTML + ej.buildTag("td", "", { "width": "70px" })[0].outerHTML + ej.buildTag("td", "", { "width": "70px" })[0].outerHTML)[0].outerHTML +
                                     ej.buildTag("tr", ej.buildTag("td", "", { "width": "70px" })[0].outerHTML + ej.buildTag("td", "", { "width": "70px" })[0].outerHTML + ej.buildTag("td", "", { "width": "70px" })[0].outerHTML)[0].outerHTML +
                                     ej.buildTag("tr", ej.buildTag("td", "", { "width": "70px" })[0].outerHTML + ej.buildTag("td", "", { "width": "70px" })[0].outerHTML + ej.buildTag("td", "", { "width": "70px" })[0].outerHTML)[0].outerHTML;

                $(tableOlapGrid).append(theademptyGrid);
                $(tableOlapGrid).append(tbodyemptyGrid);
                this._rowCount = 0;
            }
            else if (jsonObj != null && jsonObj != "") {
                var rowCount = this._rowCount;
                this._rowCount = 0;
                var pGridObj = this;
                //***************Finding row count with first column***********

                for (var index = 0; index < jsonObj.length; index++) {
                    if (parseInt(jsonObj[index].Index.split(',')[0]) == 0)
                        this._rowCount++;
                    else
                        break;
                }

                //***************Finding row count by last json record***********
                //this._rowCount = parseInt(jsonObj[jsonObj.length - 1].Index.split(',')[1]) + 1;
                this._rowCount = this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout ? this._excelRowCount : this._rowCount;
                var theadOlapGrid = $("<thead></thead>");
                var tbodyOlapGrid = $("<tbody></tbody>");
                var istheadOlapGrid = true; var columnHeaderHeight = 0;
                if (jsonObj[0].CSS == "none") {
                    if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && JSON.parse(this.getOlapReport()).PivotCalculations.length == 0 && JSON.parse(this.getOlapReport()).PivotRows.length == 0)
                        columnHeaderHeight = JSON.parse(this.getOlapReport()).PivotColumns.length - 1;
                    else
                        columnHeaderHeight = jsonObj[0].RowSpan - 1;
                }
                else {
                    jQuery.each(jsonObj, function (index, value) {
                        // if (jsonObj[index].CSS == "colheader")
                        columnHeaderHeight += jsonObj[index].RowSpan;
                        return (jsonObj[index].CSS == "colheader");
                    });
                    columnHeaderHeight = columnHeaderHeight - 2;
                }
                var isFrozenHeader = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders;
                var isNoRow = false;
                for (var index = 0; index < jsonObj.length; index++) {
                    if (index < this._rowCount) {
                        if (istheadOlapGrid) {
                            istheadOlapGrid = (index >= columnHeaderHeight) ? false : true;
                            var tRow = "<tr role='row'>";
                            if (this.model.enableGroupingBar) {
                                if (jsonObj[index].Index == "0,0" && jsonObj[index].CSS == "colheader") {
                                    tRow = tRow + "<" + (isFrozenHeader ? "td" : "th") + " class='grpRow'" + " p='-1,-1' colspan= 1 rowspan=" + (this._rowCount - 1) + "> <div class=rows>" + this._getLocalizedLabels("DragFieldHere") + "</div></th>";
                                    isNoRow = true;
                                }

                            }
                            for (var column = index; column < jsonObj.length; column = column + this._rowCount) {
                                if (jsonObj[column].Span != "Block") {

                                    if (jsonObj[column].Index == "0,0" && jsonObj[column].CSS != "colheader" && this.model.enableGroupingBar) {
                                        tRow = tRow + "<" + (isFrozenHeader ? "td" : "th") + " class=" + "grpRow" + " p=" + jsonObj[column].Index + " colspan=" + jsonObj[column].ColSpan + " rowspan=" + jsonObj[column].RowSpan + " role='columnheader' aria-describedby='row'" + ((jsonObj[column].i == null) ? "" : "i=" + jsonObj[column].i) + ">" + ej.buildTag("span#row", "rows", { "display": "none" })[0].outerHTML + (jsonObj[column].State == 0 ? "<span style=\"margin-left: 0px\"></span>" : jsonObj[column].State == 2 ? "<span class=\"expand\ e-icon\" aria-describedby='expansion' title=\"" + this._getLocalizedLabels("Expand") + "\">&nbsp;<p id='expansion' style='display:none'>collapsed</p></span>" : (jsonObj[column].State == 1 ? "<span class=\"collapse\ e-icon\" aria-describedby='collapsing' title=\"" + this._getLocalizedLabels("Collapse") + "\">&nbsp;<p id='collapsing' style='display:none'>expanded</p></span>" : "")) + jsonObj[column].Value + ej.buildTag("div.rows", this._pivotRow, {})[0].outerHTML + "</th>";
                                    }
                                    else
                                        tRow = tRow + "<" + (isFrozenHeader ? "td" : "th") + (jsonObj[column].CSS == "none" ? "" : " class=\"" + jsonObj[column].CSS) + (jsonObj[column].CSS == "none" ? " p=" + jsonObj[column].Index : "\" p=" + jsonObj[column].Index) + " colspan=" + jsonObj[column].ColSpan + " rowspan=" + jsonObj[column].RowSpan + " role='columnheader'" + ((jsonObj[column].i == null) ? "" : "i=" + jsonObj[column].i) + ">" + (jsonObj[column].State == 0 ? "<span style=\"margin-left: 10px\"></span>" : (jsonObj[column].State == 2) ? "<span class=\"expand\ e-icon\" aria-describedby='expansion' title=\"" + this._getLocalizedLabels("Expand") + "\">&nbsp;<p id='expansion' style='display:none'>collapsed</p></span>" : (jsonObj[column].State == 1 ? "<span class=\"collapse\ e-icon\" aria-describedby='collapsing' title=\" " + this._getLocalizedLabels("Collapse") + "\">&nbsp;<p id='collapsing' style='display:none'>expanded</p></span>" : "")) + jsonObj[column].Value + "</th>";
                                    if (jsonObj[column].RowSpan > 1 && jsonObj[column].ColSpan <= 1) {
                                        for (var i = column + 1; i < column + jsonObj[column].RowSpan; i++)
                                            jsonObj[i].Span = "Block";
                                    }
                                    else if (jsonObj[column].ColSpan > 1 && jsonObj[column].RowSpan <= 1) {
                                        for (var i = column + this._rowCount; i < column + (jsonObj[column].ColSpan * this._rowCount) ; i = i + this._rowCount)
                                            jsonObj[i].Span = "Block";
                                    }
                                    else if (jsonObj[column].ColSpan > 1 && jsonObj[column].RowSpan > 1) {
                                        for (var i = column; i < column + jsonObj[column].RowSpan; i++) {
                                            for (var j = i + this._rowCount; j < i + (jsonObj[column].ColSpan * this._rowCount) ; j = j + this._rowCount)
                                                jsonObj[j].Span = "Block";
                                            if (i != column)
                                                jsonObj[i].Span = "Block";
                                        }
                                    }
                                }
                            }
                            tRow += "</tr>";
                            if ($(tRow).text() != "")
                                $(theadOlapGrid).append(tRow);
                        }
                        else {
                            var tRow = "<tr role='row'>";
                            if (parseInt(jsonObj[index].Index.split(',')[0]) == 0 && parseInt(jsonObj[index].Index.split(',')[1]) == (this._rowCount - 1) && isNoRow) {
                                tRow = tRow + "<td class='rowheader'" + " p='-1,-2' colspan=1 rowspan=1>" + ((this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot || this.model.layout == ej.PivotGrid.Layout.ExcelLikeLayout) ? this._getLocalizedLabels("GrandTotal") : this._getLocalizedLabels("Total")) + "</td>";
                            }
                            for (var column = index; column < jsonObj.length; column = column + this._rowCount) {
                                if (jsonObj[column].Span != "Block") {
                                    if (jsonObj[column].CSS == "rowheader" || jsonObj[column].CSS == "summary" || jsonObj[column].CSS.indexOf("summary rstot") > -1 || jsonObj[column].CSS.indexOf("summary stot") > -1 || jsonObj[column].CSS == "summary row" || jsonObj[column].CSS.indexOf("summary rgtot") > -1) {
                                        if (this.layout().toLowerCase() == "excellikelayout") {
                                            tRow = tRow + "<" + (isFrozenHeader ? "td" : "th") + (jsonObj[column].CSS == "none" ? "" : " class=\"" + jsonObj[column].CSS) + "\" p=" + jsonObj[column].Index + " colspan=" + jsonObj[column].ColSpan + " rowspan=" + jsonObj[column].RowSpan + " role='rowheader'" + ((jsonObj[column].i == null) ? "" : "i=" + jsonObj[column].i) + ">" + (jsonObj[column].State == 2 ? "<span style=\"margin-" + (this.model.enableRTL ? "right:" : "left:") + (jsonObj[column].Level * 10) + "px\" class=\"expand\ e-icon\" aria-describedby='expansion' title=\"" + this._getLocalizedLabels("Expand") + "\">&nbsp;<p id='expansion' style='display:none'>collapsed</p></span>" : (jsonObj[column].State == 1 ? "<span style=\"margin-" + (this.model.enableRTL ? "right:" : "left:") + (jsonObj[column].Level * 10) + "px\" class=\"collapse\ e-icon\" aria-describedby='collapsing' title=\"" + this._getLocalizedLabels("Collapse") + "\">&nbsp;<p id='collapsing' style='display:none'>expanded</p></span>" : "<span style=\"margin-" + (this.model.enableRTL ? "right:" : "left:") + ((this._excelLikeJSONRecords != null && jsonObj[column].CSS == "summary row") ? jsonObj[column].Level * 10 : ((jsonObj[column].Level == 1 ? 1 : jsonObj[column].Level + 2) * 10)) + "px\">&nbsp;</span>")) + jsonObj[column].Value + "</th>";
                                        }
                                        else {
                                            tRow = tRow + "<" + (isFrozenHeader ? "td" : "th") + (jsonObj[column].CSS == "none" ? "" : " class=\"" + jsonObj[column].CSS) + "\" p=" + jsonObj[column].Index + " colspan=" + jsonObj[column].ColSpan + " rowspan=" + jsonObj[column].RowSpan + " role='rowheader'>" + (jsonObj[column].State == 0 ? "<span style=\"margin-left: 10px\"></span>" : (jsonObj[column].State == 2) ? "<span class=\"expand\ e-icon\" aria-describedby='expansion' title=\"" + this._getLocalizedLabels("Expand") + "\">&nbsp;<p id='expansion' style='display:none'>collapsed</p></span>" : (jsonObj[column].State == 1 ? "<span class=\"collapse\ e-icon\" aria-describedby='collapsing' title=\"" + this._getLocalizedLabels("Collapse") + "\">&nbsp;<p id='collapsing' style='display:none'>expanded</p></span>" : "")) + jsonObj[column].Value + "</th>";
                                        }
                                    }
                                    else
                                        tRow = tRow + "<td" + (jsonObj[column].CSS == "none" ? "" : " class=\"" + jsonObj[column].CSS) + "\" p=" + jsonObj[column].Index + " colspan=" + jsonObj[column].ColSpan + " rowspan=" + jsonObj[column].RowSpan + " role='gridcell'" + ((jsonObj[column].i == null) ? "" : "i=" + jsonObj[column].i) + ">" + (jsonObj[column].State == 2 ? "<span class=\"expand\ e-icon\" title=\"" + this._getLocalizedLabels("Expand") + "\">&nbsp;</span>" : (jsonObj[column].State == 1 ? "<span class=\"collapse\ e-icon\" title=\"" + this._getLocalizedLabels("Collapse") + "\">&nbsp;</span>" : "")) + jsonObj[column].Value + "</td>";
                                    if (jsonObj[column].RowSpan > 1 && jsonObj[column].ColSpan <= 1) {
                                        for (var i = column + 1; i < column + jsonObj[column].RowSpan; i++)
                                            jsonObj[i].Span = "Block";
                                    }
                                    else if (jsonObj[column].ColSpan > 1 && jsonObj[column].RowSpan <= 1) {
                                        for (var i = column + this._rowCount; i < column + (jsonObj[column].ColSpan * this._rowCount) ; i = i + this._rowCount)
                                            jsonObj[i].Span = "Block";
                                    }
                                    else if (jsonObj[column].ColSpan > 1 && jsonObj[column].RowSpan > 1) {
                                        for (var i = column; i < column + jsonObj[column].RowSpan; i++) {
                                            for (var j = i + this._rowCount; j < i + (jsonObj[column].ColSpan * this._rowCount) ; j = j + this._rowCount)
                                                jsonObj[j].Span = "Block";
                                            if (i != column)
                                                jsonObj[i].Span = "Block";
                                        }
                                    }
                                }
                            }
                            tRow += "</tr>";
                            if ($(tRow).text() != "")
                                $(tbodyOlapGrid).append(tRow);
                        }
                    }
                }

                if (isFrozenHeader) {
                    this._renderFrozenGridTable(tableOlapGrid, theadOlapGrid, tbodyOlapGrid);
                }
                else {
                    $(tableOlapGrid).append(theadOlapGrid);
                    $(tableOlapGrid).append(tbodyOlapGrid);
                }

            }
            this._unWireEvents();
            this._wireEvents();
            if ((!this.model.enableVirtualScrolling) && $(tableOlapGrid).find("tr:last > td").length > 0 && ($(tableOlapGrid).find("tr:last").find("td").text() == "" && (!(this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot))) && (this._pagerObj == null))
                $(tableOlapGrid).find("tr:last").hide();
            if (!this.model.enablePaging && !this.model.enableVirtualScrolling) {
                this._hideGrandTotal(tableOlapGrid);
                this._hideSubTotal(tableOlapGrid);
            }
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && (this.model.enableCollapseByDefault || !ej.isNullOrUndefined(this.model.collapsedMembers)) && !ej.isNullOrUndefined(jsonObj)) {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.enableCollapseByDefault) {
                    var isFrozenHeader = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders;
                    var _rowCount = (!ej.isNullOrUndefined(this.model.dataSource.data)) ? this.model.dataSource.rows.length : ($(this.element).parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? JSON.parse(this._pivotClientObj.getOlapReport()).PivotRows.length : JSON.parse(this.getOlapReport()).PivotRows.length;
                    var columnCount = (!ej.isNullOrUndefined(this.model.dataSource.data)) ? this.model.dataSource.columns.length : ($(this.element).parents(".e-pivotclient").length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) ? JSON.parse(this._pivotClientObj.getOlapReport()).PivotColumns.length : JSON.parse(this.getOlapReport()).PivotColumns.length;
                    this.model.collapsedMembers = {};
                    for (var rh = _rowCount; rh >= 0; rh--) {
                        if (isFrozenHeader)
                            thRList = $(tableOlapGrid).find(".pivotGridRowTable [p^='" + rh + ",']:has('span.collapse')[class^='rowheader']");
                        else
                            thRList = $(tableOlapGrid).find("th[p^='" + rh + ",']:has('span.collapse')[class^='rowheader']");
                        var field = this._getFieldName(thRList[0]);
                        this.model.collapsedMembers[field] = new Array();
                        for (var thcnt = 0; thcnt < thRList.length; thcnt++) {
                            this.model.collapsedMembers[field].push($(thRList[thcnt]).clone().children().remove().end().text());
                            this._collapseMember(tableOlapGrid, $(thRList[thcnt]).find('.collapse'));
                        }
                    }
                    for (var ch = columnCount; ch >= 0; ch--) {
                        thCList = $(tableOlapGrid).find((isFrozenHeader ? ".pivotGridFrozenTable " : "th") + "[p$='," + ch + "']:has('span.collapse')[class$='colheader']");
                        var field = this._getFieldName(thCList[0]);
                        this.model.collapsedMembers[field] = new Array();
                        for (var thcnt = 0; thcnt < thCList.length; thcnt++) {
                            this.model.collapsedMembers[field].push($(thRList[thcnt]).clone().children().remove().end().text());
                            this._collapseMember(tableOlapGrid, $(thCList[thcnt]).find('.collapse'));
                        }
                    }
                }
                else if (!ej.isNullOrUndefined(this.model.collapsedMembers)) {
                    var pivotGrid = this;
                    $.each(this.model.collapsedMembers, function (index, item) {
                        var item = item;
                        var fieldIndex, axis;
                        if (pivotGrid.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                            for (var i = 0; i < pivotGrid.model.dataSource.rows.length; i++)
                                if (pivotGrid.model.dataSource.rows[i].fieldName == index) { fieldIndex = i; axis = "row"; }
                            for (var i = 0; i < pivotGrid.model.dataSource.columns.length; i++)
                                if (pivotGrid.model.dataSource.columns[i].fieldName == index) { fieldIndex = i; axis = "column"; }
                            if (!ej.isNullOrUndefined(fieldIndex)) {
                                if (axis == "row") {
                                    for (var i = pivotGrid.model.dataSource.columns.length + 1, currentCell; i < pivotGrid._rowCount; i += ej.isNullOrUndefined(currentCell) ? 1 : currentCell.rowSpan) {
                                        currentCell = $(tableOlapGrid).find("tBody th[p='" + fieldIndex + "," + i + "']")[0];
                                        var isMatched = false;
                                        for (var j = 0; j < item.length; j++) {
                                            if ($(currentCell).text().replace("expanded", "").trim() == item[j].toString().trim()) {
                                                isMatched = true;
                                                break;
                                            }
                                        }
                                        if (!ej.isNullOrUndefined(currentCell) && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader") && isMatched && $(currentCell).find('.collapse').length > 0)
                                            pivotGrid._collapseMember(tableOlapGrid, $(currentCell).find('.collapse'));
                                    }
                                }
                                else if (axis == "column") {
                                    for (var i = pivotGrid.model.dataSource.rows.length, currentCell; i < Math.ceil(pivotGrid.getJSONRecords().length / pivotGrid._rowCount) ; i += ej.isNullOrUndefined(currentCell) ? 1 : currentCell.colSpan) {
                                        currentCell = $(tableOlapGrid).find("thead th[p='" + i + "," + fieldIndex + "']")[0];
                                        var isMatched = false;
                                        for (var j = 0; j < item.length; j++) {
                                            if ($(currentCell).text().replace("expanded", "").trim() == item[j].toString().trim()) {
                                                isMatched = true;
                                                break;
                                            }
                                        }
                                        if (!ej.isNullOrUndefined(currentCell) && ($(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader") && isMatched && $(currentCell).find('.collapse').length > 0)
                                            pivotGrid._collapseMember(tableOlapGrid, $(currentCell).find('.collapse'));
                                    }
                                }
                            }
                        }
                        else {
                            var pivotRows = JSON.parse(pivotGrid.getOlapReport()).PivotRows, pivotColumns = JSON.parse(pivotGrid.getOlapReport()).PivotColumns;
                            for (var i = 0; i < pivotRows.length; i++)
                                if (pivotRows[i].FieldName == index) { fieldIndex = i; axis = "row"; }
                            for (var i = 0; i < pivotColumns.length; i++)
                                if (pivotColumns[i].FieldName == index) { fieldIndex = i; axis = "column"; }
                            if (!ej.isNullOrUndefined(fieldIndex)) {
                                if (axis == "row") {
                                    for (var i = pivotColumns.length + 1, currentCell; i < pivotGrid._rowCount; i += ej.isNullOrUndefined(currentCell) ? 1 : currentCell.rowSpan) {
                                        currentCell = $(tableOlapGrid).find("tBody th[p='" + fieldIndex + "," + i + "']")[0];
                                        var isMatched = false;
                                        for (var j = 0; j < item.length; j++) {
                                            if ($(currentCell).text().replace("expanded", "").trim() == item[j].toString().trim()) {
                                                isMatched = true;
                                                break;
                                            }
                                        }
                                        if (!ej.isNullOrUndefined(currentCell) && ($(currentCell).hasClass("rowheader") || $(currentCell).attr('role') == "rowheader") && isMatched && $(currentCell).find('.collapse').length > 0)
                                            pivotGrid._collapseMember(tableOlapGrid, $(currentCell).find('.collapse'));
                                    }
                                }
                                else if (axis == "column") {
                                    for (var i = pivotRows.length, currentCell; i < Math.ceil(pivotGrid.getJSONRecords().length / pivotGrid._rowCount) ; i += ej.isNullOrUndefined(currentCell) ? 1 : currentCell.colSpan) {
                                        currentCell = $(tableOlapGrid).find("thead th[p='" + i + "," + fieldIndex + "']")[0];
                                        var isMatched = false;
                                        for (var j = 0; j < item.length; j++) {
                                            if ($(currentCell).text().replace("expanded", "").trim() == item[j].toString().trim()) {
                                                isMatched = true;
                                                break;
                                            }
                                        }
                                        if (!ej.isNullOrUndefined(currentCell) && ($(currentCell).hasClass("colheader") || $(currentCell).attr('role') == "columnheader") && isMatched && $(currentCell).find('.collapse').length > 0)
                                            pivotGrid._collapseMember(tableOlapGrid, $(currentCell).find('.collapse'));
                                    }
                                }
                            }
                        }
                    });
                }
            }
            this.element.html("");
            if (this.model.enableVirtualScrolling) {
                this._createVirtualPivotGrid(tableOlapGrid);
                if (this.model.enableRTL)
                    this.element.addClass("e-rtl");
                this._applyVScrolling();
            }
            else if (this.model.enableGroupingBar) {
                this.element.append(tableOlapGrid);
                if (this._JSONRecords == null || this._JSONRecords.length == 0)
                    this.element.append(ej.buildTag("span", this._getLocalizedLabels("NoRecordsToDisplay"), { "display": "inline-block", "padding": "10px 0px 0px 0px", "font-family": "Segoe UI" })[0].outerHTML);
                if (this.model.enableRTL)
                    this.element.addClass("e-rtl");
                this._createFields(tableOlapGrid, $("#" + this._id).find(".pivotGridTable").width(), $("#" + this._id).find(".pivotGridTable th").outerWidth());
            }
            else {
                if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar && !this._pivotClientObj.model.displaySettings.enableFullScreen) {
                    $(toolBar).append(tableOlapGrid);
                    this.element.append($(toolBar));
                }
                else
                    this.element.append(tableOlapGrid);
            }
            if (this.model.enableColumnResizing && (!this.model.enablePaging && !this.model.enableVirtualScrolling && !this.model.frozenHeaderSettings.enableFrozenHeaders && !this.model.frozenHeaderSettings.enableFrozenColumnHeaders && !this.model.frozenHeaderSettings.enableFrozenRowHeaders)) {
                var colgroup = $("<colgroup></colgroup>");
                for (var i = 0; i < (jsonObj.length / this._rowCount) ; i++) {
                    if (ej.isNullOrUndefined(this.element.find("tbody tr:first").children()[i]))
                        break;
                    var col = "<col style='width:" + this.element.find("tbody tr:first").children()[i].offsetWidth / Number($(this.element.find("tbody tr:first").children()[i]).attr("colspan")) + "px'></col>";
                    colgroup.append(col);
                }
                $(tableOlapGrid).append(colgroup);
            }
            if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.enableVirtualScrolling && !this._pivotClientObj.model.enablePaging) {
                this._pivotClientObj.element.find(".categPageIndicator, .seriesPageIndicator , .vScrollThumb, .hScrollThumb").remove();
                var seriesPageIndicator = ej.buildTag("div.seriesPageIndicator inActive", ej.buildTag("span.axislabel", this._getLocalizedLabels("SeriesPage") + " : ")[0].outerHTML + ej.buildTag("span.series_CurrentPage", this._seriesCurrentPage)[0].outerHTML + " / " + ej.buildTag("span.series_pageCount", this._seriesPageCount)[0].outerHTML)[0].outerHTML;
                if (this._seriesPageCount > 1) {
                    if (this._pivotClientObj.element.find(".vScrollPanel").width() != 12) {
                        this._pivotClientObj.element.width(this._pivotClientObj.element.width() + 12);
                    }
                    this._pivotClientObj.element.find(".vScrollPanel").width(12);
                    this._pivotClientObj.element.find(".virtualScrolling").append(seriesPageIndicator);
                    if (this._pivotClientObj.controlPlacement() == ej.PivotClient.ControlPlacement.Tab && this._pivotClientObj.model.displaySettings.mode == ej.PivotClient.DisplayMode.ChartAndGrid) {
                       this._pivotClientObj.element.find(".virtualScrolling").css("padding-top", "10px");
                    }
                    else
                        this._pivotClientObj.element.find(".virtualScrolling").css("padding-left", "2px");
                }
                else {
                    if (this._pivotClientObj.element.find(".vScrollPanel").width() == 12) {
                        this._pivotClientObj.element.width(this._pivotClientObj.element.width() - 12);
                        this._pivotClientObj.element.find(".vScrollPanel").width(0);
                    }
                }
                var categPageIndicator = ej.buildTag("div.categPageIndicator inActive", ej.buildTag("span.axislabel", this._getLocalizedLabels("CategoricalPage") + " : ")[0].outerHTML + ej.buildTag("span.categ_CurrentPage", this._categCurrentPage)[0].outerHTML + " / " + ej.buildTag("span.categ_pageCount", this._categPageCount)[0].outerHTML)[0].outerHTML;
                if (this._categPageCount > 1) {
                    if (this._pivotClientObj.element.find(".hScrollPanel").height() != 12) {
                        this._pivotClientObj.element.find(".hScrollPanel").height(12);
                    }
                    if (this._pivotClientObj.controlPlacement() == ej.PivotClient.ControlPlacement.title)
                        this._pivotClientObj.element.find(".hsVirtualScrolling").css("margin-top", "3px");
                    this._pivotClientObj.element.find(".hsVirtualScrolling").append(categPageIndicator);
                }
                else {
                    if (this._pivotClientObj.element.find(".hScrollPanel").height() == 12) {
                        if (!this._pivotClientObj.model.isResponsive) {
                            this._pivotClientObj.element.find(".categoricalAxis, .rowAxis,.slicerAxis").height(150);
                        } else
                            this._pivotClientObj.element.find(".categoricalAxis, .rowAxis,.slicerAxis").height(this._pivotClientObj.element.find(".categoricalAxis, .rowAxis,.slicerAxis").height() - 6);
                        this._pivotClientObj.element.find(".cubeBrowser").height(this._pivotClientObj.element.find(".cubeBrowser").height() - 20);
                        this._pivotClientObj.element.find(".hScrollPanel").height(0);
                    }
                }
                this._applyVScrolling();
                if (this._pivotClientObj.element.find(".chartContainer").length > 0) {
                    this._pivotClientObj.element.find(".gridContainer").height(this._pivotClientObj.element.find(".chartContainer").height() + 5);
                }
            }
            
            if (this.model.enableColumnResizing) {
                this.element.addClass("column-resize");
            }
            else
                this.element.removeClass("column-resize");
            if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                this._applyFrozenHeaderWidth(jsonObj);
                if (this.model.enableColumnResizing)
                    this.element.find(".pivotGridTable").width("auto");
            }
            if (this.model.enableCellDoubleClick)
                this._on(this.element, "dblclick", ".value, .summary", this._cellRangeInfo)
            if (this.model.enableRTL) {
                this.element.addClass("e-rtl");
                this.element.find(".groupingBarPivot").addClass("e-rtl");
                this.element.find('table .rowheader,.colheader,.summary, .groupingBarPivot, .grpRow').css("text-align", "right");
            }
            else {
                this.element.removeClass("e-rtl");
                this.element.find(".groupingBarPivot").removeClass("e-rtl");
                this.element.find('table .rowheader,.colheader,.summary, .grpRow, .groupingBarPivot ').css("text-align", "left");
            }
            if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar && !this._pivotClientObj.model.displaySettings.enableFullScreen) {
                $("#" + this._id).prepend("<div class='toolBar' style='height:40px,width:" + this.element.find("#PivotGridToolbar").width() + "px'></div>");
                var numberformatting = "", collapseByDefault = "", frozenHeader = ej.buildTag("li#frozenHeaders.frozenHeaders e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("FrozenHeader")).attr({ "title": this._getLocalizedLabels("FrozenHeader"), tabindex: 0 })[0].outerHTML;
                var cellSelect = ej.buildTag("li.cellSelect e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("CellSelection")).attr({ "title": this._getLocalizedLabels("CellSelection"), tabindex: 0 })[0].outerHTML;
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                    collapseByDefault = ej.buildTag("li#collapseByDefault.collapseByDefault e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("CollapseByDefault")).attr({ "title": this._getLocalizedLabels("CollapseByDefault"), tabindex: 0 })[0].outerHTML;
                numberformatting = ej.buildTag("li.numberFormatting e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("NumberFormatting")).attr({ "title": this._getLocalizedLabels("NumberFormatting"), tabindex: 0 })[0].outerHTML;
                var calculatedField = ej.buildTag("li.calculatedField e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("CalculatedField")).attr({ "title": this._getLocalizedLabels("CalculatedField"), tabindex: 0 })[0].outerHTML;
                var icons = ej.buildTag("ul",
                (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? ej.buildTag("li#cellEditing.cellEditing e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("CellEditing")).attr({ "title": this._getLocalizedLabels("CellEditing"), tabindex: 0 })[0].outerHTML : " ") +
                ej.buildTag("li#drillThrough.drillThrough e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("DrillThrough")).attr({ "title": this._getLocalizedLabels("DrillThrough"), tabindex: 0 })[0].outerHTML+
                (!((this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot || this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) ? ej.buildTag("li.advancedFiltering e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("AdvancedFiltering")).attr({ "title": this._getLocalizedLabels("AdvancedFiltering"), tabindex: 0 })[0].outerHTML : "") +
                ej.buildTag("li#columnResize.columnResize e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ColumnResize")).attr({ "title": this._getLocalizedLabels("ColumnResize"), tabindex: 0 })[0].outerHTML +
                ej.buildTag("li.toolTip e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ToolTip")).attr({ "title": this._getLocalizedLabels("ToolTip"), tabindex: 0 })[0].outerHTML + (this._pivotClientObj.displayMode() == ej.PivotClient.DisplayMode.GridOnly ? collapseByDefault : "") +
                ej.buildTag("li.rtl e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("RTL")).attr({ "title": this._getLocalizedLabels("RTL"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                ej.buildTag("ul", ej.buildTag("li.hyperlinkOptions e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("HyperLink")).attr({ "title": this._getLocalizedLabels("HyperLink"), tabindex: 0 })[0].outerHTML +
                ej.buildTag("li.layouts e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Layouts")).attr({ "title": this._getLocalizedLabels("Layouts"), tabindex: 0 })[0].outerHTML + frozenHeader +
                ej.buildTag("li.exporting e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Exporting")).attr({ "title": this._getLocalizedLabels("Exporting"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                ej.buildTag("ul", ej.buildTag("li.summaryCustomize#summaryCustomize e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("SummaryCustomization")).attr({ "title": this._getLocalizedLabels("SummaryCustomization"), tabindex: 0 })[0].outerHTML +
                ej.buildTag("li.conditionalFormat e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ConditionalFormatting")).attr({ "title": this._getLocalizedLabels("ConditionalFormatting"), tabindex: 0 })[0].outerHTML +
                (this._pivotClientObj.model.analysisMode == "pivot" && this._pivotClientObj.model.operationalMode == "clientmode" ? (ej.buildTag("li.summaryTypes e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("SummaryTypes")).attr({ "title": this._getLocalizedLabels("SummaryTypes"), tabindex: 0 })[0].outerHTML + numberformatting) : ""))[0].outerHTML;
                $(".toolBar").append(icons);
                $(".toolBar").ejToolbar({ enableRTL: this.model.enableRTL, height: "35px", enableSeparator: true });
            }
            this._stateMaintenance();
            if ($.trim(this.model.pivotTableFieldListID) != "" && this._isSchemaInitialize && this.model.enablePivotFieldList)
                this._renderPivotSchemaDesigner();

            if (this._schemaData != null)
                this.element.find(".colheader, .rowheader, .value").addClass("e-droppable");
            this.exportRecords = jsonObj;
            ej.Pivot.closePreventPanel(this);
            if (this._schemaData)
                ej.Pivot.closePreventPanel(this._schemaData);
            if (this._excelLikeJSONRecords != null && this.layout().toLowerCase() == ej.PivotGrid.Layout.ExcelLikeLayout)
                this._rowCount = rowCount;
            if (this.model.valueSortSettings) {
                if (!ej.isNullOrUndefined(this.model.valueSortSettings.headerText) && this.model.valueSortSettings.headerText != "" && !ej.isNullOrUndefined(ej.PivotAnalysis._valueSorting)) {
                    var ele = this.element.find("[p='" + Number(ej.PivotAnalysis._valueSorting) + "," + (Number(this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? JSON.parse(this.getOlapReport()).PivotColumns.length : this.model.dataSource.columns.length) + "']"));
                    if ($(ele).find(".valueSorting").length == 0 && !$(ele).hasClass("rowheader")) {
                        var sorting = ej.buildTag("span.valueSorting e-icon " + ej.PivotAnalysis._sort).css("width", "30px").attr("role", "button").attr("aria-label", "sort")[0].outerHTML;
                        $(ele).append(sorting);
                    }
                }
                else if (!ej.isNullOrUndefined(sortEle) && $(sortEle).find(".rowheader").length == 0) {
                    this.element.find("[p='" + Number($(sortEle).attr("p").split(',')[0]) + "," + Number($(sortEle).attr("p").split(',')[1]) + "']").html(sortEle.html());
                }
            }
            if (this.model.enableGroupingBar && this.element.find(".pivotGridTable").width() > 0) {
                if (!(this.element.find(".values .pvtBtn, .columns .pvtBtn").length == 0 && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) && (this.element.find("tbody .value").length > 0 && this.element.find("thead tr").length > 0))
                    this.element.find(".groupingBarPivot").width(this.element.find(".pivotGridTable").width());
            }
            if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                this._applyFrozenHeaderWidth(this._JSONRecords);
            var row = [], col = [], headerInfo = {}, width = [], colIndex, mode = this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? true : false;
            if (this.model.analysisMode != ej.PivotGrid.AnalysisMode.Olap && (this.model.headerSettings.showColumnItems || this.model.headerSettings.showRowItems) && !this.model.enableGroupingBar) {
                if ((mode && (JSON.parse(this.getOlapReport()).PivotRows.length > 0 || JSON.parse(this.getOlapReport()).PivotColumns.length > 0) && JSON.parse(this.getOlapReport()).PivotCalculations.length > 0) || (!mode && ((this.model.dataSource.rows.length > 0 || this.model.dataSource.columns.length > 0) && this.model.dataSource.values.length > 0))) {
                    for (var i = 0; i < (mode ? JSON.parse(this.getOlapReport()).PivotRows.length : this.model.dataSource.rows.length) ; i++)
                        row.push(mode ? JSON.parse(this.getOlapReport()).PivotRows[i].FieldHeader : this.model.dataSource.rows[i].fieldCaption);
                    for (var i = 0; i < (mode ? JSON.parse(this.getOlapReport()).PivotColumns.length : this.model.dataSource.columns.length) ; i++)
                        col.push(mode ? JSON.parse(this.getOlapReport()).PivotColumns[i].FieldHeader : this.model.dataSource.columns[i].fieldCaption);
                    headerInfo = { rows: row, columns: col };
                }
            }
            else if (this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && (this.model.headerSettings.showColumnItems || this.model.headerSettings.showRowItems) && !this.model.enableGroupingBar && ((mode && JSON.parse(this.getOlapReport()).PivotCalculations.length) || (!mode && this.model.dataSource.values[0].measures.length)) && this._getAxis() == "columns") {
                for (var i = 0; i < jsonObj.length; i++) {
                    if (jsonObj[i].CSS != "value" && jsonObj[i].CSS != " value") {
                        if (jsonObj[i].CSS == "rowheader" && jsonObj[i].Info != "" && $.inArray(jsonObj[i].Info.split("::")[1].replace(/[\[\]]+/g, ''), row) == -1) {
                            row.push(jsonObj[i].Info.split("::")[1].replace(/[\[\]]+/g, ''));
                            width.push(this.element.find("[p=" + "'" + jsonObj[i].Index.split(",")[0] + "," + jsonObj[i].Index.split(",")[1] + "'" + "]").width());
                            i = i + (this._rowCount - (i % this._rowCount));
                        }
                        if (jsonObj[i].CSS == "colheader" && jsonObj[i].Info != "" && $.inArray(jsonObj[i].Info.split("::")[1].replace(/[\[\]]+/g, ''), col) == -1 && jsonObj[i].Info.indexOf('Measure') === -1) {
                            col.push(jsonObj[i].Info.split("::")[1].replace(/[\[\]]+/g, ''));
                        }
                    }
                    else {
                        colIndex = jsonObj[i].Index.split(",")[0];
                        break;
                    }
                }
                headerInfo = { rows: row, columns: col };
            }
            if (!$.isEmptyObject(headerInfo) && ((this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && headerInfo.rows.length > 0) || this.model.analysisMode == "pivot")) {
                if (headerInfo.rows != null && headerInfo.columns != null && headerInfo.rows.length > 1 && headerInfo.columns.length > 0)
                    this.element.find("[p='0,0']").attr("rowspan", headerInfo.columns.length).attr("colspan", (headerInfo.rows.length - 1));
                else
                    this.element.find("[p='0,0']").attr("rowspan", "1").attr("colspan", "1");
                for (var i = 0; i < headerInfo.columns.length; i++) {
                    if ((headerInfo.rows.length == 0 || headerInfo.rows.length == 1)) {
                        if (i == 0)
                            this.model.headerSettings.showColumnItems ? this.element.find("[p=" + "'" + 0 + "," + i + "'" + "]").html(ej.buildTag("div.colHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.columns[i].split(".")[2]) : (headerInfo.columns[i])).attr({ "title": headerInfo.columns[i] })[0].outerHTML).addClass("headcol").addClass("headcol").addClass("colfirst").addClass("rowfirst") : this.element.find("[p=" + "'" + 0 + "," + i + "'" + "]").html("").addClass("headcol").addClass("headcol").addClass("colfirst").addClass("rowfirst");
                        else
                            this.model.headerSettings.showColumnItems ? this.element.find("[p=" + "'" + 1 + "," + i + "'" + "]").before(ej.buildTag("th.headrow rowfirst", ej.buildTag("div.colHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.columns[i].split(".")[2]) : (headerInfo.columns[i])).attr({ "title": headerInfo.columns[i] })[0].outerHTML)[0].outerHTML) : this.element.find("[p=" + "'" + 1 + "," + i + "'" + "]").before("<th class='headcol rowfirst'></th>");
                    }
                    else if (i == 0)
                        this.model.headerSettings.showColumnItems ? this.element.find("[p=" + "'" + headerInfo.rows.length + "," + i + "'" + "]").before(ej.buildTag("th.headcol colfirst", ej.buildTag("div.colHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.columns[i].split(".")[2]) : (headerInfo.columns[i])).attr({ "title": headerInfo.columns[i] })[0].outerHTML)[0].outerHTML) : this.element.find("[p=" + "'" + headerInfo.rows.length + "," + i + "'" + "]").before("<th class='headcol colfirst'></th>");
                    else {
                        this.model.headerSettings.showColumnItems ? this.element.find("[p=" + "'" + headerInfo.rows.length + "," + i + "'" + "]").before(ej.buildTag("th.headrow", ej.buildTag("div.colHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.columns[i].split(".")[2]) : (headerInfo.columns[i])).attr({ "title": headerInfo.columns[i] })[0].outerHTML)[0].outerHTML) : this.element.find("[p=" + "'" + headerInfo.rows.length + "," + i + "'" + "]").before("<th class='headcol'></th>");
                        this.element.find("[p='0,0']").addClass("topele");
                    }
                }
                if (headerInfo.rows.length == 0) {
                    this.element.find("[p=" + "'" + 1 + "," + headerInfo.columns.length + "'" + "]").before("<th class='headrow rowfirst'></th>");
                }
                for (var i = 0; i < headerInfo.rows.length; i++) {
                    if ((headerInfo.columns.length == 0)) {
                        if (i == 0)
                            this.model.headerSettings.showRowItems ? this.element.find("[p=" + "'" + 0 + "," + i + "'" + "]").html(ej.buildTag("div.rowHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.rows[i].split(".")[2]) : (headerInfo.rows[i])).attr({ "title": headerInfo.rows[i] })[0].outerHTML).addClass("headrow").addClass("rowfirst").addClass("colfirst") : this.element.find("[p=" + "'" + 0 + "," + i + "'" + "]").html("").addClass("headrow").addClass("rowfirst").addClass("colfirst");
                        else
                            this.model.headerSettings.showRowItems ? this.element.find("[p=" + "'" + headerInfo.rows.length + "," + headerInfo.columns.length + "'" + "]").before(ej.buildTag("th.headrow colfirst", ej.buildTag("div.rowHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.rows[i].split(".")[2]) : (headerInfo.rows[i])).attr({ "title": headerInfo.rows[i] })[0].outerHTML)[0].outerHTML) : this.element.find("[p=" + "'" + headerInfo.rows.length + "," + headerInfo.columns.length + "'" + "]").before("<th class='headrow colfirst'></th>");
                    }
                    else if (i == 0)
                        this.model.headerSettings.showRowItems ? this.element.find("[p=" + "'" + headerInfo.rows.length + "," + headerInfo.columns.length + "'" + "]").before(ej.buildTag("th.headrow rowfirst", ej.buildTag("div.rowHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.rows[i].split(".")[2]) : (headerInfo.rows[i])).attr({ "title": headerInfo.rows[i] })[0].outerHTML)[0].outerHTML) : this.element.find("[p=" + "'" + headerInfo.rows.length + "," + headerInfo.columns.length + "'" + "]").before("<th class='headrow rowfirst'></th>");
                    else {
                        this.model.headerSettings.showRowItems ? this.element.find("[p=" + "'" + headerInfo.rows.length + "," + headerInfo.columns.length + "'" + "]").before(ej.buildTag("th.headrow", ej.buildTag("div.rowHeadBtn", this.model.analysisMode != "pivot" ? (headerInfo.rows[i].split(".")[2]) : (headerInfo.rows[i])).attr({ "title": headerInfo.rows[i] })[0].outerHTML)[0].outerHTML) : this.element.find("[p=" + "'" + headerInfo.rows.length + "," + headerInfo.columns.length + "'" + "]").before("<th class='headrow'></th>");
                        this.element.find("[p='0,0']").addClass("topele");
                    }
                }
                var colBtns = this.element.find(".colHeadBtn"); var rowBtns = this.element.find(".rowHeadBtn");
                for (var i = 0; i < colBtns.length && !this.model.enableCollapseByDefault; i++) {
                    $(colBtns[i]).css({ "width": this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap ? (width[colIndex - 1]) : this.element.find("[p=" + "'" + (headerInfo.rows.length == 0 ? 0 : (headerInfo.rows.length - 1)) + "," + (headerInfo.columns.length + 1) + "'" + "]").width() });
                }
                for (var i = 0; i < rowBtns.length && !this.model.enableCollapseByDefault; i++) {
                    $(rowBtns[i]).css({ "width": this.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap ? (width[i]) : this.element.find("[p=" + "'" + i + "," + (headerInfo.columns.length + 1) + "'" + "]").width() });
                }
            }
        },
        _applyLocale: function (jsonObj) {
            if (this.model.dataSource.values.length == 0) return;
			var isFromatApplied = false, axis;
			for (var i = 0; i < this.model.dataSource.values[0].measures.length; i++) {
			    if (this.model.dataSource.values[0].measures[i].format) {
			        isFromatApplied = true;
			        break;
			    }
			}
			if(isFromatApplied)
			{
				axis = this._getAxis();
				for (var i = 0; i < this.model.dataSource.values[0].measures.length; i++) {
                    var val = [], columnIndices = [], format = this.model.dataSource.values[0].measures[i].format,celValue;
                    for(var j=0;j<jsonObj.length;j++)
                        {
                         columnIndices=  this._getColumnIndices(axis, jsonObj[j], this.model.dataSource.values[0].measures[i].fieldCaption,val);
                        }
                    for(var k=0;k<columnIndices.length;k++)
                    {
                        for(var l=0;l<jsonObj.length;l++)
                        {
                            var value = axis == "rows" ? jsonObj[l].Index.split(",")[1] : axis == "columns" ? jsonObj[l].Index.split(",")[0] : null;
                            if(value==columnIndices[k]&&jsonObj[l].Value!="")
                            {
                                celValue = jsonObj[l].Value.replace(/[\s,%]/g, '');
                                celValue = celValue.replace(ej.preferredCulture(this.model.locale).numberFormat.currency.symbol, '');
                                if ($.isNumeric(celValue) && format != undefined) {
                                    var formattedValue = ej.olap.base._getFormatedValue(celValue, format);
                                    jsonObj[l].Value = formattedValue;
                                }
                            }
                        }
                    }
                }
			}
		},
        _renderPivotSchemaDesigner :function()
        {
            if ($("#" + this.model.pivotTableFieldListID).length > 0) {
                var pivotSchemaDesigner = $("#" + this.model.pivotTableFieldListID).data('ejPivotSchemaDesigner');
                if (pivotSchemaDesigner != null) {
                    pivotSchemaDesigner.model.pivotControl = this;
                    pivotSchemaDesigner.model.enableWrapper = true;
                    pivotSchemaDesigner._load();
                    if(this._waitingPopup)
                    this._waitingPopup.hide()
                    this._isSchemaInitialize = false;
                }
                else {
                    var _this = this;
                    var timer = setInterval(function () {
                        var pivotSchemaDesigner = $("#" + _this.model.pivotTableFieldListID).data('ejPivotSchemaDesigner');
                        if (pivotSchemaDesigner != null) {
                            clearInterval(timer);
                            pivotSchemaDesigner.model.pivotControl = _this;
                            pivotSchemaDesigner.model.enableWrapper = true;
                            pivotSchemaDesigner._load();
                            if (_this._waitingPopup)
                                _this._waitingPopup.hide()
                            _this._isSchemaInitialize = false;
                            if (!ej.isNullOrUndefined(pivotSchemaDesigner.model.pivotControl))
                                pivotSchemaDesigner.model.pivotControl.element.find(".colheader, .rowheader, .value").addClass("e-droppable");
                        }
                    }, 10);
                }
            }
       },

        _renderFrozenGridTable: function (tableOlapGrid, colHeader, tableBody) {
            var frozenColTable = $("<table class=\"pivotGridFrozenTable\" style='height:47px' ></table>"),
                frozenRowTable = $("<table class=\"pivotGridRowTable\" ></table>");
                frozenValTable = $("<table class=\"pivotGridValueTable\" ></table>");
                tbodyFrozenCol = $("<tbody></tbody>"),
                tbodyFrozenRow = $("<tbody></tbody>"),
                tbodyFrozenVal = $("<tbody></tbody>");
            var tRow = tRow1 = "<tr role='row'>";
            var rowdiv = $("<div class='rowhead' style='position: relative; float: left;display: inline-block'>");

            $(tbodyFrozenCol).append($(colHeader).children());
            var tbodyvalue = tableBody.children().clone();
            var tbodyData = tableBody.children().clone();
            $(tbodyData).find(".value").remove();
            $(tbodyFrozenRow).append($(tbodyData));
            $(frozenRowTable).append(tbodyFrozenRow);
            $(rowdiv).append(frozenRowTable);
            $(tbodyvalue).find(".rowheader, .summary:not(.summary.value)").remove();
            $(tbodyFrozenVal).append($(tbodyvalue));


            var coldiv = $(ej.buildTag("div.colhead").css({ 'position': 'relative', 'overflow': 'hidden' })[0].outerHTML);
            var colmovdiv = $(ej.buildTag("div.colmovable")[0].outerHTML);
            var colfrediv = $(ej.buildTag("div.colfreeze").css({ 'float': 'left', 'height': '100%', 'visibility': (this.model.enableGroupingBar ? "visible" : "hidden") })[0].outerHTML);
            $(coldiv).append($(frozenColTable).append(tbodyFrozenCol));
            if ($(tRow).children().length == 0)
                tRow = $("<tr role='row'></tr>");
            if ($(tRow).length > 0) {
                $(colmovdiv).append(coldiv);
                $(colfrediv).append($("<table id='colfretable' style='height:100%'></table>").append(tRow));
            }

            var valScrollArea = $(ej.buildTag("div#rowvaluecontent.valScrollArea")[0].outerHTML);
            var valdiv = $(ej.buildTag("div.valueCell").css({ 'position': 'relative' })[0].outerHTML);
            var rowHeaderArea = $(ej.buildTag("div.rowHeaderArea")[0].outerHTML);
            $(valdiv).append($(frozenValTable).append(tbodyFrozenVal));
            if (!this.model.frozenHeaderSettings.enableFrozenRowHeaders && this.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                $(tableOlapGrid).append("<tr><td style='padding:0px' colspan='2'></td></tr><tr><td style='padding:0px' colspan='2'></td></tr>"); //<td style='padding:0px'></td>
                $(tableOlapGrid).find("tr:first td:eq(0)").append($("<div id='headerContent' class='headerContent'></div>"))
                $($(tableOlapGrid).find("tr:last td:eq(0)")).append($(valScrollArea));
                $(tableOlapGrid).find(".headerContent").append(colmovdiv);
                $(tableOlapGrid).find(".headerContent .colhead").prepend(colfrediv);
                $(tableOlapGrid).find(".headerContent .colhead").append("<div class='headerTable'/>");
                $(tableOlapGrid).find(".pivotGridFrozenTable").appendTo($(tableOlapGrid).find(".headerTable"));
                $(tableOlapGrid).find(".valScrollArea").append($(rowHeaderArea));
                $(tableOlapGrid).find(".rowHeaderArea").append(rowdiv, valdiv);               
            }
            else if (this.model.frozenHeaderSettings.enableFrozenRowHeaders && !this.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                $(tableOlapGrid).append("<tr ><td style='padding:0px;border-right:0px' ></td><td style='padding:0px;'></td></tr>"); //<td style='padding:0px'></td>
                $(tableOlapGrid).find("tr:first td:eq(0)").append($("<div id='headerContent' class='headerContent' style='position:relative'></div>"));
                $(tableOlapGrid).find(".headerContent").append(colfrediv ,rowdiv);
                $(tableOlapGrid).find("tr td:last").append($(valScrollArea));
                $(tableOlapGrid).find(".valScrollArea").append($(rowHeaderArea));
                $(tableOlapGrid).find(".rowHeaderArea").append(colmovdiv,valdiv);
            }
            else {
                $(tableOlapGrid).append("<tr><td style='padding:0px'></td><td style='padding:0px;'></td></tr><tr><td style='padding:0px'></td><td style='padding:0px' class='valueArea'></td></tr>");
                $(tableOlapGrid).find("tr:first td:eq(0)").append(colfrediv);
                $(tableOlapGrid).find("tr:first").children("td:eq(1)").append(colmovdiv);
                $(tableOlapGrid).find("tr:last td:eq(0)").append($(rowHeaderArea));
                $(tableOlapGrid).find(".rowHeaderArea").append(rowdiv);
                $(tableOlapGrid).find(".valueArea").append($(valScrollArea));
                $(tableOlapGrid).find(".valScrollArea").append(valdiv);
            }
            if (this.model.enableGroupingBar) {
                if ($(tableOlapGrid).find(".grpRow").length > 0)
                    $(tableOlapGrid).find(".grpRow").appendTo($(tableOlapGrid).find(".colfreeze table tr:eq(0)"));
            }
            else if ($(tableOlapGrid).find("[p='0,0']").length > 0 || $(tableOlapGrid).find("[p='-1,-1']").length > 0) {
                var index = $(tableOlapGrid).find("[p='-1,-1']").length > 0 ? "-1,-1" : "0,0";
                $(tableOlapGrid).find("[p='" + index + "']").appendTo($(tableOlapGrid).find(".colfreeze table tr:eq(0)"));
            }
        },

        _applyFrozenHeaderWidth: function (jsonObj) {
            if (jsonObj.length > 0) {
                var pGrid = this.element;
                var scrollerObj = this.element.find(".e-scroller").data("ejScroller");
                if (scrollerObj) {
                    scrollerObj.destroy();
                    $(this.element).css("overflow", "");
                    $(pGrid).find(".headerTable").css("display", "initial");
                    $(pGrid).find(".valScrollArea").css("height", "");
                    $(pGrid).find(".pivotGridRowTable, .pivotGridValueTable , .pivotGridFrozenTable").removeClass("frozenTableLayout");
                    $(pGrid).find(".pivotGridRowTable, .pivotGridValueTable , .pivotGridFrozenTable").removeAttr("style");
                }
                $(pGrid).find(".pivotGridFrozenTable colgroup, .pivotGridValueTable colgroup").remove();

                var colgroup = $("<colgroup></colgroup>"), colgrp = [];
                var colHeaderElement = $(pGrid).find(".pivotGridFrozenTable");
                var visibleRowIndex = $(pGrid).find(".pivotGridRowTable tr:visible").index();
                if (visibleRowIndex > -1) {
                    var valueCellTable = $(pGrid).find(".pivotGridValueTable tr:eq(" + visibleRowIndex + ") td");//.css("border-top", "0px");

                    for (var i = 0; i < valueCellTable.length; i++) {
                        var colIndex = $(valueCellTable[i]).attr("p").split(",")[0];
                        var headerCells = colHeaderElement.find("[p^='" + colIndex + ",']");
                        if (!ej.isNullOrUndefined(headerCells.last().attr("colSpan")) && headerCells.last().attr("colSpan") != '1')
                            headerCells = headerCells[headerCells.length - 2];
                        else
                            headerCells = $(headerCells).last();

                        if ($(valueCellTable[i]).is(":visible"))
                            colgroup.append("<col width =" + Math.max($(headerCells).outerWidth(), $(valueCellTable[i]).outerWidth()) + "px'>");
                    }
                    this.element.find(".pivotGridFrozenTable, .pivotGridValueTable").append(colgroup);
                    if (!this.model.enableColumnGrandTotal) {
                        var removeSpan = parseInt($(pGrid).find(".pivotGridFrozenTable tr:first td:last").attr("colspan"));
                        $(pGrid).find(".pivotGridFrozenTable colgroup col").slice(-removeSpan).remove();
                        $(pGrid).find(".pivotGridValueTable colgroup col").slice(-removeSpan).remove();
                    }
                    this._refreshScroller();
                }
                else {
                    this._refreshScroller();
                }
            }
        },

        _refreshScroller: function () {
            if (this.element.find(".pivotGridValueTable .value:visible").length > 0) {
                var pGridColumnTbl = this.element.find(".pivotGridFrozenTable");
                var pGridRowTbl = this.element.find(".pivotGridRowTable");
                var pGridValueTbl = this.element.find(".pivotGridValueTable");
                var rowScrollArea = this.element.find(".rowhead");
                var pGridValScrollArea = this.element.find(".valueCell");
                var scrollerSize = !ej.isNullOrUndefined(this.model.frozenHeaderSettings.scrollerSize)? this.model.frozenHeaderSettings.scrollerSize:18;
                $(pGridColumnTbl).height(this.element.find(".colfreeze").height());
                if (!this.model.frozenHeaderSettings.enableFrozenRowHeaders && this.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                    this.element.find(".colfreeze").css({ height: $(pGridColumnTbl).height(), width: $(pGridRowTbl).width() });
                    $(pGridValScrollArea).css({ "display": "inline-block", width: (this.element.width() - $(pGridRowTbl).width()) });
                    this.element.find(".headerTable").css({ "display": "inline-block", "width": $(pGridValScrollArea).width() });
                    this.element.find(".pivotGridValueTable, .pivotGridFrozenTable").addClass("frozenTableLayout");
                    this.element.find(".headerContent, .colmovable").addClass("frozenStyle");
                    this.element.find(".headerContent").css({ width: this.element.width(), height: this.element.find(".headerTable").height() });
                    var scrollHeight = 0, scrollWidth = 0;
                    if ($(pGridValueTbl).height() > 0) {
                        var groupingBarHeight = (this.model.enableGroupingBar ? this.element.find(".groupingBarPivot").height() : 0);
                        var colHeaderHeight = this.element.find(".headerContent").height();
                        var valCellTblHeight = $(pGridValScrollArea).height();
                        var calcHeight = colHeaderHeight + valCellTblHeight + groupingBarHeight;
                        var valTableHeight = this.element.height();
                        var calcWidth = $(pGridValueTbl).width() + $(pGridRowTbl).width();
                        var valTableWidth = this.element.find(".pivotGridTable").width();
                        scrollHeight = ((valTableHeight > calcHeight) ? calcHeight : (valTableHeight)) - colHeaderHeight - groupingBarHeight;// - (this.element.find(".headerContent").height()));
                        scrollWidth = (valTableWidth > calcWidth) ? calcWidth : (valTableWidth);
                    }
                    this.element.find(".valScrollArea").ejScroller({
                        scrollerSize: scrollerSize,
                        width: scrollWidth,
                        height: scrollHeight, targetControl: this, enableRTL: this.model.enableRTL,
                        scroll: this._applyScroll,
                    });

                    if (this.element.find(".e-vscrollbar").length > 0) {
                        this.element.find(".headerContent").width((this.element.find(".headerContent").width() - scrollerSize));
                        $(pGridValScrollArea).width(($(pGridValScrollArea).width() - scrollerSize));
                        this.element.find(".headerContent").addClass("frozenColHeaderArea");
                    }
                }
                else if (this.model.frozenHeaderSettings.enableFrozenRowHeaders && !this.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                    var groupingBarHeight = (this.model.enableGroupingBar ? this.element.find(".groupingBarPivot").height() : 0);
                    var scrollHeight = 0, scrollWidth = 0;
                    this.element.find(".pivotGridValueTable, .pivotGridFrozenTable" + (!this.model.enableGroupingBar ? "" : ", .pivotGridRowTable")).addClass("frozenTableLayout");
                    this.element.find(".colfreeze").height($(pGridColumnTbl).height());
                    this.element.find(".colhead").css("overflow", "visible");
                    if ($(pGridValueTbl).height() > 0) {
                        var calcHeight = this.element.height(), valTableHeight = this.element.find(".rowHeaderArea").height();
                        var calcWidth = this.element.width() - this.element.find(".headerContent").width(), valTableWidth = $(pGridValueTbl).width();
                        scrollWidth = valTableWidth > calcWidth ? calcWidth : valTableWidth; //calcWidth
                        scrollHeight = (valTableHeight > (calcHeight) ? calcHeight : valTableHeight) - groupingBarHeight + ((valTableWidth > calcWidth) ? scrollerSize : 0);
                    }
                    this.element.find(".valScrollArea").ejScroller({
                        scroll: this._applyScroll,
                        width: scrollWidth, height: scrollHeight, targetControl: this, enableRTL: this.model.enableRTL, scrollerSize: scrollerSize
                    });
                    if (!this.model.enableGroupingBar)
                        this.element.find(".pivotGridRowTable").addClass("frozenTableLayout");

                    this.element.find(".headerContent").css({ "height": this.element.find(".valScrollArea").height(), "overflow": "hidden" });
                    $(rowScrollArea).css("padding-bottom", (this.element.find(".valScrollArea .e-hscrollbar").length > 0) ? scrollerSize : "0px");
                }
                else {
                    if (this.model.enableGroupingBar)
                        this._setGroupingBarFrozenRowBtnWidth();
                    //this.element.find(".pivotGridValueTable, .pivotGridFrozenTable" + (!this.model.enableGroupingBar ? "" : ", .pivotGridRowTable")).addClass("frozenTableLayout");
                    var calcHeight = this.element.height() - (this.element.find(".colhead").height() + (this.model.enableGroupingBar ? this.element.find(".groupingBarPivot").height() : 0));
                    var valTableHeight = $(pGridValueTbl).height();
                    $(rowScrollArea).css({ "overflow": "hidden", width: ($(pGridRowTbl).width() - 3), height: (valTableHeight > (calcHeight) ? calcHeight : valTableHeight) });
                    this.element.find(".colfreeze").width($(pGridRowTbl).width() - 3);
                    this.element.find(".pivotGridFrozenTable, .pivotGridValueTable, .pivotGridRowTable").addClass("frozenTableLayout");
                    var calcWidth = this.element.width() - $(pGridRowTbl).width();
                    var valTableWidth = $(pGridValueTbl).width(); //
                    var scrollWidth = (((valTableWidth) > (calcWidth) ? (calcWidth) : valTableWidth));// + (valTableHeight > (calcHeight) ? 10 : 0);
                    var scrollHeight = ($(rowScrollArea).height() + (valTableWidth > calcWidth ? scrollerSize : 0));;

                    this.element.find(".valScrollArea").ejScroller({
                        scroll: this._applyScroll,
                        //thumbMove: this._applyScroll, wheelMove: this._applyScroll,
                        width: scrollWidth, height: (scrollHeight), targetControl: this, scrollerSize: scrollerSize
                    });

                    $(rowScrollArea).height($(pGridValScrollArea).height());
                    this.element.find(".colmovable").width($(pGridValScrollArea).width());
                    (this.element.find(".e-vscrollbar").length > 0) ? this.element.find(".colmovable").addClass("frozenColHeaderArea") : this.element.find(".colmovable").removeClass("frozenColHeaderArea");
                    $(rowScrollArea).css("padding-bottom", (this.element.find(".valScrollArea .e-hscrollbar").length > 0) ? scrollerSize : "0px");

                    this.element.find(".colhead , .colfreeze").height($(pGridColumnTbl).height());
                    $(pGridColumnTbl).height("100%");

                    if (!this.model.enableGroupingBar) {
                        this.element.find(".pivotGridRowTable").addClass("frozenTableLayout");
                    }
                }

                if (this.model.enableGroupingBar)
                    this._refreshGroupingBarLayout();

                this.element.find(".pivotGridFrozenTable tr:first td").css("border-top", "0px");
                this.element.find(".pivotGridRowTable tr td:first-child").css((this.model.enableRTL?"border-right": "border-left"), "0px");
                this.element.find(".pivotGridRowTable tr td:last-child").css((!this.model.enableRTL ? "border-right" : "border-left"), "0px");
                this.element.find(".pivotGridFrozenTable tr:last td").css("border-bottom", "0px");

                if (!this.model.frozenHeaderSettings.enableFrozenColumnHeaders && this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                    this.element.find(".pivotGridFrozenTable tr td:first-child").css((this.model.enableRTL ? "border-right" : "border-left"), "0px")
                    this.element.find(".pivotGridValueTable tr:last td").css("border-bottom", "0px");
                    if (this.element.find(".pivotGridValueTable tr td:visible:eq(0)").attr("p"))
                        this.element.find(".pivotGridValueTable tr td[p^='" + this.element.find(".pivotGridValueTable tr td:visible:eq(0)").attr("p").split(",")[0] + ",']").css((this.model.enableRTL ? "border-right" : "border-left"), "0");
                }
                else if (this.model.frozenHeaderSettings.enableFrozenColumnHeaders && !this.model.frozenHeaderSettings.enableFrozenRowHeaders) {
                    this.element.find(".pivotGridRowTable  tr:eq(0) td").css("border-top", "0px");
                    this.element.find(".pivotGridValueTable tr:eq(0) td").css("border-top", "0px");
                }
                else {
                    this.element.find(".pivotGridFrozenTable tr td:first-child").css((this.model.enableRTL?"border-right": "border-left"), "0px");
                    this.element.find(".pivotGridValueTable tr:last td").css("border-bottom", "0px");
                    if (this.element.find(".pivotGridValueTable tr td:visible:eq(0)").attr("p"))
                        this.element.find(".pivotGridValueTable tr td[p^='" + this.element.find(".pivotGridValueTable tr td:visible:eq(0)").attr("p").split(",")[0] + ",']").css((this.model.enableRTL?"border-right": "border-left"), "0");
                    this.element.find(".pivotGridRowTable  tr:eq(0) td").css("border-top", "0px");
                    this.element.find(".pivotGridValueTable tr:eq(0) td").css("border-top", "0px");
                }
            }
            else {
                if (this.model.enableGroupingBar)
                    this._refreshGroupingBarLayout();
                $(this.element).css("overflow", "auto");
                this.element.find(".headerTable").css("display", "inline-block");
                this.element.find(".valScrollArea").css("height", "100%");
            }
        },

        _applyScroll: function () {
            if ((this.model.targetControl.model.frozenHeaderSettings.enableFrozenRowHeaders && this.model.targetControl.model.frozenHeaderSettings.enableFrozenColumnHeaders) || this.model.targetControl.model.frozenHeaderSettings.enableFrozenHeaders && (!this.model.targetControl.model.frozenHeaderSettings.enableFrozenRowHeaders && !this.model.targetControl.model.frozenHeaderSettings.enableFrozenColumnHeaders)) {
                if (this.isVScroll())
                    this.model.targetControl.element.find(".rowhead").scrollTop(this.model.scrollTop);
                if (this.isHScroll())
                    this.model.targetControl.element.find(".colhead").scrollLeft(this.model.scrollLeft);
            }
            else if (!(this.model.targetControl.model.frozenHeaderSettings.enableFrozenRowHeaders) && this.model.targetControl.model.frozenHeaderSettings.enableFrozenColumnHeaders) {
                if (this.isHScroll())
                    this.model.targetControl.element.find(".colhead").scrollLeft(this.model.scrollLeft);
            }
            else {
                if (this.isVScroll())
                    this.model.targetControl.element.find(".headerContent").scrollTop(this.model.scrollTop);
            }
        },

        _setGroupingBarFrozenRowBtnWidth: function () {
            if ((this.model.frozenHeaderSettings.enableFrozenRowHeaders && this.model.frozenHeaderSettings.enableFrozenColumnHeaders || (this.model.frozenHeaderSettings.enableFrozenHeaders && !(this.model.frozenHeaderSettings.enableFrozenRowHeaders && this.model.frozenHeaderSettings.enableFrozenColumnHeaders))) && this.element.find(".pivotGridRowTable").outerWidth()>= this.element.find(".grpRow").outerWidth())
                this.element.find(".pivotGridRowTable").css("min-width", this.element.find(".grpRow").outerWidth());
            this.element.find(".grpRow .removeBtn, .grpRow .filter, .grpRow .sorting ").css("position", "inherit");
            this.element.find(".colfreeze .pivotButton").width("auto");
            var areaWidth = this.element.find(".pivotGridRowTable").width();
            var pivotButtons = this.element.find(".colfreeze .pivotButton");
            var pvtBtn = areaWidth / (pivotButtons.length);
            if (areaWidth < pvtBtn)
                pvtBtn = areaWidth - (40);
            if (this.element.find(".rows").width() > areaWidth) {
                var pvtBtnsWidth = pvtBtn * (pivotButtons.length);
                {
                    if (pvtBtn > 50 && (pvtBtnsWidth > 140)) {
                        this.element.find(".rows .pivotButton").width((pvtBtn - 5));
                        this.element.find(".rows .pvtBtn").css({ width: (pvtBtn - 37), "text-overflow": "ellipsis" })
                    }
                    else {
                        this.element.find(".rows .pivotButton").width(50);
                        this.element.find(".rows .pvtBtn").css({ width: (20), "text-overflow": "ellipsis" })
                    }
                    var buttonWidth = this.element.find(".colfreeze .pivotButton:eq(0)").outerWidth();
                    var pivotArea = (buttonWidth * pivotButtons.length) + 30;
                    this.element.find(".rowHead").width(pivotArea);
                }
            }
        },

        _refreshGroupingBarLayout: function () {
            if ($(".pivotGridTable .value").length > 0 || $(".pivotGridTable .colheader").length > 0) {
                this.element.find(".groupingBarPivot ").width(this.element.find(".pivotGridTable").width());
            }
            else if (this.element.find(".pivotGridRowTable").length > 0) {
                this.element.find(".groupingBarPivot ").width(this.element.find(".pivotGridRowTable").width() + 140);
            } else
                this.element.find(".groupingBarPivot ").width(330);
            var colTableWidth = this.element.find(".pivotGridRowTable").width();
            this.element.find(".grpRow ,.values").width(colTableWidth);
            this.element.find(".columns").css({ "height": "auto", width: (this.element.find(".valueColumn").width() - this.element.find(".values").width() - 1) });
            this._setGroupingBarFrozenRowBtnWidth();
        },
        _cellRangeInfo: function (e) {
            var pGridObj = $(e.target).parents(".e-pivotgrid").data("ejPivotGrid");
            if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableDrillThrough && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                this._dataSet = this._pivotClientObj.dataSet;
            if ($(e.target).hasClass("cellValue")) e.target = e.target.parentElement;
            var colHaederLength = $("thead tr").length, selectedCellsDetails = [], selectedCells = [], j = 0, l = 0;
            var colheaders = $.grep(this.getJSONRecords(), function (item) { return (item.CSS == "colheader" || item.CSS == "summary" || item.CSS == " calc") && item.Index.split(',')[0] == $(e.target).attr("p").split(",")[0] });
            var rowheaders = $.grep(this.getJSONRecords(), function (item) { return (item.CSS == "rowheader" || item.CSS == "summary" || item.CSS == "summary rstot") && item.Index.split(',')[1] == $(e.target).attr("p").split(",")[1] });
            if (rowheaders.length == 1 && colheaders.length == 1 && (rowheaders[0].Value.toString().indexOf(this._getLocalizedLabels("GrandTotal")) >= 0 || colheaders[0].Value.toString().indexOf(this._getLocalizedLabels("GrandTotal")) >= 0 || colheaders[0].CSS == " calc")) {
                var obj = [];

                if ((colheaders[0].Value.toString().indexOf(this._getLocalizedLabels("GrandTotal")) >= 0 || colheaders[0].CSS == " calc") && rowheaders[0].Value.toString().indexOf("Grand") >= 0) {
                    for (var i = 0; i < this.model.dataSource.data.length; i++) {
                        selectedCellsDetails[i] = this.model.dataSource.data[i];
                    }
                }
                else {
                    if (rowheaders[0].Value.toString().indexOf(this._getLocalizedLabels("GrandTotal")) >= 0)
                        var text = colheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0 ? colheaders[0].Value.replace(" " + this._getLocalizedLabels("Total"), "") : colheaders[0].Value
                    else if (colheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0 || colheaders[0].CSS == " calc")
                        var text = rowheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0 ? rowheaders[0].Value.replace(" " + this._getLocalizedLabels("Total"), "") : rowheaders[0].Value

                    for (var i = 0; i < pGridObj.model.dataSource.data.length; i++) {
                        $.each(pGridObj.model.dataSource.data[i], function (key, value) {
                            if (value == text) {
                                selectedCellsDetails[j] = pGridObj.model.dataSource.data[i];
                                j++;
                            }
                        })
                    }
                }
            }

            else if (rowheaders.length >= 1 && colheaders.length >= 1 && (rowheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0 || colheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0)) {
                if (rowheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0)
                    var text = colheaders, text1 = rowheaders;
                else if (colheaders[0].Value.toString().indexOf(this._getLocalizedLabels("Total")) >= 0)
                    var text = rowheaders, text1 = colheaders;
                var selectedCellTempArray = (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) ? this.model.dataSource.data : (this._dataSet.length > 0 ? JSON.parse(this._dataSet) : []);

                for (var k = text.length - 1; k >= 0; k--) {
                    var selectedCellArray = new Array();
                    for (var i = 0; i < selectedCellTempArray.length; i++) {
                        $.each(selectedCellTempArray[i], function (key, value) {
                            if (value == text[k].Value) {
                                selectedCellArray.push(selectedCellTempArray[i]);
                            }

                        });
                    }
                    selectedCellTempArray = selectedCellArray;
                }
                selectedCellsDetails = selectedCellArray;
                if (text1[0].Value.toString().indexOf("Grand") <= 0) {
                    var selectedCellArray = new Array();
                    for (var i = 0; i < selectedCellTempArray.length; i++) {
                        $.each(selectedCellTempArray[i], function (key, value) {
                            if (value == text1[0].Value.replace(" Total", "")) {
                                selectedCellsDetails = [];
                                selectedCellArray.push(selectedCellTempArray[i]);
                            }
                        });
                    }
                }
                selectedCellsDetails = selectedCellsDetails.length == 0 ? selectedCellArray : selectedCellsDetails;
            }
            else {
                var rowText = rowheaders, colText = colheaders;
                var selectedCellTempArray = (this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) ? this.model.dataSource.data : (this._dataSet.length > 0 ? JSON.parse(this._dataSet) : []);

                for (var k = rowText.length - 1; k >= 0; k--) {
                    var selectedCellArray = new Array();
                    for (var i = 0; i < selectedCellTempArray.length; i++) {
                        $.each(selectedCellTempArray[i], function (key, value) {
                            if (value == rowText[k].Value) {
                                selectedCellArray.push(selectedCellTempArray[i]);
                            }
                        });
                    }
                    selectedCellTempArray = selectedCellArray;
                }
                for (var k = colText.length - 1; k >= 0; k--) {
                    if (colText[k].CSS.indexOf("calc") == -1) {
                        var selectedCellArray = new Array();
                        for (var i = 0; i < selectedCellTempArray.length; i++) {
                            $.each(selectedCellTempArray[i], function (key, value) {
                                if (value == colText[k].Value) {
                                    selectedCellArray.push(selectedCellTempArray[i]);
                                }

                            });
                        }
                        selectedCellTempArray = selectedCellArray;
                    }
                }
                selectedCellsDetails = selectedCellsDetails.length == 0 ? selectedCellArray : selectedCellsDetails;
            }
            var eventArgs = { selectedData: selectedCellsDetails, element: this.element, customObject: this.model.customObject };
            if (this.model.enableCellDoubleClick && this.model.enableCellDoubleClick != null) {
                this._trigger("cellDoubleClick", eventArgs);
            }
            if ((this.model.enableDrillThrough || ($(this.element).parents(".e-pivotclient").length > 0) && this._pivotClientObj.model.enableDrillThrough) && selectedCellsDetails.length > 0)
            var control=$(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableDrillThrough?this._pivotClientObj:this;
            control._trigger("drillThrough", eventArgs);
        },

        _initCellEditing: function (e) {
            if (e.target.tagName != "INPUT" && !$(e.target).hasClass("summary") && !$(e.target).parent().hasClass("summary")) {
                this._on(this.element, "mouseup", ".value", this._completeCellEditing);
                var targetCell;
                _oriX = e.pageX, _oriY = e.pageY;
                targetCell = e.target || window.event.srcElement;
                if ($(targetCell).hasClass("cellValue")) targetCell = $(targetCell).parent()[0];
                $(".value").addClass("selection");
                $("#" + this._id).append(ej.buildTag("div.cellSelection#" + this._id + "_cellSelection", "", {}));
                _startPosCell = $(targetCell)[0].attributes.getNamedItem("p").value;
                this._on(this.element, "mousemove", ".value, .cellSelection", this._cellSelection);
            }
            else
                this._off(this.element, "mouseup", ".value", this._completeCellEditing);
        },

        _completeCellEditing: function (e) {
            var targetCell, endPosCell, cellInfo = [], rowLThPos, curCelPos;
            if (e.target.tagName != "INPUT") {
                this._off(this.element, "mousemove", ".value");
                $(".value").removeClass("selection");
                targetCell = e.target || window.event.srcElement;
                if ($(targetCell).hasClass("cellValue")) targetCell = $(targetCell).parent()[0];
                endPosCell = $(targetCell)[0].attributes.getNamedItem("p").value;
                var count = 0;
                var inputBoxes = this.element.find(".curInput");
                if (inputBoxes.length > 0) {
                    if ($(targetCell).find(".curInput").length == 0)
                        this._updateTableCell();
                    $("#" + this._id + "_cellSelection").remove();
                    if (this.model.enableToolTip) {
                        this._on(this.element, "mousemove", ".value", this._applyToolTip);
                    }
                    this._off(this.element, "mouseup", ".value");
                    return false;
                }
                for (var rowSelCnt = (parseInt(_startPosCell.split(",")[1]) < parseInt(endPosCell.split(",")[1]) ? parseInt(_startPosCell.split(",")[1]) : parseInt(endPosCell.split(",")[1])) ; rowSelCnt <= (parseInt(_startPosCell.split(",")[1]) > parseInt(endPosCell.split(",")[1]) ? parseInt(_startPosCell.split(",")[1]) : parseInt(endPosCell.split(",")[1])) ; rowSelCnt++) {
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap || $("#" + this._id).find("td[p*='," + rowSelCnt + "']").parent().is(":visible")) {
                        for (var colSelCnt = (parseInt(_startPosCell.split(",")[0]) < parseInt(endPosCell.split(",")[0]) ? parseInt(_startPosCell.split(",")[0]) : parseInt(endPosCell.split(",")[0])) ; colSelCnt <= (parseInt(_startPosCell.split(",")[0]) > parseInt(endPosCell.split(",")[0]) ? parseInt(_startPosCell.split(",")[0]) : parseInt(endPosCell.split(",")[0])) ; colSelCnt++) {
                            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap || $("#" + this._id).find("[p*='" + colSelCnt + ",']").last("th").is(":Visible") || (!this.model.enableGrandTotal || !this.model.enableRowGrandTotal)) {
                                cellInfo[count] = this.getJSONRecords()[((colSelCnt) * this._rowCount) + rowSelCnt];
                                if (!$("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").hasClass("summary")) {
                                    if ($("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "] span.cellValue").length > 0) {
                                        var value = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ($("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "] span.cellValue").text() != "" ? $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "] span.cellValue").text() : $(".curInput").val()) : $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "] span.cellValue").text();
                                        $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "] span.cellValue").html("<input type='text' class='curInput' value='" + value + "' />");
                                    }
                                    else if ($("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").children().length > 0) {
                                        $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").append("<input type='text' class='curInput' value='' />");
                                    }
                                    else {
                                        var value = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ($("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").text() != "" ? $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").text() : $(".curInput").val()) : $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").text();
                                        $("[p=" + "'" + colSelCnt + ',' + rowSelCnt + "'" + "]").html("<input type='text' class='curInput' value='" + value + "' />");
                                    }
                                }
                                var rowInfo, rowValue = "";
                                var tempThPos, measureColumn, measureRowCount = 0, measureColCount = 0;
                                if (this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders)
                                    rowLThPos = this.element.find(".summary[role!='gridcell'][p$='," + $(targetCell).attr('p').split(',')[1] + "'] , .rowheader[role!='gridcell'][p$='," + $(targetCell).attr('p').split(',')[1] + "']").last().attr("p");
                                else
                                    rowLThPos = this.element.find(".summary[role!='gridcell'][p$='," + rowSelCnt + "'] , .rowheader[role!='gridcell'][p$='," + rowSelCnt + "']").last().attr("p");
                                if (rowLThPos == undefined) {
                                    rowLThPos = $("#" + this._id).find("tbody").find('[p="' + colSelCnt + "," + rowSelCnt + '"]').parent("tr").find(".summary").first().attr('p');
                                }
                                tempThPos = rowLThPos;
                                if (rowLThPos != null) {
                                    while (rowLThPos[0] >= 0) {
                                        if (rowLThPos == this.getJSONRecords()[parseInt((parseInt(rowLThPos.split(",")[0]) * this._rowCount) + parseInt(rowLThPos.split(",")[1]))].Index) {
                                            rowInfo = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this.getJSONRecords()[parseInt((parseInt(rowLThPos.split(",")[0]) * this._rowCount) + parseInt(rowLThPos.split(",")[1]))].Info.split("::")[0] : this.getJSONRecords()[parseInt((parseInt(rowLThPos.split(",")[0]) * this._rowCount) + parseInt(rowLThPos.split(",")[1]))].Value;
                                            rowLThPos = parseInt(rowLThPos.split(",")[0]) - 1 + "," + parseInt(rowLThPos.split(",")[1]);
                                        }
                                        if ((rowValue) && (rowInfo != ""))
                                            rowValue = rowInfo + "#" + rowValue;
                                        else if (rowInfo != "")
                                            rowValue = rowInfo;
                                    }
                                    this._rowHeader[count] = rowValue;
                                    var header = this._rowHeader[count].toString().split('#');
                                    if (header.length > 1) {
                                        for (var i = 0; i < header.length - 1; i++) {
                                            for (var j = 0; j < header[i].split('.').length; j++) {
                                                if (header[i].split('.')[j] == header[i + 1].split('.')[j] && header[i].split('.')[j + 1] == header[i + 1].split('.')[j + 1]) {
                                                    header.splice(i, 1);
                                                    break;
                                                }
                                            }
                                        }
                                        this._rowHeader[count] = "";
                                        for (var i = 0; i < header.length; i++) {
                                            this._rowHeader[count] += this._rowHeader[count] == "" ? header[i] : "#" + header[i];
                                        }
                                    }
                                }
                                var columnValue = "", headerInfo;
                                var isFrozenHeader = this.model.frozenHeaderSettings.enableFrozenHeaders || this.model.frozenHeaderSettings.enableFrozenColumnHeaders || this.model.frozenHeaderSettings.enableFrozenRowHeaders;
                                var colHeadRCnt = this.element.find((isFrozenHeader ? ".pivotGridFrozenTable " : "") + 'tr:has(".colheader")').length - 1;
                                measureColumn = colHeadRCnt;
                                curCelPos = cellInfo[count].Index;
                                if ((curCelPos != undefined) && (curCelPos == this.getJSONRecords()[parseInt((parseInt(curCelPos.split(",")[0]) * this._rowCount) + parseInt(curCelPos.split(",")[1]))].Index)) {
                                    var colPos = parseInt(curCelPos.split(",")[0]);
                                }
                                for (var rCnt = 0; rCnt <= colHeadRCnt; rCnt++) {
                                    if (colPos != null)
                                        if ((colPos + "," + rCnt) == (this.getJSONRecords()[parseInt((parseInt(colPos) * this._rowCount) + rCnt)].Index)) {
                                            headerInfo = this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? this.getJSONRecords()[parseInt((parseInt(colPos) * this._rowCount) + rCnt)].Info.split("::")[0] : this.getJSONRecords()[parseInt((parseInt(colPos) * this._rowCount) + rCnt)].Value;
                                            if (columnValue == "")
                                                columnValue = headerInfo;
                                            else if (headerInfo != "")
                                                columnValue = columnValue + "#" + headerInfo;
                                        }
                                    this._colHeader[count] = columnValue;

                                }
                                var header = this._colHeader[count].split('#');
                                if (header.length > 1) {
                                    for (var i = 0; i < header.length - 1; i++) {
                                        for (var j = 0; j < header[i].split('.').length; j++) {
                                            if (header[i].split('.')[j] == header[i + 1].split('.')[j] && header[i].split('.')[j + 1] == header[i + 1].split('.')[j + 1]) {
                                                header.splice(i, 1);
                                                break;
                                            }
                                        }
                                    }
                                    this._colHeader[count] = "";
                                    for (var i = 0; i < header.length; i++) {
                                        this._colHeader[count] += this._colHeader[count] == "" ? header[i] : "#" + header[i];
                                    }
                                }
                                count++;
                            }
                        }
                    }
                }
                this._originalValue = "";
                this._cellInfo = cellInfo;
                for (var index = 0; index < this.element.find(".curInput").length; index++) {
                    var cell = this.element.find(".curInput")[index];
                    this._originalValue += this._originalValue == "" ? cell.value : "#" + cell.value;
                }
                args = { JSONRecords: cellInfo, rowHeader: this._rowHeader, columnHeader: this._colHeader, measureCount: (measureRowCount > 0 ? ("Row:" + measureRowCount) : ("Column:" + measureColCount)) }
                this._trigger("cellSelection", args);
                cellInfo = rowHeader = colHeader = [];
                $("#" + this._id + "_cellSelection").remove();
                if (this.model.enableToolTip) {
                    this._on(this.element, "mousemove", ".value", this._applyToolTip);
                }
                this._off(this.element, "mouseup", ".value");
            }
            $(".curInput").keypress(function (event) {
                if (event.which == 13) {
                    var pGridObj = $(event.target).parents(".e-pivotgrid").data("ejPivotGrid");
                    pGridObj._updateTableCell();
                }
            })
        },

        _updateTableCell: function () {
            var updateValue = "", tempVal = "";
            var editValue = $(".curInput");
            $.each(editValue, function (index, cell) {
                updateValue += updateValue == "" ? cell.value : "#" + cell.value;
            })
            var originalValueCmp = [];
            var rowHeaderName = this._rowHeader;
            var columnHeaderName = this._colHeader;
            tempVal = updateValue.split("#");
            for (var i = tempVal.length - 1; i >= 0; i--) {
                if (tempVal[i] == this._originalValue.split("#")[i]) {
                    rowHeaderName.splice(i, 1);
                    columnHeaderName.splice(i, 1);
                    tempVal.splice(i, 1);
                    this._cellInfo.splice(i, 1);
                }
                else {
                    originalValueCmp.push(this._originalValue.split("#")[i]);
                    this._cellInfo[i].Value = tempVal[i] = tempVal[i] == "" ? "0" : tempVal[i];
                }
            }
            originalValueCmp = originalValueCmp.reverse();
            updateValue = "";
            for (var j = 0; j < tempVal.length; j++) {
                updateValue += updateValue == "" ? tempVal[j] : "#" + tempVal[j];
            }
            if (updateValue.length == 0) {
                for (var j = editValue.length - 1; j >= 0; j--) {
                    $(editValue[j]).closest("td").text($(".curInput")[j].value)
                }
                return false;
            }
            this._waitingPopup.show();

            var report;
            if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                try {
                    report = JSON.parse(this.getOlapReport()).Report;
                }
                catch (err) {
                    report = this.getOlapReport();
                }
            }

            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {

                if (ej.isNullOrUndefined(this.model.editCellsInfo.JSONRecords) || this.model.editCellsInfo.JSONRecords.length == 0)
                    this.model.editCellsInfo = { JSONRecords: [], rowHeader: [], columnHeader: [] };

                var rowHeaders = this.model.editCellsInfo.rowHeader, colHeaders = this.model.editCellsInfo.columnHeader, values = this.model.editCellsInfo.JSONRecords, updateValueArray = this._cellInfo;
                for (uV = 0; uV < updateValueArray.length; uV++) {
                    var existCount = 0;
                    for (var vC = 0; vC < values.length; vC++) {
                        if (rowHeaders[vC] == rowHeaderName[uV] && colHeaders[vC] == columnHeaderName[uV]) {
                            values[vC].Value = updateValueArray[uV].Value;
                            existCount++;
                            break;
                        }
                    }
                    if (existCount == 0) {
                        rowHeaders.push(rowHeaderName[uV]);
                        colHeaders.push(columnHeaderName[uV]);
                        values.push(updateValueArray[uV]);
                    }
                }
                this._trigger("cellEdit", { editCellsInfo: this.model.editCellsInfo });

                if (!ej.isNullOrUndefined(this.model.editCellsInfo.JSONRecords) && this.model.editCellsInfo.JSONRecords.length > 0) {
                    if (this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                        var updateValue = "", cellPos = "", measure = "";
                        $.each(this.model.editCellsInfo.JSONRecords, function (index, val) {
                            updateValue = updateValue == "" ? val.Value : updateValue + ":" + val.Value;
                            cellPos = cellPos == "" ? val.Index : cellPos + ":" + val.Index;
                            measure = measure == "" ? colHeaders[index].toString().split('#')[colHeaders[index].toString().split('#').length - 1] : measure + ":" + colHeaders[index].toString().split('#')[colHeaders[index].toString().split('#').length - 1];
                        })
                        var eventArgs = JSON.stringify({ action: "cellEditing", "index": cellPos, "valueHeaders": measure, "summaryValues": updateValue, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": JSON.stringify(this.model.customObject) });
                        this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.cellEditing, eventArgs, this._renderControlSuccess);
                        for (var j = editValue.length - 1; j >= 0; j--) {
                            $(editValue[j]).closest("td").text($(editValue[j]).val());
                        }
                    }
                    else
                        this._populatePivotGrid();
                }
                else {
                    for (var j = editValue.length - 1; j >= 0; j--) {
                        $(editValue[j]).closest("td").text(ej.isNullOrUndefined(this._originalValue.split('#')[j]) ? "" : this._originalValue.split('#')[j]);
                    }
                    this._waitingPopup.hide();
                }
            }
            else if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: "writeBack", element: this.element });

                this.model.editCellsInfo.JSONRecords = this._cellInfo;
                this.model.editCellsInfo.rowHeader = rowHeaderName;
                this.model.editCellsInfo.columnHeader = columnHeaderName;

                this._trigger("cellEdit", { editCellsInfo: this.model.editCellsInfo });
                var updateValue = "";
                if (!ej.isNullOrUndefined(this.model.editCellsInfo.JSONRecords) && this.model.editCellsInfo.JSONRecords.length > 0) {
                    $.each(this.model.editCellsInfo.JSONRecords, function (index, val) {
                        updateValue = updateValue == "" ? val.Value : updateValue + ":" + val.Value;
                    })
                }

                eventArgs = JSON.stringify({ action: "writeBack", "value": updateValue, "rowUniqueName": JSON.stringify(this.model.editCellsInfo.rowHeader), "columnUniqueName": JSON.stringify(this.model.editCellsInfo.columnHeader), "currentReport": report, "customObject": JSON.stringify(this.model.customObject) });
                if (!ej.isNullOrUndefined(this.model.editCellsInfo.JSONRecords) && this.model.editCellsInfo.JSONRecords.length > 0)
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.writeBack, eventArgs, this._renderControlSuccess);
                else {
                    for (var j = editValue.length - 1; j >= 0; j--) {
                        $(editValue[j]).closest("td").text(ej.isNullOrUndefined(this._originalValue.split('#')[j]) ? "" : this._originalValue.split('#')[j]);
                    }
                    this._waitingPopup.hide();
                }
            }
            this._rowHeader = [];
            this._colHeader = [];
        },

        _createVirtualPivotGrid: function (tableOlapGrid) {
            var verticalScroll = this._seriesPageCount > 1 ? ej.buildTag("div.vScrollPanel")[0].outerHTML : "";
            var horizontalScroll = this._categPageCount > 1 ? ej.buildTag("div.hScrollPanel")[0].outerHTML : "";
            var oGridDiv = ej.buildTag("td.virtualScrollGrid", tableOlapGrid[0].outerHTML)[0];
            var vertiScrollTd = ej.buildTag("td.virtualScrollElement", verticalScroll);
            var horiScrollTd = ej.buildTag("td.virtualScrollElement", horizontalScroll);
            var trow = ej.buildTag("tr.virtualScrollElement", oGridDiv.outerHTML + vertiScrollTd[0].outerHTML);
            var trow2 = ej.buildTag("tr.virtualScrollElement", horiScrollTd[0].outerHTML + ej.buildTag("td.virtualScrollElement")[0].outerHTML);
            var virtualOlapGrid = ej.buildTag("tbody.oGridOuterDiv.virtualScrollElement", trow[0].outerHTML + trow2[0].outerHTML);
            this.element.html(ej.buildTag("table.virtualScrollElement", virtualOlapGrid[0].outerHTML));
            var seriesPageIndicator = ej.buildTag("div.seriesPageIndicator inActive", ej.buildTag("span.axislabel", this._getLocalizedLabels("SeriesPage"))[0].outerHTML + ej.buildTag("span.series_CurrentPage", this._seriesCurrentPage)[0].outerHTML + " / " + ej.buildTag("span.series_pageCount", this._seriesPageCount)[0].outerHTML)[0].outerHTML;
            if (this._seriesPageCount > 1) this.element.append(seriesPageIndicator);
            var categPageIndicator = ej.buildTag("div.categPageIndicator inActive", ej.buildTag("span.axislabel", this._getLocalizedLabels("CategoricalPage"))[0].outerHTML + ej.buildTag("span.categ_CurrentPage", this._categCurrentPage)[0].outerHTML + " / " + ej.buildTag("span.categ_pageCount", this._categPageCount)[0].outerHTML)[0].outerHTML;
            if (this._categPageCount > 1) this.element.append(categPageIndicator);
        }

    });

    ej.PivotGrid.Layout = {
        Normal: "normal",
        NormalTopSummary: "normaltopsummary",
        NoSummaries: "nosummaries",
        ExcelLikeLayout: "excellikelayout"
    };

    ej.PivotGrid.Locale = {};

    ej.PivotGrid.Locale["en-US"] = {
        Sort: "Sort",
        Search: "Search",
        SelectField: "select Field",
        LabelFilterLabel:"Show the items for which the label",
        ValueFilterLabel: "Show the items for which",
        ClearSorting: "Clear Sorting",
        ClearFilterFrom: "Clear Filter From",
        SortAtoZ: "Sort A to Z",
        SortZtoA: "Sort Z to A",
        and: "and",

        LabelFilters: "Label Filters  ",
        BeginsWith: "Begins With",
        DoesNotBeginsWith: "Does Not Begins With",
        EndsWith: "Ends With",
        NotEndsWith: "Not Ends With",
        DoesNotEndsWith: "Does Not End With",
        Contains: "Contains",
        DoesNotContains: "Does Not Contain",

        ValueFilters: "Value Filters",
        ClearFilter: "Clear Filter",
        Equals: "Equals",
        DoesNotEquals:"Does Not Equal",
        NotEquals: "Not Equals",
        GreaterThan: "Greater Than",
        IsGreaterThan: "Is Greater Than",
        IsGreaterThanOrEqualTo: "Is Greater Than Or Equal To",
        IsLessThan: "Is Less Than",
        IsLessThanOrEqualTo: "Is Less Than Or Equal To",

        GreaterThanOrEqualTo: "Greater Than Or Equal To",
        LessThan: "Less Than",
        LessThanOrEqualTo: "Less Than Or Equal To",
        Between: "Between",
        NotBetween: "Not Between",
        Top10: "Top Count",

        AddToFilter: "Add to Filter",
        AddToRow: "Add to Row",
        AddToColumn: "Add to Column",
        AddToValues: "Add to Values",
        Warning: "Warning",
        Error: "Error",
        GroupingBarAlertMsg: "The field you are moving cannot be placed in that area of the report",
        Measures: "Measures",
        Expand: "Expand",
        Collapse:"Collapse",
        ToolTipRow: "Row",
        ToolTipColumn: "Column",
        ToolTipValue: "Value",
        NoValue: "No value",
        SeriesPage: "Series Page",
        CategoricalPage: "Categorical Page",
        DragFieldHere: "Drag field here",
        ColumnArea: "Drop column here",
        RowArea: "Drop row here",
        ValueArea: "Drop values here",
        Close:"Close",
        OK: "OK",
        Cancel: "Cancel",
        Remove: "Remove",
        Goal: "Goal",
        Status: "Status",
        Trend: "Trend",
        Value: "value",
        ConditionalFormattingErrorMsg: "The given value is not matched",
        ConditionalFormattingConformMsg: "Are you sure you want to remove the selected format?",
        EnterOperand1: "Enter Operand1",
        EnterOperand2: "Enter Operand2",
        ConditionalFormatting: "Conditional Formatting",
        Condition: "Conditional Type",
        Value1: "Value1",
        Value2: "Value2",
        Editcondtion: "Edit Condition",
        AddNew: "Add New",
        Format: "Format",
        Backcolor: "Back Color",
        Borderrange: "Border Range",
        Borderstyle: "Border Style",
        Fontsize: "Font Size",
        Fontstyle: "Font Style",
        Bordercolor: "Border Color",
        NoMeasure: "Please add any measure",
        AliceBlue: "AliceBlue",
        Black: "Black",
        Blue: "Blue",
        Brown: "Brown",
        Gold: "Gold",
        Green: "Green",
        Lime: "Lime",
        Maroon: "Maroon",
        Orange: "Orange",
        Pink: "Pink",
        Red: "Red",
        Violet: "Violet",
        White: "White",
        Yellow: "Yellow",
        Solid: "Solid",
        Dashed: "Dashed",
        Dotted: "Dotted",
        Double: "Double",
        Groove: "Groove",
        Inset: "Inset",
        Outset: "Outset",
        Ridge: "Ridge",
        None: "None",
        Algerian: "Algerian",
        Arial: "Arial",
        BodoniMT: "Bodoni MT",
        BritannicBold: "Britannic Bold",
        Cambria: "Cambria",
        Calibri: "Calibri",
        CourierNew: "Courier New",
        DejaVuSans: "DejaVu Sans",
        Forte: "Forte",
        Gerogia: "Gerogia",
        Impact: "Impact",
        SegoeUI: "Segoe UI",
        Tahoma: "Tahoma",
        TimesNewRoman: "Times New Roman",
        Verdana: "Verdana",
        CubeDimensionBrowser: "Cube Dimension Browser",
        SelectHierarchy: "Select Hierarchy",
        CalculatedField: "Calculated Field",
        Name: "Name:",
        Add: "Add",
        Formula: "Formula:",
        Delete: "Delete",
        Fields: "Fields:",
        MultipleItems: "Multiple items",
        All:"All",
        CalculatedFieldNameNotFound: "Given CalculatedField name is not found",
        InsertField: "Insert Field",
        EmptyField: "Please enter Calculated field name or formula",
        NotValid: "Given formula is not valid",
        NotPresent: "Value field used in any of the Calculated Field formula is not present in the PivotGrid",
        Confirm: "Calculated field with the same name already exists. Due to want to Replace ?",
        CalcValue: "Calculated field can be inserted only in value area field",
        NoRecordsToDisplay: "No records to display.",
         NumberFormatting: "Number Formatting",
        FrozenHeaders: "Frozen Headers",
        CellSelection: "Cell Selection",
        CellContext: "Cell Context",
        ColumnResize: "Column Resize",
        Layouts:"Layouts",
        ExcelLikeLayout: "Excel Like Layout",
        NormalLayout: "Normal Layout",
        NormalTopSummary: "NormalTopSummary Layout",
        NoSummaries:"NoSummaries Layout",
        FrozenHeader: "Frozen Header",
        AdvancedFiltering: "Advanced Filtering",
        Amount: "Amount",
        Quantity: "Quantity",
        Measures: "Measures",
        NumberFormats: "Number Formats",
        Exporting: "Exporting",
        FileName: "File Name",
        ToolTip: "Tool Tip",
        RTL: "RTL",
        CollapseByDefault: "Collapse By Default",
        EnableDisablePaging: "Enalbe / Disable Paging",
        PagingOptions: "Paging Options",
        CategoricalPageSize: "Categorical Page Size",
        SeriesPageSize: "Series Page Size",

        HyperLink: "HyperLink",
        CellEditing: "Cell Editing",
        GroupingBar:"Grouping Bar",
        SummaryCustomization: "Summary Customization",
        SummaryTypes: "Summary Types",
        SummaryType: "Summary Type",
        EnableRowHeaderHyperlink: "Enable RowHeaderHyperLink",
        EnableColumnHeaderHyperlink: "Enable ColumnHeaderHyperLink",
        EnableValueCellHyperlink: "Enable ValueCellHyperLink",
        EnableSummaryCellHyperlink: "Enable SummaryCellHyperLink",
        HideGrandTotal: "Hide GrandTotal",
        HideSubTotal: "Hide SubTotal",
        Row: "Row",
        Column: "Column",
        Both:"Both",
        Sum: "Sum",
        Average: "Average",
        Count: "Count",
        Min: "Min",

        Max: "Max",
        Excel: "Excel",
        Word: "Word",
        PDF: "PDF",
        CSV: "CSV",
        Total: "Total",
        GrandTotal: "Grand Total",
        DrillThrough: "Drill Through",
        EnabledState: "Enabled State"
       };

    ej.PivotGrid.ExportOptions = {
        Excel: 'excel',
        Word: 'word',
        PDF: 'pdf',
        CSV: 'csv'
    };

    ej.PivotGrid.ConditionalOptions = {
        Equals: "Equals",
        NotEquals: "Not Equals",
        GreaterThan: "Greater Than",
        GreaterThanOrEqualTo: "Greater Than Or Equal To",
        LessThan: "Less Than",
        LessThanOrEqualTo: "Less Than Or Equal To",
        Between: "Between",
        NotBetween: "Not Between"
    };

    ej.PivotGrid.AnalysisMode = {
        Olap: "olap",
        Relational: "relational"
    };
    ej.PivotGrid.ExportMode = {
        JSON: "json",
        PivotEngine: "pivotengine"
    };
    ej.PivotGrid.OperationalMode = {
        ClientMode: "clientmode",
        ServerMode: "servermode"
    };

    if (ej.olap.base)
        $.extend(ej.PivotGrid.prototype, ej.olap.base);
    if (ej.olap._mdxParser)
        $.extend(ej.PivotGrid.prototype, ej.olap._mdxParser);

})(jQuery, Syncfusion);;
/**
* @fileOverview Pivot Schema Designer control to list out and analyze the data
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejPivotSchemaDesigner", "ej.PivotSchemaDesigner", {
        _rootCSS: "e-pivotschemadesigner",
        element: null,
        model: null,
        _requiresID: true,
        validTags: ["div", "span"],
        defaults: {
            url: "",
            cssClass: "",
            height: "630px",
            width: "415px",
            locale: "en-US",
            layout: "excel",
            enableRTL: false,
            pivotControl: null,
            pivotTableFields: [],
            pivotCalculations: [],
            pivotColumns: [],
            pivotRows: [],
            filters: [],
            olap: {
                showKpi: false,
                showNamedSets: false,
            },
            enableWrapper: false,
			enableDragDrop: true,
            serviceMethods: {
                fetchMembers: "FetchMembers", nodeStateModified: "NodeStateModified",
                nodeDropped: "NodeDropped", removeButton: "RemoveButton",
                memberExpand: "MemberExpanded", filtering: "filtering", sorting: "sorting"
            },
            customObject: {},
            beforeServiceInvoke: null,
            afterServiceInvoke: null,
            dragMove: null,
            applyFieldCaption: null
        },

        dataTypes: {
            serviceMethods: "data",
            customObject: "data",
            pivotControl: "data",
            pivotTableFieldList: "array",
            pivotCalculationList: "array",
            pivotColumnList: "array",
            pivotRowList: "array",
            filterList: "array"
        },

        locale: ej.util.valueFunction("locale"),

        _init: function () {
            this._initPrivateProperties();
            this._load();
        },

        _destroy: function () {
            this.element.empty().removeClass("e-pivotschemadesigner" + this.model.cssClass);
        },

        _initPrivateProperties: function () {
            this._id = this.element.attr("id");
            this._dialogTitle = "";
            this._currentMembers = new Array();
            this._memberTreeObj = null;
            this._tableTreeObj = null;
            this._dialogOKBtnObj = null;
            this._curFilteredText = "";
            this._curFilteredAxis = "";
            this._tempFilterData = null;
            this._droppedClass = "";
            this._selectedTreeNode = null;
            this._selectedMember = "";
            this._selectedLevel = "";
            this._isDragging = false;
            this._dataModel = "";
            this._droppedPosition = "";
            this._currentCubeName = "";
            this._errorDialog = "";
            this._nodeDropedParams = "";
            this._contextMenuObj = null;
            this._removeButtonDeferUpdate = false;
            this._isMeasureBtnRemove = false;
            this._nodeCheck = false;
            this._isFiltered = false;
            this._curFocus = { tree: null, node: null, tab: null, button: null };
            this._index = { tree: 0, node: 0, tab: 0, button: 0};
            this._selectedFieldName = "";
            this._selectedFieldCaption = "";
            this._selectedFieldAxis = "";
            this._isDropAction = false;
            this._ascdes = "";
            this._pivotClientObj = null;
            this._memberPageSettings = {
                currentMemeberPage: 1,
                startPage: 0,
                endPage: 0
            };
            this._isAllMemberChecked = true;
            this._editorTreeData = [];
            this._memberPagingAvdData = [];
        },

        _load: function () {
            var itemProps = "", report;
            if (this.model.pivotControl != null) {
                this.model.pivotControl._schemaData = this;
                if ($(this.element).parents(".e-pivotclient").length > 0)
                    this._pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    itemProps = JSON.parse(JSON.parse(this.model.pivotControl.getOlapReport()).ItemsProperties);
                    report = JSON.parse(this.model.pivotControl.getOlapReport());
                    if (this.model.pivotControl._dataModel == "Pivot") {
                        report = this.model.pivotControl._filterReport(report);
                        var items = report.PivotRows.concat(report.PivotColumns, report.PivotCalculations, report.Filters);
                        var treeViewData = $.grep(itemProps, function (value) { $.grep(items, function (field) { if (value.id == (field.FieldHeader || field.DimensionHeader)) value.id = (field.FieldName || field.DimensionName); }); return value; });
                        this._setTableFields(treeViewData);
                    }
                    else
                        this._setTableFields(itemProps);
                    this._setPivotRows(report.PivotRows);
                    this._setPivotColumns(report.PivotColumns);
                    this._setPivotCalculations(report.PivotCalculations);
                    this._setFilters(report.Filters);
                    this._dataModel = report.DataModel;
                    this._currentCubeName = report.CurrentCube;
                }
                else {
                    report = this.model.pivotControl.model.dataSource;
                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                        this.model.pivotTableFields = ej.PivotAnalysis.getTreeViewData(this.model.pivotControl.model.dataSource);
                }
                this._trigger("load", { element: this.element });
                if (this.model._waitingPopup) {
                    this._waitingPopup = this.model._waitingPopup;
                }
                else {
                    $("#" + this._id).ejWaitingPopup({ showOnInit: true });
                    this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
                }
                this.element.width(this.model.width).height(this.model.height);
                this._waitingPopup.show();
            }
            if (!this.model.enableWrapper) {
                var fieldTable =
                    (this.model.layout == "onebyone" ? "" : ej.buildTag("table.headerTable", ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.listHeader", ej.buildTag("span.headerText", this._getLocalizedLabels("PivotTableFieldList"), {})[0].outerHTML, {})[0].outerHTML + ej.buildTag("div.listSubhead", ej.buildTag("span.subheadText", this._getLocalizedLabels("ChooseFieldsToAddToReport"), {})[0].outerHTML, {})[0].outerHTML, {}).attr("valign", "top")[0].outerHTML, {})[0].outerHTML, { "width": "100%", "height": "10%" })[0].outerHTML) +

                    ej.buildTag("div.fieldTable",
                    ((this.model.pivotControl != null && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne) ? ej.buildTag("div.cubelists", ej.buildTag("input#cubeList.cubeList").attr("type", "text")[0].outerHTML)[0].outerHTML : "") +
                    ej.buildTag("div.parentSchemaFieldTree", ej.buildTag("div.schemaFieldTree#" + this._id + "_schemaFieldTree", {}, { "width": "100%" })[0].outerHTML).attr("valign", "top")[0].outerHTML).attr("overflow","auto")[0].outerHTML;

                    var filterAxis =
                    ej.buildTag("div.axisTd1", ej.buildTag("div.pivotHeader", ej.buildTag("span.headerText", this._getLocalizedLabels("ReportFilter"), {})[0].outerHTML, {})[0].outerHTML +
                    ej.buildTag("div.schemaFilter", ej.buildTag("p#reportfilter", "report filter", { "display": "none" })[0].outerHTML +
                this._createPivotButtons("filters", this.model.filters)).attr("aria-describedby", "reportfilter").attr("aria-dropeffect", "none").attr("aria-selected", "false")[0].outerHTML, {})[0].outerHTML;

                    var columnAxis =
                    ej.buildTag("div.axisTd2", ej.buildTag("div.rPivotHeader", ej.buildTag("span.headerText", this._getLocalizedLabels("ColumnLabel"), {})[0].outerHTML, {})[0].outerHTML +
                    ej.buildTag("div.schemaColumn", ej.buildTag("p#columnlabel", "column label", { "display": "none" })[0].outerHTML + this._createPivotButtons("columns", this.model.pivotColumns) +
                (this._dataModel != "XMLA" || this.model.pivotCalculations.length == 0 ? "" : (this.model.pivotCalculations[0]["measures"] != undefined && this.model.pivotCalculations[0]["measures"].length > 0 && this.model.pivotCalculations[0]["axis"] != undefined && this.model.pivotCalculations[0]["axis"] == "columns" ? this._createPivotButtons("columns", [{ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }]) : "")), {})[0].outerHTML, {}).attr("aria-describedby", "columnlabel").attr("aria-dropeffect", "none").attr("aria-selected", "false")[0].outerHTML;

                    var rowAxis =
                    ej.buildTag("div.axisTd1#axisTd", ej.buildTag("div.pivotHeader", ej.buildTag("span.headerText", this._getLocalizedLabels("RowLabel"), {})[0].outerHTML, {})[0].outerHTML +
                    ej.buildTag("div.schemaRow", ej.buildTag("p#rowlabel", "row label", { "display": "none" })[0].outerHTML +
                    this._createPivotButtons("rows", this.model.pivotRows) +
                (this._dataModel != "XMLA" || this.model.pivotCalculations.length == 0 ? "" : (this.model.pivotCalculations[0]["measures"] != undefined && this.model.pivotCalculations[0]["measures"].length > 0 && this.model.pivotCalculations[0]["axis"] != undefined && this.model.pivotCalculations[0]["axis"] == "rows" ? this._createPivotButtons("rows", [{ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }]) : "")), {})[0].outerHTML, {}).attr("aria-describedby", "rowlabel").attr("aria-dropeffect", "none").attr("aria-selected", "false")[0].outerHTML;

                    var values =
                    ej.buildTag("div.axisTd2#axisTd3", ej.buildTag("div.rPivotHeader", ej.buildTag("span.headerText", this._getLocalizedLabels("Values"), {})[0].outerHTML, {})[0].outerHTML +
                ej.buildTag("div.schemaValue", ej.buildTag("p#valuelabel", "values", { "display": "none" })[0].outerHTML + this._createPivotButtons("values", this.model.pivotCalculations), {}).attr("aria-describedby", "valuelabel").attr("aria-dropeffect", "none").attr("aria-selected", "false")[0].outerHTML, {})[0].outerHTML;

                    var axisTable = ej.buildTag("div.axisTable", (this.model.layout == "onebyone" ? (columnAxis + rowAxis + filterAxis + values) : (ej.buildTag("div", filterAxis + columnAxis, {})[0].outerHTML + ej.buildTag("div", rowAxis + values, {})[0].outerHTML)), (this.model.enableRTL && this.model.layout == "onebyone" ? { "position": "relative", "left":this._pivotClientObj.model.enableSplitter?"": "7px" } : {}))[0].outerHTML;

                var deferUpdate = ej.buildTag("div.deferUpdateLayout", ej.buildTag("input.chkDeferUpdate", "", {}).attr("type", "checkbox")[0].outerHTML + ej.buildTag("button.btnDeferUpdate", this._getLocalizedLabels("Update"), {}).attr("type", "button")[0].outerHTML)[0].outerHTML;
                var htmlTag;
                if (this.model.enableRTL && this.element.parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableSplitter) {
                    htmlTag = axisTable + (this.model.layout == "onebyone" ? "" : ej.buildTag("div.centerDiv")[0].outerHTML + ej.buildTag("div.centerHead", this._getLocalizedLabels("DragFieldBetweenAreasBelow"))[0].outerHTML) +
                              fieldTable + ($(this.element).parents(".e-pivotclient").length > 0 ? "" : ej.buildTag("span.responsiveSchema", "")[0].outerHTML) + (this.model.pivotControl != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && $(this.element).parents(".e-pivotclient").length == 0 ? deferUpdate : "") + ($(this.element).parents(".e-pivotclient").length > 0 ? "" : ej.buildTag("div.schemaNoClick", "")[0].outerHTML);
                }
                else {
                    htmlTag = fieldTable + (this.model.layout == "onebyone" ? "" : ej.buildTag("div.centerDiv")[0].outerHTML + ej.buildTag("div.centerHead", this._getLocalizedLabels("DragFieldBetweenAreasBelow"))[0].outerHTML) +
                              axisTable + ($(this.element).parents(".e-pivotclient").length > 0 ? "" : ej.buildTag("span.responsiveSchema", "")[0].outerHTML) + (this.model.pivotControl != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && $(this.element).parents(".e-pivotclient").length == 0 ? deferUpdate : "") + ($(this.element).parents(".e-pivotclient").length > 0 ? "" : ej.buildTag("div.schemaNoClick", "")[0].outerHTML);
                }
                $(htmlTag).appendTo("#" + this._id);
                if (this.element.parents(".e-pivotclient").length > 0 && !this._pivotClientObj.model.enableSplitter) {
                    if (this._pivotClientObj.model.isResponsive)
                        this.element.find(".fieldTable").addClass("addedFieldTable");
                    if(!this.model.enableRTL)
                    this.element.find(".fieldTable").addClass("fieldDisSplitTable");
                 }
                if (this.element.parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableSplitter) {
                    this.element.find(".fieldTable").addClass("fieldEnSplitTable");
                }
                if (this.model.enableRTL && this.element.parents(".e-pivotclient").length > 0) {
                    this.element.find(".fieldTable").addClass("clientFieldTable");
                    this.element.find(".fieldTable").addClass("rtlSplitTable");
                    if (this.element.parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableSplitter) {
                        this.element.find(".axisTable").addClass("clientAxisSplitterTable");
                    }
                                
                }
                if (this.model.pivotControl != null) {
                    if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || this.model.pivotControl.element.hasClass("e-pivotclient"))
                        this._refreshPivotButtons();
                    this._reSizeHandler();
                }
                else
                    this.element.hide();
            }
            else {
                this.element.show();
                if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                    this._refreshPivotButtons();
                }
                else {
                    this._setFilters(report.Filters);
                    this._refreshPivotButtons();
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this.element.append(ej.buildTag("div.deferUpdateLayout", ej.buildTag("input.chkDeferUpdate", "", {}).attr("type", "checkbox")[0].outerHTML + ej.buildTag("button.btnDeferUpdate", this._getLocalizedLabels("Update"), {}).attr("type", "button")[0].outerHTML)[0].outerHTML);
                    if (this.model.pivotControl != null) {
                if (this.model.enableDragDrop) {
                    this.element.find(".pivotButton .pvtBtn").ejButton({ size: "normal", type: ej.ButtonType.Button, enableRTL: this.model.enableRTL }).ejDraggable({
						handle: 'button', clone: true,
						cursorAt: { left: -5, top: -5 },
						dragStart: ej.proxy(function (args) {
							this._isDragging = true;
						}, this),
                                dragStop: ej.proxy(this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._pvtBtnDropped : this._clientOnPvtBtnDropped, this),
						helper: ej.proxy(function (event, ui) {
						    $(event.element).addClass("dragHover");
							if (event.sender.target.className.indexOf("e-btn") > -1) {
								var btnClone = $(event.sender.target).clone().attr("id",this._id+"_dragClone").appendTo('body');
								$("#"+this._id + "_dragClone").removeAttr("style").height($(event.sender.target).height());
								return btnClone;            
							}
							else
								return false;
						}, this)
					});
                        }
                    }
                }
                this._reSizeHandler();
            }
			
			if (this.model.enableDragDrop && this.model.pivotControl) {
			    this.element.find(".pivotButton .pvtBtn").ejButton({ size: "normal", type: ej.ButtonType.Button, enableRTL: this.model.enableRTL }).ejDraggable({
					handle: 'button', clone: true,
					cursorAt: { left: -5, top: -5 },
					dragStart: ej.proxy(function (args) {
						this._isDragging = true;
					}, this),
                    dragStop: ej.proxy(this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._pvtBtnDropped : this._clientOnPvtBtnDropped, this),
					helper: ej.proxy(function (event, ui) {
					    $(event.element).addClass("dragHover");
						if (event.sender.target.className.indexOf("e-btn") > -1) {
							var btnClone = $(event.sender.target).clone().attr("id",this._id+"_dragClone").appendTo('body');
                            $("#"+this._id + "_dragClone").removeAttr("style").height($(event.sender.target).height());
                            return btnClone;            
                        }
						else
							return false;
					}, this)
				});
			}
            this.element.find(".pivotButton .filterBtn").ejButton({
                size: "normal",
                enableRTL: this.model.enableRTL,
                type: ej.ButtonType.Button,
                contentType: "imageonly",
                prefixIcon: "filter"
            });
            if (this.model.pivotControl && this.model.pivotControl.model.operationalMode==ej.Pivot.OperationalMode.ClientMode && this.model.pivotControl.model.analysisMode==ej.Pivot.AnalysisMode.Olap&& this.model.layout==ej.PivotSchemaDesigner.Layouts.OneByOne) {
                var parms = { url: this.model.pivotControl.model.dataSource.data, cube: this.model.pivotControl.model.dataSource.cube, catalog: this.model.pivotControl.model.dataSource.catalog, request: "MDSCHEMA_CUBES" };
                ej.Pivot._getTreeData(parms, ej.Pivot.getCubeList, { pvtCtrldObj: this, action: "loadcubelist", hierarchy: this._selectedField });
                this.element.find(".cubeList").ejDropDownList({
                    dataSource: this.model.cubeCollection,
                    enableRTL: this.model.enableRTL,
                    fields: { text: "name", value: "name" },
                    width: "100%",
                    height:"27px",
                    change: ej.proxy(this._cubeChanged, this),
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                var ddlTarget = this.element.find('.cubeList').data("ejDropDownList");
                if (!ej.isNullOrUndefined(ddlTarget)) {
                    ddlTarget.selectItemByText(this.model.pivotControl.model.dataSource.cube);
                }
            }
            this.element.find(".pivotButton input").ejToggleButton({
                size: "normal",
                enableRTL: this.model.enableRTL,
                contentType: "imageonly",
                defaultPrefixIcon: "ascending",
                activePrefixIcon: "descending",
                click: ej.proxy(this._sortBtnClick, this)
            });

            if (this.model.pivotControl != null) {
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot || this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._createTreeView(this, this.model.pivotTableFields);
                else {
                    ej.Pivot.generateTreeViewData(this);
                }
            }
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            this._createContextMenu();
            if(this._waitingPopup) this._waitingPopup.hide();
            this._setPivotBtnWidth();
        },

        setCubeList: function (cubeCollection) {
            this.model.cubeCollection = cubeCollection;
        },

        refreshControl: function () {
            $(this._tableTreeObj.element).ejTreeView("unCheckAll");
            this._isDropAction = true;
            var dataSource = this.model.pivotControl.model.dataSource;
            for (var i = 0; i < dataSource.rows.length; i++)
                this._tableTreeObj.checkNode(this._tableTreeObj.element.find("li[tag='" + dataSource.rows[i].fieldName + "']"));
            for (var i = 0; i < dataSource.columns.length; i++)
                this._tableTreeObj.checkNode(this._tableTreeObj.element.find("li[tag='" + dataSource.columns[i].fieldName + "']"));
            for (var i = 0; i < dataSource.filters.length; i++)
                this._tableTreeObj.checkNode(this._tableTreeObj.element.find("li[tag='" + dataSource.filters[i].fieldName + "']"));
            for (var i = 0; i < dataSource.values.length; i++)
                this._tableTreeObj.checkNode(this._tableTreeObj.element.find("li[tag='" + dataSource.values[i].fieldName + "']"));
            this._isDropAction = false;
            this._refreshPivotButtons();
        },

        _cubeChanged: function (args) {
            if (this.model.pivotControl.model.dataSource.cube != args.selectedValue) {
                if (this._pivotClientObj._waitingPopup)
                    setTimeout(function () { var pivotClientObj = ($(args.target).parents(".e-pivotclient").length > 0) ? $(args.target).parents(".e-pivotclient").data("ejPivotClient") : $(this.element).parents(".e-pivotclient").data("ejPivotClient"); pivotClientObj._waitingPopup.show(); }, 0);
                this.model.pivotControl.model.dataSource.cube = args.selectedValue;
                this.model.pivotControl.model.dataSource.rows = this.model.pivotControl.model.dataSource.columns = this.model.pivotControl.model.dataSource.values = this.model.pivotControl.model.dataSource.filters = [];
              
                delete this.model.pivotControl._fieldData;
                this.element.find(".pivotButton").remove();
                this.element.find(".schemaFieldTree").empty();
                ej.Pivot.generateTreeViewData(this, this.model.pivotControl.model.dataSource);
                this._pivotClientObj.refreshControl();
            }
        },

        _setPivotBtnWidth: function () {
            if (this.model.layout != "excel" && this.model.pivotControl) {
                var mode = this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? true : false;
                var model = mode ? this._dataModel : this.model.pivotControl._dataModel
                var wid = model == "Olap" || model == "XMLA" ? 15 : 20;
                $.each(this.element.find(".schemaRow .pvtBtn,.schemaColumn .pvtBtn"), function (index, value) {
                    if ($(value).attr("aria-describedby") == "Measures") {
                        $(value).width($(value).parent().width() - wid - 10);
                    }
                    else {
                        $(value).width($(value).parent().width() - (3 * wid));
                        if (this._dataModel != "Pivot" && mode && $(".pivotButton:contains('" + $(value).text() + "'):first").find(".filtered").length > 0) {
                            $(value).parent().find(".filter").addClass("filtered");
                        }
                    }
                });
                $.each(this.element.find(".schemaValue .pvtBtn"), function (index, value) {
                    $(value).width($(value).parent().width() - wid - 10);
                });
                $.each(this.element.find(".schemaFilter .pvtBtn"), function (index, value) {
                    $(value).width($(value).parent().width() - (2 * wid) - 10);
                    if (this._dataModel != "Pivot" && mode && $(".pivotButton:contains('" + $(value).text() + "'):first").find(".filtered").length > 0) {
                        $(value).parent().find(".filter").addClass("filtered");
                    }
                });
            }
            else {
                $.each(this.element.find(".pvtBtn"), function (index, value) {
                    $(value).width($(value).parent().width() - 15);
                });
            }
        },

        _onContextOpen: function (args) {
		if (!$(args.target).hasClass("removeClientPivotBtn"))
            ej.Pivot._contextMenuOpen(args, this);
        },

        _contextClick: function (args) {
            schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!ej.isNullOrUndefined(pivotClientObj)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        schemaObj.model.pivotControl._waitingPopup.show();
                }, 800);
            }
            else
                this.model.pivotControl._waitingPopup.show();
            var droppedPosition = args.text == this._getLocalizedLabels("AddToColumn") ? this.element.find(".schemaColumn") : args.text == this._getLocalizedLabels("AddToRow") ? this.element.find(".schemaRow") : args.text == this._getLocalizedLabels("AddToValues") ? this.element.find(".schemaValue") : args.text == this._getLocalizedLabels("AddToFilter") ? this.element.find(".schemaFilter") : "";
            var params = { element: this._selectedMember, target: droppedPosition[0], cancel: false };
            if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                this._pvtBtnDropped(params);
            else
                this._clientOnPvtBtnDropped(params);
        },

        _createTreeView: function (args, dataSourceInfo) {
            this.element.find(".schemaFieldTree").ejTreeView({
                showCheckbox: this.model.layout == "onebyone" ? false : true,
                fields: { id: "id", parentId: "pid", text: (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode || this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) ? "name" : "caption", isChecked: "isSelected", spriteCssClass: "spriteCssClass", dataSource: dataSourceInfo },
                enableRTL: this.model.enableRTL,
                allowDragAndDrop: this.model.enableDragDrop ? true : false,
                allowDropChild: false,
                allowDropSibling: false,
                dragAndDropAcrossControl: true,
                beforeDelete: function () {
                    return false;
                },
                cssClass: 'pivotTreeViewDragedNode',
                nodeDropped: ej.proxy(this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._nodeDropped : this._clientOnNodeDropped, this),
                nodeDragStart: ej.proxy(this._nodeDrag, this),
                nodeDrag: ej.proxy(this._nodeDraged, this)
            });
            var treeViewElements = [], isMon = this.model.pivotControl.model.dataSource.providerName == ej.olap.Providers.Mondrian;
            this._tableTreeObj = this.element.find(".schemaFieldTree").data("ejTreeView");
            this._tableTreeObj.element.find(".e-ul").css({"width":"100%","height":"100%"});
            this._tableTreeObj.element.find(".measureGroupCDB").parent().siblings(".e-chkbox-wrap").remove();
            this._tableTreeObj.element.find(".folderCDB").parent().siblings(".e-chkbox-wrap").remove();
            this._tableTreeObj.element.find(".dimensionCDB").parent().siblings(".e-chkbox-wrap").remove();
            if (this.model.layout != ej.PivotSchemaDesigner.Layouts.OneByOne) {
                if (this._tableTreeObj.element.find(".measureGroupCDB").parents("li").length == 0)
                    this._tableTreeObj.element.find("#\\[Measures\\]").append(ej.buildTag("span.elementSeparator")[0].outerHTML);
                else
                    this._tableTreeObj.element.find(".measureGroupCDB").parents("li").append(ej.buildTag("span.elementSeparator")[0].outerHTML);
            this._tableTreeObj.element.find(".dimensionCDB").parents("li").append(ej.buildTag("span.elementSeparator")[0].outerHTML);
			}
			if (this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne) {
			    treeViewElements = this._tableTreeObj.element;
			    $.map(dataSourceInfo, function (obj, index) { if (obj["defaultHierarchy"]) $(treeViewElements).find("li[id='" + obj.tag + "']").attr("defaultHierarchy", obj["defaultHierarchy"]); });
			}
			treeViewElements = this._tableTreeObj.element.find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                var tagValue = this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? (isMon ? $(treeViewElements[i]).attr("id").split("~#^")[0] : $(treeViewElements[i]).attr("id")) : this.model.pivotTableFields[i].tag;
                treeViewElements[i].setAttribute("tag", tagValue);
                var checkedBoxNode = $(treeViewElements[i]).find(".e-chkbox-wrap");
                if ($(checkedBoxNode[0]).attr("aria-checked") == "true" && $($(treeViewElements[i])).find(".folderCDB").length <= 0 && $(treeViewElements[i]).attr("tag").toLowerCase().indexOf("[measures]") == -1) {
                    if (this.model.pivotControl._dataModel == "XMLA") {
                        if ($(treeViewElements[i]).parents("li:eq(0)").length>0 && $(treeViewElements[i]).parents("li:eq(0)").attr("tag").toLowerCase().indexOf("[measures]") == -1) {
                            var currentItem = (ej.Pivot.getReportItemByFieldName(($(treeViewElements[i]).attr("tag")), this.model.pivotControl.model.dataSource, this._dataModel)).item;
                            if (!ej.isNullOrUndefined(currentItem) > 0 && (currentItem["isNamedSets"] == undefined || !currentItem["isNamedSets"])) {
                                var dropSpan = ej.buildTag("span.e-icon").css("display", "inline-block").addClass("treeDrop").attr("role","button").attr("aria-label","filter button")[0].outerHTML;
                                $($(treeViewElements[i]).find(".e-text")[0]).after(dropSpan);
                            }
                        }
                    }
                    else {
                        var dropSpan = ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML;
                        $($(treeViewElements[i]).find(".e-text")[0]).after(dropSpan);
                    }
                }
            }
            if (this.model.pivotControl != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                this._tableTreeObj.model.nodeCheck = ej.proxy(this._clientPivotCheckedStateModified, this);
                this._tableTreeObj.model.nodeUncheck = ej.proxy(this._clientPivotCheckedStateModified, this);
            }
            else {
                this._tableTreeObj.model.nodeCheck = ej.proxy(this._checkedStateModified, this);
                this._tableTreeObj.model.nodeUncheck = ej.proxy(this._checkedStateModified, this);
            }
            this._tableTreeObj.element.find(".attributeCDB").parent().siblings("ul").remove();
            this._tableTreeObj.element.find(".attributeCDB").closest('div').find('.e-plus').remove();
            this._tableTreeObj.element.find(".hierarchyCDB").parent().parent().siblings("ul").find(".e-chkbox-wrap").remove();
            if (this._tableTreeObj.element.find(".e-plus").length == 0) {
                this._tableTreeObj.element.find(".e-item").css("padding", "0px");
            }
            this.element.find(".schemaFilter, .schemaColumn, .schemaRow, .schemaValue").ejDroppable({
            });
            if (this.model.pivotControl != null) {
                var contextTag = ej.buildTag("ul.pivotTreeContext#pivotTreeContext", ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToFilter"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToRow"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToColumn"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToValues"))[0].outerHTML)[0].outerHTML)[0].outerHTML;
                $(this.element).append(contextTag);
                $("#pivotTreeContext").ejMenu({
                    menuType: ej.MenuType.ContextMenu,
                    openOnClick: false,
                    enableRTL: this.model.enableRTL,
                    contextMenuTarget: this._tableTreeObj.element,
                    click: ej.proxy(this._treeContextClick, this),
                    beforeOpen: ej.proxy(this._contextOpen, this),
                    close: ej.proxy(ej.Pivot.closePreventPanel, this)
                });
            }
            
            if (this.model.pivotControl != null) {
                var deferCheck = false;
                if (this.model.pivotControl.model.enableDeferUpdate)
                    deferCheck = true;
                this.element.find(".btnDeferUpdate").ejButton({
                    size: "mini",
                    type: ej.ButtonType.Button,
                    enabled: deferCheck,
                    click: ej.proxy(this.model.pivotControl._deferUpdate, this.model.pivotControl)
                });
                this.element.find(".chkDeferUpdate").ejCheckBox({
                    text: this._getLocalizedLabels("DeferLayoutUpdate"),
                    change: this._checkedChange,
                    size: "normal",
                    checked: deferCheck
                });
            }
            this._waitingPopup.hide();
            this._unWireEvents();
            this._wireEvents();
        },
        _nodeDraged: function (args) {
            if (this._trigger("dragMove", args))
                return;
        },
        _setFirst: true,

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "OlapReport": this.setOlapReport(options[key]); break;
                    case "locale": this._load(); break;
                    case "locale": case "enableRTL": $(this.element).html(""); this._load(); break;
                }
            }
        },

        _wireEvents: function () {
            this._on($(document), 'keydown', this._keyDownPress);
            this._on($(document), 'keyup', ej.proxy(function(e){
                if (e.keyCode === 93)
                    e.preventDefault();
            }));
            if (this.model.layout != "excel" && this.model.layout != ej.PivotSchemaDesigner.Layouts.OneByOne) {
                this._on(this.element, "mouseover", ".pivotButton .pvtBtnDiv", ej.proxy(function (evt) {
                    if (!this._isDragging)
                        $(evt.target).find("button").removeClass("e-hoverBtn").addClass("e-hoverBtn");
                }, this));
                this._on(this.element, "mouseleave", ".pivotButton .pvtBtnDiv", ej.proxy(function (evt) {
                        $(evt.target).find("button").length > 0 ? $(evt.target).find("button").removeClass("e-hoverBtn") : $(evt.target).removeClass("e-hoverBtn");
                }, this));
                this._on(this.element, "mouseover", ".filter,.sorting,.removeBtn", ej.proxy(function (evt) {
                    if (!this._isDragging)
                        $(evt.target.parentElement).find("button").removeClass("e-hoverBtn").addClass("e-hoverBtn");
                }, this));
                this._on(this.element, "mouseleave", ".filter,.sorting,.removeBtn", ej.proxy(function (evt) {
                    $(evt.target.parentElement).find("button").removeClass("e-hoverBtn");
                }, this));
            }
            this._on(this.element, "mouseover", ".pvtBtnDiv .pvtBtn", ej.proxy(function (evt) {
                    if (this._isDragging) {
                        this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
                        $(evt.target).parent().siblings(".dropIndicator").addClass("dropIndicatorHover");
                    }
            }, this));
            this._on(this.element, "click", "#preventDiv", ej.proxy(function (evt) {
                if (this.element.find(".e-dialog.advancedFilterDlg:visible").length > 0) {
                    this.element.find(".e-dialog.advancedFilterDlg").hide();
                    this.element.find("#preventDiv").remove();
                }
            }, this));

            this._on(this.element, "mouseleave", ".pivotButton", ej.proxy(function (evt) { if (this._isDragging) $(evt.target).siblings(".dropIndicator").removeClass("dropIndicatorHover"); }, this));
            this._on(this.element, "mouseover", ".pivotButton", ej.proxy(function (evt) { $(evt.target).attr("title", evt.target.textContent);}, this));
            this._tableTreeObj.element.find("li").mouseover(ej.proxy(function (evt) {
                var margin;
                if ($(evt.target).siblings("span.e-icon.filter:eq(0)").length > 0 || $(evt.target).find("span.e-icon.filter:eq(0)").length > 0 || $(evt.target).parentsUntil("li").find("span.e-icon.filter:eq(0)").length > 0) {
                    margin = "-31px";
                    this.element.find("span.e-icon.filter").attr("role","button").attr("aria-label","filtered");
                }
                else {
                    margin = "-20px";
                    this.element.find("span.e-icon.treeDrop").attr("role", "button").attr("aria-label", "filter button");
                }
                var left = ($(evt.target).siblings("span.e-icon.filter:eq(0)").length > 0 || $(evt.target).find("span.e-icon.filter:eq(0)").length > 0 || $(evt.target).parentsUntil("li").find("span.e-icon.filter:eq(0)").length > 0) ? 10 : 5;
                if (this.model.enableRTL) {
                   if (this.model.pivotControl.model.analysisMode != ej.Pivot.AnalysisMode.Pivot)
                        $(evt.target).siblings("span.e-icon.treeDrop:eq(0)").length > 0 ? $(evt.target).siblings("span.e-icon.treeDrop:eq(0)").css({ display: "inline-block", "position": "absolute", "top": ($(evt.target).hasClass("filter") ? $(evt.target).position().top - 22 : $(evt.target).position().top + 2), "left": ($(evt.target).hasClass("filter") ? ($(evt.target).position().left + (6 - left)) : (($(evt.target).attr("role") == "" ? $(evt.target).position().left : -2) + (5 - left))) }) : $(evt.target).find("span.e-icon.treeDrop:eq(0)").length > 0 ? $(evt.target).find("span.e-icon.treeDrop:eq(0)").css({ "display": "inline-block", "position": "absolute" }) : $(evt.target).parentsUntil("li").find("span.e-icon.treeDrop:eq(0)").css({ "display": "inline-block", "position": "absolute" });
                    else
                        $(evt.target).siblings("span.e-icon.treeDrop:eq(0)").length > 0 ? $(evt.target).siblings("span.e-icon.treeDrop:eq(0)").css({ display: "inline-block", "position": "absolute", "top": ($(evt.target).hasClass("filter") ? $(evt.target).position().top - 22 : $(evt.target).position().top + 2), "left": ($(evt.target).hasClass("filter") ? $(evt.target).position().left + (7 - left) : $(evt.target).position().left + (10 - left)) }) : $(evt.target).find("span.e-icon.treeDrop:eq(0)").length > 0 ? $(evt.target).find("span.e-icon.treeDrop:eq(0)").css({ "display": "inline-block", "position": "absolute" }) : $(evt.target).parentsUntil("li").find("span.e-icon.treeDrop:eq(0)").css({ "display": "inline-block", "position": "absolute" });
                }
                else
                    $(evt.target).siblings("span.e-icon.treeDrop:eq(0)").length > 0 ? $(evt.target).siblings("span.e-icon.treeDrop:eq(0)").css({ display: "inline-block", "position": "static", "margin-left": margin}) : $(evt.target).find("span.e-icon.treeDrop:eq(0)").length > 0 ? $(evt.target).find("span.e-icon.treeDrop:eq(0)").css({ "display": "inline-block", "position": "static" }) : $(evt.target).parentsUntil("li").find("span.e-icon.treeDrop:eq(0)").css({ "display": "inline-block", "position": "static" });
                if ($(evt.target).parent().find(".measureGroupCDB, .folderCDB",(this.model.layout==ej.PivotSchemaDesigner.Layouts.OneByOne?"":".dimensionCDB") ).length > 0)
                    $(evt.target).css("cursor", "default");
            }, this))
          .mouseout(ej.proxy(function (evt) {
              $(this._tableTreeObj.element).find("span.e-icon.treeDrop").css({ display: "none" });
          }, this));
            this._on(this.element, "click", ".filterBtn,.filter", ej.proxy(this._filterBtnClickCommon, this));
            this._on(this.element, "click", ".sorting", ej.proxy(this._sortBtnClick, this));
            this._on(this.element, "click", ".removeBtn", ej.proxy(this._removePvtBtn, this));
            this._on(this.element, "click", ".pvtBtn", ej.proxy(this._filterBtnClickCommon, this));

            this._on(this._tableTreeObj.element, "click", ".treeDrop", ej.proxy(this._filterBtnClickCommon, this));

            this._on(this.element, "click", ".removeClientPivotBtn", ej.proxy(this._removeBtnClick, this));
            this._on(this.element, "click", ".removePivotBtn", ej.proxy(this._removeBtnClick, this));

            this._on(this.element, "click", ".ascOrder, .descOrder", ej.proxy(this._sortField, this));
            this._on(this.element, "click", ".collapseSchema", ej.proxy(this._hideSchemaDesigner, this));
            this._on(this.element, "click", ".expandSchema", ej.proxy(this._showSchemaDesigner, this));
            this._on(this.element, "click", ".nextPage, .prevPage, .firstPage, .lastPage", ej.proxy(this._navigateTreeData, this));
            this._on(this.element, "click", ".searchEditorTree", ej.proxy(function (evt) {
                ej.Pivot._searchEditorTreeNodes(evt, this);
            }, this));
            $(window).on('resize', $.proxy(this._reSizeHandler, this));
        },
        
        _navigateTreeData: function (args) {
                ej.Pivot.editorTreeNavigatee(args, this);
        },
        _filterBtnClickCommon: function (args) {
            if(($(args.target).hasClass("pvtBtn") && (this.element.parents(".e-pivotclient").length > 0)) || $(args.target).hasClass("treeDrop") || $(args.target).hasClass("filter")){
                if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                    this._clientOnFilterBtnClick(args);
                else {
                    if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && !ej.isNullOrUndefined($(args.target.nextElementSibling)))
                        if ($(args.target.nextElementSibling).hasClass("treeDrop"))
                            return false;
                        else
                            this._filterBtnClick(args);
                    else
                        this._filterBtnClick(args);
                }
			}
        },

        _unWireEvents: function () {
            this._off(this.element, "click", ".filterBtn, .ascOrder, .descOrder");
            this._off($(document), 'keydown', this._keyDownPress);
            this._off($(document), 'keyup');
            this._off(this.element, "click", "#preventDiv");
            this._off(this.element, "mouseover", ".pivotButton");
            this._off(this.element, "mouseover", ".pivotButton .pvtBtn");
            this._off(this.element, "mouseleave", ".pivotButton");
            this._off(this.element, "click", ".sorting");
            this._off(this.element, "click", ".filter");
            this._off(this.element, "click", ".removeBtn,.removeClientPivotBtn");
            this._off(this.element, "mouseover", ".schemaFieldTree li");
            this._off(this.element, "mouseout", ".schemaFieldTree li");
            this._off(this._tableTreeObj.element, "click", ".treeDrop");
            this._off(this.element, "click", ".ascOrder, .descOrder", ej.proxy(this._sortField, this));
            this._off(this.element, "click", ".filterBtn");
            this._off(this.element, "click", ".pvtBtn")
            this._off(this._tableTreeObj.element, "click", ".treeDrop");
            this._off(this._tableTreeObj.element, "click", "li");
            this._off(this.element, "click", ".removeClientPivotBtn, .removePivotBtn");
            $(window).off('resize', $.proxy(this._reSizeHandler, this));
            this._off(this.element, "click", ".nextPage, .prevPage, .firstPage, .lastPage");
            this._off(this.element, "click", ".searchEditorTree");
        },
        _keyDownPress: function (e) {           
            if ((e.keyCode === 40 || e.which === 38) && ((!ej.isNullOrUndefined(this.model.pivotControl._curFocus.tab) && this.model.pivotControl._curFocus.tab.hasClass("e-text")) || $("#" + this._id).find(".schemaFieldList .e-text:visible").hasClass("hoverCell")) && !$(".editorTreeView:visible").length > 0 && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0) {
                $("#" + this._id).find(".hoverCell").removeClass("hoverCell");
                this.model.pivotControl._curFocus.tab.mouseleave();
                e.preventDefault();
                var td = $("#" + this._id).find(".schemaFieldTree .e-text:visible");
                if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                    this._curFocus.tree.attr("tabindex", "0").removeClass("hoverCell").mouseleave();
                    if (e.which === 40) {
                        this._index.tree = this._index.tree + 1 > td.length - 1 ? 0 : this._index.tree + 1;
                    }
                    else if (e.which === 38) {
                        this._index.tree = this._index.tree - 1 < 0 ? td.length - 1 : this._index.tree - 1;
                    }
                    this._curFocus.tree = td.eq(this._index.tree).attr("tabindex", "-1");
                }
                else {
                    this._index.tree = e.which == 40 ? 1 : e.which == 38 ? td.length - 1 : 0;
                    this._curFocus.tree = td.eq(this._index.tree).attr("tabindex", "-1");
                }
                this._curFocus.tree.focus().addClass("hoverCell").mouseover();
                $(".e-node-focus").removeClass("e-node-focus");
            }
            else if ((e.which === 40 || e.which === 38 || e.which === 37 || e.which === 39) && !ej.isNullOrUndefined(this.model.pivotControl._curFocus.tab) && this.model.pivotControl._curFocus.tab.hasClass("pvtBtn") && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0 && document.activeElement.className.startsWith("pvtBtn")) {
                e.preventDefault();
                $("#" + this._id).find(".hoverCell").removeClass("hoverCell");
                if (!ej.isNullOrUndefined(this.model.pivotControl._curFocus.tab)) {
                    this.model.pivotControl._curFocus.tab.mouseleave().attr("tabindex", "0").removeClass("hoverCell");
                }
                var td = $("#" + this._id).find(".pvtBtn")
                if (!ej.isNullOrUndefined(this._curFocus.button)) {
                    this._curFocus.button.attr("tabindex", "0").removeClass("hoverCell").mouseleave();
                    if (e.which === 40 || e.which === 39) {
                        this._index.button = this._index.button + 1 > td.length - 1 ? 0 : this._index.button + 1;
                    }
                    else if (e.which === 38 || e.which === 37) {
                        this._index.button = this._index.button - 1 < 0 ? td.length - 1 : this._index.button - 1;
                    }
                    this._curFocus.button = td.eq(this._index.button);
                }
                else {
                    if (e.which === 40 || e.which === 39) {
                        this._curFocus.button = td.eq(1).attr("tabindex", "-1");
                    }
                    else if (e.which === 38 || e.which === 37) {
                        this._curFocus.button = td.eq(td.length - 1).attr("tabindex", "-1");
                    }
                }
                this._curFocus.button.addClass("hoverCell").mouseover().focus();
            }
            else if ((e.keyCode === 40 || e.which === 38) && $("#" + this._id).find(".editorTreeView:visible").length > 0 && !ej.isNullOrUndefined($("#" + this._id).find(".e-dialog .e-text")) && $(".e-dialog .e-text").hasClass("hoverCell")) {
                $("#" + this._id).find(".editorTreeView .hoverCell").removeClass("hoverCell");
                e.preventDefault();
                var td = $("#" + this._id).find(".e-dialog .e-text:visible");
                if (!ej.isNullOrUndefined(this._curFocus.node)) {
                    this._curFocus.node.attr("tabindex", "0").removeClass("hoverCell");
                    if (e.which === 40) {
                        this._index.node = this._index.node + 1 > td.length - 1 ? 0 : this._index.node + 1;
                    }
                    else if (e.which === 38) {
                        this._index.node = this._index.node - 1 < 0 ? td.length - 1 : this._index.node - 1;
                    }
                    this._curFocus.node = td.eq(this._index.node).attr("tabindex", "-1");
                }
                else {
                    this._index.node = e.which == 40 ? 1 : e.which == 38 ? td.length - 1 : 0;
                    this._curFocus.node = td.eq(this._index.node).attr("tabindex", "-1");             
                }
                this._curFocus.node.focus().addClass("hoverCell");
                $(".e-node-focus").removeClass("e-node-focus");
            }
            if ((e.which === 39 || e.which === 37) && ($("#" + this._id).find(".schemaFieldTree .e-text:visible").hasClass("hoverCell")) && !$(".editorTreeView:visible").length > 0) {
                    $("#" + this._id).find(".schemaFieldTree .hoverCell").parent().find(".e-plus,.e-minus").click();
            }
            else if ((e.which === 39 || e.which === 37) && ($("#" + this._id).find(".editorTreeView .e-text:visible").hasClass("hoverCell"))) {
                $("#" + this._id).find(".editorTreeView .hoverCell").parent().find(".e-plus,.e-minus").click();
            }
            else if (e.which === 9 && $("#" + this._id).find(".editorTreeView:visible").length > 0) {
                e.preventDefault();
                $("#" + this._id).find(".e-dialog .hoverCell").removeClass("hoverCell");
                this._curFocus.node = null;
                this._index.node = 0;
                var focEle = [];
                focEle.push($("#" + this._id).find(".e-dialog .e-text").first());
                if (!$("#" + this._id).find(".dialogOKBtn:visible").hasClass("e-disable")) {
                    focEle.push($("#" + this._id).find(".dialogOKBtn:visible"));
                }
                focEle.push($("#" + this._id).find(".dialogCancelBtn:visible"));
                focEle.push($("#" + this._id).find(".e-close:visible"));
                if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.attr("tabindex", "0").removeClass("hoverCell");
                    this._index.tab = this._index.tab + 1 > focEle.length - 1 ? 0 : this._index.tab + 1;
                    this._curFocus.tab = focEle[this._index.tab].attr("tabindex", "-1");
                }
                else {
                    this._index.tab = 1;
                    this._curFocus.tab = focEle[this._index.tab].attr("tabindex", "-1");
                }
                this._curFocus.tab.focus().addClass("hoverCell");
                e.stopImmediatePropagation();
            }
            if (e.which === 13 && $("#" + this._id).find(".hoverCell").length > 0 && !$(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0) {
                if ($("#" + this._id).find(".e-dialog:visible").length > 0) {
                    if ($(e.target).hasClass("memberCurrentPage")) {
                        ej.Pivot.editorTreeNavigatee(e, this);
                        return;
                    }
                    if ($(e.target).hasClass("searchEditorTreeView") && $(e.target).parents(".e-dialog").find(".nextPageDiv").length > 0) {
                        ej.Pivot._searchEditorTreeNodes(e, this);
                        return;
                    }
                    if ($("#" + this._id).find(".e-dialog .hoverCell").parent().find(".e-chkbox-small").length > 0) {
                        $("#" + this._id).find(".e-dialog .hoverCell").parent().find(".e-chkbox-small").click();
                    }
                    else {
                        $("#" + this._id).find(".e-dialog .hoverCell").click();
                        this._index.tab = 0;
                        if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                            this._curFocus.tree.attr("tabindex", "-1").focus().mouseover().addClass("hoverCell");
                        }
                        else if (!ej.isNullOrUndefined(this.model.pivotControl._curFocus.tab)) {
                            this.model.pivotControl._curFocus.tab.attr("tabindex", "-1").focus().mouseover().addClass("hoverCell");
                        }
                    }
                }
                else if ($("#" + this._id).find(".schemaFieldTree .hoverCell").length > 0) {
                    $("#" + this._id).find(".schemaFieldTree .hoverCell").parent().find(".e-chkbox-small").click();
                }
                else if ($(".pivotTree:visible,.pivotTreeContext:visible,.pivotTreeContextMenu:visible").length > 0) {
                    if (this._curFocus.button)
                        var tag = this._curFocus.button.parent().attr("tag");
                    this.model.pivotControl._curFocus.button = $("#" + this._id).find("[tag='" + tag + "'] button");
                    this.model.pivotControl._curFocus.button.attr("tabindex", "-1").focus().addClass("hoverCell");
                }
                if (!($(e.target).hasClass("memberCurrentPage") || ($(e.target).hasClass("searchEditorTreeView") && $(e.target).parents(".e-dialog").find(".nextPageDiv").length > 0)))
                    e.stopImmediatePropagation();
            }
            if (e.which === 70 && e.ctrlKey) {
                e.preventDefault();
                if ($("#" + this._id).find(".treeDrop").length > 0 && $("#" + this._id).find(".hoverCell").length > 0) {
                    $("#" + this._id).find(".hoverCell").parent().find(".treeDrop").click();
                }
            }
            if (e.keyCode === 93 && $("#" + this._id).find(".hoverCell").length > 0) {
                e.preventDefault();
                var position = { x: $(".hoverCell").offset().left + $(".hoverCell").outerWidth(), y: $(".hoverCell").offset().top + $(".hoverCell").outerHeight() };
                $(".hoverCell").trigger({ type: 'mouseup', which: 3, clientX: position.x, clientY: position.y, pageX: position.x, pageY: position.y });
            }
            if ((((e.which === 79 || e.which === 67) && e.ctrlKey) || e.which === 27) && $("#" + this._id).find(".hoverCell").length > 0) {
                if (e.keyCode == 79 && $("#" + this._id).find(".e-dialog").length > 0) {
                    if (e.ctrlKey) {
                        e.preventDefault();
                        $("#" + this._id).find(".dialogOKBtn:visible").click();
                    }
                }
                if (e.keyCode == 67 && $("#" + this._id).find(".e-dialog").length > 0) {
                    if (e.ctrlKey) {
                        e.preventDefault();
                        $("#" + this._id).find(".dialogCancelBtn:visible").click();
                    }
                }
                this._index.node = 0;             
                $("#" + this._id).find(".hoverCell").removeClass("hoverCell");
                if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                    this._curFocus.tree.attr("tabindex", "-1").focus().mouseover().addClass("hoverCell");
                }
                else if (!ej.isNullOrUndefined(this._curFocus.button)) {
                    this._curFocus.button.attr("tabindex", "-1").focus().mouseover().addClass("hoverCell");
                }
                else if (!ej.isNullOrUndefined(this.model.pivotControl._curFocus.tab)) {
                    this.model.pivotControl._curFocus.tab.attr("tabindex", "-1").focus().mouseover().addClass("hoverCell");
                }
            }
        },

        _getLocalizedLabels: function (property) {
            return ej.PivotSchemaDesigner.Locale[this.locale()][property] === undefined ? ej.PivotSchemaDesigner.Locale["en-US"][property] : ej.PivotSchemaDesigner.Locale[this.locale()][property];
        },

        _setTableFields: function (items) {
            if (!ej.isNullOrUndefined(items))
                this.model.pivotTableFields = items;
        },

        _setPivotRows: function (items) {
            if (!ej.isNullOrUndefined(items))
                this.model.pivotRows = items;
        },

        _setPivotColumns: function (items) {
            if (!ej.isNullOrUndefined(items))
                this.model.pivotColumns = items;
        },

        _setPivotCalculations: function (items) {
            if (!ej.isNullOrUndefined(items))
                this.model.pivotCalculations = items;
        },

        _setFilters: function (items) {
            if (!ej.isNullOrUndefined(items))
                this.model.filters = items;
        },

        _getSortedHeaders: function () {
            var labels = this.element.find(".descending").parents("label"), headers = "";
            for (var i = 0; i < labels.length; i++)
                headers += $(labels[i]).attr("for").replace("toggleBtn", "") + "##";
            return headers;
        },

        _contextOpen: function (args) {            
            if ($(args.target.parentElement).find(".measureGroupCDB").length > 0 || $(args.target.parentElement).find(".folderCDB").length > 0 || (!(this.element.parents(".e-pivotclient").length > 0) && $(args.target.parentElement).find(".dimensionCDB").length > 0) || !$(args.target).hasClass("e-text"))
                return false;
            ej.Pivot.openPreventPanel(this);
            this._selectedMember = $(args.target);
            
            if (this.model.pivotControl.model.analysisMode==ej.Pivot.AnalysisMode.Olap) {
                var menuObj = $("#pivotTreeContext").data('ejMenu');
                if ($(args.target).parents("li:eq(0)").attr("tag").toLowerCase().indexOf("[measures]") >= 0) {
                    menuObj.disableItem(this._getLocalizedLabels("AddToFilter"));
                    menuObj.disableItem(this._getLocalizedLabels("AddToRow"));
                    menuObj.disableItem(this._getLocalizedLabels("AddToColumn"));
                    menuObj.enableItem(this._getLocalizedLabels("AddToValues"));
                }
                else {
                    menuObj.disableItem(this._getLocalizedLabels("AddToValues"));
                    $(args.target.parentElement).find(".namedSetCDB").length > 0 ? menuObj.disableItem(this._getLocalizedLabels("AddToFilter")) : menuObj.enableItem(this._getLocalizedLabels("AddToFilter"));
                    menuObj.enableItem(this._getLocalizedLabels("AddToRow"));
                    menuObj.enableItem(this._getLocalizedLabels("AddToColumn"));
                }
            }
            else if (this._dataModel == "Pivot") {
                var targetText = args.target.textContent;
                if ($(args.target).hasClass("e-text") && ($(this.element).parents(".e-pivotclient").length > 0 || $.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == targetText; }).length == 0)) {
                        var menuObj = $("#pivotTreeContext").data('ejMenu');
                        menuObj.enable();
                }
                else {
                    var menuObj = $("#pivotTreeContext").data('ejMenu');
                    menuObj.disable();
                }
            }
        },

        _nodeDrag: function (args) {
            this._isDragging = true;
            if (($(args.dragTarget.parentElement).find(".measureGroupCDB").length > 0 || $(args.dragTarget.parentElement).find(".folderCDB").length > 0 || $(args.dragTarget.parentElement).find(".dimensionCDB").length > 0) && !($(args.dragTarget.parentElement).find(".dimensionCDB").length>0 && this.model.layout==ej.PivotSchemaDesigner.Layouts.OneByOne))
                return false;
        },

        _treeContextClick: function (args) {
            schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!ej.isNullOrUndefined(this._curFocus.tree))
                this._curFocus.tree.attr("tabindex", "-1").focus().addClass("hoverCell");
            else if (!ej.isNullOrUndefined(this.model.pivotControl._curFocus.tab))
                this.model.pivotControl._curFocus.tab.attr("tabindex", "-1").focus().addClass("hoverCell");
            var droppedPosition = args.text == this._getLocalizedLabels("AddToColumn") ? this.element.find(".schemaColumn") : args.text == this._getLocalizedLabels("AddToRow") ? this.element.find(".schemaRow") : args.text == this._getLocalizedLabels("AddToValues") ? this.element.find(".schemaValue") : args.text == this._getLocalizedLabels("AddToFilter") ? this.element.find(".schemaFilter") : "";
            var params = { dropTarget: droppedPosition, droppedElement: this._selectedMember.parent().parent(), target: droppedPosition };
            if (!ej.isNullOrUndefined(pivotClientObj)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        schemaObj.model.pivotControl._waitingPopup.show();
                }, 800);
            }
            else
                this.model.pivotControl._waitingPopup.show();
            this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._nodeDropped(params) : this._clientOnNodeDropped(params);
        },

        _checkedChange: function (args) {
            var pSchemaObj = $(args.event.target).parents(".e-pivotschemadesigner").data("ejPivotSchemaDesigner");
            var deferButton = $(".btnDeferUpdate").data("ejButton");
            if (args.isChecked) {
                pSchemaObj.model.pivotControl.model.enableDeferUpdate = true;
                deferButton.enable();
            }
            else {
                pSchemaObj.model.pivotControl.model.enableDeferUpdate = false;
                if (pSchemaObj.model.pivotControl._isUpdateRequired)
                    pSchemaObj.model.pivotControl._deferUpdate();
                deferButton.disable();
            }
        },

        _sortBtnClick: function (args) {
            $(args.target).toggleClass("descending");
            if (this.model.pivotControl._dataModel != "Olap" && this.model.pivotControl._dataModel != "XMLA") {
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    ej.PivotAnalysis._valueSorting = null;
                    var fieldName = $(args.target).parents(".pivotButton").attr("tag").split(":")[1];
                    var axisItems = this.model.pivotControl.model.dataSource[$(args.target).parents(".pivotButton").attr("tag").split(":")[0].toLowerCase()];
                    var items = $.grep(axisItems, function (item) { return item.fieldName == fieldName });
                    var sortOrder = args.target.className.indexOf("descending") >= 0 ? ej.PivotAnalysis.SortOrder.Descending : ej.PivotAnalysis.SortOrder.Ascending;
                    for (var i = 0; i < items.length; i++) items[i].sortOrder = sortOrder;
                    this.model.pivotControl._populatePivotGrid();
                }
                else if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    this.model.pivotControl._sortBtnClick(args);
                }
            }
        },

        _generateMembers: function (customArgs, args) {
            var data = $(args).find("Axis:eq(0) Tuple"), treeViewData = [], treeNodeInfo = {};
            treeViewData.push({ id: "All", name: "All", checkedStatus: true, tag: "" });
            for (var i = 0; i < data.length; i++) {
                var memberUqName = $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[0]).text(),
                    memberName = $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[1]).text() == "" ? "(Blank)" : $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[1]).text();
                treeNodeInfo = { hasChildren: $(data[i]).find("CHILDREN_CARDINALITY").text() != "0", checkedStatus: true, id: memberUqName.replace(/\]*\]/g, '-').replace(/\[*\[/g, '-'), name: memberName, tag: memberUqName, level: parseInt($(data[i]).find("LNum").text()) };
                treeViewData.push(treeNodeInfo);
            }
            if (!ej.isNullOrUndefined(this._waitingPopup)) {
                var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
                if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                this._waitingPopup.hide();
            }
            if (!ej.isNullOrUndefined(this.model.pivotControl) && this.model.pivotControl.model.enableMemberEditorPaging) {
                this._editorTreeData = treeViewData;
                this._editorTreeData.splice(0, 1);
                this._memberCount = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
                this.model.pivotControl._currentReportItems.push({ filterItems: this._editorTreeData, fieldName: this._selectedFieldName, dataSrc: this.model.pivotControl.model.dataSource, pageSettings: this._memberCount });
                var treeData = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.model.pivotControl.model.memberEditorPageSize));
                treeData.splice(0, 0, { id: "All", name: "All", checkedStatus: this._isAllMemberChecked, tag: "" })
                this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(treeData) });
            }
            else
                this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(treeViewData) });

        },
        _generateChildMembers: function (customArgs,args) {
            var data = $(args).find("Axis:eq(0) Tuple"), treeViewData = [];
            var pNode = this.element.find("[tag='" + customArgs.currentNode.replace(/&amp;/g, "&") + "']");
            for (var i = 0; i < data.length; i++) {
                var memberUqName = $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children().children()[0]).text();
                var memberName = $($(args).find("Axis:eq(0) Tuple:eq(" + i + ")").children()).find("Caption").text();
                var treeNodeInfo = { hasChildren: $(data[i]).find("CHILDREN_CARDINALITY").text() != "0", checkedStatus: false, id: memberUqName.replace(/\]*\]/g, '-').replace(/\[*\[/g, '-'), name: memberName, tag: memberUqName, level: $(data[i]).find("LNum").text() }
                treeViewData.push(treeNodeInfo);
            }
            if ($(pNode).parents("li").length > 1)
                parentNode = $(pNode).parents("li").first();
            else
                parentNode = $(pNode).parents("li");
            pNode.find(".e-load").removeClass("e-load");
            $($(parentNode).find('input.nodecheckbox')[0]).ejCheckBox({ checked: false })
            $.each(pNode.find("li"), function (index, value) { value.setAttribute("tag", treeViewData[index].tag); });


            this._memberTreeObj = $(".editorTreeView").data("ejTreeView");
            this._memberTreeObj.addNode(treeViewData, $(pNode));
        },

        _sortField: function (args) {
            ej.Pivot.closePreventPanel(this);
            this.element.find(".e-dialog, .clientDialog").remove();
                       
            if (($(args.element).attr("id") == "descOrder" || $(args.element).attr("id") == "ascOrder")) {
                var reportItem = ej.Pivot.getReportItemByFieldName(this._selectedFieldName, this.model.pivotControl.model.dataSource).item;
                if (!ej.isNullOrUndefined(reportItem))
                    ($(args.element).attr("id") == "descOrder") ? reportItem["sortOrder"] = ej.olap.SortOrder.Descending : reportItem["sortOrder"] = ej.olap.SortOrder.Ascending;

                if (this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                    this.model.pivotControl.refreshControl();
                else {
                    ej.olap.base._clearDrilledCellSet();
                    ej.olap.base.getJSONData({ action: "sorting" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                }
            }
        },

        _clientOnFilterBtnClick: function (args) {
            ej.Pivot.openPreventPanel(this);
            var schemaObj = this;
            this._isAllMemberChecked = true;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!ej.isNullOrUndefined(pivotClientObj)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        schemaObj._waitingPopup.show();
                }, 800);
            }
            else
                this._waitingPopup.show();
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if ($(args.target).parents().hasClass("pivotButton") && $(args.target).parents(".pivotButton").attr("tag").indexOf(":[") >= 0 && !($(args.target).parents(".pivotButton").attr("tag").toLowerCase().indexOf("[measures]") >= 0)) {
                    this._selectedFieldName = $(args.target).parents(".pivotButton").attr("tag").split(":")[1];
                }
                else if ($(args.target).parents().attr("tag") != null && ($(args.target).parents().attr("tag").split(":")[1] == "Measures" || $(args.target).parent().attr("tag").toLowerCase().indexOf("[measures]") >= 0)) {
                    ej.Pivot.closePreventPanel(this);
                    if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                    return false;
                }
                else {
                    this._selectedLevel = $($(args.target).parents("li:eq(0)")).attr("tag");
                    this._selectedFieldName = ($(args.target).parents("li:eq(0)").children("div:eq(0)").find(".levels").length > 0) ? $($(args.target).parents("li:eq(1)")).attr("tag") : $($(args.target).parents("li:eq(0)")).attr("tag");
                }
               
                if (ej.isNullOrUndefined(this._selectedFieldName) || this._selectedFieldName.toLocaleLowerCase().indexOf("measures") >= 0)
                    return false;
                
                var hierarchyName = this._selectedFieldName, currentDataSrc = this.model.pivotControl.model.dataSource, pageSettings;
                var filteredData= $.map(this.model.pivotControl._currentReportItems, function (obj, index) {
                    if (obj["fieldName"] == hierarchyName && (ej.isNullOrUndefined(obj.dataSrc) || (obj.dataSrc.cube == currentDataSrc.cube && obj.dataSrc.reportName == currentDataSrc.reportName))) {
                        pageSettings = obj.pageSettings;
                        return obj.filterItems;
                    }
                });

                if (this.model.pivotControl.model.enableMemberEditorPaging) {
                    if (pageSettings)
                        this._memberCount = pageSettings;
                    this._memberPageSettings.endPage = this.model.pivotControl.model.memberEditorPageSize;
                    this._memberPageSettings.startPage = 0;
                    this._memberPageSettings.currentMemeberPage = 1;
                }
                if (filteredData.length > 0) {
                    if (this.model.pivotControl.model.enableMemberEditorPaging) {
                        this._editorTreeData = filteredData;
                        this._memberCount = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
                        filteredData = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.model.pivotControl.model.memberEditorPageSize));;
                        filteredData.splice(0, 0, { id: "All", name: "All", checkedStatus: this._isAllMemberChecked, tag: "" })
                    }
                    this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(filteredData) });
                }
                else
                    ej.olap._mdxParser.getMembers(this.model.pivotControl.model.dataSource, this._selectedFieldName, this);
            }
            else {
                if ($(args.target).parent().hasClass("pivotButton") && $(args.target).parent().attr("tag").indexOf(":") >= 0) 
                    this._selectedFieldName = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.target).parent().attr("tag").split(":")[1]; })[0].name;
                else
                    this._selectedFieldName = $.grep(this.model.pivotTableFields, function (item) { return item.id == $($(args.target).closest("li")).attr("id"); })[0].name;
            }
            var pivotBtn= $(this.element.find(".pivotButton button[fieldname='" + this._selectedFieldName + "']"));
            this._dialogHead = this._selectedFieldCaption = pivotBtn.attr("fieldCaption");
            this._selectedFieldAxis = pivotBtn.parents().hasClass("schemaRow") ? "rows" : pivotBtn.parents().hasClass("schemaColumn") ? "columns" : pivotBtn.parents().hasClass("schemaValue") ? "values" : "filters";

            if ((this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)) {
                if (this.model.pivotControl.model.enableMemberEditorPaging) {
                    this._memberPageSettings.endPage = this.model.pivotControl.model.memberEditorPageSize;
                    this._memberPageSettings.startPage = 0;
                    this._memberPageSettings.currentMemeberPage = 1;
                    var filteredData = this._getTreeViewData();
                    filteredData.splice(0, 1);
                    this._editorTreeData = filteredData;
                    this._memberCount = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined)).length;
                    filteredData = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.model.pivotControl.model.memberEditorPageSize));;
                    filteredData.splice(0, 0, { id: "All", name: "All", checkedStatus: this._isAllMemberChecked, tag: "" })
                    this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(filteredData) });
                }
                else
                    this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(this._getTreeViewData()) });
            }
        },

        _getTreeViewData: function () {
            var axisItems = this.model.pivotControl.model.dataSource[this._selectedFieldAxis];
            var fieldName = this._selectedFieldName;
            var item = $.grep(axisItems, function (item) { return item.fieldName == fieldName; })[0];
            var members = ej.PivotAnalysis.getMembers(fieldName);
            var treeViewData = [{ id: "All", name: "All", checkedStatus: true }];
            if (item.filterItems != null && item.filterItems != undefined)
                for (var i = 0; i < members.length; i++) treeViewData.push({ id: members[i], name: members[i], checkedStatus: item.filterItems.filterType == ej.PivotAnalysis.FilterType.Include ? $.inArray(members[i].toString(), item.filterItems.values) >= 0 : $.inArray(members[i].toString(), item.filterItems.values) < 0 });
            else
                for (var i = 0; i < members.length; i++) treeViewData.push({ id: members[i], name: members[i], checkedStatus: true });
            return treeViewData;
        },
        _filterBtnClick: function (args) {
            this.model.pivotControl._editorFlag = false;
            this._isAllMemberChecked = true;
            ej.Pivot.openPreventPanel(this);
            var schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                var fieldName, fieldCaption;
                if (this.model.pivotControl._dataModel == "XMLA") {
                    if ($(args.target).parents("li:eq(0)").length > 0) {
                        this._selectedLevel = $($(args.target).parents("li:eq(0)")).attr("tag");
                        fieldName = ($(args.target).parents("li:eq(0)").children("div:eq(0)").find(".levels").length > 0) ? $($(args.target).parents("li:eq(1)")).attr("tag") : $($(args.target).parents("li:eq(0)")).attr("tag");
                    }
                    else {
                        this._selectedLevel = $(args.target).parent().attr("tag").split(":")[1];
                        fieldName = $(args.target).parent().attr("tag").split(":")[1];
                    }
                }
                else
                    fieldName = $.grep(this.model.pivotTableFields, function (item) { return item.caption == $($(args.target).parent()).text(); })[0].name;
                for (var i = 0; i < this.element.find(".pivotButton").length; i++) {
                    uniqueName = $(this.element.find(".pivotButton")[i]).find("button").attr("fieldName");
                    if (uniqueName == fieldName) {
                        fieldCaption = $(this.element.find(".pivotButton")[i]).find("button").text();
                        this._selectedAxis = $(this.element.find(".pivotButton")[i]).parent()[0].className.split(" ")[0];
                        break;
                    }

                }
                this._selectedAxis = this.model.pivotControl._selectedAxis = this._selectedAxis == "schemaRow" ? "rows" : this._selectedAxis == "schemaColumn" ? "columns" : this._selectedAxis == "schemaValue" ? "values" : "filters";
                this._dialogTitle = this.model.pivotControl._dialogTitle = fieldCaption;
                this._dialogHead = this.model.pivotControl._dialogHead = fieldCaption;
                this._selectedMember = this.model.pivotControl._selectedField = fieldName;

                if (this.model.pivotControl._dataModel == "XMLA") {
                    if ($(args.target).parents("li:eq(0)").length > 0) {
                        var currentHierarchy = $(args.currentTarget).parents("li:eq(0)").attr("tag");//this._selectedMember = $(args.currentTarget.parentNode).attr("tag").split(":")[1];
                    }
                    else {
                        var currentHierarchy = $(args.target).parent().attr("tag").split(":")[1];
                    }
                    var filteredData = $.map(this.model.pivotControl._currentReportItems, function (obj, index) { if (obj["fieldName"] == currentHierarchy) return obj["filterItems"]; });
                    if (filteredData.length > 0)
                        this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(filteredData) });
                    else {
                        //if (!ej.isNullOrUndefined(this._waitingPopup))
                        //    this._waitingPopup.show();
                        this._selectedMember = fieldName;
                        //var reportItem = this.model.pivotControl.getReportItemByFieldName(fieldName), conStr;
                        //parsedMDX = "select {" + ((reportItem.item.length > 0 && reportItem["item"][0]["hasAllMember"]) ? fieldName + ".levels(0).members" : fieldName + ".children") + "} dimension properties CHILDREN_CARDINALITY on 0 from [" + $.trim(this.model.pivotControl.model.dataSource.cube) + "]";
                        //conStr = this.model.pivotControl._getConnectionInfo(this.model.pivotControl.model.dataSource.data);
                        //pData = "<Envelope xmlns=\"http://schemas.xmlsoap.org/soap/envelope/\"> <Header></Header> <Body> <Execute xmlns=\"urn:schemas-microsoft-com:xml-analysis\"> <Command> <Statement> " + parsedMDX + " </Statement> </Command> <Properties> <PropertyList> <Catalog>" + this.model.pivotControl.model.dataSource.catalog + "</Catalog> <LocaleIdentifier>"+conStr.LCID+"</LocaleIdentifier></PropertyList> </Properties> </Execute> </Body> </Envelope>";
                        //this.doAjaxPost("POST", conStr.url, { XMLA: pData }, this._generateMembers, null, { action: "fetchMembers" });
                    }
                }
                else {
                    var treeViewData = this.model.pivotControl._getTreeViewData(fieldName, fieldCaption, this._selectedAxis);
                    this._fetchMemberSuccess({ EditorTreeInfo: JSON.stringify(treeViewData) });
                }
            }
            else {
                $(this._tableTreeObj.element).find("span.e-icon.treeDrop").css({ display: "none" });
                var hierarClass, selectedNd;
                if (this._dataModel == "Olap") {
                    if ($(args.target).attr("class").indexOf("filter") > -1) {
                        for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                            if ((this.model.pivotTableFields[i].tag.replace(/\[/g, "").replace(/\]/g, "").indexOf("Measures") > -1 && this.model.pivotTableFields[i].isSelected == true) || (this.model.pivotTableFields[i].isSelected == true && $(args.target.parentElement).attr("tag").split(":")[1] == this.model.pivotTableFields[i].tag.replace(/\[/g, "").replace(/\]/g, "")))
                                hierarClass = this.model.pivotTableFields[i].spriteCssClass;
                        }
                        for (var f = 0; f < this._tableTreeObj.element.find("li").length; f++) {
                            if ($($(args.target).parent()).attr("tag").split(":")[1] == $(this._tableTreeObj.element.find("li")[f]).attr("tag").replace(/\]/g, '').replace(/\[/g, ''))
                                selectedNd = $(this._tableTreeObj.element.find("li")[f]);
                        }
                    }
                    else
                        hierarClass = $(args.target).parent().find("a>span").attr("class");
                    if (!($(args.target).attr("class").indexOf("filter") > -1)) {
                        if (hierarClass.indexOf("hierarchyCDB") > -1 || hierarClass.indexOf("attributeCDB") > -1) {
                            selectedNd = $(args.target).parents("li")[0];
                        }
                        else {
                            selectedNd = $(args.target).parents("li")[1];
                        }
                    }
                }
                else
                    if (!($(args.target).attr("class").indexOf("filter") > -1))
                        selectedNd = $($(args.target).parent()).parent();
                    else
                        selectedNd = this._tableTreeObj.element.find("li:contains('" + $($(args.target).parent()).attr("tag").split(":")[1] + "')");
                this._selectedTreeNode = selectedNd;
                if (args.target.tagName.toLowerCase() == "span" || args.target.tagName.toLowerCase() == "button") {
                    this.model.layout != "excel" && $(args.target).attr("class").indexOf("filter") > -1 ? this._curFilteredText = $($(args.target).parents(".pivotButton")).attr("tag").split(":")[1].replace(/\]/g, '').replace(/\[/g, '') : this._curFilteredText = this._dataModel == "Olap" ? $(selectedNd).attr("tag").replace(/\]/g, '').replace(/\[/g, '') : $(selectedNd).attr("id"); 
                    if ($(this.element).parents(".e-pivotclient").length > 0) this._curFilteredText = $($(args.target).parents(".pivotButton")).attr("tag").split(":")[1].replace(/\]/g, '').replace(/\[/g, '');
                    if ($(args.target).parents("li:eq(1)").find("div:first>a>span").hasClass("hierarchyCDB")) {
                        this._curFilteredText = $(args.target).parents("li:eq(1)").find("div:first>a").text();
                    }
                    if (this._dataModel == "Pivot") {
                        // this._curFilteredAxis = !ej.isNullOrUndefined(this.element.find(".e-btn[fieldName='" + this._curFilteredText + "']").parents(".e-droppable")[0]) ? this.element.find(".e-btn[fieldName='" + this._curFilteredText + "']").parents(".e-droppable")[0].className.split(" ")[0] : "";
                        if ($(this.element).parents(".e-pivotclient").length > 0) {
                            this._curFilteredAxis = $(selectedNd)[0].className.split(" ")[0];
                            this.model.pivotControl._curFilteredText = this._curFilteredText;
                        }
                        else
                            this._curFilteredAxis = !ej.isNullOrUndefined(this.element.find(".e-btn:contains('" + ($(this.element).parents(".e-pivotclient").length > 0 ? $(selectedNd).text() : $(selectedNd).find("div:first").text()) + "')").parents(".e-droppable")[0]) ? this.element.find(".e-btn:contains('" + $(selectedNd).find("div:first").text() + "')").parents(".e-droppable")[0].className.split(" ")[0] : "";
                        this._dialogHead = $(args.target).attr("fieldcaption") || this._curFilteredText;
                    }
                    this._dialogTitle = this._dataModel == "Olap" ? $(this.element.find(".pivotButton:contains('" + $(selectedNd).find("div:first").text() + "')")[0]).attr("tag") : $(args.target).parents("li").length > 0 ? $(args.target).parents("li").attr("id") || args.target.id.replace("filterBtn", "") || $(args.target).parents(".filterBtn")[0].id.replace("filterBtn", "") : $(args.target).parent().attr("tag").split(":")[1] || args.target.id.replace("filterBtn", "") || $(args.target).parents(".filterBtn")[0].id.replace("filterBtn", "");
                    if ($(this.element).parents(".e-pivotclient").length > 0 && $(selectedNd)[0].className.split(" ")[0] == "schemaFilter" && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                        this._dialogTitle = this._curFilteredText;
                    if (this._dataModel == "Olap")
                        for (var btnCount = 0 ; btnCount < this.element.find(".e-btn").length; btnCount++) {
                            if (!ej.isNullOrUndefined($($($(this.element.find(".e-btn"))[btnCount]).parent()[0]).attr("tag")) && $($($(this.element.find(".e-btn"))[btnCount]).parent()[0]).attr("tag").split(":")[1] == $(this._selectedTreeNode).attr("tag").replace(/\]/g, '').replace(/\[/g, '') && $($($(this.element.find(".e-btn"))[btnCount]).parent()[0]).attr("tag").indexOf(this._curFilteredText) > -1) {
                                this._curFilteredAxis = !ej.isNullOrUndefined($($(this.element.find(".e-btn"))[0]).parents(".e-droppable")[0]) ? $($(this.element.find(".e-btn"))[0]).parents(".e-droppable")[0].className.split(" ")[0] : "";
                                this._dialogTitle = $($($(this.element.find(".e-btn"))[btnCount]).parent()[0]).attr("tag");
                                this._dialogHead = $($($(this.element.find(".e-btn"))[btnCount])[0]).attr("fieldCaption");
                                break;
                            }
                        }
                    var report;
                    try {
                        report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
                    }
                    catch (err) {
                        if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                            report = this.model.pivotControl.getOlapReport();
                    }
                    var sortedHeaders = this._getSortedHeaders();
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "fetchMembers", element: this.element, customObject: this.model.pivotControl.model.customObject });                    
                    var eventArgs = JSON.stringify({ "action": "fetchMembers", "headerTag": (this._dialogTitle + ((this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) && this.model.pivotControl.model.enableAdvancedFilter ? "##true" : "")) || "UniqueName##" + $(selectedNd).attr("tag"), "sortedHeaders": this.model.pivotControl._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.pivotControl.model.valueSortSettings), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (!ej.isNullOrUndefined(pivotClientObj)) {
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                schemaObj.model.pivotControl._waitingPopup.show();
                        }, 800);
                    }
                    else
                        this.model.pivotControl._waitingPopup.show();
                    this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
                    this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.fetchMembers, eventArgs, this.model.pivotControl.model.enableMemberEditorPaging ? ej.Pivot._fetchMemberPageSuccess : this._fetchMemberSuccess);
                }
            }
        },
 
        _removeBtnClick: function (args) {
            schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!ej.isNullOrUndefined(pivotClientObj)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        schemaObj.model.pivotControl._waitingPopup.show();
                }, 800);
            }
            else
                this.model.pivotControl._waitingPopup.show();
            if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                ej.PivotAnalysis._valueSorting = null;
                var currentFieldName = $(args.target).parent().attr("tag").split(":")[1];
                ej.Pivot.removeReportItem(this.model.pivotControl.model.dataSource, currentFieldName, (currentFieldName.toLocaleLowerCase().indexOf("measures") == 0));
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    this.model.pivotControl._fieldMembers = {};
                    this.model.pivotControl._fieldSelectedMembers = {};
                    ej.olap.base.clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "nodeDropped" }, this.model.pivotControl)
                }
                if (this.model.pivotControl.element.hasClass("e-pivotclient") && this.model.pivotControl._pivotChart)
                    this.model.pivotControl._pivotChart._labelCurrentTags = {};
                this._refreshPivotButtons();
                this.model.pivotControl.refreshControl();
                $(args.target).parent().remove();
            }
            else {
                var headerText = $(args.target.parentElement).find("button").attr("fieldname") || $(args.target.parentElement).text(), headerTag,
                selectedTreeNode = $($(this._tableTreeObj.element).find("div:contains(" + headerText + ")>span")[1]).find(".e-chk-act");

                $(selectedTreeNode).removeClass("e-chk-act").addClass("e-chk-inact");
                $(selectedTreeNode).children("e-checkmark").removeClass("e-checkmark");
                for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                    if (this.model.pivotTableFields[i].id == headerText) {
                        this.model.pivotTableFields[i].IsSelected = false;
                        headerTag = this.model.pivotTableFields[i];
                    }
                }
                $(args.target.parentElement).remove();
                if ($(this.element).parents(".e-pivotclient").length > 0) {
                    var tagText = $(args.target).parent().attr("tag");
                    delete this.model.pivotControl._fieldMembers[tagText.split(':')[tagText.split(':').length - 1]];
                    delete this.model.pivotControl._fieldSelectedMembers[tagText.split(':')[tagText.split(':').length - 1]];
                }
                this._clearFilterData(headerText);
                if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.pivotControl.model.customObject });
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && $(this.element).parents(".e-pivotclient").length > 0) {
                    var report;
                    try { report = JSON.parse(this.model.pivotControl.getOlapReport()).Report; }
                    catch (err) {
                        if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                            report = this.model.pivotControl.getOlapReport();
                    }
                    var eventArgs = JSON.stringify({ "action": "removeButton", "args": JSON.stringify({ "headerTag": headerText, "currentReport": report, "sortedHeaders": (!ej.isNullOrUndefined(this.model.pivotControl._ascdes) ? this.model.pivotControl._ascdes : "")}), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._droppedSuccess);
                }
                else {
                    var eventArgs = JSON.stringify({ "action": "nodeStateModified", "headerTag": JSON.stringify(headerTag), "sortedHeaders": this._getSortedHeaders(), "currentReport": this.model.pivotControl.getOlapReport(), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs, this._nodeStateModifiedSuccess);
                }
            }
            if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
        },

        _nodeCheckChanges: function (args) {
            this._isFiltered = true;
            if ((args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() == "all") && args.type == "nodeUncheck") {
                this._memberTreeObj.model.nodeCheck = "";
                this._memberTreeObj.model.nodeUncheck = "";
                this.element.find(".editorTreeView").ejTreeView("unCheckAll");
                this._memberTreeObj.model.nodeCheck = ej.proxy(this._nodeCheckChanges, this);
                this._memberTreeObj.model.nodeUncheck = ej.proxy(this._nodeCheckChanges, this);
                this._dialogOKBtnObj.disable();
                if (this.model.pivotControl && this.model.pivotControl.model.enableMemberEditorPaging) {
                    this.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                    this._isAllMemberChecked = false;
                    for (var i = 0; i < this._editorTreeData.length; i++)
                        this._editorTreeData[i].checkedStatus = false;
                }

            }
            else if ((args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() == "all") && args.type == "nodeCheck") {
                this._memberTreeObj.model.nodeCheck = "";
                this._memberTreeObj.model.nodeUncheck = "";
                this.element.find(".editorTreeView").ejTreeView("checkAll");
                $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)").removeClass("e-stop");
                this._memberTreeObj.model.nodeCheck = ej.proxy(this._nodeCheckChanges, this);
                this._memberTreeObj.model.nodeUncheck = ej.proxy(this._nodeCheckChanges, this);
                this._dialogOKBtnObj.enable();
                if (this.model.pivotControl && this.model.pivotControl.model.enableMemberEditorPaging) {
                    this.element.find(".dialogOKBtn").removeAttr("disabled");
                    this._isAllMemberChecked = true;
                    for (var i = 0; i < this._editorTreeData.length; i++)
                        this._editorTreeData[i].checkedStatus = true;
                }
            }
            else if ((args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() != "all") && !ej.isNullOrUndefined(this.model.pivotControl) && this.model.pivotControl.model.enableMemberEditorPaging) {
                if (args.type == "nodeUncheck") {
                    this.model.pivotControl._isMembersFiltered = true;
                    var temp = "";
                    ej.Pivot._memberPageNodeUncheck(args, this);
                    temp = ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).where("checkedStatus", "equal", true));
                    var firstNode = $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)");
                    if (!ej.isNullOrUndefined(temp) && temp.length == 0) {
                        this._dialogOKBtnObj.disable();
                        this.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                        this._isAllMemberChecked = false;
                        firstNode.removeClass("e-stop").removeClass("e-checkmark").addClass("e-chk-inact");
                    }
                    else
                        $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)").removeClass("e-stop").addClass("e-checkmark");
                }
                else if (args.type == "nodeCheck") {
                    this.model.pivotControl._isMembersFiltered = true;
                    ej.Pivot._memberPageNodeCheck(args, this);
                    this.element.find(".dialogOKBtn").data("ejButton").enable();
                    this.element.find(".dialogOKBtn").removeAttr("disabled");
                    this._isAllMemberChecked = true;
                    $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)").removeClass("e-stop").addClass("e-checkmark");
                }
            }
            else if (args.id.toLowerCase() == "(all)_0" || args.id.toLowerCase() != "all") {
                var uncheckedNodes = this._memberTreeObj.element.find(":input:gt(0).nodecheckbox:not(:checked)"),
                firstNode = $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)");
                if (uncheckedNodes.length == 0 || (uncheckedNodes.length == 1 && uncheckedNodes[0].id[uncheckedNodes[0].id.length - 1] == 0)) {
                    $(firstNode).parent().removeClass("e-chk-inact").removeClass("e-chk-ind").addClass("e-chk-act");
                    firstNode.removeClass("e-stop").addClass("e-checkmark");
                }
                else if (args.type == "nodeCheck" && uncheckedNodes.length == 1 && uncheckedNodes[0].id[uncheckedNodes[0].id.length - 1] == 0)
                    firstNode.removeClass("e-stop").addClass("e-checkmark");
                else if (uncheckedNodes.length > 0)
                    firstNode.removeClass("e-checkmark").addClass("e-stop");
                this._dialogOKBtnObj.enable();
                if (args.type == "nodeUncheck" && uncheckedNodes.length + 1 == this._memberTreeObj.element.find("li").length) {
                    firstNode.removeClass("e-checkmark").removeClass("e-stop");
                    this._dialogOKBtnObj.disable();
                }
            }
        },
        _pivotCheckedStateModified: function (args) {
            if (this._nodeCheck == true) {
                this._nodeCheck = false;
                return false;
            }
            if (this._isDropAction)
                return false;
            ej.PivotAnalysis._valueSorting = null;
            var headerName = this.model.pivotControl._dataModel == "XMLA" ? $(args.currentElement).attr("tag") : this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? $.grep(this.model.pivotTableFields, function (item) { return item.caption == $(args.currentElement).find("a")[0].textContent; })[0].name : $(args.currentElement).find("a")[0].textContent,
			headerCaption = $(args.currentElement).find("a")[0].textContent, filterTag = "", filterItems = "", selectedElement = "", headerTag = "", uniqueName = "", report = "", isClientMode = this.model.pivotControl._dataModel == "XMLA" ? "XMLA" : "";
            var selectedElement = new Array();
            for (var i = 0; i < this.element.find(".pivotButton").length; i++) {
                uniqueName = $(this.element.find(".pivotButton")[i]).find("button").attr("fieldName");
                if (uniqueName == headerName) {
                    selectedElement.push(this.element.find(".pivotButton")[i]);
                    if (isClientMode == "XMLA")
                        break;
                }
            }
            for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                if (this.model.pivotTableFields[i].name == headerName && args.type == "nodeCheck") {
                    this.model.pivotTableFields[i].isSelected = true;
                    headerTag = this.model.pivotTableFields[i];
                }
                else if (this.model.pivotTableFields[i].name == headerName && args.type == "nodeUncheck") {
                    this.model.pivotTableFields[i].isSelected = false;
                    headerTag = this.model.pivotTableFields[i];
                }
            }
            if (args.type == "nodeUncheck") {
                if (selectedElement.length > 1)
                    for (var i = 0; i < selectedElement.length; i++) {
                        if ($(selectedElement[i]).find('button').attr('fieldName') == headerName)
                            $(selectedElement[i]).remove();
                    }
                else
                    $(selectedElement).remove();
            }
            try {
                report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
            }
            catch (err) {
                if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                    report = this.model.pivotControl.getOlapReport();
            }
            if (isClientMode == "XMLA"&&report == "") {
                report = this.model.pivotControl.model.dataSource;
                this._selectedMember = headerName;
                this._selectedTreeNode = $(args.currentElement);
                this.model.pivotControl.dataSource = this.model.pivotControl._clearDrilledItems(this.model.pivotControl.model.dataSource, {action:"nodeStateModefied"});
            }
            var dropAxis = this._droppedClass != "" ? this._droppedClass : headerTag.pivotType != undefined ? headerTag.pivotType == "PivotItem" ? "schemaRow" : "schemaValue" : "schemaRow", eventArgs, axisName, params;
            this._droppedClass = "";

            if (args.type == "nodeCheck") {
                if (isClientMode == "XMLA") {
                    headerCaption = $(args.currentElement).find(".kpi").length > 0 ? $(args.currentElement).parents("li:eq(0)").children("div").text() + " " + headerCaption : headerCaption;
                    var liElement = this.model.pivotControl.model.dataSource.enableAdvancedFilter ? $(args.currentElement.find(".e-text")) : $(args.currentElement.find(".e-text")[0]);
                    (($(args.currentElement).attr("tag").toLowerCase().indexOf("[measures]") < 0) && !($(args.currentElement).find(".namedSetCDB").length > 0)) ? liElement.after(ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML) : "";
                    if ($(args.currentElement).attr("tag").toLocaleLowerCase().indexOf("[measures]") >= 0)
                        dropAxis = "schemaValue";
                    droppedItem = $(args.currentElement).find(".namedSetCDB").length > 0 ? { fieldName: $(args.currentElement).attr("tag"), fieldCaption: $(args.currentElement).text(), isNamedSets: true } : ej.olap.base._getCaption({ fieldName: headerName, fieldCaption: headerCaption }, this.model.pivotControl._fieldData.hierarchy);
                }
                else {
                $(args.currentElement.find(".e-text")[0]).after(ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML);
                droppedItem = { fieldName: headerName, fieldCaption: headerCaption };
                }
                dropAxis = dropAxis == "" ? "row" : dropAxis == "schemaColumn" ? "column" : dropAxis == "schemaRow" ? "row" : dropAxis == "schemaValue" ? "value" : dropAxis == "schemaFilter" ? "filter" : "";

                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var dropItem = $.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == headerName; });
                    if (dropItem.length > 0) {
                        if (this._calculatedFieldItems(dropItem))
                            return;
                        dropAxis = "value";
                        droppedItem = { fieldName: headerName, fieldCaption: headerCaption, isCalculatedField: true, formula: dropItem[0].formula };
                    }
                }

                this._createPivotButton(droppedItem, dropAxis, "", "", "");

                if (isClientMode == "XMLA" && dropAxis == "value") {
                    if (this.model.pivotControl.model.dataSource.values.length == 0) {
                        this.model.pivotControl.model.dataSource.values.push(({ measures: [], axis: "columns" }))
                    }
                    measuresAxis = this.model.pivotControl.model.dataSource.values[0]["axis"] == "columns" ? "Columns:" : "Rows:";
                    if ((this.element.find("div[tag='" + measuresAxis + "Measures" + "']").length == 0))
                        this._createPivotButton({ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }, measuresAxis == "Columns:" ? "column" : "row", "", "", "");
                    this.model.pivotControl.model.dataSource.values[0]["measures"].push(droppedItem)
                }
                else {
                if ($.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.fieldName == droppedItem.fieldName; }).length == 0)
                    dropAxis == "row" ? this.model.pivotControl.model.dataSource.rows.push(droppedItem) : dropAxis == "column" ? this.model.pivotControl.model.dataSource.columns.push(droppedItem) : dropAxis == "filter" ? this.model.pivotControl.model.dataSource.filters.push(droppedItem) : this.model.pivotControl.model.dataSource.values.push(droppedItem);
                }
                if (isClientMode == "XMLA") {
                    if (!ej.isNullOrUndefined(this.model.pivotControl._ogridWaitingPopup))
                        this.model.pivotControl._ogridWaitingPopup.show();
                    ej.olap.base.getJSONData({ action: "nodeCheck" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                }
                else{
                this._trigger("fieldItemDropped", { axis: dropAxis, fieldItem: args.currentElement });
                this.model.pivotControl.model.editCellsInfo = {};
                this.model.pivotControl._populatePivotGrid();
            }
            }
            else if (args.type == "nodeUncheck") {
                $(args.currentElement).removeClass("filter").find(".filter").remove();
                $(args.currentElement).removeClass("filter").find(".treeDrop").remove();
                this.model.pivotControl.model.dataSource.columns = $.grep(this.model.pivotControl.model.dataSource.columns, function (value) { return value.fieldName != headerName; });
                this.model.pivotControl.model.dataSource.rows = $.grep(this.model.pivotControl.model.dataSource.rows, function (value) { return value.fieldName != headerName; });
                var valueElements = this.model.pivotControl.model.dataSource.values;
                if (isClientMode == "XMLA") {
                    if ((ej.olap._mdxParser._getItemPosition(this.model.pivotControl.model.dataSource.values[0]["measures"], headerName)).length > 0)
                        this.model.pivotControl.model.dataSource.values[0]["measures"].splice(ej.olap._mdxParser._getItemPosition(this.model.pivotControl.model.dataSource.values[0]["measures"], headerName)[0], 1);
                    if (this.model.pivotControl.model.dataSource.values[0]["measures"].length == 0)
                        this.element.find("div[tag='" + (this.model.pivotControl.model.dataSource.values[0]["axis"] == "columns" ? "Columns" : "Rows") + ":Measures" + "']").remove();
                }
                else {
                this.model.pivotControl.model.dataSource.values = $.grep(valueElements, function (value) { return value.fieldName != headerName; });
                if (this.model.pivotControl._calculatedField.length > 0) {
                    var removeElement = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.isCalculatedField == true && value.formula.indexOf(headerName) > -1; });
                    for (var i = 0; i < removeElement.length; i++)
                        this._tableTreeObj.uncheckNode(removeElement[i].fieldName);
                }
                }
                this.model.pivotControl.model.dataSource.filters = $.grep(this.model.pivotControl.model.dataSource.filters, function (value) { return value.fieldName != headerName; });

                if (isClientMode == "XMLA") {
                    if (!ej.isNullOrUndefined(this.model.pivotControl._ogridWaitingPopup))
                        this.model.pivotControl._ogridWaitingPopup.show();
                    ej.olap.base.getJSONData({ action: "nodeUncheck" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                }
                else {
                dropAxis = dropAxis == "" ? "row" : dropAxis == "schemaColumn" ? "column" : dropAxis == "schemaRow" ? "row" : dropAxis == "schemaValue" ? "value" : dropAxis == "schemaFilter" ? "filter" : "";
                this._trigger("fieldItemDropped", { axis: dropAxis, fieldItem: args.currentElement });
                this.model.pivotControl.model.editCellsInfo = {};
                this.model.pivotControl._populatePivotGrid();
            }
            }
            this._setPivotBtnWidth();
        },

        _calculatedFieldItems: function (dropItem) {
            if (dropItem.length > 0) {
                var items = dropItem[0].formula.replace(/\(|\)/g, " ").replace(/[-+*/^%]/g, " ").split(" ");
                for (var k = 0; k < items.length; k++) {
                    if (!$.isNumeric(items[k]) && items[k].replace(/\s+|\s+$/gm, "") != "")
                        if ((this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.fieldName == items[k] }).length == 0) || (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && $.grep(JSON.parse(this.model.pivotControl.getOlapReport()).PivotCalculations, function (value) { return value.FieldName == items[k] }).length == 0)) {
                            alert(this.model.pivotControl._getLocalizedLabels("NotPresent"));
                            this._tableTreeObj.model.nodeCheck = null;
                            this._tableTreeObj.model.nodeUncheck = null;
                            this._tableTreeObj.uncheckNode(dropItem[0].name);
                            this._tableTreeObj.model.nodeCheck = this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? ej.proxy(this._checkedStateModified, this) : ej.proxy(this._pivotCheckedStateModified, this);
                            this._tableTreeObj.model.nodeUncheck = this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? ej.proxy(this._checkedStateModified, this) : ej.proxy(this._pivotCheckedStateModified, this);
                            return true;
                        }
                }
            }
            return false;
        },

        _checkedStateModified: function (args) {
            this.model.pivotControl._isUpdateRequired = true;
                if (this._isMeasureBtnRemove == true) {
                this._isMeasureBtnRemove = false;
                return false;
                }
                if(this._nodeCheck == true){
                this._nodeCheck = false;
                return false;
                }
                var headerText = $(args.currentElement).find("a")[0].textContent, filterTag = "", filterItems = "", selectedElement = "", headerTag = "", uniqueName = "";
                if (this._dataModel == "Pivot" && args.type == "nodeCheck") {
                    var dropItem = $.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == $(args.currentElement).attr("id"); });
                    if (this._calculatedFieldItems(dropItem))
                        return;
                }
            if (this._dataModel == "Olap") {
                if (!args.currentElement[0].id.indexOf("[Measures]") > -1)
                    for (var i = 0; i < this.element.find(".pivotButton").length; i++) {
                        headerTag = $(this.element.find(".pivotButton")[i]).attr("tag"); uniqueName = "";
                        uniqueName = ((headerTag.indexOf("[Measures]") > -1) || (headerTag.indexOf("[") > -1)) ? headerTag.split(":")[1] : this.model.pivotControl._getNodeUniqueName(headerTag);
                        uniqueName = uniqueName.replace("<>", ".");
                        if ($(args.currentElement).attr("tag").toLowerCase() == uniqueName.toLowerCase()) {
                            selectedElement = $(this.element.find(".pivotButton")[i]);
                            break;
                        }
                    }
                else
                    selectedElement = this.element.find(".pivotButton:contains(" + headerText + ")"), headerTag, report;
            }
            else
                selectedElement = this.element.find(".pivotButton:contains(" + headerText + ")"), headerTag, report;
            var isFiltered = selectedElement.length > 0 && $(selectedElement).siblings(".filterIndicator").length > 0 ? true : false,
            isSorted = args.currentElement.find("~ span:eq(0) span.descending").length > 0 ? true : false;
            for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                if (this.model.pivotTableFields[i].name == headerText && args.type == "nodeCheck") {
                    this.model.pivotTableFields[i].isSelected = true;
                    headerTag = this.model.pivotTableFields[i];
                }
                else if (this.model.pivotTableFields[i].name == headerText && args.type == "nodeUncheck") {
                    this.model.pivotTableFields[i].isSelected = false;
                    headerTag = this.model.pivotTableFields[i];
                }
            }
            if (ej.isNullOrUndefined(headerTag))
                headerTag = $(args.currentElement).attr("tag");

            if (args.type == "nodeUncheck") {
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    this._clearFilterData(headerText);
                }
                if (selectedElement.length > 1)
                    for (var i = 0; i < selectedElement.length; i++) {
                        if ($(selectedElement[i]).text() == headerText)
                            $(selectedElement[i]).remove();
                    }
                else
                    $(selectedElement).remove();
            }
            else {
                if (this._droppedClass != "")
                    this._createPivotButton({ fieldName: headerTag.id, fieldCaption: headerText }, this._droppedClass == "schemaColumn" ? "column" : this._droppedClass == "schemaRow" ? "row" : this._droppedClass == "schemaValue" ? "value" : this._droppedClass == "schemaFilter" ? "filter" : "", isFiltered, isSorted, "");
                else
                    this._createPivotButton({ fieldName: headerTag.id, fieldCaption: headerText }, ((this._dataModel == "Olap" && $(args.currentElement).attr("tag").indexOf("[Measures]") < 0) || (this._dataModel == "Pivot" && headerTag.pivotType == "PivotItem")) ? "row" : "value", isFiltered, isSorted, "");
            }
            if (!ej.isNullOrUndefined(this._tempFilterData)) {
                for (var i = 0; i < this._tempFilterData.length; i++) {
                    if (!ej.isNullOrUndefined(this._tempFilterData[i][headerTag.id])) {
                        for (var j = 0; j < this._tempFilterData[i][headerTag.id].length; j++)
                            filterItems += "##" + this._tempFilterData[i][headerTag.id][j];
                    }
                }
            }
            try {
                report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
            }
            catch (err) {
                if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                report = this.model.pivotControl.getOlapReport();
            }
            filterTag = "schemaRow::" + headerText + "::FILTERED" + filterItems;
            var dropAxis = this._droppedClass != "" ? this._droppedClass : headerTag.pivotType == "PivotItem" ? "schemaRow" : "schemaValue", eventArgs, axisName, params;
            this._droppedClass = "";
            if (!ej.isNullOrUndefined(this.model.pivotControl) && !ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                this.model.pivotControl._waitingPopup.show();
            this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
            if (!(args.type == "nodeCheck") && !(args.type == "nodeUncheck") && dropAxis != "") {
                if (this._dataModel == "Pivote") {
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    eventArgs = JSON.stringify({ "action": "nodeStateModified", "headerTag": JSON.stringify(headerTag), "dropAxis": dropAxis + "::" + this._droppedPosition, "sortedHeaders": this.model.pivotControl._ascdes, "filterParams": filterTag, "currentReport": report, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    this._droppedPosition = "";
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs, this._nodeStateModifiedSuccess);
                    else {
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs.replace("nodeStateModified", "nodeStateModifiedDeferUpdate"), this._nodeStateModifiedSuccess);
                    }
                }
                else {
                    if ($(args.currentElement).attr("tag").toLowerCase().indexOf("[measures]") == -1) {
                        var dropSpan = ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filter button").addClass("treeDrop")[0].outerHTML;
                        $(args.currentElement.find(".e-text")[0]).after($(dropSpan).hide());
                    }
                    headerTag = $(args.currentElement).attr("tag");
                    axisName = this._nodeDropedParams == "" ? ($(args.currentElement).attr("tag").toLowerCase().indexOf("[Measures]") >= 0 ? "Categorical" : "Series") : this._nodeDropedParams;
                    params = this._currentCubeName + "--" + headerTag + "--" + axisName + "--", report;
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    eventArgs = JSON.stringify({ "action": "nodeDropped", "dropType": "TreeNode", "nodeInfo": params, "currentReport": report, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._droppedSuccess);
                    else {
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._droppedSuccess);
                    }
                }
            }
            else if (args.type == "nodeCheck") {
                if (this._dataModel == "Olap") {
                    if ($(args.currentElement).attr("tag").indexOf("[Measures]") == -1) {
                        var dropSpan = ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filter button").addClass("treeDrop")[0].outerHTML;
                        $(args.currentElement.find(".e-text")[0]).after($(dropSpan).hide());
                    }
                    this._nodeDropedParams = dropAxis == "schemaColumn" ? "Categorical" : dropAxis == "schemaRow" ? "Series" : dropAxis == "schemaFilter" ? "Slicer" : "";
                    headerTag = $(args.currentElement).attr("tag");
                    axisName = this._nodeDropedParams == "" ? ($(args.currentElement).attr("tag").indexOf("[Measures]") >= 0 ? "Categorical" : "Series") : this._nodeDropedParams;
                    if (headerTag.toLowerCase().indexOf("[measures]") > -1)
                        axisName = "Categorical";
                    params = this._currentCubeName + "--" + headerTag + "--" + axisName + "--", report;
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    eventArgs = JSON.stringify({ "action": "nodeDropped", "dropType": "TreeNode", "nodeInfo": params, "currentReport": report, "gridLayout": this.model.pivotControl.model.layout, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._droppedSuccess);
                    else {
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._droppedSuccess);
                    }
                }
                else {
                    $(args.currentElement.find(".e-text")[0]).after($(ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filter button").addClass("treeDrop")[0].outerHTML).hide());
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    eventArgs = JSON.stringify({ "action": "nodeStateModified", "headerTag": JSON.stringify(headerTag), "dropAxis": dropAxis + "::", "sortedHeaders": this.model.pivotControl._ascdes, "filterParams": filterTag, "currentReport": report, "valueSorting": JSON.stringify(this.model.pivotControl.model.valueSortSettings), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs, this._nodeStateModifiedSuccess);
                    else {
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs.replace("nodeStateModified", "nodeStateModifiedDeferUpdate"), this._nodeStateModifiedSuccess);
                        if (!ej.isNullOrUndefined(this.model.pivotControl._ogridWaitingPopup))
                            this.model.pivotControl._ogridWaitingPopup.hide();
                    }
                }
            }
            else if (args.type == "nodeUncheck") {
                if (this._dataModel == "Olap") {
                    $(args.currentElement.find(".treeDrop")).remove();
                   // $(args.currentElement.find(".e-icon:not(.e-chk-image, .e-plus,.e-minus)")).remove();
                    $(args.currentElement).find(".filter").removeClass("filter");
                    var headerTag = $(selectedElement).attr("tag"), report, eventArgs;
                    delete this.model.pivotControl._fieldMembers[headerTag.split(':')[headerTag.split(':').length - 1]];
                    delete this.model.pivotControl._fieldSelectedMembers[headerTag.split(':')[headerTag.split(':').length - 1]];
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "removeButton", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    eventArgs = JSON.stringify({ "action": "removeButton", "headerInfo": headerTag, "currentReport": report, "gridLayout": this.model.pivotControl.model.layout, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (ej.isNullOrUndefined(headerTag))
                        return false;
                    if ((headerTag.indexOf("[Measures]") >= 0 || headerTag.toLowerCase().indexOf("[measures]")) && this.element.find(".schemaValue .pivotButton").length == 0) {
                        var tmp = headerTag.split(":"),
                        tempAxis = tmp[0] == "Rows" ? ".schemaRow" : tmp[0] == "Columns" ? ".schemaColumn" : "";
                        this.element.find(tempAxis + " .pivotButton:contains('Measures')").remove();
                    }
                    else if (headerTag.indexOf("[Measures]") < 0 && headerTag.indexOf("Measures") >= 0)
                        this.element.find(".schemaValue .pivotButton").remove();
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.removeButton, eventArgs, this._pvtBtnDroppedSuccess)
                    else {
                        this._removeButtonDeferUpdate = true;
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.removeButton, eventArgs.replace("removeButton", "removeButtonDeferUpdate"), this._droppedSuccess)
                    }
                }
                else {
                    this._clearFilterData(headerTag.id);
                    if (this.model.pivotControl._calculatedField.length > 0) {
                        var removeElement = $.grep(JSON.parse(this.model.pivotControl.getOlapReport()).PivotCalculations, function (value) { return value.CalculationType == 8 && value.Formula.indexOf(headerTag["id"]) > -1; })
                        for (var i = 0; i < removeElement.length; i++) {
                            this._tableTreeObj.model.nodeUncheck = null;
                            this._tableTreeObj.uncheckNode(removeElement[i].FieldName);
                            this._tableTreeObj.element.find("li[id='" + removeElement[i].FieldName + "']").removeClass("filter").find(".treeDrop").remove()
                            this._tableTreeObj.model.nodeUncheck = ej.proxy(this._checkedStateModified, this);
                        }
                    }
                    delete this.model.pivotControl._fieldMembers[headerTag.name];
                    $(args.currentElement).removeClass("filter").find(".filter").remove();
                    $(args.currentElement).removeClass("filter").find(".treeDrop").remove();
                    this.model.pivotControl._ascdes = this.model.pivotControl._ascdes.replace(headerText + "##", "");
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    eventArgs = JSON.stringify({ "action": "nodeStateModified", "headerTag": JSON.stringify(headerTag), "dropAxis": dropAxis + "::", "sortedHeaders": this.model.pivotControl._ascdes, "filterParams": filterTag, "currentReport": report, "valueSorting": JSON.stringify(this.model.pivotControl.model.valueSortSettings), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs, this._nodeStateModifiedSuccess);
                    else {
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeStateModified, eventArgs.replace("nodeStateModified", "nodeStateModifiedDeferUpdate"), this._nodeStateModifiedSuccess);
                        if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                            this.model.pivotControl._waitingPopup.hide();
                    }
                }
            }
            this._setPivotBtnWidth();
        },

        _clearFilterData: function (headerText) {
            if (!ej.isNullOrUndefined(this._tempFilterData)) {
                for (var j = 0; j < this._tempFilterData.length; j++) {
                    for (var key in this._tempFilterData[j]) {
                        if (key == headerText && this._tempFilterData[j][headerText] != "") {
                            this._tempFilterData.splice(j, 1);
                        }
                    }
                }
            }
            this.model.pivotControl._tempFilterData = this._tempFilterData;
        },

        _nodeDropped: function (args) {
            if ($(args.dropTarget).hasClass("pvtBtn"))
                args.dropTarget = $(args.dropTarget).parents('div.e-droppable').length > 0 && $(args.dropTarget).parents('.e-pivotschemadesigner').length > 0 ? $(args.dropTarget).parents('div.e-droppable') : args.dropTarget;
            if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var headerTag = "";
                var headerText = (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.pivotControl._dataModel != "XMLA") ? $.grep(this.model.pivotTableFields, function (item) { return item.caption == args.droppedElement.text() })[0].name : (this._dataModel == "XMLA") ? args.droppedElement.attr("tag") : args.droppedElement.text();
                var headerName = $(args.droppedElement).attr("id");
                var droppedAxis = args.dropTarget.hasClass("schemaColumn") ? "schemaColumn" : args.dropTarget.hasClass("schemaRow") ? "schemaRow" : args.dropTarget.hasClass("schemaFilter") ? "schemaFilter" : args.dropTarget.hasClass("schemaValue") ? "schemaValue" : "";
                if (droppedAxis == "")
                    return false;
                var droppedPosition = this._setSplitBtnTargetPos(!ej.isNullOrUndefined(args.event) ? args.event : args);
                try { report = JSON.parse(this.model.pivotControl.getOlapReport()).Report; }
                catch (err) { report = this.model.pivotControl.getOlapReport(); }
                if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                    this.model.pivotControl._waitingPopup.show();
                for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                    if (this.model.pivotTableFields[i].name == headerText) {
                        this.model.pivotTableFields[i].isSelected = true;
                        headerTag = this.model.pivotTableFields[i];
                        break;
                    }
                }
                var eventArgs = JSON.stringify({ "action": this.model.pivotControl.model.enableDeferUpdate ? "nodeDroppedDeferUpdate" : "nodeDropped", "args": JSON.stringify({ "droppedFieldCaption": headerText, "droppedFieldName": headerName, "headerTag": headerTag, "dropAxis": droppedAxis, "droppedPosition": droppedPosition, "currentReport": report }), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._pvtNodeDroppedSuccess);
                this._isDragging = false;
                return;
            }
            this.model.pivotControl._isUpdateRequired = true;
            if (args.dropTarget[0] == undefined && args.dropTarget.className == undefined)
                return;
            var pivotDrop = false;
            if (this._dataModel == "Pivot") {
                var buttonDrag = $(args.dropTarget).parents();
                for (var i = 0; i < buttonDrag.length; i++) {
                    if ($(buttonDrag[i]).hasClass("e-pivotgrid"))
                        pivotDrop = true;
                }
            }
            if (args.dropTarget.hasClass("e-droppable") || (args.dropTarget[0] != undefined && args.dropTarget[0].className.indexOf("e-droppable") >= 0) || (args.dropTarget.className != undefined && args.dropTarget.className.indexOf("e-droppable") >= 0) || pivotDrop) {
                this._isDragging = false;
                this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
                var headerTag = $(args.droppedElement).attr("tag"),
                    headerText = (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this.model.pivotControl._dataModel != "XMLA") ? $.grep(this.model.pivotTableFields, function (item) { return item.caption == args.droppedElement.text() })[0].name : (this._dataModel == "XMLA") ? args.droppedElement.attr("tag") : args.droppedElement.text(),
                    filterTag, filterItems = "", report,
                    selectedPvtBtn = this.element.find(".pivotButton:contains(" + headerText + ")"),
                    selectedTreeNode = (this._dataModel == "XMLA") ? (this._tableTreeObj.element.find("li[tag='" + headerTag + "']").length > 1 ? args.droppedElement : this._tableTreeObj.element.find("li[tag='" + headerTag + "']")) : this._dataModel == "Pivot" && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? this._tableTreeObj.element.find("li[id=" + headerText + "]") : this._dataModel == "Pivot" ? this._tableTreeObj.element.find("li:contains('" + headerText + "'):last") : this._tableTreeObj.element.find("li[tag='" + headerTag + "']"),
                    isFiltered = $(selectedPvtBtn).find(".filterIndicator").length > 0 ? true : false,
                    isSorted = $(selectedPvtBtn).find("~ span:eq(0) span.descending").length > 0 ? true : false;
                if (args.dropTarget.parent().attr("role") == "presentation")
                    return false;
                if (this.model.pivotControl._dataModel == "XMLA") {
                    var _tag = $.map($(headerTag.split('].')), function (a) { var name = a.lastIndexOf("]") >= 0 ? a : a + "]"; return name; });
                    if (_tag.length >= 2) {
                        var tagName = _tag[0] + "." + _tag[1];
                        selectedTreeNode = this._tableTreeObj.element.find("li[tag='" + tagName + "']");
                        headerTag = selectedTreeNode.attr("tag");
                    }
                    var isPivotGrid = (($(args.dropTarget).hasClass("value") || $(args.dropTarget).hasClass("colheader") || $(args.dropTarget).hasClass("rowheader") || $(args.dropTarget).hasClass("summary")) || $(args.dropTarget).parents("table:eq(0)").hasClass("pivotGridTable") || $(args.dropTarget).parents(".groupingBarPivot").length > 0);
                    var isNamedSet = ((args.droppedElement.find(".namedSetCDB").length > 0) && $(args.dropTarget).hasClass("schemaFilter"));
                    if (isPivotGrid || isNamedSet || ($(args.droppedElement).attr("tag").toLowerCase().indexOf("measures") >= 0 && !$(args.dropTarget).hasClass("schemaValue")) || ($(args.droppedElement).attr("tag").indexOf("Measures") < 0 && $(args.dropTarget).hasClass("schemaValue"))) {
                        this._createErrorDialog();
                        this._waitingPopup.hide();
                        return false;
                    }
                    var fieldItem = ej.Pivot.getReportItemByFieldName(headerTag, this.model.pivotControl.model.dataSource, this._dataModel);
                    var fieldAxis = fieldItem.axis;
                    if (!(selectedTreeNode.length > 1) && fieldItem.item.length > 0 && (fieldAxis == "rows" && args.dropTarget.hasClass("schemaRow") || (fieldAxis == "columns" && args.dropTarget.hasClass("schemaColumn")) || (fieldAxis == "values" && $(args.dropTarget).hasClass("schemaValue")) || (fieldAxis == "filters" && $(args.dropTarget).hasClass("schemaFilter"))))
                        return false;

                    if (selectedTreeNode.length > 1 && args.droppedElement.find(".kpiValue").length > 0) {
                        selectedTreeNode = selectedTreeNode.find(".kpiValue").parents("li:eq(0)");
                    }
                    if (this._tableTreeObj.isNodeChecked(selectedTreeNode))
                        for (var i = 0; i < this.element.find(".pivotButton").length; i++)
                            this.element.find(".pivotButton:eq(" + i + ")").attr("tag").split(":")[1] == headerTag ? this.element.find(".pivotButton:eq(" + i + ")").remove() : "";
                }
                else if (this._dataModel == "Olap")
                    if (($(args.droppedElement).attr("tag").indexOf("Measures") >= 0 && ($(args.dropTarget).hasClass("schemaFilter") || $(args.dropTarget).hasClass("drag"))) || ($(args.droppedElement).attr("tag").indexOf("Measures") < 0 && $(args.dropTarget).hasClass("schemaValue"))) {
                        this._createErrorDialog();
                        this._waitingPopup.hide();
                        return false;
                    }

                $(selectedTreeNode).find(".filter").remove();
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    selectedPvtBtn = new Array();
                    for (var i = 0; i < this.element.find(".pivotButton").length; i++) {
                        uniqueName = $(this.element.find(".pivotButton")[i]).find("button").attr("fieldName");
                        if (uniqueName == headerText)
                            selectedPvtBtn.push(this.element.find(".pivotButton")[i]);
                    }
                }
                if (pivotDrop)
                    if (args.event.target.tagName == "TH" || args.event.target.tagName == "TD" || $(args.event.target).hasClass("cellValue") && ($(args.event.target).parent("th").length > 0 || $(args.event.target).parent("td").length > 0)) {
                        if ($(args.event.target).hasClass("cellValue")) {
                            if ($(args.event.target).parent("th").length > 0)
                                args.event.target = $(args.event.target).parent("th")[0];
                            else if ($(args.event.target).parent("td").length > 0)
                                args.event.target = $(args.event.target).parent("td")[0];
                        }
                        this._droppedClass = args.event.target.className.split(" ")[0] == "rowheader" || args.event.target.className.split(" ")[0] == "grpRow" ? "schemaRow" : args.event.target.className.split(" ")[0] == "colheader" ? "schemaColumn" : $(args.event.target).hasClass("value") ? "schemaValue" : "";
                        if (this._droppedClass == "") return;
                    }
                    else 
                        this._droppedClass = (args.event.target.className.split(" ")[0] == "rows" || args.event.target.className.split(" ")[0] == "emptyRows") ? "schemaRow" : args.event.target.className.split(" ")[0] == "columns" ? "schemaColumn" : args.event.target.className.split(" ")[0] == "values" ? "schemaValue" : args.event.target.className.split(" ")[0] == "drag" ? "schemaFilter" : "";
                else
                    if (!ej.isNullOrUndefined(args.event)) {
                        this._droppedClass = args.event.target.className.split(" ")[0];
                    }
                    else {
                        this._droppedClass = args.dropTarget.hasClass("schemaColumn") ? "schemaColumn" : args.dropTarget.hasClass("schemaRow") ? "schemaRow" : args.dropTarget.hasClass("schemaFilter") ? "schemaFilter" : args.dropTarget.hasClass("schemaValue") ? "schemaValue" : "";
                    }
                if (this._dataModel == "Olap") {
                    var isHierarchy = $(args.droppedElement).children("div:eq(0)").find(".e-checkbox").length;
                    if (isHierarchy == 0)
                        selectedTreeNode = args.droppedElement.parent("ul").parent("li:eq(0)");
                    else
                        selectedTreeNode = args.droppedElement;
                }
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this._dataModel == "Pivot" && this._droppedClass != "schemaValue" && ($.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == selectedTreeNode.attr("id"); }).length > 0 || $.grep(JSON.parse(this.model.pivotControl.getOlapReport()).PivotCalculations, function (value) { return value.FieldName == selectedTreeNode.attr("id") && value.CalculationType == 8; }).length > 0)) {
                    this.model.pivotControl._createErrorDialog(this.model.pivotControl._getLocalizedLabels("CalcValue"), this.model.pivotControl._getLocalizedLabels("Warning"));
                    return;
                }
                if (selectedTreeNode.find(".e-chk-inact").length > 0 && (this._droppedClass != "" && (this._droppedClass == "schemaRow" || this._droppedClass == "schemaColumn" || this._droppedClass == "schemaFilter" || this._droppedClass == "schemaValue"))) {
                    this._tableTreeObj.checkNode(selectedTreeNode);
                    return false;
                }
                else if (selectedTreeNode.find(".e-chk-inact").length > 0 && (this._droppedClass != "" && (this._droppedClass == "pvtBtn" || this._droppedClass == "rowheader" || this._droppedClass == "colheader" || ((this._droppedClass == "value" && $(args.droppedElement).attr("tag").indexOf("Measures") < 0))))) {
                    this._nodeCheck = true;
                    this._tableTreeObj.checkNode(selectedTreeNode);
                }
                if (ej.isNullOrUndefined(headerTag))
                    for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                        if (this.model.pivotTableFields[i].name == headerText) {
                            this.model.pivotTableFields[i].isSelected = true;
                            headerTag = this.model.pivotTableFields[i];
                        }
                    }
                if (!ej.isNullOrUndefined(this._tempFilterData))
                    for (var i = 0; i < this._tempFilterData.length; i++) {
                        if (!ej.isNullOrUndefined(this._tempFilterData[i][headerText])) {
                            for (var j = 0; j < this._tempFilterData[i][headerText].length; j++)
                                filterItems += "##" + this._tempFilterData[i][headerText][j];
                        }
                    }
                if (args.droppedElement[0].tagName.toLowerCase() == "button") {
                    if (selectedPvtBtn.length > 1)
                        for (var i = 0; i < selectedPvtBtn.length; i++) {
                            if ($(selectedPvtBtn[i]).text() == headerText)
                                $(selectedPvtBtn[i]).remove();
                        }
                    else
                        $(selectedPvtBtn).remove();
                }
                try {
                    report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
                }
                catch (err) {
                    if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                        report = this.model.pivotControl.getOlapReport();
                }
                if (this.model.pivotControl._dataModel == "XMLA")
                    report = this.model.pivotControl.model.dataSource;

                if (this._dataModel == "Pivot" || this.model.pivotControl._dataModel == "XMLA") {
                    this.model.pivotControl._dataModel == "XMLA" ? headerText = headerTag : headerText = headerText;
                    var droppedPosition = "";
                    if (pivotDrop)
                        droppedPosition = this._droppedPosition = "";
                    else
                        if (!ej.isNullOrUndefined(args.event)) {
                            droppedPosition = this._droppedPosition = this._setSplitBtnTargetPos(args.event);
                        }
                        else {
                            droppedPosition = "";
                        }
                    for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                        if (this.model.pivotTableFields[i].name == headerText) {
                            this.model.pivotTableFields[i].isSelected = true;
                            headerTag = this.model.pivotTableFields[i];
                            $(selectedPvtBtn).remove();
                            break;
                        }
                    }
                    if (selectedTreeNode.find(".e-chk-inact").length > 0 && (this._droppedClass != "" && (this._droppedClass == "schemaRow" || this._droppedClass == "schemaColumn" || this._droppedClass == "schemaFilter" || this._droppedClass == "schemaValue")))
                        this._tableTreeObj.checkNode(selectedTreeNode);
                    else {
                        if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                            var droppedItem = this.model.pivotControl._getDroppedItem(headerText);
                            if (droppedItem.length && droppedItem[0].filterItems && droppedItem[0].filterItems.values && droppedItem[0].filterItems.values.length)
                                $($(selectedTreeNode).find(".e-text")[0]).after(ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filtered").addClass("filter")[0].outerHTML);
                            if (!droppedItem.length)
                                droppedItem[0] = { fieldName: headerText, fieldCaption: ((this._dataModel == "XMLA" && selectedTreeNode.find(".hierarchyCDB ").length > 0) ? selectedTreeNode.find("div:eq(0)").text() : headerText) };
                            this.model.pivotControl.model.dataSource.columns = $.grep(this.model.pivotControl.model.dataSource.columns, function (value) {
                                return value.fieldName != headerText;
                            });
                            this.model.pivotControl.model.dataSource.rows = $.grep(this.model.pivotControl.model.dataSource.rows, function (value) { return value.fieldName != headerText; });

                            if (this._dataModel != "XMLA") {
                                this.model.pivotControl.model.dataSource.values = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.fieldName != headerText; });
                            }
                            else {
                                this.model.pivotControl.model.dataSource.values[0]["measures"] = $.grep(this.model.pivotControl.model.dataSource.values[0]["measures"], function (value) { return value.fieldName != headerText; });
                            }

                            this.model.pivotControl.model.dataSource.filters = $.grep(this.model.pivotControl.model.dataSource.filters, function (value) { return value.fieldName != headerText; });
                            var dropAxis = this._droppedClass == "schemaRow" ? "row" : this._droppedClass == "schemaColumn" ? "column" : this._droppedClass == "schemaFilter" ? "filter" : this._droppedClass == "schemaValue" ? "value" : "";
                            if (this.model.pivotControl._dataModel == "Pivot" && $.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == droppedItem[0].fieldCaption; }).length > 0 && dropAxis != "value") {
                                alert(this.model.pivotControl._getLocalizedLabels("CalcValue"));
                                this._tableTreeObj.checkNode(droppedItem[0].fieldCaption);
                                return;
                            }
                            this._createPivotButton(droppedItem[0], dropAxis, isFiltered, isSorted, droppedPosition);
                            if ($.isNumeric(droppedPosition))
                                this._droppedClass == "schemaRow" ? this.model.pivotControl.model.dataSource.rows.splice(droppedPosition, 0, droppedItem[0]) : this._droppedClass == "schemaColumn" ? this.model.pivotControl.model.dataSource.columns.splice(droppedPosition, 0, droppedItem[0]) : this._droppedClass == "schemaValue" ? ((this.model.pivotControl._dataModel == "XMLA") ? this.model.pivotControl.model.dataSource.values[0]["measures"].splice(droppedPosition, 0, droppedItem[0]) : this.model.pivotControl.model.dataSource.values.splice(droppedPosition, 0, droppedItem[0])) : this.model.pivotControl.model.dataSource.filters.splice(droppedPosition, 0, droppedItem[0]);
                            else
                                this._droppedClass == "schemaRow" ? this.model.pivotControl.model.dataSource.rows.push(droppedItem[0]) : this._droppedClass == "schemaColumn" ? this.model.pivotControl.model.dataSource.columns.push(droppedItem[0]) : this._droppedClass == "schemaValue" ? ((this.model.pivotControl._dataModel == "XMLA") ? this.model.pivotControl.model.dataSource.values[0]["measures"].push(droppedItem[0]) : this.model.pivotControl.model.dataSource.values.push(droppedItem[0])) : this.model.pivotControl.model.dataSource.filters == null ? (this.model.pivotControl.model.dataSource.filters = [], this.model.pivotControl.model.dataSource.filters.push(droppedItem[0])) : this.model.pivotControl.model.dataSource.filters.push(droppedItem[0]);

                            if (this.model.pivotControl._dataModel == "Pivot" && this.model.pivotControl._calculatedField.length > 0 && dropAxis != "value") {
                                this.model.pivotControl._calcFieldNodeDrop(droppedItem[0]);
                                this.model.pivotControl.model.dataSource.values = $.grep(this.model.pivotControl.model.dataSource.values, function (value) {
                                    return (ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false) || (value.isCalculatedField == true && value.formula.indexOf(droppedItem[0].fieldName) == -1);
                                });
                            }

                            if (this.model.pivotControl._dataModel == "XMLA") {
                                if (this._droppedClass == "schemaFilter")
                                    this.model.pivotControl.model.dataSource.filters = $.map(this.model.pivotControl.model.dataSource.filters, function (obj, index) { obj["advancedFilter"] = []; return obj; });
                                ej.olap.base.getJSONData({ action: "nodeDropped" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                            }
                            else {
                                this._trigger("fieldItemDropped", { axis: dropAxis, fieldItem: selectedTreeNode });
                                this.model.pivotControl.model.editCellsInfo = {};
                                this.model.pivotControl._populatePivotGrid();
                            }
                        }
                        else {
                            var isFiltered = false;
                            if (this._tempFilterData != null)
                                $.each(this._tempFilterData, function (index, object) { $.each(object, function (key, value) { if (key == $(selectedTreeNode).attr("id") && value.length > 0) isFiltered = true; }); });
                            if (isFiltered)
                                $($(selectedTreeNode).find(".e-text")[0]).after(ej.buildTag("span.e-icon").addClass("filter")[0].outerHTML);
                            if (this._dataModel == "Pivot" && this.model.pivotControl._calculatedField.length > 0 && this._droppedClass != "schemaValue")
                                this.model.pivotControl._calculatedFieldNodeRemove(headerTag);
                            this._createPivotButton({ fieldName: headerTag.id, fieldCaption: headerText }, this._droppedClass == "schemaRow" ? "row" : this._droppedClass == "schemaColumn" ? "column" : this._droppedClass == "schemaFilter" ? "filter" : this._droppedClass == "schemaValue" ? "value" : "", isFiltered, isSorted, droppedPosition);
                            var filterParams = "";
                            filterParams = ej.Pivot._getFilterParams(this._droppedClass, this._tempFilterData, headerText);
                            if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                                this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.pivotControl.model.customObject });
                            var eventArgs = JSON.stringify({ "action": "nodeDropped", "dropAxis": this._droppedClass + "::" + droppedPosition, "filterParams": filterParams, "headerTag": JSON.stringify(headerTag), "sortedHeaders": this.model.pivotControl._ascdes, "currentReport": report, "valueSorting": this.model.pivotControl.model.valueSortSettings, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                            if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                                this.model.pivotControl._waitingPopup.show();
                            this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
                            if (!this.model.pivotControl.model.enableDeferUpdate)
                                this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._pvtNodeDroppedSuccess);
                            else {
                                this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._pvtNodeDroppedSuccess);
                                if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                                    this.model.pivotControl._waitingPopup.hide();
                            }
                        }
                    }
                }
                else {
                    var axis = (args.dropTarget[0] != undefined && args.dropTarget[0].className == "pivotButton") ? $(args.dropTarget).parents()[0] : (args.dropTarget[0] != undefined && args.dropTarget[0].tagName.toLowerCase() == "td" && !$(args.dropTarget.parents("table.pivotGridTable")[0]).length) ? args.dropTarget.children(":last")[0] : args.dropTarget;
                    this._droppedClass = axis[0].className.split(" ")[0];
                    var curAxis = "", axisName = "";
                    curAxis = axis[0].className.split(" ")[0];
                    if ($(args.dropTarget.parents("table.pivotGridTable")[0]).length) {
                        axisName = $(axis).hasClass("rowheader") ? "Series" : $(axis).hasClass("grpRow") ? "Series" : $(axis).hasClass("rows") ? "Series" : $(axis).hasClass("colheader") ? "Categorical" : $(axis).hasClass("columns") ? "Categorical" : $(axis).hasClass("value") ? "Slicer" : $(axis).hasClass("drag") ? "Slicer" : "";
                        if ($(args.droppedElement).attr("tag").indexOf("Measures") > 0 && axisName == "Slicer") {
                            this._createErrorDialog();
                            return false;
                        }
                    }
                    else
                        axisName = curAxis == "columns" ? "Categorical" : curAxis == "schemaColumn" ? "Categorical" : curAxis == "rows" ? "Series" : curAxis == "schemaRow" ? "Series" : curAxis == "drag" ? "Slicer" : curAxis == "schemaFilter" ? "Slicer" : "";
                    if (axisName == "")
                        axisName = (this.element.find(".schemaRow .pivotButton:contains('Measures')").length > 0 || this.element.find(".schemaRow .pivotButton:contains('MEASURES')").length > 0) ? "Series" : "Categorical";
                    if (!ej.isNullOrUndefined(args.event)) {
                        var droppedPosition = this._setSplitBtnTargetPos(args.event);
                    }
                    else {
                        var droppedPosition = "";
                    }
                    var isFiltered = false;
                    if (this.model.pivotControl._tempFilterData != null)
                        $.each(this.model.pivotControl._tempFilterData, function (index, object) { $.each(object, function (key, value) { if (key == headerTag.replace(/[\[\]']/g, '') && value.length > 0) isFiltered = true; }); });
                    if (isFiltered)
                        $($(selectedTreeNode).find(".e-text")[0]).after(ej.buildTag("span.e-icon").addClass("filter")[0].outerHTML);

                    var params = this._currentCubeName + "--" + headerTag + "--" + axisName + "--" + droppedPosition, filterParams = "";
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.pivotControl.model.customObject });
                    var eventArgs = JSON.stringify({ "action": "nodeDropped", "dropType": "TreeNode", "nodeInfo": params, "filterParams": filterParams, "currentReport": report, "gridLayout": this.model.pivotControl.model.layout, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                    if (!this.model.pivotControl.model.enableDeferUpdate && !ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                        this.model.pivotControl._waitingPopup.show();
                    this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
                    if (!this.model.pivotControl.model.enableDeferUpdate)
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._droppedSuccess);
                    else {
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._droppedSuccess);
                    }
                }
            }
            this._setPivotBtnWidth();
        },

        _addTreeDropIcon: function (treeviewItem) {
            if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                if ($(args.currentElement).attr("tag").toLowerCase().indexOf("[measures]") < 0 && !($(args.currentElement).find(".namedSetCDB").length > 0)) treeviewItem.after(ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML);
            else
                treeviewItem.after(ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML);
        },

        _removeUndefinedFields: function (dropArgs) {
            for (var itm in dropArgs) { if ((itm == "droppedFieldFormat" || itm == "droppedFieldFormatString") && (ej.isNullOrUndefined(dropArgs[itm]) || dropArgs[itm] == "")) delete dropArgs[itm]; }
            return dropArgs;
        },

        _clientPivotCheckedStateModified: function (args) {
            ej.PivotAnalysis._valueSorting = null;
            if (this._isDropAction) return;
            var droppedFieldName = "", droppedFieldFormat = "", droppedFieldFormatString = "";
            if (!ej.isNullOrUndefined(this.model.pivotControl) && !ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                this.model.pivotControl._waitingPopup.show();
            if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    droppedFieldName = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.currentElement).attr("id"); })[0].name;
                    droppedFieldFormat = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.currentElement).attr("id"); })[0].format;
                    droppedFieldFormatString = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.currentElement).attr("id"); })[0].formatString;
                }
                else
                    droppedFieldName = $(args.currentElement).attr("tag");
            }
            else
                droppedFieldName = $(args.currentElement).find("a")[0].textContent;

            if (args.type == "nodeUncheck") {
                delete this.model.pivotControl._fieldMembers[droppedFieldName.toLowerCase()];
                delete this.model.pivotControl._fieldSelectedMembers[droppedFieldName.toLowerCase()];
                ej.Pivot.removeReportItem(this.model.pivotControl.model.dataSource, droppedFieldName, false);
                $(args.currentElement).removeClass("filter").find(".treeDrop,.filter").remove();
            }
            else {
                var droppedClass = "row";
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && $(args.currentElement).attr("tag").toLocaleLowerCase().indexOf("[measures]") >= 0) droppedClass = "value";
                if (this.model.pivotControl.model.analysisMode != ej.Pivot.AnalysisMode.Olap || ($(args.currentElement).attr("tag").toLowerCase().indexOf("[measures]") < 0 && $(args.currentElement).find(".namedSetCDB").length == 0))
                    $(args.currentElement.find(".e-text")).after(ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML);
                var droppedFieldCaption = $(args.currentElement).find("a")[0].textContent;
                var dropArgs = { droppedFieldName: droppedFieldName, droppedFieldCaption: droppedFieldCaption, droppedFieldFormat: droppedFieldFormat, droppedFieldFormatString: droppedFieldFormatString, droppedClass: droppedClass, droppedPosition: "", isMeasuresDropped: (droppedFieldName.toLocaleLowerCase().indexOf("measures") == 0) };
                this._removeUndefinedFields(dropArgs);
                ej.Pivot.addReportItem(this.model.pivotControl.model.dataSource, dropArgs);
            }
			if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                    ej.olap.base.clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "nodeDropped" }, this.model.pivotControl)
            this._refreshPivotButtons();
            this.model.pivotControl.refreshControl();
			this._setPivotBtnWidth();
        },

        _clientOnNodeDropped: function (args) {
            ej.PivotAnalysis._valueSorting = null;
            this._isDragging = false;
            var pivotDrop = false;
            var schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var buttonDrag = $(args.dropTarget).parents();
                for (var i = 0; i < buttonDrag.length; i++) {
                    if (buttonDrag[i].className.split(" ")[0] == "e-pivotgrid")
                        pivotDrop = true;
                }
            }
            var droppedFieldName = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? $.grep(this.model.pivotTableFields, function (item) { return item.name == args.droppedElement.attr("id") })[0].name : (args.droppedElement.attr("defaulthierarchy") || ($(args.droppedElement).find("a:eq(0) span[class^='level'],div[class*='level']").length>0 ? $(args.droppedElement).parents("li:eq(0)").attr("tag") : args.droppedElement.attr("tag")));
            var droppedFieldCaption = $(args.droppedElement).find("div:first").text();            
            var droppedClass = "";
            var droppedtItem = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? $.grep(this.model.pivotTableFields, function (item) { return item.name == args.droppedElement.attr("id") })[0] : null;
            var droppedFieldFormat = !ej.isNullOrUndefined(droppedtItem) ? droppedtItem.format : "";
            var droppedFieldFormatString = !ej.isNullOrUndefined(droppedtItem) ? droppedtItem.formatString : "";
            var droppedFieldShowSubTotal = !ej.isNullOrUndefined(droppedtItem) ? droppedtItem.showSubTotal : true;
            if ($(args.dropTarget).hasClass("pvtBtn") || $(args.dropTarget).hasClass("pivotButton"))
                droppedClass = $(args.dropTarget).parents('div.e-droppable').hasClass("schemaColumn") ? "column" : $(args.dropTarget).parents('div.e-droppable').hasClass("schemaRow") ? "row" : $(args.dropTarget).parents('div.e-droppable').hasClass("schemaFilter") ? "filter" : $(args.dropTarget).parents('div.e-droppable').hasClass("schemaValue") ? "value" : "";
            else
                var droppedClass = args.dropTarget.hasClass("schemaColumn") ? "column" : args.dropTarget.hasClass("schemaRow") ? "row" : args.dropTarget.hasClass("schemaFilter") ? "filter" : args.dropTarget.hasClass("schemaValue") ? "value" : "";
            if (pivotDrop) {
                if ($(args.dropTarget).prop("tagName") == "TH" || $(args.dropTarget).prop("tagName") == "TD")
                    droppedClass = $(args.dropTarget).hasClass("rowheader") || $(args.dropTarget).hasClass("grpRow") ? "row" : $(args.dropTarget).hasClass("colheader") ? "column" : $(args.dropTarget).hasClass("value") ? "value" : "";
                else
                    droppedClass = ($(args.dropTarget).hasClass("rows") || $(args.dropTarget).hasClass("emptyRows")) ? "row" : $(args.dropTarget).hasClass("columns") ? "column" : $(args.dropTarget).hasClass("values") ? "value" : $(args.dropTarget).hasClass("drag") ? "filter" : "";
            }
            if (droppedClass == "")
                return false;
            var droppedPosition = ej.isNullOrUndefined(args.event) ? "" : this._setSplitBtnTargetPos(args.event);
            //validating drop action
            var isPivotGrid = (($(args.dropTarget).hasClass("value") || $(args.dropTarget).hasClass("colheader") || $(args.dropTarget).hasClass("rowheader") || $(args.dropTarget).hasClass("summary")) || $(args.dropTarget).parents("table:eq(0)").hasClass("pivotGridTable") || $(args.dropTarget).parents(".groupingBarPivot").length > 0);
            if ((droppedFieldName.toLowerCase().indexOf("[measures]") >= 0 && droppedClass != "value") || (droppedFieldName == this._getLocalizedLabels("Measures") && droppedClass != "row" && droppedClass != "column") || (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && droppedFieldName.toLowerCase().indexOf("[measures]") < 0 && droppedClass == "value") || (isPivotGrid && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap)) {
                this._createErrorDialog();
                return;
            }
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                this.model.pivotControl._fieldMembers = {};
                this.model.pivotControl._fieldSelectedMembers = {};
                if (droppedFieldName.toLowerCase().indexOf("[measures") >= 0) {
                    this.model.pivotControl.model.dataSource.values[0].axis = droppedClass == "column" ? "columns" : droppedClass == "row" ? "rows" : this.model.pivotControl.model.dataSource.values[0].axis;
                    droppedClass = "value";
                }
            }
            if (!ej.isNullOrUndefined(pivotClientObj)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        schemaObj.model.pivotControl._waitingPopup.show();
                }, 800);
            }
            else
                this.model.pivotControl._waitingPopup.show();
            var dropArgs = { droppedFieldName: droppedFieldName, droppedFieldCaption: droppedFieldCaption, droppedFieldFormat: droppedFieldFormat, droppedFieldFormatString: droppedFieldFormatString, droppedFieldShowSubTotal: droppedFieldShowSubTotal, droppedClass: droppedClass, droppedPosition: droppedPosition, isMeasuresDropped: (droppedFieldName.toLocaleLowerCase().indexOf("measures") == 0) };
            this._removeUndefinedFields(dropArgs);
            ej.Pivot.addReportItem(this.model.pivotControl.model.dataSource, dropArgs);
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                ej.olap.base.clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "nodeDropped" }, this.model.pivotControl);
            if (this.model.pivotControl.element.hasClass("e-pivotclient") && this.model.pivotControl._pivotChart)
                this.model.pivotControl._pivotChart._labelCurrentTags = {};

            var droppedElement = args.droppedElement;
            this._isDropAction = true;
            if (droppedClass == "")
                this._tableTreeObj.uncheckNode(args.droppedElement);
            else {
                if ($(args.droppedElement).find(".treeDrop").length == 0 && this.element.parents(".e-pivotclient").length == 0 && (this.model.pivotControl.model.analysisMode != ej.Pivot.AnalysisMode.Olap || ($(args.droppedElement).attr("tag").toLowerCase().indexOf("[measures]") < 0 && $(args.droppedElement).find(".namedSetCDB").length == 0)))
                    $(args.droppedElement.find(".e-text")).after(ej.buildTag("span.e-icon").css("display", "none").addClass("treeDrop")[0].outerHTML);
                this._tableTreeObj.checkNode(args.droppedElement);
            }
            this._isDropAction = false;

            this._refreshPivotButtons();
            this.model.pivotControl.refreshControl();
            this._setPivotBtnWidth();
            if (!ej.isNullOrUndefined(pivotClientObj))
                if (pivotClientObj._isTimeOut) pivotClientObj._isTimeOut = false;
        },

        _clientOnPvtBtnDropped: function (args) {
			ej.PivotAnalysis._valueSorting = null;
            var schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!ej.isNullOrUndefined(this.model.pivotControl) && !ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                if (!ej.isNullOrUndefined(pivotClientObj)) {
                    pivotClientObj._isTimeOut = true;
                    setTimeout(function () {
                        if (pivotClientObj._isTimeOut && pivotClientObj.element.find(".errorDialog:visible").length == 0)
                            schemaObj.model.pivotControl._waitingPopup.show();
                    }, 800);
                }
            else
                this.model.pivotControl._waitingPopup.show();
            if ($(args.target).hasClass("removeClientPivotBtn"))
                args.target = $(args.target).parent();
            this._isDragging = false;
            $("#" + this._id + "_dragClone").remove();
            //Getting dropped item name
            var droppedField = "", droppedFieldFormat = "", droppedFieldFormatString = "";
            if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    droppedField = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.element).attr("fieldName"); })[0].name;
                    droppedFieldFormat = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.element).attr("fieldName"); })[0].format;
                    droppedFieldFormatString = $.grep(this.model.pivotTableFields, function (item) { return item.name == $(args.element).attr("fieldName"); })[0].formatString;
                }
                else
                    droppedField = $(args.element).attr("fieldName");
            }
            else
                droppedField = args.element.text();
            var droppedFieldCaption = args.element.text();
			if(!ej.isNullOrUndefined(this.model.pivotControl._fieldMembers)) {
				delete this.model.pivotControl._fieldMembers[droppedField.toLowerCase()];
				delete this.model.pivotControl._fieldSelectedMembers[droppedField.toLowerCase()];
			}
            //Getting dropped axis
            var droppedClass = "";
            if ($(args.target).hasClass("pvtBtn") || (this.element.parents(".e-pivotclient").length > 0 && $(args.target).hasClass("pivotButton")))
                droppedClass = $(args.target).parents('div.e-droppable').hasClass("schemaColumn") ? "column" : $(args.target).parents('div.e-droppable').hasClass("schemaRow") ? "row" : $(args.target).parents('div.e-droppable').hasClass("schemaFilter") ? "filter" : $(args.target).parents('div.e-droppable').hasClass("schemaValue") ? "value" : "";
            else
                droppedClass = $(args.target).hasClass("schemaColumn") ? "column" : $(args.target).hasClass("schemaRow") ? "row" : $(args.target).hasClass("schemaFilter") ? "filter" : $(args.target).hasClass("schemaValue") ? "value" : "";

            //validating drop action
            if ((droppedField.toLowerCase().indexOf("[measures]") >= 0 && droppedClass != "value" && (droppedClass == "row" || droppedClass == "column" || droppedClass == "filter")) || (droppedField == this._getLocalizedLabels("Measures") && droppedClass != "row" && droppedClass != "column" && (droppedClass == "value" || droppedClass == "filter")) || (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && droppedField.toLowerCase().indexOf("[measures]") < 0 && droppedClass == "value")) {
                this._createErrorDialog();
                args.element.removeClass("dragHover").parent().removeClass("dragHover");
                return;
            }
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl._calculatedField != null && droppedClass != "value" && $.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == droppedField; }).length > 0) {
                ej.Pivot._createErrorDialog(this.model.pivotControl._getLocalizedLabels("CalcValue"), this.model.pivotControl._getLocalizedLabels("Warning"), this);
                args.element.removeClass("dragHover").parent().removeClass("dragHover");
                this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
                this.model.pivotControl._waitingPopup.hide();
                return;
            }
            //Getting dropped position
            var droppedPosition =!ej.isNullOrUndefined(args.event)? this._setSplitBtnTargetPos(args.event):"";
            
            var dropArgs = { droppedFieldName: droppedField, droppedFieldCaption: droppedFieldCaption, droppedFieldFormat: droppedFieldFormat, droppedFieldFormatString: droppedFieldFormatString, droppedClass: droppedClass, droppedPosition: droppedPosition, isMeasuresDropped: (droppedField.toLocaleLowerCase().indexOf("measures") == 0) };
            this._removeUndefinedFields(dropArgs);
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && (droppedField == this._getLocalizedLabels("Measures") || droppedField == "[Measures]"))
                var measureItems = this.model.pivotControl.model.dataSource.values[0].measures;
            ej.Pivot.addReportItem(this.model.pivotControl.model.dataSource, dropArgs);
            if (this.model.pivotControl._calculatedField != null && this.model.pivotControl._calculatedField.length > 0 && droppedClass != "value") {
                var removeElement = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.isCalculatedField == true && value.formula.indexOf(droppedField) > -1; });
                for (var i = 0; i < removeElement.length; i++)
                    this._tableTreeObj.uncheckNode(removeElement[i].fieldName);
            }
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl._calculatedField != null && this.model.pivotControl._calculatedField.length > 0) {
                var calculatedField = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.isCalculatedField == true; });
                this.model.pivotControl.model.dataSource.values = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false; });
                $.merge(this.model.pivotControl.model.dataSource.values, calculatedField);
            }
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                this.model.pivotControl._fieldMembers = {};
                this.model.pivotControl._fieldSelectedMembers = {};
                ej.olap.base.clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "nodeDropped" }, this.model.pivotControl)
            }
            if (this.model.pivotControl.element.hasClass("e-pivotclient") && this.model.pivotControl._pivotChart)
                this.model.pivotControl._pivotChart._labelCurrentTags = {};
            if (droppedClass == "") {
                this._isDropAction = true;
                this._tableTreeObj.element.find("li[tag='" + droppedField + "']").removeClass("filter").find(".treeDrop,.filter").remove();
                if (!ej.isNullOrUndefined(measureItems)) {
                    var schema = this;
                    $.grep(measureItems, function (measureItem) { schema._tableTreeObj.uncheckNode(schema._tableTreeObj.element.find("li[tag='" + measureItem.fieldName + "']")); });
                }
                else
                    this._tableTreeObj.uncheckNode(this._tableTreeObj.element.find("li[tag='" + droppedField + "']"));
                this._isDropAction = false;
            }
            this._refreshPivotButtons();
            this.model.pivotControl.refreshControl();
			this._setPivotBtnWidth();
        },

        _refreshPivotButtons: function () {
            this.element.find(".axisTable .schemaFilter").html(this._createPivotButtons("filters", this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this.model.pivotControl.model.dataSource.filters : JSON.parse(this.model.pivotControl.getOlapReport()).Filters));
            this.element.find(".axisTable .schemaRow").html(this._createPivotButtons("rows", this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this.model.pivotControl.model.dataSource.rows : JSON.parse(this.model.pivotControl.getOlapReport()).PivotRows));
            this.element.find(".axisTable .schemaColumn").html(this._createPivotButtons("columns", this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this.model.pivotControl.model.dataSource.columns : JSON.parse(this.model.pivotControl.getOlapReport()).PivotColumns));
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.pivotControl.model.dataSource.values.length > 0 && (!ej.isNullOrUndefined(this.model.pivotControl.model.dataSource.values[0].measures)) && this.model.pivotControl.model.dataSource.values[0].measures.length > 0) {
                if (this.model.pivotControl.model.dataSource.values[0].axis == "columns")
                    this.element.find(".axisTable .schemaColumn").append(this._createPivotButtons("columns", [{ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }]));// this.model.pivotControl.model.dataSource.values[0].measures));
                else if (this.model.pivotControl.model.dataSource.values[0].axis == "rows")
                    this.element.find(".axisTable .schemaRow").append(this._createPivotButtons("rows", [{ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }]));// this.model.pivotControl.model.dataSource.values[0].measures));
            }
            this.element.find(".axisTable .schemaValue").html(this._createPivotButtons("values", this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this.model.pivotControl.model.dataSource.values : JSON.parse(this.model.pivotControl.getOlapReport()).PivotCalculations));
            
            if (this.model.enableDragDrop) {
                this.element.find(".pivotButton .pvtBtn").ejButton({ size: "normal", type: ej.ButtonType.Button, enableRTL: this.model.enableRTL }).ejDraggable({
                    handle: 'button', clone: true,
                    cursorAt: { left: -5, top: -5 },
                    dragStart: ej.proxy(function (args) {
                        this._isDragging = true;
                    }, this),
                    dragStop: ej.proxy(this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._pvtBtnDropped : this._clientOnPvtBtnDropped, this),
                    helper: ej.proxy(function (event, ui) {
                        $(event.element).addClass("dragHover");
                        if (event.sender.target.className.indexOf("e-btn") > -1) {
                            var btnClone = $(event.sender.target).clone().attr("id",this._id+"_dragClone").appendTo('body');
                            $("#"+this._id + "_dragClone").removeAttr("style").height($(event.sender.target).height());
                            return btnClone;            
                        }
                        else
                            return false;
                    }, this)
                });
            }
            if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.pivotControl.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne)
                this.element.find(".pvtBtn").css("max-width", this.element.find(".schemaColumn").width() - this.element.find(".removeClientPivotBtn").width() - 6);
            this._createContextMenu();
            if (this.model.pivotControl.model.isResponsive && this.model.pivotControl.model.enableSplitter && !ej.isNullOrUndefined(this.model.pivotControl.element.find(".splitresponsive").data("ejSplitter")))
                this.model.pivotControl.element.find(".splitresponsive").data("ejSplitter").refresh();
            this._setSplitButtonTitle();
            if (this.model.pivotControl.model.showUniqueNameOnPivotButton)
                $(".pvtBtnDiv").addClass("schemaBtnUnique");
            if(!(this.element.parents(".e-pivotclient").length > 0))
                this._setPivotBtnWidth();
        },

        _setSplitButtonTitle: function () {
            if (this.element.find(".pvtBtn").length > 0 && this._tableTreeObj != null)
            {
                for (var i = 0; i < this.element.find(".pvtBtn").length; i++) {
                    var fieldName = this.element.find(".pvtBtn:eq(" + i + ")").attr("fieldname");
                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        var dimenstionCaption = this._tableTreeObj.element.find("li[tag='" + fieldName + "']").parents("li:eq(0)").find("a:eq(0)").text();
                        var hierarchyCaption = this.element.find(".pvtBtn:eq(" + i + ")").text();
                        if (fieldName.toLowerCase().indexOf("measures") >= 0)
                            this.element.find(".pvtBtn:eq(" + i + ")").attr("title", hierarchyCaption);
                        else
                            this.element.find(".pvtBtn:eq(" + i + ")").attr("title", dimenstionCaption + " - " + hierarchyCaption);
                    }
                    else
                        this.element.find(".pvtBtn:eq(" + i + ")").attr("title", $.grep(this.model.pivotTableFields, function (item) { return item.id == fieldName; })[0].caption);
                }
            }
        },

        _createPivotButtons: function (axis, items) {
            var rowBtns = "";
            var btnAxis = axis;
            if (!ej.isNullOrUndefined(this.model.pivotControl) && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                if (axis == "values" && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) items = $.map(items, function (obj, index) { return obj["measures"]; });
                for (var i = 0; i < items.length; i++) {
                    var buttonId = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? "" : items[i].fieldName;
                    var fldName = $.grep(this.model.pivotTableFields, function (item) { return item.name == items[i].fieldName; }),
					fldCaption = $.grep(this.model.pivotTableFields, function (item) { return item.name == items[i]; });
                    if (fldName.length > 0)
                        fldName = fldName[0].caption;
                    if (fldCaption.length > 0)
                        fldCaption = fldCaption[0].caption;
                    var filterState = "";
                    var olapClientMode = (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) ? true : false;
                    var members = olapClientMode ? "" : ej.PivotAnalysis.getMembers(items[i].fieldName);
                    var filtered = (items[i].filterItems != null && items[i].filterItems.values.length > 0) ? "filtered" : "";
                    if (axis == "filters") {
                        if (filtered == "filtered") {
                            filterState = ej.Pivot._getFilterState(olapClientMode, members, items[i], this.model.pivotControl);
                        }
                        else if (olapClientMode) {
                            ej.olap._mdxParser.getAllMember(this.model.pivotControl.model.dataSource, items[i].fieldName, this.model.pivotControl);
                            filterState = this.model.pivotControl._allMember;
                        }
                        else
                            filterState = this.model.pivotControl._getLocalizedLabels("All");
                    }
                    rowBtns += ej.buildTag("div.pivotButton",
                                    ej.buildTag("div.dropIndicator")[0].outerHTML +
                                    ($(this.element).parents(".e-pivotclient").length > 0 ? (ej.buildTag("button.pvtBtn#pivotButton" + buttonId, (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? (this.model.pivotControl.model.showUniqueNameOnPivotButton ? (axis != "values" ? (items[i].fieldName.replace(/\[/g, '').replace(/\]/g, '')) : (items[i].fieldCaption != undefined ? items[i].fieldCaption : items[i].fieldName) || items[i]) : (items[i].fieldCaption != undefined ? items[i].fieldCaption : items[i].fieldName) || items[i]) : fldName || fldCaption) + (axis == "filters" && filterState != "" ? " (" + filterState + ")" : ""), {}, { "fieldName": items[i].fieldName || items[i], "fieldCaption": items[i].fieldCaption || items[i].fieldName, "axis": axis })[0].outerHTML) : (ej.buildTag("div.pvtBtnDiv", ej.buildTag("button.pvtBtn#pivotButton" + buttonId, (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? (this.model.pivotControl.model.showUniqueNameOnPivotButton ? (axis != "values" ? (items[i].fieldName.replace(/\[/g, '').replace(/\]/g, '')) : (items[i].fieldCaption != undefined ? items[i].fieldCaption : items[i].fieldName) || items[i]) : (items[i].fieldCaption != undefined ? items[i].fieldCaption : items[i].fieldName) || items[i]) : fldName || fldCaption) + (axis == "filters" && filterState != "" ? " (" + filterState + ")" : ""), {}, { "fieldName": items[i].fieldName || items[i], "fieldCaption": items[i].fieldCaption || items[i].fieldName, "axis": axis })[0].outerHTML).attr("tag", axis + ":" + items[i].fieldName)[0].outerHTML)) +
                                    ej.buildTag("span." + (this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne ? "removeClientPivotBtn" : "removePivotBtn"), {}, { "display": (this.model.layout != ej.PivotSchemaDesigner.Layouts.OneByOne ? "none" : "inline-block") }).addClass("e-icon")[0].outerHTML).attr("tag", axis + ":" + items[i].fieldName || items[i])[0].outerHTML;
                }
            }
            else {
                //if (axis == "values" && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) items = $.map(items, function (obj, index) { return obj["measures"]; });
                if (axis == "values") {
                    var axis = this.element.find(".pivotButton:contains(" + this._getLocalizedLabels("Measures") + ")").length > 0 ? this.element.find(".pivotButton:contains('" + this._getLocalizedLabels("Measures") + "')").parent()[0].className.split(" ")[0] : "schemaColumn";
                    axis = axis == "schemaColumn" ? "columns" : "rows";
                }
                for (var i = 0; i < items.length; i++) {
                    var filterState = "";
                    if (!ej.isNullOrUndefined(this.model.pivotControl) && (axis == "filters" || axis == "slicers")) {
                        filterState = ej.Pivot._getFilterState("", [], items[i], this.model.pivotControl);
                        axis = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? "slicers" : axis;
                    }                   

                    rowBtns += ej.buildTag("div.pivotButton",
                                ej.buildTag("div.dropIndicator")[0].outerHTML +
                                ($(this.element).parents(".e-pivotclient").length > 0 ? (ej.buildTag("button.pvtBtn#pivotButton" + (items[i].FieldHeader || items[i].FieldName || items[i].DimensionHeader || items[i].DimensionName || items[i].Name), ((this.model.pivotControl.model.showUniqueNameOnPivotButton ? (axis != "values" ? items[i].Tag : (items[i].FieldHeader || items[i].FieldName || items[i].DimensionHeader || items[i].DimensionName || items[i].Name)) : (items[i].FieldHeader || items[i].FieldName || items[i].DimensionHeader || items[i].DimensionName || items[i].Name)) + ((axis == "filters" || axis == "slicers") && filterState != "" ? " (" + filterState + ")" : "")), {}, { "fieldName": items[i].FieldName || items[i].DimensionName || items[i].FieldHeader || items[i].DimensionHeader || items[i].Name || items[i], "fieldCaption": items[i].FieldHeader || items[i].DimensionHeader || items[i].FieldName || items[i].DimensionName, "axis": axis })[0].outerHTML) : (ej.buildTag("div.pvtBtnDiv", ej.buildTag("button.pvtBtn#pivotButton" + (items[i].FieldHeader || items[i].FieldName || items[i].DimensionHeader || items[i].DimensionName || items[i].Name), ((this.model.pivotControl.model.showUniqueNameOnPivotButton ? (btnAxis != "values" ? items[i].Tag : (items[i].FieldHeader || items[i].FieldName || items[i].DimensionHeader || items[i].DimensionName || items[i].Name)) : (items[i].FieldHeader || items[i].FieldName || items[i].DimensionHeader || items[i].DimensionName || items[i].Name)) + ((axis == "filters" || axis == "slicers") && filterState != "" ? " (" + filterState + ")" : "")), {}, { "fieldName": items[i].FieldName || items[i].DimensionName || items[i].FieldHeader || items[i].DimensionHeader || items[i].Name || items[i], "fieldCaption": items[i].FieldHeader || items[i].DimensionHeader || items[i].FieldName || items[i].DimensionName, "axis": axis })[0].outerHTML).attr("tag", axis + ":" + items[i].Tag)[0].outerHTML)) +
                                ej.buildTag("span." + (this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne ? "removeClientPivotBtn" : "removePivotBtn"), {}, { "display": (this.model.layout != ej.PivotSchemaDesigner.Layouts.OneByOne ? "none" : "inline-block") }).addClass("e-icon")[0].outerHTML).attr("tag", axis + ":" + items[i].Tag)[0].outerHTML;
                }
            }
            return rowBtns;
        },

        _pvtBtnDropped: function (args) {
            this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
            $(args.element).parent().removeClass("dragHover");
            $(args.element).removeClass("dragHover");
            $("#" + this._id + "_dragClone").remove();
            var headerTag = "";
            this._isDragging = false;
            if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                if($(args.target).hasClass("pivotButton"))
                    args.target = args.target.childNodes[1];
                var droppedClass = !ej.isNullOrUndefined(args.target.className.indexOf) ?  ($(args.target).attr("class")  ? args.target.className.indexOf("e-droppable") >= 0 ? args.target.className.split(" ")[0] : (args.target.className.split(" ")[0] == "pvtBtn" ? $(args.target).parents('div.e-droppable').attr("class").split(" ")[0] : "") : ""):"";
                var headerText = args.element.attr("fieldcaption") || args.element.attr("fieldname"), report;
                var headerName = args.element.parent().attr("tag").split(":")[1];
                var droppedPosition = ej.isNullOrUndefined(args.event) ? "" : this._setSplitBtnTargetPos(args.event);
                for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                    if (this.model.pivotTableFields[i].name == headerText) {
                        this.model.pivotTableFields[i].isSelected = true;
                        headerTag = this.model.pivotTableFields[i];
                        break;
                    }
                }
                try { report = JSON.parse(this.model.pivotControl.getOlapReport()).Report; }
                catch (err) { report = this.model.pivotControl.getOlapReport(); }
                if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                    this.model.pivotControl._waitingPopup.show();
                if (droppedClass == "") {
                    delete this.model.pivotControl._fieldMembers[headerName];
                    delete this.model.pivotControl._fieldSelectedMembers[headerName];
                }
                var eventArgs = JSON.stringify({ "action": this.model.pivotControl.model.enableDeferUpdate ? "nodeDroppedDeferUpdate" : "nodeDropped", "args": JSON.stringify({ "droppedFieldCaption": headerText, "droppedFieldName": headerName, "headerTag": headerTag, "dropAxis": droppedClass, "droppedPosition": droppedPosition, "currentReport": report, "sortedHeaders": !ej.isNullOrUndefined(this.model.pivotControl._ascdes) ? this.model.pivotControl._ascdes : "" }), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._pvtNodeDroppedSuccess);
                return;
            }
            this.model.pivotControl._isUpdateRequired = true;
            this._isDragging = false;
            var axis = null, axisName = "", headerText, droppedClass, isFiltered = isFiltered = args.element.find("~ .filtered").length > 0 ? true : false, isSorted = false;
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if (!ej.isNullOrUndefined(args.target.className)) {
                    axis = args.target.className.indexOf("pvtBtn") > -1 ? $(args.target).parents(".e-droppable")[0] : args.target.className.indexOf("e-droppable") ? args.target : args.target[0].tagName.toLowerCase() == "td" ? args.target.children(":last")[0] : args.target;
                }
                else {
                    axis = args.target;
                }
                if (!ej.isNullOrUndefined(axis.className)) {
                    axisName = axis.className.split(" ")[0] == "schemaColumn" ? "Categorical" : axis.className.split(" ")[0] == "schemaRow" ? "Series" : axis.className.split(" ")[0] == "schemaFilter" ? "Slicer" : "";
                    droppedClass = axis.className.split(" ")[0];
                }
                else {
                    axisName = axis.hasClass("schemaColumn") ? "Categorical" : axis.hasClass("schemaRow") ? "Series" : axis.hasClass("schemaFilter") ? "Slicer" : "";
                    this._droppedClass = droppedClass = axis.hasClass("schemaColumn") ? "schemaColumn" : axis.hasClass("schemaRow") ? "schemaRow" : axis.hasClass("schemaFilter") ? "schemaFilter" : axis.hasClass("schemaValue") ? "schemaValue" : "";
                }
                if (axisName == "" && args.element.parent().attr("tag").toLowerCase().indexOf("[measures]") > -1)
                    axisName = this.element.find(".schemaRow .pivotButton:contains('" + this._getLocalizedLabels("Measures") + "')").length > 0 ? "Series" : "Categorical";
                this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? (headerText = headerTag = $(args.element.parent()[0]).attr("tag").split(":")[1]) : headerTag = $(args.element.parent()[0]).attr("tag");
            }
            else {
                if (!ej.isNullOrUndefined(args.target.className)) {
                    droppedClass = args.target.className.indexOf("e-droppable") >= 0 ? args.target.className.split(" ")[0] : (args.target.className.split(" ")[0] == "pvtBtn" ? $(args.target).parents('div.e-droppable').attr("class").split(" ")[0] : "");
                }
                else {
                    droppedClass = $(args.target).hasClass("schemaColumn") ? "schemaColumn" : $(args.target).hasClass("schemaRow") ? "schemaRow" : $(args.target).hasClass("schemaFilter") ? "schemaFilter" : $(args.target).hasClass("schemaValue") ? "schemaValue" : "";
                }
                headerText = this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode ? $.grep(this.model.pivotTableFields, function (item) { return item.caption == args.element.text(); })[0].name : args.element.attr("fieldCaption"), headerTag, isFiltered = args.element.find("~ .filterIndicator").length > 0 ? true : false,
                isSorted = args.element.find("~ span:eq(0) span.descending").length > 0 ? true : false;
                for (var i = 0; i < this.model.pivotTableFields.length; i++) {
                    if (this.model.pivotTableFields[i].name == headerText) {
                        this.model.pivotTableFields[i].isSelected = true;
                        headerTag = this.model.pivotTableFields[i];
                    }
                }
            }
            if (this._dataModel == "Olap") {
                if ((headerTag.split(":")[1].toLocaleUpperCase() == "MEASURES" && (droppedClass != "schemaColumn" || droppedClass != "schemaRow") && (droppedClass == "schemaFilter" || droppedClass == "schemaValue")) || (headerTag.toUpperCase().indexOf("[MEASURES]") > -1 && droppedClass != "schemaValue" && (droppedClass == "schemaRow" || droppedClass == "schemaColumn" || droppedClass == "schemaFilter"))) {
                    this._createErrorDialog();
                    return false;
                }
                else if (headerTag.toUpperCase().indexOf("[MEASURES]") == -1 && droppedClass == "schemaValue") {
                    this._createErrorDialog();
                    return false;
                }
            }
            if (droppedClass == "schemaValue" || droppedClass == "schemaRow" || droppedClass == "schemaColumn" || droppedClass == "schemaFilter") {
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode && this._dataModel == "Pivot" && droppedClass != "schemaValue" && ($.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == headerText; }).length > 0 || $.grep(JSON.parse(this.model.pivotControl.getOlapReport()).PivotCalculations, function (value) { return value.FieldHeader == headerText && value.CalculationType == 8; }).length > 0)) {
                    this.model.pivotControl._createErrorDialog(this.model.pivotControl._getLocalizedLabels("CalcValue"), this.model.pivotControl._getLocalizedLabels("Warning"));
                    return;
                }
                if (!ej.isNullOrUndefined(args.event)) {
                    var droppedPosition = this._setSplitBtnTargetPos(args.event), params, report, eventArgs;
                }
                else {
                    var droppedPosition = "", params, report, eventArgs;
                }
                try {
                    report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
                }
                catch (err) {
                    if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                    report = this.model.pivotControl.getOlapReport();
                }
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    this.model.pivotControl.dataSource = this.model.pivotControl._clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "nodeDropped" });
                    var isNamedSet = droppedClass == "schemaFilter" && (this.model.pivotControl._getNodeByUniqueName(headerText) != null && this.model.pivotControl._getNodeByUniqueName(headerText).find(".namedSetCDB").length > 0);
                    var isMeasures = ($(args.element.parent()).attr("tag").split(":")[0] == "Columns" && this._droppedClass == "schemaColumn" && headerTag.toLowerCase() == "measures") || ($(args.element.parent()).attr("tag").split(":")[0] == "Rows" && this._droppedClass == "schemaRow" && headerTag.toLowerCase() == "measures")
                    if (isMeasures || isNamedSet || headerText.toLowerCase().indexOf("[measures]") >= 0 && droppedClass != "schemaValue" || (droppedClass == "schemaValue" && !(headerText.toLowerCase().indexOf("[measures]") >= 0)) || (droppedClass == "schemaFilter" && headerText.toLowerCase().indexOf("measures") >= 0)) {
                        this._waitingPopup.hide();
                        if (!isMeasures)
                            this._createErrorDialog();
                        return args.Cancel;
                    }
                    else if (headerText.toLowerCase().indexOf(("measures")) >= 0 && (!(headerText.toLowerCase().indexOf("[measures]") >= 0))) {
                        $(args.element.parent().parent()).remove();
                        this.model.pivotControl.model.dataSource.values[0]["axis"] = droppedClass == "schemaRow" ? "rows" : droppedClass == "schemaColumn" ? "columns" : "columns";
                        this._createPivotButton({ fieldName: "Measures", fieldCaption: this._getLocalizedLabels("Measures") }, droppedClass == "schemaRow" ? "row" : droppedClass == "schemaColumn" ? "column" : "column", "", "", droppedPosition);
                        ej.olap.base.getJSONData({ action: "nodeDropped" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                        this._waitingPopup.hide();
                        this._setPivotBtnWidth();
                        return false;
                    }
                }
                if (this.model.pivotControl._dataModel == "Pivot" && droppedClass != "schemaValue" && $.grep(this.model.pivotControl._calculatedField, function (value) { return value.name == headerText; }).length > 0) {
                    alert(this.model.pivotControl._getLocalizedLabels("CalcValue"));
                    return;
                }
                $(args.element.parent().parent()).remove();
                if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    if (!this.model.pivotControl.model.enableDeferUpdate && !ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                        this.model.pivotControl._waitingPopup.show();
                    this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        params = this._currentCubeName + "--" + headerTag + "--" + axisName + "--" + droppedPosition;
                        if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                            this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.pivotControl.model.customObject });
                        eventArgs = JSON.stringify({ "action": "nodeDropped", "dropType": "SplitButton", "nodeInfo": params, "currentReport": report, "gridLayout": this.model.pivotControl.model.layout, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                        if (!this.model.pivotControl.model.enableDeferUpdate)
                            this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._droppedSuccess);
                        else {
                            this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._droppedSuccess);
                        }
                    }
                    else {
                        this._createPivotButton({fieldName : args.element.attr("fieldName"), fieldCaption :  args.element.attr("fieldCaption")}, droppedClass == "schemaRow" ? "row" : droppedClass == "schemaColumn" ? "column" : droppedClass == "schemaFilter" ? "filter" : droppedClass == "schemaValue" ? "value" : "", isFiltered, isSorted, droppedPosition);
                        if (!ej.isNullOrUndefined(this.model.pivotControl._calculatedField) && this.model.pivotControl._calculatedField.length > 0 && droppedClass != "schemaValue")
                            this.model.pivotControl._calculatedFieldNodeRemove(headerTag);
                        if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                            this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.pivotControl.model.customObject });
                        var filterParams = "";
                        filterParams = ej.Pivot._getFilterParams(droppedClass, this._tempFilterData, headerText);
                        eventArgs = JSON.stringify({ "action": "nodeDropped", "dropAxis": droppedClass + "::" + droppedPosition, "filterParams": filterParams, "headerTag": JSON.stringify(headerTag), "sortedHeaders": this.model.pivotControl._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.pivotControl.model.valueSortSettings), "customObject": JSON.stringify(this.model.pivotControl.model.customObject) });
                        var successMethod = this.model.pivotControl._renderControlSuccess;
                        if (!this.model.pivotControl.model.enableDeferUpdate)
                            this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs, this._pvtNodeDroppedSuccess);
                        else {
                            this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.nodeDropped, eventArgs.replace("nodeDropped", "nodeDroppedDeferUpdate"), this._pvtNodeDroppedSuccess);
                            if (!ej.isNullOrUndefined(this.model.pivotControl._ogridWaitingPopup))
                                this.model.pivotControl._ogridWaitingPopup.hide();
                        }
                    }
                }
                else {
                    var droppedItem = this.model.pivotControl._getDroppedItem(headerText), buttonFields = {};

                    if (droppedItem.length > 0) {
                        buttonFields = (droppedItem[0]["isNamedSets"] != undefined) ? { fieldName: droppedItem[0].fieldName, fieldCaption: droppedItem[0].fieldCaption, isNamedSets: droppedItem[0]["isNamedSets"] } : { fieldName: droppedItem[0].fieldName, fieldCaption: droppedItem[0].fieldCaption };
                    }
                    var dropAxis = droppedClass == "schemaRow" ? "row" : droppedClass == "schemaColumn" ? "column" : droppedClass == "schemaFilter" ? "filter" : droppedClass == "schemaValue" ? "value" : "";
                    this._createPivotButton(buttonFields, dropAxis, isFiltered, isSorted, droppedPosition);
                    if ($.isNumeric(droppedPosition))
                        droppedClass == "schemaRow" ? this.model.pivotControl.model.dataSource.rows.splice(droppedPosition, 0, droppedItem[0]) : droppedClass == "schemaColumn" ? this.model.pivotControl.model.dataSource.columns.splice(droppedPosition, 0, droppedItem[0]) : droppedClass == "schemaValue" ?
                            (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) ? this.model.pivotControl.model.dataSource.values[0]["measures"].splice(droppedPosition, 0, droppedItem[0]) : this.model.pivotControl.model.dataSource.values.splice(droppedPosition, 0, droppedItem[0]) : this.model.pivotControl.model.dataSource.filters.splice(droppedPosition, 0, droppedItem[0]);
                    else
                        droppedClass == "schemaRow" ? this.model.pivotControl.model.dataSource.rows.push(droppedItem[0]) : droppedClass == "schemaColumn" ? this.model.pivotControl.model.dataSource.columns.push(droppedItem[0]) : droppedClass == "schemaValue" ? (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) ? this.model.pivotControl.model.dataSource.values[0]["measures"].push(droppedItem[0]) : this.model.pivotControl.model.dataSource.values.push(droppedItem[0]) : this.model.pivotControl.model.dataSource.filters.push(droppedItem[0]);

                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl._calculatedField.length > 0 && droppedClass != "schemaValue") {
                        var removeElement = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return (ej.isNullOrUndefined(value.isCalculatedField) || value.isCalculatedField == false) || (value.isCalculatedField == true && value.formula.indexOf(droppedItem[0].fieldName) == -1); });
                        var schemaRemoveElement = $.grep(this.model.pivotControl.model.dataSource.values, function (value) { return value.isCalculatedField == true && value.formula.indexOf(droppedItem[0].fieldName) > -1; });
                        for (var i = 0; i < schemaRemoveElement.length; i++)
                            this._tableTreeObj.uncheckNode(schemaRemoveElement[i].fieldName);
                        this.model.pivotControl.model.dataSource.values = removeElement;
                    }

                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        var measuresAxis = this.model.pivotControl.model.dataSource.values[0]["axis"] == "columns" ? "Columns:" : "Rows:";
                        var measureElement = (this.element.find("div[tag='" + measuresAxis + "Measures" + "']:first"));
                        measureElement.appendTo(measureElement.parent());
                        var dragAxis = args.element.attr("axis").toLowerCase();
                        this.model.pivotControl.model.dataSource = this.model.pivotControl._clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "nodeDropped" });
                    }

                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        if (!ej.isNullOrUndefined(this.model.pivotControl._ogridWaitingPopup))
                            this.model.pivotControl._ogridWaitingPopup.show();
                        ej.olap.base.getJSONData({ action: "nodeDropped" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                    }
                    else {
                        this._trigger("fieldItemDropped", { axis: dropAxis, fieldItem: droppedItem });
                        this.model.pivotControl.model.editCellsInfo = {};
                        this.model.pivotControl._populatePivotGrid();
                    }
                }
            }
            else
                this._removePvtBtn(args);
            this._setPivotBtnWidth();
        },

        _createErrorDialog: function () {
            ej.Pivot.openPreventPanel(this);
            if (this.element.find(".errorDialog").length == 0) {
                var dialogElem = ej.buildTag("div.errorDialog#ErrorDialog", ej.buildTag("div.warningImg")[0].outerHTML + ej.buildTag("div.warningContent", this._getLocalizedLabels("AlertMsg"))[0].outerHTML + ej.buildTag("div", ej.buildTag("button#ErrOKBtn.errOKBtn", "OK")[0].outerHTML)[0].outerHTML).attr("title", this._getLocalizedLabels("Warning"))[0].outerHTML;
                this.element.append(dialogElem);
                this.element.find(".errorDialog").ejDialog({ target: "#" + this._id, enableResize: false, enableRTL: this.model.enableRTL, width: "400px", close: ej.proxy(ej.Pivot.closePreventPanel, this) });
                this._errorDialog = this.element.find(".errorDialog").data("ejDialog");
                this.element.find(".errOKBtn").ejButton({ type: ej.ButtonType.Button, click: ej.proxy(this._errOKBtnClick, this) });
                this.element.find(".e-dialog .e-close").attr("title", this._getLocalizedLabels("Close"));
            }
            else {
                this._errorDialog.open();
            }
        },

        _errOKBtnClick: function (args) {
            ej.Pivot.closePreventPanel(this);
            this._errorDialog._ejDialog.find("div.e-dialog-icon").trigger("click");
        },

        _hideSchemaDesigner: function (args) {
            $("#" + this._id).animate({ left: "-" + $("#" + this._id).width() + "px" }, 500, function () {
            });
            this.element.find(".collapseSchema").addClass("expandSchema").removeClass("collapseSchema");
        },

        _showSchemaDesigner: function (args) {
            $("#" + this._id).animate({ left: "5px" });
            this.element.find(".expandSchema").addClass("collapseSchema").removeClass("expandSchema");
        },
        _reSizeHandler: function (args) {
            if(this.model.pivotControl){
            var axisTblWidth = $("#" + this._id).width();
            if (this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne) {
               

                this.element.find(".axisTd1, .axisTd2").css({ "width": "100%" });
                
                if (!this._pivotClientObj.model.isResponsive) {
                    var schemaWidth = this._pivotClientObj.element.find("#" + this._id).width() / 2;
                    this._pivotClientObj.element.find("div.fieldTable").width(schemaWidth - 6);
                    this._pivotClientObj.element.find("div.axisTable").width(schemaWidth - 5);
                }
                if (this._pivotClientObj.model.isResponsive)
                    this._pivotClientObj.element.find("div.axisTable").css({ "width":"52%"});
            }
            else {
                this.element.find("div.axisTable").width(axisTblWidth);
                var axisTdwidth = (axisTblWidth - 2) / 2;
                this.element.find(".axisTd1, .axisTd2").css({ "width": axisTdwidth });
            }
            var sFldHeight = (ej.PivotSchemaDesigner.Layouts.OneByOne == this.model.layout) ? this._pivotClientObj.element.find(".controlPanel").height() - 15 : (25 / 100) * $("#" + this._id).height();

            if (this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne)
                sFldHeight = (this.element.find(".cubelists").length > 0) ? (sFldHeight - 27) : sFldHeight + 5;
            this.element.find("div.parentSchemaFieldTree, .schemaFieldTree, div.fieldTable").height(sFldHeight);
           
            if (this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne)
                this.element.find("div.schemaFieldTree").height(sFldHeight-35);
               
            if (!($(this.element).parents(".e-pivotclient").length > 0)) {
                if ($("#" + this._id).height() < 450) {
                    $("#" + this._id).css("min-height", "450px");
                }
                if ($("#" + this._id).width() < 240) {
                    $("#" + this._id).css("min-width", "240px");
                }
            }

            var axisTblHeight, axisTrHeight;
            var pivotSchemaHeight = $(this.element).parents(".e-pivotclient").length > 0 ? this._pivotClientObj.element.find(".controlPanel").height()-10 : $("#" + this._id).height() + 20;
            var axisRemainingHeight = (ej.PivotSchemaDesigner.Layouts.OneByOne == this.model.layout) ? 0 : this.element.find("table.headerTable").height() + this.element.find("div.fieldTable").height() + this.element.find("div.centerDiv").height() + this.element.find("div.centerHead").height();
            if (this.model.pivotControl != null && (!this.model.pivotControl.element.hasClass("e-pivotclient")) && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                axisTblHeight = pivotSchemaHeight - (axisRemainingHeight + 105);
            else if (ej.PivotSchemaDesigner.Layouts.OneByOne == this.model.layout)
                axisTblHeight = pivotSchemaHeight;
            else 
                axisTblHeight = pivotSchemaHeight - (axisRemainingHeight + 80);
            this.element.find("div.axisTable").height(axisTblHeight);
            axisTrHeight = (axisTblHeight / ((this.model.layout == ej.PivotSchemaDesigner.Layouts.OneByOne) ? 4 : 2));
            this.element.find(".axisTd1,.axisTd2").css({ "height": axisTrHeight });
            if ($(this.element).parents(".e-pivotclient").length > 0) {
                this._pivotClientObj.element.find(".schemaColumn, .schemaValue").height(axisTrHeight - 28);
                this._pivotClientObj.element.find(".schemaRow, .schemaFilter").height(axisTrHeight - 28);
            }
            this._setPivotBtnWidth();
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var treeList = $(".schemaFieldTree ul>li div").width();
                $($(".e-pivotschemadesigner .schemaFieldTree.e-treeview .e-text")).each(function (e) {
                    var percent = ((treeList - (50)) / treeList) * 100;
                    $(this).width(percent.toString() + "%");
                });
            }
			}
        },

        _clientDialogBtnClick: function (args) {
            var selectedNodes = [], unSelectedNodes = [], pivotObj = this.model.pivotControl, hierarchyUQName = this._selectedFieldName, getTreeNodeState = {}, reportItem, me = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            this.element.find(".e-dialog, .clientDialog").hide();
            this.element.find("#preventDiv").remove();
            if (args.model.text.toLowerCase() == "cancel")
                return;
            if (!ej.isNullOrUndefined(pivotClientObj)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        me.model.pivotControl._waitingPopup.show();
                }, 800);
            }
            else
                pivotObj._waitingPopup.show();
            if (pivotObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if (pivotObj.element.hasClass("e-pivotclient") && !ej.isNullOrUndefined(pivotObj._pivotChart))
                    pivotObj._pivotChart._labelCurrentTags = {};
                ej.olap.base.clearDrilledItems(pivotObj.model.dataSource, { action: "filtering" }, pivotObj)

                this._memberTreeObj = ej.Pivot.updateTreeView(this);      
                var hierarchyName = this._selectedFieldName, currentDataSrc = pivotObj.model.dataSource, filterIndex = {};
                pivotObj._currentReportItems = $.map(pivotObj._currentReportItems, function (obj, index) {
                    if (obj["fieldName"] == hierarchyName && (ej.isNullOrUndefined(obj.dataSrc)|| (obj.dataSrc.cube == currentDataSrc.cube && obj.dataSrc.reportName == currentDataSrc.reportName))) {
                        filterIndex = obj.filterItems;
                        obj.filterItems = me._memberTreeObj.dataSource();
                    }
                    return obj;
                });
                getTreeNodeState = ej.Pivot.getNodesState(!ej.isNullOrUndefined(pivotObj) && pivotObj.model.enableMemberEditorPaging ? this._editorTreeData : this._memberTreeObj);
                var member = ej.Pivot._getEditorMember(hierarchyName.toLocaleLowerCase(), pivotObj, true), selMem = "selectedNodes", ftype="include", isMondrian = pivotObj.model.dataSource.providerName == "mondrian";
                pivotObj._fieldSelectedMembers[hierarchyName.toLocaleLowerCase()] = $.map(pivotObj._fieldMembers[hierarchyName.toLocaleLowerCase()], function (item) { if (!item.checked) return item }).length == 0 ? "All" : ((member != "All" && member != "multiple") ? member : pivotObj._getLocalizedLabels("MultipleItems"));                
                reportItem = ej.Pivot.getReportItemByFieldName(this._selectedFieldName, pivotObj.model.dataSource, this._dataModel)["item"];
                if (isMondrian) {
                    selMem = "unSelectedNodes";
                    ftype = "exclude";
                }
                selectedNodes = $.map(getTreeNodeState[selMem].split("::"), function (element, index) { { return { Id: element.split("||")[0], tag: element.split("||")[1], parentId: element.split("||")[2] } } });
                if (!ej.isNullOrUndefined(pivotObj._selectedNodes)) {
                    for (var i = 0; i < pivotObj._selectedNodes.length; i++) {
                        var selectedTreeNode = pivotObj._selectedNodes[i],
                        sameTreeEle = $.map(selectedNodes, function (item, index) { if (selectedTreeNode.tag == item.tag) return item });
                        if (sameTreeEle.length == 0)
                            selectedNodes.push(pivotObj._selectedNodes[i]);
                    }
                }
                if (!ej.isNullOrUndefined(reportItem)) {
                    reportItem["advancedFilter"] = [];
                    reportItem.filterItems = { filterType: ftype, values: ej.Pivot.removeParentSelectedNodes(selectedNodes) };
                    this._selectedTreeNode = this.element.find(".schemaFieldTree").find("li[tag='" + reportItem.fieldName + "']");
                    if ($(this._selectedTreeNode).parents("li:eq(0) span:eq(0)").hasClass("hierarchyCDB"))
                        this._selectedTreeNode = $(this._selectedTreeNode).parents("li:eq(0)");
                    if (getTreeNodeState["unSelectedNodes"] != "") {
                        if (!isMondrian)
                            pivotObj.model.dataSource = ej.olap.base.clearDrilledItems(pivotObj.model.dataSource, { action: "filtering" }, pivotObj);
                        if ($(this._selectedTreeNode).find(".filter").length <= 0) {
                            $($(this._selectedTreeNode).find(".e-text")[0]).after(ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filtered").addClass("filter")[0].outerHTML);
                            this.element.find(".pivotButton:contains('" + this._selectedFieldName + "') .filter").addClass("filtered");
                            this.element.find(".pvtBtn[fieldname='" + this._selectedFieldName + "']").parent().find(".filter").addClass("filtered");
                        }
                    }					
                    else if (pivotObj._unSelectedNodes) {
                        if (!isMondrian)
                            pivotObj.model.dataSource = ej.olap.base.clearDrilledItems(pivotObj.model.dataSource, { action: "filtering" }, pivotObj);
                        if ($(this._selectedTreeNode).find(".filter").length <= 0) {
                            $($(this._selectedTreeNode).find(".e-text")[0]).after(ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filtered").addClass("filter")[0].outerHTML);
                            this.element.find(".pivotButton:contains('" + this._selectedFieldName + "') .filter").addClass("filtered");
                            this.element.find(".pvtBtn[fieldname='" + this._selectedFieldName + "']").parent().find(".filter").addClass("filtered");
                        }
                    }
                    else {
                        this.element.find(".pvtBtn[fieldname='" + this._selectedFieldName + "']").parent().find(".filter").removeClass("filtered");
                        this._selectedTreeNode.find(".filter").remove();
                        delete reportItem.filterItems;
                    }
                }
                if (pivotObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap && pivotObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                    var hierarchyName = this._selectedFieldName, currentDataSrc=pivotObj.model.dataSource ; 
                    pivotObj._currentReportItems = $.map(pivotObj._currentReportItems, function (obj, index) {
                        if ((obj["fieldName"] != hierarchyName) && (ej.isNullOrUndefined(obj.dataSrc) || (obj.dataSrc.cube == currentDataSrc.cube && obj.dataSrc.reportName == currentDataSrc.reportName))) {
                            return obj;
                        }
                    });
                    if (pivotObj.model.enableMemberEditorPaging) {
                        filterIndex = this._editorTreeData;
                    }
                    else
                        filterIndex = $.extend([], this._memberTreeObj.dataSource());
                    if (isMondrian) {
                        var maxLen = 2;
                        for (var itm = 0; itm < filterIndex.length; itm++) {
                            if (!ej.isNullOrUndefined(filterIndex[itm].level) && filterIndex[itm].level > maxLen)
                                maxLen = filterIndex[itm].level;
                        }
                        pivotObj.model.dataSource._maxLevel = maxLen;
                    }
                    pivotObj._currentReportItems.push({ filterItems: filterIndex, fieldName: hierarchyName, dataSrc: pivotObj.model.dataSource, pageSettings: this._memberCount });
                }

                ej.olap.base.getJSONData({ action: "filtering" }, pivotObj.model.dataSource, pivotObj);
            }
            else {
                ej.PivotAnalysis._valueSorting = null;
                if (this.model.pivotControl.model.enableMemberEditorPaging) {
                    jQuery.each(this._editorTreeData, function (index, item) { if (item.name != "All" && item.checkedStatus) selectedNodes.push(item.name); });
                    jQuery.each(this._editorTreeData, function (index, item) {
                        if (!item.checkedStatus)
                            unSelectedNodes.push(item.name = item.name == "(blank)" ? "" : item.name);
                    });
                }
                else {
                    jQuery.each(this._memberTreeObj.element.find(":input.nodecheckbox:checked"), function (index, item) { if (item.value != "All") selectedNodes.push(item.value); });
                    jQuery.each(this._memberTreeObj.element.find(":input.nodecheckbox:not(:checked)"), function (index, item) {
                        unSelectedNodes.push(item.value = item.value == "(blank)" ? "" : item.value);
                    });
                }
                if (this._selectedFieldName)
                {
                    var reportItem = reportItem = ej.Pivot.getReportItemByFieldName(this._selectedFieldName, pivotObj.model.dataSource, this._dataModel)["item"];
                    if (reportItem)
                        reportItem["advancedFilter"] = [];
                }
                this._pivotFilterItems(selectedNodes, unSelectedNodes);
                this.model.pivotControl.refreshControl()
            }
            this._refreshPivotButtons();
            pivotObj._isMemberPageFilter = true;
            if (!ej.isNullOrUndefined(pivotClientObj))
                if (pivotClientObj._isTimeOut) pivotClientObj._isTimeOut = false;
        },

        _pivotFilterItems: function (selectedNodes, unSelectedNodes) {
            var axisItems = this.model.pivotControl.model.dataSource[this._selectedFieldAxis];
            var members = ej.PivotAnalysis.getMembers(this._selectedFieldName);
            jQuery.each(members, function (itemIndex, itemValue) {
                if (itemValue == null || !itemValue.toString().replace(/^\s+|\s+$/gm, '')) {
                    jQuery.each(unSelectedNodes, function (nodeIndex, nodeValue) {
                        if (!nodeValue.toString().replace(/^\s+|\s+$/gm, ''))
                            unSelectedNodes[nodeIndex] = itemValue;
                    });
                }
            });
            var selectedField = this._selectedFieldName;
            var items = $.grep(axisItems, function (item) { return item.fieldName == selectedField });
            for (var i = 0; i < items.length; i++)
                items[i].filterItems = selectedNodes.length == members.length ? null : { filterType: ej.PivotAnalysis.FilterType.Exclude, values: unSelectedNodes };
            if (unSelectedNodes.length > 0 && this.element.find(".schemaFieldTree li[id='" + this._selectedFieldName + "']").find(".filter").length <= 0) {
                var filterSpan = ej.buildTag("span.e-icon", { "display": "none" }).addClass("filter")[0].outerHTML;
                this.element.find(".schemaFieldTree li[id='" + this._selectedFieldName + "']").find(".e-text").after(filterSpan);
                this.element.find(".pvtBtn[fieldname='" + this._selectedFieldName + "']").parent().find(".filter").addClass("filtered");
            }
            else if (unSelectedNodes.length == 0) {
                this.element.find(".pvtBtn[fieldname='" + this._selectedFieldName + "']").parent().find(".filter").removeClass("filtered");
                this.element.find(".schemaFieldTree li[id='" + this._selectedFieldName + "']").find(".filter").remove();
            }
        },
        _dialogBtnClick: function (args) {
            ej.Pivot.closePreventPanel(this);
            this.element.find(".e-dialog, .clientDialog").hide();
            var schemaObj = this;
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!this._isFiltered) return false;
            this.model.pivotControl._isUpdateRequired = true;
            if (this.model.pivotControl != null)
                this.model.pivotControl._memberTreeObj = this._memberTreeObj;
            if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                if (args.model.text.toLowerCase() == "cancel") return;
                var selectedNodes = [], unSelectedNodes = [];
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    var hierarchyUQName = this._selectedMember;
                    this.model.pivotControl._currentReportItems = $.grep(this.model.pivotControl._currentReportItems, function (value, i) { if (value["fieldName"] != undefined && value["fieldName"].toLocaleLowerCase() != hierarchyUQName.toLocaleLowerCase()) return value; });
                    this._memberTreeObj = ej.Pivot.updateTreeView(this);
                    this.model.pivotControl._currentReportItems.push({ filterItems: $.extend([], this._memberTreeObj.dataSource()), fieldName: this._selectedMember });
                    selectedNodes = $.map(this.model.pivotControl._getSelectedNodes().split("::"), function (element, index) { { return { Id: element.split("||")[0], tag: element.split("||")[1], parentId: element.split("||")[2] } } });//$.map(this._getSelectedNodes().split("::"), function (element, index) { return { Id: element.split("||")[0], tag: element.split("||")[1],parentId:element.split("||")[2] } });

                    var currElement = (this._selectedMember != undefined) ? this._selectedMember.toLocaleLowerCase() : this._selectedMember.toLocaleLowerCase();
                    var reportItem = $.map(this.model.pivotControl.model.dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLocaleLowerCase() == currElement)) return obj; });
                    if (reportItem.length == 0) { reportItem = $.map(this.model.pivotControl.model.dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLocaleLowerCase() == currElement)) return obj; }); }
                    if (reportItem.length == 0) { reportItem = $.map(this.model.pivotControl.model.dataSource.filters, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLocaleLowerCase() == currElement)) return obj; }); }

                    if (reportItem.length > 0) {
                        if (this._getUnSelectedNodes() != "") {
                            this.model.pivotControl.model.dataSource = this.model.pivotControl._clearDrilledItems(this.model.pivotControl.model.dataSource, { action: "filtering" });
                        }
                        reportItem[0]["advancedFilter"] = [];
                        reportItem[0].filterItems = { filterType: "include", values: this.model.pivotControl._removeSelectedNodes(selectedNodes) };
                        this._selectedTreeNode = this.element.find(".schemaFieldTree").find("li[tag='" + reportItem[0].fieldName + "']");
                        if ($(this._selectedTreeNode).parents("li:eq(0)").children().children("span").hasClass("hierarchyCDB")) {
                            this._selectedTreeNode = $($(this._selectedTreeNode).parents("li:eq(0)"));
                        }
                        if (this._getUnSelectedNodes() == "") {
                            this._selectedTreeNode.find(".filter").remove();
                            this.element.find(".pvtBtn[fieldname='" + this._selectedMember + "']").parent().find(".filter").removeClass("filtered");
                            delete reportItem[0].filterItems;
                        }
                        else if ($($(this._selectedTreeNode)).find(".filter").length <= 0) {
                            $($(this._selectedTreeNode).find(".e-text")[0]).after(ej.buildTag("span.e-icon").attr("role", "button").attr("aria-label", "filtered").addClass("filter")[0].outerHTML);
                            this.element.find(".pvtBtn[fieldname='" + this._selectedMember + "']").parent().find(".filter").addClass("filtered");
                        }
                    }
                    if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                        if (!ej.isNullOrUndefined(pivotClientObj)) {
                            pivotClientObj._isTimeOut = true;
                            setTimeout(function () {
                                if (pivotClientObj._isTimeOut)
                                    schemaObj.model.pivotControl._waitingPopup.show();
                            }, 800);
                        }
                        else
                            this.model.pivotControl._waitingPopup.show();
                    ej.olap.base.getJSONData({ action: "filtering" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                }
                else {
                    ej.PivotAnalysis._valueSorting = null;
                    jQuery.each(this._memberTreeObj.element.find(":input.nodecheckbox:checked"), function (index, item) { if (item.value != "All") selectedNodes.push(item.value); });
                    jQuery.each(this._memberTreeObj.element.find(":input.nodecheckbox:not(:checked)"), function (index, item) {
                        unSelectedNodes.push(item.value = item.value == "(blank)" ? "" : item.value);
                    });
                    this.element.find(".e-dialog, .clientDialog").hide();
                    this.model.pivotControl._pivotFilterItems(selectedNodes, unSelectedNodes);
                    this.model.pivotControl.model.editCellsInfo = {};
                    this.model.pivotControl._populatePivotGrid();
                }
            }
            else {
                var unselectedNodes = "", enableFilterIndigator;
                var editorNodes = this.element.find(".editorTreeView :input.nodecheckbox");
                if (args.model.text.toLowerCase() != "cancel") {
                    var uncheckedNodes = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? unselectedNodes = this._getUnSelectedNodes() + "FILTERED" + this._getSelectedNodes(this._curFilteredAxis == "schemaFilter" ? true : false) : this.model.pivotControl.model.enableMemberEditorPaging ? this._editorTreeData : this._memberTreeObj.element.find(":input:gt(0).nodecheckbox:not(:checked)"), isFiltered = false,
                    filterParams = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? (this.model.pivotControl.model.enableMemberEditorPaging ? ej.Pivot._getUnSelectedTreeState(this) + "FILTERED" + ej.Pivot._getSelectedTreeState(this._curFilteredAxis == "schemaFilter" ? true : false, this) : uncheckedNodes) : this._curFilteredAxis + "::" + this._curFilteredText + "::FILTERED";
                    var text = this._curFilteredText, textArr = new Array(), obj = {};
                    enableFilterIndigator = this.model.pivotControl.model.enableMemberEditorPaging ? (ej.Pivot._getUnSelectedTreeState(this) != "" ? true : false) : (this._getUnSelectedNodes() != "" ? true : false);
                    if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                        if (ej.isNullOrUndefined(this.model.pivotControl._fieldMembers[text]))
                            this.model.pivotControl._fieldMembers[text] = ej.Pivot._getEditorMember(editorNodes, this.model.pivotControl, true);
                        for (var i = 0; i < uncheckedNodes.length; i++) {
                            if (!this.model.pivotControl.model.enableMemberEditorPaging)
                                textArr.push($(uncheckedNodes[i].parentElement).siblings("a").text());
                            else {
                                if (uncheckedNodes[i].checkedStatus == false)
                                    textArr.push(uncheckedNodes[i].name);
                            }
                        }
                        obj[text] = textArr;
                        var tmpFilterData = this.element.parents(".e-pivotclient").length > 0 ? this.model.pivotControl._tempFilterData : this._tempFilterData;
                        if (ej.isNullOrUndefined(tmpFilterData))
                            tmpFilterData = new Array();
                        for (var i = 0; i < tmpFilterData.length; i++) {
                            if (!ej.isNullOrUndefined(tmpFilterData[i][text])) {
                                tmpFilterData[i][text] = textArr;
                                isFiltered = true;
                            }
                        }
                        if (!isFiltered)
                            tmpFilterData.push(obj);
                        this._tempFilterData = this.model.pivotControl._tempFilterData = tmpFilterData;
                        if ((ej.isNullOrUndefined(this._curFilteredAxis) || this._curFilteredAxis != "") && this._curFilteredAxis != "schemaValue") {
                            for (var i = 0; i < uncheckedNodes.length; i++) {
                                if (!this.model.pivotControl.model.enableMemberEditorPaging)
                                    filterParams += "##" + $(uncheckedNodes[i].parentElement).siblings("a").text();
                                else {
                                    if (uncheckedNodes[i].checkedStatus == false)
                                        filterParams += "##" + uncheckedNodes[i].name;
                                }
                            }
                        }
                    }
                    else {
                        var member = ej.Pivot._getEditorMember(text, this.model.pivotControl, true);
                        this.model.pivotControl._fieldSelectedMembers[text] = $.map(this.model.pivotControl._fieldMembers[text], function (item) { if (!item.checked) return item }).length == 0 ? "All" : ((member != "All" && member != "multiple") ? member : this.model.pivotControl._getLocalizedLabels("MultipleItems"));
                        obj[this._curFilteredText] = filterParams;
                        if (ej.isNullOrUndefined(this.model.pivotControl._tempFilterData))
                            this.model.pivotControl._tempFilterData = new Array();
                        for (var i = 0; i < this.model.pivotControl._tempFilterData.length; i++) {
                            if (!ej.isNullOrUndefined(this.model.pivotControl._tempFilterData[i][this._curFilteredText])) {
                                this.model.pivotControl._tempFilterData[i][this._curFilteredText] = filterParams;
                                isFiltered = true;
                            }
                        }
                        if (!isFiltered)
                            this.model.pivotControl._tempFilterData.push(obj);
                    }
                    var filterEle = this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? this._curFilteredText : this._curFilteredText.split(".")[1];;
                    var sortedHeaders = this._getSortedHeaders(),
                    filteredBtn = this.model.layout == "excel" ? this.element.find(".schemaFieldTree li:contains('" + this._curFilteredText + "')") : this.element.find("." + this._curFilteredAxis + " .pivotButton:contains(" + this._curFilteredText + ") .filterBtn");
                    if (this.model.layout == "excel" || this.model.layout == "normal") {
                        if ($(this._selectedTreeNode).parents("li:eq(0)").children().children("span").hasClass("hierarchyCDB")) {
                            this._selectedTreeNode = $($(this._selectedTreeNode).parents("li:eq(0)"));
                        }
                        if (enableFilterIndigator && $($(this._selectedTreeNode)).find(".filter").length <= 0) {
                            var filterSpan = ej.buildTag("span.e-icon", { "display": "none" }).addClass("filter")[0].outerHTML;
                            $($(this._selectedTreeNode).find(".e-text")[0]).after(filterSpan);
                            this.element.find(".pvtBtn:contains('" + filterEle + "')").parent().find(".filter").addClass("filtered");
                        }
                        else if (!enableFilterIndigator) {
                            $(this._selectedTreeNode).find(".filter").remove();
                            this.element.find(".pvtBtn:contains('" + filterEle + "')").parent().find(".filter").removeClass("filtered");
                        }
                        if (this._curFilteredAxis == "")
                            return false;
                    }
                    if (this.model.pivotControl.model.enableGroupingBar) {
                        $.each(this.model.pivotControl.element.find(".pivotButton .filter"), function (index, itm) {
                            $(itm).removeClass("filtered")
                        })
                        if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? uncheckedNodes.length > 0 : uncheckedNodes.split("FILTERED::")[0].length > 0)
                            this.model.pivotControl.element.find("#pivotButton" + this._curFilteredText.split('.')[0]).next().addClass("filtered");;
                    }
                    var report;
                    try {
                        report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
                    }
                    catch (err) {
                        if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                        report = this.model.pivotControl.getOlapReport();
                    }
                    if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                        this._trigger("beforeServiceInvoke", { action: "filtering", element: this.element, customObject: this.model.pivotControl.model.customObject });

                    var eventArgs = this.model.pivotControl.model.customObject != {} && filterParams != "" ? JSON.stringify({ "action": "filtering", "filterParams": filterParams + ((this.model.pivotControl && $(this.model.pivotControl.element).hasClass("e-pivotclient") && !ej.isNullOrUndefined(this.model.pivotControl._ascdes) && this.model.pivotControl.model.enableAdvancedFilter) ? ">>#>#>>" + this.model.pivotControl._ascdes : ""), "sortedHeaders": this.model.pivotControl._ascdes, "currentReport": report, "valueSorting": this.model.pivotControl.model.valueSortSettings, "gridLayout": this.model.pivotControl.model.layout, "customObject": JSON.stringify(this.model.pivotControl.model.customObject) }) :
                this.model.pivotControl.model.customObject != {} ? JSON.stringify({ "action": "filtering", "currentReport": report, "valueSorting": this.model.pivotControl.model.valueSortSettings, "customObject": serializedCustomObject }) :
                filterParams != "" ? JSON.stringify({ "action": "filtering", "filterParams": filterParams, "sortedHeaders": this.model.pivotControl._ascdes, "currentReport": report, "valueSorting": this.model.pivotControl.model.valueSortSettings }) : JSON.stringify({ "action": "filtering", "valueSorting": this.model.pivotControl.model.valueSortSettings });
                if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup))
                    if (!ej.isNullOrUndefined(pivotClientObj)) {
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                schemaObj.model.pivotControl._waitingPopup.show();
                        }, 800);
                    }
                    else
                        this.model.pivotControl._waitingPopup.show();
                this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
                if (!this.model.pivotControl.model.enableDeferUpdate)
                    this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.filtering, eventArgs, this._filterElementSuccess);
                    else {
                    this.model.pivotControl._filterUpdate.push(filterParams);
                    if (!ej.isNullOrUndefined(this.model.pivotControl._waitingPopup)) {
                        if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                        this.model.pivotControl._waitingPopup.hide();
                    }
                    this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
                }
            }
                this._selectedTreeNode = null;
                this._refreshPivotButtons();
            }
            if (!ej.isNullOrUndefined(pivotClientObj))
                if (pivotClientObj._isTimeOut) pivotClientObj._isTimeOut = false;
        },

        _beforeNodeExpand:function(args){
            ej.Pivot.getChildNodes(args, this._selectedFieldName, this.model.pivotControl._currentReportItems, this.model.pivotControl.model.dataSource, this);
        },

        _nodeExpand: function (args) {
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                this.model.pivotControl._nodeExpand(args);
        },

        _nodeStateModifiedSuccess: function (report) {
            this.model.pivotControl._isUpdateRequired = true;
            if (report[0] != undefined) {
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
            }
            else {
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "nodeStateModified", element: this.element, customObject: this.model.customObject });
            if (!this.model.pivotControl.model.enableDeferUpdate)
                this.model.pivotControl._renderControlSuccess(report);
            else
                this.model.pivotControl._deferUpdateSuccess(report);
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
        },

        _pvtNodeDroppedSuccess: function (report) {
            if (report[0] != undefined) {
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
                if(report.d[0].Key == "PivotReport")
                    this.model.pivotControl.setOlapReport(report.d[0].Value);
            }
            else {
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
                this.model.pivotControl.setOlapReport(report.PivotReport);
            }
            if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });

            if (!this.model.pivotControl.model.enableDeferUpdate) {
                if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    this.model.pivotControl.refreshControl(report);
                    if (this.model.pivotControl && this.model.pivotControl._pivotGrid && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                        this.model.pivotControl._pivotGrid._removeCells(report);
                }
                else
                    this.model.pivotControl._renderControlSuccess(report);
            }
            else
                this.model.pivotControl._deferUpdateSuccess(report);
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
        },

        _pvtBtnDroppedSuccess: function (report) {
            if (report[0] != undefined) {
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
            }
            else {
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "removeButton", element: this.element, customObject: this.model.customObject });
            this.model.pivotControl._renderControlSuccess(report);
            if (this.model.pivotControl && this.model.pivotControl._pivotGrid && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                this.model.pivotControl._pivotGrid._removeCells(report);
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
        },

        _filterElementSuccess: function (report) {
            if ($(this.element).parents(".e-pivotclient").length > 0) {
                if (!ej.isNullOrUndefined(report.d)) {
                    var tempObj = {};
                    tempObj["PivotReport"] = report.d[0].Value;
                    tempObj["GridJSON"] = report.d[1].Value;
                    tempObj["ChartJSON"] = report.d[2].Value;
                    var colHiddenCells = ($.map(report.d, function (item) { if (item.Key == "FilteredColumnHeaders") return item.Value; }));
                    if (colHiddenCells.length > 0)
                        tempObj["FilteredColumnHeaders"] = colHiddenCells[0];
                    var rowHiddenCells =($.map(report.d, function (item) { if (item.Key == "FilteredRowHeaders") return item.Value; }));
                    if (rowHiddenCells.length > 0)
                        tempObj["FilteredRowHeaders"] = rowHiddenCells[0];
                    report = tempObj;
                }
                this.model.pivotControl.refreshControl(report);
                if (this.model.pivotControl && this.model.pivotControl._pivotGrid && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                this.model.pivotControl._pivotGrid._removeCells(report);
            }
            else {
                if (report[0] != undefined) {
                    if (report[2] != null && report[2] != undefined)
                        this.model.customObject = report[2].Value;
                }
                else if (report.d != undefined) {
                    if (report.d[2] != null && report.d[2] != undefined)
                        this.model.customObject = report.d[2].Value;
                }
                else {
                    if (report.customObject != null && report.customObject != undefined)
                        this.model.customObject = report.customObject;
                }
                if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                    this._trigger("afterServiceInvoke", { action: "filtering", element: this.element, customObject: this.model.customObject });
                this.model.pivotControl._renderControlSuccess(report);
            }   
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
            ej.Pivot.closePreventPanel(this);
            this.element.find(".e-dialog").remove();
        },

        _fetchChildNodeSuccess: function (data) {
            var newDataSource; var parentNode;
            if (data.length > 1 && data[0] != undefined) {
                newDataSource = JSON.parse(data[0].Value);
                if (data[1] != null && data[1] != undefined)
                    this.model.customObject = data[1].Value;
            }
            else if (data.d != undefined) {
                newDataSource = JSON.parse(data.d[0].Value);
                if (data.d[1] != null && data.d[1] != undefined)
                    this.model.customObject = data.d[1].Value;
            }
            else {
                newDataSource = JSON.parse(data.ChildNodes);
                if (data.customObject != null && data.customObject != undefined)
                    this.model.customObject = data.customObject;
            }
            var mapper = { id: "id", parentId: "pid", hasChild: "hasChildren", text: "name", isChecked: "checkedStatus" };
            if ($(this.pNode).parents("li").length > 1)
                parentNode = $(this.pNode).parents("li").first();
            else
                parentNode = $(this.pNode).parents("li");
            $($(parentNode).find('input.nodecheckbox')[0]).ejCheckBox({ checked: false })
            this._memberTreeObj._createSubNodesWhenLoadOnDemand(newDataSource, this.pNode, mapper);
            $.each($(parentNode).children().find("li"), function (index, value) {
                value.setAttribute("tag", newDataSource[index].tag);
            });
            if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "memberExpanded", element: this.element, customObject: this.model.customObject });
            // this._memberTreeObj._expandCollapseAction(this.pNode);
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
        },

        _fetchMemberSuccess: function (msg) {
            if (msg[0] != undefined && msg.length > 0) {
                this._currentMembers = msg[0].Value;
                if (msg[1] != null && msg[1] != undefined)
                    this.model.customObject = msg[1].Value;
            }
            else if (msg.d != undefined && msg.d.length > 0) {
                this._currentMembers = msg.d[0].Value;
                if (msg.d[1] != null && msg.d[1] != undefined)
                    this.model.customObject = msg.d[1].Value;
            }
            else if (msg != undefined && msg.length > 0) {
                this._currentMembers = msg.EditorTreeInfo;
                if (msg != null && msg.customObject != undefined)
                    this.model.customObject = msg.customObject;
            }
            else if (msg != undefined) {
                this._currentMembers = msg.EditorTreeInfo;
                if (msg != null && msg.customObject != undefined)
                    this.model.customObject = msg.customObject;
            }
            if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "fetchMembers", element: this.element, customObject: this.model.customObject });
            this._createDialog(this._dialogHead, this._currentMembers);

           
            if (this.model.pivotControl._waitingPopup) {
                var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
                if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                this.model.pivotControl._waitingPopup.hide();
            }
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
            if (!ej.isNullOrUndefined(this.element.find(".e-dialog .e-text:visible").first())) {
                this.element.find(".e-dialog .e-text:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
            }
        },

        _droppedSuccess: function (args) {
            var report = null;
            if (this.model.pivotControl.model.enableDeferUpdate) {
                report = this._removeButtonDeferUpdate == false ? (!ej.isNullOrUndefined(args.OlapReport) ? JSON.parse(args.OlapReport) : JSON.parse(args.d[0].Value)) : (!ej.isNullOrUndefined(args.OlapReport) ? report = args.OlapReport : report = args.d[0].Value);
            }
            else {
                if (!ej.isNullOrUndefined(args[0]) && args.length > 0) {
                    report = JSON.parse(args[1].Value);
                    if (args[2] != null && args[2] != undefined)
                        this.model.customObject = (args[2].Value);
                }
                else if (!ej.isNullOrUndefined(args.d) && args.d.length > 0) {
                    if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                        report = JSON.parse($.grep(args.d, function (item) { return item.Key == "PivotReport" })[0].Value);
                    else
                        report = JSON.parse(args.d[1].Value);
                    if (args.d[2] != null && args.d[2] != undefined)
                        this.model.customObject = (args.d[2].Value);
                }
                else if (!ej.isNullOrUndefined(args) && !ej.isNullOrUndefined(args.OlapReport))
                    report = JSON.parse(args.OlapReport);
                else if (!ej.isNullOrUndefined(args) && !ej.isNullOrUndefined(args.PivotReport))
                    report = JSON.parse(args.PivotReport);
                if (args.customObject != null && args.customObject != undefined)
                    this.model.customObject = (args.customObject);
            }
            if (this._removeButtonDeferUpdate == false) {
                this.element.find(".axisTable .pivotButton").remove();
                this._setPivotRows(report.PivotRows);
                this._setPivotColumns(report.PivotColumns);
                this._setPivotCalculations(report.PivotCalculations);
                this._setFilters(report.Filters);
                this.model.pivotControl.setOlapReport(JSON.stringify(report));
                this._refreshPivotButtons();
                if (this.model.enableDragDrop) {
                    this.element.find(".pivotButton .pvtBtn").ejButton({ size: "normal", type: ej.ButtonType.Button, enableRTL: this.model.enableRTL }).ejDraggable({
						handle: 'button', clone: true,
						cursorAt: { left: -5, top: -5 },
						dragStart: ej.proxy(function (args) {
							this._isDragging = true;
						}, this),
						dragStop: ej.proxy(this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._pvtBtnDropped : this._clientOnPvtBtnDropped, this),
						helper: ej.proxy(function (event, ui) {
						    $(event.element).addClass("dragHover");
							if (event.sender.target.className.indexOf("e-btn") > -1) {
								var btnClone = $(event.sender.target).clone().attr("id",this._id+"_dragClone").appendTo('body');
								$("#"+this._id + "_dragClone").removeAttr("style").height($(event.sender.target).height());
								return btnClone;            
							}
							else
								return false;
						}, this)
					});
				}
                this._unWireEvents();
                this._wireEvents();
            }
            if (!this.model.pivotControl.model.enableDeferUpdate) {
                if ($(this.element).parents(".e-pivotclient").length > 0 && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    this.model.pivotControl.refreshControl(args);
                    if (this.model.pivotControl && this.model.pivotControl._pivotGrid && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
                        this.model.pivotControl._pivotGrid._removeCells(args);
                }
                else
                    this.model.pivotControl._renderControlSuccess(args);
            }
            else {
                if (!ej.isNullOrUndefined(this.model.pivotControl._ogridWaitingPopup))
                    this.model.pivotControl._ogridWaitingPopup.hide();
                if (!ej.isNullOrUndefined(args.OlapReport)) {
                    this.model.pivotControl.setOlapReport(args.OlapReport);
                    if (args.HeaderCounts != undefined && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                        this.model.pivotControl._pagerObj.initPagerProperties(JSON.parse(args.HeaderCounts), JSON.parse(args.PageSettings));
                }
                else {
                    this.model.pivotControl.setOlapReport(args.d[0].Value);
                    if ($(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined)
                        this.model.pivotControl._pagerObj.initPagerProperties(JSON.parse(args.d[2].Value), JSON.parse(args.d[1].Value));
                }
                this._removeButtonDeferUpdate = false;
                this.model.pivotControl._deferUpdateSuccess(args);
            }
            if (this.model.afterServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                this._trigger("afterServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
            this._createContextMenu();
            this._setPivotBtnWidth();
        },

        _removePvtBtn: function (args) {
            this.model.pivotControl._waitingPopup.show();
            var headerText, headerTag, report, eventArgs;
            if ($(args.element).length > 0) {
                headerText = $(args.element).parent().attr("tag").split(":")[1], headerTag = $(args.element).parent().attr("tag");
            }
            else {
                headerText = $(args.target).parent().attr("tag").split(":")[1], headerTag = $(args.target).parent().attr("tag");
            }
            try {
                report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
            }
            catch (err) {
                if (!ej.isNullOrUndefined(this.model.pivotControl.getOlapReport))
                report = this.model.pivotControl.getOlapReport();
            }
            if (report == "" && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                report = this.model.pivotControl.model.dataSource;
            if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                this._clearFilterData(headerText);
                var uniqueName = ((headerTag.indexOf("[Measures]") > -1) || (headerTag.indexOf("[") > -1)) ? headerTag.split(":")[1] : this.model.pivotControl._getNodeUniqueName(headerTag);
                uniqueName = uniqueName.indexOf("<>") ? uniqueName.replace("<>", ".") : uniqueName;
                if (uniqueName == "[Measures]") {
                    if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                        ej.Pivot.removeReportItem(this.model.pivotControl.model.dataSource, headerText, headerText.toLocaleLowerCase().indexOf("measures") == 0);
                        this.model.pivotControl.refreshControl(); 
                        this.refreshControl();
                    }
                    else if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                        $(args.element).length > 0 ? $(args.element).parent().parent().remove() : $(args.target).parent().parent().remove();
                        for (var i = 0; i < this.model.pivotCalculations.length && headerTag.indexOf(this._getLocalizedLabels("Measures")) > -1; i++) {
                            uniqueName = this.model.pivotCalculations[i].Tag;
                            this._isMeasureBtnRemove = true;
                            selectedTreeNode = this.model.pivotControl._getNodeByUniqueName(uniqueName);
                            this._tableTreeObj.uncheckNode(selectedTreeNode);
                        }
                        this.element.find(".schemaNoClick").addClass("freeze").width($(this.element).width()).height($(this.element).height()).css({ "top": $(this.element).offset().top, "left": $(this.element).offset().left });
                        if (this.model.beforeServiceInvoke != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode)
                            this._trigger("beforeServiceInvoke", { action: "removeButton", element: this.element, customObject: this.model.pivotControl.model.customObject });
                        var eventArgs = JSON.stringify({ "action": "removeButton", "headerInfo": headerTag, "currentReport": report, "customObject": JSON.stringify(this.model.pivotControl.model.customObject), "gridLayout": this.model.pivotControl.model.layout });
                        if (headerTag.indexOf("[Measures]") < 0 && headerTag.indexOf("Measures") >= 0)
                            this.element.find(".schemaValue .pivotButton").remove();
                        if (this.model.pivotControl.model.enableDeferUpdate) {
                            this._removeButtonDeferUpdate = true;
                            this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.removeButton, eventArgs.replace("removeButton", "removeButtonDeferUpdate"), this._droppedSuccess)
                            this.element.find(".schemaNoClick").removeClass("freeze").removeAttr('style');
                        }
                        else {
                            this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.removeButton, eventArgs, this._pvtBtnDroppedSuccess);
                        }
                    }
                }
                else {
                    selectedTreeNode = this.model.pivotControl._getNodeByUniqueName(uniqueName);
                    this._tableTreeObj.uncheckNode(selectedTreeNode);
                  }
            }
            else if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                ej.PivotAnalysis._valueSorting = null;
                headerText = $(args.element).length > 0 ? $(args.element).parent().find(".pvtBtn").attr("fieldname") : $(args.target).parent().find(".pvtBtn").attr("fieldname");
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    if (headerTag.split(":")[1].toLowerCase() == "measures") {
                        this.model.pivotControl._ogridWaitingPopup.show();
                        this.element.find("div[tag='" + headerTag + "']").remove();
                        for (var i = 0; i < this.model.pivotControl.model.dataSource.values[0]["measures"].length; i++) {
                            this._nodeCheck = true;
                            selectedTreeNode = this._tableTreeObj.element.find("li[tag='" + this.model.pivotControl.model.dataSource.values[0]["measures"][i].fieldName + "']");
                            this._tableTreeObj.uncheckNode(selectedTreeNode);
                            this.element.find("div[tag='values:" + this.model.pivotControl.model.dataSource.values[0]["measures"][i].fieldName + "']").remove();
                        }
                        this.model.pivotControl.model.dataSource.values[0]["measures"] = [];
                        ej.olap.base.getJSONData({ action: "removeButton" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                    }
                    selectedTreeNode = this._tableTreeObj.element.find("li[tag='" + headerText + "']");
                    if (selectedTreeNode.length > 1) {
                        for (var i = 0; i < selectedTreeNode.length; i++) {
                            if (this._tableTreeObj.isNodeChecked(selectedTreeNode[i]))
                                selectedTreeNode = selectedTreeNode[i];
                        }
                    }
                }
                else
                    selectedTreeNode = this._tableTreeObj.element.find("li[id=" + headerText + "]");
                this._tableTreeObj.uncheckNode(selectedTreeNode);
            }
            else {
                selectedTreeNode = this._tableTreeObj.element.find("li:contains('" + headerText + "')");
                this._tableTreeObj.uncheckNode(selectedTreeNode);
            }
        },

        _createDialog: function (title, treeViewData) {
            this.element.find(".e-dialog, .clientDialog").remove();

            var currentHierarchy, levelInfo, sortState, seperator, groupDropDown = "", filterElementTag = "", memberSearchEditor = "";
           var isAdvancedFilter = (
               this.model.pivotControl && 
               (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.pivotControl.model.enableAdvancedFilter && this._curFilteredAxis != "schemaFilter" && this._curFilteredAxis != "schemaValue") ||
               this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.pivotControl.model.dataSource.enableAdvancedFilter &&
               ej.Pivot.getReportItemByFieldName(this._selectedFieldName, this.model.pivotControl.model.dataSource, this._dataModel).axis != "filters" &&
               ej.Pivot.getReportItemByFieldName(this._selectedFieldName, this.model.pivotControl.model.dataSource, this._dataModel).axis != "values" &&
               (!ej.isNullOrUndefined(ej.Pivot.getReportItemByFieldName(this._selectedFieldName, this.model.pivotControl.model.dataSource, this._dataModel).item))? true : false);

           if (isAdvancedFilter) {
               var treeviewInfo = JSON.parse(treeViewData);
               treeviewInfo[0].name = "(Select All)"
               currentHierarchy = this._selectedFieldName;
               if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                   if (this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap) {
                       levelInfo = $.map(this.model.pivotControl._currentReportItems, function (obj, index) { if (obj["fieldName"] == currentHierarchy) { return obj["dropdownData"]; } });
                       if (levelInfo.length == 0)
                           levelInfo = $.map(this._tableTreeObj.element.find("li[tag ='" + this._selectedFieldName + "'] li"), function (obj, index) { return { value: $(obj).attr("tag"), text: $(obj).find("a").text() }; });
                   }
                   else
                       levelInfo = [{ value: this._selectedFieldName, text: this._selectedFieldName }]
               }
               else if (this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap) {
                   levelInfo = this.model.pivotControl.model.enableMemberEditorPaging ? this._memberPagingAvdData : treeviewInfo.splice(treeviewInfo.length - 1, 1);
                   levelInfo = JSON.parse(levelInfo[0].levels);
               }
               else
                   levelInfo = [{ value: this._curFilteredText, text: this._curFilteredText }];
               treeViewData = JSON.stringify(treeviewInfo);
               groupDropDown = ej.buildTag("div.ddlGroupWrap", this._getLocalizedLabels("SelectField") + ":" + ej.buildTag("input#" + this._id + "_GroupLabelDrop.groupLabelDrop").attr("type", "text")[0].outerHTML, {})[0].outerHTML;
               filterElementTag = ej.buildTag("ul.filterElementTag")[0].outerHTML;
               var filterTag = ej.Pivot.createAdvanceFilterTag({action:"filterTag"}, this)
           }
           memberSearchEditor = ej.buildTag("div.memberSearchEditorDiv", ej.buildTag("input#" + this._id + "_SearchEditorTreeView.searchEditorTreeView").attr("type", "text")[0].outerHTML + (this.model.pivotControl.model.enableMemberEditorPaging && $.parseJSON(treeViewData).length >= this.model.pivotControl.model.memberEditorPageSize ? ej.buildTag("span.e-icon searchEditorTree", {})[0].outerHTML : ""), { "padding": (this.model.pivotControl.model.enableAdvancedFilter ? "5px 5px 0px 9px" : 0) })[0].outerHTML;
           var dialogContent = ej.buildTag("div#" + this._id + "_EditorDiv.editorDiv", groupDropDown + filterElementTag + ej.buildTag("div", memberSearchEditor + ej.buildTag("div.memberEditorDiv", ej.buildTag("div#editorTreeView.editorTreeView")[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML + ((!ej.isNullOrUndefined(treeViewData) && this.model.pivotControl.model.enableMemberEditorPaging && ($.parseJSON(treeViewData).length >= this.model.pivotControl.model.memberEditorPageSize || this.model.pivotControl.model.memberEditorPageSize < this._memberPageSettings.endPage)) ? "" : "</br>"),
           dialogFooter = ej.buildTag("div", ej.buildTag("button#" + this._id + "_OKBtn.dialogOKBtn", this._getLocalizedLabels("OK"))[0].outerHTML + ej.buildTag("button#CancelBtn.dialogCancelBtn", this._getLocalizedLabels("Cancel"))[0].outerHTML, { "float": "right", "margin": (!ej.isNullOrUndefined(treeViewData) && $.parseJSON(treeViewData).length >= this.model.pivotControl.model.memberEditorPageSize ? "10px" : "-5px ") + " " + (isAdvancedFilter ? " 5px " : " 0px ") + " 6px 0px" })[0].outerHTML,
           editorNavPanel = ej.buildTag("div.memberPager", ej.buildTag("div#" + this._id + "_NextpageDiv.nextPageDiv", ej.buildTag("div.e-icon e-media-backward_01 firstPage", {})[0].outerHTML + ej.buildTag("div.e-icon e-arrowhead-left prevPage", {})[0].outerHTML + ej.buildTag("input.memberCurrentPage#memberCurrentPage", {}, { "width": "20px", "height": "10px" })[0].outerHTML + ej.buildTag("span.memberPageCount#memberPageCount")[0].outerHTML + ej.buildTag("div.e-icon e-arrowhead-right nextPage", {})[0].outerHTML + ej.buildTag("div.e-icon e-media-forward_01 lastPage", {})[0].outerHTML)[0].outerHTML)[0].outerHTML,
           ejDialog = ej.buildTag("div#" +(isAdvancedFilter?"clientDialog": this._id + "_clientDialog")+".clientDialog", dialogContent + (!ej.isNullOrUndefined(treeViewData) && this.model.pivotControl.model.enableMemberEditorPaging && ($.parseJSON(treeViewData).length >= this.model.pivotControl.model.memberEditorPageSize || this.model.pivotControl.model.memberEditorPageSize < this._memberPageSettings.endPage) ? editorNavPanel : "") + dialogFooter, { "opacity": "1" }).attr("title", title)[0].outerHTML,

           treeViewData = JSON.parse(treeViewData), selectedData;
            for (var i = 0; i < treeViewData.length; i++)
            if (treeViewData[i].name == null || !treeViewData[i].name.toString().replace(/^\s+|\s+$/gm, '')) { treeViewData[i].name = "(blank)"; treeViewData[i].id = "(blank)"; }
            var selectedData;

            if (this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode ? !ej.isNullOrUndefined(this.model.pivotControl._fieldMembers) : !ej.isNullOrUndefined(this._tempFilterData)) {
                if (this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ServerMode) {
                    for (var i = 0; i < Object.keys(this.model.pivotControl._fieldMembers).length; i++) {
                        if (!ej.isNullOrUndefined(this.model.pivotControl._fieldMembers[this._curFilteredText]))
                            selectedData = $.map(this.model.pivotControl._fieldMembers[this._curFilteredText], function (item) { if (!item.checked) return item.name });
                    }
                }
                else {
                    for (var i = 0; i < this._tempFilterData.length; i++) {
                        if (!ej.isNullOrUndefined(this._tempFilterData[i][title]))
                            selectedData = this._tempFilterData[i][title];
                    }
                }
                if (!ej.isNullOrUndefined(selectedData)) {
                    for (var i = 0; i < selectedData.length; i++) {
                        for (var j = 0; j < treeViewData.length; j++) {
                            if (selectedData[i] == treeViewData[j].name)
                                treeViewData[j].checkedStatus = false;
                        }
                    }
                }
            }
            $(ejDialog).appendTo("#" + this._id);
            if (this.model.pivotControl.model.enableMemberEditorPaging && (treeViewData.length >= this.model.pivotControl.model.memberEditorPageSize || this.model.pivotControl.model.memberEditorPageSize < this._memberPageSettings.endPage)) {
                this.element.find(".prevPage, .firstPage").addClass("pageDisabled");
                this.element.find(".nextPage, .lastPage").addClass("pageEnabled");
                var pageCount = (this._memberCount / this.model.pivotControl.model.memberEditorPageSize);
                if (pageCount != Math.round(pageCount))
                    pageCount = parseInt(pageCount) + 1;
                this.element.find(".memberPageCount").html("/ " + pageCount);
                this.element.find(".memberCurrentPage").val(this._memberPageSettings.currentMemeberPage);
                this._memberPageSettings.currentMemeberPage > 1 ? this.element.find(".prevPage, .firstPage").removeClass("pageDisabled").addClass("pageEnabled") : this.element.find(".prevPage, .firstPage").removeClass("pageEnabled").addClass("pageDisabled");
                this._memberPageSettings.currentMemeberPage == parseInt(this.element.find(".memberPageCount").text().split("/")[1].trim()) ? this.element.find(".nextPage, .lastPage").removeClass("pageEnabled").addClass("pageDisabled") : this.element.find(".nextPage, .lastPage").removeClass("pageDisabled").addClass("pageEnabled");
                this.element.find(".nextPageDiv .pageDisabled").css("opacity", "0.5");
            }
            this.element.find("#" + this._id + "_SearchEditorTreeView").ejMaskEdit({
                name: "inputbox",
                width: "100%",
                inputMode: ej.InputMode.Text,
                watermarkText: this._getLocalizedLabels("Search") + " " + title,
                maskFormat: "",
                textAlign: this.model.enableRTL ? "right" : "left",
                change: (!this.model.pivotControl.model.enableMemberEditorPaging || this.element.find(".nextPageDiv").length == 0) ? ej.proxy(ej.Pivot._searchTreeNodes, this) : ej.proxy(function (args) { if (ej.isNullOrUndefined(args.value)) ej.Pivot._searchEditorTreeNodes(args, this); }, this)
            });
            this.element.find(".editorTreeView").ejTreeView({
                showCheckbox: true,
                loadOnDemand: true,
                enableRTL: this.model.enableRTL,
                beforeDelete: function () {
                    return false;
                },
                height: $(".memberEditorDiv").height(),
                fields: { id: "id", text: "name", isChecked: "checkedStatus", hasChild: "hasChildren", dataSource: treeViewData },
               
            });
            if (isAdvancedFilter)
            {
                this.element.find(".filterElementTag").ejMenu({
                    fields: { dataSource: filterTag, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" },
                    menuType: ej.MenuType.NormalMenu,
                    width: "100%",
                    enableRTL:this.model.enableRTL,
                    orientation: ej.Orientation.Vertical,
                    click: ej.proxy(this._filterElementClick, this)
                });
                this.element.find(".groupLabelDrop").ejDropDownList({
                    width: "99%",
                    enableRTL: this.model.enableRTL,
                    dataSource: levelInfo,
                    fields: { id: "id", text: "text", value: "value" },
                    change: ej.proxy(this._groupLabelChange, this),
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                var selectedlevel = ej.isNullOrUndefined(this._selectedLevel) ? "" : this._selectedLevel;
                selectedlevel=  $.map(levelInfo, function (obj, index) { if(obj.value.toLowerCase()==selectedlevel.toLowerCase())return obj.text; });

                var levelDropTarget = this.element.find('.groupLabelDrop').data("ejDropDownList");
                levelDropTarget.selectItemByText((selectedlevel.length > 0) ? selectedlevel[0] : levelDropTarget.model.dataSource[0].text);

                this.element.find(".memberEditorDiv").addClass("advancedFilter");
                
            }

            var isTreeNodeHasChild = $.grep(treeViewData, function (item, index) { if (item.hasChildren == true) return item; }).length > 0;
            if (!isTreeNodeHasChild)
                this.element.find(".memberEditorDiv").addClass("noChildNode");

            var treeViewElements = this.element.find(".editorTreeView").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                treeViewElements[i].setAttribute("tag", treeViewData[i].tag);
            }
            this.element.find(".dialogOKBtn, .dialogCancelBtn").ejButton({ type: ej.ButtonType.Button, click: ej.proxy(this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? this._clientDialogBtnClick: this._dialogBtnClick, this) });
            this._dialogOKBtnObj = this.element.find(".dialogOKBtn").data("ejButton");
            this._memberTreeObj = this.element.find(".editorTreeView").data("ejTreeView");
            var treeViewLi = this.element.find(".editorTreeView li:gt(0)"), firstNode = $(this._memberTreeObj.element.find("li:first")).find("div .e-chkbox-small > span > span:eq(0)"),
            uncheckedNodes = $(treeViewLi).find(":input.nodecheckbox:not(:checked)");
            if (uncheckedNodes.length > 0) {
                $(firstNode).removeClass("e-checkmark").addClass("e-stop");
            }
            if (!ej.isNullOrUndefined(this.model.pivotControl) && this.model.pivotControl.model.enableMemberEditorPaging) {
                //this.element.find(".memberPager").css("margin-top", "0px");
                if (!this._isAllMemberChecked) {
                    this._dialogOKBtnObj.disable();
                    this.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                    $(firstNode).removeClass("e-checkmark").removeClass("e-stop").addClass("e-chk-inact");
                }
            }
            if (!ej.isNullOrUndefined(this.model.pivotControl._unSelectedNodes) && this.model.pivotControl._isMemberPageFilter) {
                var unSelectedNodes = this.model.pivotControl._unSelectedNodes;
                $.map(treeViewLi, function (ele, index) {
                    var member = ele;
                    $.map(unSelectedNodes, function (item, index) {
                        if ($(member).attr("tag") == item.tag) {
                            $($(member).find("div .e-chkbox-small > span > span:eq(0)")).removeClass("e-checkmark");
                            $(firstNode).removeClass("e-checkmark").addClass("e-stop");
                        }
                    })
                })
            }
            this.element.find(".clientDialog").ejDialog({ width: isAdvancedFilter? "auto": 265, target: "#" + this._id, enableResize: false, enableRTL: this.model.enableRTL, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
            this.element.find(".clientDialog").next(".e-scrollbar").hide();
            this.element.find(".e-dialog .e-close").attr("title", this._getLocalizedLabels("Close"));
            if (isAdvancedFilter) {
                this.element.find("#clientDialog_wrapper").addClass("advancedFilterDlg");
                if (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Olap)
                    this.element.find("#clientDialog_wrapper").addClass("advancedFilterDlgOSM");
                this.element.find("#clientDialog_wrapper").css("min-width", "265px");
                if (this._droppedClass != "schemaFilter") {
                    this.element.find(".clientDialog").css("padding", "0px").parents().parents().find(".e-titlebar").remove();
                    var reportItem = ej.Pivot.getReportItemByFieldName(currentHierarchy, this.model.pivotControl.model.dataSource).item, selectedOrder;
                    if (reportItem) {
                        if (reportItem["sortOrder"] && reportItem["sortOrder"] != ej.olap.SortOrder.None) {
                            selectedOrder = (reportItem["sortOrder"] == ej.olap.SortOrder.Descending) ? "desc" : "asc";
                            if (ej.isNullOrUndefined(selectedOrder) || selectedOrder == "asc")
                                this.element.find(".clientDialog .ascImage").addClass("selectedSort");
                            else
                                this.element.find(".clientDialog .descImage").addClass("selectedSort");
                        }
                    }
                }
            }
            this._memberTreeObj.model.nodeCheck = ej.proxy(this._nodeCheckChanges, this);
            this._memberTreeObj.model.nodeUncheck = ej.proxy(this._nodeCheckChanges, this);
            (this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) ? this._memberTreeObj.model.beforeExpand = ej.proxy(this._beforeNodeExpand, this) : this._memberTreeObj.model.nodeClick = ej.proxy(this._nodeExpand, this);
            if (this._memberTreeObj.element.find(".e-plus").length == 0) {
                this._memberTreeObj.element.find(".e-item").css("padding", "0px");
            }
            this._isFiltered = false;
            this.model.pivotControl._isMemberPageFilter = false;
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.hide();
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.hide();
        },

        _applySorting: function () {
            var serializedCustomObject = JSON.stringify(this.model.pivotControl.model.customObject);
            var report;
            try {
                report = JSON.parse(this.model.pivotControl.getOlapReport()).Report;
            }
            catch (err) {
                report = this.model.pivotControl.getOlapReport();
            }
            if (this.model.pivotControl.model.beforeServiceInvoke != null)
                this._trigger("beforeServiceInvoke", { action: "sorting", element: this.element, customObject: this.model.customObject });

            var serializedCustomObject = JSON.stringify(this.model.pivotControl.model.customObject);
            var eventArgs = JSON.stringify({ "action": "sorting", "sortedHeaders": this.model.pivotControl._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.pivotControl.model.valueSortSettings), "customObject": serializedCustomObject });
            this._waitingPopup = this.element.data("ejWaitingPopup");
            if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.show();
            if (!this.model.pivotControl.model.enableDeferUpdate)
                this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.sorting, eventArgs, this._filterElementSuccess);
            else {
                if (!ej.isNullOrUndefined(this._waitingPopup))
                    this._waitingPopup.hide();
            }
        },

        _filterElementClick: function (args) {
            var currentHierarchy = this._selectedFieldName;
            if (!ej.isNullOrUndefined(args.element))
                this._filterAction = $(args.element).parents("li:eq(0)#valueFilterBtn").length == 0 ? "labelFiltering" : "valueFiltering";
            else
                this._filterAction = args.menuId == "valueFilterBtn" ? "valueFiltering" : args.menuId == "labelFilterBtn" ? "labelFiltering" : "";
            var selectedLevelInfo = this.element.find(".groupLabelDrop").data("ejDropDownList");
            this._selectedLevelUniqueName = selectedLevelInfo.getSelectedValue();
            this.model.pivotControl._selectedField = this._selectedFieldName;
            if (this.model.pivotControl && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                this.model.pivotControl._selectedField = this.model.pivotControl._curFilteredText = this._curFilteredText;
                this.model.pivotControl._curFilteredAxis = this._curFilteredAxis;
                
                this._selectedField = this._curFilteredText
                if (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    this.model.pivotControl._filterElementClick(args, this);
                }
                else {
                    var report;
                    try { report = JSON.parse(this.model.pivotControl.getOlapReport()).Report; }
                    catch (err) { report = this.model.pivotControl.getOlapReport(); }

                    var filterVal = [], levelName = this._selectedLevelUniqueName;
                    if ($(args.element).find(".descImage").length > 0 || $(args.element).find(".ascImage").length > 0 || $(args.element).find(".e-clrSort").length > 0) {
                        if (ej.isNullOrUndefined(this.model.pivotControl._ascdes))
                            this.model.pivotControl._ascdes = "";

                        if (this.model.pivotControl._ascdes.indexOf(this._selectedField) > -1 )
                            this.model.pivotControl._ascdes = this.model.pivotControl._ascdes.replace(this._selectedField + "##", "");
                        else if($(args.element).find(".e-clrSort").length==0)
                            this.model.pivotControl._ascdes = this.model.pivotControl._ascdes + this._selectedField + "##";
                        this._applySorting(args);
                        return false;
                    }
                   else if ($(args.element).find(".e-clrFilter").length > 0) {
                        this.model.pivotControl._removeFilterTag(this._selectedLevelUniqueName);
                        var filterParams = this._selectedField + "::" + this._curFilteredText + "## Clear Filter" + ((this.model.pivotControl && $(this.model.pivotControl.element).hasClass("e-pivotclient") && !ej.isNullOrUndefined(this.model.pivotControl._ascdes) && this.model.pivotControl.model.enableAdvancedFilter) ? ">>#>#>>" + this.model.pivotControl._ascdes : "");
                        var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": this._filterAction.toLowerCase(), "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "customObject": serializedCustomObject, "gridLayout": this.model.pivotControl.model.layout });
                        this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.filtering, eventArgs, this._filterElementSuccess);
                    }
                    else
                        ej.Pivot.createAdvanceFilterTag({ action: (this._filterAction == "labelFiltering" ? "labelFilterDlg" : "valueFilterDlg"), selectedArgs: args, filterInfo: filterVal }, this);
                }
                return false;
            }
            if ($(args.element).attr("id") == "clearAllFilters")
                this._clearAllFilter(args);
            else if ($(args.element).attr("id") == "clearSorting")
                this.model.pivotControl._clearSorting(args);
            
            else if ($(args.element).attr("id") == "ascOrder" || $(args.element).attr("id") == "descOrder")
                this._sortField(args);
            if ($(args.element).parent().hasClass("filterElementTag")) return; 
            this.element.find(".e-dialog, .filterDialog, #preventDiv").remove();

            if ($.trim(args.text) == $.trim(this._getLocalizedLabels("ClearFilter"))) {
                this._clearFilter(currentHierarchy, this._selectedLevelUniqueName, this.model.pivotControl.model.dataSource);
                if (this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    {
                        ej.PivotAnalysis._valueFilterArray = $.grep(ej.PivotAnalysis._valueFilterArray, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() != currentHierarchy.toLowerCase())) return obj; });
                        this.model.pivotControl.refreshControl();
                    }
                }
                else {
                    ej.olap.base.getJSONData({ action: "advancedfiltering" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
                }
                return false;
            }
            else {
                var dialogtitle, hierarchyLi, isHierarchyNode = false, currentLevelInfo = this._selectedLevelUniqueName;
                if(this.model.pivotControl){
                    this.model.pivotControl._selectedLevelUniqueName= this._selectedLevelUniqueName;
                }
                var dialogContent, dropdownValues, filterValue = this._getAdvancedFiltervalue(currentHierarchy, this._selectedLevelUniqueName), topCountFilterParams = "";
                filterValue = ($(args.element).find(".activeFilter").length > 0 && filterValue.length > 0) ? filterValue[0].values : [""];

                var reportItem = ej.Pivot.getReportItemByFieldName(currentHierarchy, this.model.pivotControl.model.dataSource).item;
                var filterVal = [];
                if (reportItem && reportItem["advancedFilter"])
                    filterVal = $.map(reportItem["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLowerCase() != currentLevelInfo)) return obj; });
                ej.Pivot.createAdvanceFilterTag({ action: (this._filterAction == "labelFiltering" ? "labelFilterDlg" : "valueFilterDlg"), selectedArgs: args, filterInfo: filterVal }, this);
            }
        },
        _getAdvancedFiltervalue: function (hierarchyUqName, levelUqName) {
            
            if (!(this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)) {
                var filterItem = ej.Pivot.getReportItemByFieldName(hierarchyUqName, this.model.pivotControl.model.dataSource, "XMLA").item, levelItem = [];
                if (filterItem.advancedFilter)
                    levelItem = $.map(filterItem.advancedFilter, function (obj, index) { if (obj.name != undefined && (obj.name.toLocaleLowerCase() == levelUqName.toLowerCase())) return obj; });
                return levelItem;
            }
            return [];

        },
        _filterOptionChanged: function (args) {
            var filterValue = this._getAdvancedFiltervalue(this._selectedFieldName, this._selectedLevelUniqueName);
            if (filterValue.length > 0) {
                if (filterValue[0].advancedFilterType == 'label' && args.value.replace(/ /g, '') == filterValue[0].labelFilterOperator)
                    filterValue = filterValue[0].values;
                else if (filterValue[0].advancedFilterType == 'value' && args.value.replace(/ /g, '') == filterValue[0].valueFilterOperator)
                    filterValue = filterValue[0].values;
                else
                    filterValue = [""];
            }
            else
                filterValue = [""];            
            var valuesTd = this.element.find(".filterValuesTd")[0];
            if (args.value.toLowerCase().indexOf("between") >= 0)
                $(valuesTd).html("<input type='text' id='filterValue1' class='filterValues' value='" + filterValue[0] + "' style='display:inline'/> <span>" + this._getLocalizedLabels("and") + "</span> <input type='text' id='filterValue2' value='" + (ej.isNullOrUndefined(filterValue[1]) ? "" : filterValue[1]) + "' class='filterValues' style='display:inline' /> </br>");
            if (args.value.toLowerCase().indexOf("between") < 0)
                $(valuesTd).html("<input type='text' id='filterValue1' class='filterValues' value='" + filterValue[0] + "' style='display:inline'/>");
        },
        _removeFilterTag: function (uniqueName) {
            var isPivotServerMode = (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
            if (uniqueName.indexOf("].") >= 0 || isPivotServerMode) {
                var removeElement = (uniqueName.split("].").length > 2 || isPivotServerMode) ? "levelUniqueName" : "hierarchyUniqueName";
                if (this._excelFilterInfo.length > 0) {
                    levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;
                    this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                        if (!(item[removeElement] == uniqueName))
                            return item;
                    });
                }
            }
        },
        _filterElementOkBtnClick: function (args) {
            var selectedOperator = this.element.find(".filterOptions")[0].value,
                enteredValue = [this.element.find("#filterValue1")[0].value],
                filterInfo = [], currentHierarchy = this._selectedFieldName,
                currentLevelInfo = this._selectedLevelUniqueName.toLowerCase();

            if (this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                var report, reportName="", selectedMeasure='';
                try { report = JSON.parse(this.model.pivotControl.getOlapReport()).Report; }
                catch (err) { report = this.model.pivotControl.getOlapReport(); }
                this._removeFilterTag(this._selectedLevelUniqueName);
                if (this.model.pivotControl.element.find('.reportlist'))
                    reportName = this.model.pivotControl.element.find('.reportlist').data("ejDropDownList").model.value;
                if (ej.isNullOrUndefined(this._excelFilterInfo))
                    this._excelFilterInfo = [];
              if (this._filterAction == "labelFiltering") {
                    this.model.pivotControl._excelFilterInfo.push({ report: reportName, action: this._filterAction, hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, operator: selectedOperator, measure: selectedMeasure, value1: "", value2: "" });
                    var selectedData = this._curFilteredText;
                    this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                    var filterParams = this._curFilteredAxis + "::" + this._curFilteredText + "##" + selectedOperator + "::" + enteredValue[0] + ((this.model.pivotControl && $(this.model.pivotControl.element).hasClass("e-pivotclient") && !ej.isNullOrUndefined(this.model.pivotControl._ascdes) && this.model.pivotControl.model.enableAdvancedFilter) ? ">>#>#>>" + this.model.pivotControl._ascdes : "");
                    var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": this._filterAction, "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.pivotControl.model.layout });
                    this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.filtering, eventArgs, this._filterElementSuccess);
                }
                else {
                    var selectedData = this._curFilteredText;
                    this.model.pivotControl._excelFilterInfo.push({ report: reportName, action: this._filterAction, hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, operator: selectedOperator, measure: selectedMeasure, value1: "", value2: "" });
                    this._tempFilterData = $.map(this._tempFilterData, function (item, i) { if (!(item[selectedData])) return item; });
                    this._measureDDL = this.element.find(".filterMeasures").data("ejDropDownList");
                    selectedMeasure = this._measureDDL.getSelectedValue();
                    var filterParams = this._curFilteredText + "::" + selectedOperator + "::" + selectedMeasure + "::" + enteredValue[0] + "::" + (this.element.find("#filterValue2").length > 0 ? this.element.find("#filterValue2")[0].value : "") + ((this.model.pivotControl && $(this.model.pivotControl.element).hasClass("e-pivotclient") && !ej.isNullOrUndefined(this.model.pivotControl._ascdes) && this.model.pivotControl.model.enableAdvancedFilter) ? ">>#>#>>" + this.model.pivotControl._ascdes : "");
                    var serializedCustomObject = JSON.stringify(this.model.customObject), eventArgs = JSON.stringify({ "action": this._filterAction, "filterParams": filterParams, "sortedHeaders": this._ascdes, "currentReport": report, "valueSorting": JSON.stringify(this.model.valueSortSettings), "customObject": serializedCustomObject, "gridLayout": this.model.layout });
                    this.doAjaxPost("POST", this.model.pivotControl.model.url + "/" + this.model.serviceMethods.filtering, eventArgs, this._filterElementSuccess);

                }
                return false;
            }
            if (this._filterAction == "valueFiltering") {
                if (!(!isNaN(parseFloat(enteredValue[0])) && isFinite(enteredValue[0])) || this._measureDDL.getSelectedValue() == "") { return; };
                this.element.find("#filterValue2")[0] != undefined ? "," + enteredValue.push(this.element.find("#filterValue2")[0].value) : enteredValue;
            }
            this.element.find(".e-dialog").remove();
            var reportItem = ej.Pivot.getReportItemByFieldName(currentHierarchy, this.model.pivotControl.model.dataSource).item
            if (reportItem) {
                delete reportItem["filterItems"];
                if (reportItem["advancedFilter"])
                    filterInfo = $.map(reportItem["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLocaleLowerCase() != currentLevelInfo.toLowerCase())) return obj; });
                if (this._filterAction.toLowerCase() == "labelfiltering")
                    filterInfo.push({ name: this._selectedLevelUniqueName, labelFilterOperator: selectedOperator.replace(/ /g, ""), advancedFilterType: ej.olap.AdvancedFilterType.LabelFilter, values: enteredValue });
                else
                    filterInfo.push({ name: this._selectedLevelUniqueName, valueFilterOperator: selectedOperator.replace(/ /g, ""), advancedFilterType: ej.olap.AdvancedFilterType.ValueFilter, values: enteredValue, measure: this._measureDDL.getSelectedValue() });

                this.model.pivotControl._currentReportItems = $.grep(this.model.pivotControl._currentReportItems, function (value, i) { if (value["fieldName"] != currentHierarchy) return value; });
                reportItem["advancedFilter"] = filterInfo;
            }
            if (this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                ej.PivotAnalysis._valueFilterArray = $.grep(ej.PivotAnalysis._valueFilterArray, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() != currentHierarchy.toLowerCase())) return obj; });
                if (this._filterAction == "valueFiltering" && !ej.isNullOrUndefined(reportItem)) {
                    ej.PivotAnalysis._valueFilterArray.push(reportItem);
                }
                this.model.pivotControl.refreshControl();
            }
            else
                ej.olap.base.getJSONData({ action: "advancedfiltering" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
        },
        _groupLabelChange: function (args) {

            var filterMenuObj = this.element.find(".filterElementTag").data("ejMenu");
            filterMenuObj.disableItemByID("labelClearFilter");
            filterMenuObj.disableItemByID("valueClearFilter");
            filterMenuObj.disableItemByID("clearAllFilters");
            filterMenuObj.disableItemByID("clearSorting");
            if (this.model.pivotControl && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)
            {
                this.model.pivotControl._selectedLevelUniqueName = args.selectedValue;
                var filterInfo = [], filterIndicator = ej.buildTag("span.filterState").addClass("e-icon").attr("aria-label", "filter state")[0].outerHTML;
                if (this.model.pivotControl._excelFilterInfo.length > 0) {
                    var levelName = this.model.pivotControl._selectedLevelUniqueName, hierarchyName = this.model.pivotControl._selectedFieldName;
                    filterInfo = $.map(this.model.pivotControl._excelFilterInfo, function (item, index) {
                        if (item.hierarchyUniqueName == hierarchyName && item.levelUniqueName == levelName)
                            return { action: item.action, operator: item.operator, value1: item.value1 };
                    });
                }
                this.element.find(".filterElementTag .activeFilter,.filterState").remove();
                this.element.find("#labelClearFilter ,#valueClearFilter").css("opacity", "0.5").attr("disable", true);

                if (filterInfo.length > 0 && !ej.isNullOrUndefined(filterInfo[0]["operator"])) {
                    var filterTag = (filterInfo[0].action.toLowerCase() == "valuefiltering") ? "valueFilterBtn" : "labelFilterBtn";
                    if(filterTag=="labelFilterBtn")
                        filterMenuObj.enableItemByID("labelClearFilter");
                    else
                        filterMenuObj.enableItemByID("valueClearFilter");
                    filterMenuObj.enableItemByID("clearAllFilters");
                    this.element.find("#" + filterTag + " a:eq(0)").append(filterIndicator);
                    this.element.find("#" + filterTag + " #labelClearFilter").removeAttr("style disable");
                    this.element.find("#" + filterTag + " #valueClearFilter").removeAttr("style disable");

                    if (filterInfo[0]["operator"].replace(/ /g, '') == "BottomCount") 
                        this.element.find("#" + filterTag + " li#" + filterInfo[0]["operator"].replace(/ /g, '').replace("Bottom", "top") + " a").append($(ej.buildTag("span.activeFilter e-icon")[0].outerHTML));                    
                    else
                        this.element.find("#" + filterTag + " li#" + filterInfo[0]["operator"].replace(/ /g, '') + " a").append($(ej.buildTag("span.activeFilter e-icon")[0].outerHTML));
                }
                else {
                    if (this._getUnSelectedNodes() != "")
                        this.element.find(".memberEditorDiv").before("<div class='filterState e-icon' style='top:126px;position:absolute;visibility:hidden'  />");
                }
                if (this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    var filterElem = this.element.find("#clearAllFilters a").children().clone();
                     this.element.find("#clearAllFilters a").text(this._getLocalizedLabels("ClearFilter") + " from \"" + args.text + "\"").append(filterElem);
                    var levelName = this.model.pivotControl._curFilteredText;
                    var sorting = ej.isNullOrUndefined(this.model.pivotControl._ascdes) ? [] : $.grep(this.model.pivotControl._ascdes.split("##"), function (value, i) { if (value == levelName) return value; });
                    if (sorting.length > 0) {
                        this.element.find(".descImage").addClass("selectedSort");
                        filterMenuObj.enableItemByID("clearSorting");
                    }
                    else
                        this.element.find(".ascImage").addClass("selectedSort");
                }
                return false;
            }
            var me = this;//this.element.hasClass("e-pivotschemadesigner") ? this.model.pivotControl : 
            var selectedLevelInfo = this.element.find(".groupLabelDrop").length > 0 ? this.element.find(".groupLabelDrop").data("ejDropDownList") : [];
            var filterData = me._getAdvancedFiltervalue(me._selectedFieldName, selectedLevelInfo.getSelectedValue());
            var filterMenuObj = this.element.find(".filterElementTag").data("ejMenu");          
            var isIncludeFilter = ej.Pivot.getReportItemByFieldName(me._selectedFieldName, me.model.pivotControl.model.dataSource).item;
            var filterIndicator = ej.buildTag("span.filterState").addClass("e-icon").attr("aria-label", "filter state")[0].outerHTML;
            var activeFilter = ej.buildTag("span.activeFilter").addClass("e-icon")[0].outerHTML;

            var reportItem = ej.Pivot.getReportItemByFieldName(me._selectedFieldName, me.model.pivotControl.model.dataSource).item, selectedOrder;
            if (reportItem) {
                if (reportItem["sortOrder"] && reportItem["sortOrder"] != ej.olap.SortOrder.None) {
                    selectedOrder = (reportItem["sortOrder"] == ej.olap.SortOrder.Descending) ? "desc" : "asc";
                    if (ej.isNullOrUndefined(selectedOrder) || selectedOrder == "asc")
                        this.element.find(".clientDialog .ascImage").addClass("selectedSort");
                    else {
                        this.element.find(".clientDialog .descImage").addClass("selectedSort");                        
                        filterMenuObj.enableItemByID("clearSorting");
                    }
                }
                else
                    this.element.find("#clearSorting").css("opacity", "0.5").attr("disabled", "disabled");
            }
            this.element.find("#clearAllFilters").css("opacity", "0.5").attr("disabled", "disabled");
            this.element.find(".filterState,.activeFilter").remove();
            var filterElem = this.element.find("#clearAllFilters a").children().clone();
            this.element.find("#clearAllFilters a").text(this._getLocalizedLabels("ClearFilter") + " from \"" + args.text + "\"").append(filterElem);

            if (filterData.length > 0) {
                if (filterData[0]["advancedFilterType"] == ej.olap.AdvancedFilterType.LabelFilter) {
                    this.element.find("#labelFilterBtn a:eq(0)").append(filterIndicator);
                    this.element.find("#labelFilterBtn .clearFilter").css("opacity", "1").removeAttr("disabled");
                    this.element.find("#labelFilterBtn li#" + filterData[0]["labelFilterOperator"] + " a").append(activeFilter);
                    filterMenuObj.enableItemByID("labelClearFilter");
                }
                else {
                    this.element.find("#valueFilterBtn a:eq(0)").append(filterIndicator);
                    this.element.find("#valueFilterBtn .clearFilter").css("opacity", "1").removeAttr("disabled");
                    this.element.find("#valueFilterBtn li#" + filterData[0]["valueFilterOperator"] + " a").append(activeFilter);
                    filterMenuObj.enableItemByID("valueClearFilter");
                }
                filterMenuObj.enableItemByID("clearAllFilters");
                this.element.find("#clearAllFilters").css("opacity", "1").removeAttr("disabled");
            }
            else if ((isIncludeFilter.length > 0 && isIncludeFilter[0]["filterItems"]) || (this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && isIncludeFilter && isIncludeFilter.filterItems)) {
                this.element.find(".memberEditorDiv").before(filterIndicator);
                this.element.find(".filterState").addClass("memberFilter").css("visibility","hidden");
                this.element.find("#clearAllFilters").css("opacity", "1").removeAttr("disabled");
            }
        },

        _clearAllFilter: function (args) {
            ej.Pivot.closePreventPanel(this);
            this.element.find(".e-dialog").remove();
            this._clearFilter(this._selectedFieldName, this._selectedLevelUniqueName, this.model.pivotControl.model.dataSource);
            var reportItem = ej.Pivot.getReportItemByFieldName(this._selectedFieldName, this.model.pivotControl.model.dataSource);
            if (reportItem && reportItem.item && reportItem.item.filterItems)
                reportItem.item.filterItems.values = [];
            if (this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var fieldName = this._selectedFieldName;
                ej.PivotAnalysis._valueFilterArray = $.grep(ej.PivotAnalysis._valueFilterArray, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() != fieldName.toLowerCase())) return obj; });
                this.model.pivotControl.refreshControl();
            }
            else
                ej.olap.base.getJSONData({ action: "advancedfiltering" }, this.model.pivotControl.model.dataSource, this.model.pivotControl);
        },

        _clearFilter: function (currentHierarchy, currentLevelInfo, dataSource) {
            var reportItem = ej.Pivot.getReportItemByFieldName(currentHierarchy, dataSource);
            if (reportItem.item && reportItem.item["advancedFilter"]) {
                currentLevelInfo =(this.model.pivotControl && this.model.pivotControl.model.analysisMode == ej.Pivot.AnalysisMode.Pivot && this.model.pivotControl.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) ? currentHierarchy: currentLevelInfo;
                reportItem.item["advancedFilter"] = $.map(reportItem.item["advancedFilter"], function (obj, index) { if (obj.name != undefined && (obj.name.toLowerCase() != currentLevelInfo.toLowerCase())) return obj; });
            }
        },
        _createPivotButton: function (text, axis, isFiltered, isSorted, dropPostion) {
            var filtered = "", descending = "";
            if (isFiltered) { filtered = "filtered" };
            if (isSorted) { descending = "descending" };
            var pvtAxis = axis == "row" ? ".schemaRow" : axis == "column" ? ".schemaColumn" : axis == "value" ? ".schemaValue" : ".schemaFilter";
            if (this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                var tagAxis = axis == "column" ? "columns" : axis == "row" ? "rows" : axis == "filter" ? "filters" : "values";
              //test  var rowBtn = ej.buildTag("div.pivotButton", ej.buildTag("div.dropIndicator")[0].outerHTML + ej.buildTag("button.pvtBtn#pivotButton" + text.fieldName, ((text.fieldCaption != undefined) ? text.fieldName : text.fieldCaption), {}, { "fieldName": text.fieldName, "axis": tagAxis })[0].outerHTML +
                var sortBtn = (axis == "column" || axis == "row") && this.model.layout != "excel" && this._dataModel != "Olap" && this._dataModel != "XMLA" ? ej.buildTag("span.sorting e-icon " + descending).attr("role", "button").attr("aria-label", "sort").attr("aria-expanded", "false")[0].outerHTML : "",
                filterBtn = (axis == "column" || axis == "row" || axis == "filter") && this.model.layout != "excel" && text.fieldCaption != "Measures" ? ej.buildTag("span.filter e-icon " + filtered).attr("role", "button").attr("aria-label", "filter")[0].outerHTML : "",
                removeBtn = this.model.layout != "excel" ? ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML : "",
                    rowBtn = ej.buildTag("div.pivotButton", ej.buildTag("div.dropIndicator")[0].outerHTML + ej.buildTag("div.pvtBtnDiv", ej.buildTag("button.pvtBtn#pivotButton" + text.fieldName, this.model.pivotControl._dataModel != "XMLA" ? $.grep(this.model.pivotTableFields, function (item) { return item.name == text.fieldName; })[0].caption : text.fieldCaption, {}, { "fieldName": text.fieldName, "fieldCaption": text.fieldCaption, "axis": tagAxis })[0].outerHTML +
                   filterBtn + sortBtn + removeBtn).attr("tag", tagAxis + ":" + text.fieldName)[0].outerHTML).attr("tag", tagAxis + ":" + text.fieldName)[0].outerHTML;
            }
            else {
                var filterState = "";
                var item = { DimensionName: text.fieldName, DimensionHeader: text.fieldCaption, Tag: text.fieldName };
                if (!ej.isNullOrUndefined(this.model.pivotControl) && axis == "filter") {
                    filterState = ej.Pivot._getFilterState("", [], item, this.model.pivotControl);
                }
                var tagAxis = axis == "column" ? "columns" : axis == "row" ? "rows" : axis == "filter" ? (this.model.pivotControl.model.analysisMode == ej.PivotGrid.AnalysisMode.Pivot ? "filters" : "slicers") : "values";
                var sortBtn = (axis == "column" || axis == "row") && this.model.layout != "excel" && this._dataModel != "Olap" && this._dataModel != "XMLA" ? ej.buildTag("span.sorting e-icon " + descending).attr("role", "button").attr("aria-label", "sort").attr("aria-expanded", "false")[0].outerHTML : "",
                filterBtn = (axis == "column" || axis == "row" || axis == "filter") && this.model.layout != "excel" && text.fieldCaption != "Measures" ? ej.buildTag("span.filter e-icon " + filtered).attr("role", "button").attr("aria-label", "filter")[0].outerHTML : "",
                removeBtn = this.model.layout != "excel" ? ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML : "",
                rowBtn = ej.buildTag("div.pivotButton", ej.buildTag("div.dropIndicator")[0].outerHTML + ej.buildTag("div.pvtBtnDiv", ej.buildTag("button.pvtBtn#pivotButton" + text.fieldName, ((this._dataModel == "Pivot" ? (text.fieldCaption) : (text == "Measures" ? text : (!ej.isNullOrUndefined(text["fieldCaption"]) && text["fieldCaption"] != "" ? text["fieldCaption"] : text.fieldName.split(".")[1]))) + (filterState != "" ? (" (" + filterState + ")") : "")), {}, { "fieldName": text.fieldName, "fieldCaption": text.fieldCaption, "axis": tagAxis })[0].outerHTML +
                filterBtn + sortBtn + removeBtn).attr("tag", tagAxis + ":" + text.fieldName)[0].outerHTML).attr("tag", tagAxis + ":" + (!ej.isNullOrUndefined(text["fieldName"]) ? text["fieldName"] : text))[0].outerHTML;
            }
            if (typeof (dropPostion) == "number" && $(this.element.find(pvtAxis + " .pivotButton")[dropPostion]).length > 0)
                axis == "row" ? $(this.element.find(".schemaRow .pivotButton")[dropPostion]).before(rowBtn) : axis == "column" ? $(this.element.find(".schemaColumn .pivotButton")[dropPostion]).before(rowBtn) :
            axis == "value" ? $(this.element.find(".schemaValue .pivotButton")[dropPostion]).before(rowBtn) : axis == "filter" ? $(this.element.find(".schemaFilter .pivotButton")[dropPostion]).before(rowBtn) : "";
            else
                axis == "row" ? this.element.find(".schemaRow").append(rowBtn) : axis == "column" ? this.element.find(".schemaColumn").append(rowBtn) :
            axis == "value" ? this.element.find(".schemaValue").append(rowBtn) : axis == "filter" ? this.element.find(".schemaFilter").append(rowBtn) : "";
            var pvtExp = (typeof (dropPostion) != "number" && dropPostion == "") ? " .pivotButton .pvtBtn:last" : " .pivotButton .pvtBtn:eq(" + dropPostion + ")";
            if (this.model.enableDragDrop) {
                this.element.find(pvtAxis + pvtExp).ejButton({ size: "normal", type: ej.ButtonType.Button, enableRTL: this.model.enableRTL }).ejDraggable({
					handle: 'button', clone: true,
					cursorAt: { left: -5, top: -5 },
					dragStart: ej.proxy(function (args) {
						this._isDragging = true;
					}, this),
					dragStop: ej.proxy(this.model.pivotControl.model.operationalMode==ej.Pivot.OperationalMode.ServerMode?this._pvtBtnDropped:this._clientOnPvtBtnDropped, this),
					helper: ej.proxy(function (event, ui) {
					    $(event.element).addClass("dragHover");
						if (event.sender.target.className.indexOf("e-btn") > -1) {
							var btnClone = $(event.sender.target).clone().attr("id",this._id+"_dragClone").appendTo('body');
                            $("#"+this._id + "_dragClone").removeAttr("style").height($(event.sender.target).height());
                            return btnClone;            
                        }
						else
							return false;
					}, this)
				});
			}
            this.element.find(pvtAxis + " .pivotButton .filterBtn:last").ejButton({
                size: "normal",
                enableRTL: this.model.enableRTL,
                type: ej.ButtonType.Button,
                contentType: "imageonly",
                prefixIcon: "filter"
            });
            this.element.find(pvtAxis + " .pivotButton input:last").ejToggleButton({
                size: "normal",
                enableRTL: this.model.enableRTL,
                contentType: "imageonly",
                defaultPrefixIcon: "ascending",
                activePrefixIcon: "descending",
                click: ej.proxy(this._sortBtnClick, this)
            });
            if (isSorted) {
                this.element.find(pvtAxis + " .pivotButton:contains(" + text + ") span:eq(0) span").removeClass("ascending").addClass("descending");
                this.element.find(pvtAxis + " .pivotButton:contains(" + text + ") span:eq(0) button").addClass("e-active");
            }
            if (this.model.pivotControl._dataModel == "XMLA") {
                if (this.element.find(".pivotButton[tag*=':Measures']").length > 0) {
                    var cloneBtn = $(pvtAxis + " .pivotButton[tag*=':Measures']");
                    $(pvtAxis).append(cloneBtn);
                }
            }
            this.element.find(".dropIndicator").removeClass("dropIndicatorHover");
            this._createContextMenu();
        },

        _createContextMenu: function () {
            var ele = this.element.find(".pivotButton");
            if (this.model.pivotControl != null) {
                var contextTag = ej.buildTag("ul.pivotTreeContextMenu#pivotTreeContextMenu", ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToFilter"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToRow"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToColumn"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToValues"))[0].outerHTML)[0].outerHTML)[0].outerHTML;
                $(this.element).append(contextTag);
                $("#pivotTreeContextMenu").ejMenu({
                    menuType: ej.MenuType.ContextMenu,
                    enableRTL: this.model.enableRTL,
                    openOnClick: false,
                    contextMenuTarget: ele,
                    click: ej.proxy(this._contextClick, this),
                    beforeOpen: ej.proxy(this._onContextOpen, this),
                    close: ej.proxy(ej.Pivot.closePreventPanel, this)
                });
            }
        },

        _createPivotButtons_1: function (rows, axis) {
            if (!ej.isNullOrUndefined(rows)) {
                var rowBtns = "", tagAxis = axis == "column" ? "Columns" : axis == "row" ? "Rows" : axis == "filter" ? "Slicers" : "";
                if (this.model.pivotControl != null && this.model.pivotControl.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode) {
                    var tagAxis = axis == "column" ? "Columns" : axis == "row" ? "Rows" : axis == "filter" ? "Slicers" : "values";
                    if (tagAxis == "values" && this.model.pivotControl._dataModel == "XMLA")
                        rows = $.map(rows, function (obj, index) { return obj["measures"]; });
                    for (var i = 0; i < rows.length; i++) {
                        var filter = (this.model.pivotControl._dataModel == "XMLA" || this.model.pivotControl._dataModel == "Olap") ? "" : !ej.isNullOrUndefined(rows[i].filterItems) ? "filtered" : "";
                        var sort = (this.model.pivotControl._dataModel == "XMLA" || this.model.pivotControl._dataModel == "Olap") ? "" : rows[i].sortOrder == ej.PivotAnalysis.SortOrder.Descending ? "descending" : "";
                        var buttonId = this.model.pivotControl._dataModel == "XMLA" ? "" : rows[i].fieldName;
                        var sortBtn = (axis == "column" || axis == "row") && this.model.layout != "excel" && this.model.pivotControl._dataModel != "Olap" && this.model.pivotControl._dataModel != "XMLA" ? ej.buildTag("span.sorting e-icon " + sort).attr("role", "button").attr("aria-label", "sort").attr("aria-expanded", "false")[0].outerHTML : "",
                        filterBtn = (axis == "column" || axis == "row" || axis == "filter") && this.model.layout != "excel" && rows[i].fieldCaption != "Measures" ? ej.buildTag("span.filter e-icon " + filter).attr("role", "button").attr("aria-label", "filter")[0].outerHTML : "",
                        removeBtn = this.model.layout != "excel" ? ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML : "";
                        rowBtns += ej.buildTag("div.pivotButton",
                                    ej.buildTag("div.dropIndicator")[0].outerHTML + ej.buildTag("div.pvtBtnDiv",
                                    ej.buildTag("button.pvtBtn#pivotButton" + buttonId, this.model.pivotControl._dataModel == "XMLA" ? (rows[i].fieldCaption != undefined ? rows[i].fieldCaption : rows[i].fieldName) || rows[i] : $.grep(this.model.pivotTableFields, function (item) { return item.name == rows[i].fieldName; })[0].caption || $.grep(this.model.pivotTableFields, function (item) { return item.name == rows[i]; })[0].caption, {}, { "fieldName": rows[i].fieldName || rows[i], "axis": tagAxis })[0].outerHTML +   //+#pivotButton rows[i].fieldName || rows[i]
                                    filterBtn + sortBtn + removeBtn).attr("tag", tagAxis + ":" + rows[i].fieldName || rows[i])[0].outerHTML).attr("tag", tagAxis + ":" + rows[i].fieldName || rows[i])[0].outerHTML;
                    }
                }
                else {
                    if (tagAxis == "" && axis == "values") {
                        var tempAxis = this.element.find(".pivotButton:contains(" + this._getLocalizedLabels("Measures") + ")").length > 0 ? this.element.find(".pivotButton:contains('" + this._getLocalizedLabels("Measures") + "')").parent()[0].className.split(" ")[0] : "schemaColumn";
                        tagAxis = tempAxis == "schemaColumn" ? "Columns" : "Rows";
                    }
                    for (var i = 0; i < rows.length; i++) {
                        rows[i].FieldHeader = rows[i].FieldHeader == "Measures" ? this._getLocalizedLabels("Measures") : rows[i].FieldHeader;
                        var sortBtn = (axis == "column" || axis == "row") && this.model.layout != "excel" && this._dataModel != "Olap" && this._dataModel != "XMLA" ? ej.buildTag("span.sorting e-icon ").attr("role", "button").attr("aria-label", "sort").attr("aria-expanded", "false")[0].outerHTML : "",
                        filterBtn = (axis == "column" || axis == "row" || axis == "filter") && this.model.layout != "excel" && rows[i].FieldHeader != "Measures" ? ej.buildTag("span.filter e-icon").attr("role", "button").attr("aria-label", "filter")[0].outerHTML : "",
                        removeBtn = this.model.layout != "excel" ? ej.buildTag("span.removeBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML : "";
                        rowBtns += ej.buildTag("div.pivotButton", ej.buildTag("div.dropIndicator")[0].outerHTML + ej.buildTag("div.pvtBtnDiv", ej.buildTag("button.pvtBtn#pivotButton" + rows[i].FieldHeader || rows[i].FieldName || rows[i].Name || rows[i].DimensionName, rows[i].FieldHeader || rows[i].FieldName || rows[i].Name || rows[i].DimensionName)[0].outerHTML +
                        filterBtn + sortBtn + removeBtn).attr("tag", tagAxis + ":" + rows[i].Tag)[0].outerHTML).attr("tag", tagAxis + ":" + rows[i].Tag)[0].outerHTML;
                    }
                }
                this._createContextMenu();
                return rowBtns;
            }
        },

        _setSplitBtnTargetPos: function (event) {
            var targetPosition = ""; var AEBdiv; var targetSplitBtn; var className;
            if (event.event != undefined && event.event.type == "touchend") {
                targetSplitBtn = event.event.originalEvent.target != null ? $(event.event.originalEvent.target).parents(".pivotButton") : $(event.event.originalEvent.srcElement).parents(".pivotButton");
                className = event.event.originalEvent.target != null ? event.event.originalEvent.target.className : event.event.originalEvent.srcElement.className;
            }
            else {
                targetSplitBtn = ej.isNullOrUndefined(event.originalEvent) ? $(event.target).parents(".pivotButton") : event.originalEvent.target != null ? $(event.originalEvent.target).parents(".pivotButton") : $(event.originalEvent.srcElement).parents(".pivotButton");
                className = ej.isNullOrUndefined(event.originalEvent) ? $(event.target).attr("class") ? $(event.target).attr("class") : "" : event.originalEvent.target != null && $(event.originalEvent.target).attr("class") ? $(event.originalEvent.target).attr("class") : $(event.originalEvent.srcElement).attr("class") ? $(event.originalEvent.srcElement).attr("class") : "";
            }
            this._droppedClass = targetSplitBtn.length > 0 ? $(targetSplitBtn[0]).parent()[0].className.split(" ")[0] : className.split(" ")[0];
            if (targetSplitBtn[0] || (className != undefined && className != null && jQuery.type(className) == "string" && className.indexOf("pivotButton") > -1)) {
                targetSplitBtn = targetSplitBtn[0] ? targetSplitBtn[0] : event.originalEvent.target != null ? event.originalEvent.target : event.originalEvent.srcElement;
                if (event.event != undefined && event.event.type == "touchend")
                    AEBdiv = event.target;
                else if (this._droppedClass != null && this._droppedClass != undefined && this._droppedClass != "")
                    AEBdiv = this.element.find("." + this._droppedClass)[0];
                else
                    AEBdiv = targetSplitBtn.parentNode;
                AEBdiv =$(AEBdiv).children(".pivotButton");
                for (var i = 0; i < AEBdiv.length; i++) {
                    if ($(AEBdiv[i]).attr("tag") == $(targetSplitBtn).attr("tag"))
                        targetPosition = i;
                }
            }
            return targetPosition;
        },

        _getUnSelectedNodes: function () {
            var treeElement = this.element.find(".editorTreeView")[0];
            var unselectedNodes = "";
            var data = $(treeElement).find(":input.nodecheckbox:not(:checked)");
            for (var i = 0; i < data.length; i++) {
                if (!($(data[i].parentElement).find('span:nth-child(1)').attr('class').indexOf("e-chk-act") > -1) && $(data[i].parentElement).attr('aria-checked') != 'mixed') {
                    var parentNode = $(data[i]).parents('li:eq(0)');
                    unselectedNodes += "::" + parentNode[0].id + "||" + $(parentNode).attr('tag');
                }
            }
            return unselectedNodes;
        },

        _getSelectedNodes: function (isSlicer) {
            if (isSlicer) {
                var treeElement = this.element.find(".editorTreeView")[0].childNodes[0];
                var selectedNodes = new Array();
                var data = $(treeElement).children();
                for (var i = 0; i < data.length; i++) {
                    var parentNode = data[i];
                    var nodeInfo = { caption: $(parentNode.firstChild).find("a").text(), parentId: parentNode.parentElement.parentElement.className.indexOf("editorTreeView") > -1 ? "None" : $(parentNode).parents()[1].id, id: parentNode.id, checked: $(parentNode).find(':input.nodecheckbox')[0].checked || ($(parentNode).find('span:nth-child(1)').attr('class').indexOf("e-chk-indeter") > -1), expanded: $(parentNode.firstChild).find(".e-minus").length > 0 ? true : false, childNodes: new Array(), tag: $(parentNode).attr('tag') };
                    if ($(parentNode).find("ul:first").children().length > 0) {
                        var liElements = $(parentNode).find("ul:first").children();
                        for (var j = 0; j < liElements.length; j++) {
                            nodeInfo.childNodes.push(this._getNodeInfo(liElements[j]));
                        }
                    }
                    selectedNodes.push(nodeInfo);
                }
                return JSON.stringify(selectedNodes);
            }
            else {
                var treeElement = $(".editorTreeView");
                var selectedNodes = "";
                var data = $(treeElement).find(':input.nodecheckbox');
                for (var i = 0; i < data.length; i++) {
                    if (data[i].checked || $(data[i].parentElement).attr('aria-checked') == 'mixed') {
                        var parentNode = $(data[i]).parents('li:eq(0)');
                        selectedNodes += "::" + parentNode[0].id + "||" + $(parentNode).attr('tag');
                    }
                }
                return selectedNodes;
            }
        },

        _getNodeInfo: function (node) {
            var childNode = { caption: $(node.firstChild).find("a").text(), parentId: node.parentElement.parentElement.className.indexOf("editorTreeView") > -1 ? "None" : $(node).parents()[1].id, id: node.id, checked: ($(node).find(':input.nodecheckbox')[0].checked || $(node).find('span:nth-child(1)').attr('class').indexOf("e-chk-indeter") > -1), expanded: $(node.firstChild).find(".e-minus").length > 0 ? true : false, childNodes: new Array(), tag: $(node).attr('tag') };
            if ($(node).find("ul:first").children().length > 0) {
                var liElements = $(node).find("ul:first").children();
                for (var i = 0; i < liElements.length; i++) {
                    childNode.childNodes.push(this._getNodeInfo(liElements[i]));
                }
            }
            return childNode;
        },

        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            this.model.pivotControl.model.editCellsInfo = {};
            var contentType, dataType, successEvt, isAsync = true;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, this, customArgs), isAsync = (!ej.isNullOrUndefined(customArgs) && customArgs["action"] != "loadFieldElements") ? true : false;
            $.ajax({
                type: type,
                url: url,
                contentType: contentType,
                dataType: dataType,
                async: isAsync,
                data: data,
                success: successEvt,
                complete: $.proxy(onComplete, this),
                error: function (msg, textStatus, errorThrown) {
                    this.model.pivotControl._ogridWaitingPopup.hide();
                }
            });
        },
    });

    ej.PivotSchemaDesigner.Locale = {};

    ej.PivotSchemaDesigner.Locale["en-US"] = {
        Sort: "Sort",
        Search: "Search",
        SelectField: "select Field",
        LabelFilterLabel: "Show the items for which the label",
        ValueFilterLabel: "Show the items for which",
        ClearSorting: "Clear Sorting",
        ClearFilterFrom: "Clear Filter From",
        SortAtoZ: "Sort A to Z",
        SortZtoA: "Sort Z to A",
        and: "and",

        LabelFilters: "Label Filters  ",
        BeginsWith: "Begins With",
        DoesNotBeginsWith: "Not Begins With",
        EndsWith: "Ends With",
        DoesNotEndsWith: "Not Ends With",
        Contains: "Contains",
        DoesNotContains: "Not Contains",

        ValueFilters: "Value Filters",
        ClearFilter: "Clear Filter",
        Equals: "Equals",
        DoesNotEquals: "Not Equals",
        GreaterThan: "Greater Than",
        GreaterThanOrEqualTo: "Greater Than Or Equal To",
        LessThan: "Less Than",
        LessThanOrEqualTo: "Less Than Or Equal To",
        Between: "Between",
        NotBetween: "Not Between",
        Top10: "Top Count",

        GreaterThan: "Greater Than",
        IsGreaterThan: "Is Greater Than",
        IsGreaterThanOrEqualTo: "Is Greater Than Or Equal To",
        IsLessThan: "Is Less Than",
        IsLessThanOrEqualTo: "Is Less Than Or Equal To",
        ClearFilter: "Clear Filter",
        SelectField:"Select field",
        Measures: "Measures",
        Warning: "Warning",
        AlertMsg:"The field you are moving cannot be placed in that area of the report",
        Goal: "Goal",
        Status:"Status",
        Trend:"Trend",
        Value: "value",
        AddToFilter: "Add to Filter",
        AddToRow: "Add to Row",
        AddToColumn: "Add to Column",
        AddToValues: "Add to Value",
        PivotTableFieldList: "PivotTable Field List",
        ChooseFieldsToAddToReport: "Choose fields to add to report:",
        DragFieldBetweenAreasBelow: "Drag fields between areas below:",
        ReportFilter: "Filters",
        ColumnLabel: "Columns",
        RowLabel: "Rows",
        Values: "Values",
        DeferLayoutUpdate: "Defer Layout Update",
        Update: "Update",
        OK: "OK",
        Cancel: "Cancel",
        Close: "Close"
    };

    ej.PivotSchemaDesigner.Layouts = {
        Excel: "excel",
        Normal: "normal",
        OneByOne:"onebyone"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to experience Html OLAP Client component elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejPivotClient", "ej.PivotClient", {

        _rootCSS: "e-pivotclient",
        element: null,
        model: null,
        validTags: ["div", "span"],
        defaults: {
            url: "",
            cssClass: "",
            title: "",
            gridLayout: "normal",
            chartType: "column",
            clientExportMode: "chartandgrid",
            enableDeferUpdate: false,
            enablePivotTreeMap: false,
            enableRTL:false,
            enableAdvancedFilter: false,
            enablePaging: false,
            enableSplitter:false,
            enableToolBar: false,
            enableLocalStorage:false,
            enableVirtualScrolling: false,
            enableMemberEditorPaging: false,
            enableDrillThrough: false,
            showUniqueNameOnPivotButton: false,
            isResponsive: false,
            collapseCubeBrowserByDefault: false,
            enableKPI:false,
            dataSource: {
                data: null,
				sourceInfo: "",
                providerName: "ssas",
                enableAdvancedFilter: false,
                isFormattedValues: false,
                reportName: "Default",
                columns: [],
                cube: "",
                catalog: "",
                rows: [],
                values: [],
                filters: [],
                pagerOptions: {
                    categoricalPageSize: 0,
                    seriesPageSize: 0,
                    categoricalCurrentPage: 0,
                    seriesCurrentPage: 0
                }
            },
           displaySettings: {
                mode: "chartandgrid",
                defaultView: "grid",
                controlPlacement: "tab",
                enableTogglePanel: false,
                
                enableFullScreen: false
            },
            serviceMethodSettings: {
                initialize: "InitializeClient",
                removeSplitButton: "RemoveSplitButton",
                filterElement: "FilterElement",
                nodeDropped: "NodeDropped",
		        toggleAxis: "ToggleAxis",
                fetchMemberTreeNodes: "FetchMemberTreeNodes",
                cubeChanged: "CubeChanged",
                measureGroupChanged: "MeasureGroupChanged",
                toolbarServices: "ToolbarOperations",
                memberExpand: "MemberExpanded",
                saveReport: "SaveReportToDB",
                fetchReportList: "FetchReportListFromDB",
                loadReport: "LoadReportFromDB",
                updateReport: "UpdateReport",
                exportPivotClient: "Export",
                mdxQuery: "GetMDXQuery",
                drillThroughHierarchies: "DrillThroughHierarchies",
                drillThroughDataTable: "DrillThroughDataTable",
                paging: "Paging",
                removeDBReport: "RemoveReportFromDB",
                renameDBReport: "RenameReportInDB",
                calculatedMember: "CalculatedMember"
            },
            size: {
                height: "685px",
                width: "1000px"
            },
            toolbarIconSettings: {
                enableAddReport: true,
                enableNewReport: true,
                enableRenameReport: true,
                enableDBManipulation: true,
                enableWordExport: true,
                enableExcelExport: true,
                enablePdfExport: true,
                enableMDXQuery: true,
                enableDeferUpdate: false,
                enableFullScreen: false,
                enableSortOrFilterColumn: true,
                enableSortOrFilterRow: true,
                enableToggleAxis: true,
                enableChartTypes: true,
                enableRemoveReport: true,
                enableCalculatedMember: false
            },
            customObject: {},
            enableMeasureGroups: false,
            locale: "en-US",
            analysisMode: "olap",
            operationalMode: "clientmode",
            renderSuccess: null,
            renderFailure: null,
            renderComplete: null,
            load: null,
            chartLoad: null,
            treeMapLoad: null,
            drillThrough : null,
            beforeExport: null,
            beforeServiceInvoke: null,
            afterServiceInvoke: null,
            saveReport: null,
            loadReport: null,
            fetchReport:null,
            memberEditorPageSize: 100
        },

        dataTypes: {
            dataSource: {
                data: "data",
                columns: "array",
                rows: "array",
                values: "array",
                filters: "array"
            },
            serviceMethodSettings: {
                initialize: "enum",
                removeSplitButton: "enum",
                filterElement: "enum",
                nodeDropped: "enum",
                toggleAxis: "enum",
                fetchMemberTreeNodes: "enum",
                cubeChanged: "enum",
                measureGroupChanged: "enum",
                toolbarServices: "enum",
                memberExpand: "enum",
                saveReport: "enum",
                fetchReportList: "enum",
                loadReport: "enum",
                updateReport: "enum",
                exportPivotClient: "enum",
                mdxQuery: "enum",
                drillThroughHierarchies: "enum",
                drillThroughDataTable: "enum",
                paging: "enum",
                removeDBReport: "enum",
                renameDBReport: "enum",
                calculatedMember: "enum"
            },
            displaySettings: "data",
            customObject: "data"
        },

        observables: ["title", "gridLayout", "displaySettings.mode", "displaySettings.defaultView", "displaySettings.controlPlacement", "displaySettings.enableTogglePanel", "locale"],
        title: ej.util.valueFunction("title"),
        gridLayout: ej.util.valueFunction("gridLayout"),
        displayMode: ej.util.valueFunction("displaySettings.mode"),
        defaultView: ej.util.valueFunction("displaySettings.defaultView"),
        controlPlacement: ej.util.valueFunction("displaySettings.controlPlacement"),
        enableTogglePanel: ej.util.valueFunction("displaySettings.enableTogglePanel"),
        locale: ej.util.valueFunction("locale"),

        _init: function () {
            this._initPrivateProperties();
            this._load();
        },

        _initPrivateProperties: function () {
            this._isCollapseCB = false;
            this._id = this.element.attr("id");
            this.oclientProxy = this;
            this.currentReport = "";
            this.currentCubeName = "";
            //reports = "";
            this.reportsCount = 0;
            this._pivotGrid = null;
            this._pivotChart = null;
            this._pivotSchemaDesigner = null;
            //otreemapObj = null;
            //chartObj = null;
            this._deferReport = "";
            this._keypress = false;
            this._memberTreeObj = null;
            this._chartHeight = 0;
            this._chartWidth = 0;
            this._gridHeight = 0;
            this._gridWidth = 0;
            this._initStyles = new Array();
            this._toggleStyles = new Array();
            this._initToggle = true;
            this._toggleExpand = false;
            this._treemapRender = false;
            this._dimensionName = "";
            this._dllSortMeasure = null;
            this._selectedFieldName = "";
            this._axis = "";
            this._isSorted = false;
            this._isFiltered = false;
            this._sortOrFilterTab = '';
            this._currentAxis = "";
            this._parentElwidth = 0;
            this.pNode = "";
            this.progressPos = null;
            this._selectedReport = "";
            this._isMembersFiltered = false;
            this._pagerObj = null;
            this._dialogTitle = "";
            this._dataModel = " ";
            this._clientReportCollection = [];
            this._drillParams = [];
            this._drillInfo = [];
            this.draggedSplitBtn = null;
            this.isDragging = false;
            this.isDropped = false;
            this.measureGroupInfo = "";
            this._currentTab = this.defaultView();
            this._currentItem = null;
            this._currentReportItems = [];
            this._treeViewData = {};
            this._memberPageSettings = {
                currentMemeberPage: 1,
                startPage: 0,
                endPage: 0
            };
            this._isNodeOrButtonDropped = false;
            this._ischartTypesChanged = false;
            this._isrenderTreeMap = false;
            this._isRemoved = false;
            this._waitingPopup = null;
            this._isGridDrillAction = false;
            this._isChartDrillAction = false;
            this._olapReport = "";
            this._jsonRecords = null;
            this._excelFilterInfo = [];
            this._index = {tab:0,icon:1,chartimg:0,button:1,dialog:0,editor:0,tree:0};
            this._curFocus = { tab: null, icon: null, chartimg: null, button: null, dialog: null, editor: null, tree: null };
            this._seriesCurrentPage = 1;
            this._categCurrentPage = 1;
            this._isReportListAction = true;
            this._currentRecordName = "";
            this._pagingSavedObjects = {
                drillEngine: [],
                savedHdrEngine: [],
                curDrilledItem: {}
            };
            this._fieldMembers = {};
            this._fieldSelectedMembers = {};
            this._allMember = "";
            this._editorTreeData = [];
            this._isSearchApplied = false;
			this._isTimeOut = false;
            this._calcMemberTreeObj = null;
            this._cubeTreeView = null;
            this._calcMemberDialog = null;
            this._calcMembers = [];
            this._selectedCalcMember = null;
        },

        getOlapReport: function () {
            return JSON.parse(this._olapReport);
        },

        setOlapReport: function (olapReport) {
            this._olapReport = JSON.stringify(olapReport);
        },

        getJSONRecords: function () {
            return JSON.parse(this._jsonRecords);
        },

        setJSONRecords: function (records) {
            this._jsonRecords = JSON.stringify(records);
        },

        getActiveTab: function () {
            return this._currentTab;
        },

        _destroy: function () {
            this.element.empty().removeClass("e-pivotclient" + this.model.cssClass);
            if (this._waitingPopup != undefined)
                this._waitingPopup._destroy();
			delete this.oclientProxy;
        },

        _load: function () {
            var eventArgs = { element: this.element, customObject: this.model.customObject };
            if (this.model.enableAdvancedFilter || this.model.dataSource.enableAdvancedFilter)
                this.model.dataSource.enableAdvancedFilter = this.model.enableAdvancedFilter = true;
            this.model.toolbarIconSettings.enableFullScreen = this.model.displaySettings.enableFullScreen = (this.model.toolbarIconSettings.enableFullScreen || this.model.displaySettings.enableFullScreen) ? true : false;
            this.model.toolbarIconSettings.enableDeferUpdate = this.model.enableDeferUpdate = (this.model.enableDeferUpdate) ? true : false;
            this._trigger("load", eventArgs);
            this.element.addClass(this.model.cssClass);
            $("#" + this._id).ejWaitingPopup({ showOnInit: true });
            this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
            if ((this.model.dataSource.data == null && this.model.url != "") || (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)) {
                this.model.operationalMode = ej.Pivot.OperationalMode.ServerMode;
                if (!ej.isNullOrUndefined(this.model.beforeServiceInvoke))
                    this._trigger("beforeServiceInvoke", { action: "initializeClient", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({
                    "action": (this.model.enableDrillThrough && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) ? "initializeClient:getDataSet" : "initializeClient", "customObject": serializedCustomObject, "clientParams": this.model.enableMeasureGroups + "-" + this.model.chartType + "-" + this.model.enableKPI
                }), this._renderControlSuccess);
            }
            else {
                this.model.operationalMode = ej.Pivot.OperationalMode.ClientMode;
                this.model.analysisMode = this.model.dataSource.cube != "" ? ej.Pivot.AnalysisMode.Olap : ej.Pivot.AnalysisMode.Pivot;
                var clientObj = this;
                setTimeout(function () {
                    clientObj._renderLayout();
                    clientObj._createControl();
                    if (clientObj.model.enableSplitter)
                        clientObj._createSplitter();
                }, 0);
                //this._waitingPopup.hide();
            }
        },

        _renderClientControls: function (msg) {
            this._renderLayout();
            this.setOlapReport(msg.PivotReport);
            var report = $.parseJSON(msg.PivotReport);
            this.currentReport = this.getOlapReport() != "" ? JSON.parse(this.getOlapReport()).Report : "";
            this.setJSONRecords({ GridJSON: msg.GridJSON, ChartJSON: msg.ChartJSON });
            this._createControl();
            if (this.model.enableSplitter)
                this._createSplitter();
            if (this.model.enableAdvancedFilter) {
                if (this._pivotGrid)
                    this._pivotGrid._removeCells(msg);
            }
        },

        _createControl: function () {
            var cubes = "";
            this.element.find("#" + this._id + "_PivotSchemaDesigner").ejPivotSchemaDesigner({ pivotControl: this, _waitingPopup: this._waitingPopup, enableRTL: this.model.enableRTL, layout: ej.PivotSchemaDesigner.Layouts.OneByOne, olap: { showKPI: false, showNamedSets: false }, serviceMethods: { nodeDropped: this.model.serviceMethodSettings.nodeDropped, memberExpand: this.model.serviceMethodSettings.memberExpand }, locale: this.model.locale, width: this.model.enableSplitter ? "100%" : this.element.width()/3, height: this.element.find(".controlPanel").height() });
           if (this.model.enablePaging)
            {
                this.element.find("#" + this._id + "_Pager").ejPivotPager({ locale: this.model.locale, mode: ej.PivotPager.Mode.Both, targetControlID: this._id });
                this.element.find(".controlPanel").height(this.element.find(".controlPanel").height() - (this.element.find("#" + this._id + "_Pager").height() + 5));
                this.element.find(".gridContainer").height(this.element.find(".gridContainer").height() - (this.element.find("#" + this._id + "_Pager").height() + 5));
                this.element.find(".chartContainer").height(this.element.find(".chartContainer").height() - (this.element.find("#" + this._id + "_Pager").height() + 10));
           }
           var searchEditor = ej.buildTag("div.searchDiv", ej.buildTag("input#" + this._id + "_SearchTreeView.searchTreeView").attr("type", "text")[0].outerHTML, { "margin": "5px 5px 0px 5px" })[0].outerHTML;
           this.element.find(".parentSchemaFieldTree").prepend(searchEditor);
           this.element.find("#" + this._id + "_SearchTreeView").ejMaskEdit({
               name: "inputbox",
               width: "100%",
               height: "25px",
               inputMode: ej.InputMode.Text,
               watermarkText: this._getLocalizedLabels("Search"),
               maskFormat: "",
               textAlign: this.model.enableRTL ? "right" : "left",
               change: ej.proxy(ej.Pivot._searchTreeNodes, this),
           });
            if (this.model.enableMeasureGroups)
                this._createMeasureGroup();
            var reportList = this._clientReportCollection.length > 0 ? this._clientReportCollection : [{ name: this.model.dataSource.reportName }];
            this.element.find(".reportlist").ejDropDownList({
                dataSource: reportList,
                enableRTL: this.model.enableRTL,
                fields: { text: "name", value: "name" },
                height: "26px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            this.element.find(".reportlist").attr("tabindex", 0);
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                this._clientReportCollection.push(this.model.dataSource);
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode != ej.Pivot.OperationalMode.ClientMode) {
                var tempddlwidth = this.element.find(".csHeader").width() - this.element.find(".cubeText").width() - this.element.find(".toggleExpandButton").width() - (this.model.enableSplitter?50:20);
                var cubeddlWidth = this.enableTogglePanel() ? tempddlwidth - 25 : tempddlwidth;
                var cubeCollection = (cubes == "" ? "" : $.parseJSON(cubes));
                this.element.find(".cubeSelector").ejDropDownList({
                    dataSource: cubeCollection,
                    enableRTL: this.model.enableRTL,
                    fields: { text: "name", value: "name" },
                    width: this.model.enableSplitter&&!this.model.isResponsive?"100%":"" + cubeddlWidth + "px",
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                this.ddlTarget = this.element.find('.cubeSelector').data("ejDropDownList");
                this.ddlTarget.selectItemByText(this.currentCubeName);
            }
            this.reportDropTarget = this.element.find('#reportList').data("ejDropDownList");
            this._isReportListAction = false;
            if (this.reportDropTarget.model.dataSource.length)
                this.reportDropTarget.selectItemByText(this.reportDropTarget.model.dataSource[0].name);
            this._isReportListAction = true;
            this._selectedReport = this.reportDropTarget._currentText;
            this.element.find(".cubeSelector").ejDropDownList("option", "change", ej.proxy(this._cubeChanged, this));
            this.element.find(".cubeSelector").attr("tabindex", 0);
            this.element.find(".reportlist").ejDropDownList("option", "change", ej.proxy(this._reportChanged, this));
            if (this.model.enableMeasureGroups)
                this.element.find(".measureGroupSelector").ejDropDownList("option", "change", ej.proxy(this._measureGroupChanged, this));
            this.element.find("#clientTab").ejTab({ enableRTL: this.model.enableRTL, itemActive: ej.proxy(this._onTabClick, this) });
            if(!this.model.enableSplitter)
			    this.element.find(".controlPanel").width(this.element.width()-this.element.find("#" + this._id + "_PivotSchemaDesigner").width() -(this.model.displaySettings.enableTogglePanel?30:10));
			
            if (this.displayMode() != "chartonly") {
                this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ locale: this.model.locale, customObject: this.model.customObject, enableRTL: this.model.enableRTL, isResponsive: this.model.isResponsive, drillSuccess: ej.proxy(this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._gridDrillSuccess : this._clientGridDrillSuccess, this), enableCollapseByDefault: true });
                this._pivotGrid = this.element.find("#" + this._id + "_PivotGrid").data("ejPivotGrid");
                this._pivotGrid.model.operationalMode = this.model.operationalMode;
                this._pivotGrid.model.analysisMode = this.model.analysisMode;
                this._pivotGrid._waitingPopup = this._waitingPopup;
                this._pivotGrid.model.url = this.model.url;
                this._pivotGrid.model.dataSource = this.model.dataSource;
            }
            if (this.displayMode() != "gridonly") {
                this.element.find("#" + this._id + "_PivotChart").ejPivotChart({ locale: this.model.locale, customObject: this.model.customObject, enableRTL: this.model.enableRTL, canResize: this.model.isResponsive, drillSuccess: ej.proxy(this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this._chartDrillSuccess : this._clientChartDrillSuccess, this), size: { height: this._chartHeight, width: this._chartWidth }, commonSeriesOptions: { type: this.model.chartType, tooltip: { visible: true } } });
                this._pivotChart = this.element.find("#" + this._id + "_PivotChart").data("ejPivotChart");
                this._pivotChart.model.operationalMode = this.model.operationalMode;
                this._pivotChart.model.analysisMode = this.model.analysisMode;
                this._pivotChart._waitingPopup = this._waitingPopup;
                this._pivotChart.model.url = this.model.url;
                this._pivotChart.model.dataSource = this.model.dataSource;
            }
            this._pivotSchemaDesigner = this.element.find("#" + this._id + "_PivotSchemaDesigner").data("ejPivotSchemaDesigner");
            var items = {};
            if (this._pivotChart != null) {
                this.element.find('#' + this._id + '_PivotChart').width(this._pivotChart.model.size.width);
                items["chartModelWidth"] = this._pivotChart.model.size.width;
            }
            items["controlPanelWidth"] = this.element.find(".controlPanel").width();
            items["chartOuterWidth"] = this._chartWidth;
            items["gridOuterWidth"] = this._gridWidth;
            this._initStyles.push(items);

            if (this.model.isResponsive) {
                this._enableResponsive();
                this._parentElwidth = $("#" + this._id).parent().width();
                if (this._parentElwidth < 850)
                    this._rwdToggleCollapse();
                else if (this._parentElwidth > 850)
                    this._rwdToggleExpand();
                this._pivotSchemaDesigner.element.width(((this._pivotSchemaDesigner.element.width() - 30) / this._pivotSchemaDesigner.element.width() * 100) + "%");
            }
            if (this.enableTogglePanel() && this.element.find(".pivotFieldList").length > 0) {
                this.element.find(".togglePanel").height(this.element.find("#" + this._id + "_PivotSchemaDesigner").height()).width(14);
                this.element.find(".toggleExpandButton,.toggleCollapseButton").css("margin-top", (this.element.find("#" + this._id + "_PivotSchemaDesigner").parents("td:eq(0)").height() - 9) / 2);
                this.element.find(".togglePanel").children().addClass("toggleButtons");
            }
            this._trigger("renderSuccess", this);
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
                this.element.find(".fieldTable").css("border", "none");
                this.element.find(".parentSchemaFieldTree").addClass("olapFieldList");
            }
            else {
                if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                    if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                        this._pivotGrid.setJSONRecords(this.getJSONRecords().GridJSON);
                        this._pivotGrid.setOlapReport(this.getOlapReport());
                        if (this.model.gridLayout == "excellikelayout")
                            this._pivotGrid.excelLikeLayout(this._pivotGrid.getJSONRecords());
                        else
                            this._pivotGrid.renderControlFromJSON();
                    }
                    if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                        //this._pivotChart.setPivotEngine(this.getJSONRecords().ChartJSON);
                        if(this._pivotChart.model.enableMultiLevelLabels)
                            this._pivotChart._generateData({ JsonRecords: this.getJSONRecords(), PivotReport: this.getOlapReport() });
                        else
                            this._pivotChart.renderControlSuccess({ JsonRecords: this.getJSONRecords().ChartJSON, OlapReport: this.getOlapReport() });
                    }
                    this.currentReport = this.getOlapReport() != "" ? JSON.parse(this.getOlapReport()).Report : "";
                }
                else {
                    var data = ej.PivotAnalysis.pivotEnginePopulate(this.model);
                    if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                        this._pivotGrid.setJSONRecords(JSON.stringify(data.json));
                        if (this.model.gridLayout == "excellikelayout")
                            this._pivotGrid.excelLikeLayout(data.json);
                        else
                            this._pivotGrid.renderControlFromJSON();
                    }
                    if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                        this._pivotChart.setPivotEngine(data.pivotEngine);
                        this._pivotChart._generateData(data.pivotEngine);
                    }
                }
            }
            this._unWireEvents();
            this._wireEvents();
            if (this.model.collapseCubeBrowserByDefault) {
                this._collapseCubeBrowser();
                this._isCollapseCB = true;
            }
        },

        _createMeasureGroup: function () {
            this.element.find(".measureGroupselector").remove();
            var measureGroupDropdown = "<div class ='measureGroupselector' style='margin:5px 5px 0px 5px'><input type='text' id='measureGroupSelector' class='measureGroupSelector' /></div>";
            $(this.element).find(".cubeBrowser").prepend(measureGroupDropdown);
            this.element.find(".measureGroupSelector").ejDropDownList({
                dataSource: this.measureGroupInfo,
                enableRTL: this.model.enableRTL,
                fields: { text: "name", value: "name" },
                height: "25px",
                width: "100%",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            this.element.find(".measureGroupSelector").attr("tabindex", 0);
            var measureDropTarget = this.element.find('.measureGroupSelector').data("ejDropDownList");
            measureDropTarget.selectItemByText(measureDropTarget.model.dataSource[0].name);
            this.element.find(".measureGroupSelector").ejDropDownList("option", "change", ej.proxy(this._measureGroupChanged, this));
        },

        refreshControl: function (report) {
            if (!ej.isNullOrUndefined(this._pivotSchemaDesigner))
                this._pivotSchemaDesigner._refreshPivotButtons();
            if (this.element.find(".chartTypesDialog").length > 0)
                this.element.find(".chartTypesDialog").remove();
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly)
                this._pivotChart._labelCurrentTags = {};            
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                var reportVal = null, gridJN = null, chartJN = null;
                if (report[0] != undefined) {
                    reportVal = report[0].Value;
                    gridJN = report[1].Value;
                    chartJN = report[2].Value;
                }
                else if (!ej.isNullOrUndefined(report.d)) {
                    reportVal = report.d[0].Value;
                    gridJN = report.d[1].Value;
                    chartJN = report.d[2].Value;
                }
                else {
                    reportVal = report.PivotReport;
                    gridJN = report.GridJSON;
                    chartJN = report.ChartJSON;
                }
                var pivotClient = this;
                this._clientReportCollection = $.map(this._clientReportCollection, function (reportCol, index) {
                    reportCol.report = reportCol.name == pivotClient._currentReportName ? JSON.parse(reportVal).Report : reportCol.report;
                    return reportCol;
                })
                this.setJSONRecords({ "GridJSON": gridJN, "ChartJSON": chartJN });
                this.setOlapReport(reportVal);
                this._pivotGrid.setJSONRecords(gridJN);
                this._pivotGrid.renderControlFromJSON();
                if (this._pivotGrid)
                    this._pivotGrid._removeCells(report);
                if (this._pivotChart._drillAction)
                    this._pivotChart._drillAction = "";
                if (this._pivotChart.model.enableMultiLevelLabels && this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                    this._pivotChart._drillParams = this._drillParams = [];
                    this._pivotChart._generateData({ JsonRecords: report, PivotReport: reportVal });
                }
                else
                    this._pivotChart.renderControlSuccess({ OlapReport: reportVal, JsonRecords: chartJN });
            }
            else {
                if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                    var data = ej.PivotAnalysis.pivotEnginePopulate(this.model);
                    this.generateJSON({ tranposeEngine: data.pivotEngine, jsonObj: data.json })
                }
                else
                    ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
            }
            if (this.model.isResponsive) {
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (!ej.isNullOrUndefined(this.chartObj))
                    this.element.find("#" + this.chartObj._id).ejChart("option", { "model": { size: { height: this._chartHeight } } });
            }
            this._unWireEvents();
            this._wireEvents();
        },

        _setFirst: true,

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "title": this.element.find(".titleText").text(this.title()); break;
                    case "currentCubeName": this.currentCubeName = options[key]; break;
                    case "gridLayout": this._renderPivotGrid(); break;
                    case "olapReport": this.currentReport = options[key]; break;
                    case "clientReports": this.reports = options[key]; break;
                    case "customObject": this.model.customObject = options[key]; break;
                    case "locale": { this.locale(); if (this._pivotGrid || this._pivotChart) this._load(); break; }
                    case "displaySettings": { if (this._pivotGrid || this._pivotChart) this._load(); break; }
                }
            }
        },

        _getMeasuresList: function () {
            var measureName = "";
            this.element.find(".memberEditorDiv").find("div").each(function () { measureName += $(this)[0].id + ","; });
            return measureName;
        },

        _getUnSelectedNodes: function () {
            var unselectedNodes = "";
            if ((this._currentItem.indexOf("Measures") < 0)) {
                 for (var i = 0; i < this._memberTreeObj.dataSource().length; i++) {
                        if (this._memberTreeObj.dataSource()[i].checkedStatus == false)
                            unselectedNodes += "::" + this._memberTreeObj.dataSource()[i].id + "||" + this._memberTreeObj.dataSource()[i].tag + ((this._currentItem.indexOf(this._getLocalizedLabels("KPIs")) == 0) ? ((!ej.isNullOrUndefined(this._memberTreeObj.dataSource()[i].parentId) ? ("~&" + this._memberTreeObj.dataSource()[i].parentId) : "")) : "");
                 }
            }
            return unselectedNodes;
        },

        _getSelectedNodes: function (isSlicer) {
            if (isSlicer) {
                var treeElement = this.element.find(".editorTreeView")[0].childNodes[0];
                var selectedNodes = new Array();
                var data = $(treeElement).children();
                for (var i = 0; i < data.length; i++) {
                    var parentNode = data[i];
                    var nodeInfo = { caption: $(parentNode.firstChild).find("a").text(), parentId: parentNode.parentElement.parentElement.className.indexOf("editorTreeView") > -1 ? "None" : $(parentNode).parents()[1].id, id: parentNode.id, checked: ($(parentNode).find(':input.nodecheckbox')[0].checked || $(parentNode).find('span:nth-child(1)').attr('class').indexOf("e-chk-indeter") > -1), expanded: $(parentNode.firstChild).find(".e-minus").length > 0 ? true : false, childNodes: new Array(), tag: $(parentNode).attr('tag') };
                    if ($(parentNode).find("ul:first").children().length > 0) {
                        var liElements = $(parentNode).find("ul:first").children();
                        for (var j = 0; j < liElements.length; j++) {
                            nodeInfo.childNodes.push(this._getNodeInfo(liElements[j]));
                        }
                    }
                    selectedNodes.push(nodeInfo);
                }
                return JSON.stringify(selectedNodes);
            }
            else {
                var selectedNodes = "";
                if ((this._currentItem.indexOf(this._getLocalizedLabels("Measures")) < 0)) {
                    for (var i = 0; i < this._memberTreeObj.dataSource().length; i++) {
                            if (this._memberTreeObj.dataSource()[i].checkedStatus == true)
                                selectedNodes += "::" + this._memberTreeObj.dataSource()[i].id + "||" + this._memberTreeObj.dataSource()[i].tag + ((this._currentItem.indexOf(this._getLocalizedLabels("KPIs")) == 0) ? ((!ej.isNullOrUndefined(this._memberTreeObj.dataSource()[i].parentId) ? ("~&" + this._memberTreeObj.dataSource()[i].parentId) : "")) : "");
                        }
                   }
                return selectedNodes;
            }
        },

        _getNodeInfo: function (node) {
            var childNode = { caption: $(node.firstChild).find("a").text(), parentId: node.parentElement.parentElement.className.indexOf("editorTreeView") > -1 ? "None" : $(node).parents()[1].id, id: node.id, checked: ($(node).find(':input.nodecheckbox')[0].checked || $(node).find('span:nth-child(1)').attr('class').indexOf("e-chk-indeter") > -1), expanded: $(node.firstChild).find(".e-minus").length > 0 ? true : false, childNodes: new Array(), tag: $(node).attr('tag') };
            if ($(node).find("ul:first").children().length > 0) {
                var liElements = $(node).find("ul:first").children();
                for (var i = 0; i < liElements.length; i++) {
                    childNode.childNodes.push(this._getNodeInfo(liElements[i]));
                }
            }
            return childNode;
        },

        _removeSplitBtn: function () {
            var dragBtn = $(document).find(".dragClone"); var btnTag;
            var clientObj = this;
            var clientBtns = this.element.find(".splitBtn");
            jQuery.each(clientBtns, function (index, value) {
                if ($($(value).children()[0]).attr("title") == $(dragBtn).attr("title")) {
                    btnTag = $(value).attr("tag");
                    $(value).remove();
                }
                if($(dragBtn).attr("title")==clientObj._getLocalizedLabels("Measures"))
                {
                    if ($($(value).children()[0]).attr("title") == clientObj._getLocalizedLabels("KPIs"))
                        $(value).remove();
                }
            });
            if (this._currentReportItems.length != 0) {
                if (this._treeViewData.hasOwnProperty($(dragBtn).attr("title"))) {
                    delete this._treeViewData[$(dragBtn).attr("title")];
                    this._currentReportItems.splice($.inArray($(dragBtn).attr("title"), this._currentReportItems), 1);
                }
            }
            if (this.model.enableAdvancedFilter && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                var btnUniqueName = btnTag.split(":")[1].split(".");
                if (!ej.isNullOrUndefined(btnUniqueName) && btnUniqueName.length == 2) {
                    this._setUniqueNameFrmBtnTag(btnUniqueName);
                    this._removeFilterTag(this._selectedFieldName);
                }
            }
            $(".dragClone").remove();
            this._isTimeOut = true;
            setTimeout(function () {
                if (clientObj._isTimeOut)
                    clientObj._waitingPopup.show();
            }, 800);
            if (this.model.beforeServiceInvoke != null)
                this._trigger("beforeServiceInvoke", { action: "removeSplitButton", element: this.element, customObject: this.model.customObject });
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.removeSplitButton, JSON.stringify({ "action": "removeSplitButton", "clientParams": btnTag, "olapReport": this.currentReport, "clientReports": this.reports, "customObject": serializedCustomObject }), this._removeSplitButtonSuccess)
            this._isNodeOrButtonDropped = true;
        },

        _wireEvents: function () {
            this._wireDialogEvent();
            this._wireEditorRemoveEvent();
            this._wireMeasureRemoveEvent();

            this._on($(document), 'keydown', this._keyPressDown);
            this._on($(document), 'keyup', this._keyPressUp);

            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").find("button").ejDraggable({
                clientObj: this,
                handle: 'button',
                clone: true,
                cursorAt: { top: -10, left: -10 },
                dragStart: function (event, ui) {
                    event.event.preventDefault();
                    $(this.element.find(".e-txt")).off('touchstart');
                    $(this.element.find(".e-txt")).off(ej.eventType.click);
                    this.model.clientObj.isDragging = true;
                    this.element.find(".e-dialog").hide();
                    this.model.clientObj.draggedSplitBtn = event.event.target;
                },
                dragStop: function (event, ui) {
                    this.element.find(".targetAxis").removeClass("targetAxis");
                    this.model.clientObj.isDragging = false;
                    var cssName = null; var droppedPosition;
                    var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                    if (event.event.type == "touchend")
                        droppedPosition = pivotClientObj._setSplitBtnTargetPos(event);
                    else
                        droppedPosition = pivotClientObj._setSplitBtnTargetPos(event.event);
                    if (pivotClientObj._dropAxisClassName != undefined && pivotClientObj._dropAxisClassName != "") {
                        if (pivotClientObj._dropAxisClassName == "outOfAxis")
                            pivotClientObj._removeSplitBtn();
                        else
                            cssName = pivotClientObj._dropAxisClassName;
                        pivotClientObj._dropAxisClassName = "";
                    }
                    else if (event.target != undefined) {
                        if ($(event.target).hasClass("e-btn") || $(event.target).hasClass("removeSplitBtn"))
                            cssName = $(event.target).parents("div:eq(1)").attr("class");
                        else if (jQuery.type(event.target.className) != "string")
                            pivotClientObj._removeSplitBtn();
                        else {
                            if (event.target.className.indexOf("splitBtn") > -1)
                                cssName = $(event.target).parents("div:eq(0)").attr("class");
                            else
                                cssName = event.target.className;
                        }
                    }
                    else {
                        if ($(event.event.originalEvent.srcElement).hasClass("e-btn") || $(event.event.originalEvent.srcElement).hasClass("removeSplitBtn"))
                            cssName = $(event.event.originalEvent.srcElement).parents("div:eq(1)").attr("class");
                        else if (event.event.originalEvent.srcElement.className.indexOf("splitBtn") > -1)
                            cssName = $(event.event.originalEvent.srcElement).parents("div:eq(0)").attr("class");
                        else
                            cssName = event.event.originalEvent.srcElement.className;
                    }
                    if (cssName != undefined && cssName != null) {
                        var axisName = (cssName.indexOf("categoricalAxis") > cssName.indexOf("rowAxis")) ? ((cssName.indexOf("categoricalAxis") > cssName.indexOf("slicerAxis")) ? "Categorical" : "Slicer") : ((cssName.indexOf("rowAxis") > cssName.indexOf("slicerAxis")) ? "Series" : (cssName.indexOf("slicerAxis") >= 0) ? "Slicer" : null);
                        if (axisName != null)
                            pivotClientObj._splitButtonDropped(axisName, droppedPosition);
                        else
                            pivotClientObj._removeSplitBtn();
                        pivotClientObj._setSplitBtnTitle();
                    }
                },
                helper: function (event, ui) {
                    var pivotClientObj = $(event.sender.target).parents(".e-pivotclient").data("ejPivotClient");
                    if (event.sender.target.className.indexOf("e-btn") > -1)
                        return $(event.sender.target).clone().addClass("dragClone").appendTo(pivotClientObj.element);
                    else
                        return false;
                }
            });

            this.element.find(".nextPage, .prevPage, .firstPage, .lastPage").click(function (args) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                ej.Pivot.editorTreeNavigatee(args, pivotClientObj);
            });
            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").mouseover(function () {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (pivotClientObj.isDragging)
                    $(this).addClass("targetAxis");
            });

            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").mouseleave(function () {
                $(this).removeClass("targetAxis");
            });

            this.element.find(".e-btn").mouseover(function (evt) {
                $(evt.target.parentNode).find("span").css("display", "inline");
            });
            if (this.model.enableDrillThrough) {
                this._pivotGrid.model.enableDrillThrough = true;
                $.proxy(this._pivotGrid._addHyperlink, this);
            }
            this.element.find(".splitBtn").mouseover(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (pivotClientObj.isDragging)
                    $(this).addClass("dropIndicator");
            });

            this.element.find(".splitBtn").mouseleave(function (evt) {
                $(this).removeClass("dropIndicator");
            });
            this._on(this.element, "click", "#preventDiv", ej.proxy(function (evt) {
                if (this.element.find(".e-dialog.advancedFilterDlg:visible").length > 0) {
                    this.element.find(".e-dialog.advancedFilterDlg").hide();
                    this.element.find("#preventDiv").remove();
                }
            }, this));
            if (!(this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)) {
                this._on(this.element, "mouseover", ".pvtBtn", ej.proxy(function (evt) {
                    var pivotClientObj = $(evt.currentTarget).parents(".e-pivotclient").data("ejPivotClient");
                if (pivotClientObj.isDragging || pivotClientObj._pivotSchemaDesigner._isDragging)
                      $(evt.target).siblings(".dropIndicator").addClass("dropIndicatorActive");
                 }, this));
            }
              this._on(this.element, "mouseleave", ".pvtBtn", ej.proxy(function (evt) {
                      $(evt.target).siblings(".dropIndicator").removeClass("dropIndicatorActive");
               }, this));
                            

              this.element.find(".sortDisable, .sortEnable, .filterDisable, .filterEnable ").on(ej.eventType.click, function (evt) {
                  var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (evt.target.className == "sortDisable") {
                    $('.measuresList_wrapper,.radioBtnAsc, .radioBtnDesc, .preserveHrchy').attr("disabled", "disabled");
                    $('.measureListLbl, .orderLbl, .radioBtnAscLbl, .radioBtnDescLbl, .preserveHrchyLbl').addClass('sortFilterDisable');
                    pivotClientObj._dllSortMeasure.disable();
                }
                else if (evt.target.className == "sortEnable") {
                    $('.measuresList_wrapper,.radioBtnAsc, .radioBtnDesc, .preserveHrchy').removeAttr("disabled");
                    $('.measureListLbl, .orderLbl, .radioBtnAscLbl, .radioBtnDescLbl, .preserveHrchyLbl').removeClass('sortFilterDisable');
                    pivotClientObj._dllSortMeasure.enable();
                }
                else if (evt.target.className == "filterDisable") {
                    $('.filterFrom, .filterTo').attr("disabled", "disabled");
                    $('.filterMeasureListLbl, .conditionLbl, .filterValueLbl, .filterBtw').addClass('sortFilterDisable');
                    pivotClientObj._dllFilterCondition.disable();
                    pivotClientObj._dllfMeasuresList.disable();
                }
                else if (evt.target.className == "filterEnable") {
                    $('.filterFrom, .filterTo').removeAttr("disabled");
                    $('.filterMeasureListLbl, .conditionLbl, .filterValueLbl, .filterBtw').removeClass('sortFilterDisable');
                    pivotClientObj._dllFilterCondition.enable();
                    pivotClientObj._dllfMeasuresList.enable();
                }
            });

            this.element.find(".filterFrom , .filterTo").keypress(function (event) {
                if (event.which == 8 || event.which == 0) {
                    return true;
                }

                if (event.which < 46 || event.which > 58) {
                    return false;
                }
                if ((event.which == 46 && $(this).val().indexOf('.') != -1) || event.which == 47) {
                    return false;
                }
            });

            this.element.find(".toggleExpandButton").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                pivotClientObj._isCollapseCB = true;
                pivotClientObj._collapseCubeBrowser();
            });

            this.element.find(".toggleCollapseButton").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                pivotClientObj._isCollapseCB = false;
                if (pivotClientObj.model.isResponsive){
                    pivotClientObj._rwdToggleExpand();
                    if (pivotClientObj.model.enableSplitter)
                          pivotClientObj.element.find(".splitresponsive").data("ejSplitter").refresh();
                    }
                else {
                    pivotClientObj._toggleExpand = false;
                    pivotClientObj._performToggleAction(pivotClientObj._initStyles);
                    pivotClientObj.element.find(".csHeader, .cubeTable,.toggleExpandButton, .pivotFieldList").show();
                    pivotClientObj.element.find(".toggleCollapseButton").hide();
                    pivotClientObj.element.find(".toggleText").hide();
                    if (pivotClientObj.displayMode() == ej.PivotClient.DisplayMode.GridOnly)
                        pivotClientObj.element.find(".gridContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                    else if (pivotClientObj.displayMode() == ej.PivotClient.DisplayMode.ChartOnly)
                        pivotClientObj.element.find(".chartContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                    else if (pivotClientObj.controlPlacement() == ej.PivotClient.ControlPlacement.Tile) {
                        if (pivotClientObj.defaultView() == ej.PivotClient.DefaultView.Grid) {
                            pivotClientObj.element.find(".gridContainer").width(pivotClientObj.element.find(".controlPanel").width()-5);
                            pivotClientObj.element.find(".chartContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                        }
                        else {
                            pivotClientObj.element.find(".gridContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                            pivotClientObj.element.find(".chartContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                        }
                    }
                    else if (pivotClientObj.controlPlacement() == ej.PivotClient.ControlPlacement.Tab) {
                        if (pivotClientObj.defaultView() == ej.PivotClient.DefaultView.Grid) {
                            pivotClientObj.element.find(".gridContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                            pivotClientObj.element.find(".chartContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                        }
                        else {
                            pivotClientObj.element.find(".gridContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                            pivotClientObj.element.find(".chartContainer").width(pivotClientObj.element.find(".controlPanel").width() - 5);
                        }
                    }
                    if (pivotClientObj.model.enableToolBar)
                    {
                        pivotClientObj.element.find("#" + this._id + "_PivotCharttoolBar").width(pivotClientObj.element.find(".chartContainer").width());
                        pivotClientObj.element.find("#" + this._id + "_PivotGridToolbar").width(pivotClientObj.element.find(".gridContainer").width()-10);
                        pivotClientObj.element.find(".chartToolBar").width(pivotClientObj.element.find(".chartContainer").width());
                        pivotClientObj.element.find(".toolBar").width(pivotClientObj.element.find(".gridContainer").width());
                    }
                    if (pivotClientObj.model.enablePivotTreeMap) {
                        if (pivotClientObj.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                            pivotClientObj.chartObj = null;
                            pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                            if (ej.isNullOrUndefined(pivotClientObj.chartObj) && !ej.isNullOrUndefined(pivotClientObj.otreemapObj))
                                pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                            if (!ej.isNullOrUndefined(pivotClientObj.chartObj)) {
                                if ((pivotClientObj.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                                    pivotClientObj.otreemapObj._treeMap.refresh();
                                }
                                else {
                                    pivotClientObj.chartObj.redraw();
                                }
                            }
                        }
                    }
                }
            });

            this.element.find(".maximizedView").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                pivotClientObj._maxViewBtnClick();
            });

            $(document).on('click', '.winCloseBtn', function (evt) {
                var pivotClientObj = $("#" + $(evt.target).attr("clientID")).data("ejPivotClient");
                pivotClientObj._maxViewClsBtnClick();
            });

            if (this.model.isResponsive)
                $(window).on('resize', $.proxy(this._reSizeHandler, this));
            if (this.model.enableSplitter) {
              this._on(this.element, "mouseup", ".parentsplit,.childsplit", ej.proxy(function (evt) {
                var pivotClientObj = this;
                if ($(evt.target).hasClass("e-shadowbar")) {
                    if ($(evt.target).parent().hasClass("childsplit") || !$(evt.target).parent().hasClass("parentsplit"))
                        var s = pivotClientObj.element.find(".controlPanelTD").width();
                    else if ($(evt.target).parent().hasClass("parentsplit") && !pivotClientObj.model.enableRTL)
                        var s = pivotClientObj.element.find(".controlPanelTD").width() + (pivotClientObj.element.find(".controlPanelTD").offset().left - pivotClientObj.element.find(".e-shadowbar").offset().left);
                    else if ($(evt.target).parent().hasClass("parentsplit") && pivotClientObj.model.enableRTL)
                        var s = pivotClientObj.element.find(".controlPanelTD").width() + (pivotClientObj.element.find(".e-shadowbar").offset().left - pivotClientObj.element.find(".e-split-divider").offset().left);
                                           
                    $("#" + pivotClientObj._pivotChart._id + "Container").width(s);
                    pivotClientObj.chartObj = null;
                    pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                    pivotClientObj.chartObj.redraw();
                  }
            }));
        }
          },

        _collapseCubeBrowser: function(){
            if (this.model.isResponsive)
                this._rwdToggleCollapse();
            else {
                this._toggleExpand = true;
                if (this._initToggle) {
                    this._initToggle = false; var items = {};
                    var tempWidth = (this.element.find(".cubeTable").width() || this.element.find(".pivotFieldList").width()) + this.element.find(".controlPanel").width() - 17;
                    items["controlPanelWidth"] = (tempWidth - 3);
                    items["chartOuterWidth"] = items["chartModelWidth"] = items["gridOuterWidth"] = tempWidth - 17;
                    this._toggleStyles.push(items);
                }
                if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly)
                    this.element.find(".gridContainer").width(this.element.width() - 40);
                else if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly)
                    this.element.find(".chartContainer").width(this.element.width() - 45);
                else if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid) {
                        this.element.find(".gridContainer").width(this.element.width() - 25);
                        this.element.find(".chartContainer").width(this.element.width() - 65);
                    }
                    else {
                        this.element.find(".gridContainer").width(this.element.width() - 40);
                        this.element.find(".chartContainer").width(this.element.width() - 45);
                    }
                }
                else if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tab) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid) {
                        this.element.find(".gridContainer").width(this.element.width() - 25);
                        this.element.find(".chartContainer").width(this.element.width() - 65);
                    }
                    else {
                        this.element.find(".gridContainer").width(this.element.width() - 25);
                        this.element.find(".chartContainer").width(this.element.width() - 45);
                    }
                }
                this._performToggleAction(this._toggleStyles);
                this.element.find(".csHeader, .cubeTable,.toggleExpandButton, .pivotFieldList").hide();
                this.element.find(".toggleCollapseButton").show();
                this.element.find(".toggleText").show();
                if (this.model.enablePivotTreeMap) {
                    if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                        this.chartObj = null;
                        this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                        if (ej.isNullOrUndefined(this.chartObj) && !ej.isNullOrUndefined(this.otreemapObj))
                            this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                        if (!ej.isNullOrUndefined(this.chartObj)) {
                            if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                                this.otreemapObj._treeMap.refresh();
                            }
                            else {
                                this.chartObj.redraw();
                            }
                        }
                    }
                }
            }
        },

        _keyPressUp: function(e){
            if (e.keyCode === 93 && !this.element.find(".e-dialog:visible").length > 0 && this.element.find(".hoverCell:visible").length > 0) {
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("e-text")) {
                    var position = { x: this.element.find(".hoverCell").offset().left + this.element.find(".hoverCell").outerWidth(), y: this.element.find(".hoverCell").offset().top + this.element.find(".hoverCell").outerHeight() };
                    this.element.find(".hoverCell").trigger({type: 'mouseup',which: 3,clientX: position.x,clientY: position.y,pageX: position.x,pageY: position.y});
                }
            }
        },
        _createSplitter: function () {
            if (!this.model.isResponsive)
            {
                if (this.model.enableRTL) {

                    if (!(this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.enableVirtualScrolling)) {
                        this.element.find(".parentsplit").ejSplitter({
                            width: "100%",
                            enableRTL: true,
                            isResponsive:true,
                            cssClass: "customCSS",
                            height: this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + 5) : this.element.find(".outerTable").height(),
                            properties: [{ expandable: false, collapsible: false, enableAutoResize: true, paneSize: "50%" }, { collapsible: false, minSize: 225 }],
                            resize: function (args) {
                                var obj = this.element.find(".childsplit").data("ejSplitter");
                                obj.option("properties", [{ expandable: false, collapsible: false, enableAutoResize: true, paneSize: "50%", minSize: 0 }, { paneSize: "50%", minSize: 0, collapsible: false }]);
                            }
                            
                        });
                    }
                    this.element.find(".childsplit").ejSplitter({
                        cssClass: "customCSS",
                        isResponsive: true,
                        height: this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? (this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 30)) : "",
                        width: "100%",
                        enableRTL: true,
                        properties: [{ expandable: false, collapsible: false, enableAutoResize: true, paneSize: "50%" }, { paneSize: "50%", collapsible: false }]
                    });
                }
                else {
                    if (!(this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.enableVirtualScrolling)) {
                        this.element.find(".parentsplit").ejSplitter({
                            cssClass: "customCSS",
                            isResponsive: true,
                            height: this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + 5) : this.element.find(".outerTable").height(),
                            properties: [{ expandable: false, collapsible: false }, { enableAutoResize: true, collapsible: false }],
                            resize: function (args) {
                                var obj = this.element.find(".childsplit").data("ejSplitter");
                                obj.option("properties", [{ expandable: false, collapsible: false, enableAutoResize: true, paneSize: "47%", enableRTL: this.model.enableRTL }, { paneSize: "47%", collapsible: false }]);
                            },
                        });
                    }
                    this.element.find(".childsplit").ejSplitter({
                        cssClass: "customCSS",
                        isResponsive: true,
                        height: this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? (this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 30)) : "",
                        properties: [{ expandable: false, collapsible: false, enableAutoResize: true, paneSize: "47%", enableRTL: this.model.enableRTL }, { paneSize: "47%", collapsible: false }]//, { collapsible: false }, { enableRTL: this.model.enableRTL }
                    });
                }
                              
            }
            if (this.model.isResponsive) {
                this.element.find(".splitresponsive").ejSplitter({
                    cssClass: "customCSS",
                    isResponsive: true,
                    height: this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? (this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 25)) : "",
                    properties: [{ expandable: false, collapsible: false, paneSize: "48%" }, { enableAutoResize: true, collapsible: false }]
                });
              
            }
        },
        _keyPressDown: function (e) {
            var btnTab;
            if (!ej.isNullOrUndefined(this._curFocus.button)) {
                btnTab = this._curFocus.button;
            }
            else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                btnTab = this._curFocus.tab;
            }
            if (e.keyCode === 93 && !ej.isNullOrUndefined(btnTab) && !this.element.find(".e-dialog:visible").length > 0 && this.element.find(".hoverCell:visible").length > 0) {
                e.preventDefault();
                var position = { x: $(btnTab).offset().left + $(btnTab).outerWidth(), y: $(btnTab).offset().top + $(btnTab).outerHeight() };
                btnTab.trigger({type: 'mouseup',which: 3,clientX: position.x,clientY: position.y,pageX: position.x,pageY: position.y});
            }
            if (((e.which === 46) || (e.which === 82 && e.ctrlKey)) && !this.element.find(".e-dialog:visible").length > 0 && !ej.isNullOrUndefined(btnTab)) {
                    e.preventDefault();
                    btnTab.parent().find(".removeSplitBtn:visible").click();
            }
            else if ((e.which === 46) || (e.which === 82 && e.ctrlKey) && ((!ej.isNullOrUndefined(this._curFocus.dialog) && this._curFocus.dialog.hasClass("measureEditor")) || (!ej.isNullOrUndefined(this._curFocus.editor) && this._curFocus.editor.hasClass("measureEditor")))) {
                if (!ej.isNullOrUndefined(this._curFocus.editor)) {
                    this._curFocus.editor.find(".removeMeasure:visible").click();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.dialog)) {
                    this._curFocus.dialog.find(".removeMeasure:visible").click();
                }
            }
            if (e.keyCode == 79 && this.element.find(".e-dialog:visible").length > 0) {
                if (e.ctrlKey) {
                    e.preventDefault();
                    if (!ej.isNullOrUndefined(this._curFocus.icon) && this._curFocus.icon.hasClass("mdxImg")) {
                        this.element.find(".dialogCancelBtn:visible").click();
                    }
                    else {
                        this.element.find(".dialogOKBtn:visible").click();
                    }
                    this._curFocus.dialog = null;
                }
            }
            if (e.which === 70 && e.ctrlKey && !ej.isNullOrUndefined(btnTab)) {
                    btnTab.click();
            }
            if (e.keyCode == 67 && this.element.find(".e-dialog:visible").length > 0 && this.element.find(".e-dialog .e-titlebar").attr("tag") != "MDX Query") {
                if (e.ctrlKey) {
                    e.preventDefault();
                    this.element.find(".dialogCancelBtn:visible").click();
                    this._curFocus.dialog = null;
                }
            }           
            if (this.element.find(".e-dialog:visible").length > 0 && e.keyCode == 27) {
                if (!ej.isNullOrUndefined(this._curFocus.icon)) {
                    this._curFocus.icon.attr("tabindex", "-1").addClass("hoverCell").focus().mouseover();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.editor)) {
                    this._curFocus.editor.attr("tabindex", "-1").addClass("hoverCell").focus().mouseover();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.dialog)) {
                    this._curFocus.dialog.attr("tabindex", "-1").addClass("hoverCell").focus().mouseover();
                }
                this._curFocus.dialog = null;
                this._index.editor = 0;
            }
            else if (this.element.find(".e-dialog:visible").length == 0 && e.keyCode == 27 && $(".fullScreenView").length != 0) {
                this._maxViewClsBtnClick();
                if (!ej.isNullOrUndefined(this._pivotGrid._curFocus.cell)) {
                    this._pivotGrid._curFocus.cell.focus().mouseover();
                }
                else if (!this._curFocus.tab.hasClass("e-icon")) {
                    this._curFocus.tab.focus().mouseover();
                }               
            }
            else if (this.element.find(".chartTypesDialog:visible").length > 0 && e.which === 27) {
                this.element.find(".chartTypesDialog").remove();
                this._curFocus.chartimg = null;
            }
            else if ($(".pivotTree:visible,.pivotTreeContext:visible").length > 0 && e.which === 27) {
                if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                    this._curFocus.tree.attr("tabindex", "-1").focus().addClass("hoverCell");
                }
                else if (!ej.isNullOrUndefined(btnTab)) {
                    btnTab.attr("tabindex", "-1").focus().addClass("hoverCell");
                }
            }
            if (((e.which === 9 && e.shiftKey) || e.which === 9) && this.element.find(".e-dialog:visible").length > 0) {
                e.preventDefault();
                this._curFocus.editor = null;
                this.element.find(".e-dialog .hoverCell:visible").removeClass("hoverCell");
                var focEle;
                if ((!ej.isNullOrUndefined(this._dllSortMeasure) && this._dllSortMeasure.model.enabled && this.element.find("#measuresList_container:visible").length > 0) || (!ej.isNullOrUndefined(this._dllfMeasuresList) && this._dllfMeasuresList.model.enabled && this.element.find("#fMeasuresList_container:visible").length > 0)) {
                    focEle = this.element.find(".e-dialog .filterEnable:visible,#measuresList_container:visible,#fMeasuresList_container:visible,#filterCondition_container:visible,.e-dialog .filterFrom:visible:not([disabled='disabled']),.e-dialog .filterTo:visible:not([disabled='disabled']),.e-dialog .radioBtnAsc:visible:not([disabled='disabled']),.e-dialog .preserveHrchy:visible:not([disabled='disabled']),.e-dialog .dialogOKBtn:visible:not([aria-disabled='true']),.e-dialog .dialogCancelBtn:visible,.e-dialog .e-close:visible,.e-dialog .checkAll:visible,.e-dialog .unCheckAll:visible,.e-dialog .sortfiltTab .e-active:visible,.e-dialog .measureEditor:visible:first,.e-dialog .e-text:visible:first,.e-dialog .sortEnable:visible,.e-dialog .reportName:visible,#reportNameList_container:visible");
                }
                else {
                    focEle = this.element.find(".e-dialog .filterEnable:visible,.e-dialog .filterFrom:visible:not([disabled='disabled']),.e-dialog .filterTo:visible:not([disabled='disabled']),.e-dialog .radioBtnAsc:visible:not([disabled='disabled']),.e-dialog .preserveHrchy:visible:not([disabled='disabled']),.e-dialog .dialogOKBtn:visible:not([aria-disabled='true']),.e-dialog .dialogCancelBtn:visible,.e-dialog .e-close:visible,.e-dialog .checkAll:visible,.e-dialog .unCheckAll:visible,.e-dialog .sortfiltTab .e-active:visible,.e-dialog .measureEditor:visible:first,.e-dialog .e-text:visible:first,.e-dialog .sortEnable:visible,.e-dialog .reportName:visible,#reportNameList_container:visible");
                }      
                if (!ej.isNullOrUndefined(this._curFocus.dialog)) {
                    this._curFocus.dialog.attr("tabindex", "0").removeClass("hoverCell").mouseleave();
                    if (e.which === 9 && e.shiftKey) {
                        this._index.dialog = this._index.dialog - 1 < 0 ? focEle.length - 1 : this._index.dialog - 1;
                    }
                    else if (e.which === 9){
                        this._index.dialog = this._index.dialog + 1 > focEle.length - 1 ? 0 : this._index.dialog + 1;
                    }
                    this._curFocus.dialog = focEle.eq(this._index.dialog);
                }
                else {
                    this._index.dialog = focEle.length > 4 ? 4 : 2;
                    this._curFocus.dialog = focEle.eq(this._index.dialog);
                }
                if (this._curFocus.dialog.hasClass("e-input") || this._curFocus.dialog.attr("type") == "radio") {
                    this._curFocus.dialog.attr("tabindex", "-1").focus();
                }
                else {
                    this._curFocus.dialog.attr("tabindex", "-1").focus().addClass("hoverCell").mouseover;
                }
            }
            else if (((e.which === 9 && e.shiftKey) || e.which === 9) && !$(".pivotTree:visible,.pivotTreeContext:visible").length > 0) {
                e.preventDefault();
                this.element.find(".hoverCell").removeClass("hoverCell").mouseleave();
                this.element.find(".e-node-focus").removeClass("e-node-focus");
                this._index.button = 1;this._index.icon = 1;this._index.chartimg = 0;this._index.tree = 0;this._index.dialog = 0;
                this._curFocus.button = null;this._curFocus.icon = null;this._curFocus.chartimg = null;this._curFocus.tree = null;this._curFocus.editor = null;this._curFocus.dialog = null;
                var focEle;
                if ($(".fullScreenView").length != 0) {
                    if ($("[role='columnheader']:visible:not([p='0,0'])").first().length > 0) {
                        focEle = $("[role='columnheader']:visible:not([p='0,0']):first");
                    }
                }
                else {
                    focEle = this.element.find("[role='columnheader']:visible:not([p='0,0']):first,.schemaFieldTree .e-text:visible:first,.reportToolbar li:visible:first,#reportList_wrapper:visible,#cubeList_wrapper:visible,#cubeSelector_wrapper:visible,.cubeTreeView .e-text:visible:first,.categoricalAxis button:visible:first,.rowAxis button:visible:first,.slicerAxis button:visible:first,.schemaColumn button:visible:first,.schemaRow button:visible:first,.schemaFilter button:visible:first,.schemaValue button:visible:first,.toggleExpandButton:visible:first,.toggleCollapseButton:visible:first,#clientTab .e-active:visible");
                }
                if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.attr("tabindex", "0").removeClass("hoverCell").mouseleave();
                    if (e.which === 9 && e.shiftKey) {

                        this._index.tab = this._index.tab - 1 < 0 ? focEle.length - 1 : this._index.tab - 1;
                    }
                    else if (e.which === 9){
                        this._index.tab = this._index.tab + 1 > focEle.length - 1 ? 0 : this._index.tab + 1;
                    }
                    this._curFocus.tab = focEle.eq(this._index.tab).attr("tabindex", "-1").focus().addClass("hoverCell").mouseover();
                    if (this._curFocus.tab.hasClass("e-button")) {
                        this._curFocus.tab.parent().find(".removeSplitBtn:visible").addClass("hoverCell");
                    }
                }
                else {
                    this._index.tab = 0;
                    this._curFocus.tab = focEle.eq(this._index.tab).attr("tabindex", "-1").focus().addClass("hoverCell").mouseover();
                    if (this._curFocus.tab.hasClass("e-button")) {
                        this._curFocus.tab.parent().find(".removeSplitBtn:visible").addClass("hoverCell");
                    }
                }
            }
            if (this.element.find(".e-dialog:visible").length > 0 && e.keyCode == 13) {
                if ($(e.target).hasClass("memberCurrentPage") && $(e.target).parents(".e-pivotschemadesigner").length == 0) {
                    ej.Pivot.editorTreeNavigatee(e, this);
                    return;
                }
                if ($(e.target).hasClass("searchEditorTreeView") && $(e.target).parents(".e-pivotschemadesigner").length == 0 && $(e.target).parents(".e-dialog").find(".nextPageDiv").length > 0) {
                    ej.Pivot._searchEditorTreeNodes(e, this);
                    return;
                }
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._curFocus.editor)) {
                    if (this._curFocus.editor.hasClass("e-text")) {
                        this.element.find(".e-dialog .hoverCell").parent().find(".e-chkbox-small").click();
                    }
                }
                else if (!ej.isNullOrUndefined(this._curFocus.dialog)) {
                    if (this._curFocus.dialog.hasClass("e-text")) {
                        this.element.find(".e-dialog .hoverCell").parent().find(".e-chkbox-small").click();
                    }
                    else {
                        this._curFocus.dialog.click();
                        if (this._curFocus.dialog.hasClass("dialogOKBtn") || this._curFocus.dialog.hasClass("dialogCancelBtn") || this._curFocus.dialog.hasClass("e-close")) {
                            this._curFocus.dialog = null;
                        }
                        this._index.editor = 0;
                    }
                }
                else if (!ej.isNullOrUndefined(this._curFocus.icon)) {
                    this._curFocus.icon.attr("tabindex", "-1").focus().mouseover();
                }
                else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                    this._curFocus.tab.attr("tabindex", "-1").focus().mouseover();
                }    
            }
            else if (e.keyCode == 13 && !ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.attr("role") != "columnheader") {
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._curFocus.icon) || (!ej.isNullOrUndefined(this._curFocus.tab) && !$(".pivotTree:visible,.pivotTreeContext:visible").length > 0 && this.element.find(".hoverCell:visible").length > 0)) {
                    this.element.find(".hoverCell:visible")[0].click();
                }
                    if (!ej.isNullOrUndefined(this.element.find(".chartTypesDialog")) && (!ej.isNullOrUndefined(this._curFocus.chartimg))) {
                        this._curFocus.chartimg.click();
                        if (!ej.isNullOrUndefined(this._curFocus.icon)) {
                            this._curFocus.icon.attr("tabindex", "-1").focus().mouseover();
                        }
                        this._index.chartimg = 0;
                        this._curFocus.chartimg = null;
                    }
            }
            if ((e.which === 39 || e.which === 37) && this.element.find(".e-dialog:visible").length > 0 && this.element.find(".e-dialog .e-text:visible").hasClass("hoverCell")) {
                this.element.find(".e-dialog .hoverCell").parent().find(".e-plus,.e-minus").click();
            }
            else if ((e.which === 39 || e.which === 37) && (this.element.find(".cubeTreeView .e-text:visible").hasClass("hoverCell")) && !this.element.find(".editorTreeView:visible").length > 0) {
                this.element.find(".cubeTreeView .hoverCell").parent().find(".e-plus,.e-minus").click();
            }
            else if ((e.which === 37 || e.which === 39 || e.which === 38 || e.which === 40) && (this.element.find(".chartTypesDialog").length > 0 || this.element.find(".reportDBDialog").length > 0)){
                e.preventDefault();
                var dia = this.element.find(".chartTypesDialog").length > 0 ? this.element.find(".chartTypesDialog") : this.element.find(".reportDBDialog");
                    dia.tabindex = -1;
                    dia.focus();
                    var td = dia.find(".chartTypesIcon").length > 0 ? dia.find(".chartTypesIcon") : this.element.find(".reportDBIcon");
                        if (!ej.isNullOrUndefined(this._curFocus.chartimg)) {
                            this._curFocus.chartimg.removeClass("hoverCell").mouseleave();
                            if (e.which === 39) {
                                this._index.chartimg = this._index.chartimg + 1 > td.length - 1 ? 0 : this._index.chartimg + 1;
                            }
                            else if (e.which === 37) {
                                this._index.chartimg = this._index.chartimg - 1 < 0 ? td.length - 1 : this._index.chartimg - 1;
                            }
                            else if (e.which === 40 && dia.find(".chartTypesIcon").length > 0) {
								this._index.chartimg = this._index.chartimg + 5 > td.length - 1 ? (this._index.chartimg + 5)%10  : this._index.chartimg + 5;
							}
                            else if (e.which === 38 && dia.find(".chartTypesIcon").length > 0) {
								this._index.chartimg = this._index.chartimg - 5 < 0 ? td.length - 1  : this._index.chartimg - 5;
							}
                            this._curFocus.chartimg = td.eq(this._index.chartimg).addClass("hoverCell").mouseover();
                        }
                        else {
                            this._index.chartimg = e.which == 39 ? 0 : e.which == 37 ? td.length - 1 : 0 ;
                            this._curFocus.chartimg = td.eq(this._index.chartimg).addClass("hoverCell").mouseover();
                        }               
            }
            else if ((e.which === 37 || e.which === 39) && !ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("e-icon") && !this._curFocus.tab.hasClass("toggleCollapseButton") && !this._curFocus.tab.hasClass("toggleExpandButton") && !this.element.find(".e-dialog:visible").length > 0) {
                e.preventDefault();
                this._curFocus.tab.removeClass("hoverCell").mouseleave();
                var td = this.element.find(".reportToolbar .e-icon:visible:not(.reportCol)");                
                    if (!ej.isNullOrUndefined(this._curFocus.icon)) {
                        this._curFocus.icon.removeClass("hoverCell").mouseleave();
                        if (e.which === 39) {
                            this._index.icon = this._index.icon + 1 > td.length - 2 ? 0 : this._index.icon + 1;
                        }
                        else if (e.which === 37) {
                            this._index.icon = this._index.icon - 1 < 0 ? td.length - 2 : this._index.icon - 1;
                        }
                        this._curFocus.icon = td.eq(this._index.icon).addClass("hoverCell").mouseover();
                        }
                        else {
                            this._index.icon = e.which == 39 ? 1 : e.which == 37 ? td.length - 2 : 0;
                            this._curFocus.icon = td.eq(this._index.icon).addClass("hoverCell").mouseover();
                        }
            }
            if ((e.which === 40 || e.which === 38) && this.element.find(".e-dialog:visible").length > 0 && !$(".pivotTree:visible,.pivotTreeContext:visible").length > 0 && (this.element.find(".e-dialog .e-text").hasClass("hoverCell") || this.element.find(".e-dialog .measureEditor").hasClass("hoverCell"))) {
                e.preventDefault();
                this.element.find(".e-dialog .hoverCell").removeClass("hoverCell");
                this.element.find(".e-dialog .e-node-focus").removeClass("e-node-focus");
                if (!ej.isNullOrUndefined(this._curFocus.dialog)) {
                    this._curFocus.dialog.mouseleave();
                }
                var td = this.element.find(".e-dialog .measureEditor:visible,.e-dialog .e-text:visible");
                        if (!ej.isNullOrUndefined(this._curFocus.editor)) {
                            this._curFocus.editor.attr("tabindex", "0").removeClass("hoverCell");
                            if (e.which === 40) {
                                this._index.editor = this._index.editor + 1 > td.length - 1 ? 0 : this._index.editor + 1;
                            }
                            else if (e.which === 38) {
                                this._index.editor = this._index.editor - 1 < 0 ? td.length - 1 : this._index.editor - 1;
                            }
                            this._curFocus.editor = td.eq(this._index.editor).attr("tabindex", "0").focus().addClass("hoverCell");
                        }
                        else {
                            if (td.length > 1) {
                                this._index.editor = e.which == 40 ? 1 : e.which == 38 ? td.length - 1 : 0;
                            }
                            else {
                                this._index.editor = 0;
                            }
                            this._curFocus.editor = td.eq(this._index.editor).attr("tabindex", "0").focus().addClass("hoverCell");
                        }
                }
            else if ((e.which === 40 || e.which === 38) && !this.element.find(".e-dialog:visible").length > 0 && !ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("e-text") && !$(".pivotTree:visible,.pivotTreeContext:visible").length > 0 && ej.isNullOrUndefined(this._schemaData)) {
                this.element.find(".hoverCell").removeClass("hoverCell");
                this._curFocus.tab.mouseleave();
                e.preventDefault();
                var td = this.element.find(".cubeTreeView .e-text:visible");
                if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                    this._curFocus.tree.attr("tabindex", "0").removeClass("hoverCell").mouseleave();
                    if (e.which === 40) {
                        this._index.tree = this._index.tree + 1 > td.length - 1 ? 0 : this._index.tree + 1;
                    }
                    else if (e.which === 38) {
                        this._index.tree = this._index.tree - 1 < 0 ? td.length - 1 : this._index.tree - 1;
                    }
                    this._curFocus.tree = td.eq(this._index.tree).attr("tabindex", "-1").focus().addClass("hoverCell").mouseover();
                    this.element.find(".e-node-focus").removeClass("e-node-focus");
                }
                else {
                    this._index.tree = e.which == 40 ? 1 : e.which == 38 ? td.length - 1 : 0;
                    this._curFocus.tree = td.eq(this._index.tree).attr("tabindex", "-1").focus().addClass("hoverCell").mouseover();
                    this.element.find(".e-node-focus").removeClass("e-node-focus");
                }
            }
            else if ((e.which === 40 || e.which === 38) && !ej.isNullOrUndefined(this._curFocus.tab) && this._curFocus.tab.hasClass("e-button") && !$(".pivotTree:visible,.pivotTreeContext:visible").length > 0 && !this.element.find(".e-dialog:visible").length > 0 && ej.isNullOrUndefined(this._schemaData)) {
                e.preventDefault();
                var td = null;
                if (this._curFocus.tab.parent().parent().hasClass("categoricalAxis") || this._curFocus.tab.parent().parent().hasClass("rowAxis") || this._curFocus.tab.parent().parent().hasClass("slicerAxis")) {
                    if (this._curFocus.tab.parent().parent().hasClass("categoricalAxis")) {
                        td = this.element.find(".categoricalAxis button");
                    }
                    else if (this._curFocus.tab.parent().parent().hasClass("rowAxis")) {
                        td = this.element.find(".rowAxis button");
                    }
                    else if (this._curFocus.tab.parent().parent().hasClass("slicerAxis")) {
                        td = this.element.find(".slicerAxis button");
                    }
                    if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                        this._curFocus.tab.removeClass("hoverCell").attr("tabindex", "0").mouseleave();
                        this._curFocus.tab.parent().find(".removeSplitBtn:visible").focus().removeClass("hoverCell");
                    }
                    if (!ej.isNullOrUndefined(this._curFocus.button)) {
                        this._curFocus.button.attr("tabindex", "0").removeClass("hoverCell");
                        this._curFocus.button.parent().find(".removeSplitBtn:visible").removeClass("hoverCell");
                            if (e.which === 40) {
                                this._index.button = this._index.button + 1 > td.length - 1 ? 0 : this._index.button + 1;
                            }
                            else if (e.which === 38) {
                                this._index.button = this._index.button - 1 < 0 ? td.length - 1 : this._index.button - 1;
                            }
                            this._curFocus.button = td.eq(this._index.button).attr("tabindex", "0").focus().addClass("hoverCell");
                            this._curFocus.button.parent().find(".removeSplitBtn:visible").addClass("hoverCell");
                        }
                    else {
                        this._index.button = e.which == 40 ? td.length > 1 ? 1 : 0 : e.which == 38 ? td.length - 1 : 0;
                        this._curFocus.button = td.eq(this._index.button).attr("tabindex", "0").focus().addClass("hoverCell");
                        this._curFocus.button.parent().find(".removeSplitBtn:visible").addClass("hoverCell");
                        }
                }
            }
        },

        _wireMeasureRemoveEvent: function () {

            this.element.find(".removeMeasure").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                pivotClientObj._isMembersFiltered = true;
                $($(evt.target).parent()).remove();
            });
        },

        _wireEditorRemoveEvent: function () {

            this.element.find(".removeSplitBtn").click(function (evt) {
                var pivotClientObj = $(evt.target).parents(".e-pivotclient").data("ejPivotClient");
                this._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
                if ($(evt.target).parent().attr("tag").indexOf("Measures") > 0) {

                    for (var i = 0; i < $(evt.target).parent().siblings(".splitBtn").length; i++) {
                        if ($(evt.target).parent().siblings(".splitBtn:eq(" + i + ")").attr("tag").indexOf(pivotClientObj._getLocalizedLabels("KPIs")) > 0) {
                            $($(evt.target).parent().siblings(".splitBtn:eq(" + i + ")")).remove();
                            break;
                        }
                    }
                }
                $($(evt.target).parent()).remove();
                if (pivotClientObj._currentReportItems.length != 0) {
                    if (pivotClientObj._treeViewData.hasOwnProperty($(evt.target).parent().find("button").attr("title"))) {
                        delete pivotClientObj._treeViewData[$(evt.target).parent().find("button").attr("title")];
                        pivotClientObj._currentReportItems.splice($.inArray($(evt.target).parent().find("button").attr("title"), pivotClientObj._currentReportItems), 1);
                    }
                }
                pivotClientObj._off(this.element, "click", ".removeSplitBtn");
                if (pivotClientObj.model.enableAdvancedFilter && pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap && pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                    var btnUniqueName = $($(evt.target)).parent("div:eq(0)").attr("Tag").split(":")[1].split(".");
                    if (!ej.isNullOrUndefined(btnUniqueName) && btnUniqueName.length == 2) {
                        pivotClientObj._setUniqueNameFrmBtnTag(btnUniqueName);
                        pivotClientObj._removeFilterTag(pivotClientObj._selectedFieldName);
                    }
                }
                if (pivotClientObj.model.beforeServiceInvoke != null)
                    pivotClientObj._trigger("beforeServiceInvoke", { action: "removeSplitButton", element: this.element, customObject: pivotClientObj.model.customObject });
                var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                delete pivotClientObj._fieldSelectedMembers[$(evt.target).parent().find("button").attr("title")];
                pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.removeSplitButton, JSON.stringify({ "action": "removeSplitButton", "clientParams": $(evt.target).parent().attr("tag"), "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject }), pivotClientObj._removeSplitButtonSuccess);
                pivotClientObj._isNodeOrButtonDropped = true;
            });
        },
        _setUniqueNameFrmBtnTag: function (btnUniqueName) {
            if (btnUniqueName.length > 0) {
                var liElement = this.element.find(".cubeTreeView li[tag^='[" + btnUniqueName[0] + "'][tag$='" + btnUniqueName[1] + "]']");
                if (liElement.length > 0) {
                    for (var i = 0; i < liElement.length; i++) {
                        if ($(liElement[i]).attr("tag").split("].").length == 2) {
                            this._selectedFieldName = $(liElement[i]).attr("tag");
                            break;
                        }
                    }
                }
                else
                    this._selectedFieldName = liElement.attr("tag");
            }
        },
        _wireDialogEvent: function () {
            this.element.find(".newReportImg, .addReportImg, .removeReportImg, .renameReportImg, .pvtBtn, .mdxImg,.colSortFilterImg, .rowSortFilterImg, .autoExecuteImg").on(ej.eventType.click, function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (evt.currentTarget.parentElement.className.indexOf("splitBtn") > -1) {
                    if ($($(evt.currentTarget).parents(".splitBtn")[0]).attr('tag').indexOf("NAMEDSET") > -1) return false;
                    pivotClientObj._currentAxis = $($(evt.currentTarget).parents(".splitBtn")[0]).attr('tag').split(':')[0];
                }
                evt.preventDefault();
                if (evt.target.innerHTML != pivotClientObj._getLocalizedLabels("Cancel") && evt.target.innerHTML != pivotClientObj._getLocalizedLabels("OK") && evt.target.parentElement.innerHTML != pivotClientObj._getLocalizedLabels("Cancel") && evt.target.parentElement.innerHTML != pivotClientObj._getLocalizedLabels("OK")) {
                    pivotClientObj._off(pivotClientObj.element, "click", ".newReportImg, .addReportImg, .removeReportImg, .renameReportImg, .mdxImg, .e-txt,.colSortFilterImg, .rowSortFilterImg, .chartTypesImg, .autoExecuteImg");
                    if (evt.target.className.indexOf("colSortFilterImg") >= 0 || evt.target.className.indexOf("rowSortFilterImg") >= 0) {
                        if (evt.target.className.indexOf("SortImg") >= 0)
                            pivotClientObj._sortOrFilterTab = "sort";
                        else
                            pivotClientObj._sortOrFilterTab = "filter";
                        if (!(evt.target.className.indexOf("colSortFilterImg") >= 0 || evt.target.className.indexOf("rowSortFilterImg") >= 0) && (pivotClientObj.element.find(".rowAxis").html() == "" && pivotClientObj.element.find(".categoricalAxis").html() == "")) {
                            pivotClientObj._isTimeOut = true;
                            setTimeout(function () {
                                if (pivotClientObj._isTimeOut)
                                    pivotClientObj._waitingPopup.show();
                            }, 800);
                        }
                        pivotClientObj._isSorted = false;
                        pivotClientObj._isFiltered = false;
                        pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toolbarServices, JSON.stringify({ "action": "FetchSortState", "toolbarOperation": null, "clientInfo": (pivotClientObj._axis = (evt.target.className.indexOf("colSortFilterImg") >= 0) ? "Column" : "Row"), "olapReport": pivotClientObj.currentReport, "clientReports": "", "customObject": JSON.stringify(pivotClientObj.model.customObject) }), pivotClientObj._fetchSortState);
                    }
                    else if (evt.target.className.indexOf("mdx") >= 0) {
                        if (pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap && pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                            pivotClientObj._mdxQuery(ej.olap.base._getParsedMDX(pivotClientObj.model.dataSource, pivotClientObj.model.dataSource.cube));
                        }
                        else
                            pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.mdxQuery, JSON.stringify({ "olapReport": pivotClientObj.currentReport, "customObject": JSON.stringify(pivotClientObj.model.customObject) }), pivotClientObj._mdxQuery);
                    }
                    else if (evt.target.className.indexOf("autoExecute") >= 0) {
                        pivotClientObj.model.enableDeferUpdate = false;
                        pivotClientObj._renderControls();
                        pivotClientObj._deferReport = pivotClientObj.currentReport;
                        pivotClientObj.model.enableDeferUpdate = true;
                    }
                    else if ((pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap) || (!$(evt.currentTarget).hasClass("pvtBtn")))
                        pivotClientObj._createDialogRequest(evt);
                    pivotClientObj._dimensionName = $(evt.currentTarget).parent().attr("tag");
                }
                pivotClientObj.isDropped = false;
            });
            this.element.find(".excelExportImg, .wordExportImg, .pdfExportImg").click(function (e) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (pivotClientObj.model.displaySettings.mode != pivotClientObj.model.clientExportMode && pivotClientObj.model.displaySettings.mode != ej.PivotClient.DisplayMode.ChartAndGrid && pivotClientObj.model.clientExportMode != ej.PivotClient.ClientExportMode.ChartAndGrid) return;
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8)
                    pivotClientObj.model.clientExportMode = ej.PivotClient.ClientExportMode.GridOnly;
                var exportOption = e.target.className.indexOf("excel") >= 0 ? "Excel" : e.target.className.indexOf("word") >= 0 ? "Word" : "Pdf";
                var params, chartString, legendString, mode;
                if (pivotClientObj.model.displaySettings.mode != ej.PivotClient.DisplayMode.GridOnly && pivotClientObj.model.clientExportMode != ej.PivotClient.ClientExportMode.GridOnly) {
                    pivotClientObj.chartObj = null;
                    pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                    if (ej.isNullOrUndefined(pivotClientObj.chartObj) && !ej.isNullOrUndefined(pivotClientObj.otreemapObj))
                        pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                    if ((pivotClientObj.chartObj.sfType.split(".")).pop().toLowerCase() != "treemap") {
                        var zoomFactor = pivotClientObj.chartObj.model.primaryXAxis.zoomFactor;
                        pivotClientObj.chartObj.model.primaryXAxis.zoomFactor = 1;
                        pivotClientObj.chartObj.model.enableCanvasRendering = true;
                        pivotClientObj.chartObj.redraw();
                        var canvasElement = pivotClientObj.chartObj["export"]();
                        chartString = canvasElement.toDataURL("image/png");
                        pivotClientObj.chartObj.model.primaryXAxis.zoomFactor = zoomFactor;
                        pivotClientObj.chartObj.model.enableCanvasRendering = false;
                        pivotClientObj.chartObj.redraw();
                        //if (chartsvgElement != undefined && chartsvgElement != null) {
                        //    var chartsvg = ej.buildTag("div").append(chartsvgElement).html();
                        //    canvg(canvasElement, chartsvg);
                        //    chartString = canvasElement.toDataURL("image/png");
                        //    var legendsvgElement = $("#legend_" + pivotClientObj._pivotChart._id + "Container_svg").clone()[0];
                        //    var legendsvg = ej.buildTag("div").append(legendsvgElement).html();
                        //    canvg(canvasElement, legendsvg);
                        //    legendString = canvasElement.toDataURL("image/png");
                        //}
                        //else {
                        //    if (pivotClientObj.model.displaySettings.mode == ej.PivotClient.DisplayMode.ChartOnly || pivotClientObj.model.clientExportMode == ej.PivotClient.ClientExportMode.ChartOnly) return;
                        //    pivotClientObj.model.clientExportMode = ej.PivotClient.ClientExportMode.GridOnly;
                        //}
                    }
                }
                var reportName = pivotClientObj.element.find(".reportlist").data("ejDropDownList").getSelectedValue();
                var exportSetting = { url: "", fileName: "PivotClient", exportMode: ej.PivotClient.ExportMode.JSON, title: reportName != null && reportName != "" ? reportName : "", description: "" };
                pivotClientObj._trigger("beforeExport", exportSetting);
                if (pivotClientObj.model.displaySettings.mode != ej.PivotClient.DisplayMode.ChartOnly && pivotClientObj.model.clientExportMode != ej.PivotClient.ClientExportMode.ChartOnly) {
                    var colorDetails = {
                        valueCellColor: pivotClientObj._pivotGrid.element.find(".value").css("color"),
                        valueCellBGColor: pivotClientObj._pivotGrid.element.find(".value").css("background-color"),
                        summaryCellColor: pivotClientObj._pivotGrid.element.find(".summary").css("color"),
                        summaryCellBGColor: pivotClientObj._pivotGrid.element.find(".summary").css("background-color")
                    }
                }
                if (pivotClientObj.model.displaySettings.mode == ej.PivotClient.DisplayMode.GridOnly || pivotClientObj.model.clientExportMode == ej.PivotClient.ClientExportMode.GridOnly) {
                    mode = ej.PivotClient.ClientExportMode.GridOnly;
                    if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || (pivotClientObj._pivotGrid._excelLikeJSONRecords != null && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON) || ($.trim(exportSetting.url) != "" && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON)) {
                        params = {
                            args: JSON.stringify({
                                exportMode: mode,
                                exportOption: exportOption,
                                pGridData: (pivotClientObj._pivotGrid.exportRecords != null && pivotClientObj._pivotGrid.exportRecords != "") ? pivotClientObj._pivotGrid.exportRecords : null, rowCount: pivotClientObj._pivotGrid._excelLikeJSONRecords != null ? pivotClientObj._pivotGrid._excelRowCount : pivotClientObj._pivotGrid._rowCount, columnCount: pivotClientObj._pivotGrid._excelLikeJSONRecords != null ? Math.floor(pivotClientObj._pivotGrid._excelLikeJSONRecords.length / pivotClientObj._pivotGrid._excelRowCount) : pivotClientObj._pivotGrid.getJSONRecords() != null ? Math.floor(pivotClientObj._pivotGrid.getJSONRecords().length / pivotClientObj._pivotGrid._rowCount) : 0, fileName: exportSetting.fileName, customObject: JSON.stringify(pivotClientObj._pivotGrid.model.customObject),
                                title: exportSetting.title,
                                description: exportSetting.description
                            })
                        };
                    }
                    else {
                        params = {
                            args: JSON.stringify({
                                exportMode: mode,
                                exportOption: exportOption,
                                currentReport: pivotClientObj.model.enableDeferUpdate ? pivotClientObj._deferReport : pivotClientObj.currentReport,
                                layout: pivotClientObj.gridLayout(),
                                colorSettings: JSON.stringify(colorDetails),
                                title: exportSetting.title,
                                description: exportSetting.description
                            })
                        };
                    }
                }
                else if (pivotClientObj.model.displaySettings.mode == ej.PivotClient.DisplayMode.ChartOnly || pivotClientObj.model.clientExportMode == ej.PivotClient.ClientExportMode.ChartOnly) {
                    mode = ej.PivotClient.ClientExportMode.ChartOnly;
                    if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || (pivotClientObj._pivotGrid._excelLikeJSONRecords != null && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON) || ($.trim(exportSetting.url) != "" && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON)) {
                        params = {
                            args: JSON.stringify({
                                exportMode: mode,
                                exportOption: exportOption,
                                fileName: exportSetting.fileName,
                                chartdata: chartString.split(',')[1],
                                bgColor: $(pivotClientObj._pivotChart.element).css('background-color'),
                                title: exportSetting.title,
                                description: exportSetting.description
                            })
                        };
                    }
                    else {
                        params = {
                            args: JSON.stringify({
                                exportMode: mode,
                                exportOption: exportOption,
                                currentReport: pivotClientObj.model.enableDeferUpdate ? pivotClientObj._deferReport : pivotClientObj.currentReport,
                                chartdata: chartString.split(',')[1],
                                legenddata: "",//legendString.split(',')[1],
                                bgColor: $(pivotClientObj._pivotChart.element).css('background-color'),
                                title: exportSetting.title,
                                description: exportSetting.description
                            })
                        };
                    }
                }
                else {
                    mode = ej.PivotClient.ClientExportMode.ChartAndGrid;
                    if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || (pivotClientObj._pivotGrid._excelLikeJSONRecords != null && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON) || ($.trim(exportSetting.url) != "" && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON)) {
                        params = {
                            args: JSON.stringify({
                                exportMode: mode,
                                exportOption: exportOption,
                                pGridData: (pivotClientObj._pivotGrid.exportRecords != null && pivotClientObj._pivotGrid.exportRecords != "") ? pivotClientObj._pivotGrid.exportRecords : null, rowCount: pivotClientObj._pivotGrid._excelLikeJSONRecords != null ? pivotClientObj._pivotGrid._excelRowCount : pivotClientObj._pivotGrid._rowCount, columnCount: pivotClientObj._pivotGrid._excelLikeJSONRecords != null ? Math.floor(pivotClientObj._pivotGrid._excelLikeJSONRecords.length / pivotClientObj._pivotGrid._excelRowCount) : pivotClientObj._pivotGrid.getJSONRecords() != null ? Math.floor(pivotClientObj._pivotGrid.getJSONRecords().length / pivotClientObj._pivotGrid._rowCount) : 0, fileName: exportSetting.fileName, customObject: JSON.stringify(pivotClientObj._pivotGrid.model.customObject),
                                chartdata: chartString.split(',')[1],
                                bgColor: $(pivotClientObj._pivotChart.element).css('background-color'),
                                title: exportSetting.title,
                                description: exportSetting.description
                            })
                        };
                    }
                    else {
                        params = {
                            args: JSON.stringify({
                                exportMode: mode,
                                exportOption: exportOption,
                                currentReport: pivotClientObj.model.enableDeferUpdate ? pivotClientObj._deferReport : pivotClientObj.currentReport,
                                layout: pivotClientObj.gridLayout(),
                                colorSettings: JSON.stringify(colorDetails),
                                chartdata: chartString.split(',')[1],
                                legenddata: "",//legendString.split(',')[1],
                                bgColor: $(pivotClientObj._pivotChart.element).css('background-color'),
                                title: exportSetting.title,
                                description: exportSetting.description
                            })
                        };
                    }
                }
                if (ej.raiseWebFormsServerEvents && ($.trim(exportSetting.url) != "" && exportSetting.url == "pivotClientExport" && exportSetting.exportMode == ej.PivotClient.ExportMode.JSON)) {
                    var serverArgs = { model: pivotClientObj.model, originalEventType: exportSetting.url };
                    var clientArgs = params;
                    ej.raiseWebFormsServerEvents(exportSetting.url, serverArgs, clientArgs);
                    setTimeout(function () {
                        ej.isOnWebForms = true;
                    }, 1000);
                }
                else
                    pivotClientObj.doPostBack($.trim(exportSetting.url) != "" ? exportSetting.url : (pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.exportPivotClient), params);
            });
            this.element.find(".toggleaxisImg").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
                if (pivotClientObj.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                    pivotClientObj.chartObj = null;
                    pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                    if (ej.isNullOrUndefined(pivotClientObj.chartObj) && !ej.isNullOrUndefined(pivotClientObj.otreemapObj))
                        pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                }
                if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                {
                    var dataSrcInfo = pivotClientObj.model.dataSource.rows;
                    pivotClientObj.model.dataSource.rows = pivotClientObj.model.dataSource.columns;
                    pivotClientObj.model.dataSource.columns = dataSrcInfo;
                    if (pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap && pivotClientObj.model.dataSource.values.length > 0)
                        pivotClientObj.model.dataSource.values[0]["axis"]= pivotClientObj.model.dataSource.values[0]["axis"] == "rows" ? "columns" : (pivotClientObj.model.dataSource.values[0]["axis"] == "columns" ? "rows" : "columns");
                    if(pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                    ej.olap.base.clearDrilledItems(pivotClientObj.model.dataSource, { action: "nodeDropped" }, pivotClientObj);
                    pivotClientObj.refreshControl();
                }
                else if (pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toolbarServices, JSON.stringify({ "action": "toggleAxis", "args": JSON.stringify({ "currentReport": JSON.parse(pivotClientObj.getOlapReport()).Report, "sortedHeaders": (!ej.isNullOrUndefined(pivotClientObj._ascdes) ? pivotClientObj._ascdes : "") }), "customObject": JSON.stringify(pivotClientObj.model.customObject) }), pivotClientObj._toggleAxisSuccess);
                }
                else if ((pivotClientObj.element.find(".rowAxis").html() != "") || (pivotClientObj.element.find(".categoricalAxis").html() != ""))
                    pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toggleAxis, JSON.stringify({ "action": "toggleAxis", "currentReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": JSON.stringify(pivotClientObj.model.customObject) }), pivotClientObj._toggleAxisSuccess);
            });

            this.element.find(".reportDBImg").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                var reportDBDlg = ej.buildTag("div.reportDBDialog#reportDBDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                     ej.buildTag("td", ej.buildTag("div.saveReportImg reportDBIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Save"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                     ej.buildTag("td", ej.buildTag("div.saveAsReportImg reportDBIcon").attr({ "title": pivotClientObj._getLocalizedLabels("SaveAs"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                     ej.buildTag("td", ej.buildTag("div.loadReportImg reportDBIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Load"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                     ej.buildTag("td", ej.buildTag("div.removeDBReportImg reportDBIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Remove"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                     ej.buildTag("td", ej.buildTag("div.renameDBReportImg reportDBIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Rename"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
              
                var ele = pivotClientObj.element.find('div.reportDBDialog');
                if (ele.length == 0) {
                    $(reportDBDlg).appendTo(pivotClientObj.element);
                    $(reportDBDlg).css("left", this.offsetLeft + 20 + "px").css("top", this.offsetTop + 20 + "px");
                }
                pivotClientObj.element.find(".reportDBIcon").click(function (evt) {
                    $(reportDBDlg).remove();
                    pivotClientObj = pivotClientObj;
                    pivotClientObj._off(pivotClientObj.element, "click", ".reportDBIcon");
                    if (evt.target.className.indexOf("loadReportImg") >= 0 || evt.target.className.indexOf("removeDBReportImg") >= 0 || evt.target.className.indexOf("renameDBReportImg") >= 0) {
                        var action = evt.target.className.indexOf("loadReportImg") >= 0 ? "LoadReport" : (evt.target.className.indexOf("removeDBReportImg") >= 0 ? "RemoveDBReport" : "RenameDBReport");
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                pivotClientObj._waitingPopup.show();
                        }, 800);
                        if (pivotClientObj.model.operationalMode == "servermode") {
                            if (pivotClientObj.model.beforeServiceInvoke != null)
                                pivotClientObj._trigger("beforeServiceInvoke", { action: "FetchingReportList", element: pivotClientObj.element, customObject: pivotClientObj.model.customObject });
                            var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                            pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.fetchReportList, JSON.stringify({ "customObject": serializedCustomObject, "action": action, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode }), pivotClientObj._fetchReportListSuccess);
                        }
                        else {
                            var fetchReportSetting = { url: "", reportCollection: pivotClientObj._clientReportCollection, reportList: "", mode: pivotClientObj.model.analysisMode }
                            pivotClientObj._trigger("fetchReport", { targetControl: pivotClientObj, fetchReportSetting: fetchReportSetting });
                            if (pivotClientObj.model.enableLocalStorage) {
                                pivotClientObj._fetchReportListSuccess({ d: [{ Key: "ReportNameList", Value: fetchReportSetting.reportList }] });
                            } else {
                                var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                                pivotClientObj.doAjaxPost("POST", fetchReportSetting.url + "/" + pivotClientObj.model.serviceMethodSettings.fetchReportList, JSON.stringify({ "customObject": serializedCustomObject, "action": action, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, }), pivotClientObj._fetchReportListSuccess);
                            }
                        }
                    }
                    else if (evt.target.className.indexOf("saveReportImg") >= 0) {
                        if (pivotClientObj._currentRecordName == "") {
                            pivotClientObj._createDialogRequest(evt);
                            return false;
                        }
                        else {
                            pivotClientObj._isTimeOut = true;
                            setTimeout(function () {
                                if (pivotClientObj._isTimeOut)
                                    pivotClientObj._waitingPopup.show();
                            }, 800);
                        }
                        if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                            if (pivotClientObj.model.beforeServiceInvoke != null)
                                pivotClientObj._trigger("beforeServiceInvoke", { action: "saveReport", element: this.element, customObject: pivotClientObj.model.customObject });
                            var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                            pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.saveReport, JSON.stringify({
                                "reportName": pivotClientObj._currentRecordName, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "olapReport": pivotClientObj.currentReport, "clientReports": (pivotClientObj.model.analysisMode == "pivot" ? JSON.stringify(pivotClientObj._clientReportCollection) : pivotClientObj.reports), "customObject": serializedCustomObject
                            }), pivotClientObj._toolbarOperationSuccess);
                        }
                        else {
                            var saveReportSetting = { url: "", reportName: pivotClientObj._currentRecordName, reportCollection: pivotClientObj._clientReportCollection, mode: pivotClientObj.model.analysisMode, filterCollection: pivotClientObj._currentReportItems }
                            pivotClientObj._trigger("saveReport", { targetControl: pivotClientObj, saveReportSetting: saveReportSetting });
                            if (!pivotClientObj.model.enableLocalStorage) {
                                var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                                pivotClientObj.doAjaxPost("POST", saveReportSetting.url + "/" + pivotClientObj.model.serviceMethodSettings.saveReport, JSON.stringify({
                                    "reportName": saveReportSetting.reportName, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "olapReport": JSON.stringify(pivotClientObj.model.dataSource), "clientReports": JSON.stringify(pivotClientObj._clientReportCollection) + ":>>:" + JSON.stringify(pivotClientObj._currentReportItems), "customObject": serializedCustomObject
                                }), pivotClientObj._toolbarOperationSuccess);
                            }
                        }
                    }
                    else if ((pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap) || (!$(evt.currentTarget).hasClass("pvtBtn")))
                        pivotClientObj._createDialogRequest(evt);
                });
            }),

            this.element.find(".chartTypesImg").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                var chartTypesDlg = ej.buildTag("div.chartTypesDialog#chartTypesDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                    ej.buildTag("td", ej.buildTag("div.line chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Line"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.spline chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Spline"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.column chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Column"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.area chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Area"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.splinearea chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("SplineArea"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                    ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.stepline chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("StepLine"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.steparea chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("StepArea"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.pie chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Pie"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.bar chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Bar"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.stackingarea chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("StackingArea"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                    ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.stackingcolumn chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("StackingColumn"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.stackingbar chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("StackingBar"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.funnel chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Funnel"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.pyramid chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Pyramid"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.doughnut chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Doughnut"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                    ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.scatter chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Scatter"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.bubble chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("Bubble"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
					ej.buildTag("td", ej.buildTag("div.waterfall chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("WaterFall"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    (pivotClientObj.model.enablePivotTreeMap ? (ej.buildTag("td", ej.buildTag("div.treemap chartTypesIcon").attr({ "title": pivotClientObj._getLocalizedLabels("TreeMap"), tabindex: 0 })[0].outerHTML)[0].outerHTML) : ""))[0].outerHTML)[0].outerHTML)[0].outerHTML);

                var ele = pivotClientObj.element.find('div.chartTypesDialog');
                if (ele.length == 0) {
                    $(chartTypesDlg).appendTo(pivotClientObj.element);
                    if (pivotClientObj.model.enableToolBar)
                        $(chartTypesDlg).css("left", $(evt.target).offset().left + 10 + "px").css("top", $(evt.target).offset().top + 15 + "px");
                    else
                        $(chartTypesDlg).css("left", this.offsetLeft + 20 + "px").css("top", this.offsetTop + 20 + "px");
                    if(!pivotClientObj._pivotChart.model.enable3D)
                       pivotClientObj.element.find("." + pivotClientObj._pivotChart.seriesType()).addClass("activeChartType");
                }
                $(".chartTypesIcon").click(function (e) {
                    var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                    pivotClientObj.element.find(".chartTypesIcon").removeClass("activeChartType");
                    $(chartTypesDlg).remove();
                    var selectedtype = e.target.className.split(" ")[0];
                    pivotClientObj.model.chartType = selectedtype;
                    pivotClientObj._pivotChart.model.enable3D = false;
                    pivotClientObj._pivotChart.model.type = selectedtype;
                    pivotClientObj._pivotChart.model.commonSeriesOptions.type = selectedtype;
                    if (selectedtype == "funnel") {
                        pivotClientObj._pivotChart.model.commonSeriesOptions.marker = {
                            dataLabel: {
                                visible: true,
                                shape: 'none',
                                font: { color: pivotClientObj.element.css("color"), size: '12px', fontWeight: 'lighter' }
                            }
                        }
                    }
                    if (pivotClientObj._pivotChart.getJSONRecords() != null) {
                        if (pivotClientObj.model.operationalMode != ej.Pivot.OperationalMode.ClientMode) {
                        pivotClientObj.chartObj = null;
                            pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                        if (ej.isNullOrUndefined(pivotClientObj.chartObj) && !ej.isNullOrUndefined(pivotClientObj.otreemapObj))
                            pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                        if (!ej.isNullOrUndefined(pivotClientObj.chartObj)) {
                            if (!pivotClientObj.model.enableDeferUpdate) {
                                if (pivotClientObj.model.enablePivotTreeMap && this.title.toLocaleLowerCase() == "treemap") {
                                    pivotClientObj._isrenderTreeMap = true;
                                    if (pivotClientObj.model.enablePivotTreeMap) {
                                        pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChartContainer").remove();
                                        pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").removeClass("e-pivotchart")
                                        if (pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").hasClass("e-pivottreemap"))
                                                pivotClientObj.otreemapObj.renderControlSuccess({ "JsonRecords": JSON.stringify(pivotClientObj._pivotChart.getJSONRecords()), "OlapReport": pivotClientObj._pivotChart.getOlapReport() });
                                        else {
                                            pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").ejPivotTreeMap({ url: pivotClientObj.model.url, customObject: pivotClientObj.model.customObject, canResize: pivotClientObj.model.isResponsive, currentReport: pivotClientObj.currentReport, locale: pivotClientObj.locale(), size: { height: pivotClientObj._chartHeight, width: pivotClientObj._chartWidth }, drillSuccess: ej.proxy(pivotClientObj._treemapDrillSuccess, pivotClientObj), beforeServiceInvoke: pivotClientObj.model.treeMapLoad });
                                            pivotClientObj.otreemapObj = pivotClientObj.element.find('#' + pivotClientObj._id + '_PivotChart').data("ejPivotTreeMap");
                                            pivotClientObj.chartObj = null;
                                        }
                                    }
                                }
                                else {
                                    pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChartTreeMapContainer").remove();
                                    pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").removeClass("e-pivottreemap")
                                    if (pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").hasClass("e-pivotchart")) {
                                        pivotClientObj._pivotChart.renderControlSuccess({ "JsonRecords": JSON.stringify(pivotClientObj._pivotChart.getJSONRecords()), "OlapReport": pivotClientObj._pivotChart.getOlapReport() });
                                        return false;
                                    }
                                    else {
                                        pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").ejPivotChart({ url: pivotClientObj.model.url, customObject: pivotClientObj.model.customObject, enableRTL: pivotClientObj.model.enableRTL, canResize: pivotClientObj.model.isResponsive, currentReport: pivotClientObj.currentReport, customObject: pivotClientObj.model.customObject, locale: pivotClientObj.locale(), showTooltip: true, size: { height: pivotClientObj._chartHeight, width: pivotClientObj._chartWidth }, commonSeriesOptions: { type: pivotClientObj.model.chartType, tooltip: { visible: true } }, beforeServiceInvoke: pivotClientObj.model.chartLoad, drillSuccess: ej.proxy(pivotClientObj._chartDrillSuccess, pivotClientObj) });
                                        pivotClientObj._pivotChart = pivotClientObj.element.find('#' + pivotClientObj._id + '_PivotChart').data("ejPivotChart");
                                        pivotClientObj.chartObj = null;
                                    }
                                }
                            }
                            else {
                                pivotClientObj._ischartTypesChanged = true;
                                if (pivotClientObj.model.enablePivotTreeMap && this.title.toLocaleLowerCase() == "treemap") {
                                    if (pivotClientObj.model.enablePivotTreeMap) {
                                        pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChartContainer").remove();
                                        pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").removeClass("e-pivotchart")
                                        if (pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").hasClass("e-pivottreemap"))
                                                pivotClientObj.otreemapObj.renderTreeMapFromJSON(pivotClientObj._pivotChart.getJSONRecords());
                                        else {
                                            pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").ejPivotTreeMap({ url: pivotClientObj.model.url, customObject: this.model.customObject, canResize: pivotClientObj.model.isResponsive, currentReport: pivotClientObj.currentReport, locale: pivotClientObj.locale(), size: { height: pivotClientObj._chartHeight, width: pivotClientObj._chartWidth }, drillSuccess: ej.proxy(pivotClientObj._treemapDrillSuccess, pivotClientObj), beforeServiceInvoke: pivotClientObj.model.treeMapLoad });
                                            pivotClientObj.otreemapObj = pivotClientObj.element.find('#' + pivotClientObj._id + '_PivotChart').data("ejPivotTreeMap");
                                            pivotClientObj._isrenderTreeMap = true;
                                            pivotClientObj.chartObj = null;
                                        }
                                    }
                                }
                                else {
                                    pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChartTreeMapContainer").remove();
                                    pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").removeClass("e-pivottreemap")
                                    if (pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").hasClass("e-pivotchart"))
                                            pivotClientObj._pivotChart.renderControlSuccess({ "JsonRecords": JSON.stringify(pivotClientObj._pivotChart.getJSONRecords()), "OlapReport": pivotClientObj._pivotChart.getOlapReport() });
                                    else {
                                        pivotClientObj.element.find("#" + pivotClientObj._id + "_PivotChart").ejPivotChart({ url: pivotClientObj.model.url, customObject: this.model.customObject, enableRTL: pivotClientObj.model.enableRTL, canResize: pivotClientObj.model.isResponsive, currentReport: pivotClientObj.currentReport, customObject: pivotClientObj.model.customObject, locale: pivotClientObj.locale(), showTooltip: true, size: { height: pivotClientObj._chartHeight, width: pivotClientObj._chartWidth }, commonSeriesOptions: { type: pivotClientObj.model.chartType, tooltip: { visible: true } }, beforeServiceInvoke: pivotClientObj.model.chartLoad, drillSuccess: ej.proxy(pivotClientObj._chartDrillSuccess, pivotClientObj) });
                                        pivotClientObj._pivotChart = pivotClientObj.element.find('#' + pivotClientObj._id + '_PivotChart').data("ejPivotChart");
                                        pivotClientObj.chartObj = null;
                                    }
                                }
                            }
                            var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                            pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.updateReport, JSON.stringify({
                                "action": "chartTypeChanged", "clientParams": selectedtype, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject
                            }), pivotClientObj._chartTypeChangedSuccess);
                        }
                    }
                        else
                            pivotClientObj._pivotChart.renderControlSuccess({ "JsonRecords": JSON.stringify(pivotClientObj._pivotChart.getJSONRecords()), "OlapReport": pivotClientObj._pivotChart.getOlapReport() });
                        if (pivotClientObj.model.isResponsive) {
                            pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                            if (!ej.isNullOrUndefined(pivotClientObj.chartObj))
                                pivotClientObj.element.find("#" + pivotClientObj.chartObj._id).ejChart("option", { "model": { size: { height: pivotClientObj._chartHeight } } });
                        }
                    }
                    else {
                        pivotClientObj._isTimeOut = false;
                        pivotClientObj._waitingPopup.hide();
                    }
                });
            });

            $(document).click(function (e) {
                if (e.target.className.indexOf('chartTypesImg') == -1)
                    $(".chartTypesDialog").remove();
                if (e.target.className.indexOf('reportDBImg') == -1)
                    $(".reportDBDialog").remove();
                if (e.target.className.indexOf('exportImg') == -1)
                    $(".exportTypesDialog").remove();
                if (e.target.className.indexOf('chart3DImg') == -1)
                    $(".chart3DTypesDialog").remove();
                if (e.target.className.indexOf('smartLabels') == -1)
                    $(".smartLabelsDialog").remove();
                if (e.target.className.indexOf('interaction') == -1)
                    $(".interactionsDialog").remove();
            });

            this.element.find(".dialogCancelBtn").on(ej.eventType.click, function (e) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                e.preventDefault();
                pivotClientObj.element.find(".e-dialog").hide();
                pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
                ej.Pivot.closePreventPanel(pivotClientObj);
            });

            this.element.find(".dialogOKBtn").on(ej.eventType.click, function (e) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                e.preventDefault();
                if (pivotClientObj.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                    pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj._pivotChart._id + "Container").data("ejChart");
                    if (ej.isNullOrUndefined(pivotClientObj.chartObj) && pivotClientObj.model.enablePivotTreeMap && !ej.isNullOrUndefined(pivotClientObj.otreemapObj))
                        pivotClientObj.chartObj = pivotClientObj.element.find("#" + pivotClientObj.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                }
                var loadDlgTitle = (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8) ? pivotClientObj._dialogTitle : pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar")[0].textContent == undefined ? pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar")[0].innerText : pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar")[0].textContent;
                if (loadDlgTitle == pivotClientObj._getLocalizedLabels("Load")) {
                    pivotClientObj._currentRecordName = pivotClientObj.element.find(".reportNameList")[0].value;
                    var selectedReport = pivotClientObj.element.find(".reportNameList")[0].value;
                    if (selectedReport != "") {
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                pivotClientObj._waitingPopup.show();
                        }, 800);
                        pivotClientObj._fieldMembers = {};
                        pivotClientObj._fieldSelectedMembers = {};
                        if (pivotClientObj.model.operationalMode == "servermode") {
                            if (pivotClientObj.model.beforeServiceInvoke != null)
                                pivotClientObj._trigger("beforeServiceInvoke", { action: "loadReport", element: this.element, customObject: pivotClientObj.model.customObject });
                            var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                            pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.loadReport, JSON.stringify({
                                "reportName": selectedReport, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject, "clientParams": JSON.stringify(pivotClientObj.model.enableMeasureGroups)
                            }), (pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? pivotClientObj._renderControlSuccess : pivotClientObj._toolbarOperationSuccess));
                        }
                        else {
                            var loadReportSetting = { url: "", reportCollection: pivotClientObj._clientReportCollection,selectedReport:selectedReport, mode: pivotClientObj.model.analysisMode }
                            pivotClientObj._trigger("loadReport", { targetControl: pivotClientObj, loadReportSetting: loadReportSetting });
                            if (pivotClientObj.model.enableLocalStorage) {
                                pivotClientObj.model.dataSource = loadReportSetting.reportCollection[0];
                                pivotClientObj._currentReportCollection = loadReportSetting.reportCollection;
                                pivotClientObj.refreshControl();
                                pivotClientObj._refreshReportList();
                                if (pivotClientObj._pivotSchemaDesigner)
                                    pivotClientObj._pivotSchemaDesigner._refreshPivotButtons();
                            } else {
                                var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                                pivotClientObj.doAjaxPost("POST", loadReportSetting.url + "/" + pivotClientObj.model.serviceMethodSettings.loadReport, JSON.stringify({
                                    "reportName": selectedReport, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject, "clientParams": JSON.stringify(pivotClientObj.model.enableMeasureGroups)
                                }), (pivotClientObj._clientToolbarOperationSuccess));
                            }
                        }
                    }
                    else {
                        ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("SelectRecordAlertMsg"), "Error", pivotClientObj);
                        return false;
                    }
                }
                else if (loadDlgTitle == pivotClientObj._getLocalizedLabels("Remove")) {
                    var selectedReport = pivotClientObj.element.find(".reportNameList")[0].value;
                    if (selectedReport != "" && !ej.isNullOrUndefined(selectedReport)) {
                        pivotClientObj._currentRecordName = selectedReport == pivotClientObj._currentRecordName ? "" : pivotClientObj._currentRecordName;
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                pivotClientObj._waitingPopup.show();
                        }, 800);
                        var fetchReportSetting;
                        if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                            fetchReportSetting = { url: "", selectedReport: selectedReport, mode: pivotClientObj.model.analysisMode }
                            pivotClientObj._trigger("loadReport", { targetControl: pivotClientObj, fetchReportSetting: fetchReportSetting });
                        }
                        if (pivotClientObj.model.beforeServiceInvoke != null)
                            pivotClientObj._trigger("beforeServiceInvoke", { action: "removeDBReport", element: this.element, customObject: pivotClientObj.model.customObject });
                        var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                        pivotClientObj._fieldMembers = {};
                        pivotClientObj._fieldSelectedMembers = {};
                        pivotClientObj.doAjaxPost("POST", (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? fetchReportSetting.url : pivotClientObj.model.url) + "/" + pivotClientObj.model.serviceMethodSettings.removeDBReport, JSON.stringify({
                            "reportName": selectedReport, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "customObject": serializedCustomObject,
                        }), pivotClientObj._toolbarOperationSuccess);
                    }
                    else {
                        ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("SelectRecordAlertMsg"), "Error", pivotClientObj);
                        return false;
                    }
                }
                else if (loadDlgTitle == pivotClientObj._getLocalizedLabels("Rename")) {
                    var renameReport = pivotClientObj.element.find(".renameReport").val();
                    var selectedReport = pivotClientObj.element.find(".reportNameList")[0].value;
                    if (selectedReport != "" && !ej.isNullOrUndefined(selectedReport) && renameReport != "" && !ej.isNullOrUndefined(renameReport)) {
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                pivotClientObj._waitingPopup.show();
                        }, 800);
                        var fetchReportSetting;
                        if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                            fetchReportSetting = { url: "", selectedReport: selectedReport, mode: pivotClientObj.model.analysisMode }
                            pivotClientObj._trigger("loadReport", { targetControl: pivotClientObj, fetchReportSetting: fetchReportSetting });
                        }
                        if (pivotClientObj.model.beforeServiceInvoke != null)
                            pivotClientObj._trigger("beforeServiceInvoke", { action: "renameDBReport", element: this.element, customObject: pivotClientObj.model.customObject });
                        var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                        pivotClientObj.doAjaxPost("POST", (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode ? fetchReportSetting.url : pivotClientObj.model.url) + "/" + pivotClientObj.model.serviceMethodSettings.renameDBReport, JSON.stringify({
                            "selectedReport": selectedReport, "renameReport": renameReport, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "customObject": serializedCustomObject,
                        }), pivotClientObj._toolbarOperationSuccess);
                    }
                    else {
                        if (selectedReport == "" || ej.isNullOrUndefined(selectedReport))
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("SelectRecordAlertMsg"), "Error", pivotClientObj);
                        else if (renameReport == "" || ej.isNullOrUndefined(renameReport))
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("SetReportNameAlertMsg"), "Error", pivotClientObj);
                        return false;
                    }
                }
                else if (pivotClientObj.element.find(".sortingDlg").length > 0) {
                    if (pivotClientObj.element.find(".sortEnable")[0].checked == true && pivotClientObj.element.find(".measuresList")[0].value == "") {
                        ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("FilterMeasureSelectionAlertMsg"), "Error", pivotClientObj);
                        return false;
                    }
                    else if (pivotClientObj.element.find(".filterEnable")[0].checked == true) {
                        if (pivotClientObj.element.find(".fMeasuresList")[0].value == "") {
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("FilterMeasureSelectionAlertMsg"), "Error", pivotClientObj); return false;
                        }
                        else if (pivotClientObj.element.find(".filterCondition")[0].value == "") {
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("FilterConditionAlertMsg"), "Error", pivotClientObj); return false;
                        }
                        else if (pivotClientObj.element.find(".filterFrom")[0].value == "") {
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("FilterStartValueAlertMsg"), "Error", pivotClientObj); return false;
                        }
                        else if ((pivotClientObj.element.find(".filterCondition")[0].value == "Between" || pivotClientObj.element.find(".filterCondition")[0].value == "NotBetween") && pivotClientObj.element.find(".filterTo")[0].value == "") {
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("FilterEndValueAlertMsg"), "Error", pivotClientObj); return false;
                        }

                        pivotClientObj._excelFilterInfo = [];
                    }
                    var sortingDetails = null, filteringDetails = null;
                    if ((pivotClientObj._isSorted == false || pivotClientObj._isSorted == true) && pivotClientObj.element.find(".sortEnable")[0].checked == true)
                        sortingDetails = $("li[tag*='" + pivotClientObj.element.find(".measuresList")[0].value + "']").attr("tag") + "::" + ((pivotClientObj.element.find(".radioBtnAsc")[0].checked == true) ? "ASC" : "DESC") + "::" + pivotClientObj._axis + "::" + ((pivotClientObj.element.find(".preserveHrchy")[0].checked == true) ? "PHT" : "PHF");
                    else if (pivotClientObj._isSorted == true && pivotClientObj.element.find(".sortDisable")[0].checked == true)
                        sortingDetails = "Disable Sorting" + "::" + " " + "::" + pivotClientObj._axis + "::" + " ";
                    else
                        sortingDetails = " " + "::" + " " + "::" + pivotClientObj._axis + "::" + " ";
                    if ((pivotClientObj._isFiltered == false || pivotClientObj._isFiltered == true) && pivotClientObj.element.find(".filterEnable")[0].checked == true)
                        filteringDetails = $("li[tag*='" + pivotClientObj.element.find(".fMeasuresList")[0].value + "']").attr("tag") + "::" + pivotClientObj.element.find(".filterCondition")[0].value + "::" + pivotClientObj.element.find(".filterFrom")[0].value + "::" + pivotClientObj.element.find(".filterTo")[0].value;
                    else if (pivotClientObj._isFiltered == true && pivotClientObj.element.find(".filterDisable")[0].checked == true)
                        filteringDetails = "Disable Filtering";
                    else
                        filteringDetails = "";
                    pivotClientObj._SortFilterDetails = sortingDetails + "||" + filteringDetails;

                    pivotClientObj._isTimeOut = true;
                    setTimeout(function () {
                        if (pivotClientObj._isTimeOut)
                            pivotClientObj._waitingPopup.show();
                    }, 800);
                    if (pivotClientObj.element.find(".sortEnable")[0].checked == true || pivotClientObj.element.find(".filterEnable")[0].checked == true) {
                        pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toolbarServices, JSON.stringify({ "action": "toolbarOperation", "toolbarOperation": "SortOrFilter", "clientInfo": pivotClientObj._SortFilterDetails, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": JSON.stringify(pivotClientObj.model.customObject) }), pivotClientObj._toolbarOperationSuccess);
                    }
                    else if (pivotClientObj.element.find(".sortDisable")[0].checked == true || pivotClientObj.element.find(".filterDisable")[0].checked == true) {
                        if (pivotClientObj._isSorted == true || pivotClientObj._isFiltered == true) {
                            pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toolbarServices, JSON.stringify({ "action": "toolbarOperation", "toolbarOperation": "SortOrFilter", "clientInfo": pivotClientObj._SortFilterDetails, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": JSON.stringify(pivotClientObj.model.customObject) }), pivotClientObj._toolbarOperationSuccess);
                            pivotClientObj._isSorted = false;
                        }
                        else {
                            ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("FilterInvalidAlertMsg"), "Error", pivotClientObj);
                            pivotClientObj._isTimeOut = false;
                            pivotClientObj._waitingPopup.hide();
                            return false;
                        }
                    }
                }
                else {
                    if ($(".memberEditorDiv").length > 0 && e.target.id == "OKBtn") {
                        if (pivotClientObj.model.enableAdvancedFilter && pivotClientObj._excelFilterInfo.length > 0) {
                            pivotClientObj._removeFilterTag(pivotClientObj._selectedFieldName);
                            if(pivotClientObj._selectedLevelUniqueName)
                                pivotClientObj._removeFilterTag(pivotClientObj._selectedLevelUniqueName);
                        }
                        if ((pivotClientObj._currentItem.indexOf(pivotClientObj._getLocalizedLabels("Measures")) < 0))
                            ej.Pivot.updateTreeView(pivotClientObj);
                        if (!pivotClientObj.model.enableMemberEditorPaging && pivotClientObj._getSelectedNodes() == 0 && args_innerHTML != pivotClientObj._getLocalizedLabels("Measures") && args_innerHTML != "ToolbarButtons")
                            return false;
                        if ((pivotClientObj._currentItem.indexOf(pivotClientObj._getLocalizedLabels("Measures")) < 0)) {
                            if (pivotClientObj._currentReportItems.length != 0) {
                                var nodeContain = false;
                                for (var i = 0; i < pivotClientObj._currentReportItems.length; i++) {
                                    if (pivotClientObj._currentReportItems[i] == pivotClientObj._currentItem) {
                                        nodeContain = true;
                                        break;
                                    }
                                }
                            }
                            if (!nodeContain || pivotClientObj._currentReportItems.length == 0)
                                pivotClientObj._currentReportItems.push(pivotClientObj._currentItem);
                            pivotClientObj._treeViewData[pivotClientObj._currentItem] = pivotClientObj._memberTreeObj.dataSource();
                        }
                    }
                    var unselectedNodes = null;
                    if (args_innerHTML != "ToolbarButtons") {
                        if (!pivotClientObj._isMembersFiltered && !pivotClientObj.model.enableMemberEditorPaging) {
                            pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
                            ej.Pivot.closePreventPanel(pivotClientObj);
                            return;
                        }
                        else if (args_innerHTML == pivotClientObj._getLocalizedLabels("Measures"))
                            unselectedNodes = "Measures:" + pivotClientObj._getMeasuresList();
                        else if (args_innerHTML != "ToolbarButtons" && args_innerHTML != undefined) {
                            ej.Pivot.updateTreeView(pivotClientObj);
                            unselectedNodes = pivotClientObj._getUnSelectedNodes() + "CHECKED" + pivotClientObj._getSelectedNodes(pivotClientObj._currentAxis == "Slicers" ? true : false);
                        }
                        pivotClientObj._isTimeOut = true;
                        setTimeout(function () {
                            if (pivotClientObj._isTimeOut)
                                pivotClientObj._waitingPopup.show();
                        }, 800);
                        if (args_innerHTML == pivotClientObj._getLocalizedLabels("Measures") && unselectedNodes != null && unselectedNodes.split(":")[1] == "") {
                            $(pivotClientObj.element).find(".splitBtn").each(function (index, value) {
                                if (value.firstChild.innerHTML == pivotClientObj._getLocalizedLabels("Measures"))
                                    $(value).remove();
                            });
                        }
                        $(pivotClientObj).find(".e-dialog").hide();
                        if (pivotClientObj.model.enableMemberEditorPaging && args_innerHTML != pivotClientObj._getLocalizedLabels("Measures")&& args_innerHTML != pivotClientObj._getLocalizedLabels("KPIs")&& pivotClientObj.element.find(".nextPageDiv").length > 0)
                            unselectedNodes = ej.Pivot._getUnSelectedTreeState(pivotClientObj) + "CHECKED" + ej.Pivot._getSelectedTreeState(pivotClientObj._currentAxis == "Slicers" ? true : false, pivotClientObj);
                        if (pivotClientObj.model.beforeServiceInvoke != null)
                            pivotClientObj._trigger("beforeServiceInvoke", { "action": "filtering", element: this.element, customObject: pivotClientObj.model.customObject });
                        var member = ej.Pivot._getEditorMember(pivotClientObj._dialogTitle, pivotClientObj, false);
                        pivotClientObj._fieldSelectedMembers[pivotClientObj._dimensionName.split(":")[1]] = $.map(pivotClientObj._fieldMembers[pivotClientObj._dialogTitle], function (item) { if (!item.checked) return item; }).length == 0 ? "All" : ((member != "All" && member != "multiple") ? member : pivotClientObj._getLocalizedLabels("MultipleItems"));
                        pivotClientObj._setSplitBtnTitle();
                        var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                        pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.filterElement, JSON.stringify({ "action": "filtering", "clientParams": unselectedNodes, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject }), pivotClientObj._filterElementSuccess);
                    }
                    else {
                        if (pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").first().text() == pivotClientObj._getLocalizedLabels("RemoveReport") && this.reportsCount < 2)
                            pivotClientObj.element.find(".e-dialog").hide();
                        else if ($.trim(pivotClientObj.element.find(".reportName").val()) === "" && pivotClientObj.element.find(".reportName").val() != undefined) {
                            if (pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").first().text() == pivotClientObj._getLocalizedLabels("NewReport") || pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").first().text() == pivotClientObj._getLocalizedLabels("AddReport") || pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").first().text() == pivotClientObj._getLocalizedLabels("RenameReport"))
                                ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("SetReportNameAlertMsg"), "Error", pivotClientObj);
                            else
                                ej.Pivot._createErrorDialog(pivotClientObj._getLocalizedLabels("SetReportNameAlertMsg"), "Error", pivotClientObj);
                            return false;
                        }
                        else {
                            this.reportDropTarget = pivotClientObj.element.find('#reportList').data("ejDropDownList");
                            var reportName = $.trim(pivotClientObj.element.find(".reportName").val()) || this.reportDropTarget.selectedTextValue;
                            var operation = pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").first().attr("tag");
                            var olapReport = (operation == "New Report" ? "" : pivotClientObj.currentReport);
                            var clientReports = (operation == "New Report" ? "" : pivotClientObj.reports);
                            pivotClientObj._currentRecordName = (operation == "New Report" ? "" : pivotClientObj._currentRecordName);
                            pivotClientObj.element.find(".e-dialog").hide();
                            pivotClientObj._isTimeOut = true;
                            setTimeout(function () {
                                if (pivotClientObj._isTimeOut)
                                    pivotClientObj._waitingPopup.show();
                            }, 800);
                            if (pivotClientObj.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                                var newDataSource = { data: pivotClientObj.model.dataSource.data, reportName: reportName, enableAdvancedFilter: pivotClientObj.model.dataSource.enableAdvancedFilter, columns: [], cube: pivotClientObj.model.dataSource.cube, catalog: pivotClientObj.model.dataSource.catalog, reportName: reportName, rows: [], values: [], filters: [] };
                                var reportListData = pivotClientObj.element.find(".reportlist").data("ejDropDownList");
                                pivotClientObj.element.find(".reportlist").ejDropDownList("option", "change", ej.proxy(pivotClientObj._reportChanged, pivotClientObj));

                                if (operation == "New Report") {
                                    pivotClientObj.model.dataSource = newDataSource;
                                    pivotClientObj._clientReportCollection = [newDataSource];
                                    pivotClientObj.element.find(".reportlist").ejDropDownList("option", "dataSource", [{ name: reportName }]);
                                    reportListData.selectItemByText(reportName);
                                    pivotClientObj._fieldMembers = {};
                                    pivotClientObj._fieldSelectedMembers = {};
                                }
                                else if (operation == "Add Report") {
                                    pivotClientObj.model.dataSource = newDataSource;
                                    pivotClientObj.model.dataSource.reportName = reportName;
                                    var isExistingRpt = $.map(pivotClientObj._clientReportCollection, function (obj, index) { if (obj.reportName == pivotClientObj.model.dataSource.reportName) { return obj; } });
                                    pivotClientObj._clientReportCollection = $.map(pivotClientObj._clientReportCollection, function (obj, index) { if (obj.reportName != pivotClientObj.model.dataSource.reportName) return obj; });
                                    pivotClientObj._clientReportCollection.push(pivotClientObj.model.dataSource);
                                    pivotClientObj._fieldMembers = {};
                                    pivotClientObj._fieldSelectedMembers = {};
                                    if (isExistingRpt.length == 0) {
                                        var reportListData = pivotClientObj.element.find(".reportlist").data("ejDropDownList");
                                        reportListData.model.dataSource.push({ name: reportName });
                                        var rpList = JSON.stringify(reportListData.model.dataSource);
                                        pivotClientObj.element.find(".reportlist").ejDropDownList("option", "dataSource", JSON.parse(rpList));
                                        reportListData.selectItemByText(reportName);
                                    }
                                    else if (pivotClientObj._clientReportCollection.length > 0)
                                        pivotClientObj._reportChanged();

                                }
                                else if (operation == "Rename Report") {
                                    pivotClientObj._clientReportCollection = $.map(pivotClientObj._clientReportCollection, function (obj, index) { if (obj.reportName == pivotClientObj.model.dataSource.reportName) obj.reportName = reportName; return obj; });
                                    var rpList = JSON.stringify(($.map(reportListData.model.dataSource, function (obj, index) { return (obj.name != reportListData.getValue()) ? obj : { name: reportName }; })));
                                    pivotClientObj.model.dataSource.reportName = reportName;
                                    pivotClientObj.element.find(".reportlist").ejDropDownList("option", "dataSource", JSON.parse(rpList));
                                    reportListData.selectItemByText(reportName);
                                    pivotClientObj._currentItem = "";
                                }
                                else if (operation == "Remove Report") {
                                    pivotClientObj._clientReportCollection = $.map(pivotClientObj._clientReportCollection, function (obj, index) { if (obj.reportName != reportName) return obj; });
                                    var currReportIndex = $(reportListData.getSelectedItem()).index() >= pivotClientObj._clientReportCollection.length ? pivotClientObj._clientReportCollection.length - 1 : $(reportListData.getSelectedItem()).index();
                                    pivotClientObj.model.dataSource = pivotClientObj._clientReportCollection[currReportIndex];
                                    var rpList = JSON.stringify($.map(reportListData.model.dataSource, function (obj, index) { if (obj.name != reportListData.getValue()) return obj; }));
                                    pivotClientObj.element.find(".reportlist").ejDropDownList("option", "dataSource", JSON.parse(rpList));
                                    pivotClientObj._fieldMembers = {};
                                    pivotClientObj._fieldSelectedMembers = {};
                                    if (reportListData.model.dataSource.length > 0)
                                        reportListData.selectItemByText(pivotClientObj.model.dataSource.reportName);
                                }
                                else if (operation == "SaveAs Report") {
                                    pivotClientObj._currentRecordName = reportName;
                                    var saveReportSetting = { url: "", reportName: reportName, reportCollection: pivotClientObj._clientReportCollection, mode: pivotClientObj.model.analysisMode, filterCollection: pivotClientObj._currentReportItems }
                                    pivotClientObj._trigger("saveReport", { targetControl: pivotClientObj, saveReportSetting: saveReportSetting });
                                    if (!pivotClientObj.model.enableLocalStorage) {
                                        var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                                        pivotClientObj.doAjaxPost("POST", saveReportSetting.url + "/" + pivotClientObj.model.serviceMethodSettings.saveReport, JSON.stringify({
                                            "reportName": saveReportSetting.reportName, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "olapReport": JSON.stringify(pivotClientObj.model.dataSource), "clientReports": JSON.stringify(pivotClientObj._clientReportCollection) + ":>>:" + JSON.stringify(pivotClientObj._currentReportItems), "customObject": serializedCustomObject
                                        }), pivotClientObj._toolbarOperationSuccess);
                                    }
                                }
                                else if (operation != "Rename Report") {
                                    pivotClientObj.refreshControl();
                                    if (pivotClientObj._pivotSchemaDesigner)
                                        pivotClientObj._pivotSchemaDesigner._refreshPivotButtons();
                                }
                                pivotClientObj._isTimeOut = false;
                                pivotClientObj._waitingPopup.hide();
                            }
                            else {
                                var reportListData = pivotClientObj.element.find(".reportlist").data("ejDropDownList");
                                pivotClientObj._clientReportCollection = $.map(pivotClientObj._clientReportCollection, function (obj, index) {
                                    if (obj.name == reportListData.getValue())
                                        obj.report = olapReport;
                                    return obj;
                                });

                                if (operation == "SaveAs Report") {
                                    pivotClientObj._currentRecordName = reportName;
                                    if (pivotClientObj.model.beforeServiceInvoke != null)
                                        pivotClientObj._trigger("beforeServiceInvoke", { action: "saveReport", element: this.element, customObject: pivotClientObj.model.customObject });
                                    var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                                    pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.saveReport, JSON.stringify({
                                        "reportName": reportName, operationalMode: pivotClientObj.model.operationalMode, analysisMode: pivotClientObj.model.analysisMode, "olapReport": olapReport, "clientReports": (pivotClientObj.model.analysisMode == "pivot" ? JSON.stringify(pivotClientObj._clientReportCollection) : clientReports), "customObject": serializedCustomObject
                                    }), pivotClientObj._toolbarOperationSuccess);
                                }
                                else {
                                    if (pivotClientObj.model.beforeServiceInvoke != null)
                                        pivotClientObj._trigger("beforeServiceInvoke", { action: "toolbarOperation", element: this.element, customObject: pivotClientObj.model.customObject });
                                    var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                                    if (pivotClientObj.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                                        pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toolbarServices, JSON.stringify({
                                            "action": "toolbarOperation", "toolbarOperation": operation, "clientInfo": reportName, "olapReport": olapReport, "clientReports": clientReports, "customObject": serializedCustomObject
                                        }), pivotClientObj._toolbarOperationSuccess);
                                    }
                                    else {
                                        if (operation == pivotClientObj._getLocalizedLabels("NewReport")) {
                                            pivotClientObj._currentReportName = reportName;
                                            pivotClientObj._fieldMembers = {};
                                            pivotClientObj._fieldSelectedMembers = {};
                                        }
                                        else if (operation == pivotClientObj._getLocalizedLabels("AddReport")) {
                                            pivotClientObj._fieldMembers = {};
                                            pivotClientObj._fieldSelectedMembers = {};

                                           

                                            reportListData.model.dataSource.push({ name: reportName });
                                            reportListData.selectItemByText(reportName);
                                            pivotClientObj._currentReportName = reportName;
                                        }
                                        else if (operation == pivotClientObj._getLocalizedLabels("RemoveReport")) {
                                            for (var i = 0; i < pivotClientObj._clientReportCollection.length; i++) {
                                                if (pivotClientObj._clientReportCollection[i].name == pivotClientObj._currentReportName)
                                                    pivotClientObj._clientReportCollection.splice(i, 1);
                                            }
                                            var reportListData = pivotClientObj.element.find(".reportlist").data("ejDropDownList");
                                            for (var i = 0; i < reportListData.model.dataSource.length; i++) {
                                                if (reportListData.model.dataSource[i].name == pivotClientObj._currentReportName)
                                                    reportListData.model.dataSource.splice(i, 1);
                                            }
                                            reportListData.selectItemByText(reportListData.model.dataSource[0].name);
                                            olapReport = pivotClientObj._clientReportCollection[0].report;
                                            reportName = pivotClientObj._clientReportCollection[0].name;
                                            pivotClientObj._currentReport = "";
                                            pivotClientObj._currentReportName = reportName;
                                            pivotClientObj._fieldMembers = {};
                                            pivotClientObj._fieldSelectedMembers = {};
                                        }
                                        else if (operation == pivotClientObj._getLocalizedLabels("RenameReport")) {
                                            var report = "";
                                            try { report = JSON.parse(pivotClientObj.getOlapReport()).Report; }
                                            catch (err) { report = pivotClientObj.getOlapReport(); }
                                            pivotClientObj._clientReportCollection = $.map(pivotClientObj._clientReportCollection, function (obj, index) { if (obj.name == pivotClientObj._currentReportName) obj.name = reportName; return obj; });
                                            var reportListData = pivotClientObj.element.find(".reportlist").data("ejDropDownList");
                                            var rpList = JSON.stringify(($.map(reportListData.model.dataSource, function (obj, index) { return (obj.name != reportListData.getValue()) ? obj : { name: reportName, report: report }; })));
                                            pivotClientObj.element.find(".reportlist").ejDropDownList("option", "dataSource", JSON.parse(rpList));
                                            pivotClientObj._isReportListAction = false;
                                            reportListData.selectItemByText(reportName);
                                            pivotClientObj._isReportListAction = true;
                                            pivotClientObj._currentReportName = reportName;
                                            pivotClientObj._isTimeOut = false;
                                            pivotClientObj._waitingPopup.hide();
                                            ej.Pivot.closePreventPanel(pivotClientObj);
                                            return;
                                        }
                                        pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.toolbarServices, JSON.stringify({
                                            action: operation,
                                            args: JSON.stringify({
                                                "clientInfo": reportName, "currentReport": olapReport
                                            }), "customObject": serializedCustomObject
                                        }), pivotClientObj._toolbarOperationSuccess);
                                    }
                                }
                            }
                        }
                    }
                }
                if (pivotClientObj._isTimeOut) pivotClientObj._isTimeOut = false;
                pivotClientObj.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
                pivotClientObj.element.find("#preventDiv").remove();
            });
            this.element.find(".searchEditorTree").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                ej.Pivot._searchEditorTreeNodes(evt, pivotClientObj);
            });

            this.element.find(".calcMemberImg").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (pivotClientObj.element.find(".calcMemberDialog").length > 0) {
                    pivotClientObj._calcMemberTreeObj.collapseAll();
                    ej.Pivot.openPreventPanel(pivotClientObj);
                    pivotClientObj._calcMemberDialog.open();
                    pivotClientObj.element.find("#" + pivotClientObj._id + "_captionFieldCM").val("");
                    pivotClientObj.element.find("#" + pivotClientObj._id + "_expressionFieldCM").val("");
                    pivotClientObj.element.find("#" + pivotClientObj._id + "_memberTypeFieldCM").data("ejDropDownList").selectItemsByIndices(0);
                    pivotClientObj.element.find("#" + pivotClientObj._id + "_dimensionFieldCM").data("ejDropDownList").selectItemsByIndices(0);
                    pivotClientObj.element.find("#" + pivotClientObj._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(0);
                    pivotClientObj.element.find("#" + pivotClientObj._id + "_customFormatFieldCM").val("");
                }
                else {
                    pivotClientObj._waitingPopup.show();
                    if (pivotClientObj.model.beforeServiceInvoke != null)
                        pivotClientObj._trigger("beforeServiceInvoke", { action: "fetchCalcMemberTreeView", element: pivotClientObj.element, customObject: pivotClientObj.model.customObject });
                    var serializedCustomObject = JSON.stringify(pivotClientObj.model.customObject);
                    pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.fetchMemberTreeNodes, JSON.stringify({ "action": "fetchCalcMemberTreeView", "dimensionName": "calcMember", "olapReport": pivotClientObj.currentReport, "customObject": serializedCustomObject }), ej.proxy(ej.Pivot._createCalcMemberDialog, pivotClientObj));
                    //ej.Pivot._createCalcMemberDialog(pivotClientObj);
                }
            });
            //this._on(this.element, "click", ".calcMemberImg", ej.proxy(ej.Pivot._createCalcMemberDialog, this)); 
            this.element.find(".unCheckAll,.checkAll").click(function (evt) {
                var pivotClientObj = $(this).parents(".e-pivotclient").data("ejPivotClient");
                if (evt.target.className.indexOf("checkAll") > -1) {
                    pivotClientObj.element.find(".editorTreeView").ejTreeView("checkAll");
                    pivotClientObj._isMembersFiltered = true;
                    pivotClientObj.element.find(".dialogOKBtn").data("ejButton").enable();
                    pivotClientObj.element.find(".dialogOKBtn").removeAttr("disabled");
                    if (pivotClientObj.model.enableMemberEditorPaging) {
                        setTimeout(function () {
                            pivotClientObj._waitingPopup.show();
                            for (var i = 0; i < pivotClientObj._editorTreeData.length; i++)
                                pivotClientObj._editorTreeData[i].checkedStatus = true;
                            pivotClientObj._waitingPopup.hide();
                        }, 0);
                    }
                }
                else {
                    pivotClientObj.element.find(".editorTreeView").ejTreeView("unCheckAll");
                    pivotClientObj.element.find(".dialogOKBtn").data("ejButton").disable();
                    pivotClientObj.element.find(".dialogOKBtn").attr('disabled', 'disabled');
                    if (pivotClientObj.model.enableMemberEditorPaging) {
                        setTimeout(function () {
                            pivotClientObj._waitingPopup.show();
                            for (var i = 0; i < pivotClientObj._editorTreeData.length; i++)
                                pivotClientObj._editorTreeData[i].checkedStatus = false;
                            pivotClientObj._waitingPopup.hide();
                        }, 0);
                    }
                }
            });
        },

        _getLocalizedLabels: function (property) {
            return ej.PivotClient.Locale[this.locale()][property] === undefined ? ej.PivotClient.Locale["en-US"][property] : ej.PivotClient.Locale[this.locale()][property];
        },

        _unWireEvents: function () {
            $(this.element.find(".dialogCancelBtn, .dialogOKBtn, .newReportImg, .addReportImg, .removeReportImg, .renameReportImg, .pvtBtn, .removeSplitBtn, .unCheckAll, .checkAll, .removeMeasure, .toggleCollapseButton, .toggleExpandButton, .reportDBImg, .saveAsReportImg, .saveReportImg, .loadReportImg, .removeDBReportImg, .renameDBReportImg, .mdxImg,.maximizedView,.colSortFilterImg, .rowSortFilterImg, .chartTypesImg, .toggleaxisImg, .autoExecuteImg, .nextPage, .prevPage, .firstPage, .lastPage, .searchEditorTree, .calcMemberImg")).off(ej.eventType.click);
            $(this.element.find(".dialogCancelBtn, .dialogOKBtn, .newReportImg, .addReportImg, .removeReportImg, .renameReportImg, .pvtBtn, .removeSplitBtn, .unCheckAll, .checkAll, .removeMeasure, .toggleCollapseButton, .toggleExpandButton, .reportDBImg, .saveAsReportImg, .saveReportImg, .loadReportImg, .removeDBReportImg, .renameDBReportImg, .mdxImg,.maximizedView,.colSortFilterImg, .rowSortFilterImg, .chartTypesImg, .toggleaxisImg,.autoExecuteImg, .nextPage, .prevPage, .firstPage, .lastPage, .searchEditorTree,.calcMemberImg")).off('click');
            $(document).find(".winCloseBtn").off(ej.eventType.click);
            $(this._off(this.element, "mouseup", ".parentsplit"));
            this._off(this.element, "click", "#preventDiv");
            $(document).find(".winCloseBtn").off('click');
            this._off($(document), 'keydown', this._keyPressDown);
            this._off($(document), 'keyup', this._keyPressUp);
            if (this.model.isResponsive)
                $(window).off('resize', $.proxy(this._reSizeHandler, this));
        },
        _calculateHeight: function () {
            $(this.element).height($(this.element).height() < 450 ? 450 : $(this.element).height());
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
                var ctrlPanelHeight = this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + 5);
                this.element.find(".oClientTbl").css("height", ctrlPanelHeight + "px");
                this.element.find(".outerTable").css("height", ctrlPanelHeight + "px");
                if (this.model.enableVirtualScrolling) {
                    this.element.find(".controlPanel").css("height", (ctrlPanelHeight - 25) + "px");
                    this._pivotGrid._applyVScrolling();
                }
                else if (this.model.enablePaging) {
                    if (this.model.displaySettings.controlPlacement == ej.PivotClient.ControlPlacement.Tab)
                        this.element.find(".controlPanel").height(ctrlPanelHeight - this.element.find("#" + this._id + "_Pager").height());
                    else
                        this.element.find(".controlPanel").height(ctrlPanelHeight - this.element.find("#" + this._id + "_Pager").height() - 5);
                }
                else
                    this.element.find(".controlPanel").css("height", ctrlPanelHeight + "px");
                this.element.find(".cubeTable").css("height", ((this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 38)) + "px"));
                cdbHeight = this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 38);
                this.element.find(".cubeBrowser").css("height", (cdbHeight + 7) - this.element.find(".cdbHeader").height());
                this.element.find(".cubeTreeView").height((this.element.find(".cubeBrowser").height() - this.element.find(".cubeName").height()) - (7 + (this.model.enableMeasureGroups ? (this.element.find(".measureGroupselector").height() + 13) : 0)));
                aebHeight = cdbHeight - ((this.element.find(".axisHeader").height() * 3) + 4);
                this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").css("height", ((aebHeight / 3) + "px"));
                if (this.model.enableSplitter)
                    this.element.find(".splitresponsive").height(this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 30));
            }
            else {
                var ctrlPanelHeight = this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + 5);
                this.element.find(".outerTable, .controlPanelTD").css("height", ctrlPanelHeight + "px");
                    if (this.model.enableVirtualScrolling) {
                      this.element.find(".controlPanel").height(ctrlPanelHeight - 15);
                    if(this.model.displaySettings.mode!=ej.PivotClient.DisplayMode.ChartOnly)
                      this._pivotGrid._applyVScrolling();
                }
                else if (this.model.enablePaging) {
                    if (this.model.displaySettings.controlPlacement == ej.PivotClient.ControlPlacement.Tab)//||this.model.displaySettings.mode==ej.pivotClient.DisplayMode.GridOnly
                        this.element.find(".controlPanel").height(ctrlPanelHeight - this.element.find("#" + this._id + "_Pager").height());
                    else
                        this.element.find(".controlPanel").height(ctrlPanelHeight - this.element.find("#" + this._id + "_Pager").height() - 5);
                }
                else
                    this.element.find(".controlPanel").height(ctrlPanelHeight);
                this.element.find("#" + this._id + "_PivotSchemaDesigner").height(ctrlPanelHeight);
                this._pivotSchemaDesigner._reSizeHandler();
                if (this.enableTogglePanel() && this.element.find(".pivotFieldList").length > 0) {
                    this.element.find("div.togglePanel").remove();
                    this.element.find(".controlPanel").width(this.element.width() - ((this.element.width() / 3) + 20));//this.element.find("#" + this._id + "_PivotSchemaDesigner").parents("td:eq(0)").height() - 30
                    $(ej.buildTag("div.togglePanel", ej.buildTag("div.toggleExpandButton e-icon", "", {}).attr("aria-describedby", "toggleexpand")[0].outerHTML + ej.buildTag("div.toggleCollapseButton e-icon", {}, { "display": "none" }).attr("aria-describedby", "togglecollapse")[0].outerHTML)[0].outerHTML).appendTo(this.element.find(".pivotFieldList").parent());
                    this.element.find(".togglePanel").height((this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + 5)) + "px").width(14);
                    this.element.find(".toggleExpandButton,.toggleCollapseButton").css("margin-top", (this.element.find("#" + this._id + "_PivotSchemaDesigner").parents("td:eq(0)").height() - 9) / 2);
                    this.element.find(".togglePanel").children().addClass("toggleButtons");
                    this._unWireEvents();
                    this._wireEvents();
                }
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                    if (this.model.enableVirtualScrolling)
                        this.element.find(".controlPanel").height(this.element.find(".controlPanel").height() - 5);
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid)
                        this.element.find(".gridContainer").height((this.element.find(".controlPanel").height() / 2) - 10);
                    else
                        this.element.find(".gridContainer").height((this.element.find(".controlPanel").height() / 2) - 10);
                }
                else {
                    if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly) {
                        if (this.model.enablePaging)
                            this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() - 10);
                        else
                            this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() - 20);
                    }
                    else {
                        if (this.model.enableVirtualScrolling)
                            this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() - (this.element.find("ul.clientTab").height() + 30));
                        else
                            this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() - (this.element.find("ul.clientTab").height() + 15));
                    }
                }
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid)
                        this.element.find(".chartContainer").height((this.element.find(".controlPanel").height() / 2) - 10);
                    else
                        this.element.find(".chartContainer").height((this.element.find(".controlPanel").height() / 2) - 15);
                }
                else {
                    if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly)
                        this.element.find(".chartContainer").height(this.element.find(".controlPanel").height() - 17);
                    else {
                        var diffHeight = this.element.find(".controlPanel").height() - (this.element.find("ul.clientTab").height() + 20);
                        if (this.model.enableVirtualScrolling)
                            this.element.find(".chartContainer").height(diffHeight - 5);
                        else
                            this.element.find(".chartContainer").height(diffHeight - 2);
                    }
                }
            }
            this._chartHeight = this.model.enableToolBar ? this.element.find(".chartContainer").height() - 68 + "px" : this.element.find(".chartContainer").height() - 3 + "px"  //+ "px";
            this._gridHeight = this.model.enableToolBar ? this.element.find(".gridContainer").height() - 46 + "px" : this.element.find(".gridContainer").height() - 10 + "px"//+ "px";
            if (this.model.enableToolBar) {
                this.element.find("#" + this._id + "_PivotGridToolbar").height(this._gridHeight);
                this.element.find("#" + this._id + "_PivotCharttoolBar").height(this._chartHeight);
            }
        },
        _performToggleAction: function (styles) {
            this.element.find(".controlPanel").width(styles[0].controlPanelWidth);
            if ((this.controlPlacement() != "horizontal") || (this.controlPlacement() == "horizontal" && this.displayMode() == "chartOnly") ||
                this.controlPlacement() == "horizontal" && this.displayMode() == "gridOnly") {
                this.element.find(".e-pivotchart").width(styles[0].chartOuterWidth);
                this.element.find(".e-pivotgrid").width(styles[0].gridOuterWidth);
                this.element.find("#" + this._id + "_PivotChart").css({ "width": "100%" });
                this.element.find("#" + this._id + "_PivotGrid").css({ "width": "98%" });
                if (!ej.isNullOrUndefined(this._pivotChart) || !ej.isNullOrUndefined(this.otreemapObj)) {
                    this.element.find("#" + this._pivotChart._id).ejPivotChart("option", "width", styles[0].chartOuterWidth + "px");
                    this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                    if (!ej.isNullOrUndefined(this.chartObj)) {
                        this.element.find("#" + this.chartObj._id).ejChart("option", { "model": { size: { width: styles[0].chartOuterWidth + "px" } } });
                        this.element.find("#" + this.chartObj._id + "_svg").width(styles[0].chartOuterWidth);
                        this.chartObj.redraw();
                    }
                }
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.PivotGrid.OperationalMode.ClientMode && this._toggleExpand && !ej.isNullOrUndefined(this.chartObj)) {
                    this.element.find("#" + this._id + "_PivotChartContainer").css("width", this.chartObj.model.size.width);
                    this.chartObj.redraw();
                }
                if (this.model.enableToolBar) {
                    this.element.find("#" + this._id + "_PivotCharttoolBar").width(this.element.find(".chartContainer").width());
                    this.element.find("#" + this._id + "_PivotGridToolbar").width(this.element.find(".gridContainer").width()-10);
                    this.element.find(".chartToolBar").width(this.element.find(".chartContainer").width());
                    this.element.find(".toolBar").width(this.element.find(".gridContainer").width());
               }
            }
        },

        _rwdToggleExpand: function () {
            this.element.find(".csHeader, .cubeTable,.e-pivotschemadesigner,.toggleExpandButton").show();
            this.element.find(".toggleCollapseButton").hide();
            this.element.find(".toggleText").hide();
            this._calculateHeight();
            if (this._parentElwidth < 850) {
                this.element.find(".outerTable").css({ "position": "absolute", "float": (this.model.enableRTL ? "right" : "left"), "tableLayout": "auto","z-index":"10000" });
				this.element.find(".pivotFieldList").width("91%");
                this.element.find("table.cubeTable").css({ "width": "71%" });
                this.element.find(".csHeader").css({ "width": "100%" });
                this.element.find("#cubeSelector_wrapper").css({ "width": "100%" });
                this.element.find(".controlPanelTD").css({ "width": (this.element.find(".oClientTbl").width() - this.element.find("table.cubeTable").width()), "float": (this.model.enableRTL ? "left" : "right"), "left": (this.model.enableRTL ?"0px": "15px"), "right": (this.model.enableRTL ?"15px": "0px"), "position": "relative" });
                this.element.find(".controlPanel").css({ "width": this.element.find(".controlPanelTD").width() - 20 });

            }

            if (this._parentElwidth > 850) {
                this.element.find(".controlPanelTD").css({ "width": "56%", "left": "inherit", "float": "left", "margin-left" : "5px" });
                this.element.find("table.cubeTable").css({ "width": "98%" });
                this.element.find(".outerTable,.controlPanelTD").css({ "position": "inherit" });
                if (this._currentTab == "grid")
                    $(".controlPanel").width(($("#" + this._id).width() * 55 / 100) + "px");
                else if (this._currentTab == "chart")
                    $(".controlPanel").width(($("#" + this._id).width() * 55 / 100) + "px");
                else
                    $(".controlPanel").width("100%");

                if (window.navigator.userAgent.indexOf('Trident') > 0) {
                    this.element.find(".outerTable").width($("#" + this._id).width() * 43 / 100);// + "px";
                    this.element.find(".csHeader").width(($("#" + this._id).width() * 41 / 100) + "px");
                    this.element.find("#cubeSelector_wrapper").width(($("#" + this._id).width() * 29 / 100 - 60) + "px");
                    if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                        this.element.find(".gridPanel").width(($("#" + this._id).width() * 56 / 100) + "px");
                }
                else {
                    this.element.find(".outerTable").css({ "width": ($("#" + this._id).width() * 42 / 100) + "px", "tableLayout": "auto" });
                    this.element.find(".csHeader").css({ "width": ($("#" + this._id).width() * 42 / 100) + "px"});
                    this.element.find("#cubeSelector_wrapper").css({ "width":($("#" + this._id).width() * 32 / 100 - 60) + "px"});
                    if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                        this.element.find(".gridPanel").css({ "width":($("#" + this._id).width() * 57 / 100) + "px"});
                }

            }
            if (this.displayMode() != "gridonly") {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid") {
                    this.element.find(".gridPanel").width($(".controlPanel").width() - 7)
                    if (!this.model.enableToolBar)
                        $("#" + this._pivotChart._id).width($(".controlPanel").width() - 7);
                    else
                        $("#" + this._pivotChart._id).width($(".controlPanel").width() - 30);
                }
                else {
                     $("#" + this._pivotChart._id).width($(".controlPanel").width()-12);
                }
                this.chartObj = null;
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                    this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                        this.otreemapObj._treeMap.refresh();
                    }
                    else {
                        this.chartObj.redraw();
                    }
                }
            }
            this._overflow();
        },

        _overflow: function () {
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                this.element.find(".ellipse").remove();
                if (this.element.find(".cdbHeader")[0].scrollHeight > this.element.find(".cdbHeader")[0].offsetHeight) {
                    this.element.find(".cdbHeader").attr('title', this.element.find(".cdbHeader").text())
                    this.element.find(".cdbHeader").after("<span class='ellipse' style='margin-top:-" + this.element.find(".cdbHeader").height() * 78 / 100 + "px'>....</span>");
                }
                else
                    this.element.find(".cdbHeader").removeAttr('title')
            }
        },

        _rwdToggleCollapse: function () {
            if (this._parentElwidth < 850) {
                this.element.find(".outerTable").css({ "position": "absolute"});
                this.element.find(".controlPanelTD").css({ "left": (this.model.enableRTL ? "0px" : "35px"), "right": (this.model.enableRTL ? "35px" : "0px"), "position": "relative" });
            }
            if (this._currentTab == "grid") {
                $(".controlPanel").css({ "width": $("#" + this._id).width() * 94 / 100 + "px"});
            }
            else
                $(".controlPanel").css({ "width": "100%"});
            if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                this.element.find(".gridPanel").css({ "width": $("#" + this._id).width() * 94 / 100 + "px"});
            this.element.find(".csHeader, .cubeTable, .e-pivotschemadesigner,.toggleExpandButton").hide();
            this.element.find(".controlPanelTD").css({ "left": (this.model.enableRTL ? "0" : "4%"), "right": (this.model.enableRTL ? "4%" : "0px"),"position": "relative", "width": "95%", "tableLayout": "fixed", "float": "" });
            $("#" + this._id).width("98%");
            this.element.find(".outerTable").css({ "position": "absolute", "width": "0px", "tableLayout": "fixed" });
            this.element.find(".toggleCollapseButton").show();
            this.element.find(".toggleText").show();
            if (this.displayMode() != "gridonly") {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid") {
                    if(this.model.enableToolBar)
                        $("#" + this._pivotChart._id).width($(".controlPanel").width() - 45);
                    else
                    $("#" + this._pivotChart._id).width($(".controlPanel").width() - 17);

                }
                else {
                   // if (!this.model.enableToolBar)
                        $("#" + this._pivotChart._id).width($(".controlPanel").width()-15);
                }
                if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                    this.chartObj = null;
                    this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                    if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                        this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                }
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                            this.otreemapObj._treeMap.refresh();
                    }
                    else {
                            this.chartObj.redraw();
                    }
                }
            }
        },
        _removeFilterTag: function (uniqueName) {
            var sortOrder=[];
            if (uniqueName.indexOf("].") >= 0) {
                var removeElement = uniqueName.split("].").length > 2 ? "levelUniqueName" : "hierarchyUniqueName";
                if (this._excelFilterInfo.length > 0) {
                    var cubeName = this.element.find('.cubeSelector').data("ejDropDownList").model.value,
                        reportName = this.element.find('#reportList').data("ejDropDownList").model.value,
                        levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;
                    this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                        if (item.cubeName == cubeName && item.report == reportName && !(item[removeElement] == uniqueName))
                            return item;
                        else
                            sortOrder = item.sortOrder;
                    });
                }
                return sortOrder;
            }
            else if (uniqueName && this._excelFilterInfo.length > 0 && this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                var    reportName = this.element.find('#reportList').data("ejDropDownList").model.value;
                this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                    if (item.report == reportName && !(item["levelUniqueName"] == uniqueName))
                        return item;
                });
            }
        },
        _groupLabelChange: function (args) {
            this._selectedLevelUniqueName = args.selectedValue;
            var filterInfo = [];
            var sortInfo=[];
            if (this._excelFilterInfo.length > 0) {
                var cubeName = this.element.find('.cubeSelector').data("ejDropDownList").model.value, reportName = this.element.find('#reportList').data("ejDropDownList").model.value, levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;
                filterInfo = $.map(this._excelFilterInfo, function (item, index) {
                    if (item.cubeName == cubeName && item.report == reportName && item.hierarchyUniqueName == hierarchyName && item.levelUniqueName == levelName)
                        return { action: item.action, operator: item.operator, value1: item.value1 ,sortInfo:item.sortOrder};
                });
            }
            var filterElem = this.element.find("#clearAllFilters a").children().clone();
            this.element.find("#clearAllFilters a").text(this._getLocalizedLabels("ClearFilter") + " from \"" + this.element.find(".groupLabelDrop").data("ejDropDownList").model.text + "\"").append(filterElem);
            this.element.find(".filterElementTag .activeFilter,.filterIndicator").remove();
            if ((filterInfo.length > 0 && (ej.isNullOrUndefined(filterInfo[0]["sortInfo"]) || (!ej.isNullOrUndefined(filterInfo[0]["sortInfo"]) &&filterInfo[0]["sortInfo"].length ==0)) || filterInfo.length == 0))
                this.element.find(".e-clrSort").parents("li:eq(0)").css("opacity", "0.5").attr("disable", true);
            else {
                if (filterInfo[0]["sortInfo"].length > 0)
                    this.element.find("#" + filterInfo[0]["sortInfo"] + " span:eq(0)").addClass("selectedSort");
            }
            this.element.find(".e-clrFilter").parents("li:eq(0)").css("opacity", "0.5").attr("disable", true);
            this.element.find("#labelClearFilter").css("opacity", "0.5").attr("disable", true);
            this.element.find("#valueClearFilter").css("opacity", "0.5").attr("disable", true);

            if (filterInfo.length > 0 && !ej.isNullOrUndefined(filterInfo[0]["operator"])) {
                var filterTag = (filterInfo[0].action == "valuefiltering") ? "valueFilterBtn" : "labelFilterBtn";
                //this.element.find(".clientDialog").prepend("<div class='filterIndicator e-icon' style='top:" + (filterTag == "labelFilterBtn" ? "169px" : "199px") + ";margin-left:12px;' />");
                this.element.find("#" + filterTag +" a:eq(0)").append("<span class='filterState e-icon'/>");
                this.element.find(".e-clrFilter").parents("li:eq(0)").removeAttr("style disable");
                this.element.find("#" + filterTag + " #labelClearFilter").removeAttr("style disable");
                this.element.find("#" + filterTag + " #valueClearFilter").removeAttr("style disable");
                if (filterInfo[0]["operator"].replace(/ /g, '') == "BottomCount") {
                    this.element.find("#" + filterTag + " li#" + filterInfo[0]["operator"].replace(/ /g, '').replace("Bottom", "top") + " a").append($(ej.buildTag("span.activeFilter e-icon")[0].outerHTML));
                }
                else
                    this.element.find("#" + filterTag + " li#" + filterInfo[0]["operator"].replace(/ /g, '') + " a").append($(ej.buildTag("span.activeFilter e-icon")[0].outerHTML));
            }
            else {
                if (this._getUnSelectedNodes()!="")
                    this.element.find(".clientDialog").prepend("<div class='filterIndicator e-icon' style='margin-top:120px' />");
            }
        },
        _filterElementClick: function (args) {
            if ($(args.element).hasClass("clearFilter") && $(args.element).css("opacity") == "0.5") //|| $(args.element).parent(".filterElementTag").length > 0
                return args.Cancel;

            this._selectedLevelUniqueName = (this.element.find(".groupLabelDrop").data("ejDropDownList").model.value || this.element.find(".groupLabelDrop").data("ejDropDownList").model.dataSource[0].value);
            var cubeName = this.element.find('.cubeSelector').length>0 ? (this.element.find('.cubeSelector').data("ejDropDownList").model.value): "", reportName = this.element.find('#reportList').data("ejDropDownList").model.value, levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;

            if (!($(args.element).attr("id") == "labelClearFilter" || ($(args.element).attr("id") == "valueClearFilter")) && !$(args.element).parent(".filterElementTag").length > 0) {
                var currentAction = $(args.element).parents("li:eq(0)#valueFilterBtn").length>0 ? "valueFilterDlg" : "labelFilterDlg";
                var filterVal = [];
                if (this._excelFilterInfo.length > 0 && $(args.element).siblings("li:eq(0)").attr("disable") != "true") {
                    filterVal = $.map(this._excelFilterInfo, function (item, index) { if (item.cubeName == cubeName && item.report == reportName && item.hierarchyUniqueName == hierarchyName && item.levelUniqueName == levelName) return { value1: item.value1, value2: item.value2, operator: item.operator, measure: item.measure }; });
                    if ((!$(args.element).hasClass(filterVal[0]["operator"].replace(/ /g, ''))) && filterVal.length > 0)
                        filterVal = [];
                }
				if(this._schemaData){
                this._schemaData._selectedLevelUniqueName = this._selectedLevelUniqueName;
                this._schemaData.selectedFieldName = this._selectedFieldName;
				}
                ej.Pivot.createAdvanceFilterTag({ action: currentAction, selectedArgs: args, filterInfo: filterVal }, this);
            }
            else if ($(args.element).attr("id") == "descOrder" || $(args.element).attr("id") == "ascOrder" || $(args.element).find(".e-clrSort").length > 0) {
                var isSorted = false;
                if (this._excelFilterInfo.length > 0) {
                    var cubeName = this.element.find('.cubeSelector').data("ejDropDownList").model.value, reportName = this.element.find('#reportList').data("ejDropDownList").model.value, levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;
                    this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                        if (item.cubeName == cubeName && item.report == reportName && item.hierarchyUniqueName == hierarchyName && item.levelUniqueName == levelName) {
                            isSorted = true;
                            if ($(args.element).find(".e-clrSort").length == 0)
                                item.sortOrder = $(args.element).attr("id");
                            else
                                delete item.sortOrder;
                        }
                        return item;
                    });
                }
                if(!isSorted)
                    this._excelFilterInfo.push({ cubeName: this.element.find('.cubeSelector').length > 0 ? (this.element.find('.cubeSelector').data("ejDropDownList").model.value) : "", report: this.element.find('#reportList').data("ejDropDownList").model.value, hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, sortOrder: $(args.element).attr("id") });

                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filterElement, JSON.stringify({ "action": "labelSorting", "clientParams": this._selectedFieldName + "--" + $(args.element).attr("id"), "olapReport": this.currentReport, "clientReports": this.reports, "customObject": JSON.stringify(this.model.customObject) }), this._filterElementSuccess);
            }
            else {
                var sortOrder=this._removeFilterTag(this._selectedLevelUniqueName);
                this._excelFilterInfo.push({ cubeName: this.element.find('.cubeSelector').length > 0 ? (this.element.find('.cubeSelector').data("ejDropDownList").model.value) : "", report: this.element.find('#reportList').data("ejDropDownList").model.value, hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, sortOrder: sortOrder });
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filterElement, JSON.stringify({ "action": "labelfiltering", "clientParams": this._selectedLevelUniqueName + "--Clear Filter", "olapReport": this.currentReport, "clientReports": this.reports, "customObject": JSON.stringify(this.model.customObject) }), this._filterElementSuccess);
            }
        },
        _filterOptionChanged: function (args) {
            var currentAction = this.element.find("#filterDialog_wrapper .e-titlebar").text().indexOf("Value") >= 0 ? "valueFilterDlg" : "labelFilterDlg";
            if (currentAction == "valueFilterDlg") {
                ej.Pivot.createAdvanceFilterTag({ action: currentAction, selectedArgs: args, filterInfo: [] }, this);
            }
        },
        _filterElementOkBtnClick: function (args) {
            var pivotClientObj = this;
            if (!ej.isNullOrUndefined(this._waitingPopup)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
            }
            var selectedOperator = (this.element.find("#filterOptions").data("ejDropDownList").model.value ||this.element.find("#filterOptions")[0].value),
                filterValue1 = this.element.find("#filterValue1")[0].value,
                filterValue2 = (this.element.find("#filterValue2").length>0? this.element.find("#filterValue2")[0].value :""),
                selectedMeasure, params, levelFilterInfo = [], actionName = "labelfiltering";

            params = this._selectedLevelUniqueName + "--" + selectedOperator + "--" + filterValue1;
            if (this.element.find(".filterMeasures").length > 0) {
                if (this.element.find("#filterValue2").length > 0)
                    params = params + "," + filterValue2;
                selectedMeasure = this.element.find(".filterMeasures").data("ejDropDownList").model.value;
                params = params + "--" + selectedMeasure;
                actionName = "valuefiltering";
            }
            var sortOrder=this._removeFilterTag(this._selectedLevelUniqueName);
            this._excelFilterInfo.push({ cubeName: this.element.find('.cubeSelector').length > 0 ? (this.element.find('.cubeSelector').data("ejDropDownList").model.value) : "", report: this.element.find('#reportList').data("ejDropDownList").model.value, action: actionName, hierarchyUniqueName: this._selectedFieldName, levelUniqueName: this._selectedLevelUniqueName, operator: selectedOperator, measure: selectedMeasure, value1: filterValue1, value2: filterValue2, sortOrder: sortOrder });
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.filterElement, JSON.stringify({ "action": actionName, "clientParams": params, "olapReport": this.currentReport, "clientReports": this.reports, "customObject": JSON.stringify(this.model.customObject) }), this._filterElementSuccess);
        },
        _splitButtonDropped: function (axis, droppedPosition) {
            this.isDropped = true;
            clientObj = this;
            var cssname = axis == "Series" ? "row" : axis.toLowerCase();
            if (($.trim(droppedPosition) == "" && this.element.find("." + cssname + "Axis").find("button:last").attr("title") == this.element.find("button.dragClone").attr("title")) || ($.trim(droppedPosition) != "" && this.element.find($("." + cssname + "Axis").find(".splitBtn")[droppedPosition]).attr("tag").split(":")[1].replace(".", " - ") == this.element.find("button.dragClone").attr("title"))) {
                this.element.find("button.dragClone").remove()
                return false
            }
            if (cssname == "slicer" && this.draggedSplitBtn != null && $(this.draggedSplitBtn).parent("div:eq(0)").attr("Tag").indexOf("Measure") > -1 && this.element.find(".splitBtn[tag*=Measures]").length > 1) {
                this.element.find("button.dragClone").remove()
                ej.Pivot._createErrorDialog(this._getLocalizedLabels("MultipleMeasure"), this._getLocalizedLabels("Warning"), this);
                return false;
            }
            if (($.trim(droppedPosition) == "") || (this.draggedSplitBtn != null && this.element.find($("." + cssname + "Axis").find(".splitBtn")[droppedPosition]).attr("tag").split(":")[1].replace(".", " - ") != this.element.find("button.dragClone").attr("title"))) {
                var params = this.element.find(".cubeName").html() + "--" + $(this.draggedSplitBtn).parent("div:eq(0)").attr("Tag") + "--" + axis + "--" + droppedPosition;
                if (this.model.enableAdvancedFilter && axis == "Slicer") {
                    var btnUniqueName = $(this.draggedSplitBtn).parent("div:eq(0)").attr("Tag").split(":")[1].split(".");
                    this._setUniqueNameFrmBtnTag(btnUniqueName);
                    this._removeFilterTag(this._selectedFieldName);
                }
				this.element.find("button.dragClone").remove();
                this.draggedSplitBtn = null;
                this._isTimeOut = true;
                setTimeout(function () {
                    if (clientObj._isTimeOut)
                        clientObj._waitingPopup.show();
                }, 800);
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeDropped, JSON.stringify({ "action": "nodeDropped", "dropType": "SplitButton", "nodeInfo": params, "olapReport": this.currentReport, "clientReports": this.reports, "customObject": serializedCustomObject }), this._nodeDroppedSuccess);
            }
            this._isNodeOrButtonDropped = true;
         },

        _filterElementSuccess: function (report) {
            this._isSearchApplied = false;
            ej.Pivot.closePreventPanel(this);
            if (report[0] != undefined) {
                this.currentReport = report[0].Value; this.reports = report[1].Value;
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                this.currentReport = report.d[0].Value; this.reports = report.d[1].Value;
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
            }
            else {
                this.currentReport = report.UpdatedReport; this.reports = report.ClientReports;
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "filtering", element: this.element, customObject: this.model.customObject });
            this._renderControls();
            this._unWireEvents();
            this._wireEvents();
            this._successAction = "Filter";
            this._trigger("renderSuccess", this);
        },

        _maxViewBtnClick: function () {
            var winWidth = $(window).width() - 150;
            var winHeight = $(window).height() - 100;
            var docDivTag = ej.buildTag("div.fullScreenView", "", { width: $(document).width(), height: $(document).height() });
            var winDivTag = ej.buildTag("div#" + this._id + "_maxView.maximumView", "", { width: winWidth, height: winHeight });
            var maxViewCls = ej.buildTag("div#Winclose.winCloseBtn e-icon", "").attr("role","button").attr("aria-label","close").attr("clientID", this._id);
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this.chartObj = null;
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                    this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
            }
            if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly && ($("#" + this._pivotChart._id + "Container_svg")[0] || $("#" + this.otreemapObj._id + "TreeMapContainer").children().length > 0)) {
                this._fullScreenView(100, 160);
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                        $("#" + this.otreemapObj._id).css({ width: "99%" });
                        $("#" + this.otreemapObj._id + "TreeMapContainer").css({ width: "100%" });
                    }
                }
                winDivTag.append(this.element.find("#" + this._id + "_PivotChart"));
            }
            if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly)
                winDivTag.append(this.element.find("#" + this._id + "_PivotGrid").css({ "max-height": winHeight, "width": winWidth, "overflow": "auto" }));
            if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tab && this.displayMode() == "chartandgrid") {
                if (this._currentTab == "grid")
                    winDivTag.append(this.element.find("#" + this._id + "_PivotGrid").css({ "max-height": winHeight, "width": winWidth }));
                else if (this._currentTab == "chart" && ($("#" + this._pivotChart._id + "Container_svg")[0] || $("#" + this.otreemapObj._id + "TreeMapContainer").children().length > 0)) {
                    this._fullScreenView(100, 160);
                    if (!ej.isNullOrUndefined(this.chartObj)) {
                        if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                            $("#" + this.otreemapObj._id).css({ width: "99%" });
                            $("#" + this.otreemapObj._id + "TreeMapContainer").css({ width: "100%" });
                        }
                    }
                    winDivTag.append(this.element.find("#" + this._id + "_PivotChart"));
                }
            }
            else if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid") {
                var hght = ($(window).height() / 2) - 50;
                this.element.find("#" + this._id + "_PivotGrid").css({ "max-height": hght, "margin-left": "0px", "overflow": "auto" });
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                        $("#" + this.otreemapObj._id).css({ width: "99%" });
                        $("#" + this.otreemapObj._id + "TreeMapContainer").css({ width: "100%" });
                    }
                }
                this._fullScreenView(50, 160);
                if (($("#" + this._pivotChart._id + "Container_svg")[0] || $("#" + this.otreemapObj._id + "TreeMapContainer").children().length > 0))
                    if (this.defaultView() == "chart")
                        winDivTag.append(this.element.find("#" + this._id + "_PivotChart")).append(this.element.find("#" + this._id + "_PivotGrid").width(($(window).width() - 160)));
                    else
                        winDivTag.append(this.element.find("#" + this._id + "_PivotGrid").width($(window).width() - 160)).append(this.element.find("#" + this._id + "_PivotChart"));
                winDivTag.append(this.element.find("#" + this._id + "_PivotGrid").width($(window).width() - 160));
            }
            winDivTag.append(maxViewCls);
            docDivTag.append(winDivTag);
            $("body").append(docDivTag);
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if (this.model.enablePivotTreeMap && (this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                        this.otreemapObj._treeMap.refresh();
                    }
                    else {
                            this.chartObj.redraw();
                    }
                }
            }
        },

        _maxViewClsBtnClick: function () {
            var fullScreen = $(".fullScreenView");
            fullScreen.find("#" + this._id + "_PivotGrid").css("margin-left", "7px");
            fullScreen.find("#" + this._id + "_PivotChart").appendTo(this.element.find(".chartContainer"));
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this.chartObj = null;
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                    this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
            }
            if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly && ($("#" + this._pivotChart._id + "Container_svg")[0]))
                this._fullScreenViewCls(560, 557);
            if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly)
                fullScreen.find("#" + this._id + "_PivotGrid").css({ "width": "inherit", "max-height": '', "overflow": "hidden" });
            if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tab && this.displayMode() == "chartandgrid") {
                if (this._currentTab == "chart" && $("#" + this._pivotChart._id + "Container_svg")[0])
                    this._fullScreenViewCls(533, 553);
                else
                    fullScreen.find("#" + this._id + "_PivotGrid").css({ "max-height": "550px", "width": "555px" });
            }
            if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                if ($("#" + this._pivotChart._id + "Container_svg")[0]) {
                    this._fullScreenViewCls(275, 555);
                    fullScreen.find("#" + this._id + "_PivotGrid").css({ "max-height": "300px", "width": "555px", "overflow": "hidden" });
                } else
                    fullScreen.find("#" + this._id + "_PivotGrid").css({ "max-height": "275px", "width": "555px" });
            if (this.enableTogglePanel() && (this.element.find(".cubeTable").is(':visible')) == false)
                fullScreen.find("#" + this._id + "_PivotGrid").css("width", "950px");
            fullScreen.find("#" + this._id + "_PivotGrid").appendTo(this.element.find(".gridContainer"));
            $(".maximumView").remove();
            $(".fullScreenView").remove();
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if (this.model.enablePivotTreeMap && (this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap")
                        this.otreemapObj._treeMap.refresh();
                    else {
                        this.chartObj.redraw();
                    }
                }
            }
        },

        _enableResponsive: function () {

            this.element.find(".outerPanel").css({ "width": "100%" });
            $(".e-pivotclient").css({ "width":"100%"});
            this.element.find(".outerTable").css({ "float": this.model.enableRTL?"right":"left" });
            this.element.find(".cdbHeader, .cubeBrowser").addClass("responsive");
            this.element.find(".rowAxis, .slicerAxis, .categoricalAxis").width("99%");
            this.element.find(".controlPanelTD").width("56%");
            if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                this.element.find(".controlPanelTD").css("display", "inline-block");
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode)
                this.element.find(".cubeTable,.e-pivotschemadesigner").width("100%");                           
            else
                this.element.find(".cubeTable").width("98%");
            if (window.navigator.userAgent.indexOf('Trident') > 0) {
                if (this._currentTab == "grid")
                    $(".controlPanel").css({ "width":$("#" + this._id).width() * 55 / 100 + "px"});
                else
                    $(".controlPanel").css({ "width":"99%"});
                this.element.find(".outerTable").width($("#" + this._id).width() * 39 / 100);
                this.element.find(".csHeader").width($("#" + this._id).width() * 38 / 100);
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                    this.element.find(".gridPanel").width($("#" + this._id).width() * 55 / 100 );
            }
            else {
                this.element.find(".outerTable").width($("#" + this._id).width() * 38 / 100);
                this.element.find(".csHeader").width($("#" + this._id).width() * 38 / 100);
            }
        },

        _fullScreenView: function (height, width) {
            if (this._pivotChart != null && this._pivotChart != undefined && ($("#" + this._pivotChart._id + "Container_svg")[0])) {
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                var chartWidth = this.chartObj.model.size.width = this._pivotChart.model.size.width = $(window).width() - width + "px";
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == "chartandgrid")
                    var chartHeight = this._pivotChart.model.size.height = this.chartObj.model.size.height = ($(window).height() / 2) - height + "px";
                else
                    var chartHeight = this._pivotChart.model.size.height = this.chartObj.model.size.height = $(window).height() - height + "px";
                this.element.find("#" + this._id + "_PivotChart").css({ "min-height": chartHeight, "width": chartWidth });
                this.element.find("#" + this._id + "_PivotChartContainer").css({ "width": chartWidth, "height":chartHeight });
                this.chartObj.redraw();
            }
        },

        _fullScreenViewCls: function (height, width) {
            if (this._pivotChart != null && this._pivotChart != undefined) {
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                var chartHeight = this.chartObj.model.size.height = this._pivotChart.model.size.height = height + "px";
                if (this.enableTogglePanel() && (this.element.find(".cubeTable").is(':visible')) == false)
                    var chartWidth = this.chartObj.model.size.width = this._pivotChart.model.size.width = "950px";
                else
                    var chartWidth = this.chartObj.model.size.width = this._pivotChart.model.size.width = width + "px";
                this.element.find("#" + this._id + "_PivotChart").css({ "min-height": chartHeight, "width": chartWidth });
                this.element.find("#" + this._pivotChart._id + "Container").width(chartWidth);
                this.chartObj.redraw();
            }
        },
        _calcMemberDroppedSuccess: function (data) {
            if (data[0] != undefined) {
                for (var i = 0; i < data.length; i++)
                {
                    if (data[i].Key == "calcMemberTreeData") {
                        this._calcMembers=JSON.parse(data[i].Value);
                        data.splice(i, 1);
                        break;
                    }
                }
            }
            else if (data.d != undefined) {
                for (var i = 0; i < data.d.length; i++) {
                    if (data.d[i].Key == "calcMemberTreeData") {
                        this._calcMembers = JSON.parse(data.d[i].Value);
                        data.d.splice(i, 1);
                        break;
                    }
                }
            }
            else {
                this._calcMembers = JSON.parse(data.calcMemberTreeData);
                delete data.calcMemberTreeData;
            }
            this._calcMemberTreeViewUpdate();
            this._nodeDroppedSuccess(data);
        },

        _nodeDroppedSuccess: function (data) {
            var columnElements, rowElements, slicerElements;
            if (data[0] != undefined) {
                columnElements = data[0].Value; rowElements = data[1].Value; slicerElements = data[2].Value;
                this.currentReport = data[3].Value; this.reports = data[4].Value;
                if (data[5] != null && data[5] != undefined)
                    this.model.customObject = data[5].Value;
            }
            else if (data.d != undefined) {
                columnElements = data.d[0].Value; rowElements = data.d[1].Value; slicerElements = data.d[2].Value;
                this.currentReport = data.d[3].Value; this.reports = data.d[4].Value;
                if (data.d[5] != null && data.d[5] != undefined)
                    this.model.customObject = data.d[5].Value;
            }
            else {
                columnElements = data.Columns; rowElements = data.Rows; slicerElements = data.Slicers;
                this.currentReport = data.UpdatedReport; this.reports = data.ClientReports;
                if (data.customObject != null && data.customObject != undefined)
                    this.model.customObject = data.customObject;
            }
            if (this._isRemoved) {
                this._isRemoved = false;
                tempArray = [];

                if (columnElements.length > 0)
                    tempArray.push(columnElements);
                if (rowElements.length > 0)
                    tempArray.push(rowElements);
                if (slicerElements.length > 0)
                    tempArray.push(slicerElements);

                if (tempArray.length > 0) {
                    for (var j = 0; j < tempArray.length; j++) {
                        var filterName;
                        var target = tempArray[j]
                        if (!ej.isNullOrUndefined(target)) {
                            for (var i = 0; i < target.split("#").length; i++) {
                                if (target.split("#")[i] == "" || target.split("#")[i] == "Measures")
                                    filterName = null;
                                else
                                    filterName = target.split("#")[i].split(".").length > 0 ? target.split("#")[i].replace(".", " - ") : target.split("#")[i];
                                if (!ej.isNullOrUndefined(filterName)) {
                                    if (this._currentReportItems.length != 0) {
                                        if (this._treeViewData.hasOwnProperty(filterName)) {
                                            delete this._treeViewData[filterName];
                                            this._currentReportItems.splice($.inArray(filterName, this._currentReportItems), 1);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").find(".splitBtn, .e-btn").remove();
            $(this._createSplitButtons(columnElements, "Columns")).appendTo(".categoricalAxis");
            $(this._createSplitButtons(rowElements, "Rows")).appendTo(".rowAxis");
            $(this._createSplitButtons(slicerElements, "Slicers")).appendTo(".slicerAxis");
            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").find("button").ejButton({ height: "20px", type: ej.ButtonType.Button });
            if (this.model.showUniqueNameOnPivotButton) {
                $(".pvtBtn").addClass("splitBtnUnique");
                $(".removeSplitBtn").addClass("removeBtnUnqiue");
            }
            this._setSplitBtnTitle();
            this._renderControls();
            this._unWireEvents();
            this._wireEvents();
            this._successAction = "NodeDrop";
            this._trigger("renderSuccess", this);
            this._buttonContextMenu();
        },
        _buttonContextMenu : function(){
            var context = ej.buildTag("ul.pivotTree#pivotTree", ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToColumn"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToRow"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToSlicer"))[0].outerHTML)[0].outerHTML)[0].outerHTML;
            this.element.append(context);
            $("#pivotTree").ejMenu({
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                contextMenuTarget: this.element.find(".e-button"),
                click: ej.proxy(this._contextClick, this),
                beforeOpen: ej.proxy(this._contextOpen, this),
                close: ej.proxy(ej.Pivot.closePreventPanel, this)
            });
        },
        _editorTreeInfoSuccess: function (editorTree) {
            
            if (editorTree[0] != undefined) {
                if (editorTree[2] != null && editorTree[2] != undefined)
                    this.model.customObject = editorTree[2].Value;
            }
            else if (editorTree.d != undefined) {
                if (editorTree.d[2] != null && editorTree.d[2] != undefined)
                    this.model.customObject = editorTree.d[2].Value;
            }
            else {
                if (editorTree.customObject != null && editorTree.customObject != undefined)
                    this.model.customObject = editorTree.customObject;
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "fetchMemberTreeNodes", element: this.element, customObject: this.model.customObject });
            this._createDialog(args_className, args_innerHTML, editorTree);
            this._isTimeOut = false;
            this._waitingPopup.hide();
            this._successAction = "EditorTreeInfo";
            this._trigger("renderSuccess", this);
            if (this.element.find(".e-dialog .e-text:visible").first().length > 0) {
                this._curFocus.editor = this.element.find(".e-dialog .e-text:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
            }
            else if (this.element.find(".e-dialog .measureEditor:visible").first().length > 0) {
                this._curFocus.editor = this.element.find(".e-dialog .measureEditor:visible").first().attr("tabindex", "-1").focus().addClass("hoverCell");
            }
        },

        _generateAllMember: function (customArgs, args) {
            this.olapCtrlObj._allMember = $($(args).find("Axis:eq(0) Tuple:eq(0)").children().children()[1]).text();
        },

        generateJSON: function (data) {
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this._pivotChart.model.analysisMode = this.model.analysisMode;
                this._pivotChart.model.operationalMode = this.model.operationalMode;
                this._pivotChart.model.dataSource = this.model.dataSource;
                this._pivotChart.setPivotEngine(data.tranposeEngine);
                this._pivotChart._drillAction = "";
                if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly && this._pivotGrid._drillAction != "") {
                    this._setChartDrillMembers(data.tranposeEngine, this._pivotGrid._drillAction);
                    this._drillInfo = [];
                }
                else 
                    this._pivotChart.generateJSON(this, data.tranposeEngine);                
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    this._pivotChart._drilledCellSet = (this._drilledCellSet.length > 0) ? this._drilledCellSet : [];
                    this._pivotChart.XMLACellSet = (this.XMLACellSet.length > 0) ? this.XMLACellSet : [];
                }
                this._pivotChart._drillAction = "";
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                this._pivotGrid.model.analysisMode = this.model.analysisMode;
                this._pivotGrid.model.operationalMode = this.model.operationalMode;
                this._pivotGrid.model.dataSource = this.model.dataSource;
                this._pivotGrid.setJSONRecords(JSON.stringify(data.jsonObj));
                this._pivotGrid.model.collapsedMembers = null;
                if (this.model.gridLayout == "excellikelayout")
                    this._pivotGrid.excelLikeLayout(data.jsonObj);
                else
                    this._pivotGrid.renderControlFromJSON();
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                    this._pivotGrid._drilledCellSet = (this._drilledCellSet.length > 0) ? this._drilledCellSet : [];
                    this._pivotGrid.XMLACellSet = (this.XMLACellSet.length > 0) ? this.XMLACellSet : [];
                }
                this._pivotGrid._drillAction = "";
            }
            if (this._pivotSchemaDesigner)
                this._pivotSchemaDesigner._refreshPivotButtons();
            if (this.model.showUniqueNameOnPivotButton) {
                $(".pivotButton").addClass("pvtBtnUnique");
                $(".pvtBtn").addClass("schemaBtnUnique");
                $(".removeClientPivotBtn").addClass("schemaRemoveBtnUnqiue");
            }
            if (this.model.isResponsive && this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (!ej.isNullOrUndefined(this.chartObj))
                    this.element.find("#" + this.chartObj._id).ejChart("option", { "model": { size: { height: this._chartHeight } } });
            }
        },

        _renderLayout: function () {
            if (this.model.isResponsive || this.model.collapseCubeBrowserByDefault) this.model.displaySettings.enableTogglePanel = true;
            var reportToolBar = ej.buildTag("div.reportToolbar#reportToolbar", this._reportToolbar(), { width: "410px", height: "29px" })[0].outerHTML;
            var browserPanel, htmlTag;
            if (this.model.enableSplitter) {
                if (!this.model.isResponsive) {
                    if (this.model.enableRTL && !this.model.enableVirtualScrolling) {
                        browserPanel = ej.buildTag("div#" + this._id + "_PivotSchemaDesigner.pivotFieldList", "", {}).attr("class", "childsplit")[0].outerHTML;
                        htmlTag = ej.buildTag("span.outerPanel", "", {  }).append("<div class=\"titleText\"><span style='padding-left:10px'>" + this.model.title + "</span></div>" + reportToolBar + "<table class=\"outerTable\" style='width:100%'><tr class='parentsplit' style='width:100%'><td class=\"controlPanelTD\" style='width:50%'>" + this._controlPanel() + "</td><td style='width:50%'>" + browserPanel + "</td></tr></table>");
                    }
                    else if (this.model.enableVirtualScrolling || (this.model.enableRTL && this.model.enableVirtualScrolling)) {
                        browserPanel = ej.buildTag("div#" + this._id + "_PivotSchemaDesigner.pivotFieldList", "", {}).attr("class", "childsplit")[0].outerHTML;
                        htmlTag = ej.buildTag("span.outerPanel", "", {}).append("<div class=\"titleText\"><span style='padding-left:10px'>" + this.model.title + "</span></div>" + reportToolBar + "<table class=\"outerTable\" style='width:100%'><tr style='width:98%'><td style='width:49%'>" + browserPanel + "</td><td class=\"controlPanelTD\" style='width:49%'>" + this._controlPanel() + "</td>" + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : "") + "</tr></table>");
                    }
                    else {
                        browserPanel = ej.buildTag("div#" + this._id + "_PivotSchemaDesigner.pivotFieldList", "", {}).attr("class", "childsplit")[0].outerHTML;
                        htmlTag = ej.buildTag("span.outerPanel", "", { }).append("<div class=\"titleText\"><span style='padding-left:10px'>" + this.model.title + "</span></div>" + reportToolBar + "<table class=\"outerTable\" style='width:100%'><tr class='parentsplit' style='width:100%'><td style='width:50%'>" + browserPanel + "</td><td class=\"controlPanelTD\" style='width:50%'>" + this._controlPanel() + "</td></tr></table>");
                    }
                }
                else if (this.model.isResponsive) {
                    browserPanel = ej.buildTag("div#" + this._id + "_PivotSchemaDesigner.pivotFieldList", "", { }).addClass("splitresponsive")[0].outerHTML;
                    htmlTag = ej.buildTag("span.outerPanel", "").append(ej.buildTag("div.titleText", ej.buildTag("span", this.title(), { "padding-left": "10px" })[0].outerHTML)[0].outerHTML + reportToolBar + ej.buildTag("table.oClientTbl", ej.buildTag("tr", ej.buildTag("td", ej.buildTag("table.outerTable", ej.buildTag("tr", ej.buildTag("td", browserPanel).attr("width", "100%")[0].outerHTML).attr("width", "100%")[0].outerHTML)[0].outerHTML + ej.buildTag("table.controlPanelTD", ej.buildTag("tr", ej.buildTag("td", this._controlPanel())[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML, { width: "100%" })[0].outerHTML);
                }
            }
            else
            {
                if (!this.model.isResponsive) {
                    browserPanel = ej.buildTag("div#" + this._id + "_PivotSchemaDesigner.pivotFieldList", "", {})[0].outerHTML;
                    htmlTag = ej.buildTag("span.outerPanel", "", { }).append(($.trim(this.model.title) != "" ? ("<div class=\"titleText\"><span style='padding-left:10px'>" + this.model.title + "</span></div>") : "") + reportToolBar + "<table class=\"outerTable\" style='display:block'><tr><td>" + browserPanel + "</td><td class=\"controlPanelTD\"style='display:block'>" + this._controlPanel() + "</td>" + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : "") + "</tr></table>");
                }
                else if (this.model.isResponsive) {
                    browserPanel =  ej.buildTag("div#" + this._id + "_PivotSchemaDesigner.pivotFieldList", "", { })[0].outerHTML //: this._createCubeSelector() + ej.buildTag("table.cubeTable", ej.buildTag("tbody", ej.buildTag("tr", ej.buildTag("td.cubeTableTD", this._createCubeBrowser(cubeTreeInfo)).attr({ valign: "bottom", width: "50%" })[0].outerHTML + ej.buildTag("td.cubeTableTD", this._createAxisElementBuilder(columnElements, rowElements, slicerElements)).attr({ valign: "bottom", width: "50%" })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
                    htmlTag = ej.buildTag("span.outerPanel", "").append(($.trim(this.model.title) != "" ? (ej.buildTag("div.titleText", ej.buildTag("span", this.title(), { "padding-left": "10px" })[0].outerHTML)[0].outerHTML) : "") + reportToolBar + ej.buildTag("table.oClientTbl", ej.buildTag("tr", ej.buildTag("td", ej.buildTag("table.outerTable", ej.buildTag("tr", ej.buildTag("td", browserPanel)[0].outerHTML)[0].outerHTML)[0].outerHTML + ej.buildTag("table.controlPanelTD", ej.buildTag("tr", ej.buildTag("td", this._controlPanel())[0].outerHTML + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : ""))[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML, { width: "100%" })[0].outerHTML);
                }           
            }
            this.element.html(htmlTag);
            this.element.find(".reportToolbar").ejToolbar({ enableRTL: this.model.enableRTL, height: "35px" });
            this._calculateSize();
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            if ((this.enableTogglePanel()&& !this.model.enableSplitter)||this.model.isResponsive) {
                this.element.find(".controlPanel").width(this.element.width() - ((this.element.width() / 3) + 20));
                $(ej.buildTag("div.togglePanel", ej.buildTag("div.toggleExpandButton e-icon", "", {}).attr("aria-describedby", "toggleexpand")[0].outerHTML + ej.buildTag("div.toggleCollapseButton e-icon", {}, { "display": "none" }).attr("aria-describedby", "togglecollapse")[0].outerHTML)[0].outerHTML).appendTo(this.element.find(".pivotFieldList").parent());
            }
            if ((this.controlPlacement() == ej.PivotClient.ControlPlacement.Tab && this.defaultView() == ej.PivotClient.DefaultView.Grid) || (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly))
                this.element.find(".chartTypesImg").addClass("chartTypesOnGridView");
            this.element.find(".controlPanel").css("right", 3);
            var reportDropDown = "<div class ='reportList' ><input type='text' id='reportList' class='reportlist' title='" + this._getLocalizedLabels("ReportList") + "'/></div>";
            $(this.element).find(".reportCol").append(reportDropDown);
        },
        _calculateSize: function () {
            $(this.element).height(this.model.size.height).width(this.model.size.width);
            $(this.element).height($(this.element).height() < 500 ? 500 : $(this.element).height());
            $(this.element).width($(this.element).width() < 600 ? 600 : $(this.element).width());
            var ctrlPanelHeight = this.element.height() - ((this.element.find("div.titleText").length > 0 ? 50 : 0) + this.element.find("#reportToolbar").height() + 5);
             if (!(this.model.analysisMode==ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode)) {
                if (!this.model.isResponsive && !this.model.enableSplitter) {
                  this.element.find(".outerTable").width(this.element.width());
                  this.element.find(".controlPanel").width(this.element.width() * (2 / 3));
                    if (this.enableTogglePanel() && this.element.find(".pivotFieldList").length > 0)
                     this.element.find(".controlPanel").width(this.element.width() - ((this.element.width() / 3) + 20));
                }
            this.element.find(".controlPanelTD, .outerTable").height(ctrlPanelHeight);
            if(this.model.enableVirtualScrolling)
                this.element.find(".controlPanel").height(ctrlPanelHeight -20);
            else
                this.element.find(".controlPanel").height(ctrlPanelHeight);
            }
            else {
                var aebHeight,axisHeaderHeight;
                if (!this.model.isResponsive && !this.model.enableSplitter) {
                    var cdbWidth = this.element.width() / 2.5;
                    this.element.find(".csHeader").width(cdbWidth+15);
                    this.element.find(".axisBuilderTD").width(cdbWidth / 2);
                    this.element.find(".cdbHeader, .cubeBrowser").width(cdbWidth / 2);
                    this.element.find(".controlPanel").width(this.element.width() - (cdbWidth + 25));
                }
           // this.element.find(".outerTable").height(ctrlPanelHeight-15);
            if (this.model.enableVirtualScrolling) 
                this.element.find(".controlPanel").height(ctrlPanelHeight - 15);
            else if (this.model.enablePaging)
                this.element.find(".controlPanel").height(ctrlPanelHeight - 5);
            else
                this.element.find(".controlPanel").height(ctrlPanelHeight);
            this.element.find(".cubeTable").height((this.element.height() - ((this.element.find("div.titleText").length>0 ?  50:0) + this.element.find("#reportToolbar").height()+ this.element.find(".csHeader").height()+38)));
            if (this.model.isResponsive) {
                this.element.find(".cubeBrowser").height(this.element.find(".cubeTable").height() - (this.element.find(".cdbHeader").height()));
                this.element.find(".cubeTreeView").height(this.element.find(".cubeBrowser").height() - (56 + (this.model.enableMeasureGroups ? 35: 0)));
                aebHeight = this.element.find(".cubeTable").height() - ((this.element.find(".axisHeader").height() * 3) +4);
            }
            else {
                this.element.find(".cdbTD, .cubeTableTD").height(this.element.find(".cubeTable").height());
                this.element.find(".cubeBrowser").height((this.element.find(".cdbTD, .cubeTableTD").height() + 9) - this.element.find(".cdbHeader").height());
                this.element.find(".cubeTreeView").height(this.element.find(".cubeBrowser").height() - (61 + (this.model.enableMeasureGroups ? 30 : 0)));
                aebHeight = this.element.find(".axisBuilderTD").height() - ((this.element.find(".axisHeader").height() * 3) + 3);
            }
            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").height((aebHeight / 3));
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                    if (this.model.enableVirtualScrolling) {
                        this.element.find(".controlPanel").width(this.element.find(".controlPanel").width() - 5);
                     }
                                     
                   if (this.defaultView() == ej.PivotClient.DefaultView.Grid) {
                        if (this.model.enablePaging)
                            this.element.find(".gridContainer").height((this.element.find(".controlPanel").height() / 2)+5 );
                        else
                            this.element.find(".gridContainer").height((this.element.find(".controlPanel").height() / 2) - 10);
                   if (!this.model.isResponsive && !this.model.enableSplitter) 
                       this.element.find(".gridContainer").width(this.element.find(".controlPanel").width() - 15);
                   
                    }
                else {
                   this.element.find(".gridContainer").height((this.element.find(".controlPanel").height() / 2) - 10);
                     if (!this.model.isResponsive && !this.model.enableSplitter)
                       this.element.find(".gridContainer").width(this.element.find(".controlPanel").width() - 20);
                    }
                  }
                else{
                    if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly) {
                        this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() -(this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode? 12: 20));
                     if (!this.model.isResponsive && !this.model.enableSplitter)
                         this.element.find(".gridContainer").width(this.element.find(".controlPanel").width() - 15)
                    }
                    else {
                        if (this.model.enableVirtualScrolling)
                            this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() - (this.element.find("ul.clientTab").height() + 30));
                        else
                            this.element.find(".gridContainer").height(this.element.find(".controlPanel").height() - (this.element.find("ul.clientTab").height() + 15));
                    }
                }
                    
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid) {
                        if (this.model.enablePaging)
                            this.element.find(".chartContainer").height((this.element.find(".controlPanel").height() / 2)+15);
                        else
                            this.element.find(".chartContainer").height((this.element.find(".controlPanel").height() / 2) - 10);
                        if (!this.model.isResponsive && !this.model.enableSplitter)
                            this.element.find(".chartContainer").width(this.element.find(".controlPanel").width() - 15);
                    }
                    else {
                        this.element.find(".chartContainer").height((this.element.find(".controlPanel").height() / 2) - 15);
                        if (!this.model.isResponsive && !this.model.enableSplitter)
                           this.element.find(".chartContainer").width(this.element.find(".controlPanel").width() - 20)
                    }
                 }
                else{
                    if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly) {
                        this.element.find(".chartContainer").height(this.element.find(".controlPanel").height() - 17);
                      if (!this.model.isResponsive && !this.model.enableSplitter)
                            this.element.find(".chartContainer").width(this.element.find(".controlPanel").width() - 20);
                    }
                    else {
                        var diffHeight = this.element.find(".controlPanel").height() - (this.element.find("ul.clientTab").height() + 20);
                        if (this.model.enableVirtualScrolling)
                            this.element.find(".chartContainer").height(diffHeight - 5);
                        else if(this.model.enablePaging)
                            this.element.find(".chartContainer").height(diffHeight);
                        else
                            this.element.find(".chartContainer").height(diffHeight-2);
                    }
                }
                    
            }

            this._chartHeight = this.model.enableToolBar ? (this.model.enablePaging? (this.element.find(".chartContainer").height() - (105)):this.element.find(".chartContainer").height() - 68) + "px" : this.element.find(".chartContainer").height() - 3 + "px";
            this._chartWidth = (this.model.isResponsive||this.model.enableSplitter)?"98%":this.element.find(".chartContainer").width() - 15 + "px";
            this._gridHeight =this.model.enableToolBar? this.element.find(".gridContainer").height() - 46 + "px":this.element.find(".gridContainer").height()-10 + "px";
            this._gridWidth =(this.model.isResponsive||this.model.enableSplitter)?"98%": this.element.find(".gridContainer").width() - 20 + "px";
        },
        _reportToolbar: function () {
            return ej.buildTag("ul", (this.model.toolbarIconSettings.enableNewReport ? ej.buildTag("li.newReportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("NewReport")).attr({ "title": this._getLocalizedLabels("NewReport"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableAddReport ? ej.buildTag("li.addReportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("AddReport")).attr({ "title": this._getLocalizedLabels("AddReport"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableRemoveReport ? ej.buildTag("li.removeReportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("RemoveReport")).attr({ "title": this._getLocalizedLabels("RemoveReport"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableRenameReport ? ej.buildTag("li.renameReportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("RenameReport")).attr({ "title": this._getLocalizedLabels("RenameReport"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableDBManipulation ? ej.buildTag("li.reportDBImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("DBReport")).attr({ "title": this._getLocalizedLabels("DBReport"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableMDXQuery && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap ? ej.buildTag("li.mdxImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("MDXQuery")).attr({ "title": this._getLocalizedLabels("MDXQuery"), tabindex: 0 })[0].outerHTML : "") +
			((this.model.toolbarIconSettings.enableDeferUpdate && this.model.enableDeferUpdate && (this.model.analysisMode != ej.Pivot.AnalysisMode.Pivot) && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) ? (ej.buildTag("li.autoExecuteImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("DeferUpdate")).attr({ "title": this._getLocalizedLabels("DeferUpdate"), tabindex: 0 })[0].outerHTML) : "") +
  			(this.model.toolbarIconSettings.enableCalculatedMember ? ej.buildTag("li.calcMemberImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("CalculatedMember")).attr({ "title": this._getLocalizedLabels("CalculatedMember"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableExcelExport ? ej.buildTag("li.excelExportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ExportToExcel")).attr({ "title": this._getLocalizedLabels("ExportToExcel"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableWordExport ? ej.buildTag("li.wordExportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ExportToWord")).attr({ "title": this._getLocalizedLabels("ExportToWord"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enablePdfExport ? ej.buildTag("li.pdfExportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ExportToPdf")).attr({ "title": this._getLocalizedLabels("ExportToPdf"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableFullScreen && this.model.displaySettings.enableFullScreen ? (ej.buildTag("li.maximizedView e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("FullScreen")).attr({ "title": this._getLocalizedLabels("FullScreen"), tabindex: 0 })[0].outerHTML) : "") +

			((this.model.operationalMode != ej.Pivot.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) ?
			((this.model.toolbarIconSettings.enableSortOrFilterColumn ? ej.buildTag("li.colSortFilterImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("SortOrFilterColumn")).attr({ "title": this._getLocalizedLabels("SortOrFilterColumn"), tabindex: 0 })[0].outerHTML : "") +
			(this.model.toolbarIconSettings.enableSortOrFilterRow ? ej.buildTag("li.rowSortFilterImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("SortOrFilterRow")).attr({ "title": this._getLocalizedLabels("SortOrFilterRow"), tabindex: 0 })[0].outerHTML : "")) : "") +

			(this.model.toolbarIconSettings.enableToggleAxis ? ej.buildTag("li.toggleaxisImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ToggleAxis")).attr({ "title": this._getLocalizedLabels("ToggleAxis"), tabindex: 0 })[0].outerHTML : "") +
            (this.model.toolbarIconSettings.enableChartTypes ? ej.buildTag("li.chartTypesImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("ChartTypes")).attr({ "title": this._getLocalizedLabels("ChartTypes"), tabindex: 0 })[0].outerHTML  :"") +
			ej.buildTag("li.reportCol e-icon", "", {}).attr("aria-label", "report").attr({ "title": this._getLocalizedLabels("ReportList"), tabindex: 0 })[0].outerHTML);
        },

        _clientGridDrillSuccess: function (args) {
            if (this._isChartDrillAction)
                this._isChartDrillAction = false;
            else {
                if (args.axis == "rowheader" && this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                    if (args.drillAction == "drilldown")
                        this._drillParams.push(args.drilledMember);
                    else
                        this._drillParams = $.grep(this._drillParams, function (item) { return item.indexOf(args.drilledMember) < 0; });
                    this._pivotChart._drillParams = this._drillParams;
                    var drillInfo = args.drilledMember.split(">#>");
                    this._pivotChart._labelCurrentTags.expandedMembers = drillInfo;
                    if (args.drillAction == "drillup") {
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                            this._pivotChart._labelCurrentTags.expandedMembers = [];
                            if (this._drillParams.length > 0)
                                this._getDrilledMember(args.drillAction);
                        }
                        else {
                            if (this._pivotChart._labelCurrentTags.expandedMembers.length == 0 && this._drillParams.length > 0)
                                this._getDrilledMember(args.drillAction);
                        }
                    }
                    this._pivotChart._drillAction = args.drillAction;
                    this._pivotChart.refreshControl();
                }
            }
        },

        _getDrilledMember: function (drillAction) {
            var member = this._drillParams[this._drillParams.length - 1];
            var drilledMembers = $.grep(this._drillParams, function (item) { return item.indexOf(member) >= 0 });
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                for (var i = 0; i < drilledMembers.length; i++)
                    if (drilledMembers[i].split(">#>").length > this._pivotChart._labelCurrentTags.expandedMembers.length)
                        this._pivotChart._labelCurrentTags.expandedMembers = drilledMembers[i].split(">#>");
            }
            else {
                var maxLength = drilledMembers[0].split(">#>").length, index = 0;
                for (var i = 1; i < drilledMembers.length; i++) {
                    if (drilledMembers[i].split(">#>").length > maxLength) {
                        index = i;
                        break;
                    }
                }
                this._drillInfo = drilledMembers[index].split(">#>");
                var dimensionIndex = 0;
                this._pivotChart._labelCurrentTags.expandedMembers = new Array();
                for (var i = 0; i < this._drillInfo.length; i++) {
                    if (ej.isNullOrUndefined(this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex])) this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex] = new Array();
                    if (i + 1 < this._drillInfo.length) {
                        if (!ej.isNullOrUndefined(ej.olap._mdxParser._splitCellInfo(this._drillInfo[i])) && !ej.isNullOrUndefined(ej.olap._mdxParser._splitCellInfo(this._drillInfo[i + 1])) &&
                            ej.olap._mdxParser._splitCellInfo(this._drillInfo[i]).hierarchyUniqueName == ej.olap._mdxParser._splitCellInfo(this._drillInfo[i + 1]).hierarchyUniqueName)
                            this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex].push(this._drillInfo[i]);
                        else
                            dimensionIndex++;
                    }
                    else {
                        this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex].push(this._drillInfo[i]);
                        this._isChartDrillAction = true;
                    }
                }
            }
        },
        _clearSorting: function (args) {
            if ($(args.target).parent().attr("disabled") == "disabled")
                return false;
            ej.Pivot.closePreventPanel(this);
            var pivotClientObj = this;
            var dataSource = this.model.dataSource;
            var currElement = this._schemaData._selectedFieldName.toLowerCase();
            var reportItem = $.map(dataSource.columns, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currElement)) return obj; });
            if (reportItem.length == 0) {
                reportItem = $.map(dataSource.rows, function (obj, index) { if (obj.fieldName != undefined && (obj.fieldName.toLowerCase() == currElement)) return obj; });
            }
            if (reportItem.length > 0) {
                delete reportItem[0]["sortOrder"];
            }
            this.model.dataSource = dataSource;
            this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog)").remove();
            if (this._schemaData != null) {
                this._schemaData.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog)").remove();
            }
            pivotClientObj._isTimeOut = true;
            setTimeout(function () {
                if (pivotClientObj._isTimeOut)
                    pivotClientObj._waitingPopup.show();
            }, 800);
            if(this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                this.refreshControl();
            else
            ej.olap.base.getJSONData({ action: "clearSorting" }, this.model.dataSource, this);
        },

        _clientChartDrillSuccess: function (args) {
            var drillInfo = new Array();
            if (args.drilledMember != "") {
                drillInfo = args.drilledMember.split(">#>");
                this._isChartDrillAction = true;
            };
            var minRowIndex = 0, maxRowIndex = this._pivotGrid._rowCount;
            for (var i = 0; i < drillInfo.length; i++) {
                var rowheaders = (i == drillInfo.length - 1 && args.drillAction == "drilldown") ? this.element.find(".e-pivotgrid .pivotGridTable th.summary[p^='" + i + "']") : this.element.find(".e-pivotgrid .pivotGridTable th.rowheader[p^='" + i + "']");
                var targetCell = $.grep(rowheaders, function (headerCell) { return $(headerCell).clone().children().remove().end().text() == drillInfo[i]; });
                targetCell = $.grep(targetCell, function (headerCell) { return parseInt($(headerCell).attr('p').split(',')[1]) >= minRowIndex && parseInt($(headerCell).attr('p').split(',')[1]) <= maxRowIndex });
                if (i == drillInfo.length - 1)
                    $(targetCell).find("." + (args.drillAction == "drilldown" ? "expand" : "collapse")).trigger("click");
                else {
                    minRowIndex = parseInt($(targetCell).attr('p').split(',')[1]);
                    maxRowIndex = minRowIndex + parseInt($(targetCell).find("span").attr("tag")) + targetCell[0].rowSpan;
                }
            }
        },

        setChartDrillParams: function (drillMemberInfo, drillAction) {
            if (drillAction == "drilldown")
                this._drillParams.push(drillMemberInfo);
            else
                this._drillParams = $.grep(this._drillParams, function (item) { return item.indexOf(drillMemberInfo) < 0; });
            this._drillInfo = drillMemberInfo.split(">#>");
            var dimensionIndex = 0;
            this._pivotChart._labelCurrentTags.expandedMembers = new Array();
            var currIndex = this._drillInfo.length - 1;
            var hasSameParent = drillAction == "drillup" && this._drillParams.length > 0 && this._drillParams[this._drillParams.length - 1] != this._drillInfo.join(">#>") && this._drillParams[this._drillParams.length - 1].split(">#>").filter(function (index, item) { return index < currIndex }).join(">#>") == this._drillInfo.filter(function (index, item) { return index < currIndex }).join(">#>");
            var drillInfo = hasSameParent ? this._drillParams[this._drillParams.length - 1].split(">#>") : this._drillInfo;

            for (var i = 0; i < drillInfo.length; i++) {
                if (ej.isNullOrUndefined(this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex])) this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex] = new Array();
                if (i + 1 < drillInfo.length || hasSameParent) {
                    if (!ej.isNullOrUndefined(ej.olap._mdxParser._splitCellInfo(drillInfo[i])) && !ej.isNullOrUndefined(ej.olap._mdxParser._splitCellInfo(drillInfo[i + 1])) ?
                            ej.olap._mdxParser._splitCellInfo(drillInfo[i]).hierarchyUniqueName == ej.olap._mdxParser._splitCellInfo(drillInfo[i + 1]).hierarchyUniqueName : (i == drillInfo.length - 1 ? true : false))
                        this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex].push(drillInfo[i]);
                    else
                        dimensionIndex++;
                }
                else if (drillAction == "drilldown") {
                    this._pivotChart._labelCurrentTags.expandedMembers[dimensionIndex].push(drillInfo[i]);
                    this._isChartDrillAction = true;
                }
            }
            var drilledDimension = $.grep(this._pivotChart._labelCurrentTags.expandedMembers, function (expandedMembers) { return expandedMembers.length > 0 });
            if (drilledDimension.length == 0 && this._drillParams.length > 0) {
                this._getDrilledMember(drillAction);
                this._pivotGrid._drillAction = "drilldown";
            }
        },

        _setChartDrillMembers: function (pivotEngine) {
            if (this._drillInfo.length > 0 && !this._pivotChart.model.enableMultiLevelLabels) {
                var levelUniqueNames = new Array();
                var drillInfo = new Array();
                var rowItemIndex = 0;
                var exceedIndex = 0;
                var clonedEngine = this._pivotChart._cloneEngine(pivotEngine);

                var isDrilled = false;
                for (var i = 0; i < this._pivotChart._labelCurrentTags.expandedMembers.length; i++)
                    for (var j = 0; j < this._pivotChart._labelCurrentTags.expandedMembers[i].length; j++)
                        isDrilled = true;
                if (isDrilled) {
                    var drilledDimensionIndex;
                    var drilledMember = this._drillInfo[this._drillInfo.length - 1];
                    for (var i = 0; i < this.model.dataSource.rows.length; i++) {
                        var drilledHierarchy = ej.olap._mdxParser._splitCellInfo(drilledMember).hierarchyUniqueName;
                        if (this.model.dataSource.rows[i].fieldName == drilledHierarchy)
                            drilledDimensionIndex = i;
                    }
                    var measureInRows = this.model.dataSource.values[0].axis == "rows" ? 1 : 0, currIndex = this._drillInfo.length - 1;
                    var hasSameParent = this._pivotGrid._drillAction == "drillup" && this._drillParams.length > 0 && this._drillParams[this._drillParams.length - 1].split(">#>").filter(function (index, item) { return index < currIndex }).join(">#>") == this._drillInfo.filter(function (index, item) { return index < currIndex }).join(">#>");
                    if (!hasSameParent) {
                        if (clonedEngine[0 + exceedIndex][0].ColSpan > (this._drillInfo.length + this._pivotGrid._drillAction == "drilldown" ? 1 : 0))
                            for (var i = (this._drillInfo.length + (this._pivotGrid._drillAction == "drilldown" ? 1 : 0) + (this.model.dataSource.rows.length - (drilledDimensionIndex + 1))) ; (i + measureInRows) < clonedEngine[0 + exceedIndex][0].ColSpan; i++) {
                                clonedEngine.splice(i, 1);
                                clonedEngine[0][0].ColSpan--;
                            }

                        for (var i = 0; i < this._drillInfo.length - (this._pivotGrid._drillAction == "drillup" ? 1 : 0) ; i++) {
                            if (!ej.isNullOrUndefined(ej.olap._mdxParser._splitCellInfo(this._drillInfo[i])) && ej.olap._mdxParser._splitCellInfo(this._drillInfo[i]).hierarchyUniqueName != "") {
                                var drillCaption = ej.olap._mdxParser._splitCellInfo(this._drillInfo[i]).leveName;
                                this._pivotChart._cropData(clonedEngine, drillCaption, i + exceedIndex, false);
                            }
                        }
                    }
                    else {
                        for (var i = 0; i < this._drillParams[this._drillParams.length - 1].split(">#>").length ; i++) {
                            if (!ej.isNullOrUndefined(ej.olap._mdxParser._splitCellInfo(this._drillParams[this._drillParams.length - 1].split(">#>")[i])) && ej.olap._mdxParser._splitCellInfo(this._drillParams[this._drillParams.length - 1].split(">#>")[i]).hierarchyUniqueName != "") {
                                var drillCaption = ej.olap._mdxParser._splitCellInfo(this._drillParams[this._drillParams.length - 1].split(">#>")[i]).leveName;
                                this._pivotChart._cropData(clonedEngine, drillCaption, i + exceedIndex, false);
                            }
                        }
                    }
                    var columnIndex = 0;
                    if (!ej.isNullOrUndefined(this._pivotChart._labelCurrentTags.expandedMembers)) {
                        for (var i = 0; i < this._pivotChart._labelCurrentTags.expandedMembers.length; i++) {
                            if (!ej.isNullOrUndefined(this._pivotChart._labelCurrentTags.expandedMembers[i])) {
                                if (i > drilledDimensionIndex) {
                                    for (var j = 0; j < this._pivotChart._labelCurrentTags.expandedMembers[i].length; j++) {
                                        var selectedMember = this._pivotChart._labelCurrentTags.expandedMembers[i][j].split("::")[2];
                                        this._pivotChart._cropData(clonedEngine, selectedMember, i + exceedIndex, true);
                                        exceedIndex++;
                                    }
                                }
                                else {
                                    for (var j = 0; j < this._pivotChart._labelCurrentTags.expandedMembers[i].length; j++) {
                                        exceedIndex++;
                                    }
                                }
                            }
                        }
                    }
                }
                this._drillInfo = [];
                this._pivotChart._generateData(clonedEngine);
            }
            else
                this._pivotChart.generateJSON(this, pivotEngine);                
        },
        refreshPagedPivotClient: function (axis, pageNo) {
            var report;
            var pivotClientObj = this;
            if (!ej.isNullOrUndefined(this._waitingPopup)) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
            }
            axis = axis.indexOf('categ') != -1 ? "categorical" : "series";
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if (axis == "categorical")
                    this._categCurrentPage = parseInt(pageNo);
                else
                    this._seriesCurrentPage = parseInt(pageNo);
                ej.olap.base.getJSONData({ action: "navPaging" }, this.model.dataSource, this);
            }
            else if (this.currentReport != "") {
                try { report = JSON.parse(this.currentReport); }
                catch (err) { report = this.currentReport; }
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.paging, JSON.stringify({ "action": "paging", "pagingInfo": axis + ":" + pageNo, "currentReport": report, "layout": ej.PivotGrid.Layout.NoSummaries, "customObject": null }), this.refreshPagedPivotClientSuccess);
            }
        },
        refreshPagedPivotClientSuccess: function (msg) {
            var chartData = [];
            if (msg.d != undefined) {
                chartData[0] = msg.d[2]; chartData[1] = msg.d[1];
            }
            else
                chartData = msg;
            if (this.model.displaySettings.mode == ej.PivotClient.DisplayMode.GridOnly) {
                this._pivotGrid._renderControlSuccess(msg);
            } else if (this.model.displaySettings.mode == ej.PivotClient.DisplayMode.ChartOnly)
                this._pivotChart.renderControlSuccess(chartData);
            else if (this.model.displaySettings.mode = ej.PivotClient.DisplayMode.ChartAndGrid) {
                this._pivotGrid._renderControlSuccess(msg);
                this._pivotChart.renderControlSuccess(chartData);
            }
        },

        _hiddenCellInfo: function (report) {
            var colHiddenCells = ($.map(report, function (item) { if (item.Key == "FilteredColumnHeaders") return item.Value; }));
            var rowHiddenCells = ($.map(report, function (item) { if (item.Key == "FilteredRowHeaders") return item.Value; }));
            return { columnArea: (colHiddenCells.length > 0) ? colHiddenCells[0] : colHiddenCells, rowArea: (rowHiddenCells.length>0)? rowHiddenCells[0]:[]  }
        },
        _renderControlSuccess: function (msg) {
            if (this.model.isResponsive || this.model.collapseCubeBrowserByDefault)
                this.model.displaySettings.enableTogglePanel = true;
            var eventArgs = { element: this.element, customObject: this.model.customObject };
            this._trigger("load", eventArgs);
            var cubes = "", columnElements = "", rowElements = "", slicerElements = "", cubeTreeInfo = "";
            if (msg[0] != undefined) {
                //msg.DataModel
                cubes = msg[0].Value; columnElements = msg[1].Value; rowElements = msg[2].Value;
                slicerElements = msg[3].Value; cubeTreeInfo = msg[4].Value; this.currentReport = this._deferReport = msg[5].Value;
                this.reports = msg[6].Value; this.reportsCount = msg[7].Value; reportList = $.parseJSON(msg[8].Value);
                if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(msg[9].Value);
                this.currentCubeName = msg[10].Value;
                if (msg[11] != null && msg[11] != undefined)
                    this.model.customObject = msg[11].Value;
            }
            else if (msg.d != undefined) {
                //this.model.analysisMode = msg.DataModel == "Olap" ? ej.Pivot.AnalysisMode.Olap : ej.Pivot.AnalysisMode.Pivot;
                if (ej.isNullOrUndefined(msg.d[3]) || msg.d[3].Value == "Pivot") {
                    this.model.analysisMode = ej.Pivot.AnalysisMode.Pivot;
                    this._currentReportName = "Default";
                    var hiddenCellCol = this._hiddenCellInfo(msg.d);
                    if (msg.d.length>4 && msg.d[4].Value == "LoadReport") {
                        this._clientReportCollection = JSON.parse(msg.d[5].Value);
                        
                        this._renderClientControls({
                            PivotReport: msg.d[0].Value, GridJSON: msg.d[1].Value, ChartJSON: msg.d[2].Value,
                            FilteredColumnHeaders: hiddenCellCol.columnArea.length > 0 ? (hiddenCellCol.columnArea) : "[]",
                            FilteredRowHeaders: (hiddenCellCol.rowArea.length > 0) ? (hiddenCellCol.rowArea) : "[]"
                        });
                        var reportList = $.map(this._clientReportCollection, function (item, index) { if (item.name != undefined) { return { name: item.name } } });
                        var reportLists = this.element.find(".reportlist").data("ejDropDownList");
                        this.element.find(".reportlist").ejDropDownList("option", "dataSource", (reportList));
                        reportLists.selectItemByText(reportList[0].name);
                        this._unWireEvents();
                        this._wireEvents();
                    }
                    else {
                        if (this.model.enableDrillThrough && !ej.isNullOrUndefined(msg.d[4].Value))
                            this.dataSet =msg.d[4].Value;
                        this._clientReportCollection = [{ name: "Default", report: $.parseJSON(msg.d[0].Value).Report }];
                        this._renderClientControls(
                            {
                                PivotReport: msg.d[0].Value, GridJSON: msg.d[1].Value, ChartJSON: msg.d[2].Value,
                                FilteredColumnHeaders: hiddenCellCol.columnArea.length > 0 ? (hiddenCellCol.columnArea[0]) : "[]",
                                FilteredRowHeaders: (hiddenCellCol.rowArea.length > 0) ? (hiddenCellCol.rowArea[0]) : "[]"
                            });
                    }
                    return;
                }
                else {
                cubes = msg.d[0].Value; columnElements = msg.d[1].Value; rowElements = msg.d[2].Value;
                slicerElements = msg.d[3].Value; cubeTreeInfo = msg.d[4].Value; this.currentReport = this._deferReport = msg.d[5].Value;
                this.reports = msg.d[6].Value; this.reportsCount = msg.d[7].Value; reportList = $.parseJSON(msg.d[8].Value);
                if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(msg.d[9].Value);
                this.currentCubeName = msg.d[10].Value;
                if (msg.d[11] != null && msg.d[11] != undefined)
                    this.model.customObject = msg.d[11].Value;
            }
            }
            else {
                if (msg != "") {
                    if (!ej.isNullOrUndefined(msg.DataModel) && msg.DataModel != "Olap") {
                        this.model.analysisMode = ej.Pivot.AnalysisMode.Pivot;
                        this._currentReportName = ej.isNullOrUndefined(msg.ReportCollection) ? "Default" : JSON.parse(msg.ReportCollection)[0].name;
                        this._clientReportCollection = ej.isNullOrUndefined(msg.ReportCollection) ? [{ name: "Default", report: $.parseJSON(msg.PivotReport).Report }] : JSON.parse(msg.ReportCollection);
                        this._renderClientControls(msg);
                        return;
                    }
                    else {
                        this.model.analysisMode = ej.Pivot.AnalysisMode.Olap;
                        cubes = msg.Cubes; columnElements = msg.Columns; rowElements = msg.Rows;
                        slicerElements = msg.Slicers; cubeTreeInfo = msg.CubeTreeInfo; this.currentReport = msg.CurrentReport;
                        this.reports = msg.ClientReports; reportList = $.parseJSON(msg.ReportList); this.reportsCount = msg.ReportsCount;
                        if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(msg.MeasureGroups);
                        this.currentCubeName = msg.CurrentCubeName;
                        if (msg.customObject != null && msg.customObject != undefined)
                            this.model.customObject = msg.customObject;
                    }
                }
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "initialize", element: this.element, customObject: this.model.customObject });
            var treeViewData = null;
            if(msg != "")
                treeViewData = $.parseJSON(cubeTreeInfo);
            var reportBar = ej.buildTag("div.reportToolbar#reportToolbar", this._reportToolbar(), { width: "410px", height: "29px" })[0].outerHTML;
            var browserPanel, htmlTag;
            if (this.model.enableSplitter) {
                if (!this.model.isResponsive) {
                    if (this.model.enableRTL) {
                        if (this.model.enableVirtualScrolling) {
                            browserPanel = this._createCubeSelector() + "<table class=cubeTable style='width:100%'><tr class='childsplit' style='width:98%'><td class=axisBuilderTD valign=\"bottom\" style='width:47%'>" + this._createAxisElementBuilder(columnElements, rowElements, slicerElements) + "</td><td class=cdbTD valign=\"bottom\" style='width:47%;'>" + this._createCubeBrowser(cubeTreeInfo) + "</td></tr></table>";//+ (this.model.enableRTL ? "padding-right:5px;" : "padding-left:" + this.model.enableSplitter ? "0px" : "5px") 
                            htmlTag = ej.buildTag("span.outerPanel", "", {}).append("<div class=\"titleText\"><span>" + this.title() + "</span></div>" + reportBar + "<table class=\"outerTable\" style='width:100%'><tr class='parentsplit' style='width:100%'><td style='width:49%'>" + browserPanel + "</td><td class=\"controlPanelTD\" style='width:49%;'>" + this._controlPanel() + "</td>" + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : "") + "</tr></table>");
                        }
                        else {
                            browserPanel = this._createCubeSelector() + "<table class=cubeTable style='width:98%'><tr class='childsplit'><td class=axisBuilderTD valign=\"bottom\" style='" + (this.model.enableRTL ? "padding-right:0px;" : "padding-left:" + this.model.enableSplitter ? "0px" : "5px") + "'>" + this._createAxisElementBuilder(columnElements, rowElements, slicerElements) + "</td><td class=cdbTD valign=\"bottom\"'>" + this._createCubeBrowser(cubeTreeInfo) + "</td></tr></table>";
                            htmlTag = ej.buildTag("span.outerPanel", "", {}).append("<div class=\"titleText\"><span>" + this.title() + "</span></div>" + reportBar + "<table class=\"outerTable\" style='width:100%'><tr class='parentsplit'><td class=\"controlPanelTD\">" + this._controlPanel() + "</td><td>" + browserPanel + "</td>" + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : "") + "</tr></table>");
                        }
                    }
                    else {
                        browserPanel = this._createCubeSelector() + "<table class=cubeTable style='width:100%'><tr class='childsplit' style='width:98%'><td class=cdbTD valign=\"bottom\" style='width:47%;'>" + this._createCubeBrowser(cubeTreeInfo) + "</td><td class=axisBuilderTD valign=\"bottom\" style='" + (this.model.enableRTL ? "padding-right:5px;" : "padding-left:" + this.model.enableSplitter ? "0px" : "5px") + "width:47%'>" + this._createAxisElementBuilder(columnElements, rowElements, slicerElements) + "</td></tr></table>";
                        htmlTag = ej.buildTag("span.outerPanel", "", {}).append("<div class=\"titleText\"><span>" + this.title() + "</span></div>" + reportBar + "<table class=\"outerTable\" style='width:100%'><tr class='parentsplit' style='width:100%'><td style='width:49%'>" + browserPanel + "</td><td class=\"controlPanelTD\" style='width:49%'>" + this._controlPanel() + "</td>" + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : "") + "</tr></table>");
                    }
                    }
                    
                else {
                       browserPanel = this._createCubeSelector() + ej.buildTag("table.cubeTable", ej.buildTag("tbody", ej.buildTag("tr.splitresponsive", ej.buildTag("td.cubeTableTD", this._createCubeBrowser(cubeTreeInfo)).attr({ valign: "bottom"}).css("width","50%")[0].outerHTML + ej.buildTag("td.cubeTableTD", this._createAxisElementBuilder(columnElements, rowElements, slicerElements)).attr({ valign: "bottom"}).css("width","50%")[0].outerHTML).css("width","100%")[0].outerHTML)[0].outerHTML)[0].outerHTML;
                       htmlTag = ej.buildTag("span.outerPanel", "").append(($.trim(this.model.title) != "" ? (ej.buildTag("div.titleText", ej.buildTag("span", this.title(), { "padding-left": "10px" })[0].outerHTML)[0].outerHTML) : "") + reportBar + ej.buildTag("table.oClientTbl", ej.buildTag("tr", ej.buildTag("td", ej.buildTag("table.outerTable", ej.buildTag("tr", ej.buildTag("td", browserPanel)[0].outerHTML)[0].outerHTML)[0].outerHTML + ej.buildTag("table.controlPanelTD", ej.buildTag("tr", ej.buildTag("td", this._controlPanel())[0].outerHTML + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : ""))[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML, { width: "100%" })[0].outerHTML);
                }
            }
            else {
                if (!this.model.isResponsive) {
                    browserPanel = this._createCubeSelector() + "<table class=cubeTable><tr><td class=cdbTD valign=\"bottom\" style='display:block'>" + this._createCubeBrowser(cubeTreeInfo) + "</td><td class=axisBuilderTD valign=\"bottom\" style='" + (this.model.enableRTL ? "padding-right:5px;" : "padding-left:5px;") + "'>" + this._createAxisElementBuilder(columnElements, rowElements, slicerElements) + "</td></tr></table>";
                    htmlTag = ej.buildTag("span.outerPanel", "", { }).append("<div class=\"titleText\"><span>" + this.title() + "</span></div>" + reportBar + "<table class=\"outerTable\"><tr><td>" + browserPanel + "</td><td class=\"controlPanelTD\" style='display:block'>" + this._controlPanel() + "</td>" + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : "") + "</tr></table>");
                }
                else if (this.model.isResponsive) {
                        browserPanel = this._createCubeSelector() + ej.buildTag("table.cubeTable", ej.buildTag("tbody", ej.buildTag("tr", ej.buildTag("td.cubeTableTD", this._createCubeBrowser(cubeTreeInfo)).attr({ valign: "bottom", width: "50%", height: "100%" }).css({"table-layout":"fixed","display":"initial"})[0].outerHTML + ej.buildTag("td.cubeTableTD", this._createAxisElementBuilder(columnElements, rowElements, slicerElements)).attr({ valign: "bottom", width: "50%",height:"100%" })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML;
                    htmlTag = ej.buildTag("span.outerPanel", "").append(($.trim(this.model.title) != "" ? (ej.buildTag("div.titleText", ej.buildTag("span", this.title(), { "padding-left": "10px" })[0].outerHTML)[0].outerHTML) : "") + reportBar + ej.buildTag("table.oClientTbl", ej.buildTag("tr", ej.buildTag("td", ej.buildTag("table.outerTable", ej.buildTag("tr", ej.buildTag("td", browserPanel)[0].outerHTML)[0].outerHTML)[0].outerHTML + ej.buildTag("table.controlPanelTD", ej.buildTag("tr", ej.buildTag("td", this._controlPanel())[0].outerHTML + (this.model.enableVirtualScrolling ? ej.buildTag("td.virtualScrolling", ej.buildTag("div.vScrollPanel")[0].outerHTML)[0].outerHTML : ""))[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML, { width: "100%","table-layout":"fixed" })[0].outerHTML);
                }
            }
            this.element.html(htmlTag);
            this.element.find(".reportToolbar").ejToolbar({ enableRTL: this.model.enableRTL, height: "35px" });
            this._calculateSize();
            if (this.model.enableRTL) {
                this.element.addClass("e-rtl");
            }
            if ((this.controlPlacement() == ej.PivotClient.ControlPlacement.Tab && this.defaultView() == ej.PivotClient.DefaultView.Grid) || (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly))
                this.element.find(".chartTypesImg").addClass("chartTypesOnGridView");
            var reportDropDown = "<div class ='reportList' ><input type='text' id='reportList' class='reportlist' title='" + this._getLocalizedLabels("ReportList") + "'/></div>";
            if (this.model.enableMeasureGroups) {
                this._createMeasureGroup();
            }
            $(this.element).find(".reportCol").append(reportDropDown);
            this.element.find(".reportlist").ejDropDownList({
                dataSource: reportList,
                enableRTL: this.model.enableRTL,
                fields: { text: "name", value: "name" },
                height: "26px",
                create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
            });
            this.element.find(".reportlist").attr("tabindex", 0);
            var tempddlwidth = this.element.find(".csHeader").width() - this.element.find(".cubeText").width() - (this.element.find(".toggleExpandButton").length > 0 ? this.element.find(".toggleExpandButton").width() : 0) - (((this.model.analysisMode=="olap"&&this.model.operationalMode=="servermode")||this.model.enableSplitter)?20:50);
            var cubeddlWidth = this.enableTogglePanel() ? tempddlwidth - 25 : tempddlwidth;
            var cubeCollection = (cubes == "" ? "" : $.parseJSON(cubes));
            this.element.find(".cubeSelector").ejDropDownList({
                dataSource: cubeCollection,
                enableRTL: this.model.enableRTL,
                fields: { text: "name", value: "name" },
                width: this.model.enableSplitter && !this.model.isResponsive? "100%" : "" + cubeddlWidth + "px"
            });
             
            this.ddlTarget = this.element.find('.cubeSelector').data("ejDropDownList");
            this.reportDropTarget = this.element.find('#reportList').data("ejDropDownList");
            if (msg != "" && !ej.isNullOrUndefined(this.ddlTarget)) {
                this.ddlTarget.selectItemByText(this.currentCubeName);
                if (this.reportDropTarget.model.dataSource.length)
                    this.reportDropTarget.selectItemByText(this.reportDropTarget.model.dataSource[0].name);
                this._selectedReport = this.reportDropTarget.currentValue;
            }
            this.element.find(".cubeSelector").ejDropDownList("option", "change", ej.proxy(this._cubeChanged, this));
            this.element.find(".cubeSelector").attr("tabindex", 0);
            this.element.find(".reportlist").ejDropDownList("option", "change", ej.proxy(this.reportChanged, this));
            if (this.model.enableMeasureGroups)
                this.element.find(".measureGroupSelector").ejDropDownList("option", "change", ej.proxy(this._measureGroupChanged, this));
            this.element.find(".cubeTreeView").ejTreeView({
                clientObj: this,
                fields: { id: "id", parentId: "pid", text: "name", spriteCssClass: "spriteCssClass", dataSource: treeViewData },
                allowDragAndDrop: true,
                enableRTL: this.model.enableRTL,
                allowDropChild: false,
                allowDropSibling: false,
                dragAndDropAcrossControl: true,
                nodeDragStart: function () {
                    this.model.clientObj.isDragging = true;
                },
                beforeDelete: function () {
                    return false;
                },
                cssClass: 'pivotTreeViewDragedNode',
                nodeDropped: ej.proxy(this._nodeDropped, this),
              });
            this.element.find(".cubeTreeView").attr("tabindex", 0);
            var treeViewElements = this.element.find(".cubeTreeView").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                treeViewElements[i].setAttribute("tag", treeViewData[i].tag);
            }
            var folders = this.element.find(".cubeTreeView .folderCDB");
            for (var i = 0; i < folders.length; i++) {
                $(folders[i].parentElement).removeClass("e-draggable");
            }
            if (this.element.find(".cubeTreeView .kpiRootCDB").length > 0)
                this.element.find(".cubeTreeView .kpiRootCDB").parent().removeClass("e-draggable");
            if (this.element.find(".cubeTreeView .calcMemberGroupCDB").length > 0) {
                this.element.find(".cubeTreeView .calcMemberGroupCDB").parent().removeClass("e-draggable");
                var calcItem = this.element.find(".cubeTreeView .calcMemberCDB").parents("li").find("li");
                if (calcItem.length > 0) {
                    for (var i = 0; i < calcItem.length; i++) {
                        this._calcMembers.push(treeViewData[i + 1]);
                        calcItem[i].setAttribute("expression", treeViewData[i + 1].expression);
                        calcItem[i].setAttribute("formatString", treeViewData[i + 1].formatString);
                        calcItem[i].setAttribute("nodeType", treeViewData[i + 1].nodeType);
                    }
                }
            }

            this._cubeTreeView = this.element.find('.cubeTreeView').data("ejTreeView");
            var searchEditor = ej.buildTag("div.searchDiv", ej.buildTag("input#" + this._id + "_SearchTreeView.searchTreeView").attr("type", "text")[0].outerHTML, {"margin":"5px 5px 0px 0px"})[0].outerHTML;
            var cubeName = ej.buildTag("div.cubeName", this.currentCubeName + searchEditor);
            $(this.element).find(".cubeBrowser").prepend(cubeName);
            this.element.find("#" + this._id + "_SearchTreeView").ejMaskEdit({
                name: "inputbox",
                width: "100%",
                inputMode: ej.InputMode.Text,
                watermarkText: this._getLocalizedLabels("Search"),
                maskFormat: "",
                textAlign: this.model.enableRTL ? "right" : "left",
                change: ej.proxy(ej.Pivot._searchTreeNodes, this),
            });
            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").ejDroppable({ drop: ej.proxy(this._onDropped, this) });
            this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").find("button").ejButton({ height: "20px", type: ej.ButtonType.Button });
            if (this.enableTogglePanel()) {
                $(ej.buildTag("div.toggleExpandButton e-icon", ej.buildTag("p#toggleexpand", "toggle expanded", {"display":"none"})[0].outerHTML).attr("aria-describedby","toggleexpand")[0].outerHTML).appendTo(this.element.find(".csHeader"));
                $(this.element.find(".outerTable").find("td")[0]).append(ej.buildTag("div.toggleCollapseButton e-icon", ej.buildTag("p#togglecollapse", "toggle collapsed", {"display":"none"})[0].outerHTML).attr("aria-describedby","togglecollapse")[0].outerHTML);
                $((ej.buildTag("div.toggleText")[0].outerHTML)).insertAfter(this.element.find(".toggleCollapseButton"));
                this.element.find(".toggleCollapseButton").hide();
                this.element.find(".toggleText").hide();
            }
            this._overflow();
            this._setSplitBtnTitle();
            this.element.find("#clientTab").ejTab({ enableRTL: this.model.enableRTL, itemActive: ej.proxy(this._onTabClick, this) });
            
            if (this.model.operationalMode != ej.Pivot.OperationalMode.ClientMode)
            {
                if (this.defaultView() == ej.PivotClient.DefaultView.Chart) {
                    this.element.find("#" + this._id + "_PivotChart").ejPivotChart({ url: this.model.url, customObject: this.model.customObject, enableRTL: this.model.enableRTL, canResize: this.model.isResponsive, currentReport: this.currentReport, locale: this.locale(), showTooltip: true, size: { height: this._chartHeight, width: this._chartWidth }, commonSeriesOptions: { type: this.model.chartType, tooltip: { visible: true } }, beforeServiceInvoke: this.model.chartLoad, drillSuccess: ej.proxy(this._chartDrillSuccess, this) });
                    if (this.gridLayout() != ej.PivotGrid.Layout.Normal)
                        this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ url: this.model.url, customObject: this.model.customObject, isResponsive: this.model.isResponsive, enableRTL: this.model.enableRTL, currentReport: this.currentReport, layout: this.gridLayout(), locale: this.locale(), drillSuccess: ej.proxy(this._gridDrillSuccess, this) });
                    else
                        this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ url: this.model.url, customObject: this.model.customObject, isResponsive: this.model.isResponsive, enableRTL: this.model.enableRTL, currentReport: this.currentReport, locale: this.locale(), drillSuccess: ej.proxy(this._gridDrillSuccess, this) });
                }
                else {
                    if (this.gridLayout() != ej.PivotGrid.Layout.Normal)
                        this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ url: this.model.url, customObject: this.model.customObject, isResponsive: this.model.isResponsive, enableRTL: this.model.enableRTL, currentReport: this.currentReport, locale: this.locale(), layout: this.gridLayout(), drillSuccess: ej.proxy(this._gridDrillSuccess, this) });
                    else
                        this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ url: this.model.url, customObject: this.model.customObject, isResponsive: this.model.isResponsive, enableRTL: this.model.enableRTL, currentReport: this.currentReport, locale: this.locale(), drillSuccess: ej.proxy(this._gridDrillSuccess, this) });
                    this.element.find("#" + this._id + "_PivotChart").ejPivotChart({ url: this.model.url, customObject: this.model.customObject, enableRTL: this.model.enableRTL, canResize: this.model.isResponsive, currentReport: this.currentReport, locale: this.locale(), showTooltip: true, size: { height: this._chartHeight, width: this._chartWidth }, commonSeriesOptions: { type: this.model.chartType, tooltip: { visible: true } }, drillSuccess: ej.proxy(this._chartDrillSuccess, this), beforeServiceInvoke: this.model.chartLoad });
                }
                if (this.model.enablePaging)
                {
                    this.element.find("#" + this._id + "_Pager").ejPivotPager({ mode: ej.PivotPager.Mode.Both, targetControlID: this._id });
                    this.element.find(".controlPanel").height(this.element.find(".controlPanel").height() - (this.element.find("#" + this._id + "_Pager").height() + 5));
                    this.element.find(".gridContainer").height(this.element.find(".gridContainer").height() - (this.element.find("#" + this._id + "_Pager").height() + 5));
                    this.element.find(".chartContainer").height(this.element.find(".chartContainer").height() - (this.element.find("#" + this._id + "_Pager").height() + 10));

                }
                if (this.displayMode() != "chartonly")
                    this._pivotGrid = this.element.find("#" + this._id + "_PivotGrid").data("ejPivotGrid");
                if (this.displayMode() != "gridOnly")
                    this._pivotChart = this.element.find('#'+ this._id + '_PivotChart').data("ejPivotChart");
                var items = {};
                if (this._pivotChart != null) {
                    this.element.find('#' + this._id + '_PivotChart').width(this._pivotChart.model.size.width);
                    items["chartModelWidth"] = this._pivotChart.model.size.width;
                }
                items["controlPanelWidth"] = this.element.find(".controlPanel").width();
                items["chartOuterWidth"] = this._chartWidth;
                items["gridOuterWidth"] = this._gridWidth;
                this._initStyles.push(items);
                this._wireEvents();
                if (this.model.isResponsive) {
                    this._enableResponsive();
                    this._parentElwidth = $("#" + this._id).parent().width();
                    if (this._parentElwidth < 850) {
                        this._rwdToggleCollapse();
                    }
                    else if (this._parentElwidth > 850) {
                        this._rwdToggleExpand();
                    }
                }
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode != ej.Pivot.OperationalMode.ClientMode) {
                    var tempddlwidth = this.element.find(".csHeader").width() - this.element.find(".cubeText").width() - this.element.find(".toggleExpandButton").width() - (this.model.enableSplitter ? 50 : 20);
                    var cubeddlWidth = this.enableTogglePanel() ? tempddlwidth - 25 : tempddlwidth;
                    var cubeCollection = (cubes == "" ? "" : $.parseJSON(cubes));
                    this.element.find(".cubeSelector").ejDropDownList({
                        width: this.model.enableSplitter && !this.model.isResponsive ? "100%" : "" + cubeddlWidth + "px",
                    });
                }
                this._trigger("renderSuccess", this);
                this._successAction = "ClientRender";
                this.progressPos = $("#" + this._id).position();
                this._treeContextMenu();
                this._buttonContextMenu();
                if (this.model.analysisMode == "olap" && this.model.operationalMode == "servermode" && this.model.enableSplitter) 
                this._createSplitter();
                if (!ej.isNullOrUndefined(msg.Exception)) {
                    ej.Pivot._createErrorDialog(msg, "Exception", this);
                }
                if (this.model.showUniqueNameOnPivotButton) {
                    $(".pvtBtn").addClass("splitBtnUnique");
                    $(".removeSplitBtn").addClass("removeBtnUnqiue");
                }
            }
            if (this.model.collapseCubeBrowserByDefault) {
                this._collapseCubeBrowser();
                this._isCollapseCB = true;
            }
        },

        _contextOpen: function (args) {
            ej.Pivot.openPreventPanel(this);
            var menuObj = $("#pivotTree").data('ejMenu');
            this._selectedMember = $(args.target);
            menuObj.enableItem(this._getLocalizedLabels("AddToColumn"));
            menuObj.enableItem(this._getLocalizedLabels("AddToRow"));
            menuObj.enableItem(this._getLocalizedLabels("AddToSlicer"));
        },

        _contextClick: function (args) {
            ej.Pivot.closePreventPanel(this);
            var axisName = args.events.text;
            var droppedPosition = "";
            var pivotClientObj = this;
            axisName = axisName == this._getLocalizedLabels("AddToSlicer") ? "Slicer" : axisName == this._getLocalizedLabels("AddToColumn") ? "Categorical" : axisName == this._getLocalizedLabels("AddToRow") ? "Series" : "";
            if (axisName == "Slicer" && this._selectedMember != null && this._selectedMember.parent().attr("tag").indexOf("Measure") > -1 && this.element.find(".splitBtn[tag*=Measures]").length > 1) {
                ej.Pivot._createErrorDialog(this._getLocalizedLabels("MultipleMeasure"), this._getLocalizedLabels("Warning"), this);
                return false;
            }
            pivotClientObj._isTimeOut = true;
            setTimeout(function () {
                if (pivotClientObj._isTimeOut)
                    pivotClientObj._waitingPopup.show();
            }, 800);
            if (this.model.beforeServiceInvoke != null)
                this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            var params = this.currentCubeName + "--" + this._selectedMember.parent().attr("tag") + "--" + axisName + "--" + droppedPosition;
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.nodeDropped, JSON.stringify({ "action": "nodeDropped", "dropType": "SplitButton", "nodeInfo": params, "olapReport": this.currentReport, "clientReports": this.reports, "customObject": serializedCustomObject }), this._nodeDroppedSuccess);

        },

        _onContextOpen: function (args) {
            if ($(args.target).find(".folderCDB").length > 0 || $(args.target).find(".calcMemberGroupCDB").length > 0)
                return false;
            ej.Pivot.openPreventPanel(this);
            var menuObj = $("#pivotTreeContext").data('ejMenu');
            this._selectedMember = $(args.target);
            menuObj.enableItem(this._getLocalizedLabels("AddToColumn"));
            menuObj.enableItem(this._getLocalizedLabels("AddToRow"));
            if ($(args.target).find(".calcMemberCDB").length > 0)
                menuObj.showItems(["#Remove"]);
            else
                menuObj.hideItems(["#Remove"]);
            $(args.target.parentElement).find(".namedSetCDB").length > 0 ? menuObj.disableItem(this._getLocalizedLabels("AddToSlicer")) : menuObj.enableItem(this._getLocalizedLabels("AddToSlicer"));
        },

        _onTreeContextClick: function (args) {
            if (!ej.isNullOrUndefined(this._curFocus.tree)) {
                this._curFocus.tree.attr("tabindex", "-1").focus().addClass("hoverCell");
            }
            else if (!ej.isNullOrUndefined(this._curFocus.tab)) {
                this._curFocus.tab.attr("tabindex", "-1").focus().addClass("hoverCell");
            }
            delete this._fieldMembers[this._dialogTitle];
            delete this._fieldSelectedMembers[this._dialogTitle];
            ej.Pivot.closePreventPanel(this);
            var axisName = args.events.text;
            var droppedPosition="";
            var pivotClientObj = this;
            pivotClientObj._isTimeOut = true;
            if (axisName == this._getLocalizedLabels("Remove")) {
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
                var clientBtns = this.element.find(".splitBtn");
                jQuery.each(clientBtns, function (index, value) {
                    if ($(clientBtns[index]).attr("tag").split(":")[1] == pivotClientObj._selectedMember.parent().parent().attr("tag").replace(/\[/g, "").replace(/\]/g, "")) {
                        $(value).remove();
                   }
                });
                pivotClientObj._cubeTreeView.model.beforeDelete = null;
                pivotClientObj._cubeTreeView.removeNode(pivotClientObj._selectedMember.parent().parent().attr("id"));
                pivotClientObj._cubeTreeView.model.beforeDelete = function () { return false };
                // pivotClientObj._selectedMember.parent().parent().remove();
                if (!ej.isNullOrUndefined(pivotClientObj._calcMemberTreeObj))
                    pivotClientObj._calcMemberTreeObj.removeNode(pivotClientObj._selectedMember.parent().parent().attr("id"));
                if (pivotClientObj.element.find(".cubeTreeView .calcMemberCDB").length == 0 && pivotClientObj.element.find(".cubeTreeView .calcMemberGroupCDB").parents("li").length > 0) {
                    pivotClientObj._cubeTreeView.model.beforeDelete = null;
                    pivotClientObj._cubeTreeView.removeNode(pivotClientObj.element.find(".cubeTreeView .calcMemberGroupCDB").parents("li").attr("id"));
                    pivotClientObj._cubeTreeView.model.beforeDelete = function () { return false };
                }
                if (pivotClientObj.element.find(".cubeTreeViewCalcMember .calcMemberCDB").length == 0 && pivotClientObj.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").parents("li").length > 0) {
                    pivotClientObj._calcMemberTreeObj.removeNode(pivotClientObj.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").parents("li").attr("id"));
                }
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "removeCalculatedMember", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                var params = this._selectedMember.parent().parent().attr("tag");
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.removeSplitButton, JSON.stringify({ "action": "removeCalculatedMember", "clientParams": params, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject }), pivotClientObj._removeSplitButtonSuccess)
            }
            else {
                axisName = axisName == pivotClientObj._getLocalizedLabels("AddToSlicer") ? "Slicer" : axisName == pivotClientObj._getLocalizedLabels("AddToColumn") ? "Categorical" : axisName == pivotClientObj._getLocalizedLabels("AddToRow") ? "Series" : "";
                if ((axisName == "Slicer" && this._selectedMember.parent().parent().attr("tag") != null && this._selectedMember.parent().parent().attr("tag").indexOf("Measure") > -1 && this.element.find(".splitBtn[tag*=Measures]").length > 1) || (axisName == "Slicer" && this._selectedMember.parent().parent().attr("tag").indexOf("Measure") > -1 && this._selectedMember.parent().parent().find(".calcMemberCDB").length > 0 && this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").length == 1 && this._selectedMember.parent().parent().attr("tag").replace(/\[/g, "").replace(/\]/g, "") != this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").attr("tag").split(":")[1].split("::")[0]) || (axisName == "Slicer" && this._selectedMember.parent().parent().attr("tag").indexOf("Measure") > -1 && this._selectedMember.parent().parent().find(".calcMemberCDB").length == 0 && this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").length == 1) || (axisName == "Slicer" && this._selectedMember.parent().parent().attr("tag").indexOf("Measure") > -1 && this._selectedMember.parent().parent().find(".calcMemberCDB").length == 1 && this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").length == 0 && this.element.find(".splitBtn[tag*=Measure]").length == 1)) {
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("MultipleMeasure"), this._getLocalizedLabels("Warning"), this);
                    return false;
                }
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                var params = pivotClientObj.currentCubeName + "--" + this._selectedMember.parent().parent().attr("tag") + "--" + axisName + "--" + droppedPosition;
                pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.nodeDropped, JSON.stringify({ "action": "nodeDropped", "dropType": "TreeNode", "nodeInfo": params, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject }), pivotClientObj._nodeDroppedSuccess);
            }
        },

        _toggleAxisSuccess: function (msg) {
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                if (ej.isNullOrUndefined(msg.d))
                    this.setOlapReport(msg.PivotReport);
                else
                    this.setOlapReport($.grep(msg.d, function (item) { return item.Key == "PivotReport" })[0].Value);
                this.refreshControl(msg);
            }
            else {
                var columnElements, rowElements, slicerElements;
                if (msg[0] != undefined) {
                    columnElements = msg[0].Value; rowElements = msg[1].Value;
                    slicerElements = msg[2].Value; this.currentReport = msg[3].Value; this.reports = msg[4].Value;
                }
                else if (msg.d != undefined) {
                    columnElements = msg.d[0].Value; rowElements = msg.d[1].Value;
                    slicerElements = msg.d[2].Value; this.currentReport = msg.d[3].Value; this.reports = msg.d[4].Value
                }
                else {
                    columnElements = msg.Columns; rowElements = msg.Rows;
                    slicerElements = msg.Slicers; this.currentReport = msg.CurrentReport;
                    this.reports = msg.ClientReports;
                }
                if (this.model.OperationalMode == ej.Pivot.AnalysisMode.ServerMode) {
                    var axisHeaderHeight, aebHeight;
                    this.element.find(".cubeTable").find(".categoricalAxis").parent().html("").html(this._createAxisElementBuilder(columnElements, rowElements, slicerElements));
                    this.element.find(".cubeTable").height((this.element.height() - ((this.element.find("div.titleText").length > 0 ? this.element.find("div.titleText").height() : 0) + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 38)));
                    this.element.find(".cdbTD, .cubeTableTD").height(this.element.find(".cubeTable").height());
                    aebHeight = this.element.find(".cdbTD, .cubeTableTD").height() - ((this.element.find(".axisHeader").height() * 3) + 7);
                    this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").height((aebHeight / 3));
                }
                this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").find("button").ejButton({ height: "20px", type: ej.ButtonType.Button });
                this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").addClass("e-droppable");
                this._renderControls();
                this._setSplitBtnTitle();
                this._unWireEvents();
                this._wireEvents();
                this._trigger("renderSuccess", this);
                this._buttonContextMenu();
            }
        },

        _measureGroupChangedSuccess: function (cubeTree) {
            var cubeTreeInfo;
            if (cubeTree[0] != undefined) {
                cubeTreeInfo = cubeTree[0].Value;
            }
            if (cubeTree.d != undefined) {
                cubeTreeInfo = cubeTree.d[0].Value;
            }
            else
                cubeTreeInfo = cubeTree.CubeTreeInfo;
            this.element.find(".e-treeview, .cubeTreeView").remove();
            var cubeTree = ej.buildTag("div#cubeTreeView.cubeTreeView")[0].outerHTML;
            this.element.find(".cubeBrowser").append(cubeTree);
            var treeViewData = $.parseJSON(cubeTreeInfo);
            this.element.find(".cubeTreeView").ejTreeView({
                clientObj: this,
                fields: { id: "id", parentId: "pid", text: "name", spriteCssClass: "spriteCssClass", dataSource: treeViewData },
                allowDragAndDrop: true,
                allowDropChild: false,
                allowDropSibling: false,
                enableRTL: this.model.enableRTL,
                dragAndDropAcrossControl: true,
                nodeDragStart: function () {
                   this.model.clientObj.isDragging = true;
                },
                nodeDropped: ej.proxy(this._nodeDropped, this),
                beforeDelete: function () {
                    return false;
                },
                cssClass: 'pivotTreeViewDragedNode',
                height: "464px"
            });
            var treeViewElements = this.element.find(".cubeTreeView").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                treeViewElements[i].setAttribute("tag", treeViewData[i].tag);
            }
            this.element.find(".cubeTreeView").height((this.element.find(".cubeBrowser").height() - this.element.find(".cubeName").height()) - (7 + (this.model.enableMeasureGroups ? (this.element.find(".measureGroupselector").height() + 13) : 0)));
            this._cubeTreeView = this.element.find('.cubeTreeView').data("ejTreeView");
            this._unWireEvents();
            this._wireEvents();
            this._isTimeOut = false;
            this._waitingPopup.hide();
            this._successAction = "MeasureGroupChange";
        },

        _cubeChangedSuccess: function (report) {
            var cubeTreeInfo, chartSettings;
            if (report[0] != undefined) {
                this.currentReport = report[0].Value; cubeTreeInfo = report[1].Value; this.reports = report[2].Value;
                this.reportsCount = report[3].Value; reportList = $.parseJSON(report[4].Value);
                if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(report[5].Value);
                chartSettings = $.parseJSON(report[6].Value);
                if (report[7] != null && report[7] != undefined)
                    this.model.customObject = report[7].Value;
            }
            else if (report.d != undefined) {
                this.currentReport = report.d[0].Value; cubeTreeInfo = report.d[1].Value; this.reports = report.d[2].Value;
                this.reportsCount = report.d[3].Value; reportList = $.parseJSON(report.d[4].Value);
                if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(report.d[5].Value);
                chartSettings = $.parseJSON(report.d[6].Value);
                if (report.d[7] != null && report.d[7] != undefined)
                    this.model.customObject = report.d[7].Value;
            }
            else {

                this.currentReport = report.NewReport; cubeTreeInfo = report.CubeTreeInfo; this.reports = report.ClientReports;
                this.reportsCount = report.ReportsCount; reportList = $.parseJSON(report.ReportList);
                if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(report.MeasureGroups);
                chartSettings = $.parseJSON(report.ControlSettings);
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            this.model.chartType = chartSettings.ChartType.toLowerCase();
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "cubeChanged", element: this.element, customObject: this.model.customObject });
            if (!this.model.enableDeferUpdate)
                this.element.find(".splitBtn, .e-pivotgrid, .e-pivotchart, .e-treeview, .cubeTreeView, .cubeName, .searchDiv").remove();
            else
                this.element.find(".splitBtn, .e-treeview, .cubeTreeView, .cubeName, .searchDiv").remove();
            var cubeTree = ej.buildTag("div#cubeTreeView.cubeTreeView")[0].outerHTML;
            var searchEditor = ej.buildTag("div.searchDiv", ej.buildTag("input#" + this._id + "_SearchTreeView.searchTreeView").attr("type", "text")[0].outerHTML, {"margin":"5px 5px 0px 5px"})[0].outerHTML;
            var cubeName = ej.buildTag("div.cubeName", this.currentCubeName + searchEditor)[0].outerHTML;
            if (this.model.enableMeasureGroups) {
                this._createMeasureGroup();               
            }
            var treeViewData = $.parseJSON(cubeTreeInfo);
            $(cubeTree).appendTo(".cubeBrowser");
            this.element.find(".cubeTreeView").ejTreeView({
                clientObj:this,
                fields: { id: "id", parentId: "pid", text: "name", spriteCssClass: "spriteCssClass", dataSource: treeViewData },
                allowDragAndDrop: true,
                allowDropChild: false,
                allowDropSibling: false,
                enableRTL: this.model.enableRTL,
                dragAndDropAcrossControl: true,
                nodeDragStart: function () {
                    this.model.clientObj.isDragging = true;
                },
                nodeDropped: ej.proxy(this._nodeDropped, this),
                beforeDelete: function () {
                    return false;
                },
                cssClass: 'pivotTreeViewDragedNode',
                height: this.model.enableMeasureGroups ? "464px" : ""
            });
             var treeViewElements = this.element.find(".cubeTreeView").find("li");
            for (var i = 0; i < treeViewElements.length; i++) {
                treeViewElements[i].setAttribute("tag", treeViewData[i].tag);
            }
            this._cubeTreeView = this.element.find('.cubeTreeView').data("ejTreeView");
            this.element.find(".reportlist").ejDropDownList("option", "change", "");
            this.element.find(".reportlist").ejDropDownList("option", "dataSource", reportList);
            this.element.find(".reportlist").ejDropDownList("option", "value", reportList[0].name);
            $(this.element).find(".cubeBrowser").prepend(cubeName);
            this.element.find("#" + this._id + "_SearchTreeView").ejMaskEdit({
                name: "inputbox",
                width: "100%",
                inputMode: ej.InputMode.Text,
                watermarkText: this._getLocalizedLabels("Search"),
                maskFormat: "",
                textAlign: this.model.enableRTL ? "right" : "left",
                change: ej.proxy(ej.Pivot._searchTreeNodes, this),
            });
            this.element.find(".cubeTable").height((this.element.height() - (this.element.find("div.titleText").height() + this.element.find("#reportToolbar").height() + this.element.find(".csHeader").height() + 38)));
            this.element.find(".cdbTD, .cubeTableTD").height(this.element.find(".cubeTable").height());
            this.element.find(".cubeBrowser").height(this.element.find(".cdbTD, .cubeTableTD").height() - this.element.find(".cdbHeader").height());
            
            this._renderControls();
            this._unWireEvents();
            this._wireEvents();
            this._isTimeOut = false;
            this._waitingPopup.hide();
            this._successAction = "CubeChange";
            this._trigger("renderSuccess", this);
            this._treeContextMenu();

            this.element.find(".cubeTreeView").height((this.element.find(".cubeBrowser").height() - this.element.find(".cubeName").height()) - (7 + (this.model.enableMeasureGroups ? (this.element.find(".measureGroupselector").height() + 13) : 0)));
        },
        
        _treeContextMenu : function(){
            var contextTag = ej.buildTag("ul.pivotTreeContext#pivotTreeContext", ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToColumn"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToRow"))[0].outerHTML)[0].outerHTML + ej.buildTag("li", ej.buildTag("a", this._getLocalizedLabels("AddToSlicer"))[0].outerHTML)[0].outerHTML + ej.buildTag("li#Remove", ej.buildTag("a", this._getLocalizedLabels("Remove"))[0].outerHTML)[0].outerHTML)[0].outerHTML;
            $(this.element).append(contextTag);
            $("#pivotTreeContext").ejMenu({
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                contextMenuTarget: this.element.find(".cubeTreeView")[0],
                click: ej.proxy(this._onTreeContextClick, this),
                beforeOpen: ej.proxy(this._onContextOpen, this),
                close: ej.proxy(ej.Pivot.closePreventPanel, this)
            });
        },
        _removeSplitButtonSuccess: function (report) {
            if (report[0] != undefined) {
                this.currentReport = report[0].Value; this.reports = report[1].Value;
                if (report[2] != null && report[2] != undefined)
                    this.model.customObject = report[2].Value;
            }
            else if (report.d != undefined) {
                this.currentReport = report.d[0].Value; this.reports = report.d[1].Value;
                if (report.d[2] != null && report.d[2] != undefined)
                    this.model.customObject = report.d[2].Value;
            }
            else {
                this.currentReport = report.UpdatedReport; this.reports = report.ClientReports;
                if (report.customObject != null && report.customObject != undefined)
                    this.model.customObject = report.customObject;
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "removeSplitButton", element: this.element, customObject: this.model.customObject });
            this._renderControls();
            this._unWireEvents();
            this._wireEvents();
            this._successAction = "ButtonRemove";
            this._trigger("renderSuccess", this);
        },

        _chartTypeChangedSuccess: function (report) {
            if (report[0] != undefined) {
                this.currentReport = report[0].Value;
                this.reports = report[1].Value;
            }
            else if (report.d != undefined) {
                this.currentReport = report.d[0].Value;
                this.reports = report.d[1].Value;
            }
            else {
                this.currentReport = report.CurrentReport;
                this.reports = report.ClientReports;
            }

        },

        _mdxQuery: function (mdxquery) {
            this.element.find(".e-dialog").hide();
            this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
            if (mdxquery.d != undefined)
                this._createDialog("mdx", mdxquery.d, "");
            else
                this._createDialog("mdx", mdxquery, "");
        },

        _refreshReportList: function () {
            var reportList = $.map(this._clientReportCollection, function (item, index) { if (item.reportName != undefined) { return { name: item.reportName } } });
            var reportLists = this.element.find(".reportlist").data("ejDropDownList");
            this.element.find(".reportlist").ejDropDownList("option", "dataSource", (reportList));
            reportLists.selectItemByText(this.model.dataSource.reportName);
            this._unWireEvents();
            this._wireEvents();
        },
        _clientToolbarOperationSuccess: function (msg) {
            var reportCol = "";
            if (msg != null) {
                var reportCollection = "";
                if (msg && msg.d) {
                    reportCol =msg.d[0].Value;
                    if (reportCol.indexOf(":>>:") > -1) {
                        this._currentReportItems = JSON.parse(reportCol.split(":>>:")[1]);
                        reportCol = reportCol.split(":>>:")[0];
                    }
                    reportCollection = JSON.parse(reportCol);
                }
                else if (msg && msg["report"]) {
                    reportCol = msg["report"];
                    if (reportCol.indexOf(":>>:") > -1) {
                        this._currentReportItems = JSON.parse(reportCol.split(":>>:")[1]);
                        reportCol = reportCol.split(":>>:")[0];
                    }
                    reportCollection = JSON.parse(reportCol);
                }
                this.model.dataSource = reportCollection[0];
                this._clientReportCollection = reportCollection;
                if (this.model.dataSource) {
                    this.refreshControl(this.model.dataSource);
                    this._refreshReportList();
                }
                else if (this._waitingPopup) {
                    this._isTimeOut = false;
                    this._waitingPopup.hide();
                }
            }
        },
        _toolbarOperationSuccess: function (report) {
            if (report != null) {
                if ((report.d != undefined && report.d || report[0] != undefined && report[0]) || report.CurrentReport || report.PivotReport) {
                    var columnElements, rowElements, slicerElements, action, renamedReport, chartSettings;
                    if (report.length > 1 && report[0] != undefined) {
                        this.currentReport = report[0].Value; this.reports = report[1].Value; this.reportsCount = report[2].Value; columnElements = report[3].Value;
                        rowElements = report[4].Value; slicerElements = report[5].Value; action = report[6].Value; reportList = $.parseJSON(report[7].Value);
                        renamedReport = report[8].Value; chartSettings = $.parseJSON(report[9].Value); cubeTreeInfo = report[10].Value; var cubeSelector = report[11].Value;
                        if (this.model.enableMeasureGroups && report[12] != null && report[12] != undefined)
                            this.measureGroupInfo = $.parseJSON(report[12].Value);
                        if (report[13] != null && report[13] != undefined)
                            this.model.customObject = report[13].Value;
                    }
                    else if (report.d != undefined) {
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                            action = $.grep(report.d, function (item) { return item.Key == "CurrentAction" })[0].Value;
                            this.setOlapReport($.grep(report.d, function (item) { return item.Key == "PivotReport" })[0].Value);
                            this.currentReport = $.parseJSON(this.getOlapReport()).Report;
                            columnElements = $.parseJSON(this.getOlapReport()).PivotColumns;
                            rowElements = $.parseJSON(this.getOlapReport()).PivotRows;
                            slicerElements = $.parseJSON(this.getOlapReport()).Filters;
                            if (action == "NewReport") {
                                this._clientReportCollection = [{ name: this._currentReportName, report: this.currentReport }];
                                this.refreshControl({ GridJSON: JSON.stringify(""), ChartJSON: JSON.stringify(""), PivotReport: $.grep(report.d, function (item) { return item.Key == "PivotReport" })[0].Value });
                            }
                            else if (action == "AddReport") {
                                this._clientReportCollection.push({ name: this._currentReportName, report: this.currentReport });
                                this.refreshControl({ GridJSON: JSON.stringify(""), ChartJSON: JSON.stringify(""), PivotReport: $.grep(report.d, function (item) { return item.Key == "PivotReport" })[0].Value });
                            }
                            else if (action == "RemoveReport" || action == "ChangeReport")
                            {
                                var valFilterHiddenCells = this._hiddenCellInfo(report.d);
                                this.refreshControl({
                                    GridJSON: $.grep(report.d, function (item) { return item.Key == "GridJSON" })[0].Value,
                                    ChartJSON: $.grep(report.d, function (item) { return item.Key == "ChartJSON" })[0].Value,
                                    PivotReport: $.grep(report.d, function (item) { return item.Key == "PivotReport" })[0].Value,
                                    FilteredColumnHeaders: valFilterHiddenCells.columnArea.length > 0 ? (valFilterHiddenCells.columnArea) : "[]",
                                    FilteredRowHeaders: (valFilterHiddenCells.rowArea.length > 0) ? (valFilterHiddenCells.rowArea) : "[]"
                                });
                            }
                            var reportList = $.map(this._clientReportCollection, function (report) { return { "name": report.name }; });
                            this.element.find(".reportlist").ejDropDownList("option", "dataSource", reportList);
                            var ddList = this.element.find(".reportlist").data("ejDropDownList");
                            this._isReportListAction = false;
                            ddList.selectItemByText(this._currentReportName);
                            this._isReportListAction = true;
                            return;
                        }
                        this.currentReport = report.d[0].Value; this.reports = report.d[1].Value; this.reportsCount = report.d[2].Value; columnElements = report.d[3].Value;
                        rowElements = report.d[4].Value; slicerElements = report.d[5].Value; action = report.d[6].Value; reportList = $.parseJSON(report.d[7].Value);
                        renamedReport = report.d[8].Value; chartSettings = $.parseJSON(report.d[9].Value); cubeTreeInfo = report.d[10].Value; cubeSelector = report.d[11].Value;
                        if (this.model.enableMeasureGroups && report.d[12] != null && report.d[12] != undefined)
                            this.measureGroupInfo = $.parseJSON(report.d[12].Value);
                        if (report.d[13] != null && report.d[13] != undefined)
                            this.model.customObject = report.d[13].Value;
                    }
                    else {
                        if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                            action = report.CurrentAction;
                            this.setOlapReport(report.PivotReport);
                            this.currentReport = $.parseJSON(this.getOlapReport()).Report;
                            columnElements = $.parseJSON(this.getOlapReport()).PivotColumns;
                            rowElements = $.parseJSON(this.getOlapReport()).PivotRows;
                            slicerElements = $.parseJSON(this.getOlapReport()).Filters;
                            if (action == "NewReport") {
                                this._clientReportCollection = [{ name: this._currentReportName, report: this.currentReport }];
                                this.refreshControl({ GridJSON: JSON.stringify(""), ChartJSON: JSON.stringify(""), PivotReport: report.PivotReport });
                            }
                            else if (action == "AddReport") {
                                this._clientReportCollection.push({ name: this._currentReportName, report: this.currentReport });
                                this.refreshControl({ GridJSON: JSON.stringify(""), ChartJSON: JSON.stringify(""), PivotReport: report.PivotReport });
                            }
                            else if (action == "RemoveReport" || action == "ChangeReport") {
                                this.refreshControl({
                                    GridJSON: report.GridJSON, ChartJSON: report.ChartJSON, PivotReport: report.PivotReport,
                                    FilteredColumnHeaders: (!ej.isNullOrUndefined(report.FilteredColumnHeaders)) ? report.FilteredColumnHeaders : "[]",
                                    FilteredRowHeaders: (!ej.isNullOrUndefined(report.FilteredRowHeaders)) ? report.FilteredRowHeaders : "[]"
                                });
                            }
							var reportList = $.map(this._clientReportCollection, function (report) { return { "name" : report.name }; });
                            this.element.find(".reportlist").ejDropDownList("option", "dataSource", reportList);
                            var ddList = this.element.find(".reportlist").data("ejDropDownList");
                            this._isReportListAction = false;
                            ddList.selectItemByText(this._currentReportName);
                            this._isReportListAction = true;
                            return;
                        }
                        else {
                            this.currentReport = report.CurrentReport; this.reports = report.Reports; this.reportsCount = report.ReportsCount; columnElements = report.Columns;
                            rowElements = report.Rows; slicerElements = report.Slicers; action = report.CurrentAction; reportList = $.parseJSON(report.ReportList);
                            renamedReport = report.RenamedReport; chartSettings = $.parseJSON(report.ControlSettings); cubeTreeInfo = report.CubeTreeInfo; cubeSelector = report.CubeSelector; if (this.model.enableMeasureGroups) this.measureGroupInfo = $.parseJSON(report.MeasureGroups);
                            if (report.customObject != null && report.customObject != undefined)
                                this.model.customObject = report.customObject;
                        }
                    }
                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap)
                        this.model.chartType = chartSettings.ChartType.toLowerCase();

                    if (this.model.afterServiceInvoke != null)
                        this._trigger("afterServiceInvoke", { action: "toolbarOperation", element: this.element, customObject: this.model.customObject });
                    if (action != "Report Change") {
                        this.element.find(".reportlist").ejDropDownList("option", "change", "");
                        this.element.find(".reportlist").ejDropDownList("option", "dataSource", reportList);
                        if (action == "Load Report") {
                            this.ddlTarget._initValue = true;
                            this.ddlTarget.selectItemByText(cubeSelector);
                            this.ddlTarget._initValue = false;
                            this.reportDropTarget.selectItemByText(this.reportDropTarget.model.dataSource[0].name);
                            this._selectedReport = this.reportDropTarget.currentValue;
                            this.element.find(".searchDiv").remove();
                            if (this.model.enableMeasureGroups) {
                                this._createMeasureGroup();
                            }
                            var searchEditor = ej.buildTag("div.searchDiv", ej.buildTag("input#" + this._id + "_SearchTreeView.searchTreeView").attr("type", "text")[0].outerHTML, { "margin": "5px 5px 0px 0px" })[0].outerHTML;
                            var cubeName = $(this.element).find(".cubeName").html(cubeSelector + searchEditor);
                            $(this.element).find(".cubeBrowser").prepend(cubeName);
                            this.element.find("#" + this._id + "_SearchTreeView").ejMaskEdit({
                                name: "inputbox",
                                width: "100%",
                                inputMode: ej.InputMode.Text,
                                watermarkText: this._getLocalizedLabels("Search"),
                                maskFormat: "",
                                textAlign: this.model.enableRTL ? "right" : "left",
                                change: ej.proxy(ej.Pivot._searchTreeNodes, this),
                            });
                            var treeViewData = $.parseJSON(cubeTreeInfo);
                            this.element.find(".cubeTreeView").ejTreeView({
                                clientObj:this,
                                fields: { id: "id", parentId: "pid", text: "name", spriteCssClass: "spriteCssClass", dataSource: treeViewData },
                                allowDragAndDrop: true,
                                allowDropChild: false,
                                allowDropSibling: false,
                                enableRTL: this.model.enableRTL,
                                dragAndDropAcrossControl: true,
                                nodeDragStart: function () {
                                    this.model.clientObj.isDragging = true;
                                },
                                nodeDropped: ej.proxy(this._nodeDropped, this),
                                beforeDelete: function () {
                                    return false;
                                },
                                cssClass: 'pivotTreeViewDragedNode',
                                height: this.model.enableMeasureGroups ? "464px" : "495px"
                            });
                            var treeViewElements = this.element.find(".cubeTreeView").find("li");
                            for (var i = 0; i < treeViewElements.length; i++) {
                                treeViewElements[i].setAttribute("tag", treeViewData[i].tag);
                            }
                            var folders = this.element.find(".cubeTreeView .folderCDB");
                            for (var i = 0; i < folders.length; i++) {
                                $(folders[i].parentElement).removeClass("e-draggable");
                            }
                            folders = this.element.find(".cubeTreeViewCalcMember .folderCDB");
                            for (var i = 0; i < folders.length; i++) {
                                $(folders[i].parentElement).removeClass("e-draggable");
                            }
                            this._cubeTreeView = this.element.find('.cubeTreeView').data("ejTreeView");
                            if (this.model.isResponsive)
                                this.element.find(".cubeTreeView").height(this.element.find(".cubeBrowser").height() - (56 + (this.model.enableMeasureGroups ? 35 : 0)));
                            else
                                this.element.find(".cubeTreeView").height(this.element.find(".cubeBrowser").height() - (61 + (this.model.enableMeasureGroups ? 30 : 0)));
                        }
                        else if (action != "Rename Report") {
                            this._isReportListAction = false;
                            this.reportDropTarget.selectItemByText(this.reportDropTarget.model.dataSource[reportList.length - 1].name);
                            this._isReportListAction = true;
                            this._selectedReport = this.reportDropTarget.currentValue;
                        }
                        else {
                            if (this._excelFilterInfo.length > 0) {
                                var cubeName = this.element.find('.cubeSelector').data("ejDropDownList").model.value, reportName = this.element.find('#reportList').data("ejDropDownList").model.value;
                                this._excelFilterInfo = $.grep(this._excelFilterInfo, function (item, index) {
                                    if (item.cubeName == cubeName && item.report == this.reportDropTarget.model.itemValue) { item.report = renamedReport; }
                                    return item;
                                });
                            }
                            this._isReportListAction = false;
                            this.reportDropTarget.selectItemByText(renamedReport);
                            this._isReportListAction = true;
                            this._selectedReport = this.reportDropTarget.currentValue;
                        }
                        this.element.find(".reportlist").ejDropDownList("option", "change", ej.proxy(this._reportChanged, this));
                    }
                    if (action != "Rename Report")
                        if (this.model.enableDeferUpdate)
                            this.element.find(".splitBtn").remove();
                        else
                            this.element.find(".splitBtn, .e-pivotgrid, .e-pivotchart").remove();
                    if (action == "Add Report" || action == "New Report" || action == "Remove Report" || action == "Report Change" || action == "Load Report" || action == "SortOrFilter" || action == "Save Report") {
                        var treeViewData = $.parseJSON(cubeTreeInfo);
                        var calcMemGroup = ej.DataManager(treeViewData).executeLocal(ej.Query().where("spriteCssClass", "contains", "calcMemberGroupCDB"));
                        this._cubeTreeView.model.beforeDelete = null;
                        this._cubeTreeView.removeNode(this.element.find(".cubeTreeView .calcMemberGroupCDB").parents("li"));
                        this._cubeTreeView.model.beforeDelete = function () { return false };
                        if (!ej.isNullOrUndefined(this._calcMemberTreeObj))
                            this._calcMemberTreeObj.removeNode(this.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").parents("li"));
                        if (calcMemGroup.length > 0 && !ej.isNullOrUndefined(this._cubeTreeView)) {
                            this._calcMembers = [];
                            this._calcMembers.push(calcMemGroup);
                            $.merge(this._calcMembers, ej.DataManager(treeViewData).executeLocal(ej.Query().where("spriteCssClass", "contains", "calcMemberCDB")));
                            this._calcMemberTreeViewUpdate();
                        }
                    }
                    if (action == "Remove Report" || action == "Report Change" || action == "Load Report" || action == "SortOrFilter" || action == "Save Report") {
                        $(this._createSplitButtons(columnElements, "Columns")).appendTo(".categoricalAxis");
                        $(this._createSplitButtons(rowElements, "Rows")).appendTo(".rowAxis");
                        $(this._createSplitButtons(slicerElements, "Slicers")).appendTo(".slicerAxis");
                        this.element.find(".categoricalAxis, .rowAxis, .slicerAxis").find("button").ejButton({ height: "20px", type: ej.ButtonType.Button });
                        this._renderControls();
                    }
                    if (action == "Add Report" || action == "New Report") {
                       this._renderControls();
                    }
                }
            }
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode) {
            this._treeContextMenu();
            this._buttonContextMenu();
            }
            if (this.model.showUniqueNameOnPivotButton) {
                $(".pvtBtn").addClass("splitBtnUnique");
                $(".removeSplitBtn").addClass("removeBtnUnqiue");
            }
            this._setSplitBtnTitle();
            this._unWireEvents();
            this._wireEvents();
            this._isTimeOut = false;
            this._waitingPopup.hide();
            this._successAction = "ToolbarOperation";
            this._trigger("renderSuccess", this);
        },
        _calcMemberTreeViewUpdate: function () {
            this._cubeTreeView.model.beforeDelete = null;
            this._cubeTreeView.removeNode(this.element.find(".cubeTreeView .calcMemberGroupCDB").parents("li"));
            this._cubeTreeView.model.beforeDelete = function () { return false };
            if (!ej.isNullOrUndefined(this._calcMemberTreeObj))
                this._calcMemberTreeObj.removeNode(this.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").parents("li"));

            if (this.element.find(".cubeTreeView").find("li").first().length > 0) {
                this._cubeTreeView.insertBefore(this._calcMembers[0], this.element.find(".cubeTreeView").find("li").first());
                this._cubeTreeView.addNodes(ej.DataManager(this._calcMembers).executeLocal(ej.Query().skip(1)), this._calcMembers[0].id);
                this.element.find(".cubeTreeView").find("#" + this._calcMembers[0].id).find('> div > div:first').removeClass("e-process");
                this._cubeTreeView.collapseNode(this._calcMembers[0].id);
            }
            else if (this._calcMembers.length > 0) {
                this._cubeTreeView.addNodes(this._calcMembers[0]);
                this.element.find(".cubeTreeView").find("#" + this._calcMembers[0].id).find('> div > div:first').removeClass("e-process");
                this._cubeTreeView.addNodes(ej.DataManager(this._calcMembers).executeLocal(ej.Query().skip(1)), this._calcMembers[0].id);
            }
            if (!ej.isNullOrUndefined(this._calcMemberTreeObj) && this.element.find(".cubeTreeViewCalcMember").find("li").first().length > 0) {
                this._calcMemberTreeObj.insertBefore(this._calcMembers[0], this.element.find(".cubeTreeViewCalcMember").find("li").first());
                this._calcMemberTreeObj.addNodes(ej.DataManager(this._calcMembers).executeLocal(ej.Query().skip(1)), this._calcMembers[0].id);
                this.element.find(".cubeTreeViewCalcMember").find("#" + this._calcMembers[0].id).find('> div > div:first').removeClass("e-process");
                this._calcMemberTreeObj.collapseNode(this._calcMembers[0].id);
            }
            else if (!ej.isNullOrUndefined(this._calcMemberTreeObj) && this._calcMembers.length > 0) {
                this._calcMemberTreeObj.addNodes(this._calcMembers[0]);
                this.element.find(".cubeTreeViewCalcMember").find("#" + this._calcMembers[0].id).find('> div > div:first').removeClass("e-process");
                this._calcMemberTreeObj.addNodes(ej.DataManager(this._calcMembers).executeLocal(ej.Query().skip(1)), this._calcMembers[0].id);
            }

            if (this.element.find(".cubeTreeView .calcMemberGroupCDB").length > 0) {
                this.element.find(".cubeTreeView .calcMemberGroupCDB").parent().removeClass("e-draggable");
                this.element.find(".cubeTreeViewCalcMember .calcMemberGroupCDB").parent().removeClass("e-draggable");
                var calcItem = this.element.find(".cubeTreeView .calcMemberCDB").parents("li").find("li");
                var calcItemDialog = this.element.find(".cubeTreeViewCalcMember .calcMemberCDB").parents("li").find("li");
                if (calcItem.length > 0) {
                    for (var i = 0; i < calcItem.length; i++) {
                        calcItem[i].setAttribute("tag", this._calcMembers[i + 1].tag);
                        calcItem[i].setAttribute("expression", this._calcMembers[i + 1].expression);
                        calcItem[i].setAttribute("formatString", this._calcMembers[i + 1].formatString);
                        calcItem[i].setAttribute("nodeType", this._calcMembers[i + 1].nodeType);
                        if (calcItemDialog.length > 0) {
                            calcItemDialog[i].setAttribute("tag", this._calcMembers[i + 1].tag);
                            calcItemDialog[i].setAttribute("expression", this._calcMembers[i + 1].expression);
                            calcItemDialog[i].setAttribute("formatString", this._calcMembers[i + 1].formatString);
                            calcItemDialog[i].setAttribute("nodeType", this._calcMembers[i + 1].nodeType);
                        }
                    }
                }
            }
        },
        _fetchChildNodeSuccess: function (data) {
 
            var newDataSource; var parentNode;
            if (data.length > 1 && data[0] != undefined)
                newDataSource = JSON.parse(data[0].Value);
            else if (data.d != undefined)
                newDataSource = JSON.parse(data.d[0].Value);
            else
                newDataSource = JSON.parse(data.ChildNodes);
            if (data[0] != undefined) {
                if (data[2] != null && data[2] != undefined)
                    this.model.customObject = data[2].Value;
            }
            else if (data.d != undefined) {
                if (data.d[2] != null && data.d[2] != undefined)
                    this.model.customObject = data.d[2].Value;
            }
            else {
                if (data.customObject != null && data.customObject != undefined)
                    this.model.customObject = data.customObject;
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "memberExpanded", element: this.element, customObject: this.model.customObject });
            var mapper = { id: "id", parentId: "pid", hasChild: "hasChildren", text: "name", isChecked: "checkedStatus" };
            if ($(this.pNode).parents("li").length > 1)
                parentNode = $(this.pNode).parents("li").first();
            else
                parentNode = $(this.pNode).parents("li");
            $($(parentNode).find('input.nodecheckbox')[0]).ejCheckBox({ checked: false })

            if (newDataSource.length > 0 && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && this.model.enableMemberEditorPaging && !ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", newDataSource[0].pid)).length > 0)
                $.merge(this._editorTreeData, $.extend(true, [], newDataSource));

			this.element.find(".nodeExpand").remove();
            this._memberTreeObj.addNode(newDataSource, parentNode);
            $.each($(parentNode).children().find("li"), function (index, value) {
                value.setAttribute("tag", newDataSource[index].tag);
            });
            //this._memberTreeObj._expandCollapseAction(this.pNode);
            this._successAction = "FetchChildNode";
            this._trigger("renderSuccess", this);
			this.element.find(".e-dialog #preventDiv").remove();
        },

        _createCubeSelector: function () {
            return ej.buildTag("div.csHeader", ej.buildTag("span.cubeText", this._getLocalizedLabels("CubeSelector"), { "padding-left": "6px", "float": "left", "margin-bottom": "10px", "width": this.model.enableSplitter&&!this.model.isResponsive?"25%":"", "text-overflow": "ellipsis" })[0].outerHTML + ej.buildTag("div.cubeSelect", "<input type='text' id='cubeSelector' class ='cubeSelector' />", { display: "inline", "float": "left", "padding-left": "5px", "position": "relative", "top": "-3px", "width": this.model.enableSplitter&&!this.model.isResponsive?"70%":"" })[0].outerHTML, { width: (this.model.isResponsive || this.model.enableSplitter) ? "100%" : "", height: "20px" })[0].outerHTML;
        },

        _createCubeBrowser: function (cubeTreeInfo) {
            return ej.buildTag("div.cdbHeader", ej.buildTag("span", this._getLocalizedLabels("CubeDimensionBrowser"))[0].outerHTML, { width: (this.model.enableSplitter ? "100%" : ""), height: "30px" })[0].outerHTML + ej.buildTag("div.cubeBrowser", ej.buildTag("div.cubeTreeView.visibleHide")[0].outerHTML, { width: (this.model.enableSplitter ? "100%" : "") })[0].outerHTML;//, height: ((this.model.enablePaging) ? "" : (this.model.analysisMode == "olap" && this.model.operationalMode == "servermode") ? "" : "530px")
        },

        _createAxisElementBuilder: function (columnDimensions, rowDimensions, slicerDimensions) {
            if (!this.model.enableSplitter) {
                    var AEBPanel = ej.buildTag("div.axisHeader", ej.buildTag("span", this._getLocalizedLabels("Column"))[0].outerHTML, { height: "30px" })[0].outerHTML + ej.buildTag("div.categoricalAxis", ej.buildTag("p#categcol", "colum", { "display": "none" })[0].outerHTML + this._createSplitButtons(columnDimensions, "Columns"), { width: this.model.isResponsive ? "99%" : "" }).attr("aria-describedby", "categcol")[0].outerHTML +
                    ej.buildTag("div.axisHeader", ej.buildTag("span", this._getLocalizedLabels("Row"))[0].outerHTML, { height: "30px" })[0].outerHTML + ej.buildTag("div.rowAxis", ej.buildTag("p#categrow", "row", { "display": "none" })[0].outerHTML + this._createSplitButtons(rowDimensions, "Rows"), { width: this.model.isResponsive ? "99%" : "" }).attr("aria-describedby", "categrow")[0].outerHTML +
                    ej.buildTag("div.axisHeader", ej.buildTag("span", this._getLocalizedLabels("Slicer"))[0].outerHTML, { height: "30px" })[0].outerHTML + ej.buildTag("div.slicerAxis", ej.buildTag("p#sliceaxis", "slicer", { "display": "none" })[0].outerHTML + this._createSplitButtons(slicerDimensions, "Slicers"), { width: this.model.isResponsive ? "99%" : "" }).attr("aria-describedby", "sliceaxis")[0].outerHTML;            
                }
            else{
                var AEBPanel = ej.buildTag("div.axisHeader", ej.buildTag("span", this._getLocalizedLabels("Column"))[0].outerHTML, { height: "30px", width:"99%"})[0].outerHTML + ej.buildTag("div.categoricalAxis", ej.buildTag("p#categcol", "colum", { "display": "none" })[0].outerHTML + this._createSplitButtons(columnDimensions, "Columns"), { width: this.model.isResponsive || this.model.enableSplitter ? "99%" : "" }).attr("aria-describedby", "categcol")[0].outerHTML +
                  ej.buildTag("div.axisHeader", ej.buildTag("span", this._getLocalizedLabels("Row"))[0].outerHTML, { height: "30px", width: "99%" })[0].outerHTML + ej.buildTag("div.rowAxis", ej.buildTag("p#categrow", "row", { "display": "none" })[0].outerHTML + this._createSplitButtons(rowDimensions, "Rows"), { width: this.model.isResponsive || this.model.enableSplitter ? "99%" : "" }).attr("aria-describedby", "categrow")[0].outerHTML +
                  ej.buildTag("div.axisHeader", ej.buildTag("span", this._getLocalizedLabels("Slicer"))[0].outerHTML, { height: "30px", width: "99%" })[0].outerHTML + ej.buildTag("div.slicerAxis", ej.buildTag("p#sliceaxis", "slicer", { "display": "none" })[0].outerHTML + this._createSplitButtons(slicerDimensions, "Slicers"), { width: this.model.isResponsive || this.model.enableSplitter ? "99%" : "" }).attr("aria-describedby", "sliceaxis")[0].outerHTML;
            }
            return AEBPanel;
        },

        _createSplitButtons: function (dimensionElements, axis) {
            var splitButtons = '';
            var captionName = '';
            if (dimensionElements.indexOf("~") > -1)
                for (var i = 0; i < dimensionElements.split('~')[0].split('#').length - 1; i++) {
                    captionName = dimensionElements.split('~')[0].split('#')[i + 1].split('.')[0];
                    if (captionName == "Measures") {
                        captionName = this._getLocalizedLabels("Measures");
                    }
                    else if (captionName == "KPIs") {
                        captionName = this._getLocalizedLabels("KPIs");
                    }
                    else if (!(dimensionElements.startsWith("#Measure")))
                        captionName = dimensionElements.split('~')[i + 2];
                    else if ((dimensionElements.indexOf("#Measure")) > -1)
                        captionName = dimensionElements.split('~')[i + 1];
                    if (captionName == undefined)
                        captionName = dimensionElements.split('~')[i + 1];
                    splitButtons += ej.buildTag("div.splitBtn", ej.buildTag("button.pvtBtn", captionName).attr({ "title": dimensionElements.split('~')[0].split('#')[i + 1].replace('.', ' - ').split("$")[0], fieldCaption: captionName, allMember: dimensionElements.split('~')[0].split('#')[i + 1].replace('.', ' - ').split('$')[1] })[0].outerHTML + ej.buildTag("span.removeSplitBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML, "", { "tag": axis + ':' + dimensionElements.split('~')[0].split('#')[i + 1].split("$")[0] })[0].outerHTML;
                }
            else
                for (var i = 0; i < dimensionElements.split('#').length - 1; i++) {
                    var caption, splitBtnTitle;
                    if (dimensionElements.split('#')[i + 1].split("::")[1] == "CalculatedMember") {
                        splitBtnTitle = dimensionElements.split('#')[i + 1].split("::")[0];
                        caption = splitBtnTitle.split(".")[splitBtnTitle.split(".").length - 1];
                        splitBtnTitle = splitBtnTitle.replace('.', ' - ');
                    }
                    else {
                        caption = dimensionElements.split('#')[i + 1].split('.')[0] == "Measures" ? this._getLocalizedLabels("Measures") : dimensionElements.split('#')[i + 1].split('.')[0];
                        if (caption.split("::")[1] == "NAMEDSET") {
                            caption = caption.split("::")[0];
                        }
                        splitBtnTitle = dimensionElements.split('#')[i + 1].replace('.', ' - ').split("$")[0] == "Measures" ? this._getLocalizedLabels("Measures") : dimensionElements.split('#')[i + 1].replace('.', ' - ').split("$")[0];
                    }
                    if (this.model.enableRTL && splitBtnTitle.indexOf("-")>0) {
                        splitBtnTitle = splitBtnTitle.split("-").reverse().join(" - ");
                    }
                    splitButtons += ej.buildTag("div.splitBtn", ej.buildTag("button.pvtBtn", this.model.showUniqueNameOnPivotButton ? splitBtnTitle : caption).attr({ "title": splitBtnTitle, fieldCaption: caption, allMember: dimensionElements.split('#')[i + 1].split("$")[1] })[0].outerHTML + ej.buildTag("span.removeSplitBtn e-icon").attr("role", "button").attr("aria-label", "remove")[0].outerHTML, "", { "tag": axis + ':' + dimensionElements.split('#')[i + 1].split("$")[0] })[0].outerHTML;
                }
            return splitButtons;
        },

        _setSplitBtnTitle: function () {
            var pivotButtons = this.element.find(".splitBtn");
            for (var i = 0; i < pivotButtons.length; i++) {
                var tagValue = $(pivotButtons[i]).attr("tag").split(":")[1].split("."),
                uniqueName = "", orgName = "";
                for (var j = 0; j < tagValue.length; j++) {
                    if (tagValue[0].toUpperCase() != "[Measures]")
                        uniqueName += "[" + tagValue[j] + "]" + (j % 2 == 0 ? "." : "");
                    else
                        uniqueName += tagValue[j] + (j % 2 == 0 ? "." : "");
                }
                if (this.element.find(".cubeTreeView").length > 0 && !(uniqueName.indexOf("Measures") >= 0)) {
                    uniqueName = uniqueName.indexOf("<>") > 0 ? uniqueName.replace("<>", ".") : uniqueName;
                    var splBtnTitle = "", allMember = $(pivotButtons[i]).find("button").attr("allMember");
                    allMember = allMember != "All" ? allMember : this._getLocalizedLabels("All");
                    var liElementText = this.element.find(".cubeTreeView").find("li[tag='" + uniqueName + "'] a:eq(0)").text();
                    if (liElementText == "")
                        liElementText = this.element.find(".cubeTreeView").find("li[tag='" + "[" + tagValue[1] + "]" + "'] a:eq(0)").text();
                    if (liElementText.indexOf(".") > 0)
                        $(pivotButtons[i]).find("button").attr("title", (this.model.enableRTL ? liElementText.split(".").reverse().join(" - ") : liElementText.replace('.', ' - ')));
                    else {
                        splBtnTitle = $(pivotButtons[i]).find("button").attr("fieldCaption")==this._getLocalizedLabels("KPIs")?this._getLocalizedLabels("KPIs"):$(pivotButtons[i]).find("button").attr("fieldCaption") + " - " + (this.element.find(".cubeTreeView").find("li[tag='" + uniqueName + "'] a:eq(0)").text() || this.element.find(".cubeTreeView").find("li[tag='" + uniqueName.toUpperCase() + "'] a:eq(0)").text() || liElementText);
                        splBtnTitle = (this.model.enableRTL && splBtnTitle.indexOf("-")>0 ? splBtnTitle.split("-").reverse().join(" - ") : splBtnTitle);
                        $(pivotButtons[i]).find("button").attr("title", splBtnTitle);
                    }
                    if ($(pivotButtons[i]).attr("tag").split(":")[0] == "Slicers" && $(pivotButtons[i]).attr("tag").indexOf("::CalculatedMember") < 0) {
                        splBtnTitle = $(pivotButtons[i]).attr("tag").split(":")[1];
                        var filterState = (this._fieldSelectedMembers[splBtnTitle] == "All" ? allMember : this._fieldSelectedMembers[splBtnTitle]) || allMember;
                        $(pivotButtons[i]).find("button").text((this.model.showUniqueNameOnPivotButton ? $(pivotButtons[i]).find("button").parent().attr("tag").split(":")[1].replace(".", " - ") : $(pivotButtons[i]).find("button").attr("fieldCaption")) + " (" + filterState + ")");
                        $(pivotButtons[i]).find("button").attr("title", $(pivotButtons[i]).find("button").attr("title") + " (" + filterState + ")");
                    }
                }
            }
        },

        _controlPanel: function () {
            var controlTable; var gridDiv;
           if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid)
                        gridDiv = ej.buildTag("div#gridPanel.gridPanel", ej.buildTag("div.gridContainer", ej.buildTag("div#" + this._id + "_PivotGrid", "", { "margin": this.model.enableToolBar?"5px 0px 7px": "5px 7px 7px", "padding": "1px" })[0].outerHTML, { "position": "relative", "overflow": this.model.enableToolBar?"":"auto", "left": "5px", "top": "5px", "width": (this.model.isResponsive || this.model.enableSplitter) ? "100%" : "" })[0].outerHTML, { width: "auto", height: "auto" })[0].outerHTML;
                    else
                        gridDiv = ej.buildTag("div#gridPanel.gridPanel", ej.buildTag("div.gridContainer", ej.buildTag("div#" + this._id + "_PivotGrid", "", { "margin": this.model.enableToolBar ? "10px 0px 7px" : "10px 7px 7px", "padding": "1px", "width": (this.model.isResponsive && !this.model.enableSplitter) ? "auto" : (this.model.enableSplitter ? "100%" : "") })[0].outerHTML, { "position": "relative", "left": "7px", "border-top": "none", "margin-top": "-7px", "overflow": this.model.enableToolBar ? "" : "auto", "height": this.model.enablePaging ? "277px" : "", "width": this.model.isResponsive ? "100%" : "" })[0].outerHTML, { width: "auto", height: "auto" })[0].outerHTML;
                }
                else {
                    if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly)
                        gridDiv = ej.buildTag("div#gridPanel.gridPanel", ej.buildTag("div.gridContainer", ej.buildTag("div#" + this._id + "_PivotGrid", "", { "margin":this.model.enableToolBar ? "5px 0px 7px":"5px 7px 7px", "padding": "1px" })[0].outerHTML, { "overflow": this.model.enableToolBar?"":"auto", "position": "absolute", "left": "7px", "padding-top": "2px", "width": (this.model.isResponsive || this.model.enableSplitter) ? "100%" : "", "top": "3px" })[0].outerHTML, { width: "auto", height: "auto" })[0].outerHTML;
                    else
                        gridDiv = ej.buildTag("div#gridPanel.gridPanel", ej.buildTag("div.gridContainer", ej.buildTag("div#" + this._id + "_PivotGrid", "", { "margin": this.model.enableToolBar ? "5px 0px 7px" : "5px 7px 7px", "padding": "1px" })[0].outerHTML, { "overflow": this.model.enableToolBar ? "" : "auto", "position": "relative", "width": (this.model.isResponsive || this.model.enableSplitter) ? "100%" : "", "left": window.navigator.userAgent.indexOf('Trident') > 0 ? (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode ? (!this.model.enableRTL ? "0px" : "15px") : (this.model.enableRTL ? "5px" : "7px")) : (this.model.enableRTL ? "5px" : "7px"), "padding-top": "5px", "border-top": "none" })[0].outerHTML, { width: "100%", height: "auto" })[0].outerHTML;
                }
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                var chartDiv;
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Grid)
                        chartDiv = ej.buildTag("div#chartPanel.chartPanel", ej.buildTag("div.chartContainer", ej.buildTag("div#" + this._id + "_PivotChart", "", { "overflow": this.model.enableToolBar || this.model.isResponsive? "" : "auto", "border": this.model.enableToolBar ? "none" : "" })[0].outerHTML, { "position": "relative", "overflow": this.model.enableToolBar || this.model.enableSplitter ? "" : "auto", "left": "-2px", "padding": this.model.enableToolBar ? "5px 0px 5px 0px" : "5px 0px 5px 5px", "width": (this.model.isResponsive || this.model.enableSplitter) ? "98%" : "", "border-top": "none", "margin-right": "-11px" })[0].outerHTML, { width: "98%", height: "auto" })[0].outerHTML;
                    else
                        chartDiv = ej.buildTag("div#chartPanel.chartPanel", ej.buildTag("div.chartContainer", ej.buildTag("div#" + this._id + "_PivotChart", "", { "min-height": this.model.enablePaging ? "255px" : "", "border": this.model.enableToolBar ? "none" : "" })[0].outerHTML, { "position": "relative", "overflow": this.model.enableToolBar || this.model.enableSplitter|| this.model.isResponsive ? "" : "auto", "padding": this.model.enableToolBar ? "5px 0px 5px 0px" : "5px 0px 5px 5px", "width": (this.model.isResponsive || this.model.enableSplitter) ? "98%" : "" })[0].outerHTML, { width: "98%", height: "auto" })[0].outerHTML;
                }
                else {
                    if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly)
                        chartDiv = ej.buildTag("div#chartPanel.chartPanel", ej.buildTag("div.chartContainer", ej.buildTag("div#" + this._id + "_PivotChart", "", { "border": this.model.enableToolBar ? "none" : "" })[0].outerHTML, { "position": "relative", "overflow": this.model.enableToolBar || this.model.enableSplitter || this.model.isResponsive ? "" : "auto", "padding": this.model.enableRTL ? "5px 25px 2px 6px" : (this.model.enableToolBar ? "5px 0px 5px 0px" : "5px 0px 5px 5px"), "margin-right": this.model.enableRTL ? "1px" : "-11px" })[0].outerHTML, { width: "98%", height: "auto" })[0].outerHTML;
                    else
                        chartDiv = ej.buildTag("div#chartPanel.chartPanel", ej.buildTag("div.chartContainer", ej.buildTag("div#" + this._id + "_PivotChart", "", { "border": this.model.enableToolBar ? "none" : "" })[0].outerHTML, { "position": "relative", "overflow": this.model.enableToolBar || this.model.enableSplitter || this.model.isResponsive ? "" : "auto", "top": "-5px", "left": window.navigator.userAgent.indexOf('Trident') > 0 ? "-7px" : "0px", "padding": this.model.enableRTL ? "5px 5px 0px 5px" : (this.model.enableToolBar ? "5px 0px 5px 0px" : "5px 0px 5px 5px"), "border-top": "none", "margin-right": this.model.enableRTL ? "0px" : "-11px", "margin-left": this.model.enableRTL ? "-11px" : "0px" })[0].outerHTML, { width: this.model.enableSplitter ? "99%" : "98%", height: "auto" })[0].outerHTML;
                }
            }
            if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tab && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid) {
                var tabUl; var tabDiv;
                var gridAnchor = "<a style='font: bold 12px Segoe UI' href='#gridPanel' tabindex='0'>" + this._getLocalizedLabels("Grid") + "</a>";
                var chartAnchor = "<a style='font: bold 12px Segoe UI' href='#chartPanel' tabindex='0'>" + this._getLocalizedLabels("Chart") + "</a>";
                var marginLeft = window.navigator.userAgent.indexOf('Trident') > 0 ? (this.model.analysisMode==ej.Pivot.AnalysisMode.Olap && this.model.operationalMode==ej.Pivot.OperationalMode.ServerMode ? (!this.model.enableRTL ? "7px" : "15px"):(this.model.enableRTL?"5px":"7px")) : (this.model.enableRTL ? "5px" : "7px"), marginRight = 0;
                if (this.model.enableRTL) {
                    marginRight = "-" + marginLeft;
                    marginLeft = 0;
                }
                if (this.defaultView() == ej.PivotClient.DefaultView.Chart) {
                    tabUl = ej.buildTag("ul.clientTab", ej.buildTag("li", chartAnchor)[0].outerHTML + ej.buildTag("li", gridAnchor)[0].outerHTML, { "margin-left": marginLeft, "margin-right": marginRight })[0].outerHTML;
                    tabDiv = ej.buildTag("div#clientTab", tabUl + chartDiv + gridDiv)[0].outerHTML;
                }
                else {
                    tabUl = ej.buildTag("ul.clientTab", ej.buildTag("li", gridAnchor)[0].outerHTML + ej.buildTag("li", chartAnchor)[0].outerHTML, { "margin-left": marginLeft, "margin-right": marginRight  })[0].outerHTML;
                    tabDiv = ej.buildTag("div#clientTab", tabUl + gridDiv + chartDiv, { "height": "100%" })[0].outerHTML;
                }
                controlTable = tabDiv;
            }
            else {
                controlTable = this._createControlContainer(this.controlPlacement(), chartDiv, gridDiv);
            }

            return ej.buildTag("div.controlPanel", controlTable, { width: this.model.isResponsive ? "100%" : this.model.displaySettings.controlPlacement == "tab" ? ((this.model.analysisMode == "olap" && this.model.operationalMode == "servermode") || !this.model.enableSplitter) ? "" : "100%" : "auto", "top": this.model.displaySettings.mode == ej.PivotClient.DisplayMode.GridOnly ? "3px" : "none", "margin-bottom": ((this.model.displaySettings.controlPlacement == ej.PivotClient.ControlPlacement.Tile && (this.model.enablePaging || this.model.enableVirtualScrolling)) ? "5px" : "0") })[0].outerHTML + (this.model.enablePaging ? ej.buildTag("div#" + this._id + "_Pager")[0].outerHTML : this.model.enableVirtualScrolling ? ej.buildTag("div#hsVirtualScrolling.hsVirtualScrolling", ej.buildTag("div.hScrollPanel")[0].outerHTML, { width: "10px" })[0].outerHTML : "");
        },

        _createControlContainer: function (controlPlacement, chartDiv, gridDiv) {
            var controlTable;
            if (this.displayMode() == ej.PivotClient.DisplayMode.ChartOnly)
                controlTable = "<table style='width:100%'><tr><td>" + chartDiv + "</td></tr></table>";
            else if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly)
                controlTable = "<table style='width:100%'><tr><td>" + gridDiv + "</td></tr></table>";
            else {
                if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile) {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Chart)
                        controlTable = "<table style='width:100%'><tr><td>" + chartDiv + "</td></tr><tr><td>" + gridDiv + "</td></tr></table>";
                    else
                        controlTable = "<table style='width:100%'><tr><td>" + gridDiv + "</td></tr><tr><td>" + chartDiv + "</td></tr></table>";
                }
                else {
                    if (this.defaultView() == ej.PivotClient.DefaultView.Chart)
                        controlTable = "<table style='width:100%'><tr><td valign='top'>" + chartDiv + "</td><td valign='top'>" + gridDiv + "</td></tr></table>";
                    else
                        controlTable = "<table style='width:100%'><tr><td valign='top'>" + gridDiv + "</td><td valign='top'>" + chartDiv + "</td></tr></table>";
                }
            }
            return controlTable;
        },

        _renderPivotGrid: function (tagInfo) {
            tagInfo = ej.isNullOrUndefined(tagInfo) ? "" : tagInfo;
            this.element.find(".e-dialog").hide();
            if (this.displayMode() != ej.PivotClient.DisplayMode.ChartOnly) {
                var gridDiv;
                if (this._pivotChart != undefined && this._pivotChart._startDrilldown) {
                    var report;
                    try {
                        report = JSON.parse(this._pivotGrid.getOlapReport()).Report;
                    }
                    catch (err) {
                        report = this._pivotGrid.getOlapReport();
                    }
                    this._pivotGrid.doAjaxPost("POST", this.model.url + "/" + this._pivotGrid.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillDownGrid", "cellPosition": "", "currentReport": report, "clientReports": this.reports, "headerInfo": tagInfo, layout: this.gridLayout(), enableRTL: this.model.enableRTL }), this._pivotGrid._drillDownSuccess);
                }
                else {
                    if (!this.model.enableDeferUpdate) {
                        this.element.find(".e-pivotgrid, #" + this._id + "_PivotGrid").remove();
                        if (this.controlPlacement() == ej.PivotClient.ControlPlacement.Tile && this.displayMode() == ej.PivotClient.DisplayMode.ChartAndGrid)
                            gridDiv = ej.buildTag("div#" + this._id + "_PivotGrid", "", { "margin": this.model.enableToolBar ? "5px 0px 7px" : "5px 7px 7px", "width": this.model.isResponsive ? "auto" : " ", "padding": "1px" })[0].outerHTML;
                        else
                            gridDiv = ej.buildTag("div#" + this._id + "_PivotGrid", "", { "margin": this.model.enableToolBar?"5px 0px 7px":"5px 7px 7px", "padding": "1px" })[0].outerHTML;
                        $(gridDiv).appendTo(this.element.find(".gridContainer"));
                        if (this.gridLayout() != ej.PivotGrid.Layout.Normal)
                            this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ url: this.model.url, customObject: this.model.customObject, enableRTL: this.model.enableRTL, isResponsive: this.model.isResponsive, currentReport: this.currentReport, locale: this.locale(), layout: this.gridLayout(), drillSuccess: ej.proxy(this._gridDrillSuccess, this) });
                        else
                            this.element.find("#" + this._id + "_PivotGrid").ejPivotGrid({ url: this.model.url, customObject: this.model.customObject, enableRTL: this.model.enableRTL, isResponsive: this.model.isResponsive, currentReport: this.currentReport, locale: this.locale(), drillSuccess: ej.proxy(this._gridDrillSuccess, this) });
                        this._pivotGrid = this.element.find("#" + this._id + "_PivotGrid").data("ejPivotGrid");
                    }
                    else {
                        this._isTimeOut = false;
                        this._waitingPopup.hide();
                    }
                }
            }
        },

        _renderPivotChart: function (drillTag, drillAction) {

            this.element.find(".e-dialog").hide();
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                if (this._pivotGrid != undefined && this._pivotGrid._startDrilldown) {
                    var report = this._pivotChart.getOlapReport();
                    this._pivotChart.doAjaxPost("POST", this.model.url + "/" + this._pivotChart.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this._pivotChart.model.enableMultiLevelLabels ? (drillAction + "#fullchart") : drillAction, "drilledSeries": drillTag, "olapReport": report, "clientReports": this.reports }), this._pivotChart.renderControlSuccess);
                }
                else {
                    if (!this.model.enableDeferUpdate) {
                        this.element.find(".e-pivotchart").remove();
                        var chartDiv = ej.buildTag("div#" + this._id + "_PivotChart", "", {"height": "auto" })[0].outerHTML;
                        if (this.element.find(".chartContainer").children().length == 0)
                            $(chartDiv).appendTo(this.element.find(".chartContainer"));
                        this.element.find("#" + this._id + "_PivotChart").ejPivotChart({ url: this.model.url, customObject: this.model.customObject, enableRTL: this.model.enableRTL, canResize: this.model.isResponsive, currentReport: this.currentReport, customObject: this.model.customObject, locale: this.locale(), showTooltip: true, size: { height: this._chartHeight, width: this._chartWidth }, commonSeriesOptions: { type: this.model.chartType, tooltip: { visible: true } }, beforeServiceInvoke: this.model.chartLoad, drillSuccess: ej.proxy(this._chartDrillSuccess, this) });
                        this._pivotChart = this.element.find('#' + this._id + '_PivotChart').data("ejPivotChart");
                        this.element.find('#' + this._id + '_PivotChart').width(this._pivotChart.model.size.width);
                    }
                    else {
                        this._isTimeOut = false;
                        this._waitingPopup.hide();
                    }
                }
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly)
            if (this._toggleExpand && !this.model.isResponsive && (this.chartObj.sfType.split(".")).pop().toLowerCase() != "treemap") {
                this.element.find(".toggleExpandButton").click();
            }
        },

        _renderPivotTreeMap: function (drillTag, currentAction) {
            this.element.find(".e-dialog").hide();
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                if (this._pivotGrid != undefined && this._pivotGrid._startDrilldown) {
                    var report = this.otreemapObj.getOlapReport();
                    this.otreemapObj.doAjaxPost("POST", this.model.url + "/" + this.otreemapObj.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": currentAction, "drillInfo": drillTag, "olapReport": report, "clientReports": this.reports }), this.otreemapObj.renderControlSuccess);
                    if (!ej.isNullOrUndefined(this.chartObj)) {
                        if (this.model.displaySettings.enableFullScreen || this.enableTogglePanel() && (this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                            $("#" + this.otreemapObj._id + "TreeMapContainer").css({ width: "100%" });
                            this.otreemapObj._treeMap.refresh();
                        }
                    }
                }
                else {
                    if (!this.model.enableDeferUpdate) {
                        this.element.find(".e-pivottreemap").remove();
                        var chartDiv = ej.buildTag("div#" + this._id + "_PivotChart", "", {"height": "auto" })[0].outerHTML;
                        if (this.element.find(".chartContainer").children().length == 0)
                            $(chartDiv).appendTo(this.element.find(".chartContainer"));
                        this.element.find("#" + this._id + "_PivotChart").ejPivotTreeMap({ url: this.model.url, customObject: this.model.customObject, canResize: this.model.isResponsive, currentReport: this.currentReport, customObject: this.model.customObject, locale: this.locale(), size: { height: this._chartHeight, width: this._chartWidth }, beforeServiceInvoke: this.model.treeMapLoad, drillSuccess: ej.proxy(this._treemapDrillSuccess, this) });
                        this.otreemapObj = this.element.find('#' + this._id + '_PivotChart').data("ejPivotTreeMap");
                        this.element.find('#' + this._id + '_PivotChart').width(this.otreemapObj.model.size.width);
                    }
                    else {
                        this._isTimeOut = false;
                        this._waitingPopup.hide();
                    }
                }
            }
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly)
            if (this._toggleExpand && !this.model.isResponsive && (this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                this.element.find(".toggleExpandButton").click();
            }
        },
        _renderControls: function () {
            if ((this._isNodeOrButtonDropped && ej.isNullOrUndefined(this.chartObj) || this._isrenderTreeMap) && this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this._isNodeOrButtonDropped = false;
                this._isrenderTreeMap = false;
                this.chartObj = null;
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (ej.isNullOrUndefined(this.chartObj) && !ej.isNullOrUndefined(this.otreemapObj))
                    this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
            }
            if (this.displayMode() == ej.PivotClient.DisplayMode.GridOnly) {
                if (this.defaultView() == ej.PivotClient.DefaultView.Chart) {
                    this._renderPivotChart();
                    this._renderPivotGrid();
                }
                else {
                    this._renderPivotGrid();
                    this._renderPivotChart();
                }
            }
            else {
                if (this.defaultView() == ej.PivotClient.DefaultView.Chart) {
                    if (!ej.isNullOrUndefined(this.chartObj)) {
                        if ((this.chartObj.sfType.split(".")).pop().toLowerCase() != "treemap")
                            this._renderPivotChart();
                        else
                            if (this.model.enablePivotTreeMap)
                                this._renderPivotTreeMap()
                    }
                    else {
                        if (this.element.find("#" + this._pivotChart._id + "Container").length > 0)
                            this._renderPivotChart();
                        else
                            if (this.model.enablePivotTreeMap)
                                this._renderPivotTreeMap()
                    }
                    this._renderPivotGrid();
                }
                else {
                    this._renderPivotGrid();
                    if (!ej.isNullOrUndefined(this.chartObj)) {
                        if ((this.chartObj.sfType.split(".")).pop().toLowerCase() != "treemap")
                            this._renderPivotChart();
                        else
                            if (this.model.enablePivotTreeMap)
                                this._renderPivotTreeMap();
                    }
                    else {
                        if (this.element.find("#" + this._pivotChart._id + "Container").length > 0)
                            this._renderPivotChart();
                        else
                            if (this.model.enablePivotTreeMap)
                                this._renderPivotTreeMap();
                    }
                }
            }
        },

        _createDialogRequest: function (evt) {
            if (evt.target.className.indexOf("dialogOKBtn") >= 0)
                return;
            if ((evt.target.type == "button" && $(evt.target).parent().attr("tag").indexOf("::CalculatedMember") > -1))
            {
                this._selectedCalcMember = $(evt.target).parent().text();
                if (this.element.find(".calcMemberDialog").length > 0) {
                    this._calcMemberTreeObj.collapseAll();
                    ej.Pivot.closePreventPanel(this);
                    this._calcMemberDialog.open();
                    var calcMember = ej.DataManager(this._calcMembers).executeLocal(ej.Query().where("name", "equal", this._selectedCalcMember));
                    if(calcMember.length>0)
                    {
                        this.element.find("#" + this._id + "_captionFieldCM").val(calcMember[0].name);
                        this.element.find("#" + this._id + "_expressionFieldCM").val(calcMember[0].expression);
                        this.element.find("#" + this._id + "_memberTypeFieldCM").data("ejDropDownList").selectItemsByIndices(calcMember[0].nodeType);
                        if (calcMember[0].nodeType == 1) {
                            var dimensionName = calcMember[0].tag.split(".")[0].replace(/\[/g, "").replace(/\]/g, "");
                            var dimensionFieldLen=this.element.find("#" + this._id + "_dimensionFieldCM").data("ejDropDownList").model.dataSource;
                            for(var i=0;i<dimensionFieldLen.length;i++)
                            {
                                if (dimensionFieldLen[i].value == dimensionName)
                                    this.element.find("#" + this._id + "_dimensionFieldCM").data("ejDropDownList").selectItemsByIndices(i);
                            }
                        }
                        if(!ej.isNullOrUndefined(calcMember[0].formatString))
                        {
                            if(calcMember[0].formatString=="Currency")
                                this.element.find("#" + this._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(1);
                            else if(calcMember[0].formatString=="Percent")
                                this.element.find("#" + this._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(2);
                            else {
                                this.element.find("#" + this._id + "_formatFieldCM").data("ejDropDownList").selectItemsByIndices(2);
                                this.element.find("#" + this._id + "_customFormatFieldCM").val(calcMember[0].formatString)
                            }
                        }
                    }
                }
                else {
                    this._waitingPopup.show();
                    if (this.model.beforeServiceInvoke != null)
                        this._trigger("beforeServiceInvoke", { action: "fetchCalcMemberTreeView", element: this.element, customObject: this.model.customObject });
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.fetchMemberTreeNodes, JSON.stringify({ "action": "fetchCalcMemberTreeView", "dimensionName": "calcMember", "olapReport": this.currentReport, "customObject": serializedCustomObject }), ej.proxy(ej.Pivot._createCalcMemberDialog, this));
                }
                return;
            }
            if (this.model.enableMemberEditorPaging) {
                this._memberPageSettings.startPage = 0;
                this._memberPageSettings.currentMemeberPage = 1;
                this._selectedFieldName = $(evt.target).parent().attr("tag");
                this._memberPageSettings.filterReportCollection = {};
            }
            var pivotClientObj = this;
            args_className = evt.target.className;
            args_innerHTML = (evt.target.innerHTML == "" ? "ToolbarButtons" : evt.target.innerHTML);
            this._dialogTitle = hierarchyCaption = (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8) ? $(evt.currentTarget)[0].title : (evt.currentTarget.attributes == "" ? "" : ($(evt.currentTarget).attr("title")) || $(evt.currentTarget).attr("aria-label"));
            this._currentItem = hierarchyCaption;
            this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
            if (args_innerHTML != "ToolbarButtons" && args_innerHTML != undefined && this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                if ($(evt.target).parent().attr("tag").indexOf(":") >= 0 && $(evt.target).parent().attr("tag").split(":")[1].indexOf(".") >= 0) {
                    var btnUniqueName = $(evt.target).parent().attr("tag").split(":")[1].split(".");
                    var liElement = this.element.find(".cubeTreeView li[tag^='[" + btnUniqueName[0] + "'][tag$='" + btnUniqueName[1] + "]']");
                    if (liElement.length > 0) {
                        for (var i = 0; i < liElement.length; i++) {
                            if ($(liElement[i]).attr("tag").split("].").length == 2) {
                                this._selectedFieldName = $(liElement[i]).attr("tag");
                                break;
                            }
                        }
                    }
                    else
                        this._selectedFieldName = liElement.attr("tag");
                }
                else
                    this._selectedFieldName = "";
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "fetchMemberTreeNodes", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.fetchMemberTreeNodes, JSON.stringify({ "action": "fetchMemberTreeNodes", "dimensionName": $(evt.target).parent().attr("Tag"), "olapReport": this.currentReport, "customObject": serializedCustomObject }), this._editorTreeInfoSuccess);
            }
            else {
                    this._createDialog(args_className, args_innerHTML, "");
            }
        },

        _fetchReportListSuccess: function (reportNameList) {

            var action = "";
            if (reportNameList[0] != undefined) {
                if (reportNameList[2] != null && reportNameList[2] != undefined)
                    this.model.customObject = reportNameList[2].Value;
            }
            else if (reportNameList.d != undefined) {
                if (reportNameList.d[2] != null && reportNameList.d[2] != undefined)
                    this.model.customObject = reportNameList.d[2].Value;
            }
            else {
                if (reportNameList.customObject != null && reportNameList.customObject != undefined)
                    this.model.customObject = reportNameList.customObject;
            }
            if (this.model.afterServiceInvoke != null)
                this._trigger("afterServiceInvoke", { action: "fetchReportList", element: this.element, customObject: this.model.customObject, reports: reportNameList });
            this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
            if (reportNameList[0] != undefined) {
                action = !ej.isNullOrUndefined(reportNameList[1].Value) ? reportNameList[1].Value : "";
                reportNameList = !ej.isNullOrUndefined(reportNameList[0].Value) ? reportNameList[0].Value : "";
            }
            else if (reportNameList.d != undefined) {
                action = !ej.isNullOrUndefined(reportNameList.d[1].Value) ? reportNameList.d[1].Value : "";
                reportNameList = !ej.isNullOrUndefined(reportNameList.d[0].Value) ? reportNameList.d[0].Value : "";
            }
            else {
                action = reportNameList.action;
                reportNameList = reportNameList.ReportNameList;
            }
            if (reportNameList == "") {
                ej.Pivot._createErrorDialog(this._getLocalizedLabels("NoReports"), "Error", this);
                this._isTimeOut = false;
            }
            else
                this._createDialog(action, reportNameList, "");
        },

        _fetchSortState: function (value) {
            this._isTimeOut = false;
            this._waitingPopup.hide();
            if (value[0] != undefined) {
                this._createDialog("SortFilterDlg", value[0].Value, "");
            }
            else if (value.d != undefined) {
                this._createDialog("SortFilterDlg", value.d[0].Value, "");
            }
            else {
                this._createDialog("SortFilterDlg", value.FetchSortState, "");
            }
        },

        _createDialog: function (args_className, args_innerHTML, editorTree) {
            var isSlicerAxis = false;
            ej.Pivot.openPreventPanel(this);
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ServerMode && (args_className == "SortFilterDlg" || args_className == "mdx")) {
                var pivotButtons, measureCnt, dimCntRw, dimCntCol;
                pivotButtons = this.element.find(".splitBtn");
                measureCnt = jQuery.grep(pivotButtons, function (button) { return ($(button).attr("tag").split(":")[1] == "Measures"); }).length;
                dimCntRw = jQuery.grep(pivotButtons, function (button) { return (($(button).attr("tag").split(":")[1] != "Measures") && ($(button).attr("tag").split(":")[0] == "Rows")); }).length;
                dimCntCol = jQuery.grep(pivotButtons, function (button) { return (($(button).attr("tag").split(":")[1] != "Measures") && ($(button).attr("tag").split(":")[0] == "Columns")); }).length;
                if (args_className == "mdx" && measureCnt == 0 && dimCntCol == 0) {
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("MDXAlertMsg"), "Error", this);
                    return false;
                }

                if (measureCnt > 0 && this.element.find(".categoricalAxis ")[0].childElementCount != 0) {
                    if ((!dimCntRw) && (document.activeElement.className.indexOf("rowSortFilterImg") > -1)) {
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("FilterSortRowAlertMsg"), "Error", this);
                        return false;
                    }
                    else if ((!dimCntCol) && (document.activeElement.className.indexOf("colSortFilterImg") > -1)) {
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("FilterSortColumnAlertMsg"), "Error", this);
                        return false;
                    }
                }
                else if (args_className != "mdx") {
                    if (!measureCnt && this._axis == "Column")
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("FilterSortcolMeasureAlertMsg"), "Error", this);
                    else if (!measureCnt && this._axis == "Row")
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("FilterSortrowMeasureAlertMsg"), "Error", this);
                    else if (!($(".categoricalAxis ")[0].childElementCount))
                        ej.Pivot._createErrorDialog(this._getLocalizedLabels("FilterSortElementAlertMsg"), "Error", this);
                    return false;
                    }   
                }
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap && !ej.isNullOrUndefined(this._selectedFieldName))
                   isSlicerAxis=this.element.find(".pvtBtn").parent("[tag='Slicers:" + this._selectedFieldName.replace(/\[/g, "").replace(/\]/g, "") + "']").length>0;
                var sortDlgField = "", sortState = "", filterState = "", levelInfo = [], editorTreeInfo;
                if (editorTree[0] != undefined)
                    editorTreeInfo = editorTree[0].Value;
                else if (editorTree.d != undefined)
                    editorTreeInfo = editorTree.d[0].Value;
                else
                    editorTreeInfo = editorTree.EditorTreeInfo;
                var ejDialog = ej.buildTag("div#" + (this.model.enableAdvancedFilter?"clientDialog" : (this._id + "_ClientDialog"))+".clientDialog", { "opacity": "1" })[0].outerHTML;
                var dialogContent; var dialogTitle; var currentTag; var searchText, editorNavPanel;

                if (args_className.split(" ")[0] == "newReportImg") {
                    dialogTitle = this._getLocalizedLabels("NewReport");
                    currentTag = "New Report";
                    var newReportLabel = "<p class='dialogPara'>" + this._getLocalizedLabels("ReportName") + "</p>";
                    var newReport = "<input type=text id=reportName class='reportName'/></br>";
                    dialogContent = ej.buildTag("div#" + this._id + "_ReportDlg.reportDlg", "<table><tr><td>" + newReportLabel + "</td><td>" + newReport + "</td></tr></table>")[0].outerHTML;
                }
                else if (args_className.split(" ")[0] == "addReportImg") {
                    dialogTitle = this._getLocalizedLabels("AddReport");
                    currentTag = "Add Report";
                    var addReportLabel = "<p class='dialogPara'>" + this._getLocalizedLabels("ReportName") + "</p>";
                    var addReport = "<input type=text id=reportName class='reportName'/></br>";
                    dialogContent = ej.buildTag("div#" + this._id + "_ReportDlg.reportDlg", "<table><tr><td>" + addReportLabel + "</td><td>" + addReport + "</td></tr></table>")[0].outerHTML;
                }
                else if (args_className.split(" ")[0] == "removeReportImg") {
                    dialogTitle = this._getLocalizedLabels("RemoveReport");
                    currentTag = "Remove Report";
                    if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode || this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot)
                        this.reportsCount = this._clientReportCollection.length;
                    if (this.reportsCount > 1)
                        dialogContent = "<p>" + this._getLocalizedLabels("AreYouSureToDeleteTheReport") + "?</p>";
                    else
                        dialogContent = "<p>" + this._getLocalizedLabels("CannotRemoveSingleReport") + "!</p>";
                }
                else if (args_className.split(" ")[0] == "SortFilterDlg") {

                    sortDlgField = args_innerHTML.split("||");
                    if (sortDlgField[1] != "")
                        sortState = sortDlgField[1].split("<<");
                    if (sortDlgField[2] != "")
                        filterState = sortDlgField[2].split("<<");
                    this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog), .clientDialog").remove();
                    dialogTitle = this._getLocalizedLabels("SortingAndFiltering");

                    var sortingLbl = ej.buildTag("label#sortingLbl.sortingLbl", this._getLocalizedLabels("Sorting"))[0].outerHTML;
                    var measureListLbl = ej.buildTag("label#measureListLbl.measureListLbl", this._getLocalizedLabels("Measure"))[0].outerHTML;
                    var orderLbl = ej.buildTag("label#orderLbl.orderLbl", this._getLocalizedLabels("Order"))[0].outerHTML;
                    var measureListDropDown = ej.buildTag("input#measuresList.measuresList", "", {}, { type: 'text', accesskey: 'M' })[0].outerHTML;

                    var sortDisableRadio = ej.buildTag("input#sortDisable.sortDisable", "", {}, { name: "sort", type: "radio", checked: 'checked', role: 'radio', tabindex: 0, accesskey: 'i' })[0].outerHTML + ej.buildTag("label.sortDisableLbl", this._getLocalizedLabels("Disable"))[0].outerHTML;
                    var sortEnableRadio = ej.buildTag("input#sortEnable.sortEnable", "", {}, { name: 'sort', type: 'radio', role: 'radio', tabindex: 1, accesskey: 'n' })[0].outerHTML + ej.buildTag("label.sortEnableLbl", this._getLocalizedLabels("Enable"))[0].outerHTML + "<br/>";
                    var newascRadio = ej.buildTag("input#radioBtnAsc.radioBtnAsc", "", {}, { name: 'order', type: 'radio', checked: 'checked', role: 'radio', tabindex: 0, accesskey: 'A' })[0].outerHTML + ej.buildTag("label.radioBtnAscLbl", this._getLocalizedLabels("Ascending"))[0].outerHTML + "<br/>";
                    var newdescRadio = ej.buildTag("input#radioBtnDesc.radioBtnDesc", "", {}, { name: 'order', type: 'radio', role: 'radio', tabindex: 2, accesskey: 'e' })[0].outerHTML + ej.buildTag("label.radioBtnDescLbl", this._getLocalizedLabels("Descending"))[0].outerHTML;
                    var preservHierarchy = ej.buildTag("input#preserveHrchy.preserveHrchy", "", {}, { type: 'checkbox', checked: 'checked', tabindex: 0, role: 'radio', accesskey: 'r' })[0].outerHTML + ej.buildTag("label.preserveHrchyLbl", this._getLocalizedLabels("PreserveHierarchy"))[0].outerHTML;

                    var filter = ej.buildTag("label#filterLbl.filterLbl", this._getLocalizedLabels("Filtering"))[0].outerHTML;
                    var filterDisableRadio = ej.buildTag("input#filterDisable.filterDisable", "", {}, { name: 'filter', type: 'radio', checked: 'checked', role: 'radio', tabindex: 0, accesskey: 'i' })[0].outerHTML + ej.buildTag("label.filterDisableLbl", this._getLocalizedLabels("Disable"))[0].outerHTML;
                    var filterEnableRadio = ej.buildTag("input#filterEnable.filterEnable", "", {}, { name: 'filter', type: 'radio', role: 'radio', tabindex: 0, accesskey: 'n' })[0].outerHTML + ej.buildTag("label.filterDisableLbl", this._getLocalizedLabels("Enable"))[0].outerHTML + "<br/>";
                    var conditionLbl = ej.buildTag("label#conditionLbl.conditionLbl", this._getLocalizedLabels("Condition"))[0].outerHTML;
                    var conditionDropDown = ej.buildTag("input#filterCondition.filterCondition", "", {}, { type: 'text', tabindex: 0, accesskey: 'o' })[0].outerHTML;

                    var filterFrom = ej.buildTag("div#filterfrom.filterFrmDiv", ej.buildTag("input#filterFrom.filterFrom" + (ej.isMobile() ? " inputConditionMbl" : ""), "", {}, { name: 'inputVal', type: ej.isMobile() ? 'number' : 'text', inputmode: ej.isMobile() ? 'numeric' : '', pattern: ej.isMobile() ? '[0-9]*' : '', tabindex: 0 })[0].outerHTML)[0].outerHTML;
                    var filterbtw = ej.buildTag("div#filterbtw.filterBtw", "<p>" + this._getLocalizedLabels("and") + "</p>")[0].outerHTML;
                    var filterTo = ej.buildTag("div#filterto.filterToDiv", ej.buildTag("input#filterTo.filterTo" + (ej.isMobile() ? " inputConditionMbl" : ""), "", {}, { name: 'inputVal', type: ej.isMobile() ? 'number' : 'text', inputmode: ej.isMobile() ? 'numeric' : '', pattern: ej.isMobile() ? '[0-9]*' : '', tabindex: 0, accesskey: 'd' })[0].outerHTML)[0].outerHTML;
                    var fMeasureListLbl = ej.buildTag("label#filterMeasureListLbl.filterMeasureListLbl", this._getLocalizedLabels("Measure"))[0].outerHTML;
                    var fMeasureList = ej.buildTag("input#fMeasuresList.fMeasuresList", "", {}, { type: 'text', tabindex: 0, accesskey: 'M' })[0].outerHTML;
                    var fValueLbl = ej.buildTag("label#filterValueLbl.filterValueLbl", this._getLocalizedLabels("Value"), {}, { tabindex: 0, accesskey: 'a' })[0].outerHTML;

                    var sortDiv = ej.buildTag("div#sortingDlg.sortingDlg", "<table class='sortReportTbl'><tr><td style='vertical-align:top;'>" + sortingLbl + "</td><td>" + sortEnableRadio + sortDisableRadio + "</td></tr><tr><td>" + measureListLbl + "</td><td>" + measureListDropDown + "</td></tr> <tr><td>" + orderLbl + "</td><td>" + newascRadio + newdescRadio + "</td></tr><tr><td></td><td>" + preservHierarchy + "</td></tr></table>")[0].outerHTML;
                    var filterDiv = ej.buildTag("div#filteringDlg.filteringDlg", "<table class='sortReportTbl'><tr><td>" + filter + "</td><td>" + filterEnableRadio + filterDisableRadio + "</td></tr><tr><td>" + fMeasureListLbl + "</td><td>" + fMeasureList + "</td></tr><tr><td>" + conditionLbl + "</td><td>" + conditionDropDown + "</td></tr><tr><td>" + fValueLbl + "</td><td>" + filterFrom + filterbtw + filterTo + "</td></tr></table>")[0].outerHTML;

                    var sortTab = "<li><a style='font: bold 12px Segoe UI' href='#sortingDlg'>" + this._getLocalizedLabels("Sorting") + "</a></li>";
                    var filterTab = "<li><a style='font: bold 12px Segoe UI' href='#filteringDlg'>" + this._getLocalizedLabels("Filtering") + "</a></li>";
                    var sortfilterTab = ej.buildTag("div#sortfilterTab.sortfilterTab", "<ul class ='sortfiltTab'>" + (sortTab + filterTab + "</ul>" + sortDiv + filterDiv ))[0].outerHTML;

                    dialogContent = sortfilterTab;
                }
                else if (args_className.split(" ")[0] == "renameReportImg") {
                    dialogTitle = this._getLocalizedLabels("RenameReport");
                    currentTag = "Rename Report";
                    var currentReportName = !ej.isNullOrUndefined(this._currentReportName) ? this._currentReportName : this.element.find(".reportlist").val();
                    var renameReportLabel = "<p class='dialogPara'>" + this._getLocalizedLabels("ReportName") + "</p>";
                    renameReport = "<input type=text id=reportName class='reportName' value='" + currentReportName + "' /></br>";
                    dialogContent = ej.buildTag("div#" + this._id + "_ReportDlg.reportDlg", "<table><tr><td>" + renameReportLabel + "</td><td>" + renameReport + "</td></tr></table>")[0].outerHTML;
                }
                else if (args_className.split(" ")[0] == "saveAsReportImg" || args_className.split(" ")[0] == "saveReportImg") {
                    dialogTitle = args_className.split(" ")[0] == "saveAsReportImg" ? this._getLocalizedLabels("SaveAs") : this._getLocalizedLabels("Save");
                    currentTag = "SaveAs Report";
                    var recordNameLabel = "<p class='dialogPara'>" + this._getLocalizedLabels("ReportName") + "</p>";
                    recordName = "<input type=text id=reportName class='reportName'/></br>";
                    dialogContent = ej.buildTag("div#" + this._id + "_ReportDlg.reportDlg", "<table><tr><td>" + recordNameLabel + "</td><td>" + recordName + "</td></tr></table>")[0].outerHTML;
                }
                else if (args_className.split(" ")[0] == "LoadReport") {
                    dialogTitle = this._getLocalizedLabels("Load");
                    currentTag = "Load Report";
                    var recordNameLabel = "<table class='loadReportTbl'><tr><td class='loadReportTd'>" + this._getLocalizedLabels("ReportName") + "</td>";
                    var recordNamesDropdown = "<td><input type='text' id='reportNameList' class='reportNameList'/></td></tr></table>";
                    dialogContent = recordNameLabel + recordNamesDropdown;
                }
                else if (args_className.split(" ")[0] == "RemoveDBReport") {
                    dialogTitle = this._getLocalizedLabels("Remove");
                    currentTag = "RemoveDB Report";
                    var recordNameLabel = "<table class='removeDBReportTbl'><tr><td class='removeDBReportTd'>" + this._getLocalizedLabels("ReportName") + "</td>";
                    var recordNamesDropdown = "<td><input type='text' id='reportNameList' class='reportNameList'/></td></tr></table>";
                    dialogContent = recordNameLabel + recordNamesDropdown;
                }
                else if (args_className.split(" ")[0] == "RenameDBReport") {
                    dialogTitle = this._getLocalizedLabels("Rename");
                    currentTag = "RenameDB Report";
                    var recordNameLabel = "<table class='renameDBReportTbl'><tr><td class='renameDBReportTd'>" + this._getLocalizedLabels("SelectReport") + "</td>";
                    var recordNamesDropdown = "<td><input type='text' id='reportNameList' class='reportNameList'/></td></tr>";
                    var renameLabel = "<tr><td class='renameDBReportTd'>" + this._getLocalizedLabels("RenameReport") + "</td>";
                    var renameRecordTxtBox = "<td><input type='text' id='renameReport' class='renameReport' style='width:146px'/></td></tr></table>";
                    dialogContent = recordNameLabel + recordNamesDropdown + renameLabel + renameRecordTxtBox;
                }
                else if (args_className.split(" ")[0] == "mdx") {
                    dialogTitle = this._getLocalizedLabels("MDXQuery");
                    currentTag = "MDX Query";
                    var textarea = "<textarea readonly='readonly' style='width:460px; height:180px; resize:none; margin:3px'>" + args_innerHTML + "</textarea>";
                    dialogContent = textarea;
                }
                else if (args_className.split(" ")[0] == "chartTypesImg") {
                    dialogTitle = this._getLocalizedLabels("ChartTypes");
                    currentTag = "Chart Types";
                    var reportNameLabel = "<p class='dialogPara'>" + this._getLocalizedLabels("ChartTypes") + "</p>";
                    reportName = "<input type=text id=reportName class='reportName'/></br>";
                    dialogContent = reportNameLabel + reportName;
                }
                else if (args_className.indexOf("e-txt") > -1) {

                    if (args_innerHTML == this._getLocalizedLabels("Measures")) {
                        dialogTitle = this._getLocalizedLabels("MeasureEditor");
                        dialogContent = "<p class='editorPara'>" + this._getLocalizedLabels("Measures") + "</p>"
                    }
                    else {
                        dialogTitle = this._getLocalizedLabels("MemberEditor");
                        dialogContent = (this.model.enableAdvancedFilter && !isSlicerAxis ? "" : "<p class='editorPara'>" + hierarchyCaption + "</p>");

                    }
                    var memberSearchEditor = ""; var memberEditor; var checkOption = "";
                    $(innerDiv).appendTo(EditorDiv);
                    if (args_innerHTML != this._getLocalizedLabels("Measures")) {
                        var checkAll = ej.buildTag("div.checkAll e-icon").attr("role", "button").attr("aria-label", "checkall")[0].outerHTML;
                        var unCheckAll = ej.buildTag("div.unCheckAll e-icon").attr("role", "button").attr("aria-label", "uncheckall")[0].outerHTML;
                        checkOption = ej.buildTag("div.checkOptions", checkAll + unCheckAll, { "height": "19px", margin: "10px 0px 0px 31px" })[0].outerHTML;
                        memberSearchEditor = ej.buildTag("div.memberSearchEditorDiv", ej.buildTag("input#searchEditorTreeView.searchEditorTreeView").attr("type", "text")[0].outerHTML + (!ej.isNullOrUndefined(editorTreeInfo) && args_innerHTML != this._getLocalizedLabels("Measures") && this.model.enableMemberEditorPaging && $.parseJSON(editorTreeInfo).length >= this.model.memberEditorPageSize ? ej.buildTag("span.e-icon searchEditorTree", {})[0].outerHTML : ""), { "padding": (this.model.enableAdvancedFilter ? "5px 0px 0px 0px" : 0) })[0].outerHTML;
                    }
                    if (args_innerHTML == this._getLocalizedLabels("Measures")) {
                        this._isMembersFiltered = false;
                        memberEditor = this._createMeasureEditor(editorTree);
                    }
                    else
                        memberEditor = ej.buildTag("div#editorTreeView.editorTreeView")[0].outerHTML;
                    var memberEditorDiv = ej.buildTag("div.memberEditorDiv", (this._selectedFieldName != "" || args_innerHTML == this._getLocalizedLabels("KPIs") ? checkOption : "") + memberEditor)[0].outerHTML;
                    var labelFilterTag = "", levelList = "";

                    if (this._selectedFieldName != "" && !isSlicerAxis && this.model.enableAdvancedFilter) {
                        levelList = ej.buildTag("div.ddlGroupWrap", this._getLocalizedLabels("SelectField") + ":" + ej.buildTag("input#GroupLabelDrop.groupLabelDrop").attr("type", "text")[0].outerHTML, {})[0].outerHTML;
                        labelFilterTag = ej.buildTag("div.filterElementTag")[0].outerHTML;
                        var filterTag = ej.Pivot.createAdvanceFilterTag({ action: "filterTag" }, this)
                        levelInfo = $.map(this.element.find(".e-treeview li[tag='" + this._selectedFieldName + "'] li"), function (item, index) { return { text: $(item).text(), value: $(item).attr("tag") }; });
                    }
                    var innerDiv = ej.buildTag("div", (labelFilterTag != "" && !isSlicerAxis && this.model.enableAdvancedFilter ? (levelList + ej.buildTag("div.e-seperator", {}, { "padding": "2px" }, cancelBtn)[0].outerHTML + labelFilterTag + ej.buildTag("div.e-seperator", {}, { "padding": "2px" })[0].outerHTML) : "") + memberSearchEditor + memberEditorDiv)[0].outerHTML;
                    var EditorDiv = ej.buildTag("div#EditorDiv.editorDiv", innerDiv, { "margin-left": this.model.enableAdvancedFilter ? "5px" : "0px" })[0].outerHTML;
                    dialogContent += EditorDiv;
                    editorNavPanel = ej.buildTag("div.memberPager", ej.buildTag("div#NextpageDiv.nextPageDiv", ej.buildTag("div.e-icon e-media-backward_01 firstPage", {})[0].outerHTML + ej.buildTag("div.e-icon e-arrowhead-left prevPage", {})[0].outerHTML + ej.buildTag("input.memberCurrentPage#memberCurrentPage", {}, { "width": "20px", "height": "10px" })[0].outerHTML + ej.buildTag("span.memberPageCount#memberPageCount")[0].outerHTML + ej.buildTag("div.e-icon e-arrowhead-right nextPage", {})[0].outerHTML + ej.buildTag("div.e-icon e-media-forward_01 lastPage", {})[0].outerHTML)[0].outerHTML, {})[0].outerHTML;
                }
                var dialogFooter;
                if (args_className.split(" ")[0] == "mdx") {
                    var cancelBtn = "<button id=CancelBtn class='dialogCancelBtn'>" + this._getLocalizedLabels("OK") + "</button>";
                    dialogFooter = ej.buildTag("div.dialogFooter", cancelBtn)[0].outerHTML;
                    $(ejDialog).appendTo("#" + this._id);
                    $(dialogContent + dialogFooter).appendTo(this.element.find(".clientDialog"));
                    this.element.find(".clientDialog").ejDialog({ enableRTL: this.model.enableRTL, width: 500, target: "#" + this._id, enableResize: false, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
                }
                else {
                    var okBtn = "<button id=OKBtn class='dialogOKBtn'>" + (args_className.split(" ")[0] == "RemoveDBReport" ? this._getLocalizedLabels("Remove") : this._getLocalizedLabels("OK")) + "</button>";
                    var cancelBtn = "<button id=CancelBtn class='dialogCancelBtn'>" + this._getLocalizedLabels("Cancel") + "</button>";
                    dialogFooter = ej.buildTag("div.dialogFooter", okBtn + ((args_className.split(" ")[0] == "removeReportImg" && this.reportsCount == 1) ? "" : cancelBtn))[0].outerHTML;
                    $(ejDialog).appendTo("#" + this._id);
                    $(dialogContent + (!ej.isNullOrUndefined(editorTreeInfo) && args_innerHTML != this._getLocalizedLabels("Measures") && this.model.enableMemberEditorPaging && $.parseJSON(editorTreeInfo).length >= this.model.memberEditorPageSize ? editorNavPanel : "") + dialogFooter).appendTo(this.element.find(".clientDialog"));
                    if (args_className.split(" ")[0] == "SortFilterDlg")
                        this.element.find(".clientDialog").ejDialog({ enableRTL: this.model.enableRTL, width: 'auto', target: "#" + this._id, cssClass: "SortFilterDlg", enableResize: false, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
                    else
                        this.element.find(".clientDialog").ejDialog({ enableRTL: this.model.enableRTL, width: 'auto', target: "#" + this._id, enableResize: false, close: ej.proxy(ej.Pivot.closePreventPanel, this) });
                    if (args_className.split(" ")[0] == "removeReportImg") {
                        this.element.find(".clientDialog").css("min-height", "60px");
                        this.element.find("#" + this._id + "_ClientDialog_wrapper").css("min-height", "100px");
                    }
                }
        
                this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").prepend(ej.buildTag("div", dialogTitle, { "display": "inline" })[0].outerHTML)[0].setAttribute("tag", currentTag);
                this.element.find(".reportName").ejMaskEdit({ width: "155px", textAlign: this.model.enableRTL ? "right" : "left" });
                this.element.find(".memberSearchEditorDiv .e-mask").addClass("dialogInput");
                this.element.find(".prevPage, .firstPage").addClass("pageDisabled");
                this.element.find(".nextPage, .lastPage").addClass("pageEnabled");
                this.element.find(".dialogOKBtn, .dialogCancelBtn").ejButton({ type: ej.ButtonType.Button});
                $(".sortfilterTab").ejTab({ enableRTL: this.model.enableRTL });
                $(".reportNameList").ejDropDownList({
                    dataSource: args_innerHTML.split("__"),
                    enableRTL: this.model.enableRTL,
                    width: "150px",
                    height: "20px",
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                if (args_className.indexOf("e-txt") > -1) {
                    this.element.find("#searchEditorTreeView").ejMaskEdit({
                        name: "inputbox",
                        width: "100%",
                        inputMode: ej.InputMode.Text,
                        watermarkText: this._getLocalizedLabels("Search") + " " + hierarchyCaption,
                        maskFormat: "",
                        textAlign: this.model.enableRTL ? "right" : "left",
                        change: (!this.model.enableMemberEditorPaging || this.element.find(".nextPageDiv").length == 0) ? ej.proxy(ej.Pivot._searchTreeNodes, this) : ej.proxy(function (args) { if (ej.isNullOrUndefined(args.value)) ej.Pivot._searchEditorTreeNodes(args, this); }, this)
                    });
                }
                this.element.find(".filterElementTag").ejMenu({
                    fields: { dataSource: filterTag, id: "id", parentId: "parentId", text: "text", spriteCssClass: "spriteCssClass" },
                    menuType: ej.MenuType.NormalMenu,
                    width: "100%",
                    height:"25px",
                    enableRTL: this.model.enableRTL,
                    orientation: ej.Orientation.Vertical,
                    click: ej.proxy(this._filterElementClick, this)
                });
                this.element.find(".groupLabelDrop").ejDropDownList({
                    width: "100%",
                    height:"25px",
                    enableRTL: this.model.enableRTL,
                    dataSource: levelInfo,
                    fields: { id: "id", text: "text", value: "value" },
                    selectedIndices: [0],
                    change: ej.proxy(this._groupLabelChange, this),
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                $(".filterFrom,.filterTo").ejMaskEdit({ width: "80px", height: "20px", textAlign: this.model.enableRTL ? "right" : "left" });
                $(".measuresList").ejDropDownList({
                    dataSource: args_innerHTML.split("||")[0].split("__"),
                    enableRTL: this.model.enableRTL,
                    width: "80%",
                    height: "20px",
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                $(".fMeasuresList").ejDropDownList({
                    dataSource: args_innerHTML.split("||")[0].split("__"),
                    width: "80%",
                    enableRTL: this.model.enableRTL,
                    height: "20px",
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                $(".filterCondition").ejDropDownList({
                    change: "_onActiveConditionChange",
                    enableRTL: this.model.enableRTL,
                    dataSource: [{ option: "EqualTo", value: this._getLocalizedLabels("EqualTo") },
                                 { option: "NotEquals", value: this._getLocalizedLabels("NotEquals") },
                                 { option: "GreaterThan", value: this._getLocalizedLabels("GreaterThan") },
                                 { option: "GreaterThanOrEqualTo", value: this._getLocalizedLabels("GreaterThanOrEqualTo") },
                                 { option: "LessThan", value: this._getLocalizedLabels("LessThan") },
                                 { option: "LessThanOrEqualTo", value: this._getLocalizedLabels("LessThanOrEqualTo") },
                                 { option: "Between", value: this._getLocalizedLabels("Between") },
                                 { option: "NotBetween", value: this._getLocalizedLabels("NotBetween") },
                    ],
                    fields: { text: "value", value: "option" },
                    width: "80%",
                    height: "20px",
                    create: function () { $(this.wrapper.find('.e-input')).focus(function () { $(this).blur(); }) }
                });
                this.element.find(".filterCondition").ejDropDownList("option", "change", ej.proxy(this._onActiveConditionChange, this));
                this._dllSortMeasure = $(".measuresList").data("ejDropDownList");
                this._dllFilterCondition = $(".filterCondition").data("ejDropDownList");
                this._dllfMeasuresList = $(".fMeasuresList").data("ejDropDownList");
                if (sortState != "") {
                    this.element.find(".radioBtnAsc")[0].checked = sortState[0] == "ASC" ? true : false;
                    this.element.find(".radioBtnDesc")[0].checked = sortState[0] == "DESC" ? true : false;
                    this.element.find(".sortDisable")[0].checked = !(this.element.find(".sortEnable")[0].checked = true);
                    this.element.find(".preserveHrchy")[0].checked = sortState[1] == "PH" ? true : false;
                    this._isSorted = true;
                    this._dllSortMeasure.setModel({ value: (sortState[2]) });
                }
                if (filterState != "") {
                    this.element.find(".filterEnable")[0].checked = true;
                    this._dllfMeasuresList.setModel({ value: (filterState[0]) });
                    this._dllFilterCondition.setModel({ value: (filterState[1]) });
                    this.element.find(".filterFrom").val(filterState[2]);
                    if (filterState[3] != undefined && filterState[3] != "" && (filterState[1] == "Between" || filterState[1] == "NotBetween"))
                        this.element.find(".filterTo").val(filterState[3]);
                    else
                        $(".filterTo").attr("disabled", "disabled");
                    this._isFiltered = true;
                }
                if (this.element.find(".sortDisable")[0] != undefined && this.element.find(".sortDisable")[0].checked == true) {
                    $('.measuresList_wrapper,.radioBtnAsc, .radioBtnDesc, .preserveHrchy').attr("disabled", "disabled");
                    $('.measureListLbl, .orderLbl, .radioBtnAscLbl, .radioBtnDescLbl, .preserveHrchyLbl').addClass('sortFilterDisable');
                    this._dllSortMeasure.disable();
                }
                if (this.element.find(".filterDisable")[0] != undefined && this.element.find(".filterDisable")[0].checked == true) {
                    $('.filterFrom, .filterTo').attr("disabled", "disabled");
                    $('.filterMeasureListLbl, .conditionLbl, .filterValueLbl, .filterBtw').addClass('sortFilterDisable');
                    this._dllFilterCondition.disable();
                    this._dllfMeasuresList.disable();
                }
                this.element.find(".e-widget-content").height("auto");
                var isAdvancedFilter = false;
                if (this._excelFilterInfo.length > 0) {
                    var cubeName = this.element.find('.cubeSelector').length>0?  this.element.find('.cubeSelector').data("ejDropDownList").model.value:"", reportName = this.element.find('#reportList').data("ejDropDownList").model.value, levelName = this._selectedLevelUniqueName, hierarchyName = this._selectedFieldName;

                    if (this.model.analysisMode == ej.Pivot.AnalysisMode.Olap) {
                        $.map(this._excelFilterInfo, function (item, index) {
                            if (item.cubeName == cubeName && item.report == reportName && (item.hierarchyUniqueName == hierarchyName || item.levelUniqueName == levelName))
                                isAdvancedFilter = true;
                        });
                    }
                    else {
                        $.map(this._excelFilterInfo, function (item, index) {
                            if (item.report == reportName && (item.hierarchyUniqueName == hierarchyName || item.levelUniqueName == levelName))
                                isAdvancedFilter = true;
                        });
                    }
                }
                if ( editorTree != "" && editorTree != undefined && args_innerHTML != this._getLocalizedLabels("Measures")) {
                    var treeViewData = null;
                    if (!isAdvancedFilter &&this._currentReportItems.length != 0) {
                        for (var i = 0; i < this._currentReportItems.length; i++) {
                            if (this._currentReportItems[i] == this._currentItem) {
                                treeViewData = JSON.parse(JSON.stringify(this._treeViewData[this._currentItem]));
                                break;
                            }
                        }
                    }
                    if (treeViewData == null || !isAdvancedFilter)
                        treeViewData = $.parseJSON(editorTreeInfo);
                    if (this.model.enableMemberEditorPaging && args_innerHTML != this._getLocalizedLabels("Measures") && this.element.find(".nextPageDiv").length > 0) {
                        this._editorTreeData = $.parseJSON(editorTreeInfo);
                        var memberCount = this._editorTreeData.length;
                        var pageCount = (memberCount / this.model.memberEditorPageSize);
                        if (pageCount != Math.round(pageCount))
                            pageCount = parseInt(pageCount) + 1;
                        if (this._memberPageSettings.currentMemeberPage == pageCount)
                            this.element.find(".nextPage, .lastPage").addClass("disabled");
                        this.element.find(".memberPageCount").html("/ " + pageCount);
                        this.element.find(".memberCurrentPage").val(this._memberPageSettings.currentMemeberPage);
                        this._memberPageSettings.currentMemeberPage > 1 ? this.element.find(".prevPage, .firstPage").removeClass("pageDisabled").addClass("pageEnabled") : this.element.find(".prevPage, .firstPage").removeClass("pageEnabled").addClass("pageDisabled");
                        this._memberPageSettings.currentMemeberPage == parseInt(this.element.find(".memberPageCount").text().split("/")[1].trim()) ? this.element.find(".nextPage, .lastPage").removeClass("pageEnabled").addClass("pageDisabled") : this.element.find(".nextPage, .lastPage").removeClass("pageDisabled").addClass("pageEnabled");
                    }
                    this._appendTreeViewData(this.model.enableMemberEditorPaging && this.element.find(".nextPageDiv").length > 0 ? ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", null || undefined).page(this._memberPageSettings.currentMemeberPage, this.model.memberEditorPageSize)) : treeViewData, isSlicerAxis);
					if (!this.model.enableAdvancedFilter) 
					    this.element.find(".memberEditorDiv").css({ "height": "286px" });
					if (this.model.enableAdvancedFilter)
					    this.element.find("#clientDialog_wrapper").addClass("advancedFilterDlg");
                }
                this.element.find("#" + this._id + "_ClientDialog_closebutton").attr("title", this._getLocalizedLabels("Close"))
                this._unWireEvents();
                this._wireEvents();
                this._isTimeOut = false;
                this._waitingPopup.hide();
            
        },
        
        _appendTreeViewData: function (treeViewData, isSlicerAxis) {
            this.element.find(".editorTreeView").ejTreeView({
                showCheckbox: true,
                loadOnDemand: true,
                enableRTL: this.model.enableRTL,
                nodeUncheck: function (e, args) {
                    var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                    pivotClientObj._isMembersFiltered = true;
                    if (($(e.currentElement).parents(".e-treeview").find(".e-checkbox:checked").length == 0 && !pivotClientObj.model.enableMemberEditorPaging) || (pivotClientObj.element.find("#" + pivotClientObj._id + "_ClientDialog > .editorPara").text() == pivotClientObj._getLocalizedLabels("KPIs") && !e.isChecked && (e.parentId == "" || (e.parentId != null && e.currentUncheckedNodes.length > 1))))
                        pivotClientObj.element.find(".dialogOKBtn").data("ejButton").disable();
                    if (pivotClientObj.model.operationalMode != ej.Pivot.OperationalMode.ClientMode && pivotClientObj.model.enableMemberEditorPaging)
                        ej.Pivot._memberPageNodeUncheck(e, pivotClientObj);

                },
                nodeCheck: function (e) {
                    var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                    pivotClientObj._isMembersFiltered = true;
                    pivotClientObj.element.find(".dialogOKBtn").data("ejButton").enable();
                    pivotClientObj.element.find(".dialogOKBtn").removeAttr("disabled");
                    if (pivotClientObj.model.operationalMode != ej.Pivot.OperationalMode.ClientMode && pivotClientObj.model.enableMemberEditorPaging)
                        ej.Pivot._memberPageNodeCheck(e, pivotClientObj);
                },
                beforeDelete: function () {
                    return false;
                },
                cssClass: 'pivotTreeViewDragedNode',
                height: $(".memberEditorDiv").height(),
                fields: { id: "id", hasChild: "hasChildren", text: "name", isChecked: "checkedStatus", dataSource: treeViewData },
                beforeExpand: ej.proxy(this._onNodeExpand, this),
            });
            var treeViewElements = this.element.find(".editorTreeView").find("li");
            if (!this._isSearchApplied) {
                for (var i = 0; i < treeViewElements.length; i++) {
                    $(treeViewElements[i]).attr("tag", treeViewData[i].tag);
                }
            }
            else {
                for (var i = 0; i < treeViewElements.length; i++) {
                    if (!ej.isNullOrUndefined($(treeViewElements[i]).attr("id")))
                        $(treeViewElements[i]).attr("tag", ej.DataManager(treeViewData).executeLocal(ej.Query().where("id", "equal", $(treeViewElements[i]).attr("id")))[0].tag);
                }
            }
            this._memberTreeObj = this.element.find('.editorTreeView').data("ejTreeView");

            var isTreeNodeHasChild = $.grep(treeViewData, function (item, index) { if (item.hasChildren == true) return item; }).length > 0;
            if (!isTreeNodeHasChild)
                this.element.find(".memberEditorDiv").addClass("noChildNode");

            this.element.find(".editorTreeView").height(256);
            if (!isSlicerAxis && this.model.enableAdvancedFilter && !ej.isNullOrUndefined(this._memberTreeObj)) {
                if (!ej.isNullOrUndefined(this.element.find(".e-treeview li[tag='" + this._selectedLevelUniqueName + "']").attr("labelFiltering")))
                    this._memberTreeObj.element.find("." + this.element.find(".e-treeview li[tag='" + this._selectedLevelUniqueName + "']").attr("labelFiltering").split("--")[1].replace(" ", "") + " a").append(ej.buildTag("div.activeFilter").addClass("e-icon")[0].outerHTML);
                this.element.find(".e-dialog:not(.calcMemberDialog, .calcMemberDialog .e-dialog) .e-titlebar").hide();
                this._groupLabelChange({ selectedValue: (this.element.find(".groupLabelDrop").data("ejDropDownList").model.value || this.element.find(".groupLabelDrop").data("ejDropDownList").model.dataSource[0].value) });
                this.element.find(".memberEditorDiv").height(286);
                this.element.find(".editorTreeView").height(256);
            }
        },

        _createMeasureEditor: function (editorTree) {
            var editorTreeInfo;
            if (editorTree[0] != undefined)
                editorTreeInfo = $.parseJSON(editorTree[0].Value);
            else if (editorTree.d != undefined)
                editorTreeInfo = $.parseJSON(editorTree.d[0].Value);
            else
                editorTreeInfo = $.parseJSON(editorTree.EditorTreeInfo);
            var measureEditor = "";
            for (var i = 0; i < editorTreeInfo.length; i++) {
                measureEditor += "<div id=\"" + editorTreeInfo[i].uniqueName + "\"class=measureEditor>" + editorTreeInfo[i].name + "<span class='removeMeasure e-icon' role='button' aria-label='remove'></span></div>";
            }
            return measureEditor;
        },

        _onNodeExpand: function (args) {
            var selectedItem = args.targetElement; var tagInfo;
            //if (this._isSearchApplied == true)
            //    return;
			var onLoad = ej.buildTag("span.nodeExpand e-load e-icon")[0].outerHTML;
            var childCount = $(selectedItem).parents("li").first().children().find("li").length;
            for (var i = 0; i < this._memberTreeObj.dataSource().length; i++) {
                if (this._memberTreeObj.dataSource()[i].parentId == args.id) {
                    args.isChildLoaded = true;
                    ej.Pivot.closePreventPanel(this);
                    return;
                }
            }
            if (!ej.isNullOrUndefined(this) && this.model.enableMemberEditorPaging && ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", args.id)).length > 0) {
                args.isChildLoaded = true;
                ej.Pivot.closePreventPanel(this);
                this.pNode = selectedItem;
                this._fetchChildNodeSuccess({ ChildNodes: JSON.stringify(ej.DataManager(this._editorTreeData).executeLocal(ej.Query().where("pid", "equal", args.id))), customObject: this.model.customObject });
                return;
            }
            if (!args.isChildLoaded) {
                $(selectedItem).parents("li").first().prepend(onLoad);
                var checkedState = $(selectedItem).parent().find("input.e-checkbox").prop("checked");
                var tagInfo = $(selectedItem).parents("li").first().attr("tag");
                if (tagInfo == undefined) {
                    for (var i = 0; i < this._memberTreeObj.dataSource().length; i++) {
                        if (this._memberTreeObj.dataSource()[i].id == args.id) {
                            tagInfo = this._memberTreeObj.dataSource()[i].tag;
                            $(args.currentElement[0]).attr("tag", this._memberTreeObj.dataSource()[i].tag)
                            break;
                        }
                    }
                }
                this.pNode = selectedItem;
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "memberExpanded", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.memberExpand, JSON.stringify({
                    "action": "memberExpanded", "checkedStatus": checkedState, "parentNode": $(selectedItem).parents("li")[0].id, "tag": tagInfo, "dimensionName": this._dimensionName, "cubeName": this.currentCubeName, "olapReport": this.currentReport, "clientReports": this.reports, "customObject": serializedCustomObject
                }), this._fetchChildNodeSuccess);
            }
        },

        _onActiveConditionChange: function (args) {
            if (args.selectedValue == "Between" || args.selectedValue == "NotBetween") {
                $(".filterTo").removeAttr("disabled");
                $(".filterBtw").removeClass("sortFilterDisable");
            }
            else {
                $(".filterTo").attr("disabled", "disabled");
                this.element.find(".filterTo").val("");
                $(".filterBtw").addClass("sortFilterDisable");
            }
        },

        _reSizeHandler: function (args) {
            if (!ej.isNullOrUndefined(this)) {
                this._parentHeight = $(args.target).height();
                this.element.height(this._parentHeight);
                this._calculateHeight();
                this._parentElwidth = $("#" + this._id).parent().width();
                if (this._parentElwidth < 850 || (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this._parentElwidth < 910)) {
                    this._rwdToggleCollapse();
                }
                if (this._parentElwidth > 850 || (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode && this._parentElwidth > 910))
                    this._rwdToggleExpand();
                if (this.model.isResponsive && this.model.enableSplitter)
                    this.element.find(".splitresponsive").data("ejSplitter").refresh();
                this._overflow();
                if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                    this.chartObj = null;
                    this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                    $("#" + this._pivotChart._id + "Container").height(this._chartHeight);
                    if (!ej.isNullOrUndefined(this.chartObj))
                        this.chartObj.model.size.height = this._chartHeight;
                    if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                        this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                    if (!ej.isNullOrUndefined(this.chartObj)) {
                        if ((this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                            this.otreemapObj._treeMap.refresh();
                        }
                        else {
                            this.chartObj.redraw();
                        }
                    }
                  
                }
                if (this._isCollapseCB)
                    this._collapseCubeBrowser();
            }
        },

        _chartDrillSuccess: function (sender) {
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                if (this._isGridDrillAction)
                    this._isGridDrillAction = false;
                else {
                    this._isGridDrillAction = false;
                    this._isChartDrillAction = true;
                    var drilledMember = this._pivotChart._selectedItem;
                    var drillAction = this._pivotChart._drillAction;
                    if (drillAction == "drilldown") {
                        if (!ej.isNullOrUndefined(this._pivotChart._labelCurrentTags.expandedMembers) && this._drillParams.indexOf(this._pivotChart._labelCurrentTags.expandedMembers.join(">#>")) == -1)
                            this._drillParams.push(this._pivotChart._labelCurrentTags.expandedMembers.join(">#>"));
                    }
                    else
                        this._drillParams = $.grep(this._drillParams, function (item) { return item.indexOf(drilledMember) < 0; });
                    var drillInfo = this._pivotChart.model.enableMultiLevelLabels ? sender.drilledMember.split(">#>") : (drillAction == "drilldown" ? this._pivotChart._labelCurrentTags.expandedMembers : this._pivotChart._currentDrillInfo);
                    var minRowIndex = 0, maxRowIndex = this._pivotGrid._rowCount;
                    for (var i = 0; i < drillInfo.length; i++) {
                        var rowheaders = (i == drillInfo.length - 1 && drillAction == "drilldown") ? this.element.find(".e-pivotgrid .pivotGridTable th.summary[p^='" + i + "']") : this.element.find(".e-pivotgrid .pivotGridTable th.rowheader[p^='" + i + "']");
                        var targetCell = $.grep(rowheaders, function (headerCell) { return $(headerCell).clone().children().remove().end().text() == drillInfo[i]; });
                        targetCell = $.grep(targetCell, function (headerCell) { return parseInt($(headerCell).attr('p').split(',')[1]) >= minRowIndex && parseInt($(headerCell).attr('p').split(',')[1]) <= maxRowIndex });
                        if (i == drillInfo.length - 1)
                            $(targetCell).find("." + (drillAction == "drilldown" ? "expand" : "collapse")).trigger("click");
                        else {
                            minRowIndex = parseInt($(targetCell).attr('p').split(',')[1]);
                            maxRowIndex = minRowIndex + (ej.isNullOrUndefined($(targetCell).find("span").attr("tag")) ? 0 : parseInt($(targetCell).find("span").attr("tag"))) + targetCell[0].rowSpan;
                        }
                    }
                    if (drillInfo.length == 0) {
                        var rowheaders = this.element.find(".e-pivotgrid .pivotGridTable th.rowheader[p^='" + 0 + "']");
                        var targetCell = $.grep(rowheaders, function (headerCell) { return $(headerCell).clone().children().remove().end().text() == drilledMember; });
                        $(targetCell).find(".collapse").trigger("click");
                    }
                }
            }
            else {
                //if (this.currentReport != undefined)
                   // currentReport = this.currentReport;
                //if (this.reports != undefined)
                  //  reports = this.reports;
                if (this._pivotChart._startDrilldown && this._pivotGrid != null && this._pivotGrid != undefined)
                    this._renderPivotGrid(this._pivotChart._selectedTagInfo);
                else if (this._pivotGrid != undefined && this._pivotGrid.element.find("table") == "block") {
                    this._isTimeOut = false;
                    this._waitingPopup.hide();
                }
            }
        },

        _treemapDrillSuccess: function (sender) {
           // if (this.currentReport != undefined)
              //  currentReport = this.currentReport;
            //if (this.reports != undefined)
                //reports = this.reports;
            if (this.otreemapObj._startDrilldown && this._pivotGrid != null && this._pivotGrid != undefined)
                this._renderPivotGrid(this.otreemapObj._selectedTagInfo);
            else if (this._pivotGrid != undefined && this._pivotGrid.element.find("table") == "block") {
                this._isTimeOut = false;
                this._waitingPopup.hide();
            }
            if (!ej.isNullOrUndefined(this.chartObj)) {
                if (this.model.displaySettings.enableFullScreen || this.enableTogglePanel() && (this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap") {
                    $("#" + this.otreemapObj._id + "TreeMapContainer").css({ width: "100%" });
                    this.otreemapObj._treeMap.refresh();
                }
            }
        },

        _gridDrillSuccess: function (sender) {
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                if (this._isChartDrillAction)
                    this._isChartDrillAction = false;
                else {
                    this._isGridDrillAction = true;
                    this._isChartDrillAction = false;
                    if (sender.axis == "rowheader" && this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                        //if (this._pivotChart._drillAction == "") {
                            if (sender.drillAction == "drilldown")
                                this._drillParams.push(sender.drilledMember);
                            else
                                this._drillParams = $.grep(this._drillParams, function (item) { return item.indexOf(sender.drilledMember) < 0; });
                            var drillInfo = sender.drilledMember.split(">#>");
                            this._pivotChart._labelCurrentTags.expandedMembers = drillInfo;
                            if (sender.drillAction == "drillup") {
                                this._pivotChart._labelCurrentTags.expandedMembers = [];
                                if (this._drillParams.length > 0)
                                    this._getDrilledMember(sender.drillAction);
                                drillInfo = this._pivotChart._labelCurrentTags.expandedMembers;
                            }
                            drillInfo = this._pivotChart.model.enableMultiLevelLabels ? (sender.drillAction == "drillup" ? sender.drilledMember.split(">#>").slice(0, -1) : sender.drilledMember.split(">#>")) : drillInfo;
                            this._pivotChart._drillAction = sender.drillAction;
                            this._pivotChart._drillParams = this._drillParams;
                            var report;
                            try {
                                report = JSON.parse(this.currentReport).Report;
                            }
                            catch (err) {
                                report = this.currentReport;
                            }
                            if (this._pivotChart.model.enableMultiLevelLabels) {
                                this._pivotChart._generateData({ JsonRecords: this.getJSONRecords(), PivotReport: this.getOlapReport() });
                            }
                            else {
                                var serializedCustomObject = JSON.stringify(this.model.customObject);
                                var params = { action: sender.drillAction, currentReport: report, drilledSeries: JSON.stringify(drillInfo), clientReports: this.reports, "customObject": serializedCustomObject };
                                this._pivotChart.doAjaxPost("POST", this.model.url + "/" + this._pivotChart.model.serviceMethodSettings.drillDown, JSON.stringify(params), this._pivotChart.renderControlSuccess);
                            }
                        //}
                    }
                    else
                        this._isGridDrillAction = false;
                    return;
                }
            }
           // if (this.currentReport != undefined)
              //  currentReport = this.currentReport;
            //if (this.reports != undefined)
                //reports = this.reports;
            if (this._pivotGrid._startDrilldown && !ej.isNullOrUndefined(this._pivotChart)) {
                var masktag; var levelCaption; var levelTag;
                levelCaption = this._pivotGrid._drillCaption;
                if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                    this.chartObj = null;
                    if (this.model.displaySettings.enableFullScreen && $("#" + this._id + "_maxView").length>0)
                        this.chartObj = $("#" + this._id + "_maxView").find("#" + this._pivotChart._id + "Container").data("ejChart");
                    else
                        this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                    if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                        this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
                }
                var pivotClientObj = this;
                if (!ej.isNullOrUndefined(this.chartObj)) {
                    if ((this.chartObj.sfType.split(".")).pop().toLowerCase() != "treemap") {
                        jQuery.each(this._pivotChart._labelCurrentTags, function (index, value) {
                            if (value != undefined && value.name == levelCaption) {
                                levelTag = value.tag;
                                masktag = value;
                            }
                        });
                        this._pivotChart._drillAction = this._pivotGrid._drillAction;
                        this._pivotChart._selectedItem = levelCaption;
                        if (this._pivotGrid._drillAction == "drilldown" && !ej.isNullOrUndefined(masktag))
                            this._pivotChart._tagCollection.push(masktag)
                        else if (!ej.isNullOrUndefined(masktag)) {
                            jQuery.each(this.element.find(".rowAxis").find("button"), function (index, value) {
                                if (value.innerHTML == masktag.tag.split("[")[1].split("]")[0])
                                    pivotClientObj._pivotChart._dimensionIndex = index;
                            });
                            jQuery.each(this._pivotChart._tagCollection, function (index, value) {
                                if (value != undefined && value.name == levelCaption) {
                                    pivotClientObj._pivotChart._selectedIndex = index + pivotClientObj._pivotChart._dimensionIndex;
                                    pivotClientObj._pivotChart._tagCollection.splice(index, pivotClientObj._pivotChart._tagCollection.length);
                                    return false;
                                }
                            });
                        }
                        if (levelTag != null && levelTag != undefined)
                            this._renderPivotChart(levelTag, this._pivotGrid._drillAction);
                        else {
                            this._isTimeOut = false;
                            this._waitingPopup.hide();
                        }
                    }
                    else {
                        for (var i = 0 ; i < this.otreemapObj.getJsonRecords().labelTags.length ; i++) {
                            if (this.otreemapObj.getJsonRecords().labelTags[i].split("::")[2] == levelCaption) {
                                levelTag = this.otreemapObj.getJsonRecords().labelTags[i];
                                break;
                            }
                        }
                        this.otreemapObj_currentAction = this._pivotGrid._drillAction;
                        this.otreemapObj._selectedItem = levelCaption;
                        if (this._pivotGrid._drillAction == "drilldown" && !ej.isNullOrUndefined(masktag))
                            this.otreemapObj._tagCollection.push(masktag)
                        else if (!ej.isNullOrUndefined(masktag)) {
                            jQuery.each(this.element.find(".rowAxis").find("button"), function (index, value) {
                                if (value.innerHTML == masktag.tag.split("[")[1].split("]")[0])
                                    pivotClientObj.otreemapObj._dimensionIndex = index;
                            });
                            jQuery.each(this.otreemapObj._tagCollection, function (index, value) {
                                if (value != undefined && value.name == levelCaption) {
                                    pivotClientObj.otreemapObj._selectedIndex = index + pivotClientObj.otreemapObj._dimensionIndex;
                                    pivotClientObj.otreemapObj._tagCollection.splice(index, pivotClientObj.otreemapObj._tagCollection.length);
                                    return false;
                                }
                            });
                        }
                        if (levelTag != null && levelTag != undefined)
                            this._renderPivotTreeMap(levelTag, this._pivotGrid._drillAction);
                        else {
                            this._isTimeOut = false;
                            this._waitingPopup.hide();
                        }
                    }
                }
            }
            else if ($("#" + this._waitingPopup._id + "_WaitingPopup")[0].style.display == "block") {
                this._isTimeOut = false;
                this._waitingPopup.hide();
            }
        },

        _nodeDropped: function (sender) {
            var dropTarget = ($(sender.dropTarget).hasClass("pvtBtn") && $(sender.dropTarget).parent("div.splitBtn").length > 0) ? $(sender.dropTarget).parent("div.splitBtn") : $(sender.dropTarget);
            var pivotClientObj = this;
            if (dropTarget.prevObject != undefined)
               dropTarget.prevObject.removeClass("targetAxis");
            else
                $(dropTarget).removeClass("targetAxis");
            pivotClientObj.isDragging = false;
            var droppedPosition = this._setSplitBtnTargetPos(sender.event);
            dropTarget.prevObject != undefined ? dropTarget.prevObject.parents().find(".e-dialog").hide() : $(dropTarget).parents().find(".e-dialog").hide();
            var cssName = null;
            if ($(dropTarget).hasClass("splitBtn"))
                cssName = $(dropTarget).parents("div:eq(0)").attr("class");
            else if (sender.event.type == "touchend")
                cssName = dropTarget[0].className;
            else if (sender.event.target != undefined) {
                if (sender.event.target.className == undefined || sender.event.target.className == null || $(sender.event.target).parents(".chartContainer").length > 0)
                    return false;
                if (sender.event.target.className.toLowerCase().indexOf("splitbtn") > -1 || $(sender.event.target).hasClass("e-button"))
                    cssName = $(dropTarget).attr("class");
                else
                    cssName = sender.event.target.className;
            }
            else {
                if (sender.event.originalEvent.srcElement.className.toLowerCase().indexOf("splitbtn") > -1)
                    cssName = dropTarget[0].className;
                else
                    cssName = sender.event.originalEvent.srcElement.className;
            }
            delete pivotClientObj._fieldMembers[pivotClientObj._dialogTitle];
            delete pivotClientObj._fieldSelectedMembers[pivotClientObj._dialogTitle];
            var axisName = (cssName.indexOf("categoricalAxis") > cssName.indexOf("rowAxis")) ? ((cssName.indexOf("categoricalAxis") > cssName.indexOf("slicerAxis")) ? "Categorical" : "Slicer") : ((cssName.indexOf("rowAxis") > cssName.indexOf("slicerAxis")) ? "Series" : (cssName.indexOf("slicerAxis") >= 0) ? "Slicer" : null);
            var tagVal;
            if ($(sender.droppedElement).parents("[tag='KPI']").length > 0) {
                if(($(sender.droppedElement).text() == "Value" || $(sender.droppedElement).text() == "Goal" || $(sender.droppedElement).text() == "Status" || $(sender.droppedElement).text() == "Trend"))
                    tagVal = ($(sender.droppedElement).attr("tag") + ":" + $(sender.droppedElement).parent().closest("li").attr("tag") + ":" + this._getLocalizedLabels("KPIs"));
                else
                    tagVal = ($(sender.droppedElement).attr("tag") + ":" + this._getLocalizedLabels("KPIs"));

            }
            else
                tagVal = $(sender.droppedElement).attr("tag");
            if ((axisName == "Slicer" && tagVal != null && tagVal.indexOf("Measure") > -1 && this.element.find(".splitBtn[tag*=Measures]").length > 1) || (axisName == "Slicer" && tagVal.indexOf("Measure") > -1 && $(sender.droppedElement).find(".calcMemberCDB").length > 0 && this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").length == 1 && $(sender.droppedElement).attr("tag").replace(/\[/g, "").replace(/\]/g, "") != this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").attr("tag").split(":")[1].split("::")[0]) || (axisName == "Slicer" && tagVal.indexOf("Measure") > -1 && $(sender.droppedElement).find(".calcMemberCDB").length == 0 && this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").length == 1) || (axisName == "Slicer" && tagVal.indexOf("Measure") > -1 && $(sender.droppedElement).find(".calcMemberCDB").length == 1 && this.element.find(".splitBtn[tag*=CalculatedMember][tag*=Measure]").length == 0 && this.element.find(".splitBtn[tag*=Measure]").length == 1)) {
                ej.Pivot._createErrorDialog(this._getLocalizedLabels("MultipleMeasure"), this._getLocalizedLabels("Warning"), this);
                return false;
            }
            if (axisName != null && tagVal != "Measures" && tagVal.lastIndexOf(".DF") != tagVal.length - ".DF".length) {
                if (!(axisName == "Slicer" && (tagVal.indexOf("Measures") >= 0 || $(sender.droppedElement[0].childNodes[0]).find(".namedSetCDB").length > 0))) {
                    this._isTimeOut = true;
                    setTimeout(function () {
                        if (pivotClientObj._isTimeOut)
                            pivotClientObj._waitingPopup.show();
                    }, 800);
                    if (this.model.beforeServiceInvoke != null)
                        this._trigger("beforeServiceInvoke", { action: "nodeDropped", element: this.element, customObject: this.model.customObject });
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    var params = pivotClientObj.currentCubeName + "--" + tagVal + "--" + axisName + "--" + droppedPosition;
                    pivotClientObj.doAjaxPost("POST", pivotClientObj.model.url + "/" + pivotClientObj.model.serviceMethodSettings.nodeDropped, JSON.stringify({ "action": "nodeDropped", "dropType": "TreeNode", "nodeInfo": params, "olapReport": pivotClientObj.currentReport, "clientReports": pivotClientObj.reports, "customObject": serializedCustomObject }), pivotClientObj._nodeDroppedSuccess);
                }
            }
            pivotClientObj._isRemoved = true;
            pivotClientObj._isNodeOrButtonDropped = true;
        },

        _setSplitBtnTargetPos: function (event) {
            var targetPosition = ""; var AEBdiv; var targetSplitBtn; var className;
            if (event.event != undefined && event.event.type == "touchend") {
                targetSplitBtn = event.event.originalEvent.target != null ? $(event.event.originalEvent.target).parents(".splitBtn") : $(event.event.originalEvent.srcElement).parents(".splitBtn");
                className = event.event.originalEvent.target != null ? event.event.originalEvent.target.className : event.event.originalEvent.srcElement.className;
            }
            else {
                targetSplitBtn = event.originalEvent.target != null ? $(event.originalEvent.target).parents(".splitBtn") : $(event.originalEvent.srcElement).parents(".splitBtn");
                className = event.originalEvent.target != null ? event.originalEvent.target.className : event.originalEvent.srcElement.className;
            }
            if (targetSplitBtn[0] || (className != undefined && className != null && jQuery.type(className) == "string" && className.indexOf("splitBtn") > -1)) {
                targetSplitBtn = targetSplitBtn[0] ? targetSplitBtn[0] : event.originalEvent.target != null ? event.originalEvent.target : event.originalEvent.srcElement;
                if (event.event != undefined && event.event.type == "touchend")
                    AEBdiv = event.target;
                else if (this._dropAxisClassName != null && this._dropAxisClassName != undefined && this._dropAxisClassName != "")
                    AEBdiv = this.element.find("." + this._dropAxisClassName)[0];
                else
                    AEBdiv = targetSplitBtn.parentNode;
                if (AEBdiv != undefined) {
                    for (var i = 0; i < $(AEBdiv).find(".splitBtn").length; i++) {
                        if ($(AEBdiv).find(".splitBtn")[i] == targetSplitBtn)
                            targetPosition = i;
                    }
                }
                else {
                    this._dropAxisClassName = "";
                }
            }
            return targetPosition;
        },

        _cubeChanged: function (sender) {
            var pivotClientObj = this;
            this._currentRecordName = "";
            this._fieldMembers = {};
            this._fieldSelectedMembers = {};
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this.chartObj = null;
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                    this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
            }
            if(this.currentCubeName == sender.text)
				return false
			else
				this.currentCubeName = sender.text;
            pivotClientObj._isTimeOut = true;
            setTimeout(function () {
                if (pivotClientObj._isTimeOut)
                    pivotClientObj._waitingPopup.show();
            }, 800);
            if (this.model.beforeServiceInvoke != null)
                this._trigger("beforeServiceInvoke", { action: "cubeChanged", element: this.element, customObject: this.model.customObject });
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.cubeChanged, JSON.stringify({ "action": "cubeChanged", "cubeName": this.currentCubeName, "customObject": serializedCustomObject, "clientParams": JSON.stringify(this.model.enableMeasureGroups)+"-"+this.model.enableKPI }), this._cubeChangedSuccess);
        },

        _measureGroupChanged: function (sender) {
            this._isTimeOut = true;
            var pivotClientObj = this;
            setTimeout(function () {
                if (pivotClientObj._isTimeOut)
                    pivotClientObj._waitingPopup.show();
            }, 800);
            if (this.model.beforeServiceInvoke != null)
                this._trigger("beforeServiceInvoke", { action: "cubeChanged", element: this.element, customObject: this.model.customObject });
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.measureGroupChanged, JSON.stringify({ "action": "measureGroupChanged", "measureGroupName": sender.text, "olapReport": this.currentReport, "clientReports": this.reports, "customObject": serializedCustomObject }), this._measureGroupChangedSuccess);
        },

        _reportChanged: function (sender) {
            this._fieldMembers = {};
            this._fieldSelectedMembers = {};
            var pivotClientObj = this;
            this.reportDropTarget = this.element.find('#reportList').data("ejDropDownList");
            if (this.model.operationalMode == ej.Pivot.OperationalMode.ClientMode) {
                var dataSourceInfo = $.map(this._clientReportCollection, function (obj, index) { if (obj.reportName == pivotClientObj.reportDropTarget.getValue()) return obj; });
                this.model.dataSource = dataSourceInfo[0];
                if (this._currentItem != "Rename Report") {
                    this.refreshControl();
                    this._pivotSchemaDesigner._refreshPivotButtons();
                }
                this._isTimeOut = false;
                this._waitingPopup.hide();
            }
            else {
                if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                    if (!this._isReportListAction) return;
                    pivotClientObj._isTimeOut = true;
                    setTimeout(function () {
                        if (pivotClientObj._isTimeOut)
                            pivotClientObj._waitingPopup.show();
                    }, 800);
                    var dataSourceInfo = $.map(this._clientReportCollection, function (obj, index) { if (obj.name == this.reportDropTarget.getValue()) return obj; });
                    this._currentReportName = dataSourceInfo[0].name;
                    if (this.model.beforeServiceInvoke != null)
                        this._trigger("beforeServiceInvoke", { action: "toolbarOperation", element: this.element, customObject: this.model.customObject });
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.toolbarServices, JSON.stringify({ "action": "Change Report", "args": JSON.stringify({ "currentReport": dataSourceInfo[0].report }), "customObject": serializedCustomObject }), this._toolbarOperationSuccess);
                }
            else if (sender.selectedText != this._selectedReport) {
                pivotClientObj._isTimeOut = true;
                setTimeout(function () {
                    if (pivotClientObj._isTimeOut)
                        pivotClientObj._waitingPopup.show();
                }, 800);
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: "toolbarOperation", element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.toolbarServices, JSON.stringify({ "action": "toolbarOperation", "toolbarOperation": "Report Change", "clientInfo": sender.text, "olapReport": null, "clientReports": this.reports, "customObject": serializedCustomObject }), this._toolbarOperationSuccess);
            }
            }
            this._selectedReport = this.reportDropTarget._currentText;
        },

        _onDropped: function (sender) {
            if (sender.target.className.indexOf("e-button") > -1) {
                var columnPosInfo = this._getAxisPosition(this.element.find(".categoricalAxis"));
                var rowPosInfo = this._getAxisPosition(this.element.find(".rowAxis"));
                var slicerPosInfo = this._getAxisPosition(this.element.find(".slicerAxis"));
                this._dropAxisClassName;
                if (sender.pageX != undefined && sender.pageY != undefined) {
                    if (sender.pageX > columnPosInfo.left && sender.pageX < columnPosInfo.right && sender.pageY > columnPosInfo.top && sender.pageY < columnPosInfo.bottom)
                        this._dropAxisClassName = "categoricalAxis";
                    else if (sender.pageX > rowPosInfo.left && sender.pageX < rowPosInfo.right && sender.pageY > rowPosInfo.top && sender.pageY < rowPosInfo.bottom)
                        this._dropAxisClassName = "rowAxis";
                    else if (sender.pageX > slicerPosInfo.left && sender.pageX < slicerPosInfo.right && sender.pageY > slicerPosInfo.top && sender.pageY < slicerPosInfo.bottom)
                        this._dropAxisClassName = "slicerAxis";
                    else
                        this._dropAxisClassName = "outOfAxis";
                }
            }
        },

        _getAxisPosition: function (targetElement) {
            var tempPos = targetElement.position();
            var item = {};
            item["top"] = tempPos.top;
            item["right"] = tempPos.left + $(targetElement).width();
            item["bottom"] = tempPos.top + $(targetElement).height();
            item["left"] = tempPos.left;
            return item;
        },

        _onTabClick: function (args) {
            if (this.displayMode() != ej.PivotClient.DisplayMode.GridOnly) {
                this.chartObj = this.element.find("#" + this._pivotChart._id + "Container").data("ejChart");
                if (ej.isNullOrUndefined(this.chartObj) && this.model.enablePivotTreeMap && !ej.isNullOrUndefined(this.otreemapObj))
                    this.chartObj = this.element.find("#" + this.otreemapObj._id + "TreeMapContainer").data("ejTreeMap");
            }
            this._currentTab = "chart";
            if ($(args.activeHeader).find("a").text() == this._getLocalizedLabels("Grid")) {
                this._currentTab = "grid";
                this.element.find(".chartTypesImg").addClass("chartTypesOnGridView");
                this.element.find(".gridPanel").css("display", "inline");
            }
            else if (!ej.isNullOrUndefined(this.chartObj)) {
                this._currentTab = "chart";
                this.element.find(".chartTypesImg").removeClass("chartTypesOnGridView");
                if (!ej.isNullOrUndefined(this.chartObj))
                (this.chartObj.sfType.split(".")).pop().toLowerCase() == "treemap" ? this.otreemapObj._treeMap.refresh() : this.chartObj.redraw();
                if (this.model.enableToolBar)
                   {
                     this._unWireEvents();
                     this._wireEvents();
                 }
            }
        },

        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            var contentType, dataType, successEvt, isAsync = true;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, ej.olap.base, customArgs), isAsync = ((ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9) ? false : (!ej.isNullOrUndefined(customArgs) && customArgs["action"] != "loadFieldElements") ? true : false);

            $.ajax({
                type: type,
                url: url,
                contentType: contentType,
                dataType: dataType,
                async: isAsync,
                data: data,
                success: successEvt,
                complete: ej.proxy(function () {
                    var eventArgs = {"action" : !ej.isNullOrUndefined(customArgs) && !ej.isNullOrUndefined(customArgs.action) ? customArgs.action : JSON.parse(data)["action"], "customObject": this.model.customObject, "element": this.element };
                    this._trigger("renderComplete", eventArgs);
                }, this),
                error: ej.proxy(function (msg, textStatus, errorThrown) {
                    this._waitingPopup = $("#" + this._id).data("ejWaitingPopup");
                    this._isTimeOut = false;
                    this._waitingPopup.hide();
                    var eventArgs = { "customObject": this.model.customObject, "element": this.element, "Message": msg };
                    this._trigger("renderFailure", eventArgs);
                    this._renderControlSuccess("");
                }, this)
            });
        },

        doPostBack: function (url, params) {
            var form = $('<form>').attr({ 'action': url, 'method': 'POST', 'name': 'export' });
            var addParam = function (paramName, paramValue) {
                var input = $('<input type="hidden" title="params">').attr({
                    'id': paramName,
                    'name': paramName,
                    'value': paramValue
                }).appendTo(form);
            };
            for (var item in params)
                addParam(item, params[item]);
            form.appendTo(document.body).submit().remove();
        }
    });

    ej.PivotClient.Locale = {};

    ej.PivotClient.Locale["en-US"] = {
        NoReports: "No Reports Found in DB",
        Sort: "Sort",
        Search: "Search",
        SelectField: "Select field",
        LabelFilterLabel: "Show the items for which the label",
        ValueFilterLabel: "Show the items for which",
        ClearSorting: "Clear Sorting",
        ClearFilterFrom: "Clear Filter From",
        SortAtoZ: "Sort A to Z",
        SortZtoA: "Sort Z to A",

        LabelFilters: "Label Filters  ",
        BeginsWith: "Begins With",
        DoesNotBeginsWith: "Does Not Begins With",
        EndsWith: "Ends With",
        NotEndsWith: "Not Ends With",
        DoesNotEndsWith: "Does Not Ends With",
        Contains: "Contains",
        DoesNotContains: "Does Not Contains",

        ValueFilters: "Value Filters",
        ClearFilter: "Clear Filter",
        Equals: "Equals",
        DoesNotEquals: "Does Not Equals",
        NotEquals: "Not Equals",
        GreaterThan: "Greater Than",
        GreaterThanOrEqualTo: "Greater Than Or Equal To",
        LessThan: "Less Than",
        LessThanOrEqualTo: "Less Than Or Equal To",
        Between: "Between",
        NotBetween: "Not Between",
        Top10:"Top Count",

        GreaterThan: "Greater Than",
        IsGreaterThan: "Is Greater Than",
        IsGreaterThanOrEqualTo: "Is Greater Than Or Equal To",
        IsLessThan: "Is Less Than",
        IsLessThanOrEqualTo: "Is Less Than Or Equal To",
        DeferUpdate: "Defer Update",
        MDXQuery: "MDX Query",
        Column: "Column",
        Row: "Row",
        Slicer: "Slicer",
        CubeSelector: "Cube Selector",
        ReportName: "Report Name",
        NewReport: "New Report",
        CubeDimensionBrowser: "Cube Dimension Browser",
        AddReport: "Add Report",
        RemoveReport: "Remove Report",
        CannotRemoveSingleReport: "Can not remove single report",
        AreYouSureToDeleteTheReport: "Are you sure to delete the Report",
        RenameReport: "Rename Report",
        ChartTypes: "Chart Types",
	    ToggleAxis: "Toggle Axis",
        Load: "Load",
        ExportToExcel: "Export To Excel",
        ExportToWord: "Export To Word",
        ExportToPdf: "Export To Pdf",
        FullScreen: "Full Screen",
        Grid: "Grid",
        Chart: "Chart",
        OK: "<u>O</u>K",
        Cancel: "<u>C</u>ancel",
        Close: "Close",
        AddToColumn: "Add to Column",
        AddToRow: "Add to Row",
        AddToSlicer: "Add to Slicer",
        MeasureEditor: "Measure Editor",
        MemberEditor: "Member Editor",
        Measures: "Measures",
        SortOrFilterColumn: "Sort/Filter (Column)",
        SortOrFilterRow: "Sort/Filter (Row)",
        SortingAndFiltering: "Sorting And Filtering",
        Sorting: "Sorting",
        Measure: "<u>M</u>easure",
        Order: "Order",
        Filtering: "Filtering",
        Condition: "C<u>o</u>ndition",
        Value: "Val<u>u</u>e",
        PreserveHierarchy: "P<u>r</u>eserve  Hierarchy",
        Ascending: "<u>A</u>scending",
        Descending: "D<u>e</u>scending",
        Enable: "E<u>n</u>able",
        Disable: "D<u>i</u>sable",
        and: "<u>a</u>nd",
        EqualTo: "EqualTo",
        NotEquals: "NotEquals",
        GreaterThan: "GreaterThan",
        GreaterThanOrEqualTo: "GreaterThanOrEqualTo",
        LessThan: "LessThan",
        LessThanOrEqualTo: "LessThanOrEqualTo",
        Between: "Between",
        NotBetween: "NotBetween",
        ReportList:"Report List",
        Line: "Line",
        Spline: "Spline",
        Column: "Column",
        Area: "Area",
        SplineArea: "Spline Area",
        StepLine: "Step Line",
        StepArea: "Step Area",
        Pie: "Pie",
        Bar: "Bar",
        StackingArea: "Stacking Area",
        StackingColumn: "Stacking Column",
        StackingBar: "Stacking Bar",
        Pyramid: "Pyramid",
        Funnel: "Funnel",
        Doughnut: "Doughnut",
        Scatter: "Scatter",
        Bubble: "Bubble",
		WaterFall: "WaterFall",
        TreeMap: "TreeMap",
        Alert: "Alert",
        MDXAlertMsg: "Please add a measure, dimension or hierarchy in an appropriate axis to view the MDX Query.",
        FilterSortRowAlertMsg: "Dimension not found in row axis. Please add Dimension element in row axis for sorting/filtering.",
        FilterSortColumnAlertMsg: "Dimension not found in column axis. Please add Dimension element in column axis for sorting/filtering.",
        FilterSortcolMeasureAlertMsg: "Please add measure to the Column axis",
        FilterSortrowMeasureAlertMsg: "Please add measure to the Row axis",
        FilterSortElementAlertMsg: "Element not found in column axis. Please add an element in column axis for sorting/filtering.",
        SelectRecordAlertMsg: "Please select a valid report.",
        FilterMeasureSelectionAlertMsg: "Please select a valid measure.",
        FilterConditionAlertMsg: "Please set a valid condition.",
        FilterStartValueAlertMsg: "Please set a start value.",
        FilterEndValueAlertMsg: "Please set a end value.",
        FilterInvalidAlertMsg: "Invalid operation !",
        Remove: "Remove",
        Save: "Save",
        SaveAs:"Save As",
        SelectReport: "Select Report",
		DBReport: "Report Manipulation in DB",
        Rename: "Rename",
        Remove: "Remove",
        SetReportNameAlertMsg: "Please set report name.",
        MultipleItems: "Multiple items",
        All: "All",
        CalculatedMember: "Calculated Member",
        Caption: "Caption:",
        Expression: "Expression:",
        MemberType: "MemberType:",
        FormatString: "Format String:",
        MultipleMeasure: "More than one measure cannot be sliced.",
        DuplicateCalcMeasure: "Calculated Member with same name already exist.",
        EmptyField: "Calculated Member name or Expression cannot be empty.",
        EmptyFormat: "Format String for Calculated Member is empty.",
        Warning: "Warning",
        Confirm: "Calculated Member with the same name already exists. Due to want to Replace ?",
        KPIs:"KPIs"

    };

    ej.PivotClient.ControlPlacement = {
        Tab: "tab",
        Tile: "tile"
    };

    ej.PivotClient.DisplayMode = {
        ChartOnly: "chartonly",
        GridOnly: "gridonly",
        ChartAndGrid: "chartandgrid"
    };

    ej.PivotClient.ClientExportMode = {
        ChartAndGrid: "chartandgrid",
        ChartOnly: "chartonly",
        GridOnly: "gridonly"
    };
    ej.PivotClient.ExportMode = {
        JSON: "json",
        PivotEngine: "pivotengine"
    };
    ej.PivotClient.DefaultView = {
        Chart: "chart",
        Grid: "grid"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Pivot Chart elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejPivotChart", "ej.PivotChart", {

        _rootCSS: "e-pivotchart",
        element: null,
        model: null,
        _requiresID: true,		
        validTags: ["div", "span"],
        defaults: $.extend(ej.datavisualization.Chart.prototype.defaults, {
            url: "",
            analysisMode: "pivot",
            operationalMode: "clientmode",
            cssClass: "",
            currentReport: "",
            customObject: {},
            enableRTL:false,
            isResponsive: false,
            enable3D: false,
            enableContextMenu: false,
            enableMultiLevelLabels: false,
            rotation: 0,
            serviceMethodSettings: {
                initialize: "InitializeChart",
                drillDown: "DrillChart",
                exportPivotChart: "Export",
                paging: "paging"
            },
            dataSource: {
                data: null,
                sourceInfo: "",
                providerName: "ssas",
                isFormattedValues: false,
                columns: [],
                cube: "",
                catalog: "",
                rows: [],
                values: [],
                filters: []
            },
            locale: null,
            drillSuccess: null,
            load: null,
            beforeServiceInvoke: null,
            afterServiceInvoke: null,
            renderComplete: null,
            renderFailure: null,
            renderSuccess: null,
            beforeExport:null,
            beforePivotEnginePopulate: null
        }),

        dataTypes: {
            dataSource: {
                data: "data",
                columns: "array",
                rows: "array",
                values: "array",
                filters: "array"
            },
            marker: "data",
            crossHair: "data",
            size: "data",
            serviceMethodSettings: {
                initialize: "enum",
                drillDown: "enum",
                exportPivotChart: "enum",
                paging: "enum"
            },
            zooming: "data",
            customObject: "data"
        },

        observables: ["title.text", "commonSeriesOptions.type", "locale"],
        titleText: ej.util.valueFunction("title.text"),
        seriesType: ej.util.valueFunction("commonSeriesOptions.type"),
        locale: ej.util.valueFunction("locale"),

        getOlapReport: function () {
            return this._olapReport;
        },

        setOlapReport: function (value) {
            this._olapReport = value;
        },

        getJSONRecords: function () {
            return this._JSONRecords;
        },

        setJSONRecords: function (value) {
            this._JSONRecords = $.parseJSON(value);
        },

        getPivotEngine: function () {
            return this._pivotEngine;
        },

        setPivotEngine: function (value) {
            this._pivotEngine = value;
        },

        _init: function () {
            this._initPrivateProperties();
            this._load();
        },

        _destroy: function () {
            this._pivotEngine = null;
            this.element.empty().removeClass("e-pivotchart" + this.model.cssClass);
            if (this._waitingPopup != undefined)
                this._waitingPopup._destroy();
        },

        _initPrivateProperties: function () {
            this._id = this.element.attr("id");
            this._olapReport = "";
            this._JSONRecords = null;
            this._currentAction = "initialize";
            this._selectedItem = "";
            this._selectedIndex = -1;
            this._selectedTagInfo = null;
            this._tagCollection = new Array();
            this._selectedTags = new Array();
            this._labelCurrentTags = new Array();
            this._startDrilldown = false;
            this._drillAction = "";
            this._initZooming = false;
            this._dimensionIndex = -1;
            this._selectedMenuItem = "";
            this._pivotEngine = null;
            this._curFocus = null;
            this._drillParams = [];
            this._currentDrillInfo = [];
            this._selectedSeriesInfo = new Array();
            this._waitingPopup = null;
            this._pivotClientObj = null;
        },

        _load: function () {
		    this.model.locale= this.model.locale || "en-US";
            var eventArgs = { action: "initialize", element: this.element, customObject: this.model.customObject };
            this._trigger("load", eventArgs);
            this.element.addClass(this.model.cssClass);

            if ($(this.element).parents(".e-pivotclient").length > 0) {
                this._pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                if ($("#" + this._pivotClientObj._id + "_maxView")[0])
                    $("#" + this._pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                else if (!ej.isNullOrUndefined(this._waitingPopup))
                    this._waitingPopup.show();
            }
            else {
                this.element.ejWaitingPopup({ showOnInit: true });
                this._waitingPopup = this.element.data("ejWaitingPopup");
                this._waitingPopup.show();
            }
            if (this.model.zooming != "")
                this._initZooming = true;
            if ((this.model.dataSource.data == null && this.model.url != "") || (this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode)) {
                this.model.operationalMode = ej.PivotChart.OperationalMode.ServerMode;
                if (this.model.url == "") {
                    this.renderChartFromJSON("");
                    return;
                }
                if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode)
                    this._trigger("beforeServiceInvoke", { action: this._currentAction, element: this.element, customObject: this.model.customObject });
                var serializedCustomObject = JSON.stringify(this.model.customObject);
                if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined)
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": "initialize", "currentReport": this.model.currentReport, "customObject": serializedCustomObject }), (this.model.enableMultiLevelLabels && this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot ? this._generateData : this.renderControlSuccess));
                else
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": "initialize" }), (this.model.enableMultiLevelLabels && this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot ? this._generateData : this.renderControlSuccess));
            }
            else {
                this.model.operationalMode = ej.PivotChart.OperationalMode.ClientMode;
                this.model.analysisMode = this.model.dataSource.cube != "" ? ej.PivotChart.AnalysisMode.Olap : ej.PivotChart.AnalysisMode.Pivot;
                this.refreshControl();
            }
        },

        refreshControl: function () {
            if (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot) {
                ej.PivotAnalysis.setFieldCaptions(this.model.dataSource);
                var data = ej.PivotAnalysis.pivotEnginePopulate(this.model);
                var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
                this._pivotEngine = data.pivotEngine;
                if (data.pivotEngine.length > 0) {
                    if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers) && !this.model.enableMultiLevelLabels) {
                        var clonedEngine = this._cloneEngine(this._pivotEngine);
                        for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++)
                            this._cropData(clonedEngine, this._labelCurrentTags.expandedMembers[i], 0, true);
                        this._generateData(clonedEngine);
                    }
                    else
                        this._generateData(this._pivotEngine);
                }
                else if (!ej.isNullOrUndefined(this._waitingPopup)) {
                    if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                    this._waitingPopup.hide();
            }
            }
            else
                ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
        },

        _setFirst: true,

        _setModel: function (options) {
            var chartObj = this.element.find("#" + this._id + "Container").data("ejChart");
            for (var key in options) {
                switch (key) {
                    case "olapReport": this.setOlapReport(options[key]); break;
                    case "jsonData": this.setJSONRecords(options[key]); break;
                    case "refreshPivotChart": this.element.renderChartFromJSON(options[key]); break;
                    case "customObject": this.model.customObject = options[key]; break;
                    case "height": this.model.size.height = options[key]; break;
                    case "width": this.model.size.width = options[key]; break;
                    case "commonSeriesOptions":
                        {
                            if (chartObj) {
                                chartObj.model.commonSeriesOptions = options[key];
                                chartObj.model.type = chartObj.model.commonSeriesOptions.type = this.seriesType();
                                for (var i = 0; i < chartObj.model.series.length; i++)
                                    chartObj.model.series[i].type = chartObj.model.type;
                            } break;
                        }
                    case "title":
                        {
                            if (chartObj)
                                chartObj.model.title.text = this.titleText();
                            break;
                        }
                    case "animation": this.model.animation = options[key]; break;
                    case "crossHair": this.model.crossHair = options[key]; break;
                    case "marker": this.model.marker = options[key]; break;
                    case "zooming": this.model.zooming = options[key]; break;
                    case "legend": this.model.legend = options[key]; break;
                    case "primaryXAxis": this.model.primaryXAxis = options[key]; break;
                    case "primaryYAxis": this.model.primaryYAxis = options[key]; break;
                    case "locale": this.locale(); break;
                    default:
                        { $.extend(true, this.model, {}, options[key]); }
                }
            }
            if (chartObj)
                this.renderControlSuccess({ "JsonRecords": JSON.stringify(this.getJSONRecords()), "OlapReport": this.getOlapReport() });
        },

        _keyDownPress: function (e) {
            if (e.which === 13 && (!ej.isNullOrUndefined(this._curFocus))) {
                this._curFocus.click();
            }
            if ((e.which === 39 || e.which === 37 || e.which === 38 || e.which === 40) && this.element.find(".e-dialog").length > 0) {
                e.preventDefault();
                var menu = this.element.find(".e-dialog");
                menu.tabindex = -1;
                menu.focus();
                var focEle = menu.find("li");
                var next;
                if (e.which === 39 || e.which === 40) {
                    if (!ej.isNullOrUndefined(this._curFocus)) {
                        this._curFocus.removeClass("hoverCell");
                        next = this._curFocus.next();
                        if (next.length > 0) {
                            this._curFocus = next;
                        }
                        else {
                            this._curFocus = focEle.eq(0);
                        }
                    }
                    else {
                        this._curFocus = focEle.eq(0);
                    }
                    this._curFocus.addClass("hoverCell");
                }
                else if (e.which === 37 || e.which === 38) {
                    if (!ej.isNullOrUndefined(this._curFocus)) {
                        this._curFocus.removeClass("hoverCell");
                        next = this._curFocus.prev();
                        if (next.length > 0) {
                            this._curFocus = next;
                        }
                        else {
                            this._curFocus = focEle.last();
                        }
                    }
                    else {
                        this._curFocus = focEle.last();
                    }
                    this._curFocus.addClass("hoverCell");
                }
            }
        },

        _wireEvents: function () {
            this._on($(document), 'keydown', this._keyDownPress);
            if (this.model.enableContextMenu && !(this.element.parents(".e-pivotclient").length > 0)) {
                this._on(this.element, "contextmenu", "#" + this._id + "Container", ej.proxy(function (evt) {
                    var chartTypes = "<li class='chartTypes'><a>" + this._getLocalizedLabels("ChartTypes") + "</a><ul><li class='line'><a>" + this._getLocalizedLabels("Line") + "</a></li><li class='spline'><a>" + this._getLocalizedLabels("Spline") + "</a></li>" +
                        "<li class='column'><a>" + this._getLocalizedLabels("Column") + "</a></li><li class='area'><a>" + this._getLocalizedLabels("Area") + "</a></li><li class='splinearea'><a>" + this._getLocalizedLabels("SplineArea") + "</a></li><li class='stepline'><a>" + this._getLocalizedLabels("StepLine") + "</a></li>" +
                        "<li class='steparea'><a>Step Area</a></li><li class='pie'><a>Pie</a></li><li class='bar'><a>Bar</a></li><li class='stackingarea'><a>Stacking Area</a></li>" +
                        "<li class='stackingcolumn'><a>" + this._getLocalizedLabels("StackingColumn") + "</a></li><li class='stackingbar'><a>" + this._getLocalizedLabels("StackingBar") + "</a></li><li class='funnel'><a>" + this._getLocalizedLabels("Funnel") + "</a></li>" +
                        "<li class='pyramid'><a>" + this._getLocalizedLabels("Pyramid") + "</a></li><li class='doughnut'><a>" + this._getLocalizedLabels("Doughnut") + "</a></li><li class='scatter'><a>" + this._getLocalizedLabels("Scatter") + "</a></li><li class='bubble'><a>" + this._getLocalizedLabels("Bubble") + "</a></li></ul></li>";
                    var chart3DTypes = "<li class='chart3DTypes'><a>" + this._getLocalizedLabels("TDCharts") + "</a><ul><li class='column'><a>" + this._getLocalizedLabels("ColumnTD") + "</a></li><li class='pie'><a>" + this._getLocalizedLabels("PieTD") + "</a></li><li class='bar'><a>" + this._getLocalizedLabels("BarTD") + "</a></li><li class='stackingbar'><a>"+this._getLocalizedLabels("StackingBarTD")+"</a></li>" +
                        "<li class='stackingcolumn'><a>" + this._getLocalizedLabels("StackingColumnTD") + "</a></li><li class='disable3D'><a>" + this._getLocalizedLabels("DisableTD") + "</a></li></ul></li>";
                    var exportTypes = "<li class='exportTypes'><a>" + this._getLocalizedLabels("Exporting") + "</a><ul><li class='excel'><a>" + this._getLocalizedLabels("Excel") + "</a></li><li class='word'><a>" + this._getLocalizedLabels("Word") + "</a></li><li class='pdf'><a>" + this._getLocalizedLabels("Pdf") + "</a></li><li class='png'><a>" + this._getLocalizedLabels("PNG") + "</a></li>" +
                        "<li class='emf'><a>" + this._getLocalizedLabels("EMF") + "</a></li><li class='gif'><a>" + this._getLocalizedLabels("GIF") + "</a></li><li class='jpg'><a>" + this._getLocalizedLabels("JPG") + "</a></li><li class='bmf'><a>" + this._getLocalizedLabels("BMP") + "</a></li></ul></li>";
                    var smartLabels = "<li class='smartLabels'><a>" + this._getLocalizedLabels("SmartLabels") + "</a><ul><li class='rotate45'><a>" + this._getLocalizedLabels("Rotate45") + "</a></li><li class='rotate90'><a>" + this._getLocalizedLabels("Rotate90") + "</a></li><li class='trim'><a>" + this._getLocalizedLabels("Trim") + "</a></li><li class='multipleRows'><a>" + this._getLocalizedLabels("MultipleRows") + "</a></li>" +
                        "<li class='wrap'><a>" + this._getLocalizedLabels("Wrap") + "</a></li><li class='hiding'><a>" + this._getLocalizedLabels("Hide") + "</a></li><li class='wrapByWord'><a>" + this._getLocalizedLabels("WrapByWord") + "</a></li></ul></li>";
                    var interaction = "<li class='interaction'><a>" + this._getLocalizedLabels("Interactions") + "</a><ul><li class='crossHair'><a>" + this._getLocalizedLabels("CrossHair") + "</a></li><li class='trackBall'><a>" + this._getLocalizedLabels("TrackBall") + "</a></li><li class='none'><a>" + this._getLocalizedLabels("None") + "</a></li></ul></li>";
                    var listContext = ej.buildTag("ul#" + this._id + "_ContextMenu",
                        ej.buildTag("li.toolTip", ej.buildTag("a", this._getLocalizedLabels("Tooltip"))[0].outerHTML)[0].outerHTML +
                        ej.buildTag("li.legend", ej.buildTag("a", this._getLocalizedLabels("Legend"))[0].outerHTML)[0].outerHTML +
                        (!this.model.enable3D?ej.buildTag("li.zooming", ej.buildTag("a", this._getLocalizedLabels("Zooming"))[0].outerHTML)[0].outerHTML:"") +
                        chartTypes + chart3DTypes + exportTypes + (!this.model.enable3D?(interaction + smartLabels):""))[0].outerHTML;

                    $("#" + this._id).append(listContext);
                    var ele = this.element.find("#" + this._id + "Container");

                    this.element.find("#" + this._id + "_ContextMenu").ejMenu({
                        width: "150px",
                        menuType: ej.MenuType.ContextMenu,
                        contextMenuTarget: ele,
                        enableRTL: this.model.enableRTL,
                        click: ej.proxy(this._contextMenuClick, this)
                    });
                    var enabledState = ej.buildTag("span.enabledState").addClass("e-icon").attr("aria-label", this._getLocalizedLabels("EnabledState"))[0].outerHTML;
                    if (this.model.enable3D)
                        $("#" + this._id + "_ContextMenu").find(".chart3DTypes ." + this.model.commonSeriesOptions.type + " a:eq(0)").append(enabledState);
                    else
                        $("#" + this._id + "_ContextMenu").find(".chartTypes ." + this.model.commonSeriesOptions.type + " a:eq(0)").append(enabledState);
                    if (this.model.commonSeriesOptions.tooltip.visible)
                        $("#" + this._id + "_ContextMenu").find(".toolTip a:eq(0)").append(enabledState);
                    if (this.model.zooming.enable)
                        $("#" + this._id + "_ContextMenu").find(".zooming a:eq(0)").append(enabledState);
                    if (this.model.legend.visible)
                        $("#" + this._id + "_ContextMenu").find(".legend a:eq(0)").append(enabledState);
                    if (this.model.primaryXAxis.labelIntersectAction != "none") {
                        $("#" + this._id + "_ContextMenu").find(".smartLabels a:eq(0)").append(enabledState);
                        $("#" + this._id + "_ContextMenu").find(".smartLabels ." + this.model.primaryXAxis.labelIntersectAction + " a:eq(0)").append(enabledState);
                        if (this.model.primaryXAxis.labelIntersectAction=="hide")
                            $("#" + this._id + "_ContextMenu").find(".smartLabels .hiding a:eq(0)").append(enabledState);
                    }
                    if (this.model.crosshair.type == "crosshair" && this.model.crosshair.visible) {
                        $("#" + this._id + "_ContextMenu").find(".interaction a:eq(0)").append(enabledState);
                        $("#" + this._id + "_ContextMenu").find(".interaction .crossHair a:eq(0)").append(enabledState);
                        if(!this.mode.enable3D)
                           $("#" + this._id + "_ContextMenu").ejMenu("disableItem", this._getLocalizedLabels("Tooltip"));
                     }
                    if (this.model.crosshair.type == "trackBall" && this.model.crosshair.visible) {
                        $("#" + this._id + "_ContextMenu").find(".interaction a:eq(0)").append(enabledState);
                        $("#" + this._id + "_ContextMenu").find(".interaction .trackBall a:eq(0)").append(enabledState);
                        if (!this.mode.enable3D)
                           $("#" + this._id + "_ContextMenu").ejMenu("disableItem", this._getLocalizedLabels("Tooltip"));
                    }
                    if (!this.model.crosshair.visible) {
                        $("#" + this._id + "_ContextMenu").find(".interaction .none a:eq(0)").append(enabledState);
                    }
                }));
            }
            this._on(this.element, "click", ".menuList", function (evt) {
                this._curFocus = null;               
                if (evt.target.innerHTML == this._getLocalizedLabels("Exit")) {
                    this.element.find("#" + this._id + "ExpandMenu, .expandMenu, .e-dialog").remove();
                }
                else if (evt.target.innerHTML.indexOf(this._getLocalizedLabels("Expand")) > -1) {
                    this._drillAction = "drilldown";
                    if ($(this.element).parents(".e-pivotclient").length > 0) {
                        var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                        if ($("#" + pivotClientObj._id + "_maxView")[0])
                            $("#" + pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                        else if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                    }
                    else if (!ej.isNullOrUndefined(this._waitingPopup))
                        this._waitingPopup.show();
                    if (this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode) {
                        var selectedMember = this.model.enableRTL ? evt.target.innerHTML.split(" - ")[0] : evt.target.innerHTML.split(" - ")[1];
                        if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                            this._getChartDrillDown("", selectedMember, evt);
                        }
                        else {
                            this._labelCurrentTags.collapsedMembers = $.grep(this._labelCurrentTags.collapsedMembers, function (item) { return item != selectedMember; });
                            var memberInfo = $(this.getJSONRecords().seriesTags).filter(function (index, item) { return item.split('::')[2] == selectedMember })[0];
                            var drilledMember = ej.olap._mdxParser._splitCellInfo(memberInfo);
                            this._getChartDrillDown(memberInfo, drilledMember, evt);
                        }
                    }
                    else {
                        var serializedCustomObject = JSON.stringify(this.model.customObject);
                        if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                            var selectedMember = this.model.enableRTL ? evt.target.innerHTML.split(" - ")[0] : evt.target.innerHTML.split(" - ")[1];
                            this._selectedItem = selectedMember;
                            if (ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) this._labelCurrentTags["expandedMembers"] = new Array();
                            this._labelCurrentTags.expandedMembers.push(selectedMember);
                            if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined)
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drilledSeries": JSON.stringify(this._labelCurrentTags.expandedMembers), "customObject": serializedCustomObject, "currentReport": JSON.parse(this.getOlapReport())["Report"] }), this.renderControlSuccess);
                            else
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drilledSeries": JSON.stringify(this._labelCurrentTags.expandedMembers), "currentReport": JSON.parse(this.getOlapReport())["Report"] }), this.renderControlSuccess);
                        }
                        else {
                            var pivotChartObj = this;
                            if (!this._isDrilled) {
                                this._isDrilled = true;
                                jQuery.each(evt.target.parentElement.children, function (index, value) {
                                    if (value.innerHTML == evt.target.innerHTML)
                                        pivotChartObj._dimensionIndex = index;
                                });
                            }
                            var report = this.getOlapReport();
                            this._drillAction = "drilldown";
                            if (this.model.enableRTL)
                                this._selectedItem = $.trim(evt.target.innerHTML.replace(" - " + this._getLocalizedLabels("Expand"), ""));
                            else
                                this._selectedItem = $.trim(evt.target.innerHTML.replace(this._getLocalizedLabels("Expand") + " - ", ""));
                            jQuery.each(this._labelCurrentTags, function (index, value) {
                                if (value.name == pivotChartObj._selectedItem) {
                                    pivotChartObj._tagCollection = [];
                                    pivotChartObj._tagCollection = pivotChartObj._selectedTags.slice();
                                    pivotChartObj._selectedTagInfo = value.tag;
                                    pivotChartObj._selectedMenuItem = value.name;
                                    return false;
                                }
                            });
                            this._startDrilldown = true;
                            if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode)
                                this._trigger("beforeServiceInvoke", { action: this._drillAction, element: this.element, customObject: this.model.customObject });
                            if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined) {
                                if (!ej.isNullOrUndefined(this._pivotClientObj))
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drilldown#fullchart" : "drilldown", "drilledSeries": this._selectedTagInfo, "olapReport": report, "clientReports": this._pivotClientObj.reports, "customObject": serializedCustomObject }), this.renderControlSuccess);
                                else
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drilldown#fullchart" : "drilldown", "drilledSeries": this._selectedTagInfo, "olapReport": report, "customObject": serializedCustomObject }), this.renderControlSuccess);
                            }
                            else {
                                if (ej.isNullOrUndefined(this._pivotClientObj))
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drilldown#fullchart" : "drilldown", "drilledSeries": this._selectedTagInfo, "olapReport": report }), this.renderControlSuccess);
                                else
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drilldown#fullchart" : "drilldown", "drilledSeries": this._selectedTagInfo, "olapReport": report, "clientReports": this._pivotClientObj.reports }), this.renderControlSuccess);
                            }
                        }
                    }
                }
                else {
                    this._drillAction = "drillup";
                    if ($(this.element).parents(".e-pivotclient").length > 0) {
                        var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                        if ($("#" + pivotClientObj._id + "_maxView")[0])
                            $("#" + pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                        else if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.show();
                    }
                    else if (!ej.isNullOrUndefined(this._waitingPopup))
                        this._waitingPopup.show();
                    if (this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode) {
                        var selectedMember = this.model.enableRTL ? evt.target.innerHTML.split(" - ")[0] : evt.target.innerHTML.split(" - ")[1];
                        this._getChartDrillDown("", selectedMember, evt);
                                }
                        else {
                        var serializedCustomObject = JSON.stringify(this.model.customObject);
                        if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                            var selectedMember = this.model.enableRTL ? evt.target.innerHTML.split(" - ")[0] : evt.target.innerHTML.split(" - ")[1];
                            var flag = false, tempArray = new Array();
                            jQuery.map(this._labelCurrentTags.expandedMembers, function (member) {
                                if (member == selectedMember) flag = true;
                                if (!flag) tempArray.push(member);
                            });
                            this._selectedItem = selectedMember;
                            this._labelCurrentTags.expandedMembers = tempArray;
                            this._currentDrillInfo = $.extend([], this._labelCurrentTags.expandedMembers, true).concat([selectedMember]);
                            if ($(this.element).parents(".e-pivotclient").length > 0) {
                                this._labelCurrentTags.expandedMembers = [];
                                var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                                if (pivotClientObj._drillParams.length > 0) {
                                    pivotClientObj._drillParams = $.grep(pivotClientObj._drillParams, function (item) { return item.indexOf(selectedMember) < 0; });
                                    pivotClientObj._getDrilledMember();
                                }
                            }
                            if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined)
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drilledSeries": JSON.stringify(this._labelCurrentTags.expandedMembers), "customObject": serializedCustomObject, "currentReport": JSON.parse(this.getOlapReport())["Report"]}), this.renderControlSuccess);
                            else
                                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drilledSeries": JSON.stringify(this._labelCurrentTags.expandedMembers), "currentReport": JSON.parse(this.getOlapReport())["Report"] }), this.renderControlSuccess);
                        }
                        else {
                            var report = this.getOlapReport();
                            this._drillAction = "drillup";
                            if (this.model.enableRTL)
                                this._selectedItem = $.trim(evt.target.innerHTML.replace(" - " + this._getLocalizedLabels("Collapse"), ""));
                            else
                                this._selectedItem = $.trim(evt.target.innerHTML.replace(this._getLocalizedLabels("Collapse") + " - ", ""));
                            this._tagCollection = [];
                            this._tagCollection = this._selectedTags.slice();
                            var pivotChartObj = this;
                            jQuery.each(this._tagCollection, function (index, value) {
                                if (value.name == pivotChartObj._selectedItem) {
                                    pivotChartObj._selectedIndex = index;
                                    pivotChartObj._selectedTagInfo = value.tag;
                                    pivotChartObj._tagCollection.splice(index, pivotChartObj._tagCollection.length);
                                    return false;
                                }
                            });
                            if (this._tagCollection.length == 0)
                                this._isDrilled = false;
                            this._startDrilldown = true;
                            if (this.model.beforeServiceInvoke != null && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode)
                                this._trigger("beforeServiceInvoke", { action: this._drillAction, element: this.element, customObject: this.model.customObject });
                            if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined) {
                                if (!ej.isNullOrUndefined(this._pivotClientObj))
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drillup#fullchart" : "drillup", "drilledSeries": this._selectedTagInfo, "olapReport": report, "clientReports": this._pivotClientObj.reports, "customObject": serializedCustomObject }), this.renderControlSuccess);
                                else
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drillup#fullchart" : "drillup", "drilledSeries": this._selectedTagInfo, "olapReport": report, "customObject": serializedCustomObject }), this.renderControlSuccess);
                            }
                            else {
                                if (ej.isNullOrUndefined(this._pivotClientObj))
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drillup#fullchart" : "drillup", "drilledSeries": this._selectedTagInfo, "olapReport": report }), this.renderControlSuccess);
                                else
                                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this.model.enableMultiLevelLabels ? "drillup#fullchart" : "drillup", "drilledSeries": this._selectedTagInfo, "olapReport": report, "clientReports": reports }), this.renderControlSuccess);
                            }
                        }
                    }
                }				
            });
            if (ej.isNullOrUndefined(this._pivotClientObj))
                $(window).on('resize', $.proxy(this._reSizeHandler, this));
            
            
                this._on(this.element, "click", ".chart3DImg", function (evt) {
                    var pivotchrt = this;
                    pivotchrt._createDialog(evt);
                    $(".chart3DTypesIcon").click(function (e) {
                        pivotchrt._contextMenuClick(e);
                        if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                            pivotchrt._pivotClientObj._unWireEvents();
                            pivotchrt._pivotClientObj._wireEvents();
                        }
                    });
                });

                if (this.element.parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar && !this._pivotClientObj.model.displaySettings.enableFullScreen) {
                    this._on(this.element, "click", ".toolTipImg", function (evt) {
                        var pivotchart = this;
                        this.model.commonSeriesOptions.tooltip.visible = !this.model.commonSeriesOptions.tooltip.visible;
                        this.renderChartFromJSON((this.getJSONRecords()));
                        if (this.model.commonSeriesOptions.tooltip.visible)
                            this.element.find(".toolTipImg").addClass("enabled");
                        else
                            this.element.find(".toolTipImg").removeClass("enabled");
                     });
                this._on(this.element, "click", ".exportImg", function (evt) {
                    var pivotChart = this;
                    pivotChart._createDialog(evt);
                 $(".exportTypesIcon").click(function (e) {
                        pivotChart._contextMenuClick(e);
                    });
                });
                this._on(this.element, "click", ".smartLabels", function (evt) {
                    var pivotChart = this;
                    pivotChart._createDialog(evt);
                    $(".smartLabelsIcon").click(function (e) {
                        pivotChart._contextMenuClick(e);
                    });
                });
                this._on(this.element, "click", ".interaction", function (evt) {
                    var pivotChart = this;
                    pivotChart._createDialog(evt);
                    $(".interactionsIcon").click(function (e) {
                        pivotChart._contextMenuClick(e);
                    });
                });
                this._on(this.element, "click", ".legend", function (evt) {
                    var pivotChart = this;
                    pivotChart._contextMenuClick(evt);
                });
                this._on(this.element, "click", ".zooming", function (evt) {
                    var pivotChart = this;
                    pivotChart._contextMenuClick(evt);
                });
            }
        },

        _unWireEvents: function () {
            this._off($(document), 'keydown', this._keyDownPress);
            $(document.body).off("click");
            this._off(this.element, "click", ".menuList");
            $(window).off('resize', $.proxy(this._reSizeHandler, this));
            this._off(this.element, "contextmenu");
            this._off(this.element, "click", ".chartTypesImg");
            this._off(this.element, "click", ".toolTipImg");
            this._off(this.element, "click", ".chart3DImg");
            this._off(this.element, "click", ".exportImg");
            this._off(this.element, "click", ".legend");
            this._off(this.element, "click", ".zooming");
            this._off(this.element, "click", ".smartLabels");
            this._off(this.element, "click", ".interaction");
        },
        _createDialog: function (evt) {
            var pivotchrt = this;
            if ($(evt.target).hasClass("exportImg")) {
                var exportTypesDlg = ej.buildTag("div.exportTypesDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                    ej.buildTag("td", ej.buildTag("div.excel exportTypesIcon").attr({ "title": this._getLocalizedLabels("Excel"), "aria-label": this._getLocalizedLabels("Excel"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.word exportTypesIcon").attr({ "title": this._getLocalizedLabels("Word"), "aria-label": this._getLocalizedLabels("Word"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.pdf exportTypesIcon").attr({ "title": this._getLocalizedLabels("Pdf"), "aria-label": this._getLocalizedLabels("Pdf"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.png exportTypesIcon").attr({ "title": this._getLocalizedLabels("PNG"), "aria-label": this._getLocalizedLabels("PNG"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                    ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.emf exportTypesIcon").attr({ "title": this._getLocalizedLabels("EMF"), "aria-label": this._getLocalizedLabels("EMF"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.gif exportTypesIcon").attr({ "title": this._getLocalizedLabels("GIF"), "aria-label": this._getLocalizedLabels("GIF"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.jpg exportTypesIcon").attr({ "title": this._getLocalizedLabels("JPG"), "aria-label": this._getLocalizedLabels("JPG"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                    ej.buildTag("td", ej.buildTag("div.bmp exportTypesIcon").attr({ "title": this._getLocalizedLabels("BMF"), "aria-label": this._getLocalizedLabels("BMF"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
            if (this.element.find('div.exportTypesDialog').length == 0) {
                    $(exportTypesDlg).appendTo(this.element);
                    $(exportTypesDlg).css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop + 15)+ "px");
                    if (this.model.enableRTL)
                        $(exportTypesDlg).addClass("e-rtl");
                }
            }
            else if ($(evt.target).hasClass("chart3DImg")) {
                var chart3DTypesDialog = ej.buildTag("div.chart3DTypesDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                        ej.buildTag("td", ej.buildTag("div.column3D chart3DTypesIcon").attr({ "title": this._getLocalizedLabels("ColumnTD"), "aria-label": this._getLocalizedLabels("ColumnTD"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.pie3D chart3DTypesIcon").attr({ "title": this._getLocalizedLabels("PieTD"), "aria-label": this._getLocalizedLabels("PieTD"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                        ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.bar3D chart3DTypesIcon").attr({ "title": this._getLocalizedLabels("BarTD"), "aria-label": this._getLocalizedLabels("BarTD"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.stackingbar3D chart3DTypesIcon").attr({ "title": this._getLocalizedLabels("StackingBarTD"), "aria-label": this._getLocalizedLabels("StackingBarTD"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                        ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.stackingcolumn3D chart3DTypesIcon").attr({ "title": this._getLocalizedLabels("StackingColumnTD"), "aria-label": this._getLocalizedLabels("StackingColumnTD"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.disable3D chart3DTypesIcon")[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
                if (this.element.find('div.chart3DTypesDialog').length == 0) {
                    $(chart3DTypesDialog).appendTo(this.element);
                    $(chart3DTypesDialog).css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop + 15) + "px");
                    if (pivotchrt.model.enable3D) {
                        $("." + this.model.type+"3D").addClass("enabled");
                    }
                    if (this.model.enableRTL)
                        $(chart3DTypesDialog).addClass("e-rtl");
                }
            }
            else if ($(evt.target).hasClass("smartLabels")) {
                var smartLabelsDialog = ej.buildTag("div.smartLabelsDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                        ej.buildTag("td", ej.buildTag("div.rotate45 smartLabelsIcon").attr({ "title": this._getLocalizedLabels("Rotate45"), "aria-label": this._getLocalizedLabels("Rotate45"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.rotate90 smartLabelsIcon").attr({ "title": this._getLocalizedLabels("Rotate90"), "aria-label": this._getLocalizedLabels("Rotate90"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.trim smartLabelsIcon").attr({ "title": this._getLocalizedLabels("Trim"), "aria-label": this._getLocalizedLabels("Trim"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                        ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.multipleRows smartLabelsIcon").attr({ "title": this._getLocalizedLabels("MultipleRows"), "aria-label": this._getLocalizedLabels("MultipleRows"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.wrap smartLabelsIcon").attr({ "title": this._getLocalizedLabels("Wrap"), "aria-label": this._getLocalizedLabels("Wrap"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.hiding smartLabelsIcon").attr({ "title": this._getLocalizedLabels("Hide"), "aria-label": this._getLocalizedLabels("Hide"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML +
                        ej.buildTag("tr", ej.buildTag("td", ej.buildTag("div.wrapByWord smartLabelsIcon").attr({ "title": this._getLocalizedLabels("WrapByWord"), "aria-label": this._getLocalizedLabels("WrapByWord"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
                if (this.element.find('div.smartLabelsDialog').length == 0) {
                    $(smartLabelsDialog).appendTo(this.element);
                    $(smartLabelsDialog).css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop + 15) + "px");
                    if (pivotchrt.model.primaryXAxis.labelIntersectAction != "none" && pivotchrt.model.primaryXAxis.labelIntersectAction != "hide" && pivotchrt.model.primaryXAxis.labelIntersectAction != undefined)
                        $("." + pivotchrt.model.primaryXAxis.labelIntersectAction).addClass("enabled");
                    if (pivotchrt.model.primaryXAxis.labelIntersectAction == "hide")
                        $(".hiding").addClass("enabled");
                    if (this.model.enableRTL)
                        $(smartLabelsDialog).addClass("e-rtl");
                }
            }

            else if ($(evt.target).hasClass("interaction")) {
                var interactionsDialog = ej.buildTag("div.interactionsDialog", ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr",
                        ej.buildTag("td", ej.buildTag("div.crossHair interactionsIcon").attr({ "title": this._getLocalizedLabels("CrossHair"), "aria-label": this._getLocalizedLabels("CrossHair"), tabindex: 0 })[0].outerHTML)[0].outerHTML +
                        ej.buildTag("td", ej.buildTag("div.trackBall interactionsIcon").attr({ "title": this._getLocalizedLabels("TrackBall"), "aria-label": this._getLocalizedLabels("TrackBall"), tabindex: 0 })[0].outerHTML)[0].outerHTML+
                        ej.buildTag("td", ej.buildTag("div.none interactionsIcon").attr({ "title": this._getLocalizedLabels("None"), "aria-label": this._getLocalizedLabels("None"), tabindex: 0 })[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML)[0].outerHTML);
                if (this.element.find('div.interactionsDialog').length == 0) {
                    $(interactionsDialog).appendTo(this.element);
                    $(interactionsDialog).css("left", evt.target.offsetLeft + 20 + "px").css("top", (evt.target.offsetTop + 15) + "px");
                    if (this.model.crosshair.type == "crosshair" && this.model.crosshair.visible) {
                        this.element.find(".crossHair").addClass("enabled");
                    }
                    if (this.model.crosshair.type == "trackBall" && this.model.crosshair.visible) {
                       this.element.find(".trackBall").addClass("enabled");
                    }
                    if (!this.model.crosshair.visible) {
                        this.element.find(".none").addClass("enabled");
                    }
                    if (this.model.enableRTL)
                        $(interactionsDialog).addClass("e-rtl");
                }
            }

        },
        _contextMenuClick: function (evt) {
            chrtObj = $("#" + this._id).data("ejPivotChart");
            var selectedValue = $(this.element).parents(".e-pivotclient").length > 0 ? $(evt.target).attr("class").split(" ")[0] : $(evt.element).attr("class").split(" ")[0];
            if($(evt.element).parents().hasClass("chartTypes"))
            {
                chrtObj.model.enable3D = false;
                chrtObj.model.type = chrtObj.model.commonSeriesOptions.type = selectedValue;
                if (chrtObj.model.type == "funnel") {
                    chrtObj.model.commonSeriesOptions.marker = {
                        dataLabel: {
                            visible: true,
                            shape: 'none',
                            font: { color: 'white', size: '12px', fontWeight: 'lighter' }
                        }
                    }
                }
                if (chrtObj.model.type == "pie" || chrtObj.model.type == "doughnut") {
                    chrtObj.model.commonSeriesOptions.explode = true;
                }
                chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
            else if ($(evt.element).hasClass("toolTip"))
            {
                chrtObj.model.commonSeriesOptions.tooltip.visible = !chrtObj.model.commonSeriesOptions.tooltip.visible;
                chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
           else if ($(evt.element).hasClass("legend") || $(evt.target).hasClass("legend")) {
                chrtObj.model.legend.visible = !chrtObj.model.legend.visible;
                chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
            else if ($(evt.element).hasClass("zooming") || $(evt.target).hasClass("zooming")) {
                chrtObj.model.zooming.enable = !chrtObj.model.zooming.enable;
                chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
            else if ($(evt.element).parents().hasClass("smartLabels") || $(evt.target).hasClass("smartLabelsIcon")) {
                if (selectedValue == "hiding")
                    chrtObj.model.primaryXAxis.labelIntersectAction = "hide";
                else
                    chrtObj.model.primaryXAxis.labelIntersectAction = selectedValue;
                chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
           else if ($(evt.element).parents().hasClass("interaction") || $(evt.target).hasClass("interactionsIcon")) {
               if (selectedValue == "crossHair") {
                   chrtObj.model.crosshair.type = ej.datavisualization.Chart.CrosshairType.Crosshair;
                   chrtObj.model.crosshair.visible = true;
                   }
               if (selectedValue == "trackBall") {
                   chrtObj.model.crosshair.type = ej.datavisualization.Chart.CrosshairType.TrackBall;
                   chrtObj.model.crosshair.visible = true;
                   }
               if (selectedValue == "none")
                   chrtObj.model.crosshair.visible = false;
               
              chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
            else if ($(evt.element).parents().hasClass("chart3DTypes") || $(evt.target).hasClass("chart3DTypesIcon"))
            {
                chrtObj.model.enable3D = true;
                if (selectedValue != "disable3D")
                    selectedValue = selectedValue.split("3")[0];
                if (selectedValue == "disable3D") {
                    chrtObj.model.enable3D = false;
                    selectedValue = chrtObj.model.commonSeriesOptions.type;
                }
                chrtObj.model.type = chrtObj.model.commonSeriesOptions.type = selectedValue;
                if (selectedValue == "pie") {
                    chrtObj.model.rotation = 24;
                }
                chrtObj.renderControlSuccess({ "JsonRecords": JSON.stringify(chrtObj.getJSONRecords()), "OlapReport": chrtObj.getOlapReport() });
            }
            else
            {
                if ($(this.element).parents(".e-pivotclient").length > 0 && !ej.isNullOrUndefined(this._pivotClientObj))
                    this.model.beforeExport = this._pivotClientObj.model.beforeExport;
                switch (selectedValue) {
                    case "excel":
                    case "word":
                    case "pdf":
                        chrtObj.exportPivotChart(selectedValue, "Sample");
                        break;
                    case "png":
                        chrtObj.exportPivotChart(selectedValue, "Sample", ej.PivotChart.ExportOptions.PNG);
                        break;
                    case "emf":
                        chrtObj.exportPivotChart(selectedValue, "Sample", ej.PivotChart.ExportOptions.EMF);
                        break;
                    case "gif":
                        chrtObj.exportPivotChart(selectedValue, "Sample", ej.PivotChart.ExportOptions.GIF);
                        break;
                    case "jpg":
                        chrtObj.exportPivotChart(selectedValue, "Sample", ej.PivotChart.ExportOptions.JPG);
                        break;
                    case "bmp":
                        chrtObj.exportPivotChart(selectedValue, "Sample", ej.PivotChart.ExportOptions.BMP);
                        break;
              }   
            }
        },

        generateJSON: function (baseObj, pivotEngine) {
            if ((!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) && this._labelCurrentTags.expandedMembers.length > 0 && !this.model.enableMultiLevelLabels) {
                var exceedIndex = 0;
                for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++) {
                    if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[i]) && this._labelCurrentTags.expandedMembers[i].length > 0) {
                        if (i > 0 && !ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[i - 1]) && this._labelCurrentTags.expandedMembers[i - 1].length > 0)
                            this._cropData(pivotEngine, this._selectedSeriesInfo[i - 1].split('::')[2], (i - 1) + exceedIndex, false);
                        for (var j = 0; j < this._labelCurrentTags.expandedMembers[i].length; j++) {
                            this._cropData(pivotEngine, this._labelCurrentTags.expandedMembers[i][j].split('::')[2], i + exceedIndex, true);
                            exceedIndex++;
                        }
                    }
                }
            }
            this._generateData(pivotEngine);
        },

        _jsonToEngine: function (item) {
            var tempEngine = JSON.parse(item);
            var pivotEngine = [];
            for (var i = 0; i < tempEngine.length; i++) {
                var colIndex = parseInt(tempEngine[i].Index.split(',')[0]);
                if (ej.isNullOrUndefined(pivotEngine[colIndex])) {
                    pivotEngine[colIndex] = [];
                    pivotEngine[colIndex].push(tempEngine[i]);
                }
                else {
                    pivotEngine[colIndex].push(tempEngine[i]);
                }
            }
            return pivotEngine;
        },

        _generateData: function (pivotEngine) {
            var isOlapServerMode = false;
            if (pivotEngine[2] != undefined)
                isOlapServerMode = (pivotEngine[2].Value == "Olap" || pivotEngine[2] == "Olap") ? true : false;
            else if (pivotEngine.d != undefined)
                isOlapServerMode = !ej.isNullOrUndefined(pivotEngine.d[2]) && (pivotEngine.d[2].Value == "Olap") ? true : false;
            else
                isOlapServerMode = pivotEngine.AnalysisMode == "Olap" ? true : false;
            if (!isOlapServerMode) {
            var chartData = {
                seriesNames: [],
                chartLables: [],
                labelTags: [],
                    multiLevelLabels: [],
                    multiLevelLabelTags: [],
                seriesTags: [],
                points_Y: [],
                    labelFormat: [],
                measureNames: ""
            };
                var pivotReport = "", values = [];
                if (this.model.enableMultiLevelLabels && this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                    var tempEngine = {};
                    if (pivotEngine[0] != undefined) {
                        if ($(this.element).parents(".e-pivotclient").length > 0) {
                            tempEngine["JsonRecords"] = ej.isNullOrUndefined(pivotEngine[0].Value) ? pivotEngine[0] : pivotEngine[0].Value;
                        }
                        else {
                            tempEngine["JsonRecords"] = {};
                            (tempEngine["JsonRecords"])["ChartJSON"] = ej.isNullOrUndefined(pivotEngine[0].Value) ? pivotEngine[0] : pivotEngine[0].Value;
                            (tempEngine["JsonRecords"])["GridJSON"] = ej.isNullOrUndefined(pivotEngine[3].Value) ? pivotEngine[3] : pivotEngine[3].Value;
                        }
                        tempEngine["PivotReport"] = ej.isNullOrUndefined(pivotEngine[1].Value) ? pivotEngine[1] : pivotEngine[1].Value;
                        pivotEngine = tempEngine;
                    }
                    else if (pivotEngine.d != undefined) {
                        if ($(this.element).parents(".e-pivotclient").length > 0) {
                            tempEngine["JsonRecords"] = !ej.isNullOrUndefined(pivotEngine.d[0]) && (pivotEngine.d[0].Key == "JsonRecords") ? pivotEngine.d[0].Value : [];
                        }
                        else {
                            tempEngine["JsonRecords"] = {};
                            (tempEngine["JsonRecords"])["ChartJSON"] = !ej.isNullOrUndefined(pivotEngine.d[0]) && (pivotEngine.d[0].Key == "JsonRecords") ? pivotEngine.d[0].Value : [];
                            (tempEngine["JsonRecords"])["GridJSON"] = !ej.isNullOrUndefined(pivotEngine.d[3]) && (pivotEngine.d[3].Key == "GridJSON") ? pivotEngine.d[3].Value : [];
                        }                        
                        tempEngine["PivotReport"] = !ej.isNullOrUndefined(pivotEngine.d[1]) && ((pivotEngine.d[1].Key == "PivotReport") || (pivotEngine.d[1].Key == "OlapReport")) ? pivotEngine.d[1].Value : [];
                        pivotEngine = tempEngine;
                    }
                    pivotReport = pivotEngine.PivotReport || pivotEngine.OlapReport;
                    if (!ej.isNullOrUndefined(pivotEngine.JsonRecords.GridJSON)) {
                        pivotEngine = this._jsonToEngine(pivotEngine.JsonRecords.GridJSON);
                    }
                    else if (ej.isNullOrUndefined(pivotEngine.GridJSON))
                        pivotEngine = pivotEngine.JsonRecords;
                    else
                        pivotEngine = this._jsonToEngine(pivotEngine.GridJSON);
                    this._pivotEngine = pivotEngine;
                    values = ej.isNullOrUndefined(JSON.parse(pivotReport).values) ? JSON.parse(pivotReport).PivotCalculations : JSON.parse(JSON.parse(pivotReport).values);
                    chartData.labelFormat = $.map(values, function (items) { return items.Format.toLowerCase() });
                }
            var columnCount = pivotEngine.length;
            if (columnCount > 0 && pivotEngine[0].length > 0) {
                var rowCount = pivotEngine[0].length;
                var summaryColumns = new Array();
                var summaryRows = new Array();

                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot)
                        var rowHeaderWidth = (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers) && !this.model.enableMultiLevelLabels) ? this.model.dataSource.rows.length - this._labelCurrentTags.expandedMembers.length : (this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode ? (pivotEngine[0])[0].ColSpan : this.model.dataSource.rows.length);
                    else
                        var rowHeaderWidth = pivotEngine[0][0].ColSpan;

                    if (this.model.enableMultiLevelLabels && ((this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) || this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap)) {
                        var columnHeaderHeight = (pivotEngine[0])[0].RowSpan;
                    }
                    else {
                var columnHeaderHeight = this.model.dataSource.columns.length;
                        if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot)
                            columnHeaderHeight += this.model.dataSource.values.length > 0 ? 1 : 0;
                        else
                            columnHeaderHeight = (pivotEngine[0])[0].RowSpan;
                    }

                    //Getting Series Labels
                var measure = "";
                for (var i = rowHeaderWidth; i < columnCount; i++) {
                    var seriesName = "";
                    var isSummary = false;
                    for (var j = 0; j < columnHeaderHeight; j++) {
                        if (!ej.isNullOrUndefined(pivotEngine[i][j])) {
                            if (pivotEngine[i][j].CSS.indexOf("summary") >= 0) {
                                isSummary = true;
                                summaryColumns.push(i);
                                    break;
                                }
                                if (pivotEngine[i][j].Info.indexOf("Measure") >= 0 && measure.indexOf(pivotEngine[i][j].Value) < 0) {
                                    measure += measure == "" ? pivotEngine[i][j].Value : "~~" + pivotEngine[i][j].Value;
                                }
                                seriesName += (seriesName == "" ? "" : (pivotEngine[i][j].Value == "" ? "" : "~~")) + pivotEngine[i][j].Value;
                            }
                        }
                        if (!isSummary && seriesName != "") chartData.seriesNames.push(seriesName);
                }

                //Getting Chart Labels
                for (var i = columnHeaderHeight; i < rowCount; i++) {
                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                            if (this.model.enableMultiLevelLabels && rowHeaderWidth > 1) {
                                this._drillParams = this._drillAction != "" ? this._drillParams : [];
                                var drillParams = $.extend(true, [], this._drillParams.sort());
                                var lockedColumn = drillParams.length > 0 ? -1 : 0, lockedSeries = "";
                                for (var i = columnHeaderHeight; i < rowCount; i++) {
                                    var drilledRowSeries = drillParams[0];
                                    var engineSeries = "";
                                    for (j = 0; j < rowHeaderWidth; j++) {
                                        engineSeries += engineSeries == "" ? pivotEngine[j][i].Value : ">#>" + pivotEngine[j][i].Value;
                                        if (lockedColumn == -1 || lockedSeries == "" || engineSeries == drillParams[1]) {
                                            if (engineSeries == drilledRowSeries || engineSeries == drillParams[1]) {
                                                if (engineSeries == drillParams[1]) {
                                                    drilledRowSeries = drillParams[1];
                                                    drillParams.splice(0, 1);
                                                }
                                                lockedColumn = j + 1;
                                                lockedSeries = engineSeries;
                                            }
                                        }
                                        if (!ej.isNullOrUndefined(drilledRowSeries) && lockedColumn > 0 && lockedColumn == rowHeaderWidth - 1 && j == rowHeaderWidth - 1) {
                                            summaryRows.push(i);
                                            chartData.chartLables.push(drilledRowSeries.split('>#>').join('~~') + "~~" + pivotEngine[j][i].Value);
                                        }
                                        else if (!ej.isNullOrUndefined(drilledRowSeries) && lockedColumn > 0 && lockedColumn == j && pivotEngine[j][i].CSS.indexOf("summary") > -1) {
                                            summaryRows.push(i);
                                            chartData.chartLables.push(drilledRowSeries.split('>#>').join('~~') + "~~" + pivotEngine[j][i].Value.split(" Total")[0]);
                                        }
                                        else if (lockedColumn - 1 == j && pivotEngine[j][i].CSS.indexOf("summary") > -1) {
                                            if (lockedSeries != "") {
                                                drillParams[0] = drillParams[0].split('>#>').slice(0, drillParams[0].split('>#>').length - 1).join('>#>');
                                                if (drillParams[0] == "") {
                                                    drillParams.splice(0, 1);
                                                    lockedSeries = "";
                                                }
                                            }
                                            lockedColumn = lockedColumn - 1;
                                        }
                                        else if ((lockedColumn == 0 || lockedSeries == "") && j == 0 && pivotEngine[0][i].CSS.indexOf("summary") > -1 && (!ej.isNullOrUndefined(drilledRowSeries) ? (drilledRowSeries.split('>#>')[0] != pivotEngine[0][i].Value.split(" Total")[0]) : true) && pivotEngine[j][i].Value != "Grand Total") {
                                            summaryRows.push(i);
                                            chartData.chartLables.push(pivotEngine[j][i].Value.split(" Total")[0]);
                                        }
                                    }
                                }
                            }
                            else {
                        if (rowHeaderWidth > 1) {
                            if (pivotEngine[0][i].CSS == "summary rstot" && pivotEngine[0][i].Value != "Grand Total")
                                chartData.chartLables.push(pivotEngine[0][i].Value.replace(" Total", ""));
                        }
                        else if (pivotEngine[0][i].CSS == "rowheader")
                            chartData.chartLables.push(pivotEngine[0][i].Value);
                    }
                            if (this.model.enableMultiLevelLabels)
                                chartData.multiLevelLabels = $.extend(true, [], chartData.chartLables);
                        }
                    else {
                        if (ej.isNullOrUndefined(this._labelCurrentTags.collapsedMembers)) this._labelCurrentTags["collapsedMembers"] = new Array();
                        if (rowHeaderWidth > 1) {
                                var chartLabel = "", isSummary = false, labelTag = "";
                                for (var j = 0; j < rowHeaderWidth; j++) {
                                    if (pivotEngine[j][i].CSS == "rowheader") {
                                        chartLabel += chartLabel == "" ? pivotEngine[j][i].Value : ((pivotEngine[j][i].Info != "" && pivotEngine[j - 1][i].Info != "" && pivotEngine[j][i].Info.split('::')[3] == pivotEngine[j - 1][i].Info.split('::')[0]) ? "#" : "~~") + pivotEngine[j][i].Value;
                                        if (pivotEngine[j][i].Info.indexOf("[Measures]") == -1) labelTag += labelTag == "" ? pivotEngine[j][i].Info : ((pivotEngine[j][i].Info != "" && pivotEngine[j - 1][i].Info != "" && pivotEngine[j][i].Info.split('::')[3] == pivotEngine[j - 1][i].Info.split('::')[0]) ? "#" : "~~") + pivotEngine[j][i].Info;
                                        if ($.inArray(pivotEngine[j][i].Value, this._labelCurrentTags.collapsedMembers) < 0 && pivotEngine[j][i].State == 2) this._labelCurrentTags.collapsedMembers.push(pivotEngine[j][i].Value);
                                        if ($.inArray(pivotEngine[j][i].Info, chartData.seriesTags) < 0 && pivotEngine[j][i].Info.indexOf("[Measures]") == -1) chartData.seriesTags.push(pivotEngine[j][i].Info);
                                    }
                                    else {
                                        if ((!this.model.enableMultiLevelLabels || chartLabel == "" || pivotEngine[j][i].CSS.indexOf("summary") >= 0) && (!this.model.enableMultiLevelLabels ? (pivotEngine[j][i].CSS.indexOf("none") == -1 && pivotEngine[j][i].CSS.indexOf("value") == -1) : true)) {
                                            isSummary = true;
                                            summaryRows.push(i);
                                            break;
                                }
                            }
                                }
                            if (!isSummary) {
                                chartData.chartLables.push(chartLabel);
                                chartData.labelTags.push(labelTag);
                            }
                        }
                        else {
                            if (pivotEngine[0][i].CSS == "rowheader") {
                                chartData.chartLables.push(pivotEngine[0][i].Value);
                                chartData.labelTags.push(pivotEngine[0][i].Info);
                                chartData.seriesTags.push(pivotEngine[0][i].Info);
                            }
                            if (pivotEngine[0][i].State == 2) this._labelCurrentTags.collapsedMembers.push(pivotEngine[0][i].Value);
                        }
                    }
                }


                    //Getting Multilevel Labels
                    if (this.model.enableMultiLevelLabels) {
                        if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                            var maxLength = 0;
                            for (var j = 0; j < chartData.multiLevelLabels.length; j++) {
                                chartData.multiLevelLabels[j] = $.map(chartData.multiLevelLabels[j].split('~~'), function (item) {
                                    return item + "#1";
                                }).join('~~');
                                maxLength = chartData.multiLevelLabels[j].split('~~').length > maxLength ? chartData.multiLevelLabels[j].split('~~').length : maxLength;
                            }
                            for (var k = 0; k < chartData.multiLevelLabels.length; k++) {
                                if (maxLength > 1 && chartData.multiLevelLabels[k].split('~~').length < maxLength) {
                                    var childMember = chartData.multiLevelLabels[k].split('~~')[chartData.multiLevelLabels[k].split('~~').length - 1].split('#1')[0];
                                    do {
                                        chartData.multiLevelLabels[k] += "~~" + childMember + "#0";
                                    } while (chartData.multiLevelLabels[k].split('~~').length < maxLength);;
                                }
                            }
                        }
                        else {
                            for (var i = columnHeaderHeight; i < rowCount; i++) {
                                if (rowHeaderWidth > 1) {
                                    var chartLabel = "", labelTag = "", isSummary = false;
                                    for (var j = 0; j < rowHeaderWidth; j++) {
                                        if (pivotEngine[j][i].CSS == "rowheader") {
                                            chartLabel += chartLabel == "" ? (pivotEngine[j][i].Value + "#" + pivotEngine[j][i].Expander) : "~~" + (pivotEngine[j][i].Value + "#" + pivotEngine[j][i].Expander);
                                            labelTag += labelTag == "" ? (pivotEngine[j][i].Info + "::" + pivotEngine[j][i].State) : "~~" + (pivotEngine[j][i].Info + "::" + pivotEngine[j][i].State);
                                        }
                                        else if (pivotEngine[j][i].CSS.indexOf("none") >= 0 && chartLabel != "") {
                                            chartLabel += "~~" + chartLabel.split("~~")[chartLabel.split("~~").length - 1].split('#')[0] + "#" + pivotEngine[j][i].Expander;
                                            labelTag += "~~" + labelTag.split("~~")[labelTag.split("~~").length - 1];
                                        }
                                        else if (chartLabel == "" || pivotEngine[j][i].CSS.indexOf("summary") >= 0 || pivotEngine[j][i].CSS.indexOf("value") >= 0) {
                                            isSummary = pivotEngine[j][i].CSS.indexOf("summary") >= 0 ? true : false;
                                            break;
                                        }
                                    }
                                    if (!isSummary && chartLabel != "") {
                                        chartData.multiLevelLabels.push(chartLabel);
                                        chartData.multiLevelLabelTags.push(labelTag);
                                    }
                                }
                                else {
                                    if (pivotEngine[0][i].CSS == "rowheader") {
                                        chartData.multiLevelLabels.push((pivotEngine[0][i].Value + "#" + pivotEngine[0][i].Expander));
                                        chartData.multiLevelLabelTags.push(pivotEngine[0][i].Info + "::" + pivotEngine[0][i].State);
                                    }
                                }
                            }
                        }
                    }

                //Forming Data Points
                for (var i = columnHeaderHeight; i < rowCount; i++) {
                    var pointsArray = new Array();
                    if (rowHeaderWidth > 1) {
                        if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                                if (this.model.enableMultiLevelLabels) {
                                    if ($.inArray(i, summaryRows) > -1) {
                                        for (var j = rowHeaderWidth; j < columnCount; j++) {
                                            if ($.inArray(j, summaryColumns) < 0)
                                                pointsArray.push(pivotEngine[j][i].Value);
                                        }
                                        chartData.points_Y.push(pointsArray);
                                    }
                                }
                                else {
                            if (pivotEngine[0][i].CSS == "summary rstot" && pivotEngine[0][i].Value != "Grand Total") {
                                for (var j = rowHeaderWidth; j < columnCount; j++) {
                                    if ($.inArray(j, summaryColumns) < 0)
                                        pointsArray.push(pivotEngine[j][i].Value);
                                }
                                chartData.points_Y.push(pointsArray);
                            }
                        }
                            }
                        else {
                            if ($.inArray(i, summaryRows) < 0) {
                                for (var j = rowHeaderWidth; j < columnCount; j++) {
                                        if ($.inArray(j, summaryColumns) < 0 && pivotEngine[j][i].CSS.indexOf("value") > -1)
                                        pointsArray.push(pivotEngine[j][i].Value == "" ? 0 : ej.parseFloat(pivotEngine[j][i].Value, this.locale()));
                                }
                                chartData.points_Y.push(pointsArray);
                            }
                        }
                    }
                    else if (pivotEngine[0][i].CSS == "rowheader") {
                        for (var j = pivotEngine[0][0].ColSpan; j < columnCount; j++) {
                            if ($.inArray(j, summaryColumns) < 0)
                                pointsArray.push(this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap ? (pivotEngine[j][i].Value == "" ? 0 : ej.parseFloat(pivotEngine[j][i].Value, this.locale())) : pivotEngine[j][i].Value);
                        }
                        chartData.points_Y.push(pointsArray);
                    }
                }
            }

            //Getting Value Names
            if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                chartData.measureNames = measure;
            }
            else {
                    var measureNames = (this.model.enableMultiLevelLabels && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) ? $(values).map(function (index, item) { return item.FieldHeader }) : $(this.model.dataSource.values).map(function (index, item) { return item.fieldCaption });
                for (var i = 0; i < measureNames.length; i++)
                chartData.measureNames += chartData.measureNames == "" ? measureNames[i] : "~" + measureNames[i];
            }
                if (this.model.enableMultiLevelLabels && this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode)
                    this.renderControlSuccess({ JsonRecords: JSON.stringify(chartData), OlapReport: pivotReport });
                else
            this.renderControlSuccess({ JsonRecords: JSON.stringify(chartData), OlapReport: JSON.stringify(this.model.dataSource) });
            chartData = {};
            }
            else {
                this.renderControlSuccess(pivotEngine);
            }
        },

        _cloneEngine: function (pivotEngine) {
            var clonedEngine = $.extend([], pivotEngine);
            for (var i = 0; i < pivotEngine.length; i++)
                clonedEngine[i] = $.extend([], pivotEngine[i]);
            return clonedEngine;
        },

        _cropData: function (pivotEngine, selectedMember, drilledDimensionIndex, isRemoved) {            
            var j = this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap ? pivotEngine[0][0].RowSpan : (this.model.dataSource.columns.length + (this.model.dataSource.values.length ==  0 || this.model.dataSource.values[0].axis == "rows" ? 0 : 1));

            while (j < pivotEngine[drilledDimensionIndex].length) {
                if (pivotEngine[drilledDimensionIndex][j].Value != selectedMember) {
                    for (var i = 0; i < pivotEngine.length; i++)
                        pivotEngine[i].splice(j, 1);
                }
                else
                    j += pivotEngine[drilledDimensionIndex][j].RowSpan;
            }
            if (this.model.analysisMode != ej.PivotChart.AnalysisMode.Olap && isRemoved) pivotEngine.splice(drilledDimensionIndex, 1);
        },

        refreshPagedPivotChart: function (axis, pageNo) {
            if (typeof ochartWaitingPopup != 'undefined' && ochartWaitingPopup != null)
                ochartWaitingPopup.show();
            axis = axis.indexOf('categ') != -1 ? "categorical" : "series";
            var report;
            try {
                report = JSON.parse(this.getOlapReport());
            }
            catch (err) {
                report = this.getOlapReport();
            }
            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.paging, JSON.stringify({ "action": "paging", "pagingInfo": axis + ":" + pageNo, "currentReport": report, "customObject": JSON.stringify(this.model.customObject) }), this.renderControlSuccess);
        },
        _updatePageSettings: function (msg, pivotClientObj) {
            var pageSettings = $.map(msg, function (obj, index) { if (obj.Key == "PageSettings") return obj; });
            var headerSettings = $.map(msg, function (obj, index) { if (obj.Key == "HeaderCounts") return obj; });
            if (pageSettings.length > 0 && pivotClientObj._pagerObj != null) {
                pivotClientObj._pagerObj.element.css("opacity", "1");
                pivotClientObj._pagerObj.element.find(".pagerTextBox").removeAttr('disabled');
                pivotClientObj._pagerObj._unwireEvents();
                pivotClientObj._pagerObj._wireEvents();
                pivotClientObj._pagerObj.initPagerProperties(JSON.parse(headerSettings[0].Value), JSON.parse(pageSettings[0].Value));
            }
        },
        renderControlSuccess: function (msg) {
            if (typeof oclientWaitingPopup != 'undefined' && oclientWaitingPopup != null)
                if ($("#" + this._pivotClientObj._id + "_maxView")[0])
                    $("#" + this._pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                else
                    oclientWaitingPopup.show();
            try {
                if (msg[0] != undefined) {
                    this.setJSONRecords(msg[0].Value); this.setOlapReport(msg[1].Value);
                    if (!ej.isNullOrUndefined(msg[2]) && msg[2].Key == "AnalysisMode" && msg[2].Value == "Olap") this.model.analysisMode = ej.PivotChart.AnalysisMode.Olap;
                    if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                        this._pivotClientObj.currentReport = (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? JSON.parse(this.getOlapReport()).Report : msg[1].Value);
                        if (msg[2] != null && msg[2] != undefined && msg[2].Key == "ClientReports")
                            this._pivotClientObj.reports = msg[2].Value;
                        this._updatePageSettings(msg, this._pivotClientObj);
                    }
                    if (msg[2] != null && msg[2] != undefined && !msg[2].Key == "ClientReports" && msg[2].Key != "AnalysisMode")
                        this.model.customObject = msg[2].Value;
                    if ($(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined) {
                        if (this._pagerObj != null && msg[2] != null && msg.d[2] != undefined)
                            this._pagerObj.initPagerProperties(JSON.parse(msg.d[3].Value), JSON.parse(msg.d[2].Value));
                    }
                }
                else if (msg.d != undefined) {
                    this.setJSONRecords(msg.d[0].Value); this.setOlapReport(msg.d[1].Value);
                    if (msg.d[2].Key == "AnalysisMode" && msg.d[2].Value == "Olap") this.model.analysisMode = ej.PivotChart.AnalysisMode.Olap;
                    if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                        this._pivotClientObj.currentReport = (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? JSON.parse(this.getOlapReport()).Report :msg.d[1].Value);
                        if (msg.d[2] != null && msg.d[2] != undefined && msg.d[2].Key == "ClientReports")
                            this._pivotClientObj.reports = msg.d[2].Value;
                        this._updatePageSettings(msg.d, this._pivotClientObj);
                    }
                    if (msg.d[2] != null && msg.d[2] != undefined && !(msg.d[2].Key == "ClientReports"))
                        this.model.customObject = msg.d[2].Value;
                    if (this._pagerObj != null && $(".e-pivotpager")[0] != null && $(".e-pivotpager")[0] != undefined) {
                        if (msg.d[2] != null && msg.d[2] != undefined && msg.d[2].Key == "PageSettings")
                            this._pagerObj.initPagerProperties(JSON.parse(msg.d[3].Value), JSON.parse(msg.d[2].Value));
                        if (msg.d[3] != null && msg.d[3] != undefined && msg.d[3].Key == "PageSettings")
                            this._pagerObj.initPagerProperties(JSON.parse(msg.d[4].Value), JSON.parse(msg.d[3].Value));
                    }
                }
                else {
                    this.setJSONRecords(msg.JsonRecords); this.setOlapReport(msg.OlapReport);
                    if (msg.AnalysisMode == "Olap") this.model.analysisMode = ej.PivotChart.AnalysisMode.Olap;
                    if (msg.customObject != null && msg.customObject != null)
                        this.model.customObject = msg.customObject;
                    if (!ej.isNullOrUndefined(this._pivotClientObj)) {
                        if (typeof (this._pivotClientObj.currentReport) != "undefined")
                            this._pivotClientObj.currentReport = (this.model.analysisMode == ej.Pivot.AnalysisMode.Pivot ? JSON.parse(this.getOlapReport()).Report : msg.OlapReport);
                        if (typeof (this._pivotClientObj.reports) != "undefined" && msg.reports != undefined && msg.reports != "undefined")
                            this._pivotClientObj.reports = msg.reports;
                    }
                }
                if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                    var eventArgs;
                    if (this._drillAction != "")
                        eventArgs = { action: this._drillAction, element: this.element, customObject: this.model.customObject };
                    else
                        eventArgs = { action: this._currentAction, element: this.element, customObject: this.model.customObject };
                    this._trigger("afterServiceInvoke", eventArgs);
                }               
                var htmlTag = ej.buildTag("div#" + this._id + "Container", "", { "height": (!ej.isNullOrUndefined(this._pivotClientObj)) ? this._pivotClientObj._chartHeight : this.element.height(), "width": (!ej.isNullOrUndefined(this._pivotClientObj)) ? (this._pivotClientObj.model.enableSplitter ? this._pivotClientObj.element.find(".controlPanelTD").width() : (this._pivotClientObj._toggleExpand ? (this._pivotClientObj.element.find(".controlPanelTD").width() - 15) : (($("#" + this._pivotClientObj._id + "_maxView").length > 0 && this._pivotClientObj._pivotChart) ? $("#" + this._pivotClientObj._pivotChart._id + "Container").width() : this._pivotClientObj._chartWidth))) : this.element.width() })[0].outerHTML;
                if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar&& !this._pivotClientObj.model.displaySettings.enableFullScreen) {
                    var toolBar = this._pivotClientObj.model.enableSplitter?$("<div id="+this._id+"toolBar style='width:" + this._pivotClientObj._chartWidth + ";height:" + this._pivotClientObj._chartHeight + ";margin-top:35px;margin-left:5px'></div>"):$("<div id="+this._id+"toolBar style='width:" + this._pivotClientObj._chartWidth + ";height:" + this._pivotClientObj._chartHeight + ";overflow:auto;margin-top:35px;margin-left:5px'></div>");
                    $(toolBar).html(htmlTag);
                    this.element.html(toolBar);
                }
                else
                    this.element.html(htmlTag);
                if (this.model.commonSeriesOptions.type == ej.PivotChart.ChartTypes.Funnel || this.model.commonSeriesOptions.type == ej.PivotChart.ChartTypes.Pyramid)
                    this.model.legend.toggleSeriesVisibility = false;
                else
                    this.model.legend.toggleSeriesVisibility = true;
                this.renderChartFromJSON(this.getJSONRecords());
                if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar && !this._pivotClientObj.model.displaySettings.enableFullScreen) {
                    $("#" + this._id).prepend("<div class='chartToolBar' style='height:40px;width:" + this._pivotClientObj.element.find(".chartContainer").width() + "px'></div>");
                    var listTool = ej.buildTag("ul", ej.buildTag("li.chart3DImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("TDCharts")).attr({ "title": this._getLocalizedLabels("TDCharts"), tabindex: 0 })[0].outerHTML +
                     ej.buildTag("li.exportImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Exporting")).attr({ "title": this._getLocalizedLabels("Exporting"), tabindex: 0 })[0].outerHTML +
                     (!this.model.enable3D ? ej.buildTag("li.smartLabels e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("SmartLabels")).attr({ "title": this._getLocalizedLabels("SmartLabels"), tabindex: 0 })[0].outerHTML : "") +
                     (!this.model.enable3D ? ej.buildTag("li.interaction e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Interactions")).attr({ "title": this._getLocalizedLabels("Interactions"), tabindex: 0 })[0].outerHTML : ""))[0].outerHTML +
                     ej.buildTag("ul", ej.buildTag("li#" + this._id + "_toolTipImg.toolTipImg e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Tooltip")).attr({ "title": this._getLocalizedLabels("Tooltip"), tabindex: 0 })[0].outerHTML +
                        ej.buildTag("li.legend e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Legend")).attr({ "title": this._getLocalizedLabels("Legend"), tabindex: 0 })[0].outerHTML +
                        (!this.model.enable3D ? ej.buildTag("li.zooming e-icon", "", {}).attr("aria-label", this._getLocalizedLabels("Zooming")).attr({ "title": this._getLocalizedLabels("Zooming"), tabindex: 0 })[0].outerHTML : ""))[0].outerHTML;
                    $(".chartToolBar").append($(listTool));
                    $(".chartToolBar").ejToolbar({ enableRTL: this.model.enableRTL, enableSeparator: true, height: "35px" });
                    if (this.model.enable3D)
                        this.element.find(".chart3DImg").addClass("enabled");
                    if (this.model.zooming.enable)
                        this.element.find(".zooming").addClass("enabled");
                    if (this.model.legend.visible)
                        this.element.find(".legend").addClass("enabled");
                    if (!ej.isNullOrUndefined(this.model.primaryXAxis.labelIntersectAction))
                        this.element.find(".smartLabels").addClass("enabled");
                    if (this.model.commonSeriesOptions.tooltip.visible)
                        this.element.find(".toolTipImg").addClass("enabled");
                    if (this.model.crosshair.visible)
                        this.element.find(".interaction").addClass("enabled");
                    if (this.model.crosshair.type == "trackball")
                        this.element.find(".trackBall").addClass("enabled");
                    if (this.model.crosshair.type == "crosshair") 
                        this.element.find(".crossHair").addClass("enabled");
                    if (!this.model.crosshair.visible)
                        this.element.find(".none").addClass("enabled");

                    this._pivotClientObj._unWireEvents();
                    this._pivotClientObj._wireEvents();
                }
                this._unWireEvents();
                this._wireEvents();
                if (this._drillAction != "") {
                    this.model.currentReport = this.getOlapReport();
                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot && !this.model.enableMultiLevelLabels) {
                        if (this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode) {
                            var chartData = this.getJSONRecords();
                            if (this.model.dataSource.rows.length - this._labelCurrentTags.expandedMembers.length > 1) {
                                this._labelCurrentTags["collapsedMembers"] = new Array();
                                for (var i = 0; i < chartData.chartLables.length; i++)
                                    this._labelCurrentTags["collapsedMembers"].push(chartData.chartLables[i]);
                            }
                        }
                        else {
                            var chartData = this.getJSONRecords();
                            var rows =  !(ej.isNullOrUndefined(JSON.parse(this.getOlapReport()).rows)) ?  JSON.parse(JSON.parse(this.getOlapReport()).rows) : (JSON.parse(this.getOlapReport()).PivotRows);
                            this._labelCurrentTags["collapsedMembers"] = new Array();
                            if (rows.length - this._labelCurrentTags.expandedMembers.length > 1) {
                                for (var i = 0; i < chartData.chartLables.length; i++)
                                    this._labelCurrentTags["collapsedMembers"].push(chartData.chartLables[i]);
                            }
                        }
                    }
                    this._trigger("drillSuccess", this.element);
                }
                else {
                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot) {
                        if (this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode) {
                            var chartData = this.getJSONRecords();
                            this._labelCurrentTags = { collapsedMembers: [] };
                            if (this.model.dataSource.rows.length > 1) {
                                for (var i = 0; i < chartData.chartLables.length; i++)
                                    this._labelCurrentTags["collapsedMembers"].push(chartData.chartLables[i]);
                            }
                        }
                        else {
                            var chartData = this.getJSONRecords();
                            this.model.currentReport = JSON.parse(this.getOlapReport());
                            this._labelCurrentTags = { collapsedMembers: [] };
                            if ($(this.element).parents(".e-pivotclient").length > 0 ? this.model.currentReport.PivotRows.length > 1 : JSON.parse(this.model.currentReport.rows).length > 1) {
                                for (var i = 0; i < chartData.chartLables.length; i++) {
                                    this._labelCurrentTags["collapsedMembers"].push(chartData.chartLables[i]);
                                }
                            }
                        }
                    }
                }
                var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
                if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                if (!ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj._waitingPopup != null) {
                    if ($("#" + this._pivotClientObj._id + "_maxView")[0]) {
                        $("#" + this._pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: false });
                        this._pivotClientObj._waitingPopup.hide();
                    }
                    else if (!ej.isNullOrUndefined(this._pivotClientObj._pivotGrid)) {
                        if (this._pivotClientObj && (this._pivotClientObj._pivotGrid._drillAction && !this._pivotClientObj._pivotGrid._startDrilldown) || this._pivotClientObj._pivotChart._drillAction && !this._pivotClientObj._pivotChart._startDrilldown)
                            this._pivotClientObj._waitingPopup.hide();
                        else if (this._pivotClientObj && this._pivotClientObj._pivotGrid._drillAction == "" && this._pivotClientObj._pivotChart._drillAction == "" && !this._pivotClientObj._pivotGrid._startDrilldown && !this._pivotClientObj._pivotChart._startDrilldown && (this._pivotClientObj._pivotGrid._JSONRecords != null || this._pivotClientObj._pivotChart._JSONRecords == null))
                            this._pivotClientObj._waitingPopup.hide();
                        else if (this._pivotClientObj._pivotChart._startDrilldown && !this._pivotClientObj._pivotGrid._startDrilldown && !$("#" + this._pivotClientObj._id + "_maxView")[0])
                            this._pivotClientObj._waitingPopup.show();
                        else if (!this._pivotClientObj._pivotChart._startDrilldown && !this._pivotClientObj._pivotGrid._startDrilldown && this._pivotClientObj._pivotChart._drillAction == "" && this._pivotClientObj._pivotGrid._drillAction == "" && (this._pivotClientObj._pivotGrid._JSONRecords != null || this._pivotClientObj._pivotChart._JSONRecords == null))
                            this._pivotClientObj._waitingPopup.hide();
                    }
                    if (this._pivotClientObj.model.displaySettings.mode == "chartonly")
                        this._pivotClientObj._waitingPopup.hide();
                }
                else
                    this._waitingPopup.hide();
                if (!ej.isNullOrUndefined(this._pivotClientObj))
                    this._pivotClientObj._pivotChart._startDrilldown = false;
            }
            catch (err) {
            }
            if (!ej.isNullOrUndefined(msg.Exception)) {
                ej.Pivot._createErrorDialog(msg, "Exception", this);
            }
            //var eventArgs = { "action": this._currentAction, "customObject": this.model.customObject, "element": this.element };
            this._trigger("renderSuccess", this);
        },

        renderChartFromJSON: function (jsonData) {
            this.setJSONRecords(JSON.stringify(jsonData));
            var chartSeries = new Array();
            if (jsonData == null || jsonData == "") {
                if (jsonData == "") {
                    var htmlTag = ej.buildTag("div#" + this._id + "Container")[0].outerHTML;
                    this.element.html(htmlTag);
                }
                chartSeries = [];
                this.model.primaryXAxis.multiLevelLabels = [];
            }
            else if (jsonData != null && jsonData.chartLables.length > 0 && jsonData.points_Y.length > 0) {
                var pivotChartObj = this;
                if (this.model.enableRTL) {
                    jsonData.chartLables = $.map(jsonData.chartLables, function (x) { return x.split("~~").map(function (val) { return val.split('#').reverse().join('#') }).reverse().join("~~"); });
                    jsonData.seriesNames = $.map(jsonData.seriesNames, function (x) { return x.split("~~").map(function (val) { return val.split('#').reverse().join('#') }).reverse().join("~~"); });
                }
                var chartLabels = [];
                if (pivotChartObj.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                    chartLabels = $.map($.extend([], jsonData.chartLables, true), function (val) { return val.split('#').join("~~") });
                }
                else {
                    chartLabels = $.map($.extend([], jsonData.chartLables, true), function (val) { return (!ej.isNullOrUndefined(pivotChartObj._labelCurrentTags.expandedMembers) && pivotChartObj._labelCurrentTags.expandedMembers.length > 0) ? (pivotChartObj._labelCurrentTags.expandedMembers.join("~~") + "~~" + val) : val; });
                }
                
                var seriesPoints = new Array(); var XValues = chartLabels; var tempArray = new Array();
                var YValues = new Array(); var pointsCount =0, pCnt = 0; var count = 0; var seriesName = new Array(); var points, measureRCnt = 0;
                measureRCnt = jsonData.measureInfo != "" ? parseInt(jsonData.measureInfo) : 0;
                jQuery.each(chartLabels, function (index, value) {
                    var YPoints = new Array();
                    if (measureRCnt > 1 && jsonData.addInfo.action != "DrillChart" || (measureRCnt > 1 && jsonData.addInfo.levelHash == "1")) {
                        var lblVal = (((index + 1) * measureRCnt) - measureRCnt);
                        for (var mCnt = 0; mCnt < measureRCnt; mCnt++) {
                            if (jsonData.points_Y[(lblVal + mCnt)] != undefined && chartLabels[index].split("~~")[0] == jsonData.points_Y[(lblVal + mCnt)][0].Item1)
                                for (var i = 0; i < jsonData.points_Y[index].length; i++) {
                                    points = { "xValues": chartLabels[index], "yValues": (jsonData.points_Y[lblVal + mCnt][i].Item2).indexOf(",") > -1 ? ej.globalize.parseFloat(ej.globalize.format((jsonData.points_Y[lblVal + mCnt][i].Item2), "c", pivotChartObj.model.locale), pivotChartObj.model.locale) : (jsonData.points_Y[lblVal + mCnt][i].Item2) == "" ? 0 : ej.globalize.parseFloat((jsonData.points_Y[lblVal + mCnt][i].Item2)), "text": (jsonData.points_Y[lblVal + mCnt][i].Item2) == "" ? 0 : (jsonData.points_Y[lblVal + mCnt][i].Item2) };
                                    points.yValues = ej.isNullOrUndefined(points.yValues) ? points.yValues : (jQuery.isNumeric(points.yValues) ? points.yValues : ej.globalize.parseFloat((jsonData.points_Y[lblVal + mCnt])[i].Item2.toString().replace(/[^\d.,-]/g, '')));
                                    YPoints.push(points);
                                }
                        }
                    }
                    else
                        for (var i = 0; i < jsonData.points_Y[index].length; i++) {
                            if (pivotChartObj.model.analysisMode == ej.PivotChart.AnalysisMode.Olap && pivotChartObj.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                                if (pivotChartObj.seriesType() == "bubble")
                                    points = { "xValues": chartLabels[index], "yValues": (jsonData.points_Y[index])[i].Item2 == "" ? 0 : (jsonData.points_Y[index])[i].Item2, "size": (jsonData.points_Y[index])[i].Item2 == "" ? 0 : (jsonData.points_Y[index])[i].Item2 };
                                else
                                    points = {
                                        "xValues": chartLabels[index], "yValues":
                                            //(jsonData.points_Y[index])[i].Item2.indexOf(",") > -1 ? ej.globalize.parseFloat(ej.globalize.format((jsonData.points_Y[index])[i].Item2, "c", pivotChartObj.model.locale), pivotChartObj.model.locale) : 
                                            (jsonData.points_Y[index])[i].Item2 == "" ? 0 : ej.globalize.parseFloat((jsonData.points_Y[index])[i].Item2), "text": (jsonData.points_Y[index])[i].Item2 == "" ? 0 : (jsonData.points_Y[index])[i].Item2
                                    };
                                points.yValues = ej.isNullOrUndefined(points.yValues) ? points.yValues : (jQuery.isNumeric(points.yValues) ? points.yValues : ej.globalize.parseFloat((jsonData.points_Y[index])[i].Item2.toString().replace(/[^\d.,-]/g, '')));
                            }
                            else {
                                if (pivotChartObj.seriesType() == "bubble")
                                    points = { "xValues": chartLabels[index].toString().split('#')[chartLabels[index].toString().split('#').length - 1], "yValues": (jsonData.points_Y[index])[i] == "" ? 0 : (jsonData.points_Y[index])[i], "size": (jsonData.points_Y[index])[i] == "" ? 0 : (jsonData.points_Y[index])[i] };
                                else
                                    points = { "xValues": chartLabels[index].toString().split('#')[chartLabels[index].toString().split('#').length - 1], "yValues": (jsonData.points_Y[index])[i] == "" ? 0 : (jsonData.points_Y[index])[i], "text": (jsonData.points_Y[index])[i] == "" ? 0 : (jsonData.points_Y[index])[i] };
                                points.yValues = ej.isNullOrUndefined(points.yValues) ? points.yValues : (jQuery.isNumeric(points.yValues) ? points.yValues : ej.globalize.parseFloat((jsonData.points_Y[index])[i].toString().replace(/[^\d.,-]/g, '')));
                            }
                            YPoints.push(points);
                        }
                    seriesPoints.push(YPoints);
                });

                if (measureRCnt > 1 && jsonData.addInfo.action != "DrillChart" || (measureRCnt > 1 && jsonData.addInfo.levelHash == "1"))
                    for (var mCnt = 0; mCnt < (measureRCnt * jsonData.seriesNames.length) ; mCnt++)
                        tempArray.push(new Array());
                else {
                    jQuery.each(jsonData.seriesNames, function (index, value) {
                        tempArray.push(new Array());
                    });
                }
                jQuery.each(chartLabels, function (index, value) {
                    for (var i = 0; i < seriesPoints[index].length; i++) {
                        if(ej.isNullOrUndefined(tempArray[i]))
                            tempArray[i]=[];
                        tempArray[i].push((seriesPoints[index])[i]);
                    }
                });
                if (measureRCnt > 1 && jsonData.addInfo.action != "DrillChart" || (measureRCnt > 1 && jsonData.addInfo.levelHash == "1")) {
                    for (var index = 0; index < (measureRCnt * jsonData.seriesNames.length) ; index++) {
                        chartSeries[pCnt] = { dataSource: tempArray[index], xName: "xValues", yName: "yValues", name: jsonData.seriesNames[pointsCount] };
                        pointsCount++; pCnt++;
                        if (pointsCount == jsonData.seriesNames.length)
                            pointsCount = 0;
                    }
                }
                else {
                    if (this.seriesType() == "bubble") {
                        jQuery.each(jsonData.seriesNames, function (index, value) {
                            chartSeries[pointsCount] = { dataSource: tempArray[index], xName: "xValues", yName: "yValues", size: "size", name: jsonData.seriesNames[pointsCount] };
                            pointsCount++;
                        });
                        if (this.model.commonSeriesOptions.marker.dataLabel)
                            this.model.commonSeriesOptions.marker.dataLabel.visible = false;
                    }
                    else {
                        jQuery.each(jsonData.seriesNames, function (index, value) {
                            chartSeries[pointsCount] = { dataSource: tempArray[index], xName: "xValues", yName: "yValues", name: jsonData.seriesNames[pointsCount], marker: { dataLabel: { textMappingName: "text" } } };
                            pointsCount++;
                        });
                        if (this.model.commonSeriesOptions.marker.dataLabel)
                            this.model.commonSeriesOptions.marker.dataLabel.visible = false;
                    }
                }

                if (this.model.enableMultiLevelLabels && !ej.isNullOrUndefined(jsonData.multiLevelLabels)) {
                    this.model.primaryXAxis["majorTickLines"] = { size: 0 };
                    var groupLabels = [], arrayLabels = [];
                    for (var i = 0; i < jsonData.multiLevelLabels.length; i++) {
                        arrayLabels.push(jsonData.multiLevelLabels[i].split("~~"));
                    }
                    for (var i = jsonData.multiLevelLabels[0].split('~~').length - 1; i >= 0; i--) {
                        var groupRowLabels = [];
                        for (var j = 0; j < jsonData.multiLevelLabels.length; j++) {
                            var rowLabels = {};
                            rowLabels["name"] = jsonData.multiLevelLabels[j].split('~~')[i].split('#')[0];                            
                            if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                                rowLabels["rowSpan"] = parseInt(jsonData.multiLevelLabels[j].split('~~')[i].split('#')[1]);
                                rowLabels["colSpan"] = parseInt(jsonData.multiLevelLabels[j].split('~~')[i].split('#')[2]);
                                rowLabels["tag"] = jsonData.multiLevelLabelTags[j].split('~~')[i];
                            }
                            else
                            {
                                if (i == jsonData.multiLevelLabels[0].split('~~').length - 1)
                                    rowLabels["colSpan"] = 1;
                                else {
                                    var parentCompare = "", colSpan = 0;
                                    for (k = j; k < arrayLabels.length; k++) {
                                        var parentLabels = "";
                                        for (var l = i; l >= 0; l--) {
                                            parentLabels += parentLabels == "" ? (arrayLabels[k])[l] : "$" + (arrayLabels[k])[l];
                                        }
                                        colSpan += parentCompare == "" || parentCompare == parentLabels ? 1 : 0;
                                        if (parentCompare != parentLabels && parentCompare != "")
                                            break;
                                        else
                                            parentCompare = parentLabels;
                                    }
                                    rowLabels["colSpan"] = colSpan;
                                }
                                if (parseInt(jsonData.multiLevelLabels[j].split('~~')[i].split('#')[1]) == 0) {
                                    var rowSpan = 0;
                                    for (var m = i; m >= 0; m--) {
                                        rowSpan++;
                                        if (parseInt((arrayLabels[j])[m].split('#')[1]) > 0)
                                            break;
                                    }
                                    rowLabels["rowSpan"] = rowSpan;
                                }
                                else
                                    rowLabels["rowSpan"] = 1;
                                rowLabels["tag"] = !ej.isNullOrUndefined(jsonData.multiLevelLabelTags[j]) ? jsonData.multiLevelLabelTags[j].split('~~')[i] : "";
                            }
                            groupRowLabels.push(rowLabels);
                        }
                        groupLabels.push(groupRowLabels);
                    }
                    var parentIndices = [];
                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                        for (var j = 0; j < groupLabels[0].length; j++) {
                            for (var i = groupLabels.length - 1; i >= 0; i--) {
                                if (!ej.isNullOrUndefined((groupLabels[i])[j])) {
                                    if ((groupLabels[i])[j].rowSpan > 1 && parentIndices.indexOf(i + "-" + j) == -1) {
                                        var rowSpan = (groupLabels[i])[j].rowSpan;
                                        var count = 1;
                                        do {
                                            delete (groupLabels[i - count])[j];
                                            count++;
                                        } while (rowSpan > count);
                                        parentIndices.push(i + "-" + j);
                                    }
                                }
                            }
                        }
                    }
                    else {
                        for (var j = 0; j < groupLabels[0].length; j++) {
                            for (var i = 0; i < groupLabels.length; i++) {
                                if (!ej.isNullOrUndefined((groupLabels[i])[j])) {
                                    if ((groupLabels[i])[j].rowSpan > 1 && parentIndices.indexOf(i + "-" + j) == -1) {
                                        var rowSpan = (groupLabels[i])[j].rowSpan;
                                        var count = 0;
                                        do {
                                            delete (groupLabels[i + count])[j];
                                            count++;
                                        } while (rowSpan > count + 1);
                                        (groupLabels[i + count])[j].rowSpan = rowSpan;
                                        parentIndices.push((i + count) + "-" + j);
                                    }
                                }
                            }
                        }
                    }

                    var finalMultiLvlLabels = [];
                    var rowFieldsLength = (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) ? (ej.isNullOrUndefined(JSON.parse(this.getOlapReport()).PivotRows) ? JSON.parse(JSON.parse(this.getOlapReport()).rows).length : JSON.parse(this.getOlapReport()).PivotRows.length) : ((this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot && this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode) ? this.model.dataSource.rows.length : 0);
                    for (var i = 0; i < groupLabels.length; i++) {
                        for (var j = 0; j < groupLabels[i].length; j++) {
                            if (!ej.isNullOrUndefined((groupLabels[i])[j])) {
                                var range = j - 0.5;
                                var obj = {};
                                obj["visible"] = true;
                                obj["text"] = this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap ? ((groupLabels[i])[j].tag.endsWith("2") ? ("+ " + (groupLabels[i])[j].name) : ((groupLabels[i])[j].tag.endsWith("1") ? "- " + (groupLabels[i])[j].name : (groupLabels[i])[j].name)) : (rowFieldsLength == groupLabels.length && i == 0 ? (groupLabels[i])[j].name : (i == 0 || (groupLabels[i])[j].rowSpan > 1 ? ("+ " + (groupLabels[i])[j].name) : ("- " + (groupLabels[i])[j].name)));
                                obj["tag"] = this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap ? (groupLabels[i])[j].tag : (rowFieldsLength == groupLabels.length && i == 0 ? ((groupLabels[i])[j].name + "#" + 0) : (i == 0 || (groupLabels[i])[j].rowSpan > 1 ? ((groupLabels[i])[j].name) + "#" + 1 : ((groupLabels[i])[j].name) + "#" + 2));
                                obj["start"] = range;
                                obj["end"] = range + (groupLabels[i])[j].colSpan;
                                obj["level"] = i;
                                obj["span"] = (groupLabels[i])[j].rowSpan > 1 ? true : false;
                                finalMultiLvlLabels.push(obj);                                
                                j += (groupLabels[i])[j].colSpan - 1;
                            }
                        }
                    }
                    this.model.primaryXAxis.multiLevelLabels = finalMultiLvlLabels;
                    this.model.zooming.enableScrollbar = true;
                }
                else if (jsonData.chartLables.length > 10 && this.model.zooming == "")
                    this.model.zooming = { enable: true, type: 'x,y', enableMouseWheel: true };
                else if (jsonData.chartLables.length < 10 && this._initZooming == "")
                    this.model.zooming = this._initZooming;
                if (jQuery.inArray(this.seriesType(), ["line", "spline", "area", "splinearea", "stepline", "steparea", "stackingarea", "scatter"]) > -1 && !this.model.commonSeriesOptions.marker.visible)
                    this.model.commonSeriesOptions.marker = {
                        shape: ej.PivotChart.SymbolShapes.Circle,
                        size: { height: 12, width: 12 },
                        visible: true,
                        connectorLine: { height: 30, type: "line" },
                        dataLabel: { visible: false },
                        border: { width: 3, color: 'white' }
                    };
                else if ((this.seriesType() == "pie" || this.seriesType() == "doughnut")){
                    this.model.commonSeriesOptions.marker.visible = false;
                    if (this.model.commonSeriesOptions.marker.dataLabel)
                        this.model.commonSeriesOptions.marker.dataLabel.visible = false;
                }
                else if ((this.seriesType() == "pyramid" || this.seriesType() == "funnel")) {
                    this.model.commonSeriesOptions.marker = {
                        dataLabel: {
                            visible: true
                        }
                    };
                }
                else if (jQuery.inArray(this.seriesType(), ["column", "stackingcolumn", "bar", "stackingbar"]) > -1 && this.model.commonSeriesOptions.marker) {
                    if (this.model.commonSeriesOptions.marker.dataLabel)
                        this.model.commonSeriesOptions.marker.dataLabel.visible = false;
                    this.model.commonSeriesOptions.marker.visible = false;
                }
                if (this.model.crosshair.visible) {
                    this.model.commonSeriesOptions.tooltip.format = "#point.x# : #point.y#";
                }
                else {
                    if (this.model.enableRTL) {
                        this.model.commonSeriesOptions.tooltip = { visible: true, template: 'e-toolTip' };
                    }
                    else {
                        this.model.commonSeriesOptions.tooltip.format = (this._getLocalizedLabels("Measure")) + " : " + jsonData.measureNames + " <br/>" +
                                      (this._getLocalizedLabels("Column")) + " : #series.name# <br/>" +
                                      (this._getLocalizedLabels("Row")) + " : #point.x# <br/>" +
                                      (this._getLocalizedLabels("Value")) + " : #point.y#";
                    }
                }

                if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap)
                    if(this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode){
                    this.model.primaryYAxis.labelFormat = (this.model.primaryYAxis.labelFormat != null || this.model.primaryYAxis.labelFormat != "") && (this.model.primaryYAxis.labelFormat) ? this.model.primaryYAxis.labelFormat : (jsonData.labelFormat.indexOf("#") > -1 && jsonData.measureNames.indexOf("~") < 0) ? (jsonData.labelFormat == "#,#" ? "Number" : "{value}" + jsonData.labelFormat.split('##')[jsonData.labelFormat.split('##').length - 1]) : (jsonData.labelFormat.toLowerCase().indexOf("percent") > -1 && jsonData.measureNames.indexOf("~") < 0) ? "{value}%" : (jsonData.labelFormat.toLowerCase().indexOf("currency") > -1 && jsonData.measureNames.indexOf("~") < 0) ? "Currency" : "";
                }
                    else {
                        if (this.model.dataSource.values[0].measures.length == 1)
                            if (!ej.isNullOrUndefined(this.model.dataSource.values[0].measures[0].format))
                                this.model.primaryYAxis.labelFormat = (this.model.primaryYAxis.labelFormat != null || this.model.primaryYAxis.labelFormat != "") && (this.model.primaryYAxis.labelFormat) ? this.model.primaryYAxis.labelFormat : (this.model.dataSource.values[0].measures[0].format.toLowerCase() == "decimal") ? "n2" : (this.model.dataSource.values[0].measures[0].format.toLowerCase() == "number") ? "Number" : (this.model.dataSource.values[0].measures[0].format.toLowerCase() == "percent") ? "p2" : (this.model.dataSource.values[0].measures[0].format.toLowerCase() == "currency") ? "Currency" : (this.model.dataSource.values[0].measures[0].format.toLowerCase() == "date") ? "MM/dd/yyyy" : (this.model.dataSource.values[0].measures[0].format.toLowerCase() == "time") ? "hh:mm:ss" : "";
                    }
                else if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Pivot)
                    if (this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode) {
                        if (this.model.dataSource.values.length == 1)
                            if (!ej.isNullOrUndefined(this.model.dataSource.values[0].format))
                                this.model.primaryYAxis.labelFormat = (this.model.primaryYAxis.labelFormat != null || this.model.primaryYAxis.labelFormat != "") && (this.model.primaryYAxis.labelFormat) ? this.model.primaryYAxis.labelFormat : (this.model.dataSource.values[0].format.toLowerCase() == "decimal") ? "n2" : (this.model.dataSource.values[0].format.toLowerCase() == "number") ? "Number" : (this.model.dataSource.values[0].format.toLowerCase() == "percentage") ? "p2" : (this.model.dataSource.values[0].format.toLowerCase() == "currency") ? "Currency" : (this.model.dataSource.values[0].format.toLowerCase() == "date") ? (!ej.isNullOrUndefined(this.model.dataSource.values[0].formatString) ? this.model.dataSource.values[0].formatString : "dd/MMMM/yyyy") : (this.model.dataSource.values[0].format.toLowerCase() == "time") ? "hh:mm:ss" : "";
                    }
                    else {
                        var pivotCalculations = (ej.isNullOrUndefined(JSON.parse(this.getOlapReport()).PivotCalculations) ? JSON.parse(JSON.parse(this.getOlapReport()).values) : JSON.parse(this.getOlapReport()).PivotCalculations);
                        if (jsonData.labelFormat.length == 1 && pivotCalculations.length == 1)
                            this.model.primaryYAxis.labelFormat = (this.model.primaryYAxis.labelFormat != null || this.model.primaryYAxis.labelFormat != "") && (this.model.primaryYAxis.labelFormat) ? this.model.primaryYAxis.labelFormat : (jsonData.labelFormat[0].toLowerCase() == "#.##") ? "n2" : (jsonData.labelFormat[0].toLowerCase() == "###") ? "Number" : (jsonData.labelFormat[0].toLowerCase() == "p") ? "p2" : (jsonData.labelFormat[0].toLowerCase() == "c") ? "Currency" : "";
                    }

                if (this.model.zooming.enableScrollbar) {
                    if (ej.isNullOrUndefined(this.model.size.width)) this.model.size.width = "800px";
                    if (ej.isNullOrUndefined(this.model.size.height)) this.model.size.height = "400px";
                    var chartWidthPixel = this.model.size.width.indexOf("%") > -1 ? (this.element.width() * this.model.size.width.split("%")[0]) / 100 : this.model.size.width.split("px")[0];
                    var chartHeightPixel = this.model.size.height.indexOf("%") > -1 ? (this.element.height() * this.model.size.height.split("%")[0]) / 100 : this.model.size.height.split("px")[0];
                    var pointsPerFrame = (this.seriesType() == "bar" || this.seriesType() == "stackingbar") ? (chartHeightPixel / 100) * 6 : (chartWidthPixel / 100) * 3;
                    this.model.primaryXAxis.zoomFactor = pointsPerFrame / (jsonData.chartLables.length * jsonData.seriesNames.length);
                }
                else
                    this.model.primaryXAxis.zoomFactor = 1;
                this.model.primaryXAxis.labelRotation = ej.isNullOrUndefined(this.model.primaryXAxis.labelRotation) ? 270 : this.model.primaryXAxis.labelRotation;                
            }
            else
                this.model.primaryXAxis.multiLevelLabels = [];
            $("#" + this._id + "Container").ejChart({
                border: this.model.border,
                backGroundImageUrl: this.model.backGroundImageUrl,
                palette: this.model.palette,
                chartArea: this.model.chartArea,
                primaryXAxis: this.model.primaryXAxis,
                primaryYAxis: this.model.primaryYAxis,
                secondaryX: this.model.secondaryX,
                secondaryY: this.model.secondaryY,
                striplineDefault: this.model.striplineDefault,
                title: {
                    text: this.titleText(),
                    textAlignment: this.model.title.textAlignment,
                    font: {
                        color: this.model.title.color,
                        fontFamily: this.model.title.fontFamily,
                        fontWeight: this.model.title.fontWeight,
                        opacity: this.model.title.opacity,
                        size: this.model.title.size,
                        fontStyle: this.model.title.fontStyle
                    }
                },
                locale : this.model.locale,
                lineCap: this.model.lineCap,
                lineJoin: this.model.lineJoin,
                legendAlignment: this.model.legendAlignment,
                legendPosition: this.model.legendPosition,
                legend: this.model.legend,
                animation: this.model.animation,
                crosshair: this.model.crosshair,
                commonSeriesOptions: {
                    doughnutCoefficient: this.model.commonSeriesOptions.doughnutCoefficient,
                    explodeOffset: this.model.commonSeriesOptions.explodeOffset,
                    pyramidMode: this.model.commonSeriesOptions.pyramidMode,
                    gapRatio: this.model.commonSeriesOptions.gapRatio,
                    pieCoefficient: this.model.commonSeriesOptions.pieCoefficient,
                    doughnutSize: this.model.commonSeriesOptions.doughnutSize,
                    startAngle: this.model.commonSeriesOptions.startAngle,
                    xAxisName: this.model.commonSeriesOptions.xAxisName,
                    yAxisName: this.model.commonSeriesOptions.yAxisName,
                    explodeAll: this.model.commonSeriesOptions.explodeAll,
                    explodeIndex: this.model.commonSeriesOptions.explodeIndex,
                    tooltipOptions: this.model.commonSeriesOptions.tooltipOptions,
                    marker: this.model.commonSeriesOptions.marker || this.model.marker,
                    font: this.model.commonSeriesOptions.font,
                    type: this.seriesType(),
                    enableAnimation: this.model.commonSeriesOptions.enableAnimation,
                    style: this.model.commonSeriesOptions.style,
                    explode: this.model.commonSeriesOptions.explode,
                    labelPosition: this.model.commonSeriesOptions.labelPosition,
                    tooltip: this.model.commonSeriesOptions.tooltip,
                    zOrder: this.model.commonSeriesOptions.zOrder,
                    drawType: this.model.commonSeriesOptions.drawType,
                    isStacking: this.model.commonSeriesOptions.isStacking,
                    enableSmartLabels: this.model.commonSeriesOptions.enableSmartLabels
                },
                seriesStyle: this.model.seriesStyle,
                pointStyle: this.model.pointStyle,
                textStyle: this.model.textStyle,
                initSeriesRender: this.model.initSeriesRender,
                theme: this.model.theme,
                canResize: this.model.isResponsive,
                rotation: this.model.rotation,
                enable3D: this.model.enable3D,
                zooming: this.model.zooming,
                margin: this.model.margin,
                elementSpacing: this.model.elementSpacing,
                seriesColors: this.model.seriesColors,
                seriesBorderColors: this.model.seriesBorderColors,
                pointColors: this.model.pointColors,
                pointBorderColors: this.model.pointBorderColors,
                series: chartSeries,
                size: this.model.size,
                load: this._onChartLoad(this),
                loaded: this.model.enableMultiLevelLabels ? ej.proxy(this._onChartLoaded, this) : null,
                axesRangeCalculate: this.model.axesRangeCalculate,
                axesTitleRendering: this.model.axesTitleRendering,
                chartAreaBoundsCalculate: this.model.chartAreaBoundsCalculate,
                legendItemRendering: this.model.legendItemRendering,
                lengendBoundsCalculate: this.model.lengendBoundsCalculate,
                preRender: this.model.preRender,
                seriesRendering: this.model.seriesRendering,
                symbolRendering: this.model.symbolRendering,
                titleRendering: this.model.titleRendering,
                axesLabelsInitialize: this.model.axesLabelsInitialize,
                pointRegionMouseMove: this.model.pointRegionMouseMove,
                legendItemClick: this.model.legendItemClick,
                legendItemMouseMove: this.model.legendItemMouseMove,
                displayTextRendering: this.model.displayTextRendering,
                toolTipInitialize: this.model.toolTipInitialize,
                trackAxisToolTip: this.model.trackAxisToolTip,
                trackToolTip: this.model.trackToolTip,
                animationComplete: this.model.animationComplete,
                destroy: this.model.destroy,
                create: this.model.create,
                axesLabelRendering: ej.proxy(this._labelRenders, this),
                multiLevelLabelClick: (!ej.isNullOrUndefined(this._pivotClientObj) ? (!this._pivotClientObj.model.enableDeferUpdate ? ej.proxy(this._multiLevelLabelClick, this) : null) : ej.proxy(this._multiLevelLabelClick, this)),
                pointRegionClick: this.model.enableMultiLevelLabels ? null : (!ej.isNullOrUndefined(this._pivotClientObj) ? (!this._pivotClientObj.model.enableDeferUpdate ? ej.proxy(this._seriesClick, this) : null) : ej.proxy(this._seriesClick, this))
            });
            if (this.model.enableRTL && jsonData != null) {
                var toolTipInfo = ej.buildTag("div#e-toolTip.e-toolTip",
                   ej.buildTag("div.toolTipInfo",
                    ej.buildTag("div", jsonData.measureNames + " : " + (this._getLocalizedLabels("Measure")) + " <br/>")[0].outerHTML +
                    ej.buildTag("div", "#series.name#: " + (this._getLocalizedLabels("Row")) + " <br/>")[0].outerHTML +
                    ej.buildTag("div", "#point.x# : " + (this._getLocalizedLabels("Column")) + " <br/>")[0].outerHTML +
                    ej.buildTag("div", "#point.y# : " + (this._getLocalizedLabels("Value")))[0].outerHTML//,
                    ).addClass("e-rtl")[0].outerHTML, {
                        "display": "none", "width": "auto", "min-width": "200px",
                        "font-size": "12px", "padding": "2px 5px",
                        "background-color": "rgb(255, 255, 255)",
                        "border": "1px solid rgb(0, 0, 0)"
                    }
                 )[0].outerHTML
                $("#" + this._id).append(toolTipInfo);
            }
            $("#" + this._id + "progressContainer").hide();
            if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                if (jsonData != null && jsonData != "") {
                    this._labelCurrentTags.splice(0, this._labelCurrentTags.length);
                    var pivotChartObj = this;
                    jQuery.each(jsonData.labelTags, function (index, value) {
                        var currentTag = new Object();
                        var splitData = value.split("::");
                        currentTag = { "name": splitData[2], "state": splitData[splitData.length - 1], "tag": value };
                        pivotChartObj._labelCurrentTags.push(currentTag);
                    });
                    if (!ej.isNullOrUndefined(pivotChartObj._selectedTagInfo)) {
                    jQuery.each(this._labelCurrentTags, function (index, value) {
                            if (value.tag.split("::")[0] == pivotChartObj._selectedTagInfo.split("::")[0] && pivotChartObj._drillAction == "drillup") {
                            pivotChartObj._selectedTagInfo = pivotChartObj._labelCurrentTags[index].tag;
                            return false;
                        }
                    });
                }
            }
            }
            var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
            if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
            if (this._waitingPopup != null)
                this._waitingPopup.hide();
            if ($(this.element).parents(".e-pivotclient").length > 0 && this._pivotClientObj.model.enableToolBar && !this._pivotClientObj.model.displaySettings.enableFullScreen) {
                if (this.model.commonSeriesOptions.tooltip.visible)
                    this.element.find(".toolTipImg").addClass("enabled");
            }
            if (!ej.isNullOrUndefined(this._pivotClientObj) && !ej.isNullOrUndefined(this._pivotClientObj) && this._pivotClientObj.model.isResponsive)
                $("#" + this._id + "Container").width('100%');           
        },

        _onChartLoad: function (args) {
            var labels = ej.isNullOrUndefined(args.model.primaryXAxis.multiLevelLabels) ? [] : args.model.primaryXAxis.multiLevelLabels;
            for (var i = 0; i < labels.length; i++) {
                if (labels[i].span) {
                    labels[i].border = { type: "withouttopborder" };
                    for (var j = 0; j < labels[i].level; j++) {
                        labels.push({ start: labels[i].start, end: labels[i].end, visible: true, text: " ", tag: labels[i].tag, level: j, border: { type: "withouttopandbottomborder" } })
                    }
                }
            }
            return this.model.load;
        },

        _onChartLoaded:function(args) {
            this.element.find("#" + this._id + "Container_svg_XAxisMultiLevelLabels_0").attr("cursor", "pointer");            
        },

        _setDrillParams: function (drilledMember, memberInfo) {
            var selectedSeries = this.getJSONRecords().chartLables[memberInfo.start + 0.5].split('~~');
            var drillParams = "";
            for (var i = 0; i < selectedSeries.length; i++) {
                drillParams += drillParams == "" ? selectedSeries[i] : ">#>" + selectedSeries[i];
                if (drilledMember == selectedSeries[i])
                    break;
            }
            var drillInfo = drillParams;
            if (this._drillAction == "drilldown")
                this._drillParams.push(drillParams);
            else
                this._drillParams = $.map(this._drillParams, function (value, index) { if (value.indexOf(drillParams) == -1) return value; });
            if ($(this.element).parents(".e-pivotclient").length > 0) {
                var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                pivotClientObj._drillParams = this._drillParams;
            }
            return drillInfo;
        },

        _getChartDrillDown: function (memberInfo, drilledMember, evt) {
            var isMondrian = this.model.dataSource.providerName == ej.olap.Providers.Mondrian;
            if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                var tempArray = new Array();
                for (var i = 0; i < this.model.dataSource.rows.length; i++) {
                    if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) {
                        for (var j = 0; j < this._labelCurrentTags.expandedMembers.length; j++) {
                            if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[j])) {
                                for (var k = 0; k < this._labelCurrentTags.expandedMembers[j].length; k++) {
                                    if (this._labelCurrentTags.expandedMembers[j][k].indexOf(this.model.dataSource.rows[i].fieldName) >= 0 && tempArray.indexOf(this._labelCurrentTags.expandedMembers[j][k].replace("&amp;", "&")) < 0 && tempArray.indexOf(this._labelCurrentTags.expandedMembers[j][k]) < 0) {
                                        tempArray.push(this._labelCurrentTags.expandedMembers[j][k]);
                                    }
                                }
                            }
                        }
                    }
                    for (var j = 0; j < this._selectedSeriesInfo.length; j++) {
                        if (this._selectedSeriesInfo[j].indexOf(this.model.dataSource.rows[i].fieldName) >= 0 && tempArray.indexOf(this._selectedSeriesInfo[j]) < 0 && tempArray.indexOf(this._selectedSeriesInfo[j].replace(/&/g, "&amp;")) < 0)
                            tempArray.push(this._selectedSeriesInfo[j].replace(/&/g, "&amp;"));
                    }
                }
                for (var i = 0; i < this._selectedSeriesInfo.length; i++)
                    this._selectedSeriesInfo[i] = this._selectedSeriesInfo[i].replace(/&/g, "&amp;");
                var uniqueNameArray = tempArray;
                if (this._drillAction == "drillup") {
                    for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++) {
                        if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[i])) {
                            for (var j = 0; j < this._labelCurrentTags.expandedMembers[i].length; j++) {
                                if (this.model.enableMultiLevelLabels && memberInfo != "") {
                                    if (this._labelCurrentTags.expandedMembers[i][j] == memberInfo) {
                                        var tempArray = new Array();
                                        jQuery.map(this._labelCurrentTags.expandedMembers[i], function (member) {
                                            if (member == memberInfo) flag = true;
                                            if (!flag) tempArray.push(member);
                                        });
                                        this._labelCurrentTags.expandedMembers[i] = tempArray;
                                    }
                                }
                                else {
                                    if (this._labelCurrentTags.expandedMembers[i][j].split('::')[2] == drilledMember) {
                                        memberInfo = this._labelCurrentTags.expandedMembers[i][j];
                                        var tempArray = new Array();
                                        jQuery.map(this._labelCurrentTags.expandedMembers[i], function (member) {
                                            if (member.split('::')[2] == drilledMember) flag = true;
                                            if (!flag) tempArray.push(member);
                                        });
                                        this._labelCurrentTags.expandedMembers[i] = tempArray;
                                    }
                                }
                            }
                        }
                    }
                    drilledMember = ej.olap._mdxParser._splitCellInfo(memberInfo);
                }
                else
                    memberInfo = memberInfo.indexOf("&amp") == -1 ? memberInfo.replace(/&/g, "&amp;") : memberInfo;
                var dimensionIndex = -1;
                for (var i = 0; i < this.model.dataSource.rows.length; i++) {
                    if (this.model.dataSource.rows[i].fieldName == drilledMember.hierarchyUniqueName) {
                        dimensionIndex = i;
                        break;
                    }
                }
                if (isMondrian && this._drillAction == "drillup" && !ej.isNullOrUndefined(this._selectedSeriesInfo[dimensionIndex]))
                    this._selectedSeriesInfo[dimensionIndex] = memberInfo;
                var index = $.inArray(memberInfo, this._selectedSeriesInfo);
                var tempArray = new Array();
                for (var i = 0; i <= index; i++)
                    tempArray.push(this._selectedSeriesInfo[i]);
                var selectedSeriesInfo = tempArray;
                this._selectedSeriesInfo = tempArray.length > 0 ? tempArray : this._selectedSeriesInfo;
                var index = $.inArray(memberInfo, uniqueNameArray);
                var tempArray = new Array();
                for (var i = 0; i <= index; i++)
                    tempArray.push(uniqueNameArray[i]);
                uniqueNameArray = tempArray;
                var currentObj = $(this.element).parents(".e-pivotclient").length > 0 ? this.element.parents(".e-pivotclient").data("ejPivotClient") : this;
                if (this._drillAction == "drilldown") {
                    if (ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) this._labelCurrentTags["expandedMembers"] = new Array();
                    if (ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[dimensionIndex])) this._labelCurrentTags.expandedMembers[dimensionIndex] = new Array();
                    this._labelCurrentTags.expandedMembers[dimensionIndex].push(memberInfo);
                    if (this.element.parents(".e-pivotclient").length > 0) {
                        currentObj = this.element.parents(".e-pivotclient").data("ejPivotClient");
                        currentObj._drillParams.push($.map(uniqueNameArray, function (item) { return item.split("&amp;").join("&") }).join(">#>"));
                    }
                }
                else {
                    if (this.element.parents(".e-pivotclient").length > 0) {
                        currentObj = this.element.parents(".e-pivotclient").data("ejPivotClient");
                        var parentArray = [], parent = "", expandedMembers = [];
                        $.each(uniqueNameArray, function (index, item) {
                            if (parent == "" || parent.split("::")[0] != item.split("::")[3])
                                parentArray.push(item);
                            parent = item;
                        });
                        $.each(parentArray, function (index, item) {
                            if (index < dimensionIndex && item.length > 0)
                                expandedMembers.push(item.split("&amp;").join("&"));
                        });
                        currentObj._drillParams = $.grep(currentObj._drillParams, function (item) { return dimensionIndex < 1 ? item.indexOf(memberInfo.split("&amp;").join("&")) == -1 : !(item.indexOf(memberInfo.split("&amp;").join("&")) > -1 && $.map(item.split(">#>"), function (itm) { if (expandedMembers.indexOf(itm) > -1) return itm }).length == expandedMembers.length); });
                        var flag = false;
                        for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++) {
                            if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[i]) && this._labelCurrentTags.expandedMembers[i].length > 0) { flag = true; break; }
                        }
                        if (currentObj._drillParams.length > 0 && this._drilledCellSet.length > 0 && !flag && !ej.isNullOrUndefined(currentObj._drillParams[currentObj._drillParams.length - 1])) {
                            var index = 0, prevMember = "", member = "", lock = false;
                            for (var i = 0; i < currentObj._drillParams[currentObj._drillParams.length - 1].split(">#>").length; i++) {
                                member = currentObj._drillParams[currentObj._drillParams.length - 1].split(">#>")[i];
                                if (member.indexOf("undefined") == -1) {                                    
                                    index = prevMember == "" ? 0 : (member.split("::")[0].split('.')[0] + '.' + member.split("::")[0].split('.')[1] == prevMember.split("::")[0].split('.')[0] + '.' + prevMember.split("::")[0].split('.')[1]) ? index : index + 1;
                                    $.each(this._drilledCellSet, function (index, item) {
                                        if ($.map(item[0].key.split("][").join("]>#>[").split(">#>"), function (itm) { if (expandedMembers.indexOf(itm) > -1) return itm }).length != expandedMembers.length || expandedMembers.length == 0) {
                                            $.each(item[0].key.split("][").join("]>#>[").split(">#>"), function (idx, itm) {
                                                if ((member.split("::")[0] + " !#rowheader") == itm) {
                                                    lock = true;
                                                }
                                            });
                                        }
                                    });
                                    if (lock) {
                                        member = member.split("&").join("&amp;");
                                        if (ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[index]))
                                            this._labelCurrentTags.expandedMembers[index] = member;
                                        else
                                            this._labelCurrentTags.expandedMembers[index].push(member);
                                        lock = false;
                                    }
                                    prevMember = member;
                                }
                            }                           
                        }
                    }
                }
                for (var i = dimensionIndex + 1; i < this._labelCurrentTags.expandedMembers.length; i++)
                    this._labelCurrentTags.expandedMembers[i] = [];
                if (this._drillAction == "drilldown")
                    ej.olap._mdxParser.updateDrilledReport({ uniqueName: memberInfo, seriesInfo: this._selectedSeriesInfo, uniqueNameArray: uniqueNameArray }, "rowheader", currentObj);
                else
                    ej.olap._mdxParser.updateDrilledReport({ uniqueName: memberInfo, seriesInfo: selectedSeriesInfo, uniqueNameArray: uniqueNameArray, action: "collapse" }, "rowheader", currentObj);
            }
            else
            {
                var drillInfo = "";
                if (this._drillAction == "" && this.model.enableMultiLevelLabels) {
                    this._waitingPopup.hide();
                    return false;
                }
                else if (this._drillAction == "drilldown") {
                    if (this.model.enableMultiLevelLabels) {
                        drillInfo = this._setDrillParams(drilledMember, memberInfo);
                        if (this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                            this._selectedItem = drilledMember;
                            this._generateData({ "JsonRecords": this._pivotEngine, "PivotReport": this.getOlapReport() });
                        }
                        else
                            this._generateData(this._pivotEngine);
                    }
                    else {
                        if (ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) this._labelCurrentTags["expandedMembers"] = new Array();
                        this._labelCurrentTags.expandedMembers.push(drilledMember);
                        var clonedEngine = this._cloneEngine(this._pivotEngine);
                        for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++)
                            this._cropData(clonedEngine, this._labelCurrentTags.expandedMembers[i], 0, true);
                        this._generateData(clonedEngine);
                    }
                    this._trigger("drillSuccess", { chartObj: this, drillAction: "drilldown", drilledMember: this.model.enableMultiLevelLabels ? drillInfo : this._labelCurrentTags.expandedMembers.join(">#>"), event: evt });
                }
                else {
                    if (this.model.enableMultiLevelLabels) {
                        drillInfo = this._setDrillParams(drilledMember, memberInfo);
                        if (this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                            this._selectedItem = drilledMember;
                            this._generateData({ "JsonRecords": this._pivotEngine, "PivotReport": this.getOlapReport() });
                        }
                        else
                            this._generateData(this._pivotEngine);
                    }
                    else {
                        var flag = false, tempArray = new Array();
                        jQuery.map(this._labelCurrentTags.expandedMembers, function (member) {
                            if (member == drilledMember) flag = true;
                            if (!flag) tempArray.push(member);
                        });
                        this._labelCurrentTags.expandedMembers = tempArray;
                        drillInfo = this._labelCurrentTags.expandedMembers.length == 0 ? drilledMember : this._labelCurrentTags.expandedMembers.join(">#>") + ">#>" + drilledMember;
                        var isClientMode=this.model.operationalMode == ej.PivotChart.OperationalMode.ClientMode;
                        if ((this._labelCurrentTags.expandedMembers.length == 0 || isClientMode) && $(this.element).parents(".e-pivotclient").length > 0) {
                            var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                            if (pivotClientObj._drillParams.length > 0) {
                                pivotClientObj._drillParams = $.grep(pivotClientObj._drillParams, function (item) { return item.indexOf(isClientMode ? drillInfo : drilledMember) < 0; });
                                pivotClientObj._getDrilledMember();
                            }
                        }
                        var clonedEngine = this._cloneEngine(this._pivotEngine);
                        for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++)
                            this._cropData(clonedEngine, this._labelCurrentTags.expandedMembers[i], 0, true);
                        this._generateData(clonedEngine);
                    }
                    this._trigger("drillSuccess", { chartObj: this, drillAction: "drillup", drilledMember: drillInfo, event: evt });
                }
            }
        },

        _multiLevelLabelClick: function (args) {
            if ($(this.element).parents(".e-pivotclient").length > 0)
                $(this.element).parents(".e-pivotclient").data("ejWaitingPopup").show();
            else if (!ej.isNullOrUndefined(this._waitingPopup))
                this._waitingPopup.show();
            if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                if (this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                    var expandableState = parseInt(args.data.multiLevelLabel.tag.split("::")[args.data.multiLevelLabel.tag.split("::").length - 1]);
                    if (args.data.multiLevelLabel.tag.startsWith("[Measures]") || expandableState == 0) {
                        if ($(this.element).parents(".e-pivotclient").length > 0)
                            $(this.element).parents(".e-pivotclient").data("ejWaitingPopup").hide();
                        else if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.hide();
                        return false;
                    }
                    this._selectedTagInfo = args.data.multiLevelLabel.tag;
                    this._drillAction = expandableState == 2 ? "drilldown" : "drillup";
                    this._startDrilldown = true;
                    var serializedCustomObject = JSON.stringify(this.model.customObject);
                    var report = this.getOlapReport();
                    if (this.model.beforeServiceInvoke != null)
                        this._trigger("beforeServiceInvoke", { action: this._drillAction, element: this.element, customObject: this.model.customObject });
                    if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined) {
                        if (!ej.isNullOrUndefined(this._pivotClientObj))
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this._drillAction + "#fullchart", "drilledSeries": this._selectedTagInfo, "olapReport": report, "clientReports": this._pivotClientObj.reports, "customObject": serializedCustomObject }), this.renderControlSuccess);
                        else
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this._drillAction + "#fullchart", "drilledSeries": this._selectedTagInfo, "olapReport": report, "customObject": serializedCustomObject }), this.renderControlSuccess);
                    }
                    else {
                        if (!ej.isNullOrUndefined(this._pivotClientObj))
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this._drillAction + "#fullchart", "drilledSeries": this._selectedTagInfo, "olapReport": report }), this.renderControlSuccess);
                        else
                            this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": this._drillAction + "#fullchart", "drilledSeries": this._selectedTagInfo, "olapReport": report, "clientReports": this._pivotClientObj.reports }), this.renderControlSuccess);
                    }
                }
                else {
                    if (args.data.multiLevelLabel.tag.endsWith("0")) {
                        if (!ej.isNullOrUndefined(this._waitingPopup))
                            this._waitingPopup.hide();
                        return false;
                    }
                    var memberInfo = args.data.multiLevelLabel.tag.split("::").splice(0, args.data.multiLevelLabel.tag.split("::").length - 1).join("::");
                    var drilledMember = ej.olap._mdxParser._splitCellInfo(memberInfo);
                    var selectedTag = this.getJSONRecords().labelTags[args.data.multiLevelLabel.start + 0.5].split("~~");
                    this._selectedSeriesInfo = [];
                    for (var i = 0; i < selectedTag.length; i++) {
                        this._selectedSeriesInfo.push(selectedTag[i].split("#")[selectedTag[i].split("#").length - 1]);
                    }
                    this._labelCurrentTags.collapsedMembers = $.grep(this._labelCurrentTags.collapsedMembers, function (item) { return item != args.data.multiLevelLabel.text.slice(2, args.data.multiLevelLabel.text.length); });
                    this._drillAction = args.data.multiLevelLabel.tag.split("::")[args.data.multiLevelLabel.tag.split("::").length - 1] == "2" ? "drilldown" : (args.data.multiLevelLabel.tag.split("::")[args.data.multiLevelLabel.tag.split("::").length - 1] == "1" ? "drillup" : "");
                    if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) {
                        for (var j = 0; j < this._labelCurrentTags.expandedMembers.length; j++) {
                            if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[j])) {
                                for (var k = 0; k < this._labelCurrentTags.expandedMembers[j].length; k++) {
                                    if (this._labelCurrentTags.expandedMembers[j][k].indexOf(memberInfo.replace(/&/g, "&amp;")) >= 0 || this._labelCurrentTags.expandedMembers[j][k].indexOf(memberInfo) >= 0) {
                                        memberInfo = memberInfo.replace(/&/g, "&amp;");
                                        break;
                                    }
                                }
                            }
                        }
                    }                    
                    this._getChartDrillDown(memberInfo, drilledMember, args);
                }
            }
            else {
                var drilledMember = args.data.multiLevelLabel.tag.split("#")[0];
                this._drillAction = args.data.multiLevelLabel.tag.endsWith("1") ? "drilldown" : (args.data.multiLevelLabel.tag.endsWith("2") ? "drillup" : "");
                this._getChartDrillDown(args.data.multiLevelLabel, drilledMember, args);
            }
        },

        _labelRenders: function (args) {
            if (this.model.enableMultiLevelLabels && ((this.seriesType() == "bar" || this.seriesType() == "stackingbar") ? (args.data.axis.orientation.toLowerCase() == "vertical") : (args.data.axis.orientation.toLowerCase() == "horizontal"))) {
                args.data.label.Text = "";
            }
            else {
                this._trigger("axesLabelRendering", args);                
                if (((args.data.axis.orientation.toLowerCase() == "horizontal" && args.data.label.Text != undefined) || ((this.seriesType() == "bar" || this.seriesType() == "stackingbar") && args.data.axis.orientation.toLowerCase() == "vertical" && args.data.label.Text != undefined)) && this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                    var splitName = this.model.enableRTL ? args.data.label.Text.toString().split("~~").reverse() : args.data.label.Text.toString().split("~~");
                    var pivotChartObj = this;
                    if (!ej.isNullOrUndefined(pivotChartObj.getJSONRecords())) {
                        $.each($.extend([], pivotChartObj.getJSONRecords().chartLables, true), function (index, val) {
                            if (val.toString().split('#').join("~~") == splitName.join("~~")) {
                                args.data.label.Text = val.toString().split("~~").map(function (itm) {
                                    return itm.split("#")[itm.split("#").length - 1]
                                }).join("~~");
                                return false;
                            }
                        });
                    }
                }
            }
        },

        _reSizeHandler: function (args) {
            var chart_resize = this.element.find("#" + this._id + "Container").height(this.element.height()).width(this.element.width()).data("ejChart");
            if (!ej.isNullOrUndefined(chart_resize)) {
                chart_resize.redraw();
            }
        },

        _getLocalizedLabels: function (property) {
            return ej.PivotChart.Locale[this.locale()][property] === undefined ? ej.PivotChart.Locale["en-US"][property] : ej.PivotChart.Locale[this.locale()][property];
        },

        _onPreventPanelClose: function (e) {
            $('body').find("#preventDiv").remove();
            if ($(".e-pivotgrid").data("ejWaitingPopup") && !(!ej.isNullOrUndefined(e) && ($(e.target).hasClass("pivotTree") || $(e.target).hasClass("pivotTreeContext") || $(e.target).hasClass("pivotTreeContextMenu"))))
                $(".e-pivotgrid").data("ejWaitingPopup").hide()
        },

        _seriesClick: function (sender) {
            this.element.find("#" + this._id + "ExpandMenu, .expandMenu, .e-dialog").remove();
            var selectedLabel, menuList = new Array(), chartOffset = this.element.position(), me = this;
            var pivotChartObj = this;
            if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap && this.model.operationalMode == ej.PivotChart.OperationalMode.ServerMode) {
                var tempLabel; var pointIndex;
                this._selectedTags = [];
                if (sender.data.region != null && sender.data.region != undefined) {
                    var labels = this.model.enableRTL ? $.map(sender.model.primaryXAxis.labels, function (x) { return x.split("~~").reverse().join("~~"); }) : sender.model.primaryXAxis.labels;
                    selectedLabel = labels[sender.data.region.Region.PointIndex];
                    pointIndex = sender.data.region.Region.PointIndex;
                }
                else if (sender.data.point.x != null && sender.data.point.x != undefined && sender.data.point.x != "") {
                    var labels = this.model.enableRTL ? $.map(sender.data.series.xAxis.labels, function (x) { return x.split("~~").reverse().join("~~"); }) : sender.data.series.xAxis.labels;
                    selectedLabel = labels[sender.data.point.X];
                    pointIndex = sender.data.point.X;
                }
                if (!this.model.enableMultiLevelLabels) {
                    if ($($("#" + this._id + "Container_vml_XAxisLabels_0")[0]).children()[pointIndex] != undefined)
                        tempLabel = $($("#" + this._id + "Container_vml_XAxisLabels_0")[0]).children()[pointIndex].innerHTML;
                    else if ($("#" + this._id + "Container_svg_XAxisLabels_0").children()[pointIndex])
                        tempLabel = $("#" + this._id + "Container_svg_XAxisLabels_0").children()[pointIndex].textContent;
                    else if (this.seriesType() == "bar" || this.seriesType() == "stackingbar") {
                        if ($($("#" + this._id + "Container_vml_YAxisLabels_0")[0]).children()[pointIndex] != undefined)
                            tempLabel = $($("#" + this._id + "Container_vml_YAxisLabels_0")[0]).children()[pointIndex].innerHTML;
                        else if ($("#" + this._id + "Container_svg_YAxisLabels_0").children()[pointIndex])
                            tempLabel = $("#" + this._id + "Container_svg_YAxisLabels_0").children()[pointIndex].textContent;
                        else {
                            var temp = sender.model.primaryXAxis.labels[pointIndex].split("~~");
                            tempLabel = temp[temp.length - 1];
                        }
                    }
                    else {
                        var temp = sender.model.primaryXAxis.labels[pointIndex].split("~~");
                        tempLabel = temp[temp.length - 1];
                    }
                }
                else {
                    tempLabel = sender.model.primaryXAxis.labels[pointIndex].split("~~")[sender.model.primaryXAxis.labels[pointIndex].split("~~").length - 1];
                }
                if (tempLabel) {
                    $("#" + this._id).find("#" + this._id + "ExpandMenu, .expandMenu, .e-dialog").remove();
                    var splitLabel = selectedLabel.split("~~");

                    jQuery.each(splitLabel, function (index, value) {
                        jQuery.each(pivotChartObj._labelCurrentTags, function (key, val) {
                            if ($.trim(value) == val.name) {
                                pivotChartObj._selectedTags.push(val);
                                return false;
                            }
                        });
                    });

                    jQuery.each(this._selectedTags, function (index, value) {
                        if (value.state > 1)
                            if (me.model.enableRTL)
                                menuList.push($(ej.buildTag("li.menuList", value.name + " - " + (pivotChartObj._getLocalizedLabels("Expand")))[0]).attr("role", "presentation")[0].outerHTML);
                            else
                                menuList.push($(ej.buildTag("li.menuList", (pivotChartObj._getLocalizedLabels("Expand")) + " - " + value.name)[0]).attr("role", "presentation")[0].outerHTML);
                    });
                    jQuery.each(this._selectedTags, function (index, value) {
                        for (var label = 0; label < selectedLabel.split("~~").length - 1; label++) {
                            if ((selectedLabel.split("~~")[label] == value.name) && value.state == 1)
                                if (me.model.enableRTL)
                                    menuList.push($(ej.buildTag("li.menuList", value.name + " - " + (pivotChartObj._getLocalizedLabels("Collapse")))[0]).attr("role", "presentation")[0].outerHTML);
                                else
                                    menuList.push($(ej.buildTag("li.menuList", (pivotChartObj._getLocalizedLabels("Collapse")) + " - " + selectedLabel.split("~~")[label])[0]).attr("role", "presentation")[0].outerHTML);
                        }
                    });
                }
            }
            else {
                selectedLabel = (sender.data.region != null && sender.data.region != undefined) ? this.getJSONRecords().chartLables[sender.data.region.Region.PointIndex] : sender.data.series.xAxis.labels[sender.data.point.X];
                if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap)
                    selectedLabel = selectedLabel.split("~~").map(function (itm) { return itm.split("#")[itm.split("#").length - 1] }).join("~~");
                if (!ej.isNullOrUndefined(this._labelCurrentTags.collapsedMembers)) {
                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                        var memberNames = selectedLabel.split("~~");
                        if (this.model.dataSource.values[0].axis == ej.olap.AxisName.Row) {
                            var measureNames = $.map(this.model.dataSource.values[0].measures, function (item) { return item.fieldName });
                            if ($.inArray(memberNames[memberNames.length - 1], measureNames) >= 0)
                                memberNames.splice(memberNames.length - 1, 1);
                        }
                        this._selectedSeriesInfo = new Array();
                        for (var i = 0; i < memberNames.length; i++) {
                            var memberName = memberNames[i].split('#')[memberNames[i].split('#').length - 1];
                            if ($(this.getJSONRecords().seriesTags).filter(function (index, item) { return item.split('::')[2] == memberName }).length > 0) this._selectedSeriesInfo.push($(this.getJSONRecords().seriesTags).filter(function (index, item) { return item.split('::')[2] == memberName })[0]);
                            if ($.inArray(memberName, this._labelCurrentTags.collapsedMembers) >= 0) {
                                if (me.model.enableRTL)
                                    menuList.push($(ej.buildTag("li.menuList",  memberName +" - " +(this._getLocalizedLabels("Expand")) )[0]).attr("role", "presentation")[0].outerHTML);
                                else
                                    menuList.push($(ej.buildTag("li.menuList", (this._getLocalizedLabels("Expand")) + " - " + memberName)[0]).attr("role", "presentation")[0].outerHTML);
                            }
                        }
                    }
                    else {
                        if ($.inArray(selectedLabel, this._labelCurrentTags.collapsedMembers) >= 0)
                            if (me.model.enableRTL)
                                menuList.push($(ej.buildTag("li.menuList", selectedLabel + " - " + (this._getLocalizedLabels("Expand")))[0]).attr("role", "presentation")[0].outerHTML);
                            else
                                menuList.push($(ej.buildTag("li.menuList", (this._getLocalizedLabels("Expand")) + " - " + selectedLabel)[0]).attr("role", "presentation")[0].outerHTML);
                    }
                }
                if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers)) {
                    if (this.model.analysisMode == ej.PivotChart.AnalysisMode.Olap) {
                        for (var j = 0; j < this._labelCurrentTags.expandedMembers.length; j++) {
                            if (!ej.isNullOrUndefined(this._labelCurrentTags.expandedMembers[j])) {
                                for (var i = 0; i < this._labelCurrentTags.expandedMembers[j].length; i++) {
                                    if (me.model.enableRTL)
                                        menuList.push($(ej.buildTag("li.menuList", this._labelCurrentTags.expandedMembers[j][i].split('::')[2] + " - " + (this._getLocalizedLabels("Collapse")))[0]).attr("role", "presentation")[0].outerHTML);
                                    else
                                        menuList.push($(ej.buildTag("li.menuList", (this._getLocalizedLabels("Collapse")) + " - " + this._labelCurrentTags.expandedMembers[j][i].split('::')[2])[0]).attr("role", "presentation")[0].outerHTML);
                                }
                            }
                        }
                    }
                    else {
                        for (var i = 0; i < this._labelCurrentTags.expandedMembers.length; i++) {
                            if (me.model.enableRTL)
                                menuList.push($(ej.buildTag("li.menuList", this._labelCurrentTags.expandedMembers[i] + " - " + (this._getLocalizedLabels("Collapse")))[0]).attr("role", "presentation")[0].outerHTML);
                            else
                                menuList.push($(ej.buildTag("li.menuList", (this._getLocalizedLabels("Collapse")) + " - " + this._labelCurrentTags.expandedMembers[i])[0]).attr("role", "presentation")[0].outerHTML);
                        }
                    }
                }                
            }
            if (menuList.length > 0) {
                menuList.push($(ej.buildTag("li.menuList", this._getLocalizedLabels("Exit"))[0]).attr("role", "presentation")[0].outerHTML);
                var expandMenu = $(ej.buildTag("div#" + this._id + "ExpandMenu.expandMenu", menuList)[0]).attr("role", "presentation")[0].outerHTML;
                $(expandMenu).ejDialog({ width: "auto", target: "#" + this._id, enableResize: false, enableRTL: this.model.enableRTL });
                $("#" + this._id + "ExpandMenu_wrapper").appendTo(this.element).css({ "left": sender.data.location.x + 8 + chartOffset.left, "top": sender.data.location.y + 8 + chartOffset.top, "min-height": navigator.userAgent.toLowerCase().indexOf('webkit') > 0 ? "initial" : "auto" });
                $("#" + this._id + "ExpandMenu").css({ "min-height": navigator.userAgent.toLowerCase().indexOf('webkit') > 0 ? "initial" : "auto" });
            }
            this.element.find(".e-titlebar, .e-header").remove();
            this._trigger("pointRegionClick", sender);
        },

        exportPivotChart: function (exportOption, fileName, exportFormat) {
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8) return;
            if (ej.isNullOrUndefined(fileName) || fileName == "") fileName = "Sample";
            var chartObj = $("#" + this._id + "Container").data("ejChart");
            var zoomFactor = chartObj.model.primaryXAxis.zoomFactor;
            chartObj.model.primaryXAxis.zoomFactor = 1;
            chartObj.model.enableCanvasRendering = true;
            chartObj.redraw();
            var canvasElement = chartObj["export"]();
            var chartString = canvasElement.toDataURL("image/png");
            chartObj.model.primaryXAxis.zoomFactor = zoomFactor;
            chartObj.model.enableCanvasRendering = false;
            chartObj.redraw();
            var bgColor = $(this.element).css('background-color') != "" ? $(this.element).css('background-color') : "rgb(255, 255, 255)";
            var exportSetting = { url: "", fileName: "PivotChart", exportMode: ej.PivotChart.ExportMode.ClientMode, title: "", description: "", exportType: exportOption, controlName: this };
            this._trigger("beforeExport", exportSetting);
            if (exportSetting.exportMode == ej.PivotChart.ExportMode.ClientMode) {
                var params = {
                    args: JSON.stringify({
                        fileName: ej.isNullOrUndefined(fileName) ? (ej.isNullOrUndefined(exportSetting.fileName) ? "PivotChart" : exportSetting.fileName) : fileName,
                        chartdata: chartString.split(',')[1],
                        bgColor: bgColor,
                        exportFormat: exportFormat,
                        title: exportSetting.title,
                        description: exportSetting.description
                    })
                };
                if (ej.raiseWebFormsServerEvents && ((exportOption == "excelExport" || exportOption == "pdfExport" || exportOption == "wordExport" || exportOption == "imageExport") && exportSetting.exportMode == ej.PivotChart.ExportMode.ClientMode && $.trim(exportSetting.url) == "")) {
                    var serverArgs = { model: this.model, originalEventType: exportOption };
                    var clientArgs = params;
                    ej.raiseWebFormsServerEvents(exportOption, serverArgs, clientArgs);
                    setTimeout(function () {
                        ej.isOnWebForms = true;
                    }, 1000);
                }
                else
                    this.doPostBack($.trim(exportSetting.url) != "" ? exportSetting.url : exportOption, params);
            }
            else {
                var params = {
                    args: JSON.stringify({
                        exportOption: exportOption,
                        chartdata: chartString.split(',')[1],
                        bgColor: bgColor,
                        title: exportSetting.title,
                        description: exportSetting.description
                    })
                };
                this.doPostBack($.trim(exportSetting.url) != "" ? exportSetting.url : this.model.url + "/" + this.model.serviceMethodSettings.exportPivotChart, params);
            }            
        },

        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            var contentType, dataType, successEvt, isAsync = true;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, ej.olap.base, customArgs), isAsync = (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9) ? false : true;
            $.ajax({
                type: type,
                url: url,
                data: data,
                async: isAsync,
                contentType: contentType,
                dataType: dataType,
                success: successEvt,
                complete: ej.proxy(function () {
                    var eventArgs = { "action": !ej.isNullOrUndefined(customArgs) && !ej.isNullOrUndefined(customArgs.action) ? customArgs.action : JSON.parse(data)["action"], "customObject": this.model.customObject, "element": this.element };
                    this._trigger("renderComplete", eventArgs);
                }, this),
                error: ej.proxy(function (msg, textStatus, errorThrown) {
                    if (typeof this._waitingPopup != 'undefined' && this._waitingPopup != null)
                        this._waitingPopup.hide();
                    if (typeof oclientWaitingPopup != 'undefined' && oclientWaitingPopup != null)
                        oclientWaitingPopup.hide();
                    var eventArgs = { "action": this._currentAction, "customObject": this.model.customObject, "element": this.element, "Message": msg };
                    this._trigger("renderFailure", eventArgs);
                    this.renderChartFromJSON("");
                }, this)
            });
        },

        doPostBack: function (url, params) {
            var form = $('<form>').attr({ 'action': url, 'method': 'POST', 'name': 'export' });
            var addParam = function (paramName, paramValue) {
                var input = $('<input type="hidden" title="params">').attr({
                    'id': paramName,
                    'name': paramName,
                    'value': paramValue
                }).appendTo(form);
            };
            for (var item in params)
                addParam(item, params[item]);
            form.appendTo(document.body).submit().remove();
                    }
            });

    ej.PivotChart.Locale = {};

    ej.PivotChart.Locale["en-US"] = {
        Measure: "Measure",
        Row: "Row",
        Column: "Column",
        Value: "Value",
        Expand: "Expand",
        Collapse: "Collapse",
        Exit: "Exit",
        ChartTypes: "Chart Types",
        TDCharts: "3D Charts",
        Tooltip: "Tooltip",
        Exporting: "Exporting",
        Line: "Line",
        Spline: "Spline",
        Column: "Column",
        Area: "Area",
        SplineArea: "Spline Area",
        StepLine: "Step Line",
        StepArea: "Step Area",
        Pie: "Pie",
        Bar: "Bar",
        StackingArea: "Stacking Area",
        StackingColumn: "Stacking Column",
        StackingBar: "Stacking Bar",
        Pyramid: "Pyramid",
        Funnel: "Funnel",
        Doughnut: "Doughnut",
        Scatter: "Scatter",
        Bubble: "Bubble",
        TreeMap: "TreeMap",
        ColumnTD: "Column 3D",
        PieTD: "Pie 3D",
        BarTD: "Bar 3D",
        StackingBarTD: "StackingBar 3D",
        StackingColumnTD: "StackingColumn 3D",
        Excel: "Excel",
        Word: "Word",
        Pdf: "PDF",
        PNG: "PNG",
        EMF: "EMF",
        GIF: "GIF",
        JPG: "JPG",
        BMP: "BMP",
        ZoomIn: "Zoom In",
        ZoomOut: "Zoom Out",
        Legend: "Legend",
        SmartLabels: "Smart Labels",
        Interactions: "Interactions",
        Zooming: "Zooming",
        Rotate45: "Rotate45",
        Rotate90: "Rotate90",
        Trim: "Trim",
        MultipleRows: "Multiple Rows",
        Wrap: "Wrap",
        Hide: "Hide",
        WrapByWord: "Wrap By word",
        CrossHair: "Cross Hair",
        TrackBall: "Track Ball",
        DisableTD: "Disable 3D Charts",
        None:"None"
    };

    ej.PivotChart.ChartTypes = {
        Line: 'line', Spline: 'spline', Column: 'column', Area: 'area', SplineArea: 'splinearea', StepLine: 'stepline', StepArea: 'steparea', Pie: 'pie', Bar: 'bar', StackingArea: 'stackingarea', StackingColumn: 'stackingcolumn', StackingBar: 'stackingbar', Pyramid: 'pyramid', Funnel: 'funnel', Doughnut: 'doughnut', Scatter: 'scatter', Bubble: 'bubble', WaterFall: 'waterfall'
    };

    ej.PivotChart.ExportOptions = {
        Excel: 'excel',
        Word: 'word',
        PDF: 'pdf',
        CSV: 'csv',
        PNG: 'png',
        JPG: 'jpg',
        EMF: 'emf',
        GIF: 'gif',
        BMP: 'bmp'
    };

    ej.PivotChart.SymbolShapes = {
        None: "none",
        LeftArrow: "leftarrow",
        RightArrow: "rightarrow",
        Circle: "circle",
        Cross: "cross",
        HorizLine: "horizline",
        VertLine: "vertline",
        Diamond: "diamond",
        Rectangle: "rectangle",
        Triangle: "triangle",
        InvertedTriangle: "invertedtriangle",
        Hexagon: "hexagon",
        Pentagon: "pentagon",
        Star: "star",
        Ellipse: "ellipse",
        Wedge: "wedge",
        Trapezoid: "trapezoid",
        UpArrow: "uparrow",
        DownArrow: "downarrow",
        Image: "image"
    };

    ej.PivotChart.AnalysisMode = {
        Olap: "olap",
        Pivot: "pivot"
    };

    ej.PivotChart.OperationalMode = {
        ClientMode: "clientmode",
        ServerMode: "servermode"
    };
    ej.PivotChart.ExportMode = {
        ClientMode: "clientmode",
        ServerMode: "servermode"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Pivot TreeMap elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejPivotTreeMap", "ej.PivotTreeMap", {

        _rootCSS: "e-pivottreemap",
        element: null,
        model: null,
        validTags: ["div", "span"],
        defaults: $.extend(ej.datavisualization.TreeMap.prototype.defaults, {
            url: "",
            cssClass: "",
            currentReport: "",
            operationalMode: "clientmode",
            customObject: {},
            isResponsive: false,
            dataSource: {
                data: null,
                isFormattedValues: false,
                columns: [],
                cube: "",
                catalog: "",
                rows: [],
                values: [],
                filters: []
            },
            serviceMethodSettings: {
                initialize: "InitializeTreeMap",
                drillDown: "DrillTreeMap",
            },
            locale: "en-US",
            drillSuccess: null,
            beforeServiceInvoke: null,
            afterServiceInvoke: null,
            load: null,
            renderComplete: null,
            renderFailure: null,
            renderSuccess: null,
            beforePivotEnginePopulate: null
        }),

        dataTypes: {
            dataSource: {
                data: "data",
                columns: "array",
                rows: "array",
                values: "array",
                filters: "array"
            },
            serviceMethodSettings: {
                initialize: "enum",
                drillDown: "enum",
            },
            customObject: "data"
        },

        locale: ej.util.valueFunction("locale"),

        getOlapReport: function () {
            return this._olapReport;
        },

        setOlapReport: function (value) {
            this._olapReport = value;
        },

        getJsonRecords: function () {
            return this._JSONRecords;
        },

        setJsonRecords: function (value) {
            this._JSONRecords = JSON.parse(value);
        },

        _init: function () {
            this._initPrivateProperties();
            this._load();
        },

        _destroy: function () {
            this.element.empty().removeClass("e-pivottreemap" + this.model.cssClass);
            if (this._waitingPopup != undefined)
                this._waitingPopup._destroy();
        },

        _initPrivateProperties: function () {
            this._id = this.element.attr("id");
            this._olapReport = "";
            this._JSONRecords = null;
            this._treeMapDatasource = [];
            this._currentAction = "initialize";
            this._selectedItem = "";
            this._selectedTagInfo = null;
            this._tagCollection = new Array();
            this._drilledMembers = new Array();
            this._startDrilldown = false;
            this._isDrilled = false;
            this._treeMap = null;
            this._waitingPopup = null;
            this._drillText = "";
            this._showDrillText = "";
        },

        _load: function () {
            this.element.addClass(this.model.cssClass);
            if ($(this.element).parents(".e-pivotclient").length > 0) {
                var pivotClientObj = $(this.element).parents(".e-pivotclient").data("ejPivotClient");
                this.model.customObject = oclientProxy.model.customObject;
                if ($("#" + pivotClientObj._id + "_maxView")[0])
                    $("#" + pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: true });
                else if (!ej.isNullOrUndefined(pivotClientObj._waitingPopup))
                    pivotClientObj._waitingPopup.show();
            }
            else {
                this.element.ejWaitingPopup({ showOnInit: true });
                this._waitingPopup = this.element.data("ejWaitingPopup");
                this._waitingPopup.show();
            }
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            if (this.model.dataSource.data == null && this.model.url == "" && this.model.dataSource.cube == "") {
                this.renderTreeMapFromJSON(null);
                this._waitingPopup.hide();
                return
            };
            if ((this.model.dataSource.data == null && this.model.url != "") || (this.model.dataSource.data != null && this.model.url != "" && this.model.operationalMode == ej.PivotTreeMap.OperationalMode.ServerMode)) {
                this.model.operationalMode = ej.PivotTreeMap.OperationalMode.ServerMode;
                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { action: this._currentAction, element: this.element, customObject: serializedCustomObject});
                if (this.model.customObject != "" && this.model.customObject != null && this.model.customObject != undefined)
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": "initialize", "currentReport": this.model.currentReport, "customObject": serializedCustomObject }), this.renderControlSuccess);
                else
                    this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": "initialize" }), this.renderControlSuccess);
            }
            else {
                this.model.operationalMode = ej.PivotTreeMap.OperationalMode.ClientMode;
                if (this.model.dataSource.rows.length > 1)
                    this.model.dataSource.rows = [this.model.dataSource.rows[this.model.dataSource.rows.length - 1]];
                if (this.model.dataSource.cube != "") {
                    this._trigger("beforePivotEnginePopulate", { treeMapObject: this });
                    ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
                }
            }
        },

        generateJSON: function (dataObj, pivotengine) {
           var ptreemapProxy = this;
            var labelTags = [], drillTags = [], measureNames = "", points_Y = [], seriesNames = [], treemapLabels = [], valuePoints = [], jsonData = {};

            for (var i = 0; i < this.model.dataSource.values[0].measures.length; i++) {
                measureNames += measureNames == "" ? this.model.dataSource.values[0].measures[i].fieldCaption : "~" + this.model.dataSource.values[0].measures[i].fieldCaption;
            }
            var axis = this.model.dataSource.values[0].axis;
            var rowCount = this.model.dataSource.rows.length;
            var rowHeaderWidth = pivotengine[0][0].ColSpan;
            var elementCount = 0;
            if (rowHeaderWidth - rowCount <= 0) {
                rowHeaderWidth = 0;
                elementCount = rowCount;
            }
            else {
                if (axis == "rows")
                    elementCount = rowHeaderWidth - 1;
                else
                elementCount = rowHeaderWidth;
                rowHeaderWidth = elementCount - 1;
            }

            ///  for treemapLabels

            var tempArray = new Array();
            for (var i = 0; i < pivotengine.length; i++) {
                for (var j = 0; j < pivotengine[i].length; j++) {
                    var tag = null;
                    if (pivotengine[i][j].CSS == " value")
                        valuePoints.push(pivotengine[i][j].Value);
                    if (pivotengine[i][j].CSS == "rowheader" && pivotengine[i][j].Value != "") {
                        var obj = {};
                        tag = pivotengine[i][j].Info + "::" + pivotengine[i][j].State;
                        drillTags.push((pivotengine[i][j].Info).replace(/&/g, "&amp;"))
                        labelTags.push(tag);
                        if (tempArray.length == 0 && pivotengine[i][j].Info.split(".")[0].indexOf("Measures") < 0) {
                            obj["level"] = i;
                            obj["index"] = j;
                            obj["label"] = pivotengine[i][j].Value;
                            tempArray.push(obj);
                        }
                        if (tempArray.length != 0 && pivotengine[i][j].Info.split(".")[0].indexOf("Measures") < 0) {
                            for (var k = 0; k < tempArray.length; k++) {
                                if (!ej.isNullOrUndefined(tempArray[k])) {
                                    if (tempArray[k].index == j && tempArray[k].level != i) {
                                        tempArray[k].level = i;
                                        tempArray[k].label = tempArray[k].label + "~~" + pivotengine[i][j].Value;
                                        break;
                                    }
                                    else if (tempArray[k].level == i) {
                                        var islevel = false;
                                        for (var m = 0; m < tempArray.length; m++) {
                                            if (!ej.isNullOrUndefined(tempArray[m]))
                                                if (tempArray[m].index == j) {
                                                    islevel = true;
                                                    break;
                                                }
                                        }
                                        if (!islevel && pivotengine[i][j].Info.split(".")[0].indexOf("Measures") < 0) {
                                            obj["level"] = i;
                                            obj["index"] = j;
                                            obj["label"] = pivotengine[i][j].Value;
                                            tempArray.push(obj);
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else if (pivotengine[i][j].CSS == "summary") {
                        if (tempArray.length != 0) {
                            for (var k = 0; k < tempArray.length; k++) {
                                if (!ej.isNullOrUndefined(tempArray[k]))
                                    if (tempArray[k].index == j) {
                                        delete tempArray[k];
                                        break;
                                    }
                            }
                        }
                    }
                }
            }
            for (var k = 0; k < tempArray.length; k++) {
                if (!ej.isNullOrUndefined(tempArray[k]))
                    if (elementCount == tempArray[k].label.split("~~").length)
                        treemapLabels.push(tempArray[k].label);
            }

            /// for seriesNames

            var tempArray = new Array();
            for (var i = 0; i < pivotengine.length; i++) {
                for (var j = 0; j < pivotengine[i].length; j++) {
                    if (pivotengine[i][j].CSS == "colheader" && pivotengine[i][j].Value != "") {
                        var obj = {};
                        if (tempArray.length == 0) {
                            obj["level"] = j;
                            obj["index"] = i;
                            obj["label"] = pivotengine[i][j].Value;
                            tempArray.push(obj);
                        }
                        if (tempArray.length != 0) {
                            for (var k = 0; k < tempArray.length; k++) {
                                if (!ej.isNullOrUndefined(tempArray[k])) {
                                    if (tempArray[k].index == i && tempArray[k].level != j && pivotengine[i][j].Info.split(".")[0].indexOf("Measures") < 0) {
                                        tempArray[k].index = i;
                                        tempArray[k].label = tempArray[k].label + "~~" + pivotengine[i][j].Value;
                                        break;
                                    }
                                    else if (tempArray[k].level == j && pivotengine[i][j].Info.split(".")[0].indexOf("Measures") < 0) {
                                        var islevel = true;
                                        for (var m = 0; m < tempArray.length; m++) {
                                            if (!ej.isNullOrUndefined(tempArray[m])) {
                                                islevel = false;
                                                if (tempArray[m].index == i) {
                                                    islevel = true;
                                                    break;
                                                }
                                            }
                                        }
                                        if (!islevel && pivotengine[i][j].Info.split(".")[0].indexOf("Measures") < 0) {
                                            obj["level"] = j;
                                            obj["index"] = i;
                                            obj["label"] = pivotengine[i][j].Value;
                                            tempArray.push(obj);
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else if (pivotengine[i][j].CSS == "summary") {
                        if (tempArray.length != 0) {
                            for (var k = 0; k < tempArray.length; k++) {
                                if (!ej.isNullOrUndefined(tempArray[k]))
                                    if (tempArray[k].index == i) {
                                        delete tempArray[k];
                                        break;
                                    }
                            }
                        }
                    }
                }
            }

            for (var k = 0; k < tempArray.length; k++) {
                if (!ej.isNullOrUndefined(tempArray[k]))
                    seriesNames.push(tempArray[k].label);
            }

            //// Add MeasureName with Dimension

            if (measureNames != "" && axis == ej.olap.AxisName.Column) {
                for (var i = 0; i < seriesNames.length; i++) {
                    seriesNames[i] = seriesNames[i] + "~" + measureNames;
                }
            }

            ///  for points_Y

            if (rowHeaderWidth == 0) {
                var valueCount = (valuePoints.length / seriesNames.length);
                for (var i = 0; i < treemapLabels.length; i++) {
                    var tempArray = new Array();
                    for (var j = i; j < valuePoints.length; j = j + valueCount) {
                        var obj = {};
                        obj["Item1"] = (treemapLabels[i].indexOf("~~") >= 0 ? treemapLabels[i].split("~~")[0] : treemapLabels[i]);
                        obj["Item2"] = valuePoints[j];
                        tempArray.push(obj);
                    }
                    points_Y.push(tempArray);
                }
            }
            else {
                var cellCount = [];
                var index = null;
                for (var i = 0; i < treemapLabels.length; i++) {
                    var tempArray = new Array();
                    for (var j = 0; j < pivotengine[rowHeaderWidth].length; j++) {
                        if (pivotengine[rowHeaderWidth][j].CSS == "rowheader" && pivotengine[rowHeaderWidth][j].Value != "")
                            if (treemapLabels[i].split("~~")[treemapLabels[i].split("~~").length - 1] == pivotengine[rowHeaderWidth][j].Value) {
                                index = j;
                                tempArray.push(index);
                                tempArray.push(treemapLabels[i]);
                                cellCount.push(tempArray);
                                break;
                            }
                    }
                }
                for (var k = 0; k < cellCount.length; k++) {
                    var tempArray = new Array();
                    for (var i = 0; i < pivotengine.length; i++) {
                        for (var j = cellCount[k][0]; j < pivotengine[i].length; j++) {
                            if (pivotengine[i][j].CSS == " value") {
                                var obj = {};
                                obj["Item1"] = (cellCount[k][1].indexOf("~~") >= 0 ? cellCount[k][1].split("~~")[0] : cellCount[k][1]);
                                obj["Item2"] = pivotengine[i][j].Value;
                                tempArray.push(obj);
                            }
                            break;
                        }
                    }
                    if (tempArray.length != 0)
                        points_Y.push(tempArray);
                }
            }

            //// for jsonData

            jsonData["labelTags"] = labelTags;
            jsonData["drillTags"] = drillTags;
            jsonData["measureNames"] = measureNames;
            jsonData["points_Y"] = points_Y;
            jsonData["seriesNames"] = seriesNames;
            jsonData["treemapLabels"] = treemapLabels;
            ptreemapProxy._JSONRecords = jsonData;
            this.renderTreeMapFromJSON(jsonData);
            this._unWireEvents();
            this._wireEvents();
        },

        _wireEvents: function () {
            if (typeof (oclientProxy) == "undefined")
                $(window).on('resize', $.proxy(this._reSizeHandler, this));
            this._on(this.element, "click", ".drillItem", this._drillTreeMap);
        },

        _drillTreeMap: function (event) {
            var ptreemapProxy = ej.isNullOrUndefined(this.model.ptreemapProxy) ? this : this.model.ptreemapProxy;
            var memberInfo = null;
            if (event.type == "treeMapGroupSelected") {
                ptreemapProxy._treemapWaitingPopup({ show: true });
                if (event.selectedGroups.length == 0) {
                    ptreemapProxy._treemapWaitingPopup({ show: false });
                    return;
                }
                ptreemapProxy._currentAction = "drilldown";                
                ptreemapProxy._selectedItem = event.selectedGroups[0].header;
                for (var j = 0; j < ptreemapProxy._treeMapDatasource.length; j++) {
                    if (ptreemapProxy._treeMapDatasource[j].Tag.split("::")[2] == ptreemapProxy._selectedItem) {
                        ptreemapProxy._selectedTagInfo = ptreemapProxy._treeMapDatasource[j].Tag;
                        if (ptreemapProxy.model.operationalMode == ej.PivotTreeMap.OperationalMode.ClientMode)
                            memberInfo = ptreemapProxy._treeMapDatasource[j].drillTag;
                        if (ptreemapProxy._selectedTagInfo.split("::")[ptreemapProxy._selectedTagInfo.split("::").length - 1] != 2) {
                            ptreemapProxy._treeMap.refresh();
                            ptreemapProxy._treemapWaitingPopup({ show: false });
                            return;
                        }
                        else
                            break;
                    }
                }
                ptreemapProxy._startDrilldown = true;
                if (ptreemapProxy.model.operationalMode == ej.PivotTreeMap.OperationalMode.ServerMode) {
                    if (ptreemapProxy.model.beforeServiceInvoke != null)
                        ptreemapProxy._trigger("beforeServiceInvoke", { action: ptreemapProxy._currentAction, element: ptreemapProxy.element, customObject: ptreemapProxy.model.customObject });
                    var serializedCustomObject = JSON.stringify(ptreemapProxy.model.customObject);
                    if (ptreemapProxy.model.customObject != "" && ptreemapProxy.model.customObject != null && ptreemapProxy.model.customObject != undefined) {
                        if (typeof (oclientProxy) != "undefined")
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport(), "clientReports": oclientProxy.reports, "customObject": serializedCustomObject }), ptreemapProxy.renderControlSuccess);
                        else
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport(), "customObject": serializedCustomObject }), ptreemapProxy.renderControlSuccess);
                    }
                    else {
                        if (!typeof (oclientProxy) != "undefined")
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport() }), ptreemapProxy.renderControlSuccess);
                        else
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drilldown", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport(), "clientReports": oclientProxy.reports }), ptreemapProxy.renderControlSuccess);
                    }
                }
                else {
                    ptreemapProxy._drilledMembers.push(memberInfo);
                    ej.olap._mdxParser.updateDrilledReport({ uniqueName: memberInfo, seriesInfo: [memberInfo], uniqueNameArray: ptreemapProxy._drilledMembers }, "rowheader", ptreemapProxy);
                }
            }
            else {
                ptreemapProxy._treemapWaitingPopup({ show: true });
                ptreemapProxy._currentAction = "drillup";
                if ($(event.target).hasClass("drillItem")) {
                    if (ptreemapProxy.getJsonRecords().treemapLabels[0].indexOf("~~") >= 0) {
                        ptreemapProxy._selectedItem = $(event.target).text();
                        for (var i = 0; i < ptreemapProxy.getJsonRecords().labelTags.length; i++) {
                            if (ptreemapProxy.getJsonRecords().labelTags[i].split("::")[2] == ptreemapProxy._selectedItem && ptreemapProxy.getJsonRecords().labelTags[i].split("::")[ptreemapProxy.getJsonRecords().labelTags[i].split("::").length - 1] == 1) {
                                ptreemapProxy._selectedTagInfo = ptreemapProxy.getJsonRecords().labelTags[i];
                                if (ptreemapProxy.model.operationalMode == ej.PivotTreeMap.OperationalMode.ClientMode)
                                    memberInfo = ptreemapProxy.getJsonRecords().drillTags[i];
                                if (ptreemapProxy._selectedTagInfo.split("::")[ptreemapProxy._selectedTagInfo.split("::").length - 1] != 1) {
                                    ptreemapProxy._treemapWaitingPopup({ show: false });
                                    return;
                                }
                                else
                                    break;
                            }
                        }
                    }
                    else {
                        ptreemapProxy._treemapWaitingPopup({ show: false });
                        return;
                    }
                }
                if (ptreemapProxy._tagCollection.length == 0)
                    ptreemapProxy._isDrilled = false;
                ptreemapProxy._startDrilldown = true;
                if (ptreemapProxy.model.operationalMode == ej.PivotTreeMap.OperationalMode.ServerMode) {
                    if (ptreemapProxy.model.beforeServiceInvoke != null)
                        ptreemapProxy._trigger("beforeServiceInvoke", { action: ptreemapProxy._currentAction, element: ptreemapProxy.element, customObject: ptreemapProxy.model.customObject });
                    var serializedCustomObject = JSON.stringify(ptreemapProxy.model.customObject);
                    if (ptreemapProxy.model.customObject != "" && ptreemapProxy.model.customObject != null && ptreemapProxy.model.customObject != undefined) {
                        if (typeof (oclientProxy) != "undefined")
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillup", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport(), "clientReports": oclientProxy.reports, "customObject": serializedCustomObject }), ptreemapProxy.renderControlSuccess);
                        else
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillup", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport(), "customObject": serializedCustomObject }), ptreemapProxy.renderControlSuccess);
                    }
                    else {
                        if (!typeof (oclientProxy) != "undefined")
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillup", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport() }), ptreemapProxy.renderControlSuccess);
                        else
                            ptreemapProxy.doAjaxPost("POST", ptreemapProxy.model.url + "/" + ptreemapProxy.model.serviceMethodSettings.drillDown, JSON.stringify({ "action": "drillup", "drillInfo": ptreemapProxy._selectedTagInfo, "olapReport": ptreemapProxy.getOlapReport(), "clientReports": oclientProxy.reports }), ptreemapProxy.renderControlSuccess);
                    }
                }
                else {
                    var uniqueNameArray = ptreemapProxy._drilledMembers.slice(0, $.inArray(memberInfo, ptreemapProxy._drilledMembers) + 1);
                    ptreemapProxy._drilledMembers = ptreemapProxy._drilledMembers.slice(0, $.inArray(memberInfo, ptreemapProxy._drilledMembers));
                    ej.olap._mdxParser.updateDrilledReport({ uniqueName: memberInfo, seriesInfo: [memberInfo], uniqueNameArray: uniqueNameArray, action: "collapse" }, "rowheader", ptreemapProxy);
                }
            }
        },

        _unWireEvents: function () {
            $(window).off('resize', $.proxy(this._reSizeHandler, this));
            this._off(this.element, "click", ".drillItem", this._drillTreeMap);
        },

        renderControlSuccess: function (msg) {
            var ptreemapProxy = this;
            ptreemapProxy._treemapWaitingPopup({ show: true });
            try {
                if (msg[0] != undefined) {
                    this.setJsonRecords(msg[0].Value); this.setOlapReport(msg[1].Value);
                    if (typeof (oclientProxy) != "undefined") {
                        oclientProxy.currentReport = msg[1].Value;
                        if (msg[2] != null && msg[2] != undefined && msg[2].Key == "ClientReports")
                            oclientProxy.reports = msg[2].Value;
                    }
                    if (msg[2] != null && msg[2] != undefined && !msg[2].Key == "ClientReports")
                        this.model.customObject = msg[2].Value;
                }
                else if (msg.d != undefined) {
                    this.setJsonRecords(msg.d[0].Value); this.setOlapReport(msg.d[1].Value);
                    if (typeof (oclientProxy) != "undefined") {
                        oclientProxy.currentReport = msg.d[1].Value;
                        if (msg.d[2] != null && msg.d[2] != undefined && msg.d[2].Key == "ClientReports")
                            oclientProxy.reports = msg.d[2].Value;
                    }
                    if (msg.d[2] != null && msg.d[2] != undefined && !(msg.d[2].Key == "ClientReports"))
                        this.model.customObject = msg.d[2].Value;
                }
                else {
                    this.setJsonRecords(msg.JsonRecords); this.setOlapReport(msg.OlapReport);
                    if (msg.customObject != null && msg.customObject != null)
                        this.model.customObject = msg.customObject;
                    if (typeof (oclientProxy) != "undefined") {
                        if (typeof (oclientProxy.currentReport) != "undefined")
                            oclientProxy.currentReport = msg.OlapReport;
                        if (typeof (oclientProxy.reports) != "undefined" && msg.reports != undefined && msg.reports != "undefined")
                            oclientProxy.reports = msg.reports;
                    }
                }
                if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotTreeMap.OperationalMode.ServerMode) {
                    var eventArgs;
                    if (this._currentAction != "initialize")
                        eventArgs = { action: this._currentAction, element: this.element, customObject: this.model.customObject };
                    else
                        eventArgs = { action: this._currentAction, element: this.element, customObject: this.model.customObject };
                    this._trigger("afterServiceInvoke", eventArgs);
                }
                this.renderTreeMapFromJSON(this.getJsonRecords())
                this._unWireEvents();
                this._wireEvents();
                if (this._currentAction != "initialize") {
                    this.model.currentReport = this.getOlapReport();
                    this._trigger("drillSuccess", this.element);
                }
                var pivotClientObj = ($(this.element).parents(".e-pivotclient").length > 0) ? $(this.element).parents(".e-pivotclient").data("ejPivotClient") : null;
                if (!ej.isNullOrUndefined(pivotClientObj)) pivotClientObj._isTimeOut = false;
                if (typeof pivotClientObj != 'undefined' && pivotClientObj._waitingPopup != null) {
                    if ($("#" + pivotClientObj._id + "_maxView")[0])
                        $("#" + pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: false });
                    else if (typeof pivotClientObj._pivotGrid != "undefined") {
                        if (pivotClientObj && (pivotClientObj._pivotGrid._drillAction && !pivotClientObj._pivotGrid._startDrilldown) || pivotClientObj.otreemapObj._currentAction && !pivotClientObj.otreemapObj._startDrilldown)
                            pivotClientObj._waitingPopup.hide();
                        else if (pivotClientObj && pivotClientObj._pivotGrid._drillAction == "" && pivotClientObj.otreemapObj._currentAction == "" && !pivotClientObj._pivotGrid._startDrilldown && !pivotClientObj.otreemapObj._startDrilldown && (pivotClientObj._pivotGrid._JSONRecords != null || pivotClientObj.otreemapObj._JSONRecords == null))
                            pivotClientObj._waitingPopup.hide();
                        else if (pivotClientObj.otreemapObj._startDrilldown && !pivotClientObj._pivotGrid._startDrilldown && !$("#" + pivotClientObj._id + "_maxView")[0])
                            pivotClientObj._waitingPopup.hide();
                        else if (!pivotClientObj.otreemapObj._startDrilldown && !pivotClientObj._pivotGrid._startDrilldown && pivotClientObj.otreemapObj._currentAction == "" && pivotClientObj._pivotGrid._drillAction == "" && (pivotClientObj._pivotGrid._JSONRecords != null || pivotClientObj.otreemapObj._JSONRecords == null))
                            pivotClientObj._waitingPopup.hide();
                    }
                    if (pivotClientObj.model.displaySettings.mode == "chartonly")
                        pivotClientObj._waitingPopup.hide();
                }
                else
                    this._waitingPopup.hide();
                if (typeof pivotClientObj != 'undefined')
                    pivotClientObj.otreemapObj._startDrilldown = false;
            }
            catch (err) {
            }
            if (!ej.isNullOrUndefined(msg.Exception)) {
                ej.Pivot._createErrorDialog(msg, "Exception", this);
            }
        },

        renderTreeMapFromJSON: function (jsonData) {
            var ptreemapProxy = this;
            this._treeMapDatasource = [];
            var rowElement = "";
            if ((ej.isNullOrUndefined(jsonData)) || jsonData.length <= 0 || jsonData.labelTags.length == 0 || jsonData.points_Y.length == 0) {
                ptreemapProxy._treemapWaitingPopup({ show: false });
                return;
            }
            (!ej.isNullOrUndefined(jsonData.chartLables)) ? jsonData.treemapLabels = jsonData.chartLables : jsonData.treemapLabels;
            if (jsonData.points_Y.length != jsonData.treemapLabels.length) {
                oclientProxy._onFiltered = false
                var treeMapData = [];
                for (var i = 0; i < JSON.parse(JSON.stringify(ptreemapProxy.getJsonRecords().points_Y)).length - 1; i++) {
                    treeMapData.push(JSON.parse(JSON.stringify(ptreemapProxy.getJsonRecords().points_Y))[i]);
                }
            }
            else
                var treeMapData = JSON.parse(JSON.stringify(ptreemapProxy.getJsonRecords().points_Y));
            if (typeof (oclientProxy) != "undefined")
                if (oclientProxy.model.enableDeferUpdate && oclientProxy._ischartTypesChanged)
                    oclientProxy._ischartTypesChanged = false;

            for (var i = 0; i < treeMapData.length; i++) {
                var rowName = ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~")[ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~").length - 1];
                for (var j = 0; j < treeMapData[i].length; j++) {
                    treeMapData[i][j]['Item1'] = treeMapData[i][j]['Item1'].replace(treeMapData[i][j]['Item1'], rowName);
                    treeMapData[i][j]['Column'] = ptreemapProxy.getJsonRecords().seriesNames[j].split("~")[0];
                    treeMapData[i][j]['Measures'] = ptreemapProxy.getJsonRecords().measureNames;
                    treeMapData[i][j]['Tag'] = $.grep(ptreemapProxy.getJsonRecords().labelTags, function (tag) { return tag.split("::")[2] == treeMapData[i][j]['Item1']; })[0];
                    if (this.model.operationalMode == ej.PivotTreeMap.OperationalMode.ClientMode)
                        treeMapData[i][j]['drillTag'] = $.grep(ptreemapProxy.getJsonRecords().drillTags, function (drilltag) { return drilltag.split("::")[2] == treeMapData[i][j]['Item1']; })[0];
                    treeMapData[i][j][treeMapData[i][j].Tag.split("::")[1].split('.')[0].replace("[", "").replace("]", "")] = treeMapData[i][j].Item1;
                    treeMapData[i][j]['RowItem'] = treeMapData[i][j].Item1;
                    treeMapData[i][j]['Value'] = (treeMapData[i][j].Item2 != "" ? treeMapData[i][j].Item2 : "0");
                    treeMapData[i][j]['Index'] = j;
                    delete treeMapData[i][j]['Item1'];
                    delete treeMapData[i][j]['Item2'];
                    rowElement += (rowElement == "" ? "" : ";") + treeMapData[i][j].Tag.split("::")[1].split('.')[0].replace("[", "").replace("]", "");
                }
            }
            if (!ej.isNullOrUndefined(ptreemapProxy.getJsonRecords().measureNames))
                var measureCount = ptreemapProxy.getJsonRecords().measureNames.split("~");
            var minValue, maxValue;
            if (measureCount.length != 2) {
                for (var i = 0; i < treeMapData.length; i++) {
                    for (var j = 0; j < treeMapData[i].length; j++) {
                        treeMapData[i][j].Value = ej.isNullOrUndefined(treeMapData[i][j].Value) ? 0 : ((treeMapData[i][j].Value.indexOf(",") || treeMapData[i][j].Value.indexOf(".") || treeMapData[i][j].Value.indexOf(" ")) > -1 ? ej.globalize.parseFloat(ej.globalize.format(treeMapData[i][j].Value, "c", this.model.locale), this.model.locale) : ej.globalize.parseFloat(treeMapData[i][j].Value));
                        this._treeMapDatasource.push(treeMapData[i][j]);
                        if (ej.isNullOrUndefined(minValue) || minValue >= treeMapData[i][j].Value)
                            minValue = treeMapData[i][j].Value;
                        if (ej.isNullOrUndefined(maxValue) || maxValue <= treeMapData[i][j].Value)
                            maxValue = treeMapData[i][j].Value;
                    }
                }
            }
            else if (measureCount.length == 2) {
                var tempAarry = [];
                $.each(treeMapData, function (i, treeMapObjData) {
                    for (var j = 0; j < treeMapObjData.length; j++) {
                        if (!ej.isNullOrUndefined(treeMapObjData[j].Value)) {
                            treeMapObjData[j].Value = ej.isNullOrUndefined(treeMapObjData[j].Value) ? 0 : ((treeMapObjData[j].Value.indexOf(",") || treeMapObjData[j].Value.indexOf(".") || treeMapObjData[j].Value.indexOf(" ")) > -1 ? ej.globalize.parseFloat(ej.globalize.format(treeMapObjData[j].Value, "c", ptreemapProxy.model.locale), ptreemapProxy.model.locale) : ej.globalize.parseFloat(treeMapObjData[j].Value));
                            treeMapObjData[j]['Color'] = treeMapObjData[j].Value;
                            if (!ej.isNullOrUndefined(treeMapObjData[j + 1])) {
                                if (treeMapObjData[j].Column == treeMapObjData[j + 1].Column) {
                                    treeMapObjData[j].Value = ej.isNullOrUndefined(treeMapObjData[j + 1].Value) ? 0 : ((treeMapObjData[j + 1].Value.indexOf(",") || treeMapObjData[j + 1].Value.indexOf(".") || treeMapObjData[j + 1].Value.indexOf(" ")) > -1 ? ej.globalize.parseFloat(ej.globalize.format(treeMapObjData[j + 1].Value, "c", ptreemapProxy.model.locale), ptreemapProxy.model.locale) : ej.globalize.parseFloat(treeMapObjData[j + 1].Value)); //treeMapObjData[j + 1].Value;
                                    j = j + 1;
                                }
                            }
                            else
                                treeMapObjData[j].Value = 0;
                        }
                    }
                    $.each(treeMapObjData, function (j, item) {
                        if (!ej.isNullOrUndefined(item) && !ej.isNullOrUndefined(item.Value) && ej.isNullOrUndefined(item.Color))
                            treeMapObjData.splice(j, 1);
                    });
                    $.each(treeMapObjData, function (j, item) {
                        if (!ej.isNullOrUndefined(item)) {
                            item.Index = j;
                            tempAarry.push(item);
                        }
                    });
                });
                this._treeMapDatasource = tempAarry;
                $.each(this._treeMapDatasource, function (k, item) {
                    if (!ej.isNullOrUndefined(item.Color)) {
                        if (ej.isNullOrUndefined(minValue) || minValue >= item.Color)
                            minValue = item.Color;
                        if (ej.isNullOrUndefined(maxValue) || maxValue <= item.Color)
                            maxValue = item.Color;
                    }
                });
            }
            if (ptreemapProxy.getJsonRecords().treemapLabels.length > 0) {
                ptreemapProxy._drillText = "";
                var temp = [];
                for (var i = 0; i < ptreemapProxy.getJsonRecords().treemapLabels.length; i++) {
                    if (ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~").length > 1) {
                        for (var j = 0; j < ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~").length - 1; j++) {
                            var drillstate = 0;
                            for (var k = 0; k < ptreemapProxy.getJsonRecords().labelTags.length; k++) {
                                if (ptreemapProxy.getJsonRecords().labelTags[k].split("::")[2] == ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~")[j] && ptreemapProxy.getJsonRecords().labelTags[k].split("::")[ptreemapProxy.getJsonRecords().labelTags[k].split("::").length - 1] == 1) {
                                    drillstate = 1;
                                    break;
                                }
                            }
                            if (temp.length == 0 && drillstate == 1)
                                temp.push(ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~")[j]);
                            else {
                                if (temp.length > 0) {
                                    var index = jQuery.inArray(ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~")[j], temp);
                                    if (index == -1 && drillstate == 1)
                                        temp.push(ptreemapProxy.getJsonRecords().treemapLabels[i].split("~~")[j]);
                                }
                            }
                        }
                    }
                }
                for (var i = 0; i < temp.length; i++) {
                    ptreemapProxy._drillText += ptreemapProxy._drillText == "" ? ej.buildTag("a.drillItem", temp[i])[0].outerHTML : " > " + ej.buildTag("a.drillItem", temp[i])[0].outerHTML;
                }
            }
            this._showDrillText = ptreemapProxy._drillText == "" ? ej.buildTag("span.drillup", rowElement.split(";")[0], { "margin-left": "5px" })[0].outerHTML : ej.buildTag("span.drillup", rowElement.split(";")[0], { "margin-left": "5px" })[0].outerHTML + ": " + ptreemapProxy._drillText;
            var htmlTag = ej.buildTag("div#" + this._id + "TreeMapContainer", "", { "height": (typeof (oclientProxy) != "undefined") ? (parseInt(oclientProxy._chartHeight) - 50).toString() + "px" : this.element.height(), "width": (typeof (oclientProxy) != "undefined") ? oclientProxy._chartWidth : this.element.width(), "margin-top": "50px" })[0].outerHTML;
            this.element.html(htmlTag);
            minValue = minValue - 1;
            maxValue = maxValue + 1;
            rowElement = rowElement.split(";")[0];
            $("#" + this._id + "TreeMapContainer").ejTreeMap({
                ptreemapProxy:this,
                dataSource: this._treeMapDatasource,
                showTooltip: true,
                colorValuePath: (measureCount.length == 2 ? "Color" : "Value"),
                tooltipTemplate: "tooltipTemplate",
                enableDrillDown: false,
                enableGradient: true,
                highlightGroupOnSelection: (typeof (oclientProxy) != "undefined" ? (!oclientProxy.model.enableDeferUpdate ? true : false) : true),
                treeMapGroupSelected: this._drillTreeMap,
                refreshed: this._treeMapRenderSuccess,
                showLegend: true,
                legendSettings: {
                    leftLabel: minValue.toString(),
                    width: 150,
                    height: 20,
                    title: this._treeMapDatasource[0].Measures,
                    rightLabel: maxValue.toString(),
                    mode: "interactive",
                    dockPosition: "bottom",
                    alignment: "center"
                },
                rangeColorMapping: [{
                    from: minValue,
                    to: maxValue,
                    gradientColors: ["#fde6cc", "#fab665"]
                }],
                weightValuePath: "Value",
                leafItemSettings: { showLabels: true, labelPath: "Column", labelVisibilityMode: "hideonexceededlength" },
                levels: [{ groupPath: rowElement, groupGap: 2, showHeader: true, headerHeight: 25, labelPosition: "topleft", headerVisibilityMode: "hideonexceededlength" }]
            });

            this._treeMap = $("#" + this._id + "TreeMapContainer").data("ejTreeMap");
            this._treeMap["rowItem"] = rowElement;
            
            $.views.helpers({
                Measures: function (data) {
                    var measures = null;
                    measures = data.Measures;
                    return measures;
                },
                Row: function (data) {
                    var column = null;
                    column = data.Column;
                    return column;
                },
                Column: function (data) {
                    var row = null;
                    row = data.RowItem;
                    return row;
                },
                Value: function (data) {
                    var value = 0;
                        value = data.Value;
                    return value;
                },
                Color: function (data) {
                    var color = 0;
                    color = ej.isNullOrUndefined(data.Color) ? data.Value : data.Color;
                    return color;
                },
            });
            var eventArgs = { "action": this._currentAction, "customObject": this.model.customObject, "element": this.element };
            this._trigger("renderSuccess", eventArgs);
            if (typeof (oclientProxy) != "undefined")
                $("#" + this._id + "TreeMapContainer").css({ width: "100%" });
            this._treeMap.refresh();
            ptreemapProxy = this;
	        ptreemapProxy._JSONRecords = jsonData;
                ptreemapProxy._treemapWaitingPopup({ show: false });
        },

        _treemapWaitingPopup: function (args) {
            var ptreemapProxy = $(this.element).hasClass("e-pivottreemap") ? $(this.element).data("ejPivotTreeMap") : $(this.element).parents(".e-pivottreemap").data("ejPivotTreeMap");
            if ($(ptreemapProxy.element).parents(".e-pivotclient").length > 0) {
                var pivotClientObj = $(ptreemapProxy.element).parents(".e-pivotclient").data("ejPivotClient");
                if (!ej.isNullOrUndefined(pivotClientObj) && !(args.show)) pivotClientObj._isTimeOut = false;
                if ($("#" + pivotClientObj._id + "_maxView")[0])
                    $("#" + pivotClientObj._id + "_maxView").ejWaitingPopup({ showOnInit: args.show });
                else if (!ej.isNullOrUndefined(pivotClientObj._waitingPopup)) {
                    if (args.show)
                        pivotClientObj._waitingPopup.show();
                    else
                        pivotClientObj._waitingPopup.hide();
                }
            }
            else {
                if (!ej.isNullOrUndefined(ptreemapProxy._waitingPopup) && args.show)
                    ptreemapProxy._waitingPopup.show();
                else
                    ptreemapProxy._waitingPopup.hide();
            }
        },
        _treeMapRenderSuccess: function (args) {
            var ptreemapProxy = this.model.ptreemapProxy;
            ptreemapProxy._treeMap = $("#" + ptreemapProxy._id + "TreeMapContainer").data("ejTreeMap");
            if (!ej.isNullOrUndefined(ptreemapProxy._treeMap)) {
                if (ptreemapProxy._treeMap.model.legendSettings.dockPosition == "top") {
                    if (!ptreemapProxy.element.find("#" + ptreemapProxy._id + "TreeMapContainer").children().hasClass("drillupAction"))
                        $(ej.buildTag("div#drillHeader .drillupAction", ptreemapProxy._showDrillText, { "height": "25px", "width": "99.8%", "z-index": "10", "position": "absolute", "margin-top": "33px" })[0].outerHTML).insertAfter($("#" + ptreemapProxy._id + "TreeMapContainer").find(".LegendDiv").css("margin-top", "-50px").css("font-size", "12px"));
                }
                else {
                    $("#" + ptreemapProxy._id + "TreeMapContainer").find(".LegendDiv").css("font-size", "12px").insertAfter($("#" + ptreemapProxy._id + "TreeMapContainer").find("._templateDiv"));
                    $(ej.buildTag("div#drillHeader .drillupAction", ptreemapProxy._showDrillText, { "height": "25px", "width": "99.8%", "position": "absolute", "margin-top": "-32px" })[0].outerHTML).insertBefore($("#" + ptreemapProxy._id + "TreeMapContainer").find("#backgroundTile"));
                }
            }
        },

        _reSizeHandler: function (args) {
            var ptreemapProxy = this;
            var resize = ptreemapProxy.element.find("#" + ptreemapProxy._id + "TreeMapContainer").width(ptreemapProxy.element.width()).data("ejTreeMap");
            if (!ej.isNullOrUndefined(resize))
                resize.refresh();
        },

        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            var contentType, dataType, successEvt, isAsync = true, ptreemapProxy = this;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, ej.olap.base, customArgs), isAsync = (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9) ? false : ((!ej.isNullOrUndefined(customArgs) && customArgs["action"] != "loadFieldElements") ? true : false);
            $.ajax({
                type: type,
                url: url,
                contentType: contentType,
                async: isAsync,
                dataType: dataType,
                data: data,
                success: successEvt,
                complete: ej.proxy(function (onComplete) {
                    $.proxy(onComplete, this);
                    var eventArgs = { "action": this._currentAction, "customObject": this.model.customObject, element: this.element };
                    this._trigger("renderComplete", eventArgs);
                }, this),
                error: ej.proxy(function (msg, textStatus, errorThrown) {
                    if (typeof this._waitingPopup != 'undefined' && this._waitingPopup != null)
                        this._waitingPopup.hide();
                    ptreemapProxy._treemapWaitingPopup({ show: false });
                    var eventArgs = { "action": this._currentAction, "customObject": this.model.customObject, "element": this.element, "Message": msg };
                    this._trigger("renderFailure", eventArgs);
                    this.renderTreeMapFromJSON("");
                }, this)
            });
        },

        doPostBack: function (url, params) {
            var form = $('<form>').attr({ 'action': url, 'method': 'POST', 'name': 'export' });
            var addParam = function (paramName, paramValue) {
                var input = $('<input type="hidden" title="params">').attr({
                    'id': paramName,
                    'name': paramName,
                    'value': paramValue
                }).appendTo(form);
            };
            for (var item in params)
                addParam(item, params[item]);
            form.appendTo(document.body).submit().remove();
        }
    });

    ej.PivotTreeMap.OperationalMode = {
        ClientMode: "clientmode",
        ServerMode: "servermode"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html OLAP Gauge elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejPivotGauge", "ej.PivotGauge", {

        _rootCSS: "e-pivotgauge",
        element: null,
        model: null,
        validTags: ["div", "span"],
        defaults: $.extend({}, ej.datavisualization.CircularGauge.prototype.defaults, {
            url: "",
            analysisMode: "pivot",
            operationalMode: "clientmode",
            cssClass: "",
            rowsCount: 0,
            columnsCount: 0,
            enableTooltip: false,
            enableAnimation: false,
            isResponsive: false,
            enableRTL:false,
            labelFormatSettings: {
                numberFormat: "default",
                decimalPlaces: 5,
                prefixText: "",
                suffixText: ""
            },
            showHeaderLabel: true,
            scales: ej.datavisualization.CircularGauge.prototype._defaultScaleValues(),
            customObject: {},
            dataSource: {
                data: null,
				sourceInfo: "",
                providerName: "ssas",
                isFormattedValues: false,
                columns: [],
                cube: "",
                catalog: "",
                rows: [],
                values: [],
                filters: []
            },
            locale: "en-US",
            serviceMethodSettings: {
                initialize: "InitializeGauge"
            },
            renderSuccess: null,
            renderComplete: null,
            renderFailure: null,
            beforeServiceInvoke: null,
            afterServiceInvoke: null,
            load: null,
            beforePivotEnginePopulate: null,
        }),

        dataTypes: {
            dataSource: {
                data: "data",
                columns: "array",
                rows: "array",
                values: "array",
                filters: "array"
            },
            serviceMethodSettings: {
                initialize: "enum"
            },
            customObject: "data",
            scales: "data"
        },

        observables: ["rowsCount", "columnsCount", "showHeaderLabel", "locale", "radius", "frameType"],
        rowsCount: ej.util.valueFunction("rowsCount"),
        columnsCount: ej.util.valueFunction("columnsCount"),
        showHeaderLabel: ej.util.valueFunction("showHeaderLabel"),
        locale: ej.util.valueFunction("locale"),
        radius: ej.util.valueFunction("radius"),
        frameType: ej.util.valueFunction("frameType"),

        getOlapReport: function () {
            return this._olapReport;
        },

        setOlapReport: function (value) {
            this._olapReport = value;
        },

        getJSONRecords: function () {
            return this._JSONRecords;
        },

        setJSONRecords: function (value) {
            this._JSONRecords = JSON.parse(value);
        },

        _init: function () {
            this.model = $.extend(ej.datavisualization.CircularGauge.prototype.defaults, this.model);
            this._scalesInitialize();
            this._initPrivateProperties();
            this._load();
        },

        _scalesInitialize: function () {
            if (this.model.scales != null) {
                $.each(this.model.scales, ej.proxy(function (index, element) {
                    var obj = ej.datavisualization.CircularGauge.prototype._defaultScaleValues();
                    $.extend(obj, element);
                    $.extend(element, obj);
                }, this));
            }
            else {
                this.model.scales = [ej.datavisualization.CircularGauge.prototype._defaultScaleValues()];
            }
            if (this.model.enableRTL) {
                $.each(this.model.scales, function (index, element) {
                    element.direction = "counterClockwise";
                })
            }
        },

        _destroy: function () {
            this._unWireEvents();
            this.element.empty().removeClass("e-pivotgauge" + this.model.cssClass);
            if (this._ogaugeWaitingPopup != undefined)
                this._ogaugeWaitingPopup._destroy();
        },

        _initPrivateProperties: function () {
            this._id = this.element.attr("id");
            this._olapReport = "";
            this._JSONRecords = null;
            this._maximum = new Array();
            this._maxValue = 0;
            this._pointerValue_0 = 0;
            this._pointerValue_1 = 0;
            this._currentLayout = "";
            this._defaultArea = 0;
            this._defaultWidth = 0;
            this._gaugeObj = {};
            this._ogaugeWaitingPopup = null;
            this._ogaugeProgressBar = null;
            this._ogaugeProgressText = null;
            this._notationStr = null;
            this._ogaugeTimer = null;
        },

        _load: function () {
            this.element.addClass(this.model.cssClass);
            $("#" + this._id).ejWaitingPopup({ showOnInit: true });
            this._ogaugeWaitingPopup = $("#" + this._id).data("ejWaitingPopup");

			if (this.model.load != null)						
                this._trigger("load", { action: "initialize", model: this.model, element: this.element, customObject: this.model.customObject });				
            var serializedCustomObject = JSON.stringify(this.model.customObject);
            if (this.model.dataSource && typeof (this.model.dataSource.data) == "string") {
                this._trigger("beforePivotEnginePopulate", { gaugeObject: this });
                this.model.operationalMode = ej.PivotGauge.OperationalMode.ClientMode;
                ej.olap.base.getJSONData({ action: "initialLoad" }, this.model.dataSource, this);
            }
            else if (this.model.dataSource && typeof (this.model.dataSource.data) == "object" && this.model.dataSource.data != null) {
                this._trigger("beforePivotEnginePopulate", { gaugeObject: this });
                var pivot = ej.PivotAnalysis.pivotEnginePopulate(this.model);
                this._dataModel = "Pivot";
                this.generateJSON({ baseObj: this }, pivot.pivotEngine);
            }
            else if (this.model.customObject != null && this.model.customObject != undefined && this.model.customObject != {}) {
                this.model.operationalMode = ej.PivotGauge.OperationalMode.ServerMode;

                if (this.model.beforeServiceInvoke != null)
                    this._trigger("beforeServiceInvoke", { element: this.element, customObject: this.model.customObject });
                this.doAjaxPost("POST", this.model.url + "/" + this.model.serviceMethodSettings.initialize, JSON.stringify({ "action": "initializeGauge", "customObject": serializedCustomObject }), this._renderControlSuccess);
            }
        },

        _setFirst: true,

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "OlapReport": this.setOlapReport(options[key]); break;
                    case "JsonData": this.setOlapReport(options[key]); break;
                    case "RefreshPivotGauge": this.element.renderControlFromJSON(options[key]); break;
                    case "customObject": this.model.customObject = options[key]; break;
                    case "locale": this.locale(); break;
                    case "rowsCount": this.rowsCount(); break;
                    case "columnsCount": this.columnsCount(); break;
                    case "showHeaderLabel": this.showHeaderLabel(); break;
                    case "locale": this.locale(); break;
                    case "radius": this.radius(); break;
                    case "frameType": this.frameType(); break;
                    case "scales": break;
                }
            }
            if (this._gaugeObj["obj0"]) {
                this._renderControlSuccess({ "PivotRecords": JSON.stringify(this.getJSONRecords()), "OlapReport": this.getOlapReport() });
            }
        },

        _wireEvents: function () {
                this.element.find(".e-circulargauge").mouseenter(ej.proxy(function (evt) {
                    if (this.model.enableTooltip)
                    this._showTooltip(evt);
                }, this)).mouseout(ej.proxy(function () {
                    $(this._tooltip).fadeOut("slow");
                }, this)).mousemove(ej.proxy(function (evt) {
                    if (this.model.enableTooltip) {
                        this._showTooltip(evt);
                        this._hideTooltip();
                    }
                }, this));
        },

        _getLocalizedLabels: function (property) {
            return ej.PivotGauge.Locale[this.locale()][property] === undefined ? ej.PivotGauge.Locale["en-US"][property] : ej.PivotGauge.Locale[this.locale()][property];
        },

        _unWireEvents: function () {
        },

        _showTooltip: function (event) {
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8)
                return;
            $(this._tooltip).remove();
            var gaugeIndexValues = event.target.id.split("_") == "" ? event.target.parentNode.id.split("_") : event.target.id.split("_");
            var gaugeIndex = gaugeIndexValues[gaugeIndexValues.length - 1];
            var goal = this._numberFormatConversion(this._JSONRecords[gaugeIndex].GoalValue || 0, this.model.labelFormatSettings.numberFormat, this.model.labelFormatSettings.decimalPlaces);
            var value = this._numberFormatConversion(this._JSONRecords[gaugeIndex].MeasureValue || this._JSONRecords[gaugeIndex].Value, this.model.labelFormatSettings.numberFormat, this.model.labelFormatSettings.decimalPlaces);
            var _factor = this._setMaxScaleValue(this._JSONRecords[gaugeIndex].GoalValue || 0, this._JSONRecords[gaugeIndex].MeasureValue || this._JSONRecords[gaugeIndex].Value, gaugeIndex);
            if (this.model.labelFormatSettings.numberFormat == ej.PivotGauge.NumberFormat.Notation) {
                var goalNValue = (this._JSONRecords[gaugeIndex].GoalValue || 0), measureNValue = (this._JSONRecords[gaugeIndex].MeasureValue || this._JSONRecords[gaugeIndex].Value);
                while (goalNValue >= 10) {
                    goalNValue = parseInt(goalNValue) / 10;
                }
                while (measureNValue >= 10) {
                    measureNValue = parseInt(measureNValue) / 10;
                }
                goal = (goalNValue).toFixed(1) + goal;
                value = (measureNValue).toFixed(1) + value;
            }
            var member = this._JSONRecords[gaugeIndex].MemberName || this._JSONRecords[gaugeIndex].Measure;
            if (member == undefined || member == "undefined")
                member = this._JSONRecords[gaugeIndex].MeasureCaption;
            var tooltipText;
            if (this.model.enableRTL || this._gaugeObj["obj" + gaugeIndex].model.scales[0].direction == "counterClockwise")
                tooltipText = member.split(" - ").reverse().join(" - ") + "<br/>" + goal + " :" + this._getLocalizedLabels("RevenueGoal") + "<br/>" + value + " :" + this._getLocalizedLabels("RevenueValue");
            else
                tooltipText = member + "<br/>" + this._getLocalizedLabels("RevenueGoal") + ": " + goal + "<br/>" + this._getLocalizedLabels("RevenueValue") + ": " + value;
            this._tooltip = ej.buildTag("div.e-pivotgauge-tooltip", tooltipText);
            $(this._tooltip).appendTo('body');
            $(this._tooltip).addClass(".e-pivotgauge-active");
            this._changeTooltipPos(event);
            if (this.model.enableRTL || this._gaugeObj["obj" + gaugeIndex].model.scales[0].direction == "counterClockwise")
                $(this._tooltip).css("text-align", "right");
            else
                $(this._tooltip).css("text-align", "left");
        },

        _changeTooltipPos: function (event) {
            var tooltipX = event.pageX - 8;
            var tooltipY = event.pageY + 8;
            $(this._tooltip).css({ top: tooltipY, left: tooltipX });
        },

        _hideTooltip: function () {
            window.setTimeout(ej.proxy(function () { $(this._tooltip).fadeOut(1500, "linear"); }, this), 3000);
        },

        _renderControlSuccess: function (msg) {
            try {
                if(msg.DataModel == "Olap")
                    this.model.analysisMode = ej.PivotGauge.AnalysisMode.Olap;
                else
                    this.model.analysisMode = ej.PivotGauge.AnalysisMode.Pivot;
                var htmlTag = "", statusImage = "", trendImage = "", liTag = "", gaugeId = 0;
                if (msg[0] != undefined && msg.length > 0) {
                    this.setJSONRecords(msg[0].Value);
                    this.setOlapReport(msg[1].Value);
                    if (msg[2] != null && msg[2] != undefined)
                        this.model.customObject = msg[2].Value;
                }
                else if (msg.d != undefined && msg.d.length > 0) {
                    this.setJSONRecords(msg.d[0].Value);
                    this.setOlapReport(msg.d[1].Value);
                    if (msg.d[2] != null && msg.d[2] != undefined)
                        this.model.customObject = msg.d[2].Value;
                }
                else if (msg.PivotRecords && msg.OlapReport) {
                    this.setJSONRecords(msg.PivotRecords);
                    this.setOlapReport(msg.OlapReport);
                    if (msg.customObject != null && msg.customObject != undefined)
                        this.model.customObject = msg.customObject;
                }

                if (this.model.afterServiceInvoke != null && this.model.operationalMode == ej.PivotGauge.OperationalMode.ServerMode)
                    this._trigger("afterServiceInvoke", { element: this.element, customObject: this.model.customObject });
                var ogaugeInfo = this.getJSONRecords();

                if (ogaugeInfo != null && ogaugeInfo.length > 0) {
                    if (this.rowsCount() < 1 && this.columnsCount() < 1) {
                        this._currentLayout = "WrapPanel";
                        for (var k = 0; k < ogaugeInfo.length; k++) {
                            statusImage = ej.buildTag("img#statusIndicator_" + k + ".kpiiconvalue")[0].outerHTML;
                            trendImage = ej.buildTag("img#trendIndicator_" + k + ".kpiiconvalue")[0].outerHTML;
                            liTag += ej.buildTag("li", ej.buildTag("div#" + this._id + "_" + k, statusImage + trendImage)[0].outerHTML)[0].outerHTML;
                        }
                        htmlTag = ej.buildTag("ul.wrapLayout", liTag)[0].outerHTML;
                    }
                    else {
                        this._currentLayout = "Table";
                        if (this.columnsCount() == undefined || this.columnsCount() < 1)
                            this.columnsCount((ogaugeInfo.length / this.rowsCount()).toFixed());
                        if (this.rowsCount() == undefined || this.rowsCount() < 1)
                            this.rowsCount((ogaugeInfo.length / this.columnsCount()).toFixed());
                        htmlTag = "<table><tbody>";
                        for (var i = 0; i < this.rowsCount() ; i++) {
                            htmlTag += "<tr>";
                            for (var j = 0; j < this.columnsCount() ; j++) {
                                statusImage = ej.buildTag("img#statusIndicator_" + gaugeId + ".kpiiconvalue")[0].outerHTML;
                                trendImage = ej.buildTag("img#trendIndicator_" + gaugeId + ".kpiiconvalue")[0].outerHTML;
                                htmlTag += "<td>" + ej.buildTag("div#" + this._id + "_" + gaugeId, statusImage + trendImage)[0].outerHTML + "</td>";
                                gaugeId++;
                            }
                            htmlTag += "</tr>";
                        }
                        htmlTag += "</tbody></table>";
                    }
                    this.element.html(htmlTag);
                    var curObj = this;
                    setTimeout(function () {
                        curObj.renderControlFromJSON(ogaugeInfo);
                        var eventArgs = { element: curObj.element, customObject: curObj.model.customObject };
                        curObj._trigger("renderSuccess", eventArgs);
                    }, 0);
                    this._defaultWidth = this.element.find("canvas").width();
                    this._defaultArea = this.element.find("table").height() * this.element.find("table").width();
                }
            }
            catch (err) {
            }
            if (!ej.isNullOrUndefined(msg.Exception)) {
                ej.Pivot._createErrorDialog(msg, "Exception", this);
            }
        },

        doAjaxPost: function (type, url, data, onSuccess, onComplete, customArgs) {
            var contentType, dataType, successEvt, isAsync = true;
            if ((data["XMLA"] == undefined))
                contentType = 'application/json; charset=utf-8', dataType = 'json', successEvt = $.proxy(onSuccess, this);
            else
                contentType = 'text/xml', dataType = 'xml', data = data["XMLA"], successEvt = $.proxy(onSuccess, ej.olap.base, customArgs), isAsync = (!ej.isNullOrUndefined(customArgs) && customArgs["action"] != "loadFieldElements") ? true : false;
            $.ajax({
                type: type,
                url: url,
                contentType: contentType,
                async: false,
                dataType: dataType,
                data: data,
                success: successEvt,
                complete: ej.proxy(function () {
                    var eventArgs = { element: this.element, customObject: this.model.customObject };
                    this._trigger("renderComplete", eventArgs);
                }, this),
                error: ej.proxy(function (msg, textStatus, errorThrown) {
                    this._ogaugeWaitingPopup.hide();
                    var eventArgs = { element: this.element, Message: msg, customObject: this.model.customObject };
                    this._trigger("renderFailure", eventArgs);
                }, this)
            });
        },


        _getCalculatedValue: function (value) {
            var stringValue = value.toString();
            var factor = 1; var len; var dividend;
            if (stringValue.indexOf('.') > -1)
                len = stringValue.split('.')[0].length;
            else
                len = stringValue.length;
            dividend = parseInt(stringValue);
            for (var i = 0; i < len; i++) {
                if (dividend > this._maxValue) {
                    dividend = dividend / 10;
                    factor = factor * 10;
                }
            }
            return factor;
        },

        _findNearestUpperLimit: function (number, factor) {
            var convertedNumber = number.toString();
            var j = parseInt(convertedNumber);
            var k = j % factor;
            return j + (factor - k);
        },

        _setMaxScaleValue: function (goal, value, i) {
            var factor;
            if (value > goal) {
                factor = this._getCalculatedValue(value);
                this._maximum[i] = this._findNearestUpperLimit((value / factor), 10);
            }
            else {
                factor = this._getCalculatedValue(goal);
                this._maximum[i] = this._findNearestUpperLimit((((goal / factor) * 4) / 3), 10);
            }
            return factor;
        },

        _numberFormatConversion: function (num, type, decimal) {
            switch (type) {
                case ej.PivotGauge.NumberFormat.Default:
                    return parseFloat(num).toFixed(decimal);
                    break;
                case ej.PivotGauge.NumberFormat.Text:
                    return num.toString();
                    break;
                case ej.PivotGauge.NumberFormat.Currency:
                    return ej.format(parseInt(num), "c", this.model.locale);
                    break;

                case ej.PivotGauge.NumberFormat.Percentage:
                    {
                        num *= 100;
                        return parseFloat(num).toFixed(2) + "%";
                    }
                    break;
                case ej.PivotGauge.NumberFormat.Fraction:
                    {
                        if (!num) {
                            num = this;
                        }
                        var whole = String(num).split('.')[0];
                        var num = parseFloat("." + String(num).split('.')[1]);
                        num = num.toFixed(4);
                        var decimal = "1";
                        for (z = 0; z < String(num).length - 2; z++) {
                            decimal += "0";
                        }
                        num = num * decimal;
                        decimal = parseInt(decimal);
                        for (z = 2; z < num + 1; z++) {
                            if (num % z == 0 && decimal % z == 0) {
                                num = num / z;
                                decimal = decimal/z;
                                z = 2;
                            }
                        }
                        if (num.toString().length == 2 &&
                                decimal.toString().length == 3) {
                            num = Math.round(Math.round(num) / 10);
                            decimal = Math.round(Math.round(decimal) / 10);
                        }
                        else if (num.toString().length == 2 &&
                                decimal.toString().length == 2) {
                            num = Math.round(num / 10);
                            decimal = Math.round(decimal/10);
                        }
                        var t = _HCF(num, decimal);
                        return ((whole == 0) ? "" : whole + " ") + num / t + "/" + decimal/t;


                    }
                    break;
                case ej.PivotGauge.NumberFormat.Scientific:
                    {
                        return parseFloat(num).toExponential();
                    }
                    break;
                case ej.PivotGauge.NumberFormat.Notation:
                    {
                        var count = 0;
                        var mod = parseInt(num);
                        while (mod >= 1) {
                            var mod = parseInt(mod) / 10;
                            count++;
                        }
                        return (this._notationStr = count == 1 ? "da" : count == 2 ? "h" : count == 3 ? "k" : count == 4 ? "k*da" : count == 5 ? "k*h" : count == 6 ? "M" : count == 7 ? "M*da" : count == 8 ? "M*h" : count == 9 ? "G" : count == 10 ? "G*da" : count == 11 ? "G*h" : count == 12 ? "T" : "");
                    }
                    break;
            }
            function _HCF(u, v) {
                var U = u, V = v
                while (true) {
                    if (!(U %= V)) return V
                    if (!(V %= U)) return U
                }
            }
        },

        removeImg: function () {
            this.element.find("img").remove();
        },

        renderControlFromJSON: function (jsonObj) {
            //Calculating pointer value, danger and safer regions
            this._maxValue = 99;
            var maxGaugeCount = 0;
            var pointerCapRadius = (this.radius() / 22);
            if (this._currentLayout == "Table" && (this.rowsCount() * this.columnsCount()) <= jsonObj.length)
                maxGaugeCount = this.rowsCount() * this.columnsCount();
            else if (this._currentLayout == "WrapPanel" || (this.rowsCount() * this.columnsCount()) > jsonObj.length)
                maxGaugeCount = jsonObj.length;
            for (var i = 0; i < maxGaugeCount; i++) {
                var goal = 0.0, value = 0.0, startValue = 0.0, endValue = 0.0, dValue = 0.0, factor = 0, mark = 0.0,
                percentageValue = 0.0, customLabel = "", imgDiv, extendRanges = new Array(), extendPointers = new Array(),
                extendLabels = new Array(), extendCustomLabels = new Array(), extendTicks = new Array(), extendIndicators = new Array(),
                extendScales = new Array(), statusClass = "", trendClass = "";

                if (jsonObj[i].MeasureValue != null && jsonObj[i].MeasureValue != undefined) {
                    value = parseFloat(jsonObj[i].MeasureValue) || 0;
                    goal = parseFloat(jsonObj[i].GoalValue) || 0;
                    customLabel = this.model.labelFormatSettings.prefixText + " " + jsonObj[i].MeasureCaption + (!($.trim(jsonObj[i].MemberName)) ? "" : " - ") + jsonObj[i].MemberName + " " + this.model.labelFormatSettings.suffixText;
                }
                else {
                    value = parseFloat(jsonObj[i].Value);
                    goal = 0.0;
                    customLabel = jsonObj[i].Measure;
                    this.model.scales[0].showIndicators = false;
                }
                customLabel = (this.model.enableRTL || this.model.scales[0].direction == "counterClockwise") ? customLabel.split(" - ").reverse().join(" - ") : customLabel;
                factor = this._setMaxScaleValue(goal, value, i);
                dValue = value;
                mark = goal / factor;
                percentageValue = (dValue / factor);
                this._pointerValue_0 = endValue + percentageValue;
                this._pointerValue_1 = mark + endValue;
                startValue = endValue;
                endValue = endValue + percentageValue;

                //Edting Model values
                if (jsonObj[i].StatusGraphic == "Traffic Signals") {
                    if (jsonObj[i].StatusValue == -1)
                        statusClass = "kpiredroad";
                    else if (jsonObj[i].StatusValue == 0)
                        statusClass = "kpiallcolor";
                    else if (jsonObj[i].StatusValue == 1)
                        statusClass = "kpigreenroad";
                }
                else {
                    if (jsonObj[i].StatusValue == -1)
                        statusClass = "kpidiamond";
                    else if (jsonObj[i].StatusValue == 0)
                        statusClass = "kpitriangle";
                    else if (jsonObj[i].StatusValue == 1)
                        statusClass = "kpicircle";
                }
                imgDiv = this.element.find("#statusIndicator_" + [i]).addClass(statusClass);
                if (imgDiv != null && imgDiv != undefined) {
                    var statusImage = $(imgDiv).css('background-image');
                    var statusIndicator = {
                        height: 15,
                        width: 15,
                        type: "image",
                        imageUrl: (!ej.isNullOrUndefined(statusImage) && statusImage != "none" && statusImage != "") ? statusImage.split("(")[1].split(")")[0].replace('"', "").replace('"', "") : "",
                        position: { x: this.radius() - 20, y: 260 }, location: { x: this.radius() - 20, y: 260 }
                    };
                }

                if (jsonObj[i].TrendGraphic != null && jsonObj[i].TrendGraphic != undefined && jsonObj[i].TrendGraphic != "" && jsonObj[i].TrendGraphic.toLowerCase() == "standard arrow") {
                    if (jsonObj[i].TrendValue == -1)
                        trendClass = "kpidownarrow";
                    else if (jsonObj[i].TrendValue == 0)
                        trendClass = "kpirightarrow";
                    else if (jsonObj[i].TrendValue == 1)
                        trendClass = "kpiuparrow";
                    imgDiv = this.element.find("#trendIndicator_" + [i]).toggleClass(trendClass);
                }
                if (!ej.isNullOrUndefined(imgDiv)) {
                    var trendImage = $(imgDiv).css('background-image');
                    var trendIndicator = {
                        height: 15,
                        width: 15,
                        type: "image",
                        imageUrl: (!ej.isNullOrUndefined(trendImage) && trendImage != "none" && trendImage != "") ? trendImage.split("(")[1].split(")")[0].replace('"', "").replace('"', "") : "",
                        position: { x: this.radius(), y: 260 }, location: { x: this.radius(), y: 260 }
                    };
                }
                if (!ej.isNullOrUndefined(this.model.scales[0])) {
                    if (this.frameType() == "fullcircle") {
                        this.model.scales[0].startAngle = 122;
                        this.model.scales[0].sweepAngle = 296;
                    }
                    else if (this.frameType() == "halfcircle") {
                        this.model.scales[0].startAngle = 180;
                        this.model.scales[0].sweepAngle = 180;
                    }
                    this.model.scales[0].indicators = this.model.scales[0].showIndicators ? [statusIndicator, trendIndicator] : this.model.scales[0].indicators;
                    if (!ej.isNullOrUndefined(this.model.scales[0].pointers[0])) {
                        var newPointerCap = ej.datavisualization.CircularGauge.prototype._defaultScaleValues().pointerCap;
                        //this.model.scales[0].pointers[0] = $.extend({}, newPointer, this.model.scales[0].pointers[0]);
                        this.model.scales[0].pointers[0].value = this._pointerValue_0;
                        this.model.scales[0].pointers[0].pointerCap = newPointerCap;
                        this.model.scales[0].pointers[0].pointerCap.radius = pointerCapRadius;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[0].pointers[1])) {
                        this.model.scales[0].pointers[1].value = this._pointerValue_1;
                        this.model.scales[0].pointers[1].type = this.model.scales[0].pointers[1].type || "marker";
                        this.model.scales[0].pointers[1].markerType = this.model.scales[0].pointers[1].markerType || "diamond";
                        this.model.scales[0].pointers[1].placement = this.model.scales[0].pointers[1].placement || "center";
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[0].ranges[0])) {
                        this.model.scales[0].ranges[0].startValue = startValue;
                        this.model.scales[0].ranges[0].endValue = mark;
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[0].ranges[1])) {
                        this.model.scales[0].ranges[1].startValue = mark;
                        this.model.scales[0].ranges[1].endValue = this._maximum[i];
                    }
                    if (!ej.isNullOrUndefined(this.model.scales[0].customLabels[0]))
                        this.model.scales[0].customLabels[0].value = this.showHeaderLabel() ? "X " + factor : "";
                    if (!ej.isNullOrUndefined(this.model.scales[0].customLabels[1]))
                        this.model.scales[0].customLabels[1].value = this.showHeaderLabel() ? customLabel : "";
                    if (!ej.isNullOrUndefined(this.model.scales[0].customLabels[2]))
                        this.model.scales[0].customLabels[2].value = this.showHeaderLabel() ? customLabel : "";

                    for (var j = 0; j < this.model.scales[0].ranges.length; j++)
                        extendRanges.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().ranges[0], this.model.scales[0].ranges[j]));
                    for (var j = 0; j < this.model.scales[0].pointers.length; j++)
                        extendPointers.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().pointers[0], this.model.scales[0].pointers[j]));
                    for (var j = 0; j < this.model.scales[0].labels.length; j++) {
                        if (this.model.labelFormatSettings.numberFormat == ej.PivotGauge.NumberFormat.Notation && !ej.isNullOrUndefined(ej.datavisualization.CircularGauge.prototype._defaultScaleValues().labels[0])) {
                            this._numberFormatConversion(this._JSONRecords[i].MeasureValue || this._JSONRecords[i].Value, this.model.labelFormatSettings.numberFormat, this.model.labelFormatSettings.decimalPlaces);
                            this.model.scales[0].labels[j].unitText = this._notationStr;
                        }
                        extendLabels.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().labels[0], this.model.scales[0].labels[j]));
                    }
                    for (var j = 0; j < this.model.scales[0].labels.length; j++)
                        extendLabels.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().labels[0], this.model.scales[0].labels[j]));
                    for (var j = 0; j < this.model.scales[0].customLabels.length; j++)
                        extendCustomLabels.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().customLabels[0], this.model.scales[0].customLabels[j]));
                    for (var j = 0; j < this.model.scales[0].ticks.length; j++)
                        extendTicks.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().ticks[0], this.model.scales[0].ticks[j]));
                    if (this.model.scales[0].indicators) {
                        for (var j = 0; j < this.model.scales[0].indicators.length; j++)
                            extendIndicators.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues().indicators[0], this.model.scales[0].indicators[j]));
                    }
                    var newScale = {
                        pointerCap: {
                            radius: pointerCapRadius || this.model.scales[0].pointerCap.radius,
                            borderWidth: this.model.scales[0].pointerCap.borderWidth,
                            interiorGradient: this.model.scales[0].pointerCap.interiorGradient,
                            borderColor: this.model.scales[0].pointerCap.borderColor,
                            backgroundColor: this.model.scales[0].pointerCap.backgroundColor
                        },
                        border: {
                            color: this.model.scales[0].border.color,
                            width: this.model.scales[0].border.width
                        },
                        majorIntervalValue: this.model.scales[0].majorIntervalValue,
                        minorIntervalValue: this.model.scales[0].minorIntervalValue,
                        minimum: this.model.scales[0].minimum,
                        backgroundColor: this.model.scales[0].backgroundColor,
                        direction: this.model.scales[0].direction,
                        showPointers: this.model.scales[0].showPointers,
                        showTicks: this.model.scales[0].showTicks,
                        showLabels: this.model.scales[0].showLabels,
                        showIndicators: this.model.scales[0].showIndicators,
                        showRanges: this.model.scales[0].showRanges,
                        showScaleBar: this.model.scales[0].showScaleBar,
                        startAngle: this.model.scales[0].startAngle,
                        sweepAngle: this.model.scales[0].sweepAngle,
                        radius: this.model.scales[0].radius,
                        size: this.model.scales[0].size,
                        maximum: this.model.scales[0].maximum || this._maximum[i],
                        pointers: extendPointers,
                        ticks: extendTicks,
                        labels: extendLabels,
                        ranges: extendRanges,
                        customLabels: extendCustomLabels,
                        indicators: extendIndicators
                    };
                    for (var j = 0; j < this.model.scales.length; j++) {
                        if (j == 0)
                            extendScales.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues(), newScale));
                        else
                            extendScales.push($.extend({}, ej.datavisualization.CircularGauge.prototype._defaultScaleValues(), this.model.scales[j]));
                    }
                }

                //Creating Gauges
                $("#" + this._id + "_" + i).ejCircularGauge({
                    backgroundColor: this.model.backgroundColor,
                    frame: {
                        frameType: this.model.frame.frameType,
                        halfCircleFrameStartAngle: this.model.halfCircleFrameStartAngle,
                        halfCircleFrameEndAngle: this.model.halfCircleFrameEndAngle
                    },

                    radius: this.radius(),
                    width: this.model.width, // Width should be 2 * radius 
                    height: this.model.height,
                    interiorGradient: this.model.interiorGradient,
                    readOnly: this.model.readOnly,
                    enableResize: this.model.isResponsive,

                    enableAnimation: ej.isMobile() ? false : this.model.enableAnimation,
                    animationSpeed: this.model.animationSpeed,
                    theme: this.model.theme,
                    isRadialGradient: this.model.isRadialGradient,

                    load: this.model.load,
                    drawTicks: this.model.drawTicks,
                    drawLabels: this.model.drawLabels,
                    drawPointers: this.model.drawPointers,
                    drawRange: this.model.drawRange,
                    drawCustomLabel: this.model.drawCustomLabel,
                    drawIndicators: this.model.drawIndicators,
                    drawPointerCap: this.model.drawPointerCap,
                    renderComplete: this.model.renderComplete,
                    mouseClick: this.model.mouseClick,
                    mouseClickMove: this.model.mouseClickMove,
                    mouseClickUp: this.model.mouseClickUp,
                    scales: extendScales
                });
                this._gaugeObj["obj" + i] = $("#" + this._id + "_" + i).data("ejCircularGauge");
            }
            this.removeImg();
            this._wireEvents();
            if(!ej.isNullOrUndefined(this._ogaugeWaitingPopup)) this._ogaugeWaitingPopup.hide();
        },

        refresh: function () {
            if (this._gaugeObj == null || this._gaugeObj == undefined) {
                for (var i = 0; i < this._JSONRecords.length; i++) {
                    this._gaugeObj["obj" + i] = $("#" + this._id + "_" + i).data("ejCircularGauge");
                    this._gaugeObj["obj" + i].refresh();
                }
            }
            else {
                for (key in this._gaugeObj) {
                    this._gaugeObj[key].refresh();
                }
            }
        },
        getJSONData: function (args, dataSource) {
            ej.olap.base.getJSONData({ action: args.action }, dataSource, args.activeObject);
        },
        generateJSON: function (args, pivotEngine) {
            var rCnt, cCnt, pivotRecords = "";

            this.baseObj = args.baseObj, this.pivotEngine = pivotEngine, this.kpiInfo = [];

            if (this.baseObj._measureDt && this.baseObj._measureDt.isKpiExist) {
                var kpiAxis = this.baseObj._measureDt.axis;
                if (pivotEngine) {
                    if (kpiAxis == "colheader") {
                        rCnt = pivotEngine.length;
                        cCnt = rCnt ? pivotEngine[0].length : 0;
                    }
                    else {
                        cCnt = pivotEngine.length;
                        rCnt = cCnt ? pivotEngine[0].length : 0;
                    }
                }
                this._getKpiHeadersCollection(rCnt, cCnt, kpiAxis);
            }
            else {
                this._getSummaryInfo();
            }
            pivotRecords = JSON.stringify(this.kpiInfo);

            this._renderControlSuccess({ PivotRecords: pivotRecords, OlapReport: "null" });
            return this.kpiInfo;
        },
        _getKpiHeadersCollection: function (rCnt, cCnt, kpiAxis) {
            var engine = this.pivotEngine, tempKpi = new Object(), rlen1, clen1, rlen2, clen2, css1, css2;
            if (kpiAxis == "rowheader") {
                rlen1 = rCnt; clen1 = cCnt;
                rlen2 = cCnt; clen2 = rCnt;
                css1 = "rowheader", css2 = "colheader";
            }
            else if (kpiAxis == "colheader") {
                rlen1 = cCnt; clen1 = rCnt;
                css2 = "rowheader", css1 = "colheader";
                rlen2 = rCnt; clen2 = cCnt;
            }
            for (var rw = 0; rw < clen1; rw++) {
                for (var cl = 0; cl < rlen1; cl++) {
                    var cellDesc = null;
                    if (kpiAxis == "rowheader")
                        cellDesc = this.pivotEngine[cl][rw];
                    else
                        cellDesc = this.pivotEngine[rw][cl];
                    if (cellDesc.CSS == css1)
                        tempKpi = this._fillKpiInfo_kpiAxis(cellDesc, css1, rw, tempKpi)
                    else
                        break;

                }
                var index = 0;
                if (index = this._isKpiExist(tempKpi))
                    this._copyKpi(parseInt(index), tempKpi);
                else if (!$.isEmptyObject(tempKpi))
                    this.kpiInfo.push(tempKpi);
                tempKpi = {};
            }
            var adjTempKpi = {}, kpiAxisHds = this.kpiInfo, preCell;
            this.kpiInfo = [];
            for (var rw = 0; rw < clen2; rw++) {
                for (var cl = 0; cl < rlen2; cl++) {
                    var cellDesc = null;
                    if (kpiAxis == "rowheader") {
                        cellDesc = this.pivotEngine[rw][cl];
                        if (this.pivotEngine[cl][rw - 1])
                            preCell = this.pivotEngine[cl][rw - 1];
                    }
                    else {
                        cellDesc = this.pivotEngine[cl][rw];
                        if (this.pivotEngine[cl - 1])
                            preCell = this.pivotEngine[cl - 1][rw];
                    }
                    if (cellDesc && cellDesc.CSS == css2 && cellDesc.Value != "") {
                        adjTempKpi = this._fillKpiInfo_kpiAxis(cellDesc, css2, rw, tempKpi)
                    }
                    else {
                        break;
                    }
                }
                var index = 0;
                if (preCell && preCell.CSS == css2 && cellDesc.CSS.indexOf("summary") == -1)
                    this._mergeValues(adjTempKpi, kpiAxisHds, kpiAxis, rw, cl);
                adjTempKpi = {};
            }

            //var tempKpi = this._fillKpiInfo_kpiAxis(cellDesc, "rowheader", rw, tempKpi)

        },
        _mergeValues: function (adjTempKpi, kpiAxisHds, kpiAxis, col, row) {
            var rCalc, cCalc,
            kpiEl = {
            };
            var kpiLen = kpiAxisHds.length, kpiInfo = {};
            for (var klt = 0 ; klt < kpiLen; klt++) {
                kpiInfo = kpiAxisHds[klt];
                if (adjTempKpi.MemberRowIndex)
                    kpiInfo.MemberRowIndex = adjTempKpi.MemberRowIndex;
                else if (adjTempKpi.MemberColIndex)
                    kpiInfo.MemberColIndex = adjTempKpi.MemberColIndex;
                if (!kpiInfo.MemberName)
                    kpiInfo.MemberName = adjTempKpi.MemberName;
                else if (adjTempKpi.MemberName)
                    kpiInfo.MemberName += "-" + adjTempKpi.MemberName;
                if (kpiAxis == "rowheader") {
                    if (kpiInfo.ValueIndex > 0) {
                        kpiInfo.MeasureValue = this.pivotEngine[row][kpiInfo.ValueIndex].ActualValue;
                        kpiInfo.ActualMeasureValue = this.pivotEngine[row][kpiInfo.ValueIndex].Value;
                    }
                    if (kpiInfo.TrendIndex > 0) {
                        kpiInfo.TrendValue = this.pivotEngine[row][kpiInfo.TrendIndex].Value;
                        //   kpiInfo.TrendGraphic = this.pivotEngine[row][kpiInfo.TrendIndex].kpiInfo.Graphic;
                    }
                    if (kpiInfo.StatusIndex > 0) {
                        kpiInfo.StatusValue = this.pivotEngine[row][kpiInfo.StatusIndex].Value;
                        //   kpiInfo.StatusGraphic = this.pivotEngine[row][kpiInfo.StatusIndex].kpiInfo.Graphic;
                    }
                    if (kpiInfo.GoalIndex > 0) {
                        //  kpiInfo.GoalValue = this.pivotEngine[row][kpiInfo.GoalIndex].Value;
                    }
                }
                else if (kpiAxis == "colheader") {
                    if (kpiInfo.ValueIndex > 0) {
                        kpiInfo.MeasureValue = this.pivotEngine[kpiInfo.ValueIndex][col].ActualValue;
                        kpiInfo.ActualMeasureValue = this.pivotEngine[kpiInfo.ValueIndex][col].Value;
                    }
                    if (kpiInfo.TrendIndex > 0) {
                        kpiInfo.TrendValue = this.pivotEngine[kpiInfo.TrendIndex][col].Value;
                        //   kpiInfo.TrendGraphic = this.pivotEngine[kpiInfo.TrendIndex][col].kpiInfo.Graphic;
                    }
                    if (kpiInfo.StatusIndex > 0) {
                        kpiInfo.StatusValue = this.pivotEngine[kpiInfo.StatusIndex][col].Value;
                        //  kpiInfo.StatusGraphic = this.pivotEngine[kpiInfo.StatusIndex][col].kpiInfo.Graphic;
                    }
                    if (kpiInfo.GoalIndex > 0) {
                        kpiInfo.GoalValue = this.pivotEngine[kpiInfo.GoalIndex][col].Value;
                        kpiInfo.ActualGoalValue = this.pivotEngine[kpiInfo.GoalIndex][col].ActualValue;
                    }
                }
                kpiInfo.IsValidKpi = true;
                kpiEl = {
                    ActualMeasureValue: 0,
                    GoalCaption: "",
                    Kpi_Name: "",
                    MeasureCaption: "",
                    GoalValue: "",
                    ActualGoalValue: 0,
                    MeasureValue: "",
                    MemberName: "",
                    StatusValue: -2,
                    TrendValue: -2,
                    TrendGraphic: null,
                    StatusGraphic: null,
                    ValueIndex: "",
                    TrendIndex: -1,
                    GoalIndex: "",
                    StatusIndex: -1,
                    MemberRowIndex: null,
                    MemberColIndex: null,
                    IsValidKpi: true
                };
                this.kpiInfo.push($.extend(kpiEl, kpiInfo));
            }
        },
        _isKpiExist: function (tempKpi) {
            for (var len = 0; len < this.kpiInfo.length; len++) {
                if (this.kpiInfo[len].MemberName == tempKpi.MemberName && this.kpiInfo[len].Kpi_Name == tempKpi.Kpi_Name) {
                    return len + "";
                }
            }
            return false;
        },
        _copyKpi: function (index, tempKpi) {
            this.kpiInfo[index] = $.extend(this.kpiInfo[index], tempKpi);
        },

        _fillKpiInfo_kpiAxis: function (cellDesc, axis, index, kpiInfo) {
            //var kpiInfo = new Object();

            var uNam = cellDesc.Info.split("::")[0];
            if (!cellDesc.kpiInfo && cellDesc.CSS == axis && uNam.indexOf("[Measures]") > -1 && !cellDesc.kpiInfo) {
                kpiInfo.Kpi_Name = this._getKpiName(uNam);
                kpiInfo.MeasureCaption = cellDesc.Value;
                kpiInfo.ValueIndex = index;
            }
            else if (cellDesc.CSS == axis) {
                if (cellDesc.kpiInfo) {
                    kpiInfo.Kpi_Name = cellDesc.kpiInfo.Value;
                }
                else {
                    if (!kpiInfo.MemberName && cellDesc.Value)
                        kpiInfo.MemberName = cellDesc.Value;
                    else if (cellDesc.Value)
                        kpiInfo.MemberName += " - " + cellDesc.Value;
                    if (axis == "colheader")
                        kpiInfo.MemberColIndex = index;
                    else
                        kpiInfo.MemberRowIndex = index;

                }
                var kpiType = cellDesc.kpi ? cellDesc.kpi : "none";
                switch (kpiType) {
                    case "status":
                        {
                            kpiInfo.StatusGraphic = cellDesc.kpiInfo.Graphic;
                            kpiInfo.StatusIndex = index;
                            break;
                        }
                    case "goal":
                        {
                            kpiInfo.GoalCaption = cellDesc.Value;
                            kpiInfo.GoalIndex = index;
                            break;
                        }
                    case "trend":
                        {
                            kpiInfo.TrendGraphic = cellDesc.kpiInfo.Graphic;
                            kpiInfo.TrendIndex = index;
                            break;
                        }

                }
            }
            return kpiInfo;
        },
        _getSummaryInfo: function () {

            var elInfo = {}, baseObj = this, summaryCol = $.map(this.pivotEngine, function (colEl, index) {
                var getMesure = false;
                elInfo.Measure = "";
                elInfo.Value = "";
                elInfo.DoubleValue = 0;
                if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8)) {
                    for (var el in colEl) {
                        if (colEl[parseInt(el)].CSS.indexOf("summary col") > -1 || colEl[parseInt(el)].CSS.indexOf("summary cgtot calc") > -1)
                            getMesure = true;
                        if (getMesure && colEl[parseInt(el)].Info.indexOf("[Measures]") > -1 || colEl[parseInt(el)].CSS.indexOf("summary cgtot calc") > -1)
                            elInfo.Measure = colEl[parseInt(el)].Value;
                    }
                    if (getMesure && !(baseObj._dataModel == "Pivot")) {
                        elInfo.Value = colEl[parseInt(el)].ActualValue;
                        elInfo.DoubleValue = parseFloat(colEl[parseInt(el)].ActualValue);
                        return $.extend({}, elInfo);
                    }
                    else if (getMesure && baseObj._dataModel == "Pivot") {
                        elInfo.Value = colEl[parseInt(el)].Value.toString();
                        elInfo.DoubleValue = colEl[parseInt(el)].Value;
                        return $.extend({}, elInfo);
                    }
                }
                else {
                    for (var len = 0; len < colEl.length; len++) {
                        if ((colEl[len].CSS.indexOf("summary col") > -1 || colEl[len].CSS.indexOf("summary cgtot calc") > -1))
                            getMesure = true;
                        //len++;
                        if (getMesure && colEl[len].Info.indexOf("[Measures]") > -1 || colEl[len].CSS.indexOf("summary cgtot calc") > -1)
                            elInfo.Measure = colEl[len].Value;
                    }
                    if (getMesure && !(baseObj._dataModel == "Pivot")) {
                        elInfo.Value = colEl[len - 1].ActualValue;
                        elInfo.DoubleValue = parseFloat(colEl[len - 1].ActualValue);
                        return $.extend({}, elInfo);
                    }
                    else if (getMesure && baseObj._dataModel == "Pivot") {
                        elInfo.Value = colEl[len - 1].Value.toString();
                        elInfo.DoubleValue = colEl[len - 1].Value;
                        return $.extend({}, elInfo);
                    }
                }

            });
            for (var len = 0; len < summaryCol.length; len++) {
                var kpiEl = {
                    Caption: null,
                    Object: null,
                    CellIndex: -1,
                    Type: -1,
                    Measure: "",
                    ClassName: "",
                    DoubleValue: 0,
                    ExpandState: 0,
                    HasChildren: false,
                    Level: -1,
                    RowIndex: 3,
                    Range: null,
                    Span: null,
                    Tag: null,
                    UniqueName: "",
                    Value: ""
                };
                this.kpiInfo.push($.extend(kpiEl, summaryCol[len]));
            }
        },
        _getKpiName: function (uName) {
            var kpiColl = this.baseObj._kpi, matchedEl = "";
            matchedEl = $(kpiColl).find("row:contains('" + uName + "')");
            if (matchedEl) {
                return $(matchedEl).find("KPI_NAME").text();
            }
            return "";
        }
    });

    ej.PivotGauge.Locale = {};

    ej.PivotGauge.Locale["en-US"] = {
        RevenueGoal: "Revenue Goal",
        RevenueValue: "Revenue Value"
    };

    ej.PivotGauge.NumberFormat = {
        Default: "default",
        Currency: "currency",
        Percentage: "percentage",
        Fraction: "fraction",
        Scientific: "scientific",
        Text: "text",
        Notation: "notation"
    };
    ej.PivotGauge.AxisName = {
        Rows: "rows",
        Columns: "columns"
    };
    ej.PivotGauge.OperationalMode = {
        ClientMode: "clientmode",
        ServerMode: "servermode"
    };
    ej.PivotGauge.AnalysisMode = {
        Olap: "olap",
        Pivot: "pivot"
    };
   
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Pivot Pager elements
* @copyright Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {

    ej.widget("ejPivotPager", "ej.PivotPager", {

        _rootCSS: "e-pivotpager",
        element: null,
        model: null,

        _getModel: function () {
            return this.model;
        },

        _setModel: function (value) {
            this.model = value;
        },

        defaults: {
            targetControlID: "",
            categoricalCurrentPage: 1,
            seriesCurrentPage: 1,
            seriesPageCount: 0,
            categoricalPageCount: 0,
            locale: "en-US",
            mode: "both"
        },

        _init: function () {
            if ($("#" + this.model.targetControlID).hasClass('e-pivotgrid')) {
                this.targetControlName = "PivotGrid";
                this.targetControl = $("#" + this.model.targetControlID).data("ejPivotGrid");
                this.targetControl._pagerObj = this;
            }
            else if ($("#" + this.model.targetControlID).hasClass('e-pivotchart')) {
                this.targetControlName = "PivotChart";
                this.targetControl = $("#" + this.model.targetControlID).data("ejPivotChart");
                this.targetControl._pagerObj = this;
            }
            else if ($("#" + this.model.targetControlID).hasClass('e-pivotclient')) {
                this.targetControlName = "PivotClient";
                this.targetControl = $("#" + this.model.targetControlID).data("ejPivotClient");
                this.targetControl._pagerObj = this;
            }
            this._load();
            this._unwireEvents();
            this._wireEvents();
        },

        _destroy: function () {
            this.element.empty().removeClass("e-pivotpager");
        },

        _wireEvents: function () {
            this._on(this.element, "keydown", ".pagerTextBox", this._pagerTextBoxClick);
            this._on(this.element, "click", ".moveNext", this._moveNextPage);
            this._on(this.element, "click", ".moveLast", this._moveLastPage);
            this._on(this.element, "click", ".moveFirst", this._moveFirstPage);
            this._on(this.element, "blur", ".pagerTextBox", this._restorePageNo);
            this._on(this.element, "click", ".movePrevious", this._movePreviousPage);
        },

        _unwireEvents: function () {
            this._off(this.element, "click", ".moveNext", this._moveNextPage);
            this._off(this.element, "blur", ".pagerTextBox", this._restorePageNo);
            this._off(this.element, "click", ".moveLast", this._moveLastPage);
            this._off(this.element, "click", ".moveFirst", this._moveFirstPage);
            this._off(this.element, "click", ".movePrevious", this._movePreviousPage);
            this._off(this.element, "keydown", ".pagerTextBox", this._pagerTextBoxClick);
        },

        _getLocalizedLabels: function (property) {
            return ej.PivotPager.Locale[this.model.locale][property] === undefined ? ej.PivotPager.Locale["en-US"][property] : ej.PivotPager.Locale[this.model.locale][property];
        },

        _load: function () {
            $(this.element).addClass("pivotPager").attr("targetControlID", this.model.targetControlID);
            var pagerContent = "";
            if (this.targetControl.model.enableRTL) {
                this.element.addClass("e-rtl");
            }
            if (this.model.mode != "series") {
                var categoricalPager = ej.buildTag("td.categPagerTd", "");
                $(categoricalPager).html(ej.buildTag("div.pagerDiv", ej.buildTag("span.moveFirst e-icon").attr("role", "button").attr("aria-label", "move first")[0].outerHTML + ej.buildTag("span.movePrevious e-icon").attr("role", "button").attr("aria-label", "move previous")[0].outerHTML + ej.buildTag("span.pagerLabel", this._getLocalizedLabels("CategoricalPage"))[0].outerHTML + ej.buildTag("input#" + this._id + "_CategCurrentPage.pagerTextBox")[0].outerHTML + ej.buildTag("span.categPageCount")[0].outerHTML + ej.buildTag("span.moveNext e-icon").attr("role", "button").attr("aria-label", "move next")[0].outerHTML + ej.buildTag("span.moveLast e-icon").attr("role", "button").attr("aria-label", "move last")[0].outerHTML));
                pagerContent = categoricalPager[0].outerHTML;
            }
            if (this.model.mode != "categorical") {
                var seriesPager = ej.buildTag("td.seriesPagerTd", "");
                $(seriesPager).html(ej.buildTag("div.pagerDiv", ej.buildTag("span.moveFirst e-icon").attr("role", "button").attr("aria-label", "move first")[0].outerHTML + ej.buildTag("span.movePrevious e-icon").attr("role", "button").attr("aria-label", "move previous")[0].outerHTML + ej.buildTag("span.pagerLabel", this._getLocalizedLabels("SeriesPage"))[0].outerHTML + ej.buildTag("input#" + this._id + "_SeriesCurrentPage.pagerTextBox")[0].outerHTML + ej.buildTag("span.seriesPageCount")[0].outerHTML + ej.buildTag("span.moveNext e-icon").attr("role", "button").attr("aria-label", "move next")[0].outerHTML + ej.buildTag("span.moveLast e-icon").attr("role", "button").attr("aria-label", "move last")[0].outerHTML));
                pagerContent += seriesPager[0].outerHTML;
            }
            var pagerTable = ej.buildTag("table", ej.buildTag("tbody", ej.buildTag("tr", pagerContent)))[0];
            $(this.element).html(pagerTable);
        },

        initPagerProperties: function (headerCounts, pageSettings) {
            if (headerCounts.Row <= pageSettings.SeriesPageSize) {
                $("#" + this._id + "_SeriesCurrentPage").attr("disabled", true);
                $(".seriesPagerTd").fadeTo(0, 0.5);
            }
            else {
                $("#" + this._id + "_SeriesCurrentPage").attr("disabled", false);
                $(".seriesPagerTd").fadeTo(0, 1);
            }
            if (headerCounts.Column <= pageSettings.CategorialPageSize) {
                $("#" + this._id + "_CategCurrentPage").attr("disabled", true);
                $(".categPagerTd").fadeTo(0, 0.5);
            }
            else {
                $("#" + this._id + "_CategCurrentPage").attr("disabled", false);
                $(".categPagerTd").fadeTo(0, 1);
            }
            this.model.categoricalPageCount = pageSettings.CategorialPageSize == 0 ? 1 : Math.ceil(headerCounts.Column / pageSettings.CategorialPageSize);
            this.model.seriesPageCount = pageSettings.SeriesPageSize == 0 ? 1 : Math.ceil(headerCounts.Row / pageSettings.SeriesPageSize);
            this.model.categoricalCurrentPage = pageSettings.CategorialCurrentPage;
            this.model.seriesCurrentPage = pageSettings.SeriesCurrentPage;
            this._initPagerControl();
        },

        _initPagerControl: function (e) {
            if (this.model.mode != "series") {
                $(this.element.find(".categPageCount")[0]).html("/ " + this.model.categoricalPageCount);
                $("#" + this._id + "_CategCurrentPage")[0].value = this.model.categoricalCurrentPage;
                this._setNavigators(this.model.categoricalCurrentPage, this.model.categoricalPageCount, this.element.find(".categPagerTd")[0]);
            }
            if (this.model.mode != "categorical") {
                $(this.element.find(".seriesPageCount")[0]).html("/ " + this.model.seriesPageCount);
                $("#" + this._id + "_SeriesCurrentPage")[0].value = this.model.seriesCurrentPage;
                this._setNavigators(this.model.seriesCurrentPage, this.model.seriesPageCount, this.element.find(".seriesPagerTd")[0]);
            }
        },
		
        _moveNextPage: function (e) {
            if (!$(e.target).hasClass("disabled")) {
                var pagerInput = $($(e.target).parents('td')[0]).find(".pagerTextBox")[0];
                $($($(e.target).parents('td')[0]).find(".movePrevious")[0]).removeClass("disabled");
                $($($(e.target).parents('td')[0]).find(".moveFirst")[0]).removeClass("disabled");
                pagerInput.value = parseInt(pagerInput.value) + 1;
                if (pagerInput.id.indexOf("Categ") != -1) {
                    this.model.categoricalCurrentPage = pagerInput.value;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("categorical", pagerInput.value);
                    if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("categorical", pagerInput.value);
                    if (pagerInput.value == this.model.categoricalPageCount) {
                        $(e.target).addClass("disabled");
                        $($($(e.target).parents('td')[0]).find(".moveLast")[0]).addClass("disabled");
                    }
                }
                else if (pagerInput.id.indexOf("Series") != -1) {
                    this.model.seriesCurrentPage = pagerInput.value;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("series", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("series", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("series", pagerInput.value);
                    if (pagerInput.value == this.model.seriesPageCount) {
                        $(e.target).addClass("disabled");
                        $($($(e.target).parents('td')[0]).find(".moveLast")[0]).addClass("disabled");
                    }
                }
            }
        },

        _movePreviousPage: function (e) {
            if (!$(e.target).hasClass("disabled")) {
                var pagerInput = $($(e.target).parents('td')[0]).find(".pagerTextBox")[0];
                $($($(e.target).parents('td')[0]).find(".moveNext")[0]).removeClass("disabled");
                $($($(e.target).parents('td')[0]).find(".moveLast")[0]).removeClass("disabled");
                pagerInput.value = parseInt(pagerInput.value) - 1;
                if (pagerInput.id.indexOf("Categ") != -1) {
                    this.model.categoricalCurrentPage = pagerInput.value;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("categorical", pagerInput.value);
                    if (pagerInput.value == "1") {
                        $(e.target).addClass("disabled");
                        $($($(e.target).parents('td')[0]).find(".moveFirst")[0]).addClass("disabled");
                    }
                }
                else if (pagerInput.id.indexOf("Series") != -1) {
                    this.model.seriesCurrentPage = pagerInput.value;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("series", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("series", pagerInput.value);
                    if (this.targetControlName == "PivotClient") {
                        this.targetControl.refreshPagedPivotClient("series", pagerInput.value);
                    }
                    if (pagerInput.value == "1") {
                        $(e.target).addClass("disabled");
                        $($($(e.target).parents('td')[0]).find(".moveFirst")[0]).addClass("disabled");
                    }
                }
            }
        },

        _moveLastPage: function (e) {
            if (!$(e.target).hasClass("disabled")) {
                var pagerInput = $($(e.target).parents('td')[0]).find(".pagerTextBox")[0];
                $($($(e.target).parents('td')[0]).find(".movePrevious")[0]).removeClass("disabled");
                $($($(e.target).parents('td')[0]).find(".moveFirst")[0]).removeClass("disabled");
                $(e.target).addClass("disabled");
                $($($(e.target).parents('td')[0]).find(".moveNext")[0]).addClass("disabled");
                if (pagerInput.id.indexOf("Categ") != -1) {
                    this.model.categoricalCurrentPage = pagerInput.value = this.model.categoricalPageCount;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("categorical", pagerInput.value);                    
                }
                else if (pagerInput.id.indexOf("Series") != -1) {
                    this.model.seriesCurrentPage = pagerInput.value = this.model.seriesPageCount;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("series", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("series", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("series", pagerInput.value);
                }
            }
        },

        _moveFirstPage: function (e) {
            if (!$(e.target).hasClass("disabled")) {
                var pagerInput = $($(e.target).parents('td')[0]).find(".pagerTextBox")[0];
                $($($(e.target).parents('td')[0]).find(".moveNext")[0]).removeClass("disabled");
                $($($(e.target).parents('td')[0]).find(".moveLast")[0]).removeClass("disabled");
                $(e.target).addClass("disabled");
                $($($(e.target).parents('td')[0]).find(".movePrevious")[0]).addClass("disabled");
                if (pagerInput.id.indexOf("Categ") != -1) {
                    this.model.categoricalCurrentPage = pagerInput.value = 1;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("categorical", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("categorical", pagerInput.value);
                }
                else if (pagerInput.id.indexOf("Series") != -1) {
                    this.model.seriesCurrentPage = pagerInput.value = 1;
                    if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid("series", pagerInput.value);
                    else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart("series", pagerInput.value);
                    else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient("series", pagerInput.value);
                }
            }
        },
        _pagerTextBoxClick: function (e) {
            if (e.which == 13) {
                e.preventDefault();
                var pagerTd = $(e.target).parents('td')[0];
                var pageCount = pagerTd.className.indexOf('categ') != -1 ? this.model.categoricalPageCount : this.model.seriesPageCount;
                if (parseInt(e.target.value) > pageCount || parseInt(e.target.value) < 1 || e.target.value == "") {
                    this._restorePageNo(e);
                    ej.Pivot._createErrorDialog(this._getLocalizedLabels("PageCountErrorMsg"), "Error", this);
                }
                else {
                    if (pagerTd.className.indexOf('categ') != -1 && this.model.categoricalCurrentPage != parseInt(e.target.value)) {
                        this.model.categoricalCurrentPage = e.target.value;
                        if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid(pagerTd.className, e.target.value);
                        else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart(pagerTd.className, e.target.value);
                        else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient(pagerTd.className, e.target.value);
                    }
                    else if (pagerTd.className.indexOf('series') != -1 && this.model.seriesCurrentPage != parseInt(e.target.value)) {
                        this.model.seriesCurrentPage = e.target.value;
                        if (this.targetControlName == "PivotGrid") this.targetControl.refreshPagedPivotGrid(pagerTd.className, e.target.value);
                        else if (this.targetControlName == "PivotChart") this.targetControl.refreshPagedPivotChart(pagerTd.className, e.target.value);
                        else if (this.targetControlName == "PivotClient") this.targetControl.refreshPagedPivotClient(pagerTd.className, e.target.value);
                    }
                    this._setNavigators(e.target.value, pageCount, pagerTd);
                    e.target.blur();
                }
            }
            else {
                if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 190]) !== -1 || (e.keyCode == 65 && e.ctrlKey === true) || (e.keyCode >= 35 && e.keyCode <= 39)) return;
                if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) e.preventDefault();
            }
        },

        _restorePageNo: function (e) { e.target.value = e.target.id.indexOf("Categ") != -1 ? this.model.categoricalCurrentPage : this.model.seriesCurrentPage; },

        _setNavigators: function (value, pageCount, pagerTd) {
            if (value == pageCount) {
                $($(pagerTd).find(".moveNext")[0]).addClass("disabled");
                $($(pagerTd).find(".moveLast")[0]).addClass("disabled");
            }
            if (value == "1") {
                $($(pagerTd).find(".movePrevious")[0]).addClass("disabled");
                $($(pagerTd).find(".moveFirst")[0]).addClass("disabled");
            }
            if (value > 1) {
                $($(pagerTd).find(".movePrevious")[0]).removeClass("disabled");
                $($(pagerTd).find(".moveFirst")[0]).removeClass("disabled");
            }
            if (value < pageCount) {
                $($(pagerTd).find(".moveNext")[0]).removeClass("disabled");
                $($(pagerTd).find(".moveLast")[0]).removeClass("disabled");
            }
        }
    })

    ej.PivotPager.Locale = {};

    ej.PivotPager.Locale["en-US"] = {
        SeriesPage: "Series Page",
        CategoricalPage: "Categorical Page",
        Error: "Error",
        OK: "OK",
        Close: "Close",
        PageCountErrorMsg:"Enter valid page number"
    };

    ej.PivotPager.Mode = {
        Both: "both",
        Categorical: "categorical",
        Series: "series"
    };

})(jQuery, Syncfusion);

;